#!/usr/bin/env python
#
# Copyright (C) 2014 Narf Industries <info@narfindustries.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
from product import Product

def get_initial_inventory():
  inv = []
  inv.append(Product(barcode="41916155", description="CBoXdTVlxY", model_num=59889, cost=0.17))
  inv.append(Product(barcode="12099137", description="BURcRQvrJKLoWsuIu", model_num=1128, cost=5.87))
  inv.append(Product(barcode="86848322", description="OuYFqLLPzpStQmLGNfrdmNBtqESEZPD", model_num=64101, cost=2.54))
  inv.append(Product(barcode="87849215", description="osjXtGjM", model_num=46035, cost=4.37))
  inv.append(Product(barcode="50361802", description="WaALSqUGTUcRRQbrpD", model_num=12881, cost=5.64))
  inv.append(Product(barcode="28433101", description="UeC", model_num=31708, cost=7.28))
  inv.append(Product(barcode="12220539", description="lbYe", model_num=23198, cost=5.34))
  inv.append(Product(barcode="47111925", description="MxLyPsRDfZNyZCZyPiFcO", model_num=31486, cost=1.1))
  inv.append(Product(barcode="00664810", description="WBsFTZeoBiL", model_num=27300, cost=4.89))
  inv.append(Product(barcode="94282841", description="CiyXLti", model_num=10630, cost=1.09))
  inv.append(Product(barcode="72291601", description="RJOT", model_num=50229, cost=5.77))
  inv.append(Product(barcode="49840365", description="LrmPNlODBcMuDdejSrklcnEJbCdJOA", model_num=45345, cost=5.19))
  inv.append(Product(barcode="50717007", description="OcYEZmPsrGyvcbxflxxamqLlLJ", model_num=60011, cost=2.57))
  inv.append(Product(barcode="99964712", description="NcVIOJwRguXBwKdEwzx", model_num=116, cost=6.68))
  inv.append(Product(barcode="13706532", description="SmMpCSxZTsPtsDwZprYJIBYtCczZ", model_num=39806, cost=7.33))
  inv.append(Product(barcode="44381534", description="mfuSPgiZIaaPTtfMKuYWPqW", model_num=30120, cost=4.71))
  inv.append(Product(barcode="66900952", description="dLuOlZFcVURjFo", model_num=14927, cost=3.05))
  inv.append(Product(barcode="74926350", description="cXK", model_num=2472, cost=3.89))
  inv.append(Product(barcode="31951871", description="gZOISWZizsGWxfIV", model_num=25650, cost=2.72))
  inv.append(Product(barcode="20585072", description="OVNnctOCWjcIXOvxXwZdeYk", model_num=33445, cost=3.71))
  inv.append(Product(barcode="29987528", description="bQemYYbkbgRlHzYhddLTXBV", model_num=63850, cost=8.27))
  inv.append(Product(barcode="44567831", description="bVxVzqJoMAbbABpuK", model_num=10273, cost=1.29))
  inv.append(Product(barcode="50044195", description="TIwQNAxBYeidFJgiuiceKyyZOo", model_num=64340, cost=6.58))
  inv.append(Product(barcode="80320569", description="ZbOKiKsPtSLZUXGSgVuVvEg", model_num=3226, cost=8.54))
  inv.append(Product(barcode="12555125", description="OOBHIukxWBXTujZouCmy", model_num=48316, cost=1.52))
  inv.append(Product(barcode="77475676", description="TkFFmsuzuD", model_num=12910, cost=8.68))
  inv.append(Product(barcode="68500061", description="xXKivnPyFeKjDSsLIcHJkcfDZr", model_num=25325, cost=5.73))
  inv.append(Product(barcode="28801547", description="zPzfWrYgkzusXM", model_num=55098, cost=3.69))
  inv.append(Product(barcode="27286316", description="iaOSmHodjClBbsmNMxMUjFEEBw", model_num=45201, cost=6.05))
  inv.append(Product(barcode="06744775", description="RZaRMCR", model_num=39161, cost=10.0))
  inv.append(Product(barcode="14976063", description="lXkSGfmjnIcJrqjzuwaLpNVsxCoeZla", model_num=58432, cost=5.36))
  inv.append(Product(barcode="93921599", description="qJGFxRH", model_num=51914, cost=1.06))
  inv.append(Product(barcode="78486525", description="lrWSt", model_num=5215, cost=1.92))
  inv.append(Product(barcode="75836131", description="Cm", model_num=35136, cost=8.44))
  inv.append(Product(barcode="95486291", description="jJIhbikVwbdVIhCAZGHqjLY", model_num=30557, cost=5.14))
  inv.append(Product(barcode="19044824", description="mfoLvDmaKMrQNvWLWUiYCiXNnZOMU", model_num=18280, cost=3.65))
  inv.append(Product(barcode="30172465", description="CKFuyRMTABZMIBdsK", model_num=44608, cost=5.41))
  inv.append(Product(barcode="83497266", description="XyEYbfHmiWVtxO", model_num=1520, cost=6.46))
  inv.append(Product(barcode="46693171", description="YmUHUvQoJ", model_num=45063, cost=0.68))
  inv.append(Product(barcode="60531381", description="QiMrgINCfFjkdvozTnpjtYrELDjgmK", model_num=50365, cost=1.93))
  inv.append(Product(barcode="80111827", description="EGCyAcNvAoGTznBIInHD", model_num=50163, cost=7.36))
  inv.append(Product(barcode="46108933", description="yA", model_num=18997, cost=0.89))
  inv.append(Product(barcode="71344234", description="GZxglAxzKwgOEwRVCgPdf", model_num=40662, cost=4.91))
  inv.append(Product(barcode="20102117", description="RijMwfgJPEmoMjLCeepSY", model_num=31998, cost=1.43))
  inv.append(Product(barcode="79267208", description="XvnPoMSNWZVhfUMmpFKpphmfbwSTVo", model_num=34301, cost=9.62))
  inv.append(Product(barcode="13001388", description="ngllfhKdGIPHvstPd", model_num=54407, cost=4.96))
  inv.append(Product(barcode="17573103", description="P", model_num=2515, cost=4.57))
  inv.append(Product(barcode="22995054", description="GoiSSYhLBSSyDMzpZEfEN", model_num=23072, cost=8.89))
  inv.append(Product(barcode="58885039", description="LvJBSMasVdFOjklc", model_num=45088, cost=2.69))
  inv.append(Product(barcode="36970139", description="emCCzWhvvveEoEViRKwIsyWcMA", model_num=47167, cost=1.94))
  inv.append(Product(barcode="15048891", description="QPuFuYcsUqextKPzFHBFhWWxiwL", model_num=39914, cost=9.83))
  inv.append(Product(barcode="52820574", description="VweQMYhAYdTCE", model_num=34549, cost=7.15))
  inv.append(Product(barcode="05558432", description="YrsbMdytqSNuDPUN", model_num=43021, cost=7.77))
  inv.append(Product(barcode="45266556", description="SxagJhzOzEhqAhpAdpuREDJnM", model_num=53735, cost=2.5))
  inv.append(Product(barcode="55671691", description="JvqXCPHjJyQ", model_num=60683, cost=5.15))
  inv.append(Product(barcode="30246117", description="DaEzVgFxbPzzIF", model_num=11978, cost=2.24))
  inv.append(Product(barcode="32349600", description="vDzqEgRHizanDmHWYmtKjy", model_num=32694, cost=0.9))
  inv.append(Product(barcode="27002400", description="TAAwfhYZBDTbayzgoqEhIiYYZLPBss", model_num=28221, cost=9.18))
  inv.append(Product(barcode="23728750", description="KMLqLPUgFrTS", model_num=28808, cost=0.98))
  inv.append(Product(barcode="27227405", description="xbIkRMPWFwVechYvOEnobB", model_num=7006, cost=9.0))
  inv.append(Product(barcode="88925705", description="aMZLCrgwzBKDLiauIPwEHaX", model_num=6082, cost=6.82))
  inv.append(Product(barcode="60234543", description="UcWX", model_num=23069, cost=1.92))
  inv.append(Product(barcode="26550548", description="btg", model_num=57058, cost=7.31))
  inv.append(Product(barcode="80824106", description="B", model_num=37533, cost=4.06))

  return inv

