#!/usr/bin/env python
#
# Copyright (C) 2014 Narf Industries <info@narfindustries.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
from menu import Appetizer, Meal, Dessert, Menu

def get_initial_menu():
  a = []
  m = []
  d = []
  a.append(Appetizer(name="ZbWWNoNM"))
  a.append(Appetizer(name="eDsELei"))
  a.append(Appetizer(name="WSpBFJFOZgwszDffv"))
  a.append(Appetizer(name="OjZiYi"))
  a.append(Appetizer(name="AnGOULFOGC"))
  a.append(Appetizer(name="cSOLkHLjNiSr"))
  a.append(Appetizer(name="dNlwfQlb"))
  a.append(Appetizer(name="Jdubqqhp"))
  a.append(Appetizer(name="ypDpTEmYTJNbgwuAAuk"))
  a.append(Appetizer(name="PxSfXOLhtqroMQEYuI"))
  a.append(Appetizer(name="KGLHaywX"))
  a.append(Appetizer(name="wTopgFWuWqFm"))
  a.append(Appetizer(name="exxhtKZQ"))
  a.append(Appetizer(name="JxQkslh"))
  a.append(Appetizer(name="OKtn"))
  a.append(Appetizer(name="sZlmZGiQPtIAh"))
  a.append(Appetizer(name="KvBPV"))
  a.append(Appetizer(name="YMiRPnuTZ"))
  a.append(Appetizer(name="vSyFUX"))
  a.append(Appetizer(name="koaVbUY"))
  a.append(Appetizer(name="vGlLNtRWMBPrSQIGBl"))
  a.append(Appetizer(name="VsdLokjwQPOmqX"))
  a.append(Appetizer(name="uMcUfcpDItFDs"))
  a.append(Appetizer(name="bdQ"))
  a.append(Appetizer(name="Snt"))
  a.append(Appetizer(name="BfJB"))
  a.append(Appetizer(name="eJpMHmjqGbdtZTaC"))
  a.append(Appetizer(name="BN"))
  a.append(Appetizer(name="OhPbcBnJFNBsfKxc"))
  a.append(Appetizer(name="MAEwIQ"))
  a.append(Appetizer(name="FbZsPlRYOfBimieMN"))
  a.append(Appetizer(name="tMyziPnmnv"))
  a.append(Appetizer(name="ENGodOMkSCcdp"))
  a.append(Appetizer(name="oW"))
  a.append(Appetizer(name="jqBfeUjRYCpwb"))
  a.append(Appetizer(name="I"))
  a.append(Appetizer(name="ZTRhTQBKSyHSvnA"))
  a.append(Appetizer(name="AAYAcqLF"))
  a.append(Appetizer(name="GdO"))
  a.append(Appetizer(name="OJGbM"))
  a.append(Appetizer(name="CvqK"))
  a.append(Appetizer(name="irsRWLUz"))
  a.append(Appetizer(name="apwd"))
  a.append(Appetizer(name="HbTGG"))
  a.append(Appetizer(name="giSPcyLgGK"))
  a.append(Appetizer(name="gBXDWHZEILFekw"))
  a.append(Appetizer(name="XLWfktopVr"))
  a.append(Appetizer(name="JhDmBevCueHq"))
  a.append(Appetizer(name="tve"))
  a.append(Appetizer(name="aUWYXBp"))
  m.append(Meal(name="Zj", main="elHXoEkGJHTfXydBj", veggie="BkngOfUoTmqtHOMAsSC", side="XjMM"))
  m.append(Meal(name="eZlRse", main="NTOvguiPgjPlEc", veggie="RDyNWXZu", side="gPRF"))
  m.append(Meal(name="XLmGtNwx", main="DRgdveNnWklqvg", veggie="peSjRFwkVUTWaBqkUZc", side="vEicQun"))
  m.append(Meal(name="mEOcRZWoWATCb", main="A", veggie="uX", side="C"))
  m.append(Meal(name="qk", main="DImoNaZRWzYbjunIA", veggie="HZQqWOurDrFhZYi", side="jfKqdlVACidsVYrKT"))
  m.append(Meal(name="vhKkoZ", main="QluJoiBdiPSjTREbfCV", veggie="RGqRxjI", side="jdoZXCoKrCHis"))
  m.append(Meal(name="KhVzoF", main="TvAMOyYghpritkQKt", veggie="YlkFYBvSqtQxU", side="ossUKKxCsEPwAQuRc"))
  m.append(Meal(name="cGsWHxAeFkByvPuAnb", main="u", veggie="UYBeUiccXeIdacmo", side="skLRiJW"))
  m.append(Meal(name="Dzs", main="hUN", veggie="RrvWQClGLc", side="E"))
  m.append(Meal(name="LPWgXP", main="ZgQkrAsglrUFknMGX", veggie="MOoJtdbGKwI", side="CzfnjxBK"))
  m.append(Meal(name="mD", main="Es", veggie="uqiFNVKzPFeoMm", side="GoAPHgyqAHYxl"))
  m.append(Meal(name="DvCF", main="pHIEymqeAycJijjFFk", veggie="e", side="IyWZnR"))
  m.append(Meal(name="QblFGrOfyuS", main="T", veggie="BZzN", side="GtrPWzKW"))
  m.append(Meal(name="FXEHUTFUF", main="McSUxQepzTIeu", veggie="VIfO", side="qg"))
  m.append(Meal(name="hqWsFPYCvuQ", main="fPIeUkgPhYG", veggie="mWWjU", side="NBmQapgAdNh"))
  m.append(Meal(name="hEftYexRZsXkUncI", main="oWQHyVMOfSyaKEib", veggie="PHdBEJSkmyKM", side="WuHadHwnipvH"))
  m.append(Meal(name="gbK", main="r", veggie="g", side="CHSfCaUqj"))
  m.append(Meal(name="FyYzVa", main="X", veggie="ImwYuQymbIIGAb", side="vZmZhVnBnTwEUnuNKAh"))
  m.append(Meal(name="QjLlpYhdEwffGsyObxr", main="mIUZITpftBvcMifY", veggie="EqSfGGewaUntOuFNlRQ", side="zWOFfCwKkwDTnIFX"))
  m.append(Meal(name="E", main="AtjGgIxYASTCOC", veggie="aOVAVDAvqbpKPQzs", side="GTzDwFtOZBGsbbM"))
  m.append(Meal(name="lZhdeTslbTBK", main="pwqEZDoh", veggie="gmpwZynj", side="cr"))
  m.append(Meal(name="Hcb", main="Tqzl", veggie="VoiXIgGAtoNHMq", side="mROScjgKBz"))
  m.append(Meal(name="caloY", main="KYlwUCwgkhh", veggie="MLxIEz", side="SxzeyKTHsODuUk"))
  m.append(Meal(name="cwoMLL", main="sKykXwqm", veggie="NXaG", side="qryLVWWEwEx"))
  m.append(Meal(name="hoPyZCWLbzlEdS", main="nJNOemZLRA", veggie="QqpfnCul", side="hKxFhOFanfnrmMMo"))
  m.append(Meal(name="HBjxBFrofPKcLh", main="HQXkYe", veggie="HVtZCfTbqD", side="TrkhFsCcoSRkwftoT"))
  m.append(Meal(name="tsiK", main="bYqcAspvb", veggie="zuFxOQEXKMHzJCHmTX", side="urVZe"))
  m.append(Meal(name="hBfkvxWNYNKAWOzmasc", main="gxqlPTpMapFtlDNcN", veggie="svzMcxufKVy", side="oLvwcIJsXjzJYrnK"))
  m.append(Meal(name="wuXVqAIWyTbaeTq", main="ucayTRX", veggie="jLIxECdyrhWfwuhZ", side="OFpbDRbVfx"))
  m.append(Meal(name="zkbsnHsQYNpgrMw", main="TgHn", veggie="PrzysxmuxvWGic", side="LLEdnN"))
  m.append(Meal(name="n", main="KoXHZsrHnUtQi", veggie="FriJyufIKULUYxS", side="KkUZp"))
  m.append(Meal(name="kcIlkHphxKeZWiyh", main="wAkD", veggie="oNKz", side="QlpxCsSSsfAsT"))
  m.append(Meal(name="IPZfoyxxrvYzwNmcndJ", main="HwOSnePDOXk", veggie="BNqrexKmxzwYqR", side="ZzTFYA"))
  m.append(Meal(name="xGimYTMbTGurv", main="yg", veggie="fVAqrTHHLKaZimlJqjI", side="VbDaKZELJ"))
  m.append(Meal(name="UmXu", main="ormjxbdGdKYIQejskBV", veggie="pSBIfScXYfA", side="OZIGfmINguZcpfi"))
  m.append(Meal(name="vZgXTmEfJrxpukXLiy", main="iAQFY", veggie="iCw", side="ipsiSSCBtPZzgLWkRby"))
  m.append(Meal(name="GatLliocExXqUDhGGg", main="BdCRYrsIW", veggie="UvmPPZRWNmeKuh", side="BUIfblmlpKYpnXzK"))
  m.append(Meal(name="mxCEajsFOx", main="jMHek", veggie="oqBIFUSsfGLwuqp", side="tpQdTrVfwEbVqCGC"))
  m.append(Meal(name="Ie", main="yvwHDjpJGkOO", veggie="eQgFSsFgTQtQT", side="VhbNDL"))
  m.append(Meal(name="MW", main="pVAbrgTmfsf", veggie="NDkwNvbbHkmg", side="eqlYvUouwSFcet"))
  m.append(Meal(name="PZVEoFhIc", main="tCfePusRu", veggie="d", side="IyghjY"))
  m.append(Meal(name="AsY", main="pfvxYeTqc", veggie="ZTxaQoNQYaIBBY", side="YRbgJKV"))
  m.append(Meal(name="k", main="rwUiJ", veggie="RrNSfpsriLJXJAn", side="YtC"))
  m.append(Meal(name="EBzXJGYjGffCyBiPp", main="QSILluzPFyZZbEsE", veggie="wtddywMhBwD", side="mLyAdUlsMGFhP"))
  m.append(Meal(name="vbWrs", main="xWBdzcvZQTf", veggie="QdjRhFJ", side="UhIQDYCNZ"))
  m.append(Meal(name="mCObWa", main="An", veggie="AFygdlesQryFQJPbBiq", side="gWvmtTG"))
  m.append(Meal(name="JssjKtCzNVAeX", main="IXrWDMTGKTAPatTSl", veggie="CtvtzAZHCYnxfk", side="TeWfgjhdilcO"))
  m.append(Meal(name="HakKrdXeRCpQJ", main="FKnGclTRQFvjz", veggie="vJpUnutIkgpm", side="bLsFqgMw"))
  m.append(Meal(name="VdI", main="rDnCfN", veggie="qe", side="EijGXvaPpbk"))
  m.append(Meal(name="wePMzfShzImZDOTgLc", main="Zxpb", veggie="YsiGeamwZgFEp", side="HDeBa"))
  d.append(Dessert(name="AKPReWjkKZRnRsGvRDU"))
  d.append(Dessert(name="xvvfIjwJxxoX"))
  d.append(Dessert(name="EcVatQDxgHwEwd"))
  d.append(Dessert(name="xL"))
  d.append(Dessert(name="CGabmQUFBiTiyg"))
  d.append(Dessert(name="OLgmcumpKx"))
  d.append(Dessert(name="ZOrnojF"))
  d.append(Dessert(name="ejxWijyBhfjzOi"))
  d.append(Dessert(name="wZyEJHaU"))
  d.append(Dessert(name="SQGmFKASiGI"))
  d.append(Dessert(name="tmdsFsKDge"))
  d.append(Dessert(name="cOkXtVctEuoeCFHQGzT"))
  d.append(Dessert(name="FZSdmjxmSVL"))
  d.append(Dessert(name="dKRAFyzUnzoKLKD"))
  d.append(Dessert(name="fegevMNqQD"))
  d.append(Dessert(name="VCmTydTBVQCeLQ"))
  d.append(Dessert(name="loyAbN"))
  d.append(Dessert(name="JnOZlrmpv"))
  d.append(Dessert(name="YZdBWVBsuGQ"))
  d.append(Dessert(name="suwkMLdoZTwWHsivcVs"))
  d.append(Dessert(name="nvoEWCpENpxDVuUGh"))
  d.append(Dessert(name="kDnXpp"))
  d.append(Dessert(name="jsffGu"))
  d.append(Dessert(name="VSJGQCLjpWi"))
  d.append(Dessert(name="yaSAoGMePbTvXYszZpd"))
  d.append(Dessert(name="YQOfPYMomTxSMKIZJPj"))
  d.append(Dessert(name="pesQByVw"))
  d.append(Dessert(name="Y"))
  d.append(Dessert(name="jqkl"))
  d.append(Dessert(name="CrBjW"))
  d.append(Dessert(name="TWYFRqe"))
  d.append(Dessert(name="UalYcxsnHdUOwB"))
  d.append(Dessert(name="GRBycFmDIEcoTP"))
  d.append(Dessert(name="oleZre"))
  d.append(Dessert(name="kXwjlceRFOuSLDl"))
  d.append(Dessert(name="qWyXwZXJFkDH"))
  d.append(Dessert(name="GbjNxstDxKmrM"))
  d.append(Dessert(name="NMLxnTqga"))
  d.append(Dessert(name="PneNgwQjz"))
  d.append(Dessert(name="yQyOP"))
  d.append(Dessert(name="ozox"))
  d.append(Dessert(name="AcdZXwJxQVoZbt"))
  d.append(Dessert(name="smmGG"))
  d.append(Dessert(name="XR"))
  d.append(Dessert(name="Amb"))
  d.append(Dessert(name="hBKpQJTqUVKJ"))
  d.append(Dessert(name="gBuAyZnrOXNVwInMU"))
  d.append(Dessert(name="m"))
  d.append(Dessert(name="cJVIJ"))
  d.append(Dessert(name="Jhu"))


  return Menu(appetizers=a, meals=m, desserts=d)

