# Cyber Grand Challenge:  Final Event Release Package

## What is the Cyber Grand Challenge (CGC)?

Today's approach to cybersecurity depends on computer security experts:
experts identify new flaws and threats and remediate them by hand.  This
process can take over a year from first detection to the deployment of a
solution, by which time critical systems may have already been breached.  This
slow reaction cycle has created a permanent offensive advantage.

The Cyber Grand Challenge (CGC) seeks to automate this cyber defense process,
fielding the first generation of machines that can discover, prove and fix
software flaws in real-time, without any assistance.  If successful, the speed
of autonomy could someday blunt the structural advantages of cyber offense.


## About Cyber Grand Challenge Final Event (CFE)

The ultimate test of wits in computer security occurs through open competition
on the global Capture the Flag (CTF) tournament circuit.  In CTF contests,
experts reverse-engineer software, probe its weaknesses, search for deeply
hidden flaws and create securely patched replacements.

What if purpose-built computer systems could compete against the CTF circuit's
greatest experts?  DARPA has modeled the Cyber Grand Challenge on today's CTF
tournaments to pave the way toward that future.

On August 4th, 2016, DARPA will hold the world's first all-computer Capture the
Flag tournament in Las Vegas.  Seven prototype systems will square off against
each other, competing for nearly $4 million in prizes in a live network
competition.  The CGC Final Event will take place in conjunction with DEF CON,
home of the longest-running annual CTF competition.


## CFE Release Package

This package contains the challenge sets that will be used in CGC Final Event.
Each challenge set folder includes the following:

* README.md that describes the challenge and embedded vulnerabilities 
* Source code (`src`, `lib`, and `include` sub-directories)
* Vulnerable and Patched versions of the binaries (`bin` sub-directory)
* Proof(s) of Vulnerability (`pov` sub-directory)
* Poll (test case) generator (`poller` sub-directory)


## Resources

To play along during CGC Final Event, please see the following links
* [Live Updates from CFE](https://repo.cybergrandchallenge.com/cfe)
* [VMs, Tools, and Code](https://repo.cybergrandchallenge.com)
* [CFE Event Details](https://www.cybergrandchallenge.com/event)

To learn more about Cyber Grand Challenge, please see the following links
* [More Info about CGC](https://www.cybergrandchallenge.com)
* [Official CGC Website](https://cgc.darpa.mil)
