/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include "static.h"

size_t static_switch(size_t idx) {
	switch (idx) {
		case 0x00000000:
			return 0x2e4c7aa3;
		case 0x00000004:
			return 0xd37edee9;
		case 0x00000008:
			return 0x7289a220;
		case 0x0000000c:
			return 0x6a2ade8e;
		case 0x00000010:
			return 0x04c90bb1;
		case 0x00000014:
			return 0x4fe78602;
		case 0x00000018:
			return 0xd2a992a6;
		case 0x0000001c:
			return 0xa33b6316;
		case 0x00000020:
			return 0x7b86672f;
		case 0x00000024:
			return 0xb449d0ea;
		case 0x00000028:
			return 0x6a428bac;
		case 0x0000002c:
			return 0xfd37eb51;
		case 0x00000030:
			return 0xa53bebed;
		case 0x00000034:
			return 0x34140218;
		case 0x00000038:
			return 0x97457f6f;
		case 0x0000003c:
			return 0x7753c77d;
		case 0x00000040:
			return 0xf9ca3abc;
		case 0x00000044:
			return 0x95b0366c;
		case 0x00000048:
			return 0x8ce80c56;
		case 0x0000004c:
			return 0x0a22c174;
		case 0x00000050:
			return 0xf7706f63;
		case 0x00000054:
			return 0xd5014cb5;
		case 0x00000058:
			return 0x516352b1;
		case 0x0000005c:
			return 0x911ad6ed;
		case 0x00000060:
			return 0x58aacd30;
		case 0x00000064:
			return 0x0f557caa;
		case 0x00000068:
			return 0x3e4171fc;
		case 0x0000006c:
			return 0x3a210a11;
		case 0x00000070:
			return 0x64c04c4b;
		case 0x00000074:
			return 0xfbcfe354;
		case 0x00000078:
			return 0xb31d2f23;
		case 0x0000007c:
			return 0x99c00b79;
		case 0x00000080:
			return 0x71702cfa;
		case 0x00000084:
			return 0xd3f1f3a0;
		case 0x00000088:
			return 0xadef0eac;
		case 0x0000008c:
			return 0x5a3b6b3b;
		case 0x00000090:
			return 0x2ceb8f6a;
		case 0x00000094:
			return 0xd79c09a1;
		case 0x00000098:
			return 0xc8a4409f;
		case 0x0000009c:
			return 0xde739920;
		case 0x000000a0:
			return 0xfe1b258c;
		case 0x000000a4:
			return 0xdc35dffa;
		case 0x000000a8:
			return 0x49208171;
		case 0x000000ac:
			return 0x4099bbe5;
		case 0x000000b0:
			return 0x46adb084;
		case 0x000000b4:
			return 0x3bddcb53;
		case 0x000000b8:
			return 0x9e646ae6;
		case 0x000000bc:
			return 0x32a5ab49;
		case 0x000000c0:
			return 0xd92d4346;
		case 0x000000c4:
			return 0xb1e7a460;
		case 0x000000c8:
			return 0x11859963;
		case 0x000000cc:
			return 0x0e5930b9;
		case 0x000000d0:
			return 0xf85d3d8b;
		case 0x000000d4:
			return 0x97c84d66;
		case 0x000000d8:
			return 0x558c12f9;
		case 0x000000dc:
			return 0x784cb173;
		case 0x000000e0:
			return 0x2adaa510;
		case 0x000000e4:
			return 0x7306837b;
		case 0x000000e8:
			return 0xc1923b6b;
		case 0x000000ec:
			return 0x7ddb1fb1;
		case 0x000000f0:
			return 0x2bc5967a;
		case 0x000000f4:
			return 0x93d9e052;
		case 0x000000f8:
			return 0x41eba87b;
		case 0x000000fc:
			return 0xbbec6f81;
		case 0x00000100:
			return 0x49b65b16;
		case 0x00000104:
			return 0x908a5345;
		case 0x00000108:
			return 0x5a80aac0;
		case 0x0000010c:
			return 0xf7f95ecf;
		case 0x00000110:
			return 0x8af42564;
		case 0x00000114:
			return 0xd4b0ce48;
		case 0x00000118:
			return 0x4d5d6f62;
		case 0x0000011c:
			return 0xdc79bcf7;
		case 0x00000120:
			return 0x0fa22883;
		case 0x00000124:
			return 0x7f578e78;
		case 0x00000128:
			return 0x9add2a57;
		case 0x0000012c:
			return 0x0f36e9e7;
		case 0x00000130:
			return 0x899eff72;
		case 0x00000134:
			return 0x8962edf6;
		case 0x00000138:
			return 0x20c9216f;
		case 0x0000013c:
			return 0xa6c0b44a;
		case 0x00000140:
			return 0x5b1ed0b8;
		case 0x00000144:
			return 0xb5677758;
		case 0x00000148:
			return 0xd2828710;
		case 0x0000014c:
			return 0x4ae8497b;
		case 0x00000150:
			return 0xf7ecccbb;
		case 0x00000154:
			return 0x1804d6d7;
		case 0x00000158:
			return 0x61af5489;
		case 0x0000015c:
			return 0xc28243ca;
		case 0x00000160:
			return 0x1826d065;
		case 0x00000164:
			return 0xd8eba2ba;
		case 0x00000168:
			return 0x702dfaef;
		case 0x0000016c:
			return 0x2313b2dd;
		case 0x00000170:
			return 0x825f6436;
		case 0x00000174:
			return 0x23df238b;
		case 0x00000178:
			return 0xcd21a278;
		case 0x0000017c:
			return 0x997a1459;
		case 0x00000180:
			return 0xb70fb6b7;
		case 0x00000184:
			return 0xf1832d0d;
		case 0x00000188:
			return 0xd8a2fc99;
		case 0x0000018c:
			return 0x02ccefed;
		case 0x00000190:
			return 0xb8b46fe1;
		case 0x00000194:
			return 0xaaca685a;
		case 0x00000198:
			return 0x27706707;
		case 0x0000019c:
			return 0xd8b7c847;
		case 0x000001a0:
			return 0xc33b5305;
		case 0x000001a4:
			return 0xf23d3a57;
		case 0x000001a8:
			return 0xe41d5fad;
		case 0x000001ac:
			return 0x22068211;
		case 0x000001b0:
			return 0x3616091f;
		case 0x000001b4:
			return 0x545abd8d;
		case 0x000001b8:
			return 0xdbe9eaf7;
		case 0x000001bc:
			return 0x0d448deb;
		case 0x000001c0:
			return 0xe99fcee2;
		case 0x000001c4:
			return 0x3994c807;
		case 0x000001c8:
			return 0x70810e6c;
		case 0x000001cc:
			return 0x1e1927cc;
		case 0x000001d0:
			return 0x2df513cb;
		case 0x000001d4:
			return 0x3c0560aa;
		case 0x000001d8:
			return 0x715e62ec;
		case 0x000001dc:
			return 0x3170a259;
		case 0x000001e0:
			return 0xa185d439;
		case 0x000001e4:
			return 0xa541ea0e;
		case 0x000001e8:
			return 0xd0985534;
		case 0x000001ec:
			return 0xd37de58b;
		case 0x000001f0:
			return 0x7077d607;
		case 0x000001f4:
			return 0xcceed1b0;
		case 0x000001f8:
			return 0xb62d0a50;
		case 0x000001fc:
			return 0x53659a88;
		case 0x00000200:
			return 0xcd21c50a;
		case 0x00000204:
			return 0xd5b93faf;
		case 0x00000208:
			return 0x79628a99;
		case 0x0000020c:
			return 0x62321ffa;
		case 0x00000210:
			return 0x50a416af;
		case 0x00000214:
			return 0xdc1e1a12;
		case 0x00000218:
			return 0xe7e8ee3e;
		case 0x0000021c:
			return 0xbe8ff9b0;
		case 0x00000220:
			return 0x54a4f42c;
		case 0x00000224:
			return 0x99dc3497;
		case 0x00000228:
			return 0x507518f0;
		case 0x0000022c:
			return 0xdadcb2c2;
		case 0x00000230:
			return 0x7fe8f908;
		case 0x00000234:
			return 0xaa3cd055;
		case 0x00000238:
			return 0x45201d56;
		case 0x0000023c:
			return 0xad39babe;
		case 0x00000240:
			return 0xf7240b5f;
		case 0x00000244:
			return 0x822b00da;
		case 0x00000248:
			return 0x94b617cc;
		case 0x0000024c:
			return 0x0cff92ee;
		case 0x00000250:
			return 0x90768743;
		case 0x00000254:
			return 0x67a49268;
		case 0x00000258:
			return 0x34fa24f7;
		case 0x0000025c:
			return 0x643abeaf;
		case 0x00000260:
			return 0xbaa18c42;
		case 0x00000264:
			return 0x3de5fbc1;
		case 0x00000268:
			return 0x47465022;
		case 0x0000026c:
			return 0x77dd5c99;
		case 0x00000270:
			return 0x747df307;
		case 0x00000274:
			return 0xd666c6b3;
		case 0x00000278:
			return 0x3fe4587a;
		case 0x0000027c:
			return 0x7ee7cec7;
		case 0x00000280:
			return 0x9b383398;
		case 0x00000284:
			return 0x045606fa;
		case 0x00000288:
			return 0x5ba5a5a6;
		case 0x0000028c:
			return 0x457c8ddf;
		case 0x00000290:
			return 0x1872daa0;
		case 0x00000294:
			return 0xac4f23a7;
		case 0x00000298:
			return 0xe2d48a45;
		case 0x0000029c:
			return 0xc5ace788;
		case 0x000002a0:
			return 0xd5bbf858;
		case 0x000002a4:
			return 0x946b5882;
		case 0x000002a8:
			return 0x3ae77c27;
		case 0x000002ac:
			return 0x7c16cf4d;
		case 0x000002b0:
			return 0x51475153;
		case 0x000002b4:
			return 0x7f308d9d;
		case 0x000002b8:
			return 0x8f506214;
		case 0x000002bc:
			return 0xa0ad1eea;
		case 0x000002c0:
			return 0x08a2bb75;
		case 0x000002c4:
			return 0xcaf45c38;
		case 0x000002c8:
			return 0xf293a0ad;
		case 0x000002cc:
			return 0x727220c3;
		case 0x000002d0:
			return 0x17e6739e;
		case 0x000002d4:
			return 0x9c3b4743;
		case 0x000002d8:
			return 0x5b691f58;
		case 0x000002dc:
			return 0xd0ae79ba;
		case 0x000002e0:
			return 0x5ccbd5d5;
		case 0x000002e4:
			return 0xe8aa4375;
		case 0x000002e8:
			return 0xe18a5ba2;
		case 0x000002ec:
			return 0xe9b6e602;
		case 0x000002f0:
			return 0xc09ce3b9;
		case 0x000002f4:
			return 0x30745d58;
		case 0x000002f8:
			return 0x6390b788;
		case 0x000002fc:
			return 0x6b8eda72;
		case 0x00000300:
			return 0x9cde040e;
		case 0x00000304:
			return 0xeb8906b5;
		case 0x00000308:
			return 0x1368a7e5;
		case 0x0000030c:
			return 0x4f9d5882;
		case 0x00000310:
			return 0xa42e5939;
		case 0x00000314:
			return 0xddf4d331;
		case 0x00000318:
			return 0x466e708c;
		case 0x0000031c:
			return 0x0dfdc638;
		case 0x00000320:
			return 0xbd31aa05;
		case 0x00000324:
			return 0x5aaa3e23;
		case 0x00000328:
			return 0x5f8dcb2e;
		case 0x0000032c:
			return 0x5d786b4e;
		case 0x00000330:
			return 0x35018788;
		case 0x00000334:
			return 0xcf69b33b;
		case 0x00000338:
			return 0xb2bba39e;
		case 0x0000033c:
			return 0x282e9a54;
		case 0x00000340:
			return 0x7acd2079;
		case 0x00000344:
			return 0x545ef601;
		case 0x00000348:
			return 0x0cda4813;
		case 0x0000034c:
			return 0x95569757;
		case 0x00000350:
			return 0xb62bb38a;
		case 0x00000354:
			return 0xd9294855;
		case 0x00000358:
			return 0xc6683343;
		case 0x0000035c:
			return 0xe174ae58;
		case 0x00000360:
			return 0xeb003cb4;
		case 0x00000364:
			return 0xdedd43bd;
		case 0x00000368:
			return 0x6ab46545;
		case 0x0000036c:
			return 0x3eb6bc06;
		case 0x00000370:
			return 0x6016c6ac;
		case 0x00000374:
			return 0x9c33518a;
		case 0x00000378:
			return 0xa1a89c6d;
		case 0x0000037c:
			return 0xa09fc6f1;
		case 0x00000380:
			return 0x22b677d5;
		case 0x00000384:
			return 0xbc34031d;
		case 0x00000388:
			return 0x286648b9;
		case 0x0000038c:
			return 0xfc3e1ef9;
		case 0x00000390:
			return 0x97dc6a7b;
		case 0x00000394:
			return 0x20f0350a;
		case 0x00000398:
			return 0xb030cd6d;
		case 0x0000039c:
			return 0xa9b48b38;
		case 0x000003a0:
			return 0x05e6066a;
		case 0x000003a4:
			return 0x9d857a31;
		case 0x000003a8:
			return 0xa093d16c;
		case 0x000003ac:
			return 0x4976c76b;
		case 0x000003b0:
			return 0xd9769c53;
		case 0x000003b4:
			return 0x04010e92;
		case 0x000003b8:
			return 0x9cbe4779;
		case 0x000003bc:
			return 0xd5dec301;
		case 0x000003c0:
			return 0xce66a5a2;
		case 0x000003c4:
			return 0x10e88e46;
		case 0x000003c8:
			return 0xcee33982;
		case 0x000003cc:
			return 0xe16eb36d;
		case 0x000003d0:
			return 0xa79c3ff3;
		case 0x000003d4:
			return 0x7fc6c7e2;
		case 0x000003d8:
			return 0xbc70afe6;
		case 0x000003dc:
			return 0x0a81eea3;
		case 0x000003e0:
			return 0x8753350c;
		case 0x000003e4:
			return 0xc22b1356;
		case 0x000003e8:
			return 0x7ffe2c42;
		case 0x000003ec:
			return 0x7616c5c1;
		case 0x000003f0:
			return 0x6fff0d71;
		case 0x000003f4:
			return 0x4f245367;
		case 0x000003f8:
			return 0x227bd876;
		case 0x000003fc:
			return 0x369d398a;
		case 0x00000400:
			return 0x31722b03;
		case 0x00000404:
			return 0x230a4654;
		case 0x00000408:
			return 0x574d5103;
		case 0x0000040c:
			return 0x1bf36f81;
		case 0x00000410:
			return 0x76fb9944;
		case 0x00000414:
			return 0xd5aff4f6;
		case 0x00000418:
			return 0xa80f7e63;
		case 0x0000041c:
			return 0xea160381;
		case 0x00000420:
			return 0xcf22c9cb;
		case 0x00000424:
			return 0xd7406000;
		case 0x00000428:
			return 0xe99a5ff8;
		case 0x0000042c:
			return 0x28a60d3f;
		case 0x00000430:
			return 0x1f199439;
		case 0x00000434:
			return 0x43da96c2;
		case 0x00000438:
			return 0xa8861d84;
		case 0x0000043c:
			return 0x9bc4857d;
		case 0x00000440:
			return 0xee34617e;
		case 0x00000444:
			return 0xcf38e3e8;
		case 0x00000448:
			return 0xedc5f6fc;
		case 0x0000044c:
			return 0x214f3a62;
		case 0x00000450:
			return 0x7fca0a20;
		case 0x00000454:
			return 0x1e3adfcb;
		case 0x00000458:
			return 0x0973882c;
		case 0x0000045c:
			return 0xd451b3be;
		case 0x00000460:
			return 0x08be4d5d;
		case 0x00000464:
			return 0xb9c8e41c;
		case 0x00000468:
			return 0xd9311e65;
		case 0x0000046c:
			return 0xd95fd495;
		case 0x00000470:
			return 0x6f66a3bc;
		case 0x00000474:
			return 0x007f0a31;
		case 0x00000478:
			return 0xcd61bcb4;
		case 0x0000047c:
			return 0x1f589237;
		case 0x00000480:
			return 0x8376a336;
		case 0x00000484:
			return 0x1819b76e;
		case 0x00000488:
			return 0x84514a8c;
		case 0x0000048c:
			return 0xfc58e387;
		case 0x00000490:
			return 0xbaf4e4a2;
		case 0x00000494:
			return 0x4b3e6ec0;
		case 0x00000498:
			return 0xdb7123ee;
		case 0x0000049c:
			return 0xbf9101a3;
		case 0x000004a0:
			return 0x7dbd1f8b;
		case 0x000004a4:
			return 0x671b3d38;
		case 0x000004a8:
			return 0xa6d3155b;
		case 0x000004ac:
			return 0x911c6d08;
		case 0x000004b0:
			return 0x674253f3;
		case 0x000004b4:
			return 0x5eeb62f7;
		case 0x000004b8:
			return 0xdd4dc392;
		case 0x000004bc:
			return 0xdbf382ab;
		case 0x000004c0:
			return 0x27ed3dc0;
		case 0x000004c4:
			return 0x02655b6a;
		case 0x000004c8:
			return 0xa59d1360;
		case 0x000004cc:
			return 0x6bc4eff4;
		case 0x000004d0:
			return 0xdfedd926;
		case 0x000004d4:
			return 0x0a13847c;
		case 0x000004d8:
			return 0x64d589ad;
		case 0x000004dc:
			return 0x766376b9;
		case 0x000004e0:
			return 0xaf6170e8;
		case 0x000004e4:
			return 0x0116f56a;
		case 0x000004e8:
			return 0xe7448fe2;
		case 0x000004ec:
			return 0x11cd2609;
		case 0x000004f0:
			return 0x867e5821;
		case 0x000004f4:
			return 0x83816da1;
		case 0x000004f8:
			return 0x158f769a;
		case 0x000004fc:
			return 0x16d54f9b;
		case 0x00000500:
			return 0x816656e5;
		case 0x00000504:
			return 0x385304a4;
		case 0x00000508:
			return 0xcb2cb164;
		case 0x0000050c:
			return 0x6783eb4d;
		case 0x00000510:
			return 0x1cfc71de;
		case 0x00000514:
			return 0x34eb210d;
		case 0x00000518:
			return 0x5b8ca7ea;
		case 0x0000051c:
			return 0x3e38848d;
		case 0x00000520:
			return 0x19a01f82;
		case 0x00000524:
			return 0x047d21d4;
		case 0x00000528:
			return 0x43cebab7;
		case 0x0000052c:
			return 0xc1849da7;
		case 0x00000530:
			return 0x3665ab83;
		case 0x00000534:
			return 0x98b90539;
		case 0x00000538:
			return 0x743802d9;
		case 0x0000053c:
			return 0x3649584d;
		case 0x00000540:
			return 0xc3074e6c;
		case 0x00000544:
			return 0x117733b4;
		case 0x00000548:
			return 0x4cea85a5;
		case 0x0000054c:
			return 0x2b4cfbb2;
		case 0x00000550:
			return 0x312106f0;
		case 0x00000554:
			return 0xd9104c45;
		case 0x00000558:
			return 0x7ce40d3c;
		case 0x0000055c:
			return 0x3c4a7ac1;
		case 0x00000560:
			return 0x20bae962;
		case 0x00000564:
			return 0x44524f15;
		case 0x00000568:
			return 0x12b71e9d;
		case 0x0000056c:
			return 0xefbeefaf;
		case 0x00000570:
			return 0x71f1be0a;
		case 0x00000574:
			return 0xcd019c18;
		case 0x00000578:
			return 0xef89ddd4;
		case 0x0000057c:
			return 0x1aeaf29f;
		case 0x00000580:
			return 0x13522538;
		case 0x00000584:
			return 0x67f77e93;
		case 0x00000588:
			return 0x5ee62307;
		case 0x0000058c:
			return 0x9d666e16;
		case 0x00000590:
			return 0x98fb3a39;
		case 0x00000594:
			return 0xd28c1c2f;
		case 0x00000598:
			return 0x689db8b2;
		case 0x0000059c:
			return 0xee9bec45;
		case 0x000005a0:
			return 0x1bff3802;
		case 0x000005a4:
			return 0x6361a4c4;
		case 0x000005a8:
			return 0x4a20c195;
		case 0x000005ac:
			return 0x9f8f5803;
		case 0x000005b0:
			return 0xfd595100;
		case 0x000005b4:
			return 0x1743be85;
		case 0x000005b8:
			return 0x83396cf0;
		case 0x000005bc:
			return 0x29c8bea9;
		case 0x000005c0:
			return 0x71fbb284;
		case 0x000005c4:
			return 0xb64f067d;
		case 0x000005c8:
			return 0xb39599ee;
		case 0x000005cc:
			return 0x72cf3499;
		case 0x000005d0:
			return 0xd7ca17e5;
		case 0x000005d4:
			return 0x4331cdd5;
		case 0x000005d8:
			return 0x2e558d32;
		case 0x000005dc:
			return 0x8797d32a;
		case 0x000005e0:
			return 0x78c6e0dc;
		case 0x000005e4:
			return 0x6c5f56ad;
		case 0x000005e8:
			return 0xd95b1017;
		case 0x000005ec:
			return 0xae7e9a96;
		case 0x000005f0:
			return 0xa513e3be;
		case 0x000005f4:
			return 0x2d69be31;
		case 0x000005f8:
			return 0xed2b9882;
		case 0x000005fc:
			return 0xb1e151f7;
		case 0x00000600:
			return 0xfcc3614a;
		case 0x00000604:
			return 0x660716c1;
		case 0x00000608:
			return 0x6b444522;
		case 0x0000060c:
			return 0x3df3bb2b;
		case 0x00000610:
			return 0x1f36ef3d;
		case 0x00000614:
			return 0xa4edfd1e;
		case 0x00000618:
			return 0x856dbb23;
		case 0x0000061c:
			return 0xcc9cd245;
		case 0x00000620:
			return 0x3f8422e5;
		case 0x00000624:
			return 0xe2590b12;
		case 0x00000628:
			return 0x099c8479;
		case 0x0000062c:
			return 0xafee2c68;
		case 0x00000630:
			return 0xfbfe7f86;
		case 0x00000634:
			return 0x8c49360f;
		case 0x00000638:
			return 0x8f2137ff;
		case 0x0000063c:
			return 0x4e592828;
		case 0x00000640:
			return 0xc2668d3f;
		case 0x00000644:
			return 0xb87853d3;
		case 0x00000648:
			return 0x8ad8973b;
		case 0x0000064c:
			return 0xd3b92c68;
		case 0x00000650:
			return 0x835eadb5;
		case 0x00000654:
			return 0x900bbcaa;
		case 0x00000658:
			return 0xf79609e9;
		case 0x0000065c:
			return 0x3996f5d1;
		case 0x00000660:
			return 0x63250d09;
		case 0x00000664:
			return 0xc0da1c57;
		case 0x00000668:
			return 0x8f9c93ce;
		case 0x0000066c:
			return 0x2e270a76;
		case 0x00000670:
			return 0x04f95b46;
		case 0x00000674:
			return 0xe2866b7c;
		case 0x00000678:
			return 0x8296068b;
		case 0x0000067c:
			return 0x6f557790;
		case 0x00000680:
			return 0x03d8c609;
		case 0x00000684:
			return 0xcd177cbd;
		case 0x00000688:
			return 0x7ecca8ed;
		case 0x0000068c:
			return 0x29ca48a3;
		case 0x00000690:
			return 0xd0b858e4;
		case 0x00000694:
			return 0x5d73bf9b;
		case 0x00000698:
			return 0x4311a519;
		case 0x0000069c:
			return 0xc8fe3afa;
		case 0x000006a0:
			return 0x0c769abd;
		case 0x000006a4:
			return 0x30268d36;
		case 0x000006a8:
			return 0x362437ae;
		case 0x000006ac:
			return 0x3ed71d10;
		case 0x000006b0:
			return 0x13b962b3;
		case 0x000006b4:
			return 0xcb0f4ece;
		case 0x000006b8:
			return 0x87fe655d;
		case 0x000006bc:
			return 0x0bcdd68a;
		case 0x000006c0:
			return 0x4ee8e763;
		case 0x000006c4:
			return 0x1f41abb1;
		case 0x000006c8:
			return 0xc4324f4c;
		case 0x000006cc:
			return 0x9f6caeaf;
		case 0x000006d0:
			return 0xb93bcaa8;
		case 0x000006d4:
			return 0x77cf2c28;
		case 0x000006d8:
			return 0xe499c67f;
		case 0x000006dc:
			return 0xc7a2fadb;
		case 0x000006e0:
			return 0xd9acd823;
		case 0x000006e4:
			return 0x12b53770;
		case 0x000006e8:
			return 0xe506e29e;
		case 0x000006ec:
			return 0x6a326ed9;
		case 0x000006f0:
			return 0xd21fd235;
		case 0x000006f4:
			return 0xa891ce29;
		case 0x000006f8:
			return 0x9efa424b;
		case 0x000006fc:
			return 0xf2eb7872;
		case 0x00000700:
			return 0xefbfd0f4;
		case 0x00000704:
			return 0xcb0c730e;
		case 0x00000708:
			return 0x12e341e7;
		case 0x0000070c:
			return 0x109aab27;
		case 0x00000710:
			return 0x504a0a7e;
		case 0x00000714:
			return 0xb32c5f5e;
		case 0x00000718:
			return 0xbf12d08b;
		case 0x0000071c:
			return 0xe30b6c8b;
		case 0x00000720:
			return 0x704917ff;
		case 0x00000724:
			return 0x62392ac3;
		case 0x00000728:
			return 0x04802605;
		case 0x0000072c:
			return 0xd78b82f8;
		case 0x00000730:
			return 0xe4422eeb;
		case 0x00000734:
			return 0xc1ddc24e;
		case 0x00000738:
			return 0xcd1d9167;
		case 0x0000073c:
			return 0x70625a4e;
		case 0x00000740:
			return 0x1a79f7cc;
		case 0x00000744:
			return 0x85041258;
		case 0x00000748:
			return 0x5f4c8fd9;
		case 0x0000074c:
			return 0xd21c634a;
		case 0x00000750:
			return 0xaefe4599;
		case 0x00000754:
			return 0xca11d6fe;
		case 0x00000758:
			return 0xb161cfe4;
		case 0x0000075c:
			return 0xeb90a705;
		case 0x00000760:
			return 0x51ac10e8;
		case 0x00000764:
			return 0xa06fd61a;
		case 0x00000768:
			return 0x3019ebbd;
		case 0x0000076c:
			return 0xb5370d81;
		case 0x00000770:
			return 0x0a29c3fa;
		case 0x00000774:
			return 0xa81519f1;
		case 0x00000778:
			return 0x90382f0f;
		case 0x0000077c:
			return 0x1de0b571;
		case 0x00000780:
			return 0x8804d5b1;
		case 0x00000784:
			return 0x997ebaf1;
		case 0x00000788:
			return 0x1439377e;
		case 0x0000078c:
			return 0x4dc3cefc;
		case 0x00000790:
			return 0xe098ef40;
		case 0x00000794:
			return 0xb7677f02;
		case 0x00000798:
			return 0xc2c31efb;
		case 0x0000079c:
			return 0xe14ecee1;
		case 0x000007a0:
			return 0x31e3da24;
		case 0x000007a4:
			return 0x2976953e;
		case 0x000007a8:
			return 0x992a7e8a;
		case 0x000007ac:
			return 0x872cd221;
		case 0x000007b0:
			return 0xe24af11a;
		case 0x000007b4:
			return 0xacb03a83;
		case 0x000007b8:
			return 0x367b08fc;
		case 0x000007bc:
			return 0x7bea9fcf;
		case 0x000007c0:
			return 0x2f01b5af;
		case 0x000007c4:
			return 0x41a91169;
		case 0x000007c8:
			return 0xa57ea9e0;
		case 0x000007cc:
			return 0xe10971f4;
		case 0x000007d0:
			return 0x97252b11;
		case 0x000007d4:
			return 0xb9778d90;
		case 0x000007d8:
			return 0x5733c2f3;
		case 0x000007dc:
			return 0x353ea4c6;
		case 0x000007e0:
			return 0x78d23293;
		case 0x000007e4:
			return 0x11f693a1;
		case 0x000007e8:
			return 0x8d7ca9fa;
		case 0x000007ec:
			return 0xac898887;
		case 0x000007f0:
			return 0x6451e134;
		case 0x000007f4:
			return 0x594c390b;
		case 0x000007f8:
			return 0xdd6a1770;
		case 0x000007fc:
			return 0xbce97e8e;
		case 0x00000800:
			return 0x40d81098;
		case 0x00000804:
			return 0xaf2514bb;
		case 0x00000808:
			return 0xff768f83;
		case 0x0000080c:
			return 0x6272df80;
		case 0x00000810:
			return 0xc38fa403;
		case 0x00000814:
			return 0x92465d41;
		case 0x00000818:
			return 0x6aa1d9bb;
		case 0x0000081c:
			return 0x18575dea;
		case 0x00000820:
			return 0xeb6ecdd7;
		case 0x00000824:
			return 0xa590f647;
		case 0x00000828:
			return 0xb2cfbeb3;
		case 0x0000082c:
			return 0xba02148b;
		case 0x00000830:
			return 0x1fcb846b;
		case 0x00000834:
			return 0xad32e750;
		case 0x00000838:
			return 0xdf6f1f11;
		case 0x0000083c:
			return 0xf4bd371e;
		case 0x00000840:
			return 0xb25e526b;
		case 0x00000844:
			return 0xe7ff8bdc;
		case 0x00000848:
			return 0xc0ea9eb1;
		case 0x0000084c:
			return 0x0456dfa2;
		case 0x00000850:
			return 0x921fcd73;
		case 0x00000854:
			return 0xe073febf;
		case 0x00000858:
			return 0x077bd12c;
		case 0x0000085c:
			return 0xf7be70b4;
		case 0x00000860:
			return 0xae43ad10;
		case 0x00000864:
			return 0xf1a17347;
		case 0x00000868:
			return 0x20143ade;
		case 0x0000086c:
			return 0xb8c9aae0;
		case 0x00000870:
			return 0xc5f38c63;
		case 0x00000874:
			return 0x34aa0b4a;
		case 0x00000878:
			return 0x802f3839;
		case 0x0000087c:
			return 0x56c018c9;
		case 0x00000880:
			return 0xf362f6d6;
		case 0x00000884:
			return 0xc88080d5;
		case 0x00000888:
			return 0x61b5ce13;
		case 0x0000088c:
			return 0xa4f33dcf;
		case 0x00000890:
			return 0x98f44d1f;
		case 0x00000894:
			return 0xb2946dfd;
		case 0x00000898:
			return 0x4e78b143;
		case 0x0000089c:
			return 0x636d9573;
		case 0x000008a0:
			return 0xaf5918fe;
		case 0x000008a4:
			return 0x66b122a6;
		case 0x000008a8:
			return 0x72e3c931;
		case 0x000008ac:
			return 0x94932673;
		case 0x000008b0:
			return 0x2d725d30;
		case 0x000008b4:
			return 0x0e89c957;
		case 0x000008b8:
			return 0x28f4e151;
		case 0x000008bc:
			return 0x812ae341;
		case 0x000008c0:
			return 0xd301591f;
		case 0x000008c4:
			return 0x9803e3c2;
		case 0x000008c8:
			return 0x59aa471d;
		case 0x000008cc:
			return 0xbd14e878;
		case 0x000008d0:
			return 0xa405382e;
		case 0x000008d4:
			return 0x764c02c2;
		case 0x000008d8:
			return 0x9e84e249;
		case 0x000008dc:
			return 0xb8d090d1;
		case 0x000008e0:
			return 0xdadcaefc;
		case 0x000008e4:
			return 0x40ae25c0;
		case 0x000008e8:
			return 0x828fd3e7;
		case 0x000008ec:
			return 0xa7cdfe7c;
		case 0x000008f0:
			return 0xc59a3b01;
		case 0x000008f4:
			return 0xa1f7cc46;
		case 0x000008f8:
			return 0x69d0ef2f;
		case 0x000008fc:
			return 0x523558cf;
		case 0x00000900:
			return 0x256b5be0;
		case 0x00000904:
			return 0x786dfa6a;
		case 0x00000908:
			return 0x6f07eeda;
		case 0x0000090c:
			return 0x2b24d171;
		case 0x00000910:
			return 0x903710fd;
		case 0x00000914:
			return 0xe96cea9f;
		case 0x00000918:
			return 0x891092c7;
		case 0x0000091c:
			return 0xbea595d8;
		case 0x00000920:
			return 0xbef7f9a5;
		case 0x00000924:
			return 0x75a36948;
		case 0x00000928:
			return 0xb48e3bf0;
		case 0x0000092c:
			return 0x24130542;
		case 0x00000930:
			return 0xba9e2a27;
		case 0x00000934:
			return 0x1a3e9324;
		case 0x00000938:
			return 0xe671a899;
		case 0x0000093c:
			return 0x9f77cd8b;
		case 0x00000940:
			return 0x6ccfae07;
		case 0x00000944:
			return 0x64b16046;
		case 0x00000948:
			return 0x79b1b891;
		case 0x0000094c:
			return 0x89267f5c;
		case 0x00000950:
			return 0x16978ffe;
		case 0x00000954:
			return 0x3b713296;
		case 0x00000958:
			return 0x58245017;
		case 0x0000095c:
			return 0xc1061e60;
		case 0x00000960:
			return 0x33e3bf25;
		case 0x00000964:
			return 0x55cd80a4;
		case 0x00000968:
			return 0x884668ef;
		case 0x0000096c:
			return 0xeb0fa234;
		case 0x00000970:
			return 0x9aece0e4;
		case 0x00000974:
			return 0x741be27e;
		case 0x00000978:
			return 0xba98c6b1;
		case 0x0000097c:
			return 0xdb3ff86b;
		case 0x00000980:
			return 0xa8084f21;
		case 0x00000984:
			return 0x1d3a68ce;
		case 0x00000988:
			return 0x6d467e73;
		case 0x0000098c:
			return 0x123ae25b;
		case 0x00000990:
			return 0x356c7bce;
		case 0x00000994:
			return 0xd00df1cd;
		case 0x00000998:
			return 0xefe8341d;
		case 0x0000099c:
			return 0x55b15ac2;
		case 0x000009a0:
			return 0x8ab9623f;
		case 0x000009a4:
			return 0x426bc10b;
		case 0x000009a8:
			return 0xfc6f814b;
		case 0x000009ac:
			return 0x987fb615;
		case 0x000009b0:
			return 0xb7f1c817;
		case 0x000009b4:
			return 0x57275251;
		case 0x000009b8:
			return 0x0edb23fb;
		case 0x000009bc:
			return 0x92545ad4;
		case 0x000009c0:
			return 0xc6173614;
		case 0x000009c4:
			return 0x1720b77f;
		case 0x000009c8:
			return 0xd9b2616f;
		case 0x000009cc:
			return 0xaabc6a90;
		case 0x000009d0:
			return 0x14fc46a6;
		case 0x000009d4:
			return 0x73bf7964;
		case 0x000009d8:
			return 0x7e9b3beb;
		case 0x000009dc:
			return 0x6699bb0a;
		case 0x000009e0:
			return 0xa3829ecc;
		case 0x000009e4:
			return 0xffd6a9b1;
		case 0x000009e8:
			return 0xb774830f;
		case 0x000009ec:
			return 0x74d475a9;
		case 0x000009f0:
			return 0x434330ee;
		case 0x000009f4:
			return 0xce4302e2;
		case 0x000009f8:
			return 0xcbef6669;
		case 0x000009fc:
			return 0xfdb6d2b7;
		case 0x00000a00:
			return 0x349d45ec;
		case 0x00000a04:
			return 0x866babcf;
		case 0x00000a08:
			return 0x70a30eeb;
		case 0x00000a0c:
			return 0x0b1620dd;
		case 0x00000a10:
			return 0xbf2253d3;
		case 0x00000a14:
			return 0xd429e629;
		case 0x00000a18:
			return 0x12a3d20b;
		case 0x00000a1c:
			return 0x0350750b;
		case 0x00000a20:
			return 0x96886048;
		case 0x00000a24:
			return 0x06d37301;
		case 0x00000a28:
			return 0xa7f845a5;
		case 0x00000a2c:
			return 0x4b4f6490;
		case 0x00000a30:
			return 0xc386ba35;
		case 0x00000a34:
			return 0x29edbc97;
		case 0x00000a38:
			return 0x8026361b;
		case 0x00000a3c:
			return 0x2840fa69;
		case 0x00000a40:
			return 0x2e7bcdef;
		case 0x00000a44:
			return 0x51582ed8;
		case 0x00000a48:
			return 0x654fefc5;
		case 0x00000a4c:
			return 0x4dc905da;
		case 0x00000a50:
			return 0x3e5fd466;
		case 0x00000a54:
			return 0xa93c1575;
		case 0x00000a58:
			return 0xfa9c78e3;
		case 0x00000a5c:
			return 0xf44d9f4d;
		case 0x00000a60:
			return 0x5c3c259c;
		case 0x00000a64:
			return 0x101f0efa;
		case 0x00000a68:
			return 0xa910b56e;
		case 0x00000a6c:
			return 0x5f6f0891;
		case 0x00000a70:
			return 0x689e62cd;
		case 0x00000a74:
			return 0xb709034f;
		case 0x00000a78:
			return 0x61fd2ec1;
		case 0x00000a7c:
			return 0x1f877910;
		case 0x00000a80:
			return 0x9451b2ae;
		case 0x00000a84:
			return 0x8e00a242;
		case 0x00000a88:
			return 0xfc51f670;
		case 0x00000a8c:
			return 0x6f007e7b;
		case 0x00000a90:
			return 0x517cc2c5;
		case 0x00000a94:
			return 0x3168a44e;
		case 0x00000a98:
			return 0x9874b086;
		case 0x00000a9c:
			return 0x62d9c898;
		case 0x00000aa0:
			return 0xecbe05e6;
		case 0x00000aa4:
			return 0x8f6ccf40;
		case 0x00000aa8:
			return 0x6f94f3c8;
		case 0x00000aac:
			return 0x7cb94377;
		case 0x00000ab0:
			return 0x8beb0c79;
		case 0x00000ab4:
			return 0xf6af1ae0;
		case 0x00000ab8:
			return 0x7d9fc16b;
		case 0x00000abc:
			return 0x173a434b;
		case 0x00000ac0:
			return 0x21d27bfc;
		case 0x00000ac4:
			return 0x82aaba63;
		case 0x00000ac8:
			return 0x4f876b0c;
		case 0x00000acc:
			return 0xffacad40;
		case 0x00000ad0:
			return 0x7b47605c;
		case 0x00000ad4:
			return 0xddb1fdf4;
		case 0x00000ad8:
			return 0xdb1ec911;
		case 0x00000adc:
			return 0xfd14cff8;
		case 0x00000ae0:
			return 0x499fbb7a;
		case 0x00000ae4:
			return 0x987d4c12;
		case 0x00000ae8:
			return 0xc956dabf;
		case 0x00000aec:
			return 0x6caa72c0;
		case 0x00000af0:
			return 0x4ee5b8a2;
		case 0x00000af4:
			return 0xd956cb80;
		case 0x00000af8:
			return 0xf6f39b0c;
		case 0x00000afc:
			return 0x117be7ba;
		case 0x00000b00:
			return 0xa84c0d7b;
		case 0x00000b04:
			return 0x7c12ca49;
		case 0x00000b08:
			return 0x28a3fac3;
		case 0x00000b0c:
			return 0x38307587;
		case 0x00000b10:
			return 0x3ad206eb;
		case 0x00000b14:
			return 0xac39c551;
		case 0x00000b18:
			return 0xb258c1a7;
		case 0x00000b1c:
			return 0xbf74c2e7;
		case 0x00000b20:
			return 0xa2d8715d;
		case 0x00000b24:
			return 0x562c5a9d;
		case 0x00000b28:
			return 0x86476590;
		case 0x00000b2c:
			return 0xd339c70a;
		case 0x00000b30:
			return 0x824a2dab;
		case 0x00000b34:
			return 0x0fe979da;
		case 0x00000b38:
			return 0x59dbba4e;
		case 0x00000b3c:
			return 0xed9aab7c;
		case 0x00000b40:
			return 0x241c03df;
		case 0x00000b44:
			return 0x1fee51ec;
		case 0x00000b48:
			return 0x41ad039f;
		case 0x00000b4c:
			return 0x0880bd23;
		case 0x00000b50:
			return 0x8412f634;
		case 0x00000b54:
			return 0xb9702aa2;
		case 0x00000b58:
			return 0x39d12d8e;
		case 0x00000b5c:
			return 0xf36d7243;
		case 0x00000b60:
			return 0x91a52660;
		case 0x00000b64:
			return 0xd73f011b;
		case 0x00000b68:
			return 0x0572d550;
		case 0x00000b6c:
			return 0xefaae71a;
		case 0x00000b70:
			return 0x7329f656;
		case 0x00000b74:
			return 0x73722317;
		case 0x00000b78:
			return 0xd85593de;
		case 0x00000b7c:
			return 0xaf5e62bb;
		case 0x00000b80:
			return 0x9f0276f0;
		case 0x00000b84:
			return 0x11fc7421;
		case 0x00000b88:
			return 0xcb548fa8;
		case 0x00000b8c:
			return 0x0c899e04;
		case 0x00000b90:
			return 0x29d0d889;
		case 0x00000b94:
			return 0xe84a251d;
		case 0x00000b98:
			return 0x5611a378;
		case 0x00000b9c:
			return 0xa3d5f1b2;
		case 0x00000ba0:
			return 0xc388f5c6;
		case 0x00000ba4:
			return 0x918c698c;
		case 0x00000ba8:
			return 0x966030a1;
		case 0x00000bac:
			return 0x38379a59;
		case 0x00000bb0:
			return 0x4806a2bc;
		case 0x00000bb4:
			return 0x65547d47;
		case 0x00000bb8:
			return 0x3877bb87;
		case 0x00000bbc:
			return 0xfe5e7f59;
		case 0x00000bc0:
			return 0x92a8e7c0;
		case 0x00000bc4:
			return 0x11e79e88;
		case 0x00000bc8:
			return 0x1f825c96;
		case 0x00000bcc:
			return 0x8b2a424f;
		case 0x00000bd0:
			return 0xb2f8fbd5;
		case 0x00000bd4:
			return 0xe17c44bd;
		case 0x00000bd8:
			return 0x5595e095;
		case 0x00000bdc:
			return 0x14a304ee;
		case 0x00000be0:
			return 0xe036e7ba;
		case 0x00000be4:
			return 0xa32029d8;
		case 0x00000be8:
			return 0x478ce6cc;
		case 0x00000bec:
			return 0xc432c134;
		case 0x00000bf0:
			return 0x60a3f0d5;
		case 0x00000bf4:
			return 0xac5de5aa;
		case 0x00000bf8:
			return 0x83fae795;
		case 0x00000bfc:
			return 0xb05a2099;
		case 0x00000c00:
			return 0xa81ba6ff;
		case 0x00000c04:
			return 0x22063610;
		case 0x00000c08:
			return 0xf3ef0fab;
		case 0x00000c0c:
			return 0x20cd926f;
		case 0x00000c10:
			return 0x209c99d2;
		case 0x00000c14:
			return 0x66dfb6cb;
		case 0x00000c18:
			return 0x46d8cb09;
		case 0x00000c1c:
			return 0x2dc5ffcd;
		case 0x00000c20:
			return 0x79efec84;
		case 0x00000c24:
			return 0xd7af20e7;
		case 0x00000c28:
			return 0x94f40730;
		case 0x00000c2c:
			return 0x7f439cb9;
		case 0x00000c30:
			return 0x32833865;
		case 0x00000c34:
			return 0x4de11844;
		case 0x00000c38:
			return 0x4c27fef8;
		case 0x00000c3c:
			return 0x06f90193;
		case 0x00000c40:
			return 0xee8f7385;
		case 0x00000c44:
			return 0xe0ea8eaf;
		case 0x00000c48:
			return 0xb14a9f54;
		case 0x00000c4c:
			return 0x072ed944;
		case 0x00000c50:
			return 0xe6e799dc;
		case 0x00000c54:
			return 0xf594a8f9;
		case 0x00000c58:
			return 0x551cac72;
		case 0x00000c5c:
			return 0xdd08d4b5;
		case 0x00000c60:
			return 0xca59abad;
		case 0x00000c64:
			return 0x392fe5d9;
		case 0x00000c68:
			return 0x392f1c96;
		case 0x00000c6c:
			return 0x30c79903;
		case 0x00000c70:
			return 0xc20702b1;
		case 0x00000c74:
			return 0xcb5d8cb6;
		case 0x00000c78:
			return 0xf3675ace;
		case 0x00000c7c:
			return 0x09201eaa;
		case 0x00000c80:
			return 0x4226c78e;
		case 0x00000c84:
			return 0x96fa46fc;
		case 0x00000c88:
			return 0xcdbeb484;
		case 0x00000c8c:
			return 0xa15c0047;
		case 0x00000c90:
			return 0xe962e8e3;
		case 0x00000c94:
			return 0x58362bae;
		case 0x00000c98:
			return 0x48ead195;
		case 0x00000c9c:
			return 0xd5b8e9e0;
		case 0x00000ca0:
			return 0xbf7264d6;
		case 0x00000ca4:
			return 0x7d20796c;
		case 0x00000ca8:
			return 0x475dc949;
		case 0x00000cac:
			return 0x08a6adb0;
		case 0x00000cb0:
			return 0xcfc3eab9;
		case 0x00000cb4:
			return 0xc351af07;
		case 0x00000cb8:
			return 0xa6a61779;
		case 0x00000cbc:
			return 0x9d6f1082;
		case 0x00000cc0:
			return 0x20a5b675;
		case 0x00000cc4:
			return 0x399ebdb9;
		case 0x00000cc8:
			return 0xcb17e636;
		case 0x00000ccc:
			return 0x3acac1e1;
		case 0x00000cd0:
			return 0xfadda9f0;
		case 0x00000cd4:
			return 0x8e2da58f;
		case 0x00000cd8:
			return 0x01a3980a;
		case 0x00000cdc:
			return 0xc07846a2;
		case 0x00000ce0:
			return 0x9e16c65c;
		case 0x00000ce4:
			return 0x58519cf7;
		case 0x00000ce8:
			return 0xd16f9d24;
		case 0x00000cec:
			return 0x9cdde3f9;
		case 0x00000cf0:
			return 0x9244ba83;
		case 0x00000cf4:
			return 0x5fece937;
		case 0x00000cf8:
			return 0x0caa0c6b;
		case 0x00000cfc:
			return 0xb07c246b;
		case 0x00000d00:
			return 0xc71e22ba;
		case 0x00000d04:
			return 0x693a4b63;
		case 0x00000d08:
			return 0x2938abf0;
		case 0x00000d0c:
			return 0xf8760800;
		case 0x00000d10:
			return 0xda0dc4df;
		case 0x00000d14:
			return 0x63b74c04;
		case 0x00000d18:
			return 0xf5e10383;
		case 0x00000d1c:
			return 0x76f09641;
		case 0x00000d20:
			return 0x755ebcf3;
		case 0x00000d24:
			return 0xb2a64b07;
		case 0x00000d28:
			return 0x67b10efc;
		case 0x00000d2c:
			return 0xb5cfa629;
		case 0x00000d30:
			return 0xc7ad0562;
		case 0x00000d34:
			return 0x1498e04a;
		case 0x00000d38:
			return 0x20fe356f;
		case 0x00000d3c:
			return 0xbbd834e6;
		case 0x00000d40:
			return 0xb2b81494;
		case 0x00000d44:
			return 0x8a94a261;
		case 0x00000d48:
			return 0x55740c50;
		case 0x00000d4c:
			return 0x2a85f7bc;
		case 0x00000d50:
			return 0x644ed94e;
		case 0x00000d54:
			return 0x99819ea0;
		case 0x00000d58:
			return 0x1850c90b;
		case 0x00000d5c:
			return 0x6fd63367;
		case 0x00000d60:
			return 0xb4788199;
		case 0x00000d64:
			return 0x05ff39a3;
		case 0x00000d68:
			return 0xdb951642;
		case 0x00000d6c:
			return 0x2a2d88a5;
		case 0x00000d70:
			return 0xec6cf8f9;
		case 0x00000d74:
			return 0xb1b00655;
		case 0x00000d78:
			return 0xd7e9a4b7;
		case 0x00000d7c:
			return 0xe8e37870;
		case 0x00000d80:
			return 0x70c61419;
		case 0x00000d84:
			return 0xc22cc49f;
		case 0x00000d88:
			return 0x1b5200f0;
		case 0x00000d8c:
			return 0x8c142e62;
		case 0x00000d90:
			return 0x2d786f8a;
		case 0x00000d94:
			return 0x18e34618;
		case 0x00000d98:
			return 0xa2a0f764;
		case 0x00000d9c:
			return 0x1f22e22d;
		case 0x00000da0:
			return 0x0331001b;
		case 0x00000da4:
			return 0x23a8b3d0;
		case 0x00000da8:
			return 0x3ae1160b;
		case 0x00000dac:
			return 0x28db0864;
		case 0x00000db0:
			return 0x28b34520;
		case 0x00000db4:
			return 0x75414a1d;
		case 0x00000db8:
			return 0x7d8b0227;
		case 0x00000dbc:
			return 0x8e4ed47f;
		case 0x00000dc0:
			return 0x91e6f77e;
		case 0x00000dc4:
			return 0x098284c3;
		case 0x00000dc8:
			return 0x12d9ff6e;
		case 0x00000dcc:
			return 0xe7ab340e;
		case 0x00000dd0:
			return 0xcad735ed;
		case 0x00000dd4:
			return 0x3d329e37;
		case 0x00000dd8:
			return 0xa8ad09fd;
		case 0x00000ddc:
			return 0xeed53263;
		case 0x00000de0:
			return 0xc4321702;
		case 0x00000de4:
			return 0xb1b7ceb0;
		case 0x00000de8:
			return 0x53ec8ee9;
		case 0x00000dec:
			return 0x6137a2f4;
		case 0x00000df0:
			return 0xed1d79f0;
		case 0x00000df4:
			return 0x1f9987fe;
		case 0x00000df8:
			return 0xcc5fd818;
		case 0x00000dfc:
			return 0xa1090ee3;
		case 0x00000e00:
			return 0xe9e03b01;
		case 0x00000e04:
			return 0x53249711;
		case 0x00000e08:
			return 0xf39c3015;
		case 0x00000e0c:
			return 0x43c75671;
		case 0x00000e10:
			return 0x30953d19;
		case 0x00000e14:
			return 0xda4ac0e6;
		case 0x00000e18:
			return 0x48500c18;
		case 0x00000e1c:
			return 0xc4db4eab;
		case 0x00000e20:
			return 0xdebd03d1;
		case 0x00000e24:
			return 0xc4648e22;
		case 0x00000e28:
			return 0x53c1ce50;
		case 0x00000e2c:
			return 0x7df4c735;
		case 0x00000e30:
			return 0xde508c05;
		case 0x00000e34:
			return 0xb96a3c57;
		case 0x00000e38:
			return 0xba379c0e;
		case 0x00000e3c:
			return 0x8d4a939c;
		case 0x00000e40:
			return 0x9aff4fd2;
		case 0x00000e44:
			return 0xf93507aa;
		case 0x00000e48:
			return 0xa083a1bf;
		case 0x00000e4c:
			return 0xe0aceea5;
		case 0x00000e50:
			return 0x460e2c53;
		case 0x00000e54:
			return 0x59f163ad;
		case 0x00000e58:
			return 0x91297c03;
		case 0x00000e5c:
			return 0x723018c9;
		case 0x00000e60:
			return 0x75698f0e;
		case 0x00000e64:
			return 0x37953be8;
		case 0x00000e68:
			return 0xb4f89bef;
		case 0x00000e6c:
			return 0xe715c5b8;
		case 0x00000e70:
			return 0xbc3e1e3a;
		case 0x00000e74:
			return 0x110df66c;
		case 0x00000e78:
			return 0x17745b1a;
		case 0x00000e7c:
			return 0x71b18d34;
		case 0x00000e80:
			return 0x80ac9e59;
		case 0x00000e84:
			return 0x0be1f13d;
		case 0x00000e88:
			return 0xfdb4e308;
		case 0x00000e8c:
			return 0xce7e61c4;
		case 0x00000e90:
			return 0xe15a8a33;
		case 0x00000e94:
			return 0x8f6c5f99;
		case 0x00000e98:
			return 0x3af80e14;
		case 0x00000e9c:
			return 0x386a710f;
		case 0x00000ea0:
			return 0xf8055028;
		case 0x00000ea4:
			return 0x3c6c7835;
		case 0x00000ea8:
			return 0x23f72002;
		case 0x00000eac:
			return 0xda7429ee;
		case 0x00000eb0:
			return 0x907f2a76;
		case 0x00000eb4:
			return 0x8faa7e57;
		case 0x00000eb8:
			return 0xbb3a6351;
		case 0x00000ebc:
			return 0x56fdf4c5;
		case 0x00000ec0:
			return 0x267fb381;
		case 0x00000ec4:
			return 0x051bd61d;
		case 0x00000ec8:
			return 0xbf2a3338;
		case 0x00000ecc:
			return 0x1d902685;
		case 0x00000ed0:
			return 0x0fd36508;
		case 0x00000ed4:
			return 0x39d84911;
		case 0x00000ed8:
			return 0x43a04f29;
		case 0x00000edc:
			return 0x07024b60;
		case 0x00000ee0:
			return 0x8cfacdc6;
		case 0x00000ee4:
			return 0xb5dfde5e;
		case 0x00000ee8:
			return 0x7f4820dd;
		case 0x00000eec:
			return 0x6d991ffd;
		case 0x00000ef0:
			return 0xda00df6e;
		case 0x00000ef4:
			return 0xa30ff315;
		case 0x00000ef8:
			return 0x06191def;
		case 0x00000efc:
			return 0x4b31633d;
		case 0x00000f00:
			return 0x16bca03c;
		case 0x00000f04:
			return 0x8d04eab6;
		case 0x00000f08:
			return 0xdefa5826;
		case 0x00000f0c:
			return 0xcad8339e;
		case 0x00000f10:
			return 0x2fc31646;
		case 0x00000f14:
			return 0x09b29576;
		case 0x00000f18:
			return 0x807e1978;
		case 0x00000f1c:
			return 0xcb19d004;
		case 0x00000f20:
			return 0x02316870;
		case 0x00000f24:
			return 0x94dcff7f;
		case 0x00000f28:
			return 0xb9a2f9d4;
		case 0x00000f2c:
			return 0xe04da4e9;
		case 0x00000f30:
			return 0xbc93679a;
		case 0x00000f34:
			return 0x0763e42b;
		case 0x00000f38:
			return 0x6ee30063;
		case 0x00000f3c:
			return 0x2580b4d9;
		case 0x00000f40:
			return 0x9e605651;
		case 0x00000f44:
			return 0xf83c0615;
		case 0x00000f48:
			return 0xace85145;
		case 0x00000f4c:
			return 0xc19060c3;
		case 0x00000f50:
			return 0xb07ddb42;
		case 0x00000f54:
			return 0xbe3dbdad;
		case 0x00000f58:
			return 0x04dd3298;
		case 0x00000f5c:
			return 0x9e3ab3b4;
		case 0x00000f60:
			return 0xf85b9341;
		case 0x00000f64:
			return 0x213634b5;
		case 0x00000f68:
			return 0xe4a777f5;
		case 0x00000f6c:
			return 0xeb04fbc0;
		case 0x00000f70:
			return 0x362967d6;
		case 0x00000f74:
			return 0xc07ed720;
		case 0x00000f78:
			return 0xed3f8a7f;
		case 0x00000f7c:
			return 0x2332fba4;
		case 0x00000f80:
			return 0x0d19133a;
		case 0x00000f84:
			return 0xaf002947;
		case 0x00000f88:
			return 0xd83d0a7e;
		case 0x00000f8c:
			return 0xf6da6380;
		case 0x00000f90:
			return 0xc5f6c1a8;
		case 0x00000f94:
			return 0xf3dee287;
		case 0x00000f98:
			return 0xab4068e6;
		case 0x00000f9c:
			return 0x1a54571a;
		case 0x00000fa0:
			return 0xa1dbc631;
		case 0x00000fa4:
			return 0x5a095229;
		case 0x00000fa8:
			return 0xcc46fbdf;
		case 0x00000fac:
			return 0x689e3889;
		case 0x00000fb0:
			return 0xb617c8d2;
		case 0x00000fb4:
			return 0xf07d32b6;
		case 0x00000fb8:
			return 0xfbcc3130;
		case 0x00000fbc:
			return 0x2ebaa19d;
		case 0x00000fc0:
			return 0x72047fc4;
		case 0x00000fc4:
			return 0x461ca48a;
		case 0x00000fc8:
			return 0x4e2fb625;
		case 0x00000fcc:
			return 0xb3fbdf2c;
		case 0x00000fd0:
			return 0x73203744;
		case 0x00000fd4:
			return 0xd44269e8;
		case 0x00000fd8:
			return 0xf28afabf;
		case 0x00000fdc:
			return 0xfee80e82;
		case 0x00000fe0:
			return 0x72648d21;
		case 0x00000fe4:
			return 0x36e1bcbd;
		case 0x00000fe8:
			return 0x66a1eb9a;
		case 0x00000fec:
			return 0x82eae5c2;
		case 0x00000ff0:
			return 0x55a3cf67;
		case 0x00000ff4:
			return 0xfa46bb44;
		case 0x00000ff8:
			return 0x662bb76b;
		case 0x00000ffc:
			return 0xa07a591b;
		case 0x00001000:
			return 0xb015f920;
		case 0x00001004:
			return 0xd97a7332;
		case 0x00001008:
			return 0x29bd8548;
		case 0x0000100c:
			return 0x017f4cb0;
		case 0x00001010:
			return 0x644fbbbe;
		case 0x00001014:
			return 0x75e0bda8;
		case 0x00001018:
			return 0x6c348fe2;
		case 0x0000101c:
			return 0x836bbf11;
		case 0x00001020:
			return 0x1a39e2c3;
		case 0x00001024:
			return 0x2a2abfac;
		case 0x00001028:
			return 0x1e0804b1;
		case 0x0000102c:
			return 0xb1cae680;
		case 0x00001030:
			return 0x4dcb19e0;
		case 0x00001034:
			return 0x5d362122;
		case 0x00001038:
			return 0x8a87a169;
		case 0x0000103c:
			return 0x0d839f8a;
		case 0x00001040:
			return 0xb964edd4;
		case 0x00001044:
			return 0xd43f5d07;
		case 0x00001048:
			return 0x3b1edde8;
		case 0x0000104c:
			return 0x8d4835fc;
		case 0x00001050:
			return 0xa819976d;
		case 0x00001054:
			return 0x30ee15fb;
		case 0x00001058:
			return 0x7b3cb8b4;
		case 0x0000105c:
			return 0x5789cff5;
		case 0x00001060:
			return 0x0b3cfbc8;
		case 0x00001064:
			return 0xf9971e8f;
		case 0x00001068:
			return 0x41457946;
		case 0x0000106c:
			return 0x41699624;
		case 0x00001070:
			return 0x6fcffea2;
		case 0x00001074:
			return 0xab67e7bd;
		case 0x00001078:
			return 0x9c83f3fa;
		case 0x0000107c:
			return 0xb4978121;
		case 0x00001080:
			return 0xacd52eef;
		case 0x00001084:
			return 0xb3555711;
		case 0x00001088:
			return 0xf8053e7b;
		case 0x0000108c:
			return 0xbcf9e13e;
		case 0x00001090:
			return 0x11c47259;
		case 0x00001094:
			return 0x4f399788;
		case 0x00001098:
			return 0x9c66402b;
		case 0x0000109c:
			return 0x49be15ef;
		case 0x000010a0:
			return 0x55a8cef8;
		case 0x000010a4:
			return 0xc10e4b70;
		case 0x000010a8:
			return 0x3a21b78a;
		case 0x000010ac:
			return 0xf2526417;
		case 0x000010b0:
			return 0x63a96ca6;
		case 0x000010b4:
			return 0xfbced870;
		case 0x000010b8:
			return 0xe628885f;
		case 0x000010bc:
			return 0x4d7282a3;
		case 0x000010c0:
			return 0x61453d0e;
		case 0x000010c4:
			return 0x42d01827;
		case 0x000010c8:
			return 0xe7e1ff2b;
		case 0x000010cc:
			return 0x27ab355b;
		case 0x000010d0:
			return 0x8d4060f1;
		case 0x000010d4:
			return 0x69f50143;
		case 0x000010d8:
			return 0xa2723b61;
		case 0x000010dc:
			return 0xfa7cc03e;
		case 0x000010e0:
			return 0xc6ab7e4a;
		case 0x000010e4:
			return 0xa48fb1cf;
		case 0x000010e8:
			return 0x0817591a;
		case 0x000010ec:
			return 0x1f6f38ed;
		case 0x000010f0:
			return 0x682568c1;
		case 0x000010f4:
			return 0x32f231c6;
		case 0x000010f8:
			return 0x5aaeeeee;
		case 0x000010fc:
			return 0x9df04529;
		case 0x00001100:
			return 0x39d7f00d;
		case 0x00001104:
			return 0x250161eb;
		case 0x00001108:
			return 0x515e9042;
		case 0x0000110c:
			return 0x7728a634;
		case 0x00001110:
			return 0xd71f8244;
		case 0x00001114:
			return 0x9f23a72c;
		case 0x00001118:
			return 0x1c694ee6;
		case 0x0000111c:
			return 0xe0dfb293;
		case 0x00001120:
			return 0xa98e84fd;
		case 0x00001124:
			return 0x3e16c299;
		case 0x00001128:
			return 0x51f25475;
		case 0x0000112c:
			return 0xbccf52af;
		case 0x00001130:
			return 0x4ca01b46;
		case 0x00001134:
			return 0x8753b2d8;
		case 0x00001138:
			return 0x893d97ff;
		case 0x0000113c:
			return 0x6e48d072;
		case 0x00001140:
			return 0xd729d317;
		case 0x00001144:
			return 0xdfc37d8b;
		case 0x00001148:
			return 0xd521ea6f;
		case 0x0000114c:
			return 0x105d4044;
		case 0x00001150:
			return 0x2e83c728;
		case 0x00001154:
			return 0xc6c7e1e3;
		case 0x00001158:
			return 0xac896560;
		case 0x0000115c:
			return 0xfd24df0d;
		case 0x00001160:
			return 0x8a0f6619;
		case 0x00001164:
			return 0x51471528;
		case 0x00001168:
			return 0x97234085;
		case 0x0000116c:
			return 0xe6d1b30c;
		case 0x00001170:
			return 0x260b1d4e;
		case 0x00001174:
			return 0x93b91289;
		case 0x00001178:
			return 0xd9f02a9c;
		case 0x0000117c:
			return 0x58e4d34d;
		case 0x00001180:
			return 0x86c830e6;
		case 0x00001184:
			return 0xbed9d4ce;
		case 0x00001188:
			return 0x8a0f2c27;
		case 0x0000118c:
			return 0xff7a9e4e;
		case 0x00001190:
			return 0x58a0a134;
		case 0x00001194:
			return 0x3978e1b6;
		case 0x00001198:
			return 0xa0778481;
		case 0x0000119c:
			return 0xd68f86c2;
		case 0x000011a0:
			return 0x63272b7d;
		case 0x000011a4:
			return 0x2063b1e5;
		case 0x000011a8:
			return 0x7ea34d08;
		case 0x000011ac:
			return 0x3547094c;
		case 0x000011b0:
			return 0x7fc4f8dc;
		case 0x000011b4:
			return 0x3a62429a;
		case 0x000011b8:
			return 0xe55a48a0;
		case 0x000011bc:
			return 0xaaf56db0;
		case 0x000011c0:
			return 0x8afc08ac;
		case 0x000011c4:
			return 0xf599a482;
		case 0x000011c8:
			return 0x655c9be7;
		case 0x000011cc:
			return 0x70a478a8;
		case 0x000011d0:
			return 0x88bab894;
		case 0x000011d4:
			return 0x17fc7d2f;
		case 0x000011d8:
			return 0xb6eb98a1;
		case 0x000011dc:
			return 0x0e01664a;
		case 0x000011e0:
			return 0xa6093dfc;
		case 0x000011e4:
			return 0x5b2f35c0;
		case 0x000011e8:
			return 0x550a698e;
		case 0x000011ec:
			return 0x36ada8d5;
		case 0x000011f0:
			return 0x6c947bff;
		case 0x000011f4:
			return 0xf09950e8;
		case 0x000011f8:
			return 0x3fdde534;
		case 0x000011fc:
			return 0xb638064f;
		case 0x00001200:
			return 0x110d0a0a;
		case 0x00001204:
			return 0xdfa7018e;
		case 0x00001208:
			return 0x840ae92c;
		case 0x0000120c:
			return 0xd54435d4;
		case 0x00001210:
			return 0x91922f5b;
		case 0x00001214:
			return 0x85dfee16;
		case 0x00001218:
			return 0x9abc2060;
		case 0x0000121c:
			return 0x2197c077;
		case 0x00001220:
			return 0xaefe542e;
		case 0x00001224:
			return 0x52d41e6f;
		case 0x00001228:
			return 0xee9768d1;
		case 0x0000122c:
			return 0x1a6449a4;
		case 0x00001230:
			return 0xfa480a82;
		case 0x00001234:
			return 0x51ec5192;
		case 0x00001238:
			return 0xbed9ba9f;
		case 0x0000123c:
			return 0x9d766619;
		case 0x00001240:
			return 0x43fb3b7f;
		case 0x00001244:
			return 0xab18cd69;
		case 0x00001248:
			return 0x939b7848;
		case 0x0000124c:
			return 0x10a1723d;
		case 0x00001250:
			return 0xf5164f14;
		case 0x00001254:
			return 0xf9611215;
		case 0x00001258:
			return 0x1941c339;
		case 0x0000125c:
			return 0xa36474dc;
		case 0x00001260:
			return 0x931203a3;
		case 0x00001264:
			return 0xfec0f1c0;
		case 0x00001268:
			return 0xf25c59d1;
		case 0x0000126c:
			return 0xc0042bdb;
		case 0x00001270:
			return 0x6c5a65d5;
		case 0x00001274:
			return 0xc4e6fff5;
		case 0x00001278:
			return 0x1da570ee;
		case 0x0000127c:
			return 0x79ce6c4a;
		case 0x00001280:
			return 0xf55da09a;
		case 0x00001284:
			return 0x2bda32a2;
		case 0x00001288:
			return 0xbd4e19cd;
		case 0x0000128c:
			return 0x850372bb;
		case 0x00001290:
			return 0x2fcf0cee;
		case 0x00001294:
			return 0x4e028e41;
		case 0x00001298:
			return 0xbc8f4ea3;
		case 0x0000129c:
			return 0x86d1644f;
		case 0x000012a0:
			return 0x6d3ec9d6;
		case 0x000012a4:
			return 0x31b7cd33;
		case 0x000012a8:
			return 0x86e8f1c3;
		case 0x000012ac:
			return 0x6b58382c;
		case 0x000012b0:
			return 0x39c99096;
		case 0x000012b4:
			return 0xae1055e7;
		case 0x000012b8:
			return 0x0fb00988;
		case 0x000012bc:
			return 0x71fea087;
		case 0x000012c0:
			return 0x29abb7e6;
		case 0x000012c4:
			return 0x3d944197;
		case 0x000012c8:
			return 0xaca4b7fe;
		case 0x000012cc:
			return 0x66a6b296;
		case 0x000012d0:
			return 0xceb67250;
		case 0x000012d4:
			return 0x7611b033;
		case 0x000012d8:
			return 0x67a12652;
		case 0x000012dc:
			return 0x6c79b857;
		case 0x000012e0:
			return 0xb2d809bc;
		case 0x000012e4:
			return 0xb681b843;
		case 0x000012e8:
			return 0x15cd1579;
		case 0x000012ec:
			return 0xc033a36b;
		case 0x000012f0:
			return 0xc1de513d;
		case 0x000012f4:
			return 0x7e44e669;
		case 0x000012f8:
			return 0x2f9cfced;
		case 0x000012fc:
			return 0x27cc1a96;
		case 0x00001300:
			return 0x5af0fe88;
		case 0x00001304:
			return 0x1beeb564;
		case 0x00001308:
			return 0xf1c9df10;
		case 0x0000130c:
			return 0x89bea7ab;
		case 0x00001310:
			return 0xfc7cbae6;
		case 0x00001314:
			return 0x78067e3c;
		case 0x00001318:
			return 0x336a12a9;
		case 0x0000131c:
			return 0x66216789;
		case 0x00001320:
			return 0xddd23574;
		case 0x00001324:
			return 0x1fdfbd52;
		case 0x00001328:
			return 0x30ad53bf;
		case 0x0000132c:
			return 0x20f522f0;
		case 0x00001330:
			return 0x5ed012e2;
		case 0x00001334:
			return 0xbc8ad53e;
		case 0x00001338:
			return 0xf00fef77;
		case 0x0000133c:
			return 0x48559928;
		case 0x00001340:
			return 0x123fc33b;
		case 0x00001344:
			return 0x1ecd51f5;
		case 0x00001348:
			return 0x075dce6d;
		case 0x0000134c:
			return 0x0d73893c;
		case 0x00001350:
			return 0x1a816352;
		case 0x00001354:
			return 0xc782b94e;
		case 0x00001358:
			return 0x8341836c;
		case 0x0000135c:
			return 0x81edc656;
		case 0x00001360:
			return 0xbba47922;
		case 0x00001364:
			return 0x1e615bcd;
		case 0x00001368:
			return 0xbfd31f57;
		case 0x0000136c:
			return 0x0e536cf3;
		case 0x00001370:
			return 0xacf519c6;
		case 0x00001374:
			return 0xf8fab260;
		case 0x00001378:
			return 0x89eacce7;
		case 0x0000137c:
			return 0xc37886de;
		case 0x00001380:
			return 0x8c075317;
		case 0x00001384:
			return 0x47f99b2f;
		case 0x00001388:
			return 0x4a5c8820;
		case 0x0000138c:
			return 0x8f856ce2;
		case 0x00001390:
			return 0x1cfff49a;
		case 0x00001394:
			return 0x25dc2e0b;
		case 0x00001398:
			return 0xf95118d3;
		case 0x0000139c:
			return 0x0b3a1856;
		case 0x000013a0:
			return 0xa8e81b88;
		case 0x000013a4:
			return 0x50afa864;
		case 0x000013a8:
			return 0x97f98719;
		case 0x000013ac:
			return 0x5119dd12;
		case 0x000013b0:
			return 0x58ff6714;
		case 0x000013b4:
			return 0xfe64fe06;
		case 0x000013b8:
			return 0x48f1adc0;
		case 0x000013bc:
			return 0x6bfe18ec;
		case 0x000013c0:
			return 0x84715883;
		case 0x000013c4:
			return 0x2501b7b7;
		case 0x000013c8:
			return 0x678e5267;
		case 0x000013cc:
			return 0x2d6b28e4;
		case 0x000013d0:
			return 0x46f18db8;
		case 0x000013d4:
			return 0x731f6fb9;
		case 0x000013d8:
			return 0xc1394362;
		case 0x000013dc:
			return 0x231c0505;
		case 0x000013e0:
			return 0xd6925815;
		case 0x000013e4:
			return 0x4bc5c53c;
		case 0x000013e8:
			return 0x4a5c8a54;
		case 0x000013ec:
			return 0x3ce5c657;
		case 0x000013f0:
			return 0x498545ed;
		case 0x000013f4:
			return 0x443a093f;
		case 0x000013f8:
			return 0x06cff8ec;
		case 0x000013fc:
			return 0x5ef11884;
		case 0x00001400:
			return 0xd3ba0d31;
		case 0x00001404:
			return 0x61d33155;
		case 0x00001408:
			return 0x4a3aa3e2;
		case 0x0000140c:
			return 0x745763ac;
		case 0x00001410:
			return 0xc610dde3;
		case 0x00001414:
			return 0x6bfe8a85;
		case 0x00001418:
			return 0x18372343;
		case 0x0000141c:
			return 0x6501ac59;
		case 0x00001420:
			return 0x8e8ddd18;
		case 0x00001424:
			return 0x36d4db43;
		case 0x00001428:
			return 0x029fbc7c;
		case 0x0000142c:
			return 0x5d9b198a;
		case 0x00001430:
			return 0xbdbcb9ef;
		case 0x00001434:
			return 0xab11974a;
		case 0x00001438:
			return 0xffb3bc4c;
		case 0x0000143c:
			return 0x9935a12a;
		case 0x00001440:
			return 0x27c22321;
		case 0x00001444:
			return 0x8a9e2f66;
		case 0x00001448:
			return 0x9f071265;
		case 0x0000144c:
			return 0x516de2f2;
		case 0x00001450:
			return 0xf25a3ed6;
		case 0x00001454:
			return 0x4158b80a;
		case 0x00001458:
			return 0x7447edf0;
		case 0x0000145c:
			return 0x4b75bada;
		case 0x00001460:
			return 0xbc5b8e14;
		case 0x00001464:
			return 0x58f0ee80;
		case 0x00001468:
			return 0x14b575ec;
		case 0x0000146c:
			return 0x0dc1249b;
		case 0x00001470:
			return 0x14565e88;
		case 0x00001474:
			return 0xf4e6fa2a;
		case 0x00001478:
			return 0xde198c81;
		case 0x0000147c:
			return 0x67b33a54;
		case 0x00001480:
			return 0x983b33c7;
		case 0x00001484:
			return 0x8f8f81d0;
		case 0x00001488:
			return 0xdc96a6bc;
		case 0x0000148c:
			return 0xa63cc245;
		case 0x00001490:
			return 0x85a28dd6;
		case 0x00001494:
			return 0xa49c06d6;
		case 0x00001498:
			return 0x8f197153;
		case 0x0000149c:
			return 0x3ce09282;
		case 0x000014a0:
			return 0x835c3181;
		case 0x000014a4:
			return 0x2cfb9609;
		case 0x000014a8:
			return 0x555c596e;
		case 0x000014ac:
			return 0x704790bd;
		case 0x000014b0:
			return 0x22568245;
		case 0x000014b4:
			return 0x71c5ef4a;
		case 0x000014b8:
			return 0xbe547470;
		case 0x000014bc:
			return 0xa7ba9864;
		case 0x000014c0:
			return 0x6d156f5c;
		case 0x000014c4:
			return 0x9ff56c9d;
		case 0x000014c8:
			return 0x0e822075;
		case 0x000014cc:
			return 0x46e9c643;
		case 0x000014d0:
			return 0x9f4a397c;
		case 0x000014d4:
			return 0x7b8fba5a;
		case 0x000014d8:
			return 0x4b0bedea;
		case 0x000014dc:
			return 0xff7ad48c;
		case 0x000014e0:
			return 0xf921aa1c;
		case 0x000014e4:
			return 0x1b5971fb;
		case 0x000014e8:
			return 0xed2ec71a;
		case 0x000014ec:
			return 0xf7cdcfd1;
		case 0x000014f0:
			return 0xe3376fdb;
		case 0x000014f4:
			return 0xe377c5c4;
		case 0x000014f8:
			return 0x303391a0;
		case 0x000014fc:
			return 0x564752ff;
		case 0x00001500:
			return 0xa2f02fa8;
		case 0x00001504:
			return 0x9ae04766;
		case 0x00001508:
			return 0xae2263ac;
		case 0x0000150c:
			return 0x0784e029;
		case 0x00001510:
			return 0xab267b5a;
		case 0x00001514:
			return 0x808b209d;
		case 0x00001518:
			return 0x0ac85f6a;
		case 0x0000151c:
			return 0xd4178a11;
		case 0x00001520:
			return 0x7dea4c55;
		case 0x00001524:
			return 0xfd5d04e2;
		case 0x00001528:
			return 0xc5a54dc4;
		case 0x0000152c:
			return 0x51caa2e9;
		case 0x00001530:
			return 0x35bfc030;
		case 0x00001534:
			return 0xd80c236b;
		case 0x00001538:
			return 0x293db6e4;
		case 0x0000153c:
			return 0x75045416;
		case 0x00001540:
			return 0x09c7d1f4;
		case 0x00001544:
			return 0xfcbe357f;
		case 0x00001548:
			return 0x7ab01948;
		case 0x0000154c:
			return 0xcb0e2b34;
		case 0x00001550:
			return 0xef33a450;
		case 0x00001554:
			return 0xbd66b2a4;
		case 0x00001558:
			return 0x9813a42e;
		case 0x0000155c:
			return 0xdb3c72b3;
		case 0x00001560:
			return 0x426470b7;
		case 0x00001564:
			return 0x50c33e22;
		case 0x00001568:
			return 0x565b6975;
		case 0x0000156c:
			return 0xc534c6c4;
		case 0x00001570:
			return 0x780763ca;
		case 0x00001574:
			return 0x96b75d6b;
		case 0x00001578:
			return 0x2980147f;
		case 0x0000157c:
			return 0x9ecf52d2;
		case 0x00001580:
			return 0x6abde2da;
		case 0x00001584:
			return 0x040b9167;
		case 0x00001588:
			return 0x7cd7b93d;
		case 0x0000158c:
			return 0xd292a4f6;
		case 0x00001590:
			return 0x8cdb7ddf;
		case 0x00001594:
			return 0x1e5681a3;
		case 0x00001598:
			return 0xe639c6b7;
		case 0x0000159c:
			return 0x45c1d66d;
		case 0x000015a0:
			return 0xbe03e81b;
		case 0x000015a4:
			return 0x658f3def;
		case 0x000015a8:
			return 0x3a219775;
		case 0x000015ac:
			return 0x083cd326;
		case 0x000015b0:
			return 0x36380124;
		case 0x000015b4:
			return 0xd6d1f101;
		case 0x000015b8:
			return 0x26e1fb28;
		case 0x000015bc:
			return 0x4115cab1;
		case 0x000015c0:
			return 0x1430a27f;
		case 0x000015c4:
			return 0x57131433;
		case 0x000015c8:
			return 0x5208e297;
		case 0x000015cc:
			return 0x037da1ec;
		case 0x000015d0:
			return 0x96f6a6de;
		case 0x000015d4:
			return 0x0036483a;
		case 0x000015d8:
			return 0x02d10f28;
		case 0x000015dc:
			return 0x91ae389d;
		case 0x000015e0:
			return 0xcba91eca;
		case 0x000015e4:
			return 0x3831e704;
		case 0x000015e8:
			return 0xf4e571de;
		case 0x000015ec:
			return 0x1907ce72;
		case 0x000015f0:
			return 0x684c17d5;
		case 0x000015f4:
			return 0xd5f00a87;
		case 0x000015f8:
			return 0x161ab121;
		case 0x000015fc:
			return 0xeb7a4870;
		case 0x00001600:
			return 0xa20e7235;
		case 0x00001604:
			return 0x276519cb;
		case 0x00001608:
			return 0xb1bbd677;
		case 0x0000160c:
			return 0xc0d18b47;
		case 0x00001610:
			return 0x28583cda;
		case 0x00001614:
			return 0x2953327c;
		case 0x00001618:
			return 0x2074a162;
		case 0x0000161c:
			return 0x89ddb091;
		case 0x00001620:
			return 0xb7eac36f;
		case 0x00001624:
			return 0x38c11edf;
		case 0x00001628:
			return 0x62baf233;
		case 0x0000162c:
			return 0xb8f1407e;
		case 0x00001630:
			return 0x951a16d9;
		case 0x00001634:
			return 0x5552c0b2;
		case 0x00001638:
			return 0x98499826;
		case 0x0000163c:
			return 0x5603af9c;
		case 0x00001640:
			return 0x22db80ac;
		case 0x00001644:
			return 0xe25371eb;
		case 0x00001648:
			return 0x3290a832;
		case 0x0000164c:
			return 0x7bd18ab6;
		case 0x00001650:
			return 0xaa18e447;
		case 0x00001654:
			return 0x7f32bfc7;
		case 0x00001658:
			return 0x79b7b127;
		case 0x0000165c:
			return 0x4959e446;
		case 0x00001660:
			return 0xcdaf0f94;
		case 0x00001664:
			return 0xb204b4b1;
		case 0x00001668:
			return 0x502a7368;
		case 0x0000166c:
			return 0x4e330376;
		case 0x00001670:
			return 0x393007b4;
		case 0x00001674:
			return 0x01f8049a;
		case 0x00001678:
			return 0x3d5fe010;
		case 0x0000167c:
			return 0x8e69ac3f;
		case 0x00001680:
			return 0xe914859c;
		case 0x00001684:
			return 0x8af0df0a;
		case 0x00001688:
			return 0x72998a6d;
		case 0x0000168c:
			return 0x9621e3e4;
		case 0x00001690:
			return 0x54806591;
		case 0x00001694:
			return 0x4282694f;
		case 0x00001698:
			return 0x493204d7;
		case 0x0000169c:
			return 0x269c6ca6;
		case 0x000016a0:
			return 0x5e706ad1;
		case 0x000016a4:
			return 0x94d8f91f;
		case 0x000016a8:
			return 0xca09c083;
		case 0x000016ac:
			return 0xdbc8e0b3;
		case 0x000016b0:
			return 0xc682d182;
		case 0x000016b4:
			return 0x1eb75529;
		case 0x000016b8:
			return 0xe10058be;
		case 0x000016bc:
			return 0x4aee5078;
		case 0x000016c0:
			return 0x697bdd50;
		case 0x000016c4:
			return 0xd074009f;
		case 0x000016c8:
			return 0xf9327347;
		case 0x000016cc:
			return 0x2644c429;
		case 0x000016d0:
			return 0x82b3d55c;
		case 0x000016d4:
			return 0xad70d3c5;
		case 0x000016d8:
			return 0x0f8cf0f2;
		case 0x000016dc:
			return 0x5bb8cc59;
		case 0x000016e0:
			return 0xe837732d;
		case 0x000016e4:
			return 0x1d2f397c;
		case 0x000016e8:
			return 0xf7ac8f12;
		case 0x000016ec:
			return 0x6e8bae79;
		case 0x000016f0:
			return 0xc6fd8401;
		case 0x000016f4:
			return 0x3eb27862;
		case 0x000016f8:
			return 0x7592724d;
		case 0x000016fc:
			return 0x29fa5695;
		case 0x00001700:
			return 0xc67890ce;
		case 0x00001704:
			return 0xfb7f466d;
		case 0x00001708:
			return 0xe12eeff5;
		case 0x0000170c:
			return 0x5fd658e0;
		case 0x00001710:
			return 0x7c25e536;
		case 0x00001714:
			return 0x0f01263d;
		case 0x00001718:
			return 0x7cceaa11;
		case 0x0000171c:
			return 0x8c11aadb;
		case 0x00001720:
			return 0x69d32037;
		case 0x00001724:
			return 0xa77fb9c2;
		case 0x00001728:
			return 0xeda1317a;
		case 0x0000172c:
			return 0xf589d3b8;
		case 0x00001730:
			return 0x0868c4dd;
		case 0x00001734:
			return 0x96b1a2a3;
		case 0x00001738:
			return 0x05c56149;
		case 0x0000173c:
			return 0x3e347d5e;
		case 0x00001740:
			return 0x7b23a4fd;
		case 0x00001744:
			return 0xe00a58e7;
		case 0x00001748:
			return 0xcec94f47;
		case 0x0000174c:
			return 0x243fb0a8;
		case 0x00001750:
			return 0x060894f9;
		case 0x00001754:
			return 0x2cc575bd;
		case 0x00001758:
			return 0x885438b5;
		case 0x0000175c:
			return 0xfa852b0e;
		case 0x00001760:
			return 0x0cc0fb9a;
		case 0x00001764:
			return 0xac38b0ba;
		case 0x00001768:
			return 0xdaef85de;
		case 0x0000176c:
			return 0x7299bdbc;
		case 0x00001770:
			return 0x17728955;
		case 0x00001774:
			return 0x5e1b7319;
		case 0x00001778:
			return 0x11243e4c;
		case 0x0000177c:
			return 0xba56c31b;
		case 0x00001780:
			return 0xc648e894;
		case 0x00001784:
			return 0x81b05107;
		case 0x00001788:
			return 0xded3713b;
		case 0x0000178c:
			return 0xdbe9a524;
		case 0x00001790:
			return 0x2fe984d5;
		case 0x00001794:
			return 0x6e7b8c21;
		case 0x00001798:
			return 0xb26cf3c8;
		case 0x0000179c:
			return 0x56835e55;
		case 0x000017a0:
			return 0x243de6d3;
		case 0x000017a4:
			return 0xb6aaff49;
		case 0x000017a8:
			return 0x10974490;
		case 0x000017ac:
			return 0xbfc8e996;
		case 0x000017b0:
			return 0x19f4c2e9;
		case 0x000017b4:
			return 0x67e24888;
		case 0x000017b8:
			return 0xbbd7bc79;
		case 0x000017bc:
			return 0xabe3837c;
		case 0x000017c0:
			return 0xc5bcb850;
		case 0x000017c4:
			return 0xd512fd63;
		case 0x000017c8:
			return 0xe8b436f5;
		case 0x000017cc:
			return 0xafd57683;
		case 0x000017d0:
			return 0x066cecd8;
		case 0x000017d4:
			return 0xd5336f9c;
		case 0x000017d8:
			return 0xc2e348eb;
		case 0x000017dc:
			return 0x42a3d849;
		case 0x000017e0:
			return 0xfd6dd8c1;
		case 0x000017e4:
			return 0x958eb283;
		case 0x000017e8:
			return 0xcfce5365;
		case 0x000017ec:
			return 0x04254f12;
		case 0x000017f0:
			return 0xae167b37;
		case 0x000017f4:
			return 0x43109cce;
		case 0x000017f8:
			return 0x53eed7bc;
		case 0x000017fc:
			return 0xc57310a8;
		case 0x00001800:
			return 0x80bf6398;
		case 0x00001804:
			return 0xed5e1c81;
		case 0x00001808:
			return 0x876e51be;
		case 0x0000180c:
			return 0x91f9a167;
		case 0x00001810:
			return 0x08d2d23b;
		case 0x00001814:
			return 0x1a11f484;
		case 0x00001818:
			return 0x50a2a11d;
		case 0x0000181c:
			return 0x7ae56f10;
		case 0x00001820:
			return 0x6704de68;
		case 0x00001824:
			return 0xaf6966cc;
		case 0x00001828:
			return 0xcab0bdb7;
		case 0x0000182c:
			return 0x86a14580;
		case 0x00001830:
			return 0xa2e7abbb;
		case 0x00001834:
			return 0xd9e07794;
		case 0x00001838:
			return 0x1a1e6d23;
		case 0x0000183c:
			return 0x55b9045c;
		case 0x00001840:
			return 0x14a3675b;
		case 0x00001844:
			return 0x134b402a;
		case 0x00001848:
			return 0xe481399f;
		case 0x0000184c:
			return 0xfd8a4fa3;
		case 0x00001850:
			return 0x8b61d6c9;
		case 0x00001854:
			return 0xc34d647c;
		case 0x00001858:
			return 0x2d91261c;
		case 0x0000185c:
			return 0x80db38c3;
		case 0x00001860:
			return 0x2080179c;
		case 0x00001864:
			return 0x80ff0007;
		case 0x00001868:
			return 0xd065159c;
		case 0x0000186c:
			return 0xccd4b8d9;
		case 0x00001870:
			return 0x502a2551;
		case 0x00001874:
			return 0xfadf2fae;
		case 0x00001878:
			return 0x43b98030;
		case 0x0000187c:
			return 0x931422dc;
		case 0x00001880:
			return 0x474d08c7;
		case 0x00001884:
			return 0x85f13e30;
		case 0x00001888:
			return 0x8ab42665;
		case 0x0000188c:
			return 0xf30126ba;
		case 0x00001890:
			return 0xc82b884a;
		case 0x00001894:
			return 0x9895b94a;
		case 0x00001898:
			return 0xc7625e29;
		case 0x0000189c:
			return 0x74ec88e7;
		case 0x000018a0:
			return 0x51cd8916;
		case 0x000018a4:
			return 0x1bb1d196;
		case 0x000018a8:
			return 0x4d6c7df3;
		case 0x000018ac:
			return 0xb421312a;
		case 0x000018b0:
			return 0xf81f217a;
		case 0x000018b4:
			return 0x30fd2f38;
		case 0x000018b8:
			return 0x047ca46c;
		case 0x000018bc:
			return 0x20803834;
		case 0x000018c0:
			return 0x36e6238f;
		case 0x000018c4:
			return 0x7e821667;
		case 0x000018c8:
			return 0xf996c104;
		case 0x000018cc:
			return 0x8b9e71ee;
		case 0x000018d0:
			return 0x410e22e2;
		case 0x000018d4:
			return 0x08df3783;
		case 0x000018d8:
			return 0x257b3c9d;
		case 0x000018dc:
			return 0x2282fa3d;
		case 0x000018e0:
			return 0x5d7c312d;
		case 0x000018e4:
			return 0x599147d2;
		case 0x000018e8:
			return 0x169957d4;
		case 0x000018ec:
			return 0x38f985a1;
		case 0x000018f0:
			return 0x3a353b71;
		case 0x000018f4:
			return 0x6d1a235c;
		case 0x000018f8:
			return 0x6c49c073;
		case 0x000018fc:
			return 0x402e3e27;
		case 0x00001900:
			return 0x644e4620;
		case 0x00001904:
			return 0xcd4e22fe;
		case 0x00001908:
			return 0x15a3c14c;
		case 0x0000190c:
			return 0x8945e982;
		case 0x00001910:
			return 0xa341e336;
		case 0x00001914:
			return 0x025ac99a;
		case 0x00001918:
			return 0xfeb7225c;
		case 0x0000191c:
			return 0xcfeb3e51;
		case 0x00001920:
			return 0x36e35d92;
		case 0x00001924:
			return 0x14dd78d6;
		case 0x00001928:
			return 0x263eb519;
		case 0x0000192c:
			return 0xc52d8362;
		case 0x00001930:
			return 0x10aa855e;
		case 0x00001934:
			return 0xd48a9671;
		case 0x00001938:
			return 0x048343b5;
		case 0x0000193c:
			return 0x483fce35;
		case 0x00001940:
			return 0x3fa4d1fa;
		case 0x00001944:
			return 0x22ac7116;
		case 0x00001948:
			return 0xa629a30a;
		case 0x0000194c:
			return 0xb219715f;
		case 0x00001950:
			return 0xd42dbbf5;
		case 0x00001954:
			return 0x9f574c88;
		case 0x00001958:
			return 0x3ba4ff74;
		case 0x0000195c:
			return 0xb30084de;
		case 0x00001960:
			return 0x619842f8;
		case 0x00001964:
			return 0x9266448a;
		case 0x00001968:
			return 0xafa43816;
		case 0x0000196c:
			return 0x5afdbe33;
		case 0x00001970:
			return 0x95c82e7a;
		case 0x00001974:
			return 0xfa38adf6;
		case 0x00001978:
			return 0x05155484;
		case 0x0000197c:
			return 0x8b5faddb;
		case 0x00001980:
			return 0xdd06ad1d;
		case 0x00001984:
			return 0x28d38959;
		case 0x00001988:
			return 0x178f6ac3;
		case 0x0000198c:
			return 0x1b872525;
		case 0x00001990:
			return 0xaf368ac7;
		case 0x00001994:
			return 0xcac5b377;
		case 0x00001998:
			return 0xc231e12b;
		case 0x0000199c:
			return 0xadfd9c91;
		case 0x000019a0:
			return 0x89923199;
		case 0x000019a4:
			return 0xefb9755d;
		case 0x000019a8:
			return 0xd8b7e713;
		case 0x000019ac:
			return 0x7efc6c9d;
		case 0x000019b0:
			return 0x4c98762f;
		case 0x000019b4:
			return 0x700ac2eb;
		case 0x000019b8:
			return 0x47d9546f;
		case 0x000019bc:
			return 0x0588d490;
		case 0x000019c0:
			return 0xcc76525c;
		case 0x000019c4:
			return 0x5e63cedb;
		case 0x000019c8:
			return 0x9bcfc6dc;
		case 0x000019cc:
			return 0x5f3e8043;
		case 0x000019d0:
			return 0x512ec5f0;
		case 0x000019d4:
			return 0x87448eb4;
		case 0x000019d8:
			return 0x99be9867;
		case 0x000019dc:
			return 0x63e81976;
		case 0x000019e0:
			return 0x72716a1f;
		case 0x000019e4:
			return 0x127524e8;
		case 0x000019e8:
			return 0x435deaac;
		case 0x000019ec:
			return 0xd3cb23d4;
		case 0x000019f0:
			return 0x7a46b0d3;
		case 0x000019f4:
			return 0xdd52697f;
		case 0x000019f8:
			return 0x0a855888;
		case 0x000019fc:
			return 0x555ee98c;
		case 0x00001a00:
			return 0x30c7901b;
		case 0x00001a04:
			return 0x74f812a3;
		case 0x00001a08:
			return 0xcfc83f3d;
		case 0x00001a0c:
			return 0x6e587332;
		case 0x00001a10:
			return 0x19586d76;
		case 0x00001a14:
			return 0xa3c2b89d;
		case 0x00001a18:
			return 0xe393abaf;
		case 0x00001a1c:
			return 0xc7653347;
		case 0x00001a20:
			return 0xecbe370c;
		case 0x00001a24:
			return 0x810d72b2;
		case 0x00001a28:
			return 0x675ca055;
		case 0x00001a2c:
			return 0xff12dc6f;
		case 0x00001a30:
			return 0x5fea84f7;
		case 0x00001a34:
			return 0xf02d5a7f;
		case 0x00001a38:
			return 0x4e034bf7;
		case 0x00001a3c:
			return 0xb4f9b61f;
		case 0x00001a40:
			return 0xe619d58d;
		case 0x00001a44:
			return 0x94a4ec52;
		case 0x00001a48:
			return 0x6f620140;
		case 0x00001a4c:
			return 0xaa88b2e1;
		case 0x00001a50:
			return 0x43572327;
		case 0x00001a54:
			return 0x928fff75;
		case 0x00001a58:
			return 0xa19b69a3;
		case 0x00001a5c:
			return 0xbe657178;
		case 0x00001a60:
			return 0xa5724c88;
		case 0x00001a64:
			return 0x475b4b89;
		case 0x00001a68:
			return 0x6060a239;
		case 0x00001a6c:
			return 0x9acc79a6;
		case 0x00001a70:
			return 0x769e0d5d;
		case 0x00001a74:
			return 0x1f2380dd;
		case 0x00001a78:
			return 0x79973118;
		case 0x00001a7c:
			return 0x59d68c0f;
		case 0x00001a80:
			return 0x74f7b2be;
		case 0x00001a84:
			return 0x97886272;
		case 0x00001a88:
			return 0xbcd3de4c;
		case 0x00001a8c:
			return 0x2fd692fc;
		case 0x00001a90:
			return 0x4a596fe6;
		case 0x00001a94:
			return 0xec18ed6c;
		case 0x00001a98:
			return 0xa349c4fa;
		case 0x00001a9c:
			return 0x8a13dbae;
		case 0x00001aa0:
			return 0x881df5a4;
		case 0x00001aa4:
			return 0x3611197f;
		case 0x00001aa8:
			return 0x0b9a6d28;
		case 0x00001aac:
			return 0xc7329fb8;
		case 0x00001ab0:
			return 0xd9cc747c;
		case 0x00001ab4:
			return 0xd47886aa;
		case 0x00001ab8:
			return 0xda08425f;
		case 0x00001abc:
			return 0x7af522e4;
		case 0x00001ac0:
			return 0x08b52f88;
		case 0x00001ac4:
			return 0x92fa56c2;
		case 0x00001ac8:
			return 0x40217dd5;
		case 0x00001acc:
			return 0xc1fb14a7;
		case 0x00001ad0:
			return 0x0dd163e8;
		case 0x00001ad4:
			return 0xd6bcc22f;
		case 0x00001ad8:
			return 0xafe7ec81;
		case 0x00001adc:
			return 0xaa132b30;
		case 0x00001ae0:
			return 0xeed0a122;
		case 0x00001ae4:
			return 0x19a2b3d0;
		case 0x00001ae8:
			return 0x4c4ab31e;
		case 0x00001aec:
			return 0xd9e337e4;
		case 0x00001af0:
			return 0x3d4319fe;
		case 0x00001af4:
			return 0x3a275158;
		case 0x00001af8:
			return 0xa09a0b6f;
		case 0x00001afc:
			return 0x3a3291da;
		case 0x00001b00:
			return 0x5c1c375f;
		case 0x00001b04:
			return 0x6e90064d;
		case 0x00001b08:
			return 0x9e78549e;
		case 0x00001b0c:
			return 0x6ba49320;
		case 0x00001b10:
			return 0x623f7d97;
		case 0x00001b14:
			return 0x0b7c61ea;
		case 0x00001b18:
			return 0xd9741204;
		case 0x00001b1c:
			return 0x2dd99f8e;
		case 0x00001b20:
			return 0x4237449b;
		case 0x00001b24:
			return 0xb8f6eaa0;
		case 0x00001b28:
			return 0x71d850ff;
		case 0x00001b2c:
			return 0xb0d572c5;
		case 0x00001b30:
			return 0x40b2bf2a;
		case 0x00001b34:
			return 0x8fa97338;
		case 0x00001b38:
			return 0xd34cc073;
		case 0x00001b3c:
			return 0x21408d69;
		case 0x00001b40:
			return 0x280535f4;
		case 0x00001b44:
			return 0x5af54b7e;
		case 0x00001b48:
			return 0xf408410c;
		case 0x00001b4c:
			return 0xd73ee1d9;
		case 0x00001b50:
			return 0xbd803a3b;
		case 0x00001b54:
			return 0x7a6ba32d;
		case 0x00001b58:
			return 0xaad2d060;
		case 0x00001b5c:
			return 0xcd1031c6;
		case 0x00001b60:
			return 0x77049cd5;
		case 0x00001b64:
			return 0x4b4f3478;
		case 0x00001b68:
			return 0x0807103c;
		case 0x00001b6c:
			return 0x0f1f1d18;
		case 0x00001b70:
			return 0xab9cd293;
		case 0x00001b74:
			return 0x40a0036b;
		case 0x00001b78:
			return 0x026a35ed;
		case 0x00001b7c:
			return 0x337c1fbf;
		case 0x00001b80:
			return 0x5733b8fa;
		case 0x00001b84:
			return 0x4d7cf7d0;
		case 0x00001b88:
			return 0x59c17a24;
		case 0x00001b8c:
			return 0xc211c1e5;
		case 0x00001b90:
			return 0x72e9704e;
		case 0x00001b94:
			return 0xe8e22625;
		case 0x00001b98:
			return 0x8bdd25d4;
		case 0x00001b9c:
			return 0xcd96e869;
		case 0x00001ba0:
			return 0xce6b034c;
		case 0x00001ba4:
			return 0x8eb14266;
		case 0x00001ba8:
			return 0x79949131;
		case 0x00001bac:
			return 0x7e758faf;
		case 0x00001bb0:
			return 0x9850c9b6;
		case 0x00001bb4:
			return 0x263178fc;
		case 0x00001bb8:
			return 0xf09d6202;
		case 0x00001bbc:
			return 0x1f671be7;
		case 0x00001bc0:
			return 0x14ee1da4;
		case 0x00001bc4:
			return 0x0ce9b787;
		case 0x00001bc8:
			return 0xdb8f1dea;
		case 0x00001bcc:
			return 0xc2decd35;
		case 0x00001bd0:
			return 0x84fd0f03;
		case 0x00001bd4:
			return 0xc581f68f;
		case 0x00001bd8:
			return 0x84234678;
		case 0x00001bdc:
			return 0x29e411a2;
		case 0x00001be0:
			return 0xbfc0f5b9;
		case 0x00001be4:
			return 0xab965d82;
		case 0x00001be8:
			return 0x30f4b580;
		case 0x00001bec:
			return 0xb11c55a7;
		case 0x00001bf0:
			return 0xacfe24ba;
		case 0x00001bf4:
			return 0x81940922;
		case 0x00001bf8:
			return 0xd0e0dfa3;
		case 0x00001bfc:
			return 0x43116b21;
		case 0x00001c00:
			return 0x3eb17fd1;
		case 0x00001c04:
			return 0xa01ff740;
		case 0x00001c08:
			return 0x662e980c;
		case 0x00001c0c:
			return 0xfc7c410b;
		case 0x00001c10:
			return 0xcf666e46;
		case 0x00001c14:
			return 0xab30a6dc;
		case 0x00001c18:
			return 0x3c08c97c;
		case 0x00001c1c:
			return 0x7e052a29;
		case 0x00001c20:
			return 0x0dff586a;
		case 0x00001c24:
			return 0xdc1db7ca;
		case 0x00001c28:
			return 0xce465282;
		case 0x00001c2c:
			return 0x6347363b;
		case 0x00001c30:
			return 0x1a607687;
		case 0x00001c34:
			return 0xf9cf1f82;
		case 0x00001c38:
			return 0x4d3143d0;
		case 0x00001c3c:
			return 0x3a54222d;
		case 0x00001c40:
			return 0x10fc37a7;
		case 0x00001c44:
			return 0x5cd94709;
		case 0x00001c48:
			return 0xa05faed0;
		case 0x00001c4c:
			return 0xcc706944;
		case 0x00001c50:
			return 0x165e09ee;
		case 0x00001c54:
			return 0xca8b718e;
		case 0x00001c58:
			return 0x294189c7;
		case 0x00001c5c:
			return 0x07af19c5;
		case 0x00001c60:
			return 0x3d8b24ca;
		case 0x00001c64:
			return 0x7efbd5a6;
		case 0x00001c68:
			return 0xf65055c3;
		case 0x00001c6c:
			return 0x023a5958;
		case 0x00001c70:
			return 0x3694ef08;
		case 0x00001c74:
			return 0xc6dbd59f;
		case 0x00001c78:
			return 0xe3ae0e74;
		case 0x00001c7c:
			return 0x7084546c;
		case 0x00001c80:
			return 0x6a8653a4;
		case 0x00001c84:
			return 0xbdf46bae;
		case 0x00001c88:
			return 0x725693f0;
		case 0x00001c8c:
			return 0xbd1e183f;
		case 0x00001c90:
			return 0x99c48bcb;
		case 0x00001c94:
			return 0x8f455804;
		case 0x00001c98:
			return 0x837b322e;
		case 0x00001c9c:
			return 0x89e3a30d;
		case 0x00001ca0:
			return 0x7284165c;
		case 0x00001ca4:
			return 0x3cc8411f;
		case 0x00001ca8:
			return 0x660f0b68;
		case 0x00001cac:
			return 0x8458f286;
		case 0x00001cb0:
			return 0x2bda468b;
		case 0x00001cb4:
			return 0xe63e89a3;
		case 0x00001cb8:
			return 0x3c7f9d08;
		case 0x00001cbc:
			return 0x745509de;
		case 0x00001cc0:
			return 0xf765d5c4;
		case 0x00001cc4:
			return 0x27157d09;
		case 0x00001cc8:
			return 0x6224268b;
		case 0x00001ccc:
			return 0x553da3fd;
		case 0x00001cd0:
			return 0xaed37e0a;
		case 0x00001cd4:
			return 0xf99246fc;
		case 0x00001cd8:
			return 0xd4b007a4;
		case 0x00001cdc:
			return 0xdf0784ef;
		case 0x00001ce0:
			return 0x9d838d72;
		case 0x00001ce4:
			return 0x4bc4c3c4;
		case 0x00001ce8:
			return 0x0b4d4f97;
		case 0x00001cec:
			return 0x57b5133a;
		case 0x00001cf0:
			return 0x4834f286;
		case 0x00001cf4:
			return 0x017c80c9;
		case 0x00001cf8:
			return 0xe2dd4777;
		case 0x00001cfc:
			return 0x2072d520;
		case 0x00001d00:
			return 0x780245af;
		case 0x00001d04:
			return 0x01dba66a;
		case 0x00001d08:
			return 0x3789c412;
		case 0x00001d0c:
			return 0x6df5a31e;
		case 0x00001d10:
			return 0xb6a3660c;
		case 0x00001d14:
			return 0x630ba3db;
		case 0x00001d18:
			return 0xdf0b3150;
		case 0x00001d1c:
			return 0x6f115f90;
		case 0x00001d20:
			return 0x7106491c;
		case 0x00001d24:
			return 0x73f4aebd;
		case 0x00001d28:
			return 0x32a44299;
		case 0x00001d2c:
			return 0xe7499f35;
		case 0x00001d30:
			return 0xa97738d4;
		case 0x00001d34:
			return 0xd97acf3d;
		case 0x00001d38:
			return 0xb85c4132;
		case 0x00001d3c:
			return 0x35b68810;
		case 0x00001d40:
			return 0x1d311e91;
		case 0x00001d44:
			return 0x79d6eac2;
		case 0x00001d48:
			return 0xd3c7635d;
		case 0x00001d4c:
			return 0x2b51b1ff;
		case 0x00001d50:
			return 0x655003e9;
		case 0x00001d54:
			return 0x4b994d08;
		case 0x00001d58:
			return 0x02c81b99;
		case 0x00001d5c:
			return 0xf74c7fbf;
		case 0x00001d60:
			return 0xa58bf33e;
		case 0x00001d64:
			return 0xeb3ec477;
		case 0x00001d68:
			return 0x3e96a833;
		case 0x00001d6c:
			return 0x3820c83c;
		case 0x00001d70:
			return 0x28f325c1;
		case 0x00001d74:
			return 0xb3daf59f;
		case 0x00001d78:
			return 0x5c943985;
		case 0x00001d7c:
			return 0x35fb1973;
		case 0x00001d80:
			return 0xd1b59414;
		case 0x00001d84:
			return 0x9278554e;
		case 0x00001d88:
			return 0xdcd53d30;
		case 0x00001d8c:
			return 0x5332bdc8;
		case 0x00001d90:
			return 0xd4492845;
		case 0x00001d94:
			return 0x952ba332;
		case 0x00001d98:
			return 0x24773415;
		case 0x00001d9c:
			return 0x273deb70;
		case 0x00001da0:
			return 0x0af70055;
		case 0x00001da4:
			return 0x79947afe;
		case 0x00001da8:
			return 0x6aa0a348;
		case 0x00001dac:
			return 0x9682c579;
		case 0x00001db0:
			return 0x595c651d;
		case 0x00001db4:
			return 0xdb90e474;
		case 0x00001db8:
			return 0x25545cca;
		case 0x00001dbc:
			return 0x4869b217;
		case 0x00001dc0:
			return 0x2ab5cb97;
		case 0x00001dc4:
			return 0xee5a559b;
		case 0x00001dc8:
			return 0xaef60c53;
		case 0x00001dcc:
			return 0x645661de;
		case 0x00001dd0:
			return 0x800cfca7;
		case 0x00001dd4:
			return 0x5210acaf;
		case 0x00001dd8:
			return 0x409e9f66;
		case 0x00001ddc:
			return 0xe1de1997;
		case 0x00001de0:
			return 0x3594a8c2;
		case 0x00001de4:
			return 0x12f5cf40;
		case 0x00001de8:
			return 0x85c6f5a7;
		case 0x00001dec:
			return 0xecbebd50;
		case 0x00001df0:
			return 0x779d7ad3;
		case 0x00001df4:
			return 0x22f7030b;
		case 0x00001df8:
			return 0x1a9c8ed5;
		case 0x00001dfc:
			return 0x389f26bb;
		case 0x00001e00:
			return 0x1e7a0306;
		case 0x00001e04:
			return 0xf82292e1;
		case 0x00001e08:
			return 0x7e2bde1f;
		case 0x00001e0c:
			return 0x0aefb031;
		case 0x00001e10:
			return 0x32719b8a;
		case 0x00001e14:
			return 0x42470a66;
		case 0x00001e18:
			return 0x3160e049;
		case 0x00001e1c:
			return 0x4e93f853;
		case 0x00001e20:
			return 0xcf547e59;
		case 0x00001e24:
			return 0x9e6840aa;
		case 0x00001e28:
			return 0x9bf7c28b;
		case 0x00001e2c:
			return 0xb2ea0c78;
		case 0x00001e30:
			return 0x323afc4a;
		case 0x00001e34:
			return 0xce9e9e1a;
		case 0x00001e38:
			return 0xbea4659c;
		case 0x00001e3c:
			return 0x4b98cdf3;
		case 0x00001e40:
			return 0xe6470c9c;
		case 0x00001e44:
			return 0x16eaa018;
		case 0x00001e48:
			return 0xccdd9b1a;
		case 0x00001e4c:
			return 0x33b1891a;
		case 0x00001e50:
			return 0xd96969db;
		case 0x00001e54:
			return 0xe45b8e46;
		case 0x00001e58:
			return 0x0cd71815;
		case 0x00001e5c:
			return 0x416e549e;
		case 0x00001e60:
			return 0xa59c3e82;
		case 0x00001e64:
			return 0xced52907;
		case 0x00001e68:
			return 0x2b1ccd51;
		case 0x00001e6c:
			return 0xbed18022;
		case 0x00001e70:
			return 0xf2f1d21a;
		case 0x00001e74:
			return 0xb3a908e8;
		case 0x00001e78:
			return 0xaac2359e;
		case 0x00001e7c:
			return 0xf7fbf141;
		case 0x00001e80:
			return 0x0d55bd5d;
		case 0x00001e84:
			return 0x8358845f;
		case 0x00001e88:
			return 0x830101f2;
		case 0x00001e8c:
			return 0x8728c458;
		case 0x00001e90:
			return 0x284a49eb;
		case 0x00001e94:
			return 0x2586a64d;
		case 0x00001e98:
			return 0x7ee39c25;
		case 0x00001e9c:
			return 0xcaa0a3d2;
		case 0x00001ea0:
			return 0x71a3522e;
		case 0x00001ea4:
			return 0xc87d6c74;
		case 0x00001ea8:
			return 0x8ff35d0a;
		case 0x00001eac:
			return 0xdcf3ef55;
		case 0x00001eb0:
			return 0x5d8ccbf4;
		case 0x00001eb4:
			return 0xbbfcc5a3;
		case 0x00001eb8:
			return 0xc7f19f52;
		case 0x00001ebc:
			return 0xd19c3deb;
		case 0x00001ec0:
			return 0x9ab9818f;
		case 0x00001ec4:
			return 0x5383bcd5;
		case 0x00001ec8:
			return 0x5119a91e;
		case 0x00001ecc:
			return 0x1238d1ca;
		case 0x00001ed0:
			return 0x2c37bc2e;
		case 0x00001ed4:
			return 0xfe68c190;
		case 0x00001ed8:
			return 0x6d3233f4;
		case 0x00001edc:
			return 0xe87e886b;
		case 0x00001ee0:
			return 0x11d70234;
		case 0x00001ee4:
			return 0x928f1444;
		case 0x00001ee8:
			return 0x6922ced2;
		case 0x00001eec:
			return 0x24e09b90;
		case 0x00001ef0:
			return 0x64813c6e;
		case 0x00001ef4:
			return 0xb72578ca;
		case 0x00001ef8:
			return 0x2dab6776;
		case 0x00001efc:
			return 0x35de6079;
		case 0x00001f00:
			return 0x57faf561;
		case 0x00001f04:
			return 0xbddf68ab;
		case 0x00001f08:
			return 0xf49c0dec;
		case 0x00001f0c:
			return 0x9175740b;
		case 0x00001f10:
			return 0x4d5f5dfc;
		case 0x00001f14:
			return 0x80334fbf;
		case 0x00001f18:
			return 0xaeaaf441;
		case 0x00001f1c:
			return 0x1b5eb332;
		case 0x00001f20:
			return 0x2e02cb8b;
		case 0x00001f24:
			return 0x62e34bce;
		case 0x00001f28:
			return 0x5ed28dcc;
		case 0x00001f2c:
			return 0x2743f690;
		case 0x00001f30:
			return 0xdc99626a;
		case 0x00001f34:
			return 0x1ee05d49;
		case 0x00001f38:
			return 0xe8a24026;
		case 0x00001f3c:
			return 0x3d8d09b1;
		case 0x00001f40:
			return 0x07a10b9a;
		case 0x00001f44:
			return 0x355e45b0;
		case 0x00001f48:
			return 0x867a8120;
		case 0x00001f4c:
			return 0xaab7031f;
		case 0x00001f50:
			return 0xa47e1265;
		case 0x00001f54:
			return 0xfc2c14a3;
		case 0x00001f58:
			return 0x76e70293;
		case 0x00001f5c:
			return 0xa2e59952;
		case 0x00001f60:
			return 0xb2c68b09;
		case 0x00001f64:
			return 0x409fd0a9;
		case 0x00001f68:
			return 0x1723f06c;
		case 0x00001f6c:
			return 0x06b21fef;
		case 0x00001f70:
			return 0xb09c0afe;
		case 0x00001f74:
			return 0xaeed47cd;
		case 0x00001f78:
			return 0x497a7cee;
		case 0x00001f7c:
			return 0xdda7c48e;
		case 0x00001f80:
			return 0x1219860e;
		case 0x00001f84:
			return 0x90462039;
		case 0x00001f88:
			return 0xa3b40713;
		case 0x00001f8c:
			return 0x8d094739;
		case 0x00001f90:
			return 0x5965c456;
		case 0x00001f94:
			return 0x02aa1dd6;
		case 0x00001f98:
			return 0x5e8af4ed;
		case 0x00001f9c:
			return 0xd60981f5;
		case 0x00001fa0:
			return 0x90e397ce;
		case 0x00001fa4:
			return 0xcb16edeb;
		case 0x00001fa8:
			return 0xdcf89ba3;
		case 0x00001fac:
			return 0x7bef8777;
		case 0x00001fb0:
			return 0xb18a2740;
		case 0x00001fb4:
			return 0xb0e0c345;
		case 0x00001fb8:
			return 0xc0429f2b;
		case 0x00001fbc:
			return 0x0de405b5;
		case 0x00001fc0:
			return 0xd5965599;
		case 0x00001fc4:
			return 0x5556a5dd;
		case 0x00001fc8:
			return 0x5be97b33;
		case 0x00001fcc:
			return 0xec785007;
		case 0x00001fd0:
			return 0xe148e4d8;
		case 0x00001fd4:
			return 0xc34d92a1;
		case 0x00001fd8:
			return 0x23fcc811;
		case 0x00001fdc:
			return 0xc549c6a1;
		case 0x00001fe0:
			return 0x9a8de3b6;
		case 0x00001fe4:
			return 0xe1e9762d;
		case 0x00001fe8:
			return 0x95603643;
		case 0x00001fec:
			return 0x5b56aade;
		case 0x00001ff0:
			return 0xffe8abbe;
		case 0x00001ff4:
			return 0xa335bf0a;
		case 0x00001ff8:
			return 0x3a2479e1;
		case 0x00001ffc:
			return 0x0d8c906a;
		case 0x00002000:
			return 0x6df6ef57;
		case 0x00002004:
			return 0xa1b0b652;
		case 0x00002008:
			return 0xb8a8d582;
		case 0x0000200c:
			return 0xd7a0d5f0;
		case 0x00002010:
			return 0xd1602bf5;
		case 0x00002014:
			return 0x6a2aaec4;
		case 0x00002018:
			return 0x358189ce;
		case 0x0000201c:
			return 0x1468c676;
		case 0x00002020:
			return 0xffff5487;
		case 0x00002024:
			return 0x35452d5a;
		case 0x00002028:
			return 0xc96aaf14;
		case 0x0000202c:
			return 0xf2cd253a;
		case 0x00002030:
			return 0x5c3f5c0c;
		case 0x00002034:
			return 0x15459f56;
		case 0x00002038:
			return 0x6ab36b1d;
		case 0x0000203c:
			return 0x339e6b02;
		case 0x00002040:
			return 0x6f392da3;
		case 0x00002044:
			return 0xa9e2fba3;
		case 0x00002048:
			return 0x07c4d275;
		case 0x0000204c:
			return 0xac51cb1e;
		case 0x00002050:
			return 0x9a83f73e;
		case 0x00002054:
			return 0x12a9e7d6;
		case 0x00002058:
			return 0xdce0611d;
		case 0x0000205c:
			return 0x9c54c921;
		case 0x00002060:
			return 0x17acf323;
		case 0x00002064:
			return 0x268dad04;
		case 0x00002068:
			return 0x1cb5a325;
		case 0x0000206c:
			return 0xf2648952;
		case 0x00002070:
			return 0x0d0478b4;
		case 0x00002074:
			return 0x454edae0;
		case 0x00002078:
			return 0x7a4f544f;
		case 0x0000207c:
			return 0xe579028e;
		case 0x00002080:
			return 0x5040878a;
		case 0x00002084:
			return 0x9aca04b8;
		case 0x00002088:
			return 0x6ab9287b;
		case 0x0000208c:
			return 0x3d3324a3;
		case 0x00002090:
			return 0x60015bc0;
		case 0x00002094:
			return 0x821359a3;
		case 0x00002098:
			return 0x690706be;
		case 0x0000209c:
			return 0xa42204a3;
		case 0x000020a0:
			return 0x24351a60;
		case 0x000020a4:
			return 0xbeb14fb5;
		case 0x000020a8:
			return 0x60d612d8;
		case 0x000020ac:
			return 0xa3d52ca8;
		case 0x000020b0:
			return 0x9b1d3ade;
		case 0x000020b4:
			return 0xb523ed44;
		case 0x000020b8:
			return 0xba639ded;
		case 0x000020bc:
			return 0x90fd310e;
		case 0x000020c0:
			return 0xc6cf5abf;
		case 0x000020c4:
			return 0xbdbb46c8;
		case 0x000020c8:
			return 0x0b012987;
		case 0x000020cc:
			return 0xa359c52f;
		case 0x000020d0:
			return 0x51fd8344;
		case 0x000020d4:
			return 0xe066f8aa;
		case 0x000020d8:
			return 0xdc6f6078;
		case 0x000020dc:
			return 0xbd950ea1;
		case 0x000020e0:
			return 0xde9aa7f9;
		case 0x000020e4:
			return 0xb57efd0d;
		case 0x000020e8:
			return 0xc9f8fdc0;
		case 0x000020ec:
			return 0x5c073422;
		case 0x000020f0:
			return 0xd3ffcc25;
		case 0x000020f4:
			return 0x326a5dd4;
		case 0x000020f8:
			return 0xe5d8a9ff;
		case 0x000020fc:
			return 0x9a3e6ccd;
		case 0x00002100:
			return 0x3a141cdd;
		case 0x00002104:
			return 0x786faba0;
		case 0x00002108:
			return 0x853674b1;
		case 0x0000210c:
			return 0xa92cf78a;
		case 0x00002110:
			return 0x2861fde7;
		case 0x00002114:
			return 0xd8741ca3;
		case 0x00002118:
			return 0xad369181;
		case 0x0000211c:
			return 0x4921086d;
		case 0x00002120:
			return 0xf4c4baad;
		case 0x00002124:
			return 0x1ad59aa8;
		case 0x00002128:
			return 0x727b177a;
		case 0x0000212c:
			return 0x8128c332;
		case 0x00002130:
			return 0x681df7ae;
		case 0x00002134:
			return 0x0eec702f;
		case 0x00002138:
			return 0xcf5d3885;
		case 0x0000213c:
			return 0x24b49445;
		case 0x00002140:
			return 0x27cee761;
		case 0x00002144:
			return 0x23809f22;
		case 0x00002148:
			return 0x1df8eb2d;
		case 0x0000214c:
			return 0x16987514;
		case 0x00002150:
			return 0x32334715;
		case 0x00002154:
			return 0x3b9edd1e;
		case 0x00002158:
			return 0x5cf8ec87;
		case 0x0000215c:
			return 0x1af400dc;
		case 0x00002160:
			return 0x6dffe8ae;
		case 0x00002164:
			return 0x6950d9e8;
		case 0x00002168:
			return 0x98c8c1bf;
		case 0x0000216c:
			return 0xb80e31c6;
		case 0x00002170:
			return 0x90c47adb;
		case 0x00002174:
			return 0xd6be296e;
		case 0x00002178:
			return 0x6394caa3;
		case 0x0000217c:
			return 0x50f5d4f3;
		case 0x00002180:
			return 0xdd743854;
		case 0x00002184:
			return 0x37be8c7d;
		case 0x00002188:
			return 0x303e4c2d;
		case 0x0000218c:
			return 0xfc3fe91d;
		case 0x00002190:
			return 0x1c77c042;
		case 0x00002194:
			return 0xe56be12b;
		case 0x00002198:
			return 0x4fafd0c8;
		case 0x0000219c:
			return 0x799b84ce;
		case 0x000021a0:
			return 0xeb5c0c60;
		case 0x000021a4:
			return 0xab4eb00a;
		case 0x000021a8:
			return 0xfbb632ad;
		case 0x000021ac:
			return 0xfa8c3d0e;
		case 0x000021b0:
			return 0x92cb7d3b;
		case 0x000021b4:
			return 0x73ebd955;
		case 0x000021b8:
			return 0xa8a88cb3;
		case 0x000021bc:
			return 0xbc312bc9;
		case 0x000021c0:
			return 0x012b6fec;
		case 0x000021c4:
			return 0x9c201af9;
		case 0x000021c8:
			return 0xee34311c;
		case 0x000021cc:
			return 0xdeb7f69a;
		case 0x000021d0:
			return 0x1074fcda;
		case 0x000021d4:
			return 0xafe13346;
		case 0x000021d8:
			return 0xba83655b;
		case 0x000021dc:
			return 0x0ce7aee7;
		case 0x000021e0:
			return 0x0b4c365b;
		case 0x000021e4:
			return 0xc3277354;
		case 0x000021e8:
			return 0xd1a38190;
		case 0x000021ec:
			return 0x39dab539;
		case 0x000021f0:
			return 0x22663634;
		case 0x000021f4:
			return 0xd2c1430c;
		case 0x000021f8:
			return 0x2df00f41;
		case 0x000021fc:
			return 0xb08ce452;
		case 0x00002200:
			return 0xf8c6c77b;
		case 0x00002204:
			return 0xb809d7c4;
		case 0x00002208:
			return 0x6ed30905;
		case 0x0000220c:
			return 0x884e91dd;
		case 0x00002210:
			return 0xf9fb18b4;
		case 0x00002214:
			return 0x8cd1d140;
		case 0x00002218:
			return 0x7d5ef975;
		case 0x0000221c:
			return 0x3097d90d;
		case 0x00002220:
			return 0xbab7c85d;
		case 0x00002224:
			return 0x8e7df9fe;
		case 0x00002228:
			return 0x192f7536;
		case 0x0000222c:
			return 0x9b6c4236;
		case 0x00002230:
			return 0x764d28af;
		case 0x00002234:
			return 0xd6656479;
		case 0x00002238:
			return 0x8e873b91;
		case 0x0000223c:
			return 0x9a16fff0;
		case 0x00002240:
			return 0x10453cc3;
		case 0x00002244:
			return 0x6aec9d81;
		case 0x00002248:
			return 0x79972ad1;
		case 0x0000224c:
			return 0xf50ae13c;
		case 0x00002250:
			return 0xa44565e0;
		case 0x00002254:
			return 0x8a473021;
		case 0x00002258:
			return 0xbf45b4f7;
		case 0x0000225c:
			return 0x7c4c344a;
		case 0x00002260:
			return 0x4774781d;
		case 0x00002264:
			return 0x7f7efc3a;
		case 0x00002268:
			return 0xbe612a67;
		case 0x0000226c:
			return 0xc932b8a0;
		case 0x00002270:
			return 0xa9e675d3;
		case 0x00002274:
			return 0x1c3d1f17;
		case 0x00002278:
			return 0x4e27051a;
		case 0x0000227c:
			return 0xb5efc4b8;
		case 0x00002280:
			return 0x8681561d;
		case 0x00002284:
			return 0x0473b2ea;
		case 0x00002288:
			return 0x0534ec3e;
		case 0x0000228c:
			return 0xca6c6a6b;
		case 0x00002290:
			return 0x4b8598a7;
		case 0x00002294:
			return 0x34cc0447;
		case 0x00002298:
			return 0xe3854873;
		case 0x0000229c:
			return 0x7e0de1fe;
		case 0x000022a0:
			return 0xd09a6806;
		case 0x000022a4:
			return 0x768b13f5;
		case 0x000022a8:
			return 0xfcf109e0;
		case 0x000022ac:
			return 0xb7658b68;
		case 0x000022b0:
			return 0xf1605001;
		case 0x000022b4:
			return 0x131ea75c;
		case 0x000022b8:
			return 0x39d92641;
		case 0x000022bc:
			return 0xe48a4020;
		case 0x000022c0:
			return 0xeb5574ed;
		case 0x000022c4:
			return 0xc232cdb9;
		case 0x000022c8:
			return 0x6d11b7dc;
		case 0x000022cc:
			return 0x3c1608af;
		case 0x000022d0:
			return 0x59800ece;
		case 0x000022d4:
			return 0x859b3c42;
		case 0x000022d8:
			return 0x811ac91b;
		case 0x000022dc:
			return 0xef4c91d6;
		case 0x000022e0:
			return 0xda875cde;
		case 0x000022e4:
			return 0x2d974a32;
		case 0x000022e8:
			return 0x7cffb3e3;
		case 0x000022ec:
			return 0x3ebaec76;
		case 0x000022f0:
			return 0x2a2b20e7;
		case 0x000022f4:
			return 0x5c7e1229;
		case 0x000022f8:
			return 0x2ef0996e;
		case 0x000022fc:
			return 0xcdf73ed4;
		case 0x00002300:
			return 0xbce1958c;
		case 0x00002304:
			return 0xfb966cfd;
		case 0x00002308:
			return 0x9393656c;
		case 0x0000230c:
			return 0x379059e6;
		case 0x00002310:
			return 0x6977b54d;
		case 0x00002314:
			return 0x38e87718;
		case 0x00002318:
			return 0x176ce97a;
		case 0x0000231c:
			return 0xe6b1a116;
		case 0x00002320:
			return 0xef8f5ef0;
		case 0x00002324:
			return 0x74bb5b2b;
		case 0x00002328:
			return 0xda246a3a;
		case 0x0000232c:
			return 0x3a82a13c;
		case 0x00002330:
			return 0xcae9654b;
		case 0x00002334:
			return 0xbee14aee;
		case 0x00002338:
			return 0x3389f597;
		case 0x0000233c:
			return 0x362a759f;
		case 0x00002340:
			return 0x2ecd219f;
		case 0x00002344:
			return 0x0de2a3dc;
		case 0x00002348:
			return 0xc6fc10cf;
		case 0x0000234c:
			return 0x19d5ddfb;
		case 0x00002350:
			return 0x3e755cb9;
		case 0x00002354:
			return 0x37da49e6;
		case 0x00002358:
			return 0xb9adff07;
		case 0x0000235c:
			return 0x3c039d42;
		case 0x00002360:
			return 0x91b51d3d;
		case 0x00002364:
			return 0x0fe008e2;
		case 0x00002368:
			return 0x37570767;
		case 0x0000236c:
			return 0x76ef4fd1;
		case 0x00002370:
			return 0xe10a25b9;
		case 0x00002374:
			return 0x64d1b5ae;
		case 0x00002378:
			return 0x41987ac0;
		case 0x0000237c:
			return 0x4b9c1c0a;
		case 0x00002380:
			return 0x4e96205d;
		case 0x00002384:
			return 0xb237069c;
		case 0x00002388:
			return 0x113b2b38;
		case 0x0000238c:
			return 0x953a7948;
		case 0x00002390:
			return 0x0819111c;
		case 0x00002394:
			return 0xad29b478;
		case 0x00002398:
			return 0xd666554e;
		case 0x0000239c:
			return 0x1d9a4029;
		case 0x000023a0:
			return 0xd525e55b;
		case 0x000023a4:
			return 0x17e9c30a;
		case 0x000023a8:
			return 0x0511c14b;
		case 0x000023ac:
			return 0x6191fc8a;
		case 0x000023b0:
			return 0xaefd82df;
		case 0x000023b4:
			return 0x3ac043c6;
		case 0x000023b8:
			return 0x8eb075e3;
		case 0x000023bc:
			return 0x7b77e8d9;
		case 0x000023c0:
			return 0xc578f4b8;
		case 0x000023c4:
			return 0x5ff47e11;
		case 0x000023c8:
			return 0x7d951118;
		case 0x000023cc:
			return 0xb9865b0d;
		case 0x000023d0:
			return 0xd2133fb7;
		case 0x000023d4:
			return 0xc286453a;
		case 0x000023d8:
			return 0x469ccca1;
		case 0x000023dc:
			return 0x53082877;
		case 0x000023e0:
			return 0xb137071d;
		case 0x000023e4:
			return 0xc0efc5fd;
		case 0x000023e8:
			return 0xbc15465b;
		case 0x000023ec:
			return 0x54bace17;
		case 0x000023f0:
			return 0x79135505;
		case 0x000023f4:
			return 0xe85e4132;
		case 0x000023f8:
			return 0xd45eaf96;
		case 0x000023fc:
			return 0x0f6aa418;
		case 0x00002400:
			return 0xa1b2366e;
		case 0x00002404:
			return 0x33564a4f;
		case 0x00002408:
			return 0xc90cd244;
		case 0x0000240c:
			return 0x58beb8ec;
		case 0x00002410:
			return 0xa27200b3;
		case 0x00002414:
			return 0x103e62ec;
		case 0x00002418:
			return 0xb777145f;
		case 0x0000241c:
			return 0xb3f63e26;
		case 0x00002420:
			return 0x7441b9ba;
		case 0x00002424:
			return 0x96b07a72;
		case 0x00002428:
			return 0x1732966e;
		case 0x0000242c:
			return 0xe62ccc3c;
		case 0x00002430:
			return 0x00eef52e;
		case 0x00002434:
			return 0x6661a028;
		case 0x00002438:
			return 0xe5384e54;
		case 0x0000243c:
			return 0x0c0a6da8;
		case 0x00002440:
			return 0x51fe7431;
		case 0x00002444:
			return 0x26edb9fb;
		case 0x00002448:
			return 0xf245cb93;
		case 0x0000244c:
			return 0xf17f0757;
		case 0x00002450:
			return 0x0e876692;
		case 0x00002454:
			return 0xde3d4fb3;
		case 0x00002458:
			return 0x72112689;
		case 0x0000245c:
			return 0x63dfa517;
		case 0x00002460:
			return 0x44a5a527;
		case 0x00002464:
			return 0xf820f83f;
		case 0x00002468:
			return 0x2df0570e;
		case 0x0000246c:
			return 0x4cc2f446;
		case 0x00002470:
			return 0xf51a617c;
		case 0x00002474:
			return 0x0e1328da;
		case 0x00002478:
			return 0x8898fb17;
		case 0x0000247c:
			return 0x3a099627;
		case 0x00002480:
			return 0x1fcdef7d;
		case 0x00002484:
			return 0xa4cff29a;
		case 0x00002488:
			return 0x7ba4274e;
		case 0x0000248c:
			return 0x2ebf5ec7;
		case 0x00002490:
			return 0x09705f52;
		case 0x00002494:
			return 0x51311f3d;
		case 0x00002498:
			return 0x674a9d5e;
		case 0x0000249c:
			return 0x76a9e154;
		case 0x000024a0:
			return 0x501551a6;
		case 0x000024a4:
			return 0x6aeaa378;
		case 0x000024a8:
			return 0x0bafd701;
		case 0x000024ac:
			return 0x246eb548;
		case 0x000024b0:
			return 0x3afde020;
		case 0x000024b4:
			return 0xb590ec03;
		case 0x000024b8:
			return 0x83be3461;
		case 0x000024bc:
			return 0xea02ca00;
		case 0x000024c0:
			return 0x58e475a3;
		case 0x000024c4:
			return 0x100c534e;
		case 0x000024c8:
			return 0x33f625e9;
		case 0x000024cc:
			return 0x35bdd879;
		case 0x000024d0:
			return 0x2a8efaa2;
		case 0x000024d4:
			return 0xab86fbe8;
		case 0x000024d8:
			return 0x1e3009fb;
		case 0x000024dc:
			return 0x12eb3849;
		case 0x000024e0:
			return 0xafc7e33e;
		case 0x000024e4:
			return 0x903b9b10;
		case 0x000024e8:
			return 0xe403c5da;
		case 0x000024ec:
			return 0xdd836a7f;
		case 0x000024f0:
			return 0x6a292575;
		case 0x000024f4:
			return 0xfc951246;
		case 0x000024f8:
			return 0x2a7102f1;
		case 0x000024fc:
			return 0x37dd7905;
		case 0x00002500:
			return 0x13e6dc09;
		case 0x00002504:
			return 0x94ad9801;
		case 0x00002508:
			return 0x341f33b1;
		case 0x0000250c:
			return 0x87f3e43e;
		case 0x00002510:
			return 0x76db0c3e;
		case 0x00002514:
			return 0x9db7ca0e;
		case 0x00002518:
			return 0x2de4ab60;
		case 0x0000251c:
			return 0xb9b2ebda;
		case 0x00002520:
			return 0xbf9b3350;
		case 0x00002524:
			return 0x9b66f7f8;
		case 0x00002528:
			return 0xedb1f95b;
		case 0x0000252c:
			return 0xdf62a086;
		case 0x00002530:
			return 0x4e355c7c;
		case 0x00002534:
			return 0x5566f0d6;
		case 0x00002538:
			return 0x9cfa45a6;
		case 0x0000253c:
			return 0x40133696;
		case 0x00002540:
			return 0x7be81d8b;
		case 0x00002544:
			return 0x71e4e370;
		case 0x00002548:
			return 0x6a437c34;
		case 0x0000254c:
			return 0x5bbc291a;
		case 0x00002550:
			return 0xb6f0d099;
		case 0x00002554:
			return 0x00c828f3;
		case 0x00002558:
			return 0x7ae7e6b8;
		case 0x0000255c:
			return 0x40c265fa;
		case 0x00002560:
			return 0xdfa242ff;
		case 0x00002564:
			return 0x41c18023;
		case 0x00002568:
			return 0xdf72877d;
		case 0x0000256c:
			return 0x0d91fc22;
		case 0x00002570:
			return 0xee9267f7;
		case 0x00002574:
			return 0x447539ce;
		case 0x00002578:
			return 0x3d6f0d43;
		case 0x0000257c:
			return 0xb2a205cb;
		case 0x00002580:
			return 0x63a169ef;
		case 0x00002584:
			return 0xa694c25f;
		case 0x00002588:
			return 0x2daa4c8b;
		case 0x0000258c:
			return 0x7a11b40e;
		case 0x00002590:
			return 0x9df2fc54;
		case 0x00002594:
			return 0x181d10bf;
		case 0x00002598:
			return 0x5e7aa674;
		case 0x0000259c:
			return 0xb0213bf4;
		case 0x000025a0:
			return 0x34dd4b80;
		case 0x000025a4:
			return 0xf6ed3087;
		case 0x000025a8:
			return 0x2e3bc8f4;
		case 0x000025ac:
			return 0x0f26c528;
		case 0x000025b0:
			return 0x6635033b;
		case 0x000025b4:
			return 0x666d3d9b;
		case 0x000025b8:
			return 0xa9a8b124;
		case 0x000025bc:
			return 0xd2c56baf;
		case 0x000025c0:
			return 0xf80aef87;
		case 0x000025c4:
			return 0x85810128;
		case 0x000025c8:
			return 0x347e2b22;
		case 0x000025cc:
			return 0x20b6928d;
		case 0x000025d0:
			return 0x6f6f04f5;
		case 0x000025d4:
			return 0x4ba12cbe;
		case 0x000025d8:
			return 0x9728ea1a;
		case 0x000025dc:
			return 0x9df82732;
		case 0x000025e0:
			return 0x8e7870ee;
		case 0x000025e4:
			return 0xfad42ca2;
		case 0x000025e8:
			return 0x7ceafa0e;
		case 0x000025ec:
			return 0x30f1cc71;
		case 0x000025f0:
			return 0x83c29199;
		case 0x000025f4:
			return 0xc694737c;
		case 0x000025f8:
			return 0x98a57f27;
		case 0x000025fc:
			return 0x9253d61a;
		case 0x00002600:
			return 0x90313c6b;
		case 0x00002604:
			return 0x08fbc61a;
		case 0x00002608:
			return 0x6dc9428f;
		case 0x0000260c:
			return 0x565e07ca;
		case 0x00002610:
			return 0xe11be4b2;
		case 0x00002614:
			return 0x4f4e4135;
		case 0x00002618:
			return 0x60367ab9;
		case 0x0000261c:
			return 0x16e24876;
		case 0x00002620:
			return 0xf5a97c63;
		case 0x00002624:
			return 0x30a91111;
		case 0x00002628:
			return 0x923e37fd;
		case 0x0000262c:
			return 0x26551294;
		case 0x00002630:
			return 0xa080e17d;
		case 0x00002634:
			return 0x08f9b9a0;
		case 0x00002638:
			return 0x688c3954;
		case 0x0000263c:
			return 0x09397c8d;
		case 0x00002640:
			return 0x9ddf0468;
		case 0x00002644:
			return 0x964547a2;
		case 0x00002648:
			return 0x5fd91a01;
		case 0x0000264c:
			return 0x004bfab0;
		case 0x00002650:
			return 0x8c362461;
		case 0x00002654:
			return 0x8f51432d;
		case 0x00002658:
			return 0x8ffe5629;
		case 0x0000265c:
			return 0x9fa64087;
		case 0x00002660:
			return 0xe98f32c6;
		case 0x00002664:
			return 0x0dbf5d01;
		case 0x00002668:
			return 0xaf020bd1;
		case 0x0000266c:
			return 0xe79d0483;
		case 0x00002670:
			return 0x0d8c13e8;
		case 0x00002674:
			return 0xf53404dc;
		case 0x00002678:
			return 0x68f1b45c;
		case 0x0000267c:
			return 0xe9dce7b4;
		case 0x00002680:
			return 0x3b90f141;
		case 0x00002684:
			return 0x28fd1580;
		case 0x00002688:
			return 0x4b55d026;
		case 0x0000268c:
			return 0x556baea5;
		case 0x00002690:
			return 0xa26b7593;
		case 0x00002694:
			return 0xe9edb14d;
		case 0x00002698:
			return 0x7919dea9;
		case 0x0000269c:
			return 0xd040e0e6;
		case 0x000026a0:
			return 0xc18cd856;
		case 0x000026a4:
			return 0xce4a025a;
		case 0x000026a8:
			return 0xa8069ff6;
		case 0x000026ac:
			return 0x2fb9b477;
		case 0x000026b0:
			return 0xd34c3049;
		case 0x000026b4:
			return 0x8048e18d;
		case 0x000026b8:
			return 0xcc208a0a;
		case 0x000026bc:
			return 0xff83d18e;
		case 0x000026c0:
			return 0xe2774080;
		case 0x000026c4:
			return 0x211362c4;
		case 0x000026c8:
			return 0xf990c795;
		case 0x000026cc:
			return 0xfb0a8da8;
		case 0x000026d0:
			return 0x322abcca;
		case 0x000026d4:
			return 0x67514883;
		case 0x000026d8:
			return 0x2da5c6d5;
		case 0x000026dc:
			return 0xf0cd7423;
		case 0x000026e0:
			return 0xea153f2c;
		case 0x000026e4:
			return 0xa993330b;
		case 0x000026e8:
			return 0x28d72583;
		case 0x000026ec:
			return 0x4c4d8084;
		case 0x000026f0:
			return 0xcdf4374e;
		case 0x000026f4:
			return 0x8eb9881c;
		case 0x000026f8:
			return 0xca03dea9;
		case 0x000026fc:
			return 0x8787ee0f;
		case 0x00002700:
			return 0x65c1fa7f;
		case 0x00002704:
			return 0x35745e89;
		case 0x00002708:
			return 0xcebbe64d;
		case 0x0000270c:
			return 0x5a3dafa5;
		case 0x00002710:
			return 0xa531f436;
		case 0x00002714:
			return 0xc8652301;
		case 0x00002718:
			return 0x4c211c8b;
		case 0x0000271c:
			return 0x1a65c457;
		case 0x00002720:
			return 0xd5792f6b;
		case 0x00002724:
			return 0xe7efd2d3;
		case 0x00002728:
			return 0xd705b2cc;
		case 0x0000272c:
			return 0xeb382193;
		case 0x00002730:
			return 0x8551b923;
		case 0x00002734:
			return 0xd94ba6d1;
		case 0x00002738:
			return 0x46c04035;
		case 0x0000273c:
			return 0x82fa8af4;
		case 0x00002740:
			return 0x17811de3;
		case 0x00002744:
			return 0xfa1b6a3a;
		case 0x00002748:
			return 0xdde90408;
		case 0x0000274c:
			return 0x196120e9;
		case 0x00002750:
			return 0x0f070c4b;
		case 0x00002754:
			return 0xa62117bf;
		case 0x00002758:
			return 0x54f687ce;
		case 0x0000275c:
			return 0x45bf9a55;
		case 0x00002760:
			return 0xee62b781;
		case 0x00002764:
			return 0xd01795c2;
		case 0x00002768:
			return 0x5362eddd;
		case 0x0000276c:
			return 0x7cf4875c;
		case 0x00002770:
			return 0xe8973e92;
		case 0x00002774:
			return 0x3100adc7;
		case 0x00002778:
			return 0xc9c91f5c;
		case 0x0000277c:
			return 0xf6259a08;
		case 0x00002780:
			return 0xe5258598;
		case 0x00002784:
			return 0xb513d02d;
		case 0x00002788:
			return 0x7fbda3e7;
		case 0x0000278c:
			return 0x110ae948;
		case 0x00002790:
			return 0xeaa35cf4;
		case 0x00002794:
			return 0x90a2ef77;
		case 0x00002798:
			return 0xe2aa03d3;
		case 0x0000279c:
			return 0x36a2ba20;
		case 0x000027a0:
			return 0x844f2a9d;
		case 0x000027a4:
			return 0xae336602;
		case 0x000027a8:
			return 0x1281c0b1;
		case 0x000027ac:
			return 0x6f88116c;
		case 0x000027b0:
			return 0x939c5d5f;
		case 0x000027b4:
			return 0x4e53ef33;
		case 0x000027b8:
			return 0x8c3c46f6;
		case 0x000027bc:
			return 0x8a5063e1;
		case 0x000027c0:
			return 0xca7c714c;
		case 0x000027c4:
			return 0x9a79456c;
		case 0x000027c8:
			return 0xd8af0de4;
		case 0x000027cc:
			return 0xbe5dd322;
		case 0x000027d0:
			return 0x4ca6bf44;
		case 0x000027d4:
			return 0xfa618a5d;
		case 0x000027d8:
			return 0x35aca848;
		case 0x000027dc:
			return 0xc7d57b58;
		case 0x000027e0:
			return 0xd1d726c1;
		case 0x000027e4:
			return 0x3355c019;
		case 0x000027e8:
			return 0x27e43cf3;
		case 0x000027ec:
			return 0x23275fd6;
		case 0x000027f0:
			return 0x8a5dfaf5;
		case 0x000027f4:
			return 0xd3424f2a;
		case 0x000027f8:
			return 0xc5c02249;
		case 0x000027fc:
			return 0xa7a84e4f;
		case 0x00002800:
			return 0x093e8ef5;
		case 0x00002804:
			return 0x4b9b482d;
		case 0x00002808:
			return 0x0853c972;
		case 0x0000280c:
			return 0x2c5ff92f;
		case 0x00002810:
			return 0xb4373c5d;
		case 0x00002814:
			return 0xf9ffd496;
		case 0x00002818:
			return 0xce617ef8;
		case 0x0000281c:
			return 0x79d5fa46;
		case 0x00002820:
			return 0xc25ce3e0;
		case 0x00002824:
			return 0x9793f718;
		case 0x00002828:
			return 0xc893bf5f;
		case 0x0000282c:
			return 0xab658aa5;
		case 0x00002830:
			return 0xf69cae76;
		case 0x00002834:
			return 0x3a981365;
		case 0x00002838:
			return 0x8f16074e;
		case 0x0000283c:
			return 0x54ee040c;
		case 0x00002840:
			return 0xd4a24a37;
		case 0x00002844:
			return 0x3176af8b;
		case 0x00002848:
			return 0x7d989f1b;
		case 0x0000284c:
			return 0x846ff4fa;
		case 0x00002850:
			return 0x70940b24;
		case 0x00002854:
			return 0xa5e153ac;
		case 0x00002858:
			return 0xf13dd129;
		case 0x0000285c:
			return 0x7588a246;
		case 0x00002860:
			return 0xe3dc408a;
		case 0x00002864:
			return 0x5df3e56a;
		case 0x00002868:
			return 0xe068aa02;
		case 0x0000286c:
			return 0x038fc479;
		case 0x00002870:
			return 0x2c9c71f6;
		case 0x00002874:
			return 0xe49376cb;
		case 0x00002878:
			return 0x7e722b22;
		case 0x0000287c:
			return 0x3d6cf8df;
		case 0x00002880:
			return 0x79ea2e10;
		case 0x00002884:
			return 0xce036697;
		case 0x00002888:
			return 0x671b3f33;
		case 0x0000288c:
			return 0xfa8b0e6d;
		case 0x00002890:
			return 0x2d5f014e;
		case 0x00002894:
			return 0x1bc371b3;
		case 0x00002898:
			return 0x17e5057b;
		case 0x0000289c:
			return 0x600f32ef;
		case 0x000028a0:
			return 0x7faea61a;
		case 0x000028a4:
			return 0x168f8476;
		case 0x000028a8:
			return 0x16f7aac2;
		case 0x000028ac:
			return 0x7fa0206f;
		case 0x000028b0:
			return 0x50539920;
		case 0x000028b4:
			return 0xa3b8e384;
		case 0x000028b8:
			return 0x2b439fd5;
		case 0x000028bc:
			return 0x87679aa9;
		case 0x000028c0:
			return 0x8a075b53;
		case 0x000028c4:
			return 0xa3894204;
		case 0x000028c8:
			return 0x632f4150;
		case 0x000028cc:
			return 0x8428b75e;
		case 0x000028d0:
			return 0x19ae425a;
		case 0x000028d4:
			return 0x77a1239f;
		case 0x000028d8:
			return 0xa9ac51d6;
		case 0x000028dc:
			return 0x931b7739;
		case 0x000028e0:
			return 0x6db9f79b;
		case 0x000028e4:
			return 0x8fb0b103;
		case 0x000028e8:
			return 0xc5f3f906;
		case 0x000028ec:
			return 0x2f69f08b;
		case 0x000028f0:
			return 0xc861339b;
		case 0x000028f4:
			return 0x90c76431;
		case 0x000028f8:
			return 0x3a622c22;
		case 0x000028fc:
			return 0x18ecf4fe;
		case 0x00002900:
			return 0xa6522db6;
		case 0x00002904:
			return 0x7cab1abd;
		case 0x00002908:
			return 0x85de7ef8;
		case 0x0000290c:
			return 0x39734412;
		case 0x00002910:
			return 0xbd633ad7;
		case 0x00002914:
			return 0xfe1d5170;
		case 0x00002918:
			return 0x368ecd2d;
		case 0x0000291c:
			return 0xdfda58b0;
		case 0x00002920:
			return 0x3db1bf3d;
		case 0x00002924:
			return 0xdd3ad212;
		case 0x00002928:
			return 0x2a1bcdfc;
		case 0x0000292c:
			return 0x3e005e61;
		case 0x00002930:
			return 0x3258227f;
		case 0x00002934:
			return 0x8676b658;
		case 0x00002938:
			return 0xaaca782c;
		case 0x0000293c:
			return 0x36409480;
		case 0x00002940:
			return 0x7a4f8e3f;
		case 0x00002944:
			return 0x1e56d0b2;
		case 0x00002948:
			return 0x01532496;
		case 0x0000294c:
			return 0xed859b30;
		case 0x00002950:
			return 0x20b5e990;
		case 0x00002954:
			return 0x22651439;
		case 0x00002958:
			return 0xce0a7353;
		case 0x0000295c:
			return 0x5747d962;
		case 0x00002960:
			return 0x794a920c;
		case 0x00002964:
			return 0xb15ddb33;
		case 0x00002968:
			return 0x7f49de9c;
		case 0x0000296c:
			return 0xc4682469;
		case 0x00002970:
			return 0x0104f878;
		case 0x00002974:
			return 0x6ece930e;
		case 0x00002978:
			return 0xc82597aa;
		case 0x0000297c:
			return 0xa93739fe;
		case 0x00002980:
			return 0x971c0cd1;
		case 0x00002984:
			return 0x7a7a2b40;
		case 0x00002988:
			return 0x2681b26b;
		case 0x0000298c:
			return 0xcdaea75a;
		case 0x00002990:
			return 0x4a5ff38c;
		case 0x00002994:
			return 0xfa1d48bc;
		case 0x00002998:
			return 0x9f660fbf;
		case 0x0000299c:
			return 0x054e84a8;
		case 0x000029a0:
			return 0xdc580ccc;
		case 0x000029a4:
			return 0xf6eaea35;
		case 0x000029a8:
			return 0xaa3225ab;
		case 0x000029ac:
			return 0x1c273ede;
		case 0x000029b0:
			return 0xd0d447d1;
		case 0x000029b4:
			return 0xcc775d69;
		case 0x000029b8:
			return 0xbc7746f8;
		case 0x000029bc:
			return 0x105eac5e;
		case 0x000029c0:
			return 0x0a9a9b47;
		case 0x000029c4:
			return 0xab68a467;
		case 0x000029c8:
			return 0xccf66475;
		case 0x000029cc:
			return 0xd18d5c35;
		case 0x000029d0:
			return 0xe2dc9fc2;
		case 0x000029d4:
			return 0xb0826afd;
		case 0x000029d8:
			return 0x1d4447a6;
		case 0x000029dc:
			return 0x0aad1631;
		case 0x000029e0:
			return 0x4540ca01;
		case 0x000029e4:
			return 0xfd2faf6f;
		case 0x000029e8:
			return 0x6527603d;
		case 0x000029ec:
			return 0x81337a23;
		case 0x000029f0:
			return 0x7d7a833c;
		case 0x000029f4:
			return 0xfea53543;
		case 0x000029f8:
			return 0x9f9840e5;
		case 0x000029fc:
			return 0xc7ff6693;
		case 0x00002a00:
			return 0x67e80086;
		case 0x00002a04:
			return 0xd36a31e0;
		case 0x00002a08:
			return 0x905e9792;
		case 0x00002a0c:
			return 0x24833cb0;
		case 0x00002a10:
			return 0xd8a2e636;
		case 0x00002a14:
			return 0xd0f67ef5;
		case 0x00002a18:
			return 0x55c2ae1b;
		case 0x00002a1c:
			return 0x70122c0a;
		case 0x00002a20:
			return 0xe87e9e7f;
		case 0x00002a24:
			return 0x3cd6aba2;
		case 0x00002a28:
			return 0x1b99f910;
		case 0x00002a2c:
			return 0x8efd26a6;
		case 0x00002a30:
			return 0x71b873a3;
		case 0x00002a34:
			return 0xdf11ac85;
		case 0x00002a38:
			return 0xfd474231;
		case 0x00002a3c:
			return 0xc9cfe48b;
		case 0x00002a40:
			return 0xbd8cfde7;
		case 0x00002a44:
			return 0x99f33f60;
		case 0x00002a48:
			return 0x710c1707;
		case 0x00002a4c:
			return 0xdaf10c99;
		case 0x00002a50:
			return 0x7d58824f;
		case 0x00002a54:
			return 0x8195c6d3;
		case 0x00002a58:
			return 0x1974aa19;
		case 0x00002a5c:
			return 0x8e1ccac5;
		case 0x00002a60:
			return 0xf0bdf63b;
		case 0x00002a64:
			return 0x1d215510;
		case 0x00002a68:
			return 0x684ab7d5;
		case 0x00002a6c:
			return 0x8d3a4caf;
		case 0x00002a70:
			return 0xd30575bd;
		case 0x00002a74:
			return 0xa895c777;
		case 0x00002a78:
			return 0x789240b0;
		case 0x00002a7c:
			return 0xf17b3ada;
		case 0x00002a80:
			return 0x63b27a95;
		case 0x00002a84:
			return 0x5f6b5b37;
		case 0x00002a88:
			return 0x6c0036e7;
		case 0x00002a8c:
			return 0xff842837;
		case 0x00002a90:
			return 0xbd6eb9b0;
		case 0x00002a94:
			return 0xd54ae7f4;
		case 0x00002a98:
			return 0x54960b6f;
		case 0x00002a9c:
			return 0xd6bb5d9f;
		case 0x00002aa0:
			return 0x806d7f7a;
		case 0x00002aa4:
			return 0x73836e28;
		case 0x00002aa8:
			return 0x4c6ecd6a;
		case 0x00002aac:
			return 0xbd0a86f0;
		case 0x00002ab0:
			return 0x96e20fea;
		case 0x00002ab4:
			return 0xcb4fdc8b;
		case 0x00002ab8:
			return 0x3dbad48b;
		case 0x00002abc:
			return 0xea455e18;
		case 0x00002ac0:
			return 0x5c5e9e42;
		case 0x00002ac4:
			return 0x25b8713c;
		case 0x00002ac8:
			return 0x583cafd1;
		case 0x00002acc:
			return 0x57b9cf89;
		case 0x00002ad0:
			return 0x014ab32a;
		case 0x00002ad4:
			return 0x964b9eeb;
		case 0x00002ad8:
			return 0x812f1ba0;
		case 0x00002adc:
			return 0x4ae23755;
		case 0x00002ae0:
			return 0x88754328;
		case 0x00002ae4:
			return 0xf8fe54ca;
		case 0x00002ae8:
			return 0xb28c8867;
		case 0x00002aec:
			return 0x4430532c;
		case 0x00002af0:
			return 0xceea02e3;
		case 0x00002af4:
			return 0x0128ccd6;
		case 0x00002af8:
			return 0x54b5a6ad;
		case 0x00002afc:
			return 0x6732ead0;
		case 0x00002b00:
			return 0x1872186e;
		case 0x00002b04:
			return 0xe2819430;
		case 0x00002b08:
			return 0x33705e45;
		case 0x00002b0c:
			return 0x927de050;
		case 0x00002b10:
			return 0xcd037b69;
		case 0x00002b14:
			return 0xcd8e1b67;
		case 0x00002b18:
			return 0x6c0cf504;
		case 0x00002b1c:
			return 0x6fbca5f8;
		case 0x00002b20:
			return 0x937f3042;
		case 0x00002b24:
			return 0x25a4f800;
		case 0x00002b28:
			return 0x7340007f;
		case 0x00002b2c:
			return 0x8d8aa2ca;
		case 0x00002b30:
			return 0xf221ed30;
		case 0x00002b34:
			return 0x23e011e3;
		case 0x00002b38:
			return 0xb58d6250;
		case 0x00002b3c:
			return 0x4035f23c;
		case 0x00002b40:
			return 0x65325568;
		case 0x00002b44:
			return 0xa4188289;
		case 0x00002b48:
			return 0x696e59f3;
		case 0x00002b4c:
			return 0x4fc2e6af;
		case 0x00002b50:
			return 0x73216e56;
		case 0x00002b54:
			return 0x13e5a220;
		case 0x00002b58:
			return 0x96a2e283;
		case 0x00002b5c:
			return 0x5a43dff9;
		case 0x00002b60:
			return 0xc8583231;
		case 0x00002b64:
			return 0x9782b572;
		case 0x00002b68:
			return 0x3e5f3b98;
		case 0x00002b6c:
			return 0x412c8349;
		case 0x00002b70:
			return 0x1a087ea5;
		case 0x00002b74:
			return 0xf6a11dac;
		case 0x00002b78:
			return 0xbc881f26;
		case 0x00002b7c:
			return 0x81f12b0a;
		case 0x00002b80:
			return 0xb2fca720;
		case 0x00002b84:
			return 0x4481476b;
		case 0x00002b88:
			return 0x7481ede9;
		case 0x00002b8c:
			return 0x392a05cd;
		case 0x00002b90:
			return 0x5a6fc7f2;
		case 0x00002b94:
			return 0x96f761ea;
		case 0x00002b98:
			return 0x6fe53892;
		case 0x00002b9c:
			return 0xf3583c1a;
		case 0x00002ba0:
			return 0xdf272436;
		case 0x00002ba4:
			return 0xf910b979;
		case 0x00002ba8:
			return 0x21185e7d;
		case 0x00002bac:
			return 0xf3e4abde;
		case 0x00002bb0:
			return 0x4f888890;
		case 0x00002bb4:
			return 0x909e691b;
		case 0x00002bb8:
			return 0x7b4cb9c0;
		case 0x00002bbc:
			return 0x32ff4f97;
		case 0x00002bc0:
			return 0x888fa7ef;
		case 0x00002bc4:
			return 0x041d4c51;
		case 0x00002bc8:
			return 0xe3f12744;
		case 0x00002bcc:
			return 0x7cf1521a;
		case 0x00002bd0:
			return 0x0cd1e679;
		case 0x00002bd4:
			return 0x97836ec5;
		case 0x00002bd8:
			return 0xdf2a4da8;
		case 0x00002bdc:
			return 0x7f1690de;
		case 0x00002be0:
			return 0x748457b9;
		case 0x00002be4:
			return 0x0c7f977a;
		case 0x00002be8:
			return 0xa584834a;
		case 0x00002bec:
			return 0xd0b47dd7;
		case 0x00002bf0:
			return 0x8ca88f09;
		case 0x00002bf4:
			return 0xee2306da;
		case 0x00002bf8:
			return 0x3f8cb317;
		case 0x00002bfc:
			return 0x2e2e89a4;
		case 0x00002c00:
			return 0x43c26948;
		case 0x00002c04:
			return 0x38a12bdc;
		case 0x00002c08:
			return 0xd8e36d69;
		case 0x00002c0c:
			return 0xb85cd327;
		case 0x00002c10:
			return 0xe4742ab9;
		case 0x00002c14:
			return 0xafad7a69;
		case 0x00002c18:
			return 0x1f53853d;
		case 0x00002c1c:
			return 0xa05e298f;
		case 0x00002c20:
			return 0x3f04caaa;
		case 0x00002c24:
			return 0x1cc25d09;
		case 0x00002c28:
			return 0x3bc23a0e;
		case 0x00002c2c:
			return 0x1187a61a;
		case 0x00002c30:
			return 0xf0414982;
		case 0x00002c34:
			return 0x21ef644a;
		case 0x00002c38:
			return 0x5ba3b125;
		case 0x00002c3c:
			return 0x117790e0;
		case 0x00002c40:
			return 0xfda1bff4;
		case 0x00002c44:
			return 0x4b9b28af;
		case 0x00002c48:
			return 0xb7f6965c;
		case 0x00002c4c:
			return 0xbcabdae5;
		case 0x00002c50:
			return 0x9578da2a;
		case 0x00002c54:
			return 0x37a6976e;
		case 0x00002c58:
			return 0xbfad5917;
		case 0x00002c5c:
			return 0xb5c896d1;
		case 0x00002c60:
			return 0x40f1af6c;
		case 0x00002c64:
			return 0xe534457f;
		case 0x00002c68:
			return 0xca5046e5;
		case 0x00002c6c:
			return 0x0a215be6;
		case 0x00002c70:
			return 0xe65b79f5;
		case 0x00002c74:
			return 0x88dc1a90;
		case 0x00002c78:
			return 0xe41c1c31;
		case 0x00002c7c:
			return 0xb354a5a2;
		case 0x00002c80:
			return 0xab501407;
		case 0x00002c84:
			return 0x8e57194b;
		case 0x00002c88:
			return 0xbd84c047;
		case 0x00002c8c:
			return 0x004a1410;
		case 0x00002c90:
			return 0xe0190b52;
		case 0x00002c94:
			return 0x3010c155;
		case 0x00002c98:
			return 0xde266eea;
		case 0x00002c9c:
			return 0x8e80aba4;
		case 0x00002ca0:
			return 0x3919c443;
		case 0x00002ca4:
			return 0xd39c7e8c;
		case 0x00002ca8:
			return 0xb9c5e27c;
		case 0x00002cac:
			return 0x2ce7dec9;
		case 0x00002cb0:
			return 0xc9980673;
		case 0x00002cb4:
			return 0x37f465ee;
		case 0x00002cb8:
			return 0x4ed2f499;
		case 0x00002cbc:
			return 0xf4bedd3c;
		case 0x00002cc0:
			return 0x2b9f3834;
		case 0x00002cc4:
			return 0x2ab935b9;
		case 0x00002cc8:
			return 0x5db74177;
		case 0x00002ccc:
			return 0x41b8b834;
		case 0x00002cd0:
			return 0xd37f12d5;
		case 0x00002cd4:
			return 0x83d6c3f0;
		case 0x00002cd8:
			return 0x551c0bd0;
		case 0x00002cdc:
			return 0x9fa90a35;
		case 0x00002ce0:
			return 0x53b3a5e6;
		case 0x00002ce4:
			return 0x0cddea0c;
		case 0x00002ce8:
			return 0xb22dde08;
		case 0x00002cec:
			return 0x57c4e0d6;
		case 0x00002cf0:
			return 0xcf434644;
		case 0x00002cf4:
			return 0xe563a338;
		case 0x00002cf8:
			return 0x5bdcdd60;
		case 0x00002cfc:
			return 0x0e509ec6;
		case 0x00002d00:
			return 0x19157080;
		case 0x00002d04:
			return 0x05653bd3;
		case 0x00002d08:
			return 0xbe305c86;
		case 0x00002d0c:
			return 0xec581183;
		case 0x00002d10:
			return 0x7041730d;
		case 0x00002d14:
			return 0xdf9fcf30;
		case 0x00002d18:
			return 0xd38fdad7;
		case 0x00002d1c:
			return 0x1603d831;
		case 0x00002d20:
			return 0x50abe674;
		case 0x00002d24:
			return 0xb0623182;
		case 0x00002d28:
			return 0xd2403ff3;
		case 0x00002d2c:
			return 0x7a748537;
		case 0x00002d30:
			return 0x081c8cb0;
		case 0x00002d34:
			return 0xfa993923;
		case 0x00002d38:
			return 0x2a738e6c;
		case 0x00002d3c:
			return 0x0c407f7e;
		case 0x00002d40:
			return 0x9dbf61fa;
		case 0x00002d44:
			return 0xf46ed510;
		case 0x00002d48:
			return 0xbcfc786c;
		case 0x00002d4c:
			return 0xed0c1d46;
		case 0x00002d50:
			return 0x394c84cc;
		case 0x00002d54:
			return 0x632f3153;
		case 0x00002d58:
			return 0x29f4aaf7;
		case 0x00002d5c:
			return 0x8086601b;
		case 0x00002d60:
			return 0x9d409b61;
		case 0x00002d64:
			return 0x22af9eaf;
		case 0x00002d68:
			return 0xbe2e1b63;
		case 0x00002d6c:
			return 0xa0d0d1ae;
		case 0x00002d70:
			return 0xbee21bf7;
		case 0x00002d74:
			return 0x3fe35185;
		case 0x00002d78:
			return 0x06456479;
		case 0x00002d7c:
			return 0x696ce3a3;
		case 0x00002d80:
			return 0x944dc4f4;
		case 0x00002d84:
			return 0x9d615a8b;
		case 0x00002d88:
			return 0x247cd59f;
		case 0x00002d8c:
			return 0x127db255;
		case 0x00002d90:
			return 0xf04260fb;
		case 0x00002d94:
			return 0xe1ee721e;
		case 0x00002d98:
			return 0x0e8b8af9;
		case 0x00002d9c:
			return 0x1e2af0b0;
		case 0x00002da0:
			return 0x822e2233;
		case 0x00002da4:
			return 0xcde7b1c4;
		case 0x00002da8:
			return 0x769f6107;
		case 0x00002dac:
			return 0x0c68fe9a;
		case 0x00002db0:
			return 0xfb4bf557;
		case 0x00002db4:
			return 0x9a33609b;
		case 0x00002db8:
			return 0x4b48642d;
		case 0x00002dbc:
			return 0x43a33dab;
		case 0x00002dc0:
			return 0x3308bc57;
		case 0x00002dc4:
			return 0x9fc0a346;
		case 0x00002dc8:
			return 0x2b3fb8e9;
		case 0x00002dcc:
			return 0x06a202d5;
		case 0x00002dd0:
			return 0x8e9d4ebd;
		case 0x00002dd4:
			return 0xf5aa702a;
		case 0x00002dd8:
			return 0x2a55f3be;
		case 0x00002ddc:
			return 0xe0ccf652;
		case 0x00002de0:
			return 0x598e918d;
		case 0x00002de4:
			return 0x05ffc441;
		case 0x00002de8:
			return 0x680ecc61;
		case 0x00002dec:
			return 0xe366cda6;
		case 0x00002df0:
			return 0x6218cfed;
		case 0x00002df4:
			return 0xca13d7f5;
		case 0x00002df8:
			return 0x4651222a;
		case 0x00002dfc:
			return 0x2e8415b2;
		case 0x00002e00:
			return 0x0ee9fa8a;
		case 0x00002e04:
			return 0x5bfb6f81;
		case 0x00002e08:
			return 0x3a5ef7ae;
		case 0x00002e0c:
			return 0x19d28f8c;
		case 0x00002e10:
			return 0xf8594766;
		case 0x00002e14:
			return 0xd20e8170;
		case 0x00002e18:
			return 0x195e1b6b;
		case 0x00002e1c:
			return 0x34e29fcc;
		case 0x00002e20:
			return 0x67cd8938;
		case 0x00002e24:
			return 0x2bcd4f03;
		case 0x00002e28:
			return 0x88dbbc6c;
		case 0x00002e2c:
			return 0xd91327ed;
		case 0x00002e30:
			return 0x2db82ccd;
		case 0x00002e34:
			return 0x21593c7d;
		case 0x00002e38:
			return 0x21e6f026;
		case 0x00002e3c:
			return 0xd4af3f53;
		case 0x00002e40:
			return 0x57d5b54f;
		case 0x00002e44:
			return 0x6bfee4b3;
		case 0x00002e48:
			return 0xf96f8180;
		case 0x00002e4c:
			return 0xf94ad0c0;
		case 0x00002e50:
			return 0x44a261ad;
		case 0x00002e54:
			return 0x695fafe6;
		case 0x00002e58:
			return 0xdd784b7a;
		case 0x00002e5c:
			return 0xf5c5395f;
		case 0x00002e60:
			return 0x9433a8ea;
		case 0x00002e64:
			return 0x7b958000;
		case 0x00002e68:
			return 0xdc5e314a;
		case 0x00002e6c:
			return 0x0685f53c;
		case 0x00002e70:
			return 0x068e8183;
		case 0x00002e74:
			return 0x85010c6a;
		case 0x00002e78:
			return 0x1d4e7973;
		case 0x00002e7c:
			return 0xa11cee71;
		case 0x00002e80:
			return 0x908b9e70;
		case 0x00002e84:
			return 0x0a7be628;
		case 0x00002e88:
			return 0xfe17e770;
		case 0x00002e8c:
			return 0x562d7e64;
		case 0x00002e90:
			return 0x038dba84;
		case 0x00002e94:
			return 0xb09842cd;
		case 0x00002e98:
			return 0x0dfc01c7;
		case 0x00002e9c:
			return 0x2f2c0a7a;
		case 0x00002ea0:
			return 0xa1a0fc48;
		case 0x00002ea4:
			return 0x967587c8;
		case 0x00002ea8:
			return 0x45f45dc1;
		case 0x00002eac:
			return 0x1cf4bc4f;
		case 0x00002eb0:
			return 0x6bf98d8f;
		case 0x00002eb4:
			return 0x1d2d6393;
		case 0x00002eb8:
			return 0x29223322;
		case 0x00002ebc:
			return 0xdaf7ae5d;
		case 0x00002ec0:
			return 0x5aa0ab74;
		case 0x00002ec4:
			return 0x39bfb359;
		case 0x00002ec8:
			return 0xe519a813;
		case 0x00002ecc:
			return 0xbab36430;
		case 0x00002ed0:
			return 0xddecab5b;
		case 0x00002ed4:
			return 0xe1060255;
		case 0x00002ed8:
			return 0x4fb0a6dc;
		case 0x00002edc:
			return 0x598f932a;
		case 0x00002ee0:
			return 0x67c6db2b;
		case 0x00002ee4:
			return 0xc791d81d;
		case 0x00002ee8:
			return 0xef44c119;
		case 0x00002eec:
			return 0x2c1af213;
		case 0x00002ef0:
			return 0x094af88f;
		case 0x00002ef4:
			return 0xf18815a1;
		case 0x00002ef8:
			return 0x340a0ff5;
		case 0x00002efc:
			return 0xd196ea89;
		case 0x00002f00:
			return 0x025c02a9;
		case 0x00002f04:
			return 0xa6372bbd;
		case 0x00002f08:
			return 0xfe21e5de;
		case 0x00002f0c:
			return 0x1825fa76;
		case 0x00002f10:
			return 0xeb7f5d12;
		case 0x00002f14:
			return 0x0fc1afcd;
		case 0x00002f18:
			return 0x747aae2c;
		case 0x00002f1c:
			return 0xbf872fd8;
		case 0x00002f20:
			return 0x1bbe96a7;
		case 0x00002f24:
			return 0x204067d4;
		case 0x00002f28:
			return 0x3a2c8998;
		case 0x00002f2c:
			return 0x20d91222;
		case 0x00002f30:
			return 0x3d76ca09;
		case 0x00002f34:
			return 0x3161f35e;
		case 0x00002f38:
			return 0x34624600;
		case 0x00002f3c:
			return 0xb73f1ab9;
		case 0x00002f40:
			return 0x4095891b;
		case 0x00002f44:
			return 0x8494d2ce;
		case 0x00002f48:
			return 0xa6b7ec0c;
		case 0x00002f4c:
			return 0xc3ae3f74;
		case 0x00002f50:
			return 0xbd1263a8;
		case 0x00002f54:
			return 0xb00ed0f8;
		case 0x00002f58:
			return 0x309f438a;
		case 0x00002f5c:
			return 0x7321a222;
		case 0x00002f60:
			return 0xcec98b2e;
		case 0x00002f64:
			return 0x1dd7a0c0;
		case 0x00002f68:
			return 0xe9a44d31;
		case 0x00002f6c:
			return 0x5111383c;
		case 0x00002f70:
			return 0x362bf0a1;
		case 0x00002f74:
			return 0xfefb3281;
		case 0x00002f78:
			return 0x698ea3f3;
		case 0x00002f7c:
			return 0x9a7f675d;
		case 0x00002f80:
			return 0xf98dc9db;
		case 0x00002f84:
			return 0x78265872;
		case 0x00002f88:
			return 0xa36edf42;
		case 0x00002f8c:
			return 0xd54fdeee;
		case 0x00002f90:
			return 0x00a3daed;
		case 0x00002f94:
			return 0xcb7f0155;
		case 0x00002f98:
			return 0x9bfe3e2e;
		case 0x00002f9c:
			return 0x9f6faed7;
		case 0x00002fa0:
			return 0x33d0bbe8;
		case 0x00002fa4:
			return 0x8fd7d2cf;
		case 0x00002fa8:
			return 0xb209a0e4;
		case 0x00002fac:
			return 0x3ec718cd;
		case 0x00002fb0:
			return 0xc5855963;
		case 0x00002fb4:
			return 0x4647e087;
		case 0x00002fb8:
			return 0x7794ddb6;
		case 0x00002fbc:
			return 0xef5a0284;
		case 0x00002fc0:
			return 0x309b609a;
		case 0x00002fc4:
			return 0xac00adb9;
		case 0x00002fc8:
			return 0x73e93131;
		case 0x00002fcc:
			return 0x80d061ae;
		case 0x00002fd0:
			return 0x2948128a;
		case 0x00002fd4:
			return 0x919be6f2;
		case 0x00002fd8:
			return 0xf90c5b73;
		case 0x00002fdc:
			return 0x94342949;
		case 0x00002fe0:
			return 0x0daacdfb;
		case 0x00002fe4:
			return 0x68aab85d;
		case 0x00002fe8:
			return 0x82bb7468;
		case 0x00002fec:
			return 0x3f806035;
		case 0x00002ff0:
			return 0xf031f48f;
		case 0x00002ff4:
			return 0xbf6d8a22;
		case 0x00002ff8:
			return 0x0e526f0e;
		case 0x00002ffc:
			return 0x1983e26c;
		case 0x00003000:
			return 0x9c630c26;
		case 0x00003004:
			return 0x68190149;
		case 0x00003008:
			return 0x7a7a9321;
		case 0x0000300c:
			return 0xb12c1377;
		case 0x00003010:
			return 0x379e8bb3;
		case 0x00003014:
			return 0xe5cf06e6;
		case 0x00003018:
			return 0x3e45f7df;
		case 0x0000301c:
			return 0xde01aeb8;
		case 0x00003020:
			return 0xb1feb525;
		case 0x00003024:
			return 0x2213c41e;
		case 0x00003028:
			return 0x69237ded;
		case 0x0000302c:
			return 0x7b3a66ee;
		case 0x00003030:
			return 0x0126269e;
		case 0x00003034:
			return 0xbe25e40e;
		case 0x00003038:
			return 0x70b0576b;
		case 0x0000303c:
			return 0xd3afef4e;
		case 0x00003040:
			return 0x989084ae;
		case 0x00003044:
			return 0x856464e2;
		case 0x00003048:
			return 0xce9d021a;
		case 0x0000304c:
			return 0x1f956e20;
		case 0x00003050:
			return 0xf275babd;
		case 0x00003054:
			return 0x2d45b7a6;
		case 0x00003058:
			return 0xe61f3581;
		case 0x0000305c:
			return 0x99634e00;
		case 0x00003060:
			return 0x79d6c263;
		case 0x00003064:
			return 0x6a05b582;
		case 0x00003068:
			return 0x9c0cbc3a;
		case 0x0000306c:
			return 0x145b37b1;
		case 0x00003070:
			return 0xea0d8172;
		case 0x00003074:
			return 0x99e21409;
		case 0x00003078:
			return 0x69effafe;
		case 0x0000307c:
			return 0x15dca8e6;
		case 0x00003080:
			return 0x73f91026;
		case 0x00003084:
			return 0x0bb90bad;
		case 0x00003088:
			return 0x57cdc011;
		case 0x0000308c:
			return 0x9405f8bc;
		case 0x00003090:
			return 0x91620d3e;
		case 0x00003094:
			return 0x9a1e14c6;
		case 0x00003098:
			return 0x17541af9;
		case 0x0000309c:
			return 0xde4f33af;
		case 0x000030a0:
			return 0x62a21ef8;
		case 0x000030a4:
			return 0x5d0c97db;
		case 0x000030a8:
			return 0xc874f0ba;
		case 0x000030ac:
			return 0x1b6b13c1;
		case 0x000030b0:
			return 0x88e0edc0;
		case 0x000030b4:
			return 0xaccd1de1;
		case 0x000030b8:
			return 0xb2bcd37f;
		case 0x000030bc:
			return 0x60e409f1;
		case 0x000030c0:
			return 0x76ae5169;
		case 0x000030c4:
			return 0x966518c8;
		case 0x000030c8:
			return 0x64e8dde9;
		case 0x000030cc:
			return 0x884bed40;
		case 0x000030d0:
			return 0x26e5618d;
		case 0x000030d4:
			return 0xebc2a729;
		case 0x000030d8:
			return 0x1892be39;
		case 0x000030dc:
			return 0x96d03f5a;
		case 0x000030e0:
			return 0xcb5134f2;
		case 0x000030e4:
			return 0xc2f0ee7e;
		case 0x000030e8:
			return 0x8f11c8e8;
		case 0x000030ec:
			return 0x9d1b3453;
		case 0x000030f0:
			return 0xcfc4b7a5;
		case 0x000030f4:
			return 0x51b030c5;
		case 0x000030f8:
			return 0xa44402d3;
		case 0x000030fc:
			return 0xb7a400f9;
		case 0x00003100:
			return 0x1e0c9380;
		case 0x00003104:
			return 0x1b828b05;
		case 0x00003108:
			return 0x1fa8effa;
		case 0x0000310c:
			return 0x4fda0e9a;
		case 0x00003110:
			return 0x8b32c785;
		case 0x00003114:
			return 0x8efe4869;
		case 0x00003118:
			return 0xc6146a71;
		case 0x0000311c:
			return 0xe709e52f;
		case 0x00003120:
			return 0xbb6be3f2;
		case 0x00003124:
			return 0xbc56a047;
		case 0x00003128:
			return 0x06f85fb6;
		case 0x0000312c:
			return 0x731a5be9;
		case 0x00003130:
			return 0x1feea6f2;
		case 0x00003134:
			return 0x70f4e279;
		case 0x00003138:
			return 0x3fde5264;
		case 0x0000313c:
			return 0x5b367aae;
		case 0x00003140:
			return 0xb4142275;
		case 0x00003144:
			return 0xc7f09dc8;
		case 0x00003148:
			return 0x5be9796a;
		case 0x0000314c:
			return 0x89f4c028;
		case 0x00003150:
			return 0x66c0e80d;
		case 0x00003154:
			return 0x95baf6c8;
		case 0x00003158:
			return 0xa07e1ad3;
		case 0x0000315c:
			return 0xf8f7e437;
		case 0x00003160:
			return 0x4e9e8981;
		case 0x00003164:
			return 0x1a963cdd;
		case 0x00003168:
			return 0xb6a06dee;
		case 0x0000316c:
			return 0x2fd9778e;
		case 0x00003170:
			return 0xe5aee6a1;
		case 0x00003174:
			return 0xa0637ac4;
		case 0x00003178:
			return 0x8d6fb278;
		case 0x0000317c:
			return 0xc3e1fe4a;
		case 0x00003180:
			return 0xfbfa9661;
		case 0x00003184:
			return 0x7a5fe4d3;
		case 0x00003188:
			return 0x41b4ee41;
		case 0x0000318c:
			return 0x801bf660;
		case 0x00003190:
			return 0x5d0cb799;
		case 0x00003194:
			return 0xb7288fa5;
		case 0x00003198:
			return 0x95bcc1c4;
		case 0x0000319c:
			return 0x850103c4;
		case 0x000031a0:
			return 0x4ba2a62f;
		case 0x000031a4:
			return 0xc09417ad;
		case 0x000031a8:
			return 0x0cad04c6;
		case 0x000031ac:
			return 0xaa22d882;
		case 0x000031b0:
			return 0x8aa3f07b;
		case 0x000031b4:
			return 0x5e8004be;
		case 0x000031b8:
			return 0xdb8bf004;
		case 0x000031bc:
			return 0xc03e10a5;
		case 0x000031c0:
			return 0x71cc0363;
		case 0x000031c4:
			return 0x230c408e;
		case 0x000031c8:
			return 0x8efa6522;
		case 0x000031cc:
			return 0x6e5f0850;
		case 0x000031d0:
			return 0x1e826cf1;
		case 0x000031d4:
			return 0x6669a93c;
		case 0x000031d8:
			return 0x03fd6cce;
		case 0x000031dc:
			return 0x6f05e576;
		case 0x000031e0:
			return 0xb7ef88e8;
		case 0x000031e4:
			return 0xe02e1d47;
		case 0x000031e8:
			return 0x48c29446;
		case 0x000031ec:
			return 0x8df61553;
		case 0x000031f0:
			return 0xd66ebcb1;
		case 0x000031f4:
			return 0x79317efb;
		case 0x000031f8:
			return 0x7e0fcafd;
		case 0x000031fc:
			return 0x7ed6441e;
		case 0x00003200:
			return 0xe8800c1a;
		case 0x00003204:
			return 0x2d17abbb;
		case 0x00003208:
			return 0xce0f3ae8;
		case 0x0000320c:
			return 0x519ac699;
		case 0x00003210:
			return 0x2855db3e;
		case 0x00003214:
			return 0x45e17ed8;
		case 0x00003218:
			return 0x7fec17cb;
		case 0x0000321c:
			return 0xfc1a10a8;
		case 0x00003220:
			return 0x220b4786;
		case 0x00003224:
			return 0xef1663ac;
		case 0x00003228:
			return 0x8f1e980b;
		case 0x0000322c:
			return 0x1206cfc3;
		case 0x00003230:
			return 0x035469be;
		case 0x00003234:
			return 0x76e2b9f5;
		case 0x00003238:
			return 0x9b8632b5;
		case 0x0000323c:
			return 0x55803324;
		case 0x00003240:
			return 0xa3f28e65;
		case 0x00003244:
			return 0x8933fe8d;
		case 0x00003248:
			return 0x8618f62f;
		case 0x0000324c:
			return 0x63a72afa;
		case 0x00003250:
			return 0x3738e13a;
		case 0x00003254:
			return 0x0f9d8e99;
		case 0x00003258:
			return 0x001b0453;
		case 0x0000325c:
			return 0x87d06735;
		case 0x00003260:
			return 0x9ce56c50;
		case 0x00003264:
			return 0x1df03667;
		case 0x00003268:
			return 0xb00e45b0;
		case 0x0000326c:
			return 0x3435f00d;
		case 0x00003270:
			return 0x4d8bb2d2;
		case 0x00003274:
			return 0x4a2e55d9;
		case 0x00003278:
			return 0x74149ec0;
		case 0x0000327c:
			return 0x5111b1e3;
		case 0x00003280:
			return 0x89c70ead;
		case 0x00003284:
			return 0x51412217;
		case 0x00003288:
			return 0x13764795;
		case 0x0000328c:
			return 0x15d3efa6;
		case 0x00003290:
			return 0x9af4e80a;
		case 0x00003294:
			return 0xd6615a50;
		case 0x00003298:
			return 0xf00f20e9;
		case 0x0000329c:
			return 0xb7a861b5;
		case 0x000032a0:
			return 0xbe782699;
		case 0x000032a4:
			return 0x2774140f;
		case 0x000032a8:
			return 0x46f2795b;
		case 0x000032ac:
			return 0x6957826b;
		case 0x000032b0:
			return 0x33a2c2ce;
		case 0x000032b4:
			return 0x56eeab38;
		case 0x000032b8:
			return 0xb6acb123;
		case 0x000032bc:
			return 0x32b1bba1;
		case 0x000032c0:
			return 0x11c27034;
		case 0x000032c4:
			return 0x80868522;
		case 0x000032c8:
			return 0x410bcf8d;
		case 0x000032cc:
			return 0x031b92ab;
		case 0x000032d0:
			return 0xf5f69b5f;
		case 0x000032d4:
			return 0x01055add;
		case 0x000032d8:
			return 0x8407b436;
		case 0x000032dc:
			return 0xe5c2bc7c;
		case 0x000032e0:
			return 0xe17045cc;
		case 0x000032e4:
			return 0xb982d8fb;
		case 0x000032e8:
			return 0x196cfd8b;
		case 0x000032ec:
			return 0xcd803064;
		case 0x000032f0:
			return 0x266c77e0;
		case 0x000032f4:
			return 0x2dd0c20d;
		case 0x000032f8:
			return 0xbaf6ba58;
		case 0x000032fc:
			return 0x7c34c948;
		case 0x00003300:
			return 0xf33f9c0e;
		case 0x00003304:
			return 0x76b39e3c;
		case 0x00003308:
			return 0x737a16f4;
		case 0x0000330c:
			return 0xa5c5dcbc;
		case 0x00003310:
			return 0xdcb764af;
		case 0x00003314:
			return 0x0637ce58;
		case 0x00003318:
			return 0x02a42494;
		case 0x0000331c:
			return 0x15eb8694;
		case 0x00003320:
			return 0xe88c1094;
		case 0x00003324:
			return 0x09ff4f4b;
		case 0x00003328:
			return 0x6d78a890;
		case 0x0000332c:
			return 0xdf4468d3;
		case 0x00003330:
			return 0x27f59e29;
		case 0x00003334:
			return 0xd27d783c;
		case 0x00003338:
			return 0x571a12f5;
		case 0x0000333c:
			return 0xc7307fbb;
		case 0x00003340:
			return 0xc5461cc0;
		case 0x00003344:
			return 0x4abd0a34;
		case 0x00003348:
			return 0xa229a1d1;
		case 0x0000334c:
			return 0x0f786a57;
		case 0x00003350:
			return 0x69926e7a;
		case 0x00003354:
			return 0x95c8bb10;
		case 0x00003358:
			return 0x70db4186;
		case 0x0000335c:
			return 0x0620f335;
		case 0x00003360:
			return 0x76a3d211;
		case 0x00003364:
			return 0x34700d23;
		case 0x00003368:
			return 0x53d98d50;
		case 0x0000336c:
			return 0xe7ea51df;
		case 0x00003370:
			return 0xe719833d;
		case 0x00003374:
			return 0x9ba0396b;
		case 0x00003378:
			return 0x83fc7e5c;
		case 0x0000337c:
			return 0xe6133ec4;
		case 0x00003380:
			return 0x53003241;
		case 0x00003384:
			return 0x18df21c9;
		case 0x00003388:
			return 0xe189816f;
		case 0x0000338c:
			return 0xf494013b;
		case 0x00003390:
			return 0x8329759b;
		case 0x00003394:
			return 0x114206c3;
		case 0x00003398:
			return 0xd3163d26;
		case 0x0000339c:
			return 0xe238bc38;
		case 0x000033a0:
			return 0xdfdfb3ef;
		case 0x000033a4:
			return 0x610c1d3d;
		case 0x000033a8:
			return 0xd4d1cddb;
		case 0x000033ac:
			return 0x659cedea;
		case 0x000033b0:
			return 0xbb3da488;
		case 0x000033b4:
			return 0x7f27db85;
		case 0x000033b8:
			return 0x715f6c1b;
		case 0x000033bc:
			return 0x900dcd9e;
		case 0x000033c0:
			return 0x99e3d383;
		case 0x000033c4:
			return 0x12a7d423;
		case 0x000033c8:
			return 0xec3c0952;
		case 0x000033cc:
			return 0xc7982152;
		case 0x000033d0:
			return 0xfcda133f;
		case 0x000033d4:
			return 0x8ae008c3;
		case 0x000033d8:
			return 0x6e546d1a;
		case 0x000033dc:
			return 0x8392563f;
		case 0x000033e0:
			return 0x33cd452f;
		case 0x000033e4:
			return 0xa45e36cc;
		case 0x000033e8:
			return 0x1dc13426;
		case 0x000033ec:
			return 0x74767a1e;
		case 0x000033f0:
			return 0x4ba3a935;
		case 0x000033f4:
			return 0x4613420c;
		case 0x000033f8:
			return 0x693c9181;
		case 0x000033fc:
			return 0x920bfe3f;
		case 0x00003400:
			return 0x47838400;
		case 0x00003404:
			return 0x16c48971;
		case 0x00003408:
			return 0xd718df26;
		case 0x0000340c:
			return 0xa70b3594;
		case 0x00003410:
			return 0x99d32e0e;
		case 0x00003414:
			return 0x7c8dcb7c;
		case 0x00003418:
			return 0x19a52746;
		case 0x0000341c:
			return 0xc61027d8;
		case 0x00003420:
			return 0x11f04ae4;
		case 0x00003424:
			return 0x84369ef7;
		case 0x00003428:
			return 0x2b6e07e8;
		case 0x0000342c:
			return 0x76f0cce6;
		case 0x00003430:
			return 0x3c4a0aa6;
		case 0x00003434:
			return 0xa2b87b7f;
		case 0x00003438:
			return 0xf0319625;
		case 0x0000343c:
			return 0xd5c1bdcb;
		case 0x00003440:
			return 0xda741c29;
		case 0x00003444:
			return 0xbedf25df;
		case 0x00003448:
			return 0x13ffeed8;
		case 0x0000344c:
			return 0x1f77374c;
		case 0x00003450:
			return 0xf2d36e05;
		case 0x00003454:
			return 0x759f30f9;
		case 0x00003458:
			return 0xffc14d72;
		case 0x0000345c:
			return 0xd3fd4415;
		case 0x00003460:
			return 0x5a613011;
		case 0x00003464:
			return 0x0798f346;
		case 0x00003468:
			return 0xfacb27e4;
		case 0x0000346c:
			return 0xebb79757;
		case 0x00003470:
			return 0x6eb3f3b9;
		case 0x00003474:
			return 0x0cd75d95;
		case 0x00003478:
			return 0xb5d47e3b;
		case 0x0000347c:
			return 0x676e00d4;
		case 0x00003480:
			return 0x82f01596;
		case 0x00003484:
			return 0x579c007c;
		case 0x00003488:
			return 0xe7c82da9;
		case 0x0000348c:
			return 0x165341e5;
		case 0x00003490:
			return 0x49d57d04;
		case 0x00003494:
			return 0x9f7811d4;
		case 0x00003498:
			return 0x80008548;
		case 0x0000349c:
			return 0x3898c3b7;
		case 0x000034a0:
			return 0x86ef1eeb;
		case 0x000034a4:
			return 0x7224b24e;
		case 0x000034a8:
			return 0x41a39d3b;
		case 0x000034ac:
			return 0x45e8e0e9;
		case 0x000034b0:
			return 0x38050a63;
		case 0x000034b4:
			return 0x682f0823;
		case 0x000034b8:
			return 0x4b0000c2;
		case 0x000034bc:
			return 0x25e512a2;
		case 0x000034c0:
			return 0x35f88c11;
		case 0x000034c4:
			return 0x95fb33db;
		case 0x000034c8:
			return 0x71063490;
		case 0x000034cc:
			return 0x4f32d064;
		case 0x000034d0:
			return 0x19e8aae7;
		case 0x000034d4:
			return 0x01668a1b;
		case 0x000034d8:
			return 0xb6c17541;
		case 0x000034dc:
			return 0xdcc8d336;
		case 0x000034e0:
			return 0x2d9a8c51;
		case 0x000034e4:
			return 0xcffd2745;
		case 0x000034e8:
			return 0x17624973;
		case 0x000034ec:
			return 0x60f6124d;
		case 0x000034f0:
			return 0xc335c400;
		case 0x000034f4:
			return 0xd32c33a3;
		case 0x000034f8:
			return 0x6af133e3;
		case 0x000034fc:
			return 0x263f2523;
		case 0x00003500:
			return 0x6f34d1f6;
		case 0x00003504:
			return 0x8549fd23;
		case 0x00003508:
			return 0x61820ad7;
		case 0x0000350c:
			return 0x5dbef1c1;
		case 0x00003510:
			return 0x2b21c43d;
		case 0x00003514:
			return 0x33d1fcdd;
		case 0x00003518:
			return 0xd13f296e;
		case 0x0000351c:
			return 0x2b78d937;
		case 0x00003520:
			return 0x76d35d63;
		case 0x00003524:
			return 0xccf33c1c;
		case 0x00003528:
			return 0xaf71118d;
		case 0x0000352c:
			return 0x9fa8752c;
		case 0x00003530:
			return 0xa3bf6aa6;
		case 0x00003534:
			return 0x338b03fe;
		case 0x00003538:
			return 0xf70be1dd;
		case 0x0000353c:
			return 0x88f163f2;
		case 0x00003540:
			return 0xebb344e5;
		case 0x00003544:
			return 0xcf0e7e7d;
		case 0x00003548:
			return 0x6ddf7070;
		case 0x0000354c:
			return 0xc5edc942;
		case 0x00003550:
			return 0x9d9926d1;
		case 0x00003554:
			return 0xec8c066b;
		case 0x00003558:
			return 0x8ac745b8;
		case 0x0000355c:
			return 0xc655d9c9;
		case 0x00003560:
			return 0x6fe022c1;
		case 0x00003564:
			return 0xd2d364f9;
		case 0x00003568:
			return 0x709ab8b7;
		case 0x0000356c:
			return 0xdc358dbb;
		case 0x00003570:
			return 0x6fe6c19a;
		case 0x00003574:
			return 0x648a6c51;
		case 0x00003578:
			return 0x4352d4a1;
		case 0x0000357c:
			return 0xb06f959b;
		case 0x00003580:
			return 0xa7b2432a;
		case 0x00003584:
			return 0x26938373;
		case 0x00003588:
			return 0x37329afc;
		case 0x0000358c:
			return 0x2a89e1ca;
		case 0x00003590:
			return 0xc0c5e50c;
		case 0x00003594:
			return 0x011bc559;
		case 0x00003598:
			return 0x0dec266a;
		case 0x0000359c:
			return 0x5f697255;
		case 0x000035a0:
			return 0xc35050e9;
		case 0x000035a4:
			return 0x51ddb00e;
		case 0x000035a8:
			return 0x7555ce12;
		case 0x000035ac:
			return 0xa2f25717;
		case 0x000035b0:
			return 0x09f85286;
		case 0x000035b4:
			return 0x1438b65a;
		case 0x000035b8:
			return 0x26959df3;
		case 0x000035bc:
			return 0xa5b5d722;
		case 0x000035c0:
			return 0xf3f7a367;
		case 0x000035c4:
			return 0xcc59ccc9;
		case 0x000035c8:
			return 0x9a831b54;
		case 0x000035cc:
			return 0x21f94d72;
		case 0x000035d0:
			return 0x58d2f36d;
		case 0x000035d4:
			return 0xef38fd49;
		case 0x000035d8:
			return 0xb1e790f0;
		case 0x000035dc:
			return 0x4b452918;
		case 0x000035e0:
			return 0x2e9d1175;
		case 0x000035e4:
			return 0x04fe0cbb;
		case 0x000035e8:
			return 0x9c165964;
		case 0x000035ec:
			return 0x1aeecef7;
		case 0x000035f0:
			return 0x3efa41be;
		case 0x000035f4:
			return 0xcf3f1745;
		case 0x000035f8:
			return 0xae562002;
		case 0x000035fc:
			return 0xbb57c6b0;
		case 0x00003600:
			return 0x15fd5896;
		case 0x00003604:
			return 0xd4253034;
		case 0x00003608:
			return 0x38b559c7;
		case 0x0000360c:
			return 0xbaa08400;
		case 0x00003610:
			return 0xf2fc18db;
		case 0x00003614:
			return 0xca99d75c;
		case 0x00003618:
			return 0x474dc026;
		case 0x0000361c:
			return 0xa7924748;
		case 0x00003620:
			return 0x7d0077bc;
		case 0x00003624:
			return 0xd76f6909;
		case 0x00003628:
			return 0x934cbb40;
		case 0x0000362c:
			return 0x32205d0f;
		case 0x00003630:
			return 0xf15b8e7b;
		case 0x00003634:
			return 0x731a44c5;
		case 0x00003638:
			return 0xeff18e72;
		case 0x0000363c:
			return 0xa88a6e50;
		case 0x00003640:
			return 0x7404a642;
		case 0x00003644:
			return 0x6f0f4722;
		case 0x00003648:
			return 0x7bc49412;
		case 0x0000364c:
			return 0xcf76c371;
		case 0x00003650:
			return 0xd74bb7ec;
		case 0x00003654:
			return 0xa71ba7c6;
		case 0x00003658:
			return 0x2d7a96d2;
		case 0x0000365c:
			return 0xc053165f;
		case 0x00003660:
			return 0x3eb007ac;
		case 0x00003664:
			return 0xce6b3748;
		case 0x00003668:
			return 0x392a0a8c;
		case 0x0000366c:
			return 0xb4bab6d1;
		case 0x00003670:
			return 0xfafed534;
		case 0x00003674:
			return 0x441d6909;
		case 0x00003678:
			return 0xf89e8115;
		case 0x0000367c:
			return 0x28110901;
		case 0x00003680:
			return 0x9cfee56c;
		case 0x00003684:
			return 0xf61c8579;
		case 0x00003688:
			return 0x8f36117f;
		case 0x0000368c:
			return 0x8a31a9c6;
		case 0x00003690:
			return 0x58ecb45a;
		case 0x00003694:
			return 0xe9359ef0;
		case 0x00003698:
			return 0x577d299f;
		case 0x0000369c:
			return 0xb0c19195;
		case 0x000036a0:
			return 0x73ac3248;
		case 0x000036a4:
			return 0xab1508be;
		case 0x000036a8:
			return 0xefba77f1;
		case 0x000036ac:
			return 0xe33828cd;
		case 0x000036b0:
			return 0x9b598759;
		case 0x000036b4:
			return 0x5610ef14;
		case 0x000036b8:
			return 0x6a14717f;
		case 0x000036bc:
			return 0x43e40e3f;
		case 0x000036c0:
			return 0xdce85466;
		case 0x000036c4:
			return 0x68583bd4;
		case 0x000036c8:
			return 0xeb4d2007;
		case 0x000036cc:
			return 0xd8c88c94;
		case 0x000036d0:
			return 0xf52e94a5;
		case 0x000036d4:
			return 0xf95fda52;
		case 0x000036d8:
			return 0x92ba6142;
		case 0x000036dc:
			return 0x8fd22865;
		case 0x000036e0:
			return 0x0181976b;
		case 0x000036e4:
			return 0xbd476bbc;
		case 0x000036e8:
			return 0x65dcfa5f;
		case 0x000036ec:
			return 0xec936f75;
		case 0x000036f0:
			return 0x03ea35cf;
		case 0x000036f4:
			return 0x86e2d790;
		case 0x000036f8:
			return 0x61ae924e;
		case 0x000036fc:
			return 0x70f9df74;
		case 0x00003700:
			return 0x83382481;
		case 0x00003704:
			return 0x298e2484;
		case 0x00003708:
			return 0x37ccd68d;
		case 0x0000370c:
			return 0x0a05474e;
		case 0x00003710:
			return 0x788deb79;
		case 0x00003714:
			return 0x7a8985a1;
		case 0x00003718:
			return 0xc355e84f;
		case 0x0000371c:
			return 0xd7a857a2;
		case 0x00003720:
			return 0x5fd1c93c;
		case 0x00003724:
			return 0xfb382408;
		case 0x00003728:
			return 0x6e5c7129;
		case 0x0000372c:
			return 0xe56791bb;
		case 0x00003730:
			return 0x00018f79;
		case 0x00003734:
			return 0x9b5c4238;
		case 0x00003738:
			return 0x04ecce66;
		case 0x0000373c:
			return 0x7713137c;
		case 0x00003740:
			return 0xd2d153c6;
		case 0x00003744:
			return 0x46b858e2;
		case 0x00003748:
			return 0x0b8f4d5f;
		case 0x0000374c:
			return 0xe5ba4f2a;
		case 0x00003750:
			return 0x3d115e42;
		case 0x00003754:
			return 0x98682e31;
		case 0x00003758:
			return 0xe079e9c8;
		case 0x0000375c:
			return 0xd521b18d;
		case 0x00003760:
			return 0x7244e035;
		case 0x00003764:
			return 0xcad118d2;
		case 0x00003768:
			return 0x7ffebf78;
		case 0x0000376c:
			return 0xce3a48f4;
		case 0x00003770:
			return 0x3739b001;
		case 0x00003774:
			return 0x1f7b9b64;
		case 0x00003778:
			return 0xb34fcdad;
		case 0x0000377c:
			return 0xb44783de;
		case 0x00003780:
			return 0x4dae6b0f;
		case 0x00003784:
			return 0x40f542c5;
		case 0x00003788:
			return 0x462c9277;
		case 0x0000378c:
			return 0x6a4b1b6e;
		case 0x00003790:
			return 0x7846280f;
		case 0x00003794:
			return 0x58a853cb;
		case 0x00003798:
			return 0x0fb74c4c;
		case 0x0000379c:
			return 0x3386cfd3;
		case 0x000037a0:
			return 0x97d36136;
		case 0x000037a4:
			return 0x7edee189;
		case 0x000037a8:
			return 0x39d1b84b;
		case 0x000037ac:
			return 0x40ce2554;
		case 0x000037b0:
			return 0x80899c23;
		case 0x000037b4:
			return 0x0c565d71;
		case 0x000037b8:
			return 0xcc1f2db7;
		case 0x000037bc:
			return 0x5bd502fc;
		case 0x000037c0:
			return 0x9d5d6a35;
		case 0x000037c4:
			return 0x1b6d2876;
		case 0x000037c8:
			return 0x3221903d;
		case 0x000037cc:
			return 0xaa0b0b5e;
		case 0x000037d0:
			return 0x39ec007b;
		case 0x000037d4:
			return 0x491c1ad6;
		case 0x000037d8:
			return 0xd250b62f;
		case 0x000037dc:
			return 0x55bfaf0d;
		case 0x000037e0:
			return 0xb7edac6c;
		case 0x000037e4:
			return 0xd34324c9;
		case 0x000037e8:
			return 0xd9f88b9d;
		case 0x000037ec:
			return 0xc31f3c6d;
		case 0x000037f0:
			return 0x75c76aca;
		case 0x000037f4:
			return 0x8f08898e;
		case 0x000037f8:
			return 0x3932c54e;
		case 0x000037fc:
			return 0x6ccded08;
		case 0x00003800:
			return 0x90c666b1;
		case 0x00003804:
			return 0x1eea766d;
		case 0x00003808:
			return 0xbf4106aa;
		case 0x0000380c:
			return 0x63652439;
		case 0x00003810:
			return 0x87dae4f3;
		case 0x00003814:
			return 0x74b99cb9;
		case 0x00003818:
			return 0xbfe923e2;
		case 0x0000381c:
			return 0x3b395fc3;
		case 0x00003820:
			return 0x996d5e5c;
		case 0x00003824:
			return 0xfcb3622d;
		case 0x00003828:
			return 0x05bf1a84;
		case 0x0000382c:
			return 0xbc066738;
		case 0x00003830:
			return 0xf99e3096;
		case 0x00003834:
			return 0xc3844d2b;
		case 0x00003838:
			return 0x97639168;
		case 0x0000383c:
			return 0x3802e066;
		case 0x00003840:
			return 0xc9d08cbf;
		case 0x00003844:
			return 0x01efb0c0;
		case 0x00003848:
			return 0x62e873ca;
		case 0x0000384c:
			return 0x0de3bbb4;
		case 0x00003850:
			return 0x3a39aa0b;
		case 0x00003854:
			return 0x02015140;
		case 0x00003858:
			return 0x1b196a12;
		case 0x0000385c:
			return 0xaa02e751;
		case 0x00003860:
			return 0x0329c4fe;
		case 0x00003864:
			return 0xec8363dd;
		case 0x00003868:
			return 0x4ef014f6;
		case 0x0000386c:
			return 0x2eb4fe08;
		case 0x00003870:
			return 0x5aca1e9e;
		case 0x00003874:
			return 0x53956d0c;
		case 0x00003878:
			return 0x623ecd87;
		case 0x0000387c:
			return 0xd57d27c9;
		case 0x00003880:
			return 0xb3e55102;
		case 0x00003884:
			return 0x5fcc899b;
		case 0x00003888:
			return 0xbc707c14;
		case 0x0000388c:
			return 0x240f8960;
		case 0x00003890:
			return 0x758d30ae;
		case 0x00003894:
			return 0x7602d7a2;
		case 0x00003898:
			return 0xbd75f1bc;
		case 0x0000389c:
			return 0xa07a8330;
		case 0x000038a0:
			return 0xe2690df1;
		case 0x000038a4:
			return 0x460b023c;
		case 0x000038a8:
			return 0xa6628427;
		case 0x000038ac:
			return 0xe3e89700;
		case 0x000038b0:
			return 0x7c754b2e;
		case 0x000038b4:
			return 0xc67ca9e5;
		case 0x000038b8:
			return 0xafdb590a;
		case 0x000038bc:
			return 0x5b75e549;
		case 0x000038c0:
			return 0xfdcb208a;
		case 0x000038c4:
			return 0xbe0a9e3b;
		case 0x000038c8:
			return 0x6649b8a0;
		case 0x000038cc:
			return 0x51d709d1;
		case 0x000038d0:
			return 0xfeaa57b1;
		case 0x000038d4:
			return 0xcc9342f3;
		case 0x000038d8:
			return 0x246ee2fc;
		case 0x000038dc:
			return 0x7fec0118;
		case 0x000038e0:
			return 0x47bb65ec;
		case 0x000038e4:
			return 0x0a68e9d4;
		case 0x000038e8:
			return 0x6ed7dc5c;
		case 0x000038ec:
			return 0xb43b8824;
		case 0x000038f0:
			return 0xe48e12a6;
		case 0x000038f4:
			return 0x6824e9c1;
		case 0x000038f8:
			return 0x673cc33c;
		case 0x000038fc:
			return 0xe96ba8d7;
		case 0x00003900:
			return 0x2de78961;
		case 0x00003904:
			return 0x5f4b6208;
		case 0x00003908:
			return 0x93e93723;
		case 0x0000390c:
			return 0xffb8dfa9;
		case 0x00003910:
			return 0xc934d346;
		case 0x00003914:
			return 0xba0f8de4;
		case 0x00003918:
			return 0xa19a292e;
		case 0x0000391c:
			return 0xe6f33116;
		case 0x00003920:
			return 0xa3854cbb;
		case 0x00003924:
			return 0x2c4290dd;
		case 0x00003928:
			return 0x835c69bf;
		case 0x0000392c:
			return 0x7cdfbdfa;
		case 0x00003930:
			return 0x3208d9cd;
		case 0x00003934:
			return 0x25cad271;
		case 0x00003938:
			return 0x9e0ea7ee;
		case 0x0000393c:
			return 0x8c956bdc;
		case 0x00003940:
			return 0x26f155f6;
		case 0x00003944:
			return 0x493ec3ab;
		case 0x00003948:
			return 0x5bbd8e0a;
		case 0x0000394c:
			return 0x830c8c7b;
		case 0x00003950:
			return 0xec2c5363;
		case 0x00003954:
			return 0x59df2fb5;
		case 0x00003958:
			return 0xf84732b7;
		case 0x0000395c:
			return 0x8d732b09;
		case 0x00003960:
			return 0xb06264cc;
		case 0x00003964:
			return 0xedc2c3f3;
		case 0x00003968:
			return 0xee7cfcbc;
		case 0x0000396c:
			return 0x88c74673;
		case 0x00003970:
			return 0xc0ad3d03;
		case 0x00003974:
			return 0x2b19569c;
		case 0x00003978:
			return 0x1c7775bd;
		case 0x0000397c:
			return 0x956025d2;
		case 0x00003980:
			return 0x2609a252;
		case 0x00003984:
			return 0x56a5e6fd;
		case 0x00003988:
			return 0x17de0b9f;
		case 0x0000398c:
			return 0x491bd7e7;
		case 0x00003990:
			return 0xa8bf1247;
		case 0x00003994:
			return 0x343e01d4;
		case 0x00003998:
			return 0x5da02d85;
		case 0x0000399c:
			return 0xa81482e9;
		case 0x000039a0:
			return 0x40083ff1;
		case 0x000039a4:
			return 0x1278515c;
		case 0x000039a8:
			return 0x5c67348a;
		case 0x000039ac:
			return 0x61f4094c;
		case 0x000039b0:
			return 0x7baf7f4a;
		case 0x000039b4:
			return 0x6a356f44;
		case 0x000039b8:
			return 0xb11c8b4a;
		case 0x000039bc:
			return 0x6711cb9f;
		case 0x000039c0:
			return 0x7e9bd366;
		case 0x000039c4:
			return 0xe0e09e1e;
		case 0x000039c8:
			return 0xd7787f8f;
		case 0x000039cc:
			return 0x084854a1;
		case 0x000039d0:
			return 0x7fc84f93;
		case 0x000039d4:
			return 0xcb563817;
		case 0x000039d8:
			return 0x09c51b3a;
		case 0x000039dc:
			return 0x185bf0a0;
		case 0x000039e0:
			return 0x5c3fa7ff;
		case 0x000039e4:
			return 0x764f43fa;
		case 0x000039e8:
			return 0x0e02e788;
		case 0x000039ec:
			return 0x86946f70;
		case 0x000039f0:
			return 0x4511c5dc;
		case 0x000039f4:
			return 0x949f2a43;
		case 0x000039f8:
			return 0xdd566edf;
		case 0x000039fc:
			return 0x547a3484;
		case 0x00003a00:
			return 0x0e4a34bd;
		case 0x00003a04:
			return 0x71661a8b;
		case 0x00003a08:
			return 0xf400d850;
		case 0x00003a0c:
			return 0xca29b8bb;
		case 0x00003a10:
			return 0x7e1ce325;
		case 0x00003a14:
			return 0xbdc9aa3e;
		case 0x00003a18:
			return 0x0ae77956;
		case 0x00003a1c:
			return 0x46604f0d;
		case 0x00003a20:
			return 0x28c50464;
		case 0x00003a24:
			return 0x18518cb9;
		case 0x00003a28:
			return 0x215cb6f8;
		case 0x00003a2c:
			return 0xa27c7a37;
		case 0x00003a30:
			return 0xee40a978;
		case 0x00003a34:
			return 0xe642809d;
		case 0x00003a38:
			return 0xb557fd6a;
		case 0x00003a3c:
			return 0x4a49d33d;
		case 0x00003a40:
			return 0xd3e448b8;
		case 0x00003a44:
			return 0x507793e3;
		case 0x00003a48:
			return 0xaf84dcfb;
		case 0x00003a4c:
			return 0xdcddb1bb;
		case 0x00003a50:
			return 0x8b440f34;
		case 0x00003a54:
			return 0x9a114ded;
		case 0x00003a58:
			return 0x837092e9;
		case 0x00003a5c:
			return 0x73b221d7;
		case 0x00003a60:
			return 0xefe35200;
		case 0x00003a64:
			return 0xc9d1efe1;
		case 0x00003a68:
			return 0x076b15bf;
		case 0x00003a6c:
			return 0x18437912;
		case 0x00003a70:
			return 0xef69fcf4;
		case 0x00003a74:
			return 0x2ead13a3;
		case 0x00003a78:
			return 0xca0dac4f;
		case 0x00003a7c:
			return 0xd6e83ac6;
		case 0x00003a80:
			return 0xb8592edf;
		case 0x00003a84:
			return 0x2de22eeb;
		case 0x00003a88:
			return 0x08c5e5a3;
		case 0x00003a8c:
			return 0x3d5c802e;
		case 0x00003a90:
			return 0x2e74f4af;
		case 0x00003a94:
			return 0x4e51ef6b;
		case 0x00003a98:
			return 0x9a26b1dc;
		case 0x00003a9c:
			return 0x72fe076f;
		case 0x00003aa0:
			return 0xee4a63a8;
		case 0x00003aa4:
			return 0x855cdd6c;
		case 0x00003aa8:
			return 0xd4fd06db;
		case 0x00003aac:
			return 0x14c78458;
		case 0x00003ab0:
			return 0xb578fc43;
		case 0x00003ab4:
			return 0x2e1fb011;
		case 0x00003ab8:
			return 0x5653e6ef;
		case 0x00003abc:
			return 0x8bae77ae;
		case 0x00003ac0:
			return 0x45a40776;
		case 0x00003ac4:
			return 0x24e870d3;
		case 0x00003ac8:
			return 0xfdc4cfab;
		case 0x00003acc:
			return 0x702212d5;
		case 0x00003ad0:
			return 0x73a6025e;
		case 0x00003ad4:
			return 0xe3cc12b6;
		case 0x00003ad8:
			return 0x95922c0c;
		case 0x00003adc:
			return 0x130e32d5;
		case 0x00003ae0:
			return 0x8e9807b6;
		case 0x00003ae4:
			return 0x83e22537;
		case 0x00003ae8:
			return 0x250fe83d;
		case 0x00003aec:
			return 0xba179534;
		case 0x00003af0:
			return 0xbf493859;
		case 0x00003af4:
			return 0xfb4bc21c;
		case 0x00003af8:
			return 0xd8928424;
		case 0x00003afc:
			return 0x681a5ee9;
		case 0x00003b00:
			return 0x0b0ce946;
		case 0x00003b04:
			return 0x64d72625;
		case 0x00003b08:
			return 0xa28c217d;
		case 0x00003b0c:
			return 0xd13bbd34;
		case 0x00003b10:
			return 0x79197f55;
		case 0x00003b14:
			return 0x3a015cab;
		case 0x00003b18:
			return 0x7b95d44f;
		case 0x00003b1c:
			return 0xd4da88fa;
		case 0x00003b20:
			return 0xf0a47acb;
		case 0x00003b24:
			return 0xbf77168d;
		case 0x00003b28:
			return 0x69d11f98;
		case 0x00003b2c:
			return 0x06db1d8c;
		case 0x00003b30:
			return 0xf9610d83;
		case 0x00003b34:
			return 0x221ec287;
		case 0x00003b38:
			return 0x9cca7fe7;
		case 0x00003b3c:
			return 0x5314c72b;
		case 0x00003b40:
			return 0xc26a54e1;
		case 0x00003b44:
			return 0x22f81650;
		case 0x00003b48:
			return 0x139afcf4;
		case 0x00003b4c:
			return 0xdf3977b6;
		case 0x00003b50:
			return 0xb6d0bd2b;
		case 0x00003b54:
			return 0x2e45aa47;
		case 0x00003b58:
			return 0x8572fdbe;
		case 0x00003b5c:
			return 0x6752032a;
		case 0x00003b60:
			return 0xc286570b;
		case 0x00003b64:
			return 0x09bb0a77;
		case 0x00003b68:
			return 0x49f4e5c9;
		case 0x00003b6c:
			return 0xf6b9c89b;
		case 0x00003b70:
			return 0xc406c97b;
		case 0x00003b74:
			return 0x3ac2fcac;
		case 0x00003b78:
			return 0x02f5e333;
		case 0x00003b7c:
			return 0x53874a1f;
		case 0x00003b80:
			return 0x7d4ac776;
		case 0x00003b84:
			return 0x5f41f2d3;
		case 0x00003b88:
			return 0x1115f055;
		case 0x00003b8c:
			return 0xfba0f518;
		case 0x00003b90:
			return 0x2a5d5f51;
		case 0x00003b94:
			return 0x64e7555a;
		case 0x00003b98:
			return 0xd89b562f;
		case 0x00003b9c:
			return 0x8553817a;
		case 0x00003ba0:
			return 0xe42af543;
		case 0x00003ba4:
			return 0x91e59b87;
		case 0x00003ba8:
			return 0xb8ca8967;
		case 0x00003bac:
			return 0x3eb24a88;
		case 0x00003bb0:
			return 0x42abdc63;
		case 0x00003bb4:
			return 0x3d4337d2;
		case 0x00003bb8:
			return 0xd9d68bf4;
		case 0x00003bbc:
			return 0x54fa44f5;
		case 0x00003bc0:
			return 0xed1df273;
		case 0x00003bc4:
			return 0xbaea0f9a;
		case 0x00003bc8:
			return 0x9b15b589;
		case 0x00003bcc:
			return 0xaf0bda5d;
		case 0x00003bd0:
			return 0x3798fb19;
		case 0x00003bd4:
			return 0x815b1b72;
		case 0x00003bd8:
			return 0xae61b6da;
		case 0x00003bdc:
			return 0x78ae41d4;
		case 0x00003be0:
			return 0x9f45efd2;
		case 0x00003be4:
			return 0x0e35ee73;
		case 0x00003be8:
			return 0x3d2743e2;
		case 0x00003bec:
			return 0x1059275c;
		case 0x00003bf0:
			return 0x64a4e147;
		case 0x00003bf4:
			return 0x3155fe95;
		case 0x00003bf8:
			return 0xec09d9e9;
		case 0x00003bfc:
			return 0x2970f20d;
		case 0x00003c00:
			return 0xcf64e7b5;
		case 0x00003c04:
			return 0xf1d61ccd;
		case 0x00003c08:
			return 0xdfe54a82;
		case 0x00003c0c:
			return 0x76c69dc1;
		case 0x00003c10:
			return 0x4dfb7169;
		case 0x00003c14:
			return 0x09bf6732;
		case 0x00003c18:
			return 0xd5f95583;
		case 0x00003c1c:
			return 0x17c6337a;
		case 0x00003c20:
			return 0x563d947d;
		case 0x00003c24:
			return 0x8dcc0b09;
		case 0x00003c28:
			return 0x1415d444;
		case 0x00003c2c:
			return 0x6ce82c54;
		case 0x00003c30:
			return 0x01960a53;
		case 0x00003c34:
			return 0x1b2b89e8;
		case 0x00003c38:
			return 0x7b6fba91;
		case 0x00003c3c:
			return 0x1a82c66a;
		case 0x00003c40:
			return 0x69e679ed;
		case 0x00003c44:
			return 0x032fb63d;
		case 0x00003c48:
			return 0xfe56cf2e;
		case 0x00003c4c:
			return 0x7bf13f7e;
		case 0x00003c50:
			return 0xfe2469a9;
		case 0x00003c54:
			return 0x933ca04f;
		case 0x00003c58:
			return 0x322d074b;
		case 0x00003c5c:
			return 0xf27c2175;
		case 0x00003c60:
			return 0x70b0ccbf;
		case 0x00003c64:
			return 0x2430aa3c;
		case 0x00003c68:
			return 0x9276c20d;
		case 0x00003c6c:
			return 0xfa742abd;
		case 0x00003c70:
			return 0xad1f58d3;
		case 0x00003c74:
			return 0x029884be;
		case 0x00003c78:
			return 0xba9887e0;
		case 0x00003c7c:
			return 0x590f317b;
		case 0x00003c80:
			return 0x55a6f403;
		case 0x00003c84:
			return 0x464976b7;
		case 0x00003c88:
			return 0x849839d5;
		case 0x00003c8c:
			return 0x51b04dcb;
		case 0x00003c90:
			return 0xa1c0be29;
		case 0x00003c94:
			return 0x9f96ee5b;
		case 0x00003c98:
			return 0x2975d1b3;
		case 0x00003c9c:
			return 0xdf7f8784;
		case 0x00003ca0:
			return 0x23910a27;
		case 0x00003ca4:
			return 0x494e1dbe;
		case 0x00003ca8:
			return 0x697c125d;
		case 0x00003cac:
			return 0xa38aeb36;
		case 0x00003cb0:
			return 0x89e1cca8;
		case 0x00003cb4:
			return 0xc37edb65;
		case 0x00003cb8:
			return 0xc0391506;
		case 0x00003cbc:
			return 0x3746b7cf;
		case 0x00003cc0:
			return 0x5f72f605;
		case 0x00003cc4:
			return 0x3da2a2f2;
		case 0x00003cc8:
			return 0x154be745;
		case 0x00003ccc:
			return 0x851905ae;
		case 0x00003cd0:
			return 0xde6c3a41;
		case 0x00003cd4:
			return 0xd5574ab1;
		case 0x00003cd8:
			return 0x7541da9e;
		case 0x00003cdc:
			return 0xdae5d9fb;
		case 0x00003ce0:
			return 0x2208c8ef;
		case 0x00003ce4:
			return 0x135bf5aa;
		case 0x00003ce8:
			return 0xb553d782;
		case 0x00003cec:
			return 0xc04cdf21;
		case 0x00003cf0:
			return 0xb1816bf0;
		case 0x00003cf4:
			return 0x90a35a84;
		case 0x00003cf8:
			return 0x1c01cb80;
		case 0x00003cfc:
			return 0x8942e58b;
		case 0x00003d00:
			return 0x9229dfc6;
		case 0x00003d04:
			return 0xb9451aba;
		case 0x00003d08:
			return 0x2a2e4482;
		case 0x00003d0c:
			return 0x47831b4e;
		case 0x00003d10:
			return 0x91ff385d;
		case 0x00003d14:
			return 0xf219800c;
		case 0x00003d18:
			return 0x7b84d59a;
		case 0x00003d1c:
			return 0x6f0a227c;
		case 0x00003d20:
			return 0xcf7be443;
		case 0x00003d24:
			return 0xf7c2e278;
		case 0x00003d28:
			return 0x6aa8bba1;
		case 0x00003d2c:
			return 0xcf03e7bd;
		case 0x00003d30:
			return 0x6ba051ef;
		case 0x00003d34:
			return 0xda0c263b;
		case 0x00003d38:
			return 0x73efd86e;
		case 0x00003d3c:
			return 0x614aaeda;
		case 0x00003d40:
			return 0xa846f0eb;
		case 0x00003d44:
			return 0xa65e774d;
		case 0x00003d48:
			return 0x50448e07;
		case 0x00003d4c:
			return 0xc0cc66a9;
		case 0x00003d50:
			return 0xee0b1ac3;
		case 0x00003d54:
			return 0xfa277e63;
		case 0x00003d58:
			return 0x9e879014;
		case 0x00003d5c:
			return 0xe39f2978;
		case 0x00003d60:
			return 0xb81c7a31;
		case 0x00003d64:
			return 0x2023559d;
		case 0x00003d68:
			return 0xc9d62ac5;
		case 0x00003d6c:
			return 0x1e7e1a2a;
		case 0x00003d70:
			return 0xfbd47f31;
		case 0x00003d74:
			return 0xc108772c;
		case 0x00003d78:
			return 0x2c189aa0;
		case 0x00003d7c:
			return 0x73ee16e0;
		case 0x00003d80:
			return 0x366ca762;
		case 0x00003d84:
			return 0x67061445;
		case 0x00003d88:
			return 0xb4c22689;
		case 0x00003d8c:
			return 0x07d14ab4;
		case 0x00003d90:
			return 0xebf015ca;
		case 0x00003d94:
			return 0x5253aa9e;
		case 0x00003d98:
			return 0x0a208ffe;
		case 0x00003d9c:
			return 0x9dc52674;
		case 0x00003da0:
			return 0x5aa3d090;
		case 0x00003da4:
			return 0xbf979ff3;
		case 0x00003da8:
			return 0xb49a6261;
		case 0x00003dac:
			return 0xd752eb23;
		case 0x00003db0:
			return 0x0d80b764;
		case 0x00003db4:
			return 0x4c2b91a5;
		case 0x00003db8:
			return 0x8693f8a2;
		case 0x00003dbc:
			return 0x429d0e31;
		case 0x00003dc0:
			return 0x4aef2649;
		case 0x00003dc4:
			return 0xbd77b062;
		case 0x00003dc8:
			return 0xe949f0be;
		case 0x00003dcc:
			return 0x36f1bfe9;
		case 0x00003dd0:
			return 0x2a2f2c47;
		case 0x00003dd4:
			return 0xa4996d0e;
		case 0x00003dd8:
			return 0x2e07b3aa;
		case 0x00003ddc:
			return 0x21e203fe;
		case 0x00003de0:
			return 0x079d68c9;
		case 0x00003de4:
			return 0xd32c4ce5;
		case 0x00003de8:
			return 0xe0d17d16;
		case 0x00003dec:
			return 0x1e20e123;
		case 0x00003df0:
			return 0x3573c6f3;
		case 0x00003df4:
			return 0x4de3be5c;
		case 0x00003df8:
			return 0xecf4a687;
		case 0x00003dfc:
			return 0x5b17e6a4;
		case 0x00003e00:
			return 0xf1afd674;
		case 0x00003e04:
			return 0x4b5ae28a;
		case 0x00003e08:
			return 0xea93a576;
		case 0x00003e0c:
			return 0xafcffdca;
		case 0x00003e10:
			return 0xa273a08b;
		case 0x00003e14:
			return 0x20993372;
		case 0x00003e18:
			return 0x904fa34e;
		case 0x00003e1c:
			return 0xfc31d233;
		case 0x00003e20:
			return 0x210b4897;
		case 0x00003e24:
			return 0x25fdf7f0;
		case 0x00003e28:
			return 0x7546fd5a;
		case 0x00003e2c:
			return 0x3d43754d;
		case 0x00003e30:
			return 0xde8deb5f;
		case 0x00003e34:
			return 0xcc63d239;
		case 0x00003e38:
			return 0xc6bbd594;
		case 0x00003e3c:
			return 0x72c0a113;
		case 0x00003e40:
			return 0x594fc6e1;
		case 0x00003e44:
			return 0xa5c0f88c;
		case 0x00003e48:
			return 0xf1b9f6c6;
		case 0x00003e4c:
			return 0xba0f4934;
		case 0x00003e50:
			return 0x506dc3e5;
		case 0x00003e54:
			return 0x1ebfd2f2;
		case 0x00003e58:
			return 0x73540f1f;
		case 0x00003e5c:
			return 0x2961468f;
		case 0x00003e60:
			return 0xefec56ce;
		case 0x00003e64:
			return 0x2e728672;
		case 0x00003e68:
			return 0x3a7f0769;
		case 0x00003e6c:
			return 0x56f36f57;
		case 0x00003e70:
			return 0x62009eae;
		case 0x00003e74:
			return 0xd4626672;
		case 0x00003e78:
			return 0xc5a09fab;
		case 0x00003e7c:
			return 0x4722d16d;
		case 0x00003e80:
			return 0xa2a56cad;
		case 0x00003e84:
			return 0xa424f566;
		case 0x00003e88:
			return 0x9baa90f6;
		case 0x00003e8c:
			return 0x9a899de3;
		case 0x00003e90:
			return 0x58acdef0;
		case 0x00003e94:
			return 0xdc4b2e97;
		case 0x00003e98:
			return 0x040ddcca;
		case 0x00003e9c:
			return 0x50749b0f;
		case 0x00003ea0:
			return 0xcf09df55;
		case 0x00003ea4:
			return 0x57075ec6;
		case 0x00003ea8:
			return 0xae51d7f3;
		case 0x00003eac:
			return 0x1c165a2c;
		case 0x00003eb0:
			return 0xb199f1da;
		case 0x00003eb4:
			return 0xe6165c77;
		case 0x00003eb8:
			return 0xf29fb40a;
		case 0x00003ebc:
			return 0x8db2ac8d;
		case 0x00003ec0:
			return 0xad2f1ff3;
		case 0x00003ec4:
			return 0x027bcbe5;
		case 0x00003ec8:
			return 0x6665220e;
		case 0x00003ecc:
			return 0x12a089e6;
		case 0x00003ed0:
			return 0xb65977e2;
		case 0x00003ed4:
			return 0xd6a5592d;
		case 0x00003ed8:
			return 0x4c8cdeb4;
		case 0x00003edc:
			return 0x6f1890ca;
		case 0x00003ee0:
			return 0x6d20b5cf;
		case 0x00003ee4:
			return 0x991ee040;
		case 0x00003ee8:
			return 0x32c3b590;
		case 0x00003eec:
			return 0xeaa39d3b;
		case 0x00003ef0:
			return 0xdad4e30b;
		case 0x00003ef4:
			return 0x8f237090;
		case 0x00003ef8:
			return 0x145c36a9;
		case 0x00003efc:
			return 0x1f6f18fa;
		case 0x00003f00:
			return 0xf429ac2b;
		case 0x00003f04:
			return 0xb1a34e0f;
		case 0x00003f08:
			return 0xc2b367a4;
		case 0x00003f0c:
			return 0x45be77c6;
		case 0x00003f10:
			return 0x1b3a451f;
		case 0x00003f14:
			return 0x18e8723d;
		case 0x00003f18:
			return 0x5a43b231;
		case 0x00003f1c:
			return 0x4c70861a;
		case 0x00003f20:
			return 0x6d84d55b;
		case 0x00003f24:
			return 0xb2845ddf;
		case 0x00003f28:
			return 0x9392c991;
		case 0x00003f2c:
			return 0xdb28f053;
		case 0x00003f30:
			return 0xd18144a4;
		case 0x00003f34:
			return 0x91297a63;
		case 0x00003f38:
			return 0x8e101e5b;
		case 0x00003f3c:
			return 0xeecff3ed;
		case 0x00003f40:
			return 0xef8c2bdd;
		case 0x00003f44:
			return 0xeeaca2b8;
		case 0x00003f48:
			return 0x4b862a34;
		case 0x00003f4c:
			return 0x46449b86;
		case 0x00003f50:
			return 0x4573f4e7;
		case 0x00003f54:
			return 0x877428da;
		case 0x00003f58:
			return 0xe5708912;
		case 0x00003f5c:
			return 0xfdcf147b;
		case 0x00003f60:
			return 0x1ce3a508;
		case 0x00003f64:
			return 0xdb5c30c4;
		case 0x00003f68:
			return 0x51beb155;
		case 0x00003f6c:
			return 0xf1e1aba7;
		case 0x00003f70:
			return 0x27ac6af4;
		case 0x00003f74:
			return 0xd3ff41ec;
		case 0x00003f78:
			return 0x1d7fa0a2;
		case 0x00003f7c:
			return 0xca3d06e3;
		case 0x00003f80:
			return 0x2b4192b3;
		case 0x00003f84:
			return 0xcf081ae7;
		case 0x00003f88:
			return 0x52badd92;
		case 0x00003f8c:
			return 0x9961647c;
		case 0x00003f90:
			return 0xb5f6dc2e;
		case 0x00003f94:
			return 0x03dd05c9;
		case 0x00003f98:
			return 0xea8c5c0c;
		case 0x00003f9c:
			return 0xf21d36a2;
		case 0x00003fa0:
			return 0x58788aba;
		case 0x00003fa4:
			return 0xa78bd480;
		case 0x00003fa8:
			return 0x7ba1c2c1;
		case 0x00003fac:
			return 0xee791381;
		case 0x00003fb0:
			return 0x7ec2a7f3;
		case 0x00003fb4:
			return 0xcc18ba45;
		case 0x00003fb8:
			return 0x24211344;
		case 0x00003fbc:
			return 0x16ffe798;
		case 0x00003fc0:
			return 0x008da21d;
		case 0x00003fc4:
			return 0x3e09aa9c;
		case 0x00003fc8:
			return 0x50a80852;
		case 0x00003fcc:
			return 0xda5e209e;
		case 0x00003fd0:
			return 0x43e9ed2c;
		case 0x00003fd4:
			return 0x4bf1fcff;
		case 0x00003fd8:
			return 0xa6f40f54;
		case 0x00003fdc:
			return 0xe81d34ac;
		case 0x00003fe0:
			return 0x45436fd3;
		case 0x00003fe4:
			return 0x8e3d7da7;
		case 0x00003fe8:
			return 0x44d1a225;
		case 0x00003fec:
			return 0xad0c40eb;
		case 0x00003ff0:
			return 0xb3f0a484;
		case 0x00003ff4:
			return 0x2072a7a6;
		case 0x00003ff8:
			return 0x86dbccc8;
		case 0x00003ffc:
			return 0xce02ecc7;
		case 0x00004000:
			return 0xa57cba23;
		case 0x00004004:
			return 0x99ee46d9;
		case 0x00004008:
			return 0x6db7e83d;
		case 0x0000400c:
			return 0x19a69320;
		case 0x00004010:
			return 0xe35b2f7f;
		case 0x00004014:
			return 0x419227e3;
		case 0x00004018:
			return 0x17cc42cf;
		case 0x0000401c:
			return 0xe9da7fcd;
		case 0x00004020:
			return 0xe96d01e6;
		case 0x00004024:
			return 0x4e6666ff;
		case 0x00004028:
			return 0x2b8bdcfe;
		case 0x0000402c:
			return 0xb427d61e;
		case 0x00004030:
			return 0x509fee71;
		case 0x00004034:
			return 0x978417c8;
		case 0x00004038:
			return 0x0c2d7951;
		case 0x0000403c:
			return 0xf8239c72;
		case 0x00004040:
			return 0x049490bf;
		case 0x00004044:
			return 0xa2ac8e89;
		case 0x00004048:
			return 0x48934959;
		case 0x0000404c:
			return 0x04860e51;
		case 0x00004050:
			return 0x6927ec30;
		case 0x00004054:
			return 0x87471b99;
		case 0x00004058:
			return 0xdafb9abb;
		case 0x0000405c:
			return 0x8fd0e860;
		case 0x00004060:
			return 0x2eeb65b0;
		case 0x00004064:
			return 0x60167bb3;
		case 0x00004068:
			return 0x3a767dfb;
		case 0x0000406c:
			return 0x04af826a;
		case 0x00004070:
			return 0x4415cbc7;
		case 0x00004074:
			return 0xa5ef7d80;
		case 0x00004078:
			return 0xd970063c;
		case 0x0000407c:
			return 0x06173606;
		case 0x00004080:
			return 0xf1273f69;
		case 0x00004084:
			return 0x9cb8abbe;
		case 0x00004088:
			return 0xd2412638;
		case 0x0000408c:
			return 0x18b6065f;
		case 0x00004090:
			return 0x417e9311;
		case 0x00004094:
			return 0x57386f9a;
		case 0x00004098:
			return 0x69d398ed;
		case 0x0000409c:
			return 0x33ff9e56;
		case 0x000040a0:
			return 0x5993336e;
		case 0x000040a4:
			return 0xdff50b2b;
		case 0x000040a8:
			return 0xe0f070fa;
		case 0x000040ac:
			return 0xb0017c4d;
		case 0x000040b0:
			return 0xa2f5e943;
		case 0x000040b4:
			return 0xd707b253;
		case 0x000040b8:
			return 0x00955fab;
		case 0x000040bc:
			return 0xf3bf91c8;
		case 0x000040c0:
			return 0xcc8806a3;
		case 0x000040c4:
			return 0x2fba4f2b;
		case 0x000040c8:
			return 0x68e77897;
		case 0x000040cc:
			return 0xb2310c28;
		case 0x000040d0:
			return 0x048ad77a;
		case 0x000040d4:
			return 0xd2bb467d;
		case 0x000040d8:
			return 0xf9f484cb;
		case 0x000040dc:
			return 0xa9dba075;
		case 0x000040e0:
			return 0x34619603;
		case 0x000040e4:
			return 0x7de7f899;
		case 0x000040e8:
			return 0x678eaf04;
		case 0x000040ec:
			return 0xdac37b02;
		case 0x000040f0:
			return 0x34e0e627;
		case 0x000040f4:
			return 0x8fbd1de0;
		case 0x000040f8:
			return 0x5e223eb6;
		case 0x000040fc:
			return 0xe58e6541;
		case 0x00004100:
			return 0x1006ea77;
		case 0x00004104:
			return 0x06bf849c;
		case 0x00004108:
			return 0x2e92db62;
		case 0x0000410c:
			return 0x9dcb477c;
		case 0x00004110:
			return 0x2f6a5bda;
		case 0x00004114:
			return 0x0bf7f29d;
		case 0x00004118:
			return 0x4531ac83;
		case 0x0000411c:
			return 0x643a4aef;
		case 0x00004120:
			return 0xde822297;
		case 0x00004124:
			return 0x9b150906;
		case 0x00004128:
			return 0x2ea6566c;
		case 0x0000412c:
			return 0x31be70cd;
		case 0x00004130:
			return 0x69d25fe1;
		case 0x00004134:
			return 0x20eac1e2;
		case 0x00004138:
			return 0x461059b0;
		case 0x0000413c:
			return 0xde20836c;
		case 0x00004140:
			return 0x36d9c014;
		case 0x00004144:
			return 0x5a83c776;
		case 0x00004148:
			return 0x30173aaa;
		case 0x0000414c:
			return 0xec152f93;
		case 0x00004150:
			return 0xb6b6b886;
		case 0x00004154:
			return 0x158a7247;
		case 0x00004158:
			return 0x07c81797;
		case 0x0000415c:
			return 0x374a5cee;
		case 0x00004160:
			return 0x444f6aca;
		case 0x00004164:
			return 0x8eba8e79;
		case 0x00004168:
			return 0x63802ba9;
		case 0x0000416c:
			return 0x8d01df26;
		case 0x00004170:
			return 0x2d26bd4d;
		case 0x00004174:
			return 0xaf5d9c5c;
		case 0x00004178:
			return 0xfd8f558a;
		case 0x0000417c:
			return 0x9342286b;
		case 0x00004180:
			return 0xdf1201fc;
		case 0x00004184:
			return 0xb3dc02c2;
		case 0x00004188:
			return 0x1522a795;
		case 0x0000418c:
			return 0x09b07cdc;
		case 0x00004190:
			return 0x62c551c6;
		case 0x00004194:
			return 0x326aec87;
		case 0x00004198:
			return 0xcdf48355;
		case 0x0000419c:
			return 0xfa18014e;
		case 0x000041a0:
			return 0xe8fd2c4a;
		case 0x000041a4:
			return 0x2e56bba8;
		case 0x000041a8:
			return 0x74b90d71;
		case 0x000041ac:
			return 0x616cc0ab;
		case 0x000041b0:
			return 0xa1fb14a3;
		case 0x000041b4:
			return 0x260df89b;
		case 0x000041b8:
			return 0x59f7f5bc;
		case 0x000041bc:
			return 0x9a544a48;
		case 0x000041c0:
			return 0xff1c4bf3;
		case 0x000041c4:
			return 0xa9d80202;
		case 0x000041c8:
			return 0xb0916c25;
		case 0x000041cc:
			return 0x72c0ac63;
		case 0x000041d0:
			return 0xc0c77431;
		case 0x000041d4:
			return 0x2e8bf0f0;
		case 0x000041d8:
			return 0x549e9e24;
		case 0x000041dc:
			return 0xe42d845e;
		case 0x000041e0:
			return 0x4ae96ddf;
		case 0x000041e4:
			return 0x06380ae2;
		case 0x000041e8:
			return 0xf9952310;
		case 0x000041ec:
			return 0xd280b8b6;
		case 0x000041f0:
			return 0xc1008277;
		case 0x000041f4:
			return 0x52ba5b94;
		case 0x000041f8:
			return 0x1f0bed07;
		case 0x000041fc:
			return 0xf7a4266f;
		case 0x00004200:
			return 0x01089777;
		case 0x00004204:
			return 0x9d278968;
		case 0x00004208:
			return 0xa53e46db;
		case 0x0000420c:
			return 0xec8e6d15;
		case 0x00004210:
			return 0xffd1d555;
		case 0x00004214:
			return 0x1ce2e555;
		case 0x00004218:
			return 0x8042958c;
		case 0x0000421c:
			return 0xc69055cb;
		case 0x00004220:
			return 0xdff27857;
		case 0x00004224:
			return 0x0dc44563;
		case 0x00004228:
			return 0xb0469255;
		case 0x0000422c:
			return 0xa3474356;
		case 0x00004230:
			return 0xc9f63c71;
		case 0x00004234:
			return 0x9aabae69;
		case 0x00004238:
			return 0xf44348bc;
		case 0x0000423c:
			return 0x370350db;
		case 0x00004240:
			return 0xdc63e997;
		case 0x00004244:
			return 0xd60521dd;
		case 0x00004248:
			return 0x4093d4d0;
		case 0x0000424c:
			return 0x690b5abc;
		case 0x00004250:
			return 0x0ccccfb7;
		case 0x00004254:
			return 0x8f364cb0;
		case 0x00004258:
			return 0x0f6f312a;
		case 0x0000425c:
			return 0xd0e17f0b;
		case 0x00004260:
			return 0x9a27ef89;
		case 0x00004264:
			return 0x55a6c8e3;
		case 0x00004268:
			return 0xeb3657df;
		case 0x0000426c:
			return 0x089f2454;
		case 0x00004270:
			return 0x92921d61;
		case 0x00004274:
			return 0x2231c2cb;
		case 0x00004278:
			return 0x2c1a0c89;
		case 0x0000427c:
			return 0x4868e4d3;
		case 0x00004280:
			return 0x8f2fa335;
		case 0x00004284:
			return 0xc6e2e75f;
		case 0x00004288:
			return 0x33e8eb0a;
		case 0x0000428c:
			return 0xbf5cd5f1;
		case 0x00004290:
			return 0x75955be3;
		case 0x00004294:
			return 0x5c3e788f;
		case 0x00004298:
			return 0x90eff56f;
		case 0x0000429c:
			return 0xd29b5e5d;
		case 0x000042a0:
			return 0x8fba8bc3;
		case 0x000042a4:
			return 0x060db761;
		case 0x000042a8:
			return 0xd47fd172;
		case 0x000042ac:
			return 0x45813759;
		case 0x000042b0:
			return 0x53c12e7a;
		case 0x000042b4:
			return 0xffe52372;
		case 0x000042b8:
			return 0x84c5c82b;
		case 0x000042bc:
			return 0x610d8256;
		case 0x000042c0:
			return 0xd9fff7cf;
		case 0x000042c4:
			return 0xe2f50adf;
		case 0x000042c8:
			return 0x35c92d67;
		case 0x000042cc:
			return 0xbca14266;
		case 0x000042d0:
			return 0x99db9822;
		case 0x000042d4:
			return 0x0eb4378f;
		case 0x000042d8:
			return 0x563101a3;
		case 0x000042dc:
			return 0xa476cf88;
		case 0x000042e0:
			return 0x91d346e0;
		case 0x000042e4:
			return 0x54ec53bc;
		case 0x000042e8:
			return 0x6ea1059c;
		case 0x000042ec:
			return 0xd720d7b7;
		case 0x000042f0:
			return 0x5b828a1c;
		case 0x000042f4:
			return 0x7251c222;
		case 0x000042f8:
			return 0xb3a28f91;
		case 0x000042fc:
			return 0xa4ed106e;
		case 0x00004300:
			return 0xf0fc0026;
		case 0x00004304:
			return 0x111fa97b;
		case 0x00004308:
			return 0xe2f0ca7b;
		case 0x0000430c:
			return 0x3b13e58c;
		case 0x00004310:
			return 0x7fcce6c2;
		case 0x00004314:
			return 0x01f7a587;
		case 0x00004318:
			return 0x8a89bc5d;
		case 0x0000431c:
			return 0xed5fa336;
		case 0x00004320:
			return 0xd19894c8;
		case 0x00004324:
			return 0xbdd741b0;
		case 0x00004328:
			return 0x17290791;
		case 0x0000432c:
			return 0xd8a22462;
		case 0x00004330:
			return 0x2496cfe2;
		case 0x00004334:
			return 0xa2cb8dbc;
		case 0x00004338:
			return 0x98b6b5cc;
		case 0x0000433c:
			return 0xa8eb81fe;
		case 0x00004340:
			return 0x6c18d18b;
		case 0x00004344:
			return 0x1506af5c;
		case 0x00004348:
			return 0x8ee0da4e;
		case 0x0000434c:
			return 0xd6b22fef;
		case 0x00004350:
			return 0xd4a37613;
		case 0x00004354:
			return 0xdd4b5716;
		case 0x00004358:
			return 0x895b6857;
		case 0x0000435c:
			return 0xe38464bf;
		case 0x00004360:
			return 0x86e1abd6;
		case 0x00004364:
			return 0xdd328e4f;
		case 0x00004368:
			return 0x220aa71a;
		case 0x0000436c:
			return 0x079a66b7;
		case 0x00004370:
			return 0xebc913cc;
		case 0x00004374:
			return 0x0c7e27ee;
		case 0x00004378:
			return 0x7c3fbd8a;
		case 0x0000437c:
			return 0xe2cd4f7a;
		case 0x00004380:
			return 0xb912ef08;
		case 0x00004384:
			return 0x99935837;
		case 0x00004388:
			return 0xc3d18655;
		case 0x0000438c:
			return 0x83ccfc8e;
		case 0x00004390:
			return 0xfd0e8fc9;
		case 0x00004394:
			return 0xcbc88e36;
		case 0x00004398:
			return 0xacbfd92c;
		case 0x0000439c:
			return 0x6b0bc14e;
		case 0x000043a0:
			return 0x5922fb3a;
		case 0x000043a4:
			return 0x83fde0a0;
		case 0x000043a8:
			return 0xbe9adbae;
		case 0x000043ac:
			return 0xa46a0803;
		case 0x000043b0:
			return 0xb6ef7769;
		case 0x000043b4:
			return 0xa88196fe;
		case 0x000043b8:
			return 0xbbf5101f;
		case 0x000043bc:
			return 0x57629972;
		case 0x000043c0:
			return 0xf7994bf9;
		case 0x000043c4:
			return 0xaf3b2a67;
		case 0x000043c8:
			return 0x70416310;
		case 0x000043cc:
			return 0x18e400e2;
		case 0x000043d0:
			return 0xbfa9931c;
		case 0x000043d4:
			return 0xdce0e4b3;
		case 0x000043d8:
			return 0xfb7d092c;
		case 0x000043dc:
			return 0xdfc58edc;
		case 0x000043e0:
			return 0x9eb83426;
		case 0x000043e4:
			return 0xc0e2e2bf;
		case 0x000043e8:
			return 0xde9dafb2;
		case 0x000043ec:
			return 0xaa01954d;
		case 0x000043f0:
			return 0xf3967b7f;
		case 0x000043f4:
			return 0x4fb93c58;
		case 0x000043f8:
			return 0x87888e53;
		case 0x000043fc:
			return 0x4be23a63;
		case 0x00004400:
			return 0x65a72d7b;
		case 0x00004404:
			return 0x88ab4fa3;
		case 0x00004408:
			return 0xa3a9c328;
		case 0x0000440c:
			return 0x0039ff91;
		case 0x00004410:
			return 0xad3ac4da;
		case 0x00004414:
			return 0x62519064;
		case 0x00004418:
			return 0x3186cd8a;
		case 0x0000441c:
			return 0xc2795dde;
		case 0x00004420:
			return 0x9d7a38a1;
		case 0x00004424:
			return 0xfed81ade;
		case 0x00004428:
			return 0xdc968002;
		case 0x0000442c:
			return 0x42e4c61f;
		case 0x00004430:
			return 0x584ef9f7;
		case 0x00004434:
			return 0x77fa1072;
		case 0x00004438:
			return 0x8acfa82c;
		case 0x0000443c:
			return 0x87b28b26;
		case 0x00004440:
			return 0x09ef39ed;
		case 0x00004444:
			return 0xfd8564c6;
		case 0x00004448:
			return 0xf3db38bf;
		case 0x0000444c:
			return 0xbb966c64;
		case 0x00004450:
			return 0x7f78501d;
		case 0x00004454:
			return 0xec51e96b;
		case 0x00004458:
			return 0xc49a9713;
		case 0x0000445c:
			return 0x23288e22;
		case 0x00004460:
			return 0x397b0f29;
		case 0x00004464:
			return 0xd3fa5d49;
		case 0x00004468:
			return 0xb6440197;
		case 0x0000446c:
			return 0x2181b3ee;
		case 0x00004470:
			return 0x2afc7488;
		case 0x00004474:
			return 0xd55a5094;
		case 0x00004478:
			return 0x8fbeba57;
		case 0x0000447c:
			return 0xbd151313;
		case 0x00004480:
			return 0x533d71c8;
		case 0x00004484:
			return 0x2185be82;
		case 0x00004488:
			return 0x6470e3a8;
		case 0x0000448c:
			return 0xfa1305c4;
		case 0x00004490:
			return 0xe7362afd;
		case 0x00004494:
			return 0xd536721b;
		case 0x00004498:
			return 0xbad37183;
		case 0x0000449c:
			return 0xd2e4e3c2;
		case 0x000044a0:
			return 0xa6f125af;
		case 0x000044a4:
			return 0x19a381ec;
		case 0x000044a8:
			return 0x732ea6be;
		case 0x000044ac:
			return 0x04a6e251;
		case 0x000044b0:
			return 0x89ab6126;
		case 0x000044b4:
			return 0x1d007f7f;
		case 0x000044b8:
			return 0xd7c8f64c;
		case 0x000044bc:
			return 0x87ad0e5d;
		case 0x000044c0:
			return 0x8f965f4b;
		case 0x000044c4:
			return 0x97794e6c;
		case 0x000044c8:
			return 0xfe5359c3;
		case 0x000044cc:
			return 0xb9e0b3b8;
		case 0x000044d0:
			return 0xa8570c09;
		case 0x000044d4:
			return 0x6af20468;
		case 0x000044d8:
			return 0x258f887d;
		case 0x000044dc:
			return 0xf4667e18;
		case 0x000044e0:
			return 0x804d8806;
		case 0x000044e4:
			return 0xe83205c5;
		case 0x000044e8:
			return 0x43064b8f;
		case 0x000044ec:
			return 0x126686b5;
		case 0x000044f0:
			return 0xfd043d6c;
		case 0x000044f4:
			return 0x2c63f740;
		case 0x000044f8:
			return 0x84a18a30;
		case 0x000044fc:
			return 0x8d6361a2;
		case 0x00004500:
			return 0x6c123120;
		case 0x00004504:
			return 0xa1fc5fbb;
		case 0x00004508:
			return 0x5bc5e4ed;
		case 0x0000450c:
			return 0xb76c2385;
		case 0x00004510:
			return 0x9695e2d6;
		case 0x00004514:
			return 0x2311e112;
		case 0x00004518:
			return 0x131c6dd9;
		case 0x0000451c:
			return 0x03067b33;
		case 0x00004520:
			return 0x64d111f4;
		case 0x00004524:
			return 0x8296d8d2;
		case 0x00004528:
			return 0x1ac3cf90;
		case 0x0000452c:
			return 0xde98b969;
		case 0x00004530:
			return 0x46de3155;
		case 0x00004534:
			return 0x946d68c9;
		case 0x00004538:
			return 0x019590b6;
		case 0x0000453c:
			return 0xa1cde058;
		case 0x00004540:
			return 0x1f9ea6d6;
		case 0x00004544:
			return 0x1ce7cd9c;
		case 0x00004548:
			return 0xf758deef;
		case 0x0000454c:
			return 0xd5d325f9;
		case 0x00004550:
			return 0x15970a62;
		case 0x00004554:
			return 0xbf4ee593;
		case 0x00004558:
			return 0xd3ae8144;
		case 0x0000455c:
			return 0xf846d4d1;
		case 0x00004560:
			return 0x35ed1ec4;
		case 0x00004564:
			return 0x225adfb6;
		case 0x00004568:
			return 0x2458eb0e;
		case 0x0000456c:
			return 0xa77291c9;
		case 0x00004570:
			return 0xf9cb4edc;
		case 0x00004574:
			return 0xcf620eaf;
		case 0x00004578:
			return 0x18da6e8c;
		case 0x0000457c:
			return 0x4cb1ed83;
		case 0x00004580:
			return 0x116ffd1e;
		case 0x00004584:
			return 0x6f1a971e;
		case 0x00004588:
			return 0x4784f223;
		case 0x0000458c:
			return 0xbed7fba1;
		case 0x00004590:
			return 0x52dfae9c;
		case 0x00004594:
			return 0xde0e77e6;
		case 0x00004598:
			return 0xd5bced4e;
		case 0x0000459c:
			return 0x4ee377ff;
		case 0x000045a0:
			return 0x0b9711f7;
		case 0x000045a4:
			return 0xef1a841b;
		case 0x000045a8:
			return 0x6af2bfb4;
		case 0x000045ac:
			return 0x69c45acb;
		case 0x000045b0:
			return 0xa6989023;
		case 0x000045b4:
			return 0x66cff11e;
		case 0x000045b8:
			return 0x92c487a5;
		case 0x000045bc:
			return 0xf1e3463c;
		case 0x000045c0:
			return 0xa736b2a1;
		case 0x000045c4:
			return 0xb13aaa09;
		case 0x000045c8:
			return 0x4c4e6e1f;
		case 0x000045cc:
			return 0x457e32cc;
		case 0x000045d0:
			return 0x7c070c3c;
		case 0x000045d4:
			return 0x8d01bb25;
		case 0x000045d8:
			return 0xa942a063;
		case 0x000045dc:
			return 0x3e309c15;
		case 0x000045e0:
			return 0x81463c31;
		case 0x000045e4:
			return 0x462bc84f;
		case 0x000045e8:
			return 0x58b3ecb8;
		case 0x000045ec:
			return 0x4891883e;
		case 0x000045f0:
			return 0xbc2cb183;
		case 0x000045f4:
			return 0x44d4382c;
		case 0x000045f8:
			return 0x192c4f0e;
		case 0x000045fc:
			return 0x7e2d1875;
		case 0x00004600:
			return 0xce2e89ee;
		case 0x00004604:
			return 0xcdfea86b;
		case 0x00004608:
			return 0xc6850075;
		case 0x0000460c:
			return 0x17b3ee66;
		case 0x00004610:
			return 0x49025a61;
		case 0x00004614:
			return 0x02c64448;
		case 0x00004618:
			return 0xf7d87f92;
		case 0x0000461c:
			return 0x1224f74c;
		case 0x00004620:
			return 0x7cdeaa75;
		case 0x00004624:
			return 0x73edf4e2;
		case 0x00004628:
			return 0xa41085dc;
		case 0x0000462c:
			return 0x37e872ff;
		case 0x00004630:
			return 0x4ddad985;
		case 0x00004634:
			return 0x9e8069a7;
		case 0x00004638:
			return 0x5aa51b09;
		case 0x0000463c:
			return 0xb88ac57a;
		case 0x00004640:
			return 0x117e15eb;
		case 0x00004644:
			return 0x912f5bfc;
		case 0x00004648:
			return 0x818cc575;
		case 0x0000464c:
			return 0xdea807c1;
		case 0x00004650:
			return 0x52269e31;
		case 0x00004654:
			return 0x8f4c6ca7;
		case 0x00004658:
			return 0x4dbf063c;
		case 0x0000465c:
			return 0x2fe5d667;
		case 0x00004660:
			return 0x8a12bbee;
		case 0x00004664:
			return 0xc62730a1;
		case 0x00004668:
			return 0x112eba2d;
		case 0x0000466c:
			return 0x3943fcb3;
		case 0x00004670:
			return 0x7ab871c3;
		case 0x00004674:
			return 0x9862d7f6;
		case 0x00004678:
			return 0x438a356c;
		case 0x0000467c:
			return 0xc8f9bea4;
		case 0x00004680:
			return 0x73471db1;
		case 0x00004684:
			return 0x78b0d121;
		case 0x00004688:
			return 0x093c8ff3;
		case 0x0000468c:
			return 0x4c8f935f;
		case 0x00004690:
			return 0x70159dac;
		case 0x00004694:
			return 0xea0e8c6d;
		case 0x00004698:
			return 0x90cee545;
		case 0x0000469c:
			return 0xe87866c9;
		case 0x000046a0:
			return 0x77cdc58a;
		case 0x000046a4:
			return 0xced00cf1;
		case 0x000046a8:
			return 0xc7879c5c;
		case 0x000046ac:
			return 0x3973f92f;
		case 0x000046b0:
			return 0x75ba6d0b;
		case 0x000046b4:
			return 0x37208ba8;
		case 0x000046b8:
			return 0xdfe6f950;
		case 0x000046bc:
			return 0xfef43540;
		case 0x000046c0:
			return 0x1c2acedf;
		case 0x000046c4:
			return 0xc47dfdb3;
		case 0x000046c8:
			return 0x72fcd6ba;
		case 0x000046cc:
			return 0x4803e1b3;
		case 0x000046d0:
			return 0xa0e8e5cf;
		case 0x000046d4:
			return 0x0e2d99e1;
		case 0x000046d8:
			return 0x7a567efa;
		case 0x000046dc:
			return 0xda722db8;
		case 0x000046e0:
			return 0x1221c9ae;
		case 0x000046e4:
			return 0xba6aa7ab;
		case 0x000046e8:
			return 0x6204f0be;
		case 0x000046ec:
			return 0x60c71662;
		case 0x000046f0:
			return 0x9717d59f;
		case 0x000046f4:
			return 0x6c46ad2d;
		case 0x000046f8:
			return 0xbbc28fef;
		case 0x000046fc:
			return 0x933615a3;
		case 0x00004700:
			return 0x20291427;
		case 0x00004704:
			return 0x7a1dfbaf;
		case 0x00004708:
			return 0xc90274d0;
		case 0x0000470c:
			return 0x51c3f206;
		case 0x00004710:
			return 0xdf22f5ac;
		case 0x00004714:
			return 0xccc1c054;
		case 0x00004718:
			return 0xe03219bc;
		case 0x0000471c:
			return 0xd61cb1a8;
		case 0x00004720:
			return 0xf5b2b5dc;
		case 0x00004724:
			return 0xa937f837;
		case 0x00004728:
			return 0xe1e36799;
		case 0x0000472c:
			return 0x56307f07;
		case 0x00004730:
			return 0x8bb8505b;
		case 0x00004734:
			return 0x0b809c4c;
		case 0x00004738:
			return 0xcb716f5c;
		case 0x0000473c:
			return 0x718904fe;
		case 0x00004740:
			return 0xa9a936b2;
		case 0x00004744:
			return 0xa037ca19;
		case 0x00004748:
			return 0xca6a211b;
		case 0x0000474c:
			return 0x99d9113c;
		case 0x00004750:
			return 0x6ebf05c4;
		case 0x00004754:
			return 0xb067259e;
		case 0x00004758:
			return 0x19b67e3e;
		case 0x0000475c:
			return 0xd3fbc398;
		case 0x00004760:
			return 0x91f27c24;
		case 0x00004764:
			return 0x91c52098;
		case 0x00004768:
			return 0x0d33baca;
		case 0x0000476c:
			return 0x43b0ec9f;
		case 0x00004770:
			return 0x4ed058f3;
		case 0x00004774:
			return 0x0e0a573c;
		case 0x00004778:
			return 0x26b8e270;
		case 0x0000477c:
			return 0x462cdbe5;
		case 0x00004780:
			return 0x49d96a19;
		case 0x00004784:
			return 0x495e8fd0;
		case 0x00004788:
			return 0xf0325963;
		case 0x0000478c:
			return 0xa9511f70;
		case 0x00004790:
			return 0x92521c9c;
		case 0x00004794:
			return 0x01a127e4;
		case 0x00004798:
			return 0x50fece1f;
		case 0x0000479c:
			return 0x04634893;
		case 0x000047a0:
			return 0xa5d3c37a;
		case 0x000047a4:
			return 0x60f11f95;
		case 0x000047a8:
			return 0x1a966869;
		case 0x000047ac:
			return 0x4711faee;
		case 0x000047b0:
			return 0x4b66c609;
		case 0x000047b4:
			return 0xf465ec31;
		case 0x000047b8:
			return 0x543b6e3d;
		case 0x000047bc:
			return 0xa6d6b48f;
		case 0x000047c0:
			return 0x2d6d281b;
		case 0x000047c4:
			return 0x002e5926;
		case 0x000047c8:
			return 0x3f75e425;
		case 0x000047cc:
			return 0xa125f68d;
		case 0x000047d0:
			return 0xc7ba5bdd;
		case 0x000047d4:
			return 0xc314163d;
		case 0x000047d8:
			return 0x16f656f0;
		case 0x000047dc:
			return 0xa16ac8cd;
		case 0x000047e0:
			return 0x0732729d;
		case 0x000047e4:
			return 0x42bc64a2;
		case 0x000047e8:
			return 0xfc5fb062;
		case 0x000047ec:
			return 0x36206215;
		case 0x000047f0:
			return 0x9ff7743a;
		case 0x000047f4:
			return 0xbd9185a2;
		case 0x000047f8:
			return 0xc81d91a3;
		case 0x000047fc:
			return 0xfdc58981;
		case 0x00004800:
			return 0xf6f68bf0;
		case 0x00004804:
			return 0x045914ac;
		case 0x00004808:
			return 0xed6de959;
		case 0x0000480c:
			return 0xf551047d;
		case 0x00004810:
			return 0x1d4b3849;
		case 0x00004814:
			return 0x767f3fc6;
		case 0x00004818:
			return 0x3ad717bf;
		case 0x0000481c:
			return 0x8b84fc37;
		case 0x00004820:
			return 0x6f9c87bd;
		case 0x00004824:
			return 0x4161de05;
		case 0x00004828:
			return 0x758ca7d8;
		case 0x0000482c:
			return 0x96ec9c3f;
		case 0x00004830:
			return 0xf3b858b0;
		case 0x00004834:
			return 0x3f9c4f6b;
		case 0x00004838:
			return 0x1c99a65d;
		case 0x0000483c:
			return 0x2ffdba68;
		case 0x00004840:
			return 0x60567c51;
		case 0x00004844:
			return 0x74e7b1be;
		case 0x00004848:
			return 0x2eaaeaa9;
		case 0x0000484c:
			return 0xd0b0f316;
		case 0x00004850:
			return 0xd6493ab2;
		case 0x00004854:
			return 0xb48a9769;
		case 0x00004858:
			return 0x109dc462;
		case 0x0000485c:
			return 0x51029ba8;
		case 0x00004860:
			return 0xbae78be6;
		case 0x00004864:
			return 0x082f651f;
		case 0x00004868:
			return 0x384a205b;
		case 0x0000486c:
			return 0x41db3ed5;
		case 0x00004870:
			return 0x9f4e40b5;
		case 0x00004874:
			return 0x37899a38;
		case 0x00004878:
			return 0xec954c5d;
		case 0x0000487c:
			return 0x5b915ea6;
		case 0x00004880:
			return 0xca8f3165;
		case 0x00004884:
			return 0x8dc036b4;
		case 0x00004888:
			return 0xfdb3fdf5;
		case 0x0000488c:
			return 0x8630eae6;
		case 0x00004890:
			return 0xe36e930f;
		case 0x00004894:
			return 0xd520a162;
		case 0x00004898:
			return 0x47093475;
		case 0x0000489c:
			return 0xf05a2a0f;
		case 0x000048a0:
			return 0x84681bc2;
		case 0x000048a4:
			return 0x1b71a07e;
		case 0x000048a8:
			return 0xa6d5f295;
		case 0x000048ac:
			return 0xc9e65363;
		case 0x000048b0:
			return 0xdc09bb76;
		case 0x000048b4:
			return 0xffd724be;
		case 0x000048b8:
			return 0x967dd641;
		case 0x000048bc:
			return 0x9d74a0ea;
		case 0x000048c0:
			return 0xe6c18711;
		case 0x000048c4:
			return 0x34e9298d;
		case 0x000048c8:
			return 0xc2bfe754;
		case 0x000048cc:
			return 0xf1deb472;
		case 0x000048d0:
			return 0x1b06b6d8;
		case 0x000048d4:
			return 0x78900236;
		case 0x000048d8:
			return 0x90ff7bb8;
		case 0x000048dc:
			return 0x61a90db4;
		case 0x000048e0:
			return 0xe1388f08;
		case 0x000048e4:
			return 0x4d69ece6;
		case 0x000048e8:
			return 0xc8489a5a;
		case 0x000048ec:
			return 0x9080cd59;
		case 0x000048f0:
			return 0x73e759b4;
		case 0x000048f4:
			return 0x5edb5708;
		case 0x000048f8:
			return 0xab78c33d;
		case 0x000048fc:
			return 0xb501cec1;
		case 0x00004900:
			return 0xe926d32f;
		case 0x00004904:
			return 0xf194f2ff;
		case 0x00004908:
			return 0xa36192bf;
		case 0x0000490c:
			return 0x75cf0613;
		case 0x00004910:
			return 0xe7738a1d;
		case 0x00004914:
			return 0x1832778f;
		case 0x00004918:
			return 0x57807d53;
		case 0x0000491c:
			return 0xc686b8c7;
		case 0x00004920:
			return 0xe6949e90;
		case 0x00004924:
			return 0x82897d2b;
		case 0x00004928:
			return 0xa74d75d5;
		case 0x0000492c:
			return 0xec821cc7;
		case 0x00004930:
			return 0x701ad520;
		case 0x00004934:
			return 0xf4893500;
		case 0x00004938:
			return 0x46a3b92b;
		case 0x0000493c:
			return 0x67fa6b30;
		case 0x00004940:
			return 0x7455b86c;
		case 0x00004944:
			return 0xa00423b2;
		case 0x00004948:
			return 0x4ea1c1c7;
		case 0x0000494c:
			return 0xedb50df9;
		case 0x00004950:
			return 0x5e067339;
		case 0x00004954:
			return 0xa854766b;
		case 0x00004958:
			return 0x86a875a1;
		case 0x0000495c:
			return 0x5f829fbc;
		case 0x00004960:
			return 0x9fecf213;
		case 0x00004964:
			return 0xbf3846a8;
		case 0x00004968:
			return 0xb1f805e2;
		case 0x0000496c:
			return 0xe16df0ca;
		case 0x00004970:
			return 0x47435b42;
		case 0x00004974:
			return 0x463ddfa2;
		case 0x00004978:
			return 0x1b059f45;
		case 0x0000497c:
			return 0x23b1b24a;
		case 0x00004980:
			return 0x4e4e2df2;
		case 0x00004984:
			return 0x0de4840d;
		case 0x00004988:
			return 0x0c25f228;
		case 0x0000498c:
			return 0x66e5b08e;
		case 0x00004990:
			return 0x9e22bf7b;
		case 0x00004994:
			return 0x499b08cb;
		case 0x00004998:
			return 0x7eca826a;
		case 0x0000499c:
			return 0x35e1bc09;
		case 0x000049a0:
			return 0x0fe9fede;
		case 0x000049a4:
			return 0x102c28fa;
		case 0x000049a8:
			return 0x61f78245;
		case 0x000049ac:
			return 0x7194cbed;
		case 0x000049b0:
			return 0xbecece30;
		case 0x000049b4:
			return 0x82ad094f;
		case 0x000049b8:
			return 0x293983de;
		case 0x000049bc:
			return 0xf5783094;
		case 0x000049c0:
			return 0x2d47f50c;
		case 0x000049c4:
			return 0x9b3c5430;
		case 0x000049c8:
			return 0x134c67bb;
		case 0x000049cc:
			return 0x1b7c3441;
		case 0x000049d0:
			return 0x0ecf0c65;
		case 0x000049d4:
			return 0xf474ca4e;
		case 0x000049d8:
			return 0x938cfa57;
		case 0x000049dc:
			return 0xb6699e1c;
		case 0x000049e0:
			return 0x2c94df9f;
		case 0x000049e4:
			return 0x449b39c6;
		case 0x000049e8:
			return 0xb6c54723;
		case 0x000049ec:
			return 0x0d792b8d;
		case 0x000049f0:
			return 0x1ca1b48f;
		case 0x000049f4:
			return 0x30dd42fa;
		case 0x000049f8:
			return 0xba015821;
		case 0x000049fc:
			return 0xd46fafa9;
		case 0x00004a00:
			return 0x997084d4;
		case 0x00004a04:
			return 0x4abc3dbf;
		case 0x00004a08:
			return 0x550e536b;
		case 0x00004a0c:
			return 0x4b73ce87;
		case 0x00004a10:
			return 0xe2172d0d;
		case 0x00004a14:
			return 0xecdeab63;
		case 0x00004a18:
			return 0xcbc73ed1;
		case 0x00004a1c:
			return 0xa6ba4387;
		case 0x00004a20:
			return 0xa7f2634c;
		case 0x00004a24:
			return 0x2da1150a;
		case 0x00004a28:
			return 0xc7b6b382;
		case 0x00004a2c:
			return 0x335dd16b;
		case 0x00004a30:
			return 0x7f64217e;
		case 0x00004a34:
			return 0x179ba028;
		case 0x00004a38:
			return 0xb70bd5ec;
		case 0x00004a3c:
			return 0x0d74f60d;
		case 0x00004a40:
			return 0x2c100f86;
		case 0x00004a44:
			return 0x549218ef;
		case 0x00004a48:
			return 0x94e986cf;
		case 0x00004a4c:
			return 0xa005cf92;
		case 0x00004a50:
			return 0x3f9bc69c;
		case 0x00004a54:
			return 0x767adbc6;
		case 0x00004a58:
			return 0xacbc9a21;
		case 0x00004a5c:
			return 0xfffd1cbe;
		case 0x00004a60:
			return 0x80eb8c8d;
		case 0x00004a64:
			return 0xe3f38d89;
		case 0x00004a68:
			return 0x5d7e7804;
		case 0x00004a6c:
			return 0xa9f1ea51;
		case 0x00004a70:
			return 0x735dcc1c;
		case 0x00004a74:
			return 0x002843fe;
		case 0x00004a78:
			return 0x2c74a68f;
		case 0x00004a7c:
			return 0x16c76aa1;
		case 0x00004a80:
			return 0x5d369601;
		case 0x00004a84:
			return 0xea63d78c;
		case 0x00004a88:
			return 0x76b36c60;
		case 0x00004a8c:
			return 0x80a5784e;
		case 0x00004a90:
			return 0x248988bb;
		case 0x00004a94:
			return 0x9f8f9a14;
		case 0x00004a98:
			return 0xc97e8c9a;
		case 0x00004a9c:
			return 0x11bf5072;
		case 0x00004aa0:
			return 0x907e80d6;
		case 0x00004aa4:
			return 0xc499e0d2;
		case 0x00004aa8:
			return 0x81069ed1;
		case 0x00004aac:
			return 0xcc0398de;
		case 0x00004ab0:
			return 0x4bd2d20c;
		case 0x00004ab4:
			return 0xe8127540;
		case 0x00004ab8:
			return 0xaa523abe;
		case 0x00004abc:
			return 0x68b62e6f;
		case 0x00004ac0:
			return 0x662db081;
		case 0x00004ac4:
			return 0xcc0a145d;
		case 0x00004ac8:
			return 0xacb64990;
		case 0x00004acc:
			return 0x0abc2fd9;
		case 0x00004ad0:
			return 0xd514dd12;
		case 0x00004ad4:
			return 0xb6e115f5;
		case 0x00004ad8:
			return 0x31a4f9c6;
		case 0x00004adc:
			return 0x7e4b8934;
		case 0x00004ae0:
			return 0x597ae6b7;
		case 0x00004ae4:
			return 0x7bc21f95;
		case 0x00004ae8:
			return 0x21267e9d;
		case 0x00004aec:
			return 0xb0defc5c;
		case 0x00004af0:
			return 0xcbef5f63;
		case 0x00004af4:
			return 0xc1ad0fab;
		case 0x00004af8:
			return 0xec522de2;
		case 0x00004afc:
			return 0x65c5c729;
		case 0x00004b00:
			return 0xb732682b;
		case 0x00004b04:
			return 0x0274dcfb;
		case 0x00004b08:
			return 0x900982bf;
		case 0x00004b0c:
			return 0x11dd04a3;
		case 0x00004b10:
			return 0x30e8918d;
		case 0x00004b14:
			return 0x0494c26c;
		case 0x00004b18:
			return 0x56d09f4d;
		case 0x00004b1c:
			return 0x9648d4a9;
		case 0x00004b20:
			return 0xb85f77e9;
		case 0x00004b24:
			return 0x3f83f878;
		case 0x00004b28:
			return 0xa9e7b725;
		case 0x00004b2c:
			return 0x50749a6c;
		case 0x00004b30:
			return 0x20446079;
		case 0x00004b34:
			return 0xb9eb04b1;
		case 0x00004b38:
			return 0xcf30a7ca;
		case 0x00004b3c:
			return 0x1589c49d;
		case 0x00004b40:
			return 0xeac432da;
		case 0x00004b44:
			return 0x693f0028;
		case 0x00004b48:
			return 0x49f60334;
		case 0x00004b4c:
			return 0x7a51b8ee;
		case 0x00004b50:
			return 0x19df59cb;
		case 0x00004b54:
			return 0x34518abc;
		case 0x00004b58:
			return 0x3dbc74ff;
		case 0x00004b5c:
			return 0x49c49757;
		case 0x00004b60:
			return 0x4ba63c66;
		case 0x00004b64:
			return 0xb77ec45c;
		case 0x00004b68:
			return 0x05c22037;
		case 0x00004b6c:
			return 0xac9ef494;
		case 0x00004b70:
			return 0xfacf76be;
		case 0x00004b74:
			return 0xb1e561db;
		case 0x00004b78:
			return 0x69020c76;
		case 0x00004b7c:
			return 0xea27e835;
		case 0x00004b80:
			return 0xfec55a31;
		case 0x00004b84:
			return 0xaf769066;
		case 0x00004b88:
			return 0x3c3a5eed;
		case 0x00004b8c:
			return 0x396fc184;
		case 0x00004b90:
			return 0x27604e31;
		case 0x00004b94:
			return 0x2183d26e;
		case 0x00004b98:
			return 0x6bc37603;
		case 0x00004b9c:
			return 0xbbc73e7b;
		case 0x00004ba0:
			return 0xea56f128;
		case 0x00004ba4:
			return 0xa13959fb;
		case 0x00004ba8:
			return 0x712594f8;
		case 0x00004bac:
			return 0x81cfb75f;
		case 0x00004bb0:
			return 0x491e6673;
		case 0x00004bb4:
			return 0xde90db1d;
		case 0x00004bb8:
			return 0x46012da1;
		case 0x00004bbc:
			return 0x46600a31;
		case 0x00004bc0:
			return 0x70148694;
		case 0x00004bc4:
			return 0x8e9c1f6d;
		case 0x00004bc8:
			return 0x83e82f4d;
		case 0x00004bcc:
			return 0xb620e527;
		case 0x00004bd0:
			return 0xf91a20ee;
		case 0x00004bd4:
			return 0x01babadc;
		case 0x00004bd8:
			return 0x1d3b8e2c;
		case 0x00004bdc:
			return 0xc0d7fa0e;
		case 0x00004be0:
			return 0xd904ac55;
		case 0x00004be4:
			return 0xc737d0bb;
		case 0x00004be8:
			return 0xa05c32c3;
		case 0x00004bec:
			return 0x7c0c3b7b;
		case 0x00004bf0:
			return 0x69d8799b;
		case 0x00004bf4:
			return 0x173a2a25;
		case 0x00004bf8:
			return 0x528aa70b;
		case 0x00004bfc:
			return 0xac94ef2f;
		case 0x00004c00:
			return 0xf8fb9227;
		case 0x00004c04:
			return 0xa40908f6;
		case 0x00004c08:
			return 0x2d4cbe7e;
		case 0x00004c0c:
			return 0xf1651a5f;
		case 0x00004c10:
			return 0x362844b4;
		case 0x00004c14:
			return 0x963514f9;
		case 0x00004c18:
			return 0xf3140f24;
		case 0x00004c1c:
			return 0x7466daef;
		case 0x00004c20:
			return 0x5d43f6a2;
		case 0x00004c24:
			return 0x7eca7acb;
		case 0x00004c28:
			return 0xe4ca9f78;
		case 0x00004c2c:
			return 0xedf54c85;
		case 0x00004c30:
			return 0x7ee4fcbc;
		case 0x00004c34:
			return 0x15b4ff64;
		case 0x00004c38:
			return 0x7e450a93;
		case 0x00004c3c:
			return 0xc301cef1;
		case 0x00004c40:
			return 0x912cc365;
		case 0x00004c44:
			return 0x86164b03;
		case 0x00004c48:
			return 0x26e5325b;
		case 0x00004c4c:
			return 0x638558b9;
		case 0x00004c50:
			return 0x4884d4bf;
		case 0x00004c54:
			return 0x4e3e88e6;
		case 0x00004c58:
			return 0x71d640a3;
		case 0x00004c5c:
			return 0x088be327;
		case 0x00004c60:
			return 0xd0d7cc91;
		case 0x00004c64:
			return 0x596f8dfb;
		case 0x00004c68:
			return 0xc21c31c8;
		case 0x00004c6c:
			return 0x9f9a6847;
		case 0x00004c70:
			return 0x067a6fd0;
		case 0x00004c74:
			return 0xaafa0f2c;
		case 0x00004c78:
			return 0x3909ee5d;
		case 0x00004c7c:
			return 0x89d597e2;
		case 0x00004c80:
			return 0xb4d70ef8;
		case 0x00004c84:
			return 0x454804a0;
		case 0x00004c88:
			return 0x3151f236;
		case 0x00004c8c:
			return 0x3d6fdec5;
		case 0x00004c90:
			return 0x151eff5a;
		case 0x00004c94:
			return 0xb7653aa7;
		case 0x00004c98:
			return 0x622e8d85;
		case 0x00004c9c:
			return 0xb34959cd;
		case 0x00004ca0:
			return 0x1bb0c632;
		case 0x00004ca4:
			return 0x425fffee;
		case 0x00004ca8:
			return 0x48940663;
		case 0x00004cac:
			return 0x3dcb3018;
		case 0x00004cb0:
			return 0xb4f3862b;
		case 0x00004cb4:
			return 0x98f4dd8b;
		case 0x00004cb8:
			return 0x837823b4;
		case 0x00004cbc:
			return 0x62334df0;
		case 0x00004cc0:
			return 0x71c7c001;
		case 0x00004cc4:
			return 0x3218f61f;
		case 0x00004cc8:
			return 0x8b1473be;
		case 0x00004ccc:
			return 0x4344c569;
		case 0x00004cd0:
			return 0x79fa0b77;
		case 0x00004cd4:
			return 0xb13c382e;
		case 0x00004cd8:
			return 0x1151c19a;
		case 0x00004cdc:
			return 0x631f7706;
		case 0x00004ce0:
			return 0x24b59b41;
		case 0x00004ce4:
			return 0x0d52693e;
		case 0x00004ce8:
			return 0x0bba6b0f;
		case 0x00004cec:
			return 0xe814e05e;
		case 0x00004cf0:
			return 0x0c9e1bae;
		case 0x00004cf4:
			return 0xfb7ae034;
		case 0x00004cf8:
			return 0x5023e7f5;
		case 0x00004cfc:
			return 0x6cd5f9c7;
		case 0x00004d00:
			return 0xc7318868;
		case 0x00004d04:
			return 0x3bc7060b;
		case 0x00004d08:
			return 0x7bfd69a8;
		case 0x00004d0c:
			return 0xdd97277e;
		case 0x00004d10:
			return 0x74e832dc;
		case 0x00004d14:
			return 0x8266191c;
		case 0x00004d18:
			return 0xf266c15f;
		case 0x00004d1c:
			return 0x27a8d55c;
		case 0x00004d20:
			return 0x2eb5fcd2;
		case 0x00004d24:
			return 0x8a1cebc2;
		case 0x00004d28:
			return 0xe2bec148;
		case 0x00004d2c:
			return 0x3ea34b00;
		case 0x00004d30:
			return 0x58481cd7;
		case 0x00004d34:
			return 0x3a491ae6;
		case 0x00004d38:
			return 0x9fe81a19;
		case 0x00004d3c:
			return 0xbc1e66b4;
		case 0x00004d40:
			return 0x8838300c;
		case 0x00004d44:
			return 0xc62a088c;
		case 0x00004d48:
			return 0xa74a70d7;
		case 0x00004d4c:
			return 0xaa0df07d;
		case 0x00004d50:
			return 0xef2322cf;
		case 0x00004d54:
			return 0x0b171f7b;
		case 0x00004d58:
			return 0x22c14cfc;
		case 0x00004d5c:
			return 0xaa38387e;
		case 0x00004d60:
			return 0x4b153159;
		case 0x00004d64:
			return 0x9eb4b5b8;
		case 0x00004d68:
			return 0xd7d3cae6;
		case 0x00004d6c:
			return 0x3dbe817b;
		case 0x00004d70:
			return 0x16ee2fef;
		case 0x00004d74:
			return 0xe8e4b23d;
		case 0x00004d78:
			return 0xdd3816dc;
		case 0x00004d7c:
			return 0x2692c39d;
		case 0x00004d80:
			return 0xb74a777a;
		case 0x00004d84:
			return 0x140acab7;
		case 0x00004d88:
			return 0xce70bdeb;
		case 0x00004d8c:
			return 0xd55184b3;
		case 0x00004d90:
			return 0x400207f7;
		case 0x00004d94:
			return 0x5eb6fbdc;
		case 0x00004d98:
			return 0x806c8646;
		case 0x00004d9c:
			return 0x3e40bc5c;
		case 0x00004da0:
			return 0xfd36b7db;
		case 0x00004da4:
			return 0xa652c2c0;
		case 0x00004da8:
			return 0x4dba519c;
		case 0x00004dac:
			return 0xd1b7e5ea;
		case 0x00004db0:
			return 0xd105d038;
		case 0x00004db4:
			return 0x6b29d1fa;
		case 0x00004db8:
			return 0x8aa33e15;
		case 0x00004dbc:
			return 0x0c2252f4;
		case 0x00004dc0:
			return 0xba969a84;
		case 0x00004dc4:
			return 0x37dfd4ce;
		case 0x00004dc8:
			return 0x533b0c13;
		case 0x00004dcc:
			return 0xe9a5a466;
		case 0x00004dd0:
			return 0xd6a728ea;
		case 0x00004dd4:
			return 0x3bd6deb7;
		case 0x00004dd8:
			return 0xe8836344;
		case 0x00004ddc:
			return 0xb9fd8aa5;
		case 0x00004de0:
			return 0xf9051ab0;
		case 0x00004de4:
			return 0x59e52a95;
		case 0x00004de8:
			return 0x005a2ad8;
		case 0x00004dec:
			return 0xe8c5d134;
		case 0x00004df0:
			return 0x460a241d;
		case 0x00004df4:
			return 0xcf952286;
		case 0x00004df8:
			return 0xcf96c082;
		case 0x00004dfc:
			return 0x12238786;
		case 0x00004e00:
			return 0xdeeeb906;
		case 0x00004e04:
			return 0xe329de01;
		case 0x00004e08:
			return 0x8b7de824;
		case 0x00004e0c:
			return 0x2c26ae9f;
		case 0x00004e10:
			return 0x1c2ced21;
		case 0x00004e14:
			return 0x904f2b70;
		case 0x00004e18:
			return 0x68d642cc;
		case 0x00004e1c:
			return 0x5156182d;
		case 0x00004e20:
			return 0xcc19c2ed;
		case 0x00004e24:
			return 0x32523f99;
		case 0x00004e28:
			return 0xecedb231;
		case 0x00004e2c:
			return 0xd6c61bb4;
		case 0x00004e30:
			return 0x4c2998f6;
		case 0x00004e34:
			return 0x26bc2eb7;
		case 0x00004e38:
			return 0x8e8b898d;
		case 0x00004e3c:
			return 0x2e42cc6c;
		case 0x00004e40:
			return 0x28121335;
		case 0x00004e44:
			return 0x0feb61df;
		case 0x00004e48:
			return 0x69505ae4;
		case 0x00004e4c:
			return 0x09fd1c7e;
		case 0x00004e50:
			return 0x93e259c4;
		case 0x00004e54:
			return 0x08a07bb2;
		case 0x00004e58:
			return 0xd51673e8;
		case 0x00004e5c:
			return 0xfa178282;
		case 0x00004e60:
			return 0xafcf1182;
		case 0x00004e64:
			return 0x73ba4fd6;
		case 0x00004e68:
			return 0x7c946405;
		case 0x00004e6c:
			return 0x064d5d67;
		case 0x00004e70:
			return 0xec297c4d;
		case 0x00004e74:
			return 0x843b9b95;
		case 0x00004e78:
			return 0xef5b33d0;
		case 0x00004e7c:
			return 0x3960a372;
		case 0x00004e80:
			return 0xa5e6912c;
		case 0x00004e84:
			return 0x0e38e7de;
		case 0x00004e88:
			return 0xa22e01d8;
		case 0x00004e8c:
			return 0xa57bd023;
		case 0x00004e90:
			return 0x6ab0190c;
		case 0x00004e94:
			return 0xca7ea3e8;
		case 0x00004e98:
			return 0x14031980;
		case 0x00004e9c:
			return 0x3cf3eb03;
		case 0x00004ea0:
			return 0x45538489;
		case 0x00004ea4:
			return 0xdc1f1262;
		case 0x00004ea8:
			return 0x553120b8;
		case 0x00004eac:
			return 0xaa4154d7;
		case 0x00004eb0:
			return 0x74122246;
		case 0x00004eb4:
			return 0x5dae742c;
		case 0x00004eb8:
			return 0x5be3cc6b;
		case 0x00004ebc:
			return 0xeb2f589a;
		case 0x00004ec0:
			return 0x9b95aa02;
		case 0x00004ec4:
			return 0xe3198364;
		case 0x00004ec8:
			return 0xd5b2b82b;
		case 0x00004ecc:
			return 0xb77f5ef4;
		case 0x00004ed0:
			return 0x2b03ae39;
		case 0x00004ed4:
			return 0x1f4eddfb;
		case 0x00004ed8:
			return 0xee6ef7bb;
		case 0x00004edc:
			return 0x8997652b;
		case 0x00004ee0:
			return 0x9918b212;
		case 0x00004ee4:
			return 0xc6654fdb;
		case 0x00004ee8:
			return 0x4469311a;
		case 0x00004eec:
			return 0x72ed7741;
		case 0x00004ef0:
			return 0xb34db573;
		case 0x00004ef4:
			return 0x8d919f26;
		case 0x00004ef8:
			return 0xdde34527;
		case 0x00004efc:
			return 0xe94909f8;
		case 0x00004f00:
			return 0xc4508a7a;
		case 0x00004f04:
			return 0xaa6ff0c7;
		case 0x00004f08:
			return 0x8e3df5df;
		case 0x00004f0c:
			return 0xca4758d4;
		case 0x00004f10:
			return 0xe9582dd4;
		case 0x00004f14:
			return 0xb6a58d6d;
		case 0x00004f18:
			return 0x33a5e38f;
		case 0x00004f1c:
			return 0xad7b7f7d;
		case 0x00004f20:
			return 0xcada51ee;
		case 0x00004f24:
			return 0x4edbfa7d;
		case 0x00004f28:
			return 0xbd1370ba;
		case 0x00004f2c:
			return 0x72f90e30;
		case 0x00004f30:
			return 0x43bbb4f3;
		case 0x00004f34:
			return 0x7701cc05;
		case 0x00004f38:
			return 0xea124e32;
		case 0x00004f3c:
			return 0x0047a168;
		case 0x00004f40:
			return 0xb8c503ff;
		case 0x00004f44:
			return 0x888b0076;
		case 0x00004f48:
			return 0xbb755406;
		case 0x00004f4c:
			return 0xa5175af9;
		case 0x00004f50:
			return 0x2d09d6d1;
		case 0x00004f54:
			return 0x4f60b6a9;
		case 0x00004f58:
			return 0xc12b1d98;
		case 0x00004f5c:
			return 0x640af243;
		case 0x00004f60:
			return 0x8f16db90;
		case 0x00004f64:
			return 0x9317ff2d;
		case 0x00004f68:
			return 0x442dc0d5;
		case 0x00004f6c:
			return 0xee4c8137;
		case 0x00004f70:
			return 0x6b4a113d;
		case 0x00004f74:
			return 0x62af4270;
		case 0x00004f78:
			return 0xf51281b0;
		case 0x00004f7c:
			return 0x4e961f6c;
		case 0x00004f80:
			return 0xd30d3bd4;
		case 0x00004f84:
			return 0xa2139f1e;
		case 0x00004f88:
			return 0x781f9639;
		case 0x00004f8c:
			return 0x2bd9423f;
		case 0x00004f90:
			return 0xb463a54b;
		case 0x00004f94:
			return 0x3be0224f;
		case 0x00004f98:
			return 0x952cabc1;
		case 0x00004f9c:
			return 0xf9606fc2;
		case 0x00004fa0:
			return 0xdd7df826;
		case 0x00004fa4:
			return 0xa613b0fa;
		case 0x00004fa8:
			return 0x52403824;
		case 0x00004fac:
			return 0x405aaded;
		case 0x00004fb0:
			return 0x329159b0;
		case 0x00004fb4:
			return 0x0ea2813f;
		case 0x00004fb8:
			return 0x49baaee1;
		case 0x00004fbc:
			return 0xad7e6c34;
		case 0x00004fc0:
			return 0x21733c1a;
		case 0x00004fc4:
			return 0xd936f793;
		case 0x00004fc8:
			return 0x2f5d4ffa;
		case 0x00004fcc:
			return 0xa364d140;
		case 0x00004fd0:
			return 0xff8bad32;
		case 0x00004fd4:
			return 0xe906e3db;
		case 0x00004fd8:
			return 0xd7c80753;
		case 0x00004fdc:
			return 0xa85c9b72;
		case 0x00004fe0:
			return 0x969b96b7;
		case 0x00004fe4:
			return 0xd4062a53;
		case 0x00004fe8:
			return 0xaa828592;
		case 0x00004fec:
			return 0xdcf7442b;
		case 0x00004ff0:
			return 0xee167ef8;
		case 0x00004ff4:
			return 0x54e9c312;
		case 0x00004ff8:
			return 0xf45e31d6;
		case 0x00004ffc:
			return 0x64c0ee72;
		case 0x00005000:
			return 0x227e7b48;
		case 0x00005004:
			return 0x63cee783;
		case 0x00005008:
			return 0x73f59d87;
		case 0x0000500c:
			return 0xbb379591;
		case 0x00005010:
			return 0x00864d47;
		case 0x00005014:
			return 0x9ce336b5;
		case 0x00005018:
			return 0x19671c20;
		case 0x0000501c:
			return 0x25ea4a35;
		case 0x00005020:
			return 0xd5b644ba;
		case 0x00005024:
			return 0x698a49f2;
		case 0x00005028:
			return 0xdd291646;
		case 0x0000502c:
			return 0x61e414dc;
		case 0x00005030:
			return 0x4c79210f;
		case 0x00005034:
			return 0x7428f4c8;
		case 0x00005038:
			return 0x184a6fbb;
		case 0x0000503c:
			return 0x29f24974;
		case 0x00005040:
			return 0x2e9df728;
		case 0x00005044:
			return 0x622d3044;
		case 0x00005048:
			return 0x1a488808;
		case 0x0000504c:
			return 0xef00f254;
		case 0x00005050:
			return 0xf5cf1ae7;
		case 0x00005054:
			return 0x48cb5ad9;
		case 0x00005058:
			return 0x3cf3df5d;
		case 0x0000505c:
			return 0x23bcc612;
		case 0x00005060:
			return 0xe603cd00;
		case 0x00005064:
			return 0x47e9beda;
		case 0x00005068:
			return 0x626000c0;
		case 0x0000506c:
			return 0x92f128fe;
		case 0x00005070:
			return 0x0d822b39;
		case 0x00005074:
			return 0x4e5287ad;
		case 0x00005078:
			return 0x55f8875d;
		case 0x0000507c:
			return 0x1f25dc59;
		case 0x00005080:
			return 0x7aecdfff;
		case 0x00005084:
			return 0xa5795ecc;
		case 0x00005088:
			return 0x69b86e1d;
		case 0x0000508c:
			return 0x1e491e8d;
		case 0x00005090:
			return 0xca788024;
		case 0x00005094:
			return 0x1bd1195a;
		case 0x00005098:
			return 0x77b63aa9;
		case 0x0000509c:
			return 0xc4836e7e;
		case 0x000050a0:
			return 0x749b2f04;
		case 0x000050a4:
			return 0xd0330772;
		case 0x000050a8:
			return 0x01212ba9;
		case 0x000050ac:
			return 0xf2767404;
		case 0x000050b0:
			return 0x5d2ab928;
		case 0x000050b4:
			return 0xa0880d02;
		case 0x000050b8:
			return 0xf5da2f97;
		case 0x000050bc:
			return 0xbcf44e6f;
		case 0x000050c0:
			return 0x122de9b6;
		case 0x000050c4:
			return 0x09033053;
		case 0x000050c8:
			return 0x6e034229;
		case 0x000050cc:
			return 0x1a60bbb1;
		case 0x000050d0:
			return 0x18dceaa3;
		case 0x000050d4:
			return 0x26667ff9;
		case 0x000050d8:
			return 0xae6b587e;
		case 0x000050dc:
			return 0x89ca7f09;
		case 0x000050e0:
			return 0x8c509b27;
		case 0x000050e4:
			return 0xc6e62d9e;
		case 0x000050e8:
			return 0x5193da28;
		case 0x000050ec:
			return 0x23d7b40d;
		case 0x000050f0:
			return 0x5dc74e81;
		case 0x000050f4:
			return 0x8e32b1c9;
		case 0x000050f8:
			return 0x85245df8;
		case 0x000050fc:
			return 0x40cdcdc2;
		case 0x00005100:
			return 0x18631618;
		case 0x00005104:
			return 0xd01b9424;
		case 0x00005108:
			return 0x63e77aac;
		case 0x0000510c:
			return 0x93798af4;
		case 0x00005110:
			return 0xac71185d;
		case 0x00005114:
			return 0x95847a67;
		case 0x00005118:
			return 0x73f8b88d;
		case 0x0000511c:
			return 0xa425d370;
		case 0x00005120:
			return 0x46a52b73;
		case 0x00005124:
			return 0x21a3f4f3;
		case 0x00005128:
			return 0x4b006115;
		case 0x0000512c:
			return 0x7258b4a5;
		case 0x00005130:
			return 0xea7bdf51;
		case 0x00005134:
			return 0x746eb3ac;
		case 0x00005138:
			return 0xbb018364;
		case 0x0000513c:
			return 0xefab5481;
		case 0x00005140:
			return 0xe76e6edc;
		case 0x00005144:
			return 0x7d893c88;
		case 0x00005148:
			return 0xa2977f21;
		case 0x0000514c:
			return 0x2eac4bf1;
		case 0x00005150:
			return 0x19177fd4;
		case 0x00005154:
			return 0x8ed3a848;
		case 0x00005158:
			return 0xe5b9af69;
		case 0x0000515c:
			return 0xc4f4eb4d;
		case 0x00005160:
			return 0x793fdcf2;
		case 0x00005164:
			return 0x342816ba;
		case 0x00005168:
			return 0xfcda7030;
		case 0x0000516c:
			return 0xf3b1200b;
		case 0x00005170:
			return 0xc1a43418;
		case 0x00005174:
			return 0xd188735a;
		case 0x00005178:
			return 0x4674e6e5;
		case 0x0000517c:
			return 0xa7046d7d;
		case 0x00005180:
			return 0x7271468d;
		case 0x00005184:
			return 0x2b9a9775;
		case 0x00005188:
			return 0xf37a8d9d;
		case 0x0000518c:
			return 0x539eb907;
		case 0x00005190:
			return 0xe8c4a730;
		case 0x00005194:
			return 0xb3f65a66;
		case 0x00005198:
			return 0xc75132b9;
		case 0x0000519c:
			return 0x76eddb98;
		case 0x000051a0:
			return 0xf9f37b52;
		case 0x000051a4:
			return 0xd0cf4f3a;
		case 0x000051a8:
			return 0x859b0450;
		case 0x000051ac:
			return 0x832d2da2;
		case 0x000051b0:
			return 0x8f40426d;
		case 0x000051b4:
			return 0x6b9e1e86;
		case 0x000051b8:
			return 0xb383642d;
		case 0x000051bc:
			return 0x5be3dfb9;
		case 0x000051c0:
			return 0x39082249;
		case 0x000051c4:
			return 0x1cdde5fe;
		case 0x000051c8:
			return 0x7852fd7f;
		case 0x000051cc:
			return 0x4d80bcdf;
		case 0x000051d0:
			return 0x94b1ce4b;
		case 0x000051d4:
			return 0x4f3b0c35;
		case 0x000051d8:
			return 0x0d1df059;
		case 0x000051dc:
			return 0x743c2d29;
		case 0x000051e0:
			return 0x56ec9eb1;
		case 0x000051e4:
			return 0xfc98e45e;
		case 0x000051e8:
			return 0xf5851767;
		case 0x000051ec:
			return 0x91977423;
		case 0x000051f0:
			return 0x6261512d;
		case 0x000051f4:
			return 0x597ef967;
		case 0x000051f8:
			return 0x7b4d2473;
		case 0x000051fc:
			return 0xdc3db15d;
		case 0x00005200:
			return 0x6f46962b;
		case 0x00005204:
			return 0x0fce45c0;
		case 0x00005208:
			return 0xb14e73a0;
		case 0x0000520c:
			return 0xa65444d4;
		case 0x00005210:
			return 0x99be5d16;
		case 0x00005214:
			return 0x4dddc867;
		case 0x00005218:
			return 0x4c78f2b8;
		case 0x0000521c:
			return 0x40ebf096;
		case 0x00005220:
			return 0x52944010;
		case 0x00005224:
			return 0xc3ad8e81;
		case 0x00005228:
			return 0xe8903c86;
		case 0x0000522c:
			return 0x43c01f17;
		case 0x00005230:
			return 0xbdfd584b;
		case 0x00005234:
			return 0x393eee64;
		case 0x00005238:
			return 0x1148f8f3;
		case 0x0000523c:
			return 0xb5463ad0;
		case 0x00005240:
			return 0x40df6ef1;
		case 0x00005244:
			return 0x374bbab7;
		case 0x00005248:
			return 0x798e1714;
		case 0x0000524c:
			return 0xd05a512e;
		case 0x00005250:
			return 0x3ecd9b7a;
		case 0x00005254:
			return 0xb599a823;
		case 0x00005258:
			return 0x2929e21e;
		case 0x0000525c:
			return 0x689e5012;
		case 0x00005260:
			return 0x6eb6100f;
		case 0x00005264:
			return 0xe5b04664;
		case 0x00005268:
			return 0x540f0ffb;
		case 0x0000526c:
			return 0xd3cc89ad;
		case 0x00005270:
			return 0xe56f9898;
		case 0x00005274:
			return 0x6bb7a4a5;
		case 0x00005278:
			return 0x2defb856;
		case 0x0000527c:
			return 0xd11eaf7f;
		case 0x00005280:
			return 0x39b5ab03;
		case 0x00005284:
			return 0xf7e61f65;
		case 0x00005288:
			return 0x042ecd11;
		case 0x0000528c:
			return 0xd1a65a86;
		case 0x00005290:
			return 0xca13f8b1;
		case 0x00005294:
			return 0xb0044683;
		case 0x00005298:
			return 0xc45f0505;
		case 0x0000529c:
			return 0x5f607653;
		case 0x000052a0:
			return 0x2f9ec54b;
		case 0x000052a4:
			return 0xd9c1662b;
		case 0x000052a8:
			return 0x9ef7c22b;
		case 0x000052ac:
			return 0x2363debf;
		case 0x000052b0:
			return 0x5774458c;
		case 0x000052b4:
			return 0xa776cf0d;
		case 0x000052b8:
			return 0x51e3cf6a;
		case 0x000052bc:
			return 0x10268829;
		case 0x000052c0:
			return 0xfb2b0cab;
		case 0x000052c4:
			return 0xbb0def18;
		case 0x000052c8:
			return 0xc54f51c5;
		case 0x000052cc:
			return 0xbd547179;
		case 0x000052d0:
			return 0x098a5efa;
		case 0x000052d4:
			return 0xaee9c425;
		case 0x000052d8:
			return 0xc1949d88;
		case 0x000052dc:
			return 0x49e6434b;
		case 0x000052e0:
			return 0xdd867368;
		case 0x000052e4:
			return 0x84191ef5;
		case 0x000052e8:
			return 0xe070d7b0;
		case 0x000052ec:
			return 0x1ed8c841;
		case 0x000052f0:
			return 0xad878d51;
		case 0x000052f4:
			return 0x23f4e719;
		case 0x000052f8:
			return 0x4e9143fc;
		case 0x000052fc:
			return 0x4a3f5511;
		case 0x00005300:
			return 0xc7c9cb3a;
		case 0x00005304:
			return 0x8bb67833;
		case 0x00005308:
			return 0xb80fd6e3;
		case 0x0000530c:
			return 0x6a5bb717;
		case 0x00005310:
			return 0x8541831d;
		case 0x00005314:
			return 0x6e260f32;
		case 0x00005318:
			return 0x209ccf75;
		case 0x0000531c:
			return 0xb860a6ba;
		case 0x00005320:
			return 0xf7b75736;
		case 0x00005324:
			return 0x43ff46a6;
		case 0x00005328:
			return 0xad19e806;
		case 0x0000532c:
			return 0xb8594822;
		case 0x00005330:
			return 0x6fb1c445;
		case 0x00005334:
			return 0x7ad5c577;
		case 0x00005338:
			return 0x3711e9ae;
		case 0x0000533c:
			return 0x451c244a;
		case 0x00005340:
			return 0xbc3d7834;
		case 0x00005344:
			return 0x35aa8909;
		case 0x00005348:
			return 0xb6b2c550;
		case 0x0000534c:
			return 0xf8dbd6f8;
		case 0x00005350:
			return 0x352b0e93;
		case 0x00005354:
			return 0x902adf9c;
		case 0x00005358:
			return 0x0fa79d41;
		case 0x0000535c:
			return 0x55c7dd92;
		case 0x00005360:
			return 0x609695b1;
		case 0x00005364:
			return 0x1ce35bfa;
		case 0x00005368:
			return 0xda54b186;
		case 0x0000536c:
			return 0x5ed98cf0;
		case 0x00005370:
			return 0xbc77cd8b;
		case 0x00005374:
			return 0x6c31630d;
		case 0x00005378:
			return 0x51a4c6ef;
		case 0x0000537c:
			return 0xd4f702e2;
		case 0x00005380:
			return 0xa1b61eab;
		case 0x00005384:
			return 0x617c9e96;
		case 0x00005388:
			return 0xd9f104da;
		case 0x0000538c:
			return 0xec712c6a;
		case 0x00005390:
			return 0xe2c50ef6;
		case 0x00005394:
			return 0xcb8a0632;
		case 0x00005398:
			return 0x20b8d2ca;
		case 0x0000539c:
			return 0x100fdef7;
		case 0x000053a0:
			return 0xb8f3c7cd;
		case 0x000053a4:
			return 0xd6e4ed40;
		case 0x000053a8:
			return 0x047bd424;
		case 0x000053ac:
			return 0x028da57f;
		case 0x000053b0:
			return 0xf80bab45;
		case 0x000053b4:
			return 0xefe842a3;
		case 0x000053b8:
			return 0x7ad0333d;
		case 0x000053bc:
			return 0x639839c9;
		case 0x000053c0:
			return 0xa6f71d03;
		case 0x000053c4:
			return 0x3a474b96;
		case 0x000053c8:
			return 0x5daa81f6;
		case 0x000053cc:
			return 0x0fa049b5;
		case 0x000053d0:
			return 0x0702a999;
		case 0x000053d4:
			return 0x34b641bd;
		case 0x000053d8:
			return 0x936b206c;
		case 0x000053dc:
			return 0x937543c4;
		case 0x000053e0:
			return 0xc507db2d;
		case 0x000053e4:
			return 0x32621321;
		case 0x000053e8:
			return 0xead6cf44;
		case 0x000053ec:
			return 0x24b76dee;
		case 0x000053f0:
			return 0x95a4254b;
		case 0x000053f4:
			return 0x16f3cd99;
		case 0x000053f8:
			return 0xa461c79e;
		case 0x000053fc:
			return 0x60bedf88;
		case 0x00005400:
			return 0x2b1b53d1;
		case 0x00005404:
			return 0xf1b3c662;
		case 0x00005408:
			return 0xe29bb6bd;
		case 0x0000540c:
			return 0x31547962;
		case 0x00005410:
			return 0x8f1d5002;
		case 0x00005414:
			return 0xe8a9a5af;
		case 0x00005418:
			return 0x759a5247;
		case 0x0000541c:
			return 0x809a3b87;
		case 0x00005420:
			return 0x0e3973a1;
		case 0x00005424:
			return 0x3907cbce;
		case 0x00005428:
			return 0x9d1f2def;
		case 0x0000542c:
			return 0x58f3dca2;
		case 0x00005430:
			return 0x0ad0e410;
		case 0x00005434:
			return 0x9625ba1e;
		case 0x00005438:
			return 0xed65bd38;
		case 0x0000543c:
			return 0xe1d396a4;
		case 0x00005440:
			return 0x309f540c;
		case 0x00005444:
			return 0x3b2b48fb;
		case 0x00005448:
			return 0x0d401840;
		case 0x0000544c:
			return 0x1caea28d;
		case 0x00005450:
			return 0x3d004cf9;
		case 0x00005454:
			return 0xe02da2e9;
		case 0x00005458:
			return 0x52fa6843;
		case 0x0000545c:
			return 0xdd479375;
		case 0x00005460:
			return 0x3001d78d;
		case 0x00005464:
			return 0x88422d13;
		case 0x00005468:
			return 0x2d6152fb;
		case 0x0000546c:
			return 0x544ccd15;
		case 0x00005470:
			return 0x330d149f;
		case 0x00005474:
			return 0x2bb00a61;
		case 0x00005478:
			return 0x9c74a97f;
		case 0x0000547c:
			return 0x439f0340;
		case 0x00005480:
			return 0xed922288;
		case 0x00005484:
			return 0xe793f2e1;
		case 0x00005488:
			return 0x0a3a6207;
		case 0x0000548c:
			return 0x487f7a40;
		case 0x00005490:
			return 0x3ad066c9;
		case 0x00005494:
			return 0x079229a5;
		case 0x00005498:
			return 0x81146b36;
		case 0x0000549c:
			return 0x0279a109;
		case 0x000054a0:
			return 0x0c6924f3;
		case 0x000054a4:
			return 0x781e0584;
		case 0x000054a8:
			return 0x06d9f8bf;
		case 0x000054ac:
			return 0x57f0b73f;
		case 0x000054b0:
			return 0x53fdabe7;
		case 0x000054b4:
			return 0xc4afadd9;
		case 0x000054b8:
			return 0x6bc048f4;
		case 0x000054bc:
			return 0xbe18bb99;
		case 0x000054c0:
			return 0xf676cb41;
		case 0x000054c4:
			return 0x40d303ef;
		case 0x000054c8:
			return 0x9083cc2e;
		case 0x000054cc:
			return 0xba382fb2;
		case 0x000054d0:
			return 0xc0b49ea0;
		case 0x000054d4:
			return 0xac65b08a;
		case 0x000054d8:
			return 0xf09e53d6;
		case 0x000054dc:
			return 0x4fd945da;
		case 0x000054e0:
			return 0xabacda7b;
		case 0x000054e4:
			return 0x691caca6;
		case 0x000054e8:
			return 0x160ebd61;
		case 0x000054ec:
			return 0x3c93d77d;
		case 0x000054f0:
			return 0xd9c8ecf6;
		case 0x000054f4:
			return 0x01aa82e1;
		case 0x000054f8:
			return 0xe3c95cb2;
		case 0x000054fc:
			return 0xe8a53e80;
		case 0x00005500:
			return 0x92dc6ba1;
		case 0x00005504:
			return 0x98364215;
		case 0x00005508:
			return 0xf10038f2;
		case 0x0000550c:
			return 0x503ae577;
		case 0x00005510:
			return 0xa7880172;
		case 0x00005514:
			return 0x0c0eeabb;
		case 0x00005518:
			return 0x631d4cf6;
		case 0x0000551c:
			return 0x01bc3f37;
		case 0x00005520:
			return 0xa2a831be;
		case 0x00005524:
			return 0xc790b7f2;
		case 0x00005528:
			return 0x889b3215;
		case 0x0000552c:
			return 0x97e269a5;
		case 0x00005530:
			return 0x4f95d164;
		case 0x00005534:
			return 0xfff31354;
		case 0x00005538:
			return 0x1c3ab260;
		case 0x0000553c:
			return 0x0f75adce;
		case 0x00005540:
			return 0x4fd23276;
		case 0x00005544:
			return 0x3913ad6e;
		case 0x00005548:
			return 0xff9f0d95;
		case 0x0000554c:
			return 0xd67d13b0;
		case 0x00005550:
			return 0xc3148429;
		case 0x00005554:
			return 0x1f388486;
		case 0x00005558:
			return 0x6f4c197e;
		case 0x0000555c:
			return 0xcb87ab06;
		case 0x00005560:
			return 0xc081a64f;
		case 0x00005564:
			return 0x70480bec;
		case 0x00005568:
			return 0x9fbd0fc6;
		case 0x0000556c:
			return 0xe45e0c1d;
		case 0x00005570:
			return 0xc6eb230d;
		case 0x00005574:
			return 0x776d0615;
		case 0x00005578:
			return 0x2838920e;
		case 0x0000557c:
			return 0x93e2bc79;
		case 0x00005580:
			return 0x0db8d3f8;
		case 0x00005584:
			return 0x2b5fb2ce;
		case 0x00005588:
			return 0x828faa54;
		case 0x0000558c:
			return 0x6ac7112d;
		case 0x00005590:
			return 0x8471179a;
		case 0x00005594:
			return 0xfc8e0124;
		case 0x00005598:
			return 0x4dceeedc;
		case 0x0000559c:
			return 0x26974bb5;
		case 0x000055a0:
			return 0x71dfb0a7;
		case 0x000055a4:
			return 0xe4c8483f;
		case 0x000055a8:
			return 0xf48529e2;
		case 0x000055ac:
			return 0x6d5643d3;
		case 0x000055b0:
			return 0xbfcd7068;
		case 0x000055b4:
			return 0x8afc3a41;
		case 0x000055b8:
			return 0x7390be10;
		case 0x000055bc:
			return 0x2895273b;
		case 0x000055c0:
			return 0x0109603f;
		case 0x000055c4:
			return 0x179ac7f2;
		case 0x000055c8:
			return 0xb0474c62;
		case 0x000055cc:
			return 0x80dd560d;
		case 0x000055d0:
			return 0x41bac1a4;
		case 0x000055d4:
			return 0xa4002a2c;
		case 0x000055d8:
			return 0x2f2dfb97;
		case 0x000055dc:
			return 0xb691f8f6;
		case 0x000055e0:
			return 0x2374fb2b;
		case 0x000055e4:
			return 0x0c29f912;
		case 0x000055e8:
			return 0x23fff371;
		case 0x000055ec:
			return 0xf85c4c9d;
		case 0x000055f0:
			return 0x0ffdb073;
		case 0x000055f4:
			return 0x3320f00d;
		case 0x000055f8:
			return 0x175b7af8;
		case 0x000055fc:
			return 0xa0e1a481;
		case 0x00005600:
			return 0x70fb652c;
		case 0x00005604:
			return 0x22ff4a62;
		case 0x00005608:
			return 0x40fe3aaf;
		case 0x0000560c:
			return 0x63e07379;
		case 0x00005610:
			return 0x353cbd8a;
		case 0x00005614:
			return 0xc7169eef;
		case 0x00005618:
			return 0xe0da4163;
		case 0x0000561c:
			return 0x601a06e7;
		case 0x00005620:
			return 0xb4ea8d14;
		case 0x00005624:
			return 0x072789ba;
		case 0x00005628:
			return 0xf2e80b73;
		case 0x0000562c:
			return 0xcb666c8c;
		case 0x00005630:
			return 0x5259007d;
		case 0x00005634:
			return 0x7d916b6c;
		case 0x00005638:
			return 0x045fd65e;
		case 0x0000563c:
			return 0xe89429a3;
		case 0x00005640:
			return 0x86c99007;
		case 0x00005644:
			return 0x26b3b2b3;
		case 0x00005648:
			return 0xcc07e7df;
		case 0x0000564c:
			return 0x2fe4d6b7;
		case 0x00005650:
			return 0x73bfe405;
		case 0x00005654:
			return 0x13bec041;
		case 0x00005658:
			return 0x33f61131;
		case 0x0000565c:
			return 0x37ae7a16;
		case 0x00005660:
			return 0xb4f2a243;
		case 0x00005664:
			return 0xa6f37dc1;
		case 0x00005668:
			return 0xc7a308ff;
		case 0x0000566c:
			return 0x068afbb3;
		case 0x00005670:
			return 0x8a326a51;
		case 0x00005674:
			return 0x930028b6;
		case 0x00005678:
			return 0xeccf35a3;
		case 0x0000567c:
			return 0x47127f6c;
		case 0x00005680:
			return 0x79cb9dd0;
		case 0x00005684:
			return 0x69d20ee6;
		case 0x00005688:
			return 0xa8117e75;
		case 0x0000568c:
			return 0x7e73c976;
		case 0x00005690:
			return 0x8a27b0ed;
		case 0x00005694:
			return 0xbdb743d2;
		case 0x00005698:
			return 0x6dbecbe5;
		case 0x0000569c:
			return 0x8bb0b45c;
		case 0x000056a0:
			return 0x0d074dda;
		case 0x000056a4:
			return 0x7542097e;
		case 0x000056a8:
			return 0x119ec367;
		case 0x000056ac:
			return 0xdf7ecfc6;
		case 0x000056b0:
			return 0xea03fbbd;
		case 0x000056b4:
			return 0xbebe42ee;
		case 0x000056b8:
			return 0x309ebe52;
		case 0x000056bc:
			return 0x17542afe;
		case 0x000056c0:
			return 0x57528f21;
		case 0x000056c4:
			return 0xe99a4250;
		case 0x000056c8:
			return 0x2f96fe86;
		case 0x000056cc:
			return 0xa4c5f88c;
		case 0x000056d0:
			return 0x280f1585;
		case 0x000056d4:
			return 0x6f14886f;
		case 0x000056d8:
			return 0xd104b5b3;
		case 0x000056dc:
			return 0x08185ba8;
		case 0x000056e0:
			return 0x2c83d7b2;
		case 0x000056e4:
			return 0xf6c99f0a;
		case 0x000056e8:
			return 0xf61c6362;
		case 0x000056ec:
			return 0x6db0d8bf;
		case 0x000056f0:
			return 0x16ecaa02;
		case 0x000056f4:
			return 0xaff2b6a7;
		case 0x000056f8:
			return 0x73061e27;
		case 0x000056fc:
			return 0x0e3414df;
		case 0x00005700:
			return 0xa3aa3423;
		case 0x00005704:
			return 0x44251b44;
		case 0x00005708:
			return 0xf892becf;
		case 0x0000570c:
			return 0xed333a73;
		case 0x00005710:
			return 0xa76b5644;
		case 0x00005714:
			return 0xfb97e013;
		case 0x00005718:
			return 0x3a173cf2;
		case 0x0000571c:
			return 0xdf25d1f4;
		case 0x00005720:
			return 0xa1fd3519;
		case 0x00005724:
			return 0x598d381e;
		case 0x00005728:
			return 0xe1699fab;
		case 0x0000572c:
			return 0x51230ffd;
		case 0x00005730:
			return 0x4d19558f;
		case 0x00005734:
			return 0xa1855d77;
		case 0x00005738:
			return 0x99c41260;
		case 0x0000573c:
			return 0xa0a82f75;
		case 0x00005740:
			return 0x1b61ded1;
		case 0x00005744:
			return 0xe2397167;
		case 0x00005748:
			return 0x02124499;
		case 0x0000574c:
			return 0xbd613c4e;
		case 0x00005750:
			return 0x0c9dc3ec;
		case 0x00005754:
			return 0xea668441;
		case 0x00005758:
			return 0xfff996fd;
		case 0x0000575c:
			return 0x1ab7541d;
		case 0x00005760:
			return 0xd233238d;
		case 0x00005764:
			return 0x35fe77d3;
		case 0x00005768:
			return 0x42248187;
		case 0x0000576c:
			return 0xe4ebaefe;
		case 0x00005770:
			return 0xde31a2ec;
		case 0x00005774:
			return 0x768bf2e9;
		case 0x00005778:
			return 0x6c51359f;
		case 0x0000577c:
			return 0xc5462794;
		case 0x00005780:
			return 0x63373519;
		case 0x00005784:
			return 0xa7e4fef9;
		case 0x00005788:
			return 0x5c0744d9;
		case 0x0000578c:
			return 0x8902ad19;
		case 0x00005790:
			return 0xfdae0622;
		case 0x00005794:
			return 0x81542302;
		case 0x00005798:
			return 0xa7ada587;
		case 0x0000579c:
			return 0x065ed250;
		case 0x000057a0:
			return 0x57374a64;
		case 0x000057a4:
			return 0x66917e78;
		case 0x000057a8:
			return 0xdef8acc2;
		case 0x000057ac:
			return 0x258f98ff;
		case 0x000057b0:
			return 0xd28797b5;
		case 0x000057b4:
			return 0x766d6108;
		case 0x000057b8:
			return 0x423dd2f7;
		case 0x000057bc:
			return 0x4a10c5fc;
		case 0x000057c0:
			return 0xf4668381;
		case 0x000057c4:
			return 0x331ac0a1;
		case 0x000057c8:
			return 0xdecccad2;
		case 0x000057cc:
			return 0xa17c2223;
		case 0x000057d0:
			return 0x7eb417b0;
		case 0x000057d4:
			return 0xb4a832f6;
		case 0x000057d8:
			return 0xdb52c7dc;
		case 0x000057dc:
			return 0x222871f6;
		case 0x000057e0:
			return 0xff17a31c;
		case 0x000057e4:
			return 0xe221daa0;
		case 0x000057e8:
			return 0x23e09cce;
		case 0x000057ec:
			return 0x2222ff5f;
		case 0x000057f0:
			return 0x3ada0b26;
		case 0x000057f4:
			return 0x123c83b1;
		case 0x000057f8:
			return 0xec127e56;
		case 0x000057fc:
			return 0x334e3d76;
		case 0x00005800:
			return 0x5fa5dfdb;
		case 0x00005804:
			return 0xeb107951;
		case 0x00005808:
			return 0xc2560f56;
		case 0x0000580c:
			return 0xe26b3ca5;
		case 0x00005810:
			return 0x1fd99233;
		case 0x00005814:
			return 0x39b016d6;
		case 0x00005818:
			return 0xbf32c916;
		case 0x0000581c:
			return 0x4a11aaa8;
		case 0x00005820:
			return 0xeb9180dc;
		case 0x00005824:
			return 0x8b40c4f9;
		case 0x00005828:
			return 0x4ab3ae0b;
		case 0x0000582c:
			return 0x34319804;
		case 0x00005830:
			return 0x11fdddfc;
		case 0x00005834:
			return 0xe9b72232;
		case 0x00005838:
			return 0x35d8f43d;
		case 0x0000583c:
			return 0xeca00411;
		case 0x00005840:
			return 0x06c8e144;
		case 0x00005844:
			return 0x8dea39d1;
		case 0x00005848:
			return 0x78c7c354;
		case 0x0000584c:
			return 0x37349cb5;
		case 0x00005850:
			return 0xe52d65b8;
		case 0x00005854:
			return 0x18e8ddd0;
		case 0x00005858:
			return 0xdb355795;
		case 0x0000585c:
			return 0x5ccb5c28;
		case 0x00005860:
			return 0x817905d3;
		case 0x00005864:
			return 0xe3bd0354;
		case 0x00005868:
			return 0x415b2431;
		case 0x0000586c:
			return 0xec1b462e;
		case 0x00005870:
			return 0x66560140;
		case 0x00005874:
			return 0x1699f008;
		case 0x00005878:
			return 0x0c5e791a;
		case 0x0000587c:
			return 0xf093c1c1;
		case 0x00005880:
			return 0x0625b711;
		case 0x00005884:
			return 0x3a3f442d;
		case 0x00005888:
			return 0x9bc010a9;
		case 0x0000588c:
			return 0xa75ae2d2;
		case 0x00005890:
			return 0xf75f174f;
		case 0x00005894:
			return 0x268d49d2;
		case 0x00005898:
			return 0x3cd36bde;
		case 0x0000589c:
			return 0xd654d623;
		case 0x000058a0:
			return 0x1a717e3a;
		case 0x000058a4:
			return 0x5181e76c;
		case 0x000058a8:
			return 0x35f11aff;
		case 0x000058ac:
			return 0x38bb95b2;
		case 0x000058b0:
			return 0x624957ab;
		case 0x000058b4:
			return 0xa300d054;
		case 0x000058b8:
			return 0x81b7e8f4;
		case 0x000058bc:
			return 0xe2c716b5;
		case 0x000058c0:
			return 0x653fa6bf;
		case 0x000058c4:
			return 0x81b01222;
		case 0x000058c8:
			return 0xefd92c4a;
		case 0x000058cc:
			return 0x1c194cc0;
		case 0x000058d0:
			return 0x7dc35849;
		case 0x000058d4:
			return 0x7848d295;
		case 0x000058d8:
			return 0x14b8db31;
		case 0x000058dc:
			return 0x9d1c718d;
		case 0x000058e0:
			return 0x5a6667ce;
		case 0x000058e4:
			return 0x66179766;
		case 0x000058e8:
			return 0x03777f48;
		case 0x000058ec:
			return 0x3dde2fb8;
		case 0x000058f0:
			return 0x52323fd4;
		case 0x000058f4:
			return 0xbac49fd0;
		case 0x000058f8:
			return 0x7a51d36c;
		case 0x000058fc:
			return 0xd800bbc2;
		case 0x00005900:
			return 0x4bd0b002;
		case 0x00005904:
			return 0x9a754b87;
		case 0x00005908:
			return 0x6f850747;
		case 0x0000590c:
			return 0xc2035ea6;
		case 0x00005910:
			return 0xe471818f;
		case 0x00005914:
			return 0x73312e69;
		case 0x00005918:
			return 0x5c48b1c2;
		case 0x0000591c:
			return 0xe2670cff;
		case 0x00005920:
			return 0x31b44cc7;
		case 0x00005924:
			return 0x42277171;
		case 0x00005928:
			return 0x29b4dee1;
		case 0x0000592c:
			return 0xe17b8b7e;
		case 0x00005930:
			return 0x92aeb632;
		case 0x00005934:
			return 0xd4c81ed4;
		case 0x00005938:
			return 0x35efd990;
		case 0x0000593c:
			return 0xc84d8e7f;
		case 0x00005940:
			return 0x105da935;
		case 0x00005944:
			return 0x99927706;
		case 0x00005948:
			return 0x3cbbc66a;
		case 0x0000594c:
			return 0x4eb4c93d;
		case 0x00005950:
			return 0x1b0184e7;
		case 0x00005954:
			return 0x8d1ac07c;
		case 0x00005958:
			return 0x88503ef5;
		case 0x0000595c:
			return 0x6ce1f122;
		case 0x00005960:
			return 0xa4b34d84;
		case 0x00005964:
			return 0x82b83e10;
		case 0x00005968:
			return 0x5bbf0cbe;
		case 0x0000596c:
			return 0x9b1908d2;
		case 0x00005970:
			return 0xf0ad1557;
		case 0x00005974:
			return 0xb87c9921;
		case 0x00005978:
			return 0xa4a43d50;
		case 0x0000597c:
			return 0xc6b3cfe7;
		case 0x00005980:
			return 0xd31c85a1;
		case 0x00005984:
			return 0x85df0af9;
		case 0x00005988:
			return 0x194fc075;
		case 0x0000598c:
			return 0x7e696b40;
		case 0x00005990:
			return 0xc91352e0;
		case 0x00005994:
			return 0xa2b08d42;
		case 0x00005998:
			return 0xba8eb6b0;
		case 0x0000599c:
			return 0x81e45a62;
		case 0x000059a0:
			return 0x3ed1c008;
		case 0x000059a4:
			return 0xfd550acf;
		case 0x000059a8:
			return 0xd0af1358;
		case 0x000059ac:
			return 0xf66dfcc0;
		case 0x000059b0:
			return 0xe2205ac2;
		case 0x000059b4:
			return 0xedd6019d;
		case 0x000059b8:
			return 0xc8410580;
		case 0x000059bc:
			return 0xf57cf5d9;
		case 0x000059c0:
			return 0xb63af5ef;
		case 0x000059c4:
			return 0xbb0d9451;
		case 0x000059c8:
			return 0x338fad86;
		case 0x000059cc:
			return 0x977cd131;
		case 0x000059d0:
			return 0xb309d156;
		case 0x000059d4:
			return 0xcbd88e51;
		case 0x000059d8:
			return 0x89f16ed8;
		case 0x000059dc:
			return 0xbdd0e0ff;
		case 0x000059e0:
			return 0xa51e57c9;
		case 0x000059e4:
			return 0xa2825012;
		case 0x000059e8:
			return 0x950b7119;
		case 0x000059ec:
			return 0x58a11408;
		case 0x000059f0:
			return 0x76129010;
		case 0x000059f4:
			return 0xe2bbfb7e;
		case 0x000059f8:
			return 0xb0285554;
		case 0x000059fc:
			return 0xf9ecf780;
		case 0x00005a00:
			return 0x5971b670;
		case 0x00005a04:
			return 0xad7eb3e2;
		case 0x00005a08:
			return 0xf9abbd91;
		case 0x00005a0c:
			return 0x03c1e649;
		case 0x00005a10:
			return 0xaef54240;
		case 0x00005a14:
			return 0xcf80cea1;
		case 0x00005a18:
			return 0x770198b0;
		case 0x00005a1c:
			return 0x9f57c639;
		case 0x00005a20:
			return 0x261b179a;
		case 0x00005a24:
			return 0xa771fcb9;
		case 0x00005a28:
			return 0xbc233e56;
		case 0x00005a2c:
			return 0x84fb6626;
		case 0x00005a30:
			return 0xa32d9ff7;
		case 0x00005a34:
			return 0xd224f67b;
		case 0x00005a38:
			return 0x65de1ea1;
		case 0x00005a3c:
			return 0x34f2e7c0;
		case 0x00005a40:
			return 0x08c45302;
		case 0x00005a44:
			return 0xffc2583f;
		case 0x00005a48:
			return 0xcf8df07d;
		case 0x00005a4c:
			return 0x89cfbafb;
		case 0x00005a50:
			return 0x469e7c8e;
		case 0x00005a54:
			return 0x1f1f5226;
		case 0x00005a58:
			return 0x94aa327e;
		case 0x00005a5c:
			return 0xbbea1571;
		case 0x00005a60:
			return 0xdca3169a;
		case 0x00005a64:
			return 0x3bf6203c;
		case 0x00005a68:
			return 0xf7b2f37d;
		case 0x00005a6c:
			return 0xab513721;
		case 0x00005a70:
			return 0x70ebf24a;
		case 0x00005a74:
			return 0x21d6ba98;
		case 0x00005a78:
			return 0xa364d215;
		case 0x00005a7c:
			return 0xf17131cf;
		case 0x00005a80:
			return 0x37fcb074;
		case 0x00005a84:
			return 0xa225d22f;
		case 0x00005a88:
			return 0x0efbe415;
		case 0x00005a8c:
			return 0x13254c88;
		case 0x00005a90:
			return 0xb27242c4;
		case 0x00005a94:
			return 0x4a35b6e2;
		case 0x00005a98:
			return 0x9ac22034;
		case 0x00005a9c:
			return 0xf707a119;
		case 0x00005aa0:
			return 0x235c7f86;
		case 0x00005aa4:
			return 0x92a36d96;
		case 0x00005aa8:
			return 0x03e518d0;
		case 0x00005aac:
			return 0x699caa55;
		case 0x00005ab0:
			return 0xb1188464;
		case 0x00005ab4:
			return 0x0ea96485;
		case 0x00005ab8:
			return 0x75412f91;
		case 0x00005abc:
			return 0xe25123b0;
		case 0x00005ac0:
			return 0xf9daa010;
		case 0x00005ac4:
			return 0x23961261;
		case 0x00005ac8:
			return 0xbca4ce0b;
		case 0x00005acc:
			return 0x2b194c96;
		case 0x00005ad0:
			return 0xde90d7a8;
		case 0x00005ad4:
			return 0x3e722892;
		case 0x00005ad8:
			return 0x33ac6a25;
		case 0x00005adc:
			return 0xbc2de908;
		case 0x00005ae0:
			return 0x653cb05d;
		case 0x00005ae4:
			return 0x86da1ffe;
		case 0x00005ae8:
			return 0xbd311781;
		case 0x00005aec:
			return 0x4ffde820;
		case 0x00005af0:
			return 0x0d09772c;
		case 0x00005af4:
			return 0xd46a8c8c;
		case 0x00005af8:
			return 0x7c3fd36f;
		case 0x00005afc:
			return 0xe7cb5c66;
		case 0x00005b00:
			return 0xf6ba0bbf;
		case 0x00005b04:
			return 0xd775b340;
		case 0x00005b08:
			return 0x6b0003f6;
		case 0x00005b0c:
			return 0xdcbf1345;
		case 0x00005b10:
			return 0xc5d16384;
		case 0x00005b14:
			return 0x957fd4d2;
		case 0x00005b18:
			return 0x918cdd5c;
		case 0x00005b1c:
			return 0xc3346b68;
		case 0x00005b20:
			return 0x0f3ef3d4;
		case 0x00005b24:
			return 0xb9257ba7;
		case 0x00005b28:
			return 0x75d988df;
		case 0x00005b2c:
			return 0x53f46465;
		case 0x00005b30:
			return 0x556e4cab;
		case 0x00005b34:
			return 0xb24bed84;
		case 0x00005b38:
			return 0x11870151;
		case 0x00005b3c:
			return 0xda0b2d3c;
		case 0x00005b40:
			return 0xd7144755;
		case 0x00005b44:
			return 0xfa045185;
		case 0x00005b48:
			return 0xf419accd;
		case 0x00005b4c:
			return 0x4679122e;
		case 0x00005b50:
			return 0x056a3529;
		case 0x00005b54:
			return 0x51fba812;
		case 0x00005b58:
			return 0x8c2ce097;
		case 0x00005b5c:
			return 0x335c16ae;
		case 0x00005b60:
			return 0xcdc1ea9f;
		case 0x00005b64:
			return 0x997e4d6a;
		case 0x00005b68:
			return 0xbfacc6d5;
		case 0x00005b6c:
			return 0xcb21c5ef;
		case 0x00005b70:
			return 0x63224f93;
		case 0x00005b74:
			return 0x01b2176b;
		case 0x00005b78:
			return 0xd24053c6;
		case 0x00005b7c:
			return 0x5f66aa9c;
		case 0x00005b80:
			return 0xe73fa84a;
		case 0x00005b84:
			return 0x3ad2e805;
		case 0x00005b88:
			return 0xf2e4ab14;
		case 0x00005b8c:
			return 0x89f64aa6;
		case 0x00005b90:
			return 0x242ffc71;
		case 0x00005b94:
			return 0xe5c4ea8a;
		case 0x00005b98:
			return 0x079aeeef;
		case 0x00005b9c:
			return 0x69f8654a;
		case 0x00005ba0:
			return 0x3702814b;
		case 0x00005ba4:
			return 0x3f5a8bc2;
		case 0x00005ba8:
			return 0xabfc917e;
		case 0x00005bac:
			return 0x91120900;
		case 0x00005bb0:
			return 0x93138a03;
		case 0x00005bb4:
			return 0xc2989664;
		case 0x00005bb8:
			return 0x3e80a255;
		case 0x00005bbc:
			return 0x07c36c83;
		case 0x00005bc0:
			return 0x80c60a55;
		case 0x00005bc4:
			return 0xe3bbb36c;
		case 0x00005bc8:
			return 0x2c4d6570;
		case 0x00005bcc:
			return 0x2fa26d7b;
		case 0x00005bd0:
			return 0x15b0e39f;
		case 0x00005bd4:
			return 0xf9ebc00f;
		case 0x00005bd8:
			return 0xfa7843cc;
		case 0x00005bdc:
			return 0xd1d8e0f6;
		case 0x00005be0:
			return 0x5948cecf;
		case 0x00005be4:
			return 0x83187683;
		case 0x00005be8:
			return 0x3180753d;
		case 0x00005bec:
			return 0xf3b30412;
		case 0x00005bf0:
			return 0xecbbfa06;
		case 0x00005bf4:
			return 0x0f68ac86;
		case 0x00005bf8:
			return 0x91d7521a;
		case 0x00005bfc:
			return 0x4f1ffe87;
		case 0x00005c00:
			return 0x5a37cb71;
		case 0x00005c04:
			return 0x7e3f25a2;
		case 0x00005c08:
			return 0x57eab31c;
		case 0x00005c0c:
			return 0x2da3639c;
		case 0x00005c10:
			return 0x986a6607;
		case 0x00005c14:
			return 0xbb60673e;
		case 0x00005c18:
			return 0x18f3ba68;
		case 0x00005c1c:
			return 0x63d91ae4;
		case 0x00005c20:
			return 0x0b18d649;
		case 0x00005c24:
			return 0xe40ec5ba;
		case 0x00005c28:
			return 0x18dbee32;
		case 0x00005c2c:
			return 0xb81dd15f;
		case 0x00005c30:
			return 0x736ae4cb;
		case 0x00005c34:
			return 0x315a1553;
		case 0x00005c38:
			return 0x642cd90b;
		case 0x00005c3c:
			return 0x88c1b0bc;
		case 0x00005c40:
			return 0x5ca3dc82;
		case 0x00005c44:
			return 0xed7e1391;
		case 0x00005c48:
			return 0x499807ce;
		case 0x00005c4c:
			return 0x59b7abe2;
		case 0x00005c50:
			return 0xef304286;
		case 0x00005c54:
			return 0x5eeb4a5f;
		case 0x00005c58:
			return 0x1b9aecfe;
		case 0x00005c5c:
			return 0xba95e569;
		case 0x00005c60:
			return 0x6fe6ebc0;
		case 0x00005c64:
			return 0xe8082600;
		case 0x00005c68:
			return 0xfb364906;
		case 0x00005c6c:
			return 0xfa998457;
		case 0x00005c70:
			return 0x6a950b1d;
		case 0x00005c74:
			return 0x8ea994c5;
		case 0x00005c78:
			return 0x8d8ad13c;
		case 0x00005c7c:
			return 0x8087feec;
		case 0x00005c80:
			return 0x1dc20b63;
		case 0x00005c84:
			return 0xb725fd73;
		case 0x00005c88:
			return 0x4c51f0bd;
		case 0x00005c8c:
			return 0x3953cfe4;
		case 0x00005c90:
			return 0x1c88441e;
		case 0x00005c94:
			return 0x112f31a4;
		case 0x00005c98:
			return 0xca2867b0;
		case 0x00005c9c:
			return 0x0216d4db;
		case 0x00005ca0:
			return 0x0b2d2ab0;
		case 0x00005ca4:
			return 0xa4843604;
		case 0x00005ca8:
			return 0x8cba99dd;
		case 0x00005cac:
			return 0x0cbd91db;
		case 0x00005cb0:
			return 0x62ccfdd6;
		case 0x00005cb4:
			return 0x52713c60;
		case 0x00005cb8:
			return 0x7ca94c6d;
		case 0x00005cbc:
			return 0xb120ad51;
		case 0x00005cc0:
			return 0x57193d3c;
		case 0x00005cc4:
			return 0x2ce0784e;
		case 0x00005cc8:
			return 0xa1b413ee;
		case 0x00005ccc:
			return 0x5dc2fe0c;
		case 0x00005cd0:
			return 0x2f56b6d4;
		case 0x00005cd4:
			return 0x03f55026;
		case 0x00005cd8:
			return 0x17d83c1a;
		case 0x00005cdc:
			return 0xbbfed1f4;
		case 0x00005ce0:
			return 0x13b06f1c;
		case 0x00005ce4:
			return 0x9570766d;
		case 0x00005ce8:
			return 0xae7a5a03;
		case 0x00005cec:
			return 0x808a5320;
		case 0x00005cf0:
			return 0x68dd733d;
		case 0x00005cf4:
			return 0x91c65951;
		case 0x00005cf8:
			return 0xed934efb;
		case 0x00005cfc:
			return 0xc0177f2c;
		case 0x00005d00:
			return 0x6ce4eabd;
		case 0x00005d04:
			return 0x3869e560;
		case 0x00005d08:
			return 0x553e169e;
		case 0x00005d0c:
			return 0xd25794c5;
		case 0x00005d10:
			return 0x61e232a7;
		case 0x00005d14:
			return 0xf755b707;
		case 0x00005d18:
			return 0xc3ef9158;
		case 0x00005d1c:
			return 0xcdee5934;
		case 0x00005d20:
			return 0x6d60eb72;
		case 0x00005d24:
			return 0xf05aa0c6;
		case 0x00005d28:
			return 0x9e578321;
		case 0x00005d2c:
			return 0x64d7ef57;
		case 0x00005d30:
			return 0x61c1ebee;
		case 0x00005d34:
			return 0xa571b366;
		case 0x00005d38:
			return 0x06089e39;
		case 0x00005d3c:
			return 0x5a907e19;
		case 0x00005d40:
			return 0x955533b1;
		case 0x00005d44:
			return 0x5e10ce4a;
		case 0x00005d48:
			return 0xb9d2d74d;
		case 0x00005d4c:
			return 0x0f5cfbd5;
		case 0x00005d50:
			return 0x568b9ccd;
		case 0x00005d54:
			return 0x546b1b54;
		case 0x00005d58:
			return 0xb9f17821;
		case 0x00005d5c:
			return 0x08683763;
		case 0x00005d60:
			return 0x0961424b;
		case 0x00005d64:
			return 0xf8c0b4ad;
		case 0x00005d68:
			return 0x40a9c6a8;
		case 0x00005d6c:
			return 0xe4211a23;
		case 0x00005d70:
			return 0x0cf52313;
		case 0x00005d74:
			return 0xe7713d91;
		case 0x00005d78:
			return 0x32f58814;
		case 0x00005d7c:
			return 0x8b1a75f2;
		case 0x00005d80:
			return 0xcec47d87;
		case 0x00005d84:
			return 0xba59883b;
		case 0x00005d88:
			return 0x1c844223;
		case 0x00005d8c:
			return 0xb1f22374;
		case 0x00005d90:
			return 0x9dcfb079;
		case 0x00005d94:
			return 0x3174a326;
		case 0x00005d98:
			return 0x3bd145f1;
		case 0x00005d9c:
			return 0x75e908f1;
		case 0x00005da0:
			return 0xf6635edb;
		case 0x00005da4:
			return 0xc065b825;
		case 0x00005da8:
			return 0x6f98e23d;
		case 0x00005dac:
			return 0xdebb7df3;
		case 0x00005db0:
			return 0xf82b5b0e;
		case 0x00005db4:
			return 0x1101e58d;
		case 0x00005db8:
			return 0xf36ffba8;
		case 0x00005dbc:
			return 0x613f8828;
		case 0x00005dc0:
			return 0x3677d80d;
		case 0x00005dc4:
			return 0x680110a9;
		case 0x00005dc8:
			return 0x6e0d53ca;
		case 0x00005dcc:
			return 0x648ced1f;
		case 0x00005dd0:
			return 0x0b97cb9f;
		case 0x00005dd4:
			return 0xa2fd10cc;
		case 0x00005dd8:
			return 0x2fd7c331;
		case 0x00005ddc:
			return 0xef0dd701;
		case 0x00005de0:
			return 0xc030e230;
		case 0x00005de4:
			return 0x0298e745;
		case 0x00005de8:
			return 0x845d5cd2;
		case 0x00005dec:
			return 0x7fc72bf4;
		case 0x00005df0:
			return 0xbeb59c3d;
		case 0x00005df4:
			return 0x8967bd75;
		case 0x00005df8:
			return 0x5fd5f84c;
		case 0x00005dfc:
			return 0xd5fd5b9c;
		case 0x00005e00:
			return 0xd0c53700;
		case 0x00005e04:
			return 0x8e03d433;
		case 0x00005e08:
			return 0x50936196;
		case 0x00005e0c:
			return 0x3ba981f6;
		case 0x00005e10:
			return 0x752f941e;
		case 0x00005e14:
			return 0x0782283d;
		case 0x00005e18:
			return 0x076ba988;
		case 0x00005e1c:
			return 0x356818b1;
		case 0x00005e20:
			return 0x1f8aa82b;
		case 0x00005e24:
			return 0x29ef160d;
		case 0x00005e28:
			return 0x5dfe1733;
		case 0x00005e2c:
			return 0x87b41b7d;
		case 0x00005e30:
			return 0xa8507dfa;
		case 0x00005e34:
			return 0x8fb5baee;
		case 0x00005e38:
			return 0x16d4a003;
		case 0x00005e3c:
			return 0x88a90c28;
		case 0x00005e40:
			return 0x894d5b3b;
		case 0x00005e44:
			return 0x473a5d66;
		case 0x00005e48:
			return 0x391663ed;
		case 0x00005e4c:
			return 0x8330d06e;
		case 0x00005e50:
			return 0x1644352e;
		case 0x00005e54:
			return 0xe366d0e2;
		case 0x00005e58:
			return 0xbf39ab2f;
		case 0x00005e5c:
			return 0xa60f6728;
		case 0x00005e60:
			return 0xd1721843;
		case 0x00005e64:
			return 0xf99f0ff1;
		case 0x00005e68:
			return 0x1cf77302;
		case 0x00005e6c:
			return 0xc92394c8;
		case 0x00005e70:
			return 0x0ab8be4e;
		case 0x00005e74:
			return 0xed2d55fa;
		case 0x00005e78:
			return 0xcc046b8b;
		case 0x00005e7c:
			return 0xed9dabbd;
		case 0x00005e80:
			return 0x5d1ed809;
		case 0x00005e84:
			return 0x1480720e;
		case 0x00005e88:
			return 0x511bc940;
		case 0x00005e8c:
			return 0x313bfc66;
		case 0x00005e90:
			return 0xf5380336;
		case 0x00005e94:
			return 0x9183e7a7;
		case 0x00005e98:
			return 0x11b8549d;
		case 0x00005e9c:
			return 0xf8dd351f;
		case 0x00005ea0:
			return 0x32d5910d;
		case 0x00005ea4:
			return 0x4f921f04;
		case 0x00005ea8:
			return 0x44e34594;
		case 0x00005eac:
			return 0x671a59e0;
		case 0x00005eb0:
			return 0x528eb473;
		case 0x00005eb4:
			return 0xcfa360d8;
		case 0x00005eb8:
			return 0x708d7149;
		case 0x00005ebc:
			return 0x1a783fec;
		case 0x00005ec0:
			return 0x70a15882;
		case 0x00005ec4:
			return 0x84fb8f69;
		case 0x00005ec8:
			return 0x77992679;
		case 0x00005ecc:
			return 0x28ed7ddc;
		case 0x00005ed0:
			return 0x97e616be;
		case 0x00005ed4:
			return 0x26318f11;
		case 0x00005ed8:
			return 0xa3eb407e;
		case 0x00005edc:
			return 0xb4ba0531;
		case 0x00005ee0:
			return 0x33e069f4;
		case 0x00005ee4:
			return 0xdb602d50;
		case 0x00005ee8:
			return 0x3c4a29fd;
		case 0x00005eec:
			return 0x73c1d628;
		case 0x00005ef0:
			return 0x93ee8b06;
		case 0x00005ef4:
			return 0x37dd15a8;
		case 0x00005ef8:
			return 0xa353f136;
		case 0x00005efc:
			return 0x0e130673;
		case 0x00005f00:
			return 0x9c9324f8;
		case 0x00005f04:
			return 0xdc8071d5;
		case 0x00005f08:
			return 0x9e5d324a;
		case 0x00005f0c:
			return 0x8cdf5a28;
		case 0x00005f10:
			return 0x71c5bb2e;
		case 0x00005f14:
			return 0xfe1be736;
		case 0x00005f18:
			return 0x09fa0bd3;
		case 0x00005f1c:
			return 0x6c0e3c5a;
		case 0x00005f20:
			return 0x06336c3b;
		case 0x00005f24:
			return 0x98a1e300;
		case 0x00005f28:
			return 0x7fad3b9c;
		case 0x00005f2c:
			return 0xc4527723;
		case 0x00005f30:
			return 0xdd30e5d0;
		case 0x00005f34:
			return 0xd0460459;
		case 0x00005f38:
			return 0x0ec7392c;
		case 0x00005f3c:
			return 0x477a6c20;
		case 0x00005f40:
			return 0x86a78ae5;
		case 0x00005f44:
			return 0xf6e7acdc;
		case 0x00005f48:
			return 0x0493693b;
		case 0x00005f4c:
			return 0xeb037ed6;
		case 0x00005f50:
			return 0x7b4c81e2;
		case 0x00005f54:
			return 0xe7b9d0dd;
		case 0x00005f58:
			return 0xf1826776;
		case 0x00005f5c:
			return 0xfca9079a;
		case 0x00005f60:
			return 0xb8691b29;
		case 0x00005f64:
			return 0xa1e34b8b;
		case 0x00005f68:
			return 0xbe7c4e8f;
		case 0x00005f6c:
			return 0x7da10157;
		case 0x00005f70:
			return 0xfc7fe5fb;
		case 0x00005f74:
			return 0xc51d4973;
		case 0x00005f78:
			return 0x64790418;
		case 0x00005f7c:
			return 0x80631a5c;
		case 0x00005f80:
			return 0x8c7f3c65;
		case 0x00005f84:
			return 0xcb2f373e;
		case 0x00005f88:
			return 0x4ff4cb88;
		case 0x00005f8c:
			return 0x4beb3d76;
		case 0x00005f90:
			return 0x620fba74;
		case 0x00005f94:
			return 0x8cb2fdeb;
		case 0x00005f98:
			return 0xf81b36ae;
		case 0x00005f9c:
			return 0xf273bf4d;
		case 0x00005fa0:
			return 0x4a1e286b;
		case 0x00005fa4:
			return 0x150da1eb;
		case 0x00005fa8:
			return 0x0ebc46d9;
		case 0x00005fac:
			return 0xc070ea06;
		case 0x00005fb0:
			return 0x8a2e3340;
		case 0x00005fb4:
			return 0x1bea603d;
		case 0x00005fb8:
			return 0x4e0ff85c;
		case 0x00005fbc:
			return 0xa2aa9c02;
		case 0x00005fc0:
			return 0x23cd87d2;
		case 0x00005fc4:
			return 0x230c8e3e;
		case 0x00005fc8:
			return 0x34be08f9;
		case 0x00005fcc:
			return 0x164749fb;
		case 0x00005fd0:
			return 0xb6e7b18c;
		case 0x00005fd4:
			return 0xd59c8cf9;
		case 0x00005fd8:
			return 0xf5686f60;
		case 0x00005fdc:
			return 0x4eda978f;
		case 0x00005fe0:
			return 0xa0b0421b;
		case 0x00005fe4:
			return 0x6337c4be;
		case 0x00005fe8:
			return 0xc01a7b5c;
		case 0x00005fec:
			return 0x1968db2c;
		case 0x00005ff0:
			return 0x188b0da1;
		case 0x00005ff4:
			return 0xd0ea4416;
		case 0x00005ff8:
			return 0x95a9384c;
		case 0x00005ffc:
			return 0xd8654203;
		case 0x00006000:
			return 0x4d57fd19;
		case 0x00006004:
			return 0x396e1d53;
		case 0x00006008:
			return 0xa537f96a;
		case 0x0000600c:
			return 0xdd8c4040;
		case 0x00006010:
			return 0xf044bebf;
		case 0x00006014:
			return 0xcf9506aa;
		case 0x00006018:
			return 0xad1c7ed6;
		case 0x0000601c:
			return 0xdfd9f2fc;
		case 0x00006020:
			return 0xab86e918;
		case 0x00006024:
			return 0x7d14cca3;
		case 0x00006028:
			return 0x8b1f861c;
		case 0x0000602c:
			return 0x6cfbeb99;
		case 0x00006030:
			return 0x2a6ce44f;
		case 0x00006034:
			return 0xdb52d6e2;
		case 0x00006038:
			return 0x16de4a79;
		case 0x0000603c:
			return 0x384999de;
		case 0x00006040:
			return 0x2445aeea;
		case 0x00006044:
			return 0x945b08be;
		case 0x00006048:
			return 0x953e8584;
		case 0x0000604c:
			return 0x1b9ce1f3;
		case 0x00006050:
			return 0xab46cc65;
		case 0x00006054:
			return 0x987cdb48;
		case 0x00006058:
			return 0x2b449919;
		case 0x0000605c:
			return 0xa6a3ec6e;
		case 0x00006060:
			return 0x0973825d;
		case 0x00006064:
			return 0xff008f0e;
		case 0x00006068:
			return 0xed212e87;
		case 0x0000606c:
			return 0x8dbe3232;
		case 0x00006070:
			return 0x7b0fdf92;
		case 0x00006074:
			return 0x6a1f1038;
		case 0x00006078:
			return 0x2f94be5f;
		case 0x0000607c:
			return 0x2965ff56;
		case 0x00006080:
			return 0xadc04d72;
		case 0x00006084:
			return 0xdcba00ea;
		case 0x00006088:
			return 0x6dbf45a0;
		case 0x0000608c:
			return 0xb7bd5f1b;
		case 0x00006090:
			return 0x0e898064;
		case 0x00006094:
			return 0xce59cadf;
		case 0x00006098:
			return 0xa8aa672b;
		case 0x0000609c:
			return 0x9ceca5bd;
		case 0x000060a0:
			return 0x9c83b03e;
		case 0x000060a4:
			return 0xca4fee7a;
		case 0x000060a8:
			return 0xfe5b1cc1;
		case 0x000060ac:
			return 0x47fcc55c;
		case 0x000060b0:
			return 0x6ac9aece;
		case 0x000060b4:
			return 0xae5c8893;
		case 0x000060b8:
			return 0x2b1675fc;
		case 0x000060bc:
			return 0x6580682b;
		case 0x000060c0:
			return 0x2e586b25;
		case 0x000060c4:
			return 0x87e7d06a;
		case 0x000060c8:
			return 0x231cdc33;
		case 0x000060cc:
			return 0xfc1421cc;
		case 0x000060d0:
			return 0x9d947ead;
		case 0x000060d4:
			return 0x78708e42;
		case 0x000060d8:
			return 0xf7bc2dd3;
		case 0x000060dc:
			return 0x12c8228e;
		case 0x000060e0:
			return 0x00797585;
		case 0x000060e4:
			return 0x0ba7f70c;
		case 0x000060e8:
			return 0xf5c636fe;
		case 0x000060ec:
			return 0xb6a100de;
		case 0x000060f0:
			return 0xc20ab948;
		case 0x000060f4:
			return 0x4a649a80;
		case 0x000060f8:
			return 0x79f17c74;
		case 0x000060fc:
			return 0xa4bc7d13;
		case 0x00006100:
			return 0xcfbc2ad9;
		case 0x00006104:
			return 0xb86222c5;
		case 0x00006108:
			return 0xd0874547;
		case 0x0000610c:
			return 0x0df3f969;
		case 0x00006110:
			return 0x3686dcb0;
		case 0x00006114:
			return 0x877c7f34;
		case 0x00006118:
			return 0x60d984c9;
		case 0x0000611c:
			return 0xb2fea9b7;
		case 0x00006120:
			return 0x93e46919;
		case 0x00006124:
			return 0xc1646c88;
		case 0x00006128:
			return 0x087b2621;
		case 0x0000612c:
			return 0x98dd44b6;
		case 0x00006130:
			return 0xb00d6b04;
		case 0x00006134:
			return 0x5ccd190b;
		case 0x00006138:
			return 0x48a77ea6;
		case 0x0000613c:
			return 0xbe8c85b3;
		case 0x00006140:
			return 0xe09bdba0;
		case 0x00006144:
			return 0x056feec7;
		case 0x00006148:
			return 0xb16f4f00;
		case 0x0000614c:
			return 0x67aa3914;
		case 0x00006150:
			return 0x2f955fe8;
		case 0x00006154:
			return 0x51d095bd;
		case 0x00006158:
			return 0x6b68a26f;
		case 0x0000615c:
			return 0xdf79c163;
		case 0x00006160:
			return 0x8dde6526;
		case 0x00006164:
			return 0x8dd85e87;
		case 0x00006168:
			return 0xb07ba2c7;
		case 0x0000616c:
			return 0x65cd56b8;
		case 0x00006170:
			return 0xbd7ceb4d;
		case 0x00006174:
			return 0xe25c5eb4;
		case 0x00006178:
			return 0xed403a9b;
		case 0x0000617c:
			return 0xb65b9606;
		case 0x00006180:
			return 0xe9e14412;
		case 0x00006184:
			return 0x662fef37;
		case 0x00006188:
			return 0x42e5f4d0;
		case 0x0000618c:
			return 0xe6a51175;
		case 0x00006190:
			return 0x8d8796e7;
		case 0x00006194:
			return 0x3242afec;
		case 0x00006198:
			return 0x7ff2f721;
		case 0x0000619c:
			return 0x30955f75;
		case 0x000061a0:
			return 0xcca11655;
		case 0x000061a4:
			return 0xdefc8ffb;
		case 0x000061a8:
			return 0x21082ad2;
		case 0x000061ac:
			return 0xe2eddec1;
		case 0x000061b0:
			return 0xedc48d16;
		case 0x000061b4:
			return 0xedc74d94;
		case 0x000061b8:
			return 0xb0c9bc6d;
		case 0x000061bc:
			return 0x79177b3f;
		case 0x000061c0:
			return 0x60131145;
		case 0x000061c4:
			return 0xbb1ce772;
		case 0x000061c8:
			return 0x28afbe4a;
		case 0x000061cc:
			return 0x0d093396;
		case 0x000061d0:
			return 0xcff27b82;
		case 0x000061d4:
			return 0x732a8d90;
		case 0x000061d8:
			return 0xca767410;
		case 0x000061dc:
			return 0x1dd2ff27;
		case 0x000061e0:
			return 0x64bedd40;
		case 0x000061e4:
			return 0x2d21c6ff;
		case 0x000061e8:
			return 0xed9e7045;
		case 0x000061ec:
			return 0xbc676514;
		case 0x000061f0:
			return 0xb668ef62;
		case 0x000061f4:
			return 0x8d3512c1;
		case 0x000061f8:
			return 0x15d80979;
		case 0x000061fc:
			return 0xa8584b47;
		case 0x00006200:
			return 0x679e73e6;
		case 0x00006204:
			return 0xa93e5002;
		case 0x00006208:
			return 0xa8d7d8a9;
		case 0x0000620c:
			return 0x805933c7;
		case 0x00006210:
			return 0x27182118;
		case 0x00006214:
			return 0xafda3e45;
		case 0x00006218:
			return 0x12d5a9a4;
		case 0x0000621c:
			return 0xcbfed1c2;
		case 0x00006220:
			return 0xd9470d43;
		case 0x00006224:
			return 0xcb2d7a33;
		case 0x00006228:
			return 0xe10416ca;
		case 0x0000622c:
			return 0xc395661d;
		case 0x00006230:
			return 0x08dd2b7a;
		case 0x00006234:
			return 0xead1ca98;
		case 0x00006238:
			return 0xfb25ab4a;
		case 0x0000623c:
			return 0xff53b7ff;
		case 0x00006240:
			return 0x1c0814be;
		case 0x00006244:
			return 0x547f4674;
		case 0x00006248:
			return 0x883c5c56;
		case 0x0000624c:
			return 0x5b46f637;
		case 0x00006250:
			return 0xffcd32aa;
		case 0x00006254:
			return 0x88e5680c;
		case 0x00006258:
			return 0xd628e8eb;
		case 0x0000625c:
			return 0xfc353b8b;
		case 0x00006260:
			return 0x98bb1608;
		case 0x00006264:
			return 0xf63b6cb2;
		case 0x00006268:
			return 0x9b358747;
		case 0x0000626c:
			return 0xe1679f83;
		case 0x00006270:
			return 0xc93356a2;
		case 0x00006274:
			return 0x33acd0b9;
		case 0x00006278:
			return 0x45d338a8;
		case 0x0000627c:
			return 0xf2333c85;
		case 0x00006280:
			return 0xc3de83ff;
		case 0x00006284:
			return 0xf06a82da;
		case 0x00006288:
			return 0x1f91de9f;
		case 0x0000628c:
			return 0xda9d4272;
		case 0x00006290:
			return 0x84b1830d;
		case 0x00006294:
			return 0x7fc9b8be;
		case 0x00006298:
			return 0x3adff77a;
		case 0x0000629c:
			return 0xbbcf651b;
		case 0x000062a0:
			return 0xea19c54a;
		case 0x000062a4:
			return 0x1e5d7faa;
		case 0x000062a8:
			return 0x27160e5f;
		case 0x000062ac:
			return 0x3953696f;
		case 0x000062b0:
			return 0x2e9444be;
		case 0x000062b4:
			return 0xff648a0a;
		case 0x000062b8:
			return 0x6fdc35ac;
		case 0x000062bc:
			return 0x75a43eeb;
		case 0x000062c0:
			return 0x8307dd0c;
		case 0x000062c4:
			return 0x3aa10690;
		case 0x000062c8:
			return 0xf11f6199;
		case 0x000062cc:
			return 0x4d3a5a27;
		case 0x000062d0:
			return 0xe1ab04b8;
		case 0x000062d4:
			return 0xfe11309b;
		case 0x000062d8:
			return 0x66b1ce9c;
		case 0x000062dc:
			return 0x32a22abb;
		case 0x000062e0:
			return 0x2e5bc7b6;
		case 0x000062e4:
			return 0xd70104bc;
		case 0x000062e8:
			return 0xb3b69ece;
		case 0x000062ec:
			return 0x3d3ac85a;
		case 0x000062f0:
			return 0x6249fb98;
		case 0x000062f4:
			return 0xb6c659e0;
		case 0x000062f8:
			return 0x66571895;
		case 0x000062fc:
			return 0x47ef4adb;
		case 0x00006300:
			return 0xad9131c7;
		case 0x00006304:
			return 0x3a4a2a85;
		case 0x00006308:
			return 0x22e163b9;
		case 0x0000630c:
			return 0x9861c541;
		case 0x00006310:
			return 0xde866720;
		case 0x00006314:
			return 0x5d7774f8;
		case 0x00006318:
			return 0x159b28de;
		case 0x0000631c:
			return 0x62725206;
		case 0x00006320:
			return 0x2567e7c2;
		case 0x00006324:
			return 0x725c436a;
		case 0x00006328:
			return 0x05a98732;
		case 0x0000632c:
			return 0xd86d15aa;
		case 0x00006330:
			return 0xbe7fe2fe;
		case 0x00006334:
			return 0x1712f31e;
		case 0x00006338:
			return 0x028200e6;
		case 0x0000633c:
			return 0x916bb078;
		case 0x00006340:
			return 0xf54d2fe2;
		case 0x00006344:
			return 0x44c758f8;
		case 0x00006348:
			return 0x599b9445;
		case 0x0000634c:
			return 0xa152e419;
		case 0x00006350:
			return 0xff753449;
		case 0x00006354:
			return 0x16a32acc;
		case 0x00006358:
			return 0x14782e10;
		case 0x0000635c:
			return 0x14d70b40;
		case 0x00006360:
			return 0x674d38bd;
		case 0x00006364:
			return 0xa9773e3b;
		case 0x00006368:
			return 0xb4e9a0c2;
		case 0x0000636c:
			return 0x134490da;
		case 0x00006370:
			return 0xaf38c3b9;
		case 0x00006374:
			return 0xca493995;
		case 0x00006378:
			return 0xf499ddb2;
		case 0x0000637c:
			return 0xccf97ef0;
		case 0x00006380:
			return 0x40bc81ba;
		case 0x00006384:
			return 0xe8cd3986;
		case 0x00006388:
			return 0x44eb2983;
		case 0x0000638c:
			return 0xbb4f666a;
		case 0x00006390:
			return 0x1a928e81;
		case 0x00006394:
			return 0x3e091bc8;
		case 0x00006398:
			return 0xd1ba61c2;
		case 0x0000639c:
			return 0xeeccc223;
		case 0x000063a0:
			return 0x6d6034b9;
		case 0x000063a4:
			return 0x2e9be8ea;
		case 0x000063a8:
			return 0x65abadfc;
		case 0x000063ac:
			return 0xe98c9e23;
		case 0x000063b0:
			return 0xa952843a;
		case 0x000063b4:
			return 0x414a8228;
		case 0x000063b8:
			return 0x64428e8c;
		case 0x000063bc:
			return 0x9ed4353a;
		case 0x000063c0:
			return 0x7e2be87b;
		case 0x000063c4:
			return 0xfb80d4b8;
		case 0x000063c8:
			return 0xd8e3f5d4;
		case 0x000063cc:
			return 0x95d580bb;
		case 0x000063d0:
			return 0x74548c9f;
		case 0x000063d4:
			return 0x2570bac4;
		case 0x000063d8:
			return 0x1b78e181;
		case 0x000063dc:
			return 0x2fc4d4a7;
		case 0x000063e0:
			return 0x2b8a6a42;
		case 0x000063e4:
			return 0xab948026;
		case 0x000063e8:
			return 0xd2165a06;
		case 0x000063ec:
			return 0x42b568ce;
		case 0x000063f0:
			return 0x5ec823bc;
		case 0x000063f4:
			return 0x1b1a8a7a;
		case 0x000063f8:
			return 0x60df1892;
		case 0x000063fc:
			return 0x9a538981;
		case 0x00006400:
			return 0xc81d0542;
		case 0x00006404:
			return 0x74ca077b;
		case 0x00006408:
			return 0xf3e2a7d3;
		case 0x0000640c:
			return 0x288317f2;
		case 0x00006410:
			return 0xcd95fb1e;
		case 0x00006414:
			return 0x2782e4ef;
		case 0x00006418:
			return 0x30c965bd;
		case 0x0000641c:
			return 0x4900c9b9;
		case 0x00006420:
			return 0x71850fc0;
		case 0x00006424:
			return 0xeeb45ec5;
		case 0x00006428:
			return 0x63d14023;
		case 0x0000642c:
			return 0x74247daa;
		case 0x00006430:
			return 0x60c28883;
		case 0x00006434:
			return 0x38f0bf42;
		case 0x00006438:
			return 0x363cce13;
		case 0x0000643c:
			return 0x3ae7e632;
		case 0x00006440:
			return 0x18fb4eb6;
		case 0x00006444:
			return 0xad31645f;
		case 0x00006448:
			return 0xbc75e1ed;
		case 0x0000644c:
			return 0x8ef92127;
		case 0x00006450:
			return 0x57995ad7;
		case 0x00006454:
			return 0x78ee8bba;
		case 0x00006458:
			return 0x46fdd4b7;
		case 0x0000645c:
			return 0x9d132797;
		case 0x00006460:
			return 0xa3d23686;
		case 0x00006464:
			return 0x50b0de12;
		case 0x00006468:
			return 0x375be392;
		case 0x0000646c:
			return 0x53d6adb6;
		case 0x00006470:
			return 0x2de4cb15;
		case 0x00006474:
			return 0x5649ef5f;
		case 0x00006478:
			return 0xc18e0be6;
		case 0x0000647c:
			return 0xb92e47fe;
		case 0x00006480:
			return 0x04c7434e;
		case 0x00006484:
			return 0x2e03abc8;
		case 0x00006488:
			return 0x8bd69f73;
		case 0x0000648c:
			return 0x38e43651;
		case 0x00006490:
			return 0xe024c7dc;
		case 0x00006494:
			return 0x8d342cb7;
		case 0x00006498:
			return 0x6f57a1de;
		case 0x0000649c:
			return 0xbe000185;
		case 0x000064a0:
			return 0x4cc13a79;
		case 0x000064a4:
			return 0x668ead0e;
		case 0x000064a8:
			return 0xa4f6f507;
		case 0x000064ac:
			return 0x58b39dd1;
		case 0x000064b0:
			return 0x1226d93c;
		case 0x000064b4:
			return 0x29725408;
		case 0x000064b8:
			return 0x92699c74;
		case 0x000064bc:
			return 0x9f972abf;
		case 0x000064c0:
			return 0x254125c9;
		case 0x000064c4:
			return 0xbf18ae3a;
		case 0x000064c8:
			return 0xcd3df68b;
		case 0x000064cc:
			return 0x9283fc7b;
		case 0x000064d0:
			return 0x689d3fba;
		case 0x000064d4:
			return 0x49f8bc85;
		case 0x000064d8:
			return 0x71c6070d;
		case 0x000064dc:
			return 0x7a44226e;
		case 0x000064e0:
			return 0x1f5cbb25;
		case 0x000064e4:
			return 0xee705ce0;
		case 0x000064e8:
			return 0x60465318;
		case 0x000064ec:
			return 0xd3dae17a;
		case 0x000064f0:
			return 0x58412098;
		case 0x000064f4:
			return 0x70086add;
		case 0x000064f8:
			return 0x7f961f83;
		case 0x000064fc:
			return 0x4ec2aa54;
		case 0x00006500:
			return 0x53bd5622;
		case 0x00006504:
			return 0x1a8e0ef9;
		case 0x00006508:
			return 0xa8f6479f;
		case 0x0000650c:
			return 0x6680c1eb;
		case 0x00006510:
			return 0x2515f5ac;
		case 0x00006514:
			return 0xc6ce14f0;
		case 0x00006518:
			return 0x7b6ac7ab;
		case 0x0000651c:
			return 0xb3053289;
		case 0x00006520:
			return 0x41268b8c;
		case 0x00006524:
			return 0x2195215c;
		case 0x00006528:
			return 0x84908be8;
		case 0x0000652c:
			return 0xa2f06e1f;
		case 0x00006530:
			return 0xa2ca9de5;
		case 0x00006534:
			return 0x9ba6161a;
		case 0x00006538:
			return 0x8ee2fb7f;
		case 0x0000653c:
			return 0xef655188;
		case 0x00006540:
			return 0xaeced860;
		case 0x00006544:
			return 0x3e96591c;
		case 0x00006548:
			return 0xe7aff76a;
		case 0x0000654c:
			return 0x89532b26;
		case 0x00006550:
			return 0x63b05166;
		case 0x00006554:
			return 0xd034f48d;
		case 0x00006558:
			return 0x30116f93;
		case 0x0000655c:
			return 0x418cf011;
		case 0x00006560:
			return 0xc6adb6fe;
		case 0x00006564:
			return 0x0d3e118d;
		case 0x00006568:
			return 0x8ff8243e;
		case 0x0000656c:
			return 0x13c6421e;
		case 0x00006570:
			return 0xc6f996ea;
		case 0x00006574:
			return 0xc1f68c03;
		case 0x00006578:
			return 0xb1edb818;
		case 0x0000657c:
			return 0x0e14eaf7;
		case 0x00006580:
			return 0x9d3b7ceb;
		case 0x00006584:
			return 0x1fa53e10;
		case 0x00006588:
			return 0x32ba9ced;
		case 0x0000658c:
			return 0x2967a03d;
		case 0x00006590:
			return 0xffd1f4df;
		case 0x00006594:
			return 0xdd799f92;
		case 0x00006598:
			return 0xbe836156;
		case 0x0000659c:
			return 0xf85c2a03;
		case 0x000065a0:
			return 0x09e00f77;
		case 0x000065a4:
			return 0xc3d9513b;
		case 0x000065a8:
			return 0xb2d2e3b4;
		case 0x000065ac:
			return 0x2a105de3;
		case 0x000065b0:
			return 0xec8ab066;
		case 0x000065b4:
			return 0x7ab88a09;
		case 0x000065b8:
			return 0x4e1412d9;
		case 0x000065bc:
			return 0xff83eb0a;
		case 0x000065c0:
			return 0xf5a25460;
		case 0x000065c4:
			return 0xa3d1256d;
		case 0x000065c8:
			return 0x4d3c6a4c;
		case 0x000065cc:
			return 0xf38afb97;
		case 0x000065d0:
			return 0xbbc3b613;
		case 0x000065d4:
			return 0x5b792802;
		case 0x000065d8:
			return 0x2c9da78b;
		case 0x000065dc:
			return 0x6f5137a7;
		case 0x000065e0:
			return 0x549427e9;
		case 0x000065e4:
			return 0xe97ff0ab;
		case 0x000065e8:
			return 0x4903147f;
		case 0x000065ec:
			return 0x6ed70427;
		case 0x000065f0:
			return 0xa3d28680;
		case 0x000065f4:
			return 0xc014e34a;
		case 0x000065f8:
			return 0x356732b7;
		case 0x000065fc:
			return 0x3f2537b2;
		case 0x00006600:
			return 0x12625570;
		case 0x00006604:
			return 0x9cd0ebbb;
		case 0x00006608:
			return 0xa98c4276;
		case 0x0000660c:
			return 0x6c777fdf;
		case 0x00006610:
			return 0x4d0cd12a;
		case 0x00006614:
			return 0x6da61be1;
		case 0x00006618:
			return 0x340304c7;
		case 0x0000661c:
			return 0x8856f438;
		case 0x00006620:
			return 0xb8290dc0;
		case 0x00006624:
			return 0x62bcb40b;
		case 0x00006628:
			return 0x1ff22cb0;
		case 0x0000662c:
			return 0x8a7e4bfd;
		case 0x00006630:
			return 0x9556b569;
		case 0x00006634:
			return 0x2b13482a;
		case 0x00006638:
			return 0xf174a50f;
		case 0x0000663c:
			return 0xbca15d65;
		case 0x00006640:
			return 0xf090c69b;
		case 0x00006644:
			return 0xc2d8245e;
		case 0x00006648:
			return 0x09d70fb8;
		case 0x0000664c:
			return 0xd74fa414;
		case 0x00006650:
			return 0xa8a17a12;
		case 0x00006654:
			return 0x6a71af7e;
		case 0x00006658:
			return 0x1c6a1f81;
		case 0x0000665c:
			return 0x23976d55;
		case 0x00006660:
			return 0xc3e33612;
		case 0x00006664:
			return 0x6b1f4bb1;
		case 0x00006668:
			return 0xd00640fa;
		case 0x0000666c:
			return 0x0147ce49;
		case 0x00006670:
			return 0xb7af6cb9;
		case 0x00006674:
			return 0x2d5e74b2;
		case 0x00006678:
			return 0x1f7f0a2e;
		case 0x0000667c:
			return 0xa2e421f9;
		case 0x00006680:
			return 0x3b45f30a;
		case 0x00006684:
			return 0xd5eab6a5;
		case 0x00006688:
			return 0x932f484e;
		case 0x0000668c:
			return 0x7fc073fe;
		case 0x00006690:
			return 0x389d1be8;
		case 0x00006694:
			return 0xdadd385f;
		case 0x00006698:
			return 0x28dbcd87;
		case 0x0000669c:
			return 0x3d895ce5;
		case 0x000066a0:
			return 0x52e568b6;
		case 0x000066a4:
			return 0xe5956012;
		case 0x000066a8:
			return 0x2af18781;
		case 0x000066ac:
			return 0xf54fc7e0;
		case 0x000066b0:
			return 0x04aeb833;
		case 0x000066b4:
			return 0x6f3a43f1;
		case 0x000066b8:
			return 0x9fa08785;
		case 0x000066bc:
			return 0xb92848af;
		case 0x000066c0:
			return 0x5b7f884e;
		case 0x000066c4:
			return 0x5cec17cf;
		case 0x000066c8:
			return 0xc944c60b;
		case 0x000066cc:
			return 0xc9cf1740;
		case 0x000066d0:
			return 0x49eae1f2;
		case 0x000066d4:
			return 0x0f5e359c;
		case 0x000066d8:
			return 0x9dd00f5e;
		case 0x000066dc:
			return 0xc52a30bf;
		case 0x000066e0:
			return 0xa9dca93e;
		case 0x000066e4:
			return 0x8a0ef455;
		case 0x000066e8:
			return 0x08aa267a;
		case 0x000066ec:
			return 0xc093a70b;
		case 0x000066f0:
			return 0xe9011e6c;
		case 0x000066f4:
			return 0xe29eef96;
		case 0x000066f8:
			return 0xfa6bfdcc;
		case 0x000066fc:
			return 0x3f3bb514;
		case 0x00006700:
			return 0x27d1e0fd;
		case 0x00006704:
			return 0x2a120868;
		case 0x00006708:
			return 0xb20aa8d3;
		case 0x0000670c:
			return 0x70249b3f;
		case 0x00006710:
			return 0x55ce5d9f;
		case 0x00006714:
			return 0x6cc20216;
		case 0x00006718:
			return 0xe07c5a3a;
		case 0x0000671c:
			return 0x27c73b1d;
		case 0x00006720:
			return 0x56546094;
		case 0x00006724:
			return 0x5a335ac0;
		case 0x00006728:
			return 0x6ffd55d7;
		case 0x0000672c:
			return 0x5e9742f2;
		case 0x00006730:
			return 0xdc0f2948;
		case 0x00006734:
			return 0x3ad05a14;
		case 0x00006738:
			return 0xabe455b0;
		case 0x0000673c:
			return 0xb86133e5;
		case 0x00006740:
			return 0x93906474;
		case 0x00006744:
			return 0xc336e5f2;
		case 0x00006748:
			return 0x404540f0;
		case 0x0000674c:
			return 0x4270136d;
		case 0x00006750:
			return 0xbe2cafc9;
		case 0x00006754:
			return 0x642e889e;
		case 0x00006758:
			return 0x39d6ac8d;
		case 0x0000675c:
			return 0x18207853;
		case 0x00006760:
			return 0xa8881e32;
		case 0x00006764:
			return 0x998b00ac;
		case 0x00006768:
			return 0x9465b452;
		case 0x0000676c:
			return 0x9ceab0a8;
		case 0x00006770:
			return 0x59c4f81b;
		case 0x00006774:
			return 0xde8353e5;
		case 0x00006778:
			return 0x646ef784;
		case 0x0000677c:
			return 0x12e0840a;
		case 0x00006780:
			return 0x3c882f54;
		case 0x00006784:
			return 0x5ca4f627;
		case 0x00006788:
			return 0xbab38714;
		case 0x0000678c:
			return 0x934c13ef;
		case 0x00006790:
			return 0xc79e164a;
		case 0x00006794:
			return 0xf431d27a;
		case 0x00006798:
			return 0xa6a1dbda;
		case 0x0000679c:
			return 0x350e659d;
		case 0x000067a0:
			return 0x6d1f3c86;
		case 0x000067a4:
			return 0x11c8d387;
		case 0x000067a8:
			return 0xba748969;
		case 0x000067ac:
			return 0x23947386;
		case 0x000067b0:
			return 0x4f6c6827;
		case 0x000067b4:
			return 0x6bd72686;
		case 0x000067b8:
			return 0xec82b5d2;
		case 0x000067bc:
			return 0xd5f5b137;
		case 0x000067c0:
			return 0x59a1892e;
		case 0x000067c4:
			return 0x394b65a6;
		case 0x000067c8:
			return 0x706a0908;
		case 0x000067cc:
			return 0x14bab2a7;
		case 0x000067d0:
			return 0x43ac9c56;
		case 0x000067d4:
			return 0xd2b66662;
		case 0x000067d8:
			return 0xd18024c1;
		case 0x000067dc:
			return 0x61ee9c91;
		case 0x000067e0:
			return 0x50b81b72;
		case 0x000067e4:
			return 0x1bf0d1b0;
		case 0x000067e8:
			return 0x97d3aa5c;
		case 0x000067ec:
			return 0x4b8126bb;
		case 0x000067f0:
			return 0xd0ee6a26;
		case 0x000067f4:
			return 0x5eea39ae;
		case 0x000067f8:
			return 0xd0b029fb;
		case 0x000067fc:
			return 0xfeeb0ad3;
		case 0x00006800:
			return 0x1e7a0aff;
		case 0x00006804:
			return 0x9d04daad;
		case 0x00006808:
			return 0x2fcd7ddf;
		case 0x0000680c:
			return 0xaea9e68e;
		case 0x00006810:
			return 0xd1a5bd21;
		case 0x00006814:
			return 0x4f223b97;
		case 0x00006818:
			return 0x1fa81f07;
		case 0x0000681c:
			return 0xce15f07c;
		case 0x00006820:
			return 0x4367c348;
		case 0x00006824:
			return 0x107d8c21;
		case 0x00006828:
			return 0x07addb69;
		case 0x0000682c:
			return 0xcbb79a1e;
		case 0x00006830:
			return 0xd63c6c20;
		case 0x00006834:
			return 0xa5fa8155;
		case 0x00006838:
			return 0x0dfee6cf;
		case 0x0000683c:
			return 0x3f55f74e;
		case 0x00006840:
			return 0x1b91c6a9;
		case 0x00006844:
			return 0xbf233fd8;
		case 0x00006848:
			return 0x5b315676;
		case 0x0000684c:
			return 0x45f7c4ab;
		case 0x00006850:
			return 0x2eba2c2e;
		case 0x00006854:
			return 0x9d4369d2;
		case 0x00006858:
			return 0xe127cfec;
		case 0x0000685c:
			return 0x13ea17b1;
		case 0x00006860:
			return 0xaae7667e;
		case 0x00006864:
			return 0x71ecf52c;
		case 0x00006868:
			return 0x45079e49;
		case 0x0000686c:
			return 0xdb25ccde;
		case 0x00006870:
			return 0xa20cea08;
		case 0x00006874:
			return 0x2665d2e5;
		case 0x00006878:
			return 0x8003677e;
		case 0x0000687c:
			return 0xa6c87eb5;
		case 0x00006880:
			return 0xf36b6551;
		case 0x00006884:
			return 0x2830ef4e;
		case 0x00006888:
			return 0xc384662f;
		case 0x0000688c:
			return 0xfe4452ec;
		case 0x00006890:
			return 0xcfa37bc0;
		case 0x00006894:
			return 0xfea9e515;
		case 0x00006898:
			return 0x73f380cc;
		case 0x0000689c:
			return 0xaebb52ad;
		case 0x000068a0:
			return 0xe3516fe4;
		case 0x000068a4:
			return 0x88056c9b;
		case 0x000068a8:
			return 0x0a4f5196;
		case 0x000068ac:
			return 0xa26f3e18;
		case 0x000068b0:
			return 0xb45a1eba;
		case 0x000068b4:
			return 0x078928de;
		case 0x000068b8:
			return 0x2cb43a80;
		case 0x000068bc:
			return 0xa566e345;
		case 0x000068c0:
			return 0xc9f8f5a5;
		case 0x000068c4:
			return 0x136ae77f;
		case 0x000068c8:
			return 0x9354d7c2;
		case 0x000068cc:
			return 0x5620d279;
		case 0x000068d0:
			return 0x77ba2653;
		case 0x000068d4:
			return 0x2bf0ae83;
		case 0x000068d8:
			return 0x379bc499;
		case 0x000068dc:
			return 0x3d2da24b;
		case 0x000068e0:
			return 0x82a5de47;
		case 0x000068e4:
			return 0x494d763b;
		case 0x000068e8:
			return 0x0a21e25f;
		case 0x000068ec:
			return 0xfd1e6a50;
		case 0x000068f0:
			return 0x8324a94c;
		case 0x000068f4:
			return 0x60ceeaa8;
		case 0x000068f8:
			return 0x4182914f;
		case 0x000068fc:
			return 0x70342a3b;
		case 0x00006900:
			return 0x3752524c;
		case 0x00006904:
			return 0x198ef7de;
		case 0x00006908:
			return 0xec0cd92e;
		case 0x0000690c:
			return 0x2fd4d712;
		case 0x00006910:
			return 0x697b338c;
		case 0x00006914:
			return 0x2e5cd0bc;
		case 0x00006918:
			return 0x73d3977c;
		case 0x0000691c:
			return 0x23f283a4;
		case 0x00006920:
			return 0xe04131bd;
		case 0x00006924:
			return 0x4f45df2d;
		case 0x00006928:
			return 0xe4e3ef84;
		case 0x0000692c:
			return 0xbe567058;
		case 0x00006930:
			return 0x79512111;
		case 0x00006934:
			return 0xbf574ed9;
		case 0x00006938:
			return 0xb1c025d9;
		case 0x0000693c:
			return 0xe5c47dfa;
		case 0x00006940:
			return 0x1bd0a83e;
		case 0x00006944:
			return 0x211aaa2c;
		case 0x00006948:
			return 0xa8a9e87b;
		case 0x0000694c:
			return 0x6983cfb4;
		case 0x00006950:
			return 0x8ad583e2;
		case 0x00006954:
			return 0x6c4cf9d0;
		case 0x00006958:
			return 0x3cfd340d;
		case 0x0000695c:
			return 0x16e2e1ee;
		case 0x00006960:
			return 0x00d6c12a;
		case 0x00006964:
			return 0x11d2b2a0;
		case 0x00006968:
			return 0x39929c56;
		case 0x0000696c:
			return 0x5f4e646c;
		case 0x00006970:
			return 0x7c83fd0f;
		case 0x00006974:
			return 0x10963e5b;
		case 0x00006978:
			return 0xb10398a3;
		case 0x0000697c:
			return 0x3f3c0e1b;
		case 0x00006980:
			return 0xa894fac6;
		case 0x00006984:
			return 0x3c72c90d;
		case 0x00006988:
			return 0xeffafa2c;
		case 0x0000698c:
			return 0xb99d8fbb;
		case 0x00006990:
			return 0xf38be7d9;
		case 0x00006994:
			return 0xdf61cc0a;
		case 0x00006998:
			return 0x2d82a8d1;
		case 0x0000699c:
			return 0xcd7c0fd1;
		case 0x000069a0:
			return 0xe8b0022a;
		case 0x000069a4:
			return 0x6b14bc68;
		case 0x000069a8:
			return 0xd0dd65c3;
		case 0x000069ac:
			return 0xa7a580e3;
		case 0x000069b0:
			return 0xe2082e68;
		case 0x000069b4:
			return 0x83d8182a;
		case 0x000069b8:
			return 0xc69c1b4b;
		case 0x000069bc:
			return 0x36515a49;
		case 0x000069c0:
			return 0xbc665e0e;
		case 0x000069c4:
			return 0x2478553a;
		case 0x000069c8:
			return 0xa7a8718f;
		case 0x000069cc:
			return 0x3f69c9df;
		case 0x000069d0:
			return 0x95d19b3c;
		case 0x000069d4:
			return 0x1ff36f1c;
		case 0x000069d8:
			return 0x38ab8341;
		case 0x000069dc:
			return 0xb7e438a7;
		case 0x000069e0:
			return 0xb2cd22bc;
		case 0x000069e4:
			return 0xec73f83e;
		case 0x000069e8:
			return 0xbf511a7f;
		case 0x000069ec:
			return 0xf244b485;
		case 0x000069f0:
			return 0x8de7e924;
		case 0x000069f4:
			return 0x75a645bb;
		case 0x000069f8:
			return 0xa623e9a4;
		case 0x000069fc:
			return 0xb4654425;
		case 0x00006a00:
			return 0xd3b7fc3a;
		case 0x00006a04:
			return 0xa2dca7b9;
		case 0x00006a08:
			return 0x51bb80db;
		case 0x00006a0c:
			return 0x37dc709d;
		case 0x00006a10:
			return 0x6894d642;
		case 0x00006a14:
			return 0x1b46dce5;
		case 0x00006a18:
			return 0x66d2dc1f;
		case 0x00006a1c:
			return 0x86a576ea;
		case 0x00006a20:
			return 0x1ef634d2;
		case 0x00006a24:
			return 0xb4042520;
		case 0x00006a28:
			return 0x1d0d38e3;
		case 0x00006a2c:
			return 0x77f5bda9;
		case 0x00006a30:
			return 0x70324faf;
		case 0x00006a34:
			return 0x156a2373;
		case 0x00006a38:
			return 0x37e2c27d;
		case 0x00006a3c:
			return 0x3367aa22;
		case 0x00006a40:
			return 0x19cced31;
		case 0x00006a44:
			return 0x3c0daf21;
		case 0x00006a48:
			return 0x7a3fe58c;
		case 0x00006a4c:
			return 0xff92489d;
		case 0x00006a50:
			return 0x6512ccbb;
		case 0x00006a54:
			return 0x84b187ed;
		case 0x00006a58:
			return 0x33f72043;
		case 0x00006a5c:
			return 0x890b6a36;
		case 0x00006a60:
			return 0x05af304f;
		case 0x00006a64:
			return 0x78bead96;
		case 0x00006a68:
			return 0x5f7f682e;
		case 0x00006a6c:
			return 0xcd6a6378;
		case 0x00006a70:
			return 0xeb196a33;
		case 0x00006a74:
			return 0x41f0b246;
		case 0x00006a78:
			return 0x0b58aeee;
		case 0x00006a7c:
			return 0xac08e6b6;
		case 0x00006a80:
			return 0x9f2e6f20;
		case 0x00006a84:
			return 0xaa01817b;
		case 0x00006a88:
			return 0x72337e89;
		case 0x00006a8c:
			return 0xa03d9b9f;
		case 0x00006a90:
			return 0xd54ee33d;
		case 0x00006a94:
			return 0x2359b3f1;
		case 0x00006a98:
			return 0x9b7c69e2;
		case 0x00006a9c:
			return 0x7529d833;
		case 0x00006aa0:
			return 0xcc6d28cc;
		case 0x00006aa4:
			return 0x08effeb6;
		case 0x00006aa8:
			return 0xad4ef1ee;
		case 0x00006aac:
			return 0x447eecda;
		case 0x00006ab0:
			return 0xb11c5f36;
		case 0x00006ab4:
			return 0x4e27ab6e;
		case 0x00006ab8:
			return 0x9a5a163d;
		case 0x00006abc:
			return 0x8743b4e0;
		case 0x00006ac0:
			return 0x63cecf56;
		case 0x00006ac4:
			return 0x659984b8;
		case 0x00006ac8:
			return 0xbd348a71;
		case 0x00006acc:
			return 0xe6a7c631;
		case 0x00006ad0:
			return 0xc337c39a;
		case 0x00006ad4:
			return 0x2ff54f47;
		case 0x00006ad8:
			return 0xd4033285;
		case 0x00006adc:
			return 0x1c06e87c;
		case 0x00006ae0:
			return 0x7013da39;
		case 0x00006ae4:
			return 0x22e8afe9;
		case 0x00006ae8:
			return 0x1ca4385c;
		case 0x00006aec:
			return 0x509c9a4f;
		case 0x00006af0:
			return 0x532d5844;
		case 0x00006af4:
			return 0xb75c4e07;
		case 0x00006af8:
			return 0x122e3da4;
		case 0x00006afc:
			return 0xcb56c9e7;
		case 0x00006b00:
			return 0x5145099f;
		case 0x00006b04:
			return 0x3ad32705;
		case 0x00006b08:
			return 0x64ba3316;
		case 0x00006b0c:
			return 0x468d1d15;
		case 0x00006b10:
			return 0x451b6cfa;
		case 0x00006b14:
			return 0x4ec16dbc;
		case 0x00006b18:
			return 0xb97df097;
		case 0x00006b1c:
			return 0x171b5780;
		case 0x00006b20:
			return 0xcdbc6921;
		case 0x00006b24:
			return 0xf919fac7;
		case 0x00006b28:
			return 0x94591aa5;
		case 0x00006b2c:
			return 0x49e5d40f;
		case 0x00006b30:
			return 0x3fec77f1;
		case 0x00006b34:
			return 0x2a95956f;
		case 0x00006b38:
			return 0x6b167d0a;
		case 0x00006b3c:
			return 0xdeb440a1;
		case 0x00006b40:
			return 0xfc0ef188;
		case 0x00006b44:
			return 0x4c2f24ec;
		case 0x00006b48:
			return 0xddff5b2d;
		case 0x00006b4c:
			return 0xccca3a2e;
		case 0x00006b50:
			return 0x926d0b6a;
		case 0x00006b54:
			return 0xad834728;
		case 0x00006b58:
			return 0x55238b86;
		case 0x00006b5c:
			return 0xaf0bd210;
		case 0x00006b60:
			return 0x346c348d;
		case 0x00006b64:
			return 0x0dc22209;
		case 0x00006b68:
			return 0x34b468aa;
		case 0x00006b6c:
			return 0x49f13f68;
		case 0x00006b70:
			return 0x658a0de5;
		case 0x00006b74:
			return 0x67594a88;
		case 0x00006b78:
			return 0x23eef445;
		case 0x00006b7c:
			return 0x8ba93c8d;
		case 0x00006b80:
			return 0x8aa73ca8;
		case 0x00006b84:
			return 0xb5e23e8f;
		case 0x00006b88:
			return 0x901d4202;
		case 0x00006b8c:
			return 0x13882631;
		case 0x00006b90:
			return 0x1cb881e1;
		case 0x00006b94:
			return 0xb74866fc;
		case 0x00006b98:
			return 0xbc172dab;
		case 0x00006b9c:
			return 0x5f35e0ed;
		case 0x00006ba0:
			return 0xb51b3af9;
		case 0x00006ba4:
			return 0x0cd1bcc6;
		case 0x00006ba8:
			return 0xa5fb3f85;
		case 0x00006bac:
			return 0xe25a347e;
		case 0x00006bb0:
			return 0xc97c9fdc;
		case 0x00006bb4:
			return 0xa8b2a2c8;
		case 0x00006bb8:
			return 0xf860b459;
		case 0x00006bbc:
			return 0x3effae38;
		case 0x00006bc0:
			return 0xae178efc;
		case 0x00006bc4:
			return 0x3aae1a10;
		case 0x00006bc8:
			return 0x110ee652;
		case 0x00006bcc:
			return 0x886e19af;
		case 0x00006bd0:
			return 0xca1282c4;
		case 0x00006bd4:
			return 0x38656a09;
		case 0x00006bd8:
			return 0x99c700aa;
		case 0x00006bdc:
			return 0xb505082c;
		case 0x00006be0:
			return 0x503cb188;
		case 0x00006be4:
			return 0x5f1fd0a5;
		case 0x00006be8:
			return 0xad2ff9bb;
		case 0x00006bec:
			return 0xa3785cff;
		case 0x00006bf0:
			return 0x45a20d17;
		case 0x00006bf4:
			return 0xca86f78c;
		case 0x00006bf8:
			return 0x7b0f8282;
		case 0x00006bfc:
			return 0x5f002df8;
		case 0x00006c00:
			return 0xd5d5a144;
		case 0x00006c04:
			return 0x1f86e7a7;
		case 0x00006c08:
			return 0x1e94de9a;
		case 0x00006c0c:
			return 0x58c32e15;
		case 0x00006c10:
			return 0x04771e3f;
		case 0x00006c14:
			return 0xc90ec4a9;
		case 0x00006c18:
			return 0xb8f05f9a;
		case 0x00006c1c:
			return 0xb42132d5;
		case 0x00006c20:
			return 0x3fb5df33;
		case 0x00006c24:
			return 0x98f746fe;
		case 0x00006c28:
			return 0xe49fabb1;
		case 0x00006c2c:
			return 0x49e36f50;
		case 0x00006c30:
			return 0x686acfe3;
		case 0x00006c34:
			return 0x22653e13;
		case 0x00006c38:
			return 0x2353b0ab;
		case 0x00006c3c:
			return 0x707122ad;
		case 0x00006c40:
			return 0x03d254cb;
		case 0x00006c44:
			return 0xdfe40f4a;
		case 0x00006c48:
			return 0x25e38171;
		case 0x00006c4c:
			return 0xc580386c;
		case 0x00006c50:
			return 0x88bdfc54;
		case 0x00006c54:
			return 0xa0b52327;
		case 0x00006c58:
			return 0x890f2502;
		case 0x00006c5c:
			return 0xb0d92a8a;
		case 0x00006c60:
			return 0xff7cb350;
		case 0x00006c64:
			return 0x13daf243;
		case 0x00006c68:
			return 0x3ec2075f;
		case 0x00006c6c:
			return 0xc9bf8565;
		case 0x00006c70:
			return 0xc839b21d;
		case 0x00006c74:
			return 0x69b6e74f;
		case 0x00006c78:
			return 0xccfa79f9;
		case 0x00006c7c:
			return 0x022dc1ee;
		case 0x00006c80:
			return 0x7edc71cf;
		case 0x00006c84:
			return 0x1b094009;
		case 0x00006c88:
			return 0x05667b7a;
		case 0x00006c8c:
			return 0x4352ff06;
		case 0x00006c90:
			return 0x25964b9a;
		case 0x00006c94:
			return 0x26d5a031;
		case 0x00006c98:
			return 0xae5298bb;
		case 0x00006c9c:
			return 0x6a59e8a2;
		case 0x00006ca0:
			return 0xd275d7f2;
		case 0x00006ca4:
			return 0x457f3a30;
		case 0x00006ca8:
			return 0x28053c03;
		case 0x00006cac:
			return 0x1fc0f9d6;
		case 0x00006cb0:
			return 0x617048c1;
		case 0x00006cb4:
			return 0xb2248a17;
		case 0x00006cb8:
			return 0x024daeca;
		case 0x00006cbc:
			return 0x49f79683;
		case 0x00006cc0:
			return 0xf9d6ef56;
		case 0x00006cc4:
			return 0x3f2df7cc;
		case 0x00006cc8:
			return 0x4fa70211;
		case 0x00006ccc:
			return 0xdc8d72f9;
		case 0x00006cd0:
			return 0x785fe6e8;
		case 0x00006cd4:
			return 0xd75fb1ce;
		case 0x00006cd8:
			return 0xaed7564d;
		case 0x00006cdc:
			return 0x0e17f3cc;
		case 0x00006ce0:
			return 0x7454b2f6;
		case 0x00006ce4:
			return 0x524302f8;
		case 0x00006ce8:
			return 0xc4d88d8b;
		case 0x00006cec:
			return 0xea319788;
		case 0x00006cf0:
			return 0x0512c5ae;
		case 0x00006cf4:
			return 0x5fc77165;
		case 0x00006cf8:
			return 0x2e0d7271;
		case 0x00006cfc:
			return 0xee4c3bdb;
		case 0x00006d00:
			return 0xfb7ea58a;
		case 0x00006d04:
			return 0xbc0a5979;
		case 0x00006d08:
			return 0xe6ab6b85;
		case 0x00006d0c:
			return 0x633be859;
		case 0x00006d10:
			return 0xae3ba1aa;
		case 0x00006d14:
			return 0x911b2ae9;
		case 0x00006d18:
			return 0xaa4fd865;
		case 0x00006d1c:
			return 0x9bd28401;
		case 0x00006d20:
			return 0x186f217b;
		case 0x00006d24:
			return 0x47f9375b;
		case 0x00006d28:
			return 0x608507c7;
		case 0x00006d2c:
			return 0x6d555a73;
		case 0x00006d30:
			return 0xa17f3c36;
		case 0x00006d34:
			return 0xfd68448d;
		case 0x00006d38:
			return 0x45705632;
		case 0x00006d3c:
			return 0x83018321;
		case 0x00006d40:
			return 0xde57b8e5;
		case 0x00006d44:
			return 0xdcd2fe81;
		case 0x00006d48:
			return 0x78358da3;
		case 0x00006d4c:
			return 0xbfd5a9eb;
		case 0x00006d50:
			return 0x6a530b8b;
		case 0x00006d54:
			return 0x39f1328d;
		case 0x00006d58:
			return 0xb06c4344;
		case 0x00006d5c:
			return 0xc721a15d;
		case 0x00006d60:
			return 0xed74e0a9;
		case 0x00006d64:
			return 0xd7661132;
		case 0x00006d68:
			return 0x0445b330;
		case 0x00006d6c:
			return 0x79579105;
		case 0x00006d70:
			return 0x3bdcc0fc;
		case 0x00006d74:
			return 0x9387e3ec;
		case 0x00006d78:
			return 0x8f05116b;
		case 0x00006d7c:
			return 0xe0d11322;
		case 0x00006d80:
			return 0xfdbc2d24;
		case 0x00006d84:
			return 0x0894c3ee;
		case 0x00006d88:
			return 0x91e69905;
		case 0x00006d8c:
			return 0x986c2572;
		case 0x00006d90:
			return 0x6258ffbb;
		case 0x00006d94:
			return 0x62c45f2f;
		case 0x00006d98:
			return 0x62366cbc;
		case 0x00006d9c:
			return 0x796e8fdf;
		case 0x00006da0:
			return 0x57f7de8a;
		case 0x00006da4:
			return 0x1becc2c6;
		case 0x00006da8:
			return 0x30f05fff;
		case 0x00006dac:
			return 0x1050d470;
		case 0x00006db0:
			return 0x5479384d;
		case 0x00006db4:
			return 0xc71ecc69;
		case 0x00006db8:
			return 0xac3ef6ce;
		case 0x00006dbc:
			return 0x4cd5d715;
		case 0x00006dc0:
			return 0x7649267d;
		case 0x00006dc4:
			return 0x9453f8aa;
		case 0x00006dc8:
			return 0x3b4bdade;
		case 0x00006dcc:
			return 0xdad91383;
		case 0x00006dd0:
			return 0x30484689;
		case 0x00006dd4:
			return 0xe726277c;
		case 0x00006dd8:
			return 0xb762c532;
		case 0x00006ddc:
			return 0x94b5a68f;
		case 0x00006de0:
			return 0x1d04c6f3;
		case 0x00006de4:
			return 0x825a6572;
		case 0x00006de8:
			return 0x5fee429c;
		case 0x00006dec:
			return 0x3d326867;
		case 0x00006df0:
			return 0x8f1aecdc;
		case 0x00006df4:
			return 0x65a3c460;
		case 0x00006df8:
			return 0x918eef50;
		case 0x00006dfc:
			return 0xd69d9a96;
		case 0x00006e00:
			return 0xc9b490aa;
		case 0x00006e04:
			return 0x0b03e857;
		case 0x00006e08:
			return 0xf354adaa;
		case 0x00006e0c:
			return 0xaa63a89b;
		case 0x00006e10:
			return 0xe2407e32;
		case 0x00006e14:
			return 0x4a82f53e;
		case 0x00006e18:
			return 0x7e72ae2a;
		case 0x00006e1c:
			return 0x43f973d9;
		case 0x00006e20:
			return 0xafa59167;
		case 0x00006e24:
			return 0xcfd60762;
		case 0x00006e28:
			return 0x2e9fa39b;
		case 0x00006e2c:
			return 0xecce2f1a;
		case 0x00006e30:
			return 0xd41ea7ef;
		case 0x00006e34:
			return 0x00aa07f6;
		case 0x00006e38:
			return 0x06149672;
		case 0x00006e3c:
			return 0xf17f7234;
		case 0x00006e40:
			return 0x53646ad8;
		case 0x00006e44:
			return 0xcf4ad1b5;
		case 0x00006e48:
			return 0x8fda1bf9;
		case 0x00006e4c:
			return 0x73faf381;
		case 0x00006e50:
			return 0xc667f089;
		case 0x00006e54:
			return 0x77c5a2f0;
		case 0x00006e58:
			return 0xd3600747;
		case 0x00006e5c:
			return 0x73137738;
		case 0x00006e60:
			return 0x3e10349a;
		case 0x00006e64:
			return 0x70758fb9;
		case 0x00006e68:
			return 0x567db36a;
		case 0x00006e6c:
			return 0x95938ae1;
		case 0x00006e70:
			return 0xaab87308;
		case 0x00006e74:
			return 0xba126983;
		case 0x00006e78:
			return 0xe7a3c187;
		case 0x00006e7c:
			return 0x0dd87ac7;
		case 0x00006e80:
			return 0xc2a6652f;
		case 0x00006e84:
			return 0x6061b5fc;
		case 0x00006e88:
			return 0x50c03213;
		case 0x00006e8c:
			return 0x50f4b8d4;
		case 0x00006e90:
			return 0x1b06e1ec;
		case 0x00006e94:
			return 0xb67bbe45;
		case 0x00006e98:
			return 0x3759bb14;
		case 0x00006e9c:
			return 0xb5b79b1a;
		case 0x00006ea0:
			return 0xc7ca07e0;
		case 0x00006ea4:
			return 0xe924aed0;
		case 0x00006ea8:
			return 0x0500f1cd;
		case 0x00006eac:
			return 0x60dee276;
		case 0x00006eb0:
			return 0xe4b7f5c1;
		case 0x00006eb4:
			return 0x0891a6ec;
		case 0x00006eb8:
			return 0x4727c959;
		case 0x00006ebc:
			return 0x35a0242e;
		case 0x00006ec0:
			return 0x0be30ca8;
		case 0x00006ec4:
			return 0xd37f18d1;
		case 0x00006ec8:
			return 0xdd7f0837;
		case 0x00006ecc:
			return 0xb9d48aff;
		case 0x00006ed0:
			return 0x4bbcbd77;
		case 0x00006ed4:
			return 0x11a0b09b;
		case 0x00006ed8:
			return 0xbade5ede;
		case 0x00006edc:
			return 0xa435edb8;
		case 0x00006ee0:
			return 0x1d714800;
		case 0x00006ee4:
			return 0xae5a72c2;
		case 0x00006ee8:
			return 0xf0a8100e;
		case 0x00006eec:
			return 0xa7bb7835;
		case 0x00006ef0:
			return 0x07440e21;
		case 0x00006ef4:
			return 0x453516e5;
		case 0x00006ef8:
			return 0x76da6c0b;
		case 0x00006efc:
			return 0xf4debaca;
		case 0x00006f00:
			return 0x162bca39;
		case 0x00006f04:
			return 0xf923094b;
		case 0x00006f08:
			return 0x78d2223a;
		case 0x00006f0c:
			return 0x1b58e24f;
		case 0x00006f10:
			return 0x63267937;
		case 0x00006f14:
			return 0x11ef4a81;
		case 0x00006f18:
			return 0x79a3f4f3;
		case 0x00006f1c:
			return 0xf9670904;
		case 0x00006f20:
			return 0x3db019d0;
		case 0x00006f24:
			return 0xc66dd7c4;
		case 0x00006f28:
			return 0x70f55653;
		case 0x00006f2c:
			return 0xdf7b3938;
		case 0x00006f30:
			return 0xb04c3b70;
		case 0x00006f34:
			return 0xff566651;
		case 0x00006f38:
			return 0xea776ec9;
		case 0x00006f3c:
			return 0xac74c5b9;
		case 0x00006f40:
			return 0x20b0a785;
		case 0x00006f44:
			return 0x29db3466;
		case 0x00006f48:
			return 0xa54ba864;
		case 0x00006f4c:
			return 0x612a2455;
		case 0x00006f50:
			return 0x3f4415f4;
		case 0x00006f54:
			return 0x18bfb8ce;
		case 0x00006f58:
			return 0xab16b5dc;
		case 0x00006f5c:
			return 0x6dcdae85;
		case 0x00006f60:
			return 0x8a6850f5;
		case 0x00006f64:
			return 0x9fc4d5e6;
		case 0x00006f68:
			return 0x021c05dd;
		case 0x00006f6c:
			return 0xd17166a4;
		case 0x00006f70:
			return 0x83ba93ad;
		case 0x00006f74:
			return 0xf484de4c;
		case 0x00006f78:
			return 0xdbcfbfd8;
		case 0x00006f7c:
			return 0x21b1d481;
		case 0x00006f80:
			return 0xf7a46e9b;
		case 0x00006f84:
			return 0xa2c977ad;
		case 0x00006f88:
			return 0x56395705;
		case 0x00006f8c:
			return 0x91717b25;
		case 0x00006f90:
			return 0x35352d61;
		case 0x00006f94:
			return 0x07464df7;
		case 0x00006f98:
			return 0xff300036;
		case 0x00006f9c:
			return 0xd512f689;
		case 0x00006fa0:
			return 0x6682d7be;
		case 0x00006fa4:
			return 0xaffd0b1d;
		case 0x00006fa8:
			return 0x4746a07d;
		case 0x00006fac:
			return 0x4b8eb1e2;
		case 0x00006fb0:
			return 0x37670b6d;
		case 0x00006fb4:
			return 0xf6eb22e4;
		case 0x00006fb8:
			return 0xf25e4395;
		case 0x00006fbc:
			return 0x1d8cdb00;
		case 0x00006fc0:
			return 0x52372b94;
		case 0x00006fc4:
			return 0xa2fdb313;
		case 0x00006fc8:
			return 0x281ab51e;
		case 0x00006fcc:
			return 0x528a090d;
		case 0x00006fd0:
			return 0x3e598283;
		case 0x00006fd4:
			return 0x8d60c02d;
		case 0x00006fd8:
			return 0x1deaf992;
		case 0x00006fdc:
			return 0xfe1ae0d0;
		case 0x00006fe0:
			return 0x9bd7f58d;
		case 0x00006fe4:
			return 0x49e02e3a;
		case 0x00006fe8:
			return 0x34d3a217;
		case 0x00006fec:
			return 0x29835057;
		case 0x00006ff0:
			return 0x10a19d4c;
		case 0x00006ff4:
			return 0xd2eb5c0a;
		case 0x00006ff8:
			return 0xff38ab6b;
		case 0x00006ffc:
			return 0x170df8dd;
		case 0x00007000:
			return 0xb847f727;
		case 0x00007004:
			return 0x8c69ec01;
		case 0x00007008:
			return 0x08737d57;
		case 0x0000700c:
			return 0x96b5452d;
		case 0x00007010:
			return 0xef15ff0c;
		case 0x00007014:
			return 0xb270ca2d;
		case 0x00007018:
			return 0x0a87b76d;
		case 0x0000701c:
			return 0xfc313e6e;
		case 0x00007020:
			return 0xce87b8bb;
		case 0x00007024:
			return 0x5729450b;
		case 0x00007028:
			return 0x73013bf8;
		case 0x0000702c:
			return 0x7b54bfe9;
		case 0x00007030:
			return 0x7f1d17f7;
		case 0x00007034:
			return 0x04ee2ae1;
		case 0x00007038:
			return 0x93008e7c;
		case 0x0000703c:
			return 0x247f46df;
		case 0x00007040:
			return 0xf1eab85f;
		case 0x00007044:
			return 0xddaa0bad;
		case 0x00007048:
			return 0xc92d4b7e;
		case 0x0000704c:
			return 0x001e4f49;
		case 0x00007050:
			return 0x1dfdafc5;
		case 0x00007054:
			return 0x19882eae;
		case 0x00007058:
			return 0x2294b21e;
		case 0x0000705c:
			return 0xf7745251;
		case 0x00007060:
			return 0x12088a7c;
		case 0x00007064:
			return 0xeaba7422;
		case 0x00007068:
			return 0x1afcbcd6;
		case 0x0000706c:
			return 0x57331c86;
		case 0x00007070:
			return 0xdde234f1;
		case 0x00007074:
			return 0xd303f524;
		case 0x00007078:
			return 0xc84f1ae3;
		case 0x0000707c:
			return 0x78495a16;
		case 0x00007080:
			return 0x0b6c6d6b;
		case 0x00007084:
			return 0x4242dcbf;
		case 0x00007088:
			return 0x9ee36f58;
		case 0x0000708c:
			return 0xc9a76bcc;
		case 0x00007090:
			return 0x86700bd9;
		case 0x00007094:
			return 0x5cdaab22;
		case 0x00007098:
			return 0x21dec118;
		case 0x0000709c:
			return 0x62e5e860;
		case 0x000070a0:
			return 0x9e880f39;
		case 0x000070a4:
			return 0x9ea89e06;
		case 0x000070a8:
			return 0x425eea76;
		case 0x000070ac:
			return 0x42cfce48;
		case 0x000070b0:
			return 0x38ba970c;
		case 0x000070b4:
			return 0x1c120b14;
		case 0x000070b8:
			return 0xdd6b9b90;
		case 0x000070bc:
			return 0xc7dbcdb0;
		case 0x000070c0:
			return 0x5cc59a9f;
		case 0x000070c4:
			return 0x960cf040;
		case 0x000070c8:
			return 0xdd1f5634;
		case 0x000070cc:
			return 0xfcd36e0f;
		case 0x000070d0:
			return 0xcdc88691;
		case 0x000070d4:
			return 0x5677b849;
		case 0x000070d8:
			return 0x9615b8e2;
		case 0x000070dc:
			return 0x23f4e268;
		case 0x000070e0:
			return 0xad4dde07;
		case 0x000070e4:
			return 0x738727ff;
		case 0x000070e8:
			return 0x00a9ed36;
		case 0x000070ec:
			return 0xca48b951;
		case 0x000070f0:
			return 0xadba6d84;
		case 0x000070f4:
			return 0x067a2b87;
		case 0x000070f8:
			return 0x37e32a15;
		case 0x000070fc:
			return 0x4b7f0151;
		case 0x00007100:
			return 0x6bb58822;
		case 0x00007104:
			return 0x965d4797;
		case 0x00007108:
			return 0x5af8e669;
		case 0x0000710c:
			return 0x73c9d77f;
		case 0x00007110:
			return 0x678dfcf1;
		case 0x00007114:
			return 0xb179690f;
		case 0x00007118:
			return 0x96de0614;
		case 0x0000711c:
			return 0xed327b1f;
		case 0x00007120:
			return 0x2c1fbc4f;
		case 0x00007124:
			return 0x02e68250;
		case 0x00007128:
			return 0xddd5d68a;
		case 0x0000712c:
			return 0xce32f4b9;
		case 0x00007130:
			return 0x6e7371bf;
		case 0x00007134:
			return 0xab507f82;
		case 0x00007138:
			return 0xe002f655;
		case 0x0000713c:
			return 0x76c50a96;
		case 0x00007140:
			return 0x5f53d945;
		case 0x00007144:
			return 0xee980c83;
		case 0x00007148:
			return 0xc5ca3087;
		case 0x0000714c:
			return 0xb0683aef;
		case 0x00007150:
			return 0x181f64fe;
		case 0x00007154:
			return 0xd75f4111;
		case 0x00007158:
			return 0xa3005da8;
		case 0x0000715c:
			return 0xe5f586a6;
		case 0x00007160:
			return 0xbb8fa7ab;
		case 0x00007164:
			return 0xe6fd9f78;
		case 0x00007168:
			return 0x381ae1c3;
		case 0x0000716c:
			return 0x5c25f7af;
		case 0x00007170:
			return 0x88fd6ea2;
		case 0x00007174:
			return 0x0e5d93cb;
		case 0x00007178:
			return 0x27296ada;
		case 0x0000717c:
			return 0x7cb520d9;
		case 0x00007180:
			return 0x06292706;
		case 0x00007184:
			return 0x1418b5ca;
		case 0x00007188:
			return 0x7df27573;
		case 0x0000718c:
			return 0x5d0a7613;
		case 0x00007190:
			return 0xe8fcdf73;
		case 0x00007194:
			return 0x2cfefce2;
		case 0x00007198:
			return 0xa3469ce6;
		case 0x0000719c:
			return 0x8579ffb6;
		case 0x000071a0:
			return 0xc531d05a;
		case 0x000071a4:
			return 0xe8d5b6fc;
		case 0x000071a8:
			return 0xa3aee9e1;
		case 0x000071ac:
			return 0x988dbbec;
		case 0x000071b0:
			return 0x99d73a68;
		case 0x000071b4:
			return 0x7bf18a98;
		case 0x000071b8:
			return 0x79b56d55;
		case 0x000071bc:
			return 0xe8598190;
		case 0x000071c0:
			return 0xd7a02cb9;
		case 0x000071c4:
			return 0x6ea84ddb;
		case 0x000071c8:
			return 0x65bb7fb8;
		case 0x000071cc:
			return 0x77ff6778;
		case 0x000071d0:
			return 0xc234b44b;
		case 0x000071d4:
			return 0x7c08e2e1;
		case 0x000071d8:
			return 0x0849f109;
		case 0x000071dc:
			return 0x9180e172;
		case 0x000071e0:
			return 0xf4e649b4;
		case 0x000071e4:
			return 0x5b58bcb8;
		case 0x000071e8:
			return 0xf4466b96;
		case 0x000071ec:
			return 0x52eb1f27;
		case 0x000071f0:
			return 0x7d70c9b8;
		case 0x000071f4:
			return 0x6d5512fa;
		case 0x000071f8:
			return 0x94b6a1ee;
		case 0x000071fc:
			return 0x52f9c9e1;
		case 0x00007200:
			return 0x322516c5;
		case 0x00007204:
			return 0x9cb58e05;
		case 0x00007208:
			return 0x45e51e6b;
		case 0x0000720c:
			return 0x19bcce51;
		case 0x00007210:
			return 0x6705fd2e;
		case 0x00007214:
			return 0x5640f4b3;
		case 0x00007218:
			return 0xce04f95d;
		case 0x0000721c:
			return 0xba228d3a;
		case 0x00007220:
			return 0x88e64b71;
		case 0x00007224:
			return 0xfec3a309;
		case 0x00007228:
			return 0x51e53f36;
		case 0x0000722c:
			return 0x87750fef;
		case 0x00007230:
			return 0x05c14da0;
		case 0x00007234:
			return 0x7b6b7f9b;
		case 0x00007238:
			return 0x49529e17;
		case 0x0000723c:
			return 0xe252ce8f;
		case 0x00007240:
			return 0xa9066972;
		case 0x00007244:
			return 0xfaecdb90;
		case 0x00007248:
			return 0x2859c655;
		case 0x0000724c:
			return 0xf8442654;
		case 0x00007250:
			return 0xe4e55351;
		case 0x00007254:
			return 0xe05ae24a;
		case 0x00007258:
			return 0x83497e01;
		case 0x0000725c:
			return 0x390e4ee0;
		case 0x00007260:
			return 0xa233c0bc;
		case 0x00007264:
			return 0xc78befa7;
		case 0x00007268:
			return 0x4bb70d9c;
		case 0x0000726c:
			return 0xe46953ff;
		case 0x00007270:
			return 0x2b0bae3c;
		case 0x00007274:
			return 0xe6014d23;
		case 0x00007278:
			return 0x9d0b8ca8;
		case 0x0000727c:
			return 0x0b8c0ca7;
		case 0x00007280:
			return 0x80d89ed3;
		case 0x00007284:
			return 0xd9ee9f21;
		case 0x00007288:
			return 0x0e080749;
		case 0x0000728c:
			return 0x3908b1ee;
		case 0x00007290:
			return 0xb8cc2a2d;
		case 0x00007294:
			return 0x81f03412;
		case 0x00007298:
			return 0x09588bc5;
		case 0x0000729c:
			return 0x369b08c7;
		case 0x000072a0:
			return 0x6f1a02d0;
		case 0x000072a4:
			return 0x52de994d;
		case 0x000072a8:
			return 0x0e4c807c;
		case 0x000072ac:
			return 0x66c2f127;
		case 0x000072b0:
			return 0x9ee2e143;
		case 0x000072b4:
			return 0x7b348730;
		case 0x000072b8:
			return 0xb0441929;
		case 0x000072bc:
			return 0xe8893a6e;
		case 0x000072c0:
			return 0x8db87574;
		case 0x000072c4:
			return 0x636b4153;
		case 0x000072c8:
			return 0x2d5b050e;
		case 0x000072cc:
			return 0xab8ede0f;
		case 0x000072d0:
			return 0x76e71328;
		case 0x000072d4:
			return 0x36dbebff;
		case 0x000072d8:
			return 0xf2c9567e;
		case 0x000072dc:
			return 0xfb36dc69;
		case 0x000072e0:
			return 0x63a62290;
		case 0x000072e4:
			return 0x8de2e3fe;
		case 0x000072e8:
			return 0xda4eb032;
		case 0x000072ec:
			return 0x5c58277a;
		case 0x000072f0:
			return 0x621dcd77;
		case 0x000072f4:
			return 0x771ac91f;
		case 0x000072f8:
			return 0xeb24b02f;
		case 0x000072fc:
			return 0x2c0704b3;
		case 0x00007300:
			return 0xf77e5a45;
		case 0x00007304:
			return 0xc8bd3611;
		case 0x00007308:
			return 0x236d0fa9;
		case 0x0000730c:
			return 0x9e9eccfd;
		case 0x00007310:
			return 0xf82b7eee;
		case 0x00007314:
			return 0x4d564864;
		case 0x00007318:
			return 0x0b32ed9f;
		case 0x0000731c:
			return 0x65dbab75;
		case 0x00007320:
			return 0x268eec63;
		case 0x00007324:
			return 0xab0bf7f5;
		case 0x00007328:
			return 0x39bad883;
		case 0x0000732c:
			return 0xc557ffc6;
		case 0x00007330:
			return 0x7b47e1b1;
		case 0x00007334:
			return 0x8e03d6d2;
		case 0x00007338:
			return 0xb2f06c45;
		case 0x0000733c:
			return 0x3684e4b5;
		case 0x00007340:
			return 0x131f17d3;
		case 0x00007344:
			return 0xd9b66866;
		case 0x00007348:
			return 0x8e60047d;
		case 0x0000734c:
			return 0xdfa05f69;
		case 0x00007350:
			return 0xe2a2e366;
		case 0x00007354:
			return 0x9d0d2a81;
		case 0x00007358:
			return 0xb6915669;
		case 0x0000735c:
			return 0x438b8fbc;
		case 0x00007360:
			return 0x02f94de4;
		case 0x00007364:
			return 0x7b6f17a0;
		case 0x00007368:
			return 0x77a18763;
		case 0x0000736c:
			return 0xc3495659;
		case 0x00007370:
			return 0x79ea5280;
		case 0x00007374:
			return 0x3dfb9394;
		case 0x00007378:
			return 0xb354e690;
		case 0x0000737c:
			return 0x300142a4;
		case 0x00007380:
			return 0xbf911220;
		case 0x00007384:
			return 0xb3ece916;
		case 0x00007388:
			return 0xfcf5c988;
		case 0x0000738c:
			return 0xbab9ef79;
		case 0x00007390:
			return 0xe5f06e8e;
		case 0x00007394:
			return 0xbeb3be2c;
		case 0x00007398:
			return 0xb9ab66fb;
		case 0x0000739c:
			return 0x71913b7c;
		case 0x000073a0:
			return 0x39f29a45;
		case 0x000073a4:
			return 0x1fdaa5ca;
		case 0x000073a8:
			return 0x53252611;
		case 0x000073ac:
			return 0xcfe0fdc9;
		case 0x000073b0:
			return 0x13f36f88;
		case 0x000073b4:
			return 0x9d132df0;
		case 0x000073b8:
			return 0x456eb623;
		case 0x000073bc:
			return 0x423038f9;
		case 0x000073c0:
			return 0x95b9220e;
		case 0x000073c4:
			return 0xefa1b8d0;
		case 0x000073c8:
			return 0xbff10c31;
		case 0x000073cc:
			return 0x4f5d77fe;
		case 0x000073d0:
			return 0x06fefc4f;
		case 0x000073d4:
			return 0xafa47db6;
		case 0x000073d8:
			return 0x76592903;
		case 0x000073dc:
			return 0x04440847;
		case 0x000073e0:
			return 0x3e8aaf36;
		case 0x000073e4:
			return 0xa3ab5040;
		case 0x000073e8:
			return 0x17937e04;
		case 0x000073ec:
			return 0x7164ff30;
		case 0x000073f0:
			return 0xafd4d423;
		case 0x000073f4:
			return 0xf3015a79;
		case 0x000073f8:
			return 0xeff200e0;
		case 0x000073fc:
			return 0xb7d64704;
		case 0x00007400:
			return 0x1b75c089;
		case 0x00007404:
			return 0xe0029fc6;
		case 0x00007408:
			return 0x50de6df1;
		case 0x0000740c:
			return 0xe125ac09;
		case 0x00007410:
			return 0xe678f46c;
		case 0x00007414:
			return 0x26c8606a;
		case 0x00007418:
			return 0x86db07e7;
		case 0x0000741c:
			return 0x472bc3ce;
		case 0x00007420:
			return 0x01108305;
		case 0x00007424:
			return 0xb579f9d7;
		case 0x00007428:
			return 0x0dccb605;
		case 0x0000742c:
			return 0x0c8e34b7;
		case 0x00007430:
			return 0xbb0ff086;
		case 0x00007434:
			return 0xf9e1f34c;
		case 0x00007438:
			return 0x407210d3;
		case 0x0000743c:
			return 0xae2dbbaa;
		case 0x00007440:
			return 0xbbe747fd;
		case 0x00007444:
			return 0xbb8becf6;
		case 0x00007448:
			return 0xa317ab56;
		case 0x0000744c:
			return 0xad551b2c;
		case 0x00007450:
			return 0x6053ba06;
		case 0x00007454:
			return 0x4c4364c4;
		case 0x00007458:
			return 0x0806436a;
		case 0x0000745c:
			return 0x47d735e6;
		case 0x00007460:
			return 0xe2648541;
		case 0x00007464:
			return 0xc2758c46;
		case 0x00007468:
			return 0x846a6713;
		case 0x0000746c:
			return 0xd1c9b030;
		case 0x00007470:
			return 0xbfc22ac6;
		case 0x00007474:
			return 0xd1336a90;
		case 0x00007478:
			return 0xb9cb4b6f;
		case 0x0000747c:
			return 0xa6feb009;
		case 0x00007480:
			return 0x5f82fb9d;
		case 0x00007484:
			return 0x0b595849;
		case 0x00007488:
			return 0x16218b1d;
		case 0x0000748c:
			return 0xc082672f;
		case 0x00007490:
			return 0x18c6ef8b;
		case 0x00007494:
			return 0x9f3f4260;
		case 0x00007498:
			return 0xb4009488;
		case 0x0000749c:
			return 0xb39da81f;
		case 0x000074a0:
			return 0x8f486f0f;
		case 0x000074a4:
			return 0x03351635;
		case 0x000074a8:
			return 0x97277a0c;
		case 0x000074ac:
			return 0x054b9855;
		case 0x000074b0:
			return 0xf8edf83a;
		case 0x000074b4:
			return 0x95c5984f;
		case 0x000074b8:
			return 0x592cc221;
		case 0x000074bc:
			return 0xe088e045;
		case 0x000074c0:
			return 0x4a7762f2;
		case 0x000074c4:
			return 0x799bee62;
		case 0x000074c8:
			return 0x9c501dc7;
		case 0x000074cc:
			return 0x9ef9fcb0;
		case 0x000074d0:
			return 0xd9e4634d;
		case 0x000074d4:
			return 0x9fcb7efa;
		case 0x000074d8:
			return 0xf2d1bca9;
		case 0x000074dc:
			return 0x223a66e9;
		case 0x000074e0:
			return 0x7b8414d4;
		case 0x000074e4:
			return 0x3c2fb7e4;
		case 0x000074e8:
			return 0xade0bab5;
		case 0x000074ec:
			return 0xd67b176d;
		case 0x000074f0:
			return 0x32fe525c;
		case 0x000074f4:
			return 0x5cabcabc;
		case 0x000074f8:
			return 0xec7d0719;
		case 0x000074fc:
			return 0xde5a6748;
		case 0x00007500:
			return 0x4eb9cfe7;
		case 0x00007504:
			return 0x590489ae;
		case 0x00007508:
			return 0x19b3a4e3;
		case 0x0000750c:
			return 0x17f7378a;
		case 0x00007510:
			return 0x230b8bdc;
		case 0x00007514:
			return 0xb32a976a;
		case 0x00007518:
			return 0x0b3827b5;
		case 0x0000751c:
			return 0xc51d21bb;
		case 0x00007520:
			return 0x4cd07703;
		case 0x00007524:
			return 0x3eefa349;
		case 0x00007528:
			return 0x0265dc5c;
		case 0x0000752c:
			return 0xdc949a6c;
		case 0x00007530:
			return 0xfe8c58e3;
		case 0x00007534:
			return 0x2522846b;
		case 0x00007538:
			return 0xec9d49fe;
		case 0x0000753c:
			return 0xcc269821;
		case 0x00007540:
			return 0xb8830cbf;
		case 0x00007544:
			return 0x4aea5e88;
		case 0x00007548:
			return 0x1ef2ccda;
		case 0x0000754c:
			return 0x86e2cfd3;
		case 0x00007550:
			return 0x3556165d;
		case 0x00007554:
			return 0x08ab290a;
		case 0x00007558:
			return 0xcac56c42;
		case 0x0000755c:
			return 0xfbe846f2;
		case 0x00007560:
			return 0x2fa514c6;
		case 0x00007564:
			return 0x7c33cad2;
		case 0x00007568:
			return 0xc2118805;
		case 0x0000756c:
			return 0xae51c177;
		case 0x00007570:
			return 0x2ad58b0e;
		case 0x00007574:
			return 0x441d0565;
		case 0x00007578:
			return 0xe2f6014a;
		case 0x0000757c:
			return 0xd065f9f6;
		case 0x00007580:
			return 0x5db4e905;
		case 0x00007584:
			return 0x23e3627d;
		case 0x00007588:
			return 0x06adcef5;
		case 0x0000758c:
			return 0xc22f5b77;
		case 0x00007590:
			return 0x0215295a;
		case 0x00007594:
			return 0x288907e9;
		case 0x00007598:
			return 0x9c09fabe;
		case 0x0000759c:
			return 0x8c6a3a9a;
		case 0x000075a0:
			return 0x7db7a872;
		case 0x000075a4:
			return 0x9bd52887;
		case 0x000075a8:
			return 0x93137d36;
		case 0x000075ac:
			return 0xa946626e;
		case 0x000075b0:
			return 0x8f1498e0;
		case 0x000075b4:
			return 0x3361dfba;
		case 0x000075b8:
			return 0x758597fc;
		case 0x000075bc:
			return 0xf587807d;
		case 0x000075c0:
			return 0x2f078ce8;
		case 0x000075c4:
			return 0x99cda8b5;
		case 0x000075c8:
			return 0xdade6714;
		case 0x000075cc:
			return 0x36a8ec16;
		case 0x000075d0:
			return 0x68908bc2;
		case 0x000075d4:
			return 0x71d99694;
		case 0x000075d8:
			return 0xc38bb823;
		case 0x000075dc:
			return 0x6338d5ff;
		case 0x000075e0:
			return 0x5c0468d4;
		case 0x000075e4:
			return 0xa302bd0e;
		case 0x000075e8:
			return 0x1f3f0295;
		case 0x000075ec:
			return 0x13d7ca3f;
		case 0x000075f0:
			return 0x9d9654d8;
		case 0x000075f4:
			return 0x7afae637;
		case 0x000075f8:
			return 0xc03886f6;
		case 0x000075fc:
			return 0xdb95b241;
		case 0x00007600:
			return 0xa5c2f2a4;
		case 0x00007604:
			return 0x33d29f15;
		case 0x00007608:
			return 0xb7646f2b;
		case 0x0000760c:
			return 0x7c3a8a2c;
		case 0x00007610:
			return 0x1ff222ee;
		case 0x00007614:
			return 0xed85aad7;
		case 0x00007618:
			return 0x5fea1957;
		case 0x0000761c:
			return 0xe702d11a;
		case 0x00007620:
			return 0x5f367827;
		case 0x00007624:
			return 0xe98be33c;
		case 0x00007628:
			return 0xfb5d7d12;
		case 0x0000762c:
			return 0x07a67e92;
		case 0x00007630:
			return 0xa78030b9;
		case 0x00007634:
			return 0xb7e065d0;
		case 0x00007638:
			return 0x4ee7c046;
		case 0x0000763c:
			return 0x358f2bba;
		case 0x00007640:
			return 0x2c3ca208;
		case 0x00007644:
			return 0xcdc942bf;
		case 0x00007648:
			return 0x4d562eff;
		case 0x0000764c:
			return 0xd3b3604e;
		case 0x00007650:
			return 0x95216f78;
		case 0x00007654:
			return 0x3c142b6f;
		case 0x00007658:
			return 0x57ceaf65;
		case 0x0000765c:
			return 0xd634047f;
		case 0x00007660:
			return 0x1ce2e3ac;
		case 0x00007664:
			return 0xaf0e2654;
		case 0x00007668:
			return 0x8b32eef4;
		case 0x0000766c:
			return 0xd21fe9bc;
		case 0x00007670:
			return 0x54b0896d;
		case 0x00007674:
			return 0xe6abc193;
		case 0x00007678:
			return 0x21392c73;
		case 0x0000767c:
			return 0xa83c95fb;
		case 0x00007680:
			return 0x876a56fa;
		case 0x00007684:
			return 0xc91163ca;
		case 0x00007688:
			return 0xe2e7979f;
		case 0x0000768c:
			return 0xbcaa78f8;
		case 0x00007690:
			return 0xc44ae389;
		case 0x00007694:
			return 0x152708d0;
		case 0x00007698:
			return 0x99e716e9;
		case 0x0000769c:
			return 0xcdef32ed;
		case 0x000076a0:
			return 0x0f40747f;
		case 0x000076a4:
			return 0x7333d438;
		case 0x000076a8:
			return 0xcb5de12f;
		case 0x000076ac:
			return 0xc93dae25;
		case 0x000076b0:
			return 0xc622a005;
		case 0x000076b4:
			return 0x2c26634f;
		case 0x000076b8:
			return 0xe6b11cb4;
		case 0x000076bc:
			return 0xb1a4492d;
		case 0x000076c0:
			return 0x63fc70bf;
		case 0x000076c4:
			return 0x94c59daa;
		case 0x000076c8:
			return 0xb1dc31c0;
		case 0x000076cc:
			return 0xc6c02cdf;
		case 0x000076d0:
			return 0xea163ab4;
		case 0x000076d4:
			return 0x7398bd84;
		case 0x000076d8:
			return 0x9d4a6236;
		case 0x000076dc:
			return 0x1b6a1bbc;
		case 0x000076e0:
			return 0x940c3ef7;
		case 0x000076e4:
			return 0xfec78692;
		case 0x000076e8:
			return 0x2b2cb164;
		case 0x000076ec:
			return 0x69906602;
		case 0x000076f0:
			return 0x789d915a;
		case 0x000076f4:
			return 0x8aae08e6;
		case 0x000076f8:
			return 0x08348c35;
		case 0x000076fc:
			return 0xe6274dbd;
		case 0x00007700:
			return 0x220d24f3;
		case 0x00007704:
			return 0xed8d5314;
		case 0x00007708:
			return 0x49402a31;
		case 0x0000770c:
			return 0x7d1fd405;
		case 0x00007710:
			return 0xcf439049;
		case 0x00007714:
			return 0x80727a48;
		case 0x00007718:
			return 0x743dd1a1;
		case 0x0000771c:
			return 0xa4091ca1;
		case 0x00007720:
			return 0xa1cb0388;
		case 0x00007724:
			return 0x4986045f;
		case 0x00007728:
			return 0x9e222d1d;
		case 0x0000772c:
			return 0x64bde775;
		case 0x00007730:
			return 0x6d8503db;
		case 0x00007734:
			return 0xa01adab1;
		case 0x00007738:
			return 0x80a23cdf;
		case 0x0000773c:
			return 0xefa01522;
		case 0x00007740:
			return 0x7109b55b;
		case 0x00007744:
			return 0x918f0a65;
		case 0x00007748:
			return 0xdac1e9c1;
		case 0x0000774c:
			return 0x9d42fdc9;
		case 0x00007750:
			return 0x4c354883;
		case 0x00007754:
			return 0x9af7607a;
		case 0x00007758:
			return 0xc0b2f7a2;
		case 0x0000775c:
			return 0x7844e729;
		case 0x00007760:
			return 0x9976b16f;
		case 0x00007764:
			return 0x6a8e9d9c;
		case 0x00007768:
			return 0xd6a1df96;
		case 0x0000776c:
			return 0x59d7b5bc;
		case 0x00007770:
			return 0x0995a007;
		case 0x00007774:
			return 0x16b87f1a;
		case 0x00007778:
			return 0xab3601fb;
		case 0x0000777c:
			return 0x8bb96bb1;
		case 0x00007780:
			return 0xeff1575f;
		case 0x00007784:
			return 0x2f73836d;
		case 0x00007788:
			return 0xf2d9102e;
		case 0x0000778c:
			return 0x307f76d7;
		case 0x00007790:
			return 0xa6c7335a;
		case 0x00007794:
			return 0xe701975b;
		case 0x00007798:
			return 0xe68c4e08;
		case 0x0000779c:
			return 0x54903905;
		case 0x000077a0:
			return 0x296d423a;
		case 0x000077a4:
			return 0x50f38745;
		case 0x000077a8:
			return 0x00ef67dc;
		case 0x000077ac:
			return 0xe4e25e26;
		case 0x000077b0:
			return 0xc9923c21;
		case 0x000077b4:
			return 0xba49f81f;
		case 0x000077b8:
			return 0x352793fb;
		case 0x000077bc:
			return 0xcafcf286;
		case 0x000077c0:
			return 0xee07abb5;
		case 0x000077c4:
			return 0xec487ae3;
		case 0x000077c8:
			return 0x266b7f37;
		case 0x000077cc:
			return 0xba650969;
		case 0x000077d0:
			return 0xe985e3ad;
		case 0x000077d4:
			return 0x93c3434f;
		case 0x000077d8:
			return 0x56c878a4;
		case 0x000077dc:
			return 0x353f26f7;
		case 0x000077e0:
			return 0x1020c5c5;
		case 0x000077e4:
			return 0x3de1ae67;
		case 0x000077e8:
			return 0x42b42261;
		case 0x000077ec:
			return 0xbd9b2687;
		case 0x000077f0:
			return 0x5398349c;
		case 0x000077f4:
			return 0x60d71407;
		case 0x000077f8:
			return 0xebf101c6;
		case 0x000077fc:
			return 0x87ed704f;
		case 0x00007800:
			return 0xed0766fb;
		case 0x00007804:
			return 0x1be5343a;
		case 0x00007808:
			return 0x4db77bef;
		case 0x0000780c:
			return 0xfcab1d26;
		case 0x00007810:
			return 0x3abf17be;
		case 0x00007814:
			return 0xebdf4abd;
		case 0x00007818:
			return 0x07634533;
		case 0x0000781c:
			return 0x67052689;
		case 0x00007820:
			return 0x4af795a7;
		case 0x00007824:
			return 0xfdc0ae9a;
		case 0x00007828:
			return 0x7ecb5ffa;
		case 0x0000782c:
			return 0xe04cc507;
		case 0x00007830:
			return 0xa07e1929;
		case 0x00007834:
			return 0x27adcd5b;
		case 0x00007838:
			return 0x538035fe;
		case 0x0000783c:
			return 0xd58df55a;
		case 0x00007840:
			return 0x30dacc08;
		case 0x00007844:
			return 0x4b83db93;
		case 0x00007848:
			return 0xd9dd04ea;
		case 0x0000784c:
			return 0x417d4985;
		case 0x00007850:
			return 0x847ef82b;
		case 0x00007854:
			return 0x7bd5f0c9;
		case 0x00007858:
			return 0x39d56676;
		case 0x0000785c:
			return 0xb5617038;
		case 0x00007860:
			return 0xf615ea50;
		case 0x00007864:
			return 0x05529c0f;
		case 0x00007868:
			return 0x8b4f2cb0;
		case 0x0000786c:
			return 0x9cfbdac4;
		case 0x00007870:
			return 0xe848e037;
		case 0x00007874:
			return 0xb54cd309;
		case 0x00007878:
			return 0x7b97233d;
		case 0x0000787c:
			return 0x590c4934;
		case 0x00007880:
			return 0xcaaf801f;
		case 0x00007884:
			return 0x0ff0afa8;
		case 0x00007888:
			return 0x38a09476;
		case 0x0000788c:
			return 0x2b7c70ed;
		case 0x00007890:
			return 0x6f051de9;
		case 0x00007894:
			return 0x5fa8e2fc;
		case 0x00007898:
			return 0x3ab4e9b5;
		case 0x0000789c:
			return 0x9035c678;
		case 0x000078a0:
			return 0x0d591926;
		case 0x000078a4:
			return 0xa4bb4c69;
		case 0x000078a8:
			return 0x1f93c24b;
		case 0x000078ac:
			return 0xdb12d2af;
		case 0x000078b0:
			return 0xfb35aac2;
		case 0x000078b4:
			return 0x812efa91;
		case 0x000078b8:
			return 0x685f1bee;
		case 0x000078bc:
			return 0xc0563df5;
		case 0x000078c0:
			return 0xb04d519b;
		case 0x000078c4:
			return 0x28ee17c4;
		case 0x000078c8:
			return 0x551780f2;
		case 0x000078cc:
			return 0x8fada95a;
		case 0x000078d0:
			return 0xcfb928b2;
		case 0x000078d4:
			return 0xe634ea1d;
		case 0x000078d8:
			return 0x5f25f0a1;
		case 0x000078dc:
			return 0xa57008d5;
		case 0x000078e0:
			return 0x99c772cb;
		case 0x000078e4:
			return 0x3dd9aa8d;
		case 0x000078e8:
			return 0x38c6fdf3;
		case 0x000078ec:
			return 0xdca91520;
		case 0x000078f0:
			return 0x562f2a55;
		case 0x000078f4:
			return 0x4a9af087;
		case 0x000078f8:
			return 0xa024f907;
		case 0x000078fc:
			return 0xfb8e1ca2;
		case 0x00007900:
			return 0x03cdf510;
		case 0x00007904:
			return 0xac168b97;
		case 0x00007908:
			return 0x42c49f4e;
		case 0x0000790c:
			return 0x5dbbd0d1;
		case 0x00007910:
			return 0xc7e0d9d4;
		case 0x00007914:
			return 0xa4fbec51;
		case 0x00007918:
			return 0x848737ce;
		case 0x0000791c:
			return 0x7e2d7954;
		case 0x00007920:
			return 0xbfb6bfec;
		case 0x00007924:
			return 0xf97f1203;
		case 0x00007928:
			return 0x87e23ed1;
		case 0x0000792c:
			return 0x23a7697b;
		case 0x00007930:
			return 0xbab81ba3;
		case 0x00007934:
			return 0x37819750;
		case 0x00007938:
			return 0xddf4f80c;
		case 0x0000793c:
			return 0xefa5c1f0;
		case 0x00007940:
			return 0xd223485c;
		case 0x00007944:
			return 0x8ff6cd96;
		case 0x00007948:
			return 0x46da0d1e;
		case 0x0000794c:
			return 0xc6f6dca0;
		case 0x00007950:
			return 0xa7b0c5a1;
		case 0x00007954:
			return 0xcbdf4877;
		case 0x00007958:
			return 0xe50e05a7;
		case 0x0000795c:
			return 0xc32e2d52;
		case 0x00007960:
			return 0x7f4a7427;
		case 0x00007964:
			return 0xdb693e69;
		case 0x00007968:
			return 0xb2d28cb4;
		case 0x0000796c:
			return 0x7293efce;
		case 0x00007970:
			return 0xd4103a53;
		case 0x00007974:
			return 0xeb602715;
		case 0x00007978:
			return 0x92c88197;
		case 0x0000797c:
			return 0x231cadb6;
		case 0x00007980:
			return 0x8caee1eb;
		case 0x00007984:
			return 0x1f935b43;
		case 0x00007988:
			return 0xe372ee6a;
		case 0x0000798c:
			return 0xbf9da0b2;
		case 0x00007990:
			return 0x10cac68b;
		case 0x00007994:
			return 0xdf4d51c8;
		case 0x00007998:
			return 0x458ed3f9;
		case 0x0000799c:
			return 0xe073c007;
		case 0x000079a0:
			return 0x40790294;
		case 0x000079a4:
			return 0xfabbdabb;
		case 0x000079a8:
			return 0xfbf64dbd;
		case 0x000079ac:
			return 0x06ae2c2d;
		case 0x000079b0:
			return 0x78f34442;
		case 0x000079b4:
			return 0x29b31aba;
		case 0x000079b8:
			return 0x4a902adf;
		case 0x000079bc:
			return 0xd48902b3;
		case 0x000079c0:
			return 0x685da2df;
		case 0x000079c4:
			return 0x6d8b3e71;
		case 0x000079c8:
			return 0xd640f965;
		case 0x000079cc:
			return 0xf82dc1e2;
		case 0x000079d0:
			return 0x4737bbfb;
		case 0x000079d4:
			return 0x0df213c9;
		case 0x000079d8:
			return 0xb30d3c02;
		case 0x000079dc:
			return 0xbe8dced7;
		case 0x000079e0:
			return 0x1dab4844;
		case 0x000079e4:
			return 0x1d00ecd3;
		case 0x000079e8:
			return 0x56a24a36;
		case 0x000079ec:
			return 0x847cef3c;
		case 0x000079f0:
			return 0x8d71efd2;
		case 0x000079f4:
			return 0x327c9a28;
		case 0x000079f8:
			return 0xcd823726;
		case 0x000079fc:
			return 0x9fd9e105;
		case 0x00007a00:
			return 0xa47f9971;
		case 0x00007a04:
			return 0x09cf9a95;
		case 0x00007a08:
			return 0x39ad4ee0;
		case 0x00007a0c:
			return 0x74624077;
		case 0x00007a10:
			return 0x9cb4ca37;
		case 0x00007a14:
			return 0xbb8bf399;
		case 0x00007a18:
			return 0x55a75207;
		case 0x00007a1c:
			return 0x7a84fb58;
		case 0x00007a20:
			return 0xd7baf911;
		case 0x00007a24:
			return 0x0442f967;
		case 0x00007a28:
			return 0x078bad67;
		case 0x00007a2c:
			return 0x0bf20779;
		case 0x00007a30:
			return 0x2c473d76;
		case 0x00007a34:
			return 0x33182693;
		case 0x00007a38:
			return 0xd7ec7641;
		case 0x00007a3c:
			return 0x66e01674;
		case 0x00007a40:
			return 0x127956eb;
		case 0x00007a44:
			return 0x8339816f;
		case 0x00007a48:
			return 0xac70f1f5;
		case 0x00007a4c:
			return 0xfafcef55;
		case 0x00007a50:
			return 0x40975ae4;
		case 0x00007a54:
			return 0x7d7088b2;
		case 0x00007a58:
			return 0xe395dadb;
		case 0x00007a5c:
			return 0x8b75e5ea;
		case 0x00007a60:
			return 0xc3a3af0e;
		case 0x00007a64:
			return 0x5ed5ade0;
		case 0x00007a68:
			return 0x2c65c4e6;
		case 0x00007a6c:
			return 0x68f97bda;
		case 0x00007a70:
			return 0xac458dfc;
		case 0x00007a74:
			return 0x2dfbaa51;
		case 0x00007a78:
			return 0xe3907047;
		case 0x00007a7c:
			return 0x411c6ffa;
		case 0x00007a80:
			return 0x8ba9ba5e;
		case 0x00007a84:
			return 0xcbd0f647;
		case 0x00007a88:
			return 0xdb232554;
		case 0x00007a8c:
			return 0x920b3706;
		case 0x00007a90:
			return 0x15cd4bcb;
		case 0x00007a94:
			return 0xda3ab8af;
		case 0x00007a98:
			return 0x26117622;
		case 0x00007a9c:
			return 0xfd8c0b24;
		case 0x00007aa0:
			return 0x212441a0;
		case 0x00007aa4:
			return 0xa545c258;
		case 0x00007aa8:
			return 0xd86ede97;
		case 0x00007aac:
			return 0x8f7d6816;
		case 0x00007ab0:
			return 0x8608328e;
		case 0x00007ab4:
			return 0xd549e846;
		case 0x00007ab8:
			return 0x8e897109;
		case 0x00007abc:
			return 0xedf6d9f4;
		case 0x00007ac0:
			return 0x32f59171;
		case 0x00007ac4:
			return 0x867f6805;
		case 0x00007ac8:
			return 0x66af040c;
		case 0x00007acc:
			return 0xd508e219;
		case 0x00007ad0:
			return 0x53f0dd96;
		case 0x00007ad4:
			return 0xd080a90a;
		case 0x00007ad8:
			return 0x822962c9;
		case 0x00007adc:
			return 0x63eaef9b;
		case 0x00007ae0:
			return 0x1630b41d;
		case 0x00007ae4:
			return 0x0aaf1c4f;
		case 0x00007ae8:
			return 0x0de4d4fc;
		case 0x00007aec:
			return 0xf1d16354;
		case 0x00007af0:
			return 0x8af32f42;
		case 0x00007af4:
			return 0xb3a6bf72;
		case 0x00007af8:
			return 0x1f4fc93f;
		case 0x00007afc:
			return 0x1af6cb2e;
		case 0x00007b00:
			return 0xd19a98ab;
		case 0x00007b04:
			return 0x0e703d2d;
		case 0x00007b08:
			return 0xae92f9f8;
		case 0x00007b0c:
			return 0x03512e31;
		case 0x00007b10:
			return 0x8a028851;
		case 0x00007b14:
			return 0xb4a02a21;
		case 0x00007b18:
			return 0x63aec7f0;
		case 0x00007b1c:
			return 0x6ce6cb0a;
		case 0x00007b20:
			return 0x2fb19b25;
		case 0x00007b24:
			return 0x7347b039;
		case 0x00007b28:
			return 0xdb187cca;
		case 0x00007b2c:
			return 0x55186ff1;
		case 0x00007b30:
			return 0x91344bed;
		case 0x00007b34:
			return 0xe225241a;
		case 0x00007b38:
			return 0xf11aedff;
		case 0x00007b3c:
			return 0x8e950635;
		case 0x00007b40:
			return 0x60847147;
		case 0x00007b44:
			return 0xdf509234;
		case 0x00007b48:
			return 0x87b9af60;
		case 0x00007b4c:
			return 0x8a6a4121;
		case 0x00007b50:
			return 0xdbc2d81c;
		case 0x00007b54:
			return 0x63593c95;
		case 0x00007b58:
			return 0x0ed5f9c9;
		case 0x00007b5c:
			return 0x2e34d7dc;
		case 0x00007b60:
			return 0xc396e3ae;
		case 0x00007b64:
			return 0x121d04a1;
		case 0x00007b68:
			return 0x557b1f60;
		case 0x00007b6c:
			return 0x9695bc13;
		case 0x00007b70:
			return 0xd4dfe18b;
		case 0x00007b74:
			return 0x95ce3d45;
		case 0x00007b78:
			return 0x7f4615f6;
		case 0x00007b7c:
			return 0x8b89dd63;
		case 0x00007b80:
			return 0xad4fbdfc;
		case 0x00007b84:
			return 0xe24b7993;
		case 0x00007b88:
			return 0x8740a37b;
		case 0x00007b8c:
			return 0x47d12bd6;
		case 0x00007b90:
			return 0xecd5e133;
		case 0x00007b94:
			return 0x750d1765;
		case 0x00007b98:
			return 0x96e580ce;
		case 0x00007b9c:
			return 0x49d6162d;
		case 0x00007ba0:
			return 0x7cc7acd8;
		case 0x00007ba4:
			return 0xcacf6e92;
		case 0x00007ba8:
			return 0xf12d378a;
		case 0x00007bac:
			return 0xfd59aebc;
		case 0x00007bb0:
			return 0x249b8cca;
		case 0x00007bb4:
			return 0xc9082f6e;
		case 0x00007bb8:
			return 0xc8d4a172;
		case 0x00007bbc:
			return 0x3d843942;
		case 0x00007bc0:
			return 0x6d02bbad;
		case 0x00007bc4:
			return 0x963c1db5;
		case 0x00007bc8:
			return 0x180a209c;
		case 0x00007bcc:
			return 0xb3948a3a;
		case 0x00007bd0:
			return 0x4187eda0;
		case 0x00007bd4:
			return 0xa32e0aa4;
		case 0x00007bd8:
			return 0x8bc5fb4c;
		case 0x00007bdc:
			return 0xe1c7683e;
		case 0x00007be0:
			return 0xe54a61a9;
		case 0x00007be4:
			return 0xb3bdf72f;
		case 0x00007be8:
			return 0x74f63ccc;
		case 0x00007bec:
			return 0x73bae2ba;
		case 0x00007bf0:
			return 0x6e627e33;
		case 0x00007bf4:
			return 0x9c3e7b2f;
		case 0x00007bf8:
			return 0x91bcf8d3;
		case 0x00007bfc:
			return 0x1e3f4e51;
		case 0x00007c00:
			return 0x7f3bee4d;
		case 0x00007c04:
			return 0x50b4c882;
		case 0x00007c08:
			return 0xb0f23724;
		case 0x00007c0c:
			return 0xa9783f62;
		case 0x00007c10:
			return 0xa76b3c47;
		case 0x00007c14:
			return 0x3cdd0175;
		case 0x00007c18:
			return 0x8f5a46c0;
		case 0x00007c1c:
			return 0xc25c6d63;
		case 0x00007c20:
			return 0x6bba2f35;
		case 0x00007c24:
			return 0x06dc0082;
		case 0x00007c28:
			return 0x429497f1;
		case 0x00007c2c:
			return 0x8b0ef55c;
		case 0x00007c30:
			return 0x022ff327;
		case 0x00007c34:
			return 0x7178d3d1;
		case 0x00007c38:
			return 0xb27cb67e;
		case 0x00007c3c:
			return 0x67e595a4;
		case 0x00007c40:
			return 0xfd1b21a4;
		case 0x00007c44:
			return 0x2114a29d;
		case 0x00007c48:
			return 0xf8e68b8b;
		case 0x00007c4c:
			return 0xf372e280;
		case 0x00007c50:
			return 0x614fa72f;
		case 0x00007c54:
			return 0x38d1ad66;
		case 0x00007c58:
			return 0x9567663a;
		case 0x00007c5c:
			return 0x179ccf22;
		case 0x00007c60:
			return 0xc3c88f11;
		case 0x00007c64:
			return 0x1d8ef363;
		case 0x00007c68:
			return 0xacd4a123;
		case 0x00007c6c:
			return 0x34e2e08e;
		case 0x00007c70:
			return 0xad10fc6c;
		case 0x00007c74:
			return 0x94aac3f2;
		case 0x00007c78:
			return 0x8172d638;
		case 0x00007c7c:
			return 0xa8e2ac56;
		case 0x00007c80:
			return 0x21a415a7;
		case 0x00007c84:
			return 0xff1506ba;
		case 0x00007c88:
			return 0xfbd849f0;
		case 0x00007c8c:
			return 0x7433a067;
		case 0x00007c90:
			return 0xf086a629;
		case 0x00007c94:
			return 0x33c190d1;
		case 0x00007c98:
			return 0xc4ec4262;
		case 0x00007c9c:
			return 0xfa8c7179;
		case 0x00007ca0:
			return 0x5fc005df;
		case 0x00007ca4:
			return 0x037fe22d;
		case 0x00007ca8:
			return 0x29e08a43;
		case 0x00007cac:
			return 0xc23f3b33;
		case 0x00007cb0:
			return 0xdb708f18;
		case 0x00007cb4:
			return 0x1f97bf67;
		case 0x00007cb8:
			return 0xee6a46e1;
		case 0x00007cbc:
			return 0xb6fd7887;
		case 0x00007cc0:
			return 0xad9a66d2;
		case 0x00007cc4:
			return 0xb87a77c1;
		case 0x00007cc8:
			return 0x2f641ac3;
		case 0x00007ccc:
			return 0xc5c4d0f9;
		case 0x00007cd0:
			return 0x05f736a1;
		case 0x00007cd4:
			return 0xdfd82496;
		case 0x00007cd8:
			return 0xe5826296;
		case 0x00007cdc:
			return 0x710fcea7;
		case 0x00007ce0:
			return 0xdf54a9cd;
		case 0x00007ce4:
			return 0x8148ac91;
		case 0x00007ce8:
			return 0xfe70a4b9;
		case 0x00007cec:
			return 0xcbcca437;
		case 0x00007cf0:
			return 0xb4a7ed1f;
		case 0x00007cf4:
			return 0xd2e9c883;
		case 0x00007cf8:
			return 0x4a0c894a;
		case 0x00007cfc:
			return 0x96fd6163;
		case 0x00007d00:
			return 0x31ef1272;
		case 0x00007d04:
			return 0xb2f8085a;
		case 0x00007d08:
			return 0x65c9c4e0;
		case 0x00007d0c:
			return 0xa8a56ba7;
		case 0x00007d10:
			return 0x5e87eb29;
		case 0x00007d14:
			return 0x45a8da86;
		case 0x00007d18:
			return 0x83ec6f46;
		case 0x00007d1c:
			return 0xb50000f6;
		case 0x00007d20:
			return 0x6bc98c8f;
		case 0x00007d24:
			return 0x5b908d3d;
		case 0x00007d28:
			return 0x7155ed18;
		case 0x00007d2c:
			return 0x73f868da;
		case 0x00007d30:
			return 0x651a7fc2;
		case 0x00007d34:
			return 0x4323047d;
		case 0x00007d38:
			return 0xa486d0ab;
		case 0x00007d3c:
			return 0xe69c4e4f;
		case 0x00007d40:
			return 0x4b936235;
		case 0x00007d44:
			return 0xcaaaaa9a;
		case 0x00007d48:
			return 0x2ad3310f;
		case 0x00007d4c:
			return 0x8fcc7ad0;
		case 0x00007d50:
			return 0x7bc10eda;
		case 0x00007d54:
			return 0x7e47e1d9;
		case 0x00007d58:
			return 0x56b9500a;
		case 0x00007d5c:
			return 0xddec146e;
		case 0x00007d60:
			return 0x79ef2809;
		case 0x00007d64:
			return 0xa0802f31;
		case 0x00007d68:
			return 0x16e0074b;
		case 0x00007d6c:
			return 0xc7c94f8f;
		case 0x00007d70:
			return 0x73e56b5e;
		case 0x00007d74:
			return 0x3fbedf6d;
		case 0x00007d78:
			return 0x4f792da1;
		case 0x00007d7c:
			return 0x7ba24aab;
		case 0x00007d80:
			return 0xb698402d;
		case 0x00007d84:
			return 0xd677cc62;
		case 0x00007d88:
			return 0x00ff48be;
		case 0x00007d8c:
			return 0x4c419e52;
		case 0x00007d90:
			return 0x7277cc80;
		case 0x00007d94:
			return 0x558df448;
		case 0x00007d98:
			return 0x8e13e71a;
		case 0x00007d9c:
			return 0x3f7f1cc6;
		case 0x00007da0:
			return 0xfcbdf0c0;
		case 0x00007da4:
			return 0xc9678a32;
		case 0x00007da8:
			return 0x8815186f;
		case 0x00007dac:
			return 0x5885f004;
		case 0x00007db0:
			return 0x185106da;
		case 0x00007db4:
			return 0xdbc2c0ef;
		case 0x00007db8:
			return 0xbdd938c7;
		case 0x00007dbc:
			return 0xb5b4d9d2;
		case 0x00007dc0:
			return 0x2262d53d;
		case 0x00007dc4:
			return 0x48a471eb;
		case 0x00007dc8:
			return 0xbc76b3d1;
		case 0x00007dcc:
			return 0x183a7472;
		case 0x00007dd0:
			return 0x32bbcbb1;
		case 0x00007dd4:
			return 0x9c024cad;
		case 0x00007dd8:
			return 0x75248409;
		case 0x00007ddc:
			return 0x1eb271fa;
		case 0x00007de0:
			return 0x359d2cae;
		case 0x00007de4:
			return 0x53adf503;
		case 0x00007de8:
			return 0xcfa20307;
		case 0x00007dec:
			return 0xa209224b;
		case 0x00007df0:
			return 0x62cef6b6;
		case 0x00007df4:
			return 0xd946fe0c;
		case 0x00007df8:
			return 0x10463d62;
		case 0x00007dfc:
			return 0xb3ad1e1a;
		case 0x00007e00:
			return 0x5e010bcc;
		case 0x00007e04:
			return 0x69b28051;
		case 0x00007e08:
			return 0x104c2f7c;
		case 0x00007e0c:
			return 0x656b7758;
		case 0x00007e10:
			return 0x552af1f1;
		case 0x00007e14:
			return 0x947423a4;
		case 0x00007e18:
			return 0x555f6943;
		case 0x00007e1c:
			return 0x24c822a6;
		case 0x00007e20:
			return 0x93f81a00;
		case 0x00007e24:
			return 0x2998c631;
		case 0x00007e28:
			return 0x80730d5b;
		case 0x00007e2c:
			return 0xa192a460;
		case 0x00007e30:
			return 0xf6d0c7ca;
		case 0x00007e34:
			return 0x4753ac08;
		case 0x00007e38:
			return 0x4a898bc1;
		case 0x00007e3c:
			return 0x031b791d;
		case 0x00007e40:
			return 0xdd01a356;
		case 0x00007e44:
			return 0x87149cc3;
		case 0x00007e48:
			return 0x67c3204d;
		case 0x00007e4c:
			return 0x607c32e1;
		case 0x00007e50:
			return 0x484e7089;
		case 0x00007e54:
			return 0xf1539208;
		case 0x00007e58:
			return 0x17f1eb8b;
		case 0x00007e5c:
			return 0x91ef1f6f;
		case 0x00007e60:
			return 0x7b060135;
		case 0x00007e64:
			return 0xc24378d2;
		case 0x00007e68:
			return 0x5989b070;
		case 0x00007e6c:
			return 0x544a5f8f;
		case 0x00007e70:
			return 0x5409a2e0;
		case 0x00007e74:
			return 0xedee8c83;
		case 0x00007e78:
			return 0xa1261397;
		case 0x00007e7c:
			return 0x5668b9de;
		case 0x00007e80:
			return 0xb6fda720;
		case 0x00007e84:
			return 0x20a46a61;
		case 0x00007e88:
			return 0x91d186fe;
		case 0x00007e8c:
			return 0x55d0afab;
		case 0x00007e90:
			return 0x482c643d;
		case 0x00007e94:
			return 0xaa28fb7d;
		case 0x00007e98:
			return 0xb185237d;
		case 0x00007e9c:
			return 0xa9ac46ec;
		case 0x00007ea0:
			return 0x919a429e;
		case 0x00007ea4:
			return 0x7aae7783;
		case 0x00007ea8:
			return 0x960f6d38;
		case 0x00007eac:
			return 0x5c062bb4;
		case 0x00007eb0:
			return 0x69fff7cc;
		case 0x00007eb4:
			return 0x7e62b5dd;
		case 0x00007eb8:
			return 0xe562e0b6;
		case 0x00007ebc:
			return 0x936b4d77;
		case 0x00007ec0:
			return 0xd2f32777;
		case 0x00007ec4:
			return 0xc87968b0;
		case 0x00007ec8:
			return 0xb24497d1;
		case 0x00007ecc:
			return 0x9fc1d216;
		case 0x00007ed0:
			return 0x2b874bbb;
		case 0x00007ed4:
			return 0x18a8f409;
		case 0x00007ed8:
			return 0x9031b107;
		case 0x00007edc:
			return 0x6ebd434b;
		case 0x00007ee0:
			return 0xbe4a9588;
		case 0x00007ee4:
			return 0x35976f5b;
		case 0x00007ee8:
			return 0x459c40a5;
		case 0x00007eec:
			return 0x5f7c1211;
		case 0x00007ef0:
			return 0x0c7fe0ed;
		case 0x00007ef4:
			return 0x95410375;
		case 0x00007ef8:
			return 0x58f158d2;
		case 0x00007efc:
			return 0x38217ce3;
		case 0x00007f00:
			return 0x1914bf57;
		case 0x00007f04:
			return 0xb7fa9ded;
		case 0x00007f08:
			return 0x4073a161;
		case 0x00007f0c:
			return 0x19c6c43d;
		case 0x00007f10:
			return 0x17fe8f70;
		case 0x00007f14:
			return 0xf44b9384;
		case 0x00007f18:
			return 0x8da5d327;
		case 0x00007f1c:
			return 0x266f91be;
		case 0x00007f20:
			return 0xb71c71a7;
		case 0x00007f24:
			return 0x30cae4b7;
		case 0x00007f28:
			return 0xc185c1d8;
		case 0x00007f2c:
			return 0xbc1f820d;
		case 0x00007f30:
			return 0x1e6291f8;
		case 0x00007f34:
			return 0x6bedf54c;
		case 0x00007f38:
			return 0x88cd08ba;
		case 0x00007f3c:
			return 0x20e965fc;
		case 0x00007f40:
			return 0xad60b7b3;
		case 0x00007f44:
			return 0xb9917e8f;
		case 0x00007f48:
			return 0x1e545423;
		case 0x00007f4c:
			return 0x8dc553e2;
		case 0x00007f50:
			return 0x7b1fccd5;
		case 0x00007f54:
			return 0x407e1aac;
		case 0x00007f58:
			return 0x82788862;
		case 0x00007f5c:
			return 0xe100c20d;
		case 0x00007f60:
			return 0x2cb9fc53;
		case 0x00007f64:
			return 0x7fc4b12d;
		case 0x00007f68:
			return 0xcbc1cc66;
		case 0x00007f6c:
			return 0x633b9f20;
		case 0x00007f70:
			return 0x0cb2ab67;
		case 0x00007f74:
			return 0x6e8e8b93;
		case 0x00007f78:
			return 0x094ada01;
		case 0x00007f7c:
			return 0x59a3809c;
		case 0x00007f80:
			return 0xdcd79e57;
		case 0x00007f84:
			return 0xa2ee355b;
		case 0x00007f88:
			return 0xd559bb9a;
		case 0x00007f8c:
			return 0x83edc241;
		case 0x00007f90:
			return 0xb8d9f576;
		case 0x00007f94:
			return 0x556da211;
		case 0x00007f98:
			return 0xd0f8ae2c;
		case 0x00007f9c:
			return 0xf6a8c1af;
		case 0x00007fa0:
			return 0x0aaf2247;
		case 0x00007fa4:
			return 0xc4db21b0;
		case 0x00007fa8:
			return 0x1459ab30;
		case 0x00007fac:
			return 0x729808f3;
		case 0x00007fb0:
			return 0x046abd2f;
		case 0x00007fb4:
			return 0x4bb02018;
		case 0x00007fb8:
			return 0x22d5ec1a;
		case 0x00007fbc:
			return 0xb34206b5;
		case 0x00007fc0:
			return 0xfe39ebce;
		case 0x00007fc4:
			return 0xf543ca75;
		case 0x00007fc8:
			return 0xee9e1d03;
		case 0x00007fcc:
			return 0x1b610078;
		case 0x00007fd0:
			return 0xaf7d7b54;
		case 0x00007fd4:
			return 0x4f790b36;
		case 0x00007fd8:
			return 0xc05c8185;
		case 0x00007fdc:
			return 0xadb553eb;
		case 0x00007fe0:
			return 0x8f36c778;
		case 0x00007fe4:
			return 0x354fc6fa;
		case 0x00007fe8:
			return 0x424b6654;
		case 0x00007fec:
			return 0x5131bad8;
		case 0x00007ff0:
			return 0xa1a3371d;
		case 0x00007ff4:
			return 0x0003d49a;
		case 0x00007ff8:
			return 0x509f7719;
		case 0x00007ffc:
			return 0x299e487f;
		case 0x00008000:
			return 0x79c013b5;
		case 0x00008004:
			return 0x53cd8b1c;
		case 0x00008008:
			return 0xf48437a2;
		case 0x0000800c:
			return 0x899de37c;
		case 0x00008010:
			return 0x3a268f78;
		case 0x00008014:
			return 0x5aa340f7;
		case 0x00008018:
			return 0xa11338dd;
		case 0x0000801c:
			return 0xa9c60b43;
		case 0x00008020:
			return 0x011553bb;
		case 0x00008024:
			return 0x913a1b67;
		case 0x00008028:
			return 0x861e9ad4;
		case 0x0000802c:
			return 0xd76b15a5;
		case 0x00008030:
			return 0x78d5008f;
		case 0x00008034:
			return 0x7e4c7e06;
		case 0x00008038:
			return 0xebca357f;
		case 0x0000803c:
			return 0x57ceca3b;
		case 0x00008040:
			return 0xfe4fc5cf;
		case 0x00008044:
			return 0x3ace4b33;
		case 0x00008048:
			return 0x585d38f8;
		case 0x0000804c:
			return 0xbf58d76b;
		case 0x00008050:
			return 0x78623b1f;
		case 0x00008054:
			return 0x4695b706;
		case 0x00008058:
			return 0x557df36a;
		case 0x0000805c:
			return 0x354478f3;
		case 0x00008060:
			return 0xbb811be3;
		case 0x00008064:
			return 0x1e97e42f;
		case 0x00008068:
			return 0x97fe02e9;
		case 0x0000806c:
			return 0x24d0ea10;
		case 0x00008070:
			return 0xc9b02867;
		case 0x00008074:
			return 0xdfe0bafa;
		case 0x00008078:
			return 0x490285b6;
		case 0x0000807c:
			return 0xb33ecdc4;
		case 0x00008080:
			return 0x178e9cf9;
		case 0x00008084:
			return 0x38ade1cc;
		case 0x00008088:
			return 0x343e2835;
		case 0x0000808c:
			return 0x645c1543;
		case 0x00008090:
			return 0xa750d28b;
		case 0x00008094:
			return 0x36fc8286;
		case 0x00008098:
			return 0x1c0f5455;
		case 0x0000809c:
			return 0xac6ed0d8;
		case 0x000080a0:
			return 0x6f3c2722;
		case 0x000080a4:
			return 0xc8b0238b;
		case 0x000080a8:
			return 0x2ee241dd;
		case 0x000080ac:
			return 0xb3bb15e8;
		case 0x000080b0:
			return 0x2ab737ee;
		case 0x000080b4:
			return 0xda335a0d;
		case 0x000080b8:
			return 0xeee0293a;
		case 0x000080bc:
			return 0x5ef27a03;
		case 0x000080c0:
			return 0x4568d574;
		case 0x000080c4:
			return 0x37759681;
		case 0x000080c8:
			return 0xed2e01bd;
		case 0x000080cc:
			return 0xff695f25;
		case 0x000080d0:
			return 0x4bdd349a;
		case 0x000080d4:
			return 0xf1563c06;
		case 0x000080d8:
			return 0xc392c41a;
		case 0x000080dc:
			return 0xebb0fe63;
		case 0x000080e0:
			return 0x14f802cc;
		case 0x000080e4:
			return 0x9bb28a10;
		case 0x000080e8:
			return 0xba83d3b8;
		case 0x000080ec:
			return 0x0a955c2a;
		case 0x000080f0:
			return 0xbefa6645;
		case 0x000080f4:
			return 0xd3672d47;
		case 0x000080f8:
			return 0xde263d09;
		case 0x000080fc:
			return 0x8f99a9fb;
		case 0x00008100:
			return 0xf516af10;
		case 0x00008104:
			return 0x3a42a0f1;
		case 0x00008108:
			return 0x519d4b7d;
		case 0x0000810c:
			return 0x53ff3657;
		case 0x00008110:
			return 0xd1e55d29;
		case 0x00008114:
			return 0x535001dc;
		case 0x00008118:
			return 0xab1b56c0;
		case 0x0000811c:
			return 0x8d6f3f8c;
		case 0x00008120:
			return 0x98573116;
		case 0x00008124:
			return 0x43aba64d;
		case 0x00008128:
			return 0x47a76980;
		case 0x0000812c:
			return 0x318f5be2;
		case 0x00008130:
			return 0x5ee8b91f;
		case 0x00008134:
			return 0x820ebfc6;
		case 0x00008138:
			return 0x38be0aa3;
		case 0x0000813c:
			return 0x255f12dd;
		case 0x00008140:
			return 0x2a652765;
		case 0x00008144:
			return 0x0a1c7e43;
		case 0x00008148:
			return 0x484d09f0;
		case 0x0000814c:
			return 0xaa065f3a;
		case 0x00008150:
			return 0x9752d93c;
		case 0x00008154:
			return 0x7a47f89c;
		case 0x00008158:
			return 0x58079edf;
		case 0x0000815c:
			return 0x93a9b5b9;
		case 0x00008160:
			return 0x8e63ab87;
		case 0x00008164:
			return 0x145e554d;
		case 0x00008168:
			return 0xe5ef515b;
		case 0x0000816c:
			return 0x65ec4f70;
		case 0x00008170:
			return 0x04dad6d9;
		case 0x00008174:
			return 0x16469f14;
		case 0x00008178:
			return 0x2cd062a0;
		case 0x0000817c:
			return 0xa60d57ba;
		case 0x00008180:
			return 0xbd806db4;
		case 0x00008184:
			return 0x599697aa;
		case 0x00008188:
			return 0x15cc7dde;
		case 0x0000818c:
			return 0xc1022735;
		case 0x00008190:
			return 0xdfd82c7f;
		case 0x00008194:
			return 0xe57d5baa;
		case 0x00008198:
			return 0x4c403218;
		case 0x0000819c:
			return 0x9f6a6586;
		case 0x000081a0:
			return 0x49fcdd9e;
		case 0x000081a4:
			return 0x9c91278d;
		case 0x000081a8:
			return 0xb38929ff;
		case 0x000081ac:
			return 0x2dd2e44f;
		case 0x000081b0:
			return 0x03def2a4;
		case 0x000081b4:
			return 0x87c69d24;
		case 0x000081b8:
			return 0x8365da3c;
		case 0x000081bc:
			return 0xe43b7dba;
		case 0x000081c0:
			return 0x01699c7a;
		case 0x000081c4:
			return 0x61032817;
		case 0x000081c8:
			return 0x0832e000;
		case 0x000081cc:
			return 0xb07aaeb7;
		case 0x000081d0:
			return 0x9960b9dc;
		case 0x000081d4:
			return 0xe9030bdc;
		case 0x000081d8:
			return 0x9016df46;
		case 0x000081dc:
			return 0xb5def4cb;
		case 0x000081e0:
			return 0x5f7e5660;
		case 0x000081e4:
			return 0x8a764b9f;
		case 0x000081e8:
			return 0x5d8f8109;
		case 0x000081ec:
			return 0x0f2a941b;
		case 0x000081f0:
			return 0x60d45306;
		case 0x000081f4:
			return 0x04d8ce6e;
		case 0x000081f8:
			return 0x239fec29;
		case 0x000081fc:
			return 0x1419460c;
		case 0x00008200:
			return 0xa40a8471;
		case 0x00008204:
			return 0x15c9d8c6;
		case 0x00008208:
			return 0xb2d5ff98;
		case 0x0000820c:
			return 0x358b8180;
		case 0x00008210:
			return 0xd8acd2d5;
		case 0x00008214:
			return 0xdea9135e;
		case 0x00008218:
			return 0xcf94daaf;
		case 0x0000821c:
			return 0x682d3570;
		case 0x00008220:
			return 0x6f641e6b;
		case 0x00008224:
			return 0x3e43bf3f;
		case 0x00008228:
			return 0x39e8b04f;
		case 0x0000822c:
			return 0x73bd8235;
		case 0x00008230:
			return 0x2def65c8;
		case 0x00008234:
			return 0x84515b93;
		case 0x00008238:
			return 0x1383cd97;
		case 0x0000823c:
			return 0x3a9c31c9;
		case 0x00008240:
			return 0x3a4afaf2;
		case 0x00008244:
			return 0x1cc2c083;
		case 0x00008248:
			return 0x9acc8784;
		case 0x0000824c:
			return 0xbaff298d;
		case 0x00008250:
			return 0x4b980da1;
		case 0x00008254:
			return 0x6cb480d6;
		case 0x00008258:
			return 0xab5c636f;
		case 0x0000825c:
			return 0x50729637;
		case 0x00008260:
			return 0x93981c4b;
		case 0x00008264:
			return 0xd35b72c7;
		case 0x00008268:
			return 0x5c1cb917;
		case 0x0000826c:
			return 0x1a574048;
		case 0x00008270:
			return 0x131a0390;
		case 0x00008274:
			return 0x4ff8c014;
		case 0x00008278:
			return 0xb63361d9;
		case 0x0000827c:
			return 0x9d519ed1;
		case 0x00008280:
			return 0x2bbb6daf;
		case 0x00008284:
			return 0xe343ea64;
		case 0x00008288:
			return 0x6eb6f24e;
		case 0x0000828c:
			return 0x7751a283;
		case 0x00008290:
			return 0x12128f3e;
		case 0x00008294:
			return 0x2cb33a73;
		case 0x00008298:
			return 0xb6910b45;
		case 0x0000829c:
			return 0xd904905a;
		case 0x000082a0:
			return 0x81ff1577;
		case 0x000082a4:
			return 0x6dec5fbc;
		case 0x000082a8:
			return 0x7bb61894;
		case 0x000082ac:
			return 0x520ea045;
		case 0x000082b0:
			return 0x35ce023e;
		case 0x000082b4:
			return 0x482e4d3f;
		case 0x000082b8:
			return 0xa2415484;
		case 0x000082bc:
			return 0x004061ec;
		case 0x000082c0:
			return 0x1f51baca;
		case 0x000082c4:
			return 0x4b7ddc83;
		case 0x000082c8:
			return 0x21b0262d;
		case 0x000082cc:
			return 0xcea44b66;
		case 0x000082d0:
			return 0xa66a387b;
		case 0x000082d4:
			return 0x3e415107;
		case 0x000082d8:
			return 0xab04cb0c;
		case 0x000082dc:
			return 0xddfe53c4;
		case 0x000082e0:
			return 0x2923e164;
		case 0x000082e4:
			return 0x663ce69c;
		case 0x000082e8:
			return 0x90f24e8a;
		case 0x000082ec:
			return 0x904a69d2;
		case 0x000082f0:
			return 0x779fa26b;
		case 0x000082f4:
			return 0x4fe438d3;
		case 0x000082f8:
			return 0xd0f57883;
		case 0x000082fc:
			return 0x5d146841;
		case 0x00008300:
			return 0xeeaab4d1;
		case 0x00008304:
			return 0x6d6e7213;
		case 0x00008308:
			return 0xafff4d62;
		case 0x0000830c:
			return 0x4980722b;
		case 0x00008310:
			return 0x6214306a;
		case 0x00008314:
			return 0xc35f783d;
		case 0x00008318:
			return 0xc3fa8dcc;
		case 0x0000831c:
			return 0xd424c909;
		case 0x00008320:
			return 0x5dee3c18;
		case 0x00008324:
			return 0xb979854d;
		case 0x00008328:
			return 0x678b8b03;
		case 0x0000832c:
			return 0x49cc44d8;
		case 0x00008330:
			return 0xc4dbe6f7;
		case 0x00008334:
			return 0x67c19fe4;
		case 0x00008338:
			return 0x63c86f3b;
		case 0x0000833c:
			return 0xd52245b8;
		case 0x00008340:
			return 0xbf049358;
		case 0x00008344:
			return 0x02d084a4;
		case 0x00008348:
			return 0x83bae592;
		case 0x0000834c:
			return 0x71222c0c;
		case 0x00008350:
			return 0xdbbdca88;
		case 0x00008354:
			return 0x0c15b208;
		case 0x00008358:
			return 0x771243f4;
		case 0x0000835c:
			return 0xfe772b2e;
		case 0x00008360:
			return 0xed0056ab;
		case 0x00008364:
			return 0x5893af1f;
		case 0x00008368:
			return 0xc6ab118d;
		case 0x0000836c:
			return 0xe6567ede;
		case 0x00008370:
			return 0x9e1b9409;
		case 0x00008374:
			return 0xcea6ae02;
		case 0x00008378:
			return 0x45b48cf3;
		case 0x0000837c:
			return 0x3844bfdc;
		case 0x00008380:
			return 0xccdff21b;
		case 0x00008384:
			return 0x93cac6fb;
		case 0x00008388:
			return 0x0f467970;
		case 0x0000838c:
			return 0x911597ce;
		case 0x00008390:
			return 0x4811307e;
		case 0x00008394:
			return 0x5a14fb70;
		case 0x00008398:
			return 0x1bbb34d8;
		case 0x0000839c:
			return 0x522d62d3;
		case 0x000083a0:
			return 0x0bb2f7bc;
		case 0x000083a4:
			return 0x87599cea;
		case 0x000083a8:
			return 0x062aba18;
		case 0x000083ac:
			return 0xcec42d16;
		case 0x000083b0:
			return 0x5e894730;
		case 0x000083b4:
			return 0xad2a5498;
		case 0x000083b8:
			return 0x575e6135;
		case 0x000083bc:
			return 0x8af1f069;
		case 0x000083c0:
			return 0xe6176593;
		case 0x000083c4:
			return 0xfd640ba2;
		case 0x000083c8:
			return 0x9e433aeb;
		case 0x000083cc:
			return 0x6dd00225;
		case 0x000083d0:
			return 0xf2c66a05;
		case 0x000083d4:
			return 0xd0605da7;
		case 0x000083d8:
			return 0x8bae7fc7;
		case 0x000083dc:
			return 0xab85b7bd;
		case 0x000083e0:
			return 0x31b087ca;
		case 0x000083e4:
			return 0xd914d724;
		case 0x000083e8:
			return 0x48d46648;
		case 0x000083ec:
			return 0x2b7404a7;
		case 0x000083f0:
			return 0x0aed3928;
		case 0x000083f4:
			return 0xd665af40;
		case 0x000083f8:
			return 0x865c83c1;
		case 0x000083fc:
			return 0xf79c946c;
		case 0x00008400:
			return 0x5f277de0;
		case 0x00008404:
			return 0xa42288e8;
		case 0x00008408:
			return 0x35c2ec9c;
		case 0x0000840c:
			return 0x9f0f1724;
		case 0x00008410:
			return 0xa29c87f5;
		case 0x00008414:
			return 0x690fddfd;
		case 0x00008418:
			return 0x31e4c65b;
		case 0x0000841c:
			return 0x36c3298b;
		case 0x00008420:
			return 0x35f578ae;
		case 0x00008424:
			return 0x12d7d530;
		case 0x00008428:
			return 0xb1b219c7;
		case 0x0000842c:
			return 0x7291a55b;
		case 0x00008430:
			return 0x01f93dc6;
		case 0x00008434:
			return 0xb0a749c0;
		case 0x00008438:
			return 0xdb2b819d;
		case 0x0000843c:
			return 0xe2c835ec;
		case 0x00008440:
			return 0x2f3d08cb;
		case 0x00008444:
			return 0x4dc21852;
		case 0x00008448:
			return 0x3b4d4330;
		case 0x0000844c:
			return 0xcd17751f;
		case 0x00008450:
			return 0x24a92a33;
		case 0x00008454:
			return 0x0d5f8420;
		case 0x00008458:
			return 0x52641ec2;
		case 0x0000845c:
			return 0x9cc9d5a3;
		case 0x00008460:
			return 0x5fabb06a;
		case 0x00008464:
			return 0xf4793c26;
		case 0x00008468:
			return 0x8c8ca5ab;
		case 0x0000846c:
			return 0x3c051f2b;
		case 0x00008470:
			return 0xff72caa5;
		case 0x00008474:
			return 0x7b3c2a8d;
		case 0x00008478:
			return 0x7d51eba8;
		case 0x0000847c:
			return 0x03718689;
		case 0x00008480:
			return 0x3b0f38b4;
		case 0x00008484:
			return 0x74395002;
		case 0x00008488:
			return 0x8445b52a;
		case 0x0000848c:
			return 0xdb249d76;
		case 0x00008490:
			return 0xe4f10e94;
		case 0x00008494:
			return 0x8800e516;
		case 0x00008498:
			return 0x1fda4613;
		case 0x0000849c:
			return 0x816df1ec;
		case 0x000084a0:
			return 0x0f67ab15;
		case 0x000084a4:
			return 0x735b9fd3;
		case 0x000084a8:
			return 0x0fb0bde2;
		case 0x000084ac:
			return 0x8697689e;
		case 0x000084b0:
			return 0x22418b6a;
		case 0x000084b4:
			return 0x438b71c1;
		case 0x000084b8:
			return 0x52794054;
		case 0x000084bc:
			return 0xc467c992;
		case 0x000084c0:
			return 0xb25f910d;
		case 0x000084c4:
			return 0xab9e91c0;
		case 0x000084c8:
			return 0xf60ac283;
		case 0x000084cc:
			return 0xb686f614;
		case 0x000084d0:
			return 0xe06864b9;
		case 0x000084d4:
			return 0xd9743e57;
		case 0x000084d8:
			return 0x8e9342a3;
		case 0x000084dc:
			return 0xdefed693;
		case 0x000084e0:
			return 0xc59df5ea;
		case 0x000084e4:
			return 0x1aebc14d;
		case 0x000084e8:
			return 0x1a3df3f2;
		case 0x000084ec:
			return 0x956254b7;
		case 0x000084f0:
			return 0x8c199108;
		case 0x000084f4:
			return 0xfe1bb59f;
		case 0x000084f8:
			return 0x33385694;
		case 0x000084fc:
			return 0x30027c7c;
		case 0x00008500:
			return 0x95173344;
		case 0x00008504:
			return 0x54552200;
		case 0x00008508:
			return 0xcc4c0e21;
		case 0x0000850c:
			return 0xdf7e5d3d;
		case 0x00008510:
			return 0x975e8c56;
		case 0x00008514:
			return 0x4a8c8304;
		case 0x00008518:
			return 0x593565ba;
		case 0x0000851c:
			return 0xe8b85653;
		case 0x00008520:
			return 0x1b3ae4eb;
		case 0x00008524:
			return 0x9bb29a69;
		case 0x00008528:
			return 0xa1eb221f;
		case 0x0000852c:
			return 0xfaf650f0;
		case 0x00008530:
			return 0xe682380a;
		case 0x00008534:
			return 0x88d354e5;
		case 0x00008538:
			return 0xe085ce58;
		case 0x0000853c:
			return 0x3a5e247e;
		case 0x00008540:
			return 0x8c06e473;
		case 0x00008544:
			return 0x7f451319;
		case 0x00008548:
			return 0x6878ceeb;
		case 0x0000854c:
			return 0x6db06066;
		case 0x00008550:
			return 0x12dbc108;
		case 0x00008554:
			return 0xf3cbaf3f;
		case 0x00008558:
			return 0x1805143b;
		case 0x0000855c:
			return 0xedbe028d;
		case 0x00008560:
			return 0x1188ad98;
		case 0x00008564:
			return 0xd455c52d;
		case 0x00008568:
			return 0x32270188;
		case 0x0000856c:
			return 0xf7277fc6;
		case 0x00008570:
			return 0x9e9812c1;
		case 0x00008574:
			return 0x2aee689f;
		case 0x00008578:
			return 0x0dc8ce36;
		case 0x0000857c:
			return 0x2afd23b1;
		case 0x00008580:
			return 0xbf12da33;
		case 0x00008584:
			return 0xc826a1cc;
		case 0x00008588:
			return 0x1e6fd3f8;
		case 0x0000858c:
			return 0x477c3f36;
		case 0x00008590:
			return 0x4da95a72;
		case 0x00008594:
			return 0xa58318ad;
		case 0x00008598:
			return 0x5e6b4524;
		case 0x0000859c:
			return 0x51696b10;
		case 0x000085a0:
			return 0xf9a89d98;
		case 0x000085a4:
			return 0x8fc16de5;
		case 0x000085a8:
			return 0xdb92a0cd;
		case 0x000085ac:
			return 0xf6586581;
		case 0x000085b0:
			return 0x2c111877;
		case 0x000085b4:
			return 0xe52c0f99;
		case 0x000085b8:
			return 0xd0a5a5ea;
		case 0x000085bc:
			return 0x9436b17f;
		case 0x000085c0:
			return 0xad33f2df;
		case 0x000085c4:
			return 0x51b389e3;
		case 0x000085c8:
			return 0xf366e858;
		case 0x000085cc:
			return 0xac35453d;
		case 0x000085d0:
			return 0x908a85e9;
		case 0x000085d4:
			return 0x12709b32;
		case 0x000085d8:
			return 0x628ca908;
		case 0x000085dc:
			return 0x29914af3;
		case 0x000085e0:
			return 0x97e2739a;
		case 0x000085e4:
			return 0x50dfba95;
		case 0x000085e8:
			return 0x9c0209ea;
		case 0x000085ec:
			return 0xb0fdd3aa;
		case 0x000085f0:
			return 0x6dd847d1;
		case 0x000085f4:
			return 0x41c82058;
		case 0x000085f8:
			return 0x17190031;
		case 0x000085fc:
			return 0x353154c9;
		case 0x00008600:
			return 0x64c1b09f;
		case 0x00008604:
			return 0x049a2d96;
		case 0x00008608:
			return 0xf68326d2;
		case 0x0000860c:
			return 0x52f75d48;
		case 0x00008610:
			return 0x1a96c848;
		case 0x00008614:
			return 0xd3dfbf67;
		case 0x00008618:
			return 0x012fb18b;
		case 0x0000861c:
			return 0x2400fa56;
		case 0x00008620:
			return 0xc4cb103c;
		case 0x00008624:
			return 0xa5902fe4;
		case 0x00008628:
			return 0xe581a0df;
		case 0x0000862c:
			return 0x71fdd6c6;
		case 0x00008630:
			return 0xe4c93e75;
		case 0x00008634:
			return 0x2e3a5585;
		case 0x00008638:
			return 0x2b227a18;
		case 0x0000863c:
			return 0xc8c35c82;
		case 0x00008640:
			return 0x332f9a99;
		case 0x00008644:
			return 0x60283c4c;
		case 0x00008648:
			return 0x9b02e530;
		case 0x0000864c:
			return 0x33a1c9ac;
		case 0x00008650:
			return 0x02601af3;
		case 0x00008654:
			return 0xe1e53eee;
		case 0x00008658:
			return 0x77143ae2;
		case 0x0000865c:
			return 0x922149e8;
		case 0x00008660:
			return 0x00f309e4;
		case 0x00008664:
			return 0xd2cd0ea6;
		case 0x00008668:
			return 0xda7ecdc7;
		case 0x0000866c:
			return 0x2eba69fb;
		case 0x00008670:
			return 0x20ef2e7a;
		case 0x00008674:
			return 0xaee13b77;
		case 0x00008678:
			return 0x806ea1ba;
		case 0x0000867c:
			return 0xd4059fdd;
		case 0x00008680:
			return 0x00fd1923;
		case 0x00008684:
			return 0x3c825ba6;
		case 0x00008688:
			return 0xae2b670c;
		case 0x0000868c:
			return 0x4e015ee9;
		case 0x00008690:
			return 0x119f5bc5;
		case 0x00008694:
			return 0xecca412b;
		case 0x00008698:
			return 0x183fce2e;
		case 0x0000869c:
			return 0xfa764e1b;
		case 0x000086a0:
			return 0x71f73711;
		case 0x000086a4:
			return 0xc7023ddf;
		case 0x000086a8:
			return 0x0324a48e;
		case 0x000086ac:
			return 0x0c4bf386;
		case 0x000086b0:
			return 0x9958444a;
		case 0x000086b4:
			return 0xb494722e;
		case 0x000086b8:
			return 0x29cb9b05;
		case 0x000086bc:
			return 0xb69a7278;
		case 0x000086c0:
			return 0xfba740b2;
		case 0x000086c4:
			return 0xdf178ce1;
		case 0x000086c8:
			return 0x12fe8369;
		case 0x000086cc:
			return 0xc88f9e83;
		case 0x000086d0:
			return 0x571a5948;
		case 0x000086d4:
			return 0xc5f6af71;
		case 0x000086d8:
			return 0x632cf3d2;
		case 0x000086dc:
			return 0x67f7523d;
		case 0x000086e0:
			return 0x819f3102;
		case 0x000086e4:
			return 0x9806d5da;
		case 0x000086e8:
			return 0xb4cc04b7;
		case 0x000086ec:
			return 0x2eae9f4e;
		case 0x000086f0:
			return 0xdc6a861c;
		case 0x000086f4:
			return 0x70dc4817;
		case 0x000086f8:
			return 0x52628140;
		case 0x000086fc:
			return 0x76292962;
		case 0x00008700:
			return 0xb496a6a4;
		case 0x00008704:
			return 0xa3cb0647;
		case 0x00008708:
			return 0xabd82bbb;
		case 0x0000870c:
			return 0x15b434ea;
		case 0x00008710:
			return 0xf06f73ad;
		case 0x00008714:
			return 0x5b8b5228;
		case 0x00008718:
			return 0x24e77284;
		case 0x0000871c:
			return 0x4d94585a;
		case 0x00008720:
			return 0xb8e75072;
		case 0x00008724:
			return 0xe7acf360;
		case 0x00008728:
			return 0x92747b05;
		case 0x0000872c:
			return 0x8b7b7861;
		case 0x00008730:
			return 0xb3bd1f76;
		case 0x00008734:
			return 0xa8efd1db;
		case 0x00008738:
			return 0xb0c37182;
		case 0x0000873c:
			return 0xaa814f79;
		case 0x00008740:
			return 0x0f8647c5;
		case 0x00008744:
			return 0x6d716b03;
		case 0x00008748:
			return 0x4e691b91;
		case 0x0000874c:
			return 0x23cf2fdc;
		case 0x00008750:
			return 0x267da616;
		case 0x00008754:
			return 0xc80af1b9;
		case 0x00008758:
			return 0xc01f9fda;
		case 0x0000875c:
			return 0xe0dbe952;
		case 0x00008760:
			return 0x2de40f02;
		case 0x00008764:
			return 0x12905e9d;
		case 0x00008768:
			return 0x3ed7b723;
		case 0x0000876c:
			return 0x4380f814;
		case 0x00008770:
			return 0x3e99171c;
		case 0x00008774:
			return 0xbeca4554;
		case 0x00008778:
			return 0xe1523281;
		case 0x0000877c:
			return 0x08214ed6;
		case 0x00008780:
			return 0x304161f4;
		case 0x00008784:
			return 0x4932db71;
		case 0x00008788:
			return 0xca4e3645;
		case 0x0000878c:
			return 0xc287e11e;
		case 0x00008790:
			return 0x370fdd7d;
		case 0x00008794:
			return 0x83903c4d;
		case 0x00008798:
			return 0x70522f6e;
		case 0x0000879c:
			return 0x08beb58c;
		case 0x000087a0:
			return 0x8ae76e56;
		case 0x000087a4:
			return 0x27480b9b;
		case 0x000087a8:
			return 0x64d9f32c;
		case 0x000087ac:
			return 0x7072c2ce;
		case 0x000087b0:
			return 0xf90b2645;
		case 0x000087b4:
			return 0x08ba0c73;
		case 0x000087b8:
			return 0xc05edc4e;
		case 0x000087bc:
			return 0x6230d154;
		case 0x000087c0:
			return 0x78903c87;
		case 0x000087c4:
			return 0x648286db;
		case 0x000087c8:
			return 0x784d0863;
		case 0x000087cc:
			return 0x9f4b3ad9;
		case 0x000087d0:
			return 0x0e246658;
		case 0x000087d4:
			return 0xf64597b6;
		case 0x000087d8:
			return 0xf99b635f;
		case 0x000087dc:
			return 0x72400ccd;
		case 0x000087e0:
			return 0xc1206b36;
		case 0x000087e4:
			return 0x93d6b71a;
		case 0x000087e8:
			return 0xebe0f6e9;
		case 0x000087ec:
			return 0xf68dfe10;
		case 0x000087f0:
			return 0x2a81bd4a;
		case 0x000087f4:
			return 0x732e9cec;
		case 0x000087f8:
			return 0x17891b5f;
		case 0x000087fc:
			return 0xb5f394b3;
		case 0x00008800:
			return 0xc8ad9317;
		case 0x00008804:
			return 0xf1f6b426;
		case 0x00008808:
			return 0x25b35f52;
		case 0x0000880c:
			return 0x2e1f6c4c;
		case 0x00008810:
			return 0xe1622627;
		case 0x00008814:
			return 0xbd4abbf0;
		case 0x00008818:
			return 0xd865d299;
		case 0x0000881c:
			return 0x285ff3fd;
		case 0x00008820:
			return 0x53647572;
		case 0x00008824:
			return 0x0cf1a356;
		case 0x00008828:
			return 0xad4731fc;
		case 0x0000882c:
			return 0x02b13bd9;
		case 0x00008830:
			return 0x75b7bd59;
		case 0x00008834:
			return 0x533d7ae3;
		case 0x00008838:
			return 0xf89b26b7;
		case 0x0000883c:
			return 0xfd2e54aa;
		case 0x00008840:
			return 0x5e5662bf;
		case 0x00008844:
			return 0xb1acf5df;
		case 0x00008848:
			return 0xb23b2dff;
		case 0x0000884c:
			return 0x70202f44;
		case 0x00008850:
			return 0xea31b054;
		case 0x00008854:
			return 0x3e99017b;
		case 0x00008858:
			return 0x2ed51974;
		case 0x0000885c:
			return 0xa12997ce;
		case 0x00008860:
			return 0xff78f1c6;
		case 0x00008864:
			return 0x790065e9;
		case 0x00008868:
			return 0xf08cf246;
		case 0x0000886c:
			return 0x65a19282;
		case 0x00008870:
			return 0x8b83a9b1;
		case 0x00008874:
			return 0xae6c890d;
		case 0x00008878:
			return 0x042d8846;
		case 0x0000887c:
			return 0x2eeb75b5;
		case 0x00008880:
			return 0xa7a67c50;
		case 0x00008884:
			return 0xa899505f;
		case 0x00008888:
			return 0xbf4bbd03;
		case 0x0000888c:
			return 0xaad5716d;
		case 0x00008890:
			return 0x2aec2f95;
		case 0x00008894:
			return 0xf15eba6a;
		case 0x00008898:
			return 0xb16f4db4;
		case 0x0000889c:
			return 0xc177e346;
		case 0x000088a0:
			return 0x44f82688;
		case 0x000088a4:
			return 0xbd8a8d7b;
		case 0x000088a8:
			return 0x5607d41a;
		case 0x000088ac:
			return 0x166fedf3;
		case 0x000088b0:
			return 0x601d3c64;
		case 0x000088b4:
			return 0x607c87bf;
		case 0x000088b8:
			return 0xa6cd8e07;
		case 0x000088bc:
			return 0x2c6c694f;
		case 0x000088c0:
			return 0xf237bb95;
		case 0x000088c4:
			return 0x7eb49781;
		case 0x000088c8:
			return 0x375cc055;
		case 0x000088cc:
			return 0x8aad85e5;
		case 0x000088d0:
			return 0x4141d6b1;
		case 0x000088d4:
			return 0xf8636168;
		case 0x000088d8:
			return 0x49285222;
		case 0x000088dc:
			return 0x92837ae8;
		case 0x000088e0:
			return 0xb4049d07;
		case 0x000088e4:
			return 0xdd297da6;
		case 0x000088e8:
			return 0xdf4c0dfb;
		case 0x000088ec:
			return 0x8da68358;
		case 0x000088f0:
			return 0xe1d1f2be;
		case 0x000088f4:
			return 0x25dc2cda;
		case 0x000088f8:
			return 0x0e6dc6d5;
		case 0x000088fc:
			return 0xf9f0af36;
		case 0x00008900:
			return 0x0ba08ba1;
		case 0x00008904:
			return 0x2da3d9aa;
		case 0x00008908:
			return 0x1220b1e2;
		case 0x0000890c:
			return 0x7801e729;
		case 0x00008910:
			return 0x5afd4548;
		case 0x00008914:
			return 0xf4c01767;
		case 0x00008918:
			return 0xaa0bd498;
		case 0x0000891c:
			return 0x07bf81d8;
		case 0x00008920:
			return 0x1ce2f4f7;
		case 0x00008924:
			return 0xc4476df0;
		case 0x00008928:
			return 0xc23d373d;
		case 0x0000892c:
			return 0xc8d20475;
		case 0x00008930:
			return 0xa81c1893;
		case 0x00008934:
			return 0x69c0752a;
		case 0x00008938:
			return 0xb886b23c;
		case 0x0000893c:
			return 0x4819c9e3;
		case 0x00008940:
			return 0x8d7ee97b;
		case 0x00008944:
			return 0x2b36131f;
		case 0x00008948:
			return 0xbef4ab00;
		case 0x0000894c:
			return 0x00bcee11;
		case 0x00008950:
			return 0x7f1d6bcc;
		case 0x00008954:
			return 0xcdc9d241;
		case 0x00008958:
			return 0x3ec271d3;
		case 0x0000895c:
			return 0x48b18b1b;
		case 0x00008960:
			return 0x72bfbfe7;
		case 0x00008964:
			return 0x3551f6ec;
		case 0x00008968:
			return 0x0abdc10c;
		case 0x0000896c:
			return 0xb75c22d1;
		case 0x00008970:
			return 0x77e78f99;
		case 0x00008974:
			return 0x3980f615;
		case 0x00008978:
			return 0xa91ef933;
		case 0x0000897c:
			return 0x2c4328a8;
		case 0x00008980:
			return 0x76496416;
		case 0x00008984:
			return 0xb4891beb;
		case 0x00008988:
			return 0x8a77df88;
		case 0x0000898c:
			return 0x4ccef54a;
		case 0x00008990:
			return 0x6f0ce360;
		case 0x00008994:
			return 0xdb7d7c41;
		case 0x00008998:
			return 0xb6b0b212;
		case 0x0000899c:
			return 0x8d2b4320;
		case 0x000089a0:
			return 0x91e8f211;
		case 0x000089a4:
			return 0x59927cbd;
		case 0x000089a8:
			return 0xaa95e342;
		case 0x000089ac:
			return 0x9c3faaf1;
		case 0x000089b0:
			return 0x75a1808d;
		case 0x000089b4:
			return 0xb40c67cb;
		case 0x000089b8:
			return 0x1e7fd7b5;
		case 0x000089bc:
			return 0x617b9d17;
		case 0x000089c0:
			return 0x9bf2230c;
		case 0x000089c4:
			return 0xa299bca3;
		case 0x000089c8:
			return 0xfaa2b22c;
		case 0x000089cc:
			return 0x38348905;
		case 0x000089d0:
			return 0x1b425248;
		case 0x000089d4:
			return 0x3bf65d5f;
		case 0x000089d8:
			return 0x0513f263;
		case 0x000089dc:
			return 0x266a253a;
		case 0x000089e0:
			return 0x6aa3b761;
		case 0x000089e4:
			return 0xdece84a5;
		case 0x000089e8:
			return 0xc7f0ddbe;
		case 0x000089ec:
			return 0xb6a742e8;
		case 0x000089f0:
			return 0xa9c995ad;
		case 0x000089f4:
			return 0x839dc1ee;
		case 0x000089f8:
			return 0x496df294;
		case 0x000089fc:
			return 0xf620f222;
		case 0x00008a00:
			return 0x98873a90;
		case 0x00008a04:
			return 0x50243587;
		case 0x00008a08:
			return 0x5b3c61d4;
		case 0x00008a0c:
			return 0x024a26ef;
		case 0x00008a10:
			return 0xdab02914;
		case 0x00008a14:
			return 0xf8e72238;
		case 0x00008a18:
			return 0xee97e907;
		case 0x00008a1c:
			return 0xee734204;
		case 0x00008a20:
			return 0xa5e15dcf;
		case 0x00008a24:
			return 0x22a30f70;
		case 0x00008a28:
			return 0x8bc839da;
		case 0x00008a2c:
			return 0x2405c949;
		case 0x00008a30:
			return 0x132575e8;
		case 0x00008a34:
			return 0xe5f3a281;
		case 0x00008a38:
			return 0xc3845c23;
		case 0x00008a3c:
			return 0x0dbcff5e;
		case 0x00008a40:
			return 0xa74de75f;
		case 0x00008a44:
			return 0xbba6a384;
		case 0x00008a48:
			return 0x5cba1f2e;
		case 0x00008a4c:
			return 0xd246bc92;
		case 0x00008a50:
			return 0x6bb90b5c;
		case 0x00008a54:
			return 0xd477ab2a;
		case 0x00008a58:
			return 0x6b6c06ee;
		case 0x00008a5c:
			return 0x062c8180;
		case 0x00008a60:
			return 0x5d078efe;
		case 0x00008a64:
			return 0xcc791940;
		case 0x00008a68:
			return 0x759d7169;
		case 0x00008a6c:
			return 0x5f3c9c0c;
		case 0x00008a70:
			return 0x64e9ef6c;
		case 0x00008a74:
			return 0x0e9178df;
		case 0x00008a78:
			return 0x33fd66eb;
		case 0x00008a7c:
			return 0xfac6141e;
		case 0x00008a80:
			return 0xcdd5ca5f;
		case 0x00008a84:
			return 0x7cf64f0d;
		case 0x00008a88:
			return 0xe4cf4e21;
		case 0x00008a8c:
			return 0x180ff094;
		case 0x00008a90:
			return 0x7628a075;
		case 0x00008a94:
			return 0xb6da06f6;
		case 0x00008a98:
			return 0x4afaf875;
		case 0x00008a9c:
			return 0x6072004b;
		case 0x00008aa0:
			return 0xfb1c8851;
		case 0x00008aa4:
			return 0xb5b702d0;
		case 0x00008aa8:
			return 0x2a09ac73;
		case 0x00008aac:
			return 0x8d1f6727;
		case 0x00008ab0:
			return 0xebb5a2ec;
		case 0x00008ab4:
			return 0xcfe51544;
		case 0x00008ab8:
			return 0x1a3b1fd0;
		case 0x00008abc:
			return 0x5fc2ec18;
		case 0x00008ac0:
			return 0x2b241112;
		case 0x00008ac4:
			return 0x4c9f2b6b;
		case 0x00008ac8:
			return 0xdf7a4bac;
		case 0x00008acc:
			return 0xcfc9caef;
		case 0x00008ad0:
			return 0x2d8a1ac7;
		case 0x00008ad4:
			return 0x337a2b58;
		case 0x00008ad8:
			return 0xaea79e56;
		case 0x00008adc:
			return 0x135459e5;
		case 0x00008ae0:
			return 0x61ce7393;
		case 0x00008ae4:
			return 0x823fb274;
		case 0x00008ae8:
			return 0x3f745c63;
		case 0x00008aec:
			return 0xf0d7a74b;
		case 0x00008af0:
			return 0x0d0a4e05;
		case 0x00008af4:
			return 0x15f9fb30;
		case 0x00008af8:
			return 0x424b23d3;
		case 0x00008afc:
			return 0x2d09655d;
		case 0x00008b00:
			return 0x462550b4;
		case 0x00008b04:
			return 0x7a5bf49e;
		case 0x00008b08:
			return 0x819ef870;
		case 0x00008b0c:
			return 0x322a768c;
		case 0x00008b10:
			return 0xb01cfed1;
		case 0x00008b14:
			return 0x1f727a9e;
		case 0x00008b18:
			return 0x8b1989fe;
		case 0x00008b1c:
			return 0x90e7d10a;
		case 0x00008b20:
			return 0xf238662d;
		case 0x00008b24:
			return 0xa195d390;
		case 0x00008b28:
			return 0xa75c7461;
		case 0x00008b2c:
			return 0x69f78aee;
		case 0x00008b30:
			return 0x5f1eb0d2;
		case 0x00008b34:
			return 0x8192256f;
		case 0x00008b38:
			return 0x8f9db0bb;
		case 0x00008b3c:
			return 0xb3b0aa36;
		case 0x00008b40:
			return 0x16e49d9e;
		case 0x00008b44:
			return 0x1d1a7578;
		case 0x00008b48:
			return 0x2b5ef630;
		case 0x00008b4c:
			return 0x23a9b25c;
		case 0x00008b50:
			return 0x97482a7c;
		case 0x00008b54:
			return 0xa1c7fb90;
		case 0x00008b58:
			return 0x0ec52b91;
		case 0x00008b5c:
			return 0xea8bb503;
		case 0x00008b60:
			return 0xc69f313d;
		case 0x00008b64:
			return 0x709476af;
		case 0x00008b68:
			return 0xc1588fcc;
		case 0x00008b6c:
			return 0xfc8211f0;
		case 0x00008b70:
			return 0x17f1f602;
		case 0x00008b74:
			return 0xf2163a72;
		case 0x00008b78:
			return 0xda8cd958;
		case 0x00008b7c:
			return 0x67a3000e;
		case 0x00008b80:
			return 0x98582441;
		case 0x00008b84:
			return 0xd0b8cf6d;
		case 0x00008b88:
			return 0x1cbffcb6;
		case 0x00008b8c:
			return 0x8e915b3a;
		case 0x00008b90:
			return 0x6ef11735;
		case 0x00008b94:
			return 0x392bbc10;
		case 0x00008b98:
			return 0xd119423d;
		case 0x00008b9c:
			return 0x979ccf11;
		case 0x00008ba0:
			return 0xf2fb67cd;
		case 0x00008ba4:
			return 0xddbf1ef1;
		case 0x00008ba8:
			return 0xc7022d6d;
		case 0x00008bac:
			return 0x3e9d2ebd;
		case 0x00008bb0:
			return 0xd5b120ef;
		case 0x00008bb4:
			return 0xbd322551;
		case 0x00008bb8:
			return 0xf606f2c3;
		case 0x00008bbc:
			return 0x1ce58e52;
		case 0x00008bc0:
			return 0xc38ed9e6;
		case 0x00008bc4:
			return 0xf013fc3d;
		case 0x00008bc8:
			return 0x9e1c34c7;
		case 0x00008bcc:
			return 0x19e01e43;
		case 0x00008bd0:
			return 0x9132f594;
		case 0x00008bd4:
			return 0xa4b137b3;
		case 0x00008bd8:
			return 0xb650f918;
		case 0x00008bdc:
			return 0x0c75a09c;
		case 0x00008be0:
			return 0xdfc4f46f;
		case 0x00008be4:
			return 0x2f33d151;
		case 0x00008be8:
			return 0x2419011e;
		case 0x00008bec:
			return 0x59d78378;
		case 0x00008bf0:
			return 0x62500db5;
		case 0x00008bf4:
			return 0xf7fd1bb8;
		case 0x00008bf8:
			return 0x16d230a1;
		case 0x00008bfc:
			return 0x74967ec5;
		case 0x00008c00:
			return 0x779014a2;
		case 0x00008c04:
			return 0x7ed11e8c;
		case 0x00008c08:
			return 0x91844602;
		case 0x00008c0c:
			return 0x5c8a90c7;
		case 0x00008c10:
			return 0x5b6446ca;
		case 0x00008c14:
			return 0x8999c432;
		case 0x00008c18:
			return 0x294ca32f;
		case 0x00008c1c:
			return 0xc05cfa58;
		case 0x00008c20:
			return 0x33febf31;
		case 0x00008c24:
			return 0x48c9f29c;
		case 0x00008c28:
			return 0xf6d72f05;
		case 0x00008c2c:
			return 0x6e940b32;
		case 0x00008c30:
			return 0x3c28c4ba;
		case 0x00008c34:
			return 0xa3bc3d7b;
		case 0x00008c38:
			return 0x718f3ac0;
		case 0x00008c3c:
			return 0x8b2e3d8c;
		case 0x00008c40:
			return 0x5b47766d;
		case 0x00008c44:
			return 0xb5c3779c;
		case 0x00008c48:
			return 0x39bfc3c9;
		case 0x00008c4c:
			return 0x0f2f161b;
		case 0x00008c50:
			return 0x962693b7;
		case 0x00008c54:
			return 0xf8a8f0c0;
		case 0x00008c58:
			return 0x22fc5800;
		case 0x00008c5c:
			return 0x978b3b36;
		case 0x00008c60:
			return 0xf7c79fc9;
		case 0x00008c64:
			return 0x70bdd416;
		case 0x00008c68:
			return 0x5d7426f3;
		case 0x00008c6c:
			return 0xe1439a44;
		case 0x00008c70:
			return 0x58af68ac;
		case 0x00008c74:
			return 0xa34fb9b2;
		case 0x00008c78:
			return 0x7e549147;
		case 0x00008c7c:
			return 0x4f32ab99;
		case 0x00008c80:
			return 0xfcad24ec;
		case 0x00008c84:
			return 0xf7fd4407;
		case 0x00008c88:
			return 0xcba60471;
		case 0x00008c8c:
			return 0x4b4d42b2;
		case 0x00008c90:
			return 0xabd24e16;
		case 0x00008c94:
			return 0xfd8f73c5;
		case 0x00008c98:
			return 0xc821e101;
		case 0x00008c9c:
			return 0x6c7c0c5c;
		case 0x00008ca0:
			return 0x519098a5;
		case 0x00008ca4:
			return 0x223c1e7f;
		case 0x00008ca8:
			return 0xf63e980c;
		case 0x00008cac:
			return 0xd3d04e73;
		case 0x00008cb0:
			return 0x2d4e020e;
		case 0x00008cb4:
			return 0xa8b85ea5;
		case 0x00008cb8:
			return 0xe9e5398a;
		case 0x00008cbc:
			return 0x53a46e3c;
		case 0x00008cc0:
			return 0xf487b9b6;
		case 0x00008cc4:
			return 0xe9dd3de8;
		case 0x00008cc8:
			return 0x874db4d9;
		case 0x00008ccc:
			return 0xe9ad0f84;
		case 0x00008cd0:
			return 0x13242fce;
		case 0x00008cd4:
			return 0x5c8eadfc;
		case 0x00008cd8:
			return 0xac929c7f;
		case 0x00008cdc:
			return 0x060f4f37;
		case 0x00008ce0:
			return 0xf572a788;
		case 0x00008ce4:
			return 0x117da07e;
		case 0x00008ce8:
			return 0x1f7f5bc4;
		case 0x00008cec:
			return 0x80ffe79e;
		case 0x00008cf0:
			return 0xa0338bd3;
		case 0x00008cf4:
			return 0x46132c27;
		case 0x00008cf8:
			return 0xe3fe3cd6;
		case 0x00008cfc:
			return 0xfb8f4be6;
		case 0x00008d00:
			return 0x731c5662;
		case 0x00008d04:
			return 0x76d941c1;
		case 0x00008d08:
			return 0xe6c057f5;
		case 0x00008d0c:
			return 0xbecbad8c;
		case 0x00008d10:
			return 0xac876c01;
		case 0x00008d14:
			return 0xb41675f5;
		case 0x00008d18:
			return 0x09e9519f;
		case 0x00008d1c:
			return 0x370b3c2a;
		case 0x00008d20:
			return 0x54a75a4c;
		case 0x00008d24:
			return 0xcd1cab30;
		case 0x00008d28:
			return 0xd3d8ed25;
		case 0x00008d2c:
			return 0xc5874f39;
		case 0x00008d30:
			return 0x446192ee;
		case 0x00008d34:
			return 0x09476c46;
		case 0x00008d38:
			return 0x47bd8c6b;
		case 0x00008d3c:
			return 0x23f1cc18;
		case 0x00008d40:
			return 0xc653651f;
		case 0x00008d44:
			return 0x1917c65c;
		case 0x00008d48:
			return 0xd1339de1;
		case 0x00008d4c:
			return 0x6666b8a6;
		case 0x00008d50:
			return 0x583fde04;
		case 0x00008d54:
			return 0x1392a2f9;
		case 0x00008d58:
			return 0xc3136950;
		case 0x00008d5c:
			return 0x1bbbf6f6;
		case 0x00008d60:
			return 0x14a1f7cf;
		case 0x00008d64:
			return 0xf2bde85b;
		case 0x00008d68:
			return 0x980aae08;
		case 0x00008d6c:
			return 0xe0d76c52;
		case 0x00008d70:
			return 0x677ade5d;
		case 0x00008d74:
			return 0x0a4e26c0;
		case 0x00008d78:
			return 0xcf89ba03;
		case 0x00008d7c:
			return 0x30d2c86c;
		case 0x00008d80:
			return 0x987aa788;
		case 0x00008d84:
			return 0x70867eb5;
		case 0x00008d88:
			return 0xe39d72ed;
		case 0x00008d8c:
			return 0x3f13683c;
		case 0x00008d90:
			return 0x27c0dcee;
		case 0x00008d94:
			return 0xc2fc00f4;
		case 0x00008d98:
			return 0xc5bda2df;
		case 0x00008d9c:
			return 0x849b17ed;
		case 0x00008da0:
			return 0x526bf07a;
		case 0x00008da4:
			return 0x70682347;
		case 0x00008da8:
			return 0x157469c9;
		case 0x00008dac:
			return 0x6c58b1f1;
		case 0x00008db0:
			return 0x289084da;
		case 0x00008db4:
			return 0xf022659a;
		case 0x00008db8:
			return 0xef6a46c8;
		case 0x00008dbc:
			return 0xeaa2419f;
		case 0x00008dc0:
			return 0xd88fcdf4;
		case 0x00008dc4:
			return 0x467f4fd7;
		case 0x00008dc8:
			return 0x08ed9157;
		case 0x00008dcc:
			return 0x376a9a65;
		case 0x00008dd0:
			return 0x57dadac1;
		case 0x00008dd4:
			return 0xd1ad4776;
		case 0x00008dd8:
			return 0x7fc97a2a;
		case 0x00008ddc:
			return 0xa105d00e;
		case 0x00008de0:
			return 0x23ed6e9f;
		case 0x00008de4:
			return 0x6931979c;
		case 0x00008de8:
			return 0x96c5ad0c;
		case 0x00008dec:
			return 0xe6c97009;
		case 0x00008df0:
			return 0x7f800da0;
		case 0x00008df4:
			return 0x6c7d7062;
		case 0x00008df8:
			return 0xe9282fed;
		case 0x00008dfc:
			return 0x4b992932;
		case 0x00008e00:
			return 0xd55e2adb;
		case 0x00008e04:
			return 0xf770259b;
		case 0x00008e08:
			return 0x5f712e6d;
		case 0x00008e0c:
			return 0x30ac3de1;
		case 0x00008e10:
			return 0x9f4ab2dd;
		case 0x00008e14:
			return 0x8b38cc9d;
		case 0x00008e18:
			return 0x88439855;
		case 0x00008e1c:
			return 0x97eea5ef;
		case 0x00008e20:
			return 0x3df721bb;
		case 0x00008e24:
			return 0x26643ff0;
		case 0x00008e28:
			return 0x0201a879;
		case 0x00008e2c:
			return 0xa4b9d109;
		case 0x00008e30:
			return 0xfba78201;
		case 0x00008e34:
			return 0xd4b45d55;
		case 0x00008e38:
			return 0x73ebf260;
		case 0x00008e3c:
			return 0x1b45463d;
		case 0x00008e40:
			return 0xa5bc9aff;
		case 0x00008e44:
			return 0x82abf8c5;
		case 0x00008e48:
			return 0xe9d7868a;
		case 0x00008e4c:
			return 0xfc091879;
		case 0x00008e50:
			return 0xcf048c7c;
		case 0x00008e54:
			return 0xafa75c4f;
		case 0x00008e58:
			return 0x12c8fee5;
		case 0x00008e5c:
			return 0xfd914809;
		case 0x00008e60:
			return 0x0ecc8bb7;
		case 0x00008e64:
			return 0x8787cdb6;
		case 0x00008e68:
			return 0x76cff9f3;
		case 0x00008e6c:
			return 0xa05b9bae;
		case 0x00008e70:
			return 0xb1077a4f;
		case 0x00008e74:
			return 0xe586dfca;
		case 0x00008e78:
			return 0xa1d2d11f;
		case 0x00008e7c:
			return 0x66c54dca;
		case 0x00008e80:
			return 0x7362a966;
		case 0x00008e84:
			return 0xb4984d22;
		case 0x00008e88:
			return 0xc5533e6f;
		case 0x00008e8c:
			return 0x9d5dcd09;
		case 0x00008e90:
			return 0x16d43484;
		case 0x00008e94:
			return 0x3dadca3c;
		case 0x00008e98:
			return 0x59fc2d97;
		case 0x00008e9c:
			return 0x714e618e;
		case 0x00008ea0:
			return 0x8260f243;
		case 0x00008ea4:
			return 0x8b5e1d9d;
		case 0x00008ea8:
			return 0xdd1e398a;
		case 0x00008eac:
			return 0xdf39a8e9;
		case 0x00008eb0:
			return 0x2c154ae2;
		case 0x00008eb4:
			return 0x150ddcbf;
		case 0x00008eb8:
			return 0x5e696a7a;
		case 0x00008ebc:
			return 0x5a5e352c;
		case 0x00008ec0:
			return 0xf89b39d8;
		case 0x00008ec4:
			return 0x417f41bd;
		case 0x00008ec8:
			return 0x86e9b7db;
		case 0x00008ecc:
			return 0xf9a4d0f5;
		case 0x00008ed0:
			return 0x82268feb;
		case 0x00008ed4:
			return 0x82f44128;
		case 0x00008ed8:
			return 0x29b48b25;
		case 0x00008edc:
			return 0xa2870be1;
		case 0x00008ee0:
			return 0x55a7839f;
		case 0x00008ee4:
			return 0x5eee4541;
		case 0x00008ee8:
			return 0xf9d8fc69;
		case 0x00008eec:
			return 0xedc1808e;
		case 0x00008ef0:
			return 0x20829959;
		case 0x00008ef4:
			return 0x7cfad3a4;
		case 0x00008ef8:
			return 0x54853f53;
		case 0x00008efc:
			return 0xfbc5ab1c;
		case 0x00008f00:
			return 0x24485f15;
		case 0x00008f04:
			return 0x2f8a2099;
		case 0x00008f08:
			return 0x300c174a;
		case 0x00008f0c:
			return 0xa6aa96bf;
		case 0x00008f10:
			return 0x159825d3;
		case 0x00008f14:
			return 0x65438eec;
		case 0x00008f18:
			return 0xd290e3e8;
		case 0x00008f1c:
			return 0x20503ae1;
		case 0x00008f20:
			return 0xfdda5ad8;
		case 0x00008f24:
			return 0x2d50b1ba;
		case 0x00008f28:
			return 0xc0c7c345;
		case 0x00008f2c:
			return 0x6eeade57;
		case 0x00008f30:
			return 0x92ff17f9;
		case 0x00008f34:
			return 0x04d2a08e;
		case 0x00008f38:
			return 0x67e61092;
		case 0x00008f3c:
			return 0x537a470b;
		case 0x00008f40:
			return 0x2a2ab44c;
		case 0x00008f44:
			return 0x716c0890;
		case 0x00008f48:
			return 0x6f093d86;
		case 0x00008f4c:
			return 0xc661b861;
		case 0x00008f50:
			return 0xe8127c97;
		case 0x00008f54:
			return 0x9005074c;
		case 0x00008f58:
			return 0x4a69d964;
		case 0x00008f5c:
			return 0x5306d37c;
		case 0x00008f60:
			return 0xf80a2b12;
		case 0x00008f64:
			return 0x42090668;
		case 0x00008f68:
			return 0xa2a3a728;
		case 0x00008f6c:
			return 0xeb9bb6b2;
		case 0x00008f70:
			return 0x37958845;
		case 0x00008f74:
			return 0x291491e2;
		case 0x00008f78:
			return 0x8abfc197;
		case 0x00008f7c:
			return 0xaf41d1dc;
		case 0x00008f80:
			return 0xde79fa1f;
		case 0x00008f84:
			return 0xb68351ad;
		case 0x00008f88:
			return 0xc725d3d0;
		case 0x00008f8c:
			return 0xae12333a;
		case 0x00008f90:
			return 0xe887dec9;
		case 0x00008f94:
			return 0x16f8ce86;
		case 0x00008f98:
			return 0x5b79d371;
		case 0x00008f9c:
			return 0x8f282bcd;
		case 0x00008fa0:
			return 0x52d95ce3;
		case 0x00008fa4:
			return 0x2a514b2e;
		case 0x00008fa8:
			return 0x26380ae5;
		case 0x00008fac:
			return 0x8154ee4b;
		case 0x00008fb0:
			return 0xbcb09ee2;
		case 0x00008fb4:
			return 0x0482729c;
		case 0x00008fb8:
			return 0x9d665154;
		case 0x00008fbc:
			return 0x71a65a6f;
		case 0x00008fc0:
			return 0xfde632ae;
		case 0x00008fc4:
			return 0x8732ae5b;
		case 0x00008fc8:
			return 0xcd1c685c;
		case 0x00008fcc:
			return 0x11a69e14;
		case 0x00008fd0:
			return 0xaa79ec0f;
		case 0x00008fd4:
			return 0x1d8b4d00;
		case 0x00008fd8:
			return 0x2f49b825;
		case 0x00008fdc:
			return 0x5ce9ac89;
		case 0x00008fe0:
			return 0x718c03c4;
		case 0x00008fe4:
			return 0x46837ed1;
		case 0x00008fe8:
			return 0xc339120d;
		case 0x00008fec:
			return 0x38af82c0;
		case 0x00008ff0:
			return 0xc7a60982;
		case 0x00008ff4:
			return 0x7d5aaa4f;
		case 0x00008ff8:
			return 0x40e1a0d5;
		case 0x00008ffc:
			return 0xc10fad10;
		case 0x00009000:
			return 0x081fdfa7;
		case 0x00009004:
			return 0x191cd5f3;
		case 0x00009008:
			return 0xfff86d4f;
		case 0x0000900c:
			return 0x343f930a;
		case 0x00009010:
			return 0xf88e2fb6;
		case 0x00009014:
			return 0xcdcb56a8;
		case 0x00009018:
			return 0xac23a730;
		case 0x0000901c:
			return 0xe4c06469;
		case 0x00009020:
			return 0x319871b1;
		case 0x00009024:
			return 0x4907d27f;
		case 0x00009028:
			return 0x38de146f;
		case 0x0000902c:
			return 0xa9ef5ec1;
		case 0x00009030:
			return 0x59a37ba3;
		case 0x00009034:
			return 0x495aea35;
		case 0x00009038:
			return 0xae35efe1;
		case 0x0000903c:
			return 0x89207bf5;
		case 0x00009040:
			return 0x60425cc4;
		case 0x00009044:
			return 0x4a5001b2;
		case 0x00009048:
			return 0x44423c7e;
		case 0x0000904c:
			return 0x5ead8247;
		case 0x00009050:
			return 0x296b60bc;
		case 0x00009054:
			return 0x1832469f;
		case 0x00009058:
			return 0x57f4c1ef;
		case 0x0000905c:
			return 0x5366c3bb;
		case 0x00009060:
			return 0xbeea2036;
		case 0x00009064:
			return 0x3d94e277;
		case 0x00009068:
			return 0xa76b0ad0;
		case 0x0000906c:
			return 0x2bff36cb;
		case 0x00009070:
			return 0xcfba9945;
		case 0x00009074:
			return 0x9935c5b8;
		case 0x00009078:
			return 0xc313819a;
		case 0x0000907c:
			return 0x2ca02fae;
		case 0x00009080:
			return 0x6ee4ce8c;
		case 0x00009084:
			return 0x2eaf30c5;
		case 0x00009088:
			return 0x43c40060;
		case 0x0000908c:
			return 0x3bb0dd7a;
		case 0x00009090:
			return 0xdce732c2;
		case 0x00009094:
			return 0x6de55142;
		case 0x00009098:
			return 0x38272692;
		case 0x0000909c:
			return 0x54558071;
		case 0x000090a0:
			return 0x3d6a9d16;
		case 0x000090a4:
			return 0xb42c826b;
		case 0x000090a8:
			return 0xfb28eaa4;
		case 0x000090ac:
			return 0x6a0eacb2;
		case 0x000090b0:
			return 0x6208ba21;
		case 0x000090b4:
			return 0x2223c004;
		case 0x000090b8:
			return 0xbeb7fed8;
		case 0x000090bc:
			return 0x787ec804;
		case 0x000090c0:
			return 0x10f92494;
		case 0x000090c4:
			return 0x447e933a;
		case 0x000090c8:
			return 0xae523bd7;
		case 0x000090cc:
			return 0x623d511a;
		case 0x000090d0:
			return 0x3e803ad2;
		case 0x000090d4:
			return 0xfb904182;
		case 0x000090d8:
			return 0x6954c7bb;
		case 0x000090dc:
			return 0xd8c7ac77;
		case 0x000090e0:
			return 0xa2e22525;
		case 0x000090e4:
			return 0xaba48b3c;
		case 0x000090e8:
			return 0xd8bab007;
		case 0x000090ec:
			return 0xd3fd5ac6;
		case 0x000090f0:
			return 0xf730e9a6;
		case 0x000090f4:
			return 0x38da3582;
		case 0x000090f8:
			return 0xb0a6f50f;
		case 0x000090fc:
			return 0x204532fd;
		case 0x00009100:
			return 0x8c4474fa;
		case 0x00009104:
			return 0xba5c13a6;
		case 0x00009108:
			return 0x05543964;
		case 0x0000910c:
			return 0x3d6ac1dd;
		case 0x00009110:
			return 0xe5c60657;
		case 0x00009114:
			return 0xf304799c;
		case 0x00009118:
			return 0x800f63ba;
		case 0x0000911c:
			return 0x72a1bd5e;
		case 0x00009120:
			return 0xd27d74b5;
		case 0x00009124:
			return 0x7d08b794;
		case 0x00009128:
			return 0xc5e3ac7f;
		case 0x0000912c:
			return 0x00326e96;
		case 0x00009130:
			return 0x9ff52770;
		case 0x00009134:
			return 0x1fe438cf;
		case 0x00009138:
			return 0x4a4ab55f;
		case 0x0000913c:
			return 0xd22db3b2;
		case 0x00009140:
			return 0xa9d4f4d5;
		case 0x00009144:
			return 0x00517b0c;
		case 0x00009148:
			return 0x1721c78e;
		case 0x0000914c:
			return 0x0ac4f6a5;
		case 0x00009150:
			return 0x56f03e83;
		case 0x00009154:
			return 0x75ea7f94;
		case 0x00009158:
			return 0x0c836220;
		case 0x0000915c:
			return 0x1298449e;
		case 0x00009160:
			return 0x8aa6e098;
		case 0x00009164:
			return 0x6d255727;
		case 0x00009168:
			return 0x7714bfbb;
		case 0x0000916c:
			return 0x0453ff1e;
		case 0x00009170:
			return 0x656ccd7a;
		case 0x00009174:
			return 0xb0ea6ed1;
		case 0x00009178:
			return 0x091d108e;
		case 0x0000917c:
			return 0x23891c06;
		case 0x00009180:
			return 0x3a0c8d48;
		case 0x00009184:
			return 0x2764566d;
		case 0x00009188:
			return 0x6fc44ffb;
		case 0x0000918c:
			return 0x4713bc74;
		case 0x00009190:
			return 0x5b585864;
		case 0x00009194:
			return 0xa3167854;
		case 0x00009198:
			return 0x69a994b5;
		case 0x0000919c:
			return 0x989828fe;
		case 0x000091a0:
			return 0xb65b7f26;
		case 0x000091a4:
			return 0x8a09c7bf;
		case 0x000091a8:
			return 0x1269c186;
		case 0x000091ac:
			return 0xdb93494f;
		case 0x000091b0:
			return 0x8de4c8cc;
		case 0x000091b4:
			return 0x7e42c80b;
		case 0x000091b8:
			return 0x7182f04e;
		case 0x000091bc:
			return 0xeafe293e;
		case 0x000091c0:
			return 0x4682ad0d;
		case 0x000091c4:
			return 0x713b8774;
		case 0x000091c8:
			return 0x4a25f548;
		case 0x000091cc:
			return 0xb2bdc33f;
		case 0x000091d0:
			return 0x3ccc5490;
		case 0x000091d4:
			return 0x1808792f;
		case 0x000091d8:
			return 0x323af218;
		case 0x000091dc:
			return 0xca21b472;
		case 0x000091e0:
			return 0xeac26f79;
		case 0x000091e4:
			return 0x135a305c;
		case 0x000091e8:
			return 0x399b02ed;
		case 0x000091ec:
			return 0x0698d07b;
		case 0x000091f0:
			return 0xea5884fd;
		case 0x000091f4:
			return 0x6e4add4c;
		case 0x000091f8:
			return 0x6da1f201;
		case 0x000091fc:
			return 0xbefb2dee;
		case 0x00009200:
			return 0x9f933450;
		case 0x00009204:
			return 0xe9054d56;
		case 0x00009208:
			return 0x338cec78;
		case 0x0000920c:
			return 0xe2c926f5;
		case 0x00009210:
			return 0x8ed94d52;
		case 0x00009214:
			return 0xca7333c3;
		case 0x00009218:
			return 0xe92c8a33;
		case 0x0000921c:
			return 0x27c2083a;
		case 0x00009220:
			return 0x53d973ab;
		case 0x00009224:
			return 0xe11b7487;
		case 0x00009228:
			return 0xff2ea9f1;
		case 0x0000922c:
			return 0xe279944d;
		case 0x00009230:
			return 0x0244aa89;
		case 0x00009234:
			return 0x4210308c;
		case 0x00009238:
			return 0x81736693;
		case 0x0000923c:
			return 0xcb1f2fbf;
		case 0x00009240:
			return 0x756b7534;
		case 0x00009244:
			return 0x32135b59;
		case 0x00009248:
			return 0x40f92c61;
		case 0x0000924c:
			return 0xe91f50b2;
		case 0x00009250:
			return 0x9aef99da;
		case 0x00009254:
			return 0x6a4a1827;
		case 0x00009258:
			return 0xcab37cbd;
		case 0x0000925c:
			return 0x8661757f;
		case 0x00009260:
			return 0xcf652485;
		case 0x00009264:
			return 0xa7342299;
		case 0x00009268:
			return 0x15095f36;
		case 0x0000926c:
			return 0x3f8117ad;
		case 0x00009270:
			return 0x385998de;
		case 0x00009274:
			return 0x337a6bbf;
		case 0x00009278:
			return 0xf8e357b1;
		case 0x0000927c:
			return 0xe044a778;
		case 0x00009280:
			return 0xa841a528;
		case 0x00009284:
			return 0xbcd3ac35;
		case 0x00009288:
			return 0x06ffcb5c;
		case 0x0000928c:
			return 0x8cdface0;
		case 0x00009290:
			return 0x9ab3abb3;
		case 0x00009294:
			return 0x4ac9ee19;
		case 0x00009298:
			return 0x231e30d6;
		case 0x0000929c:
			return 0xed79b71e;
		case 0x000092a0:
			return 0xfd3b4724;
		case 0x000092a4:
			return 0xca1687b2;
		case 0x000092a8:
			return 0xafbbb9fd;
		case 0x000092ac:
			return 0xb806fb49;
		case 0x000092b0:
			return 0x54be619b;
		case 0x000092b4:
			return 0x597df487;
		case 0x000092b8:
			return 0xcfa6caa6;
		case 0x000092bc:
			return 0xf924b027;
		case 0x000092c0:
			return 0x6171aa52;
		case 0x000092c4:
			return 0x3bdebabd;
		case 0x000092c8:
			return 0x4234722d;
		case 0x000092cc:
			return 0x3359f199;
		case 0x000092d0:
			return 0x0cd7afb8;
		case 0x000092d4:
			return 0xd214f81a;
		case 0x000092d8:
			return 0x2f735e88;
		case 0x000092dc:
			return 0x8aa116a0;
		case 0x000092e0:
			return 0xbc8749de;
		case 0x000092e4:
			return 0xf742a2e8;
		case 0x000092e8:
			return 0xb140ec41;
		case 0x000092ec:
			return 0x7eb2c735;
		case 0x000092f0:
			return 0xc21391df;
		case 0x000092f4:
			return 0xd58a8bba;
		case 0x000092f8:
			return 0xd6532e36;
		case 0x000092fc:
			return 0xe6386ab9;
		case 0x00009300:
			return 0x53cbeb87;
		case 0x00009304:
			return 0xc38ae82e;
		case 0x00009308:
			return 0xbbedda0b;
		case 0x0000930c:
			return 0x9d5d8e09;
		case 0x00009310:
			return 0xa61bf7c3;
		case 0x00009314:
			return 0x589cc3ec;
		case 0x00009318:
			return 0x8b14ad03;
		case 0x0000931c:
			return 0x9b91085e;
		case 0x00009320:
			return 0xba2ebad0;
		case 0x00009324:
			return 0x37c1c479;
		case 0x00009328:
			return 0x409ad188;
		case 0x0000932c:
			return 0x1ff2eb3c;
		case 0x00009330:
			return 0x085cc85c;
		case 0x00009334:
			return 0x0d3f2480;
		case 0x00009338:
			return 0x8f323626;
		case 0x0000933c:
			return 0x570022c6;
		case 0x00009340:
			return 0x865d6548;
		case 0x00009344:
			return 0xc2da0498;
		case 0x00009348:
			return 0xa812aece;
		case 0x0000934c:
			return 0x89b4eaa6;
		case 0x00009350:
			return 0x2568e6b3;
		case 0x00009354:
			return 0xae5f8526;
		case 0x00009358:
			return 0xe388da7b;
		case 0x0000935c:
			return 0xe02341c9;
		case 0x00009360:
			return 0xea53b283;
		case 0x00009364:
			return 0xa1515bc1;
		case 0x00009368:
			return 0x28b29e45;
		case 0x0000936c:
			return 0xe639afce;
		case 0x00009370:
			return 0x5d3a9428;
		case 0x00009374:
			return 0xe3e7c559;
		case 0x00009378:
			return 0x75a870b9;
		case 0x0000937c:
			return 0xe9f1a0ae;
		case 0x00009380:
			return 0xfe126630;
		case 0x00009384:
			return 0xcb05716e;
		case 0x00009388:
			return 0xd73c70a0;
		case 0x0000938c:
			return 0x97399af0;
		case 0x00009390:
			return 0x68046daf;
		case 0x00009394:
			return 0x9226ee09;
		case 0x00009398:
			return 0x22f7853f;
		case 0x0000939c:
			return 0xa6575859;
		case 0x000093a0:
			return 0xd1c90250;
		case 0x000093a4:
			return 0x7741e4b1;
		case 0x000093a8:
			return 0xc06dd37b;
		case 0x000093ac:
			return 0x9c69ad07;
		case 0x000093b0:
			return 0xbe9d2831;
		case 0x000093b4:
			return 0x45b7f394;
		case 0x000093b8:
			return 0x7aae033b;
		case 0x000093bc:
			return 0x86421778;
		case 0x000093c0:
			return 0x9e1704da;
		case 0x000093c4:
			return 0x91f917c2;
		case 0x000093c8:
			return 0x6743d1d4;
		case 0x000093cc:
			return 0x4a174c02;
		case 0x000093d0:
			return 0xf35a53fd;
		case 0x000093d4:
			return 0x6cca3d13;
		case 0x000093d8:
			return 0xbd835a5b;
		case 0x000093dc:
			return 0x8ae3aac8;
		case 0x000093e0:
			return 0xfb77f66f;
		case 0x000093e4:
			return 0xd0f311b1;
		case 0x000093e8:
			return 0xd30b68d4;
		case 0x000093ec:
			return 0xfe9bfe18;
		case 0x000093f0:
			return 0xae306994;
		case 0x000093f4:
			return 0x13a08cde;
		case 0x000093f8:
			return 0xb85698f2;
		case 0x000093fc:
			return 0x2eeb47c2;
		case 0x00009400:
			return 0xe60b337f;
		case 0x00009404:
			return 0x732f1158;
		case 0x00009408:
			return 0xf017fdea;
		case 0x0000940c:
			return 0x9388c1d5;
		case 0x00009410:
			return 0x061aa8a7;
		case 0x00009414:
			return 0x737f87b1;
		case 0x00009418:
			return 0x322969f6;
		case 0x0000941c:
			return 0x11cbec67;
		case 0x00009420:
			return 0x6c8140ea;
		case 0x00009424:
			return 0xb91a0503;
		case 0x00009428:
			return 0x99bed360;
		case 0x0000942c:
			return 0xd5b975f4;
		case 0x00009430:
			return 0x8172680e;
		case 0x00009434:
			return 0xe8d5d547;
		case 0x00009438:
			return 0x7d313262;
		case 0x0000943c:
			return 0x77fb1ca2;
		case 0x00009440:
			return 0x17dab9b7;
		case 0x00009444:
			return 0x663226c3;
		case 0x00009448:
			return 0x8f315127;
		case 0x0000944c:
			return 0x353062bf;
		case 0x00009450:
			return 0x8112a837;
		case 0x00009454:
			return 0xc1833d55;
		case 0x00009458:
			return 0xdeeed5bf;
		case 0x0000945c:
			return 0x203c3be3;
		case 0x00009460:
			return 0x8ef963f8;
		case 0x00009464:
			return 0x96383ee1;
		case 0x00009468:
			return 0x9be1aee9;
		case 0x0000946c:
			return 0xbee54c7b;
		case 0x00009470:
			return 0x2480dbea;
		case 0x00009474:
			return 0x7060dd66;
		case 0x00009478:
			return 0x3f0b1c9f;
		case 0x0000947c:
			return 0x33544ec2;
		case 0x00009480:
			return 0x4076061b;
		case 0x00009484:
			return 0x4ab9819d;
		case 0x00009488:
			return 0x75626ae0;
		case 0x0000948c:
			return 0x406b05ea;
		case 0x00009490:
			return 0x30787219;
		case 0x00009494:
			return 0x44674314;
		case 0x00009498:
			return 0x512eb04d;
		case 0x0000949c:
			return 0xcaa95832;
		case 0x000094a0:
			return 0x1e07b9eb;
		case 0x000094a4:
			return 0xa0ec9fab;
		case 0x000094a8:
			return 0x4dcb4521;
		case 0x000094ac:
			return 0xd47a394b;
		case 0x000094b0:
			return 0x73965729;
		case 0x000094b4:
			return 0x786b4ed8;
		case 0x000094b8:
			return 0x8055357f;
		case 0x000094bc:
			return 0xf4b41f74;
		case 0x000094c0:
			return 0x7ca86281;
		case 0x000094c4:
			return 0x50a9bd76;
		case 0x000094c8:
			return 0x3f6dfa43;
		case 0x000094cc:
			return 0x948ae221;
		case 0x000094d0:
			return 0x073688c5;
		case 0x000094d4:
			return 0x5572d66e;
		case 0x000094d8:
			return 0x9e05ee5e;
		case 0x000094dc:
			return 0x84520b32;
		case 0x000094e0:
			return 0x0e29d3c0;
		case 0x000094e4:
			return 0xa6998dc7;
		case 0x000094e8:
			return 0x610093c2;
		case 0x000094ec:
			return 0xde8d6b08;
		case 0x000094f0:
			return 0x5dadf6fa;
		case 0x000094f4:
			return 0x4bd95438;
		case 0x000094f8:
			return 0x77043d61;
		case 0x000094fc:
			return 0x6b7e9546;
		case 0x00009500:
			return 0x087910ea;
		case 0x00009504:
			return 0xcbfdc777;
		case 0x00009508:
			return 0x32ad28c3;
		case 0x0000950c:
			return 0x0e510ff3;
		case 0x00009510:
			return 0x2e4ff778;
		case 0x00009514:
			return 0x702dbc46;
		case 0x00009518:
			return 0x5d8c57a0;
		case 0x0000951c:
			return 0x1b7f42f4;
		case 0x00009520:
			return 0xe034afbc;
		case 0x00009524:
			return 0x65b50fe5;
		case 0x00009528:
			return 0x99f1a4ea;
		case 0x0000952c:
			return 0x2fbbf76b;
		case 0x00009530:
			return 0x75db3672;
		case 0x00009534:
			return 0x8a4ccf56;
		case 0x00009538:
			return 0x8448a671;
		case 0x0000953c:
			return 0x744bc188;
		case 0x00009540:
			return 0x8e31cdf4;
		case 0x00009544:
			return 0xbb4d9ca8;
		case 0x00009548:
			return 0x5b15a47a;
		case 0x0000954c:
			return 0xcc3536ea;
		case 0x00009550:
			return 0xc9016544;
		case 0x00009554:
			return 0x1ae1a852;
		case 0x00009558:
			return 0xcba4b63a;
		case 0x0000955c:
			return 0xeb1df22a;
		case 0x00009560:
			return 0x59a45f68;
		case 0x00009564:
			return 0xee0e4018;
		case 0x00009568:
			return 0xfb1d0d77;
		case 0x0000956c:
			return 0x31fd5a7e;
		case 0x00009570:
			return 0x442e410e;
		case 0x00009574:
			return 0x877fb437;
		case 0x00009578:
			return 0x04962a1b;
		case 0x0000957c:
			return 0x1032b34c;
		case 0x00009580:
			return 0xdf38c87d;
		case 0x00009584:
			return 0x46733b03;
		case 0x00009588:
			return 0x03258559;
		case 0x0000958c:
			return 0x1ac5efd5;
		case 0x00009590:
			return 0xe9296dce;
		case 0x00009594:
			return 0x1438e4af;
		case 0x00009598:
			return 0x5a1030a5;
		case 0x0000959c:
			return 0xb837ec4a;
		case 0x000095a0:
			return 0xe4cda2e5;
		case 0x000095a4:
			return 0xace2a585;
		case 0x000095a8:
			return 0x832ea0d7;
		case 0x000095ac:
			return 0x0414f2c1;
		case 0x000095b0:
			return 0xf6cfe439;
		case 0x000095b4:
			return 0x5fb5f6ec;
		case 0x000095b8:
			return 0x1c48942a;
		case 0x000095bc:
			return 0x2e286837;
		case 0x000095c0:
			return 0x5c80e3e6;
		case 0x000095c4:
			return 0x11dc13f9;
		case 0x000095c8:
			return 0x23c8941d;
		case 0x000095cc:
			return 0x7af82120;
		case 0x000095d0:
			return 0x5acda64d;
		case 0x000095d4:
			return 0xab01cec6;
		case 0x000095d8:
			return 0x4a977a96;
		case 0x000095dc:
			return 0x13c0b359;
		case 0x000095e0:
			return 0x645f91d8;
		case 0x000095e4:
			return 0x7a7db3b2;
		case 0x000095e8:
			return 0xa74b0161;
		case 0x000095ec:
			return 0xe2b2bbcf;
		case 0x000095f0:
			return 0xeaa98f85;
		case 0x000095f4:
			return 0x70aa4cfd;
		case 0x000095f8:
			return 0x4cf053d9;
		case 0x000095fc:
			return 0x7d6ab03b;
		case 0x00009600:
			return 0xe63ab757;
		case 0x00009604:
			return 0x07e24a52;
		case 0x00009608:
			return 0x169859f1;
		case 0x0000960c:
			return 0x1aae916e;
		case 0x00009610:
			return 0x63769b5d;
		case 0x00009614:
			return 0x1fbea58d;
		case 0x00009618:
			return 0xce60d3d2;
		case 0x0000961c:
			return 0xa3b183bf;
		case 0x00009620:
			return 0xfc29699d;
		case 0x00009624:
			return 0xc706dea0;
		case 0x00009628:
			return 0x685381f1;
		case 0x0000962c:
			return 0x72f2b8f7;
		case 0x00009630:
			return 0x0c5bd545;
		case 0x00009634:
			return 0x6e6699c5;
		case 0x00009638:
			return 0x598d464d;
		case 0x0000963c:
			return 0x11c1f31b;
		case 0x00009640:
			return 0xa6c2c9b1;
		case 0x00009644:
			return 0xa4bcd4db;
		case 0x00009648:
			return 0x0692ecd8;
		case 0x0000964c:
			return 0xf61a15a9;
		case 0x00009650:
			return 0x6f2b037f;
		case 0x00009654:
			return 0xc5541ee5;
		case 0x00009658:
			return 0xd7b1b466;
		case 0x0000965c:
			return 0xec216294;
		case 0x00009660:
			return 0xfc2c28ea;
		case 0x00009664:
			return 0x90b635a6;
		case 0x00009668:
			return 0x83ff743c;
		case 0x0000966c:
			return 0x31bd7bc3;
		case 0x00009670:
			return 0x66f6ba79;
		case 0x00009674:
			return 0xf4bc076c;
		case 0x00009678:
			return 0xcc4b29bc;
		case 0x0000967c:
			return 0x08d43c6d;
		case 0x00009680:
			return 0x2b32c917;
		case 0x00009684:
			return 0xd2fcecd6;
		case 0x00009688:
			return 0x9cfd09c9;
		case 0x0000968c:
			return 0x724504c4;
		case 0x00009690:
			return 0xeb4809f4;
		case 0x00009694:
			return 0x0693c643;
		case 0x00009698:
			return 0xe1cd1699;
		case 0x0000969c:
			return 0xd9152e5e;
		case 0x000096a0:
			return 0xdc463f32;
		case 0x000096a4:
			return 0x6b28a70a;
		case 0x000096a8:
			return 0x0d438b0f;
		case 0x000096ac:
			return 0xfbdc34d3;
		case 0x000096b0:
			return 0x25e25fd2;
		case 0x000096b4:
			return 0x1a59bfc7;
		case 0x000096b8:
			return 0x6e34870a;
		case 0x000096bc:
			return 0xcecc6c72;
		case 0x000096c0:
			return 0xdbc47f8d;
		case 0x000096c4:
			return 0xb8a0bc3b;
		case 0x000096c8:
			return 0xfd9e7b4b;
		case 0x000096cc:
			return 0x0ba42f48;
		case 0x000096d0:
			return 0x4784bdf6;
		case 0x000096d4:
			return 0x80239719;
		case 0x000096d8:
			return 0x2e714acb;
		case 0x000096dc:
			return 0x65d23ea7;
		case 0x000096e0:
			return 0xf8263fff;
		case 0x000096e4:
			return 0xb82cf8da;
		case 0x000096e8:
			return 0xd711f748;
		case 0x000096ec:
			return 0xfe775e04;
		case 0x000096f0:
			return 0x9459dcb8;
		case 0x000096f4:
			return 0x21de6ef6;
		case 0x000096f8:
			return 0x006b00fd;
		case 0x000096fc:
			return 0x8de3636e;
		case 0x00009700:
			return 0xdc107a65;
		case 0x00009704:
			return 0x0c18c0b3;
		case 0x00009708:
			return 0x459954ac;
		case 0x0000970c:
			return 0xc392068a;
		case 0x00009710:
			return 0x097e74d0;
		case 0x00009714:
			return 0x83f880e9;
		case 0x00009718:
			return 0x90ea34b1;
		case 0x0000971c:
			return 0x966696d2;
		case 0x00009720:
			return 0xe22fd346;
		case 0x00009724:
			return 0xd1cc1221;
		case 0x00009728:
			return 0xc45ceaad;
		case 0x0000972c:
			return 0xaec79e04;
		case 0x00009730:
			return 0xb1b734ca;
		case 0x00009734:
			return 0x3c90e503;
		case 0x00009738:
			return 0xce84597b;
		case 0x0000973c:
			return 0x3e8dfe67;
		case 0x00009740:
			return 0x9f35203c;
		case 0x00009744:
			return 0xb4bf651a;
		case 0x00009748:
			return 0x721e8f8b;
		case 0x0000974c:
			return 0xa6791de1;
		case 0x00009750:
			return 0x1bf1596e;
		case 0x00009754:
			return 0x7be40b86;
		case 0x00009758:
			return 0xba78130c;
		case 0x0000975c:
			return 0x012929ae;
		case 0x00009760:
			return 0xd175f735;
		case 0x00009764:
			return 0xdbf8ee18;
		case 0x00009768:
			return 0x0692bb98;
		case 0x0000976c:
			return 0xc503308c;
		case 0x00009770:
			return 0x81bd5b53;
		case 0x00009774:
			return 0xd8cc9b37;
		case 0x00009778:
			return 0xb42d2c8b;
		case 0x0000977c:
			return 0x253e7c3a;
		case 0x00009780:
			return 0x7681bd20;
		case 0x00009784:
			return 0xe69be831;
		case 0x00009788:
			return 0xffb0ee4d;
		case 0x0000978c:
			return 0x76e53271;
		case 0x00009790:
			return 0xb24ccbc1;
		case 0x00009794:
			return 0x3d7c1555;
		case 0x00009798:
			return 0xab30dbb5;
		case 0x0000979c:
			return 0x9d7718bb;
		case 0x000097a0:
			return 0x46fee0c3;
		case 0x000097a4:
			return 0x0e42ed98;
		case 0x000097a8:
			return 0xafe0e81f;
		case 0x000097ac:
			return 0x3e5a6ba6;
		case 0x000097b0:
			return 0x005b9a3e;
		case 0x000097b4:
			return 0x1ddb5117;
		case 0x000097b8:
			return 0x0e144d0e;
		case 0x000097bc:
			return 0x23385e56;
		case 0x000097c0:
			return 0x9a8a1621;
		case 0x000097c4:
			return 0x5203d24d;
		case 0x000097c8:
			return 0xd1897c39;
		case 0x000097cc:
			return 0x34c79368;
		case 0x000097d0:
			return 0x3a2f5544;
		case 0x000097d4:
			return 0xefd425c7;
		case 0x000097d8:
			return 0x13f06937;
		case 0x000097dc:
			return 0x6b77dbd7;
		case 0x000097e0:
			return 0x6f18b1bc;
		case 0x000097e4:
			return 0xdd7c7828;
		case 0x000097e8:
			return 0x5f91240d;
		case 0x000097ec:
			return 0x2e20049a;
		case 0x000097f0:
			return 0xe21dc75d;
		case 0x000097f4:
			return 0xb463cb57;
		case 0x000097f8:
			return 0xa0f42ebf;
		case 0x000097fc:
			return 0x62a2f2cb;
		case 0x00009800:
			return 0xca853ee3;
		case 0x00009804:
			return 0x502f3986;
		case 0x00009808:
			return 0x774aea36;
		case 0x0000980c:
			return 0x9745b8f1;
		case 0x00009810:
			return 0x703f96da;
		case 0x00009814:
			return 0x7435aa63;
		case 0x00009818:
			return 0x78e2cdf4;
		case 0x0000981c:
			return 0xd0aa5fdf;
		case 0x00009820:
			return 0x786b1d1e;
		case 0x00009824:
			return 0x5175b9d5;
		case 0x00009828:
			return 0x3f8b18e9;
		case 0x0000982c:
			return 0x694ec022;
		case 0x00009830:
			return 0xe3f7babd;
		case 0x00009834:
			return 0x32325d94;
		case 0x00009838:
			return 0x92a477b5;
		case 0x0000983c:
			return 0x369e2ee7;
		case 0x00009840:
			return 0x3047fab6;
		case 0x00009844:
			return 0xec5f06e2;
		case 0x00009848:
			return 0xcba2ba05;
		case 0x0000984c:
			return 0xa4778139;
		case 0x00009850:
			return 0x3033c4e9;
		case 0x00009854:
			return 0x3e7be683;
		case 0x00009858:
			return 0xb4086d87;
		case 0x0000985c:
			return 0x78e194a6;
		case 0x00009860:
			return 0x8c63b227;
		case 0x00009864:
			return 0x40b5c0ad;
		case 0x00009868:
			return 0x0be7571b;
		case 0x0000986c:
			return 0xe09640f5;
		case 0x00009870:
			return 0x504357b1;
		case 0x00009874:
			return 0x66c1b78c;
		case 0x00009878:
			return 0x181c7581;
		case 0x0000987c:
			return 0x43fc5be0;
		case 0x00009880:
			return 0x5c26dc85;
		case 0x00009884:
			return 0xf52704ec;
		case 0x00009888:
			return 0x93bce6be;
		case 0x0000988c:
			return 0xb3f9cd02;
		case 0x00009890:
			return 0x15225a48;
		case 0x00009894:
			return 0x602eb252;
		case 0x00009898:
			return 0x4df08d79;
		case 0x0000989c:
			return 0x66967493;
		case 0x000098a0:
			return 0x020dda88;
		case 0x000098a4:
			return 0xe6b44b6e;
		case 0x000098a8:
			return 0x7bb30df3;
		case 0x000098ac:
			return 0x896833f2;
		case 0x000098b0:
			return 0xfcaeefe5;
		case 0x000098b4:
			return 0x90f986cc;
		case 0x000098b8:
			return 0x97b01874;
		case 0x000098bc:
			return 0x779db199;
		case 0x000098c0:
			return 0xe2077e6d;
		case 0x000098c4:
			return 0xf119a11e;
		case 0x000098c8:
			return 0xbfa0fed8;
		case 0x000098cc:
			return 0xedd535d4;
		case 0x000098d0:
			return 0x4831e07f;
		case 0x000098d4:
			return 0x1ce96cd6;
		case 0x000098d8:
			return 0x299d1663;
		case 0x000098dc:
			return 0xacb83595;
		case 0x000098e0:
			return 0x228a013a;
		case 0x000098e4:
			return 0xdbe7ef56;
		case 0x000098e8:
			return 0x61de5212;
		case 0x000098ec:
			return 0xbf621eec;
		case 0x000098f0:
			return 0x8e1d7526;
		case 0x000098f4:
			return 0xce734398;
		case 0x000098f8:
			return 0x81d21e40;
		case 0x000098fc:
			return 0x9502b1db;
		case 0x00009900:
			return 0x6165918c;
		case 0x00009904:
			return 0xf45aa3cd;
		case 0x00009908:
			return 0xb9fc1390;
		case 0x0000990c:
			return 0x35b9dc6f;
		case 0x00009910:
			return 0xf78f0fd2;
		case 0x00009914:
			return 0x52412b2d;
		case 0x00009918:
			return 0x7d493968;
		case 0x0000991c:
			return 0x79350d54;
		case 0x00009920:
			return 0x046ba38c;
		case 0x00009924:
			return 0x72228913;
		case 0x00009928:
			return 0x9ecc0a4c;
		case 0x0000992c:
			return 0xd5e8528c;
		case 0x00009930:
			return 0x28f9b97d;
		case 0x00009934:
			return 0x3bb36ee3;
		case 0x00009938:
			return 0xbc00c0d4;
		case 0x0000993c:
			return 0x1a094df2;
		case 0x00009940:
			return 0x9d1f6fc3;
		case 0x00009944:
			return 0x90427f1c;
		case 0x00009948:
			return 0x628127ec;
		case 0x0000994c:
			return 0x8f5f2b1b;
		case 0x00009950:
			return 0x98da8a57;
		case 0x00009954:
			return 0x87e6a5c6;
		case 0x00009958:
			return 0x7990b995;
		case 0x0000995c:
			return 0x133a2b37;
		case 0x00009960:
			return 0x70baabc6;
		case 0x00009964:
			return 0x0b95113b;
		case 0x00009968:
			return 0x99b9cef7;
		case 0x0000996c:
			return 0xce8813a9;
		case 0x00009970:
			return 0x361dbc23;
		case 0x00009974:
			return 0x47edbd68;
		case 0x00009978:
			return 0x250bafca;
		case 0x0000997c:
			return 0xe91478cb;
		case 0x00009980:
			return 0xfb81fdcb;
		case 0x00009984:
			return 0xc7804e24;
		case 0x00009988:
			return 0x8fd59a21;
		case 0x0000998c:
			return 0xe41ed02a;
		case 0x00009990:
			return 0x3e206e7a;
		case 0x00009994:
			return 0xe7d43388;
		case 0x00009998:
			return 0x6ba13c02;
		case 0x0000999c:
			return 0x56e14534;
		case 0x000099a0:
			return 0xf2e3c317;
		case 0x000099a4:
			return 0x572cede5;
		case 0x000099a8:
			return 0x85651df9;
		case 0x000099ac:
			return 0xe8bf7768;
		case 0x000099b0:
			return 0xb090c34c;
		case 0x000099b4:
			return 0xe10b2ff6;
		case 0x000099b8:
			return 0xc01bd80c;
		case 0x000099bc:
			return 0x4684a4ca;
		case 0x000099c0:
			return 0x9fb1c73a;
		case 0x000099c4:
			return 0xbaf7b527;
		case 0x000099c8:
			return 0x0ea03186;
		case 0x000099cc:
			return 0x820ecb2f;
		case 0x000099d0:
			return 0xb8587ee3;
		case 0x000099d4:
			return 0xc571cf31;
		case 0x000099d8:
			return 0x1c3197cd;
		case 0x000099dc:
			return 0x3d50142e;
		case 0x000099e0:
			return 0x0e30d3e8;
		case 0x000099e4:
			return 0x4324e147;
		case 0x000099e8:
			return 0x5579b0fc;
		case 0x000099ec:
			return 0x22ddff12;
		case 0x000099f0:
			return 0x7744e238;
		case 0x000099f4:
			return 0x90b73520;
		case 0x000099f8:
			return 0xd788ad4f;
		case 0x000099fc:
			return 0x5534ac3d;
		case 0x00009a00:
			return 0x06918a2e;
		case 0x00009a04:
			return 0x0a457d35;
		case 0x00009a08:
			return 0x48bb91ea;
		case 0x00009a0c:
			return 0x21731c64;
		case 0x00009a10:
			return 0xbc6d6b49;
		case 0x00009a14:
			return 0x022807ea;
		case 0x00009a18:
			return 0x2ac45720;
		case 0x00009a1c:
			return 0x3414d9e7;
		case 0x00009a20:
			return 0x7f9c53f8;
		case 0x00009a24:
			return 0xe61d69c5;
		case 0x00009a28:
			return 0x83860165;
		case 0x00009a2c:
			return 0x4df6f6fb;
		case 0x00009a30:
			return 0x3e2c056e;
		case 0x00009a34:
			return 0x6cf99e00;
		case 0x00009a38:
			return 0x1483f821;
		case 0x00009a3c:
			return 0x3db8d038;
		case 0x00009a40:
			return 0x3f21211f;
		case 0x00009a44:
			return 0x02b71283;
		case 0x00009a48:
			return 0x0920a803;
		case 0x00009a4c:
			return 0x5100a3f8;
		case 0x00009a50:
			return 0xf41ec18d;
		case 0x00009a54:
			return 0x94d2070b;
		case 0x00009a58:
			return 0x3e5af32f;
		case 0x00009a5c:
			return 0x9586c0ed;
		case 0x00009a60:
			return 0xb26a6e35;
		case 0x00009a64:
			return 0xd7299387;
		case 0x00009a68:
			return 0xadd0f72d;
		case 0x00009a6c:
			return 0x0ef2906f;
		case 0x00009a70:
			return 0x45040031;
		case 0x00009a74:
			return 0x24358a34;
		case 0x00009a78:
			return 0xcd3fef41;
		case 0x00009a7c:
			return 0x13ab2e4e;
		case 0x00009a80:
			return 0xb95029d4;
		case 0x00009a84:
			return 0xd25fec5e;
		case 0x00009a88:
			return 0x4c8989c3;
		case 0x00009a8c:
			return 0x38fa688a;
		case 0x00009a90:
			return 0x6ef871fe;
		case 0x00009a94:
			return 0xa0f3a7cf;
		case 0x00009a98:
			return 0xa85eedc6;
		case 0x00009a9c:
			return 0x6a950059;
		case 0x00009aa0:
			return 0x6d811d72;
		case 0x00009aa4:
			return 0xd5176722;
		case 0x00009aa8:
			return 0x2ca039ae;
		case 0x00009aac:
			return 0xb2211c0b;
		case 0x00009ab0:
			return 0xcc132196;
		case 0x00009ab4:
			return 0x1eb3b3c1;
		case 0x00009ab8:
			return 0xa5213401;
		case 0x00009abc:
			return 0x70b23925;
		case 0x00009ac0:
			return 0xddf67440;
		case 0x00009ac4:
			return 0xccc7784c;
		case 0x00009ac8:
			return 0x420bf3a6;
		case 0x00009acc:
			return 0xc6d8aa63;
		case 0x00009ad0:
			return 0xb81917de;
		case 0x00009ad4:
			return 0x549a8a77;
		case 0x00009ad8:
			return 0xd3cc5f2d;
		case 0x00009adc:
			return 0x761818c0;
		case 0x00009ae0:
			return 0x043af64f;
		case 0x00009ae4:
			return 0xd6e09c2a;
		case 0x00009ae8:
			return 0x5ab9a124;
		case 0x00009aec:
			return 0xedc6aa3f;
		case 0x00009af0:
			return 0x177ce10c;
		case 0x00009af4:
			return 0x6e72f3f8;
		case 0x00009af8:
			return 0x9f3248ea;
		case 0x00009afc:
			return 0x4ed3728c;
		case 0x00009b00:
			return 0x4a9c89a0;
		case 0x00009b04:
			return 0x5f93f7ec;
		case 0x00009b08:
			return 0x8637e86c;
		case 0x00009b0c:
			return 0xec688130;
		case 0x00009b10:
			return 0x8fff764c;
		case 0x00009b14:
			return 0x91cb7f88;
		case 0x00009b18:
			return 0x0f62a9e1;
		case 0x00009b1c:
			return 0x1f04679a;
		case 0x00009b20:
			return 0xe0e54897;
		case 0x00009b24:
			return 0x87cafcbb;
		case 0x00009b28:
			return 0xad1521ea;
		case 0x00009b2c:
			return 0x360b5f4a;
		case 0x00009b30:
			return 0x48a2a57c;
		case 0x00009b34:
			return 0xf611f044;
		case 0x00009b38:
			return 0x358e79a9;
		case 0x00009b3c:
			return 0xa923f77e;
		case 0x00009b40:
			return 0xb5b02581;
		case 0x00009b44:
			return 0xf9326448;
		case 0x00009b48:
			return 0x479cf271;
		case 0x00009b4c:
			return 0x7e3190c1;
		case 0x00009b50:
			return 0x773bea49;
		case 0x00009b54:
			return 0x172330a4;
		case 0x00009b58:
			return 0x4135e641;
		case 0x00009b5c:
			return 0xa746aa3d;
		case 0x00009b60:
			return 0x3a989b07;
		case 0x00009b64:
			return 0x4731e9ba;
		case 0x00009b68:
			return 0x877629fa;
		case 0x00009b6c:
			return 0x9577574c;
		case 0x00009b70:
			return 0xd673f2e3;
		case 0x00009b74:
			return 0x6213d9a3;
		case 0x00009b78:
			return 0xbe8dfbf6;
		case 0x00009b7c:
			return 0x3cdd4936;
		case 0x00009b80:
			return 0x90df60d2;
		case 0x00009b84:
			return 0x43dc722f;
		case 0x00009b88:
			return 0xff0482b7;
		case 0x00009b8c:
			return 0x6243e6fc;
		case 0x00009b90:
			return 0x17fd8314;
		case 0x00009b94:
			return 0x032ef080;
		case 0x00009b98:
			return 0xb366790b;
		case 0x00009b9c:
			return 0x0f37af55;
		case 0x00009ba0:
			return 0xbd183977;
		case 0x00009ba4:
			return 0x3ea380c4;
		case 0x00009ba8:
			return 0xe6227ac6;
		case 0x00009bac:
			return 0x7a69d6a1;
		case 0x00009bb0:
			return 0x11b10fea;
		case 0x00009bb4:
			return 0x3097977d;
		case 0x00009bb8:
			return 0xb1cfc2c0;
		case 0x00009bbc:
			return 0x81917971;
		case 0x00009bc0:
			return 0x7cc163cb;
		case 0x00009bc4:
			return 0x778ca6cd;
		case 0x00009bc8:
			return 0xb6332b97;
		case 0x00009bcc:
			return 0x9a3a629c;
		case 0x00009bd0:
			return 0x6a82c364;
		case 0x00009bd4:
			return 0x43b416ab;
		case 0x00009bd8:
			return 0xd56da569;
		case 0x00009bdc:
			return 0xa8fe80e7;
		case 0x00009be0:
			return 0xba4f4d37;
		case 0x00009be4:
			return 0x6e351095;
		case 0x00009be8:
			return 0x6195249b;
		case 0x00009bec:
			return 0x06bc4335;
		case 0x00009bf0:
			return 0xc02da6b9;
		case 0x00009bf4:
			return 0x157c8644;
		case 0x00009bf8:
			return 0xb7fe2e1d;
		case 0x00009bfc:
			return 0xc00c9cff;
		case 0x00009c00:
			return 0x49917ef9;
		case 0x00009c04:
			return 0x1e309385;
		case 0x00009c08:
			return 0x29d3100d;
		case 0x00009c0c:
			return 0xad964968;
		case 0x00009c10:
			return 0x6b675a7d;
		case 0x00009c14:
			return 0x40c1e529;
		case 0x00009c18:
			return 0xf77a7ac2;
		case 0x00009c1c:
			return 0x90f0d9b0;
		case 0x00009c20:
			return 0x8f84c098;
		case 0x00009c24:
			return 0x499e99d3;
		case 0x00009c28:
			return 0x4d5a39f6;
		case 0x00009c2c:
			return 0xf8ae3e46;
		case 0x00009c30:
			return 0x77eb23dc;
		case 0x00009c34:
			return 0xb6d620f0;
		case 0x00009c38:
			return 0xdf5c4a77;
		case 0x00009c3c:
			return 0xc40e6229;
		case 0x00009c40:
			return 0x216c4095;
		case 0x00009c44:
			return 0xff72410e;
		case 0x00009c48:
			return 0xed2ac64d;
		case 0x00009c4c:
			return 0x3d0f88cb;
		case 0x00009c50:
			return 0xf2c5cccc;
		case 0x00009c54:
			return 0xa27bd6c8;
		case 0x00009c58:
			return 0xd55ec25b;
		case 0x00009c5c:
			return 0xf1f0adbe;
		case 0x00009c60:
			return 0xacf9e999;
		case 0x00009c64:
			return 0x9053adf5;
		case 0x00009c68:
			return 0x6ed97df1;
		case 0x00009c6c:
			return 0x86421f66;
		case 0x00009c70:
			return 0x6876a21b;
		case 0x00009c74:
			return 0xfb2efbd9;
		case 0x00009c78:
			return 0x3cbf89b9;
		case 0x00009c7c:
			return 0x17fb01b0;
		case 0x00009c80:
			return 0xd55175c8;
		case 0x00009c84:
			return 0x4591ce2f;
		case 0x00009c88:
			return 0x2143a4c7;
		case 0x00009c8c:
			return 0xddcf0fe7;
		case 0x00009c90:
			return 0x9e9e521d;
		case 0x00009c94:
			return 0x5ab91583;
		case 0x00009c98:
			return 0xb9d89550;
		case 0x00009c9c:
			return 0x8fd83bab;
		case 0x00009ca0:
			return 0x8af7840f;
		case 0x00009ca4:
			return 0x8c6948b5;
		case 0x00009ca8:
			return 0x7a9ea139;
		case 0x00009cac:
			return 0x68deb03e;
		case 0x00009cb0:
			return 0x126c611c;
		case 0x00009cb4:
			return 0x81b628f2;
		case 0x00009cb8:
			return 0x6335e414;
		case 0x00009cbc:
			return 0xf73adf4b;
		case 0x00009cc0:
			return 0x1647ab46;
		case 0x00009cc4:
			return 0x29b42a4e;
		case 0x00009cc8:
			return 0xc1567d90;
		case 0x00009ccc:
			return 0x48000953;
		case 0x00009cd0:
			return 0x77b9867d;
		case 0x00009cd4:
			return 0x3874ff1b;
		case 0x00009cd8:
			return 0xed89323f;
		case 0x00009cdc:
			return 0x444f8320;
		case 0x00009ce0:
			return 0x65fba3b5;
		case 0x00009ce4:
			return 0x5c63a193;
		case 0x00009ce8:
			return 0xee42d616;
		case 0x00009cec:
			return 0x6d073e31;
		case 0x00009cf0:
			return 0x821fc423;
		case 0x00009cf4:
			return 0xa9e0f8c9;
		case 0x00009cf8:
			return 0x4b355c3f;
		case 0x00009cfc:
			return 0xd0fa2fb9;
		case 0x00009d00:
			return 0x9be4b8df;
		case 0x00009d04:
			return 0xde73e0fb;
		case 0x00009d08:
			return 0x8d91423f;
		case 0x00009d0c:
			return 0x64d0246a;
		case 0x00009d10:
			return 0xa10589bf;
		case 0x00009d14:
			return 0xa8cb8678;
		case 0x00009d18:
			return 0x9abd73ba;
		case 0x00009d1c:
			return 0x9b8d7901;
		case 0x00009d20:
			return 0xfb7fec77;
		case 0x00009d24:
			return 0xb9c7cfe6;
		case 0x00009d28:
			return 0xc378068c;
		case 0x00009d2c:
			return 0xd4fc5d93;
		case 0x00009d30:
			return 0x8064fe9b;
		case 0x00009d34:
			return 0x4d82dc55;
		case 0x00009d38:
			return 0x94072821;
		case 0x00009d3c:
			return 0x831a6ed6;
		case 0x00009d40:
			return 0xc9f2961d;
		case 0x00009d44:
			return 0x388808fb;
		case 0x00009d48:
			return 0x9c60f22e;
		case 0x00009d4c:
			return 0xaf8770b2;
		case 0x00009d50:
			return 0x9e30e1da;
		case 0x00009d54:
			return 0x8904dd66;
		case 0x00009d58:
			return 0x0aaa7b3e;
		case 0x00009d5c:
			return 0x6e17c94a;
		case 0x00009d60:
			return 0xe40a50f3;
		case 0x00009d64:
			return 0x74a6e6a5;
		case 0x00009d68:
			return 0xc2df1b26;
		case 0x00009d6c:
			return 0xc3aa3fae;
		case 0x00009d70:
			return 0x485efa91;
		case 0x00009d74:
			return 0xc9fa0472;
		case 0x00009d78:
			return 0xe6380827;
		case 0x00009d7c:
			return 0xc32d6359;
		case 0x00009d80:
			return 0x5aa72bcc;
		case 0x00009d84:
			return 0x45e1b5d3;
		case 0x00009d88:
			return 0xd2f3a0d5;
		case 0x00009d8c:
			return 0xfa4adaa5;
		case 0x00009d90:
			return 0x769845aa;
		case 0x00009d94:
			return 0xb6c11ad0;
		case 0x00009d98:
			return 0x1d7469b3;
		case 0x00009d9c:
			return 0x995d2ddf;
		case 0x00009da0:
			return 0x06c53a4f;
		case 0x00009da4:
			return 0x4efae069;
		case 0x00009da8:
			return 0x5ec46d67;
		case 0x00009dac:
			return 0xc34325ab;
		case 0x00009db0:
			return 0x59a49126;
		case 0x00009db4:
			return 0x088d5f39;
		case 0x00009db8:
			return 0xd75d99d3;
		case 0x00009dbc:
			return 0x6b8df913;
		case 0x00009dc0:
			return 0x3334cfef;
		case 0x00009dc4:
			return 0x7ecee807;
		case 0x00009dc8:
			return 0x54f908cb;
		case 0x00009dcc:
			return 0xd5d24dba;
		case 0x00009dd0:
			return 0x6673694a;
		case 0x00009dd4:
			return 0xee2cc096;
		case 0x00009dd8:
			return 0x2da4dc76;
		case 0x00009ddc:
			return 0xa42f439c;
		case 0x00009de0:
			return 0x30c2b312;
		case 0x00009de4:
			return 0xa5b776fd;
		case 0x00009de8:
			return 0x3b09e0c5;
		case 0x00009dec:
			return 0x59a35854;
		case 0x00009df0:
			return 0xe08e3c9a;
		case 0x00009df4:
			return 0x0497f1ba;
		case 0x00009df8:
			return 0xc9fd4bae;
		case 0x00009dfc:
			return 0x971b83f4;
		case 0x00009e00:
			return 0x03feba93;
		case 0x00009e04:
			return 0xff9ce2c8;
		case 0x00009e08:
			return 0x9a00c351;
		case 0x00009e0c:
			return 0x46806939;
		case 0x00009e10:
			return 0x77b22d14;
		case 0x00009e14:
			return 0x292d2dd6;
		case 0x00009e18:
			return 0xed02125c;
		case 0x00009e1c:
			return 0x4a33da3e;
		case 0x00009e20:
			return 0xccab5f75;
		case 0x00009e24:
			return 0x83cadd25;
		case 0x00009e28:
			return 0x0a543081;
		case 0x00009e2c:
			return 0x8caee953;
		case 0x00009e30:
			return 0x0a18881a;
		case 0x00009e34:
			return 0xdb4b9af5;
		case 0x00009e38:
			return 0x9b779c20;
		case 0x00009e3c:
			return 0x28214f9d;
		case 0x00009e40:
			return 0xc966bdd2;
		case 0x00009e44:
			return 0xbf344eb5;
		case 0x00009e48:
			return 0xdec780ff;
		case 0x00009e4c:
			return 0x27ff2dda;
		case 0x00009e50:
			return 0x6086bb43;
		case 0x00009e54:
			return 0xc55a4382;
		case 0x00009e58:
			return 0xeabc376b;
		case 0x00009e5c:
			return 0x2d746aaa;
		case 0x00009e60:
			return 0x1dfb90bf;
		case 0x00009e64:
			return 0xdd71861d;
		case 0x00009e68:
			return 0x9940a7b9;
		case 0x00009e6c:
			return 0x01be46c0;
		case 0x00009e70:
			return 0x70a51f10;
		case 0x00009e74:
			return 0x55d68a26;
		case 0x00009e78:
			return 0x59dd891c;
		case 0x00009e7c:
			return 0xf4ce7fd3;
		case 0x00009e80:
			return 0x92802f2f;
		case 0x00009e84:
			return 0x06c28b8a;
		case 0x00009e88:
			return 0x0002a273;
		case 0x00009e8c:
			return 0x755c05c7;
		case 0x00009e90:
			return 0x7a1aec18;
		case 0x00009e94:
			return 0x7fd24070;
		case 0x00009e98:
			return 0xb0821249;
		case 0x00009e9c:
			return 0x6d195f68;
		case 0x00009ea0:
			return 0x6bc1400f;
		case 0x00009ea4:
			return 0x7f389900;
		case 0x00009ea8:
			return 0xb08f4032;
		case 0x00009eac:
			return 0x6c8ba7f2;
		case 0x00009eb0:
			return 0xc099a375;
		case 0x00009eb4:
			return 0x8219923b;
		case 0x00009eb8:
			return 0x3eb974ff;
		case 0x00009ebc:
			return 0x0b11d920;
		case 0x00009ec0:
			return 0x5a428089;
		case 0x00009ec4:
			return 0x13f21c6b;
		case 0x00009ec8:
			return 0xa1db74f2;
		case 0x00009ecc:
			return 0x07715518;
		case 0x00009ed0:
			return 0xc1975590;
		case 0x00009ed4:
			return 0xdb126e34;
		case 0x00009ed8:
			return 0xc7e1ed86;
		case 0x00009edc:
			return 0x10ed586d;
		case 0x00009ee0:
			return 0xddb85c6d;
		case 0x00009ee4:
			return 0x0e91dcb9;
		case 0x00009ee8:
			return 0xa0fb80f9;
		case 0x00009eec:
			return 0xb3ea1366;
		case 0x00009ef0:
			return 0x057d24bd;
		case 0x00009ef4:
			return 0xcd322ecd;
		case 0x00009ef8:
			return 0xe2e9e024;
		case 0x00009efc:
			return 0x9c5d8c40;
		case 0x00009f00:
			return 0x2f2302c9;
		case 0x00009f04:
			return 0x809c253c;
		case 0x00009f08:
			return 0xaae413b7;
		case 0x00009f0c:
			return 0xd2746374;
		case 0x00009f10:
			return 0x5fe9d2fc;
		case 0x00009f14:
			return 0xa43190bf;
		case 0x00009f18:
			return 0x9ef64b4f;
		case 0x00009f1c:
			return 0x7c9d2b39;
		case 0x00009f20:
			return 0x5df1f665;
		case 0x00009f24:
			return 0x9ba4fd63;
		case 0x00009f28:
			return 0x534e5e9c;
		case 0x00009f2c:
			return 0xda355330;
		case 0x00009f30:
			return 0xffbbb483;
		case 0x00009f34:
			return 0x0ce452b4;
		case 0x00009f38:
			return 0x621db296;
		case 0x00009f3c:
			return 0x454bf59a;
		case 0x00009f40:
			return 0xf2d22e30;
		case 0x00009f44:
			return 0x125b01ee;
		case 0x00009f48:
			return 0xc86531a7;
		case 0x00009f4c:
			return 0x3cdf325c;
		case 0x00009f50:
			return 0x73074cca;
		case 0x00009f54:
			return 0xd7ddf147;
		case 0x00009f58:
			return 0xce9092fe;
		case 0x00009f5c:
			return 0x5a487431;
		case 0x00009f60:
			return 0xee5a0c68;
		case 0x00009f64:
			return 0x8d6a915b;
		case 0x00009f68:
			return 0xb1c678fa;
		case 0x00009f6c:
			return 0x03e22eb8;
		case 0x00009f70:
			return 0x23233240;
		case 0x00009f74:
			return 0x0320987f;
		case 0x00009f78:
			return 0x4e248ea2;
		case 0x00009f7c:
			return 0x1039c7d1;
		case 0x00009f80:
			return 0x7ce7934f;
		case 0x00009f84:
			return 0xe06854ef;
		case 0x00009f88:
			return 0xd0a1fac6;
		case 0x00009f8c:
			return 0x703e8286;
		case 0x00009f90:
			return 0xf0b54245;
		case 0x00009f94:
			return 0x2179543e;
		case 0x00009f98:
			return 0xba9a066f;
		case 0x00009f9c:
			return 0xea233b03;
		case 0x00009fa0:
			return 0x7b458af7;
		case 0x00009fa4:
			return 0xcda3e13d;
		case 0x00009fa8:
			return 0x5079f201;
		case 0x00009fac:
			return 0x333dce7f;
		case 0x00009fb0:
			return 0x469c5ad4;
		case 0x00009fb4:
			return 0x0174c19d;
		case 0x00009fb8:
			return 0x7054fc6c;
		case 0x00009fbc:
			return 0xa494809d;
		case 0x00009fc0:
			return 0xce03a9ba;
		case 0x00009fc4:
			return 0x888e6323;
		case 0x00009fc8:
			return 0x48868061;
		case 0x00009fcc:
			return 0x73944475;
		case 0x00009fd0:
			return 0x6b859582;
		case 0x00009fd4:
			return 0x8566af90;
		case 0x00009fd8:
			return 0xd5e49159;
		case 0x00009fdc:
			return 0x31ba724f;
		case 0x00009fe0:
			return 0x03855ae6;
		case 0x00009fe4:
			return 0x315ec1b9;
		case 0x00009fe8:
			return 0xf697d69e;
		case 0x00009fec:
			return 0x1c9b060a;
		case 0x00009ff0:
			return 0x930ef453;
		case 0x00009ff4:
			return 0x909cb28e;
		case 0x00009ff8:
			return 0x0ab67c2e;
		case 0x00009ffc:
			return 0x768589f9;
		case 0x0000a000:
			return 0x289c2dbf;
		case 0x0000a004:
			return 0x94c722cb;
		case 0x0000a008:
			return 0xd03b1b84;
		case 0x0000a00c:
			return 0x831b2579;
		case 0x0000a010:
			return 0x5ce60dad;
		case 0x0000a014:
			return 0x33d15d02;
		case 0x0000a018:
			return 0x5fc29ce8;
		case 0x0000a01c:
			return 0x21967fd8;
		case 0x0000a020:
			return 0x3c3ed993;
		case 0x0000a024:
			return 0x02b79127;
		case 0x0000a028:
			return 0x35027bb8;
		case 0x0000a02c:
			return 0x11d9fcc0;
		case 0x0000a030:
			return 0xb775acfd;
		case 0x0000a034:
			return 0x460e4d2a;
		case 0x0000a038:
			return 0xf00f5fc3;
		case 0x0000a03c:
			return 0xc165facb;
		case 0x0000a040:
			return 0x469ba9ec;
		case 0x0000a044:
			return 0x937ee6a5;
		case 0x0000a048:
			return 0x12378939;
		case 0x0000a04c:
			return 0x8d882671;
		case 0x0000a050:
			return 0x8044ef1b;
		case 0x0000a054:
			return 0xc360de10;
		case 0x0000a058:
			return 0x5b93ffbb;
		case 0x0000a05c:
			return 0xa1bfc4eb;
		case 0x0000a060:
			return 0x628d226e;
		case 0x0000a064:
			return 0x099162b6;
		case 0x0000a068:
			return 0xed976693;
		case 0x0000a06c:
			return 0x2b6cc782;
		case 0x0000a070:
			return 0xa7ce4b95;
		case 0x0000a074:
			return 0x1a5b37a6;
		case 0x0000a078:
			return 0x9edb8e98;
		case 0x0000a07c:
			return 0xc7664ad3;
		case 0x0000a080:
			return 0x367b2695;
		case 0x0000a084:
			return 0x571eb149;
		case 0x0000a088:
			return 0x76eebdfc;
		case 0x0000a08c:
			return 0x887e5ae6;
		case 0x0000a090:
			return 0x688ec1dc;
		case 0x0000a094:
			return 0x4dcb1bc3;
		case 0x0000a098:
			return 0x33f66f23;
		case 0x0000a09c:
			return 0xa538159c;
		case 0x0000a0a0:
			return 0xc9196005;
		case 0x0000a0a4:
			return 0x91c0bbe0;
		case 0x0000a0a8:
			return 0x449dd3fb;
		case 0x0000a0ac:
			return 0x3d09aa0d;
		case 0x0000a0b0:
			return 0x895557d8;
		case 0x0000a0b4:
			return 0xc8c0c679;
		case 0x0000a0b8:
			return 0x751d598b;
		case 0x0000a0bc:
			return 0xcfcbb8c7;
		case 0x0000a0c0:
			return 0x767be696;
		case 0x0000a0c4:
			return 0x02bae390;
		case 0x0000a0c8:
			return 0x5780affb;
		case 0x0000a0cc:
			return 0x4428d798;
		case 0x0000a0d0:
			return 0x3d7bbb0c;
		case 0x0000a0d4:
			return 0xc850bab4;
		case 0x0000a0d8:
			return 0x72d19ee6;
		case 0x0000a0dc:
			return 0xcf3f508a;
		case 0x0000a0e0:
			return 0x3714578f;
		case 0x0000a0e4:
			return 0x37b84291;
		case 0x0000a0e8:
			return 0x9fa8f9a8;
		case 0x0000a0ec:
			return 0xe6d0bd92;
		case 0x0000a0f0:
			return 0x314fe921;
		case 0x0000a0f4:
			return 0x51fb0798;
		case 0x0000a0f8:
			return 0xbd8cb0a5;
		case 0x0000a0fc:
			return 0xac60af65;
		case 0x0000a100:
			return 0xdff0e2f4;
		case 0x0000a104:
			return 0x5fe56c0a;
		case 0x0000a108:
			return 0x9afffa1c;
		case 0x0000a10c:
			return 0xd6d69588;
		case 0x0000a110:
			return 0x3e3df2f9;
		case 0x0000a114:
			return 0xaa4838ff;
		case 0x0000a118:
			return 0x81f28f77;
		case 0x0000a11c:
			return 0xa9d66e4d;
		case 0x0000a120:
			return 0xb78dccab;
		case 0x0000a124:
			return 0x383602d5;
		case 0x0000a128:
			return 0x50661d99;
		case 0x0000a12c:
			return 0x1b074d94;
		case 0x0000a130:
			return 0x778a7e8b;
		case 0x0000a134:
			return 0x2dfbba75;
		case 0x0000a138:
			return 0x3a7cf514;
		case 0x0000a13c:
			return 0x728e066f;
		case 0x0000a140:
			return 0x2c206a70;
		case 0x0000a144:
			return 0xfbd4cf6e;
		case 0x0000a148:
			return 0x316cc219;
		case 0x0000a14c:
			return 0x587ed6b1;
		case 0x0000a150:
			return 0x5dec5c3e;
		case 0x0000a154:
			return 0xe3f54689;
		case 0x0000a158:
			return 0xcc1d6844;
		case 0x0000a15c:
			return 0xe9d9a65f;
		case 0x0000a160:
			return 0x9d643afc;
		case 0x0000a164:
			return 0xf687ef96;
		case 0x0000a168:
			return 0xd279a04b;
		case 0x0000a16c:
			return 0xc27709cf;
		case 0x0000a170:
			return 0xf541066c;
		case 0x0000a174:
			return 0xf06ab94c;
		case 0x0000a178:
			return 0xb5c84300;
		case 0x0000a17c:
			return 0xc69ebd72;
		case 0x0000a180:
			return 0xcde29ef2;
		case 0x0000a184:
			return 0xca0dd83d;
		case 0x0000a188:
			return 0x8c69f034;
		case 0x0000a18c:
			return 0x63c77406;
		case 0x0000a190:
			return 0xe41a4d28;
		case 0x0000a194:
			return 0x4c12468d;
		case 0x0000a198:
			return 0xfa8bdc10;
		case 0x0000a19c:
			return 0x6362a9fb;
		case 0x0000a1a0:
			return 0xe7eaf0ba;
		case 0x0000a1a4:
			return 0xc556e73d;
		case 0x0000a1a8:
			return 0xe734f8c5;
		case 0x0000a1ac:
			return 0x41243fc6;
		case 0x0000a1b0:
			return 0x7e5506d6;
		case 0x0000a1b4:
			return 0x2ec536ad;
		case 0x0000a1b8:
			return 0xf238fe6d;
		case 0x0000a1bc:
			return 0x84580693;
		case 0x0000a1c0:
			return 0x05eb65bc;
		case 0x0000a1c4:
			return 0xfb902b99;
		case 0x0000a1c8:
			return 0xa85a2e29;
		case 0x0000a1cc:
			return 0x3fcad9cd;
		case 0x0000a1d0:
			return 0x64be8d1a;
		case 0x0000a1d4:
			return 0xa8e59e16;
		case 0x0000a1d8:
			return 0xd564ba2f;
		case 0x0000a1dc:
			return 0x6d0d4e31;
		case 0x0000a1e0:
			return 0x334d665d;
		case 0x0000a1e4:
			return 0x0bc8c461;
		case 0x0000a1e8:
			return 0x6ca4af07;
		case 0x0000a1ec:
			return 0x3ac6addb;
		case 0x0000a1f0:
			return 0x6cefdbd7;
		case 0x0000a1f4:
			return 0x3ce664f2;
		case 0x0000a1f8:
			return 0xdc7f95b7;
		case 0x0000a1fc:
			return 0x09d8a8f5;
		case 0x0000a200:
			return 0xf5c8de08;
		case 0x0000a204:
			return 0x44eca90e;
		case 0x0000a208:
			return 0xe421109f;
		case 0x0000a20c:
			return 0x4335b214;
		case 0x0000a210:
			return 0x9fee0e30;
		case 0x0000a214:
			return 0x8a0acc0a;
		case 0x0000a218:
			return 0x339b0c82;
		case 0x0000a21c:
			return 0x0db13f37;
		case 0x0000a220:
			return 0x6e88b52d;
		case 0x0000a224:
			return 0x782f265c;
		case 0x0000a228:
			return 0x8346e0e2;
		case 0x0000a22c:
			return 0x553314cc;
		case 0x0000a230:
			return 0xfae41231;
		case 0x0000a234:
			return 0x15e12255;
		case 0x0000a238:
			return 0x99ff5409;
		case 0x0000a23c:
			return 0x808d7535;
		case 0x0000a240:
			return 0xf642d37b;
		case 0x0000a244:
			return 0xf6c6990f;
		case 0x0000a248:
			return 0xcc239625;
		case 0x0000a24c:
			return 0x56b980cf;
		case 0x0000a250:
			return 0x105ea0da;
		case 0x0000a254:
			return 0x3d50126f;
		case 0x0000a258:
			return 0x9fc1caa4;
		case 0x0000a25c:
			return 0x4932f15b;
		case 0x0000a260:
			return 0x83723457;
		case 0x0000a264:
			return 0xec16f4db;
		case 0x0000a268:
			return 0x5f97e771;
		case 0x0000a26c:
			return 0x60fe38c4;
		case 0x0000a270:
			return 0x7250f87f;
		case 0x0000a274:
			return 0xc484264b;
		case 0x0000a278:
			return 0xc4be0aa9;
		case 0x0000a27c:
			return 0xf2f68dbb;
		case 0x0000a280:
			return 0x6c32be6c;
		case 0x0000a284:
			return 0xe6b9dcc7;
		case 0x0000a288:
			return 0x9ff7951f;
		case 0x0000a28c:
			return 0xa5089ddf;
		case 0x0000a290:
			return 0x31434b72;
		case 0x0000a294:
			return 0x05a73a6f;
		case 0x0000a298:
			return 0x72f06e88;
		case 0x0000a29c:
			return 0x1e3351ed;
		case 0x0000a2a0:
			return 0x96cdced1;
		case 0x0000a2a4:
			return 0x80b636bc;
		case 0x0000a2a8:
			return 0x0150da5e;
		case 0x0000a2ac:
			return 0x76e6a678;
		case 0x0000a2b0:
			return 0x2068c069;
		case 0x0000a2b4:
			return 0x93c50328;
		case 0x0000a2b8:
			return 0xc4f2285f;
		case 0x0000a2bc:
			return 0x70dcd294;
		case 0x0000a2c0:
			return 0x46a0c2ce;
		case 0x0000a2c4:
			return 0x956636f6;
		case 0x0000a2c8:
			return 0xd263c681;
		case 0x0000a2cc:
			return 0x9637b8f2;
		case 0x0000a2d0:
			return 0xa97684fb;
		case 0x0000a2d4:
			return 0x51a38207;
		case 0x0000a2d8:
			return 0xd7c8240d;
		case 0x0000a2dc:
			return 0x33f14409;
		case 0x0000a2e0:
			return 0x4fdedd7a;
		case 0x0000a2e4:
			return 0xc44f36ff;
		case 0x0000a2e8:
			return 0xab727b40;
		case 0x0000a2ec:
			return 0xdc3e69d8;
		case 0x0000a2f0:
			return 0xc682b568;
		case 0x0000a2f4:
			return 0x02109992;
		case 0x0000a2f8:
			return 0x666f74e5;
		case 0x0000a2fc:
			return 0xe6f779ec;
		case 0x0000a300:
			return 0x9652d16b;
		case 0x0000a304:
			return 0x54438c28;
		case 0x0000a308:
			return 0x795bc08c;
		case 0x0000a30c:
			return 0x7b5fb1db;
		case 0x0000a310:
			return 0x2cca2e62;
		case 0x0000a314:
			return 0x72d2312a;
		case 0x0000a318:
			return 0x060605b0;
		case 0x0000a31c:
			return 0xee1e03a9;
		case 0x0000a320:
			return 0x1311edd7;
		case 0x0000a324:
			return 0x4200603c;
		case 0x0000a328:
			return 0x4055933a;
		case 0x0000a32c:
			return 0x902545e0;
		case 0x0000a330:
			return 0xa5c35198;
		case 0x0000a334:
			return 0x7a394e30;
		case 0x0000a338:
			return 0x9bd2493b;
		case 0x0000a33c:
			return 0xc5185db0;
		case 0x0000a340:
			return 0x3a2d93c5;
		case 0x0000a344:
			return 0xcff4851c;
		case 0x0000a348:
			return 0x72f911ed;
		case 0x0000a34c:
			return 0xd285926a;
		case 0x0000a350:
			return 0x63f199db;
		case 0x0000a354:
			return 0x12b387d9;
		case 0x0000a358:
			return 0x3d4e7527;
		case 0x0000a35c:
			return 0x2a6bc0c9;
		case 0x0000a360:
			return 0x79264214;
		case 0x0000a364:
			return 0xad659374;
		case 0x0000a368:
			return 0xdca710ee;
		case 0x0000a36c:
			return 0x46851eb1;
		case 0x0000a370:
			return 0xf8baaadd;
		case 0x0000a374:
			return 0x98722abc;
		case 0x0000a378:
			return 0x68ab4ab3;
		case 0x0000a37c:
			return 0x9687491e;
		case 0x0000a380:
			return 0x4dba40fa;
		case 0x0000a384:
			return 0xc45980c4;
		case 0x0000a388:
			return 0x5c2f0b38;
		case 0x0000a38c:
			return 0xdc56a38f;
		case 0x0000a390:
			return 0xc66426c7;
		case 0x0000a394:
			return 0xaf6a9a12;
		case 0x0000a398:
			return 0x20ecc73c;
		case 0x0000a39c:
			return 0x84ad0ca6;
		case 0x0000a3a0:
			return 0xdc479bc9;
		case 0x0000a3a4:
			return 0x7b24e010;
		case 0x0000a3a8:
			return 0x458f6781;
		case 0x0000a3ac:
			return 0xc52c5396;
		case 0x0000a3b0:
			return 0x4870bab9;
		case 0x0000a3b4:
			return 0x484e2a62;
		case 0x0000a3b8:
			return 0xca576398;
		case 0x0000a3bc:
			return 0xe31af178;
		case 0x0000a3c0:
			return 0x00900683;
		case 0x0000a3c4:
			return 0x626cc4de;
		case 0x0000a3c8:
			return 0x5e1585bb;
		case 0x0000a3cc:
			return 0xcf0ce8d7;
		case 0x0000a3d0:
			return 0xb36cbd00;
		case 0x0000a3d4:
			return 0xf834768e;
		case 0x0000a3d8:
			return 0xddbd1469;
		case 0x0000a3dc:
			return 0xc0543f7c;
		case 0x0000a3e0:
			return 0x2bb10cb8;
		case 0x0000a3e4:
			return 0xc3d6fc64;
		case 0x0000a3e8:
			return 0xbca934e4;
		case 0x0000a3ec:
			return 0x4a24ad16;
		case 0x0000a3f0:
			return 0xfac0d4ab;
		case 0x0000a3f4:
			return 0xb5b65871;
		case 0x0000a3f8:
			return 0x42159137;
		case 0x0000a3fc:
			return 0x272cd9e0;
		case 0x0000a400:
			return 0xb757461d;
		case 0x0000a404:
			return 0x946ba6e7;
		case 0x0000a408:
			return 0x77a477ff;
		case 0x0000a40c:
			return 0xc3f58122;
		case 0x0000a410:
			return 0x58a4c914;
		case 0x0000a414:
			return 0xc75b8073;
		case 0x0000a418:
			return 0xad3e2946;
		case 0x0000a41c:
			return 0xb392c64a;
		case 0x0000a420:
			return 0x11b61c5f;
		case 0x0000a424:
			return 0x2cb0eadb;
		case 0x0000a428:
			return 0x177b9e4a;
		case 0x0000a42c:
			return 0xf442b6e9;
		case 0x0000a430:
			return 0xf0775537;
		case 0x0000a434:
			return 0xe4312f37;
		case 0x0000a438:
			return 0xbf064077;
		case 0x0000a43c:
			return 0xb530a4ec;
		case 0x0000a440:
			return 0xa9a2dca3;
		case 0x0000a444:
			return 0x0f06db06;
		case 0x0000a448:
			return 0xa4e4de9e;
		case 0x0000a44c:
			return 0x9a39dc75;
		case 0x0000a450:
			return 0x5cb4fff3;
		case 0x0000a454:
			return 0xad010bd0;
		case 0x0000a458:
			return 0x2bc0a8e3;
		case 0x0000a45c:
			return 0xb8121311;
		case 0x0000a460:
			return 0x1ced6643;
		case 0x0000a464:
			return 0x2ce03e03;
		case 0x0000a468:
			return 0xf2f08eaf;
		case 0x0000a46c:
			return 0xb5f9356c;
		case 0x0000a470:
			return 0x3a476291;
		case 0x0000a474:
			return 0x833f18bb;
		case 0x0000a478:
			return 0x9273ef46;
		case 0x0000a47c:
			return 0x14aa9f1d;
		case 0x0000a480:
			return 0x26c34946;
		case 0x0000a484:
			return 0xa5f47936;
		case 0x0000a488:
			return 0x2de04331;
		case 0x0000a48c:
			return 0xd197bde1;
		case 0x0000a490:
			return 0xd98383b4;
		case 0x0000a494:
			return 0xe21305c9;
		case 0x0000a498:
			return 0x96c72ae5;
		case 0x0000a49c:
			return 0x5f84a466;
		case 0x0000a4a0:
			return 0xa37059b6;
		case 0x0000a4a4:
			return 0x18021bae;
		case 0x0000a4a8:
			return 0xa2a552ab;
		case 0x0000a4ac:
			return 0x15792011;
		case 0x0000a4b0:
			return 0x0dcad133;
		case 0x0000a4b4:
			return 0xfe56f244;
		case 0x0000a4b8:
			return 0x7053066b;
		case 0x0000a4bc:
			return 0x39fe2022;
		case 0x0000a4c0:
			return 0x9657c80f;
		case 0x0000a4c4:
			return 0x72259b46;
		case 0x0000a4c8:
			return 0xf06f686f;
		case 0x0000a4cc:
			return 0x5da1c07b;
		case 0x0000a4d0:
			return 0x48cc1ab6;
		case 0x0000a4d4:
			return 0xb168534d;
		case 0x0000a4d8:
			return 0x1a3ff452;
		case 0x0000a4dc:
			return 0x94cd4b11;
		case 0x0000a4e0:
			return 0x2454b2f9;
		case 0x0000a4e4:
			return 0xd84c971a;
		case 0x0000a4e8:
			return 0x3e407fe2;
		case 0x0000a4ec:
			return 0x8dd501d2;
		case 0x0000a4f0:
			return 0xd65c91ee;
		case 0x0000a4f4:
			return 0xe66ea8c1;
		case 0x0000a4f8:
			return 0xb6530680;
		case 0x0000a4fc:
			return 0x30487525;
		case 0x0000a500:
			return 0xb294a80e;
		case 0x0000a504:
			return 0x75de7c57;
		case 0x0000a508:
			return 0x9b910f56;
		case 0x0000a50c:
			return 0x6cfa3c80;
		case 0x0000a510:
			return 0x2928233a;
		case 0x0000a514:
			return 0x6540359d;
		case 0x0000a518:
			return 0x5fb63e86;
		case 0x0000a51c:
			return 0xfbde9178;
		case 0x0000a520:
			return 0x2875a3c5;
		case 0x0000a524:
			return 0x00187da5;
		case 0x0000a528:
			return 0x1f9b50a9;
		case 0x0000a52c:
			return 0xd082b3b7;
		case 0x0000a530:
			return 0x41440894;
		case 0x0000a534:
			return 0x15fc4220;
		case 0x0000a538:
			return 0x7d4f300c;
		case 0x0000a53c:
			return 0xb6377095;
		case 0x0000a540:
			return 0x1974f39e;
		case 0x0000a544:
			return 0xf8fc40ca;
		case 0x0000a548:
			return 0x30d2510b;
		case 0x0000a54c:
			return 0xb6c0d511;
		case 0x0000a550:
			return 0x8dff73b9;
		case 0x0000a554:
			return 0xc01ef08a;
		case 0x0000a558:
			return 0x31ba75e8;
		case 0x0000a55c:
			return 0x51df440f;
		case 0x0000a560:
			return 0x3d6476be;
		case 0x0000a564:
			return 0x7b4b70cf;
		case 0x0000a568:
			return 0xd2f6dc8c;
		case 0x0000a56c:
			return 0xb99d5a7a;
		case 0x0000a570:
			return 0x0155a8b1;
		case 0x0000a574:
			return 0x9ed62ba2;
		case 0x0000a578:
			return 0xfbd225ea;
		case 0x0000a57c:
			return 0x2bddcdf5;
		case 0x0000a580:
			return 0x78d27487;
		case 0x0000a584:
			return 0xe00f2cb2;
		case 0x0000a588:
			return 0x0064b8d5;
		case 0x0000a58c:
			return 0x088cfa8c;
		case 0x0000a590:
			return 0x32b21453;
		case 0x0000a594:
			return 0x6a6cce6c;
		case 0x0000a598:
			return 0xa1702ce7;
		case 0x0000a59c:
			return 0x9810ce04;
		case 0x0000a5a0:
			return 0x45c71734;
		case 0x0000a5a4:
			return 0xb1596d66;
		case 0x0000a5a8:
			return 0x08e49dae;
		case 0x0000a5ac:
			return 0x47217805;
		case 0x0000a5b0:
			return 0x3542d888;
		case 0x0000a5b4:
			return 0xa840c11b;
		case 0x0000a5b8:
			return 0x2268d9a8;
		case 0x0000a5bc:
			return 0x9fee8972;
		case 0x0000a5c0:
			return 0x244c7a4b;
		case 0x0000a5c4:
			return 0xc52833b4;
		case 0x0000a5c8:
			return 0xa7593600;
		case 0x0000a5cc:
			return 0x2a0813b8;
		case 0x0000a5d0:
			return 0x017c8ac8;
		case 0x0000a5d4:
			return 0xe5716985;
		case 0x0000a5d8:
			return 0x8c484400;
		case 0x0000a5dc:
			return 0xda30717d;
		case 0x0000a5e0:
			return 0x9f31f908;
		case 0x0000a5e4:
			return 0x3eb893bb;
		case 0x0000a5e8:
			return 0x2061dc9a;
		case 0x0000a5ec:
			return 0xf59d9b86;
		case 0x0000a5f0:
			return 0xeda70472;
		case 0x0000a5f4:
			return 0x01905703;
		case 0x0000a5f8:
			return 0xc4446296;
		case 0x0000a5fc:
			return 0xa5cf06ff;
		case 0x0000a600:
			return 0x78afd514;
		case 0x0000a604:
			return 0x2197b23a;
		case 0x0000a608:
			return 0xd25a45eb;
		case 0x0000a60c:
			return 0x43e400b7;
		case 0x0000a610:
			return 0x9026b81c;
		case 0x0000a614:
			return 0xcd7ebaa1;
		case 0x0000a618:
			return 0xb101a2b1;
		case 0x0000a61c:
			return 0xb29b0108;
		case 0x0000a620:
			return 0xa130c0ac;
		case 0x0000a624:
			return 0x28542611;
		case 0x0000a628:
			return 0x1ab63e3f;
		case 0x0000a62c:
			return 0x5dfa7cc5;
		case 0x0000a630:
			return 0x3168090c;
		case 0x0000a634:
			return 0xbd5487d4;
		case 0x0000a638:
			return 0x28f68f7f;
		case 0x0000a63c:
			return 0xee59b20f;
		case 0x0000a640:
			return 0x6743491a;
		case 0x0000a644:
			return 0x50d3d529;
		case 0x0000a648:
			return 0x4bdcfab7;
		case 0x0000a64c:
			return 0x7a7053b0;
		case 0x0000a650:
			return 0xf24eab02;
		case 0x0000a654:
			return 0x9ef0da81;
		case 0x0000a658:
			return 0x9a822c22;
		case 0x0000a65c:
			return 0x385f627c;
		case 0x0000a660:
			return 0x9aae65b3;
		case 0x0000a664:
			return 0xe46d45c1;
		case 0x0000a668:
			return 0x383c604d;
		case 0x0000a66c:
			return 0x4c24a398;
		case 0x0000a670:
			return 0xf17adfa7;
		case 0x0000a674:
			return 0x5d7d5305;
		case 0x0000a678:
			return 0x8c6e1620;
		case 0x0000a67c:
			return 0x8ca24426;
		case 0x0000a680:
			return 0x9b6abf2c;
		case 0x0000a684:
			return 0x41cb2130;
		case 0x0000a688:
			return 0xeb800fa4;
		case 0x0000a68c:
			return 0x58e98829;
		case 0x0000a690:
			return 0xc7c4ee61;
		case 0x0000a694:
			return 0xb2a2e465;
		case 0x0000a698:
			return 0x881d9a67;
		case 0x0000a69c:
			return 0x302b6344;
		case 0x0000a6a0:
			return 0x27d677b4;
		case 0x0000a6a4:
			return 0xa417843a;
		case 0x0000a6a8:
			return 0xb7874a42;
		case 0x0000a6ac:
			return 0x6b0a03d5;
		case 0x0000a6b0:
			return 0xaa564307;
		case 0x0000a6b4:
			return 0xbaf69555;
		case 0x0000a6b8:
			return 0xe5f043bf;
		case 0x0000a6bc:
			return 0xc3bb0ac4;
		case 0x0000a6c0:
			return 0x7596c50c;
		case 0x0000a6c4:
			return 0xaadc6bd2;
		case 0x0000a6c8:
			return 0x873ac962;
		case 0x0000a6cc:
			return 0xbf4a54f0;
		case 0x0000a6d0:
			return 0xd7a8423e;
		case 0x0000a6d4:
			return 0x3c16e263;
		case 0x0000a6d8:
			return 0x41448449;
		case 0x0000a6dc:
			return 0x2b9ccd64;
		case 0x0000a6e0:
			return 0x255394d8;
		case 0x0000a6e4:
			return 0x379f7355;
		case 0x0000a6e8:
			return 0x43320854;
		case 0x0000a6ec:
			return 0x370540de;
		case 0x0000a6f0:
			return 0x81affed7;
		case 0x0000a6f4:
			return 0xcd437d73;
		case 0x0000a6f8:
			return 0x3f5c6272;
		case 0x0000a6fc:
			return 0x3275b6b1;
		case 0x0000a700:
			return 0xa8c26c99;
		case 0x0000a704:
			return 0xd1fc3e18;
		case 0x0000a708:
			return 0xceead528;
		case 0x0000a70c:
			return 0x0279342f;
		case 0x0000a710:
			return 0xf437f2c0;
		case 0x0000a714:
			return 0x6b011a50;
		case 0x0000a718:
			return 0x553bdb21;
		case 0x0000a71c:
			return 0xa0876e32;
		case 0x0000a720:
			return 0x5b9f1420;
		case 0x0000a724:
			return 0xa207b759;
		case 0x0000a728:
			return 0x0ac1bed4;
		case 0x0000a72c:
			return 0x21afa95b;
		case 0x0000a730:
			return 0xef2957db;
		case 0x0000a734:
			return 0x4b2cad9e;
		case 0x0000a738:
			return 0x46d8eda3;
		case 0x0000a73c:
			return 0x2b9bfe09;
		case 0x0000a740:
			return 0xa152f628;
		case 0x0000a744:
			return 0x1a53995d;
		case 0x0000a748:
			return 0x709eeabf;
		case 0x0000a74c:
			return 0xedf98f79;
		case 0x0000a750:
			return 0xea344d90;
		case 0x0000a754:
			return 0x6621b2df;
		case 0x0000a758:
			return 0x6a5cb080;
		case 0x0000a75c:
			return 0x88cba780;
		case 0x0000a760:
			return 0xbb61649a;
		case 0x0000a764:
			return 0xddf5e7d4;
		case 0x0000a768:
			return 0x4ead4633;
		case 0x0000a76c:
			return 0x2e7cfff1;
		case 0x0000a770:
			return 0x3f22f79b;
		case 0x0000a774:
			return 0x1c480959;
		case 0x0000a778:
			return 0x86112ad5;
		case 0x0000a77c:
			return 0x567a8859;
		case 0x0000a780:
			return 0xfa497b60;
		case 0x0000a784:
			return 0xaf261c1d;
		case 0x0000a788:
			return 0x1c0e04a3;
		case 0x0000a78c:
			return 0x3d694779;
		case 0x0000a790:
			return 0x67f0eb8e;
		case 0x0000a794:
			return 0x35ec8f35;
		case 0x0000a798:
			return 0x92734352;
		case 0x0000a79c:
			return 0x0faeb042;
		case 0x0000a7a0:
			return 0x4eee4c1b;
		case 0x0000a7a4:
			return 0x240ffc7c;
		case 0x0000a7a8:
			return 0x32c170f3;
		case 0x0000a7ac:
			return 0x0b448cc3;
		case 0x0000a7b0:
			return 0xfb39dd8d;
		case 0x0000a7b4:
			return 0x625db895;
		case 0x0000a7b8:
			return 0x332991f7;
		case 0x0000a7bc:
			return 0xa32d4569;
		case 0x0000a7c0:
			return 0x0f09c8b2;
		case 0x0000a7c4:
			return 0x5c18ff2a;
		case 0x0000a7c8:
			return 0xd5928fa9;
		case 0x0000a7cc:
			return 0x3a50bb0a;
		case 0x0000a7d0:
			return 0x290f8b17;
		case 0x0000a7d4:
			return 0x310ae439;
		case 0x0000a7d8:
			return 0x78a77228;
		case 0x0000a7dc:
			return 0x94be422b;
		case 0x0000a7e0:
			return 0xc9903a3d;
		case 0x0000a7e4:
			return 0x29fa8cbd;
		case 0x0000a7e8:
			return 0xb9cf3d48;
		case 0x0000a7ec:
			return 0x38037eed;
		case 0x0000a7f0:
			return 0x30ed2e09;
		case 0x0000a7f4:
			return 0x9c42cb4e;
		case 0x0000a7f8:
			return 0xf3fccb68;
		case 0x0000a7fc:
			return 0xab155b34;
		case 0x0000a800:
			return 0xde27c9ae;
		case 0x0000a804:
			return 0xe9d4955f;
		case 0x0000a808:
			return 0xb5e9671c;
		case 0x0000a80c:
			return 0xee18bb85;
		case 0x0000a810:
			return 0x7337bf6a;
		case 0x0000a814:
			return 0x1ba8dac7;
		case 0x0000a818:
			return 0x0708dbf1;
		case 0x0000a81c:
			return 0xcb3ac309;
		case 0x0000a820:
			return 0xc4d2c7b2;
		case 0x0000a824:
			return 0x1b2e8431;
		case 0x0000a828:
			return 0x805bbc2b;
		case 0x0000a82c:
			return 0x0d74db29;
		case 0x0000a830:
			return 0x276c638e;
		case 0x0000a834:
			return 0x84193001;
		case 0x0000a838:
			return 0xab20b0d5;
		case 0x0000a83c:
			return 0xb7e5396b;
		case 0x0000a840:
			return 0x3a290fb4;
		case 0x0000a844:
			return 0x9e0a18f7;
		case 0x0000a848:
			return 0x879b7f68;
		case 0x0000a84c:
			return 0xf26174e0;
		case 0x0000a850:
			return 0x719029c4;
		case 0x0000a854:
			return 0x8414aa93;
		case 0x0000a858:
			return 0xffd3afbc;
		case 0x0000a85c:
			return 0x37ab7eb1;
		case 0x0000a860:
			return 0x8bb4a6b5;
		case 0x0000a864:
			return 0x424639fb;
		case 0x0000a868:
			return 0x3f214426;
		case 0x0000a86c:
			return 0x761e111d;
		case 0x0000a870:
			return 0x5d698de8;
		case 0x0000a874:
			return 0xf023dc14;
		case 0x0000a878:
			return 0x65bf7e02;
		case 0x0000a87c:
			return 0x6e5e63af;
		case 0x0000a880:
			return 0xd821f9c7;
		case 0x0000a884:
			return 0x3f7fc1c5;
		case 0x0000a888:
			return 0x81f12b4a;
		case 0x0000a88c:
			return 0x6fd9a84e;
		case 0x0000a890:
			return 0x7f156011;
		case 0x0000a894:
			return 0xa1afd659;
		case 0x0000a898:
			return 0xceac56f6;
		case 0x0000a89c:
			return 0x7fa17037;
		case 0x0000a8a0:
			return 0x75afde68;
		case 0x0000a8a4:
			return 0xde9f8ad3;
		case 0x0000a8a8:
			return 0xcf7fad33;
		case 0x0000a8ac:
			return 0xbd5f9c65;
		case 0x0000a8b0:
			return 0x0b4a5a33;
		case 0x0000a8b4:
			return 0x06d85bd3;
		case 0x0000a8b8:
			return 0x2fb3f42f;
		case 0x0000a8bc:
			return 0x63d025ef;
		case 0x0000a8c0:
			return 0xafee49b4;
		case 0x0000a8c4:
			return 0x6b9b333c;
		case 0x0000a8c8:
			return 0xc08556ee;
		case 0x0000a8cc:
			return 0x2d88877c;
		case 0x0000a8d0:
			return 0xb1c425dd;
		case 0x0000a8d4:
			return 0xcec179b7;
		case 0x0000a8d8:
			return 0x83499006;
		case 0x0000a8dc:
			return 0xfcede918;
		case 0x0000a8e0:
			return 0x35f6400a;
		case 0x0000a8e4:
			return 0x219b74df;
		case 0x0000a8e8:
			return 0x8f1d0e66;
		case 0x0000a8ec:
			return 0x4b6f05ec;
		case 0x0000a8f0:
			return 0x31726961;
		case 0x0000a8f4:
			return 0xb3564094;
		case 0x0000a8f8:
			return 0x410e7376;
		case 0x0000a8fc:
			return 0xf12299c1;
		case 0x0000a900:
			return 0x21692111;
		case 0x0000a904:
			return 0x3fc2549c;
		case 0x0000a908:
			return 0x5ef5d978;
		case 0x0000a90c:
			return 0xbca2980a;
		case 0x0000a910:
			return 0x8633bb03;
		case 0x0000a914:
			return 0xb77b8a77;
		case 0x0000a918:
			return 0x0a2af428;
		case 0x0000a91c:
			return 0x970ffc75;
		case 0x0000a920:
			return 0x16603eed;
		case 0x0000a924:
			return 0xe2180d4a;
		case 0x0000a928:
			return 0x9de5965b;
		case 0x0000a92c:
			return 0x82a98ed9;
		case 0x0000a930:
			return 0x258cfb9f;
		case 0x0000a934:
			return 0x76837093;
		case 0x0000a938:
			return 0xa02edd9a;
		case 0x0000a93c:
			return 0x676ba146;
		case 0x0000a940:
			return 0xc4d3f8c3;
		case 0x0000a944:
			return 0xa99b3e0a;
		case 0x0000a948:
			return 0x59a51977;
		case 0x0000a94c:
			return 0xe237da50;
		case 0x0000a950:
			return 0x53279356;
		case 0x0000a954:
			return 0x260a7051;
		case 0x0000a958:
			return 0xdb669431;
		case 0x0000a95c:
			return 0x2e41a1cd;
		case 0x0000a960:
			return 0xd7fd5f56;
		case 0x0000a964:
			return 0x4e02ab80;
		case 0x0000a968:
			return 0xec4f0a11;
		case 0x0000a96c:
			return 0xea933514;
		case 0x0000a970:
			return 0x6f7481b4;
		case 0x0000a974:
			return 0x8ebcfdd9;
		case 0x0000a978:
			return 0xc5fd3f8e;
		case 0x0000a97c:
			return 0x6fa902e6;
		case 0x0000a980:
			return 0xff8ca0e0;
		case 0x0000a984:
			return 0xd7cd7b8c;
		case 0x0000a988:
			return 0x48cb35a4;
		case 0x0000a98c:
			return 0x6f2cecc2;
		case 0x0000a990:
			return 0x046ba9b9;
		case 0x0000a994:
			return 0x5f510d59;
		case 0x0000a998:
			return 0xdd3c1ba0;
		case 0x0000a99c:
			return 0xcd595f97;
		case 0x0000a9a0:
			return 0x5e707acb;
		case 0x0000a9a4:
			return 0x30815e6f;
		case 0x0000a9a8:
			return 0x0a125429;
		case 0x0000a9ac:
			return 0x7bf94593;
		case 0x0000a9b0:
			return 0xde3c351b;
		case 0x0000a9b4:
			return 0x9ff63a6f;
		case 0x0000a9b8:
			return 0xd80fb5f0;
		case 0x0000a9bc:
			return 0x1b9e2467;
		case 0x0000a9c0:
			return 0x9dfc4f6d;
		case 0x0000a9c4:
			return 0xa7aa0134;
		case 0x0000a9c8:
			return 0x3451f371;
		case 0x0000a9cc:
			return 0xf543132a;
		case 0x0000a9d0:
			return 0xb630b535;
		case 0x0000a9d4:
			return 0x24d340e0;
		case 0x0000a9d8:
			return 0xa99655e0;
		case 0x0000a9dc:
			return 0xac9471b7;
		case 0x0000a9e0:
			return 0x8d0f435c;
		case 0x0000a9e4:
			return 0x1c253948;
		case 0x0000a9e8:
			return 0x732b06b0;
		case 0x0000a9ec:
			return 0xec0ac5b2;
		case 0x0000a9f0:
			return 0x6c35e053;
		case 0x0000a9f4:
			return 0x0d96c49a;
		case 0x0000a9f8:
			return 0x879f5982;
		case 0x0000a9fc:
			return 0xb368d56d;
		case 0x0000aa00:
			return 0x1ce93c3d;
		case 0x0000aa04:
			return 0xc0bc7316;
		case 0x0000aa08:
			return 0xc15a3f00;
		case 0x0000aa0c:
			return 0x94e80462;
		case 0x0000aa10:
			return 0x3a523701;
		case 0x0000aa14:
			return 0xf85abfd0;
		case 0x0000aa18:
			return 0xfeee857d;
		case 0x0000aa1c:
			return 0x5abf6c93;
		case 0x0000aa20:
			return 0x843a8643;
		case 0x0000aa24:
			return 0xa91724b8;
		case 0x0000aa28:
			return 0x09d0f192;
		case 0x0000aa2c:
			return 0x711a022c;
		case 0x0000aa30:
			return 0x582f4989;
		case 0x0000aa34:
			return 0x019eb3f2;
		case 0x0000aa38:
			return 0x3ccae04f;
		case 0x0000aa3c:
			return 0x24d2deb1;
		case 0x0000aa40:
			return 0x0f1a1565;
		case 0x0000aa44:
			return 0xfd21b454;
		case 0x0000aa48:
			return 0x14d185d5;
		case 0x0000aa4c:
			return 0xfa81f8d3;
		case 0x0000aa50:
			return 0x72a8ac6e;
		case 0x0000aa54:
			return 0x45468b9a;
		case 0x0000aa58:
			return 0x2d022532;
		case 0x0000aa5c:
			return 0x458c6264;
		case 0x0000aa60:
			return 0x1fb6b87c;
		case 0x0000aa64:
			return 0xa91f155a;
		case 0x0000aa68:
			return 0xa2977619;
		case 0x0000aa6c:
			return 0x1c92e8a8;
		case 0x0000aa70:
			return 0xf8b20403;
		case 0x0000aa74:
			return 0x9130856f;
		case 0x0000aa78:
			return 0x175567ad;
		case 0x0000aa7c:
			return 0x4f474be9;
		case 0x0000aa80:
			return 0x6980715f;
		case 0x0000aa84:
			return 0xd8524df7;
		case 0x0000aa88:
			return 0x0c134c8f;
		case 0x0000aa8c:
			return 0xbdc2e937;
		case 0x0000aa90:
			return 0x1274ad44;
		case 0x0000aa94:
			return 0xb272df66;
		case 0x0000aa98:
			return 0xe0f4ed46;
		case 0x0000aa9c:
			return 0xfa261fba;
		case 0x0000aaa0:
			return 0x4e10c308;
		case 0x0000aaa4:
			return 0xc63ba5b2;
		case 0x0000aaa8:
			return 0xb8dfe46f;
		case 0x0000aaac:
			return 0x26e668e4;
		case 0x0000aab0:
			return 0x60970250;
		case 0x0000aab4:
			return 0x8cc40050;
		case 0x0000aab8:
			return 0x3c4cecf9;
		case 0x0000aabc:
			return 0xdac1c7cc;
		case 0x0000aac0:
			return 0x02d7d6cd;
		case 0x0000aac4:
			return 0x0cc06128;
		case 0x0000aac8:
			return 0x8fa1396f;
		case 0x0000aacc:
			return 0x3012d81c;
		case 0x0000aad0:
			return 0x63015dda;
		case 0x0000aad4:
			return 0x8254db40;
		case 0x0000aad8:
			return 0xfb40d930;
		case 0x0000aadc:
			return 0xe2902f60;
		case 0x0000aae0:
			return 0x55b69c30;
		case 0x0000aae4:
			return 0x7c0aaac5;
		case 0x0000aae8:
			return 0x61185e2d;
		case 0x0000aaec:
			return 0x873092e8;
		case 0x0000aaf0:
			return 0x56e53541;
		case 0x0000aaf4:
			return 0x27604293;
		case 0x0000aaf8:
			return 0x3c7fbacb;
		case 0x0000aafc:
			return 0x7aadeefd;
		case 0x0000ab00:
			return 0xcb708c67;
		case 0x0000ab04:
			return 0x4126c960;
		case 0x0000ab08:
			return 0x3f617797;
		case 0x0000ab0c:
			return 0x7f971733;
		case 0x0000ab10:
			return 0x369111b7;
		case 0x0000ab14:
			return 0x037522a3;
		case 0x0000ab18:
			return 0xa282a818;
		case 0x0000ab1c:
			return 0xf075b7be;
		case 0x0000ab20:
			return 0xdc6be1aa;
		case 0x0000ab24:
			return 0x1232c872;
		case 0x0000ab28:
			return 0x4954bf64;
		case 0x0000ab2c:
			return 0x33e92f3e;
		case 0x0000ab30:
			return 0xab914c58;
		case 0x0000ab34:
			return 0xf15a60f4;
		case 0x0000ab38:
			return 0xcf703fa3;
		case 0x0000ab3c:
			return 0x22a3a328;
		case 0x0000ab40:
			return 0x08eff904;
		case 0x0000ab44:
			return 0xcb0ef234;
		case 0x0000ab48:
			return 0x08946641;
		case 0x0000ab4c:
			return 0x6ed2c73c;
		case 0x0000ab50:
			return 0x3b2afb38;
		case 0x0000ab54:
			return 0x1feb54b1;
		case 0x0000ab58:
			return 0x85842dde;
		case 0x0000ab5c:
			return 0xd76e5ba9;
		case 0x0000ab60:
			return 0xf871fbdd;
		case 0x0000ab64:
			return 0xc87b8afe;
		case 0x0000ab68:
			return 0x95f06b23;
		case 0x0000ab6c:
			return 0x03639402;
		case 0x0000ab70:
			return 0x955e9512;
		case 0x0000ab74:
			return 0xee5badc1;
		case 0x0000ab78:
			return 0xe01de997;
		case 0x0000ab7c:
			return 0x91093019;
		case 0x0000ab80:
			return 0x4d7b9c4c;
		case 0x0000ab84:
			return 0xd582c7ce;
		case 0x0000ab88:
			return 0xb7d821e2;
		case 0x0000ab8c:
			return 0x0682badd;
		case 0x0000ab90:
			return 0x29ca71e9;
		case 0x0000ab94:
			return 0xb7306e60;
		case 0x0000ab98:
			return 0xc517e8f2;
		case 0x0000ab9c:
			return 0x56fb2c28;
		case 0x0000aba0:
			return 0x19049a55;
		case 0x0000aba4:
			return 0xe2109194;
		case 0x0000aba8:
			return 0xa1c77e35;
		case 0x0000abac:
			return 0x2e144bbf;
		case 0x0000abb0:
			return 0x0b4305c8;
		case 0x0000abb4:
			return 0x66572d67;
		case 0x0000abb8:
			return 0xd05bc784;
		case 0x0000abbc:
			return 0x9504b44c;
		case 0x0000abc0:
			return 0x94b3a0f6;
		case 0x0000abc4:
			return 0x4925ab33;
		case 0x0000abc8:
			return 0xb8c2a0cc;
		case 0x0000abcc:
			return 0x7d9a3d11;
		case 0x0000abd0:
			return 0x0e9dfb6f;
		case 0x0000abd4:
			return 0x7ae1bd33;
		case 0x0000abd8:
			return 0x7cb6855b;
		case 0x0000abdc:
			return 0x03a2d174;
		case 0x0000abe0:
			return 0x91e85a9a;
		case 0x0000abe4:
			return 0xc1948641;
		case 0x0000abe8:
			return 0x327c93bf;
		case 0x0000abec:
			return 0xb1c4cd10;
		case 0x0000abf0:
			return 0x0f8bf91f;
		case 0x0000abf4:
			return 0x2564f176;
		case 0x0000abf8:
			return 0x01367d3d;
		case 0x0000abfc:
			return 0x645ed0f1;
		case 0x0000ac00:
			return 0x110f1827;
		case 0x0000ac04:
			return 0xcf098694;
		case 0x0000ac08:
			return 0x94b5d5b8;
		case 0x0000ac0c:
			return 0xa2aca7ca;
		case 0x0000ac10:
			return 0x59da0b78;
		case 0x0000ac14:
			return 0x36bd9f1d;
		case 0x0000ac18:
			return 0x3040f188;
		case 0x0000ac1c:
			return 0x7db7b488;
		case 0x0000ac20:
			return 0x7973a4de;
		case 0x0000ac24:
			return 0xf75b31fa;
		case 0x0000ac28:
			return 0x25aa0178;
		case 0x0000ac2c:
			return 0xc2416292;
		case 0x0000ac30:
			return 0x37e9bcb2;
		case 0x0000ac34:
			return 0x7b8eb91b;
		case 0x0000ac38:
			return 0x75f51b2b;
		case 0x0000ac3c:
			return 0x76b7de00;
		case 0x0000ac40:
			return 0x12a1948e;
		case 0x0000ac44:
			return 0x4f590d04;
		case 0x0000ac48:
			return 0xbf79dd29;
		case 0x0000ac4c:
			return 0x02c11f57;
		case 0x0000ac50:
			return 0x4dd21fe2;
		case 0x0000ac54:
			return 0x5ef9a544;
		case 0x0000ac58:
			return 0xef36a014;
		case 0x0000ac5c:
			return 0x5510268f;
		case 0x0000ac60:
			return 0x304be38a;
		case 0x0000ac64:
			return 0x794fdc19;
		case 0x0000ac68:
			return 0xfd338ef9;
		case 0x0000ac6c:
			return 0x6d9a72a8;
		case 0x0000ac70:
			return 0x5fdcfaa0;
		case 0x0000ac74:
			return 0xefd3d8c8;
		case 0x0000ac78:
			return 0x89d00a1c;
		case 0x0000ac7c:
			return 0xd4e847b5;
		case 0x0000ac80:
			return 0xdf735bae;
		case 0x0000ac84:
			return 0x909ec947;
		case 0x0000ac88:
			return 0xdd652f0f;
		case 0x0000ac8c:
			return 0x8918be00;
		case 0x0000ac90:
			return 0x177b8e56;
		case 0x0000ac94:
			return 0x9c04a157;
		case 0x0000ac98:
			return 0xf2f0aeaf;
		case 0x0000ac9c:
			return 0x536ef870;
		case 0x0000aca0:
			return 0x97b79f10;
		case 0x0000aca4:
			return 0x03175ee0;
		case 0x0000aca8:
			return 0xbde0cdc4;
		case 0x0000acac:
			return 0x553a9c5d;
		case 0x0000acb0:
			return 0x6ac88110;
		case 0x0000acb4:
			return 0x5f900596;
		case 0x0000acb8:
			return 0xd75b9380;
		case 0x0000acbc:
			return 0x815ad196;
		case 0x0000acc0:
			return 0x9fb7e8ac;
		case 0x0000acc4:
			return 0xa73265ec;
		case 0x0000acc8:
			return 0x9504b4ca;
		case 0x0000accc:
			return 0xd6cccf21;
		case 0x0000acd0:
			return 0x79703944;
		case 0x0000acd4:
			return 0xafaff1c0;
		case 0x0000acd8:
			return 0x83c2bebd;
		case 0x0000acdc:
			return 0x9440592e;
		case 0x0000ace0:
			return 0xf83ae0cf;
		case 0x0000ace4:
			return 0x474ecb3f;
		case 0x0000ace8:
			return 0x22f94d7d;
		case 0x0000acec:
			return 0xfc676822;
		case 0x0000acf0:
			return 0xee7eb64b;
		case 0x0000acf4:
			return 0x9772f8dc;
		case 0x0000acf8:
			return 0x61e97766;
		case 0x0000acfc:
			return 0xd8a02a5a;
		case 0x0000ad00:
			return 0x51eef7dc;
		case 0x0000ad04:
			return 0x237bcf53;
		case 0x0000ad08:
			return 0x6355a123;
		case 0x0000ad0c:
			return 0x3d3724b0;
		case 0x0000ad10:
			return 0x8b241d73;
		case 0x0000ad14:
			return 0x24ded24b;
		case 0x0000ad18:
			return 0x41c77562;
		case 0x0000ad1c:
			return 0xf8738a52;
		case 0x0000ad20:
			return 0x5dc4c645;
		case 0x0000ad24:
			return 0x8580870c;
		case 0x0000ad28:
			return 0x83176bb7;
		case 0x0000ad2c:
			return 0x26b54914;
		case 0x0000ad30:
			return 0x7e55b69c;
		case 0x0000ad34:
			return 0x925fb71b;
		case 0x0000ad38:
			return 0x45c314ea;
		case 0x0000ad3c:
			return 0x5c5abc5a;
		case 0x0000ad40:
			return 0xf013ba24;
		case 0x0000ad44:
			return 0xb4e551f2;
		case 0x0000ad48:
			return 0xf39f158f;
		case 0x0000ad4c:
			return 0x30382147;
		case 0x0000ad50:
			return 0xb3436a08;
		case 0x0000ad54:
			return 0x1ee9744e;
		case 0x0000ad58:
			return 0xa24e21e6;
		case 0x0000ad5c:
			return 0xc44220d7;
		case 0x0000ad60:
			return 0xb228639f;
		case 0x0000ad64:
			return 0x259cf08c;
		case 0x0000ad68:
			return 0xcef30609;
		case 0x0000ad6c:
			return 0x1529bfc1;
		case 0x0000ad70:
			return 0xabdb630d;
		case 0x0000ad74:
			return 0x77d021e8;
		case 0x0000ad78:
			return 0xeaf687e3;
		case 0x0000ad7c:
			return 0x57b04d75;
		case 0x0000ad80:
			return 0xef85165a;
		case 0x0000ad84:
			return 0xa5709c52;
		case 0x0000ad88:
			return 0x65bfac81;
		case 0x0000ad8c:
			return 0xdd81d8b2;
		case 0x0000ad90:
			return 0xd532d18a;
		case 0x0000ad94:
			return 0xdd4ef6f3;
		case 0x0000ad98:
			return 0x0e56b54e;
		case 0x0000ad9c:
			return 0x71fdea35;
		case 0x0000ada0:
			return 0x92d30771;
		case 0x0000ada4:
			return 0x52f63aff;
		case 0x0000ada8:
			return 0xf010c050;
		case 0x0000adac:
			return 0x44c48456;
		case 0x0000adb0:
			return 0x44bb492c;
		case 0x0000adb4:
			return 0xb056aee2;
		case 0x0000adb8:
			return 0x3d2adb4e;
		case 0x0000adbc:
			return 0xd5a55302;
		case 0x0000adc0:
			return 0x29cde3fd;
		case 0x0000adc4:
			return 0x2dc1b281;
		case 0x0000adc8:
			return 0x84e33795;
		case 0x0000adcc:
			return 0x7ec4038f;
		case 0x0000add0:
			return 0x50e2ac7f;
		case 0x0000add4:
			return 0x1dbee6b1;
		case 0x0000add8:
			return 0x8368af6f;
		case 0x0000addc:
			return 0x16901703;
		case 0x0000ade0:
			return 0xb3bd0eca;
		case 0x0000ade4:
			return 0x3d2bf1d5;
		case 0x0000ade8:
			return 0x0cf7ee3c;
		case 0x0000adec:
			return 0x5a571c66;
		case 0x0000adf0:
			return 0xcfd4b05c;
		case 0x0000adf4:
			return 0x711d7ecc;
		case 0x0000adf8:
			return 0x0d12bf27;
		case 0x0000adfc:
			return 0x72b2d7e5;
		case 0x0000ae00:
			return 0xe6972698;
		case 0x0000ae04:
			return 0xf0bc55d5;
		case 0x0000ae08:
			return 0xb35d6dc2;
		case 0x0000ae0c:
			return 0x8bc6d98b;
		case 0x0000ae10:
			return 0xd445502a;
		case 0x0000ae14:
			return 0x8124c14d;
		case 0x0000ae18:
			return 0xc0d56fa8;
		case 0x0000ae1c:
			return 0x012fc256;
		case 0x0000ae20:
			return 0x48449573;
		case 0x0000ae24:
			return 0x012a4eba;
		case 0x0000ae28:
			return 0x79d8ca88;
		case 0x0000ae2c:
			return 0x42817fb0;
		case 0x0000ae30:
			return 0x372c7e64;
		case 0x0000ae34:
			return 0x42285c52;
		case 0x0000ae38:
			return 0x0184681b;
		case 0x0000ae3c:
			return 0x8a4cffac;
		case 0x0000ae40:
			return 0x46cfbcf5;
		case 0x0000ae44:
			return 0x002ae833;
		case 0x0000ae48:
			return 0x2be4e0c8;
		case 0x0000ae4c:
			return 0xe6a9b256;
		case 0x0000ae50:
			return 0x397af83e;
		case 0x0000ae54:
			return 0x1a7420d4;
		case 0x0000ae58:
			return 0x638bda7b;
		case 0x0000ae5c:
			return 0x6f8b66db;
		case 0x0000ae60:
			return 0x76b197de;
		case 0x0000ae64:
			return 0xa663d16d;
		case 0x0000ae68:
			return 0x28e5b331;
		case 0x0000ae6c:
			return 0x7849b6e2;
		case 0x0000ae70:
			return 0xa9dc8b7e;
		case 0x0000ae74:
			return 0x34be9b63;
		case 0x0000ae78:
			return 0x3098680b;
		case 0x0000ae7c:
			return 0x63c2739b;
		case 0x0000ae80:
			return 0xad2cc157;
		case 0x0000ae84:
			return 0x9bacc06b;
		case 0x0000ae88:
			return 0xf27e6103;
		case 0x0000ae8c:
			return 0xb5f4b24e;
		case 0x0000ae90:
			return 0x852590ad;
		case 0x0000ae94:
			return 0x5a90344d;
		case 0x0000ae98:
			return 0xb5910e7f;
		case 0x0000ae9c:
			return 0xde8eefe6;
		case 0x0000aea0:
			return 0x0b2fd94d;
		case 0x0000aea4:
			return 0x08d972be;
		case 0x0000aea8:
			return 0x3cc06b7d;
		case 0x0000aeac:
			return 0xc461e687;
		case 0x0000aeb0:
			return 0xd09a3cca;
		case 0x0000aeb4:
			return 0x7a77b796;
		case 0x0000aeb8:
			return 0x333e5d9d;
		case 0x0000aebc:
			return 0xba3da8ae;
		case 0x0000aec0:
			return 0xe63f3f1f;
		case 0x0000aec4:
			return 0x789f88d5;
		case 0x0000aec8:
			return 0x7cce8dd1;
		case 0x0000aecc:
			return 0xfb678438;
		case 0x0000aed0:
			return 0xf60348be;
		case 0x0000aed4:
			return 0x96eabc37;
		case 0x0000aed8:
			return 0x9be61ed6;
		case 0x0000aedc:
			return 0xb0710077;
		case 0x0000aee0:
			return 0x45cd8957;
		case 0x0000aee4:
			return 0x2082d8b3;
		case 0x0000aee8:
			return 0xd0b2e53f;
		case 0x0000aeec:
			return 0xbe8ad37a;
		case 0x0000aef0:
			return 0x92a7c8ba;
		case 0x0000aef4:
			return 0x9d3369a9;
		case 0x0000aef8:
			return 0x1394a00c;
		case 0x0000aefc:
			return 0x7b30df84;
		case 0x0000af00:
			return 0x814232a6;
		case 0x0000af04:
			return 0x12c34e0e;
		case 0x0000af08:
			return 0x3348ff5c;
		case 0x0000af0c:
			return 0xbe85fdb0;
		case 0x0000af10:
			return 0x301d8b10;
		case 0x0000af14:
			return 0xc84deb61;
		case 0x0000af18:
			return 0xdbf2f979;
		case 0x0000af1c:
			return 0x8c4a095b;
		case 0x0000af20:
			return 0xd496a89d;
		case 0x0000af24:
			return 0xc322251c;
		case 0x0000af28:
			return 0x2c6252b9;
		case 0x0000af2c:
			return 0x8e7bdf1f;
		case 0x0000af30:
			return 0x2cde4f52;
		case 0x0000af34:
			return 0xcfaa7c46;
		case 0x0000af38:
			return 0xd60be9c0;
		case 0x0000af3c:
			return 0xf46d5031;
		case 0x0000af40:
			return 0x66a9b5c9;
		case 0x0000af44:
			return 0xbb40ac64;
		case 0x0000af48:
			return 0x849fbf82;
		case 0x0000af4c:
			return 0x724b3b27;
		case 0x0000af50:
			return 0x713d30fd;
		case 0x0000af54:
			return 0xb44f6a3f;
		case 0x0000af58:
			return 0xbaae1f3e;
		case 0x0000af5c:
			return 0xedc81234;
		case 0x0000af60:
			return 0x8a3893c2;
		case 0x0000af64:
			return 0x4f33ab2b;
		case 0x0000af68:
			return 0x29e5e69a;
		case 0x0000af6c:
			return 0x32257d8d;
		case 0x0000af70:
			return 0x30a73d54;
		case 0x0000af74:
			return 0x4b964acd;
		case 0x0000af78:
			return 0xc16d00b7;
		case 0x0000af7c:
			return 0x156fbc21;
		case 0x0000af80:
			return 0x89a0d04f;
		case 0x0000af84:
			return 0x1b015c18;
		case 0x0000af88:
			return 0xa9726d04;
		case 0x0000af8c:
			return 0x2004609e;
		case 0x0000af90:
			return 0x85eb1abe;
		case 0x0000af94:
			return 0x456a7912;
		case 0x0000af98:
			return 0x1a352034;
		case 0x0000af9c:
			return 0x731e211b;
		case 0x0000afa0:
			return 0x63572e70;
		case 0x0000afa4:
			return 0xcb20c920;
		case 0x0000afa8:
			return 0xd00fb59b;
		case 0x0000afac:
			return 0x8f18721e;
		case 0x0000afb0:
			return 0x48b77b8a;
		case 0x0000afb4:
			return 0x9bdaf8b9;
		case 0x0000afb8:
			return 0x47cc1db1;
		case 0x0000afbc:
			return 0xca402a3a;
		case 0x0000afc0:
			return 0xb8fa5283;
		case 0x0000afc4:
			return 0x2241d9d9;
		case 0x0000afc8:
			return 0x3c3dee9a;
		case 0x0000afcc:
			return 0x954d40be;
		case 0x0000afd0:
			return 0xfd850826;
		case 0x0000afd4:
			return 0x3f096a2e;
		case 0x0000afd8:
			return 0x93aadac1;
		case 0x0000afdc:
			return 0xe41a0cbd;
		case 0x0000afe0:
			return 0xa7a42a84;
		case 0x0000afe4:
			return 0x529631fb;
		case 0x0000afe8:
			return 0x71182806;
		case 0x0000afec:
			return 0x1da05bdf;
		case 0x0000aff0:
			return 0x9765c0ff;
		case 0x0000aff4:
			return 0x892edc53;
		case 0x0000aff8:
			return 0x43023e18;
		case 0x0000affc:
			return 0xd4a88834;
		case 0x0000b000:
			return 0x326b0165;
		case 0x0000b004:
			return 0xb46e9a82;
		case 0x0000b008:
			return 0x8ae65032;
		case 0x0000b00c:
			return 0xadf3e719;
		case 0x0000b010:
			return 0x2ef47567;
		case 0x0000b014:
			return 0x2f887786;
		case 0x0000b018:
			return 0x6a4ccccd;
		case 0x0000b01c:
			return 0x96a41b2e;
		case 0x0000b020:
			return 0x0446cabc;
		case 0x0000b024:
			return 0xe28b659f;
		case 0x0000b028:
			return 0x587c8d64;
		case 0x0000b02c:
			return 0x821c828d;
		case 0x0000b030:
			return 0xaf060408;
		case 0x0000b034:
			return 0x68148d1b;
		case 0x0000b038:
			return 0x9a97dc38;
		case 0x0000b03c:
			return 0xab8de2d8;
		case 0x0000b040:
			return 0x4bb8a254;
		case 0x0000b044:
			return 0x4aecf49d;
		case 0x0000b048:
			return 0x306e1ec0;
		case 0x0000b04c:
			return 0xc9c95336;
		case 0x0000b050:
			return 0x7c86181a;
		case 0x0000b054:
			return 0x8ecf2f7a;
		case 0x0000b058:
			return 0x6aa6e0a4;
		case 0x0000b05c:
			return 0xb779a504;
		case 0x0000b060:
			return 0x4bd98082;
		case 0x0000b064:
			return 0x3db47759;
		case 0x0000b068:
			return 0xa450c8bc;
		case 0x0000b06c:
			return 0x4b40b16b;
		case 0x0000b070:
			return 0xb5f3d0b2;
		case 0x0000b074:
			return 0x5de9830f;
		case 0x0000b078:
			return 0x24d882f5;
		case 0x0000b07c:
			return 0x08288964;
		case 0x0000b080:
			return 0x2017dfaa;
		case 0x0000b084:
			return 0x5fd77efb;
		case 0x0000b088:
			return 0x15427257;
		case 0x0000b08c:
			return 0x8d0e2dbb;
		case 0x0000b090:
			return 0x92944358;
		case 0x0000b094:
			return 0x2471c420;
		case 0x0000b098:
			return 0xb285898d;
		case 0x0000b09c:
			return 0x104c7f70;
		case 0x0000b0a0:
			return 0x8cc2122a;
		case 0x0000b0a4:
			return 0x4805aa13;
		case 0x0000b0a8:
			return 0x28dcdf25;
		case 0x0000b0ac:
			return 0xe19c6516;
		case 0x0000b0b0:
			return 0xbc119912;
		case 0x0000b0b4:
			return 0xdf7fc31f;
		case 0x0000b0b8:
			return 0xb5d73839;
		case 0x0000b0bc:
			return 0x1b083d40;
		case 0x0000b0c0:
			return 0x6d93e14a;
		case 0x0000b0c4:
			return 0xd5c88acb;
		case 0x0000b0c8:
			return 0x0bee7db5;
		case 0x0000b0cc:
			return 0xcdd4ae34;
		case 0x0000b0d0:
			return 0xeef12de3;
		case 0x0000b0d4:
			return 0x0605eae8;
		case 0x0000b0d8:
			return 0x7c973774;
		case 0x0000b0dc:
			return 0xcdf05c16;
		case 0x0000b0e0:
			return 0xb0649fb6;
		case 0x0000b0e4:
			return 0x5471d71b;
		case 0x0000b0e8:
			return 0x7295386c;
		case 0x0000b0ec:
			return 0xcd3332e1;
		case 0x0000b0f0:
			return 0x682dccca;
		case 0x0000b0f4:
			return 0x902563bf;
		case 0x0000b0f8:
			return 0x7be6ecc8;
		case 0x0000b0fc:
			return 0xde01a238;
		case 0x0000b100:
			return 0x2a3aa58c;
		case 0x0000b104:
			return 0x944c6b35;
		case 0x0000b108:
			return 0x6ed963a0;
		case 0x0000b10c:
			return 0x7dcf0279;
		case 0x0000b110:
			return 0x2a5b5794;
		case 0x0000b114:
			return 0xf9fe5aa9;
		case 0x0000b118:
			return 0xc3c70fe3;
		case 0x0000b11c:
			return 0x6c15bc6d;
		case 0x0000b120:
			return 0x5b6ebdea;
		case 0x0000b124:
			return 0x9bfa7020;
		case 0x0000b128:
			return 0x5c6ac469;
		case 0x0000b12c:
			return 0xb3f7cc12;
		case 0x0000b130:
			return 0xd8ccac63;
		case 0x0000b134:
			return 0x3c257831;
		case 0x0000b138:
			return 0xf4deb167;
		case 0x0000b13c:
			return 0x7876e327;
		case 0x0000b140:
			return 0x22839460;
		case 0x0000b144:
			return 0xf0efcb2c;
		case 0x0000b148:
			return 0x225d42a8;
		case 0x0000b14c:
			return 0x1a37b3f3;
		case 0x0000b150:
			return 0xe7fb1d5c;
		case 0x0000b154:
			return 0xb0e33b1b;
		case 0x0000b158:
			return 0xd1b30297;
		case 0x0000b15c:
			return 0x9386b9f0;
		case 0x0000b160:
			return 0x3dca5ade;
		case 0x0000b164:
			return 0x64a812e7;
		case 0x0000b168:
			return 0xb0a89c8f;
		case 0x0000b16c:
			return 0x71426cfc;
		case 0x0000b170:
			return 0x185f3b59;
		case 0x0000b174:
			return 0x9e3fbe25;
		case 0x0000b178:
			return 0xab81b1f0;
		case 0x0000b17c:
			return 0x4c31e1ad;
		case 0x0000b180:
			return 0x880e4e27;
		case 0x0000b184:
			return 0x3376604e;
		case 0x0000b188:
			return 0xd92b1cf1;
		case 0x0000b18c:
			return 0xe9606737;
		case 0x0000b190:
			return 0x5ecaeb84;
		case 0x0000b194:
			return 0xc5125f56;
		case 0x0000b198:
			return 0x2e8adf06;
		case 0x0000b19c:
			return 0xb90597a4;
		case 0x0000b1a0:
			return 0x6fa54d2c;
		case 0x0000b1a4:
			return 0x67880d7a;
		case 0x0000b1a8:
			return 0xa8f1a38e;
		case 0x0000b1ac:
			return 0x603db0c4;
		case 0x0000b1b0:
			return 0x991bfcf5;
		case 0x0000b1b4:
			return 0x2b0b33e2;
		case 0x0000b1b8:
			return 0x3f5d7b51;
		case 0x0000b1bc:
			return 0x0b6eef77;
		case 0x0000b1c0:
			return 0xd2c60509;
		case 0x0000b1c4:
			return 0x2703d14b;
		case 0x0000b1c8:
			return 0x62f70de2;
		case 0x0000b1cc:
			return 0x78a3a3fb;
		case 0x0000b1d0:
			return 0x95029fb5;
		case 0x0000b1d4:
			return 0x7ab45fdd;
		case 0x0000b1d8:
			return 0x6ace80f0;
		case 0x0000b1dc:
			return 0xe73996e9;
		case 0x0000b1e0:
			return 0x30d29e26;
		case 0x0000b1e4:
			return 0x1317df23;
		case 0x0000b1e8:
			return 0x7c143d09;
		case 0x0000b1ec:
			return 0x726dd659;
		case 0x0000b1f0:
			return 0x3bfe52e4;
		case 0x0000b1f4:
			return 0x8c0831da;
		case 0x0000b1f8:
			return 0x014af48a;
		case 0x0000b1fc:
			return 0xce78dadb;
		case 0x0000b200:
			return 0xda8b3410;
		case 0x0000b204:
			return 0x5511fa6f;
		case 0x0000b208:
			return 0xe784bdf5;
		case 0x0000b20c:
			return 0x0958fbc3;
		case 0x0000b210:
			return 0xcec056d7;
		case 0x0000b214:
			return 0xc8738cb3;
		case 0x0000b218:
			return 0x95e062c5;
		case 0x0000b21c:
			return 0xf1de0518;
		case 0x0000b220:
			return 0xb29b4b43;
		case 0x0000b224:
			return 0x02f6ed1e;
		case 0x0000b228:
			return 0x0adf8e90;
		case 0x0000b22c:
			return 0xcb42695f;
		case 0x0000b230:
			return 0xa1f71bda;
		case 0x0000b234:
			return 0xe62e054e;
		case 0x0000b238:
			return 0x72e90ac0;
		case 0x0000b23c:
			return 0x41f20e56;
		case 0x0000b240:
			return 0x3e253c08;
		case 0x0000b244:
			return 0x084e3b01;
		case 0x0000b248:
			return 0x4e4450e8;
		case 0x0000b24c:
			return 0x87209ce4;
		case 0x0000b250:
			return 0x4b3d61c3;
		case 0x0000b254:
			return 0x31b2ebbb;
		case 0x0000b258:
			return 0x5c58530a;
		case 0x0000b25c:
			return 0x5c75108c;
		case 0x0000b260:
			return 0x895626ae;
		case 0x0000b264:
			return 0x9a827e55;
		case 0x0000b268:
			return 0xa8ed7d7b;
		case 0x0000b26c:
			return 0x570f1be3;
		case 0x0000b270:
			return 0x34845405;
		case 0x0000b274:
			return 0x3985ba33;
		case 0x0000b278:
			return 0xc57b4c50;
		case 0x0000b27c:
			return 0xe772e02f;
		case 0x0000b280:
			return 0x4c286ad0;
		case 0x0000b284:
			return 0x166bae29;
		case 0x0000b288:
			return 0x8f774870;
		case 0x0000b28c:
			return 0x8c3ddb5e;
		case 0x0000b290:
			return 0x3b900b69;
		case 0x0000b294:
			return 0x6b93c720;
		case 0x0000b298:
			return 0x9fecf15c;
		case 0x0000b29c:
			return 0x2c73d692;
		case 0x0000b2a0:
			return 0x717c66bd;
		case 0x0000b2a4:
			return 0x28a0509d;
		case 0x0000b2a8:
			return 0xf69a8c49;
		case 0x0000b2ac:
			return 0x5b3f14f2;
		case 0x0000b2b0:
			return 0x1cba8230;
		case 0x0000b2b4:
			return 0xdf6a7048;
		case 0x0000b2b8:
			return 0x01e44eb9;
		case 0x0000b2bc:
			return 0x8b5463d7;
		case 0x0000b2c0:
			return 0x6b80457b;
		case 0x0000b2c4:
			return 0x28945957;
		case 0x0000b2c8:
			return 0x08183342;
		case 0x0000b2cc:
			return 0x0db23ee1;
		case 0x0000b2d0:
			return 0xe6f383bc;
		case 0x0000b2d4:
			return 0xbdb50fc1;
		case 0x0000b2d8:
			return 0x3fb67421;
		case 0x0000b2dc:
			return 0xffc4a003;
		case 0x0000b2e0:
			return 0x11fb0885;
		case 0x0000b2e4:
			return 0x7560c934;
		case 0x0000b2e8:
			return 0x644e0172;
		case 0x0000b2ec:
			return 0xee1cb55d;
		case 0x0000b2f0:
			return 0x54fcc7be;
		case 0x0000b2f4:
			return 0x793887ea;
		case 0x0000b2f8:
			return 0xe10d6800;
		case 0x0000b2fc:
			return 0x0ffd2c90;
		case 0x0000b300:
			return 0x88c9d8fe;
		case 0x0000b304:
			return 0xe8659638;
		case 0x0000b308:
			return 0xf1817e8d;
		case 0x0000b30c:
			return 0x49418db8;
		case 0x0000b310:
			return 0xae5ade19;
		case 0x0000b314:
			return 0x7ac24fa2;
		case 0x0000b318:
			return 0xd53bac1b;
		case 0x0000b31c:
			return 0x1e22335d;
		case 0x0000b320:
			return 0x6ed5e5b4;
		case 0x0000b324:
			return 0xa850cbc4;
		case 0x0000b328:
			return 0xcd28d7ef;
		case 0x0000b32c:
			return 0xae7065d7;
		case 0x0000b330:
			return 0xa4d25ce5;
		case 0x0000b334:
			return 0x78f30286;
		case 0x0000b338:
			return 0x27146d79;
		case 0x0000b33c:
			return 0xc48d52e7;
		case 0x0000b340:
			return 0xe27f280a;
		case 0x0000b344:
			return 0xe256bc03;
		case 0x0000b348:
			return 0xb4a8ae2c;
		case 0x0000b34c:
			return 0x87945825;
		case 0x0000b350:
			return 0x8f5e02eb;
		case 0x0000b354:
			return 0x7b4eb9f5;
		case 0x0000b358:
			return 0x67c182a5;
		case 0x0000b35c:
			return 0xd4596c10;
		case 0x0000b360:
			return 0xdfe4bd9b;
		case 0x0000b364:
			return 0x390ef369;
		case 0x0000b368:
			return 0xc054e4b5;
		case 0x0000b36c:
			return 0x03488e48;
		case 0x0000b370:
			return 0x636fd666;
		case 0x0000b374:
			return 0xb514b93f;
		case 0x0000b378:
			return 0xccd10f9b;
		case 0x0000b37c:
			return 0x2e171b6f;
		case 0x0000b380:
			return 0x6bdc06a2;
		case 0x0000b384:
			return 0xdd7ece97;
		case 0x0000b388:
			return 0x6cb842d4;
		case 0x0000b38c:
			return 0x17be2f65;
		case 0x0000b390:
			return 0x89934d75;
		case 0x0000b394:
			return 0xff4b3183;
		case 0x0000b398:
			return 0xb32f3ef6;
		case 0x0000b39c:
			return 0xd70a3b1d;
		case 0x0000b3a0:
			return 0x0b7fe4dc;
		case 0x0000b3a4:
			return 0x26d3fb39;
		case 0x0000b3a8:
			return 0xf7498613;
		case 0x0000b3ac:
			return 0x219dff4c;
		case 0x0000b3b0:
			return 0xe603d04d;
		case 0x0000b3b4:
			return 0x28b5cacb;
		case 0x0000b3b8:
			return 0x0380cc42;
		case 0x0000b3bc:
			return 0x7ae52f49;
		case 0x0000b3c0:
			return 0x12314484;
		case 0x0000b3c4:
			return 0xc7539bb0;
		case 0x0000b3c8:
			return 0x9b81adcc;
		case 0x0000b3cc:
			return 0xf00f89de;
		case 0x0000b3d0:
			return 0x69059fe7;
		case 0x0000b3d4:
			return 0x4f83a55b;
		case 0x0000b3d8:
			return 0x99ed58aa;
		case 0x0000b3dc:
			return 0xa507d32b;
		case 0x0000b3e0:
			return 0x99ed9e3c;
		case 0x0000b3e4:
			return 0x3ebcfaa4;
		case 0x0000b3e8:
			return 0x7cde5f28;
		case 0x0000b3ec:
			return 0x302367dd;
		case 0x0000b3f0:
			return 0x4b3a26dc;
		case 0x0000b3f4:
			return 0x0ca6e085;
		case 0x0000b3f8:
			return 0xd3e098f9;
		case 0x0000b3fc:
			return 0x2b5e4cfb;
		case 0x0000b400:
			return 0x80f5a6a3;
		case 0x0000b404:
			return 0x92c9d87f;
		case 0x0000b408:
			return 0xf19270bd;
		case 0x0000b40c:
			return 0x800eeb21;
		case 0x0000b410:
			return 0xf3a058c4;
		case 0x0000b414:
			return 0xb0328c6d;
		case 0x0000b418:
			return 0x882c6892;
		case 0x0000b41c:
			return 0x99ab06f4;
		case 0x0000b420:
			return 0xfd3af4c1;
		case 0x0000b424:
			return 0x2bc4c58f;
		case 0x0000b428:
			return 0xb180c893;
		case 0x0000b42c:
			return 0xd6de64b8;
		case 0x0000b430:
			return 0x96db6b61;
		case 0x0000b434:
			return 0x015428a1;
		case 0x0000b438:
			return 0xd7a3ce0e;
		case 0x0000b43c:
			return 0xfc962e76;
		case 0x0000b440:
			return 0xdd67baf9;
		case 0x0000b444:
			return 0x4bf2886b;
		case 0x0000b448:
			return 0x7410b4ba;
		case 0x0000b44c:
			return 0x81cb680c;
		case 0x0000b450:
			return 0x96f635da;
		case 0x0000b454:
			return 0x90aefc52;
		case 0x0000b458:
			return 0xfdeb7e8a;
		case 0x0000b45c:
			return 0x93d778fb;
		case 0x0000b460:
			return 0x6beec559;
		case 0x0000b464:
			return 0xe8281ad8;
		case 0x0000b468:
			return 0x00bf69c5;
		case 0x0000b46c:
			return 0x1cb786d5;
		case 0x0000b470:
			return 0x097c1531;
		case 0x0000b474:
			return 0x8eb88b92;
		case 0x0000b478:
			return 0x4d1d3004;
		case 0x0000b47c:
			return 0xd79ee083;
		case 0x0000b480:
			return 0x32292b8d;
		case 0x0000b484:
			return 0x7f08a3dc;
		case 0x0000b488:
			return 0x312bc4e2;
		case 0x0000b48c:
			return 0xedb5a677;
		case 0x0000b490:
			return 0x6534c97a;
		case 0x0000b494:
			return 0xfafe4ff5;
		case 0x0000b498:
			return 0x28a29f0d;
		case 0x0000b49c:
			return 0x55e5a9b8;
		case 0x0000b4a0:
			return 0xb04bf232;
		case 0x0000b4a4:
			return 0x5561cc6d;
		case 0x0000b4a8:
			return 0x53e74f91;
		case 0x0000b4ac:
			return 0x5c5bcfac;
		case 0x0000b4b0:
			return 0x9155fcc1;
		case 0x0000b4b4:
			return 0x23fac3df;
		case 0x0000b4b8:
			return 0xb51b506a;
		case 0x0000b4bc:
			return 0xc2f65bae;
		case 0x0000b4c0:
			return 0x0f724246;
		case 0x0000b4c4:
			return 0x85bb00ed;
		case 0x0000b4c8:
			return 0x0ac29c8a;
		case 0x0000b4cc:
			return 0xe1600bbe;
		case 0x0000b4d0:
			return 0x0eb68aba;
		case 0x0000b4d4:
			return 0x620af894;
		case 0x0000b4d8:
			return 0xe2383a8d;
		case 0x0000b4dc:
			return 0xfd966bd9;
		case 0x0000b4e0:
			return 0x3a544169;
		case 0x0000b4e4:
			return 0x96961864;
		case 0x0000b4e8:
			return 0xddb06ef5;
		case 0x0000b4ec:
			return 0x107f06f5;
		case 0x0000b4f0:
			return 0x749534d9;
		case 0x0000b4f4:
			return 0x2c017d4b;
		case 0x0000b4f8:
			return 0x3d3637b2;
		case 0x0000b4fc:
			return 0x0a4cd539;
		case 0x0000b500:
			return 0xe63b7433;
		case 0x0000b504:
			return 0xc2af9ef9;
		case 0x0000b508:
			return 0x13d8e9ad;
		case 0x0000b50c:
			return 0xcd143c20;
		case 0x0000b510:
			return 0x69ebf1ff;
		case 0x0000b514:
			return 0xb0e3ed31;
		case 0x0000b518:
			return 0x15ef6bfe;
		case 0x0000b51c:
			return 0xf66db24b;
		case 0x0000b520:
			return 0xe26cf0fb;
		case 0x0000b524:
			return 0xf61161ba;
		case 0x0000b528:
			return 0x6c402c76;
		case 0x0000b52c:
			return 0x98ddc7f0;
		case 0x0000b530:
			return 0x55665ae6;
		case 0x0000b534:
			return 0x8bf71d61;
		case 0x0000b538:
			return 0x5a416351;
		case 0x0000b53c:
			return 0x75048e4c;
		case 0x0000b540:
			return 0x0fe7eaaf;
		case 0x0000b544:
			return 0xfae9811e;
		case 0x0000b548:
			return 0x8d2f492c;
		case 0x0000b54c:
			return 0xa920f348;
		case 0x0000b550:
			return 0x7a358b1a;
		case 0x0000b554:
			return 0xeacc45f0;
		case 0x0000b558:
			return 0xfb35b8f6;
		case 0x0000b55c:
			return 0xec9b49c5;
		case 0x0000b560:
			return 0x9f895ada;
		case 0x0000b564:
			return 0x74880624;
		case 0x0000b568:
			return 0x164c2c3c;
		case 0x0000b56c:
			return 0x00c1afe0;
		case 0x0000b570:
			return 0x5b214d5c;
		case 0x0000b574:
			return 0xc16e8450;
		case 0x0000b578:
			return 0x8c286517;
		case 0x0000b57c:
			return 0xaf6178e1;
		case 0x0000b580:
			return 0x3e7ddea6;
		case 0x0000b584:
			return 0xbe31127a;
		case 0x0000b588:
			return 0x2fbd105c;
		case 0x0000b58c:
			return 0xe5da6948;
		case 0x0000b590:
			return 0xad380e79;
		case 0x0000b594:
			return 0x59f4d79d;
		case 0x0000b598:
			return 0xd6a8aceb;
		case 0x0000b59c:
			return 0x21fff900;
		case 0x0000b5a0:
			return 0x789bc033;
		case 0x0000b5a4:
			return 0x8d6a514d;
		case 0x0000b5a8:
			return 0xd4b83504;
		case 0x0000b5ac:
			return 0x3293f645;
		case 0x0000b5b0:
			return 0x2977adfd;
		case 0x0000b5b4:
			return 0x7a4225c9;
		case 0x0000b5b8:
			return 0x246a8d05;
		case 0x0000b5bc:
			return 0x07796f89;
		case 0x0000b5c0:
			return 0x651084f2;
		case 0x0000b5c4:
			return 0x53e1c54b;
		case 0x0000b5c8:
			return 0x3d711892;
		case 0x0000b5cc:
			return 0x30510c46;
		case 0x0000b5d0:
			return 0xa3483636;
		case 0x0000b5d4:
			return 0xdfe59495;
		case 0x0000b5d8:
			return 0x808ea12d;
		case 0x0000b5dc:
			return 0x0086880c;
		case 0x0000b5e0:
			return 0xcf035c9e;
		case 0x0000b5e4:
			return 0x0a97ba9f;
		case 0x0000b5e8:
			return 0x60d4b325;
		case 0x0000b5ec:
			return 0x9995a253;
		case 0x0000b5f0:
			return 0xed5c0ca4;
		case 0x0000b5f4:
			return 0xb5affc26;
		case 0x0000b5f8:
			return 0x13d007c3;
		case 0x0000b5fc:
			return 0x96a36054;
		case 0x0000b600:
			return 0x28f06c3f;
		case 0x0000b604:
			return 0x357069d2;
		case 0x0000b608:
			return 0x326380f0;
		case 0x0000b60c:
			return 0x0deb94c5;
		case 0x0000b610:
			return 0x2d24c72a;
		case 0x0000b614:
			return 0x49ced82d;
		case 0x0000b618:
			return 0x9335b61c;
		case 0x0000b61c:
			return 0x8e0660dc;
		case 0x0000b620:
			return 0x97a6017b;
		case 0x0000b624:
			return 0x31a019b6;
		case 0x0000b628:
			return 0xdaa79e89;
		case 0x0000b62c:
			return 0x96ce1fda;
		case 0x0000b630:
			return 0x80e651a6;
		case 0x0000b634:
			return 0x4dc0e740;
		case 0x0000b638:
			return 0xc3f19fbb;
		case 0x0000b63c:
			return 0x6a4438ab;
		case 0x0000b640:
			return 0xca2e7d33;
		case 0x0000b644:
			return 0xfad01cdb;
		case 0x0000b648:
			return 0x5568707f;
		case 0x0000b64c:
			return 0x8ed87e76;
		case 0x0000b650:
			return 0x50895066;
		case 0x0000b654:
			return 0x610daf33;
		case 0x0000b658:
			return 0x1bb77e80;
		case 0x0000b65c:
			return 0xd483f8ca;
		case 0x0000b660:
			return 0x18609879;
		case 0x0000b664:
			return 0xaea09600;
		case 0x0000b668:
			return 0x0f611f9d;
		case 0x0000b66c:
			return 0x6c52ccd6;
		case 0x0000b670:
			return 0x706936e9;
		case 0x0000b674:
			return 0x76202aac;
		case 0x0000b678:
			return 0x78bd33ed;
		case 0x0000b67c:
			return 0x2f8a790a;
		case 0x0000b680:
			return 0x9612a268;
		case 0x0000b684:
			return 0x66b57c91;
		case 0x0000b688:
			return 0xf1fa7dd7;
		case 0x0000b68c:
			return 0x2ac3cd65;
		case 0x0000b690:
			return 0xacef756e;
		case 0x0000b694:
			return 0x867d41eb;
		case 0x0000b698:
			return 0xa7d67dbf;
		case 0x0000b69c:
			return 0x717d58ff;
		case 0x0000b6a0:
			return 0x8d4fb6e5;
		case 0x0000b6a4:
			return 0x5858759f;
		case 0x0000b6a8:
			return 0xec0f3c3c;
		case 0x0000b6ac:
			return 0x5304665c;
		case 0x0000b6b0:
			return 0xad01b1fb;
		case 0x0000b6b4:
			return 0xbe52df96;
		case 0x0000b6b8:
			return 0x75b26748;
		case 0x0000b6bc:
			return 0xc1a63999;
		case 0x0000b6c0:
			return 0xd2171032;
		case 0x0000b6c4:
			return 0x6de13aa9;
		case 0x0000b6c8:
			return 0x453be8e2;
		case 0x0000b6cc:
			return 0x921b6ad7;
		case 0x0000b6d0:
			return 0xa1b547b4;
		case 0x0000b6d4:
			return 0x9fea97bc;
		case 0x0000b6d8:
			return 0x89157cab;
		case 0x0000b6dc:
			return 0x556fadab;
		case 0x0000b6e0:
			return 0x9292efd5;
		case 0x0000b6e4:
			return 0x32ea7a4e;
		case 0x0000b6e8:
			return 0x9ca6c5ef;
		case 0x0000b6ec:
			return 0x0c7d4c05;
		case 0x0000b6f0:
			return 0xf9024802;
		case 0x0000b6f4:
			return 0x3e989ff2;
		case 0x0000b6f8:
			return 0xe3a7aafd;
		case 0x0000b6fc:
			return 0x2fc878d6;
		case 0x0000b700:
			return 0xc2ad1220;
		case 0x0000b704:
			return 0xf7ef42e1;
		case 0x0000b708:
			return 0xe8ce78ca;
		case 0x0000b70c:
			return 0x43f7eddb;
		case 0x0000b710:
			return 0x369d3627;
		case 0x0000b714:
			return 0x481143fa;
		case 0x0000b718:
			return 0xaed16952;
		case 0x0000b71c:
			return 0xc80f298d;
		case 0x0000b720:
			return 0xf2c2012e;
		case 0x0000b724:
			return 0xae2b65ee;
		case 0x0000b728:
			return 0xad58f247;
		case 0x0000b72c:
			return 0x58145188;
		case 0x0000b730:
			return 0xa2b52a31;
		case 0x0000b734:
			return 0x3d1c9fd9;
		case 0x0000b738:
			return 0xa8bc5be8;
		case 0x0000b73c:
			return 0x4218c947;
		case 0x0000b740:
			return 0xcc0d13cb;
		case 0x0000b744:
			return 0x2fea4bf1;
		case 0x0000b748:
			return 0xdbe12fe8;
		case 0x0000b74c:
			return 0x81dc504c;
		case 0x0000b750:
			return 0x92e681c3;
		case 0x0000b754:
			return 0xfadae252;
		case 0x0000b758:
			return 0x3b6ea8cc;
		case 0x0000b75c:
			return 0x2c00daf3;
		case 0x0000b760:
			return 0xd10444af;
		case 0x0000b764:
			return 0x5842691d;
		case 0x0000b768:
			return 0xe2e64eaa;
		case 0x0000b76c:
			return 0xe9e9bedf;
		case 0x0000b770:
			return 0xb04d21ab;
		case 0x0000b774:
			return 0x0f2f03f6;
		case 0x0000b778:
			return 0x09c014ca;
		case 0x0000b77c:
			return 0xebf6633f;
		case 0x0000b780:
			return 0x0113f9b8;
		case 0x0000b784:
			return 0xc5113792;
		case 0x0000b788:
			return 0xbb956dcf;
		case 0x0000b78c:
			return 0xef035391;
		case 0x0000b790:
			return 0x87ad2695;
		case 0x0000b794:
			return 0xe8e07668;
		case 0x0000b798:
			return 0x17884839;
		case 0x0000b79c:
			return 0xd5296055;
		case 0x0000b7a0:
			return 0x6789493f;
		case 0x0000b7a4:
			return 0x28088722;
		case 0x0000b7a8:
			return 0x93a01071;
		case 0x0000b7ac:
			return 0x497d892c;
		case 0x0000b7b0:
			return 0x4481e7b9;
		case 0x0000b7b4:
			return 0x84e4f4da;
		case 0x0000b7b8:
			return 0x76aac90d;
		case 0x0000b7bc:
			return 0xf76df8ab;
		case 0x0000b7c0:
			return 0x9d563794;
		case 0x0000b7c4:
			return 0xa20037c8;
		case 0x0000b7c8:
			return 0x6f1864f2;
		case 0x0000b7cc:
			return 0x139ec68b;
		case 0x0000b7d0:
			return 0x256cc1ef;
		case 0x0000b7d4:
			return 0x11343ae2;
		case 0x0000b7d8:
			return 0x862265c7;
		case 0x0000b7dc:
			return 0xb74134ec;
		case 0x0000b7e0:
			return 0xe69af0e3;
		case 0x0000b7e4:
			return 0x2d9c7209;
		case 0x0000b7e8:
			return 0xba640fb6;
		case 0x0000b7ec:
			return 0x267f2f1d;
		case 0x0000b7f0:
			return 0xa7ae55de;
		case 0x0000b7f4:
			return 0xb7a32d2b;
		case 0x0000b7f8:
			return 0xb2e2c85f;
		case 0x0000b7fc:
			return 0xf4593fe0;
		case 0x0000b800:
			return 0x812c7b63;
		case 0x0000b804:
			return 0xb32c6006;
		case 0x0000b808:
			return 0x7818f088;
		case 0x0000b80c:
			return 0x0fe333cc;
		case 0x0000b810:
			return 0x24fcfea0;
		case 0x0000b814:
			return 0x715d77dc;
		case 0x0000b818:
			return 0xfc615e3e;
		case 0x0000b81c:
			return 0x135bf0c0;
		case 0x0000b820:
			return 0x42a2c69c;
		case 0x0000b824:
			return 0xa5e0473a;
		case 0x0000b828:
			return 0xfa315966;
		case 0x0000b82c:
			return 0xd4acc85f;
		case 0x0000b830:
			return 0xdc6a7bbb;
		case 0x0000b834:
			return 0xe997315e;
		case 0x0000b838:
			return 0xc2655ff0;
		case 0x0000b83c:
			return 0xc6ed6af4;
		case 0x0000b840:
			return 0xd9672e34;
		case 0x0000b844:
			return 0x637862ad;
		case 0x0000b848:
			return 0x92442c02;
		case 0x0000b84c:
			return 0xc2e66fd5;
		case 0x0000b850:
			return 0x458f8dde;
		case 0x0000b854:
			return 0x5998b0b6;
		case 0x0000b858:
			return 0xc43b41db;
		case 0x0000b85c:
			return 0x4092eced;
		case 0x0000b860:
			return 0x433df427;
		case 0x0000b864:
			return 0x93ba07a0;
		case 0x0000b868:
			return 0x1fdefbfc;
		case 0x0000b86c:
			return 0xc8134f00;
		case 0x0000b870:
			return 0xb57347a6;
		case 0x0000b874:
			return 0xdb4b6a6d;
		case 0x0000b878:
			return 0xfee4f0e1;
		case 0x0000b87c:
			return 0xb31ebf9d;
		case 0x0000b880:
			return 0x0a4e0ee4;
		case 0x0000b884:
			return 0x40ac9f2b;
		case 0x0000b888:
			return 0x20be1b88;
		case 0x0000b88c:
			return 0xc39c6595;
		case 0x0000b890:
			return 0x24a7a3f3;
		case 0x0000b894:
			return 0x4f33a95f;
		case 0x0000b898:
			return 0xd48f8189;
		case 0x0000b89c:
			return 0x8095d75c;
		case 0x0000b8a0:
			return 0x8d541b21;
		case 0x0000b8a4:
			return 0x632ffc4c;
		case 0x0000b8a8:
			return 0x844b5c9e;
		case 0x0000b8ac:
			return 0x4089ad4f;
		case 0x0000b8b0:
			return 0x5a769f55;
		case 0x0000b8b4:
			return 0x554973ec;
		case 0x0000b8b8:
			return 0x961d558a;
		case 0x0000b8bc:
			return 0xaa68ef77;
		case 0x0000b8c0:
			return 0x41bb1e81;
		case 0x0000b8c4:
			return 0x7d36a644;
		case 0x0000b8c8:
			return 0xff444bfb;
		case 0x0000b8cc:
			return 0x3eaacac2;
		case 0x0000b8d0:
			return 0xf8715f3b;
		case 0x0000b8d4:
			return 0x0ac0ca69;
		case 0x0000b8d8:
			return 0x32753441;
		case 0x0000b8dc:
			return 0xbb10c4bd;
		case 0x0000b8e0:
			return 0x04e0808b;
		case 0x0000b8e4:
			return 0x701ec50c;
		case 0x0000b8e8:
			return 0x68ac50f9;
		case 0x0000b8ec:
			return 0x24e3d705;
		case 0x0000b8f0:
			return 0x1dbec455;
		case 0x0000b8f4:
			return 0xcfa4066e;
		case 0x0000b8f8:
			return 0x3eccd30e;
		case 0x0000b8fc:
			return 0x0a7f7d0d;
		case 0x0000b900:
			return 0xdd1be74a;
		case 0x0000b904:
			return 0xf9dab560;
		case 0x0000b908:
			return 0xc8d6ef18;
		case 0x0000b90c:
			return 0x86142760;
		case 0x0000b910:
			return 0xfec380c3;
		case 0x0000b914:
			return 0x2874c451;
		case 0x0000b918:
			return 0x1670f52b;
		case 0x0000b91c:
			return 0x825968e4;
		case 0x0000b920:
			return 0xace68e2f;
		case 0x0000b924:
			return 0xd79d30e7;
		case 0x0000b928:
			return 0xd197b9b4;
		case 0x0000b92c:
			return 0xaefbb065;
		case 0x0000b930:
			return 0x691286af;
		case 0x0000b934:
			return 0xf9623bf3;
		case 0x0000b938:
			return 0xd1cef38e;
		case 0x0000b93c:
			return 0x7c893d5f;
		case 0x0000b940:
			return 0x2ee91061;
		case 0x0000b944:
			return 0x2b1a63a1;
		case 0x0000b948:
			return 0x3b459b8a;
		case 0x0000b94c:
			return 0xa7c52eb0;
		case 0x0000b950:
			return 0xc0f6b98e;
		case 0x0000b954:
			return 0x7da77d9f;
		case 0x0000b958:
			return 0x1916646f;
		case 0x0000b95c:
			return 0xb6ee8afb;
		case 0x0000b960:
			return 0x9f52e6c0;
		case 0x0000b964:
			return 0x72f30f78;
		case 0x0000b968:
			return 0x6b49ff60;
		case 0x0000b96c:
			return 0xcd7f1af1;
		case 0x0000b970:
			return 0x1895c5b1;
		case 0x0000b974:
			return 0x73f8f4ab;
		case 0x0000b978:
			return 0xcfbb2080;
		case 0x0000b97c:
			return 0x4ba66ceb;
		case 0x0000b980:
			return 0x162ee359;
		case 0x0000b984:
			return 0xf2c8eebe;
		case 0x0000b988:
			return 0x3ea7f6ad;
		case 0x0000b98c:
			return 0xd236c4cd;
		case 0x0000b990:
			return 0xd0325c11;
		case 0x0000b994:
			return 0xee93f54c;
		case 0x0000b998:
			return 0xbf6adf7a;
		case 0x0000b99c:
			return 0xc61d945d;
		case 0x0000b9a0:
			return 0x63450404;
		case 0x0000b9a4:
			return 0x166f9c3f;
		case 0x0000b9a8:
			return 0x2cc12506;
		case 0x0000b9ac:
			return 0x86c56c7c;
		case 0x0000b9b0:
			return 0x7874befd;
		case 0x0000b9b4:
			return 0x357aa4e0;
		case 0x0000b9b8:
			return 0xc5b758a0;
		case 0x0000b9bc:
			return 0x73da13fc;
		case 0x0000b9c0:
			return 0x34dcb30c;
		case 0x0000b9c4:
			return 0x6026199f;
		case 0x0000b9c8:
			return 0xcefd027b;
		case 0x0000b9cc:
			return 0x65133249;
		case 0x0000b9d0:
			return 0xeea8a3c9;
		case 0x0000b9d4:
			return 0x7e794e23;
		case 0x0000b9d8:
			return 0x85ca7e5b;
		case 0x0000b9dc:
			return 0x896ab925;
		case 0x0000b9e0:
			return 0x87740e4a;
		case 0x0000b9e4:
			return 0x06bcd6a0;
		case 0x0000b9e8:
			return 0x8bc5add8;
		case 0x0000b9ec:
			return 0x5b7dc442;
		case 0x0000b9f0:
			return 0x817fad50;
		case 0x0000b9f4:
			return 0xa8827f2a;
		case 0x0000b9f8:
			return 0xe8b5747b;
		case 0x0000b9fc:
			return 0xb33af0f6;
		case 0x0000ba00:
			return 0xc73f626c;
		case 0x0000ba04:
			return 0x25032250;
		case 0x0000ba08:
			return 0x559c9bfe;
		case 0x0000ba0c:
			return 0x2de13701;
		case 0x0000ba10:
			return 0x7ba9da20;
		case 0x0000ba14:
			return 0xa40848e1;
		case 0x0000ba18:
			return 0x6ee0d4ae;
		case 0x0000ba1c:
			return 0x0b7527c1;
		case 0x0000ba20:
			return 0x9593b4b3;
		case 0x0000ba24:
			return 0x89f6623b;
		case 0x0000ba28:
			return 0xc0da9b6e;
		case 0x0000ba2c:
			return 0x11129042;
		case 0x0000ba30:
			return 0xc8d390fd;
		case 0x0000ba34:
			return 0xd160f9ee;
		case 0x0000ba38:
			return 0x0fc0e757;
		case 0x0000ba3c:
			return 0x188235c3;
		case 0x0000ba40:
			return 0x4a277724;
		case 0x0000ba44:
			return 0xbb5172cf;
		case 0x0000ba48:
			return 0x33dc8c90;
		case 0x0000ba4c:
			return 0x7e1ddbe0;
		case 0x0000ba50:
			return 0x3e3d7e48;
		case 0x0000ba54:
			return 0x3d6c0d4b;
		case 0x0000ba58:
			return 0x675587fe;
		case 0x0000ba5c:
			return 0xd8f26e5f;
		case 0x0000ba60:
			return 0xda05741a;
		case 0x0000ba64:
			return 0xca081f59;
		case 0x0000ba68:
			return 0x5e78ac6d;
		case 0x0000ba6c:
			return 0xe34fc136;
		case 0x0000ba70:
			return 0xb7f6a266;
		case 0x0000ba74:
			return 0x0f6873c7;
		case 0x0000ba78:
			return 0xdc13d0a9;
		case 0x0000ba7c:
			return 0xb5866415;
		case 0x0000ba80:
			return 0x67629981;
		case 0x0000ba84:
			return 0xef2af71b;
		case 0x0000ba88:
			return 0x90c05d03;
		case 0x0000ba8c:
			return 0x2de07b1b;
		case 0x0000ba90:
			return 0x039ff538;
		case 0x0000ba94:
			return 0xcfa0b6ca;
		case 0x0000ba98:
			return 0xe6a22bc4;
		case 0x0000ba9c:
			return 0xf3f63b13;
		case 0x0000baa0:
			return 0xc007e5f5;
		case 0x0000baa4:
			return 0xfb8a1b6e;
		case 0x0000baa8:
			return 0x1918c9aa;
		case 0x0000baac:
			return 0x239a2efd;
		case 0x0000bab0:
			return 0xa1de68ed;
		case 0x0000bab4:
			return 0xdde7964e;
		case 0x0000bab8:
			return 0x9fbee71f;
		case 0x0000babc:
			return 0x8b92b786;
		case 0x0000bac0:
			return 0xd7443032;
		case 0x0000bac4:
			return 0x88efc9d2;
		case 0x0000bac8:
			return 0x76a7a593;
		case 0x0000bacc:
			return 0x5377f8b3;
		case 0x0000bad0:
			return 0x2feba062;
		case 0x0000bad4:
			return 0x1edc26b6;
		case 0x0000bad8:
			return 0xd345db3d;
		case 0x0000badc:
			return 0x67eb6428;
		case 0x0000bae0:
			return 0x150a8371;
		case 0x0000bae4:
			return 0x24559b34;
		case 0x0000bae8:
			return 0x627da3ee;
		case 0x0000baec:
			return 0xff160c37;
		case 0x0000baf0:
			return 0x8c896d91;
		case 0x0000baf4:
			return 0xe35188e8;
		case 0x0000baf8:
			return 0x57a8cc90;
		case 0x0000bafc:
			return 0x26e206ff;
		case 0x0000bb00:
			return 0x6dfc0b1b;
		case 0x0000bb04:
			return 0x1927bb46;
		case 0x0000bb08:
			return 0x97c0eadd;
		case 0x0000bb0c:
			return 0x25648770;
		case 0x0000bb10:
			return 0x9e6405e0;
		case 0x0000bb14:
			return 0xc211672b;
		case 0x0000bb18:
			return 0xc7c7e4c2;
		case 0x0000bb1c:
			return 0x13a1fa73;
		case 0x0000bb20:
			return 0x4f59e998;
		case 0x0000bb24:
			return 0x9ae6df83;
		case 0x0000bb28:
			return 0xdb9aa94d;
		case 0x0000bb2c:
			return 0x82b60ab5;
		case 0x0000bb30:
			return 0x4ac257d2;
		case 0x0000bb34:
			return 0x4f0ed7bc;
		case 0x0000bb38:
			return 0xe7dcedc6;
		case 0x0000bb3c:
			return 0xa61114eb;
		case 0x0000bb40:
			return 0x807c6c83;
		case 0x0000bb44:
			return 0x32a2f615;
		case 0x0000bb48:
			return 0x0f15142f;
		case 0x0000bb4c:
			return 0x28c2ce92;
		case 0x0000bb50:
			return 0xdf84c136;
		case 0x0000bb54:
			return 0x80480934;
		case 0x0000bb58:
			return 0x445079cc;
		case 0x0000bb5c:
			return 0x16586a00;
		case 0x0000bb60:
			return 0x2822b3c3;
		case 0x0000bb64:
			return 0xef518d90;
		case 0x0000bb68:
			return 0x554fd698;
		case 0x0000bb6c:
			return 0x809f5bc7;
		case 0x0000bb70:
			return 0xd11e6bb2;
		case 0x0000bb74:
			return 0x9e1294b3;
		case 0x0000bb78:
			return 0x9b430871;
		case 0x0000bb7c:
			return 0x8e125e51;
		case 0x0000bb80:
			return 0x83048e30;
		case 0x0000bb84:
			return 0x82e906fa;
		case 0x0000bb88:
			return 0xd111d1c8;
		case 0x0000bb8c:
			return 0x89a10620;
		case 0x0000bb90:
			return 0xe2f01797;
		case 0x0000bb94:
			return 0x50dbca57;
		case 0x0000bb98:
			return 0xfdc125a0;
		case 0x0000bb9c:
			return 0x59ef44c0;
		case 0x0000bba0:
			return 0xe28bea7c;
		case 0x0000bba4:
			return 0xce4b3487;
		case 0x0000bba8:
			return 0x43400f29;
		case 0x0000bbac:
			return 0x26606f67;
		case 0x0000bbb0:
			return 0x6980e8d6;
		case 0x0000bbb4:
			return 0x9d3f2faa;
		case 0x0000bbb8:
			return 0x6087c271;
		case 0x0000bbbc:
			return 0xb5eb7b4b;
		case 0x0000bbc0:
			return 0x3b4de5b6;
		case 0x0000bbc4:
			return 0xe4d17607;
		case 0x0000bbc8:
			return 0x75c9f0d6;
		case 0x0000bbcc:
			return 0x3b10dc23;
		case 0x0000bbd0:
			return 0xb5318979;
		case 0x0000bbd4:
			return 0xd0e699f2;
		case 0x0000bbd8:
			return 0x56d97bfd;
		case 0x0000bbdc:
			return 0x13d88633;
		case 0x0000bbe0:
			return 0x65f280d5;
		case 0x0000bbe4:
			return 0x6799a872;
		case 0x0000bbe8:
			return 0x8ecd4ad6;
		case 0x0000bbec:
			return 0x6a123260;
		case 0x0000bbf0:
			return 0xeb6b0e7b;
		case 0x0000bbf4:
			return 0xcf518364;
		case 0x0000bbf8:
			return 0x77533e6f;
		case 0x0000bbfc:
			return 0xe34d1650;
		case 0x0000bc00:
			return 0x6bfd6bce;
		case 0x0000bc04:
			return 0x70a34b9b;
		case 0x0000bc08:
			return 0x6e5860bb;
		case 0x0000bc0c:
			return 0xabb73eb8;
		case 0x0000bc10:
			return 0xea83360c;
		case 0x0000bc14:
			return 0xd0950b69;
		case 0x0000bc18:
			return 0x8564e7cd;
		case 0x0000bc1c:
			return 0x2e12859f;
		case 0x0000bc20:
			return 0xc89a99ff;
		case 0x0000bc24:
			return 0xfd4227b8;
		case 0x0000bc28:
			return 0x8d4b9efb;
		case 0x0000bc2c:
			return 0x84de307f;
		case 0x0000bc30:
			return 0xc3c0fee4;
		case 0x0000bc34:
			return 0x21498271;
		case 0x0000bc38:
			return 0x3199b22d;
		case 0x0000bc3c:
			return 0x30e558c0;
		case 0x0000bc40:
			return 0x8365db13;
		case 0x0000bc44:
			return 0x757719a7;
		case 0x0000bc48:
			return 0x16582d92;
		case 0x0000bc4c:
			return 0x0bd87f22;
		case 0x0000bc50:
			return 0xabb39fda;
		case 0x0000bc54:
			return 0xa2fbeafd;
		case 0x0000bc58:
			return 0x6a8b468f;
		case 0x0000bc5c:
			return 0xfb75e638;
		case 0x0000bc60:
			return 0x2de745b3;
		case 0x0000bc64:
			return 0x76878d0e;
		case 0x0000bc68:
			return 0x491a01a1;
		case 0x0000bc6c:
			return 0x34ba56dd;
		case 0x0000bc70:
			return 0x142e7e4a;
		case 0x0000bc74:
			return 0x722233ec;
		case 0x0000bc78:
			return 0xaf12bcb5;
		case 0x0000bc7c:
			return 0x0fd0a4ec;
		case 0x0000bc80:
			return 0x70d01b2f;
		case 0x0000bc84:
			return 0xa6dce05f;
		case 0x0000bc88:
			return 0xf4a636ec;
		case 0x0000bc8c:
			return 0x3444691c;
		case 0x0000bc90:
			return 0x69ccdcba;
		case 0x0000bc94:
			return 0xa680e55c;
		case 0x0000bc98:
			return 0x57e7969b;
		case 0x0000bc9c:
			return 0x06dbada6;
		case 0x0000bca0:
			return 0xdaf1d158;
		case 0x0000bca4:
			return 0x5b3a7989;
		case 0x0000bca8:
			return 0x35fe13f9;
		case 0x0000bcac:
			return 0x58d935b6;
		case 0x0000bcb0:
			return 0x4d574ac8;
		case 0x0000bcb4:
			return 0x86faf880;
		case 0x0000bcb8:
			return 0x7169e455;
		case 0x0000bcbc:
			return 0x2232a8b0;
		case 0x0000bcc0:
			return 0x2664faa5;
		case 0x0000bcc4:
			return 0x8a89f904;
		case 0x0000bcc8:
			return 0xd2cac1ee;
		case 0x0000bccc:
			return 0x312fa40d;
		case 0x0000bcd0:
			return 0xa9923cd2;
		case 0x0000bcd4:
			return 0xa5fb97b5;
		case 0x0000bcd8:
			return 0x0f48b949;
		case 0x0000bcdc:
			return 0x06b135d4;
		case 0x0000bce0:
			return 0xf182559d;
		case 0x0000bce4:
			return 0x5ddcbd36;
		case 0x0000bce8:
			return 0x0eecd1a0;
		case 0x0000bcec:
			return 0xfc897656;
		case 0x0000bcf0:
			return 0x00d59f93;
		case 0x0000bcf4:
			return 0x1887f51b;
		case 0x0000bcf8:
			return 0xeb85a56d;
		case 0x0000bcfc:
			return 0x6cd0cddb;
		case 0x0000bd00:
			return 0x5e306530;
		case 0x0000bd04:
			return 0xd3cfb4a6;
		case 0x0000bd08:
			return 0x89c0e1a7;
		case 0x0000bd0c:
			return 0x26cb41b1;
		case 0x0000bd10:
			return 0x62092ec3;
		case 0x0000bd14:
			return 0x5d8c3a97;
		case 0x0000bd18:
			return 0x4930e269;
		case 0x0000bd1c:
			return 0x67e12d38;
		case 0x0000bd20:
			return 0xc9da9e28;
		case 0x0000bd24:
			return 0xa5e5b6bd;
		case 0x0000bd28:
			return 0x26e0633a;
		case 0x0000bd2c:
			return 0x7bc282e5;
		case 0x0000bd30:
			return 0x507a07ef;
		case 0x0000bd34:
			return 0xb185ab18;
		case 0x0000bd38:
			return 0x05953f57;
		case 0x0000bd3c:
			return 0xfa6a8795;
		case 0x0000bd40:
			return 0x4ed9cf7b;
		case 0x0000bd44:
			return 0xf2f55d92;
		case 0x0000bd48:
			return 0x2cc856ee;
		case 0x0000bd4c:
			return 0xbbc92cb9;
		case 0x0000bd50:
			return 0xd9c564cb;
		case 0x0000bd54:
			return 0x238a3f70;
		case 0x0000bd58:
			return 0x5f0f9ede;
		case 0x0000bd5c:
			return 0x27c55864;
		case 0x0000bd60:
			return 0xfccbff3f;
		case 0x0000bd64:
			return 0x652da44f;
		case 0x0000bd68:
			return 0x8f579048;
		case 0x0000bd6c:
			return 0x7cb467ba;
		case 0x0000bd70:
			return 0xf11b34f1;
		case 0x0000bd74:
			return 0x01ef4456;
		case 0x0000bd78:
			return 0x99a51ec0;
		case 0x0000bd7c:
			return 0x7afec5b2;
		case 0x0000bd80:
			return 0xb0164369;
		case 0x0000bd84:
			return 0x2a5c1638;
		case 0x0000bd88:
			return 0x0a12a167;
		case 0x0000bd8c:
			return 0x619643f6;
		case 0x0000bd90:
			return 0x287d48b3;
		case 0x0000bd94:
			return 0x03719f36;
		case 0x0000bd98:
			return 0x242e9975;
		case 0x0000bd9c:
			return 0x8fc52730;
		case 0x0000bda0:
			return 0x14ad4e59;
		case 0x0000bda4:
			return 0x029512af;
		case 0x0000bda8:
			return 0x31ba6d37;
		case 0x0000bdac:
			return 0x55472f26;
		case 0x0000bdb0:
			return 0xdc7fd1b0;
		case 0x0000bdb4:
			return 0x3f1c0c8d;
		case 0x0000bdb8:
			return 0x8842a905;
		case 0x0000bdbc:
			return 0xa72f6e47;
		case 0x0000bdc0:
			return 0xf23c6adc;
		case 0x0000bdc4:
			return 0x4c76bef6;
		case 0x0000bdc8:
			return 0xbca43ebb;
		case 0x0000bdcc:
			return 0x2c9d6e23;
		case 0x0000bdd0:
			return 0x65a7d8cd;
		case 0x0000bdd4:
			return 0xd08223e3;
		case 0x0000bdd8:
			return 0xae2131f8;
		case 0x0000bddc:
			return 0x972d2087;
		case 0x0000bde0:
			return 0x4c25429a;
		case 0x0000bde4:
			return 0xb212af1f;
		case 0x0000bde8:
			return 0xf7b37e0f;
		case 0x0000bdec:
			return 0x525697f8;
		case 0x0000bdf0:
			return 0x0c37202f;
		case 0x0000bdf4:
			return 0x82d3d1ed;
		case 0x0000bdf8:
			return 0xa8df2b58;
		case 0x0000bdfc:
			return 0xe2b01d99;
		case 0x0000be00:
			return 0xa0333e1c;
		case 0x0000be04:
			return 0x3f10d03d;
		case 0x0000be08:
			return 0x3dcf04d2;
		case 0x0000be0c:
			return 0xa31fdf66;
		case 0x0000be10:
			return 0xa6609c75;
		case 0x0000be14:
			return 0xa07b6342;
		case 0x0000be18:
			return 0x26e1d2fa;
		case 0x0000be1c:
			return 0xbfc7eb0d;
		case 0x0000be20:
			return 0x0a005fe0;
		case 0x0000be24:
			return 0x47747e35;
		case 0x0000be28:
			return 0x0891e4bb;
		case 0x0000be2c:
			return 0x44bf8a35;
		case 0x0000be30:
			return 0x161ef0fd;
		case 0x0000be34:
			return 0xf8d22294;
		case 0x0000be38:
			return 0xba989cc5;
		case 0x0000be3c:
			return 0xe4600346;
		case 0x0000be40:
			return 0x9f7a10f6;
		case 0x0000be44:
			return 0xa188a496;
		case 0x0000be48:
			return 0xb2735462;
		case 0x0000be4c:
			return 0xdd02e038;
		case 0x0000be50:
			return 0xd614bd28;
		case 0x0000be54:
			return 0x0dbdc4ef;
		case 0x0000be58:
			return 0xb8624e44;
		case 0x0000be5c:
			return 0x682f2efb;
		case 0x0000be60:
			return 0xb9d35f03;
		case 0x0000be64:
			return 0xaab6f624;
		case 0x0000be68:
			return 0x2d472297;
		case 0x0000be6c:
			return 0x320e7a1d;
		case 0x0000be70:
			return 0x472385fc;
		case 0x0000be74:
			return 0x1a73bfd2;
		case 0x0000be78:
			return 0xb5f3d70d;
		case 0x0000be7c:
			return 0x38387df6;
		case 0x0000be80:
			return 0x981ff234;
		case 0x0000be84:
			return 0xabbcbef5;
		case 0x0000be88:
			return 0x425a48ea;
		case 0x0000be8c:
			return 0x04abe2b6;
		case 0x0000be90:
			return 0x8a951391;
		case 0x0000be94:
			return 0xeb6e23df;
		case 0x0000be98:
			return 0xe78484a6;
		case 0x0000be9c:
			return 0x90e49817;
		case 0x0000bea0:
			return 0x565d5dc6;
		case 0x0000bea4:
			return 0xd80042e9;
		case 0x0000bea8:
			return 0xd29b86a0;
		case 0x0000beac:
			return 0x23585fc3;
		case 0x0000beb0:
			return 0x1abdd4a9;
		case 0x0000beb4:
			return 0x56c8d9e0;
		case 0x0000beb8:
			return 0x7db1d2f4;
		case 0x0000bebc:
			return 0xae4e3e72;
		case 0x0000bec0:
			return 0x95711d8b;
		case 0x0000bec4:
			return 0xa98dfc60;
		case 0x0000bec8:
			return 0x6abd58f4;
		case 0x0000becc:
			return 0x8fdacbea;
		case 0x0000bed0:
			return 0x02cf7306;
		case 0x0000bed4:
			return 0x4eca4f45;
		case 0x0000bed8:
			return 0xf0a87f89;
		case 0x0000bedc:
			return 0xe5f479f8;
		case 0x0000bee0:
			return 0x5427b474;
		case 0x0000bee4:
			return 0x064c1106;
		case 0x0000bee8:
			return 0x5c8ac2e4;
		case 0x0000beec:
			return 0x1087aec4;
		case 0x0000bef0:
			return 0x1eecfca6;
		case 0x0000bef4:
			return 0xf196c547;
		case 0x0000bef8:
			return 0x2098d887;
		case 0x0000befc:
			return 0xe48a854e;
		case 0x0000bf00:
			return 0x92d7d28d;
		case 0x0000bf04:
			return 0x61b6e372;
		case 0x0000bf08:
			return 0xacf6e9e5;
		case 0x0000bf0c:
			return 0x9f52c0da;
		case 0x0000bf10:
			return 0xe6d3a7e0;
		case 0x0000bf14:
			return 0xd278b24e;
		case 0x0000bf18:
			return 0xb9b9a4dc;
		case 0x0000bf1c:
			return 0x26479e2f;
		case 0x0000bf20:
			return 0xda32c195;
		case 0x0000bf24:
			return 0x29c1cafd;
		case 0x0000bf28:
			return 0x043e7bdb;
		case 0x0000bf2c:
			return 0x1be890c1;
		case 0x0000bf30:
			return 0x1c15da9a;
		case 0x0000bf34:
			return 0x6b762ed8;
		case 0x0000bf38:
			return 0x8063fe67;
		case 0x0000bf3c:
			return 0x1f35f3db;
		case 0x0000bf40:
			return 0xaae2a661;
		case 0x0000bf44:
			return 0xe694fd12;
		case 0x0000bf48:
			return 0x64bfc1b3;
		case 0x0000bf4c:
			return 0x1c0eb5e1;
		case 0x0000bf50:
			return 0x2c2cd322;
		case 0x0000bf54:
			return 0xc47a5715;
		case 0x0000bf58:
			return 0xb662ad38;
		case 0x0000bf5c:
			return 0x26ffad00;
		case 0x0000bf60:
			return 0xc9478278;
		case 0x0000bf64:
			return 0xc7232e44;
		case 0x0000bf68:
			return 0x18dcea7b;
		case 0x0000bf6c:
			return 0x53fc1701;
		case 0x0000bf70:
			return 0x57447962;
		case 0x0000bf74:
			return 0x656cd9a4;
		case 0x0000bf78:
			return 0xad4bbd07;
		case 0x0000bf7c:
			return 0x5645c091;
		case 0x0000bf80:
			return 0xa445e247;
		case 0x0000bf84:
			return 0x32e7a391;
		case 0x0000bf88:
			return 0x1991e73f;
		case 0x0000bf8c:
			return 0x62a7986e;
		case 0x0000bf90:
			return 0x632f4dbf;
		case 0x0000bf94:
			return 0x2967b636;
		case 0x0000bf98:
			return 0xb7e699c3;
		case 0x0000bf9c:
			return 0x460c55c5;
		case 0x0000bfa0:
			return 0x9cba0a69;
		case 0x0000bfa4:
			return 0xc2a953c4;
		case 0x0000bfa8:
			return 0xabba8ffb;
		case 0x0000bfac:
			return 0x38a8a7aa;
		case 0x0000bfb0:
			return 0x8f15a106;
		case 0x0000bfb4:
			return 0x25e63b6d;
		case 0x0000bfb8:
			return 0x9d934306;
		case 0x0000bfbc:
			return 0x19e59658;
		case 0x0000bfc0:
			return 0x095fffce;
		case 0x0000bfc4:
			return 0xc6c1d093;
		case 0x0000bfc8:
			return 0x2ac5293d;
		case 0x0000bfcc:
			return 0x4856342f;
		case 0x0000bfd0:
			return 0xfc900318;
		case 0x0000bfd4:
			return 0xc93630be;
		case 0x0000bfd8:
			return 0x9c01b7e3;
		case 0x0000bfdc:
			return 0x97f8dd5b;
		case 0x0000bfe0:
			return 0xed5febaf;
		case 0x0000bfe4:
			return 0x117b0ebc;
		case 0x0000bfe8:
			return 0xf2975a2e;
		case 0x0000bfec:
			return 0x06f9e03c;
		case 0x0000bff0:
			return 0x2901ca95;
		case 0x0000bff4:
			return 0x7023d132;
		case 0x0000bff8:
			return 0xffcbd638;
		case 0x0000bffc:
			return 0x98f03016;
		case 0x0000c000:
			return 0xc7614012;
		case 0x0000c004:
			return 0x58251d5a;
		case 0x0000c008:
			return 0xf7df261c;
		case 0x0000c00c:
			return 0xba5b0f4a;
		case 0x0000c010:
			return 0x5c50e0c6;
		case 0x0000c014:
			return 0xb8bb70ae;
		case 0x0000c018:
			return 0x6a1bba4a;
		case 0x0000c01c:
			return 0x7183e38c;
		case 0x0000c020:
			return 0x71d44db1;
		case 0x0000c024:
			return 0xf4c0daae;
		case 0x0000c028:
			return 0xbad5e507;
		case 0x0000c02c:
			return 0xc1327dc9;
		case 0x0000c030:
			return 0x996ec2e6;
		case 0x0000c034:
			return 0xaf19bdba;
		case 0x0000c038:
			return 0x6cdd33ef;
		case 0x0000c03c:
			return 0xb4509b89;
		case 0x0000c040:
			return 0x9b9cce2d;
		case 0x0000c044:
			return 0xd91e9624;
		case 0x0000c048:
			return 0x8fb7cbd9;
		case 0x0000c04c:
			return 0xea8e9ad8;
		case 0x0000c050:
			return 0x6899761c;
		case 0x0000c054:
			return 0x3d818332;
		case 0x0000c058:
			return 0x4bcb5aee;
		case 0x0000c05c:
			return 0x749e8f3e;
		case 0x0000c060:
			return 0xe15ac92f;
		case 0x0000c064:
			return 0xc5da16c1;
		case 0x0000c068:
			return 0x1b0057c0;
		case 0x0000c06c:
			return 0x64404bd7;
		case 0x0000c070:
			return 0x04bc8108;
		case 0x0000c074:
			return 0xdee20742;
		case 0x0000c078:
			return 0xf51c1ac3;
		case 0x0000c07c:
			return 0x6b2c2f8a;
		case 0x0000c080:
			return 0x81120fba;
		case 0x0000c084:
			return 0xad5c8b61;
		case 0x0000c088:
			return 0xb89f03d9;
		case 0x0000c08c:
			return 0xc7898d37;
		case 0x0000c090:
			return 0x2a2d4ecb;
		case 0x0000c094:
			return 0x5e482e95;
		case 0x0000c098:
			return 0xed41d4da;
		case 0x0000c09c:
			return 0x6c78aaef;
		case 0x0000c0a0:
			return 0xb5d8c46d;
		case 0x0000c0a4:
			return 0xe9973bf8;
		case 0x0000c0a8:
			return 0xaaedce61;
		case 0x0000c0ac:
			return 0x14edc59d;
		case 0x0000c0b0:
			return 0x8af08148;
		case 0x0000c0b4:
			return 0x2629f7bf;
		case 0x0000c0b8:
			return 0xb0f3ab31;
		case 0x0000c0bc:
			return 0xf968908b;
		case 0x0000c0c0:
			return 0xa76edbef;
		case 0x0000c0c4:
			return 0x1247fb28;
		case 0x0000c0c8:
			return 0xac50c6cf;
		case 0x0000c0cc:
			return 0xe1df8d6b;
		case 0x0000c0d0:
			return 0xe9c86b3e;
		case 0x0000c0d4:
			return 0x0f74b342;
		case 0x0000c0d8:
			return 0xb8abc2e5;
		case 0x0000c0dc:
			return 0x6220a15b;
		case 0x0000c0e0:
			return 0xf238a51d;
		case 0x0000c0e4:
			return 0x2418beb1;
		case 0x0000c0e8:
			return 0x57b7ea59;
		case 0x0000c0ec:
			return 0x21c33dc8;
		case 0x0000c0f0:
			return 0xccadf20f;
		case 0x0000c0f4:
			return 0x5c974113;
		case 0x0000c0f8:
			return 0x07a8bc0b;
		case 0x0000c0fc:
			return 0xffccac8f;
		case 0x0000c100:
			return 0x683e22bc;
		case 0x0000c104:
			return 0x1f9434ce;
		case 0x0000c108:
			return 0x1583542e;
		case 0x0000c10c:
			return 0x2060a28f;
		case 0x0000c110:
			return 0xc5f43134;
		case 0x0000c114:
			return 0xe48079d7;
		case 0x0000c118:
			return 0xca4ea2d0;
		case 0x0000c11c:
			return 0x0aeb4825;
		case 0x0000c120:
			return 0xac5392cd;
		case 0x0000c124:
			return 0x21f16800;
		case 0x0000c128:
			return 0xf43c24c4;
		case 0x0000c12c:
			return 0xda088f3a;
		case 0x0000c130:
			return 0xa80c711e;
		case 0x0000c134:
			return 0x50d57fb8;
		case 0x0000c138:
			return 0x0d58305a;
		case 0x0000c13c:
			return 0x9b3ba5a1;
		case 0x0000c140:
			return 0xe85d9e7c;
		case 0x0000c144:
			return 0x395f1b6f;
		case 0x0000c148:
			return 0xb92fea39;
		case 0x0000c14c:
			return 0x0dfa15f7;
		case 0x0000c150:
			return 0x32db043f;
		case 0x0000c154:
			return 0x8067df1d;
		case 0x0000c158:
			return 0x9545fda2;
		case 0x0000c15c:
			return 0x8e3e86b6;
		case 0x0000c160:
			return 0xa0b62fd6;
		case 0x0000c164:
			return 0x3636f12a;
		case 0x0000c168:
			return 0xf169a2e8;
		case 0x0000c16c:
			return 0x0006ee51;
		case 0x0000c170:
			return 0x4b61c959;
		case 0x0000c174:
			return 0xed4f6a39;
		case 0x0000c178:
			return 0x44785ffd;
		case 0x0000c17c:
			return 0xaed015dc;
		case 0x0000c180:
			return 0x97f1d32f;
		case 0x0000c184:
			return 0xf7ebb822;
		case 0x0000c188:
			return 0xd3c294f0;
		case 0x0000c18c:
			return 0x12fca77a;
		case 0x0000c190:
			return 0x119e5ae8;
		case 0x0000c194:
			return 0x2211a43e;
		case 0x0000c198:
			return 0xc71dbe68;
		case 0x0000c19c:
			return 0x90e5183a;
		case 0x0000c1a0:
			return 0x89cabc9d;
		case 0x0000c1a4:
			return 0x214f5d0a;
		case 0x0000c1a8:
			return 0xb24402af;
		case 0x0000c1ac:
			return 0xb54b93f4;
		case 0x0000c1b0:
			return 0x40af66a3;
		case 0x0000c1b4:
			return 0x08dc0b82;
		case 0x0000c1b8:
			return 0x0703f3b9;
		case 0x0000c1bc:
			return 0xa70bcdf1;
		case 0x0000c1c0:
			return 0x3876f65d;
		case 0x0000c1c4:
			return 0x63fa47e3;
		case 0x0000c1c8:
			return 0x7480d4d8;
		case 0x0000c1cc:
			return 0xeeab95a1;
		case 0x0000c1d0:
			return 0x1c16614d;
		case 0x0000c1d4:
			return 0x604512f6;
		case 0x0000c1d8:
			return 0xfc6303bf;
		case 0x0000c1dc:
			return 0x597adb33;
		case 0x0000c1e0:
			return 0x8d8ed612;
		case 0x0000c1e4:
			return 0xd6e61619;
		case 0x0000c1e8:
			return 0xd0ea64f9;
		case 0x0000c1ec:
			return 0x4bc69a17;
		case 0x0000c1f0:
			return 0xcaaef224;
		case 0x0000c1f4:
			return 0xef55113d;
		case 0x0000c1f8:
			return 0x7e483a89;
		case 0x0000c1fc:
			return 0xc49b9347;
		case 0x0000c200:
			return 0x3f44a44e;
		case 0x0000c204:
			return 0xbfd7aeaa;
		case 0x0000c208:
			return 0xc1981c8f;
		case 0x0000c20c:
			return 0x0201b58d;
		case 0x0000c210:
			return 0xacec61f2;
		case 0x0000c214:
			return 0x05223b65;
		case 0x0000c218:
			return 0x6a340305;
		case 0x0000c21c:
			return 0x305684e7;
		case 0x0000c220:
			return 0x34055e9f;
		case 0x0000c224:
			return 0x63e0650c;
		case 0x0000c228:
			return 0xb6f5fec5;
		case 0x0000c22c:
			return 0xb9941943;
		case 0x0000c230:
			return 0x9c81b160;
		case 0x0000c234:
			return 0x7e696069;
		case 0x0000c238:
			return 0x4fe4229f;
		case 0x0000c23c:
			return 0x6d33147e;
		case 0x0000c240:
			return 0x4cdb8dd7;
		case 0x0000c244:
			return 0x9c897f5b;
		case 0x0000c248:
			return 0x91cccc3c;
		case 0x0000c24c:
			return 0x3780e95b;
		case 0x0000c250:
			return 0xb7964435;
		case 0x0000c254:
			return 0xbf289eb8;
		case 0x0000c258:
			return 0xe42c2920;
		case 0x0000c25c:
			return 0xd6fe1fc6;
		case 0x0000c260:
			return 0xc62ab380;
		case 0x0000c264:
			return 0x820a9903;
		case 0x0000c268:
			return 0x60f9d61b;
		case 0x0000c26c:
			return 0xac22192a;
		case 0x0000c270:
			return 0x1236bf0c;
		case 0x0000c274:
			return 0x67595d82;
		case 0x0000c278:
			return 0x31c4a634;
		case 0x0000c27c:
			return 0xd228d55e;
		case 0x0000c280:
			return 0x126f37d5;
		case 0x0000c284:
			return 0xfbd03058;
		case 0x0000c288:
			return 0x0c82b6e6;
		case 0x0000c28c:
			return 0xf79552e7;
		case 0x0000c290:
			return 0xd34a6181;
		case 0x0000c294:
			return 0xae04f723;
		case 0x0000c298:
			return 0x45fd34a9;
		case 0x0000c29c:
			return 0x16073845;
		case 0x0000c2a0:
			return 0x2c0d3072;
		case 0x0000c2a4:
			return 0xa1c6b3be;
		case 0x0000c2a8:
			return 0xd782d65e;
		case 0x0000c2ac:
			return 0xeb64b3b4;
		case 0x0000c2b0:
			return 0xc38e4a25;
		case 0x0000c2b4:
			return 0x57e6dd23;
		case 0x0000c2b8:
			return 0x68716c7a;
		case 0x0000c2bc:
			return 0x8a0a6384;
		case 0x0000c2c0:
			return 0x94883cad;
		case 0x0000c2c4:
			return 0xc5afc5ee;
		case 0x0000c2c8:
			return 0x7f21d95c;
		case 0x0000c2cc:
			return 0xa3ac2c72;
		case 0x0000c2d0:
			return 0x9e9d4258;
		case 0x0000c2d4:
			return 0x6755c6c0;
		case 0x0000c2d8:
			return 0x3ad1c15d;
		case 0x0000c2dc:
			return 0x9670dce0;
		case 0x0000c2e0:
			return 0x938dacf3;
		case 0x0000c2e4:
			return 0x57a2593a;
		case 0x0000c2e8:
			return 0xa3e52bb4;
		case 0x0000c2ec:
			return 0xf37f8b58;
		case 0x0000c2f0:
			return 0xa2b1ba8e;
		case 0x0000c2f4:
			return 0x7973b5f8;
		case 0x0000c2f8:
			return 0xd8c4eded;
		case 0x0000c2fc:
			return 0x27e9c0c2;
		case 0x0000c300:
			return 0x07cfffb7;
		case 0x0000c304:
			return 0xbd6e047c;
		case 0x0000c308:
			return 0x949e9ee0;
		case 0x0000c30c:
			return 0x05ebdb04;
		case 0x0000c310:
			return 0x3517a2cc;
		case 0x0000c314:
			return 0x6cc9ce86;
		case 0x0000c318:
			return 0x538cd6c2;
		case 0x0000c31c:
			return 0xc09c4b1f;
		case 0x0000c320:
			return 0x35cdd47b;
		case 0x0000c324:
			return 0x4da0bc71;
		case 0x0000c328:
			return 0x9e96d9d9;
		case 0x0000c32c:
			return 0x077dda93;
		case 0x0000c330:
			return 0x4e0bec22;
		case 0x0000c334:
			return 0xb6ba0fe2;
		case 0x0000c338:
			return 0xd0e8d41c;
		case 0x0000c33c:
			return 0x900b563d;
		case 0x0000c340:
			return 0x37fa8d68;
		case 0x0000c344:
			return 0x9ba4d78d;
		case 0x0000c348:
			return 0x5f64e113;
		case 0x0000c34c:
			return 0xbbb9fa77;
		case 0x0000c350:
			return 0xd9244ee2;
		case 0x0000c354:
			return 0x09ef8240;
		case 0x0000c358:
			return 0xd5aadd06;
		case 0x0000c35c:
			return 0xb5c86d01;
		case 0x0000c360:
			return 0xc6a4b1f0;
		case 0x0000c364:
			return 0xe6ec0fb1;
		case 0x0000c368:
			return 0x61047d3f;
		case 0x0000c36c:
			return 0xf987e943;
		case 0x0000c370:
			return 0xcc74a463;
		case 0x0000c374:
			return 0xbc9fad60;
		case 0x0000c378:
			return 0xf6ea1590;
		case 0x0000c37c:
			return 0x86be3027;
		case 0x0000c380:
			return 0x358396ba;
		case 0x0000c384:
			return 0x742ffdea;
		case 0x0000c388:
			return 0x1e4fe32a;
		case 0x0000c38c:
			return 0xe1e09d3a;
		case 0x0000c390:
			return 0xdc04e990;
		case 0x0000c394:
			return 0x5ba9c0f6;
		case 0x0000c398:
			return 0x3e621f60;
		case 0x0000c39c:
			return 0x28358c13;
		case 0x0000c3a0:
			return 0x4532f510;
		case 0x0000c3a4:
			return 0x68033305;
		case 0x0000c3a8:
			return 0x451c2140;
		case 0x0000c3ac:
			return 0xadeca778;
		case 0x0000c3b0:
			return 0xc29e0a0b;
		case 0x0000c3b4:
			return 0xc7c040f9;
		case 0x0000c3b8:
			return 0xa95c7c7a;
		case 0x0000c3bc:
			return 0xb344de66;
		case 0x0000c3c0:
			return 0xb7479ee4;
		case 0x0000c3c4:
			return 0xdfe35de5;
		case 0x0000c3c8:
			return 0x8e509815;
		case 0x0000c3cc:
			return 0x42dd53e5;
		case 0x0000c3d0:
			return 0x36f8c48c;
		case 0x0000c3d4:
			return 0x93c782d7;
		case 0x0000c3d8:
			return 0xfe7917e1;
		case 0x0000c3dc:
			return 0xb73034a1;
		case 0x0000c3e0:
			return 0x24a69b12;
		case 0x0000c3e4:
			return 0xfa6a623e;
		case 0x0000c3e8:
			return 0x6edaf846;
		case 0x0000c3ec:
			return 0x061f6e5f;
		case 0x0000c3f0:
			return 0x4d15450a;
		case 0x0000c3f4:
			return 0x31b309f8;
		case 0x0000c3f8:
			return 0x089886e6;
		case 0x0000c3fc:
			return 0x165cc010;
		case 0x0000c400:
			return 0x3acac0ea;
		case 0x0000c404:
			return 0xd32e856a;
		case 0x0000c408:
			return 0xf1ede45a;
		case 0x0000c40c:
			return 0xdea45997;
		case 0x0000c410:
			return 0x5b0142e8;
		case 0x0000c414:
			return 0xad5365dd;
		case 0x0000c418:
			return 0x61745dd8;
		case 0x0000c41c:
			return 0x2c9eba6a;
		case 0x0000c420:
			return 0x4e52f0d9;
		case 0x0000c424:
			return 0x5feba316;
		case 0x0000c428:
			return 0x28877ac4;
		case 0x0000c42c:
			return 0xebda2f03;
		case 0x0000c430:
			return 0x8daae201;
		case 0x0000c434:
			return 0xb087b9b4;
		case 0x0000c438:
			return 0xd2fdd2e5;
		case 0x0000c43c:
			return 0x0c1055fc;
		case 0x0000c440:
			return 0x77ed3091;
		case 0x0000c444:
			return 0x58889ba0;
		case 0x0000c448:
			return 0x1f058195;
		case 0x0000c44c:
			return 0x7e6d7d81;
		case 0x0000c450:
			return 0xae596b5b;
		case 0x0000c454:
			return 0x726a0fb9;
		case 0x0000c458:
			return 0x02b8de55;
		case 0x0000c45c:
			return 0xa3cb2e8a;
		case 0x0000c460:
			return 0x217d2527;
		case 0x0000c464:
			return 0xaa3e73f7;
		case 0x0000c468:
			return 0x0faad647;
		case 0x0000c46c:
			return 0xe94ceeff;
		case 0x0000c470:
			return 0x84483934;
		case 0x0000c474:
			return 0xe369a93f;
		case 0x0000c478:
			return 0x2ebf7524;
		case 0x0000c47c:
			return 0xd2abac6a;
		case 0x0000c480:
			return 0x23e6d6d7;
		case 0x0000c484:
			return 0x9d2400aa;
		case 0x0000c488:
			return 0x98f89516;
		case 0x0000c48c:
			return 0x7ca40710;
		case 0x0000c490:
			return 0x989d9fb3;
		case 0x0000c494:
			return 0x9e7daf1f;
		case 0x0000c498:
			return 0x06a71389;
		case 0x0000c49c:
			return 0x9b1cca99;
		case 0x0000c4a0:
			return 0xcde8fb89;
		case 0x0000c4a4:
			return 0x698d3112;
		case 0x0000c4a8:
			return 0x8cbd13ab;
		case 0x0000c4ac:
			return 0x17bfa5b9;
		case 0x0000c4b0:
			return 0xee536242;
		case 0x0000c4b4:
			return 0x5545e831;
		case 0x0000c4b8:
			return 0x0a884bd2;
		case 0x0000c4bc:
			return 0xc16f7fdf;
		case 0x0000c4c0:
			return 0x641f00ca;
		case 0x0000c4c4:
			return 0x541f7f9d;
		case 0x0000c4c8:
			return 0x31afbcf1;
		case 0x0000c4cc:
			return 0xf4d37b6c;
		case 0x0000c4d0:
			return 0xbefe80ba;
		case 0x0000c4d4:
			return 0x2e034716;
		case 0x0000c4d8:
			return 0xf07868b8;
		case 0x0000c4dc:
			return 0x3c223221;
		case 0x0000c4e0:
			return 0x77982855;
		case 0x0000c4e4:
			return 0x77c6f847;
		case 0x0000c4e8:
			return 0x74b24803;
		case 0x0000c4ec:
			return 0x2a6e5ee1;
		case 0x0000c4f0:
			return 0xbd38a238;
		case 0x0000c4f4:
			return 0x25a46f94;
		case 0x0000c4f8:
			return 0xc22ff78f;
		case 0x0000c4fc:
			return 0xeafae296;
		case 0x0000c500:
			return 0xe28e3b65;
		case 0x0000c504:
			return 0xf061ddf1;
		case 0x0000c508:
			return 0x1a62246f;
		case 0x0000c50c:
			return 0xf0ad3f06;
		case 0x0000c510:
			return 0xc7fe8f9a;
		case 0x0000c514:
			return 0x590096c4;
		case 0x0000c518:
			return 0xe050fbee;
		case 0x0000c51c:
			return 0xf09d9673;
		case 0x0000c520:
			return 0x935cfa25;
		case 0x0000c524:
			return 0xcd494b75;
		case 0x0000c528:
			return 0x6798377f;
		case 0x0000c52c:
			return 0x747a51fd;
		case 0x0000c530:
			return 0xf9c212f5;
		case 0x0000c534:
			return 0xb53211b5;
		case 0x0000c538:
			return 0xe465b9b8;
		case 0x0000c53c:
			return 0xed5474e2;
		case 0x0000c540:
			return 0x5402adb0;
		case 0x0000c544:
			return 0x04b67914;
		case 0x0000c548:
			return 0x8a2d75e8;
		case 0x0000c54c:
			return 0x6d92320e;
		case 0x0000c550:
			return 0xdee89522;
		case 0x0000c554:
			return 0x4bb67991;
		case 0x0000c558:
			return 0xf9f2f390;
		case 0x0000c55c:
			return 0x59da9621;
		case 0x0000c560:
			return 0x9bae0517;
		case 0x0000c564:
			return 0x1ae8c8f4;
		case 0x0000c568:
			return 0x3b2954f3;
		case 0x0000c56c:
			return 0xfd261bf0;
		case 0x0000c570:
			return 0x54ae1d09;
		case 0x0000c574:
			return 0xcb88cb0c;
		case 0x0000c578:
			return 0x8758d877;
		case 0x0000c57c:
			return 0xfae092b4;
		case 0x0000c580:
			return 0xf38c2f95;
		case 0x0000c584:
			return 0xcd288de1;
		case 0x0000c588:
			return 0x120dc1f8;
		case 0x0000c58c:
			return 0x84e11e6b;
		case 0x0000c590:
			return 0xcac2cd81;
		case 0x0000c594:
			return 0x83a63aea;
		case 0x0000c598:
			return 0xea18bad1;
		case 0x0000c59c:
			return 0x4d50f341;
		case 0x0000c5a0:
			return 0x247a6dc4;
		case 0x0000c5a4:
			return 0xc90e09ac;
		case 0x0000c5a8:
			return 0x15e72675;
		case 0x0000c5ac:
			return 0xcea396fc;
		case 0x0000c5b0:
			return 0xa16ad4bf;
		case 0x0000c5b4:
			return 0xfbf37ff3;
		case 0x0000c5b8:
			return 0x4fb6197f;
		case 0x0000c5bc:
			return 0xe921bc82;
		case 0x0000c5c0:
			return 0x3f33186d;
		case 0x0000c5c4:
			return 0x1d8fada3;
		case 0x0000c5c8:
			return 0x2017eba8;
		case 0x0000c5cc:
			return 0xe6592ed8;
		case 0x0000c5d0:
			return 0x278c115a;
		case 0x0000c5d4:
			return 0xad62bece;
		case 0x0000c5d8:
			return 0x9b895c42;
		case 0x0000c5dc:
			return 0x674dcb5a;
		case 0x0000c5e0:
			return 0x33ebdeb2;
		case 0x0000c5e4:
			return 0xb778fe73;
		case 0x0000c5e8:
			return 0xf465d332;
		case 0x0000c5ec:
			return 0xd0bf8253;
		case 0x0000c5f0:
			return 0x256d129b;
		case 0x0000c5f4:
			return 0xffb0d6c9;
		case 0x0000c5f8:
			return 0x677d8594;
		case 0x0000c5fc:
			return 0x0e72528b;
		case 0x0000c600:
			return 0xeeb920fe;
		case 0x0000c604:
			return 0x1b95b2c9;
		case 0x0000c608:
			return 0x02042512;
		case 0x0000c60c:
			return 0xadadb195;
		case 0x0000c610:
			return 0x8d3ddd1f;
		case 0x0000c614:
			return 0x7b9526cb;
		case 0x0000c618:
			return 0x0217117a;
		case 0x0000c61c:
			return 0xdf417b4e;
		case 0x0000c620:
			return 0xcc4e61c9;
		case 0x0000c624:
			return 0x680ec04e;
		case 0x0000c628:
			return 0xdd1400a6;
		case 0x0000c62c:
			return 0x92ccd8a7;
		case 0x0000c630:
			return 0xdb993444;
		case 0x0000c634:
			return 0x339fca33;
		case 0x0000c638:
			return 0x45a6be19;
		case 0x0000c63c:
			return 0x592c7cbb;
		case 0x0000c640:
			return 0x00709976;
		case 0x0000c644:
			return 0xe181f2c5;
		case 0x0000c648:
			return 0x0468288f;
		case 0x0000c64c:
			return 0x2c4ec2be;
		case 0x0000c650:
			return 0xee9e89ae;
		case 0x0000c654:
			return 0xaeed5b74;
		case 0x0000c658:
			return 0x244a539c;
		case 0x0000c65c:
			return 0x37921cd6;
		case 0x0000c660:
			return 0xaef9aefd;
		case 0x0000c664:
			return 0x1eb84155;
		case 0x0000c668:
			return 0x6227fd87;
		case 0x0000c66c:
			return 0x24d2d03d;
		case 0x0000c670:
			return 0x91cb8214;
		case 0x0000c674:
			return 0xf4c1b38c;
		case 0x0000c678:
			return 0xde9a6e06;
		case 0x0000c67c:
			return 0x50bffddd;
		case 0x0000c680:
			return 0x96ad7460;
		case 0x0000c684:
			return 0x5007cdf8;
		case 0x0000c688:
			return 0x367edafe;
		case 0x0000c68c:
			return 0x670eb765;
		case 0x0000c690:
			return 0x9dc4c46b;
		case 0x0000c694:
			return 0xda6838b3;
		case 0x0000c698:
			return 0x54e95a7f;
		case 0x0000c69c:
			return 0xc3dacb80;
		case 0x0000c6a0:
			return 0x42aa696a;
		case 0x0000c6a4:
			return 0x79711029;
		case 0x0000c6a8:
			return 0x11a110d9;
		case 0x0000c6ac:
			return 0x83a90f9c;
		case 0x0000c6b0:
			return 0xcc03365d;
		case 0x0000c6b4:
			return 0x55e91698;
		case 0x0000c6b8:
			return 0x3992058f;
		case 0x0000c6bc:
			return 0xbaf65d75;
		case 0x0000c6c0:
			return 0x5cec318e;
		case 0x0000c6c4:
			return 0xcf475590;
		case 0x0000c6c8:
			return 0x8364dcb5;
		case 0x0000c6cc:
			return 0xb70630c5;
		case 0x0000c6d0:
			return 0xd5927718;
		case 0x0000c6d4:
			return 0x92ac02a3;
		case 0x0000c6d8:
			return 0xeddcf83e;
		case 0x0000c6dc:
			return 0x6e10d605;
		case 0x0000c6e0:
			return 0xe3cad9fd;
		case 0x0000c6e4:
			return 0x59cf5347;
		case 0x0000c6e8:
			return 0x0681f85e;
		case 0x0000c6ec:
			return 0xf75d57d9;
		case 0x0000c6f0:
			return 0xf305c193;
		case 0x0000c6f4:
			return 0x6aaf1391;
		case 0x0000c6f8:
			return 0x52367717;
		case 0x0000c6fc:
			return 0xdee7f9c8;
		case 0x0000c700:
			return 0x35e8a519;
		case 0x0000c704:
			return 0x42f070ee;
		case 0x0000c708:
			return 0x7a82fd3d;
		case 0x0000c70c:
			return 0xb45afeb4;
		case 0x0000c710:
			return 0x680c4492;
		case 0x0000c714:
			return 0x2bc60a58;
		case 0x0000c718:
			return 0x68e70fd5;
		case 0x0000c71c:
			return 0x8b2e56ba;
		case 0x0000c720:
			return 0x3ce2633c;
		case 0x0000c724:
			return 0x38fbe573;
		case 0x0000c728:
			return 0x714ffff1;
		case 0x0000c72c:
			return 0xd7007b3b;
		case 0x0000c730:
			return 0xdbdc7af6;
		case 0x0000c734:
			return 0xb6aa6b63;
		case 0x0000c738:
			return 0xd6e729f6;
		case 0x0000c73c:
			return 0xc049b2ac;
		case 0x0000c740:
			return 0xc1254a44;
		case 0x0000c744:
			return 0xc1d261d5;
		case 0x0000c748:
			return 0xbab032ce;
		case 0x0000c74c:
			return 0xd69ddbca;
		case 0x0000c750:
			return 0xef36b258;
		case 0x0000c754:
			return 0x926cb697;
		case 0x0000c758:
			return 0x9239b7d6;
		case 0x0000c75c:
			return 0x67c37c5c;
		case 0x0000c760:
			return 0x977d1d57;
		case 0x0000c764:
			return 0xf0fd2902;
		case 0x0000c768:
			return 0xb26e7c37;
		case 0x0000c76c:
			return 0x027fc839;
		case 0x0000c770:
			return 0xa9858004;
		case 0x0000c774:
			return 0x6ce08243;
		case 0x0000c778:
			return 0xd73b84d4;
		case 0x0000c77c:
			return 0xa086e478;
		case 0x0000c780:
			return 0x95fee645;
		case 0x0000c784:
			return 0xa152be71;
		case 0x0000c788:
			return 0x3a9d958e;
		case 0x0000c78c:
			return 0x2daade4b;
		case 0x0000c790:
			return 0xfc44d158;
		case 0x0000c794:
			return 0xf75638a2;
		case 0x0000c798:
			return 0xe6b15021;
		case 0x0000c79c:
			return 0x7e6aa791;
		case 0x0000c7a0:
			return 0xb807818b;
		case 0x0000c7a4:
			return 0x7dba4119;
		case 0x0000c7a8:
			return 0x2f9c5fcc;
		case 0x0000c7ac:
			return 0x0463c298;
		case 0x0000c7b0:
			return 0xf10fde6f;
		case 0x0000c7b4:
			return 0xfba07538;
		case 0x0000c7b8:
			return 0x8802f244;
		case 0x0000c7bc:
			return 0x77b229e8;
		case 0x0000c7c0:
			return 0x2dbe2c5c;
		case 0x0000c7c4:
			return 0xf02e5f63;
		case 0x0000c7c8:
			return 0x531f3dcd;
		case 0x0000c7cc:
			return 0xd1f83c45;
		case 0x0000c7d0:
			return 0x6ff202a4;
		case 0x0000c7d4:
			return 0xdfae3dc6;
		case 0x0000c7d8:
			return 0x599e6bd9;
		case 0x0000c7dc:
			return 0x69d70d62;
		case 0x0000c7e0:
			return 0x07a11fa9;
		case 0x0000c7e4:
			return 0x21c93e07;
		case 0x0000c7e8:
			return 0xa203fc09;
		case 0x0000c7ec:
			return 0x877a5038;
		case 0x0000c7f0:
			return 0x037673f5;
		case 0x0000c7f4:
			return 0x3565354f;
		case 0x0000c7f8:
			return 0x44ebb7d2;
		case 0x0000c7fc:
			return 0x7bd25b8b;
		case 0x0000c800:
			return 0x0df014a9;
		case 0x0000c804:
			return 0x42616acd;
		case 0x0000c808:
			return 0x2ee91a81;
		case 0x0000c80c:
			return 0x23b780e4;
		case 0x0000c810:
			return 0x7ffe4659;
		case 0x0000c814:
			return 0xdf1a4b8e;
		case 0x0000c818:
			return 0x19612dea;
		case 0x0000c81c:
			return 0xb6de335a;
		case 0x0000c820:
			return 0x32985f02;
		case 0x0000c824:
			return 0x9f68dd83;
		case 0x0000c828:
			return 0x3350c75f;
		case 0x0000c82c:
			return 0x06d26641;
		case 0x0000c830:
			return 0xf4b537b4;
		case 0x0000c834:
			return 0xc83b6fd3;
		case 0x0000c838:
			return 0xb400b68f;
		case 0x0000c83c:
			return 0x64ba663d;
		case 0x0000c840:
			return 0x87e36fac;
		case 0x0000c844:
			return 0x79733187;
		case 0x0000c848:
			return 0x5f22a373;
		case 0x0000c84c:
			return 0xedfe9b68;
		case 0x0000c850:
			return 0x88818213;
		case 0x0000c854:
			return 0xcc06c3c8;
		case 0x0000c858:
			return 0xdf0d8c60;
		case 0x0000c85c:
			return 0xcbc62cc1;
		case 0x0000c860:
			return 0xc6f612e5;
		case 0x0000c864:
			return 0xdef47733;
		case 0x0000c868:
			return 0x379a9ad0;
		case 0x0000c86c:
			return 0x53244e66;
		case 0x0000c870:
			return 0xb7492cba;
		case 0x0000c874:
			return 0x273516ad;
		case 0x0000c878:
			return 0xef518897;
		case 0x0000c87c:
			return 0x1bb5ecb6;
		case 0x0000c880:
			return 0x39219538;
		case 0x0000c884:
			return 0x054cb0f4;
		case 0x0000c888:
			return 0x99dad710;
		case 0x0000c88c:
			return 0x196db12f;
		case 0x0000c890:
			return 0x76f6cc79;
		case 0x0000c894:
			return 0x7809f77a;
		case 0x0000c898:
			return 0x2fdb2e64;
		case 0x0000c89c:
			return 0x9ef8c90a;
		case 0x0000c8a0:
			return 0xd5386600;
		case 0x0000c8a4:
			return 0x89d3b27a;
		case 0x0000c8a8:
			return 0x586ca132;
		case 0x0000c8ac:
			return 0xc4aadf74;
		case 0x0000c8b0:
			return 0x6a6a894e;
		case 0x0000c8b4:
			return 0x32ee866b;
		case 0x0000c8b8:
			return 0x83583385;
		case 0x0000c8bc:
			return 0xea780f6e;
		case 0x0000c8c0:
			return 0x3ab026b5;
		case 0x0000c8c4:
			return 0xf445a2e8;
		case 0x0000c8c8:
			return 0xd8aad38a;
		case 0x0000c8cc:
			return 0xd3fd3865;
		case 0x0000c8d0:
			return 0x3bd5d537;
		case 0x0000c8d4:
			return 0xd0b9766e;
		case 0x0000c8d8:
			return 0xe949d1d8;
		case 0x0000c8dc:
			return 0x5de326cf;
		case 0x0000c8e0:
			return 0xfc4a29a6;
		case 0x0000c8e4:
			return 0xe17dde88;
		case 0x0000c8e8:
			return 0xf5424508;
		case 0x0000c8ec:
			return 0x8ade4abb;
		case 0x0000c8f0:
			return 0x7909c237;
		case 0x0000c8f4:
			return 0x1d1c3e07;
		case 0x0000c8f8:
			return 0xbefbb9ec;
		case 0x0000c8fc:
			return 0x62a33bc1;
		case 0x0000c900:
			return 0x42dd7278;
		case 0x0000c904:
			return 0x79bdecf9;
		case 0x0000c908:
			return 0xea60daef;
		case 0x0000c90c:
			return 0x4d2acf7e;
		case 0x0000c910:
			return 0xa3745777;
		case 0x0000c914:
			return 0x89d76346;
		case 0x0000c918:
			return 0x5d4dbbcc;
		case 0x0000c91c:
			return 0x0c1a9fdd;
		case 0x0000c920:
			return 0x78ec303b;
		case 0x0000c924:
			return 0x330c49bd;
		case 0x0000c928:
			return 0x61a2c103;
		case 0x0000c92c:
			return 0x0f03959b;
		case 0x0000c930:
			return 0x1bd5148c;
		case 0x0000c934:
			return 0x8b0fe012;
		case 0x0000c938:
			return 0xfea8463c;
		case 0x0000c93c:
			return 0x11c313db;
		case 0x0000c940:
			return 0xd78425f5;
		case 0x0000c944:
			return 0x7160bda8;
		case 0x0000c948:
			return 0x390145d0;
		case 0x0000c94c:
			return 0x22f4b636;
		case 0x0000c950:
			return 0x26599194;
		case 0x0000c954:
			return 0x3c7dcc35;
		case 0x0000c958:
			return 0x53ec894e;
		case 0x0000c95c:
			return 0xe0445969;
		case 0x0000c960:
			return 0x57e510ef;
		case 0x0000c964:
			return 0xfb5cf9d2;
		case 0x0000c968:
			return 0xca59e354;
		case 0x0000c96c:
			return 0x3374f3b7;
		case 0x0000c970:
			return 0x6ff26365;
		case 0x0000c974:
			return 0xa4b2dc95;
		case 0x0000c978:
			return 0xcc40134c;
		case 0x0000c97c:
			return 0x70f39c37;
		case 0x0000c980:
			return 0xf44a2f01;
		case 0x0000c984:
			return 0xe7abddb8;
		case 0x0000c988:
			return 0x77f40516;
		case 0x0000c98c:
			return 0xd16e8dc1;
		case 0x0000c990:
			return 0xd61e86f7;
		case 0x0000c994:
			return 0xe99571c4;
		case 0x0000c998:
			return 0x0e9ba693;
		case 0x0000c99c:
			return 0xb8920c88;
		case 0x0000c9a0:
			return 0x0b6fe233;
		case 0x0000c9a4:
			return 0x384cf6dc;
		case 0x0000c9a8:
			return 0xdb690d1a;
		case 0x0000c9ac:
			return 0xcde93e9f;
		case 0x0000c9b0:
			return 0x95b73d91;
		case 0x0000c9b4:
			return 0x3530742d;
		case 0x0000c9b8:
			return 0x3196884d;
		case 0x0000c9bc:
			return 0x8cbd0b1d;
		case 0x0000c9c0:
			return 0x7cebde43;
		case 0x0000c9c4:
			return 0x4605c76b;
		case 0x0000c9c8:
			return 0x9392584c;
		case 0x0000c9cc:
			return 0xfadfa8fa;
		case 0x0000c9d0:
			return 0x268b11d0;
		case 0x0000c9d4:
			return 0x40b4255f;
		case 0x0000c9d8:
			return 0xb34bcaa7;
		case 0x0000c9dc:
			return 0xf7a260fc;
		case 0x0000c9e0:
			return 0x033d94a2;
		case 0x0000c9e4:
			return 0xa6e75bae;
		case 0x0000c9e8:
			return 0xacbcc0fe;
		case 0x0000c9ec:
			return 0xc232aaf2;
		case 0x0000c9f0:
			return 0x8b0e2e4d;
		case 0x0000c9f4:
			return 0x37a2519d;
		case 0x0000c9f8:
			return 0x77ddce5f;
		case 0x0000c9fc:
			return 0xeefe55a7;
		case 0x0000ca00:
			return 0xd73c43d5;
		case 0x0000ca04:
			return 0x348a94ed;
		case 0x0000ca08:
			return 0x961aeb26;
		case 0x0000ca0c:
			return 0xfa0a3598;
		case 0x0000ca10:
			return 0x7531954a;
		case 0x0000ca14:
			return 0x8bc9342d;
		case 0x0000ca18:
			return 0x1907a086;
		case 0x0000ca1c:
			return 0x22fa2acd;
		case 0x0000ca20:
			return 0x020f3d33;
		case 0x0000ca24:
			return 0x9b19c690;
		case 0x0000ca28:
			return 0x41847a4e;
		case 0x0000ca2c:
			return 0x94bea402;
		case 0x0000ca30:
			return 0x3de9a6e5;
		case 0x0000ca34:
			return 0x78a4fd6d;
		case 0x0000ca38:
			return 0x09b7b39a;
		case 0x0000ca3c:
			return 0xa2481b27;
		case 0x0000ca40:
			return 0x56257526;
		case 0x0000ca44:
			return 0xba3abedc;
		case 0x0000ca48:
			return 0xa99a7d18;
		case 0x0000ca4c:
			return 0xb108dd52;
		case 0x0000ca50:
			return 0x379e9e26;
		case 0x0000ca54:
			return 0x8afe6b07;
		case 0x0000ca58:
			return 0x85d1a87a;
		case 0x0000ca5c:
			return 0x29198dc1;
		case 0x0000ca60:
			return 0x9ae28bd1;
		case 0x0000ca64:
			return 0x88bb1a96;
		case 0x0000ca68:
			return 0x69380a14;
		case 0x0000ca6c:
			return 0xa556a185;
		case 0x0000ca70:
			return 0x156c514d;
		case 0x0000ca74:
			return 0x717af4d2;
		case 0x0000ca78:
			return 0x27e94c64;
		case 0x0000ca7c:
			return 0xd19da38c;
		case 0x0000ca80:
			return 0x1934a158;
		case 0x0000ca84:
			return 0xa342d38b;
		case 0x0000ca88:
			return 0x664bf1f7;
		case 0x0000ca8c:
			return 0x0f2c273e;
		case 0x0000ca90:
			return 0x4e5d35bf;
		case 0x0000ca94:
			return 0x1dc7758e;
		case 0x0000ca98:
			return 0xb569e6e8;
		case 0x0000ca9c:
			return 0x06c48109;
		case 0x0000caa0:
			return 0x6ed5ed06;
		case 0x0000caa4:
			return 0xc4ffa543;
		case 0x0000caa8:
			return 0xdf128027;
		case 0x0000caac:
			return 0xa6e9f088;
		case 0x0000cab0:
			return 0x525a4f30;
		case 0x0000cab4:
			return 0x0141d3bf;
		case 0x0000cab8:
			return 0xcbd75a69;
		case 0x0000cabc:
			return 0x57580077;
		case 0x0000cac0:
			return 0x27d93e12;
		case 0x0000cac4:
			return 0x7d7b7f65;
		case 0x0000cac8:
			return 0x7535a6b8;
		case 0x0000cacc:
			return 0xb6ebacf9;
		case 0x0000cad0:
			return 0xfa5c63c9;
		case 0x0000cad4:
			return 0x567c3534;
		case 0x0000cad8:
			return 0x4de30486;
		case 0x0000cadc:
			return 0x04df2561;
		case 0x0000cae0:
			return 0xf74e00da;
		case 0x0000cae4:
			return 0x35d1f202;
		case 0x0000cae8:
			return 0x98cda51d;
		case 0x0000caec:
			return 0x0aa93d66;
		case 0x0000caf0:
			return 0x422716fe;
		case 0x0000caf4:
			return 0x7874e7e0;
		case 0x0000caf8:
			return 0xf1c95c32;
		case 0x0000cafc:
			return 0x35bcec0a;
		case 0x0000cb00:
			return 0xac4b1084;
		case 0x0000cb04:
			return 0xab6cb216;
		case 0x0000cb08:
			return 0xba02a493;
		case 0x0000cb0c:
			return 0xbf364d6d;
		case 0x0000cb10:
			return 0x807ee397;
		case 0x0000cb14:
			return 0x7ff012d5;
		case 0x0000cb18:
			return 0xbc5aa399;
		case 0x0000cb1c:
			return 0xdabcd244;
		case 0x0000cb20:
			return 0x55b161c1;
		case 0x0000cb24:
			return 0x4bd724c0;
		case 0x0000cb28:
			return 0x715354d6;
		case 0x0000cb2c:
			return 0xd25ef7b2;
		case 0x0000cb30:
			return 0xb8db7344;
		case 0x0000cb34:
			return 0x14370a6c;
		case 0x0000cb38:
			return 0x82e2e2c7;
		case 0x0000cb3c:
			return 0x3c3f35b7;
		case 0x0000cb40:
			return 0x655eaddf;
		case 0x0000cb44:
			return 0xec9c896d;
		case 0x0000cb48:
			return 0x6930c57f;
		case 0x0000cb4c:
			return 0x5fb9f722;
		case 0x0000cb50:
			return 0x633ab488;
		case 0x0000cb54:
			return 0xf953af1b;
		case 0x0000cb58:
			return 0xb875af77;
		case 0x0000cb5c:
			return 0x58a0a20b;
		case 0x0000cb60:
			return 0x46e97f3b;
		case 0x0000cb64:
			return 0xc7d84c42;
		case 0x0000cb68:
			return 0xfc9693f6;
		case 0x0000cb6c:
			return 0x528964c3;
		case 0x0000cb70:
			return 0x364202a1;
		case 0x0000cb74:
			return 0xa61b28d0;
		case 0x0000cb78:
			return 0x29ab16ee;
		case 0x0000cb7c:
			return 0xacf69e2e;
		case 0x0000cb80:
			return 0x22c344ba;
		case 0x0000cb84:
			return 0xc23a4947;
		case 0x0000cb88:
			return 0x6a2443d6;
		case 0x0000cb8c:
			return 0x8acca8ae;
		case 0x0000cb90:
			return 0xfd445bc6;
		case 0x0000cb94:
			return 0xdaa607e8;
		case 0x0000cb98:
			return 0x3a8c7484;
		case 0x0000cb9c:
			return 0xbadfa7ba;
		case 0x0000cba0:
			return 0xc6de2f9e;
		case 0x0000cba4:
			return 0x7a9de282;
		case 0x0000cba8:
			return 0x0142039b;
		case 0x0000cbac:
			return 0x52d8d2fc;
		case 0x0000cbb0:
			return 0xdb7a3f37;
		case 0x0000cbb4:
			return 0x7f888229;
		case 0x0000cbb8:
			return 0xd0c910fa;
		case 0x0000cbbc:
			return 0xf2b15458;
		case 0x0000cbc0:
			return 0x65617f7e;
		case 0x0000cbc4:
			return 0x91e88b7c;
		case 0x0000cbc8:
			return 0x4b27aca9;
		case 0x0000cbcc:
			return 0x37fb14ec;
		case 0x0000cbd0:
			return 0x9b857516;
		case 0x0000cbd4:
			return 0xf874c08c;
		case 0x0000cbd8:
			return 0x1310c1b7;
		case 0x0000cbdc:
			return 0x848f76c8;
		case 0x0000cbe0:
			return 0xf53d41de;
		case 0x0000cbe4:
			return 0x0801c01c;
		case 0x0000cbe8:
			return 0x2634d118;
		case 0x0000cbec:
			return 0xd50a22b1;
		case 0x0000cbf0:
			return 0xb2b3e92e;
		case 0x0000cbf4:
			return 0x8ab40fe1;
		case 0x0000cbf8:
			return 0xa60485b6;
		case 0x0000cbfc:
			return 0xe8fe27bd;
		case 0x0000cc00:
			return 0x0d5c5b45;
		case 0x0000cc04:
			return 0x8569b05a;
		case 0x0000cc08:
			return 0x6f30530f;
		case 0x0000cc0c:
			return 0xc3899db3;
		case 0x0000cc10:
			return 0x7459ede8;
		case 0x0000cc14:
			return 0x7a387e9a;
		case 0x0000cc18:
			return 0x63587edf;
		case 0x0000cc1c:
			return 0xd83a5b26;
		case 0x0000cc20:
			return 0xcb3ebf7a;
		case 0x0000cc24:
			return 0xcc3f137d;
		case 0x0000cc28:
			return 0x23c02870;
		case 0x0000cc2c:
			return 0x65dda415;
		case 0x0000cc30:
			return 0xaab31b84;
		case 0x0000cc34:
			return 0x1f1ac721;
		case 0x0000cc38:
			return 0xd9aec38b;
		case 0x0000cc3c:
			return 0x1d764a49;
		case 0x0000cc40:
			return 0xa78a7b12;
		case 0x0000cc44:
			return 0xbf018306;
		case 0x0000cc48:
			return 0xfb9d719f;
		case 0x0000cc4c:
			return 0x9056e42d;
		case 0x0000cc50:
			return 0xa5366b2b;
		case 0x0000cc54:
			return 0x5e40b9b5;
		case 0x0000cc58:
			return 0xaf9a1adf;
		case 0x0000cc5c:
			return 0xd41be42b;
		case 0x0000cc60:
			return 0xf9c7345b;
		case 0x0000cc64:
			return 0xc5c7e6ab;
		case 0x0000cc68:
			return 0x4e342cc4;
		case 0x0000cc6c:
			return 0x7f756ccb;
		case 0x0000cc70:
			return 0x5229fc82;
		case 0x0000cc74:
			return 0x43b376dd;
		case 0x0000cc78:
			return 0x544fc22b;
		case 0x0000cc7c:
			return 0xcc24a629;
		case 0x0000cc80:
			return 0xdcf0ae56;
		case 0x0000cc84:
			return 0x9173706b;
		case 0x0000cc88:
			return 0x14319822;
		case 0x0000cc8c:
			return 0xeb90d154;
		case 0x0000cc90:
			return 0x14990027;
		case 0x0000cc94:
			return 0x7f36c5bd;
		case 0x0000cc98:
			return 0xf9bb2352;
		case 0x0000cc9c:
			return 0x37ab2f62;
		case 0x0000cca0:
			return 0xcfe52cb7;
		case 0x0000cca4:
			return 0x6c0cc5d6;
		case 0x0000cca8:
			return 0xd5804e8d;
		case 0x0000ccac:
			return 0xba520f75;
		case 0x0000ccb0:
			return 0xf489d65f;
		case 0x0000ccb4:
			return 0x8a734075;
		case 0x0000ccb8:
			return 0xec611b80;
		case 0x0000ccbc:
			return 0xdbd9621d;
		case 0x0000ccc0:
			return 0x4221bda8;
		case 0x0000ccc4:
			return 0x4a2c8c39;
		case 0x0000ccc8:
			return 0xb7a3ed77;
		case 0x0000cccc:
			return 0x37e3a0f3;
		case 0x0000ccd0:
			return 0xfa52f4df;
		case 0x0000ccd4:
			return 0xcc513ec2;
		case 0x0000ccd8:
			return 0x51ecd8f9;
		case 0x0000ccdc:
			return 0x2c449a59;
		case 0x0000cce0:
			return 0xc4a42cc0;
		case 0x0000cce4:
			return 0xfeff81ce;
		case 0x0000cce8:
			return 0xdaf3ac74;
		case 0x0000ccec:
			return 0x97116da8;
		case 0x0000ccf0:
			return 0x95d3c775;
		case 0x0000ccf4:
			return 0x1b8df95d;
		case 0x0000ccf8:
			return 0x7d770ff0;
		case 0x0000ccfc:
			return 0xbb2e8ba4;
		case 0x0000cd00:
			return 0x511637db;
		case 0x0000cd04:
			return 0x8ad54ab5;
		case 0x0000cd08:
			return 0x042afa64;
		case 0x0000cd0c:
			return 0xfbd73e30;
		case 0x0000cd10:
			return 0x52bb8eae;
		case 0x0000cd14:
			return 0x6acf1004;
		case 0x0000cd18:
			return 0x70f08750;
		case 0x0000cd1c:
			return 0x4a9706c4;
		case 0x0000cd20:
			return 0xd38169cf;
		case 0x0000cd24:
			return 0xce5a04ce;
		case 0x0000cd28:
			return 0x932e29ad;
		case 0x0000cd2c:
			return 0x93fc5a94;
		case 0x0000cd30:
			return 0x20946d75;
		case 0x0000cd34:
			return 0x6df853a4;
		case 0x0000cd38:
			return 0x79902d93;
		case 0x0000cd3c:
			return 0xa867269a;
		case 0x0000cd40:
			return 0x5b3cec6d;
		case 0x0000cd44:
			return 0x1ede2304;
		case 0x0000cd48:
			return 0x0188a471;
		case 0x0000cd4c:
			return 0x199aaee5;
		case 0x0000cd50:
			return 0x5fc8fa25;
		case 0x0000cd54:
			return 0x79d91b1b;
		case 0x0000cd58:
			return 0x2f62d32d;
		case 0x0000cd5c:
			return 0x061d7d77;
		case 0x0000cd60:
			return 0x2bbc74de;
		case 0x0000cd64:
			return 0xf9c967df;
		case 0x0000cd68:
			return 0x3e6f30aa;
		case 0x0000cd6c:
			return 0xfe7bff5d;
		case 0x0000cd70:
			return 0x1f2ad5c6;
		case 0x0000cd74:
			return 0xf0cc7cd7;
		case 0x0000cd78:
			return 0xbca42a96;
		case 0x0000cd7c:
			return 0x17749e2c;
		case 0x0000cd80:
			return 0xb31a7a42;
		case 0x0000cd84:
			return 0x52b171c5;
		case 0x0000cd88:
			return 0xb3d79ae5;
		case 0x0000cd8c:
			return 0x559af8cd;
		case 0x0000cd90:
			return 0xafe2ed1b;
		case 0x0000cd94:
			return 0x5347b150;
		case 0x0000cd98:
			return 0x6ce71442;
		case 0x0000cd9c:
			return 0x6113e3ff;
		case 0x0000cda0:
			return 0xbfb89deb;
		case 0x0000cda4:
			return 0x91d1693d;
		case 0x0000cda8:
			return 0xa395b453;
		case 0x0000cdac:
			return 0xdbb574ea;
		case 0x0000cdb0:
			return 0x121a6414;
		case 0x0000cdb4:
			return 0xa2c2e7fb;
		case 0x0000cdb8:
			return 0x72ee3bd0;
		case 0x0000cdbc:
			return 0x5b87df52;
		case 0x0000cdc0:
			return 0xfdf6b851;
		case 0x0000cdc4:
			return 0x34c2db69;
		case 0x0000cdc8:
			return 0x17f34bbe;
		case 0x0000cdcc:
			return 0x02f8273d;
		case 0x0000cdd0:
			return 0x9e7b695d;
		case 0x0000cdd4:
			return 0xdc3b7f9f;
		case 0x0000cdd8:
			return 0x48133f47;
		case 0x0000cddc:
			return 0xf75d3a80;
		case 0x0000cde0:
			return 0x1bd75307;
		case 0x0000cde4:
			return 0xbd634e60;
		case 0x0000cde8:
			return 0xb1790b07;
		case 0x0000cdec:
			return 0x327893d5;
		case 0x0000cdf0:
			return 0x7f57e3c8;
		case 0x0000cdf4:
			return 0x61658664;
		case 0x0000cdf8:
			return 0x10e7f414;
		case 0x0000cdfc:
			return 0xa4626970;
		case 0x0000ce00:
			return 0xd1c1941c;
		case 0x0000ce04:
			return 0xe106f78d;
		case 0x0000ce08:
			return 0x1821a51c;
		case 0x0000ce0c:
			return 0xad494a2f;
		case 0x0000ce10:
			return 0x93f14461;
		case 0x0000ce14:
			return 0xb1098304;
		case 0x0000ce18:
			return 0x74b92e37;
		case 0x0000ce1c:
			return 0x314ac4cf;
		case 0x0000ce20:
			return 0x7a04bf99;
		case 0x0000ce24:
			return 0xfd64b513;
		case 0x0000ce28:
			return 0x4a9f459a;
		case 0x0000ce2c:
			return 0x2bf0974d;
		case 0x0000ce30:
			return 0xb4b944cb;
		case 0x0000ce34:
			return 0x9f0ddff7;
		case 0x0000ce38:
			return 0xed01f574;
		case 0x0000ce3c:
			return 0x7266ccc9;
		case 0x0000ce40:
			return 0x74360673;
		case 0x0000ce44:
			return 0x7ff68ccd;
		case 0x0000ce48:
			return 0x0914c7ba;
		case 0x0000ce4c:
			return 0x493306aa;
		case 0x0000ce50:
			return 0x3125c1d3;
		case 0x0000ce54:
			return 0xc7abfcce;
		case 0x0000ce58:
			return 0x1ec19394;
		case 0x0000ce5c:
			return 0xfc25c32b;
		case 0x0000ce60:
			return 0x731bd27e;
		case 0x0000ce64:
			return 0x0ea1eafa;
		case 0x0000ce68:
			return 0x89418869;
		case 0x0000ce6c:
			return 0xc75f2957;
		case 0x0000ce70:
			return 0xa9e922ac;
		case 0x0000ce74:
			return 0x44ef4a0c;
		case 0x0000ce78:
			return 0x9ca27e21;
		case 0x0000ce7c:
			return 0xadc3aba6;
		case 0x0000ce80:
			return 0x083a87b2;
		case 0x0000ce84:
			return 0x56fa8a9b;
		case 0x0000ce88:
			return 0xd5d54968;
		case 0x0000ce8c:
			return 0x632e9fb4;
		case 0x0000ce90:
			return 0x3309f0bd;
		case 0x0000ce94:
			return 0x56ab617f;
		case 0x0000ce98:
			return 0x28cb9965;
		case 0x0000ce9c:
			return 0x27e3447d;
		case 0x0000cea0:
			return 0x4f3f1175;
		case 0x0000cea4:
			return 0xe8c960e9;
		case 0x0000cea8:
			return 0xf88d2bd4;
		case 0x0000ceac:
			return 0x6cb3e51a;
		case 0x0000ceb0:
			return 0x431dcb75;
		case 0x0000ceb4:
			return 0xf9b1516e;
		case 0x0000ceb8:
			return 0x8b5fd027;
		case 0x0000cebc:
			return 0x4f1dd098;
		case 0x0000cec0:
			return 0xfda055c9;
		case 0x0000cec4:
			return 0xe19a1303;
		case 0x0000cec8:
			return 0xf3000c40;
		case 0x0000cecc:
			return 0xd841bc86;
		case 0x0000ced0:
			return 0x0bca3298;
		case 0x0000ced4:
			return 0x21babad6;
		case 0x0000ced8:
			return 0x1cc07ff4;
		case 0x0000cedc:
			return 0x6240c2de;
		case 0x0000cee0:
			return 0x867ebae5;
		case 0x0000cee4:
			return 0x15eab5d3;
		case 0x0000cee8:
			return 0x9c8b3646;
		case 0x0000ceec:
			return 0x5e4888f2;
		case 0x0000cef0:
			return 0x2775a481;
		case 0x0000cef4:
			return 0x48ba29ea;
		case 0x0000cef8:
			return 0xbc521d1b;
		case 0x0000cefc:
			return 0xac75d715;
		case 0x0000cf00:
			return 0x30fb3211;
		case 0x0000cf04:
			return 0xb0d30b17;
		case 0x0000cf08:
			return 0x5a54d08d;
		case 0x0000cf0c:
			return 0xa6d398ce;
		case 0x0000cf10:
			return 0xb4dd4ba8;
		case 0x0000cf14:
			return 0x5d579241;
		case 0x0000cf18:
			return 0x3827a096;
		case 0x0000cf1c:
			return 0xe7110f60;
		case 0x0000cf20:
			return 0xd16a8d25;
		case 0x0000cf24:
			return 0x47851d40;
		case 0x0000cf28:
			return 0x3d4b6870;
		case 0x0000cf2c:
			return 0x0bebaa1f;
		case 0x0000cf30:
			return 0x71621ad8;
		case 0x0000cf34:
			return 0x4ce853be;
		case 0x0000cf38:
			return 0x44d984f9;
		case 0x0000cf3c:
			return 0xa89e3011;
		case 0x0000cf40:
			return 0xb2a08bf7;
		case 0x0000cf44:
			return 0x2ed45b28;
		case 0x0000cf48:
			return 0xd9a8f1bb;
		case 0x0000cf4c:
			return 0x80924e56;
		case 0x0000cf50:
			return 0x8cbd7d81;
		case 0x0000cf54:
			return 0x2bd51c4a;
		case 0x0000cf58:
			return 0x7be02ff7;
		case 0x0000cf5c:
			return 0x3a2b18bc;
		case 0x0000cf60:
			return 0x3e1cdc10;
		case 0x0000cf64:
			return 0x3aae8ea1;
		case 0x0000cf68:
			return 0x23dfe080;
		case 0x0000cf6c:
			return 0xa0648de3;
		case 0x0000cf70:
			return 0x5979e2df;
		case 0x0000cf74:
			return 0xf6d20637;
		case 0x0000cf78:
			return 0x1c9877c5;
		case 0x0000cf7c:
			return 0xe09b9085;
		case 0x0000cf80:
			return 0xea6643a2;
		case 0x0000cf84:
			return 0xa92f45f8;
		case 0x0000cf88:
			return 0x22497495;
		case 0x0000cf8c:
			return 0x12876bb9;
		case 0x0000cf90:
			return 0x39f7a802;
		case 0x0000cf94:
			return 0xd720e9f2;
		case 0x0000cf98:
			return 0x10108a32;
		case 0x0000cf9c:
			return 0x7ff66cf7;
		case 0x0000cfa0:
			return 0x97d6dead;
		case 0x0000cfa4:
			return 0xd4dda830;
		case 0x0000cfa8:
			return 0xd2d1feae;
		case 0x0000cfac:
			return 0x1494e91f;
		case 0x0000cfb0:
			return 0x3e100569;
		case 0x0000cfb4:
			return 0x026f8978;
		case 0x0000cfb8:
			return 0x5214951d;
		case 0x0000cfbc:
			return 0x62bec44a;
		case 0x0000cfc0:
			return 0xfe9c7971;
		case 0x0000cfc4:
			return 0xd98c152d;
		case 0x0000cfc8:
			return 0xc1baca50;
		case 0x0000cfcc:
			return 0x56a120f7;
		case 0x0000cfd0:
			return 0xbd41be14;
		case 0x0000cfd4:
			return 0xf3f87878;
		case 0x0000cfd8:
			return 0x02a57733;
		case 0x0000cfdc:
			return 0x55316e90;
		case 0x0000cfe0:
			return 0x6094cfb9;
		case 0x0000cfe4:
			return 0x208e3af8;
		case 0x0000cfe8:
			return 0x6fc0fb7a;
		case 0x0000cfec:
			return 0xe8544070;
		case 0x0000cff0:
			return 0x0ec0274f;
		case 0x0000cff4:
			return 0x4e1e21e6;
		case 0x0000cff8:
			return 0x4522f5f6;
		case 0x0000cffc:
			return 0x801a13b3;
		case 0x0000d000:
			return 0x0d935424;
		case 0x0000d004:
			return 0x0734b577;
		case 0x0000d008:
			return 0x50170a1f;
		case 0x0000d00c:
			return 0xbef81db7;
		case 0x0000d010:
			return 0x8ee4c84a;
		case 0x0000d014:
			return 0xfc87fa79;
		case 0x0000d018:
			return 0x47b9bdca;
		case 0x0000d01c:
			return 0xaf25e692;
		case 0x0000d020:
			return 0x909539db;
		case 0x0000d024:
			return 0x33b94807;
		case 0x0000d028:
			return 0x0569a339;
		case 0x0000d02c:
			return 0x9729a301;
		case 0x0000d030:
			return 0xafe5d16d;
		case 0x0000d034:
			return 0x2e004fe8;
		case 0x0000d038:
			return 0xac78c138;
		case 0x0000d03c:
			return 0xa7b32e02;
		case 0x0000d040:
			return 0xffa0463e;
		case 0x0000d044:
			return 0xb4482ea0;
		case 0x0000d048:
			return 0x7f6056ce;
		case 0x0000d04c:
			return 0x9ccd4e3e;
		case 0x0000d050:
			return 0xff82021f;
		case 0x0000d054:
			return 0xf37a6b7c;
		case 0x0000d058:
			return 0xca396365;
		case 0x0000d05c:
			return 0xe4538d24;
		case 0x0000d060:
			return 0xb07a9bab;
		case 0x0000d064:
			return 0x203a08ad;
		case 0x0000d068:
			return 0xceeb2fd9;
		case 0x0000d06c:
			return 0xd408f3fd;
		case 0x0000d070:
			return 0x2238b3c3;
		case 0x0000d074:
			return 0xc4092a03;
		case 0x0000d078:
			return 0x0c9d5429;
		case 0x0000d07c:
			return 0x2ccdb6ee;
		case 0x0000d080:
			return 0x2956412f;
		case 0x0000d084:
			return 0x0e750eaa;
		case 0x0000d088:
			return 0x81dd1b84;
		case 0x0000d08c:
			return 0x1954d02c;
		case 0x0000d090:
			return 0xfe688e16;
		case 0x0000d094:
			return 0x87ef13dc;
		case 0x0000d098:
			return 0xca0b8404;
		case 0x0000d09c:
			return 0xe26ee39a;
		case 0x0000d0a0:
			return 0x20088609;
		case 0x0000d0a4:
			return 0xda49a0f1;
		case 0x0000d0a8:
			return 0xcb178de7;
		case 0x0000d0ac:
			return 0x170105e4;
		case 0x0000d0b0:
			return 0x8e6ff648;
		case 0x0000d0b4:
			return 0xe9db97b5;
		case 0x0000d0b8:
			return 0x29d91ef1;
		case 0x0000d0bc:
			return 0x09a5d3cf;
		case 0x0000d0c0:
			return 0xb17216e4;
		case 0x0000d0c4:
			return 0x201bf2dc;
		case 0x0000d0c8:
			return 0x7bd6e62f;
		case 0x0000d0cc:
			return 0x076deb8d;
		case 0x0000d0d0:
			return 0xff97f867;
		case 0x0000d0d4:
			return 0x6d017560;
		case 0x0000d0d8:
			return 0xcb232f05;
		case 0x0000d0dc:
			return 0xbf7cf39d;
		case 0x0000d0e0:
			return 0x124adc11;
		case 0x0000d0e4:
			return 0xeeaf439a;
		case 0x0000d0e8:
			return 0xa72aab27;
		case 0x0000d0ec:
			return 0xd13812c2;
		case 0x0000d0f0:
			return 0xd851ff54;
		case 0x0000d0f4:
			return 0xb8f9c814;
		case 0x0000d0f8:
			return 0x6a142782;
		case 0x0000d0fc:
			return 0x2010875e;
		case 0x0000d100:
			return 0xa7688b7b;
		case 0x0000d104:
			return 0x2afcbe04;
		case 0x0000d108:
			return 0xf2e546cb;
		case 0x0000d10c:
			return 0x24b0b227;
		case 0x0000d110:
			return 0x345aaada;
		case 0x0000d114:
			return 0xfe34f8e8;
		case 0x0000d118:
			return 0x5bcd2a54;
		case 0x0000d11c:
			return 0x29d55ba5;
		case 0x0000d120:
			return 0x0a38eec9;
		case 0x0000d124:
			return 0xb6cccb29;
		case 0x0000d128:
			return 0x8ab10f13;
		case 0x0000d12c:
			return 0xf2e129d8;
		case 0x0000d130:
			return 0x3ba6d380;
		case 0x0000d134:
			return 0xea5d7487;
		case 0x0000d138:
			return 0xb993b89e;
		case 0x0000d13c:
			return 0x49d49dbf;
		case 0x0000d140:
			return 0x8aa2aeae;
		case 0x0000d144:
			return 0x5e4465f1;
		case 0x0000d148:
			return 0x0804e696;
		case 0x0000d14c:
			return 0xdf04405f;
		case 0x0000d150:
			return 0x77d89e35;
		case 0x0000d154:
			return 0x3b7d3e23;
		case 0x0000d158:
			return 0x684c1a7c;
		case 0x0000d15c:
			return 0x7ea14c95;
		case 0x0000d160:
			return 0x2ff5794f;
		case 0x0000d164:
			return 0xdf3465bf;
		case 0x0000d168:
			return 0x12368e6a;
		case 0x0000d16c:
			return 0xcb398005;
		case 0x0000d170:
			return 0xbac4bdcb;
		case 0x0000d174:
			return 0x09d05a91;
		case 0x0000d178:
			return 0xba4e3939;
		case 0x0000d17c:
			return 0x69253dbe;
		case 0x0000d180:
			return 0x7ed40fcc;
		case 0x0000d184:
			return 0xf5d3cfb8;
		case 0x0000d188:
			return 0x12e2ea20;
		case 0x0000d18c:
			return 0x565a2842;
		case 0x0000d190:
			return 0xcd052d4a;
		case 0x0000d194:
			return 0xd169a9fa;
		case 0x0000d198:
			return 0x28be7967;
		case 0x0000d19c:
			return 0xe442b73b;
		case 0x0000d1a0:
			return 0x0bcc13da;
		case 0x0000d1a4:
			return 0xa5537883;
		case 0x0000d1a8:
			return 0x874c32e2;
		case 0x0000d1ac:
			return 0xaa4f5bb9;
		case 0x0000d1b0:
			return 0xda6f9a13;
		case 0x0000d1b4:
			return 0xd58d4b5f;
		case 0x0000d1b8:
			return 0xabeba83e;
		case 0x0000d1bc:
			return 0x96721904;
		case 0x0000d1c0:
			return 0xf06b9bf7;
		case 0x0000d1c4:
			return 0x23ea6d4b;
		case 0x0000d1c8:
			return 0xa8ddcf30;
		case 0x0000d1cc:
			return 0xdad31bb8;
		case 0x0000d1d0:
			return 0xa39265cc;
		case 0x0000d1d4:
			return 0xfeff658e;
		case 0x0000d1d8:
			return 0xdae5eb32;
		case 0x0000d1dc:
			return 0x16196770;
		case 0x0000d1e0:
			return 0x59a5253a;
		case 0x0000d1e4:
			return 0x337c4c81;
		case 0x0000d1e8:
			return 0x02155224;
		case 0x0000d1ec:
			return 0x874096cf;
		case 0x0000d1f0:
			return 0x93ebb80e;
		case 0x0000d1f4:
			return 0xada1cd75;
		case 0x0000d1f8:
			return 0xc980e6aa;
		case 0x0000d1fc:
			return 0xa42a495f;
		case 0x0000d200:
			return 0xc770cd77;
		case 0x0000d204:
			return 0xdfbe2f4c;
		case 0x0000d208:
			return 0x17f66cfe;
		case 0x0000d20c:
			return 0xa6032f77;
		case 0x0000d210:
			return 0x5c47ee04;
		case 0x0000d214:
			return 0xffb53579;
		case 0x0000d218:
			return 0x0e578143;
		case 0x0000d21c:
			return 0x4c54ae5d;
		case 0x0000d220:
			return 0xb1bd6910;
		case 0x0000d224:
			return 0x4d4dd5bb;
		case 0x0000d228:
			return 0x407727f1;
		case 0x0000d22c:
			return 0xcb759f36;
		case 0x0000d230:
			return 0x30cbd06f;
		case 0x0000d234:
			return 0x7994a17e;
		case 0x0000d238:
			return 0x95858d97;
		case 0x0000d23c:
			return 0xa8db87cb;
		case 0x0000d240:
			return 0x76170a71;
		case 0x0000d244:
			return 0x2b131e35;
		case 0x0000d248:
			return 0xea0090fc;
		case 0x0000d24c:
			return 0xf813402a;
		case 0x0000d250:
			return 0x53ddb584;
		case 0x0000d254:
			return 0x25d8ccf4;
		case 0x0000d258:
			return 0x129dc692;
		case 0x0000d25c:
			return 0xa43e7926;
		case 0x0000d260:
			return 0xf4de7a77;
		case 0x0000d264:
			return 0x05cb0ac2;
		case 0x0000d268:
			return 0xa29714f2;
		case 0x0000d26c:
			return 0x43e04f07;
		case 0x0000d270:
			return 0x042c4323;
		case 0x0000d274:
			return 0xbfdcabf8;
		case 0x0000d278:
			return 0x78be9fc0;
		case 0x0000d27c:
			return 0x04911f6a;
		case 0x0000d280:
			return 0xa025784d;
		case 0x0000d284:
			return 0xc0946ce7;
		case 0x0000d288:
			return 0xcbb4533c;
		case 0x0000d28c:
			return 0xefb7b9a1;
		case 0x0000d290:
			return 0xed681d5b;
		case 0x0000d294:
			return 0xd5556139;
		case 0x0000d298:
			return 0x05474477;
		case 0x0000d29c:
			return 0x6775b4da;
		case 0x0000d2a0:
			return 0x7e9ea9e2;
		case 0x0000d2a4:
			return 0x1e3a09a3;
		case 0x0000d2a8:
			return 0x6ad4085f;
		case 0x0000d2ac:
			return 0xe726f68a;
		case 0x0000d2b0:
			return 0x06307c83;
		case 0x0000d2b4:
			return 0x5a80f5b1;
		case 0x0000d2b8:
			return 0x942d5e8f;
		case 0x0000d2bc:
			return 0x65a057cc;
		case 0x0000d2c0:
			return 0xb359c3eb;
		case 0x0000d2c4:
			return 0x8323f01f;
		case 0x0000d2c8:
			return 0x9b78e74e;
		case 0x0000d2cc:
			return 0xd9678018;
		case 0x0000d2d0:
			return 0xca0f4376;
		case 0x0000d2d4:
			return 0xd01d40e6;
		case 0x0000d2d8:
			return 0xe6ba7cf7;
		case 0x0000d2dc:
			return 0x602851da;
		case 0x0000d2e0:
			return 0xa5593780;
		case 0x0000d2e4:
			return 0x595c9e44;
		case 0x0000d2e8:
			return 0x7d5201b2;
		case 0x0000d2ec:
			return 0xa8d37c77;
		case 0x0000d2f0:
			return 0x858aecfa;
		case 0x0000d2f4:
			return 0x3b0eb767;
		case 0x0000d2f8:
			return 0x1f9da30c;
		case 0x0000d2fc:
			return 0x223aede8;
		case 0x0000d300:
			return 0xf510b1e1;
		case 0x0000d304:
			return 0xf8f63f8f;
		case 0x0000d308:
			return 0x0fbc7b98;
		case 0x0000d30c:
			return 0x584bf8ed;
		case 0x0000d310:
			return 0xc481214a;
		case 0x0000d314:
			return 0xaf7cae21;
		case 0x0000d318:
			return 0x78f36d75;
		case 0x0000d31c:
			return 0x62db6995;
		case 0x0000d320:
			return 0x14383886;
		case 0x0000d324:
			return 0xd5b4a7ae;
		case 0x0000d328:
			return 0xbd97b716;
		case 0x0000d32c:
			return 0xc0c2551e;
		case 0x0000d330:
			return 0x8b8d2a61;
		case 0x0000d334:
			return 0x2607603a;
		case 0x0000d338:
			return 0xd65f6914;
		case 0x0000d33c:
			return 0x9e728ac7;
		case 0x0000d340:
			return 0x619b5588;
		case 0x0000d344:
			return 0xfbbc9971;
		case 0x0000d348:
			return 0x4ac7f7aa;
		case 0x0000d34c:
			return 0xa9b121e6;
		case 0x0000d350:
			return 0x76467ea1;
		case 0x0000d354:
			return 0x204d1eab;
		case 0x0000d358:
			return 0x9726863b;
		case 0x0000d35c:
			return 0x447b822c;
		case 0x0000d360:
			return 0x3d7bd8c8;
		case 0x0000d364:
			return 0x84755429;
		case 0x0000d368:
			return 0x6f83d226;
		case 0x0000d36c:
			return 0x8e5b8206;
		case 0x0000d370:
			return 0xbda73411;
		case 0x0000d374:
			return 0xf67ad3c7;
		case 0x0000d378:
			return 0x02fa8085;
		case 0x0000d37c:
			return 0x7e954cf8;
		case 0x0000d380:
			return 0xd03a88a1;
		case 0x0000d384:
			return 0x81cd152c;
		case 0x0000d388:
			return 0x6e09f285;
		case 0x0000d38c:
			return 0x7c730717;
		case 0x0000d390:
			return 0xd357ecd3;
		case 0x0000d394:
			return 0xf791ded9;
		case 0x0000d398:
			return 0x00e24bba;
		case 0x0000d39c:
			return 0x02118873;
		case 0x0000d3a0:
			return 0xa66f87f5;
		case 0x0000d3a4:
			return 0xb58a1d30;
		case 0x0000d3a8:
			return 0x2bc12860;
		case 0x0000d3ac:
			return 0x37ee3762;
		case 0x0000d3b0:
			return 0x20c6af2a;
		case 0x0000d3b4:
			return 0xfb6320d9;
		case 0x0000d3b8:
			return 0xec035e47;
		case 0x0000d3bc:
			return 0x3dae5b81;
		case 0x0000d3c0:
			return 0x5f6d776e;
		case 0x0000d3c4:
			return 0x7446907f;
		case 0x0000d3c8:
			return 0x79946370;
		case 0x0000d3cc:
			return 0xde0c8d01;
		case 0x0000d3d0:
			return 0x9f237a3f;
		case 0x0000d3d4:
			return 0x801123ad;
		case 0x0000d3d8:
			return 0xe7e26e5b;
		case 0x0000d3dc:
			return 0x5e3563a3;
		case 0x0000d3e0:
			return 0xfc2e4dd1;
		case 0x0000d3e4:
			return 0x3b550f11;
		case 0x0000d3e8:
			return 0x68f3bff7;
		case 0x0000d3ec:
			return 0xa5dc287b;
		case 0x0000d3f0:
			return 0x393eb72a;
		case 0x0000d3f4:
			return 0xf26ef65e;
		case 0x0000d3f8:
			return 0x4860ada2;
		case 0x0000d3fc:
			return 0x4546776c;
		case 0x0000d400:
			return 0xe69d6216;
		case 0x0000d404:
			return 0xfa15b02d;
		case 0x0000d408:
			return 0x9cab276b;
		case 0x0000d40c:
			return 0x51fa6e16;
		case 0x0000d410:
			return 0x5be0e276;
		case 0x0000d414:
			return 0x659bcc4b;
		case 0x0000d418:
			return 0x8766b5bd;
		case 0x0000d41c:
			return 0x95c40174;
		case 0x0000d420:
			return 0xacf61494;
		case 0x0000d424:
			return 0x52540e3c;
		case 0x0000d428:
			return 0xb13f6e70;
		case 0x0000d42c:
			return 0xfa6bdbdd;
		case 0x0000d430:
			return 0x48819173;
		case 0x0000d434:
			return 0xf7494de8;
		case 0x0000d438:
			return 0x3a25c7a2;
		case 0x0000d43c:
			return 0x662ce080;
		case 0x0000d440:
			return 0xc012db13;
		case 0x0000d444:
			return 0x07d63f16;
		case 0x0000d448:
			return 0x246715ea;
		case 0x0000d44c:
			return 0x5c7e2043;
		case 0x0000d450:
			return 0x2c98b080;
		case 0x0000d454:
			return 0x4c10b181;
		case 0x0000d458:
			return 0x4b4e2bd9;
		case 0x0000d45c:
			return 0x96e2a4d4;
		case 0x0000d460:
			return 0x2370958f;
		case 0x0000d464:
			return 0x0fcf6125;
		case 0x0000d468:
			return 0x30d06a45;
		case 0x0000d46c:
			return 0x71ca2465;
		case 0x0000d470:
			return 0x73843792;
		case 0x0000d474:
			return 0x6f6515d5;
		case 0x0000d478:
			return 0x24db1891;
		case 0x0000d47c:
			return 0x25f7c0b9;
		case 0x0000d480:
			return 0x37eeaadc;
		case 0x0000d484:
			return 0x23727503;
		case 0x0000d488:
			return 0xbb819f8b;
		case 0x0000d48c:
			return 0xe5d1b975;
		case 0x0000d490:
			return 0xe017204d;
		case 0x0000d494:
			return 0x59b9b1af;
		case 0x0000d498:
			return 0xbd69a94e;
		case 0x0000d49c:
			return 0xd53809ab;
		case 0x0000d4a0:
			return 0xd83ba88f;
		case 0x0000d4a4:
			return 0x18160cc4;
		case 0x0000d4a8:
			return 0xb525b560;
		case 0x0000d4ac:
			return 0x9c3e75cd;
		case 0x0000d4b0:
			return 0x3fd4ac49;
		case 0x0000d4b4:
			return 0x83656616;
		case 0x0000d4b8:
			return 0xd8e90ef4;
		case 0x0000d4bc:
			return 0x30a5a0e2;
		case 0x0000d4c0:
			return 0x555f35ee;
		case 0x0000d4c4:
			return 0x424b85b0;
		case 0x0000d4c8:
			return 0x0d637d36;
		case 0x0000d4cc:
			return 0x02ca466f;
		case 0x0000d4d0:
			return 0xf1b3b147;
		case 0x0000d4d4:
			return 0xc2ae9cfe;
		case 0x0000d4d8:
			return 0x474bd533;
		case 0x0000d4dc:
			return 0xc9211a09;
		case 0x0000d4e0:
			return 0x89865a87;
		case 0x0000d4e4:
			return 0x91f08075;
		case 0x0000d4e8:
			return 0x6a15278e;
		case 0x0000d4ec:
			return 0xefe7f098;
		case 0x0000d4f0:
			return 0x7855f38b;
		case 0x0000d4f4:
			return 0xce75a7c4;
		case 0x0000d4f8:
			return 0xdc659212;
		case 0x0000d4fc:
			return 0x2fbe0e9b;
		case 0x0000d500:
			return 0x19ae5b5a;
		case 0x0000d504:
			return 0xbc6ad8ba;
		case 0x0000d508:
			return 0x039d8178;
		case 0x0000d50c:
			return 0x75beaaa2;
		case 0x0000d510:
			return 0x46c52bf9;
		case 0x0000d514:
			return 0x959870b1;
		case 0x0000d518:
			return 0x6504c2a9;
		case 0x0000d51c:
			return 0x48196452;
		case 0x0000d520:
			return 0x875995ff;
		case 0x0000d524:
			return 0x704bc4e1;
		case 0x0000d528:
			return 0x6abb7632;
		case 0x0000d52c:
			return 0x1d1b0e2b;
		case 0x0000d530:
			return 0x9fb67d21;
		case 0x0000d534:
			return 0x8901bdd6;
		case 0x0000d538:
			return 0x9aa7c77a;
		case 0x0000d53c:
			return 0x0b2a932a;
		case 0x0000d540:
			return 0x64a6275c;
		case 0x0000d544:
			return 0xf49cfda1;
		case 0x0000d548:
			return 0xa68c98d5;
		case 0x0000d54c:
			return 0x584f1c59;
		case 0x0000d550:
			return 0x45a1039a;
		case 0x0000d554:
			return 0x33210b37;
		case 0x0000d558:
			return 0xcafed30f;
		case 0x0000d55c:
			return 0x8b806f15;
		case 0x0000d560:
			return 0x42ba032f;
		case 0x0000d564:
			return 0xf5ccaa0a;
		case 0x0000d568:
			return 0xd4c1993b;
		case 0x0000d56c:
			return 0xba97fc94;
		case 0x0000d570:
			return 0x3932fa37;
		case 0x0000d574:
			return 0x4dd66f9b;
		case 0x0000d578:
			return 0x8afde314;
		case 0x0000d57c:
			return 0x2df5b1ed;
		case 0x0000d580:
			return 0x0af39671;
		case 0x0000d584:
			return 0xa5b15892;
		case 0x0000d588:
			return 0x2edd8e3c;
		case 0x0000d58c:
			return 0xc0571a05;
		case 0x0000d590:
			return 0xcee14d87;
		case 0x0000d594:
			return 0x1c87c200;
		case 0x0000d598:
			return 0x420052e4;
		case 0x0000d59c:
			return 0xeb022fd7;
		case 0x0000d5a0:
			return 0x7de54ba9;
		case 0x0000d5a4:
			return 0x36feec17;
		case 0x0000d5a8:
			return 0x2bdb5323;
		case 0x0000d5ac:
			return 0xc0da894d;
		case 0x0000d5b0:
			return 0x0458aa2f;
		case 0x0000d5b4:
			return 0x19841fe8;
		case 0x0000d5b8:
			return 0x561e9392;
		case 0x0000d5bc:
			return 0x9e367c4d;
		case 0x0000d5c0:
			return 0xdf52e535;
		case 0x0000d5c4:
			return 0xdbb848fd;
		case 0x0000d5c8:
			return 0xc0018c2e;
		case 0x0000d5cc:
			return 0xeb0bbbff;
		case 0x0000d5d0:
			return 0xe4c61e28;
		case 0x0000d5d4:
			return 0x95263e72;
		case 0x0000d5d8:
			return 0xe9d24da6;
		case 0x0000d5dc:
			return 0xa6c5c3e3;
		case 0x0000d5e0:
			return 0x3d758c79;
		case 0x0000d5e4:
			return 0x4d792bd1;
		case 0x0000d5e8:
			return 0xb3c28dfc;
		case 0x0000d5ec:
			return 0x0ffaf770;
		case 0x0000d5f0:
			return 0xaa8e9e18;
		case 0x0000d5f4:
			return 0x4b9a239b;
		case 0x0000d5f8:
			return 0xbc9a6179;
		case 0x0000d5fc:
			return 0xf74d3a27;
		case 0x0000d600:
			return 0xb3e007da;
		case 0x0000d604:
			return 0x24d0d99a;
		case 0x0000d608:
			return 0x997b50d9;
		case 0x0000d60c:
			return 0x615835dc;
		case 0x0000d610:
			return 0x7df31838;
		case 0x0000d614:
			return 0x838233d5;
		case 0x0000d618:
			return 0xd5d64085;
		case 0x0000d61c:
			return 0xe66ad493;
		case 0x0000d620:
			return 0xc4716aae;
		case 0x0000d624:
			return 0x5660b348;
		case 0x0000d628:
			return 0x5a342112;
		case 0x0000d62c:
			return 0x7d3a3a0b;
		case 0x0000d630:
			return 0xfaaccf38;
		case 0x0000d634:
			return 0x49c68b0e;
		case 0x0000d638:
			return 0x26e6df54;
		case 0x0000d63c:
			return 0xb3eb7770;
		case 0x0000d640:
			return 0x6e672390;
		case 0x0000d644:
			return 0x25255eed;
		case 0x0000d648:
			return 0x94889e49;
		case 0x0000d64c:
			return 0xf730c073;
		case 0x0000d650:
			return 0x29da1636;
		case 0x0000d654:
			return 0xd18a1b77;
		case 0x0000d658:
			return 0x6b3dbbb7;
		case 0x0000d65c:
			return 0x538ee8bb;
		case 0x0000d660:
			return 0x5bf8f0ab;
		case 0x0000d664:
			return 0x48aaf3de;
		case 0x0000d668:
			return 0xfccbfd08;
		case 0x0000d66c:
			return 0x05fbcfb6;
		case 0x0000d670:
			return 0xc8453383;
		case 0x0000d674:
			return 0xad38df5d;
		case 0x0000d678:
			return 0x9e309e4d;
		case 0x0000d67c:
			return 0xe7fcb05f;
		case 0x0000d680:
			return 0xf30cb552;
		case 0x0000d684:
			return 0xfdd32cb4;
		case 0x0000d688:
			return 0xc014e2a1;
		case 0x0000d68c:
			return 0xb1f95c1e;
		case 0x0000d690:
			return 0xfec464d3;
		case 0x0000d694:
			return 0x731e7fbf;
		case 0x0000d698:
			return 0xba28b94d;
		case 0x0000d69c:
			return 0xa5d235d4;
		case 0x0000d6a0:
			return 0x7f165c26;
		case 0x0000d6a4:
			return 0xd45da5f5;
		case 0x0000d6a8:
			return 0xcc833202;
		case 0x0000d6ac:
			return 0xc9c97f4d;
		case 0x0000d6b0:
			return 0x62503be9;
		case 0x0000d6b4:
			return 0xba4dba37;
		case 0x0000d6b8:
			return 0xa58799a6;
		case 0x0000d6bc:
			return 0xed7d65e8;
		case 0x0000d6c0:
			return 0x914bcb6b;
		case 0x0000d6c4:
			return 0x5f286d58;
		case 0x0000d6c8:
			return 0xfa0a04cb;
		case 0x0000d6cc:
			return 0x53583c21;
		case 0x0000d6d0:
			return 0xac624d01;
		case 0x0000d6d4:
			return 0xfd255b94;
		case 0x0000d6d8:
			return 0x3417002d;
		case 0x0000d6dc:
			return 0x3d40fd6b;
		case 0x0000d6e0:
			return 0x889a35a6;
		case 0x0000d6e4:
			return 0x36f2d494;
		case 0x0000d6e8:
			return 0xab4472a0;
		case 0x0000d6ec:
			return 0xf913d75c;
		case 0x0000d6f0:
			return 0x04c604e7;
		case 0x0000d6f4:
			return 0xd03ba655;
		case 0x0000d6f8:
			return 0x8a061681;
		case 0x0000d6fc:
			return 0xd0190b76;
		case 0x0000d700:
			return 0x3c210c4e;
		case 0x0000d704:
			return 0xc29ed674;
		case 0x0000d708:
			return 0x7560284f;
		case 0x0000d70c:
			return 0x033bed4f;
		case 0x0000d710:
			return 0xde4395e2;
		case 0x0000d714:
			return 0x1ea1f9d9;
		case 0x0000d718:
			return 0x3292e006;
		case 0x0000d71c:
			return 0xd936d1e2;
		case 0x0000d720:
			return 0x27e8a3b0;
		case 0x0000d724:
			return 0x33602e2c;
		case 0x0000d728:
			return 0xa329c4e8;
		case 0x0000d72c:
			return 0x4012e72b;
		case 0x0000d730:
			return 0x687cc3c5;
		case 0x0000d734:
			return 0x213cef4d;
		case 0x0000d738:
			return 0x80dd0549;
		case 0x0000d73c:
			return 0xb37aab06;
		case 0x0000d740:
			return 0xde117edd;
		case 0x0000d744:
			return 0xee05e975;
		case 0x0000d748:
			return 0x97f5218c;
		case 0x0000d74c:
			return 0x9873fc6b;
		case 0x0000d750:
			return 0xc17b3d85;
		case 0x0000d754:
			return 0xeab064f4;
		case 0x0000d758:
			return 0xf96a81b0;
		case 0x0000d75c:
			return 0x6b8b622d;
		case 0x0000d760:
			return 0xa69cd308;
		case 0x0000d764:
			return 0x44c11237;
		case 0x0000d768:
			return 0x5c0afc1b;
		case 0x0000d76c:
			return 0x01c78659;
		case 0x0000d770:
			return 0x7a010f7c;
		case 0x0000d774:
			return 0xb69710b1;
		case 0x0000d778:
			return 0x0489f665;
		case 0x0000d77c:
			return 0xc923dbe7;
		case 0x0000d780:
			return 0x20abf3b9;
		case 0x0000d784:
			return 0xdbdbaef6;
		case 0x0000d788:
			return 0x64106890;
		case 0x0000d78c:
			return 0x0f4771c6;
		case 0x0000d790:
			return 0x72881a87;
		case 0x0000d794:
			return 0x0b5459b2;
		case 0x0000d798:
			return 0x52c8ce79;
		case 0x0000d79c:
			return 0xcb122798;
		case 0x0000d7a0:
			return 0xaf9a8852;
		case 0x0000d7a4:
			return 0xee5c66b1;
		case 0x0000d7a8:
			return 0x2491a822;
		case 0x0000d7ac:
			return 0xacb2a2ad;
		case 0x0000d7b0:
			return 0x7ce5cc33;
		case 0x0000d7b4:
			return 0x50952433;
		case 0x0000d7b8:
			return 0xdd7b6b2a;
		case 0x0000d7bc:
			return 0xb82a1a97;
		case 0x0000d7c0:
			return 0x007bcdc0;
		case 0x0000d7c4:
			return 0x34251cba;
		case 0x0000d7c8:
			return 0x05ca0120;
		case 0x0000d7cc:
			return 0x8f7f03f2;
		case 0x0000d7d0:
			return 0x05f0b845;
		case 0x0000d7d4:
			return 0x47cea350;
		case 0x0000d7d8:
			return 0x29cbe454;
		case 0x0000d7dc:
			return 0x30ba4d8f;
		case 0x0000d7e0:
			return 0x195aee0e;
		case 0x0000d7e4:
			return 0xc7d0089f;
		case 0x0000d7e8:
			return 0x6973fd35;
		case 0x0000d7ec:
			return 0x086e1053;
		case 0x0000d7f0:
			return 0xc8651fd4;
		case 0x0000d7f4:
			return 0x97024647;
		case 0x0000d7f8:
			return 0x530403e1;
		case 0x0000d7fc:
			return 0xd3e6ea37;
		case 0x0000d800:
			return 0xd86cc952;
		case 0x0000d804:
			return 0x557224dc;
		case 0x0000d808:
			return 0xaa7eba92;
		case 0x0000d80c:
			return 0x1f948092;
		case 0x0000d810:
			return 0x49b12497;
		case 0x0000d814:
			return 0x43cc634e;
		case 0x0000d818:
			return 0x3252bb3b;
		case 0x0000d81c:
			return 0x22c2fe91;
		case 0x0000d820:
			return 0xda228f41;
		case 0x0000d824:
			return 0x9be6b763;
		case 0x0000d828:
			return 0x5a3795b8;
		case 0x0000d82c:
			return 0x3a82e581;
		case 0x0000d830:
			return 0x5e00f988;
		case 0x0000d834:
			return 0xddf519d9;
		case 0x0000d838:
			return 0x685787f4;
		case 0x0000d83c:
			return 0xc634b2f1;
		case 0x0000d840:
			return 0x184f5a33;
		case 0x0000d844:
			return 0x77e644f7;
		case 0x0000d848:
			return 0x3ca8b13b;
		case 0x0000d84c:
			return 0x841d7362;
		case 0x0000d850:
			return 0x35e1cb80;
		case 0x0000d854:
			return 0x3b7755eb;
		case 0x0000d858:
			return 0x0be787de;
		case 0x0000d85c:
			return 0x6c1622b0;
		case 0x0000d860:
			return 0xdb4d94e8;
		case 0x0000d864:
			return 0x6c82d0e4;
		case 0x0000d868:
			return 0x8aec10cd;
		case 0x0000d86c:
			return 0x9e7e5e31;
		case 0x0000d870:
			return 0x82ddc9eb;
		case 0x0000d874:
			return 0x0fcfa37d;
		case 0x0000d878:
			return 0xf8b4da31;
		case 0x0000d87c:
			return 0xf05125cc;
		case 0x0000d880:
			return 0xd360942e;
		case 0x0000d884:
			return 0x35f229ca;
		case 0x0000d888:
			return 0xae88d821;
		case 0x0000d88c:
			return 0x209657a9;
		case 0x0000d890:
			return 0x8b189ab9;
		case 0x0000d894:
			return 0x00896c25;
		case 0x0000d898:
			return 0x55ec5991;
		case 0x0000d89c:
			return 0x4a5d3773;
		case 0x0000d8a0:
			return 0x4de5db67;
		case 0x0000d8a4:
			return 0xd9b0c139;
		case 0x0000d8a8:
			return 0x344d11e8;
		case 0x0000d8ac:
			return 0x1e6f1f31;
		case 0x0000d8b0:
			return 0x720f4a72;
		case 0x0000d8b4:
			return 0xffc9e086;
		case 0x0000d8b8:
			return 0xee9fb3c0;
		case 0x0000d8bc:
			return 0x20ba0110;
		case 0x0000d8c0:
			return 0x59f0f881;
		case 0x0000d8c4:
			return 0x7b4e7295;
		case 0x0000d8c8:
			return 0x8f8aa879;
		case 0x0000d8cc:
			return 0xbcca1ea3;
		case 0x0000d8d0:
			return 0x2d39f230;
		case 0x0000d8d4:
			return 0x730ec6f8;
		case 0x0000d8d8:
			return 0x512b3a06;
		case 0x0000d8dc:
			return 0x3e85694d;
		case 0x0000d8e0:
			return 0x56d7e9f6;
		case 0x0000d8e4:
			return 0xb3c6ed16;
		case 0x0000d8e8:
			return 0x1e41dc91;
		case 0x0000d8ec:
			return 0x951992af;
		case 0x0000d8f0:
			return 0xcdd5610a;
		case 0x0000d8f4:
			return 0x4d91dbfa;
		case 0x0000d8f8:
			return 0xcca1d275;
		case 0x0000d8fc:
			return 0x6bed7b2b;
		case 0x0000d900:
			return 0x885620ff;
		case 0x0000d904:
			return 0xe80b5854;
		case 0x0000d908:
			return 0xb7a4386a;
		case 0x0000d90c:
			return 0x5915dc22;
		case 0x0000d910:
			return 0x04372477;
		case 0x0000d914:
			return 0xd10c0479;
		case 0x0000d918:
			return 0xe10fbf51;
		case 0x0000d91c:
			return 0x9119450a;
		case 0x0000d920:
			return 0xb63acc2f;
		case 0x0000d924:
			return 0x9ae66bf4;
		case 0x0000d928:
			return 0xd70f0304;
		case 0x0000d92c:
			return 0x8ddced49;
		case 0x0000d930:
			return 0x60c590f4;
		case 0x0000d934:
			return 0x59b89a77;
		case 0x0000d938:
			return 0xf790b680;
		case 0x0000d93c:
			return 0x651b8dd0;
		case 0x0000d940:
			return 0x6464418b;
		case 0x0000d944:
			return 0x52faa37b;
		case 0x0000d948:
			return 0x49d58b23;
		case 0x0000d94c:
			return 0x716066da;
		case 0x0000d950:
			return 0x3d68dc24;
		case 0x0000d954:
			return 0x8e70e99f;
		case 0x0000d958:
			return 0xb8aa225a;
		case 0x0000d95c:
			return 0xd7cc2eec;
		case 0x0000d960:
			return 0x01ec4250;
		case 0x0000d964:
			return 0x21d2a3f6;
		case 0x0000d968:
			return 0x85df30b9;
		case 0x0000d96c:
			return 0x16af88d8;
		case 0x0000d970:
			return 0xd72d4b0e;
		case 0x0000d974:
			return 0x9f88e7ca;
		case 0x0000d978:
			return 0x8787bdf1;
		case 0x0000d97c:
			return 0x8fad6ba7;
		case 0x0000d980:
			return 0x4bd76a8b;
		case 0x0000d984:
			return 0xd4497c0d;
		case 0x0000d988:
			return 0x424959d9;
		case 0x0000d98c:
			return 0x58da8bd0;
		case 0x0000d990:
			return 0x81ad64d9;
		case 0x0000d994:
			return 0x14c055f6;
		case 0x0000d998:
			return 0x6d6c3e74;
		case 0x0000d99c:
			return 0x4d8831fa;
		case 0x0000d9a0:
			return 0xc3b8ea35;
		case 0x0000d9a4:
			return 0xe04722fa;
		case 0x0000d9a8:
			return 0x85b21d97;
		case 0x0000d9ac:
			return 0xd55515b4;
		case 0x0000d9b0:
			return 0x1f0b873c;
		case 0x0000d9b4:
			return 0x199d0623;
		case 0x0000d9b8:
			return 0xb8cb77ec;
		case 0x0000d9bc:
			return 0xd4c59f58;
		case 0x0000d9c0:
			return 0x46572ab3;
		case 0x0000d9c4:
			return 0x068b1430;
		case 0x0000d9c8:
			return 0x5b34b19e;
		case 0x0000d9cc:
			return 0xf1e180ca;
		case 0x0000d9d0:
			return 0x0c734e71;
		case 0x0000d9d4:
			return 0xf7eacb59;
		case 0x0000d9d8:
			return 0x0f3e7ebd;
		case 0x0000d9dc:
			return 0x839af3af;
		case 0x0000d9e0:
			return 0x7ac68877;
		case 0x0000d9e4:
			return 0x8a871a89;
		case 0x0000d9e8:
			return 0x3103f829;
		case 0x0000d9ec:
			return 0x7e1e7458;
		case 0x0000d9f0:
			return 0x06934509;
		case 0x0000d9f4:
			return 0x8d2f404c;
		case 0x0000d9f8:
			return 0xbb45460d;
		case 0x0000d9fc:
			return 0xe79f8400;
		case 0x0000da00:
			return 0x055fe62d;
		case 0x0000da04:
			return 0xf5403f57;
		case 0x0000da08:
			return 0x3bbd96e8;
		case 0x0000da0c:
			return 0x07bd1f09;
		case 0x0000da10:
			return 0x008a343c;
		case 0x0000da14:
			return 0x285ee722;
		case 0x0000da18:
			return 0x2948d57c;
		case 0x0000da1c:
			return 0x8b6a033e;
		case 0x0000da20:
			return 0xef89c679;
		case 0x0000da24:
			return 0xd1eefb08;
		case 0x0000da28:
			return 0x2f967d70;
		case 0x0000da2c:
			return 0xe60a5c42;
		case 0x0000da30:
			return 0x5d83c15e;
		case 0x0000da34:
			return 0x8bf83f5a;
		case 0x0000da38:
			return 0x24682a34;
		case 0x0000da3c:
			return 0x770b0103;
		case 0x0000da40:
			return 0xf1629782;
		case 0x0000da44:
			return 0x599728c4;
		case 0x0000da48:
			return 0x8f8d9fac;
		case 0x0000da4c:
			return 0x3cfdcd75;
		case 0x0000da50:
			return 0x92d34d45;
		case 0x0000da54:
			return 0x52c83fb0;
		case 0x0000da58:
			return 0x79306942;
		case 0x0000da5c:
			return 0x22a5f2cd;
		case 0x0000da60:
			return 0xf270c650;
		case 0x0000da64:
			return 0x077661c2;
		case 0x0000da68:
			return 0xee5ded92;
		case 0x0000da6c:
			return 0x73a4f8ff;
		case 0x0000da70:
			return 0xc7c31884;
		case 0x0000da74:
			return 0x25cf36d2;
		case 0x0000da78:
			return 0xed9b08e3;
		case 0x0000da7c:
			return 0xa9b6f54f;
		case 0x0000da80:
			return 0xff658b31;
		case 0x0000da84:
			return 0xdc62f3ae;
		case 0x0000da88:
			return 0xd42410f5;
		case 0x0000da8c:
			return 0x4b3d74ad;
		case 0x0000da90:
			return 0x9700065c;
		case 0x0000da94:
			return 0x7250e325;
		case 0x0000da98:
			return 0xe95195f4;
		case 0x0000da9c:
			return 0x9aee6dc2;
		case 0x0000daa0:
			return 0x762c23d7;
		case 0x0000daa4:
			return 0xfc9a0325;
		case 0x0000daa8:
			return 0x3ca37d62;
		case 0x0000daac:
			return 0xb7d55d89;
		case 0x0000dab0:
			return 0x434b01a1;
		case 0x0000dab4:
			return 0x7b493e8a;
		case 0x0000dab8:
			return 0xb62cfd92;
		case 0x0000dabc:
			return 0x6b436a76;
		case 0x0000dac0:
			return 0x72b202c0;
		case 0x0000dac4:
			return 0x5ad12d39;
		case 0x0000dac8:
			return 0xbeb1bca2;
		case 0x0000dacc:
			return 0xa3146320;
		case 0x0000dad0:
			return 0x6dc65660;
		case 0x0000dad4:
			return 0xd262a5ce;
		case 0x0000dad8:
			return 0x643b9a1e;
		case 0x0000dadc:
			return 0xed095dab;
		case 0x0000dae0:
			return 0x76447cd5;
		case 0x0000dae4:
			return 0x9c79fff4;
		case 0x0000dae8:
			return 0x91be7c96;
		case 0x0000daec:
			return 0xd2cc8df4;
		case 0x0000daf0:
			return 0x45c56e6a;
		case 0x0000daf4:
			return 0xe531bac0;
		case 0x0000daf8:
			return 0x88931c7a;
		case 0x0000dafc:
			return 0x2940feb0;
		case 0x0000db00:
			return 0x6304d253;
		case 0x0000db04:
			return 0x5d8858af;
		case 0x0000db08:
			return 0x41a17d43;
		case 0x0000db0c:
			return 0x9517345f;
		case 0x0000db10:
			return 0x4392c781;
		case 0x0000db14:
			return 0x5b6c9d01;
		case 0x0000db18:
			return 0xc7202ed3;
		case 0x0000db1c:
			return 0x588a4c79;
		case 0x0000db20:
			return 0xc637e503;
		case 0x0000db24:
			return 0xf779d71b;
		case 0x0000db28:
			return 0xff29e2c7;
		case 0x0000db2c:
			return 0xf72f97f2;
		case 0x0000db30:
			return 0x5a7d2ee9;
		case 0x0000db34:
			return 0x426d7e2d;
		case 0x0000db38:
			return 0xc18545ed;
		case 0x0000db3c:
			return 0x8782ff5d;
		case 0x0000db40:
			return 0x87ad426e;
		case 0x0000db44:
			return 0x0dd9e7f3;
		case 0x0000db48:
			return 0xfbad74ff;
		case 0x0000db4c:
			return 0x14107e41;
		case 0x0000db50:
			return 0x23c5e43a;
		case 0x0000db54:
			return 0x65a29dad;
		case 0x0000db58:
			return 0x1c4a4ecd;
		case 0x0000db5c:
			return 0x0cd9adfe;
		case 0x0000db60:
			return 0xa2624723;
		case 0x0000db64:
			return 0x7196836a;
		case 0x0000db68:
			return 0x1ae1f255;
		case 0x0000db6c:
			return 0xd0ca4c87;
		case 0x0000db70:
			return 0xaee1e0b4;
		case 0x0000db74:
			return 0x1a53173d;
		case 0x0000db78:
			return 0x90ef4e0b;
		case 0x0000db7c:
			return 0xe5eba706;
		case 0x0000db80:
			return 0x208968ea;
		case 0x0000db84:
			return 0x51b17f16;
		case 0x0000db88:
			return 0xe8b2b9fb;
		case 0x0000db8c:
			return 0x3420e956;
		case 0x0000db90:
			return 0xb438e17e;
		case 0x0000db94:
			return 0x4aa51f98;
		case 0x0000db98:
			return 0x5287c0eb;
		case 0x0000db9c:
			return 0x80bde1e9;
		case 0x0000dba0:
			return 0x14e0ed62;
		case 0x0000dba4:
			return 0xd09d0504;
		case 0x0000dba8:
			return 0x413f8feb;
		case 0x0000dbac:
			return 0x8ab06096;
		case 0x0000dbb0:
			return 0x344953c2;
		case 0x0000dbb4:
			return 0x46c750df;
		case 0x0000dbb8:
			return 0x5f23016f;
		case 0x0000dbbc:
			return 0x87d213cc;
		case 0x0000dbc0:
			return 0x2e48c1f4;
		case 0x0000dbc4:
			return 0xbaa2aecb;
		case 0x0000dbc8:
			return 0xab872876;
		case 0x0000dbcc:
			return 0x26fd74cf;
		case 0x0000dbd0:
			return 0x1013f451;
		case 0x0000dbd4:
			return 0xb276a13f;
		case 0x0000dbd8:
			return 0xef3d1d4a;
		case 0x0000dbdc:
			return 0x4bc95c7e;
		case 0x0000dbe0:
			return 0xfec7d6fb;
		case 0x0000dbe4:
			return 0x893dc4e6;
		case 0x0000dbe8:
			return 0xb10b828c;
		case 0x0000dbec:
			return 0x13ea4b6a;
		case 0x0000dbf0:
			return 0xab151a03;
		case 0x0000dbf4:
			return 0x13e5762c;
		case 0x0000dbf8:
			return 0x9a25e5eb;
		case 0x0000dbfc:
			return 0xc7a2debb;
		case 0x0000dc00:
			return 0x96f5b626;
		case 0x0000dc04:
			return 0xf2283511;
		case 0x0000dc08:
			return 0x6b2cfef1;
		case 0x0000dc0c:
			return 0x04d626d6;
		case 0x0000dc10:
			return 0xa4f05522;
		case 0x0000dc14:
			return 0xdb828c63;
		case 0x0000dc18:
			return 0x4c54ae47;
		case 0x0000dc1c:
			return 0x86d42119;
		case 0x0000dc20:
			return 0xd749c211;
		case 0x0000dc24:
			return 0xf3707587;
		case 0x0000dc28:
			return 0x8df19a1f;
		case 0x0000dc2c:
			return 0x104ad8d7;
		case 0x0000dc30:
			return 0x85e39746;
		case 0x0000dc34:
			return 0xf53f8668;
		case 0x0000dc38:
			return 0x548c802b;
		case 0x0000dc3c:
			return 0x570d9131;
		case 0x0000dc40:
			return 0xb9c13eb9;
		case 0x0000dc44:
			return 0xe6fc9d1f;
		case 0x0000dc48:
			return 0xf9057b22;
		case 0x0000dc4c:
			return 0x1fe34e7e;
		case 0x0000dc50:
			return 0xf473e9c0;
		case 0x0000dc54:
			return 0x296d5ecb;
		case 0x0000dc58:
			return 0xa39950d6;
		case 0x0000dc5c:
			return 0x791fbfcb;
		case 0x0000dc60:
			return 0x2c9df8eb;
		case 0x0000dc64:
			return 0x05a6e6d7;
		case 0x0000dc68:
			return 0x5b271aab;
		case 0x0000dc6c:
			return 0x5472f6f8;
		case 0x0000dc70:
			return 0xc3538f11;
		case 0x0000dc74:
			return 0x2326dc33;
		case 0x0000dc78:
			return 0x05355a46;
		case 0x0000dc7c:
			return 0x0999779d;
		case 0x0000dc80:
			return 0x891e976b;
		case 0x0000dc84:
			return 0x1b10e5c9;
		case 0x0000dc88:
			return 0x638fbfb7;
		case 0x0000dc8c:
			return 0xb0eab4ca;
		case 0x0000dc90:
			return 0xf048b086;
		case 0x0000dc94:
			return 0x82ddd21d;
		case 0x0000dc98:
			return 0x2466d609;
		case 0x0000dc9c:
			return 0x170c753b;
		case 0x0000dca0:
			return 0x939d9db3;
		case 0x0000dca4:
			return 0x37873c2b;
		case 0x0000dca8:
			return 0xabb29a1a;
		case 0x0000dcac:
			return 0xd7cd78b3;
		case 0x0000dcb0:
			return 0x4647c444;
		case 0x0000dcb4:
			return 0x64517280;
		case 0x0000dcb8:
			return 0x742269a6;
		case 0x0000dcbc:
			return 0x3f9e437e;
		case 0x0000dcc0:
			return 0xcf7d2ae5;
		case 0x0000dcc4:
			return 0x1b1e7de4;
		case 0x0000dcc8:
			return 0x790c47a4;
		case 0x0000dccc:
			return 0x0a983f26;
		case 0x0000dcd0:
			return 0x4804299d;
		case 0x0000dcd4:
			return 0x0263afc9;
		case 0x0000dcd8:
			return 0x1a6d5cae;
		case 0x0000dcdc:
			return 0x9661afc6;
		case 0x0000dce0:
			return 0x8e08eb37;
		case 0x0000dce4:
			return 0x61a169b5;
		case 0x0000dce8:
			return 0x40379a8a;
		case 0x0000dcec:
			return 0x07853f8f;
		case 0x0000dcf0:
			return 0x5247eb66;
		case 0x0000dcf4:
			return 0xa8eff578;
		case 0x0000dcf8:
			return 0x251f5a0a;
		case 0x0000dcfc:
			return 0x168e2020;
		case 0x0000dd00:
			return 0x70e32dd2;
		case 0x0000dd04:
			return 0x81e91ca9;
		case 0x0000dd08:
			return 0xff6ec574;
		case 0x0000dd0c:
			return 0xe0a62ef5;
		case 0x0000dd10:
			return 0x5677150d;
		case 0x0000dd14:
			return 0xeaa631c2;
		case 0x0000dd18:
			return 0xa296c938;
		case 0x0000dd1c:
			return 0xee8340c3;
		case 0x0000dd20:
			return 0x66f5012b;
		case 0x0000dd24:
			return 0x2f48a38d;
		case 0x0000dd28:
			return 0x5091e57c;
		case 0x0000dd2c:
			return 0xe4c75762;
		case 0x0000dd30:
			return 0xac231051;
		case 0x0000dd34:
			return 0x32534224;
		case 0x0000dd38:
			return 0x2b9acaa0;
		case 0x0000dd3c:
			return 0xb36c952e;
		case 0x0000dd40:
			return 0xcd621414;
		case 0x0000dd44:
			return 0x6e23750c;
		case 0x0000dd48:
			return 0xe32c7347;
		case 0x0000dd4c:
			return 0x1ad91a5b;
		case 0x0000dd50:
			return 0x9c2da6ca;
		case 0x0000dd54:
			return 0x3f2bbb47;
		case 0x0000dd58:
			return 0xa208cbb9;
		case 0x0000dd5c:
			return 0xe1b84df2;
		case 0x0000dd60:
			return 0x598d26ba;
		case 0x0000dd64:
			return 0x5f6ae44c;
		case 0x0000dd68:
			return 0xb453a69a;
		case 0x0000dd6c:
			return 0x28bda310;
		case 0x0000dd70:
			return 0x1fcdaec1;
		case 0x0000dd74:
			return 0xb9ded839;
		case 0x0000dd78:
			return 0x2f8ab609;
		case 0x0000dd7c:
			return 0xdcf0d1ae;
		case 0x0000dd80:
			return 0x4467ded3;
		case 0x0000dd84:
			return 0x1a1ab4a9;
		case 0x0000dd88:
			return 0xe5582786;
		case 0x0000dd8c:
			return 0x2a64c591;
		case 0x0000dd90:
			return 0x3eacd04a;
		case 0x0000dd94:
			return 0x42b6914c;
		case 0x0000dd98:
			return 0xb7e29631;
		case 0x0000dd9c:
			return 0x54d1d0a5;
		case 0x0000dda0:
			return 0xbaa1718b;
		case 0x0000dda4:
			return 0xb18780f9;
		case 0x0000dda8:
			return 0xcfb7f68b;
		case 0x0000ddac:
			return 0xc95acda1;
		case 0x0000ddb0:
			return 0xb88c293e;
		case 0x0000ddb4:
			return 0x143adead;
		case 0x0000ddb8:
			return 0x7a4bd105;
		case 0x0000ddbc:
			return 0x15adb4b0;
		case 0x0000ddc0:
			return 0x569a3864;
		case 0x0000ddc4:
			return 0x43d3b905;
		case 0x0000ddc8:
			return 0xfe2c6ff7;
		case 0x0000ddcc:
			return 0x2c1ca1dc;
		case 0x0000ddd0:
			return 0x2781be19;
		case 0x0000ddd4:
			return 0xc1eef165;
		case 0x0000ddd8:
			return 0x41b2e3ed;
		case 0x0000dddc:
			return 0xc71c3b76;
		case 0x0000dde0:
			return 0x5c3688c6;
		case 0x0000dde4:
			return 0x6621465d;
		case 0x0000dde8:
			return 0xfd2be0f3;
		case 0x0000ddec:
			return 0xf8aae2ce;
		case 0x0000ddf0:
			return 0x9f5cc75e;
		case 0x0000ddf4:
			return 0x09fa8122;
		case 0x0000ddf8:
			return 0x1fa8c948;
		case 0x0000ddfc:
			return 0x2d1b023f;
		case 0x0000de00:
			return 0x0fb3247a;
		case 0x0000de04:
			return 0xce8e9273;
		case 0x0000de08:
			return 0x22c76eb7;
		case 0x0000de0c:
			return 0x8e2bbd65;
		case 0x0000de10:
			return 0x22692bdd;
		case 0x0000de14:
			return 0xfb1b6866;
		case 0x0000de18:
			return 0xe7ceff58;
		case 0x0000de1c:
			return 0x48e9a611;
		case 0x0000de20:
			return 0xe1dd2ae0;
		case 0x0000de24:
			return 0x4b476b14;
		case 0x0000de28:
			return 0xe4e0a811;
		case 0x0000de2c:
			return 0xac740943;
		case 0x0000de30:
			return 0x8a695c2e;
		case 0x0000de34:
			return 0x0b6bc265;
		case 0x0000de38:
			return 0xca62dcd5;
		case 0x0000de3c:
			return 0x9920562a;
		case 0x0000de40:
			return 0x7beba014;
		case 0x0000de44:
			return 0xd066c30d;
		case 0x0000de48:
			return 0x60c5c7a7;
		case 0x0000de4c:
			return 0x679b200e;
		case 0x0000de50:
			return 0x854b9c1b;
		case 0x0000de54:
			return 0x9a5ebdce;
		case 0x0000de58:
			return 0x90f5b4c4;
		case 0x0000de5c:
			return 0xc813fa1c;
		case 0x0000de60:
			return 0x6713dfbd;
		case 0x0000de64:
			return 0x6d3ac129;
		case 0x0000de68:
			return 0x2c5e58a8;
		case 0x0000de6c:
			return 0x798ecbc6;
		case 0x0000de70:
			return 0xe2c85930;
		case 0x0000de74:
			return 0xf4f14968;
		case 0x0000de78:
			return 0x696f93ca;
		case 0x0000de7c:
			return 0xaf645d63;
		case 0x0000de80:
			return 0x7fb9878b;
		case 0x0000de84:
			return 0x4c2427af;
		case 0x0000de88:
			return 0x11236b9e;
		case 0x0000de8c:
			return 0xf2aae6e1;
		case 0x0000de90:
			return 0x147f114d;
		case 0x0000de94:
			return 0x811f0b30;
		case 0x0000de98:
			return 0x48847f09;
		case 0x0000de9c:
			return 0x7a45ffde;
		case 0x0000dea0:
			return 0x97eb9101;
		case 0x0000dea4:
			return 0x8db9e659;
		case 0x0000dea8:
			return 0xb957480f;
		case 0x0000deac:
			return 0xa2955c79;
		case 0x0000deb0:
			return 0xe22dde64;
		case 0x0000deb4:
			return 0x53bab1ef;
		case 0x0000deb8:
			return 0xe1e8058e;
		case 0x0000debc:
			return 0x9621bb75;
		case 0x0000dec0:
			return 0xa4584798;
		case 0x0000dec4:
			return 0x61ce8941;
		case 0x0000dec8:
			return 0x3b87ed94;
		case 0x0000decc:
			return 0x2d6f4eb4;
		case 0x0000ded0:
			return 0xbcae1165;
		case 0x0000ded4:
			return 0xa73a15f4;
		case 0x0000ded8:
			return 0x3c2eab73;
		case 0x0000dedc:
			return 0x0fdd22ab;
		case 0x0000dee0:
			return 0x2a9c0576;
		case 0x0000dee4:
			return 0x9fd16180;
		case 0x0000dee8:
			return 0x430c9a8b;
		case 0x0000deec:
			return 0x82baca6f;
		case 0x0000def0:
			return 0xcecd602e;
		case 0x0000def4:
			return 0xa46ccf96;
		case 0x0000def8:
			return 0x53d91203;
		case 0x0000defc:
			return 0x2fa2cd5c;
		case 0x0000df00:
			return 0x76b960ce;
		case 0x0000df04:
			return 0x0da06749;
		case 0x0000df08:
			return 0x4b88d40b;
		case 0x0000df0c:
			return 0xa2d8b103;
		case 0x0000df10:
			return 0x3670b036;
		case 0x0000df14:
			return 0xfe9b6152;
		case 0x0000df18:
			return 0x1d84b63c;
		case 0x0000df1c:
			return 0xe0b88302;
		case 0x0000df20:
			return 0x90aef55b;
		case 0x0000df24:
			return 0xf247f921;
		case 0x0000df28:
			return 0xf9c735da;
		case 0x0000df2c:
			return 0x132bf6d9;
		case 0x0000df30:
			return 0x0fa04801;
		case 0x0000df34:
			return 0x8ff611f2;
		case 0x0000df38:
			return 0x7c28976e;
		case 0x0000df3c:
			return 0x38c0b199;
		case 0x0000df40:
			return 0x64e7fb8d;
		case 0x0000df44:
			return 0xa9da5973;
		case 0x0000df48:
			return 0x7b45ec7c;
		case 0x0000df4c:
			return 0x981e7a68;
		case 0x0000df50:
			return 0xdb9aa310;
		case 0x0000df54:
			return 0xc6189aeb;
		case 0x0000df58:
			return 0x5acbe10c;
		case 0x0000df5c:
			return 0xa090fcba;
		case 0x0000df60:
			return 0x1c7a5707;
		case 0x0000df64:
			return 0xeeb4e98a;
		case 0x0000df68:
			return 0x421c9a13;
		case 0x0000df6c:
			return 0x1cb9eb16;
		case 0x0000df70:
			return 0x21a58af0;
		case 0x0000df74:
			return 0x290e8c1b;
		case 0x0000df78:
			return 0x49b936d6;
		case 0x0000df7c:
			return 0x1233291c;
		case 0x0000df80:
			return 0x97a9da39;
		case 0x0000df84:
			return 0x710814ef;
		case 0x0000df88:
			return 0xf779c0fd;
		case 0x0000df8c:
			return 0x12f3f49d;
		case 0x0000df90:
			return 0x453e765d;
		case 0x0000df94:
			return 0x5d710176;
		case 0x0000df98:
			return 0x52d18e74;
		case 0x0000df9c:
			return 0x15403252;
		case 0x0000dfa0:
			return 0x91a3b71c;
		case 0x0000dfa4:
			return 0xe61663c6;
		case 0x0000dfa8:
			return 0x682508b9;
		case 0x0000dfac:
			return 0x6a9f1f6b;
		case 0x0000dfb0:
			return 0xb9ec312f;
		case 0x0000dfb4:
			return 0x02d81ac4;
		case 0x0000dfb8:
			return 0x92646700;
		case 0x0000dfbc:
			return 0xb5b67486;
		case 0x0000dfc0:
			return 0x8f4523e5;
		case 0x0000dfc4:
			return 0x66326eb5;
		case 0x0000dfc8:
			return 0xb05f8280;
		case 0x0000dfcc:
			return 0x782ba5c1;
		case 0x0000dfd0:
			return 0xaa4854ae;
		case 0x0000dfd4:
			return 0xfb02b9c2;
		case 0x0000dfd8:
			return 0x68a9f05c;
		case 0x0000dfdc:
			return 0xe9902077;
		case 0x0000dfe0:
			return 0x5189e1b6;
		case 0x0000dfe4:
			return 0x4d2d912a;
		case 0x0000dfe8:
			return 0xdaa109d3;
		case 0x0000dfec:
			return 0x235ff33b;
		case 0x0000dff0:
			return 0x70a86573;
		case 0x0000dff4:
			return 0xde6b0bea;
		case 0x0000dff8:
			return 0x4294caec;
		case 0x0000dffc:
			return 0x2d3c91d6;
		case 0x0000e000:
			return 0x269eabd5;
		case 0x0000e004:
			return 0x2f83d6e3;
		case 0x0000e008:
			return 0x01bd1f21;
		case 0x0000e00c:
			return 0x5f682067;
		case 0x0000e010:
			return 0x0fc58e4f;
		case 0x0000e014:
			return 0x4698ece3;
		case 0x0000e018:
			return 0x2b44b0a6;
		case 0x0000e01c:
			return 0xb8d2bc4a;
		case 0x0000e020:
			return 0x71182f98;
		case 0x0000e024:
			return 0xe0092d65;
		case 0x0000e028:
			return 0x22999551;
		case 0x0000e02c:
			return 0x914dc32a;
		case 0x0000e030:
			return 0xdf83bf6d;
		case 0x0000e034:
			return 0x3fa040b5;
		case 0x0000e038:
			return 0x5c3afaf1;
		case 0x0000e03c:
			return 0x79a902a4;
		case 0x0000e040:
			return 0x318cf359;
		case 0x0000e044:
			return 0xb1a47244;
		case 0x0000e048:
			return 0x7ca59ceb;
		case 0x0000e04c:
			return 0xf1b7e44d;
		case 0x0000e050:
			return 0x5cc37982;
		case 0x0000e054:
			return 0xef2d8fc7;
		case 0x0000e058:
			return 0xbb46f1fc;
		case 0x0000e05c:
			return 0xb487d8b4;
		case 0x0000e060:
			return 0x37d62c39;
		case 0x0000e064:
			return 0xde43e3f1;
		case 0x0000e068:
			return 0xb2d7974f;
		case 0x0000e06c:
			return 0x310de8cd;
		case 0x0000e070:
			return 0x4f15bb3d;
		case 0x0000e074:
			return 0x2a4c3a26;
		case 0x0000e078:
			return 0x5b345f33;
		case 0x0000e07c:
			return 0x487b0042;
		case 0x0000e080:
			return 0x35f832d1;
		case 0x0000e084:
			return 0x985fc82c;
		case 0x0000e088:
			return 0xb5499461;
		case 0x0000e08c:
			return 0x9e631cf8;
		case 0x0000e090:
			return 0xd5ec530f;
		case 0x0000e094:
			return 0xddea212f;
		case 0x0000e098:
			return 0x8eee5a5f;
		case 0x0000e09c:
			return 0x99d948d7;
		case 0x0000e0a0:
			return 0xe946d901;
		case 0x0000e0a4:
			return 0x9bd905cc;
		case 0x0000e0a8:
			return 0x47b718b0;
		case 0x0000e0ac:
			return 0x132c95e6;
		case 0x0000e0b0:
			return 0x5a19ca6c;
		case 0x0000e0b4:
			return 0x6eb7176a;
		case 0x0000e0b8:
			return 0x9f1d702c;
		case 0x0000e0bc:
			return 0xdfc082f8;
		case 0x0000e0c0:
			return 0x0aeecabd;
		case 0x0000e0c4:
			return 0x3e251ac5;
		case 0x0000e0c8:
			return 0xf94722f0;
		case 0x0000e0cc:
			return 0x129b2612;
		case 0x0000e0d0:
			return 0xf83277d1;
		case 0x0000e0d4:
			return 0x6db78eaf;
		case 0x0000e0d8:
			return 0xa81ac5c9;
		case 0x0000e0dc:
			return 0xa2274e19;
		case 0x0000e0e0:
			return 0x138589c2;
		case 0x0000e0e4:
			return 0xb63f9fe5;
		case 0x0000e0e8:
			return 0xf937dda4;
		case 0x0000e0ec:
			return 0xcf3d5c87;
		case 0x0000e0f0:
			return 0x9b8b1c04;
		case 0x0000e0f4:
			return 0xd56072c7;
		case 0x0000e0f8:
			return 0xcd0c935f;
		case 0x0000e0fc:
			return 0x05c22ed5;
		case 0x0000e100:
			return 0xbd5337a8;
		case 0x0000e104:
			return 0xe8f3ed5d;
		case 0x0000e108:
			return 0xfbf62270;
		case 0x0000e10c:
			return 0x72ef6ac4;
		case 0x0000e110:
			return 0xa34c2820;
		case 0x0000e114:
			return 0xf648d65b;
		case 0x0000e118:
			return 0xc3317943;
		case 0x0000e11c:
			return 0x733c9424;
		case 0x0000e120:
			return 0x47f3089e;
		case 0x0000e124:
			return 0x7e505648;
		case 0x0000e128:
			return 0x084ce826;
		case 0x0000e12c:
			return 0xd51c6596;
		case 0x0000e130:
			return 0xca2aaf93;
		case 0x0000e134:
			return 0xd308450c;
		case 0x0000e138:
			return 0xcc6b928b;
		case 0x0000e13c:
			return 0xcc381293;
		case 0x0000e140:
			return 0xaad4b0e8;
		case 0x0000e144:
			return 0x23cf22c8;
		case 0x0000e148:
			return 0x9153e376;
		case 0x0000e14c:
			return 0xcc5e7cc7;
		case 0x0000e150:
			return 0x47df2bf2;
		case 0x0000e154:
			return 0x7baecc05;
		case 0x0000e158:
			return 0x737b76ec;
		case 0x0000e15c:
			return 0x99f58427;
		case 0x0000e160:
			return 0x7e5bccab;
		case 0x0000e164:
			return 0x8cc7cede;
		case 0x0000e168:
			return 0xa9e05a08;
		case 0x0000e16c:
			return 0x6a51b15d;
		case 0x0000e170:
			return 0xab1919a5;
		case 0x0000e174:
			return 0x14d36d72;
		case 0x0000e178:
			return 0x8ac3cd4c;
		case 0x0000e17c:
			return 0x16f05f87;
		case 0x0000e180:
			return 0x1be95ad9;
		case 0x0000e184:
			return 0xb1ab5cc7;
		case 0x0000e188:
			return 0xba3d232d;
		case 0x0000e18c:
			return 0xad804b86;
		case 0x0000e190:
			return 0xec6e73b4;
		case 0x0000e194:
			return 0x93447167;
		case 0x0000e198:
			return 0x0eac164c;
		case 0x0000e19c:
			return 0xecd86c69;
		case 0x0000e1a0:
			return 0x6d1a3bf4;
		case 0x0000e1a4:
			return 0xbab1dcf4;
		case 0x0000e1a8:
			return 0x80648287;
		case 0x0000e1ac:
			return 0x7080cd4c;
		case 0x0000e1b0:
			return 0x9978e4ad;
		case 0x0000e1b4:
			return 0xe264e83d;
		case 0x0000e1b8:
			return 0x27270e88;
		case 0x0000e1bc:
			return 0x016968f9;
		case 0x0000e1c0:
			return 0x7fbec428;
		case 0x0000e1c4:
			return 0xc6f8e112;
		case 0x0000e1c8:
			return 0xbadfe5a7;
		case 0x0000e1cc:
			return 0x94fdd67f;
		case 0x0000e1d0:
			return 0x7ec1c824;
		case 0x0000e1d4:
			return 0xb55dc81b;
		case 0x0000e1d8:
			return 0x9106b7c2;
		case 0x0000e1dc:
			return 0xa862cfb7;
		case 0x0000e1e0:
			return 0xd7ea0919;
		case 0x0000e1e4:
			return 0xc7d81033;
		case 0x0000e1e8:
			return 0x58963e5c;
		case 0x0000e1ec:
			return 0x0e8bcbd5;
		case 0x0000e1f0:
			return 0xfee11c9a;
		case 0x0000e1f4:
			return 0xc93434ec;
		case 0x0000e1f8:
			return 0xc5c51da3;
		case 0x0000e1fc:
			return 0x8616f0ed;
		case 0x0000e200:
			return 0xb15b12bf;
		case 0x0000e204:
			return 0xad59105b;
		case 0x0000e208:
			return 0xbc30445d;
		case 0x0000e20c:
			return 0xec2d9daa;
		case 0x0000e210:
			return 0xc2d2ea52;
		case 0x0000e214:
			return 0x0c9fb350;
		case 0x0000e218:
			return 0xfa441fbe;
		case 0x0000e21c:
			return 0x15cd36b3;
		case 0x0000e220:
			return 0x7ce9d267;
		case 0x0000e224:
			return 0x47838760;
		case 0x0000e228:
			return 0x51134200;
		case 0x0000e22c:
			return 0x272510ba;
		case 0x0000e230:
			return 0x6b4c4ecd;
		case 0x0000e234:
			return 0xff394f33;
		case 0x0000e238:
			return 0x05f933a1;
		case 0x0000e23c:
			return 0xce93302b;
		case 0x0000e240:
			return 0xbe0c0cfa;
		case 0x0000e244:
			return 0x5cb8f789;
		case 0x0000e248:
			return 0xf69cd4bb;
		case 0x0000e24c:
			return 0x01e4b7ff;
		case 0x0000e250:
			return 0x3f17cfa6;
		case 0x0000e254:
			return 0x1814e8f6;
		case 0x0000e258:
			return 0x0c416834;
		case 0x0000e25c:
			return 0x36f1504d;
		case 0x0000e260:
			return 0xbe51fe09;
		case 0x0000e264:
			return 0xaa0813a8;
		case 0x0000e268:
			return 0x756e1a58;
		case 0x0000e26c:
			return 0x12ac4efb;
		case 0x0000e270:
			return 0xaa7974d8;
		case 0x0000e274:
			return 0x1985265b;
		case 0x0000e278:
			return 0x776cff8b;
		case 0x0000e27c:
			return 0xea919b2b;
		case 0x0000e280:
			return 0x6d5ee79f;
		case 0x0000e284:
			return 0x89535743;
		case 0x0000e288:
			return 0x9c9d1ab1;
		case 0x0000e28c:
			return 0xa4055619;
		case 0x0000e290:
			return 0x9dae6fa6;
		case 0x0000e294:
			return 0x2e3fd95c;
		case 0x0000e298:
			return 0x6e6e7185;
		case 0x0000e29c:
			return 0x16ec964f;
		case 0x0000e2a0:
			return 0x39f8f23b;
		case 0x0000e2a4:
			return 0xae7a095b;
		case 0x0000e2a8:
			return 0xdf41bcf6;
		case 0x0000e2ac:
			return 0xf3e8fe9f;
		case 0x0000e2b0:
			return 0x8ce879a0;
		case 0x0000e2b4:
			return 0x07169c5b;
		case 0x0000e2b8:
			return 0x65e82496;
		case 0x0000e2bc:
			return 0xc317b2ea;
		case 0x0000e2c0:
			return 0x592ab677;
		case 0x0000e2c4:
			return 0xd3423924;
		case 0x0000e2c8:
			return 0x54ed9c6f;
		case 0x0000e2cc:
			return 0xf8032ba4;
		case 0x0000e2d0:
			return 0xc2011ac1;
		case 0x0000e2d4:
			return 0x970a18a0;
		case 0x0000e2d8:
			return 0x7cc7ba65;
		case 0x0000e2dc:
			return 0xab064f50;
		case 0x0000e2e0:
			return 0xf84b8ec0;
		case 0x0000e2e4:
			return 0x929f95e2;
		case 0x0000e2e8:
			return 0x15ebaeba;
		case 0x0000e2ec:
			return 0xd9d429a6;
		case 0x0000e2f0:
			return 0x385434d4;
		case 0x0000e2f4:
			return 0x4e94bcad;
		case 0x0000e2f8:
			return 0x142f76c5;
		case 0x0000e2fc:
			return 0x587f299b;
		case 0x0000e300:
			return 0xa466b0d9;
		case 0x0000e304:
			return 0x16e6b1e7;
		case 0x0000e308:
			return 0xa0b7d677;
		case 0x0000e30c:
			return 0xd75d9a61;
		case 0x0000e310:
			return 0x0908d0ed;
		case 0x0000e314:
			return 0x4ec6e340;
		case 0x0000e318:
			return 0x618d299b;
		case 0x0000e31c:
			return 0xe603bf3c;
		case 0x0000e320:
			return 0x9c40e2ee;
		case 0x0000e324:
			return 0x27457368;
		case 0x0000e328:
			return 0x892fa7b8;
		case 0x0000e32c:
			return 0x996391b0;
		case 0x0000e330:
			return 0xa9714326;
		case 0x0000e334:
			return 0x9b6f4c75;
		case 0x0000e338:
			return 0xdbd6c1ac;
		case 0x0000e33c:
			return 0x11edc705;
		case 0x0000e340:
			return 0xf4de5fbc;
		case 0x0000e344:
			return 0xfd139385;
		case 0x0000e348:
			return 0x61cfec8b;
		case 0x0000e34c:
			return 0xc96f9d5b;
		case 0x0000e350:
			return 0x8ec34dde;
		case 0x0000e354:
			return 0x1a95256d;
		case 0x0000e358:
			return 0xcb7c17e3;
		case 0x0000e35c:
			return 0xae0284a1;
		case 0x0000e360:
			return 0xca74862b;
		case 0x0000e364:
			return 0x5e157f08;
		case 0x0000e368:
			return 0x67f5a77c;
		case 0x0000e36c:
			return 0xb1fcacc2;
		case 0x0000e370:
			return 0xba38c1a7;
		case 0x0000e374:
			return 0x48d96992;
		case 0x0000e378:
			return 0xbe1606d6;
		case 0x0000e37c:
			return 0x325ee48c;
		case 0x0000e380:
			return 0x259dda05;
		case 0x0000e384:
			return 0x6796f6c1;
		case 0x0000e388:
			return 0x41870e7c;
		case 0x0000e38c:
			return 0x50b7dc1b;
		case 0x0000e390:
			return 0x21056770;
		case 0x0000e394:
			return 0xa05a4a8f;
		case 0x0000e398:
			return 0x0b335508;
		case 0x0000e39c:
			return 0x2782b111;
		case 0x0000e3a0:
			return 0xbff02130;
		case 0x0000e3a4:
			return 0x3ab45e41;
		case 0x0000e3a8:
			return 0xf2124b68;
		case 0x0000e3ac:
			return 0xcaf273d7;
		case 0x0000e3b0:
			return 0xa34282cc;
		case 0x0000e3b4:
			return 0xfb765110;
		case 0x0000e3b8:
			return 0x330f15d3;
		case 0x0000e3bc:
			return 0x6a2d3db3;
		case 0x0000e3c0:
			return 0xd9d8ae4b;
		case 0x0000e3c4:
			return 0x8c4ab608;
		case 0x0000e3c8:
			return 0x13c50a46;
		case 0x0000e3cc:
			return 0xb4ea121f;
		case 0x0000e3d0:
			return 0xf6d54a5f;
		case 0x0000e3d4:
			return 0x7fbe374a;
		case 0x0000e3d8:
			return 0x07e68f6c;
		case 0x0000e3dc:
			return 0x6dec110a;
		case 0x0000e3e0:
			return 0x1bb7389b;
		case 0x0000e3e4:
			return 0x055d21bd;
		case 0x0000e3e8:
			return 0x3931fcbf;
		case 0x0000e3ec:
			return 0xf2069fe6;
		case 0x0000e3f0:
			return 0x8ef46434;
		case 0x0000e3f4:
			return 0x84dd35fe;
		case 0x0000e3f8:
			return 0x2dfe1ea3;
		case 0x0000e3fc:
			return 0xd2672b92;
		case 0x0000e400:
			return 0x82c565f6;
		case 0x0000e404:
			return 0x54ec8371;
		case 0x0000e408:
			return 0x54c592ef;
		case 0x0000e40c:
			return 0x3be998be;
		case 0x0000e410:
			return 0x69cdc6ba;
		case 0x0000e414:
			return 0x0c9c57b3;
		case 0x0000e418:
			return 0xa76dd5cf;
		case 0x0000e41c:
			return 0x676028ff;
		case 0x0000e420:
			return 0x52136234;
		case 0x0000e424:
			return 0x0b1475c7;
		case 0x0000e428:
			return 0x7a76dcd6;
		case 0x0000e42c:
			return 0x9c995726;
		case 0x0000e430:
			return 0x048d4869;
		case 0x0000e434:
			return 0x78df0306;
		case 0x0000e438:
			return 0x0071bd8f;
		case 0x0000e43c:
			return 0x0ca947a1;
		case 0x0000e440:
			return 0xd2942016;
		case 0x0000e444:
			return 0xf06df11c;
		case 0x0000e448:
			return 0x6e4d9406;
		case 0x0000e44c:
			return 0xc9be08fb;
		case 0x0000e450:
			return 0x560a66cf;
		case 0x0000e454:
			return 0xe6147b6b;
		case 0x0000e458:
			return 0xbad1e82a;
		case 0x0000e45c:
			return 0x8980d42f;
		case 0x0000e460:
			return 0xb848b3b2;
		case 0x0000e464:
			return 0xd8ee88ce;
		case 0x0000e468:
			return 0xb3b5b6d5;
		case 0x0000e46c:
			return 0xa6bdfb30;
		case 0x0000e470:
			return 0x2b448ea7;
		case 0x0000e474:
			return 0x06f9cfc8;
		case 0x0000e478:
			return 0x1fd46b17;
		case 0x0000e47c:
			return 0x385b9aa3;
		case 0x0000e480:
			return 0x4ab1c6af;
		case 0x0000e484:
			return 0xb9894e31;
		case 0x0000e488:
			return 0x93feaaf5;
		case 0x0000e48c:
			return 0x1bd8a005;
		case 0x0000e490:
			return 0x7263dcd7;
		case 0x0000e494:
			return 0x30e4b87d;
		case 0x0000e498:
			return 0xdc6e50fc;
		case 0x0000e49c:
			return 0xd5fa5ef2;
		case 0x0000e4a0:
			return 0x488eec8c;
		case 0x0000e4a4:
			return 0x189f26f8;
		case 0x0000e4a8:
			return 0x68a18272;
		case 0x0000e4ac:
			return 0x05f23070;
		case 0x0000e4b0:
			return 0x4648660a;
		case 0x0000e4b4:
			return 0x128eeb27;
		case 0x0000e4b8:
			return 0xa3b9869d;
		case 0x0000e4bc:
			return 0xedd6d475;
		case 0x0000e4c0:
			return 0x719602d4;
		case 0x0000e4c4:
			return 0xd7c3e4af;
		case 0x0000e4c8:
			return 0x48d21b5a;
		case 0x0000e4cc:
			return 0xe0eb3eb2;
		case 0x0000e4d0:
			return 0x651ccf3f;
		case 0x0000e4d4:
			return 0xedb17931;
		case 0x0000e4d8:
			return 0xa6c19891;
		case 0x0000e4dc:
			return 0xfabe60a3;
		case 0x0000e4e0:
			return 0xaf29ed68;
		case 0x0000e4e4:
			return 0x47504dbc;
		case 0x0000e4e8:
			return 0xe4f6eb24;
		case 0x0000e4ec:
			return 0xf1a6925b;
		case 0x0000e4f0:
			return 0x14b04689;
		case 0x0000e4f4:
			return 0x028b7d97;
		case 0x0000e4f8:
			return 0x536d41a3;
		case 0x0000e4fc:
			return 0xd20f456a;
		case 0x0000e500:
			return 0xe59b17bc;
		case 0x0000e504:
			return 0xb60f9393;
		case 0x0000e508:
			return 0x79e6cd4b;
		case 0x0000e50c:
			return 0x951c1b4c;
		case 0x0000e510:
			return 0x8b0a41ae;
		case 0x0000e514:
			return 0x681cdcd1;
		case 0x0000e518:
			return 0xf47a6085;
		case 0x0000e51c:
			return 0x6929d570;
		case 0x0000e520:
			return 0x2bf45c05;
		case 0x0000e524:
			return 0x153a1798;
		case 0x0000e528:
			return 0xf2c356f4;
		case 0x0000e52c:
			return 0xd44b6622;
		case 0x0000e530:
			return 0xd77e5294;
		case 0x0000e534:
			return 0x1216f281;
		case 0x0000e538:
			return 0x6b69ee16;
		case 0x0000e53c:
			return 0xb9799f9f;
		case 0x0000e540:
			return 0x67cb3a0f;
		case 0x0000e544:
			return 0xcc8bee6c;
		case 0x0000e548:
			return 0x8920d879;
		case 0x0000e54c:
			return 0xb31aae33;
		case 0x0000e550:
			return 0xc3a0341c;
		case 0x0000e554:
			return 0x63eac044;
		case 0x0000e558:
			return 0x8553e978;
		case 0x0000e55c:
			return 0x445ac47d;
		case 0x0000e560:
			return 0xff2534ff;
		case 0x0000e564:
			return 0x2ae75f70;
		case 0x0000e568:
			return 0x25f8113b;
		case 0x0000e56c:
			return 0xf7bf23c4;
		case 0x0000e570:
			return 0x96248c11;
		case 0x0000e574:
			return 0xbf03c29c;
		case 0x0000e578:
			return 0x4fa1339e;
		case 0x0000e57c:
			return 0xfa7ee820;
		case 0x0000e580:
			return 0x8465af24;
		case 0x0000e584:
			return 0xd52a1e3e;
		case 0x0000e588:
			return 0x70a8f5ca;
		case 0x0000e58c:
			return 0x7d2481ee;
		case 0x0000e590:
			return 0x20df6809;
		case 0x0000e594:
			return 0x81d4450c;
		case 0x0000e598:
			return 0xf6e2112f;
		case 0x0000e59c:
			return 0x3b212d31;
		case 0x0000e5a0:
			return 0x477f53cb;
		case 0x0000e5a4:
			return 0x6023ca8b;
		case 0x0000e5a8:
			return 0x7ebc57fa;
		case 0x0000e5ac:
			return 0xa683fab7;
		case 0x0000e5b0:
			return 0x945a240d;
		case 0x0000e5b4:
			return 0x9f44d7be;
		case 0x0000e5b8:
			return 0x90bf30ba;
		case 0x0000e5bc:
			return 0x4767cfd8;
		case 0x0000e5c0:
			return 0x7f983065;
		case 0x0000e5c4:
			return 0x71c87939;
		case 0x0000e5c8:
			return 0x0dec5b69;
		case 0x0000e5cc:
			return 0x427c0c76;
		case 0x0000e5d0:
			return 0x3ae16153;
		case 0x0000e5d4:
			return 0x898f8930;
		case 0x0000e5d8:
			return 0xec7df77b;
		case 0x0000e5dc:
			return 0x7dcab8b3;
		case 0x0000e5e0:
			return 0xe7726fc2;
		case 0x0000e5e4:
			return 0xd6eabc84;
		case 0x0000e5e8:
			return 0x1fb8ab8d;
		case 0x0000e5ec:
			return 0x04b98846;
		case 0x0000e5f0:
			return 0xa8c874a0;
		case 0x0000e5f4:
			return 0x3f45767f;
		case 0x0000e5f8:
			return 0x21ca43e9;
		case 0x0000e5fc:
			return 0xa028c663;
		case 0x0000e600:
			return 0xd547e5d7;
		case 0x0000e604:
			return 0x2e65e7ef;
		case 0x0000e608:
			return 0x8c9b2e18;
		case 0x0000e60c:
			return 0xc893f389;
		case 0x0000e610:
			return 0x803985bf;
		case 0x0000e614:
			return 0xca4350e3;
		case 0x0000e618:
			return 0xc5257432;
		case 0x0000e61c:
			return 0x60d1b327;
		case 0x0000e620:
			return 0x88eb72a7;
		case 0x0000e624:
			return 0x9b5a0e8d;
		case 0x0000e628:
			return 0xf3134cd8;
		case 0x0000e62c:
			return 0x75bda650;
		case 0x0000e630:
			return 0x3a43c513;
		case 0x0000e634:
			return 0x9c1c3e9b;
		case 0x0000e638:
			return 0xb8b29de6;
		case 0x0000e63c:
			return 0x53198595;
		case 0x0000e640:
			return 0x360973e6;
		case 0x0000e644:
			return 0x178d0f10;
		case 0x0000e648:
			return 0xc8f0f87f;
		case 0x0000e64c:
			return 0xbf667702;
		case 0x0000e650:
			return 0x1bf686ea;
		case 0x0000e654:
			return 0x79b83ca3;
		case 0x0000e658:
			return 0x025deb3e;
		case 0x0000e65c:
			return 0xccfcf179;
		case 0x0000e660:
			return 0xddaf84cb;
		case 0x0000e664:
			return 0x9ab482ef;
		case 0x0000e668:
			return 0x7e286a61;
		case 0x0000e66c:
			return 0xcbe719fb;
		case 0x0000e670:
			return 0xf600e0fa;
		case 0x0000e674:
			return 0x8ed6def3;
		case 0x0000e678:
			return 0x046c9a0d;
		case 0x0000e67c:
			return 0x82cc012e;
		case 0x0000e680:
			return 0x3a565746;
		case 0x0000e684:
			return 0x654a32ed;
		case 0x0000e688:
			return 0x9feec3d2;
		case 0x0000e68c:
			return 0x1c5a172a;
		case 0x0000e690:
			return 0x427df95c;
		case 0x0000e694:
			return 0xe988370d;
		case 0x0000e698:
			return 0x03a02fd1;
		case 0x0000e69c:
			return 0xe02a7ef0;
		case 0x0000e6a0:
			return 0x019916d6;
		case 0x0000e6a4:
			return 0x525de382;
		case 0x0000e6a8:
			return 0xb2f1e1eb;
		case 0x0000e6ac:
			return 0x54577652;
		case 0x0000e6b0:
			return 0x8e064c13;
		case 0x0000e6b4:
			return 0x9b381960;
		case 0x0000e6b8:
			return 0x8a0c35e3;
		case 0x0000e6bc:
			return 0xc04c5165;
		case 0x0000e6c0:
			return 0xa6f36b7e;
		case 0x0000e6c4:
			return 0xb412883c;
		case 0x0000e6c8:
			return 0x7074359e;
		case 0x0000e6cc:
			return 0xadbf44b5;
		case 0x0000e6d0:
			return 0x53db4bb2;
		case 0x0000e6d4:
			return 0x1c76aebd;
		case 0x0000e6d8:
			return 0x9843fdf7;
		case 0x0000e6dc:
			return 0xaaa9160e;
		case 0x0000e6e0:
			return 0x5015ac45;
		case 0x0000e6e4:
			return 0xfef3a1d3;
		case 0x0000e6e8:
			return 0x3de8cbb4;
		case 0x0000e6ec:
			return 0x846f7c94;
		case 0x0000e6f0:
			return 0xe2bf0d22;
		case 0x0000e6f4:
			return 0xf9602eaa;
		case 0x0000e6f8:
			return 0xe1634f7b;
		case 0x0000e6fc:
			return 0xb8cdd377;
		case 0x0000e700:
			return 0xa70e9791;
		case 0x0000e704:
			return 0xdb685a6b;
		case 0x0000e708:
			return 0x4cdb53f3;
		case 0x0000e70c:
			return 0x25bb6cf5;
		case 0x0000e710:
			return 0x2b2f30cf;
		case 0x0000e714:
			return 0xac5175c8;
		case 0x0000e718:
			return 0x5f0590fe;
		case 0x0000e71c:
			return 0x94d34296;
		case 0x0000e720:
			return 0x816db876;
		case 0x0000e724:
			return 0x90d68587;
		case 0x0000e728:
			return 0xd3ddc562;
		case 0x0000e72c:
			return 0x494952f6;
		case 0x0000e730:
			return 0xd96d6d8f;
		case 0x0000e734:
			return 0x21ca5207;
		case 0x0000e738:
			return 0x673fe25f;
		case 0x0000e73c:
			return 0x85978c65;
		case 0x0000e740:
			return 0x7c6885d0;
		case 0x0000e744:
			return 0x06f0584a;
		case 0x0000e748:
			return 0xebbdd5c9;
		case 0x0000e74c:
			return 0xbc8cd232;
		case 0x0000e750:
			return 0x066193f2;
		case 0x0000e754:
			return 0xf1b4ab2a;
		case 0x0000e758:
			return 0x2ad94e0b;
		case 0x0000e75c:
			return 0x95eb5828;
		case 0x0000e760:
			return 0x14a45473;
		case 0x0000e764:
			return 0x854943b5;
		case 0x0000e768:
			return 0x222c4afa;
		case 0x0000e76c:
			return 0x719df33a;
		case 0x0000e770:
			return 0x8847bc4c;
		case 0x0000e774:
			return 0x5c572ad2;
		case 0x0000e778:
			return 0x79e684a4;
		case 0x0000e77c:
			return 0x6249e906;
		case 0x0000e780:
			return 0xfa3d220d;
		case 0x0000e784:
			return 0x7fea0b7e;
		case 0x0000e788:
			return 0x1df65896;
		case 0x0000e78c:
			return 0xed8d1122;
		case 0x0000e790:
			return 0xb55b54c8;
		case 0x0000e794:
			return 0xdf2ba3e6;
		case 0x0000e798:
			return 0x26c9ab72;
		case 0x0000e79c:
			return 0x699f282b;
		case 0x0000e7a0:
			return 0x958306ac;
		case 0x0000e7a4:
			return 0x2f00c58d;
		case 0x0000e7a8:
			return 0x07f6f67b;
		case 0x0000e7ac:
			return 0xa4fd3e3f;
		case 0x0000e7b0:
			return 0x607ab25d;
		case 0x0000e7b4:
			return 0x486e8bab;
		case 0x0000e7b8:
			return 0x43b77a2d;
		case 0x0000e7bc:
			return 0x15d90ce1;
		case 0x0000e7c0:
			return 0xbb59aab8;
		case 0x0000e7c4:
			return 0x95292a47;
		case 0x0000e7c8:
			return 0x16d15db1;
		case 0x0000e7cc:
			return 0xcf237502;
		case 0x0000e7d0:
			return 0x6afbdd70;
		case 0x0000e7d4:
			return 0x23ea2d95;
		case 0x0000e7d8:
			return 0xa3f28b2d;
		case 0x0000e7dc:
			return 0x2227408e;
		case 0x0000e7e0:
			return 0xde6085fc;
		case 0x0000e7e4:
			return 0x41bce296;
		case 0x0000e7e8:
			return 0x127c080c;
		case 0x0000e7ec:
			return 0xe75274a7;
		case 0x0000e7f0:
			return 0xe410a35c;
		case 0x0000e7f4:
			return 0xf2def148;
		case 0x0000e7f8:
			return 0xdff8ee87;
		case 0x0000e7fc:
			return 0xa991540e;
		case 0x0000e800:
			return 0x58dc2688;
		case 0x0000e804:
			return 0xab4234c2;
		case 0x0000e808:
			return 0x37ef5a97;
		case 0x0000e80c:
			return 0xe0682b9f;
		case 0x0000e810:
			return 0x49ad37eb;
		case 0x0000e814:
			return 0x3a154514;
		case 0x0000e818:
			return 0xe7f1ed52;
		case 0x0000e81c:
			return 0x6f84cfc5;
		case 0x0000e820:
			return 0xefd12881;
		case 0x0000e824:
			return 0x3fc078a3;
		case 0x0000e828:
			return 0xbbca8d64;
		case 0x0000e82c:
			return 0x5eb3e04b;
		case 0x0000e830:
			return 0x02fa8204;
		case 0x0000e834:
			return 0x09d9cb42;
		case 0x0000e838:
			return 0x42d23d6b;
		case 0x0000e83c:
			return 0x7f2d97a4;
		case 0x0000e840:
			return 0x26e726a2;
		case 0x0000e844:
			return 0xbcc2f093;
		case 0x0000e848:
			return 0xf798b1f6;
		case 0x0000e84c:
			return 0xcff49a97;
		case 0x0000e850:
			return 0x74cb9f91;
		case 0x0000e854:
			return 0xbbe8e7cb;
		case 0x0000e858:
			return 0x29bae445;
		case 0x0000e85c:
			return 0x1a609088;
		case 0x0000e860:
			return 0x42b5f22c;
		case 0x0000e864:
			return 0x72f91f3f;
		case 0x0000e868:
			return 0xdceda565;
		case 0x0000e86c:
			return 0xd35916fb;
		case 0x0000e870:
			return 0x0587aadc;
		case 0x0000e874:
			return 0x8837f951;
		case 0x0000e878:
			return 0xd162746a;
		case 0x0000e87c:
			return 0xfefb56df;
		case 0x0000e880:
			return 0xd75decd5;
		case 0x0000e884:
			return 0xc511a94a;
		case 0x0000e888:
			return 0x924c15fa;
		case 0x0000e88c:
			return 0xd67f4897;
		case 0x0000e890:
			return 0x28bb8402;
		case 0x0000e894:
			return 0xf79ece6b;
		case 0x0000e898:
			return 0xa6b3d4df;
		case 0x0000e89c:
			return 0x49c3823b;
		case 0x0000e8a0:
			return 0xa87ff769;
		case 0x0000e8a4:
			return 0x0f2ef28b;
		case 0x0000e8a8:
			return 0x495fba3e;
		case 0x0000e8ac:
			return 0xd7bd8917;
		case 0x0000e8b0:
			return 0x7966f286;
		case 0x0000e8b4:
			return 0x162f166f;
		case 0x0000e8b8:
			return 0x845f15f8;
		case 0x0000e8bc:
			return 0xb8cbea7b;
		case 0x0000e8c0:
			return 0x6582a5a0;
		case 0x0000e8c4:
			return 0x1a7176e4;
		case 0x0000e8c8:
			return 0x545eb6d5;
		case 0x0000e8cc:
			return 0xe3f7ffec;
		case 0x0000e8d0:
			return 0x3638c0ad;
		case 0x0000e8d4:
			return 0xfd0f534d;
		case 0x0000e8d8:
			return 0xdc069338;
		case 0x0000e8dc:
			return 0x7e2a3fe3;
		case 0x0000e8e0:
			return 0x18c5e21a;
		case 0x0000e8e4:
			return 0x5dbeee03;
		case 0x0000e8e8:
			return 0xd5b1086b;
		case 0x0000e8ec:
			return 0xeae05b9a;
		case 0x0000e8f0:
			return 0xb7aa549e;
		case 0x0000e8f4:
			return 0x8651974d;
		case 0x0000e8f8:
			return 0x4dacbe39;
		case 0x0000e8fc:
			return 0x277f5744;
		case 0x0000e900:
			return 0x96182446;
		case 0x0000e904:
			return 0x73ef1bee;
		case 0x0000e908:
			return 0xad8f1fed;
		case 0x0000e90c:
			return 0xea68ee64;
		case 0x0000e910:
			return 0xbd242af5;
		case 0x0000e914:
			return 0x30b25bd7;
		case 0x0000e918:
			return 0x5bd0c225;
		case 0x0000e91c:
			return 0x1cb1ae12;
		case 0x0000e920:
			return 0x29720f79;
		case 0x0000e924:
			return 0x4ceac5f3;
		case 0x0000e928:
			return 0x157ce4ad;
		case 0x0000e92c:
			return 0x82d576a7;
		case 0x0000e930:
			return 0x5afefaee;
		case 0x0000e934:
			return 0xabfe51d0;
		case 0x0000e938:
			return 0x1e27235e;
		case 0x0000e93c:
			return 0x919f63fa;
		case 0x0000e940:
			return 0x6fd67db1;
		case 0x0000e944:
			return 0xa002747e;
		case 0x0000e948:
			return 0xc285d95a;
		case 0x0000e94c:
			return 0x38301149;
		case 0x0000e950:
			return 0xe88f5c8c;
		case 0x0000e954:
			return 0x9eb0e788;
		case 0x0000e958:
			return 0xc62715ee;
		case 0x0000e95c:
			return 0x82784c80;
		case 0x0000e960:
			return 0x5aff19a6;
		case 0x0000e964:
			return 0x2528f06b;
		case 0x0000e968:
			return 0xbd60d8a4;
		case 0x0000e96c:
			return 0x678e4143;
		case 0x0000e970:
			return 0x9b55756f;
		case 0x0000e974:
			return 0x12d4e6b7;
		case 0x0000e978:
			return 0x980585a5;
		case 0x0000e97c:
			return 0xedf339a8;
		case 0x0000e980:
			return 0x54537f19;
		case 0x0000e984:
			return 0xfd26a771;
		case 0x0000e988:
			return 0x878d7c56;
		case 0x0000e98c:
			return 0x49d803fa;
		case 0x0000e990:
			return 0x66e9780f;
		case 0x0000e994:
			return 0x053c8edb;
		case 0x0000e998:
			return 0xb7dc894f;
		case 0x0000e99c:
			return 0x14787813;
		case 0x0000e9a0:
			return 0x185d326e;
		case 0x0000e9a4:
			return 0x26771f63;
		case 0x0000e9a8:
			return 0x245fdf4c;
		case 0x0000e9ac:
			return 0xc8d8a84f;
		case 0x0000e9b0:
			return 0xb61f92a8;
		case 0x0000e9b4:
			return 0xafac5627;
		case 0x0000e9b8:
			return 0x37911213;
		case 0x0000e9bc:
			return 0xfd298f48;
		case 0x0000e9c0:
			return 0x66bdfda7;
		case 0x0000e9c4:
			return 0xa8dd8433;
		case 0x0000e9c8:
			return 0xc2627147;
		case 0x0000e9cc:
			return 0xb54db5ee;
		case 0x0000e9d0:
			return 0x4f1d61f2;
		case 0x0000e9d4:
			return 0x048953e2;
		case 0x0000e9d8:
			return 0x8e182122;
		case 0x0000e9dc:
			return 0xb0831842;
		case 0x0000e9e0:
			return 0xca617673;
		case 0x0000e9e4:
			return 0x2ad343b4;
		case 0x0000e9e8:
			return 0x7464aa1b;
		case 0x0000e9ec:
			return 0xa0449f07;
		case 0x0000e9f0:
			return 0x34e6ac71;
		case 0x0000e9f4:
			return 0x0145c19b;
		case 0x0000e9f8:
			return 0xc70785cc;
		case 0x0000e9fc:
			return 0x2980cf7d;
		case 0x0000ea00:
			return 0x43b5fb9c;
		case 0x0000ea04:
			return 0xffa3f508;
		case 0x0000ea08:
			return 0xa1477ab4;
		case 0x0000ea0c:
			return 0xd3bfe03a;
		case 0x0000ea10:
			return 0x41d15db3;
		case 0x0000ea14:
			return 0xec0983b4;
		case 0x0000ea18:
			return 0x464dbd92;
		case 0x0000ea1c:
			return 0xa2387c96;
		case 0x0000ea20:
			return 0x33588daf;
		case 0x0000ea24:
			return 0x3e9f50c2;
		case 0x0000ea28:
			return 0xdf2c171d;
		case 0x0000ea2c:
			return 0x31d6df5c;
		case 0x0000ea30:
			return 0x93dbe2f2;
		case 0x0000ea34:
			return 0xf0360a7b;
		case 0x0000ea38:
			return 0xc397bf34;
		case 0x0000ea3c:
			return 0x73855af7;
		case 0x0000ea40:
			return 0xf4959b25;
		case 0x0000ea44:
			return 0xfe6868d1;
		case 0x0000ea48:
			return 0x54a3894e;
		case 0x0000ea4c:
			return 0x60369af3;
		case 0x0000ea50:
			return 0x9355a4e0;
		case 0x0000ea54:
			return 0xf098d165;
		case 0x0000ea58:
			return 0xcf02ac52;
		case 0x0000ea5c:
			return 0x24c2d1dd;
		case 0x0000ea60:
			return 0x4f266d02;
		case 0x0000ea64:
			return 0xc40bbfc2;
		case 0x0000ea68:
			return 0x1ad44a87;
		case 0x0000ea6c:
			return 0x1153ba73;
		case 0x0000ea70:
			return 0xaf2bc70d;
		case 0x0000ea74:
			return 0xc3d3f29e;
		case 0x0000ea78:
			return 0xe877381b;
		case 0x0000ea7c:
			return 0x8e0c11d5;
		case 0x0000ea80:
			return 0xe0bb52c8;
		case 0x0000ea84:
			return 0x3520a68e;
		case 0x0000ea88:
			return 0x7ac51529;
		case 0x0000ea8c:
			return 0xfb4ef4c3;
		case 0x0000ea90:
			return 0x99e3d900;
		case 0x0000ea94:
			return 0x1f39b56b;
		case 0x0000ea98:
			return 0xb6981b0b;
		case 0x0000ea9c:
			return 0x31a7bc06;
		case 0x0000eaa0:
			return 0xfa16eedd;
		case 0x0000eaa4:
			return 0xe021601b;
		case 0x0000eaa8:
			return 0x49d2d8ee;
		case 0x0000eaac:
			return 0x55f6d3b3;
		case 0x0000eab0:
			return 0x6f8fccd9;
		case 0x0000eab4:
			return 0x5a3abf48;
		case 0x0000eab8:
			return 0x2acf5bae;
		case 0x0000eabc:
			return 0xcb062ada;
		case 0x0000eac0:
			return 0xbb3611e3;
		case 0x0000eac4:
			return 0x63d2eb82;
		case 0x0000eac8:
			return 0x1f31c451;
		case 0x0000eacc:
			return 0x054a7da1;
		case 0x0000ead0:
			return 0x556e1fc3;
		case 0x0000ead4:
			return 0x6c10fb5c;
		case 0x0000ead8:
			return 0xec66c804;
		case 0x0000eadc:
			return 0x8944fcc5;
		case 0x0000eae0:
			return 0x8ef3c994;
		case 0x0000eae4:
			return 0x61905842;
		case 0x0000eae8:
			return 0x063baa0f;
		case 0x0000eaec:
			return 0xac3fa468;
		case 0x0000eaf0:
			return 0xd6d377ab;
		case 0x0000eaf4:
			return 0x4c43d2f2;
		case 0x0000eaf8:
			return 0xf1a08d2c;
		case 0x0000eafc:
			return 0xd6624ecd;
		case 0x0000eb00:
			return 0x04e7c0e3;
		case 0x0000eb04:
			return 0xbc9ea6f8;
		case 0x0000eb08:
			return 0xb93ef628;
		case 0x0000eb0c:
			return 0xfa67b084;
		case 0x0000eb10:
			return 0x5b19614a;
		case 0x0000eb14:
			return 0x11505128;
		case 0x0000eb18:
			return 0x65ecdd31;
		case 0x0000eb1c:
			return 0x9d74bea5;
		case 0x0000eb20:
			return 0x1a9c83a8;
		case 0x0000eb24:
			return 0x593b2945;
		case 0x0000eb28:
			return 0x73bb4cdf;
		case 0x0000eb2c:
			return 0x5b2d5b1c;
		case 0x0000eb30:
			return 0x603212e6;
		case 0x0000eb34:
			return 0xc73558b7;
		case 0x0000eb38:
			return 0xc91d0d95;
		case 0x0000eb3c:
			return 0x4ef21fdd;
		case 0x0000eb40:
			return 0xd4b54ff0;
		case 0x0000eb44:
			return 0x6de3d0b8;
		case 0x0000eb48:
			return 0xadec5fd8;
		case 0x0000eb4c:
			return 0xc3f62a05;
		case 0x0000eb50:
			return 0xdb27a1da;
		case 0x0000eb54:
			return 0x743684a9;
		case 0x0000eb58:
			return 0x87e195f3;
		case 0x0000eb5c:
			return 0xce6f4add;
		case 0x0000eb60:
			return 0xa12563a0;
		case 0x0000eb64:
			return 0xb514929a;
		case 0x0000eb68:
			return 0x81e981af;
		case 0x0000eb6c:
			return 0xa4e8d175;
		case 0x0000eb70:
			return 0x5f352e31;
		case 0x0000eb74:
			return 0x645d09dc;
		case 0x0000eb78:
			return 0x53057769;
		case 0x0000eb7c:
			return 0xfe88995e;
		case 0x0000eb80:
			return 0xb3e58ce1;
		case 0x0000eb84:
			return 0xae45af39;
		case 0x0000eb88:
			return 0x3fea6a10;
		case 0x0000eb8c:
			return 0x52ab8693;
		case 0x0000eb90:
			return 0x28aec09d;
		case 0x0000eb94:
			return 0xf0e7e00a;
		case 0x0000eb98:
			return 0x19019486;
		case 0x0000eb9c:
			return 0xaae16280;
		case 0x0000eba0:
			return 0x00fffcce;
		case 0x0000eba4:
			return 0x2bbee0b9;
		case 0x0000eba8:
			return 0xd6de13e6;
		case 0x0000ebac:
			return 0x7b1a6904;
		case 0x0000ebb0:
			return 0xa4bb6416;
		case 0x0000ebb4:
			return 0xbe4b12b1;
		case 0x0000ebb8:
			return 0x1a94dfa9;
		case 0x0000ebbc:
			return 0x6e6aef28;
		case 0x0000ebc0:
			return 0x6c52c703;
		case 0x0000ebc4:
			return 0x43c965c2;
		case 0x0000ebc8:
			return 0x3c9c55d2;
		case 0x0000ebcc:
			return 0xc675f9d2;
		case 0x0000ebd0:
			return 0x4add7154;
		case 0x0000ebd4:
			return 0x3de0599a;
		case 0x0000ebd8:
			return 0x08fa341a;
		case 0x0000ebdc:
			return 0x181dc74e;
		case 0x0000ebe0:
			return 0xf15ba6f2;
		case 0x0000ebe4:
			return 0xebe71a39;
		case 0x0000ebe8:
			return 0xaa0c69f1;
		case 0x0000ebec:
			return 0x99c3e659;
		case 0x0000ebf0:
			return 0xd56e76a2;
		case 0x0000ebf4:
			return 0x6de24b45;
		case 0x0000ebf8:
			return 0x979c2f14;
		case 0x0000ebfc:
			return 0x729c30bb;
		case 0x0000ec00:
			return 0x96374584;
		case 0x0000ec04:
			return 0xd9dda789;
		case 0x0000ec08:
			return 0x2835b8b6;
		case 0x0000ec0c:
			return 0x5509fd10;
		case 0x0000ec10:
			return 0x3022006f;
		case 0x0000ec14:
			return 0x94df7c80;
		case 0x0000ec18:
			return 0x09527822;
		case 0x0000ec1c:
			return 0x1f45c9da;
		case 0x0000ec20:
			return 0x34996e29;
		case 0x0000ec24:
			return 0x02aec9d9;
		case 0x0000ec28:
			return 0x2b1856a3;
		case 0x0000ec2c:
			return 0x38f7d8c5;
		case 0x0000ec30:
			return 0x64988aeb;
		case 0x0000ec34:
			return 0xc369290a;
		case 0x0000ec38:
			return 0xd3ca8f72;
		case 0x0000ec3c:
			return 0xd6855094;
		case 0x0000ec40:
			return 0xa7ae0bc8;
		case 0x0000ec44:
			return 0xa1215c2b;
		case 0x0000ec48:
			return 0xf2dc4442;
		case 0x0000ec4c:
			return 0x2ace96c9;
		case 0x0000ec50:
			return 0x3ed602ed;
		case 0x0000ec54:
			return 0x3749d292;
		case 0x0000ec58:
			return 0x8d1d69b3;
		case 0x0000ec5c:
			return 0xc717e607;
		case 0x0000ec60:
			return 0x5ed1f21c;
		case 0x0000ec64:
			return 0x13213ffe;
		case 0x0000ec68:
			return 0xc8cec031;
		case 0x0000ec6c:
			return 0x7d7f4688;
		case 0x0000ec70:
			return 0xb7d428d8;
		case 0x0000ec74:
			return 0x25f86248;
		case 0x0000ec78:
			return 0xd761d68e;
		case 0x0000ec7c:
			return 0xc416218f;
		case 0x0000ec80:
			return 0xe71646ae;
		case 0x0000ec84:
			return 0x2d4ce5d9;
		case 0x0000ec88:
			return 0x2e22f054;
		case 0x0000ec8c:
			return 0x31550b2c;
		case 0x0000ec90:
			return 0x91041ed6;
		case 0x0000ec94:
			return 0x5a720ce0;
		case 0x0000ec98:
			return 0xe3df2ef3;
		case 0x0000ec9c:
			return 0xf86c29c6;
		case 0x0000eca0:
			return 0x014633c3;
		case 0x0000eca4:
			return 0x1d630134;
		case 0x0000eca8:
			return 0x8562fab8;
		case 0x0000ecac:
			return 0xd13806a6;
		case 0x0000ecb0:
			return 0xebc2a09d;
		case 0x0000ecb4:
			return 0x2d6ced09;
		case 0x0000ecb8:
			return 0x24e4e075;
		case 0x0000ecbc:
			return 0xe19c41cc;
		case 0x0000ecc0:
			return 0x76c92c3e;
		case 0x0000ecc4:
			return 0xcd0b795e;
		case 0x0000ecc8:
			return 0x2e2ae407;
		case 0x0000eccc:
			return 0xdb6bebb8;
		case 0x0000ecd0:
			return 0xf265ae07;
		case 0x0000ecd4:
			return 0x39023779;
		case 0x0000ecd8:
			return 0x9daef8df;
		case 0x0000ecdc:
			return 0x37a13d1a;
		case 0x0000ece0:
			return 0x8dfdabc1;
		case 0x0000ece4:
			return 0x80a90053;
		case 0x0000ece8:
			return 0x08c3d372;
		case 0x0000ecec:
			return 0x713adc87;
		case 0x0000ecf0:
			return 0xaa53de0b;
		case 0x0000ecf4:
			return 0x54b3d5ff;
		case 0x0000ecf8:
			return 0x080bfab6;
		case 0x0000ecfc:
			return 0xe5e92316;
		case 0x0000ed00:
			return 0xc00155d1;
		case 0x0000ed04:
			return 0x56f46511;
		case 0x0000ed08:
			return 0x85c28722;
		case 0x0000ed0c:
			return 0x7d4029ce;
		case 0x0000ed10:
			return 0x9e9f2243;
		case 0x0000ed14:
			return 0x561e4044;
		case 0x0000ed18:
			return 0xeda217e3;
		case 0x0000ed1c:
			return 0x49d941ea;
		case 0x0000ed20:
			return 0x4fb5ed32;
		case 0x0000ed24:
			return 0x09867b6b;
		case 0x0000ed28:
			return 0x34ef3e4f;
		case 0x0000ed2c:
			return 0x7b9f0125;
		case 0x0000ed30:
			return 0xc7a7a77d;
		case 0x0000ed34:
			return 0x79d0313b;
		case 0x0000ed38:
			return 0x4c8ed39d;
		case 0x0000ed3c:
			return 0x0cdd17aa;
		case 0x0000ed40:
			return 0x40232927;
		case 0x0000ed44:
			return 0xfabe784c;
		case 0x0000ed48:
			return 0x5c8a8912;
		case 0x0000ed4c:
			return 0x208b3b7b;
		case 0x0000ed50:
			return 0x7f4443cb;
		case 0x0000ed54:
			return 0x16140a9e;
		case 0x0000ed58:
			return 0xd94ee612;
		case 0x0000ed5c:
			return 0x13787eec;
		case 0x0000ed60:
			return 0xecc428bc;
		case 0x0000ed64:
			return 0xfbdb12f7;
		case 0x0000ed68:
			return 0x0b6389c5;
		case 0x0000ed6c:
			return 0xbad069fe;
		case 0x0000ed70:
			return 0x6f295db5;
		case 0x0000ed74:
			return 0xfd910bb4;
		case 0x0000ed78:
			return 0x9bdad7f4;
		case 0x0000ed7c:
			return 0x9d1456fc;
		case 0x0000ed80:
			return 0x931d3670;
		case 0x0000ed84:
			return 0xa4ecac19;
		case 0x0000ed88:
			return 0xb5b00c9e;
		case 0x0000ed8c:
			return 0xc0d2fd75;
		case 0x0000ed90:
			return 0x23da5e05;
		case 0x0000ed94:
			return 0xb6a50384;
		case 0x0000ed98:
			return 0x0d91a1ff;
		case 0x0000ed9c:
			return 0x58781eb9;
		case 0x0000eda0:
			return 0x93404889;
		case 0x0000eda4:
			return 0x6adf6356;
		case 0x0000eda8:
			return 0x662fd092;
		case 0x0000edac:
			return 0xf070d27c;
		case 0x0000edb0:
			return 0x03bfa42d;
		case 0x0000edb4:
			return 0x2750c44b;
		case 0x0000edb8:
			return 0x914da25e;
		case 0x0000edbc:
			return 0xfd958c9c;
		case 0x0000edc0:
			return 0x97792990;
		case 0x0000edc4:
			return 0x165a5ed1;
		case 0x0000edc8:
			return 0x892e3e98;
		case 0x0000edcc:
			return 0x115b602e;
		case 0x0000edd0:
			return 0x7f9c5548;
		case 0x0000edd4:
			return 0x93c6f053;
		case 0x0000edd8:
			return 0x9efe1999;
		case 0x0000eddc:
			return 0x2046e41a;
		case 0x0000ede0:
			return 0x0bf7b95e;
		case 0x0000ede4:
			return 0xf7a1d32f;
		case 0x0000ede8:
			return 0xb4948513;
		case 0x0000edec:
			return 0xc9aeae15;
		case 0x0000edf0:
			return 0x480433a0;
		case 0x0000edf4:
			return 0x3f8ab84d;
		case 0x0000edf8:
			return 0x5ac8887e;
		case 0x0000edfc:
			return 0x4f9694ed;
		case 0x0000ee00:
			return 0x19d02045;
		case 0x0000ee04:
			return 0xcdf0ad78;
		case 0x0000ee08:
			return 0x1f94cb42;
		case 0x0000ee0c:
			return 0x6dc81d77;
		case 0x0000ee10:
			return 0xaba16cf7;
		case 0x0000ee14:
			return 0x76efc88a;
		case 0x0000ee18:
			return 0x08799a84;
		case 0x0000ee1c:
			return 0xa5b8ae11;
		case 0x0000ee20:
			return 0xcab74db7;
		case 0x0000ee24:
			return 0xf22503c3;
		case 0x0000ee28:
			return 0x1176d0e1;
		case 0x0000ee2c:
			return 0x7ed8105d;
		case 0x0000ee30:
			return 0x56cda7c7;
		case 0x0000ee34:
			return 0x52542e7a;
		case 0x0000ee38:
			return 0xdb4b27a9;
		case 0x0000ee3c:
			return 0x453a5701;
		case 0x0000ee40:
			return 0x1e2a5d2f;
		case 0x0000ee44:
			return 0xe8ff49a2;
		case 0x0000ee48:
			return 0x87710e74;
		case 0x0000ee4c:
			return 0x09fecf41;
		case 0x0000ee50:
			return 0x9cc0d6c9;
		case 0x0000ee54:
			return 0x7ce7e07a;
		case 0x0000ee58:
			return 0x7ce10e9a;
		case 0x0000ee5c:
			return 0xbf4fc880;
		case 0x0000ee60:
			return 0xa227db9b;
		case 0x0000ee64:
			return 0x779e4629;
		case 0x0000ee68:
			return 0xa51f857e;
		case 0x0000ee6c:
			return 0xec347522;
		case 0x0000ee70:
			return 0x50aa577d;
		case 0x0000ee74:
			return 0xaf142f70;
		case 0x0000ee78:
			return 0x3510d1ad;
		case 0x0000ee7c:
			return 0xdff84b01;
		case 0x0000ee80:
			return 0xe1a52d28;
		case 0x0000ee84:
			return 0x60d139c6;
		case 0x0000ee88:
			return 0x2476651d;
		case 0x0000ee8c:
			return 0x6eb4d5aa;
		case 0x0000ee90:
			return 0x659cc157;
		case 0x0000ee94:
			return 0x20da22d6;
		case 0x0000ee98:
			return 0xcc0e94d4;
		case 0x0000ee9c:
			return 0x14657f24;
		case 0x0000eea0:
			return 0xbb6def17;
		case 0x0000eea4:
			return 0x71454378;
		case 0x0000eea8:
			return 0x1426e776;
		case 0x0000eeac:
			return 0x3cddbfb6;
		case 0x0000eeb0:
			return 0x46171de3;
		case 0x0000eeb4:
			return 0xfce72d15;
		case 0x0000eeb8:
			return 0x42f41e04;
		case 0x0000eebc:
			return 0x6e88b545;
		case 0x0000eec0:
			return 0x951ebc88;
		case 0x0000eec4:
			return 0xba53e2d1;
		case 0x0000eec8:
			return 0xd583f1ea;
		case 0x0000eecc:
			return 0xbf0ffc0c;
		case 0x0000eed0:
			return 0x5b130eea;
		case 0x0000eed4:
			return 0x0d2c7e66;
		case 0x0000eed8:
			return 0x5203dab0;
		case 0x0000eedc:
			return 0xfca1339d;
		case 0x0000eee0:
			return 0x6faefd45;
		case 0x0000eee4:
			return 0x22bbe200;
		case 0x0000eee8:
			return 0x18f5db91;
		case 0x0000eeec:
			return 0x3156b679;
		case 0x0000eef0:
			return 0xe9c7e473;
		case 0x0000eef4:
			return 0x6c19dcd1;
		case 0x0000eef8:
			return 0x3d1c2d4e;
		case 0x0000eefc:
			return 0x5ea4f84d;
		case 0x0000ef00:
			return 0x5148bf87;
		case 0x0000ef04:
			return 0x7d7babdd;
		case 0x0000ef08:
			return 0xc830c6c1;
		case 0x0000ef0c:
			return 0xd354de99;
		case 0x0000ef10:
			return 0x854419ce;
		case 0x0000ef14:
			return 0x49da0710;
		case 0x0000ef18:
			return 0xc4c464b9;
		case 0x0000ef1c:
			return 0x820272bd;
		case 0x0000ef20:
			return 0x45310862;
		case 0x0000ef24:
			return 0xe58dab71;
		case 0x0000ef28:
			return 0xa4ff7d77;
		case 0x0000ef2c:
			return 0xd5170996;
		case 0x0000ef30:
			return 0x1d3d057e;
		case 0x0000ef34:
			return 0xeab9bc1c;
		case 0x0000ef38:
			return 0xaeb2f909;
		case 0x0000ef3c:
			return 0xf6745739;
		case 0x0000ef40:
			return 0x6d12b6df;
		case 0x0000ef44:
			return 0x84872199;
		case 0x0000ef48:
			return 0x0dcdb23a;
		case 0x0000ef4c:
			return 0x95fc4518;
		case 0x0000ef50:
			return 0xe6863fc8;
		case 0x0000ef54:
			return 0xed41f72e;
		case 0x0000ef58:
			return 0xe5068897;
		case 0x0000ef5c:
			return 0xb23402bf;
		case 0x0000ef60:
			return 0x7589ee21;
		case 0x0000ef64:
			return 0x349ed48d;
		case 0x0000ef68:
			return 0x836305b5;
		case 0x0000ef6c:
			return 0x6efbbcc0;
		case 0x0000ef70:
			return 0x6ed600b0;
		case 0x0000ef74:
			return 0xc08e1ffa;
		case 0x0000ef78:
			return 0xfac77c2e;
		case 0x0000ef7c:
			return 0x27e92fa4;
		case 0x0000ef80:
			return 0x8a3c5f1f;
		case 0x0000ef84:
			return 0x7b79dde3;
		case 0x0000ef88:
			return 0xa027b3c4;
		case 0x0000ef8c:
			return 0xec553e2a;
		case 0x0000ef90:
			return 0xef8324a4;
		case 0x0000ef94:
			return 0xbf686d10;
		case 0x0000ef98:
			return 0x54718cf5;
		case 0x0000ef9c:
			return 0x0fcf4787;
		case 0x0000efa0:
			return 0x89e0b51f;
		case 0x0000efa4:
			return 0x5262481a;
		case 0x0000efa8:
			return 0x8efd94bc;
		case 0x0000efac:
			return 0x74542ad0;
		case 0x0000efb0:
			return 0xa88a30d8;
		case 0x0000efb4:
			return 0x2791c68c;
		case 0x0000efb8:
			return 0x0dbab467;
		case 0x0000efbc:
			return 0xdb7112a7;
		case 0x0000efc0:
			return 0x44221375;
		case 0x0000efc4:
			return 0x922af447;
		case 0x0000efc8:
			return 0x785db974;
		case 0x0000efcc:
			return 0xd3cbd3ae;
		case 0x0000efd0:
			return 0x7f9ddd7f;
		case 0x0000efd4:
			return 0x00c8a07d;
		case 0x0000efd8:
			return 0x9d78db68;
		case 0x0000efdc:
			return 0x92176dd4;
		case 0x0000efe0:
			return 0x1e015a91;
		case 0x0000efe4:
			return 0x2418d0de;
		case 0x0000efe8:
			return 0x5c1de524;
		case 0x0000efec:
			return 0x90d40954;
		case 0x0000eff0:
			return 0xf4092b91;
		case 0x0000eff4:
			return 0x32a7eb10;
		case 0x0000eff8:
			return 0xc224d7a8;
		case 0x0000effc:
			return 0xf09554f1;
		case 0x0000f000:
			return 0x419df8af;
		case 0x0000f004:
			return 0x78c7f455;
		case 0x0000f008:
			return 0x78e9942a;
		case 0x0000f00c:
			return 0x2ba4198e;
		case 0x0000f010:
			return 0x73caada5;
		case 0x0000f014:
			return 0x2ccf3bcc;
		case 0x0000f018:
			return 0xa75103e4;
		case 0x0000f01c:
			return 0x79dd8d54;
		case 0x0000f020:
			return 0x1dc084b2;
		case 0x0000f024:
			return 0x49bca3de;
		case 0x0000f028:
			return 0x49224d2f;
		case 0x0000f02c:
			return 0xcd1733c0;
		case 0x0000f030:
			return 0xba432bcb;
		case 0x0000f034:
			return 0xf3bccc3b;
		case 0x0000f038:
			return 0x0e24cd2a;
		case 0x0000f03c:
			return 0xc60675a3;
		case 0x0000f040:
			return 0x5848de1d;
		case 0x0000f044:
			return 0x98b306e5;
		case 0x0000f048:
			return 0x23eb412a;
		case 0x0000f04c:
			return 0xbd080ee5;
		case 0x0000f050:
			return 0x4f876f5b;
		case 0x0000f054:
			return 0xb2b2a45c;
		case 0x0000f058:
			return 0x039bec1f;
		case 0x0000f05c:
			return 0x8b4a23af;
		case 0x0000f060:
			return 0xcf9ca591;
		case 0x0000f064:
			return 0x49c14369;
		case 0x0000f068:
			return 0x6ed930d1;
		case 0x0000f06c:
			return 0xaa1eece4;
		case 0x0000f070:
			return 0x9a9f8cb6;
		case 0x0000f074:
			return 0xd31ebf32;
		case 0x0000f078:
			return 0xb08d455e;
		case 0x0000f07c:
			return 0x969c2a0b;
		case 0x0000f080:
			return 0x6f38a6dc;
		case 0x0000f084:
			return 0x35771ce1;
		case 0x0000f088:
			return 0x09012a36;
		case 0x0000f08c:
			return 0x4aca992b;
		case 0x0000f090:
			return 0x2d0e0f92;
		case 0x0000f094:
			return 0x681c7504;
		case 0x0000f098:
			return 0x37bb16c4;
		case 0x0000f09c:
			return 0x53424c83;
		case 0x0000f0a0:
			return 0x17395249;
		case 0x0000f0a4:
			return 0x96db8368;
		case 0x0000f0a8:
			return 0xc0a4e50a;
		case 0x0000f0ac:
			return 0x0d427b43;
		case 0x0000f0b0:
			return 0x7f0274f2;
		case 0x0000f0b4:
			return 0x7d334e5f;
		case 0x0000f0b8:
			return 0xabb3ea31;
		case 0x0000f0bc:
			return 0x0f37fa1a;
		case 0x0000f0c0:
			return 0xac0d218d;
		case 0x0000f0c4:
			return 0xfd4e7daf;
		case 0x0000f0c8:
			return 0x5846aeac;
		case 0x0000f0cc:
			return 0xb6088ef4;
		case 0x0000f0d0:
			return 0x8321591f;
		case 0x0000f0d4:
			return 0xd654dd8f;
		case 0x0000f0d8:
			return 0x569047b4;
		case 0x0000f0dc:
			return 0xaabe1799;
		case 0x0000f0e0:
			return 0xa1c8e159;
		case 0x0000f0e4:
			return 0xecb08618;
		case 0x0000f0e8:
			return 0xe873b555;
		case 0x0000f0ec:
			return 0x4435aa99;
		case 0x0000f0f0:
			return 0xc30ab0d0;
		case 0x0000f0f4:
			return 0x93f0589a;
		case 0x0000f0f8:
			return 0xd807275b;
		case 0x0000f0fc:
			return 0xf9404f19;
		case 0x0000f100:
			return 0x82f56d07;
		case 0x0000f104:
			return 0x4ecdf35f;
		case 0x0000f108:
			return 0x8af2ee18;
		case 0x0000f10c:
			return 0x869ec6e1;
		case 0x0000f110:
			return 0x63675c45;
		case 0x0000f114:
			return 0x7edbbd16;
		case 0x0000f118:
			return 0x03752ca2;
		case 0x0000f11c:
			return 0x0255c7bc;
		case 0x0000f120:
			return 0x9af73dcc;
		case 0x0000f124:
			return 0xa1e58dd4;
		case 0x0000f128:
			return 0xa70a25c7;
		case 0x0000f12c:
			return 0xd631b596;
		case 0x0000f130:
			return 0x4ac7e2cb;
		case 0x0000f134:
			return 0xe98e97d5;
		case 0x0000f138:
			return 0x1f0a55ee;
		case 0x0000f13c:
			return 0x2826f188;
		case 0x0000f140:
			return 0xd03e427b;
		case 0x0000f144:
			return 0x74ef7e28;
		case 0x0000f148:
			return 0xe4ebbf63;
		case 0x0000f14c:
			return 0xed007755;
		case 0x0000f150:
			return 0x863d9297;
		case 0x0000f154:
			return 0x6577065d;
		case 0x0000f158:
			return 0xd81c542f;
		case 0x0000f15c:
			return 0x6ae889e7;
		case 0x0000f160:
			return 0x2db65a9f;
		case 0x0000f164:
			return 0x4643160b;
		case 0x0000f168:
			return 0xdc447a98;
		case 0x0000f16c:
			return 0x2ebe5949;
		case 0x0000f170:
			return 0x0de6ccc3;
		case 0x0000f174:
			return 0x744ee916;
		case 0x0000f178:
			return 0x6a5cb83d;
		case 0x0000f17c:
			return 0x1e2e754c;
		case 0x0000f180:
			return 0xfd2ddde3;
		case 0x0000f184:
			return 0xef3c4e73;
		case 0x0000f188:
			return 0x5b96a66a;
		case 0x0000f18c:
			return 0x1b66adf8;
		case 0x0000f190:
			return 0xa0286bf5;
		case 0x0000f194:
			return 0x2c0c7032;
		case 0x0000f198:
			return 0x49c47774;
		case 0x0000f19c:
			return 0xacfdd97c;
		case 0x0000f1a0:
			return 0x4083ed70;
		case 0x0000f1a4:
			return 0x6c7e0cba;
		case 0x0000f1a8:
			return 0xf2826000;
		case 0x0000f1ac:
			return 0x80da2417;
		case 0x0000f1b0:
			return 0xcb5dcc37;
		case 0x0000f1b4:
			return 0x2e386626;
		case 0x0000f1b8:
			return 0x44a34439;
		case 0x0000f1bc:
			return 0xa8604bb4;
		case 0x0000f1c0:
			return 0x73673a73;
		case 0x0000f1c4:
			return 0x0495af09;
		case 0x0000f1c8:
			return 0xe146ca3a;
		case 0x0000f1cc:
			return 0x843c8601;
		case 0x0000f1d0:
			return 0x1b4c52d2;
		case 0x0000f1d4:
			return 0x7fc31d74;
		case 0x0000f1d8:
			return 0xb0bd8217;
		case 0x0000f1dc:
			return 0xae52ff3f;
		case 0x0000f1e0:
			return 0x5f9cb88e;
		case 0x0000f1e4:
			return 0xfdfa651d;
		case 0x0000f1e8:
			return 0xd62517a9;
		case 0x0000f1ec:
			return 0xa16923dd;
		case 0x0000f1f0:
			return 0x6447c3ae;
		case 0x0000f1f4:
			return 0xde2dda2f;
		case 0x0000f1f8:
			return 0x2f28fe09;
		case 0x0000f1fc:
			return 0xc4c0c567;
		case 0x0000f200:
			return 0x743fa7c2;
		case 0x0000f204:
			return 0x420ba439;
		case 0x0000f208:
			return 0xdcd4c2c3;
		case 0x0000f20c:
			return 0xf5b6b3fe;
		case 0x0000f210:
			return 0xb0407d85;
		case 0x0000f214:
			return 0x693f3d76;
		case 0x0000f218:
			return 0xc45e6c85;
		case 0x0000f21c:
			return 0x10490c61;
		case 0x0000f220:
			return 0x7f1064bd;
		case 0x0000f224:
			return 0x7f2d9c40;
		case 0x0000f228:
			return 0x0f6d58c6;
		case 0x0000f22c:
			return 0xe0f63932;
		case 0x0000f230:
			return 0xaa08499b;
		case 0x0000f234:
			return 0x3c799dce;
		case 0x0000f238:
			return 0x238e2340;
		case 0x0000f23c:
			return 0x2bf3337b;
		case 0x0000f240:
			return 0x598b4dc6;
		case 0x0000f244:
			return 0x1dd7657b;
		case 0x0000f248:
			return 0xed704701;
		case 0x0000f24c:
			return 0x46d24cec;
		case 0x0000f250:
			return 0x51a44145;
		case 0x0000f254:
			return 0x67189932;
		case 0x0000f258:
			return 0xdcf83bfd;
		case 0x0000f25c:
			return 0x2a527b04;
		case 0x0000f260:
			return 0x56205735;
		case 0x0000f264:
			return 0x0a925426;
		case 0x0000f268:
			return 0x7154dfa7;
		case 0x0000f26c:
			return 0x98e47bb5;
		case 0x0000f270:
			return 0x2747a2ce;
		case 0x0000f274:
			return 0x6d750c18;
		case 0x0000f278:
			return 0x3a75fbe7;
		case 0x0000f27c:
			return 0x7f3e7a13;
		case 0x0000f280:
			return 0x4ab9c311;
		case 0x0000f284:
			return 0xce9c96e6;
		case 0x0000f288:
			return 0x9053248a;
		case 0x0000f28c:
			return 0xfd87b9a9;
		case 0x0000f290:
			return 0xc6232f3b;
		case 0x0000f294:
			return 0x42d89c44;
		case 0x0000f298:
			return 0xbdeb6340;
		case 0x0000f29c:
			return 0x1cb6b179;
		case 0x0000f2a0:
			return 0xf388aec9;
		case 0x0000f2a4:
			return 0xa0f818c6;
		case 0x0000f2a8:
			return 0x8f8d6a3b;
		case 0x0000f2ac:
			return 0x745a3a41;
		case 0x0000f2b0:
			return 0x11cd761b;
		case 0x0000f2b4:
			return 0xa5d4aff3;
		case 0x0000f2b8:
			return 0x2992c6b2;
		case 0x0000f2bc:
			return 0x3b03ce25;
		case 0x0000f2c0:
			return 0xa165f5b7;
		case 0x0000f2c4:
			return 0x862b67eb;
		case 0x0000f2c8:
			return 0xbeb6c46b;
		case 0x0000f2cc:
			return 0x40793aa6;
		case 0x0000f2d0:
			return 0xda776a4c;
		case 0x0000f2d4:
			return 0x9d52b41d;
		case 0x0000f2d8:
			return 0x618eb39f;
		case 0x0000f2dc:
			return 0x1fb15ead;
		case 0x0000f2e0:
			return 0x57ecdb0e;
		case 0x0000f2e4:
			return 0x0f146acc;
		case 0x0000f2e8:
			return 0x8f5ea1d3;
		case 0x0000f2ec:
			return 0x89c0a024;
		case 0x0000f2f0:
			return 0x9578da61;
		case 0x0000f2f4:
			return 0x3d331ae5;
		case 0x0000f2f8:
			return 0x7726394f;
		case 0x0000f2fc:
			return 0x7ca7a5ca;
		case 0x0000f300:
			return 0x9e6b57c4;
		case 0x0000f304:
			return 0x45a22559;
		case 0x0000f308:
			return 0xac22ea80;
		case 0x0000f30c:
			return 0xa6edfdb3;
		case 0x0000f310:
			return 0x18e150c7;
		case 0x0000f314:
			return 0x94e07a9f;
		case 0x0000f318:
			return 0x44b532f4;
		case 0x0000f31c:
			return 0xac30cf3e;
		case 0x0000f320:
			return 0xad6dd3f1;
		case 0x0000f324:
			return 0x329fd24d;
		case 0x0000f328:
			return 0x6d8c2412;
		case 0x0000f32c:
			return 0x0e8aacda;
		case 0x0000f330:
			return 0xb535e0ea;
		case 0x0000f334:
			return 0x8efbff87;
		case 0x0000f338:
			return 0x5314c9fc;
		case 0x0000f33c:
			return 0x9d927854;
		case 0x0000f340:
			return 0x906d3127;
		case 0x0000f344:
			return 0xc6878887;
		case 0x0000f348:
			return 0x543cbf47;
		case 0x0000f34c:
			return 0xda2c01a8;
		case 0x0000f350:
			return 0x08af59bd;
		case 0x0000f354:
			return 0xdddab27d;
		case 0x0000f358:
			return 0xb180fb10;
		case 0x0000f35c:
			return 0x165ea918;
		case 0x0000f360:
			return 0xa80bfcf0;
		case 0x0000f364:
			return 0xc48c7f79;
		case 0x0000f368:
			return 0xb20bb6f6;
		case 0x0000f36c:
			return 0x50b6cafa;
		case 0x0000f370:
			return 0xfb8e6870;
		case 0x0000f374:
			return 0xf2036538;
		case 0x0000f378:
			return 0x6a3cbe6b;
		case 0x0000f37c:
			return 0xa9839607;
		case 0x0000f380:
			return 0x0a4dd7e4;
		case 0x0000f384:
			return 0x9274cf05;
		case 0x0000f388:
			return 0x25d6acef;
		case 0x0000f38c:
			return 0x33e13d09;
		case 0x0000f390:
			return 0xab5435ba;
		case 0x0000f394:
			return 0xb5a58853;
		case 0x0000f398:
			return 0x650c071c;
		case 0x0000f39c:
			return 0xcff45c74;
		case 0x0000f3a0:
			return 0x1ecfb0f8;
		case 0x0000f3a4:
			return 0x841ad26e;
		case 0x0000f3a8:
			return 0xc8725f62;
		case 0x0000f3ac:
			return 0x76c7234f;
		case 0x0000f3b0:
			return 0xef0a9a16;
		case 0x0000f3b4:
			return 0x4956b5d4;
		case 0x0000f3b8:
			return 0xda89d09f;
		case 0x0000f3bc:
			return 0x48234515;
		case 0x0000f3c0:
			return 0x0b0cf990;
		case 0x0000f3c4:
			return 0xf0025bab;
		case 0x0000f3c8:
			return 0xccf12aef;
		case 0x0000f3cc:
			return 0x30b0b2d3;
		case 0x0000f3d0:
			return 0x88d0d3cb;
		case 0x0000f3d4:
			return 0x66ec6b93;
		case 0x0000f3d8:
			return 0x6d444756;
		case 0x0000f3dc:
			return 0x2da38997;
		case 0x0000f3e0:
			return 0xf01093fd;
		case 0x0000f3e4:
			return 0x79da9cd1;
		case 0x0000f3e8:
			return 0x68b55235;
		case 0x0000f3ec:
			return 0x3a1bb2ff;
		case 0x0000f3f0:
			return 0x1a1a1e95;
		case 0x0000f3f4:
			return 0x77afbec6;
		case 0x0000f3f8:
			return 0xb90cc9f1;
		case 0x0000f3fc:
			return 0x8cd2b0e5;
		case 0x0000f400:
			return 0x98b53fb1;
		case 0x0000f404:
			return 0x0fbc6915;
		case 0x0000f408:
			return 0xdad7f23d;
		case 0x0000f40c:
			return 0x0a0f12ea;
		case 0x0000f410:
			return 0xe3fd10ad;
		case 0x0000f414:
			return 0x6fe9e1bd;
		case 0x0000f418:
			return 0x134a079e;
		case 0x0000f41c:
			return 0x9bddd4d6;
		case 0x0000f420:
			return 0x9c04997c;
		case 0x0000f424:
			return 0xc3d6a4f7;
		case 0x0000f428:
			return 0x36dd9afe;
		case 0x0000f42c:
			return 0x26012c05;
		case 0x0000f430:
			return 0x78df98e3;
		case 0x0000f434:
			return 0x23d7b5ac;
		case 0x0000f438:
			return 0x30d4f5af;
		case 0x0000f43c:
			return 0x3c8ec6d2;
		case 0x0000f440:
			return 0xa9066bb9;
		case 0x0000f444:
			return 0x9edd0bc6;
		case 0x0000f448:
			return 0x0b08768c;
		case 0x0000f44c:
			return 0x03998491;
		case 0x0000f450:
			return 0xb46d9ead;
		case 0x0000f454:
			return 0xba764882;
		case 0x0000f458:
			return 0x4f8cd9f2;
		case 0x0000f45c:
			return 0x63417f44;
		case 0x0000f460:
			return 0xce4ebee3;
		case 0x0000f464:
			return 0xdd635f50;
		case 0x0000f468:
			return 0x4e3ebcc8;
		case 0x0000f46c:
			return 0x307b2fc6;
		case 0x0000f470:
			return 0x37b3553b;
		case 0x0000f474:
			return 0xb02b98cc;
		case 0x0000f478:
			return 0xd05e5801;
		case 0x0000f47c:
			return 0x5d5ca793;
		case 0x0000f480:
			return 0xa80aeff7;
		case 0x0000f484:
			return 0x29006a6a;
		case 0x0000f488:
			return 0xdc956453;
		case 0x0000f48c:
			return 0xf3933850;
		case 0x0000f490:
			return 0xf86222d4;
		case 0x0000f494:
			return 0x0d7483fa;
		case 0x0000f498:
			return 0x1a7d3c7e;
		case 0x0000f49c:
			return 0xc6943f01;
		case 0x0000f4a0:
			return 0x39d7c54d;
		case 0x0000f4a4:
			return 0x4575b8bd;
		case 0x0000f4a8:
			return 0x796be8a2;
		case 0x0000f4ac:
			return 0x49614b7b;
		case 0x0000f4b0:
			return 0x7615ad66;
		case 0x0000f4b4:
			return 0x7b0a1d06;
		case 0x0000f4b8:
			return 0xfbe73ff6;
		case 0x0000f4bc:
			return 0xdfdab317;
		case 0x0000f4c0:
			return 0xcafe0370;
		case 0x0000f4c4:
			return 0x507071a4;
		case 0x0000f4c8:
			return 0xa9dac919;
		case 0x0000f4cc:
			return 0x4ac6eae3;
		case 0x0000f4d0:
			return 0xe8823c8e;
		case 0x0000f4d4:
			return 0x5290aa2f;
		case 0x0000f4d8:
			return 0x894a871f;
		case 0x0000f4dc:
			return 0x86630ad4;
		case 0x0000f4e0:
			return 0xbfb80454;
		case 0x0000f4e4:
			return 0xf7c9e79a;
		case 0x0000f4e8:
			return 0xf43a9f4b;
		case 0x0000f4ec:
			return 0xd27e8789;
		case 0x0000f4f0:
			return 0x2e292a3d;
		case 0x0000f4f4:
			return 0x9211a11d;
		case 0x0000f4f8:
			return 0x9bd32d8b;
		case 0x0000f4fc:
			return 0xdf65d35c;
		case 0x0000f500:
			return 0xa09d3ccd;
		case 0x0000f504:
			return 0xcbb14d85;
		case 0x0000f508:
			return 0xb8f34f30;
		case 0x0000f50c:
			return 0x25e37c39;
		case 0x0000f510:
			return 0x92a78a90;
		case 0x0000f514:
			return 0x3ecc3037;
		case 0x0000f518:
			return 0x583b49e9;
		case 0x0000f51c:
			return 0x5041c168;
		case 0x0000f520:
			return 0xc4081c0a;
		case 0x0000f524:
			return 0xa6a64271;
		case 0x0000f528:
			return 0x15044876;
		case 0x0000f52c:
			return 0xe76d2284;
		case 0x0000f530:
			return 0x5eaa2dc8;
		case 0x0000f534:
			return 0x60433748;
		case 0x0000f538:
			return 0x2e8827c2;
		case 0x0000f53c:
			return 0xbee225d7;
		case 0x0000f540:
			return 0xb75aec33;
		case 0x0000f544:
			return 0x62590cf4;
		case 0x0000f548:
			return 0xb4e7f9b5;
		case 0x0000f54c:
			return 0x992e09e8;
		case 0x0000f550:
			return 0xd6f0cb8b;
		case 0x0000f554:
			return 0x7240f468;
		case 0x0000f558:
			return 0x09f831b4;
		case 0x0000f55c:
			return 0x87d4ed01;
		case 0x0000f560:
			return 0x39c64c81;
		case 0x0000f564:
			return 0x81abd2ec;
		case 0x0000f568:
			return 0xae6122f9;
		case 0x0000f56c:
			return 0x63217891;
		case 0x0000f570:
			return 0xab4d2de5;
		case 0x0000f574:
			return 0xc27f087b;
		case 0x0000f578:
			return 0xddac8c16;
		case 0x0000f57c:
			return 0x42d2d1c8;
		case 0x0000f580:
			return 0x6452b261;
		case 0x0000f584:
			return 0x0c70e1aa;
		case 0x0000f588:
			return 0xd39ead0d;
		case 0x0000f58c:
			return 0x3438f032;
		case 0x0000f590:
			return 0x2244409e;
		case 0x0000f594:
			return 0x96aa4498;
		case 0x0000f598:
			return 0x45a85033;
		case 0x0000f59c:
			return 0xff3f0b15;
		case 0x0000f5a0:
			return 0xaf9fcf46;
		case 0x0000f5a4:
			return 0x1441a3b4;
		case 0x0000f5a8:
			return 0x89e52209;
		case 0x0000f5ac:
			return 0xc2a395a3;
		case 0x0000f5b0:
			return 0xdf3eb875;
		case 0x0000f5b4:
			return 0xc45dfcff;
		case 0x0000f5b8:
			return 0x73f3383b;
		case 0x0000f5bc:
			return 0xdd78fe25;
		case 0x0000f5c0:
			return 0x9f4d31f6;
		case 0x0000f5c4:
			return 0xc83dba02;
		case 0x0000f5c8:
			return 0x50806933;
		case 0x0000f5cc:
			return 0x55efb065;
		case 0x0000f5d0:
			return 0xd75a55b0;
		case 0x0000f5d4:
			return 0xc70cacf4;
		case 0x0000f5d8:
			return 0x0be6fd2a;
		case 0x0000f5dc:
			return 0xb68e1184;
		case 0x0000f5e0:
			return 0xb08258dc;
		case 0x0000f5e4:
			return 0xf7f3be83;
		case 0x0000f5e8:
			return 0xc3724a26;
		case 0x0000f5ec:
			return 0xe28326e7;
		case 0x0000f5f0:
			return 0x9ca7bf55;
		case 0x0000f5f4:
			return 0x25e1386d;
		case 0x0000f5f8:
			return 0xcc5c28dc;
		case 0x0000f5fc:
			return 0x84344496;
		case 0x0000f600:
			return 0x0c564946;
		case 0x0000f604:
			return 0x12e014da;
		case 0x0000f608:
			return 0x4ea6ea25;
		case 0x0000f60c:
			return 0x465377c4;
		case 0x0000f610:
			return 0x0196387b;
		case 0x0000f614:
			return 0x7ce2669d;
		case 0x0000f618:
			return 0xcfad202c;
		case 0x0000f61c:
			return 0xd0be95aa;
		case 0x0000f620:
			return 0xae1b01ec;
		case 0x0000f624:
			return 0x7ee0e7f2;
		case 0x0000f628:
			return 0x115464f2;
		case 0x0000f62c:
			return 0xa5376cb0;
		case 0x0000f630:
			return 0x699e808a;
		case 0x0000f634:
			return 0x57691f0d;
		case 0x0000f638:
			return 0xe37db430;
		case 0x0000f63c:
			return 0x29fea754;
		case 0x0000f640:
			return 0xe7cdc419;
		case 0x0000f644:
			return 0xa8135138;
		case 0x0000f648:
			return 0x6b049452;
		case 0x0000f64c:
			return 0x22d33fcb;
		case 0x0000f650:
			return 0x7b53a0c7;
		case 0x0000f654:
			return 0x87baf90a;
		case 0x0000f658:
			return 0x9f0272a4;
		case 0x0000f65c:
			return 0x1e08d5e1;
		case 0x0000f660:
			return 0x0bbf61ed;
		case 0x0000f664:
			return 0x4d52fc2a;
		case 0x0000f668:
			return 0x8002409d;
		case 0x0000f66c:
			return 0x63b0f500;
		case 0x0000f670:
			return 0x58deaa8c;
		case 0x0000f674:
			return 0xc1c3dd79;
		case 0x0000f678:
			return 0xe7e61d76;
		case 0x0000f67c:
			return 0x05bdb127;
		case 0x0000f680:
			return 0x7fb3e90f;
		case 0x0000f684:
			return 0x69b7e4ab;
		case 0x0000f688:
			return 0xd7d0f9b5;
		case 0x0000f68c:
			return 0xfb3d047c;
		case 0x0000f690:
			return 0x9fde0ff1;
		case 0x0000f694:
			return 0xed8303f9;
		case 0x0000f698:
			return 0x722610fc;
		case 0x0000f69c:
			return 0x065661e3;
		case 0x0000f6a0:
			return 0xae800c3e;
		case 0x0000f6a4:
			return 0x51d48339;
		case 0x0000f6a8:
			return 0x3c91b019;
		case 0x0000f6ac:
			return 0xebdbb2c2;
		case 0x0000f6b0:
			return 0x38239db0;
		case 0x0000f6b4:
			return 0xa1bdc352;
		case 0x0000f6b8:
			return 0x8989e522;
		case 0x0000f6bc:
			return 0x9c22d4f8;
		case 0x0000f6c0:
			return 0x92faf815;
		case 0x0000f6c4:
			return 0xa60644c6;
		case 0x0000f6c8:
			return 0x551ac393;
		case 0x0000f6cc:
			return 0xa9cbc3e8;
		case 0x0000f6d0:
			return 0x5498873a;
		case 0x0000f6d4:
			return 0x93d54e56;
		case 0x0000f6d8:
			return 0x81aea9c0;
		case 0x0000f6dc:
			return 0x9b844332;
		case 0x0000f6e0:
			return 0x29eee61b;
		case 0x0000f6e4:
			return 0xd3888618;
		case 0x0000f6e8:
			return 0xc50209b9;
		case 0x0000f6ec:
			return 0xbf8576e8;
		case 0x0000f6f0:
			return 0x594d060f;
		case 0x0000f6f4:
			return 0xf777f011;
		case 0x0000f6f8:
			return 0x5a0aa35b;
		case 0x0000f6fc:
			return 0x57e8a1bd;
		case 0x0000f700:
			return 0xfdac571b;
		case 0x0000f704:
			return 0x0c7ef184;
		case 0x0000f708:
			return 0xdfcb6954;
		case 0x0000f70c:
			return 0xcbd1dc28;
		case 0x0000f710:
			return 0x34ba19a4;
		case 0x0000f714:
			return 0x26c4f21c;
		case 0x0000f718:
			return 0x8fb8b928;
		case 0x0000f71c:
			return 0x66af1130;
		case 0x0000f720:
			return 0xfe6278b2;
		case 0x0000f724:
			return 0x88c67875;
		case 0x0000f728:
			return 0x79ffa3a1;
		case 0x0000f72c:
			return 0x9e66bc17;
		case 0x0000f730:
			return 0x5b885143;
		case 0x0000f734:
			return 0x2b612276;
		case 0x0000f738:
			return 0x7074133f;
		case 0x0000f73c:
			return 0xfb0c5d55;
		case 0x0000f740:
			return 0x4a42205d;
		case 0x0000f744:
			return 0x6019440d;
		case 0x0000f748:
			return 0xad704bfb;
		case 0x0000f74c:
			return 0x79866e9a;
		case 0x0000f750:
			return 0xba57f390;
		case 0x0000f754:
			return 0xb8f081b3;
		case 0x0000f758:
			return 0xdf9fe297;
		case 0x0000f75c:
			return 0xd60dba46;
		case 0x0000f760:
			return 0x6deea4b6;
		case 0x0000f764:
			return 0xed16e53c;
		case 0x0000f768:
			return 0xc9eebf4a;
		case 0x0000f76c:
			return 0x887b423d;
		case 0x0000f770:
			return 0xcca92cc1;
		case 0x0000f774:
			return 0x0cb7d3fb;
		case 0x0000f778:
			return 0x55149234;
		case 0x0000f77c:
			return 0xffc00e3a;
		case 0x0000f780:
			return 0x29428ede;
		case 0x0000f784:
			return 0xad305f28;
		case 0x0000f788:
			return 0xaa1f2828;
		case 0x0000f78c:
			return 0x46facdb5;
		case 0x0000f790:
			return 0x1a80cecb;
		case 0x0000f794:
			return 0x547d76ab;
		case 0x0000f798:
			return 0x47830565;
		case 0x0000f79c:
			return 0xa67e1338;
		case 0x0000f7a0:
			return 0x1cc55e2a;
		case 0x0000f7a4:
			return 0x02df9116;
		case 0x0000f7a8:
			return 0x1604cf66;
		case 0x0000f7ac:
			return 0x03ebfa9a;
		case 0x0000f7b0:
			return 0x26c91069;
		case 0x0000f7b4:
			return 0x9e4b3f50;
		case 0x0000f7b8:
			return 0x5b7353cb;
		case 0x0000f7bc:
			return 0x1d3183a4;
		case 0x0000f7c0:
			return 0xe9282bbc;
		case 0x0000f7c4:
			return 0x0bb6c8c2;
		case 0x0000f7c8:
			return 0xe8fddc11;
		case 0x0000f7cc:
			return 0x622e57e7;
		case 0x0000f7d0:
			return 0x6f762dc6;
		case 0x0000f7d4:
			return 0x6b9cc07f;
		case 0x0000f7d8:
			return 0x03cccde0;
		case 0x0000f7dc:
			return 0x10a64583;
		case 0x0000f7e0:
			return 0x11ee6d02;
		case 0x0000f7e4:
			return 0x9fcee31d;
		case 0x0000f7e8:
			return 0x87673b5d;
		case 0x0000f7ec:
			return 0x91085e1b;
		case 0x0000f7f0:
			return 0x32291024;
		case 0x0000f7f4:
			return 0xf9d8f247;
		case 0x0000f7f8:
			return 0xe78610ce;
		case 0x0000f7fc:
			return 0xdea6c7aa;
		case 0x0000f800:
			return 0x1bfc38c6;
		case 0x0000f804:
			return 0x5bf980f5;
		case 0x0000f808:
			return 0x0929f279;
		case 0x0000f80c:
			return 0x4cb8b8e9;
		case 0x0000f810:
			return 0x7d10f91e;
		case 0x0000f814:
			return 0xeb913936;
		case 0x0000f818:
			return 0x90693f29;
		case 0x0000f81c:
			return 0x6b008b68;
		case 0x0000f820:
			return 0xad1eb00e;
		case 0x0000f824:
			return 0x10fae31b;
		case 0x0000f828:
			return 0x7746db6d;
		case 0x0000f82c:
			return 0x70d63106;
		case 0x0000f830:
			return 0x5b4c1cf9;
		case 0x0000f834:
			return 0x8de588ff;
		case 0x0000f838:
			return 0x9a9c191a;
		case 0x0000f83c:
			return 0x472638f1;
		case 0x0000f840:
			return 0x26efdf10;
		case 0x0000f844:
			return 0x64cb8eae;
		case 0x0000f848:
			return 0xd2da6dd3;
		case 0x0000f84c:
			return 0x49ab3b6f;
		case 0x0000f850:
			return 0x5f81f9ca;
		case 0x0000f854:
			return 0x23da5984;
		case 0x0000f858:
			return 0x1b87da6c;
		case 0x0000f85c:
			return 0x60b21d86;
		case 0x0000f860:
			return 0xa5d79a29;
		case 0x0000f864:
			return 0xfec74927;
		case 0x0000f868:
			return 0x477c324a;
		case 0x0000f86c:
			return 0xd45d58b0;
		case 0x0000f870:
			return 0xec5d90f3;
		case 0x0000f874:
			return 0x83526724;
		case 0x0000f878:
			return 0xd9fe4387;
		case 0x0000f87c:
			return 0xffc50c93;
		case 0x0000f880:
			return 0xf1475413;
		case 0x0000f884:
			return 0x542fb123;
		case 0x0000f888:
			return 0x3a8ffcb0;
		case 0x0000f88c:
			return 0x257aa9a2;
		case 0x0000f890:
			return 0x4701b784;
		case 0x0000f894:
			return 0x96911b39;
		case 0x0000f898:
			return 0x4f302f8e;
		case 0x0000f89c:
			return 0x7a8bcbc8;
		case 0x0000f8a0:
			return 0x6c0b1ffa;
		case 0x0000f8a4:
			return 0x209663d2;
		case 0x0000f8a8:
			return 0x4b94028b;
		case 0x0000f8ac:
			return 0x238062fc;
		case 0x0000f8b0:
			return 0xbec11948;
		case 0x0000f8b4:
			return 0x514654a9;
		case 0x0000f8b8:
			return 0xd624c205;
		case 0x0000f8bc:
			return 0x7a696830;
		case 0x0000f8c0:
			return 0x63782c71;
		case 0x0000f8c4:
			return 0xf402b93e;
		case 0x0000f8c8:
			return 0x832eac9c;
		case 0x0000f8cc:
			return 0xdaa7e370;
		case 0x0000f8d0:
			return 0x3e528771;
		case 0x0000f8d4:
			return 0x38d0b7bb;
		case 0x0000f8d8:
			return 0x80bf5fb5;
		case 0x0000f8dc:
			return 0x64419df8;
		case 0x0000f8e0:
			return 0xd053cd9e;
		case 0x0000f8e4:
			return 0xc4693809;
		case 0x0000f8e8:
			return 0xd28219f3;
		case 0x0000f8ec:
			return 0xc200c42c;
		case 0x0000f8f0:
			return 0x39e18e70;
		case 0x0000f8f4:
			return 0xd00b435b;
		case 0x0000f8f8:
			return 0xd29f1682;
		case 0x0000f8fc:
			return 0x03785c63;
		case 0x0000f900:
			return 0x747861b9;
		case 0x0000f904:
			return 0x729eddb8;
		case 0x0000f908:
			return 0x0996c4dd;
		case 0x0000f90c:
			return 0xb3c2cddf;
		case 0x0000f910:
			return 0x86c3d56a;
		case 0x0000f914:
			return 0xd899b22f;
		case 0x0000f918:
			return 0x298c880a;
		case 0x0000f91c:
			return 0xb34aaf5e;
		case 0x0000f920:
			return 0x32c246c6;
		case 0x0000f924:
			return 0x1e0c17f2;
		case 0x0000f928:
			return 0x51fcc022;
		case 0x0000f92c:
			return 0x50000937;
		case 0x0000f930:
			return 0xb1b83e49;
		case 0x0000f934:
			return 0x2c91313e;
		case 0x0000f938:
			return 0x2ac739af;
		case 0x0000f93c:
			return 0xd037829f;
		case 0x0000f940:
			return 0x4a44220f;
		case 0x0000f944:
			return 0x8ffc260b;
		case 0x0000f948:
			return 0x312440c7;
		case 0x0000f94c:
			return 0x70408484;
		case 0x0000f950:
			return 0xd1858306;
		case 0x0000f954:
			return 0xe71f0b5e;
		case 0x0000f958:
			return 0x81f6bc4f;
		case 0x0000f95c:
			return 0xf584198c;
		case 0x0000f960:
			return 0x431a0551;
		case 0x0000f964:
			return 0x6faa6c60;
		case 0x0000f968:
			return 0xeed0b172;
		case 0x0000f96c:
			return 0x1c91c106;
		case 0x0000f970:
			return 0x9c11daec;
		case 0x0000f974:
			return 0xe7b17e34;
		case 0x0000f978:
			return 0xcb3d2b43;
		case 0x0000f97c:
			return 0x02eacc08;
		case 0x0000f980:
			return 0x11a725fb;
		case 0x0000f984:
			return 0xd1a31406;
		case 0x0000f988:
			return 0x75992abd;
		case 0x0000f98c:
			return 0xea666872;
		case 0x0000f990:
			return 0x06f11a6c;
		case 0x0000f994:
			return 0x074aac34;
		case 0x0000f998:
			return 0x5a9ff856;
		case 0x0000f99c:
			return 0x71dc3e57;
		case 0x0000f9a0:
			return 0x924eba73;
		case 0x0000f9a4:
			return 0x4a259c20;
		case 0x0000f9a8:
			return 0x772c5349;
		case 0x0000f9ac:
			return 0x7ac8a9b4;
		case 0x0000f9b0:
			return 0xb3e91a90;
		case 0x0000f9b4:
			return 0xdb5b6102;
		case 0x0000f9b8:
			return 0xa03b1936;
		case 0x0000f9bc:
			return 0xa9b6f91b;
		case 0x0000f9c0:
			return 0xd92f8b25;
		case 0x0000f9c4:
			return 0x87b1fcab;
		case 0x0000f9c8:
			return 0xed1acf5d;
		case 0x0000f9cc:
			return 0x1b8bf2cc;
		case 0x0000f9d0:
			return 0xd9fe94b7;
		case 0x0000f9d4:
			return 0x9ad98825;
		case 0x0000f9d8:
			return 0x1f84986b;
		case 0x0000f9dc:
			return 0x9939415e;
		case 0x0000f9e0:
			return 0x20a69b38;
		case 0x0000f9e4:
			return 0x79ef10f0;
		case 0x0000f9e8:
			return 0x74a62ec4;
		case 0x0000f9ec:
			return 0x75ef54de;
		case 0x0000f9f0:
			return 0x931532a0;
		case 0x0000f9f4:
			return 0x03b4e19c;
		case 0x0000f9f8:
			return 0x46aaea65;
		case 0x0000f9fc:
			return 0xa4fd56fd;
		case 0x0000fa00:
			return 0xce41a776;
		case 0x0000fa04:
			return 0x24c65053;
		case 0x0000fa08:
			return 0xd79777a7;
		case 0x0000fa0c:
			return 0x59bf6274;
		case 0x0000fa10:
			return 0x02834183;
		case 0x0000fa14:
			return 0xbe980906;
		case 0x0000fa18:
			return 0xd8d069db;
		case 0x0000fa1c:
			return 0x2a5a5de8;
		case 0x0000fa20:
			return 0x2f128afb;
		case 0x0000fa24:
			return 0x6f9a8625;
		case 0x0000fa28:
			return 0x440ae7a8;
		case 0x0000fa2c:
			return 0x0139cd7a;
		case 0x0000fa30:
			return 0x13e8b7ea;
		case 0x0000fa34:
			return 0x5a5862b8;
		case 0x0000fa38:
			return 0xa35a9b38;
		case 0x0000fa3c:
			return 0x9c67d543;
		case 0x0000fa40:
			return 0x813c4293;
		case 0x0000fa44:
			return 0x58df3b97;
		case 0x0000fa48:
			return 0x470e4a88;
		case 0x0000fa4c:
			return 0xe74ebf73;
		case 0x0000fa50:
			return 0x838654e0;
		case 0x0000fa54:
			return 0xecf4139c;
		case 0x0000fa58:
			return 0xa9550e74;
		case 0x0000fa5c:
			return 0x84d99dc4;
		case 0x0000fa60:
			return 0x3f7553f1;
		case 0x0000fa64:
			return 0xad7c8070;
		case 0x0000fa68:
			return 0x29a218fb;
		case 0x0000fa6c:
			return 0x2692bcf2;
		case 0x0000fa70:
			return 0x37e3892f;
		case 0x0000fa74:
			return 0x310da53e;
		case 0x0000fa78:
			return 0x9cd3a257;
		case 0x0000fa7c:
			return 0x8f520497;
		case 0x0000fa80:
			return 0x4ce16f42;
		case 0x0000fa84:
			return 0xcd27d8a0;
		case 0x0000fa88:
			return 0xe31795fe;
		case 0x0000fa8c:
			return 0x38a35ad1;
		case 0x0000fa90:
			return 0x6f2f6000;
		case 0x0000fa94:
			return 0x9cac0039;
		case 0x0000fa98:
			return 0xa60aff68;
		case 0x0000fa9c:
			return 0x5844a09a;
		case 0x0000faa0:
			return 0x37280a75;
		case 0x0000faa4:
			return 0x331a51c0;
		case 0x0000faa8:
			return 0x34b0deaa;
		case 0x0000faac:
			return 0xd01e8496;
		case 0x0000fab0:
			return 0x12b767f9;
		case 0x0000fab4:
			return 0xd4dbf949;
		case 0x0000fab8:
			return 0x79d9a387;
		case 0x0000fabc:
			return 0x3ed4f0fb;
		case 0x0000fac0:
			return 0x0bde8023;
		case 0x0000fac4:
			return 0x57895fbc;
		case 0x0000fac8:
			return 0xb8dbf23a;
		case 0x0000facc:
			return 0x793ffd10;
		case 0x0000fad0:
			return 0x1458a976;
		case 0x0000fad4:
			return 0x10da7799;
		case 0x0000fad8:
			return 0x7d63ecf8;
		case 0x0000fadc:
			return 0xb1b03b40;
		case 0x0000fae0:
			return 0xc11a8e71;
		case 0x0000fae4:
			return 0x3f9beb31;
		case 0x0000fae8:
			return 0xca700c2d;
		case 0x0000faec:
			return 0xfc615315;
		case 0x0000faf0:
			return 0x4f57ab40;
		case 0x0000faf4:
			return 0xb27342fe;
		case 0x0000faf8:
			return 0x4b385abb;
		case 0x0000fafc:
			return 0xfd9e6c83;
		case 0x0000fb00:
			return 0x92ae0a77;
		case 0x0000fb04:
			return 0x5cbcbb8e;
		case 0x0000fb08:
			return 0x5c5439f3;
		case 0x0000fb0c:
			return 0x3cb3b56d;
		case 0x0000fb10:
			return 0x00f6e1c4;
		case 0x0000fb14:
			return 0x25349836;
		case 0x0000fb18:
			return 0xbb33bed1;
		case 0x0000fb1c:
			return 0x81159744;
		case 0x0000fb20:
			return 0xb0ea0fec;
		case 0x0000fb24:
			return 0x41fe936d;
		case 0x0000fb28:
			return 0x069525ab;
		case 0x0000fb2c:
			return 0x0d421847;
		case 0x0000fb30:
			return 0x17708f3c;
		case 0x0000fb34:
			return 0x758b248d;
		case 0x0000fb38:
			return 0xa9ed9109;
		case 0x0000fb3c:
			return 0x7b792171;
		case 0x0000fb40:
			return 0xce83dd89;
		case 0x0000fb44:
			return 0xc3933c3f;
		case 0x0000fb48:
			return 0x17ce1f35;
		case 0x0000fb4c:
			return 0x77f1c457;
		case 0x0000fb50:
			return 0xeb2c41a5;
		case 0x0000fb54:
			return 0x605c55c7;
		case 0x0000fb58:
			return 0xd332ea8d;
		case 0x0000fb5c:
			return 0xe506cc7d;
		case 0x0000fb60:
			return 0xdec3bc47;
		case 0x0000fb64:
			return 0x7893acea;
		case 0x0000fb68:
			return 0x40730297;
		case 0x0000fb6c:
			return 0x881be10f;
		case 0x0000fb70:
			return 0x06fae748;
		case 0x0000fb74:
			return 0x1ca42aa4;
		case 0x0000fb78:
			return 0x94698506;
		case 0x0000fb7c:
			return 0xa5ff7f3a;
		case 0x0000fb80:
			return 0xde51cf1d;
		case 0x0000fb84:
			return 0xddf6fcf8;
		case 0x0000fb88:
			return 0x7c3a6f17;
		case 0x0000fb8c:
			return 0x3258d28d;
		case 0x0000fb90:
			return 0x8b130c63;
		case 0x0000fb94:
			return 0x26ae5929;
		case 0x0000fb98:
			return 0x2530b82c;
		case 0x0000fb9c:
			return 0x519c789b;
		case 0x0000fba0:
			return 0x65a28e40;
		case 0x0000fba4:
			return 0x29c72a01;
		case 0x0000fba8:
			return 0xba33fb23;
		case 0x0000fbac:
			return 0xcfa85039;
		case 0x0000fbb0:
			return 0xeb40dce6;
		case 0x0000fbb4:
			return 0x94b71955;
		case 0x0000fbb8:
			return 0x1c9a30c2;
		case 0x0000fbbc:
			return 0x239c64be;
		case 0x0000fbc0:
			return 0xb853bff6;
		case 0x0000fbc4:
			return 0xee844b32;
		case 0x0000fbc8:
			return 0x51f81bad;
		case 0x0000fbcc:
			return 0xa8d6e9d4;
		case 0x0000fbd0:
			return 0x46487b4f;
		case 0x0000fbd4:
			return 0x85fda962;
		case 0x0000fbd8:
			return 0x09e2c887;
		case 0x0000fbdc:
			return 0x70ff3cca;
		case 0x0000fbe0:
			return 0x6b6f5810;
		case 0x0000fbe4:
			return 0xaef2e495;
		case 0x0000fbe8:
			return 0x93b03821;
		case 0x0000fbec:
			return 0x08e21126;
		case 0x0000fbf0:
			return 0xd11e8d81;
		case 0x0000fbf4:
			return 0x7b7d820b;
		case 0x0000fbf8:
			return 0x49887cf8;
		case 0x0000fbfc:
			return 0xad3460ef;
		case 0x0000fc00:
			return 0xc0094e98;
		case 0x0000fc04:
			return 0x9afc9d48;
		case 0x0000fc08:
			return 0x3f3baafb;
		case 0x0000fc0c:
			return 0x4ad9abf6;
		case 0x0000fc10:
			return 0xe22cc090;
		case 0x0000fc14:
			return 0x983ee020;
		case 0x0000fc18:
			return 0x3bf73d44;
		case 0x0000fc1c:
			return 0x685e3c84;
		case 0x0000fc20:
			return 0x732d4db3;
		case 0x0000fc24:
			return 0xe45a0bbd;
		case 0x0000fc28:
			return 0xe92a6ae1;
		case 0x0000fc2c:
			return 0x991ede5a;
		case 0x0000fc30:
			return 0x890da72b;
		case 0x0000fc34:
			return 0x5c3f82fe;
		case 0x0000fc38:
			return 0x59624d82;
		case 0x0000fc3c:
			return 0x31d51fd0;
		case 0x0000fc40:
			return 0x9643ded4;
		case 0x0000fc44:
			return 0xac595658;
		case 0x0000fc48:
			return 0x90fa8944;
		case 0x0000fc4c:
			return 0x65df3db8;
		case 0x0000fc50:
			return 0xe5fa501f;
		case 0x0000fc54:
			return 0x5dba55c4;
		case 0x0000fc58:
			return 0x76678340;
		case 0x0000fc5c:
			return 0xe2705fd7;
		case 0x0000fc60:
			return 0x8454d74d;
		case 0x0000fc64:
			return 0xf6e4090e;
		case 0x0000fc68:
			return 0x975de038;
		case 0x0000fc6c:
			return 0x9996368a;
		case 0x0000fc70:
			return 0xd82d68ac;
		case 0x0000fc74:
			return 0x7795e662;
		case 0x0000fc78:
			return 0xae2951d5;
		case 0x0000fc7c:
			return 0x9c9e606f;
		case 0x0000fc80:
			return 0xcd661e9f;
		case 0x0000fc84:
			return 0xd16eb934;
		case 0x0000fc88:
			return 0x44449f5e;
		case 0x0000fc8c:
			return 0x8ee1b030;
		case 0x0000fc90:
			return 0xedd44403;
		case 0x0000fc94:
			return 0x9dd6746a;
		case 0x0000fc98:
			return 0x96c9ec74;
		case 0x0000fc9c:
			return 0x0883b3ce;
		case 0x0000fca0:
			return 0x835cdfe2;
		case 0x0000fca4:
			return 0xf5c99e68;
		case 0x0000fca8:
			return 0x68d80c9c;
		case 0x0000fcac:
			return 0x941dae67;
		case 0x0000fcb0:
			return 0x6e773086;
		case 0x0000fcb4:
			return 0x889223f2;
		case 0x0000fcb8:
			return 0xe664a198;
		case 0x0000fcbc:
			return 0x47912441;
		case 0x0000fcc0:
			return 0x458b2b1f;
		case 0x0000fcc4:
			return 0x4caffafd;
		case 0x0000fcc8:
			return 0x53dc5765;
		case 0x0000fccc:
			return 0xf5993596;
		case 0x0000fcd0:
			return 0xf5476c62;
		case 0x0000fcd4:
			return 0xc528f4df;
		case 0x0000fcd8:
			return 0x83626c0e;
		case 0x0000fcdc:
			return 0x50a168cb;
		case 0x0000fce0:
			return 0xaa9beb92;
		case 0x0000fce4:
			return 0x61fe9fc7;
		case 0x0000fce8:
			return 0x55bd50ca;
		case 0x0000fcec:
			return 0x6d29de7a;
		case 0x0000fcf0:
			return 0xc594af62;
		case 0x0000fcf4:
			return 0x70b9f760;
		case 0x0000fcf8:
			return 0x98de8ae3;
		case 0x0000fcfc:
			return 0x5f2c93e2;
		case 0x0000fd00:
			return 0xc066b332;
		case 0x0000fd04:
			return 0x684129bb;
		case 0x0000fd08:
			return 0x37807f7b;
		case 0x0000fd0c:
			return 0xa91927bb;
		case 0x0000fd10:
			return 0xa8bb1222;
		case 0x0000fd14:
			return 0xdb099bcd;
		case 0x0000fd18:
			return 0xb067a9f9;
		case 0x0000fd1c:
			return 0xa288dc40;
		case 0x0000fd20:
			return 0x65e4948c;
		case 0x0000fd24:
			return 0xad71dde1;
		case 0x0000fd28:
			return 0x52b1c3eb;
		case 0x0000fd2c:
			return 0xb193accd;
		case 0x0000fd30:
			return 0x4dab9a34;
		case 0x0000fd34:
			return 0x84dc44a7;
		case 0x0000fd38:
			return 0x0e8b786d;
		case 0x0000fd3c:
			return 0x4876be1f;
		case 0x0000fd40:
			return 0xe8ee66ad;
		case 0x0000fd44:
			return 0xced317ed;
		case 0x0000fd48:
			return 0x94782de0;
		case 0x0000fd4c:
			return 0x0654856d;
		case 0x0000fd50:
			return 0xea2e2bd8;
		case 0x0000fd54:
			return 0x6ffdc7ed;
		case 0x0000fd58:
			return 0x51076fe1;
		case 0x0000fd5c:
			return 0x9b7ca9c2;
		case 0x0000fd60:
			return 0xdd075f79;
		case 0x0000fd64:
			return 0xd38fbf3d;
		case 0x0000fd68:
			return 0x38b039c7;
		case 0x0000fd6c:
			return 0xc35e752c;
		case 0x0000fd70:
			return 0x72c2e945;
		case 0x0000fd74:
			return 0xc509c48c;
		case 0x0000fd78:
			return 0x7f84bade;
		case 0x0000fd7c:
			return 0xb78b88b0;
		case 0x0000fd80:
			return 0x657050ff;
		case 0x0000fd84:
			return 0x64357011;
		case 0x0000fd88:
			return 0xc84b6cd5;
		case 0x0000fd8c:
			return 0x558110ee;
		case 0x0000fd90:
			return 0xbce7507e;
		case 0x0000fd94:
			return 0xba37815e;
		case 0x0000fd98:
			return 0x0f3511ba;
		case 0x0000fd9c:
			return 0x8721cb7e;
		case 0x0000fda0:
			return 0x2fdab77b;
		case 0x0000fda4:
			return 0xf829ad3f;
		case 0x0000fda8:
			return 0xb78efa75;
		case 0x0000fdac:
			return 0xba537612;
		case 0x0000fdb0:
			return 0xd3611031;
		case 0x0000fdb4:
			return 0xbfb2c5b8;
		case 0x0000fdb8:
			return 0xac1c2b5b;
		case 0x0000fdbc:
			return 0x96ba9fe3;
		case 0x0000fdc0:
			return 0x4f933360;
		case 0x0000fdc4:
			return 0x72e4eaa3;
		case 0x0000fdc8:
			return 0xb42e2aee;
		case 0x0000fdcc:
			return 0xa8bbb885;
		case 0x0000fdd0:
			return 0xa9bd3f2e;
		case 0x0000fdd4:
			return 0x3c00b0c4;
		case 0x0000fdd8:
			return 0x57326fce;
		case 0x0000fddc:
			return 0x8b930af1;
		case 0x0000fde0:
			return 0x0db37c87;
		case 0x0000fde4:
			return 0x66674c9e;
		case 0x0000fde8:
			return 0x49e686d4;
		case 0x0000fdec:
			return 0xb9a731d9;
		case 0x0000fdf0:
			return 0xf6bfc5f1;
		case 0x0000fdf4:
			return 0x1fb42c01;
		case 0x0000fdf8:
			return 0x915a97d9;
		case 0x0000fdfc:
			return 0xc3fcfdeb;
		case 0x0000fe00:
			return 0xbc8f9350;
		case 0x0000fe04:
			return 0x66beded0;
		case 0x0000fe08:
			return 0xbeca7a48;
		case 0x0000fe0c:
			return 0x5ab20ef7;
		case 0x0000fe10:
			return 0xe512f9dc;
		case 0x0000fe14:
			return 0x0c9586e2;
		case 0x0000fe18:
			return 0xe158866a;
		case 0x0000fe1c:
			return 0xa821a195;
		case 0x0000fe20:
			return 0xcd2c9ddd;
		case 0x0000fe24:
			return 0xcd08c2a3;
		case 0x0000fe28:
			return 0xa863dc85;
		case 0x0000fe2c:
			return 0xd72b7996;
		case 0x0000fe30:
			return 0xef2462d8;
		case 0x0000fe34:
			return 0x866dd6fc;
		case 0x0000fe38:
			return 0xa334dad0;
		case 0x0000fe3c:
			return 0x63e2e4b6;
		case 0x0000fe40:
			return 0xfb785135;
		case 0x0000fe44:
			return 0x581c0877;
		case 0x0000fe48:
			return 0x422d41cd;
		case 0x0000fe4c:
			return 0x189dd073;
		case 0x0000fe50:
			return 0xf7262d20;
		case 0x0000fe54:
			return 0x67af8162;
		case 0x0000fe58:
			return 0x32ac05a1;
		case 0x0000fe5c:
			return 0x31fc4fde;
		case 0x0000fe60:
			return 0x016cc388;
		case 0x0000fe64:
			return 0xf9661997;
		case 0x0000fe68:
			return 0x58906526;
		case 0x0000fe6c:
			return 0x33ada52e;
		case 0x0000fe70:
			return 0x46a56edc;
		case 0x0000fe74:
			return 0x6ca71adf;
		case 0x0000fe78:
			return 0x66442be8;
		case 0x0000fe7c:
			return 0x2aeda8e9;
		case 0x0000fe80:
			return 0x25883acf;
		case 0x0000fe84:
			return 0xcddbefbb;
		case 0x0000fe88:
			return 0x282ec7aa;
		case 0x0000fe8c:
			return 0xe99a5e1b;
		case 0x0000fe90:
			return 0x483fe0bf;
		case 0x0000fe94:
			return 0x8497e59e;
		case 0x0000fe98:
			return 0xaa1f1211;
		case 0x0000fe9c:
			return 0x786c05a6;
		case 0x0000fea0:
			return 0x291953a8;
		case 0x0000fea4:
			return 0x53c7251e;
		case 0x0000fea8:
			return 0xb9ec2fa2;
		case 0x0000feac:
			return 0x0d4c2eb9;
		case 0x0000feb0:
			return 0xd99be26d;
		case 0x0000feb4:
			return 0x05a1944d;
		case 0x0000feb8:
			return 0x919cd95b;
		case 0x0000febc:
			return 0x1e42f01b;
		case 0x0000fec0:
			return 0x5de3671c;
		case 0x0000fec4:
			return 0x064e397a;
		case 0x0000fec8:
			return 0xb97503f9;
		case 0x0000fecc:
			return 0xa52b2635;
		case 0x0000fed0:
			return 0x67d6f649;
		case 0x0000fed4:
			return 0x2f13fe76;
		case 0x0000fed8:
			return 0x0e68279b;
		case 0x0000fedc:
			return 0xe5701c17;
		case 0x0000fee0:
			return 0x9198c0de;
		case 0x0000fee4:
			return 0xcb7782c9;
		case 0x0000fee8:
			return 0x689c8bab;
		case 0x0000feec:
			return 0x7f367ef5;
		case 0x0000fef0:
			return 0x3ad047af;
		case 0x0000fef4:
			return 0x28adc99d;
		case 0x0000fef8:
			return 0x048297ab;
		case 0x0000fefc:
			return 0x3f073786;
		case 0x0000ff00:
			return 0xb661d26c;
		case 0x0000ff04:
			return 0xb4ee3a5d;
		case 0x0000ff08:
			return 0xbe780411;
		case 0x0000ff0c:
			return 0x0efa472c;
		case 0x0000ff10:
			return 0xe72e21cc;
		case 0x0000ff14:
			return 0xe2e38c52;
		case 0x0000ff18:
			return 0x85f9175a;
		case 0x0000ff1c:
			return 0xe7e0875c;
		case 0x0000ff20:
			return 0xb929a2fd;
		case 0x0000ff24:
			return 0x5e5de602;
		case 0x0000ff28:
			return 0x320081c1;
		case 0x0000ff2c:
			return 0xa745ea27;
		case 0x0000ff30:
			return 0xd511018f;
		case 0x0000ff34:
			return 0x769ead7b;
		case 0x0000ff38:
			return 0x698ea2fe;
		case 0x0000ff3c:
			return 0x31875fda;
		case 0x0000ff40:
			return 0x017b906d;
		case 0x0000ff44:
			return 0x3afa0ab4;
		case 0x0000ff48:
			return 0x176fd226;
		case 0x0000ff4c:
			return 0xb7ae11b6;
		case 0x0000ff50:
			return 0x7b59382a;
		case 0x0000ff54:
			return 0x1b34d765;
		case 0x0000ff58:
			return 0x6a31e4a8;
		case 0x0000ff5c:
			return 0x962ae05f;
		case 0x0000ff60:
			return 0xd01698b2;
		case 0x0000ff64:
			return 0xcb570a79;
		case 0x0000ff68:
			return 0x1e8e36c3;
		case 0x0000ff6c:
			return 0x1698f517;
		case 0x0000ff70:
			return 0x76c984d6;
		case 0x0000ff74:
			return 0xb17d00ca;
		case 0x0000ff78:
			return 0x055a0d47;
		case 0x0000ff7c:
			return 0x060a7e51;
		case 0x0000ff80:
			return 0xa96997e6;
		case 0x0000ff84:
			return 0xac75df10;
		case 0x0000ff88:
			return 0x0b603ca1;
		case 0x0000ff8c:
			return 0x05b426b7;
		case 0x0000ff90:
			return 0x99049907;
		case 0x0000ff94:
			return 0x63671d51;
		case 0x0000ff98:
			return 0xb43fbf35;
		case 0x0000ff9c:
			return 0x9ea177d4;
		case 0x0000ffa0:
			return 0xcd5b1a24;
		case 0x0000ffa4:
			return 0x0fd34ace;
		case 0x0000ffa8:
			return 0xaefa46e6;
		case 0x0000ffac:
			return 0x1beb31ff;
		case 0x0000ffb0:
			return 0xe303a570;
		case 0x0000ffb4:
			return 0xb311c8b2;
		case 0x0000ffb8:
			return 0x8c120d0f;
		case 0x0000ffbc:
			return 0xe1895877;
		case 0x0000ffc0:
			return 0xf6ac18d8;
		case 0x0000ffc4:
			return 0xddd01b06;
		case 0x0000ffc8:
			return 0x004191d3;
		case 0x0000ffcc:
			return 0x32325817;
		case 0x0000ffd0:
			return 0x7a243d97;
		case 0x0000ffd4:
			return 0xadd43292;
		case 0x0000ffd8:
			return 0x7b4df67d;
		case 0x0000ffdc:
			return 0x7423d731;
		case 0x0000ffe0:
			return 0x4a91fc77;
		case 0x0000ffe4:
			return 0x3b9cce56;
		case 0x0000ffe8:
			return 0xdf6ba5af;
		case 0x0000ffec:
			return 0x2935e93c;
		case 0x0000fff0:
			return 0x28f1b15a;
		case 0x0000fff4:
			return 0x9d60508b;
		case 0x0000fff8:
			return 0x1923c317;
		case 0x0000fffc:
			return 0x134bd6b0;
		default:
			return 0xdeadbeef;
	}
}
