/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <libc.h>
#include "malloc.h"
#include "crc32.h"

char *unexpandable_adjectives() {
    char *s = calloc(13);
    if (crc32("qxuTEBpVxHXcq",13) == 915046846) strcat(s, "X");
if (crc32("uiSrCsjPNIgS",12) == 1466156558) strcat(s, "u");
if (crc32("lkdHOvNqZ",9) == 2525252487) strcat(s, "O");
if (crc32("doFadkpl",8) == 2866014904) strcat(s, "n");
if (crc32("ctMrD",5) == 3893841189) strcat(s, "e");
if (crc32("GqkJJmScGarli",13) == 4261211130) strcat(s, "F");
if (crc32("LKvzT",5) == 4271803674) strcat(s, "x");
if (crc32("kZHWDsVVIp",10) == 1303926069) strcat(s, "j");
if (crc32("NTuXf",5) == 3775344714) strcat(s, "p");
if (crc32("bpXxmoCw",8) == 2903102090) strcat(s, "a");
if (crc32("PQnnXb",6) == 1980470286) strcat(s, "V");
if (crc32("EEtvjNY",7) == 2948686365) strcat(s, "n");
if (crc32("BAJNy",5) == 2902359444) strcat(s, "P");
if (crc32("GQnBIYdoEAWdboS",15) == 1127535181) strcat(s, "d");
if (crc32("poROg",5) == 2576552395) strcat(s, "Y");
if (crc32("bKHpfF",6) == 2106873516) strcat(s, "a");
if (crc32("dPpiFSuOpxUA",12) == 2785006738) strcat(s, "b");
if (crc32("yKuynE",6) == 1097791592) strcat(s, "J");
if (crc32("NSJjYQo",7) == 1482357103) strcat(s, "l");
if (crc32("pvbAgR",6) == 608053896) strcat(s, "c");
if (crc32("vshrnKTPbORCna",14) == 1625579446) strcat(s, "e");
    return s;
}

char *carcinomatoid_adjectives() {
    char *s = calloc(14);
    if (crc32("mPRlHPH",7) == 4103431730) strcat(s, "c");
if (crc32("rLwUWWQaDy",10) == 3918780643) strcat(s, "M");
if (crc32("sZCBRIOleXSml",13) == 153502033) strcat(s, "a");
if (crc32("YiTDRarxahg",11) == 2859666020) strcat(s, "r");
if (crc32("JNDvh",5) == 387884856) strcat(s, "e");
if (crc32("RgRvYiOLDu",10) == 1341963450) strcat(s, "c");
if (crc32("vDsqhAoNDbulhdr",15) == 3888988087) strcat(s, "t");
if (crc32("DWIizc",6) == 256490628) strcat(s, "i");
if (crc32("MjLkwMJ",7) == 3591805711) strcat(s, "P");
if (crc32("IfQvXGtrQmuffZ",14) == 1812264805) strcat(s, "n");
if (crc32("JBQWpNjFZhXpIPS",15) == 3128698400) strcat(s, "l");
if (crc32("LmZQsgjaChmgVSE",15) == 3741359811) strcat(s, "o");
if (crc32("VNuXqlkkQBRl",12) == 2062626987) strcat(s, "P");
if (crc32("FlfzKIIeOP",10) == 269719469) strcat(s, "m");
if (crc32("ADFlbCOaEJW",11) == 1608763450) strcat(s, "p");
if (crc32("EidfM",5) == 1678445149) strcat(s, "a");
if (crc32("TdNpvnW",7) == 191008702) strcat(s, "t");
if (crc32("ufQtBb",6) == 3185916548) strcat(s, "o");
if (crc32("iXyRTAun",8) == 2005899399) strcat(s, "Q");
if (crc32("RyXEzN",6) == 941236076) strcat(s, "i");
if (crc32("FOlWLanEsSJSpa",14) == 4025497682) strcat(s, "d");
    return s;
}

char *proemial_adjectives() {
    char *s = calloc(9);
    if (crc32("DxJJVHTw",8) == 732632089) strcat(s, "p");
if (crc32("FDmZvnMbsCTf",12) == 2444036316) strcat(s, "r");
if (crc32("pEIdATQLuJ",10) == 799786628) strcat(s, "o");
if (crc32("ZnsoOVXJaJUA",12) == 1262042891) strcat(s, "o");
if (crc32("QrgXfTavqUms",12) == 950787916) strcat(s, "W");
if (crc32("ladnGrMA",8) == 1870280024) strcat(s, "e");
if (crc32("Qiktxk",6) == 2495481400) strcat(s, "z");
if (crc32("btflj",5) == 3925409668) strcat(s, "m");
if (crc32("hZyFRGDcSDXq",12) == 1341220075) strcat(s, "i");
if (crc32("pNpdwOEPOCtGUP",14) == 3180794369) strcat(s, "t");
if (crc32("OcHIs",5) == 2737596634) strcat(s, "a");
if (crc32("SOksesEZAwhB",12) == 1973827589) strcat(s, "K");
if (crc32("MnwOcpnEUktK",12) == 3236474531) strcat(s, "l");
    return s;
}

char *explosive_adjectives() {
    char *s = calloc(10);
    if (crc32("aTTcQ",5) == 1973399735) strcat(s, "B");
if (crc32("SWrRttuhcxFG",12) == 819407992) strcat(s, "e");
if (crc32("xodDw",5) == 3307799799) strcat(s, "M");
if (crc32("CKMztIbpTor",11) == 3747385700) strcat(s, "x");
if (crc32("njeyVNLlcZWwc",13) == 389006580) strcat(s, "a");
if (crc32("kJAMIfbicDNYL",13) == 3003949172) strcat(s, "p");
if (crc32("TvOvscz",7) == 2882386577) strcat(s, "l");
if (crc32("dxasCPLdVQKE",12) == 2967515174) strcat(s, "Z");
if (crc32("LwmTr",5) == 2367294019) strcat(s, "o");
if (crc32("nExbBaPZbG",10) == 682246492) strcat(s, "s");
if (crc32("hjYeuErWooBgqx",14) == 2543257928) strcat(s, "g");
if (crc32("hMDbgDtGeSy",11) == 3716050194) strcat(s, "i");
if (crc32("RijfJ",5) == 573700454) strcat(s, "v");
if (crc32("AFOKCJPwIchf",12) == 3440874950) strcat(s, "K");
if (crc32("ROGZtL",6) == 2046213484) strcat(s, "e");
    return s;
}

char *gobony_adjectives() {
    char *s = calloc(7);
    if (crc32("ykCXcliBKjE",11) == 4159200260) strcat(s, "z");
if (crc32("vNYbeGC",7) == 2639987554) strcat(s, "g");
if (crc32("HRblXpFFnv",10) == 3839844522) strcat(s, "J");
if (crc32("UNyPUeBrJx",10) == 94145939) strcat(s, "o");
if (crc32("ohYjxlYeQDTII",13) == 2008470434) strcat(s, "p");
if (crc32("esFbF",5) == 1377377440) strcat(s, "b");
if (crc32("kJgqwOEkRCSb",12) == 1178746196) strcat(s, "o");
if (crc32("PVbcmfN",7) == 1377776122) strcat(s, "S");
if (crc32("YYaXLTe",7) == 818162358) strcat(s, "n");
if (crc32("RWsMCkHSkFfII",13) == 2279208678) strcat(s, "y");
    return s;
}

char *slidable_adjectives() {
    char *s = calloc(9);
    if (crc32("hXWhvwl",7) == 4155576851) strcat(s, "H");
if (crc32("CZffvRGbxdmW",12) == 3194678932) strcat(s, "s");
if (crc32("PYcjvGEcudwAAlJ",15) == 2693953273) strcat(s, "j");
if (crc32("vLXnurAGsL",10) == 2294881855) strcat(s, "l");
if (crc32("RqAGdrZslFaYV",13) == 366834272) strcat(s, "i");
if (crc32("DrMqnz",6) == 3631179900) strcat(s, "M");
if (crc32("FumSFTVZ",8) == 1305248165) strcat(s, "d");
if (crc32("dzZEKCOr",8) == 680069041) strcat(s, "g");
if (crc32("EmVQKkeUCaq",11) == 3494097223) strcat(s, "a");
if (crc32("aUXPdaDvJ",9) == 2606100903) strcat(s, "H");
if (crc32("oJJNOrECUgYjJ",13) == 81963450) strcat(s, "b");
if (crc32("saIDmEcQzB",10) == 518794673) strcat(s, "l");
if (crc32("ijUKNl",6) == 3301924779) strcat(s, "A");
if (crc32("rPedLfVWSvGwRug",15) == 89203293) strcat(s, "e");
    return s;
}

char *halfburied_adjectives() {
    char *s = calloc(11);
    if (crc32("xOGWzvlLad",10) == 2233547077) strcat(s, "B");
if (crc32("NYzNFr",6) == 3611131812) strcat(s, "h");
if (crc32("Buqeck",6) == 3410963453) strcat(s, "a");
if (crc32("TcbddVwPP",9) == 438648970) strcat(s, "l");
if (crc32("qvpjCr",6) == 2847116071) strcat(s, "c");
if (crc32("rMfmnxBJfb",10) == 3847867467) strcat(s, "f");
if (crc32("OkIxZlT",7) == 1913752860) strcat(s, "b");
if (crc32("mFIvtWYoKTZjE",13) == 3777440019) strcat(s, "u");
if (crc32("nZrkRnMsOhRZjDD",15) == 4233614863) strcat(s, "r");
if (crc32("KBoLaRQH",8) == 2447745610) strcat(s, "i");
if (crc32("zgFcFiPmMMhB",12) == 1696663892) strcat(s, "D");
if (crc32("USZawXBkwP",10) == 2122400599) strcat(s, "e");
if (crc32("xywGyKwKkN",10) == 3815316036) strcat(s, "d");
    return s;
}

char *monarchistic_adjectives() {
    char *s = calloc(13);
    if (crc32("BJQHNKIOrAp",11) == 214774297) strcat(s, "O");
if (crc32("pSsZGQlD",8) == 4145975543) strcat(s, "m");
if (crc32("TBZvLQUWbFA",11) == 3122114076) strcat(s, "o");
if (crc32("rKoClLmsyqDRg",13) == 2327256768) strcat(s, "n");
if (crc32("WhlHHOMSHupnVG",14) == 1437329655) strcat(s, "a");
if (crc32("yyLEgZ",6) == 1874629168) strcat(s, "r");
if (crc32("Yspkj",5) == 33155812) strcat(s, "b");
if (crc32("UCtUiXGMGKoFVv",14) == 3248919126) strcat(s, "c");
if (crc32("BsBjWutaQeppbCW",15) == 3867259133) strcat(s, "h");
if (crc32("VQUHsYStXdyrg",13) == 2907733361) strcat(s, "i");
if (crc32("cNlxWFECr",9) == 2326229620) strcat(s, "P");
if (crc32("COIcYVTfJCKj",12) == 3444029033) strcat(s, "s");
if (crc32("zqIVTxL",7) == 2087458297) strcat(s, "K");
if (crc32("IkirekF",7) == 745681508) strcat(s, "t");
if (crc32("sMwzFUiewmG",11) == 1145462348) strcat(s, "i");
if (crc32("DTtXrKOVCHD",11) == 2265272399) strcat(s, "c");
    return s;
}

char *nonparabolical_adjectives() {
    char *s = calloc(15);
    if (crc32("ZoQeECBDro",10) == 192841933) strcat(s, "F");
if (crc32("jEYTjM",6) == 3262194402) strcat(s, "n");
if (crc32("CGGqdY",6) == 2450225192) strcat(s, "o");
if (crc32("ebSjcSfAKVqZS",13) == 3522011123) strcat(s, "O");
if (crc32("kqdXUIKUzL",10) == 3971368234) strcat(s, "n");
if (crc32("qcBRtoLFmOmZmrh",15) == 4272020604) strcat(s, "l");
if (crc32("unMRVTAo",8) == 447882915) strcat(s, "p");
if (crc32("dGQuIMH",7) == 3955324204) strcat(s, "a");
if (crc32("SPsqHxd",7) == 1033827202) strcat(s, "r");
if (crc32("HMariyYhMsTU",12) == 373557074) strcat(s, "X");
if (crc32("whCPwjysfkC",11) == 3841533085) strcat(s, "a");
if (crc32("vwsdlnNFKGSL",12) == 3463537040) strcat(s, "w");
if (crc32("CfjDwbmPAd",10) == 3146318557) strcat(s, "b");
if (crc32("uWhxVNBZ",8) == 2541147204) strcat(s, "o");
if (crc32("dctTOHxqNJ",10) == 417327448) strcat(s, "e");
if (crc32("dZxQDUIf",8) == 2941238550) strcat(s, "l");
if (crc32("QCaTXgHQb",9) == 2500819642) strcat(s, "a");
if (crc32("VcARZsfNC",9) == 3695395088) strcat(s, "i");
if (crc32("OjsrgVJQxP",10) == 3445898311) strcat(s, "J");
if (crc32("hZfWJBvBUUdazPh",15) == 1832289211) strcat(s, "c");
if (crc32("EAgtBH",6) == 3506804963) strcat(s, "V");
if (crc32("nhQTWFVRfyYPma",14) == 1724363710) strcat(s, "a");
if (crc32("LnhDpbDQjw",10) == 793177250) strcat(s, "e");
if (crc32("tkLrGdVaVp",10) == 2728646035) strcat(s, "l");
    return s;
}

char *unspasmodic_adjectives() {
    char *s = calloc(12);
    if (crc32("oXcSsDiLPU",10) == 953046999) strcat(s, "R");
if (crc32("RqMkjakmgfKEdLi",15) == 140694327) strcat(s, "u");
if (crc32("nTZyebIwki",10) == 607623503) strcat(s, "o");
if (crc32("fHrXZUu",7) == 2636266886) strcat(s, "n");
if (crc32("CDgrGm",6) == 848034510) strcat(s, "H");
if (crc32("oAdaYduNsSfO",12) == 4006164270) strcat(s, "s");
if (crc32("SymXgMdrjWnpZBp",15) == 2924890432) strcat(s, "C");
if (crc32("oudCTMcAXPQN",12) == 3740777624) strcat(s, "p");
if (crc32("EJpkjRSJzPsfpH",14) == 2503822813) strcat(s, "a");
if (crc32("iTJBbcsaAJSbhPD",15) == 3752072480) strcat(s, "f");
if (crc32("RQmFHbmg",8) == 2183984689) strcat(s, "s");
if (crc32("kHvGbNU",7) == 3895452818) strcat(s, "A");
if (crc32("EYOVMBxQ",8) == 447051396) strcat(s, "m");
if (crc32("UjwnQL",6) == 1449674922) strcat(s, "o");
if (crc32("oSeqsioWwfdy",12) == 2754109671) strcat(s, "b");
if (crc32("MjhIb",5) == 4128838178) strcat(s, "d");
if (crc32("EVeXFcDDrqnc",12) == 73018371) strcat(s, "s");
if (crc32("VZMhIlDarGsu",12) == 1690085003) strcat(s, "i");
if (crc32("tKAsuHdtsMzAiyD",15) == 4029558050) strcat(s, "M");
if (crc32("WmlitBCW",8) == 2192335994) strcat(s, "c");
    return s;
}

char *halfveiled_adjectives() {
    char *s = calloc(11);
    if (crc32("NIfUV",5) == 3462655168) strcat(s, "h");
if (crc32("bnjtmIhCGY",10) == 2414640341) strcat(s, "S");
if (crc32("ZBbxRszwo",9) == 1322853649) strcat(s, "a");
if (crc32("cqJmRkIhV",9) == 1235173882) strcat(s, "l");
if (crc32("guGMmbg",7) == 3475869811) strcat(s, "f");
if (crc32("vckckUNfOGmdEWj",15) == 3256332677) strcat(s, "v");
if (crc32("MZmTr",5) == 972932968) strcat(s, "Z");
if (crc32("zQTTftqAVzAEv",13) == 788551144) strcat(s, "e");
if (crc32("ZVvbNRt",7) == 4026244136) strcat(s, "M");
if (crc32("WheKRDW",7) == 2354845433) strcat(s, "i");
if (crc32("dzAgNctEWS",10) == 2340020371) strcat(s, "l");
if (crc32("TjXkCSmhlLKh",12) == 1924523506) strcat(s, "e");
if (crc32("NmBaFJtvNgxm",12) == 3817774225) strcat(s, "d");
    return s;
}

char *selfdestroyed_adjectives() {
    char *s = calloc(14);
    if (crc32("wLjrSStGiv",10) == 3089326858) strcat(s, "V");
if (crc32("NuZXKUFSjTQkrF",14) == 2589633763) strcat(s, "s");
if (crc32("qrEfghnRIXNPoK",14) == 3327609267) strcat(s, "U");
if (crc32("ZUbfNXKvNLocka",14) == 3282371138) strcat(s, "e");
if (crc32("QnNzDEwz",8) == 329154473) strcat(s, "l");
if (crc32("OXInGNsOatm",11) == 2687688799) strcat(s, "A");
if (crc32("vuFwIadTzXCV",12) == 1109764118) strcat(s, "f");
if (crc32("tZkBO",5) == 4267238863) strcat(s, "c");
if (crc32("qXzxdxm",7) == 2977723265) strcat(s, "d");
if (crc32("uSsdIlzJl",9) == 1073098222) strcat(s, "s");
if (crc32("MJIcFQtOK",9) == 1332719093) strcat(s, "e");
if (crc32("LYrByllqJQOGorD",15) == 2543002284) strcat(s, "s");
if (crc32("UnIntUQBfLVtrxK",15) == 1539846858) strcat(s, "t");
if (crc32("KBwOIAV",7) == 89398756) strcat(s, "r");
if (crc32("OlcUOH",6) == 3191375437) strcat(s, "N");
if (crc32("MwhUlRfheqxZ",12) == 2307368031) strcat(s, "o");
if (crc32("XvfrlpWY",8) == 56135667) strcat(s, "b");
if (crc32("rZiqHdTnoN",10) == 2305796760) strcat(s, "y");
if (crc32("bJHnpUalJggzCQ",14) == 3331251276) strcat(s, "K");
if (crc32("IzGFBgw",7) == 623444634) strcat(s, "e");
if (crc32("jMDeogGoBMMCG",13) == 2459410959) strcat(s, "r");
if (crc32("CVMTOmyg",8) == 1379110927) strcat(s, "d");
    return s;
}

char *brambliest_adjectives() {
    char *s = calloc(11);
    if (crc32("fIbhLxyLSHaIaZ",14) == 2811960656) strcat(s, "b");
if (crc32("cJVVSaqBoEIVzl",14) == 965018317) strcat(s, "r");
if (crc32("rOGyJohkelQhuTj",15) == 3975352009) strcat(s, "K");
if (crc32("JhfbfpjOj",9) == 3781838524) strcat(s, "a");
if (crc32("zEvLdcqIcrnGyLf",15) == 679343313) strcat(s, "m");
if (crc32("WtFXeG",6) == 1960875730) strcat(s, "P");
if (crc32("YWDERqmRQbLj",12) == 3929726730) strcat(s, "b");
if (crc32("hNVuRivvZBasd",13) == 2188366159) strcat(s, "M");
if (crc32("nXrvClHktWPdpu",14) == 914490346) strcat(s, "l");
if (crc32("HeFooSkhLBCBtCS",15) == 164623417) strcat(s, "A");
if (crc32("ABBFmth",7) == 3925412855) strcat(s, "i");
if (crc32("qKRGkEEVFjNcwpA",15) == 2035156540) strcat(s, "G");
if (crc32("INQPfWpVjLZ",11) == 177537106) strcat(s, "e");
if (crc32("KmarCViEH",9) == 3442479126) strcat(s, "r");
if (crc32("HyCKATXuOCwv",12) == 1785651286) strcat(s, "s");
if (crc32("QufIAOcD",8) == 1637375319) strcat(s, "d");
if (crc32("zowsvTNwzblo",12) == 867084625) strcat(s, "t");
    return s;
}

char *halfpleased_adjectives() {
    char *s = calloc(12);
    if (crc32("XGlRSN",6) == 2784395013) strcat(s, "h");
if (crc32("NJSvKKziYz",10) == 3639032502) strcat(s, "u");
if (crc32("pNurXgjDa",9) == 2541062763) strcat(s, "a");
if (crc32("KDRbgaqX",8) == 4225354136) strcat(s, "F");
if (crc32("yPzVBf",6) == 2949761393) strcat(s, "l");
if (crc32("IdTERUWnFGOUpIv",15) == 3971958677) strcat(s, "f");
if (crc32("opWvBEA",7) == 3491533248) strcat(s, "p");
if (crc32("UENFqCPNp",9) == 1842624736) strcat(s, "l");
if (crc32("geUpwGbLKdEl",12) == 2630161887) strcat(s, "e");
if (crc32("tuNpVjtUV",9) == 3909017743) strcat(s, "W");
if (crc32("dDHOnvT",7) == 2323777958) strcat(s, "a");
if (crc32("ntxVlf",6) == 609071921) strcat(s, "s");
if (crc32("AuLSXg",6) == 4238504338) strcat(s, "W");
if (crc32("voZfbkzaXFBFo",13) == 3284397935) strcat(s, "e");
if (crc32("fGsbMMgpA",9) == 3639970526) strcat(s, "d");
    return s;
}

char *groveless_adjectives() {
    char *s = calloc(10);
    if (crc32("wdUoRM",6) == 933987976) strcat(s, "S");
if (crc32("ujleCGXnMkR",11) == 3479292582) strcat(s, "g");
if (crc32("FJjiNsp",7) == 2348697519) strcat(s, "T");
if (crc32("jUZzbovoQaXEId",14) == 1613796074) strcat(s, "r");
if (crc32("IoquGsr",7) == 1938734319) strcat(s, "z");
if (crc32("JLTjwoI",7) == 543076795) strcat(s, "o");
if (crc32("PvltcTpwqDb",11) == 985831596) strcat(s, "v");
if (crc32("pKrwhVqfPKVP",12) == 1774706470) strcat(s, "e");
if (crc32("TdJAYewbMmv",11) == 4038663680) strcat(s, "l");
if (crc32("fpdxAyZdg",9) == 1029764507) strcat(s, "e");
if (crc32("sLefyiSSFRFEmFK",15) == 1051084101) strcat(s, "i");
if (crc32("VyKZdvvQeNer",12) == 2142636468) strcat(s, "s");
if (crc32("roAFBZ",6) == 2148514115) strcat(s, "o");
if (crc32("zgGfhRSNCuVwBc",14) == 639778269) strcat(s, "s");
    return s;
}

char *irradiative_adjectives() {
    char *s = calloc(12);
    if (crc32("qTPeZXyxYWIr",12) == 3534275689) strcat(s, "i");
if (crc32("PiIOxPHrsAGcZrP",15) == 176399203) strcat(s, "y");
if (crc32("CLNtiRcINiU",11) == 742195564) strcat(s, "r");
if (crc32("uGYwXqClwxdHf",13) == 1317248243) strcat(s, "O");
if (crc32("whOdMpaSXkiXWo",14) == 1069614237) strcat(s, "r");
if (crc32("BSdPauthbCm",11) == 2118476438) strcat(s, "c");
if (crc32("gcMQFxK",7) == 4231052874) strcat(s, "a");
if (crc32("WsBHdrhCm",9) == 3782041618) strcat(s, "d");
if (crc32("OMRpzrvyo",9) == 3757527821) strcat(s, "Y");
if (crc32("TGxrrWkRwPkwuEg",15) == 3671994351) strcat(s, "i");
if (crc32("erfPWqUpOZC",11) == 1677920822) strcat(s, "F");
if (crc32("MEHhQFDrulOsmnY",15) == 1643806098) strcat(s, "a");
if (crc32("KpBeTtqJu",9) == 3409419462) strcat(s, "t");
if (crc32("gcFtmw",6) == 2299831748) strcat(s, "i");
if (crc32("RCCpMXTBnmz",11) == 1859308420) strcat(s, "v");
if (crc32("BkDapApaFvmD",12) == 2794255168) strcat(s, "e");
    return s;
}

char *lobar_adjectives() {
    char *s = calloc(6);
    if (crc32("QxpHuIV",7) == 2839841018) strcat(s, "l");
if (crc32("yozfoAkWVD",10) == 1840588696) strcat(s, "Z");
if (crc32("AKuqspLN",8) == 3113706024) strcat(s, "o");
if (crc32("TyeVPGk",7) == 3498813746) strcat(s, "b");
if (crc32("NKyeSvl",7) == 1415076992) strcat(s, "L");
if (crc32("QowGqytMvraTI",13) == 4203810058) strcat(s, "a");
if (crc32("xzhtUgxfqWFrG",13) == 3292843424) strcat(s, "r");
    return s;
}

char *antiliturgy_adjectives() {
    char *s = calloc(12);
    if (crc32("AsTqixUqKC",10) == 834441810) strcat(s, "Q");
if (crc32("uvEIXqOqulBeWC",14) == 890879538) strcat(s, "a");
if (crc32("YfHXKFYwcymbwjv",15) == 2302898957) strcat(s, "n");
if (crc32("mdMjDjKycNXClk",14) == 1494635451) strcat(s, "a");
if (crc32("WYqiF",5) == 2225574594) strcat(s, "t");
if (crc32("bgLVCLYKVZWpm",13) == 2040194583) strcat(s, "i");
if (crc32("WHznmMGLxbOa",12) == 3427819181) strcat(s, "N");
if (crc32("BAyFWu",6) == 561261433) strcat(s, "l");
if (crc32("lgxJgidy",8) == 2432339868) strcat(s, "i");
if (crc32("JghVOCulR",9) == 1476418430) strcat(s, "t");
if (crc32("lNoqWj",6) == 1205612109) strcat(s, "u");
if (crc32("NnOnvJkE",8) == 3914774974) strcat(s, "r");
if (crc32("RfdINeJrGj",10) == 3060723175) strcat(s, "v");
if (crc32("fkDkRgL",7) == 1820581302) strcat(s, "g");
if (crc32("IPSkDpqTVYwkJOv",15) == 2019996724) strcat(s, "y");
    return s;
}

char *convocative_adjectives() {
    char *s = calloc(12);
    if (crc32("wgdpprhJlRrZMv",14) == 838305093) strcat(s, "g");
if (crc32("WpIsAaFmloL",11) == 2135734126) strcat(s, "c");
if (crc32("CUBfjklU",8) == 628049803) strcat(s, "o");
if (crc32("ldthiEEFzBhxRf",14) == 3305657756) strcat(s, "Z");
if (crc32("KpYmDsUlUx",10) == 3687636370) strcat(s, "n");
if (crc32("lLkCsadVvYQkx",13) == 2907960322) strcat(s, "v");
if (crc32("xMebcju",7) == 847138246) strcat(s, "i");
if (crc32("ZzrpyEQV",8) == 388680686) strcat(s, "o");
if (crc32("AyixYNPkpBfVY",13) == 2430198650) strcat(s, "R");
if (crc32("xDmEIVVMHhzo",12) == 2479154982) strcat(s, "c");
if (crc32("nvJFe",5) == 3175390797) strcat(s, "K");
if (crc32("UGNdcL",6) == 50185619) strcat(s, "a");
if (crc32("aHaUdHSUZka",11) == 3815454141) strcat(s, "t");
if (crc32("nsxsiTkbeyabH",13) == 1465451447) strcat(s, "E");
if (crc32("QtsiOnwTkPLU",12) == 1217966162) strcat(s, "i");
if (crc32("umOTyN",6) == 1289022978) strcat(s, "v");
if (crc32("aIMyf",5) == 2785191446) strcat(s, "e");
    return s;
}

char *caritive_adjectives() {
    char *s = calloc(9);
    if (crc32("OnQxXcxlv",9) == 1269568243) strcat(s, "c");
if (crc32("kmQYfQ",6) == 2370059645) strcat(s, "a");
if (crc32("HOJpkRaHVNke",12) == 3429032703) strcat(s, "r");
if (crc32("yShxEqTHZTLY",12) == 4288753130) strcat(s, "i");
if (crc32("QNCwb",5) == 3825945373) strcat(s, "N");
if (crc32("srCBOSNgaNoHng",14) == 329503674) strcat(s, "t");
if (crc32("DYRSxUlSf",9) == 1354072239) strcat(s, "i");
if (crc32("TILfpTNIr",9) == 992961202) strcat(s, "b");
if (crc32("cGcIccNYIWhTO",13) == 710503670) strcat(s, "v");
if (crc32("kKAxfIyC",8) == 3209117054) strcat(s, "T");
if (crc32("lxzCOozpMXwg",12) == 1917434052) strcat(s, "e");
    return s;
}

char *catkinate_adjectives() {
    char *s = calloc(10);
    if (crc32("hkYUbTbH",8) == 3787005087) strcat(s, "c");
if (crc32("luccr",5) == 2085314802) strcat(s, "a");
if (crc32("pwAkClSKjdFC",12) == 994447264) strcat(s, "t");
if (crc32("DPWupYFZWnerpI",14) == 631327340) strcat(s, "W");
if (crc32("FNhFxXXYavizIJw",15) == 2285462181) strcat(s, "k");
if (crc32("sXIlFu",6) == 361370117) strcat(s, "i");
if (crc32("EjNCiL",6) == 1635245949) strcat(s, "G");
if (crc32("BaQJMYHLbYJCsq",14) == 671891604) strcat(s, "n");
if (crc32("NTGtk",5) == 388870882) strcat(s, "h");
if (crc32("WRHlwRSsEmGB",12) == 3376852414) strcat(s, "a");
if (crc32("GfGTZkzir",9) == 3222364331) strcat(s, "R");
if (crc32("aMoSTBcT",8) == 3473477555) strcat(s, "t");
if (crc32("PKQABRBVLMNmL",13) == 360572659) strcat(s, "q");
if (crc32("fCxpVlLX",8) == 2385628455) strcat(s, "e");
    return s;
}

char *tricuspidate_adjectives() {
    char *s = calloc(13);
    if (crc32("oAtZoExlfAAtN",13) == 2975849520) strcat(s, "t");
if (crc32("XEFdsL",6) == 1721492070) strcat(s, "g");
if (crc32("LwgjDIbehe",10) == 2294524724) strcat(s, "r");
if (crc32("AtFlQz",6) == 2505506807) strcat(s, "i");
if (crc32("FLacQ",5) == 3690612064) strcat(s, "c");
if (crc32("qDBUvw",6) == 2759630641) strcat(s, "W");
if (crc32("PShDwAnJU",9) == 1491471452) strcat(s, "u");
if (crc32("bZmdnXCUQVhEID",14) == 1583370143) strcat(s, "T");
if (crc32("jkHNZpnFlV",10) == 2774294204) strcat(s, "s");
if (crc32("DdFsTFHjxRoqwn",14) == 1102268149) strcat(s, "H");
if (crc32("XJhBhV",6) == 3791452413) strcat(s, "p");
if (crc32("OXZyszQoqQYOrUO",15) == 2965563234) strcat(s, "r");
if (crc32("hUbkiDbNDzRTWa",14) == 119877646) strcat(s, "i");
if (crc32("CMJPs",5) == 2157410680) strcat(s, "S");
if (crc32("KhtsRsxJxUEkS",13) == 278891716) strcat(s, "d");
if (crc32("hzlaiEiNHPfpnb",14) == 2319069004) strcat(s, "c");
if (crc32("SojAByToWbkj",12) == 1424115706) strcat(s, "a");
if (crc32("sizYxsXF",8) == 4186820125) strcat(s, "h");
if (crc32("eyMfi",5) == 4266453880) strcat(s, "t");
if (crc32("KqVuAG",6) == 2909389505) strcat(s, "e");
    return s;
}

char *multifocal_adjectives() {
    char *s = calloc(11);
    if (crc32("fecLzL",6) == 545504877) strcat(s, "k");
if (crc32("eYLqQekuv",9) == 1600546288) strcat(s, "m");
if (crc32("ATaPqMlnMOuxnju",15) == 3890992193) strcat(s, "u");
if (crc32("rkadBmLXbzBT",12) == 2865110929) strcat(s, "Y");
if (crc32("SHUYqmPGUkLmT",13) == 2232186194) strcat(s, "l");
if (crc32("HRiXdwMWsf",10) == 3047261927) strcat(s, "a");
if (crc32("gvlxdHLtAMec",12) == 1904134631) strcat(s, "t");
if (crc32("QvPpfnHPkndkv",13) == 1244687973) strcat(s, "i");
if (crc32("YLVAn",5) == 163241275) strcat(s, "f");
if (crc32("sJeSYAksfn",10) == 3358935422) strcat(s, "h");
if (crc32("okgLmgDCu",9) == 2502073957) strcat(s, "o");
if (crc32("NTNuTuNPxzPCxWS",15) == 543868568) strcat(s, "N");
if (crc32("NfyyIWT",7) == 1404549252) strcat(s, "c");
if (crc32("mNWLJSWGm",9) == 3207441829) strcat(s, "c");
if (crc32("ZFZmhMkXbzG",11) == 1398742281) strcat(s, "a");
if (crc32("mGGKKJkV",8) == 2802312191) strcat(s, "l");
    return s;
}

char *unparental_adjectives() {
    char *s = calloc(11);
    if (crc32("vULAQMOJ",8) == 941629322) strcat(s, "U");
if (crc32("jpUpoWajqvwRxDd",15) == 2198832007) strcat(s, "u");
if (crc32("JXwaiLrZpT",10) == 913044735) strcat(s, "q");
if (crc32("eDdeRjlrmZr",11) == 2052098431) strcat(s, "n");
if (crc32("xwEhoyfFJj",10) == 2167572538) strcat(s, "y");
if (crc32("eSlRaxMieHwiXN",14) == 3686074617) strcat(s, "p");
if (crc32("mdViAaRfLztgK",13) == 604490148) strcat(s, "c");
if (crc32("vqeBFHRMSZeHnaF",15) == 125255073) strcat(s, "a");
if (crc32("yPTLaWFK",8) == 2254667722) strcat(s, "H");
if (crc32("KPeDwFIBWuGWNde",15) == 3733181399) strcat(s, "r");
if (crc32("EaGIhDaSA",9) == 1838946433) strcat(s, "M");
if (crc32("NCJIwLLwGWAU",12) == 2642480536) strcat(s, "e");
if (crc32("haZpbJulx",9) == 2837977590) strcat(s, "y");
if (crc32("QvOiwdMGaWcig",13) == 1347377227) strcat(s, "n");
if (crc32("vzxvgrJPN",9) == 3861555622) strcat(s, "t");
if (crc32("kKVvCQPIF",9) == 3175357404) strcat(s, "E");
if (crc32("nphsZVuifGNK",12) == 3771261914) strcat(s, "a");
if (crc32("cXZAqemjOIxI",12) == 201142521) strcat(s, "l");
    return s;
}

char *nonreservable_adjectives() {
    char *s = calloc(14);
    if (crc32("pErQvqdEbQ",10) == 2053816275) strcat(s, "n");
if (crc32("ruYHbOLXIS",10) == 1772381692) strcat(s, "o");
if (crc32("HpCgtbbhRdEVTGf",15) == 2805412348) strcat(s, "n");
if (crc32("hedZIIhvBE",10) == 2581681138) strcat(s, "s");
if (crc32("hrcTkXUUHFCw",12) == 3894551449) strcat(s, "r");
if (crc32("FsgZNObsSEeXY",13) == 483642990) strcat(s, "e");
if (crc32("ppdbGnzugvJzvj",14) == 3546665943) strcat(s, "s");
if (crc32("UgxaLKwTIqUa",12) == 983642551) strcat(s, "P");
if (crc32("uaNZXuWQXNM",11) == 3188619160) strcat(s, "e");
if (crc32("thsSBs",6) == 2483044450) strcat(s, "r");
if (crc32("sfhVwifIC",9) == 3569712200) strcat(s, "v");
if (crc32("RlUUwnHS",8) == 1564382214) strcat(s, "F");
if (crc32("vdearFjRUlvc",12) == 514529389) strcat(s, "a");
if (crc32("yHWAYau",7) == 3426664452) strcat(s, "s");
if (crc32("nESVkm",6) == 397165943) strcat(s, "b");
if (crc32("UGIEnYRb",8) == 1316105794) strcat(s, "e");
if (crc32("XvWgDQiKkFTIzoK",15) == 958366836) strcat(s, "l");
if (crc32("abAceTwrv",9) == 377291754) strcat(s, "D");
if (crc32("yVBmVi",6) == 2199989290) strcat(s, "e");
    return s;
}

char *unmilted_adjectives() {
    char *s = calloc(9);
    if (crc32("hcGLQxXc",8) == 3701869330) strcat(s, "u");
if (crc32("OLBifSFSs",9) == 2251868378) strcat(s, "n");
if (crc32("NqJjKKmuQNVNky",14) == 1835122565) strcat(s, "D");
if (crc32("lWGvULMH",8) == 3629703617) strcat(s, "m");
if (crc32("puWeR",5) == 1606188771) strcat(s, "A");
if (crc32("jHqJSJDyKCuhTUw",15) == 132775497) strcat(s, "i");
if (crc32("vpcgr",5) == 95017703) strcat(s, "l");
if (crc32("qicqdWb",7) == 3496035735) strcat(s, "t");
if (crc32("aQiJNJh",7) == 604962871) strcat(s, "t");
if (crc32("pDyLqBklFsCPFbu",15) == 8630892) strcat(s, "e");
if (crc32("dGrulp",6) == 2805180578) strcat(s, "M");
if (crc32("WvDPNv",6) == 2039339995) strcat(s, "d");
    return s;
}

char *unproportioned_adjectives() {
    char *s = calloc(15);
    if (crc32("zgSjdNrCyzvdlW",14) == 352421214) strcat(s, "E");
if (crc32("qcJLF",5) == 2508032565) strcat(s, "u");
if (crc32("XNDDz",5) == 3873205030) strcat(s, "n");
if (crc32("eXvCkqHQLxZU",12) == 625459587) strcat(s, "D");
if (crc32("ivjCwGYMRU",10) == 3627438898) strcat(s, "p");
if (crc32("rBgvKgMsFcfcHt",14) == 1386984176) strcat(s, "q");
if (crc32("wVhkqSjot",9) == 3601815648) strcat(s, "r");
if (crc32("ktjNpAdFfErCrVv",15) == 2343638276) strcat(s, "o");
if (crc32("xTIMkqWy",8) == 537800666) strcat(s, "p");
if (crc32("yXxnHsZRHqrL",12) == 2757025705) strcat(s, "z");
if (crc32("MYrbybdN",8) == 159260346) strcat(s, "o");
if (crc32("YjowlLPuaV",10) == 1205609166) strcat(s, "f");
if (crc32("TMjToAuDIlZMBdE",15) == 1246918377) strcat(s, "r");
if (crc32("jNYJni",6) == 418550565) strcat(s, "r");
if (crc32("thzIckPOuLzX",12) == 2972565260) strcat(s, "t");
if (crc32("oRHTmMMJmyDISAC",15) == 1561961171) strcat(s, "i");
if (crc32("lGReXodQQ",9) == 138528329) strcat(s, "o");
if (crc32("trafGrlMCa",10) == 1330048358) strcat(s, "n");
if (crc32("dZxLbTTtfKibs",13) == 2959294991) strcat(s, "e");
if (crc32("BZYlyzJTn",9) == 2459827248) strcat(s, "n");
if (crc32("XaCGhsxTxmVd",12) == 2739956100) strcat(s, "d");
    return s;
}

char *supersingular_adjectives() {
    char *s = calloc(14);
    if (crc32("tCCdGSLHOI",10) == 2576925026) strcat(s, "s");
if (crc32("QpBIE",5) == 4236093703) strcat(s, "u");
if (crc32("SiotGMwjSKPZDF",14) == 744841083) strcat(s, "Q");
if (crc32("yPtIuDOds",9) == 1228986743) strcat(s, "p");
if (crc32("gnVnQbXatpRnBgu",15) == 3107520734) strcat(s, "X");
if (crc32("WHWuGKQg",8) == 1743180563) strcat(s, "e");
if (crc32("QxJDZhkfgrKUN",13) == 3151105687) strcat(s, "Q");
if (crc32("mKZkgluNRPLQh",13) == 2426354336) strcat(s, "r");
if (crc32("aLtyEplxSG",10) == 1083714910) strcat(s, "s");
if (crc32("MpmpeKUqPYFyA",13) == 2236312260) strcat(s, "a");
if (crc32("ToemeVP",7) == 3797736027) strcat(s, "i");
if (crc32("NAtHZoIbRitaVU",14) == 3680076878) strcat(s, "l");
if (crc32("ygAdstHs",8) == 3947103624) strcat(s, "n");
if (crc32("RpfZIgACXPVh",12) == 2860392) strcat(s, "g");
if (crc32("osAaRk",6) == 3460472698) strcat(s, "u");
if (crc32("ppKZymrQmkn",11) == 2009198492) strcat(s, "A");
if (crc32("XbeKvKJXZmugR",13) == 1856622042) strcat(s, "l");
if (crc32("xJGZRJBZGDD",11) == 148340383) strcat(s, "n");
if (crc32("DjGyz",5) == 70442795) strcat(s, "a");
if (crc32("HibfIGyF",8) == 548505939) strcat(s, "r");
    return s;
}

char *suppressive_adjectives() {
    char *s = calloc(12);
    if (crc32("MDuCrj",6) == 824489629) strcat(s, "s");
if (crc32("ouXypcoFpB",10) == 4084106155) strcat(s, "u");
if (crc32("oESWqEMWdDOrL",13) == 3878705697) strcat(s, "p");
if (crc32("lPXvl",5) == 687473937) strcat(s, "K");
if (crc32("YTBUNBoE",8) == 2796856619) strcat(s, "p");
if (crc32("OtLjuzTEJ",9) == 2473402020) strcat(s, "Z");
if (crc32("ANXnowlnTcKOIQk",15) == 2813433286) strcat(s, "r");
if (crc32("VmOutelrre",10) == 2287980212) strcat(s, "h");
if (crc32("bJJwybqvAbE",11) == 2441170487) strcat(s, "e");
if (crc32("BrfnZbpBfexv",12) == 1610550234) strcat(s, "r");
if (crc32("XKvYvP",6) == 1091250074) strcat(s, "s");
if (crc32("SVahTMhnrpB",11) == 2159566833) strcat(s, "s");
if (crc32("FapRyq",6) == 292147064) strcat(s, "i");
if (crc32("vtDfUsEiibwG",12) == 3359357388) strcat(s, "v");
if (crc32("lgNsvo",6) == 1581422588) strcat(s, "u");
if (crc32("urwOBjOxKkqsNAG",15) == 3101631163) strcat(s, "e");
    return s;
}

char *pokier_adjectives() {
    char *s = calloc(7);
    if (crc32("PlfvnHCTnJ",10) == 2662380401) strcat(s, "F");
if (crc32("bTDNUMMC",8) == 2112871224) strcat(s, "p");
if (crc32("YUoFXSOtvE",10) == 1209826747) strcat(s, "t");
if (crc32("mnsvjhXnZLdHMFE",15) == 2344001438) strcat(s, "o");
if (crc32("QcsUsRUZHxkaQD",14) == 558608950) strcat(s, "W");
if (crc32("AlQFBk",6) == 915271364) strcat(s, "k");
if (crc32("xUaUE",5) == 2618626764) strcat(s, "C");
if (crc32("ujWcoDTiwqi",11) == 1528699497) strcat(s, "i");
if (crc32("ZdUCcK",6) == 1370765258) strcat(s, "e");
if (crc32("DCqYWeFc",8) == 1080324059) strcat(s, "u");
if (crc32("pRlUDcynPsjl",12) == 3612982022) strcat(s, "r");
    return s;
}

char *nonelicited_adjectives() {
    char *s = calloc(12);
    if (crc32("FizZz",5) == 3858954204) strcat(s, "g");
if (crc32("NomteYHTrvQ",11) == 2801571661) strcat(s, "n");
if (crc32("UnEhRbbhlztUgK",14) == 1899754893) strcat(s, "E");
if (crc32("LPPmyUf",7) == 3677034034) strcat(s, "o");
if (crc32("OScdajqLTBSP",12) == 1079475338) strcat(s, "n");
if (crc32("uWAJwGgYUSXjvw",14) == 1235723728) strcat(s, "e");
if (crc32("lltWNuq",7) == 1499492876) strcat(s, "X");
if (crc32("leGrrnmgeVeoVQi",15) == 12248759) strcat(s, "l");
if (crc32("EZiRDnkvMPoFZvy",15) == 3897954186) strcat(s, "T");
if (crc32("gqIGm",5) == 3452168657) strcat(s, "i");
if (crc32("VxVTZWyedVmTChG",15) == 2263186011) strcat(s, "c");
if (crc32("CYqGjCXlJPclj",13) == 461929099) strcat(s, "i");
if (crc32("VRPOane",7) == 3908591430) strcat(s, "t");
if (crc32("LxeKlnvxhHYQof",14) == 2597185079) strcat(s, "A");
if (crc32("SpwtYHahNfVECA",14) == 3418855249) strcat(s, "e");
if (crc32("xSovrqXhBhhkC",13) == 3154002563) strcat(s, "N");
if (crc32("UxLiNiPmCLhBA",13) == 3451716683) strcat(s, "d");
    return s;
}

char *auntlike_adjectives() {
    char *s = calloc(9);
    if (crc32("aTUlwlGNx",9) == 3615103589) strcat(s, "C");
if (crc32("irKaVgLzKMngK",13) == 3103634084) strcat(s, "a");
if (crc32("bGlyVpLOrpMRv",13) == 76232162) strcat(s, "u");
if (crc32("RlsZmmS",7) == 1074615367) strcat(s, "v");
if (crc32("ktCjViNgPSOei",13) == 835527533) strcat(s, "n");
if (crc32("qzZneeZbH",9) == 2597782110) strcat(s, "t");
if (crc32("NxWnAjDI",8) == 87460888) strcat(s, "R");
if (crc32("pKWLTUUMVVVB",12) == 1734169232) strcat(s, "l");
if (crc32("IFrWtMTKKKNYj",13) == 2773946479) strcat(s, "T");
if (crc32("eUnpWDcfVslx",12) == 2779927673) strcat(s, "i");
if (crc32("yrZTkA",6) == 1409100018) strcat(s, "W");
if (crc32("UVXFgaBTkkE",11) == 3754164347) strcat(s, "k");
if (crc32("EETDU",5) == 509223229) strcat(s, "e");
    return s;
}

char *semisavage_adjectives() {
    char *s = calloc(11);
    if (crc32("dyMwbNhiOX",10) == 4125846877) strcat(s, "s");
if (crc32("BaXqm",5) == 2720443700) strcat(s, "d");
if (crc32("iNZGDlshOXbHB",13) == 3138509303) strcat(s, "e");
if (crc32("lzLGKPKtXNaUP",13) == 3157273085) strcat(s, "m");
if (crc32("cWYFFtIxIsI",11) == 4028839986) strcat(s, "i");
if (crc32("bOyULjDFeLXwdvm",15) == 2680388609) strcat(s, "s");
if (crc32("LtTbMRf",7) == 2262187023) strcat(s, "a");
if (crc32("cgLKDxKqPSUyXnP",15) == 163956089) strcat(s, "v");
if (crc32("dnBZjbZcPvKBLXj",15) == 1095514919) strcat(s, "v");
if (crc32("pQgDiKBjONK",11) == 2945315242) strcat(s, "a");
if (crc32("AYDjaBwo",8) == 1021627608) strcat(s, "g");
if (crc32("lERUoa",6) == 2370090095) strcat(s, "e");
    return s;
}

char *halfcontented_adjectives() {
    char *s = calloc(14);
    if (crc32("QSNLgg",6) == 4068646363) strcat(s, "h");
if (crc32("BJXzMqGi",8) == 172343427) strcat(s, "a");
if (crc32("aLZkLu",6) == 1945667241) strcat(s, "l");
if (crc32("iZllpgWdC",9) == 1049770864) strcat(s, "x");
if (crc32("EnkIcMRSETwqMq",14) == 1464507679) strcat(s, "f");
if (crc32("iXYUQHKRfHOujy",14) == 3350080580) strcat(s, "h");
if (crc32("NyBtFBSRy",9) == 694236927) strcat(s, "c");
if (crc32("NDNYi",5) == 744797980) strcat(s, "M");
if (crc32("ALPwROSQ",8) == 3556398110) strcat(s, "o");
if (crc32("ItEfiZLOxInNoQ",14) == 3206631163) strcat(s, "n");
if (crc32("nAbxqpUfkczolI",14) == 1460068369) strcat(s, "t");
if (crc32("wWyXcIFhRfFa",12) == 4146634870) strcat(s, "e");
if (crc32("ZpSRrALmdHk",11) == 1636720178) strcat(s, "A");
if (crc32("GuLLAfuyvxcvCxI",15) == 1520068483) strcat(s, "n");
if (crc32("DxYzkOl",7) == 841545209) strcat(s, "u");
if (crc32("iloBvs",6) == 1657349488) strcat(s, "t");
if (crc32("SbOaFabkl",9) == 2474945130) strcat(s, "e");
if (crc32("RyzwloWSvAxhbL",14) == 1237001911) strcat(s, "H");
if (crc32("XJeND",5) == 1807689095) strcat(s, "d");
    return s;
}

char *masked_adjectives() {
    char *s = calloc(7);
    if (crc32("HZaOluNzVyOTp",13) == 1950849239) strcat(s, "m");
if (crc32("JxINrkafCjzP",12) == 289702786) strcat(s, "x");
if (crc32("fzVKaXJkEMEUs",13) == 1461844219) strcat(s, "a");
if (crc32("CboAGpylLegycD",14) == 2021930302) strcat(s, "f");
if (crc32("iuvgKV",6) == 1027788900) strcat(s, "s");
if (crc32("meVMNhGZNHMa",12) == 1816617484) strcat(s, "R");
if (crc32("xDiackyAHPnvQiU",15) == 4109898019) strcat(s, "k");
if (crc32("qGpWoy",6) == 2132176420) strcat(s, "Y");
if (crc32("AJrpHhEW",8) == 3207851637) strcat(s, "e");
if (crc32("ZCwwOYGB",8) == 235076111) strcat(s, "d");
    return s;
}

char *spirant_adjectives() {
    char *s = calloc(8);
    if (crc32("sGCQcdHQd",9) == 1131342873) strcat(s, "s");
if (crc32("MVnbkxD",7) == 127894591) strcat(s, "p");
if (crc32("GBHbyxOvoA",10) == 3369125544) strcat(s, "f");
if (crc32("sYkeEqELipT",11) == 2631414152) strcat(s, "i");
if (crc32("vqbnHIfFAFZNdcL",15) == 2835829238) strcat(s, "r");
if (crc32("WeKQDLisdDHhjM",14) == 2025489135) strcat(s, "s");
if (crc32("QfmomJzWrz",10) == 3400815551) strcat(s, "a");
if (crc32("XmreFpd",7) == 878827442) strcat(s, "i");
if (crc32("RTzFS",5) == 3451516424) strcat(s, "n");
if (crc32("pVqLBhKbRXIN",12) == 138508067) strcat(s, "t");
    return s;
}

char *generative_adjectives() {
    char *s = calloc(11);
    if (crc32("QFltpwfBQKUDwj",14) == 474477755) strcat(s, "g");
if (crc32("YLDrWjop",8) == 448900325) strcat(s, "e");
if (crc32("gatEepv",7) == 1745370078) strcat(s, "n");
if (crc32("bSqVbZW",7) == 3749908269) strcat(s, "e");
if (crc32("HhsQuwOQW",9) == 1890355838) strcat(s, "r");
if (crc32("sQclbleEQNgYtYc",15) == 2443229628) strcat(s, "a");
if (crc32("klHCwxlZidb",11) == 3256248964) strcat(s, "t");
if (crc32("KTPOXpVHELKH",12) == 742617684) strcat(s, "i");
if (crc32("faCCS",5) == 1674214840) strcat(s, "x");
if (crc32("irJDCDi",7) == 289052004) strcat(s, "v");
if (crc32("VWujwhXcdaNkP",13) == 3876737885) strcat(s, "D");
if (crc32("aKEeCdsRWlE",11) == 259275467) strcat(s, "e");
    return s;
}

char *manubrial_adjectives() {
    char *s = calloc(10);
    if (crc32("daSdHy",6) == 1290163064) strcat(s, "e");
if (crc32("nuhfoS",6) == 281132910) strcat(s, "m");
if (crc32("ePPfaI",6) == 495961389) strcat(s, "k");
if (crc32("GFiXhkQDgK",10) == 674230698) strcat(s, "a");
if (crc32("phDhwcFSSoH",11) == 1264973489) strcat(s, "A");
if (crc32("AKjsjeyodzhdMSq",15) == 465833252) strcat(s, "n");
if (crc32("czgLwwppwzafS",13) == 318775860) strcat(s, "u");
if (crc32("VkMIvWXhZNiYnYu",15) == 4050299843) strcat(s, "u");
if (crc32("ORNiOEk",7) == 3811370206) strcat(s, "b");
if (crc32("joQHYAsLWx",10) == 2915113841) strcat(s, "r");
if (crc32("jyQTjCzvdt",10) == 2204300932) strcat(s, "i");
if (crc32("OsoddrgaM",9) == 30444509) strcat(s, "i");
if (crc32("FTjJTtYB",8) == 39463851) strcat(s, "a");
if (crc32("iZhyis",6) == 2073003880) strcat(s, "X");
if (crc32("JKawGLXPZBFvHue",15) == 1568920305) strcat(s, "l");
    return s;
}

char *unarbitrary_adjectives() {
    char *s = calloc(12);
    if (crc32("PcDgWQJVHkCb",12) == 2719881135) strcat(s, "k");
if (crc32("zidDcFMuFvluBBC",15) == 1557927031) strcat(s, "u");
if (crc32("DfnaRXTZcgSeyjT",15) == 2972773485) strcat(s, "n");
if (crc32("hZbGHkBLNq",10) == 3338715264) strcat(s, "G");
if (crc32("dXhsubdiG",9) == 3891160718) strcat(s, "a");
if (crc32("ZNUJmIsJopAtAf",14) == 3256546391) strcat(s, "J");
if (crc32("NXIWPuEcwOBOFBJ",15) == 580488777) strcat(s, "r");
if (crc32("UpCnSxTI",8) == 1775221710) strcat(s, "b");
if (crc32("SwapfUGiLC",10) == 1774930123) strcat(s, "v");
if (crc32("YzlANXPolqX",11) == 1805252810) strcat(s, "i");
if (crc32("xIfxrwIXqIEP",12) == 3459727121) strcat(s, "t");
if (crc32("jFSMHOVLIUwD",12) == 1761106831) strcat(s, "r");
if (crc32("LamiAwd",7) == 2702883454) strcat(s, "a");
if (crc32("WgkexS",6) == 1021622472) strcat(s, "r");
if (crc32("aVfdysSMpsNFH",13) == 2489722359) strcat(s, "y");
    return s;
}

char *untameable_adjectives() {
    char *s = calloc(11);
    if (crc32("ElpWNCcoQqIFTl",14) == 3127449827) strcat(s, "u");
if (crc32("IAUWmOg",7) == 1974567332) strcat(s, "s");
if (crc32("FfazzZ",6) == 4196638281) strcat(s, "n");
if (crc32("dYgjdTDSjzlpQ",13) == 327195740) strcat(s, "k");
if (crc32("hToZOayAKpDp",12) == 306843803) strcat(s, "t");
if (crc32("BhdNkYwJYZl",11) == 58987558) strcat(s, "v");
if (crc32("eyWza",5) == 122755249) strcat(s, "a");
if (crc32("kptGR",5) == 691628225) strcat(s, "r");
if (crc32("gtBqV",5) == 3462368851) strcat(s, "m");
if (crc32("nlOtJnW",7) == 1951487452) strcat(s, "e");
if (crc32("XfEShsCqEezUh",13) == 1602198058) strcat(s, "a");
if (crc32("ybdfXZPQ",8) == 2351911057) strcat(s, "g");
if (crc32("nSTDrWYhs",9) == 954167233) strcat(s, "b");
if (crc32("jnjuaqDZ",8) == 2933897163) strcat(s, "l");
if (crc32("yGcXvVAnmBOFde",14) == 2194304905) strcat(s, "l");
if (crc32("LynDCXzt",8) == 2497421586) strcat(s, "e");
    return s;
}

char *dignitarial_adjectives() {
    char *s = calloc(12);
    if (crc32("TBuxxx",6) == 3151332317) strcat(s, "d");
if (crc32("brLlXWs",7) == 4113724374) strcat(s, "u");
if (crc32("HfrHVPBIzQJYp",13) == 767138458) strcat(s, "i");
if (crc32("nAguzjFSQnZ",11) == 908920685) strcat(s, "g");
if (crc32("CfoSIxSPMOe",11) == 1718268412) strcat(s, "S");
if (crc32("SoEpX",5) == 3859434056) strcat(s, "n");
if (crc32("CPZVzi",6) == 757261294) strcat(s, "i");
if (crc32("WPoYT",5) == 3286766729) strcat(s, "t");
if (crc32("xDmSsVOLlvUxOm",14) == 2790220408) strcat(s, "a");
if (crc32("JpqEqFPxDGYcvE",14) == 2139922164) strcat(s, "F");
if (crc32("vLiWDGzhMbA",11) == 2534287838) strcat(s, "r");
if (crc32("KRxOQW",6) == 3403041153) strcat(s, "H");
if (crc32("yTbqJjuUgdPBMF",14) == 1774501816) strcat(s, "i");
if (crc32("HeJJaUVl",8) == 2414148164) strcat(s, "r");
if (crc32("krHWADnCYu",10) == 2207679876) strcat(s, "a");
if (crc32("combDTqQbUmhPn",14) == 3246395467) strcat(s, "l");
    return s;
}

char *spiritualistic_adjectives() {
    char *s = calloc(15);
    if (crc32("CJkOKWB",7) == 2050891433) strcat(s, "s");
if (crc32("rKHqwfFjZDVydoO",15) == 830127433) strcat(s, "p");
if (crc32("nQtQR",5) == 3870083767) strcat(s, "i");
if (crc32("GHLdXft",7) == 3505180568) strcat(s, "r");
if (crc32("fKhIoXRiP",9) == 1967388099) strcat(s, "c");
if (crc32("RuJqNzheTWxhB",13) == 3369792220) strcat(s, "i");
if (crc32("iGKBxV",6) == 772799173) strcat(s, "t");
if (crc32("VqzdAbvLhuWl",12) == 151046475) strcat(s, "F");
if (crc32("BsrfEBpjaKTTt",13) == 1261566836) strcat(s, "u");
if (crc32("BRCVhv",6) == 1146291736) strcat(s, "a");
if (crc32("nTEOwLGow",9) == 1760693585) strcat(s, "I");
if (crc32("yTzePHGxqWzGlZ",14) == 3928146790) strcat(s, "l");
if (crc32("ikvlV",5) == 3772855532) strcat(s, "D");
if (crc32("wZcViGVCSbsDPTT",15) == 218164414) strcat(s, "i");
if (crc32("SwYdGM",6) == 2763244533) strcat(s, "C");
if (crc32("xIYsdJp",7) == 863505681) strcat(s, "s");
if (crc32("eUweTc",6) == 2682782273) strcat(s, "M");
if (crc32("mIUJEsaf",8) == 2467652488) strcat(s, "t");
if (crc32("qMENePOTXIbV",12) == 3257908925) strcat(s, "e");
if (crc32("WhPfLVbQi",9) == 2712979838) strcat(s, "i");
if (crc32("JAxDFbvoFpAg",12) == 1424490379) strcat(s, "Q");
if (crc32("quykWfQy",8) == 3921579706) strcat(s, "c");
    return s;
}

char *complementfixing_adjectives() {
    char *s = calloc(17);
    if (crc32("ddfPAGhL",8) == 1054942945) strcat(s, "j");
if (crc32("EAyolBIxt",9) == 3044229772) strcat(s, "c");
if (crc32("syTTCUgnSPziX",13) == 462289481) strcat(s, "G");
if (crc32("phTor",5) == 4139329834) strcat(s, "o");
if (crc32("GGJVzhBcbtBtue",14) == 3963879158) strcat(s, "m");
if (crc32("WnAhoaJKr",9) == 2079557456) strcat(s, "p");
if (crc32("pCCBUcGy",8) == 968644151) strcat(s, "w");
if (crc32("XMbQXEA",7) == 1084856504) strcat(s, "l");
if (crc32("jAtcVCwWLOct",12) == 2722259202) strcat(s, "E");
if (crc32("FsOOv",5) == 3713669304) strcat(s, "e");
if (crc32("MbZXvpmtqxtZN",13) == 3164870440) strcat(s, "m");
if (crc32("KxcClC",6) == 707458882) strcat(s, "o");
if (crc32("uHgkIaKmQ",9) == 3975051881) strcat(s, "e");
if (crc32("PEaQPFYJtb",10) == 2946677750) strcat(s, "n");
if (crc32("tQobqibYOpFWn",13) == 4074736371) strcat(s, "V");
if (crc32("xkwYJoHowiNnjI",14) == 348626339) strcat(s, "t");
if (crc32("awGWosikZI",10) == 3142435876) strcat(s, "m");
if (crc32("bLElzoiR",8) == 21187298) strcat(s, "f");
if (crc32("uvlSldvZpYfIX",13) == 2591869268) strcat(s, "Q");
if (crc32("gFbIwJkN",8) == 343993385) strcat(s, "i");
if (crc32("MQahnPutr",9) == 3375567538) strcat(s, "B");
if (crc32("DdQlKvTzRhtXldw",15) == 994723955) strcat(s, "x");
if (crc32("lNmwA",5) == 3229713435) strcat(s, "i");
if (crc32("avCTeyBXlOhQOji",15) == 2902009176) strcat(s, "v");
if (crc32("giOWmeUQcg",10) == 3752711369) strcat(s, "n");
if (crc32("qiRIshOKDpgra",13) == 772050878) strcat(s, "g");
    return s;
}

char *cryogenic_adjectives() {
    char *s = calloc(10);
    if (crc32("uCJukmVVn",9) == 1238330482) strcat(s, "c");
if (crc32("EiFxHDVqzPHcfmn",15) == 3299064200) strcat(s, "A");
if (crc32("JlxYpyJpsUmal",13) == 918006339) strcat(s, "r");
if (crc32("MwdKsoLUyaCzMoC",15) == 3186948665) strcat(s, "Q");
if (crc32("HFiFUvfXVSC",11) == 699728871) strcat(s, "y");
if (crc32("yaWmiWROmgxy",12) == 2517483695) strcat(s, "U");
if (crc32("JkTXKsaSKzyiZad",15) == 996892797) strcat(s, "o");
if (crc32("VyWCFYYTFyWaGl",14) == 1811623517) strcat(s, "g");
if (crc32("vyRaJtGgz",9) == 3102378255) strcat(s, "g");
if (crc32("mEDwrRGS",8) == 2398132008) strcat(s, "n");
if (crc32("VMLNxnFEzmTFvbD",15) == 3442781191) strcat(s, "e");
if (crc32("FQVvpZ",6) == 1999317801) strcat(s, "n");
if (crc32("iNHiKcXGxJsDh",13) == 1482279998) strcat(s, "k");
if (crc32("qwWLGDBbc",9) == 929525189) strcat(s, "i");
if (crc32("KpbnfLTS",8) == 3590058721) strcat(s, "c");
    return s;
}

char *active_adjectives() {
    char *s = calloc(7);
    if (crc32("fdiUxeGuoYDh",12) == 461434035) strcat(s, "a");
if (crc32("QpcmyBnhvBtcKoD",15) == 481122854) strcat(s, "t");
if (crc32("npBlJuO",7) == 3609362225) strcat(s, "c");
if (crc32("zoQBxA",6) == 947172371) strcat(s, "r");
if (crc32("XWgMHHeBq",9) == 281370746) strcat(s, "t");
if (crc32("trXrlAvzBTar",12) == 488979358) strcat(s, "i");
if (crc32("FkxDm",5) == 3535055755) strcat(s, "K");
if (crc32("mUbRLgR",7) == 2145464583) strcat(s, "v");
if (crc32("vTgImPlGifcdKXH",15) == 424271461) strcat(s, "m");
if (crc32("mSBGESl",7) == 2049216352) strcat(s, "e");
    return s;
}

char *pseudoreformed_adjectives() {
    char *s = calloc(15);
    if (crc32("gkNPwKDHzi",10) == 2734710493) strcat(s, "p");
if (crc32("HJnpzPAXBYM",11) == 3448073621) strcat(s, "Q");
if (crc32("YIerH",5) == 1043305997) strcat(s, "s");
if (crc32("SvYrL",5) == 3555184152) strcat(s, "M");
if (crc32("ZZfbQIq",7) == 1531317778) strcat(s, "e");
if (crc32("rBqhOlsfnCGM",12) == 239337169) strcat(s, "L");
if (crc32("mbRPTtzbQF",10) == 1767082096) strcat(s, "u");
if (crc32("TPngGveYdRoTbA",14) == 13982301) strcat(s, "d");
if (crc32("PhcMrHQeTdjDOil",15) == 634140358) strcat(s, "o");
if (crc32("zMTskPqHm",9) == 273656675) strcat(s, "r");
if (crc32("ovAmvUdq",8) == 998751797) strcat(s, "X");
if (crc32("VDZBtXApsKxFmC",14) == 1406578352) strcat(s, "e");
if (crc32("PQxIv",5) == 1337936316) strcat(s, "f");
if (crc32("KtMLklfbctuaNke",15) == 1366300960) strcat(s, "b");
if (crc32("FKYaUfasKk",10) == 498097711) strcat(s, "o");
if (crc32("ognPvMQPfx",10) == 314343844) strcat(s, "r");
if (crc32("AQfYyvba",8) == 3308002811) strcat(s, "m");
if (crc32("ZxRxynMw",8) == 695169074) strcat(s, "e");
if (crc32("LbeKeEtKMgvl",12) == 86130113) strcat(s, "d");
    return s;
}

char *yeararound_adjectives() {
    char *s = calloc(11);
    if (crc32("kVZbnvFUp",9) == 3221003916) strcat(s, "J");
if (crc32("SgVkTlsTRT",10) == 2923079814) strcat(s, "y");
if (crc32("BvcDu",5) == 1420720575) strcat(s, "e");
if (crc32("wWZWvVMv",8) == 283267379) strcat(s, "O");
if (crc32("VItoq",5) == 32648335) strcat(s, "a");
if (crc32("WCnGnQjJbpgdVm",14) == 536453223) strcat(s, "f");
if (crc32("HHvxKzjiGTrROP",14) == 4208690709) strcat(s, "r");
if (crc32("DQjhltzDLULT",12) == 618289070) strcat(s, "q");
if (crc32("IefnOJIoMLyPcX",14) == 4165652589) strcat(s, "a");
if (crc32("HmHulCKbEgc",11) == 1366258247) strcat(s, "r");
if (crc32("PGrPBaAMdXlZptZ",15) == 3549495106) strcat(s, "p");
if (crc32("XxBHJcaKmZ",10) == 3397864025) strcat(s, "o");
if (crc32("OQWcdKtaaeGsUGm",15) == 4012199875) strcat(s, "u");
if (crc32("YsUdkNAnZXtYZgo",15) == 846997016) strcat(s, "n");
if (crc32("LYAFEzA",7) == 1290813445) strcat(s, "d");
    return s;
}

char *unneedy_adjectives() {
    char *s = calloc(8);
    if (crc32("DHgGonmUe",9) == 2347040581) strcat(s, "C");
if (crc32("nDsQtylMowWjNc",14) == 463229510) strcat(s, "u");
if (crc32("MGxrpjKkKpebf",13) == 1809753024) strcat(s, "n");
if (crc32("jcgoiOyeP",9) == 2119396871) strcat(s, "Q");
if (crc32("WqNOyEjzdRymL",13) == 1849691605) strcat(s, "n");
if (crc32("UFXHlsgZxFd",11) == 623669210) strcat(s, "c");
if (crc32("mPqzj",5) == 1091129374) strcat(s, "e");
if (crc32("gbKrNtLhbVQ",11) == 2193864312) strcat(s, "C");
if (crc32("GMhMGiHUHaeuuS",14) == 2188270040) strcat(s, "e");
if (crc32("OSnulYD",7) == 579722075) strcat(s, "y");
if (crc32("PEsrLFoeVdq",11) == 1331913995) strcat(s, "d");
if (crc32("GALHjazvWUEwHq",14) == 984559107) strcat(s, "j");
if (crc32("PmdhniLgQKKqfQe",15) == 2166260209) strcat(s, "y");
    return s;
}

char *glandulous_adjectives() {
    char *s = calloc(11);
    if (crc32("iDZPPXXvfzsmhKS",15) == 2637398684) strcat(s, "P");
if (crc32("Fvuqsin",7) == 3456078623) strcat(s, "g");
if (crc32("oZNvmWLfL",9) == 1783588084) strcat(s, "l");
if (crc32("bveFS",5) == 482624191) strcat(s, "s");
if (crc32("fQnWe",5) == 696952153) strcat(s, "a");
if (crc32("mrgsvpsccX",10) == 582679115) strcat(s, "n");
if (crc32("sEGHhvvnJwk",11) == 3672474285) strcat(s, "D");
if (crc32("RdNcxkiEyznHXe",14) == 1581962007) strcat(s, "d");
if (crc32("VtHqhxxtbiY",11) == 2660402275) strcat(s, "u");
if (crc32("cfYiZFICgCTCXaJ",15) == 475142374) strcat(s, "l");
if (crc32("MwgUoiRPZoiA",12) == 3541041059) strcat(s, "A");
if (crc32("CnxGtsrTlpzdoto",15) == 644140821) strcat(s, "o");
if (crc32("jyXPDKsEaIxS",12) == 655272745) strcat(s, "W");
if (crc32("QdslVB",6) == 1456884772) strcat(s, "u");
if (crc32("uZrMvLvWhZQarmC",15) == 87447330) strcat(s, "G");
if (crc32("DZAaiFRhDvDIi",13) == 1129391850) strcat(s, "s");
    return s;
}

char *serflike_adjectives() {
    char *s = calloc(9);
    if (crc32("ZWQGJNCCTkYJPA",14) == 1283444256) strcat(s, "s");
if (crc32("CCppVgrLgSZaqe",14) == 1535184709) strcat(s, "e");
if (crc32("tjryPanmmuoVXM",14) == 911454060) strcat(s, "H");
if (crc32("dtHoX",5) == 3079758733) strcat(s, "r");
if (crc32("zSOFRoIsBJe",11) == 3995179713) strcat(s, "f");
if (crc32("ZXaNSEU",7) == 3715636284) strcat(s, "l");
if (crc32("uZzUUuEGApIUG",13) == 259072295) strcat(s, "R");
if (crc32("VUuOdftItOwf",12) == 2459090676) strcat(s, "i");
if (crc32("wNXQOfCnyrjqPCs",15) == 3792071804) strcat(s, "X");
if (crc32("JGcWPr",6) == 2969706860) strcat(s, "k");
if (crc32("CDdMhLcPetmGBpD",15) == 3364208799) strcat(s, "T");
if (crc32("LmVXNFkptgfak",13) == 2671249631) strcat(s, "e");
    return s;
}

char *ternate_adjectives() {
    char *s = calloc(8);
    if (crc32("WzFhphxXyQba",12) == 859771823) strcat(s, "y");
if (crc32("cRkdnTEGlN",10) == 165156537) strcat(s, "t");
if (crc32("SaETp",5) == 3263722535) strcat(s, "e");
if (crc32("zHvGpHxQx",9) == 3841419158) strcat(s, "r");
if (crc32("xsDcHL",6) == 1302173539) strcat(s, "H");
if (crc32("mFFfM",5) == 1445086078) strcat(s, "n");
if (crc32("tQmPNT",6) == 3495766583) strcat(s, "U");
if (crc32("LISFFMTPQkfsEU",14) == 1290970583) strcat(s, "a");
if (crc32("JggRPBsRxXOml",13) == 1595519936) strcat(s, "i");
if (crc32("szBYbuq",7) == 1081779001) strcat(s, "t");
if (crc32("tyuWqembDUNxYMM",15) == 1290448932) strcat(s, "e");
    return s;
}

char *wirespun_adjectives() {
    char *s = calloc(9);
    if (crc32("rZefnz",6) == 1676466988) strcat(s, "v");
if (crc32("wnHTM",5) == 4263129847) strcat(s, "w");
if (crc32("GemJKOb",7) == 2036346970) strcat(s, "i");
if (crc32("xtAcQbFsGpy",11) == 316664022) strcat(s, "N");
if (crc32("ArHOJssGLmGUSt",14) == 4107104723) strcat(s, "r");
if (crc32("CvlNIPMpZ",9) == 97807738) strcat(s, "C");
if (crc32("mqain",5) == 589545150) strcat(s, "e");
if (crc32("QexQKkFEImXJFC",14) == 4044305014) strcat(s, "x");
if (crc32("DrIivvRlSpX",11) == 128610284) strcat(s, "s");
if (crc32("qefias",6) == 3436160490) strcat(s, "p");
if (crc32("MVnfgda",7) == 747922198) strcat(s, "u");
if (crc32("hmqApKpX",8) == 1805664796) strcat(s, "b");
if (crc32("nynWXqPj",8) == 757626321) strcat(s, "n");
    return s;
}

char *unrelishing_adjectives() {
    char *s = calloc(12);
    if (crc32("AWnwlxoiey",10) == 3421196756) strcat(s, "u");
if (crc32("cxHkaC",6) == 1102130060) strcat(s, "h");
if (crc32("oBsIPywXyg",10) == 2171527667) strcat(s, "n");
if (crc32("krvuXzupHLzTA",13) == 3679901079) strcat(s, "Q");
if (crc32("EuwEWxP",7) == 3539343165) strcat(s, "r");
if (crc32("MapXPPVfa",9) == 2554195867) strcat(s, "J");
if (crc32("jmsbNVy",7) == 2527192646) strcat(s, "e");
if (crc32("HqDnMGkLF",9) == 2595120906) strcat(s, "W");
if (crc32("aKkFXVM",7) == 59546570) strcat(s, "l");
if (crc32("sHRiyblg",8) == 1316872080) strcat(s, "m");
if (crc32("EatoWjnGaMkBh",13) == 3832715584) strcat(s, "i");
if (crc32("MFUukuvNmc",10) == 2932502528) strcat(s, "p");
if (crc32("wRfJhoFexlGc",12) == 4000772614) strcat(s, "s");
if (crc32("dQRFJWVHl",9) == 1129179966) strcat(s, "h");
if (crc32("PXyospLPcnH",11) == 2775968386) strcat(s, "i");
if (crc32("VKzPaXVqliufMc",14) == 2798645792) strcat(s, "n");
if (crc32("JURpislfPaaq",12) == 1203172395) strcat(s, "g");
    return s;
}

char *overdiverse_adjectives() {
    char *s = calloc(12);
    if (crc32("wXGNrbpBmDBiRpY",15) == 3878843738) strcat(s, "o");
if (crc32("QcDRU",5) == 2506515079) strcat(s, "D");
if (crc32("FABLb",5) == 3193388159) strcat(s, "v");
if (crc32("tdMEUmerFANjhs",14) == 2309147322) strcat(s, "j");
if (crc32("uiVVQEuMyeMLQue",15) == 555987904) strcat(s, "e");
if (crc32("nsggCxFkNclbcD",14) == 758914002) strcat(s, "M");
if (crc32("SWYzgn",6) == 3728659632) strcat(s, "r");
if (crc32("BZWUJsUeKlnohxR",15) == 1105102923) strcat(s, "d");
if (crc32("aYFLvCo",7) == 314323133) strcat(s, "l");
if (crc32("dMFtEHjnk",9) == 1218120522) strcat(s, "i");
if (crc32("ovQYDhuBvEzIwD",14) == 1174083136) strcat(s, "X");
if (crc32("HzmZuW",6) == 4002094224) strcat(s, "v");
if (crc32("kFxwjbrLZbpMZj",14) == 2471365471) strcat(s, "e");
if (crc32("pjexGHObTILNq",13) == 536572951) strcat(s, "r");
if (crc32("GjPjPbTMcT",10) == 3720779981) strcat(s, "s");
if (crc32("RyiKm",5) == 4115595044) strcat(s, "e");
    return s;
}

char *unmerry_adjectives() {
    char *s = calloc(8);
    if (crc32("rkplGnTU",8) == 3562700179) strcat(s, "u");
if (crc32("lDbQeKtfYfaiNi",14) == 991678621) strcat(s, "o");
if (crc32("ZADCWMDC",8) == 2642057194) strcat(s, "n");
if (crc32("mTHMZkuuvv",10) == 2082020823) strcat(s, "A");
if (crc32("qxZDnHfApYtvok",14) == 443044570) strcat(s, "m");
if (crc32("GaaUQ",5) == 1037994566) strcat(s, "e");
if (crc32("jyseq",5) == 2784343408) strcat(s, "P");
if (crc32("mWCFCUfYvbJ",11) == 3146482278) strcat(s, "r");
if (crc32("EsmNUPHklATUwkx",15) == 3721511495) strcat(s, "E");
if (crc32("uwWeEluguACWi",13) == 2265228350) strcat(s, "r");
if (crc32("bQJcuMsSNMrp",12) == 2534803192) strcat(s, "y");
    return s;
}

char *untransformed_adjectives() {
    char *s = calloc(14);
    if (crc32("IbXlavkSztjiegz",15) == 778111622) strcat(s, "m");
if (crc32("ynxnG",5) == 2688376417) strcat(s, "u");
if (crc32("maZylxbnbH",10) == 2074310061) strcat(s, "n");
if (crc32("wuBGooqqHyH",11) == 2462681423) strcat(s, "J");
if (crc32("RHaeuoH",7) == 2866799196) strcat(s, "t");
if (crc32("KkVrBhHGyOvAlH",14) == 1901252360) strcat(s, "n");
if (crc32("efhIReMyhrb",11) == 3854733786) strcat(s, "r");
if (crc32("QaVPayAFaNzn",12) == 2971973730) strcat(s, "T");
if (crc32("CswCIVcsNEkucnn",15) == 2790825424) strcat(s, "a");
if (crc32("uJXETFK",7) == 1847957835) strcat(s, "I");
if (crc32("JGWpRYrSvQj",11) == 46076802) strcat(s, "n");
if (crc32("UEKngarAsZX",11) == 1348948944) strcat(s, "j");
if (crc32("XPqJAUczW",9) == 1836538024) strcat(s, "s");
if (crc32("HmGagzXp",8) == 516213601) strcat(s, "f");
if (crc32("qNABOkQRB",9) == 1266409236) strcat(s, "R");
if (crc32("SRFGJMjKGxONA",13) == 3391976480) strcat(s, "o");
if (crc32("kazskirTguk",11) == 3313669623) strcat(s, "r");
if (crc32("hrCWsZYcbvsQxe",14) == 651261193) strcat(s, "G");
if (crc32("kYFJjRrIBbkZRt",14) == 569648690) strcat(s, "m");
if (crc32("BObdMRz",7) == 2808086153) strcat(s, "e");
if (crc32("IMBNn",5) == 2162001332) strcat(s, "C");
if (crc32("BUZyfR",6) == 1257441951) strcat(s, "d");
    return s;
}

char *superlaborious_adjectives() {
    char *s = calloc(15);
    if (crc32("mBoObAI",7) == 1473414268) strcat(s, "n");
if (crc32("cioumCZO",8) == 4032779951) strcat(s, "s");
if (crc32("uuPnupRhxr",10) == 459384492) strcat(s, "u");
if (crc32("yKEPiOwgHpJd",12) == 928275547) strcat(s, "p");
if (crc32("xNcOyMG",7) == 2611679866) strcat(s, "t");
if (crc32("yHeuVf",6) == 3818814743) strcat(s, "e");
if (crc32("NxauBtTUbUXX",12) == 1404767745) strcat(s, "P");
if (crc32("kgPitDW",7) == 1307771163) strcat(s, "r");
if (crc32("JeAZwQtExSVpiTD",15) == 3898767689) strcat(s, "l");
if (crc32("NeykJd",6) == 2939778721) strcat(s, "k");
if (crc32("dwviyp",6) == 3472845916) strcat(s, "a");
if (crc32("eFVgAUPkiyWp",12) == 3080064904) strcat(s, "b");
if (crc32("nTMqWsmivsN",11) == 532655837) strcat(s, "o");
if (crc32("BAyTGQGkfBqNyrp",15) == 2453950148) strcat(s, "C");
if (crc32("pRcQuTP",7) == 2062000364) strcat(s, "r");
if (crc32("JdegZUcxBoZzQ",13) == 4282293137) strcat(s, "i");
if (crc32("TzIXWrY",7) == 3713592089) strcat(s, "o");
if (crc32("CsJVzrbnHwZWKet",15) == 1682581926) strcat(s, "h");
if (crc32("yRvwFNJ",7) == 2839827783) strcat(s, "u");
if (crc32("sPCtQ",5) == 2529070249) strcat(s, "s");
    return s;
}

char *exostotic_adjectives() {
    char *s = calloc(10);
    if (crc32("VOYbnYadqpNshYL",15) == 4082293262) strcat(s, "e");
if (crc32("UhywTEbFehVf",12) == 4264474708) strcat(s, "n");
if (crc32("WOhSwe",6) == 3072615319) strcat(s, "x");
if (crc32("vXQZyOTdmr",10) == 1382746703) strcat(s, "u");
if (crc32("SpoLKwPMzVldzGE",15) == 86327871) strcat(s, "o");
if (crc32("gfnYqMZlsI",10) == 43441571) strcat(s, "s");
if (crc32("TDQffJk",7) == 725363509) strcat(s, "b");
if (crc32("ywxIjPS",7) == 3499940010) strcat(s, "t");
if (crc32("WlhJHRgGBbpdq",13) == 3912788853) strcat(s, "I");
if (crc32("vitNPPrSsQp",11) == 291077475) strcat(s, "o");
if (crc32("rCdZlcfAa",9) == 938310746) strcat(s, "E");
if (crc32("oekbjHURJZIbZ",13) == 649233120) strcat(s, "t");
if (crc32("ZHGIhhNaIbEGosD",15) == 938485816) strcat(s, "i");
if (crc32("cRdbQ",5) == 2110600722) strcat(s, "c");
    return s;
}

char *ketogenetic_adjectives() {
    char *s = calloc(12);
    if (crc32("JwquhHtHniO",11) == 1361637535) strcat(s, "k");
if (crc32("hwTtAppknhKTQ",13) == 1114317212) strcat(s, "O");
if (crc32("dZLsNaSHsPwthTd",15) == 966778533) strcat(s, "e");
if (crc32("uqcXbcSszJPvAa",14) == 53317197) strcat(s, "t");
if (crc32("HAvTFTESRw",10) == 2330267136) strcat(s, "o");
if (crc32("gwXoIsjrRHbUQU",14) == 4246103612) strcat(s, "g");
if (crc32("PkFxGXjnYcQyzHt",15) == 1537632988) strcat(s, "m");
if (crc32("zvpcdqA",7) == 2691652776) strcat(s, "e");
if (crc32("XOXXRTNedAvJg",13) == 1463213072) strcat(s, "M");
if (crc32("XguiydPzs",9) == 1423999708) strcat(s, "n");
if (crc32("hHxGOl",6) == 1711421072) strcat(s, "l");
if (crc32("hzPeVZH",7) == 3942979039) strcat(s, "e");
if (crc32("BPeviREMmziS",12) == 959123870) strcat(s, "t");
if (crc32("mjPiWPkRizi",11) == 5677180) strcat(s, "E");
if (crc32("PJIsvZcotya",11) == 3263541051) strcat(s, "i");
if (crc32("fulnZCW",7) == 3870184280) strcat(s, "c");
    return s;
}

char *illusionistic_adjectives() {
    char *s = calloc(14);
    if (crc32("JTOIty",6) == 203713260) strcat(s, "i");
if (crc32("LJCftAVx",8) == 1139739443) strcat(s, "l");
if (crc32("mizfQxTuFAQGRf",14) == 4057824599) strcat(s, "l");
if (crc32("njYoZSTnx",9) == 3577631146) strcat(s, "g");
if (crc32("OoiUXBs",7) == 3616604100) strcat(s, "u");
if (crc32("DLfeqJMTzTBsU",13) == 3200267537) strcat(s, "s");
if (crc32("wQWXLyp",7) == 545462584) strcat(s, "i");
if (crc32("gRTbf",5) == 345755725) strcat(s, "o");
if (crc32("VzsMVTMXQ",9) == 2202680725) strcat(s, "k");
if (crc32("SVUtLg",6) == 2897881727) strcat(s, "n");
if (crc32("RHYjdjGj",8) == 2109959369) strcat(s, "d");
if (crc32("NdArNljCq",9) == 793447796) strcat(s, "i");
if (crc32("UtWkUgZrHuW",11) == 3843501492) strcat(s, "Y");
if (crc32("niJiJeTGeeBanT",14) == 3345081612) strcat(s, "s");
if (crc32("BadZDBcN",8) == 2051081657) strcat(s, "t");
if (crc32("qIuNCIn",7) == 707848360) strcat(s, "w");
if (crc32("ULKNf",5) == 1375180004) strcat(s, "i");
if (crc32("uTphcN",6) == 3589356077) strcat(s, "c");
    return s;
}

char *impressional_adjectives() {
    char *s = calloc(13);
    if (crc32("jUskGPf",7) == 3607346672) strcat(s, "i");
if (crc32("ohvekTOHleLqRe",14) == 727066904) strcat(s, "m");
if (crc32("WuIUYlgvqeS",11) == 3492451560) strcat(s, "J");
if (crc32("fBfhelNjtoPNn",13) == 3973808296) strcat(s, "p");
if (crc32("FKwsX",5) == 1838680302) strcat(s, "r");
if (crc32("ydqlNOItw",9) == 88906686) strcat(s, "e");
if (crc32("jocCj",5) == 238958233) strcat(s, "x");
if (crc32("dbYTH",5) == 4261567957) strcat(s, "s");
if (crc32("oyUpnHOhqiu",11) == 3995352764) strcat(s, "k");
if (crc32("BvoRzwJafRcH",12) == 2487154288) strcat(s, "s");
if (crc32("drlDdxvu",8) == 798852093) strcat(s, "i");
if (crc32("DhfcOFpuBtRolTy",15) == 3481256583) strcat(s, "o");
if (crc32("fYKBZhTW",8) == 3669759094) strcat(s, "k");
if (crc32("KaOKfvNznkFeDP",14) == 1133472849) strcat(s, "n");
if (crc32("mfkTnlraYyvphla",15) == 4062334156) strcat(s, "a");
if (crc32("lNqxuON",7) == 984499737) strcat(s, "l");
    return s;
}

char *nonconsultative_adjectives() {
    char *s = calloc(16);
    if (crc32("JZbvWENkopqPTK",14) == 768665401) strcat(s, "p");
if (crc32("vwNkfNjBHwzsfe",14) == 43221282) strcat(s, "n");
if (crc32("xsMeBthY",8) == 293714537) strcat(s, "O");
if (crc32("FzsHLXXk",8) == 1016201344) strcat(s, "o");
if (crc32("SEQnqEYHulURLHW",15) == 1662660921) strcat(s, "M");
if (crc32("xURLVCgWzwsFIm",14) == 2166205930) strcat(s, "n");
if (crc32("nOyiJdyKPyMA",12) == 3821573382) strcat(s, "N");
if (crc32("JpozxZVZqROgF",13) == 2270553061) strcat(s, "c");
if (crc32("HnNTVvTXwWRlHZ",14) == 336461539) strcat(s, "D");
if (crc32("aCdpbegqaCu",11) == 740332140) strcat(s, "o");
if (crc32("IdPArZOpkHRGSL",14) == 573272299) strcat(s, "n");
if (crc32("BudNLQLJUqb",11) == 3349492197) strcat(s, "m");
if (crc32("YisXN",5) == 12488684) strcat(s, "s");
if (crc32("UDpzdiqQWFFajwt",15) == 349164307) strcat(s, "O");
if (crc32("AwnHDaGbYEUxpeO",15) == 2218407420) strcat(s, "u");
if (crc32("qOjVV",5) == 3930994412) strcat(s, "l");
if (crc32("mkzUihdphXWz",12) == 2737720409) strcat(s, "t");
if (crc32("fQzQiCvNtIkUREU",15) == 767651601) strcat(s, "C");
if (crc32("vWFAtqgMDa",10) == 661817599) strcat(s, "a");
if (crc32("AghbPj",6) == 4241081991) strcat(s, "t");
if (crc32("gXGMzUvP",8) == 2228929592) strcat(s, "x");
if (crc32("VtvKsLAoGcIRuV",14) == 1654376164) strcat(s, "i");
if (crc32("gUfYv",5) == 2410030678) strcat(s, "v");
if (crc32("rhnCCkANQ",9) == 2578300172) strcat(s, "e");
    return s;
}

char *postmeiotic_adjectives() {
    char *s = calloc(12);
    if (crc32("baMEdUdlfIx",11) == 2994101125) strcat(s, "I");
if (crc32("zlFtfToYq",9) == 3997554231) strcat(s, "p");
if (crc32("fuRhLCyryo",10) == 2241378463) strcat(s, "d");
if (crc32("FBaTeCsoL",9) == 2301363511) strcat(s, "o");
if (crc32("mRzZCX",6) == 4071456337) strcat(s, "r");
if (crc32("KReaoUHfe",9) == 548165872) strcat(s, "s");
if (crc32("tKTMsHcylg",10) == 4068166572) strcat(s, "N");
if (crc32("zurajdksZY",10) == 1456418101) strcat(s, "t");
if (crc32("nuKFNKpzfRO",11) == 1225273742) strcat(s, "Y");
if (crc32("DPbXgqBwNgHNfIM",15) == 2769500197) strcat(s, "m");
if (crc32("aZUbYcnZT",9) == 2482611562) strcat(s, "f");
if (crc32("LcGTTIx",7) == 717957637) strcat(s, "e");
if (crc32("VCJwFaHpkDAG",12) == 3293534212) strcat(s, "J");
if (crc32("RyiPb",5) == 3435604271) strcat(s, "i");
if (crc32("CsWovwpH",8) == 1569405379) strcat(s, "o");
if (crc32("iYSxPxprpXc",11) == 1058873960) strcat(s, "t");
if (crc32("ZYJyYq",6) == 3569972000) strcat(s, "O");
if (crc32("FMMuRDWRggfK",12) == 2784546062) strcat(s, "i");
if (crc32("JYakBImwXWljwg",14) == 4174925383) strcat(s, "T");
if (crc32("ViBqYeWd",8) == 693856567) strcat(s, "c");
    return s;
}

char *indecipherable_adjectives() {
    char *s = calloc(15);
    if (crc32("rTkUgMWhGLuNUU",14) == 446167562) strcat(s, "I");
if (crc32("lGXNjorl",8) == 717873317) strcat(s, "i");
if (crc32("nnIHD",5) == 226707658) strcat(s, "n");
if (crc32("wxZjpT",6) == 2048947964) strcat(s, "c");
if (crc32("pTKipV",6) == 3512166349) strcat(s, "d");
if (crc32("TfNfMn",6) == 3907226660) strcat(s, "e");
if (crc32("sbgCKRQMFH",10) == 3267402383) strcat(s, "S");
if (crc32("VADvAyYfF",9) == 3550016195) strcat(s, "c");
if (crc32("KZfLyTyIASsERWH",15) == 1791367415) strcat(s, "i");
if (crc32("vtRFfv",6) == 1890267989) strcat(s, "y");
if (crc32("LFNfgABc",8) == 3736507473) strcat(s, "p");
if (crc32("esQtceMqtphNnWD",15) == 1911171810) strcat(s, "j");
if (crc32("AAoRdgMfcPegZqJ",15) == 3946638213) strcat(s, "h");
if (crc32("UZJbBJd",7) == 2893595180) strcat(s, "r");
if (crc32("CAynCMIlnwJ",11) == 2587672795) strcat(s, "e");
if (crc32("GiuIaAGGsAXK",12) == 556105257) strcat(s, "s");
if (crc32("FifSlztyRk",10) == 2777916965) strcat(s, "r");
if (crc32("vMYkPmUrB",9) == 3658328449) strcat(s, "e");
if (crc32("BfjoDn",6) == 3425686797) strcat(s, "a");
if (crc32("XvOjxyjq",8) == 208542837) strcat(s, "b");
if (crc32("jaxdSI",6) == 3275542350) strcat(s, "l");
if (crc32("FfsjJdoayvvBSH",14) == 3432770119) strcat(s, "a");
if (crc32("xpEUtz",6) == 2455744068) strcat(s, "e");
    return s;
}

char *radical_adjectives() {
    char *s = calloc(8);
    if (crc32("esgitJMtDxTx",12) == 3633645448) strcat(s, "H");
if (crc32("RuZmTzMCaVZAnvd",15) == 1812329702) strcat(s, "r");
if (crc32("dMqcwY",6) == 1763689718) strcat(s, "a");
if (crc32("UawkUmhtJPQ",11) == 1388547765) strcat(s, "F");
if (crc32("XvLKV",5) == 1745918716) strcat(s, "d");
if (crc32("ydmuGgvVkVQg",12) == 1326925356) strcat(s, "i");
if (crc32("TINMgl",6) == 3210728423) strcat(s, "s");
if (crc32("cmBcMMWODsBBFK",14) == 4212804778) strcat(s, "c");
if (crc32("IsgOeuGD",8) == 3513372066) strcat(s, "a");
if (crc32("Vhcsh",5) == 2181670076) strcat(s, "l");
    return s;
}

char *neuroglic_adjectives() {
    char *s = calloc(10);
    if (crc32("ILLvA",5) == 1128132978) strcat(s, "n");
if (crc32("YkykLU",6) == 1641664613) strcat(s, "e");
if (crc32("WRLaKsIIiwBp",12) == 2372111542) strcat(s, "u");
if (crc32("jEClF",5) == 2638332777) strcat(s, "r");
if (crc32("evNMzUzq",8) == 114058389) strcat(s, "j");
if (crc32("btQjThiLlGD",11) == 1090948756) strcat(s, "o");
if (crc32("nCYetgtgT",9) == 2217711791) strcat(s, "g");
if (crc32("usTpBPUUyrFQjQ",14) == 39871731) strcat(s, "l");
if (crc32("FoIWmYZ",7) == 3773049109) strcat(s, "i");
if (crc32("sNOjHHjvSSCS",12) == 3335915437) strcat(s, "c");
    return s;
}

char *goddamned_adjectives() {
    char *s = calloc(10);
    if (crc32("ZVWLjjGgf",9) == 1886773994) strcat(s, "g");
if (crc32("HqYeZ",5) == 2373652827) strcat(s, "o");
if (crc32("PuHXkDqDW",9) == 695189167) strcat(s, "d");
if (crc32("ntvpj",5) == 3596217512) strcat(s, "d");
if (crc32("mkVIu",5) == 574756638) strcat(s, "a");
if (crc32("yrruunwPrM",10) == 443359185) strcat(s, "a");
if (crc32("Njjlu",5) == 3642616252) strcat(s, "m");
if (crc32("BQacm",5) == 2741375077) strcat(s, "n");
if (crc32("eAFwvNYrpjZumnE",15) == 1199888112) strcat(s, "e");
if (crc32("XvLQeOPwlXReLI",14) == 1957945661) strcat(s, "r");
if (crc32("QaAorreDgwY",11) == 1800992846) strcat(s, "d");
    return s;
}

char *oceanographic_adjectives() {
    char *s = calloc(14);
    if (crc32("vTYsRGMAG",9) == 2997864461) strcat(s, "o");
if (crc32("CHtGSh",6) == 335184282) strcat(s, "c");
if (crc32("QdafDkrXrXaVWU",14) == 1385337386) strcat(s, "e");
if (crc32("wuDYngyXlbV",11) == 1683662277) strcat(s, "k");
if (crc32("HUaSabEIqnRqM",13) == 651405499) strcat(s, "a");
if (crc32("wEicwUhptUDk",12) == 2897771633) strcat(s, "P");
if (crc32("IzSXRPKl",8) == 3282052541) strcat(s, "n");
if (crc32("oAZEQGAwkK",10) == 411746818) strcat(s, "H");
if (crc32("PWgLQqCys",9) == 1861150553) strcat(s, "o");
if (crc32("OvJTZdPlnQhwAqz",15) == 3974309904) strcat(s, "c");
if (crc32("hLTBvNVSySZAE",13) == 3941679712) strcat(s, "g");
if (crc32("cYZPBpyzUqBVkk",14) == 229967936) strcat(s, "r");
if (crc32("SbJFmFBOvYVxjk",14) == 1228099817) strcat(s, "a");
if (crc32("XAoDCnkIGsDP",12) == 297237291) strcat(s, "p");
if (crc32("fsppnwyeDoxs",12) == 1081827500) strcat(s, "j");
if (crc32("mHNFaWaao",9) == 1713283726) strcat(s, "h");
if (crc32("EERTnXStKGkK",12) == 3951145519) strcat(s, "i");
if (crc32("AUagrQMbRCHMMsZ",15) == 248142452) strcat(s, "c");
    return s;
}

char *amphitropous_adjectives() {
    char *s = calloc(13);
    if (crc32("kNFXMOUt",8) == 2951304946) strcat(s, "a");
if (crc32("TNXcBEA",7) == 2285122855) strcat(s, "L");
if (crc32("vlJbWeegDFzRzV",14) == 1636642207) strcat(s, "m");
if (crc32("XeBtFywRkzq",11) == 3508200953) strcat(s, "p");
if (crc32("PgWfVU",6) == 2067717417) strcat(s, "h");
if (crc32("LeDMcXWFiU",10) == 948156457) strcat(s, "q");
if (crc32("JAcMhnV",7) == 827165069) strcat(s, "i");
if (crc32("TAHMHXNhrEdhYaJ",15) == 999448427) strcat(s, "v");
if (crc32("LfMrQPohpCB",11) == 3509566944) strcat(s, "t");
if (crc32("iOAGPbWdjnYCQW",14) == 2010843643) strcat(s, "m");
if (crc32("UaafqjbyIh",10) == 3098126750) strcat(s, "r");
if (crc32("KLbhxoAih",9) == 835288552) strcat(s, "D");
if (crc32("NFaNaD",6) == 2817165461) strcat(s, "o");
if (crc32("jwjhEtxKFyh",11) == 3449743897) strcat(s, "p");
if (crc32("KZRpUkwKNRTMtL",14) == 3700054283) strcat(s, "o");
if (crc32("jiyvdGoaHUHC",12) == 260792070) strcat(s, "q");
if (crc32("pDxAh",5) == 3681515134) strcat(s, "u");
if (crc32("tLkkpJz",7) == 3094493885) strcat(s, "Z");
if (crc32("goYMozEdxmapz",13) == 2743932640) strcat(s, "s");
    return s;
}

char *freer_adjectives() {
    char *s = calloc(6);
    if (crc32("KwxmQAV",7) == 217294896) strcat(s, "c");
if (crc32("mvwXjashZa",10) == 3122094475) strcat(s, "f");
if (crc32("wkjYq",5) == 2286567086) strcat(s, "M");
if (crc32("mxWPu",5) == 4197198912) strcat(s, "r");
if (crc32("OZZMASiww",9) == 1117106825) strcat(s, "e");
if (crc32("KsFbTgNKSxYPIlS",15) == 3613977826) strcat(s, "p");
if (crc32("OylUbccmHYTfU",13) == 2529757338) strcat(s, "e");
if (crc32("ByPDzqFFsG",10) == 2946489877) strcat(s, "e");
if (crc32("uKXFIPsZh",9) == 714456329) strcat(s, "r");
    return s;
}

char *redundant_adjectives() {
    char *s = calloc(10);
    if (crc32("FfgCczYZyWLWr",13) == 111469631) strcat(s, "l");
if (crc32("kJUPrhowlhhK",12) == 2768240083) strcat(s, "r");
if (crc32("xsteDP",6) == 2775243215) strcat(s, "w");
if (crc32("MAZLMWRr",8) == 870022994) strcat(s, "e");
if (crc32("aPKjzLNoa",9) == 3609257655) strcat(s, "d");
if (crc32("MIyxKVYiLUwH",12) == 1944319534) strcat(s, "x");
if (crc32("XbGFua",6) == 2831434399) strcat(s, "u");
if (crc32("czNByaRb",8) == 271378114) strcat(s, "n");
if (crc32("ZWmGCekubWhcF",13) == 1435185724) strcat(s, "w");
if (crc32("cPApDzVGnRAWwG",14) == 803265761) strcat(s, "d");
if (crc32("RNeVWqMHbi",10) == 828303797) strcat(s, "a");
if (crc32("eTUasUsdoQhAx",13) == 3604224514) strcat(s, "i");
if (crc32("NyXnzfzn",8) == 3508073393) strcat(s, "n");
if (crc32("DKlOScwFObhcbAF",15) == 2784473582) strcat(s, "t");
    return s;
}

char *promotional_adjectives() {
    char *s = calloc(12);
    if (crc32("tohbaxMcyZxKG",13) == 2119065659) strcat(s, "p");
if (crc32("korSuRa",7) == 1840256117) strcat(s, "h");
if (crc32("GHeUfEB",7) == 189544267) strcat(s, "r");
if (crc32("inwZKQJw",8) == 4028064249) strcat(s, "o");
if (crc32("vOCXzWOX",8) == 3936315041) strcat(s, "v");
if (crc32("JzNfUpHkPcOkwe",14) == 2008361506) strcat(s, "m");
if (crc32("MgKQSVqsqLa",11) == 985332129) strcat(s, "s");
if (crc32("nwqHnfMDy",9) == 2162735478) strcat(s, "o");
if (crc32("MgkPdVRLDih",11) == 2022371864) strcat(s, "t");
if (crc32("iNASmohh",8) == 3262833068) strcat(s, "A");
if (crc32("YGuvVrF",7) == 2896000226) strcat(s, "i");
if (crc32("qSzLKMEfL",9) == 3679015926) strcat(s, "T");
if (crc32("VYPshmYryTzXi",13) == 2436645401) strcat(s, "o");
if (crc32("HAjQVjAz",8) == 598624853) strcat(s, "n");
if (crc32("NMKkpjo",7) == 4017374726) strcat(s, "a");
if (crc32("aAcvpNDSWUkN",12) == 508772965) strcat(s, "l");
    return s;
}

char *jerseyed_adjectives() {
    char *s = calloc(9);
    if (crc32("fvRjKeAGO",9) == 1184006379) strcat(s, "y");
if (crc32("JSKCJufQOJaOHwo",15) == 383373711) strcat(s, "j");
if (crc32("JkRelD",6) == 1711448373) strcat(s, "e");
if (crc32("UBWOsysllOLwstQ",15) == 3451087316) strcat(s, "Z");
if (crc32("YuNkhUwJJUC",11) == 3985692292) strcat(s, "r");
if (crc32("cVOSLmOtgpvPEpY",15) == 3580011718) strcat(s, "X");
if (crc32("UyjMCNazhVCai",13) == 1510826419) strcat(s, "s");
if (crc32("yUjBGAMTg",9) == 1990323575) strcat(s, "e");
if (crc32("fRClAuKDwvtbfl",14) == 1722210953) strcat(s, "y");
if (crc32("kyqzCxfYnKq",11) == 2353350607) strcat(s, "e");
if (crc32("KekJDYbQRhOaX",13) == 3549545317) strcat(s, "d");
    return s;
}

char *Navarrian_adjectives() {
    char *s = calloc(10);
    if (crc32("sFtSRYeuXhaNUv",14) == 1027730663) strcat(s, "u");
if (crc32("YfUHnaF",7) == 4207933277) strcat(s, "N");
if (crc32("tDUwjvadFbgOU",13) == 554832861) strcat(s, "a");
if (crc32("bqOMvCVZZY",10) == 4046515072) strcat(s, "q");
if (crc32("NeoESuRZFWINoB",14) == 2024806335) strcat(s, "v");
if (crc32("kNyQrkCFKrvio",13) == 3301486128) strcat(s, "a");
if (crc32("mMejRnnXRUNHLC",14) == 3913462220) strcat(s, "r");
if (crc32("jILWo",5) == 2731232440) strcat(s, "r");
if (crc32("gDAcGnayhRxvTL",14) == 4159831009) strcat(s, "s");
if (crc32("ybdIOQpQl",9) == 1697545181) strcat(s, "i");
if (crc32("MKukiRa",7) == 2312905797) strcat(s, "m");
if (crc32("awAJlSrbkZ",10) == 3413526149) strcat(s, "a");
if (crc32("zlrhJXooVhGiJY",14) == 1187412888) strcat(s, "u");
if (crc32("agtJdgN",7) == 2845944720) strcat(s, "n");
    return s;
}

char *kinematographic_adjectives() {
    char *s = calloc(16);
    if (crc32("RevTRSIoegBuXqB",15) == 1593295748) strcat(s, "q");
if (crc32("RYVGIANmdecHw",13) == 3227469891) strcat(s, "k");
if (crc32("TWBjLfiwac",10) == 2132679059) strcat(s, "s");
if (crc32("fZKXE",5) == 2096863828) strcat(s, "i");
if (crc32("NVSlEaMoeFV",11) == 3953284424) strcat(s, "n");
if (crc32("GGETxAsGvoO",11) == 363837262) strcat(s, "F");
if (crc32("iIQrO",5) == 571012708) strcat(s, "e");
if (crc32("eytlArr",7) == 766668142) strcat(s, "a");
if (crc32("KuTqGIKI",8) == 2569913585) strcat(s, "m");
if (crc32("ZOclS",5) == 105724288) strcat(s, "a");
if (crc32("EmLvnhEo",8) == 755514524) strcat(s, "t");
if (crc32("jwKGey",6) == 76033690) strcat(s, "q");
if (crc32("QTssBvuaqO",10) == 2483851960) strcat(s, "o");
if (crc32("WkXahkRMdeZ",11) == 3957547043) strcat(s, "g");
if (crc32("liRnGgLGFgnPEvT",15) == 2266152592) strcat(s, "I");
if (crc32("KUpfuz",6) == 3780319528) strcat(s, "r");
if (crc32("moFTkauLa",9) == 2870077358) strcat(s, "a");
if (crc32("KUfdAvcnvJ",10) == 3796391245) strcat(s, "p");
if (crc32("izQVIHv",7) == 1013180833) strcat(s, "h");
if (crc32("JApSbWXBhh",10) == 1098072397) strcat(s, "i");
if (crc32("ZaenxEFqtJjq",12) == 3403261271) strcat(s, "c");
    return s;
}

char *sharpedged_adjectives() {
    char *s = calloc(11);
    if (crc32("koNDxs",6) == 1382388835) strcat(s, "o");
if (crc32("tPpBOF",6) == 3911020514) strcat(s, "s");
if (crc32("hPIYbLhmhSMVW",13) == 2715466473) strcat(s, "I");
if (crc32("zsptFbYgwY",10) == 3424629039) strcat(s, "h");
if (crc32("HNjWowqN",8) == 4259144799) strcat(s, "m");
if (crc32("uVhqTKa",7) == 3248976129) strcat(s, "a");
if (crc32("fqnayJZ",7) == 3403967797) strcat(s, "r");
if (crc32("sRpVv",5) == 1901041921) strcat(s, "K");
if (crc32("KzoIL",5) == 4040797015) strcat(s, "p");
if (crc32("xQEHz",5) == 3093490667) strcat(s, "x");
if (crc32("HOaHSExIB",9) == 2378586796) strcat(s, "e");
if (crc32("vKWcQYyTmqjliGn",15) == 3013101418) strcat(s, "U");
if (crc32("fRqwJhqPojB",11) == 1617083052) strcat(s, "d");
if (crc32("yqWyRuCMwEZj",12) == 388242717) strcat(s, "g");
if (crc32("WbYfwskQHnUf",12) == 844611552) strcat(s, "e");
if (crc32("bvRcAwYVL",9) == 2802488222) strcat(s, "Q");
if (crc32("LAFxGJSoyf",10) == 1586601349) strcat(s, "d");
    return s;
}

char *capitular_adjectives() {
    char *s = calloc(10);
    if (crc32("ViQHJVErs",9) == 272472463) strcat(s, "c");
if (crc32("UFvbVZGl",8) == 365406160) strcat(s, "a");
if (crc32("iMkHIxbsPa",10) == 3181588958) strcat(s, "p");
if (crc32("tvIJQqmDiPitm",13) == 2177969861) strcat(s, "i");
if (crc32("WWGbcfuUZPdLu",13) == 31187942) strcat(s, "H");
if (crc32("ThZMDG",6) == 801142953) strcat(s, "t");
if (crc32("gybGRst",7) == 3097250687) strcat(s, "L");
if (crc32("iWIkXUj",7) == 587856482) strcat(s, "u");
if (crc32("PqZRKIkZzHOXYI",14) == 2123929513) strcat(s, "l");
if (crc32("dFPoUUdFGCEBx",13) == 3762397216) strcat(s, "d");
if (crc32("xqPRlRUcG",9) == 1589836111) strcat(s, "a");
if (crc32("nwvyXkkHZ",9) == 1685111335) strcat(s, "r");
    return s;
}

char *masturbatory_adjectives() {
    char *s = calloc(13);
    if (crc32("fNHbFlIpDG",10) == 2230391464) strcat(s, "m");
if (crc32("WAEzJadmHaXNs",13) == 1284262377) strcat(s, "V");
if (crc32("mbfpI",5) == 1523207225) strcat(s, "a");
if (crc32("aCvXweZDXH",10) == 3785406688) strcat(s, "q");
if (crc32("LXsJRVVOLjxKs",13) == 3295755185) strcat(s, "s");
if (crc32("BlZaNTwnXpOsADp",15) == 4223653952) strcat(s, "t");
if (crc32("OYhQtgWA",8) == 2682427643) strcat(s, "u");
if (crc32("WRKJVhCUHruk",12) == 583572996) strcat(s, "N");
if (crc32("PhdFAHtd",8) == 2418422811) strcat(s, "r");
if (crc32("xsNKeBoBGHoB",12) == 1880373343) strcat(s, "b");
if (crc32("nudejlnbg",9) == 747813965) strcat(s, "R");
if (crc32("WDNmFu",6) == 2964487464) strcat(s, "a");
if (crc32("NscTvPNbIyhX",12) == 1017919018) strcat(s, "p");
if (crc32("LzboyKF",7) == 3822783512) strcat(s, "t");
if (crc32("sfUlVpaic",9) == 140055019) strcat(s, "D");
if (crc32("YMmxKlLqWveIJA",14) == 2812062354) strcat(s, "o");
if (crc32("vGdBSpw",7) == 3391936402) strcat(s, "J");
if (crc32("qHmrAi",6) == 1510627351) strcat(s, "r");
if (crc32("kWuFvXOyReeS",12) == 2067899921) strcat(s, "y");
    return s;
}

char *palaverous_adjectives() {
    char *s = calloc(11);
    if (crc32("mizsceVXa",9) == 904494237) strcat(s, "U");
if (crc32("rQgXtZi",7) == 589358480) strcat(s, "p");
if (crc32("bZTdTKVurQD",11) == 232892041) strcat(s, "H");
if (crc32("svpDgJvf",8) == 1750893298) strcat(s, "a");
if (crc32("DUboKzCh",8) == 1778932917) strcat(s, "l");
if (crc32("yzWzwSdXE",9) == 1645381834) strcat(s, "a");
if (crc32("SmLxTyMqGmzNbd",14) == 3063152135) strcat(s, "v");
if (crc32("qGQmZRaxFfkXWeZ",15) == 3730227903) strcat(s, "e");
if (crc32("YDUecCr",7) == 1628270087) strcat(s, "V");
if (crc32("DOjwObo",7) == 122453621) strcat(s, "r");
if (crc32("yFlPtXlGkXLwB",13) == 438377630) strcat(s, "o");
if (crc32("yeiMHNAaww",10) == 3576714798) strcat(s, "u");
if (crc32("AyqQL",5) == 2850280191) strcat(s, "F");
if (crc32("crIDiOLADoTOV",13) == 1506833928) strcat(s, "s");
    return s;
}

char *unpendant_adjectives() {
    char *s = calloc(10);
    if (crc32("uxFRGuaFIn",10) == 3162175743) strcat(s, "u");
if (crc32("oQCkDEn",7) == 2225322168) strcat(s, "n");
if (crc32("TMGIVSRoBrnqQ",13) == 3915032692) strcat(s, "p");
if (crc32("NeoVNuTMIESptY",14) == 1047546974) strcat(s, "L");
if (crc32("POeJcB",6) == 3222827315) strcat(s, "e");
if (crc32("cDkfQBk",7) == 2072255568) strcat(s, "T");
if (crc32("HHmBjQKON",9) == 3954422012) strcat(s, "n");
if (crc32("ukPLkLSqQSmoo",13) == 3703343977) strcat(s, "d");
if (crc32("BvSaJJVfdDrepXa",15) == 1929082674) strcat(s, "a");
if (crc32("UXNhjKrcsZr",11) == 2512589868) strcat(s, "n");
if (crc32("tGYQWczFMGN",11) == 3317141298) strcat(s, "l");
if (crc32("cRJajtTx",8) == 49758701) strcat(s, "t");
    return s;
}

char *germinable_adjectives() {
    char *s = calloc(11);
    if (crc32("bLGlDEAUu",9) == 2205578027) strcat(s, "g");
if (crc32("XUnvRbMtgOrjvkf",15) == 424407085) strcat(s, "o");
if (crc32("GWpUhEsmDEn",11) == 3795640409) strcat(s, "e");
if (crc32("PFeeEqb",7) == 3646629724) strcat(s, "r");
if (crc32("uXCzbfnolaLNCT",14) == 3625392182) strcat(s, "F");
if (crc32("AHiZrTg",7) == 4143776733) strcat(s, "m");
if (crc32("NlGnUT",6) == 923986593) strcat(s, "i");
if (crc32("BSZDZzTOkBFAwSQ",15) == 2842925750) strcat(s, "n");
if (crc32("VXqrwXWSELX",11) == 1934521981) strcat(s, "C");
if (crc32("ZSFBBIVB",8) == 1924062594) strcat(s, "a");
if (crc32("psQeMqzq",8) == 1282274673) strcat(s, "b");
if (crc32("aHnFECm",7) == 41388213) strcat(s, "X");
if (crc32("BymlJXeWJJBrEt",14) == 2665157376) strcat(s, "l");
if (crc32("fUvzkKI",7) == 55976265) strcat(s, "e");
    return s;
}

char *ceremonial_adjectives() {
    char *s = calloc(11);
    if (crc32("SrvpSoIwu",9) == 357064884) strcat(s, "z");
if (crc32("jmeVVSGKWIQGz",13) == 684140515) strcat(s, "c");
if (crc32("HNrxbOWCtxlQO",13) == 960058432) strcat(s, "e");
if (crc32("NqFFLJoXQ",9) == 546128213) strcat(s, "d");
if (crc32("pQiNNkq",7) == 2184232249) strcat(s, "r");
if (crc32("spTwNbWvO",9) == 3268667671) strcat(s, "e");
if (crc32("kqOqdGl",7) == 1767999017) strcat(s, "m");
if (crc32("YfUEFd",6) == 3931080456) strcat(s, "o");
if (crc32("JBJwG",5) == 280433751) strcat(s, "n");
if (crc32("TLfxat",6) == 4157511063) strcat(s, "D");
if (crc32("HycgEkNzkznJdUK",15) == 1141686736) strcat(s, "i");
if (crc32("uyCWFluCAUEbp",13) == 1559114491) strcat(s, "m");
if (crc32("QZGfKuIzcXYlw",13) == 1503429048) strcat(s, "a");
if (crc32("vVxOzvGHQDGLD",13) == 2703085359) strcat(s, "F");
if (crc32("KDMPBbbyDKzfKC",14) == 2029140465) strcat(s, "l");
    return s;
}

char *factitive_adjectives() {
    char *s = calloc(10);
    if (crc32("oStRvKbiFT",10) == 970851736) strcat(s, "H");
if (crc32("bywfxS",6) == 2936688971) strcat(s, "f");
if (crc32("VfMMuR",6) == 614087323) strcat(s, "f");
if (crc32("xMGqDEPlHDuFI",13) == 2663080517) strcat(s, "a");
if (crc32("QklJvLhJQ",9) == 454712434) strcat(s, "c");
if (crc32("ujiHb",5) == 2140256787) strcat(s, "t");
if (crc32("sSjxsNap",8) == 3479398509) strcat(s, "E");
if (crc32("SdlykvLdft",10) == 2699080210) strcat(s, "i");
if (crc32("CmGyrusjakZNT",13) == 692688109) strcat(s, "t");
if (crc32("YnaTBSLXWVlN",12) == 2793746810) strcat(s, "i");
if (crc32("KbYozkLW",8) == 538031281) strcat(s, "X");
if (crc32("oQRCZ",5) == 2434998708) strcat(s, "v");
if (crc32("VKJCkffGTgbDTYg",15) == 4121042432) strcat(s, "y");
if (crc32("nvnbBtMZ",8) == 1383799662) strcat(s, "e");
    return s;
}

char *euphonic_adjectives() {
    char *s = calloc(9);
    if (crc32("IhAhKdg",7) == 1164878835) strcat(s, "w");
if (crc32("RVXWah",6) == 521313984) strcat(s, "e");
if (crc32("yOvvr",5) == 1720051530) strcat(s, "u");
if (crc32("gHDduF",6) == 1525631049) strcat(s, "p");
if (crc32("WdGji",5) == 3941550077) strcat(s, "n");
if (crc32("jEtiDUPL",8) == 2373652721) strcat(s, "h");
if (crc32("eVAWz",5) == 3635033511) strcat(s, "T");
if (crc32("FXIeAWk",7) == 1572060186) strcat(s, "o");
if (crc32("grziGMC",7) == 900300932) strcat(s, "b");
if (crc32("knfmnSNN",8) == 3333952834) strcat(s, "n");
if (crc32("adBcF",5) == 3213753282) strcat(s, "A");
if (crc32("OmFnGGzNUA",10) == 1433610450) strcat(s, "i");
if (crc32("GhtDiTNsFYlA",12) == 796547264) strcat(s, "c");
    return s;
}

char *antirevolution_adjectives() {
    char *s = calloc(15);
    if (crc32("tpjBqU",6) == 3523456446) strcat(s, "a");
if (crc32("lbEtTjNElDSr",12) == 177003913) strcat(s, "e");
if (crc32("mcnrv",5) == 1748317531) strcat(s, "n");
if (crc32("hyXCoVRHTGN",11) == 599069869) strcat(s, "U");
if (crc32("xRMHkQNzJ",9) == 3626543811) strcat(s, "t");
if (crc32("drKvAbHAWpGy",12) == 4167046516) strcat(s, "i");
if (crc32("WAAIDAXdSRrvada",15) == 3051501720) strcat(s, "r");
if (crc32("qHDFFwVxfqA",11) == 3863716843) strcat(s, "e");
if (crc32("vViTL",5) == 1016492912) strcat(s, "b");
if (crc32("RwvUdzpy",8) == 2644661932) strcat(s, "v");
if (crc32("UttiMwu",7) == 236837934) strcat(s, "o");
if (crc32("SZoMFmMqP",9) == 2633639498) strcat(s, "l");
if (crc32("AHNOZt",6) == 3957477651) strcat(s, "X");
if (crc32("NjnkLSgW",8) == 3395582512) strcat(s, "u");
if (crc32("SmNRS",5) == 2578236442) strcat(s, "s");
if (crc32("xuYKjbI",7) == 2107183393) strcat(s, "t");
if (crc32("kaovCeYtzVZiV",13) == 1043382734) strcat(s, "i");
if (crc32("TiFugehKp",9) == 1484894835) strcat(s, "o");
if (crc32("rAOgmbLCLmJNdxU",15) == 1595857981) strcat(s, "n");
    return s;
}

char *vortical_adjectives() {
    char *s = calloc(9);
    if (crc32("lgRGTt",6) == 2022225094) strcat(s, "v");
if (crc32("TtoNROHHH",9) == 1176725939) strcat(s, "Z");
if (crc32("Akucjnm",7) == 2294250562) strcat(s, "o");
if (crc32("qORNCJJ",7) == 3324601795) strcat(s, "Y");
if (crc32("IQiIGzTgPB",10) == 1889165329) strcat(s, "r");
if (crc32("FAxDK",5) == 1752416551) strcat(s, "z");
if (crc32("Ewxrkk",6) == 3291218) strcat(s, "t");
if (crc32("IIDwPPKmVQJapSd",15) == 992641687) strcat(s, "J");
if (crc32("VeXERqipZLSZi",13) == 1022850462) strcat(s, "i");
if (crc32("nmgVpVuErVKmz",13) == 1936644545) strcat(s, "c");
if (crc32("oimCM",5) == 140039824) strcat(s, "a");
if (crc32("FnyNkEBtJgMZUU",14) == 2938865986) strcat(s, "W");
if (crc32("fAMLOIWmrv",10) == 3741245856) strcat(s, "l");
    return s;
}

char *unendorsable_adjectives() {
    char *s = calloc(13);
    if (crc32("WcLOOxAlhC",10) == 115701050) strcat(s, "u");
if (crc32("GDuMhttZP",9) == 221747517) strcat(s, "R");
if (crc32("YxssheamV",9) == 2844764158) strcat(s, "n");
if (crc32("iwegpekaDIMK",12) == 1788901148) strcat(s, "e");
if (crc32("epJjV",5) == 2631454790) strcat(s, "n");
if (crc32("aCOwhozO",8) == 936774210) strcat(s, "d");
if (crc32("eyoWdqwrLq",10) == 3933820521) strcat(s, "o");
if (crc32("zDdawvdYsko",11) == 3727025596) strcat(s, "r");
if (crc32("GMgDCxTjfXaj",12) == 3910128462) strcat(s, "R");
if (crc32("NWDMaNYTkfpADSL",15) == 1809331604) strcat(s, "s");
if (crc32("AuwCkoi",7) == 1948613784) strcat(s, "a");
if (crc32("zPDWDv",6) == 359662390) strcat(s, "R");
if (crc32("DCySTkdnUUAWg",13) == 1453147261) strcat(s, "b");
if (crc32("IXXuYzkMMa",10) == 3957501875) strcat(s, "k");
if (crc32("uwnPluJffttlK",13) == 2859153461) strcat(s, "l");
if (crc32("kzVKJXcUM",9) == 2233530840) strcat(s, "v");
if (crc32("tDXdTyQZTOEDhEK",15) == 2683967976) strcat(s, "e");
    return s;
}

char *wellpaved_adjectives() {
    char *s = calloc(10);
    if (crc32("krRWGHAapr",10) == 1456430643) strcat(s, "X");
if (crc32("YgOmLayJAfpOBr",14) == 3504389173) strcat(s, "w");
if (crc32("lkyffaPNfWKU",12) == 3144510414) strcat(s, "L");
if (crc32("MVCuawPTjjHjNEC",15) == 115268279) strcat(s, "e");
if (crc32("HLYYQTrwiYShyV",14) == 1643004330) strcat(s, "l");
if (crc32("vNSjSAOROuq",11) == 2491808569) strcat(s, "l");
if (crc32("hQdxrRtdgJzDTLt",15) == 3388619088) strcat(s, "p");
if (crc32("PJAabr",6) == 745696966) strcat(s, "a");
if (crc32("wXqtS",5) == 188707771) strcat(s, "E");
if (crc32("MRGRgknMhN",10) == 663803097) strcat(s, "v");
if (crc32("UVYxkZG",7) == 1102090849) strcat(s, "e");
if (crc32("RnvVewJIAivrMD",14) == 252979079) strcat(s, "d");
    return s;
}

char *undisclosed_adjectives() {
    char *s = calloc(12);
    if (crc32("EkszQqZjQPIXfAD",15) == 605694733) strcat(s, "u");
if (crc32("mXfkFcfKV",9) == 2556949278) strcat(s, "s");
if (crc32("UnFvVC",6) == 649332784) strcat(s, "n");
if (crc32("OIcKyGZZMP",10) == 3061542035) strcat(s, "v");
if (crc32("uLJjgDaPqmAycp",14) == 3091157317) strcat(s, "d");
if (crc32("fGGBHBXEF",9) == 9724983) strcat(s, "i");
if (crc32("ZgyYxexhffRCwkd",15) == 3005607970) strcat(s, "e");
if (crc32("VcNSioslRJzTfft",15) == 126635535) strcat(s, "s");
if (crc32("PniEElTIKPYzN",13) == 3152822574) strcat(s, "c");
if (crc32("ePYzev",6) == 3012129863) strcat(s, "W");
if (crc32("LdqwomHMrtkNm",13) == 1510747151) strcat(s, "l");
if (crc32("cepJDyar",8) == 1980923929) strcat(s, "o");
if (crc32("rXhuYF",6) == 2804285068) strcat(s, "s");
if (crc32("vVcfmLpif",9) == 1718994469) strcat(s, "e");
if (crc32("MQIuvgTD",8) == 2280706173) strcat(s, "j");
if (crc32("zsonNnIft",9) == 3387240675) strcat(s, "d");
    return s;
}

char *phlegmy_adjectives() {
    char *s = calloc(8);
    if (crc32("GGDMxGVZpwGPMJ",14) == 3032309022) strcat(s, "f");
if (crc32("cNmevTdEsQkL",12) == 3247323825) strcat(s, "p");
if (crc32("kBQOy",5) == 714866466) strcat(s, "h");
if (crc32("tnbpe",5) == 437281576) strcat(s, "o");
if (crc32("gaiEhTsqBgwRJK",14) == 1739520133) strcat(s, "l");
if (crc32("XPNfHHzsKNS",11) == 2926198411) strcat(s, "e");
if (crc32("fhvmWxH",7) == 861089206) strcat(s, "w");
if (crc32("sgJbrthB",8) == 3823460318) strcat(s, "g");
if (crc32("fCJdrwBStM",10) == 235504837) strcat(s, "m");
if (crc32("juasW",5) == 4048127786) strcat(s, "y");
    return s;
}

char *wellverified_adjectives() {
    char *s = calloc(13);
    if (crc32("QejVM",5) == 1852153694) strcat(s, "w");
if (crc32("XARaVHNeYCjsh",13) == 1995800394) strcat(s, "L");
if (crc32("pLIZXvUHX",9) == 1699647544) strcat(s, "e");
if (crc32("qBltSKOYPC",10) == 1796455079) strcat(s, "D");
if (crc32("tnOvHKNgn",9) == 1060831987) strcat(s, "l");
if (crc32("gmFJMZ",6) == 3364531176) strcat(s, "l");
if (crc32("cCtSTqCeJoTtQe",14) == 2921638102) strcat(s, "J");
if (crc32("cxELkfEB",8) == 2482410630) strcat(s, "v");
if (crc32("YMbkJROasZAwjTo",15) == 180229348) strcat(s, "j");
if (crc32("coJhIUuMGTQFM",13) == 531703233) strcat(s, "e");
if (crc32("tOoRbSsmBOpnvHa",15) == 815681576) strcat(s, "r");
if (crc32("RqOVnH",6) == 4157580288) strcat(s, "j");
if (crc32("ughxgjCnRxUsnl",14) == 3177150237) strcat(s, "i");
if (crc32("pRcYjVlNyOWdqx",14) == 4057725982) strcat(s, "M");
if (crc32("CxFNY",5) == 2141202270) strcat(s, "f");
if (crc32("TuyqpChzZlZ",11) == 3065472172) strcat(s, "F");
if (crc32("FSDiy",5) == 576505554) strcat(s, "i");
if (crc32("wXVHGifuLRAJQt",14) == 1326129096) strcat(s, "v");
if (crc32("dkUWfdThh",9) == 766503588) strcat(s, "e");
if (crc32("ErnmG",5) == 3987042240) strcat(s, "d");
    return s;
}

char *columbous_adjectives() {
    char *s = calloc(10);
    if (crc32("cnAcQzvkMqXwi",13) == 3719176664) strcat(s, "C");
if (crc32("eNINZcmIEEJHLne",15) == 1314813652) strcat(s, "c");
if (crc32("yzOugbPnwzFf",12) == 4059912295) strcat(s, "f");
if (crc32("rzedwPGh",8) == 2445348792) strcat(s, "o");
if (crc32("iouFz",5) == 3627375750) strcat(s, "Q");
if (crc32("ECrlrQyWJIvcwcV",15) == 498596617) strcat(s, "l");
if (crc32("HHCONdpAmbajR",13) == 1811114511) strcat(s, "a");
if (crc32("iKUoYwhpyRkQ",12) == 2048499794) strcat(s, "u");
if (crc32("CpoYjPzgKpg",11) == 2041905452) strcat(s, "j");
if (crc32("hFFyMQN",7) == 2000054371) strcat(s, "m");
if (crc32("mHqDgJywNWOmMRy",15) == 2325754724) strcat(s, "b");
if (crc32("iuSdlnkmf",9) == 3290099193) strcat(s, "o");
if (crc32("YJSHciGuf",9) == 1784881410) strcat(s, "u");
if (crc32("hdfTqsGjbVSAh",13) == 1559181109) strcat(s, "s");
    return s;
}

char *subbranchial_adjectives() {
    char *s = calloc(13);
    if (crc32("JVnpoyS",7) == 2783525375) strcat(s, "s");
if (crc32("IJJHvMZqNF",10) == 2029924629) strcat(s, "u");
if (crc32("oSxDpOLSODD",11) == 3566992224) strcat(s, "b");
if (crc32("TkeuLyQduBeDs",13) == 2315104032) strcat(s, "Y");
if (crc32("LZydfAyqZFBpzg",14) == 630208989) strcat(s, "b");
if (crc32("iZmtFhzhBxFccls",15) == 1651395079) strcat(s, "r");
if (crc32("JllFglPx",8) == 3439491569) strcat(s, "d");
if (crc32("erIrpyf",7) == 2550148187) strcat(s, "a");
if (crc32("dAKjWuPnwS",10) == 3563434270) strcat(s, "G");
if (crc32("yxjsbKeOCDr",11) == 1395997442) strcat(s, "n");
if (crc32("JzZYRGn",7) == 485913741) strcat(s, "N");
if (crc32("QfYQIoJl",8) == 3510631420) strcat(s, "c");
if (crc32("gJTrbskyT",9) == 3139903300) strcat(s, "h");
if (crc32("adfSHYlJ",8) == 3305678638) strcat(s, "i");
if (crc32("ErUZclhHz",9) == 559393563) strcat(s, "a");
if (crc32("qwUUjKVmRupAXj",14) == 2589003111) strcat(s, "l");
    return s;
}

char *unacrimonious_adjectives() {
    char *s = calloc(14);
    if (crc32("okqBIuebHmzoGQm",15) == 1983538620) strcat(s, "u");
if (crc32("kvrjJYwzbdKKdD",14) == 2731876814) strcat(s, "n");
if (crc32("pXAzcYsekbRWRp",14) == 2446854235) strcat(s, "a");
if (crc32("QLwkA",5) == 3305065308) strcat(s, "c");
if (crc32("qWYjbznYoOVff",13) == 2107416412) strcat(s, "r");
if (crc32("KJEqRUkfts",10) == 1989785613) strcat(s, "i");
if (crc32("BLTYvDpkgre",11) == 692749474) strcat(s, "f");
if (crc32("adjNN",5) == 1827309918) strcat(s, "m");
if (crc32("RrIjBnhP",8) == 3182508538) strcat(s, "u");
if (crc32("csobHMC",7) == 4098020455) strcat(s, "o");
if (crc32("GYkNTzN",7) == 2560305710) strcat(s, "v");
if (crc32("FyJFMaSGikQOWwm",15) == 3901626959) strcat(s, "n");
if (crc32("LnyWSVt",7) == 1532151010) strcat(s, "i");
if (crc32("KxznOt",6) == 3743666843) strcat(s, "q");
if (crc32("vbkjLSbqnOrLsJ",14) == 2474258917) strcat(s, "o");
if (crc32("kBQnYBfZItzy",12) == 307765576) strcat(s, "u");
if (crc32("hKWXJuJMOprgMv",14) == 1147384120) strcat(s, "E");
if (crc32("MiEvFFRmPBzAh",13) == 2757742996) strcat(s, "s");
    return s;
}

char *postsuppurative_adjectives() {
    char *s = calloc(16);
    if (crc32("NcmJrwPPVoYxkBb",15) == 27108662) strcat(s, "p");
if (crc32("vTYEWvyYaPA",11) == 3703032370) strcat(s, "m");
if (crc32("qvtDbTGw",8) == 1013161617) strcat(s, "o");
if (crc32("ncKpQXsYn",9) == 865415494) strcat(s, "D");
if (crc32("SePdtDBbldcw",12) == 780899583) strcat(s, "s");
if (crc32("rleaCgkoKpnk",12) == 1007970013) strcat(s, "t");
if (crc32("yCTOwkqqBdZGg",13) == 2211073821) strcat(s, "I");
if (crc32("VDtiiBPZiQ",10) == 3984005853) strcat(s, "s");
if (crc32("csfguUd",7) == 3308133845) strcat(s, "u");
if (crc32("KGxRRfx",7) == 1675257855) strcat(s, "p");
if (crc32("MyEjdzhlEdR",11) == 1219639386) strcat(s, "T");
if (crc32("kQTBuHEglgXam",13) == 2270108452) strcat(s, "p");
if (crc32("SJNNJUqONpWI",12) == 2488900686) strcat(s, "u");
if (crc32("RqkhAxds",8) == 1117305805) strcat(s, "r");
if (crc32("SGyKlHjH",8) == 4264615942) strcat(s, "r");
if (crc32("tRTzkb",6) == 1528739252) strcat(s, "a");
if (crc32("dSefKqdqbSO",11) == 3694960769) strcat(s, "t");
if (crc32("yieTAWRJFAk",11) == 102407777) strcat(s, "i");
if (crc32("rECKQ",5) == 2496080008) strcat(s, "v");
if (crc32("GxwTXHOyQQh",11) == 2262230379) strcat(s, "e");
    return s;
}

char *preAryan_adjectives() {
    char *s = calloc(9);
    if (crc32("qnXndnr",7) == 1018977076) strcat(s, "p");
if (crc32("LMEBlPjwmu",10) == 1208236752) strcat(s, "r");
if (crc32("bURjF",5) == 838545344) strcat(s, "g");
if (crc32("kkHJoiUkAeXTpHY",15) == 1712522287) strcat(s, "e");
if (crc32("OQHshFy",7) == 2440625185) strcat(s, "P");
if (crc32("SDWUAFUPl",9) == 4111728915) strcat(s, "A");
if (crc32("CnbzvaVUVuCWEo",14) == 233729538) strcat(s, "o");
if (crc32("ngYbDIfJKjO",11) == 1767362119) strcat(s, "r");
if (crc32("PuynmxqI",8) == 3823622776) strcat(s, "s");
if (crc32("LPnMisFIavKOa",13) == 2077261315) strcat(s, "y");
if (crc32("FhINeMOO",8) == 261153555) strcat(s, "g");
if (crc32("LsvtwvkyQyFpN",13) == 281747431) strcat(s, "a");
if (crc32("vncRDvtYgWVyZhp",15) == 3479102521) strcat(s, "n");
    return s;
}

char *presbyterian_adjectives() {
    char *s = calloc(13);
    if (crc32("MzcwTVMtDkgY",12) == 1519313612) strcat(s, "B");
if (crc32("cHmvZheHxXd",11) == 3873439921) strcat(s, "p");
if (crc32("srUfAoBPkyxen",13) == 1648407147) strcat(s, "l");
if (crc32("lExEEJinEu",10) == 822255964) strcat(s, "r");
if (crc32("AtVaXBuyKOpe",12) == 977074875) strcat(s, "F");
if (crc32("lvGuQVFVkSsuqZ",14) == 3587160367) strcat(s, "e");
if (crc32("MnnGkPth",8) == 2147708347) strcat(s, "W");
if (crc32("OpCmlSewwSmhYwO",15) == 1953276916) strcat(s, "s");
if (crc32("gRvCRQvsAikt",12) == 1608665045) strcat(s, "b");
if (crc32("JZJKvopPNztt",12) == 4104764323) strcat(s, "y");
if (crc32("jSuQwKKUxjVVpq",14) == 3373875770) strcat(s, "t");
if (crc32("zLroloViIohnsHk",15) == 2149934472) strcat(s, "c");
if (crc32("DrQTfIktWNwqF",13) == 3129613872) strcat(s, "e");
if (crc32("ZVttNJhmTwr",11) == 2951774913) strcat(s, "r");
if (crc32("ckWvnDmAOzFJ",12) == 4277753790) strcat(s, "z");
if (crc32("HXAwVFwZAqEEX",13) == 2470567287) strcat(s, "i");
if (crc32("xwZbEntWB",9) == 2483688204) strcat(s, "N");
if (crc32("MWBOWeKchAoZt",13) == 3299518962) strcat(s, "a");
if (crc32("xGxcOfzmCyupoG",14) == 797494719) strcat(s, "w");
if (crc32("xBcvMTFVjmVvF",13) == 2518835138) strcat(s, "n");
    return s;
}

char *Levitical_adjectives() {
    char *s = calloc(10);
    if (crc32("BDDYOcxZmUrVCPz",15) == 4066442117) strcat(s, "m");
if (crc32("dunHkdgYlfAkDF",14) == 265741254) strcat(s, "L");
if (crc32("FYmuWqzBGrRZ",12) == 3305367379) strcat(s, "f");
if (crc32("HdbaWzt",7) == 4073586955) strcat(s, "e");
if (crc32("caJVlGN",7) == 1999553150) strcat(s, "v");
if (crc32("JGxKn",5) == 2815999228) strcat(s, "c");
if (crc32("EqhiyZ",6) == 3862078997) strcat(s, "i");
if (crc32("GGlLINjoQuyz",12) == 3429696306) strcat(s, "t");
if (crc32("MogVFN",6) == 3772858657) strcat(s, "i");
if (crc32("bzoGXfZa",8) == 450256815) strcat(s, "e");
if (crc32("oLAjkT",6) == 1501888331) strcat(s, "c");
if (crc32("mGxGjLdfA",9) == 3661974403) strcat(s, "a");
if (crc32("aCLsrPmkRbf",11) == 4093058890) strcat(s, "l");
    return s;
}

char *nonpassionate_adjectives() {
    char *s = calloc(14);
    if (crc32("YCkXGJlqTLMiLx",14) == 1444716246) strcat(s, "z");
if (crc32("DnUccNYeKyyghT",14) == 2766329935) strcat(s, "n");
if (crc32("OkqVvQDvfT",10) == 2480100835) strcat(s, "C");
if (crc32("ZwrSpwYPz",9) == 808539191) strcat(s, "o");
if (crc32("tUzuzOFWH",9) == 4277453994) strcat(s, "p");
if (crc32("bqSsHDOMzJkAXuw",15) == 820060360) strcat(s, "n");
if (crc32("EKFTjyqgI",9) == 50659382) strcat(s, "p");
if (crc32("KlguNtiuaF",10) == 483047343) strcat(s, "m");
if (crc32("WaRBrNwKCyRe",12) == 1266189061) strcat(s, "a");
if (crc32("nzurV",5) == 3989904414) strcat(s, "i");
if (crc32("HeWGaZvkfBAtXg",14) == 280647953) strcat(s, "s");
if (crc32("kqhDdARcQWp",11) == 3554019683) strcat(s, "w");
if (crc32("JiWZHfiD",8) == 1997370744) strcat(s, "s");
if (crc32("dxvpt",5) == 741373650) strcat(s, "i");
if (crc32("kfAmsfBKr",9) == 3145429770) strcat(s, "x");
if (crc32("hHNHq",5) == 1416011566) strcat(s, "o");
if (crc32("VfnAMLGAyb",10) == 2820306242) strcat(s, "a");
if (crc32("WaOlECsnNItnJNJ",15) == 3570923196) strcat(s, "n");
if (crc32("bNzdwIgZedA",11) == 2222950031) strcat(s, "t");
if (crc32("VpGAsGO",7) == 282912505) strcat(s, "a");
if (crc32("BrinxpK",7) == 1150492930) strcat(s, "B");
if (crc32("oVOtQylt",8) == 1744954835) strcat(s, "t");
if (crc32("AZBTjQNyqa",10) == 1039751582) strcat(s, "X");
if (crc32("zcxOuDx",7) == 3375372094) strcat(s, "e");
    return s;
}

char *nuggety_adjectives() {
    char *s = calloc(8);
    if (crc32("WtSJyyW",7) == 811933669) strcat(s, "n");
if (crc32("UuMDQCIKznRRe",13) == 3916739977) strcat(s, "u");
if (crc32("tivySnHUcHuZsN",14) == 3863901806) strcat(s, "g");
if (crc32("VgITrKzHbo",10) == 1295028310) strcat(s, "Q");
if (crc32("yxgZFnzSZ",9) == 1773978845) strcat(s, "g");
if (crc32("SukOauzUCwd",11) == 1685399038) strcat(s, "S");
if (crc32("EmRCifnVEF",10) == 3424979094) strcat(s, "e");
if (crc32("HYjiTGgxeqxX",12) == 1286781423) strcat(s, "E");
if (crc32("ZiIQnehj",8) == 124282012) strcat(s, "t");
if (crc32("qfBSOh",6) == 2185084359) strcat(s, "g");
if (crc32("FCuIChZBMpwPj",13) == 337752542) strcat(s, "y");
    return s;
}

char *granulocytic_adjectives() {
    char *s = calloc(13);
    if (crc32("boCZffFle",9) == 3440976338) strcat(s, "g");
if (crc32("DUBTNZ",6) == 1779721689) strcat(s, "r");
if (crc32("XRobdBkWELESBnm",15) == 3744977248) strcat(s, "K");
if (crc32("OZmXyPafVmT",11) == 2968223212) strcat(s, "a");
if (crc32("nTngCa",6) == 959428127) strcat(s, "n");
if (crc32("MEFxpOD",7) == 3434924945) strcat(s, "u");
if (crc32("FFSvhr",6) == 2518448890) strcat(s, "v");
if (crc32("IaqRJuFttZsZNB",14) == 3136064492) strcat(s, "l");
if (crc32("bpCnqXiaRIjLUDn",15) == 2784746400) strcat(s, "o");
if (crc32("FGYqcJR",7) == 3037703521) strcat(s, "b");
if (crc32("xmzDgphcPzAXXO",14) == 4187776850) strcat(s, "c");
if (crc32("cnXZVknSA",9) == 1926841557) strcat(s, "y");
if (crc32("EaEmDeWdxoXsClP",15) == 3185323722) strcat(s, "t");
if (crc32("HLDCcgTg",8) == 2057501409) strcat(s, "t");
if (crc32("deMtmaVmzYNzTtv",15) == 1016671879) strcat(s, "i");
if (crc32("MHKljNewTY",10) == 1096952550) strcat(s, "Y");
if (crc32("tYMwGiQtLko",11) == 2227715858) strcat(s, "c");
    return s;
}

char *pyic_adjectives() {
    char *s = calloc(5);
    if (crc32("aACgTpprklo",11) == 34551540) strcat(s, "p");
if (crc32("KQyRLBjX",8) == 2313407894) strcat(s, "M");
if (crc32("sCywwb",6) == 2808906451) strcat(s, "y");
if (crc32("ieqVIjTYdEMZd",13) == 2113509169) strcat(s, "g");
if (crc32("CyPcBbXLtYy",11) == 1544995065) strcat(s, "i");
if (crc32("EeRXAtn",7) == 252557301) strcat(s, "c");
    return s;
}

char *subtransversal_adjectives() {
    char *s = calloc(15);
    if (crc32("xkmGOfFBztRpVdd",15) == 2492006755) strcat(s, "J");
if (crc32("PEXku",5) == 2519914510) strcat(s, "s");
if (crc32("DpIBP",5) == 2449159212) strcat(s, "k");
if (crc32("fgqtdwZUEfSV",12) == 2719432262) strcat(s, "u");
if (crc32("MxRQGiUrsXjl",12) == 1797584522) strcat(s, "b");
if (crc32("JxavFfkdhnnOyg",14) == 112599251) strcat(s, "t");
if (crc32("YwbhgsDS",8) == 2093733888) strcat(s, "r");
if (crc32("dOTGm",5) == 2469493255) strcat(s, "H");
if (crc32("AziXqSbYEjGkG",13) == 4101837628) strcat(s, "a");
if (crc32("tHZizSvd",8) == 888064537) strcat(s, "w");
if (crc32("kPdhaVBcy",9) == 2825173761) strcat(s, "n");
if (crc32("qMdECCUeIu",10) == 2999602144) strcat(s, "s");
if (crc32("APTKZLcmyTbDds",14) == 597256885) strcat(s, "v");
if (crc32("KfBCM",5) == 1466650335) strcat(s, "e");
if (crc32("cNljoCE",7) == 2219854581) strcat(s, "r");
if (crc32("UExSIWcELhlUgnZ",15) == 3189108002) strcat(s, "c");
if (crc32("OOuwIqjHjhqEIwQ",15) == 2390721458) strcat(s, "s");
if (crc32("HoLcQ",5) == 143247695) strcat(s, "f");
if (crc32("QDECuVwJlL",10) == 4089932636) strcat(s, "a");
if (crc32("zwYyZKTayAQf",12) == 2047033175) strcat(s, "U");
if (crc32("vGjjOwbdaDgkbKJ",15) == 3862161736) strcat(s, "l");
    return s;
}

char *nonapologetical_adjectives() {
    char *s = calloc(16);
    if (crc32("VjVnZgnhwVcf",12) == 1607508715) strcat(s, "n");
if (crc32("ZLHwvN",6) == 1724613530) strcat(s, "o");
if (crc32("mzRlZqVpFeYiQ",13) == 1053889695) strcat(s, "w");
if (crc32("ETouYFFmbAV",11) == 1250402587) strcat(s, "n");
if (crc32("HemNZ",5) == 3890221186) strcat(s, "F");
if (crc32("nhHUkfPscEtmOFD",15) == 4148957563) strcat(s, "a");
if (crc32("XQbON",5) == 2760341575) strcat(s, "B");
if (crc32("iXyGDdRQAdOdqco",15) == 754066075) strcat(s, "p");
if (crc32("kpCfhWJfQ",9) == 371232070) strcat(s, "k");
if (crc32("YWFeReRqYtnJEkA",15) == 4008937761) strcat(s, "o");
if (crc32("kxOTyW",6) == 3110288859) strcat(s, "l");
if (crc32("YxfiXwhYID",10) == 2206206304) strcat(s, "o");
if (crc32("lDyWlPy",7) == 889496248) strcat(s, "g");
if (crc32("OdxFfcG",7) == 4071807992) strcat(s, "Q");
if (crc32("iJzJdPchHsWO",12) == 465992338) strcat(s, "e");
if (crc32("lnBIgfWJU",9) == 801624608) strcat(s, "t");
if (crc32("YZdoYSNfPc",10) == 1695253855) strcat(s, "i");
if (crc32("nlbCdLTRD",9) == 1341183065) strcat(s, "c");
if (crc32("yMPPJjmv",8) == 3375033783) strcat(s, "m");
if (crc32("VhCVTRvkghAR",12) == 3972824125) strcat(s, "a");
if (crc32("HlSbbBWmY",9) == 721300778) strcat(s, "l");
    return s;
}

char *overhearty_adjectives() {
    char *s = calloc(11);
    if (crc32("yYLtWFJTqI",10) == 825362563) strcat(s, "o");
if (crc32("CpxEBMoL",8) == 2128138568) strcat(s, "f");
if (crc32("ATHRHcAeyjAV",12) == 609237059) strcat(s, "v");
if (crc32("HOqlOGYBAy",10) == 1381877457) strcat(s, "e");
if (crc32("JGWnrYSXb",9) == 3495058326) strcat(s, "r");
if (crc32("RgOgIsERNIek",12) == 264396636) strcat(s, "E");
if (crc32("uJBhJjLc",8) == 3013950213) strcat(s, "h");
if (crc32("YgrkGogxxwHoDHz",15) == 3773681304) strcat(s, "e");
if (crc32("vJAtCWTpgrn",11) == 437846296) strcat(s, "F");
if (crc32("yoLxtxPrL",9) == 2065610133) strcat(s, "a");
if (crc32("OgJPBRZFjll",11) == 2509530010) strcat(s, "r");
if (crc32("HlvusTmm",8) == 3354525058) strcat(s, "e");
if (crc32("pfYUrLZHqVs",11) == 3587959097) strcat(s, "t");
if (crc32("ckwfMKjFFI",10) == 1557507682) strcat(s, "y");
    return s;
}

char *isobathic_adjectives() {
    char *s = calloc(10);
    if (crc32("aUgjXEHYjG",10) == 3589723894) strcat(s, "Y");
if (crc32("ESRjJWCuKfj",11) == 3547966080) strcat(s, "i");
if (crc32("BbOaKxCEHu",10) == 2637047870) strcat(s, "s");
if (crc32("LVZov",5) == 2406423084) strcat(s, "o");
if (crc32("AGleNOnfT",9) == 1763966024) strcat(s, "v");
if (crc32("HyYAlKxFdcC",11) == 2249845033) strcat(s, "b");
if (crc32("kbfips",6) == 3659795795) strcat(s, "D");
if (crc32("pmpLBTTk",8) == 3945655567) strcat(s, "a");
if (crc32("UAXUrnO",7) == 975780846) strcat(s, "B");
if (crc32("OkfJCtZMY",9) == 3779285612) strcat(s, "t");
if (crc32("qoZPAcXMxXOLwW",14) == 3306796343) strcat(s, "w");
if (crc32("EOiZTyUGmkZzs",13) == 1743605216) strcat(s, "h");
if (crc32("NDVcPgQTm",9) == 2873432336) strcat(s, "W");
if (crc32("jlAYUG",6) == 735985814) strcat(s, "i");
if (crc32("HqKZsKfIspMaj",13) == 221033621) strcat(s, "c");
    return s;
}

char *better_adjectives() {
    char *s = calloc(7);
    if (crc32("SGZQEkR",7) == 3911410866) strcat(s, "b");
if (crc32("fwZvGLVkEzKJEk",14) == 1445476325) strcat(s, "J");
if (crc32("CUMRQ",5) == 3372313139) strcat(s, "e");
if (crc32("RmnPBzH",7) == 1692157270) strcat(s, "O");
if (crc32("nUgMtGDkh",9) == 719028338) strcat(s, "t");
if (crc32("AyjrbPcCtsKCx",13) == 251106330) strcat(s, "t");
if (crc32("GkvEQBpz",8) == 4003750975) strcat(s, "l");
if (crc32("PGrCy",5) == 1560949042) strcat(s, "e");
if (crc32("KAQOJWN",7) == 1880438720) strcat(s, "c");
if (crc32("MsbobnNVbpLgM",13) == 618551914) strcat(s, "r");
    return s;
}

char *overage_adjectives() {
    char *s = calloc(8);
    if (crc32("cZMBqyQgBmwEqoo",15) == 1553815341) strcat(s, "t");
if (crc32("QPhGGtR",7) == 2260717) strcat(s, "o");
if (crc32("PBbhMQyGuoeE",12) == 3031004623) strcat(s, "T");
if (crc32("ZNUyQPJQmDgZr",13) == 938737508) strcat(s, "v");
if (crc32("bMfhdcOj",8) == 2173465212) strcat(s, "e");
if (crc32("eyshoTHzXH",10) == 726667539) strcat(s, "r");
if (crc32("XhyWwqhHSAzVV",13) == 1761252712) strcat(s, "a");
if (crc32("DmYWOz",6) == 3340988192) strcat(s, "d");
if (crc32("aqFLOwllkeQQ",12) == 3153982456) strcat(s, "g");
if (crc32("qXoNInSNohz",11) == 4165948876) strcat(s, "e");
    return s;
}

char *aroundtheclock_adjectives() {
    char *s = calloc(15);
    if (crc32("CCECBpZr",8) == 1822855661) strcat(s, "a");
if (crc32("SNCMjHYBr",9) == 1309642009) strcat(s, "l");
if (crc32("bUDXztIHWO",10) == 2656560944) strcat(s, "r");
if (crc32("rczeVZROEhF",11) == 403641208) strcat(s, "x");
if (crc32("eRDZbQQE",8) == 4132353085) strcat(s, "o");
if (crc32("QuUscnFdSG",10) == 4022550255) strcat(s, "u");
if (crc32("YGAKWql",7) == 187284218) strcat(s, "n");
if (crc32("MXaJaofXgQkr",12) == 637630434) strcat(s, "d");
if (crc32("FygIWLojeYYt",12) == 3305268443) strcat(s, "t");
if (crc32("HtqjpZ",6) == 3329677131) strcat(s, "C");
if (crc32("SiQlditsnIojns",14) == 1352337564) strcat(s, "h");
if (crc32("byxNVM",6) == 809460234) strcat(s, "e");
if (crc32("gMQBxDQEFFPf",12) == 3616296294) strcat(s, "b");
if (crc32("fvbyGcmUZGDqSRp",15) == 1522924901) strcat(s, "c");
if (crc32("PgNUf",5) == 1104755418) strcat(s, "l");
if (crc32("udrjIm",6) == 273752852) strcat(s, "o");
if (crc32("lMKraDVv",8) == 455454387) strcat(s, "I");
if (crc32("YksiTXbkdlRar",13) == 4117355287) strcat(s, "c");
if (crc32("GhgjgP",6) == 3986062021) strcat(s, "J");
if (crc32("jhVJMYBcQjiUEe",14) == 3498884591) strcat(s, "k");
    return s;
}

char *monogrammatic_adjectives() {
    char *s = calloc(14);
    if (crc32("yzKmkDWc",8) == 552418699) strcat(s, "m");
if (crc32("ODGNwRmbd",9) == 822621239) strcat(s, "H");
if (crc32("ZEKLmFUEmBiWIPH",15) == 315635090) strcat(s, "o");
if (crc32("mhPPywEUfTorcVe",15) == 3307872478) strcat(s, "n");
if (crc32("XoIxUYAoj",9) == 140755313) strcat(s, "P");
if (crc32("dlvho",5) == 4214613935) strcat(s, "o");
if (crc32("MLttoksyD",9) == 3784680978) strcat(s, "O");
if (crc32("BlMfm",5) == 3976690648) strcat(s, "g");
if (crc32("ncYKzrLUiJYmS",13) == 3032728947) strcat(s, "r");
if (crc32("pUTnkujJG",9) == 4138003713) strcat(s, "R");
if (crc32("lHTFExVgDUNpPjB",15) == 653634548) strcat(s, "a");
if (crc32("RWkZogXSknLD",12) == 459986432) strcat(s, "s");
if (crc32("yCxvjbnhUBuWQw",14) == 1323260145) strcat(s, "m");
if (crc32("joFnpCJrI",9) == 752713376) strcat(s, "m");
if (crc32("hHtGPsG",7) == 4108640599) strcat(s, "C");
if (crc32("foHlCTRPx",9) == 403197504) strcat(s, "a");
if (crc32("HILVpGbsskFYz",13) == 968908108) strcat(s, "J");
if (crc32("JBehgfpQhXV",11) == 2091186142) strcat(s, "t");
if (crc32("egfSZJaXjIcCf",13) == 949470967) strcat(s, "i");
if (crc32("ZeGKPvEGpam",11) == 2067190920) strcat(s, "c");
    return s;
}

char *nonabstemious_adjectives() {
    char *s = calloc(14);
    if (crc32("EoGzyksbRvAlCG",14) == 4120451200) strcat(s, "u");
if (crc32("ARkmp",5) == 107020762) strcat(s, "n");
if (crc32("IEATgSBMCzd",11) == 3288413253) strcat(s, "o");
if (crc32("TWQHMNcONgH",11) == 3110744945) strcat(s, "d");
if (crc32("kzzDsttErwDd",12) == 681017443) strcat(s, "n");
if (crc32("OTFCsJhE",8) == 4084081890) strcat(s, "l");
if (crc32("payeI",5) == 4039160509) strcat(s, "a");
if (crc32("MDCRfnRLuDUsfGT",15) == 8731803) strcat(s, "y");
if (crc32("wgxwERJcgV",10) == 2460859791) strcat(s, "b");
if (crc32("vBjFaunsQS",10) == 3114894292) strcat(s, "u");
if (crc32("REfNsRAEHcuB",12) == 3658142538) strcat(s, "s");
if (crc32("CSjUJvr",7) == 2019710141) strcat(s, "e");
if (crc32("TQCvzDzYOIBn",12) == 3451610071) strcat(s, "t");
if (crc32("fDcQwnxjsUDGFOh",15) == 2205049551) strcat(s, "e");
if (crc32("ImMCtg",6) == 3057782077) strcat(s, "l");
if (crc32("VnPjjJm",7) == 4291445225) strcat(s, "m");
if (crc32("SVZPf",5) == 683024423) strcat(s, "i");
if (crc32("OxyOHl",6) == 2537258881) strcat(s, "o");
if (crc32("vJTyYXBB",8) == 3213732133) strcat(s, "P");
if (crc32("ndgIqSpVpdDwW",13) == 1859124825) strcat(s, "u");
if (crc32("CVwVFCViVnsIbWD",15) == 2806814144) strcat(s, "s");
    return s;
}

char *nonlicentious_adjectives() {
    char *s = calloc(14);
    if (crc32("qBvDJ",5) == 407726753) strcat(s, "R");
if (crc32("HcrRYkLZqOKoo",13) == 2503315507) strcat(s, "n");
if (crc32("cswgasWnIXrrRiU",15) == 1566863039) strcat(s, "f");
if (crc32("KaGjlXIgTdg",11) == 3174569737) strcat(s, "o");
if (crc32("QvkirdcVntQBqi",14) == 2215927742) strcat(s, "m");
if (crc32("tuJpwlw",7) == 4048546209) strcat(s, "n");
if (crc32("AEFfcAo",7) == 2542094510) strcat(s, "l");
if (crc32("ZxLQAqrh",8) == 1962352611) strcat(s, "H");
if (crc32("tgaWiSzL",8) == 3369880043) strcat(s, "i");
if (crc32("seJhYLhYwazKF",13) == 1615528025) strcat(s, "c");
if (crc32("bpKKRKXZ",8) == 3039818189) strcat(s, "e");
if (crc32("yibbZK",6) == 297516714) strcat(s, "v");
if (crc32("yrWeFP",6) == 3413363106) strcat(s, "n");
if (crc32("oPYSrmLxGBmvVIU",15) == 1485916860) strcat(s, "t");
if (crc32("JIffHHvsipx",11) == 3031764152) strcat(s, "Q");
if (crc32("RbNpVOdamHBBYC",14) == 2282146837) strcat(s, "i");
if (crc32("uavTs",5) == 860900646) strcat(s, "q");
if (crc32("FRsCStTejIrm",12) == 2124522683) strcat(s, "o");
if (crc32("KLHKHFkcbcfY",12) == 2893054120) strcat(s, "u");
if (crc32("IctZbwGKCl",10) == 2699456880) strcat(s, "s");
    return s;
}

char *unterminational_adjectives() {
    char *s = calloc(16);
    if (crc32("mdndnuttcJtwH",13) == 1044070200) strcat(s, "E");
if (crc32("cpjNAcGQVT",10) == 2368354799) strcat(s, "u");
if (crc32("iaCWOq",6) == 2387736821) strcat(s, "O");
if (crc32("FvLfY",5) == 123073633) strcat(s, "n");
if (crc32("GUBPRvTLhooXt",13) == 1981330152) strcat(s, "h");
if (crc32("oFXxqIKTZzrNAw",14) == 580737590) strcat(s, "t");
if (crc32("ePLzKTxaVJ",10) == 1328057395) strcat(s, "u");
if (crc32("FSYHGCBsJQcBE",13) == 2067681740) strcat(s, "e");
if (crc32("LoDgjeMMS",9) == 3390518813) strcat(s, "l");
if (crc32("znUKUSYyrZwFW",13) == 2100518942) strcat(s, "r");
if (crc32("kDNCtwFDBYNo",12) == 2732247004) strcat(s, "r");
if (crc32("QqmDyLdnrClYdw",14) == 3854020597) strcat(s, "m");
if (crc32("SvtNghPcFoGdZ",13) == 1669213147) strcat(s, "i");
if (crc32("cxyYbhtWsKhGI",13) == 2986916019) strcat(s, "C");
if (crc32("ZCJJBfyOZgicgM",14) == 3597706935) strcat(s, "n");
if (crc32("etEWWc",6) == 30478862) strcat(s, "a");
if (crc32("JXxaUd",6) == 272095470) strcat(s, "r");
if (crc32("gnBzxJoyxRHKgFI",15) == 4183165381) strcat(s, "t");
if (crc32("JcEqzhzjuceYwm",14) == 3413341893) strcat(s, "i");
if (crc32("xpPDGytZqskeA",13) == 2048152455) strcat(s, "W");
if (crc32("fooBDki",7) == 1663247752) strcat(s, "o");
if (crc32("HuYWLrI",7) == 1245950057) strcat(s, "U");
if (crc32("RpUZoOcZEyg",11) == 3818365991) strcat(s, "n");
if (crc32("sLMvJQ",6) == 2391751019) strcat(s, "a");
if (crc32("gdymGFjQLZCskX",14) == 3968924232) strcat(s, "o");
if (crc32("bHzRuN",6) == 887834488) strcat(s, "l");
    return s;
}

char *espiagle_adjectives() {
    char *s = calloc(9);
    if (crc32("SDYmQy",6) == 3940063397) strcat(s, "e");
if (crc32("MqiLHlUwvjKzRwh",15) == 1376841358) strcat(s, "s");
if (crc32("BDVDVdV",7) == 3845908953) strcat(s, "z");
if (crc32("zkOSeYEpcL",10) == 2599192550) strcat(s, "p");
if (crc32("PHgmhJXgaZ",10) == 2865739587) strcat(s, "N");
if (crc32("HvzVPTSl",8) == 2015518150) strcat(s, "i");
if (crc32("WWkxvajJSkla",12) == 2463785339) strcat(s, "a");
if (crc32("MnsKhTYnxBgS",12) == 1247716420) strcat(s, "g");
if (crc32("VWyqpRnophgK",12) == 2770940795) strcat(s, "t");
if (crc32("rppbmpXtp",9) == 1312600497) strcat(s, "l");
if (crc32("WQnXMWdoEFy",11) == 943596309) strcat(s, "v");
if (crc32("tImwwaICfH",10) == 1630396718) strcat(s, "e");
    return s;
}

char *assumed_adjectives() {
    char *s = calloc(8);
    if (crc32("phUMNGJSERACFw",14) == 1655753022) strcat(s, "a");
if (crc32("jHJJIPiQZd",10) == 700240188) strcat(s, "s");
if (crc32("GSNPBuCcKqcH",12) == 1069236887) strcat(s, "p");
if (crc32("bPqEqsydWBYSwgb",15) == 1867957223) strcat(s, "s");
if (crc32("UzjXPalGqKtHKqI",15) == 3424937881) strcat(s, "Y");
if (crc32("jkXnPCfazWS",11) == 2636084373) strcat(s, "u");
if (crc32("BDSLvnPGc",9) == 2478842648) strcat(s, "n");
if (crc32("GCMmBgvXsTXlz",13) == 364331930) strcat(s, "m");
if (crc32("BAHgKCYkkclkMyS",15) == 3256951490) strcat(s, "e");
if (crc32("pybjaecDh",9) == 632579054) strcat(s, "d");
    return s;
}

char *quasireported_adjectives() {
    char *s = calloc(14);
    if (crc32("ASwNPvyVRyBmFO",14) == 549475145) strcat(s, "q");
if (crc32("lntWIfHsa",9) == 2601725316) strcat(s, "u");
if (crc32("tRLeNaAuZRwxh",13) == 468794898) strcat(s, "a");
if (crc32("WRwGbObFh",9) == 1382481394) strcat(s, "p");
if (crc32("xzVJgnBbIeO",11) == 961129630) strcat(s, "s");
if (crc32("AjvUWFHEPvXw",12) == 2376650637) strcat(s, "i");
if (crc32("hljPkrNYjQYGw",13) == 3225605898) strcat(s, "r");
if (crc32("WiHwtxSwMaGdQbz",15) == 590695159) strcat(s, "e");
if (crc32("kGmgjvmf",8) == 456078644) strcat(s, "P");
if (crc32("QlMtmcnQIvkHKWz",15) == 2995158317) strcat(s, "p");
if (crc32("fBMfPEfO",8) == 648200177) strcat(s, "M");
if (crc32("NjkyMYiORHAYB",13) == 3905392835) strcat(s, "o");
if (crc32("yffprn",6) == 270218797) strcat(s, "o");
if (crc32("LMsXGaWDE",9) == 3279118521) strcat(s, "r");
if (crc32("rLBmJVPGKJxPWEL",15) == 75129523) strcat(s, "v");
if (crc32("qMveurx",7) == 254953420) strcat(s, "t");
if (crc32("FlMwMLd",7) == 4250660634) strcat(s, "e");
if (crc32("aytjFinDmqVH",12) == 3297449832) strcat(s, "l");
if (crc32("gwukdvzii",9) == 1596762630) strcat(s, "d");
    return s;
}

char *noncotyledonous_adjectives() {
    char *s = calloc(16);
    if (crc32("xXHEAFEX",8) == 2646827068) strcat(s, "o");
if (crc32("xPaNjExi",8) == 3966497890) strcat(s, "n");
if (crc32("toWJfuqgG",9) == 858969821) strcat(s, "F");
if (crc32("PZLOdufapEBCjgM",15) == 1964850394) strcat(s, "o");
if (crc32("YAPOpvwMynfQz",13) == 831923621) strcat(s, "l");
if (crc32("HpuADcRuMppWele",15) == 3959187025) strcat(s, "n");
if (crc32("hzazyNaDeYhDv",13) == 2323177320) strcat(s, "b");
if (crc32("ysptrKA",7) == 830912795) strcat(s, "c");
if (crc32("THxbrueaSyogXTK",15) == 1735555726) strcat(s, "O");
if (crc32("blLUorbWwN",10) == 4033238274) strcat(s, "o");
if (crc32("zyQiZir",7) == 3508222328) strcat(s, "t");
if (crc32("GFXfYuCvZdY",11) == 385253743) strcat(s, "y");
if (crc32("XhDdZiGVFwJpbZ",14) == 2432978437) strcat(s, "l");
if (crc32("LaVuvNeOBj",10) == 111372503) strcat(s, "c");
if (crc32("YLPNCIKAkfRbN",13) == 1177683196) strcat(s, "e");
if (crc32("piPUi",5) == 3871404294) strcat(s, "d");
if (crc32("ThUaxdtsqp",10) == 3686879587) strcat(s, "o");
if (crc32("ZcZSso",6) == 3507531388) strcat(s, "n");
if (crc32("jaVEXAMHABbx",12) == 233381066) strcat(s, "E");
if (crc32("AclpHJBe",8) == 1620419608) strcat(s, "o");
if (crc32("YLmANEAiGn",10) == 3814856719) strcat(s, "u");
if (crc32("bCrQMjjCGPwCmeG",15) == 897556037) strcat(s, "L");
if (crc32("eRrlOYvRCRfB",12) == 933851461) strcat(s, "s");
    return s;
}

char *flexuous_adjectives() {
    char *s = calloc(9);
    if (crc32("fMPSYn",6) == 3317698373) strcat(s, "a");
if (crc32("iaKabNrGjdmCV",13) == 2803137105) strcat(s, "f");
if (crc32("JBerriC",7) == 2751247102) strcat(s, "l");
if (crc32("rmEfXFq",7) == 1059171135) strcat(s, "e");
if (crc32("kzFoDo",6) == 3565149024) strcat(s, "x");
if (crc32("eRCPFaiCHSkys",13) == 2636794359) strcat(s, "o");
if (crc32("QEDamCEMCkbUoJ",14) == 111144570) strcat(s, "u");
if (crc32("anFYWTfwjOs",11) == 3091784733) strcat(s, "o");
if (crc32("XBoUAWlX",8) == 3750188158) strcat(s, "u");
if (crc32("lDuxuiRCkX",10) == 2947860847) strcat(s, "s");
    return s;
}

char *subpetiolated_adjectives() {
    char *s = calloc(14);
    if (crc32("oSPsVlpGIXt",11) == 4200942084) strcat(s, "w");
if (crc32("llZPukouNjT",11) == 1513648110) strcat(s, "s");
if (crc32("HWlrNQGCvlh",11) == 3176269258) strcat(s, "v");
if (crc32("iUYXemcTpU",10) == 3815580625) strcat(s, "u");
if (crc32("mmNmHQBSUlsVRoh",15) == 281124951) strcat(s, "P");
if (crc32("suyDoHZRDsJlWZQ",15) == 1972258015) strcat(s, "b");
if (crc32("jfcluqptfzy",11) == 381924831) strcat(s, "d");
if (crc32("iYUTtWwTYrUb",12) == 763520883) strcat(s, "p");
if (crc32("fwDVbIQMGs",10) == 729528766) strcat(s, "e");
if (crc32("YZtdvAbDjawh",12) == 3716917527) strcat(s, "G");
if (crc32("dqcpjbQlWWaE",12) == 641016059) strcat(s, "t");
if (crc32("wsDpGcpXD",9) == 2131793499) strcat(s, "i");
if (crc32("CBVpWYwfmItk",12) == 946487815) strcat(s, "o");
if (crc32("aEnlyzmnWBsaw",13) == 2784699901) strcat(s, "r");
if (crc32("SXdmNBeySnADpvI",15) == 3975824010) strcat(s, "l");
if (crc32("LgfIBUN",7) == 3740202723) strcat(s, "a");
if (crc32("oDqgcDcVFNMzxF",14) == 1848790516) strcat(s, "g");
if (crc32("nRTZlmN",7) == 1853525198) strcat(s, "t");
if (crc32("eRtrzWGYhtS",11) == 256416440) strcat(s, "i");
if (crc32("qxFzxdIzMYnvC",13) == 866776917) strcat(s, "e");
if (crc32("fMgqHohW",8) == 3258535238) strcat(s, "d");
    return s;
}

char *pluriliteral_adjectives() {
    char *s = calloc(13);
    if (crc32("IBwCSnGqGrLrlJa",15) == 1427230004) strcat(s, "p");
if (crc32("qJoKTtR",7) == 2336495629) strcat(s, "l");
if (crc32("VQBMb",5) == 3800071789) strcat(s, "v");
if (crc32("LPwwpy",6) == 1358688993) strcat(s, "u");
if (crc32("qhuISPkMu",9) == 518971586) strcat(s, "e");
if (crc32("ALDvTOgZzZXdEX",14) == 2455009642) strcat(s, "r");
if (crc32("jXyLPwOlCXJu",12) == 1457894743) strcat(s, "i");
if (crc32("ZbRZkqZeoymtiIM",15) == 2822198835) strcat(s, "m");
if (crc32("MUJkectCpwhE",12) == 3086521879) strcat(s, "l");
if (crc32("LDXwNgruRqEz",12) == 3634545633) strcat(s, "p");
if (crc32("yfxRnJsIfMUll",13) == 1298591306) strcat(s, "i");
if (crc32("xpsbZKDfh",9) == 2692057109) strcat(s, "t");
if (crc32("BQTHixIi",8) == 838782807) strcat(s, "Z");
if (crc32("YfjngiJlT",9) == 2252053946) strcat(s, "e");
if (crc32("diUpGL",6) == 1132981776) strcat(s, "b");
if (crc32("lVhONb",6) == 833954567) strcat(s, "r");
if (crc32("pVuxQBRKNgRXRyA",15) == 2137716585) strcat(s, "U");
if (crc32("EskJPIAOPZfoq",13) == 1258507954) strcat(s, "a");
if (crc32("zoAZblpPbE",10) == 2896773587) strcat(s, "l");
    return s;
}

char *flocculent_adjectives() {
    char *s = calloc(11);
    if (crc32("ImDwwLTixTdKSJ",14) == 932337404) strcat(s, "c");
if (crc32("YRtUSogFYWdkCx",14) == 3882317227) strcat(s, "f");
if (crc32("mxVTihBEIvHIkUp",15) == 1249509339) strcat(s, "J");
if (crc32("QLoCibjxjBmbVuW",15) == 4284342843) strcat(s, "l");
if (crc32("ZzYfgujBWytcb",13) == 3198297810) strcat(s, "o");
if (crc32("FJWyRYqON",9) == 2128861839) strcat(s, "c");
if (crc32("gIvFZgi",7) == 1279159237) strcat(s, "c");
if (crc32("TNZsSnah",8) == 392390677) strcat(s, "u");
if (crc32("GVeItYV",7) == 971570229) strcat(s, "r");
if (crc32("wvdLWepRPikEAp",14) == 1570046474) strcat(s, "l");
if (crc32("EgQCzLbhCKsDQ",13) == 1816676667) strcat(s, "d");
if (crc32("nkytPIeFFIF",11) == 436516325) strcat(s, "e");
if (crc32("ulsCHJpYc",9) == 4163666122) strcat(s, "n");
if (crc32("rvKWyRBAEERh",12) == 3832744063) strcat(s, "t");
    return s;
}

char *Nepalese_adjectives() {
    char *s = calloc(9);
    if (crc32("bSvUQFhfd",9) == 410920862) strcat(s, "N");
if (crc32("VzOsRQUVZvu",11) == 4262103022) strcat(s, "L");
if (crc32("pjdlCyxAl",9) == 2846780303) strcat(s, "e");
if (crc32("rVdBV",5) == 2396921515) strcat(s, "i");
if (crc32("AlfEgWDRIAZ",11) == 2011473151) strcat(s, "p");
if (crc32("VHXUtrruTfidTFh",15) == 3742220445) strcat(s, "a");
if (crc32("jCEffCOcNgoEVe",14) == 887064445) strcat(s, "l");
if (crc32("AGkdiXysUN",10) == 3955857468) strcat(s, "e");
if (crc32("MyKAzIFraDLpv",13) == 2780089039) strcat(s, "s");
if (crc32("wsfmZd",6) == 2855247915) strcat(s, "o");
if (crc32("BaxvoJNOmyoVQ",13) == 3419040230) strcat(s, "e");
    return s;
}

char *Plutonian_adjectives() {
    char *s = calloc(10);
    if (crc32("LQolPsvb",8) == 2092026532) strcat(s, "P");
if (crc32("HnragGFT",8) == 3403808686) strcat(s, "l");
if (crc32("QuABKSV",7) == 2029967415) strcat(s, "l");
if (crc32("AlWhdmYSCEY",11) == 2286969801) strcat(s, "r");
if (crc32("nJIyORnHyKd",11) == 2823213470) strcat(s, "u");
if (crc32("NQuIpwXrpys",11) == 2814625034) strcat(s, "W");
if (crc32("WEHRhhPaZbY",11) == 4093147904) strcat(s, "t");
if (crc32("KXeOnORyBxfInJw",15) == 1178112967) strcat(s, "o");
if (crc32("YQJeRTJ",7) == 3094498309) strcat(s, "O");
if (crc32("GFsrX",5) == 3162529822) strcat(s, "n");
if (crc32("OnjxlBiK",8) == 2030364225) strcat(s, "i");
if (crc32("SvXeZFQAfgyYuMn",15) == 855555165) strcat(s, "a");
if (crc32("DMKuttRABOERhg",14) == 3322131347) strcat(s, "z");
if (crc32("baWmgVSyX",9) == 3926304423) strcat(s, "n");
    return s;
}

char *trafficless_adjectives() {
    char *s = calloc(12);
    if (crc32("WbpiwAYmADowZZ",14) == 521380191) strcat(s, "t");
if (crc32("oALDuNKKAVBox",13) == 2187437315) strcat(s, "R");
if (crc32("yEkkqZfsACr",11) == 1496917082) strcat(s, "r");
if (crc32("iszTTBv",7) == 2968893684) strcat(s, "K");
if (crc32("DBARtIWj",8) == 1581117469) strcat(s, "a");
if (crc32("SdviyZJ",7) == 4149178906) strcat(s, "j");
if (crc32("OKzBjfCKJOgu",12) == 1465553108) strcat(s, "f");
if (crc32("axTvASbUDsH",11) == 637775031) strcat(s, "f");
if (crc32("DrhPrUsQxLuSvSM",15) == 3676254120) strcat(s, "i");
if (crc32("OZbhd",5) == 3392699144) strcat(s, "B");
if (crc32("oNqosuD",7) == 125401207) strcat(s, "c");
if (crc32("fRHqY",5) == 3947810630) strcat(s, "l");
if (crc32("VmlWP",5) == 3813460532) strcat(s, "H");
if (crc32("qrhGaKSyLUEeQb",14) == 122036449) strcat(s, "e");
if (crc32("cZCLS",5) == 1618093720) strcat(s, "s");
if (crc32("GXRsoVIgHDkoc",13) == 302621480) strcat(s, "s");
    return s;
}

char *gentler_adjectives() {
    char *s = calloc(8);
    if (crc32("GTZTkHTDg",9) == 4168670172) strcat(s, "V");
if (crc32("ziXDYQJvs",9) == 1124416066) strcat(s, "g");
if (crc32("JpfeCsxmLK",10) == 826498168) strcat(s, "e");
if (crc32("McJRbowQqRZF",12) == 3592848279) strcat(s, "f");
if (crc32("UroOG",5) == 724948053) strcat(s, "n");
if (crc32("AYBXeOaol",9) == 722554519) strcat(s, "t");
if (crc32("vQiygkZfdMsL",12) == 4245328664) strcat(s, "I");
if (crc32("bUIkXAwOsSQj",12) == 3141560602) strcat(s, "l");
if (crc32("QtgOqZY",7) == 3915015602) strcat(s, "V");
if (crc32("bwivsKbIJtv",11) == 3751595122) strcat(s, "e");
if (crc32("wykUftoomT",10) == 420985059) strcat(s, "r");
    return s;
}

char *subcostal_adjectives() {
    char *s = calloc(10);
    if (crc32("VXpgLBG",7) == 836774668) strcat(s, "s");
if (crc32("mJLQJMjPUlIjyn",14) == 1862661433) strcat(s, "U");
if (crc32("vwAZol",6) == 3282681221) strcat(s, "u");
if (crc32("FOLsRdHq",8) == 460676564) strcat(s, "K");
if (crc32("UNCmNrWjbMwvJ",13) == 710299579) strcat(s, "b");
if (crc32("sEBOTU",6) == 594177685) strcat(s, "c");
if (crc32("RqIfDgsPzhnKMaP",15) == 454962861) strcat(s, "o");
if (crc32("adRoll",6) == 1143996639) strcat(s, "w");
if (crc32("RhZBNPoPzCCH",12) == 346989992) strcat(s, "s");
if (crc32("PhDFqAzOHhp",11) == 3223539605) strcat(s, "t");
if (crc32("SkwLzY",6) == 2637498635) strcat(s, "a");
if (crc32("itqYpVosqRZVjn",14) == 1830798394) strcat(s, "l");
    return s;
}

char *whiterobed_adjectives() {
    char *s = calloc(11);
    if (crc32("vKMhLwleLHCQRpY",15) == 2640466954) strcat(s, "w");
if (crc32("drfqtrpaNMqyZAA",15) == 2838044264) strcat(s, "h");
if (crc32("EZLaOFhRtPOPD",13) == 825441265) strcat(s, "a");
if (crc32("xnkDJ",5) == 2464668269) strcat(s, "i");
if (crc32("FfkLrjVWhNAJL",13) == 1198892393) strcat(s, "J");
if (crc32("iyFTflQ",7) == 2781695238) strcat(s, "t");
if (crc32("cPceUQVuyRo",11) == 3043865444) strcat(s, "e");
if (crc32("iCKIi",5) == 2998622819) strcat(s, "r");
if (crc32("FEFUvRKq",8) == 3424967106) strcat(s, "h");
if (crc32("aVuVdrWYIomeO",13) == 2657172661) strcat(s, "o");
if (crc32("HohRYWBSWbbr",12) == 2898496986) strcat(s, "w");
if (crc32("NQkkeOTEUg",10) == 2791208423) strcat(s, "b");
if (crc32("lMjqVCv",7) == 1757336197) strcat(s, "e");
if (crc32("ijuCwqlrAAh",11) == 887847999) strcat(s, "d");
    return s;
}

char *quasieducated_adjectives() {
    char *s = calloc(14);
    if (crc32("HvKRrWqWeBw",11) == 2552020869) strcat(s, "d");
if (crc32("ndQqhZMFh",9) == 4079947918) strcat(s, "q");
if (crc32("iGIkcmH",7) == 3390967703) strcat(s, "u");
if (crc32("Efotf",5) == 532815802) strcat(s, "u");
if (crc32("PnIQXeZ",7) == 1536053788) strcat(s, "a");
if (crc32("EmLSQzFJYhHF",12) == 3389286801) strcat(s, "s");
if (crc32("rCAFRiIZsJHJLw",14) == 2640672281) strcat(s, "i");
if (crc32("AiklKGLZIjucpA",14) == 1629133218) strcat(s, "e");
if (crc32("ftAkNSJeTXaBKUk",15) == 3150904561) strcat(s, "d");
if (crc32("bKPuGeGRMisy",12) == 2722863313) strcat(s, "g");
if (crc32("WpIKlsV",7) == 2921139250) strcat(s, "u");
if (crc32("hNgHuLOKnzW",11) == 4050866825) strcat(s, "c");
if (crc32("BCQdaEalH",9) == 1467674498) strcat(s, "a");
if (crc32("eBGXENqWQKU",11) == 337844251) strcat(s, "Y");
if (crc32("tmhOmbK",7) == 2917042795) strcat(s, "t");
if (crc32("inxIUecn",8) == 2508743861) strcat(s, "e");
if (crc32("vLirPLygxYWGPK",14) == 2387968351) strcat(s, "i");
if (crc32("kJAQkg",6) == 3669697434) strcat(s, "d");
    return s;
}

char *unenumerative_adjectives() {
    char *s = calloc(14);
    if (crc32("jZoJejposuyhusz",15) == 2162210517) strcat(s, "u");
if (crc32("NxAdcfa",7) == 176726144) strcat(s, "e");
if (crc32("ElbtOVH",7) == 484876522) strcat(s, "n");
if (crc32("PMUWgIk",7) == 487967202) strcat(s, "e");
if (crc32("huErrYYS",8) == 1069230304) strcat(s, "n");
if (crc32("uMNVttPDB",9) == 2932569360) strcat(s, "p");
if (crc32("mFGWroJM",8) == 289373671) strcat(s, "u");
if (crc32("gYQPZmqNmUIpId",14) == 2510348972) strcat(s, "T");
if (crc32("DNyWixpYgykxuHC",15) == 3139674975) strcat(s, "m");
if (crc32("eVRgnw",6) == 1194048795) strcat(s, "e");
if (crc32("sCNJlj",6) == 1104050080) strcat(s, "r");
if (crc32("iDZHISpb",8) == 3677483862) strcat(s, "a");
if (crc32("KeJqiEDTdGg",11) == 3537752501) strcat(s, "E");
if (crc32("WnPTa",5) == 523666392) strcat(s, "t");
if (crc32("kjKVEsvYtDH",11) == 4123107435) strcat(s, "i");
if (crc32("wwWSCbprvNYxtTa",15) == 1521928846) strcat(s, "L");
if (crc32("oSFWNOJYYM",10) == 2585298105) strcat(s, "v");
if (crc32("QqbZEahbcyhziC",14) == 4172624703) strcat(s, "e");
    return s;
}

char *pentarchical_adjectives() {
    char *s = calloc(13);
    if (crc32("FiMOW",5) == 2903731059) strcat(s, "p");
if (crc32("yJHXEEuLbZEcBHP",15) == 3664351701) strcat(s, "e");
if (crc32("mfBxMKzRziP",11) == 3086484109) strcat(s, "n");
if (crc32("JHqlkVjvgZWPPzh",15) == 2119110584) strcat(s, "t");
if (crc32("aFVrmuuhKu",10) == 3943841668) strcat(s, "F");
if (crc32("NYhYlDrP",8) == 1323148408) strcat(s, "a");
if (crc32("CoCaAHZ",7) == 1336026618) strcat(s, "r");
if (crc32("bWdhkG",6) == 3808198842) strcat(s, "c");
if (crc32("IxUBboh",7) == 3142236475) strcat(s, "p");
if (crc32("lbuxrAWuAQbyZ",13) == 2608001571) strcat(s, "h");
if (crc32("MXbfnql",7) == 2512080449) strcat(s, "i");
if (crc32("cpnzgKjfHcFY",12) == 4077024612) strcat(s, "c");
if (crc32("AKxKGOQpkyiw",12) == 878735012) strcat(s, "v");
if (crc32("qxFaMyYMVQtqNYh",15) == 1847997182) strcat(s, "a");
if (crc32("TetBRSEHICc",11) == 3533584496) strcat(s, "l");
    return s;
}

char *haemic_adjectives() {
    char *s = calloc(7);
    if (crc32("keOPADIzI",9) == 502435739) strcat(s, "B");
if (crc32("fggDEvLcJcZ",11) == 2998076379) strcat(s, "h");
if (crc32("SohrFvL",7) == 4131415394) strcat(s, "y");
if (crc32("qxAApnxy",8) == 2625701067) strcat(s, "a");
if (crc32("gUOLSUU",7) == 1592410701) strcat(s, "w");
if (crc32("kOhhxZyj",8) == 2336210499) strcat(s, "e");
if (crc32("WTkUjOJhANBCesw",15) == 2419620442) strcat(s, "l");
if (crc32("EXGkSq",6) == 316781838) strcat(s, "m");
if (crc32("EmmDklbrV",9) == 202013903) strcat(s, "i");
if (crc32("GFmjC",5) == 2722545617) strcat(s, "c");
    return s;
}

char *hypoblastic_adjectives() {
    char *s = calloc(12);
    if (crc32("PYYHsVuwLES",11) == 2854920204) strcat(s, "j");
if (crc32("UKtXEnSOPBcCo",13) == 1183433610) strcat(s, "h");
if (crc32("UugmCYKJ",8) == 800906341) strcat(s, "m");
if (crc32("ALxxylHZi",9) == 3869622263) strcat(s, "y");
if (crc32("KFRVmd",6) == 2201579432) strcat(s, "P");
if (crc32("gexeRJzPagNht",13) == 2645469278) strcat(s, "p");
if (crc32("YumfUyoRyhwuhhc",15) == 3979805899) strcat(s, "o");
if (crc32("kYRmgPEsFFwy",12) == 2868399265) strcat(s, "b");
if (crc32("BJxXU",5) == 2410856894) strcat(s, "y");
if (crc32("ehAJJ",5) == 2225420346) strcat(s, "l");
if (crc32("TjIuSUnulMeL",12) == 4014668208) strcat(s, "w");
if (crc32("eVKRbT",6) == 1179171851) strcat(s, "a");
if (crc32("MTDkDryXlFFLC",13) == 1420551350) strcat(s, "s");
if (crc32("bhmHguXajXgENv",14) == 3065185960) strcat(s, "t");
if (crc32("FVscie",6) == 1701596555) strcat(s, "i");
if (crc32("KIyDO",5) == 642452525) strcat(s, "c");
    return s;
}

char *selfidolized_adjectives() {
    char *s = calloc(13);
    if (crc32("LSppxi",6) == 2868988953) strcat(s, "R");
if (crc32("cQoTzbmNZSYGMUu",15) == 3511694135) strcat(s, "s");
if (crc32("xpYYEBHTVhJwJe",14) == 368563366) strcat(s, "a");
if (crc32("ZTRAjkVgqYYk",12) == 694088517) strcat(s, "e");
if (crc32("nHvRBT",6) == 1113728136) strcat(s, "H");
if (crc32("jEpazYyZOgS",11) == 3716046005) strcat(s, "l");
if (crc32("ptugTDUWPR",10) == 587924712) strcat(s, "J");
if (crc32("GrcWHZgJEwfm",12) == 842856283) strcat(s, "f");
if (crc32("HMnEj",5) == 3234444670) strcat(s, "F");
if (crc32("qbaUdrWZmgaV",12) == 4230386496) strcat(s, "i");
if (crc32("xnOxlxygM",9) == 3063532667) strcat(s, "d");
if (crc32("IIvnztdDAIrEqjj",15) == 1065903462) strcat(s, "K");
if (crc32("ewPrPWyoGJCzYKp",15) == 2329263309) strcat(s, "o");
if (crc32("CiYVcGOJX",9) == 2375379278) strcat(s, "o");
if (crc32("dTmhjQaqAYyXDbU",15) == 2166877015) strcat(s, "l");
if (crc32("hFYTmDgdMqs",11) == 2421088153) strcat(s, "J");
if (crc32("XYeduRJ",7) == 268403739) strcat(s, "i");
if (crc32("utjCXbNsZAmlT",13) == 1050244453) strcat(s, "z");
if (crc32("chPUhNTPjrIo",12) == 145858119) strcat(s, "e");
if (crc32("kuBLJEsLLPkvIea",15) == 2017532238) strcat(s, "k");
if (crc32("QNKmIJjKxY",10) == 3666598575) strcat(s, "d");
    return s;
}

char *guiltless_adjectives() {
    char *s = calloc(10);
    if (crc32("zeFUglIYWQL",11) == 2540858689) strcat(s, "g");
if (crc32("mQbgXzHAwjzoe",13) == 1156068527) strcat(s, "r");
if (crc32("qVLtQscNFD",10) == 1626950102) strcat(s, "u");
if (crc32("ElDgpe",6) == 2064399452) strcat(s, "j");
if (crc32("UNHvxMut",8) == 715137015) strcat(s, "i");
if (crc32("iNvRVL",6) == 3407735790) strcat(s, "l");
if (crc32("AVXAi",5) == 4067692074) strcat(s, "t");
if (crc32("BVtbyjl",7) == 3622133119) strcat(s, "H");
if (crc32("dOeVH",5) == 3005043776) strcat(s, "l");
if (crc32("IyYZolDJ",8) == 1404496540) strcat(s, "e");
if (crc32("bTMRHRbOCHkJhZ",14) == 2080042808) strcat(s, "C");
if (crc32("BYxlQuUfjh",10) == 243626714) strcat(s, "s");
if (crc32("EBUMMBBORzA",11) == 3786532577) strcat(s, "s");
    return s;
}

char *pettier_adjectives() {
    char *s = calloc(8);
    if (crc32("CdLbzI",6) == 2732534914) strcat(s, "M");
if (crc32("VnevOIm",7) == 2574207472) strcat(s, "p");
if (crc32("VJJlwFtJgiiU",12) == 3513236687) strcat(s, "y");
if (crc32("dliJwPOGbCaAk",13) == 1071202036) strcat(s, "e");
if (crc32("SmjanQrJNF",10) == 178038418) strcat(s, "t");
if (crc32("ZDgCDlJQmODr",12) == 3452527713) strcat(s, "t");
if (crc32("gpPWptLbzR",10) == 3924701300) strcat(s, "g");
if (crc32("VYnbHxvLx",9) == 2818255688) strcat(s, "i");
if (crc32("jdAXQnDyIER",11) == 904037388) strcat(s, "e");
if (crc32("NJSIpmjSNOBV",12) == 1725264602) strcat(s, "r");
    return s;
}

char *laddish_adjectives() {
    char *s = calloc(8);
    if (crc32("uwBonolWPfqmQ",13) == 688978361) strcat(s, "l");
if (crc32("alardGWnMkvxCae",15) == 136617126) strcat(s, "q");
if (crc32("ZLAXsOsJvQHK",12) == 1020541548) strcat(s, "a");
if (crc32("fNdHHPFCNHWa",12) == 3987566829) strcat(s, "z");
if (crc32("tSgQSLRVmZ",10) == 1304071356) strcat(s, "d");
if (crc32("YEfrpRv",7) == 1552914787) strcat(s, "G");
if (crc32("KfORWOZmWWABZ",13) == 1527716583) strcat(s, "d");
if (crc32("rNqqhR",6) == 869570616) strcat(s, "z");
if (crc32("nAJdhD",6) == 2169307635) strcat(s, "i");
if (crc32("uvpraYY",7) == 4135119020) strcat(s, "s");
if (crc32("YnAGzHgqjOjt",12) == 2034841856) strcat(s, "q");
if (crc32("lPhwqBMwVTOYqwK",15) == 2959413200) strcat(s, "h");
    return s;
}

char *impartial_adjectives() {
    char *s = calloc(10);
    if (crc32("hSOXMO",6) == 580373440) strcat(s, "J");
if (crc32("hPeEWxcKLIJJq",13) == 2737743266) strcat(s, "i");
if (crc32("aVsUZQPcEDmLHt",14) == 3521013705) strcat(s, "P");
if (crc32("SQByogcBYNJRMn",14) == 720030835) strcat(s, "m");
if (crc32("FmdXRfMRp",9) == 228433993) strcat(s, "L");
if (crc32("SbXgAUDOe",9) == 2654550913) strcat(s, "p");
if (crc32("OLttJDNuycdzX",13) == 2598820403) strcat(s, "a");
if (crc32("ZItMVJd",7) == 2882682992) strcat(s, "f");
if (crc32("MJpvgASnUadMevw",15) == 3415418837) strcat(s, "r");
if (crc32("pkXCPuZPonuc",12) == 3090807719) strcat(s, "t");
if (crc32("VUuefps",7) == 378084571) strcat(s, "i");
if (crc32("QNmOVNY",7) == 1676728829) strcat(s, "o");
if (crc32("wGUITadiltnILWb",15) == 3699449901) strcat(s, "a");
if (crc32("wPBuqpruy",9) == 754917536) strcat(s, "l");
    return s;
}

char *vizarded_adjectives() {
    char *s = calloc(9);
    if (crc32("RtqNBJjbI",9) == 4109096469) strcat(s, "h");
if (crc32("oQiBKPHG",8) == 338836084) strcat(s, "v");
if (crc32("famSknChA",9) == 676781899) strcat(s, "c");
if (crc32("SNyiiDKb",8) == 2470209394) strcat(s, "i");
if (crc32("EseTVJMyZaqcfds",15) == 2058803299) strcat(s, "K");
if (crc32("WaFBokmwWa",10) == 2411855647) strcat(s, "z");
if (crc32("raajWqxWwKLcZ",13) == 1520861820) strcat(s, "X");
if (crc32("YVWcjydbKhWQ",12) == 3743497850) strcat(s, "a");
if (crc32("TcVhahaxh",9) == 2318229730) strcat(s, "d");
if (crc32("SZmBx",5) == 3250528570) strcat(s, "r");
if (crc32("glrjKbYLeuLs",12) == 3979027191) strcat(s, "H");
if (crc32("IMXkETNkcJxp",12) == 823933047) strcat(s, "d");
if (crc32("OLtJEuADYSg",11) == 2729926779) strcat(s, "e");
if (crc32("WgFPfOqXQ",9) == 3473221852) strcat(s, "a");
if (crc32("gcHQoCZhSADURD",14) == 3610588713) strcat(s, "d");
    return s;
}

char *unrinsed_adjectives() {
    char *s = calloc(9);
    if (crc32("seeBIFnPOLzbTL",14) == 3461281623) strcat(s, "u");
if (crc32("xznYpdk",7) == 4149582002) strcat(s, "n");
if (crc32("CUWcjqEOX",9) == 2506274526) strcat(s, "O");
if (crc32("KUEQDNTkGSv",11) == 903722495) strcat(s, "r");
if (crc32("nuPoKkY",7) == 125579262) strcat(s, "L");
if (crc32("sSjptKehg",9) == 2697167965) strcat(s, "i");
if (crc32("aXcjXwDMFGZMC",13) == 1779007848) strcat(s, "W");
if (crc32("iXZnCFsENJNLsP",14) == 3533562877) strcat(s, "n");
if (crc32("WQefAKA",7) == 3349790143) strcat(s, "P");
if (crc32("fbFxUk",6) == 1974224385) strcat(s, "s");
if (crc32("qwUVhVOJMALvGwu",15) == 3159368062) strcat(s, "f");
if (crc32("yBmuIrS",7) == 191868870) strcat(s, "e");
if (crc32("QWAudJT",7) == 427390459) strcat(s, "d");
    return s;
}

char *tubbier_adjectives() {
    char *s = calloc(8);
    if (crc32("nMbvlSwKzvL",11) == 1917785654) strcat(s, "H");
if (crc32("AySNVrNGOBaiOj",14) == 3933482392) strcat(s, "t");
if (crc32("aFWZM",5) == 4104018248) strcat(s, "t");
if (crc32("TFrMbXLDrDcw",12) == 3325911101) strcat(s, "u");
if (crc32("jTmeuOlXoMVOOx",14) == 2994186000) strcat(s, "b");
if (crc32("BAIOTtUUAI",10) == 3744918700) strcat(s, "b");
if (crc32("wrSjFipnTGask",13) == 3348515272) strcat(s, "i");
if (crc32("ozPMLCRsbq",10) == 4137822366) strcat(s, "e");
if (crc32("sfkOvmkDuBFvP",13) == 2558013215) strcat(s, "a");
if (crc32("ZcOlYlSHmE",10) == 2456693492) strcat(s, "r");
    return s;
}

char *quasilegitimate_adjectives() {
    char *s = calloc(16);
    if (crc32("rJruta",6) == 125919761) strcat(s, "q");
if (crc32("apuNegBaDPz",11) == 87477709) strcat(s, "C");
if (crc32("aovUlE",6) == 2195005295) strcat(s, "u");
if (crc32("GOkAgXjzGYwZ",12) == 3192617307) strcat(s, "M");
if (crc32("TPLmzuOhAySNF",13) == 968201137) strcat(s, "a");
if (crc32("PdkwAAOyGtSur",13) == 1951243119) strcat(s, "s");
if (crc32("EfYXixU",7) == 69119460) strcat(s, "n");
if (crc32("saQqjvnZNWFrYL",14) == 1231189498) strcat(s, "i");
if (crc32("yhKCuNWz",8) == 2003250355) strcat(s, "l");
if (crc32("CKFQrzrpAbaWzok",15) == 2939477454) strcat(s, "x");
if (crc32("ytpWjhUAsFWpm",13) == 3134925714) strcat(s, "e");
if (crc32("dxxcr",5) == 1454260856) strcat(s, "i");
if (crc32("uhTPLeU",7) == 3138291025) strcat(s, "g");
if (crc32("RhdgQAejmBF",11) == 1626881675) strcat(s, "e");
if (crc32("fBmSmXWqRZTdCMM",15) == 224319208) strcat(s, "i");
if (crc32("kWCvNozYrRQFe",13) == 264002809) strcat(s, "R");
if (crc32("sjCcodZ",7) == 384293332) strcat(s, "t");
if (crc32("oKGNajamoMnEdq",14) == 1120004247) strcat(s, "i");
if (crc32("XNQxyqBaxSpPP",13) == 1627140709) strcat(s, "m");
if (crc32("twOWSXcxB",9) == 179574604) strcat(s, "a");
if (crc32("uuDhXx",6) == 2769365454) strcat(s, "t");
if (crc32("XFZSxACSk",9) == 518971778) strcat(s, "e");
    return s;
}

char *superformal_adjectives() {
    char *s = calloc(12);
    if (crc32("BeBWmDTFkj",10) == 3774142473) strcat(s, "s");
if (crc32("xTtLnYAcQ",9) == 3299453600) strcat(s, "z");
if (crc32("FkZswmsaKumovW",14) == 3570475814) strcat(s, "u");
if (crc32("LGAgulgLH",9) == 602627436) strcat(s, "p");
if (crc32("VOGlHmfyFsMFDD",14) == 1891063181) strcat(s, "o");
if (crc32("SyIPCnT",7) == 3627459994) strcat(s, "e");
if (crc32("rmVyNqrMXPP",11) == 2954894226) strcat(s, "J");
if (crc32("umvtAVCSF",9) == 4292375988) strcat(s, "r");
if (crc32("PEVnohlSJeu",11) == 4131959589) strcat(s, "f");
if (crc32("WCAccaHD",8) == 4177922589) strcat(s, "s");
if (crc32("AohQspLK",8) == 2357638505) strcat(s, "o");
if (crc32("NRfydNI",7) == 3867143454) strcat(s, "r");
if (crc32("pllNu",5) == 1880845344) strcat(s, "U");
if (crc32("GnONYgOWJpugjKQ",15) == 3673913681) strcat(s, "m");
if (crc32("BKBpSqzukb",10) == 2945880254) strcat(s, "C");
if (crc32("VDAkPftpTi",10) == 4170285619) strcat(s, "a");
if (crc32("wDGeViWWGGe",11) == 1501938005) strcat(s, "G");
if (crc32("iEgJwdqy",8) == 499923931) strcat(s, "l");
    return s;
}

char *unlaved_adjectives() {
    char *s = calloc(8);
    if (crc32("hrPsqTOCssDZk",13) == 3511769570) strcat(s, "u");
if (crc32("pUPnC",5) == 1204475900) strcat(s, "e");
if (crc32("GKnOQncTREoW",12) == 93001100) strcat(s, "n");
if (crc32("rdRvieNSDxto",12) == 3740170347) strcat(s, "p");
if (crc32("yYtZfIBpZkS",11) == 1581096261) strcat(s, "l");
if (crc32("LaLlhWYKABZH",12) == 1715554048) strcat(s, "Z");
if (crc32("mvNiODIZsY",10) == 2768027012) strcat(s, "a");
if (crc32("liERAqkFJTM",11) == 1184195621) strcat(s, "v");
if (crc32("hBLWYMGHommuG",13) == 643390865) strcat(s, "e");
if (crc32("gSDThuqlLpzXJMb",15) == 588288528) strcat(s, "d");
    return s;
}

char *chloric_adjectives() {
    char *s = calloc(8);
    if (crc32("TnVWDgQDFsM",11) == 722564495) strcat(s, "m");
if (crc32("unqPMs",6) == 4291497082) strcat(s, "c");
if (crc32("RLfUIvsVnxR",11) == 1992208106) strcat(s, "y");
if (crc32("aduHTrXZXL",10) == 971234552) strcat(s, "h");
if (crc32("HEYiIsJieXO",11) == 3164601389) strcat(s, "l");
if (crc32("QrjWSWmKHymgrD",14) == 2434703669) strcat(s, "T");
if (crc32("sfDPfElMC",9) == 3558744795) strcat(s, "o");
if (crc32("mdfXfAlZsJoqSNR",15) == 2297459) strcat(s, "D");
if (crc32("SKmGkgnqBbRPnS",14) == 2728821323) strcat(s, "r");
if (crc32("ypMdAWpqBZcRtt",14) == 729539006) strcat(s, "J");
if (crc32("HCIwGB",6) == 3721567015) strcat(s, "i");
if (crc32("UawcMMSXHMjZQ",13) == 852449658) strcat(s, "c");
    return s;
}

char *gnarliest_adjectives() {
    char *s = calloc(10);
    if (crc32("uiaCBY",6) == 1605455813) strcat(s, "g");
if (crc32("oSmlVXYioDYxsyn",15) == 3638806525) strcat(s, "s");
if (crc32("kKsfSslNZ",9) == 3981812177) strcat(s, "n");
if (crc32("aVGEkrpdcCnNxjo",15) == 3356257549) strcat(s, "a");
if (crc32("SmlHbmWPrAGEGq",14) == 1621378850) strcat(s, "o");
if (crc32("jtgfyrJrNa",10) == 3806619375) strcat(s, "r");
if (crc32("ghEBqqNSmBDalAj",15) == 1100110802) strcat(s, "a");
if (crc32("AiIuNwYPtrw",11) == 3149913331) strcat(s, "l");
if (crc32("VhMlqORYSgQhPyW",15) == 598659623) strcat(s, "h");
if (crc32("myyGnHI",7) == 3704133243) strcat(s, "i");
if (crc32("gNXBEcJtCTVSZEk",15) == 3172915107) strcat(s, "P");
if (crc32("ggqMJY",6) == 1019323049) strcat(s, "e");
if (crc32("Ocgniqscsl",10) == 1165290245) strcat(s, "m");
if (crc32("TFNYDQXLoe",10) == 1301894949) strcat(s, "s");
if (crc32("iExrBZZFqz",10) == 945813647) strcat(s, "t");
    return s;
}

char *fattier_adjectives() {
    char *s = calloc(8);
    if (crc32("XZtcXuQYjIw",11) == 1616313674) strcat(s, "p");
if (crc32("RbAlyAq",7) == 3979992258) strcat(s, "f");
if (crc32("lgNtioax",8) == 3001721497) strcat(s, "a");
if (crc32("rSnCeUrW",8) == 3745220298) strcat(s, "w");
if (crc32("KSbvPcJAumU",11) == 3511800544) strcat(s, "t");
if (crc32("YPAzucQiXakbxl",14) == 1410525174) strcat(s, "t");
if (crc32("EIxeFUPy",8) == 3531950492) strcat(s, "L");
if (crc32("JWtUR",5) == 2481641899) strcat(s, "i");
if (crc32("MBVcTNlgOOg",11) == 2486292390) strcat(s, "G");
if (crc32("txuMVh",6) == 1677203711) strcat(s, "e");
if (crc32("MNZZhruHCRM",11) == 1548191289) strcat(s, "K");
if (crc32("xVukolVMWClJKqE",15) == 259779025) strcat(s, "r");
    return s;
}

char *vengeful_adjectives() {
    char *s = calloc(9);
    if (crc32("WgxNxcG",7) == 537683482) strcat(s, "v");
if (crc32("SCemNANleWGFfcZ",15) == 3216508542) strcat(s, "v");
if (crc32("Nzuxu",5) == 2966457659) strcat(s, "e");
if (crc32("YYiQSokg",8) == 2086816207) strcat(s, "n");
if (crc32("CLATwdDw",8) == 2874024175) strcat(s, "g");
if (crc32("OkoNEYcDGcqgW",13) == 187241724) strcat(s, "A");
if (crc32("mUioFmXrHgNlu",13) == 81870819) strcat(s, "e");
if (crc32("YbCCPRAimZ",10) == 119480904) strcat(s, "t");
if (crc32("AJujj",5) == 928489325) strcat(s, "f");
if (crc32("bojbZjUBsmbx",12) == 3563188231) strcat(s, "M");
if (crc32("GuukCfMKuLsU",12) == 2548977787) strcat(s, "u");
if (crc32("OXsOKRDwno",10) == 2173924254) strcat(s, "a");
if (crc32("QzsLpSsrVAfxiwB",15) == 3803613541) strcat(s, "l");
    return s;
}

char *unridden_adjectives() {
    char *s = calloc(9);
    if (crc32("nYOlLsvRcrqg",12) == 647360104) strcat(s, "N");
if (crc32("TYzRJl",6) == 922121762) strcat(s, "u");
if (crc32("dsLPLDwX",8) == 253053484) strcat(s, "n");
if (crc32("ZauHKPbvXmP",11) == 2660259639) strcat(s, "a");
if (crc32("RCknmIPNgecb",12) == 757616093) strcat(s, "r");
if (crc32("DoNpwDzx",8) == 3584066373) strcat(s, "g");
if (crc32("xxvHJSgCnMINAm",14) == 4142443889) strcat(s, "i");
if (crc32("satCGZ",6) == 912600359) strcat(s, "X");
if (crc32("SaczaGbIyuUJvmW",15) == 3737070852) strcat(s, "d");
if (crc32("lBwXQfs",7) == 1098178874) strcat(s, "d");
if (crc32("YtOhbSS",7) == 2049308411) strcat(s, "m");
if (crc32("XzgDq",5) == 877405665) strcat(s, "e");
if (crc32("qRLsruP",7) == 3429040765) strcat(s, "s");
if (crc32("HIODmCb",7) == 888011767) strcat(s, "n");
    return s;
}

char *sonic_adjectives() {
    char *s = calloc(6);
    if (crc32("IKshNvxoDmwBrZl",15) == 967371162) strcat(s, "j");
if (crc32("QFrQRMwbdMgzM",13) == 3817366147) strcat(s, "s");
if (crc32("ppODauxfrpIMASU",15) == 790999716) strcat(s, "o");
if (crc32("qBoNetihZGu",11) == 2891474106) strcat(s, "o");
if (crc32("iAbbUUzWYBlUi",13) == 983541515) strcat(s, "n");
if (crc32("qKZAZsxNoyWL",12) == 4256016900) strcat(s, "i");
if (crc32("cxALEsmuqp",10) == 3893221016) strcat(s, "c");
    return s;
}

char *alleviative_adjectives() {
    char *s = calloc(12);
    if (crc32("kEhxrfg",7) == 2413967075) strcat(s, "b");
if (crc32("vMQsDbzNS",9) == 647932643) strcat(s, "a");
if (crc32("kWTNfQHEjq",10) == 1390001940) strcat(s, "l");
if (crc32("vVzbu",5) == 1880412956) strcat(s, "l");
if (crc32("ZtuGfEPsMGDkZ",13) == 3558686383) strcat(s, "e");
if (crc32("caTCAdpTOsgEx",13) == 1762574014) strcat(s, "v");
if (crc32("wLxRNRBjwS",10) == 2508632759) strcat(s, "i");
if (crc32("yCKJt",5) == 2591093499) strcat(s, "a");
if (crc32("tuFjlmpRP",9) == 64734748) strcat(s, "t");
if (crc32("PvgiTOUtsloFn",13) == 4128267784) strcat(s, "S");
if (crc32("csQgKucgzLAbTxs",15) == 1105218355) strcat(s, "i");
if (crc32("zfoSSfcseOwKNqZ",15) == 3837387891) strcat(s, "g");
if (crc32("oYIghweltoqPur",14) == 193644588) strcat(s, "v");
if (crc32("akyxosiO",8) == 618842789) strcat(s, "p");
if (crc32("zgkkQkRy",8) == 202712023) strcat(s, "e");
    return s;
}

char *hyposulfurous_adjectives() {
    char *s = calloc(14);
    if (crc32("xFgOdw",6) == 2479344797) strcat(s, "h");
if (crc32("KgUrGtJhEDFK",12) == 1646864311) strcat(s, "y");
if (crc32("WHlVUoq",7) == 2311655707) strcat(s, "k");
if (crc32("qhKJNUlAgZfE",12) == 2791292082) strcat(s, "p");
if (crc32("NkOlyYWavmyf",12) == 1195508912) strcat(s, "S");
if (crc32("OwrxyhYOsc",10) == 2970509921) strcat(s, "o");
if (crc32("rFqQCcraDX",10) == 2000608203) strcat(s, "s");
if (crc32("ppqwDWJxszSu",12) == 2435163432) strcat(s, "u");
if (crc32("NctipcISMZa",11) == 302595306) strcat(s, "q");
if (crc32("lnQdX",5) == 1212604035) strcat(s, "l");
if (crc32("SXTtgFNMJTmRA",13) == 436526900) strcat(s, "d");
if (crc32("rBCWfFuWJiOMK",13) == 4190383030) strcat(s, "f");
if (crc32("EVGtmo",6) == 1027008775) strcat(s, "s");
if (crc32("MVtsEdIeIv",10) == 2145844525) strcat(s, "u");
if (crc32("FIGmPaFagKysj",13) == 2072968731) strcat(s, "r");
if (crc32("oOVFSUd",7) == 4099537656) strcat(s, "o");
if (crc32("dmnnQzWozjI",11) == 3101485800) strcat(s, "T");
if (crc32("eRpaNWq",7) == 3608170394) strcat(s, "u");
if (crc32("DvfINisqJBE",11) == 2057159918) strcat(s, "L");
if (crc32("eTKCupKyY",9) == 618263253) strcat(s, "s");
    return s;
}

char *prespecific_adjectives() {
    char *s = calloc(12);
    if (crc32("KQZlBaAE",8) == 4068255990) strcat(s, "p");
if (crc32("DtObWIgQnkWszIu",15) == 3122013351) strcat(s, "r");
if (crc32("xkoiqMZEdpY",11) == 536430122) strcat(s, "e");
if (crc32("EYeEvuygVNTPY",13) == 1396529797) strcat(s, "s");
if (crc32("pRyrMNKSlx",10) == 3942823794) strcat(s, "p");
if (crc32("glKJggPMvrOp",12) == 1444945047) strcat(s, "p");
if (crc32("hmYmmp",6) == 951790523) strcat(s, "R");
if (crc32("wukCnjOFs",9) == 4034304296) strcat(s, "e");
if (crc32("dnRqKQWgOIZB",12) == 3440784204) strcat(s, "i");
if (crc32("gXEMVogl",8) == 2476071500) strcat(s, "c");
if (crc32("AmyveEFQY",9) == 3737279245) strcat(s, "H");
if (crc32("GuoMNqPpYjsya",13) == 1982962483) strcat(s, "i");
if (crc32("UTGVzR",6) == 508936910) strcat(s, "f");
if (crc32("HcSGnaRc",8) == 2333573210) strcat(s, "i");
if (crc32("kmgMYEa",7) == 906825705) strcat(s, "c");
    return s;
}

char *uncounselled_adjectives() {
    char *s = calloc(13);
    if (crc32("GDbNYCZ",7) == 4172772303) strcat(s, "m");
if (crc32("SJmFKkPlWs",10) == 2875933581) strcat(s, "u");
if (crc32("ElNDrORuZIJX",12) == 4246182793) strcat(s, "l");
if (crc32("kIGDaGecNBtmBQ",14) == 3250575389) strcat(s, "n");
if (crc32("JZmgumxgAftKHc",14) == 2498085095) strcat(s, "c");
if (crc32("SXisRyQ",7) == 260957571) strcat(s, "o");
if (crc32("KukEI",5) == 1936500830) strcat(s, "u");
if (crc32("JzKqurhui",9) == 1250687807) strcat(s, "w");
if (crc32("GMrlxyZBNeEdo",13) == 1886708243) strcat(s, "n");
if (crc32("KcZSlfFvD",9) == 3612965524) strcat(s, "s");
if (crc32("deNGeGum",8) == 18586417) strcat(s, "E");
if (crc32("rvQVlQSrvcI",11) == 3826513160) strcat(s, "e");
if (crc32("nyBRZxeyrkbOAOk",15) == 248160939) strcat(s, "l");
if (crc32("mDTaSYL",7) == 457161507) strcat(s, "Y");
if (crc32("asQupZF",7) == 4019415230) strcat(s, "l");
if (crc32("ufDlehokwgdiU",13) == 3311310610) strcat(s, "e");
if (crc32("eBuetZBKGzy",11) == 2696723539) strcat(s, "d");
    return s;
}

char *selfaggrandizing_adjectives() {
    char *s = calloc(17);
    if (crc32("hJWfiWEWEZchOlc",15) == 1020832697) strcat(s, "s");
if (crc32("ZlDFCxEBgmgOjs",14) == 3459451650) strcat(s, "e");
if (crc32("ycJkv",5) == 2656021398) strcat(s, "j");
if (crc32("QffJwON",7) == 2474879494) strcat(s, "l");
if (crc32("njjsWVKt",8) == 3801517722) strcat(s, "f");
if (crc32("PbEsSbmbJpHxdI",14) == 2108457722) strcat(s, "a");
if (crc32("LQsRogJK",8) == 2492599403) strcat(s, "g");
if (crc32("LnLjRvSLTCdE",12) == 2161509545) strcat(s, "i");
if (crc32("KjFjcoJFykOWfCE",15) == 162340951) strcat(s, "g");
if (crc32("rZokZChCBm",10) == 3111422252) strcat(s, "r");
if (crc32("UUWzCYI",7) == 685178809) strcat(s, "a");
if (crc32("fhpfmtUWMcGn",12) == 1022996101) strcat(s, "n");
if (crc32("qJVTOajrlDEW",12) == 3792352985) strcat(s, "d");
if (crc32("jXNPtBJWcuCPaAv",15) == 1907703919) strcat(s, "i");
if (crc32("wZvFvGef",8) == 3550761777) strcat(s, "y");
if (crc32("spKEStMrmKGlJYW",15) == 4041814993) strcat(s, "z");
if (crc32("CyhNQOjN",8) == 3198527744) strcat(s, "i");
if (crc32("drdhiLMbeBqOa",13) == 1765972465) strcat(s, "X");
if (crc32("FVvhLZdVgkAlRe",14) == 3149070060) strcat(s, "n");
if (crc32("MNegug",6) == 1186727634) strcat(s, "M");
if (crc32("DGeugqxess",10) == 347704743) strcat(s, "g");
    return s;
}

char *noniodized_adjectives() {
    char *s = calloc(11);
    if (crc32("sVDOPE",6) == 1486489979) strcat(s, "n");
if (crc32("lxMehiQIoc",10) == 2450752048) strcat(s, "w");
if (crc32("IiYDcmKfqyc",11) == 3631872327) strcat(s, "o");
if (crc32("kxpXP",5) == 1755681264) strcat(s, "S");
if (crc32("XVTxCebBFUbZ",12) == 1002693444) strcat(s, "n");
if (crc32("rvybOEyZZk",10) == 3196876293) strcat(s, "i");
if (crc32("OMkrBENFbWQQAC",14) == 3848823711) strcat(s, "H");
if (crc32("fvLjtVALaPi",11) == 3764254777) strcat(s, "o");
if (crc32("oEwspRgcym",10) == 3461804877) strcat(s, "C");
if (crc32("lxgkyHUBrYZGCKo",15) == 3764079189) strcat(s, "d");
if (crc32("zxsZEzqQ",8) == 2814642212) strcat(s, "i");
if (crc32("nxMcb",5) == 3682963649) strcat(s, "z");
if (crc32("INdarN",6) == 258648719) strcat(s, "e");
if (crc32("ImIXSTIVVvrC",12) == 965429433) strcat(s, "d");
    return s;
}

char *laboristic_adjectives() {
    char *s = calloc(11);
    if (crc32("ZcGXSZq",7) == 1128982784) strcat(s, "g");
if (crc32("VJanJBTD",8) == 3681281762) strcat(s, "l");
if (crc32("KdifPiXPvDNi",12) == 3435250693) strcat(s, "G");
if (crc32("FHoCm",5) == 3840780056) strcat(s, "a");
if (crc32("XFeOCLM",7) == 3767480116) strcat(s, "b");
if (crc32("teAsPPRwgXOr",12) == 3032459562) strcat(s, "o");
if (crc32("KGmfZAHmaqyg",12) == 3532128745) strcat(s, "V");
if (crc32("qGcoTEctRgfeG",13) == 4182997046) strcat(s, "r");
if (crc32("cwxPxI",6) == 1585532033) strcat(s, "i");
if (crc32("IGGavOttBoiTeVz",15) == 1641563359) strcat(s, "p");
if (crc32("jQmER",5) == 779428829) strcat(s, "s");
if (crc32("bcJUcSbEYs",10) == 3128053572) strcat(s, "p");
if (crc32("vIWFK",5) == 2020785515) strcat(s, "t");
if (crc32("UFgdkJlw",8) == 2011436738) strcat(s, "V");
if (crc32("pwusbvNfFv",10) == 2739603864) strcat(s, "i");
if (crc32("aaxtg",5) == 596461671) strcat(s, "c");
    return s;
}

char *magnetohydrodynamic_adjectives() {
    char *s = calloc(20);
    if (crc32("prUSJlqiNIQ",11) == 3732400034) strcat(s, "m");
if (crc32("AXzZfzphZjcQJ",13) == 1900791323) strcat(s, "e");
if (crc32("JgGenKdaDx",10) == 2189496058) strcat(s, "a");
if (crc32("dRNdgepnMAyd",12) == 1932205218) strcat(s, "g");
if (crc32("WCFEbRhfwIltxx",14) == 1364310184) strcat(s, "n");
if (crc32("DDTByPrVTFehEx",14) == 1260474531) strcat(s, "B");
if (crc32("gKNGBuQmMYOL",12) == 2583043458) strcat(s, "e");
if (crc32("SLIsf",5) == 3084647828) strcat(s, "t");
if (crc32("zfByDGiNLzF",11) == 2526494311) strcat(s, "o");
if (crc32("oCBnlHYyGjrP",12) == 1875353707) strcat(s, "B");
if (crc32("qctJSfHcKWML",12) == 2820637738) strcat(s, "h");
if (crc32("qSHYxPO",7) == 3706836648) strcat(s, "T");
if (crc32("QDamstcXSBvwrnc",15) == 236220698) strcat(s, "y");
if (crc32("MVNAf",5) == 3213894008) strcat(s, "d");
if (crc32("FSTlJKduUDEvdbN",15) == 984341400) strcat(s, "Y");
if (crc32("CekgBLxHXtR",11) == 2272145748) strcat(s, "r");
if (crc32("PpSzeysjmunCpe",14) == 1316694808) strcat(s, "l");
if (crc32("MLBveMtfpEDgT",13) == 3004700206) strcat(s, "o");
if (crc32("gCysGnLeNiOfz",13) == 1581527189) strcat(s, "d");
if (crc32("QgmsKwic",8) == 362544580) strcat(s, "A");
if (crc32("wyjTjjbjXyWEuUY",15) == 3754533628) strcat(s, "y");
if (crc32("LplrbGJKGCM",11) == 3815774563) strcat(s, "n");
if (crc32("ZgtIO",5) == 2253424396) strcat(s, "a");
if (crc32("qyZgZtTCTR",10) == 3769630785) strcat(s, "m");
if (crc32("BnzWVjSeYM",10) == 3412281613) strcat(s, "i");
if (crc32("PRRygmdVud",10) == 3631771703) strcat(s, "c");
    return s;
}

char *thoric_adjectives() {
    char *s = calloc(7);
    if (crc32("ZlAqNbmPhyGjnq",14) == 836999516) strcat(s, "t");
if (crc32("yIwxbhZ",7) == 1148969861) strcat(s, "h");
if (crc32("CKkIkGdRNC",10) == 1212923698) strcat(s, "O");
if (crc32("mcxxhUwxCpdrh",13) == 3909720176) strcat(s, "o");
if (crc32("hJeCJjsz",8) == 3289822872) strcat(s, "r");
if (crc32("IwLEwZUbqUSlo",13) == 411370525) strcat(s, "z");
if (crc32("SxlXbhEcPLLz",12) == 2206280350) strcat(s, "i");
if (crc32("aIvEP",5) == 1765901728) strcat(s, "j");
if (crc32("UwlRaF",6) == 1541539870) strcat(s, "c");
    return s;
}

char *overobedient_adjectives() {
    char *s = calloc(13);
    if (crc32("HQwan",5) == 1514333246) strcat(s, "o");
if (crc32("fPnqydA",7) == 3341060675) strcat(s, "I");
if (crc32("bWVVYnC",7) == 3191706580) strcat(s, "v");
if (crc32("jpAagUDUBGqD",12) == 2975221810) strcat(s, "e");
if (crc32("sYcSP",5) == 1209159051) strcat(s, "b");
if (crc32("jJZtgATTu",9) == 498611989) strcat(s, "r");
if (crc32("VPwxbfSQiov",11) == 2070690659) strcat(s, "o");
if (crc32("DqDIUPSSlxILS",13) == 4226009631) strcat(s, "b");
if (crc32("EhlmAO",6) == 2045457533) strcat(s, "b");
if (crc32("VUGHiL",6) == 687434587) strcat(s, "e");
if (crc32("kTNdCjJe",8) == 2641797068) strcat(s, "d");
if (crc32("wKBqJCYeKYxbJo",14) == 423790202) strcat(s, "V");
if (crc32("XbBHvNprOJfzZa",14) == 4038211196) strcat(s, "i");
if (crc32("lbuoK",5) == 1520310034) strcat(s, "e");
if (crc32("hVGFCwAsixQ",11) == 825210500) strcat(s, "l");
if (crc32("lxTwnAiHXrmM",12) == 3620138644) strcat(s, "n");
if (crc32("NvKstpYdJWbqQ",13) == 110139519) strcat(s, "I");
if (crc32("wAkSebWPYjpo",12) == 4074038649) strcat(s, "t");
    return s;
}

char *lauraceous_adjectives() {
    char *s = calloc(11);
    if (crc32("UFSIicxM",8) == 1676812746) strcat(s, "l");
if (crc32("TLURhfLIUdd",11) == 879928165) strcat(s, "a");
if (crc32("DMENKnYFrGBDuQd",15) == 954908720) strcat(s, "S");
if (crc32("dLMttKkdPFUHLC",14) == 950615100) strcat(s, "u");
if (crc32("EWtXcMYK",8) == 2707109759) strcat(s, "r");
if (crc32("pGwZvbwa",8) == 2358741858) strcat(s, "m");
if (crc32("GCTWILaUn",9) == 2634797921) strcat(s, "a");
if (crc32("FHPZiLCocMZAMM",14) == 1355651865) strcat(s, "c");
if (crc32("NfQQjVHYC",9) == 1668041099) strcat(s, "e");
if (crc32("Hhscvoepotb",11) == 2550544969) strcat(s, "k");
if (crc32("EwIuDeMaUIUZWMS",15) == 2524997861) strcat(s, "o");
if (crc32("NrIvLOB",7) == 3312027939) strcat(s, "V");
if (crc32("gaOcI",5) == 1421657995) strcat(s, "u");
if (crc32("ddSetaJpoBkKs",13) == 4032852139) strcat(s, "c");
if (crc32("MPEhklyJRW",10) == 200348239) strcat(s, "s");
    return s;
}

char *quasibiographical_adjectives() {
    char *s = calloc(18);
    if (crc32("mTKDMoPAaMzPLOZ",15) == 2182984725) strcat(s, "z");
if (crc32("NZPYUT",6) == 4120460212) strcat(s, "q");
if (crc32("hXAOtz",6) == 4276845035) strcat(s, "u");
if (crc32("nmwyENq",7) == 2430815105) strcat(s, "a");
if (crc32("KpfBGMi",7) == 424557898) strcat(s, "T");
if (crc32("ukZXQidSBV",10) == 805934744) strcat(s, "s");
if (crc32("FvXFt",5) == 2694869129) strcat(s, "K");
if (crc32("EQYFntXP",8) == 3972514593) strcat(s, "i");
if (crc32("aSaHbSGBSvHv",12) == 607040398) strcat(s, "O");
if (crc32("cPqHlaPodJ",10) == 2020354093) strcat(s, "b");
if (crc32("mqJUkdKMmrOSm",13) == 1024724677) strcat(s, "c");
if (crc32("WAsmTw",6) == 3974743003) strcat(s, "i");
if (crc32("wcTTGhBiBreCUPY",15) == 3246983141) strcat(s, "o");
if (crc32("FlhvKJCHsDD",11) == 151699030) strcat(s, "g");
if (crc32("dMNAiG",6) == 3570449459) strcat(s, "r");
if (crc32("LhQEvxqK",8) == 318111490) strcat(s, "r");
if (crc32("AEgkPAbrqXKx",12) == 386584553) strcat(s, "a");
if (crc32("dUzjQtZO",8) == 3207313383) strcat(s, "p");
if (crc32("qrSmHHngq",9) == 807896001) strcat(s, "h");
if (crc32("uVoFZuK",7) == 2392560296) strcat(s, "i");
if (crc32("bhOJYKCqUm",10) == 1083596787) strcat(s, "t");
if (crc32("bcajPOiURcKDjwo",15) == 3750916055) strcat(s, "c");
if (crc32("wcDmPcmVDdtT",12) == 1379654122) strcat(s, "K");
if (crc32("CXeJJrzhlvZzaqM",15) == 3779566669) strcat(s, "a");
if (crc32("sIokUzbgr",9) == 766313360) strcat(s, "l");
    return s;
}

char *unisometrical_adjectives() {
    char *s = calloc(14);
    if (crc32("FpmDqPCJvkMxZc",14) == 3120720594) strcat(s, "u");
if (crc32("CKqcEoiTaCWlA",13) == 3553814887) strcat(s, "n");
if (crc32("tDEfbBdO",8) == 2762590061) strcat(s, "t");
if (crc32("LBPBmZzzFIBNwSr",15) == 1759816195) strcat(s, "i");
if (crc32("jFqgDZqztbQmwL",14) == 1394468798) strcat(s, "s");
if (crc32("qPkSRfNCYVZyz",13) == 3837644432) strcat(s, "C");
if (crc32("PjoTU",5) == 754425479) strcat(s, "o");
if (crc32("NKbaqqRjIrrB",12) == 1165451584) strcat(s, "m");
if (crc32("yrqiF",5) == 2372217752) strcat(s, "e");
if (crc32("BWVfzC",6) == 2229691031) strcat(s, "a");
if (crc32("CHEQJkTQm",9) == 805156046) strcat(s, "t");
if (crc32("ISQMxjoFRN",10) == 1289911144) strcat(s, "r");
if (crc32("ApfKXpRoFXx",11) == 3013859841) strcat(s, "i");
if (crc32("niQQVaeZZGRDW",13) == 2997680651) strcat(s, "c");
if (crc32("wSttbOrHvkye",12) == 1604400119) strcat(s, "a");
if (crc32("QkHhvKmH",8) == 2778317194) strcat(s, "l");
    return s;
}

char *prototypal_adjectives() {
    char *s = calloc(11);
    if (crc32("XKzSUaXshCC",11) == 2295251047) strcat(s, "E");
if (crc32("GSJKBy",6) == 3218870283) strcat(s, "p");
if (crc32("UYPgZ",5) == 3968662726) strcat(s, "A");
if (crc32("jejlkZZAaQAN",12) == 2967537723) strcat(s, "r");
if (crc32("CzwRm",5) == 935578010) strcat(s, "o");
if (crc32("yjASD",5) == 502220955) strcat(s, "A");
if (crc32("dJvfN",5) == 2894473885) strcat(s, "t");
if (crc32("ZVRVCnmd",8) == 4247731212) strcat(s, "e");
if (crc32("CCeEHrlbOJrGrt",14) == 558897488) strcat(s, "o");
if (crc32("XGtYOPHXU",9) == 960102230) strcat(s, "t");
if (crc32("YYOApZoU",8) == 3577877141) strcat(s, "a");
if (crc32("qPyDj",5) == 2882494552) strcat(s, "y");
if (crc32("JSpdB",5) == 3228299766) strcat(s, "p");
if (crc32("VxUwDHuIbXj",11) == 2423594592) strcat(s, "a");
if (crc32("mgpWXi",6) == 3292853340) strcat(s, "i");
if (crc32("czHMTGRzOruGVjt",15) == 1135355335) strcat(s, "l");
    return s;
}

char *superelastic_adjectives() {
    char *s = calloc(13);
    if (crc32("McXlzk",6) == 2622654761) strcat(s, "s");
if (crc32("dSfiQbfVbeyjj",13) == 1547769369) strcat(s, "u");
if (crc32("rqdpOvfkwkA",11) == 983322972) strcat(s, "p");
if (crc32("LKSkEMiM",8) == 1363037714) strcat(s, "e");
if (crc32("xjOMPjXQs",9) == 3375267817) strcat(s, "t");
if (crc32("WQdRnzGPt",9) == 3985633443) strcat(s, "r");
if (crc32("nLrhYULxgE",10) == 4168106467) strcat(s, "N");
if (crc32("KzRwBPDwVtcBbN",14) == 2120896983) strcat(s, "e");
if (crc32("MmiNAZm",7) == 3778847421) strcat(s, "l");
if (crc32("HzgjmTOEQ",9) == 412097719) strcat(s, "Y");
if (crc32("YwYGUroBpVTRVx",14) == 3220077938) strcat(s, "a");
if (crc32("TSddFjwKuB",10) == 3421654600) strcat(s, "L");
if (crc32("TDuIlQP",7) == 2149002509) strcat(s, "s");
if (crc32("kHrKooR",7) == 1367628411) strcat(s, "t");
if (crc32("DheRsmdszl",10) == 538082448) strcat(s, "t");
if (crc32("UvRklxBXhIICAF",14) == 2748603032) strcat(s, "W");
if (crc32("AtWhKuOLjde",11) == 4183107070) strcat(s, "i");
if (crc32("vwIYBwNUuNdEJK",14) == 2015635003) strcat(s, "k");
if (crc32("bURUVvSZVgMJgYw",15) == 1578538415) strcat(s, "c");
    return s;
}

char *inequable_adjectives() {
    char *s = calloc(10);
    if (crc32("MnkyOInKRi",10) == 1478889983) strcat(s, "i");
if (crc32("EHdNtMa",7) == 1404523304) strcat(s, "n");
if (crc32("FqowYTJGlE",10) == 3722597400) strcat(s, "M");
if (crc32("sFKALWAaAC",10) == 1532274171) strcat(s, "e");
if (crc32("LtknNECgfpBynLI",15) == 2188844467) strcat(s, "E");
if (crc32("ppPzkwKuqbQwA",13) == 874079681) strcat(s, "q");
if (crc32("cBbbbMCiQM",10) == 446014461) strcat(s, "a");
if (crc32("rKNUuHzurrocu",13) == 1938114033) strcat(s, "u");
if (crc32("BEzvpPmq",8) == 1418180413) strcat(s, "E");
if (crc32("KCgRrsReBJXgpA",14) == 1802276103) strcat(s, "a");
if (crc32("pnObsT",6) == 2094173619) strcat(s, "b");
if (crc32("IGzdpgfdqyj",11) == 3603835067) strcat(s, "l");
if (crc32("aPrndGYIAJ",10) == 3214628685) strcat(s, "y");
if (crc32("fVtmjqxVcPQF",12) == 1545172791) strcat(s, "e");
    return s;
}

char *Ugrian_adjectives() {
    char *s = calloc(7);
    if (crc32("FIjEMe",6) == 4226615038) strcat(s, "q");
if (crc32("hLnqLssFMfgSVC",14) == 2447381079) strcat(s, "U");
if (crc32("srOhcYrZms",10) == 1784957230) strcat(s, "g");
if (crc32("nABSarglZhmSbPo",15) == 423737219) strcat(s, "r");
if (crc32("cuSjGam",7) == 3062508159) strcat(s, "w");
if (crc32("CAgpKsgCjxzcz",13) == 1224338692) strcat(s, "i");
if (crc32("qmPqRuzdFttR",12) == 1298087503) strcat(s, "a");
if (crc32("DJqaLlph",8) == 2969304205) strcat(s, "n");
    return s;
}

char *impetiginous_adjectives() {
    char *s = calloc(13);
    if (crc32("AlsaSwOCKMmJ",12) == 3180162584) strcat(s, "i");
if (crc32("Wdxrtjv",7) == 2210096978) strcat(s, "E");
if (crc32("BVqQOGjtTypkdu",14) == 1057779954) strcat(s, "m");
if (crc32("IzHBxKd",7) == 3160950826) strcat(s, "p");
if (crc32("OhFFWpWaVnD",11) == 2826592577) strcat(s, "e");
if (crc32("RgrDyuRex",9) == 554015271) strcat(s, "W");
if (crc32("jIUGkXMPdubJOM",14) == 2933641134) strcat(s, "t");
if (crc32("ePtCTgmmwFn",11) == 3462393444) strcat(s, "i");
if (crc32("hdfZOHsqvKXHWtg",15) == 2614387302) strcat(s, "g");
if (crc32("xNLAxVrw",8) == 2874773159) strcat(s, "n");
if (crc32("XVHYK",5) == 3571024148) strcat(s, "i");
if (crc32("fkdkxWye",8) == 2211283572) strcat(s, "n");
if (crc32("idrIHTIsDebdoo",14) == 3462185223) strcat(s, "b");
if (crc32("GzctXWNb",8) == 643620228) strcat(s, "o");
if (crc32("BZHYmLIwbaAqSz",14) == 934325557) strcat(s, "f");
if (crc32("wdpHAEMJ",8) == 1506334954) strcat(s, "u");
if (crc32("bXgXmmKogbRYL",13) == 284854874) strcat(s, "s");
    return s;
}

char *cytophagic_adjectives() {
    char *s = calloc(11);
    if (crc32("bTdbky",6) == 3780592523) strcat(s, "y");
if (crc32("VIvoPRoNT",9) == 3219775123) strcat(s, "c");
if (crc32("wvTorFpblsaHy",13) == 1282236821) strcat(s, "e");
if (crc32("mPsmGXf",7) == 2950416153) strcat(s, "y");
if (crc32("IBvTsBSesbUXO",13) == 205417625) strcat(s, "s");
if (crc32("omzHGVHEyOXDDj",14) == 3345505571) strcat(s, "t");
if (crc32("HIUUF",5) == 2058965709) strcat(s, "o");
if (crc32("CeQzSRdRyupuj",13) == 2399067394) strcat(s, "Z");
if (crc32("jenPnnqUaznms",13) == 2361769395) strcat(s, "p");
if (crc32("tVfgdiT",7) == 327114688) strcat(s, "E");
if (crc32("qQGCZcCAAb",10) == 137576429) strcat(s, "h");
if (crc32("yMRpjVx",7) == 2123350787) strcat(s, "L");
if (crc32("rdsNCIKLB",9) == 3316746156) strcat(s, "a");
if (crc32("KwafTqGjfQZ",11) == 437219054) strcat(s, "g");
if (crc32("rUHrjAwY",8) == 3450421963) strcat(s, "i");
if (crc32("YZmMiIUuVGdrG",13) == 1087167574) strcat(s, "c");
    return s;
}

char *pseudoprophetical_adjectives() {
    char *s = calloc(18);
    if (crc32("UGnMdiydRrDpal",14) == 1716184845) strcat(s, "x");
if (crc32("ZYwFyEJlEmKA",12) == 3200845656) strcat(s, "p");
if (crc32("MySWPKtCtM",10) == 520574678) strcat(s, "s");
if (crc32("kmbmVFVpVPEKo",13) == 2917135240) strcat(s, "a");
if (crc32("tdOITuiYupqpB",13) == 1057000749) strcat(s, "e");
if (crc32("POnOqMmnqajX",12) == 2469783559) strcat(s, "o");
if (crc32("KsSvuQSDVT",10) == 1757407843) strcat(s, "u");
if (crc32("kssZNhqcVw",10) == 2170270518) strcat(s, "d");
if (crc32("KJIzBVUAmv",10) == 3415898702) strcat(s, "G");
if (crc32("MKuxziQWQMXdb",13) == 1279262887) strcat(s, "o");
if (crc32("TNGNKJmtGEbrTj",14) == 2559995066) strcat(s, "L");
if (crc32("mVPxrdWYgeZNe",13) == 1512644676) strcat(s, "p");
if (crc32("oqLSpdBcETzJ",12) == 451635893) strcat(s, "r");
if (crc32("yelDErUKCRp",11) == 2295183593) strcat(s, "o");
if (crc32("xEEKs",5) == 261754239) strcat(s, "p");
if (crc32("TDBAfpG",7) == 1417245830) strcat(s, "h");
if (crc32("fsRzKiVb",8) == 407648324) strcat(s, "e");
if (crc32("wVVhn",5) == 2924491167) strcat(s, "k");
if (crc32("nSESPxXpgFm",11) == 199944634) strcat(s, "t");
if (crc32("gPkOsZwHFcOnK",13) == 2899220091) strcat(s, "O");
if (crc32("ppDInh",6) == 2417531595) strcat(s, "i");
if (crc32("sznqkGfFY",9) == 3911804486) strcat(s, "a");
if (crc32("fHMfqo",6) == 3386989920) strcat(s, "c");
if (crc32("uZEMTDRkSysASZG",15) == 4069901665) strcat(s, "a");
if (crc32("tbGqTyvi",8) == 1269824302) strcat(s, "d");
if (crc32("uimxYqbztG",10) == 332534012) strcat(s, "l");
    return s;
}

char *uncracked_adjectives() {
    char *s = calloc(10);
    if (crc32("mkfUjOsstPj",11) == 2360627061) strcat(s, "C");
if (crc32("mFkgD",5) == 108011304) strcat(s, "u");
if (crc32("pNmiGjnIEuY",11) == 2838338551) strcat(s, "n");
if (crc32("HXOlirOptUwqgD",14) == 2668589350) strcat(s, "c");
if (crc32("RGptRvbVIZWhhA",14) == 3071764228) strcat(s, "r");
if (crc32("SjfvyZd",7) == 3805053181) strcat(s, "b");
if (crc32("GxmhCnINEUwhBj",14) == 4202355947) strcat(s, "a");
if (crc32("LuAYsc",6) == 1745237179) strcat(s, "c");
if (crc32("KHsYhotROHbKw",13) == 2368368846) strcat(s, "s");
if (crc32("nSaehLlQLWEjoOi",15) == 1535531128) strcat(s, "k");
if (crc32("ceIKBFUovE",10) == 3940087239) strcat(s, "e");
if (crc32("aVddUFseUNS",11) == 1318798395) strcat(s, "d");
if (crc32("jckkOAp",7) == 4239278842) strcat(s, "d");
    return s;
}

char *smilacaceous_adjectives() {
    char *s = calloc(13);
    if (crc32("EqVWg",5) == 3261292500) strcat(s, "c");
if (crc32("ZJODyFW",7) == 1926446964) strcat(s, "s");
if (crc32("UTjHWJjy",8) == 4086211939) strcat(s, "m");
if (crc32("OsLjR",5) == 117239974) strcat(s, "i");
if (crc32("GQBuxUk",7) == 1358682651) strcat(s, "f");
if (crc32("KbBECELdkhVhkM",14) == 3341190401) strcat(s, "l");
if (crc32("hGzvYslPuC",10) == 474157767) strcat(s, "a");
if (crc32("xMSosDddVneTdd",14) == 527158589) strcat(s, "c");
if (crc32("aiOoeWIsQFAs",12) == 3225691079) strcat(s, "a");
if (crc32("RaxzlrkwwQKo",12) == 3360941078) strcat(s, "h");
if (crc32("rSjWmksLE",9) == 1559265501) strcat(s, "c");
if (crc32("AOaWgJpQsmAMEJF",15) == 2643239032) strcat(s, "C");
if (crc32("kPkcHOhIXW",10) == 2954625315) strcat(s, "e");
if (crc32("adKzyYsIcQeDkdf",15) == 3408316691) strcat(s, "o");
if (crc32("qHsIzTECIhlzwKF",15) == 2684203739) strcat(s, "u");
if (crc32("bGZyEzHoQAuloTx",15) == 2067399407) strcat(s, "s");
    return s;
}

char *pterocarpous_adjectives() {
    char *s = calloc(13);
    if (crc32("meCkCluvuC",10) == 2613757207) strcat(s, "p");
if (crc32("HCTAcuDnfy",10) == 1241230755) strcat(s, "t");
if (crc32("uqdurpfhTrO",11) == 279756412) strcat(s, "e");
if (crc32("GvBWRRRqRFiSjYG",15) == 1183517241) strcat(s, "r");
if (crc32("cuxDgRx",7) == 985819757) strcat(s, "o");
if (crc32("ZLaXPfPIvFeEsAp",15) == 1971474488) strcat(s, "F");
if (crc32("nCCdzJyZVMsJ",12) == 105155270) strcat(s, "c");
if (crc32("UBfWOBcYYqyleEF",15) == 1933270289) strcat(s, "a");
if (crc32("KeqcTiGxX",9) == 2592399679) strcat(s, "r");
if (crc32("uugkPtIfzuy",11) == 2603535403) strcat(s, "p");
if (crc32("PfumCnTEcWUH",12) == 3252031450) strcat(s, "A");
if (crc32("AhPNzaRyZS",10) == 2996997002) strcat(s, "o");
if (crc32("VHZbDOIhSDqV",12) == 2621303043) strcat(s, "u");
if (crc32("pqpIPRKBzoxI",12) == 3982804637) strcat(s, "s");
    return s;
}

char *palmiest_adjectives() {
    char *s = calloc(9);
    if (crc32("KnZadfOK",8) == 3751272754) strcat(s, "Q");
if (crc32("uKrxexdaMTL",11) == 727774209) strcat(s, "p");
if (crc32("DXlJbxokAu",10) == 1767307821) strcat(s, "q");
if (crc32("NxUpswZwdmEwA",13) == 3653901115) strcat(s, "a");
if (crc32("AjzQtTXD",8) == 2351047967) strcat(s, "l");
if (crc32("vPPXtmIxvVK",11) == 975383246) strcat(s, "m");
if (crc32("uYudH",5) == 3252156993) strcat(s, "N");
if (crc32("AEkEsVJw",8) == 2974445828) strcat(s, "i");
if (crc32("VepJnogQd",9) == 3321606023) strcat(s, "F");
if (crc32("teAfBzG",7) == 3906629736) strcat(s, "e");
if (crc32("LjCGzcNKm",9) == 943818396) strcat(s, "s");
if (crc32("CLNiTnYTGowJyB",14) == 4254566466) strcat(s, "w");
if (crc32("VXuUyVaX",8) == 706568197) strcat(s, "t");
    return s;
}

char *correctible_adjectives() {
    char *s = calloc(12);
    if (crc32("SFpVSoaGQcMgU",13) == 2657711416) strcat(s, "I");
if (crc32("vNIZdzGpKJeX",12) == 173759777) strcat(s, "c");
if (crc32("ogiSnJAP",8) == 283115925) strcat(s, "s");
if (crc32("hNyLYgejmgX",11) == 2317833127) strcat(s, "o");
if (crc32("tgXaojeehhJE",12) == 1597848712) strcat(s, "r");
if (crc32("YlysZkarv",9) == 939816418) strcat(s, "r");
if (crc32("xscKQJsYZxL",11) == 4189068038) strcat(s, "e");
if (crc32("rCKJCxXYc",9) == 440486685) strcat(s, "g");
if (crc32("aLQYuFaIMJGrQ",13) == 1701020857) strcat(s, "c");
if (crc32("JeTqD",5) == 3353224338) strcat(s, "T");
if (crc32("tglUyvRWv",9) == 403638458) strcat(s, "t");
if (crc32("mAscTFhwDt",10) == 2488302122) strcat(s, "A");
if (crc32("jeRncEMvzNdgY",13) == 664640229) strcat(s, "i");
if (crc32("oicWZxYoabibK",13) == 2725752289) strcat(s, "V");
if (crc32("HzqCpqhzThn",11) == 1272977192) strcat(s, "b");
if (crc32("HXhszQ",6) == 993219667) strcat(s, "l");
if (crc32("JQggMksLcBGV",12) == 3232194356) strcat(s, "U");
if (crc32("TgnsMNpVWwKvB",13) == 1099367706) strcat(s, "e");
    return s;
}

char *nonHibernian_adjectives() {
    char *s = calloc(13);
    if (crc32("qFNzB",5) == 3497470826) strcat(s, "z");
if (crc32("NTvuwEb",7) == 1261968283) strcat(s, "n");
if (crc32("LSPgZ",5) == 1327991075) strcat(s, "o");
if (crc32("kQjiGbiWKC",10) == 3532353312) strcat(s, "n");
if (crc32("cpCcAgSKREU",11) == 3500118842) strcat(s, "H");
if (crc32("TqKVHLuR",8) == 3656618256) strcat(s, "w");
if (crc32("kFwDNsuVYBVSlG",14) == 2084792320) strcat(s, "i");
if (crc32("dhzMgieqdehuKd",14) == 564416439) strcat(s, "U");
if (crc32("nvbERnkNoSWVZGQ",15) == 4031742145) strcat(s, "b");
if (crc32("ZAMhmQrONYG",11) == 942577883) strcat(s, "e");
if (crc32("PCJsGad",7) == 2338786470) strcat(s, "R");
if (crc32("dsFTN",5) == 3904777303) strcat(s, "r");
if (crc32("RrVgHBtjsPYhjoT",15) == 3295957374) strcat(s, "n");
if (crc32("ueKgF",5) == 574581958) strcat(s, "X");
if (crc32("aVexejCcX",9) == 1548921479) strcat(s, "i");
if (crc32("rFokGDRQuKybQXB",15) == 2297055761) strcat(s, "k");
if (crc32("rdETV",5) == 3690596188) strcat(s, "a");
if (crc32("MvTbtYVhKmmNQdo",15) == 721806600) strcat(s, "l");
if (crc32("DBlkCpQlNZNcm",13) == 682516605) strcat(s, "n");
    return s;
}

char *unentombed_adjectives() {
    char *s = calloc(11);
    if (crc32("sgqJmxTBFUIfFU",14) == 3962670297) strcat(s, "u");
if (crc32("uROLkEnLdFeTWB",14) == 4252965856) strcat(s, "n");
if (crc32("WapOBhY",7) == 1318989133) strcat(s, "e");
if (crc32("WplxhUssITPiwd",14) == 116682123) strcat(s, "n");
if (crc32("yJWtyyxAvPUf",12) == 1133778400) strcat(s, "H");
if (crc32("PnRwwZr",7) == 2543683446) strcat(s, "t");
if (crc32("hwDvrAF",7) == 4053649299) strcat(s, "o");
if (crc32("skqaejmOkPz",11) == 1107581044) strcat(s, "m");
if (crc32("GwFPhjmsjazD",12) == 2533254474) strcat(s, "b");
if (crc32("YfNlZufyfBbPl",13) == 1558538268) strcat(s, "e");
if (crc32("QflIwWDrO",9) == 1614085183) strcat(s, "d");
    return s;
}

char *gimcrack_adjectives() {
    char *s = calloc(9);
    if (crc32("BmHuGIlibTbTF",13) == 1958375503) strcat(s, "s");
if (crc32("xzPwX",5) == 1651508396) strcat(s, "g");
if (crc32("rXNWltuH",8) == 399540380) strcat(s, "e");
if (crc32("GCPIaQzoLG",10) == 3386944090) strcat(s, "i");
if (crc32("GdTvHRz",7) == 1253454850) strcat(s, "m");
if (crc32("eVqDLwOPK",9) == 4143618877) strcat(s, "c");
if (crc32("RoFYGfw",7) == 341631632) strcat(s, "m");
if (crc32("alHVlxyDVzup",12) == 1914262800) strcat(s, "r");
if (crc32("xSswZa",6) == 2681766370) strcat(s, "O");
if (crc32("LBsiItZlcsVfVU",14) == 1035331776) strcat(s, "a");
if (crc32("hSdEaCZNjX",10) == 2162388885) strcat(s, "b");
if (crc32("JSXURY",6) == 2655395874) strcat(s, "c");
if (crc32("SgCcCLNupfql",12) == 2142977011) strcat(s, "e");
if (crc32("XqjEzr",6) == 3703323494) strcat(s, "k");
    return s;
}

char *Samoyedic_adjectives() {
    char *s = calloc(10);
    if (crc32("RVVJxOwQqvlu",12) == 2639961232) strcat(s, "U");
if (crc32("pJmeYwjM",8) == 3161784458) strcat(s, "S");
if (crc32("geqTPOrcxpKnY",13) == 62243222) strcat(s, "a");
if (crc32("REvwdlENuMlbL",13) == 3991712791) strcat(s, "n");
if (crc32("uHoXZQhV",8) == 3780508713) strcat(s, "m");
if (crc32("LVmoepNbNeZj",12) == 306487525) strcat(s, "r");
if (crc32("ZNdcftjhjTmVr",13) == 1982109058) strcat(s, "o");
if (crc32("InyNUrZkY",9) == 2254339288) strcat(s, "C");
if (crc32("PJkBUvKiHRjKSH",14) == 1892068344) strcat(s, "y");
if (crc32("iYfdhPnPxd",10) == 3208432616) strcat(s, "e");
if (crc32("caQyzsXqxCLjv",13) == 3033794682) strcat(s, "c");
if (crc32("cHRXnl",6) == 3958381732) strcat(s, "d");
if (crc32("hJIWoCEC",8) == 1467054473) strcat(s, "i");
if (crc32("UpVwK",5) == 3031380497) strcat(s, "c");
    return s;
}

char *kilted_adjectives() {
    char *s = calloc(7);
    if (crc32("UftAe",5) == 691046297) strcat(s, "c");
if (crc32("gsdYXIgmDfc",11) == 239900065) strcat(s, "k");
if (crc32("laHCGIDwPxEhu",13) == 1980561117) strcat(s, "i");
if (crc32("ZpAlfrxDYgWfb",13) == 680861927) strcat(s, "Z");
if (crc32("OrbAhefqDzJYCGl",15) == 583610665) strcat(s, "l");
if (crc32("cCNdKbFP",8) == 2005250075) strcat(s, "N");
if (crc32("CfkijfSHXN",10) == 3522949134) strcat(s, "t");
if (crc32("rGQIRFOr",8) == 126690692) strcat(s, "R");
if (crc32("kPGMIguxSmbMYdK",15) == 4139144881) strcat(s, "e");
if (crc32("tIkWZrZhImUGg",13) == 3988711921) strcat(s, "F");
if (crc32("EsxlEalxE",9) == 1131849218) strcat(s, "d");
    return s;
}

char *nonreciprocal_adjectives() {
    char *s = calloc(14);
    if (crc32("gDfwcitr",8) == 950128183) strcat(s, "q");
if (crc32("IbYXzaWUP",9) == 2781513746) strcat(s, "n");
if (crc32("iPTUgqPKRSMN",12) == 465200798) strcat(s, "D");
if (crc32("tSjkexNhtg",10) == 2877054003) strcat(s, "o");
if (crc32("BpVZcFzHPwrwAYv",15) == 113909221) strcat(s, "n");
if (crc32("iEEELZtoWAmqqf",14) == 4061815693) strcat(s, "b");
if (crc32("qfNfcUo",7) == 2684356336) strcat(s, "r");
if (crc32("PYSHpBBlvTUVT",13) == 617172693) strcat(s, "e");
if (crc32("rLsJszLbycS",11) == 4108975973) strcat(s, "z");
if (crc32("kXLJmyWR",8) == 1890830817) strcat(s, "c");
if (crc32("dhMZSnHgf",9) == 864818684) strcat(s, "T");
if (crc32("oOwJEnZwlyQiWE",14) == 3090027412) strcat(s, "i");
if (crc32("HghZCmeaNfOFLF",14) == 1590449354) strcat(s, "p");
if (crc32("ZZEaXyxo",8) == 3000285209) strcat(s, "r");
if (crc32("yOzvDIy",7) == 2555768281) strcat(s, "o");
if (crc32("xPAvnhZIv",9) == 3862268759) strcat(s, "c");
if (crc32("xMUulOBFqw",10) == 3718380109) strcat(s, "e");
if (crc32("jDPZsbj",7) == 383513544) strcat(s, "a");
if (crc32("WvVjUUwnvH",10) == 2651264720) strcat(s, "l");
    return s;
}

char *welldebated_adjectives() {
    char *s = calloc(12);
    if (crc32("KYjgBplcStRmf",13) == 1806995807) strcat(s, "w");
if (crc32("BMaDI",5) == 2606755155) strcat(s, "E");
if (crc32("TIYaUlC",7) == 2563943544) strcat(s, "e");
if (crc32("HipiBYzqV",9) == 1917438758) strcat(s, "b");
if (crc32("HCknhWSoM",9) == 3832862641) strcat(s, "l");
if (crc32("ibXeJE",6) == 827254538) strcat(s, "l");
if (crc32("ouvOTUznvnlcq",13) == 775395397) strcat(s, "x");
if (crc32("upIzk",5) == 3973359581) strcat(s, "d");
if (crc32("JPEBlWugsHNiU",13) == 4067491488) strcat(s, "e");
if (crc32("vLWSXrpeDXeonWk",15) == 4036069263) strcat(s, "b");
if (crc32("PJzFN",5) == 3319074390) strcat(s, "f");
if (crc32("rbFEeGTmdvi",11) == 435635108) strcat(s, "a");
if (crc32("ihXyqbYUuZmIcN",14) == 2445354761) strcat(s, "d");
if (crc32("KfdtHpCdw",9) == 4254125528) strcat(s, "t");
if (crc32("eDxaEGnlJo",10) == 1479845142) strcat(s, "w");
if (crc32("IyjjI",5) == 1352931036) strcat(s, "e");
if (crc32("EhGmBfD",7) == 2104472342) strcat(s, "d");
    return s;
}

char *quasidefinite_adjectives() {
    char *s = calloc(14);
    if (crc32("idUDdxlx",8) == 1568665563) strcat(s, "q");
if (crc32("NFVmYGxt",8) == 28046302) strcat(s, "G");
if (crc32("wljZBXpEbGSgGGy",15) == 2407348520) strcat(s, "u");
if (crc32("vttjqhlZQNeqKi",14) == 2718396727) strcat(s, "D");
if (crc32("fPZKxRDLxM",10) == 3893687712) strcat(s, "a");
if (crc32("AjxRVsXvUSBG",12) == 3138020895) strcat(s, "s");
if (crc32("wGMbDUCnK",9) == 142550815) strcat(s, "i");
if (crc32("BavBzrDPkEnMNsm",15) == 3768594211) strcat(s, "H");
if (crc32("BaWsnXzSik",10) == 2382645354) strcat(s, "d");
if (crc32("qehdEUKfozdze",13) == 1135123185) strcat(s, "e");
if (crc32("ruxagptGs",9) == 2770473139) strcat(s, "f");
if (crc32("AefuXKdcZcsO",12) == 2862134687) strcat(s, "u");
if (crc32("YJGlSpJAKFozac",14) == 435325424) strcat(s, "i");
if (crc32("VMpgKEiwDh",10) == 1020686260) strcat(s, "z");
if (crc32("UTyMgyUSyHCmRO",14) == 2620492196) strcat(s, "n");
if (crc32("XZVdgOnUdxxJ",12) == 1528809973) strcat(s, "i");
if (crc32("AFpWOD",6) == 2657912473) strcat(s, "I");
if (crc32("WKHEzMqiOJI",11) == 1602067437) strcat(s, "t");
if (crc32("LbxVwSxfG",9) == 1518767028) strcat(s, "e");
    return s;
}

char *postnodal_adjectives() {
    char *s = calloc(10);
    if (crc32("aVHbIWbyOtHURH",14) == 4268930915) strcat(s, "p");
if (crc32("DtPchT",6) == 569785754) strcat(s, "r");
if (crc32("tFcEmeEb",8) == 3715250092) strcat(s, "o");
if (crc32("WGwgsnh",7) == 1793112252) strcat(s, "s");
if (crc32("PSwCjPliWu",10) == 10477571) strcat(s, "U");
if (crc32("qRohhFuOmr",10) == 1834803394) strcat(s, "t");
if (crc32("lwUDLZ",6) == 2106835546) strcat(s, "F");
if (crc32("cgyoaL",6) == 1115702108) strcat(s, "n");
if (crc32("aGxfFbQuLowiK",13) == 2673537559) strcat(s, "s");
if (crc32("cNNphicOe",9) == 1327648148) strcat(s, "o");
if (crc32("oPJBvrVe",8) == 3595164932) strcat(s, "g");
if (crc32("wfLmRLY",7) == 520246413) strcat(s, "d");
if (crc32("TQlFf",5) == 3377312241) strcat(s, "p");
if (crc32("QYKgVG",6) == 1187511091) strcat(s, "a");
if (crc32("qyZLyMUKdNn",11) == 986173474) strcat(s, "l");
    return s;
}

char *Jeffersonian_adjectives() {
    char *s = calloc(13);
    if (crc32("unZBJbsIxR",10) == 1498054910) strcat(s, "J");
if (crc32("noPGop",6) == 2498149798) strcat(s, "e");
if (crc32("xaYYWUzYy",9) == 63292089) strcat(s, "m");
if (crc32("dTnWupWCAjWpJr",14) == 1995183456) strcat(s, "f");
if (crc32("CHITqFuNPdkjCvn",15) == 4202822131) strcat(s, "f");
if (crc32("JITWiaJUNT",10) == 951501645) strcat(s, "e");
if (crc32("cUvNpmNXfySbCa",14) == 1422281021) strcat(s, "r");
if (crc32("gtYbkQZY",8) == 3168966634) strcat(s, "s");
if (crc32("KxATi",5) == 3698045037) strcat(s, "o");
if (crc32("ancnhTyAbIx",11) == 1727625031) strcat(s, "r");
if (crc32("EnVdv",5) == 1561233596) strcat(s, "n");
if (crc32("evlEVNWLc",9) == 2757617831) strcat(s, "i");
if (crc32("lFEJJJzsWK",10) == 4271815715) strcat(s, "a");
if (crc32("eTWxS",5) == 2951240784) strcat(s, "n");
    return s;
}

char *amphitokous_adjectives() {
    char *s = calloc(12);
    if (crc32("QLrJf",5) == 3953207615) strcat(s, "a");
if (crc32("jryDulsHQf",10) == 4280201473) strcat(s, "m");
if (crc32("AJvEWVdz",8) == 2729205072) strcat(s, "p");
if (crc32("MxoxV",5) == 1594302104) strcat(s, "X");
if (crc32("MPnJCG",6) == 2937009929) strcat(s, "h");
if (crc32("GJfPVQsxUmE",11) == 1284470812) strcat(s, "i");
if (crc32("LgtZWtbaJEN",11) == 1821075302) strcat(s, "p");
if (crc32("ZJyoeNsH",8) == 2082071209) strcat(s, "t");
if (crc32("RPwPMHOHYoHyfO",14) == 1606957063) strcat(s, "o");
if (crc32("ZkQeZoi",7) == 3327226534) strcat(s, "k");
if (crc32("WRpOE",5) == 145993066) strcat(s, "o");
if (crc32("czqwYOjJT",9) == 938171188) strcat(s, "u");
if (crc32("OakogwvloZk",11) == 1090784560) strcat(s, "s");
    return s;
}

char *unfutile_adjectives() {
    char *s = calloc(9);
    if (crc32("AgrXck",6) == 1778205852) strcat(s, "u");
if (crc32("HeocjbCbBV",10) == 61748844) strcat(s, "n");
if (crc32("ZXBCorhKjkBULnE",15) == 2146717494) strcat(s, "S");
if (crc32("XYExNfgt",8) == 2313059190) strcat(s, "f");
if (crc32("TircGWp",7) == 531007200) strcat(s, "u");
if (crc32("HHurdSSpM",9) == 1564518013) strcat(s, "t");
if (crc32("bbVapHeBGeDip",13) == 4024137255) strcat(s, "t");
if (crc32("tuEpaDhM",8) == 74427751) strcat(s, "i");
if (crc32("sCdzmuZpIej",11) == 816330931) strcat(s, "y");
if (crc32("nHQSt",5) == 352367062) strcat(s, "l");
if (crc32("gprypEr",7) == 225989976) strcat(s, "T");
if (crc32("NtkRthn",7) == 3269161604) strcat(s, "e");
    return s;
}

char *offertorial_adjectives() {
    char *s = calloc(12);
    if (crc32("EsWzcysxQ",9) == 1741932621) strcat(s, "E");
if (crc32("qyZcBIu",7) == 3534028606) strcat(s, "o");
if (crc32("EEVtAIeu",8) == 2700048285) strcat(s, "f");
if (crc32("LsOGSrmBMET",11) == 4028323519) strcat(s, "a");
if (crc32("iyerc",5) == 3281596266) strcat(s, "f");
if (crc32("BZEXaGGp",8) == 3350925320) strcat(s, "e");
if (crc32("iItGpDJaw",9) == 875030235) strcat(s, "v");
if (crc32("fcClEBqGy",9) == 4280139439) strcat(s, "r");
if (crc32("ceKEPlIAMYHopr",14) == 151154425) strcat(s, "t");
if (crc32("LTFHfFSdhAzYMrL",15) == 3106406453) strcat(s, "e");
if (crc32("LprtXHFXiBu",11) == 953038475) strcat(s, "o");
if (crc32("XpOLXABlucuq",12) == 221891762) strcat(s, "l");
if (crc32("poPXFAFNQSBIp",13) == 3110525871) strcat(s, "r");
if (crc32("qzwTLptSXHK",11) == 1985488077) strcat(s, "x");
if (crc32("nhcyUCxmAwc",11) == 1085701546) strcat(s, "i");
if (crc32("qbtpBOjQXeK",11) == 2527348971) strcat(s, "a");
if (crc32("pmnYTZRcqzt",11) == 1443837557) strcat(s, "x");
if (crc32("mUpFROOhV",9) == 3066346998) strcat(s, "l");
    return s;
}

char *crotchety_adjectives() {
    char *s = calloc(10);
    if (crc32("rtRcUfdHaopp",12) == 2262668529) strcat(s, "j");
if (crc32("ZcZMEejwF",9) == 1293435455) strcat(s, "c");
if (crc32("bRDptvSRsJV",11) == 4096976490) strcat(s, "r");
if (crc32("aXbbgcdFbNstUm",14) == 2354231932) strcat(s, "Y");
if (crc32("YIclfFHzdSNATJ",14) == 175518889) strcat(s, "o");
if (crc32("MYFFjaLCBQKOY",13) == 1848509444) strcat(s, "t");
if (crc32("bEevu",5) == 177883765) strcat(s, "W");
if (crc32("dSplFaA",7) == 3917987639) strcat(s, "c");
if (crc32("oHtyNCdm",8) == 314395944) strcat(s, "q");
if (crc32("Oafwqm",6) == 2706031807) strcat(s, "h");
if (crc32("SdVPKSDRGYKkC",13) == 2262191642) strcat(s, "e");
if (crc32("PUmUfUXZlaKTPF",14) == 1637578049) strcat(s, "t");
if (crc32("ajFjddwDfi",10) == 2914246886) strcat(s, "y");
    return s;
}

char *antinomical_adjectives() {
    char *s = calloc(12);
    if (crc32("oJKihdb",7) == 2972725705) strcat(s, "k");
if (crc32("mLvIBnTEWEGaS",13) == 1733822275) strcat(s, "a");
if (crc32("AYaAZfdm",8) == 2014406430) strcat(s, "o");
if (crc32("xUmSmOmpKV",10) == 99817982) strcat(s, "n");
if (crc32("hmVLOiC",7) == 3621918383) strcat(s, "t");
if (crc32("uogDk",5) == 2545455235) strcat(s, "i");
if (crc32("hoSFtjhWHsg",11) == 3805085328) strcat(s, "n");
if (crc32("XADGorBWyLR",11) == 3050354454) strcat(s, "o");
if (crc32("fKXSXScoDAwz",12) == 481555356) strcat(s, "m");
if (crc32("DQGmEVRbNIH",11) == 2656639717) strcat(s, "l");
if (crc32("XpsqYSh",7) == 1511512651) strcat(s, "i");
if (crc32("gydwXHCpc",9) == 3104224954) strcat(s, "F");
if (crc32("CkBMitCW",8) == 2466223475) strcat(s, "c");
if (crc32("IvqLNFPBUBVr",12) == 166924981) strcat(s, "a");
if (crc32("LhXRoP",6) == 112697798) strcat(s, "k");
if (crc32("kTRjHtMz",8) == 1436709124) strcat(s, "l");
    return s;
}

char *Cesarean_adjectives() {
    char *s = calloc(9);
    if (crc32("koAKBbJWX",9) == 3897299776) strcat(s, "C");
if (crc32("crNZcaFbX",9) == 3487016701) strcat(s, "e");
if (crc32("EfqGLQURjPYnieL",15) == 826227468) strcat(s, "s");
if (crc32("EdflnaemamCbhDD",15) == 3988427276) strcat(s, "a");
if (crc32("DxxIOJE",7) == 3129802836) strcat(s, "w");
if (crc32("XPDOuDKjyMJzd",13) == 4002985877) strcat(s, "r");
if (crc32("ubuQDhVazSU",11) == 2709774056) strcat(s, "e");
if (crc32("LjSkW",5) == 1853930129) strcat(s, "D");
if (crc32("vXWwQ",5) == 2884137817) strcat(s, "a");
if (crc32("aMRSAvyNNvVItSa",15) == 339465424) strcat(s, "n");
    return s;
}

char *unevaporated_adjectives() {
    char *s = calloc(13);
    if (crc32("KHLmIC",6) == 3816624916) strcat(s, "u");
if (crc32("mJhKJi",6) == 3229796716) strcat(s, "O");
if (crc32("oRonL",5) == 2077955879) strcat(s, "n");
if (crc32("MoShb",5) == 1701248386) strcat(s, "e");
if (crc32("CRaZqKQFGK",10) == 3884631210) strcat(s, "v");
if (crc32("jlQfKG",6) == 2159118971) strcat(s, "a");
if (crc32("zHpludGuNVwXGz",14) == 3852503650) strcat(s, "p");
if (crc32("CLDCCTwZV",9) == 2309336454) strcat(s, "Q");
if (crc32("eMhqnYkzx",9) == 1707679272) strcat(s, "o");
if (crc32("JMKoORs",7) == 795090542) strcat(s, "t");
if (crc32("kFQJqNQW",8) == 3854661388) strcat(s, "r");
if (crc32("byVfHHxXddK",11) == 3397475151) strcat(s, "O");
if (crc32("ipUyM",5) == 2782417268) strcat(s, "a");
if (crc32("JiruXZkZ",8) == 3601616290) strcat(s, "t");
if (crc32("XtRdlWX",7) == 3197470496) strcat(s, "A");
if (crc32("gxJtnkDmICx",11) == 3004476217) strcat(s, "e");
if (crc32("IsgddopNqSoUdCB",15) == 2184788507) strcat(s, "d");
    return s;
}

char *friable_adjectives() {
    char *s = calloc(8);
    if (crc32("GCVrx",5) == 772372034) strcat(s, "B");
if (crc32("fVfhvhiiuQDSt",13) == 1257859889) strcat(s, "f");
if (crc32("pMCvwsnTwVcJs",13) == 3181231897) strcat(s, "f");
if (crc32("RDRDIfbmul",10) == 2199639979) strcat(s, "r");
if (crc32("vbJnnvRkGFZFeEB",15) == 2198983050) strcat(s, "J");
if (crc32("vDMZpfAO",8) == 1448668551) strcat(s, "i");
if (crc32("sGHkXmjOu",9) == 3393836950) strcat(s, "a");
if (crc32("TDSdKnpyd",9) == 1832382724) strcat(s, "h");
if (crc32("kKSYBEKVxIGOFSU",15) == 1237798865) strcat(s, "b");
if (crc32("clwilySKnBlATZQ",15) == 4001397890) strcat(s, "l");
if (crc32("mKOiuS",6) == 248570182) strcat(s, "e");
    return s;
}

char *chewy_adjectives() {
    char *s = calloc(6);
    if (crc32("ytySrA",6) == 1895440218) strcat(s, "s");
if (crc32("GaachYqHnuapRXw",15) == 903146619) strcat(s, "c");
if (crc32("hYRuuEckcDezW",13) == 3477270791) strcat(s, "c");
if (crc32("eGTcWTrTdBWH",12) == 2833351481) strcat(s, "h");
if (crc32("yyjIAZaPQMIZst",14) == 3290087753) strcat(s, "E");
if (crc32("qnHOS",5) == 576926126) strcat(s, "e");
if (crc32("HIrQfdGA",8) == 3033005644) strcat(s, "J");
if (crc32("NwHPSDSb",8) == 937635178) strcat(s, "w");
if (crc32("BijWAhK",7) == 3643351819) strcat(s, "y");
    return s;
}

char *propertied_adjectives() {
    char *s = calloc(11);
    if (crc32("pqwWkYdInM",10) == 718167066) strcat(s, "O");
if (crc32("XCwqFC",6) == 2757847883) strcat(s, "p");
if (crc32("uloxx",5) == 449885073) strcat(s, "G");
if (crc32("MvWZyDKPCuXU",12) == 2467659746) strcat(s, "r");
if (crc32("hhLwHd",6) == 237299972) strcat(s, "o");
if (crc32("QvCgoLo",7) == 3112845425) strcat(s, "m");
if (crc32("WaZjrVXNzG",10) == 2685847660) strcat(s, "p");
if (crc32("YLvRPtN",7) == 4071003550) strcat(s, "e");
if (crc32("URrWxQYPwL",10) == 3485198491) strcat(s, "r");
if (crc32("gSwtmiFETXvOklV",15) == 3105769687) strcat(s, "m");
if (crc32("XwQVFrr",7) == 2809203140) strcat(s, "t");
if (crc32("rwShzVWKHOSeM",13) == 111341518) strcat(s, "i");
if (crc32("cEXRjytxsfRfNx",14) == 1894141751) strcat(s, "e");
if (crc32("coyfTMDXcL",10) == 1910913456) strcat(s, "d");
    return s;
}

char *unbureaucratic_adjectives() {
    char *s = calloc(15);
    if (crc32("IlzNTLgnpoHQqm",14) == 1354306320) strcat(s, "J");
if (crc32("xvBuuB",6) == 2308746338) strcat(s, "u");
if (crc32("FnUsJ",5) == 3565109682) strcat(s, "m");
if (crc32("akktDtI",7) == 3957421819) strcat(s, "n");
if (crc32("MaLHe",5) == 2569265149) strcat(s, "b");
if (crc32("pTUPlCbn",8) == 2220223370) strcat(s, "u");
if (crc32("lCrXTWVfUrU",11) == 1328167980) strcat(s, "X");
if (crc32("SIxtMn",6) == 2090193962) strcat(s, "r");
if (crc32("WYjsnFxM",8) == 3690233952) strcat(s, "e");
if (crc32("BivwTp",6) == 4131944193) strcat(s, "a");
if (crc32("DrgvoD",6) == 4248372849) strcat(s, "B");
if (crc32("VmWFGtdz",8) == 1044908834) strcat(s, "u");
if (crc32("QiQgftEaXqH",11) == 4096245027) strcat(s, "H");
if (crc32("agTWQdCqfDYg",12) == 1836833288) strcat(s, "c");
if (crc32("KGrIBdECaHF",11) == 3223155286) strcat(s, "c");
if (crc32("dbkWutqU",8) == 3885415752) strcat(s, "r");
if (crc32("dhNVNPjRFrbOa",13) == 1076912355) strcat(s, "G");
if (crc32("slagcul",7) == 1638178327) strcat(s, "a");
if (crc32("aRzfPUBBmUkzqT",14) == 1302634268) strcat(s, "t");
if (crc32("xeYAtRUPs",9) == 1320555816) strcat(s, "J");
if (crc32("BEQcO",5) == 2367059161) strcat(s, "i");
if (crc32("EBxKHLYpWBj",11) == 1535983216) strcat(s, "p");
if (crc32("reftCjxmlXXA",12) == 2372959884) strcat(s, "c");
    return s;
}

char *consistorian_adjectives() {
    char *s = calloc(13);
    if (crc32("LmqfDnkffe",10) == 1685568694) strcat(s, "Z");
if (crc32("ZONICJuzRI",10) == 3096842676) strcat(s, "c");
if (crc32("YkvJgGahc",9) == 2304321782) strcat(s, "o");
if (crc32("LOyhcipisI",10) == 1342709837) strcat(s, "n");
if (crc32("JgFmGF",6) == 1540925542) strcat(s, "f");
if (crc32("xrGTWp",6) == 489210343) strcat(s, "s");
if (crc32("LNqvBIdcU",9) == 2885477212) strcat(s, "i");
if (crc32("ZpRxOtnpEMybRm",14) == 1770922815) strcat(s, "l");
if (crc32("qOHCEnXReSSnI",13) == 554762851) strcat(s, "s");
if (crc32("UoTKNBA",7) == 758509213) strcat(s, "t");
if (crc32("yKebPRvyQzyrI",13) == 157931246) strcat(s, "o");
if (crc32("ufpRE",5) == 865587940) strcat(s, "r");
if (crc32("pTpDDj",6) == 1387086510) strcat(s, "i");
if (crc32("fmWaSIbxH",9) == 3931755922) strcat(s, "a");
if (crc32("pjOxJ",5) == 4046231895) strcat(s, "h");
if (crc32("MpikJTmcMbuG",12) == 1159583479) strcat(s, "n");
    return s;
}

char *dacolleta_adjectives() {
    char *s = calloc(10);
    if (crc32("HUwaOOOYc",9) == 3394029173) strcat(s, "U");
if (crc32("xsOGjvtKmDXJysN",15) == 2326700739) strcat(s, "d");
if (crc32("KwYoWkmE",8) == 3427067387) strcat(s, "a");
if (crc32("wyqjaKuaQOsGQQK",15) == 369637511) strcat(s, "c");
if (crc32("BMlHZ",5) == 1335003858) strcat(s, "p");
if (crc32("HqDgPCYguWSa",12) == 1663211623) strcat(s, "o");
if (crc32("SqAlowIJ",8) == 3910891028) strcat(s, "l");
if (crc32("OZghRBmoeMVOPce",15) == 728766986) strcat(s, "S");
if (crc32("dxpWTyEqumCZt",13) == 2447418362) strcat(s, "l");
if (crc32("yDZDudgKYSPurNz",15) == 3109600918) strcat(s, "q");
if (crc32("IHBjKTz",7) == 3415480776) strcat(s, "e");
if (crc32("uFHoN",5) == 3293791871) strcat(s, "m");
if (crc32("tsNXF",5) == 606285139) strcat(s, "t");
if (crc32("EYTQEiSnNf",10) == 2336957155) strcat(s, "a");
    return s;
}

char *unacknowledged_adjectives() {
    char *s = calloc(15);
    if (crc32("LurlqKTLVkYYNp",14) == 1203417411) strcat(s, "u");
if (crc32("UNnbKD",6) == 1329270508) strcat(s, "G");
if (crc32("CXddwJM",7) == 2212589486) strcat(s, "n");
if (crc32("SMnjeeCskInUds",14) == 369308790) strcat(s, "a");
if (crc32("ofWeUPxqvC",10) == 1663714553) strcat(s, "c");
if (crc32("CWFUfAc",7) == 2297205768) strcat(s, "M");
if (crc32("ApsdImzjyO",10) == 803094864) strcat(s, "k");
if (crc32("vEcYyparNyfgr",13) == 2213553369) strcat(s, "n");
if (crc32("lPMMkXcqejSBlYq",15) == 1285908281) strcat(s, "o");
if (crc32("JKmgWUXUWx",10) == 2113229455) strcat(s, "P");
if (crc32("OKkNat",6) == 3712110409) strcat(s, "w");
if (crc32("FemCXDuHHmdvOw",14) == 3338747494) strcat(s, "X");
if (crc32("CYKpjPqEHrWwe",13) == 3116384697) strcat(s, "l");
if (crc32("PKJuI",5) == 2455870331) strcat(s, "e");
if (crc32("wboqUiQatjNR",12) == 3462484947) strcat(s, "d");
if (crc32("JrhPhQPkZ",9) == 1290760658) strcat(s, "g");
if (crc32("BVTaHbdWOm",10) == 388106084) strcat(s, "O");
if (crc32("BJWXJe",6) == 3794415719) strcat(s, "e");
if (crc32("KJLmPwpDCdXXIBr",15) == 4183107793) strcat(s, "J");
if (crc32("tqHCMuWLsgJlff",14) == 3042043715) strcat(s, "d");
    return s;
}

char *selfbetraying_adjectives() {
    char *s = calloc(14);
    if (crc32("PZiZIRHyI",9) == 113100045) strcat(s, "C");
if (crc32("MYIurbTxYQehs",13) == 4187274622) strcat(s, "s");
if (crc32("DntOGu",6) == 3393578989) strcat(s, "L");
if (crc32("Gutvgz",6) == 3168842403) strcat(s, "e");
if (crc32("bMdTlIxMe",9) == 1434874581) strcat(s, "r");
if (crc32("wcFmUgAyIoQjiV",14) == 1630883889) strcat(s, "l");
if (crc32("eUwxXwCflQbRam",14) == 604737995) strcat(s, "R");
if (crc32("WjfZQjprvbhsk",13) == 1580469765) strcat(s, "f");
if (crc32("KYpzKQucyYb",11) == 474395773) strcat(s, "b");
if (crc32("hXxnPvfGPISx",12) == 1931955999) strcat(s, "e");
if (crc32("Vtekl",5) == 1259567221) strcat(s, "g");
if (crc32("mLyAbYMRdD",10) == 2819600684) strcat(s, "t");
if (crc32("LhvIzrVsrTBfd",13) == 4185237294) strcat(s, "r");
if (crc32("GcpoSficELv",11) == 3046554278) strcat(s, "a");
if (crc32("vCMNwtQoNE",10) == 460141387) strcat(s, "y");
if (crc32("OVUUGOpheUgXYuF",15) == 1267183863) strcat(s, "i");
if (crc32("roagV",5) == 3352562513) strcat(s, "n");
if (crc32("WmYsabgoxfVkwk",14) == 371821320) strcat(s, "g");
    return s;
}

char *scoldable_adjectives() {
    char *s = calloc(10);
    if (crc32("ZbWPi",5) == 3263734626) strcat(s, "s");
if (crc32("tVCDXDdcxko",11) == 3984455615) strcat(s, "p");
if (crc32("AmCeLUq",7) == 1100940416) strcat(s, "c");
if (crc32("WdwNjribq",9) == 2303948733) strcat(s, "w");
if (crc32("vMiTspGxr",9) == 2808903730) strcat(s, "o");
if (crc32("LXOPptUh",8) == 1901459458) strcat(s, "l");
if (crc32("cZNpfAElSOUJWNQ",15) == 2690988591) strcat(s, "m");
if (crc32("yMlJQfnRWlISf",13) == 388124926) strcat(s, "d");
if (crc32("jVrETJYZmBxKGik",15) == 845648625) strcat(s, "a");
if (crc32("CkBHTdZPt",9) == 1227305368) strcat(s, "b");
if (crc32("GAhguVWHhKpCdnH",15) == 3833795500) strcat(s, "l");
if (crc32("hBdCfWfkmKHcJ",13) == 2796206092) strcat(s, "Q");
if (crc32("IxxIwSfcqJi",11) == 2840254729) strcat(s, "e");
    return s;
}

char *halfcivilized_adjectives() {
    char *s = calloc(14);
    if (crc32("zfKcjUps",8) == 3540418192) strcat(s, "h");
if (crc32("gxBLQoJIMKxkTf",14) == 1753128041) strcat(s, "a");
if (crc32("sTxNnWg",7) == 33489515) strcat(s, "l");
if (crc32("KWFiCVtMU",9) == 286673698) strcat(s, "f");
if (crc32("tXCQFMSN",8) == 393347608) strcat(s, "c");
if (crc32("fOcwCyXmKxJy",12) == 3349911097) strcat(s, "T");
if (crc32("OjFyvRCpbVkQ",12) == 2314036283) strcat(s, "i");
if (crc32("NFKifPrVbrdhJKs",15) == 3497454742) strcat(s, "l");
if (crc32("ZiNXkJMgGFNrpZc",15) == 3490337137) strcat(s, "v");
if (crc32("haJJAXjPyzVDJg",14) == 3035731930) strcat(s, "u");
if (crc32("GwdWnLXjQY",10) == 3975058519) strcat(s, "i");
if (crc32("jfQMFyeKqub",11) == 1614953861) strcat(s, "l");
if (crc32("YogpKZwAPhPmGAW",15) == 3615807249) strcat(s, "i");
if (crc32("mFUaAFjHKyvZh",13) == 783972614) strcat(s, "z");
if (crc32("qCFIJZmoVn",10) == 859023868) strcat(s, "e");
if (crc32("NaDBycpyJd",10) == 3561734876) strcat(s, "d");
    return s;
}

char *unpurified_adjectives() {
    char *s = calloc(11);
    if (crc32("OmfFr",5) == 2176800858) strcat(s, "u");
if (crc32("KvDZBTBaRrqv",12) == 3209509652) strcat(s, "n");
if (crc32("nImpaW",6) == 3405894135) strcat(s, "Y");
if (crc32("LrWdoiODhWOWGbM",15) == 1099685966) strcat(s, "p");
if (crc32("xxPWbMZ",7) == 1315545250) strcat(s, "u");
if (crc32("jPAAFAxB",8) == 374870473) strcat(s, "r");
if (crc32("yONukgKibGjgNKC",15) == 3886910516) strcat(s, "R");
if (crc32("JVuUmiCRrPTu",12) == 3569534733) strcat(s, "i");
if (crc32("NaPaEcs",7) == 15992257) strcat(s, "f");
if (crc32("jQiaXQbiqXBgmpj",15) == 3082428120) strcat(s, "i");
if (crc32("kcwTpByhcvVs",12) == 1990292437) strcat(s, "e");
if (crc32("dlvIoQp",7) == 3171150661) strcat(s, "d");
    return s;
}

char *factional_adjectives() {
    char *s = calloc(10);
    if (crc32("UbfdQuXIfldB",12) == 2253242344) strcat(s, "n");
if (crc32("uTJjk",5) == 2332046268) strcat(s, "f");
if (crc32("fvPtJp",6) == 50842654) strcat(s, "F");
if (crc32("CoTdEyy",7) == 3381608518) strcat(s, "a");
if (crc32("gtRTLHnYFqSMskm",15) == 2729309217) strcat(s, "O");
if (crc32("LwDHfCGUvlTpFg",14) == 2938097598) strcat(s, "c");
if (crc32("FANtImE",7) == 738907851) strcat(s, "s");
if (crc32("BuyKHPkJYEgg",12) == 4001409855) strcat(s, "t");
if (crc32("iZuRcCEJFxruw",13) == 2827300952) strcat(s, "X");
if (crc32("sBHKDRkpNCmXCpr",15) == 2118638479) strcat(s, "i");
if (crc32("WRzfCRqLaEm",11) == 3047856073) strcat(s, "c");
if (crc32("BEGEk",5) == 1784728814) strcat(s, "o");
if (crc32("CGHrOWFMbI",10) == 1202774080) strcat(s, "n");
if (crc32("KMJEb",5) == 3552619911) strcat(s, "a");
if (crc32("BVGcdDOP",8) == 1561179723) strcat(s, "l");
    return s;
}

char *sweatier_adjectives() {
    char *s = calloc(9);
    if (crc32("RwDOdippHjbDTK",14) == 664027890) strcat(s, "s");
if (crc32("wiHDGO",6) == 99653523) strcat(s, "i");
if (crc32("eAtToOVAGmyZEr",14) == 836875567) strcat(s, "w");
if (crc32("bkbIoMGxAoCMs",13) == 3028323882) strcat(s, "w");
if (crc32("CTyrvA",6) == 3428928564) strcat(s, "e");
if (crc32("TzNYwnZk",8) == 3532789911) strcat(s, "a");
if (crc32("EZTLzeEBtA",10) == 3837964763) strcat(s, "r");
if (crc32("ZEFKzOnw",8) == 193905187) strcat(s, "t");
if (crc32("MLsyYSnvuyY",11) == 1654462084) strcat(s, "i");
if (crc32("GukJSNLixG",10) == 3160524921) strcat(s, "e");
if (crc32("IEkLPGz",7) == 2999506028) strcat(s, "D");
if (crc32("UiLwU",5) == 1912615361) strcat(s, "r");
    return s;
}

char *nonanimate_adjectives() {
    char *s = calloc(11);
    if (crc32("GrtWiX",6) == 281918143) strcat(s, "w");
if (crc32("YhRzyJDrjKAmcEk",15) == 2912056377) strcat(s, "n");
if (crc32("VKLEVraaVK",10) == 4259546401) strcat(s, "o");
if (crc32("OSecMuijCSA",11) == 1755301029) strcat(s, "n");
if (crc32("FrPXgXkPeDo",11) == 2017966161) strcat(s, "T");
if (crc32("zXOpJouuwHXbeFC",15) == 42508064) strcat(s, "a");
if (crc32("hEdmJcBJCvMhwz",14) == 3460204236) strcat(s, "n");
if (crc32("fjJWGNDH",8) == 3896892610) strcat(s, "n");
if (crc32("wWFGZSRKtGpK",12) == 3033722490) strcat(s, "i");
if (crc32("afbtBhuiYMw",11) == 3563013330) strcat(s, "m");
if (crc32("YTeiu",5) == 2554797928) strcat(s, "b");
if (crc32("vTtFQtqqjot",11) == 2101311796) strcat(s, "a");
if (crc32("EWDkpgVHwojMFj",14) == 553013503) strcat(s, "t");
if (crc32("qGopS",5) == 2592451395) strcat(s, "e");
    return s;
}

char *unapposite_adjectives() {
    char *s = calloc(11);
    if (crc32("LgHsiU",6) == 1164120999) strcat(s, "u");
if (crc32("aKFbHnfmjb",10) == 168655525) strcat(s, "v");
if (crc32("vJdtLWXxbQ",10) == 4071809383) strcat(s, "n");
if (crc32("MewLInvHwGcbHIK",15) == 3394194841) strcat(s, "a");
if (crc32("JdccVNl",7) == 2932059066) strcat(s, "M");
if (crc32("xyQXLseSioEJHhs",15) == 565368890) strcat(s, "p");
if (crc32("FQESjQD",7) == 2745144432) strcat(s, "p");
if (crc32("HudhBQGRx",9) == 246018551) strcat(s, "o");
if (crc32("ZrDZDAg",7) == 3820659786) strcat(s, "O");
if (crc32("TIGGPBxg",8) == 292617595) strcat(s, "s");
if (crc32("OXpyrmKsuf",10) == 2714087682) strcat(s, "a");
if (crc32("zuECKVCJ",8) == 3478990221) strcat(s, "i");
if (crc32("vAoYrcx",7) == 1020018246) strcat(s, "t");
if (crc32("DTqeDtRoEZkWVvW",15) == 3910894463) strcat(s, "o");
if (crc32("FdbmONALSXUPbuy",15) == 4181055929) strcat(s, "e");
    return s;
}

char *brakeless_adjectives() {
    char *s = calloc(10);
    if (crc32("zagkNITTF",9) == 2565176116) strcat(s, "b");
if (crc32("FUGECe",6) == 2819399933) strcat(s, "v");
if (crc32("zPnHcofuScn",11) == 596141019) strcat(s, "r");
if (crc32("AQNnMLMtIhMimN",14) == 445205172) strcat(s, "v");
if (crc32("nTWzfieGVLaB",12) == 2231822239) strcat(s, "a");
if (crc32("WuUDC",5) == 21479960) strcat(s, "k");
if (crc32("aiKmwlEUjxN",11) == 3526268714) strcat(s, "g");
if (crc32("KZTcqePmH",9) == 728820380) strcat(s, "e");
if (crc32("iYbDeuAMJie",11) == 2688258784) strcat(s, "l");
if (crc32("rMDKAhM",7) == 1927273908) strcat(s, "G");
if (crc32("DuHsubM",7) == 1783795759) strcat(s, "e");
if (crc32("ouebH",5) == 399158697) strcat(s, "H");
if (crc32("IpYTnNz",7) == 2865941465) strcat(s, "s");
if (crc32("dpQRPzHQHOsv",12) == 3347386791) strcat(s, "s");
    return s;
}

char *windier_adjectives() {
    char *s = calloc(8);
    if (crc32("BgbqNDqGNSGyEZ",14) == 1170251874) strcat(s, "M");
if (crc32("yyIviFL",7) == 1296680544) strcat(s, "w");
if (crc32("puDSaiNJtbjVYFp",15) == 2417911513) strcat(s, "W");
if (crc32("eKXEelJAKTHN",12) == 2443371359) strcat(s, "i");
if (crc32("ZOWNrR",6) == 1925642711) strcat(s, "n");
if (crc32("ritaaEHeu",9) == 1652776049) strcat(s, "d");
if (crc32("vbcYvKoRQUua",12) == 3124905357) strcat(s, "i");
if (crc32("oAyKLxDRlXC",11) == 2247313546) strcat(s, "e");
if (crc32("vjtSA",5) == 664685064) strcat(s, "r");
    return s;
}

char *undeepened_adjectives() {
    char *s = calloc(11);
    if (crc32("ugbigGJmFCirW",13) == 1870030925) strcat(s, "u");
if (crc32("RcMpMkUivkvrLk",14) == 4001828944) strcat(s, "n");
if (crc32("vYPpwJuffxC",11) == 3334238545) strcat(s, "S");
if (crc32("USXfBj",6) == 3220814050) strcat(s, "d");
if (crc32("VeQwsklXjpQBeA",14) == 1880940810) strcat(s, "e");
if (crc32("gFFlLcSjuwv",11) == 1739213772) strcat(s, "p");
if (crc32("wtmbCBj",7) == 3379127328) strcat(s, "e");
if (crc32("CDAiq",5) == 794979421) strcat(s, "p");
if (crc32("ZjJuFj",6) == 1652725753) strcat(s, "e");
if (crc32("dCdpBCVwce",10) == 4114843442) strcat(s, "n");
if (crc32("LOTAzlON",8) == 2395209218) strcat(s, "h");
if (crc32("EiuvnDVBLaML",12) == 1157506032) strcat(s, "e");
if (crc32("fmzDVlfs",8) == 3094319833) strcat(s, "w");
if (crc32("xHoorDcj",8) == 3668037224) strcat(s, "d");
    return s;
}

char *secular_adjectives() {
    char *s = calloc(8);
    if (crc32("uZyjUodedqfP",12) == 1938740638) strcat(s, "S");
if (crc32("eajKUYrA",8) == 3586716510) strcat(s, "s");
if (crc32("OkNkMkhuFg",10) == 1674761507) strcat(s, "e");
if (crc32("sdvaYocHVUMmFng",15) == 1765432596) strcat(s, "c");
if (crc32("sOxNdAovn",9) == 3937484360) strcat(s, "u");
if (crc32("IylBMjIMwLZqMOI",15) == 3112110887) strcat(s, "y");
if (crc32("hDvlGZER",8) == 944898535) strcat(s, "l");
if (crc32("VdEdN",5) == 596713533) strcat(s, "a");
if (crc32("jmiFHj",6) == 3740351187) strcat(s, "r");
    return s;
}

char *womanish_adjectives() {
    char *s = calloc(9);
    if (crc32("dRhZxwePvm",10) == 2136336326) strcat(s, "g");
if (crc32("KZaNbiCvdJJxoNZ",15) == 1602277594) strcat(s, "w");
if (crc32("AOnsgEVq",8) == 2778322774) strcat(s, "o");
if (crc32("LSXZfDSZNDm",11) == 2451855289) strcat(s, "m");
if (crc32("TAMqmjkaUzmOQ",13) == 3483373510) strcat(s, "f");
if (crc32("nbXsIEF",7) == 533341253) strcat(s, "a");
if (crc32("IRizBEmgPVigElb",15) == 3169175890) strcat(s, "n");
if (crc32("oDBtMdCNA",9) == 2197381619) strcat(s, "i");
if (crc32("mrerdsefMMFO",12) == 350959326) strcat(s, "s");
if (crc32("UXqAQkFJNyrVPXo",15) == 2982331129) strcat(s, "S");
if (crc32("LgCPXd",6) == 1072327575) strcat(s, "h");
    return s;
}

char *nonincriminating_adjectives() {
    char *s = calloc(17);
    if (crc32("hgcyRXqMJiEB",12) == 2346932002) strcat(s, "n");
if (crc32("BdFMaQjeNi",10) == 4167276399) strcat(s, "k");
if (crc32("gMUgy",5) == 3982230531) strcat(s, "o");
if (crc32("maPorc",6) == 978551226) strcat(s, "i");
if (crc32("TOqgc",5) == 1676810648) strcat(s, "n");
if (crc32("uwQjlUzipA",10) == 868704120) strcat(s, "i");
if (crc32("btraDuVu",8) == 2225165128) strcat(s, "b");
if (crc32("YTnAe",5) == 566087659) strcat(s, "n");
if (crc32("NZREE",5) == 3945251327) strcat(s, "g");
if (crc32("MROrxddfjshNlVz",15) == 2469142409) strcat(s, "c");
if (crc32("kVwjSEYzdb",10) == 366053942) strcat(s, "r");
if (crc32("ZsTmQ",5) == 1786895841) strcat(s, "i");
if (crc32("yvrlP",5) == 2413512062) strcat(s, "a");
if (crc32("YnPAfutX",8) == 4283113058) strcat(s, "m");
if (crc32("IYRbwwYOUo",10) == 3727246573) strcat(s, "i");
if (crc32("ioAcDhwBUWf",11) == 3794756897) strcat(s, "n");
if (crc32("luisSDOtZ",9) == 215103017) strcat(s, "j");
if (crc32("PKnxTlVYm",9) == 1350351677) strcat(s, "a");
if (crc32("TghAFLLOtqHsBgY",15) == 1221566679) strcat(s, "L");
if (crc32("ZvjpfCorn",9) == 620099379) strcat(s, "t");
if (crc32("ofaDLpIIRgOuHA",14) == 562336892) strcat(s, "i");
if (crc32("pnEtheUuyCcC",12) == 2223907741) strcat(s, "j");
if (crc32("gLAqCmSMYxGo",12) == 2218107273) strcat(s, "n");
if (crc32("lCBBjPxHSiC",11) == 910004305) strcat(s, "P");
if (crc32("YhSKujDz",8) == 256846460) strcat(s, "g");
    return s;
}

char *antimoralistic_adjectives() {
    char *s = calloc(15);
    if (crc32("UksmLjP",7) == 2113366138) strcat(s, "t");
if (crc32("qbNcdyUya",9) == 3723581087) strcat(s, "a");
if (crc32("UHPINziDVsggQA",14) == 3007973836) strcat(s, "n");
if (crc32("uStPpKIXFkb",11) == 3451348882) strcat(s, "t");
if (crc32("MKGqqWfRlKGowiC",15) == 1726185814) strcat(s, "i");
if (crc32("kuNVjRSsNLwIWp",14) == 3835295830) strcat(s, "m");
if (crc32("dUOrxsCbcB",10) == 2078002394) strcat(s, "N");
if (crc32("VngoBkqieK",10) == 2776796278) strcat(s, "o");
if (crc32("OBENkjSX",8) == 2940417631) strcat(s, "f");
if (crc32("WsWtpIaUG",9) == 3716881857) strcat(s, "r");
if (crc32("aQnKdLxpTC",10) == 4277490010) strcat(s, "a");
if (crc32("cDgVcyixlU",10) == 2496674766) strcat(s, "o");
if (crc32("WrTrxuqNykRr",12) == 2042231371) strcat(s, "l");
if (crc32("KphjtISEwQO",11) == 2611196152) strcat(s, "X");
if (crc32("aqXEcSKkWo",10) == 2067064395) strcat(s, "i");
if (crc32("qIuaxMuunZNdC",13) == 2913949406) strcat(s, "N");
if (crc32("WTwfskrVBEmAtMh",15) == 1687334559) strcat(s, "s");
if (crc32("EYMNOtZZtONpf",13) == 2934291133) strcat(s, "t");
if (crc32("lTABpyEvcFbvr",13) == 447468816) strcat(s, "I");
if (crc32("UlluDwoYS",9) == 3480884066) strcat(s, "i");
if (crc32("TkKJCEl",7) == 1218025960) strcat(s, "c");
    return s;
}

char *undistrained_adjectives() {
    char *s = calloc(13);
    if (crc32("wnQBOWZbAJmX",12) == 1014572667) strcat(s, "u");
if (crc32("cIVVREJWpEQ",11) == 170660107) strcat(s, "p");
if (crc32("KQfID",5) == 2262839509) strcat(s, "n");
if (crc32("NbphHvTdjA",10) == 2134491229) strcat(s, "P");
if (crc32("MwUiwZWqLkC",11) == 1486422968) strcat(s, "d");
if (crc32("mIdzvK",6) == 620907685) strcat(s, "i");
if (crc32("gcFlhQ",6) == 878388916) strcat(s, "s");
if (crc32("nvbdnSYY",8) == 1110179562) strcat(s, "J");
if (crc32("tYvsMXlPd",9) == 475170048) strcat(s, "t");
if (crc32("xKrouPalW",9) == 3569219235) strcat(s, "r");
if (crc32("EIuHzjCrpck",11) == 1611875315) strcat(s, "r");
if (crc32("cIzBbJvysKJSN",13) == 1904230835) strcat(s, "a");
if (crc32("SSzOvYXbgsefwm",14) == 1453151697) strcat(s, "H");
if (crc32("WjPxSxEXfSw",11) == 2305554377) strcat(s, "i");
if (crc32("fpgeJieHRmdDZf",14) == 4078462349) strcat(s, "n");
if (crc32("vxNtXkc",7) == 3324418470) strcat(s, "e");
if (crc32("bBCCDy",6) == 2424079112) strcat(s, "d");
    return s;
}

char *tardier_adjectives() {
    char *s = calloc(8);
    if (crc32("cMMwuHOQswylC",13) == 1172848692) strcat(s, "k");
if (crc32("WLBrgsBb",8) == 3915191859) strcat(s, "t");
if (crc32("pSeDCydf",8) == 2276936111) strcat(s, "X");
if (crc32("lihWSMsefEj",11) == 3684806888) strcat(s, "a");
if (crc32("fXhfyI",6) == 607754779) strcat(s, "r");
if (crc32("mxGhNLZsDV",10) == 1669527917) strcat(s, "m");
if (crc32("sHIOIaLj",8) == 2622478551) strcat(s, "d");
if (crc32("HdNrstgjqVo",11) == 3419938694) strcat(s, "G");
if (crc32("GVcxszCPhxqLTU",14) == 4184420914) strcat(s, "i");
if (crc32("PTkaxC",6) == 3722375838) strcat(s, "e");
if (crc32("EZNfP",5) == 4151146435) strcat(s, "G");
if (crc32("XMcygF",6) == 919381302) strcat(s, "r");
    return s;
}

char *dolllike_adjectives() {
    char *s = calloc(9);
    if (crc32("PMgGbRCSraxHzk",14) == 983112080) strcat(s, "E");
if (crc32("JjKkP",5) == 290922795) strcat(s, "d");
if (crc32("lrCXFbIK",8) == 765928364) strcat(s, "o");
if (crc32("VqfbSOl",7) == 2357196468) strcat(s, "T");
if (crc32("WejjXcFEG",9) == 3737775039) strcat(s, "l");
if (crc32("DGHjK",5) == 1829219933) strcat(s, "l");
if (crc32("VmdvWIdqY",9) == 1649527432) strcat(s, "t");
if (crc32("KDmvohV",7) == 217604936) strcat(s, "l");
if (crc32("AZoPtOmDMzOHDM",14) == 3084087232) strcat(s, "d");
if (crc32("kIFsxMGrUsmrdz",14) == 3481140562) strcat(s, "i");
if (crc32("QmRJbv",6) == 3843480350) strcat(s, "k");
if (crc32("vmRHjwpHbTfxIr",14) == 3959498039) strcat(s, "e");
    return s;
}

char *immovable_adjectives() {
    char *s = calloc(10);
    if (crc32("jdfAcvODZHFLRGh",15) == 224952057) strcat(s, "i");
if (crc32("FPRsSjUVTKybD",13) == 4065967710) strcat(s, "D");
if (crc32("LdaNaCvJoljfhd",14) == 1246796841) strcat(s, "m");
if (crc32("XSECeyoYBzXYw",13) == 3608690260) strcat(s, "m");
if (crc32("lvGWJNPwoJSqbdc",15) == 3310403512) strcat(s, "F");
if (crc32("CJFBOetSVorD",12) == 1818866995) strcat(s, "o");
if (crc32("telsOpQSpIJ",11) == 2634649069) strcat(s, "h");
if (crc32("QaSmGiwuJMNNYMJ",15) == 774570079) strcat(s, "v");
if (crc32("UVKdKLGw",8) == 3584939068) strcat(s, "f");
if (crc32("ZteSHkvJmN",10) == 356708781) strcat(s, "a");
if (crc32("CoORaZijNVDFo",13) == 2416159521) strcat(s, "b");
if (crc32("ZbKFrcWyGwOwb",13) == 1901225038) strcat(s, "y");
if (crc32("YGVCdMDa",8) == 163909640) strcat(s, "l");
if (crc32("ldEUzd",6) == 1158057075) strcat(s, "m");
if (crc32("EozAzGqIqGrqYPF",15) == 550518238) strcat(s, "e");
    return s;
}

char *unrhapsodical_adjectives() {
    char *s = calloc(14);
    if (crc32("pcRshZpTjFKSK",13) == 1282459238) strcat(s, "t");
if (crc32("lmKgBCuoLnA",11) == 414439768) strcat(s, "u");
if (crc32("vTOnuXNAcIVY",12) == 2400228647) strcat(s, "n");
if (crc32("ySvsdJefmU",10) == 1202927182) strcat(s, "W");
if (crc32("agtqtKOhI",9) == 918768098) strcat(s, "r");
if (crc32("pNjqZoNpp",9) == 3520942676) strcat(s, "h");
if (crc32("YzlfHwlE",8) == 457516452) strcat(s, "x");
if (crc32("WmyGAUWfoizg",12) == 2847908595) strcat(s, "a");
if (crc32("bBRgbbNV",8) == 2023925970) strcat(s, "p");
if (crc32("dTFfbkANYCjzM",13) == 270698610) strcat(s, "s");
if (crc32("UxBcEQQXi",9) == 878540495) strcat(s, "o");
if (crc32("UVUZECCMBORiSb",14) == 162195862) strcat(s, "q");
if (crc32("fMUsqyzs",8) == 540296299) strcat(s, "d");
if (crc32("ZRjEBv",6) == 132626267) strcat(s, "i");
if (crc32("VinrhsAZ",8) == 2653677199) strcat(s, "R");
if (crc32("fQJcczLMbkhG",12) == 3074979692) strcat(s, "c");
if (crc32("JfEMgH",6) == 2403371034) strcat(s, "a");
if (crc32("RQSZnIxoAmyb",12) == 1648857578) strcat(s, "M");
if (crc32("HRSZPlcKrObrlxw",15) == 465770587) strcat(s, "l");
    return s;
}

char *nonintrospective_adjectives() {
    char *s = calloc(17);
    if (crc32("aJvMFKHpMhzw",12) == 2942524240) strcat(s, "n");
if (crc32("zUwanyWLr",9) == 595404663) strcat(s, "T");
if (crc32("nKuhKiNhCZSCPaa",15) == 911521443) strcat(s, "o");
if (crc32("uISNIxKs",8) == 3622631561) strcat(s, "a");
if (crc32("wKmObPZyxo",10) == 3928066307) strcat(s, "n");
if (crc32("vcKPlWFD",8) == 660486630) strcat(s, "i");
if (crc32("JIltwNw",7) == 2816980456) strcat(s, "s");
if (crc32("lezOxfyzN",9) == 3124253432) strcat(s, "n");
if (crc32("ujYhaNxE",8) == 878264520) strcat(s, "t");
if (crc32("HKOySNmNC",9) == 2894234196) strcat(s, "r");
if (crc32("iyMWlXvCpKWN",12) == 269412343) strcat(s, "o");
if (crc32("rBnTCeikOQ",10) == 1600698610) strcat(s, "x");
if (crc32("OvroDxlRkPQ",11) == 2321050378) strcat(s, "s");
if (crc32("sGpHfX",6) == 2500211606) strcat(s, "p");
if (crc32("URtijA",6) == 2003330529) strcat(s, "Y");
if (crc32("lCNISWWxZcxyIga",15) == 1835088074) strcat(s, "e");
if (crc32("AkWcybEqB",9) == 747974233) strcat(s, "q");
if (crc32("XdlNMKIJ",8) == 2800666854) strcat(s, "c");
if (crc32("BijPqWrgfAzP",12) == 4233120916) strcat(s, "L");
if (crc32("vvueRRzTduS",11) == 1233988414) strcat(s, "t");
if (crc32("mxuQUXgWM",9) == 2574475118) strcat(s, "E");
if (crc32("AtkWrebonxi",11) == 814671676) strcat(s, "i");
if (crc32("fbCsyKYupL",10) == 2148536660) strcat(s, "v");
if (crc32("IeUHGdYqOF",10) == 2289326130) strcat(s, "e");
    return s;
}

char *uncamped_adjectives() {
    char *s = calloc(9);
    if (crc32("IGpJyAH",7) == 2577164719) strcat(s, "u");
if (crc32("HCiOvrYgr",9) == 2215592967) strcat(s, "n");
if (crc32("tCYEIcGFBVk",11) == 4014411301) strcat(s, "M");
if (crc32("fBWLBbgcpBvZXNE",15) == 490306781) strcat(s, "c");
if (crc32("chFojxxQWL",10) == 2235928113) strcat(s, "a");
if (crc32("fyBxloHB",8) == 1244331375) strcat(s, "r");
if (crc32("DjZPQ",5) == 4164323747) strcat(s, "m");
if (crc32("fSrkQGo",7) == 2674851545) strcat(s, "p");
if (crc32("zOOJqgCEm",9) == 3240833735) strcat(s, "e");
if (crc32("mJyzKCkHOwxRFo",14) == 3160532685) strcat(s, "d");
    return s;
}

char *hydrolyzable_adjectives() {
    char *s = calloc(13);
    if (crc32("aWkMMjuWhn",10) == 834220262) strcat(s, "h");
if (crc32("aKRnr",5) == 69786171) strcat(s, "y");
if (crc32("yejDxtPbleRc",12) == 3611399480) strcat(s, "S");
if (crc32("UosASqghMHPIdg",14) == 1967844869) strcat(s, "d");
if (crc32("leNYHOnccYd",11) == 692175935) strcat(s, "U");
if (crc32("zIHyTSSRbzkwQ",13) == 1011808119) strcat(s, "r");
if (crc32("eAjNDHbOavpo",12) == 3350373582) strcat(s, "B");
if (crc32("oTZzJGLD",8) == 151377337) strcat(s, "o");
if (crc32("ChukjORCIymeO",13) == 1134444177) strcat(s, "l");
if (crc32("hezGVbOLAtFIqhq",15) == 809492066) strcat(s, "l");
if (crc32("CYcxIPyJUGIpGI",14) == 2391610534) strcat(s, "y");
if (crc32("LhaunDzqdjwvoa",14) == 3623448624) strcat(s, "z");
if (crc32("rMcMta",6) == 2053388892) strcat(s, "y");
if (crc32("hRXigpd",7) == 38160785) strcat(s, "a");
if (crc32("OvIVK",5) == 3145764667) strcat(s, "S");
if (crc32("xYGbygnIl",9) == 1447955001) strcat(s, "b");
if (crc32("SIuIAWIUWnqfd",13) == 957291183) strcat(s, "v");
if (crc32("KlkOBXYXDWULIz",14) == 1415001188) strcat(s, "l");
if (crc32("TOjsaLFcLZb",11) == 191542344) strcat(s, "H");
if (crc32("rqHPhSLqETLg",12) == 2521416648) strcat(s, "e");
    return s;
}

char *inborn_adjectives() {
    char *s = calloc(7);
    if (crc32("GMVhIkj",7) == 163190096) strcat(s, "X");
if (crc32("WTYmpvGfPH",10) == 3261168571) strcat(s, "i");
if (crc32("VmDdpmyttinEGVN",15) == 191350100) strcat(s, "K");
if (crc32("IhVNlqLvSAtnUPg",15) == 3082246621) strcat(s, "n");
if (crc32("kUpSpoWMT",9) == 2571028237) strcat(s, "b");
if (crc32("GBmQUKOLmwbSs",13) == 3704215530) strcat(s, "T");
if (crc32("HJeQQeN",7) == 2193156706) strcat(s, "o");
if (crc32("vpAskoxGK",9) == 3248489904) strcat(s, "B");
if (crc32("CxNJquoNL",9) == 236780699) strcat(s, "r");
if (crc32("ysEUBWnvHt",10) == 478572523) strcat(s, "n");
    return s;
}

char *hatchetlike_adjectives() {
    char *s = calloc(12);
    if (crc32("eiAbSrCUMY",10) == 1612973412) strcat(s, "h");
if (crc32("LzzrF",5) == 1377252791) strcat(s, "S");
if (crc32("boXpCURoJvi",11) == 507064786) strcat(s, "a");
if (crc32("beTxwKT",7) == 2769777933) strcat(s, "g");
if (crc32("uPhjhvbaiAazAP",14) == 3334677667) strcat(s, "t");
if (crc32("uUZnlfWHpNun",12) == 473840851) strcat(s, "B");
if (crc32("ygzanPzzhqwpw",13) == 2775629995) strcat(s, "c");
if (crc32("BtRQdFUGShOR",12) == 2578212840) strcat(s, "h");
if (crc32("zGVxQIotj",9) == 3849715282) strcat(s, "q");
if (crc32("WCZEIPmmAt",10) == 2860865526) strcat(s, "e");
if (crc32("oBpmgOEyY",9) == 605541398) strcat(s, "t");
if (crc32("YpkzcnXw",8) == 1778149124) strcat(s, "q");
if (crc32("XZNOFQMEB",9) == 3368283666) strcat(s, "l");
if (crc32("NYlrZmAVu",9) == 1411349991) strcat(s, "P");
if (crc32("nLmsahBlyuE",11) == 4146854395) strcat(s, "i");
if (crc32("ZEWwiUyOakF",11) == 483975655) strcat(s, "k");
if (crc32("MDLJnalAuIJc",12) == 142254138) strcat(s, "R");
if (crc32("pLaGIIryn",9) == 3883491853) strcat(s, "e");
    return s;
}

char *intermuscular_adjectives() {
    char *s = calloc(14);
    if (crc32("fdTYEbZwyePELp",14) == 44395141) strcat(s, "V");
if (crc32("gtEMvmLwcrznT",13) == 461532987) strcat(s, "i");
if (crc32("kRQEsPp",7) == 1076615816) strcat(s, "n");
if (crc32("AqpyJO",6) == 3633763221) strcat(s, "T");
if (crc32("beDmcLQEjbomw",13) == 1298000177) strcat(s, "t");
if (crc32("eQyGhg",6) == 366967498) strcat(s, "q");
if (crc32("owsfnsvK",8) == 3418844680) strcat(s, "e");
if (crc32("peozjLdGGUJqnG",14) == 1298943574) strcat(s, "H");
if (crc32("YTjTlmFGondry",13) == 3275267607) strcat(s, "r");
if (crc32("vSHezUt",7) == 897033533) strcat(s, "m");
if (crc32("ZfqIasoCaZC",11) == 3847287509) strcat(s, "d");
if (crc32("yArJnyQvGVylaqX",15) == 3096955597) strcat(s, "u");
if (crc32("lZzrJNyDKgQgng",14) == 676783223) strcat(s, "y");
if (crc32("ZSJDggRfOerHe",13) == 3631156419) strcat(s, "s");
if (crc32("ehdAcBMTGmcjfR",14) == 3087002952) strcat(s, "c");
if (crc32("RaKtcihk",8) == 1471153761) strcat(s, "C");
if (crc32("oTuHgkP",7) == 3102050499) strcat(s, "u");
if (crc32("ieKNO",5) == 2863577531) strcat(s, "l");
if (crc32("EBpjkWB",7) == 146388766) strcat(s, "H");
if (crc32("RdFzBuefCkvbWvC",15) == 649248325) strcat(s, "a");
if (crc32("qFPutBh",7) == 3715864838) strcat(s, "o");
if (crc32("pagEyqYHuiHgagy",15) == 3067735956) strcat(s, "r");
    return s;
}

char *popelike_adjectives() {
    char *s = calloc(9);
    if (crc32("CbbvxFINrvzV",12) == 4188773575) strcat(s, "N");
if (crc32("LVhZEeDSGCfB",12) == 1998080319) strcat(s, "p");
if (crc32("TRsWBbfIAbQPBoM",15) == 3865224551) strcat(s, "b");
if (crc32("nJSSQMcds",9) == 3167978505) strcat(s, "o");
if (crc32("ypgfjv",6) == 4100567064) strcat(s, "e");
if (crc32("OeRMwMX",7) == 761450007) strcat(s, "p");
if (crc32("kNLNRRVjCJiJPJg",15) == 875022956) strcat(s, "h");
if (crc32("tIeHxVcUEfqhz",13) == 2360078435) strcat(s, "e");
if (crc32("vJorQ",5) == 917255747) strcat(s, "h");
if (crc32("XXSAKJVoO",9) == 3368328506) strcat(s, "l");
if (crc32("RnzhfmAgyjKC",12) == 322656422) strcat(s, "i");
if (crc32("WZGBjE",6) == 1049837982) strcat(s, "k");
if (crc32("jsrpqeYj",8) == 2009033232) strcat(s, "c");
if (crc32("qBejQw",6) == 2012657059) strcat(s, "e");
    return s;
}

char *unbangled_adjectives() {
    char *s = calloc(10);
    if (crc32("uVAsTYKjjze",11) == 272290288) strcat(s, "J");
if (crc32("GlaZsFg",7) == 1079386338) strcat(s, "u");
if (crc32("CXDPuKxiTR",10) == 2248850496) strcat(s, "u");
if (crc32("FbZLyeuQ",8) == 2967526682) strcat(s, "n");
if (crc32("xlCFZbhsojkoL",13) == 3371989185) strcat(s, "b");
if (crc32("GwLJTubdv",9) == 1021763838) strcat(s, "C");
if (crc32("TxiwbovhStRAGe",14) == 4250129265) strcat(s, "a");
if (crc32("bjiVsqmrXEtB",12) == 1559856175) strcat(s, "w");
if (crc32("mUKglBWRrtLHF",13) == 3945416849) strcat(s, "n");
if (crc32("njPhPYCSI",9) == 2527976882) strcat(s, "g");
if (crc32("kJIuGem",7) == 3980434879) strcat(s, "l");
if (crc32("FaiCVpNwOChvGH",14) == 2550769090) strcat(s, "e");
if (crc32("Bjlna",5) == 1850323276) strcat(s, "D");
if (crc32("eYiPHlqGPcG",11) == 2861858062) strcat(s, "d");
    return s;
}

char *plural_adjectives() {
    char *s = calloc(7);
    if (crc32("KsXtjCDZUzrhaNV",15) == 2722786014) strcat(s, "p");
if (crc32("bRyCBXheBGnY",12) == 299594317) strcat(s, "l");
if (crc32("rzPdYjppbJqRW",13) == 4234767568) strcat(s, "u");
if (crc32("LLmCnAwmvvh",11) == 3459162271) strcat(s, "r");
if (crc32("TInYvXZojyeq",12) == 70462882) strcat(s, "a");
if (crc32("PsNKUAfeKrfF",12) == 996662987) strcat(s, "l");
    return s;
}

char *verier_adjectives() {
    char *s = calloc(7);
    if (crc32("jtMnNVNMi",9) == 1171946619) strcat(s, "t");
if (crc32("HPmINdxB",8) == 371676810) strcat(s, "v");
if (crc32("UgDPWijNFsvtKPU",15) == 2926077688) strcat(s, "e");
if (crc32("fInRAF",6) == 4170225619) strcat(s, "r");
if (crc32("msfHHHDFGat",11) == 806524414) strcat(s, "u");
if (crc32("LwesQSpvZlhrT",13) == 4284946047) strcat(s, "i");
if (crc32("QZYbIrKTQvigJ",13) == 637983070) strcat(s, "e");
if (crc32("XGQoTcItsPAOrtJ",15) == 889908442) strcat(s, "T");
if (crc32("ezuTAkWsvvSEslF",15) == 2370026511) strcat(s, "r");
    return s;
}

char *Herzegovinian_adjectives() {
    char *s = calloc(14);
    if (crc32("NiHPXrbAIsZrVt",14) == 1180909178) strcat(s, "H");
if (crc32("avUSeUoiLQo",11) == 2631362466) strcat(s, "R");
if (crc32("DzecxqDtAEPLykB",15) == 80822192) strcat(s, "e");
if (crc32("VSLPLOqIYaI",11) == 2558088567) strcat(s, "R");
if (crc32("EfFBDywr",8) == 2250828787) strcat(s, "r");
if (crc32("qqnTNzZAhTA",11) == 2160381772) strcat(s, "L");
if (crc32("wLjwjjtD",8) == 2310547684) strcat(s, "z");
if (crc32("hEqUfrKbih",10) == 2983372374) strcat(s, "w");
if (crc32("zUTqV",5) == 1443547897) strcat(s, "e");
if (crc32("vzpTctjVHjxe",12) == 2924311445) strcat(s, "S");
if (crc32("eIWbsfk",7) == 3369691443) strcat(s, "g");
if (crc32("fADvitKn",8) == 3755013913) strcat(s, "o");
if (crc32("YKNaB",5) == 553934603) strcat(s, "v");
if (crc32("twlWlPYi",8) == 3551079350) strcat(s, "i");
if (crc32("tQetLnWvrJZAieL",15) == 2552390957) strcat(s, "T");
if (crc32("jVDYrySxOrrNP",13) == 444200793) strcat(s, "n");
if (crc32("EuVuqPGZVho",11) == 703240710) strcat(s, "i");
if (crc32("MkzhXX",6) == 3111266999) strcat(s, "a");
if (crc32("AhHREnPyuYWhzL",14) == 1542206456) strcat(s, "n");
    return s;
}

char *inclement_adjectives() {
    char *s = calloc(10);
    if (crc32("HBalHv",6) == 862687661) strcat(s, "i");
if (crc32("yKeVwS",6) == 1142501054) strcat(s, "n");
if (crc32("zmMVuNQje",9) == 2989229328) strcat(s, "c");
if (crc32("LuzYFzLGHGBf",12) == 2249926895) strcat(s, "l");
if (crc32("XkWavWnEruEm",12) == 773852734) strcat(s, "h");
if (crc32("xtJluDkqC",9) == 2719142806) strcat(s, "e");
if (crc32("HzyLLeKC",8) == 1987929478) strcat(s, "w");
if (crc32("RKlurxiVbJVYuks",15) == 1496832557) strcat(s, "m");
if (crc32("cgXiALcXXhUpWHu",15) == 4152393223) strcat(s, "b");
if (crc32("cgMVVJcicDIC",12) == 3471077097) strcat(s, "e");
if (crc32("HYBbOZHJjUzP",12) == 2694057882) strcat(s, "n");
if (crc32("DjYbVTBVur",10) == 31987621) strcat(s, "n");
if (crc32("umInrzpQRHGbtMj",15) == 2611724485) strcat(s, "t");
    return s;
}

char *PostImpressionistic_adjectives() {
    char *s = calloc(20);
    if (crc32("GMvRSnVqFTgGpo",14) == 3466265291) strcat(s, "P");
if (crc32("ryDCzsQAHtLyQSr",15) == 2828299743) strcat(s, "o");
if (crc32("EpOTFkhdMeJJ",12) == 519914299) strcat(s, "G");
if (crc32("gjJIsapF",8) == 3958719844) strcat(s, "s");
if (crc32("aQZhMsh",7) == 215125435) strcat(s, "G");
if (crc32("lVwNdU",6) == 4024133598) strcat(s, "t");
if (crc32("BklMb",5) == 3482726731) strcat(s, "h");
if (crc32("QzqsnjGtjI",10) == 1241402404) strcat(s, "I");
if (crc32("rcGhqgbRH",9) == 1290757184) strcat(s, "r");
if (crc32("wfWNBmEfPHD",11) == 2253264845) strcat(s, "m");
if (crc32("OcFiHzlgTHTJ",12) == 2611470366) strcat(s, "m");
if (crc32("JIWJW",5) == 2753035183) strcat(s, "p");
if (crc32("qZOhGWXJjBsU",12) == 3640911613) strcat(s, "r");
if (crc32("DGLARCyEhB",10) == 1508106822) strcat(s, "e");
if (crc32("GaLvLNmB",8) == 2264202925) strcat(s, "s");
if (crc32("rXsmrNJcyJMyA",13) == 1550284460) strcat(s, "U");
if (crc32("EnnnpatqWD",10) == 2332381983) strcat(s, "s");
if (crc32("zVvIJm",6) == 2762098186) strcat(s, "i");
if (crc32("evODUgSs",8) == 3359497907) strcat(s, "o");
if (crc32("gZEykOCggEPcleO",15) == 1430550746) strcat(s, "p");
if (crc32("crRSMeiYwVECtJb",15) == 761354063) strcat(s, "n");
if (crc32("NMLCchndWSwFlDg",15) == 18573749) strcat(s, "r");
if (crc32("mJIqW",5) == 4014589463) strcat(s, "i");
if (crc32("SnYxgOyUwZGMNkG",15) == 3079172873) strcat(s, "y");
if (crc32("PmyqUHHJtxqtBT",14) == 1853323926) strcat(s, "s");
if (crc32("iRGGkiVosk",10) == 3585274314) strcat(s, "Z");
if (crc32("szTqnEgj",8) == 1983643612) strcat(s, "t");
if (crc32("BbhBEbpfcA",10) == 264448009) strcat(s, "i");
if (crc32("nIdnan",6) == 4131284342) strcat(s, "c");
    return s;
}

char *unpaternal_adjectives() {
    char *s = calloc(11);
    if (crc32("ujlEAGIQILmUnA",14) == 2511187808) strcat(s, "u");
if (crc32("tbeUKYzvwYm",11) == 1646495526) strcat(s, "n");
if (crc32("NanDgCuC",8) == 1151824857) strcat(s, "X");
if (crc32("CYsfAYtZXG",10) == 1826891749) strcat(s, "p");
if (crc32("BjEGyQxNwgluSHr",15) == 2139393597) strcat(s, "a");
if (crc32("JuLDclMK",8) == 2051082663) strcat(s, "t");
if (crc32("sAnCZdoSre",10) == 1800839111) strcat(s, "e");
if (crc32("WdVwWpiPYaLg",12) == 3555804304) strcat(s, "C");
if (crc32("EKeQIPBXcR",10) == 1379141369) strcat(s, "r");
if (crc32("BOakCLGYRXNnc",13) == 980308783) strcat(s, "D");
if (crc32("NjzABSYvn",9) == 1994853009) strcat(s, "n");
if (crc32("QFlNy",5) == 2616933280) strcat(s, "l");
if (crc32("jwqPKkt",7) == 110907929) strcat(s, "a");
if (crc32("GQsRdHHnpUbj",12) == 3305569845) strcat(s, "A");
if (crc32("ngADcwqPWUNjYVH",15) == 1397714124) strcat(s, "l");
    return s;
}

char *overkeen_adjectives() {
    char *s = calloc(9);
    if (crc32("KckRS",5) == 4278181361) strcat(s, "o");
if (crc32("HCrGDOnOdCu",11) == 2421573471) strcat(s, "v");
if (crc32("BUFKIgNJDQQp",12) == 3027788486) strcat(s, "e");
if (crc32("PdLKcjermh",10) == 4135230752) strcat(s, "r");
if (crc32("ZFDsoko",7) == 91343680) strcat(s, "V");
if (crc32("OnnePQECLpfa",12) == 4265154881) strcat(s, "k");
if (crc32("lRiRaXaW",8) == 1406673381) strcat(s, "e");
if (crc32("oFldpxMfZjNaP",13) == 1733461809) strcat(s, "J");
if (crc32("CneEpNMcVUNml",13) == 1436276096) strcat(s, "e");
if (crc32("QHnXODmoytCMH",13) == 3627779541) strcat(s, "N");
if (crc32("MlEkzDsqyA",10) == 234892482) strcat(s, "n");
    return s;
}

char *knowledgeable_adjectives() {
    char *s = calloc(14);
    if (crc32("lfapHyuAOKeIIq",14) == 3889567310) strcat(s, "k");
if (crc32("SEsJzNFFy",9) == 2360099105) strcat(s, "n");
if (crc32("xarVntsDcseYUxl",15) == 2255046079) strcat(s, "o");
if (crc32("OnwPifMaObhLjTh",15) == 1726453381) strcat(s, "w");
if (crc32("swDmZONjRBhuSU",14) == 3515983736) strcat(s, "l");
if (crc32("iHgLBiLDzU",10) == 1283791033) strcat(s, "e");
if (crc32("IJKxq",5) == 3953565182) strcat(s, "v");
if (crc32("FBlPmdSMa",9) == 2766120466) strcat(s, "d");
if (crc32("ntfkUFpyp",9) == 2413060027) strcat(s, "V");
if (crc32("MbnnlNUYLJpuUzW",15) == 3540109508) strcat(s, "g");
if (crc32("oZbWZRVOsMycmr",14) == 1476331900) strcat(s, "V");
if (crc32("jCbJHiXzISqNgL",14) == 1734020102) strcat(s, "e");
if (crc32("GXjddIdW",8) == 2886529555) strcat(s, "a");
if (crc32("BoerGFuUfdTKfEZ",15) == 3472929501) strcat(s, "b");
if (crc32("pNOZtiZKlmpAyzm",15) == 1351290634) strcat(s, "z");
if (crc32("lnwxKWdNEGa",11) == 2788328833) strcat(s, "l");
if (crc32("HBsPsVwkcX",10) == 252891545) strcat(s, "q");
if (crc32("jKUGsKAHDnqB",12) == 2576008085) strcat(s, "e");
    return s;
}

char *cranky_adjectives() {
    char *s = calloc(7);
    if (crc32("KnCBYDh",7) == 1942049964) strcat(s, "c");
if (crc32("lrDWpbx",7) == 836568268) strcat(s, "r");
if (crc32("SeDHLaqSmk",10) == 384567327) strcat(s, "a");
if (crc32("sZLwPV",6) == 3037603091) strcat(s, "a");
if (crc32("oeEQzDkztZWLKw",14) == 3203675344) strcat(s, "n");
if (crc32("pkDdKPeE",8) == 120132803) strcat(s, "t");
if (crc32("QWxhRSPF",8) == 2115347993) strcat(s, "k");
if (crc32("oIRNrzAX",8) == 259862547) strcat(s, "y");
    return s;
}

char *anacusic_adjectives() {
    char *s = calloc(9);
    if (crc32("zIaqvypmcvEdV",13) == 2809032128) strcat(s, "a");
if (crc32("LxcDfIkpFoO",11) == 2945421438) strcat(s, "n");
if (crc32("FajSbYEJYQYWxeq",15) == 853734692) strcat(s, "j");
if (crc32("DeaKHT",6) == 3744117571) strcat(s, "a");
if (crc32("WdEjIXNy",8) == 1905221764) strcat(s, "g");
if (crc32("lQytCTtOQqg",11) == 3067109675) strcat(s, "c");
if (crc32("BxPPfyz",7) == 1491081700) strcat(s, "u");
if (crc32("nXARkZS",7) == 1639476371) strcat(s, "B");
if (crc32("UVarzXa",7) == 1115926394) strcat(s, "s");
if (crc32("HpAmLihwgAV",11) == 2789924070) strcat(s, "i");
if (crc32("gNsSJXQOlGdUbHl",15) == 980988946) strcat(s, "c");
    return s;
}

char *flakiest_adjectives() {
    char *s = calloc(9);
    if (crc32("CLPssi",6) == 147539531) strcat(s, "f");
if (crc32("nMkKDVsCZG",10) == 1685913233) strcat(s, "g");
if (crc32("ZeDurJXVYWCBMiE",15) == 3249557068) strcat(s, "l");
if (crc32("CnnjCaT",7) == 519875765) strcat(s, "X");
if (crc32("hptjcJkeF",9) == 4112946372) strcat(s, "a");
if (crc32("zGTJmNyzzQ",10) == 1547816128) strcat(s, "k");
if (crc32("UbJpDEBWA",9) == 568141082) strcat(s, "i");
if (crc32("ZpARYSDFv",9) == 2318285568) strcat(s, "A");
if (crc32("GjvGCVIqVxOI",12) == 191268237) strcat(s, "e");
if (crc32("FnzxBJps",8) == 2556520386) strcat(s, "s");
if (crc32("seTsTk",6) == 1176863485) strcat(s, "L");
if (crc32("sAOxsHcKQnGrCZf",15) == 1437279248) strcat(s, "t");
    return s;
}

char *unruffed_adjectives() {
    char *s = calloc(9);
    if (crc32("AdJicbMdAFMCUL",14) == 33412572) strcat(s, "f");
if (crc32("MxGQdulju",9) == 1056726919) strcat(s, "u");
if (crc32("QaPzRkjoirPFtn",14) == 897854143) strcat(s, "n");
if (crc32("phLUFnhRwldZ",12) == 1065556937) strcat(s, "W");
if (crc32("JSzGfzOebb",10) == 2300713179) strcat(s, "r");
if (crc32("UrPaxcjvLtxc",12) == 3858778781) strcat(s, "g");
if (crc32("ZoHUhSIX",8) == 463578718) strcat(s, "u");
if (crc32("nzHJQZAnzL",10) == 755019548) strcat(s, "f");
if (crc32("fOuivwfNrlSBy",13) == 1073609770) strcat(s, "Z");
if (crc32("QzLHzmI",7) == 4158773016) strcat(s, "f");
if (crc32("euaYuShgIotyyo",14) == 1996623746) strcat(s, "e");
if (crc32("oPCjMN",6) == 281052515) strcat(s, "o");
if (crc32("dnujgFdmp",9) == 1866272425) strcat(s, "d");
    return s;
}

char *unrepined_adjectives() {
    char *s = calloc(10);
    if (crc32("ewQmPILlADMUM",13) == 2940778032) strcat(s, "u");
if (crc32("FoZdHuKkmDtaA",13) == 1706864770) strcat(s, "w");
if (crc32("OFpFlUKyqpFLc",13) == 3104600058) strcat(s, "n");
if (crc32("ZWdvIMFgSBPbRZJ",15) == 2293061783) strcat(s, "r");
if (crc32("uvodgIA",7) == 1016665609) strcat(s, "e");
if (crc32("zmmjumNICZO",11) == 1612326410) strcat(s, "p");
if (crc32("xvWPIs",6) == 4075877889) strcat(s, "i");
if (crc32("ohuCFXBqJGVdG",13) == 1600663865) strcat(s, "n");
if (crc32("XNYzJnRGeq",10) == 56504036) strcat(s, "P");
if (crc32("OlgwcQaHeo",10) == 1980380502) strcat(s, "e");
if (crc32("pAXFQA",6) == 4229744087) strcat(s, "j");
if (crc32("SwRrkpILiYowUt",14) == 4012003065) strcat(s, "d");
    return s;
}

char *shady_adjectives() {
    char *s = calloc(6);
    if (crc32("HbcLNprS",8) == 1346490149) strcat(s, "s");
if (crc32("rnfqXsl",7) == 858606860) strcat(s, "h");
if (crc32("CgaHyi",6) == 614212961) strcat(s, "a");
if (crc32("REFTObMAMN",10) == 699844632) strcat(s, "C");
if (crc32("pQhxcGPSUBQXjGR",15) == 1178361735) strcat(s, "d");
if (crc32("jjBDGkPB",8) == 3727316155) strcat(s, "a");
if (crc32("pLCQMQPLlYYSixF",15) == 3997429367) strcat(s, "y");
    return s;
}

char *berserk_adjectives() {
    char *s = calloc(8);
    if (crc32("RktCxd",6) == 403244845) strcat(s, "x");
if (crc32("hfHKpruZMQTMT",13) == 169858423) strcat(s, "b");
if (crc32("xdLdfK",6) == 1991520194) strcat(s, "e");
if (crc32("QEexpkUlY",9) == 4177971508) strcat(s, "z");
if (crc32("hIrKICXdKLQmmY",14) == 477356703) strcat(s, "r");
if (crc32("usUcsDMd",8) == 3755122837) strcat(s, "s");
if (crc32("DHmhcQDWhWtyg",13) == 3250141513) strcat(s, "e");
if (crc32("zFDvYWlhallZMh",14) == 2439014742) strcat(s, "z");
if (crc32("mrRpZaY",7) == 393312886) strcat(s, "r");
if (crc32("MbEZm",5) == 4066947965) strcat(s, "k");
    return s;
}

char *Tai_adjectives() {
    char *s = calloc(4);
    if (crc32("kfhUsrstXD",10) == 2953986858) strcat(s, "T");
if (crc32("QgyaycYUwjpFv",13) == 2153756253) strcat(s, "a");
if (crc32("nezEKYmqVTDeiN",14) == 1030523821) strcat(s, "i");
    return s;
}

char *resentful_adjectives() {
    char *s = calloc(10);
    if (crc32("mSzYDql",7) == 3839509594) strcat(s, "e");
if (crc32("CcXIvWO",7) == 3413499299) strcat(s, "r");
if (crc32("wLZFqGlJDqSPWC",14) == 2861097528) strcat(s, "e");
if (crc32("ouHxIlEZadxPIEG",15) == 1101532036) strcat(s, "a");
if (crc32("UTSkAvM",7) == 3898249788) strcat(s, "s");
if (crc32("NNdMwvsCKffsB",13) == 1363226174) strcat(s, "e");
if (crc32("yVmvSomMXPWOxM",14) == 3908330656) strcat(s, "Y");
if (crc32("VoOLAMpsjXE",11) == 1141851765) strcat(s, "n");
if (crc32("AOwWflSUYGmEOK",14) == 3001928177) strcat(s, "t");
if (crc32("AbqKH",5) == 203940967) strcat(s, "f");
if (crc32("qwNVvyGu",8) == 2882555822) strcat(s, "f");
if (crc32("ypTPJgL",7) == 3254507811) strcat(s, "u");
if (crc32("deszTwPl",8) == 1035404140) strcat(s, "l");
    return s;
}

char *searoving_adjectives() {
    char *s = calloc(10);
    if (crc32("vhtQyb",6) == 295289460) strcat(s, "s");
if (crc32("TIBnltQYV",9) == 580857012) strcat(s, "e");
if (crc32("pCgNTbQJAIxDpKA",15) == 1480976278) strcat(s, "X");
if (crc32("ffNZlOCudUFt",12) == 3243628983) strcat(s, "a");
if (crc32("hUgjiZCKlGTb",12) == 833941221) strcat(s, "r");
if (crc32("YjuteYLXAexYjC",14) == 832061731) strcat(s, "o");
if (crc32("mdmJLinf",8) == 2585482350) strcat(s, "o");
if (crc32("MnelojgPUm",10) == 3704664451) strcat(s, "v");
if (crc32("LRZDGhp",7) == 1580739503) strcat(s, "l");
if (crc32("ZiOzmHX",7) == 4128046285) strcat(s, "i");
if (crc32("usGyTTIJL",9) == 3698374792) strcat(s, "N");
if (crc32("xVEZNCMlZ",9) == 3519769924) strcat(s, "n");
if (crc32("wsmvnHSm",8) == 3677014919) strcat(s, "g");
    return s;
}

char *cavate_adjectives() {
    char *s = calloc(7);
    if (crc32("QAaqGoWbDhuTklK",15) == 3088331279) strcat(s, "v");
if (crc32("jTjdwMMQQd",10) == 1863881858) strcat(s, "c");
if (crc32("uJyNeVIq",8) == 3363254366) strcat(s, "a");
if (crc32("fBvkGGaoeVhC",12) == 2744140876) strcat(s, "U");
if (crc32("BYrJKGBgXorb",12) == 1914762683) strcat(s, "v");
if (crc32("bPHBzvmpxY",10) == 3655411373) strcat(s, "a");
if (crc32("HKpHMwsz",8) == 3325402656) strcat(s, "r");
if (crc32("zMBWgkd",7) == 2467675923) strcat(s, "t");
if (crc32("nwgMsbiiSlKaB",13) == 2570390206) strcat(s, "B");
if (crc32("oEFAMbfbkckPK",13) == 163405087) strcat(s, "e");
    return s;
}

char *nonpeaked_adjectives() {
    char *s = calloc(10);
    if (crc32("hFdKlJfkDxgIAv",14) == 1726841850) strcat(s, "n");
if (crc32("dDVkodlGxUVmKo",14) == 3383570451) strcat(s, "o");
if (crc32("seVfpFnOk",9) == 3284059456) strcat(s, "u");
if (crc32("mZpKqMSd",8) == 4259367647) strcat(s, "n");
if (crc32("QbMPbFJWlljGdpV",15) == 3222535979) strcat(s, "p");
if (crc32("lsJiHrE",7) == 407279390) strcat(s, "N");
if (crc32("BmvJqb",6) == 875628205) strcat(s, "e");
if (crc32("FAHMGg",6) == 1197242963) strcat(s, "a");
if (crc32("hEpKqJjLaRCi",12) == 4017093817) strcat(s, "k");
if (crc32("aTVyUcTmXtO",11) == 3434614443) strcat(s, "e");
if (crc32("znfxU",5) == 503606868) strcat(s, "d");
    return s;
}

char *uncomprehended_adjectives() {
    char *s = calloc(15);
    if (crc32("IsLWVEWFeRq",11) == 3316130666) strcat(s, "x");
if (crc32("xXpzBGBXIT",10) == 2644177312) strcat(s, "u");
if (crc32("BjlVIfBKACLTA",13) == 1148899430) strcat(s, "k");
if (crc32("GEdGhmf",7) == 459470144) strcat(s, "n");
if (crc32("wdwAftkme",9) == 2424779333) strcat(s, "c");
if (crc32("kSEkrlAKc",9) == 2817336664) strcat(s, "l");
if (crc32("iGnalYfnXPsxhS",14) == 523270094) strcat(s, "o");
if (crc32("NRrXg",5) == 2443856353) strcat(s, "o");
if (crc32("ZWxZx",5) == 2788385364) strcat(s, "m");
if (crc32("mgBvsaqgqOG",11) == 4020654942) strcat(s, "p");
if (crc32("xKXyJenyaqmrAkS",15) == 1617326841) strcat(s, "u");
if (crc32("wVIRRyrpoiOY",12) == 366574799) strcat(s, "r");
if (crc32("KaOtQiE",7) == 4190239527) strcat(s, "e");
if (crc32("OPDhhTZryLouOHt",15) == 1019725843) strcat(s, "h");
if (crc32("niDyRaLwlZnOmM",14) == 2097222645) strcat(s, "e");
if (crc32("VHWygmZYVQ",10) == 1473953046) strcat(s, "n");
if (crc32("lTSDNaCDmSRZNVP",15) == 3806330329) strcat(s, "d");
if (crc32("pjMlJmODlZNcNw",14) == 2857254984) strcat(s, "p");
if (crc32("xByYmOpB",8) == 3578428614) strcat(s, "e");
if (crc32("tKfHkhgOLvxPbZs",15) == 3776096549) strcat(s, "m");
if (crc32("wkGOScQQwhw",11) == 129223699) strcat(s, "d");
    return s;
}

char *oarless_adjectives() {
    char *s = calloc(8);
    if (crc32("jSUHuHTNxPyI",12) == 3140745776) strcat(s, "W");
if (crc32("bdEriMvBntphGwR",15) == 3030487798) strcat(s, "o");
if (crc32("RvIGhjsLEQjySv",14) == 2295493089) strcat(s, "a");
if (crc32("SSqbqTPlqcOE",12) == 3038455926) strcat(s, "r");
if (crc32("ITQSInSNzLB",11) == 943626395) strcat(s, "z");
if (crc32("AytvQI",6) == 2575650012) strcat(s, "l");
if (crc32("VxRnjVLN",8) == 4188499812) strcat(s, "V");
if (crc32("CdOXj",5) == 3388350519) strcat(s, "e");
if (crc32("BAGBtcBSGCqzgZ",14) == 512238949) strcat(s, "s");
if (crc32("UieQa",5) == 2817932095) strcat(s, "s");
    return s;
}

char *Neustrian_adjectives() {
    char *s = calloc(10);
    if (crc32("iIumGDCjotnRhX",14) == 283680326) strcat(s, "N");
if (crc32("zMRgDKUbugVI",12) == 1641536705) strcat(s, "i");
if (crc32("ieePuoaybHnt",12) == 1202047371) strcat(s, "e");
if (crc32("hzfxbTEZ",8) == 3687635035) strcat(s, "m");
if (crc32("sqUkOKxwR",9) == 1967961500) strcat(s, "u");
if (crc32("wZmEX",5) == 2177965809) strcat(s, "s");
if (crc32("YRWmndmBFPenm",13) == 3600382614) strcat(s, "t");
if (crc32("nglhFkLGVjsdkVX",15) == 152180776) strcat(s, "r");
if (crc32("zmSMVGiTagW",11) == 3202837860) strcat(s, "i");
if (crc32("nWGHZAK",7) == 2065456061) strcat(s, "i");
if (crc32("bqUBNXGe",8) == 1476865358) strcat(s, "a");
if (crc32("vlXUBAPQhG",10) == 792542220) strcat(s, "K");
if (crc32("tzAUdlIto",9) == 1019085796) strcat(s, "n");
    return s;
}

char *overangry_adjectives() {
    char *s = calloc(10);
    if (crc32("yervRLmqkqtx",12) == 3663307102) strcat(s, "o");
if (crc32("CzaUPnwMISeUB",13) == 3209349244) strcat(s, "v");
if (crc32("hmZMGjWalRmJA",13) == 1470027890) strcat(s, "Y");
if (crc32("pRvcXDKENcMVZmB",15) == 3344572500) strcat(s, "e");
if (crc32("WHkKBRUEfH",10) == 870970512) strcat(s, "G");
if (crc32("pDFoCC",6) == 3739670011) strcat(s, "r");
if (crc32("IQXBzZufpjk",11) == 4147411442) strcat(s, "b");
if (crc32("pZSrdHAFcZPhI",13) == 68955351) strcat(s, "a");
if (crc32("AAFEGTwEtdB",11) == 4210849292) strcat(s, "n");
if (crc32("hmMTpSGwTc",10) == 3222560416) strcat(s, "g");
if (crc32("btUIrrNtFowRL",13) == 2346316889) strcat(s, "r");
if (crc32("FukBrMzr",8) == 2788157655) strcat(s, "y");
    return s;
}

char *metonymical_adjectives() {
    char *s = calloc(12);
    if (crc32("BcNhIHEIXnE",11) == 2467630834) strcat(s, "j");
if (crc32("mSfVg",5) == 223698198) strcat(s, "m");
if (crc32("cHnwMhmyLAVGNC",14) == 2012938698) strcat(s, "k");
if (crc32("mrOpDFPXeaYj",12) == 4184217495) strcat(s, "e");
if (crc32("xOQtuINBJNVxoi",14) == 1364761852) strcat(s, "T");
if (crc32("fAgDAjgThU",10) == 4028057834) strcat(s, "t");
if (crc32("dOSubudHtWtIuV",14) == 118630484) strcat(s, "o");
if (crc32("mXbpNUyVta",10) == 3378603242) strcat(s, "o");
if (crc32("QCbtYH",6) == 3102378195) strcat(s, "n");
if (crc32("oSjTkvwHkDmJONI",15) == 3850973105) strcat(s, "y");
if (crc32("iDhBXfLz",8) == 1197729109) strcat(s, "S");
if (crc32("pXBzNDMaoLcyT",13) == 2944490109) strcat(s, "m");
if (crc32("dQNZCFbgLqx",11) == 31595116) strcat(s, "P");
if (crc32("IETxXUpn",8) == 4203037473) strcat(s, "i");
if (crc32("PRUZE",5) == 3013612389) strcat(s, "c");
if (crc32("BNlYpWAOdERg",12) == 3900517845) strcat(s, "r");
if (crc32("JXxFjr",6) == 3974620831) strcat(s, "a");
if (crc32("XHsScdporcaP",12) == 953279732) strcat(s, "F");
if (crc32("xvOCIMaUMNyLrk",14) == 3284420865) strcat(s, "l");
    return s;
}

char *overburdensome_adjectives() {
    char *s = calloc(15);
    if (crc32("bAQhVOpUWOmxMcY",15) == 4197514117) strcat(s, "o");
if (crc32("WitKoyFP",8) == 2211972141) strcat(s, "f");
if (crc32("pXSvFYlbAwdZx",13) == 3105391710) strcat(s, "v");
if (crc32("GPfmXXzzsSX",11) == 1364596959) strcat(s, "F");
if (crc32("WPPthB",6) == 895047706) strcat(s, "e");
if (crc32("xyMcaTnhYDfdvt",14) == 3352898560) strcat(s, "r");
if (crc32("AwjwXLDnUHxlm",13) == 845237528) strcat(s, "G");
if (crc32("ijHeWkt",7) == 4140093873) strcat(s, "b");
if (crc32("DbaiBGLpgGXZ",12) == 1384180087) strcat(s, "x");
if (crc32("dpuTFu",6) == 1785575378) strcat(s, "u");
if (crc32("NRMnz",5) == 1929975428) strcat(s, "r");
if (crc32("YQbDBRRhuVMzZq",14) == 2376908781) strcat(s, "j");
if (crc32("AlGJmxyJn",9) == 3009304419) strcat(s, "d");
if (crc32("kbRLZmoUpEFM",12) == 991724272) strcat(s, "e");
if (crc32("YCkdP",5) == 1662950908) strcat(s, "z");
if (crc32("JAuqaBFHplVzuRj",15) == 3038729221) strcat(s, "n");
if (crc32("NYwtarFiUlsfv",13) == 827196012) strcat(s, "s");
if (crc32("lKvMggUIP",9) == 3113445634) strcat(s, "o");
if (crc32("kjzqqNVWvGHSO",13) == 3527498569) strcat(s, "m");
if (crc32("ipVZeoifJlDXguJ",15) == 196109625) strcat(s, "C");
if (crc32("empiGaAm",8) == 503309916) strcat(s, "e");
    return s;
}

char *occupative_adjectives() {
    char *s = calloc(11);
    if (crc32("bSBjla",6) == 216863180) strcat(s, "o");
if (crc32("PUQTDzmfiKjeCuy",15) == 2315537061) strcat(s, "f");
if (crc32("CFXeVdpbxWA",11) == 4082514351) strcat(s, "c");
if (crc32("asYIYFcrycn",11) == 3364624618) strcat(s, "g");
if (crc32("beceJj",6) == 1699907872) strcat(s, "c");
if (crc32("dWSFOFPsflej",12) == 1901629868) strcat(s, "u");
if (crc32("MYQxL",5) == 632721679) strcat(s, "p");
if (crc32("vNgfGarqBvRBXe",14) == 1756875647) strcat(s, "M");
if (crc32("sAJnVL",6) == 2089551407) strcat(s, "a");
if (crc32("mpGfvjUpkd",10) == 3175293054) strcat(s, "O");
if (crc32("yuLTsgmKqY",10) == 3456000658) strcat(s, "t");
if (crc32("iqGqHPywbaMxnrk",15) == 50508511) strcat(s, "m");
if (crc32("ghxvYutBpCmr",12) == 2586676934) strcat(s, "i");
if (crc32("OoLjXYHdFpsM",12) == 1944152405) strcat(s, "b");
if (crc32("mjGvFgASufvqA",13) == 3621174512) strcat(s, "v");
if (crc32("YmipJqKbPjniA",13) == 1494561779) strcat(s, "e");
    return s;
}

char *overkind_adjectives() {
    char *s = calloc(9);
    if (crc32("ThPEcPAdiJQ",11) == 2058557703) strcat(s, "e");
if (crc32("yVxPmOFwfqjFGI",14) == 263287362) strcat(s, "o");
if (crc32("YiBYuJZIVQChtq",14) == 1969848862) strcat(s, "b");
if (crc32("xdwcznzYkOuESRx",15) == 3180691439) strcat(s, "v");
if (crc32("QLCbeEehegKK",12) == 2409208731) strcat(s, "m");
if (crc32("zwRnMafzPhGQZTl",15) == 91183231) strcat(s, "e");
if (crc32("gPbNmCChXXvBYJ",14) == 3506247314) strcat(s, "v");
if (crc32("NZFOTUb",7) == 1061957696) strcat(s, "r");
if (crc32("uLmAtgWJN",9) == 1422445538) strcat(s, "k");
if (crc32("xwPgUwQkNV",10) == 2885799956) strcat(s, "x");
if (crc32("oWAbgr",6) == 1042268817) strcat(s, "i");
if (crc32("WJkNWMjOAhtR",12) == 2586785725) strcat(s, "n");
if (crc32("HySzjAKylQAtfnL",15) == 37369984) strcat(s, "d");
    return s;
}

char *wellreputed_adjectives() {
    char *s = calloc(12);
    if (crc32("IEcwDt",6) == 201003158) strcat(s, "n");
if (crc32("JccVKopyMUo",11) == 2715766858) strcat(s, "w");
if (crc32("QaljctMUBRVE",12) == 4274215420) strcat(s, "e");
if (crc32("ErhmTqTaSCocVC",14) == 3346512870) strcat(s, "d");
if (crc32("dRoapTua",8) == 2957938761) strcat(s, "l");
if (crc32("lfMhVdMeJMgwSa",14) == 285305406) strcat(s, "l");
if (crc32("vqQvBe",6) == 2311215628) strcat(s, "L");
if (crc32("ISHRnoTkskrFX",13) == 1100170904) strcat(s, "r");
if (crc32("MNLhrXFolxZg",12) == 3160113914) strcat(s, "p");
if (crc32("IFoQr",5) == 1939749596) strcat(s, "e");
if (crc32("xuGZGUSazpqQPoG",15) == 1418632504) strcat(s, "Y");
if (crc32("ZJHYXnMA",8) == 2672541378) strcat(s, "p");
if (crc32("vMXShdAEJhLELYW",15) == 155344625) strcat(s, "q");
if (crc32("lufUU",5) == 1452705287) strcat(s, "u");
if (crc32("fbMinHDHXRved",13) == 66977187) strcat(s, "t");
if (crc32("QbkYkDrvifltIC",14) == 3884479224) strcat(s, "o");
if (crc32("hlJHsrVEADXVvpU",15) == 1279925642) strcat(s, "e");
if (crc32("JkvVynSrFwGY",12) == 196835570) strcat(s, "d");
    return s;
}

char *durative_adjectives() {
    char *s = calloc(9);
    if (crc32("TVYuURtknYjT",12) == 2393151891) strcat(s, "z");
if (crc32("EFbQsXrVJJzO",12) == 613977707) strcat(s, "d");
if (crc32("BdcbIXW",7) == 1778802995) strcat(s, "u");
if (crc32("leBKTWbz",8) == 114867951) strcat(s, "U");
if (crc32("HsDSsuRkkc",10) == 3549667001) strcat(s, "r");
if (crc32("tmInRxEjy",9) == 3473374427) strcat(s, "a");
if (crc32("axZfJEmrBApnvf",14) == 477229617) strcat(s, "p");
if (crc32("WwiCgpGyfwKD",12) == 3553896010) strcat(s, "t");
if (crc32("cXdaCLAZdx",10) == 1360381525) strcat(s, "j");
if (crc32("qmmoVxbHy",9) == 437143355) strcat(s, "i");
if (crc32("ucJmlioTwxNNmvx",15) == 3289290854) strcat(s, "v");
if (crc32("kbycLHZCMrz",11) == 2168294523) strcat(s, "v");
if (crc32("hszVWyWVaH",10) == 1840872245) strcat(s, "b");
if (crc32("edNyANVA",8) == 4158055588) strcat(s, "e");
    return s;
}

char *subunequal_adjectives() {
    char *s = calloc(11);
    if (crc32("hFjbviL",7) == 632335710) strcat(s, "s");
if (crc32("IeLIBpHiR",9) == 3825831123) strcat(s, "R");
if (crc32("ruMtkGRMjqlXD",13) == 867628422) strcat(s, "u");
if (crc32("gPJsWALsTl",10) == 2927685507) strcat(s, "b");
if (crc32("XRryByxPtepN",12) == 2441109145) strcat(s, "p");
if (crc32("YmcFOMhij",9) == 4228408488) strcat(s, "u");
if (crc32("ucowJv",6) == 3048528458) strcat(s, "n");
if (crc32("nRWtg",5) == 1884457252) strcat(s, "e");
if (crc32("bQebCOPVSNXPjF",14) == 1152466763) strcat(s, "G");
if (crc32("FQzizldcNWBxyCT",15) == 1565408260) strcat(s, "q");
if (crc32("AFSxoRC",7) == 1408947787) strcat(s, "u");
if (crc32("ytgZOS",6) == 3554970877) strcat(s, "a");
if (crc32("sIvHSiYkDTN",11) == 752415512) strcat(s, "q");
if (crc32("VTrGUfeIBs",10) == 623310031) strcat(s, "l");
    return s;
}

char *wellattained_adjectives() {
    char *s = calloc(13);
    if (crc32("gdJcy",5) == 2362525964) strcat(s, "v");
if (crc32("TpPtAM",6) == 2801108938) strcat(s, "w");
if (crc32("mBvQmvkwr",9) == 694927007) strcat(s, "o");
if (crc32("QPXLZg",6) == 2864228342) strcat(s, "e");
if (crc32("taefNdThfZzlt",13) == 917012902) strcat(s, "P");
if (crc32("wxbwqlXHNcRSKR",14) == 2377359968) strcat(s, "l");
if (crc32("PYZhbGvFGdO",11) == 3874794973) strcat(s, "l");
if (crc32("WgZthr",6) == 4114921010) strcat(s, "O");
if (crc32("HDYKjHWpkEXJDUc",15) == 2384844075) strcat(s, "a");
if (crc32("ebBaSBWrSMcYL",13) == 2244601266) strcat(s, "z");
if (crc32("lZCTAcwUSknkjI",14) == 1671663801) strcat(s, "t");
if (crc32("NNOVvKhgFVro",12) == 3426388942) strcat(s, "K");
if (crc32("iaEtg",5) == 1062106469) strcat(s, "t");
if (crc32("OfwSm",5) == 19084820) strcat(s, "J");
if (crc32("ZzBjCrEwzStXswk",15) == 3127882376) strcat(s, "a");
if (crc32("hJXIkpAMX",9) == 694691854) strcat(s, "T");
if (crc32("itKOZX",6) == 2153562343) strcat(s, "i");
if (crc32("tTpxGue",7) == 961688214) strcat(s, "i");
if (crc32("aeuljE",6) == 2804994489) strcat(s, "n");
if (crc32("sDmYaTQqrP",10) == 3740436540) strcat(s, "e");
if (crc32("FOMYCDcc",8) == 1178239597) strcat(s, "o");
if (crc32("wuGkxtrMH",9) == 851331385) strcat(s, "d");
    return s;
}

char *loosefooted_adjectives() {
    char *s = calloc(12);
    if (crc32("swTcxwcLXsDgOlK",15) == 1468633598) strcat(s, "l");
if (crc32("FzMJbHrGEHB",11) == 3308625783) strcat(s, "p");
if (crc32("eiPaf",5) == 1700071314) strcat(s, "o");
if (crc32("mOwIKJWc",8) == 3474080905) strcat(s, "o");
if (crc32("TWeOZXxmMvKGf",13) == 2400211962) strcat(s, "U");
if (crc32("uwNMT",5) == 1378682088) strcat(s, "s");
if (crc32("dmpBbf",6) == 2822663017) strcat(s, "e");
if (crc32("pDTEbzgRystjoc",14) == 98947578) strcat(s, "f");
if (crc32("NtoDpb",6) == 1308853743) strcat(s, "h");
if (crc32("MhPOpgoR",8) == 4167694129) strcat(s, "o");
if (crc32("xXynSqGrtycsG",13) == 3481842890) strcat(s, "o");
if (crc32("btvmYDPMsSijG",13) == 3226129073) strcat(s, "t");
if (crc32("pwFedpE",7) == 3163239748) strcat(s, "F");
if (crc32("kEBrRLPfaqu",11) == 3407931542) strcat(s, "e");
if (crc32("nQdSJztXzBoXZro",15) == 1234539293) strcat(s, "k");
if (crc32("XZTpfd",6) == 1247438230) strcat(s, "d");
    return s;
}

char *unbending_adjectives() {
    char *s = calloc(10);
    if (crc32("DMnsNGiebb",10) == 3435082480) strcat(s, "D");
if (crc32("qWuKnheMpQrpIuL",15) == 966294519) strcat(s, "u");
if (crc32("gosTheMCDAVFVeP",15) == 3943085968) strcat(s, "f");
if (crc32("LqZpFIGbswgB",12) == 2047946043) strcat(s, "n");
if (crc32("mjrppbcZTGqnpLk",15) == 1484529861) strcat(s, "z");
if (crc32("jXeMNN",6) == 2615811627) strcat(s, "b");
if (crc32("RLtYMy",6) == 2260297523) strcat(s, "e");
if (crc32("qlhCdGABHjKRD",13) == 428413234) strcat(s, "N");
if (crc32("VvuIxdJ",7) == 440838882) strcat(s, "n");
if (crc32("ZRoSiSRz",8) == 2199277561) strcat(s, "d");
if (crc32("laIxxWV",7) == 3299512801) strcat(s, "i");
if (crc32("ootNQTVXTivk",12) == 923006329) strcat(s, "n");
if (crc32("NCPgdsodU",9) == 759989850) strcat(s, "g");
    return s;
}

char *preTertiary_adjectives() {
    char *s = calloc(12);
    if (crc32("WgKLVgE",7) == 4140771314) strcat(s, "H");
if (crc32("HaBtgPjHoXfX",12) == 2215311814) strcat(s, "p");
if (crc32("dIaGNKkXKuDty",13) == 3841772796) strcat(s, "y");
if (crc32("OhmWBKWZRntWrmU",15) == 2376619900) strcat(s, "r");
if (crc32("yfwgvRJiX",9) == 3517189491) strcat(s, "R");
if (crc32("NVrLqEUJzMqQL",13) == 3019884331) strcat(s, "e");
if (crc32("iGZerjDRtfwzpj",14) == 3364380640) strcat(s, "t");
if (crc32("xYlLKz",6) == 3365777734) strcat(s, "T");
if (crc32("pnmGSjCa",8) == 828064302) strcat(s, "e");
if (crc32("pAhyuSaDRsa",11) == 1563145063) strcat(s, "T");
if (crc32("ytgNfsEjtnNlu",13) == 448258463) strcat(s, "r");
if (crc32("CrMjujUi",8) == 1129031206) strcat(s, "V");
if (crc32("pUHWMAFEErkR",12) == 739073066) strcat(s, "t");
if (crc32("oZpAed",6) == 1270637902) strcat(s, "A");
if (crc32("lpUrdDOYP",9) == 3290037927) strcat(s, "i");
if (crc32("NJnMOBWOjaOXi",13) == 3834701879) strcat(s, "a");
if (crc32("ksYYPhtyhMzYaQo",15) == 1866774559) strcat(s, "r");
if (crc32("AYuqW",5) == 2748923824) strcat(s, "V");
if (crc32("JUsbsWyRWbBKg",13) == 2559464111) strcat(s, "y");
    return s;
}

char *robust_adjectives() {
    char *s = calloc(7);
    if (crc32("oIaXNdqwHZaGg",13) == 4027855230) strcat(s, "o");
if (crc32("FkONMRX",7) == 3969087665) strcat(s, "r");
if (crc32("EiyuQq",6) == 1811833013) strcat(s, "h");
if (crc32("lUQNfcuN",8) == 610970997) strcat(s, "o");
if (crc32("yvslqHzQQXUGRkN",15) == 988552163) strcat(s, "b");
if (crc32("mFRISLW",7) == 3455763585) strcat(s, "u");
if (crc32("FGaeslRLyHAM",12) == 2161143853) strcat(s, "V");
if (crc32("DtCyi",5) == 927143557) strcat(s, "s");
if (crc32("OYouW",5) == 1313389908) strcat(s, "t");
    return s;
}

char *halfprofessed_adjectives() {
    char *s = calloc(14);
    if (crc32("lbziE",5) == 3760249518) strcat(s, "h");
if (crc32("KAvIWOnOws",10) == 1772840047) strcat(s, "j");
if (crc32("iyZxhMdtHlO",11) == 5877610) strcat(s, "a");
if (crc32("uaIQwPu",7) == 229378240) strcat(s, "l");
if (crc32("DqCMNyktk",9) == 3231639562) strcat(s, "O");
if (crc32("CZulYdcJKZtrSX",14) == 2469562757) strcat(s, "f");
if (crc32("atpTKOIpSfQ",11) == 2493048533) strcat(s, "k");
if (crc32("WeCLaynf",8) == 1888864899) strcat(s, "p");
if (crc32("tjQdEsbD",8) == 362392541) strcat(s, "r");
if (crc32("OtoePltvnXW",11) == 3124185230) strcat(s, "M");
if (crc32("xAPyJtln",8) == 3300176361) strcat(s, "o");
if (crc32("EqFBjfNqSdcnfA",14) == 3131364852) strcat(s, "v");
if (crc32("CDtvFGtRyAYuo",13) == 1695110872) strcat(s, "f");
if (crc32("ZYTIhUFcf",9) == 2136371148) strcat(s, "e");
if (crc32("VSHohVcwPk",10) == 3504042622) strcat(s, "s");
if (crc32("WyppsMUtnZmY",12) == 72415770) strcat(s, "g");
if (crc32("nixWExRik",9) == 1291820705) strcat(s, "s");
if (crc32("cRLMTuqho",9) == 1505301002) strcat(s, "y");
if (crc32("bMapeT",6) == 4151992627) strcat(s, "e");
if (crc32("EWfrCtXCxnhpk",13) == 1524355421) strcat(s, "d");
    return s;
}

char *instructorial_adjectives() {
    char *s = calloc(14);
    if (crc32("hDYmQFFQahHGrC",14) == 198448751) strcat(s, "i");
if (crc32("yqZPP",5) == 1368921500) strcat(s, "n");
if (crc32("VSksDPxfacuPACT",15) == 2279275304) strcat(s, "s");
if (crc32("AytKRGwsILVqOLR",15) == 1581864907) strcat(s, "t");
if (crc32("oDIMQ",5) == 4022746766) strcat(s, "r");
if (crc32("WwqSuZBjh",9) == 2679611985) strcat(s, "y");
if (crc32("DTDZWCuHy",9) == 3919283012) strcat(s, "u");
if (crc32("SMGYiMGTtgw",11) == 2867297823) strcat(s, "E");
if (crc32("IeSUUxn",7) == 2956814412) strcat(s, "c");
if (crc32("SMCXFOcgqPZNo",13) == 3748176606) strcat(s, "t");
if (crc32("GHvFx",5) == 3671066361) strcat(s, "o");
if (crc32("NaFsL",5) == 1008374765) strcat(s, "I");
if (crc32("mkHBLuxVOto",11) == 3307897618) strcat(s, "r");
if (crc32("VmIxmKSepkA",11) == 4253538472) strcat(s, "i");
if (crc32("saBMjX",6) == 1995151668) strcat(s, "a");
if (crc32("KUMjdrxYHz",10) == 1974102543) strcat(s, "a");
if (crc32("fGCqIBoanPke",12) == 1706999553) strcat(s, "l");
    return s;
}

char *easy_adjectives() {
    char *s = calloc(5);
    if (crc32("CXXTRVwCbSb",11) == 1136647993) strcat(s, "e");
if (crc32("FmYruoFPICzCy",13) == 3131922972) strcat(s, "a");
if (crc32("mVDGnzUqSS",10) == 1475906817) strcat(s, "O");
if (crc32("duJdhLxctKBmFFe",15) == 3749621301) strcat(s, "s");
if (crc32("uHBPhOkbOBDQRU",14) == 2551568833) strcat(s, "y");
    return s;
}

char *uncasketed_adjectives() {
    char *s = calloc(11);
    if (crc32("ahJHEOYAnL",10) == 2858274843) strcat(s, "H");
if (crc32("PhvhPTyKfad",11) == 666935292) strcat(s, "u");
if (crc32("ClAkXjJJRaghDG",14) == 3795707694) strcat(s, "n");
if (crc32("YuFZAvmh",8) == 3663143209) strcat(s, "c");
if (crc32("pzgXIixfUmx",11) == 1198305218) strcat(s, "B");
if (crc32("IkqVbKfBnkDw",12) == 1350182764) strcat(s, "a");
if (crc32("zsEBsnIEg",9) == 4033515286) strcat(s, "X");
if (crc32("lWTYyt",6) == 3394275081) strcat(s, "s");
if (crc32("ASGTfQmn",8) == 334422854) strcat(s, "Y");
if (crc32("VRHWzSxDaKajZQO",15) == 650459298) strcat(s, "k");
if (crc32("ZBJMKyCb",8) == 321745300) strcat(s, "e");
if (crc32("rzSeeNo",7) == 272405377) strcat(s, "D");
if (crc32("hZSRM",5) == 634041925) strcat(s, "t");
if (crc32("xarKu",5) == 1633145085) strcat(s, "Z");
if (crc32("EHwJKsSmb",9) == 1153740620) strcat(s, "e");
if (crc32("WiasrS",6) == 2152100594) strcat(s, "c");
if (crc32("AUiWGqHxX",9) == 4161567441) strcat(s, "d");
    return s;
}

char *nonirrigated_adjectives() {
    char *s = calloc(13);
    if (crc32("JqgYDYqi",8) == 1314253150) strcat(s, "B");
if (crc32("PGkhtDj",7) == 3592312678) strcat(s, "n");
if (crc32("klKfcEN",7) == 209611625) strcat(s, "o");
if (crc32("DptZkBhV",8) == 1619543576) strcat(s, "n");
if (crc32("PMEFgxBYH",9) == 201876596) strcat(s, "n");
if (crc32("bkLsqVgdsJhxBX",14) == 653632497) strcat(s, "i");
if (crc32("WZpfxzdgEwMiIK",14) == 1552580436) strcat(s, "r");
if (crc32("YIVAAMpOpnY",11) == 948145242) strcat(s, "r");
if (crc32("ZnxnJlfZD",9) == 929108543) strcat(s, "i");
if (crc32("qQSureaSlDnF",12) == 277359193) strcat(s, "M");
if (crc32("msGDIc",6) == 1066051086) strcat(s, "g");
if (crc32("auZbrBfD",8) == 2045441901) strcat(s, "a");
if (crc32("UYmPQRg",7) == 1535800229) strcat(s, "t");
if (crc32("fNqHjaYqaB",10) == 872555536) strcat(s, "e");
if (crc32("XYrWEAyrJIUKf",13) == 1744167086) strcat(s, "d");
    return s;
}

char *epidural_adjectives() {
    char *s = calloc(9);
    if (crc32("sDqBZyMkedjOA",13) == 1538055881) strcat(s, "e");
if (crc32("CcNiphq",7) == 3713642610) strcat(s, "t");
if (crc32("nOCzSlBbZWr",11) == 685152810) strcat(s, "p");
if (crc32("TyBriRWjx",9) == 1814365348) strcat(s, "Y");
if (crc32("FLkQCcyNIjk",11) == 3639958365) strcat(s, "i");
if (crc32("enBNTZYR",8) == 417328445) strcat(s, "L");
if (crc32("qGuCxsuG",8) == 2181348481) strcat(s, "d");
if (crc32("pInlFtlWbdsBTNH",15) == 3491363048) strcat(s, "H");
if (crc32("SqepCnT",7) == 2422622924) strcat(s, "u");
if (crc32("qALdlIJ",7) == 3427755698) strcat(s, "r");
if (crc32("vkXuxsoXJt",10) == 3234345217) strcat(s, "D");
if (crc32("mjJjMymAhpoyqi",14) == 261345760) strcat(s, "a");
if (crc32("MgfUACDOm",9) == 813209349) strcat(s, "p");
if (crc32("tdKIZ",5) == 2835283905) strcat(s, "l");
    return s;
}

char *undistant_adjectives() {
    char *s = calloc(10);
    if (crc32("raMlVQ",6) == 4038029738) strcat(s, "T");
if (crc32("UBBVdUzHOktx",12) == 3206600724) strcat(s, "u");
if (crc32("IicygOrCTwlXAuH",15) == 1833801945) strcat(s, "R");
if (crc32("twpKwS",6) == 4017094505) strcat(s, "n");
if (crc32("zgjHtMfqqqjmXGP",15) == 2577441921) strcat(s, "a");
if (crc32("NcoUfcU",7) == 4177697071) strcat(s, "d");
if (crc32("QoBLQDTmflzZ",12) == 2462266006) strcat(s, "n");
if (crc32("OjuCWuqa",8) == 4136904369) strcat(s, "i");
if (crc32("oFArcE",6) == 2741551064) strcat(s, "s");
if (crc32("GEtuKUerYKUd",12) == 1146066289) strcat(s, "t");
if (crc32("uuJhcfjchpKSU",13) == 1565472765) strcat(s, "m");
if (crc32("JrzkbLSvrgcBgJu",15) == 3816493537) strcat(s, "a");
if (crc32("mbxnWYd",7) == 3416209138) strcat(s, "a");
if (crc32("QdgzyngWwkRx",12) == 4192045298) strcat(s, "n");
if (crc32("xdhAYKkmJXsUlq",14) == 450149541) strcat(s, "r");
if (crc32("oTBQUBOTDJDdzjY",15) == 358548939) strcat(s, "t");
    return s;
}

char *indusial_adjectives() {
    char *s = calloc(9);
    if (crc32("NifrnERjElZ",11) == 2780051133) strcat(s, "i");
if (crc32("DEQSr",5) == 2239298459) strcat(s, "n");
if (crc32("iovHFLkHLCOP",12) == 1247955100) strcat(s, "d");
if (crc32("kZzjxooXEYjWk",13) == 2031468596) strcat(s, "u");
if (crc32("AtUFNGeJwMhRst",14) == 3716695820) strcat(s, "W");
if (crc32("WwYDthdlw",9) == 3457973933) strcat(s, "s");
if (crc32("xPxjaZ",6) == 1915995469) strcat(s, "i");
if (crc32("VFQlZKgxzVKHyY",14) == 3474330329) strcat(s, "A");
if (crc32("fgaCLd",6) == 2737365006) strcat(s, "a");
if (crc32("CFLMhupBLhLKpE",14) == 2334311178) strcat(s, "l");
    return s;
}

char *unsubjugated_adjectives() {
    char *s = calloc(13);
    if (crc32("gKhXPGAPjSsp",12) == 2935780002) strcat(s, "A");
if (crc32("iJRFKo",6) == 1474913157) strcat(s, "u");
if (crc32("RZeGzNvBsREux",13) == 3691569460) strcat(s, "n");
if (crc32("NnPbBLwTBau",11) == 1650669700) strcat(s, "y");
if (crc32("ejLiLwGNoIG",11) == 4125061613) strcat(s, "s");
if (crc32("AvplVLkCEBjP",12) == 2505967717) strcat(s, "e");
if (crc32("dfjcvS",6) == 2715341346) strcat(s, "u");
if (crc32("rFIGQi",6) == 614242715) strcat(s, "b");
if (crc32("nLewqnKjHbyxQk",14) == 903151809) strcat(s, "j");
if (crc32("XQIwDng",7) == 3065288239) strcat(s, "u");
if (crc32("hAXvBxoOduU",11) == 4168029842) strcat(s, "q");
if (crc32("nymSluvr",8) == 4140727783) strcat(s, "g");
if (crc32("BXZwpjyOyiSkLA",14) == 1914459532) strcat(s, "a");
if (crc32("sURhrjJAMcRMC",13) == 3116097730) strcat(s, "a");
if (crc32("oxGbUvHSCe",10) == 657436996) strcat(s, "P");
if (crc32("ONdVgfbXRt",10) == 2703878526) strcat(s, "t");
if (crc32("cwRyrJEQU",9) == 73275490) strcat(s, "e");
if (crc32("sWwBVXu",7) == 990468458) strcat(s, "O");
if (crc32("fqWcbAe",7) == 2302527278) strcat(s, "d");
    return s;
}

char *viniferous_adjectives() {
    char *s = calloc(11);
    if (crc32("vGBjaZcAZrxIMoo",15) == 1175227918) strcat(s, "B");
if (crc32("zcDDPmUcMwiBdjF",15) == 3957072038) strcat(s, "v");
if (crc32("VCJiStLLmIF",11) == 979209867) strcat(s, "i");
if (crc32("ZfhYtto",7) == 414514070) strcat(s, "L");
if (crc32("fyAhqM",6) == 3230146304) strcat(s, "n");
if (crc32("wAVRr",5) == 2326186072) strcat(s, "l");
if (crc32("rWzBPyr",7) == 1495642868) strcat(s, "i");
if (crc32("ADYnNfsski",10) == 1041683116) strcat(s, "f");
if (crc32("VIdMUuiRrQ",10) == 298737511) strcat(s, "e");
if (crc32("GhDdXIhrJONb",12) == 1667030331) strcat(s, "j");
if (crc32("hiUkPNljFwciy",13) == 2474726670) strcat(s, "r");
if (crc32("qAeqdRZmEyJChkl",15) == 1434439900) strcat(s, "F");
if (crc32("tFxcN",5) == 4049198056) strcat(s, "o");
if (crc32("XKCHgjOimEphPA",14) == 316411745) strcat(s, "u");
if (crc32("cEnWKTMim",9) == 3165276292) strcat(s, "s");
    return s;
}

char *multivalent_adjectives() {
    char *s = calloc(12);
    if (crc32("sHdAjTA",7) == 1991365820) strcat(s, "m");
if (crc32("ykUTNlzpDsQ",11) == 3262015972) strcat(s, "S");
if (crc32("YKVWN",5) == 3013308573) strcat(s, "u");
if (crc32("QDLIWz",6) == 634505346) strcat(s, "i");
if (crc32("EXuRmzDIo",9) == 3856446072) strcat(s, "l");
if (crc32("yOeTu",5) == 1093872096) strcat(s, "t");
if (crc32("RuwbdEpSbIqXnN",14) == 3521280060) strcat(s, "i");
if (crc32("TAsrgDkiyyu",11) == 40225342) strcat(s, "v");
if (crc32("RIOuPatgVPd",11) == 1215555820) strcat(s, "l");
if (crc32("WAJpazzbvx",10) == 1027518548) strcat(s, "a");
if (crc32("cfgHC",5) == 2156368173) strcat(s, "y");
if (crc32("SeBmLI",6) == 1221857855) strcat(s, "l");
if (crc32("NmVTyjAysfoJEPW",15) == 2151974761) strcat(s, "q");
if (crc32("CxmBYn",6) == 2324541021) strcat(s, "e");
if (crc32("LnRUjnMDfVJizn",14) == 3326120155) strcat(s, "F");
if (crc32("KKueqf",6) == 2071390187) strcat(s, "n");
if (crc32("BvNWmzAbx",9) == 1307582899) strcat(s, "W");
if (crc32("rrKdSDTfBvZu",12) == 2581972915) strcat(s, "t");
    return s;
}

char *teetotal_adjectives() {
    char *s = calloc(9);
    if (crc32("nWZoKzRXvkDCX",13) == 988646991) strcat(s, "S");
if (crc32("isRMwYmAjag",11) == 426263251) strcat(s, "t");
if (crc32("qvNhpbhJrjDgA",13) == 3356317145) strcat(s, "s");
if (crc32("CjyZZ",5) == 488676360) strcat(s, "e");
if (crc32("fyzhJZQVadEt",12) == 386439141) strcat(s, "X");
if (crc32("xIylskUiHrBK",12) == 218542474) strcat(s, "e");
if (crc32("ZQaQuaG",7) == 1894379523) strcat(s, "o");
if (crc32("zjiId",5) == 230275510) strcat(s, "t");
if (crc32("LPoNvtVsag",10) == 616974612) strcat(s, "a");
if (crc32("BOTpaHkabzIwUQI",15) == 1123438563) strcat(s, "o");
if (crc32("pKhIGWx",7) == 2234808089) strcat(s, "t");
if (crc32("lYHlfT",6) == 3141261410) strcat(s, "a");
if (crc32("GjkZZ",5) == 3787530428) strcat(s, "Y");
if (crc32("OkvWZZcyU",9) == 2381222874) strcat(s, "l");
    return s;
}

char *Carolinian_adjectives() {
    char *s = calloc(11);
    if (crc32("IgmBAFDQtj",10) == 460506427) strcat(s, "a");
if (crc32("jMEKEUoY",8) == 1191993160) strcat(s, "C");
if (crc32("vKPBxIwiQB",10) == 724274751) strcat(s, "u");
if (crc32("LIvYITKShF",10) == 1023374855) strcat(s, "a");
if (crc32("lsdCDLwUn",9) == 3363660494) strcat(s, "r");
if (crc32("XHLXkPsjwYVEvF",14) == 3740706512) strcat(s, "o");
if (crc32("JzfgVZTSkr",10) == 3991534563) strcat(s, "l");
if (crc32("SzyxFnyHLy",10) == 1147601715) strcat(s, "A");
if (crc32("GpICOeaZ",8) == 3877969447) strcat(s, "i");
if (crc32("QwMfVTA",7) == 133861239) strcat(s, "n");
if (crc32("SbNar",5) == 2421659570) strcat(s, "i");
if (crc32("FndQIfmfRKd",11) == 1156348908) strcat(s, "a");
if (crc32("ItScPLUiOe",10) == 771489797) strcat(s, "n");
    return s;
}

char *proBrazilian_adjectives() {
    char *s = calloc(13);
    if (crc32("HXhhIStgsJ",10) == 1879110570) strcat(s, "p");
if (crc32("VtKLpJzxoxoms",13) == 4161970567) strcat(s, "r");
if (crc32("mwhFF",5) == 774916730) strcat(s, "o");
if (crc32("OOwAjRimxy",10) == 1969619507) strcat(s, "Y");
if (crc32("cuJdqPEd",8) == 1065977970) strcat(s, "B");
if (crc32("TZyoOfUNbyjn",12) == 461781460) strcat(s, "Z");
if (crc32("kkUFKn",6) == 206621717) strcat(s, "r");
if (crc32("HNjoHQPDtEdL",12) == 3192650137) strcat(s, "a");
if (crc32("mdzwnRuYzE",10) == 2183644581) strcat(s, "M");
if (crc32("XxAjSNMrhOmliA",14) == 3000908699) strcat(s, "z");
if (crc32("ismYVvcqGZfgti",14) == 1007662151) strcat(s, "q");
if (crc32("DAGRIfgHLztwWZ",14) == 1843346815) strcat(s, "i");
if (crc32("ZWqrx",5) == 1005555016) strcat(s, "i");
if (crc32("mDkMWkss",8) == 2208186721) strcat(s, "l");
if (crc32("ivYoRfMxiw",10) == 1688243994) strcat(s, "i");
if (crc32("koyCgb",6) == 628662077) strcat(s, "a");
if (crc32("zafAkX",6) == 1392803336) strcat(s, "U");
if (crc32("WvoSHiAzNGQBnD",14) == 3080049582) strcat(s, "n");
    return s;
}

char *nonconductible_adjectives() {
    char *s = calloc(15);
    if (crc32("RXHdzWZExcpQhNZ",15) == 2416192816) strcat(s, "n");
if (crc32("VqCofpQy",8) == 2364194304) strcat(s, "c");
if (crc32("GfSCxyRjHt",10) == 1189143461) strcat(s, "o");
if (crc32("zbgPbm",6) == 1443651299) strcat(s, "n");
if (crc32("DYhaZYe",7) == 469476205) strcat(s, "c");
if (crc32("RDLzzUMvkgcqqto",15) == 352156562) strcat(s, "o");
if (crc32("MDpbpJ",6) == 908929074) strcat(s, "n");
if (crc32("TYLwa",5) == 2667517029) strcat(s, "d");
if (crc32("vzHpMqK",7) == 3433555214) strcat(s, "B");
if (crc32("kOCjjcWmdMzRf",13) == 2551300134) strcat(s, "u");
if (crc32("ilBFqoCl",8) == 2095791799) strcat(s, "c");
if (crc32("UXcmFgezgCk",11) == 3447435498) strcat(s, "t");
if (crc32("SklLabm",7) == 1304370131) strcat(s, "i");
if (crc32("cksZfrB",7) == 1669624272) strcat(s, "H");
if (crc32("PoqbZjDhJPV",11) == 2119588166) strcat(s, "b");
if (crc32("vjFKEESWgA",10) == 751051907) strcat(s, "l");
if (crc32("CvMCZzcFwoQldIc",15) == 1290977927) strcat(s, "e");
    return s;
}

char *unmossy_adjectives() {
    char *s = calloc(8);
    if (crc32("MfcqE",5) == 34556907) strcat(s, "u");
if (crc32("ymEDSeysDAMK",12) == 4078233702) strcat(s, "n");
if (crc32("fIYIUSnjV",9) == 885816913) strcat(s, "F");
if (crc32("TGoSIBZoHT",10) == 1267270145) strcat(s, "m");
if (crc32("uFmJIbLfRgPhBDi",15) == 714230070) strcat(s, "o");
if (crc32("EvUVPdlRQ",9) == 3383882772) strcat(s, "W");
if (crc32("nhIKAiXsVX",10) == 985176553) strcat(s, "s");
if (crc32("sSolnCjwJPv",11) == 3052098549) strcat(s, "c");
if (crc32("fPPIuigJABCBCYx",15) == 3747433271) strcat(s, "s");
if (crc32("OPrLIIcjirbwjeM",15) == 712781924) strcat(s, "m");
if (crc32("GVpyhXAcNnVXkFY",15) == 3801639341) strcat(s, "y");
    return s;
}

char *zoophobous_adjectives() {
    char *s = calloc(11);
    if (crc32("pNzzoEkwoYr",11) == 3780318117) strcat(s, "z");
if (crc32("aAMAMYUGOn",10) == 3390233536) strcat(s, "h");
if (crc32("VkcYCgjDMp",10) == 4120587180) strcat(s, "o");
if (crc32("fqUvjRyG",8) == 1049549524) strcat(s, "o");
if (crc32("uLrxPYiNBuOY",12) == 929989433) strcat(s, "n");
if (crc32("LxBtSaPoE",9) == 2524679333) strcat(s, "p");
if (crc32("saumBtFr",8) == 716999020) strcat(s, "h");
if (crc32("avhLK",5) == 3609351209) strcat(s, "o");
if (crc32("LqsKXgoOrpXJiL",14) == 1438143720) strcat(s, "b");
if (crc32("vwriNe",6) == 2190360835) strcat(s, "o");
if (crc32("PgguvUGXKfcYyE",14) == 1730661016) strcat(s, "o");
if (crc32("GnQHbqheRf",10) == 4168723565) strcat(s, "u");
if (crc32("UqWoQvgrfBktzhp",15) == 3890415700) strcat(s, "J");
if (crc32("OZlWuPGFlSn",11) == 4187407972) strcat(s, "s");
    return s;
}

char *transCarpathian_adjectives() {
    char *s = calloc(16);
    if (crc32("wSnDwDu",7) == 3909696675) strcat(s, "t");
if (crc32("znxzwv",6) == 327948517) strcat(s, "r");
if (crc32("NppzZMuusIRY",12) == 3632094048) strcat(s, "a");
if (crc32("TkZhr",5) == 2509419725) strcat(s, "n");
if (crc32("NfIli",5) == 3183604466) strcat(s, "s");
if (crc32("kSJKDZ",6) == 2549345169) strcat(s, "x");
if (crc32("BWlHx",5) == 2507720040) strcat(s, "C");
if (crc32("JpSMw",5) == 2634335030) strcat(s, "G");
if (crc32("WHovAxGZcRaUAc",14) == 3202060815) strcat(s, "a");
if (crc32("jogJpWXSzksD",12) == 591301630) strcat(s, "c");
if (crc32("ExVMNGXsAcmdnN",14) == 2903584102) strcat(s, "r");
if (crc32("MASIu",5) == 2873635810) strcat(s, "m");
if (crc32("HxsDXgAsqpZ",11) == 1846254319) strcat(s, "p");
if (crc32("OxMfWyaUDiSYiM",14) == 1556411440) strcat(s, "a");
if (crc32("EmZDXdakzKvAgQN",15) == 1188087970) strcat(s, "x");
if (crc32("NjyWfdkN",8) == 2517845527) strcat(s, "t");
if (crc32("eLjrptKVARophwh",15) == 860313775) strcat(s, "X");
if (crc32("yLtGdbvqWwZf",12) == 3918877021) strcat(s, "h");
if (crc32("FARjzoqNJoATDyg",15) == 3454305171) strcat(s, "i");
if (crc32("cNxTJYNyYbWNr",13) == 3051612861) strcat(s, "a");
if (crc32("qcDtQ",5) == 2435194714) strcat(s, "c");
if (crc32("YVdfOqQBMNR",11) == 519781423) strcat(s, "n");
    return s;
}

char *interstrial_adjectives() {
    char *s = calloc(12);
    if (crc32("urYdT",5) == 953999044) strcat(s, "i");
if (crc32("dgXijyGLjgiewd",14) == 4137834687) strcat(s, "K");
if (crc32("zWlOMxERp",9) == 3461229656) strcat(s, "n");
if (crc32("wxvMJG",6) == 3128927675) strcat(s, "t");
if (crc32("QUAtlscFlMrwvs",14) == 681940895) strcat(s, "D");
if (crc32("pPcuGkMuXWAwNUa",15) == 4059755707) strcat(s, "e");
if (crc32("unKtQHW",7) == 2326852029) strcat(s, "s");
if (crc32("hmssYwqEvrSBA",13) == 3773019850) strcat(s, "r");
if (crc32("JATFnI",6) == 2186700983) strcat(s, "a");
if (crc32("VDKUHxaPrA",10) == 146350962) strcat(s, "s");
if (crc32("DTbDDyMa",8) == 987655723) strcat(s, "q");
if (crc32("tXHivxLj",8) == 3476435977) strcat(s, "t");
if (crc32("zEHxdquDp",9) == 1534550572) strcat(s, "r");
if (crc32("QSnhO",5) == 980256232) strcat(s, "A");
if (crc32("PfiifXyxInvXHd",14) == 4026448095) strcat(s, "i");
if (crc32("KXlSLgQCiJ",10) == 178603571) strcat(s, "R");
if (crc32("NPAzzfkJX",9) == 1798399406) strcat(s, "a");
if (crc32("eIzwKEfHJJUEhOP",15) == 3247737805) strcat(s, "x");
if (crc32("pAlLJqNjUaQn",12) == 333114078) strcat(s, "l");
    return s;
}

char *unrestful_adjectives() {
    char *s = calloc(10);
    if (crc32("rLYoOqrtPeYyg",13) == 865268204) strcat(s, "u");
if (crc32("cZsUiRIwCvx",11) == 1902855126) strcat(s, "n");
if (crc32("aGfyxUcwoIP",11) == 3090689357) strcat(s, "r");
if (crc32("kJKLlbkm",8) == 3817838162) strcat(s, "t");
if (crc32("iuPgxA",6) == 3483615345) strcat(s, "e");
if (crc32("ALpxgBlTIlKE",12) == 199922095) strcat(s, "Q");
if (crc32("bFpVZQsFBZRrcDB",15) == 3163287727) strcat(s, "s");
if (crc32("AmwipBMAJOGPLG",14) == 803648150) strcat(s, "Y");
if (crc32("NUpyWvSyhQ",10) == 3663003978) strcat(s, "t");
if (crc32("xlohTZUSQnk",11) == 2077077347) strcat(s, "f");
if (crc32("ZkqBRFhHSaLzEjp",15) == 3439110999) strcat(s, "n");
if (crc32("IOBnKUy",7) == 3655458524) strcat(s, "u");
if (crc32("ApfOzeXnXPJmsTP",15) == 3492702373) strcat(s, "k");
if (crc32("VEYfP",5) == 3860524435) strcat(s, "l");
    return s;
}

char *malarian_adjectives() {
    char *s = calloc(9);
    if (crc32("uVCJLDWDcFYGQNz",15) == 4110304604) strcat(s, "m");
if (crc32("pSacrhMqEGLLGhA",15) == 3163580909) strcat(s, "a");
if (crc32("QqXdpvmENtueL",13) == 1742404031) strcat(s, "l");
if (crc32("tCcpsMdPxnxo",12) == 1606780248) strcat(s, "r");
if (crc32("YpOxbuqKJFsL",12) == 954878002) strcat(s, "a");
if (crc32("hJfymmHGZHRf",12) == 2204213728) strcat(s, "F");
if (crc32("uibYSWmqJjFQOS",14) == 2678672490) strcat(s, "r");
if (crc32("VvzFHpUiLUYN",12) == 2266769868) strcat(s, "c");
if (crc32("zXfunLu",7) == 1104178002) strcat(s, "i");
if (crc32("YxDbSJMTVU",10) == 830232182) strcat(s, "a");
if (crc32("hhWhC",5) == 2602934798) strcat(s, "k");
if (crc32("bheVZISrZ",9) == 4164517248) strcat(s, "n");
    return s;
}

char *fragmentary_adjectives() {
    char *s = calloc(12);
    if (crc32("wuxbyekssFvRfzo",15) == 3263084512) strcat(s, "l");
if (crc32("wGrlNYKUAcg",11) == 2582797913) strcat(s, "f");
if (crc32("tPbQiCi",7) == 2981780174) strcat(s, "r");
if (crc32("JppEkp",6) == 447337692) strcat(s, "g");
if (crc32("HzejkWzMd",9) == 543457119) strcat(s, "a");
if (crc32("EgNgLyUMJxN",11) == 240746079) strcat(s, "g");
if (crc32("NEOdXRcLTY",10) == 1187375842) strcat(s, "m");
if (crc32("wzqQHsadu",9) == 3144983002) strcat(s, "e");
if (crc32("mnbjGhRTUVpLB",13) == 1567082347) strcat(s, "n");
if (crc32("ugygwQ",6) == 3867290220) strcat(s, "t");
if (crc32("XNxxkUZWUcY",11) == 2448647867) strcat(s, "n");
if (crc32("pMqnxXdzWldU",12) == 2372284851) strcat(s, "a");
if (crc32("USxmO",5) == 2798511136) strcat(s, "A");
if (crc32("kKAxSINZKpNrc",13) == 1717694618) strcat(s, "r");
if (crc32("tuWsdvDX",8) == 1225538222) strcat(s, "y");
    return s;
}

char *crackbrained_adjectives() {
    char *s = calloc(13);
    if (crc32("WOGeAOaeiSZEOSk",15) == 1952511657) strcat(s, "c");
if (crc32("pqYnIfYDXvTg",12) == 200549942) strcat(s, "a");
if (crc32("QPNOcLmXW",9) == 4094600608) strcat(s, "r");
if (crc32("WZrPdXsGunsNX",13) == 11915734) strcat(s, "O");
if (crc32("FoCntZPbHwkkls",14) == 1440069349) strcat(s, "a");
if (crc32("QuYoj",5) == 3017780185) strcat(s, "c");
if (crc32("vdyMUMmorP",10) == 2400468988) strcat(s, "k");
if (crc32("SmRwUdoa",8) == 897788288) strcat(s, "b");
if (crc32("EVDemnELw",9) == 809272376) strcat(s, "k");
if (crc32("lPXGI",5) == 2205826317) strcat(s, "r");
if (crc32("cYStxaG",7) == 1507976660) strcat(s, "a");
if (crc32("IkauuBhQzhnti",13) == 857025695) strcat(s, "i");
if (crc32("yQHnvalrPVtDTJ",14) == 1499636573) strcat(s, "n");
if (crc32("GawNyMKfDVYbYJD",15) == 4222864614) strcat(s, "e");
if (crc32("nRAhWkJMbf",10) == 2230560840) strcat(s, "i");
if (crc32("TloXzTmJffutRs",14) == 15329874) strcat(s, "d");
    return s;
}

char *quasihappy_adjectives() {
    char *s = calloc(11);
    if (crc32("YXzQQ",5) == 456301851) strcat(s, "q");
if (crc32("UVvAPmZpeqIp",12) == 3192752916) strcat(s, "u");
if (crc32("uyqfhleHfYfeb",13) == 4286078142) strcat(s, "a");
if (crc32("dskOF",5) == 2143730252) strcat(s, "s");
if (crc32("JUFiMiavXsiWh",13) == 2949566310) strcat(s, "i");
if (crc32("XJqiErcULaL",11) == 2473501841) strcat(s, "A");
if (crc32("uEgDSVpKx",9) == 1877968473) strcat(s, "h");
if (crc32("DdNdRiT",7) == 1523317497) strcat(s, "a");
if (crc32("JUYwlAdHW",9) == 3976345146) strcat(s, "p");
if (crc32("CKUmusVefNEj",12) == 3443878845) strcat(s, "p");
if (crc32("zijzMsI",7) == 3415009806) strcat(s, "k");
if (crc32("vpehwOOavVn",11) == 114063532) strcat(s, "y");
    return s;
}

char *alexipharmic_adjectives() {
    char *s = calloc(13);
    if (crc32("nJTMDOVMwLIkc",13) == 3051308453) strcat(s, "a");
if (crc32("PHByxu",6) == 3404733859) strcat(s, "i");
if (crc32("UBXtzlMEjbiO",12) == 1231224508) strcat(s, "l");
if (crc32("icBbjhGEIzJN",12) == 2960555077) strcat(s, "e");
if (crc32("xdUwgvFBtNmc",12) == 1182018349) strcat(s, "x");
if (crc32("LLCCVGmZKIM",11) == 2970433029) strcat(s, "i");
if (crc32("PwvtZCK",7) == 22355781) strcat(s, "x");
if (crc32("oHbIyMNb",8) == 2833338739) strcat(s, "p");
if (crc32("eInIlEmA",8) == 1171808869) strcat(s, "Q");
if (crc32("ISJak",5) == 2448590665) strcat(s, "h");
if (crc32("KgPCACPiU",9) == 1504663052) strcat(s, "Z");
if (crc32("CkWeslIwCwa",11) == 2864224521) strcat(s, "a");
if (crc32("RAUXEBgtxg",10) == 652340208) strcat(s, "r");
if (crc32("ifidfkTdsZWAUYa",15) == 2977278270) strcat(s, "f");
if (crc32("MijzFutanwKOu",13) == 2049053388) strcat(s, "m");
if (crc32("qWcLZrHRWBUcxnD",15) == 2184204503) strcat(s, "a");
if (crc32("ZrLpHIfcdG",10) == 179210018) strcat(s, "i");
if (crc32("RdmgiYLE",8) == 3547947988) strcat(s, "s");
if (crc32("MYAVKhmSESQV",12) == 1110774310) strcat(s, "c");
    return s;
}

char *analytic_adjectives() {
    char *s = calloc(9);
    if (crc32("yPxDPPBwNia",11) == 3193873838) strcat(s, "a");
if (crc32("TZwNwApDVIY",11) == 4266729695) strcat(s, "n");
if (crc32("MLxiravPDtOjj",13) == 3893395310) strcat(s, "a");
if (crc32("vnwlsyfWCkgRnm",14) == 821129409) strcat(s, "E");
if (crc32("IedMXNpfEORjhPP",15) == 3471447663) strcat(s, "l");
if (crc32("FpnZUlEP",8) == 2107529736) strcat(s, "y");
if (crc32("gmoHV",5) == 2255246307) strcat(s, "X");
if (crc32("GmAgtZnERmepkE",14) == 1575457469) strcat(s, "t");
if (crc32("DJJSxFa",7) == 74713045) strcat(s, "o");
if (crc32("ZqKWRrzj",8) == 1253138593) strcat(s, "i");
if (crc32("ljEUrAo",7) == 2010072009) strcat(s, "c");
    return s;
}

char *nonrepayable_adjectives() {
    char *s = calloc(13);
    if (crc32("tuSBGv",6) == 2502043430) strcat(s, "E");
if (crc32("ZzGSlHRvVhqUN",13) == 1019793579) strcat(s, "n");
if (crc32("EgCqYbrO",8) == 990494305) strcat(s, "R");
if (crc32("wlQfJ",5) == 888185681) strcat(s, "o");
if (crc32("ibqsXZYHjnAUO",13) == 1497760013) strcat(s, "x");
if (crc32("ufqArCHgDfdDS",13) == 2698064916) strcat(s, "n");
if (crc32("UctDYLNVtFozROH",15) == 1865257713) strcat(s, "r");
if (crc32("jzLMWeDanfdrMDh",15) == 3182110370) strcat(s, "e");
if (crc32("lWCFSJZ",7) == 2383375188) strcat(s, "p");
if (crc32("JUIYhXgP",8) == 1039799216) strcat(s, "m");
if (crc32("QnyyAEwXbiCEM",13) == 2799518694) strcat(s, "a");
if (crc32("tOuppDi",7) == 1471925660) strcat(s, "s");
if (crc32("neptgHUsr",9) == 866415178) strcat(s, "y");
if (crc32("BLDtduVivfoubH",14) == 287375242) strcat(s, "a");
if (crc32("YKgunlTeGY",10) == 1475501002) strcat(s, "b");
if (crc32("JlFeIUzIldYJLli",15) == 1250837440) strcat(s, "l");
if (crc32("jxIOf",5) == 3606804165) strcat(s, "m");
if (crc32("jwnLo",5) == 549493310) strcat(s, "e");
    return s;
}

char *pulverisable_adjectives() {
    char *s = calloc(13);
    if (crc32("EjZBipcbzhtXRg",14) == 3875273621) strcat(s, "f");
if (crc32("FGBxJYzR",8) == 1195332447) strcat(s, "p");
if (crc32("MDXqhIGeSQccs",13) == 3572856380) strcat(s, "u");
if (crc32("AqdwEK",6) == 2376709192) strcat(s, "J");
if (crc32("XmzSXCJF",8) == 902223485) strcat(s, "l");
if (crc32("iZeGBb",6) == 4098136540) strcat(s, "v");
if (crc32("qDBOcOl",7) == 3683255321) strcat(s, "e");
if (crc32("VhEGJvUwgy",10) == 3002589728) strcat(s, "A");
if (crc32("ypeVtqSnHcuyATC",15) == 3390915299) strcat(s, "r");
if (crc32("hcMGspUoseqUIU",14) == 3219338907) strcat(s, "S");
if (crc32("AYFuTxaqRXMOtz",14) == 3741171974) strcat(s, "i");
if (crc32("wTWsnUlbC",9) == 3566709397) strcat(s, "D");
if (crc32("IyEyzlVmh",9) == 614478793) strcat(s, "s");
if (crc32("znwvErS",7) == 2065082815) strcat(s, "a");
if (crc32("MzsWrZxMvESFID",14) == 1516660387) strcat(s, "b");
if (crc32("htNUD",5) == 3570755653) strcat(s, "f");
if (crc32("YhApLIuzTcJl",12) == 3062602400) strcat(s, "l");
if (crc32("LiJWmmXndGOq",12) == 212606461) strcat(s, "e");
    return s;
}

char *scotomatous_adjectives() {
    char *s = calloc(12);
    if (crc32("jAHwiUj",7) == 1539178967) strcat(s, "W");
if (crc32("fxuXvAtVNbNU",12) == 3413210453) strcat(s, "s");
if (crc32("EcrlynkCU",9) == 2529191704) strcat(s, "t");
if (crc32("sdPKstufQS",10) == 751625735) strcat(s, "c");
if (crc32("GPCGUyROHjZeb",13) == 271355693) strcat(s, "w");
if (crc32("FByTUZ",6) == 2063612794) strcat(s, "o");
if (crc32("xOAxirhQV",9) == 1790585636) strcat(s, "t");
if (crc32("NhtPio",6) == 3422634863) strcat(s, "o");
if (crc32("uftupw",6) == 2875637541) strcat(s, "m");
if (crc32("RejCSl",6) == 2910518803) strcat(s, "L");
if (crc32("xUgaVhR",7) == 4132462648) strcat(s, "a");
if (crc32("VgzORQbbu",9) == 2263668120) strcat(s, "t");
if (crc32("EWEjAkw",7) == 1735183541) strcat(s, "o");
if (crc32("SEHqVhFNNbTVgor",15) == 1977827585) strcat(s, "u");
if (crc32("gXLIFC",6) == 1635804139) strcat(s, "s");
if (crc32("fxydHGRLavh",11) == 3144163293) strcat(s, "s");
    return s;
}

char *unsocializable_adjectives() {
    char *s = calloc(15);
    if (crc32("lrjWpKxPXbms",12) == 1237207497) strcat(s, "u");
if (crc32("AYgoieaJFbJM",12) == 1394035173) strcat(s, "n");
if (crc32("LPvAd",5) == 1455222387) strcat(s, "W");
if (crc32("mnanobFFnjjm",12) == 1291245698) strcat(s, "s");
if (crc32("NXwVQH",6) == 3381469477) strcat(s, "o");
if (crc32("BKqbYETcRauuu",13) == 2127039840) strcat(s, "c");
if (crc32("QGWvv",5) == 136862944) strcat(s, "m");
if (crc32("bKrWwB",6) == 2343893253) strcat(s, "i");
if (crc32("cEwnmfi",7) == 2943017880) strcat(s, "a");
if (crc32("uHQTvrPZpanV",12) == 3865444550) strcat(s, "l");
if (crc32("TbYFfHpOqqI",11) == 439229918) strcat(s, "i");
if (crc32("NrgQHtl",7) == 3872388083) strcat(s, "z");
if (crc32("xmokSYVgta",10) == 1178851045) strcat(s, "a");
if (crc32("HewXsfOS",8) == 3905107812) strcat(s, "b");
if (crc32("EbKhnUGaG",9) == 1481996693) strcat(s, "Q");
if (crc32("WjXniaEYLh",10) == 2012116362) strcat(s, "l");
if (crc32("qTEIsyW",7) == 1797676655) strcat(s, "e");
    return s;
}

char *proFlorentine_adjectives() {
    char *s = calloc(14);
    if (crc32("DeySVcaNqZWhG",13) == 864607451) strcat(s, "s");
if (crc32("PROHTLXOtfhFcyg",15) == 4033247229) strcat(s, "p");
if (crc32("aGwoUtGYQdN",11) == 1538339779) strcat(s, "r");
if (crc32("uzsJylkWZHPOcZu",15) == 3512563580) strcat(s, "T");
if (crc32("mjMsrNAAAiRgZ",13) == 2916218900) strcat(s, "o");
if (crc32("qLVAzawIxJhtFXl",15) == 3914899155) strcat(s, "f");
if (crc32("JSegVpEUWKeqQB",14) == 927182874) strcat(s, "F");
if (crc32("pGPCfFkLJGsiQ",13) == 3482090231) strcat(s, "D");
if (crc32("UoJjs",5) == 2122840910) strcat(s, "l");
if (crc32("lLcwgeeYqdEq",12) == 766391720) strcat(s, "n");
if (crc32("dzVgO",5) == 184325387) strcat(s, "o");
if (crc32("ACciRN",6) == 771761506) strcat(s, "P");
if (crc32("aipcWOhNJnMpBmZ",15) == 1058522311) strcat(s, "r");
if (crc32("KzhzYyGbjLyeXq",14) == 3194252651) strcat(s, "i");
if (crc32("MovKuc",6) == 2903406781) strcat(s, "e");
if (crc32("wxfzw",5) == 1957724608) strcat(s, "n");
if (crc32("LjqjYNtvXWxsOSr",15) == 3177091540) strcat(s, "x");
if (crc32("ndQApzO",7) == 2484722052) strcat(s, "t");
if (crc32("MSDkWF",6) == 1191627159) strcat(s, "i");
if (crc32("ohHuWxiwehqNM",13) == 2301169068) strcat(s, "n");
if (crc32("KsqOZkUTyVfxpOc",15) == 3331144108) strcat(s, "e");
    return s;
}

char *unessayed_adjectives() {
    char *s = calloc(10);
    if (crc32("TFsbeRm",7) == 889177860) strcat(s, "v");
if (crc32("uWhexftBssD",11) == 3757801992) strcat(s, "u");
if (crc32("rjWuWdf",7) == 1635133208) strcat(s, "I");
if (crc32("MorCCJXWBOv",11) == 401653558) strcat(s, "n");
if (crc32("oxraokjRjWPkqt",14) == 1946834461) strcat(s, "e");
if (crc32("pgLRVXYuI",9) == 1920869122) strcat(s, "N");
if (crc32("qRMSLKjdiSdd",12) == 1510651552) strcat(s, "s");
if (crc32("fBMUN",5) == 3483844179) strcat(s, "s");
if (crc32("UdgHlBApVQBvwzf",15) == 3563375008) strcat(s, "a");
if (crc32("RJConKDwgvIWgi",14) == 2678663019) strcat(s, "C");
if (crc32("vwaIThKpgIZfTJg",15) == 1088814988) strcat(s, "y");
if (crc32("ujwDo",5) == 1591945882) strcat(s, "h");
if (crc32("iAEcJfjjBn",10) == 496851415) strcat(s, "e");
if (crc32("WyKdugZJOD",10) == 1079783480) strcat(s, "d");
    return s;
}

char *eudaemonistic_adjectives() {
    char *s = calloc(14);
    if (crc32("SKVdyqHg",8) == 3868257327) strcat(s, "e");
if (crc32("dhqJBhUQiHpcWhh",15) == 201057676) strcat(s, "b");
if (crc32("epvWAUl",7) == 2635657244) strcat(s, "u");
if (crc32("vOhMZDN",7) == 1220309834) strcat(s, "d");
if (crc32("bgqlgTAr",8) == 239962393) strcat(s, "O");
if (crc32("GajxUBg",7) == 3650067150) strcat(s, "a");
if (crc32("mGfPttUpFnk",11) == 2964269473) strcat(s, "e");
if (crc32("QqvVkGSeTFQUl",13) == 3339757573) strcat(s, "K");
if (crc32("YwIfCZweZxkrtn",14) == 1503450706) strcat(s, "m");
if (crc32("AZwHwunhoWjx",12) == 46979957) strcat(s, "D");
if (crc32("AdMedD",6) == 1312164838) strcat(s, "o");
if (crc32("ngJhRGyWGc",10) == 669145994) strcat(s, "S");
if (crc32("deiLoKLzwPC",11) == 3079043975) strcat(s, "n");
if (crc32("VZRuBKzDndFSD",13) == 669596717) strcat(s, "l");
if (crc32("fIzzwTZ",7) == 3999931388) strcat(s, "i");
if (crc32("nCdCDtxbhmct",12) == 1571426601) strcat(s, "S");
if (crc32("KViBHgEVozCK",12) == 728711751) strcat(s, "s");
if (crc32("OffJVYzRlRxn",12) == 483919702) strcat(s, "h");
if (crc32("jRlZzzQ",7) == 2604928315) strcat(s, "t");
if (crc32("kgRnTfcZyJlsn",13) == 3124095103) strcat(s, "x");
if (crc32("wYsFObWTue",10) == 1676272141) strcat(s, "i");
if (crc32("WKQLCp",6) == 2543842833) strcat(s, "r");
if (crc32("AxbeVKfoflO",11) == 1084045808) strcat(s, "c");
    return s;
}

char *headless_adjectives() {
    char *s = calloc(9);
    if (crc32("tDYiLZqAiPDh",12) == 995014076) strcat(s, "i");
if (crc32("XwgbNtp",7) == 1075756038) strcat(s, "h");
if (crc32("mWhNaPGov",9) == 2810250938) strcat(s, "V");
if (crc32("ZjeGYrdvnoySFg",14) == 994059133) strcat(s, "e");
if (crc32("OrcvLBkMNB",10) == 1004216179) strcat(s, "t");
if (crc32("GGIPYX",6) == 3441760754) strcat(s, "a");
if (crc32("IuBnpdFMg",9) == 1046642726) strcat(s, "d");
if (crc32("bgvcYyvOcX",10) == 1492928158) strcat(s, "t");
if (crc32("WxzOprpSlL",10) == 1195227977) strcat(s, "l");
if (crc32("CtoRRZJTO",9) == 282542402) strcat(s, "L");
if (crc32("ttiitSNAA",9) == 366872434) strcat(s, "e");
if (crc32("DJGmZ",5) == 2982184840) strcat(s, "s");
if (crc32("AmxSwTpb",8) == 3815271747) strcat(s, "s");
    return s;
}

char *sporting_adjectives() {
    char *s = calloc(9);
    if (crc32("WuZeCXkGzG",10) == 975940945) strcat(s, "s");
if (crc32("ylVheQJ",7) == 2849942896) strcat(s, "p");
if (crc32("DXyTRqvF",8) == 3952901687) strcat(s, "o");
if (crc32("PsFQPhdu",8) == 2308562116) strcat(s, "W");
if (crc32("VxwVncydT",9) == 1388993128) strcat(s, "r");
if (crc32("nnzyOOQDPuXw",12) == 3380831210) strcat(s, "X");
if (crc32("LesosmnkWH",10) == 3494611871) strcat(s, "t");
if (crc32("RPAHpp",6) == 3935054974) strcat(s, "i");
if (crc32("qVOdtCmdql",10) == 950846538) strcat(s, "X");
if (crc32("AihNCk",6) == 1682355814) strcat(s, "n");
if (crc32("fQIqdxkNgzu",11) == 578642897) strcat(s, "g");
    return s;
}

char *feudalistic_adjectives() {
    char *s = calloc(12);
    if (crc32("DbguL",5) == 2596563889) strcat(s, "f");
if (crc32("ApEqyz",6) == 716555501) strcat(s, "f");
if (crc32("KnbxZfiMXaX",11) == 2202864585) strcat(s, "e");
if (crc32("lQQIfBZyVxntXFq",15) == 3810662348) strcat(s, "u");
if (crc32("ayZoorgALGCg",12) == 3463084921) strcat(s, "d");
if (crc32("rzvInVbfiT",10) == 1341539709) strcat(s, "a");
if (crc32("Ecwnulrd",8) == 3302911250) strcat(s, "l");
if (crc32("eSAwEnbQGN",10) == 1144997974) strcat(s, "k");
if (crc32("QsinHtBGHscqhm",14) == 2920302581) strcat(s, "i");
if (crc32("PGSUUzuMgLxSQJK",15) == 3133064631) strcat(s, "Z");
if (crc32("JefulsmFKfdFR",13) == 1716052487) strcat(s, "s");
if (crc32("xImtssLrQayr",12) == 54867220) strcat(s, "t");
if (crc32("HQyUanX",7) == 4069555428) strcat(s, "i");
if (crc32("sUxoMsnWCODRWL",14) == 2444405945) strcat(s, "c");
    return s;
}

char *annihilationistical_adjectives() {
    char *s = calloc(20);
    if (crc32("qKrGYeoEEoLu",12) == 2776891223) strcat(s, "C");
if (crc32("FtGAXGOEK",9) == 1062563420) strcat(s, "a");
if (crc32("IVyKerAiT",9) == 3984804230) strcat(s, "l");
if (crc32("yuhTUCuNGr",10) == 3820008575) strcat(s, "n");
if (crc32("JlbhfhQmwu",10) == 1634142834) strcat(s, "z");
if (crc32("EPfgZdawSVa",11) == 2114966813) strcat(s, "n");
if (crc32("pnJeKqK",7) == 4137980968) strcat(s, "i");
if (crc32("ujsRFxsjH",9) == 1229648913) strcat(s, "h");
if (crc32("muhDSf",6) == 2296177298) strcat(s, "i");
if (crc32("XSBCrsrgRpqT",12) == 3967062024) strcat(s, "l");
if (crc32("QnOEa",5) == 561742752) strcat(s, "C");
if (crc32("flVUgFm",7) == 2567210168) strcat(s, "a");
if (crc32("UtHMNFIXwT",10) == 2759241428) strcat(s, "t");
if (crc32("IOlCdJvOrRgQCi",14) == 2983852025) strcat(s, "h");
if (crc32("BZZIYVvxztTyKit",15) == 166682794) strcat(s, "i");
if (crc32("vZYiVKSlpqzy",12) == 139383406) strcat(s, "G");
if (crc32("kxEsvui",7) == 745525291) strcat(s, "o");
if (crc32("lAEByPrUtFWdT",13) == 2507153427) strcat(s, "n");
if (crc32("yKpnXSJMnntmwmi",15) == 578493605) strcat(s, "i");
if (crc32("ANXGZYZdaAnd",12) == 1032842442) strcat(s, "v");
if (crc32("WgZeAMN",7) == 3042926038) strcat(s, "s");
if (crc32("PvKmUoGA",8) == 3124386724) strcat(s, "t");
if (crc32("yaPlosPd",8) == 2358955824) strcat(s, "R");
if (crc32("dDtMHgEcAOrwVU",14) == 351076953) strcat(s, "i");
if (crc32("OXGAqQXVxVhqXWr",15) == 1404850674) strcat(s, "c");
if (crc32("YzrigvLAHH",10) == 2953000244) strcat(s, "a");
if (crc32("KdMLEt",6) == 1920430240) strcat(s, "l");
    return s;
}

char *cognizant_adjectives() {
    char *s = calloc(10);
    if (crc32("mHrEqSbJbcC",11) == 4287234287) strcat(s, "c");
if (crc32("yKoucvWd",8) == 2657846460) strcat(s, "o");
if (crc32("BKdWDCunxrVhTRM",15) == 3263402669) strcat(s, "f");
if (crc32("lUZUqI",6) == 3387202599) strcat(s, "g");
if (crc32("WYYYUzWeDvl",11) == 305769671) strcat(s, "I");
if (crc32("oVQJmbjAyB",10) == 2947415074) strcat(s, "n");
if (crc32("kxLYzN",6) == 2865088793) strcat(s, "a");
if (crc32("qjJmBjLS",8) == 1066146109) strcat(s, "i");
if (crc32("PLkswFjzfhxsJ",13) == 865726613) strcat(s, "o");
if (crc32("EjPWY",5) == 2304457520) strcat(s, "z");
if (crc32("OogbvVAgm",9) == 405632440) strcat(s, "Y");
if (crc32("fZTMCVKTKIwG",12) == 1292537875) strcat(s, "a");
if (crc32("twWoDVsRdeAt",12) == 897038704) strcat(s, "n");
if (crc32("wTCrT",5) == 3396136503) strcat(s, "t");
    return s;
}

char *pensionary_adjectives() {
    char *s = calloc(11);
    if (crc32("EJtAgSTL",8) == 2024983873) strcat(s, "p");
if (crc32("rJqcJsWnyqMEgG",14) == 1828621989) strcat(s, "q");
if (crc32("AQxWeVJqwsi",11) == 2639561474) strcat(s, "e");
if (crc32("wqIJyyo",7) == 1194719160) strcat(s, "V");
if (crc32("JtFkaex",7) == 3648102542) strcat(s, "n");
if (crc32("lZkZuuqEFcHTgi",14) == 2002669162) strcat(s, "s");
if (crc32("CpEWShPOWvz",11) == 3916641514) strcat(s, "Y");
if (crc32("GifAjTfugBgLzat",15) == 3968262448) strcat(s, "i");
if (crc32("FFPLkVd",7) == 1759192400) strcat(s, "o");
if (crc32("qBxEYL",6) == 2672187408) strcat(s, "n");
if (crc32("IVYjNPbjYmD",11) == 4099154180) strcat(s, "k");
if (crc32("hxTppGlaaMYx",12) == 1775325333) strcat(s, "a");
if (crc32("SzjLnieCLZnmwk",14) == 1777354639) strcat(s, "s");
if (crc32("wutQqZHiNj",10) == 2289397466) strcat(s, "r");
if (crc32("KLgtFV",6) == 2750230536) strcat(s, "m");
if (crc32("CNAThNhFaTqHSvU",15) == 2540596872) strcat(s, "y");
    return s;
}

char *sylvatic_adjectives() {
    char *s = calloc(9);
    if (crc32("dRCOBRMMBXF",11) == 1464053361) strcat(s, "J");
if (crc32("AQpLzH",6) == 3487372023) strcat(s, "s");
if (crc32("PxRHREglzOAMoOD",15) == 3353502865) strcat(s, "y");
if (crc32("dlAxrLS",7) == 3882756469) strcat(s, "h");
if (crc32("CEHHwZwPz",9) == 1075002432) strcat(s, "l");
if (crc32("Elmpbpmos",9) == 4154477786) strcat(s, "v");
if (crc32("SrxEuMqGFHPvlt",14) == 4248186948) strcat(s, "x");
if (crc32("osadbMu",7) == 1406732545) strcat(s, "a");
if (crc32("kiMsXDjLIqFpSS",14) == 3163703640) strcat(s, "V");
if (crc32("zSwPVFB",7) == 2303820546) strcat(s, "t");
if (crc32("GqdccVpIMzO",11) == 3861036498) strcat(s, "i");
if (crc32("CBUIEXUeosO",11) == 42184150) strcat(s, "T");
if (crc32("obaHy",5) == 335775115) strcat(s, "c");
    return s;
}

char *Voltairean_adjectives() {
    char *s = calloc(11);
    if (crc32("oOGRdHcdSK",10) == 447188480) strcat(s, "N");
if (crc32("uuicfZcJ",8) == 1762950989) strcat(s, "V");
if (crc32("OhIqMjKQG",9) == 1882198416) strcat(s, "F");
if (crc32("gtfRabD",7) == 1540852413) strcat(s, "o");
if (crc32("NmbEFtb",7) == 1771248942) strcat(s, "h");
if (crc32("LxmvolrjScYeiv",14) == 11196271) strcat(s, "l");
if (crc32("PfnuVhbW",8) == 941118708) strcat(s, "E");
if (crc32("rtIQDqhvTIdQ",12) == 2851991425) strcat(s, "t");
if (crc32("mlAhKkJMOrmp",12) == 3868656513) strcat(s, "a");
if (crc32("OVrSMCTbtL",10) == 3869992121) strcat(s, "i");
if (crc32("xzqsBfehq",9) == 2937018099) strcat(s, "r");
if (crc32("JlnJogo",7) == 92051795) strcat(s, "O");
if (crc32("LLFLQZHiakmtk",13) == 3351776568) strcat(s, "e");
if (crc32("eKyIuvYgINxi",12) == 1647004970) strcat(s, "a");
if (crc32("JclzgtZn",8) == 3022165708) strcat(s, "n");
    return s;
}

char *organisational_adjectives() {
    char *s = calloc(15);
    if (crc32("VzcayCNjqyNxPTb",15) == 2664778522) strcat(s, "E");
if (crc32("GWGPPNtzwOvyv",13) == 2729956608) strcat(s, "o");
if (crc32("wbNsIAvve",9) == 453850650) strcat(s, "r");
if (crc32("VndLOykRfFQPy",13) == 790737253) strcat(s, "g");
if (crc32("fkjzCcuBO",9) == 3938145914) strcat(s, "C");
if (crc32("SrpPx",5) == 3358844443) strcat(s, "a");
if (crc32("PePZkIQRkjJJPb",14) == 350501052) strcat(s, "n");
if (crc32("IanVcYJOoVhuR",13) == 3829384926) strcat(s, "v");
if (crc32("IWnaaokrI",9) == 1114033987) strcat(s, "i");
if (crc32("BwvACToHT",9) == 2940685681) strcat(s, "x");
if (crc32("RFBleQxKQsEh",12) == 2347381425) strcat(s, "s");
if (crc32("rmIObfVlOdR",11) == 3427755942) strcat(s, "M");
if (crc32("OOByiomcDmY",11) == 406267868) strcat(s, "a");
if (crc32("KImNCptnwOuHHu",14) == 756796424) strcat(s, "v");
if (crc32("ehLQQoReu",9) == 2254524085) strcat(s, "t");
if (crc32("poQzXwvbR",9) == 1974886113) strcat(s, "A");
if (crc32("fkLeZuU",7) == 2929748207) strcat(s, "i");
if (crc32("sGmWkVlb",8) == 2110825692) strcat(s, "C");
if (crc32("cAaWZ",5) == 206116790) strcat(s, "o");
if (crc32("tJDyBJr",7) == 1464860130) strcat(s, "n");
if (crc32("FuOKtqS",7) == 3763379102) strcat(s, "a");
if (crc32("DgFqBUWm",8) == 3804426469) strcat(s, "U");
if (crc32("LYbAIfYBxBGTUp",14) == 210891907) strcat(s, "l");
    return s;
}

char *unsurmised_adjectives() {
    char *s = calloc(11);
    if (crc32("dwkDAEKLXlK",11) == 2948940901) strcat(s, "m");
if (crc32("RCHMjvuXi",9) == 1350413899) strcat(s, "u");
if (crc32("DbCyGWLZGcrB",12) == 726546252) strcat(s, "v");
if (crc32("sEPdGfqEDYEdep",14) == 350657949) strcat(s, "n");
if (crc32("RQECKNKEOuyuKYN",15) == 4190274263) strcat(s, "k");
if (crc32("PzJzwnsEbT",10) == 3412451057) strcat(s, "s");
if (crc32("VskGGCigHN",10) == 182408834) strcat(s, "Z");
if (crc32("hbffjmDG",8) == 3672327719) strcat(s, "u");
if (crc32("DwpZg",5) == 1523235012) strcat(s, "r");
if (crc32("mjafeUEYYpQKHU",14) == 3523614619) strcat(s, "X");
if (crc32("GIHVO",5) == 3202752088) strcat(s, "m");
if (crc32("OMPftBNvfS",10) == 1179969903) strcat(s, "i");
if (crc32("dPmjaVGPBliXOml",15) == 2685247272) strcat(s, "s");
if (crc32("LVQECIFDkCKe",12) == 2922979993) strcat(s, "e");
if (crc32("YqVJaFIRRYjC",12) == 967651887) strcat(s, "d");
    return s;
}

char *unporcelainized_adjectives() {
    char *s = calloc(16);
    if (crc32("XesgXjQbqv",10) == 3079438456) strcat(s, "u");
if (crc32("fUmRgD",6) == 2771197573) strcat(s, "d");
if (crc32("xEdMVkKdiXHQXi",14) == 2917092037) strcat(s, "n");
if (crc32("CIqoaEYyU",9) == 392413927) strcat(s, "P");
if (crc32("EvrCCbl",7) == 1032075471) strcat(s, "p");
if (crc32("VgSlNZy",7) == 3114176395) strcat(s, "A");
if (crc32("CDMyMOCwPDSQnD",14) == 3249680576) strcat(s, "o");
if (crc32("nPofGbVkIGf",11) == 3190385148) strcat(s, "r");
if (crc32("KYrpTKmW",8) == 1583382751) strcat(s, "m");
if (crc32("UmBeQtTAW",9) == 2289676939) strcat(s, "c");
if (crc32("dWmZapnumQPKq",13) == 2443511077) strcat(s, "e");
if (crc32("xmhWv",5) == 3432314575) strcat(s, "l");
if (crc32("RSVwvxodHyJzwdE",15) == 3843300269) strcat(s, "g");
if (crc32("qKwRrOb",7) == 456321592) strcat(s, "a");
if (crc32("haiWFCTLjwfV",12) == 3684146193) strcat(s, "i");
if (crc32("NEouVHAxtKCsbCC",15) == 747714174) strcat(s, "S");
if (crc32("itCDDffy",8) == 3561778123) strcat(s, "n");
if (crc32("ZGdEEl",6) == 3316482051) strcat(s, "E");
if (crc32("OQsgHCsTzit",11) == 3588566650) strcat(s, "i");
if (crc32("JXFxUnP",7) == 512795087) strcat(s, "z");
if (crc32("udwrDeiUlOlDn",13) == 2994900528) strcat(s, "v");
if (crc32("YfhPc",5) == 3316122966) strcat(s, "e");
if (crc32("rmzvW",5) == 1500552397) strcat(s, "d");
    return s;
}

char *amphiarthrodial_adjectives() {
    char *s = calloc(16);
    if (crc32("BlmulzQRRyA",11) == 2957993443) strcat(s, "r");
if (crc32("GIbKt",5) == 3311097942) strcat(s, "a");
if (crc32("tjDiUCgxeussqw",14) == 1856495592) strcat(s, "E");
if (crc32("KmuPnBaqvCAhFT",14) == 1455903784) strcat(s, "m");
if (crc32("MktOMOAB",8) == 1997767904) strcat(s, "p");
if (crc32("HwaXH",5) == 4057620338) strcat(s, "Q");
if (crc32("jNLJUBkU",8) == 1210144488) strcat(s, "h");
if (crc32("gxyhdSQfGWcMvll",15) == 2431253985) strcat(s, "K");
if (crc32("dUJURgtTY",9) == 1036150858) strcat(s, "i");
if (crc32("XLyOBskxouB",11) == 379272046) strcat(s, "a");
if (crc32("WjtoCbYJGAv",11) == 2363959394) strcat(s, "r");
if (crc32("NDtvp",5) == 1285301902) strcat(s, "X");
if (crc32("FsxoxjvCR",9) == 3691994886) strcat(s, "t");
if (crc32("KYsOktPyFADl",12) == 1260165137) strcat(s, "E");
if (crc32("zXKNvqOEKOPoDP",14) == 1298141369) strcat(s, "h");
if (crc32("YMNhNRkgAFIj",12) == 3121358864) strcat(s, "r");
if (crc32("AOdiGRuVbb",10) == 2712889883) strcat(s, "S");
if (crc32("eJtjSwnt",8) == 2054379055) strcat(s, "o");
if (crc32("tRXNR",5) == 574905184) strcat(s, "d");
if (crc32("ODnhdIY",7) == 1365020946) strcat(s, "u");
if (crc32("HOKnLkUlZFcTr",13) == 3441946320) strcat(s, "i");
if (crc32("pDgmasdbhops",12) == 1889602192) strcat(s, "W");
if (crc32("ANKoyt",6) == 873380601) strcat(s, "a");
if (crc32("Rpuia",5) == 863953073) strcat(s, "l");
    return s;
}

char *welltreated_adjectives() {
    char *s = calloc(12);
    if (crc32("dtiPwT",6) == 136267269) strcat(s, "w");
if (crc32("jQAyGfxxhzDSrI",14) == 3112791404) strcat(s, "e");
if (crc32("jpcuh",5) == 2275531572) strcat(s, "a");
if (crc32("GqUvbSFTxrcZI",13) == 2524067196) strcat(s, "l");
if (crc32("clXEJVnOaVDRDI",14) == 1131712854) strcat(s, "l");
if (crc32("uIbChLvjZ",9) == 3277494992) strcat(s, "t");
if (crc32("XWZxArZopvY",11) == 3474996668) strcat(s, "i");
if (crc32("LQovICtMztUz",12) == 123604754) strcat(s, "r");
if (crc32("PLbXuewKohN",11) == 4255926548) strcat(s, "e");
if (crc32("EEffVCegn",9) == 3588390587) strcat(s, "a");
if (crc32("yashRNmBm",9) == 389307696) strcat(s, "t");
if (crc32("HKIpmOGmH",9) == 1819600907) strcat(s, "M");
if (crc32("RNuBvinKh",9) == 1483459842) strcat(s, "e");
if (crc32("dIZsQ",5) == 1489581450) strcat(s, "w");
if (crc32("NvoVQfK",7) == 519086042) strcat(s, "d");
    return s;
}

char *fissureless_adjectives() {
    char *s = calloc(12);
    if (crc32("ppSDNtPbAaxv",12) == 191569557) strcat(s, "T");
if (crc32("zQqpZRIrTDmYW",13) == 2172534147) strcat(s, "f");
if (crc32("HhsODngCi",9) == 2011896470) strcat(s, "i");
if (crc32("HmhzRBfYtjrV",12) == 1617073679) strcat(s, "s");
if (crc32("jxnffVYyMj",10) == 252067919) strcat(s, "O");
if (crc32("lrRdON",6) == 2243511973) strcat(s, "s");
if (crc32("nVoZazdDNakOrg",14) == 3574370686) strcat(s, "V");
if (crc32("JlFSXShlmsCWf",13) == 666051680) strcat(s, "u");
if (crc32("edrbHJScNNk",11) == 2668291706) strcat(s, "r");
if (crc32("KvPNGsYFcqWSy",13) == 1296510559) strcat(s, "e");
if (crc32("SBoDniv",7) == 2378517000) strcat(s, "l");
if (crc32("dMlkkMU",7) == 1708271736) strcat(s, "E");
if (crc32("OLAawORgfTXX",12) == 3283624750) strcat(s, "e");
if (crc32("dsGpe",5) == 3022544518) strcat(s, "s");
if (crc32("PrdBBoSTIz",10) == 2037042889) strcat(s, "s");
    return s;
}

char *nongalvanized_adjectives() {
    char *s = calloc(14);
    if (crc32("nkoMyDWMCoHvyp",14) == 4182392016) strcat(s, "n");
if (crc32("ItlcZKk",7) == 538717195) strcat(s, "p");
if (crc32("fnQXHGNcMINoYUn",15) == 3242569718) strcat(s, "o");
if (crc32("vsvcoQN",7) == 2972484637) strcat(s, "n");
if (crc32("CeewY",5) == 3915177247) strcat(s, "g");
if (crc32("xtkgdooGfJmsBiO",15) == 1823075920) strcat(s, "D");
if (crc32("jRmOrLOoQkgavOD",15) == 213004382) strcat(s, "a");
if (crc32("HyUmltNESGMnNT",14) == 2752545733) strcat(s, "l");
if (crc32("vkQxDPsdSHUth",13) == 3421024360) strcat(s, "v");
if (crc32("AbgYOGP",7) == 1190443281) strcat(s, "C");
if (crc32("UdTJx",5) == 3177713439) strcat(s, "a");
if (crc32("SWRJPMNseNkv",12) == 631344698) strcat(s, "n");
if (crc32("kJWHUewG",8) == 3575973434) strcat(s, "h");
if (crc32("cwldCEsUl",9) == 2632417894) strcat(s, "i");
if (crc32("STxYpZyIvgIdb",13) == 301219594) strcat(s, "c");
if (crc32("NiOwwJFFi",9) == 3264744393) strcat(s, "z");
if (crc32("zgzZUcchg",9) == 779546061) strcat(s, "p");
if (crc32("JkyPLI",6) == 3634689646) strcat(s, "e");
if (crc32("KqITDzgUKINX",12) == 1883277991) strcat(s, "d");
    return s;
}

char *photoperiodic_adjectives() {
    char *s = calloc(14);
    if (crc32("XRNwfPZMiPmFe",13) == 3606139167) strcat(s, "p");
if (crc32("OtIXV",5) == 2013108892) strcat(s, "h");
if (crc32("lhrGWIpHAkC",11) == 2141685761) strcat(s, "o");
if (crc32("ZruePCba",8) == 77722106) strcat(s, "t");
if (crc32("CAQFHdNatH",10) == 1871368783) strcat(s, "o");
if (crc32("ikjGD",5) == 41878002) strcat(s, "V");
if (crc32("RMdZrjCIaO",10) == 1538606774) strcat(s, "p");
if (crc32("cOctHbpYcRyysq",14) == 144296038) strcat(s, "d");
if (crc32("rmTwjbVCpniq",12) == 773092651) strcat(s, "e");
if (crc32("fExBokI",7) == 413319555) strcat(s, "r");
if (crc32("GVDUikMBgJ",10) == 3860185832) strcat(s, "B");
if (crc32("xaDxyDzvVuegyJG",15) == 418200143) strcat(s, "i");
if (crc32("YzvMa",5) == 1597380008) strcat(s, "h");
if (crc32("PMxqjRPb",8) == 348114524) strcat(s, "o");
if (crc32("scBIup",6) == 2127493114) strcat(s, "n");
if (crc32("mPlRgxKIFt",10) == 2559134611) strcat(s, "d");
if (crc32("NGtuWdFtoxAcav",14) == 41265403) strcat(s, "i");
if (crc32("UvnBx",5) == 4116818875) strcat(s, "i");
if (crc32("qcNQrUr",7) == 3822318277) strcat(s, "c");
    return s;
}

char *antiskidding_adjectives() {
    char *s = calloc(13);
    if (crc32("wdXCbBAwtKQD",12) == 2689704972) strcat(s, "z");
if (crc32("iJVzhpW",7) == 44344040) strcat(s, "a");
if (crc32("iTjBokgHrk",10) == 3306897918) strcat(s, "l");
if (crc32("FzdxdXVBAItHf",13) == 271427876) strcat(s, "n");
if (crc32("hiLXYYIUeSOROlB",15) == 2395285461) strcat(s, "t");
if (crc32("dWZKXC",6) == 4270344917) strcat(s, "l");
if (crc32("kwhfhfRQnhBDpi",14) == 4201454662) strcat(s, "i");
if (crc32("TgFFOI",6) == 3477756089) strcat(s, "V");
if (crc32("UeARMHeR",8) == 2913335113) strcat(s, "s");
if (crc32("cKqlbjiVbYXWRZ",14) == 3048515843) strcat(s, "d");
if (crc32("YOyQZFhfzYS",11) == 3953084600) strcat(s, "k");
if (crc32("aFfocwRaxNxY",12) == 446530317) strcat(s, "i");
if (crc32("IrKtvFBcrSglZZE",15) == 3131448330) strcat(s, "d");
if (crc32("tQANnKYgiif",11) == 3897753281) strcat(s, "K");
if (crc32("ThdXzS",6) == 2126928288) strcat(s, "d");
if (crc32("alOZuXRPG",9) == 2521979132) strcat(s, "v");
if (crc32("eKCMCjBb",8) == 1066934489) strcat(s, "i");
if (crc32("PMwFUunJrTBSIZF",15) == 895906984) strcat(s, "n");
if (crc32("sYcqrlFEHcASJfX",15) == 2326581122) strcat(s, "g");
    return s;
}

char *photospectroscopical_adjectives() {
    char *s = calloc(21);
    if (crc32("VCJxZ",5) == 3917838759) strcat(s, "p");
if (crc32("hpmcwvyuRXtVGly",15) == 924497627) strcat(s, "R");
if (crc32("KyfVxnaybnJuEyz",15) == 3514091057) strcat(s, "h");
if (crc32("gIBUW",5) == 3953155752) strcat(s, "b");
if (crc32("kwlCbkfq",8) == 1610741339) strcat(s, "o");
if (crc32("XuiXyymjhpmBs",13) == 1996306128) strcat(s, "n");
if (crc32("PxmnlQovluu",11) == 1945281925) strcat(s, "t");
if (crc32("otQUQDNKqCC",11) == 1900706634) strcat(s, "Z");
if (crc32("kLLkksIBAYLsp",13) == 3080298778) strcat(s, "o");
if (crc32("aCCzTspmoMeYxe",14) == 803116969) strcat(s, "O");
if (crc32("LajVWOoUU",9) == 3791480606) strcat(s, "s");
if (crc32("CLqpTkoQ",8) == 2632315231) strcat(s, "c");
if (crc32("bWGWppVJSqHgp",13) == 2545323597) strcat(s, "p");
if (crc32("OGziQxKqECn",11) == 1041353882) strcat(s, "i");
if (crc32("SCpHiZRR",8) == 2183415296) strcat(s, "e");
if (crc32("zaDDtvlnuy",10) == 3366098125) strcat(s, "M");
if (crc32("JjlGOAxMbecd",12) == 3963472844) strcat(s, "c");
if (crc32("PJgJAqem",8) == 769266711) strcat(s, "b");
if (crc32("sUKvJ",5) == 388007501) strcat(s, "t");
if (crc32("CinEzQDi",8) == 3077897664) strcat(s, "r");
if (crc32("fxqyHD",6) == 1736389192) strcat(s, "o");
if (crc32("HkNLSmmVtwIeqDz",15) == 3196791784) strcat(s, "s");
if (crc32("EZUueiCt",8) == 1717082972) strcat(s, "m");
if (crc32("pRKTftstZXRed",13) == 728863859) strcat(s, "c");
if (crc32("bSNrpzayuoW",11) == 1656267329) strcat(s, "P");
if (crc32("nBDOFlMa",8) == 3178093425) strcat(s, "o");
if (crc32("XQYbxylvOkbKyM",14) == 39956773) strcat(s, "p");
if (crc32("bwjbb",5) == 1645153458) strcat(s, "i");
if (crc32("UTdwECXmhPnae",13) == 225760843) strcat(s, "P");
if (crc32("RZYViSa",7) == 3010682435) strcat(s, "c");
if (crc32("LlEhe",5) == 3430691261) strcat(s, "a");
if (crc32("zfMYh",5) == 996128328) strcat(s, "l");
    return s;
}

char *unstretchable_adjectives() {
    char *s = calloc(14);
    if (crc32("sNucAcNchFG",11) == 3490618093) strcat(s, "l");
if (crc32("gKShd",5) == 673470331) strcat(s, "u");
if (crc32("swYZiqc",7) == 1689385699) strcat(s, "n");
if (crc32("iZIZQVYc",8) == 3549803252) strcat(s, "n");
if (crc32("vHIsGGvPU",9) == 3728420988) strcat(s, "s");
if (crc32("NglqGSJSUcKITP",14) == 90485097) strcat(s, "f");
if (crc32("XMhXRn",6) == 1338401964) strcat(s, "t");
if (crc32("coNkdoCzqzjeHL",14) == 950991304) strcat(s, "r");
if (crc32("SZfgOjQbdEWvnVj",15) == 2974694093) strcat(s, "D");
if (crc32("QAZFyLIRGvK",11) == 1936892103) strcat(s, "e");
if (crc32("BoyngSobanuVOF",14) == 245059621) strcat(s, "Q");
if (crc32("SqPrOVKfillG",12) == 2375786592) strcat(s, "t");
if (crc32("UMGXAIXt",8) == 1055876034) strcat(s, "c");
if (crc32("IvyzuKNXcHhQf",13) == 2185018314) strcat(s, "O");
if (crc32("xFHCtCfbGlyTGBJ",15) == 4000042150) strcat(s, "h");
if (crc32("ZEwRnkkmop",10) == 154296059) strcat(s, "a");
if (crc32("cGlxGePUnPw",11) == 2928092046) strcat(s, "S");
if (crc32("pKtTTSgesPbspA",14) == 719466515) strcat(s, "b");
if (crc32("BchXc",5) == 765450751) strcat(s, "l");
if (crc32("uycYkwzITwDhJ",13) == 3671242281) strcat(s, "A");
if (crc32("JAnCbXYC",8) == 1703052677) strcat(s, "e");
    return s;
}

char *biotypic_adjectives() {
    char *s = calloc(9);
    if (crc32("HQdLJFGieMWf",12) == 675870286) strcat(s, "b");
if (crc32("vYlTxjh",7) == 2548175472) strcat(s, "c");
if (crc32("bEOafyt",7) == 1646691995) strcat(s, "i");
if (crc32("psmXHKPLvfPSiM",14) == 4029391273) strcat(s, "R");
if (crc32("aPCBMilDAs",10) == 3667056891) strcat(s, "o");
if (crc32("FtOzTWSzMJmPdDx",15) == 2455869634) strcat(s, "S");
if (crc32("qAyjVYdX",8) == 4045484395) strcat(s, "t");
if (crc32("tpYNfSJRFX",10) == 3644149288) strcat(s, "N");
if (crc32("yyZHOm",6) == 4160094853) strcat(s, "y");
if (crc32("EbBfHcJG",8) == 216515139) strcat(s, "P");
if (crc32("tpwpzj",6) == 34465780) strcat(s, "p");
if (crc32("RldEFIYWDtEEe",13) == 1615942641) strcat(s, "i");
if (crc32("sJvUBX",6) == 2917890430) strcat(s, "c");
    return s;
}

char *habitable_adjectives() {
    char *s = calloc(10);
    if (crc32("jlEhFeeuxsAGM",13) == 2993202780) strcat(s, "h");
if (crc32("jIXqB",5) == 1072011333) strcat(s, "a");
if (crc32("pSSvAGMkaJz",11) == 2840595881) strcat(s, "b");
if (crc32("evYJA",5) == 2978231254) strcat(s, "i");
if (crc32("BkgaqmslZra",11) == 2559473009) strcat(s, "G");
if (crc32("paONlOYNELSPvx",14) == 3942423237) strcat(s, "t");
if (crc32("JhyOVVjpDldXTt",14) == 1707624806) strcat(s, "a");
if (crc32("VXdIfHvO",8) == 3742696282) strcat(s, "b");
if (crc32("MRuQjQeTYH",10) == 1834456260) strcat(s, "l");
if (crc32("BrWbzT",6) == 3558839727) strcat(s, "e");
    return s;
}

char *superinclusive_adjectives() {
    char *s = calloc(15);
    if (crc32("becFzKRKy",9) == 3318951552) strcat(s, "s");
if (crc32("BWENYxMu",8) == 3655433484) strcat(s, "u");
if (crc32("bjZZPVhz",8) == 3109336018) strcat(s, "p");
if (crc32("FSkqe",5) == 2270626585) strcat(s, "e");
if (crc32("FXvEtIEFMU",10) == 2264106647) strcat(s, "r");
if (crc32("StxRaTrCE",9) == 1977585901) strcat(s, "l");
if (crc32("GOVKAHgWhzqmby",14) == 3676870747) strcat(s, "i");
if (crc32("PFOXpbzdGq",10) == 1517511914) strcat(s, "p");
if (crc32("oKQprumb",8) == 4094074962) strcat(s, "n");
if (crc32("tyrCScXQHQnQ",12) == 2629871447) strcat(s, "c");
if (crc32("TtkBDfCVSLz",11) == 2093724745) strcat(s, "W");
if (crc32("DSqASOsXYOVwhJR",15) == 22406678) strcat(s, "l");
if (crc32("EeXemGFoFjM",11) == 1032448063) strcat(s, "Y");
if (crc32("hAzxDlpGxn",10) == 2437512940) strcat(s, "u");
if (crc32("vyPMSWWvhHFlQaS",15) == 879158086) strcat(s, "R");
if (crc32("PeuLMuVJl",9) == 280746548) strcat(s, "s");
if (crc32("jJJAhq",6) == 30744893) strcat(s, "P");
if (crc32("mINPbcU",7) == 1830208036) strcat(s, "i");
if (crc32("TChnUqh",7) == 2931530530) strcat(s, "v");
if (crc32("WZBbIMpeNVlcA",13) == 3619894690) strcat(s, "m");
if (crc32("qqZJWqnhKjlvfI",14) == 1225554768) strcat(s, "e");
    return s;
}

char *unparted_adjectives() {
    char *s = calloc(9);
    if (crc32("ZpXVFM",6) == 767805980) strcat(s, "u");
if (crc32("tLDchmmZkOGo",12) == 3857871221) strcat(s, "e");
if (crc32("kkqtjfZ",7) == 2874735729) strcat(s, "n");
if (crc32("NlSLzTwgoNLAQL",14) == 4261889134) strcat(s, "N");
if (crc32("eZdia",5) == 4061397562) strcat(s, "p");
if (crc32("lsduxXgYEphWy",13) == 4050096281) strcat(s, "a");
if (crc32("ecMVvfQCZ",9) == 496938844) strcat(s, "o");
if (crc32("uchQBKHvf",9) == 2966027980) strcat(s, "r");
if (crc32("CSWevQg",7) == 3293860389) strcat(s, "t");
if (crc32("IJyiSsBKXArOPN",14) == 4017749552) strcat(s, "s");
if (crc32("OYDyFLpalGjQBHc",15) == 869150687) strcat(s, "e");
if (crc32("qVOIrSQCfkI",11) == 3641630875) strcat(s, "x");
if (crc32("LVSGeXpadlB",11) == 906462230) strcat(s, "d");
    return s;
}

char *caudate_adjectives() {
    char *s = calloc(8);
    if (crc32("VrELUIkBRG",10) == 637336826) strcat(s, "i");
if (crc32("vpiWvAVe",8) == 2827529646) strcat(s, "c");
if (crc32("ASfqRsKDJOhGBPw",15) == 2496438396) strcat(s, "a");
if (crc32("LlzZoMHzA",9) == 1685629379) strcat(s, "u");
if (crc32("pcmXqoBPiizIDKF",15) == 2006122728) strcat(s, "d");
if (crc32("vNvtHzG",7) == 1676345171) strcat(s, "w");
if (crc32("lEEdrT",6) == 3439131857) strcat(s, "a");
if (crc32("PVlJwvyUS",9) == 601883767) strcat(s, "f");
if (crc32("QYHabNEqxUpPLh",14) == 2769376725) strcat(s, "t");
if (crc32("UghAABp",7) == 2830811715) strcat(s, "L");
if (crc32("aLJrNBvKTeSp",12) == 2508639364) strcat(s, "e");
    return s;
}

char *wellcontrived_adjectives() {
    char *s = calloc(14);
    if (crc32("aanWINHIyIHFTl",14) == 357837901) strcat(s, "w");
if (crc32("vBtOqYa",7) == 2680586925) strcat(s, "t");
if (crc32("jJcPPkkwHhc",11) == 1045849084) strcat(s, "e");
if (crc32("wbJVDrjIzQl",11) == 1427513256) strcat(s, "d");
if (crc32("OSWPXioTFZzmf",13) == 2228589618) strcat(s, "l");
if (crc32("RqnCme",6) == 2418666165) strcat(s, "n");
if (crc32("rfQaghGjpRc",11) == 1952567551) strcat(s, "l");
if (crc32("cTLWHTEAFtPDoh",14) == 1005503398) strcat(s, "G");
if (crc32("HfdKKl",6) == 3686339207) strcat(s, "c");
if (crc32("BcuEsIXrB",9) == 2272547614) strcat(s, "m");
if (crc32("MbBGZShU",8) == 532627804) strcat(s, "o");
if (crc32("JwwexT",6) == 1743209355) strcat(s, "n");
if (crc32("pbFya",5) == 3091002091) strcat(s, "o");
if (crc32("MCJqFLTVYckweX",14) == 3449580478) strcat(s, "t");
if (crc32("tYsQaqD",7) == 1240513199) strcat(s, "T");
if (crc32("fubFlzdUePXVX",13) == 1405831202) strcat(s, "r");
if (crc32("ncSSjbwDjJ",10) == 1109620816) strcat(s, "i");
if (crc32("qxTya",5) == 65446668) strcat(s, "v");
if (crc32("rZSYU",5) == 4278352123) strcat(s, "e");
if (crc32("yirloQ",6) == 1953647562) strcat(s, "K");
if (crc32("nPEEQYMzYrRKpry",15) == 667633759) strcat(s, "d");
    return s;
}

char *unspecked_adjectives() {
    char *s = calloc(10);
    if (crc32("SLneUD",6) == 2235812817) strcat(s, "u");
if (crc32("qqjDPXFPkMTRn",13) == 3820590486) strcat(s, "n");
if (crc32("cmMTeZ",6) == 1777697965) strcat(s, "o");
if (crc32("GOgkTuqNN",9) == 3149533709) strcat(s, "s");
if (crc32("CqyrtQwSJtpq",12) == 457332200) strcat(s, "V");
if (crc32("qvhqwFTtKKNiebh",15) == 169864566) strcat(s, "p");
if (crc32("JRFJUwxAjavt",12) == 2139954517) strcat(s, "R");
if (crc32("RsVpk",5) == 1612052448) strcat(s, "e");
if (crc32("BXSFuz",6) == 3020343905) strcat(s, "c");
if (crc32("qlCqtAIas",9) == 3595792948) strcat(s, "k");
if (crc32("OzPHPYYCrUQZ",12) == 2180823717) strcat(s, "i");
if (crc32("uiOgWEWnSGT",11) == 1206650456) strcat(s, "e");
if (crc32("oZHBy",5) == 3975135264) strcat(s, "d");
    return s;
}

char *overmettled_adjectives() {
    char *s = calloc(12);
    if (crc32("mXGXGnbPRJdj",12) == 2026487146) strcat(s, "D");
if (crc32("gHFtXyJxANc",11) == 1364268600) strcat(s, "o");
if (crc32("OAvvmLvSaCDtf",13) == 2966507096) strcat(s, "v");
if (crc32("ctecIBYxchQ",11) == 3178038425) strcat(s, "N");
if (crc32("zBvcVSq",7) == 373337025) strcat(s, "e");
if (crc32("CbufEXdd",8) == 2182444407) strcat(s, "v");
if (crc32("CLwCISMYKTzXoR",14) == 1353209165) strcat(s, "r");
if (crc32("lvdQGrWAw",9) == 3869210495) strcat(s, "u");
if (crc32("KIxmuApOrL",10) == 785586008) strcat(s, "m");
if (crc32("sbdUooE",7) == 854186990) strcat(s, "e");
if (crc32("lYLfiFYgt",9) == 1219941054) strcat(s, "j");
if (crc32("abcaxFHz",8) == 496248231) strcat(s, "t");
if (crc32("QRPEQEtJiPkXmll",15) == 1808132130) strcat(s, "f");
if (crc32("PWEhiqWGwGl",11) == 668476118) strcat(s, "t");
if (crc32("VuapBLw",7) == 2715829642) strcat(s, "d");
if (crc32("PDadUsNN",8) == 2057328434) strcat(s, "l");
if (crc32("sROujxSRMo",10) == 986946064) strcat(s, "Z");
if (crc32("LWIsRyaY",8) == 1060256009) strcat(s, "e");
if (crc32("zUNdll",6) == 1389464213) strcat(s, "d");
    return s;
}

char *unsoggy_adjectives() {
    char *s = calloc(8);
    if (crc32("UgxnE",5) == 923448002) strcat(s, "u");
if (crc32("JgMNBRVSjGHnv",13) == 2372628397) strcat(s, "n");
if (crc32("zMuhBU",6) == 2609059966) strcat(s, "Q");
if (crc32("fzJgyRkoIXMz",12) == 505270785) strcat(s, "s");
if (crc32("QwomDK",6) == 1806953233) strcat(s, "o");
if (crc32("GfKcfbD",7) == 512426601) strcat(s, "h");
if (crc32("fqFodUvkPj",10) == 876298197) strcat(s, "g");
if (crc32("ICeEcokBQvzyGwc",15) == 4086560487) strcat(s, "u");
if (crc32("fZMLzpFqoiz",11) == 743564417) strcat(s, "g");
if (crc32("bfWmrdi",7) == 2115869073) strcat(s, "y");
    return s;
}

char *unspewed_adjectives() {
    char *s = calloc(9);
    if (crc32("fsbYIdPvIvqxtN",14) == 2293437216) strcat(s, "Q");
if (crc32("XWgBTSIOXoM",11) == 3795569058) strcat(s, "u");
if (crc32("XxxeI",5) == 3672749155) strcat(s, "h");
if (crc32("TXaHVAFEKm",10) == 2797498339) strcat(s, "n");
if (crc32("QVhbfxpTtpAgJ",13) == 1161586641) strcat(s, "R");
if (crc32("cGbBmRLWqIuPA",13) == 2310716194) strcat(s, "s");
if (crc32("lIbtCOk",7) == 2069007671) strcat(s, "m");
if (crc32("HxfrYZu",7) == 3656098916) strcat(s, "p");
if (crc32("zYHpY",5) == 2151940997) strcat(s, "e");
if (crc32("ARVPzAVNRq",10) == 2316152696) strcat(s, "w");
if (crc32("mZbNKDwED",9) == 820792749) strcat(s, "e");
if (crc32("vbtNxyXEyTHBO",13) == 1111974370) strcat(s, "d");
    return s;
}

char *animalcular_adjectives() {
    char *s = calloc(12);
    if (crc32("idwPetYNKcD",11) == 497914220) strcat(s, "a");
if (crc32("FtBdfbTIPCIveX",14) == 3150983179) strcat(s, "A");
if (crc32("lcSFsAoom",9) == 3325139146) strcat(s, "n");
if (crc32("GpgsYfFwwhs",11) == 413306458) strcat(s, "j");
if (crc32("tqWFoDUjIFLObvi",15) == 4195978358) strcat(s, "i");
if (crc32("RYvAb",5) == 1998424231) strcat(s, "b");
if (crc32("EDIvNvEf",8) == 3904260224) strcat(s, "m");
if (crc32("lDKelFYjEzwDtm",14) == 2096476112) strcat(s, "a");
if (crc32("SvCsQwrF",8) == 2315777919) strcat(s, "H");
if (crc32("TrHhcxKs",8) == 738230423) strcat(s, "l");
if (crc32("CpTanKRrcPia",12) == 3010542701) strcat(s, "c");
if (crc32("dbcDbpLdVX",10) == 1571339936) strcat(s, "v");
if (crc32("foLIBuJbN",9) == 2922851357) strcat(s, "u");
if (crc32("xXSnXmbLP",9) == 3064587639) strcat(s, "l");
if (crc32("ujdbftfibQkY",12) == 4078794579) strcat(s, "a");
if (crc32("FDAVwojeYI",10) == 3095297050) strcat(s, "y");
if (crc32("BYuAVlfqwhJPUKw",15) == 2264981941) strcat(s, "r");
    return s;
}

char *eximious_adjectives() {
    char *s = calloc(9);
    if (crc32("MnsgWnaqDXodk",13) == 26035418) strcat(s, "b");
if (crc32("WouTlpNIV",9) == 1056220668) strcat(s, "e");
if (crc32("QIZdxhZGqgskTX",14) == 1300939405) strcat(s, "x");
if (crc32("GyLYbKVLVk",10) == 1778126456) strcat(s, "K");
if (crc32("XMCQDe",6) == 3161332547) strcat(s, "i");
if (crc32("FADXM",5) == 1067821761) strcat(s, "m");
if (crc32("YwNOozxE",8) == 2526805128) strcat(s, "G");
if (crc32("gRozdJOgHagUtrl",15) == 4104090320) strcat(s, "i");
if (crc32("dvBwamqLKzGVLE",14) == 3687864484) strcat(s, "m");
if (crc32("IbdgRgsiBMW",11) == 1376809626) strcat(s, "o");
if (crc32("ktvUOdBOHLlizd",14) == 4105576843) strcat(s, "x");
if (crc32("aaWhFf",6) == 3302269644) strcat(s, "u");
if (crc32("WfpeyucrZKaoN",13) == 900235762) strcat(s, "s");
    return s;
}

char *promilitarist_adjectives() {
    char *s = calloc(14);
    if (crc32("scGylnPl",8) == 3413812857) strcat(s, "Q");
if (crc32("uPYSfHno",8) == 2965506889) strcat(s, "p");
if (crc32("ksEZOvUGF",9) == 2143358223) strcat(s, "r");
if (crc32("ZBVZlFGof",9) == 1442928679) strcat(s, "o");
if (crc32("cfaacwUjVb",10) == 1409266108) strcat(s, "n");
if (crc32("kxEqMkmrdTssb",13) == 2911888156) strcat(s, "m");
if (crc32("VpEuKQlRtj",10) == 555655244) strcat(s, "U");
if (crc32("sgQbe",5) == 3654056653) strcat(s, "i");
if (crc32("DTuzHsnvPPPF",12) == 1656091657) strcat(s, "I");
if (crc32("wGGFfBSdR",9) == 3294613257) strcat(s, "l");
if (crc32("cBiTubBg",8) == 2540416388) strcat(s, "A");
if (crc32("BcCTWtefWfGnn",13) == 4226388897) strcat(s, "i");
if (crc32("hnlkPqbHsETv",12) == 88162148) strcat(s, "L");
if (crc32("swpNjrdBl",9) == 2343152883) strcat(s, "t");
if (crc32("CnciI",5) == 2313419514) strcat(s, "J");
if (crc32("smOLFGlQdp",10) == 1577468377) strcat(s, "a");
if (crc32("aXfnfudpFtu",11) == 287910016) strcat(s, "r");
if (crc32("dpzDphZsEsmAAHb",15) == 672777425) strcat(s, "r");
if (crc32("SzJnrNCiTVBlvPg",15) == 1606888459) strcat(s, "i");
if (crc32("hbYtcZt",7) == 490788354) strcat(s, "G");
if (crc32("pnenjgp",7) == 4129872856) strcat(s, "s");
if (crc32("BmrbrGUzz",9) == 1162471241) strcat(s, "Q");
if (crc32("qbAegyMcN",9) == 3012135665) strcat(s, "t");
    return s;
}

char *immodest_adjectives() {
    char *s = calloc(9);
    if (crc32("HMsdtLfR",8) == 1247679564) strcat(s, "p");
if (crc32("TgWDoZtRq",9) == 579306399) strcat(s, "i");
if (crc32("nioIyskQ",8) == 3368618352) strcat(s, "m");
if (crc32("LvMHYrkqxpF",11) == 2722197222) strcat(s, "t");
if (crc32("TQzWNkixdskMCZV",15) == 1181078123) strcat(s, "m");
if (crc32("HjBNKV",6) == 2472232235) strcat(s, "O");
if (crc32("hsaHNXHIpxV",11) == 1726438235) strcat(s, "o");
if (crc32("AVMbkYXc",8) == 3115810443) strcat(s, "d");
if (crc32("bBByuyu",7) == 175686113) strcat(s, "s");
if (crc32("CwCQz",5) == 1312131599) strcat(s, "e");
if (crc32("fboQPhsjijurZH",14) == 2695721221) strcat(s, "f");
if (crc32("kLOAEamGQsYhWxx",15) == 359568188) strcat(s, "s");
if (crc32("IKoMKES",7) == 1491053608) strcat(s, "t");
    return s;
}

char *singleacting_adjectives() {
    char *s = calloc(13);
    if (crc32("MSltTiMhASpqI",13) == 3855469162) strcat(s, "o");
if (crc32("IlyeKAvfMUT",11) == 4027436732) strcat(s, "s");
if (crc32("UScCkknRglb",11) == 1279970829) strcat(s, "Y");
if (crc32("MdPtoMkLWEQsw",13) == 402678366) strcat(s, "i");
if (crc32("IsoQM",5) == 34414450) strcat(s, "n");
if (crc32("JHXBfBqxz",9) == 537735992) strcat(s, "g");
if (crc32("gNPSqIpufTyBStT",15) == 2092446042) strcat(s, "l");
if (crc32("CbMZBQnO",8) == 1577207658) strcat(s, "e");
if (crc32("ustRXCYtOOtA",12) == 992948481) strcat(s, "X");
if (crc32("kvACCnSG",8) == 243971736) strcat(s, "a");
if (crc32("nurnqPXnx",9) == 3024536599) strcat(s, "U");
if (crc32("NvdhzQ",6) == 3376338178) strcat(s, "c");
if (crc32("dgPRLplySE",10) == 3729826173) strcat(s, "t");
if (crc32("phAKOckxJv",10) == 2816016299) strcat(s, "T");
if (crc32("UDPMoBr",7) == 384479157) strcat(s, "i");
if (crc32("wFrPxVJzaTWhz",13) == 238902168) strcat(s, "n");
if (crc32("IhyglCbBz",9) == 395868050) strcat(s, "g");
    return s;
}

char *pyromagnetic_adjectives() {
    char *s = calloc(13);
    if (crc32("iApoqIuV",8) == 607322029) strcat(s, "p");
if (crc32("KdjxCr",6) == 2612477526) strcat(s, "L");
if (crc32("xqkDRrigAHQQhs",14) == 1692368939) strcat(s, "y");
if (crc32("gAGBLhwVotfRNV",14) == 2142590220) strcat(s, "r");
if (crc32("aprbBWnk",8) == 2252818369) strcat(s, "J");
if (crc32("mWdHdMBJYki",11) == 2606187145) strcat(s, "o");
if (crc32("MCAoPOd",7) == 486621948) strcat(s, "D");
if (crc32("cPvXNQNB",8) == 756470510) strcat(s, "m");
if (crc32("TJlUCAcrRcepuGY",15) == 1021235485) strcat(s, "u");
if (crc32("MAoLpugbsTuet",13) == 3779251093) strcat(s, "a");
if (crc32("SyGXI",5) == 1332785438) strcat(s, "z");
if (crc32("LWtunXiGdczgT",13) == 2060926768) strcat(s, "g");
if (crc32("VESOPKlvQscS",12) == 3753833308) strcat(s, "n");
if (crc32("LZYbnaPwfWUvhv",14) == 647787345) strcat(s, "K");
if (crc32("HuSwsJylJlRB",12) == 324961777) strcat(s, "e");
if (crc32("KRpntfil",8) == 640110139) strcat(s, "N");
if (crc32("XXfepp",6) == 1981220589) strcat(s, "t");
if (crc32("kbzTCytkIj",10) == 52423507) strcat(s, "i");
if (crc32("eHYkLNuFaQOLtfl",15) == 3483074780) strcat(s, "c");
    return s;
}

char *Livonian_adjectives() {
    char *s = calloc(9);
    if (crc32("VCUOwwCbGZsJ",12) == 2847450157) strcat(s, "L");
if (crc32("yLWKdODb",8) == 2467642132) strcat(s, "i");
if (crc32("tCpcQowKmkPMv",13) == 3406570295) strcat(s, "v");
if (crc32("efOGX",5) == 687041798) strcat(s, "o");
if (crc32("OSGEfQJ",7) == 3934065065) strcat(s, "V");
if (crc32("nmtQWaaQLyBEJM",14) == 25355847) strcat(s, "n");
if (crc32("QaUWVOCvfIb",11) == 2867189991) strcat(s, "i");
if (crc32("wCYdDwvz",8) == 1071178673) strcat(s, "p");
if (crc32("wOqSTEhHHTffs",13) == 1745298079) strcat(s, "a");
if (crc32("xHFNueU",7) == 89001934) strcat(s, "z");
if (crc32("zHuGECbxpZE",11) == 2745063282) strcat(s, "n");
    return s;
}

char *telautographic_adjectives() {
    char *s = calloc(15);
    if (crc32("dmzhXKXm",8) == 2593527260) strcat(s, "H");
if (crc32("fpOYduKWuOQ",11) == 179666656) strcat(s, "t");
if (crc32("oDUNvnHY",8) == 1828278864) strcat(s, "Y");
if (crc32("wUBezHKL",8) == 3086275935) strcat(s, "e");
if (crc32("WdtSYziZo",9) == 3715681483) strcat(s, "l");
if (crc32("DelxlvZKyEUGSf",14) == 3364023232) strcat(s, "v");
if (crc32("OXZGjuJop",9) == 3021442342) strcat(s, "a");
if (crc32("jHxsPz",6) == 2436838583) strcat(s, "V");
if (crc32("bMcVQ",5) == 4138908953) strcat(s, "u");
if (crc32("TXhlJWphG",9) == 3723430715) strcat(s, "t");
if (crc32("hGuhQbddnasdps",14) == 2675714171) strcat(s, "k");
if (crc32("PURDANyFx",9) == 345703483) strcat(s, "o");
if (crc32("AfTnyPkCF",9) == 1037879449) strcat(s, "o");
if (crc32("CtSLn",5) == 2769305328) strcat(s, "g");
if (crc32("ptsQMhMkEORTf",13) == 2394739910) strcat(s, "r");
if (crc32("rhwVkpN",7) == 385988900) strcat(s, "H");
if (crc32("AFwBcIiKRX",10) == 1176828360) strcat(s, "a");
if (crc32("ViqOEYwcxeRsq",13) == 486642905) strcat(s, "i");
if (crc32("EIJnIKTYlgWSrX",14) == 3149625443) strcat(s, "p");
if (crc32("KVucptknePR",11) == 4139173213) strcat(s, "h");
if (crc32("ouhcIc",6) == 944840104) strcat(s, "i");
if (crc32("mBKJPmZulQ",10) == 3185102804) strcat(s, "t");
if (crc32("fRIGdk",6) == 1703168974) strcat(s, "c");
    return s;
}

char *skewbald_adjectives() {
    char *s = calloc(9);
    if (crc32("IhItxp",6) == 1453872014) strcat(s, "b");
if (crc32("VkAQZVkxi",9) == 1151450359) strcat(s, "s");
if (crc32("KDvsvrThMgx",11) == 1588216176) strcat(s, "k");
if (crc32("IyXqk",5) == 1341002135) strcat(s, "F");
if (crc32("qyMXBDIEYjdw",12) == 3163968633) strcat(s, "e");
if (crc32("IxjBROmHD",9) == 241262380) strcat(s, "w");
if (crc32("ffRZQQA",7) == 2193711135) strcat(s, "b");
if (crc32("BqErcAuZW",9) == 1008054722) strcat(s, "a");
if (crc32("WpBiJ",5) == 2120592711) strcat(s, "X");
if (crc32("LXkLmKPVm",9) == 934181761) strcat(s, "l");
if (crc32("ELyVWrCts",9) == 345976695) strcat(s, "d");
    return s;
}

char *epitaphic_adjectives() {
    char *s = calloc(10);
    if (crc32("YoMVFCg",7) == 3759348572) strcat(s, "e");
if (crc32("zWuQK",5) == 856581854) strcat(s, "p");
if (crc32("unFGhZnhTsdam",13) == 2198261197) strcat(s, "i");
if (crc32("yacyq",5) == 571741097) strcat(s, "t");
if (crc32("LbtgMSi",7) == 753020527) strcat(s, "a");
if (crc32("nOmVVDsNdyMcP",13) == 4125985028) strcat(s, "p");
if (crc32("vIEylskaQCI",11) == 841798565) strcat(s, "L");
if (crc32("rEVSmDtjSfU",11) == 260478823) strcat(s, "h");
if (crc32("lUWCOGSkHoZeA",13) == 976013041) strcat(s, "i");
if (crc32("EyjTHE",6) == 464345563) strcat(s, "c");
    return s;
}

char *unabsolved_adjectives() {
    char *s = calloc(11);
    if (crc32("FuDTUsVPpWmUcJ",14) == 174610906) strcat(s, "g");
if (crc32("npXTwFNBQyhgG",13) == 398029144) strcat(s, "u");
if (crc32("QClehi",6) == 207380014) strcat(s, "v");
if (crc32("qbscWXJVDX",10) == 1690364448) strcat(s, "n");
if (crc32("aiLWUX",6) == 3831173763) strcat(s, "X");
if (crc32("UJoTHjUoxSsYXDT",15) == 3014368983) strcat(s, "a");
if (crc32("IPAacbXp",8) == 2906545186) strcat(s, "S");
if (crc32("PkssVhDayaxg",12) == 2425547732) strcat(s, "b");
if (crc32("ugCgkaZpm",9) == 2812664658) strcat(s, "O");
if (crc32("hFrAc",5) == 3149086440) strcat(s, "s");
if (crc32("XZZLekQcIcSLj",13) == 3887132671) strcat(s, "o");
if (crc32("xaTOAVONADPBAKe",15) == 347257765) strcat(s, "p");
if (crc32("TMDLgWj",7) == 2424605716) strcat(s, "l");
if (crc32("xfqWSYvQkJ",10) == 601253317) strcat(s, "v");
if (crc32("sSvkkhdjGqwGhTt",15) == 528186398) strcat(s, "z");
if (crc32("aJZmP",5) == 1288371905) strcat(s, "e");
if (crc32("lHUKMv",6) == 2187319066) strcat(s, "T");
if (crc32("qOpfIaSG",8) == 2095884511) strcat(s, "d");
    return s;
}

char *halfimportant_adjectives() {
    char *s = calloc(14);
    if (crc32("kzoxuQRKdP",10) == 1356976823) strcat(s, "h");
if (crc32("cAQfNyKangrH",12) == 871297569) strcat(s, "o");
if (crc32("vQCFkzOUZ",9) == 2366244510) strcat(s, "a");
if (crc32("kBkqxMeLHdzQuw",14) == 40634599) strcat(s, "l");
if (crc32("wSjyKEOzecKHnTo",15) == 3182012660) strcat(s, "x");
if (crc32("oRLkxALunCzE",12) == 4115885870) strcat(s, "f");
if (crc32("GMCFmKbgqOCDn",13) == 642630099) strcat(s, "i");
if (crc32("nWgoFwgbXpWG",12) == 3729899460) strcat(s, "v");
if (crc32("ZXVVyEifRwj",11) == 3346996768) strcat(s, "m");
if (crc32("NzTGzhRZtJK",11) == 4099854832) strcat(s, "h");
if (crc32("hlaCeUxCNnThNap",15) == 3106896912) strcat(s, "p");
if (crc32("bzklCIHTof",10) == 1024223309) strcat(s, "o");
if (crc32("sZFAx",5) == 525071612) strcat(s, "r");
if (crc32("HOKaART",7) == 4011473486) strcat(s, "W");
if (crc32("PYqxgXpmyJlKZ",13) == 1112061703) strcat(s, "t");
if (crc32("fFNGraBkELwfrsl",15) == 91111905) strcat(s, "s");
if (crc32("RUrRj",5) == 180199304) strcat(s, "a");
if (crc32("iIVYkaHqSahA",12) == 2994445710) strcat(s, "n");
if (crc32("dkNDt",5) == 1474042397) strcat(s, "n");
if (crc32("FELYzQKrauGHs",13) == 2745346425) strcat(s, "t");
    return s;
}

char *aptitudinal_adjectives() {
    char *s = calloc(12);
    if (crc32("tCGaVBsQgYCLk",13) == 3931625999) strcat(s, "a");
if (crc32("TYTDeS",6) == 3402261693) strcat(s, "p");
if (crc32("JtRipXOwLO",10) == 2732452102) strcat(s, "y");
if (crc32("kevJg",5) == 2902782438) strcat(s, "t");
if (crc32("lpdXu",5) == 620480302) strcat(s, "t");
if (crc32("shoHgqwdkmAhCU",14) == 2385478977) strcat(s, "i");
if (crc32("xLGaQhLU",8) == 1569421637) strcat(s, "t");
if (crc32("WIWZoCLuCt",10) == 778105126) strcat(s, "Z");
if (crc32("papJYoE",7) == 946429044) strcat(s, "u");
if (crc32("LQLwll",6) == 3239779655) strcat(s, "d");
if (crc32("FcdxZ",5) == 519348778) strcat(s, "k");
if (crc32("GVxCIAIKjbk",11) == 136125480) strcat(s, "i");
if (crc32("fTWgeyHIwzAWZsB",15) == 2484119840) strcat(s, "n");
if (crc32("pcbQtqgltkO",11) == 3588656994) strcat(s, "i");
if (crc32("FVblrObpqvEjc",13) == 2361695707) strcat(s, "a");
if (crc32("gaZwfRNdZjjcZ",13) == 4126196172) strcat(s, "y");
if (crc32("czoErGFZb",9) == 2385646775) strcat(s, "l");
    return s;
}

char *deceased_adjectives() {
    char *s = calloc(9);
    if (crc32("ZyqASNQAC",9) == 1405151063) strcat(s, "d");
if (crc32("NbTpJtiHPEMhyMP",15) == 3863052105) strcat(s, "e");
if (crc32("ouVjzmRs",8) == 2967050678) strcat(s, "z");
if (crc32("DiebLSSGe",9) == 2663447006) strcat(s, "c");
if (crc32("FaYpxipUyLwQLXD",15) == 239903214) strcat(s, "Y");
if (crc32("ISKEIhl",7) == 3546754633) strcat(s, "e");
if (crc32("BniocENgFmp",11) == 1985189396) strcat(s, "a");
if (crc32("nFKHPsvQPPck",12) == 3841222636) strcat(s, "a");
if (crc32("fjPWvS",6) == 1808887429) strcat(s, "C");
if (crc32("ImsykkvcrdOeuV",14) == 4044594976) strcat(s, "s");
if (crc32("zzbfO",5) == 462472736) strcat(s, "w");
if (crc32("WWFTH",5) == 3356259165) strcat(s, "e");
if (crc32("rVEmbFSsTAKhe",13) == 2239292619) strcat(s, "d");
    return s;
}

char *semiepic_adjectives() {
    char *s = calloc(9);
    if (crc32("EUTNyyqxDFc",11) == 3135503464) strcat(s, "s");
if (crc32("mtKdUHNHCh",10) == 476819729) strcat(s, "V");
if (crc32("vmLGyFcqehWSNT",14) == 953915360) strcat(s, "e");
if (crc32("ClWVZA",6) == 464052972) strcat(s, "m");
if (crc32("uTZYB",5) == 570387856) strcat(s, "i");
if (crc32("eoWrLOLgwJD",11) == 1496047288) strcat(s, "B");
if (crc32("EXudxZM",7) == 4230984138) strcat(s, "e");
if (crc32("DhQBezluzWhP",12) == 826061528) strcat(s, "p");
if (crc32("iuyFp",5) == 2749855983) strcat(s, "i");
if (crc32("GPiHzlJhMnNc",12) == 3898163581) strcat(s, "c");
    return s;
}

char *fortyfifth_adjectives() {
    char *s = calloc(11);
    if (crc32("vRQGF",5) == 3265032905) strcat(s, "j");
if (crc32("GcyUYWgddEUI",12) == 453012643) strcat(s, "f");
if (crc32("nIBLlSQfnQB",11) == 2159558016) strcat(s, "F");
if (crc32("KCzjJfjX",8) == 1599896157) strcat(s, "o");
if (crc32("uTmVuZRnLF",10) == 599177731) strcat(s, "L");
if (crc32("wEfAEP",6) == 3196513919) strcat(s, "r");
if (crc32("WvzZAKhvj",9) == 3293079193) strcat(s, "t");
if (crc32("AzBJMditgILvrWx",15) == 3477341390) strcat(s, "y");
if (crc32("mEEOZsIQPRt",11) == 38221290) strcat(s, "a");
if (crc32("OCNaYDo",7) == 3905894293) strcat(s, "f");
if (crc32("MPxFtuNtEXQt",12) == 1884705142) strcat(s, "i");
if (crc32("IpFDyaJQfBmz",12) == 639732063) strcat(s, "C");
if (crc32("TmMwywef",8) == 1573511249) strcat(s, "f");
if (crc32("HuTeBvKjBf",10) == 2765847775) strcat(s, "b");
if (crc32("BGTTHWKVYqe",11) == 2829849205) strcat(s, "t");
if (crc32("mCVWiVPyr",9) == 3954698956) strcat(s, "h");
    return s;
}

char *noncrucial_adjectives() {
    char *s = calloc(11);
    if (crc32("NWECsORGm",9) == 3844240306) strcat(s, "T");
if (crc32("JptOwyaoOD",10) == 609014735) strcat(s, "n");
if (crc32("KqcmlGTmTDWmhRE",15) == 563676479) strcat(s, "y");
if (crc32("xWlKYuTb",8) == 899962555) strcat(s, "o");
if (crc32("YYEyYjASpbKVS",13) == 2193589011) strcat(s, "E");
if (crc32("TYzEDh",6) == 3060869696) strcat(s, "n");
if (crc32("XjRLudFzqadkwXE",15) == 4293660264) strcat(s, "Y");
if (crc32("aNLQT",5) == 2946304946) strcat(s, "c");
if (crc32("VVvfpkK",7) == 3041986527) strcat(s, "L");
if (crc32("RIefHaJekGK",11) == 2580107671) strcat(s, "r");
if (crc32("nGYdfl",6) == 3885467990) strcat(s, "u");
if (crc32("HOZYtYBomXfPKbT",15) == 891226028) strcat(s, "c");
if (crc32("hyGqLlwBgU",10) == 2230223068) strcat(s, "i");
if (crc32("APKzpFnRG",9) == 1827962179) strcat(s, "h");
if (crc32("CODAsxikttX",11) == 305825739) strcat(s, "a");
if (crc32("nrmuCF",6) == 131748886) strcat(s, "F");
if (crc32("XSoeQDdGwma",11) == 541749741) strcat(s, "l");
    return s;
}

char *quasithorough_adjectives() {
    char *s = calloc(14);
    if (crc32("YpfWnstg",8) == 2261277783) strcat(s, "T");
if (crc32("BkHxWjzzGem",11) == 1895473070) strcat(s, "q");
if (crc32("dxHtNFWJXwsJVK",14) == 1898488049) strcat(s, "D");
if (crc32("afThpnjkPcpJF",13) == 3108390817) strcat(s, "u");
if (crc32("mDQLfCJlOVeSiiS",15) == 1437946239) strcat(s, "W");
if (crc32("fDKkDaBFwIUBUNM",15) == 1731346219) strcat(s, "a");
if (crc32("VJxszm",6) == 1740232770) strcat(s, "s");
if (crc32("udCaSKeUBfSYsSv",15) == 785041371) strcat(s, "Z");
if (crc32("AYYlOzufAuh",11) == 923400161) strcat(s, "i");
if (crc32("ckeMaqt",7) == 2514315264) strcat(s, "Q");
if (crc32("wrpzwxz",7) == 160507951) strcat(s, "t");
if (crc32("mqzPO",5) == 1277146295) strcat(s, "d");
if (crc32("zDQmzKcWuxafxN",14) == 2264682867) strcat(s, "h");
if (crc32("JKLhqsloYYjVQHA",15) == 1770137919) strcat(s, "Z");
if (crc32("EZTrgwwpMku",11) == 96104010) strcat(s, "o");
if (crc32("NQOvFU",6) == 3497624963) strcat(s, "V");
if (crc32("tqmmwmn",7) == 3325840992) strcat(s, "r");
if (crc32("iGJMvrKdgJpPsz",14) == 1857650388) strcat(s, "o");
if (crc32("QpuSQZcWYKjaFKn",15) == 2242976106) strcat(s, "u");
if (crc32("HHqDDhRnpaoit",13) == 620423607) strcat(s, "v");
if (crc32("QJjPREOeoH",10) == 1514330354) strcat(s, "g");
if (crc32("qdhjZYqo",8) == 2803021292) strcat(s, "C");
if (crc32("lHLDeaNmcNfxvxa",15) == 1315445531) strcat(s, "h");
    return s;
}

char *tressiest_adjectives() {
    char *s = calloc(10);
    if (crc32("UKuupheSYREgNx",14) == 942352896) strcat(s, "t");
if (crc32("PrFEFEVetMIzTuS",15) == 3345752281) strcat(s, "S");
if (crc32("aQWpGIuvSUlNSY",14) == 903347752) strcat(s, "r");
if (crc32("WjykfLtVb",9) == 3046495493) strcat(s, "f");
if (crc32("vkIcZIKpi",9) == 1155751348) strcat(s, "e");
if (crc32("wHmCRfU",7) == 4164251249) strcat(s, "s");
if (crc32("jyhiqmIoWsuDo",13) == 2398714653) strcat(s, "c");
if (crc32("hscYUmEGKuoKStX",15) == 1319227014) strcat(s, "s");
if (crc32("pxlUnCbnMrVMM",13) == 601661023) strcat(s, "E");
if (crc32("hlqmkHsaQrLTGwW",15) == 4238640682) strcat(s, "i");
if (crc32("PUUBAq",6) == 2189893206) strcat(s, "d");
if (crc32("aNcvrW",6) == 71305304) strcat(s, "e");
if (crc32("KOtYNROAXvstiV",14) == 658482440) strcat(s, "e");
if (crc32("HeVxSxF",7) == 3184152355) strcat(s, "s");
if (crc32("pBuSUBzAfT",10) == 1352763878) strcat(s, "k");
if (crc32("zQHwXSddUvrPy",13) == 3557853680) strcat(s, "t");
    return s;
}

char *brassbound_adjectives() {
    char *s = calloc(11);
    if (crc32("HgtSQVktXJeKEr",14) == 1691161173) strcat(s, "x");
if (crc32("TXXDQkd",7) == 395739274) strcat(s, "b");
if (crc32("WcBBFVRyMa",10) == 1318375052) strcat(s, "r");
if (crc32("qQBfaLfkEnPuGJ",14) == 1865952380) strcat(s, "L");
if (crc32("SzmVLwBnuvMpc",13) == 3657104384) strcat(s, "a");
if (crc32("buXkSUvvcPE",11) == 3077607993) strcat(s, "s");
if (crc32("mzxOTevibMesgU",14) == 2724136515) strcat(s, "y");
if (crc32("rpVMbiUzAnSStNd",15) == 3045986041) strcat(s, "s");
if (crc32("tpItoyqxUBRClB",14) == 2214441947) strcat(s, "C");
if (crc32("FQZPPToKjaIf",12) == 218557832) strcat(s, "b");
if (crc32("mxsnRRgIQMaiy",13) == 3219488577) strcat(s, "x");
if (crc32("rsbgarjZ",8) == 4172976545) strcat(s, "o");
if (crc32("YpwnyItSEbKGYDR",15) == 1516761696) strcat(s, "u");
if (crc32("AVEWYWotuUfipVZ",15) == 1977579964) strcat(s, "p");
if (crc32("XNNcvcjYeZdFktJ",15) == 2494283990) strcat(s, "n");
if (crc32("UzVJh",5) == 329116601) strcat(s, "d");
    return s;
}

char *omnipresent_adjectives() {
    char *s = calloc(12);
    if (crc32("wkuImbtJFHwDkIP",15) == 3151818548) strcat(s, "D");
if (crc32("Azvbi",5) == 2498363943) strcat(s, "o");
if (crc32("NBZqBSVyx",9) == 1317285616) strcat(s, "J");
if (crc32("TuiFUH",6) == 2585636277) strcat(s, "m");
if (crc32("qWjgzSLfoYZL",12) == 355190528) strcat(s, "n");
if (crc32("nSLSOVOgmvpV",12) == 3803329145) strcat(s, "p");
if (crc32("vrZTkhLU",8) == 4181887758) strcat(s, "i");
if (crc32("fKCoDaaRZBTjFci",15) == 3039578001) strcat(s, "p");
if (crc32("zqKrSvJDY",9) == 3474655100) strcat(s, "e");
if (crc32("fZjCBvZ",7) == 66660923) strcat(s, "r");
if (crc32("dDfQBrHX",8) == 1633753661) strcat(s, "e");
if (crc32("oImbK",5) == 3449211256) strcat(s, "s");
if (crc32("bAmxnzikYjgxT",13) == 3322932465) strcat(s, "e");
if (crc32("ekgSKoMJiyW",11) == 3669912531) strcat(s, "m");
if (crc32("rDQkiuRwy",9) == 2621880213) strcat(s, "n");
if (crc32("rSafELkNMbA",11) == 396674149) strcat(s, "t");
    return s;
}

char *unbenevolent_adjectives() {
    char *s = calloc(13);
    if (crc32("qWMVGHQ",7) == 3655651074) strcat(s, "u");
if (crc32("nnEQNclaFBUou",13) == 1116918237) strcat(s, "n");
if (crc32("HzphpJoT",8) == 3669498995) strcat(s, "B");
if (crc32("ZzfQC",5) == 2955717410) strcat(s, "b");
if (crc32("qmNxQcLStPApUNr",15) == 4128414987) strcat(s, "e");
if (crc32("cLfpNpBHVoC",11) == 3665171851) strcat(s, "t");
if (crc32("hFvMDk",6) == 4206187135) strcat(s, "n");
if (crc32("VAQzKZIHfY",10) == 3698970996) strcat(s, "D");
if (crc32("aBciwKRYh",9) == 331569785) strcat(s, "e");
if (crc32("crqQufKoNTn",11) == 2133894555) strcat(s, "L");
if (crc32("rhSIQaVTMXeTAh",14) == 1196715061) strcat(s, "v");
if (crc32("eUIDaHdHhJRSPE",14) == 3904861880) strcat(s, "o");
if (crc32("cyAXDaSJDUqHrf",14) == 3803071185) strcat(s, "o");
if (crc32("geFXYN",6) == 3783470926) strcat(s, "N");
if (crc32("ilyUVerQTaDCy",13) == 2674463643) strcat(s, "l");
if (crc32("ROtxfm",6) == 2486966304) strcat(s, "e");
if (crc32("YwTeeGJgj",9) == 553533966) strcat(s, "O");
if (crc32("ZANhIMOczlO",11) == 1922568200) strcat(s, "n");
if (crc32("SqQXISpgWIpw",12) == 1557159413) strcat(s, "t");
    return s;
}

char *impenetrable_adjectives() {
    char *s = calloc(13);
    if (crc32("XkmAXmc",7) == 3695832935) strcat(s, "r");
if (crc32("tNSdna",6) == 2434784267) strcat(s, "i");
if (crc32("thONLMsnkqIoaw",14) == 2325487961) strcat(s, "h");
if (crc32("OUAXSIhFQP",10) == 3695445727) strcat(s, "m");
if (crc32("ymbwKtHyieeKvm",14) == 1826951010) strcat(s, "M");
if (crc32("aDHxvXdRYjR",11) == 1824172817) strcat(s, "p");
if (crc32("SQjJKIIk",8) == 4256161123) strcat(s, "I");
if (crc32("cBNvhiNpIu",10) == 3304744928) strcat(s, "e");
if (crc32("UySsEMQ",7) == 3917471759) strcat(s, "n");
if (crc32("moDqDKQ",7) == 2284692500) strcat(s, "e");
if (crc32("LZcHpSVZxt",10) == 3802324463) strcat(s, "t");
if (crc32("iUtTYQcNqG",10) == 2865023708) strcat(s, "r");
if (crc32("lcEgU",5) == 4104069772) strcat(s, "a");
if (crc32("ZKvjpO",6) == 2154005129) strcat(s, "B");
if (crc32("FmvlattTWqippV",14) == 3063766220) strcat(s, "b");
if (crc32("GDFVp",5) == 1018406741) strcat(s, "t");
if (crc32("UpLzLtNXg",9) == 4183863619) strcat(s, "l");
if (crc32("PLzTbLJ",7) == 2000071469) strcat(s, "x");
if (crc32("PemCHrDHA",9) == 2292204648) strcat(s, "e");
    return s;
}

char *Ertebolle_adjectives() {
    char *s = calloc(10);
    if (crc32("pFlfYZ",6) == 2956894293) strcat(s, "E");
if (crc32("nUzJO",5) == 2841696169) strcat(s, "r");
if (crc32("YGwiO",5) == 4127246361) strcat(s, "t");
if (crc32("wXVZqNEQk",9) == 1803705580) strcat(s, "d");
if (crc32("sHUoOnOQPh",10) == 1951530779) strcat(s, "e");
if (crc32("sEDitnNJ",8) == 264394086) strcat(s, "b");
if (crc32("SyiNOd",6) == 3457070988) strcat(s, "o");
if (crc32("ITThRoVYRc",10) == 1287104717) strcat(s, "l");
if (crc32("vZjjIT",6) == 363331724) strcat(s, "u");
if (crc32("NPAZPAFtbqhJpjf",15) == 64826625) strcat(s, "l");
if (crc32("tZzECtJLTWDU",12) == 2644215955) strcat(s, "e");
    return s;
}

char *monic_adjectives() {
    char *s = calloc(6);
    if (crc32("Newbm",5) == 409959441) strcat(s, "m");
if (crc32("ZWGTb",5) == 3940881421) strcat(s, "o");
if (crc32("aJjCSTJKBs",10) == 2437435372) strcat(s, "l");
if (crc32("QdfbAkNP",8) == 3702760523) strcat(s, "n");
if (crc32("tzpDaxYGst",10) == 4279367593) strcat(s, "i");
if (crc32("xmtPrEV",7) == 4043512212) strcat(s, "Q");
if (crc32("mSMyJgydKFPMSx",14) == 3324522437) strcat(s, "c");
    return s;
}

char *unacclaimed_adjectives() {
    char *s = calloc(12);
    if (crc32("YNQeCrGzcUlCm",13) == 2137251632) strcat(s, "u");
if (crc32("AzxxL",5) == 1810156077) strcat(s, "O");
if (crc32("jbNFfyGWuPpPXt",14) == 49764026) strcat(s, "n");
if (crc32("qkgUIZwPSbFcnP",14) == 390207333) strcat(s, "a");
if (crc32("oLFXdXTfp",9) == 2531632083) strcat(s, "Z");
if (crc32("KKcrvJf",7) == 1600132824) strcat(s, "c");
if (crc32("srxwndjRmh",10) == 967547550) strcat(s, "A");
if (crc32("hXzdHAvv",8) == 1608950209) strcat(s, "c");
if (crc32("yMVtAm",6) == 1517523457) strcat(s, "l");
if (crc32("eHRlWNUjWAplzi",14) == 1946755690) strcat(s, "a");
if (crc32("wrCMvoS",7) == 392733220) strcat(s, "w");
if (crc32("HOdSfgqg",8) == 2011706048) strcat(s, "i");
if (crc32("qofUCMNCGx",10) == 3756818408) strcat(s, "m");
if (crc32("oIrXMoqnkTRUdE",14) == 3422501086) strcat(s, "e");
if (crc32("hyAckocCYT",10) == 129157878) strcat(s, "d");
    return s;
}

char *unawed_adjectives() {
    char *s = calloc(7);
    if (crc32("FHiJT",5) == 1856497899) strcat(s, "u");
if (crc32("fiJShIpAI",9) == 2174045358) strcat(s, "I");
if (crc32("VlmBY",5) == 2423658857) strcat(s, "n");
if (crc32("sagQfdVVwMNpEtq",15) == 1182011169) strcat(s, "l");
if (crc32("SkqgTe",6) == 2821622397) strcat(s, "a");
if (crc32("Buwsvgl",7) == 678533720) strcat(s, "V");
if (crc32("aMlmN",5) == 200565305) strcat(s, "w");
if (crc32("sDUEvcyW",8) == 887020252) strcat(s, "e");
if (crc32("IorIllu",7) == 2025415967) strcat(s, "d");
    return s;
}

char *subpharyngeal_adjectives() {
    char *s = calloc(14);
    if (crc32("pwlNsvFEu",9) == 3550496702) strcat(s, "r");
if (crc32("tyFDaGqBw",9) == 2965893619) strcat(s, "s");
if (crc32("XzIRHIlPuQ",10) == 828525839) strcat(s, "J");
if (crc32("YYVvbuxq",8) == 917651970) strcat(s, "u");
if (crc32("hzoCqbDXy",9) == 2980393899) strcat(s, "b");
if (crc32("YPxVKokc",8) == 3994422075) strcat(s, "E");
if (crc32("tHVzuTJzN",9) == 392605618) strcat(s, "p");
if (crc32("kWDvqvEMB",9) == 2788527647) strcat(s, "S");
if (crc32("ZZgZeRmWJoQaGHY",15) == 3236578096) strcat(s, "h");
if (crc32("yvubYweZoaZPddX",15) == 1066496464) strcat(s, "a");
if (crc32("pEakbgZQozJIqx",14) == 1593316930) strcat(s, "r");
if (crc32("KajiW",5) == 1860916332) strcat(s, "y");
if (crc32("NMWBI",5) == 34870804) strcat(s, "N");
if (crc32("koYzdpSfG",9) == 2674442985) strcat(s, "n");
if (crc32("zOqqdP",6) == 3020534318) strcat(s, "T");
if (crc32("knlfbLjlrooX",12) == 632679320) strcat(s, "g");
if (crc32("hzbDq",5) == 2477154188) strcat(s, "e");
if (crc32("PRpgItm",7) == 2814879512) strcat(s, "a");
if (crc32("hPLfU",5) == 2729631110) strcat(s, "X");
if (crc32("VBzrq",5) == 587328152) strcat(s, "l");
    return s;
}

char *unambulant_adjectives() {
    char *s = calloc(11);
    if (crc32("IiDqbOHIQ",9) == 1216196732) strcat(s, "u");
if (crc32("gaSxgQau",8) == 1181988005) strcat(s, "n");
if (crc32("KgPBhPUpMyeRzT",14) == 809082276) strcat(s, "e");
if (crc32("okquwfPC",8) == 4224231027) strcat(s, "a");
if (crc32("byALTQqX",8) == 298117746) strcat(s, "J");
if (crc32("QVgrfP",6) == 1745596107) strcat(s, "m");
if (crc32("RyVsRBXunJf",11) == 751359809) strcat(s, "b");
if (crc32("ojtKdh",6) == 1099456995) strcat(s, "u");
if (crc32("plzFZlXK",8) == 2235420807) strcat(s, "l");
if (crc32("YjZCZvdiGEsv",12) == 2695545585) strcat(s, "l");
if (crc32("HQbgISyX",8) == 1736277273) strcat(s, "a");
if (crc32("sPVolTBYqBGvGd",14) == 651167202) strcat(s, "n");
if (crc32("OTOnLVVMtqifI",13) == 921831487) strcat(s, "m");
if (crc32("HyUaEYus",8) == 1247298677) strcat(s, "t");
    return s;
}

char *chivalric_adjectives() {
    char *s = calloc(10);
    if (crc32("mbMhrzYmmO",10) == 1100489414) strcat(s, "a");
if (crc32("bIFFGuNIVBLgH",13) == 2921156284) strcat(s, "c");
if (crc32("fyksa",5) == 4218372034) strcat(s, "Y");
if (crc32("MRdzuaY",7) == 2913856067) strcat(s, "h");
if (crc32("bwfEEE",6) == 1501863687) strcat(s, "m");
if (crc32("MoKuvJtphYhA",12) == 410922752) strcat(s, "i");
if (crc32("YtzDy",5) == 2026563972) strcat(s, "z");
if (crc32("ZFQWeBo",7) == 3242133779) strcat(s, "v");
if (crc32("biVGkU",6) == 1718077154) strcat(s, "a");
if (crc32("HBJMWi",6) == 1032164910) strcat(s, "l");
if (crc32("pzGEL",5) == 3166927508) strcat(s, "r");
if (crc32("wkvgcQtfB",9) == 816682471) strcat(s, "i");
if (crc32("pnlUzxMJOityQli",15) == 2812998209) strcat(s, "i");
if (crc32("qZTtunP",7) == 2441596118) strcat(s, "c");
    return s;
}

char *interpretational_adjectives() {
    char *s = calloc(17);
    if (crc32("rVLVgKeUviPOzzj",15) == 306503102) strcat(s, "L");
if (crc32("YHZRBvihiGHYfY",14) == 4261976019) strcat(s, "i");
if (crc32("VkExpiAaazKhhEM",15) == 2846317518) strcat(s, "n");
if (crc32("tikuGdky",8) == 3873087903) strcat(s, "t");
if (crc32("lwbRDRgSv",9) == 754450954) strcat(s, "x");
if (crc32("tGyPWNZJfOt",11) == 1774553191) strcat(s, "e");
if (crc32("rVAsRyDPO",9) == 3144700906) strcat(s, "r");
if (crc32("znksWj",6) == 3025723771) strcat(s, "u");
if (crc32("SgmAdXWO",8) == 3826367636) strcat(s, "p");
if (crc32("XfpamCdvracmulb",15) == 4193070551) strcat(s, "r");
if (crc32("OMggwJTdJ",9) == 1294747146) strcat(s, "e");
if (crc32("MnCPDAEhVEAYEK",14) == 221502430) strcat(s, "t");
if (crc32("nXzFJyJ",7) == 3202154484) strcat(s, "a");
if (crc32("zJonoLyA",8) == 2190093549) strcat(s, "t");
if (crc32("nJVwVwbknVDUom",14) == 2812678693) strcat(s, "l");
if (crc32("QyzNf",5) == 1177269520) strcat(s, "i");
if (crc32("TijEOIFmlIgeH",13) == 2329346157) strcat(s, "o");
if (crc32("xNpZRETQAzfKLH",14) == 3182977035) strcat(s, "n");
if (crc32("jiOXTOKCVKXM",12) == 3310857548) strcat(s, "a");
if (crc32("ZaPpvoBzsZnUijL",15) == 4108487215) strcat(s, "l");
    return s;
}

char *floppiest_adjectives() {
    char *s = calloc(10);
    if (crc32("ejcGyfjRPfTfqnj",15) == 522318313) strcat(s, "Z");
if (crc32("jRhfr",5) == 3217824113) strcat(s, "f");
if (crc32("VRTjhDZ",7) == 1548254224) strcat(s, "l");
if (crc32("ZjweUJlh",8) == 3255360719) strcat(s, "o");
if (crc32("XroMxYZkLL",10) == 2867660692) strcat(s, "p");
if (crc32("zscyOqkXbCLOGGq",15) == 2023689772) strcat(s, "z");
if (crc32("bazQFf",6) == 1000503710) strcat(s, "p");
if (crc32("BdtjXdIaWE",10) == 2318461961) strcat(s, "Y");
if (crc32("imKuC",5) == 1511928391) strcat(s, "i");
if (crc32("MYqrDfOu",8) == 758736763) strcat(s, "e");
if (crc32("DJfQziMnccWPiDN",15) == 2075405791) strcat(s, "O");
if (crc32("pBjyTVlsH",9) == 1624552943) strcat(s, "s");
if (crc32("MOcjG",5) == 751815705) strcat(s, "X");
if (crc32("aMYRjbu",7) == 1703422318) strcat(s, "t");
    return s;
}

char *ichthyosaurian_adjectives() {
    char *s = calloc(15);
    if (crc32("GLsjd",5) == 1039611735) strcat(s, "V");
if (crc32("tfvMFrALrSM",11) == 3544874168) strcat(s, "i");
if (crc32("GHBoeUcYU",9) == 459033429) strcat(s, "c");
if (crc32("iiQPB",5) == 1530487751) strcat(s, "h");
if (crc32("LAvpISChDb",10) == 2275072417) strcat(s, "t");
if (crc32("MBFLyBEgUdzcxo",14) == 1752730363) strcat(s, "h");
if (crc32("uYzgdmJQKMP",11) == 3863108854) strcat(s, "y");
if (crc32("IsmikNgShKC",11) == 3451266106) strcat(s, "K");
if (crc32("aRbpUtBgNpLhzB",14) == 1386945254) strcat(s, "o");
if (crc32("agHHJUexNXcJm",13) == 750375969) strcat(s, "m");
if (crc32("tUmmFHcsHhcA",12) == 590237702) strcat(s, "s");
if (crc32("SOXxoyn",7) == 4113820696) strcat(s, "W");
if (crc32("YAQPyuhbyoGo",12) == 3570849520) strcat(s, "a");
if (crc32("YaduFlJFpi",10) == 424582082) strcat(s, "u");
if (crc32("VrIoRi",6) == 4050879590) strcat(s, "r");
if (crc32("PQPoxDSinvG",11) == 2670806290) strcat(s, "i");
if (crc32("KvALO",5) == 2953761383) strcat(s, "B");
if (crc32("AlTzGRRfyxG",11) == 1841212530) strcat(s, "a");
if (crc32("wwJGYBVAYk",10) == 275664019) strcat(s, "w");
if (crc32("OYbPXkqEewJyn",13) == 1521889821) strcat(s, "n");
    return s;
}

char *tortious_adjectives() {
    char *s = calloc(9);
    if (crc32("zSOyZAloPQPg",12) == 3935658376) strcat(s, "t");
if (crc32("jbsmFH",6) == 4128418870) strcat(s, "l");
if (crc32("jsDjnLeySQrD",12) == 2988642801) strcat(s, "o");
if (crc32("QMWPjvFlnMuoFo",14) == 1034562280) strcat(s, "r");
if (crc32("zfzoNVRU",8) == 2172191348) strcat(s, "r");
if (crc32("bmgtSPqcQGBh",12) == 3680148243) strcat(s, "t");
if (crc32("SkLmAQ",6) == 188592091) strcat(s, "j");
if (crc32("zhDzkNNYyhD",11) == 1631896246) strcat(s, "i");
if (crc32("qyjNSBMZgnTfj",13) == 2414299368) strcat(s, "b");
if (crc32("gXsUTkEsfY",10) == 3902378936) strcat(s, "o");
if (crc32("POorywCKJsf",11) == 67264421) strcat(s, "P");
if (crc32("YuGeikKPaf",10) == 3756956689) strcat(s, "u");
if (crc32("kdrWdCExTqDh",12) == 4197004800) strcat(s, "A");
if (crc32("ybNaLwcquzTJAPN",15) == 2220218167) strcat(s, "s");
    return s;
}

char *semielliptical_adjectives() {
    char *s = calloc(15);
    if (crc32("JdGmyTvWin",10) == 2055776160) strcat(s, "s");
if (crc32("uDMiZWhTttS",11) == 34660792) strcat(s, "e");
if (crc32("QLhLKyjbWJE",11) == 261225913) strcat(s, "m");
if (crc32("rEquDmOAdpByTjO",15) == 2467795427) strcat(s, "m");
if (crc32("IqEGbDdWhW",10) == 3959372213) strcat(s, "i");
if (crc32("eXyqxiiXyzJM",12) == 3412372110) strcat(s, "J");
if (crc32("ETGKcz",6) == 2814964116) strcat(s, "e");
if (crc32("nFcNsb",6) == 2896121533) strcat(s, "C");
if (crc32("OOoyueaWUt",10) == 2379943754) strcat(s, "l");
if (crc32("saLhjOXiCnQ",11) == 58794510) strcat(s, "l");
if (crc32("rAnvbtUWIksHdnh",15) == 2429699969) strcat(s, "L");
if (crc32("vKVEVndMLHEOsr",14) == 3251729140) strcat(s, "i");
if (crc32("KsalQshJfCoU",12) == 2156881551) strcat(s, "h");
if (crc32("CouHPmamsFjcOR",14) == 1091638521) strcat(s, "p");
if (crc32("FlgEUXkjxglfsOk",15) == 1970847531) strcat(s, "Q");
if (crc32("soEEvRkwhn",10) == 796876703) strcat(s, "t");
if (crc32("RcjkMpqcGFBxBo",14) == 3848778476) strcat(s, "i");
if (crc32("iHgZaE",6) == 1261463452) strcat(s, "c");
if (crc32("nXvlUFaPx",9) == 3097362091) strcat(s, "T");
if (crc32("JEFQECvNn",9) == 2717896819) strcat(s, "a");
if (crc32("PHlRkyPMASDmWzL",15) == 2704420593) strcat(s, "H");
if (crc32("GZEajirBWHoOQ",13) == 1139261068) strcat(s, "l");
    return s;
}

char *nonrepentant_adjectives() {
    char *s = calloc(13);
    if (crc32("JfOKLzShWuBX",12) == 2633724801) strcat(s, "n");
if (crc32("EPLzAiYtMGfAU",13) == 3599067280) strcat(s, "c");
if (crc32("ETtFSokyr",9) == 2059671219) strcat(s, "o");
if (crc32("UAyqGqu",7) == 1572390061) strcat(s, "G");
if (crc32("QWFZheXBKm",10) == 593777902) strcat(s, "n");
if (crc32("RshnvYTyAmdD",12) == 2200399293) strcat(s, "z");
if (crc32("NEhjP",5) == 1066856827) strcat(s, "r");
if (crc32("JJEWbXGm",8) == 2535008216) strcat(s, "e");
if (crc32("CtDhdfvw",8) == 2827384704) strcat(s, "p");
if (crc32("SufPNSwuErsQK",13) == 4232966823) strcat(s, "e");
if (crc32("ehtsD",5) == 4251926346) strcat(s, "Z");
if (crc32("hudvsFpS",8) == 3981132912) strcat(s, "n");
if (crc32("RKrNarcIMEoE",12) == 392054003) strcat(s, "u");
if (crc32("TDSpwwgBq",9) == 1756373850) strcat(s, "t");
if (crc32("xjXXUPgEXNTEsM",14) == 470166317) strcat(s, "a");
if (crc32("xkRzAcsoAphMmNf",15) == 334443307) strcat(s, "u");
if (crc32("ahiczNuN",8) == 2381918167) strcat(s, "n");
if (crc32("xrXrg",5) == 816588628) strcat(s, "j");
if (crc32("rSFsVakbYmiB",12) == 3990643835) strcat(s, "t");
    return s;
}

char *gushy_adjectives() {
    char *s = calloc(6);
    if (crc32("byhfjFLGm",9) == 3643867516) strcat(s, "g");
if (crc32("dlWAueFSwW",10) == 1938285311) strcat(s, "u");
if (crc32("nLNkvmHJILZ",11) == 2041828204) strcat(s, "s");
if (crc32("WNZocmZenhwxxL",14) == 3839364592) strcat(s, "h");
if (crc32("HnRKEgB",7) == 2165138388) strcat(s, "z");
if (crc32("zJoNmiEJXnDfPZ",14) == 1256236661) strcat(s, "y");
    return s;
}

char *gemmuliferous_adjectives() {
    char *s = calloc(14);
    if (crc32("ZBnSrGjRHk",10) == 3555891708) strcat(s, "B");
if (crc32("YNghIxBxcgwQ",12) == 4039631958) strcat(s, "g");
if (crc32("fcufoTy",7) == 378543894) strcat(s, "c");
if (crc32("tDciznJipPZOv",13) == 1351044915) strcat(s, "e");
if (crc32("SMaMUYakWNckqg",14) == 1312116818) strcat(s, "X");
if (crc32("nrVUQVy",7) == 3821663802) strcat(s, "m");
if (crc32("cKoDbFxSjmTwa",13) == 1814834843) strcat(s, "q");
if (crc32("qvsfgeUUANA",11) == 1957116159) strcat(s, "m");
if (crc32("jqkLEjw",7) == 1792449521) strcat(s, "u");
if (crc32("CxqWeQplD",9) == 3948682001) strcat(s, "l");
if (crc32("wtkkzONUZg",10) == 2488887576) strcat(s, "S");
if (crc32("bWjhVSweFHe",11) == 248418178) strcat(s, "i");
if (crc32("oyKHPgBow",9) == 2989732810) strcat(s, "f");
if (crc32("JnhzJzlYklV",11) == 3852615935) strcat(s, "e");
if (crc32("RzPuJ",5) == 1818916032) strcat(s, "Y");
if (crc32("DfYQXjbx",8) == 1284328565) strcat(s, "r");
if (crc32("BitefXwQd",9) == 970849359) strcat(s, "o");
if (crc32("ILBRryHMZDD",11) == 1805092319) strcat(s, "Y");
if (crc32("gcXZOmfvb",9) == 3089914378) strcat(s, "u");
if (crc32("eveCHeRxfUiybBQ",15) == 1005752672) strcat(s, "s");
    return s;
}

char *unregularised_adjectives() {
    char *s = calloc(14);
    if (crc32("nETCVbGNeUsV",12) == 3491929035) strcat(s, "u");
if (crc32("NpHuOKZreMDf",12) == 1296461028) strcat(s, "V");
if (crc32("aTcJmU",6) == 540406845) strcat(s, "n");
if (crc32("DlMgfNBZe",9) == 2973043790) strcat(s, "r");
if (crc32("yfCGfauLLs",10) == 709822156) strcat(s, "e");
if (crc32("JdbQfKFBFvrsY",13) == 460244148) strcat(s, "g");
if (crc32("ebRTKb",6) == 2961820824) strcat(s, "u");
if (crc32("zlpDryUmNKfakb",14) == 1818669007) strcat(s, "b");
if (crc32("aEmmezUH",8) == 1355612398) strcat(s, "l");
if (crc32("JrISAdBMmTtJZPZ",15) == 1480992777) strcat(s, "a");
if (crc32("YxbDuTO",7) == 1364883739) strcat(s, "r");
if (crc32("KKmzkQaD",8) == 3705614161) strcat(s, "i");
if (crc32("ydrRuVaKk",9) == 2343901015) strcat(s, "s");
if (crc32("tNSBuZEG",8) == 2841226220) strcat(s, "e");
if (crc32("pIWxBUzPqNN",11) == 2879525758) strcat(s, "S");
if (crc32("wTZQbrLPqrTsa",13) == 2014986545) strcat(s, "d");
    return s;
}

char *preexclusive_adjectives() {
    char *s = calloc(13);
    if (crc32("ZfcdYh",6) == 1459260949) strcat(s, "f");
if (crc32("SUgZzmny",8) == 1042191086) strcat(s, "p");
if (crc32("GrRgAlYz",8) == 4236185482) strcat(s, "Y");
if (crc32("EkScRxJbKAZn",12) == 3314233667) strcat(s, "r");
if (crc32("jfjUUYMTOMxug",13) == 545063382) strcat(s, "m");
if (crc32("ekyxPQXh",8) == 107998141) strcat(s, "e");
if (crc32("vsRaRf",6) == 2913652320) strcat(s, "N");
if (crc32("bvTIiaGcUk",10) == 1871302561) strcat(s, "e");
if (crc32("ZflwLMkoZEsnl",13) == 2015102122) strcat(s, "x");
if (crc32("SukbALrJMxwq",12) == 2718089288) strcat(s, "c");
if (crc32("sYJbz",5) == 1413723195) strcat(s, "l");
if (crc32("aSoYfidY",8) == 3985802192) strcat(s, "u");
if (crc32("CcWuurVgDN",10) == 1814571127) strcat(s, "s");
if (crc32("LORkVFo",7) == 1719237642) strcat(s, "F");
if (crc32("ghUBee",6) == 2817396422) strcat(s, "i");
if (crc32("vUkJDJMCFBS",11) == 926509820) strcat(s, "v");
if (crc32("kdbPgoFGVjnD",12) == 3501415238) strcat(s, "e");
    return s;
}

char *catatonic_adjectives() {
    char *s = calloc(10);
    if (crc32("fFsDpWREIfF",11) == 3826445180) strcat(s, "c");
if (crc32("WNtGiT",6) == 1639489828) strcat(s, "O");
if (crc32("kJlzQt",6) == 502031071) strcat(s, "a");
if (crc32("DdFEFOJOS",9) == 4050099537) strcat(s, "D");
if (crc32("UccslmQQB",9) == 1958880100) strcat(s, "t");
if (crc32("XqFGqht",7) == 858209610) strcat(s, "a");
if (crc32("gxnvhEmT",8) == 4213517472) strcat(s, "K");
if (crc32("ihNmxPJQKz",10) == 442313695) strcat(s, "t");
if (crc32("DePleb",6) == 256809786) strcat(s, "E");
if (crc32("qUHrNdFsayCgwxM",15) == 826132126) strcat(s, "o");
if (crc32("owcmjFAzljNBD",13) == 886262718) strcat(s, "n");
if (crc32("nITTJE",6) == 1759519961) strcat(s, "o");
if (crc32("qPwDRgEraRcJfiX",15) == 158167543) strcat(s, "i");
if (crc32("KzGgsQhYIviMEME",15) == 3265961549) strcat(s, "x");
if (crc32("kGttO",5) == 3503026618) strcat(s, "c");
    return s;
}

char *incongruent_adjectives() {
    char *s = calloc(12);
    if (crc32("pCoSRACo",8) == 2592641036) strcat(s, "P");
if (crc32("GdcWcmCzIhacE",13) == 762866686) strcat(s, "i");
if (crc32("nNjqqIFJvcja",12) == 3302774872) strcat(s, "n");
if (crc32("gNchmB",6) == 4248359495) strcat(s, "o");
if (crc32("XURZbybMATCvioI",15) == 3323975238) strcat(s, "c");
if (crc32("NlGYMeZNm",9) == 1299784902) strcat(s, "o");
if (crc32("lxoPTOmPl",9) == 6104502) strcat(s, "w");
if (crc32("ANSLElswpcJQAqA",15) == 3925527985) strcat(s, "n");
if (crc32("ctejEhrZWlzFM",13) == 826642631) strcat(s, "g");
if (crc32("lIxCRgUVBOYJMcU",15) == 3778798250) strcat(s, "r");
if (crc32("niyvMvuTAWNR",12) == 3034798531) strcat(s, "t");
if (crc32("cGktNiCPVXu",11) == 4250312831) strcat(s, "u");
if (crc32("xocThfPkqVvBt",13) == 1476939678) strcat(s, "M");
if (crc32("tbmtGusvele",11) == 3853629220) strcat(s, "e");
if (crc32("ginHqICARRuLAh",14) == 3188632942) strcat(s, "n");
if (crc32("fiTQhO",6) == 2547373733) strcat(s, "D");
if (crc32("aGjLkDXKGg",10) == 1946461133) strcat(s, "t");
    return s;
}

char *unpretermitted_adjectives() {
    char *s = calloc(15);
    if (crc32("QQpNfAbOyvz",11) == 296453805) strcat(s, "p");
if (crc32("vixZHsrdL",9) == 3758203744) strcat(s, "u");
if (crc32("GPndpAdYOJQYkI",14) == 735457851) strcat(s, "C");
if (crc32("dWaAxhIQIk",10) == 3976368807) strcat(s, "n");
if (crc32("iQkuTZcoTkZNMi",14) == 1399852134) strcat(s, "p");
if (crc32("nogYYTRApR",10) == 2668187330) strcat(s, "r");
if (crc32("MkgdaIB",7) == 3047787184) strcat(s, "e");
if (crc32("lmuWdyQROUrx",12) == 2228258362) strcat(s, "Q");
if (crc32("HRVxbyupYGMXkvP",15) == 3609965674) strcat(s, "t");
if (crc32("VuobZFvUVbR",11) == 3699253310) strcat(s, "Q");
if (crc32("xLkoaLe",7) == 2681675493) strcat(s, "e");
if (crc32("sLWJvOekYaD",11) == 3179328867) strcat(s, "W");
if (crc32("QdDXUYFXgGMPcj",14) == 868098136) strcat(s, "r");
if (crc32("BNQdfiYn",8) == 1621482215) strcat(s, "N");
if (crc32("KLrgkHCQZMS",11) == 3470117560) strcat(s, "m");
if (crc32("PgnOuRtUvAV",11) == 1889503294) strcat(s, "i");
if (crc32("pyaOSIMk",8) == 3423855930) strcat(s, "i");
if (crc32("VAkzq",5) == 3834185273) strcat(s, "t");
if (crc32("WvURg",5) == 862534896) strcat(s, "t");
if (crc32("jUPcmrPFc",9) == 302343088) strcat(s, "c");
if (crc32("RmjaGBP",7) == 296035288) strcat(s, "e");
if (crc32("uCKHIo",6) == 2005649096) strcat(s, "L");
if (crc32("NArCJL",6) == 655706876) strcat(s, "d");
    return s;
}

char *uncomplaisant_adjectives() {
    char *s = calloc(14);
    if (crc32("aYaYqft",7) == 3095897254) strcat(s, "u");
if (crc32("kkkwdFvi",8) == 3314232951) strcat(s, "n");
if (crc32("tzFcE",5) == 1458875418) strcat(s, "C");
if (crc32("SrbJLVNnzXhJMu",14) == 2254052523) strcat(s, "c");
if (crc32("GqzJc",5) == 2378953412) strcat(s, "e");
if (crc32("hiMtWJPYkT",10) == 979533234) strcat(s, "o");
if (crc32("UiCpkou",7) == 832443363) strcat(s, "m");
if (crc32("ZvCoUFBgLTLVC",13) == 706360530) strcat(s, "p");
if (crc32("sGwFw",5) == 1198489423) strcat(s, "l");
if (crc32("NBItfV",6) == 64834580) strcat(s, "U");
if (crc32("niTJMe",6) == 1450438345) strcat(s, "a");
if (crc32("FMKOFdkDNz",10) == 902128907) strcat(s, "X");
if (crc32("AtnhxozBBRGjk",13) == 3004815101) strcat(s, "i");
if (crc32("eXPXjunZoLL",11) == 2990374272) strcat(s, "F");
if (crc32("zICmaflrO",9) == 1952937040) strcat(s, "s");
if (crc32("YURTdsJDW",9) == 3437720710) strcat(s, "K");
if (crc32("DhASJWNVX",9) == 3117616402) strcat(s, "a");
if (crc32("WcQFNqO",7) == 3828424789) strcat(s, "n");
if (crc32("wvuxoK",6) == 69694828) strcat(s, "u");
if (crc32("lBSWQdWvqDQsiG",14) == 598522774) strcat(s, "t");
    return s;
}

char *amphichroic_adjectives() {
    char *s = calloc(12);
    if (crc32("PahwAlpVQlnFy",13) == 2326349960) strcat(s, "a");
if (crc32("zAUiuCkGwa",10) == 1924578147) strcat(s, "n");
if (crc32("TEcQutZrQ",9) == 1617415283) strcat(s, "m");
if (crc32("MKWqNBsDhqPa",12) == 4047911910) strcat(s, "u");
if (crc32("uPbdZFpDxWaKTLE",15) == 3283975426) strcat(s, "p");
if (crc32("XPeNILsosVlyBid",15) == 1383864360) strcat(s, "h");
if (crc32("eShIfbWkeDGv",12) == 2012755550) strcat(s, "l");
if (crc32("hyyuOFFbbNFI",12) == 3474017164) strcat(s, "i");
if (crc32("dqWqZCGYwDJdG",13) == 4055119223) strcat(s, "H");
if (crc32("bZYWCkO",7) == 1564470902) strcat(s, "c");
if (crc32("iEYZsd",6) == 1883638901) strcat(s, "V");
if (crc32("uxGJmF",6) == 397217538) strcat(s, "h");
if (crc32("GHCkOzDfK",9) == 1631024273) strcat(s, "t");
if (crc32("ryvhBsFRZ",9) == 3435229045) strcat(s, "r");
if (crc32("xrfCyEUa",8) == 1031864946) strcat(s, "o");
if (crc32("TfEDqXTJuPNDv",13) == 2221704558) strcat(s, "i");
if (crc32("lbCteBFXIUzaWgT",15) == 2742112345) strcat(s, "q");
if (crc32("CtfRMK",6) == 3790627903) strcat(s, "c");
    return s;
}

char *despisable_adjectives() {
    char *s = calloc(11);
    if (crc32("yjFSgzm",7) == 505348819) strcat(s, "G");
if (crc32("djTqNxIjr",9) == 2790465692) strcat(s, "d");
if (crc32("vipuUZzEzsx",11) == 755663515) strcat(s, "B");
if (crc32("ZaIzOPxn",8) == 4111928710) strcat(s, "e");
if (crc32("HwsklgJVGUTYmkm",15) == 3783332240) strcat(s, "s");
if (crc32("kVZAOSablQxVx",13) == 277611815) strcat(s, "H");
if (crc32("dfeGpkgFJJ",10) == 2799807278) strcat(s, "p");
if (crc32("zlyTOHXfd",9) == 1979424298) strcat(s, "i");
if (crc32("vluwWoCjJ",9) == 3627169092) strcat(s, "s");
if (crc32("JUZjgoYYKiJQFh",14) == 1110085412) strcat(s, "F");
if (crc32("ofPVZbGivOu",11) == 4242537201) strcat(s, "a");
if (crc32("VhVwDbNsx",9) == 1803952069) strcat(s, "O");
if (crc32("WEtCYukVDCpOo",13) == 1540620220) strcat(s, "b");
if (crc32("jYDsN",5) == 1094761319) strcat(s, "l");
if (crc32("mrWkOfFUhSyKcK",14) == 2345095579) strcat(s, "e");
    return s;
}

char *rebuttable_adjectives() {
    char *s = calloc(11);
    if (crc32("xRuWURgyYQKqaM",14) == 1865381311) strcat(s, "r");
if (crc32("UtHlkvhSNXTLr",13) == 2106576026) strcat(s, "e");
if (crc32("jNUBknBHuZbZyM",14) == 1826899719) strcat(s, "b");
if (crc32("ckyTo",5) == 2892840388) strcat(s, "u");
if (crc32("umctIWQHIS",10) == 1677728763) strcat(s, "t");
if (crc32("pcCjoaxPHNJgbC",14) == 1327000828) strcat(s, "t");
if (crc32("uxItZvolugGP",12) == 1730745711) strcat(s, "a");
if (crc32("Ifmxxx",6) == 2775671852) strcat(s, "b");
if (crc32("hESnSCxdgoiocw",14) == 3106744553) strcat(s, "l");
if (crc32("xOaxYh",6) == 4256945409) strcat(s, "O");
if (crc32("OdYJnhzXhQ",10) == 1803537330) strcat(s, "e");
    return s;
}

char *clairvoyant_adjectives() {
    char *s = calloc(12);
    if (crc32("ddHPOHzGBh",10) == 357044698) strcat(s, "H");
if (crc32("OrnTXZzQtUaHeW",14) == 2422315127) strcat(s, "c");
if (crc32("FiMryXLsOVsQ",12) == 3975559132) strcat(s, "l");
if (crc32("pdzxqPN",7) == 2170814880) strcat(s, "a");
if (crc32("TQMZeEqHfzowHIi",15) == 3779524431) strcat(s, "e");
if (crc32("qZWnXWMGHZ",10) == 1548517212) strcat(s, "i");
if (crc32("vDyoZUaNhub",11) == 2707915341) strcat(s, "t");
if (crc32("GhNnDmW",7) == 2526186247) strcat(s, "r");
if (crc32("YpStb",5) == 504092244) strcat(s, "v");
if (crc32("ttSyMsjKhTNn",12) == 3889454959) strcat(s, "s");
if (crc32("aiNki",5) == 3963476531) strcat(s, "o");
if (crc32("gJNTutAeCRsEU",13) == 82118040) strcat(s, "y");
if (crc32("qqPUABBmauHven",14) == 3123187448) strcat(s, "a");
if (crc32("xrtKmuRg",8) == 517864585) strcat(s, "n");
if (crc32("bqWHvliCKbF",11) == 3477717546) strcat(s, "t");
    return s;
}

char *unascended_adjectives() {
    char *s = calloc(11);
    if (crc32("GiFFppd",7) == 4050653861) strcat(s, "c");
if (crc32("IfJcKe",6) == 529184467) strcat(s, "u");
if (crc32("YxLacDtHNb",10) == 3397533435) strcat(s, "n");
if (crc32("dzBHoSdRumPlUZ",14) == 60147088) strcat(s, "a");
if (crc32("UJOBjVKwywN",11) == 126191584) strcat(s, "s");
if (crc32("NVmEV",5) == 1431941371) strcat(s, "Y");
if (crc32("vzwKqbtyueADJ",13) == 1707688702) strcat(s, "c");
if (crc32("SGeTiFnAKSvyN",13) == 2396840994) strcat(s, "X");
if (crc32("HXSZIxU",7) == 1392170221) strcat(s, "e");
if (crc32("FjTsjX",6) == 558046201) strcat(s, "a");
if (crc32("epONtFjM",8) == 263817141) strcat(s, "n");
if (crc32("bZbhqdJZJMa",11) == 4160234498) strcat(s, "l");
if (crc32("rOnYKbpbbqZR",12) == 1726539185) strcat(s, "d");
if (crc32("heUKCgkMv",9) == 2354743761) strcat(s, "e");
if (crc32("dIXgeOgTGwy",11) == 2383308623) strcat(s, "d");
    return s;
}

char *feathery_adjectives() {
    char *s = calloc(9);
    if (crc32("pNpLCEOrKZ",10) == 965135980) strcat(s, "f");
if (crc32("sesHkNVmWipOz",13) == 2572002863) strcat(s, "s");
if (crc32("WnxAFnTguE",10) == 320865848) strcat(s, "e");
if (crc32("roexgmbUO",9) == 4178765905) strcat(s, "e");
if (crc32("oaOubmRrwzF",11) == 1130516870) strcat(s, "a");
if (crc32("ZpmRNfs",7) == 195737900) strcat(s, "r");
if (crc32("tUoaDdN",7) == 2794857936) strcat(s, "t");
if (crc32("IyfUEJhlDtJTGJ",14) == 2245332500) strcat(s, "i");
if (crc32("YJKOMizG",8) == 1662786948) strcat(s, "h");
if (crc32("zbdiktjdLFQR",12) == 1186458792) strcat(s, "e");
if (crc32("GoxBPyGLdFTqKo",14) == 2932067254) strcat(s, "r");
if (crc32("SZqirHolYHAYqhv",15) == 1816876933) strcat(s, "y");
if (crc32("yjhmKGWi",8) == 2225745572) strcat(s, "y");
    return s;
}

char *gynaecoid_adjectives() {
    char *s = calloc(10);
    if (crc32("hLcElGWNUZaKHJ",14) == 4097336572) strcat(s, "g");
if (crc32("qoCBIIG",7) == 3067583857) strcat(s, "y");
if (crc32("DQnLGNjfDB",10) == 3063996841) strcat(s, "n");
if (crc32("RNoyY",5) == 3830010580) strcat(s, "E");
if (crc32("kBzyfUwXAFuj",12) == 3236418328) strcat(s, "a");
if (crc32("sCcXIJQSKOobd",13) == 2626157767) strcat(s, "s");
if (crc32("ekevskDWhEQtKXH",15) == 1597396609) strcat(s, "e");
if (crc32("ZomvGl",6) == 1706665251) strcat(s, "c");
if (crc32("rTVgxu",6) == 1590468596) strcat(s, "o");
if (crc32("mZKsmXWaSQA",11) == 4018003459) strcat(s, "i");
if (crc32("spmAWocabtWM",12) == 3177356477) strcat(s, "w");
if (crc32("jmvXHy",6) == 1150137022) strcat(s, "d");
    return s;
}

char *unmicaceous_adjectives() {
    char *s = calloc(12);
    if (crc32("sSbGhKoUaOQgGK",14) == 2404162467) strcat(s, "F");
if (crc32("sEDMlWojneKztHd",15) == 2624662644) strcat(s, "u");
if (crc32("IZzAFowgAaKVSxY",15) == 852357558) strcat(s, "Z");
if (crc32("OXdnbVCvmicoRQz",15) == 1733068999) strcat(s, "n");
if (crc32("STyEnnxslSih",12) == 3384375675) strcat(s, "m");
if (crc32("rrRbmjI",7) == 3033509767) strcat(s, "F");
if (crc32("VZIOYoX",7) == 38855072) strcat(s, "i");
if (crc32("snKQyeM",7) == 1699187565) strcat(s, "c");
if (crc32("QgOniIqdqKt",11) == 965938904) strcat(s, "x");
if (crc32("bcfDTOraqLPIU",13) == 890101877) strcat(s, "a");
if (crc32("PClDoQGat",9) == 3709731552) strcat(s, "c");
if (crc32("uVJIfX",6) == 2156600395) strcat(s, "e");
if (crc32("vJxuDbRgLqC",11) == 1836516354) strcat(s, "h");
if (crc32("VEyYm",5) == 3739340126) strcat(s, "o");
if (crc32("BRKfFCD",7) == 3122339055) strcat(s, "f");
if (crc32("aqgAdOX",7) == 635845566) strcat(s, "u");
if (crc32("Ewtmw",5) == 3977480696) strcat(s, "s");
    return s;
}

char *nonCalvinistical_adjectives() {
    char *s = calloc(17);
    if (crc32("KvTqDp",6) == 3055495763) strcat(s, "K");
if (crc32("vlHFWzZlmO",10) == 244130378) strcat(s, "n");
if (crc32("LWYmElnKHZCNaZN",15) == 2284277956) strcat(s, "o");
if (crc32("kAxNQ",5) == 589083672) strcat(s, "n");
if (crc32("OFLtFkTa",8) == 3625134541) strcat(s, "C");
if (crc32("aQxgmralnIw",11) == 3924081757) strcat(s, "a");
if (crc32("pQFXMZlAPKor",12) == 3808858252) strcat(s, "w");
if (crc32("ZULflm",6) == 2348262352) strcat(s, "l");
if (crc32("GtTjtunoQzuJb",13) == 2001829180) strcat(s, "v");
if (crc32("FGsebUsjd",9) == 1899747920) strcat(s, "i");
if (crc32("sncyqCTp",8) == 3378224356) strcat(s, "n");
if (crc32("HFMIEpqEFLOgse",14) == 2801042085) strcat(s, "z");
if (crc32("rTmOXVIgHJBzKb",14) == 445556105) strcat(s, "i");
if (crc32("NJQpzmFKTIVTsij",15) == 829864251) strcat(s, "s");
if (crc32("CDfInytXUjo",11) == 2388401754) strcat(s, "x");
if (crc32("iHDPlPJXdPNRtrM",15) == 1303993621) strcat(s, "t");
if (crc32("qLNUatq",7) == 2445118209) strcat(s, "i");
if (crc32("ynHoGdoge",9) == 4216739231) strcat(s, "c");
if (crc32("MWusi",5) == 1390216588) strcat(s, "a");
if (crc32("mVvVrRQCR",9) == 1549441784) strcat(s, "l");
    return s;
}

char *wasteless_adjectives() {
    char *s = calloc(10);
    if (crc32("eVfegozSVqev",12) == 136832330) strcat(s, "M");
if (crc32("pOrOcyaSPPY",11) == 4225100372) strcat(s, "w");
if (crc32("BGEuryp",7) == 1775897040) strcat(s, "a");
if (crc32("zbYESIVbhzC",11) == 2101600977) strcat(s, "s");
if (crc32("plDNkb",6) == 1728846255) strcat(s, "i");
if (crc32("ELKwEnTbXAf",11) == 3844161898) strcat(s, "t");
if (crc32("CItrz",5) == 3189726347) strcat(s, "S");
if (crc32("GpPhMWECbUE",11) == 3022900540) strcat(s, "e");
if (crc32("MtvpLH",6) == 809017509) strcat(s, "l");
if (crc32("SZrpEG",6) == 2734295792) strcat(s, "a");
if (crc32("nDhDs",5) == 4018913604) strcat(s, "e");
if (crc32("RrvgXfFrErh",11) == 3676707869) strcat(s, "m");
if (crc32("XMLcKAIMSow",11) == 1477908314) strcat(s, "s");
if (crc32("uvyrf",5) == 3797156543) strcat(s, "w");
if (crc32("gfARuf",6) == 138973428) strcat(s, "s");
    return s;
}

char *nonpastoral_adjectives() {
    char *s = calloc(12);
    if (crc32("lltbDeJyGLdu",12) == 1501964438) strcat(s, "n");
if (crc32("QuTXVYE",7) == 2247487049) strcat(s, "n");
if (crc32("KShvBxu",7) == 50030731) strcat(s, "o");
if (crc32("fIFkSbtbd",9) == 790338322) strcat(s, "z");
if (crc32("IkXQOUiwLgRKXh",14) == 2592001480) strcat(s, "n");
if (crc32("kmeuTAPtrSKQGH",14) == 2401187336) strcat(s, "p");
if (crc32("TguKReRKe",9) == 3339766280) strcat(s, "a");
if (crc32("JePnVBRrSbGVf",13) == 4182837172) strcat(s, "h");
if (crc32("PFXVySEl",8) == 4053153233) strcat(s, "s");
if (crc32("BuIWwD",6) == 1547706433) strcat(s, "t");
if (crc32("OJkuUgeI",8) == 2149904858) strcat(s, "o");
if (crc32("OAbogVhnSjb",11) == 3539346438) strcat(s, "J");
if (crc32("WiMrdogXDuyDSL",14) == 2851643374) strcat(s, "r");
if (crc32("bDGFNEShzREvt",13) == 245853787) strcat(s, "l");
if (crc32("iBsPGX",6) == 1941231070) strcat(s, "a");
if (crc32("faydHjk",7) == 3453976369) strcat(s, "l");
    return s;
}

char *surefooted_adjectives() {
    char *s = calloc(11);
    if (crc32("WYsmdsBgn",9) == 891891872) strcat(s, "s");
if (crc32("ICMqkv",6) == 2246327420) strcat(s, "u");
if (crc32("ALdnBWHgf",9) == 2564295635) strcat(s, "r");
if (crc32("TlhbellSD",9) == 845026351) strcat(s, "e");
if (crc32("PXHnw",5) == 3139330389) strcat(s, "f");
if (crc32("GZExIFuTyA",10) == 2557565301) strcat(s, "M");
if (crc32("vIzJnuVSPAAdBVn",15) == 2377495024) strcat(s, "o");
if (crc32("MLbmgDBDbnChP",13) == 2987247248) strcat(s, "o");
if (crc32("KADjRBJdO",9) == 2950938872) strcat(s, "t");
if (crc32("TfNrcHxSG",9) == 773034245) strcat(s, "e");
if (crc32("LDOvVBvgJtvt",12) == 4224546833) strcat(s, "d");
    return s;
}

char *insurgent_adjectives() {
    char *s = calloc(10);
    if (crc32("yggeGDJcI",9) == 3027740277) strcat(s, "i");
if (crc32("mghkrPf",7) == 1854317616) strcat(s, "n");
if (crc32("pmSQQe",6) == 4059824791) strcat(s, "s");
if (crc32("TbpRuYKuihlJI",13) == 2193135837) strcat(s, "u");
if (crc32("owOaKQKbf",9) == 1642771915) strcat(s, "r");
if (crc32("XCAGExcp",8) == 1344855505) strcat(s, "g");
if (crc32("WPYXlYDcX",9) == 1169748979) strcat(s, "e");
if (crc32("lukIVKgCaJH",11) == 3527622976) strcat(s, "g");
if (crc32("LjbHlExApXMPVeK",15) == 612949345) strcat(s, "n");
if (crc32("QzGwU",5) == 3380183185) strcat(s, "t");
    return s;
}

char *unsinning_adjectives() {
    char *s = calloc(10);
    if (crc32("schplwYAE",9) == 3574053550) strcat(s, "U");
if (crc32("aylCwHYZTCs",11) == 3479076620) strcat(s, "u");
if (crc32("qbzyQVslG",9) == 1803036422) strcat(s, "n");
if (crc32("AYtPL",5) == 2208126639) strcat(s, "s");
if (crc32("ByJnOqGYyrHB",12) == 486439411) strcat(s, "t");
if (crc32("LauDq",5) == 966177571) strcat(s, "i");
if (crc32("pCmikEHorypnexP",15) == 278921328) strcat(s, "v");
if (crc32("HypbUk",6) == 2613773583) strcat(s, "n");
if (crc32("tYEewofR",8) == 3030765262) strcat(s, "Q");
if (crc32("aGqKDpTWxtC",11) == 3420420715) strcat(s, "n");
if (crc32("dCzelUbGfaUJmel",15) == 2128293193) strcat(s, "G");
if (crc32("arDaxxtPU",9) == 2783150575) strcat(s, "i");
if (crc32("qpgVZkkinbvVHo",14) == 2797264947) strcat(s, "U");
if (crc32("gPbPupbdTwaUiQ",14) == 491896154) strcat(s, "n");
if (crc32("BtkouJMfdduZ",12) == 3233310702) strcat(s, "g");
    return s;
}

char *openmouthed_adjectives() {
    char *s = calloc(12);
    if (crc32("vzdfOVeqaxCuvr",14) == 109188912) strcat(s, "y");
if (crc32("hrVaQGNGThwaOu",14) == 1899697845) strcat(s, "o");
if (crc32("EXQrOJqQ",8) == 3376663370) strcat(s, "q");
if (crc32("JOZrQq",6) == 2999269750) strcat(s, "p");
if (crc32("QSbqjTMs",8) == 3706206448) strcat(s, "e");
if (crc32("qForyhwqCn",10) == 1918838038) strcat(s, "n");
if (crc32("AporhdInzZpxS",13) == 2087053110) strcat(s, "m");
if (crc32("BFSGhvBqSni",11) == 2451340109) strcat(s, "X");
if (crc32("IxdJIGu",7) == 3549029266) strcat(s, "o");
if (crc32("FSzixPU",7) == 2806302865) strcat(s, "W");
if (crc32("LDsctueplxtaGr",14) == 1983619510) strcat(s, "u");
if (crc32("PbPGXlwBdXlvXN",14) == 1366671998) strcat(s, "F");
if (crc32("OAefQCAaYYeVa",13) == 999606914) strcat(s, "t");
if (crc32("IZxTmfenZeWqS",13) == 312970149) strcat(s, "s");
if (crc32("BcZoYTi",7) == 1487577718) strcat(s, "h");
if (crc32("QwljCnuyCWNG",12) == 827159513) strcat(s, "K");
if (crc32("mLHjs",5) == 1591073975) strcat(s, "e");
if (crc32("NFDQCeSZQF",10) == 3130394777) strcat(s, "d");
    return s;
}

char *unhistoric_adjectives() {
    char *s = calloc(11);
    if (crc32("gSLfmDNwiYtK",12) == 306618199) strcat(s, "v");
if (crc32("AZbwPRCtV",9) == 60358425) strcat(s, "u");
if (crc32("jjtsuIelhpJ",11) == 3648958477) strcat(s, "n");
if (crc32("wtYfyuw",7) == 3361161626) strcat(s, "h");
if (crc32("NkjeFGZNg",9) == 2461314591) strcat(s, "w");
if (crc32("XrzitpDV",8) == 3992792) strcat(s, "i");
if (crc32("TUoMBWYCtxbZCs",14) == 3569545651) strcat(s, "G");
if (crc32("jnzgLCcGiPAiHRp",15) == 296773027) strcat(s, "s");
if (crc32("YCFLc",5) == 178538803) strcat(s, "m");
if (crc32("YFLOZEzUODxNfEd",15) == 1981993464) strcat(s, "t");
if (crc32("QKjVHjKZIiT",11) == 478403796) strcat(s, "o");
if (crc32("clnMdBs",7) == 312019891) strcat(s, "z");
if (crc32("jtsMgsTfD",9) == 304298001) strcat(s, "r");
if (crc32("VOxDdBYUgNvC",12) == 2646684018) strcat(s, "i");
if (crc32("kMxmoxeJBDQHrCF",15) == 2454868078) strcat(s, "M");
if (crc32("QwYgtVfryQJgT",13) == 2537294794) strcat(s, "c");
    return s;
}

char *nonperiodical_adjectives() {
    char *s = calloc(14);
    if (crc32("gWUoV",5) == 2985297065) strcat(s, "n");
if (crc32("lsQkq",5) == 978048909) strcat(s, "F");
if (crc32("xOWxYRcMUXK",11) == 2427310871) strcat(s, "o");
if (crc32("XxuSHnEm",8) == 3135156322) strcat(s, "n");
if (crc32("aRtbAvkrb",9) == 3529435889) strcat(s, "t");
if (crc32("wdpbAaiDRgL",11) == 2643543268) strcat(s, "p");
if (crc32("VynCOAecg",9) == 1584736476) strcat(s, "T");
if (crc32("EJYTeMvPVnHgXjD",15) == 2694733659) strcat(s, "e");
if (crc32("NEJlGwWc",8) == 132549680) strcat(s, "x");
if (crc32("qrYLm",5) == 3473170086) strcat(s, "r");
if (crc32("fPNDyrsdyBRDo",13) == 1321995516) strcat(s, "f");
if (crc32("oKnyvVtgmMS",11) == 3778613747) strcat(s, "i");
if (crc32("kpUWYGJ",7) == 4085963123) strcat(s, "o");
if (crc32("nxturrRyGN",10) == 424974916) strcat(s, "J");
if (crc32("DJGGbhJZwQnTn",13) == 421758764) strcat(s, "d");
if (crc32("DbhjzDNAgMu",11) == 1309599538) strcat(s, "i");
if (crc32("NyhkePYrrskRnFT",15) == 4182257045) strcat(s, "u");
if (crc32("EiBxteZUkpewef",14) == 601841438) strcat(s, "c");
if (crc32("CitkHOROayuQTDe",15) == 3244740670) strcat(s, "o");
if (crc32("xsXRBSWqthaM",12) == 2996479945) strcat(s, "a");
if (crc32("nLPfzTOYzHwBBD",14) == 4264301095) strcat(s, "T");
if (crc32("sMMnrn",6) == 2323413) strcat(s, "l");
    return s;
}

char *fortyish_adjectives() {
    char *s = calloc(9);
    if (crc32("qguOTWBkE",9) == 4081659234) strcat(s, "f");
if (crc32("pDyxElPp",8) == 3745458980) strcat(s, "Q");
if (crc32("TNrJW",5) == 3633737470) strcat(s, "o");
if (crc32("voTjHFdbggveNHe",15) == 3256720751) strcat(s, "J");
if (crc32("HNTpDlljD",9) == 268511193) strcat(s, "r");
if (crc32("sooPbfxQfSBvApd",15) == 324458622) strcat(s, "t");
if (crc32("JoxeVKXfpv",10) == 1435492509) strcat(s, "v");
if (crc32("WGNxtIcaAFD",11) == 3828584376) strcat(s, "y");
if (crc32("RjUnLGSYt",9) == 3056279954) strcat(s, "S");
if (crc32("vnmUHHDLv",9) == 3001629279) strcat(s, "i");
if (crc32("neCCIqJK",8) == 4049012079) strcat(s, "Y");
if (crc32("FfQLmylL",8) == 472471255) strcat(s, "s");
if (crc32("ArZGXTWEeI",10) == 329430581) strcat(s, "h");
    return s;
}

char *selfcleaning_adjectives() {
    char *s = calloc(13);
    if (crc32("BOPIX",5) == 1793344602) strcat(s, "a");
if (crc32("SKXXTziqshhjkLA",15) == 1259711996) strcat(s, "s");
if (crc32("IHlWhHfSf",9) == 3173144386) strcat(s, "e");
if (crc32("bAgqyLOCztO",11) == 1045319831) strcat(s, "V");
if (crc32("gcZgHh",6) == 3896544728) strcat(s, "l");
if (crc32("UyTaJUYTNmA",11) == 200952530) strcat(s, "d");
if (crc32("duMCBhMQBj",10) == 3325232243) strcat(s, "f");
if (crc32("tLDhEMXv",8) == 960393609) strcat(s, "L");
if (crc32("gkPthNPoGpB",11) == 1967296707) strcat(s, "c");
if (crc32("rSMHAiJYtVXx",12) == 2401906536) strcat(s, "Y");
if (crc32("RzeCdELLzyLzo",13) == 3004853414) strcat(s, "l");
if (crc32("UVMHCkBhY",9) == 3031135652) strcat(s, "e");
if (crc32("HEaFSmCt",8) == 3075473607) strcat(s, "z");
if (crc32("hoXymGFEQJQ",11) == 589848772) strcat(s, "a");
if (crc32("QSkuAioCLepK",12) == 3798157767) strcat(s, "n");
if (crc32("LAcywBCqJ",9) == 99963766) strcat(s, "i");
if (crc32("uFAPFpKhXnD",11) == 4273052582) strcat(s, "n");
if (crc32("OScduZSAwspUHx",14) == 3434996291) strcat(s, "g");
    return s;
}

char *matronal_adjectives() {
    char *s = calloc(9);
    if (crc32("HVqLGeNdkJMIMz",14) == 212875718) strcat(s, "Z");
if (crc32("kVMaZKUxfEQwA",13) == 2776976264) strcat(s, "m");
if (crc32("aZFvSJOUnJUGw",13) == 836066571) strcat(s, "p");
if (crc32("dWciFQ",6) == 2085543575) strcat(s, "a");
if (crc32("xIOavfVlpMkz",12) == 1347311625) strcat(s, "s");
if (crc32("mRURvjkmsR",10) == 287127766) strcat(s, "t");
if (crc32("nGePnYc",7) == 3162005369) strcat(s, "G");
if (crc32("CjOEEefeFGOekFm",15) == 1969130718) strcat(s, "r");
if (crc32("lHCelLff",8) == 1563500891) strcat(s, "b");
if (crc32("QKRlySbRKCA",11) == 3092353055) strcat(s, "o");
if (crc32("fpBZYPqI",8) == 1463388570) strcat(s, "J");
if (crc32("qcYZxiZkLqH",11) == 766970248) strcat(s, "n");
if (crc32("kqgxdcsM",8) == 2353344194) strcat(s, "a");
if (crc32("BVEtLzPwNIQGK",13) == 3451159523) strcat(s, "o");
if (crc32("ompuvTcgh",9) == 2281918209) strcat(s, "l");
    return s;
}

char *estrildine_adjectives() {
    char *s = calloc(11);
    if (crc32("ULIGBbvc",8) == 3998974801) strcat(s, "e");
if (crc32("lyHNDV",6) == 1184444082) strcat(s, "v");
if (crc32("dKLcdb",6) == 888846748) strcat(s, "s");
if (crc32("AHwVexdZN",9) == 1194792198) strcat(s, "t");
if (crc32("hWdfSf",6) == 26646401) strcat(s, "G");
if (crc32("ryZfJ",5) == 2541905005) strcat(s, "r");
if (crc32("zHuXmJFwxcqNXL",14) == 2947114493) strcat(s, "z");
if (crc32("KcAOC",5) == 704537279) strcat(s, "i");
if (crc32("FgxUYlOEc",9) == 1961583831) strcat(s, "l");
if (crc32("ZkbMKwyIrRPNKb",14) == 2166180522) strcat(s, "d");
if (crc32("owwKZB",6) == 1362317205) strcat(s, "i");
if (crc32("XfRacf",6) == 3925034131) strcat(s, "o");
if (crc32("yJdvB",5) == 1746948298) strcat(s, "n");
if (crc32("IXkUf",5) == 3066140624) strcat(s, "g");
if (crc32("GiNIRd",6) == 4050619805) strcat(s, "e");
    return s;
}

char *flitting_adjectives() {
    char *s = calloc(9);
    if (crc32("jyZqiqCK",8) == 488188476) strcat(s, "f");
if (crc32("oDGIfblEaMZSTL",14) == 693546592) strcat(s, "L");
if (crc32("QATalmj",7) == 2923082289) strcat(s, "l");
if (crc32("RVzpT",5) == 1892170325) strcat(s, "i");
if (crc32("DueXM",5) == 61061760) strcat(s, "t");
if (crc32("GgfZLbJMRMMqIza",15) == 2143299949) strcat(s, "P");
if (crc32("uNMJuv",6) == 4071819957) strcat(s, "t");
if (crc32("VnlOImpobzUFF",13) == 3398017232) strcat(s, "i");
if (crc32("wKLmCJUFMjXSL",13) == 4266398325) strcat(s, "n");
if (crc32("vNeUvSDFqEtbw",13) == 2233125185) strcat(s, "J");
if (crc32("MjigJJmNZx",10) == 3514076289) strcat(s, "g");
    return s;
}

char *wellcontented_adjectives() {
    char *s = calloc(14);
    if (crc32("cctuJUMCACx",11) == 4032984634) strcat(s, "D");
if (crc32("sPrxSee",7) == 710130751) strcat(s, "w");
if (crc32("jXgdKuRNI",9) == 1636595704) strcat(s, "U");
if (crc32("lKvuOLLqcbxR",12) == 771375785) strcat(s, "e");
if (crc32("cBzSbuKXYsx",11) == 3643237001) strcat(s, "l");
if (crc32("bXnsPRUzrv",10) == 2826202717) strcat(s, "l");
if (crc32("VbCnMwxstC",10) == 4244640290) strcat(s, "c");
if (crc32("EKeuxUnWFf",10) == 1191130087) strcat(s, "o");
if (crc32("ORqSXOADWPbfS",13) == 71719636) strcat(s, "i");
if (crc32("usuoAuU",7) == 3303807048) strcat(s, "n");
if (crc32("KcHrbqYQyqfyA",13) == 1661367563) strcat(s, "t");
if (crc32("GmGfsb",6) == 1481842563) strcat(s, "U");
if (crc32("pgqtkcZVWcF",11) == 1255453409) strcat(s, "e");
if (crc32("lGmomgai",8) == 559346624) strcat(s, "K");
if (crc32("nScbUdEKRLuyqPj",15) == 3431587066) strcat(s, "n");
if (crc32("gKPnfU",6) == 926106489) strcat(s, "t");
if (crc32("IUnngYsBgTNo",12) == 959214217) strcat(s, "t");
if (crc32("dsfoZ",5) == 4007396731) strcat(s, "V");
if (crc32("ImYlea",6) == 767620539) strcat(s, "e");
if (crc32("sGUOEapOvl",10) == 1037933649) strcat(s, "d");
    return s;
}

char *denunciable_adjectives() {
    char *s = calloc(12);
    if (crc32("aRvNqP",6) == 1504094014) strcat(s, "d");
if (crc32("LUyPmqSE",8) == 1458948984) strcat(s, "W");
if (crc32("mGIupKUtQvK",11) == 1919681465) strcat(s, "e");
if (crc32("JvoDmB",6) == 2224957763) strcat(s, "z");
if (crc32("TBqqAawtK",9) == 897875743) strcat(s, "n");
if (crc32("sPPHqLJ",7) == 2837566913) strcat(s, "M");
if (crc32("iySqLhELJI",10) == 46819699) strcat(s, "u");
if (crc32("EongHxeptIJ",11) == 3658892194) strcat(s, "w");
if (crc32("mjgFkU",6) == 2579823380) strcat(s, "n");
if (crc32("GHxsrgEsmjwV",12) == 113650811) strcat(s, "P");
if (crc32("VBmgCGuqCq",10) == 880837063) strcat(s, "c");
if (crc32("ePwWzRYUvaxe",12) == 1055647281) strcat(s, "i");
if (crc32("asiKJfROm",9) == 677897784) strcat(s, "i");
if (crc32("HNOydQcfWkM",11) == 2854787498) strcat(s, "a");
if (crc32("YkEfjyvmPdh",11) == 2956946066) strcat(s, "o");
if (crc32("OdRFnFoWJtk",11) == 3865272111) strcat(s, "b");
if (crc32("JGRrjFaxdD",10) == 1804707609) strcat(s, "l");
if (crc32("AWTauSBgOpBV",12) == 2634683594) strcat(s, "y");
if (crc32("tMiHGUkO",8) == 591559442) strcat(s, "e");
    return s;
}

char *antarthritic_adjectives() {
    char *s = calloc(13);
    if (crc32("tImHbTOD",8) == 29773033) strcat(s, "n");
if (crc32("wtonzXiz",8) == 1727180871) strcat(s, "a");
if (crc32("hAqdGQudnXFH",12) == 1524921923) strcat(s, "m");
if (crc32("LVIffHIGp",9) == 2591829663) strcat(s, "n");
if (crc32("odYxtiigNJK",11) == 2711429282) strcat(s, "K");
if (crc32("QKJHHrwC",8) == 4204528839) strcat(s, "t");
if (crc32("jNZRcCXu",8) == 3454204150) strcat(s, "x");
if (crc32("kCujfEwXOm",10) == 2030024208) strcat(s, "a");
if (crc32("sbBeTToujcVkF",13) == 1351637530) strcat(s, "K");
if (crc32("RNOCcWZoyiBVcfA",15) == 940874047) strcat(s, "r");
if (crc32("SVnxdPafOmL",11) == 3360843866) strcat(s, "t");
if (crc32("obWGHRqUDUYKOc",14) == 532259512) strcat(s, "h");
if (crc32("lodcO",5) == 516459933) strcat(s, "r");
if (crc32("WHyeicrFiQwm",12) == 3885722395) strcat(s, "v");
if (crc32("mHnykkL",7) == 433244022) strcat(s, "i");
if (crc32("kCymL",5) == 1990482465) strcat(s, "e");
if (crc32("yrHuxYLb",8) == 1298525791) strcat(s, "t");
if (crc32("DDkYit",6) == 3831830438) strcat(s, "i");
if (crc32("pNZKy",5) == 2667211904) strcat(s, "y");
if (crc32("MksptDgbE",9) == 2520146846) strcat(s, "c");
    return s;
}

char *sepaled_adjectives() {
    char *s = calloc(8);
    if (crc32("CgfemKueYW",10) == 2736230204) strcat(s, "Z");
if (crc32("FZrKmZPmD",9) == 2571327593) strcat(s, "s");
if (crc32("dJsDyyNNrGAKMz",14) == 2390453942) strcat(s, "e");
if (crc32("xBTdbZQor",9) == 1870802300) strcat(s, "U");
if (crc32("kZIzSoDKP",9) == 2490387132) strcat(s, "p");
if (crc32("xXYGzhqQSkYXyL",14) == 3622360472) strcat(s, "a");
if (crc32("niaCbjFfiO",10) == 2197903786) strcat(s, "l");
if (crc32("LOtmSchoyER",11) == 1003801626) strcat(s, "e");
if (crc32("MatCfK",6) == 3799955079) strcat(s, "d");
    return s;
}

char *dewlapped_adjectives() {
    char *s = calloc(10);
    if (crc32("pUeZuIXUoIEzP",13) == 3113687145) strcat(s, "x");
if (crc32("bMjlXLM",7) == 2801794683) strcat(s, "d");
if (crc32("oJGRwhuwmOa",11) == 577102903) strcat(s, "k");
if (crc32("rFWIfmPNvcWsYFm",15) == 3478146770) strcat(s, "e");
if (crc32("oaleLdocssOkpT",14) == 366537752) strcat(s, "w");
if (crc32("yXbMhrUka",9) == 765105743) strcat(s, "l");
if (crc32("UhcNvM",6) == 1717313297) strcat(s, "a");
if (crc32("oVrjsZ",6) == 2804821601) strcat(s, "E");
if (crc32("TPspOzZD",8) == 1208730104) strcat(s, "p");
if (crc32("XpziqCUsxrgf",12) == 1890774973) strcat(s, "G");
if (crc32("dBehwAxcwmC",11) == 1744651188) strcat(s, "p");
if (crc32("DhBlZsFXaRR",11) == 803400795) strcat(s, "e");
if (crc32("EbXakDoollszs",13) == 117645931) strcat(s, "d");
    return s;
}

char *bomba_adjectives() {
    char *s = calloc(6);
    if (crc32("UOOhuzcjhPGb",12) == 1834439592) strcat(s, "b");
if (crc32("fdYquyLgUtGWe",13) == 2791737294) strcat(s, "o");
if (crc32("DPCbnGuWPDcJe",13) == 2948691341) strcat(s, "Z");
if (crc32("EjFiBRkzJe",10) == 566556132) strcat(s, "m");
if (crc32("QNSmcmusfvTdtAF",15) == 1946485556) strcat(s, "b");
if (crc32("FszPRKxzLWNhWTy",15) == 820214020) strcat(s, "a");
    return s;
}

char *precondylar_adjectives() {
    char *s = calloc(12);
    if (crc32("JMYUBtVSk",9) == 1732124428) strcat(s, "G");
if (crc32("aRKicx",6) == 732172046) strcat(s, "p");
if (crc32("rJaaZOdZUBVhA",13) == 3602162858) strcat(s, "e");
if (crc32("PWwELWTBZJQsit",14) == 2630794276) strcat(s, "r");
if (crc32("XiRmxjRaRPpp",12) == 3172203898) strcat(s, "e");
if (crc32("HzCkmOW",7) == 1906595762) strcat(s, "c");
if (crc32("OXTTSuY",7) == 1745573248) strcat(s, "o");
if (crc32("MDpcvpMbf",9) == 2432628510) strcat(s, "n");
if (crc32("LbjXQUgCEuvNms",14) == 1446410633) strcat(s, "d");
if (crc32("WlCAlbSSCAD",11) == 1020060470) strcat(s, "T");
if (crc32("ezWuXNDlqZezqA",14) == 320266676) strcat(s, "y");
if (crc32("xQWkvObQQyKaw",13) == 1963715225) strcat(s, "D");
if (crc32("ZeZYNRKTIbC",11) == 2451972424) strcat(s, "l");
if (crc32("SYCIuJbjPjoiu",13) == 1000277639) strcat(s, "a");
if (crc32("PVOlhFpufzInNWA",15) == 510044541) strcat(s, "r");
    return s;
}

char *sartorial_adjectives() {
    char *s = calloc(10);
    if (crc32("phlPPfNHW",9) == 3301541015) strcat(s, "s");
if (crc32("lDorixW",7) == 2692646888) strcat(s, "l");
if (crc32("aXxXH",5) == 1011788219) strcat(s, "a");
if (crc32("ogWycSlulnJRB",13) == 1647531068) strcat(s, "r");
if (crc32("YRLDLrNeQFKz",12) == 69085491) strcat(s, "d");
if (crc32("OtTFSG",6) == 180939830) strcat(s, "t");
if (crc32("uDlZDm",6) == 4036212577) strcat(s, "o");
if (crc32("dvULcKG",7) == 2944125422) strcat(s, "r");
if (crc32("xKALXEY",7) == 1848836345) strcat(s, "i");
if (crc32("vFzdn",5) == 4231195369) strcat(s, "a");
if (crc32("pQITGeHbOOGQAP",14) == 1131675899) strcat(s, "z");
if (crc32("dUGNXlbkZQVT",12) == 461162147) strcat(s, "l");
    return s;
}

char *halfmumbled_adjectives() {
    char *s = calloc(12);
    if (crc32("wOleEJuPtEJTlw",14) == 1653458569) strcat(s, "p");
if (crc32("HyFwReKmPhSUIC",14) == 2073251334) strcat(s, "h");
if (crc32("aNXHbFdmv",9) == 424804244) strcat(s, "a");
if (crc32("KSIHF",5) == 3866949528) strcat(s, "q");
if (crc32("LKiUt",5) == 3231085042) strcat(s, "l");
if (crc32("vlQsYPJpvBvmc",13) == 4024856323) strcat(s, "f");
if (crc32("ykfZOUYQkkge",12) == 2586134216) strcat(s, "m");
if (crc32("avGDyJWb",8) == 2306915178) strcat(s, "U");
if (crc32("UdefKflu",8) == 2688458639) strcat(s, "u");
if (crc32("VKKAW",5) == 1573309048) strcat(s, "m");
if (crc32("tCEHTpJQRFr",11) == 40787233) strcat(s, "r");
if (crc32("daOApTuxtzLNoz",14) == 4210827110) strcat(s, "b");
if (crc32("PFFryb",6) == 2013956632) strcat(s, "d");
if (crc32("dWdsWzpLmMirGm",14) == 3832557906) strcat(s, "l");
if (crc32("fqlHcwcfO",9) == 1005162001) strcat(s, "K");
if (crc32("IEPWRqbzxlPeAbW",15) == 3736301488) strcat(s, "e");
if (crc32("WoEsAAeqHIvDM",13) == 3969892356) strcat(s, "d");
    return s;
}

char *rachidian_adjectives() {
    char *s = calloc(10);
    if (crc32("TkeyGqKWPTQSt",13) == 4149136332) strcat(s, "B");
if (crc32("rkwetlr",7) == 3877187132) strcat(s, "r");
if (crc32("NxXrIpsSHv",10) == 2458198573) strcat(s, "a");
if (crc32("YxsPRDudXSZwKGy",15) == 1612192982) strcat(s, "c");
if (crc32("mZfeZQJweZyEUgm",15) == 1616969130) strcat(s, "W");
if (crc32("aBxKHwUtNOx",11) == 2034822118) strcat(s, "h");
if (crc32("xcgrEY",6) == 3860595206) strcat(s, "i");
if (crc32("JzKRNPij",8) == 534635640) strcat(s, "h");
if (crc32("nhFJE",5) == 1719992895) strcat(s, "d");
if (crc32("OgParqjNcBudT",13) == 656889445) strcat(s, "J");
if (crc32("FhpYZY",6) == 2603654515) strcat(s, "i");
if (crc32("JLjpaffXkHFZ",12) == 3597600798) strcat(s, "a");
if (crc32("IScVFMCn",8) == 3483237361) strcat(s, "n");
    return s;
}

char *unbeneficent_adjectives() {
    char *s = calloc(13);
    if (crc32("oGHZRNCODyV",11) == 591096776) strcat(s, "u");
if (crc32("pebKaP",6) == 1640729196) strcat(s, "n");
if (crc32("CtuIwyylBnQp",12) == 1073338655) strcat(s, "n");
if (crc32("zFCnwhd",7) == 2124030456) strcat(s, "b");
if (crc32("lnaJPS",6) == 1589142212) strcat(s, "e");
if (crc32("hwcGfdYVFc",10) == 1946393024) strcat(s, "n");
if (crc32("WmvNiirGON",10) == 468577193) strcat(s, "R");
if (crc32("sySnMPxTSfW",11) == 2221429596) strcat(s, "e");
if (crc32("UvngTLXH",8) == 3487793136) strcat(s, "U");
if (crc32("RhpkwY",6) == 78821103) strcat(s, "f");
if (crc32("PFvJZArDroMu",12) == 2759706467) strcat(s, "Y");
if (crc32("LsvXstmUh",9) == 227584153) strcat(s, "i");
if (crc32("nCQKKqY",7) == 1928457880) strcat(s, "W");
if (crc32("XDaBSXBW",8) == 1047103282) strcat(s, "c");
if (crc32("IIOGzSKVxbe",11) == 2271164110) strcat(s, "w");
if (crc32("hacqKc",6) == 1252101839) strcat(s, "e");
if (crc32("uGntMt",6) == 3395874574) strcat(s, "r");
if (crc32("KKCEtFNgtQ",10) == 1314544430) strcat(s, "n");
if (crc32("LgvhqmeQtM",10) == 4268369718) strcat(s, "b");
if (crc32("bGFLrcUJ",8) == 3894440848) strcat(s, "t");
    return s;
}

char *chevronny_adjectives() {
    char *s = calloc(10);
    if (crc32("QlCkIZRlSvxKbn",14) == 1710143052) strcat(s, "i");
if (crc32("FsArnNUL",8) == 152907907) strcat(s, "c");
if (crc32("NLaZMm",6) == 2381736026) strcat(s, "h");
if (crc32("pjiWYMxjRG",10) == 284941026) strcat(s, "z");
if (crc32("YCwFsdbGCgM",11) == 2635119391) strcat(s, "e");
if (crc32("uVRWuQ",6) == 1654191214) strcat(s, "i");
if (crc32("UOmQSLY",7) == 538772316) strcat(s, "v");
if (crc32("DSIREyNqvCnmvm",14) == 55389950) strcat(s, "C");
if (crc32("yzGjLZBLFktwoE",14) == 244542908) strcat(s, "r");
if (crc32("ocdqVbJ",7) == 2016443227) strcat(s, "o");
if (crc32("pgtMBsXGgAZ",11) == 3331284297) strcat(s, "n");
if (crc32("MIcvSpYURLJN",12) == 534981591) strcat(s, "I");
if (crc32("bKvwalkyCMLi",12) == 2057779894) strcat(s, "n");
if (crc32("YoShSt",6) == 2967685592) strcat(s, "o");
if (crc32("rQMdrLxt",8) == 3652794832) strcat(s, "y");
    return s;
}

char *antifrictional_adjectives() {
    char *s = calloc(15);
    if (crc32("rHiMHV",6) == 3911045527) strcat(s, "F");
if (crc32("pZEsULEXlenCj",13) == 234155861) strcat(s, "a");
if (crc32("yzrbshPR",8) == 1001237046) strcat(s, "n");
if (crc32("yvJbICzSmWJqPrk",15) == 2697410508) strcat(s, "k");
if (crc32("iBehOtPtEN",10) == 1754080863) strcat(s, "t");
if (crc32("zROCRsOjqELF",12) == 2625252822) strcat(s, "i");
if (crc32("VwyTZPFkH",9) == 3750696163) strcat(s, "t");
if (crc32("kHhNnVl",7) == 3488836969) strcat(s, "f");
if (crc32("zIsjmBPfh",9) == 2373208600) strcat(s, "r");
if (crc32("NRqMSyvHncTptGT",15) == 517080520) strcat(s, "i");
if (crc32("tLXUl",5) == 1813612319) strcat(s, "I");
if (crc32("BFhlTuyO",8) == 2683298097) strcat(s, "c");
if (crc32("pOpfzSCOJO",10) == 2605093995) strcat(s, "t");
if (crc32("rQyMEaiOzHxsY",13) == 1439194267) strcat(s, "i");
if (crc32("oBWJiHfI",8) == 3098878061) strcat(s, "o");
if (crc32("HCcBhfreuhmQYZ",14) == 2817527691) strcat(s, "o");
if (crc32("WBwFEskwjv",10) == 3009568319) strcat(s, "n");
if (crc32("MlAUQ",5) == 3175681242) strcat(s, "a");
if (crc32("sCSoqGAgZjhaG",13) == 1235770909) strcat(s, "l");
    return s;
}

char *Scotistic_adjectives() {
    char *s = calloc(10);
    if (crc32("OrOgRuYTYtaLtSf",15) == 2389212515) strcat(s, "S");
if (crc32("nDpBiY",6) == 2431054220) strcat(s, "c");
if (crc32("LqksnTPzKuBngiq",15) == 1379965087) strcat(s, "o");
if (crc32("LQmPyBpMnSyfRd",14) == 107895029) strcat(s, "t");
if (crc32("WbbdloQZ",8) == 352524287) strcat(s, "i");
if (crc32("shnUXmLPgF",10) == 616687710) strcat(s, "s");
if (crc32("MhQWbgH",7) == 916698826) strcat(s, "v");
if (crc32("TjOhfbdbic",10) == 1880146113) strcat(s, "t");
if (crc32("QdbmgRy",7) == 37484336) strcat(s, "N");
if (crc32("OHXdeDxIzY",10) == 4087755697) strcat(s, "i");
if (crc32("zPzjpBTnLY",10) == 61420492) strcat(s, "c");
    return s;
}

char *anacoluthic_adjectives() {
    char *s = calloc(12);
    if (crc32("DqxeXqXo",8) == 1772131965) strcat(s, "m");
if (crc32("YMSmQyanGecocz",14) == 1751864886) strcat(s, "a");
if (crc32("eKEWmd",6) == 2294543969) strcat(s, "N");
if (crc32("iEzyuUiMJiZO",12) == 3674701603) strcat(s, "n");
if (crc32("nrWCAygHRICxiyV",15) == 1314699618) strcat(s, "J");
if (crc32("RcDTmUWQUnSKKey",15) == 903010666) strcat(s, "a");
if (crc32("XaKKeLhRJnhLo",13) == 272499063) strcat(s, "P");
if (crc32("WzjfgmeQLwRM",12) == 2879288498) strcat(s, "c");
if (crc32("PmqjT",5) == 2970133560) strcat(s, "u");
if (crc32("hhOBFHlwddU",11) == 310847836) strcat(s, "o");
if (crc32("AXhwgGdlsAHMBv",14) == 1285509910) strcat(s, "F");
if (crc32("spLtOE",6) == 919338975) strcat(s, "l");
if (crc32("ujdKSr",6) == 1699753189) strcat(s, "q");
if (crc32("PmiYneFSckl",11) == 2293133960) strcat(s, "u");
if (crc32("QTEpzUq",7) == 3444901124) strcat(s, "t");
if (crc32("ZGZWlhVFH",9) == 2688986247) strcat(s, "h");
if (crc32("TYdrTekT",8) == 3470446771) strcat(s, "b");
if (crc32("PzbFBeRePb",10) == 2942009448) strcat(s, "i");
if (crc32("mcpuanfpSjc",11) == 3279554590) strcat(s, "k");
if (crc32("uMvSPzVH",8) == 777911) strcat(s, "c");
    return s;
}

char *leechlike_adjectives() {
    char *s = calloc(10);
    if (crc32("fmZccgYbZeU",11) == 667182256) strcat(s, "l");
if (crc32("JZPWGTp",7) == 3076101232) strcat(s, "e");
if (crc32("iiSGsVODXUBhS",13) == 181857343) strcat(s, "e");
if (crc32("EENIsC",6) == 2432912923) strcat(s, "e");
if (crc32("NLBbc",5) == 2976149726) strcat(s, "s");
if (crc32("JdtJiFi",7) == 3284305795) strcat(s, "c");
if (crc32("ppPYZJWxStjU",12) == 884962531) strcat(s, "h");
if (crc32("cYXYLrHWKRSpKc",14) == 3398853179) strcat(s, "e");
if (crc32("ovHUpQ",6) == 964070750) strcat(s, "l");
if (crc32("cMmol",5) == 2135900831) strcat(s, "i");
if (crc32("MBaFgDsacQ",10) == 2576423305) strcat(s, "i");
if (crc32("ALvvB",5) == 3293314119) strcat(s, "c");
if (crc32("yiJDMUn",7) == 3637928011) strcat(s, "k");
if (crc32("BqOjTqavYqd",11) == 1583138165) strcat(s, "e");
    return s;
}

char *communicable_adjectives() {
    char *s = calloc(13);
    if (crc32("mnYPX",5) == 3223278972) strcat(s, "c");
if (crc32("wldtjfMPqEHgc",13) == 1422815903) strcat(s, "i");
if (crc32("masBnq",6) == 1997714053) strcat(s, "o");
if (crc32("RnECKltTqgWrQB",14) == 2013213695) strcat(s, "D");
if (crc32("KOaSSprlynNkp",13) == 3032725420) strcat(s, "m");
if (crc32("zFOTgGF",7) == 4289072837) strcat(s, "m");
if (crc32("JZnloT",6) == 3422685497) strcat(s, "d");
if (crc32("oTGpJOlSRRGpvz",14) == 4257248707) strcat(s, "u");
if (crc32("gMhYvZrKhKCf",12) == 2665617245) strcat(s, "L");
if (crc32("bKNqzTGLJCbyN",13) == 1331746284) strcat(s, "n");
if (crc32("xsSuhDrZakwgUPS",15) == 1915768799) strcat(s, "m");
if (crc32("lzcUgBWCkpvk",12) == 1420099341) strcat(s, "i");
if (crc32("LmUXXmalWaZ",11) == 3264425573) strcat(s, "c");
if (crc32("toGagrGOE",9) == 1492427532) strcat(s, "k");
if (crc32("hIDeYeMU",8) == 3563796826) strcat(s, "a");
if (crc32("FyulbBOLKQOr",12) == 3226441762) strcat(s, "Q");
if (crc32("EefodNVhJv",10) == 2305025869) strcat(s, "b");
if (crc32("RCrPZugH",8) == 2120063486) strcat(s, "T");
if (crc32("zCXejJge",8) == 2729195700) strcat(s, "l");
if (crc32("pQXSGy",6) == 1228008935) strcat(s, "e");
    return s;
}

char *nerveless_adjectives() {
    char *s = calloc(10);
    if (crc32("DEujyzlFT",9) == 32837924) strcat(s, "z");
if (crc32("tiXJPkG",7) == 1417085288) strcat(s, "n");
if (crc32("QWFXAGxGpeXlP",13) == 360225636) strcat(s, "e");
if (crc32("WHtkwXMrayfwRzL",15) == 195054564) strcat(s, "r");
if (crc32("VojxIhzphWVLV",13) == 3494934316) strcat(s, "v");
if (crc32("LjZltsmoHnvr",12) == 1773365199) strcat(s, "e");
if (crc32("aQJpLoBIJ",9) == 4192970922) strcat(s, "a");
if (crc32("sXblkO",6) == 2225060199) strcat(s, "l");
if (crc32("SgagsfrtgaE",11) == 2071771468) strcat(s, "e");
if (crc32("XYJYwiZZlEEc",12) == 740395022) strcat(s, "s");
if (crc32("JxCVDOS",7) == 2571337370) strcat(s, "s");
    return s;
}

char *pseudoMongolian_adjectives() {
    char *s = calloc(16);
    if (crc32("nIMjvLcLD",9) == 141929928) strcat(s, "p");
if (crc32("HTpDq",5) == 220782491) strcat(s, "s");
if (crc32("qufJbKzBmZPdbl",14) == 3438592479) strcat(s, "M");
if (crc32("cuKGnJJ",7) == 2347496835) strcat(s, "e");
if (crc32("RfOHQDhcuI",10) == 344830591) strcat(s, "H");
if (crc32("WhAkgQsqb",9) == 3908525851) strcat(s, "u");
if (crc32("qlrwPI",6) == 139286313) strcat(s, "d");
if (crc32("jmCTHkyqKF",10) == 976536529) strcat(s, "o");
if (crc32("nEdzUrtA",8) == 2002324550) strcat(s, "M");
if (crc32("IdVUL",5) == 4145175513) strcat(s, "o");
if (crc32("dWMuzvp",7) == 1412873762) strcat(s, "w");
if (crc32("zwqQQcg",7) == 2217231554) strcat(s, "n");
if (crc32("JPVglxO",7) == 544445908) strcat(s, "g");
if (crc32("mFnXy",5) == 900078) strcat(s, "o");
if (crc32("WfCJwDnTrIGvb",13) == 3934036067) strcat(s, "g");
if (crc32("dySByfkcZh",10) == 4033851052) strcat(s, "l");
if (crc32("BPzpFeFFEqns",12) == 1035912407) strcat(s, "i");
if (crc32("fkyzo",5) == 1871362968) strcat(s, "a");
if (crc32("sBnMY",5) == 1550107526) strcat(s, "n");
    return s;
}

char *defeasible_adjectives() {
    char *s = calloc(11);
    if (crc32("cFirVzIbvhh",11) == 3219225757) strcat(s, "d");
if (crc32("mZJbtDkzrg",10) == 3267718370) strcat(s, "e");
if (crc32("HTmMNtx",7) == 1040985883) strcat(s, "l");
if (crc32("nzypuLUjXGwnzPd",15) == 278812058) strcat(s, "f");
if (crc32("teZLgNyxMWkfYYz",15) == 1519667546) strcat(s, "q");
if (crc32("iAOAWVWTt",9) == 27290526) strcat(s, "e");
if (crc32("OPatgIJBLVyjzVg",15) == 1051895939) strcat(s, "a");
if (crc32("lLsJAsrpUV",10) == 2015813278) strcat(s, "s");
if (crc32("PCHiTBz",7) == 698952247) strcat(s, "i");
if (crc32("bjHqOhjJhdQkr",13) == 501501096) strcat(s, "i");
if (crc32("yssGZ",5) == 657157369) strcat(s, "k");
if (crc32("jrnKddeuPNvP",12) == 1833113376) strcat(s, "b");
if (crc32("ZqBogBe",7) == 701382250) strcat(s, "l");
if (crc32("uAMQCxFqyuQfz",13) == 1900421696) strcat(s, "e");
    return s;
}

char *glostfired_adjectives() {
    char *s = calloc(11);
    if (crc32("wzDsrdBY",8) == 1356450231) strcat(s, "O");
if (crc32("hrsGznJWgxYCWaV",15) == 1468256016) strcat(s, "g");
if (crc32("UXvgGnxqoNj",11) == 1262193927) strcat(s, "j");
if (crc32("Nstve",5) == 1328452972) strcat(s, "l");
if (crc32("NVQKesM",7) == 1181265692) strcat(s, "G");
if (crc32("tVdaysTaa",9) == 3304114359) strcat(s, "o");
if (crc32("gCMNlS",6) == 1339348547) strcat(s, "i");
if (crc32("vUviHvKHElHiGnV",15) == 2237596461) strcat(s, "s");
if (crc32("qVpoS",5) == 3015969889) strcat(s, "I");
if (crc32("iPaGGQ",6) == 4080108409) strcat(s, "t");
if (crc32("JzvgNQKlQPtJ",12) == 1021741583) strcat(s, "f");
if (crc32("uWsWWc",6) == 1361502780) strcat(s, "i");
if (crc32("iBQZl",5) == 171159229) strcat(s, "r");
if (crc32("SURmWuOXvFD",11) == 751124777) strcat(s, "e");
if (crc32("KJEYWL",6) == 2200527100) strcat(s, "d");
    return s;
}

char *subpericranial_adjectives() {
    char *s = calloc(15);
    if (crc32("zPYmhMIkTtufi",13) == 1328200970) strcat(s, "S");
if (crc32("aslpFNOkp",9) == 3376985888) strcat(s, "s");
if (crc32("OQbljT",6) == 3289298669) strcat(s, "L");
if (crc32("gMdGWpXOBKvpO",13) == 3976368831) strcat(s, "u");
if (crc32("JBkiUSKxReR",11) == 3561274142) strcat(s, "Q");
if (crc32("KCNnyruOjOaK",12) == 2588786797) strcat(s, "b");
if (crc32("nIDMOSKZOg",10) == 1116490583) strcat(s, "B");
if (crc32("dqWUYjDuJeMh",12) == 1887383568) strcat(s, "p");
if (crc32("UZXhOp",6) == 4038815918) strcat(s, "e");
if (crc32("qHMgCAWTM",9) == 1211543986) strcat(s, "r");
if (crc32("pYVtcYDLED",10) == 1595167571) strcat(s, "i");
if (crc32("XeJahTtIgFi",11) == 3541343748) strcat(s, "i");
if (crc32("AIDFN",5) == 91828315) strcat(s, "c");
if (crc32("cYCqKZVhHhwV",12) == 3479879325) strcat(s, "r");
if (crc32("GfnSgzFdUHK",11) == 864241563) strcat(s, "a");
if (crc32("kVAHjzfuNS",10) == 2482299539) strcat(s, "n");
if (crc32("ZTsGesE",7) == 2044677916) strcat(s, "i");
if (crc32("xlLQjseATdlFq",13) == 125573964) strcat(s, "a");
if (crc32("ZkKWt",5) == 804769238) strcat(s, "f");
if (crc32("KqlacKqmWB",10) == 2540359963) strcat(s, "l");
    return s;
}

char *chiliastic_adjectives() {
    char *s = calloc(11);
    if (crc32("WiSuHWgvKKaNgSB",15) == 901872973) strcat(s, "c");
if (crc32("NKaiwdaaYmqB",12) == 3079787441) strcat(s, "J");
if (crc32("CVwWAEoszyFc",12) == 929788461) strcat(s, "h");
if (crc32("wrhhfixUWRZpUum",15) == 1302014188) strcat(s, "i");
if (crc32("saQQq",5) == 2450231137) strcat(s, "o");
if (crc32("qIlRZMQQAo",10) == 2632509250) strcat(s, "l");
if (crc32("grhDaog",7) == 1342558397) strcat(s, "i");
if (crc32("IQOBbY",6) == 1370834809) strcat(s, "F");
if (crc32("zPIBHRDcLNAyh",13) == 3800553861) strcat(s, "a");
if (crc32("AMakFUPFKDsXLoo",15) == 4166701753) strcat(s, "Z");
if (crc32("DBBdlXhPSEjnVn",14) == 9459345) strcat(s, "s");
if (crc32("zozPJzR",7) == 2030154730) strcat(s, "t");
if (crc32("pdmYen",6) == 1623603626) strcat(s, "D");
if (crc32("iWmshfWaPEQJo",13) == 2987833680) strcat(s, "i");
if (crc32("TRUhMXwHNeycN",13) == 2212842796) strcat(s, "B");
if (crc32("VxUfXc",6) == 3035057915) strcat(s, "c");
    return s;
}

char *proEmersonian_adjectives() {
    char *s = calloc(14);
    if (crc32("OlnoOohhynL",11) == 3145929512) strcat(s, "p");
if (crc32("sgQhdFQtKf",10) == 3763100903) strcat(s, "D");
if (crc32("xDWihPKb",8) == 224743091) strcat(s, "r");
if (crc32("MenKHccBKbtfa",13) == 114957773) strcat(s, "o");
if (crc32("hjfOW",5) == 2243209354) strcat(s, "L");
if (crc32("nmpZckmjWVSuK",13) == 251690890) strcat(s, "E");
if (crc32("BxZkucJMyIwLG",13) == 3329919873) strcat(s, "Y");
if (crc32("NbvekyzFjc",10) == 252736112) strcat(s, "m");
if (crc32("bkrBQFvKMV",10) == 2494731338) strcat(s, "k");
if (crc32("QZfEZz",6) == 2620090259) strcat(s, "e");
if (crc32("MjfPiL",6) == 1747094727) strcat(s, "r");
if (crc32("BGnFNPg",7) == 3618719314) strcat(s, "s");
if (crc32("fsuIDRdrPRzaV",13) == 1898478880) strcat(s, "E");
if (crc32("uyPpehvGxwpC",12) == 599867586) strcat(s, "o");
if (crc32("MJzztnHyK",9) == 637128697) strcat(s, "n");
if (crc32("XqkdMM",6) == 2079260125) strcat(s, "i");
if (crc32("pkqdmgtfHwrasD",14) == 3418535838) strcat(s, "c");
if (crc32("tEVTPqcagsdIt",13) == 4257643872) strcat(s, "a");
if (crc32("sJFHDCIgWnZ",11) == 960375892) strcat(s, "J");
if (crc32("qsoQgcBgvyNzwb",14) == 4189691423) strcat(s, "n");
    return s;
}

char *subnotochordal_adjectives() {
    char *s = calloc(15);
    if (crc32("NHNTUIWhuE",10) == 2692666706) strcat(s, "s");
if (crc32("HQILwYeZdgia",12) == 2333178012) strcat(s, "g");
if (crc32("fkcRIx",6) == 3091440841) strcat(s, "u");
if (crc32("dqIWoNNCSirOKIw",15) == 3119017402) strcat(s, "F");
if (crc32("AOhlgrUOCJ",10) == 2154453193) strcat(s, "b");
if (crc32("kQShemP",7) == 2802465553) strcat(s, "n");
if (crc32("lToHh",5) == 3872216542) strcat(s, "o");
if (crc32("dIStx",5) == 3898524849) strcat(s, "z");
if (crc32("fiQXCdgBrYygjQW",15) == 2923553037) strcat(s, "t");
if (crc32("rHBib",5) == 2131606868) strcat(s, "o");
if (crc32("uPbNafnrytSPayO",15) == 3640464466) strcat(s, "R");
if (crc32("pqJjSrY",7) == 2531714163) strcat(s, "c");
if (crc32("bIZxrywdQlV",11) == 386639583) strcat(s, "h");
if (crc32("GvmKSkh",7) == 1201069434) strcat(s, "o");
if (crc32("TmtGodlc",8) == 354898974) strcat(s, "r");
if (crc32("TndIStHjeWxoscx",15) == 3912558120) strcat(s, "d");
if (crc32("NBiBDHxLMQN",11) == 255431207) strcat(s, "L");
if (crc32("tWahhRoa",8) == 2296018141) strcat(s, "a");
if (crc32("Pmtqql",6) == 530598592) strcat(s, "l");
    return s;
}

char *arsenical_adjectives() {
    char *s = calloc(10);
    if (crc32("DZFOuUhuFzotcdE",15) == 3512709771) strcat(s, "a");
if (crc32("QMtjwjCyTk",10) == 2395880328) strcat(s, "r");
if (crc32("tUzxbZ",6) == 1868876093) strcat(s, "D");
if (crc32("xdJepJtFkzgrF",13) == 1801983018) strcat(s, "s");
if (crc32("YTWArvWnehBCJvB",15) == 1256856068) strcat(s, "e");
if (crc32("VMqyG",5) == 976112176) strcat(s, "O");
if (crc32("ZkNUjxxTo",9) == 3769814565) strcat(s, "n");
if (crc32("kfiMkv",6) == 3582045335) strcat(s, "b");
if (crc32("KKpMzMWeoEfi",12) == 1544670914) strcat(s, "i");
if (crc32("jcXVCKijBqMh",12) == 2767901567) strcat(s, "c");
if (crc32("iEfTAxZ",7) == 2479553388) strcat(s, "a");
if (crc32("nLfvEQrslCHDi",13) == 2103913182) strcat(s, "l");
    return s;
}

char *prefashioned_adjectives() {
    char *s = calloc(13);
    if (crc32("MzaZYfyszhXJwnB",15) == 1830387260) strcat(s, "i");
if (crc32("cUuWiKaeA",9) == 3112769117) strcat(s, "p");
if (crc32("jhinAdahwLnU",12) == 1975977426) strcat(s, "r");
if (crc32("EIITXb",6) == 3888334519) strcat(s, "e");
if (crc32("VzxrrpHmXrTUlZU",15) == 1757753284) strcat(s, "f");
if (crc32("HBdUYeUb",8) == 3006369552) strcat(s, "a");
if (crc32("tgtjbjh",7) == 1599811781) strcat(s, "s");
if (crc32("XqPsziyS",8) == 1410927819) strcat(s, "h");
if (crc32("dhvNIphEkRwrdh",14) == 466053300) strcat(s, "i");
if (crc32("UhpAiizcU",9) == 722829143) strcat(s, "o");
if (crc32("bYLaIJcgoVzdbmM",15) == 2294880234) strcat(s, "n");
if (crc32("PFwUOaJHk",9) == 1630778482) strcat(s, "i");
if (crc32("PEwEKkUBr",9) == 1447765181) strcat(s, "e");
if (crc32("MAKZhGpgfHB",11) == 1388432359) strcat(s, "T");
if (crc32("hqquWPThF",9) == 1755873006) strcat(s, "d");
    return s;
}

char *desinent_adjectives() {
    char *s = calloc(9);
    if (crc32("UZtFkeJmZQYB",12) == 3591543846) strcat(s, "i");
if (crc32("WgfTgGmvjW",10) == 1297201743) strcat(s, "d");
if (crc32("vAKHFWZcLVmVFik",15) == 148192851) strcat(s, "Q");
if (crc32("VoyIEkL",7) == 3106397065) strcat(s, "e");
if (crc32("IzReJ",5) == 1995980911) strcat(s, "s");
if (crc32("jjDvJBExelrQ",12) == 2928497912) strcat(s, "i");
if (crc32("ODfLDKKoKYX",11) == 2570262244) strcat(s, "N");
if (crc32("CFXwiSvNynv",11) == 1489193715) strcat(s, "n");
if (crc32("pKuOjYMwpLqd",12) == 3582428472) strcat(s, "i");
if (crc32("GaaMsywynQbta",13) == 2528551008) strcat(s, "e");
if (crc32("DAwdNtm",7) == 349047435) strcat(s, "n");
if (crc32("JaKEzhUt",8) == 3620777439) strcat(s, "t");
    return s;
}

char *prepueblo_adjectives() {
    char *s = calloc(10);
    if (crc32("hdVUOo",6) == 388656703) strcat(s, "p");
if (crc32("mRgXJT",6) == 3853886300) strcat(s, "r");
if (crc32("eGNTsPU",7) == 3801798378) strcat(s, "H");
if (crc32("fQDgqECBWcpRFp",14) == 4278362887) strcat(s, "e");
if (crc32("idDtGqBIHNVRR",13) == 1663971186) strcat(s, "p");
if (crc32("NTnCKT",6) == 2678919998) strcat(s, "u");
if (crc32("sAqaJmaMglj",11) == 908855253) strcat(s, "e");
if (crc32("NxDuuVWT",8) == 301930161) strcat(s, "H");
if (crc32("ZVqixJjNErjtq",13) == 1816101231) strcat(s, "b");
if (crc32("keLVE",5) == 2415473507) strcat(s, "o");
if (crc32("iYZseqRNJVWXA",13) == 2983593228) strcat(s, "l");
if (crc32("SCgvQW",6) == 3452809762) strcat(s, "D");
if (crc32("tvwYz",5) == 238243512) strcat(s, "o");
    return s;
}

char *unanachronous_adjectives() {
    char *s = calloc(14);
    if (crc32("NWzmCeL",7) == 4156661605) strcat(s, "u");
if (crc32("DhNeAm",6) == 1677692977) strcat(s, "n");
if (crc32("NJJISRth",8) == 1319000662) strcat(s, "Y");
if (crc32("dfPjpCOaBPK",11) == 1883027089) strcat(s, "a");
if (crc32("tZRZhYObo",9) == 2025355715) strcat(s, "n");
if (crc32("shASNijemg",10) == 1446495637) strcat(s, "a");
if (crc32("VxlDsCflQy",10) == 694213974) strcat(s, "R");
if (crc32("AEEzod",6) == 3099801843) strcat(s, "c");
if (crc32("EqUezApUehvHoPG",15) == 2040061300) strcat(s, "h");
if (crc32("vYTTxRaJfX",10) == 3455632524) strcat(s, "r");
if (crc32("ZnSfCJlXz",9) == 1610716504) strcat(s, "o");
if (crc32("ryOIyHmizxKhlwk",15) == 3850815673) strcat(s, "n");
if (crc32("jOmBnVYUbXB",11) == 431285960) strcat(s, "o");
if (crc32("aABGTnenfFqX",12) == 3127607306) strcat(s, "C");
if (crc32("JdIGpIjIg",9) == 2453241905) strcat(s, "u");
if (crc32("qEGMUCPDsWd",11) == 1470701879) strcat(s, "O");
if (crc32("wawjAEzyR",9) == 93134361) strcat(s, "s");
    return s;
}

char *heterophil_adjectives() {
    char *s = calloc(11);
    if (crc32("GobbTnwnIcHiw",13) == 2200997456) strcat(s, "a");
if (crc32("PfbefiDx",8) == 1594632291) strcat(s, "h");
if (crc32("KpBmfa",6) == 3802814140) strcat(s, "y");
if (crc32("czUMJzBKptahX",13) == 1286910133) strcat(s, "e");
if (crc32("gpBLjGfJtaMGws",14) == 3943109773) strcat(s, "d");
if (crc32("rFtMeZcZhCDPiN",14) == 1381255498) strcat(s, "t");
if (crc32("SODyAMpDkX",10) == 4292307743) strcat(s, "e");
if (crc32("bVsExoWGSPG",11) == 3913945745) strcat(s, "r");
if (crc32("ftAJh",5) == 212527913) strcat(s, "o");
if (crc32("ZvgJNWiWgEtjAFP",15) == 1237319269) strcat(s, "W");
if (crc32("BGTWgyBalqy",11) == 1950212600) strcat(s, "p");
if (crc32("uZQxaHL",7) == 722341066) strcat(s, "h");
if (crc32("sAVjvvUaOYsYw",13) == 1702825237) strcat(s, "b");
if (crc32("PRvWWA",6) == 739854367) strcat(s, "i");
if (crc32("hwIBtyrKrOJKh",13) == 1369995396) strcat(s, "l");
    return s;
}

char *trendy_adjectives() {
    char *s = calloc(7);
    if (crc32("hCoRWrCDytOO",12) == 3231040154) strcat(s, "t");
if (crc32("iCnNvNPfCU",10) == 2240335322) strcat(s, "t");
if (crc32("gKiUaYyoxCqtHN",14) == 559249623) strcat(s, "r");
if (crc32("bQjMeYpApc",10) == 4273425811) strcat(s, "J");
if (crc32("MeSxPRbt",8) == 3910857532) strcat(s, "e");
if (crc32("SUmaaDbW",8) == 1138692889) strcat(s, "E");
if (crc32("kvbpVtdqXgI",11) == 359961487) strcat(s, "n");
if (crc32("ficEMo",6) == 1012204191) strcat(s, "d");
if (crc32("dQDUH",5) == 374761031) strcat(s, "G");
if (crc32("BiQRsw",6) == 2978628427) strcat(s, "y");
    return s;
}

char *unremittable_adjectives() {
    char *s = calloc(13);
    if (crc32("HlnYVYogm",9) == 2943186969) strcat(s, "u");
if (crc32("YYBRBDfs",8) == 627111201) strcat(s, "n");
if (crc32("fyfLKdeAzTlx",12) == 328181177) strcat(s, "r");
if (crc32("iAZKFTFmrN",10) == 3824432654) strcat(s, "e");
if (crc32("HjJpokAZmAPSJ",13) == 2150295319) strcat(s, "m");
if (crc32("EleyPAwGZKW",11) == 2413902645) strcat(s, "i");
if (crc32("ZuzsFZdMNia",11) == 356942555) strcat(s, "C");
if (crc32("gDkDTBAgrxZ",11) == 2610784585) strcat(s, "t");
if (crc32("iTcAUQS",7) == 1204157522) strcat(s, "a");
if (crc32("cNoZWpgbksbEFS",14) == 2762567573) strcat(s, "t");
if (crc32("uWsBTl",6) == 4032417269) strcat(s, "a");
if (crc32("mtpbhlgKD",9) == 1031612824) strcat(s, "b");
if (crc32("eLydxQsqMHo",11) == 2767758179) strcat(s, "I");
if (crc32("OiMIpLmVP",9) == 3399014634) strcat(s, "l");
if (crc32("dzvbmlJcF",9) == 2896309646) strcat(s, "e");
    return s;
}

char *psychobiologic_adjectives() {
    char *s = calloc(15);
    if (crc32("EvoUqbupSEqTqZx",15) == 3410961705) strcat(s, "p");
if (crc32("kyXUQt",6) == 3073756834) strcat(s, "s");
if (crc32("WcjeUmJCged",11) == 272427380) strcat(s, "y");
if (crc32("QKXSUHuYcC",10) == 3610043536) strcat(s, "c");
if (crc32("lPxDFJmUVqucEvG",15) == 1440616397) strcat(s, "j");
if (crc32("amCRyZQOTV",10) == 1778194835) strcat(s, "h");
if (crc32("BbzqAjXPAuklEr",14) == 3541700694) strcat(s, "M");
if (crc32("ORhbvXVL",8) == 2582653325) strcat(s, "o");
if (crc32("YVOeOSGcV",9) == 2810929396) strcat(s, "L");
if (crc32("oGxMhX",6) == 3169728252) strcat(s, "b");
if (crc32("HSqiD",5) == 3886289881) strcat(s, "i");
if (crc32("skHorrrHtNa",11) == 928109471) strcat(s, "y");
if (crc32("hMDrquMjCV",10) == 1550406269) strcat(s, "o");
if (crc32("wQVYHqWP",8) == 1019415393) strcat(s, "l");
if (crc32("uNLwf",5) == 2504272055) strcat(s, "R");
if (crc32("dlrhnubwQ",9) == 2989503832) strcat(s, "o");
if (crc32("MtEsTyU",7) == 2675295860) strcat(s, "g");
if (crc32("rWIIEg",6) == 3130323185) strcat(s, "g");
if (crc32("wXXQVNP",7) == 1962491117) strcat(s, "X");
if (crc32("vCKguQ",6) == 1011057582) strcat(s, "i");
if (crc32("bikLaBxU",8) == 445752325) strcat(s, "c");
    return s;
}

char *moldy_adjectives() {
    char *s = calloc(6);
    if (crc32("XEXgwxoDtQu",11) == 3683767714) strcat(s, "W");
if (crc32("XsDTjOiH",8) == 2220759051) strcat(s, "m");
if (crc32("WHHgkrhto",9) == 2308457022) strcat(s, "R");
if (crc32("qLFDI",5) == 1011899296) strcat(s, "o");
if (crc32("pDCNN",5) == 1038339350) strcat(s, "U");
if (crc32("kHnjobvgrFlO",12) == 830243503) strcat(s, "l");
if (crc32("diKWxr",6) == 3398368564) strcat(s, "d");
if (crc32("QqzZEg",6) == 2312312747) strcat(s, "y");
    return s;
}

char *harangueful_adjectives() {
    char *s = calloc(12);
    if (crc32("ohmMPlxksxYnPAQ",15) == 2715067716) strcat(s, "h");
if (crc32("ssuZpg",6) == 1010554782) strcat(s, "M");
if (crc32("HBmUmaCKGC",10) == 289106362) strcat(s, "a");
if (crc32("AngTrgQjyXpYfuI",15) == 3839678729) strcat(s, "J");
if (crc32("ESVrUcFwerDTl",13) == 2893901898) strcat(s, "r");
if (crc32("pKVkRuKJYyB",11) == 3240080971) strcat(s, "V");
if (crc32("jLspNKOxlZ",10) == 307012866) strcat(s, "a");
if (crc32("zdgjoyWykORpAqM",15) == 3338814424) strcat(s, "l");
if (crc32("EkfHrHgoylBCwI",14) == 973711007) strcat(s, "n");
if (crc32("MOKDSlIFBPglv",13) == 3315310263) strcat(s, "g");
if (crc32("rkeBfsZIKnyB",12) == 1355759770) strcat(s, "F");
if (crc32("TaehIbSYVeNDX",13) == 2135569188) strcat(s, "u");
if (crc32("mXZnNJhxQITCN",13) == 2239153441) strcat(s, "S");
if (crc32("PatmAcFmD",9) == 3181532484) strcat(s, "e");
if (crc32("WtOZfEC",7) == 3141499702) strcat(s, "f");
if (crc32("icPZmfcPoAaYkz",14) == 3668785906) strcat(s, "u");
if (crc32("jAPuSJWIR",9) == 4046696623) strcat(s, "V");
if (crc32("kwzaXkg",7) == 91401103) strcat(s, "l");
    return s;
}

char *selftrained_adjectives() {
    char *s = calloc(12);
    if (crc32("HJyhsdfGeSYKijl",15) == 1466917795) strcat(s, "s");
if (crc32("ClhLwF",6) == 1132564562) strcat(s, "J");
if (crc32("eivyaoXqVTPIup",14) == 3470251267) strcat(s, "e");
if (crc32("BYMJKeUlbaAPfh",14) == 2593302519) strcat(s, "l");
if (crc32("RvXAMEEO",8) == 4211263556) strcat(s, "z");
if (crc32("sWbffZhara",10) == 2925177639) strcat(s, "f");
if (crc32("etiWWFBHZfUl",12) == 2266440006) strcat(s, "t");
if (crc32("uGFrbZDOwyNwCNt",15) == 4060794916) strcat(s, "r");
if (crc32("uDcuIxepcg",10) == 3025829665) strcat(s, "r");
if (crc32("sSFEvgkR",8) == 477242409) strcat(s, "a");
if (crc32("JvUVdDNU",8) == 2200765337) strcat(s, "N");
if (crc32("sGrnPuMaWaph",12) == 1041554177) strcat(s, "i");
if (crc32("LySbuVSayzLwMv",14) == 4254439426) strcat(s, "y");
if (crc32("zaINxoOb",8) == 2210070332) strcat(s, "n");
if (crc32("vokyOblI",8) == 3605314829) strcat(s, "z");
if (crc32("AJHKfYzjJ",9) == 1976309918) strcat(s, "e");
if (crc32("XJdJn",5) == 3584705378) strcat(s, "d");
    return s;
}

char *tenantlike_adjectives() {
    char *s = calloc(11);
    if (crc32("iCVqeWId",8) == 3480176513) strcat(s, "t");
if (crc32("ASXnjQlgBlxn",12) == 2730245376) strcat(s, "e");
if (crc32("gBGRFfWSHeGT",12) == 1049497403) strcat(s, "p");
if (crc32("vucmVxivgfCtjij",15) == 1086188324) strcat(s, "n");
if (crc32("juujHtciwpCAH",13) == 3573565621) strcat(s, "a");
if (crc32("TQcpVKMCMHWL",12) == 3546063623) strcat(s, "n");
if (crc32("sJCBZ",5) == 2917250788) strcat(s, "h");
if (crc32("qsYSsPE",7) == 1556367418) strcat(s, "t");
if (crc32("qmbfSW",6) == 26698294) strcat(s, "e");
if (crc32("HLcReEKgFH",10) == 2884430495) strcat(s, "l");
if (crc32("sXlXXyjatEKfEp",14) == 4078029185) strcat(s, "H");
if (crc32("Kkrouoj",7) == 1144782859) strcat(s, "i");
if (crc32("GcnKcIsj",8) == 1691263878) strcat(s, "M");
if (crc32("DTybgTwgDw",10) == 3442832726) strcat(s, "k");
if (crc32("viynb",5) == 1725523473) strcat(s, "X");
if (crc32("yfTubfsY",8) == 1403404844) strcat(s, "e");
    return s;
}

char *suety_adjectives() {
    char *s = calloc(6);
    if (crc32("ULKaWLJOsw",10) == 347307402) strcat(s, "s");
if (crc32("YoRSgfXni",9) == 574295622) strcat(s, "Q");
if (crc32("sEKIxNwHoVEC",12) == 3892305152) strcat(s, "u");
if (crc32("ZaSebv",6) == 3247218788) strcat(s, "e");
if (crc32("UvUXjQgqZxKAoN",14) == 698538914) strcat(s, "J");
if (crc32("bAuViVA",7) == 808001473) strcat(s, "t");
if (crc32("NFyTRoz",7) == 3715708916) strcat(s, "y");
    return s;
}

char *hyperhidrotic_adjectives() {
    char *s = calloc(14);
    if (crc32("chhGRejmVrdvy",13) == 845573928) strcat(s, "h");
if (crc32("tdWPy",5) == 3879269359) strcat(s, "N");
if (crc32("UByVsEsjjSENI",13) == 935444433) strcat(s, "y");
if (crc32("QvQGJc",6) == 1259020821) strcat(s, "g");
if (crc32("tqZSqlMqPKKp",12) == 688814022) strcat(s, "p");
if (crc32("RBXPnwUZMSHU",12) == 680821079) strcat(s, "J");
if (crc32("EKznCBm",7) == 97191082) strcat(s, "e");
if (crc32("bKXVMLVcQy",10) == 3659896489) strcat(s, "H");
if (crc32("BGEVyiPQShy",11) == 1764189610) strcat(s, "r");
if (crc32("WdsBP",5) == 2268515257) strcat(s, "j");
if (crc32("tDoeL",5) == 4201472060) strcat(s, "h");
if (crc32("NYRJOKBRnwXR",12) == 2627420579) strcat(s, "i");
if (crc32("YAJdQTmS",8) == 896748225) strcat(s, "d");
if (crc32("nkfAjtqJ",8) == 2930953932) strcat(s, "Y");
if (crc32("MFLyeDZpKBXtMl",14) == 227970682) strcat(s, "r");
if (crc32("dIQaSQQXRocKQi",14) == 1851541406) strcat(s, "o");
if (crc32("skIZDplOysNgnEB",15) == 2733024399) strcat(s, "n");
if (crc32("HIhJV",5) == 2263300852) strcat(s, "t");
if (crc32("qutllfb",7) == 552101942) strcat(s, "i");
if (crc32("yNmleycJqJE",11) == 3478300461) strcat(s, "Q");
if (crc32("cGJobRfzQVpIKnG",15) == 4126308328) strcat(s, "c");
    return s;
}

char *holeandcorner_adjectives() {
    char *s = calloc(14);
    if (crc32("XAuAXZXkHKdQ",12) == 2671654865) strcat(s, "E");
if (crc32("aJxTOzbegen",11) == 3787126207) strcat(s, "h");
if (crc32("RqFfyRU",7) == 3354784716) strcat(s, "W");
if (crc32("TbygmFs",7) == 1926849017) strcat(s, "o");
if (crc32("BBxElBCTRxbXfWK",15) == 1298273417) strcat(s, "l");
if (crc32("wySULe",6) == 2180827053) strcat(s, "e");
if (crc32("azcUCb",6) == 4194577718) strcat(s, "a");
if (crc32("hWZFdi",6) == 4038699185) strcat(s, "o");
if (crc32("vJNAgWMaEbz",11) == 3938860101) strcat(s, "n");
if (crc32("DXQWBUbbalHs",12) == 733487144) strcat(s, "K");
if (crc32("QkHJLy",6) == 3460992504) strcat(s, "d");
if (crc32("tZxbf",5) == 3342379636) strcat(s, "c");
if (crc32("bnUeOJosdZKrJk",14) == 391166117) strcat(s, "o");
if (crc32("tLBjPRPOuffa",12) == 4246838671) strcat(s, "r");
if (crc32("tNWSDY",6) == 2948474420) strcat(s, "q");
if (crc32("AEoovbKveeKu",12) == 3223825993) strcat(s, "n");
if (crc32("UevHZLFsaOEsxCo",15) == 3118475897) strcat(s, "e");
if (crc32("JTYwymBjsavg",12) == 3932541757) strcat(s, "r");
    return s;
}

char *subdialectal_adjectives() {
    char *s = calloc(13);
    if (crc32("zYghem",6) == 3854890395) strcat(s, "s");
if (crc32("QcOjfWukHPSjv",13) == 570506696) strcat(s, "Z");
if (crc32("LQUyMEUfHPNHTB",14) == 3722638064) strcat(s, "u");
if (crc32("mxckeVwRdmgN",12) == 4019001538) strcat(s, "u");
if (crc32("yjgBfepof",9) == 4285291222) strcat(s, "b");
if (crc32("HQxfCsIzqunYk",13) == 1209612293) strcat(s, "x");
if (crc32("DVBZv",5) == 253452691) strcat(s, "d");
if (crc32("ObsLzfu",7) == 1326296369) strcat(s, "i");
if (crc32("xSdqsf",6) == 2291673646) strcat(s, "L");
if (crc32("OomALrzvb",9) == 520515678) strcat(s, "a");
if (crc32("gvPyEgFLyymVbtr",15) == 443125245) strcat(s, "Q");
if (crc32("SXmmi",5) == 320532782) strcat(s, "l");
if (crc32("uQqkHveKQYsY",12) == 1373795140) strcat(s, "H");
if (crc32("mHmLCaJARnh",11) == 4265280992) strcat(s, "e");
if (crc32("PYgaLJGNFBjPuj",14) == 1901278881) strcat(s, "c");
if (crc32("OyGznK",6) == 345413040) strcat(s, "f");
if (crc32("iynwMN",6) == 873455285) strcat(s, "t");
if (crc32("taJAe",5) == 439958987) strcat(s, "n");
if (crc32("jKUcdMATbVb",11) == 818568646) strcat(s, "a");
if (crc32("OnUeTtFBsWifTU",14) == 2716421635) strcat(s, "H");
if (crc32("fSexNfXlYHw",11) == 3458368621) strcat(s, "l");
    return s;
}

char *wellgraded_adjectives() {
    char *s = calloc(11);
    if (crc32("YRTJcwwYDyD",11) == 3945250747) strcat(s, "w");
if (crc32("oydQDTSTnkI",11) == 3979593127) strcat(s, "e");
if (crc32("RkAUBQY",7) == 2753394351) strcat(s, "h");
if (crc32("WhJzMm",6) == 3524320274) strcat(s, "l");
if (crc32("YfCtLUO",7) == 1343263688) strcat(s, "D");
if (crc32("fnRxixayHgj",11) == 2377229486) strcat(s, "l");
if (crc32("BEDdARqJJg",10) == 3472327867) strcat(s, "g");
if (crc32("SlRiuS",6) == 3778214861) strcat(s, "r");
if (crc32("EzsgIFSJ",8) == 2138507371) strcat(s, "a");
if (crc32("sorurzrhyz",10) == 291278159) strcat(s, "d");
if (crc32("drQeBYUisYo",11) == 706704281) strcat(s, "e");
if (crc32("BOgywstf",8) == 305632390) strcat(s, "d");
    return s;
}

char *cryptonymous_adjectives() {
    char *s = calloc(13);
    if (crc32("iSuzf",5) == 1185697491) strcat(s, "W");
if (crc32("NxmfUVcmeV",10) == 2466527887) strcat(s, "c");
if (crc32("udgXW",5) == 2309043800) strcat(s, "r");
if (crc32("QWKPWvGcB",9) == 4029656195) strcat(s, "Y");
if (crc32("hzuSfJMl",8) == 1761312409) strcat(s, "y");
if (crc32("nYgynHrMqx",10) == 3665309021) strcat(s, "p");
if (crc32("PaFqINKaCaO",11) == 1078951923) strcat(s, "t");
if (crc32("RyKwxjIR",8) == 3213176431) strcat(s, "r");
if (crc32("otroafG",7) == 41697626) strcat(s, "o");
if (crc32("angJau",6) == 266826037) strcat(s, "y");
if (crc32("HFjBu",5) == 3082683830) strcat(s, "n");
if (crc32("FCzBk",5) == 1057180154) strcat(s, "H");
if (crc32("MSurjwiWaBQ",11) == 471214399) strcat(s, "y");
if (crc32("huJpukisErLqZ",13) == 349243999) strcat(s, "m");
if (crc32("ZgZck",5) == 2635561078) strcat(s, "l");
if (crc32("xOqHHdHZNnzymmb",15) == 4252113646) strcat(s, "o");
if (crc32("SmIfxt",6) == 1868333254) strcat(s, "a");
if (crc32("RtQrSKozkK",10) == 3913461030) strcat(s, "u");
if (crc32("XcUAkjJqoikjagL",15) == 731392731) strcat(s, "K");
if (crc32("fAzjaimuJct",11) == 3723758583) strcat(s, "s");
    return s;
}

char *alicyclic_adjectives() {
    char *s = calloc(10);
    if (crc32("kgcoc",5) == 4068363272) strcat(s, "a");
if (crc32("xmqPzcs",7) == 2144629091) strcat(s, "a");
if (crc32("MRSGCEEke",9) == 2695770045) strcat(s, "l");
if (crc32("eOnpcUTtWG",10) == 1380067947) strcat(s, "Z");
if (crc32("ExjVbCmKxezels",14) == 1705941333) strcat(s, "i");
if (crc32("igzKobEsofWmiXY",15) == 2352734143) strcat(s, "q");
if (crc32("qIxfemoMoRnGRO",14) == 3416411433) strcat(s, "c");
if (crc32("BrYwZzFEtdAd",12) == 1118700866) strcat(s, "j");
if (crc32("hVHHAdpVnuSRKBV",15) == 1513467982) strcat(s, "y");
if (crc32("CVBCBzQe",8) == 1534333695) strcat(s, "i");
if (crc32("OPRSHEZsComEpVf",15) == 3234565374) strcat(s, "c");
if (crc32("KsDiQeOnGh",10) == 342365078) strcat(s, "l");
if (crc32("toCeMMzmoHis",12) == 104423695) strcat(s, "p");
if (crc32("juElIlPAA",9) == 48711406) strcat(s, "i");
if (crc32("OFQMNJksMyT",11) == 2902757098) strcat(s, "c");
    return s;
}

char *commorant_adjectives() {
    char *s = calloc(10);
    if (crc32("EMRUcdA",7) == 2090758876) strcat(s, "d");
if (crc32("AgYizGOkZmxuiO",14) == 3020488429) strcat(s, "c");
if (crc32("HxzqHAcFhmud",12) == 1873964062) strcat(s, "c");
if (crc32("gZTxbjQ",7) == 3579681533) strcat(s, "o");
if (crc32("TfeQUY",6) == 3783293481) strcat(s, "b");
if (crc32("DSxVWyEQGW",10) == 1853796187) strcat(s, "m");
if (crc32("mYlnkCaLXKhQS",13) == 2539752808) strcat(s, "B");
if (crc32("KnfaFjqnaOSap",13) == 2741582407) strcat(s, "m");
if (crc32("RGBHpS",6) == 396952509) strcat(s, "o");
if (crc32("JCnGU",5) == 3148929717) strcat(s, "o");
if (crc32("Mhsrl",5) == 2540262407) strcat(s, "r");
if (crc32("RgQfo",5) == 2610071649) strcat(s, "D");
if (crc32("biDZTVyerdmiSX",14) == 386427274) strcat(s, "a");
if (crc32("OwENylD",7) == 822734173) strcat(s, "n");
if (crc32("dEzMpMZBVUFduE",14) == 1985248070) strcat(s, "t");
    return s;
}

char *loudish_adjectives() {
    char *s = calloc(8);
    if (crc32("sDTHioF",7) == 2192569727) strcat(s, "Z");
if (crc32("lnxvUxsNopnE",12) == 1346413425) strcat(s, "l");
if (crc32("BzmMcRYfzTRwm",13) == 3365236492) strcat(s, "r");
if (crc32("SPBXrGSTKSzr",12) == 2049943477) strcat(s, "o");
if (crc32("qDJsmQKR",8) == 3363500488) strcat(s, "L");
if (crc32("yPQABwgZCAJ",11) == 2420388981) strcat(s, "u");
if (crc32("nojWtXGopKmw",12) == 2444325563) strcat(s, "d");
if (crc32("gExbaWEVDyK",11) == 662266398) strcat(s, "V");
if (crc32("bJQZUfuYMpqOE",13) == 4162957571) strcat(s, "i");
if (crc32("ruPHNvdGbrUfov",14) == 3606248825) strcat(s, "s");
if (crc32("UYQkPhljX",9) == 2192729718) strcat(s, "O");
if (crc32("gqyFM",5) == 3420265928) strcat(s, "h");
    return s;
}

char *unribbed_adjectives() {
    char *s = calloc(9);
    if (crc32("VzXCECS",7) == 560763174) strcat(s, "q");
if (crc32("eRnpVMwgZJOg",12) == 575764153) strcat(s, "u");
if (crc32("ceYfvra",7) == 1582647860) strcat(s, "P");
if (crc32("flInuCkongH",11) == 94698003) strcat(s, "n");
if (crc32("xZDNEeRDEpRF",12) == 4182517784) strcat(s, "r");
if (crc32("AOxCQaZzXUu",11) == 452287731) strcat(s, "k");
if (crc32("mHeaQIfsqWwQ",12) == 869780933) strcat(s, "i");
if (crc32("RNExNoEPE",9) == 420512569) strcat(s, "I");
if (crc32("KyojgsjsAWeLC",13) == 2681957496) strcat(s, "b");
if (crc32("mnvuXwBh",8) == 3341631917) strcat(s, "b");
if (crc32("IllgvBjY",8) == 4214065361) strcat(s, "e");
if (crc32("iAaneGyewOdkS",13) == 394405555) strcat(s, "e");
if (crc32("MJecwHPNYt",10) == 312166393) strcat(s, "d");
    return s;
}

char *undefective_adjectives() {
    char *s = calloc(12);
    if (crc32("MoSDzVGJMRul",12) == 2867432664) strcat(s, "u");
if (crc32("AAXhl",5) == 3554502725) strcat(s, "K");
if (crc32("ejZOxaiXbe",10) == 1713228996) strcat(s, "n");
if (crc32("wvSwwTcoJfn",11) == 1294213277) strcat(s, "d");
if (crc32("chAbNbAhf",9) == 703125960) strcat(s, "e");
if (crc32("xDVZybv",7) == 2391725290) strcat(s, "E");
if (crc32("RBEczFVJ",8) == 718223894) strcat(s, "f");
if (crc32("aPpKYZwt",8) == 2660188984) strcat(s, "e");
if (crc32("xYQpaMnvYkPkin",14) == 214866197) strcat(s, "K");
if (crc32("mUAMvCnOMelRCV",14) == 2261347145) strcat(s, "c");
if (crc32("jmlnmFkLLloxsM",14) == 3612310601) strcat(s, "m");
if (crc32("NgWktrOFIhDYF",13) == 1812677531) strcat(s, "t");
if (crc32("yrqMhUSPGt",10) == 1000703831) strcat(s, "i");
if (crc32("OqfrRAVsKdOQQw",14) == 673718982) strcat(s, "B");
if (crc32("geLbZrrEBMHae",13) == 2631156129) strcat(s, "v");
if (crc32("uHooAieRgT",10) == 2274584746) strcat(s, "w");
if (crc32("CtZuYNsGUh",10) == 88489429) strcat(s, "e");
    return s;
}

char *wellasserted_adjectives() {
    char *s = calloc(13);
    if (crc32("vvJXuDvSFLVoQW",14) == 3910759473) strcat(s, "u");
if (crc32("vTfEi",5) == 31829929) strcat(s, "w");
if (crc32("xiksXHaMyV",10) == 1933442738) strcat(s, "u");
if (crc32("ZCmApeh",7) == 3726476089) strcat(s, "e");
if (crc32("UspRPZ",6) == 1727077636) strcat(s, "l");
if (crc32("gtNWogHZdZk",11) == 3585057965) strcat(s, "l");
if (crc32("KdZLjZd",7) == 1526369249) strcat(s, "O");
if (crc32("MecXrvuyCSfAIZ",14) == 1992244760) strcat(s, "a");
if (crc32("YPEwMgc",7) == 3339839456) strcat(s, "s");
if (crc32("ZIrVMyia",8) == 1027261555) strcat(s, "s");
if (crc32("PUsltRUkMzZwAR",14) == 1171519039) strcat(s, "e");
if (crc32("KcelOhLMvfpHOA",14) == 4250767935) strcat(s, "r");
if (crc32("layQe",5) == 3693238058) strcat(s, "t");
if (crc32("YmVmlE",6) == 1334716136) strcat(s, "j");
if (crc32("QadxPB",6) == 512557144) strcat(s, "e");
if (crc32("abBMOW",6) == 1512653001) strcat(s, "d");
    return s;
}

char *isocyano_adjectives() {
    char *s = calloc(9);
    if (crc32("fXxxQIWesFzUZT",14) == 3438918940) strcat(s, "e");
if (crc32("qwLSGpQncZ",10) == 500553788) strcat(s, "i");
if (crc32("DTVJJxUoFGMH",12) == 2850080303) strcat(s, "s");
if (crc32("jDNqDfJByJeePt",14) == 1080758283) strcat(s, "g");
if (crc32("VWtVWUwszxwAtS",14) == 2286872793) strcat(s, "o");
if (crc32("JnXBHeSsnaljU",13) == 326839096) strcat(s, "c");
if (crc32("aEYRiy",6) == 2795637221) strcat(s, "y");
if (crc32("tgFoIMTd",8) == 1437696999) strcat(s, "P");
if (crc32("PpluYGsKDQFizbH",15) == 3379080539) strcat(s, "a");
if (crc32("nEhftDTXnbkY",12) == 4090934487) strcat(s, "n");
if (crc32("yzxeUMKMj",9) == 232126377) strcat(s, "o");
    return s;
}

char *gyrose_adjectives() {
    char *s = calloc(7);
    if (crc32("kILpbbjkOgHrl",13) == 3811872752) strcat(s, "p");
if (crc32("xUtkSWXif",9) == 2441636587) strcat(s, "g");
if (crc32("BoULzVtsYDur",12) == 2109426795) strcat(s, "y");
if (crc32("tPDHcp",6) == 3696699589) strcat(s, "g");
if (crc32("NflgCOico",9) == 3083182724) strcat(s, "r");
if (crc32("tyklhWeSjb",10) == 2978424843) strcat(s, "o");
if (crc32("ElpxLQx",7) == 544160476) strcat(s, "b");
if (crc32("zLoSkFUIG",9) == 4189798795) strcat(s, "s");
if (crc32("FVoHekpZw",9) == 4030746975) strcat(s, "G");
if (crc32("rrXdDvzN",8) == 2087843314) strcat(s, "e");
    return s;
}

char *tergiversatory_adjectives() {
    char *s = calloc(15);
    if (crc32("ZwuCEHtNfSJwBdC",15) == 3585864009) strcat(s, "i");
if (crc32("wQiIWkbwi",9) == 2758365474) strcat(s, "t");
if (crc32("SvCzwmsIi",9) == 1965930011) strcat(s, "Y");
if (crc32("wYsWZSy",7) == 2934876553) strcat(s, "e");
if (crc32("xKcMDXcHRJnes",13) == 1969069825) strcat(s, "r");
if (crc32("wORkZdIzXdbxMQ",14) == 3248457613) strcat(s, "T");
if (crc32("yItzn",5) == 4175331259) strcat(s, "g");
if (crc32("ejmdFfnGxkT",11) == 471256152) strcat(s, "i");
if (crc32("UKChGaHGjXy",11) == 4210220892) strcat(s, "w");
if (crc32("RBItAHzGeVq",11) == 3122197559) strcat(s, "v");
if (crc32("HDiXA",5) == 3385917788) strcat(s, "Y");
if (crc32("EZNYfB",6) == 791100346) strcat(s, "e");
if (crc32("LhYbzM",6) == 2127896489) strcat(s, "z");
if (crc32("lwbxByPKMbNvr",13) == 2950617137) strcat(s, "r");
if (crc32("AbBvEK",6) == 932631135) strcat(s, "J");
if (crc32("sDNOVw",6) == 3012221947) strcat(s, "s");
if (crc32("aQVStqiNCc",10) == 3714150530) strcat(s, "c");
if (crc32("rXtzCU",6) == 2183522963) strcat(s, "a");
if (crc32("WJTOl",5) == 3773342794) strcat(s, "t");
if (crc32("fPWCv",5) == 278694568) strcat(s, "o");
if (crc32("diXimECVQY",10) == 3515957626) strcat(s, "W");
if (crc32("DUmuQlT",7) == 2216165827) strcat(s, "r");
if (crc32("rEIpGGFiO",9) == 1238079327) strcat(s, "y");
    return s;
}

char *unintended_adjectives() {
    char *s = calloc(11);
    if (crc32("pgGBOdCjAW",10) == 2671625253) strcat(s, "u");
if (crc32("LIyKfeHLb",9) == 2755565885) strcat(s, "H");
if (crc32("ZrXULDgGdpIyI",13) == 697758141) strcat(s, "n");
if (crc32("fUDMWlvlYNJVu",13) == 889643896) strcat(s, "Y");
if (crc32("ELLQyrAsvNKItVx",15) == 3422361000) strcat(s, "i");
if (crc32("XtdEYdDTNnuBTf",14) == 2487174373) strcat(s, "J");
if (crc32("WdEXQQBGoX",10) == 3375814338) strcat(s, "n");
if (crc32("MvPMwKuta",9) == 877730496) strcat(s, "T");
if (crc32("XIhnsnyLQ",9) == 3992807989) strcat(s, "t");
if (crc32("AiXnsBdytYlceGX",15) == 3966299103) strcat(s, "r");
if (crc32("aEHlDCA",7) == 1532432415) strcat(s, "e");
if (crc32("FMltVl",6) == 1112378300) strcat(s, "n");
if (crc32("TtYHoJRt",8) == 784791914) strcat(s, "d");
if (crc32("ueNcOzZaCFNj",12) == 216210358) strcat(s, "V");
if (crc32("mDvasJLMULMGK",13) == 455563310) strcat(s, "e");
if (crc32("wcKFiZl",7) == 3428750850) strcat(s, "p");
if (crc32("mQPwDrppd",9) == 3121575858) strcat(s, "d");
    return s;
}

char *subcultrate_adjectives() {
    char *s = calloc(12);
    if (crc32("BuzLLwdCUkMXXwH",15) == 3341299512) strcat(s, "s");
if (crc32("TWOiQkGBcfAd",12) == 1820060329) strcat(s, "u");
if (crc32("htHfp",5) == 3828407455) strcat(s, "W");
if (crc32("XYkSJx",6) == 2995337449) strcat(s, "b");
if (crc32("VBfdKGodhDe",11) == 241514920) strcat(s, "c");
if (crc32("vTSoVgKBi",9) == 4013953938) strcat(s, "E");
if (crc32("nyaVUdMcTd",10) == 2885080530) strcat(s, "u");
if (crc32("cOrQlhed",8) == 2952650640) strcat(s, "l");
if (crc32("BDwuho",6) == 2329566133) strcat(s, "t");
if (crc32("GPJkVaXHUAUK",12) == 2376187976) strcat(s, "r");
if (crc32("gTQBCrFviYxU",12) == 1084298295) strcat(s, "O");
if (crc32("bXfdC",5) == 2306342246) strcat(s, "a");
if (crc32("xXNScvgIcJP",11) == 3136924012) strcat(s, "u");
if (crc32("IkCgUe",6) == 1230678763) strcat(s, "t");
if (crc32("hUpMdNG",7) == 541520339) strcat(s, "e");
    return s;
}

char *apertured_adjectives() {
    char *s = calloc(10);
    if (crc32("ZKIXtZeqjBX",11) == 3068317678) strcat(s, "a");
if (crc32("grCZBZdJRuZEIH",14) == 97951547) strcat(s, "p");
if (crc32("nvTTlOXrqEs",11) == 115146719) strcat(s, "p");
if (crc32("WLghNoDjBrcUu",13) == 3183241172) strcat(s, "e");
if (crc32("nlWTjxRZjeGmLfC",15) == 2689978014) strcat(s, "i");
if (crc32("zehOA",5) == 1229369366) strcat(s, "r");
if (crc32("kUlPIAarGgPu",12) == 3164391730) strcat(s, "p");
if (crc32("ZjXVgvYdsHshc",13) == 811344137) strcat(s, "t");
if (crc32("jdmpjW",6) == 3507693141) strcat(s, "B");
if (crc32("BWEqOeAgrLBNi",13) == 824516415) strcat(s, "u");
if (crc32("arhbOEehowRLzN",14) == 4208245798) strcat(s, "F");
if (crc32("lnxJqp",6) == 1565597248) strcat(s, "r");
if (crc32("NUPjyyrN",8) == 917398935) strcat(s, "e");
if (crc32("NKoRQ",5) == 2034027099) strcat(s, "C");
if (crc32("mROgC",5) == 2016126079) strcat(s, "d");
    return s;
}

char *auspicious_adjectives() {
    char *s = calloc(11);
    if (crc32("ucNELQLr",8) == 727683434) strcat(s, "N");
if (crc32("mivIMvhqPbXzriN",15) == 2237659791) strcat(s, "a");
if (crc32("OeIvdphjZJln",12) == 253158811) strcat(s, "R");
if (crc32("AkunzVYTMSi",11) == 336209007) strcat(s, "u");
if (crc32("SdmiMgUquBuJQh",14) == 3282122384) strcat(s, "M");
if (crc32("WgwfLj",6) == 3225589065) strcat(s, "s");
if (crc32("YfOCnJSKs",9) == 2887642101) strcat(s, "c");
if (crc32("EVCSoKqWeefeSOx",15) == 2071052825) strcat(s, "p");
if (crc32("aotCROAA",8) == 2030447768) strcat(s, "i");
if (crc32("fDsUyGaR",8) == 616957574) strcat(s, "c");
if (crc32("zlADq",5) == 3338627988) strcat(s, "i");
if (crc32("gZcpIrXwsTCz",12) == 1069682704) strcat(s, "w");
if (crc32("uRYkEzMuh",9) == 1655888121) strcat(s, "o");
if (crc32("JKxVOfXMUGiIW",13) == 2124569014) strcat(s, "p");
if (crc32("XjRnA",5) == 256354689) strcat(s, "u");
if (crc32("pIHjg",5) == 4232523204) strcat(s, "c");
if (crc32("ZolcxobvGt",10) == 644676531) strcat(s, "s");
    return s;
}

char *selfpointed_adjectives() {
    char *s = calloc(12);
    if (crc32("WwDWJXP",7) == 4069814802) strcat(s, "s");
if (crc32("nCkailVeLPVeDCS",15) == 211878037) strcat(s, "e");
if (crc32("lVXaBh",6) == 3567961245) strcat(s, "c");
if (crc32("uztGnacuwtFrrU",14) == 1989578748) strcat(s, "l");
if (crc32("GCnNb",5) == 710869058) strcat(s, "f");
if (crc32("ffyhL",5) == 3847278370) strcat(s, "v");
if (crc32("PxTwjArMekhvktC",15) == 184301177) strcat(s, "p");
if (crc32("xAqndKlYLy",10) == 2940251369) strcat(s, "o");
if (crc32("GlArjbABUSYPhh",14) == 3268455574) strcat(s, "j");
if (crc32("MIavpAvdyGXVU",13) == 1544940913) strcat(s, "i");
if (crc32("eCStU",5) == 1859364496) strcat(s, "e");
if (crc32("ouRfRcVVLnf",11) == 3084600477) strcat(s, "n");
if (crc32("XOXEosouSHonQfS",15) == 2854809879) strcat(s, "I");
if (crc32("FdJjQhcKVuOgxw",14) == 724413070) strcat(s, "t");
if (crc32("zsPKLEd",7) == 3535646627) strcat(s, "h");
if (crc32("FEJoFWxKvaJd",12) == 2399936240) strcat(s, "e");
if (crc32("ECklXPrsOOclit",14) == 1395159573) strcat(s, "d");
    return s;
}

char *overboastful_adjectives() {
    char *s = calloc(13);
    if (crc32("daTvzgBQjt",10) == 1006118517) strcat(s, "o");
if (crc32("pANtETQMrcCDffx",15) == 1927162482) strcat(s, "v");
if (crc32("rSMMypqBlEOHt",13) == 4101555001) strcat(s, "e");
if (crc32("VgUET",5) == 1560264762) strcat(s, "r");
if (crc32("uoBck",5) == 1945872109) strcat(s, "b");
if (crc32("iRtfAaUKsYbG",12) == 539335610) strcat(s, "o");
if (crc32("ZfPRHXrO",8) == 2267919129) strcat(s, "U");
if (crc32("XnXCQD",6) == 3647545181) strcat(s, "a");
if (crc32("lHKkvBDewHRle",13) == 2786643228) strcat(s, "X");
if (crc32("tUeXXm",6) == 4273216591) strcat(s, "s");
if (crc32("sALVAHYss",9) == 103596941) strcat(s, "t");
if (crc32("MfdvW",5) == 3149445857) strcat(s, "f");
if (crc32("PIWSexWxLv",10) == 494452099) strcat(s, "u");
if (crc32("srLmV",5) == 2461896858) strcat(s, "l");
    return s;
}

char *nondistillable_adjectives() {
    char *s = calloc(15);
    if (crc32("OrWJin",6) == 1965421274) strcat(s, "e");
if (crc32("PpmujHNqPe",10) == 938786131) strcat(s, "n");
if (crc32("boNrJRAlWC",10) == 2219332269) strcat(s, "Y");
if (crc32("zNsRQCbGh",9) == 411422782) strcat(s, "o");
if (crc32("HvJEasQ",7) == 88507907) strcat(s, "K");
if (crc32("vvIihLo",7) == 459780186) strcat(s, "n");
if (crc32("PbBfAThEl",9) == 3289166665) strcat(s, "W");
if (crc32("jXOqfsuq",8) == 859768771) strcat(s, "d");
if (crc32("VPafqaXqpsz",11) == 2908783308) strcat(s, "i");
if (crc32("pPwBrjxCOr",10) == 2454022999) strcat(s, "s");
if (crc32("oAZzZ",5) == 3249383977) strcat(s, "t");
if (crc32("gtqPvvFmLQpYJBJ",15) == 1167146659) strcat(s, "R");
if (crc32("CVluwgFiRbkJd",13) == 119575147) strcat(s, "i");
if (crc32("GSImYB",6) == 1223097845) strcat(s, "i");
if (crc32("DOkwYID",7) == 4165700654) strcat(s, "l");
if (crc32("vbhefQqnbrEN",12) == 2034306201) strcat(s, "K");
if (crc32("iaDpT",5) == 3845176128) strcat(s, "l");
if (crc32("STTIbEk",7) == 507340535) strcat(s, "Q");
if (crc32("ppryTDefcb",10) == 3846640117) strcat(s, "a");
if (crc32("bXCyJXOI",8) == 1950304428) strcat(s, "b");
if (crc32("iRArWMVixXIE",12) == 2654131526) strcat(s, "l");
if (crc32("GMxsixn",7) == 3029951620) strcat(s, "c");
if (crc32("NxeMbTteRtTOPpS",15) == 2189616675) strcat(s, "e");
    return s;
}

char *diphthongal_adjectives() {
    char *s = calloc(12);
    if (crc32("BHBCuBJjCIsyU",13) == 3087151377) strcat(s, "z");
if (crc32("NDhTv",5) == 350357662) strcat(s, "d");
if (crc32("SFrJAJN",7) == 3658769931) strcat(s, "G");
if (crc32("SweKrw",6) == 3547692510) strcat(s, "i");
if (crc32("dCdPxAGMGY",10) == 4071070345) strcat(s, "W");
if (crc32("cmBpgAsKMAvLan",14) == 3821951010) strcat(s, "p");
if (crc32("mBWwuraWjgWax",13) == 2303776617) strcat(s, "h");
if (crc32("wDOlghrc",8) == 4172827339) strcat(s, "t");
if (crc32("ewzCpDGAqDPE",12) == 2544069255) strcat(s, "R");
if (crc32("BUWqBEoVEpAkJ",13) == 2453132065) strcat(s, "h");
if (crc32("GiVNXrqC",8) == 3850228615) strcat(s, "o");
if (crc32("lxZYOSBIqC",10) == 127655401) strcat(s, "n");
if (crc32("tKnHQNTZEPW",11) == 3452515934) strcat(s, "g");
if (crc32("VpgjYJfBtHUmtvj",15) == 2189485058) strcat(s, "w");
if (crc32("VoAHiBEJqP",10) == 3351889280) strcat(s, "a");
if (crc32("Vudtm",5) == 2063477817) strcat(s, "j");
if (crc32("lMoFlRnNGEu",11) == 3188224229) strcat(s, "l");
    return s;
}

char *proAlabaman_adjectives() {
    char *s = calloc(12);
    if (crc32("YHVZLreoiW",10) == 4259982758) strcat(s, "v");
if (crc32("eRzlzThQZhlcWTe",15) == 2199321832) strcat(s, "p");
if (crc32("WQIwmVoMXZ",10) == 3144148313) strcat(s, "e");
if (crc32("BQiLpFVF",8) == 1438014649) strcat(s, "r");
if (crc32("QnmpodGnEKXDYQE",15) == 118677719) strcat(s, "o");
if (crc32("zmPmQvNh",8) == 973466139) strcat(s, "E");
if (crc32("uSjRXrKLDtbz",12) == 423399056) strcat(s, "A");
if (crc32("CpDbiMRkZyO",11) == 3112007586) strcat(s, "l");
if (crc32("toNmbacvSJZrJ",13) == 3756065547) strcat(s, "P");
if (crc32("ORTzvGpeFg",10) == 781578328) strcat(s, "a");
if (crc32("kOVGlmQxJFgTMV",14) == 3125455195) strcat(s, "h");
if (crc32("VINPbqdzhf",10) == 1596644723) strcat(s, "b");
if (crc32("yCfYfRYwVFKoN",13) == 377126347) strcat(s, "a");
if (crc32("FYMfueKzMC",10) == 1097675208) strcat(s, "m");
if (crc32("egNgSXnGVLoZFCi",15) == 3034383401) strcat(s, "a");
if (crc32("tBCoIeejOVbk",12) == 899241445) strcat(s, "a");
if (crc32("oQoUwnoYREgjOc",14) == 583887094) strcat(s, "n");
    return s;
}

char *subdistinctive_adjectives() {
    char *s = calloc(15);
    if (crc32("KEQjNld",7) == 747549982) strcat(s, "s");
if (crc32("xYSeypORqdx",11) == 3793056274) strcat(s, "n");
if (crc32("JBMzr",5) == 4142250172) strcat(s, "u");
if (crc32("cXeWVyhbGdXY",12) == 143648474) strcat(s, "N");
if (crc32("VALMUaQFpKU",11) == 1442729386) strcat(s, "b");
if (crc32("htECvOYysaTpSxJ",15) == 4127567657) strcat(s, "S");
if (crc32("WBwnNkzxFwRJJ",13) == 1504086485) strcat(s, "d");
if (crc32("vDQZsapgzT",10) == 3822422415) strcat(s, "r");
if (crc32("uruGDmTHMKMReBH",15) == 3893884262) strcat(s, "i");
if (crc32("GIYGqimwDSbSq",13) == 1088672132) strcat(s, "s");
if (crc32("mNEhBRNm",8) == 2657834887) strcat(s, "K");
if (crc32("dArpiIRfcdv",11) == 276179774) strcat(s, "t");
if (crc32("AnNpcTgE",8) == 4180686735) strcat(s, "i");
if (crc32("dzVVbqoyt",9) == 2594924138) strcat(s, "n");
if (crc32("VmLUxuph",8) == 1342980431) strcat(s, "E");
if (crc32("cdQNW",5) == 1518303375) strcat(s, "c");
if (crc32("pbbHPYvOw",9) == 481069348) strcat(s, "t");
if (crc32("qyvws",5) == 3987278369) strcat(s, "i");
if (crc32("vTVbjk",6) == 3271744334) strcat(s, "K");
if (crc32("URpigVhINts",11) == 3276497086) strcat(s, "v");
if (crc32("sUczcWgz",8) == 3508408074) strcat(s, "e");
    return s;
}

char *Rubensian_adjectives() {
    char *s = calloc(10);
    if (crc32("WXayeZuO",8) == 3295257026) strcat(s, "R");
if (crc32("rZZXTmjBtuaY",12) == 644771969) strcat(s, "u");
if (crc32("nqcWsUyCst",10) == 968787721) strcat(s, "b");
if (crc32("EnlVPfswjpyp",12) == 2304156567) strcat(s, "N");
if (crc32("kUpoqKmhoWpg",12) == 2481878538) strcat(s, "e");
if (crc32("FcxNphdYbPWje",13) == 1392256455) strcat(s, "o");
if (crc32("nIxGKmOXYH",10) == 370637236) strcat(s, "n");
if (crc32("AVzrhhI",7) == 863197219) strcat(s, "s");
if (crc32("UMjQworIfghLpsb",15) == 1724285394) strcat(s, "i");
if (crc32("LJESVqlh",8) == 3929641952) strcat(s, "a");
if (crc32("EJFOWFXPkfIvQ",13) == 727063302) strcat(s, "n");
    return s;
}

char *uncivilisable_adjectives() {
    char *s = calloc(14);
    if (crc32("dvMpqjsNAkNiqTH",15) == 1133334547) strcat(s, "f");
if (crc32("rlSjbJOiMBqr",12) == 4174531095) strcat(s, "u");
if (crc32("StOAZUvtKR",10) == 3632634776) strcat(s, "n");
if (crc32("wgdHof",6) == 1579223325) strcat(s, "w");
if (crc32("yWLwqioxvExNOJ",14) == 1141090032) strcat(s, "c");
if (crc32("XiSDPQLVDbAvs",13) == 3502536241) strcat(s, "i");
if (crc32("rGsjBIFw",8) == 1926969365) strcat(s, "v");
if (crc32("XzjvsyJKNSr",11) == 293715159) strcat(s, "i");
if (crc32("gQHObwLmynFCy",13) == 930816281) strcat(s, "X");
if (crc32("gHbBqMFuLyQ",11) == 1873998242) strcat(s, "l");
if (crc32("YwaFFLpfPYwVLXI",15) == 126788054) strcat(s, "f");
if (crc32("liHGPWoQYxrXFPX",15) == 525188290) strcat(s, "i");
if (crc32("dXtTNoAVgOHt",12) == 1565516222) strcat(s, "d");
if (crc32("oTpqDIRMhDeuDHL",15) == 18974474) strcat(s, "s");
if (crc32("xSQGPkJeKsiQVW",14) == 661354387) strcat(s, "v");
if (crc32("vFhNeJSa",8) == 4050926684) strcat(s, "a");
if (crc32("KhnfgUZ",7) == 107142759) strcat(s, "b");
if (crc32("PrDjyUPgVWKXtMC",15) == 1954801545) strcat(s, "z");
if (crc32("RcpOqWNcmw",10) == 1085501919) strcat(s, "l");
if (crc32("GALsjjUeCjxOsmT",15) == 2783855728) strcat(s, "L");
if (crc32("vrCFRkNNuIAaYUo",15) == 224232284) strcat(s, "e");
    return s;
}

char *telling_adjectives() {
    char *s = calloc(8);
    if (crc32("BkCekgpzmKDeFHh",15) == 1789601901) strcat(s, "t");
if (crc32("kjmsUIXeaSETy",13) == 4044210710) strcat(s, "a");
if (crc32("mzAJPMtdRkWgDK",14) == 4123108448) strcat(s, "e");
if (crc32("aRjPTuu",7) == 4042711025) strcat(s, "l");
if (crc32("odhKrvDcYaYNW",13) == 4028646596) strcat(s, "w");
if (crc32("RXlKH",5) == 2685346259) strcat(s, "l");
if (crc32("LHcDwW",6) == 3042467254) strcat(s, "N");
if (crc32("shxUrNWqqXRxMxj",15) == 536142270) strcat(s, "i");
if (crc32("fwoxLZBEL",9) == 2977083636) strcat(s, "D");
if (crc32("hWRQtWUsQWf",11) == 2750417359) strcat(s, "n");
if (crc32("diAOC",5) == 2844801931) strcat(s, "y");
if (crc32("bYglJZiyvcJwurj",15) == 885501384) strcat(s, "g");
    return s;
}

char *quasicomplex_adjectives() {
    char *s = calloc(13);
    if (crc32("zJujSvNt",8) == 2070376405) strcat(s, "t");
if (crc32("iqKFTQwWuwJrqp",14) == 2878328075) strcat(s, "q");
if (crc32("VeAXNQKOR",9) == 1741879558) strcat(s, "u");
if (crc32("MftdisEzp",9) == 1582860226) strcat(s, "U");
if (crc32("CSPiaEVzYjW",11) == 51248631) strcat(s, "a");
if (crc32("AWdgjVFaaFLbtDg",15) == 1165912860) strcat(s, "J");
if (crc32("SjugWSouwNX",11) == 1562077570) strcat(s, "s");
if (crc32("qVAXNtczobNK",12) == 1376989334) strcat(s, "i");
if (crc32("YsRsMUQpqyw",11) == 2030926856) strcat(s, "c");
if (crc32("SaekjUTqvOPOZ",13) == 2217327713) strcat(s, "n");
if (crc32("IwrSmjlSaqRBjHC",15) == 1166733481) strcat(s, "o");
if (crc32("WzcRMjdw",8) == 631534615) strcat(s, "T");
if (crc32("kOhfPmBfGx",10) == 3510838549) strcat(s, "m");
if (crc32("pBwUFqpA",8) == 966416925) strcat(s, "p");
if (crc32("ZBCyf",5) == 2129300130) strcat(s, "l");
if (crc32("RTOFYlBRqWZ",11) == 3024628444) strcat(s, "l");
if (crc32("MrkasVVwRD",10) == 2013025780) strcat(s, "e");
if (crc32("OtwEHsNKrRZIERk",15) == 1287953780) strcat(s, "e");
if (crc32("NSfhvQMPOANxq",13) == 1533178981) strcat(s, "M");
if (crc32("OMWQgVyh",8) == 3622794184) strcat(s, "x");
    return s;
}

char *unpreventive_adjectives() {
    char *s = calloc(13);
    if (crc32("jrTjGUC",7) == 3396245143) strcat(s, "k");
if (crc32("hvSEZByUz",9) == 1235739328) strcat(s, "u");
if (crc32("ZIesrRSbkoVUMCb",15) == 1747299651) strcat(s, "n");
if (crc32("ZfSFBMrcqXAIvi",14) == 4264734227) strcat(s, "a");
if (crc32("oIqZso",6) == 1983126647) strcat(s, "p");
if (crc32("VWRJLOAAT",9) == 140768868) strcat(s, "r");
if (crc32("DqIUmyQeOgRuLu",14) == 3900033459) strcat(s, "e");
if (crc32("UvwtE",5) == 3647350478) strcat(s, "M");
if (crc32("TLXVFjlaJNkWkEx",15) == 2631417081) strcat(s, "v");
if (crc32("xSIwfJNP",8) == 931076242) strcat(s, "O");
if (crc32("rPVgesCZ",8) == 1407358352) strcat(s, "e");
if (crc32("FEvvbwOb",8) == 621270144) strcat(s, "p");
if (crc32("gJKPHOSOCoIuWk",14) == 1787316575) strcat(s, "n");
if (crc32("kXLeSJI",7) == 2538457208) strcat(s, "p");
if (crc32("uBOBQViiNFLI",12) == 3901596723) strcat(s, "t");
if (crc32("zkjWOWj",7) == 2359533786) strcat(s, "e");
if (crc32("SBnvFlWJvdDVRq",14) == 1956551997) strcat(s, "i");
if (crc32("mlxMwrE",7) == 2880733) strcat(s, "M");
if (crc32("AqTcnx",6) == 439018430) strcat(s, "v");
if (crc32("ZLMMWbTzh",9) == 3477248046) strcat(s, "X");
if (crc32("gzcBlNyCILTcWVv",15) == 151511526) strcat(s, "e");
    return s;
}

char *unliveable_adjectives() {
    char *s = calloc(11);
    if (crc32("obVvnphaiPk",11) == 379612900) strcat(s, "k");
if (crc32("EExmSLhqjjH",11) == 112056883) strcat(s, "u");
if (crc32("VoPpx",5) == 4221144292) strcat(s, "U");
if (crc32("buoxUKf",7) == 2993211607) strcat(s, "n");
if (crc32("DSrdzyNpjwZ",11) == 1792558210) strcat(s, "o");
if (crc32("btQxNmWQ",8) == 870916423) strcat(s, "l");
if (crc32("OMKVD",5) == 3671771136) strcat(s, "r");
if (crc32("rPMpBjCvq",9) == 429368654) strcat(s, "i");
if (crc32("bRuxHb",6) == 724713318) strcat(s, "v");
if (crc32("CXpHFvTd",8) == 3416296940) strcat(s, "e");
if (crc32("ZnuCVxmVbVTGPg",14) == 2113140517) strcat(s, "a");
if (crc32("ZUnbeVJvjjTIKb",14) == 3179266586) strcat(s, "M");
if (crc32("rXiWMBwapLPosUC",15) == 314838680) strcat(s, "b");
if (crc32("ypupAjpTe",9) == 2032907028) strcat(s, "z");
if (crc32("XiWXP",5) == 4170544387) strcat(s, "l");
if (crc32("gNOqOc",6) == 1924696223) strcat(s, "c");
if (crc32("RvSiOPCpftjLp",13) == 4027687907) strcat(s, "e");
    return s;
}

char *dormient_adjectives() {
    char *s = calloc(9);
    if (crc32("gMeNeSB",7) == 234505332) strcat(s, "d");
if (crc32("sHlkxwzk",8) == 1363682419) strcat(s, "o");
if (crc32("ONBnb",5) == 325459005) strcat(s, "w");
if (crc32("oIKneRyVSTL",11) == 512347479) strcat(s, "r");
if (crc32("bhGFFBArbOfE",12) == 2261175782) strcat(s, "B");
if (crc32("AbRCOqlx",8) == 3288030234) strcat(s, "m");
if (crc32("RwGbBuKPhvrrDTY",15) == 1363578497) strcat(s, "T");
if (crc32("dDLjzGzVFa",10) == 1497586487) strcat(s, "i");
if (crc32("iqDujY",6) == 3462711272) strcat(s, "N");
if (crc32("kRHwOOXZfWBer",13) == 2543743707) strcat(s, "e");
if (crc32("GIebYpNrU",9) == 3567942998) strcat(s, "n");
if (crc32("xLJzaGZJt",9) == 130425316) strcat(s, "t");
    return s;
}

char *fattenable_adjectives() {
    char *s = calloc(11);
    if (crc32("OVKXs",5) == 3100253883) strcat(s, "R");
if (crc32("XLJhFi",6) == 3963391439) strcat(s, "f");
if (crc32("HhuMuvvHSk",10) == 566391144) strcat(s, "Y");
if (crc32("aoFUptxcFpHhFF",14) == 2694537035) strcat(s, "a");
if (crc32("viriyBroEgg",11) == 354384624) strcat(s, "t");
if (crc32("VRToNKSTUxXBuX",14) == 2496459727) strcat(s, "t");
if (crc32("wxZfn",5) == 3688720553) strcat(s, "e");
if (crc32("SWJVAZwkukYXcyL",15) == 4275793776) strcat(s, "s");
if (crc32("xXzFSXZieDCGau",14) == 3209847087) strcat(s, "n");
if (crc32("KcLSTMAA",8) == 2016846210) strcat(s, "a");
if (crc32("OxvLFHyN",8) == 2359367187) strcat(s, "J");
if (crc32("YTYYPNhrNA",10) == 1486491527) strcat(s, "b");
if (crc32("jxxXemFmicP",11) == 2163759776) strcat(s, "b");
if (crc32("PlhtTWw",7) == 3703462863) strcat(s, "l");
if (crc32("QXYRiQ",6) == 253621633) strcat(s, "e");
    return s;
}

char *nonproportionable_adjectives() {
    char *s = calloc(18);
    if (crc32("xFLlzkMhzAiFTgm",15) == 2845853498) strcat(s, "l");
if (crc32("CoZelEsJwf",10) == 666378956) strcat(s, "n");
if (crc32("EKMfNiwSIR",10) == 10233299) strcat(s, "o");
if (crc32("XGXTtRItibRNEK",14) == 3736610156) strcat(s, "e");
if (crc32("pXIxkrpx",8) == 4061025607) strcat(s, "n");
if (crc32("gIevfZzsfklUa",13) == 2707124086) strcat(s, "r");
if (crc32("tWXGNHOEL",9) == 637733712) strcat(s, "p");
if (crc32("ZkANPT",6) == 2099551045) strcat(s, "r");
if (crc32("OQpGgRfOSckNQ",13) == 3914221883) strcat(s, "o");
if (crc32("ZuyaYuLfoe",10) == 834711983) strcat(s, "p");
if (crc32("uKvTmICElslE",12) == 4212427734) strcat(s, "W");
if (crc32("mDboKWX",7) == 2415266093) strcat(s, "o");
if (crc32("cTjctIZlWwi",11) == 140300471) strcat(s, "y");
if (crc32("LCPrFge",7) == 224233128) strcat(s, "r");
if (crc32("JqhIeJsnwcjHj",13) == 2045830670) strcat(s, "Y");
if (crc32("GkUSg",5) == 3907065201) strcat(s, "t");
if (crc32("qoGkqfyGarqBuo",14) == 1934244708) strcat(s, "K");
if (crc32("nDuIrudwyXu",11) == 3254641084) strcat(s, "i");
if (crc32("jcGUWXpfmXYhjm",14) == 1205337882) strcat(s, "o");
if (crc32("NXaTnEV",7) == 3304535139) strcat(s, "n");
if (crc32("wEvQXELcqqNJeA",14) == 1829616579) strcat(s, "a");
if (crc32("PGKhqejvtFGIT",13) == 1920453271) strcat(s, "b");
if (crc32("aIPicGvu",8) == 890292806) strcat(s, "l");
if (crc32("NTngVBbPsUt",11) == 3457661483) strcat(s, "Q");
if (crc32("SGSRknAAcX",10) == 1494759664) strcat(s, "e");
    return s;
}

char *iniquitous_adjectives() {
    char *s = calloc(11);
    if (crc32("PRDUusVktKxZaMe",15) == 694264688) strcat(s, "g");
if (crc32("JRDTsjIr",8) == 2467659131) strcat(s, "i");
if (crc32("puMUjkyxHzok",12) == 2689575574) strcat(s, "X");
if (crc32("IoEvky",6) == 3515997570) strcat(s, "n");
if (crc32("qoBormzS",8) == 2271189190) strcat(s, "i");
if (crc32("Ufxbtn",6) == 4285717914) strcat(s, "q");
if (crc32("WNGbzWO",7) == 2135925406) strcat(s, "u");
if (crc32("lfnyFMMmHDTu",12) == 3465748971) strcat(s, "S");
if (crc32("cQFtaLURlDfq",12) == 813614502) strcat(s, "i");
if (crc32("gNWmzGRSlKgDhY",14) == 3424752039) strcat(s, "t");
if (crc32("AecxfJkR",8) == 2121632479) strcat(s, "o");
if (crc32("IQYEY",5) == 480568013) strcat(s, "u");
if (crc32("zBYUOignRzahE",13) == 436181265) strcat(s, "s");
    return s;
}

char *unimplorable_adjectives() {
    char *s = calloc(13);
    if (crc32("fjXZCsqnhpyeri",14) == 988545484) strcat(s, "V");
if (crc32("dGPpVqeYiWsmNH",14) == 2974381242) strcat(s, "u");
if (crc32("SXRKrImkJR",10) == 714548520) strcat(s, "S");
if (crc32("AcGTwu",6) == 2251553181) strcat(s, "n");
if (crc32("fsqAhlKo",8) == 2368702869) strcat(s, "K");
if (crc32("fGvbR",5) == 1413560427) strcat(s, "i");
if (crc32("RprLMIj",7) == 2219449490) strcat(s, "m");
if (crc32("rHMQtiwQMywOpq",14) == 3297403148) strcat(s, "p");
if (crc32("BPxGeHdNprDy",12) == 788622642) strcat(s, "v");
if (crc32("OOgqHeCUUONFo",13) == 1364558512) strcat(s, "l");
if (crc32("CrDgwRcVki",10) == 212156759) strcat(s, "o");
if (crc32("TnijvLhdeQxB",12) == 3216940476) strcat(s, "i");
if (crc32("dzWMkvjkkF",10) == 960160968) strcat(s, "r");
if (crc32("bCfsRrRuzkCuHP",14) == 437003591) strcat(s, "a");
if (crc32("rYieP",5) == 3352443427) strcat(s, "b");
if (crc32("EUcdXnSgEWPd",12) == 3363348468) strcat(s, "A");
if (crc32("WqoIejfbtCk",11) == 871470815) strcat(s, "l");
if (crc32("dxEFcUPEJsC",11) == 4058875625) strcat(s, "e");
    return s;
}

char *Monophysitic_adjectives() {
    char *s = calloc(13);
    if (crc32("HMeaWh",6) == 30683525) strcat(s, "M");
if (crc32("uLWECaRjkqRKrI",14) == 3635361131) strcat(s, "o");
if (crc32("KQFPZmaDnamU",12) == 3675676976) strcat(s, "m");
if (crc32("FclcUBoaJ",9) == 3206102118) strcat(s, "n");
if (crc32("DIIBu",5) == 1803333839) strcat(s, "w");
if (crc32("eHDeBkrQlopd",12) == 3489778115) strcat(s, "o");
if (crc32("jvFYbDmfSHnbv",13) == 3912669758) strcat(s, "H");
if (crc32("oVZSODC",7) == 2438475624) strcat(s, "p");
if (crc32("zlWjeL",6) == 2516261521) strcat(s, "F");
if (crc32("sOvXrl",6) == 2468456219) strcat(s, "h");
if (crc32("jdbIzktjWhEOC",13) == 3612232212) strcat(s, "N");
if (crc32("alMxeFvI",8) == 1100692070) strcat(s, "y");
if (crc32("KdOmzGNZdnn",11) == 3398719898) strcat(s, "J");
if (crc32("WhLPGMjdrehH",12) == 3064319972) strcat(s, "s");
if (crc32("TsiuPfecUhXADyB",15) == 1459296355) strcat(s, "m");
if (crc32("yXZySH",6) == 2207056524) strcat(s, "i");
if (crc32("UUCMu",5) == 2113537467) strcat(s, "n");
if (crc32("AbfGAmebQpklp",13) == 3258442773) strcat(s, "t");
if (crc32("IoGVooNoWqy",11) == 3103810576) strcat(s, "i");
if (crc32("bgcIRBnxYVNpcA",14) == 2529250190) strcat(s, "c");
    return s;
}

char *onstream_adjectives() {
    char *s = calloc(9);
    if (crc32("VJOAfu",6) == 2955284669) strcat(s, "G");
if (crc32("SuZSSqoKO",9) == 1586237049) strcat(s, "o");
if (crc32("AOGIecY",7) == 1029137821) strcat(s, "T");
if (crc32("QhSIwlv",7) == 1146526865) strcat(s, "n");
if (crc32("PbgNpvLl",8) == 1019548907) strcat(s, "P");
if (crc32("JOPGEapPv",9) == 673527879) strcat(s, "s");
if (crc32("JzIlxCQfiBaKw",13) == 2795890501) strcat(s, "t");
if (crc32("DpRElUozEYmpfZo",15) == 189838542) strcat(s, "u");
if (crc32("mgcpzQvoI",9) == 1572702801) strcat(s, "r");
if (crc32("oQbuix",6) == 569493684) strcat(s, "A");
if (crc32("CcHvBX",6) == 1337934989) strcat(s, "e");
if (crc32("HgDWBTqJU",9) == 90987998) strcat(s, "X");
if (crc32("tGUVA",5) == 1274983961) strcat(s, "a");
if (crc32("UkEmBaBjWyDbfYA",15) == 641927526) strcat(s, "h");
if (crc32("ZBtoMGJk",8) == 903675782) strcat(s, "m");
    return s;
}

char *shadowless_adjectives() {
    char *s = calloc(11);
    if (crc32("WVndcISJfU",10) == 3011910910) strcat(s, "o");
if (crc32("iGqfyVJN",8) == 416417163) strcat(s, "s");
if (crc32("ubRBpAYsn",9) == 666744969) strcat(s, "R");
if (crc32("ypNGAqHQiaKkKZ",14) == 4213208097) strcat(s, "h");
if (crc32("qJlkxkQCDuRzY",13) == 1404970666) strcat(s, "R");
if (crc32("hpxyTr",6) == 968925111) strcat(s, "a");
if (crc32("iJLFpQnzLoCd",12) == 2375986881) strcat(s, "u");
if (crc32("pxHBPSESTZb",11) == 384865697) strcat(s, "d");
if (crc32("TAhxc",5) == 1568733386) strcat(s, "o");
if (crc32("HLAdrmxJmzvKXcx",15) == 1588936635) strcat(s, "w");
if (crc32("peYkDx",6) == 3548267449) strcat(s, "w");
if (crc32("JOtLoZanK",9) == 3860375051) strcat(s, "Q");
if (crc32("JHfoSTTnpti",11) == 1278976068) strcat(s, "l");
if (crc32("DosvdjSONj",10) == 1902901832) strcat(s, "U");
if (crc32("pFseRcmyYHjg",12) == 55949624) strcat(s, "e");
if (crc32("eITAvY",6) == 3808251216) strcat(s, "s");
if (crc32("UmMdHDPgUBRwM",13) == 640531171) strcat(s, "F");
if (crc32("ZccORXUuE",9) == 1772288462) strcat(s, "s");
    return s;
}

char *Carnacian_adjectives() {
    char *s = calloc(10);
    if (crc32("kkSgbfbP",8) == 921072796) strcat(s, "J");
if (crc32("ILlqkwDZSnD",11) == 3939104118) strcat(s, "C");
if (crc32("XPfvfpYmw",9) == 1336563006) strcat(s, "a");
if (crc32("zdHGBpdXuKUud",13) == 411718688) strcat(s, "t");
if (crc32("GuooMoKihsnkhqe",15) == 2265053406) strcat(s, "r");
if (crc32("ySbFkTOKczyO",12) == 3098403730) strcat(s, "n");
if (crc32("NQePSGbiCs",10) == 4239690359) strcat(s, "M");
if (crc32("WswQqeQgSmEaPrS",15) == 3044028677) strcat(s, "a");
if (crc32("ZVsdkIVWjbfnNW",14) == 2639311176) strcat(s, "c");
if (crc32("rtsQHB",6) == 3535994595) strcat(s, "q");
if (crc32("ibGYt",5) == 2330662356) strcat(s, "i");
if (crc32("KRLOKLESk",9) == 2639347675) strcat(s, "D");
if (crc32("ZEqKEeArb",9) == 479075840) strcat(s, "a");
if (crc32("QDIdLilWSW",10) == 2972279591) strcat(s, "j");
if (crc32("QkpfTWSa",8) == 4008723611) strcat(s, "n");
    return s;
}

char *uninterpolative_adjectives() {
    char *s = calloc(16);
    if (crc32("lWDVMEs",7) == 3215256066) strcat(s, "u");
if (crc32("prUlzbCsHc",10) == 3758097201) strcat(s, "n");
if (crc32("WmHJeXYxLZ",10) == 255415645) strcat(s, "Y");
if (crc32("wjLxf",5) == 3824983954) strcat(s, "i");
if (crc32("vuaDmaP",7) == 2844291644) strcat(s, "I");
if (crc32("NfKOi",5) == 15487485) strcat(s, "n");
if (crc32("nPcZKUFZiQz",11) == 4195897181) strcat(s, "V");
if (crc32("lHnbQUhCiIOLJ",13) == 4037361532) strcat(s, "t");
if (crc32("XKxuTG",6) == 3034721482) strcat(s, "e");
if (crc32("ndBqFuLOIAIN",12) == 3688814037) strcat(s, "t");
if (crc32("KKtkVunyiwOMpKA",15) == 3027677685) strcat(s, "r");
if (crc32("kccveSKLxZF",11) == 84919744) strcat(s, "p");
if (crc32("qDmzbnVhtLiEbR",14) == 1057950660) strcat(s, "N");
if (crc32("dKxyxcyWgamqK",13) == 2361073813) strcat(s, "o");
if (crc32("mNHFJtNpUfw",11) == 2441728004) strcat(s, "l");
if (crc32("CIJnGA",6) == 1480309177) strcat(s, "m");
if (crc32("VSCtEXNjlNPwO",13) == 1069799487) strcat(s, "a");
if (crc32("herfCOQ",7) == 2505478140) strcat(s, "d");
if (crc32("fRmoujvvEFWKiQ",14) == 2406079002) strcat(s, "t");
if (crc32("hjPdpTQcvVZHyeA",15) == 1759325667) strcat(s, "i");
if (crc32("wZKrqUiObnzK",12) == 183380578) strcat(s, "v");
if (crc32("XrALvwBASIm",11) == 3874122467) strcat(s, "k");
if (crc32("femKMdau",8) == 1263033474) strcat(s, "e");
    return s;
}

char *postSocratic_adjectives() {
    char *s = calloc(13);
    if (crc32("NAhXbjBiVrKzu",13) == 2479463110) strcat(s, "p");
if (crc32("wcJodqooAmNnapG",15) == 309906690) strcat(s, "a");
if (crc32("nFxduPMyFbsk",12) == 3412449300) strcat(s, "o");
if (crc32("QcLvQGh",7) == 830195756) strcat(s, "l");
if (crc32("iyZawdnqtdEMqoC",15) == 4133932948) strcat(s, "s");
if (crc32("QALlHJJ",7) == 2469241994) strcat(s, "Z");
if (crc32("lNEog",5) == 2798227175) strcat(s, "t");
if (crc32("HcXjZQKU",8) == 3608751563) strcat(s, "S");
if (crc32("QMQudlLyNXYI",12) == 1531155258) strcat(s, "s");
if (crc32("vNVCGcJVxgbr",12) == 3989625681) strcat(s, "o");
if (crc32("FEHASTgyldHj",12) == 505478527) strcat(s, "P");
if (crc32("NUThKNtdhgh",11) == 2020443947) strcat(s, "c");
if (crc32("TDhWbyrNsxYSx",13) == 1950143154) strcat(s, "x");
if (crc32("gqIqDActRBLivdj",15) == 1998259506) strcat(s, "r");
if (crc32("rsqzOu",6) == 2486266736) strcat(s, "a");
if (crc32("jdYZoRixmy",10) == 1748918417) strcat(s, "C");
if (crc32("zuIzUyS",7) == 3105003523) strcat(s, "t");
if (crc32("IZwXojiXGWya",12) == 2974483683) strcat(s, "S");
if (crc32("TWKWZc",6) == 501717676) strcat(s, "i");
if (crc32("otSdQgQoIRk",11) == 2478098564) strcat(s, "c");
    return s;
}

char *tiptop_adjectives() {
    char *s = calloc(7);
    if (crc32("SwcRUMDVxfdeY",13) == 3583121341) strcat(s, "x");
if (crc32("DJAgIyiWFMQ",11) == 2242059730) strcat(s, "t");
if (crc32("jzQWFcIqXixw",12) == 1217464730) strcat(s, "R");
if (crc32("eERPKXjBf",9) == 721421740) strcat(s, "i");
if (crc32("cIGdvepbYRPxhU",14) == 2896935377) strcat(s, "p");
if (crc32("hwbNiyMIq",9) == 1924319252) strcat(s, "t");
if (crc32("sgSePeDTxkpMAH",14) == 3286072416) strcat(s, "F");
if (crc32("InVooi",6) == 3295756764) strcat(s, "o");
if (crc32("LnAOnGfiyflxxy",14) == 43102357) strcat(s, "p");
    return s;
}

char *unmotioning_adjectives() {
    char *s = calloc(12);
    if (crc32("UgbLuwa",7) == 3283218784) strcat(s, "u");
if (crc32("LmPeZg",6) == 3194593028) strcat(s, "n");
if (crc32("VMkMpJFeYWhxO",13) == 4172017278) strcat(s, "e");
if (crc32("OPdOYoYFQidkI",13) == 464689150) strcat(s, "m");
if (crc32("VXrBrXCu",8) == 3660229489) strcat(s, "o");
if (crc32("hhSNA",5) == 2418644761) strcat(s, "t");
if (crc32("rrrUjinVZCVVlz",14) == 1063441234) strcat(s, "i");
if (crc32("xPeiawQ",7) == 3321148666) strcat(s, "L");
if (crc32("SJTEUtgsX",9) == 2769336421) strcat(s, "o");
if (crc32("VBMnSAgadQLrT",13) == 2080722433) strcat(s, "J");
if (crc32("BTNJYef",7) == 364634382) strcat(s, "n");
if (crc32("YfbmQGQuYY",10) == 2258762089) strcat(s, "H");
if (crc32("ilkJzfXiqtOPfrE",15) == 744758838) strcat(s, "i");
if (crc32("RcTJeOEyb",9) == 606405406) strcat(s, "n");
if (crc32("fARIRvLMhzsgeOp",15) == 2644340610) strcat(s, "g");
    return s;
}

char *fireresistant_adjectives() {
    char *s = calloc(14);
    if (crc32("RQVQpZqxX",9) == 787590799) strcat(s, "f");
if (crc32("FzJGAwp",7) == 1169025036) strcat(s, "i");
if (crc32("hGUEfLZzLvq",11) == 1702157788) strcat(s, "r");
if (crc32("LmEdiPnPCoqpVO",14) == 498017463) strcat(s, "e");
if (crc32("CKRwFL",6) == 4276022525) strcat(s, "r");
if (crc32("rVwPpPOdAFVQP",13) == 82857626) strcat(s, "z");
if (crc32("kruuJQHe",8) == 1697054031) strcat(s, "e");
if (crc32("hJNoQ",5) == 532989192) strcat(s, "s");
if (crc32("MvNHzifJz",9) == 898404712) strcat(s, "R");
if (crc32("CtVCe",5) == 3012639068) strcat(s, "i");
if (crc32("CNGOOpCyHfuSJ",13) == 2440910358) strcat(s, "s");
if (crc32("rHKEHcbgm",9) == 3359713367) strcat(s, "t");
if (crc32("SfGtuv",6) == 2478809253) strcat(s, "a");
if (crc32("YhkBuzM",7) == 2927146162) strcat(s, "m");
if (crc32("vQTPqoRWf",9) == 3201057776) strcat(s, "n");
if (crc32("QUxYwKBGTbpBbH",14) == 3219724736) strcat(s, "t");
    return s;
}

char *prebuccal_adjectives() {
    char *s = calloc(10);
    if (crc32("fkYZENg",7) == 1308082719) strcat(s, "p");
if (crc32("xMpcyUffXkhNpz",14) == 1762826230) strcat(s, "X");
if (crc32("WbREYzLtRCnj",12) == 554867559) strcat(s, "r");
if (crc32("NzWTpUiUBwY",11) == 276872155) strcat(s, "e");
if (crc32("UylscGZUkDHCP",13) == 527565728) strcat(s, "w");
if (crc32("pGUJVHPDunsq",12) == 3431294296) strcat(s, "b");
if (crc32("JcppbIhZQeS",11) == 1229876000) strcat(s, "o");
if (crc32("kbFaArXPPYy",11) == 894301935) strcat(s, "u");
if (crc32("pflhrforqNBh",12) == 2677841518) strcat(s, "c");
if (crc32("XIUeLpF",7) == 2416610679) strcat(s, "c");
if (crc32("UaGBqZsTc",9) == 194314280) strcat(s, "t");
if (crc32("kdHDKNKJxa",10) == 4012484342) strcat(s, "a");
if (crc32("nzTzkzfMka",10) == 2243607566) strcat(s, "F");
if (crc32("iLVBCnF",7) == 1804281751) strcat(s, "l");
    return s;
}

char *antiimperialistic_adjectives() {
    char *s = calloc(18);
    if (crc32("cMHuSrUgxk",10) == 1035682159) strcat(s, "c");
if (crc32("HJzjaOfuEvAKgT",14) == 4287598280) strcat(s, "a");
if (crc32("TSJsUtI",7) == 2231471748) strcat(s, "n");
if (crc32("burSEEZHKmXBS",13) == 207923572) strcat(s, "t");
if (crc32("TafeFhdyzf",10) == 1217753452) strcat(s, "x");
if (crc32("rjpdbpRni",9) == 782188371) strcat(s, "i");
if (crc32("XneyYgGkAxlmcwo",15) == 1418636017) strcat(s, "C");
if (crc32("tDNlZEtAcXwW",12) == 4187280471) strcat(s, "i");
if (crc32("RTQysOaQHboMcCx",15) == 4155387057) strcat(s, "m");
if (crc32("ncMQeZEYLnlPdb",14) == 3561164498) strcat(s, "p");
if (crc32("ZfyUvLZx",8) == 3156382270) strcat(s, "e");
if (crc32("iYgznpEBpIkqEQ",14) == 989746370) strcat(s, "s");
if (crc32("sowUsmcB",8) == 860899085) strcat(s, "r");
if (crc32("qcpNzeQ",7) == 536020862) strcat(s, "x");
if (crc32("YLYxaEROH",9) == 2142273965) strcat(s, "i");
if (crc32("MScHhTEUuKdmsv",14) == 3231775342) strcat(s, "R");
if (crc32("McRVShws",8) == 2919184601) strcat(s, "a");
if (crc32("gLqSWvmPFokx",12) == 650371172) strcat(s, "q");
if (crc32("DdenKccNyGjvWo",14) == 1455264518) strcat(s, "l");
if (crc32("RVcFGuPBMZxZ",12) == 1293118585) strcat(s, "b");
if (crc32("gLFXUiYmSTHw",12) == 2892252588) strcat(s, "i");
if (crc32("wBccpQZFa",9) == 1519636109) strcat(s, "s");
if (crc32("OfkhEqi",7) == 2515104121) strcat(s, "t");
if (crc32("dpPrTc",6) == 1298208526) strcat(s, "i");
if (crc32("PQstLAQRQtBryu",14) == 1271172808) strcat(s, "s");
if (crc32("oocNhBunyOE",11) == 3955954225) strcat(s, "c");
    return s;
}

char *doiled_adjectives() {
    char *s = calloc(7);
    if (crc32("YbiiAZVAwMbmP",13) == 1370734179) strcat(s, "k");
if (crc32("gRtydmZp",8) == 2335031289) strcat(s, "d");
if (crc32("RRjwjHeuCnON",12) == 398253002) strcat(s, "W");
if (crc32("TeuREdR",7) == 2958882293) strcat(s, "o");
if (crc32("bEVAAfCaqgo",11) == 1336290986) strcat(s, "D");
if (crc32("qCXRE",5) == 1738882160) strcat(s, "i");
if (crc32("ICCshn",6) == 1593726132) strcat(s, "l");
if (crc32("sihtGgdFrMP",11) == 3511511177) strcat(s, "e");
if (crc32("QdPcnOYGgiSrdvh",15) == 1173718687) strcat(s, "B");
if (crc32("kqqaxc",6) == 3196596919) strcat(s, "d");
    return s;
}

char *mechanistic_adjectives() {
    char *s = calloc(12);
    if (crc32("FRwPSSie",8) == 3104875068) strcat(s, "z");
if (crc32("wufWPQYwHV",10) == 3912495029) strcat(s, "m");
if (crc32("ajEpaHPLora",11) == 2990392985) strcat(s, "u");
if (crc32("gXBYXabEux",10) == 1806249372) strcat(s, "e");
if (crc32("rTLxXRNhlqea",12) == 1536214943) strcat(s, "F");
if (crc32("qJyCqDdoSpnu",12) == 327138621) strcat(s, "c");
if (crc32("AbaQxgcKirlk",12) == 1242249809) strcat(s, "v");
if (crc32("VWIOoNPvQs",10) == 715023076) strcat(s, "h");
if (crc32("CkyQUtsqD",9) == 2503138580) strcat(s, "j");
if (crc32("yoHFgqj",7) == 488242740) strcat(s, "a");
if (crc32("eLVLQa",6) == 1436729894) strcat(s, "J");
if (crc32("AWpFxcqfu",9) == 3818944633) strcat(s, "n");
if (crc32("sYdtfieRzBOZfyp",15) == 1262794807) strcat(s, "L");
if (crc32("uolKtKDCclUkReG",15) == 2810347144) strcat(s, "i");
if (crc32("HsDEci",6) == 2939487640) strcat(s, "Z");
if (crc32("FWPmgJs",7) == 3563134411) strcat(s, "s");
if (crc32("TXQeMJ",6) == 3234699138) strcat(s, "t");
if (crc32("oyCcSRnjwhKLO",13) == 2285191482) strcat(s, "B");
if (crc32("FtwSjTIvJN",10) == 547842961) strcat(s, "i");
if (crc32("XwtXXGk",7) == 2657958543) strcat(s, "c");
    return s;
}

char *unendurability_adjectives() {
    char *s = calloc(15);
    if (crc32("LmXVjQF",7) == 2026231703) strcat(s, "R");
if (crc32("TIPNRtrGczJb",12) == 1009509419) strcat(s, "u");
if (crc32("lmIEGYrihH",10) == 3520155320) strcat(s, "n");
if (crc32("SENvTNFUOzz",11) == 623906909) strcat(s, "Z");
if (crc32("WfoWmBvPzmrH",12) == 3776536741) strcat(s, "e");
if (crc32("tVBZSW",6) == 2727159055) strcat(s, "n");
if (crc32("VfBXYl",6) == 27847796) strcat(s, "d");
if (crc32("ALkhXdVNzB",10) == 4125920747) strcat(s, "a");
if (crc32("RaqcAsqmvdDY",12) == 1491698291) strcat(s, "u");
if (crc32("tSSOidsXSmf",11) == 3955603554) strcat(s, "r");
if (crc32("dnGqINewRF",10) == 3877039218) strcat(s, "D");
if (crc32("RXAbqyWJ",8) == 2931656413) strcat(s, "a");
if (crc32("DkjQpPjy",8) == 1544553919) strcat(s, "b");
if (crc32("JDIGlNh",7) == 3600834090) strcat(s, "i");
if (crc32("QtbUodmXbnFCnQ",14) == 491034504) strcat(s, "P");
if (crc32("RXUqOFDMYTYqHJ",14) == 1050465074) strcat(s, "l");
if (crc32("MmGLmR",6) == 1309330172) strcat(s, "t");
if (crc32("PYibYnNRaojFDJ",14) == 1716244911) strcat(s, "i");
if (crc32("yVzynTnDPBIzxVY",15) == 1590161567) strcat(s, "t");
if (crc32("RswIpICLWnbOHRg",15) == 4012103382) strcat(s, "k");
if (crc32("veYur",5) == 862350815) strcat(s, "y");
    return s;
}

char *tragicomical_adjectives() {
    char *s = calloc(13);
    if (crc32("ZtAsmGcsCbOEHpM",15) == 3678872390) strcat(s, "J");
if (crc32("WYfFAL",6) == 1763188228) strcat(s, "t");
if (crc32("iCHfcWKySX",10) == 1524509701) strcat(s, "P");
if (crc32("lDkYjmETlSduxY",14) == 2654006853) strcat(s, "r");
if (crc32("kTsUx",5) == 4003721552) strcat(s, "Q");
if (crc32("OQSBtBvqasTL",12) == 3028481501) strcat(s, "a");
if (crc32("SjtKQ",5) == 2883931098) strcat(s, "D");
if (crc32("yIhgjhHdZKKMb",13) == 3424864470) strcat(s, "g");
if (crc32("pVkxcwcqxUA",11) == 3013617377) strcat(s, "f");
if (crc32("nimKZzEhcvadNV",14) == 2530483231) strcat(s, "i");
if (crc32("iHHZOV",6) == 1020825606) strcat(s, "c");
if (crc32("LydglKpKOelLdYO",15) == 1798270693) strcat(s, "n");
if (crc32("bFaimdYStndnz",13) == 338442370) strcat(s, "o");
if (crc32("bznMssvU",8) == 1613801320) strcat(s, "m");
if (crc32("LeRgSYdY",8) == 2139780891) strcat(s, "j");
if (crc32("PEajJLP",7) == 1531952487) strcat(s, "i");
if (crc32("qBUOEd",6) == 1001025849) strcat(s, "r");
if (crc32("nnCmREBY",8) == 1409932723) strcat(s, "c");
if (crc32("zBbUoAPzkaH",11) == 1281194195) strcat(s, "b");
if (crc32("fRjFYlGlKCak",12) == 663414049) strcat(s, "a");
if (crc32("aGQpWInmD",9) == 2419546056) strcat(s, "b");
if (crc32("VuVPpLcnauMUHQG",15) == 1162623631) strcat(s, "l");
    return s;
}

char *biauricular_adjectives() {
    char *s = calloc(12);
    if (crc32("JHhTTmrDRd",10) == 1501955627) strcat(s, "b");
if (crc32("HcbXdgcifNwlJo",14) == 602275088) strcat(s, "R");
if (crc32("JVQLDRBcAz",10) == 2237267150) strcat(s, "i");
if (crc32("BiGGhtGCBUj",11) == 64478564) strcat(s, "a");
if (crc32("cnOKVwUN",8) == 2156971096) strcat(s, "r");
if (crc32("TOUhXMUW",8) == 3073693333) strcat(s, "u");
if (crc32("KCYlts",6) == 3197736845) strcat(s, "r");
if (crc32("XbIDgILOwoH",11) == 1356870776) strcat(s, "i");
if (crc32("wJqLjToxCrlktg",14) == 577279738) strcat(s, "c");
if (crc32("otbMhVjdyJa",11) == 4069529043) strcat(s, "K");
if (crc32("HnlIBrXDyaEOKuM",15) == 2071420520) strcat(s, "u");
if (crc32("EnzaNXxVIiqbDlN",15) == 674282571) strcat(s, "l");
if (crc32("DvjFiZSKC",9) == 2635879114) strcat(s, "C");
if (crc32("AeMtUFsKXSu",11) == 3314900387) strcat(s, "a");
if (crc32("fNhOUpLue",9) == 1055656579) strcat(s, "r");
    return s;
}

char *waitressless_adjectives() {
    char *s = calloc(13);
    if (crc32("ziXdPQNEqDel",12) == 3089558727) strcat(s, "w");
if (crc32("HdHrqcQZizBpDQ",14) == 4000360939) strcat(s, "a");
if (crc32("OFeBCOWfowKj",12) == 1590437059) strcat(s, "i");
if (crc32("mHzeeXA",7) == 772593926) strcat(s, "f");
if (crc32("NWndhg",6) == 3832950780) strcat(s, "t");
if (crc32("NrMQLsapdDnAI",13) == 722546209) strcat(s, "r");
if (crc32("NSxnSpyvSJiieD",14) == 2706387957) strcat(s, "e");
if (crc32("zpXHhUO",7) == 3467891335) strcat(s, "y");
if (crc32("ZcguDrYABc",10) == 2321470679) strcat(s, "s");
if (crc32("nUvxIiVgoEY",11) == 4193006656) strcat(s, "s");
if (crc32("cYSCdIzo",8) == 3714799092) strcat(s, "Q");
if (crc32("atTMUekq",8) == 1174165744) strcat(s, "l");
if (crc32("KrfGMylKlJ",10) == 3654787082) strcat(s, "e");
if (crc32("jRiCfurFO",9) == 2212818737) strcat(s, "A");
if (crc32("prbuLJOvrfYc",12) == 2995562311) strcat(s, "s");
if (crc32("vmbzMRsJgxMn",12) == 294928162) strcat(s, "s");
    return s;
}

char *unfacaded_adjectives() {
    char *s = calloc(10);
    if (crc32("eeaHv",5) == 1406908418) strcat(s, "u");
if (crc32("ARStgbvCZpd",11) == 1387301432) strcat(s, "n");
if (crc32("VwaNcfEFS",9) == 3146291762) strcat(s, "f");
if (crc32("CEkgQeeeD",9) == 3532075762) strcat(s, "a");
if (crc32("hPhtUND",7) == 295228693) strcat(s, "c");
if (crc32("vPkvvhKg",8) == 4037166034) strcat(s, "a");
if (crc32("ELSCjpphGDPlr",13) == 2263224131) strcat(s, "d");
if (crc32("SEelQH",6) == 1029282817) strcat(s, "e");
if (crc32("vFXSceJLkWfNBgA",15) == 888071251) strcat(s, "d");
    return s;
}

char *shroudless_adjectives() {
    char *s = calloc(11);
    if (crc32("bmOzTOPF",8) == 1246559908) strcat(s, "s");
if (crc32("JbbXgACqnqbJ",12) == 2407908362) strcat(s, "h");
if (crc32("sdAJTClOwUxUet",14) == 1241077207) strcat(s, "N");
if (crc32("kOdIybOLdPKjEZt",15) == 2037542133) strcat(s, "r");
if (crc32("RcsGvHRicfYK",12) == 1876821041) strcat(s, "A");
if (crc32("MiPOBdyfNMf",11) == 3896118555) strcat(s, "o");
if (crc32("pVgAfkxhIGckV",13) == 3929609247) strcat(s, "u");
if (crc32("kURvbWyvHfC",11) == 3520413003) strcat(s, "X");
if (crc32("PUmSDDt",7) == 3993937413) strcat(s, "d");
if (crc32("CFLyXkhRl",9) == 795598647) strcat(s, "l");
if (crc32("DzAaJKTVID",10) == 605354149) strcat(s, "e");
if (crc32("pNnZo",5) == 2603292641) strcat(s, "s");
if (crc32("newabLW",7) == 874774918) strcat(s, "s");
    return s;
}

char *insentient_adjectives() {
    char *s = calloc(11);
    if (crc32("UeHeJsvjcKu",11) == 705026674) strcat(s, "s");
if (crc32("nkmxYFfSWGQW",12) == 523072486) strcat(s, "i");
if (crc32("FDEHmhQb",8) == 1413999712) strcat(s, "i");
if (crc32("FnRJECIzzKGw",12) == 3603671438) strcat(s, "n");
if (crc32("LOJgSwMARV",10) == 1619426507) strcat(s, "u");
if (crc32("RnsFpQNj",8) == 913424442) strcat(s, "s");
if (crc32("jucsMMoTlTajWoA",15) == 4183847854) strcat(s, "e");
if (crc32("hvmpKeubA",9) == 2906600208) strcat(s, "n");
if (crc32("zcvxf",5) == 1335391471) strcat(s, "t");
if (crc32("FVpHuEB",7) == 619844813) strcat(s, "t");
if (crc32("LVhLFLtuOLQz",12) == 1082041113) strcat(s, "i");
if (crc32("ogFRJnwoSQ",10) == 277115897) strcat(s, "e");
if (crc32("ksiviBy",7) == 1380289267) strcat(s, "Q");
if (crc32("fMqpCGzRBYoU",12) == 764288371) strcat(s, "n");
if (crc32("icZKtjSnMWuxr",13) == 2820152984) strcat(s, "j");
if (crc32("eoHdpKh",7) == 1704093083) strcat(s, "t");
    return s;
}

char *perceptual_adjectives() {
    char *s = calloc(11);
    if (crc32("GuzvNfUTDq",10) == 2426520026) strcat(s, "p");
if (crc32("IPNma",5) == 3358467689) strcat(s, "e");
if (crc32("pssPN",5) == 991100778) strcat(s, "r");
if (crc32("OLeFiAqFZz",10) == 2829042998) strcat(s, "o");
if (crc32("cCPBhZib",8) == 3894587419) strcat(s, "c");
if (crc32("BTxNdrzgZh",10) == 1739199642) strcat(s, "e");
if (crc32("MoJmkRtB",8) == 441322141) strcat(s, "J");
if (crc32("AFvtZqHiQemVwG",14) == 2280280219) strcat(s, "p");
if (crc32("CdGSMLvCAHutUtU",15) == 2627651593) strcat(s, "u");
if (crc32("TaMwynMkcGshrvo",15) == 2608087703) strcat(s, "t");
if (crc32("Mlhoiss",7) == 1756405351) strcat(s, "P");
if (crc32("vQIsWhdyLzH",11) == 3610226666) strcat(s, "u");
if (crc32("UOakKCmeMoyL",12) == 895541362) strcat(s, "a");
if (crc32("QjiOvmpHPCG",11) == 3130459972) strcat(s, "g");
if (crc32("ZPBVx",5) == 3199038887) strcat(s, "l");
    return s;
}

char *tuberculous_adjectives() {
    char *s = calloc(12);
    if (crc32("cifxJlOn",8) == 1525195718) strcat(s, "t");
if (crc32("PEzxWxBNS",9) == 2440116571) strcat(s, "u");
if (crc32("vgEWQp",6) == 1899456817) strcat(s, "b");
if (crc32("nuuVjmoH",8) == 3709150175) strcat(s, "c");
if (crc32("lMcZxyUIzd",10) == 3513321865) strcat(s, "e");
if (crc32("RafMoY",6) == 3255533270) strcat(s, "r");
if (crc32("UUNEfutCwMH",11) == 814830551) strcat(s, "o");
if (crc32("wTqJXkIPHJu",11) == 3950201482) strcat(s, "c");
if (crc32("UIhvwOGfW",9) == 1849782610) strcat(s, "h");
if (crc32("piHAyDysJZ",10) == 3186751870) strcat(s, "u");
if (crc32("tSayQkioZ",9) == 2365132724) strcat(s, "z");
if (crc32("jGRKqLZHCKD",11) == 2209301036) strcat(s, "l");
if (crc32("ezLZkik",7) == 4248143082) strcat(s, "o");
if (crc32("DEdcXPuXqtW",11) == 1096531752) strcat(s, "S");
if (crc32("fkBZWxejlzZiogK",15) == 3333442396) strcat(s, "u");
if (crc32("jfpGME",6) == 174203400) strcat(s, "s");
if (crc32("mdJuygdUQxlhF",13) == 876794042) strcat(s, "s");
    return s;
}

char *closelipped_adjectives() {
    char *s = calloc(12);
    if (crc32("xhHcVkx",7) == 135863679) strcat(s, "G");
if (crc32("BaTmsECqhmhsEG",14) == 718589203) strcat(s, "c");
if (crc32("JAYPtFQzld",10) == 220101136) strcat(s, "j");
if (crc32("pOpiVO",6) == 1190696218) strcat(s, "l");
if (crc32("lZDDRhhdVwf",11) == 3814097351) strcat(s, "D");
if (crc32("dVsNV",5) == 4273157805) strcat(s, "o");
if (crc32("cfRRtRJ",7) == 2482721136) strcat(s, "c");
if (crc32("eHJrqbybwVDiW",13) == 913435890) strcat(s, "s");
if (crc32("XkUjh",5) == 3756594357) strcat(s, "m");
if (crc32("tgbfWApwTX",10) == 2877073801) strcat(s, "e");
if (crc32("aYsgJ",5) == 1048013359) strcat(s, "l");
if (crc32("qCptwwuygtgTfAi",15) == 574283016) strcat(s, "i");
if (crc32("VNvGMMrrDo",10) == 1723675303) strcat(s, "p");
if (crc32("xQWVPG",6) == 1059595274) strcat(s, "p");
if (crc32("FhDMSp",6) == 1814485516) strcat(s, "e");
if (crc32("JVEyAtIfPWik",12) == 445482840) strcat(s, "d");
    return s;
}

char *unimmolated_adjectives() {
    char *s = calloc(12);
    if (crc32("Ltrrlkpd",8) == 4272643634) strcat(s, "s");
if (crc32("XNwmL",5) == 1259158173) strcat(s, "u");
if (crc32("nMuvPTvuAzBQ",12) == 4272683048) strcat(s, "n");
if (crc32("bMqgoZOcU",9) == 3895449205) strcat(s, "i");
if (crc32("kRXgunncXAIpb",13) == 30401595) strcat(s, "i");
if (crc32("wuuYItspwgEl",12) == 1107855545) strcat(s, "m");
if (crc32("TgOvLW",6) == 923261128) strcat(s, "m");
if (crc32("fnCQoIRGU",9) == 755762827) strcat(s, "S");
if (crc32("CamrIKYMf",9) == 708906936) strcat(s, "o");
if (crc32("baxVAojSmEo",11) == 2227239375) strcat(s, "l");
if (crc32("dfvkDbZxG",9) == 1234318297) strcat(s, "S");
if (crc32("tpwvU",5) == 2459243600) strcat(s, "a");
if (crc32("WUrodAQ",7) == 2111486243) strcat(s, "t");
if (crc32("LuZGSis",7) == 578915182) strcat(s, "e");
if (crc32("QsZaUg",6) == 836629461) strcat(s, "d");
    return s;
}

char *goahead_adjectives() {
    char *s = calloc(8);
    if (crc32("sBmdZKUTcV",10) == 3809433440) strcat(s, "g");
if (crc32("xEWAyIZ",7) == 1170270487) strcat(s, "o");
if (crc32("ZARyBGCxbsauX",13) == 2913425848) strcat(s, "K");
if (crc32("mtRXaaqj",8) == 771899981) strcat(s, "a");
if (crc32("ZjmIaVAjulx",11) == 2938086139) strcat(s, "h");
if (crc32("rrFIOyYXJ",9) == 626542462) strcat(s, "L");
if (crc32("aLFeIYS",7) == 4113344764) strcat(s, "e");
if (crc32("aDmfiYQvhsvjIp",14) == 3924569442) strcat(s, "i");
if (crc32("gjyeuQF",7) == 3960284845) strcat(s, "a");
if (crc32("CVyNBnnUI",9) == 3628181593) strcat(s, "u");
if (crc32("UZgNXAEC",8) == 273229352) strcat(s, "d");
    return s;
}

char *unlumbering_adjectives() {
    char *s = calloc(12);
    if (crc32("SQnKCYtxRtdZ",12) == 3730842325) strcat(s, "w");
if (crc32("UWjwUu",6) == 2234805804) strcat(s, "u");
if (crc32("cjZucSrolpv",11) == 1690239732) strcat(s, "I");
if (crc32("JFBQXmuOV",9) == 821907259) strcat(s, "n");
if (crc32("oVUQv",5) == 1133974456) strcat(s, "l");
if (crc32("NyaOuKd",7) == 427459659) strcat(s, "h");
if (crc32("SvvdlJVyx",9) == 3142390513) strcat(s, "u");
if (crc32("HEMfQm",6) == 2002630681) strcat(s, "m");
if (crc32("DpVUhi",6) == 3246558560) strcat(s, "b");
if (crc32("ivkCxMVzUFwJxvU",15) == 2668877124) strcat(s, "H");
if (crc32("Skkpcqwy",8) == 2581352486) strcat(s, "e");
if (crc32("KFbvoGjKEpPq",12) == 970655754) strcat(s, "r");
if (crc32("zgQSlmkJM",9) == 2259264003) strcat(s, "e");
if (crc32("yUUDggCZkHCESXV",15) == 218859195) strcat(s, "i");
if (crc32("IYbmLmMpvIZ",11) == 3680554887) strcat(s, "t");
if (crc32("BFCwBrpJIqT",11) == 2330016375) strcat(s, "n");
if (crc32("EzVaJcRK",8) == 3455818868) strcat(s, "i");
if (crc32("yRqcENbSnWH",11) == 1009429145) strcat(s, "g");
    return s;
}

char *unleased_adjectives() {
    char *s = calloc(9);
    if (crc32("XMIDMKAj",8) == 2762197815) strcat(s, "y");
if (crc32("mkirSn",6) == 3247291652) strcat(s, "u");
if (crc32("wyzpgEnSle",10) == 3197540116) strcat(s, "n");
if (crc32("EkwgDQwmAM",10) == 3735713186) strcat(s, "K");
if (crc32("yCDPlVQ",7) == 3127798427) strcat(s, "l");
if (crc32("AsaDNxIHhLfjSO",14) == 3608006) strcat(s, "e");
if (crc32("GwgwmVxIwa",10) == 2317161559) strcat(s, "V");
if (crc32("EfNzPiapspDJjip",15) == 1335914090) strcat(s, "a");
if (crc32("FvTyCGNzMjgz",12) == 1212131756) strcat(s, "s");
if (crc32("GDWsFt",6) == 1469490178) strcat(s, "R");
if (crc32("yXIdioIDamh",11) == 512564295) strcat(s, "e");
if (crc32("ncFidrsjaN",10) == 2041162398) strcat(s, "d");
    return s;
}

char *crotched_adjectives() {
    char *s = calloc(9);
    if (crc32("qfwikPzHbo",10) == 1885410629) strcat(s, "Y");
if (crc32("YOfySrNYRc",10) == 2236401941) strcat(s, "c");
if (crc32("sGOXbrwUFFbI",12) == 355406473) strcat(s, "i");
if (crc32("mItfWoYqqFx",11) == 2101177923) strcat(s, "r");
if (crc32("fLgZFTBCEJqdG",13) == 3184435454) strcat(s, "o");
if (crc32("ptGZOVwO",8) == 12526186) strcat(s, "r");
if (crc32("NdYkbVOjV",9) == 466548933) strcat(s, "t");
if (crc32("FmFJgOHeN",9) == 2524282427) strcat(s, "c");
if (crc32("OcmlrkeEaOdQ",12) == 605401567) strcat(s, "h");
if (crc32("azHbLcmqpKyogaP",15) == 1486364189) strcat(s, "e");
if (crc32("jroIh",5) == 4124008925) strcat(s, "d");
    return s;
}

char *nondomineering_adjectives() {
    char *s = calloc(15);
    if (crc32("lGnjQhfXo",9) == 808282152) strcat(s, "m");
if (crc32("XadmAHtTIfMQ",12) == 2580958754) strcat(s, "n");
if (crc32("SIiWMFe",7) == 2252813840) strcat(s, "o");
if (crc32("pvwilSjiD",9) == 2132139722) strcat(s, "n");
if (crc32("GbKAek",6) == 3217727651) strcat(s, "d");
if (crc32("LzDOBjXlLFTG",12) == 808133484) strcat(s, "i");
if (crc32("UxTaF",5) == 280365050) strcat(s, "o");
if (crc32("RkCvpLN",7) == 482348984) strcat(s, "U");
if (crc32("XFghrIPgoEHt",12) == 3380205631) strcat(s, "m");
if (crc32("uLjrFS",6) == 545377037) strcat(s, "i");
if (crc32("iJylrzfnhungnU",14) == 3695299383) strcat(s, "N");
if (crc32("GEvjLTNVAvQ",11) == 666225687) strcat(s, "n");
if (crc32("nXqrBOKNmDWKUV",14) == 387524987) strcat(s, "M");
if (crc32("gufsPX",6) == 49286074) strcat(s, "e");
if (crc32("GWTqFQaX",8) == 972193916) strcat(s, "e");
if (crc32("ZTjEg",5) == 3950426575) strcat(s, "r");
if (crc32("XZyvHCnxeFJ",11) == 172443900) strcat(s, "a");
if (crc32("XpFLcgwZm",9) == 2249783501) strcat(s, "i");
if (crc32("lrKOgIIViFjWhHf",15) == 2706398469) strcat(s, "n");
if (crc32("GyRQws",6) == 4020424903) strcat(s, "W");
if (crc32("HmzRU",5) == 2902965344) strcat(s, "g");
    return s;
}

char *subimpressed_adjectives() {
    char *s = calloc(13);
    if (crc32("unnjLrlSLfb",11) == 1475783917) strcat(s, "s");
if (crc32("zfMWxVeaFRG",11) == 418895433) strcat(s, "u");
if (crc32("oUFPCM",6) == 969972166) strcat(s, "W");
if (crc32("daPUuE",6) == 1936812359) strcat(s, "b");
if (crc32("xAbVfFwnCdbmfh",14) == 2226874155) strcat(s, "L");
if (crc32("VKVDUTt",7) == 4162571635) strcat(s, "i");
if (crc32("qKGfAAViLJFoty",14) == 3226794812) strcat(s, "m");
if (crc32("wcyzEVexFidBqb",14) == 2309657423) strcat(s, "G");
if (crc32("CnzyPoa",7) == 3410543070) strcat(s, "p");
if (crc32("eybFxeYGpu",10) == 2299331939) strcat(s, "c");
if (crc32("kbGhnXKtyVuGWrl",15) == 2963152978) strcat(s, "r");
if (crc32("iNcojBUS",8) == 3570176454) strcat(s, "Y");
if (crc32("PNefjqyrq",9) == 3460672278) strcat(s, "e");
if (crc32("cWYpPlw",7) == 51401451) strcat(s, "s");
if (crc32("LgrgumyTm",9) == 604841460) strcat(s, "s");
if (crc32("zUbUPClKbjoJqFx",15) == 2194629593) strcat(s, "w");
if (crc32("bqgwkGbyWySQ",12) == 440064026) strcat(s, "e");
if (crc32("giznGrMd",8) == 1931989189) strcat(s, "d");
    return s;
}

char *unstaggering_adjectives() {
    char *s = calloc(13);
    if (crc32("otWpYSOKhmZLz",13) == 2580177525) strcat(s, "u");
if (crc32("ZzakiM",6) == 2122421452) strcat(s, "B");
if (crc32("VxumrJIGZj",10) == 947458093) strcat(s, "n");
if (crc32("RsTeHCJ",7) == 1445944965) strcat(s, "s");
if (crc32("UaLWjBScEKydYx",14) == 156467621) strcat(s, "o");
if (crc32("CWHOUrBWHJZtVxM",15) == 2002485760) strcat(s, "t");
if (crc32("UkcRQuglvCnFUqN",15) == 2407076189) strcat(s, "a");
if (crc32("RoAaKjWNDUOT",12) == 2588307226) strcat(s, "g");
if (crc32("qwnnCczhpdioAx",14) == 1059704391) strcat(s, "x");
if (crc32("nnCYEUFsruLcyoU",15) == 3757325414) strcat(s, "g");
if (crc32("pHHxqqufVqdkMt",14) == 2689451914) strcat(s, "e");
if (crc32("EYvMitOjfCfNEJ",14) == 2448595927) strcat(s, "n");
if (crc32("VJlwfpoKZJUQCj",14) == 1219758080) strcat(s, "r");
if (crc32("kOFgmnntVxlCD",13) == 2029548125) strcat(s, "i");
if (crc32("felTyGKFqKfHSOP",15) == 1262687907) strcat(s, "n");
if (crc32("UHyWeQ",6) == 4263510732) strcat(s, "g");
    return s;
}

char *brevirostrate_adjectives() {
    char *s = calloc(14);
    if (crc32("WuMmvVttIOJ",11) == 1838306457) strcat(s, "b");
if (crc32("vEPdfxzDqftX",12) == 3470808183) strcat(s, "I");
if (crc32("diGASwQnbiq",11) == 4215468355) strcat(s, "r");
if (crc32("ofLrHJMC",8) == 123209957) strcat(s, "d");
if (crc32("EEFzxXOo",8) == 516391001) strcat(s, "e");
if (crc32("yQTWPNBXEDivFTx",15) == 3201387418) strcat(s, "v");
if (crc32("KvyQvAQQo",9) == 674898341) strcat(s, "i");
if (crc32("hpfdrdGjCbzawu",14) == 1807495902) strcat(s, "r");
if (crc32("kBNnFgNMaZ",10) == 2177578916) strcat(s, "T");
if (crc32("WBceSI",6) == 2070099008) strcat(s, "o");
if (crc32("kQEczt",6) == 2992718190) strcat(s, "s");
if (crc32("smFVbNKCQdiS",12) == 1646760931) strcat(s, "W");
if (crc32("BTIbWDm",7) == 3553516462) strcat(s, "t");
if (crc32("yBSDySxsLi",10) == 2930390634) strcat(s, "R");
if (crc32("ENXPRfJc",8) == 1003929411) strcat(s, "r");
if (crc32("kXaPURKvpFjtpt",14) == 2817178495) strcat(s, "S");
if (crc32("aEKMEVAQmRNViug",15) == 988709040) strcat(s, "a");
if (crc32("XVJElz",6) == 433266159) strcat(s, "j");
if (crc32("ZeAarCTv",8) == 3427255238) strcat(s, "t");
if (crc32("UptxdE",6) == 2462850283) strcat(s, "o");
if (crc32("TvvwidEfFGWcva",14) == 541857740) strcat(s, "e");
    return s;
}

char *plethoric_adjectives() {
    char *s = calloc(10);
    if (crc32("PsuILYOSaBnMJJ",14) == 2250901122) strcat(s, "p");
if (crc32("MocMzMArQHoOLkh",15) == 278736345) strcat(s, "b");
if (crc32("sRJkPvwHrzlsM",13) == 3714139513) strcat(s, "l");
if (crc32("NMbGlsboRr",10) == 2669995537) strcat(s, "d");
if (crc32("GTIGhZcmu",9) == 4178033480) strcat(s, "e");
if (crc32("hiFzBiKaDUTuzK",14) == 3721818982) strcat(s, "U");
if (crc32("TdVXPYmkwKlnb",13) == 2035970324) strcat(s, "t");
if (crc32("GLTFSpOCNQO",11) == 1255355481) strcat(s, "h");
if (crc32("vdfbCWryjiHDMRw",15) == 926231977) strcat(s, "h");
if (crc32("Ogjew",5) == 1567193182) strcat(s, "f");
if (crc32("KyrDxCGUyMihriT",15) == 3619419391) strcat(s, "o");
if (crc32("PihYMaELPWpNIS",14) == 2511051398) strcat(s, "b");
if (crc32("PVdtQZWaE",9) == 1513641673) strcat(s, "r");
if (crc32("DAfdV",5) == 3768056945) strcat(s, "p");
if (crc32("YEAPKo",6) == 2344932426) strcat(s, "i");
if (crc32("KzenFuGqUZRRTjU",15) == 3544617902) strcat(s, "j");
if (crc32("TbEWi",5) == 761003226) strcat(s, "c");
    return s;
}

char *intercosmic_adjectives() {
    char *s = calloc(12);
    if (crc32("pddaLNpWToM",11) == 3358283892) strcat(s, "i");
if (crc32("WjhbpE",6) == 4018403915) strcat(s, "n");
if (crc32("yyjJHk",6) == 1612036519) strcat(s, "V");
if (crc32("GIydoUen",8) == 1824813312) strcat(s, "t");
if (crc32("asEWTDuUzaAsCcP",15) == 1783865109) strcat(s, "e");
if (crc32("YtDdyHxkkq",10) == 47364301) strcat(s, "R");
if (crc32("NHuvHCeVxxJlH",13) == 1614297890) strcat(s, "r");
if (crc32("OYnIApP",7) == 3361480598) strcat(s, "N");
if (crc32("XTQtpI",6) == 2633657019) strcat(s, "c");
if (crc32("PaMBwUAuyyDSw",13) == 553095993) strcat(s, "r");
if (crc32("wQytRLXjW",9) == 2577911961) strcat(s, "o");
if (crc32("nCUYdchkiN",10) == 2995533108) strcat(s, "s");
if (crc32("fuEvGm",6) == 258144444) strcat(s, "w");
if (crc32("YzcbyKNVm",9) == 3879439501) strcat(s, "m");
if (crc32("dcQtd",5) == 4025557833) strcat(s, "i");
if (crc32("myMwcVVVPeCeY",13) == 3477890880) strcat(s, "V");
if (crc32("LIsbGLtz",8) == 537351123) strcat(s, "c");
    return s;
}

char *chasmogamic_adjectives() {
    char *s = calloc(12);
    if (crc32("SaHaOPSnUw",10) == 2034836041) strcat(s, "c");
if (crc32("LEszCZrDaGThxVc",15) == 2030303332) strcat(s, "y");
if (crc32("JdifrTdGweYI",12) == 3755194187) strcat(s, "h");
if (crc32("xfBSdGlxdF",10) == 3701177528) strcat(s, "R");
if (crc32("IOoAi",5) == 3459362539) strcat(s, "a");
if (crc32("dAtOC",5) == 1123326628) strcat(s, "s");
if (crc32("fPhLqRUjmUV",11) == 296734213) strcat(s, "s");
if (crc32("soGITqLiQVapGh",14) == 3947405232) strcat(s, "m");
if (crc32("NIifOLYvsvyXpG",14) == 765136477) strcat(s, "k");
if (crc32("DgQRh",5) == 1798984725) strcat(s, "o");
if (crc32("DzTcmbwxPoEi",12) == 620127999) strcat(s, "v");
if (crc32("HXSPUKyVhcFh",12) == 1045124610) strcat(s, "g");
if (crc32("rQWzBvSwldNs",12) == 2296447191) strcat(s, "a");
if (crc32("FedsXKZh",8) == 3114358412) strcat(s, "F");
if (crc32("gCQTAeJpnT",10) == 3679343736) strcat(s, "m");
if (crc32("NBzbIAdmQyo",11) == 2591966549) strcat(s, "E");
if (crc32("lTGqLmZt",8) == 1709370271) strcat(s, "i");
if (crc32("hxXILCTc",8) == 2783393319) strcat(s, "c");
    return s;
}

char *unwearisome_adjectives() {
    char *s = calloc(12);
    if (crc32("gtihpoxDHS",10) == 1181136164) strcat(s, "U");
if (crc32("GZzYPgMz",8) == 771185172) strcat(s, "u");
if (crc32("JNeNdotBj",9) == 1314461219) strcat(s, "n");
if (crc32("IeZsqvKWmvEGwbO",15) == 2233912510) strcat(s, "w");
if (crc32("TOxlkIM",7) == 4075665638) strcat(s, "R");
if (crc32("PqhOT",5) == 1888592784) strcat(s, "e");
if (crc32("JMZWUEaSOocs",12) == 3029787940) strcat(s, "a");
if (crc32("vkFwFBfxn",9) == 1735536127) strcat(s, "H");
if (crc32("zrJENyJwmJAtVjd",15) == 2303221504) strcat(s, "r");
if (crc32("LsnWrhb",7) == 2521836108) strcat(s, "A");
if (crc32("uCixq",5) == 4182977930) strcat(s, "i");
if (crc32("IIRTDfsRn",9) == 1186019741) strcat(s, "s");
if (crc32("xjZIiNT",7) == 985770522) strcat(s, "o");
if (crc32("bzsVaafmTTAuU",13) == 3335842983) strcat(s, "m");
if (crc32("qooZd",5) == 3711192705) strcat(s, "u");
if (crc32("npacD",5) == 4251681367) strcat(s, "e");
    return s;
}

char *proArian_adjectives() {
    char *s = calloc(9);
    if (crc32("oCMhmAg",7) == 1293159016) strcat(s, "p");
if (crc32("iywKut",6) == 532441399) strcat(s, "q");
if (crc32("QeVQszLD",8) == 4145358230) strcat(s, "r");
if (crc32("UsRISJUO",8) == 886777587) strcat(s, "o");
if (crc32("aIFKk",5) == 966156603) strcat(s, "A");
if (crc32("HYlCiJmZ",8) == 700209778) strcat(s, "r");
if (crc32("ndFdMJxy",8) == 2957348730) strcat(s, "i");
if (crc32("GCyfdrEVOSS",11) == 2659273439) strcat(s, "N");
if (crc32("FMPlsaumIVMbRgO",15) == 3700651769) strcat(s, "a");
if (crc32("QoIncIxCDHXCu",13) == 2360713897) strcat(s, "n");
    return s;
}

char *muckerish_adjectives() {
    char *s = calloc(10);
    if (crc32("ZKFpVP",6) == 2372542807) strcat(s, "N");
if (crc32("PzitZ",5) == 2102955161) strcat(s, "m");
if (crc32("CmONxBGZ",8) == 3633305894) strcat(s, "u");
if (crc32("cXOTBRfot",9) == 2585310994) strcat(s, "c");
if (crc32("OVAnBDyipVQUzK",14) == 3824429188) strcat(s, "k");
if (crc32("izGQIEx",7) == 469950576) strcat(s, "e");
if (crc32("pifjSYpWLvormnF",15) == 1667611440) strcat(s, "t");
if (crc32("wazPMjRYcWcKnd",14) == 3629563734) strcat(s, "r");
if (crc32("avWsItItxdDEsnZ",15) == 2050392768) strcat(s, "i");
if (crc32("mkaEtdFk",8) == 1960122249) strcat(s, "g");
if (crc32("XVfbfzwOdHJPwYi",15) == 1427473811) strcat(s, "s");
if (crc32("bZLaEzLX",8) == 385320102) strcat(s, "h");
if (crc32("wCoVrzzUGooB",12) == 2261875234) strcat(s, "h");
    return s;
}

char *quasialternative_adjectives() {
    char *s = calloc(17);
    if (crc32("dCYuUSIcJsDTR",13) == 1848066427) strcat(s, "q");
if (crc32("yXRoOKaFQRWrs",13) == 261599085) strcat(s, "z");
if (crc32("JqIhjBTnqma",11) == 4080863175) strcat(s, "u");
if (crc32("WQEZH",5) == 1440855839) strcat(s, "p");
if (crc32("mNRktlX",7) == 329992207) strcat(s, "a");
if (crc32("AiQGNJqxhMlCYsQ",15) == 1560770801) strcat(s, "Z");
if (crc32("VqxPvROPPDle",12) == 1351990419) strcat(s, "s");
if (crc32("urXqtoO",7) == 3302796178) strcat(s, "X");
if (crc32("NtLGxDHdVY",10) == 2483167328) strcat(s, "i");
if (crc32("GqSuarfbI",9) == 69727583) strcat(s, "a");
if (crc32("JvBXEefiigJNu",13) == 2918058491) strcat(s, "l");
if (crc32("yiZAwMxXhKLN",12) == 2917040823) strcat(s, "t");
if (crc32("VlGNDLSPEHm",11) == 3072412259) strcat(s, "e");
if (crc32("FVLmiU",6) == 1381906840) strcat(s, "B");
if (crc32("XGyqEgvqwD",10) == 1955935805) strcat(s, "r");
if (crc32("apnRIzzqNhnvmiW",15) == 1154581195) strcat(s, "h");
if (crc32("JmmYGUdYaUDl",12) == 218500209) strcat(s, "n");
if (crc32("WCZFAuTzXrT",11) == 1284636458) strcat(s, "T");
if (crc32("uJZLmyqZNFZYjR",14) == 2461415527) strcat(s, "a");
if (crc32("qzNaF",5) == 2127659474) strcat(s, "p");
if (crc32("OMaoAAuIcQo",11) == 3268038028) strcat(s, "t");
if (crc32("jOLxEGFq",8) == 2135727600) strcat(s, "i");
if (crc32("UCgtQl",6) == 3766441006) strcat(s, "v");
if (crc32("zEZxsJjB",8) == 3685842423) strcat(s, "S");
if (crc32("OZqfEGCyC",9) == 1112692255) strcat(s, "e");
    return s;
}

char *scrawnier_adjectives() {
    char *s = calloc(10);
    if (crc32("uwfCH",5) == 1478335340) strcat(s, "m");
if (crc32("RmRruVgvnGWgE",13) == 3709772176) strcat(s, "s");
if (crc32("uFbWAtXV",8) == 3917242653) strcat(s, "c");
if (crc32("JVXeQU",6) == 1347835178) strcat(s, "r");
if (crc32("jEZlWkDGSyqNo",13) == 1639671093) strcat(s, "q");
if (crc32("GbWpGaUgbg",10) == 3718991035) strcat(s, "a");
if (crc32("kxYMCOBKc",9) == 705536340) strcat(s, "w");
if (crc32("IPCJOuh",7) == 3499888455) strcat(s, "G");
if (crc32("YHDatqfXARoIeAR",15) == 294550240) strcat(s, "n");
if (crc32("bEboM",5) == 675360308) strcat(s, "i");
if (crc32("VzTBYibDukJRwG",14) == 3819056022) strcat(s, "n");
if (crc32("MYGrhxafMhB",11) == 3479114793) strcat(s, "e");
if (crc32("cWDtVaTI",8) == 768518796) strcat(s, "z");
if (crc32("ZLTst",5) == 1569513102) strcat(s, "r");
    return s;
}

char *nonelective_adjectives() {
    char *s = calloc(12);
    if (crc32("GyJEm",5) == 4190515937) strcat(s, "n");
if (crc32("YtCQyZwjfPKIelr",15) == 2438626765) strcat(s, "o");
if (crc32("GsRrOYZURlLY",12) == 1325275903) strcat(s, "n");
if (crc32("GMOblfHrGbk",11) == 2938487161) strcat(s, "e");
if (crc32("oIZHMWzMo",9) == 1807847035) strcat(s, "S");
if (crc32("lChxXRiCuGoKp",13) == 2916151491) strcat(s, "l");
if (crc32("qPubKp",6) == 293811957) strcat(s, "b");
if (crc32("WMsWzyVDhM",10) == 838161828) strcat(s, "e");
if (crc32("uMiAGHldpq",10) == 3173137888) strcat(s, "c");
if (crc32("TeoiK",5) == 301161932) strcat(s, "t");
if (crc32("EcVGIGrzuEEufBw",15) == 1818368710) strcat(s, "i");
if (crc32("GqGuzmW",7) == 381067809) strcat(s, "v");
if (crc32("COKUreScD",9) == 899013232) strcat(s, "e");
    return s;
}

char *splinterless_adjectives() {
    char *s = calloc(13);
    if (crc32("uGJnHmFAOlaWFdo",15) == 1259244647) strcat(s, "h");
if (crc32("KNFfMaKKVjtCLX",14) == 1264703999) strcat(s, "s");
if (crc32("poHlIDut",8) == 2682940037) strcat(s, "p");
if (crc32("GZbPfS",6) == 2204968628) strcat(s, "L");
if (crc32("hbrjcWiu",8) == 996003592) strcat(s, "l");
if (crc32("CGiAUnULAFb",11) == 920668223) strcat(s, "q");
if (crc32("dVlcBjgHZP",10) == 1702962287) strcat(s, "i");
if (crc32("dujhgKRTwcLplB",14) == 2829711206) strcat(s, "j");
if (crc32("nMejyoRiAdNjOP",14) == 1691021623) strcat(s, "n");
if (crc32("ucrohTHV",8) == 2878383919) strcat(s, "p");
if (crc32("rUOToNI",7) == 107333623) strcat(s, "t");
if (crc32("sFeWTtncqVQeDo",14) == 3669905729) strcat(s, "e");
if (crc32("EnBmUKAxglGXQ",13) == 3431862716) strcat(s, "r");
if (crc32("sZjVxqBzclX",11) == 84863325) strcat(s, "k");
if (crc32("qADFZVdRgtAbki",14) == 1207072304) strcat(s, "l");
if (crc32("jVkLWAvxbnncp",13) == 3770121306) strcat(s, "e");
if (crc32("opGKjTgwCUc",11) == 2490246823) strcat(s, "s");
if (crc32("OrUidR",6) == 2368068086) strcat(s, "C");
if (crc32("zDskhQwDcWo",11) == 3869095930) strcat(s, "s");
    return s;
}

char *elmy_adjectives() {
    char *s = calloc(5);
    if (crc32("fuKowckx",8) == 3617928660) strcat(s, "e");
if (crc32("mqqsYKLV",8) == 345471051) strcat(s, "w");
if (crc32("DqlOwohA",8) == 1055083721) strcat(s, "l");
if (crc32("BuFqyL",6) == 2830872569) strcat(s, "m");
if (crc32("JekizQqxm",9) == 3539012016) strcat(s, "y");
    return s;
}

char *unnormalizing_adjectives() {
    char *s = calloc(14);
    if (crc32("owTbKaxIEf",10) == 2738084900) strcat(s, "u");
if (crc32("TfujcSUVgzqAakc",15) == 761546416) strcat(s, "x");
if (crc32("ElLCjxcQuAUyIk",14) == 3456613142) strcat(s, "n");
if (crc32("xNVVUeFoN",9) == 4037689308) strcat(s, "n");
if (crc32("zkuWND",6) == 2490245437) strcat(s, "c");
if (crc32("aEBwl",5) == 2581502467) strcat(s, "o");
if (crc32("zhmBnyIzzdlfll",14) == 3158186685) strcat(s, "G");
if (crc32("uFkqqUkdP",9) == 3961090652) strcat(s, "r");
if (crc32("cyAYK",5) == 2759709251) strcat(s, "m");
if (crc32("OVIHpxP",7) == 650621364) strcat(s, "m");
if (crc32("plONUKpXYGXJ",12) == 58734217) strcat(s, "a");
if (crc32("jCJhfZEszXTFxWY",15) == 4066758368) strcat(s, "D");
if (crc32("qIeLgZJHRyXNhq",14) == 2692816285) strcat(s, "l");
if (crc32("eKStBaApOrKoXVz",15) == 1745790652) strcat(s, "i");
if (crc32("SdfSXKLRt",9) == 2031641019) strcat(s, "z");
if (crc32("sRZNJdAMSdbhO",13) == 4202070847) strcat(s, "B");
if (crc32("SBEVlYI",7) == 2516593945) strcat(s, "i");
if (crc32("OXCXNFSfHpoHz",13) == 3085105416) strcat(s, "n");
if (crc32("YFAvfEjOrcyWbI",14) == 760012253) strcat(s, "R");
if (crc32("csWphAUIKdx",11) == 1285454762) strcat(s, "g");
    return s;
}

char *unarching_adjectives() {
    char *s = calloc(10);
    if (crc32("ujfIbvJDUCxsmU",14) == 3556912593) strcat(s, "W");
if (crc32("vYyfpzNRSlVJV",13) == 2609678526) strcat(s, "u");
if (crc32("liColQ",6) == 1171801529) strcat(s, "n");
if (crc32("pEHfxugX",8) == 2916812529) strcat(s, "J");
if (crc32("hRDmiubh",8) == 666604802) strcat(s, "a");
if (crc32("RLrxC",5) == 175494105) strcat(s, "r");
if (crc32("HvtYWNljkRvi",12) == 4197992567) strcat(s, "O");
if (crc32("VBLPhbzkP",9) == 2411066146) strcat(s, "c");
if (crc32("EpHpo",5) == 2981452287) strcat(s, "h");
if (crc32("YPOYymoySZQKu",13) == 1987044230) strcat(s, "t");
if (crc32("btsgiL",6) == 132859519) strcat(s, "i");
if (crc32("SuvXbcmmJMAFw",13) == 2874450413) strcat(s, "n");
if (crc32("nxVZvotPT",9) == 1889520046) strcat(s, "g");
    return s;
}

char *Fliptop_adjectives() {
    char *s = calloc(8);
    if (crc32("ThzrACm",7) == 1158342976) strcat(s, "F");
if (crc32("HYNPH",5) == 4185764871) strcat(s, "f");
if (crc32("lZpUrqn",7) == 2989848055) strcat(s, "l");
if (crc32("kvhsHNOuWHphkh",14) == 93502103) strcat(s, "i");
if (crc32("MQnRNG",6) == 905220668) strcat(s, "p");
if (crc32("AvKSe",5) == 1029996741) strcat(s, "t");
if (crc32("ybHjiOP",7) == 3149624211) strcat(s, "Z");
if (crc32("aUhLt",5) == 3552803268) strcat(s, "o");
if (crc32("MKxyKLBVZjmKlX",14) == 3359156911) strcat(s, "p");
    return s;
}

char *subtruncated_adjectives() {
    char *s = calloc(13);
    if (crc32("oYWVrgCJtUrEw",13) == 3452286497) strcat(s, "u");
if (crc32("jiihNzTonHsaoEK",15) == 512761451) strcat(s, "s");
if (crc32("MwNBmjhs",8) == 19932868) strcat(s, "u");
if (crc32("fOwJbpaBT",9) == 549427246) strcat(s, "W");
if (crc32("RHxadEZPA",9) == 1187584003) strcat(s, "b");
if (crc32("jePOV",5) == 2474639933) strcat(s, "V");
if (crc32("QMAnvz",6) == 2116516137) strcat(s, "t");
if (crc32("SAzgiAKFKmAoaQ",14) == 1883710416) strcat(s, "P");
if (crc32("gaJLNYQmMFVdmpM",15) == 3672829654) strcat(s, "r");
if (crc32("rkejwWiGLE",10) == 14821648) strcat(s, "E");
if (crc32("THgyrmYccMahM",13) == 1975355587) strcat(s, "u");
if (crc32("zsqRPXZo",8) == 862217205) strcat(s, "n");
if (crc32("nGMjPaZuq",9) == 1456205268) strcat(s, "w");
if (crc32("eGaDQEyXJilfgR",14) == 87674248) strcat(s, "c");
if (crc32("TdQvv",5) == 310948028) strcat(s, "a");
if (crc32("dZpzJ",5) == 419993844) strcat(s, "t");
if (crc32("KVIoz",5) == 2647850787) strcat(s, "Z");
if (crc32("WSDSSWO",7) == 4172032928) strcat(s, "e");
if (crc32("lgubDnYXz",9) == 701125377) strcat(s, "F");
if (crc32("OqPgwXfycq",10) == 1110399453) strcat(s, "d");
    return s;
}

char *unexamining_adjectives() {
    char *s = calloc(12);
    if (crc32("ezuHBcNHcaeTe",13) == 3052515220) strcat(s, "d");
if (crc32("NGQOvFBCRz",10) == 2207350925) strcat(s, "u");
if (crc32("oaisZv",6) == 342715174) strcat(s, "x");
if (crc32("jHGPlCihKNsZRe",14) == 537632084) strcat(s, "n");
if (crc32("JELEpGswQCW",11) == 3134330452) strcat(s, "O");
if (crc32("VpuflPmAxYm",11) == 2709482599) strcat(s, "e");
if (crc32("XgRPoaiLQqwPhg",14) == 490126116) strcat(s, "E");
if (crc32("KmqKuSHPK",9) == 320261097) strcat(s, "x");
if (crc32("cBUgOSUpBP",10) == 4199716188) strcat(s, "a");
if (crc32("hErDpse",7) == 1977441676) strcat(s, "X");
if (crc32("nOiXpKSYrLvvPvk",15) == 2977854434) strcat(s, "m");
if (crc32("xlaHrX",6) == 1509918873) strcat(s, "Q");
if (crc32("MgvXTY",6) == 3381518852) strcat(s, "i");
if (crc32("ExbSFvNswU",10) == 2835472096) strcat(s, "n");
if (crc32("QHJwCLmPPCqkS",13) == 787620045) strcat(s, "b");
if (crc32("tYGtvEYX",8) == 3551928076) strcat(s, "i");
if (crc32("NHdShySFsawndN",14) == 4042703258) strcat(s, "N");
if (crc32("fnNjlWdBoM",10) == 1616128582) strcat(s, "n");
if (crc32("qySSyFOZIeDYH",13) == 2786005586) strcat(s, "m");
if (crc32("lNYSaRKtWx",10) == 1407656611) strcat(s, "g");
    return s;
}

char *subtegumentary_adjectives() {
    char *s = calloc(15);
    if (crc32("ZaSVFH",6) == 3514146512) strcat(s, "m");
if (crc32("KMuEnmA",7) == 1721737785) strcat(s, "s");
if (crc32("VAJSYmkf",8) == 3119022789) strcat(s, "G");
if (crc32("dvUuvwuGE",9) == 3430239583) strcat(s, "u");
if (crc32("JbkrmSBPZeB",11) == 3814098346) strcat(s, "c");
if (crc32("tDJLaxID",8) == 1204704608) strcat(s, "b");
if (crc32("zxsVRIahJWHVu",13) == 1590505259) strcat(s, "v");
if (crc32("uzWsULkbmAPLQ",13) == 3460673558) strcat(s, "t");
if (crc32("vyffxMMOCrdTzw",14) == 4215365673) strcat(s, "Z");
if (crc32("AiokLghZ",8) == 867929242) strcat(s, "e");
if (crc32("BYVtLXcMmvApk",13) == 3421142966) strcat(s, "d");
if (crc32("hQpAtQJdrbXmdX",14) == 1527711567) strcat(s, "g");
if (crc32("FTibJCfeuIpxtkB",15) == 908066622) strcat(s, "u");
if (crc32("DYPgKDSPn",9) == 1545887693) strcat(s, "m");
if (crc32("iCaMbzPcmAbNRQX",15) == 2038389440) strcat(s, "e");
if (crc32("xGSfsGBYHxuIt",13) == 1717502372) strcat(s, "n");
if (crc32("VCyVAe",6) == 3740941911) strcat(s, "t");
if (crc32("EEWfgyUZHTRwYF",14) == 2630459177) strcat(s, "D");
if (crc32("WaKxRfMFgahYo",13) == 910690936) strcat(s, "a");
if (crc32("CcOtuCQzDbsg",12) == 1948151702) strcat(s, "G");
if (crc32("mMSrYWUYFZBRb",13) == 198513346) strcat(s, "r");
if (crc32("gczNASuZDkIbNRO",15) == 168697332) strcat(s, "k");
if (crc32("mNOkbUsV",8) == 1465292773) strcat(s, "y");
    return s;
}

char *nonconsequent_adjectives() {
    char *s = calloc(14);
    if (crc32("VNoUBfBaBwzO",12) == 42482277) strcat(s, "n");
if (crc32("nRqvGyw",7) == 3356281440) strcat(s, "o");
if (crc32("uAtGFmxWuX",10) == 3684064205) strcat(s, "n");
if (crc32("GqeCmlqazAsdu",13) == 2567009676) strcat(s, "a");
if (crc32("rVyiEKUPQtKOMZN",15) == 3536534844) strcat(s, "c");
if (crc32("WCZKkbmYeyFFnn",14) == 3062683453) strcat(s, "C");
if (crc32("pDGvnOiH",8) == 1912497065) strcat(s, "o");
if (crc32("bZirjJzzmKa",11) == 1531499535) strcat(s, "g");
if (crc32("VNvtDcUhYvDdhzb",15) == 3924571480) strcat(s, "n");
if (crc32("PNdKsMlmSQBoeg",14) == 4243648742) strcat(s, "i");
if (crc32("UpRuJ",5) == 4137142489) strcat(s, "s");
if (crc32("odHDJVc",7) == 1914278142) strcat(s, "K");
if (crc32("tlauKxRAMuc",11) == 2142818414) strcat(s, "e");
if (crc32("lkeBEVqqAZmcSc",14) == 2439128208) strcat(s, "m");
if (crc32("fZKQaXIha",9) == 3464070849) strcat(s, "q");
if (crc32("KAXgOoBFOKU",11) == 1315303699) strcat(s, "S");
if (crc32("OsMhXSP",7) == 1681573630) strcat(s, "u");
if (crc32("CePIMdzzbAwSoh",14) == 1748215845) strcat(s, "e");
if (crc32("saIrgktOAM",10) == 386443213) strcat(s, "n");
if (crc32("UyMcLCu",7) == 3420941475) strcat(s, "n");
if (crc32("JPpccGNZO",9) == 2667177762) strcat(s, "t");
    return s;
}

char *spriggy_adjectives() {
    char *s = calloc(8);
    if (crc32("GmFturDQZLqfZwc",15) == 1188057141) strcat(s, "p");
if (crc32("QQnmQ",5) == 1050077955) strcat(s, "s");
if (crc32("OwHyHZxvSWJVs",13) == 1275929073) strcat(s, "x");
if (crc32("BDHLDufeimKbq",13) == 2402601964) strcat(s, "p");
if (crc32("CedcMW",6) == 668057966) strcat(s, "r");
if (crc32("YXaZMZ",6) == 3809547720) strcat(s, "q");
if (crc32("QpueyXnDfhpHIOn",15) == 37595699) strcat(s, "i");
if (crc32("XdLXiLNuy",9) == 1545722446) strcat(s, "g");
if (crc32("qlkxCmm",7) == 2040544889) strcat(s, "g");
if (crc32("QbfpS",5) == 3279544516) strcat(s, "y");
    return s;
}

char *shadowed_adjectives() {
    char *s = calloc(9);
    if (crc32("gogZAyOFpy",10) == 3202035394) strcat(s, "b");
if (crc32("AWuQLe",6) == 2944330310) strcat(s, "s");
if (crc32("szdxxAi",7) == 2944597185) strcat(s, "h");
if (crc32("RwMEMTHd",8) == 2306127087) strcat(s, "a");
if (crc32("zTIWigFjDQl",11) == 4075239946) strcat(s, "a");
if (crc32("YHdhbUKFnVmu",12) == 3519705153) strcat(s, "e");
if (crc32("PfQYiZ",6) == 2221096517) strcat(s, "d");
if (crc32("tdkFb",5) == 4129473065) strcat(s, "C");
if (crc32("wrbrfIipPHakINr",15) == 1176407076) strcat(s, "o");
if (crc32("FrIdiTLRWYjFt",13) == 3289950318) strcat(s, "w");
if (crc32("bKpPfjdgs",9) == 2619302243) strcat(s, "a");
if (crc32("cWsntWpq",8) == 4078120681) strcat(s, "e");
if (crc32("EMBjOlAzTa",10) == 2902754604) strcat(s, "T");
if (crc32("meRLkQ",6) == 3600491929) strcat(s, "d");
    return s;
}

char *unsentient_adjectives() {
    char *s = calloc(11);
    if (crc32("FOmkDKYTsw",10) == 9684139) strcat(s, "Y");
if (crc32("kBJdepymUDFp",12) == 1621900212) strcat(s, "u");
if (crc32("LCMLZsZBNWFcO",13) == 1114361434) strcat(s, "g");
if (crc32("UnWel",5) == 3629497650) strcat(s, "n");
if (crc32("yNAReHbIvTtrfYj",15) == 715830531) strcat(s, "s");
if (crc32("MIuyRNRHRIWd",12) == 3219403542) strcat(s, "e");
if (crc32("lUFFYsy",7) == 2857581617) strcat(s, "n");
if (crc32("hQsqbyoHR",9) == 3437811929) strcat(s, "k");
if (crc32("NaGJjrWqTJaIoe",14) == 1404852044) strcat(s, "t");
if (crc32("GMTdGAQVnR",10) == 1794935348) strcat(s, "K");
if (crc32("FARhVAGvlUxz",12) == 2958820242) strcat(s, "i");
if (crc32("ikgBHcZHN",9) == 506859305) strcat(s, "e");
if (crc32("NwKxdhWKMyjIb",13) == 4165297973) strcat(s, "n");
if (crc32("CvemopbSt",9) == 2557598991) strcat(s, "E");
if (crc32("MXTRVD",6) == 3160416619) strcat(s, "t");
    return s;
}

char *sigmate_adjectives() {
    char *s = calloc(8);
    if (crc32("yYOPJBtuHJGMY",13) == 2989553629) strcat(s, "s");
if (crc32("WoDtijYjbWzWV",13) == 2366439787) strcat(s, "i");
if (crc32("nVPKYiCVfLmG",12) == 2541921262) strcat(s, "H");
if (crc32("TUcRebpQyJr",11) == 2002565831) strcat(s, "g");
if (crc32("GXvvwxdccrH",11) == 1940985522) strcat(s, "m");
if (crc32("cGNqCaM",7) == 125355601) strcat(s, "a");
if (crc32("iwxLXMTRZZigGn",14) == 2091520854) strcat(s, "D");
if (crc32("GmjZXQr",7) == 2694581034) strcat(s, "t");
if (crc32("mvNaDmDQflD",11) == 1981027990) strcat(s, "s");
if (crc32("HmoETnFwewOLk",13) == 1691028045) strcat(s, "e");
    return s;
}

char *semielliptic_adjectives() {
    char *s = calloc(13);
    if (crc32("mnUjFdnuPWUW",12) == 1509992537) strcat(s, "s");
if (crc32("dmUJhhzswdwOSV",14) == 3163867918) strcat(s, "e");
if (crc32("dTTwCbsYZLIN",12) == 3535470142) strcat(s, "m");
if (crc32("qqmzQhNdXUcQU",13) == 2806417259) strcat(s, "Q");
if (crc32("FUDqUkgkZlrmYBH",15) == 2686776812) strcat(s, "i");
if (crc32("ogimgsZNx",9) == 1597514205) strcat(s, "z");
if (crc32("sKRcwrI",7) == 226801588) strcat(s, "e");
if (crc32("pVVOHW",6) == 941817803) strcat(s, "U");
if (crc32("CxMZxxPYIuMts",13) == 1360706965) strcat(s, "l");
if (crc32("ZIrtS",5) == 3168352066) strcat(s, "l");
if (crc32("eLGRiWnoQvgnTT",14) == 3777933506) strcat(s, "N");
if (crc32("FBXYgmAZPtZBqq",14) == 3057963726) strcat(s, "i");
if (crc32("fLxgDnOzw",9) == 150104441) strcat(s, "a");
if (crc32("cHOaRMmOKGutdrh",15) == 1509764549) strcat(s, "p");
if (crc32("UNnTFtsqBiAgP",13) == 3156227316) strcat(s, "t");
if (crc32("vlNcGtphtvUQ",12) == 484713879) strcat(s, "t");
if (crc32("KzaWIygMbMH",11) == 2721052052) strcat(s, "i");
if (crc32("rPuPDiGj",8) == 2320604619) strcat(s, "c");
    return s;
}

char *nonspeculatory_adjectives() {
    char *s = calloc(15);
    if (crc32("YoeJFTannf",10) == 3672745639) strcat(s, "m");
if (crc32("qSWNGtJevIfFvD",14) == 2225738998) strcat(s, "n");
if (crc32("DIxFTNQkMz",10) == 3966564659) strcat(s, "o");
if (crc32("PnMzQQB",7) == 2125106381) strcat(s, "n");
if (crc32("rhVpghtanIwLlWO",15) == 2059630542) strcat(s, "s");
if (crc32("mUJTDUEG",8) == 667328592) strcat(s, "p");
if (crc32("omlfyiqwxSPUWH",14) == 2257508806) strcat(s, "T");
if (crc32("ugXUgzJwNweORjE",15) == 4023272244) strcat(s, "e");
if (crc32("BuvYCjqoLw",10) == 2781285040) strcat(s, "k");
if (crc32("bTpuOnbI",8) == 3281226021) strcat(s, "c");
if (crc32("nczdIydnN",9) == 291654272) strcat(s, "m");
if (crc32("thdGDTNcaWsxu",13) == 1828496960) strcat(s, "u");
if (crc32("iTCYH",5) == 480578481) strcat(s, "j");
if (crc32("twtOdWLKyUPv",12) == 4026434183) strcat(s, "l");
if (crc32("EPypMEALc",9) == 2692668146) strcat(s, "a");
if (crc32("FcicZ",5) == 3707463226) strcat(s, "y");
if (crc32("hJRblCdOlJ",10) == 2441791272) strcat(s, "t");
if (crc32("WYSvGzjBEZb",11) == 432355421) strcat(s, "P");
if (crc32("urizEIgk",8) == 1168211091) strcat(s, "o");
if (crc32("FcznPIRYVhWiG",13) == 965568710) strcat(s, "r");
if (crc32("AkvtcPUDUine",12) == 2339267232) strcat(s, "G");
if (crc32("awHAJqXQKXt",11) == 1814502751) strcat(s, "y");
    return s;
}

char *mongolian_adjectives() {
    char *s = calloc(10);
    if (crc32("biuPgeLybhJr",12) == 1002760194) strcat(s, "k");
if (crc32("SNhfhSdxGQKe",12) == 1465600428) strcat(s, "m");
if (crc32("xmUlvpyLE",9) == 4105214466) strcat(s, "o");
if (crc32("sGHNfswsbqjj",12) == 355399662) strcat(s, "W");
if (crc32("pOQulBX",7) == 816498492) strcat(s, "n");
if (crc32("AyhLuNXs",8) == 1328647635) strcat(s, "K");
if (crc32("krokmJIca",9) == 1470270191) strcat(s, "g");
if (crc32("TMoyRJWh",8) == 912843803) strcat(s, "o");
if (crc32("MdsHWhTQZrTNS",13) == 1977698581) strcat(s, "l");
if (crc32("iHytM",5) == 3800559383) strcat(s, "I");
if (crc32("HhYTJ",5) == 2071994008) strcat(s, "i");
if (crc32("ydDYVVZQzGKII",13) == 259193043) strcat(s, "a");
if (crc32("dkTEbOQfjusAMo",14) == 1540474443) strcat(s, "A");
if (crc32("yZTwYa",6) == 2874243891) strcat(s, "n");
    return s;
}

char *contactual_adjectives() {
    char *s = calloc(11);
    if (crc32("zSMClxziLkbRir",14) == 2105543400) strcat(s, "c");
if (crc32("EHtwlVSoIai",11) == 2458445138) strcat(s, "L");
if (crc32("ZZownM",6) == 2946285532) strcat(s, "o");
if (crc32("BwIQaynBfROuz",13) == 4136818990) strcat(s, "n");
if (crc32("AtXzsTXIlAhIQ",13) == 3598052962) strcat(s, "T");
if (crc32("ODYqIomRHdbbVo",14) == 1596259561) strcat(s, "t");
if (crc32("KOAMt",5) == 1234286004) strcat(s, "a");
if (crc32("JVFKzjifHjzpbw",14) == 1110987580) strcat(s, "s");
if (crc32("yHyKMmEm",8) == 900408747) strcat(s, "c");
if (crc32("bujhN",5) == 3227728) strcat(s, "t");
if (crc32("KeQOBNDjeR",10) == 3512845803) strcat(s, "u");
if (crc32("FMACiZ",6) == 3132075926) strcat(s, "K");
if (crc32("QokHC",5) == 870516693) strcat(s, "a");
if (crc32("IMiOSBS",7) == 4139456017) strcat(s, "l");
    return s;
}

char *obcuneate_adjectives() {
    char *s = calloc(10);
    if (crc32("RPxAF",5) == 3130325413) strcat(s, "C");
if (crc32("eCohcjKnGNGgND",14) == 2487106167) strcat(s, "o");
if (crc32("qEpsmJriNFskv",13) == 1385380328) strcat(s, "b");
if (crc32("ujYUCKqVS",9) == 4025359929) strcat(s, "c");
if (crc32("fgKGgLhwdVxs",12) == 498333900) strcat(s, "u");
if (crc32("pwCqAyUMKnltbK",14) == 1177584367) strcat(s, "n");
if (crc32("HdXZqrA",7) == 66905743) strcat(s, "K");
if (crc32("bBYsscTvZaFFNBv",15) == 1946824946) strcat(s, "e");
if (crc32("MBDEPewosrKYdt",14) == 2270074883) strcat(s, "P");
if (crc32("VecwJ",5) == 3245340801) strcat(s, "a");
if (crc32("RVZNDYEpR",9) == 3389620945) strcat(s, "s");
if (crc32("HRSFfNNiH",9) == 2230931252) strcat(s, "t");
if (crc32("mIJIFtSJNQW",11) == 4292811960) strcat(s, "e");
    return s;
}

char *unmeddling_adjectives() {
    char *s = calloc(11);
    if (crc32("SrZvxAoQ",8) == 1059171646) strcat(s, "u");
if (crc32("BawhsvfAl",9) == 3596516706) strcat(s, "n");
if (crc32("wjtUdeDB",8) == 1777111072) strcat(s, "p");
if (crc32("xRsxSTF",7) == 1019614910) strcat(s, "m");
if (crc32("dmSJNV",6) == 188899587) strcat(s, "e");
if (crc32("BkgdarAvhkL",11) == 1598876676) strcat(s, "d");
if (crc32("dikIMkjEdXCVo",13) == 1789078258) strcat(s, "s");
if (crc32("TJFdXa",6) == 2380810533) strcat(s, "d");
if (crc32("oEhbDSHJeCACp",13) == 314055648) strcat(s, "l");
if (crc32("gLJQORAXorgzgQH",15) == 3495316164) strcat(s, "k");
if (crc32("jtKBtSHrwLWTUI",14) == 1908187359) strcat(s, "i");
if (crc32("cKlXx",5) == 691533663) strcat(s, "s");
if (crc32("tlydzedgIPMwD",13) == 1710180436) strcat(s, "n");
if (crc32("qPSRWlUWyIe",11) == 3385683555) strcat(s, "g");
    return s;
}

char *nonaccenting_adjectives() {
    char *s = calloc(13);
    if (crc32("FWeqNOcjBnNhK",13) == 3972725633) strcat(s, "V");
if (crc32("ZwtIya",6) == 142320664) strcat(s, "n");
if (crc32("uzojMttt",8) == 3306640416) strcat(s, "o");
if (crc32("CgALq",5) == 1964424298) strcat(s, "n");
if (crc32("MywcEkifX",9) == 2957093735) strcat(s, "a");
if (crc32("aiMKxdL",7) == 1463361417) strcat(s, "c");
if (crc32("QHqyU",5) == 759038999) strcat(s, "c");
if (crc32("zkzpwJ",6) == 2507468927) strcat(s, "d");
if (crc32("xaoNnJGgpxNN",12) == 744710570) strcat(s, "e");
if (crc32("QJeaEARKSOI",11) == 1602961601) strcat(s, "H");
if (crc32("TtvOchcpcFYBRH",14) == 414398013) strcat(s, "n");
if (crc32("YQPGTmAzPv",10) == 2558954094) strcat(s, "t");
if (crc32("XgUkiXajAP",10) == 352095065) strcat(s, "b");
if (crc32("YLgcSaITdPUUSxh",15) == 2705210820) strcat(s, "i");
if (crc32("uiaAqVVOtoNu",12) == 687535517) strcat(s, "e");
if (crc32("nADCGkAx",8) == 1012447937) strcat(s, "n");
if (crc32("nsgGsKfxbqd",11) == 4290348377) strcat(s, "w");
if (crc32("QpbzxOokBJFNDTR",15) == 1913247442) strcat(s, "g");
    return s;
}

char *Pegasian_adjectives() {
    char *s = calloc(9);
    if (crc32("ROVLIqxUndQKnz",14) == 1063101022) strcat(s, "k");
if (crc32("DlFdGIDmvo",10) == 3911723980) strcat(s, "P");
if (crc32("ofyUlCdOodukLe",14) == 403557774) strcat(s, "o");
if (crc32("uhZlNoRxTwBv",12) == 2663371336) strcat(s, "e");
if (crc32("NhGeWHCeHbFjuzT",15) == 2124651218) strcat(s, "z");
if (crc32("lUhccvGKwrOdAsC",15) == 531920899) strcat(s, "g");
if (crc32("RNnGyvXeEjfu",12) == 3438696762) strcat(s, "f");
if (crc32("mmOXfG",6) == 516759978) strcat(s, "a");
if (crc32("wvoLDqRx",8) == 3216548323) strcat(s, "s");
if (crc32("JoCBxzawRfS",11) == 1452171373) strcat(s, "n");
if (crc32("rWzup",5) == 1220633248) strcat(s, "i");
if (crc32("LVYkXlkDSp",10) == 2398746685) strcat(s, "x");
if (crc32("PaDNrxJVlIjHLJ",14) == 420720550) strcat(s, "a");
if (crc32("GavSlIDmF",9) == 3350731941) strcat(s, "n");
    return s;
}

char *underivable_adjectives() {
    char *s = calloc(12);
    if (crc32("HjYyHjwXf",9) == 3810365604) strcat(s, "u");
if (crc32("neeIccnxQtkFXwD",15) == 2792934968) strcat(s, "b");
if (crc32("oZbqHXLxq",9) == 2721891400) strcat(s, "n");
if (crc32("fesvXUiQuizZar",14) == 1074280005) strcat(s, "z");
if (crc32("MtqfjjqCRaSE",12) == 2749483291) strcat(s, "d");
if (crc32("EaGlXnhhRNF",11) == 610526815) strcat(s, "e");
if (crc32("UFlmwiKfrwCxLrh",15) == 3124914013) strcat(s, "r");
if (crc32("YOxDhZC",7) == 3787362475) strcat(s, "i");
if (crc32("WJebvYhNSg",10) == 1387762507) strcat(s, "g");
if (crc32("TTydvXugT",9) == 2665861448) strcat(s, "v");
if (crc32("HsUcjb",6) == 1717025293) strcat(s, "a");
if (crc32("cdBluSXrT",9) == 757720055) strcat(s, "P");
if (crc32("WUhrzncifyvUZeb",15) == 278698235) strcat(s, "b");
if (crc32("DNaoDUQG",8) == 823310894) strcat(s, "l");
if (crc32("JLxDiKaZZmF",11) == 2055939919) strcat(s, "y");
if (crc32("aAgSY",5) == 2405543130) strcat(s, "e");
    return s;
}

char *contained_adjectives() {
    char *s = calloc(10);
    if (crc32("tvHMzlYMQoJI",12) == 662082367) strcat(s, "c");
if (crc32("fcUOZwpALw",10) == 1130161998) strcat(s, "y");
if (crc32("cMutwtK",7) == 3128464127) strcat(s, "o");
if (crc32("rYREzOw",7) == 3286575412) strcat(s, "n");
if (crc32("orLszTf",7) == 3540609062) strcat(s, "v");
if (crc32("kHHZcx",6) == 2499237740) strcat(s, "t");
if (crc32("czIKxoColIeux",13) == 2720798407) strcat(s, "g");
if (crc32("vSuNjOiLtcCXKT",14) == 516172742) strcat(s, "a");
if (crc32("uCVboXzpHad",11) == 255304063) strcat(s, "i");
if (crc32("zFBpCvIp",8) == 1356763552) strcat(s, "g");
if (crc32("DrDhjemQnDg",11) == 532457864) strcat(s, "n");
if (crc32("lKoCO",5) == 2823388855) strcat(s, "e");
if (crc32("ihHilMrIYDc",11) == 4000658529) strcat(s, "w");
if (crc32("ZANPINVLYfaMxb",14) == 52178491) strcat(s, "d");
    return s;
}

char *pseudocultural_adjectives() {
    char *s = calloc(15);
    if (crc32("MPMrg",5) == 466720091) strcat(s, "p");
if (crc32("HLSeoPWFuvDfNnu",15) == 1216073769) strcat(s, "e");
if (crc32("GMarLr",6) == 903101390) strcat(s, "s");
if (crc32("dhOza",5) == 3231839027) strcat(s, "e");
if (crc32("FIrMLWwBtdhPfg",14) == 4003427796) strcat(s, "u");
if (crc32("SxWCEHVOEdhUnI",14) == 3211423067) strcat(s, "E");
if (crc32("QoOrVmFLZLLZ",12) == 2578165072) strcat(s, "d");
if (crc32("NqvmEvfclo",10) == 2228281625) strcat(s, "J");
if (crc32("OEabl",5) == 3935376843) strcat(s, "o");
if (crc32("MHrRdnUubN",10) == 4000100468) strcat(s, "N");
if (crc32("vfNEzLdLzd",10) == 2029081764) strcat(s, "c");
if (crc32("TkkZdjFDSYb",11) == 550789651) strcat(s, "l");
if (crc32("FDUEDAjY",8) == 508512756) strcat(s, "u");
if (crc32("OLhBNPltoCyhx",13) == 1970423465) strcat(s, "l");
if (crc32("LoIykz",6) == 1507845390) strcat(s, "t");
if (crc32("STnXMzAmUWNY",12) == 1220037002) strcat(s, "u");
if (crc32("zjyTdxtd",8) == 2044736663) strcat(s, "r");
if (crc32("VkvUN",5) == 2609015824) strcat(s, "a");
if (crc32("TAURviODv",9) == 2682742379) strcat(s, "P");
if (crc32("ZfiYTlvmgxwz",12) == 3957716770) strcat(s, "l");
    return s;
}

char *cantharidean_adjectives() {
    char *s = calloc(13);
    if (crc32("XgaEBHYvtCD",11) == 40971394) strcat(s, "c");
if (crc32("KVlRopu",7) == 1283648957) strcat(s, "D");
if (crc32("NGehWdv",7) == 3846278848) strcat(s, "a");
if (crc32("VjtUMhktSEM",11) == 1468685184) strcat(s, "J");
if (crc32("gWzDDXIvw",9) == 918327399) strcat(s, "n");
if (crc32("ECywKLSAy",9) == 3910782198) strcat(s, "t");
if (crc32("mRioeq",6) == 2102840144) strcat(s, "t");
if (crc32("vANfXdfdBTfXmi",14) == 3173125287) strcat(s, "S");
if (crc32("XBugQCVmMxLpWB",14) == 2275421765) strcat(s, "h");
if (crc32("fEIlHWuuJqYKh",13) == 1109628353) strcat(s, "a");
if (crc32("dYArMLIUMbFjSl",14) == 2904121464) strcat(s, "r");
if (crc32("EcWQbfjn",8) == 1117052100) strcat(s, "i");
if (crc32("YTVclwIZvPOFE",13) == 1171296416) strcat(s, "z");
if (crc32("ZbpLopAvaf",10) == 3141644601) strcat(s, "d");
if (crc32("BplxBPFInF",10) == 1336897959) strcat(s, "F");
if (crc32("udQqPIMIcyBo",12) == 2573096267) strcat(s, "e");
if (crc32("EmRmcUG",7) == 1220649608) strcat(s, "w");
if (crc32("FXicVzGxA",9) == 2100662716) strcat(s, "a");
if (crc32("PWhxawYEnEoU",12) == 3710073707) strcat(s, "a");
if (crc32("jkwDnVCpQDopO",13) == 3232469247) strcat(s, "n");
    return s;
}

char *sisterly_adjectives() {
    char *s = calloc(9);
    if (crc32("wRWQcEI",7) == 3304641590) strcat(s, "s");
if (crc32("rWTxhtPjm",9) == 3672570901) strcat(s, "i");
if (crc32("bDMNs",5) == 3994173636) strcat(s, "s");
if (crc32("tfUSGDlyMq",10) == 464711674) strcat(s, "A");
if (crc32("hsekMgzWiM",10) == 2967028419) strcat(s, "t");
if (crc32("CmxMdd",6) == 3488550067) strcat(s, "c");
if (crc32("PMgQpTlxF",9) == 724137720) strcat(s, "e");
if (crc32("rkiGN",5) == 3226300746) strcat(s, "r");
if (crc32("cTPidEWhIA",10) == 1467827774) strcat(s, "k");
if (crc32("zyVAqfwim",9) == 3102146660) strcat(s, "l");
if (crc32("lwKmjcwuN",9) == 2919707371) strcat(s, "n");
if (crc32("bRDgltFwVEH",11) == 3880275875) strcat(s, "y");
    return s;
}

char *unshowy_adjectives() {
    char *s = calloc(8);
    if (crc32("AQulXIeWlIUzVBl",15) == 64710200) strcat(s, "u");
if (crc32("CXGBcP",6) == 1857556136) strcat(s, "T");
if (crc32("MYxBYbUI",8) == 2435788791) strcat(s, "n");
if (crc32("FvuWprBJuRwsX",13) == 2057371098) strcat(s, "F");
if (crc32("KGaIUKYxRv",10) == 1553795171) strcat(s, "s");
if (crc32("GDHyKp",6) == 1290112539) strcat(s, "n");
if (crc32("OwtNU",5) == 3429541852) strcat(s, "h");
if (crc32("qaAMcZcfniQGzOg",15) == 2844312907) strcat(s, "o");
if (crc32("RgLvPd",6) == 2857150576) strcat(s, "w");
if (crc32("iTyQIFhAMFEfQz",14) == 2198872349) strcat(s, "y");
    return s;
}

char *happygolucky_adjectives() {
    char *s = calloc(13);
    if (crc32("WwkOYfwWSK",10) == 2402026929) strcat(s, "X");
if (crc32("QGZHlTLWnq",10) == 1782923719) strcat(s, "h");
if (crc32("IGxhUd",6) == 370827493) strcat(s, "a");
if (crc32("XkUsoG",6) == 524609447) strcat(s, "p");
if (crc32("vzxxLxckM",9) == 784994952) strcat(s, "A");
if (crc32("vjJsBQPxljvKxv",14) == 4282819414) strcat(s, "p");
if (crc32("qgnslEEDivdBoF",14) == 4051162142) strcat(s, "G");
if (crc32("OAxJCJ",6) == 3028573390) strcat(s, "y");
if (crc32("KxAkKynTaam",11) == 832867269) strcat(s, "g");
if (crc32("cIgASZT",7) == 1165489789) strcat(s, "o");
if (crc32("baewvovbgxGPA",13) == 3974134362) strcat(s, "l");
if (crc32("LtbQSmyoEvzQDo",14) == 1333349735) strcat(s, "j");
if (crc32("adAKnY",6) == 2826329809) strcat(s, "u");
if (crc32("yqYhhLnbpLpEBY",14) == 3611651645) strcat(s, "O");
if (crc32("AFDQNjXaWvQ",11) == 3478065188) strcat(s, "c");
if (crc32("jFBMtHuMMYm",11) == 2348581383) strcat(s, "k");
if (crc32("GzMLyO",6) == 412944867) strcat(s, "y");
    return s;
}

char *nonapplicable_adjectives() {
    char *s = calloc(14);
    if (crc32("ZcspvL",6) == 3912315718) strcat(s, "n");
if (crc32("wlJiLna",7) == 666068440) strcat(s, "o");
if (crc32("YrBcoAU",7) == 2559181709) strcat(s, "J");
if (crc32("FJmTeIMDZrOjpO",14) == 3083318823) strcat(s, "n");
if (crc32("nzBupJFed",9) == 3967461541) strcat(s, "a");
if (crc32("vIYesFUqIfUmghY",15) == 1996737311) strcat(s, "B");
if (crc32("uAyXAS",6) == 3760628284) strcat(s, "p");
if (crc32("tUCmynoSl",9) == 774612418) strcat(s, "p");
if (crc32("sqFEBtUUTGGollh",15) == 3649199277) strcat(s, "r");
if (crc32("GDSDOqsIPK",10) == 280464988) strcat(s, "l");
if (crc32("hJmUX",5) == 1316170097) strcat(s, "r");
if (crc32("LNOfB",5) == 4032383803) strcat(s, "i");
if (crc32("oTLOCAlJrnrimv",14) == 3870163006) strcat(s, "c");
if (crc32("IXJKOAGafx",10) == 265053480) strcat(s, "a");
if (crc32("VQllOw",6) == 3493156820) strcat(s, "c");
if (crc32("zzFgdOWDvJx",11) == 4198579064) strcat(s, "b");
if (crc32("ulJgLhFAzgA",11) == 1605233395) strcat(s, "l");
if (crc32("OzrpeOZoPSp",11) == 638617992) strcat(s, "e");
    return s;
}

char *unadvertised_adjectives() {
    char *s = calloc(13);
    if (crc32("UzMpthkUa",9) == 2258223434) strcat(s, "u");
if (crc32("JDuAisFRUNCmH",13) == 2700896248) strcat(s, "n");
if (crc32("HQUFVOPE",8) == 3611161350) strcat(s, "W");
if (crc32("JWwhqw",6) == 3713742311) strcat(s, "a");
if (crc32("mblgPHwBcr",10) == 1836284811) strcat(s, "d");
if (crc32("ORQFngo",7) == 3581552488) strcat(s, "y");
if (crc32("ogvYEXlw",8) == 63720256) strcat(s, "v");
if (crc32("fNZdIovRzTip",12) == 3367242684) strcat(s, "e");
if (crc32("qaBzRjbhrxNrVbT",15) == 336186786) strcat(s, "r");
if (crc32("pFklCljGKDgvT",13) == 3595031441) strcat(s, "i");
if (crc32("KTushWSJg",9) == 275135649) strcat(s, "t");
if (crc32("ucGHtUgfuYWGhdb",15) == 648893248) strcat(s, "i");
if (crc32("nCkkzKuStWm",11) == 881955101) strcat(s, "P");
if (crc32("ewGUEbLwtAd",11) == 822428784) strcat(s, "s");
if (crc32("oVWRf",5) == 2223411207) strcat(s, "o");
if (crc32("wYItwQoRcrNNUKD",15) == 2741378820) strcat(s, "e");
if (crc32("vGXkbxyIJRwgacy",15) == 949885450) strcat(s, "d");
    return s;
}

char *cornmeal_adjectives() {
    char *s = calloc(9);
    if (crc32("NfXZgMPOcYuJRxI",15) == 4040138794) strcat(s, "Z");
if (crc32("fCFFk",5) == 1369776898) strcat(s, "c");
if (crc32("zDLVFYnL",8) == 2117708395) strcat(s, "o");
if (crc32("fGsQhkGAK",9) == 3861410422) strcat(s, "Q");
if (crc32("lVXYXWTQtE",10) == 395164861) strcat(s, "r");
if (crc32("qSOSKz",6) == 14621874) strcat(s, "n");
if (crc32("otJHE",5) == 2217428894) strcat(s, "G");
if (crc32("nsFDaSUjdcsuAja",15) == 3187616840) strcat(s, "m");
if (crc32("vNVDCZuiTJkIl",13) == 1990358426) strcat(s, "O");
if (crc32("GwcXzYHmeoxi",12) == 2397190290) strcat(s, "e");
if (crc32("EonRvWcdBk",10) == 1086518193) strcat(s, "a");
if (crc32("oUNyzmCyOr",10) == 1848904728) strcat(s, "l");
    return s;
}

char *structureless_adjectives() {
    char *s = calloc(14);
    if (crc32("jgJDZBVt",8) == 323467379) strcat(s, "a");
if (crc32("wGagLuCqEFZA",12) == 3323798893) strcat(s, "s");
if (crc32("ZeVucVXMXU",10) == 1358607287) strcat(s, "t");
if (crc32("InaJnyMpIGUo",12) == 3782269179) strcat(s, "w");
if (crc32("KQmkZU",6) == 129345229) strcat(s, "r");
if (crc32("gNBRsCXz",8) == 4217878005) strcat(s, "B");
if (crc32("ppVnBZyCN",9) == 1603416877) strcat(s, "u");
if (crc32("lFQyErqcJ",9) == 3608697151) strcat(s, "H");
if (crc32("NdanzTCWOrp",11) == 428372178) strcat(s, "c");
if (crc32("XKmjtpqCDWI",11) == 4040719284) strcat(s, "t");
if (crc32("pDEpIudsnyrDjep",15) == 2917208430) strcat(s, "Y");
if (crc32("FZFicrkMsS",10) == 166304916) strcat(s, "u");
if (crc32("DFEpSrfbM",9) == 3962881456) strcat(s, "u");
if (crc32("ytQZS",5) == 167097215) strcat(s, "r");
if (crc32("bgjlY",5) == 1183747936) strcat(s, "N");
if (crc32("btUHoFwHbRl",11) == 1750594061) strcat(s, "e");
if (crc32("VKGthV",6) == 1042388599) strcat(s, "l");
if (crc32("gVhuRxUqjyha",12) == 1475816988) strcat(s, "b");
if (crc32("HSEzD",5) == 2770935559) strcat(s, "e");
if (crc32("wQydKY",6) == 4198861269) strcat(s, "s");
if (crc32("PTRZVT",6) == 4028089135) strcat(s, "s");
    return s;
}

char *saxophonic_adjectives() {
    char *s = calloc(11);
    if (crc32("MmEzb",5) == 793795225) strcat(s, "M");
if (crc32("hJHdVm",6) == 2310707301) strcat(s, "s");
if (crc32("KZkZXWYIVgRw",12) == 919683266) strcat(s, "S");
if (crc32("GDsMRtlvCBEHjN",14) == 2842403912) strcat(s, "a");
if (crc32("dOxgnJ",6) == 1986041862) strcat(s, "x");
if (crc32("zNIvJomqAxmOJ",13) == 352368575) strcat(s, "w");
if (crc32("CVUfBsDVpy",10) == 3836507178) strcat(s, "o");
if (crc32("xHgmgxMHs",9) == 2701531874) strcat(s, "p");
if (crc32("iZxFCB",6) == 1971350816) strcat(s, "h");
if (crc32("YaxdQDHxIf",10) == 3241286497) strcat(s, "D");
if (crc32("nOnULr",6) == 181828707) strcat(s, "o");
if (crc32("vIMKPEItX",9) == 4063543567) strcat(s, "r");
if (crc32("WUkordYkWOnf",12) == 3059624866) strcat(s, "n");
if (crc32("ZwMmSGoVBUXa",12) == 1542394412) strcat(s, "E");
if (crc32("AmCVYvQwxkgHsdt",15) == 3215323806) strcat(s, "i");
if (crc32("AtKSXtBmqCtKMwh",15) == 405117974) strcat(s, "c");
    return s;
}

char *halffinished_adjectives() {
    char *s = calloc(13);
    if (crc32("RoORKmJJ",8) == 596097922) strcat(s, "h");
if (crc32("mbBcaYbPlzzyIid",15) == 3086256036) strcat(s, "a");
if (crc32("vTYVG",5) == 719478754) strcat(s, "y");
if (crc32("aLYhyEdiU",9) == 958483296) strcat(s, "l");
if (crc32("GQyJktr",7) == 255451608) strcat(s, "m");
if (crc32("gnSzJdyQst",10) == 1038326287) strcat(s, "f");
if (crc32("WaeGXjlt",8) == 3323500751) strcat(s, "g");
if (crc32("KKIOGml",7) == 3387545053) strcat(s, "f");
if (crc32("riJhvgmTF",9) == 3822892199) strcat(s, "D");
if (crc32("XGLMnkjR",8) == 1069038854) strcat(s, "i");
if (crc32("kPnxEwusZrVH",12) == 351453834) strcat(s, "n");
if (crc32("bpdUEniForMlFD",14) == 1179739871) strcat(s, "l");
if (crc32("tAYnZEPVGU",10) == 2116180020) strcat(s, "i");
if (crc32("cyiiNvhRaIj",11) == 2487374028) strcat(s, "z");
if (crc32("mFjDIJAS",8) == 2367330654) strcat(s, "s");
if (crc32("DzrsvaVAnjW",11) == 3762826877) strcat(s, "h");
if (crc32("qsiLYpJFZGpgo",13) == 136709368) strcat(s, "e");
if (crc32("ViFCTFAyJ",9) == 3971107951) strcat(s, "d");
    return s;
}

char *nongranulated_adjectives() {
    char *s = calloc(14);
    if (crc32("BjtWgutROcLtZ",13) == 3397227487) strcat(s, "n");
if (crc32("GNOBljfHQFHYX",13) == 4068127247) strcat(s, "o");
if (crc32("mkPfmCxNDvepu",13) == 4188815197) strcat(s, "n");
if (crc32("HpUZcXugbuu",11) == 4182920256) strcat(s, "g");
if (crc32("qtJZMJaZOauY",12) == 1836601888) strcat(s, "x");
if (crc32("tcDyNqszqZAQvnK",15) == 3182943078) strcat(s, "r");
if (crc32("fFeTfMIHzsOc",12) == 2636111613) strcat(s, "v");
if (crc32("eDSBfTwO",8) == 379702319) strcat(s, "a");
if (crc32("pIVvKzd",7) == 1401608107) strcat(s, "W");
if (crc32("PjHtplLXnhZ",11) == 4238079076) strcat(s, "n");
if (crc32("DPnqaAliZNoc",12) == 735675695) strcat(s, "g");
if (crc32("ZNpMDkjV",8) == 1398747965) strcat(s, "u");
if (crc32("PvpctMAej",9) == 1039488684) strcat(s, "l");
if (crc32("ypFQSMXB",8) == 3732112397) strcat(s, "M");
if (crc32("FOuAEunDjNDkDl",14) == 551132805) strcat(s, "a");
if (crc32("pgJFp",5) == 1508266952) strcat(s, "X");
if (crc32("LhQasqUwIOcnr",13) == 3597065706) strcat(s, "t");
if (crc32("YjuhR",5) == 3720427020) strcat(s, "e");
if (crc32("ettrQIBBa",9) == 4003578870) strcat(s, "d");
    return s;
}

char *unlaurelled_adjectives() {
    char *s = calloc(12);
    if (crc32("fmqwPPhJmed",11) == 3596102157) strcat(s, "u");
if (crc32("mpkzLMUBK",9) == 2033629465) strcat(s, "n");
if (crc32("QltNVqjJWm",10) == 2200928748) strcat(s, "q");
if (crc32("RmZBensZJgUXl",13) == 2611148032) strcat(s, "l");
if (crc32("OUnEDPAQGjKuznI",15) == 3475246182) strcat(s, "a");
if (crc32("OTPAEVhWFZ",10) == 353436979) strcat(s, "g");
if (crc32("gaKheLBXtUKWje",14) == 3551434894) strcat(s, "u");
if (crc32("bWuEpw",6) == 1235703945) strcat(s, "c");
if (crc32("DIEfePVvwQq",11) == 337896811) strcat(s, "r");
if (crc32("HMpmBbl",7) == 151080763) strcat(s, "e");
if (crc32("HmPjcQObQthFh",13) == 1566677227) strcat(s, "w");
if (crc32("GfDXpejn",8) == 579716887) strcat(s, "l");
if (crc32("UIzIpJUSjKWi",12) == 640038682) strcat(s, "d");
if (crc32("PxgJckqHNTdoUl",14) == 22329721) strcat(s, "l");
if (crc32("KRFRi",5) == 1089556020) strcat(s, "e");
if (crc32("DUXlWfmBvF",10) == 3636529166) strcat(s, "d");
if (crc32("zHewDnQZPkVTEPf",15) == 1442826907) strcat(s, "d");
    return s;
}

char *xenogenic_adjectives() {
    char *s = calloc(10);
    if (crc32("hyhvG",5) == 809846392) strcat(s, "G");
if (crc32("TlnTAEbuwK",10) == 3987451699) strcat(s, "x");
if (crc32("YSMlDKrmhuc",11) == 2192214269) strcat(s, "s");
if (crc32("nAAWiR",6) == 2645449003) strcat(s, "e");
if (crc32("RjrwbBSHQGGWlvN",15) == 1022965976) strcat(s, "V");
if (crc32("AkwcwzQJTv",10) == 2621914367) strcat(s, "n");
if (crc32("eHPJd",5) == 3443772192) strcat(s, "O");
if (crc32("WiPbGTj",7) == 4223413701) strcat(s, "o");
if (crc32("AunpOunxCG",10) == 3621633443) strcat(s, "t");
if (crc32("JAzEU",5) == 950041360) strcat(s, "g");
if (crc32("wbkqbGjPJTsg",12) == 2789576056) strcat(s, "Z");
if (crc32("zCFiXwlLimTGvVa",15) == 3598371529) strcat(s, "e");
if (crc32("bQEOjRqgPf",10) == 66575527) strcat(s, "h");
if (crc32("MQcXndrWHanwfy",14) == 2140346911) strcat(s, "n");
if (crc32("XNsZRppcTqSgXj",14) == 3406361658) strcat(s, "a");
if (crc32("nhzKA",5) == 1434643347) strcat(s, "i");
if (crc32("WJvyHRZ",7) == 73483584) strcat(s, "V");
if (crc32("OdpJyewOioaK",12) == 1518529063) strcat(s, "c");
    return s;
}

char *busied_adjectives() {
    char *s = calloc(7);
    if (crc32("iYfLXXS",7) == 2380022277) strcat(s, "b");
if (crc32("YpgdOHdCE",9) == 3350087177) strcat(s, "z");
if (crc32("ycRvoLDI",8) == 3664207869) strcat(s, "u");
if (crc32("ZUWfGx",6) == 3647364721) strcat(s, "u");
if (crc32("iJpAaQjhO",9) == 1595683316) strcat(s, "s");
if (crc32("WSNClGVYHaXoGF",14) == 2087310062) strcat(s, "a");
if (crc32("ponLuMzzE",9) == 1849605753) strcat(s, "i");
if (crc32("Gljbosxc",8) == 1180616797) strcat(s, "e");
if (crc32("hFgqKFanHIUSSc",14) == 1313046294) strcat(s, "B");
if (crc32("vFWbnMsPY",9) == 2563454770) strcat(s, "d");
    return s;
}

char *proCeylon_adjectives() {
    char *s = calloc(10);
    if (crc32("VLQprSeZ",8) == 2000215630) strcat(s, "p");
if (crc32("CfwKUSvLuQjZjqw",15) == 3955808420) strcat(s, "r");
if (crc32("zwRNQ",5) == 2651221601) strcat(s, "o");
if (crc32("zHUFXMPXNSAQCxZ",15) == 3809191665) strcat(s, "h");
if (crc32("TDvzf",5) == 1052381327) strcat(s, "C");
if (crc32("jICCrFqCZFppecU",15) == 1052261615) strcat(s, "p");
if (crc32("gAiSr",5) == 2785250608) strcat(s, "e");
if (crc32("KhWbItXFsaFqgx",14) == 1743523971) strcat(s, "k");
if (crc32("JUyiC",5) == 679009150) strcat(s, "y");
if (crc32("GKLknxptiE",10) == 1169876493) strcat(s, "l");
if (crc32("YcrplvRfFeQFRZx",15) == 2139335329) strcat(s, "o");
if (crc32("sZxdnoaOLigE",12) == 1297860536) strcat(s, "n");
    return s;
}

char *prouniversity_adjectives() {
    char *s = calloc(14);
    if (crc32("DaXCaZW",7) == 2467099052) strcat(s, "p");
if (crc32("DIXiyrbCIwp",11) == 2918016011) strcat(s, "T");
if (crc32("GxWPlUBhDOm",11) == 3455756214) strcat(s, "r");
if (crc32("wFcIIbDj",8) == 1019953402) strcat(s, "l");
if (crc32("KuWLivuazCf",11) == 2979116952) strcat(s, "o");
if (crc32("hpMgq",5) == 1906559316) strcat(s, "u");
if (crc32("DjrywxMNl",9) == 3292758554) strcat(s, "n");
if (crc32("KvBnW",5) == 3661282005) strcat(s, "i");
if (crc32("ghXCKe",6) == 1598141696) strcat(s, "v");
if (crc32("DzCcK",5) == 30804331) strcat(s, "U");
if (crc32("NMsWsDdqRtXfR",13) == 1933994304) strcat(s, "e");
if (crc32("IdvCt",5) == 1953616997) strcat(s, "I");
if (crc32("ZmXdkAZ",7) == 886731570) strcat(s, "r");
if (crc32("LFsDBFnrOMMk",12) == 2477792743) strcat(s, "z");
if (crc32("WTEtVjVuGQDFH",13) == 1997646404) strcat(s, "s");
if (crc32("SalLOaWH",8) == 1994456377) strcat(s, "i");
if (crc32("walra",5) == 1563813691) strcat(s, "k");
if (crc32("efNYgvhr",8) == 4038911016) strcat(s, "t");
if (crc32("CuSRUQaZhrvTdS",14) == 1735914821) strcat(s, "N");
if (crc32("tCEhOuj",7) == 3874460761) strcat(s, "y");
    return s;
}

char *stipitiform_adjectives() {
    char *s = calloc(12);
    if (crc32("yXpRvonlo",9) == 3527392502) strcat(s, "s");
if (crc32("zMHMtUwcADdd",12) == 955279637) strcat(s, "G");
if (crc32("PovoUmLx",8) == 892157959) strcat(s, "t");
if (crc32("cApSBblOlGAHOX",14) == 2202160453) strcat(s, "i");
if (crc32("RYgQasFlst",10) == 2557103878) strcat(s, "P");
if (crc32("kCQVu",5) == 9534836) strcat(s, "p");
if (crc32("LujIoL",6) == 1320542192) strcat(s, "i");
if (crc32("rwBqNqsUB",9) == 731070270) strcat(s, "d");
if (crc32("PYBAIlqdWvgNDg",14) == 2296773387) strcat(s, "t");
if (crc32("MGDZYoK",7) == 3274185235) strcat(s, "i");
if (crc32("oXiWHvk",7) == 556379184) strcat(s, "S");
if (crc32("fmaUNJfvJJEfj",13) == 1284720733) strcat(s, "f");
if (crc32("cTuSbxlHIRvquBN",15) == 3486895750) strcat(s, "o");
if (crc32("OiJTstsDySNq",12) == 2677374515) strcat(s, "r");
if (crc32("ajoOpZf",7) == 926356035) strcat(s, "Q");
if (crc32("iTwVEOUdaurh",12) == 2140918110) strcat(s, "m");
    return s;
}

char *unsanctionable_adjectives() {
    char *s = calloc(15);
    if (crc32("IpkBgzWCLkNuEB",14) == 749833093) strcat(s, "u");
if (crc32("WsLsuBTa",8) == 3929309078) strcat(s, "u");
if (crc32("XRkwEs",6) == 1255633852) strcat(s, "O");
if (crc32("OdaBJVCvicEdlcP",15) == 239999307) strcat(s, "n");
if (crc32("wsmyKw",6) == 3114217120) strcat(s, "s");
if (crc32("vcFFhkUeDec",11) == 2558072645) strcat(s, "s");
if (crc32("ZbIYuVVOz",9) == 436057918) strcat(s, "a");
if (crc32("dLKPKX",6) == 3912296227) strcat(s, "n");
if (crc32("gtAfqtODzlF",11) == 693047551) strcat(s, "c");
if (crc32("tuGoHjqx",8) == 2303584858) strcat(s, "t");
if (crc32("SMKhRiiOU",9) == 3160871726) strcat(s, "p");
if (crc32("HTmPYi",6) == 1706917414) strcat(s, "i");
if (crc32("VGBQy",5) == 3133362046) strcat(s, "O");
if (crc32("Hnxga",5) == 1068757475) strcat(s, "o");
if (crc32("VowBEsqajVSOg",13) == 2495676257) strcat(s, "b");
if (crc32("KBblTCZV",8) == 793820140) strcat(s, "n");
if (crc32("wKGMGbJ",7) == 2131524030) strcat(s, "X");
if (crc32("BCjfU",5) == 5647435) strcat(s, "a");
if (crc32("IoBuqumjVUlcYH",14) == 4081084699) strcat(s, "L");
if (crc32("lSOHpEMm",8) == 225243548) strcat(s, "b");
if (crc32("VDYkRQR",7) == 3409303726) strcat(s, "i");
if (crc32("owETbfefcBLBHQ",14) == 211272056) strcat(s, "l");
if (crc32("gKgwElQ",7) == 3362614816) strcat(s, "e");
    return s;
}

char *neuroplasmatic_adjectives() {
    char *s = calloc(15);
    if (crc32("bIvDVqrCY",9) == 1132035355) strcat(s, "n");
if (crc32("HiWFQYdj",8) == 4217815484) strcat(s, "e");
if (crc32("rLBPvj",6) == 3817361425) strcat(s, "u");
if (crc32("XVpGCiHVFUGTE",13) == 245605261) strcat(s, "r");
if (crc32("GfORHyBOugGNz",13) == 927438177) strcat(s, "o");
if (crc32("ibiRRvhPCAFJs",13) == 3711502915) strcat(s, "p");
if (crc32("phTAsqWrPfUEJt",14) == 3617553458) strcat(s, "u");
if (crc32("kZYMjwZhx",9) == 1323898113) strcat(s, "l");
if (crc32("VfMJzknzHQYc",12) == 2309718488) strcat(s, "a");
if (crc32("kURCPFoLniYFYGV",15) == 4047202921) strcat(s, "s");
if (crc32("mindzXm",7) == 3535217294) strcat(s, "m");
if (crc32("bnjjOMLvT",9) == 3839808936) strcat(s, "V");
if (crc32("HMaiXBMVrizesv",14) == 1284243834) strcat(s, "a");
if (crc32("pkcJlrgU",8) == 3419981668) strcat(s, "t");
if (crc32("RYjOIfhEA",9) == 1229995887) strcat(s, "D");
if (crc32("UVrbt",5) == 2405558246) strcat(s, "i");
if (crc32("DEILcCIsbx",10) == 3762058263) strcat(s, "F");
if (crc32("XLJilhtvjX",10) == 1332413349) strcat(s, "c");
    return s;
}

char *groomish_adjectives() {
    char *s = calloc(9);
    if (crc32("wwHCnXcSDpY",11) == 4009951797) strcat(s, "d");
if (crc32("tcDYnW",6) == 2257173442) strcat(s, "g");
if (crc32("yfpVXsFkIwXzVy",14) == 3564135321) strcat(s, "i");
if (crc32("EZLHaRQmQ",9) == 2992472895) strcat(s, "r");
if (crc32("CVAcPOg",7) == 3067345893) strcat(s, "o");
if (crc32("CycALmM",7) == 2552660533) strcat(s, "o");
if (crc32("LjzLBcYijHGT",12) == 2992852795) strcat(s, "m");
if (crc32("dNJGNjlkryOU",12) == 2468863270) strcat(s, "i");
if (crc32("nCXucfms",8) == 2027502898) strcat(s, "s");
if (crc32("pvwjmcXRcZg",11) == 2033550062) strcat(s, "Z");
if (crc32("pKthSsqWCIdECr",14) == 3391867971) strcat(s, "h");
    return s;
}

char *discreditable_adjectives() {
    char *s = calloc(14);
    if (crc32("uOTkazmVuL",10) == 1451873818) strcat(s, "d");
if (crc32("aTssya",6) == 109968821) strcat(s, "r");
if (crc32("geVwqBySpWz",11) == 3059037437) strcat(s, "i");
if (crc32("ZJlpDpEBPzZ",11) == 1428169505) strcat(s, "b");
if (crc32("EiTzhxUlqnxwG",13) == 1755013721) strcat(s, "s");
if (crc32("lHlmpT",6) == 3568402905) strcat(s, "c");
if (crc32("ADzZNIYJKr",10) == 2911302278) strcat(s, "r");
if (crc32("EXXXgWAgckzp",12) == 1236242271) strcat(s, "e");
if (crc32("UrIszHeojQu",11) == 2671184220) strcat(s, "d");
if (crc32("weZAV",5) == 2042727309) strcat(s, "q");
if (crc32("mTPByclEPGQAg",13) == 3822754183) strcat(s, "i");
if (crc32("gsCBbPaPst",10) == 2892654957) strcat(s, "t");
if (crc32("pLyUXbh",7) == 2005018411) strcat(s, "a");
if (crc32("jDgeNTGrUkV",11) == 672962629) strcat(s, "b");
if (crc32("VJqoRoOH",8) == 2136866680) strcat(s, "o");
if (crc32("BfUmqmSCjxoUV",13) == 1958447722) strcat(s, "l");
if (crc32("zmvAINnO",8) == 1977138049) strcat(s, "R");
if (crc32("yxNiXhM",7) == 1709586433) strcat(s, "e");
    return s;
}

char *odontophorous_adjectives() {
    char *s = calloc(14);
    if (crc32("sLTKeViIxySPna",14) == 867280344) strcat(s, "D");
if (crc32("OrgXBVjPCIqb",12) == 3161328142) strcat(s, "o");
if (crc32("JIFSONkVpWPFa",13) == 2026536284) strcat(s, "d");
if (crc32("XZFrYEfIAVKwdm",14) == 2689681276) strcat(s, "H");
if (crc32("UXLLTkBODzIIaqH",15) == 592217717) strcat(s, "o");
if (crc32("hTlSbXdbw",9) == 770513856) strcat(s, "n");
if (crc32("HvxDZQYBV",9) == 2788216896) strcat(s, "F");
if (crc32("NVFrcgJAVPDUDUx",15) == 1571272035) strcat(s, "t");
if (crc32("QKOrv",5) == 833733331) strcat(s, "z");
if (crc32("bXKvJIFhWoSb",12) == 2798960646) strcat(s, "o");
if (crc32("SGGFQqJf",8) == 22674070) strcat(s, "O");
if (crc32("EMvwQSL",7) == 996234995) strcat(s, "p");
if (crc32("nIqwemqAI",9) == 3299944939) strcat(s, "N");
if (crc32("hVJqR",5) == 1330310038) strcat(s, "h");
if (crc32("GnTdz",5) == 1803530973) strcat(s, "e");
if (crc32("LhEAPhJT",8) == 1914062647) strcat(s, "o");
if (crc32("OoBEiPpBuywv",12) == 3810061172) strcat(s, "G");
if (crc32("FWGtivUlLGia",12) == 1311191729) strcat(s, "r");
if (crc32("qXIMqwwqo",9) == 2933187211) strcat(s, "P");
if (crc32("akOPLQG",7) == 4054346510) strcat(s, "o");
if (crc32("peTpaX",6) == 3808045018) strcat(s, "u");
if (crc32("GjFYfpBAA",9) == 4150373362) strcat(s, "s");
    return s;
}

char *subvitalized_adjectives() {
    char *s = calloc(13);
    if (crc32("kOLwGQjgU",9) == 2962293649) strcat(s, "s");
if (crc32("LTWdaIiepM",10) == 3515031125) strcat(s, "u");
if (crc32("BYINZTqiIooXoiM",15) == 521725637) strcat(s, "b");
if (crc32("DAPGERqPYfm",11) == 375901337) strcat(s, "v");
if (crc32("pHRYwufReWZGbK",14) == 3056373283) strcat(s, "i");
if (crc32("NSmyj",5) == 4008806278) strcat(s, "l");
if (crc32("tXgopIbWfcZafI",14) == 3488521433) strcat(s, "t");
if (crc32("seFZc",5) == 2488278653) strcat(s, "a");
if (crc32("wleMoOhUsymY",12) == 2088116712) strcat(s, "p");
if (crc32("YbbrpNQjKARjY",13) == 2976507974) strcat(s, "l");
if (crc32("uKnmLu",6) == 1524842469) strcat(s, "m");
if (crc32("qbwCFOhug",9) == 3766678731) strcat(s, "i");
if (crc32("eZpgk",5) == 2540555526) strcat(s, "z");
if (crc32("cGpfp",5) == 689983305) strcat(s, "e");
if (crc32("bitzKUFmp",9) == 2646486708) strcat(s, "h");
if (crc32("sDtcZw",6) == 2986226614) strcat(s, "d");
    return s;
}

char *excrescent_adjectives() {
    char *s = calloc(11);
    if (crc32("EitUsGypYdu",11) == 1129359599) strcat(s, "e");
if (crc32("fBGcLay",7) == 2677544857) strcat(s, "t");
if (crc32("oRMAGgFQs",9) == 3247543570) strcat(s, "x");
if (crc32("VNvwu",5) == 1989237437) strcat(s, "i");
if (crc32("EbQWg",5) == 2353816643) strcat(s, "c");
if (crc32("OtcWBTK",7) == 1336618459) strcat(s, "R");
if (crc32("dHRtEbnsQylxQ",13) == 3520493231) strcat(s, "r");
if (crc32("aazXHJmuMmW",11) == 2664171530) strcat(s, "e");
if (crc32("KRbOWGnbqcud",12) == 1074383026) strcat(s, "s");
if (crc32("UXDkvuRegukDdEj",15) == 418290008) strcat(s, "c");
if (crc32("UfhbkpVXe",9) == 2541478705) strcat(s, "e");
if (crc32("kTCEg",5) == 1084970390) strcat(s, "n");
if (crc32("trwIsserBDIhL",13) == 2360909488) strcat(s, "c");
if (crc32("rxGbNOmZTMiByx",14) == 2574394521) strcat(s, "t");
    return s;
}

char *semipractical_adjectives() {
    char *s = calloc(14);
    if (crc32("fKydZbcSMSA",11) == 2426478196) strcat(s, "s");
if (crc32("cqsxyAhtOBiyC",13) == 2914077611) strcat(s, "e");
if (crc32("JMBXeDUMwqTFB",13) == 3064988584) strcat(s, "m");
if (crc32("LRyOa",5) == 220393756) strcat(s, "N");
if (crc32("mboVYt",6) == 3510599525) strcat(s, "i");
if (crc32("AulrlLKtmDKktyY",15) == 1008396494) strcat(s, "s");
if (crc32("Yyrjqt",6) == 2344329553) strcat(s, "p");
if (crc32("ZkBkk",5) == 2010186599) strcat(s, "r");
if (crc32("DSZbXZ",6) == 1461027508) strcat(s, "u");
if (crc32("HAyMy",5) == 3123146946) strcat(s, "a");
if (crc32("COkTovFdXZn",11) == 2042060811) strcat(s, "D");
if (crc32("wQqIzoMI",8) == 3730195750) strcat(s, "c");
if (crc32("diMgYmABrwQQfM",14) == 3961306349) strcat(s, "t");
if (crc32("OVPxalWYso",10) == 680121558) strcat(s, "r");
if (crc32("ozNKZXjMUV",10) == 278623267) strcat(s, "i");
if (crc32("CtNYTwwFUntMjBS",15) == 3988753376) strcat(s, "c");
if (crc32("vOvUGP",6) == 999448056) strcat(s, "X");
if (crc32("AVBvAerC",8) == 1803174482) strcat(s, "a");
if (crc32("YumwycZXjy",10) == 4243952462) strcat(s, "l");
    return s;
}

char *unrequisitioned_adjectives() {
    char *s = calloc(16);
    if (crc32("ECcEIFzjXOkXjcV",15) == 2508078037) strcat(s, "u");
if (crc32("ildMxfSJiU",10) == 4292501258) strcat(s, "n");
if (crc32("yJfbGIXIOydEoEQ",15) == 1409209115) strcat(s, "H");
if (crc32("zULlFpoz",8) == 3040625793) strcat(s, "r");
if (crc32("DFAXCw",6) == 2794126393) strcat(s, "e");
if (crc32("lAdJcWXMDvXJcR",14) == 4049498322) strcat(s, "o");
if (crc32("JqxTwW",6) == 2348573871) strcat(s, "q");
if (crc32("rZtLZvpPgOMsU",13) == 729547447) strcat(s, "u");
if (crc32("hgeBohLQnDtVAt",14) == 2990995459) strcat(s, "i");
if (crc32("CcwUoA",6) == 2579343084) strcat(s, "s");
if (crc32("XdXsPeRAuA",10) == 2584526495) strcat(s, "i");
if (crc32("FZKFyxxU",8) == 258700743) strcat(s, "i");
if (crc32("nvRnkGHEZbMq",12) == 1752370352) strcat(s, "L");
if (crc32("nVurlkJjRWaTDmf",15) == 4149097078) strcat(s, "t");
if (crc32("dkhSmdVIeiq",11) == 1811261810) strcat(s, "i");
if (crc32("OPqCLB",6) == 312345092) strcat(s, "o");
if (crc32("lmoRPZtddJxmjC",14) == 1387708128) strcat(s, "n");
if (crc32("ZmzpU",5) == 278216354) strcat(s, "e");
if (crc32("UphfpfNSOavztL",14) == 3499490742) strcat(s, "d");
    return s;
}

char *unsunken_adjectives() {
    char *s = calloc(9);
    if (crc32("wqYEJFlfBdRVC",13) == 3237096958) strcat(s, "u");
if (crc32("ryScCovF",8) == 1927971613) strcat(s, "n");
if (crc32("zggkvu",6) == 2333119713) strcat(s, "n");
if (crc32("vrNTDWNaUs",10) == 1752520486) strcat(s, "O");
if (crc32("DUmZTKiLyJ",10) == 1865633187) strcat(s, "s");
if (crc32("zvkPEqFvb",9) == 2178607788) strcat(s, "u");
if (crc32("yXJArYVmFKxKPk",14) == 440513139) strcat(s, "n");
if (crc32("zjzRfBRbN",9) == 1158236728) strcat(s, "k");
if (crc32("tEaGmzuIFCPRX",13) == 2308783638) strcat(s, "M");
if (crc32("vmgXECrdnW",10) == 3216688635) strcat(s, "e");
if (crc32("YdcTMPlqFUjzUbS",15) == 724436310) strcat(s, "n");
    return s;
}

char *sublanceolate_adjectives() {
    char *s = calloc(14);
    if (crc32("TEkYuGPCUfDt",12) == 2355183257) strcat(s, "b");
if (crc32("lZIpDunCrT",10) == 1749439608) strcat(s, "s");
if (crc32("kVMtUIxgTD",10) == 615475066) strcat(s, "u");
if (crc32("fKBQNSQZWALkHu",14) == 3063578006) strcat(s, "b");
if (crc32("dmcbPHqky",9) == 3478802383) strcat(s, "l");
if (crc32("hZKHqwSY",8) == 2005678058) strcat(s, "E");
if (crc32("DaKrxFbzNxixTf",14) == 3046010934) strcat(s, "a");
if (crc32("IUFUZZPpLjc",11) == 2260931945) strcat(s, "n");
if (crc32("UqcMLvB",7) == 52740127) strcat(s, "n");
if (crc32("gTCgFJLrTVriZo",14) == 3286898379) strcat(s, "l");
if (crc32("pJBIKTTeebks",12) == 3993522023) strcat(s, "c");
if (crc32("xBQGiuyXrBo",11) == 3047781116) strcat(s, "Y");
if (crc32("wmqAdXNRptMBn",13) == 4016867161) strcat(s, "e");
if (crc32("IiwEFB",6) == 3935592160) strcat(s, "t");
if (crc32("WWebFFHWJnRhJ",13) == 2118511502) strcat(s, "o");
if (crc32("rXtjjCEbOYM",11) == 2418974059) strcat(s, "T");
if (crc32("lAoLuF",6) == 2086004124) strcat(s, "l");
if (crc32("sFnitADHWpjfT",13) == 2476674187) strcat(s, "D");
if (crc32("Rxiaxclbq",9) == 3383471002) strcat(s, "a");
if (crc32("iFuLeW",6) == 2171481447) strcat(s, "t");
if (crc32("aUbRXpv",7) == 2599301272) strcat(s, "e");
    return s;
}

char *torchless_adjectives() {
    char *s = calloc(10);
    if (crc32("szCkJSk",7) == 802871205) strcat(s, "t");
if (crc32("aIJfSkQFSBmbh",13) == 423340761) strcat(s, "o");
if (crc32("eqnUycpQspj",11) == 1945404697) strcat(s, "r");
if (crc32("bfmegHFNum",10) == 3393421680) strcat(s, "H");
if (crc32("HhvcQgcgsL",10) == 2861436984) strcat(s, "c");
if (crc32("FqNEUr",6) == 1928833443) strcat(s, "h");
if (crc32("bdmJB",5) == 1138715684) strcat(s, "h");
if (crc32("HSBxkXj",7) == 3890847602) strcat(s, "L");
if (crc32("habZuFmmWXYT",12) == 3541484008) strcat(s, "l");
if (crc32("KmcPWPs",7) == 449714151) strcat(s, "p");
if (crc32("lVNePAkuNxLeBJN",15) == 1096382904) strcat(s, "e");
if (crc32("PWFMmRfmZqSZNae",15) == 3802620862) strcat(s, "T");
if (crc32("LxLSM",5) == 366054712) strcat(s, "s");
if (crc32("TDEqtozZBMRzF",13) == 3330481847) strcat(s, "Y");
if (crc32("kNWveK",6) == 3406863377) strcat(s, "s");
    return s;
}

char *ostracizable_adjectives() {
    char *s = calloc(13);
    if (crc32("JIEJpjT",7) == 4169140624) strcat(s, "w");
if (crc32("WmKKthCvDNkxQKx",15) == 106968949) strcat(s, "o");
if (crc32("RYYnwyq",7) == 4226184020) strcat(s, "g");
if (crc32("fhFlBxSeMbu",11) == 1934798265) strcat(s, "s");
if (crc32("JXNmfZ",6) == 2772345783) strcat(s, "u");
if (crc32("AZPvtFHpKfPz",12) == 1871945336) strcat(s, "t");
if (crc32("pmUYyosPBJCufPq",15) == 2303879578) strcat(s, "r");
if (crc32("foVEywrD",8) == 4192758864) strcat(s, "A");
if (crc32("tiyvVYXJknVbUv",14) == 2542235905) strcat(s, "a");
if (crc32("LGjcZqpZ",8) == 3091418656) strcat(s, "c");
if (crc32("LLZDMJeeDYaqly",14) == 3683827117) strcat(s, "i");
if (crc32("rZXmoVWjcgcELG",14) == 869160695) strcat(s, "h");
if (crc32("GbKXigBiyMr",11) == 1423764375) strcat(s, "z");
if (crc32("dcPgVH",6) == 879623735) strcat(s, "t");
if (crc32("UWwJpR",6) == 1175319073) strcat(s, "a");
if (crc32("fDxMfHoaZjl",11) == 1159154803) strcat(s, "G");
if (crc32("MpClr",5) == 149015643) strcat(s, "b");
if (crc32("EAYcgQnr",8) == 2647319691) strcat(s, "l");
if (crc32("GmXFN",5) == 662605205) strcat(s, "y");
if (crc32("NMcwHDTx",8) == 272723636) strcat(s, "e");
    return s;
}

char *vectorial_adjectives() {
    char *s = calloc(10);
    if (crc32("uBWPCUvou",9) == 2895098714) strcat(s, "v");
if (crc32("KPBLyhQ",7) == 1427366914) strcat(s, "a");
if (crc32("pCIhpR",6) == 2939243258) strcat(s, "e");
if (crc32("asCZWRA",7) == 1717394682) strcat(s, "c");
if (crc32("zTRGJeBZJjGnYY",14) == 1016556271) strcat(s, "t");
if (crc32("luPWzZTenOsasYo",15) == 35642828) strcat(s, "o");
if (crc32("KIOAhKWNcO",10) == 2865338410) strcat(s, "r");
if (crc32("xtbtwXon",8) == 370272436) strcat(s, "g");
if (crc32("NmlugzghDBszOqa",15) == 2133276731) strcat(s, "i");
if (crc32("XEQcapewpCL",11) == 2603802785) strcat(s, "a");
if (crc32("xxRwRuUevCG",11) == 1089980734) strcat(s, "l");
    return s;
}

char *unsuspicious_adjectives() {
    char *s = calloc(13);
    if (crc32("kuAZCu",6) == 1534803150) strcat(s, "u");
if (crc32("FSRzYoLHJQK",11) == 1372371365) strcat(s, "q");
if (crc32("hQwcVbKY",8) == 2402584110) strcat(s, "n");
if (crc32("wRkSC",5) == 512351649) strcat(s, "W");
if (crc32("IXMPUDAi",8) == 2656242226) strcat(s, "s");
if (crc32("fXlLZXJBrXaOX",13) == 1596967811) strcat(s, "N");
if (crc32("emoPYIbPUmBw",12) == 1425919973) strcat(s, "u");
if (crc32("uVxfPPqvrjerW",13) == 577914027) strcat(s, "s");
if (crc32("WqIkbM",6) == 233636259) strcat(s, "P");
if (crc32("BFWvhYNauFohvX",14) == 2322546713) strcat(s, "p");
if (crc32("eTDriUtbA",9) == 1508384745) strcat(s, "c");
if (crc32("noqQwCURTphCPf",14) == 525211655) strcat(s, "i");
if (crc32("CFaQQGcpE",9) == 3356131597) strcat(s, "H");
if (crc32("NtnEOTiJVvGp",12) == 4243529350) strcat(s, "c");
if (crc32("wIacsglUcB",10) == 1322211973) strcat(s, "v");
if (crc32("yKKkha",6) == 768270190) strcat(s, "i");
if (crc32("ChZWPbbckWupwPV",15) == 1909318996) strcat(s, "n");
if (crc32("HsgwCBw",7) == 3291894518) strcat(s, "o");
if (crc32("VimfDvHMf",9) == 1465975545) strcat(s, "P");
if (crc32("dkODdWQfre",10) == 2737134927) strcat(s, "u");
if (crc32("SdHxYyMjzFzp",12) == 3536521841) strcat(s, "O");
if (crc32("MuuXQ",5) == 110372814) strcat(s, "s");
    return s;
}

char *hardhanded_adjectives() {
    char *s = calloc(11);
    if (crc32("FUntpWOdotlwO",13) == 4249721537) strcat(s, "h");
if (crc32("JKGdsUtQhRPDF",13) == 1248173310) strcat(s, "a");
if (crc32("DanMlD",6) == 4238056316) strcat(s, "T");
if (crc32("AITzGdIHfBfd",12) == 2688157404) strcat(s, "r");
if (crc32("lWcQTlmFfBlwQG",14) == 2951499520) strcat(s, "w");
if (crc32("uUkxjLbwKGqaO",13) == 3241918824) strcat(s, "d");
if (crc32("vxcVXyO",7) == 3162552034) strcat(s, "m");
if (crc32("gJdcE",5) == 505481886) strcat(s, "h");
if (crc32("JsPpHKEaIVALJS",14) == 664572092) strcat(s, "a");
if (crc32("CoCRsVulPi",10) == 1662589315) strcat(s, "U");
if (crc32("uIYHJb",6) == 3731373122) strcat(s, "n");
if (crc32("ajFmbzldC",9) == 981474649) strcat(s, "W");
if (crc32("MqqbLZiPR",9) == 3882275731) strcat(s, "d");
if (crc32("qwmxO",5) == 3052556747) strcat(s, "e");
if (crc32("DWLbO",5) == 4121108239) strcat(s, "d");
    return s;
}

char *nephelinitic_adjectives() {
    char *s = calloc(13);
    if (crc32("YswoRxaDaq",10) == 2479305381) strcat(s, "n");
if (crc32("UbuKZJkoiVDsvd",14) == 2136017154) strcat(s, "l");
if (crc32("kBKfeGt",7) == 3245328557) strcat(s, "e");
if (crc32("KVjGU",5) == 1588414929) strcat(s, "E");
if (crc32("rrOPwOiaMMEUx",13) == 2125353983) strcat(s, "p");
if (crc32("yVolnjmdpTzRIf",14) == 653272640) strcat(s, "h");
if (crc32("vwXfR",5) == 2453010854) strcat(s, "e");
if (crc32("ZxVZIfRHNva",11) == 4215224626) strcat(s, "l");
if (crc32("nTAltQKpSDJNclA",15) == 1907032839) strcat(s, "L");
if (crc32("TJgDLwXC",8) == 4051474223) strcat(s, "i");
if (crc32("GGMiMxTopjKv",12) == 1043292211) strcat(s, "n");
if (crc32("YvLbo",5) == 2221423781) strcat(s, "N");
if (crc32("iAYxpbVJR",9) == 771610872) strcat(s, "i");
if (crc32("NpBcWSuAnpHi",12) == 2129977166) strcat(s, "o");
if (crc32("ALJFAOCXg",9) == 488914594) strcat(s, "t");
if (crc32("iRkCgBPydU",10) == 3619790427) strcat(s, "i");
if (crc32("VgWDXhpufar",11) == 3567282497) strcat(s, "d");
if (crc32("iudrueYVfJbdhH",14) == 305470717) strcat(s, "c");
    return s;
}

char *afterdinner_adjectives() {
    char *s = calloc(12);
    if (crc32("nFrAF",5) == 2146901775) strcat(s, "a");
if (crc32("gXojwObRbTOQSN",14) == 2075605294) strcat(s, "e");
if (crc32("ZQuOabSmoNmcN",13) == 4213751223) strcat(s, "f");
if (crc32("LIGXIGnWdMPi",12) == 456520044) strcat(s, "t");
if (crc32("HOdPXlxnD",9) == 4203201196) strcat(s, "a");
if (crc32("iMBwrpziu",9) == 1157170860) strcat(s, "e");
if (crc32("bDAvDQxaIYq",11) == 1495668276) strcat(s, "r");
if (crc32("MHbiiz",6) == 3091278962) strcat(s, "d");
if (crc32("YdNoIckOitV",11) == 1406691120) strcat(s, "i");
if (crc32("JHEUAtGBN",9) == 3129809810) strcat(s, "n");
if (crc32("OWhPkaLeM",9) == 3156780536) strcat(s, "f");
if (crc32("qGqBeP",6) == 1209248735) strcat(s, "n");
if (crc32("fONSBmBJaAW",11) == 2511490474) strcat(s, "e");
if (crc32("zpYvGZObBYwze",13) == 4158378196) strcat(s, "r");
    return s;
}

char *unborrowed_adjectives() {
    char *s = calloc(11);
    if (crc32("DJbjQEhMwLqogfc",15) == 1138989112) strcat(s, "m");
if (crc32("lcQOfBrR",8) == 2960585458) strcat(s, "u");
if (crc32("mMXAIdCABG",10) == 437974753) strcat(s, "n");
if (crc32("pLtvDJfeh",9) == 3819412983) strcat(s, "b");
if (crc32("NUbtiSJEdVF",11) == 4231405122) strcat(s, "o");
if (crc32("MGZBdv",6) == 2274291850) strcat(s, "r");
if (crc32("tOgPSLlSw",9) == 1227859576) strcat(s, "r");
if (crc32("AQCLK",5) == 522077611) strcat(s, "o");
if (crc32("tnDVnevrcMEGK",13) == 1018318170) strcat(s, "w");
if (crc32("NuEUhZrvPKPD",12) == 2780796385) strcat(s, "e");
if (crc32("XYrIAwhnwceUc",13) == 2197541846) strcat(s, "z");
if (crc32("ZDDLpdtJo",9) == 2911441789) strcat(s, "d");
    return s;
}

char *hempy_adjectives() {
    char *s = calloc(6);
    if (crc32("oeUUobkSjIias",13) == 354359290) strcat(s, "h");
if (crc32("uMBMuw",6) == 2671265312) strcat(s, "e");
if (crc32("IKhSRiWaJp",10) == 1558801821) strcat(s, "m");
if (crc32("wZWGfBRkEoRak",13) == 2601273456) strcat(s, "p");
if (crc32("yjmbCqPmreq",11) == 1005632501) strcat(s, "y");
    return s;
}

char *unheady_adjectives() {
    char *s = calloc(8);
    if (crc32("rxLZsbf",7) == 4061791607) strcat(s, "F");
if (crc32("KtrOVYazlc",10) == 1551022716) strcat(s, "u");
if (crc32("fGGrvVs",7) == 958643853) strcat(s, "n");
if (crc32("WEzMw",5) == 1236017751) strcat(s, "M");
if (crc32("XiWdQbfBLWRBd",13) == 300894378) strcat(s, "h");
if (crc32("AgnFrBVNJYCV",12) == 87509531) strcat(s, "e");
if (crc32("UIWdPzo",7) == 413893256) strcat(s, "D");
if (crc32("ZsknjYgRYwRPWtb",15) == 4039191545) strcat(s, "a");
if (crc32("gAKxMkrANsGskHd",15) == 3299585220) strcat(s, "w");
if (crc32("jnBwcLq",7) == 1708131625) strcat(s, "d");
if (crc32("LyEhackDudNtMG",14) == 290367044) strcat(s, "y");
    return s;
}

char *stromatic_adjectives() {
    char *s = calloc(10);
    if (crc32("CAJIEEBsM",9) == 256600310) strcat(s, "L");
if (crc32("DPLzHT",6) == 3239738609) strcat(s, "s");
if (crc32("EqCkk",5) == 814053673) strcat(s, "A");
if (crc32("zJukeoSRGgktQJr",15) == 3248985267) strcat(s, "t");
if (crc32("azJzPuTBGwfk",12) == 3354970001) strcat(s, "q");
if (crc32("AlFTqaBEAmgqg",13) == 3206049097) strcat(s, "r");
if (crc32("HbIPSJTY",8) == 9535251) strcat(s, "d");
if (crc32("WEmEUqnPIEt",11) == 2003925253) strcat(s, "o");
if (crc32("uGKYocXW",8) == 4263239000) strcat(s, "m");
if (crc32("zpUJVwMKU",9) == 293843695) strcat(s, "l");
if (crc32("kBNsCLasn",9) == 3818503533) strcat(s, "a");
if (crc32("VjJTMgmsAk",10) == 951266584) strcat(s, "s");
if (crc32("xNcmVKVfB",9) == 2807280776) strcat(s, "t");
if (crc32("VGjhEumNEHNTvgu",15) == 1867073014) strcat(s, "i");
if (crc32("sogrfOFbdGUE",12) == 2237968093) strcat(s, "y");
if (crc32("nJHtBuqBFzTeL",13) == 1898131228) strcat(s, "c");
    return s;
}

char *raving_adjectives() {
    char *s = calloc(7);
    if (crc32("fjpIBIgOTG",10) == 2010541626) strcat(s, "r");
if (crc32("yxwTTHnai",9) == 3802018728) strcat(s, "a");
if (crc32("UkgEggmwYPgizV",14) == 2949481714) strcat(s, "Z");
if (crc32("LsrOz",5) == 3002022641) strcat(s, "v");
if (crc32("mDEmowgGPrNHCPo",15) == 4291394194) strcat(s, "N");
if (crc32("FqeaLXsK",8) == 1792353576) strcat(s, "i");
if (crc32("FlTNLUE",7) == 571514618) strcat(s, "J");
if (crc32("Ffhxrj",6) == 1789902601) strcat(s, "n");
if (crc32("xvntySlBUJKeYOp",15) == 520379513) strcat(s, "v");
if (crc32("ayoSPhIIFxSOO",13) == 4196764231) strcat(s, "g");
    return s;
}

char *auriform_adjectives() {
    char *s = calloc(9);
    if (crc32("fWwIozIn",8) == 2230448171) strcat(s, "M");
if (crc32("aBJPoHyXCHrBMk",14) == 2499916079) strcat(s, "a");
if (crc32("VbDOzFipnzjBG",13) == 2655722335) strcat(s, "e");
if (crc32("dKZUwzO",7) == 1803015797) strcat(s, "u");
if (crc32("guKtrj",6) == 981630332) strcat(s, "r");
if (crc32("SaEcdrPoDA",10) == 749591664) strcat(s, "i");
if (crc32("aThsLBWFvRjr",12) == 1465514037) strcat(s, "d");
if (crc32("VsgktLBxknrjCiB",15) == 2963654516) strcat(s, "f");
if (crc32("lxQWchRnQzaGLw",14) == 1619821995) strcat(s, "o");
if (crc32("KdCIfmkmmb",10) == 3273064506) strcat(s, "k");
if (crc32("RwTjNU",6) == 3483510131) strcat(s, "r");
if (crc32("QedGk",5) == 3845067961) strcat(s, "m");
    return s;
}

char *unhallucinatory_adjectives() {
    char *s = calloc(16);
    if (crc32("ULLqoSofhhT",11) == 3415844469) strcat(s, "u");
if (crc32("eFOOIDw",7) == 2701658735) strcat(s, "n");
if (crc32("ddlXOzGjzHNWvr",14) == 1953234328) strcat(s, "h");
if (crc32("ToqzwBddIIp",11) == 1785802078) strcat(s, "C");
if (crc32("zugpwld",7) == 480196759) strcat(s, "a");
if (crc32("MUNkCKzyCoSC",12) == 4012875027) strcat(s, "E");
if (crc32("OOqSnT",6) == 3211678294) strcat(s, "l");
if (crc32("IghXpcCveOACrGG",15) == 1851312534) strcat(s, "l");
if (crc32("rrgfzoklX",9) == 2864707354) strcat(s, "k");
if (crc32("tgaVdhDkBWa",11) == 2823637131) strcat(s, "u");
if (crc32("RrOhjSkuWynLpo",14) == 1851720181) strcat(s, "c");
if (crc32("GvjoK",5) == 613297538) strcat(s, "i");
if (crc32("SEEjkohJgykN",12) == 2482892386) strcat(s, "P");
if (crc32("tROXeRCBG",9) == 1713768703) strcat(s, "n");
if (crc32("jeNzbxPjkaz",11) == 3667265888) strcat(s, "a");
if (crc32("rkekjPWYN",9) == 2231438650) strcat(s, "t");
if (crc32("UugKBeuV",8) == 3842497499) strcat(s, "P");
if (crc32("rZsRAVLiULV",11) == 3941058433) strcat(s, "o");
if (crc32("FpLaNeRqQABSB",13) == 1926206320) strcat(s, "r");
if (crc32("IHjpKH",6) == 2599864788) strcat(s, "y");
    return s;
}

char *unmodest_adjectives() {
    char *s = calloc(9);
    if (crc32("UIxNsPb",7) == 394742102) strcat(s, "q");
if (crc32("ttItoCfYiSkoUi",14) == 3497590151) strcat(s, "u");
if (crc32("tVuiUobEyLb",11) == 2277638023) strcat(s, "n");
if (crc32("BaMauIe",7) == 2767506524) strcat(s, "g");
if (crc32("BGNxUsbaZObIq",13) == 3462131016) strcat(s, "m");
if (crc32("YiYxWhphdVSa",12) == 419332347) strcat(s, "Y");
if (crc32("vvIECdCAbucYTS",14) == 4043037003) strcat(s, "o");
if (crc32("xLXkO",5) == 4101786916) strcat(s, "R");
if (crc32("bxBQkEw",7) == 811275758) strcat(s, "d");
if (crc32("AMTMNiJY",8) == 3934433465) strcat(s, "z");
if (crc32("DhekcvXtNvUQN",13) == 719739508) strcat(s, "e");
if (crc32("bBlnSlO",7) == 3564821135) strcat(s, "X");
if (crc32("sfoozB",6) == 1204455081) strcat(s, "s");
if (crc32("ZhyCyQqSrykSMoW",15) == 1555871770) strcat(s, "s");
if (crc32("NOwrxMxwjNqiB",13) == 3466151646) strcat(s, "t");
    return s;
}

char *ruthenic_adjectives() {
    char *s = calloc(9);
    if (crc32("seZcWcSWJya",11) == 3037332870) strcat(s, "r");
if (crc32("cpomKN",6) == 1741912551) strcat(s, "r");
if (crc32("UZDBsDeDBu",10) == 2843140729) strcat(s, "X");
if (crc32("XaoEJokgxld",11) == 4257728099) strcat(s, "u");
if (crc32("ZFPwOovlC",9) == 343066700) strcat(s, "t");
if (crc32("Pnezaola",8) == 740655081) strcat(s, "S");
if (crc32("EKVZQ",5) == 774732198) strcat(s, "h");
if (crc32("DADuodJDyVKDjS",14) == 2975278086) strcat(s, "e");
if (crc32("fWdNsxu",7) == 3804676137) strcat(s, "n");
if (crc32("pAiaWAMnkyilsg",14) == 3263749656) strcat(s, "i");
if (crc32("YRCKorTJ",8) == 2301416021) strcat(s, "K");
if (crc32("KepGLzHMkDSPaH",14) == 1473588770) strcat(s, "c");
    return s;
}

char *horrent_adjectives() {
    char *s = calloc(8);
    if (crc32("EJZLYomgUjbqjrT",15) == 1753254346) strcat(s, "U");
if (crc32("RxxbkfBenmmrWX",14) == 884014325) strcat(s, "h");
if (crc32("xpACoRtvtElBUct",15) == 865120741) strcat(s, "o");
if (crc32("UxILvcgsaXXNC",13) == 1254027740) strcat(s, "z");
if (crc32("pVLJYdRUBMl",11) == 1219624096) strcat(s, "r");
if (crc32("zcbyBqTtmhFabE",14) == 339676067) strcat(s, "r");
if (crc32("jHQyqmUqSipc",12) == 2831013811) strcat(s, "e");
if (crc32("dyzvlb",6) == 1528550358) strcat(s, "z");
if (crc32("rCGDVx",6) == 722758068) strcat(s, "n");
if (crc32("tcpKUDPJBIT",11) == 2361783159) strcat(s, "t");
    return s;
}

char *preAugustan_adjectives() {
    char *s = calloc(12);
    if (crc32("fPuZN",5) == 714110015) strcat(s, "u");
if (crc32("QkicV",5) == 2762497390) strcat(s, "p");
if (crc32("NxmgnXCM",8) == 1940257008) strcat(s, "r");
if (crc32("gFbeToIl",8) == 1396473477) strcat(s, "J");
if (crc32("JHBiMZz",7) == 1925709191) strcat(s, "e");
if (crc32("oVwktnCOjM",10) == 3288331063) strcat(s, "s");
if (crc32("BmefLaNpqI",10) == 1850895407) strcat(s, "A");
if (crc32("SAyXQY",6) == 2613362520) strcat(s, "u");
if (crc32("PweoFwUIEv",10) == 246030793) strcat(s, "g");
if (crc32("JgjWYOYtXAejBic",15) == 4150972993) strcat(s, "G");
if (crc32("mtLhuKsbDPEvNE",14) == 98494938) strcat(s, "u");
if (crc32("nqTNkxEBZ",9) == 2404609351) strcat(s, "s");
if (crc32("xqQlonfog",9) == 1020090410) strcat(s, "K");
if (crc32("oSjAOzoFFeALyJD",15) == 639789136) strcat(s, "t");
if (crc32("wYmjVEbjNsavTbN",15) == 1197695500) strcat(s, "P");
if (crc32("CQTwUQ",6) == 4077654345) strcat(s, "a");
if (crc32("TzTKIZV",7) == 3069089227) strcat(s, "S");
if (crc32("QyiBoLgcuML",11) == 754023638) strcat(s, "n");
    return s;
}

char *comelier_adjectives() {
    char *s = calloc(9);
    if (crc32("XsnWryGbA",9) == 1908330907) strcat(s, "c");
if (crc32("XKnaKeWla",9) == 1232290583) strcat(s, "p");
if (crc32("XmxwUJVyjKNuf",13) == 1171186035) strcat(s, "o");
if (crc32("KSysGzaM",8) == 30767542) strcat(s, "v");
if (crc32("sVHitiZU",8) == 2296373099) strcat(s, "m");
if (crc32("MBqEzTDN",8) == 1040532826) strcat(s, "e");
if (crc32("NlqeIJTpJuvsOs",14) == 2353515246) strcat(s, "w");
if (crc32("eCFrJxpPNEQw",12) == 4258223329) strcat(s, "l");
if (crc32("KWciGtXfECGKukq",15) == 2450463976) strcat(s, "i");
if (crc32("Zqyrl",5) == 200745115) strcat(s, "D");
if (crc32("iCcTqRljplnfFJk",15) == 616747507) strcat(s, "e");
if (crc32("sRMjzOhjrSb",11) == 3836157682) strcat(s, "a");
if (crc32("LHrQW",5) == 73082619) strcat(s, "r");
    return s;
}

char *subendothelial_adjectives() {
    char *s = calloc(15);
    if (crc32("kaFANqhgYTJIV",13) == 1861022981) strcat(s, "s");
if (crc32("TQRvDMrprd",10) == 4003093980) strcat(s, "o");
if (crc32("ZJfzojrSXzr",11) == 3987221476) strcat(s, "u");
if (crc32("mvKXucQkg",9) == 2815128593) strcat(s, "b");
if (crc32("ulKVdaMU",8) == 3167744952) strcat(s, "e");
if (crc32("BIyDkpBPkbIA",12) == 534042207) strcat(s, "n");
if (crc32("bKEXVzRweC",10) == 3041423112) strcat(s, "d");
if (crc32("zfnELnKWY",9) == 3429117220) strcat(s, "o");
if (crc32("salvTjFHfIN",11) == 1310093029) strcat(s, "g");
if (crc32("WLnIGcBua",9) == 2775964360) strcat(s, "t");
if (crc32("tDMCKOHyHrUIbvw",15) == 1743968676) strcat(s, "z");
if (crc32("ZsLcoUculBLOQJ",14) == 3847445560) strcat(s, "h");
if (crc32("SASoLrVj",8) == 180282987) strcat(s, "e");
if (crc32("VyMofBpAYmHtSNp",15) == 387541323) strcat(s, "f");
if (crc32("UvEgDJAsCQjK",12) == 605183709) strcat(s, "l");
if (crc32("KtJOmOHF",8) == 4173061515) strcat(s, "Z");
if (crc32("eGzwfFTJfmo",11) == 3156466112) strcat(s, "i");
if (crc32("izymWXaDIGy",11) == 3921323717) strcat(s, "a");
if (crc32("DWogswUgEmCJ",12) == 3691134764) strcat(s, "l");
    return s;
}

char *tressured_adjectives() {
    char *s = calloc(10);
    if (crc32("MwfGfF",6) == 2390138832) strcat(s, "t");
if (crc32("OJLKlZgVFN",10) == 1397478398) strcat(s, "x");
if (crc32("yPiGsGjD",8) == 3527210045) strcat(s, "r");
if (crc32("yOFlWKXUQWt",11) == 1517767131) strcat(s, "O");
if (crc32("YRqrqUPKmhA",11) == 1385357237) strcat(s, "e");
if (crc32("RmwQmZzX",8) == 2467500535) strcat(s, "s");
if (crc32("vZFKq",5) == 1419258786) strcat(s, "s");
if (crc32("kDgiGUIpqyDvCXb",15) == 2370770381) strcat(s, "u");
if (crc32("ZQxgZNfuU",9) == 1593109134) strcat(s, "r");
if (crc32("jxWOFakLgjJtHB",14) == 1966297532) strcat(s, "e");
if (crc32("QTnDqIiKvaPel",13) == 3120912463) strcat(s, "D");
if (crc32("evFkIXbjvkHMHc",14) == 2150789361) strcat(s, "d");
    return s;
}

char *scarlatinoid_adjectives() {
    char *s = calloc(13);
    if (crc32("ZkqxCrFKNvh",11) == 2824581203) strcat(s, "s");
if (crc32("uTEaBb",6) == 4008661149) strcat(s, "t");
if (crc32("ZAxRNCXUxm",10) == 3581966208) strcat(s, "c");
if (crc32("qGGrSJsIKaSL",12) == 627029464) strcat(s, "h");
if (crc32("MKznq",5) == 2941148892) strcat(s, "a");
if (crc32("TZdlsZzip",9) == 2852156800) strcat(s, "r");
if (crc32("VlHte",5) == 2552084211) strcat(s, "Y");
if (crc32("kunCHWplDsCecDU",15) == 1027984424) strcat(s, "l");
if (crc32("mcfXnaqnYF",10) == 1466124167) strcat(s, "a");
if (crc32("dqTMcntoQ",9) == 1270536757) strcat(s, "t");
if (crc32("nxMstlqtYi",10) == 1270703182) strcat(s, "a");
if (crc32("IHbcB",5) == 1345370721) strcat(s, "i");
if (crc32("VkHOaZiwJA",10) == 1817921160) strcat(s, "n");
if (crc32("RZxUA",5) == 2765642521) strcat(s, "H");
if (crc32("RnJKGjh",7) == 3961530140) strcat(s, "o");
if (crc32("xhJEVKDKUtks",12) == 2387268300) strcat(s, "o");
if (crc32("yEMGReDEdXj",11) == 3891213005) strcat(s, "i");
if (crc32("RsqCdsbGvGWcjl",14) == 3336499435) strcat(s, "n");
if (crc32("tlgnagoYoCLx",12) == 750244500) strcat(s, "d");
    return s;
}

char *bathypelagic_adjectives() {
    char *s = calloc(13);
    if (crc32("EfcFVDnXzwWT",12) == 3868739901) strcat(s, "D");
if (crc32("uqhrOyWul",9) == 1902056713) strcat(s, "b");
if (crc32("WEwDHffwLmLOjhE",15) == 1998784587) strcat(s, "j");
if (crc32("MnNfuhisiOUVnRY",15) == 2683834003) strcat(s, "a");
if (crc32("LfqbXLpQ",8) == 2492514336) strcat(s, "t");
if (crc32("yWXHqeDoFxwGkXF",15) == 3649281831) strcat(s, "P");
if (crc32("XBwwp",5) == 2660828025) strcat(s, "h");
if (crc32("WQKquXuhY",9) == 1038540312) strcat(s, "y");
if (crc32("FYECiVy",7) == 179971341) strcat(s, "p");
if (crc32("ugfognhcJhWTIQ",14) == 3511110249) strcat(s, "e");
if (crc32("gvXFYKVgvjUslX",14) == 1900839935) strcat(s, "C");
if (crc32("SHItMaqbtReeFo",14) == 961275310) strcat(s, "l");
if (crc32("ZSWCMginq",9) == 88237231) strcat(s, "G");
if (crc32("jTxmCrxvQdv",11) == 148907144) strcat(s, "a");
if (crc32("lxQDLqx",7) == 3077442477) strcat(s, "Q");
if (crc32("ArBNyGfkrohuQ",13) == 3035864181) strcat(s, "g");
if (crc32("yKhZbF",6) == 3842051576) strcat(s, "i");
if (crc32("OwoOJXJeuOclzj",14) == 2919479125) strcat(s, "c");
    return s;
}

char *unrefunding_adjectives() {
    char *s = calloc(12);
    if (crc32("GfNitA",6) == 3282570191) strcat(s, "u");
if (crc32("YqAqvprlOKIktRb",15) == 682765976) strcat(s, "n");
if (crc32("lHFIbgaONmTtQm",14) == 2802850603) strcat(s, "D");
if (crc32("BrhCXQkBTKv",11) == 2667564054) strcat(s, "r");
if (crc32("QvoyDpjqWCiYAW",14) == 2399210065) strcat(s, "D");
if (crc32("SlzWNjVngYJzOp",14) == 709312951) strcat(s, "e");
if (crc32("fzRkapWcp",9) == 2597513683) strcat(s, "f");
if (crc32("XAKcXwC",7) == 2732986561) strcat(s, "u");
if (crc32("jrKNyyiXudFWpy",14) == 4291019124) strcat(s, "n");
if (crc32("rkLJpEqqYrVl",12) == 3486254542) strcat(s, "S");
if (crc32("EIxDTYjFMHPgXt",14) == 441086228) strcat(s, "d");
if (crc32("tTcnoFCvLCNpE",13) == 2516050032) strcat(s, "k");
if (crc32("fmINWFkHKd",10) == 3179128579) strcat(s, "i");
if (crc32("HxqkJF",6) == 280775469) strcat(s, "o");
if (crc32("PbNwKaUaLVAmVFt",15) == 2689706412) strcat(s, "n");
if (crc32("PDvDIbl",7) == 4242997968) strcat(s, "e");
if (crc32("pssPhWry",8) == 48628190) strcat(s, "g");
    return s;
}

char *heartrending_adjectives() {
    char *s = calloc(13);
    if (crc32("BixXLJZFlANRFz",14) == 747866901) strcat(s, "h");
if (crc32("OGyPJ",5) == 148572957) strcat(s, "F");
if (crc32("JjZpc",5) == 441795296) strcat(s, "e");
if (crc32("MvcXJEy",7) == 1328528694) strcat(s, "U");
if (crc32("DgNFZkwdsnQYiI",14) == 3032117647) strcat(s, "a");
if (crc32("KxuWwVkxpDXu",12) == 3720909961) strcat(s, "s");
if (crc32("MYUimhLgfel",11) == 3789236428) strcat(s, "r");
if (crc32("KPnjzKSYeWbbiUw",15) == 1150167059) strcat(s, "m");
if (crc32("gAieQuHLFyOa",12) == 4194306353) strcat(s, "t");
if (crc32("HTEmHO",6) == 2908498393) strcat(s, "r");
if (crc32("rGJNJK",6) == 2026810932) strcat(s, "e");
if (crc32("YdPBlJrcUSmGg",13) == 3136922379) strcat(s, "n");
if (crc32("cJDQcrpbQmhLuJ",14) == 2640303220) strcat(s, "d");
if (crc32("LuiqwpxrkaVWx",13) == 2497313990) strcat(s, "f");
if (crc32("HwKtGfgCrCPgE",13) == 2471245982) strcat(s, "i");
if (crc32("yleLHBg",7) == 1380498196) strcat(s, "J");
if (crc32("KtqTIOL",7) == 3167619230) strcat(s, "n");
if (crc32("cIdhHapGQPpNHGp",15) == 3640361342) strcat(s, "N");
if (crc32("IefEGSUfMJv",11) == 2448611786) strcat(s, "g");
    return s;
}

char *nonstratified_adjectives() {
    char *s = calloc(14);
    if (crc32("KadIuK",6) == 138856001) strcat(s, "n");
if (crc32("vZjImP",6) == 1552212458) strcat(s, "p");
if (crc32("RVhNcFXfq",9) == 2986874494) strcat(s, "o");
if (crc32("ORzcerGLMQu",11) == 4157063106) strcat(s, "n");
if (crc32("dNLdfwXdiZObEWP",15) == 4070087118) strcat(s, "t");
if (crc32("TkVrTmAkkqI",11) == 4063759173) strcat(s, "s");
if (crc32("PesLrBopyPey",12) == 4223728522) strcat(s, "e");
if (crc32("sTlcIuPhzaeBJJ",14) == 2996705662) strcat(s, "t");
if (crc32("mwZjZm",6) == 3707603187) strcat(s, "r");
if (crc32("fGfgtJa",7) == 3959658939) strcat(s, "Z");
if (crc32("tsgQCU",6) == 2497267435) strcat(s, "a");
if (crc32("wpjaSYDmaPXBE",13) == 2893443623) strcat(s, "t");
if (crc32("IQJEZBilZuHGLPl",15) == 3164864321) strcat(s, "i");
if (crc32("hUuGioLPLQOr",12) == 1027529938) strcat(s, "O");
if (crc32("mpkMMyAMaGLKwc",14) == 3546827610) strcat(s, "f");
if (crc32("DRNgxRRMnGo",11) == 3919156249) strcat(s, "i");
if (crc32("bgeeuBPhpkIdkc",14) == 1295115878) strcat(s, "e");
if (crc32("hEGaYGaCNxfqlU",14) == 3903535632) strcat(s, "d");
    return s;
}

char *nondisciplining_adjectives() {
    char *s = calloc(16);
    if (crc32("wudSFC",6) == 94370673) strcat(s, "n");
if (crc32("UeUUaibQkyMA",12) == 677190294) strcat(s, "o");
if (crc32("ktzxzZUs",8) == 3859566130) strcat(s, "Q");
if (crc32("haeLpqBvOTQgV",13) == 2294706334) strcat(s, "n");
if (crc32("IOIMMYuXwu",10) == 1805300889) strcat(s, "d");
if (crc32("QswTFVBXpME",11) == 1282520441) strcat(s, "i");
if (crc32("szhlD",5) == 113897462) strcat(s, "Q");
if (crc32("uvrJsE",6) == 572577685) strcat(s, "s");
if (crc32("AidoDCOy",8) == 783212381) strcat(s, "c");
if (crc32("scQJRSB",7) == 1404868922) strcat(s, "N");
if (crc32("LYhIdyO",7) == 760762165) strcat(s, "i");
if (crc32("TWzxBfFWP",9) == 4022679073) strcat(s, "p");
if (crc32("NsacdMpQSKOd",12) == 2045321720) strcat(s, "l");
if (crc32("XGmnx",5) == 757986503) strcat(s, "i");
if (crc32("fkgyUcqETgrZQVe",15) == 1384321526) strcat(s, "n");
if (crc32("jScqYD",6) == 24510874) strcat(s, "i");
if (crc32("eKUgB",5) == 2288511709) strcat(s, "k");
if (crc32("UdWKNLKBnuoVcb",14) == 4222726382) strcat(s, "n");
if (crc32("dyZzywPAf",9) == 913105070) strcat(s, "T");
if (crc32("UKyxtYe",7) == 3591264842) strcat(s, "g");
    return s;
}

char *aphakial_adjectives() {
    char *s = calloc(9);
    if (crc32("isGEpPo",7) == 3662517462) strcat(s, "Q");
if (crc32("QKOVpjkb",8) == 4164277010) strcat(s, "a");
if (crc32("iiJZleJepOVHXe",14) == 2954467428) strcat(s, "G");
if (crc32("IivdrmxaKvQVfWW",15) == 2436140964) strcat(s, "p");
if (crc32("YbJJFSFBkOs",11) == 4287070580) strcat(s, "h");
if (crc32("CfKIcrJMPXrbP",13) == 4260763370) strcat(s, "t");
if (crc32("fJHbMEXzwdo",11) == 1450220300) strcat(s, "a");
if (crc32("SJRKkjKR",8) == 253385021) strcat(s, "k");
if (crc32("HPAEN",5) == 140586563) strcat(s, "x");
if (crc32("ybwEsHA",7) == 693375493) strcat(s, "i");
if (crc32("nDVvavcwVeBa",12) == 3850337959) strcat(s, "a");
if (crc32("mwUQBrUnQlo",11) == 2186549159) strcat(s, "l");
    return s;
}

char *nonsolvable_adjectives() {
    char *s = calloc(12);
    if (crc32("eDuOxMRS",8) == 1611127374) strcat(s, "n");
if (crc32("TpaLZBb",7) == 882647286) strcat(s, "o");
if (crc32("GQYbbpiGxnoVqxF",15) == 1847955895) strcat(s, "n");
if (crc32("oyMXRxmNr",9) == 1869312115) strcat(s, "s");
if (crc32("uNniHIFg",8) == 4018452835) strcat(s, "U");
if (crc32("JXrnkQETeaECMf",14) == 3806140380) strcat(s, "o");
if (crc32("CcXwFcs",7) == 1806645457) strcat(s, "l");
if (crc32("dFOROrHXxSMqLD",14) == 2540613938) strcat(s, "a");
if (crc32("xqXjtaSB",8) == 3353072466) strcat(s, "v");
if (crc32("AAUqhQGLVIMHL",13) == 3797650739) strcat(s, "I");
if (crc32("otPXEWXJrSTQJnq",15) == 1659175569) strcat(s, "a");
if (crc32("SYhGGUjosBifX",13) == 761855987) strcat(s, "u");
if (crc32("wwDgz",5) == 2529629113) strcat(s, "b");
if (crc32("fTPnodqnbDq",11) == 2616340821) strcat(s, "N");
if (crc32("bhYoczrxNEX",11) == 3656457956) strcat(s, "l");
if (crc32("gPUyXc",6) == 632522832) strcat(s, "W");
if (crc32("MePxiydHkUOvjEg",15) == 1111200888) strcat(s, "e");
    return s;
}

char *weaponed_adjectives() {
    char *s = calloc(9);
    if (crc32("blBgjBtJ",8) == 3943801760) strcat(s, "V");
if (crc32("akhZUiTcxSSzzHt",15) == 546109392) strcat(s, "w");
if (crc32("pRXMewVdXe",10) == 397519851) strcat(s, "e");
if (crc32("uwUdgw",6) == 4128212125) strcat(s, "a");
if (crc32("bRuXh",5) == 669352084) strcat(s, "p");
if (crc32("ZfeMD",5) == 1879365725) strcat(s, "P");
if (crc32("tFipmrWmkMnakw",14) == 601073753) strcat(s, "o");
if (crc32("YvvGEdfFmsYWKCU",15) == 2212678164) strcat(s, "Y");
if (crc32("tgQDK",5) == 1961109558) strcat(s, "n");
if (crc32("rYcuMbxqUsvMs",13) == 1517033582) strcat(s, "e");
if (crc32("BlBYnbOFHg",10) == 2474468935) strcat(s, "d");
    return s;
}

char *shivery_adjectives() {
    char *s = calloc(8);
    if (crc32("rWdkdXKBvuKTLGs",15) == 2230377412) strcat(s, "R");
if (crc32("KojsfKRVsYOqumY",15) == 12907699) strcat(s, "s");
if (crc32("peVViqQBpBj",11) == 3784147608) strcat(s, "h");
if (crc32("PgtynKrB",8) == 948521588) strcat(s, "i");
if (crc32("SQDlRlWUALS",11) == 172781779) strcat(s, "K");
if (crc32("dRsrtTYoEVGtkt",14) == 1402053749) strcat(s, "v");
if (crc32("OJljHeHRuCHfTWo",15) == 1890014276) strcat(s, "K");
if (crc32("AYzbkWflxMlkG",13) == 2651298982) strcat(s, "e");
if (crc32("yGitMguOBFWA",12) == 3220715080) strcat(s, "Z");
if (crc32("OgaakChvTsJQfA",14) == 1473478660) strcat(s, "r");
if (crc32("KTyiO",5) == 2752698752) strcat(s, "y");
    return s;
}

char *pseudomilitary_adjectives() {
    char *s = calloc(15);
    if (crc32("LHshsaNnVOjxS",13) == 218232867) strcat(s, "x");
if (crc32("AXTSStZpqOUPXh",14) == 3976085335) strcat(s, "p");
if (crc32("JLaiqAnrfh",10) == 907304804) strcat(s, "P");
if (crc32("DaEdAdmbivYBJ",13) == 1642908740) strcat(s, "s");
if (crc32("zOHdNlSUCVyJR",13) == 2200148321) strcat(s, "e");
if (crc32("izzYaTuollh",11) == 2916407161) strcat(s, "u");
if (crc32("lQKnogMbbQDxaKR",15) == 2986019399) strcat(s, "H");
if (crc32("FgjjZ",5) == 3867992191) strcat(s, "d");
if (crc32("SHmaiIIjCLzq",12) == 3567993037) strcat(s, "o");
if (crc32("zqnSBUQseyHwBnu",15) == 3126713675) strcat(s, "d");
if (crc32("zJsmuYFZknr",11) == 2608328940) strcat(s, "m");
if (crc32("kkRtGQopoaz",11) == 4233443313) strcat(s, "i");
if (crc32("vdqIrsMIYqC",11) == 4245110992) strcat(s, "b");
if (crc32("OSUOqDA",7) == 1447842055) strcat(s, "l");
if (crc32("LmGgQCYiky",10) == 3636959730) strcat(s, "l");
if (crc32("FeVWbQ",6) == 4112756963) strcat(s, "i");
if (crc32("ACyyiMHNVkr",11) == 880831127) strcat(s, "c");
if (crc32("JOZtHQsaFnJ",11) == 1795755464) strcat(s, "t");
if (crc32("wSGYNFihbDRfsTb",15) == 2272566454) strcat(s, "V");
if (crc32("knGzLzEowzSq",12) == 1385955295) strcat(s, "a");
if (crc32("FEsVqkHM",8) == 48317979) strcat(s, "q");
if (crc32("RZQSXNtb",8) == 3518482531) strcat(s, "r");
if (crc32("jHTodPagE",9) == 443686541) strcat(s, "W");
if (crc32("JVKqzXif",8) == 1251263842) strcat(s, "y");
    return s;
}

char *incognita_adjectives() {
    char *s = calloc(10);
    if (crc32("CdXRM",5) == 2407188515) strcat(s, "i");
if (crc32("UNeoHQWb",8) == 1242803496) strcat(s, "n");
if (crc32("EySZXN",6) == 1090521123) strcat(s, "c");
if (crc32("qvIzhPkENwmocjL",15) == 635851269) strcat(s, "B");
if (crc32("KjVTkMHXddZW",12) == 505359142) strcat(s, "o");
if (crc32("zgCFzui",7) == 1939651335) strcat(s, "T");
if (crc32("JgodMs",6) == 2488514195) strcat(s, "g");
if (crc32("zhHGHXysWLzGdxX",15) == 4096210960) strcat(s, "n");
if (crc32("IDCHuqMi",8) == 2058951090) strcat(s, "s");
if (crc32("XGGZrDQR",8) == 2463334549) strcat(s, "i");
if (crc32("wUgbIjInFWTsOSJ",15) == 2085591975) strcat(s, "t");
if (crc32("WGWKtCIBwwKr",12) == 3711961622) strcat(s, "t");
if (crc32("MYkdMF",6) == 1318507448) strcat(s, "a");
    return s;
}

char *archetypic_adjectives() {
    char *s = calloc(11);
    if (crc32("yqAWscCL",8) == 1464309226) strcat(s, "H");
if (crc32("lSXBGEYG",8) == 3253077381) strcat(s, "a");
if (crc32("nQOVrZZEaKmq",12) == 2331039789) strcat(s, "q");
if (crc32("kXEfu",5) == 1138790581) strcat(s, "r");
if (crc32("cUQMtZPlyu",10) == 2819326681) strcat(s, "L");
if (crc32("HIWnmEj",7) == 4084418394) strcat(s, "c");
if (crc32("XpwhIs",6) == 4032175489) strcat(s, "h");
if (crc32("FGIVWokt",8) == 1346929268) strcat(s, "e");
if (crc32("hoGpGQs",7) == 424707449) strcat(s, "N");
if (crc32("JadcPbnoC",9) == 2796050747) strcat(s, "t");
if (crc32("hYShKtDRGbRxs",13) == 1724627164) strcat(s, "y");
if (crc32("uNYnZfyoEjzXDn",14) == 2419168042) strcat(s, "c");
if (crc32("zteDuKMKZWeCW",13) == 3573546007) strcat(s, "p");
if (crc32("lSchS",5) == 1452235141) strcat(s, "i");
if (crc32("mVZPNVvumnuzhS",14) == 1895620677) strcat(s, "c");
    return s;
}

char *nonformal_adjectives() {
    char *s = calloc(10);
    if (crc32("GKhLgPpVugMg",12) == 1857541544) strcat(s, "P");
if (crc32("gIvpIefUVIro",12) == 298173820) strcat(s, "n");
if (crc32("VGTPqaKbfqqo",12) == 2742869661) strcat(s, "f");
if (crc32("LHLHkgFoGFhPR",13) == 3099876379) strcat(s, "o");
if (crc32("GiDRYoAPtT",10) == 3140966354) strcat(s, "v");
if (crc32("jNwEUJVfhvbUf",13) == 2624081576) strcat(s, "n");
if (crc32("GMKLUel",7) == 2085351819) strcat(s, "R");
if (crc32("EsdckVJtcgCudwy",15) == 1729819079) strcat(s, "f");
if (crc32("tvLBHaiwOQfYKCl",15) == 1196789100) strcat(s, "j");
if (crc32("IObMiGxxBXxcGLk",15) == 4280587456) strcat(s, "o");
if (crc32("oQiGWC",6) == 1690763810) strcat(s, "r");
if (crc32("oypYobCFESEkhKA",15) == 874933618) strcat(s, "m");
if (crc32("dbyxZMm",7) == 2203483314) strcat(s, "h");
if (crc32("aTQmJi",6) == 2998885008) strcat(s, "a");
if (crc32("QKxpFexfhD",10) == 973005425) strcat(s, "v");
if (crc32("iSXKtXCrYTJmWq",14) == 3807344879) strcat(s, "l");
    return s;
}

char *touristy_adjectives() {
    char *s = calloc(9);
    if (crc32("JeoNTNvfHo",10) == 4133935640) strcat(s, "t");
if (crc32("jpRNM",5) == 1999674645) strcat(s, "o");
if (crc32("fsfsXymH",8) == 859071073) strcat(s, "u");
if (crc32("WVIWAVcnaA",10) == 203077057) strcat(s, "r");
if (crc32("SdqGAyckyEQ",11) == 2700174343) strcat(s, "i");
if (crc32("WxerOZL",7) == 1215522137) strcat(s, "s");
if (crc32("eEQktvSDMyB",11) == 1791701679) strcat(s, "t");
if (crc32("AbshkYVpVOZOUcN",15) == 3253777477) strcat(s, "y");
    return s;
}

char *escapeless_adjectives() {
    char *s = calloc(11);
    if (crc32("hHyAfKpqpTnqBg",14) == 403131223) strcat(s, "e");
if (crc32("CtVvzxskw",9) == 4241774897) strcat(s, "N");
if (crc32("neADMSQPuwoVnb",14) == 2434786106) strcat(s, "s");
if (crc32("uSsdpRvtJTnDP",13) == 1837818392) strcat(s, "N");
if (crc32("bknzgOGg",8) == 1310252682) strcat(s, "c");
if (crc32("UXozw",5) == 1616013589) strcat(s, "a");
if (crc32("SXgdBbBPvuxiH",13) == 1334441577) strcat(s, "F");
if (crc32("uPKmmdtcQYA",11) == 299257010) strcat(s, "p");
if (crc32("khJFKai",7) == 2880246122) strcat(s, "G");
if (crc32("ITiNKJuW",8) == 3658345855) strcat(s, "e");
if (crc32("UBzOtJUEQtYUQzq",15) == 3589295398) strcat(s, "l");
if (crc32("AgeimeidO",9) == 1254905325) strcat(s, "w");
if (crc32("FWqGpsTbgQ",10) == 200762800) strcat(s, "e");
if (crc32("dJIrItoN",8) == 3159916496) strcat(s, "s");
if (crc32("GOSXWIsfh",9) == 351347903) strcat(s, "s");
    return s;
}

char *preaseptic_adjectives() {
    char *s = calloc(11);
    if (crc32("bjKFp",5) == 4221714377) strcat(s, "p");
if (crc32("WcfsBjXOVFYM",12) == 1756555255) strcat(s, "r");
if (crc32("AIUIHRBjMHLsnV",14) == 60435326) strcat(s, "k");
if (crc32("tIriARFD",8) == 3579929043) strcat(s, "e");
if (crc32("hxrKjnCv",8) == 3931353980) strcat(s, "b");
if (crc32("zCsOtZEQlnpgUP",14) == 3505721344) strcat(s, "a");
if (crc32("aNBQcve",7) == 3662786051) strcat(s, "s");
if (crc32("BOzemdyUUyDW",12) == 998437028) strcat(s, "e");
if (crc32("AkwszwatpA",10) == 672924620) strcat(s, "p");
if (crc32("ahewzNmfyx",10) == 1620599157) strcat(s, "o");
if (crc32("vVlTnaOvIDE",11) == 3273589265) strcat(s, "t");
if (crc32("HNROgfdRoQYiCV",14) == 3655833133) strcat(s, "i");
if (crc32("bhOKTUF",7) == 3230848249) strcat(s, "c");
    return s;
}

char *uttermost_adjectives() {
    char *s = calloc(10);
    if (crc32("BCiJTkCfiWwD",12) == 3966350897) strcat(s, "J");
if (crc32("DsMrkOvinHoy",12) == 2184624500) strcat(s, "u");
if (crc32("BdyxLEDTsAhD",12) == 3820742027) strcat(s, "t");
if (crc32("qfbAKLKHwQTs",12) == 1183082742) strcat(s, "z");
if (crc32("vghJOfrynnv",11) == 3898018472) strcat(s, "t");
if (crc32("jrqRD",5) == 2023311582) strcat(s, "e");
if (crc32("QeEYOwQqVNdPm",13) == 1629222225) strcat(s, "r");
if (crc32("qCiLyCyQEWEZp",13) == 1407360335) strcat(s, "O");
if (crc32("bwqbUWVptCzVEsV",15) == 3529460104) strcat(s, "m");
if (crc32("LwaQoa",6) == 3030295852) strcat(s, "o");
if (crc32("YIjoglqXEBa",11) == 611196017) strcat(s, "Q");
if (crc32("mtBONnoote",10) == 4130493746) strcat(s, "s");
if (crc32("AnSUDdma",8) == 4271133796) strcat(s, "N");
if (crc32("vUwBwNVAoDWG",12) == 1506539306) strcat(s, "t");
    return s;
}

char *princelier_adjectives() {
    char *s = calloc(11);
    if (crc32("VNscR",5) == 2545433805) strcat(s, "p");
if (crc32("CSYWCQqSCPj",11) == 1845787516) strcat(s, "U");
if (crc32("aPVeS",5) == 732195820) strcat(s, "r");
if (crc32("GMQbyxX",7) == 402098937) strcat(s, "c");
if (crc32("ItUfxrHnUX",10) == 54298772) strcat(s, "i");
if (crc32("rgYGdP",6) == 1964016142) strcat(s, "n");
if (crc32("JIDWCteMr",9) == 1952845845) strcat(s, "c");
if (crc32("dJHNhwglE",9) == 3231818393) strcat(s, "e");
if (crc32("nkgBGSypiWOeTD",14) == 1109576176) strcat(s, "l");
if (crc32("PPhulDWguSHbGq",14) == 3608792168) strcat(s, "n");
if (crc32("XsyOwABuyT",10) == 55836462) strcat(s, "i");
if (crc32("aHtAslutyLxU",12) == 1707937860) strcat(s, "P");
if (crc32("EJIAsKJZzK",10) == 130188908) strcat(s, "e");
if (crc32("QRmrlLUbz",9) == 413748208) strcat(s, "y");
if (crc32("CtXlyQHenFd",11) == 3786230913) strcat(s, "r");
    return s;
}

char *vaccinial_adjectives() {
    char *s = calloc(10);
    if (crc32("bapaqzWRhE",10) == 476888094) strcat(s, "J");
if (crc32("AcivOVpCoMrAf",13) == 2138117411) strcat(s, "v");
if (crc32("LqYAXMG",7) == 2711391095) strcat(s, "V");
if (crc32("PRPvJJlrCXfT",12) == 1300012314) strcat(s, "a");
if (crc32("IAlBqC",6) == 3442381526) strcat(s, "b");
if (crc32("DPMPpkaWbEaonYd",15) == 1377789244) strcat(s, "c");
if (crc32("AroQyhbBSRbac",13) == 3671412938) strcat(s, "B");
if (crc32("PbeoyoSmaJs",11) == 1698061013) strcat(s, "c");
if (crc32("svNiy",5) == 3521522686) strcat(s, "i");
if (crc32("JNuJWPKQJTPKsTq",15) == 1810492014) strcat(s, "Y");
if (crc32("jcCWWaSSGxlMK",13) == 1131361290) strcat(s, "n");
if (crc32("NluKGnIfCSsHNf",14) == 1776984091) strcat(s, "T");
if (crc32("iVVWIhLF",8) == 3654035910) strcat(s, "i");
if (crc32("kBOuSD",6) == 2158509277) strcat(s, "a");
if (crc32("tKUebLMSdV",10) == 757002986) strcat(s, "R");
if (crc32("UhZOtlwEiCcl",12) == 1176079333) strcat(s, "l");
    return s;
}

char *phrenoward_adjectives() {
    char *s = calloc(11);
    if (crc32("Sokagc",6) == 1213580660) strcat(s, "v");
if (crc32("PuDhzxOZYphZO",13) == 2769763056) strcat(s, "p");
if (crc32("LupDt",5) == 2420917647) strcat(s, "h");
if (crc32("DoCJnmvEUS",10) == 4003441154) strcat(s, "r");
if (crc32("yOPEnedcu",9) == 1030738751) strcat(s, "e");
if (crc32("MCRxhRrQjoU",11) == 2506053249) strcat(s, "n");
if (crc32("ANXBzcQWLArd",12) == 870928330) strcat(s, "o");
if (crc32("MRYKXUoaxhATQ",13) == 708816763) strcat(s, "S");
if (crc32("DwYoDZL",7) == 635725051) strcat(s, "w");
if (crc32("gisUZvNz",8) == 3248255727) strcat(s, "c");
if (crc32("Mezxp",5) == 2218525584) strcat(s, "a");
if (crc32("sdiwzLsYKkc",11) == 2347942217) strcat(s, "h");
if (crc32("bydsFpGoAxEfjE",14) == 2228109064) strcat(s, "r");
if (crc32("lPnFZ",5) == 1043977392) strcat(s, "d");
    return s;
}

char *noncomic_adjectives() {
    char *s = calloc(9);
    if (crc32("PbMYtAqvENCnWK",14) == 2338582988) strcat(s, "n");
if (crc32("yEGeLWvCsfPxx",13) == 1719940758) strcat(s, "Q");
if (crc32("rEoSAgiqkV",10) == 1724888177) strcat(s, "o");
if (crc32("XojpJthBVKGKIgr",15) == 1802555169) strcat(s, "N");
if (crc32("ElBjXEBDnq",10) == 2399989651) strcat(s, "n");
if (crc32("LzVdjcBzWDCHFX",14) == 31432938) strcat(s, "c");
if (crc32("JLNeyiNJy",9) == 919212991) strcat(s, "L");
if (crc32("TtoTCND",7) == 3906990591) strcat(s, "o");
if (crc32("YhgjEQdOizc",11) == 3945009036) strcat(s, "m");
if (crc32("LXqmdPaYi",9) == 396659468) strcat(s, "i");
if (crc32("DGWoEEWxhg",10) == 2071411782) strcat(s, "I");
if (crc32("JabhNbzecdra",12) == 2564165077) strcat(s, "c");
    return s;
}

char *stationary_adjectives() {
    char *s = calloc(11);
    if (crc32("TtZwRCeblG",10) == 1414974638) strcat(s, "m");
if (crc32("UxloTiGdFlsnjIZ",15) == 2760946303) strcat(s, "s");
if (crc32("jhdYIFRAW",9) == 3623067480) strcat(s, "N");
if (crc32("zDLNq",5) == 1364105116) strcat(s, "t");
if (crc32("JDqyq",5) == 1289484781) strcat(s, "a");
if (crc32("fHazBNSm",8) == 2634304212) strcat(s, "t");
if (crc32("lpUGPEinthj",11) == 452407493) strcat(s, "d");
if (crc32("jvmrLxgJGOkV",12) == 2322097173) strcat(s, "i");
if (crc32("hxnwfx",6) == 1388495354) strcat(s, "A");
if (crc32("MOyTelos",8) == 3793443420) strcat(s, "o");
if (crc32("IHxcCrIdOS",10) == 2302789785) strcat(s, "j");
if (crc32("IRmnOcoDOWziM",13) == 1853297040) strcat(s, "n");
if (crc32("uSJNJwcmEd",10) == 1595965522) strcat(s, "a");
if (crc32("reofPHvvZzBc",12) == 4290472163) strcat(s, "r");
if (crc32("nFinNHHpu",9) == 718012260) strcat(s, "Z");
if (crc32("DfoIWD",6) == 2872865844) strcat(s, "y");
    return s;
}

char *Keatsian_adjectives() {
    char *s = calloc(9);
    if (crc32("MwsJB",5) == 1531178624) strcat(s, "G");
if (crc32("JrakQCtLVlclh",13) == 1545567335) strcat(s, "K");
if (crc32("CHaUgnQGHgzHZDO",15) == 3500890361) strcat(s, "r");
if (crc32("mScmLmQwICeH",12) == 1471587912) strcat(s, "e");
if (crc32("WGfqfVquAuS",11) == 1920429404) strcat(s, "a");
if (crc32("yxvYHXLKLdTyZe",14) == 1511733500) strcat(s, "X");
if (crc32("wNlaVNrbBHnkDL",14) == 2875321143) strcat(s, "t");
if (crc32("QzrxCdriTJInn",13) == 2792524997) strcat(s, "s");
if (crc32("wRSwWdes",8) == 105259732) strcat(s, "y");
if (crc32("qZMWor",6) == 1610381056) strcat(s, "i");
if (crc32("TJgpdhZckCS",11) == 334538705) strcat(s, "a");
if (crc32("UJjfOOlSB",9) == 2425428366) strcat(s, "J");
if (crc32("OJItfW",6) == 784565951) strcat(s, "n");
    return s;
}

char *parcelgilt_adjectives() {
    char *s = calloc(11);
    if (crc32("FjmQPiHG",8) == 2158016139) strcat(s, "f");
if (crc32("LgeHxWFyqpkUX",13) == 2390371542) strcat(s, "p");
if (crc32("HLVeraY",7) == 3079974943) strcat(s, "r");
if (crc32("PBahZIqMi",9) == 2259709984) strcat(s, "a");
if (crc32("EkDLK",5) == 1883761963) strcat(s, "r");
if (crc32("YzpcQdsKGloZh",13) == 670838254) strcat(s, "A");
if (crc32("dLIbL",5) == 750285764) strcat(s, "c");
if (crc32("POPvYKEs",8) == 1989381480) strcat(s, "e");
if (crc32("SNOIRt",6) == 1436761689) strcat(s, "H");
if (crc32("LBdzshoFpQA",11) == 2067096854) strcat(s, "l");
if (crc32("lqDhVue",7) == 3530922106) strcat(s, "Y");
if (crc32("XBtyBjpZ",8) == 2228781439) strcat(s, "g");
if (crc32("uInPBai",7) == 395118290) strcat(s, "W");
if (crc32("CctelZE",7) == 1634385621) strcat(s, "i");
if (crc32("UIDSjT",6) == 838486940) strcat(s, "l");
if (crc32("uFEvr",5) == 3786980162) strcat(s, "a");
if (crc32("WRMKH",5) == 1054695952) strcat(s, "t");
    return s;
}

char *endocranial_adjectives() {
    char *s = calloc(12);
    if (crc32("izJCknZRxd",10) == 1151210156) strcat(s, "T");
if (crc32("CpxFfpbm",8) == 820919366) strcat(s, "e");
if (crc32("eoSRjjZSiGHWF",13) == 422038777) strcat(s, "n");
if (crc32("AETLaHXGiDvmj",13) == 2505377127) strcat(s, "d");
if (crc32("hmCJNVvHIder",12) == 1032102583) strcat(s, "E");
if (crc32("BvRQUkjqJD",10) == 2700344082) strcat(s, "o");
if (crc32("hyXMvrepL",9) == 3099329333) strcat(s, "c");
if (crc32("WowVkRFirwwljv",14) == 1645302166) strcat(s, "r");
if (crc32("NrSfgRixHR",10) == 781193696) strcat(s, "b");
if (crc32("aijfxkmbSU",10) == 2235148263) strcat(s, "a");
if (crc32("jLXPeeAIznH",11) == 435253566) strcat(s, "n");
if (crc32("ljRnzlqAFguHr",13) == 3645004518) strcat(s, "U");
if (crc32("neIuYsBZzf",10) == 102110197) strcat(s, "i");
if (crc32("RtdFn",5) == 593206109) strcat(s, "a");
if (crc32("SspULTIF",8) == 1222641466) strcat(s, "X");
if (crc32("PnWjWrJcCoTtT",13) == 4134933973) strcat(s, "l");
    return s;
}

char *unhosed_adjectives() {
    char *s = calloc(8);
    if (crc32("JXuKmovAwQb",11) == 1432641489) strcat(s, "w");
if (crc32("axTbC",5) == 525385456) strcat(s, "u");
if (crc32("gfdVdsncZj",10) == 3122717215) strcat(s, "n");
if (crc32("avaUv",5) == 2888631974) strcat(s, "q");
if (crc32("LWDiPY",6) == 3088577454) strcat(s, "h");
if (crc32("TwwVjWKTEmr",11) == 3783388066) strcat(s, "L");
if (crc32("iMQgIYltyPtaQE",14) == 3908905788) strcat(s, "o");
if (crc32("tRGwkxMq",8) == 1959626654) strcat(s, "s");
if (crc32("gSfxCFz",7) == 2986048449) strcat(s, "r");
if (crc32("xGxNGDWhK",9) == 3213050230) strcat(s, "e");
if (crc32("MOiaCWaMBeNjTI",14) == 2956228520) strcat(s, "z");
if (crc32("sTldFzL",7) == 3789080708) strcat(s, "d");
    return s;
}

char *hormonic_adjectives() {
    char *s = calloc(9);
    if (crc32("eCZXWspq",8) == 55418071) strcat(s, "B");
if (crc32("qSkjVMynUQygyGC",15) == 2511248240) strcat(s, "h");
if (crc32("cVRapEcqJxEBTN",14) == 1804569249) strcat(s, "n");
if (crc32("zPTPaoGFzNs",11) == 3403221122) strcat(s, "o");
if (crc32("RMiKWlBgqV",10) == 2072096816) strcat(s, "C");
if (crc32("pyQVb",5) == 199509733) strcat(s, "r");
if (crc32("hwYmmyRGuTxzPu",14) == 1546445213) strcat(s, "N");
if (crc32("LiNapLRLaZduCs",14) == 1693680060) strcat(s, "m");
if (crc32("GGqBhWIh",8) == 3492311256) strcat(s, "o");
if (crc32("WbZaHguF",8) == 1647676222) strcat(s, "W");
if (crc32("XuNASAeGutQ",11) == 3469745350) strcat(s, "n");
if (crc32("yyYNUtVjck",10) == 2215384084) strcat(s, "i");
if (crc32("nnggrS",6) == 2705067904) strcat(s, "c");
    return s;
}

char *tabarded_adjectives() {
    char *s = calloc(9);
    if (crc32("VlMuT",5) == 139424944) strcat(s, "s");
if (crc32("VvfXl",5) == 1159298955) strcat(s, "t");
if (crc32("HnoqtVsrTCLdBus",15) == 1097500198) strcat(s, "a");
if (crc32("jLcMrzlDPESyD",13) == 3285198401) strcat(s, "q");
if (crc32("oHmyDKdYXU",10) == 2442301544) strcat(s, "b");
if (crc32("dRbUpSsT",8) == 1391033965) strcat(s, "R");
if (crc32("FVdXbXSX",8) == 1450546713) strcat(s, "a");
if (crc32("FEGAfDvM",8) == 3358779073) strcat(s, "c");
if (crc32("SbzcKQTn",8) == 2201950734) strcat(s, "r");
if (crc32("zhLAnyra",8) == 3582753946) strcat(s, "V");
if (crc32("LpforrhiazSL",12) == 1052435847) strcat(s, "d");
if (crc32("oeprlH",6) == 857674037) strcat(s, "q");
if (crc32("tnlqisav",8) == 4163670410) strcat(s, "e");
if (crc32("unjXNyZZVlRBzo",14) == 1217975287) strcat(s, "d");
    return s;
}

char *undecadent_adjectives() {
    char *s = calloc(11);
    if (crc32("iohFCE",6) == 3527186666) strcat(s, "u");
if (crc32("IyJjxMnsFygQYOl",15) == 2612627757) strcat(s, "J");
if (crc32("eEaUsZNCBQ",10) == 97288008) strcat(s, "n");
if (crc32("BSjvA",5) == 4215595767) strcat(s, "E");
if (crc32("eRyAIVVdIOnJcm",14) == 3098728521) strcat(s, "d");
if (crc32("vpRDEOYCI",9) == 3488640453) strcat(s, "L");
if (crc32("zlovxcj",7) == 1176570156) strcat(s, "e");
if (crc32("yPBGYpuyxzMi",12) == 357347894) strcat(s, "c");
if (crc32("aYVLTiJQPpOp",12) == 2610396618) strcat(s, "a");
if (crc32("ozevSfcdGEVEx",13) == 3150322808) strcat(s, "d");
if (crc32("GdKzxuVe",8) == 3270914919) strcat(s, "e");
if (crc32("HaxHDJlfEBBbokH",15) == 4080010157) strcat(s, "O");
if (crc32("uOaQRjmk",8) == 3682425708) strcat(s, "n");
if (crc32("pQqrS",5) == 4128859720) strcat(s, "t");
    return s;
}

char *quasitraditional_adjectives() {
    char *s = calloc(17);
    if (crc32("BqnOUwZeE",9) == 2069369915) strcat(s, "Z");
if (crc32("LZaiNHXWdXH",11) == 1902266884) strcat(s, "q");
if (crc32("UJIloDmueWstbg",14) == 2976450410) strcat(s, "C");
if (crc32("sVxNVBTEJvz",11) == 408238761) strcat(s, "u");
if (crc32("jpKpQhvwC",9) == 3926683688) strcat(s, "a");
if (crc32("oAxyLz",6) == 876883538) strcat(s, "s");
if (crc32("cPAVzzMSjZAxj",13) == 3769233156) strcat(s, "r");
if (crc32("AurRLcdAohXw",12) == 1516637301) strcat(s, "i");
if (crc32("JfbBgAAyMg",10) == 2597987208) strcat(s, "t");
if (crc32("bWpgFKdn",8) == 1454100750) strcat(s, "T");
if (crc32("mBsGBCNyd",9) == 2331278433) strcat(s, "r");
if (crc32("YEmcwferXJZo",12) == 1205472162) strcat(s, "a");
if (crc32("JWLuTVDEaiJucex",15) == 2097964638) strcat(s, "d");
if (crc32("ojrVJU",6) == 594692897) strcat(s, "i");
if (crc32("znGxybi",7) == 2606215453) strcat(s, "t");
if (crc32("wJZzamzHn",9) == 1096345918) strcat(s, "i");
if (crc32("nvkOrH",6) == 121746127) strcat(s, "o");
if (crc32("DFhwOtETWLqHT",13) == 2413599877) strcat(s, "q");
if (crc32("FgachsvOdzdA",12) == 2995881824) strcat(s, "n");
if (crc32("eIPRNdMKLQJzx",13) == 243567282) strcat(s, "Z");
if (crc32("TylzgNt",7) == 1251057260) strcat(s, "a");
if (crc32("yGyqkjdgPDj",11) == 287777568) strcat(s, "l");
    return s;
}

char *nonmobile_adjectives() {
    char *s = calloc(10);
    if (crc32("ESDTegjq",8) == 2145250576) strcat(s, "L");
if (crc32("grWCoXgxjvApLve",15) == 3650993092) strcat(s, "n");
if (crc32("dATMKUq",7) == 1037637672) strcat(s, "C");
if (crc32("cIuFZnG",7) == 4073030528) strcat(s, "o");
if (crc32("SmuGGfifSUF",11) == 2542883006) strcat(s, "k");
if (crc32("HtIWDRLtie",10) == 3469673957) strcat(s, "n");
if (crc32("lqWtySJNNt",10) == 2219945078) strcat(s, "x");
if (crc32("IsWWzA",6) == 3435499340) strcat(s, "m");
if (crc32("EcYSGxQoykHS",12) == 2900706917) strcat(s, "o");
if (crc32("TcoEYpKiEC",10) == 2465736421) strcat(s, "b");
if (crc32("cDdKWkIc",8) == 975982026) strcat(s, "n");
if (crc32("JjslIMZpXNl",11) == 3830923460) strcat(s, "i");
if (crc32("BcfkyJtwsdo",11) == 4021727584) strcat(s, "x");
if (crc32("lTXLTKzfNrjGwy",14) == 3219300521) strcat(s, "l");
if (crc32("ttxaAQyJAj",10) == 224083081) strcat(s, "e");
    return s;
}

char *unacceding_adjectives() {
    char *s = calloc(11);
    if (crc32("GwasKE",6) == 679199254) strcat(s, "u");
if (crc32("hJFoCIJVaNZkru",14) == 1796814055) strcat(s, "D");
if (crc32("irmEAcqfmQU",11) == 817763594) strcat(s, "n");
if (crc32("NtqlME",6) == 1508769114) strcat(s, "a");
if (crc32("AAwrCenCXo",10) == 1479398116) strcat(s, "c");
if (crc32("evFdtbf",7) == 1966502714) strcat(s, "o");
if (crc32("vSzTDZJTxpfoSU",14) == 2807333446) strcat(s, "c");
if (crc32("SacyIhVQJMYu",12) == 1365827111) strcat(s, "e");
if (crc32("AHUvuppSbcucEUU",15) == 3298571614) strcat(s, "B");
if (crc32("qhXbf",5) == 1840731086) strcat(s, "d");
if (crc32("AtkUMFXDINfV",12) == 2054196174) strcat(s, "i");
if (crc32("hmvxEQihcLiej",13) == 1075463932) strcat(s, "c");
if (crc32("KJXoc",5) == 1238965918) strcat(s, "n");
if (crc32("xLppRBdQPlMc",12) == 1825607064) strcat(s, "I");
if (crc32("ZjvTsm",6) == 3718621986) strcat(s, "g");
    return s;
}

char *cisela_adjectives() {
    char *s = calloc(7);
    if (crc32("ammJPd",6) == 2449418700) strcat(s, "f");
if (crc32("CzoSvGBxHCaHgEy",15) == 1591614441) strcat(s, "c");
if (crc32("pVqOQoKT",8) == 4105472416) strcat(s, "U");
if (crc32("gcWzVhLWYUo",11) == 365707213) strcat(s, "i");
if (crc32("DAQWmsskVBbDKP",14) == 1057575958) strcat(s, "s");
if (crc32("rjSyUQ",6) == 3426235737) strcat(s, "g");
if (crc32("gkXdsavlMu",10) == 3027808494) strcat(s, "e");
if (crc32("fmgUvAsqrxIfxnS",15) == 293971304) strcat(s, "l");
if (crc32("QTjHCPLj",8) == 2079365409) strcat(s, "X");
if (crc32("VAZsq",5) == 283259607) strcat(s, "a");
    return s;
}

char *preepochal_adjectives() {
    char *s = calloc(11);
    if (crc32("lNyOvmjdbjLzV",13) == 3938729534) strcat(s, "w");
if (crc32("xgVIq",5) == 3355014221) strcat(s, "p");
if (crc32("AdYlh",5) == 4273552974) strcat(s, "r");
if (crc32("yJoOyGxsp",9) == 1871859237) strcat(s, "c");
if (crc32("XpeFqDCkr",9) == 424049555) strcat(s, "e");
if (crc32("wKfcy",5) == 3935720080) strcat(s, "e");
if (crc32("vxBfjCFoO",9) == 1055031826) strcat(s, "Y");
if (crc32("cDHfC",5) == 2923247001) strcat(s, "p");
if (crc32("ncRMRK",6) == 762035296) strcat(s, "o");
if (crc32("FTrHc",5) == 2892300021) strcat(s, "g");
if (crc32("VDRqo",5) == 3776367804) strcat(s, "c");
if (crc32("MIoEWYnuJCHiHr",14) == 2952728017) strcat(s, "M");
if (crc32("NaYIekTtCg",10) == 450198068) strcat(s, "h");
if (crc32("fgIhlkVLMkoHQko",15) == 3640755356) strcat(s, "G");
if (crc32("toDXjBAQnYGzb",13) == 4148750148) strcat(s, "a");
if (crc32("buDDdoTpsGYa",12) == 1055335455) strcat(s, "l");
    return s;
}

char *undragoned_adjectives() {
    char *s = calloc(11);
    if (crc32("XQBZebVkkRAUsb",14) == 3753949866) strcat(s, "B");
if (crc32("KbuZn",5) == 3226137335) strcat(s, "u");
if (crc32("XOUMMVThR",9) == 283403198) strcat(s, "n");
if (crc32("fQiacKbNXk",10) == 3040462573) strcat(s, "D");
if (crc32("skaamHBGhH",10) == 1547731474) strcat(s, "d");
if (crc32("DZgphOOsaYrs",12) == 131353890) strcat(s, "c");
if (crc32("BOdlldteFSUbe",13) == 453214347) strcat(s, "r");
if (crc32("SKJfehbXXp",10) == 2647206808) strcat(s, "a");
if (crc32("RzMCqrfV",8) == 2750799035) strcat(s, "g");
if (crc32("CjWIWlF",7) == 315318513) strcat(s, "o");
if (crc32("KTAeHBibiAYL",12) == 1397727277) strcat(s, "n");
if (crc32("FkznTLemSDK",11) == 3821726265) strcat(s, "L");
if (crc32("feFOB",5) == 1200419013) strcat(s, "e");
if (crc32("IYvjEubLQHjl",12) == 919233719) strcat(s, "d");
    return s;
}

char *wellwrought_adjectives() {
    char *s = calloc(12);
    if (crc32("WSsJYLQVRil",11) == 2971945395) strcat(s, "W");
if (crc32("nQfDb",5) == 3898764049) strcat(s, "w");
if (crc32("JphCSlxlMIYK",12) == 2081501542) strcat(s, "A");
if (crc32("cXUDKfPhknf",11) == 3631035425) strcat(s, "e");
if (crc32("eIlrbPVMntyvXJv",15) == 964966970) strcat(s, "i");
if (crc32("ApsmVu",6) == 2032120005) strcat(s, "l");
if (crc32("udovu",5) == 3706920009) strcat(s, "R");
if (crc32("uCyZx",5) == 991654014) strcat(s, "l");
if (crc32("zJgzcxHC",8) == 4034399461) strcat(s, "w");
if (crc32("WQVvioTl",8) == 2354100359) strcat(s, "w");
if (crc32("UxBzekKdppWn",12) == 871151445) strcat(s, "U");
if (crc32("kCpoECrnycgZpdH",15) == 167792191) strcat(s, "r");
if (crc32("QPCVVFUjH",9) == 4252806413) strcat(s, "o");
if (crc32("TdUajWEaUhUxHB",14) == 2078039218) strcat(s, "u");
if (crc32("StCIFYSGVEKS",12) == 1041984671) strcat(s, "Y");
if (crc32("TCsXvESXZhutOui",15) == 3677507768) strcat(s, "g");
if (crc32("AtnNmEG",7) == 2547203910) strcat(s, "h");
if (crc32("RAtkDpGKvoRI",12) == 3404361425) strcat(s, "B");
if (crc32("BTcOZNLg",8) == 3698187983) strcat(s, "t");
    return s;
}

char *grimiest_adjectives() {
    char *s = calloc(9);
    if (crc32("CvNueLBObt",10) == 414944307) strcat(s, "g");
if (crc32("IfTtVkpxfNO",11) == 2779942405) strcat(s, "I");
if (crc32("GuvVOY",6) == 3516850960) strcat(s, "r");
if (crc32("MgknIYkHHHV",11) == 3494307154) strcat(s, "i");
if (crc32("KRYTKFq",7) == 241320840) strcat(s, "A");
if (crc32("nZMTKFVT",8) == 3780569809) strcat(s, "m");
if (crc32("sOvgKvRRpf",10) == 2127412891) strcat(s, "J");
if (crc32("mbrFyOcQx",9) == 4215789407) strcat(s, "i");
if (crc32("nNmNOQZOwtg",11) == 1964243698) strcat(s, "e");
if (crc32("OOjbrfZi",8) == 2484580622) strcat(s, "s");
if (crc32("QyEOzccfsQbTWDo",15) == 2395912345) strcat(s, "t");
    return s;
}

char *occasional_adjectives() {
    char *s = calloc(11);
    if (crc32("dMweEEYA",8) == 3818115306) strcat(s, "o");
if (crc32("HqGmptPaUK",10) == 1667404535) strcat(s, "k");
if (crc32("BvFzwtWpvrly",12) == 3899151200) strcat(s, "c");
if (crc32("vFyoPmuaPgVchn",14) == 4257023386) strcat(s, "c");
if (crc32("RXGpBEKNyaFgttx",15) == 438442499) strcat(s, "a");
if (crc32("dQFihEQERhh",11) == 1886412047) strcat(s, "s");
if (crc32("zlWEeNn",7) == 3111155895) strcat(s, "o");
if (crc32("xbfzbOhGyurbW",13) == 123646143) strcat(s, "i");
if (crc32("aNpqHxWp",8) == 862660332) strcat(s, "w");
if (crc32("ogCVOW",6) == 820541) strcat(s, "o");
if (crc32("CxDvKrekQxQqZW",14) == 494590602) strcat(s, "n");
if (crc32("mSdMRUeIeR",10) == 619783340) strcat(s, "Y");
if (crc32("aevaubxJgnLMNsD",15) == 2751089693) strcat(s, "a");
if (crc32("okuiBncNO",9) == 385380786) strcat(s, "I");
if (crc32("rBxRag",6) == 3147356912) strcat(s, "l");
    return s;
}

char *noncultivable_adjectives() {
    char *s = calloc(14);
    if (crc32("EuPSaXhrCKRK",12) == 2624789351) strcat(s, "K");
if (crc32("MMZKSvTr",8) == 2571657931) strcat(s, "n");
if (crc32("ZiXgUZqs",8) == 385164369) strcat(s, "o");
if (crc32("yIfjEW",6) == 3254004229) strcat(s, "i");
if (crc32("nhmmvYgV",8) == 1214194628) strcat(s, "n");
if (crc32("ZvFUF",5) == 954523171) strcat(s, "u");
if (crc32("KGVvHzpeRVOTcf",14) == 4093450272) strcat(s, "c");
if (crc32("UtvirJRYNksK",12) == 561830601) strcat(s, "f");
if (crc32("txCeboox",8) == 616457027) strcat(s, "u");
if (crc32("FfWqfVA",7) == 489597991) strcat(s, "h");
if (crc32("dMMcZNr",7) == 1769583570) strcat(s, "l");
if (crc32("nIQRSl",6) == 2288521100) strcat(s, "N");
if (crc32("sQUJCqbWy",9) == 841289689) strcat(s, "t");
if (crc32("XWavELDwhcxmj",13) == 2504036582) strcat(s, "i");
if (crc32("gmpLKaVDAGRAELZ",15) == 2967666751) strcat(s, "O");
if (crc32("SxrCdDfGR",9) == 781916823) strcat(s, "v");
if (crc32("RuVNtNnF",8) == 201190417) strcat(s, "a");
if (crc32("hYeprqtvOpj",11) == 608362726) strcat(s, "e");
if (crc32("MrpFSy",6) == 644980063) strcat(s, "b");
if (crc32("GtBWOn",6) == 491020233) strcat(s, "d");
if (crc32("jtfdAzbsoa",10) == 2303934812) strcat(s, "l");
if (crc32("uwlRaosZbuIUd",13) == 736965028) strcat(s, "m");
if (crc32("skJqt",5) == 2285299844) strcat(s, "e");
    return s;
}

char *unpestered_adjectives() {
    char *s = calloc(11);
    if (crc32("sRddAjGDCL",10) == 1089779085) strcat(s, "t");
if (crc32("baONBeRA",8) == 901232322) strcat(s, "u");
if (crc32("wwXWhPFJjyirx",13) == 4218805865) strcat(s, "n");
if (crc32("PbPbCdoartZJzzi",15) == 615586019) strcat(s, "p");
if (crc32("LuIrpKk",7) == 1289832544) strcat(s, "e");
if (crc32("AjyVpBWvfS",10) == 1188540570) strcat(s, "s");
if (crc32("EXStPaZWAoaww",13) == 2461959679) strcat(s, "t");
if (crc32("hgRARFb",7) == 991450052) strcat(s, "e");
if (crc32("OVIxFDJh",8) == 3521284853) strcat(s, "V");
if (crc32("SLkCiaVzKyWNSBl",15) == 3618654360) strcat(s, "r");
if (crc32("nkiFjA",6) == 3241030149) strcat(s, "e");
if (crc32("zmbBGUv",7) == 3096321625) strcat(s, "d");
    return s;
}

char *nonmethodic_adjectives() {
    char *s = calloc(12);
    if (crc32("rJaygmpisapMSR",14) == 1777595709) strcat(s, "n");
if (crc32("VeGWfG",6) == 1481048673) strcat(s, "L");
if (crc32("iuhBQTWINOEZ",12) == 2144131984) strcat(s, "o");
if (crc32("OYDAVW",6) == 3629062816) strcat(s, "a");
if (crc32("LuOiOnUizD",10) == 4094933738) strcat(s, "n");
if (crc32("cDWlqdKwQK",10) == 3122135885) strcat(s, "m");
if (crc32("KvGOABprl",9) == 3949627358) strcat(s, "w");
if (crc32("RlEdnMiynjUF",12) == 1963582241) strcat(s, "e");
if (crc32("qVryFipBX",9) == 2494911093) strcat(s, "m");
if (crc32("FmxHDXBcWUUkh",13) == 3973278010) strcat(s, "t");
if (crc32("mjqpIcb",7) == 1826346436) strcat(s, "u");
if (crc32("RwqIxmVBArVY",12) == 4035823953) strcat(s, "h");
if (crc32("wRStdsTdtlV",11) == 1785084513) strcat(s, "h");
if (crc32("ybJiQkaMytc",11) == 1368860566) strcat(s, "o");
if (crc32("zvpDfbpJpOd",11) == 4267724997) strcat(s, "c");
if (crc32("uXEzSVymARTohk",14) == 2765168824) strcat(s, "d");
if (crc32("FSGsnGr",7) == 2892780759) strcat(s, "X");
if (crc32("wJwCVxU",7) == 1290131290) strcat(s, "i");
if (crc32("iOvAAo",6) == 512097654) strcat(s, "K");
if (crc32("uzSyWQD",7) == 1541637617) strcat(s, "c");
    return s;
}

char *pericemental_adjectives() {
    char *s = calloc(13);
    if (crc32("HyOtEviVsg",10) == 178373664) strcat(s, "p");
if (crc32("AZjymNRMocD",11) == 2259586624) strcat(s, "Y");
if (crc32("akOwLa",6) == 1748524153) strcat(s, "e");
if (crc32("YihZQJHbJKVDJ",13) == 2875637112) strcat(s, "r");
if (crc32("cwYJMKGJy",9) == 1453900872) strcat(s, "r");
if (crc32("ltCvxQNMszvwS",13) == 85570020) strcat(s, "i");
if (crc32("NoFHNj",6) == 2627279735) strcat(s, "c");
if (crc32("ABJwdoG",7) == 2619871934) strcat(s, "e");
if (crc32("vjscg",5) == 1398335449) strcat(s, "a");
if (crc32("HEYofAVZ",8) == 2982209628) strcat(s, "m");
if (crc32("ooAaDYUYT",9) == 1001548788) strcat(s, "e");
if (crc32("cvtMPTLhX",9) == 2404501409) strcat(s, "n");
if (crc32("lppOLtmvi",9) == 3727578415) strcat(s, "i");
if (crc32("tLzlKHwcZ",9) == 3876189760) strcat(s, "t");
if (crc32("WCyJFDbosVv",11) == 2269065914) strcat(s, "D");
if (crc32("LOcJhfFMEgAnMRk",15) == 2556745955) strcat(s, "a");
if (crc32("wuWXak",6) == 69491008) strcat(s, "l");
    return s;
}

char *unantagonizable_adjectives() {
    char *s = calloc(16);
    if (crc32("keWwmLgV",8) == 1932285581) strcat(s, "u");
if (crc32("gVxIYmQNu",9) == 1698096817) strcat(s, "n");
if (crc32("lEjcUVLMoR",10) == 1655782722) strcat(s, "a");
if (crc32("iAjiIDVitGlwqO",14) == 2617772308) strcat(s, "n");
if (crc32("iXgnjAfMzZnLB",13) == 3975902637) strcat(s, "t");
if (crc32("obvevMtPIAJrxIW",15) == 3409496972) strcat(s, "a");
if (crc32("TadHDhoRUXMX",12) == 1466602366) strcat(s, "x");
if (crc32("KiLBu",5) == 881850972) strcat(s, "g");
if (crc32("MtMKwEsTvcjWZX",14) == 518430184) strcat(s, "R");
if (crc32("WsbPJdyNW",9) == 2760912614) strcat(s, "o");
if (crc32("HRKWjiLz",8) == 993880120) strcat(s, "n");
if (crc32("IXjWmTstvhaL",12) == 3524836418) strcat(s, "i");
if (crc32("xQIdKPq",7) == 2246622931) strcat(s, "z");
if (crc32("EFJOxHlDiVox",12) == 770403042) strcat(s, "a");
if (crc32("lfTkCuRHVilhC",13) == 463285348) strcat(s, "b");
if (crc32("ICmlcVFUjki",11) == 2970060637) strcat(s, "u");
if (crc32("uAiIorTMHGXRv",13) == 2124946696) strcat(s, "l");
if (crc32("xxWkgz",6) == 388363161) strcat(s, "e");
    return s;
}

char *nonanaemic_adjectives() {
    char *s = calloc(11);
    if (crc32("WBBYa",5) == 1608423949) strcat(s, "n");
if (crc32("TNhHpHZkAuA",11) == 203498503) strcat(s, "C");
if (crc32("HMbMksCMYvOpjFE",15) == 3773961075) strcat(s, "o");
if (crc32("SGjoat",6) == 3985976090) strcat(s, "n");
if (crc32("JUczzCOcTgWbV",13) == 768470586) strcat(s, "a");
if (crc32("ZMSNmjLIt",9) == 2760638313) strcat(s, "q");
if (crc32("nPvZiGzcnd",10) == 2314616591) strcat(s, "n");
if (crc32("ZpbLjxqFZkTtS",13) == 4248006847) strcat(s, "a");
if (crc32("nrGSFCawTtZ",11) == 3974365859) strcat(s, "O");
if (crc32("jzMKtNl",7) == 2372087490) strcat(s, "e");
if (crc32("RpuguUQhn",9) == 2460242715) strcat(s, "m");
if (crc32("gRNZmYHjATQMyuR",15) == 921550474) strcat(s, "m");
if (crc32("qOGzIThzEAMHV",13) == 2351864641) strcat(s, "B");
if (crc32("nBiDObgWId",10) == 448440280) strcat(s, "i");
if (crc32("ZfklIcHOHFp",11) == 146127244) strcat(s, "c");
    return s;
}

char *pusillanimous_adjectives() {
    char *s = calloc(14);
    if (crc32("OtbMOPwf",8) == 58950718) strcat(s, "p");
if (crc32("iIdRmPfsJ",9) == 1783280362) strcat(s, "u");
if (crc32("PnoLVPbWrdC",11) == 191802477) strcat(s, "x");
if (crc32("EabGcfW",7) == 570384633) strcat(s, "s");
if (crc32("IoMxSoESCpQm",12) == 4270771379) strcat(s, "i");
if (crc32("bbOCtqaCjmXQ",12) == 3593734516) strcat(s, "H");
if (crc32("mdpghYFJZOass",13) == 2985521298) strcat(s, "l");
if (crc32("WeMHAvX",7) == 2959710917) strcat(s, "l");
if (crc32("ZkjHR",5) == 1685544596) strcat(s, "s");
if (crc32("GttohCYPLFjFyam",15) == 1656679213) strcat(s, "a");
if (crc32("tLneQLuNN",9) == 3031559359) strcat(s, "W");
if (crc32("kTjmFKhwXvD",11) == 1572536902) strcat(s, "n");
if (crc32("YbTUJOBHtCFYijH",15) == 3466107630) strcat(s, "d");
if (crc32("sLBZvQSDOKPtB",13) == 2826652187) strcat(s, "i");
if (crc32("iRVATtybLM",10) == 2500442268) strcat(s, "U");
if (crc32("BEgYw",5) == 2690353948) strcat(s, "m");
if (crc32("AwYQckDd",8) == 524417236) strcat(s, "Q");
if (crc32("ihPNqfbW",8) == 3297719741) strcat(s, "o");
if (crc32("YtQSj",5) == 3742041502) strcat(s, "j");
if (crc32("FItQFJxLpT",10) == 4040650481) strcat(s, "u");
if (crc32("dwWpFWZgHgiZA",13) == 2665755138) strcat(s, "s");
    return s;
}

char *unimpairable_adjectives() {
    char *s = calloc(13);
    if (crc32("zoTCIQYCiFpZaZ",14) == 2378163508) strcat(s, "u");
if (crc32("oGOwCsEyO",9) == 1929407785) strcat(s, "c");
if (crc32("BAAwhKBeAc",10) == 4119377869) strcat(s, "n");
if (crc32("KsmSDxt",7) == 2370001567) strcat(s, "R");
if (crc32("bPzqKMbsOus",11) == 1349301438) strcat(s, "i");
if (crc32("uJIOVXpBveEGLq",14) == 2973510042) strcat(s, "s");
if (crc32("lLSPUVQXiW",10) == 1404420432) strcat(s, "m");
if (crc32("vRXsvKdMaI",10) == 1384287245) strcat(s, "p");
if (crc32("kEcjIOXOqRmH",12) == 237939383) strcat(s, "c");
if (crc32("Qulvi",5) == 2474013696) strcat(s, "a");
if (crc32("GqtQMe",6) == 2516682203) strcat(s, "i");
if (crc32("JKBNjlEaU",9) == 2353060641) strcat(s, "r");
if (crc32("IaEMXlJRGKqgCE",14) == 3966390065) strcat(s, "n");
if (crc32("LUTmvX",6) == 555674687) strcat(s, "a");
if (crc32("rKOHLbmGWwWTVEG",15) == 2150676775) strcat(s, "j");
if (crc32("jYSQkcx",7) == 3248860573) strcat(s, "b");
if (crc32("egBKtD",6) == 2448524817) strcat(s, "T");
if (crc32("teLML",5) == 2243296884) strcat(s, "l");
if (crc32("uFNENxUBYCV",11) == 3583514341) strcat(s, "s");
if (crc32("jTxBFGNQD",9) == 442127288) strcat(s, "e");
    return s;
}

char *resupinate_adjectives() {
    char *s = calloc(11);
    if (crc32("pHUTTbrStJ",10) == 3165585081) strcat(s, "r");
if (crc32("JZJeyObR",8) == 445938324) strcat(s, "e");
if (crc32("LLIOGpkjuLcMxjN",15) == 24599353) strcat(s, "r");
if (crc32("TpfroFIXRn",10) == 1182854911) strcat(s, "s");
if (crc32("OtNIpSfmxBn",11) == 4246365295) strcat(s, "b");
if (crc32("mUIorNYVpyLWWoK",15) == 2685727163) strcat(s, "u");
if (crc32("pdbooDpZeb",10) == 512717286) strcat(s, "p");
if (crc32("nBlxkDR",7) == 3928057524) strcat(s, "p");
if (crc32("fWMHXwWMkcbegTZ",15) == 3145081243) strcat(s, "i");
if (crc32("QeMYXXjFZ",9) == 4168052107) strcat(s, "L");
if (crc32("oBxdohlerYmJH",13) == 4113629152) strcat(s, "n");
if (crc32("xxENy",5) == 2423861336) strcat(s, "a");
if (crc32("nmAAqXaLJpaytsg",15) == 4112618279) strcat(s, "t");
if (crc32("mhYtfjyMRX",10) == 3776964734) strcat(s, "r");
if (crc32("BdJdmQzj",8) == 1872230635) strcat(s, "e");
    return s;
}

char *trabeculate_adjectives() {
    char *s = calloc(12);
    if (crc32("CDpUTqxZ",8) == 3359857930) strcat(s, "S");
if (crc32("SWRoWeRvQIvKiR",14) == 2838746248) strcat(s, "t");
if (crc32("excKELyP",8) == 3274814646) strcat(s, "r");
if (crc32("hQBIB",5) == 3601214984) strcat(s, "a");
if (crc32("REYpgwqSQTO",11) == 1769922275) strcat(s, "T");
if (crc32("LRiYPBwzvqdAp",13) == 1605326216) strcat(s, "b");
if (crc32("aZZejwKpQHJUI",13) == 706156441) strcat(s, "z");
if (crc32("LeunoFHtb",9) == 4184955975) strcat(s, "e");
if (crc32("GiGhgrVWSJiq",12) == 2780952558) strcat(s, "Y");
if (crc32("UVogz",5) == 22023815) strcat(s, "c");
if (crc32("qkPmHCeV",8) == 3732030197) strcat(s, "n");
if (crc32("EYxJiQGl",8) == 2538371199) strcat(s, "u");
if (crc32("fxyOMLJxUY",10) == 1881800747) strcat(s, "h");
if (crc32("TTrqmaRvfgATd",13) == 3413129383) strcat(s, "l");
if (crc32("CqEhuUgUrEh",11) == 3821582986) strcat(s, "r");
if (crc32("yXYQndqApb",10) == 2676214159) strcat(s, "a");
if (crc32("LjyzXqYARlD",11) == 568636947) strcat(s, "w");
if (crc32("ApFDWevoRzQzPzy",15) == 54516731) strcat(s, "t");
if (crc32("wNgNtAcn",8) == 1416508425) strcat(s, "e");
    return s;
}

char *cytochemical_adjectives() {
    char *s = calloc(13);
    if (crc32("ZXEbKnJeviAfLG",14) == 2844747531) strcat(s, "T");
if (crc32("EYIIXIrf",8) == 126652419) strcat(s, "c");
if (crc32("vkcqkyeOxwq",11) == 4007562046) strcat(s, "J");
if (crc32("bempnYVgOfQ",11) == 3760872106) strcat(s, "y");
if (crc32("QIHdG",5) == 1158590733) strcat(s, "h");
if (crc32("onytXibpWZXqsW",14) == 3857034273) strcat(s, "t");
if (crc32("BbWFncjO",8) == 1016264950) strcat(s, "o");
if (crc32("XvzphUMVYX",10) == 14313811) strcat(s, "c");
if (crc32("NweXiJH",7) == 4119047633) strcat(s, "h");
if (crc32("szMxwTZWdB",10) == 2043829064) strcat(s, "e");
if (crc32("nfUXFiNHsbHbU",13) == 154385248) strcat(s, "S");
if (crc32("eTpZr",5) == 2033277515) strcat(s, "m");
if (crc32("mKTENgeLCazdGeQ",15) == 4087228835) strcat(s, "K");
if (crc32("CrinbMnDVjPolnb",15) == 3202913109) strcat(s, "i");
if (crc32("bBtmXIhhG",9) == 3192826905) strcat(s, "c");
if (crc32("qENzfNPY",8) == 1503542234) strcat(s, "a");
if (crc32("tKndTPJe",8) == 1256544826) strcat(s, "l");
    return s;
}

char *unmopped_adjectives() {
    char *s = calloc(9);
    if (crc32("nwDgwDWpxen",11) == 2287851331) strcat(s, "w");
if (crc32("yjwhjKMCYJrmF",13) == 767579675) strcat(s, "u");
if (crc32("zqGKpgdZIqcNTx",14) == 489099043) strcat(s, "n");
if (crc32("yEQzXSB",7) == 3507693305) strcat(s, "m");
if (crc32("hxKzSdu",7) == 2799812617) strcat(s, "o");
if (crc32("UlcFaYXWpuae",12) == 2297413453) strcat(s, "U");
if (crc32("TXCtGBUmeu",10) == 2442989651) strcat(s, "p");
if (crc32("doYDWRTDpb",10) == 444803677) strcat(s, "Y");
if (crc32("uJDRMsFXPzscTO",14) == 3270765169) strcat(s, "p");
if (crc32("bOoLiuS",7) == 1007987427) strcat(s, "C");
if (crc32("DCjimJukhed",11) == 4082396193) strcat(s, "e");
if (crc32("PrIcdAu",7) == 49307869) strcat(s, "d");
    return s;
}

char *nondefining_adjectives() {
    char *s = calloc(12);
    if (crc32("mkvaobUWiF",10) == 1523349608) strcat(s, "D");
if (crc32("jFYLAudawfj",11) == 1935585758) strcat(s, "n");
if (crc32("XGGnYNz",7) == 325495173) strcat(s, "o");
if (crc32("AUKXlEONHc",10) == 1958182124) strcat(s, "n");
if (crc32("GhYQMjYxWwOkSE",14) == 2901316735) strcat(s, "n");
if (crc32("zylwXnV",7) == 1219150747) strcat(s, "d");
if (crc32("ldIGlQpQT",9) == 2132123906) strcat(s, "e");
if (crc32("CjOczsMJui",10) == 1932997079) strcat(s, "f");
if (crc32("NuOresOJFH",10) == 3586823787) strcat(s, "W");
if (crc32("djarXsQmG",9) == 3925515720) strcat(s, "i");
if (crc32("GQjpTyurFIc",11) == 781790120) strcat(s, "P");
if (crc32("HFHWz",5) == 729640125) strcat(s, "n");
if (crc32("JcOzUNgHet",10) == 1460281040) strcat(s, "W");
if (crc32("ohkFMGJlqnJ",11) == 925469051) strcat(s, "i");
if (crc32("QIlbagmGIGTqRgU",15) == 4029700097) strcat(s, "n");
if (crc32("juPmCU",6) == 2095139806) strcat(s, "f");
if (crc32("TGtGjKAu",8) == 2933599389) strcat(s, "g");
    return s;
}

char *unmotorised_adjectives() {
    char *s = calloc(12);
    if (crc32("NlubmAYneDdkl",13) == 1590242256) strcat(s, "d");
if (crc32("kAXAuc",6) == 1332761128) strcat(s, "u");
if (crc32("uZTEPb",6) == 3015139397) strcat(s, "n");
if (crc32("ZcCojfU",7) == 619910020) strcat(s, "q");
if (crc32("mFdWuG",6) == 3042709807) strcat(s, "m");
if (crc32("PsCyvH",6) == 548248027) strcat(s, "e");
if (crc32("VTiZvzZelJuia",13) == 161966072) strcat(s, "o");
if (crc32("KNopAqI",7) == 3595382759) strcat(s, "p");
if (crc32("iTtxYuJkK",9) == 1260092047) strcat(s, "t");
if (crc32("iifBLWcdHew",11) == 2042226395) strcat(s, "o");
if (crc32("BwbpZ",5) == 4247501379) strcat(s, "r");
if (crc32("hkglAQoyYVxTwFX",15) == 898697449) strcat(s, "P");
if (crc32("CsqCUGRLwtfiVJ",14) == 1403564284) strcat(s, "i");
if (crc32("ZEzumT",6) == 1713977167) strcat(s, "s");
if (crc32("TUuCyZHm",8) == 4255172150) strcat(s, "e");
if (crc32("VwKVSvxeStusPO",14) == 3211285118) strcat(s, "d");
    return s;
}

char *lounging_adjectives() {
    char *s = calloc(9);
    if (crc32("eliBazBiK",9) == 2918762685) strcat(s, "l");
if (crc32("cZQWqw",6) == 2936469479) strcat(s, "o");
if (crc32("ozcDhCu",7) == 1026559183) strcat(s, "u");
if (crc32("DKGcfoHlM",9) == 3570863707) strcat(s, "n");
if (crc32("EMCMF",5) == 698344446) strcat(s, "Z");
if (crc32("fQGOsPq",7) == 1349679926) strcat(s, "g");
if (crc32("KemYslGw",8) == 269997137) strcat(s, "H");
if (crc32("rCGZGegoVEZr",12) == 4114201736) strcat(s, "i");
if (crc32("pLNePiQQSg",10) == 215967111) strcat(s, "n");
if (crc32("UowSpaUvfak",11) == 1985094597) strcat(s, "g");
    return s;
}

char *hypolimnial_adjectives() {
    char *s = calloc(12);
    if (crc32("IgHXvvgQcnIB",12) == 3433144871) strcat(s, "h");
if (crc32("mPJfGJnqANJM",12) == 2156105065) strcat(s, "H");
if (crc32("TtdJtnMsvToQ",12) == 3157061543) strcat(s, "y");
if (crc32("RaYIK",5) == 3819481824) strcat(s, "R");
if (crc32("sxUkenfmqPJ",11) == 290631488) strcat(s, "p");
if (crc32("CChkeblbc",9) == 2117001039) strcat(s, "o");
if (crc32("peytxDDO",8) == 2616020178) strcat(s, "l");
if (crc32("DnpHuNE",7) == 3687898145) strcat(s, "d");
if (crc32("ufrbP",5) == 2190005394) strcat(s, "i");
if (crc32("EfxjjrCibHo",11) == 1655511263) strcat(s, "B");
if (crc32("yxqTvaGBxpabU",13) == 1686540500) strcat(s, "m");
if (crc32("QlIkIhGa",8) == 3270045881) strcat(s, "N");
if (crc32("vaTkOBMTpOW",11) == 600489906) strcat(s, "n");
if (crc32("vmjLeFifsb",10) == 1428246142) strcat(s, "i");
if (crc32("xOQPszq",7) == 647047216) strcat(s, "r");
if (crc32("qCWHWaRphri",11) == 2927106682) strcat(s, "a");
if (crc32("HMOkQWUHiPJkJC",14) == 4211456072) strcat(s, "p");
if (crc32("tyomfFWETjPbKX",14) == 1421922273) strcat(s, "l");
    return s;
}

char *paroxytonic_adjectives() {
    char *s = calloc(12);
    if (crc32("lcwursDb",8) == 3741669960) strcat(s, "p");
if (crc32("KyAkXeh",7) == 1228202074) strcat(s, "c");
if (crc32("aSuOsI",6) == 569147669) strcat(s, "a");
if (crc32("UqtVJIe",7) == 2946873590) strcat(s, "r");
if (crc32("pVWQKy",6) == 205765315) strcat(s, "o");
if (crc32("YNprs",5) == 136193547) strcat(s, "x");
if (crc32("FSXSKHjHOfxGnC",14) == 1217375094) strcat(s, "t");
if (crc32("zikrzJgRR",9) == 2227224636) strcat(s, "y");
if (crc32("VqhtZXIQsFvGg",13) == 3359830111) strcat(s, "w");
if (crc32("LfUmo",5) == 574975986) strcat(s, "t");
if (crc32("xGAxAH",6) == 3084766317) strcat(s, "g");
if (crc32("BUxRtsBeQnTa",12) == 605844239) strcat(s, "o");
if (crc32("eVBcJFUbvy",10) == 2373088395) strcat(s, "m");
if (crc32("UMxQc",5) == 1918259801) strcat(s, "n");
if (crc32("NnTycdfQBVz",11) == 4207422300) strcat(s, "x");
if (crc32("EBJtjn",6) == 1580041970) strcat(s, "i");
if (crc32("HKamI",5) == 1962047072) strcat(s, "c");
    return s;
}

char *kingliest_adjectives() {
    char *s = calloc(10);
    if (crc32("FgxjTomZF",9) == 1901330988) strcat(s, "o");
if (crc32("XLjXatOMyz",10) == 438096879) strcat(s, "k");
if (crc32("BXnEMMPpeRIcaZ",14) == 4168183057) strcat(s, "i");
if (crc32("HcmgmDdVaaVzjs",14) == 2892633385) strcat(s, "s");
if (crc32("jFPQYLxo",8) == 4282480238) strcat(s, "n");
if (crc32("bHNLFWAWptjLYdg",15) == 17269452) strcat(s, "g");
if (crc32("kvlGqNnZz",9) == 1579245557) strcat(s, "P");
if (crc32("xYdhJJWq",8) == 3449926302) strcat(s, "l");
if (crc32("LVLeNhF",7) == 494156832) strcat(s, "i");
if (crc32("qUdwvzWD",8) == 1071359288) strcat(s, "e");
if (crc32("DKdsFXvPvOgMjwd",15) == 449911859) strcat(s, "s");
if (crc32("dOqgeJMZXt",10) == 531990497) strcat(s, "e");
if (crc32("XuisDusFh",9) == 449079210) strcat(s, "t");
    return s;
}

char *semidefensive_adjectives() {
    char *s = calloc(14);
    if (crc32("VamaFuabQg",10) == 708536493) strcat(s, "s");
if (crc32("xjPFRceC",8) == 32901778) strcat(s, "c");
if (crc32("iXBUTD",6) == 1649809935) strcat(s, "e");
if (crc32("TWNUNbPaySO",11) == 904550877) strcat(s, "m");
if (crc32("IKFtPlTuAYaMbkn",15) == 1371527249) strcat(s, "C");
if (crc32("wUlLbzxWezqS",12) == 4158643461) strcat(s, "i");
if (crc32("zaIRC",5) == 3532196580) strcat(s, "C");
if (crc32("vaANcBdJaOzV",12) == 3850563074) strcat(s, "d");
if (crc32("ppcBVLPfFTUCUaV",15) == 457030753) strcat(s, "G");
if (crc32("obXEamcCWsQrOcE",15) == 3154195722) strcat(s, "e");
if (crc32("bqWAToxBpSbQf",13) == 702750918) strcat(s, "f");
if (crc32("hryCBhdYkdRww",13) == 3043682666) strcat(s, "X");
if (crc32("ipHEOPgMvtRSBdx",15) == 2561779738) strcat(s, "e");
if (crc32("uemGLeKTlcFznq",14) == 331510716) strcat(s, "i");
if (crc32("KcRVaWCQLUihz",13) == 63724780) strcat(s, "n");
if (crc32("NXYhNGFRIB",10) == 4025258222) strcat(s, "s");
if (crc32("TwDgCeiE",8) == 2622617275) strcat(s, "B");
if (crc32("smgUnTICgTwIsA",14) == 2900365491) strcat(s, "i");
if (crc32("DDvDYfD",7) == 4202578172) strcat(s, "v");
if (crc32("ekaeYnnuGNUgY",13) == 3618774437) strcat(s, "t");
if (crc32("xTamsoPH",8) == 2545606770) strcat(s, "e");
    return s;
}

char *fullcut_adjectives() {
    char *s = calloc(8);
    if (crc32("QPkaWauTn",9) == 3008465844) strcat(s, "f");
if (crc32("fbMsCWzpa",9) == 193772139) strcat(s, "r");
if (crc32("uMNsjF",6) == 1738489766) strcat(s, "u");
if (crc32("ILJPabjMAGnAJ",13) == 2522020150) strcat(s, "l");
if (crc32("qWdmJa",6) == 3433051199) strcat(s, "N");
if (crc32("pLWPk",5) == 3877252582) strcat(s, "l");
if (crc32("CsOPvKLMuOVMB",13) == 538019323) strcat(s, "c");
if (crc32("AChCro",6) == 652202299) strcat(s, "u");
if (crc32("LzttQhNQKPpbqI",14) == 1113882503) strcat(s, "j");
if (crc32("MACZavbKz",9) == 4129146599) strcat(s, "t");
    return s;
}

char *untottering_adjectives() {
    char *s = calloc(12);
    if (crc32("CMRcmjJQGdcJ",12) == 2812798641) strcat(s, "u");
if (crc32("VuIKdhL",7) == 48297325) strcat(s, "n");
if (crc32("mHkSKwNIpz",10) == 2288498571) strcat(s, "t");
if (crc32("JvxIPdSGIgG",11) == 2903593771) strcat(s, "o");
if (crc32("CwEdUdIjvaU",11) == 652693085) strcat(s, "N");
if (crc32("aBDOeYS",7) == 1262381618) strcat(s, "t");
if (crc32("jVHZRjqq",8) == 549381021) strcat(s, "o");
if (crc32("uMetBdNHaC",10) == 3829947213) strcat(s, "t");
if (crc32("jbgRCAmBQBDzgE",14) == 1023631927) strcat(s, "e");
if (crc32("phJquUKD",8) == 1341129660) strcat(s, "r");
if (crc32("bsypIn",6) == 2597772611) strcat(s, "r");
if (crc32("OeNjGYGAT",9) == 1846927394) strcat(s, "i");
if (crc32("RhXhk",5) == 1748233852) strcat(s, "d");
if (crc32("TKOqJ",5) == 2622450670) strcat(s, "n");
if (crc32("HVglYnZ",7) == 2031093648) strcat(s, "g");
    return s;
}

char *untributary_adjectives() {
    char *s = calloc(12);
    if (crc32("QLDalSlFb",9) == 1339489055) strcat(s, "u");
if (crc32("znLpxHjDMrMR",12) == 1171765788) strcat(s, "E");
if (crc32("eHNWcXfbSatPPd",14) == 430316331) strcat(s, "n");
if (crc32("CMfGdRma",8) == 3792222318) strcat(s, "t");
if (crc32("VkppIZzIoB",10) == 1103990052) strcat(s, "u");
if (crc32("dDbKm",5) == 3577445791) strcat(s, "r");
if (crc32("FMHsKcBKePekrF",14) == 158505336) strcat(s, "Q");
if (crc32("lQvFWlTRY",9) == 2569507500) strcat(s, "i");
if (crc32("ciBgEWySZOuYbX",14) == 3088400870) strcat(s, "b");
if (crc32("QxaAuclvI",9) == 2731111070) strcat(s, "d");
if (crc32("MfeEOYO",7) == 1842939731) strcat(s, "u");
if (crc32("AZeNvoJjt",9) == 2019520513) strcat(s, "n");
if (crc32("sIcSNfgN",8) == 3958683700) strcat(s, "t");
if (crc32("YHbZVBuvsuA",11) == 733847196) strcat(s, "a");
if (crc32("kUteJFb",7) == 816250874) strcat(s, "r");
if (crc32("hNZXDPpQWe",10) == 3539232053) strcat(s, "V");
if (crc32("eVtap",5) == 109949960) strcat(s, "y");
    return s;
}

char *ulnar_adjectives() {
    char *s = calloc(6);
    if (crc32("BGsmmB",6) == 1753607370) strcat(s, "u");
if (crc32("nsdaWmJ",7) == 198333203) strcat(s, "l");
if (crc32("qwSXFtBYilucCFL",15) == 3231678125) strcat(s, "n");
if (crc32("QwaTvz",6) == 477632118) strcat(s, "a");
if (crc32("jOhZblK",7) == 193492670) strcat(s, "S");
if (crc32("epGbjcsdB",9) == 2916666212) strcat(s, "r");
    return s;
}

char *unapplauding_adjectives() {
    char *s = calloc(13);
    if (crc32("XydEp",5) == 3774185027) strcat(s, "i");
if (crc32("NlUqxwRPDauP",12) == 197364841) strcat(s, "u");
if (crc32("WKsnBTrg",8) == 1125010211) strcat(s, "n");
if (crc32("DMwgSskTUCLRMff",15) == 3031935036) strcat(s, "C");
if (crc32("cEFHnOkLxZZsVC",14) == 2529086259) strcat(s, "a");
if (crc32("VCKcHuIVQay",11) == 2266086771) strcat(s, "t");
if (crc32("Iassyz",6) == 1557604124) strcat(s, "p");
if (crc32("aVCNXohk",8) == 3427340165) strcat(s, "W");
if (crc32("KLCtxqIFWuSqoa",14) == 2527494648) strcat(s, "p");
if (crc32("mFCqIUhmbCwZp",13) == 1546552454) strcat(s, "n");
if (crc32("XXjhgYifKVRL",12) == 612894483) strcat(s, "l");
if (crc32("bCBTy",5) == 3085721027) strcat(s, "S");
if (crc32("hiTfQomByXo",11) == 1302910177) strcat(s, "a");
if (crc32("ssWEW",5) == 271066450) strcat(s, "u");
if (crc32("jBUeXXP",7) == 2006440344) strcat(s, "d");
if (crc32("uhUbDHX",7) == 1156959216) strcat(s, "G");
if (crc32("uToVMVlDNNFCdFk",15) == 3570778924) strcat(s, "i");
if (crc32("KvWmexCSmgCQQrH",15) == 3589720811) strcat(s, "B");
if (crc32("luSNpNL",7) == 3415013608) strcat(s, "n");
if (crc32("RgDwzDsvJMMSpP",14) == 35707087) strcat(s, "g");
    return s;
}

char *proSouth_adjectives() {
    char *s = calloc(9);
    if (crc32("IIqMhrYT",8) == 1290167483) strcat(s, "p");
if (crc32("wxRXMM",6) == 542540688) strcat(s, "r");
if (crc32("VwxvUc",6) == 3446109172) strcat(s, "o");
if (crc32("icZgRRJVbgZq",12) == 1829899480) strcat(s, "M");
if (crc32("kxmuCrrzfiKo",12) == 1182750298) strcat(s, "S");
if (crc32("eXLZGl",6) == 2857173778) strcat(s, "o");
if (crc32("QfNbq",5) == 1803371945) strcat(s, "x");
if (crc32("CYVePSwPDJwbb",13) == 2039308668) strcat(s, "u");
if (crc32("CBZMBLefCxq",11) == 2573636425) strcat(s, "b");
if (crc32("UrOfCrKzDQdJr",13) == 2327290035) strcat(s, "t");
if (crc32("KiJFcfbD",8) == 1626226168) strcat(s, "Y");
if (crc32("CQdJgjcUm",9) == 2289558655) strcat(s, "h");
    return s;
}

char *undefendable_adjectives() {
    char *s = calloc(13);
    if (crc32("eimOvYlUsMn",11) == 2267373682) strcat(s, "u");
if (crc32("kXuko",5) == 793244178) strcat(s, "n");
if (crc32("jcAbupyWCWAkg",13) == 2616657134) strcat(s, "K");
if (crc32("rbkQAfXIN",9) == 1298113923) strcat(s, "d");
if (crc32("uQCXcABCbUGcrdx",15) == 101981499) strcat(s, "e");
if (crc32("oJNeMUyqeC",10) == 1970386294) strcat(s, "x");
if (crc32("TOChFKmbsJiR",12) == 1486217272) strcat(s, "f");
if (crc32("PigXGYqxsUi",11) == 3842749004) strcat(s, "e");
if (crc32("HrMNhdMi",8) == 2623157218) strcat(s, "C");
if (crc32("LdEJfv",6) == 4276879880) strcat(s, "n");
if (crc32("IMzRJogqSaW",11) == 3641922082) strcat(s, "d");
if (crc32("lqNaZvNI",8) == 1972188226) strcat(s, "c");
if (crc32("fLwmaNTE",8) == 2792880702) strcat(s, "a");
if (crc32("tQcYFuHQ",8) == 1854385200) strcat(s, "Q");
if (crc32("qixwIiBq",8) == 4079124247) strcat(s, "b");
if (crc32("hCDUCZWFKgch",12) == 3286492153) strcat(s, "R");
if (crc32("qvChAAtOajQpOO",14) == 2499856319) strcat(s, "l");
if (crc32("ZlHFdJbab",9) == 616994005) strcat(s, "e");
    return s;
}

char *gastrocnemial_adjectives() {
    char *s = calloc(14);
    if (crc32("rFpKfZmDj",9) == 2889273791) strcat(s, "U");
if (crc32("SszAZuQdBIIr",12) == 2135072908) strcat(s, "g");
if (crc32("ItWRTVykx",9) == 4216080452) strcat(s, "R");
if (crc32("BwgFVKQIeyf",11) == 4093866195) strcat(s, "a");
if (crc32("TSFCUT",6) == 2601441047) strcat(s, "j");
if (crc32("gdnTV",5) == 1206040239) strcat(s, "s");
if (crc32("tmkJutKKXiD",11) == 1563540868) strcat(s, "P");
if (crc32("OBMvP",5) == 1204828452) strcat(s, "t");
if (crc32("wKqLN",5) == 1499363847) strcat(s, "r");
if (crc32("fMOxaBwpEYJTUAJ",15) == 3401117904) strcat(s, "Y");
if (crc32("WUurHJCT",8) == 120470932) strcat(s, "o");
if (crc32("DVbuzwGwXBbyr",13) == 2765732238) strcat(s, "c");
if (crc32("ugNeRF",6) == 3822742330) strcat(s, "c");
if (crc32("cziCFIpAQVV",11) == 1629012907) strcat(s, "E");
if (crc32("KnvzifXk",8) == 104022095) strcat(s, "n");
if (crc32("MkLmTa",6) == 2571733029) strcat(s, "e");
if (crc32("eDvNiBSUT",9) == 225626892) strcat(s, "G");
if (crc32("ABfQZUOEbTxP",12) == 1256645036) strcat(s, "m");
if (crc32("ayTYYblwa",9) == 2749299453) strcat(s, "V");
if (crc32("EegJte",6) == 317861064) strcat(s, "i");
if (crc32("oZodwQA",7) == 291777517) strcat(s, "a");
if (crc32("ggYibSXHL",9) == 1914705987) strcat(s, "r");
if (crc32("fcapVTyLlzJyQ",13) == 2402278089) strcat(s, "l");
    return s;
}

char *bellowslike_adjectives() {
    char *s = calloc(12);
    if (crc32("iwRNuD",6) == 3979521079) strcat(s, "b");
if (crc32("ABsuePy",7) == 40721762) strcat(s, "e");
if (crc32("sNWTwm",6) == 2141384841) strcat(s, "J");
if (crc32("XjnHZSMKSOLPIIB",15) == 3847518406) strcat(s, "l");
if (crc32("ESvuCaXxiGF",11) == 3635041635) strcat(s, "C");
if (crc32("XlNtjtaTWjH",11) == 2378548802) strcat(s, "l");
if (crc32("IchkiwGlyfg",11) == 3188925708) strcat(s, "o");
if (crc32("PqDtpLcPp",9) == 4196880678) strcat(s, "h");
if (crc32("wLGfqmxWd",9) == 3150019387) strcat(s, "w");
if (crc32("lFahUah",7) == 3639681649) strcat(s, "e");
if (crc32("AJqmyhZWjYj",11) == 1671387717) strcat(s, "s");
if (crc32("TBcpJI",6) == 2082115181) strcat(s, "l");
if (crc32("yXAlTgHYd",9) == 3565959171) strcat(s, "f");
if (crc32("SuXaZHD",7) == 2004701096) strcat(s, "i");
if (crc32("CzlKtuBvTpOd",12) == 732885835) strcat(s, "F");
if (crc32("ifUkaCBrPNcWzGx",15) == 107799744) strcat(s, "k");
if (crc32("KUjGQtkg",8) == 3967067149) strcat(s, "R");
if (crc32("nVfzWzWPMlmk",12) == 2401947330) strcat(s, "e");
    return s;
}

char *Pyrrhic_adjectives() {
    char *s = calloc(8);
    if (crc32("jWyMfJWmhWg",11) == 161384947) strcat(s, "P");
if (crc32("pkBiEbYCLxKddaO",15) == 1531490435) strcat(s, "y");
if (crc32("cqnlikrhcn",10) == 2083004795) strcat(s, "H");
if (crc32("SNysBaISTdizTU",14) == 3339853523) strcat(s, "r");
if (crc32("OMXgTMqui",9) == 2084877682) strcat(s, "s");
if (crc32("xvHdI",5) == 835463356) strcat(s, "r");
if (crc32("SwefsabFwWyhqrI",15) == 4237877754) strcat(s, "W");
if (crc32("hOzYMNwFTkdCon",14) == 840748666) strcat(s, "h");
if (crc32("HzySsiLobKL",11) == 1009016073) strcat(s, "p");
if (crc32("kLTXpR",6) == 3261613473) strcat(s, "i");
if (crc32("tAxBRdzGDaGwpe",14) == 574303307) strcat(s, "a");
if (crc32("RVwlrODnzmgX",12) == 1881200588) strcat(s, "c");
    return s;
}

char *barbellate_adjectives() {
    char *s = calloc(11);
    if (crc32("bJUQtVdz",8) == 1938456303) strcat(s, "b");
if (crc32("rsyrSbTrAugzLN",14) == 2496655971) strcat(s, "y");
if (crc32("bPIkYQuvsrpp",12) == 3370705594) strcat(s, "a");
if (crc32("JIaXQGHz",8) == 1228130238) strcat(s, "r");
if (crc32("caAcDz",6) == 3591166632) strcat(s, "b");
if (crc32("hbUFIJ",6) == 2313247385) strcat(s, "e");
if (crc32("swtaflAyf",9) == 4117266170) strcat(s, "d");
if (crc32("uKOqEpPCGqfuJIi",15) == 773125346) strcat(s, "l");
if (crc32("mlGVutDsOwFjpV",14) == 1928622531) strcat(s, "b");
if (crc32("LmlJkJ",6) == 3020390919) strcat(s, "l");
if (crc32("pZQlTMdLP",9) == 4098674365) strcat(s, "a");
if (crc32("VHgkUnWjOGVK",12) == 2518609156) strcat(s, "t");
if (crc32("KttdBB",6) == 1231579144) strcat(s, "Z");
if (crc32("XpVNUY",6) == 3923016451) strcat(s, "e");
    return s;
}

char *spreathed_adjectives() {
    char *s = calloc(10);
    if (crc32("eHVHylxveLT",11) == 2976085925) strcat(s, "N");
if (crc32("lYqjKvUSPYC",11) == 2291631195) strcat(s, "s");
if (crc32("xFjDmAXNfHblyiR",15) == 1275343821) strcat(s, "p");
if (crc32("HaXYHx",6) == 4247877934) strcat(s, "r");
if (crc32("LsbMvFDzXJkV",12) == 300658253) strcat(s, "S");
if (crc32("yHlKmaGYIaEvfk",14) == 3378346196) strcat(s, "e");
if (crc32("OgYriwfrD",9) == 2407781634) strcat(s, "a");
if (crc32("zZnulcGzuzodjJ",14) == 2623067889) strcat(s, "t");
if (crc32("agVmUszAN",9) == 726227070) strcat(s, "h");
if (crc32("zBDSqpumBf",10) == 1576395825) strcat(s, "u");
if (crc32("SLzMKQTlujKaS",13) == 59854205) strcat(s, "e");
if (crc32("RttgRjoxnHyta",13) == 265419060) strcat(s, "I");
if (crc32("rTyHwKfy",8) == 2285515804) strcat(s, "d");
    return s;
}

char *quasicalm_adjectives() {
    char *s = calloc(10);
    if (crc32("JSfsYFrOLhpFa",13) == 1132591312) strcat(s, "i");
if (crc32("aUcVyTDqJW",10) == 2758402819) strcat(s, "q");
if (crc32("uwTMpuHQUvzK",12) == 3809368041) strcat(s, "u");
if (crc32("xSrylE",6) == 3090148472) strcat(s, "f");
if (crc32("wPQOPkqm",8) == 2008794284) strcat(s, "a");
if (crc32("baZQaqcgHvPvX",13) == 3392949502) strcat(s, "l");
if (crc32("UzQKkLa",7) == 765819784) strcat(s, "s");
if (crc32("SLJSy",5) == 269424448) strcat(s, "u");
if (crc32("BTrMlApsFIj",11) == 3373307394) strcat(s, "i");
if (crc32("QEYGOB",6) == 3403679187) strcat(s, "c");
if (crc32("zmRiP",5) == 207641449) strcat(s, "a");
if (crc32("TDoRppUUalu",11) == 3945816208) strcat(s, "l");
if (crc32("tGxagZpuuQfTljF",15) == 3269721823) strcat(s, "K");
if (crc32("pHvKAf",6) == 2907412642) strcat(s, "m");
    return s;
}

char *overmerciful_adjectives() {
    char *s = calloc(13);
    if (crc32("xmYWeRQ",7) == 1336250472) strcat(s, "o");
if (crc32("CAUTt",5) == 420555762) strcat(s, "v");
if (crc32("mxquZKZKSKcrSRH",15) == 2092520263) strcat(s, "C");
if (crc32("yPlNXtS",7) == 344274055) strcat(s, "e");
if (crc32("LMMpMqwMPxO",11) == 4111152313) strcat(s, "r");
if (crc32("dRXNBOQkEYebq",13) == 763632935) strcat(s, "j");
if (crc32("DCegcBJEedAqjE",14) == 4288229515) strcat(s, "m");
if (crc32("qKZcIr",6) == 789473404) strcat(s, "e");
if (crc32("oUUJEkyCewSMv",13) == 758276863) strcat(s, "p");
if (crc32("lFHIsODv",8) == 1550451552) strcat(s, "r");
if (crc32("ywgsBmGdyrNSe",13) == 1286319302) strcat(s, "c");
if (crc32("uwPluuiQLplUd",13) == 973348640) strcat(s, "Y");
if (crc32("ZbTxzzDtQngD",12) == 3645105736) strcat(s, "i");
if (crc32("ufiYtwWep",9) == 2765120448) strcat(s, "f");
if (crc32("kGkGXUvMJBhZ",12) == 1703507897) strcat(s, "u");
if (crc32("QAVjPlqC",8) == 61888443) strcat(s, "Y");
if (crc32("CckRya",6) == 2714488145) strcat(s, "l");
    return s;
}

char *unlevigated_adjectives() {
    char *s = calloc(12);
    if (crc32("kzmgBlcdbZGw",12) == 1515793393) strcat(s, "y");
if (crc32("GnfrUWmhIbNCoM",14) == 4076351426) strcat(s, "u");
if (crc32("CnPaQQQxJAMG",12) == 1266230885) strcat(s, "v");
if (crc32("DKtLVqWEJpD",11) == 1026568185) strcat(s, "n");
if (crc32("RjRrMawqRhWm",12) == 1033213355) strcat(s, "y");
if (crc32("KelCOHovdkU",11) == 1657647467) strcat(s, "l");
if (crc32("HWNRWG",6) == 68047177) strcat(s, "U");
if (crc32("CuOzsYwqKmkoof",14) == 3621964389) strcat(s, "e");
if (crc32("OWMBvHLLNYd",11) == 1246379135) strcat(s, "v");
if (crc32("rxsPPbFsDU",10) == 3555193234) strcat(s, "i");
if (crc32("YMPAKIUVH",9) == 3799207587) strcat(s, "A");
if (crc32("GSbLeOJklIj",11) == 3733281556) strcat(s, "g");
if (crc32("cBZeGmZ",7) == 3934366553) strcat(s, "t");
if (crc32("DXdXHgRmUS",10) == 628502538) strcat(s, "a");
if (crc32("KPntwhQAZZfkNec",15) == 3295251811) strcat(s, "t");
if (crc32("lzSIZliPj",9) == 2681628544) strcat(s, "d");
if (crc32("zwDBrBFCJo",10) == 2541826977) strcat(s, "e");
if (crc32("sHGYo",5) == 3847298113) strcat(s, "d");
    return s;
}

char *unfervent_adjectives() {
    char *s = calloc(10);
    if (crc32("UQJYLl",6) == 2231412470) strcat(s, "q");
if (crc32("CKEtCa",6) == 167679410) strcat(s, "u");
if (crc32("RbNODwi",7) == 1798124579) strcat(s, "n");
if (crc32("nfjBvaYHQG",10) == 1427654319) strcat(s, "o");
if (crc32("UJzdSPskjbda",12) == 3033185284) strcat(s, "f");
if (crc32("lqeHo",5) == 3172740551) strcat(s, "t");
if (crc32("iJSgbjFUD",9) == 3697008412) strcat(s, "e");
if (crc32("NnfeJe",6) == 3314389215) strcat(s, "r");
if (crc32("uzesZAVm",8) == 634070024) strcat(s, "v");
if (crc32("vhiBzGBaKzz",11) == 3330005558) strcat(s, "e");
if (crc32("RcoKCWxrbONH",12) == 3349102730) strcat(s, "n");
if (crc32("RHTjCLItNsecRzw",15) == 2352450141) strcat(s, "t");
    return s;
}

char *metempsychosic_adjectives() {
    char *s = calloc(15);
    if (crc32("QrJge",5) == 893913823) strcat(s, "f");
if (crc32("PScrgmcpOxnorA",14) == 610649934) strcat(s, "m");
if (crc32("TgUTKKWIMKl",11) == 419791656) strcat(s, "e");
if (crc32("BiQjkL",6) == 1442555314) strcat(s, "r");
if (crc32("IpzSxABsmTwuoqb",15) == 287826783) strcat(s, "t");
if (crc32("MgZdgqoHhe",10) == 1470117435) strcat(s, "e");
if (crc32("GuuXYLWBkvkbPN",14) == 1163548291) strcat(s, "m");
if (crc32("KyNVe",5) == 203394766) strcat(s, "Y");
if (crc32("WXekXrxyqfzE",12) == 3129731499) strcat(s, "p");
if (crc32("oCaBI",5) == 3501954550) strcat(s, "s");
if (crc32("KoeVxsY",7) == 1223462267) strcat(s, "O");
if (crc32("RAUbQmjhlw",10) == 627813452) strcat(s, "y");
if (crc32("RjxKUZiDrwLwyZ",14) == 3190338844) strcat(s, "x");
if (crc32("XjEvqFE",7) == 265822992) strcat(s, "c");
if (crc32("MkosRzNlcZANuoJ",15) == 2001991183) strcat(s, "c");
if (crc32("kNrBVkk",7) == 2816006106) strcat(s, "h");
if (crc32("DxXXIReFlmbIkY",14) == 3893359303) strcat(s, "w");
if (crc32("xIwdbxWQtrFyiS",14) == 1992365964) strcat(s, "o");
if (crc32("sKcZtyPrYzyWqlC",15) == 3008546855) strcat(s, "m");
if (crc32("xFixIOzwlq",10) == 4064099675) strcat(s, "s");
if (crc32("FFdRXaNPlcuwb",13) == 3111545836) strcat(s, "i");
if (crc32("rlpWiAigusBrKoF",15) == 637213935) strcat(s, "A");
if (crc32("yDXeqzuYkqTJC",13) == 147653413) strcat(s, "c");
    return s;
}

char *unadornable_adjectives() {
    char *s = calloc(12);
    if (crc32("gRMKtl",6) == 2106515458) strcat(s, "A");
if (crc32("JLnASIH",7) == 929129517) strcat(s, "u");
if (crc32("JkhBwHsNcpCJaR",14) == 1699701439) strcat(s, "l");
if (crc32("shIPoG",6) == 357267484) strcat(s, "n");
if (crc32("wLIskUWbD",9) == 2800011264) strcat(s, "V");
if (crc32("JmnybTKtsT",10) == 2230966703) strcat(s, "a");
if (crc32("NqyoVI",6) == 1869791625) strcat(s, "V");
if (crc32("wECriWzwTGCo",12) == 3636351271) strcat(s, "d");
if (crc32("OLWKmsyIktBX",12) == 369047567) strcat(s, "o");
if (crc32("CjbzdFuCKNtOr",13) == 866016426) strcat(s, "r");
if (crc32("DGkaGnS",7) == 784646104) strcat(s, "n");
if (crc32("prnNLJdnIRl",11) == 3240161807) strcat(s, "x");
if (crc32("ALtSINqAXd",10) == 3313596196) strcat(s, "a");
if (crc32("oBFIWRN",7) == 3200028412) strcat(s, "b");
if (crc32("jbhdoQX",7) == 1862993810) strcat(s, "b");
if (crc32("mqLAfezwlxKvy",13) == 3071207236) strcat(s, "X");
if (crc32("xWcIOYYu",8) == 3429563203) strcat(s, "l");
if (crc32("qgTRINRQ",8) == 2533098383) strcat(s, "e");
    return s;
}

char *octupled_adjectives() {
    char *s = calloc(9);
    if (crc32("FrsELqEbELq",11) == 1088627500) strcat(s, "o");
if (crc32("ipyQFYXBY",9) == 3613043317) strcat(s, "c");
if (crc32("WRaqEmCJgCSOG",13) == 1181319276) strcat(s, "P");
if (crc32("NOPYv",5) == 1546995194) strcat(s, "t");
if (crc32("PAjiRzSIEBfIk",13) == 2137037773) strcat(s, "u");
if (crc32("CzDgNyhUXZRAzai",15) == 2891318796) strcat(s, "p");
if (crc32("iCLggGEC",8) == 2299201690) strcat(s, "h");
if (crc32("poxHkpjy",8) == 895728694) strcat(s, "l");
if (crc32("eOweUEzQUYsqjSA",15) == 2849648243) strcat(s, "e");
if (crc32("qwNnoeqbZg",10) == 3405303226) strcat(s, "w");
if (crc32("RIxzFLIy",8) == 943465003) strcat(s, "d");
    return s;
}

char *unpoeticised_adjectives() {
    char *s = calloc(13);
    if (crc32("iHsgJms",7) == 124615355) strcat(s, "L");
if (crc32("ZqCUWqQHBuqWHJN",15) == 3314394051) strcat(s, "u");
if (crc32("NoiBQnWIoXdRrV",14) == 2961052645) strcat(s, "n");
if (crc32("jVYxFRKM",8) == 4278552244) strcat(s, "L");
if (crc32("ibHlNXGhY",9) == 2951291511) strcat(s, "p");
if (crc32("RACWguMZ",8) == 2835403429) strcat(s, "o");
if (crc32("vatWfSdGv",9) == 3761837043) strcat(s, "f");
if (crc32("rERcurLSmA",10) == 2653152517) strcat(s, "e");
if (crc32("igXqqrwLEW",10) == 2393073168) strcat(s, "t");
if (crc32("JpTAxnueBQY",11) == 1897587477) strcat(s, "i");
if (crc32("wWDPa",5) == 748148063) strcat(s, "c");
if (crc32("hdcaMzgLenlF",12) == 3084858646) strcat(s, "L");
if (crc32("yDFfmP",6) == 2038560590) strcat(s, "i");
if (crc32("kQwUlJPs",8) == 4104110394) strcat(s, "s");
if (crc32("TjzBkf",6) == 1924761755) strcat(s, "T");
if (crc32("axkHBhBqlKBK",12) == 3140694313) strcat(s, "e");
if (crc32("xhiWiHTU",8) == 1125003816) strcat(s, "T");
if (crc32("OECqRncX",8) == 3338609898) strcat(s, "d");
    return s;
}

char *leftlaid_adjectives() {
    char *s = calloc(9);
    if (crc32("fSvEMYOCXDgODw",14) == 2123847324) strcat(s, "z");
if (crc32("tovjYeAweUjVx",13) == 393412385) strcat(s, "l");
if (crc32("FiBSV",5) == 1400157837) strcat(s, "V");
if (crc32("NdVTuISnzMmgeGo",15) == 2163782322) strcat(s, "e");
if (crc32("crzigFiYIgxoF",13) == 3100682090) strcat(s, "c");
if (crc32("AWhQzFEwSRMTpD",14) == 2118588298) strcat(s, "f");
if (crc32("LqIPLYYTXSkd",12) == 3809818442) strcat(s, "t");
if (crc32("yflYd",5) == 3198721232) strcat(s, "v");
if (crc32("TCDSRhIyC",9) == 2262420852) strcat(s, "l");
if (crc32("CGxeAsfwkXgI",12) == 921533831) strcat(s, "a");
if (crc32("rInDhzyKlFtNOBw",15) == 252155916) strcat(s, "z");
if (crc32("erxvnKgE",8) == 2617344025) strcat(s, "i");
if (crc32("liFawXdAncUk",12) == 3368512609) strcat(s, "m");
if (crc32("qVoXOCpQkDwTuzf",15) == 3431320563) strcat(s, "d");
    return s;
}

char *taenidial_adjectives() {
    char *s = calloc(10);
    if (crc32("sptxOhT",7) == 3368789194) strcat(s, "f");
if (crc32("CRvChycGm",9) == 1774067904) strcat(s, "t");
if (crc32("tNtSs",5) == 2286118157) strcat(s, "A");
if (crc32("kqckGb",6) == 1725313759) strcat(s, "a");
if (crc32("metLXHdJeaDjR",13) == 1631823005) strcat(s, "e");
if (crc32("hEaNhjOP",8) == 4079785802) strcat(s, "n");
if (crc32("BVGXomgd",8) == 1434667256) strcat(s, "r");
if (crc32("pLtyDGVEADTPUu",14) == 2954878979) strcat(s, "i");
if (crc32("ynhmhuYpJDCz",12) == 674956944) strcat(s, "d");
if (crc32("EYYNFaSVuNzTTmE",15) == 3920511545) strcat(s, "i");
if (crc32("dPrXjpeJpUqGg",13) == 2659991819) strcat(s, "m");
if (crc32("QSqTzYiu",8) == 281110766) strcat(s, "a");
if (crc32("lhwUNDzu",8) == 1158417152) strcat(s, "l");
    return s;
}

char *subbronchial_adjectives() {
    char *s = calloc(13);
    if (crc32("mtWYQ",5) == 1564200032) strcat(s, "s");
if (crc32("NikrBLIe",8) == 354419472) strcat(s, "b");
if (crc32("MhUsH",5) == 2394012613) strcat(s, "u");
if (crc32("RRbgeromF",9) == 955582131) strcat(s, "b");
if (crc32("uNLRhhJdpw",10) == 940451444) strcat(s, "b");
if (crc32("jAzigSi",7) == 1803706165) strcat(s, "r");
if (crc32("nDezZHFpX",9) == 3201513872) strcat(s, "o");
if (crc32("NKWuLkPpZIkJ",12) == 2134262639) strcat(s, "n");
if (crc32("OWHcWKg",7) == 3592221636) strcat(s, "c");
if (crc32("pmZHWoIlAil",11) == 370703408) strcat(s, "h");
if (crc32("QhvpAPAjUaCJHSZ",15) == 2053148405) strcat(s, "i");
if (crc32("RhGQIR",6) == 2527450180) strcat(s, "a");
if (crc32("fMlkQSiVJ",9) == 1728723924) strcat(s, "T");
if (crc32("eurpXNiDevlxp",13) == 1721004679) strcat(s, "l");
    return s;
}

char *parallelepipedous_adjectives() {
    char *s = calloc(18);
    if (crc32("zAdUs",5) == 402053696) strcat(s, "p");
if (crc32("MdjOerEZDc",10) == 743250401) strcat(s, "a");
if (crc32("CmqSAzNBmemyyj",14) == 1215345405) strcat(s, "F");
if (crc32("BLlwZ",5) == 2682158638) strcat(s, "r");
if (crc32("RgkkYRdoDvAl",12) == 3120780453) strcat(s, "a");
if (crc32("FpZyE",5) == 3821938350) strcat(s, "l");
if (crc32("PbnHXE",6) == 3292936583) strcat(s, "t");
if (crc32("fstmnLvRSAfT",12) == 2815932896) strcat(s, "l");
if (crc32("ogxgOhDAElW",11) == 1224398789) strcat(s, "B");
if (crc32("hjrznTHgDGcQAg",14) == 3671430336) strcat(s, "e");
if (crc32("ohptJpBOWsuJiMh",15) == 3469326983) strcat(s, "l");
if (crc32("FuhYqnHCyU",10) == 3562156006) strcat(s, "T");
if (crc32("wWMRFAzrj",9) == 1419841837) strcat(s, "e");
if (crc32("LOnGaRsjv",9) == 3090965627) strcat(s, "E");
if (crc32("IzmAsrCmAWxPLi",14) == 1967016154) strcat(s, "p");
if (crc32("YUOxXbt",7) == 1632005821) strcat(s, "i");
if (crc32("DYTjeMZhrQAho",13) == 3951849181) strcat(s, "p");
if (crc32("CspikzMIugvXHH",14) == 2707006922) strcat(s, "l");
if (crc32("rXhuxbCOh",9) == 1139840193) strcat(s, "e");
if (crc32("OxEWHKnfLjl",11) == 1093476739) strcat(s, "G");
if (crc32("HakqeHm",7) == 1375627289) strcat(s, "d");
if (crc32("PEZZDxwyo",9) == 1637319127) strcat(s, "w");
if (crc32("KQMRgiDhgeD",11) == 3863877768) strcat(s, "o");
if (crc32("awfuYrxRh",9) == 3711882900) strcat(s, "u");
if (crc32("QnaFdPJE",8) == 3645390812) strcat(s, "R");
if (crc32("ifUQdCijIA",10) == 3596467363) strcat(s, "s");
    return s;
}

char *sacramental_adjectives() {
    char *s = calloc(12);
    if (crc32("ZYaucmppp",9) == 19377745) strcat(s, "s");
if (crc32("tnQdXN",6) == 3625621416) strcat(s, "a");
if (crc32("WDXywFOqzdeQq",13) == 1146907611) strcat(s, "c");
if (crc32("oIItXDFdTmN",11) == 450166769) strcat(s, "g");
if (crc32("nehYM",5) == 3372775592) strcat(s, "r");
if (crc32("dwRSPHkHQvwM",12) == 302675806) strcat(s, "a");
if (crc32("AkpJN",5) == 2157270446) strcat(s, "m");
if (crc32("VlzaQKXMajZ",11) == 2499947917) strcat(s, "e");
if (crc32("GjWfYreJIuD",11) == 1480560205) strcat(s, "h");
if (crc32("nqkdOUXTakzsqOX",15) == 226707200) strcat(s, "n");
if (crc32("lUoNLJOCQ",9) == 78881165) strcat(s, "C");
if (crc32("vTylXXCidIlsMnx",15) == 854222733) strcat(s, "t");
if (crc32("jMnCZRFV",8) == 3357096190) strcat(s, "e");
if (crc32("AKOueTqNqTF",11) == 439577078) strcat(s, "a");
if (crc32("wlGTSlxI",8) == 2195257869) strcat(s, "f");
if (crc32("EcglgfqvIu",10) == 3915876651) strcat(s, "l");
    return s;
}

char *lexicologic_adjectives() {
    char *s = calloc(12);
    if (crc32("ALmmBxVvAwNQm",13) == 55825117) strcat(s, "o");
if (crc32("QlMfgEjqZ",9) == 2149036392) strcat(s, "l");
if (crc32("WlPnUw",6) == 557472790) strcat(s, "o");
if (crc32("GTTJZvOXvDH",11) == 2168631900) strcat(s, "e");
if (crc32("jtvLbrUn",8) == 3620383310) strcat(s, "x");
if (crc32("dDWZajHZyIbr",12) == 1167906169) strcat(s, "I");
if (crc32("pRdpQVupQWaBbI",14) == 1033643577) strcat(s, "i");
if (crc32("kPryIJQBhi",10) == 332029860) strcat(s, "X");
if (crc32("onBEw",5) == 919114176) strcat(s, "c");
if (crc32("nAtswgyIsy",10) == 2034958460) strcat(s, "e");
if (crc32("rqaeOFOzqJH",11) == 2509275275) strcat(s, "o");
if (crc32("cBHOvbDK",8) == 2655061214) strcat(s, "o");
if (crc32("BvdXziphVkOMrTZ",15) == 35323964) strcat(s, "l");
if (crc32("gYfTgrq",7) == 3715262793) strcat(s, "o");
if (crc32("UDavNlExAw",10) == 256174141) strcat(s, "y");
if (crc32("skPQdwKnAmmWNsq",15) == 4161232663) strcat(s, "g");
if (crc32("mOHrqEGg",8) == 529836990) strcat(s, "w");
if (crc32("iuEudL",6) == 788541730) strcat(s, "i");
if (crc32("CZniGDCvfg",10) == 750172980) strcat(s, "c");
    return s;
}

char *wellread_adjectives() {
    char *s = calloc(9);
    if (crc32("DRDwzXdIMWZD",12) == 2981491389) strcat(s, "w");
if (crc32("HRtnQclVyTldscw",15) == 1474282135) strcat(s, "u");
if (crc32("WbgCIP",6) == 3712410714) strcat(s, "e");
if (crc32("vqZajNF",7) == 4263803865) strcat(s, "J");
if (crc32("okemqxedGHIGJ",13) == 1243772000) strcat(s, "l");
if (crc32("dirbKqqG",8) == 1292874022) strcat(s, "l");
if (crc32("SeVTNVgUG",9) == 2307803007) strcat(s, "r");
if (crc32("BTadBrskkLmkWWu",15) == 3852096586) strcat(s, "v");
if (crc32("QCGlvME",7) == 423369192) strcat(s, "e");
if (crc32("IJhKeJRgujKUP",13) == 866062538) strcat(s, "K");
if (crc32("msbqt",5) == 4095060303) strcat(s, "a");
if (crc32("dDBDz",5) == 1415414008) strcat(s, "H");
if (crc32("ofdFOcC",7) == 909196266) strcat(s, "d");
    return s;
}

char *graphomotor_adjectives() {
    char *s = calloc(12);
    if (crc32("UPaqKrdZv",9) == 1051490560) strcat(s, "g");
if (crc32("HtlNQRMLoIxInN",14) == 1554664176) strcat(s, "r");
if (crc32("XujQuwAH",8) == 1838652236) strcat(s, "a");
if (crc32("hFWil",5) == 1222052312) strcat(s, "p");
if (crc32("KTbbzyfRbEqZXO",14) == 922458757) strcat(s, "h");
if (crc32("uzIiBbstmt",10) == 2388812261) strcat(s, "F");
if (crc32("pmYXvvasTtT",11) == 712345264) strcat(s, "o");
if (crc32("GCABSZdlibb",11) == 3775841211) strcat(s, "I");
if (crc32("lwzuI",5) == 1747348597) strcat(s, "m");
if (crc32("sawgzYoTIWI",11) == 561322961) strcat(s, "W");
if (crc32("gVJnLogPkHj",11) == 1676447935) strcat(s, "o");
if (crc32("TatIuyE",7) == 582579289) strcat(s, "T");
if (crc32("MuLglJaUbC",10) == 1046425038) strcat(s, "t");
if (crc32("ewnYNDYuaGXVY",13) == 574702390) strcat(s, "M");
if (crc32("LRjobJhRM",9) == 3468147253) strcat(s, "o");
if (crc32("LTXwOqtQinDaCC",14) == 1888413910) strcat(s, "G");
if (crc32("tQjNJzQONfy",11) == 1783409149) strcat(s, "r");
    return s;
}

char *cutrate_adjectives() {
    char *s = calloc(8);
    if (crc32("lqgfdfCpMSdsh",13) == 2817308450) strcat(s, "T");
if (crc32("cnZgYmqmKvLih",13) == 1355779017) strcat(s, "c");
if (crc32("bSqahhvq",8) == 1741476274) strcat(s, "u");
if (crc32("GQPHI",5) == 3303736023) strcat(s, "b");
if (crc32("hhKDnIgOMxvvaED",15) == 1806891655) strcat(s, "t");
if (crc32("wCHRqYiYoFeGP",13) == 4180213363) strcat(s, "r");
if (crc32("mBikAgcT",8) == 2353116264) strcat(s, "x");
if (crc32("FSKZZTdjz",9) == 769763192) strcat(s, "a");
if (crc32("HmxGfqSBpNFaUdi",15) == 293853682) strcat(s, "s");
if (crc32("fFfjCLxxV",9) == 2518059458) strcat(s, "t");
if (crc32("dQmxfDIxCIN",11) == 1241611610) strcat(s, "e");
    return s;
}

char *semifictionalized_adjectives() {
    char *s = calloc(18);
    if (crc32("GHfpoNG",7) == 1196360796) strcat(s, "s");
if (crc32("DxNpxWyq",8) == 776476613) strcat(s, "c");
if (crc32("nTyVmIauk",9) == 1180761481) strcat(s, "e");
if (crc32("pJKgu",5) == 3347612427) strcat(s, "y");
if (crc32("tBetrdJwaAe",11) == 273351302) strcat(s, "m");
if (crc32("iUVtJXlsS",9) == 1895707187) strcat(s, "i");
if (crc32("UzmEGfqiNq",10) == 3093447435) strcat(s, "E");
if (crc32("VpuRsFx",7) == 674717984) strcat(s, "f");
if (crc32("nEnESuZgxB",10) == 1012953779) strcat(s, "n");
if (crc32("qsvufKK",7) == 3463415563) strcat(s, "i");
if (crc32("YBRshHpYkMYcRj",14) == 2499715156) strcat(s, "c");
if (crc32("wUnwcrGebj",10) == 2624948469) strcat(s, "t");
if (crc32("rXnjIfOeQrKNn",13) == 3648638904) strcat(s, "i");
if (crc32("QKjvY",5) == 2715203468) strcat(s, "o");
if (crc32("YJeYreEoF",9) == 3434949238) strcat(s, "L");
if (crc32("CNhqaNojBYAEyE",14) == 1856222810) strcat(s, "n");
if (crc32("SJWDnLEXp",9) == 3301371801) strcat(s, "a");
if (crc32("yDmnnGDZh",9) == 4063822183) strcat(s, "a");
if (crc32("wXdsafQLZNi",11) == 695192578) strcat(s, "l");
if (crc32("cVylQYBGfSdOiG",14) == 997058327) strcat(s, "i");
if (crc32("cylxoQLhvtyldjb",15) == 834514980) strcat(s, "z");
if (crc32("NIFFCRNFfgUWF",13) == 3306442917) strcat(s, "e");
if (crc32("WeuLsmvuxRcWNB",14) == 2546795008) strcat(s, "d");
    return s;
}

char *porous_adjectives() {
    char *s = calloc(7);
    if (crc32("yQvJVBDPOH",10) == 2306062912) strcat(s, "p");
if (crc32("MSzDqXACPMBYV",13) == 4098207669) strcat(s, "o");
if (crc32("DEJMndRevN",10) == 3825893594) strcat(s, "r");
if (crc32("XKFjzXaE",8) == 3004383245) strcat(s, "o");
if (crc32("sNrUIEnwV",9) == 1838288074) strcat(s, "u");
if (crc32("HXPqkSANYQLMxRR",15) == 1086548314) strcat(s, "M");
if (crc32("RunmdjKMlRhG",12) == 2737697337) strcat(s, "s");
    return s;
}

char *overlong_adjectives() {
    char *s = calloc(9);
    if (crc32("KxaIMY",6) == 3853117229) strcat(s, "y");
if (crc32("FUFPIdOXH",9) == 3977663834) strcat(s, "o");
if (crc32("ILxytGaAwF",10) == 3366263897) strcat(s, "v");
if (crc32("PylkJUaIUxYJg",13) == 2761255402) strcat(s, "E");
if (crc32("jeITm",5) == 2345118778) strcat(s, "e");
if (crc32("fjkjcoAgGkassiZ",15) == 1875799070) strcat(s, "r");
if (crc32("btZJeYjlZ",9) == 1971443639) strcat(s, "l");
if (crc32("LPpFRW",6) == 3023650112) strcat(s, "h");
if (crc32("SybnVjIIDCGSlIA",15) == 3668001885) strcat(s, "o");
if (crc32("YawxVbaknFs",11) == 123689995) strcat(s, "F");
if (crc32("LhEXKFbEzAVn",12) == 2692780795) strcat(s, "n");
if (crc32("hHwfvIaKDU",10) == 3231811361) strcat(s, "K");
if (crc32("IGuUgO",6) == 2299487178) strcat(s, "g");
    return s;
}

char *local_adjectives() {
    char *s = calloc(6);
    if (crc32("sdOJVdhpRW",10) == 3208552454) strcat(s, "k");
if (crc32("DDkXEn",6) == 569700165) strcat(s, "l");
if (crc32("TBAcIMt",7) == 3570043734) strcat(s, "z");
if (crc32("YHlZoZEIIBhHj",13) == 2371450167) strcat(s, "o");
if (crc32("bdNCnkY",7) == 2864014099) strcat(s, "c");
if (crc32("ulMdKGAbfXkYIy",14) == 296659308) strcat(s, "a");
if (crc32("HgBybTKPNKn",11) == 3688365305) strcat(s, "l");
    return s;
}

char *unstrengthened_adjectives() {
    char *s = calloc(15);
    if (crc32("VAhtNEiQv",9) == 1984642832) strcat(s, "p");
if (crc32("tQIKXPIE",8) == 2330384466) strcat(s, "u");
if (crc32("WIfjhNYSOfKqd",13) == 2344812486) strcat(s, "n");
if (crc32("BPbruulRsJeMtrB",15) == 2012550765) strcat(s, "j");
if (crc32("badhJQ",6) == 3033951534) strcat(s, "s");
if (crc32("nNFwdnfTLtxv",12) == 2034404896) strcat(s, "t");
if (crc32("HZQLyYCMyWg",11) == 3243470741) strcat(s, "n");
if (crc32("hNTEhWXpaG",10) == 1345784993) strcat(s, "r");
if (crc32("pYxacwgRuBxpPwz",15) == 2318059175) strcat(s, "H");
if (crc32("JxJTcIIqTqTHdgv",15) == 4198467212) strcat(s, "e");
if (crc32("TmnWaTXDfuqKl",13) == 2139011684) strcat(s, "n");
if (crc32("YnRGf",5) == 735527479) strcat(s, "o");
if (crc32("YwvvTcCDqND",11) == 2378192418) strcat(s, "g");
if (crc32("AvGakWcVjq",10) == 219593175) strcat(s, "b");
if (crc32("iICNAwqzekMg",12) == 1634287413) strcat(s, "t");
if (crc32("vubUergW",8) == 1807455806) strcat(s, "k");
if (crc32("kbXOaQ",6) == 636922915) strcat(s, "h");
if (crc32("eBituVKyxreW",12) == 101896273) strcat(s, "L");
if (crc32("SsCJWnpdcNB",11) == 3980712819) strcat(s, "e");
if (crc32("JEPZlFEGCpqGeKI",15) == 2958602729) strcat(s, "q");
if (crc32("ROWrhLggK",9) == 337818936) strcat(s, "n");
if (crc32("vtJBTy",6) == 3994613041) strcat(s, "n");
if (crc32("dKXhIER",7) == 115026710) strcat(s, "e");
if (crc32("fxEXfthmKHl",11) == 1007561157) strcat(s, "d");
    return s;
}

char *genomic_adjectives() {
    char *s = calloc(8);
    if (crc32("uRSpHNGNyFQeK",13) == 1545528370) strcat(s, "g");
if (crc32("NkUAQtgDaWA",11) == 3673436235) strcat(s, "n");
if (crc32("ODvzpO",6) == 1020383394) strcat(s, "e");
if (crc32("xvYBqOL",7) == 3822609559) strcat(s, "d");
if (crc32("pYYzQtnsd",9) == 2912748987) strcat(s, "n");
if (crc32("NqBzwDmiJ",9) == 4134441239) strcat(s, "v");
if (crc32("GasezhLdRdyZCO",14) == 876198700) strcat(s, "o");
if (crc32("BsOPaJegwHf",11) == 714474572) strcat(s, "m");
if (crc32("apQjAk",6) == 2387311926) strcat(s, "m");
if (crc32("hSDzqjidXMA",11) == 2343440263) strcat(s, "j");
if (crc32("XFIpdhYTqeBK",12) == 1499935188) strcat(s, "i");
if (crc32("XjUWKbeICl",10) == 1837297196) strcat(s, "J");
if (crc32("gVkxAi",6) == 2024360568) strcat(s, "c");
    return s;
}

char *nonadapting_adjectives() {
    char *s = calloc(12);
    if (crc32("nIRzNTEgWtDtU",13) == 440612009) strcat(s, "n");
if (crc32("wwLlebAA",8) == 1630727715) strcat(s, "o");
if (crc32("TuvBZJGkBDgtPnz",15) == 2877034722) strcat(s, "M");
if (crc32("TKkYXxqmjrrCbfL",15) == 2055992818) strcat(s, "n");
if (crc32("ODoTiyWeinNuNi",14) == 1826882126) strcat(s, "N");
if (crc32("CMDtjkGGLDJAEcj",15) == 299276080) strcat(s, "a");
if (crc32("UiOMrGsZuvZuFWz",15) == 3619883029) strcat(s, "d");
if (crc32("ZwSUZpxJeUI",11) == 2219236157) strcat(s, "a");
if (crc32("bywbDsTlJZA",11) == 3531406054) strcat(s, "p");
if (crc32("lesjxoyhfOSMET",14) == 1760445968) strcat(s, "J");
if (crc32("bjWFUM",6) == 3390059083) strcat(s, "t");
if (crc32("owfDrtTdtT",10) == 2537052434) strcat(s, "i");
if (crc32("cbyGdMLYYqeI",12) == 1414950462) strcat(s, "n");
if (crc32("MnaGBsLCYI",10) == 3121065935) strcat(s, "g");
    return s;
}

char *trichogynic_adjectives() {
    char *s = calloc(12);
    if (crc32("biHsOhCCKulG",12) == 834808198) strcat(s, "t");
if (crc32("aCDXktZPh",9) == 4221442808) strcat(s, "S");
if (crc32("dqCiLssxmLaSknk",15) == 544725397) strcat(s, "r");
if (crc32("cILzjyMAyjgy",12) == 1955441733) strcat(s, "I");
if (crc32("kBXBccWBT",9) == 831920095) strcat(s, "i");
if (crc32("XLLiMZuHeA",10) == 3954125991) strcat(s, "c");
if (crc32("eDAqplqx",8) == 3051422322) strcat(s, "x");
if (crc32("eoGaMaxCXW",10) == 363432508) strcat(s, "h");
if (crc32("AnyuaQX",7) == 1791494477) strcat(s, "o");
if (crc32("wjFEMGEgphsRQ",13) == 2259245689) strcat(s, "g");
if (crc32("jvMdjfYTRZfRWjB",15) == 1354750134) strcat(s, "y");
if (crc32("bsTqwXQP",8) == 625863499) strcat(s, "n");
if (crc32("SrMPSdJY",8) == 799030516) strcat(s, "g");
if (crc32("gKSeSYG",7) == 680675159) strcat(s, "i");
if (crc32("dmGbPpLhLABn",12) == 1254958912) strcat(s, "k");
if (crc32("ADSrq",5) == 3812000697) strcat(s, "c");
    return s;
}

char *suspectless_adjectives() {
    char *s = calloc(12);
    if (crc32("Wpziqe",6) == 300094484) strcat(s, "s");
if (crc32("JQnQBCwVEkTGk",13) == 2914737313) strcat(s, "u");
if (crc32("izKuRgEStcYsq",13) == 3531190081) strcat(s, "s");
if (crc32("QNVQTtUkjTVN",12) == 2958528653) strcat(s, "p");
if (crc32("BzglePLdCxj",11) == 534363885) strcat(s, "Q");
if (crc32("gShKNdaCBtccXFQ",15) == 2625237889) strcat(s, "e");
if (crc32("UJhRzQOIP",9) == 1850448416) strcat(s, "c");
if (crc32("HnvIfegjBdqqQtY",15) == 3084957026) strcat(s, "t");
if (crc32("XSpalDKURKeaJHY",15) == 481498251) strcat(s, "l");
if (crc32("gJbqWJ",6) == 4208097133) strcat(s, "d");
if (crc32("jWdqetet",8) == 2236538218) strcat(s, "e");
if (crc32("WlHXUHZYdX",10) == 2137783855) strcat(s, "s");
if (crc32("UxuVxqKfwBFpEQD",15) == 1991221730) strcat(s, "t");
if (crc32("lKSomtdhjCCBG",13) == 119315531) strcat(s, "s");
    return s;
}

char *clypeal_adjectives() {
    char *s = calloc(8);
    if (crc32("OUbFtxtmSc",10) == 700933952) strcat(s, "C");
if (crc32("iHxfJxRP",8) == 1640807733) strcat(s, "c");
if (crc32("BKTRDTFAiUJV",12) == 3701973198) strcat(s, "l");
if (crc32("SkOVemBCjbFgK",13) == 3909379936) strcat(s, "y");
if (crc32("yKBXEnTt",8) == 594612470) strcat(s, "A");
if (crc32("DuVZf",5) == 3137632907) strcat(s, "p");
if (crc32("XRcxkjnQWGpbd",13) == 3236509901) strcat(s, "H");
if (crc32("FUKtkRguONlQQz",14) == 1954616750) strcat(s, "e");
if (crc32("teaPYzcRge",10) == 4053153997) strcat(s, "G");
if (crc32("WTHpSWLLFA",10) == 2390724456) strcat(s, "a");
if (crc32("bvBGOrj",7) == 1036575230) strcat(s, "S");
if (crc32("ZXzSkFg",7) == 2713289606) strcat(s, "l");
    return s;
}

char *religiose_adjectives() {
    char *s = calloc(10);
    if (crc32("mncuLLIakJV",11) == 90632545) strcat(s, "r");
if (crc32("iPeSFNXnDsZQb",13) == 3478953565) strcat(s, "r");
if (crc32("cPaMpn",6) == 2036115648) strcat(s, "e");
if (crc32("CIwzGNjSAry",11) == 345774972) strcat(s, "l");
if (crc32("bRvttFth",8) == 3355019020) strcat(s, "r");
if (crc32("VoWOBUsJvOjJz",13) == 384552989) strcat(s, "i");
if (crc32("weIdHPr",7) == 1996776546) strcat(s, "g");
if (crc32("yDSvvmCM",8) == 2431966784) strcat(s, "V");
if (crc32("ERJauprsZ",9) == 3288904023) strcat(s, "i");
if (crc32("YiZqVplhfeP",11) == 1351113409) strcat(s, "Y");
if (crc32("PLYotNNxUnqb",12) == 3069965465) strcat(s, "o");
if (crc32("zclaNABw",8) == 1060476020) strcat(s, "s");
if (crc32("UCeDPZ",6) == 4252953165) strcat(s, "y");
if (crc32("YvOjbcEnpsLhCB",14) == 3651357914) strcat(s, "e");
    return s;
}

char *propretorian_adjectives() {
    char *s = calloc(13);
    if (crc32("xhtVqbkdf",9) == 3637733703) strcat(s, "p");
if (crc32("FlmoEdZiB",9) == 3063392036) strcat(s, "r");
if (crc32("HeErSclZjiQ",11) == 3656952395) strcat(s, "h");
if (crc32("sfwxiqfQtxWBHUt",15) == 2141097891) strcat(s, "o");
if (crc32("LQDSltFltTi",11) == 2054388904) strcat(s, "p");
if (crc32("zHzAUUZ",7) == 2159075980) strcat(s, "r");
if (crc32("lNYZGmmPkkmEXh",14) == 2962087444) strcat(s, "e");
if (crc32("fQvyraH",7) == 2028850717) strcat(s, "P");
if (crc32("IyMFWOiFKoGin",13) == 80793835) strcat(s, "t");
if (crc32("sWYXCW",6) == 731388983) strcat(s, "G");
if (crc32("fqrlyZILrJHZMSR",15) == 1701512208) strcat(s, "o");
if (crc32("xGQaFUdONHi",11) == 2298419017) strcat(s, "r");
if (crc32("BCMkTPZGILW",11) == 1598563131) strcat(s, "m");
if (crc32("IOqUgkwpBGTV",12) == 379340753) strcat(s, "i");
if (crc32("EoQbbgcbRTn",11) == 4050352954) strcat(s, "l");
if (crc32("kiKhnSLeSiv",11) == 3380789864) strcat(s, "a");
if (crc32("VRfbLWQuR",9) == 747795672) strcat(s, "n");
    return s;
}

char *multisacculate_adjectives() {
    char *s = calloc(15);
    if (crc32("qcBEYR",6) == 108952322) strcat(s, "m");
if (crc32("PgqVYu",6) == 1727722588) strcat(s, "u");
if (crc32("ejTzDSdTPtXftbt",15) == 3985380804) strcat(s, "l");
if (crc32("VDcric",6) == 3624185887) strcat(s, "t");
if (crc32("mfAVcRS",7) == 304838010) strcat(s, "i");
if (crc32("lyOMdNl",7) == 3094664255) strcat(s, "c");
if (crc32("kJFDjdaInbw",11) == 3032194398) strcat(s, "s");
if (crc32("nwuqy",5) == 1545623866) strcat(s, "N");
if (crc32("LDLGbxxymblNSVx",15) == 584547163) strcat(s, "a");
if (crc32("zViOuwgdXLni",12) == 1888479719) strcat(s, "l");
if (crc32("AWHzrm",6) == 3594121332) strcat(s, "c");
if (crc32("CDEucMZhOVqk",12) == 2700332430) strcat(s, "c");
if (crc32("UFUVUZ",6) == 3802278247) strcat(s, "u");
if (crc32("oTysBzaPt",9) == 3264106439) strcat(s, "l");
if (crc32("vJLUTCXwThznS",13) == 3005182863) strcat(s, "f");
if (crc32("qhLsqJEqWkQxh",13) == 2705980421) strcat(s, "a");
if (crc32("QEHEbyg",7) == 2433435965) strcat(s, "B");
if (crc32("rZHSjJHpCeeQN",13) == 1604138976) strcat(s, "t");
if (crc32("vmlYLCijU",9) == 2659119191) strcat(s, "e");
    return s;
}

char *polyparian_adjectives() {
    char *s = calloc(11);
    if (crc32("qPHGOGxqyFtgv",13) == 4086658636) strcat(s, "p");
if (crc32("QqzCPkned",9) == 3861267570) strcat(s, "o");
if (crc32("YVQvFALuM",9) == 618021782) strcat(s, "l");
if (crc32("GcpIKQgOyPtrh",13) == 1271401166) strcat(s, "y");
if (crc32("dpepqczjuanbvxP",15) == 4120304860) strcat(s, "p");
if (crc32("dOutODVCchIV",12) == 3783731860) strcat(s, "a");
if (crc32("mKODQ",5) == 405453379) strcat(s, "r");
if (crc32("jPPdezhmt",9) == 3089900241) strcat(s, "l");
if (crc32("XTsAiBlgzf",10) == 3874866106) strcat(s, "i");
if (crc32("akAjfELcGKQWbM",14) == 3303326613) strcat(s, "a");
if (crc32("DzOUkhbobCIOkTs",15) == 4151695081) strcat(s, "b");
if (crc32("vmDQLH",6) == 1356381893) strcat(s, "n");
    return s;
}

char *undifferentiated_adjectives() {
    char *s = calloc(17);
    if (crc32("htkorrtMbADPf",13) == 498306271) strcat(s, "u");
if (crc32("qNQeVvkAimzCBG",14) == 1905715651) strcat(s, "a");
if (crc32("TJzVPINY",8) == 2178166424) strcat(s, "n");
if (crc32("XnqNRlPkSqi",11) == 3470997459) strcat(s, "d");
if (crc32("yFEGtNRJBF",10) == 2449904693) strcat(s, "i");
if (crc32("XQYUbcXVvIzaiDY",15) == 2520840386) strcat(s, "r");
if (crc32("qwfHarH",7) == 2778576998) strcat(s, "f");
if (crc32("NjBbJsM",7) == 3851791652) strcat(s, "o");
if (crc32("AbeIFQrZJJcUs",13) == 2826407218) strcat(s, "f");
if (crc32("kDdYATNtkODeZjB",15) == 1429782094) strcat(s, "e");
if (crc32("TIHSFXrBRSb",11) == 1471642599) strcat(s, "r");
if (crc32("TVgwTFxXCeGE",12) == 348923250) strcat(s, "e");
if (crc32("IHlEEBoTTdf",11) == 1436420761) strcat(s, "n");
if (crc32("bGwclpTKZMegF",13) == 2351504452) strcat(s, "t");
if (crc32("uesiasUwfWeFA",13) == 4113388544) strcat(s, "i");
if (crc32("oYGsJpzXt",9) == 3789058144) strcat(s, "a");
if (crc32("WpbZDxslwCGnbd",14) == 2516078838) strcat(s, "a");
if (crc32("wkPHLOPsJpO",11) == 2514410457) strcat(s, "t");
if (crc32("eedjXvo",7) == 3795138958) strcat(s, "e");
if (crc32("WPJGYOihBzvjs",13) == 1748169627) strcat(s, "D");
if (crc32("ihFZE",5) == 2657602686) strcat(s, "d");
    return s;
}

char *scorpionic_adjectives() {
    char *s = calloc(11);
    if (crc32("znTds",5) == 227641098) strcat(s, "s");
if (crc32("WsbvDrVcstOr",12) == 866142282) strcat(s, "c");
if (crc32("gvMtVsOyX",9) == 789176103) strcat(s, "o");
if (crc32("zPjmOpVFP",9) == 1508582781) strcat(s, "r");
if (crc32("NJtucn",6) == 3295568668) strcat(s, "p");
if (crc32("CHssqw",6) == 1389603414) strcat(s, "n");
if (crc32("PrdilVuBosXn",12) == 2586554585) strcat(s, "i");
if (crc32("wknyFJWjW",9) == 3316803057) strcat(s, "b");
if (crc32("yxxbgGShZ",9) == 985061741) strcat(s, "o");
if (crc32("yRfTtkDDh",9) == 2464798431) strcat(s, "n");
if (crc32("DyFCZmS",7) == 470628069) strcat(s, "i");
if (crc32("gAJujtoI",8) == 679941892) strcat(s, "c");
    return s;
}

char *gainable_adjectives() {
    char *s = calloc(9);
    if (crc32("GJqKyWxcYnIOS",13) == 3619737485) strcat(s, "e");
if (crc32("sluEEDcqhIkcrpm",15) == 1085080547) strcat(s, "g");
if (crc32("erfRjVP",7) == 2588350366) strcat(s, "p");
if (crc32("IKobtuQkW",9) == 2529609993) strcat(s, "a");
if (crc32("TykQxV",6) == 4030425098) strcat(s, "r");
if (crc32("AdHWNpJDgWC",11) == 3497001586) strcat(s, "i");
if (crc32("owuyfxbNNmiZsS",14) == 513513234) strcat(s, "e");
if (crc32("XQmEk",5) == 2861645875) strcat(s, "n");
if (crc32("yeRIQwihG",9) == 2650152654) strcat(s, "J");
if (crc32("ruyZZkduwogIfA",14) == 585219711) strcat(s, "a");
if (crc32("kUBfkSlNvwgepwi",15) == 1341198700) strcat(s, "Y");
if (crc32("YMzYKkgLLN",10) == 2603576299) strcat(s, "b");
if (crc32("pLZhm",5) == 289318779) strcat(s, "l");
if (crc32("msytcnL",7) == 614532778) strcat(s, "e");
    return s;
}

char *unsignalised_adjectives() {
    char *s = calloc(13);
    if (crc32("CDxFXoUpyIqBFQp",15) == 155732894) strcat(s, "y");
if (crc32("fmTQZ",5) == 1521944765) strcat(s, "u");
if (crc32("gaztVxzL",8) == 706260067) strcat(s, "n");
if (crc32("lLnlu",5) == 3763129830) strcat(s, "s");
if (crc32("tZbfhA",6) == 722752168) strcat(s, "o");
if (crc32("XCigKECesa",10) == 594931846) strcat(s, "i");
if (crc32("omsKhpFcokoI",12) == 3941793228) strcat(s, "I");
if (crc32("oiyqbwxuTEWJqM",14) == 2524740687) strcat(s, "g");
if (crc32("XZJNd",5) == 1709475623) strcat(s, "b");
if (crc32("hzdqZZc",7) == 3313093493) strcat(s, "n");
if (crc32("KjhfUfINGXCDlYQ",15) == 3373511290) strcat(s, "a");
if (crc32("wlLqMMmMpyoid",13) == 1858574178) strcat(s, "i");
if (crc32("qmGFIFqUrw",10) == 3335932304) strcat(s, "l");
if (crc32("ooDTS",5) == 1645420904) strcat(s, "I");
if (crc32("fGHQJugdnD",10) == 105603207) strcat(s, "i");
if (crc32("ccKqvEkyystWg",13) == 2963766799) strcat(s, "s");
if (crc32("gBOoEqXR",8) == 4239370428) strcat(s, "J");
if (crc32("YCJVwqin",8) == 4275457522) strcat(s, "e");
if (crc32("gyjmzpaNiz",10) == 2313233839) strcat(s, "d");
    return s;
}

char *preJustinian_adjectives() {
    char *s = calloc(13);
    if (crc32("hYRzxzUxfbVDa",13) == 3059536198) strcat(s, "q");
if (crc32("NtfgGclxUf",10) == 316882317) strcat(s, "p");
if (crc32("nLGbAaySkA",10) == 1117706020) strcat(s, "T");
if (crc32("MSTUiYODPv",10) == 3461461499) strcat(s, "r");
if (crc32("cubWvqmKx",9) == 3266885277) strcat(s, "e");
if (crc32("YJBNNiNHgOQABz",14) == 53903571) strcat(s, "J");
if (crc32("cbPbPmOHHdVurh",14) == 2240779110) strcat(s, "u");
if (crc32("oZOvzMztcQRgaoz",15) == 1106808090) strcat(s, "r");
if (crc32("taycVhOVqHGs",12) == 453164795) strcat(s, "s");
if (crc32("SllVkHdkOt",10) == 373293215) strcat(s, "t");
if (crc32("SiVSzeB",7) == 394246713) strcat(s, "i");
if (crc32("mAhImt",6) == 1725498802) strcat(s, "n");
if (crc32("OyVazD",6) == 3088875064) strcat(s, "i");
if (crc32("bjjsHUpMLiRQ",12) == 551376386) strcat(s, "a");
if (crc32("xrnQQlgvdQSHnRR",15) == 2906312859) strcat(s, "S");
if (crc32("eShNBYFGQIAGLu",14) == 1441434563) strcat(s, "n");
    return s;
}

char *discovert_adjectives() {
    char *s = calloc(10);
    if (crc32("ZEgbIiTOjIByXK",14) == 696723950) strcat(s, "k");
if (crc32("WmZxgAzMAwSHt",13) == 106818389) strcat(s, "d");
if (crc32("PjUvi",5) == 2379662438) strcat(s, "i");
if (crc32("dUorcPPJaNGAJ",13) == 1016028779) strcat(s, "s");
if (crc32("dGPSVVmS",8) == 1735692523) strcat(s, "c");
if (crc32("ZdtwRAIav",9) == 2154046229) strcat(s, "o");
if (crc32("WeAMAvuGmPozmuh",15) == 3644731449) strcat(s, "v");
if (crc32("GXwFo",5) == 148422294) strcat(s, "e");
if (crc32("eWPLvBj",7) == 2213289246) strcat(s, "r");
if (crc32("cGwUrIjaOfwcnF",14) == 1684091780) strcat(s, "t");
    return s;
}

char *furuncular_adjectives() {
    char *s = calloc(11);
    if (crc32("szwRmQA",7) == 2423157312) strcat(s, "l");
if (crc32("ZXrZKOSdtoz",11) == 861836574) strcat(s, "f");
if (crc32("VqHKBFSdqx",10) == 186292417) strcat(s, "X");
if (crc32("jEQKoYeCFU",10) == 1634533689) strcat(s, "u");
if (crc32("uqolzMMMmFK",11) == 3462691817) strcat(s, "S");
if (crc32("ktFjRYhE",8) == 1409062791) strcat(s, "r");
if (crc32("xrQOBmvrmGvCD",13) == 508764460) strcat(s, "u");
if (crc32("ezwljPjCA",9) == 2191156467) strcat(s, "C");
if (crc32("CKxPbPaGnUOZa",13) == 1894687447) strcat(s, "n");
if (crc32("pTrytMxNWBTr",12) == 2064580267) strcat(s, "T");
if (crc32("GKYobK",6) == 3489115943) strcat(s, "c");
if (crc32("aiRruMPN",8) == 3913901688) strcat(s, "Z");
if (crc32("pHjXDbM",7) == 1728175841) strcat(s, "u");
if (crc32("xcxrYwFMvlGvveP",15) == 3118355600) strcat(s, "l");
if (crc32("GzpeCTtusVMZ",12) == 354664269) strcat(s, "X");
if (crc32("PWNLdAgSqgT",11) == 2051878410) strcat(s, "a");
if (crc32("KXcisxaCs",9) == 200077932) strcat(s, "h");
if (crc32("vOeZh",5) == 1055326054) strcat(s, "r");
    return s;
}

char *chirurgical_adjectives() {
    char *s = calloc(12);
    if (crc32("YqsQErbaCGjLWp",14) == 659708716) strcat(s, "c");
if (crc32("sGuyNKvFekhgw",13) == 2510643418) strcat(s, "p");
if (crc32("oenepdQLQLE",11) == 259491271) strcat(s, "h");
if (crc32("iavwrPujTdD",11) == 1381124258) strcat(s, "i");
if (crc32("vOspI",5) == 760596309) strcat(s, "W");
if (crc32("gAAOR",5) == 1296361469) strcat(s, "r");
if (crc32("aCuQIFvdRBjLr",13) == 387495687) strcat(s, "u");
if (crc32("OWNpSXDu",8) == 2952823604) strcat(s, "r");
if (crc32("TZOSSXy",7) == 2987052147) strcat(s, "G");
if (crc32("AKxbMqCiOM",10) == 1811347341) strcat(s, "g");
if (crc32("BmQNGQsz",8) == 462789810) strcat(s, "i");
if (crc32("bjVTmIsNCbe",11) == 1788781463) strcat(s, "c");
if (crc32("KuJQRrVSAoihkL",14) == 3752474599) strcat(s, "a");
if (crc32("ElMphxUHVxb",11) == 146816308) strcat(s, "c");
if (crc32("anAaHmNVRwwniW",14) == 2912330097) strcat(s, "l");
    return s;
}

char *unfreckled_adjectives() {
    char *s = calloc(11);
    if (crc32("iZJQjXXVoZ",10) == 3131351801) strcat(s, "u");
if (crc32("DqQRZQmew",9) == 1453261047) strcat(s, "n");
if (crc32("NRThiS",6) == 2203334202) strcat(s, "u");
if (crc32("FPwcV",5) == 1207625510) strcat(s, "f");
if (crc32("cNzoDMNxOPSBncL",15) == 3189738488) strcat(s, "o");
if (crc32("GqRLHsswrnEDu",13) == 3267570820) strcat(s, "r");
if (crc32("HRdIPUP",7) == 3419312248) strcat(s, "w");
if (crc32("KuBpJDp",7) == 1889417745) strcat(s, "e");
if (crc32("znZKJyN",7) == 3416821849) strcat(s, "c");
if (crc32("GtcDchx",7) == 3227808439) strcat(s, "X");
if (crc32("ygTYiLiETWEhw",13) == 2729300210) strcat(s, "k");
if (crc32("ogpKsDCpfGko",12) == 4032468344) strcat(s, "E");
if (crc32("anHfbHUMCzhJwzz",15) == 4063675870) strcat(s, "l");
if (crc32("EddznRLEbCkT",12) == 516387549) strcat(s, "e");
if (crc32("zfVdE",5) == 3409575625) strcat(s, "w");
if (crc32("GefWcC",6) == 620157934) strcat(s, "d");
    return s;
}

char *nonsimulate_adjectives() {
    char *s = calloc(12);
    if (crc32("vUUwZdJQd",9) == 1294589510) strcat(s, "n");
if (crc32("kAKCCnvbKwUWcHM",15) == 2545618370) strcat(s, "o");
if (crc32("NkPwOG",6) == 1872263789) strcat(s, "n");
if (crc32("MBTIWWqudNqUVd",14) == 2570615219) strcat(s, "E");
if (crc32("xIBYYm",6) == 156920390) strcat(s, "s");
if (crc32("oJgDt",5) == 3264650950) strcat(s, "G");
if (crc32("zmGJm",5) == 4031512962) strcat(s, "i");
if (crc32("gRMOd",5) == 3376968561) strcat(s, "m");
if (crc32("NuVxiR",6) == 813444256) strcat(s, "u");
if (crc32("XSRVjVh",7) == 122402355) strcat(s, "T");
if (crc32("domlBs",6) == 3121028328) strcat(s, "l");
if (crc32("yktrSaRblCvzSX",14) == 1826236530) strcat(s, "a");
if (crc32("wptwxY",6) == 1434354146) strcat(s, "u");
if (crc32("mckgNifgzP",10) == 770924419) strcat(s, "t");
if (crc32("dGmYojQurt",10) == 1025246706) strcat(s, "e");
    return s;
}

char *primaeval_adjectives() {
    char *s = calloc(10);
    if (crc32("tLedxrzif",9) == 1048790471) strcat(s, "p");
if (crc32("ndYLPoV",7) == 3030198522) strcat(s, "c");
if (crc32("QWvWavKXVWd",11) == 1393669617) strcat(s, "r");
if (crc32("szVJxXf",7) == 637440900) strcat(s, "i");
if (crc32("BzIDpSiOQH",10) == 134222101) strcat(s, "m");
if (crc32("nsPYK",5) == 2137088502) strcat(s, "a");
if (crc32("JexNNhVNxSGOx",13) == 3493642363) strcat(s, "e");
if (crc32("JLbKUILpQmlLW",13) == 1904371804) strcat(s, "v");
if (crc32("MbLeIQpkaL",10) == 3706227868) strcat(s, "C");
if (crc32("RkuOILR",7) == 531790131) strcat(s, "a");
if (crc32("eZemDVLUdW",10) == 769916011) strcat(s, "l");
    return s;
}

char *unecstatic_adjectives() {
    char *s = calloc(11);
    if (crc32("LrbYDtlVDVPIoby",15) == 2777235516) strcat(s, "u");
if (crc32("ElEWyJSdfc",10) == 3914722816) strcat(s, "n");
if (crc32("vomncS",6) == 1239643792) strcat(s, "g");
if (crc32("xPMjKEPPIFCCFJV",15) == 3383682495) strcat(s, "e");
if (crc32("jyUSbzCwOhh",11) == 4201392881) strcat(s, "c");
if (crc32("YSgqDKxUDfo",11) == 3630862298) strcat(s, "S");
if (crc32("qtEPybRS",8) == 1576149387) strcat(s, "s");
if (crc32("NzniPff",7) == 3724038917) strcat(s, "A");
if (crc32("qvfwg",5) == 3006688634) strcat(s, "t");
if (crc32("lbLmNEWq",8) == 1809374555) strcat(s, "W");
if (crc32("DNNLDHOm",8) == 1519230515) strcat(s, "a");
if (crc32("TChGa",5) == 4137405682) strcat(s, "C");
if (crc32("VNpgTuIhGoCCw",13) == 2719292901) strcat(s, "t");
if (crc32("egmGZmjMpPjxb",13) == 214496469) strcat(s, "W");
if (crc32("TTfaIgtD",8) == 2286792226) strcat(s, "i");
if (crc32("nNLBPSScZtexv",13) == 1388646968) strcat(s, "U");
if (crc32("bTnXbU",6) == 3438359967) strcat(s, "c");
    return s;
}

char *unstrange_adjectives() {
    char *s = calloc(10);
    if (crc32("JlbhkABhyPY",11) == 2266559645) strcat(s, "u");
if (crc32("encBvCQuKGoG",12) == 3641921671) strcat(s, "n");
if (crc32("RlkFQPQFUbVsYv",14) == 3597023834) strcat(s, "w");
if (crc32("WVoOOYJusT",10) == 118014469) strcat(s, "s");
if (crc32("QOdmnhLEy",9) == 2911065676) strcat(s, "B");
if (crc32("sWUIGqChgjc",11) == 4290429788) strcat(s, "t");
if (crc32("mrCuXAZAdOKniiA",15) == 3926448848) strcat(s, "q");
if (crc32("xSOFlxh",7) == 1232067522) strcat(s, "r");
if (crc32("LRvwGZmtHFm",11) == 1844937512) strcat(s, "a");
if (crc32("UZQedUBbjBoPp",13) == 2183660921) strcat(s, "n");
if (crc32("IEjQTNoXjlxaKLr",15) == 4110415387) strcat(s, "g");
if (crc32("eGbrqL",6) == 3051035104) strcat(s, "k");
if (crc32("QZrWuTYcguWpNtl",15) == 3111695252) strcat(s, "e");
    return s;
}

char *jimcrow_adjectives() {
    char *s = calloc(8);
    if (crc32("HBqwH",5) == 3539357911) strcat(s, "j");
if (crc32("whZsYF",6) == 3285454681) strcat(s, "p");
if (crc32("DhcgxJTPROi",11) == 730540737) strcat(s, "i");
if (crc32("UuoFz",5) == 1212471630) strcat(s, "T");
if (crc32("muZdM",5) == 2478189735) strcat(s, "m");
if (crc32("AjnEq",5) == 527404355) strcat(s, "c");
if (crc32("jvqSzkFcgomjdO",14) == 3295617628) strcat(s, "r");
if (crc32("JPngJmvLj",9) == 1278448944) strcat(s, "o");
if (crc32("TmnyibcIaiUZr",13) == 2466576627) strcat(s, "N");
if (crc32("sidLvXWhZ",9) == 3500319133) strcat(s, "w");
    return s;
}

char *importable_adjectives() {
    char *s = calloc(11);
    if (crc32("JlptFnkomPv",11) == 2538739336) strcat(s, "i");
if (crc32("afFpHWIYhRHxFkr",15) == 489868624) strcat(s, "m");
if (crc32("TrZNTxuqgMPKIb",14) == 2998553919) strcat(s, "p");
if (crc32("nEeuoUOCyPmWuZ",14) == 1499185659) strcat(s, "a");
if (crc32("cUYlHNGQnNGUP",13) == 1260764854) strcat(s, "o");
if (crc32("OHkZoC",6) == 2817767092) strcat(s, "r");
if (crc32("kvsyUVarwDTX",12) == 1385787164) strcat(s, "t");
if (crc32("IDOfqHhUi",9) == 285929697) strcat(s, "T");
if (crc32("OOuUovURAR",10) == 1754350171) strcat(s, "a");
if (crc32("EfgvekbpvhOOC",13) == 2928132171) strcat(s, "E");
if (crc32("IjQVwFKwj",9) == 3460114944) strcat(s, "b");
if (crc32("PznVaoFLEZ",10) == 2750580221) strcat(s, "l");
if (crc32("StPhqEvGsWJWvp",14) == 4082275448) strcat(s, "e");
    return s;
}

char *pruinose_adjectives() {
    char *s = calloc(9);
    if (crc32("mTuzCqsD",8) == 129596011) strcat(s, "N");
if (crc32("GLAGSJwiG",9) == 1422565009) strcat(s, "p");
if (crc32("IodbLXIiMBC",11) == 3413098402) strcat(s, "o");
if (crc32("ohvwZFfw",8) == 1868073973) strcat(s, "r");
if (crc32("qWMUJOnrZABoO",13) == 1650790843) strcat(s, "u");
if (crc32("YlNzXHMFLfZEsY",14) == 4179008392) strcat(s, "i");
if (crc32("FBKvyHBDVDEO",12) == 382485553) strcat(s, "n");
if (crc32("QChymikqkmS",11) == 1842767323) strcat(s, "o");
if (crc32("DOuPMrzKEEEYK",13) == 2353460807) strcat(s, "w");
if (crc32("XcJPU",5) == 996531139) strcat(s, "s");
if (crc32("kVVKTjlr",8) == 2424950584) strcat(s, "x");
if (crc32("cTApiMXoFYSBcbL",15) == 1581160899) strcat(s, "e");
    return s;
}

char *nonresidual_adjectives() {
    char *s = calloc(12);
    if (crc32("QQGwq",5) == 1175064075) strcat(s, "k");
if (crc32("cbxlXHFjEY",10) == 1957974150) strcat(s, "n");
if (crc32("vQQkLIXjNJlMKM",14) == 582316418) strcat(s, "w");
if (crc32("WxkfHnTNJnlCmX",14) == 1890687580) strcat(s, "o");
if (crc32("ehlGxdgtPpy",11) == 4174161694) strcat(s, "n");
if (crc32("MBXfWpFrRywRNgf",15) == 2011067335) strcat(s, "r");
if (crc32("nMcAcu",6) == 3312632978) strcat(s, "G");
if (crc32("HqMcQqRXhz",10) == 2630265457) strcat(s, "e");
if (crc32("cjaRtobGzpg",11) == 919159840) strcat(s, "Q");
if (crc32("dnrRiQKdKhN",11) == 2414234380) strcat(s, "s");
if (crc32("UJGMumMAnPDmp",13) == 780128018) strcat(s, "Q");
if (crc32("dtNVGPxIW",9) == 2935438506) strcat(s, "i");
if (crc32("wqAUkttAdmyxyzU",15) == 2822059472) strcat(s, "J");
if (crc32("ewCdUZ",6) == 671385153) strcat(s, "d");
if (crc32("bFYEYZcZVR",10) == 3210003281) strcat(s, "u");
if (crc32("kMUoaU",6) == 2871873234) strcat(s, "a");
if (crc32("FzvGVSum",8) == 347578658) strcat(s, "l");
    return s;
}

char *boskiest_adjectives() {
    char *s = calloc(9);
    if (crc32("gTkQP",5) == 622255509) strcat(s, "b");
if (crc32("NdtVDgfX",8) == 248845780) strcat(s, "o");
if (crc32("vKMgILJgC",9) == 489645040) strcat(s, "s");
if (crc32("ytWrM",5) == 2854902788) strcat(s, "k");
if (crc32("HWJdptZnwzwWvFR",15) == 4061691061) strcat(s, "i");
if (crc32("lwyyUZBPqaBXY",13) == 2481261337) strcat(s, "j");
if (crc32("ZcWhp",5) == 163631164) strcat(s, "e");
if (crc32("UsrNyCA",7) == 1911923195) strcat(s, "C");
if (crc32("OGqvOy",6) == 2027475978) strcat(s, "s");
if (crc32("NtjfN",5) == 4051309045) strcat(s, "C");
if (crc32("drawjH",6) == 2491743100) strcat(s, "t");
    return s;
}

char *Pennsylvanian_adjectives() {
    char *s = calloc(14);
    if (crc32("BTdywJA",7) == 4187055880) strcat(s, "P");
if (crc32("IvjGDPPrpnHKk",13) == 372137369) strcat(s, "e");
if (crc32("zZzzbViDePFqWq",14) == 4209179258) strcat(s, "n");
if (crc32("FXHijNnL",8) == 1693769177) strcat(s, "U");
if (crc32("rgRXQnwGGJEO",12) == 275914167) strcat(s, "n");
if (crc32("QXtWopxlybIWKyp",15) == 73365515) strcat(s, "B");
if (crc32("ubrrMLkm",8) == 4256651769) strcat(s, "s");
if (crc32("keDGxhi",7) == 2373560902) strcat(s, "g");
if (crc32("lydHV",5) == 2040647799) strcat(s, "y");
if (crc32("UHrvxAGACwQcyc",14) == 2016644496) strcat(s, "C");
if (crc32("LKLqNAIKFCn",11) == 1163670668) strcat(s, "l");
if (crc32("hBMPytadsO",10) == 1322886736) strcat(s, "v");
if (crc32("xcDORonIwSE",11) == 756900276) strcat(s, "a");
if (crc32("iyvvMwQOj",9) == 1257299544) strcat(s, "P");
if (crc32("qSlxhw",6) == 1180221119) strcat(s, "n");
if (crc32("xuLtQxSUu",9) == 180023565) strcat(s, "c");
if (crc32("zVhyLjPdtwd",11) == 1215230657) strcat(s, "i");
if (crc32("NsWBfmoNGqZafb",14) == 1169840640) strcat(s, "t");
if (crc32("fFELDkLA",8) == 2601026085) strcat(s, "a");
if (crc32("pPcjMWBex",9) == 761788204) strcat(s, "p");
if (crc32("LiTXg",5) == 3608043287) strcat(s, "n");
    return s;
}

char *auriculoventricular_adjectives() {
    char *s = calloc(20);
    if (crc32("KHtFW",5) == 525206439) strcat(s, "P");
if (crc32("clRwPFahifeHNCr",15) == 1746574736) strcat(s, "a");
if (crc32("KLMDYTQqft",10) == 1825141442) strcat(s, "Z");
if (crc32("WFmqDgzvCKI",11) == 1386400916) strcat(s, "u");
if (crc32("MbFJoVV",7) == 4092916264) strcat(s, "r");
if (crc32("uojexMVsUAunUi",14) == 2510583891) strcat(s, "u");
if (crc32("UPaNC",5) == 904293298) strcat(s, "i");
if (crc32("VCMqDUgwquV",11) == 662087120) strcat(s, "K");
if (crc32("MLoGEaxMBVkH",12) == 1071180700) strcat(s, "c");
if (crc32("FVJNKpLJjCMPAV",14) == 2504742007) strcat(s, "l");
if (crc32("xtWBe",5) == 2109336509) strcat(s, "u");
if (crc32("BwtjaXBxhMiBB",13) == 2846408887) strcat(s, "W");
if (crc32("sfoCiFIsdlEnYUx",15) == 2199540813) strcat(s, "l");
if (crc32("tLqcQOiparh",11) == 3687960961) strcat(s, "a");
if (crc32("HnqGNrUlhv",10) == 67931948) strcat(s, "o");
if (crc32("JEANIOmcyLelu",13) == 3546642679) strcat(s, "v");
if (crc32("lfICiFF",7) == 475800146) strcat(s, "i");
if (crc32("pbgMnjzeExRCU",13) == 924593370) strcat(s, "e");
if (crc32("zRAXTKsoSUYFloE",15) == 3706169696) strcat(s, "k");
if (crc32("zhNoRVW",7) == 3280148490) strcat(s, "n");
if (crc32("cocOxCpNdzZht",13) == 2248728082) strcat(s, "t");
if (crc32("YsKsMcX",7) == 2736559470) strcat(s, "r");
if (crc32("xewqAFtVCC",10) == 4122039025) strcat(s, "g");
if (crc32("QQjYVA",6) == 2846823686) strcat(s, "i");
if (crc32("uWdHVolsaDlJHac",15) == 1371345263) strcat(s, "X");
if (crc32("eRiFOHdPZ",9) == 3658087857) strcat(s, "c");
if (crc32("DOKaJEh",7) == 4115708681) strcat(s, "z");
if (crc32("OKpsLGJYS",9) == 2380108302) strcat(s, "u");
if (crc32("EekgXLXAaT",10) == 1589589240) strcat(s, "S");
if (crc32("SicYkG",6) == 2343953739) strcat(s, "l");
if (crc32("yaWcs",5) == 1599456530) strcat(s, "a");
if (crc32("KqRHIQLcVZkV",12) == 1125641778) strcat(s, "r");
    return s;
}

char *reparable_adjectives() {
    char *s = calloc(10);
    if (crc32("OCSalZeQwE",10) == 2543302974) strcat(s, "r");
if (crc32("BddjnbDzQznXm",13) == 3245493307) strcat(s, "e");
if (crc32("QsVDYwPT",8) == 1737229728) strcat(s, "p");
if (crc32("SkomJqycmCmzTk",14) == 3169896494) strcat(s, "T");
if (crc32("YhYWWfwE",8) == 1256760645) strcat(s, "a");
if (crc32("alVNkdtWEvM",11) == 4141203211) strcat(s, "J");
if (crc32("doEeB",5) == 1071395248) strcat(s, "r");
if (crc32("SIyMDiBMOuWq",12) == 293763447) strcat(s, "S");
if (crc32("cVistRIbJfqWnOg",15) == 3637392245) strcat(s, "a");
if (crc32("XQqHLMZgipiZnD",14) == 3182129262) strcat(s, "P");
if (crc32("dyeft",5) == 2524232009) strcat(s, "b");
if (crc32("GOjra",5) == 2373599075) strcat(s, "l");
if (crc32("VpdRh",5) == 2658457770) strcat(s, "e");
    return s;
}

char *deutoplasmic_adjectives() {
    char *s = calloc(13);
    if (crc32("ASdXWfBIflTMi",13) == 1282710042) strcat(s, "T");
if (crc32("FAPgGIy",7) == 2649153556) strcat(s, "d");
if (crc32("oAjKvEWpmWStWTP",15) == 10662856) strcat(s, "e");
if (crc32("GXbcHygsvQLZWB",14) == 1779085625) strcat(s, "E");
if (crc32("WbqFRZgUvHGYt",13) == 4161454073) strcat(s, "u");
if (crc32("psVwic",6) == 3285110970) strcat(s, "S");
if (crc32("KicMkM",6) == 2680850191) strcat(s, "t");
if (crc32("qeUkbgehTfd",11) == 2747552687) strcat(s, "M");
if (crc32("EjMoCXBmXd",10) == 1429340808) strcat(s, "o");
if (crc32("vBfoT",5) == 1133782995) strcat(s, "p");
if (crc32("ECiGDGGUXXKIPH",14) == 941977646) strcat(s, "l");
if (crc32("klCoRkZWJgIQaL",14) == 1320836697) strcat(s, "a");
if (crc32("vHVRoPFgp",9) == 1078628552) strcat(s, "s");
if (crc32("HzCFDyjImWDkgm",14) == 3708225647) strcat(s, "p");
if (crc32("yivMJdYkHoEh",12) == 3970876269) strcat(s, "m");
if (crc32("kuXYtThM",8) == 2777585069) strcat(s, "z");
if (crc32("ParDuCt",7) == 879990187) strcat(s, "i");
if (crc32("OpobwefLkDK",11) == 4157346499) strcat(s, "G");
if (crc32("qfhUBbCfYKDs",12) == 4182965711) strcat(s, "c");
    return s;
}

char *ancient_adjectives() {
    char *s = calloc(8);
    if (crc32("GTZDMZ",6) == 1934012676) strcat(s, "a");
if (crc32("DhEUbbdSaVgP",12) == 1480477806) strcat(s, "C");
if (crc32("rUCWCUXLXjbcF",13) == 836485067) strcat(s, "n");
if (crc32("jNcUlWrsq",9) == 2335406721) strcat(s, "c");
if (crc32("AMZbOV",6) == 3202909369) strcat(s, "X");
if (crc32("RVzoU",5) == 3398763613) strcat(s, "i");
if (crc32("NptoyeXihSA",11) == 75101384) strcat(s, "e");
if (crc32("rFILTzcaaTgQ",12) == 2570299760) strcat(s, "E");
if (crc32("rmHUfgJtSTQr",12) == 3371085601) strcat(s, "n");
if (crc32("DIKHZPtqIfEW",12) == 318388707) strcat(s, "i");
if (crc32("Bsbnc",5) == 4178418371) strcat(s, "t");
    return s;
}

char *unthroaty_adjectives() {
    char *s = calloc(10);
    if (crc32("rfyHkkqb",8) == 3607788119) strcat(s, "p");
if (crc32("YpekFEou",8) == 2145158411) strcat(s, "u");
if (crc32("muaaRtBqRnLwIN",14) == 1010517158) strcat(s, "y");
if (crc32("fzIypdREPGufub",14) == 4232993773) strcat(s, "n");
if (crc32("rhcqUX",6) == 1335928620) strcat(s, "B");
if (crc32("pSNOMsyp",8) == 2777676861) strcat(s, "t");
if (crc32("ymbAdysJylES",12) == 3753838430) strcat(s, "h");
if (crc32("MnjiZbjiI",9) == 293306496) strcat(s, "r");
if (crc32("AAsDVRoBEOyNw",13) == 3049420718) strcat(s, "o");
if (crc32("TmveTC",6) == 1983194703) strcat(s, "a");
if (crc32("rGOyfwORGRJnU",13) == 2995254966) strcat(s, "t");
if (crc32("NucKtJuvlCetdzv",15) == 671745808) strcat(s, "y");
    return s;
}

char *porrect_adjectives() {
    char *s = calloc(8);
    if (crc32("rgzSmA",6) == 1741296329) strcat(s, "p");
if (crc32("DXVCzkISZRVor",13) == 969711845) strcat(s, "o");
if (crc32("fesOJcs",7) == 3301324900) strcat(s, "Z");
if (crc32("xPuBWI",6) == 3148208739) strcat(s, "r");
if (crc32("zHQoG",5) == 900729321) strcat(s, "y");
if (crc32("fWERmd",6) == 3156393029) strcat(s, "r");
if (crc32("zoLqmxE",7) == 3272180151) strcat(s, "e");
if (crc32("uezLjIcg",8) == 4065511881) strcat(s, "N");
if (crc32("ImbfZ",5) == 2848426366) strcat(s, "c");
if (crc32("GISCzmvjGVH",11) == 1947738276) strcat(s, "i");
if (crc32("ANBqVBQRurWSSt",14) == 3860444114) strcat(s, "t");
    return s;
}

char *ellipsoidal_adjectives() {
    char *s = calloc(12);
    if (crc32("UyQVHfJwinN",11) == 4272690217) strcat(s, "e");
if (crc32("uDdGILkOMO",10) == 613984333) strcat(s, "l");
if (crc32("weSBXfWIMMvSyuZ",15) == 2943034948) strcat(s, "l");
if (crc32("godmw",5) == 3064845906) strcat(s, "r");
if (crc32("hfgJYsAqUY",10) == 42330391) strcat(s, "i");
if (crc32("Slfbyvx",7) == 3204856578) strcat(s, "y");
if (crc32("HLBJEpIhmh",10) == 1210530345) strcat(s, "p");
if (crc32("amAYwIqtg",9) == 293767364) strcat(s, "r");
if (crc32("WyGdsdpEqUQHSGa",15) == 3845273469) strcat(s, "s");
if (crc32("ZLNsPwgOMQKuxl",14) == 4091658280) strcat(s, "o");
if (crc32("WGHdMEASM",9) == 3555288333) strcat(s, "i");
if (crc32("muxPvXWBzSrGV",13) == 2796607701) strcat(s, "d");
if (crc32("DDnpHeCl",8) == 3132089397) strcat(s, "F");
if (crc32("mqkjVVeUczu",11) == 4272715267) strcat(s, "a");
if (crc32("vIfAsfGcuueBWNS",15) == 3037733733) strcat(s, "q");
if (crc32("HuCIvcLWPjWx",12) == 3268580421) strcat(s, "l");
    return s;
}

char *interAmerican_adjectives() {
    char *s = calloc(14);
    if (crc32("UdsMU",5) == 1964396098) strcat(s, "B");
if (crc32("PzqKPhrcG",9) == 2983705086) strcat(s, "i");
if (crc32("WykaXb",6) == 1091654372) strcat(s, "b");
if (crc32("CULQjYibHOjklnH",15) == 3466288033) strcat(s, "n");
if (crc32("dsaobrcv",8) == 2160323998) strcat(s, "c");
if (crc32("nwHYW",5) == 4130822182) strcat(s, "t");
if (crc32("sZcAuRXROhJTkw",14) == 435383682) strcat(s, "X");
if (crc32("HXbHTDkvIdvj",12) == 936782479) strcat(s, "e");
if (crc32("nXXTBfuh",8) == 3900335651) strcat(s, "U");
if (crc32("sFYAuVgw",8) == 4265163468) strcat(s, "r");
if (crc32("jhmmVDGEt",9) == 2128082202) strcat(s, "A");
if (crc32("RLHjXyfk",8) == 2149290327) strcat(s, "Y");
if (crc32("VHgeHlJqCWTSD",13) == 3729120231) strcat(s, "m");
if (crc32("cLlfnimIQORMcd",14) == 519836005) strcat(s, "Z");
if (crc32("eMLYyeKmDVg",11) == 3700259290) strcat(s, "e");
if (crc32("ytwOBqrfZy",10) == 1173448956) strcat(s, "B");
if (crc32("yhbXwLcSwMrh",12) == 815662743) strcat(s, "r");
if (crc32("byAkOXVwwiMDH",13) == 4115405661) strcat(s, "r");
if (crc32("fleaCSuAJFXBc",13) == 219807610) strcat(s, "i");
if (crc32("xlazcjQ",7) == 1424099104) strcat(s, "c");
if (crc32("ewgOeHqhKy",10) == 483637567) strcat(s, "S");
if (crc32("OSRvEYyYUpWra",13) == 1551362832) strcat(s, "a");
if (crc32("CHXYXLE",7) == 2369205927) strcat(s, "n");
    return s;
}

char *undelaying_adjectives() {
    char *s = calloc(11);
    if (crc32("PJoNEGAQEpSFKJ",14) == 105067404) strcat(s, "o");
if (crc32("XHxmsNHOamXbCfj",15) == 748086668) strcat(s, "u");
if (crc32("zqaTka",6) == 628919853) strcat(s, "H");
if (crc32("ODPaHZZDkhvTDw",14) == 3168023670) strcat(s, "n");
if (crc32("xSrJMSqP",8) == 1632538544) strcat(s, "R");
if (crc32("nWVKqMsAuJpnd",13) == 702318548) strcat(s, "d");
if (crc32("jokMmhDDveAg",12) == 2503486054) strcat(s, "m");
if (crc32("UGGGMLYMauuK",12) == 1054652296) strcat(s, "e");
if (crc32("QSfPfctjuSQJA",13) == 3742638134) strcat(s, "l");
if (crc32("LTLYzYGOTgEMOiA",15) == 108595909) strcat(s, "a");
if (crc32("IiTlaeIUKq",10) == 1675663939) strcat(s, "k");
if (crc32("XyjRZCXwwISJDV",14) == 225887426) strcat(s, "y");
if (crc32("ESLcGcmfsKmB",12) == 2784738309) strcat(s, "i");
if (crc32("kBcIc",5) == 2790035488) strcat(s, "n");
if (crc32("HbzJcwmsxKJNUYn",15) == 3475597806) strcat(s, "g");
    return s;
}

char *shrieky_adjectives() {
    char *s = calloc(8);
    if (crc32("mDWzFAtUesRpRC",14) == 1956280790) strcat(s, "s");
if (crc32("WjfdKGRXPHf",11) == 1877554428) strcat(s, "h");
if (crc32("uESdAXZqKLiG",12) == 3182708969) strcat(s, "B");
if (crc32("TUAtjdSztoxUV",13) == 3751962656) strcat(s, "r");
if (crc32("zDHFypLIqJLS",12) == 2180160857) strcat(s, "i");
if (crc32("zvhDKa",6) == 3453003675) strcat(s, "e");
if (crc32("qFLZLiZzjT",10) == 1281644205) strcat(s, "k");
if (crc32("eVUstNmNT",9) == 2860864879) strcat(s, "y");
    return s;
}

char *unanatomized_adjectives() {
    char *s = calloc(13);
    if (crc32("umJmxbxl",8) == 3855681301) strcat(s, "y");
if (crc32("EWTFqKQCGUf",11) == 3800466625) strcat(s, "u");
if (crc32("rSrEqgBZC",9) == 2304412541) strcat(s, "G");
if (crc32("WcqfAgEhkKoxY",13) == 845829771) strcat(s, "n");
if (crc32("zFTMKqWhAbNZ",12) == 4242353113) strcat(s, "i");
if (crc32("hJVejDiwTP",10) == 2263998757) strcat(s, "a");
if (crc32("VcKDCEZNB",9) == 3283918796) strcat(s, "l");
if (crc32("zrukEJYZF",9) == 1773068345) strcat(s, "n");
if (crc32("bcLSxwQikpyE",12) == 1044851982) strcat(s, "w");
if (crc32("dFdqdJLNFmLw",12) == 385229413) strcat(s, "a");
if (crc32("qZMDjz",6) == 842012254) strcat(s, "t");
if (crc32("auhJhibYjZvwV",13) == 3656925262) strcat(s, "o");
if (crc32("TpEJzIEn",8) == 2933365424) strcat(s, "d");
if (crc32("GQFMpcSze",9) == 131660969) strcat(s, "m");
if (crc32("tdKLmwQv",8) == 1214877189) strcat(s, "i");
if (crc32("bHCcGHLay",9) == 229336469) strcat(s, "z");
if (crc32("XMkCAmiQGVpB",12) == 968321871) strcat(s, "Z");
if (crc32("xAEtGLk",7) == 30956437) strcat(s, "e");
if (crc32("utGMlQLAYSPt",12) == 4039065050) strcat(s, "d");
    return s;
}

char *backhanded_adjectives() {
    char *s = calloc(11);
    if (crc32("hNHozkArWq",10) == 1376940183) strcat(s, "b");
if (crc32("IbeopmHOL",9) == 1615238625) strcat(s, "a");
if (crc32("rgobfXoOAyy",11) == 3607968433) strcat(s, "D");
if (crc32("DIabTLYPMDM",11) == 56347102) strcat(s, "c");
if (crc32("tJvrM",5) == 2076261360) strcat(s, "k");
if (crc32("sGnatYoXin",10) == 1688564835) strcat(s, "B");
if (crc32("CrWGvA",6) == 3769461222) strcat(s, "h");
if (crc32("FGKwj",5) == 2793684774) strcat(s, "a");
if (crc32("eFVYuOiz",8) == 1438519896) strcat(s, "u");
if (crc32("qmYrkgDbYknFh",13) == 2699250682) strcat(s, "n");
if (crc32("QkVAqMXHNG",10) == 2351960548) strcat(s, "d");
if (crc32("HPSSaDHjQ",9) == 59859108) strcat(s, "e");
if (crc32("bKzUOJqKxFVaWK",14) == 2691096870) strcat(s, "d");
    return s;
}

char *whackiest_adjectives() {
    char *s = calloc(10);
    if (crc32("FbyIyUz",7) == 3244934793) strcat(s, "w");
if (crc32("FrtBcKONR",9) == 4254985630) strcat(s, "h");
if (crc32("ZJfsapzKD",9) == 684656499) strcat(s, "a");
if (crc32("oRtkLgkYdof",11) == 1494943961) strcat(s, "B");
if (crc32("jaSeziZFJdEbKBB",15) == 2315309173) strcat(s, "c");
if (crc32("zzPTqwF",7) == 2839748721) strcat(s, "k");
if (crc32("gaIsGMTHmCqXR",13) == 1214810432) strcat(s, "m");
if (crc32("YwSfWeg",7) == 4267114635) strcat(s, "i");
if (crc32("ljHlH",5) == 3838757216) strcat(s, "v");
if (crc32("NfiCpbXKgRS",11) == 3200762546) strcat(s, "e");
if (crc32("oSoCEuXu",8) == 886591769) strcat(s, "s");
if (crc32("LZAbKNOpmcJFp",13) == 644935985) strcat(s, "t");
    return s;
}

char *flyblown_adjectives() {
    char *s = calloc(9);
    if (crc32("JxRTAY",6) == 667416054) strcat(s, "f");
if (crc32("QBrjqNptwwCA",12) == 1740206441) strcat(s, "l");
if (crc32("EmsFUiZPRxBDOZA",15) == 2420253039) strcat(s, "Q");
if (crc32("vtgMudnfNgKgz",13) == 1822592302) strcat(s, "y");
if (crc32("vJbYqVEKudBVx",13) == 3252871182) strcat(s, "b");
if (crc32("RkrxQacDofnS",12) == 1408189275) strcat(s, "s");
if (crc32("xywFn",5) == 1142974732) strcat(s, "l");
if (crc32("PDMsCExdszsiTRX",15) == 2300897171) strcat(s, "o");
if (crc32("PuJCxC",6) == 1498699901) strcat(s, "C");
if (crc32("QbjKU",5) == 531780525) strcat(s, "w");
if (crc32("cfsBHfwjU",9) == 2836431606) strcat(s, "n");
    return s;
}

char *unworkmanly_adjectives() {
    char *s = calloc(12);
    if (crc32("LclyjbaatgsnqZh",15) == 2343043929) strcat(s, "u");
if (crc32("GhTTvsZvMF",10) == 1583253147) strcat(s, "m");
if (crc32("fKubthH",7) == 911467704) strcat(s, "n");
if (crc32("FbwSKr",6) == 3198542573) strcat(s, "w");
if (crc32("LjezvWuOV",9) == 2196446940) strcat(s, "t");
if (crc32("FmlnoePknLgl",12) == 2656635633) strcat(s, "o");
if (crc32("oliPieRY",8) == 732992499) strcat(s, "l");
if (crc32("LXWqWidwNyzrTS",14) == 4135953127) strcat(s, "r");
if (crc32("PQJIlIyweWS",11) == 393114713) strcat(s, "k");
if (crc32("tOzPMXmYBypSUYx",15) == 2630862229) strcat(s, "d");
if (crc32("smAcCMJOj",9) == 3648203790) strcat(s, "m");
if (crc32("QZtgjpTswJEd",12) == 1235267255) strcat(s, "a");
if (crc32("NxrSaXcAGofFInX",15) == 853943853) strcat(s, "n");
if (crc32("YICMTzdvs",9) == 3297747395) strcat(s, "n");
if (crc32("bmJjhywQUTmMZ",13) == 2772894924) strcat(s, "l");
if (crc32("CShWcpKZwz",10) == 2995149603) strcat(s, "y");
    return s;
}

char *domestic_adjectives() {
    char *s = calloc(9);
    if (crc32("kyfQKuA",7) == 1919938518) strcat(s, "d");
if (crc32("BYlMsPWpNolgc",13) == 149529221) strcat(s, "o");
if (crc32("vKhUFrC",7) == 2752641520) strcat(s, "m");
if (crc32("YqAtbQWF",8) == 412775474) strcat(s, "i");
if (crc32("LnEUXtjz",8) == 494672089) strcat(s, "e");
if (crc32("wHEeKkkFVAMzfD",14) == 4067633690) strcat(s, "f");
if (crc32("fiQwGyxyklKxN",13) == 3592772610) strcat(s, "s");
if (crc32("rUrofWgnxFBLLY",14) == 940252740) strcat(s, "t");
if (crc32("DIEtXHbu",8) == 1586607120) strcat(s, "O");
if (crc32("KaPwuOTxk",9) == 923473673) strcat(s, "i");
if (crc32("iVSvrbeUkoN",11) == 1908235578) strcat(s, "c");
    return s;
}

char *paleontographic_adjectives() {
    char *s = calloc(16);
    if (crc32("UgnyopYYGIPH",12) == 1831095758) strcat(s, "Q");
if (crc32("yXYUM",5) == 2425738221) strcat(s, "p");
if (crc32("kIbdBpbnqD",10) == 2050667177) strcat(s, "a");
if (crc32("aUQxxhGhjR",10) == 3072496860) strcat(s, "l");
if (crc32("HTwjYPhYXj",10) == 2573383495) strcat(s, "e");
if (crc32("nrluawlQ",8) == 725530274) strcat(s, "K");
if (crc32("oNzIRUBn",8) == 3836820847) strcat(s, "o");
if (crc32("kburFee",7) == 1289207063) strcat(s, "E");
if (crc32("stRbsKdZH",9) == 1939962040) strcat(s, "n");
if (crc32("ajmZCVwffBckgNT",15) == 2592636045) strcat(s, "R");
if (crc32("LLMZZjJDxzbLSEp",15) == 1362921819) strcat(s, "t");
if (crc32("VQHZHNV",7) == 1880502682) strcat(s, "K");
if (crc32("fzMLdIGArX",10) == 2724835214) strcat(s, "o");
if (crc32("sIbEkdEBb",9) == 390967483) strcat(s, "g");
if (crc32("VedwSl",6) == 813749435) strcat(s, "r");
if (crc32("KMVArRktdiS",11) == 676918253) strcat(s, "r");
if (crc32("wuFuUsaSZMKo",12) == 2665041597) strcat(s, "o");
if (crc32("araHk",5) == 143859005) strcat(s, "a");
if (crc32("YZhuCZ",6) == 915061695) strcat(s, "c");
if (crc32("qgmnUl",6) == 1382258956) strcat(s, "p");
if (crc32("GCDclZZTjEx",11) == 746999316) strcat(s, "W");
if (crc32("ouonqy",6) == 1201927107) strcat(s, "h");
if (crc32("wybumiJzzV",10) == 2208851430) strcat(s, "J");
if (crc32("sZmeRspgHtbzoI",14) == 3219468624) strcat(s, "i");
if (crc32("eyIeDmnvwuVw",12) == 3214470948) strcat(s, "c");
    return s;
}

char *subaqueous_adjectives() {
    char *s = calloc(11);
    if (crc32("LaeyC",5) == 2231548069) strcat(s, "A");
if (crc32("SbWHzAIurpJAIY",14) == 1775475029) strcat(s, "s");
if (crc32("YSvGueuKAOYCB",13) == 1212506728) strcat(s, "r");
if (crc32("tUinSoVVeLIeq",13) == 759393934) strcat(s, "u");
if (crc32("pRYkVSOxMcMmpV",14) == 3117989219) strcat(s, "b");
if (crc32("zZrkwfZWagQ",11) == 564598970) strcat(s, "w");
if (crc32("tgxME",5) == 1963115287) strcat(s, "a");
if (crc32("TcsAnTKtng",10) == 1041281496) strcat(s, "q");
if (crc32("mvWycKMCOSgW",12) == 448038851) strcat(s, "u");
if (crc32("MxjrjkqguuLF",12) == 166961284) strcat(s, "s");
if (crc32("KwegUyi",7) == 2592080667) strcat(s, "e");
if (crc32("wgVvNa",6) == 673946728) strcat(s, "c");
if (crc32("IietBfZOnLYTkw",14) == 2962101585) strcat(s, "o");
if (crc32("AKGDBYCuQFptymD",15) == 716031554) strcat(s, "u");
if (crc32("rZBGOGiVi",9) == 3137358739) strcat(s, "C");
if (crc32("fbxVbkQkwaIGJsP",15) == 2335288288) strcat(s, "s");
    return s;
}

char *blastodermatic_adjectives() {
    char *s = calloc(15);
    if (crc32("wlaFJWUUawlh",12) == 774140237) strcat(s, "m");
if (crc32("QZvmHczIpYC",11) == 3362889192) strcat(s, "b");
if (crc32("zHknosFrC",9) == 647030602) strcat(s, "l");
if (crc32("MCMPtyCV",8) == 3146717222) strcat(s, "e");
if (crc32("UPNrVyldZFcHZrS",15) == 3870025708) strcat(s, "a");
if (crc32("iFZFS",5) == 1725971891) strcat(s, "f");
if (crc32("rDpXud",6) == 1264321670) strcat(s, "s");
if (crc32("HxuAZR",6) == 3579300612) strcat(s, "b");
if (crc32("BSuEOnQQoKAa",12) == 3883674783) strcat(s, "t");
if (crc32("MgJSfveX",8) == 2369598763) strcat(s, "K");
if (crc32("AyoZNVbgIi",10) == 201321314) strcat(s, "o");
if (crc32("iUouL",5) == 3229225380) strcat(s, "d");
if (crc32("zkNFgXqb",8) == 3273572729) strcat(s, "X");
if (crc32("WQNZaFsnvnjXQNQ",15) == 2555124256) strcat(s, "e");
if (crc32("HuOBc",5) == 2675073955) strcat(s, "r");
if (crc32("lUzStMqVnnn",11) == 1113120166) strcat(s, "m");
if (crc32("AXijfOa",7) == 1585093860) strcat(s, "a");
if (crc32("mlawsREHYgqQH",13) == 3629061782) strcat(s, "t");
if (crc32("RPFEG",5) == 395128866) strcat(s, "k");
if (crc32("NmwnrUvVlwfYHFX",15) == 1665632359) strcat(s, "i");
if (crc32("tDALfZ",6) == 1848848330) strcat(s, "c");
    return s;
}

char *premaxillary_adjectives() {
    char *s = calloc(13);
    if (crc32("gveMZeEUpBGhKvv",15) == 2201540449) strcat(s, "p");
if (crc32("hlILAObQCnwqCIb",15) == 1340344452) strcat(s, "r");
if (crc32("ZLuvlsdZV",9) == 595593345) strcat(s, "p");
if (crc32("xvkrRpQBgukz",12) == 1691223717) strcat(s, "e");
if (crc32("qgadGBerqcBS",12) == 10955266) strcat(s, "m");
if (crc32("PyrIqwsg",8) == 251938887) strcat(s, "a");
if (crc32("waOocFrwzWPFl",13) == 2242171293) strcat(s, "a");
if (crc32("qLgdxCnGZwf",11) == 1862293185) strcat(s, "x");
if (crc32("kESnzkCovcb",11) == 427358409) strcat(s, "y");
if (crc32("ywWenFYYkSKgZr",14) == 1203053045) strcat(s, "i");
if (crc32("RTAWhXRjmAUCJyo",15) == 3003283657) strcat(s, "l");
if (crc32("PmPaeGZlKjw",11) == 3155149199) strcat(s, "l");
if (crc32("SuXsbBzLxxze",12) == 3008106293) strcat(s, "y");
if (crc32("NwrQsgHpwuOBDWL",15) == 4227036031) strcat(s, "a");
if (crc32("xITkhlW",7) == 3596048477) strcat(s, "A");
if (crc32("hyxnPeqbEp",10) == 3238069984) strcat(s, "r");
if (crc32("kbKTdEQTRHLvZLp",15) == 2260501910) strcat(s, "y");
    return s;
}

char *squally_adjectives() {
    char *s = calloc(8);
    if (crc32("nhEuAnv",7) == 1031061917) strcat(s, "I");
if (crc32("PDKPVyfygbUIy",13) == 3620878164) strcat(s, "s");
if (crc32("CqAWW",5) == 333655019) strcat(s, "h");
if (crc32("rlJjoqrTzvel",12) == 1768033130) strcat(s, "q");
if (crc32("KXAWHP",6) == 3679954005) strcat(s, "k");
if (crc32("ukVVhGwXyLe",11) == 2324666274) strcat(s, "u");
if (crc32("GgTsFmCjmDXOk",13) == 2675604993) strcat(s, "X");
if (crc32("XvEhAdxnAZQM",12) == 2062464118) strcat(s, "a");
if (crc32("gsMkmZOciTCS",12) == 3671037577) strcat(s, "v");
if (crc32("nGELCcUC",8) == 139473681) strcat(s, "l");
if (crc32("rlJRyeeezN",10) == 3705224957) strcat(s, "l");
if (crc32("QNYLPcmQX",9) == 843745488) strcat(s, "e");
if (crc32("ammVYCmbyPaJhA",14) == 483342020) strcat(s, "y");
    return s;
}

char *semiconditioned_adjectives() {
    char *s = calloc(16);
    if (crc32("zijNvxRxtywDvYT",15) == 3426083075) strcat(s, "J");
if (crc32("XSuUWvVfHQAeRyq",15) == 472802408) strcat(s, "s");
if (crc32("TrKUZeITDUp",11) == 2100825403) strcat(s, "l");
if (crc32("KsnuI",5) == 2408186778) strcat(s, "e");
if (crc32("qirgxiDCeFUqNvK",15) == 991835359) strcat(s, "t");
if (crc32("xxccrpqWc",9) == 2057715439) strcat(s, "m");
if (crc32("SNydyZIvAjB",11) == 543842020) strcat(s, "y");
if (crc32("QjELRCpnFdhOF",13) == 3537472553) strcat(s, "i");
if (crc32("MGAmfsfko",9) == 1407959689) strcat(s, "W");
if (crc32("uTXlUQvwEjh",11) == 2259454609) strcat(s, "c");
if (crc32("JVBgC",5) == 2356171631) strcat(s, "o");
if (crc32("ueJDEr",6) == 3223152513) strcat(s, "t");
if (crc32("lkQhkoa",7) == 3573169542) strcat(s, "n");
if (crc32("XUGVRfEIi",9) == 2277858235) strcat(s, "N");
if (crc32("LYYwlUv",7) == 3385516943) strcat(s, "d");
if (crc32("EpSFp",5) == 2782038510) strcat(s, "i");
if (crc32("NPnnDNpULQvU",12) == 492586512) strcat(s, "t");
if (crc32("nLvfkLE",7) == 1649324411) strcat(s, "k");
if (crc32("zSotbzA",7) == 1057554977) strcat(s, "i");
if (crc32("wmQCoZzQaZr",11) == 4258163338) strcat(s, "o");
if (crc32("ZVgitST",7) == 896578660) strcat(s, "b");
if (crc32("PxBetYgl",8) == 357110622) strcat(s, "n");
if (crc32("MyGXtF",6) == 1179024756) strcat(s, "e");
if (crc32("LbDqQHarQojSKEt",15) == 2033630135) strcat(s, "k");
if (crc32("zfafq",5) == 918391600) strcat(s, "d");
    return s;
}

char *sodless_adjectives() {
    char *s = calloc(8);
    if (crc32("zoNHEFi",7) == 244047637) strcat(s, "T");
if (crc32("lyhQsjwzCJ",10) == 1310355811) strcat(s, "s");
if (crc32("WHuFybvJP",9) == 964667419) strcat(s, "o");
if (crc32("UynCi",5) == 3431051817) strcat(s, "a");
if (crc32("LyeVHoKGZNp",11) == 3225853344) strcat(s, "d");
if (crc32("hicYMwiahDp",11) == 1781254778) strcat(s, "T");
if (crc32("wgfPRWD",7) == 2539534258) strcat(s, "l");
if (crc32("cLTnRtFJg",9) == 2245915795) strcat(s, "X");
if (crc32("wCSUJADbyOnRkS",14) == 3690540566) strcat(s, "e");
if (crc32("dNaLPQ",6) == 3273264103) strcat(s, "r");
if (crc32("BKHLLMaHFn",10) == 1964137033) strcat(s, "s");
if (crc32("brgabuonujJLNU",14) == 2829293301) strcat(s, "e");
if (crc32("vZRZFATIZd",10) == 3795497646) strcat(s, "s");
    return s;
}

char *tricksiest_adjectives() {
    char *s = calloc(11);
    if (crc32("wbDbQLp",7) == 657002856) strcat(s, "r");
if (crc32("pvKPIyKCoH",10) == 3110529992) strcat(s, "t");
if (crc32("NgLPhCpEWaRbVI",14) == 2263690718) strcat(s, "r");
if (crc32("FyMSKpvAyXipg",13) == 515846897) strcat(s, "i");
if (crc32("dXYEAJiFX",9) == 2637304708) strcat(s, "c");
if (crc32("WObLAAsBDwaLioS",15) == 246240995) strcat(s, "X");
if (crc32("ZHzyzBiSNQX",11) == 1366242435) strcat(s, "k");
if (crc32("zLOYJeWQRJB",11) == 1889253863) strcat(s, "r");
if (crc32("HXFSMTt",7) == 4121120953) strcat(s, "s");
if (crc32("jneonGYOtPctSGe",15) == 1573569991) strcat(s, "U");
if (crc32("QDJbwwTYYpFGcxr",15) == 573020820) strcat(s, "i");
if (crc32("esDsMpjwQnqmJb",14) == 329572792) strcat(s, "e");
if (crc32("chdZyxiYlNZHy",13) == 2640946380) strcat(s, "e");
if (crc32("vARAVzfTNykvkTx",15) == 1048759057) strcat(s, "s");
if (crc32("vwalYJmkJAXfDC",14) == 3543729177) strcat(s, "t");
    return s;
}

char *postdiphtherial_adjectives() {
    char *s = calloc(16);
    if (crc32("FdAGtongG",9) == 6023768) strcat(s, "p");
if (crc32("AXBuehoFct",10) == 1895949465) strcat(s, "o");
if (crc32("KEAzbUIPitt",11) == 2545775061) strcat(s, "s");
if (crc32("liSaCIgrwFrka",13) == 3900119348) strcat(s, "J");
if (crc32("MIDnCWvZrD",10) == 3432581975) strcat(s, "t");
if (crc32("bVCkabwOAZP",11) == 129267036) strcat(s, "d");
if (crc32("dkkiLliI",8) == 1695776649) strcat(s, "i");
if (crc32("gubBC",5) == 3608686093) strcat(s, "p");
if (crc32("gwkmihjalfBw",12) == 1063870478) strcat(s, "h");
if (crc32("fspULQTUPV",10) == 1084376454) strcat(s, "t");
if (crc32("XqOcwh",6) == 1063049487) strcat(s, "h");
if (crc32("qNorENwwyctYrl",14) == 1607727643) strcat(s, "S");
if (crc32("gWcXiG",6) == 968601250) strcat(s, "e");
if (crc32("xDTbHiltlISQefK",15) == 1821050247) strcat(s, "r");
if (crc32("WkKZdiTdj",9) == 2394705382) strcat(s, "S");
if (crc32("MKcguvgs",8) == 3689506517) strcat(s, "i");
if (crc32("LQwOj",5) == 2745733067) strcat(s, "a");
if (crc32("dAfqYluRlOcO",12) == 3248544784) strcat(s, "l");
    return s;
}

char *Pannonian_adjectives() {
    char *s = calloc(10);
    if (crc32("pkwLgtCHbwPRrNz",15) == 2716369697) strcat(s, "P");
if (crc32("TDMWdRNhIG",10) == 2707118148) strcat(s, "a");
if (crc32("HtjdEe",6) == 4110955937) strcat(s, "n");
if (crc32("bhDDEAHjh",9) == 2723561932) strcat(s, "n");
if (crc32("DLoGQFVmkpflq",13) == 193363375) strcat(s, "G");
if (crc32("fxmPQYsdfWmKB",13) == 1261275305) strcat(s, "o");
if (crc32("pmNiCNYzk",9) == 1858995107) strcat(s, "n");
if (crc32("siWAMHVJ",8) == 3471380298) strcat(s, "u");
if (crc32("kywJQ",5) == 2041833071) strcat(s, "i");
if (crc32("jWbgUE",6) == 3795436634) strcat(s, "T");
if (crc32("VhSEHqMPyChA",12) == 1996795237) strcat(s, "a");
if (crc32("jnuPgMtgHLJEYMW",15) == 1356674735) strcat(s, "X");
if (crc32("yRGfxrOPJbtED",13) == 4130862916) strcat(s, "n");
    return s;
}

char *highclass_adjectives() {
    char *s = calloc(10);
    if (crc32("wbFMEJHpYphoA",13) == 4076580375) strcat(s, "h");
if (crc32("iKgXsUauyBGX",12) == 3758073765) strcat(s, "i");
if (crc32("TGSnqQdQI",9) == 836427865) strcat(s, "U");
if (crc32("ChRJlXjeQHtsf",13) == 1805974881) strcat(s, "g");
if (crc32("fMQlx",5) == 1137077298) strcat(s, "h");
if (crc32("phMHIiaFaFvrk",13) == 3473047034) strcat(s, "c");
if (crc32("fwRojZQCX",9) == 2258972853) strcat(s, "l");
if (crc32("aLupzZDQHac",11) == 2233765110) strcat(s, "a");
if (crc32("PTesztkAs",9) == 3517143391) strcat(s, "P");
if (crc32("mMjrBWHMAgOil",13) == 2342169460) strcat(s, "s");
if (crc32("sLqslftIC",9) == 949028430) strcat(s, "S");
if (crc32("LCtcbpmbF",9) == 4014774589) strcat(s, "s");
    return s;
}

char *unbigoted_adjectives() {
    char *s = calloc(10);
    if (crc32("zoaeZQNYtkhpZq",14) == 1551674281) strcat(s, "r");
if (crc32("osnkRFEL",8) == 2315390750) strcat(s, "u");
if (crc32("uIUdtOzMDkAmK",13) == 422218884) strcat(s, "i");
if (crc32("FJNymkuq",8) == 1405030544) strcat(s, "n");
if (crc32("rNIOosQMKpEi",12) == 1180754314) strcat(s, "b");
if (crc32("aXblR",5) == 2519832263) strcat(s, "s");
if (crc32("FnmgsZb",7) == 4198887154) strcat(s, "i");
if (crc32("DPVhuAreoMTN",12) == 654310072) strcat(s, "g");
if (crc32("NamCE",5) == 1361281233) strcat(s, "P");
if (crc32("ckYmsRb",7) == 3301449040) strcat(s, "o");
if (crc32("cmKOzDyjL",9) == 1816621010) strcat(s, "t");
if (crc32("xAzqCqOVowzoeqC",15) == 363084981) strcat(s, "e");
if (crc32("sFUcuuYPVqfY",12) == 4279777102) strcat(s, "d");
    return s;
}

char *unmatriculated_adjectives() {
    char *s = calloc(15);
    if (crc32("MyqDEPRDoLmdoK",14) == 2402921505) strcat(s, "u");
if (crc32("LMlCuVd",7) == 1529023727) strcat(s, "B");
if (crc32("MhScLMgcy",9) == 2288770271) strcat(s, "n");
if (crc32("IPgnuwBhC",9) == 2970780111) strcat(s, "V");
if (crc32("qngKZAsvJyje",12) == 2040083110) strcat(s, "m");
if (crc32("fDomRbQwlg",10) == 710493662) strcat(s, "f");
if (crc32("vHgUNDLH",8) == 3043541120) strcat(s, "a");
if (crc32("iWIEdffqbLM",11) == 628174782) strcat(s, "E");
if (crc32("HUavnvdiXvA",11) == 1332308388) strcat(s, "t");
if (crc32("VOoyj",5) == 3332714472) strcat(s, "y");
if (crc32("TJrKRTbFbVANF",13) == 426665578) strcat(s, "r");
if (crc32("hgRZK",5) == 3594556812) strcat(s, "k");
if (crc32("yXEobRuhA",9) == 2942875412) strcat(s, "i");
if (crc32("kUtkhv",6) == 2543794221) strcat(s, "c");
if (crc32("ByMPReVHFpF",11) == 648796799) strcat(s, "W");
if (crc32("HAYXtTZPLEcT",12) == 959724561) strcat(s, "u");
if (crc32("uIDPbInHAvJiMD",14) == 3998070288) strcat(s, "l");
if (crc32("ttfIBlYX",8) == 1866414989) strcat(s, "h");
if (crc32("IrTNuPQpR",9) == 2778659859) strcat(s, "a");
if (crc32("TCgzPWnZX",9) == 2204758004) strcat(s, "t");
if (crc32("TZxVuiqWVfQ",11) == 2447192700) strcat(s, "e");
if (crc32("mcwXbfaWGU",10) == 164404696) strcat(s, "d");
    return s;
}

char *nonvirginal_adjectives() {
    char *s = calloc(12);
    if (crc32("TCQgCDhn",8) == 227642745) strcat(s, "N");
if (crc32("KFTJBRU",7) == 3687384541) strcat(s, "n");
if (crc32("wixqryajB",9) == 423131736) strcat(s, "p");
if (crc32("tjbmxl",6) == 2150709486) strcat(s, "o");
if (crc32("NtfcbbOEnfdchsd",15) == 398105123) strcat(s, "R");
if (crc32("QEMifIBqDSSIA",13) == 1939260286) strcat(s, "n");
if (crc32("ssqugjBEI",9) == 1543707027) strcat(s, "x");
if (crc32("ArvHZafqc",9) == 4074402012) strcat(s, "v");
if (crc32("ZyOytBxiUQpOUY",14) == 1892803056) strcat(s, "y");
if (crc32("lJSIUsO",7) == 1846601766) strcat(s, "i");
if (crc32("NrCWK",5) == 2939995262) strcat(s, "L");
if (crc32("qIPUTPknlP",10) == 263872519) strcat(s, "r");
if (crc32("fFPaFDaatDn",11) == 2113895393) strcat(s, "y");
if (crc32("IeaiEt",6) == 3602738326) strcat(s, "g");
if (crc32("KsZCF",5) == 3041641010) strcat(s, "i");
if (crc32("PKQRkxBeatI",11) == 1599428228) strcat(s, "D");
if (crc32("gojbL",5) == 3818189181) strcat(s, "n");
if (crc32("bdPnXFkz",8) == 4008586739) strcat(s, "a");
if (crc32("WEKPJl",6) == 1583429029) strcat(s, "l");
    return s;
}

char *unbesprinkled_adjectives() {
    char *s = calloc(14);
    if (crc32("xcDQYivCERgiSzC",15) == 1347162211) strcat(s, "u");
if (crc32("Oxgvnpwn",8) == 1812459751) strcat(s, "n");
if (crc32("dkEMqSBeEn",10) == 2198564945) strcat(s, "j");
if (crc32("kFsPINSCoMGjRcU",15) == 1107652478) strcat(s, "b");
if (crc32("zxhpqbGmiE",10) == 1899352192) strcat(s, "e");
if (crc32("nJwWHGODITt",11) == 1979995514) strcat(s, "s");
if (crc32("AOFOV",5) == 3778582774) strcat(s, "p");
if (crc32("hVxDLYFoGytQIBG",15) == 1810541185) strcat(s, "c");
if (crc32("xCsrCNWnbw",10) == 1528129480) strcat(s, "r");
if (crc32("HqGRzAoHBJP",11) == 1749701794) strcat(s, "i");
if (crc32("QYxuLMx",7) == 757628838) strcat(s, "H");
if (crc32("mcwTDg",6) == 27578377) strcat(s, "n");
if (crc32("wMYfxJHAGbGIvLT",15) == 273683831) strcat(s, "k");
if (crc32("PXzLzVqpNSab",12) == 3528249163) strcat(s, "l");
if (crc32("IlkNtuHlFJXHBLH",15) == 3580673544) strcat(s, "j");
if (crc32("cDnAaPPP",8) == 3801711870) strcat(s, "e");
if (crc32("QVFPXsrlPLtQST",14) == 4156556018) strcat(s, "y");
if (crc32("WriqZN",6) == 3782625764) strcat(s, "d");
    return s;
}

char *ovine_adjectives() {
    char *s = calloc(6);
    if (crc32("jpmue",5) == 1358985338) strcat(s, "o");
if (crc32("QGMqf",5) == 742695557) strcat(s, "j");
if (crc32("YgNnPJFlKfwTn",13) == 274629594) strcat(s, "v");
if (crc32("afQzLlV",7) == 1563522597) strcat(s, "i");
if (crc32("CHKYrppKZ",9) == 2209614591) strcat(s, "h");
if (crc32("SHDgGcRrVL",10) == 1578168681) strcat(s, "n");
if (crc32("NglIpbeCb",9) == 1509439223) strcat(s, "y");
if (crc32("ajjOQqgy",8) == 9359643) strcat(s, "e");
    return s;
}

char *undisparaged_adjectives() {
    char *s = calloc(13);
    if (crc32("mSqGmxxT",8) == 2751948713) strcat(s, "g");
if (crc32("WnsRcdJY",8) == 1346470916) strcat(s, "u");
if (crc32("jebgHmrhKnh",11) == 1012872799) strcat(s, "n");
if (crc32("rQZEpKPxUYXpS",13) == 249268882) strcat(s, "J");
if (crc32("cjWxtvfNSfEr",12) == 3204089421) strcat(s, "d");
if (crc32("lKrLYjq",7) == 2534789626) strcat(s, "I");
if (crc32("AXeSEPdUoaE",11) == 2832768609) strcat(s, "i");
if (crc32("YbSuM",5) == 2619857879) strcat(s, "q");
if (crc32("RwiTGmrGkYcKwW",14) == 2219511981) strcat(s, "s");
if (crc32("ryEdUluvlS",10) == 2507347322) strcat(s, "W");
if (crc32("unjaAKKWcX",10) == 3992990084) strcat(s, "p");
if (crc32("khGBaAIA",8) == 2989924896) strcat(s, "a");
if (crc32("gFsMxJQGAxF",11) == 2173676681) strcat(s, "r");
if (crc32("sFlOpMDk",8) == 2562426174) strcat(s, "a");
if (crc32("dKfvetogzmPL",12) == 694732170) strcat(s, "g");
if (crc32("pvHXUSFSkD",10) == 1976647530) strcat(s, "n");
if (crc32("YRjBjax",7) == 4018194594) strcat(s, "e");
if (crc32("YGNhsHoVwIZ",11) == 830008617) strcat(s, "d");
    return s;
}

char *perishless_adjectives() {
    char *s = calloc(11);
    if (crc32("oSAGKMxTto",10) == 2059299791) strcat(s, "p");
if (crc32("opThGRwpkKLK",12) == 3001248527) strcat(s, "j");
if (crc32("BNPQdH",6) == 3413426376) strcat(s, "e");
if (crc32("xPtDmMB",7) == 330739581) strcat(s, "t");
if (crc32("MbcHCqXSWE",10) == 229288343) strcat(s, "r");
if (crc32("ucASKH",6) == 308789393) strcat(s, "i");
if (crc32("cCFzTKhMsQvsG",13) == 807226887) strcat(s, "g");
if (crc32("CmeHqlTaiKkardo",15) == 1214896055) strcat(s, "s");
if (crc32("wjrPz",5) == 2220205549) strcat(s, "h");
if (crc32("ihGdgJ",6) == 2396648885) strcat(s, "t");
if (crc32("pqLHqAol",8) == 2546874092) strcat(s, "l");
if (crc32("rVroNG",6) == 1149527472) strcat(s, "e");
if (crc32("zLLKW",5) == 998297291) strcat(s, "s");
if (crc32("oNXMB",5) == 421615219) strcat(s, "s");
    return s;
}

char *prepolice_adjectives() {
    char *s = calloc(10);
    if (crc32("oqSXvjA",7) == 1463338135) strcat(s, "A");
if (crc32("LSIEpcY",7) == 1700958585) strcat(s, "p");
if (crc32("RBifezENVDTAI",13) == 3244565814) strcat(s, "g");
if (crc32("qjtRcGWrTcHO",12) == 1210817173) strcat(s, "r");
if (crc32("eKOaP",5) == 3859115758) strcat(s, "A");
if (crc32("uybVKJDEMD",10) == 1555867304) strcat(s, "e");
if (crc32("IRhEcflDBQ",10) == 2297303655) strcat(s, "p");
if (crc32("XehMlBhS",8) == 587445603) strcat(s, "o");
if (crc32("yTvtLuHF",8) == 1793457147) strcat(s, "A");
if (crc32("ZlDyzC",6) == 893783453) strcat(s, "l");
if (crc32("NJvFOaZCGT",10) == 2084684706) strcat(s, "E");
if (crc32("iGyisMiGYiFy",12) == 1997786282) strcat(s, "i");
if (crc32("oiWJXMIRkx",10) == 2641584373) strcat(s, "c");
if (crc32("KoadM",5) == 1009296132) strcat(s, "t");
if (crc32("EfRtvkkNEkb",11) == 1335429125) strcat(s, "e");
    return s;
}

char *impactive_adjectives() {
    char *s = calloc(10);
    if (crc32("whghuiA",7) == 1650115342) strcat(s, "i");
if (crc32("jQkIkToYnF",10) == 2187870028) strcat(s, "J");
if (crc32("BcCZCMiDYusdna",14) == 3609584459) strcat(s, "m");
if (crc32("JDwASRfqI",9) == 2254443119) strcat(s, "p");
if (crc32("YZxGdxtL",8) == 1456790285) strcat(s, "n");
if (crc32("GtYISA",6) == 4140717198) strcat(s, "a");
if (crc32("cRKYCJsyK",9) == 1540830118) strcat(s, "c");
if (crc32("NtIsehojn",9) == 1572173866) strcat(s, "t");
if (crc32("hExVZGa",7) == 3116539449) strcat(s, "i");
if (crc32("ysQvoOTzLu",10) == 1253141274) strcat(s, "r");
if (crc32("expDMeOwt",9) == 396544273) strcat(s, "v");
if (crc32("sMiCDPFeIoOnVw",14) == 78737995) strcat(s, "e");
    return s;
}

char *flakeless_adjectives() {
    char *s = calloc(10);
    if (crc32("IqkWYFhmIdASZ",13) == 358200752) strcat(s, "f");
if (crc32("BbFbWtswhAnJA",13) == 3410223225) strcat(s, "l");
if (crc32("WBhLbhSCZfcnU",13) == 3845045965) strcat(s, "a");
if (crc32("SCFbsFIHAbokxxG",15) == 3581579857) strcat(s, "k");
if (crc32("JnQFJQGNeMqBjB",14) == 602579013) strcat(s, "s");
if (crc32("xHSlFkSMdi",10) == 1460123676) strcat(s, "e");
if (crc32("PnQYFfIJSOOCE",13) == 3843044806) strcat(s, "l");
if (crc32("aRatQDkQsUEQ",12) == 3079536033) strcat(s, "e");
if (crc32("XFODnLbbU",9) == 379776249) strcat(s, "s");
if (crc32("mPIENuAh",8) == 3265366504) strcat(s, "a");
if (crc32("cNHiuaRjAwXZUh",14) == 2095461104) strcat(s, "s");
    return s;
}

char *Ottomanlike_adjectives() {
    char *s = calloc(12);
    if (crc32("ODUKJySOd",9) == 3892062170) strcat(s, "S");
if (crc32("sJBpIWeLmI",10) == 987176443) strcat(s, "O");
if (crc32("enmYcMTBDHaVCb",14) == 1529132197) strcat(s, "s");
if (crc32("eYmhbOBIJN",10) == 3006884783) strcat(s, "t");
if (crc32("glzKtOqt",8) == 2287408897) strcat(s, "t");
if (crc32("ZPMdZyqlCUH",11) == 1202353710) strcat(s, "r");
if (crc32("GMlrG",5) == 4059238055) strcat(s, "o");
if (crc32("rgKsLbFx",8) == 464473753) strcat(s, "n");
if (crc32("VkGdztdEi",9) == 3649591521) strcat(s, "m");
if (crc32("lzqbFVaZZcRXv",13) == 4276588492) strcat(s, "a");
if (crc32("vTzRsx",6) == 2421968745) strcat(s, "n");
if (crc32("NthfLWjSC",9) == 2953215292) strcat(s, "q");
if (crc32("wRgFevJCYARadg",14) == 2557830233) strcat(s, "l");
if (crc32("hKtItbaoaQFjo",13) == 2505433484) strcat(s, "f");
if (crc32("jIrDjBFuvoZfGjC",15) == 2318050770) strcat(s, "i");
if (crc32("pLfZQ",5) == 3376305000) strcat(s, "e");
if (crc32("txZwyXXLzMOhkQP",15) == 711993842) strcat(s, "k");
if (crc32("WIPCxR",6) == 788028617) strcat(s, "e");
    return s;
}

char *proresearch_adjectives() {
    char *s = calloc(12);
    if (crc32("LLchDFKygM",10) == 3473503148) strcat(s, "p");
if (crc32("ktHGjSNzC",9) == 1067940683) strcat(s, "r");
if (crc32("ogMHkAf",7) == 887089843) strcat(s, "C");
if (crc32("qJFnBCdM",8) == 1352496300) strcat(s, "o");
if (crc32("sRGGegAfleZ",11) == 1297475227) strcat(s, "r");
if (crc32("BqPZAJV",7) == 3552608879) strcat(s, "W");
if (crc32("JKvyQ",5) == 714727414) strcat(s, "e");
if (crc32("YQOEIR",6) == 2325874530) strcat(s, "M");
if (crc32("GqoJRXVFpCuy",12) == 66912513) strcat(s, "s");
if (crc32("zmLZEBdErRlF",12) == 4245534108) strcat(s, "n");
if (crc32("ExsxBgBwe",9) == 2637330946) strcat(s, "e");
if (crc32("PerhMoNelL",10) == 4096719357) strcat(s, "U");
if (crc32("YZWGlLowFkfQP",13) == 1786638071) strcat(s, "a");
if (crc32("jwplhzk",7) == 1708911340) strcat(s, "r");
if (crc32("bsjWRCxPTbHBb",13) == 2965746771) strcat(s, "c");
if (crc32("oOfJvQdQbYM",11) == 3536217718) strcat(s, "E");
if (crc32("OIhBuLuHxiNZmw",14) == 2431119091) strcat(s, "h");
    return s;
}

char *sheathier_adjectives() {
    char *s = calloc(10);
    if (crc32("QifRzvYVzlRgTq",14) == 1323876964) strcat(s, "s");
if (crc32("xsnVSz",6) == 2243168749) strcat(s, "T");
if (crc32("BHmITadRHvjjNpr",15) == 86218259) strcat(s, "h");
if (crc32("RebkPxkUUiAoP",13) == 1634892943) strcat(s, "e");
if (crc32("yDvAgxbIsofd",12) == 3650449359) strcat(s, "s");
if (crc32("bVmmZupJda",10) == 661524289) strcat(s, "a");
if (crc32("KUcBYyZR",8) == 3833538542) strcat(s, "t");
if (crc32("nlgQf",5) == 3758067383) strcat(s, "V");
if (crc32("kmxmgcfGaQP",11) == 1843432183) strcat(s, "h");
if (crc32("tcPgXhrdR",9) == 3084307369) strcat(s, "r");
if (crc32("zAheJyWLp",9) == 3885884675) strcat(s, "i");
if (crc32("SBrWGMZzo",9) == 1179195306) strcat(s, "e");
if (crc32("btNOuLqohL",10) == 2435413351) strcat(s, "r");
    return s;
}

char *supermilitary_adjectives() {
    char *s = calloc(14);
    if (crc32("rBORBKjcInUFN",13) == 130700380) strcat(s, "s");
if (crc32("qpDgYGY",7) == 422649278) strcat(s, "u");
if (crc32("hngpBNizE",9) == 1282935514) strcat(s, "p");
if (crc32("jXqimJsIoYdEuI",14) == 1383197284) strcat(s, "q");
if (crc32("gFaoqNWdoKPpF",13) == 932155374) strcat(s, "e");
if (crc32("CEwDtXwFSSKJ",12) == 2940570580) strcat(s, "M");
if (crc32("yJTiJCIpGM",10) == 3640666924) strcat(s, "r");
if (crc32("xZvFes",6) == 3834952783) strcat(s, "P");
if (crc32("ERqyv",5) == 631108572) strcat(s, "m");
if (crc32("gaNPFJixDoTc",12) == 4028990321) strcat(s, "i");
if (crc32("gDUkxWwJTsrmC",13) == 4079207886) strcat(s, "T");
if (crc32("sPoaLlQK",8) == 3950600723) strcat(s, "l");
if (crc32("gCWkQCWUOMczPfJ",15) == 3418494489) strcat(s, "i");
if (crc32("CBBLxwmETMkHeI",14) == 2942416187) strcat(s, "t");
if (crc32("BoiQzuQGMGa",11) == 1099663855) strcat(s, "a");
if (crc32("qjmLyd",6) == 2798660783) strcat(s, "r");
if (crc32("aaCnwqYrmS",10) == 4227366365) strcat(s, "y");
    return s;
}

char *holomorphic_adjectives() {
    char *s = calloc(12);
    if (crc32("AOdtmpoKEI",10) == 258189580) strcat(s, "h");
if (crc32("GCLkZqRhxwjWSX",14) == 812469952) strcat(s, "o");
if (crc32("fXUtyAPXQfUl",12) == 3255657705) strcat(s, "O");
if (crc32("QRWdMFBfrDgy",12) == 3539943030) strcat(s, "l");
if (crc32("kEOnAfEjYh",10) == 1716552938) strcat(s, "o");
if (crc32("NTWGurb",7) == 2330012504) strcat(s, "b");
if (crc32("qHcDEkARNv",10) == 1527807866) strcat(s, "m");
if (crc32("AHfzDV",6) == 1282625659) strcat(s, "o");
if (crc32("DnTgnHzdYwH",11) == 1930969781) strcat(s, "r");
if (crc32("ywpDyGbWHJYl",12) == 2555294416) strcat(s, "v");
if (crc32("Iiwazf",6) == 3276505880) strcat(s, "p");
if (crc32("LbNcJ",5) == 1758678525) strcat(s, "h");
if (crc32("tAHLZJ",6) == 2157954566) strcat(s, "u");
if (crc32("utwAIEGNjqqn",12) == 474142291) strcat(s, "i");
if (crc32("anCwfoTrOCjvPw",14) == 3225470228) strcat(s, "c");
    return s;
}

char *Peruginesque_adjectives() {
    char *s = calloc(13);
    if (crc32("iYmYY",5) == 3720672567) strcat(s, "P");
if (crc32("sfPYNTsq",8) == 2776127349) strcat(s, "e");
if (crc32("MQcuimbw",8) == 1151529037) strcat(s, "r");
if (crc32("qYaXelzYqi",10) == 1238742561) strcat(s, "r");
if (crc32("vVHEIUbJSdXFb",13) == 2749452529) strcat(s, "u");
if (crc32("mGlWz",5) == 1671338100) strcat(s, "Q");
if (crc32("rPkGkopPyQSh",12) == 840342510) strcat(s, "g");
if (crc32("RpzzhQNwJmzlhU",14) == 3370714728) strcat(s, "b");
if (crc32("WDXiBDFKIw",10) == 1633183476) strcat(s, "i");
if (crc32("taBHfgAHetJlY",13) == 2118762601) strcat(s, "Y");
if (crc32("ZDuCfqKrO",9) == 3647665247) strcat(s, "n");
if (crc32("AcYzfTyDwKXRLu",14) == 3612410030) strcat(s, "e");
if (crc32("rzmbciCQlzqIBe",14) == 2482964410) strcat(s, "s");
if (crc32("BNIoex",6) == 2889271422) strcat(s, "z");
if (crc32("RjPPVDMkC",9) == 1717987769) strcat(s, "q");
if (crc32("PDdWxXZ",7) == 3005664891) strcat(s, "u");
if (crc32("yGTkFDf",7) == 4086809898) strcat(s, "A");
if (crc32("PdaGBO",6) == 60621436) strcat(s, "e");
    return s;
}

char *Casanovanic_adjectives() {
    char *s = calloc(12);
    if (crc32("QBfptXAEWV",10) == 3941191915) strcat(s, "e");
if (crc32("VNHNiR",6) == 2569575503) strcat(s, "C");
if (crc32("VzFUXxE",7) == 2664037364) strcat(s, "T");
if (crc32("ShgPaYpD",8) == 2504630465) strcat(s, "a");
if (crc32("MIFBZpKRco",10) == 2688447238) strcat(s, "M");
if (crc32("wcLIix",6) == 1025501549) strcat(s, "s");
if (crc32("LhROJXkuOGhKC",13) == 815995403) strcat(s, "a");
if (crc32("GOckIXE",7) == 3689186723) strcat(s, "n");
if (crc32("vYuzcRywSgkIgRR",15) == 3532561317) strcat(s, "o");
if (crc32("yXhHcDCpUYtOHiE",15) == 2639332033) strcat(s, "v");
if (crc32("dGwrpxgfaZyHVH",14) == 3298656476) strcat(s, "S");
if (crc32("lXXHBebEkmCYNcc",15) == 2135743374) strcat(s, "a");
if (crc32("nYubyvzcONWlhSE",15) == 2056664298) strcat(s, "n");
if (crc32("OmvLPqjvBcXhIm",14) == 2121763779) strcat(s, "L");
if (crc32("Uqubr",5) == 1588118481) strcat(s, "i");
if (crc32("KBWytAdOkJplDa",14) == 3958120927) strcat(s, "c");
    return s;
}

char *circumstantial_adjectives() {
    char *s = calloc(15);
    if (crc32("lgposaIGbGX",11) == 667519079) strcat(s, "c");
if (crc32("fxiYZU",6) == 69658646) strcat(s, "a");
if (crc32("JVjWYyewFf",10) == 1291067938) strcat(s, "i");
if (crc32("tKaKdCmHJzOSdG",14) == 206272957) strcat(s, "a");
if (crc32("ZibrqlYiAXxjJRx",15) == 1811167572) strcat(s, "r");
if (crc32("qMQFPxyaqOva",12) == 3421709603) strcat(s, "c");
if (crc32("fUfJJHvCvZDdSy",14) == 2816714612) strcat(s, "p");
if (crc32("FwSjcMAGUc",10) == 2072677089) strcat(s, "u");
if (crc32("xecwNoUB",8) == 1618975959) strcat(s, "o");
if (crc32("Xtgitb",6) == 1414917797) strcat(s, "m");
if (crc32("cVuvM",5) == 3588547352) strcat(s, "s");
if (crc32("frxdHEJxWsBxX",13) == 1338201619) strcat(s, "N");
if (crc32("haunQPAMGWLvg",13) == 2795997509) strcat(s, "t");
if (crc32("bslVQXGoxuToO",13) == 3185546744) strcat(s, "a");
if (crc32("jYqleMSwuBrX",12) == 2895619516) strcat(s, "u");
if (crc32("AHbZLjd",7) == 1997844625) strcat(s, "n");
if (crc32("lQsIENEWVAyz",12) == 4044278136) strcat(s, "t");
if (crc32("TJxCTKpp",8) == 2989387238) strcat(s, "K");
if (crc32("mOHooIsxTDX",11) == 750224793) strcat(s, "i");
if (crc32("dxnoyoUhvXppE",13) == 82114982) strcat(s, "a");
if (crc32("RsOvabxlpLoM",12) == 1664198152) strcat(s, "l");
    return s;
}

char *quasisuperficial_adjectives() {
    char *s = calloc(17);
    if (crc32("kADgEHIjsT",10) == 3445458203) strcat(s, "x");
if (crc32("wdQYMmefdF",10) == 3585681896) strcat(s, "q");
if (crc32("DhjrCAgJM",9) == 2093815820) strcat(s, "u");
if (crc32("HvXVOWcVb",9) == 2677690455) strcat(s, "D");
if (crc32("xLInHftmDIb",11) == 2238942477) strcat(s, "a");
if (crc32("UPBqlgRkKgwdxYc",15) == 3728939182) strcat(s, "s");
if (crc32("bNVABT",6) == 196234002) strcat(s, "r");
if (crc32("lbAsvxYiexqx",12) == 3533217449) strcat(s, "i");
if (crc32("NGoRF",5) == 1939547871) strcat(s, "s");
if (crc32("CqlQMpeuYedviPC",15) == 441135648) strcat(s, "y");
if (crc32("CyGEbm",6) == 3633733808) strcat(s, "u");
if (crc32("FTKOsBBdZyK",11) == 2388105082) strcat(s, "Q");
if (crc32("LgPwTQmSBcJYN",13) == 1113312662) strcat(s, "p");
if (crc32("JXAwoB",6) == 532880122) strcat(s, "e");
if (crc32("RXSMxtRrzIKLxTd",15) == 1150176742) strcat(s, "g");
if (crc32("UJQKGGSEhlHQn",13) == 1702700552) strcat(s, "r");
if (crc32("tckfqnCJRZjxvQB",15) == 629313027) strcat(s, "f");
if (crc32("DxHHXoceBgux",12) == 2968155909) strcat(s, "i");
if (crc32("CWKQwUndqBZzsf",14) == 1238102572) strcat(s, "c");
if (crc32("vulurh",6) == 539046110) strcat(s, "i");
if (crc32("ZLzdxC",6) == 980032755) strcat(s, "f");
if (crc32("SLuNamv",7) == 2635253254) strcat(s, "a");
if (crc32("KZXTWfHA",8) == 575084555) strcat(s, "s");
if (crc32("QMqczRYBy",9) == 2941976235) strcat(s, "l");
    return s;
}

char *disintegratory_adjectives() {
    char *s = calloc(15);
    if (crc32("sLYMejZCslnH",12) == 540692816) strcat(s, "d");
if (crc32("wInMaoIUsXNkQj",14) == 4129635051) strcat(s, "i");
if (crc32("cLIbcGgDnjSs",12) == 447812963) strcat(s, "N");
if (crc32("BdGwdPj",7) == 2577685744) strcat(s, "s");
if (crc32("RVAaQsl",7) == 961324321) strcat(s, "Q");
if (crc32("wPObPYtEZTb",11) == 585332238) strcat(s, "i");
if (crc32("bxGrfGCdJaJ",11) == 350836962) strcat(s, "n");
if (crc32("fWAzAQOLs",9) == 645051769) strcat(s, "t");
if (crc32("DmLAfGPfmrwMtQV",15) == 3613228444) strcat(s, "F");
if (crc32("EYThJWHvnBfxkz",14) == 3338965545) strcat(s, "e");
if (crc32("OeJkCzNrZTfarVW",15) == 48311591) strcat(s, "g");
if (crc32("KRDNlPZUpxn",11) == 1267935883) strcat(s, "r");
if (crc32("XDBoZXUrbQxLS",13) == 3279321818) strcat(s, "S");
if (crc32("HMonuKrzJGr",11) == 177344026) strcat(s, "a");
if (crc32("HDMrkilbAzXrcUh",15) == 3664549136) strcat(s, "D");
if (crc32("QSKqwqkuqGrY",12) == 2864069952) strcat(s, "t");
if (crc32("ijTgcHIgNFMl",12) == 3496098541) strcat(s, "o");
if (crc32("dpNvTiYLuQ",10) == 4195794407) strcat(s, "r");
if (crc32("oUjlDDYw",8) == 3914015776) strcat(s, "U");
if (crc32("JUpkpSqueLCY",12) == 1940727579) strcat(s, "y");
    return s;
}

char *nonpermissible_adjectives() {
    char *s = calloc(15);
    if (crc32("QRkOysp",7) == 2066387552) strcat(s, "n");
if (crc32("zwRCmhc",7) == 833720100) strcat(s, "o");
if (crc32("PRiFxyETp",9) == 1667343227) strcat(s, "n");
if (crc32("DSuFUZjDGUVee",13) == 960179981) strcat(s, "p");
if (crc32("msebJmZWQ",9) == 3061480024) strcat(s, "b");
if (crc32("WLvUOXEgmSFK",12) == 1483573149) strcat(s, "e");
if (crc32("Bnnakjfgzu",10) == 1939995035) strcat(s, "b");
if (crc32("apGXyxpuewLM",12) == 3699603717) strcat(s, "r");
if (crc32("uOysEgr",7) == 2253441441) strcat(s, "l");
if (crc32("fAudxFagBiV",11) == 218575401) strcat(s, "m");
if (crc32("PDbjWuYda",9) == 2308458836) strcat(s, "c");
if (crc32("hPdHWvzCfwQh",12) == 1526219821) strcat(s, "i");
if (crc32("vfsNHOlSigUap",13) == 3830211409) strcat(s, "M");
if (crc32("iyfEhzj",7) == 732177153) strcat(s, "s");
if (crc32("fKoMZriKK",9) == 1575707712) strcat(s, "y");
if (crc32("nAjbaTXldqlnD",13) == 3062208184) strcat(s, "s");
if (crc32("iSoeLV",6) == 303517820) strcat(s, "i");
if (crc32("cQaEVSARKZBN",12) == 1321151030) strcat(s, "b");
if (crc32("wWzfiIBIFKP",11) == 350041602) strcat(s, "t");
if (crc32("gFJyDqlpfesF",12) == 1722426689) strcat(s, "l");
if (crc32("BbZpqK",6) == 936081872) strcat(s, "e");
    return s;
}

char *noncorruptible_adjectives() {
    char *s = calloc(15);
    if (crc32("HiJGoiG",7) == 3472822878) strcat(s, "n");
if (crc32("ktLNfiNLy",9) == 2013653526) strcat(s, "i");
if (crc32("mwkGVsAITk",10) == 1670211282) strcat(s, "o");
if (crc32("xpsEkOPFqva",11) == 2521583886) strcat(s, "n");
if (crc32("XFuwLe",6) == 1729009953) strcat(s, "Y");
if (crc32("jtGqCNXsY",9) == 1444848791) strcat(s, "c");
if (crc32("ALKTilKvtHn",11) == 3025267162) strcat(s, "o");
if (crc32("JzcyUEQ",7) == 570533474) strcat(s, "D");
if (crc32("YlqkAOQbZHJ",11) == 2388264106) strcat(s, "r");
if (crc32("iECeJPqGiArAfR",14) == 2559755789) strcat(s, "F");
if (crc32("mwAunGFO",8) == 475634983) strcat(s, "r");
if (crc32("KVWuSwj",7) == 1954980348) strcat(s, "u");
if (crc32("ivmjzoHPmZXZjRo",15) == 4115484127) strcat(s, "V");
if (crc32("ncmlPgVuekmwtYw",15) == 2563735299) strcat(s, "p");
if (crc32("OukiJHisspz",11) == 138754389) strcat(s, "t");
if (crc32("yNpnuCyiATG",11) == 2568916280) strcat(s, "i");
if (crc32("ouYeqaFoELaZw",13) == 221436173) strcat(s, "b");
if (crc32("TbAmFa",6) == 975048969) strcat(s, "l");
if (crc32("XkUooWvr",8) == 3769190365) strcat(s, "e");
    return s;
}

char *SpanishAmerican_adjectives() {
    char *s = calloc(16);
    if (crc32("aWSJQoFTFV",10) == 3709817748) strcat(s, "S");
if (crc32("oJquHE",6) == 428773544) strcat(s, "Q");
if (crc32("vBsGDgYhL",9) == 2071221019) strcat(s, "p");
if (crc32("FivOc",5) == 2761528759) strcat(s, "a");
if (crc32("aNWaVKnjOFnXD",13) == 434480764) strcat(s, "t");
if (crc32("rcWMHDDW",8) == 3368591571) strcat(s, "n");
if (crc32("hwQJRLqAMv",10) == 1612131575) strcat(s, "C");
if (crc32("RSNqf",5) == 3048794090) strcat(s, "i");
if (crc32("rDkdpLmuRzZ",11) == 1223190042) strcat(s, "s");
if (crc32("dFJoMcKfuQG",11) == 3651773032) strcat(s, "h");
if (crc32("zYGjhteMtsVOmI",14) == 669414125) strcat(s, "A");
if (crc32("UOVlTyeim",9) == 2159192127) strcat(s, "j");
if (crc32("fQeTm",5) == 2724169) strcat(s, "m");
if (crc32("mjFXUs",6) == 70919093) strcat(s, "e");
if (crc32("gfMIkwx",7) == 831387875) strcat(s, "r");
if (crc32("mgplxIe",7) == 2891922878) strcat(s, "i");
if (crc32("SoXjspcxE",9) == 1332799018) strcat(s, "k");
if (crc32("JzaECgtQz",9) == 458954105) strcat(s, "c");
if (crc32("KChCqFmSz",9) == 3907521212) strcat(s, "o");
if (crc32("iKVDdsvMFef",11) == 2939435270) strcat(s, "a");
if (crc32("JHIicgkCEtJbRTK",15) == 2323865803) strcat(s, "E");
if (crc32("nxtaaUPc",8) == 3435721485) strcat(s, "n");
    return s;
}

char *farseeing_adjectives() {
    char *s = calloc(10);
    if (crc32("wQcgVxjnyStw",12) == 2931382625) strcat(s, "f");
if (crc32("XyRIznkh",8) == 88920665) strcat(s, "y");
if (crc32("xxKPdQCHi",9) == 4183048208) strcat(s, "a");
if (crc32("vqpgv",5) == 871697234) strcat(s, "D");
if (crc32("kINsTGozXwm",11) == 2779191508) strcat(s, "r");
if (crc32("hvHlVYDNLgqk",12) == 1379288061) strcat(s, "s");
if (crc32("GuIBZaIM",8) == 909982764) strcat(s, "e");
if (crc32("XHcgGXfHqC",10) == 2675787778) strcat(s, "e");
if (crc32("yudywXWKaHkQs",13) == 3480226906) strcat(s, "A");
if (crc32("iyiibGWV",8) == 4222034224) strcat(s, "i");
if (crc32("dqiGLpvpyzc",11) == 2398491525) strcat(s, "n");
if (crc32("xWLqeVSwGUx",11) == 2870855791) strcat(s, "X");
if (crc32("jaYvTP",6) == 4013575692) strcat(s, "g");
    return s;
}

char *neurogliac_adjectives() {
    char *s = calloc(11);
    if (crc32("sjHpu",5) == 1561483864) strcat(s, "n");
if (crc32("KZXbGYHe",8) == 3963628571) strcat(s, "y");
if (crc32("xjOuvMFiJCPVBwq",15) == 4071038412) strcat(s, "e");
if (crc32("LRzHlDMYFgqeHB",14) == 748048548) strcat(s, "W");
if (crc32("MiylEjj",7) == 1448942352) strcat(s, "u");
if (crc32("vvMgDyI",7) == 350364658) strcat(s, "h");
if (crc32("XVsbDfJrzjULot",14) == 84766940) strcat(s, "r");
if (crc32("GwldqVMum",9) == 381787888) strcat(s, "o");
if (crc32("ndHYJIim",8) == 2492111514) strcat(s, "K");
if (crc32("VVtxpBMZRMjUU",13) == 2143998565) strcat(s, "g");
if (crc32("SwocNx",6) == 1775955596) strcat(s, "l");
if (crc32("lBAoKZbDzwCqVN",14) == 559442648) strcat(s, "i");
if (crc32("oIFfirSzHpkQylS",15) == 1046212787) strcat(s, "r");
if (crc32("slybsVpFpj",10) == 1275074160) strcat(s, "a");
if (crc32("wiEtzXIX",8) == 2893578620) strcat(s, "c");
    return s;
}

char *unhawked_adjectives() {
    char *s = calloc(9);
    if (crc32("WbqQXPhBx",9) == 4127349411) strcat(s, "u");
if (crc32("taSJLfxtD",9) == 1612631161) strcat(s, "d");
if (crc32("dzdzUbTYRP",10) == 971504274) strcat(s, "n");
if (crc32("vyIkZ",5) == 3564876205) strcat(s, "h");
if (crc32("QmOyDaRaLpTs",12) == 2198890964) strcat(s, "a");
if (crc32("fbVChYKr",8) == 904233457) strcat(s, "q");
if (crc32("IpJeJaeIVXAAOZW",15) == 3029115119) strcat(s, "w");
if (crc32("hEObkjOZWF",10) == 545504121) strcat(s, "k");
if (crc32("iRityM",6) == 1068295181) strcat(s, "e");
if (crc32("EwZhzHgGHJWkUa",14) == 783755872) strcat(s, "d");
    return s;
}

char *twaddly_adjectives() {
    char *s = calloc(8);
    if (crc32("xMMCHGJO",8) == 1415473863) strcat(s, "t");
if (crc32("ijWjQ",5) == 3469143641) strcat(s, "M");
if (crc32("PNVJVbiiHLhqP",13) == 3332778587) strcat(s, "w");
if (crc32("yimuXbn",7) == 4250852995) strcat(s, "r");
if (crc32("CWtNrFHGz",9) == 1066166081) strcat(s, "a");
if (crc32("mQYlkYvDeyKh",12) == 3350617545) strcat(s, "d");
if (crc32("ARIDVsMhvX",10) == 520784271) strcat(s, "d");
if (crc32("oCtTNsR",7) == 3658547053) strcat(s, "l");
if (crc32("gcagjtPuHG",10) == 368224863) strcat(s, "P");
if (crc32("GWJWAA",6) == 1548683138) strcat(s, "y");
    return s;
}

char *unmanful_adjectives() {
    char *s = calloc(9);
    if (crc32("YTwEwbKIaPjV",12) == 3926662165) strcat(s, "u");
if (crc32("BkSbfEJvdLxUcY",14) == 3462317638) strcat(s, "d");
if (crc32("hYSlX",5) == 459793981) strcat(s, "n");
if (crc32("skbszorkoNpRyq",14) == 3419020263) strcat(s, "m");
if (crc32("STpitApFfjGdB",13) == 2230839335) strcat(s, "a");
if (crc32("NKoSfx",6) == 454717504) strcat(s, "d");
if (crc32("Dwaghru",7) == 1108223605) strcat(s, "n");
if (crc32("pocmbAipqnlIM",13) == 3558649828) strcat(s, "X");
if (crc32("TMmoattvT",9) == 1853399397) strcat(s, "f");
if (crc32("CbCHJICHxdBH",12) == 4157283141) strcat(s, "u");
if (crc32("NGuuJzdqNtH",11) == 3981990280) strcat(s, "s");
if (crc32("hQVVlhEeyUolAl",14) == 1053629626) strcat(s, "l");
    return s;
}

char *wellinvented_adjectives() {
    char *s = calloc(13);
    if (crc32("jiIJSEeVQOPgFsL",15) == 3329641205) strcat(s, "w");
if (crc32("ASjNNsH",7) == 1532155989) strcat(s, "e");
if (crc32("XgzVM",5) == 3579483860) strcat(s, "l");
if (crc32("hMUKRpp",7) == 974629341) strcat(s, "l");
if (crc32("NAIkONspVGXLUo",14) == 1107941077) strcat(s, "Z");
if (crc32("xrZMchafBmLZRQw",15) == 2184207621) strcat(s, "i");
if (crc32("AGhWYSNXNxJGSb",14) == 3917400493) strcat(s, "l");
if (crc32("SwQrMoFniMP",11) == 2895921932) strcat(s, "n");
if (crc32("DKttEel",7) == 2322069701) strcat(s, "v");
if (crc32("qbtGwmiTbBhr",12) == 3595664013) strcat(s, "e");
if (crc32("tLdrylfczOM",11) == 1372402254) strcat(s, "n");
if (crc32("dYuhg",5) == 811456855) strcat(s, "t");
if (crc32("leMFZ",5) == 2234847344) strcat(s, "Q");
if (crc32("nKxlyOncK",9) == 2093764045) strcat(s, "e");
if (crc32("sdunviimPi",10) == 3622137395) strcat(s, "z");
if (crc32("zVuQJnUDNlFPnA",14) == 3021505036) strcat(s, "d");
    return s;
}

char *tinfoil_adjectives() {
    char *s = calloc(8);
    if (crc32("NBAzKGrIBt",10) == 2594439678) strcat(s, "t");
if (crc32("OTOKZZwZmZr",11) == 2427902806) strcat(s, "i");
if (crc32("gxMlHYq",7) == 3615244725) strcat(s, "E");
if (crc32("jANyUJhxzd",10) == 3695093049) strcat(s, "n");
if (crc32("ANybS",5) == 1509743123) strcat(s, "l");
if (crc32("thXtQJakj",9) == 1533022305) strcat(s, "f");
if (crc32("yWVAHbXiqdET",12) == 3345018563) strcat(s, "g");
if (crc32("xOVvqL",6) == 2068111367) strcat(s, "o");
if (crc32("HPkPWRsSnDuulDo",15) == 3806545292) strcat(s, "q");
if (crc32("RCgntjyP",8) == 12212366) strcat(s, "i");
if (crc32("FYhAzOZ",7) == 3346375997) strcat(s, "X");
if (crc32("HjsdBrvHuGOzqD",14) == 290944505) strcat(s, "l");
    return s;
}

char *nonclarified_adjectives() {
    char *s = calloc(13);
    if (crc32("bgfFRR",6) == 3702143996) strcat(s, "u");
if (crc32("ZgMsX",5) == 193987245) strcat(s, "n");
if (crc32("IQxHeoDke",9) == 1952670448) strcat(s, "X");
if (crc32("tZKSaVX",7) == 511790016) strcat(s, "o");
if (crc32("LACTdmJGVbPq",12) == 1601926) strcat(s, "f");
if (crc32("LWiUKAd",7) == 3100617652) strcat(s, "n");
if (crc32("vffUjD",6) == 3763507122) strcat(s, "c");
if (crc32("OVEtyD",6) == 1352259470) strcat(s, "s");
if (crc32("DRrAbrDrfuWIAtd",15) == 404914598) strcat(s, "l");
if (crc32("WLIjckHhfWhHGU",14) == 2105575542) strcat(s, "a");
if (crc32("yyiHssRwofEL",12) == 661762051) strcat(s, "r");
if (crc32("vuGUar",6) == 882888177) strcat(s, "j");
if (crc32("iuEfreCZdSXiMcc",15) == 23112672) strcat(s, "i");
if (crc32("OreoHDKc",8) == 1127629757) strcat(s, "f");
if (crc32("ddkQahOr",8) == 630081816) strcat(s, "i");
if (crc32("VZgAvnSnSdmYSI",14) == 1323029515) strcat(s, "D");
if (crc32("LisdnXZrXdr",11) == 1381795787) strcat(s, "e");
if (crc32("zjgYHaaZRQXD",12) == 2197998981) strcat(s, "d");
    return s;
}

char *isographic_adjectives() {
    char *s = calloc(11);
    if (crc32("ecUllkIhR",9) == 502955367) strcat(s, "R");
if (crc32("QTyjpeCbVHTc",12) == 1377718603) strcat(s, "i");
if (crc32("kfmRIWALmpaJYe",14) == 3723037657) strcat(s, "s");
if (crc32("DpvsN",5) == 4168104344) strcat(s, "k");
if (crc32("QHHjsBXFe",9) == 3521677076) strcat(s, "o");
if (crc32("MCRlBJM",7) == 3991176510) strcat(s, "Z");
if (crc32("WXnQKmUDDkOwm",13) == 2389449577) strcat(s, "g");
if (crc32("mJMOgDKRjikJHf",14) == 3336307036) strcat(s, "r");
if (crc32("yCeoPEKTp",9) == 1445610251) strcat(s, "a");
if (crc32("kgozWdGP",8) == 556107999) strcat(s, "a");
if (crc32("MEbRj",5) == 2754767668) strcat(s, "p");
if (crc32("SpHJLdJuyfL",11) == 3892584489) strcat(s, "h");
if (crc32("kjZFdtlgrOwBYS",14) == 4075922812) strcat(s, "i");
if (crc32("GUYiMFnZ",8) == 3852276191) strcat(s, "c");
    return s;
}

char *nonphobic_adjectives() {
    char *s = calloc(10);
    if (crc32("IGuuqXuBtEZufki",15) == 2268215059) strcat(s, "n");
if (crc32("GlBymfpZK",9) == 1326950218) strcat(s, "Y");
if (crc32("vEciotdoFxBOMZ",14) == 655129398) strcat(s, "o");
if (crc32("CcoZRoJ",7) == 3291996232) strcat(s, "z");
if (crc32("PPXtPQvJ",8) == 3057726550) strcat(s, "n");
if (crc32("rhWZHCKFCGuF",12) == 3912441050) strcat(s, "p");
if (crc32("daSThWK",7) == 161772670) strcat(s, "r");
if (crc32("dSHFi",5) == 2683071451) strcat(s, "h");
if (crc32("YKsDuwobeGMo",12) == 2276879823) strcat(s, "o");
if (crc32("hDLbMczpZcehVvg",15) == 2567829898) strcat(s, "o");
if (crc32("LnCckRwMWs",10) == 2086488201) strcat(s, "b");
if (crc32("dZviHvgTg",9) == 2909101790) strcat(s, "I");
if (crc32("sNDCSHHJBDtmRYt",15) == 274063400) strcat(s, "i");
if (crc32("ZHZbMpnk",8) == 1373613966) strcat(s, "y");
if (crc32("LAwGI",5) == 2567906094) strcat(s, "c");
    return s;
}

char *pseudofaithful_adjectives() {
    char *s = calloc(15);
    if (crc32("eKbkvKLiYkyYw",13) == 933399030) strcat(s, "r");
if (crc32("xiAodhcG",8) == 2402775988) strcat(s, "p");
if (crc32("MLvLqtBaw",9) == 2712801593) strcat(s, "s");
if (crc32("FAYJhUOnUQ",10) == 3760716532) strcat(s, "Y");
if (crc32("ylbJU",5) == 433332386) strcat(s, "e");
if (crc32("BBHVF",5) == 3638275725) strcat(s, "u");
if (crc32("OeNjzRGpIIdQQ",13) == 1577289682) strcat(s, "S");
if (crc32("HqHdjXHgTZz",11) == 3040101933) strcat(s, "d");
if (crc32("uVpwn",5) == 2280850402) strcat(s, "o");
if (crc32("synopYOb",8) == 4232659937) strcat(s, "Y");
if (crc32("xWTCeVHLIPM",11) == 2340937868) strcat(s, "f");
if (crc32("hKvMCiRcAG",10) == 88033375) strcat(s, "a");
if (crc32("hftmVssfxnYlv",13) == 3618336309) strcat(s, "i");
if (crc32("GLmnT",5) == 709107574) strcat(s, "t");
if (crc32("EWeCMWWr",8) == 3330923960) strcat(s, "w");
if (crc32("dJMUedwpwiR",11) == 986445411) strcat(s, "h");
if (crc32("dmhusKI",7) == 826119705) strcat(s, "I");
if (crc32("rvOTd",5) == 3836365854) strcat(s, "f");
if (crc32("CrRZXbZ",7) == 4141654522) strcat(s, "u");
if (crc32("cgFMn",5) == 629913951) strcat(s, "l");
    return s;
}

char *wellbeaten_adjectives() {
    char *s = calloc(11);
    if (crc32("TiAXh",5) == 231538526) strcat(s, "w");
if (crc32("wzYDeTyRmbsSWoZ",15) == 3714899316) strcat(s, "e");
if (crc32("WCNXD",5) == 1965045743) strcat(s, "Q");
if (crc32("GFsNykmTxpDi",12) == 330037575) strcat(s, "l");
if (crc32("kPvqIE",6) == 1205840643) strcat(s, "q");
if (crc32("quRtnufzi",9) == 379555093) strcat(s, "l");
if (crc32("EjQWQrdCqeZqotK",15) == 2571990341) strcat(s, "Q");
if (crc32("yRdlBQBxJKug",12) == 3966716831) strcat(s, "b");
if (crc32("gqtgIpUGinhXxKn",15) == 1654146658) strcat(s, "p");
if (crc32("OATckmwjZr",10) == 1619441443) strcat(s, "e");
if (crc32("VddfuBqX",8) == 1908090879) strcat(s, "m");
if (crc32("PzBddmgceni",11) == 512355717) strcat(s, "a");
if (crc32("CDfeFMJhfkfEvWr",15) == 2093775484) strcat(s, "t");
if (crc32("cSCYDFOFIs",10) == 2582161386) strcat(s, "L");
if (crc32("JPaLiAsOdBZ",11) == 1918812304) strcat(s, "e");
if (crc32("nvEpieoukETfSW",14) == 997340844) strcat(s, "I");
if (crc32("RmQdXLfrOFwzBh",14) == 3788621185) strcat(s, "n");
    return s;
}

char *allelic_adjectives() {
    char *s = calloc(8);
    if (crc32("XQgtM",5) == 3008776106) strcat(s, "a");
if (crc32("WumiIwEZPHQA",12) == 1296991869) strcat(s, "l");
if (crc32("UEUTM",5) == 651581071) strcat(s, "l");
if (crc32("twZQClWI",8) == 2407875657) strcat(s, "Z");
if (crc32("IwJPK",5) == 1133615194) strcat(s, "e");
if (crc32("Sjpbje",6) == 3009583123) strcat(s, "h");
if (crc32("dZpTnBFDnPuvAYp",15) == 366161097) strcat(s, "l");
if (crc32("KWlVmFSFLdlf",12) == 807709078) strcat(s, "H");
if (crc32("sARYVtOW",8) == 4004787454) strcat(s, "i");
if (crc32("VUQSpDOWjYyTg",13) == 27345036) strcat(s, "G");
if (crc32("eevBcyrMHxXHfV",14) == 3372604807) strcat(s, "c");
    return s;
}

char *overreserved_adjectives() {
    char *s = calloc(13);
    if (crc32("EQtoTzpack",10) == 959668593) strcat(s, "o");
if (crc32("fItvlJmpEfR",11) == 1191329925) strcat(s, "K");
if (crc32("SGIpKg",6) == 2747089521) strcat(s, "v");
if (crc32("VOTnmv",6) == 3735370477) strcat(s, "e");
if (crc32("GvXsLsBHyvpDMN",14) == 1899882534) strcat(s, "r");
if (crc32("DXHdBKFYnQgRk",13) == 1181331790) strcat(s, "C");
if (crc32("YMIRrVdVhfVx",12) == 1935794533) strcat(s, "r");
if (crc32("lIVKjQt",7) == 130760068) strcat(s, "D");
if (crc32("zkxhExHGOZ",10) == 1512495775) strcat(s, "e");
if (crc32("vXEhcLGe",8) == 47145532) strcat(s, "y");
if (crc32("JEZEAMNsUlJXnK",14) == 2684483866) strcat(s, "s");
if (crc32("GQMwzU",6) == 883793607) strcat(s, "s");
if (crc32("SuUdJS",6) == 1091801064) strcat(s, "e");
if (crc32("balchXMYGt",10) == 1446064309) strcat(s, "W");
if (crc32("iivyx",5) == 3832641019) strcat(s, "r");
if (crc32("FjJcgHnKKyaduQ",14) == 3284308845) strcat(s, "q");
if (crc32("eupcKs",6) == 602288984) strcat(s, "v");
if (crc32("ancnlDbekVGb",12) == 3750623031) strcat(s, "e");
if (crc32("xLAUzE",6) == 3520321922) strcat(s, "b");
if (crc32("XedZfIj",7) == 3723170708) strcat(s, "d");
    return s;
}

char *subcontiguous_adjectives() {
    char *s = calloc(14);
    if (crc32("lBzWBFCQrCpoeY",14) == 1543355500) strcat(s, "s");
if (crc32("MDTDbCw",7) == 2683842422) strcat(s, "T");
if (crc32("artptDlLI",9) == 1514449985) strcat(s, "u");
if (crc32("GvuOGzlQYsCT",12) == 2115498091) strcat(s, "b");
if (crc32("ORvayBJZl",9) == 1987632636) strcat(s, "K");
if (crc32("jKkIn",5) == 2525420319) strcat(s, "c");
if (crc32("loYtspQgAm",10) == 3751504201) strcat(s, "d");
if (crc32("WeBgVqK",7) == 419352720) strcat(s, "o");
if (crc32("IJNztA",6) == 3824399763) strcat(s, "n");
if (crc32("duAuFOMzkyer",12) == 2955479671) strcat(s, "D");
if (crc32("XcSdokn",7) == 2806620731) strcat(s, "t");
if (crc32("oWKoCtat",8) == 95516904) strcat(s, "i");
if (crc32("qaRVen",6) == 3807277119) strcat(s, "S");
if (crc32("MwzHl",5) == 3043751480) strcat(s, "g");
if (crc32("cEUwYBQsfDe",11) == 700536783) strcat(s, "u");
if (crc32("gkBrOgQbvSUFxGF",15) == 1754143263) strcat(s, "o");
if (crc32("SFlkhXxLtHaz",12) == 1666740248) strcat(s, "l");
if (crc32("bughoY",6) == 3576408919) strcat(s, "u");
if (crc32("aBGBfeqR",8) == 2120203130) strcat(s, "d");
if (crc32("DGgNp",5) == 519415554) strcat(s, "s");
    return s;
}

char *prechoroid_adjectives() {
    char *s = calloc(11);
    if (crc32("CZioEBcETYytL",13) == 4016541887) strcat(s, "q");
if (crc32("BCanHwuAdacIdc",14) == 1809334660) strcat(s, "p");
if (crc32("lOdAo",5) == 572933195) strcat(s, "r");
if (crc32("gdzmNSZYAhJ",11) == 4110034837) strcat(s, "e");
if (crc32("yqUdU",5) == 1854981547) strcat(s, "t");
if (crc32("fmqWtHYqN",9) == 1339407864) strcat(s, "c");
if (crc32("bfGHSg",6) == 645916470) strcat(s, "d");
if (crc32("qrudFFY",7) == 3563870049) strcat(s, "h");
if (crc32("bziQb",5) == 1715998470) strcat(s, "o");
if (crc32("QNkXKXcFTYMKX",13) == 402281345) strcat(s, "Y");
if (crc32("tOJXXeceKICbghB",15) == 1633992507) strcat(s, "r");
if (crc32("BYJvLuGiQhPY",12) == 1966825482) strcat(s, "o");
if (crc32("ShcmoqqX",8) == 2364707717) strcat(s, "i");
if (crc32("lXvcmEajPiRorHP",15) == 1097989561) strcat(s, "d");
    return s;
}

char *exsufflicate_adjectives() {
    char *s = calloc(13);
    if (crc32("TrSATDo",7) == 3269570488) strcat(s, "c");
if (crc32("mWdKudpMQlnliIQ",15) == 1718317317) strcat(s, "e");
if (crc32("SPScjh",6) == 1285139267) strcat(s, "x");
if (crc32("pXHJHCxb",8) == 3498855870) strcat(s, "i");
if (crc32("LSxcljt",7) == 4250619269) strcat(s, "s");
if (crc32("ycmfibNnVjscKnp",15) == 4216624230) strcat(s, "z");
if (crc32("YjfOocD",7) == 732013648) strcat(s, "u");
if (crc32("FBocNJiiB",9) == 842209515) strcat(s, "C");
if (crc32("WwyEw",5) == 2729865443) strcat(s, "f");
if (crc32("hsKVqTz",7) == 3963760472) strcat(s, "W");
if (crc32("jllCoOWPo",9) == 3146401132) strcat(s, "f");
if (crc32("miWDDUF",7) == 3914537168) strcat(s, "l");
if (crc32("PedIGuIvMbwBdQR",15) == 3909588984) strcat(s, "f");
if (crc32("vUGNSfSmrcanRrU",15) == 2548660853) strcat(s, "i");
if (crc32("wDWnozYDD",9) == 2461627749) strcat(s, "c");
if (crc32("uoZFuyeFtwOEYeE",15) == 3553278774) strcat(s, "a");
if (crc32("CeptyIKcqySDxp",14) == 247376544) strcat(s, "a");
if (crc32("EEyKPmm",7) == 3824248130) strcat(s, "t");
if (crc32("HVXcOTVRQo",10) == 2967440320) strcat(s, "o");
if (crc32("WIOBtneXB",9) == 1161590580) strcat(s, "e");
    return s;
}

char *gasiform_adjectives() {
    char *s = calloc(9);
    if (crc32("zEGnws",6) == 2339282522) strcat(s, "u");
if (crc32("bnCUyN",6) == 1588818814) strcat(s, "g");
if (crc32("EUITrxXnSDDbNWt",15) == 2775007813) strcat(s, "a");
if (crc32("kBgPtYoDCgARkeP",15) == 3525596988) strcat(s, "s");
if (crc32("KmsIyNeaaDUlHIA",15) == 2666556242) strcat(s, "d");
if (crc32("RYADOIV",7) == 2872511036) strcat(s, "i");
if (crc32("owJmGxIDOILu",12) == 2004106172) strcat(s, "V");
if (crc32("NTpymoa",7) == 1769859767) strcat(s, "f");
if (crc32("ywTTcVRLOZTgqMJ",15) == 3922092257) strcat(s, "u");
if (crc32("DQsTYCvlACKQJ",13) == 781746591) strcat(s, "o");
if (crc32("WgeDFMrbXQ",10) == 889606769) strcat(s, "r");
if (crc32("WVKIGUVSsi",10) == 1527500259) strcat(s, "b");
if (crc32("QhHqsjaDVpwvlsg",15) == 2551588253) strcat(s, "m");
    return s;
}

char *groggier_adjectives() {
    char *s = calloc(9);
    if (crc32("oUbyU",5) == 2403111067) strcat(s, "g");
if (crc32("nnrsliYIVuQLIJZ",15) == 2533581912) strcat(s, "S");
if (crc32("UaGLJCuyFYZJP",13) == 3428865547) strcat(s, "r");
if (crc32("PcHdXs",6) == 3385737277) strcat(s, "o");
if (crc32("HNxwmsAQV",9) == 2866383675) strcat(s, "q");
if (crc32("zyMbFGuXnx",10) == 1483505648) strcat(s, "g");
if (crc32("mMBqQlQEYuBpF",13) == 3991839936) strcat(s, "g");
if (crc32("HIIoBzagiRbsp",13) == 3615472010) strcat(s, "i");
if (crc32("FMTEhjQA",8) == 2980647275) strcat(s, "e");
if (crc32("aUjpPOeXUZy",11) == 2367915028) strcat(s, "o");
if (crc32("ZswTH",5) == 979697698) strcat(s, "r");
    return s;
}

char *quasiathletic_adjectives() {
    char *s = calloc(14);
    if (crc32("QAkRJbaXOH",10) == 3869027862) strcat(s, "q");
if (crc32("nXROjiOpgdjJis",14) == 2249129296) strcat(s, "W");
if (crc32("tsrysFjZTWUC",12) == 1319656608) strcat(s, "u");
if (crc32("ZeEqQGZlRdC",11) == 1466684497) strcat(s, "K");
if (crc32("zGiEDQW",7) == 3741145762) strcat(s, "a");
if (crc32("nQgpiUGAD",9) == 3314905708) strcat(s, "I");
if (crc32("QrllcXuXLNS",11) == 2634589080) strcat(s, "s");
if (crc32("CoghR",5) == 3756867075) strcat(s, "i");
if (crc32("KnnnuEqHfIwn",12) == 230242612) strcat(s, "h");
if (crc32("mgBljunNVeBRRy",14) == 3327809116) strcat(s, "a");
if (crc32("GRxENgJGGndMY",13) == 1049988387) strcat(s, "Z");
if (crc32("lGgCLMlu",8) == 701457439) strcat(s, "t");
if (crc32("VtmBRHKv",8) == 2216750285) strcat(s, "r");
if (crc32("CeDbh",5) == 3065518054) strcat(s, "h");
if (crc32("RoqjkfZTnTfhnSM",15) == 1750788772) strcat(s, "l");
if (crc32("rCrjnHm",7) == 4046781620) strcat(s, "e");
if (crc32("hmbkICjzVCLX",12) == 1122287231) strcat(s, "e");
if (crc32("FmOqVlXJ",8) == 298669320) strcat(s, "t");
if (crc32("TBHseLwzYE",10) == 2207415083) strcat(s, "i");
if (crc32("aqgYaVDaAr",10) == 2094138235) strcat(s, "U");
if (crc32("TwsrWDZT",8) == 2654876164) strcat(s, "c");
    return s;
}

char *nonobligated_adjectives() {
    char *s = calloc(13);
    if (crc32("yBpEASAqhlWH",12) == 3946893442) strcat(s, "n");
if (crc32("VcUpZlljlB",10) == 1463663894) strcat(s, "o");
if (crc32("WwKAuL",6) == 894270575) strcat(s, "w");
if (crc32("vJnkksNJ",8) == 1897474353) strcat(s, "n");
if (crc32("AoVrmhhrNkTpl",13) == 216369249) strcat(s, "o");
if (crc32("WZckLXgWgb",10) == 3188770158) strcat(s, "b");
if (crc32("tOKVD",5) == 2053127184) strcat(s, "g");
if (crc32("rxvflywzr",9) == 1718417005) strcat(s, "l");
if (crc32("VgzYCvs",7) == 4200892334) strcat(s, "E");
if (crc32("tkycWocq",8) == 1253428032) strcat(s, "i");
if (crc32("EAaHsKCVH",9) == 1582511768) strcat(s, "B");
if (crc32("itpWTgJacCMOrwe",15) == 348063440) strcat(s, "g");
if (crc32("XzBRTqxfkYzmf",13) == 3823381994) strcat(s, "S");
if (crc32("FWGpcyQtnYL",11) == 957797986) strcat(s, "a");
if (crc32("cxxli",5) == 2671256147) strcat(s, "d");
if (crc32("vWogszcMwAspgH",14) == 2616793998) strcat(s, "t");
if (crc32("QYjeDZIFOZJV",12) == 4036845343) strcat(s, "e");
if (crc32("KkhsNEFSQTssile",15) == 3946986606) strcat(s, "d");
    return s;
}

char *unadvised_adjectives() {
    char *s = calloc(10);
    if (crc32("nGHHBs",6) == 4240935246) strcat(s, "O");
if (crc32("VeSyUFeBpufAWQ",14) == 3600617090) strcat(s, "u");
if (crc32("TOGNjdmNfJwHO",13) == 1183053967) strcat(s, "N");
if (crc32("LbsQCuaJSu",10) == 1165252131) strcat(s, "n");
if (crc32("lYPnHzoK",8) == 1685287300) strcat(s, "Q");
if (crc32("oGcngiUXnxhLB",13) == 147927913) strcat(s, "a");
if (crc32("IlSdbnE",7) == 1319442882) strcat(s, "d");
if (crc32("AkfLhFSfibM",11) == 2072595456) strcat(s, "V");
if (crc32("GkWQyUwYcEk",11) == 4160199490) strcat(s, "v");
if (crc32("raCEiUwsvedoV",13) == 1303688636) strcat(s, "i");
if (crc32("RbfLQAhpezY",11) == 3316447477) strcat(s, "s");
if (crc32("SGPtR",5) == 528482405) strcat(s, "j");
if (crc32("aKWgKEJw",8) == 4215611098) strcat(s, "e");
if (crc32("wTcfsknH",8) == 844026213) strcat(s, "d");
    return s;
}

char *wellremembered_adjectives() {
    char *s = calloc(15);
    if (crc32("znhkw",5) == 2364443209) strcat(s, "Y");
if (crc32("ZbBlMUuaXF",10) == 2744889245) strcat(s, "w");
if (crc32("GHTwdGOOgJaaj",13) == 212002558) strcat(s, "e");
if (crc32("yOwwPDJW",8) == 838931667) strcat(s, "f");
if (crc32("dVVEMOOjxm",10) == 2214816435) strcat(s, "l");
if (crc32("PITMpCDcI",9) == 2162535256) strcat(s, "l");
if (crc32("TOuCtdvLPuabfmf",15) == 987689221) strcat(s, "r");
if (crc32("IKqbobQplhUugoP",15) == 1097108916) strcat(s, "V");
if (crc32("McxZR",5) == 3489763302) strcat(s, "e");
if (crc32("eERKEZ",6) == 3043860115) strcat(s, "d");
if (crc32("tlydaIfvQQPYU",13) == 668172589) strcat(s, "m");
if (crc32("QZVriOMzW",9) == 1323419709) strcat(s, "e");
if (crc32("kQWQzQveYFvUa",13) == 1262131008) strcat(s, "m");
if (crc32("kZGkaX",6) == 4198846005) strcat(s, "b");
if (crc32("TiCbgsH",7) == 730480854) strcat(s, "a");
if (crc32("EFKStVxbtO",10) == 1062466044) strcat(s, "e");
if (crc32("FvSWCjJW",8) == 909722221) strcat(s, "r");
if (crc32("FiGfmPOEGiuYlN",14) == 646982201) strcat(s, "v");
if (crc32("VJltTSHnlcFz",12) == 3509193879) strcat(s, "e");
if (crc32("SVkBXOyYLiq",11) == 2040041341) strcat(s, "E");
if (crc32("nTOOZ",5) == 601261849) strcat(s, "d");
    return s;
}

char *unquizzical_adjectives() {
    char *s = calloc(12);
    if (crc32("CcdiBHbcfjdDw",13) == 2235530587) strcat(s, "B");
if (crc32("gUXUNtg",7) == 2567939848) strcat(s, "u");
if (crc32("IutwhX",6) == 3587237071) strcat(s, "n");
if (crc32("QzrZatC",7) == 2017870460) strcat(s, "q");
if (crc32("llcsIo",6) == 3943939168) strcat(s, "x");
if (crc32("iSeSo",5) == 2302622200) strcat(s, "u");
if (crc32("WMCBGRpFFbmS",12) == 2854673083) strcat(s, "E");
if (crc32("kyjDYhwvAarpHA",14) == 3434517941) strcat(s, "i");
if (crc32("mIcsLTYaFnR",11) == 2105049624) strcat(s, "z");
if (crc32("LuWAXf",6) == 768065285) strcat(s, "U");
if (crc32("TaplVhSyVptwuj",14) == 3671869489) strcat(s, "z");
if (crc32("dtVXFSVpLsb",11) == 1545625395) strcat(s, "i");
if (crc32("EQeGLhbhH",9) == 3719472591) strcat(s, "c");
if (crc32("evyonmKitLvBi",13) == 2468540756) strcat(s, "E");
if (crc32("xRJKx",5) == 1591409900) strcat(s, "a");
if (crc32("jJJNwm",6) == 444341914) strcat(s, "r");
if (crc32("EjejbijK",8) == 135734620) strcat(s, "l");
    return s;
}

char *hypersentimental_adjectives() {
    char *s = calloc(17);
    if (crc32("AtaSHZ",6) == 669664013) strcat(s, "h");
if (crc32("ynlhIeN",7) == 2190943286) strcat(s, "y");
if (crc32("NVrfQQL",7) == 3852811292) strcat(s, "S");
if (crc32("yIwUA",5) == 1129694422) strcat(s, "p");
if (crc32("FhaoYmcHGu",10) == 3227453794) strcat(s, "N");
if (crc32("CWPtYaNctqWFG",13) == 1620136201) strcat(s, "e");
if (crc32("iBWtsAG",7) == 954329921) strcat(s, "M");
if (crc32("TemnWSSdUWU",11) == 3748724376) strcat(s, "r");
if (crc32("KNOxuxJcpgbUYzY",15) == 3435430906) strcat(s, "s");
if (crc32("VfmrXG",6) == 2038716459) strcat(s, "e");
if (crc32("ThjjPtZpcR",10) == 3898520782) strcat(s, "v");
if (crc32("LVPHTwiNpy",10) == 2728894831) strcat(s, "n");
if (crc32("jIhGTmy",7) == 2806223207) strcat(s, "t");
if (crc32("iFKCJij",7) == 3984676819) strcat(s, "q");
if (crc32("WdatazBMsXa",11) == 1398367592) strcat(s, "i");
if (crc32("DYybeREdxn",10) == 2970524134) strcat(s, "m");
if (crc32("rJeBySmnKE",10) == 3702881778) strcat(s, "e");
if (crc32("mAUdbukE",8) == 2487710243) strcat(s, "t");
if (crc32("CWjrIG",6) == 2026914204) strcat(s, "n");
if (crc32("rdSnSYklFTieuh",14) == 494112478) strcat(s, "t");
if (crc32("gwdzYjA",7) == 1355736589) strcat(s, "a");
if (crc32("mWvyIjvd",8) == 1910633256) strcat(s, "l");
    return s;
}

char *unincriminating_adjectives() {
    char *s = calloc(16);
    if (crc32("SYTwM",5) == 1098289323) strcat(s, "f");
if (crc32("SIPEBhkLynookpM",15) == 3128673020) strcat(s, "u");
if (crc32("kFSyAoiYrafq",12) == 756189792) strcat(s, "G");
if (crc32("BcwXprkDGzyl",12) == 1310675450) strcat(s, "n");
if (crc32("lDAJu",5) == 3577178096) strcat(s, "i");
if (crc32("bgdlKo",6) == 16116858) strcat(s, "s");
if (crc32("aASGmDCxLW",10) == 769279942) strcat(s, "n");
if (crc32("SvDqWP",6) == 2459867647) strcat(s, "c");
if (crc32("GxWyPTWOFNf",11) == 1505337813) strcat(s, "N");
if (crc32("nSocNqDhc",9) == 1624452805) strcat(s, "r");
if (crc32("NAfcaJxN",8) == 862164920) strcat(s, "i");
if (crc32("aePjQsoQQz",10) == 1704482767) strcat(s, "X");
if (crc32("INXpKgZpyanKNS",14) == 2020425555) strcat(s, "m");
if (crc32("GmCqnAVmJC",10) == 3280645302) strcat(s, "i");
if (crc32("KgTcHKn",7) == 3986683408) strcat(s, "n");
if (crc32("yfxFIrAqKwL",11) == 2540149309) strcat(s, "n");
if (crc32("IupgXWSrpTJsx",13) == 475956121) strcat(s, "a");
if (crc32("DpxkWG",6) == 731036164) strcat(s, "t");
if (crc32("qZNhYUvrzwVU",12) == 2798179701) strcat(s, "W");
if (crc32("ygsyo",5) == 3780563558) strcat(s, "i");
if (crc32("sokMnX",6) == 103192165) strcat(s, "q");
if (crc32("XNYVxEEvAeTD",12) == 59127819) strcat(s, "n");
if (crc32("HyViFt",6) == 2254609538) strcat(s, "G");
if (crc32("LKWvuwCmBIdxrz",14) == 588929406) strcat(s, "g");
    return s;
}

char *everyday_adjectives() {
    char *s = calloc(9);
    if (crc32("EqSwDin",7) == 4149747681) strcat(s, "n");
if (crc32("TYmPAWKHdBvacfP",15) == 524478447) strcat(s, "e");
if (crc32("aUsTMyb",7) == 3764952368) strcat(s, "b");
if (crc32("uDVpnpQ",7) == 444796097) strcat(s, "v");
if (crc32("LYPoKTQWjbDOUwS",15) == 17120996) strcat(s, "e");
if (crc32("ZxUphtJP",8) == 390414011) strcat(s, "r");
if (crc32("HPyFocyaxOEYd",13) == 3589023452) strcat(s, "a");
if (crc32("MlOQYPmiwHM",11) == 3642431335) strcat(s, "y");
if (crc32("VzUXcOPYboJWC",13) == 2984164638) strcat(s, "d");
if (crc32("gZQsgZFOnpc",11) == 2615785312) strcat(s, "k");
if (crc32("PWXdmAEvP",9) == 1857161616) strcat(s, "a");
if (crc32("vtqSEscwnNG",11) == 31855738) strcat(s, "E");
if (crc32("lhKTMsrDhFIRvc",14) == 1094730762) strcat(s, "y");
    return s;
}

char *gauntleted_adjectives() {
    char *s = calloc(11);
    if (crc32("sRJUoSiL",8) == 4240759709) strcat(s, "x");
if (crc32("hCnriHdQp",9) == 1295675989) strcat(s, "g");
if (crc32("jLqymvxmgYc",11) == 3423832352) strcat(s, "a");
if (crc32("RauzawtrslrQvtT",15) == 2576373658) strcat(s, "K");
if (crc32("jsutygQayD",10) == 2720076193) strcat(s, "u");
if (crc32("FdSRddcLmfzVGf",14) == 481543322) strcat(s, "n");
if (crc32("irPjGeNMKDFf",12) == 2390098025) strcat(s, "k");
if (crc32("OXmkzR",6) == 2597599147) strcat(s, "t");
if (crc32("iLLbIr",6) == 102455022) strcat(s, "l");
if (crc32("EuxwXfUgDDEz",12) == 2299861996) strcat(s, "N");
if (crc32("fgThlR",6) == 184283303) strcat(s, "e");
if (crc32("LOKuw",5) == 3568893286) strcat(s, "V");
if (crc32("gFksbftawgqk",12) == 3770083847) strcat(s, "t");
if (crc32("txCuadMM",8) == 2881435341) strcat(s, "e");
if (crc32("HgVjMekOeikc",12) == 2212006016) strcat(s, "d");
    return s;
}

char *embowed_adjectives() {
    char *s = calloc(8);
    if (crc32("fsdVXasnHnBN",12) == 3980378523) strcat(s, "v");
if (crc32("iOugiZgFZ",9) == 490882120) strcat(s, "e");
if (crc32("JCvjSZSw",8) == 1090588346) strcat(s, "m");
if (crc32("wXkJylpYlL",10) == 1626578929) strcat(s, "H");
if (crc32("qUIblH",6) == 2639256204) strcat(s, "b");
if (crc32("NoVIEteL",8) == 858593458) strcat(s, "o");
if (crc32("KVSgy",5) == 3686031845) strcat(s, "P");
if (crc32("yofhIaGpCGnDjp",14) == 2006748616) strcat(s, "w");
if (crc32("pHsGWThNbs",10) == 364091060) strcat(s, "e");
if (crc32("mJRziLmSz",9) == 2817633890) strcat(s, "u");
if (crc32("oPXduJlKSja",11) == 1200474505) strcat(s, "d");
    return s;
}

char *microstomatous_adjectives() {
    char *s = calloc(15);
    if (crc32("FSpbwXBSyu",10) == 347689054) strcat(s, "m");
if (crc32("psMDl",5) == 3995705665) strcat(s, "i");
if (crc32("ToLjFEeioKh",11) == 2254201926) strcat(s, "c");
if (crc32("hEuVtD",6) == 3410280570) strcat(s, "r");
if (crc32("PJffjtjEYtCnAbu",15) == 2734424130) strcat(s, "o");
if (crc32("owrHqthov",9) == 4148833222) strcat(s, "t");
if (crc32("HJgpGAh",7) == 3686320832) strcat(s, "s");
if (crc32("kFtbjIhVDuUD",12) == 2728534985) strcat(s, "t");
if (crc32("xLnUID",6) == 708085481) strcat(s, "o");
if (crc32("ttwEcEzalIoltWp",15) == 4157227208) strcat(s, "m");
if (crc32("iYvsaQuF",8) == 1557201321) strcat(s, "a");
if (crc32("GVPeGydFhp",10) == 2577654456) strcat(s, "N");
if (crc32("BnEZwiIxO",9) == 456679695) strcat(s, "t");
if (crc32("Golih",5) == 982990004) strcat(s, "w");
if (crc32("RiBOHDkRCHQJBvY",15) == 24136119) strcat(s, "o");
if (crc32("CbXtjfuQJcl",11) == 3089735701) strcat(s, "G");
if (crc32("uGLnAiAWUF",10) == 2930519634) strcat(s, "u");
if (crc32("mfATeXbJBoxSOG",14) == 4189140782) strcat(s, "a");
if (crc32("hRNyPqfmORDZOIu",15) == 3892304682) strcat(s, "s");
    return s;
}

char *selfworn_adjectives() {
    char *s = calloc(9);
    if (crc32("ADMYWQTejy",10) == 3172542468) strcat(s, "s");
if (crc32("pnkJbevfumzvbK",14) == 1732751498) strcat(s, "y");
if (crc32("zoxNxESFRZm",11) == 2101063928) strcat(s, "e");
if (crc32("eDbEg",5) == 2517471423) strcat(s, "l");
if (crc32("rgNyiY",6) == 1991692591) strcat(s, "n");
if (crc32("PWOAbUVfCyNMJ",13) == 730911502) strcat(s, "f");
if (crc32("PxCrlzhkGhfiXg",14) == 1947180617) strcat(s, "R");
if (crc32("oKzoejCjf",9) == 3972541705) strcat(s, "w");
if (crc32("JqhoJiGpUbQ",11) == 3341245430) strcat(s, "o");
if (crc32("yTbXeTVErHRKPd",14) == 3313024037) strcat(s, "F");
if (crc32("BzhWhfNpXp",10) == 113013875) strcat(s, "r");
if (crc32("YsHjxw",6) == 374754246) strcat(s, "n");
    return s;
}

char *fidgety_adjectives() {
    char *s = calloc(8);
    if (crc32("QvNEZtooHClS",12) == 1174508136) strcat(s, "I");
if (crc32("SHaWEtgec",9) == 2651020556) strcat(s, "f");
if (crc32("RDTTwCAjTKeVA",13) == 716467077) strcat(s, "n");
if (crc32("asmZtj",6) == 2185975631) strcat(s, "i");
if (crc32("DyclmEg",7) == 3344768206) strcat(s, "Q");
if (crc32("JePQCt",6) == 1687982674) strcat(s, "d");
if (crc32("wWVtOPuvyYo",11) == 667447432) strcat(s, "F");
if (crc32("MGqYbVnmpbKkL",13) == 2834150263) strcat(s, "g");
if (crc32("AWgHHBoIJr",10) == 3609382640) strcat(s, "i");
if (crc32("cngRq",5) == 559864169) strcat(s, "e");
if (crc32("wbhRFuA",7) == 1353801618) strcat(s, "T");
if (crc32("AmCrWCt",7) == 4040189551) strcat(s, "t");
if (crc32("igODsXGfezJ",11) == 244304897) strcat(s, "w");
if (crc32("jYuPCQ",6) == 3670746015) strcat(s, "y");
    return s;
}

char *halfflattered_adjectives() {
    char *s = calloc(14);
    if (crc32("wbqyBckUTAom",12) == 3242402688) strcat(s, "h");
if (crc32("crOrYYSnC",9) == 1617739008) strcat(s, "a");
if (crc32("oqxFanr",7) == 424922772) strcat(s, "D");
if (crc32("qOJWgzVg",8) == 1405836595) strcat(s, "l");
if (crc32("SyyKfayh",8) == 783919608) strcat(s, "f");
if (crc32("JRBSJjmWFBt",11) == 1443926634) strcat(s, "f");
if (crc32("DSNuohvq",8) == 563566215) strcat(s, "f");
if (crc32("rWaPLeYg",8) == 2985259297) strcat(s, "l");
if (crc32("lYtUMYtUdEQ",11) == 1230973493) strcat(s, "q");
if (crc32("cLtYOHrzwSJDgF",14) == 3518253591) strcat(s, "a");
if (crc32("tNayfigfPue",11) == 3636614879) strcat(s, "A");
if (crc32("ETQbahgFP",9) == 3119384139) strcat(s, "t");
if (crc32("ptoqMwxumSrlP",13) == 1132120538) strcat(s, "w");
if (crc32("ZdGwvU",6) == 1165770469) strcat(s, "t");
if (crc32("kPmDxkOOu",9) == 444357318) strcat(s, "e");
if (crc32("TmrwZZQxCKUAiy",14) == 6848396) strcat(s, "r");
if (crc32("uRDFxq",6) == 142290230) strcat(s, "e");
if (crc32("aryeEjUB",8) == 2292277553) strcat(s, "G");
if (crc32("lUTjIDShrKGCC",13) == 2523450952) strcat(s, "d");
    return s;
}

char *peachiest_adjectives() {
    char *s = calloc(10);
    if (crc32("uDvmdFmvcyzkTy",14) == 533007190) strcat(s, "d");
if (crc32("TfAHAhleiYh",11) == 1971270718) strcat(s, "p");
if (crc32("PRNfXfWraHd",11) == 284473876) strcat(s, "e");
if (crc32("TnUmhl",6) == 1428375889) strcat(s, "a");
if (crc32("CEdOi",5) == 2045416513) strcat(s, "c");
if (crc32("bmlrwZQqrzmAZ",13) == 254719115) strcat(s, "o");
if (crc32("PXaQKdq",7) == 3554346817) strcat(s, "h");
if (crc32("wxXSVMTiZeWKz",13) == 2242859018) strcat(s, "i");
if (crc32("pKTzlBJxkJsDqRO",15) == 2590241835) strcat(s, "e");
if (crc32("ZjZDHkyJCPlRGN",14) == 562185249) strcat(s, "s");
if (crc32("uztoZyfEwl",10) == 3593617438) strcat(s, "t");
    return s;
}

char *unsighing_adjectives() {
    char *s = calloc(10);
    if (crc32("WCDzAeDMCDCXJTN",15) == 2672491258) strcat(s, "u");
if (crc32("OdeFolSagM",10) == 356280992) strcat(s, "G");
if (crc32("PYGmzYWfze",10) == 543488253) strcat(s, "n");
if (crc32("bHFuzNyQn",9) == 2297633808) strcat(s, "s");
if (crc32("jhgKdvLoAvi",11) == 3500314529) strcat(s, "B");
if (crc32("gyXpMwJSuced",12) == 4128411659) strcat(s, "i");
if (crc32("gEAdRIUa",8) == 3804212712) strcat(s, "g");
if (crc32("iqMITKKovJL",11) == 2608450993) strcat(s, "h");
if (crc32("zATaJpylZFRQ",12) == 957698635) strcat(s, "i");
if (crc32("MgmpHq",6) == 2869547109) strcat(s, "n");
if (crc32("yqVMFnIBbcNCgVF",15) == 4253656855) strcat(s, "g");
    return s;
}

char *unacclimatized_adjectives() {
    char *s = calloc(15);
    if (crc32("wHzBoCSI",8) == 3017177631) strcat(s, "u");
if (crc32("bklPkjvkviZNaV",14) == 1779680621) strcat(s, "n");
if (crc32("XgxJvnHFzjoXg",13) == 1561414581) strcat(s, "S");
if (crc32("vkcCTjUNyYI",11) == 1551854703) strcat(s, "a");
if (crc32("nmwbfGcbyIo",11) == 2095222997) strcat(s, "y");
if (crc32("blDZYmDL",8) == 1088773839) strcat(s, "c");
if (crc32("zTljkFLozF",10) == 3900409651) strcat(s, "c");
if (crc32("yVzATw",6) == 1339038721) strcat(s, "l");
if (crc32("rQpfdikAa",9) == 4259911788) strcat(s, "z");
if (crc32("onFxpKNJlcLDhm",14) == 2338859925) strcat(s, "i");
if (crc32("jAAuqSIF",8) == 150992144) strcat(s, "V");
if (crc32("yIzvODUpvqGci",13) == 72098172) strcat(s, "m");
if (crc32("WVHmN",5) == 2647200189) strcat(s, "a");
if (crc32("nkUqaTZIXoB",11) == 778339283) strcat(s, "t");
if (crc32("NZYBbqCPyUXJ",12) == 3658037227) strcat(s, "M");
if (crc32("ichGjJhqgRT",11) == 3975870496) strcat(s, "i");
if (crc32("MGFSv",5) == 2430393632) strcat(s, "h");
if (crc32("khQue",5) == 3569103438) strcat(s, "z");
if (crc32("OIBpgIzrDg",10) == 771494746) strcat(s, "e");
if (crc32("tAwtkJZXaryGia",14) == 3396031514) strcat(s, "w");
if (crc32("UafOcGQNymGMhoD",15) == 3770128053) strcat(s, "d");
    return s;
}

char *phlebotomical_adjectives() {
    char *s = calloc(14);
    if (crc32("esISS",5) == 155700245) strcat(s, "M");
if (crc32("cMQNiYGoG",9) == 3701512934) strcat(s, "p");
if (crc32("WlDSFxvn",8) == 2858373728) strcat(s, "h");
if (crc32("XVgJMFlkqiBuB",13) == 2866690757) strcat(s, "l");
if (crc32("TPLkjMs",7) == 240634244) strcat(s, "j");
if (crc32("PgKyrcsNaobvpF",14) == 1225714461) strcat(s, "e");
if (crc32("GBKixY",6) == 2146346339) strcat(s, "b");
if (crc32("IiOSLltL",8) == 1750427315) strcat(s, "o");
if (crc32("MkBjXaAmlfscxl",14) == 3083938052) strcat(s, "t");
if (crc32("PeEnODhonGvme",13) == 2920245566) strcat(s, "o");
if (crc32("irkuNMfwRWBK",12) == 1550933156) strcat(s, "m");
if (crc32("BuzAYivnGB",10) == 1642556459) strcat(s, "a");
if (crc32("xNqcPRYQESjXZ",13) == 3528731403) strcat(s, "i");
if (crc32("KCMsZDl",7) == 1491880374) strcat(s, "t");
if (crc32("oYyfktKzEMw",11) == 1751795382) strcat(s, "c");
if (crc32("NIqcxonsietzC",13) == 83995746) strcat(s, "a");
if (crc32("ObpMuOKiTNVr",12) == 599853013) strcat(s, "l");
    return s;
}

char *unretardable_adjectives() {
    char *s = calloc(13);
    if (crc32("OvFNKUesLl",10) == 598674716) strcat(s, "u");
if (crc32("DOdIsdtQ",8) == 3713781892) strcat(s, "n");
if (crc32("LfswI",5) == 3994305958) strcat(s, "h");
if (crc32("dKOfVSgvgZX",11) == 1029344927) strcat(s, "r");
if (crc32("UCYvstsVjO",10) == 2002234488) strcat(s, "e");
if (crc32("DkweLhx",7) == 803091397) strcat(s, "m");
if (crc32("yvlttK",6) == 1663583256) strcat(s, "t");
if (crc32("LGrZUjpBVF",10) == 4228475333) strcat(s, "c");
if (crc32("fyADucNzGdMFF",13) == 3716312680) strcat(s, "a");
if (crc32("xuyfdFfgAHdJR",13) == 3792220081) strcat(s, "r");
if (crc32("TjAdMhYT",8) == 469454898) strcat(s, "d");
if (crc32("yXTYxZsUqRo",11) == 310315111) strcat(s, "S");
if (crc32("gbJexhia",8) == 988899835) strcat(s, "a");
if (crc32("sWehiEB",7) == 2902286597) strcat(s, "b");
if (crc32("iOLoyUb",7) == 3160065622) strcat(s, "l");
if (crc32("DhRlt",5) == 3494175823) strcat(s, "A");
if (crc32("IYVbdOWYezLpF",13) == 1899405739) strcat(s, "e");
    return s;
}

char *cerographic_adjectives() {
    char *s = calloc(12);
    if (crc32("VvRus",5) == 3411633629) strcat(s, "c");
if (crc32("YyTUQHqNgwbf",12) == 449995938) strcat(s, "e");
if (crc32("SGVLXw",6) == 2917818657) strcat(s, "R");
if (crc32("gYZVWg",6) == 2073932119) strcat(s, "r");
if (crc32("xXoVnyHZVkUGumt",15) == 3618789438) strcat(s, "O");
if (crc32("fFJzYPZB",8) == 1273175176) strcat(s, "o");
if (crc32("HcWRupxJnh",10) == 688702361) strcat(s, "g");
if (crc32("ZcSMmZXRtLy",11) == 1941066398) strcat(s, "p");
if (crc32("VfrMMRaYzEr",11) == 1461062549) strcat(s, "r");
if (crc32("uBCNiLxDNuTrNd",14) == 2155381758) strcat(s, "L");
if (crc32("STvNoHGvrt",10) == 1843636036) strcat(s, "a");
if (crc32("tsLqwb",6) == 4177859879) strcat(s, "Y");
if (crc32("aBXUBn",6) == 1557322939) strcat(s, "p");
if (crc32("zlhbgc",6) == 1903678355) strcat(s, "C");
if (crc32("WknSGzmbCrdVkF",14) == 3679021970) strcat(s, "h");
if (crc32("gpfEYStpEwrAADr",15) == 3319179071) strcat(s, "Q");
if (crc32("WnYgrMOsUTxRQJr",15) == 781296689) strcat(s, "i");
if (crc32("TduoNArPeVSxInl",15) == 3611267165) strcat(s, "c");
    return s;
}

char *susurrous_adjectives() {
    char *s = calloc(10);
    if (crc32("nFYVYjVEyOPxvH",14) == 3352021647) strcat(s, "c");
if (crc32("axfsXVWLkBqz",12) == 3398934105) strcat(s, "s");
if (crc32("SlkrUSmKMaKwtL",14) == 3322946729) strcat(s, "u");
if (crc32("lgZxEDi",7) == 3465119170) strcat(s, "s");
if (crc32("SdAaXpke",8) == 985958903) strcat(s, "w");
if (crc32("bhoqrlVsDrqWm",13) == 4262396147) strcat(s, "u");
if (crc32("RrGLB",5) == 2089594833) strcat(s, "z");
if (crc32("rYcGRaGbFrr",11) == 360047727) strcat(s, "r");
if (crc32("DEdYhU",6) == 3558084447) strcat(s, "r");
if (crc32("RjPWkTU",7) == 2768630601) strcat(s, "K");
if (crc32("CyIKC",5) == 1280641593) strcat(s, "o");
if (crc32("JVPOuUXPlsO",11) == 3947118255) strcat(s, "u");
if (crc32("KCDdpiUOI",9) == 1406469547) strcat(s, "H");
if (crc32("iXMxlSTiILcY",12) == 2043931246) strcat(s, "s");
    return s;
}

char *unaccused_adjectives() {
    char *s = calloc(10);
    if (crc32("LImmpVH",7) == 4238858780) strcat(s, "O");
if (crc32("odkzfqOKOFUjKcq",15) == 2102561185) strcat(s, "u");
if (crc32("dBUcjBxINhVI",12) == 448076444) strcat(s, "n");
if (crc32("wHCltiYrn",9) == 1690728380) strcat(s, "A");
if (crc32("UfjPFOFNl",9) == 2704144895) strcat(s, "a");
if (crc32("AdCJgCeoQxBV",12) == 3699923820) strcat(s, "F");
if (crc32("lYIRTYUXKkGZY",13) == 987651625) strcat(s, "c");
if (crc32("mJeUdAbqi",9) == 1890989742) strcat(s, "c");
if (crc32("tNvXaOgQgtIxX",13) == 4051951224) strcat(s, "f");
if (crc32("fxBHCuWAKkayZqe",15) == 3587972194) strcat(s, "u");
if (crc32("UXaHzlbCRtfp",12) == 2219692128) strcat(s, "a");
if (crc32("sZECYVkpG",9) == 744378988) strcat(s, "s");
if (crc32("OVmoFbFgkaFDNm",14) == 3466854862) strcat(s, "x");
if (crc32("HigVMV",6) == 3488900271) strcat(s, "e");
if (crc32("wQSTEDeT",8) == 2924032429) strcat(s, "d");
    return s;
}

char *serpentine_adjectives() {
    char *s = calloc(11);
    if (crc32("IULGfZNJGBXjf",13) == 1171306652) strcat(s, "Q");
if (crc32("UknKQqlOTOj",11) == 3227846688) strcat(s, "s");
if (crc32("mWzkiLAfkpnwm",13) == 92376400) strcat(s, "p");
if (crc32("UOixEloTOAWNCPT",15) == 3412902995) strcat(s, "e");
if (crc32("grxlxZfkI",9) == 948864833) strcat(s, "r");
if (crc32("tzwUJGBqMt",10) == 2623332777) strcat(s, "p");
if (crc32("gwPVYXRS",8) == 2203822666) strcat(s, "e");
if (crc32("JndhMAgIJAWVYk",14) == 2437586650) strcat(s, "B");
if (crc32("lydlsTHFHqmr",12) == 361714778) strcat(s, "n");
if (crc32("LcnUZuVHxCfnMG",14) == 597495992) strcat(s, "d");
if (crc32("jzIWEzTKVE",10) == 2925686227) strcat(s, "t");
if (crc32("DrurZE",6) == 3949966887) strcat(s, "i");
if (crc32("MiGrrWrRgtM",11) == 2313413420) strcat(s, "n");
if (crc32("MFeLTrZEonzfpV",14) == 3489879652) strcat(s, "e");
    return s;
}

char *porcine_adjectives() {
    char *s = calloc(8);
    if (crc32("BCsDTAW",7) == 451455718) strcat(s, "p");
if (crc32("CsFMwJN",7) == 2047711766) strcat(s, "c");
if (crc32("LHBKukUFIjgiFgg",15) == 1608857193) strcat(s, "o");
if (crc32("ZluGQwPy",8) == 3984821251) strcat(s, "r");
if (crc32("KknOgjID",8) == 3280095478) strcat(s, "c");
if (crc32("sUproOFnJpW",11) == 1726064708) strcat(s, "h");
if (crc32("ANTxaHQw",8) == 1515075141) strcat(s, "i");
if (crc32("DdyiRBkS",8) == 3745005114) strcat(s, "q");
if (crc32("yhgIIbvfUGCrhh",14) == 618112169) strcat(s, "n");
if (crc32("jqSHRagBJYXuFM",14) == 1494428586) strcat(s, "e");
    return s;
}

char *inadequate_adjectives() {
    char *s = calloc(11);
    if (crc32("NELgZUfmxvhiN",13) == 1567412134) strcat(s, "l");
if (crc32("ShtwedCPLDmCvs",14) == 1122141763) strcat(s, "i");
if (crc32("PfmQkrvDTmz",11) == 4088108502) strcat(s, "s");
if (crc32("wHbYYzDRMrCSfsa",15) == 1456903825) strcat(s, "n");
if (crc32("dWxtiVZYejtvn",13) == 2891051947) strcat(s, "m");
if (crc32("WNRkIk",6) == 2581057712) strcat(s, "a");
if (crc32("oyrgMj",6) == 3636236846) strcat(s, "d");
if (crc32("gKzTnMacr",9) == 2161760224) strcat(s, "r");
if (crc32("jqRFHZIgcpxZWMC",15) == 1178013176) strcat(s, "e");
if (crc32("lwzHZwTFfOkc",12) == 3067097855) strcat(s, "X");
if (crc32("rDzijnmHzQKpY",13) == 1393842358) strcat(s, "q");
if (crc32("YpDlWJUaHNuuAnf",15) == 1748002873) strcat(s, "u");
if (crc32("bkfUelnDmB",10) == 2088446855) strcat(s, "c");
if (crc32("oLDKVAaZXC",10) == 3495513193) strcat(s, "a");
if (crc32("jhtcZuxugEuCNY",14) == 1221489450) strcat(s, "t");
if (crc32("uIDpz",5) == 4184886237) strcat(s, "t");
if (crc32("YRsWXQz",7) == 2685261974) strcat(s, "h");
if (crc32("KXzouuIIfruAO",13) == 2115568022) strcat(s, "e");
    return s;
}

char *lefthanded_adjectives() {
    char *s = calloc(11);
    if (crc32("MfXNILiPAhR",11) == 4026561569) strcat(s, "l");
if (crc32("ozAPRGFyNjdP",12) == 3517536421) strcat(s, "e");
if (crc32("kxZNxEfMPrXiKx",14) == 1768480693) strcat(s, "f");
if (crc32("zqwXx",5) == 1956362044) strcat(s, "W");
if (crc32("AMRyghIu",8) == 4054582844) strcat(s, "t");
if (crc32("CvLcLMKOdjo",11) == 329658534) strcat(s, "t");
if (crc32("NdXPajaUY",9) == 3572196753) strcat(s, "h");
if (crc32("hnEikJBhdBdlZ",13) == 3274320490) strcat(s, "L");
if (crc32("LyQkcestG",9) == 2904016888) strcat(s, "a");
if (crc32("GwqpWzaqRyYc",12) == 2056872661) strcat(s, "C");
if (crc32("ZODXrRHnvXVZ",12) == 1650471089) strcat(s, "n");
if (crc32("vGbcBuTrsjMxF",13) == 211843717) strcat(s, "d");
if (crc32("JHbFuIPo",8) == 2080964246) strcat(s, "e");
if (crc32("UffCmFX",7) == 1344731898) strcat(s, "Z");
if (crc32("IDTQXaWqdJsOkUA",15) == 4187610459) strcat(s, "d");
    return s;
}

char *unimpressive_adjectives() {
    char *s = calloc(13);
    if (crc32("HvRRXbjjXSpW",12) == 3759955006) strcat(s, "u");
if (crc32("eyrhjaWjTOScvJ",14) == 180570209) strcat(s, "n");
if (crc32("fPinVTTNH",9) == 1156753665) strcat(s, "Y");
if (crc32("ECtSfqef",8) == 1771665407) strcat(s, "i");
if (crc32("efUvVXllUlarB",13) == 3634187310) strcat(s, "J");
if (crc32("gvjdQtYTZ",9) == 3753761286) strcat(s, "m");
if (crc32("eyfobNTdgdZ",11) == 4059143070) strcat(s, "p");
if (crc32("wBjidvyvuBh",11) == 3945792553) strcat(s, "r");
if (crc32("LQBWRPFpTgS",11) == 4188504242) strcat(s, "e");
if (crc32("LbyapYIizYZnOZ",14) == 2871922594) strcat(s, "S");
if (crc32("eiFauxOwP",9) == 876635293) strcat(s, "s");
if (crc32("cMdRIKyP",8) == 3228130226) strcat(s, "s");
if (crc32("OYlnBZdGaVZl",12) == 536564530) strcat(s, "i");
if (crc32("bKruORBgFPc",11) == 1381032670) strcat(s, "v");
if (crc32("ZAqoL",5) == 1595238299) strcat(s, "e");
    return s;
}

char *earthborn_adjectives() {
    char *s = calloc(10);
    if (crc32("CYUztLjkYM",10) == 692004253) strcat(s, "B");
if (crc32("WMoFDlp",7) == 2199619075) strcat(s, "e");
if (crc32("SRiIEuMHLJ",10) == 4246985685) strcat(s, "I");
if (crc32("BpYHMjFAVHG",11) == 4158804775) strcat(s, "a");
if (crc32("MTJZEFYRDbqOr",13) == 2080410056) strcat(s, "r");
if (crc32("OYdGlDcmFkRLujq",15) == 1149229052) strcat(s, "g");
if (crc32("zESmfyjWJAreGz",14) == 4124472158) strcat(s, "t");
if (crc32("FvdjdVo",7) == 1614061808) strcat(s, "u");
if (crc32("lKJFcjofqacFf",13) == 4115845506) strcat(s, "h");
if (crc32("rSzvEcZLN",9) == 1247412083) strcat(s, "V");
if (crc32("TLrkcPhKmiQfP",13) == 2203554060) strcat(s, "b");
if (crc32("pmpjFljMElTDC",13) == 2093012751) strcat(s, "o");
if (crc32("nyaub",5) == 2744563159) strcat(s, "d");
if (crc32("ZPjYMNrHUabWZ",13) == 988344193) strcat(s, "r");
if (crc32("HZwtKTPbeVCgf",13) == 3724744796) strcat(s, "i");
if (crc32("fOpysRD",7) == 3412753815) strcat(s, "n");
    return s;
}

char *hyperanabolic_adjectives() {
    char *s = calloc(14);
    if (crc32("yOzsfiA",7) == 3218225874) strcat(s, "t");
if (crc32("EmWaYnhO",8) == 3840689115) strcat(s, "h");
if (crc32("oulLzcALVPo",11) == 16789422) strcat(s, "y");
if (crc32("WCeDcjBtmR",10) == 488854048) strcat(s, "p");
if (crc32("CVMGDZmtvY",10) == 3068654734) strcat(s, "w");
if (crc32("Utqfl",5) == 4028392280) strcat(s, "e");
if (crc32("rOhUFfOrwRtPA",13) == 2949312638) strcat(s, "r");
if (crc32("EqOAOBIYoy",10) == 4243640928) strcat(s, "a");
if (crc32("zgOKRxli",8) == 21951021) strcat(s, "n");
if (crc32("UzGuPnnTZaBdy",13) == 1330737026) strcat(s, "v");
if (crc32("YGHYtQam",8) == 3190386055) strcat(s, "a");
if (crc32("rFpdShhMnH",10) == 2123785605) strcat(s, "h");
if (crc32("EPnlTn",6) == 950899660) strcat(s, "b");
if (crc32("ZdLixUD",7) == 3189652602) strcat(s, "o");
if (crc32("hjcNbIAF",8) == 814017863) strcat(s, "t");
if (crc32("GcuWZTRXfe",10) == 2509382222) strcat(s, "l");
if (crc32("PBrXc",5) == 2147455601) strcat(s, "N");
if (crc32("dMlIKfcK",8) == 2434488410) strcat(s, "i");
if (crc32("uZATLodVzXNzdI",14) == 1914520740) strcat(s, "c");
    return s;
}

char *manganic_adjectives() {
    char *s = calloc(9);
    if (crc32("SwIvTCrPMbFPLPX",15) == 3280351962) strcat(s, "y");
if (crc32("LqsQViFG",8) == 1043453473) strcat(s, "m");
if (crc32("aiQqusHopzbiN",13) == 1285843706) strcat(s, "a");
if (crc32("pltyXyuY",8) == 4101223792) strcat(s, "n");
if (crc32("vKnBpLwQA",9) == 1401653273) strcat(s, "g");
if (crc32("iKacthYqbcSvpaB",15) == 3048858928) strcat(s, "M");
if (crc32("XgEuGnMTM",9) == 665003849) strcat(s, "a");
if (crc32("FNHqmjNaphWqAtj",15) == 2184799035) strcat(s, "j");
if (crc32("zHAnTvAh",8) == 1934123763) strcat(s, "n");
if (crc32("fXLkGOymHTaromR",15) == 1398580171) strcat(s, "r");
if (crc32("gcOYDHUoEUA",11) == 323305638) strcat(s, "i");
if (crc32("NmXSRyaHFp",10) == 3835354156) strcat(s, "c");
    return s;
}

char *warty_adjectives() {
    char *s = calloc(6);
    if (crc32("ythPZduRGcjmnFi",15) == 1861525911) strcat(s, "G");
if (crc32("RFocpufKxriSma",14) == 602071099) strcat(s, "w");
if (crc32("XbZDiNYmgUR",11) == 463576484) strcat(s, "f");
if (crc32("spULtbelPH",10) == 1827847662) strcat(s, "a");
if (crc32("ErXmliFZZOxbTF",14) == 4017389322) strcat(s, "r");
if (crc32("pzTdG",5) == 3592284463) strcat(s, "x");
if (crc32("uDgDjzInynT",11) == 558616546) strcat(s, "t");
if (crc32("ELIpAefziCTYzFP",15) == 56304096) strcat(s, "W");
if (crc32("rPeVgMMCiwXSP",13) == 2688344940) strcat(s, "y");
    return s;
}

char *capitalisable_adjectives() {
    char *s = calloc(14);
    if (crc32("GjeiXWRSY",9) == 1493456331) strcat(s, "c");
if (crc32("yHZSwTEQAbfkDJa",15) == 3722959668) strcat(s, "a");
if (crc32("JNjHoohh",8) == 2881604363) strcat(s, "w");
if (crc32("HYkgiXDLDtJmWC",14) == 4051553292) strcat(s, "p");
if (crc32("fxpDMXcNmKFlO",13) == 114593889) strcat(s, "f");
if (crc32("WnCzuqrAwRg",11) == 4224903157) strcat(s, "i");
if (crc32("eIUbQIajUUX",11) == 3510343363) strcat(s, "p");
if (crc32("lOcDfo",6) == 2768071683) strcat(s, "t");
if (crc32("MuxhURFEHp",10) == 1259148111) strcat(s, "a");
if (crc32("cjSPwuNz",8) == 3698398783) strcat(s, "l");
if (crc32("edtHdntTpZmjJWL",15) == 2950692898) strcat(s, "i");
if (crc32("DBBpOKrBsekkLE",14) == 1445530524) strcat(s, "s");
if (crc32("gvTLrBbohuRIG",13) == 332403112) strcat(s, "I");
if (crc32("CymulbLQ",8) == 1151060538) strcat(s, "a");
if (crc32("yOlPUkkvE",9) == 267216992) strcat(s, "c");
if (crc32("emqGLofnmp",10) == 664017888) strcat(s, "b");
if (crc32("PSTvmHuTmtwmR",13) == 775563526) strcat(s, "Z");
if (crc32("QZqxMVkHFu",10) == 4247429945) strcat(s, "l");
if (crc32("IArBV",5) == 3570250877) strcat(s, "i");
if (crc32("hDiKue",6) == 2909212881) strcat(s, "e");
    return s;
}

char *cloggy_adjectives() {
    char *s = calloc(7);
    if (crc32("OIwrIq",6) == 3171660511) strcat(s, "c");
if (crc32("CncpbMErNrBgBV",14) == 3217824852) strcat(s, "C");
if (crc32("cvujZdJf",8) == 2042265958) strcat(s, "l");
if (crc32("hwxGVSYTIykI",12) == 2393638436) strcat(s, "o");
if (crc32("ZsTxVb",6) == 251421232) strcat(s, "o");
if (crc32("piZEHwzuaMgMULV",15) == 4192921004) strcat(s, "g");
if (crc32("GvfCOJtFrxuIfx",14) == 2370629438) strcat(s, "g");
if (crc32("eUExFtzXHgXoaI",14) == 1339562603) strcat(s, "b");
if (crc32("aEzikVMWcMgjZYR",15) == 2461745124) strcat(s, "y");
    return s;
}

char *onlimits_adjectives() {
    char *s = calloc(9);
    if (crc32("XNbJSafT",8) == 2585624976) strcat(s, "x");
if (crc32("elQNUpyYTtDjm",13) == 1008437195) strcat(s, "o");
if (crc32("uDPxvExZ",8) == 3187101678) strcat(s, "V");
if (crc32("QWWUtMISagme",12) == 2535991601) strcat(s, "n");
if (crc32("hHuvPnXQlvObKfC",15) == 3655530337) strcat(s, "l");
if (crc32("dfFdRZmhykv",11) == 1283096072) strcat(s, "i");
if (crc32("EbZKb",5) == 6324271) strcat(s, "n");
if (crc32("CHPjrCpPKzR",11) == 1990713723) strcat(s, "m");
if (crc32("gybYAGAqKD",10) == 2453830331) strcat(s, "i");
if (crc32("yjDnvQHNBNAtS",13) == 2430438464) strcat(s, "t");
if (crc32("IazhTzQgCHrTOV",14) == 1828583250) strcat(s, "a");
if (crc32("CeASK",5) == 3561595853) strcat(s, "s");
    return s;
}

char *unlittered_adjectives() {
    char *s = calloc(11);
    if (crc32("GRnattMPN",9) == 779175649) strcat(s, "x");
if (crc32("uOQuyf",6) == 1260992231) strcat(s, "u");
if (crc32("uzMSzm",6) == 3088603439) strcat(s, "n");
if (crc32("zUOPkRhima",10) == 2598258877) strcat(s, "l");
if (crc32("mGAgbDIsoJrKsnS",15) == 3477466541) strcat(s, "d");
if (crc32("VGgnbfNRbYzMK",13) == 3440033852) strcat(s, "i");
if (crc32("mcvwNIDguNaVdcf",15) == 1174269382) strcat(s, "m");
if (crc32("womFDiETSyfQRy",14) == 2186519194) strcat(s, "t");
if (crc32("qcwChGUBPInVU",13) == 158745192) strcat(s, "t");
if (crc32("mTmhOSWVUG",10) == 2344113597) strcat(s, "e");
if (crc32("KclnoDCFex",10) == 2510751667) strcat(s, "M");
if (crc32("jsdpb",5) == 2943847933) strcat(s, "r");
if (crc32("RnQRqjozLhD",11) == 2949908225) strcat(s, "e");
if (crc32("ebvVHKgxloJo",12) == 2967573860) strcat(s, "w");
if (crc32("eFgqYec",7) == 3392046038) strcat(s, "d");
    return s;
}

char *cablelaid_adjectives() {
    char *s = calloc(10);
    if (crc32("PDGGuyVgiHDoF",13) == 714789304) strcat(s, "c");
if (crc32("zclto",5) == 2336269793) strcat(s, "a");
if (crc32("LDRhQBSOlObyS",13) == 3273594514) strcat(s, "b");
if (crc32("ItYFechvDeDjpgf",15) == 3870071919) strcat(s, "c");
if (crc32("wBhiXpMGj",9) == 2274379955) strcat(s, "l");
if (crc32("lEVftGSqQV",10) == 272152623) strcat(s, "e");
if (crc32("vurXSQTqIujH",12) == 1517602874) strcat(s, "l");
if (crc32("unNxhSDzxYgp",12) == 536194488) strcat(s, "T");
if (crc32("repZiXVmZ",9) == 1215129579) strcat(s, "a");
if (crc32("eBAeOwh",7) == 935898421) strcat(s, "i");
if (crc32("uurinTagADiQIkB",15) == 3384062534) strcat(s, "R");
if (crc32("odIqsOFy",8) == 1917023175) strcat(s, "d");
    return s;
}

char *undestitute_adjectives() {
    char *s = calloc(12);
    if (crc32("aIHvtXuR",8) == 1676983085) strcat(s, "F");
if (crc32("QiqcXgsN",8) == 708528820) strcat(s, "u");
if (crc32("OjCiVe",6) == 2211454607) strcat(s, "n");
if (crc32("AuhjYdy",7) == 2449695790) strcat(s, "d");
if (crc32("FQYyAAZoKePOQsS",15) == 1390283254) strcat(s, "w");
if (crc32("QDwmpuUQIPUkx",13) == 2507095945) strcat(s, "e");
if (crc32("bvFtuDPYRsHEzwN",15) == 493710424) strcat(s, "x");
if (crc32("nCzuuoUkWNKYm",13) == 3307018703) strcat(s, "s");
if (crc32("CwcgAZYXMu",10) == 3841075937) strcat(s, "Q");
if (crc32("GNDrLgCz",8) == 2991284136) strcat(s, "t");
if (crc32("gxMaTEqm",8) == 1074146628) strcat(s, "i");
if (crc32("AUwywCW",7) == 24333690) strcat(s, "t");
if (crc32("CZAqGIW",7) == 1391167061) strcat(s, "u");
if (crc32("MZapdoubJ",9) == 3234220324) strcat(s, "N");
if (crc32("PRkWOPEbRKdYh",13) == 2424954286) strcat(s, "t");
if (crc32("gqDLJBtnulLQGKx",15) == 3758470496) strcat(s, "e");
    return s;
}

char *postuterine_adjectives() {
    char *s = calloc(12);
    if (crc32("OISCiqUtBvexZ",13) == 937037405) strcat(s, "b");
if (crc32("PAIZAmhCeppDehR",15) == 1133244091) strcat(s, "p");
if (crc32("aqJWlSnV",8) == 1963866963) strcat(s, "k");
if (crc32("CKvlrdIeMWizYx",14) == 686545650) strcat(s, "o");
if (crc32("sdqfyYCzz",9) == 3123677814) strcat(s, "s");
if (crc32("nRPeDKSJtEaba",13) == 2882865027) strcat(s, "t");
if (crc32("grmvKEo",7) == 3151647162) strcat(s, "V");
if (crc32("kWfrEup",7) == 2785977968) strcat(s, "u");
if (crc32("FZjybEfsOHLL",12) == 2524554464) strcat(s, "e");
if (crc32("hKQKjYseUsxAf",13) == 1571477884) strcat(s, "t");
if (crc32("kbZrNpSkQKhsEJb",15) == 4246666819) strcat(s, "s");
if (crc32("bCkArWcFfpSv",12) == 593504269) strcat(s, "e");
if (crc32("qsFLpbuMjZLTR",13) == 1403803300) strcat(s, "S");
if (crc32("oSRpwAFQxr",10) == 2324333216) strcat(s, "r");
if (crc32("jlomDcCMIZ",10) == 2205749438) strcat(s, "k");
if (crc32("dCfZiyF",7) == 4292834516) strcat(s, "i");
if (crc32("TfNrLaL",7) == 3750538579) strcat(s, "D");
if (crc32("DIymkcJJTA",10) == 3046995571) strcat(s, "n");
if (crc32("BntGCXXdTvnE",12) == 2888870478) strcat(s, "L");
if (crc32("VEDFuiN",7) == 3868292998) strcat(s, "e");
    return s;
}

char *unorganic_adjectives() {
    char *s = calloc(10);
    if (crc32("eKQdfszaeqEuxRd",15) == 3334643536) strcat(s, "u");
if (crc32("nhkFHynBkTLvkBT",15) == 4090119366) strcat(s, "Q");
if (crc32("cjfTkkZjj",9) == 3962482897) strcat(s, "n");
if (crc32("NlCAbVCv",8) == 1649444185) strcat(s, "o");
if (crc32("dqEFvtlCiNy",11) == 599501623) strcat(s, "r");
if (crc32("xjhiWHlE",8) == 4106311205) strcat(s, "W");
if (crc32("zBtuvbDuaqIZFgj",15) == 2610445930) strcat(s, "g");
if (crc32("yBQTPLN",7) == 2918847983) strcat(s, "X");
if (crc32("dFkfmPD",7) == 1077817556) strcat(s, "a");
if (crc32("RpVaapsxa",9) == 3520685796) strcat(s, "n");
if (crc32("cZSUXJZ",7) == 39423565) strcat(s, "O");
if (crc32("LcGcuT",6) == 1708551050) strcat(s, "i");
if (crc32("rNaVn",5) == 822443046) strcat(s, "c");
    return s;
}

char *yarer_adjectives() {
    char *s = calloc(6);
    if (crc32("xVgIpYkZSzpu",12) == 3999048728) strcat(s, "x");
if (crc32("kCliRt",6) == 632376900) strcat(s, "y");
if (crc32("dDbwQo",6) == 837305319) strcat(s, "a");
if (crc32("eEOQkuT",7) == 3366566947) strcat(s, "r");
if (crc32("fKvLa",5) == 3956782523) strcat(s, "C");
if (crc32("ulZoCBD",7) == 2362328187) strcat(s, "e");
if (crc32("oCNOC",5) == 3122442591) strcat(s, "v");
if (crc32("CyQGtAnfVKdUvtl",15) == 2415779284) strcat(s, "r");
    return s;
}

char *wellaccustomed_adjectives() {
    char *s = calloc(15);
    if (crc32("CumkOHW",7) == 2290885809) strcat(s, "w");
if (crc32("IrOXVSudyS",10) == 87259020) strcat(s, "e");
if (crc32("daduO",5) == 2057929574) strcat(s, "e");
if (crc32("DGpGkZPtYICwlwg",15) == 1331748640) strcat(s, "l");
if (crc32("bOPmeuSRZeht",12) == 273038412) strcat(s, "l");
if (crc32("pzMpzPvni",9) == 3804708768) strcat(s, "a");
if (crc32("SSiEAlqiJxMimw",14) == 1750301624) strcat(s, "F");
if (crc32("gHQwWSEsK",9) == 1999679600) strcat(s, "c");
if (crc32("agHsKHwFe",9) == 4117811789) strcat(s, "S");
if (crc32("BLRevYDD",8) == 1429778882) strcat(s, "c");
if (crc32("yQqFa",5) == 2297734734) strcat(s, "u");
if (crc32("sHPQB",5) == 1899921353) strcat(s, "s");
if (crc32("cpmRGpO",7) == 2420068000) strcat(s, "t");
if (crc32("IVHrw",5) == 1149531318) strcat(s, "L");
if (crc32("SiICbAbc",8) == 4104567551) strcat(s, "o");
if (crc32("kVadjfQzVxtkhy",14) == 2632724977) strcat(s, "F");
if (crc32("lmAwGnNqt",9) == 3381250545) strcat(s, "m");
if (crc32("NxhBWkAcSLwQ",12) == 2144912266) strcat(s, "Q");
if (crc32("XWMZFexQGhP",11) == 1868705183) strcat(s, "e");
if (crc32("JGOWoQPfYNrUnfj",15) == 1563877736) strcat(s, "d");
    return s;
}

char *centrolecithal_adjectives() {
    char *s = calloc(15);
    if (crc32("jguhBArtmCVKLu",14) == 4228066162) strcat(s, "z");
if (crc32("LdMMrAzldEQY",12) == 1666729749) strcat(s, "c");
if (crc32("HOKiCTiAJCdvW",13) == 2776342187) strcat(s, "T");
if (crc32("bxDbJoBMgLB",11) == 1275285461) strcat(s, "e");
if (crc32("WnThyVSjDqf",11) == 2693808113) strcat(s, "M");
if (crc32("hqgQXivcvIow",12) == 3123364714) strcat(s, "n");
if (crc32("xMKsvpVuYNiIQSh",15) == 1755641357) strcat(s, "r");
if (crc32("WNlQsePDnwA",11) == 328917843) strcat(s, "t");
if (crc32("QwRwsAqmZRYpZM",14) == 2414289833) strcat(s, "s");
if (crc32("lxXEEGEb",8) == 3129090316) strcat(s, "r");
if (crc32("BnRqUDqmoDf",11) == 2370205509) strcat(s, "o");
if (crc32("PsRyLuI",7) == 2218679675) strcat(s, "P");
if (crc32("mpZnpAAOjGvzC",13) == 2164298043) strcat(s, "l");
if (crc32("YGdpyaDQR",9) == 2229689663) strcat(s, "U");
if (crc32("oPsPkjgbdMK",11) == 4233311190) strcat(s, "e");
if (crc32("MoGuPdKZbhhy",12) == 3197285150) strcat(s, "c");
if (crc32("pFJtRyGQxx",10) == 4247795562) strcat(s, "b");
if (crc32("fnQoYqqab",9) == 486028083) strcat(s, "i");
if (crc32("Biqgcd",6) == 2410060722) strcat(s, "b");
if (crc32("WErZUQenNDwwDM",14) == 3139888638) strcat(s, "t");
if (crc32("WWWGoZAYsS",10) == 1300890153) strcat(s, "h");
if (crc32("UJrKWMMF",8) == 3103044169) strcat(s, "e");
if (crc32("naZXdLVsmugM",12) == 1180188927) strcat(s, "a");
if (crc32("eHWnpFNhYBcSPSU",15) == 3101888092) strcat(s, "T");
if (crc32("hGpgH",5) == 1877604231) strcat(s, "l");
    return s;
}

char *nonvitriolic_adjectives() {
    char *s = calloc(13);
    if (crc32("CyMOfiqmKXsdU",13) == 1721875021) strcat(s, "G");
if (crc32("CDOjrXzBfOKLdzB",15) == 3828717100) strcat(s, "n");
if (crc32("RJWfMlgjSW",10) == 1394083344) strcat(s, "P");
if (crc32("PGsKCWcJxKg",11) == 107800584) strcat(s, "o");
if (crc32("GfMKkSVhTYSpIrV",15) == 590568421) strcat(s, "M");
if (crc32("CMtMkrMOmRjc",12) == 2202401599) strcat(s, "n");
if (crc32("ACJREjaF",8) == 2012803161) strcat(s, "T");
if (crc32("WouVewunmG",10) == 2862951712) strcat(s, "v");
if (crc32("NlkPXcQUZgNcZsC",15) == 3583560760) strcat(s, "i");
if (crc32("rdKTPkda",8) == 3259918837) strcat(s, "B");
if (crc32("OVqAPzeiMr",10) == 3917115) strcat(s, "t");
if (crc32("QllVpSJkCXfYbZ",14) == 3995453585) strcat(s, "r");
if (crc32("TGIFkjrTVoVF",12) == 2205242628) strcat(s, "i");
if (crc32("VQCRLwcgBrhB",12) == 2183986353) strcat(s, "a");
if (crc32("TdkRmO",6) == 4282448376) strcat(s, "o");
if (crc32("bsiEMppbQJgjMEM",15) == 2867997683) strcat(s, "l");
if (crc32("jwBmXunYwxpZ",12) == 3421928674) strcat(s, "A");
if (crc32("ixEZAVqrAKTf",12) == 3592377917) strcat(s, "i");
if (crc32("TJEOBlMBQy",10) == 3513441263) strcat(s, "W");
if (crc32("wJyyJSLolkB",11) == 287849511) strcat(s, "c");
    return s;
}

char *Gabar_adjectives() {
    char *s = calloc(6);
    if (crc32("bggPUss",7) == 2881944889) strcat(s, "f");
if (crc32("QZVwl",5) == 732589792) strcat(s, "G");
if (crc32("sdtfXO",6) == 1824523333) strcat(s, "a");
if (crc32("RGGnIpmoM",9) == 774001542) strcat(s, "B");
if (crc32("nCOdONIrkNLf",12) == 3134236880) strcat(s, "b");
if (crc32("wjWSOQkWDjfov",13) == 3877416728) strcat(s, "a");
if (crc32("ycQqiskhUXgNbm",14) == 2211450937) strcat(s, "r");
    return s;
}

char *oilfired_adjectives() {
    char *s = calloc(9);
    if (crc32("fvqUXqgBv",9) == 1480741268) strcat(s, "o");
if (crc32("czUvJ",5) == 2569609437) strcat(s, "i");
if (crc32("NlbitoPwf",9) == 3354154870) strcat(s, "o");
if (crc32("anxkFPegn",9) == 131090602) strcat(s, "l");
if (crc32("plpWZbFwc",9) == 1330859176) strcat(s, "f");
if (crc32("ACaMyvdEuTpZ",12) == 574958337) strcat(s, "i");
if (crc32("cvPHvGas",8) == 2884686298) strcat(s, "K");
if (crc32("OUBOiWB",7) == 3087407976) strcat(s, "r");
if (crc32("KLkawgydqYwA",12) == 4025609012) strcat(s, "x");
if (crc32("oRmGCdndaCY",11) == 1862858545) strcat(s, "e");
if (crc32("dmNuaROQP",9) == 2515045874) strcat(s, "d");
    return s;
}

char *anthocarpous_adjectives() {
    char *s = calloc(13);
    if (crc32("XKHmvpAdMhaFtPb",15) == 4289799167) strcat(s, "u");
if (crc32("qCCIKePeudajZ",13) == 1694565479) strcat(s, "a");
if (crc32("ozjbKSaOVwyRMDP",15) == 3926252184) strcat(s, "s");
if (crc32("ZJrVfHpAtF",10) == 3503644157) strcat(s, "n");
if (crc32("NXSUdSUeRlOHL",13) == 711192042) strcat(s, "k");
if (crc32("vztCTqmP",8) == 1652653017) strcat(s, "t");
if (crc32("FOgPPWFeFPZ",11) == 1634286205) strcat(s, "b");
if (crc32("NtWDhT",6) == 1755966197) strcat(s, "h");
if (crc32("OQjcVV",6) == 2558341148) strcat(s, "a");
if (crc32("mMKkQbbCU",9) == 3268936827) strcat(s, "o");
if (crc32("MEmKaEY",7) == 473878495) strcat(s, "c");
if (crc32("evxOQnDC",8) == 91996245) strcat(s, "a");
if (crc32("NFpCwMMV",8) == 256904848) strcat(s, "Q");
if (crc32("tRkczRB",7) == 1246064359) strcat(s, "r");
if (crc32("lvqoNVwmGZT",11) == 1419579730) strcat(s, "c");
if (crc32("uJAIFedfSMRwmzk",15) == 4161828128) strcat(s, "p");
if (crc32("JqEHkBblBAoskl",14) == 128878707) strcat(s, "C");
if (crc32("SMZLFVEXNc",10) == 3276740378) strcat(s, "o");
if (crc32("OHMyquy",7) == 1423075149) strcat(s, "u");
if (crc32("byPXFNctXZL",11) == 3894759206) strcat(s, "s");
    return s;
}

char *Argonautic_adjectives() {
    char *s = calloc(11);
    if (crc32("VvJQAAVcWI",10) == 4063293975) strcat(s, "p");
if (crc32("hwuztOcZqmihF",13) == 1469243487) strcat(s, "A");
if (crc32("qIQUMoC",7) == 1937129343) strcat(s, "r");
if (crc32("VBBXlSk",7) == 236516777) strcat(s, "G");
if (crc32("hjJAX",5) == 3391386466) strcat(s, "g");
if (crc32("homIMQ",6) == 2713388467) strcat(s, "o");
if (crc32("HWIHPr",6) == 1155513586) strcat(s, "n");
if (crc32("fJDnxjuT",8) == 4211334620) strcat(s, "h");
if (crc32("XoytqwnU",8) == 3693235054) strcat(s, "a");
if (crc32("vFYfW",5) == 3134454955) strcat(s, "r");
if (crc32("ookrsKm",7) == 1088236948) strcat(s, "u");
if (crc32("onlpseRsVJLhGrq",15) == 3671910300) strcat(s, "t");
if (crc32("SvWJAptCqoVql",13) == 3790239013) strcat(s, "i");
if (crc32("iwRkOSowj",9) == 3953932385) strcat(s, "c");
    return s;
}

char *bluffable_adjectives() {
    char *s = calloc(10);
    if (crc32("ydxFsG",6) == 3624141276) strcat(s, "i");
if (crc32("WfPYOZV",7) == 2453659649) strcat(s, "b");
if (crc32("uIFVrQrLdasuyWu",15) == 4035800392) strcat(s, "i");
if (crc32("HoTabxDz",8) == 1054947938) strcat(s, "l");
if (crc32("VGkeLMjcb",9) == 1237328414) strcat(s, "u");
if (crc32("HPDxVX",6) == 1757282534) strcat(s, "X");
if (crc32("RDytObeC",8) == 2640427091) strcat(s, "f");
if (crc32("qFigb",5) == 2368255040) strcat(s, "s");
if (crc32("gwUEILlOu",9) == 3296986117) strcat(s, "f");
if (crc32("AwYIXMadbXsgON",14) == 3207823237) strcat(s, "a");
if (crc32("YutdwAnUhLS",11) == 1586150150) strcat(s, "b");
if (crc32("FwuFTiSJeyuAk",13) == 606528279) strcat(s, "l");
if (crc32("nQRARtaYdUZp",12) == 1080230791) strcat(s, "e");
    return s;
}

char *illustratable_adjectives() {
    char *s = calloc(14);
    if (crc32("PkSxHACeGOZ",11) == 664130499) strcat(s, "i");
if (crc32("XXVcYt",6) == 3248150796) strcat(s, "l");
if (crc32("FKgAyNJpelAxIH",14) == 1690332430) strcat(s, "L");
if (crc32("zYtxTY",6) == 1554472349) strcat(s, "l");
if (crc32("bFPvYVknNi",10) == 698785386) strcat(s, "u");
if (crc32("KdFyDRVhT",9) == 4010084033) strcat(s, "D");
if (crc32("LIVKeH",6) == 1855927699) strcat(s, "s");
if (crc32("fvVnMxYhSXcuy",13) == 3330261288) strcat(s, "X");
if (crc32("pILMtYhtaA",10) == 1241206084) strcat(s, "t");
if (crc32("naoPORxSqrA",11) == 136069926) strcat(s, "y");
if (crc32("kLHrr",5) == 612991448) strcat(s, "r");
if (crc32("fREMjgLypr",10) == 1617226941) strcat(s, "E");
if (crc32("tfwVOM",6) == 3596011609) strcat(s, "a");
if (crc32("sEYijTceBPYCb",13) == 2953496754) strcat(s, "O");
if (crc32("sXFtO",5) == 2949536718) strcat(s, "t");
if (crc32("nvJrGWJEsaoU",12) == 21366218) strcat(s, "g");
if (crc32("JITnPGsFp",9) == 3762423686) strcat(s, "a");
if (crc32("TvuBHOzr",8) == 211250012) strcat(s, "b");
if (crc32("NIKBR",5) == 1455383869) strcat(s, "B");
if (crc32("nyDOQBhTfzIp",12) == 4229614878) strcat(s, "l");
if (crc32("WLHAmIdHWXfQ",12) == 3519385728) strcat(s, "e");
    return s;
}

char *wellbrewed_adjectives() {
    char *s = calloc(11);
    if (crc32("sCUhAxiEIeCoQP",14) == 2446148086) strcat(s, "w");
if (crc32("HrUTqRTwb",9) == 2248526034) strcat(s, "e");
if (crc32("MswhYbUQNPpwa",13) == 915505827) strcat(s, "q");
if (crc32("BwOTCNWuFNm",11) == 2667345752) strcat(s, "l");
if (crc32("lIALytvoydfaV",13) == 1847282895) strcat(s, "E");
if (crc32("LfUOvaV",7) == 1568448033) strcat(s, "l");
if (crc32("vtupuEkdmzrkN",13) == 2947590904) strcat(s, "b");
if (crc32("OYMATmEuroI",11) == 3033445297) strcat(s, "r");
if (crc32("LNTHkswAEBneWY",14) == 718100205) strcat(s, "F");
if (crc32("tTvUk",5) == 3285134532) strcat(s, "e");
if (crc32("UibyEBBhmtQ",11) == 2219626553) strcat(s, "h");
if (crc32("QcHfJrDs",8) == 1296883269) strcat(s, "w");
if (crc32("QAUFxA",6) == 571773581) strcat(s, "b");
if (crc32("OWNbXS",6) == 1969745299) strcat(s, "e");
if (crc32("xFVnXbv",7) == 2067968060) strcat(s, "d");
    return s;
}

char *dermographic_adjectives() {
    char *s = calloc(13);
    if (crc32("xNVdbUfhCuqzC",13) == 2707061241) strcat(s, "Y");
if (crc32("bwKYv",5) == 2112363296) strcat(s, "d");
if (crc32("rrdIFBKhQ",9) == 2863564273) strcat(s, "e");
if (crc32("sifkFBOTqvas",12) == 951681387) strcat(s, "r");
if (crc32("SFkxJJvUxBXsrUR",15) == 2693305016) strcat(s, "j");
if (crc32("dKObxlZN",8) == 1409658689) strcat(s, "m");
if (crc32("nTzkFwUho",9) == 3001714601) strcat(s, "o");
if (crc32("XgmHyQ",6) == 4032902263) strcat(s, "m");
if (crc32("azrajYDttEam",12) == 3743354300) strcat(s, "g");
if (crc32("tZsAIVLPiYnx",12) == 2762130077) strcat(s, "r");
if (crc32("iVnpICiteHH",11) == 3934145283) strcat(s, "a");
if (crc32("DZGoiYEmceCfmc",14) == 1527952704) strcat(s, "p");
if (crc32("YyRdaeXUTh",10) == 4185633497) strcat(s, "h");
if (crc32("HBFPZdmx",8) == 3359581189) strcat(s, "i");
if (crc32("Pagigrpkn",9) == 2066123821) strcat(s, "c");
    return s;
}

char *unloafing_adjectives() {
    char *s = calloc(10);
    if (crc32("fekvPJZrspC",11) == 1573153775) strcat(s, "X");
if (crc32("GTsqw",5) == 3329003920) strcat(s, "u");
if (crc32("yoSAFRPLvgRI",12) == 3567542199) strcat(s, "n");
if (crc32("jUtHB",5) == 367649508) strcat(s, "m");
if (crc32("annCpXZWUAnSVF",14) == 1483716956) strcat(s, "l");
if (crc32("mdcdyqV",7) == 1639071095) strcat(s, "o");
if (crc32("HnULJQ",6) == 3882003799) strcat(s, "a");
if (crc32("hJzyqzljdovKMPO",15) == 1298092131) strcat(s, "f");
if (crc32("ssQWNroWeuQWS",13) == 1256454123) strcat(s, "i");
if (crc32("AZfVhdX",7) == 865202720) strcat(s, "d");
if (crc32("NJnTzUQC",8) == 1688465980) strcat(s, "n");
if (crc32("KQfhZp",6) == 2583055314) strcat(s, "g");
    return s;
}

char *cindery_adjectives() {
    char *s = calloc(8);
    if (crc32("QKCOWxxOH",9) == 3776368915) strcat(s, "x");
if (crc32("MIzveWNp",8) == 2180394884) strcat(s, "c");
if (crc32("gQCCGvdI",8) == 1471530412) strcat(s, "K");
if (crc32("FTpRoIk",7) == 221131451) strcat(s, "i");
if (crc32("zNlTylghhiLznnD",15) == 613111611) strcat(s, "n");
if (crc32("xboCgvHleEZ",11) == 470388873) strcat(s, "d");
if (crc32("YZEcKi",6) == 693681586) strcat(s, "e");
if (crc32("PqZDfcjBSuAhq",13) == 1882643439) strcat(s, "r");
if (crc32("qPifTW",6) == 926611376) strcat(s, "g");
if (crc32("ckDExAjdgshn",12) == 4223939939) strcat(s, "y");
    return s;
}

char *rebellike_adjectives() {
    char *s = calloc(10);
    if (crc32("EQOYfOGaXNuavS",14) == 3407852286) strcat(s, "r");
if (crc32("yHhsVyWjyvDGeC",14) == 1864066214) strcat(s, "u");
if (crc32("RbyaXgmUVv",10) == 2404619858) strcat(s, "e");
if (crc32("YlxYLIjGlfIJM",13) == 2701351538) strcat(s, "b");
if (crc32("oGHBdtbQk",9) == 3380817051) strcat(s, "e");
if (crc32("hLWXIco",7) == 900977055) strcat(s, "l");
if (crc32("SHbMFNhluQM",11) == 4101478248) strcat(s, "l");
if (crc32("hCDfFrxwtCsdTGe",15) == 2394991097) strcat(s, "i");
if (crc32("SRROM",5) == 3709709745) strcat(s, "m");
if (crc32("qpQbxPEZoX",10) == 441517617) strcat(s, "k");
if (crc32("eiCBhWEnKaCk",12) == 4253746705) strcat(s, "e");
    return s;
}

char *unqueried_adjectives() {
    char *s = calloc(10);
    if (crc32("TPWcyalmdh",10) == 3627594021) strcat(s, "m");
if (crc32("LSDKLdZxa",9) == 1172465431) strcat(s, "u");
if (crc32("dOTTSz",6) == 4137200475) strcat(s, "n");
if (crc32("ycOJyb",6) == 2688971393) strcat(s, "q");
if (crc32("lrbgdyTsdEt",11) == 423354153) strcat(s, "u");
if (crc32("mhKSy",5) == 2643607075) strcat(s, "e");
if (crc32("RGoZklMmHWkg",12) == 3792282823) strcat(s, "r");
if (crc32("FHLVQ",5) == 3325871410) strcat(s, "i");
if (crc32("cbeojbmRHYWWgCZ",15) == 2952185233) strcat(s, "p");
if (crc32("sDKgwE",6) == 4131551474) strcat(s, "e");
if (crc32("fWRvfOaCjYYk",12) == 713902685) strcat(s, "u");
if (crc32("fQxKtglLYZbN",12) == 694963265) strcat(s, "d");
    return s;
}

char *swart_adjectives() {
    char *s = calloc(6);
    if (crc32("qvpbMdFqr",9) == 2344027484) strcat(s, "U");
if (crc32("LqwrgGwWpDWi",12) == 2709430151) strcat(s, "s");
if (crc32("hSYIdBnOTBA",11) == 1269648650) strcat(s, "w");
if (crc32("ErVzIAGMkWVleTL",15) == 2877988616) strcat(s, "e");
if (crc32("VwrEkRxXJNtdPN",14) == 1978349730) strcat(s, "a");
if (crc32("SXXQU",5) == 1831260973) strcat(s, "r");
if (crc32("aAZnxfMBF",9) == 253775753) strcat(s, "t");
    return s;
}

char *nonefficient_adjectives() {
    char *s = calloc(13);
    if (crc32("BCrvelagHvntpVk",15) == 3385070347) strcat(s, "I");
if (crc32("sMuzjErxrLkxOu",14) == 1155579486) strcat(s, "n");
if (crc32("gaFdUVwEGA",10) == 3169822047) strcat(s, "L");
if (crc32("zrLtZVFtNx",10) == 2101672188) strcat(s, "o");
if (crc32("YJUAhtqUyqAG",12) == 290335550) strcat(s, "n");
if (crc32("FTxNUfKJehRXEK",14) == 2106795318) strcat(s, "e");
if (crc32("OPRkKTz",7) == 2677890275) strcat(s, "f");
if (crc32("Lnqtko",6) == 1386122341) strcat(s, "S");
if (crc32("lddgOLMfebzxOj",14) == 3651541314) strcat(s, "f");
if (crc32("OpDrIHF",7) == 2419217026) strcat(s, "l");
if (crc32("ILOYz",5) == 3798769250) strcat(s, "i");
if (crc32("OUYJB",5) == 3746115850) strcat(s, "P");
if (crc32("gVUnqQJKkILso",13) == 983869224) strcat(s, "c");
if (crc32("dxbsqLt",7) == 2124409119) strcat(s, "W");
if (crc32("IgGXF",5) == 2906171939) strcat(s, "i");
if (crc32("wJUmuSqUDw",10) == 1977258071) strcat(s, "f");
if (crc32("ONKNTVSWNHHrUn",14) == 4053592616) strcat(s, "e");
if (crc32("zssYrk",6) == 182056133) strcat(s, "h");
if (crc32("JzhjsYl",7) == 1404956002) strcat(s, "n");
if (crc32("wpiuJ",5) == 1200742435) strcat(s, "A");
if (crc32("sKvgozwqQrxLvFq",15) == 1419947716) strcat(s, "t");
    return s;
}

char *nondefiant_adjectives() {
    char *s = calloc(11);
    if (crc32("PhmJDSxSFF",10) == 1144026603) strcat(s, "R");
if (crc32("SvOTmyoRTu",10) == 2807721173) strcat(s, "n");
if (crc32("wZElegzhE",9) == 4149005041) strcat(s, "b");
if (crc32("mpqrjTibHkzuzds",15) == 666520180) strcat(s, "o");
if (crc32("pOKWilqYIeO",11) == 1799217883) strcat(s, "n");
if (crc32("LYpLdpViejYcYn",14) == 3747926752) strcat(s, "d");
if (crc32("teAUBTtMWEDSLkg",15) == 3149252816) strcat(s, "r");
if (crc32("PpsjJYLDq",9) == 573938957) strcat(s, "e");
if (crc32("YubLqMSzFtur",12) == 3194622059) strcat(s, "K");
if (crc32("KdnOxwLvEAFa",12) == 224036211) strcat(s, "f");
if (crc32("ndoptaCH",8) == 3520142318) strcat(s, "i");
if (crc32("uIVZcRsTMD",10) == 155715897) strcat(s, "V");
if (crc32("eSzfC",5) == 3411844833) strcat(s, "a");
if (crc32("EzCBwVwvYYGkCWh",15) == 141683921) strcat(s, "n");
if (crc32("MWubTywazFq",11) == 2323974133) strcat(s, "R");
if (crc32("ALIwFlkXW",9) == 4090104579) strcat(s, "t");
    return s;
}

char *assentient_adjectives() {
    char *s = calloc(11);
    if (crc32("VYTLnRM",7) == 954707235) strcat(s, "X");
if (crc32("czoBy",5) == 3023032954) strcat(s, "a");
if (crc32("YsPPMPLbZdl",11) == 130493432) strcat(s, "y");
if (crc32("uOlSPo",6) == 1211239302) strcat(s, "s");
if (crc32("IEAHDvYPIDlTnN",14) == 3516140896) strcat(s, "s");
if (crc32("AxZFVHQwJfzoXg",14) == 1144844593) strcat(s, "B");
if (crc32("hqYpDDWGY",9) == 2707308285) strcat(s, "e");
if (crc32("vOONXDnQaZgty",13) == 2775636980) strcat(s, "L");
if (crc32("AsIqvJXzA",9) == 676153619) strcat(s, "n");
if (crc32("QbcOnhKuMQ",10) == 4157012449) strcat(s, "t");
if (crc32("VBfkKZytDV",10) == 2084534340) strcat(s, "i");
if (crc32("mZGTiZQCUraE",12) == 1167555199) strcat(s, "e");
if (crc32("SkWSKUKZYUDDiB",14) == 1192276670) strcat(s, "j");
if (crc32("FySqZKPJhYKKe",13) == 6827616) strcat(s, "n");
if (crc32("LlIPWceZ",8) == 3359498079) strcat(s, "t");
    return s;
}

char *unwrangling_adjectives() {
    char *s = calloc(12);
    if (crc32("bFnQgrRwmzX",11) == 1301559387) strcat(s, "B");
if (crc32("Ppsqc",5) == 556152342) strcat(s, "u");
if (crc32("GjhFOlzNaRom",12) == 788027087) strcat(s, "n");
if (crc32("iryEVHsQcOEOf",13) == 3933816055) strcat(s, "w");
if (crc32("mqMlVraglY",10) == 2466060784) strcat(s, "r");
if (crc32("EUcWb",5) == 3056951594) strcat(s, "a");
if (crc32("vizyhPrbsq",10) == 3653037260) strcat(s, "n");
if (crc32("Mikjd",5) == 2971718081) strcat(s, "g");
if (crc32("rKFYJUnQH",9) == 932168927) strcat(s, "l");
if (crc32("JYDfv",5) == 2671168233) strcat(s, "i");
if (crc32("YcdVIToAcFH",11) == 3318826612) strcat(s, "Q");
if (crc32("KXXsrTxh",8) == 1363952232) strcat(s, "n");
if (crc32("mmzjC",5) == 1198331326) strcat(s, "g");
    return s;
}

char *tubate_adjectives() {
    char *s = calloc(7);
    if (crc32("rWzjkFJxvaad",12) == 2269418778) strcat(s, "T");
if (crc32("iBbyDcvlGrFqP",13) == 2005394924) strcat(s, "t");
if (crc32("OySGHzkLGYd",11) == 4209125545) strcat(s, "u");
if (crc32("DlLWRvqpjZ",10) == 3071394965) strcat(s, "r");
if (crc32("tlZUMYlhga",10) == 2995575999) strcat(s, "b");
if (crc32("HqykVOmxONyDq",13) == 1321691384) strcat(s, "a");
if (crc32("AQxNiyuiuFbBBxj",15) == 2429025086) strcat(s, "t");
if (crc32("ZUsAhCuVZDvCq",13) == 1611710975) strcat(s, "t");
if (crc32("MhYGkVMmXRfSXx",14) == 2061435465) strcat(s, "J");
if (crc32("fzYEYoehr",9) == 374203640) strcat(s, "e");
    return s;
}

char *quasiexpectant_adjectives() {
    char *s = calloc(15);
    if (crc32("nNluY",5) == 554336440) strcat(s, "z");
if (crc32("PpYyNbUiXln",11) == 1856428925) strcat(s, "q");
if (crc32("UDxckx",6) == 3899523627) strcat(s, "b");
if (crc32("ZiHkgtJxvj",10) == 2908694053) strcat(s, "u");
if (crc32("nYNCP",5) == 687906830) strcat(s, "M");
if (crc32("xYabPilxV",9) == 3589813943) strcat(s, "a");
if (crc32("KXnDXk",6) == 541185313) strcat(s, "b");
if (crc32("HEGiZmvkJ",9) == 3086654185) strcat(s, "s");
if (crc32("bjtsBQaFQRD",11) == 2957186752) strcat(s, "i");
if (crc32("QmtGKsUYCzW",11) == 3550856504) strcat(s, "v");
if (crc32("xZdWxeLcTHB",11) == 668315761) strcat(s, "e");
if (crc32("HyIdwvCEJCCCAd",14) == 527095291) strcat(s, "C");
if (crc32("mkZoY",5) == 3663593917) strcat(s, "x");
if (crc32("twJjmonhUDQMa",13) == 3130599554) strcat(s, "p");
if (crc32("VEaHDNBFmzvG",12) == 2043956953) strcat(s, "e");
if (crc32("ABDGnlFx",8) == 44768822) strcat(s, "t");
if (crc32("gpuExC",6) == 2137162463) strcat(s, "c");
if (crc32("jPsYDtyudfuxMBY",15) == 2026891536) strcat(s, "g");
if (crc32("tARqdXxCI",9) == 922241060) strcat(s, "t");
if (crc32("WEnnJbAkLxKoC",13) == 84650469) strcat(s, "a");
if (crc32("eGMlmf",6) == 3211770494) strcat(s, "c");
if (crc32("DxfMOzrluF",10) == 211312758) strcat(s, "n");
if (crc32("FHyOCFljeg",10) == 472017833) strcat(s, "g");
if (crc32("uwUdkyy",7) == 3792310914) strcat(s, "t");
    return s;
}

char *electrotropic_adjectives() {
    char *s = calloc(14);
    if (crc32("JoiDwFuZpcyLzGK",15) == 1616535505) strcat(s, "e");
if (crc32("MULZzljtqgjpX",13) == 324620066) strcat(s, "l");
if (crc32("xaeKhLhupthBZP",14) == 2021362543) strcat(s, "e");
if (crc32("AVwUYfVpWwgcHe",14) == 4190078053) strcat(s, "v");
if (crc32("FRdnoPbV",8) == 1372019964) strcat(s, "c");
if (crc32("RxqVIJgVGYVpDvH",15) == 330874116) strcat(s, "t");
if (crc32("mbHQzTtkWqeRIv",14) == 1845434589) strcat(s, "t");
if (crc32("klfmaWmqsMDX",12) == 1938356371) strcat(s, "r");
if (crc32("upTGqgr",7) == 583715755) strcat(s, "o");
if (crc32("WbRNgf",6) == 2845296871) strcat(s, "p");
if (crc32("bsEgQBhiwwT",11) == 1173521932) strcat(s, "t");
if (crc32("daroTyQfb",9) == 2029242849) strcat(s, "O");
if (crc32("fFpzWoHMovgF",12) == 4140574880) strcat(s, "r");
if (crc32("xRQJE",5) == 2756201037) strcat(s, "M");
if (crc32("ZGXnZQDKfzBwRB",14) == 3780847102) strcat(s, "o");
if (crc32("PhJSrw",6) == 2727201511) strcat(s, "c");
if (crc32("QhKGHxTXrmn",11) == 294371037) strcat(s, "p");
if (crc32("QQCjJCxBHAazBm",14) == 874174037) strcat(s, "V");
if (crc32("KKytLvfwYQ",10) == 1153562997) strcat(s, "i");
if (crc32("zaoTL",5) == 351045347) strcat(s, "c");
    return s;
}

char *unretrogressive_adjectives() {
    char *s = calloc(16);
    if (crc32("nazAtHq",7) == 3116613307) strcat(s, "h");
if (crc32("YNPjdBoipM",10) == 2021451848) strcat(s, "u");
if (crc32("ZpYJDSJYETTHuy",14) == 178876393) strcat(s, "n");
if (crc32("HJcyABQUaky",11) == 3255966891) strcat(s, "G");
if (crc32("qeQUxy",6) == 4153882880) strcat(s, "r");
if (crc32("gjJxkdymvab",11) == 2771978113) strcat(s, "r");
if (crc32("OxVNrVvrTgqZ",12) == 2616054236) strcat(s, "e");
if (crc32("UYnKMKqtBIIsKro",15) == 2303805426) strcat(s, "t");
if (crc32("PHMIruuNnqQzk",13) == 3503179222) strcat(s, "E");
if (crc32("iJdGSvXcds",10) == 552900804) strcat(s, "r");
if (crc32("vVLiElVgNA",10) == 4039988282) strcat(s, "c");
if (crc32("dZylTkVCsZP",11) == 137056011) strcat(s, "o");
if (crc32("aUBNqs",6) == 917005738) strcat(s, "g");
if (crc32("gdzyhksMZLUYjM",14) == 2653026884) strcat(s, "r");
if (crc32("hisoHlePER",10) == 1505558822) strcat(s, "e");
if (crc32("rlfMBDVHZB",10) == 1944835725) strcat(s, "X");
if (crc32("MVDNe",5) == 2895571419) strcat(s, "s");
if (crc32("ZMkQlfHRnx",10) == 674451690) strcat(s, "l");
if (crc32("vgKAQqpiLEixVDl",15) == 720143661) strcat(s, "s");
if (crc32("gTSfeZqnH",9) == 2388904564) strcat(s, "Z");
if (crc32("IeGZIAENUMdhqJt",15) == 1497347906) strcat(s, "i");
if (crc32("txWSmQCoVYip",12) == 1035732084) strcat(s, "v");
if (crc32("TdiacADCyiOHfu",14) == 633574129) strcat(s, "K");
if (crc32("GWXZwPiMCfRDeY",14) == 788243099) strcat(s, "e");
    return s;
}

char *exhaustible_adjectives() {
    char *s = calloc(12);
    if (crc32("JkQoNhtiLQaA",12) == 3708287972) strcat(s, "K");
if (crc32("ISbYetxI",8) == 2249472793) strcat(s, "e");
if (crc32("eJUxOGlNXSjcy",13) == 487188275) strcat(s, "D");
if (crc32("sHyoMZPGKfIqqMD",15) == 1220645288) strcat(s, "x");
if (crc32("TiNRAcfEIiRehk",14) == 1878136548) strcat(s, "h");
if (crc32("rtSlUjUM",8) == 865761523) strcat(s, "a");
if (crc32("tcYFgMgCmvwiaGi",15) == 3438156468) strcat(s, "b");
if (crc32("IuAfzt",6) == 1173174571) strcat(s, "u");
if (crc32("UvLYmPFdXtzqM",13) == 2280209045) strcat(s, "p");
if (crc32("qHDaaeQngGZCD",13) == 2224908623) strcat(s, "s");
if (crc32("rDHJgSZEb",9) == 1631123869) strcat(s, "O");
if (crc32("OGXzk",5) == 2002587301) strcat(s, "t");
if (crc32("uYyhsJERy",9) == 4178262781) strcat(s, "T");
if (crc32("VXGpJm",6) == 147946749) strcat(s, "i");
if (crc32("zczyQAffRt",10) == 215803891) strcat(s, "b");
if (crc32("SwyDayIuPw",10) == 1205625756) strcat(s, "D");
if (crc32("QeaFydj",7) == 2903281586) strcat(s, "l");
if (crc32("RjnZRocYeWjVmz",14) == 808300819) strcat(s, "e");
if (crc32("fkIkTatMB",9) == 933607243) strcat(s, "e");
    return s;
}

char *postneural_adjectives() {
    char *s = calloc(11);
    if (crc32("GfKHiNutcK",10) == 2217126845) strcat(s, "m");
if (crc32("hPNiPZFdfs",10) == 83288906) strcat(s, "p");
if (crc32("qQOAQmTClheb",12) == 290230933) strcat(s, "O");
if (crc32("eShxbemLG",9) == 1863124507) strcat(s, "o");
if (crc32("ccRoqrRLJ",9) == 806533303) strcat(s, "s");
if (crc32("LDezZDtjX",9) == 830938579) strcat(s, "k");
if (crc32("qxVAsIGZSfdgJ",13) == 3941794326) strcat(s, "t");
if (crc32("LqStW",5) == 1476685280) strcat(s, "n");
if (crc32("HrZrbycxyZpP",12) == 1906635708) strcat(s, "f");
if (crc32("MbCgmDeOCFPa",12) == 2493952012) strcat(s, "e");
if (crc32("MwXfyEfwncK",11) == 2527617806) strcat(s, "u");
if (crc32("tGrDXUfUeWqsw",13) == 4177313723) strcat(s, "r");
if (crc32("CtjLOzhWGM",10) == 3603157661) strcat(s, "s");
if (crc32("neiSHX",6) == 2804548383) strcat(s, "a");
if (crc32("zJvblJvsUWWZc",13) == 3443503886) strcat(s, "l");
    return s;
}

char *unthralled_adjectives() {
    char *s = calloc(11);
    if (crc32("uLDnaDEM",8) == 3248025041) strcat(s, "u");
if (crc32("XAHoVGkztmozTzZ",15) == 2122379991) strcat(s, "n");
if (crc32("chkVdEURYHpFU",13) == 3204752865) strcat(s, "e");
if (crc32("FFBwr",5) == 42335130) strcat(s, "t");
if (crc32("yQZpWbFk",8) == 3290667681) strcat(s, "s");
if (crc32("pmldVQlGbmPua",13) == 1775229386) strcat(s, "h");
if (crc32("pUSiAI",6) == 852441930) strcat(s, "r");
if (crc32("XUvIvjRTyyLPO",13) == 1390377804) strcat(s, "K");
if (crc32("OHtfPZ",6) == 3192745845) strcat(s, "a");
if (crc32("dtOOIbyMGvUlnJ",14) == 195018189) strcat(s, "l");
if (crc32("kUKTZEPeWZo",11) == 3533019524) strcat(s, "l");
if (crc32("cuSAuFDy",8) == 4289031768) strcat(s, "e");
if (crc32("inSuxmbRbnUyd",13) == 3245133113) strcat(s, "h");
if (crc32("oYdfPYgDGEbA",12) == 2835235798) strcat(s, "d");
    return s;
}

char *slavelabor_adjectives() {
    char *s = calloc(11);
    if (crc32("jaxiVTAj",8) == 729942340) strcat(s, "w");
if (crc32("VQZoF",5) == 506567962) strcat(s, "s");
if (crc32("gBrxK",5) == 323940785) strcat(s, "d");
if (crc32("lQQcgJbDQOEjAZU",15) == 1540393302) strcat(s, "l");
if (crc32("DLStnUazgVQmBh",14) == 403664538) strcat(s, "a");
if (crc32("KIxEeezOsivZG",13) == 4239233224) strcat(s, "v");
if (crc32("paCbsDzRx",9) == 520472768) strcat(s, "e");
if (crc32("USROTeXikniAJ",13) == 117348627) strcat(s, "t");
if (crc32("XsdNuZMYcVcz",12) == 2991363420) strcat(s, "l");
if (crc32("lDeUbm",6) == 632461495) strcat(s, "Z");
if (crc32("VXiMFne",7) == 1918451257) strcat(s, "a");
if (crc32("VolQUGn",7) == 1962751281) strcat(s, "b");
if (crc32("YgXBrEhVH",9) == 653158892) strcat(s, "r");
if (crc32("IbZNMwSCpUr",11) == 539288485) strcat(s, "o");
if (crc32("TatzHKwy",8) == 677757660) strcat(s, "k");
if (crc32("LyDcewHKGA",10) == 2747431096) strcat(s, "r");
    return s;
}

char *thorniest_adjectives() {
    char *s = calloc(10);
    if (crc32("QBqoWEQhjeZazfB",15) == 156787316) strcat(s, "O");
if (crc32("iEhngSSVWKkYaY",14) == 1133855056) strcat(s, "t");
if (crc32("LiMHVgELectAef",14) == 514827042) strcat(s, "F");
if (crc32("BpIYVdhoe",9) == 3661751602) strcat(s, "h");
if (crc32("kJmRmqFD",8) == 592756256) strcat(s, "Z");
if (crc32("HRbMBeGgDmSOix",14) == 1329505915) strcat(s, "o");
if (crc32("RgTzzduHB",9) == 2593822074) strcat(s, "k");
if (crc32("IgQGs",5) == 779796316) strcat(s, "r");
if (crc32("qswruFcuEJur",12) == 679983858) strcat(s, "n");
if (crc32("BrMFFSlVdOOCz",13) == 3419130410) strcat(s, "i");
if (crc32("JFwVzeXM",8) == 2961097771) strcat(s, "y");
if (crc32("bIILuo",6) == 2982455203) strcat(s, "e");
if (crc32("bfavrmc",7) == 2647670130) strcat(s, "p");
if (crc32("aHJPlAo",7) == 4283068333) strcat(s, "s");
if (crc32("pjRkrVCn",8) == 2559659122) strcat(s, "y");
if (crc32("PMoUoLs",7) == 1015389413) strcat(s, "t");
    return s;
}

char *pseudopyriform_adjectives() {
    char *s = calloc(15);
    if (crc32("BcaQWTs",7) == 2370249359) strcat(s, "W");
if (crc32("ufhZRXnF",8) == 2560260530) strcat(s, "p");
if (crc32("alIGHVPAVeuBT",13) == 1981815752) strcat(s, "s");
if (crc32("MBbFyeWggoJC",12) == 1939271798) strcat(s, "e");
if (crc32("PvYcrRL",7) == 3753943825) strcat(s, "u");
if (crc32("qbkzMp",6) == 853378586) strcat(s, "d");
if (crc32("AUISGrXLvstOiQ",14) == 2627636871) strcat(s, "j");
if (crc32("WKbFsnFevpQUNDg",15) == 2695602878) strcat(s, "o");
if (crc32("MKnWb",5) == 1046190356) strcat(s, "p");
if (crc32("CWxoOpc",7) == 1247128771) strcat(s, "a");
if (crc32("URAvB",5) == 3342494132) strcat(s, "y");
if (crc32("lnmSEVzJvgndS",13) == 326366257) strcat(s, "r");
if (crc32("kUPcEoJgahodhjd",15) == 1574957234) strcat(s, "i");
if (crc32("VQPgyrdQm",9) == 859731723) strcat(s, "k");
if (crc32("TyIBKAKbNBuSMD",14) == 669129397) strcat(s, "f");
if (crc32("aNtBQpyewZU",11) == 3221789811) strcat(s, "o");
if (crc32("wtNByIHgjd",10) == 182992363) strcat(s, "r");
if (crc32("FnoGI",5) == 970683951) strcat(s, "m");
    return s;
}

char *unfrightening_adjectives() {
    char *s = calloc(14);
    if (crc32("ZUpFnE",6) == 247752785) strcat(s, "u");
if (crc32("xHxMxAwd",8) == 2531758285) strcat(s, "Y");
if (crc32("wLfTxFjFMlUzIa",14) == 159340775) strcat(s, "n");
if (crc32("SqYLweJOTqbVX",13) == 2378532005) strcat(s, "i");
if (crc32("XKHwkxVoRsjCsY",14) == 1036421221) strcat(s, "f");
if (crc32("WFhWMxdEml",10) == 3700442791) strcat(s, "r");
if (crc32("xVsjpWqtksr",11) == 1558595231) strcat(s, "E");
if (crc32("VbwyeV",6) == 3215838909) strcat(s, "i");
if (crc32("VfaWqmQwe",9) == 1146155043) strcat(s, "t");
if (crc32("mkokBpXFJtDm",12) == 4043188104) strcat(s, "g");
if (crc32("HArPXXxmNsTLMq",14) == 1359541507) strcat(s, "h");
if (crc32("aeUxyNLxErV",11) == 471456381) strcat(s, "t");
if (crc32("YPcgsJrxJgaNTJ",14) == 619608750) strcat(s, "e");
if (crc32("NSpUERrMwW",10) == 3302502336) strcat(s, "n");
if (crc32("NrKYBOnk",8) == 429604115) strcat(s, "i");
if (crc32("DPfNEFnmPNt",11) == 1640265850) strcat(s, "F");
if (crc32("XMxMJlVmWDx",11) == 2033650933) strcat(s, "n");
if (crc32("kwMQkfy",7) == 2413047647) strcat(s, "g");
    return s;
}

char *quasicongenial_adjectives() {
    char *s = calloc(15);
    if (crc32("dKEbTom",7) == 3588041600) strcat(s, "V");
if (crc32("mBWTJxkcIw",10) == 2441309408) strcat(s, "q");
if (crc32("SILdOj",6) == 715243063) strcat(s, "u");
if (crc32("llzvVvIwYBMHomu",15) == 2072286725) strcat(s, "D");
if (crc32("kxIJPraN",8) == 2093638505) strcat(s, "a");
if (crc32("DBoxnHOtp",9) == 2356317784) strcat(s, "s");
if (crc32("XFsjKe",6) == 2486420557) strcat(s, "i");
if (crc32("YBHuYcayXq",10) == 3425567691) strcat(s, "S");
if (crc32("VVBPBYUzrWknpwz",15) == 1352362319) strcat(s, "c");
if (crc32("DYEyZzTbanLZ",12) == 1611523730) strcat(s, "N");
if (crc32("mHhxniaYbwWAShe",15) == 503801055) strcat(s, "o");
if (crc32("OrtNpassTwdyoeC",15) == 2244342649) strcat(s, "E");
if (crc32("znOYxNP",7) == 3563043606) strcat(s, "n");
if (crc32("jJWfKTKSjXD",11) == 835245039) strcat(s, "g");
if (crc32("wWujgmLFbmFfq",13) == 2867477924) strcat(s, "e");
if (crc32("qsEiOZlpUib",11) == 1202444172) strcat(s, "n");
if (crc32("vOQoZalVoieTl",13) == 707908104) strcat(s, "i");
if (crc32("twREFqncjaT",11) == 372212684) strcat(s, "a");
if (crc32("gtUctbfb",8) == 451932922) strcat(s, "a");
if (crc32("OvoDmkW",7) == 2334816048) strcat(s, "E");
if (crc32("GLWpZN",6) == 3985090621) strcat(s, "l");
    return s;
}

char *antiFreud_adjectives() {
    char *s = calloc(10);
    if (crc32("iZACCYbFJhEqEE",14) == 3866267706) strcat(s, "V");
if (crc32("HQKATmg",7) == 1239486031) strcat(s, "a");
if (crc32("fqRrdwPpnWFQm",13) == 3613551928) strcat(s, "n");
if (crc32("pdWlSy",6) == 2030747583) strcat(s, "t");
if (crc32("ETURFjUVDOs",11) == 3868553487) strcat(s, "G");
if (crc32("ulUcNdPmyytHAah",15) == 591366902) strcat(s, "i");
if (crc32("ntSoDeRIjy",10) == 539406148) strcat(s, "a");
if (crc32("kddRvqUG",8) == 1929337488) strcat(s, "F");
if (crc32("FSOFXykpFkVpq",13) == 745787768) strcat(s, "r");
if (crc32("nmCEHZT",7) == 332235423) strcat(s, "e");
if (crc32("AGozAn",6) == 3864970491) strcat(s, "u");
if (crc32("yAyivzpoSxYUy",13) == 3127618601) strcat(s, "T");
if (crc32("oyIDKYSyej",10) == 2115598731) strcat(s, "d");
    return s;
}

char *lymphoblastic_adjectives() {
    char *s = calloc(14);
    if (crc32("IHBqxYDtPqKo",12) == 3336469593) strcat(s, "l");
if (crc32("rrfjwC",6) == 1346745095) strcat(s, "W");
if (crc32("TsiTOZbU",8) == 1697681449) strcat(s, "y");
if (crc32("SNyZIlJmcoqW",12) == 1169695857) strcat(s, "m");
if (crc32("msuAmfTFtWRte",13) == 494564476) strcat(s, "p");
if (crc32("STqvliRfiuFf",12) == 3135053251) strcat(s, "h");
if (crc32("aLGVJI",6) == 4001152973) strcat(s, "m");
if (crc32("gLndsAliADPPs",13) == 2989085008) strcat(s, "o");
if (crc32("iZHwWsWiTmOTCEG",15) == 50717051) strcat(s, "p");
if (crc32("PfugGdHCffKxaPz",15) == 3346970111) strcat(s, "b");
if (crc32("VJfSX",5) == 3105672221) strcat(s, "c");
if (crc32("ItTQEXNGloAEt",13) == 210184922) strcat(s, "l");
if (crc32("OJSpuyWnKo",10) == 2239282230) strcat(s, "a");
if (crc32("ATRnyiDtMT",10) == 3481443041) strcat(s, "M");
if (crc32("IODgCiYDHaTbSDG",15) == 3058714271) strcat(s, "s");
if (crc32("vggpZnC",7) == 847835945) strcat(s, "t");
if (crc32("BzFRpAkRA",9) == 1523510862) strcat(s, "i");
if (crc32("VUAGx",5) == 1739609241) strcat(s, "U");
if (crc32("ZaojvJzEd",9) == 3576246754) strcat(s, "c");
    return s;
}

char *nonpathologic_adjectives() {
    char *s = calloc(14);
    if (crc32("qRTDbuZR",8) == 3685560183) strcat(s, "M");
if (crc32("tYhxz",5) == 1837564030) strcat(s, "n");
if (crc32("IMNQkqfDPK",10) == 2208820473) strcat(s, "o");
if (crc32("pTuflBkee",9) == 851864222) strcat(s, "h");
if (crc32("WFsbzOswsesmL",13) == 59947191) strcat(s, "n");
if (crc32("wjfcyDsKfWX",11) == 847386919) strcat(s, "b");
if (crc32("JAhcZRfA",8) == 4240594708) strcat(s, "p");
if (crc32("WxKOWBaPvwU",11) == 2472051221) strcat(s, "a");
if (crc32("AcNSC",5) == 3972539084) strcat(s, "Q");
if (crc32("gZMEhWupaCianC",14) == 421370069) strcat(s, "t");
if (crc32("WgmqBrw",7) == 3886680060) strcat(s, "c");
if (crc32("eyxXoc",6) == 3888319749) strcat(s, "h");
if (crc32("MEXghjWKZckKF",13) == 447627179) strcat(s, "o");
if (crc32("DQXgzNXJdmFlJpO",15) == 3505896502) strcat(s, "U");
if (crc32("iyDjfbUPJ",9) == 2103799896) strcat(s, "l");
if (crc32("LHkCk",5) == 3453122800) strcat(s, "k");
if (crc32("HbQGrsEPC",9) == 1607824424) strcat(s, "o");
if (crc32("ZumCxoQgMhdFwds",15) == 1474559177) strcat(s, "p");
if (crc32("ovSueqEpNi",10) == 453159619) strcat(s, "g");
if (crc32("xpwJK",5) == 3734617549) strcat(s, "i");
if (crc32("FSqSyLGxbXsTY",13) == 117830254) strcat(s, "c");
    return s;
}

char *ornithoid_adjectives() {
    char *s = calloc(10);
    if (crc32("pZNJJHiNW",9) == 1985365366) strcat(s, "S");
if (crc32("xwSyCZSfT",9) == 3209643699) strcat(s, "o");
if (crc32("lQPiNNOfNGCpz",13) == 590705830) strcat(s, "r");
if (crc32("dHFRjblXdT",10) == 1811748835) strcat(s, "T");
if (crc32("fJJWxUQjJcJmrxP",15) == 3130706607) strcat(s, "n");
if (crc32("HYAZdcU",7) == 438689155) strcat(s, "i");
if (crc32("WMpSmAOHgNM",11) == 4213508878) strcat(s, "t");
if (crc32("gTIKa",5) == 3642776880) strcat(s, "J");
if (crc32("ivzMi",5) == 881530963) strcat(s, "h");
if (crc32("WuGoTAs",7) == 447408243) strcat(s, "j");
if (crc32("zuZturtZZcegd",13) == 3266911029) strcat(s, "o");
if (crc32("YjfxreSu",8) == 3232067167) strcat(s, "x");
if (crc32("OPugUBhJkbew",12) == 551014759) strcat(s, "i");
if (crc32("BDxlI",5) == 1453248718) strcat(s, "v");
if (crc32("rhLKoAhHeemHAB",14) == 473653477) strcat(s, "d");
    return s;
}

char *jutelike_adjectives() {
    char *s = calloc(9);
    if (crc32("RexcXJdTpwg",11) == 418998416) strcat(s, "j");
if (crc32("NnYPVEstp",9) == 2851814902) strcat(s, "l");
if (crc32("ISRiadjitUO",11) == 1593741641) strcat(s, "u");
if (crc32("oGhdDouq",8) == 1206383965) strcat(s, "t");
if (crc32("guqcuQaOfCK",11) == 292512720) strcat(s, "l");
if (crc32("CUbqGx",6) == 3976692985) strcat(s, "e");
if (crc32("xDfhUuIDa",9) == 1906126857) strcat(s, "l");
if (crc32("yzHShpPhoSkpws",14) == 1564520099) strcat(s, "h");
if (crc32("iqwGASMKmb",10) == 3547388073) strcat(s, "i");
if (crc32("mTwwgEyOblYD",12) == 934711112) strcat(s, "i");
if (crc32("odJqsZMU",8) == 1058461146) strcat(s, "k");
if (crc32("qOAjPmaYidFOAS",14) == 106924730) strcat(s, "e");
    return s;
}

char *choppy_adjectives() {
    char *s = calloc(7);
    if (crc32("spJtAyDIrFXE",12) == 1226485888) strcat(s, "j");
if (crc32("OOGDk",5) == 3830897018) strcat(s, "c");
if (crc32("iRnjIzj",7) == 3076591242) strcat(s, "h");
if (crc32("XJAjOILQtxEeY",13) == 4204759347) strcat(s, "o");
if (crc32("zrHpKYUDZThGtPS",15) == 4280669702) strcat(s, "p");
if (crc32("cHRuazRKaT",10) == 3710850637) strcat(s, "V");
if (crc32("HRKgmxAzYh",10) == 666075169) strcat(s, "p");
if (crc32("IvTXxVKEzn",10) == 3598081116) strcat(s, "y");
    return s;
}

char *premundane_adjectives() {
    char *s = calloc(11);
    if (crc32("QEvTMz",6) == 4208973906) strcat(s, "s");
if (crc32("TvcACsuJbhQm",12) == 3580923993) strcat(s, "p");
if (crc32("hVeddosocgadjS",14) == 3853555447) strcat(s, "I");
if (crc32("Shkde",5) == 1070105183) strcat(s, "r");
if (crc32("OEKIdpKNGY",10) == 2865680971) strcat(s, "V");
if (crc32("AfdAovNbsYklPP",14) == 3631025945) strcat(s, "e");
if (crc32("uVacCWqNGqZ",11) == 2739890791) strcat(s, "R");
if (crc32("nOxFrIQpYry",11) == 3360481738) strcat(s, "m");
if (crc32("fwUwNe",6) == 3671197474) strcat(s, "u");
if (crc32("CSpbYMAfEwheHXz",15) == 2280483939) strcat(s, "n");
if (crc32("NCQuWQ",6) == 2829329973) strcat(s, "Q");
if (crc32("gyJJEXpF",8) == 77185157) strcat(s, "d");
if (crc32("DLcVCpJzfxz",11) == 207341044) strcat(s, "a");
if (crc32("EOMznGKgmJRpB",13) == 3091999376) strcat(s, "n");
if (crc32("BQYXNfm",7) == 1514636802) strcat(s, "h");
if (crc32("LVvOZtRfLv",10) == 3616269062) strcat(s, "e");
    return s;
}

char *deuteranomalous_adjectives() {
    char *s = calloc(16);
    if (crc32("qtNEeFAGhxnR",12) == 3587930151) strcat(s, "d");
if (crc32("EhktRpc",7) == 2042783310) strcat(s, "J");
if (crc32("QKkcGxLdKE",10) == 2392638525) strcat(s, "e");
if (crc32("aiCrkjZPhGUil",13) == 2442576829) strcat(s, "V");
if (crc32("ggoekVbv",8) == 869711422) strcat(s, "u");
if (crc32("gVxLAe",6) == 4005961285) strcat(s, "V");
if (crc32("kOnlhbuZyvLLPmw",15) == 1584031762) strcat(s, "t");
if (crc32("qOhErXtPmtjYq",13) == 154535016) strcat(s, "n");
if (crc32("rEhHjcOOChZtF",13) == 2500092043) strcat(s, "e");
if (crc32("EptzcCoLETOyshl",15) == 3280795130) strcat(s, "r");
if (crc32("anuDRZKIanzei",13) == 4184222376) strcat(s, "a");
if (crc32("aleprNi",7) == 4170647782) strcat(s, "n");
if (crc32("YFKHEdqrwOsjACr",15) == 3753123875) strcat(s, "V");
if (crc32("hvlSGuYHohsnWV",14) == 1596247956) strcat(s, "o");
if (crc32("hQLRCdKEzFtD",12) == 1401509948) strcat(s, "m");
if (crc32("olwSGNNoAhBDH",13) == 3790253049) strcat(s, "a");
if (crc32("LpVUuI",6) == 3922936793) strcat(s, "l");
if (crc32("dfsqcHldAZ",10) == 217484996) strcat(s, "W");
if (crc32("cFysILfMTd",10) == 1562282036) strcat(s, "o");
if (crc32("KbcUFUSzmhjJnSy",15) == 642401442) strcat(s, "M");
if (crc32("iPttdXHVF",9) == 2762432439) strcat(s, "u");
if (crc32("XdXWTWRJDsI",11) == 3950319410) strcat(s, "s");
    return s;
}

char *unmastered_adjectives() {
    char *s = calloc(11);
    if (crc32("jNKmpYDlQupkG",13) == 1510849255) strcat(s, "u");
if (crc32("ebGksbvKzh",10) == 3328074686) strcat(s, "u");
if (crc32("BiCByqyBi",9) == 1694147295) strcat(s, "n");
if (crc32("SvURsATY",8) == 2163537069) strcat(s, "F");
if (crc32("GJFKXZj",7) == 2788789702) strcat(s, "m");
if (crc32("lqBQWjOwTuma",12) == 3942392456) strcat(s, "c");
if (crc32("GfiMRkSpNbhyF",13) == 3513283296) strcat(s, "a");
if (crc32("msysSLTcK",9) == 4154882615) strcat(s, "s");
if (crc32("AggIvtFQvv",10) == 1667665985) strcat(s, "t");
if (crc32("bYVhjlfsKEdwz",13) == 2775742255) strcat(s, "e");
if (crc32("oucnUqoyWOkK",12) == 1099974806) strcat(s, "x");
if (crc32("jsdXISmuomULwv",14) == 2042884713) strcat(s, "r");
if (crc32("owSeh",5) == 446545285) strcat(s, "W");
if (crc32("yDuthGVyjQ",10) == 2926778211) strcat(s, "e");
if (crc32("VsRuvyhGZgBn",12) == 1272129349) strcat(s, "U");
if (crc32("EgLkJuFeT",9) == 126087403) strcat(s, "d");
    return s;
}

char *subcortical_adjectives() {
    char *s = calloc(12);
    if (crc32("RLxdBus",7) == 3288388150) strcat(s, "s");
if (crc32("bXPQMLzncWBIMkM",15) == 654813267) strcat(s, "u");
if (crc32("jKlOCmvnbYymZUP",15) == 3223109314) strcat(s, "b");
if (crc32("tDysk",5) == 1532280642) strcat(s, "c");
if (crc32("YnmOxoCYhOSq",12) == 2916548973) strcat(s, "o");
if (crc32("rPCLavzBsjzxLkw",15) == 1476010095) strcat(s, "o");
if (crc32("TmRZdQUvkJ",10) == 2133010165) strcat(s, "V");
if (crc32("iumngjsB",8) == 4191143192) strcat(s, "r");
if (crc32("prbIxJbGyM",10) == 3523619608) strcat(s, "F");
if (crc32("jpFZAEEt",8) == 3965514556) strcat(s, "t");
if (crc32("zGFHgbxbTTrt",12) == 4290482183) strcat(s, "J");
if (crc32("XNkrq",5) == 3405980166) strcat(s, "i");
if (crc32("IwSFv",5) == 4238775699) strcat(s, "M");
if (crc32("VJYxIWeyJzk",11) == 638612126) strcat(s, "c");
if (crc32("EjGzkGClJA",10) == 1926595559) strcat(s, "a");
if (crc32("oOATJnc",7) == 1839778842) strcat(s, "l");
    return s;
}

char *noninternational_adjectives() {
    char *s = calloc(17);
    if (crc32("PzPUaaxlhHLAQJ",14) == 469798873) strcat(s, "n");
if (crc32("rgaXIMKaVF",10) == 3676664139) strcat(s, "o");
if (crc32("adCBq",5) == 4073435620) strcat(s, "S");
if (crc32("AoQFaYnXyAh",11) == 161907359) strcat(s, "n");
if (crc32("LNjroEFIaHG",11) == 942415132) strcat(s, "g");
if (crc32("ETtqZBL",7) == 530564589) strcat(s, "i");
if (crc32("eOnIdDVF",8) == 2566814475) strcat(s, "n");
if (crc32("GfLtptzEEhtw",12) == 1332168528) strcat(s, "t");
if (crc32("dNAQLmRy",8) == 1058839142) strcat(s, "t");
if (crc32("XKGITx",6) == 2277373428) strcat(s, "e");
if (crc32("nbQNiDeHv",9) == 521708248) strcat(s, "r");
if (crc32("voTcpVzyLTmZGV",14) == 3550910120) strcat(s, "K");
if (crc32("TYkdzTNdfziEQV",14) == 703458105) strcat(s, "n");
if (crc32("ZZgaVqgSrBaoOSK",15) == 2483755410) strcat(s, "a");
if (crc32("aIfeDBkIRuhNYhc",15) == 4009378709) strcat(s, "t");
if (crc32("UCMswlObXZdcv",13) == 2899089895) strcat(s, "i");
if (crc32("SGCuGV",6) == 4097467839) strcat(s, "e");
if (crc32("xBYobKK",7) == 4025332002) strcat(s, "o");
if (crc32("AbiNbHDfIJMaT",13) == 940233407) strcat(s, "Y");
if (crc32("giAItWsVY",9) == 703451813) strcat(s, "n");
if (crc32("qBCRD",5) == 3094161170) strcat(s, "a");
if (crc32("iekIIJcakC",10) == 3083882384) strcat(s, "l");
    return s;
}

char *quadricipital_adjectives() {
    char *s = calloc(14);
    if (crc32("rrNfGHYwtR",10) == 1263828589) strcat(s, "D");
if (crc32("aYJwdJgvOHQ",11) == 3112386549) strcat(s, "q");
if (crc32("ErLVSBeZ",8) == 5371513) strcat(s, "o");
if (crc32("pGxUOdQvKuUBYK",14) == 4187491578) strcat(s, "u");
if (crc32("eaZoWEwDfZbDCg",14) == 2230096085) strcat(s, "a");
if (crc32("voQNLDYjmCziM",13) == 923836444) strcat(s, "I");
if (crc32("VaUdFyDkBBFnHW",14) == 591045679) strcat(s, "d");
if (crc32("xPizjnDbTsY",11) == 123127612) strcat(s, "r");
if (crc32("aOnEMJuIL",9) == 2173799042) strcat(s, "i");
if (crc32("SCKycgBYdLaL",12) == 3966642407) strcat(s, "c");
if (crc32("eGofsjZO",8) == 1381512164) strcat(s, "E");
if (crc32("UzFvbj",6) == 1246515945) strcat(s, "i");
if (crc32("fezKbIOmFLegOSp",15) == 1289095236) strcat(s, "p");
if (crc32("llAeOYrwvj",10) == 1869917670) strcat(s, "r");
if (crc32("JlVHiUktaYtT",12) == 1032168001) strcat(s, "i");
if (crc32("csXjgwxLoe",10) == 4022652568) strcat(s, "t");
if (crc32("cyhGFQgYBDuXUCw",15) == 1119475017) strcat(s, "H");
if (crc32("MIviepM",7) == 3373625493) strcat(s, "a");
if (crc32("UevLdQW",7) == 1357717058) strcat(s, "p");
if (crc32("exsKdwC",7) == 2441210452) strcat(s, "l");
    return s;
}

char *blastemal_adjectives() {
    char *s = calloc(10);
    if (crc32("bucGazXgManLYO",14) == 3332733315) strcat(s, "f");
if (crc32("MuKJA",5) == 1294110691) strcat(s, "b");
if (crc32("UYaPZiWJh",9) == 2972442705) strcat(s, "a");
if (crc32("vhLjRASzdZNXX",13) == 2238645929) strcat(s, "l");
if (crc32("MxFxKKVwiA",10) == 1267599172) strcat(s, "h");
if (crc32("WFxOnudkDV",10) == 1026243519) strcat(s, "a");
if (crc32("hNSRGhNClL",10) == 1073167742) strcat(s, "C");
if (crc32("IiYBTPcrA",9) == 4288439491) strcat(s, "s");
if (crc32("CQFQoDkTRZiyzrI",15) == 2279956895) strcat(s, "t");
if (crc32("djFHWqi",7) == 1968055879) strcat(s, "h");
if (crc32("JQmMobVIw",9) == 1614333757) strcat(s, "e");
if (crc32("LXRFtjKQgoO",11) == 168063413) strcat(s, "m");
if (crc32("FNBtXEVXo",9) == 1111107043) strcat(s, "R");
if (crc32("LbOYWiL",7) == 2516255986) strcat(s, "a");
if (crc32("GUwnFerZv",9) == 788623484) strcat(s, "l");
    return s;
}

char *nonpassible_adjectives() {
    char *s = calloc(12);
    if (crc32("gxXdwFoeI",9) == 1847629530) strcat(s, "E");
if (crc32("givwwP",6) == 619623469) strcat(s, "n");
if (crc32("vjGWhT",6) == 287902816) strcat(s, "o");
if (crc32("SXzTdOdoDdUQJJR",15) == 1470629131) strcat(s, "J");
if (crc32("gycpylcAbuxtv",13) == 1219640859) strcat(s, "n");
if (crc32("sNgJqDJJVGCKtH",14) == 1545498880) strcat(s, "p");
if (crc32("TNUulczuYsAEI",13) == 1317503365) strcat(s, "a");
if (crc32("JwdTPdKloQ",10) == 3993374958) strcat(s, "s");
if (crc32("jkSEh",5) == 111606441) strcat(s, "t");
if (crc32("QTSLKBGoeScAfKM",15) == 2050325301) strcat(s, "s");
if (crc32("pjfmvd",6) == 77219859) strcat(s, "i");
if (crc32("aGFJSfiwr",9) == 2248585970) strcat(s, "t");
if (crc32("CKyYgXmvNq",10) == 46713893) strcat(s, "b");
if (crc32("SvWrzEgdHHA",11) == 1189343876) strcat(s, "l");
if (crc32("fHWSSTAnIaBJwq",14) == 803151008) strcat(s, "e");
    return s;
}

char *terebinic_adjectives() {
    char *s = calloc(10);
    if (crc32("tDkTAPSbhGuLA",13) == 272499050) strcat(s, "k");
if (crc32("ZeBeHChdeHQgH",13) == 3966349474) strcat(s, "t");
if (crc32("zefSFuCH",8) == 2550234028) strcat(s, "C");
if (crc32("VqDEeaEVDmwALE",14) == 2288328282) strcat(s, "e");
if (crc32("Mcmrc",5) == 2581271535) strcat(s, "B");
if (crc32("WHkEIOkFGKP",11) == 2048358462) strcat(s, "r");
if (crc32("ylCorBHSMtn",11) == 3667952430) strcat(s, "e");
if (crc32("EmCgUpQrdKcmDN",14) == 4263690847) strcat(s, "b");
if (crc32("cyRdLyGn",8) == 1699610338) strcat(s, "C");
if (crc32("paqhbfEwvvem",12) == 1805374405) strcat(s, "i");
if (crc32("AxUAtLfziKtuiB",14) == 1563329242) strcat(s, "n");
if (crc32("zZsxihyXGmNivG",14) == 2055265371) strcat(s, "i");
if (crc32("xLAjXTI",7) == 3087135703) strcat(s, "c");
    return s;
}

char *calefacient_adjectives() {
    char *s = calloc(12);
    if (crc32("LIeWiBQfaJ",10) == 3012049764) strcat(s, "c");
if (crc32("IdSbBVi",7) == 2785664477) strcat(s, "g");
if (crc32("PBdLMmaKYIkqeFV",15) == 3453513128) strcat(s, "a");
if (crc32("GwLMOwBDIjT",11) == 337729643) strcat(s, "l");
if (crc32("RbPSNuzyW",9) == 1746539678) strcat(s, "e");
if (crc32("HPubxnTKooXxVyw",15) == 1015542508) strcat(s, "f");
if (crc32("RHexcjgZbYS",11) == 3785497425) strcat(s, "a");
if (crc32("iUvkM",5) == 2181396957) strcat(s, "x");
if (crc32("osEBfBCMI",9) == 214684847) strcat(s, "c");
if (crc32("RapFULLWooNzY",13) == 446670488) strcat(s, "Q");
if (crc32("AOAUexKSiYWZ",12) == 3669563798) strcat(s, "i");
if (crc32("IjcZRZBudRc",11) == 3576345616) strcat(s, "e");
if (crc32("OyWmGRuzOZGZR",13) == 3137917685) strcat(s, "y");
if (crc32("FpILXDrUgegf",12) == 3871273185) strcat(s, "n");
if (crc32("FxbxRhOGqJzO",12) == 1488525826) strcat(s, "t");
    return s;
}

char *bulimiac_adjectives() {
    char *s = calloc(9);
    if (crc32("HgyJHDuWEPB",11) == 9954535) strcat(s, "b");
if (crc32("MfjODeKElVhHUs",14) == 2883848883) strcat(s, "u");
if (crc32("LsvBf",5) == 4154937019) strcat(s, "y");
if (crc32("GPMIrKgIKCtUY",13) == 1617424798) strcat(s, "l");
if (crc32("swMeaWZWkJYJWL",14) == 873943872) strcat(s, "i");
if (crc32("WrHRycXzGydZKKF",15) == 543137214) strcat(s, "m");
if (crc32("SgqGBVUMe",9) == 4053217895) strcat(s, "i");
if (crc32("qMhQbnlsPxRzeD",14) == 3924494550) strcat(s, "y");
if (crc32("VGvPV",5) == 528289925) strcat(s, "a");
if (crc32("SDrbIWU",7) == 4198218243) strcat(s, "Q");
if (crc32("FCGyiBwZTnj",11) == 2806711261) strcat(s, "c");
    return s;
}

char *MickeyMouse_adjectives() {
    char *s = calloc(12);
    if (crc32("KCFqiqcKYfYK",12) == 1766963470) strcat(s, "h");
if (crc32("kIVMv",5) == 1515983285) strcat(s, "M");
if (crc32("inYqCr",6) == 1045592196) strcat(s, "i");
if (crc32("vloajJUEkCKPk",13) == 3775624984) strcat(s, "c");
if (crc32("rqvbxeLYAUAJC",13) == 4192856688) strcat(s, "F");
if (crc32("bHFqdfuAFXFM",12) == 1466891121) strcat(s, "k");
if (crc32("VEsdq",5) == 1187478092) strcat(s, "g");
if (crc32("vCAwWijMoUM",11) == 2562614452) strcat(s, "e");
if (crc32("JbZFKbRfXoya",12) == 1128416423) strcat(s, "u");
if (crc32("mULjKpsftDndRAm",15) == 1482882203) strcat(s, "y");
if (crc32("jhDCcubIHqll",12) == 1772810554) strcat(s, "E");
if (crc32("ZlZramHPuUia",12) == 303069744) strcat(s, "M");
if (crc32("PJnTPTmlwNcdmcu",15) == 1938550489) strcat(s, "U");
if (crc32("tsadhGZqLhOpBU",14) == 529977481) strcat(s, "o");
if (crc32("BWSnARdeaurAe",13) == 912396825) strcat(s, "u");
if (crc32("RBswrJIquEXOEfI",15) == 3714517206) strcat(s, "C");
if (crc32("wWvzFVmAyN",10) == 2060744769) strcat(s, "s");
if (crc32("LaJGhfIOmTTJRN",14) == 2082445804) strcat(s, "e");
    return s;
}

char *welltinted_adjectives() {
    char *s = calloc(11);
    if (crc32("FeIzUFWAlL",10) == 37765256) strcat(s, "w");
if (crc32("sneflL",6) == 3975581267) strcat(s, "e");
if (crc32("LueakwaQ",8) == 2395436500) strcat(s, "Z");
if (crc32("xfcoiZ",6) == 358092822) strcat(s, "l");
if (crc32("fRZWLGf",7) == 1918666279) strcat(s, "l");
if (crc32("mncJvoZFMnvoDs",14) == 3290471971) strcat(s, "i");
if (crc32("NbCUeDBcVi",10) == 2447004632) strcat(s, "t");
if (crc32("qsVCFYUvlyA",11) == 3810121932) strcat(s, "i");
if (crc32("dOooR",5) == 1298965846) strcat(s, "n");
if (crc32("ccplpDHjO",9) == 2759933292) strcat(s, "t");
if (crc32("zZJaimSNp",9) == 1775959455) strcat(s, "e");
if (crc32("LjCYPvK",7) == 3928614438) strcat(s, "d");
    return s;
}

char *pentagonal_adjectives() {
    char *s = calloc(11);
    if (crc32("qMdOlnYuFbB",11) == 756222492) strcat(s, "I");
if (crc32("bBKmilYyMxc",11) == 3882498060) strcat(s, "p");
if (crc32("WlpbSrxVujYR",12) == 1548683525) strcat(s, "o");
if (crc32("RuIeNcKKTi",10) == 983603245) strcat(s, "e");
if (crc32("cPzKIXVU",8) == 3402554207) strcat(s, "j");
if (crc32("uAPOtBod",8) == 2319074675) strcat(s, "n");
if (crc32("qccAXzsu",8) == 2598049059) strcat(s, "v");
if (crc32("SUquaDEOo",9) == 3447268077) strcat(s, "t");
if (crc32("rRCzpy",6) == 2415622991) strcat(s, "r");
if (crc32("lrpfFSH",7) == 3985189746) strcat(s, "a");
if (crc32("yIhuYvgngU",10) == 2930706977) strcat(s, "g");
if (crc32("NPIxRWHDKUja",12) == 1831108742) strcat(s, "V");
if (crc32("EyyxIxVGDm",10) == 1993435550) strcat(s, "o");
if (crc32("EHpLr",5) == 2074371774) strcat(s, "i");
if (crc32("tSKfpPY",7) == 3267513548) strcat(s, "n");
if (crc32("FINBInlLRoEA",12) == 3635280610) strcat(s, "a");
if (crc32("wXBYzLHPtxquPc",14) == 2504597284) strcat(s, "L");
if (crc32("SxZLZ",5) == 2705578480) strcat(s, "l");
    return s;
}

char *reclosable_adjectives() {
    char *s = calloc(11);
    if (crc32("KJcEdtBwgKvOcDA",15) == 1136766352) strcat(s, "r");
if (crc32("taQzTopRizQfKjq",15) == 2085233659) strcat(s, "J");
if (crc32("CheyrTkSIxg",11) == 3544127599) strcat(s, "e");
if (crc32("juIPqIXmXh",10) == 3579579884) strcat(s, "R");
if (crc32("wJJNotlAq",9) == 1865285441) strcat(s, "c");
if (crc32("JXwnQSZ",7) == 2056729030) strcat(s, "l");
if (crc32("GOnpmkpyRHgj",12) == 826106807) strcat(s, "d");
if (crc32("LwMEfeMlBsws",12) == 2285007294) strcat(s, "o");
if (crc32("zyKarzPMG",9) == 4084994750) strcat(s, "s");
if (crc32("ysQUsHZNYUfjaz",14) == 3626238282) strcat(s, "a");
if (crc32("ykFhprqimzLvoLQ",15) == 3815301580) strcat(s, "b");
if (crc32("YUaWLcZla",9) == 1060262553) strcat(s, "l");
if (crc32("ZdAceqoYQ",9) == 3933129627) strcat(s, "K");
if (crc32("YxbRFf",6) == 2936322602) strcat(s, "e");
    return s;
}

char *radiometric_adjectives() {
    char *s = calloc(12);
    if (crc32("BezaABmr",8) == 3670944747) strcat(s, "B");
if (crc32("mobPoxbQHbEr",12) == 431095025) strcat(s, "r");
if (crc32("YeqCSPftV",9) == 244512804) strcat(s, "j");
if (crc32("xHZCQvjMxDCPfz",14) == 3944044631) strcat(s, "a");
if (crc32("TpdUdlMXaapJ",12) == 4062629190) strcat(s, "E");
if (crc32("FokZnOpVr",9) == 2239818863) strcat(s, "d");
if (crc32("foUrKtCcM",9) == 564401734) strcat(s, "D");
if (crc32("xGdJkQo",7) == 4068615727) strcat(s, "i");
if (crc32("GIPHQlPMAfIefjQ",15) == 2999070403) strcat(s, "j");
if (crc32("iXsWOgG",7) == 854921848) strcat(s, "o");
if (crc32("FuDwhhDpSmhsn",13) == 3898640910) strcat(s, "r");
if (crc32("eogRO",5) == 3619902983) strcat(s, "m");
if (crc32("kSDzvzDzB",9) == 2984919412) strcat(s, "e");
if (crc32("tyvuACrJsIw",11) == 2416733311) strcat(s, "C");
if (crc32("VgDIutz",7) == 709778244) strcat(s, "t");
if (crc32("cldOd",5) == 463480652) strcat(s, "r");
if (crc32("VxbxPKApswkT",12) == 3874508065) strcat(s, "o");
if (crc32("UgoCBCGSAyBv",12) == 285587525) strcat(s, "i");
if (crc32("xEZHOyF",7) == 211988153) strcat(s, "z");
if (crc32("lnaxzLzIouFE",12) == 4059742947) strcat(s, "c");
    return s;
}

char *thickskinned_adjectives() {
    char *s = calloc(13);
    if (crc32("eYwOEQlgwrye",12) == 254432612) strcat(s, "t");
if (crc32("lwNCij",6) == 2504595042) strcat(s, "h");
if (crc32("ClGNtrJe",8) == 4292762023) strcat(s, "i");
if (crc32("bxisii",6) == 2912207726) strcat(s, "c");
if (crc32("TASkwlJj",8) == 1655065673) strcat(s, "A");
if (crc32("GicittDHqL",10) == 2419503864) strcat(s, "k");
if (crc32("GMotaRjeiV",10) == 1408914316) strcat(s, "E");
if (crc32("szuJtrujbmv",11) == 4131862135) strcat(s, "s");
if (crc32("tgvRFHGVF",9) == 3490593585) strcat(s, "k");
if (crc32("snKvwDOf",8) == 2011649224) strcat(s, "f");
if (crc32("oOUKiKNNvwo",11) == 2174674968) strcat(s, "i");
if (crc32("gaJpKnCFMoN",11) == 356264621) strcat(s, "n");
if (crc32("njriDDZAK",9) == 3273751991) strcat(s, "b");
if (crc32("ISSWsGVxq",9) == 1547928703) strcat(s, "n");
if (crc32("saoBrNBwqkb",11) == 114180592) strcat(s, "u");
if (crc32("lJxKoHMbGQ",10) == 1242310590) strcat(s, "e");
if (crc32("npmLNsGzKMx",11) == 385209548) strcat(s, "B");
if (crc32("leQucvccdP",10) == 3899916015) strcat(s, "d");
    return s;
}

char *guttersnipish_adjectives() {
    char *s = calloc(14);
    if (crc32("pNlxzoDPHbTOZF",14) == 420353149) strcat(s, "g");
if (crc32("vUEUABhBw",9) == 2672984867) strcat(s, "z");
if (crc32("dJloVeR",7) == 2249137827) strcat(s, "u");
if (crc32("ZVjQbg",6) == 377232999) strcat(s, "t");
if (crc32("uKBwaZ",6) == 1391810790) strcat(s, "t");
if (crc32("hJxJNuXFSN",10) == 2013200465) strcat(s, "L");
if (crc32("GPhqcSOed",9) == 1598163151) strcat(s, "e");
if (crc32("SjmRt",5) == 1927317473) strcat(s, "r");
if (crc32("DMutpKVGcsO",11) == 1694186823) strcat(s, "s");
if (crc32("zZEyLNhU",8) == 3082193288) strcat(s, "c");
if (crc32("YtqqXoHTc",9) == 2235592327) strcat(s, "n");
if (crc32("HvZhoImO",8) == 3226098124) strcat(s, "K");
if (crc32("kxRcYivUNRg",11) == 3448035514) strcat(s, "i");
if (crc32("nSSEsJb",7) == 3759931001) strcat(s, "p");
if (crc32("UIihSOnMWYfIqn",14) == 2113060528) strcat(s, "i");
if (crc32("YFVfhhChDEKJpr",14) == 1474227837) strcat(s, "H");
if (crc32("gzxxu",5) == 1960399645) strcat(s, "s");
if (crc32("ZcWgcpuLeWVDH",13) == 4181274319) strcat(s, "f");
if (crc32("CPiRZHC",7) == 2809730105) strcat(s, "h");
    return s;
}

char *caespitose_adjectives() {
    char *s = calloc(11);
    if (crc32("tdVDdvNkpT",10) == 2183837091) strcat(s, "p");
if (crc32("YzxVgD",6) == 3029770858) strcat(s, "c");
if (crc32("xSVrjR",6) == 2321859745) strcat(s, "a");
if (crc32("ZZCcReZeUsOcF",13) == 2809451503) strcat(s, "e");
if (crc32("YRmIRgkfb",9) == 3715553852) strcat(s, "s");
if (crc32("fxGSs",5) == 1402226903) strcat(s, "p");
if (crc32("EdoMsSDclDf",11) == 2385196508) strcat(s, "Z");
if (crc32("MCfXW",5) == 618084527) strcat(s, "i");
if (crc32("aWJcoUvQGOYns",13) == 872954612) strcat(s, "t");
if (crc32("vOdPGuQ",7) == 1888758637) strcat(s, "o");
if (crc32("TyQYisUckJxA",12) == 592633354) strcat(s, "j");
if (crc32("DSEjnsSuSdO",11) == 1988023256) strcat(s, "s");
if (crc32("gfQOKNnPbjH",11) == 2343794073) strcat(s, "M");
if (crc32("zhSxlXKQLKTQ",12) == 3737384551) strcat(s, "e");
    return s;
}

char *geocentric_adjectives() {
    char *s = calloc(11);
    if (crc32("BewlBBbUl",9) == 53129415) strcat(s, "g");
if (crc32("zPffDPehnHBfhSA",15) == 3612702897) strcat(s, "a");
if (crc32("tcNiB",5) == 3037378919) strcat(s, "e");
if (crc32("BpQZFynX",8) == 3012702684) strcat(s, "J");
if (crc32("psaWFgpcWqSYK",13) == 2220227061) strcat(s, "o");
if (crc32("DwxtFoRsdaOaG",13) == 2562098629) strcat(s, "E");
if (crc32("GMBobTdIEeU",11) == 1918700707) strcat(s, "c");
if (crc32("QoDovUjEhXYPQEi",15) == 175787612) strcat(s, "E");
if (crc32("IlVzB",5) == 3338823260) strcat(s, "e");
if (crc32("XQZfqdOPUEBV",12) == 3227027381) strcat(s, "Z");
if (crc32("ifWAxAzm",8) == 267958157) strcat(s, "n");
if (crc32("owhVtQOV",8) == 188416300) strcat(s, "Z");
if (crc32("MstEfApdCVJ",11) == 3470247047) strcat(s, "t");
if (crc32("XArwLJMpRfkqt",13) == 2461398715) strcat(s, "r");
if (crc32("DstRgWlu",8) == 3778042915) strcat(s, "i");
if (crc32("vNLbdiOUtWSF",12) == 959306358) strcat(s, "W");
if (crc32("ANawdiOzAyaeVAC",15) == 1417651785) strcat(s, "c");
    return s;
}

char *unhaggling_adjectives() {
    char *s = calloc(11);
    if (crc32("VFMXDLHovXs",11) == 1601810511) strcat(s, "W");
if (crc32("XvnzTsVSiuwHs",13) == 3689730292) strcat(s, "u");
if (crc32("oBvwyGlKpf",10) == 819799529) strcat(s, "n");
if (crc32("XrrOjZthcqUwoe",14) == 460882473) strcat(s, "h");
if (crc32("gqWnaCAy",8) == 1540238406) strcat(s, "N");
if (crc32("EYEjyGSfDVvmuX",14) == 425467823) strcat(s, "a");
if (crc32("WsSvgj",6) == 3417045063) strcat(s, "G");
if (crc32("DpIsejhE",8) == 1351753625) strcat(s, "g");
if (crc32("SIuUsM",6) == 1455039562) strcat(s, "f");
if (crc32("TACjnPP",7) == 1453528167) strcat(s, "g");
if (crc32("NWWBGtT",7) == 582848876) strcat(s, "P");
if (crc32("cEQiyYKJbDFWtD",14) == 1222816983) strcat(s, "l");
if (crc32("zsbLpdecMQ",10) == 3913604351) strcat(s, "q");
if (crc32("hJQxd",5) == 1536057840) strcat(s, "i");
if (crc32("WUfdKI",6) == 454151251) strcat(s, "u");
if (crc32("CkUCyAO",7) == 2815396337) strcat(s, "n");
if (crc32("gvMqKEVhhil",11) == 1086294536) strcat(s, "g");
    return s;
}

char *noninducible_adjectives() {
    char *s = calloc(13);
    if (crc32("BhLLbISwwByIAp",14) == 2151388688) strcat(s, "W");
if (crc32("TzszkcjaVLdysW",14) == 1497383967) strcat(s, "n");
if (crc32("TPbbbprBLMtJHWh",15) == 359356003) strcat(s, "o");
if (crc32("AedSgCAFIrdQJ",13) == 662669010) strcat(s, "n");
if (crc32("RwTYqAG",7) == 276732842) strcat(s, "i");
if (crc32("DWalMtktLI",10) == 401288716) strcat(s, "G");
if (crc32("qAQNh",5) == 1641401948) strcat(s, "n");
if (crc32("pPjtuxvSCGnV",12) == 1347819742) strcat(s, "d");
if (crc32("gwsrSCsHpP",10) == 3613492420) strcat(s, "n");
if (crc32("rkMfRpgKVQIl",12) == 2742158250) strcat(s, "u");
if (crc32("SBEhMRiu",8) == 1030195911) strcat(s, "w");
if (crc32("ZwJeLZOV",8) == 840623133) strcat(s, "c");
if (crc32("eWWgYjQgfYtO",12) == 2685711062) strcat(s, "i");
if (crc32("WblSEViCqxTZvZ",14) == 3477108118) strcat(s, "I");
if (crc32("wnfuaqTkqrAvQ",13) == 772759222) strcat(s, "b");
if (crc32("AcbTjMGgSOfK",12) == 3259847265) strcat(s, "J");
if (crc32("mHsGC",5) == 4286196690) strcat(s, "l");
if (crc32("VCWNcUODzuB",11) == 521234703) strcat(s, "e");
    return s;
}

char *nonrepressible_adjectives() {
    char *s = calloc(15);
    if (crc32("zMGYLDZkoRZPB",13) == 1620085815) strcat(s, "V");
if (crc32("GVyYBsWJGvf",11) == 3192841993) strcat(s, "n");
if (crc32("CyEzEikFjGDsR",13) == 3954152207) strcat(s, "g");
if (crc32("LieKbpTPFFSAtH",14) == 872890238) strcat(s, "o");
if (crc32("sdVtF",5) == 1892222723) strcat(s, "n");
if (crc32("zLgTnR",6) == 924984885) strcat(s, "V");
if (crc32("FTTnOsUkg",9) == 3808975543) strcat(s, "r");
if (crc32("kztjz",5) == 2312890189) strcat(s, "d");
if (crc32("ROTXhJWOXJb",11) == 432200166) strcat(s, "e");
if (crc32("BjeRgi",6) == 1573043291) strcat(s, "p");
if (crc32("mzQcEcB",7) == 1359426969) strcat(s, "r");
if (crc32("myaBri",6) == 3606243045) strcat(s, "t");
if (crc32("uwvZCZT",7) == 3115840648) strcat(s, "e");
if (crc32("sUVSCpGZTED",11) == 409903615) strcat(s, "K");
if (crc32("HxpEFLcRRcYRdm",14) == 4121853523) strcat(s, "s");
if (crc32("nJOhDrjgCXP",11) == 177210532) strcat(s, "s");
if (crc32("hwodgOXj",8) == 3636575389) strcat(s, "i");
if (crc32("shhESj",6) == 553972822) strcat(s, "b");
if (crc32("yrExJBsfeGF",11) == 1095602985) strcat(s, "p");
if (crc32("WqGZcWI",7) == 1164507746) strcat(s, "l");
if (crc32("jltRRZq",7) == 2136641971) strcat(s, "L");
if (crc32("neMueNtcSB",10) == 787129526) strcat(s, "e");
    return s;
}

char *nonaspirated_adjectives() {
    char *s = calloc(13);
    if (crc32("gywUOnQDXbij",12) == 2466715599) strcat(s, "n");
if (crc32("pOvKCiINeGOs",12) == 215440443) strcat(s, "o");
if (crc32("KlOqDRWrEVuLmmR",15) == 1665079288) strcat(s, "d");
if (crc32("DwuTjUBlWtjwx",13) == 1891576951) strcat(s, "n");
if (crc32("HmdMcklHoOHuJ",13) == 2268007909) strcat(s, "Q");
if (crc32("VznxclOnFVs",11) == 1681628702) strcat(s, "a");
if (crc32("HnvEJbeAu",9) == 1316702378) strcat(s, "U");
if (crc32("buTnerIY",8) == 2418057981) strcat(s, "s");
if (crc32("fjhJOsNmQwHd",12) == 3219210044) strcat(s, "h");
if (crc32("YphICzBvlPVdt",13) == 1358841220) strcat(s, "p");
if (crc32("pPbvapbiWor",11) == 403113555) strcat(s, "t");
if (crc32("SXiXOeCVBPO",11) == 1653777052) strcat(s, "i");
if (crc32("euGwXegEhiy",11) == 2620040253) strcat(s, "W");
if (crc32("DjdwtXbSsVFNBf",14) == 1871983863) strcat(s, "r");
if (crc32("dcfZcfdYHyFcqt",14) == 1820558626) strcat(s, "v");
if (crc32("xIivrPgidVn",11) == 3292958344) strcat(s, "a");
if (crc32("jhOgxSaDACeiqP",14) == 779904401) strcat(s, "E");
if (crc32("BJNjghuAjvAWHcx",15) == 3900823618) strcat(s, "t");
if (crc32("NJeBlQeWKM",10) == 2531111605) strcat(s, "h");
if (crc32("upYLivaClr",10) == 367513126) strcat(s, "e");
if (crc32("OeGQopXqAp",10) == 3735596629) strcat(s, "d");
    return s;
}

char *digitipinnate_adjectives() {
    char *s = calloc(14);
    if (crc32("tgYHcCROfYcov",13) == 2653969783) strcat(s, "d");
if (crc32("kuPUcaJoPfA",11) == 79332569) strcat(s, "H");
if (crc32("QrVdnZBBz",9) == 1023839318) strcat(s, "i");
if (crc32("StzkB",5) == 45712488) strcat(s, "K");
if (crc32("QhxTlxeqIlH",11) == 1839376066) strcat(s, "g");
if (crc32("igsveJvSlGt",11) == 2714681495) strcat(s, "i");
if (crc32("xvPWjPqnNoMaOF",14) == 2525203239) strcat(s, "t");
if (crc32("PYuIcfuBVSfGE",13) == 588444252) strcat(s, "n");
if (crc32("UPcDBzTlFrnl",12) == 2685440498) strcat(s, "i");
if (crc32("pGdKPiZDdwa",11) == 3814032371) strcat(s, "p");
if (crc32("ZyQqBt",6) == 657719897) strcat(s, "z");
if (crc32("XomHAURds",9) == 298261089) strcat(s, "i");
if (crc32("uFjwErp",7) == 3825867561) strcat(s, "n");
if (crc32("DxNady",6) == 4131367925) strcat(s, "n");
if (crc32("ULAbgSJY",8) == 211014062) strcat(s, "a");
if (crc32("OBnytlf",7) == 1676376057) strcat(s, "t");
if (crc32("AgGNzq",6) == 603569235) strcat(s, "i");
if (crc32("friXgQkJvziYlyz",15) == 1318273200) strcat(s, "e");
    return s;
}

char *assiduous_adjectives() {
    char *s = calloc(10);
    if (crc32("WQJUKSYbTqYWjsn",15) == 794118723) strcat(s, "a");
if (crc32("MettpPdF",8) == 1505537318) strcat(s, "Q");
if (crc32("hhJvfeeCSPHqDZM",15) == 219535596) strcat(s, "s");
if (crc32("RouBadlwfXtpMs",14) == 1277983349) strcat(s, "k");
if (crc32("JilBvhCQhWdl",12) == 1032494617) strcat(s, "s");
if (crc32("CtnAhLzJnL",10) == 2557129035) strcat(s, "i");
if (crc32("CSrCgDUozal",11) == 3525078510) strcat(s, "u");
if (crc32("IxHXhkt",7) == 1511115116) strcat(s, "d");
if (crc32("AObnRFpunu",10) == 4127844111) strcat(s, "v");
if (crc32("qCcTWmjEkCvMbc",14) == 1489886900) strcat(s, "u");
if (crc32("gPePhYbzGtzZS",13) == 646196996) strcat(s, "o");
if (crc32("lfOXCRyua",9) == 1439574586) strcat(s, "u");
if (crc32("GyBKZpaiwTeSIt",14) == 1812874544) strcat(s, "g");
if (crc32("rKBadVHf",8) == 1805495979) strcat(s, "s");
    return s;
}

char *parotid_adjectives() {
    char *s = calloc(8);
    if (crc32("RUIBIhHCxB",10) == 3876878594) strcat(s, "o");
if (crc32("ckohCIuC",8) == 2841656616) strcat(s, "p");
if (crc32("JmAUqqvdVXRVzK",14) == 1168132360) strcat(s, "W");
if (crc32("gkzSePJDOgqtrB",14) == 1669973303) strcat(s, "a");
if (crc32("tFaOEfWRvaR",11) == 2267790955) strcat(s, "r");
if (crc32("vuwqoKES",8) == 3622294693) strcat(s, "Z");
if (crc32("aidhjHslal",10) == 14608659) strcat(s, "o");
if (crc32("oKcgwbjsJKO",11) == 1059707189) strcat(s, "t");
if (crc32("nXsxenjtMQZrWt",14) == 3485509646) strcat(s, "i");
if (crc32("rnVNxngYUNlf",12) == 2252426439) strcat(s, "w");
if (crc32("VVkzyCBjaQmJ",12) == 2336411769) strcat(s, "d");
    return s;
}

char *wellhatched_adjectives() {
    char *s = calloc(12);
    if (crc32("kyEXNKMkuDpsdoX",15) == 2996410811) strcat(s, "C");
if (crc32("CRSOUm",6) == 745315215) strcat(s, "w");
if (crc32("qacPOBpeNZaiA",13) == 3397647104) strcat(s, "e");
if (crc32("yFjerROv",8) == 1775424666) strcat(s, "l");
if (crc32("XJORarbJllK",11) == 396557916) strcat(s, "I");
if (crc32("ksbinzZpXzX",11) == 39769570) strcat(s, "l");
if (crc32("ssFOiJCgQkUu",12) == 3313637510) strcat(s, "j");
if (crc32("KkGHoGsDboyDmCc",15) == 1740941501) strcat(s, "h");
if (crc32("cCHZlaywOLMBzW",14) == 2252161152) strcat(s, "R");
if (crc32("OVNfGUVnY",9) == 688539368) strcat(s, "a");
if (crc32("AYkLakLmsiZU",12) == 726728556) strcat(s, "t");
if (crc32("kbGvxGOR",8) == 3114230231) strcat(s, "c");
if (crc32("ekEXmMfLWqsykO",14) == 1397792686) strcat(s, "h");
if (crc32("rLQpfNyEO",9) == 4195294360) strcat(s, "F");
if (crc32("RMuKFXmIGe",10) == 915397851) strcat(s, "e");
if (crc32("lbdXvH",6) == 4203692577) strcat(s, "d");
    return s;
}

char *balmier_adjectives() {
    char *s = calloc(8);
    if (crc32("TOwTTFDytxmbUFc",15) == 369797181) strcat(s, "R");
if (crc32("vNbjGZHg",8) == 17396467) strcat(s, "b");
if (crc32("vBBerlQa",8) == 907205577) strcat(s, "z");
if (crc32("qMjXyynJI",9) == 3648542732) strcat(s, "a");
if (crc32("iTyFqmVQtovQwjD",15) == 883919682) strcat(s, "j");
if (crc32("gLQWyfdeySTu",12) == 2752720128) strcat(s, "l");
if (crc32("MZZocvsWElxyrO",14) == 1897899653) strcat(s, "m");
if (crc32("SYwXr",5) == 3980833326) strcat(s, "a");
if (crc32("ulBONIqYtdvCU",13) == 222387304) strcat(s, "i");
if (crc32("phdEdWeKdsdqO",13) == 1805390721) strcat(s, "e");
if (crc32("GwWDT",5) == 1189832150) strcat(s, "k");
if (crc32("lReZltmedjaH",12) == 701734732) strcat(s, "r");
    return s;
}

char *spoutlike_adjectives() {
    char *s = calloc(10);
    if (crc32("XbSEImLbk",9) == 1212559144) strcat(s, "n");
if (crc32("sqOKVz",6) == 458186505) strcat(s, "s");
if (crc32("YbbLRCNLgHDWn",13) == 66408649) strcat(s, "p");
if (crc32("XUCiT",5) == 80545951) strcat(s, "a");
if (crc32("gzOliFIyUYaPWv",14) == 2778457673) strcat(s, "o");
if (crc32("IXwudQXVxjXu",12) == 3340151430) strcat(s, "A");
if (crc32("mzKUx",5) == 1189033511) strcat(s, "u");
if (crc32("NHFFikRmy",9) == 2789328533) strcat(s, "I");
if (crc32("rKOBOmnUrQKYKW",14) == 2959029476) strcat(s, "t");
if (crc32("aczdPWJR",8) == 674985694) strcat(s, "l");
if (crc32("oqpCzkSEtRfT",12) == 2775818892) strcat(s, "r");
if (crc32("OBNYqa",6) == 2043163003) strcat(s, "i");
if (crc32("XFAzB",5) == 3307955258) strcat(s, "b");
if (crc32("cGvrIK",6) == 216364836) strcat(s, "k");
if (crc32("hbGvyCrjWKJgk",13) == 1579698727) strcat(s, "F");
if (crc32("muoOEdCSVIyorQG",15) == 3427201616) strcat(s, "e");
    return s;
}

char *prerenal_adjectives() {
    char *s = calloc(9);
    if (crc32("bkOwRRj",7) == 2247059416) strcat(s, "p");
if (crc32("awnGI",5) == 2309398153) strcat(s, "y");
if (crc32("PwRsvOrlGRdi",12) == 2049455218) strcat(s, "r");
if (crc32("FMHujCYMoMifBs",14) == 2571046706) strcat(s, "a");
if (crc32("FagVu",5) == 320694358) strcat(s, "e");
if (crc32("fZbRvlIw",8) == 4011312079) strcat(s, "J");
if (crc32("oliODOFejWGUV",13) == 4142882418) strcat(s, "r");
if (crc32("kiblbW",6) == 2650509425) strcat(s, "M");
if (crc32("SPNnQOGZUWFZZ",13) == 1822830575) strcat(s, "e");
if (crc32("VcdYQPmhxN",10) == 3595116427) strcat(s, "n");
if (crc32("JBhmSJykh",9) == 3531576886) strcat(s, "j");
if (crc32("gBaMsLQBwfEXLfQ",15) == 29796239) strcat(s, "a");
if (crc32("qXiqgfOTSxzz",12) == 3920961842) strcat(s, "J");
if (crc32("HqpSteb",7) == 3797034397) strcat(s, "l");
    return s;
}

char *juvenescent_adjectives() {
    char *s = calloc(12);
    if (crc32("slCTQA",6) == 551102508) strcat(s, "j");
if (crc32("otltoKpXr",9) == 2860279521) strcat(s, "k");
if (crc32("zWzANk",6) == 1342759307) strcat(s, "u");
if (crc32("zFVbD",5) == 3528377854) strcat(s, "n");
if (crc32("NkABDRvBF",9) == 483344668) strcat(s, "v");
if (crc32("jZUzRTJEPxiHi",13) == 605432690) strcat(s, "D");
if (crc32("XqrPJxycCBCsP",13) == 205132728) strcat(s, "e");
if (crc32("VETUUh",6) == 1371253157) strcat(s, "n");
if (crc32("yIxYohID",8) == 2690075494) strcat(s, "e");
if (crc32("PxrPl",5) == 4184898748) strcat(s, "s");
if (crc32("Qqmzb",5) == 649142244) strcat(s, "c");
if (crc32("IqzbOdbwrJTURev",15) == 1004823261) strcat(s, "e");
if (crc32("MWQdqJa",7) == 1060539105) strcat(s, "j");
if (crc32("ELMOwlwtf",9) == 1406294890) strcat(s, "n");
if (crc32("VuhuNCMuT",9) == 3358145120) strcat(s, "t");
    return s;
}

char *unmatted_adjectives() {
    char *s = calloc(9);
    if (crc32("MgNFY",5) == 236979526) strcat(s, "u");
if (crc32("HRyuysUxXClM",12) == 2636841911) strcat(s, "N");
if (crc32("TEeYmrKde",9) == 3134681246) strcat(s, "n");
if (crc32("EfFKBcBtFgEKb",13) == 1780194997) strcat(s, "m");
if (crc32("jbmyydczdREn",12) == 2666361308) strcat(s, "I");
if (crc32("wUMEVPTfIfPAgk",14) == 3364987045) strcat(s, "a");
if (crc32("NaDUxCzymQtgN",13) == 1468087231) strcat(s, "I");
if (crc32("fRJab",5) == 319021149) strcat(s, "t");
if (crc32("JoTlO",5) == 3548867012) strcat(s, "Y");
if (crc32("mZZsirasRxBv",12) == 3110599813) strcat(s, "t");
if (crc32("FFDQMjJo",8) == 107616775) strcat(s, "Y");
if (crc32("xIiGWiZ",7) == 2922331935) strcat(s, "e");
if (crc32("cLKsdzzrsfp",11) == 3392016494) strcat(s, "d");
    return s;
}

char *quasiroyal_adjectives() {
    char *s = calloc(11);
    if (crc32("OALjbYxVs",9) == 36286083) strcat(s, "q");
if (crc32("CGdlhghBgjyn",12) == 2647472494) strcat(s, "u");
if (crc32("ulTHFxqjo",9) == 2180823676) strcat(s, "a");
if (crc32("nGxHTMO",7) == 3860185545) strcat(s, "E");
if (crc32("jLuVzBz",7) == 1050501408) strcat(s, "s");
if (crc32("UDzbCACXpQHUESr",15) == 1711372390) strcat(s, "i");
if (crc32("tFMSPuWt",8) == 2637395782) strcat(s, "i");
if (crc32("GNZWAoCxyoYNU",13) == 1679393324) strcat(s, "Z");
if (crc32("GHFZVsE",7) == 3864892303) strcat(s, "r");
if (crc32("zweuC",5) == 3331444151) strcat(s, "F");
if (crc32("yeEQi",5) == 3750201424) strcat(s, "o");
if (crc32("wkDsh",5) == 1687487884) strcat(s, "t");
if (crc32("xhmmBCumY",9) == 3409663287) strcat(s, "y");
if (crc32("LvrgSDaRhhuurfX",15) == 3595239707) strcat(s, "a");
if (crc32("AyHlAVBSMIwOwN",14) == 3479784689) strcat(s, "l");
    return s;
}

char *noninferential_adjectives() {
    char *s = calloc(15);
    if (crc32("CixOrFD",7) == 1296489561) strcat(s, "n");
if (crc32("aGNoMJoMBU",10) == 1165602117) strcat(s, "o");
if (crc32("wzoeKHPeBcAt",12) == 520930505) strcat(s, "I");
if (crc32("gpJOr",5) == 854112016) strcat(s, "n");
if (crc32("tVTfokumUUQKv",13) == 1254393304) strcat(s, "s");
if (crc32("jrQrSqQRY",9) == 1494034259) strcat(s, "i");
if (crc32("CWGldiuJmLziT",13) == 2633998772) strcat(s, "n");
if (crc32("arEiJBavCzKZF",13) == 4140201114) strcat(s, "f");
if (crc32("bkaabNJGIXR",11) == 90906448) strcat(s, "M");
if (crc32("aNghgztP",8) == 239844668) strcat(s, "e");
if (crc32("hNJseGg",7) == 1499258248) strcat(s, "r");
if (crc32("XuweRxBa",8) == 3628832786) strcat(s, "a");
if (crc32("ihnenVkwhR",10) == 626605658) strcat(s, "e");
if (crc32("ihRSGiGqQ",9) == 1073394944) strcat(s, "t");
if (crc32("xrPrqSQ",7) == 636299190) strcat(s, "n");
if (crc32("YXTIjLJJp",9) == 2396049695) strcat(s, "m");
if (crc32("HRIqd",5) == 3423959045) strcat(s, "t");
if (crc32("xsxlZsGrfJ",10) == 468121381) strcat(s, "i");
if (crc32("hLEJQqeOQHxCD",13) == 922705537) strcat(s, "J");
if (crc32("aQZwgV",6) == 715326357) strcat(s, "a");
if (crc32("MhOSGZdqXiK",11) == 2780584439) strcat(s, "l");
if (crc32("FlzQSGMDOpRCR",13) == 739810620) strcat(s, "l");
    return s;
}

char *accentless_adjectives() {
    char *s = calloc(11);
    if (crc32("gnyJcdj",7) == 2815818383) strcat(s, "M");
if (crc32("qwxndWbP",8) == 208922354) strcat(s, "a");
if (crc32("SxjCbfpKoqYJ",12) == 3766411660) strcat(s, "U");
if (crc32("GjHBenVEARSoptC",15) == 574026400) strcat(s, "c");
if (crc32("ZaTiwKscVbpfZ",13) == 327313459) strcat(s, "c");
if (crc32("xaXycWduQod",11) == 898923899) strcat(s, "e");
if (crc32("VAcULYeyrMuQZC",14) == 4216837271) strcat(s, "n");
if (crc32("eFKdHWLeeOCNQ",13) == 1725472072) strcat(s, "X");
if (crc32("YRKSLmtyKf",10) == 2382155465) strcat(s, "t");
if (crc32("VzfxXQJX",8) == 2092210445) strcat(s, "Y");
if (crc32("yDgDDbwhPapwMl",14) == 3127583134) strcat(s, "l");
if (crc32("QBYCOtgIwta",11) == 3265192353) strcat(s, "A");
if (crc32("dsXCECPC",8) == 2566243701) strcat(s, "e");
if (crc32("WcYUeqgfqsW",11) == 1264885270) strcat(s, "s");
if (crc32("ULddqkOfov",10) == 1442568062) strcat(s, "s");
    return s;
}

char *uncircumscribed_adjectives() {
    char *s = calloc(16);
    if (crc32("xcxtkltWP",9) == 3998832556) strcat(s, "u");
if (crc32("JzRPrIM",7) == 550714808) strcat(s, "n");
if (crc32("mFfLrsfgwS",10) == 3328542682) strcat(s, "c");
if (crc32("nbCUtFINsCy",11) == 624768970) strcat(s, "m");
if (crc32("HvFrUwBZqF",10) == 2538057036) strcat(s, "i");
if (crc32("MOwYp",5) == 3160803105) strcat(s, "h");
if (crc32("ZgQObPnDtGG",11) == 1905406001) strcat(s, "r");
if (crc32("zbcCZxlxHKr",11) == 2171725893) strcat(s, "c");
if (crc32("EswCp",5) == 4115938425) strcat(s, "c");
if (crc32("VBIYzqnoutmdeBV",15) == 3379448671) strcat(s, "O");
if (crc32("SQaesQUpq",9) == 3995821346) strcat(s, "u");
if (crc32("XMEBNlOGOESK",12) == 1978335857) strcat(s, "m");
if (crc32("FovGQs",6) == 273873349) strcat(s, "h");
if (crc32("YvdhqCQvlmpqj",13) == 705625413) strcat(s, "s");
if (crc32("IJZjVZJpGjeTn",13) == 729394904) strcat(s, "l");
if (crc32("uCGDFeMWrRWlB",13) == 1557919651) strcat(s, "c");
if (crc32("gmgbLpFJsaj",11) == 2954425833) strcat(s, "r");
if (crc32("VleUmdaZgMCya",13) == 2019350518) strcat(s, "i");
if (crc32("HPappUONmcKFMdY",15) == 10459473) strcat(s, "b");
if (crc32("hTFQvga",7) == 2935298313) strcat(s, "L");
if (crc32("vWoYSlOZJeftSb",14) == 4046994945) strcat(s, "e");
if (crc32("vmBiENUBrFvCSZ",14) == 1784696002) strcat(s, "d");
    return s;
}

char *dure_adjectives() {
    char *s = calloc(5);
    if (crc32("SQQDnD",6) == 954245700) strcat(s, "Y");
if (crc32("TZtmhPAR",8) == 1020516167) strcat(s, "d");
if (crc32("hlYftdITBkJy",12) == 2492058842) strcat(s, "A");
if (crc32("ADVxIAzR",8) == 3839188336) strcat(s, "u");
if (crc32("gWQxMbHPXfxAlGn",15) == 70605787) strcat(s, "F");
if (crc32("MGPviutIS",9) == 1556106621) strcat(s, "r");
if (crc32("SdklU",5) == 2602469187) strcat(s, "e");
    return s;
}

char *eupotamic_adjectives() {
    char *s = calloc(10);
    if (crc32("mnmHffhUpqvcD",13) == 156146482) strcat(s, "e");
if (crc32("KRTREE",6) == 2414499340) strcat(s, "C");
if (crc32("FjOyywjH",8) == 256304867) strcat(s, "u");
if (crc32("YbyMXEd",7) == 1457503772) strcat(s, "p");
if (crc32("zGcTxuuq",8) == 320267240) strcat(s, "o");
if (crc32("yQioVrfqr",9) == 1981389704) strcat(s, "t");
if (crc32("xITYdp",6) == 4214631323) strcat(s, "a");
if (crc32("FLVQG",5) == 3816445781) strcat(s, "a");
if (crc32("lNlnIASeRVwXia",14) == 863568413) strcat(s, "J");
if (crc32("hQuWNIbBTj",10) == 3076593182) strcat(s, "m");
if (crc32("XXEiPVngkWnfKvW",15) == 1159949250) strcat(s, "i");
if (crc32("qUjRmXa",7) == 4150667564) strcat(s, "k");
if (crc32("VFUhvZrxFPBgK",13) == 3445034174) strcat(s, "c");
    return s;
}

char *salpingian_adjectives() {
    char *s = calloc(11);
    if (crc32("YchrXZjSU",9) == 4213924933) strcat(s, "s");
if (crc32("fHbSMaAJQai",11) == 2769236415) strcat(s, "a");
if (crc32("boKAQchCQfYEObx",15) == 1711043551) strcat(s, "l");
if (crc32("htKycuyY",8) == 3690661121) strcat(s, "a");
if (crc32("nFeMdnBsQe",10) == 1884202819) strcat(s, "p");
if (crc32("icPFoDus",8) == 1148713187) strcat(s, "i");
if (crc32("NIYCisP",7) == 902978553) strcat(s, "n");
if (crc32("hLfWgQF",7) == 2514260334) strcat(s, "R");
if (crc32("TDeTVOIqFWcO",12) == 2291737732) strcat(s, "g");
if (crc32("Csjizpo",7) == 497405245) strcat(s, "J");
if (crc32("wAcfmUJmmyXQ",12) == 543689941) strcat(s, "i");
if (crc32("PVKZzD",6) == 2202071952) strcat(s, "a");
if (crc32("dBqHFyywAzBR",12) == 1851625290) strcat(s, "n");
    return s;
}

char *tactile_adjectives() {
    char *s = calloc(8);
    if (crc32("AmpIMrChwJH",11) == 1072805870) strcat(s, "t");
if (crc32("yMpBcfEaAMUhK",13) == 1962276119) strcat(s, "a");
if (crc32("wOLkb",5) == 311575829) strcat(s, "c");
if (crc32("TkoPtTdY",8) == 1619050074) strcat(s, "t");
if (crc32("qzTyNivbq",9) == 1185864961) strcat(s, "i");
if (crc32("hRVRXJpKRe",10) == 170321171) strcat(s, "l");
if (crc32("KJtApmosaEAmb",13) == 1051028608) strcat(s, "p");
if (crc32("DqBzlMg",7) == 472640598) strcat(s, "e");
    return s;
}

char *scalariform_adjectives() {
    char *s = calloc(12);
    if (crc32("TRUXkoXY",8) == 2606564758) strcat(s, "s");
if (crc32("CNjiguNfHLjz",12) == 3249508966) strcat(s, "c");
if (crc32("TDafjMA",7) == 4207875150) strcat(s, "d");
if (crc32("ggJaGx",6) == 3548056734) strcat(s, "a");
if (crc32("AhecK",5) == 3168923839) strcat(s, "l");
if (crc32("aPQWggtVnXKfrT",14) == 970181100) strcat(s, "z");
if (crc32("BuMjkgn",7) == 635124029) strcat(s, "a");
if (crc32("iLzaONd",7) == 4171938113) strcat(s, "h");
if (crc32("ueqdJkq",7) == 3623218400) strcat(s, "r");
if (crc32("CCIvflivG",9) == 464847022) strcat(s, "i");
if (crc32("GFcLglRZx",9) == 1520203917) strcat(s, "f");
if (crc32("SAlcMDpyKMe",11) == 2794124076) strcat(s, "W");
if (crc32("AubHSYkxnwY",11) == 2912537876) strcat(s, "o");
if (crc32("twTnUqpFXIecGZ",14) == 3331617433) strcat(s, "r");
if (crc32("jNwzoXHfU",9) == 3553721786) strcat(s, "r");
if (crc32("XQSihM",6) == 1872445731) strcat(s, "m");
    return s;
}

char *semipendent_adjectives() {
    char *s = calloc(12);
    if (crc32("BNdlODkrONvfFu",14) == 3232468146) strcat(s, "s");
if (crc32("zCdVJErnIcqx",12) == 699891336) strcat(s, "e");
if (crc32("SJhlNfdK",8) == 3900904669) strcat(s, "U");
if (crc32("YkmAGd",6) == 961677930) strcat(s, "m");
if (crc32("fXEkOl",6) == 3164683161) strcat(s, "i");
if (crc32("YQzgzCsE",8) == 2528363897) strcat(s, "r");
if (crc32("TDapFcryaaAZ",12) == 2741511507) strcat(s, "p");
if (crc32("OBKfswFtA",9) == 3070703330) strcat(s, "W");
if (crc32("AwftsjXeXqJH",12) == 3820036118) strcat(s, "e");
if (crc32("VQROll",6) == 2920824685) strcat(s, "i");
if (crc32("pgunCF",6) == 3417393624) strcat(s, "n");
if (crc32("hQOjvaIcmIVn",12) == 1244259528) strcat(s, "x");
if (crc32("pEJAtfBGyFId",12) == 3649762553) strcat(s, "d");
if (crc32("yvuewtyqofOR",12) == 1284328730) strcat(s, "F");
if (crc32("GrWmOr",6) == 4289856618) strcat(s, "e");
if (crc32("VaBCL",5) == 165215085) strcat(s, "d");
if (crc32("xddtdKyNmFiueHR",15) == 2353782489) strcat(s, "n");
if (crc32("SaRlUUluOqvVv",13) == 1148915906) strcat(s, "S");
if (crc32("ZSBgmic",7) == 882536242) strcat(s, "t");
    return s;
}

char *nematocystic_adjectives() {
    char *s = calloc(13);
    if (crc32("iXvNVHlrFzqwHd",14) == 1478627542) strcat(s, "n");
if (crc32("uNbZVKcXvHZB",12) == 351271813) strcat(s, "Q");
if (crc32("aEbmIfCuCvySM",13) == 2165667786) strcat(s, "e");
if (crc32("OpthvE",6) == 1800683497) strcat(s, "m");
if (crc32("wVRAQN",6) == 841909997) strcat(s, "a");
if (crc32("IEEIbeZOTwRWhhA",15) == 1863191440) strcat(s, "o");
if (crc32("pyUvYXqWXQzTOox",15) == 3170330094) strcat(s, "t");
if (crc32("jdehtGaFZFDeD",13) == 2162554952) strcat(s, "m");
if (crc32("ZOhDGsLvHN",10) == 2072552051) strcat(s, "o");
if (crc32("xCulpHaDKp",10) == 2643289980) strcat(s, "c");
if (crc32("FimQmJLHgAxKN",13) == 3474001994) strcat(s, "y");
if (crc32("HrsOsqyEpXqQma",14) == 1732743195) strcat(s, "s");
if (crc32("uSPaybPp",8) == 2359900557) strcat(s, "t");
if (crc32("UKSAehtq",8) == 4144785433) strcat(s, "i");
if (crc32("rtgPBXQ",7) == 2830528855) strcat(s, "A");
if (crc32("RmPFx",5) == 3657202517) strcat(s, "c");
    return s;
}

char *unbodied_adjectives() {
    char *s = calloc(9);
    if (crc32("BAeDkJetJg",10) == 1850965154) strcat(s, "u");
if (crc32("BVRhyz",6) == 770455427) strcat(s, "n");
if (crc32("KRuCIJDN",8) == 2135146128) strcat(s, "b");
if (crc32("LLwtkoTMX",9) == 3751042438) strcat(s, "o");
if (crc32("eXdtYkfOjPTc",12) == 1502486627) strcat(s, "X");
if (crc32("xopnCInOSIhJ",12) == 4216686337) strcat(s, "d");
if (crc32("zPNrmUxtfBbhlJE",15) == 1140231305) strcat(s, "i");
if (crc32("cKxugQEBpT",10) == 415204892) strcat(s, "W");
if (crc32("OMRbvy",6) == 2504280685) strcat(s, "e");
if (crc32("sxQClxJlwOMt",12) == 3900357154) strcat(s, "d");
    return s;
}

char *reparative_adjectives() {
    char *s = calloc(11);
    if (crc32("sOcdhgCUmzDr",12) == 1831299751) strcat(s, "Q");
if (crc32("zIaVv",5) == 2412680968) strcat(s, "r");
if (crc32("dwvAwNnsztzrR",13) == 1131329675) strcat(s, "j");
if (crc32("iRmhMo",6) == 3417873245) strcat(s, "e");
if (crc32("SLixplovodza",12) == 3554122978) strcat(s, "R");
if (crc32("MHkxDgZWXh",10) == 4229000506) strcat(s, "p");
if (crc32("giGppJARa",9) == 2338761670) strcat(s, "v");
if (crc32("aPqSpFXsjxtXWP",14) == 4017937937) strcat(s, "a");
if (crc32("ZlFaWhcpM",9) == 3342334516) strcat(s, "a");
if (crc32("PBOUVRRNlZmpOMF",15) == 3234939974) strcat(s, "r");
if (crc32("rWMcNIDW",8) == 1709923717) strcat(s, "a");
if (crc32("xyVCjP",6) == 1020730922) strcat(s, "n");
if (crc32("qwiprvofkUF",11) == 2742815417) strcat(s, "t");
if (crc32("SStgHpRrVoEaaE",14) == 791849377) strcat(s, "i");
if (crc32("cxffBlfEiJm",11) == 2066226648) strcat(s, "F");
if (crc32("CkATxJKxWsKPtT",14) == 3417304552) strcat(s, "v");
if (crc32("tUmIFrollO",10) == 3911203592) strcat(s, "e");
    return s;
}

char *leucocythaemic_adjectives() {
    char *s = calloc(15);
    if (crc32("qLPuzpRllHlEM",13) == 4056693721) strcat(s, "l");
if (crc32("BDOyHMLMhDkQaxa",15) == 2830273248) strcat(s, "E");
if (crc32("hitfDna",7) == 2928238405) strcat(s, "e");
if (crc32("QHqAdZtH",8) == 2066377565) strcat(s, "P");
if (crc32("HVhJkFrTnSJ",11) == 1056692439) strcat(s, "u");
if (crc32("vaDeYBhUp",9) == 2464216248) strcat(s, "d");
if (crc32("dpnqH",5) == 3452297523) strcat(s, "c");
if (crc32("aiAkQqxSNl",10) == 2870410162) strcat(s, "Z");
if (crc32("JDCZpioIYLmn",12) == 4261607152) strcat(s, "o");
if (crc32("ZwFCFHhdquciV",13) == 559663347) strcat(s, "j");
if (crc32("SHheohgwAnH",11) == 3464768193) strcat(s, "c");
if (crc32("owMBlGUcriZ",11) == 394574874) strcat(s, "y");
if (crc32("RnftO",5) == 2581871837) strcat(s, "D");
if (crc32("XqcgoSY",7) == 4125167415) strcat(s, "t");
if (crc32("ETOdHgluLadK",12) == 4150877992) strcat(s, "h");
if (crc32("ncibtdnHdUWADA",14) == 99956319) strcat(s, "a");
if (crc32("jgUCVmLtM",9) == 2887390199) strcat(s, "w");
if (crc32("KbAUn",5) == 1689297780) strcat(s, "e");
if (crc32("ndPzzV",6) == 3798959094) strcat(s, "d");
if (crc32("tbiJS",5) == 3836598772) strcat(s, "m");
if (crc32("VQIWdfiwTxg",11) == 4195033425) strcat(s, "X");
if (crc32("UkZQTw",6) == 3659245877) strcat(s, "i");
if (crc32("epyIqfpiy",9) == 2821929316) strcat(s, "F");
if (crc32("DzCiv",5) == 274103826) strcat(s, "c");
    return s;
}

char *unprudential_adjectives() {
    char *s = calloc(13);
    if (crc32("clDQurjzWwHNxFj",15) == 3288169914) strcat(s, "u");
if (crc32("TNeIsXC",7) == 57313075) strcat(s, "n");
if (crc32("DBomvHhuaX",10) == 1729327164) strcat(s, "p");
if (crc32("hFnFsDa",7) == 2623469446) strcat(s, "r");
if (crc32("cXwsWeZxdwn",11) == 1504078173) strcat(s, "u");
if (crc32("UMDpBMiXpZn",11) == 863797170) strcat(s, "U");
if (crc32("pRyOirNBd",9) == 567761830) strcat(s, "d");
if (crc32("ARqGxhaYv",9) == 2575981773) strcat(s, "m");
if (crc32("qnwiicgyxcyDrm",14) == 3020611063) strcat(s, "e");
if (crc32("BORWTH",6) == 3691399123) strcat(s, "I");
if (crc32("UJvnrLLNaGHebXo",15) == 3147012428) strcat(s, "n");
if (crc32("TFxDkXxljEsRB",13) == 617733123) strcat(s, "h");
if (crc32("jPWYqCIDzrIYmV",14) == 1263037509) strcat(s, "t");
if (crc32("ItlxKhzIUss",11) == 2893999732) strcat(s, "i");
if (crc32("VGTOWzSLUJ",10) == 621469945) strcat(s, "Y");
if (crc32("EsKLLe",6) == 77897253) strcat(s, "a");
if (crc32("BYXkiVsPnV",10) == 1554927481) strcat(s, "l");
    return s;
}

char *megalithic_adjectives() {
    char *s = calloc(11);
    if (crc32("fkZCCCEO",8) == 3628155977) strcat(s, "m");
if (crc32("osdHcjdVLvQGup",14) == 2785799039) strcat(s, "e");
if (crc32("MktUrbWuZUtzsAG",15) == 1256636088) strcat(s, "u");
if (crc32("vVFFvsNHsP",10) == 3633238536) strcat(s, "g");
if (crc32("vbRmtatqHLMPvlA",15) == 4207416908) strcat(s, "Q");
if (crc32("FajgGdskEGJ",11) == 1740668247) strcat(s, "a");
if (crc32("xOdpvTu",7) == 363626907) strcat(s, "l");
if (crc32("AByuZ",5) == 276459732) strcat(s, "i");
if (crc32("PyrJwpTGUJNlKPT",15) == 3545681913) strcat(s, "t");
if (crc32("DWYyUzRWahcZRRo",15) == 992287174) strcat(s, "k");
if (crc32("AHKMTIneeUXQwV",14) == 1106546269) strcat(s, "h");
if (crc32("ePKicDsAsiLY",12) == 1506268608) strcat(s, "m");
if (crc32("koUkmudfXQjSJv",14) == 2720380965) strcat(s, "i");
if (crc32("gGgFMDVJ",8) == 2565298327) strcat(s, "c");
    return s;
}

char *progambling_adjectives() {
    char *s = calloc(12);
    if (crc32("LlbZBd",6) == 963024218) strcat(s, "V");
if (crc32("lTzgJQfjMWpHGYn",15) == 423514607) strcat(s, "p");
if (crc32("PnAfcVMuNaK",11) == 2606148683) strcat(s, "U");
if (crc32("ShBLCIEpJTNUJ",13) == 788105368) strcat(s, "r");
if (crc32("YqapSRxXEb",10) == 844094438) strcat(s, "J");
if (crc32("FojIZSNruZSx",12) == 1095393186) strcat(s, "o");
if (crc32("wZtbNpOKz",9) == 3209792880) strcat(s, "g");
if (crc32("WFTnjlDgLepW",12) == 2555218863) strcat(s, "a");
if (crc32("NYbFwFCoIXDXBJ",14) == 1313353919) strcat(s, "a");
if (crc32("XQoOyAsWWHKV",12) == 2572022997) strcat(s, "M");
if (crc32("UoiAfy",6) == 3689644732) strcat(s, "m");
if (crc32("BFBVqBPMOE",10) == 900765538) strcat(s, "s");
if (crc32("MHEYrwvHrRdU",12) == 3643584287) strcat(s, "b");
if (crc32("VyxqQuHac",9) == 3303138920) strcat(s, "l");
if (crc32("BmpWuljWYh",10) == 2730910237) strcat(s, "S");
if (crc32("gSAklRm",7) == 714131136) strcat(s, "i");
if (crc32("gBrxJatke",9) == 1355105348) strcat(s, "n");
if (crc32("JotaPuXVde",10) == 2339258402) strcat(s, "g");
    return s;
}

char *unpropounded_adjectives() {
    char *s = calloc(13);
    if (crc32("POBssLZyfcwH",12) == 3849945763) strcat(s, "u");
if (crc32("XPhUIFoi",8) == 1974652221) strcat(s, "N");
if (crc32("nrLvAtFDt",9) == 4104757696) strcat(s, "n");
if (crc32("TnigCrlBiapSwCX",15) == 1953692200) strcat(s, "l");
if (crc32("ddHXlvyFkqG",11) == 4055977063) strcat(s, "p");
if (crc32("CQuTlHcrQ",9) == 4165175464) strcat(s, "r");
if (crc32("oMDhG",5) == 658594381) strcat(s, "B");
if (crc32("hODrPzGMLCvL",12) == 1395564641) strcat(s, "o");
if (crc32("fhVPWwjkQnfz",12) == 333146999) strcat(s, "p");
if (crc32("PrDBmLLXXiClD",13) == 105994646) strcat(s, "o");
if (crc32("AvNdVao",7) == 943111486) strcat(s, "u");
if (crc32("usoHGsuRvjkZIE",14) == 327409601) strcat(s, "O");
if (crc32("irbHOmTgGwfD",12) == 1803699639) strcat(s, "n");
if (crc32("aqAtTyoij",9) == 1045656565) strcat(s, "d");
if (crc32("xSxPDtGBIbY",11) == 2719412594) strcat(s, "e");
if (crc32("acRHh",5) == 2625801141) strcat(s, "f");
if (crc32("uTnNyLHcgvJ",11) == 506813527) strcat(s, "d");
    return s;
}

char *wellfarmed_adjectives() {
    char *s = calloc(11);
    if (crc32("LjygOjHwM",9) == 1797727311) strcat(s, "w");
if (crc32("NJPOeRfH",8) == 1191385730) strcat(s, "e");
if (crc32("nxLIWgctZ",9) == 6237460) strcat(s, "l");
if (crc32("ZMNbvPxDWgJ",11) == 2806793801) strcat(s, "F");
if (crc32("BOEGZWazv",9) == 3815017335) strcat(s, "l");
if (crc32("jvwes",5) == 3688082949) strcat(s, "o");
if (crc32("iaPkd",5) == 1911573466) strcat(s, "f");
if (crc32("dmurS",5) == 3653112289) strcat(s, "j");
if (crc32("XtyZKz",6) == 2299275178) strcat(s, "a");
if (crc32("YREvhOYFrB",10) == 1831292321) strcat(s, "r");
if (crc32("hOCYWTfKObbdmSF",15) == 1399587813) strcat(s, "B");
if (crc32("VFTEFMcspDU",11) == 3456831915) strcat(s, "m");
if (crc32("uieaoN",6) == 1222874420) strcat(s, "e");
if (crc32("PVCiYonBbNRyLZb",15) == 1037301692) strcat(s, "S");
if (crc32("vXaRYFDZ",8) == 1139090251) strcat(s, "d");
    return s;
}

char *vacciniaceous_adjectives() {
    char *s = calloc(14);
    if (crc32("nefWQeXWEXG",11) == 1104691880) strcat(s, "v");
if (crc32("TQJOamFELEx",11) == 1193192640) strcat(s, "o");
if (crc32("ardwobWbSMVBcNK",15) == 3382493394) strcat(s, "a");
if (crc32("ZAgRRD",6) == 1236366576) strcat(s, "c");
if (crc32("ufXtMjBwnwfnB",13) == 105306234) strcat(s, "c");
if (crc32("TAWdqhzZfWQS",12) == 804043354) strcat(s, "i");
if (crc32("NjiJKvOlFwcRUV",14) == 993207728) strcat(s, "A");
if (crc32("QsKOHrbanpXs",12) == 2285708083) strcat(s, "n");
if (crc32("zfvgKj",6) == 2955882884) strcat(s, "i");
if (crc32("Cqksf",5) == 2890257400) strcat(s, "f");
if (crc32("nSzaEKhkkJ",10) == 2911696967) strcat(s, "a");
if (crc32("QLpMz",5) == 1658930830) strcat(s, "H");
if (crc32("tQDBwArFpxqAlv",14) == 1333964452) strcat(s, "c");
if (crc32("kpqTRsZmt",9) == 2485556041) strcat(s, "e");
if (crc32("HEKRatZHp",9) == 2901772070) strcat(s, "o");
if (crc32("zeESoXHSar",10) == 1680020775) strcat(s, "u");
if (crc32("FpZBnE",6) == 3145198915) strcat(s, "s");
    return s;
}

char *Aragonese_adjectives() {
    char *s = calloc(10);
    if (crc32("XNSjB",5) == 3702550369) strcat(s, "A");
if (crc32("WSJxhPFyAgAJol",14) == 2164603257) strcat(s, "Q");
if (crc32("PfRZdVfyuQYc",12) == 365200230) strcat(s, "r");
if (crc32("SolFQRAfpeD",11) == 4059168331) strcat(s, "w");
if (crc32("RrBtWRq",7) == 1876881793) strcat(s, "a");
if (crc32("gIIciDljWSPJqfW",15) == 4224915743) strcat(s, "U");
if (crc32("AxUpiprxfktH",12) == 4268987822) strcat(s, "g");
if (crc32("oSenzZLsWIZh",12) == 894545272) strcat(s, "o");
if (crc32("YmWrcn",6) == 513062014) strcat(s, "n");
if (crc32("MKjHelLPEIRJrQ",14) == 1346508114) strcat(s, "V");
if (crc32("ksmQvJqMzRx",11) == 841917818) strcat(s, "e");
if (crc32("HEnQkxyKHO",10) == 760050544) strcat(s, "a");
if (crc32("kmdWgEzTrO",10) == 3301826880) strcat(s, "s");
if (crc32("oYjnNEBMsgjaj",13) == 1632465670) strcat(s, "e");
    return s;
}

char *unbaked_adjectives() {
    char *s = calloc(8);
    if (crc32("Xpplqc",6) == 1621107067) strcat(s, "u");
if (crc32("gEaUpgmiocm",11) == 3697859542) strcat(s, "n");
if (crc32("cqqusyWY",8) == 3211532496) strcat(s, "m");
if (crc32("hyPFopz",7) == 1393566742) strcat(s, "b");
if (crc32("vItkg",5) == 1351316446) strcat(s, "a");
if (crc32("aeLpBveQJxNTsL",14) == 864312734) strcat(s, "T");
if (crc32("WKIldYkFpTCm",12) == 2702623259) strcat(s, "k");
if (crc32("SamSFWNRBMNsySs",15) == 3256376042) strcat(s, "e");
if (crc32("XEStXVB",7) == 1605485767) strcat(s, "d");
    return s;
}

char *fiducial_adjectives() {
    char *s = calloc(9);
    if (crc32("NcCpeftECNOXwy",14) == 4052821851) strcat(s, "f");
if (crc32("aelgOQRHYxphzI",14) == 4168464935) strcat(s, "i");
if (crc32("PDBdxudoYmH",11) == 1611379523) strcat(s, "d");
if (crc32("wqStV",5) == 518512352) strcat(s, "r");
if (crc32("KcfDtWyalHPTWLB",15) == 2246931807) strcat(s, "u");
if (crc32("AqlBor",6) == 4025796472) strcat(s, "c");
if (crc32("ndGMmlVReJ",10) == 3436857428) strcat(s, "i");
if (crc32("PeJNw",5) == 794800613) strcat(s, "a");
if (crc32("YAzkARc",7) == 3191205451) strcat(s, "r");
if (crc32("GnkYqLji",8) == 3418134666) strcat(s, "l");
    return s;
}

char *collective_adjectives() {
    char *s = calloc(11);
    if (crc32("COvpglEdxzApK",13) == 3846385066) strcat(s, "c");
if (crc32("ZqPaXy",6) == 29815612) strcat(s, "o");
if (crc32("OREWBZzdfb",10) == 1775236754) strcat(s, "J");
if (crc32("SgDDFUwgXd",10) == 1040693882) strcat(s, "l");
if (crc32("imiszveCyTOWizN",15) == 890435896) strcat(s, "l");
if (crc32("BLmDRNcbWX",10) == 1520912020) strcat(s, "X");
if (crc32("ZJulJPGinVIhu",13) == 686978608) strcat(s, "e");
if (crc32("GJYVWPStM",9) == 3907659156) strcat(s, "U");
if (crc32("rjGLUpTKojAp",12) == 2481935257) strcat(s, "c");
if (crc32("EFMURdkAOg",10) == 3780675462) strcat(s, "t");
if (crc32("qpapuQtjc",9) == 3513605173) strcat(s, "p");
if (crc32("gWBtnFhkDnqJuE",14) == 2119433811) strcat(s, "i");
if (crc32("pOkmJNmsEZyv",12) == 2987356291) strcat(s, "v");
if (crc32("NRNpDF",6) == 1049850268) strcat(s, "M");
if (crc32("UnGZvBReBXmEzse",15) == 3989014838) strcat(s, "e");
    return s;
}

char *unpilloried_adjectives() {
    char *s = calloc(12);
    if (crc32("ifZJkBUoGTESn",13) == 2353331500) strcat(s, "u");
if (crc32("KhcMNZaJDd",10) == 3473735665) strcat(s, "T");
if (crc32("QvEZqdQSjlShG",13) == 753093857) strcat(s, "n");
if (crc32("XJuqRxX",7) == 743057668) strcat(s, "p");
if (crc32("SPqpfhZwFsPU",12) == 2699963379) strcat(s, "i");
if (crc32("NEAKra",6) == 1817709125) strcat(s, "l");
if (crc32("UiiqAhrTY",9) == 762419433) strcat(s, "D");
if (crc32("cEddCnyyHUJ",11) == 94913113) strcat(s, "l");
if (crc32("ICLxik",6) == 3479279867) strcat(s, "c");
if (crc32("NnsUoMaelC",10) == 380688747) strcat(s, "o");
if (crc32("zGIexMDUAIELd",13) == 2814777587) strcat(s, "r");
if (crc32("SOAPraijbgD",11) == 287165031) strcat(s, "i");
if (crc32("AfKoZkt",7) == 3648704704) strcat(s, "O");
if (crc32("InrykCKWnimD",12) == 1355943066) strcat(s, "e");
if (crc32("NPlowgs",7) == 140445575) strcat(s, "d");
    return s;
}

char *draggy_adjectives() {
    char *s = calloc(7);
    if (crc32("Shvxe",5) == 1337480901) strcat(s, "s");
if (crc32("fsjjf",5) == 3612963636) strcat(s, "d");
if (crc32("pxpMzOKDfwoX",12) == 1307795887) strcat(s, "r");
if (crc32("kTMyALrkkQ",10) == 4196049243) strcat(s, "D");
if (crc32("ZnScDAkGgI",10) == 4127084556) strcat(s, "a");
if (crc32("isvmtrdeD",9) == 3829734200) strcat(s, "g");
if (crc32("bgfJfCGEkZP",11) == 2402175671) strcat(s, "g");
if (crc32("EIIDSLGFO",9) == 1100747179) strcat(s, "a");
if (crc32("FMpcMiwzGYFVBre",15) == 1977780730) strcat(s, "y");
    return s;
}

char *glottidean_adjectives() {
    char *s = calloc(11);
    if (crc32("FHYyBlfzoh",10) == 330190300) strcat(s, "o");
if (crc32("buDngettDYh",11) == 2498004838) strcat(s, "g");
if (crc32("YWvrhsWXQuf",11) == 1962059756) strcat(s, "l");
if (crc32("koxRBHNb",8) == 2989318846) strcat(s, "o");
if (crc32("MxjqUaQ",7) == 1342654874) strcat(s, "i");
if (crc32("ozJIscyDVvv",11) == 801649905) strcat(s, "t");
if (crc32("plGBWszWwEdG",12) == 1110103223) strcat(s, "t");
if (crc32("zNidgQ",6) == 3281530459) strcat(s, "i");
if (crc32("pmHfKQ",6) == 3327733618) strcat(s, "d");
if (crc32("ReHZmTkKzR",10) == 1684245551) strcat(s, "y");
if (crc32("IZFqsycZaqf",11) == 4121506477) strcat(s, "e");
if (crc32("IKxXcZKudLRPZ",13) == 1883502189) strcat(s, "r");
if (crc32("kAvsmBwAPNs",11) == 3280800090) strcat(s, "a");
if (crc32("IuPbTqlgy",9) == 1255788974) strcat(s, "n");
    return s;
}

char *undefrayed_adjectives() {
    char *s = calloc(11);
    if (crc32("iKzuyAxRssU",11) == 4220472040) strcat(s, "u");
if (crc32("BSnMdDUKw",9) == 1792304621) strcat(s, "n");
if (crc32("ewpMJ",5) == 3862390419) strcat(s, "d");
if (crc32("WtmPwfkrjc",10) == 2375613220) strcat(s, "e");
if (crc32("XHhjoyJDVB",10) == 4204978026) strcat(s, "f");
if (crc32("hoFLGusEDSS",11) == 3790210979) strcat(s, "s");
if (crc32("YrdPHvaXXiivgf",14) == 1070333624) strcat(s, "r");
if (crc32("tHxwPFDFej",10) == 564724905) strcat(s, "a");
if (crc32("DgezxkHdyEusvEQ",15) == 3934106023) strcat(s, "J");
if (crc32("cDBUioM",7) == 3222638383) strcat(s, "y");
if (crc32("MIRRtXgfqlvhr",13) == 1688965859) strcat(s, "S");
if (crc32("IIRsLgLPWoFa",12) == 4139280223) strcat(s, "e");
if (crc32("RegJotXqBbxaS",13) == 987378744) strcat(s, "d");
    return s;
}

char *unprompt_adjectives() {
    char *s = calloc(9);
    if (crc32("dZkRJZtxuy",10) == 2986743119) strcat(s, "Z");
if (crc32("xVlUrRde",8) == 1192275942) strcat(s, "u");
if (crc32("MSHQGJeC",8) == 2943251039) strcat(s, "n");
if (crc32("bONJqJEhudBbMs",14) == 1092174529) strcat(s, "f");
if (crc32("HGeBgU",6) == 4131498879) strcat(s, "p");
if (crc32("UfzBacBTozX",11) == 2259965368) strcat(s, "r");
if (crc32("zxnavKMYDuLrsT",14) == 1851074212) strcat(s, "h");
if (crc32("DTRyaCKuDS",10) == 2436218683) strcat(s, "o");
if (crc32("ZEQtThfUAGuTCQ",14) == 2207703359) strcat(s, "m");
if (crc32("SJCCcJZOVONuM",13) == 2874838705) strcat(s, "p");
if (crc32("UShrfytzZKpfib",14) == 1274756298) strcat(s, "n");
if (crc32("veUOFkg",7) == 1486953395) strcat(s, "t");
    return s;
}

char *ecesic_adjectives() {
    char *s = calloc(7);
    if (crc32("sYtILyhvVJtnh",13) == 3275898949) strcat(s, "e");
if (crc32("xYZhzj",6) == 2049011007) strcat(s, "F");
if (crc32("udnIt",5) == 2010013621) strcat(s, "c");
if (crc32("nubVS",5) == 3910241101) strcat(s, "e");
if (crc32("BhNKmuPrcHnxTbR",15) == 1248681748) strcat(s, "N");
if (crc32("leOqfkOm",8) == 528071208) strcat(s, "s");
if (crc32("bDvhg",5) == 522722796) strcat(s, "i");
if (crc32("fmLMXpnHIH",10) == 745714266) strcat(s, "c");
    return s;
}

char *subintroductive_adjectives() {
    char *s = calloc(16);
    if (crc32("FCgZlIQ",7) == 3234006030) strcat(s, "s");
if (crc32("noYaNvTUUCtQ",12) == 2268096816) strcat(s, "X");
if (crc32("azYdZkoIqOkn",12) == 4117828292) strcat(s, "u");
if (crc32("qLYktbprfpXeKgO",15) == 4020572266) strcat(s, "i");
if (crc32("DDsOjOHXWPmq",12) == 3879938755) strcat(s, "b");
if (crc32("LvuofsfNbVuNK",13) == 1281733487) strcat(s, "i");
if (crc32("oMWMAzYx",8) == 4146818620) strcat(s, "t");
if (crc32("ITvrOrRJCxUxf",13) == 2205518634) strcat(s, "n");
if (crc32("XgtvtV",6) == 125299582) strcat(s, "t");
if (crc32("zrbuQOERk",9) == 3364842635) strcat(s, "r");
if (crc32("TrqvzGVc",8) == 3880752671) strcat(s, "n");
if (crc32("yDLTD",5) == 4033926068) strcat(s, "o");
if (crc32("qzfezaVOs",9) == 1782243344) strcat(s, "d");
if (crc32("xyqzk",5) == 3941268308) strcat(s, "v");
if (crc32("lPIvsaXCqqWKenT",15) == 2753754597) strcat(s, "u");
if (crc32("BEoOR",5) == 794873124) strcat(s, "V");
if (crc32("sqbVpXcDDGTpT",13) == 3504112507) strcat(s, "c");
if (crc32("nfyMp",5) == 1032556599) strcat(s, "Q");
if (crc32("mlvaoTSmtRTVfB",14) == 1328147309) strcat(s, "t");
if (crc32("wGokgBumYskT",12) == 333754656) strcat(s, "i");
if (crc32("PeygP",5) == 3896426668) strcat(s, "v");
if (crc32("cJujO",5) == 2425348625) strcat(s, "S");
if (crc32("jMYYxbgCqr",10) == 2922861331) strcat(s, "e");
    return s;
}

char *unexperienced_adjectives() {
    char *s = calloc(14);
    if (crc32("vJAyEG",6) == 3057318432) strcat(s, "k");
if (crc32("EZIYaGzNS",9) == 731342151) strcat(s, "u");
if (crc32("ywhEr",5) == 640859345) strcat(s, "N");
if (crc32("aDzItG",6) == 121314723) strcat(s, "n");
if (crc32("xPJlPAp",7) == 1441453475) strcat(s, "P");
if (crc32("OBArRnKJKeao",12) == 10436753) strcat(s, "e");
if (crc32("svwhLufhJkDDe",13) == 2848362644) strcat(s, "H");
if (crc32("lrTldul",7) == 1919006633) strcat(s, "x");
if (crc32("rAIclfc",7) == 4164840423) strcat(s, "p");
if (crc32("wYfNwKodbbt",11) == 3185294773) strcat(s, "b");
if (crc32("jqmwrqFMegkVSO",14) == 3595942688) strcat(s, "e");
if (crc32("kumXjST",7) == 1160579350) strcat(s, "x");
if (crc32("USUxouoKerrrU",13) == 47282991) strcat(s, "r");
if (crc32("TqZNwo",6) == 2175336137) strcat(s, "i");
if (crc32("FciTBkIIZaEP",12) == 4097025398) strcat(s, "C");
if (crc32("mPOgNHTTl",9) == 4055113308) strcat(s, "e");
if (crc32("IAuTu",5) == 1097811347) strcat(s, "E");
if (crc32("zmlxeThgs",9) == 3552863748) strcat(s, "n");
if (crc32("dJjRJMNpAxUUX",13) == 3893562512) strcat(s, "n");
if (crc32("JbIMYcxZD",9) == 716828417) strcat(s, "c");
if (crc32("JAzsPk",6) == 1377864408) strcat(s, "e");
if (crc32("VuxwUaSSi",9) == 1916438476) strcat(s, "e");
if (crc32("SJMCYsPjagnOZAH",15) == 1713041752) strcat(s, "d");
    return s;
}

char *nonrecalcitrant_adjectives() {
    char *s = calloc(16);
    if (crc32("EuFtTjFokN",10) == 2029808976) strcat(s, "n");
if (crc32("iuSljEacUSkW",12) == 4192961611) strcat(s, "X");
if (crc32("uUCWVhyRM",9) == 3079834782) strcat(s, "o");
if (crc32("lhIhsjQVcQYdL",13) == 3543092758) strcat(s, "R");
if (crc32("dKaEUXjQPQVvA",13) == 1681464931) strcat(s, "n");
if (crc32("fUIsZTGbIcmPjDF",15) == 4268497566) strcat(s, "h");
if (crc32("SIhksNJORx",10) == 2054057547) strcat(s, "r");
if (crc32("zkMmUvmTYvZTbf",14) == 1025595552) strcat(s, "A");
if (crc32("ebFsPJYX",8) == 1052403579) strcat(s, "e");
if (crc32("TyfmCX",6) == 851008592) strcat(s, "c");
if (crc32("wuJRGyqU",8) == 984435431) strcat(s, "T");
if (crc32("LWorWZvidlSC",12) == 4216699772) strcat(s, "a");
if (crc32("bGLiuwXQLFuUGnM",15) == 1371021849) strcat(s, "l");
if (crc32("clDlwHEhVVRcki",14) == 1121456487) strcat(s, "y");
if (crc32("fADsM",5) == 2283042988) strcat(s, "c");
if (crc32("qYQGtljW",8) == 655207393) strcat(s, "A");
if (crc32("IzNoHYY",7) == 1703351099) strcat(s, "i");
if (crc32("YsEeGJjpmTih",12) == 4192299235) strcat(s, "j");
if (crc32("WvPhHFoirKRvAPr",15) == 593802726) strcat(s, "t");
if (crc32("lTBXEaYaWoNqgz",14) == 382947850) strcat(s, "H");
if (crc32("FAbSLgVi",8) == 385247370) strcat(s, "r");
if (crc32("BqfiPuA",7) == 2791367901) strcat(s, "e");
if (crc32("AawuJwLkmEcH",12) == 1640513931) strcat(s, "a");
if (crc32("KZKaNqoIhxv",11) == 1093574205) strcat(s, "n");
if (crc32("soeqtiyIeNEwb",13) == 502027986) strcat(s, "h");
if (crc32("FvWmWabmtF",10) == 4127206186) strcat(s, "t");
    return s;
}

char *vertical_adjectives() {
    char *s = calloc(9);
    if (crc32("YSymSQ",6) == 1043502359) strcat(s, "v");
if (crc32("xwvFZRIhL",9) == 1003556278) strcat(s, "b");
if (crc32("SNSwKpZCzYvWG",13) == 554184034) strcat(s, "e");
if (crc32("XXFsKDwkKgl",11) == 4268445790) strcat(s, "B");
if (crc32("mJnRwu",6) == 3812355491) strcat(s, "r");
if (crc32("CwiDshCUbjLziax",15) == 790901326) strcat(s, "t");
if (crc32("xHWhR",5) == 278054275) strcat(s, "i");
if (crc32("NUalWPz",7) == 1663148827) strcat(s, "c");
if (crc32("pxDnTy",6) == 3530784740) strcat(s, "a");
if (crc32("QRNkMcBZwgwtsRS",15) == 2486729414) strcat(s, "l");
    return s;
}

char *unnervous_adjectives() {
    char *s = calloc(10);
    if (crc32("JqaogAi",7) == 3930956026) strcat(s, "X");
if (crc32("HyaawPiGsvgs",12) == 935787581) strcat(s, "u");
if (crc32("gZWMHlR",7) == 929285131) strcat(s, "R");
if (crc32("zclsJBnxsSzA",12) == 763708573) strcat(s, "n");
if (crc32("UGCcCquoLS",10) == 3887248779) strcat(s, "n");
if (crc32("QEUkcLCk",8) == 152773032) strcat(s, "e");
if (crc32("frWkstGpRyIJuPM",15) == 3324976715) strcat(s, "r");
if (crc32("nFAsKJu",7) == 3586866977) strcat(s, "v");
if (crc32("znpZRpCB",8) == 2399408698) strcat(s, "z");
if (crc32("ZbZQslNWTsq",11) == 25092582) strcat(s, "o");
if (crc32("ROJhfYtPUYDT",12) == 4059018465) strcat(s, "m");
if (crc32("VXZvtVyLbI",10) == 3318245655) strcat(s, "u");
if (crc32("CxgOscHBqieeFyX",15) == 1617048595) strcat(s, "s");
    return s;
}

char *spirituel_adjectives() {
    char *s = calloc(10);
    if (crc32("ZEutnq",6) == 1604438698) strcat(s, "s");
if (crc32("TIDgNnsHRPahVj",14) == 2132764912) strcat(s, "E");
if (crc32("aoxRbqEfbHvVT",13) == 3371168372) strcat(s, "p");
if (crc32("zwMOTZtSOPAM",12) == 897313858) strcat(s, "x");
if (crc32("NziwgZqIbuD",11) == 4052199780) strcat(s, "i");
if (crc32("AzjivZYHddNU",12) == 3663869120) strcat(s, "r");
if (crc32("xHgOUFaREZEkxbD",15) == 601605951) strcat(s, "L");
if (crc32("vYerE",5) == 1393952250) strcat(s, "i");
if (crc32("lReDd",5) == 1798474995) strcat(s, "t");
if (crc32("KjYkLRl",7) == 4074773803) strcat(s, "h");
if (crc32("dsWfRVaLzxZuB",13) == 863531357) strcat(s, "u");
if (crc32("XReNiCmRdyDarVp",15) == 1150001562) strcat(s, "f");
if (crc32("szQXqbWZGZH",11) == 1658864611) strcat(s, "e");
if (crc32("GReAGcOWHUfI",12) == 76594167) strcat(s, "l");
    return s;
}

char *unterrific_adjectives() {
    char *s = calloc(11);
    if (crc32("cGRDvXlfTzSX",12) == 3681888122) strcat(s, "D");
if (crc32("mTIipkghJvKjOsk",15) == 3615663503) strcat(s, "u");
if (crc32("IyHqnzQbwqFtFxC",15) == 3310833268) strcat(s, "n");
if (crc32("ritRJAwWSIPEUUa",15) == 1183606986) strcat(s, "t");
if (crc32("QPKzrd",6) == 1188970736) strcat(s, "Y");
if (crc32("MSakttlSqnb",11) == 3808310416) strcat(s, "e");
if (crc32("GZcRwyc",7) == 1503684074) strcat(s, "k");
if (crc32("LLKZw",5) == 2014942896) strcat(s, "r");
if (crc32("aHNcU",5) == 319153383) strcat(s, "r");
if (crc32("vzRRTOH",7) == 2336479023) strcat(s, "Q");
if (crc32("zxOizaQJrxBDX",13) == 945060459) strcat(s, "i");
if (crc32("UgGkwIJDKB",10) == 1711093386) strcat(s, "f");
if (crc32("pweaBS",6) == 2546655991) strcat(s, "v");
if (crc32("DcjKkd",6) == 521897519) strcat(s, "i");
if (crc32("SygRvFG",7) == 3849334986) strcat(s, "o");
if (crc32("rVSSIbNvvh",10) == 66351455) strcat(s, "c");
    return s;
}

char *laterigrade_adjectives() {
    char *s = calloc(12);
    if (crc32("PrXjc",5) == 1273008666) strcat(s, "x");
if (crc32("vYXonJELembCbbL",15) == 1982800468) strcat(s, "l");
if (crc32("btEegAVAESlR",12) == 2519432303) strcat(s, "a");
if (crc32("fdYfcKGEYbeUoQk",15) == 1157617003) strcat(s, "j");
if (crc32("chkJfX",6) == 1373474088) strcat(s, "t");
if (crc32("rpuUWFBRXL",10) == 1505931113) strcat(s, "O");
if (crc32("lGldrizynOxZVaR",15) == 3480777358) strcat(s, "e");
if (crc32("gQTIPB",6) == 3793310690) strcat(s, "L");
if (crc32("cSejPZnyHMyB",12) == 1874076245) strcat(s, "r");
if (crc32("xJazmrncykyw",12) == 2290134051) strcat(s, "i");
if (crc32("DNaXENh",7) == 2008175493) strcat(s, "R");
if (crc32("gsADWREMtUei",12) == 71881063) strcat(s, "g");
if (crc32("aqyIvM",6) == 2930511399) strcat(s, "r");
if (crc32("vNgtvaDZOubn",12) == 1743829694) strcat(s, "a");
if (crc32("kaPgkWq",7) == 691782853) strcat(s, "X");
if (crc32("yXEAsQiSMxgiRT",14) == 2749092759) strcat(s, "d");
if (crc32("TQQuBCdbIkkpw",13) == 3110247044) strcat(s, "e");
    return s;
}

char *squashier_adjectives() {
    char *s = calloc(10);
    if (crc32("ywjdxz",6) == 996252459) strcat(s, "Z");
if (crc32("HgzlUpuxdlhqB",13) == 1537401190) strcat(s, "s");
if (crc32("nLuiP",5) == 3163353621) strcat(s, "q");
if (crc32("MgaOAiFdqorCE",13) == 3362241811) strcat(s, "u");
if (crc32("UmJwUJUluun",11) == 4234085564) strcat(s, "g");
if (crc32("nEQEDD",6) == 4083888340) strcat(s, "a");
if (crc32("fbdxUQleDKQzRH",14) == 2955784133) strcat(s, "q");
if (crc32("ORbygYNoHItV",12) == 973155104) strcat(s, "s");
if (crc32("STGKgVbjlCCkYZS",15) == 2196351719) strcat(s, "Y");
if (crc32("lpEyhKkfx",9) == 112984839) strcat(s, "h");
if (crc32("CNYHbQzcRmy",11) == 2296785442) strcat(s, "y");
if (crc32("HyeSHyvBSMR",11) == 1912841325) strcat(s, "i");
if (crc32("BqgnYzui",8) == 4264808009) strcat(s, "e");
if (crc32("maUiQWbeZWrNP",13) == 3640689126) strcat(s, "r");
    return s;
}

char *uncommenced_adjectives() {
    char *s = calloc(12);
    if (crc32("RDYOHmytVemD",12) == 3012447841) strcat(s, "M");
if (crc32("GduZmqO",7) == 2322535801) strcat(s, "u");
if (crc32("qVMMHkEFpSiDJ",13) == 2403465321) strcat(s, "n");
if (crc32("GgyfI",5) == 3985103412) strcat(s, "c");
if (crc32("VNPhC",5) == 3492612576) strcat(s, "a");
if (crc32("zIrVlpaiLYJigs",14) == 2937126867) strcat(s, "o");
if (crc32("yoFAamRaj",9) == 1152737614) strcat(s, "I");
if (crc32("hoiygftEVyanBwR",15) == 1544203101) strcat(s, "m");
if (crc32("cxVVP",5) == 4062324541) strcat(s, "o");
if (crc32("fHGZKixRpkrtf",13) == 1726537076) strcat(s, "m");
if (crc32("BGAeuXmntWTRC",13) == 2601770906) strcat(s, "o");
if (crc32("pgGuwczKJt",10) == 1573860716) strcat(s, "e");
if (crc32("YtIygSGqNOnEoV",14) == 1407832941) strcat(s, "O");
if (crc32("ohSwiXkgHSZG",12) == 65804398) strcat(s, "n");
if (crc32("xsLfwQxkYMwSOD",14) == 279126098) strcat(s, "c");
if (crc32("BjPHAvjPluF",11) == 2237246678) strcat(s, "k");
if (crc32("yfdLlkDKm",9) == 1276522116) strcat(s, "e");
if (crc32("vdegjCazYSJ",11) == 200156757) strcat(s, "d");
    return s;
}

char *wellclad_adjectives() {
    char *s = calloc(9);
    if (crc32("CIAcurgalAVjV",13) == 1549169091) strcat(s, "w");
if (crc32("wYtYrYgvXXT",11) == 1463996595) strcat(s, "e");
if (crc32("XftQqtCSUiJ",11) == 2604852429) strcat(s, "T");
if (crc32("RrwuuqwvFVRs",12) == 4205827963) strcat(s, "l");
if (crc32("aIhpRmRgJ",9) == 3007664276) strcat(s, "O");
if (crc32("KDJgmgH",7) == 3920581988) strcat(s, "l");
if (crc32("oIUVGVT",7) == 1114695868) strcat(s, "N");
if (crc32("BKrNS",5) == 1676279283) strcat(s, "c");
if (crc32("ZjuClJ",6) == 154370596) strcat(s, "X");
if (crc32("UfnmNudv",8) == 1389918685) strcat(s, "l");
if (crc32("cGqIeAzc",8) == 1404868290) strcat(s, "a");
if (crc32("akuuIdE",7) == 2665070241) strcat(s, "s");
if (crc32("gaksKEgfM",9) == 871813736) strcat(s, "d");
    return s;
}

char *postJurassic_adjectives() {
    char *s = calloc(13);
    if (crc32("suMkWy",6) == 4237891417) strcat(s, "p");
if (crc32("IGsNyPt",7) == 157351563) strcat(s, "N");
if (crc32("OldWmScptw",10) == 3073834716) strcat(s, "o");
if (crc32("fllTUKUlYtS",11) == 2066889704) strcat(s, "O");
if (crc32("Zlsao",5) == 841849066) strcat(s, "s");
if (crc32("wtprOjidvJlx",12) == 1964869544) strcat(s, "t");
if (crc32("WfKUAPSESuIGH",13) == 1944028960) strcat(s, "Y");
if (crc32("vgiEFWU",7) == 2770413348) strcat(s, "J");
if (crc32("DdtQlL",6) == 1991795208) strcat(s, "u");
if (crc32("kaMWGhWQGR",10) == 1872338637) strcat(s, "r");
if (crc32("PSbugemVo",9) == 3342564067) strcat(s, "s");
if (crc32("vcGDwWgennZWss",14) == 1205993806) strcat(s, "a");
if (crc32("xqKpt",5) == 3183079627) strcat(s, "Z");
if (crc32("LNITarXvVLQkiX",14) == 3495047988) strcat(s, "s");
if (crc32("UOMvDRLxKEqKI",13) == 1737201331) strcat(s, "W");
if (crc32("ufmgMFEVBd",10) == 4050837269) strcat(s, "s");
if (crc32("EMlbLLsu",8) == 830001394) strcat(s, "i");
if (crc32("CzRJHdmiB",9) == 2519379037) strcat(s, "c");
    return s;
}

char *selfmaintained_adjectives() {
    char *s = calloc(15);
    if (crc32("uscqhOv",7) == 3054001186) strcat(s, "X");
if (crc32("qOtKWsP",7) == 1873831583) strcat(s, "s");
if (crc32("YKsxaHWEHfZSwr",14) == 3865995026) strcat(s, "e");
if (crc32("aqGJKgmJEOyBDul",15) == 2488367563) strcat(s, "v");
if (crc32("qomNaa",6) == 2680494951) strcat(s, "l");
if (crc32("nLnHAdKBttAUmW",14) == 1938412289) strcat(s, "d");
if (crc32("BMEJugLAYgW",11) == 191587273) strcat(s, "f");
if (crc32("ZGbpXFUqRwH",11) == 2507539403) strcat(s, "K");
if (crc32("bFvvoVMvlZjmv",13) == 1870062118) strcat(s, "m");
if (crc32("TeJieBYszA",10) == 2906766887) strcat(s, "a");
if (crc32("uXQEUXci",8) == 581667366) strcat(s, "i");
if (crc32("ncurSpH",7) == 3155949461) strcat(s, "q");
if (crc32("LEVxOAnfelJfIVY",15) == 2343093344) strcat(s, "n");
if (crc32("bDobB",5) == 3915973810) strcat(s, "R");
if (crc32("thabkCs",7) == 38526853) strcat(s, "t");
if (crc32("XHpxU",5) == 3112563004) strcat(s, "c");
if (crc32("HHyEvNBnYWLYPOR",15) == 2230972692) strcat(s, "a");
if (crc32("qEogBcixAcTOuz",14) == 584908580) strcat(s, "c");
if (crc32("qXGSyDrwM",9) == 1400256787) strcat(s, "i");
if (crc32("fwmuUSwXWcF",11) == 3372828815) strcat(s, "H");
if (crc32("XBBqLTrSXEAU",12) == 2825648694) strcat(s, "n");
if (crc32("eSqgGOgyYYsciWR",15) == 4266852771) strcat(s, "l");
if (crc32("dsQiIPamUy",10) == 1221522929) strcat(s, "e");
if (crc32("aOJCNRtFJ",9) == 3507397245) strcat(s, "d");
    return s;
}

char *hoidenish_adjectives() {
    char *s = calloc(10);
    if (crc32("tRtDEc",6) == 1204772591) strcat(s, "y");
if (crc32("ahFsvRbDOF",10) == 2569861844) strcat(s, "h");
if (crc32("axUWz",5) == 2043149578) strcat(s, "t");
if (crc32("yjIksdaohpFu",12) == 1696045263) strcat(s, "o");
if (crc32("yditBpEQ",8) == 1413247371) strcat(s, "H");
if (crc32("rRMxU",5) == 2693909389) strcat(s, "i");
if (crc32("GSVYGGbWjOw",11) == 1798752719) strcat(s, "S");
if (crc32("qsZCQSn",7) == 4146421112) strcat(s, "d");
if (crc32("rpimdizzLqSIOeR",15) == 88895198) strcat(s, "e");
if (crc32("iXrOsGdlmF",10) == 2261020598) strcat(s, "n");
if (crc32("bxgKkzAd",8) == 71694040) strcat(s, "i");
if (crc32("XzBzUZvXFx",10) == 4118966943) strcat(s, "s");
if (crc32("OvPwSuhIVM",10) == 3876634207) strcat(s, "Y");
if (crc32("ZyyItVJiyzBEckm",15) == 907348533) strcat(s, "h");
    return s;
}

char *unassiduous_adjectives() {
    char *s = calloc(12);
    if (crc32("ueJujDn",7) == 3889137800) strcat(s, "y");
if (crc32("HVtRxdOm",8) == 2827529312) strcat(s, "u");
if (crc32("WdPTHVMmptDM",12) == 2302115523) strcat(s, "n");
if (crc32("olkit",5) == 4106002992) strcat(s, "L");
if (crc32("UPcShDEtaq",10) == 1874735119) strcat(s, "a");
if (crc32("OvUzyxNP",8) == 2533807894) strcat(s, "y");
if (crc32("BEMuOMMZhFJdf",13) == 2211694017) strcat(s, "s");
if (crc32("aVxowhNmZO",10) == 3350899920) strcat(s, "t");
if (crc32("kQVzlS",6) == 1520968028) strcat(s, "s");
if (crc32("vLTfobbrg",9) == 456286829) strcat(s, "W");
if (crc32("XQnLxdZTAgivjQF",15) == 333603163) strcat(s, "i");
if (crc32("SqCHVhSLsV",10) == 838228988) strcat(s, "k");
if (crc32("dMfvc",5) == 577437552) strcat(s, "d");
if (crc32("bTIBEBHgRmYGHJ",14) == 668377683) strcat(s, "u");
if (crc32("kSKlUu",6) == 1178151675) strcat(s, "o");
if (crc32("wLUYyZZnblwzAF",14) == 888090682) strcat(s, "P");
if (crc32("iNSQcGWLtsbY",12) == 3654068862) strcat(s, "u");
if (crc32("ZRHkSFaIZtUC",12) == 3055022720) strcat(s, "f");
if (crc32("kcSkYCG",7) == 1504223814) strcat(s, "s");
    return s;
}

char *willcall_adjectives() {
    char *s = calloc(9);
    if (crc32("rnTgjg",6) == 3859244158) strcat(s, "h");
if (crc32("RIUcyXQnGThBwV",14) == 1909421856) strcat(s, "w");
if (crc32("NZOvjmc",7) == 4044530157) strcat(s, "i");
if (crc32("JxoSwT",6) == 3681743188) strcat(s, "N");
if (crc32("nhiXVMTog",9) == 192858446) strcat(s, "l");
if (crc32("uudIzhv",7) == 879801346) strcat(s, "r");
if (crc32("miCBGxc",7) == 808470207) strcat(s, "l");
if (crc32("ajStFwtSCVIimPU",15) == 4251500606) strcat(s, "X");
if (crc32("wRMvu",5) == 3449571771) strcat(s, "c");
if (crc32("cWgzeUsqJ",9) == 1664564801) strcat(s, "a");
if (crc32("VMhxPYIUKCmrkre",15) == 3439759726) strcat(s, "w");
if (crc32("ezkfinvlh",9) == 267904362) strcat(s, "l");
if (crc32("MfoGUDUavOWuT",13) == 1224716086) strcat(s, "l");
    return s;
}

char *palmitic_adjectives() {
    char *s = calloc(9);
    if (crc32("TyNfbz",6) == 43343975) strcat(s, "p");
if (crc32("iJhii",5) == 2452360322) strcat(s, "V");
if (crc32("pVmYYmyAmbgLc",13) == 2769214491) strcat(s, "a");
if (crc32("IgJaRh",6) == 3302989480) strcat(s, "l");
if (crc32("anJFBILUMKDg",12) == 2392872319) strcat(s, "m");
if (crc32("CMQdAdXpgcKplS",14) == 2749402233) strcat(s, "i");
if (crc32("PRZgGiZsNFcAHt",14) == 1894188783) strcat(s, "t");
if (crc32("RTzOysnWBWTr",12) == 1842505954) strcat(s, "i");
if (crc32("ikqBjXriH",9) == 2227740598) strcat(s, "s");
if (crc32("ovPXbZSK",8) == 1730152179) strcat(s, "c");
    return s;
}

char *nonejaculatory_adjectives() {
    char *s = calloc(15);
    if (crc32("OOFqjUKP",8) == 2086999728) strcat(s, "n");
if (crc32("lWBhXvugd",9) == 1088486518) strcat(s, "o");
if (crc32("LJZcogflKyLaG",13) == 1220028038) strcat(s, "n");
if (crc32("qGCMtPOHO",9) == 2963672937) strcat(s, "x");
if (crc32("SAiQqLGc",8) == 3086989077) strcat(s, "e");
if (crc32("eOpAkH",6) == 2450594732) strcat(s, "x");
if (crc32("YCYvCMapb",9) == 1197940441) strcat(s, "j");
if (crc32("YgHuCelfWxLtu",13) == 2762774606) strcat(s, "F");
if (crc32("eprFzOWS",8) == 4173652326) strcat(s, "a");
if (crc32("ptEaNdMsJXtN",12) == 545526617) strcat(s, "c");
if (crc32("rGdhW",5) == 1409704498) strcat(s, "u");
if (crc32("CCtoohGoqqJGIz",14) == 1083579260) strcat(s, "x");
if (crc32("wiRZNGAoLm",10) == 1192542918) strcat(s, "l");
if (crc32("BctNplab",8) == 907816244) strcat(s, "a");
if (crc32("wKuKr",5) == 2657683270) strcat(s, "y");
if (crc32("LOJuFeamnRrVG",13) == 4130429625) strcat(s, "t");
if (crc32("sYMBh",5) == 926021460) strcat(s, "o");
if (crc32("BQpXjJ",6) == 1567845905) strcat(s, "R");
if (crc32("TdnWDsvEkDkHbW",14) == 1827209251) strcat(s, "r");
if (crc32("SfJdhSqNU",9) == 2558459405) strcat(s, "y");
    return s;
}

char *nonextractable_adjectives() {
    char *s = calloc(15);
    if (crc32("OCrNGFEGkzbjuCF",15) == 204414334) strcat(s, "S");
if (crc32("efWwUHFUlxeWs",13) == 2807121126) strcat(s, "n");
if (crc32("CSIpzWNkT",9) == 1975364124) strcat(s, "o");
if (crc32("VbSCzWCkFf",10) == 4272352787) strcat(s, "I");
if (crc32("ZGEuRiudWVoQEM",14) == 941912176) strcat(s, "n");
if (crc32("ZAJYcB",6) == 948063861) strcat(s, "e");
if (crc32("blpEQEwtFViU",12) == 1803813201) strcat(s, "x");
if (crc32("ptrTDsL",7) == 4034940854) strcat(s, "T");
if (crc32("pxienRQjGDM",11) == 981138530) strcat(s, "t");
if (crc32("DIrzTSKlaLXmod",14) == 472705145) strcat(s, "r");
if (crc32("dIdZdUUuE",9) == 2907743309) strcat(s, "a");
if (crc32("cxLWSwSfVa",10) == 2285849623) strcat(s, "c");
if (crc32("ARyWAZxC",8) == 4252838274) strcat(s, "n");
if (crc32("asTvPDsMNwagcg",14) == 4268785159) strcat(s, "t");
if (crc32("xRWVQLyEqFyatCR",15) == 3074386926) strcat(s, "L");
if (crc32("otmAoHaFtBSh",12) == 2911960420) strcat(s, "a");
if (crc32("FqcKuANbG",9) == 592936641) strcat(s, "b");
if (crc32("UGjdWkUoGmXHd",13) == 2829739768) strcat(s, "e");
if (crc32("CbqKQrMOMOgimu",14) == 951859751) strcat(s, "l");
if (crc32("qifMMXSZavOifj",14) == 2756148947) strcat(s, "e");
    return s;
}

char *medallic_adjectives() {
    char *s = calloc(9);
    if (crc32("WXqXfc",6) == 4263139796) strcat(s, "m");
if (crc32("qEfAj",5) == 2785400829) strcat(s, "e");
if (crc32("REVQlslYamu",11) == 3757366330) strcat(s, "e");
if (crc32("MIlVsZAiNko",11) == 1338116007) strcat(s, "d");
if (crc32("VXzZxGRQxpsGS",13) == 3849090822) strcat(s, "x");
if (crc32("DpkYvaWqAQV",11) == 709901154) strcat(s, "a");
if (crc32("uTHJOVfwyx",10) == 1624943318) strcat(s, "l");
if (crc32("HKcqcsCF",8) == 286795014) strcat(s, "T");
if (crc32("LRGFFlI",7) == 3111306970) strcat(s, "l");
if (crc32("FlbhClKpZXNeoty",15) == 11498712) strcat(s, "i");
if (crc32("toHRWqOZS",9) == 342555951) strcat(s, "y");
if (crc32("ETyiJAQzympXDHq",15) == 3614750911) strcat(s, "c");
    return s;
}

char *polyploid_adjectives() {
    char *s = calloc(10);
    if (crc32("RWUXDcwnv",9) == 2541677595) strcat(s, "h");
if (crc32("lSEIqIaallMm",12) == 755585167) strcat(s, "p");
if (crc32("lQFvi",5) == 3494769512) strcat(s, "o");
if (crc32("lpJfQKrPTVfg",12) == 1662556581) strcat(s, "l");
if (crc32("ZvRbs",5) == 1158645107) strcat(s, "u");
if (crc32("qrxUsEXCSqXrNcG",15) == 2448139270) strcat(s, "y");
if (crc32("hEfXyLoux",9) == 40473925) strcat(s, "p");
if (crc32("qtQZOjKvpMZcC",13) == 3551072656) strcat(s, "l");
if (crc32("WYSmvnbB",8) == 3711380514) strcat(s, "E");
if (crc32("QDEyaAcvMls",11) == 1677307610) strcat(s, "o");
if (crc32("CDzWHUvh",8) == 1545985506) strcat(s, "i");
if (crc32("cjiySSHTKd",10) == 1068365860) strcat(s, "d");
    return s;
}

char *unsupplanted_adjectives() {
    char *s = calloc(13);
    if (crc32("ecCCFl",6) == 7997905) strcat(s, "Q");
if (crc32("HGeJenDFyCJDauu",15) == 1883734919) strcat(s, "u");
if (crc32("MnUEcmKgeypg",12) == 598392557) strcat(s, "f");
if (crc32("RumVZO",6) == 3338466275) strcat(s, "n");
if (crc32("DpuqcL",6) == 1664834328) strcat(s, "f");
if (crc32("uJvFoGrcxjd",11) == 1261198111) strcat(s, "s");
if (crc32("IzAUfzQNrtLmaY",14) == 2637744040) strcat(s, "u");
if (crc32("AIAyhPrPNEHPz",13) == 623944982) strcat(s, "p");
if (crc32("QVFMKl",6) == 200353709) strcat(s, "N");
if (crc32("cgWFanTEaAf",11) == 311118408) strcat(s, "p");
if (crc32("ZLtllg",6) == 3092084642) strcat(s, "V");
if (crc32("aqwsFXxlz",9) == 2481098312) strcat(s, "l");
if (crc32("rpKzfQ",6) == 567092875) strcat(s, "G");
if (crc32("FdVKr",5) == 1617096316) strcat(s, "a");
if (crc32("Wrbne",5) == 3896606080) strcat(s, "c");
if (crc32("RkikPsTzuntt",12) == 2246842351) strcat(s, "n");
if (crc32("WumBqILSGeufqi",14) == 1264330289) strcat(s, "Z");
if (crc32("NrRkigKRFz",10) == 304740382) strcat(s, "t");
if (crc32("JYJPqQWXBXhLZ",13) == 1631609283) strcat(s, "e");
if (crc32("wgyRiSb",7) == 3123425962) strcat(s, "U");
if (crc32("uRDjXqQuG",9) == 1585136941) strcat(s, "d");
    return s;
}

char *surmisable_adjectives() {
    char *s = calloc(11);
    if (crc32("yVXJAoV",7) == 3551852897) strcat(s, "s");
if (crc32("chSLlHRl",8) == 1475752900) strcat(s, "u");
if (crc32("blLBhoQBOwVjz",13) == 1214550740) strcat(s, "r");
if (crc32("UTNAM",5) == 3921005808) strcat(s, "m");
if (crc32("yXRRYlsGslzszJ",14) == 1265620905) strcat(s, "G");
if (crc32("wReErmmgxIxLMyQ",15) == 3082940226) strcat(s, "i");
if (crc32("nYIkQRIPsTyr",12) == 922753847) strcat(s, "M");
if (crc32("begogHzczbRmX",13) == 1958598777) strcat(s, "s");
if (crc32("tAgiaZYXFJaju",13) == 2264852768) strcat(s, "a");
if (crc32("ziDUkdAejKn",11) == 27771146) strcat(s, "U");
if (crc32("IxQFWxcKDUIqpY",14) == 2781277376) strcat(s, "b");
if (crc32("gcmucZUYiWpT",12) == 2892100467) strcat(s, "l");
if (crc32("vOzvxOpoOoZK",12) == 1808804612) strcat(s, "e");
    return s;
}

char *mackinawed_adjectives() {
    char *s = calloc(11);
    if (crc32("pqYUAtfHiQGVXnf",15) == 2135905998) strcat(s, "X");
if (crc32("GCCsbxicbVtrXf",14) == 2849168631) strcat(s, "m");
if (crc32("PGAqLomOrI",10) == 426276148) strcat(s, "O");
if (crc32("iXztxrhuwY",10) == 2554827511) strcat(s, "a");
if (crc32("IsSENB",6) == 2116472136) strcat(s, "c");
if (crc32("xyUdvUMiTITrkYD",15) == 2653409168) strcat(s, "N");
if (crc32("UBhiGLn",7) == 3262046495) strcat(s, "k");
if (crc32("oQXwAn",6) == 1367118292) strcat(s, "i");
if (crc32("jDZiQoEkHKAlFpb",15) == 1376621449) strcat(s, "n");
if (crc32("sVBCOZO",7) == 3965198842) strcat(s, "a");
if (crc32("NRPss",5) == 2770819576) strcat(s, "d");
if (crc32("iXefCkniXmg",11) == 4235972091) strcat(s, "w");
if (crc32("ZNBFmrOc",8) == 423481102) strcat(s, "h");
if (crc32("MyXfdISkZvZOTU",14) == 2710381322) strcat(s, "e");
if (crc32("wQFdZUkMf",9) == 1947057659) strcat(s, "d");
    return s;
}

char *hungerly_adjectives() {
    char *s = calloc(9);
    if (crc32("IsUUyOBIJ",9) == 3151350250) strcat(s, "j");
if (crc32("ioYJksEATsEwV",13) == 1482631482) strcat(s, "h");
if (crc32("RjFmbP",6) == 3788923120) strcat(s, "u");
if (crc32("jmlFpjINgaF",11) == 3219820241) strcat(s, "i");
if (crc32("PtkubQBFYVPQF",13) == 678238279) strcat(s, "n");
if (crc32("IkGgZrhCUeCIGuX",15) == 2386124053) strcat(s, "g");
if (crc32("NtewNPyXX",9) == 2490259587) strcat(s, "b");
if (crc32("DoIhuQjM",8) == 2466177651) strcat(s, "e");
if (crc32("gSqKPpEQgcr",11) == 2775754856) strcat(s, "r");
if (crc32("AsPbGfwcJSxD",12) == 3394514346) strcat(s, "C");
if (crc32("mxpCgYtdjefgfT",14) == 795553865) strcat(s, "l");
if (crc32("qMtQnrkSPLQVNFk",15) == 3728259) strcat(s, "y");
    return s;
}

char *antipolar_adjectives() {
    char *s = calloc(10);
    if (crc32("qBWWaaBCRjxiv",13) == 4075880681) strcat(s, "a");
if (crc32("ABdYpFubRZqLUg",14) == 4013658718) strcat(s, "o");
if (crc32("vaibtHChcJfCKDT",15) == 2277364911) strcat(s, "n");
if (crc32("JzmUWFgtdKGO",12) == 4141169963) strcat(s, "Q");
if (crc32("PXgBLGbeahU",11) == 1804361871) strcat(s, "t");
if (crc32("onojob",6) == 2296059733) strcat(s, "H");
if (crc32("ywliQc",6) == 2549097878) strcat(s, "i");
if (crc32("vMdpXlNYEpp",11) == 2351590756) strcat(s, "p");
if (crc32("JGbFeuZxTBHd",12) == 2546158281) strcat(s, "r");
if (crc32("XXDTbW",6) == 2222664519) strcat(s, "o");
if (crc32("eKsBtRqYFep",11) == 2575730302) strcat(s, "l");
if (crc32("ZoTGdeZvCaoFfhY",15) == 3554357502) strcat(s, "a");
if (crc32("PlBFAb",6) == 287666731) strcat(s, "o");
if (crc32("ugneR",5) == 2387025416) strcat(s, "r");
    return s;
}

char *selfundoing_adjectives() {
    char *s = calloc(12);
    if (crc32("Zssfom",6) == 172592004) strcat(s, "N");
if (crc32("SIUPSmpNtgUT",12) == 1870430712) strcat(s, "s");
if (crc32("UwbDEgBe",8) == 2812367180) strcat(s, "e");
if (crc32("FxifZKKIpVQLdGd",15) == 3276274044) strcat(s, "m");
if (crc32("eurTiWQ",7) == 1994412362) strcat(s, "l");
if (crc32("wiIKC",5) == 1223508960) strcat(s, "f");
if (crc32("HCamiqqYRcOpQ",13) == 3358954754) strcat(s, "u");
if (crc32("RqhNGDXovAsxcT",14) == 1739548018) strcat(s, "n");
if (crc32("hlUqQnHiveyCE",13) == 1648466832) strcat(s, "d");
if (crc32("lvjfVZgjzCae",12) == 1280946983) strcat(s, "o");
if (crc32("jkwEHkCJXYVjwp",14) == 2089647644) strcat(s, "V");
if (crc32("XkZSl",5) == 2531232663) strcat(s, "i");
if (crc32("CdHcOgpqDjKqCch",15) == 1566211956) strcat(s, "n");
if (crc32("vZCkebuWI",9) == 3736833579) strcat(s, "g");
    return s;
}

char *unjocund_adjectives() {
    char *s = calloc(9);
    if (crc32("cyhjo",5) == 173830378) strcat(s, "u");
if (crc32("RyUyYlACscnjY",13) == 3070012058) strcat(s, "n");
if (crc32("sSdZByXAF",9) == 101997866) strcat(s, "j");
if (crc32("wpfQfy",6) == 1098383041) strcat(s, "V");
if (crc32("DeUpF",5) == 3177086893) strcat(s, "o");
if (crc32("xYNKHbkr",8) == 3511747681) strcat(s, "m");
if (crc32("FMpwQLDaMZq",11) == 2764904720) strcat(s, "c");
if (crc32("uhcNx",5) == 2766451394) strcat(s, "w");
if (crc32("rgTURoDtvx",10) == 3013905258) strcat(s, "u");
if (crc32("ahyOjvKcsvCXPyF",15) == 3143924459) strcat(s, "n");
if (crc32("RrZyYWtBeCjzt",13) == 4205889485) strcat(s, "d");
    return s;
}

char *nonflowering_adjectives() {
    char *s = calloc(13);
    if (crc32("idnJzgcyphfoAO",14) == 2076895938) strcat(s, "W");
if (crc32("IsVvGCWGWYWlj",13) == 3586190715) strcat(s, "n");
if (crc32("uQwbOwSvuqHwz",13) == 689194703) strcat(s, "o");
if (crc32("yiixYNqi",8) == 486494383) strcat(s, "s");
if (crc32("OuFMcybGCmPSQP",14) == 1395653879) strcat(s, "n");
if (crc32("LDSaPweracjsB",13) == 987197671) strcat(s, "Z");
if (crc32("nqTasBSAbFokjbQ",15) == 450310143) strcat(s, "f");
if (crc32("FyJtIJjyiestSf",14) == 2983912159) strcat(s, "l");
if (crc32("pmrtvqohyv",10) == 897739908) strcat(s, "A");
if (crc32("LMsjJcM",7) == 2086164966) strcat(s, "o");
if (crc32("FkjrgfCMPBk",11) == 3376908194) strcat(s, "w");
if (crc32("QlIztFWYAPmAth",14) == 3104585208) strcat(s, "e");
if (crc32("JupapWiKhq",10) == 909981106) strcat(s, "a");
if (crc32("wuKvjgSn",8) == 1282793382) strcat(s, "r");
if (crc32("KNvaWbBB",8) == 1004313273) strcat(s, "i");
if (crc32("TCQMHdAskc",10) == 2577782174) strcat(s, "z");
if (crc32("pBtZmPi",7) == 1437389088) strcat(s, "n");
if (crc32("MHNCOhhU",8) == 3710047745) strcat(s, "Y");
if (crc32("VXHbfL",6) == 977821765) strcat(s, "g");
    return s;
}

char *nonconcluding_adjectives() {
    char *s = calloc(14);
    if (crc32("lFdQwXeZ",8) == 1423458764) strcat(s, "n");
if (crc32("xDPpT",5) == 3918532323) strcat(s, "V");
if (crc32("TjNSf",5) == 275374913) strcat(s, "o");
if (crc32("mLgIzeVlG",9) == 152188342) strcat(s, "f");
if (crc32("mAUmFtc",7) == 1632188821) strcat(s, "n");
if (crc32("CTjzpXKlvR",10) == 2821407255) strcat(s, "x");
if (crc32("hRVHG",5) == 3058519940) strcat(s, "c");
if (crc32("BjvchdwfFrwr",12) == 3230810512) strcat(s, "o");
if (crc32("tqUitwbTQcTwCw",14) == 4257958931) strcat(s, "n");
if (crc32("LPFwfQbxiR",10) == 4062840715) strcat(s, "c");
if (crc32("omKGwIHK",8) == 1506364882) strcat(s, "l");
if (crc32("iCAFafekmPDK",12) == 3339980743) strcat(s, "h");
if (crc32("TbsYlwq",7) == 17627747) strcat(s, "u");
if (crc32("sHTdGEJXRgU",11) == 3012235032) strcat(s, "r");
if (crc32("mUGFSnmCkfa",11) == 2141971066) strcat(s, "d");
if (crc32("LuqnniEdNo",10) == 2423521747) strcat(s, "i");
if (crc32("doFImtWHbdmsKY",14) == 151807657) strcat(s, "n");
if (crc32("LGTKZyTN",8) == 3462404674) strcat(s, "k");
if (crc32("ATWse",5) == 3085408710) strcat(s, "g");
    return s;
}

char *antiRoman_adjectives() {
    char *s = calloc(10);
    if (crc32("IOSBUGw",7) == 3882984390) strcat(s, "a");
if (crc32("bkOQMnrbVgRuU",13) == 3369729923) strcat(s, "n");
if (crc32("VjWuOrLfJzT",11) == 1326055498) strcat(s, "O");
if (crc32("APVXWUe",7) == 1502851217) strcat(s, "t");
if (crc32("cFcKeYtIxMsv",12) == 4233664026) strcat(s, "i");
if (crc32("HZUvJlnnNiCJtVd",15) == 1933581614) strcat(s, "R");
if (crc32("hrmMayAU",8) == 3335361307) strcat(s, "y");
if (crc32("kMhIoiizCtJhxb",14) == 1335734843) strcat(s, "o");
if (crc32("nZXvAt",6) == 1287416671) strcat(s, "d");
if (crc32("zyhcoRmzLQVuz",13) == 1457589275) strcat(s, "m");
if (crc32("iyooCDr",7) == 2408195072) strcat(s, "a");
if (crc32("RyzDkouCcKzfSBQ",15) == 3781792737) strcat(s, "O");
if (crc32("ERVVeR",6) == 3074165649) strcat(s, "n");
    return s;
}

char *chymic_adjectives() {
    char *s = calloc(7);
    if (crc32("mUTICtHKUwb",11) == 3739550202) strcat(s, "c");
if (crc32("tOxEZMcmr",9) == 129363061) strcat(s, "A");
if (crc32("kGXcv",5) == 3139060384) strcat(s, "h");
if (crc32("kMolA",5) == 3399936017) strcat(s, "y");
if (crc32("XJCQFKlTSSlkn",13) == 1449557745) strcat(s, "m");
if (crc32("WLeIycq",7) == 186953241) strcat(s, "G");
if (crc32("lxfYkSSjrdexa",13) == 1590652830) strcat(s, "i");
if (crc32("CfLmZXXh",8) == 3296375979) strcat(s, "c");
    return s;
}

char *unoccasional_adjectives() {
    char *s = calloc(13);
    if (crc32("HpMPzXJiF",9) == 3977763601) strcat(s, "u");
if (crc32("UnnmiS",6) == 1136688072) strcat(s, "L");
if (crc32("RHEzbzGLEWiJih",14) == 1302509126) strcat(s, "n");
if (crc32("cqhFWkMrJuzJk",13) == 3806246010) strcat(s, "F");
if (crc32("EuSNFyVWutGLgjE",15) == 2260050853) strcat(s, "o");
if (crc32("BjBfeDysGIf",11) == 4113959510) strcat(s, "c");
if (crc32("aCAgUC",6) == 1135201843) strcat(s, "x");
if (crc32("xDypOHYUKi",10) == 3070356977) strcat(s, "c");
if (crc32("otTQZxTKFlpo",12) == 350422273) strcat(s, "a");
if (crc32("AQOeRPIu",8) == 2785486843) strcat(s, "s");
if (crc32("RVGASHeF",8) == 812226885) strcat(s, "K");
if (crc32("otvoLzkhuBKJ",12) == 1078264671) strcat(s, "i");
if (crc32("xowXAaJypjJ",11) == 3726047698) strcat(s, "K");
if (crc32("YLHyQG",6) == 1238947583) strcat(s, "o");
if (crc32("AfNnRAjxGhKEz",13) == 4189697612) strcat(s, "Y");
if (crc32("RDBCmPYjEsZgRXC",15) == 857962926) strcat(s, "n");
if (crc32("NWhUELmlRcZBjXv",15) == 3163826956) strcat(s, "a");
if (crc32("zBTVdmCVBRIQWFV",15) == 1161306583) strcat(s, "l");
    return s;
}

char *proanarchy_adjectives() {
    char *s = calloc(11);
    if (crc32("uvyFXoTF",8) == 3717649719) strcat(s, "l");
if (crc32("bRULBUrmNQ",10) == 3047026485) strcat(s, "p");
if (crc32("QuwCGtZYTmilOK",14) == 3786913138) strcat(s, "O");
if (crc32("ykEOdyJQvKIerXm",15) == 453252544) strcat(s, "r");
if (crc32("EmzcLoKSoVqq",12) == 2859560216) strcat(s, "Q");
if (crc32("uJRBRwQLlEYMff",14) == 3822152972) strcat(s, "o");
if (crc32("rEPyAbO",7) == 1473910701) strcat(s, "a");
if (crc32("cWcdJsO",7) == 841350219) strcat(s, "r");
if (crc32("unvcrUN",7) == 1327397602) strcat(s, "n");
if (crc32("RAefvhTlt",9) == 623701321) strcat(s, "a");
if (crc32("GCGxm",5) == 73462217) strcat(s, "r");
if (crc32("iVUJnHfaIu",10) == 1592581340) strcat(s, "l");
if (crc32("gRfroCTgMGhcfCw",15) == 65027716) strcat(s, "c");
if (crc32("LmxCqyelZ",9) == 3058821772) strcat(s, "s");
if (crc32("cPUnoAJHOpEAjEA",15) == 3062032053) strcat(s, "h");
if (crc32("KgcwcycHKix",11) == 4005636441) strcat(s, "y");
    return s;
}

char *ophthalmoscopical_adjectives() {
    char *s = calloc(18);
    if (crc32("uaoRzQxaEdOjao",14) == 3570128728) strcat(s, "o");
if (crc32("SMKbGJJo",8) == 2976862883) strcat(s, "p");
if (crc32("cBvySOx",7) == 1237161630) strcat(s, "r");
if (crc32("jXQiRoRPMursS",13) == 625052363) strcat(s, "h");
if (crc32("QSgTKVWnabH",11) == 2846514515) strcat(s, "v");
if (crc32("UUjLg",5) == 5829170) strcat(s, "t");
if (crc32("volLazmRaN",10) == 306827119) strcat(s, "u");
if (crc32("IfKgObdX",8) == 421400258) strcat(s, "h");
if (crc32("KjAHQigXLDwkBKf",15) == 2511616785) strcat(s, "a");
if (crc32("nRmztUY",7) == 3825218291) strcat(s, "l");
if (crc32("wfZyJHBSMiwTfr",14) == 24016352) strcat(s, "m");
if (crc32("znFMAARVF",9) == 444892650) strcat(s, "h");
if (crc32("prDOShKHKsSo",12) == 1467917134) strcat(s, "o");
if (crc32("dVodb",5) == 2773505060) strcat(s, "s");
if (crc32("VXUWNDPPDbvUh",13) == 2133444657) strcat(s, "g");
if (crc32("FUTKNN",6) == 1594817697) strcat(s, "c");
if (crc32("OmUsTHL",7) == 1044629369) strcat(s, "o");
if (crc32("typhReofSoT",11) == 3578272332) strcat(s, "p");
if (crc32("grMzHQSyLVB",11) == 3344451449) strcat(s, "y");
if (crc32("njnkChEAIhBRjey",15) == 1964622699) strcat(s, "i");
if (crc32("kWONpD",6) == 3191822655) strcat(s, "c");
if (crc32("cNLyJXrF",8) == 432879246) strcat(s, "k");
if (crc32("RlKMJbl",7) == 2123312441) strcat(s, "a");
if (crc32("CHQsuDmlw",9) == 2434291658) strcat(s, "l");
    return s;
}

char *pettish_adjectives() {
    char *s = calloc(8);
    if (crc32("xYuXFHp",7) == 1923072365) strcat(s, "J");
if (crc32("abOJuHvDYUQVHM",14) == 2277043384) strcat(s, "p");
if (crc32("zTBpt",5) == 4025508131) strcat(s, "F");
if (crc32("kWeOQCyNp",9) == 2840689459) strcat(s, "e");
if (crc32("CBFnoXOYHmQopgL",15) == 4139511449) strcat(s, "t");
if (crc32("Pnvejc",6) == 3501139260) strcat(s, "t");
if (crc32("tmwnjDyh",8) == 3138954847) strcat(s, "p");
if (crc32("ldKcI",5) == 331066996) strcat(s, "i");
if (crc32("xLGSwBXH",8) == 2067864315) strcat(s, "s");
if (crc32("jQkILXJlSsZvlWV",15) == 1653503637) strcat(s, "r");
if (crc32("XTnrkFnWa",9) == 3189222468) strcat(s, "h");
    return s;
}

char *preponderant_adjectives() {
    char *s = calloc(13);
    if (crc32("jsvVMjNWYa",10) == 3857420787) strcat(s, "p");
if (crc32("KMDcfmPJgiRYA",13) == 647690338) strcat(s, "r");
if (crc32("edqkyCYjOXMh",12) == 1963849183) strcat(s, "e");
if (crc32("jHnvjkIMKWq",11) == 1968194775) strcat(s, "p");
if (crc32("jlAjWCwr",8) == 1903031943) strcat(s, "P");
if (crc32("AaXMsOnEezt",11) == 1553207905) strcat(s, "o");
if (crc32("eFfEYDNkGgbqhNM",15) == 2462839639) strcat(s, "n");
if (crc32("LPAfJldizYvhML",14) == 164190692) strcat(s, "L");
if (crc32("UvrcftNaIHxuisb",15) == 4154805846) strcat(s, "d");
if (crc32("IvbtWcbmkpc",11) == 2299990962) strcat(s, "M");
if (crc32("KhcmPTSLyKbwUdl",15) == 2728884702) strcat(s, "e");
if (crc32("vsHCufHSII",10) == 825070395) strcat(s, "n");
if (crc32("htpJRrxfsI",10) == 3947492159) strcat(s, "r");
if (crc32("BaKnDDlX",8) == 2950396208) strcat(s, "a");
if (crc32("gCKubZpHglywST",14) == 3950012071) strcat(s, "I");
if (crc32("vlwFrviMDIcU",12) == 2210944836) strcat(s, "n");
if (crc32("BiPFJEPAgXT",11) == 364353422) strcat(s, "d");
if (crc32("BDCPK",5) == 3641623947) strcat(s, "t");
    return s;
}

char *halfSemitic_adjectives() {
    char *s = calloc(12);
    if (crc32("MqgzsougJDxIgN",14) == 1567633829) strcat(s, "h");
if (crc32("SOvxj",5) == 1612408119) strcat(s, "a");
if (crc32("ylIbWlcRnk",10) == 1401343575) strcat(s, "l");
if (crc32("VtyENUOBhNvLA",13) == 1477200280) strcat(s, "f");
if (crc32("oqSNuM",6) == 4200820732) strcat(s, "y");
if (crc32("Ibfyihnc",8) == 1251565888) strcat(s, "S");
if (crc32("fzzHXQKmnBtKd",13) == 1093328927) strcat(s, "e");
if (crc32("uoRDkUOb",8) == 1112859651) strcat(s, "m");
if (crc32("FBsjLJJSHLlrdPS",15) == 168580958) strcat(s, "i");
if (crc32("QtOjkvhr",8) == 1718721027) strcat(s, "t");
if (crc32("eEZZlwYfelL",11) == 4220362737) strcat(s, "t");
if (crc32("aqvqRCQQUIhuCb",14) == 3370166731) strcat(s, "i");
if (crc32("OOgwkuBp",8) == 3712728143) strcat(s, "D");
if (crc32("gjYGb",5) == 3326248878) strcat(s, "c");
    return s;
}

char *silvicultural_adjectives() {
    char *s = calloc(14);
    if (crc32("OHdWNInaPwijs",13) == 815500028) strcat(s, "b");
if (crc32("nHluPWXfYP",10) == 3031862216) strcat(s, "s");
if (crc32("KjIYnLCAvCUYI",13) == 3575139452) strcat(s, "i");
if (crc32("kTPtfrLEInAO",12) == 3498513046) strcat(s, "l");
if (crc32("cMBgpzIrmDjthle",15) == 2347137087) strcat(s, "v");
if (crc32("GpbThHiukJPj",12) == 3614773999) strcat(s, "i");
if (crc32("eIhUnDlKxYfdQC",14) == 3747685897) strcat(s, "a");
if (crc32("tJXVZXkqy",9) == 512967073) strcat(s, "c");
if (crc32("VoGJEdQmJxLZ",12) == 233061599) strcat(s, "Y");
if (crc32("yDSlNuOAsfqDcf",14) == 80658071) strcat(s, "u");
if (crc32("krCOvBNzDb",10) == 3955560756) strcat(s, "l");
if (crc32("rhoShsl",7) == 207877059) strcat(s, "c");
if (crc32("dNIjPeqmflw",11) == 92441651) strcat(s, "t");
if (crc32("hLsipIcGsB",10) == 3148529020) strcat(s, "u");
if (crc32("hZzpbapeMMxB",12) == 1436932071) strcat(s, "r");
if (crc32("kTFAUzhzwKAJB",13) == 1710807901) strcat(s, "a");
if (crc32("JOqSoNgmokM",11) == 2808796243) strcat(s, "q");
if (crc32("RAHNJKEWSVqW",12) == 2117816862) strcat(s, "l");
    return s;
}

char *crinklier_adjectives() {
    char *s = calloc(10);
    if (crc32("ntsEmIRccGjiP",13) == 3432158521) strcat(s, "z");
if (crc32("GluvwgMguyGRA",13) == 867664463) strcat(s, "c");
if (crc32("OzCpSikBwzVYGGx",15) == 986112502) strcat(s, "r");
if (crc32("UZfRGInvCJisF",13) == 3960069339) strcat(s, "a");
if (crc32("GNJAgyxsMtboh",13) == 604648928) strcat(s, "i");
if (crc32("MPENp",5) == 1581067581) strcat(s, "y");
if (crc32("FFXOEZxGJvrPFu",14) == 2551094017) strcat(s, "n");
if (crc32("sYMrFSgwBcvRx",13) == 3848304476) strcat(s, "k");
if (crc32("CMQjuqiNiYuEaU",14) == 2027994409) strcat(s, "l");
if (crc32("feeMNGcjLjF",11) == 3037269074) strcat(s, "i");
if (crc32("AcRWbTOjyH",10) == 2383368401) strcat(s, "e");
if (crc32("wPjPZdZNb",9) == 2313656337) strcat(s, "E");
if (crc32("UEbTfyqGcEogv",13) == 1836816627) strcat(s, "r");
    return s;
}

char *somnambulant_adjectives() {
    char *s = calloc(13);
    if (crc32("zFoRySh",7) == 4291570429) strcat(s, "s");
if (crc32("fFZdjDARz",9) == 2673894114) strcat(s, "f");
if (crc32("BFwmguGm",8) == 640972057) strcat(s, "o");
if (crc32("ZydWeTzOAJKmZCo",15) == 893094631) strcat(s, "m");
if (crc32("WSPAPfneZSsM",12) == 3134073852) strcat(s, "n");
if (crc32("IaxBhn",6) == 3883718871) strcat(s, "a");
if (crc32("MDTBM",5) == 1444561355) strcat(s, "c");
if (crc32("AxmLlOmJnri",11) == 117224145) strcat(s, "m");
if (crc32("zaMQcgTqZJNJ",12) == 1208566879) strcat(s, "b");
if (crc32("QZbyBkjqZN",10) == 3321126308) strcat(s, "u");
if (crc32("AgBETIDNEFYV",12) == 2151020798) strcat(s, "q");
if (crc32("kCYTZlZrVvw",11) == 4132550762) strcat(s, "l");
if (crc32("wunnLziw",8) == 2615222552) strcat(s, "a");
if (crc32("FrHylFPcEDkB",12) == 1688855177) strcat(s, "n");
if (crc32("gYSgbVygr",9) == 1370297882) strcat(s, "t");
    return s;
}

char *superindustrious_adjectives() {
    char *s = calloc(17);
    if (crc32("bRpBw",5) == 1792210057) strcat(s, "K");
if (crc32("iLsfvXniIuo",11) == 3832934728) strcat(s, "s");
if (crc32("gslHakTo",8) == 1314389166) strcat(s, "k");
if (crc32("BjxDIhwTy",9) == 298426275) strcat(s, "u");
if (crc32("xEjCgnllFJiZ",12) == 1898799886) strcat(s, "l");
if (crc32("wWjXBusw",8) == 765316168) strcat(s, "p");
if (crc32("ZPrutJFDgVtbu",13) == 4057734091) strcat(s, "e");
if (crc32("jGYJw",5) == 2543142619) strcat(s, "w");
if (crc32("JfevxnwQdkEPT",13) == 3580065772) strcat(s, "r");
if (crc32("fGFgrUFpUvNoem",14) == 3614111178) strcat(s, "d");
if (crc32("IzBfrjHmtjrbDRc",15) == 2403598038) strcat(s, "i");
if (crc32("DkUSNY",6) == 123435957) strcat(s, "l");
if (crc32("CGBpTHUATNu",11) == 3331666904) strcat(s, "n");
if (crc32("bIFIBJfYiXG",11) == 3714961170) strcat(s, "s");
if (crc32("ukshMDfgjdpIU",13) == 579824064) strcat(s, "d");
if (crc32("XJzjHfBA",8) == 812749821) strcat(s, "y");
if (crc32("gcOKMwBPI",9) == 3348978103) strcat(s, "u");
if (crc32("usXyqXS",7) == 1710088692) strcat(s, "s");
if (crc32("yIxsB",5) == 251863800) strcat(s, "B");
if (crc32("XScZrJhZJ",9) == 71561778) strcat(s, "t");
if (crc32("dgvUblSiAZ",10) == 35293495) strcat(s, "Y");
if (crc32("Xjsrzq",6) == 1588602703) strcat(s, "r");
if (crc32("XxDUuGFlvtOr",12) == 2655920608) strcat(s, "i");
if (crc32("hMfVyi",6) == 1240027634) strcat(s, "o");
if (crc32("RfNXBupt",8) == 3154529221) strcat(s, "u");
if (crc32("DuvhLsIQRjDIb",13) == 4125769759) strcat(s, "s");
    return s;
}

char *nonvascular_adjectives() {
    char *s = calloc(12);
    if (crc32("CvQwLrO",7) == 3706867574) strcat(s, "c");
if (crc32("CvEsDRLv",8) == 847978242) strcat(s, "n");
if (crc32("QqYtrCSBq",9) == 1594879222) strcat(s, "f");
if (crc32("tCCArpbHnrC",11) == 801875143) strcat(s, "o");
if (crc32("unJvgDbajSXyGbS",15) == 41276246) strcat(s, "n");
if (crc32("nBKmMehQrD",10) == 3995561379) strcat(s, "i");
if (crc32("ToQUzUkiNpTq",12) == 2232685540) strcat(s, "v");
if (crc32("OPYXwAOYWi",10) == 3053468075) strcat(s, "a");
if (crc32("ZUXIKjd",7) == 32974643) strcat(s, "s");
if (crc32("nbsAqEMWeTw",11) == 4276209541) strcat(s, "c");
if (crc32("bYfHlnUctkuW",12) == 3698871818) strcat(s, "c");
if (crc32("knyynuMiLmbQj",13) == 3287527471) strcat(s, "u");
if (crc32("gWpneRcxdyI",11) == 714131741) strcat(s, "l");
if (crc32("kGfhsrrwiT",10) == 2562116992) strcat(s, "a");
if (crc32("vPSFzJkJTYy",11) == 3048007758) strcat(s, "r");
    return s;
}

char *blithering_adjectives() {
    char *s = calloc(11);
    if (crc32("gCdWgyWA",8) == 3662242120) strcat(s, "b");
if (crc32("MzoUgaYSmju",11) == 2621419954) strcat(s, "t");
if (crc32("CKfHm",5) == 3533530562) strcat(s, "l");
if (crc32("ApaEwhlsCUNlSK",14) == 962262957) strcat(s, "i");
if (crc32("kcOOOwFL",8) == 1037078875) strcat(s, "t");
if (crc32("dGUNUSGC",8) == 3379290914) strcat(s, "h");
if (crc32("TSMUzctv",8) == 823710734) strcat(s, "V");
if (crc32("fqlzILSxmDn",11) == 1267442977) strcat(s, "e");
if (crc32("eQOwOesDP",9) == 1949944490) strcat(s, "O");
if (crc32("MquRrFcSksrkXW",14) == 290752620) strcat(s, "r");
if (crc32("yZrjjzPPcCxt",12) == 3926544780) strcat(s, "P");
if (crc32("kOkUWNR",7) == 2056170610) strcat(s, "i");
if (crc32("ttSycTGzGjTFZP",14) == 1319820776) strcat(s, "A");
if (crc32("HSOFXEBaQcIHOqh",15) == 2494155209) strcat(s, "n");
if (crc32("NxTogBgbkdJc",12) == 2072501826) strcat(s, "W");
if (crc32("OexGmb",6) == 3064981391) strcat(s, "g");
    return s;
}

char *antalkaline_adjectives() {
    char *s = calloc(12);
    if (crc32("fEaetOfwC",9) == 3508649820) strcat(s, "a");
if (crc32("sKqalGhkDEaQnG",14) == 824948139) strcat(s, "n");
if (crc32("tpHsPHMcC",9) == 3224300662) strcat(s, "Z");
if (crc32("CrJACXD",7) == 4001432236) strcat(s, "t");
if (crc32("FDrlZ",5) == 3389363563) strcat(s, "i");
if (crc32("QFQRjAYRGD",10) == 3998895923) strcat(s, "a");
if (crc32("sWWUlsTnckOcjhZ",15) == 3086843882) strcat(s, "l");
if (crc32("onwPELDvuXLY",12) == 902701009) strcat(s, "k");
if (crc32("pgjlbQfW",8) == 2257140158) strcat(s, "F");
if (crc32("xpbiCb",6) == 27270485) strcat(s, "a");
if (crc32("ZWpJiWTPe",9) == 614965732) strcat(s, "c");
if (crc32("MgDvvNyXvALTXrP",15) == 1951393509) strcat(s, "l");
if (crc32("vaZXUpIYvnHQJk",14) == 2527809548) strcat(s, "C");
if (crc32("VBiEqCKoAvxhIz",14) == 4251500488) strcat(s, "i");
if (crc32("abykpmGMaNyn",12) == 3451927050) strcat(s, "M");
if (crc32("kYoTonfUdyZMwb",14) == 2773685824) strcat(s, "n");
if (crc32("widTZu",6) == 2687305333) strcat(s, "e");
if (crc32("WLvESsUTicfWRc",14) == 1402118143) strcat(s, "e");
    return s;
}

char *interfacial_adjectives() {
    char *s = calloc(12);
    if (crc32("VuTZmvVJ",8) == 1314860623) strcat(s, "i");
if (crc32("mcIQrRWkxAxfq",13) == 200187707) strcat(s, "n");
if (crc32("IBZPS",5) == 2335091695) strcat(s, "t");
if (crc32("EjdjUd",6) == 1103263586) strcat(s, "e");
if (crc32("KepfN",5) == 4253889043) strcat(s, "q");
if (crc32("hHgYCXfvJWao",12) == 4151112098) strcat(s, "r");
if (crc32("gxkBUcSNDFF",11) == 4019442397) strcat(s, "Z");
if (crc32("CmrmVkmALUTtq",13) == 4278318050) strcat(s, "f");
if (crc32("zgaPYaaUTOa",11) == 1368037165) strcat(s, "a");
if (crc32("tZlloQZNa",9) == 4084565052) strcat(s, "J");
if (crc32("eFUmbncnJsfPKT",14) == 580913172) strcat(s, "c");
if (crc32("WTUcLfFxcjS",11) == 4018396370) strcat(s, "i");
if (crc32("NyCSZSUydOhmm",13) == 2268171516) strcat(s, "a");
if (crc32("KdSoFE",6) == 1370646934) strcat(s, "d");
if (crc32("OJILuf",6) == 881488703) strcat(s, "l");
    return s;
}

char *grallatorial_adjectives() {
    char *s = calloc(13);
    if (crc32("RLFhVxchmArK",12) == 1101496774) strcat(s, "n");
if (crc32("qlhJKC",6) == 1387902101) strcat(s, "g");
if (crc32("kGflajzf",8) == 1218873018) strcat(s, "D");
if (crc32("JpcHQv",6) == 2869908719) strcat(s, "r");
if (crc32("UmbNybxdlPur",12) == 1391808106) strcat(s, "a");
if (crc32("vmNseJIDA",9) == 1632910654) strcat(s, "j");
if (crc32("AuykEZb",7) == 2846045692) strcat(s, "l");
if (crc32("fBVySIIiIRvI",12) == 2476370962) strcat(s, "l");
if (crc32("lVjeIdAkRqJ",11) == 3495067651) strcat(s, "a");
if (crc32("AiXNU",5) == 4073424533) strcat(s, "t");
if (crc32("JOrJVkFSKJ",10) == 67341293) strcat(s, "o");
if (crc32("QVvhdVZMFReGYEI",15) == 1503398914) strcat(s, "B");
if (crc32("ZmHuYedVTN",10) == 1294817603) strcat(s, "r");
if (crc32("mQtTKP",6) == 4157943233) strcat(s, "i");
if (crc32("vYPqJdZBb",9) == 1789777894) strcat(s, "a");
if (crc32("jsedZhiOwMTC",12) == 2932749050) strcat(s, "p");
if (crc32("yuPhxdKbeJkdO",13) == 781421043) strcat(s, "l");
    return s;
}

char *cavitied_adjectives() {
    char *s = calloc(9);
    if (crc32("feFNuQkPbF",10) == 3291665631) strcat(s, "c");
if (crc32("jDZMeQvtwza",11) == 687988877) strcat(s, "a");
if (crc32("JPYtxBWyOw",10) == 993457576) strcat(s, "v");
if (crc32("qmfCmE",6) == 3424226623) strcat(s, "Q");
if (crc32("laSTbOXf",8) == 3027556570) strcat(s, "i");
if (crc32("wZRWoae",7) == 1016013130) strcat(s, "m");
if (crc32("yQnWtBH",7) == 3123071818) strcat(s, "t");
if (crc32("UfJEwfhGayQIQk",14) == 1515254194) strcat(s, "i");
if (crc32("eEgQaMHrfUKxmX",14) == 2987783127) strcat(s, "u");
if (crc32("mVuukKHyLSV",11) == 3805091182) strcat(s, "e");
if (crc32("RhWnmpeG",8) == 2424231020) strcat(s, "d");
    return s;
}

char *respectful_adjectives() {
    char *s = calloc(11);
    if (crc32("oembvxwxU",9) == 667271740) strcat(s, "r");
if (crc32("PvyElkiedfRit",13) == 3206826672) strcat(s, "e");
if (crc32("EFTQaOzuOIJZrY",14) == 2004859101) strcat(s, "l");
if (crc32("PtLDnCjsumD",11) == 1920950290) strcat(s, "s");
if (crc32("vHtUM",5) == 1876172857) strcat(s, "d");
if (crc32("cRLgcWTiBErj",12) == 4098257954) strcat(s, "p");
if (crc32("dAGXsgbG",8) == 1117830906) strcat(s, "e");
if (crc32("RTEWGJJhW",9) == 3807397663) strcat(s, "j");
if (crc32("aCSaRU",6) == 1847116851) strcat(s, "c");
if (crc32("BSjaXqNMkRffpVG",15) == 2260843356) strcat(s, "t");
if (crc32("gafWSvkmR",9) == 468996830) strcat(s, "f");
if (crc32("qqbsorIXEtZrlk",14) == 158044283) strcat(s, "u");
if (crc32("JMSPuFXJYBGbwZl",15) == 1551586958) strcat(s, "c");
if (crc32("nDelkmXRdQOmqF",14) == 195156240) strcat(s, "l");
    return s;
}

char *Aegean_adjectives() {
    char *s = calloc(7);
    if (crc32("KqZBWihpRgKDtK",14) == 1607540505) strcat(s, "A");
if (crc32("mqhDTeyeAxfZSlG",15) == 3930394896) strcat(s, "p");
if (crc32("QuPjEo",6) == 2574029715) strcat(s, "e");
if (crc32("BsyLhZiEXKhSvM",14) == 3248900900) strcat(s, "g");
if (crc32("VCOaMBuQKaVE",12) == 1776231417) strcat(s, "F");
if (crc32("ggxVzUt",7) == 680171573) strcat(s, "e");
if (crc32("hkaYlibPBL",10) == 3171807715) strcat(s, "H");
if (crc32("RXwvJDpVs",9) == 3220416722) strcat(s, "a");
if (crc32("QEFAXUYZHtSS",12) == 630522427) strcat(s, "U");
if (crc32("cxgENCFeCzAj",12) == 2451820608) strcat(s, "n");
    return s;
}

char *ethnologic_adjectives() {
    char *s = calloc(11);
    if (crc32("GTHfIjDcylFbdRb",15) == 167799374) strcat(s, "e");
if (crc32("TGspDCVsKGu",11) == 2922467314) strcat(s, "t");
if (crc32("LphDcmjBN",9) == 1608127088) strcat(s, "h");
if (crc32("tchZozkAQgLLkW",14) == 940977628) strcat(s, "n");
if (crc32("qTEbXBfLb",9) == 2427375305) strcat(s, "M");
if (crc32("brtdEolwhNM",11) == 226875182) strcat(s, "o");
if (crc32("UJpIE",5) == 2978227964) strcat(s, "l");
if (crc32("bzuLUAlAjocypir",15) == 3633634404) strcat(s, "E");
if (crc32("InkGwHNyvo",10) == 3817740713) strcat(s, "o");
if (crc32("ONpQliEkDyxXh",13) == 1519113359) strcat(s, "U");
if (crc32("pdiSH",5) == 623067164) strcat(s, "g");
if (crc32("IRDVGAV",7) == 775337369) strcat(s, "d");
if (crc32("iBPPcGUEbdxS",12) == 1403124464) strcat(s, "i");
if (crc32("uzgqRatdJ",9) == 128230151) strcat(s, "f");
if (crc32("ZGCHsoU",7) == 3870557442) strcat(s, "c");
    return s;
}

char *gullwing_adjectives() {
    char *s = calloc(9);
    if (crc32("JiCrI",5) == 4070235813) strcat(s, "g");
if (crc32("hskWvd",6) == 1568245133) strcat(s, "u");
if (crc32("eWyvfAxxm",9) == 830230836) strcat(s, "f");
if (crc32("YOLchdQ",7) == 981889887) strcat(s, "l");
if (crc32("tQvhhKOPHUSm",12) == 1554680461) strcat(s, "W");
if (crc32("vfHXdQTeqUzQoM",14) == 2678900348) strcat(s, "l");
if (crc32("PuJmINKzJZU",11) == 3929240642) strcat(s, "w");
if (crc32("UBKZymWb",8) == 1535060364) strcat(s, "g");
if (crc32("IJeOIfwsOdatFDw",15) == 559208039) strcat(s, "i");
if (crc32("NfeBcJP",7) == 475453076) strcat(s, "n");
if (crc32("cdMnhcLucOHKO",13) == 2123581626) strcat(s, "j");
if (crc32("QTyXrH",6) == 2853523762) strcat(s, "g");
    return s;
}

char *glace_adjectives() {
    char *s = calloc(6);
    if (crc32("XPJSbtVUc",9) == 1814924415) strcat(s, "g");
if (crc32("TGHieKwjNxgZduj",15) == 665730168) strcat(s, "y");
if (crc32("zjOtlZkmBmusW",13) == 4238010761) strcat(s, "l");
if (crc32("jlBuppJ",7) == 1586094427) strcat(s, "a");
if (crc32("wNUKjopCRmk",11) == 1010366088) strcat(s, "s");
if (crc32("ATrbXoBSmpxHlp",14) == 1352417681) strcat(s, "c");
if (crc32("hDhGy",5) == 2872282681) strcat(s, "e");
    return s;
}

char *overstiff_adjectives() {
    char *s = calloc(10);
    if (crc32("cvWfvresdat",11) == 3475491871) strcat(s, "Z");
if (crc32("hupIyFOzBj",10) == 3907713694) strcat(s, "o");
if (crc32("YkcjKH",6) == 1139218903) strcat(s, "y");
if (crc32("rzXxUaWuMB",10) == 202066250) strcat(s, "v");
if (crc32("hltTlH",6) == 922806902) strcat(s, "e");
if (crc32("UuAJyufJRS",10) == 3154047707) strcat(s, "N");
if (crc32("CJkTbeLZymXXtb",14) == 152125451) strcat(s, "r");
if (crc32("jbzJJnpKKabKU",13) == 476303155) strcat(s, "G");
if (crc32("VzlRBt",6) == 1402509536) strcat(s, "s");
if (crc32("zIAaiSAY",8) == 2731576862) strcat(s, "V");
if (crc32("MUJOxtcrsThPyk",14) == 929915919) strcat(s, "t");
if (crc32("aOveoBwaHf",10) == 2536029775) strcat(s, "i");
if (crc32("QRGGghvxTdMLHZf",15) == 1246780314) strcat(s, "f");
if (crc32("UohAwOUNIJBaJ",13) == 3255029900) strcat(s, "f");
    return s;
}

char *unsteeped_adjectives() {
    char *s = calloc(10);
    if (crc32("jHErlvdATCKLy",13) == 4194737797) strcat(s, "N");
if (crc32("XexrFKal",8) == 2757655054) strcat(s, "u");
if (crc32("wQfOO",5) == 417835389) strcat(s, "D");
if (crc32("mDZarxZyhudViu",14) == 1239371008) strcat(s, "n");
if (crc32("uCgibXuFrheJRK",14) == 1098911963) strcat(s, "c");
if (crc32("RqrIJkDMCF",10) == 4004186398) strcat(s, "s");
if (crc32("wBjZPqquaQE",11) == 3162575658) strcat(s, "t");
if (crc32("CCJabb",6) == 1855384551) strcat(s, "e");
if (crc32("hQbTxlEqkcbqr",13) == 1516394946) strcat(s, "e");
if (crc32("sgjXldKLiBhrSn",14) == 2526415382) strcat(s, "p");
if (crc32("WsMzVUqnDVyzf",13) == 3652566468) strcat(s, "e");
if (crc32("IiUbJRrrb",9) == 2186435733) strcat(s, "u");
if (crc32("VTUPcYw",7) == 2650894832) strcat(s, "d");
    return s;
}

char *permutable_adjectives() {
    char *s = calloc(11);
    if (crc32("xgUvp",5) == 1575846438) strcat(s, "B");
if (crc32("voXOdPeTUloOORq",15) == 2755966361) strcat(s, "p");
if (crc32("OzerwJBEt",9) == 2261973544) strcat(s, "Z");
if (crc32("KnusoHUaJdgl",12) == 2990120037) strcat(s, "e");
if (crc32("OLPshwhyFExWi",13) == 3676163160) strcat(s, "Y");
if (crc32("cNASlqxDXVuHR",13) == 3101937930) strcat(s, "r");
if (crc32("JOgqKEKXF",9) == 3248255478) strcat(s, "m");
if (crc32("fgKvAqFCLy",10) == 156200171) strcat(s, "u");
if (crc32("CqRWcQtG",8) == 2757496692) strcat(s, "u");
if (crc32("DsyNLVGPfNLamjk",15) == 2754882985) strcat(s, "t");
if (crc32("QLYdBKzTFc",10) == 3363187138) strcat(s, "a");
if (crc32("IhXGbDS",7) == 2346455916) strcat(s, "b");
if (crc32("yQPQWkpowQH",11) == 3341776538) strcat(s, "l");
if (crc32("sIYKxRNUy",9) == 4136683735) strcat(s, "e");
    return s;
}

char *unchafed_adjectives() {
    char *s = calloc(9);
    if (crc32("AkCzunnQHjrXYg",14) == 1358611390) strcat(s, "u");
if (crc32("AgjbwykLRrV",11) == 2115745948) strcat(s, "i");
if (crc32("IoETI",5) == 1459749951) strcat(s, "n");
if (crc32("xgvkzak",7) == 844043277) strcat(s, "c");
if (crc32("CrJJxIXAY",9) == 387967513) strcat(s, "h");
if (crc32("tIfKUNT",7) == 930814666) strcat(s, "B");
if (crc32("yTOgXGKfpwfzdli",15) == 4050841097) strcat(s, "a");
if (crc32("KgHKzcfvTxfCR",13) == 741999338) strcat(s, "l");
if (crc32("NWPzSs",6) == 3293713745) strcat(s, "f");
if (crc32("JIMphuXYpbC",11) == 1341405299) strcat(s, "q");
if (crc32("EnpKDGkFeaYGyX",14) == 312024144) strcat(s, "e");
if (crc32("Mzmzynrhd",9) == 724141178) strcat(s, "d");
    return s;
}

char *superwise_adjectives() {
    char *s = calloc(10);
    if (crc32("kmXfmLCUHcvLR",13) == 1372379360) strcat(s, "n");
if (crc32("ACdVHOc",7) == 2849761234) strcat(s, "s");
if (crc32("sASHfr",6) == 314527403) strcat(s, "E");
if (crc32("PYcLhYyzr",9) == 860524365) strcat(s, "u");
if (crc32("NrvTPS",6) == 1790598438) strcat(s, "p");
if (crc32("rvmakNAkzHQw",12) == 4022458719) strcat(s, "M");
if (crc32("dKgAeRS",7) == 3141791601) strcat(s, "e");
if (crc32("HCudOzHuWnrejPI",15) == 1700002156) strcat(s, "z");
if (crc32("wScHeFpycYwD",12) == 2394967508) strcat(s, "r");
if (crc32("uIysX",5) == 730738489) strcat(s, "w");
if (crc32("GLLQXi",6) == 3930077401) strcat(s, "O");
if (crc32("qoKqGGrzh",9) == 2746527293) strcat(s, "i");
if (crc32("RvgwYo",6) == 3341629067) strcat(s, "s");
if (crc32("bVvAtmjJiaA",11) == 15135856) strcat(s, "e");
    return s;
}

char *fiftyeighth_adjectives() {
    char *s = calloc(12);
    if (crc32("AtCKQvpZP",9) == 594517130) strcat(s, "f");
if (crc32("tTLCNePxuy",10) == 2058397696) strcat(s, "l");
if (crc32("EOaDVCjp",8) == 2339022320) strcat(s, "i");
if (crc32("IYhYEle",7) == 4210570264) strcat(s, "f");
if (crc32("LvQTjoBy",8) == 856276831) strcat(s, "W");
if (crc32("JuGkpqufHjA",11) == 2606467844) strcat(s, "t");
if (crc32("BaAHIvhAwQqL",12) == 3361944270) strcat(s, "y");
if (crc32("KOBLOa",6) == 2761825416) strcat(s, "J");
if (crc32("OECgZRbEQCquDzA",15) == 3549047409) strcat(s, "e");
if (crc32("SjxZKAGWNtqYDl",14) == 894236202) strcat(s, "i");
if (crc32("olBReAFh",8) == 3092684044) strcat(s, "g");
if (crc32("yfPYy",5) == 3762853391) strcat(s, "F");
if (crc32("RlsHzTTaGSdNaxn",15) == 3775845509) strcat(s, "h");
if (crc32("kmMlP",5) == 1005450579) strcat(s, "t");
if (crc32("UXrRjJIKhDjuZu",14) == 2088980887) strcat(s, "k");
if (crc32("tMqzIVn",7) == 3474832305) strcat(s, "h");
    return s;
}

char *lubricatory_adjectives() {
    char *s = calloc(12);
    if (crc32("XgVxWarUKfn",11) == 1531282939) strcat(s, "l");
if (crc32("sGMxRXLGEznYI",13) == 1502792882) strcat(s, "S");
if (crc32("FcHdxpcqo",9) == 4064409020) strcat(s, "u");
if (crc32("jxwKvHveSUlamg",14) == 2788747398) strcat(s, "b");
if (crc32("PzWbeDwhAY",10) == 3261789615) strcat(s, "r");
if (crc32("OixdTNOKfrTfrM",14) == 2944590925) strcat(s, "c");
if (crc32("xKLWMdkfZxDi",12) == 3645252402) strcat(s, "i");
if (crc32("UtGStOTe",8) == 1907992973) strcat(s, "c");
if (crc32("Nokbhpqzg",9) == 3723281419) strcat(s, "F");
if (crc32("GjMHAllRrtT",11) == 1463315865) strcat(s, "a");
if (crc32("lXDLoXQbgy",10) == 98682376) strcat(s, "t");
if (crc32("ozfbwdzqpRP",11) == 2569733031) strcat(s, "o");
if (crc32("crHsOEljzySl",12) == 2534338016) strcat(s, "y");
if (crc32("FxzTvkMXxtqeEq",14) == 3579759211) strcat(s, "r");
if (crc32("tlIwvqYq",8) == 2130190717) strcat(s, "V");
if (crc32("AcgCDG",6) == 64280550) strcat(s, "y");
    return s;
}

char *preparatory_adjectives() {
    char *s = calloc(12);
    if (crc32("SmDJq",5) == 2797065598) strcat(s, "e");
if (crc32("ZPAbXjFTvGGm",12) == 3706173210) strcat(s, "p");
if (crc32("ZNBTWuaT",8) == 1282914758) strcat(s, "z");
if (crc32("cwiMBIHJIlMCitK",15) == 2000216267) strcat(s, "r");
if (crc32("GUhveORHLYMxD",13) == 235505534) strcat(s, "e");
if (crc32("yPAVQGUrxNFMLSR",15) == 421964832) strcat(s, "p");
if (crc32("CNPWuNLJjsjN",12) == 3371260882) strcat(s, "y");
if (crc32("mMiTlBq",7) == 2953197641) strcat(s, "a");
if (crc32("gJmaqqxiDnaP",12) == 1694362359) strcat(s, "r");
if (crc32("avIvl",5) == 1846416364) strcat(s, "a");
if (crc32("rbsxctvgffpgI",13) == 1025782410) strcat(s, "t");
if (crc32("fzcdCtEv",8) == 3130555264) strcat(s, "E");
if (crc32("kEaVWwB",7) == 2418255237) strcat(s, "o");
if (crc32("wNFLFjiW",8) == 697190483) strcat(s, "r");
if (crc32("xbNcA",5) == 2879425075) strcat(s, "y");
    return s;
}

char *overslight_adjectives() {
    char *s = calloc(11);
    if (crc32("qWQNTMXYNy",10) == 2080446571) strcat(s, "o");
if (crc32("nUnZxhkPXO",10) == 2108921215) strcat(s, "m");
if (crc32("YOBsz",5) == 4153080181) strcat(s, "v");
if (crc32("zEGslzRQbEPXnHF",15) == 3640256222) strcat(s, "a");
if (crc32("wbpJbUR",7) == 4112400795) strcat(s, "e");
if (crc32("eGlFp",5) == 651740255) strcat(s, "r");
if (crc32("gSUuuxnAaZt",11) == 708404849) strcat(s, "y");
if (crc32("YpfivrRMwTtjnqW",15) == 3017211098) strcat(s, "s");
if (crc32("EzTPGQltQM",10) == 2462514418) strcat(s, "l");
if (crc32("uvZNkoXCMCcwBc",14) == 1830614967) strcat(s, "d");
if (crc32("EqKUGMbezJn",11) == 2961767824) strcat(s, "i");
if (crc32("IlnBh",5) == 559851353) strcat(s, "g");
if (crc32("eWHfaxwMrSa",11) == 539451354) strcat(s, "x");
if (crc32("gHqTCPEhYPIvm",13) == 1313225892) strcat(s, "h");
if (crc32("fyNWlLL",7) == 2320831597) strcat(s, "t");
    return s;
}

char *breezelike_adjectives() {
    char *s = calloc(11);
    if (crc32("QNWXwzRWbXQkzLI",15) == 1237790457) strcat(s, "l");
if (crc32("oEOYpInsMvmsgO",14) == 3770529552) strcat(s, "b");
if (crc32("ogSWHHnHmPsHbL",14) == 743141238) strcat(s, "W");
if (crc32("TnmstD",6) == 2781274818) strcat(s, "r");
if (crc32("XeBjDtRuzWKe",12) == 3207198093) strcat(s, "U");
if (crc32("cOBmyaSfbJn",11) == 1189290830) strcat(s, "e");
if (crc32("fBeORe",6) == 2402754816) strcat(s, "e");
if (crc32("exCoQDQa",8) == 4246271021) strcat(s, "y");
if (crc32("OgKggN",6) == 3733659945) strcat(s, "z");
if (crc32("gIqfBMp",7) == 1192857291) strcat(s, "e");
if (crc32("WObZRQEsP",9) == 2582732427) strcat(s, "l");
if (crc32("mEYlBD",6) == 3515723900) strcat(s, "i");
if (crc32("mzzLWS",6) == 3427842760) strcat(s, "k");
if (crc32("NiDzBtUclXXPlnJ",15) == 2850349328) strcat(s, "x");
if (crc32("uNQnl",5) == 1591711857) strcat(s, "e");
    return s;
}

char *foveolar_adjectives() {
    char *s = calloc(9);
    if (crc32("auSXmgZKqUVOLWU",15) == 35572859) strcat(s, "f");
if (crc32("PTAsZHILmw",10) == 424105542) strcat(s, "z");
if (crc32("kSYEGNXtKAIV",12) == 1464889221) strcat(s, "o");
if (crc32("ohKFYQee",8) == 2562012704) strcat(s, "v");
if (crc32("uPQyLeDD",8) == 2084218468) strcat(s, "n");
if (crc32("ZokSMV",6) == 1119309772) strcat(s, "e");
if (crc32("zUIaiXiATm",10) == 3691898842) strcat(s, "o");
if (crc32("cOEayNUQwT",10) == 2664965104) strcat(s, "N");
if (crc32("zHxfEou",7) == 1439393339) strcat(s, "l");
if (crc32("fMZemLHbBtIiKkD",15) == 4054817065) strcat(s, "a");
if (crc32("vWyiSgfJCwTwdd",14) == 17494955) strcat(s, "Y");
if (crc32("QpZOgfemsG",10) == 2424614912) strcat(s, "r");
    return s;
}

char *unmitigated_adjectives() {
    char *s = calloc(12);
    if (crc32("iHcmlMh",7) == 1549579380) strcat(s, "X");
if (crc32("zsULcVCBfYTaYbM",15) == 1107052558) strcat(s, "u");
if (crc32("YCbjWeuHgdb",11) == 271310448) strcat(s, "n");
if (crc32("DKTGjteBkOG",11) == 1674275735) strcat(s, "m");
if (crc32("ZlZELrGu",8) == 2972758042) strcat(s, "r");
if (crc32("BcGGlfoeHM",10) == 3390036475) strcat(s, "i");
if (crc32("ADKdVO",6) == 3522993392) strcat(s, "t");
if (crc32("TkFxoPhLLjkq",12) == 2777494300) strcat(s, "I");
if (crc32("QktFteWlHyvKLK",14) == 4178013566) strcat(s, "i");
if (crc32("CxghXRuh",8) == 3517201935) strcat(s, "g");
if (crc32("cAPwTr",6) == 2149883006) strcat(s, "a");
if (crc32("kDclKCLNrNilKQq",15) == 1512224202) strcat(s, "a");
if (crc32("WWxlWKdQ",8) == 840835132) strcat(s, "A");
if (crc32("PKgppvzuiJRrm",13) == 1618705873) strcat(s, "t");
if (crc32("TinMtXnFQBPdJ",13) == 4229203681) strcat(s, "e");
if (crc32("smEtQ",5) == 599616188) strcat(s, "o");
if (crc32("HdJKiHq",7) == 2132755184) strcat(s, "d");
    return s;
}

char *sunniest_adjectives() {
    char *s = calloc(9);
    if (crc32("DiggaP",6) == 1305339368) strcat(s, "s");
if (crc32("KeDCIeT",7) == 2898690884) strcat(s, "s");
if (crc32("uqUFVTf",7) == 3220813811) strcat(s, "u");
if (crc32("HklVQN",6) == 2536404421) strcat(s, "n");
if (crc32("qAcJsjFQiNaR",12) == 3058828190) strcat(s, "n");
if (crc32("wInyCyvZ",8) == 3755781332) strcat(s, "F");
if (crc32("SzNcZWgj",8) == 1472946301) strcat(s, "i");
if (crc32("tNjeQdUNTWd",11) == 3173394991) strcat(s, "e");
if (crc32("DmXmQxBUFD",10) == 937233842) strcat(s, "s");
if (crc32("OGXfhjYKhG",10) == 3760078455) strcat(s, "t");
    return s;
}

char *glassier_adjectives() {
    char *s = calloc(9);
    if (crc32("MsCmha",6) == 1549239314) strcat(s, "X");
if (crc32("OoVKaKMMwviiqqY",15) == 1177219845) strcat(s, "g");
if (crc32("dtbVs",5) == 2905592949) strcat(s, "j");
if (crc32("nMEwtRLHXbr",11) == 559718496) strcat(s, "l");
if (crc32("MIBSVNOlxBdL",12) == 793991520) strcat(s, "a");
if (crc32("IFixRFTlWJ",10) == 2067380248) strcat(s, "q");
if (crc32("OjlRFRmltvXp",12) == 963681577) strcat(s, "s");
if (crc32("meWffjznuAmL",12) == 2942502648) strcat(s, "s");
if (crc32("TQVXKyHxN",9) == 3254543556) strcat(s, "i");
if (crc32("pfFdovNwt",9) == 2897516106) strcat(s, "e");
if (crc32("otIciUg",7) == 3437800713) strcat(s, "E");
if (crc32("tWEfdSN",7) == 1437756691) strcat(s, "r");
    return s;
}

char *nonreturnable_adjectives() {
    char *s = calloc(14);
    if (crc32("PaFeNPd",7) == 1878280470) strcat(s, "G");
if (crc32("XkgeoPXtJpyo",12) == 1386338633) strcat(s, "n");
if (crc32("sXbAWvJWuJvDjNj",15) == 1542329493) strcat(s, "o");
if (crc32("DQpbcDE",7) == 1513472102) strcat(s, "n");
if (crc32("pMLIopXPel",10) == 2873362586) strcat(s, "r");
if (crc32("HuKeg",5) == 1171504387) strcat(s, "e");
if (crc32("SAfiFFfwmEVVRVS",15) == 3054760944) strcat(s, "w");
if (crc32("EiDVvQsVz",9) == 3634272935) strcat(s, "t");
if (crc32("dwyHzHj",7) == 3265429852) strcat(s, "E");
if (crc32("oBOZFOFnxPV",11) == 1088905737) strcat(s, "u");
if (crc32("vJCPGLvoy",9) == 72474121) strcat(s, "r");
if (crc32("EYHWSzHktGUVf",13) == 1913233727) strcat(s, "n");
if (crc32("VvyQvTWZ",8) == 4143166298) strcat(s, "d");
if (crc32("kfNFuMM",7) == 2353818673) strcat(s, "a");
if (crc32("NWsVBlaZkqyob",13) == 308063616) strcat(s, "c");
if (crc32("DbZpuFpuS",9) == 11065256) strcat(s, "b");
if (crc32("hBZXRbXCQy",10) == 1370125093) strcat(s, "l");
if (crc32("xIvdOm",6) == 1178125988) strcat(s, "e");
    return s;
}

char *semimedicinal_adjectives() {
    char *s = calloc(14);
    if (crc32("ZMByrZCvtcZ",11) == 946908172) strcat(s, "I");
if (crc32("NHzCvH",6) == 2603597188) strcat(s, "s");
if (crc32("ULvaEeLaPIxA",12) == 2236612695) strcat(s, "e");
if (crc32("xYakFHQbLQJE",12) == 3489968457) strcat(s, "G");
if (crc32("IgzSN",5) == 1822723353) strcat(s, "m");
if (crc32("yQUTMoFN",8) == 756295173) strcat(s, "n");
if (crc32("ElhvDsWqxTqvkmz",15) == 4233713646) strcat(s, "i");
if (crc32("ZUUhKscd",8) == 220500743) strcat(s, "b");
if (crc32("YJdps",5) == 2925910130) strcat(s, "m");
if (crc32("KqoHaTpvtF",10) == 4256404323) strcat(s, "e");
if (crc32("aboEfOdoSu",10) == 4076470881) strcat(s, "d");
if (crc32("cIgzbJ",6) == 2345643747) strcat(s, "v");
if (crc32("wjyKqLUNCldW",12) == 2881752364) strcat(s, "i");
if (crc32("JTCBP",5) == 1274437866) strcat(s, "c");
if (crc32("WyAYHS",6) == 3072751258) strcat(s, "L");
if (crc32("tNwffzVTN",9) == 3040948378) strcat(s, "i");
if (crc32("xjoATvbzMMlX",12) == 396597868) strcat(s, "n");
if (crc32("EXgbzsEHnzTvJ",13) == 1875899930) strcat(s, "P");
if (crc32("VPBzHuDiDdMPMX",14) == 2656253507) strcat(s, "a");
if (crc32("AJLoK",5) == 3580328888) strcat(s, "l");
if (crc32("uoKshWOgSlYEz",13) == 1432679088) strcat(s, "l");
    return s;
}

char *cleptobiotic_adjectives() {
    char *s = calloc(13);
    if (crc32("eFkPICJL",8) == 1643024317) strcat(s, "c");
if (crc32("mgRYsMaed",9) == 3662209190) strcat(s, "F");
if (crc32("xksGmIglyuElvDN",15) == 1316889997) strcat(s, "l");
if (crc32("ZXDNXYNsWQb",11) == 1822385923) strcat(s, "a");
if (crc32("CdsLV",5) == 3846608657) strcat(s, "e");
if (crc32("PfDCMJUTdtETEIY",15) == 337296681) strcat(s, "p");
if (crc32("cBOFty",6) == 3363511053) strcat(s, "t");
if (crc32("OEmoBFhwFi",10) == 2255252925) strcat(s, "o");
if (crc32("MukLYWalCbFV",12) == 2581432565) strcat(s, "O");
if (crc32("UHBDF",5) == 281407614) strcat(s, "b");
if (crc32("OspQTBSl",8) == 2647726497) strcat(s, "z");
if (crc32("cnnKMdKEWylyM",13) == 1349177147) strcat(s, "i");
if (crc32("NDVLmunpoSE",11) == 797582579) strcat(s, "o");
if (crc32("sGGCL",5) == 2943911870) strcat(s, "t");
if (crc32("PbEed",5) == 599871541) strcat(s, "Y");
if (crc32("fWGwdzf",7) == 1181070463) strcat(s, "i");
if (crc32("oFHaksLFMQsUBe",14) == 3418288112) strcat(s, "E");
if (crc32("uglDCSEudyl",11) == 107344105) strcat(s, "c");
    return s;
}

char *hematopoietic_adjectives() {
    char *s = calloc(14);
    if (crc32("daoNMyjqsrkxU",13) == 3487440331) strcat(s, "X");
if (crc32("mZkmkIZecAPuj",13) == 2665097052) strcat(s, "h");
if (crc32("RXJpQcAqT",9) == 720047176) strcat(s, "Y");
if (crc32("gDflSCR",7) == 285053902) strcat(s, "e");
if (crc32("jpHSWPFTK",9) == 1947869696) strcat(s, "m");
if (crc32("wsMqVsHVVdbKTNE",15) == 3691010219) strcat(s, "v");
if (crc32("DHLKInLgu",9) == 2222115872) strcat(s, "a");
if (crc32("pDWXLKfOS",9) == 476280925) strcat(s, "k");
if (crc32("dBYUSlkq",8) == 1797426) strcat(s, "t");
if (crc32("HgNCapqUz",9) == 908980705) strcat(s, "G");
if (crc32("zfiZyt",6) == 2207869340) strcat(s, "o");
if (crc32("gSWXDnwcvX",10) == 3335535743) strcat(s, "p");
if (crc32("FFZRTYPZ",8) == 1422560014) strcat(s, "o");
if (crc32("kfSZw",5) == 815769219) strcat(s, "K");
if (crc32("cXtzWMFaDDTQk",13) == 3254971573) strcat(s, "i");
if (crc32("pWAMcE",6) == 593433353) strcat(s, "e");
if (crc32("kVKLidml",8) == 3139305401) strcat(s, "Q");
if (crc32("pEwEIVlDxRbkMI",14) == 42206678) strcat(s, "t");
if (crc32("GMFizyPg",8) == 3041674758) strcat(s, "E");
if (crc32("sOXNoyHSkKiXU",13) == 1226500954) strcat(s, "i");
if (crc32("TofUni",6) == 2257965199) strcat(s, "c");
    return s;
}

char *nondimensioned_adjectives() {
    char *s = calloc(15);
    if (crc32("xRoQtBRrY",9) == 1570027717) strcat(s, "n");
if (crc32("jxdaDzEm",8) == 3439256901) strcat(s, "V");
if (crc32("qaamgpehjFgwon",14) == 2134878331) strcat(s, "o");
if (crc32("hIrJcIdpo",9) == 1731623477) strcat(s, "n");
if (crc32("zfoLZYIKI",9) == 923028533) strcat(s, "d");
if (crc32("hsgvUkaFWO",10) == 3954685647) strcat(s, "i");
if (crc32("WuVga",5) == 1757956804) strcat(s, "m");
if (crc32("MAClIGRpcBOQHO",14) == 1574606573) strcat(s, "A");
if (crc32("RMFpcTPTgeI",11) == 719733456) strcat(s, "e");
if (crc32("fJQfRrtfkQiMJeE",15) == 2386683487) strcat(s, "n");
if (crc32("kAGEHiL",7) == 589050835) strcat(s, "s");
if (crc32("HCIbhaHJjIp",11) == 1096505685) strcat(s, "i");
if (crc32("gTjvbpvTqmkb",12) == 2729480678) strcat(s, "i");
if (crc32("gHNsd",5) == 2270757676) strcat(s, "o");
if (crc32("xWPYrygEcTozPx",14) == 3169334545) strcat(s, "n");
if (crc32("auwSvwPpttXriqb",15) == 2179435469) strcat(s, "e");
if (crc32("REzKgFHCy",9) == 4013842823) strcat(s, "d");
    return s;
}

char *hydrogenous_adjectives() {
    char *s = calloc(12);
    if (crc32("ldiPH",5) == 563226751) strcat(s, "A");
if (crc32("yhAbC",5) == 87315639) strcat(s, "h");
if (crc32("QOteuhfGsSkUa",13) == 2107307616) strcat(s, "y");
if (crc32("ymiIxM",6) == 715361859) strcat(s, "d");
if (crc32("fhuliZoycsJE",12) == 3405769402) strcat(s, "r");
if (crc32("jYYmG",5) == 2503587583) strcat(s, "Q");
if (crc32("jLWygAdbHmbs",12) == 2861014685) strcat(s, "o");
if (crc32("ZMHGu",5) == 1008803998) strcat(s, "g");
if (crc32("hfZPMIBExbL",11) == 244182988) strcat(s, "t");
if (crc32("JQMQkRwLsZpCJmz",15) == 2765129091) strcat(s, "e");
if (crc32("nbnzI",5) == 494987115) strcat(s, "t");
if (crc32("GxLQumZFIajcriH",15) == 259255061) strcat(s, "n");
if (crc32("NeldrUwsEkpyZ",13) == 1077957233) strcat(s, "o");
if (crc32("gWZiesVLk",9) == 265443855) strcat(s, "f");
if (crc32("RWxEOGdF",8) == 3418176854) strcat(s, "u");
if (crc32("ftlLBtZMGrK",11) == 956893507) strcat(s, "s");
    return s;
}

char *whopping_adjectives() {
    char *s = calloc(9);
    if (crc32("dEthyRNKqzFgsDD",15) == 913123121) strcat(s, "b");
if (crc32("kYSEpXlUG",9) == 2787902251) strcat(s, "w");
if (crc32("amTAcmTP",8) == 3182338123) strcat(s, "h");
if (crc32("GzfrAiEi",8) == 2383636827) strcat(s, "o");
if (crc32("obBUSOk",7) == 3090530921) strcat(s, "p");
if (crc32("MBjkzdBOhAbJEFs",15) == 2767616928) strcat(s, "r");
if (crc32("ZmKztEAGk",9) == 313921005) strcat(s, "p");
if (crc32("PqlDxfupMuA",11) == 1841587143) strcat(s, "i");
if (crc32("vStlpH",6) == 3785510847) strcat(s, "n");
if (crc32("tWyIOXJmHfCNJ",13) == 4110611410) strcat(s, "g");
    return s;
}

char *unhollowed_adjectives() {
    char *s = calloc(11);
    if (crc32("CxGADuIpggMVvwg",15) == 273365620) strcat(s, "o");
if (crc32("ZEsMWhU",7) == 1300665414) strcat(s, "u");
if (crc32("AxoJMltqDHubw",13) == 1700653800) strcat(s, "J");
if (crc32("hKBZSItdN",9) == 1365640828) strcat(s, "n");
if (crc32("vfbmKFW",7) == 3374617390) strcat(s, "h");
if (crc32("efkafoL",7) == 2982807864) strcat(s, "u");
if (crc32("VNtfmXOhIhqe",12) == 1539969126) strcat(s, "o");
if (crc32("NAfpzQA",7) == 3406617207) strcat(s, "l");
if (crc32("OYpMrFmQQZL",11) == 3416844804) strcat(s, "l");
if (crc32("MvnmKrbCctWbvys",15) == 1190133453) strcat(s, "W");
if (crc32("mPKfJzPCMMvN",12) == 3859817838) strcat(s, "o");
if (crc32("cfDGKzWPcNUmhKH",15) == 95063766) strcat(s, "w");
if (crc32("iYBGA",5) == 2203319503) strcat(s, "D");
if (crc32("cNfQcR",6) == 1625808539) strcat(s, "e");
if (crc32("KIEiVWcqPlxCT",13) == 4073652848) strcat(s, "d");
    return s;
}

char *phyletic_adjectives() {
    char *s = calloc(9);
    if (crc32("htaDqAPlyfDuU",13) == 4036628446) strcat(s, "p");
if (crc32("jclwo",5) == 3516538017) strcat(s, "b");
if (crc32("vYIaNDg",7) == 3538622270) strcat(s, "h");
if (crc32("EUNaBgxWLEicpOO",15) == 2151986565) strcat(s, "t");
if (crc32("YUCRBTYVJkklDs",14) == 606321805) strcat(s, "y");
if (crc32("GMGPqsvhotOUVDH",15) == 4048579215) strcat(s, "X");
if (crc32("oROSukyTRVnBp",13) == 1154010674) strcat(s, "l");
if (crc32("SQCMVMwNTtvQ",12) == 3871327814) strcat(s, "e");
if (crc32("OuftRGRANSM",11) == 3023712096) strcat(s, "R");
if (crc32("IeiDsNnsEl",10) == 3321901888) strcat(s, "t");
if (crc32("mawFEtwTX",9) == 960301597) strcat(s, "i");
if (crc32("zPqyWjq",7) == 3667690551) strcat(s, "c");
    return s;
}

char *heimish_adjectives() {
    char *s = calloc(8);
    if (crc32("jIyobD",6) == 1439906533) strcat(s, "V");
if (crc32("PnlVIxLsFE",10) == 3479912907) strcat(s, "h");
if (crc32("PUcAfOM",7) == 739656765) strcat(s, "e");
if (crc32("vgDcRBbrEdv",11) == 3208055390) strcat(s, "c");
if (crc32("WsMrhEetbbNBZBy",15) == 3481909901) strcat(s, "i");
if (crc32("dWEHXwPntnc",11) == 670381410) strcat(s, "m");
if (crc32("wbjhOpEX",8) == 3041020710) strcat(s, "y");
if (crc32("NvBxBnPMMnEQ",12) == 3282917038) strcat(s, "i");
if (crc32("TRuim",5) == 2402009359) strcat(s, "h");
if (crc32("fTbLMrLVxwwUpW",14) == 363237312) strcat(s, "s");
if (crc32("aJpRKmV",7) == 2821461449) strcat(s, "h");
    return s;
}

char *alarmable_adjectives() {
    char *s = calloc(10);
    if (crc32("AlmsMlnvZhCXYB",14) == 3736893146) strcat(s, "R");
if (crc32("MeoqnOgkBPsVXy",14) == 4233594842) strcat(s, "a");
if (crc32("LdkIwcuGgTQImA",14) == 2433702833) strcat(s, "l");
if (crc32("cYWdGWzdW",9) == 4268295320) strcat(s, "M");
if (crc32("xwBRqRMLVpFKTW",14) == 2381422183) strcat(s, "a");
if (crc32("yQQhUdUq",8) == 1858872536) strcat(s, "r");
if (crc32("yfXmrQUpQOcmDmi",15) == 2907144543) strcat(s, "m");
if (crc32("ITmQbcHNc",9) == 210845177) strcat(s, "x");
if (crc32("qwpGlwGJWybi",12) == 2673029794) strcat(s, "a");
if (crc32("YjpRrAaUr",9) == 4251612584) strcat(s, "K");
if (crc32("axAnolsjYpCO",12) == 2905640876) strcat(s, "b");
if (crc32("xidmFWtqRZMlplN",15) == 682349281) strcat(s, "l");
if (crc32("BfTPCFO",7) == 1444396084) strcat(s, "K");
if (crc32("PzBdTIzgqXCS",12) == 3652025652) strcat(s, "e");
    return s;
}

char *unflitched_adjectives() {
    char *s = calloc(11);
    if (crc32("nkTGWyUbAGdCKM",14) == 289198083) strcat(s, "o");
if (crc32("hEMCMYMOt",9) == 2188555084) strcat(s, "u");
if (crc32("futjXg",6) == 839708410) strcat(s, "i");
if (crc32("AxJwYxKMi",9) == 821506525) strcat(s, "n");
if (crc32("KAYgQwizAzkecg",14) == 4133887472) strcat(s, "I");
if (crc32("hGBFTVIJ",8) == 3914317611) strcat(s, "f");
if (crc32("IynNjFYYCt",10) == 737734686) strcat(s, "l");
if (crc32("cfRJcdoxC",9) == 2370182496) strcat(s, "H");
if (crc32("BPSgTvewx",9) == 3086780830) strcat(s, "i");
if (crc32("McJYtUFxkXLFyy",14) == 820462085) strcat(s, "O");
if (crc32("zBLhsOxrEbT",11) == 2959820270) strcat(s, "t");
if (crc32("zGUHvpM",7) == 3088532165) strcat(s, "c");
if (crc32("FmUjwL",6) == 2951129282) strcat(s, "c");
if (crc32("rkhocR",6) == 1868959864) strcat(s, "h");
if (crc32("nSMRcZ",6) == 1067941922) strcat(s, "e");
if (crc32("tKizHxhHSXlkWEA",15) == 563900344) strcat(s, "d");
    return s;
}

char *inventionless_adjectives() {
    char *s = calloc(14);
    if (crc32("XYXwaZg",7) == 2799422203) strcat(s, "N");
if (crc32("tRMzYwXyVfSastJ",15) == 768993295) strcat(s, "i");
if (crc32("BGdEpVnMZPBqPm",14) == 1391792860) strcat(s, "n");
if (crc32("CccTK",5) == 2242574424) strcat(s, "v");
if (crc32("DvEgkOdnGwlmFR",14) == 2927789343) strcat(s, "e");
if (crc32("BoqxPMP",7) == 2674067873) strcat(s, "n");
if (crc32("zCLZDBbiM",9) == 1632055493) strcat(s, "t");
if (crc32("LbAQzylLCpMbV",13) == 2529818904) strcat(s, "i");
if (crc32("KHyhCEYrGr",10) == 3007728856) strcat(s, "h");
if (crc32("XStJNSEKQGRNL",13) == 322306986) strcat(s, "o");
if (crc32("lyQqS",5) == 636456505) strcat(s, "n");
if (crc32("prCNCKJJMWl",11) == 2201734190) strcat(s, "l");
if (crc32("cZpcFFMpXduObk",14) == 3349504339) strcat(s, "P");
if (crc32("AEFzXfRp",8) == 1714325742) strcat(s, "e");
if (crc32("fcRvDih",7) == 1999152166) strcat(s, "s");
if (crc32("fyinzuFCdYZBg",13) == 2468664742) strcat(s, "O");
if (crc32("AHrZRdbn",8) == 279165963) strcat(s, "s");
    return s;
}

char *uncelestial_adjectives() {
    char *s = calloc(12);
    if (crc32("NbkrsfEtSyVS",12) == 1476960991) strcat(s, "u");
if (crc32("XXVFfenRrZHtEU",14) == 1877166910) strcat(s, "n");
if (crc32("GNHhKbzhitrXXV",14) == 2407594286) strcat(s, "c");
if (crc32("vqTqAnhPJn",10) == 2908615683) strcat(s, "H");
if (crc32("MICGewJBe",9) == 3172510806) strcat(s, "e");
if (crc32("nPSjMF",6) == 4130686885) strcat(s, "K");
if (crc32("iWJANFOb",8) == 1545955057) strcat(s, "l");
if (crc32("IpuqfqvCMLN",11) == 2785321116) strcat(s, "L");
if (crc32("lbAkjQ",6) == 3377640313) strcat(s, "e");
if (crc32("DcddK",5) == 826065607) strcat(s, "k");
if (crc32("buouxCeXu",9) == 170886655) strcat(s, "s");
if (crc32("bPTYye",6) == 684333723) strcat(s, "t");
if (crc32("ZvNUalWoYOLQheL",15) == 4173721088) strcat(s, "l");
if (crc32("IfajxuzSRS",10) == 1527709734) strcat(s, "i");
if (crc32("YKzzwyRPygXKRhL",15) == 143164707) strcat(s, "Q");
if (crc32("ByBQC",5) == 3444389555) strcat(s, "a");
if (crc32("xaoDxGTmVRiyl",13) == 2369417847) strcat(s, "C");
if (crc32("jXRbopvjPUGCxJE",15) == 4141766495) strcat(s, "l");
    return s;
}

char *heartaching_adjectives() {
    char *s = calloc(12);
    if (crc32("agRhgRmvf",9) == 4034884440) strcat(s, "h");
if (crc32("CTSGvBiAE",9) == 3211324137) strcat(s, "E");
if (crc32("wcTUVP",6) == 3504688847) strcat(s, "e");
if (crc32("EQWvN",5) == 1483418529) strcat(s, "r");
if (crc32("QBQNDNFjwSHFWvh",15) == 1639944513) strcat(s, "a");
if (crc32("JOAWd",5) == 3647698619) strcat(s, "r");
if (crc32("QIGyLLxvM",9) == 2136475611) strcat(s, "t");
if (crc32("hWnzErvEvIeD",12) == 2708147900) strcat(s, "a");
if (crc32("HFClvPWooHwBTEf",15) == 1355724227) strcat(s, "c");
if (crc32("FFUSyGum",8) == 2354224154) strcat(s, "h");
if (crc32("RMgDa",5) == 3455192150) strcat(s, "V");
if (crc32("PNoKhwEGnaHdLFI",15) == 3867197593) strcat(s, "i");
if (crc32("kiTyKgy",7) == 3407603665) strcat(s, "A");
if (crc32("mLjOTSywXTR",11) == 721824864) strcat(s, "n");
if (crc32("wGjsWrCKfqfZ",12) == 2852339173) strcat(s, "g");
    return s;
}

char *preSyrian_adjectives() {
    char *s = calloc(10);
    if (crc32("YzcBNBptCvws",12) == 2271560938) strcat(s, "v");
if (crc32("saUwvCNYR",9) == 1065821249) strcat(s, "p");
if (crc32("hhlZIlAYra",10) == 173552647) strcat(s, "I");
if (crc32("SQaUWgGPwKAd",12) == 2647030698) strcat(s, "r");
if (crc32("SOGBFNis",8) == 2246985826) strcat(s, "e");
if (crc32("VJXwCikPEvQJ",12) == 2289472596) strcat(s, "S");
if (crc32("ffgkQEs",7) == 2179995989) strcat(s, "R");
if (crc32("NDwEyRSbA",9) == 2264455179) strcat(s, "y");
if (crc32("mMFKAEavhh",10) == 671902654) strcat(s, "r");
if (crc32("dZoFJaWeNSOV",12) == 3924534745) strcat(s, "r");
if (crc32("VVUbVdJHNTjfP",13) == 1092578716) strcat(s, "i");
if (crc32("TtvtQMxoceYK",12) == 10539603) strcat(s, "q");
if (crc32("UAqdpKfYMqmg",12) == 4009066794) strcat(s, "a");
if (crc32("qYKZJQV",7) == 2101239050) strcat(s, "E");
if (crc32("fkgxuCvw",8) == 3212682110) strcat(s, "n");
    return s;
}

char *wellintentioned_adjectives() {
    char *s = calloc(16);
    if (crc32("cbOFkVVkqmjfpV",14) == 356459122) strcat(s, "w");
if (crc32("GIUuVw",6) == 1282726467) strcat(s, "p");
if (crc32("TYAqGeYg",8) == 4073055534) strcat(s, "e");
if (crc32("GUZQmzFXn",9) == 3356783388) strcat(s, "l");
if (crc32("FFHyCGJOb",9) == 1333451755) strcat(s, "l");
if (crc32("SRLHjYK",7) == 3263393985) strcat(s, "i");
if (crc32("eOjADNU",7) == 1399212223) strcat(s, "v");
if (crc32("jfvGmSlZp",9) == 1302563963) strcat(s, "n");
if (crc32("biKtsIOOzzpDj",13) == 3074002233) strcat(s, "t");
if (crc32("RMbMGekOrOndOS",14) == 3967259400) strcat(s, "e");
if (crc32("PleJxVlnM",9) == 2659007658) strcat(s, "A");
if (crc32("XqKAUgFHsItBew",14) == 2456346086) strcat(s, "n");
if (crc32("esvLKLkSab",10) == 1373973206) strcat(s, "t");
if (crc32("roLDjMF",7) == 157565642) strcat(s, "i");
if (crc32("rkvZjTrXQwJd",12) == 1711586180) strcat(s, "o");
if (crc32("SSUXKWIc",8) == 678487695) strcat(s, "n");
if (crc32("wbfCoVzo",8) == 499747856) strcat(s, "e");
if (crc32("FqCzKIRKMvSN",12) == 3386213452) strcat(s, "Q");
if (crc32("iLtTBsPapwCnvq",14) == 3321173748) strcat(s, "d");
    return s;
}

char *pestiferous_adjectives() {
    char *s = calloc(12);
    if (crc32("LbbnIZrEDvBk",12) == 1008519055) strcat(s, "p");
if (crc32("TsmqTee",7) == 998675945) strcat(s, "e");
if (crc32("jIfxfDMzKpK",11) == 2167361371) strcat(s, "s");
if (crc32("RbECOBij",8) == 768814376) strcat(s, "V");
if (crc32("tvQIYCL",7) == 2081173524) strcat(s, "t");
if (crc32("QlTHBSjjvniXPm",14) == 466762760) strcat(s, "B");
if (crc32("gqEAJjilaEJZFO",14) == 2781958857) strcat(s, "i");
if (crc32("VGgNaeqypqjKRrY",15) == 437914479) strcat(s, "Z");
if (crc32("oYgHHn",6) == 934357766) strcat(s, "f");
if (crc32("TgxCU",5) == 2787465652) strcat(s, "h");
if (crc32("MQGnFOgT",8) == 3846487103) strcat(s, "e");
if (crc32("aqmCkZK",7) == 2097679203) strcat(s, "r");
if (crc32("uJQvf",5) == 3010690657) strcat(s, "o");
if (crc32("ZZhPuaruQAkh",12) == 422036453) strcat(s, "x");
if (crc32("ZEIgHQhywXT",11) == 1636035556) strcat(s, "u");
if (crc32("RZSPEkTQTpSg",12) == 4147353166) strcat(s, "v");
if (crc32("qvLCRWlvvO",10) == 127328454) strcat(s, "s");
    return s;
}

char *quasiconsiderate_adjectives() {
    char *s = calloc(17);
    if (crc32("LPtlqu",6) == 1116761332) strcat(s, "q");
if (crc32("ctyAmuqvGaiOxo",14) == 2023035933) strcat(s, "X");
if (crc32("msWox",5) == 188939712) strcat(s, "u");
if (crc32("ASMJcAAb",8) == 565737024) strcat(s, "a");
if (crc32("ezCVEh",6) == 1970155743) strcat(s, "s");
if (crc32("RpQDvOCnbMJqe",13) == 177516121) strcat(s, "D");
if (crc32("BfbkUxmdg",9) == 2999189157) strcat(s, "i");
if (crc32("fzHSVjfq",8) == 411391785) strcat(s, "c");
if (crc32("owpqpkZmqLRiv",13) == 2825951297) strcat(s, "o");
if (crc32("hbgTQl",6) == 2625044489) strcat(s, "n");
if (crc32("NMZflvqlnbXG",12) == 2439486351) strcat(s, "l");
if (crc32("yXyrmyrxusJ",11) == 3718945461) strcat(s, "s");
if (crc32("NWrwOgFeb",9) == 1897505881) strcat(s, "i");
if (crc32("YLhWapk",7) == 598852934) strcat(s, "S");
if (crc32("rrBbXtClD",9) == 1721401963) strcat(s, "d");
if (crc32("aCtzyg",6) == 2204519863) strcat(s, "j");
if (crc32("hpxPi",5) == 3496531533) strcat(s, "e");
if (crc32("nLqVYP",6) == 1000087412) strcat(s, "A");
if (crc32("TrNRaLiIuhpK",12) == 265806487) strcat(s, "r");
if (crc32("dTLjbqJUc",9) == 1109751866) strcat(s, "a");
if (crc32("hLebaCzcEHXQJH",14) == 2314599029) strcat(s, "t");
if (crc32("jFrLzYgUXLghTCp",15) == 3078877144) strcat(s, "L");
if (crc32("DRhparO",7) == 476863898) strcat(s, "e");
    return s;
}

char *knightless_adjectives() {
    char *s = calloc(11);
    if (crc32("SpqDTdErow",10) == 3181529638) strcat(s, "k");
if (crc32("aOOmupSbXVuko",13) == 2974531771) strcat(s, "Y");
if (crc32("iUQvl",5) == 4274825781) strcat(s, "n");
if (crc32("mufWwrLtXZwp",12) == 2717889449) strcat(s, "s");
if (crc32("ewOJH",5) == 1750021077) strcat(s, "i");
if (crc32("XJIeSIx",7) == 13283263) strcat(s, "V");
if (crc32("tAqTfIHmkI",10) == 2118759420) strcat(s, "g");
if (crc32("IInmToombSYH",12) == 3240194505) strcat(s, "h");
if (crc32("RMXZFMQYDR",10) == 979341435) strcat(s, "p");
if (crc32("vTpAYnssLtTcfBc",15) == 1450884078) strcat(s, "t");
if (crc32("RrrZQxBNwgdXLaQ",15) == 2864019361) strcat(s, "g");
if (crc32("DVhMzcDKbIXusg",14) == 3884262762) strcat(s, "l");
if (crc32("IYKHm",5) == 1386756036) strcat(s, "e");
if (crc32("JAtJI",5) == 2712082074) strcat(s, "s");
if (crc32("cjFHjwmPJSBpx",13) == 264027898) strcat(s, "U");
if (crc32("cVIMtwdwIL",10) == 2876684024) strcat(s, "s");
    return s;
}

char *benthonic_adjectives() {
    char *s = calloc(10);
    if (crc32("CoXtSBoDCxdr",12) == 2974360574) strcat(s, "u");
if (crc32("YOBSqLaH",8) == 248056945) strcat(s, "b");
if (crc32("YRQknULh",8) == 3126468280) strcat(s, "o");
if (crc32("HvhbQcVYaC",10) == 4110527229) strcat(s, "e");
if (crc32("lzKxhlwlvSpvjb",14) == 3413733940) strcat(s, "I");
if (crc32("gkfuVxW",7) == 2164647268) strcat(s, "n");
if (crc32("TPQPkNmRNiGDD",13) == 4047992576) strcat(s, "n");
if (crc32("fRglWmGMyogiVK",14) == 3779165151) strcat(s, "t");
if (crc32("vhtpJgh",7) == 2244365783) strcat(s, "h");
if (crc32("HXGYEQfeEdWhSYD",15) == 1688317994) strcat(s, "o");
if (crc32("GFDotAzXPVFleuh",15) == 3289490761) strcat(s, "n");
if (crc32("tRicYDbrs",9) == 1915240546) strcat(s, "i");
if (crc32("GcyQZbPqNCzM",12) == 3028695019) strcat(s, "d");
if (crc32("CAjFeeZ",7) == 2623418269) strcat(s, "c");
    return s;
}

char *anabatic_adjectives() {
    char *s = calloc(9);
    if (crc32("anTXQNqQDNUnhO",14) == 3933589708) strcat(s, "a");
if (crc32("knxefALfOhL",11) == 42516521) strcat(s, "n");
if (crc32("XBAykStmlQ",10) == 1226617395) strcat(s, "a");
if (crc32("llPVoGIIvedsvgG",15) == 612908132) strcat(s, "e");
if (crc32("KnDlpSrvD",9) == 3474326258) strcat(s, "b");
if (crc32("MAAVBIRv",8) == 3823937576) strcat(s, "M");
if (crc32("AlquPaKEBLsY",12) == 4197576517) strcat(s, "a");
if (crc32("nlZBo",5) == 333891486) strcat(s, "x");
if (crc32("KWprIJjQVF",10) == 887865047) strcat(s, "t");
if (crc32("KgRbSkdzWzvXTXN",15) == 2029263639) strcat(s, "s");
if (crc32("gAFLFbQuCLQx",12) == 2478781972) strcat(s, "i");
if (crc32("ksofDtZ",7) == 725274953) strcat(s, "c");
    return s;
}

char *cordilleran_adjectives() {
    char *s = calloc(12);
    if (crc32("jBNZVpUOXvln",12) == 2497526078) strcat(s, "c");
if (crc32("bQAckPVmYrLgV",13) == 2976764598) strcat(s, "o");
if (crc32("nHTkXUaghgBgL",13) == 2159382575) strcat(s, "v");
if (crc32("yuliOBeVTcexYY",14) == 354025591) strcat(s, "r");
if (crc32("LCHLUhcDjA",10) == 3423100125) strcat(s, "d");
if (crc32("NzlSrlYvbpRQ",12) == 277781175) strcat(s, "s");
if (crc32("CifFEd",6) == 27757553) strcat(s, "i");
if (crc32("dBUxjs",6) == 2147066126) strcat(s, "V");
if (crc32("fAdCtq",6) == 2687865480) strcat(s, "l");
if (crc32("wtlNKiJfsnmLWTk",15) == 1135580320) strcat(s, "l");
if (crc32("RCQXezZXDUNSt",13) == 2481588817) strcat(s, "e");
if (crc32("ItjfPBjmYsFMKg",14) == 1337080718) strcat(s, "r");
if (crc32("tmELXlMccwG",11) == 2457340796) strcat(s, "x");
if (crc32("NvwbmcFMpspgv",13) == 2705676910) strcat(s, "a");
if (crc32("dhdwCSskxnPvC",13) == 1890231035) strcat(s, "n");
    return s;
}

char *aesthetical_adjectives() {
    char *s = calloc(12);
    if (crc32("mhLkNvbhookclh",14) == 536533290) strcat(s, "a");
if (crc32("KhBOyEpXvmncz",13) == 1753893434) strcat(s, "c");
if (crc32("JYcxfFssVDNaK",13) == 3517511023) strcat(s, "e");
if (crc32("qrdCFQ",6) == 2390300228) strcat(s, "s");
if (crc32("PEMZyvnysC",10) == 3389483301) strcat(s, "t");
if (crc32("rjJdLDu",7) == 604596714) strcat(s, "h");
if (crc32("klUgTanS",8) == 3037082806) strcat(s, "y");
if (crc32("tQzcv",5) == 387045438) strcat(s, "e");
if (crc32("zuuyzm",6) == 3631654897) strcat(s, "W");
if (crc32("JhgFeOxT",8) == 1538931226) strcat(s, "t");
if (crc32("pBeLROk",7) == 1899866702) strcat(s, "i");
if (crc32("XoqMysmeY",9) == 418063607) strcat(s, "c");
if (crc32("QXtWIbRiqrc",11) == 1183719716) strcat(s, "V");
if (crc32("ErmOhswRPBa",11) == 3907662772) strcat(s, "a");
if (crc32("RQMHiqcibBUwQ",13) == 2430122479) strcat(s, "l");
    return s;
}

char *tracheoscopic_adjectives() {
    char *s = calloc(14);
    if (crc32("KLftrrKYUC",10) == 1900828011) strcat(s, "t");
if (crc32("LSvKGphfBqFYvY",14) == 1743168544) strcat(s, "r");
if (crc32("eOteMvHb",8) == 739611319) strcat(s, "a");
if (crc32("LoBiABispWTbmR",14) == 748034824) strcat(s, "c");
if (crc32("MqJEzUTGeLpP",12) == 4155896324) strcat(s, "h");
if (crc32("bkJCePGcfMrtxk",14) == 4187531306) strcat(s, "L");
if (crc32("TuytSjRJzmNfNZQ",15) == 1199022672) strcat(s, "e");
if (crc32("sTuULbQBDgjtA",13) == 2389649542) strcat(s, "o");
if (crc32("JtFPGIFtpwerQk",14) == 75974024) strcat(s, "s");
if (crc32("VQrakAgRUfsObNr",15) == 3430940838) strcat(s, "c");
if (crc32("ootvXQlixxITQ",13) == 4174369898) strcat(s, "e");
if (crc32("DqJeeOUrqVWKk",13) == 2499940129) strcat(s, "o");
if (crc32("tmVnoKKBaf",10) == 3153840235) strcat(s, "N");
if (crc32("BmRrIsNZlfZXX",13) == 1804578609) strcat(s, "p");
if (crc32("GItaejZRyCUlsnp",15) == 1223317745) strcat(s, "R");
if (crc32("QuvAFRZWYaGxMNX",15) == 1184683090) strcat(s, "i");
if (crc32("dJRkvZQRaOO",11) == 1299863340) strcat(s, "c");
    return s;
}

char *unwishful_adjectives() {
    char *s = calloc(10);
    if (crc32("gXFHlEUCTs",10) == 4158392482) strcat(s, "u");
if (crc32("SUfvwPUjNzu",11) == 2654085751) strcat(s, "n");
if (crc32("zndJQBNYmyoDQPz",15) == 886287239) strcat(s, "w");
if (crc32("eDfORpkwDm",10) == 1374063077) strcat(s, "i");
if (crc32("OfdAFIS",7) == 3627973622) strcat(s, "t");
if (crc32("wGJKndgo",8) == 2691509792) strcat(s, "s");
if (crc32("qZUdE",5) == 3413124675) strcat(s, "h");
if (crc32("vwdyeEAjCuAbQ",13) == 3929104732) strcat(s, "f");
if (crc32("wCFhG",5) == 3702269019) strcat(s, "Y");
if (crc32("McjYBezg",8) == 2291082065) strcat(s, "u");
if (crc32("gkGJptgWXGstky",14) == 3602944538) strcat(s, "q");
if (crc32("gEzURZRuYmlyvs",14) == 2093612958) strcat(s, "l");
    return s;
}

char *nonalkaloidal_adjectives() {
    char *s = calloc(14);
    if (crc32("lukvCqxHT",9) == 3872859143) strcat(s, "G");
if (crc32("oCVyvAY",7) == 1670630715) strcat(s, "n");
if (crc32("SVUdD",5) == 1341018131) strcat(s, "M");
if (crc32("qscea",5) == 330598981) strcat(s, "o");
if (crc32("GLrgOyrJhd",10) == 4077274313) strcat(s, "Q");
if (crc32("fLetsCxz",8) == 4161201801) strcat(s, "n");
if (crc32("HQvkSbLSv",9) == 1219000520) strcat(s, "a");
if (crc32("jWWvUQ",6) == 1995921648) strcat(s, "o");
if (crc32("ofdDtxF",7) == 1834665477) strcat(s, "l");
if (crc32("zLIDWPZJ",8) == 1264769567) strcat(s, "f");
if (crc32("tqxwXhsi",8) == 3550832371) strcat(s, "k");
if (crc32("zzsNKV",6) == 974306013) strcat(s, "a");
if (crc32("yUJLjfPVOTsGuer",15) == 1344403255) strcat(s, "l");
if (crc32("LOzxhGA",7) == 84359819) strcat(s, "o");
if (crc32("jRyAFNTz",8) == 1937838381) strcat(s, "i");
if (crc32("bMIhHAdmK",9) == 647501299) strcat(s, "d");
if (crc32("MKKQGSVbjgY",11) == 2244680026) strcat(s, "a");
if (crc32("fyZNgPe",7) == 2615320641) strcat(s, "o");
if (crc32("zKZhfsZgYQ",10) == 3699101237) strcat(s, "l");
    return s;
}

char *prostomiate_adjectives() {
    char *s = calloc(12);
    if (crc32("XEbwUzcRn",9) == 3633798479) strcat(s, "p");
if (crc32("fsqCVsoZGVxLM",13) == 1179224013) strcat(s, "f");
if (crc32("iqrckEguNonPuO",14) == 1631017134) strcat(s, "r");
if (crc32("zOjYaxSdM",9) == 446763737) strcat(s, "o");
if (crc32("QuVnHVZdnzs",11) == 1753618851) strcat(s, "s");
if (crc32("OVJAhOBpC",9) == 2312475986) strcat(s, "s");
if (crc32("VclUMGNxwEKYg",13) == 1740259274) strcat(s, "g");
if (crc32("dfZywsvMMsm",11) == 4158016564) strcat(s, "t");
if (crc32("yYEHsWPmuLQ",11) == 1177518808) strcat(s, "h");
if (crc32("DPEHPuOZSaEppG",14) == 564339010) strcat(s, "o");
if (crc32("RYokJGNyHsvBw",13) == 821946396) strcat(s, "m");
if (crc32("WUozwl",6) == 2371194139) strcat(s, "t");
if (crc32("EDkjalZbBsDSRsM",15) == 997734011) strcat(s, "i");
if (crc32("zyePhmslUGW",11) == 3715440520) strcat(s, "a");
if (crc32("AUBQOoGjBra",11) == 3953121827) strcat(s, "t");
if (crc32("YwFlWTvC",8) == 681104689) strcat(s, "e");
    return s;
}

char *antherless_adjectives() {
    char *s = calloc(11);
    if (crc32("OslPVOHTC",9) == 3200927343) strcat(s, "a");
if (crc32("lIebKfqIwp",10) == 823942462) strcat(s, "n");
if (crc32("jfnepythGCfH",12) == 199610360) strcat(s, "t");
if (crc32("RQcInezSw",9) == 2638432841) strcat(s, "h");
if (crc32("fkkUR",5) == 979155194) strcat(s, "e");
if (crc32("hehHvigETEiFcs",14) == 2383052407) strcat(s, "s");
if (crc32("WkunTo",6) == 1406766509) strcat(s, "r");
if (crc32("yBOozNk",7) == 4061593329) strcat(s, "l");
if (crc32("ckwyJco",7) == 4128565741) strcat(s, "e");
if (crc32("DhccYQHBKx",10) == 960881864) strcat(s, "s");
if (crc32("ltXnXKFAAFaQ",12) == 1836908235) strcat(s, "s");
    return s;
}

char *redfigure_adjectives() {
    char *s = calloc(10);
    if (crc32("buXGepDG",8) == 1393791391) strcat(s, "u");
if (crc32("vrNOvxyf",8) == 3582059138) strcat(s, "r");
if (crc32("KCVtAPYwgKxP",12) == 3356154714) strcat(s, "E");
if (crc32("TZKCEBKvJlCwX",13) == 3766799034) strcat(s, "e");
if (crc32("ZQPIc",5) == 1586274990) strcat(s, "d");
if (crc32("ljvsBOGvinLAn",13) == 839468689) strcat(s, "r");
if (crc32("HDAPVNZpgkk",11) == 1906842976) strcat(s, "f");
if (crc32("yWhqZTEmlGYk",12) == 4172886708) strcat(s, "z");
if (crc32("qCENHwXAx",9) == 3470410779) strcat(s, "i");
if (crc32("WkpSzSoCulk",11) == 550231469) strcat(s, "F");
if (crc32("NRZMTHPlys",10) == 2630503316) strcat(s, "g");
if (crc32("MZxsAn",6) == 3067863833) strcat(s, "I");
if (crc32("hMGxvynZlfZBkz",14) == 4179927311) strcat(s, "u");
if (crc32("PXKrAdJuUL",10) == 276656189) strcat(s, "z");
if (crc32("kgThHKrorHlKa",13) == 2524740042) strcat(s, "r");
if (crc32("DwLKWGqvw",9) == 4036867481) strcat(s, "C");
if (crc32("tWdCYSXLMPSX",12) == 3865146015) strcat(s, "e");
    return s;
}

char *untaxied_adjectives() {
    char *s = calloc(9);
    if (crc32("ybBaSvbPIFyIich",15) == 1107862540) strcat(s, "B");
if (crc32("XIEQPYLb",8) == 1065640180) strcat(s, "u");
if (crc32("DESoskyyZkGT",12) == 2128305024) strcat(s, "n");
if (crc32("qFwzYLKrzUH",11) == 2830271093) strcat(s, "t");
if (crc32("pAcITqtxnhp",11) == 3182706723) strcat(s, "a");
if (crc32("cCQTQ",5) == 1054126310) strcat(s, "x");
if (crc32("GJbqoGjmbo",10) == 626025462) strcat(s, "n");
if (crc32("IlxZFHi",7) == 637700542) strcat(s, "i");
if (crc32("ArjPzVaT",8) == 1220559713) strcat(s, "R");
if (crc32("FOCNzlgf",8) == 2646525128) strcat(s, "e");
if (crc32("pFTdHCi",7) == 697071789) strcat(s, "z");
if (crc32("HEdqYDfdBrK",11) == 289478753) strcat(s, "d");
    return s;
}

char *involucral_adjectives() {
    char *s = calloc(11);
    if (crc32("AsnuPki",7) == 1453195902) strcat(s, "i");
if (crc32("LDmEiwiAYmEfWM",14) == 367885174) strcat(s, "n");
if (crc32("lRQwGDQwIa",10) == 4144107224) strcat(s, "u");
if (crc32("drFlMtrEtXwfTWv",15) == 4086963956) strcat(s, "v");
if (crc32("tawxwc",6) == 3188634836) strcat(s, "N");
if (crc32("rJNPfXsIxr",10) == 3433742268) strcat(s, "o");
if (crc32("FVyRLrVBqkGES",13) == 632351402) strcat(s, "f");
if (crc32("FJDVqvtbxDFe",12) == 3633694188) strcat(s, "l");
if (crc32("rfgCdYWn",8) == 40608530) strcat(s, "s");
if (crc32("fnvSkQLXEJ",10) == 486195179) strcat(s, "u");
if (crc32("jUyYVxNiVsAX",12) == 3175698887) strcat(s, "c");
if (crc32("kHFOqTDafxE",11) == 4141320763) strcat(s, "z");
if (crc32("EIuIdzeMv",9) == 138695415) strcat(s, "r");
if (crc32("wBfvxOrCtlKhq",13) == 2502654025) strcat(s, "a");
if (crc32("mjMifBBoC",9) == 1508419762) strcat(s, "l");
    return s;
}

char *agrostographic_adjectives() {
    char *s = calloc(15);
    if (crc32("onkYnde",7) == 4102772338) strcat(s, "a");
if (crc32("wfjXZnixZdsBj",13) == 857654971) strcat(s, "g");
if (crc32("UCUVDJywfhJEm",13) == 2665215892) strcat(s, "r");
if (crc32("SfUqQ",5) == 2017114633) strcat(s, "X");
if (crc32("CIAXlIRwKT",10) == 1960791020) strcat(s, "o");
if (crc32("jJEnPDkIlgbsNhz",15) == 2747915516) strcat(s, "s");
if (crc32("gWrLIJzFwbZbO",13) == 1207227747) strcat(s, "t");
if (crc32("BHOKbbEnQngT",12) == 4074138652) strcat(s, "N");
if (crc32("swNBTmKdL",9) == 3657257368) strcat(s, "o");
if (crc32("FLQcuhlFqYy",11) == 1164490231) strcat(s, "g");
if (crc32("VBQiZcZBUgKEYx",14) == 1101865624) strcat(s, "T");
if (crc32("TyoVpF",6) == 1777025528) strcat(s, "r");
if (crc32("BYOSYPt",7) == 3906760843) strcat(s, "a");
if (crc32("lhhRcngxn",9) == 2739968455) strcat(s, "p");
if (crc32("bEXpSecVb",9) == 2558453473) strcat(s, "h");
if (crc32("cQfCAdXzqJj",11) == 4080421726) strcat(s, "i");
if (crc32("GGHSTIfPqBnroE",14) == 770561705) strcat(s, "Q");
if (crc32("lKagsFIajJmSn",13) == 284325129) strcat(s, "c");
    return s;
}

char *outdated_adjectives() {
    char *s = calloc(9);
    if (crc32("AJZhYQdoEzL",11) == 3005743694) strcat(s, "o");
if (crc32("XZJirTNnzzkaX",13) == 2841617813) strcat(s, "O");
if (crc32("sCSEEOOFWirRAFF",15) == 2760245895) strcat(s, "u");
if (crc32("GcKwyiPlblmA",12) == 3761610953) strcat(s, "M");
if (crc32("otFNlFmrQwe",11) == 3285022408) strcat(s, "t");
if (crc32("cRGwHMxSSQ",10) == 3881851893) strcat(s, "f");
if (crc32("EXkvQHJZgnuepr",14) == 3022108169) strcat(s, "d");
if (crc32("kRSCUj",6) == 1030825155) strcat(s, "q");
if (crc32("nkERdfiWdCCGlS",14) == 1646163389) strcat(s, "a");
if (crc32("YovaI",5) == 3019770562) strcat(s, "t");
if (crc32("fprWjiiVUNtVvC",14) == 1242033684) strcat(s, "B");
if (crc32("YOKSioiZ",8) == 3170902320) strcat(s, "e");
if (crc32("TzTytdmeaZoTQiG",15) == 3595441230) strcat(s, "d");
    return s;
}

char *turbaned_adjectives() {
    char *s = calloc(9);
    if (crc32("zyeGPcubt",9) == 3092320085) strcat(s, "t");
if (crc32("rGJYGJrKIleOE",13) == 3602222145) strcat(s, "r");
if (crc32("POPEHfAClbGvPl",14) == 4046316741) strcat(s, "u");
if (crc32("NckebfNEmyt",11) == 4081278357) strcat(s, "r");
if (crc32("bTAYLCBegueOV",13) == 3565074910) strcat(s, "b");
if (crc32("CeToiQp",7) == 2864926123) strcat(s, "a");
if (crc32("DitlYkMhhvr",11) == 1294540948) strcat(s, "Z");
if (crc32("QUozSDYhLfEbLDr",15) == 11623073) strcat(s, "n");
if (crc32("UfFWkNxHWjQ",11) == 376873529) strcat(s, "p");
if (crc32("gCknFYRegR",10) == 224756857) strcat(s, "e");
if (crc32("dAKAcTjHVTFFnkr",15) == 3167001644) strcat(s, "d");
    return s;
}

char *syzygial_adjectives() {
    char *s = calloc(9);
    if (crc32("zVTYKZR",7) == 4233073995) strcat(s, "I");
if (crc32("PzSgkOQGRGdaV",13) == 1454414417) strcat(s, "s");
if (crc32("dLqDymGdEBfYjWF",15) == 354356165) strcat(s, "x");
if (crc32("oNdAo",5) == 3711588862) strcat(s, "y");
if (crc32("ffyLcvZ",7) == 804751777) strcat(s, "b");
if (crc32("wNweNGsoMxG",11) == 2623975848) strcat(s, "z");
if (crc32("nXBqgdk",7) == 3365812870) strcat(s, "p");
if (crc32("jUYQbAeVAhValTX",15) == 1280238320) strcat(s, "y");
if (crc32("fcmUcnsIIiyJLY",14) == 3984652989) strcat(s, "q");
if (crc32("doDrMqchtx",10) == 1674762328) strcat(s, "g");
if (crc32("XOeSRrD",7) == 4172479557) strcat(s, "i");
if (crc32("QyMVofTUwQMUGX",14) == 232304507) strcat(s, "a");
if (crc32("OnnOHu",6) == 3510557253) strcat(s, "l");
    return s;
}

char *lacerated_adjectives() {
    char *s = calloc(10);
    if (crc32("OMsicoyOBtOGF",13) == 126043653) strcat(s, "l");
if (crc32("UBNdu",5) == 26638503) strcat(s, "S");
if (crc32("TeFfpphYjcBcmq",14) == 3547781998) strcat(s, "a");
if (crc32("glVvuCLEQi",10) == 49723699) strcat(s, "c");
if (crc32("iiViAbSgIDKKOcQ",15) == 2175992843) strcat(s, "e");
if (crc32("DOwaIUVbROVekm",14) == 2302966710) strcat(s, "r");
if (crc32("KCgxwVHN",8) == 2683755108) strcat(s, "m");
if (crc32("VMSrYQmCoXlM",12) == 2634288731) strcat(s, "a");
if (crc32("KlmtlxyXVi",10) == 1993175260) strcat(s, "t");
if (crc32("AjHeBEkbmeIJFe",14) == 1425923828) strcat(s, "e");
if (crc32("ppicWfyoxu",10) == 2821495680) strcat(s, "M");
if (crc32("HJhLePKHPm",10) == 2129662063) strcat(s, "d");
    return s;
}

char *nondormant_adjectives() {
    char *s = calloc(11);
    if (crc32("ClqvHvCkXdfy",12) == 3039015094) strcat(s, "n");
if (crc32("DnDvcKJtR",9) == 1914857898) strcat(s, "W");
if (crc32("ljLPGWkApgEEmpK",15) == 1098558779) strcat(s, "o");
if (crc32("lnTLCNgtYhFvFxG",15) == 3980361983) strcat(s, "X");
if (crc32("vuYLIFYcYwjEls",14) == 1688237285) strcat(s, "n");
if (crc32("KDbLZeppxOcqEU",14) == 2511511565) strcat(s, "d");
if (crc32("WWQhAYpTffriE",13) == 1566184662) strcat(s, "o");
if (crc32("jJlvmSjce",9) == 135028797) strcat(s, "L");
if (crc32("hthZtMBuD",9) == 154080784) strcat(s, "r");
if (crc32("ANssKbnQmb",10) == 955813651) strcat(s, "m");
if (crc32("vbjbDesDNtJJESV",15) == 287929634) strcat(s, "h");
if (crc32("npJzIoY",7) == 3567242592) strcat(s, "a");
if (crc32("vgPFMfA",7) == 3413601811) strcat(s, "n");
if (crc32("oGiORBFmuQsmFW",14) == 1197798460) strcat(s, "t");
    return s;
}

char *Chaucerian_adjectives() {
    char *s = calloc(11);
    if (crc32("CBPam",5) == 3409259649) strcat(s, "C");
if (crc32("jWyfSeONii",10) == 3762737063) strcat(s, "s");
if (crc32("RcuXAkd",7) == 625205820) strcat(s, "h");
if (crc32("gKHDw",5) == 4229008306) strcat(s, "K");
if (crc32("ayANOuYxsHao",12) == 541267628) strcat(s, "a");
if (crc32("faoCf",5) == 1875161376) strcat(s, "u");
if (crc32("CeoHnUmWSGR",11) == 2387920371) strcat(s, "c");
if (crc32("kXfOMqjWesNdFZ",14) == 1449200779) strcat(s, "d");
if (crc32("sSYuvj",6) == 1945818994) strcat(s, "e");
if (crc32("mGTpClkje",9) == 2005078371) strcat(s, "i");
if (crc32("nZpmiWYDcERCA",13) == 3177112704) strcat(s, "r");
if (crc32("uhgpuGFNAt",10) == 3914991870) strcat(s, "i");
if (crc32("VSiBcbWWE",9) == 633711769) strcat(s, "g");
if (crc32("KaLNeqLwaQBLF",13) == 1055524991) strcat(s, "a");
if (crc32("TzdciRNQXJto",12) == 2365928407) strcat(s, "D");
if (crc32("kqNthbJjIH",10) == 3865380571) strcat(s, "n");
    return s;
}

char *unthreaded_adjectives() {
    char *s = calloc(11);
    if (crc32("rinhfMa",7) == 1054115318) strcat(s, "u");
if (crc32("eQiySicigc",10) == 2308167354) strcat(s, "u");
if (crc32("iwaGvczgpnEn",12) == 767916505) strcat(s, "O");
if (crc32("KuuDxIplPn",10) == 3821136482) strcat(s, "n");
if (crc32("JVaycdIUkdKWxjZ",15) == 2630232299) strcat(s, "t");
if (crc32("MKoZhhJlf",9) == 713831016) strcat(s, "h");
if (crc32("gDWuOzxy",8) == 2078273498) strcat(s, "r");
if (crc32("xpGyRA",6) == 3539938118) strcat(s, "p");
if (crc32("pazLgI",6) == 1175241367) strcat(s, "e");
if (crc32("gGLkeGotbW",10) == 944179610) strcat(s, "n");
if (crc32("ZGVPytOqz",9) == 2198564821) strcat(s, "a");
if (crc32("sitpj",5) == 560197720) strcat(s, "l");
if (crc32("DLelSEsWOFQTpY",14) == 1243375502) strcat(s, "d");
if (crc32("pfEuqt",6) == 2865040826) strcat(s, "p");
if (crc32("VyMDnqyRueNT",12) == 877104217) strcat(s, "e");
if (crc32("hWJcAX",6) == 3988542957) strcat(s, "d");
    return s;
}

char *unmasking_adjectives() {
    char *s = calloc(10);
    if (crc32("VacVziwjBt",10) == 451741089) strcat(s, "u");
if (crc32("AlmaYuizV",9) == 2568042349) strcat(s, "U");
if (crc32("UeApEmCfbx",10) == 1371892608) strcat(s, "n");
if (crc32("IXxYVIApwkRI",12) == 1400628370) strcat(s, "E");
if (crc32("OixoRBLfmQvBMe",14) == 2165789829) strcat(s, "m");
if (crc32("zoIXLhlUPaIfWu",14) == 3981222155) strcat(s, "a");
if (crc32("pMySAtpQPTvGJhm",15) == 4155658704) strcat(s, "s");
if (crc32("YHFkEhEBHhPR",12) == 3802048307) strcat(s, "l");
if (crc32("InZqy",5) == 921593692) strcat(s, "k");
if (crc32("oCdgbxnyyJKHZr",14) == 2304459563) strcat(s, "i");
if (crc32("eILzCjDxVhpyxs",14) == 2671697391) strcat(s, "R");
if (crc32("bPXMZcCOCbaX",12) == 3027218081) strcat(s, "n");
if (crc32("bVQamVReFzPct",13) == 1101729780) strcat(s, "g");
    return s;
}

char *agrostographical_adjectives() {
    char *s = calloc(17);
    if (crc32("oyVoQUocE",9) == 3864592862) strcat(s, "g");
if (crc32("ZWXRNILFJFdCzIz",15) == 3672873499) strcat(s, "a");
if (crc32("qgwwqbaa",8) == 3365924405) strcat(s, "g");
if (crc32("LQEuTnRjJ",9) == 1344724225) strcat(s, "o");
if (crc32("vPBVUcOzhcEuy",13) == 3766095553) strcat(s, "r");
if (crc32("fYWfbZzFoLigir",14) == 2406915972) strcat(s, "a");
if (crc32("ILSNGpAV",8) == 2228881282) strcat(s, "o");
if (crc32("nwQwCIcfMvXeZ",13) == 2894332817) strcat(s, "s");
if (crc32("XLgnUFPzzjvk",12) == 2444976099) strcat(s, "Z");
if (crc32("JahvfFHZKZwbBm",14) == 4278071015) strcat(s, "t");
if (crc32("DpjOMhPxFlwMNuq",15) == 2890186484) strcat(s, "o");
if (crc32("iLqbuNGUAE",10) == 3040954051) strcat(s, "g");
if (crc32("FykDfdz",7) == 2434124561) strcat(s, "r");
if (crc32("NzMKZkEgMJ",10) == 1742917361) strcat(s, "y");
if (crc32("LUqInDpZPLjKI",13) == 428836430) strcat(s, "a");
if (crc32("UuUQaoeQYQxU",12) == 2140308025) strcat(s, "j");
if (crc32("pbandWpKZbno",12) == 2732690067) strcat(s, "p");
if (crc32("ilUTFiLGrSvpsE",14) == 3060016151) strcat(s, "h");
if (crc32("kGvQEVaPLUIyJA",14) == 359084968) strcat(s, "I");
if (crc32("uxPDTYpZ",8) == 2087412857) strcat(s, "i");
if (crc32("DHCxKHysHnxLXav",15) == 993733643) strcat(s, "c");
if (crc32("vCUOySMcEqLRXj",14) == 3375367195) strcat(s, "L");
if (crc32("cBVTWH",6) == 364839773) strcat(s, "a");
if (crc32("gMUEsaVViVDFUfF",15) == 2662648924) strcat(s, "l");
    return s;
}

char *nonassimilable_adjectives() {
    char *s = calloc(15);
    if (crc32("NOEQy",5) == 515814392) strcat(s, "n");
if (crc32("JRvsGlcQ",8) == 1631344352) strcat(s, "z");
if (crc32("vJtJvmroYWkz",12) == 77767772) strcat(s, "o");
if (crc32("KAACXwkpKpfjF",13) == 3398902630) strcat(s, "H");
if (crc32("bcAmG",5) == 1173401075) strcat(s, "n");
if (crc32("HPiXgEwHNJOKA",13) == 656585443) strcat(s, "c");
if (crc32("srhpjNfQYbjn",12) == 4199797111) strcat(s, "a");
if (crc32("EmnnsnQG",8) == 2316945597) strcat(s, "s");
if (crc32("JoSBFzAllTQsX",13) == 2958089530) strcat(s, "s");
if (crc32("onDpvAjTylbLs",13) == 588970304) strcat(s, "a");
if (crc32("NqkEg",5) == 3896032694) strcat(s, "i");
if (crc32("RgJFdC",6) == 3043775648) strcat(s, "m");
if (crc32("mbvWvZrPzPFYHB",14) == 2761177148) strcat(s, "t");
if (crc32("stQbKH",6) == 1666101286) strcat(s, "i");
if (crc32("ysAFSn",6) == 1337912151) strcat(s, "l");
if (crc32("RhgFVNO",7) == 3378159914) strcat(s, "L");
if (crc32("zemQnwvUpEdXdU",14) == 3800440050) strcat(s, "a");
if (crc32("znYAQoD",7) == 1784077969) strcat(s, "R");
if (crc32("pUBQnUsHntwST",13) == 272081961) strcat(s, "b");
if (crc32("hwlRPNVjrOqkVOJ",15) == 2527635477) strcat(s, "I");
if (crc32("xOjHeYkHs",9) == 3288025047) strcat(s, "l");
if (crc32("rnUsbhQisHNeCA",14) == 3886432704) strcat(s, "x");
if (crc32("xCqtkbjP",8) == 4032110422) strcat(s, "e");
    return s;
}

char *drearies_adjectives() {
    char *s = calloc(9);
    if (crc32("QasvtRsEYY",10) == 1723732808) strcat(s, "g");
if (crc32("KnUYIftKfG",10) == 3344042848) strcat(s, "d");
if (crc32("XVXCOgK",7) == 1694108543) strcat(s, "d");
if (crc32("OaMhuqrX",8) == 3551657276) strcat(s, "r");
if (crc32("dhhxeCNl",8) == 4026871491) strcat(s, "e");
if (crc32("pCqCuwNZlgw",11) == 4254906601) strcat(s, "e");
if (crc32("VXQLAyzB",8) == 2299146661) strcat(s, "a");
if (crc32("gHBVscUmmOiCc",13) == 1349278838) strcat(s, "O");
if (crc32("IufCn",5) == 4062476928) strcat(s, "r");
if (crc32("YvHwLpzzoAAE",12) == 2742537651) strcat(s, "i");
if (crc32("IuMalP",6) == 3007791834) strcat(s, "E");
if (crc32("OyYWpoVyFKoGK",13) == 1728743869) strcat(s, "e");
if (crc32("dePjApBKEUv",11) == 12514125) strcat(s, "s");
    return s;
}

char *curdiest_adjectives() {
    char *s = calloc(9);
    if (crc32("sIBrrzxc",8) == 4242614261) strcat(s, "c");
if (crc32("vilrVMjPSn",10) == 1952955242) strcat(s, "T");
if (crc32("vHHzfEALeYsCVc",14) == 2116821506) strcat(s, "u");
if (crc32("SPPsqtbG",8) == 1744086594) strcat(s, "c");
if (crc32("crdNK",5) == 430705656) strcat(s, "r");
if (crc32("WXqkeV",6) == 2779354621) strcat(s, "d");
if (crc32("RfOSO",5) == 3632459557) strcat(s, "Y");
if (crc32("wIsrrixZPo",10) == 2799218628) strcat(s, "i");
if (crc32("YwwliIVixLSgBB",14) == 10465603) strcat(s, "N");
if (crc32("FVKwCXcxyAa",11) == 1995607513) strcat(s, "e");
if (crc32("POXGxdlifgJnmQa",15) == 1564222304) strcat(s, "s");
if (crc32("JqwSMDztcazTI",13) == 1779571984) strcat(s, "G");
if (crc32("GpvWsivMTPUIhAU",15) == 1023111628) strcat(s, "t");
    return s;
}

char *ferny_adjectives() {
    char *s = calloc(6);
    if (crc32("gHQkkQfq",8) == 2745353014) strcat(s, "B");
if (crc32("dMGpDAInmh",10) == 492701549) strcat(s, "f");
if (crc32("QYgYoWeOSedj",12) == 1682137268) strcat(s, "e");
if (crc32("zSIgNgkzqdvHK",13) == 2831890798) strcat(s, "s");
if (crc32("RFjAmEcIOEfQmSg",15) == 3983018210) strcat(s, "r");
if (crc32("niehJZUU",8) == 3762941111) strcat(s, "G");
if (crc32("qrLiwvOlHlSuU",13) == 1552893906) strcat(s, "n");
if (crc32("IwZNuJGLjupk",12) == 3238757583) strcat(s, "y");
    return s;
}

char *ionizable_adjectives() {
    char *s = calloc(10);
    if (crc32("czHHRSYW",8) == 1767774551) strcat(s, "i");
if (crc32("VecmFuuaOmTBuNN",15) == 2850158292) strcat(s, "o");
if (crc32("GLvKgb",6) == 2231848522) strcat(s, "n");
if (crc32("CBuZoRCEjWbXySs",15) == 4110864079) strcat(s, "i");
if (crc32("wAUCRER",7) == 1856384572) strcat(s, "z");
if (crc32("qqafF",5) == 3848290532) strcat(s, "L");
if (crc32("JLqzTkf",7) == 2362459828) strcat(s, "a");
if (crc32("iTwCAnHBDcyn",12) == 3251096334) strcat(s, "L");
if (crc32("nysvDXJ",7) == 152472414) strcat(s, "b");
if (crc32("TfUCizsmV",9) == 2177438173) strcat(s, "y");
if (crc32("tyjtshgbIQpHzxn",15) == 2796545217) strcat(s, "l");
if (crc32("mqnTUrxy",8) == 4264021877) strcat(s, "e");
    return s;
}

char *chuckfull_adjectives() {
    char *s = calloc(10);
    if (crc32("uHmvEP",6) == 4261150673) strcat(s, "c");
if (crc32("sXoFbCoGl",9) == 3758063074) strcat(s, "h");
if (crc32("iUDFMn",6) == 3782671493) strcat(s, "u");
if (crc32("QYulHmDpyYQ",11) == 3262085306) strcat(s, "c");
if (crc32("bmOmPGDuNFJ",11) == 2279077354) strcat(s, "c");
if (crc32("IzkOrj",6) == 225979300) strcat(s, "k");
if (crc32("EiIkv",5) == 1346062471) strcat(s, "f");
if (crc32("wYybbJqcxucn",12) == 604979774) strcat(s, "u");
if (crc32("QFjNkKfxFvu",11) == 1276380953) strcat(s, "Q");
if (crc32("UcmdXsKFUA",10) == 1307878235) strcat(s, "l");
if (crc32("EnVnVVdSYdnJcF",14) == 2563910333) strcat(s, "t");
if (crc32("uhifN",5) == 3964082007) strcat(s, "l");
    return s;
}

char *irrefragable_adjectives() {
    char *s = calloc(13);
    if (crc32("rGSZvRvv",8) == 196701891) strcat(s, "W");
if (crc32("TKQmte",6) == 1288412043) strcat(s, "i");
if (crc32("uGVsosE",7) == 3197582344) strcat(s, "r");
if (crc32("fBeZcYCJ",8) == 2366349852) strcat(s, "r");
if (crc32("PpucJgEMSSh",11) == 666100363) strcat(s, "O");
if (crc32("PDkkhn",6) == 3216289518) strcat(s, "e");
if (crc32("nrcexHjBoCz",11) == 2422254375) strcat(s, "f");
if (crc32("snMkMLIqIywqwd",14) == 2981196652) strcat(s, "Q");
if (crc32("Ncnpmq",6) == 576420610) strcat(s, "r");
if (crc32("MoQLMytK",8) == 1754705302) strcat(s, "a");
if (crc32("cDAOSaTwqv",10) == 3112901847) strcat(s, "g");
if (crc32("WIREjDbNjslNPd",14) == 4059446256) strcat(s, "a");
if (crc32("kPWRrVyLAKTWY",13) == 3747193654) strcat(s, "b");
if (crc32("oGVMSTD",7) == 4091742682) strcat(s, "i");
if (crc32("NTHVyIhHx",9) == 3194147425) strcat(s, "l");
if (crc32("zkxCXPTficZ",11) == 3297172232) strcat(s, "Q");
if (crc32("hERTEhj",7) == 168715455) strcat(s, "e");
    return s;
}

char *nonoptimistic_adjectives() {
    char *s = calloc(14);
    if (crc32("OXWdOzgrYMtJFQ",14) == 3654958190) strcat(s, "I");
if (crc32("lAIOyueqnfuE",12) == 1884744922) strcat(s, "n");
if (crc32("isUwbMdWoMSnCA",14) == 1461772216) strcat(s, "E");
if (crc32("qaXwDcoYKJXUz",13) == 1213558334) strcat(s, "o");
if (crc32("eEUwsATskq",10) == 971375158) strcat(s, "y");
if (crc32("iacNhRkDZjzx",12) == 1628321066) strcat(s, "n");
if (crc32("QGZOWc",6) == 2622941517) strcat(s, "O");
if (crc32("oIdGPWGprlaUMF",14) == 2893524030) strcat(s, "o");
if (crc32("boJpFQeSId",10) == 4286382403) strcat(s, "i");
if (crc32("XUTBG",5) == 1943073631) strcat(s, "p");
if (crc32("mMDST",5) == 1157462631) strcat(s, "t");
if (crc32("TjNSlQfNqqGvak",14) == 3137980778) strcat(s, "i");
if (crc32("mhcZcDLaMs",10) == 1600876644) strcat(s, "Q");
if (crc32("NrUomuLt",8) == 4113663781) strcat(s, "m");
if (crc32("WdxBwMJPMWieYXT",15) == 723515998) strcat(s, "J");
if (crc32("NlUjiWjy",8) == 66327942) strcat(s, "i");
if (crc32("ZNwQnIX",7) == 510952514) strcat(s, "C");
if (crc32("ppHLqjiVrOW",11) == 876317048) strcat(s, "s");
if (crc32("sXAUEnUJAz",10) == 2151989484) strcat(s, "W");
if (crc32("vAOdneuuB",9) == 335277559) strcat(s, "t");
if (crc32("XRNrTbfFazijn",13) == 3759265442) strcat(s, "d");
if (crc32("WRlKuXLBNxXFKiw",15) == 3841379865) strcat(s, "i");
if (crc32("UEwidUvEIeNEF",13) == 3023108904) strcat(s, "c");
    return s;
}

char *overpartial_adjectives() {
    char *s = calloc(12);
    if (crc32("aLaRLmJW",8) == 4254684488) strcat(s, "h");
if (crc32("NUyAxsutHWc",11) == 3508922282) strcat(s, "o");
if (crc32("jbNlECshC",9) == 3682369073) strcat(s, "v");
if (crc32("XOrtOyHBK",9) == 1111695532) strcat(s, "S");
if (crc32("cykVZmUGiU",10) == 2723236806) strcat(s, "e");
if (crc32("aSuuKVzvmc",10) == 1313516325) strcat(s, "r");
if (crc32("ewBib",5) == 92610097) strcat(s, "p");
if (crc32("xQDcAPFIgvonPT",14) == 2405135253) strcat(s, "a");
if (crc32("wsklXedrgGV",11) == 2084664620) strcat(s, "Y");
if (crc32("zGltu",5) == 1500669170) strcat(s, "r");
if (crc32("oadwigpZFgG",11) == 3510244737) strcat(s, "t");
if (crc32("jfwVZRfntkBy",12) == 3611721102) strcat(s, "i");
if (crc32("GzLTOqXYOlKbD",13) == 3335970663) strcat(s, "a");
if (crc32("WlUPXPtfFi",10) == 3733088149) strcat(s, "l");
    return s;
}

char *nonastronomical_adjectives() {
    char *s = calloc(16);
    if (crc32("zINDTJWoL",9) == 4167913929) strcat(s, "n");
if (crc32("PjblIeDRF",9) == 321008027) strcat(s, "J");
if (crc32("doBFEhKDj",9) == 3487863683) strcat(s, "o");
if (crc32("YoCEO",5) == 2312464682) strcat(s, "n");
if (crc32("GizeuCjH",8) == 1823226981) strcat(s, "b");
if (crc32("BVvSVMx",7) == 1211989923) strcat(s, "a");
if (crc32("vxmzTgnHn",9) == 3780963999) strcat(s, "s");
if (crc32("QognrCvACgNcgdZ",15) == 3060067515) strcat(s, "J");
if (crc32("MDcqlAPsSOmjHP",14) == 1061600321) strcat(s, "t");
if (crc32("PeLBSDL",7) == 3474692749) strcat(s, "r");
if (crc32("TnpkiKxrn",9) == 2319630300) strcat(s, "q");
if (crc32("WbVWGMhKjAkW",12) == 41041196) strcat(s, "o");
if (crc32("uYFljRLZdT",10) == 3091069766) strcat(s, "n");
if (crc32("JyGwhPuREAb",11) == 3754765816) strcat(s, "O");
if (crc32("IiDytuqza",9) == 756073333) strcat(s, "o");
if (crc32("tCoewOWJNAY",11) == 1672087252) strcat(s, "m");
if (crc32("vYHQAz",6) == 215974051) strcat(s, "d");
if (crc32("oAIPVjQpUI",10) == 4182885386) strcat(s, "i");
if (crc32("DopjBHtiEnVR",12) == 3672103677) strcat(s, "C");
if (crc32("uYXEmOVVOtbQ",12) == 3037254149) strcat(s, "c");
if (crc32("arffUCFJof",10) == 1003371431) strcat(s, "a");
if (crc32("zJOfLrZhY",9) == 3585742033) strcat(s, "l");
    return s;
}

char *furthermost_adjectives() {
    char *s = calloc(12);
    if (crc32("MPeQaFV",7) == 162838470) strcat(s, "u");
if (crc32("svBvOTOqO",9) == 2126147587) strcat(s, "f");
if (crc32("QgkCnwC",7) == 149269279) strcat(s, "m");
if (crc32("FIISZfK",7) == 2906235314) strcat(s, "u");
if (crc32("THEJooJH",8) == 259014000) strcat(s, "W");
if (crc32("TvfvpMCHNhmC",12) == 1731571697) strcat(s, "r");
if (crc32("ZtbgTaPLoVA",11) == 1191013973) strcat(s, "x");
if (crc32("lbfDlljvOoI",11) == 1587570906) strcat(s, "t");
if (crc32("ZnLAqk",6) == 1980478219) strcat(s, "h");
if (crc32("qXeLvQ",6) == 1773025098) strcat(s, "e");
if (crc32("xZvNtDVwIGYf",12) == 3964161619) strcat(s, "f");
if (crc32("OkyUsBZcsm",10) == 3863658144) strcat(s, "r");
if (crc32("pMldrIaDgk",10) == 1010942706) strcat(s, "b");
if (crc32("VUzHGIANO",9) == 2761595911) strcat(s, "m");
if (crc32("HPrRT",5) == 172362582) strcat(s, "o");
if (crc32("duerFnQXBNR",11) == 3842354222) strcat(s, "o");
if (crc32("SxfAvZQTqhJA",12) == 403736841) strcat(s, "s");
if (crc32("SrTtJeyLV",9) == 1100848025) strcat(s, "y");
if (crc32("mUjOfvOTSmG",11) == 1808428538) strcat(s, "t");
    return s;
}

char *dink_adjectives() {
    char *s = calloc(5);
    if (crc32("JoQIXVs",7) == 546839638) strcat(s, "d");
if (crc32("PSgLLyUZv",9) == 4034812186) strcat(s, "Q");
if (crc32("nndUeUtekpiVHx",14) == 1833610602) strcat(s, "i");
if (crc32("DxhtvGSbwfaFt",13) == 1605524555) strcat(s, "n");
if (crc32("RFOUmtgFayexAOW",15) == 3364045095) strcat(s, "k");
    return s;
}

char *anticentralization_adjectives() {
    char *s = calloc(19);
    if (crc32("UhYwpbBHIBtlvt",14) == 2207364284) strcat(s, "X");
if (crc32("aBscWDvnAzA",11) == 2371582544) strcat(s, "a");
if (crc32("EcSZebgPiAZLuzO",15) == 1030288251) strcat(s, "n");
if (crc32("AVloQpqvieF",11) == 3212972926) strcat(s, "t");
if (crc32("FoBLYxjcDws",11) == 2383167484) strcat(s, "i");
if (crc32("iRZtaUu",7) == 4199289504) strcat(s, "c");
if (crc32("FSoBgm",6) == 513057719) strcat(s, "e");
if (crc32("fkdfBFnypyD",11) == 217575417) strcat(s, "n");
if (crc32("UmBNJBdWBD",10) == 2360236657) strcat(s, "t");
if (crc32("UrCWRvozHM",10) == 515412606) strcat(s, "r");
if (crc32("DZmqpmTAy",9) == 469979892) strcat(s, "S");
if (crc32("fQXbjWtlPy",10) == 3575534191) strcat(s, "a");
if (crc32("fHDzXf",6) == 1557881969) strcat(s, "P");
if (crc32("osjCsQpGMUGu",12) == 3185272765) strcat(s, "l");
if (crc32("RxqAsHYo",8) == 1857552223) strcat(s, "J");
if (crc32("RQjUmPz",7) == 2344743371) strcat(s, "i");
if (crc32("KpjTnp",6) == 1495945935) strcat(s, "Q");
if (crc32("cdeJPi",6) == 2888861269) strcat(s, "z");
if (crc32("xalRIFkoabYKlQQ",15) == 3135771247) strcat(s, "R");
if (crc32("BSgQJqxocyb",11) == 2335980550) strcat(s, "a");
if (crc32("PvduYnSKfNCK",12) == 1506502364) strcat(s, "t");
if (crc32("QEGxPrVBURnoBM",14) == 2690348607) strcat(s, "i");
if (crc32("IMxiXLcJ",8) == 2055515309) strcat(s, "R");
if (crc32("wbofGaRfoTsawIO",15) == 63460020) strcat(s, "o");
if (crc32("zgIdm",5) == 2657666496) strcat(s, "n");
    return s;
}

char *fishable_adjectives() {
    char *s = calloc(9);
    if (crc32("uXTKBd",6) == 1384041417) strcat(s, "f");
if (crc32("MxDxvtJIUo",10) == 4059014381) strcat(s, "i");
if (crc32("pLLvoyHl",8) == 129522651) strcat(s, "j");
if (crc32("MRQIJXhizCGQdt",14) == 2439624922) strcat(s, "s");
if (crc32("EvcVXR",6) == 778093176) strcat(s, "h");
if (crc32("FxCzMmIBSpfW",12) == 3528123704) strcat(s, "c");
if (crc32("Fvxkvj",6) == 542811961) strcat(s, "a");
if (crc32("aoLHXbj",7) == 2128324675) strcat(s, "p");
if (crc32("rFbDak",6) == 1621186594) strcat(s, "b");
if (crc32("xWVrtmM",7) == 2581915175) strcat(s, "M");
if (crc32("juZfKatz",8) == 3753733905) strcat(s, "l");
if (crc32("ApSYvN",6) == 3722480975) strcat(s, "E");
if (crc32("CSIpS",5) == 2732571199) strcat(s, "e");
    return s;
}

char *unstoneable_adjectives() {
    char *s = calloc(12);
    if (crc32("XioXPCOQAQYswl",14) == 4204745691) strcat(s, "u");
if (crc32("WSjWMztGegdb",12) == 1630638427) strcat(s, "n");
if (crc32("EzGsK",5) == 4280351549) strcat(s, "f");
if (crc32("WwKvHrSmGaBz",12) == 1454559581) strcat(s, "s");
if (crc32("UsZdyVf",7) == 4088183492) strcat(s, "e");
if (crc32("fupYfmtqCeY",11) == 2188388853) strcat(s, "t");
if (crc32("QtLwHdqQXa",10) == 2524424751) strcat(s, "s");
if (crc32("NDPAhBgLmdJI",12) == 1871126157) strcat(s, "o");
if (crc32("nFqKHsltcYAvu",13) == 2354690170) strcat(s, "R");
if (crc32("cbgPfFinVWXfOzG",15) == 3115452604) strcat(s, "n");
if (crc32("VQzhlwTugBB",11) == 1304084731) strcat(s, "L");
if (crc32("ZaeNxfpM",8) == 4135351501) strcat(s, "e");
if (crc32("wJzhhQwn",8) == 750525377) strcat(s, "A");
if (crc32("iBMHUDCszFi",11) == 1193446588) strcat(s, "a");
if (crc32("FupEYvFXMCILUpq",15) == 3669896293) strcat(s, "b");
if (crc32("NKEbPxLD",8) == 3505473885) strcat(s, "T");
if (crc32("OAZlCY",6) == 113328375) strcat(s, "l");
if (crc32("UfnwqG",6) == 2938689643) strcat(s, "e");
    return s;
}

char *unpledged_adjectives() {
    char *s = calloc(10);
    if (crc32("yWBCbivtWLoSmL",14) == 189611805) strcat(s, "u");
if (crc32("OVkxMySww",9) == 1837013477) strcat(s, "d");
if (crc32("JVuTVdoxqEg",11) == 3981494748) strcat(s, "n");
if (crc32("TwbjtEOYcECJovR",15) == 1763012119) strcat(s, "J");
if (crc32("bvIETRswyOURU",13) == 1114523936) strcat(s, "p");
if (crc32("zFBQGzBhLZ",10) == 1088901198) strcat(s, "l");
if (crc32("EfvkiBfzxqQg",12) == 3022285121) strcat(s, "e");
if (crc32("zzcKNEPodPVtD",13) == 2217633249) strcat(s, "a");
if (crc32("NGtIGPaxs",9) == 2773504455) strcat(s, "d");
if (crc32("NVBCrLFQ",8) == 3747898019) strcat(s, "M");
if (crc32("xNFszfpth",9) == 3404527593) strcat(s, "g");
if (crc32("HXSxyZFrfdp",11) == 1175153654) strcat(s, "e");
if (crc32("ddbpDW",6) == 3939575020) strcat(s, "d");
    return s;
}

char *unrecusant_adjectives() {
    char *s = calloc(11);
    if (crc32("FVOeMFqiBqWa",12) == 666570613) strcat(s, "u");
if (crc32("XYRyKSnfmZy",11) == 3734756696) strcat(s, "n");
if (crc32("HuZdtcJxEG",10) == 3926950600) strcat(s, "r");
if (crc32("krWPqNBUFHXtm",13) == 283888541) strcat(s, "T");
if (crc32("pfoGInBF",8) == 3418371663) strcat(s, "e");
if (crc32("FvJdUEDEA",9) == 4125071009) strcat(s, "c");
if (crc32("eZNqpn",6) == 3986067152) strcat(s, "V");
if (crc32("hEoXFlLeVjfrN",13) == 1208649971) strcat(s, "u");
if (crc32("uVikpiaWyvHA",12) == 539365202) strcat(s, "s");
if (crc32("LkixmrwHjmn",11) == 2540151352) strcat(s, "a");
if (crc32("XmYYNqdMTRqhpR",14) == 3549254360) strcat(s, "E");
if (crc32("qmGPToH",7) == 3004214072) strcat(s, "n");
if (crc32("EXRSUJu",7) == 127798421) strcat(s, "V");
if (crc32("miHZfLDitCrmn",13) == 1472606259) strcat(s, "t");
    return s;
}

char *prefeudal_adjectives() {
    char *s = calloc(10);
    if (crc32("rBnslDocA",9) == 1106240227) strcat(s, "p");
if (crc32("TrFcBhvYfnFnj",13) == 2788524166) strcat(s, "G");
if (crc32("gvLxZZBKWCIM",12) == 3713338256) strcat(s, "r");
if (crc32("noOtvMGIggoyAzP",15) == 2009226607) strcat(s, "e");
if (crc32("zAFNqKqy",8) == 884803410) strcat(s, "f");
if (crc32("YuEXdFXmGylkie",14) == 3601659124) strcat(s, "e");
if (crc32("ZdjVVc",6) == 1495597455) strcat(s, "k");
if (crc32("BQsJLxvlaDq",11) == 1539078728) strcat(s, "u");
if (crc32("lfAjHNyce",9) == 984178489) strcat(s, "d");
if (crc32("sGUsmQqkcJclmpG",15) == 3535555050) strcat(s, "V");
if (crc32("VmIEm",5) == 2038166082) strcat(s, "a");
if (crc32("isaNHSVhr",9) == 3825766537) strcat(s, "t");
if (crc32("yJPeApasbPkFjSU",15) == 2326625944) strcat(s, "l");
    return s;
}

char *bacchantic_adjectives() {
    char *s = calloc(11);
    if (crc32("pIyGmmpa",8) == 1121384854) strcat(s, "b");
if (crc32("EHMXoy",6) == 1186556140) strcat(s, "a");
if (crc32("iqmUScaJOa",10) == 4108848784) strcat(s, "c");
if (crc32("mbyUgJsf",8) == 2500067977) strcat(s, "c");
if (crc32("jgOlqBlNvxmsOoA",15) == 939787343) strcat(s, "L");
if (crc32("oXhsbOewCGtHjat",15) == 1593436011) strcat(s, "h");
if (crc32("Bevpn",5) == 1033951822) strcat(s, "a");
if (crc32("uqnuaOJOgGF",11) == 2323144697) strcat(s, "q");
if (crc32("PruEJUD",7) == 2933619005) strcat(s, "n");
if (crc32("HOYHh",5) == 1970443686) strcat(s, "t");
if (crc32("clGHmoknxR",10) == 1414855753) strcat(s, "i");
if (crc32("iihwvz",6) == 1820462438) strcat(s, "c");
    return s;
}

char *deeplaid_adjectives() {
    char *s = calloc(9);
    if (crc32("GRxZr",5) == 3913820235) strcat(s, "d");
if (crc32("ZujVmDSJyX",10) == 3508019635) strcat(s, "r");
if (crc32("JIdoLNYgwa",10) == 259249987) strcat(s, "e");
if (crc32("PecKPFn",7) == 345174253) strcat(s, "e");
if (crc32("IuoDZxDbpXpRb",13) == 1939671671) strcat(s, "m");
if (crc32("OVyyvt",6) == 2609247469) strcat(s, "p");
if (crc32("lubaFTazMFnhgbr",15) == 454278915) strcat(s, "l");
if (crc32("BOrHpwarlffZZ",13) == 1129569911) strcat(s, "a");
if (crc32("wZUuSqwOlJQjCLX",15) == 4290305547) strcat(s, "j");
if (crc32("wTlcCrHIxk",10) == 4077405119) strcat(s, "i");
if (crc32("gFmqwVJlIL",10) == 906565631) strcat(s, "d");
    return s;
}

char *preachier_adjectives() {
    char *s = calloc(10);
    if (crc32("PRjxZESUUi",10) == 1139532770) strcat(s, "N");
if (crc32("UcJfmb",6) == 4161744687) strcat(s, "p");
if (crc32("VgGJduKdUybO",12) == 320974076) strcat(s, "r");
if (crc32("oaOGeMwO",8) == 2807217245) strcat(s, "e");
if (crc32("oJtragXtQXY",11) == 3148673462) strcat(s, "a");
if (crc32("OrryNAztAZwPnd",14) == 1629787734) strcat(s, "j");
if (crc32("uopSBj",6) == 2611103993) strcat(s, "c");
if (crc32("XubFrEpNI",9) == 348665030) strcat(s, "h");
if (crc32("iDOcMq",6) == 3631828040) strcat(s, "i");
if (crc32("nDwKACg",7) == 656867133) strcat(s, "a");
if (crc32("DMHfkEefiLr",11) == 702966822) strcat(s, "e");
if (crc32("oyXGZEnKKFeZ",12) == 801677210) strcat(s, "n");
if (crc32("QUKAYUTc",8) == 1532061110) strcat(s, "r");
    return s;
}

char *winglike_adjectives() {
    char *s = calloc(9);
    if (crc32("BsFBmvDB",8) == 2002632342) strcat(s, "Y");
if (crc32("LCMaBBcKgE",10) == 113242634) strcat(s, "w");
if (crc32("ianpGTcZ",8) == 4219050482) strcat(s, "G");
if (crc32("QwGmTBln",8) == 4071481875) strcat(s, "i");
if (crc32("QWWhBfw",7) == 4080842773) strcat(s, "n");
if (crc32("FqDvugIuUOY",11) == 1053726035) strcat(s, "E");
if (crc32("HjsThkCZAM",10) == 1362078584) strcat(s, "g");
if (crc32("zyPzZ",5) == 1369827139) strcat(s, "l");
if (crc32("kwOrb",5) == 459012249) strcat(s, "i");
if (crc32("wVOqVMiKheoH",12) == 471376132) strcat(s, "I");
if (crc32("BIMEAdkPH",9) == 220186645) strcat(s, "k");
if (crc32("RSlBG",5) == 3894388626) strcat(s, "s");
if (crc32("IumiUQTjiJyiib",14) == 3143588941) strcat(s, "e");
    return s;
}

char *closewinded_adjectives() {
    char *s = calloc(12);
    if (crc32("ZmYhdK",6) == 1831589317) strcat(s, "c");
if (crc32("ymfAFqx",7) == 2688936395) strcat(s, "J");
if (crc32("nTWjvP",6) == 1329287403) strcat(s, "l");
if (crc32("wGuyJQIzi",9) == 1021903907) strcat(s, "o");
if (crc32("IJGUmWVF",8) == 1563495643) strcat(s, "U");
if (crc32("GRmMBvgZhd",10) == 3109626550) strcat(s, "s");
if (crc32("uUXdpE",6) == 1915811122) strcat(s, "e");
if (crc32("xKEIPSzIQT",10) == 3983478678) strcat(s, "g");
if (crc32("pITGpwXYgLhFl",13) == 2683679515) strcat(s, "w");
if (crc32("BmfcAFACmslaAsr",15) == 3859049266) strcat(s, "i");
if (crc32("pOlNtFpDwemnI",13) == 87482487) strcat(s, "q");
if (crc32("jmNZrfMljGQh",12) == 1835991123) strcat(s, "n");
if (crc32("zNkhDPnBJLamsim",15) == 4281237669) strcat(s, "d");
if (crc32("LiaWFOPTyfpswhy",15) == 3770837055) strcat(s, "O");
if (crc32("WjPAJOXI",8) == 2383877087) strcat(s, "e");
if (crc32("jQsSQNym",8) == 2548390970) strcat(s, "d");
    return s;
}

char *remillable_adjectives() {
    char *s = calloc(11);
    if (crc32("lFteYd",6) == 2460007991) strcat(s, "r");
if (crc32("oerlQTca",8) == 2582174076) strcat(s, "d");
if (crc32("IPpCBXaFnJn",11) == 3818302521) strcat(s, "e");
if (crc32("qpTiCp",6) == 2576232703) strcat(s, "W");
if (crc32("DsKkwTI",7) == 3824416656) strcat(s, "m");
if (crc32("LcIkyP",6) == 549635604) strcat(s, "i");
if (crc32("vpXqheSNMDsrpSf",15) == 4035612223) strcat(s, "l");
if (crc32("alByIJavnJOh",12) == 1667834829) strcat(s, "Z");
if (crc32("PcsDYjJq",8) == 1951273930) strcat(s, "l");
if (crc32("zlOSMKagAtYx",12) == 2463230785) strcat(s, "a");
if (crc32("locNEcmgcYQH",12) == 793204010) strcat(s, "U");
if (crc32("XZlrgkXK",8) == 3917437266) strcat(s, "b");
if (crc32("cVIdcdtlq",9) == 2235360812) strcat(s, "l");
if (crc32("tqfVeSX",7) == 169215542) strcat(s, "j");
if (crc32("toVDfOnST",9) == 4238153537) strcat(s, "e");
    return s;
}

char *gynaecocratic_adjectives() {
    char *s = calloc(14);
    if (crc32("OKItBVutkHSOFM",14) == 519270267) strcat(s, "g");
if (crc32("BiEasIhTZKOe",12) == 1981701292) strcat(s, "R");
if (crc32("RixljYWZxc",10) == 97024943) strcat(s, "y");
if (crc32("oadtJcA",7) == 1900558307) strcat(s, "B");
if (crc32("bOlEdrJ",7) == 1268635726) strcat(s, "n");
if (crc32("POXGFJvTnQzM",12) == 3954989896) strcat(s, "B");
if (crc32("ppksMSOSIGuHaj",14) == 1280711089) strcat(s, "a");
if (crc32("MdmSujYlB",9) == 2857394227) strcat(s, "e");
if (crc32("qybII",5) == 1901052738) strcat(s, "c");
if (crc32("PniPopLkNcxTg",13) == 45167847) strcat(s, "o");
if (crc32("WapyuT",6) == 1515326450) strcat(s, "P");
if (crc32("WaOIpd",6) == 3720865154) strcat(s, "c");
if (crc32("OSFHkcBNVAbhWQ",14) == 1935644517) strcat(s, "r");
if (crc32("KCzrJunujUkNNZi",15) == 1811000005) strcat(s, "O");
if (crc32("IxFxXy",6) == 4010897860) strcat(s, "a");
if (crc32("ZHEZY",5) == 3465757440) strcat(s, "t");
if (crc32("gBxJoyE",7) == 4285099067) strcat(s, "U");
if (crc32("xzQvYEHfvaDaH",13) == 4079396969) strcat(s, "i");
if (crc32("lXFnFpP",7) == 1065844385) strcat(s, "T");
if (crc32("pGDqFLXt",8) == 4199585079) strcat(s, "c");
    return s;
}

char *dawnlike_adjectives() {
    char *s = calloc(9);
    if (crc32("caWzutbyWG",10) == 88710866) strcat(s, "d");
if (crc32("HvPMmHPjsFXuaX",14) == 2303315485) strcat(s, "C");
if (crc32("kqTxuyPhC",9) == 1634109261) strcat(s, "a");
if (crc32("JBNSmxiOgnrI",12) == 3952491801) strcat(s, "U");
if (crc32("vfRrTnEBb",9) == 2153568378) strcat(s, "w");
if (crc32("oTxeAVivCcGjVU",14) == 303422696) strcat(s, "n");
if (crc32("YWGDlWHgEAPEhw",14) == 2413082629) strcat(s, "K");
if (crc32("PXnwlBacDdQKSE",14) == 1321648027) strcat(s, "l");
if (crc32("GmZfnwvxhdMkAG",14) == 2556083880) strcat(s, "i");
if (crc32("YbGHwwyKmOND",12) == 3926291857) strcat(s, "k");
if (crc32("EJxWWtBCiHn",11) == 1344488619) strcat(s, "L");
if (crc32("gTcORcp",7) == 678039940) strcat(s, "e");
    return s;
}

char *methodical_adjectives() {
    char *s = calloc(11);
    if (crc32("nfRAafIGzeTfEMj",15) == 4244600961) strcat(s, "D");
if (crc32("yMamskFZtRW",11) == 1737506058) strcat(s, "m");
if (crc32("OBPMTH",6) == 3146909702) strcat(s, "u");
if (crc32("FkZIVVutuJBI",12) == 1663768164) strcat(s, "e");
if (crc32("RBVVKLcQft",10) == 3999290622) strcat(s, "g");
if (crc32("TzKyFpMRwHVKh",13) == 3217716730) strcat(s, "t");
if (crc32("dsfYeUFsM",9) == 2680949788) strcat(s, "z");
if (crc32("SPtZZIqjFIzave",14) == 687196066) strcat(s, "h");
if (crc32("AwqimNLagUchG",13) == 1979377257) strcat(s, "I");
if (crc32("lbkbIbNZV",9) == 2122945523) strcat(s, "o");
if (crc32("bvuKKMWfMUwQpSR",15) == 2247295475) strcat(s, "N");
if (crc32("czjgxhTqnora",12) == 3990636442) strcat(s, "d");
if (crc32("twNsxbPsJuqR",12) == 107994139) strcat(s, "i");
if (crc32("AeuEvjJfqJbRz",13) == 3571143231) strcat(s, "j");
if (crc32("RaAQIjcHJfHpr",13) == 498681209) strcat(s, "c");
if (crc32("RCHxeMlV",8) == 2060983313) strcat(s, "n");
if (crc32("WQCxvcuvv",9) == 907855425) strcat(s, "a");
if (crc32("zzXSeruVh",9) == 3960204269) strcat(s, "E");
if (crc32("WSbXDQNDcjqRLox",15) == 897931303) strcat(s, "l");
    return s;
}

char *saporous_adjectives() {
    char *s = calloc(9);
    if (crc32("aHZWJMR",7) == 1459763476) strcat(s, "Z");
if (crc32("OEXjiOtt",8) == 2434845475) strcat(s, "s");
if (crc32("VbfczoAB",8) == 3703835427) strcat(s, "a");
if (crc32("UJNFW",5) == 2099116346) strcat(s, "Y");
if (crc32("tRdAR",5) == 2293062491) strcat(s, "p");
if (crc32("ExuOPWUZdCCW",12) == 4090025662) strcat(s, "o");
if (crc32("MkgDCtfkuUxfnlE",15) == 1660807703) strcat(s, "r");
if (crc32("VObZmeN",7) == 2915359655) strcat(s, "r");
if (crc32("QWZjhImWXWhyn",13) == 2841002645) strcat(s, "o");
if (crc32("yAVAaOlqrlyCNd",14) == 808373158) strcat(s, "p");
if (crc32("MHvBaQupOYncM",13) == 1087816021) strcat(s, "u");
if (crc32("ZUwGrRmqbjGNFP",14) == 391864976) strcat(s, "s");
    return s;
}

char *unalphabetical_adjectives() {
    char *s = calloc(15);
    if (crc32("elCYMkTDzgF",11) == 1590034757) strcat(s, "u");
if (crc32("bpyqAs",6) == 667616188) strcat(s, "z");
if (crc32("ZDLemYlNfer",11) == 3394778210) strcat(s, "n");
if (crc32("rYMjcLQoWqUX",12) == 2998172607) strcat(s, "a");
if (crc32("XFWZqZQctR",10) == 2035024123) strcat(s, "l");
if (crc32("coYUkWInOHgoXJ",14) == 3846989735) strcat(s, "p");
if (crc32("RQUEefdyPDwa",12) == 651471593) strcat(s, "q");
if (crc32("UeYpMgvtk",9) == 1014324335) strcat(s, "h");
if (crc32("hOpiNJc",7) == 3236825764) strcat(s, "a");
if (crc32("DKbNQLgO",8) == 3941123974) strcat(s, "b");
if (crc32("VBJfL",5) == 3944870807) strcat(s, "k");
if (crc32("HyuJENwYO",9) == 397661554) strcat(s, "e");
if (crc32("mnXUs",5) == 1050164258) strcat(s, "E");
if (crc32("gCXHJoPQwat",11) == 2086409568) strcat(s, "t");
if (crc32("eJamWgdFc",9) == 2150492631) strcat(s, "C");
if (crc32("MZVOPiK",7) == 1477243920) strcat(s, "i");
if (crc32("gLZZsPUZKZNqqCi",15) == 3349051883) strcat(s, "c");
if (crc32("igkMwViO",8) == 3149885342) strcat(s, "l");
if (crc32("YniRlCs",7) == 3211575585) strcat(s, "a");
if (crc32("syjnMiMXysrlck",14) == 86079376) strcat(s, "l");
    return s;
}

char *Chattertonian_adjectives() {
    char *s = calloc(14);
    if (crc32("VvVGPpePX",9) == 3862122923) strcat(s, "T");
if (crc32("rriGERqpgbmN",12) == 3269841015) strcat(s, "C");
if (crc32("dMAbOMfEUR",10) == 2577264111) strcat(s, "h");
if (crc32("RrWduMOzXA",10) == 2986361924) strcat(s, "a");
if (crc32("XEElD",5) == 2887988497) strcat(s, "t");
if (crc32("mmSGionAdjUzGpn",15) == 1430320683) strcat(s, "Q");
if (crc32("ISGHsNh",7) == 162675950) strcat(s, "t");
if (crc32("nMdagTg",7) == 3035638132) strcat(s, "M");
if (crc32("fXjEtEK",7) == 3580299276) strcat(s, "e");
if (crc32("Xahqj",5) == 3857451734) strcat(s, "p");
if (crc32("dfZPbf",6) == 264462908) strcat(s, "r");
if (crc32("NqcOg",5) == 738096892) strcat(s, "A");
if (crc32("URruJJ",6) == 2697030113) strcat(s, "t");
if (crc32("aFKYu",5) == 3956715406) strcat(s, "o");
if (crc32("pLXpBvVjEI",10) == 1524942673) strcat(s, "n");
if (crc32("TZlISFrzK",9) == 3413610831) strcat(s, "i");
if (crc32("ZDCFNAsEaVj",11) == 2754695488) strcat(s, "a");
if (crc32("nXYTVXJcYLPz",12) == 616067100) strcat(s, "n");
    return s;
}

char *transAustralian_adjectives() {
    char *s = calloc(16);
    if (crc32("tdpIGoOvOH",10) == 371679247) strcat(s, "G");
if (crc32("ZqOiZKjGmXK",11) == 3263887781) strcat(s, "t");
if (crc32("kbVUlAO",7) == 2613827537) strcat(s, "h");
if (crc32("McIpA",5) == 511544759) strcat(s, "r");
if (crc32("fpRZpzREQTGMAVj",15) == 1639762439) strcat(s, "a");
if (crc32("PuWmjnIDBgzPmL",14) == 3793536577) strcat(s, "D");
if (crc32("yAfefGWLHBI",11) == 988698731) strcat(s, "n");
if (crc32("iatPoqnQ",8) == 661350168) strcat(s, "a");
if (crc32("csSwBNAgwyLRvs",14) == 1904930697) strcat(s, "s");
if (crc32("nZYflA",6) == 3277044468) strcat(s, "A");
if (crc32("iVhfgNHrwW",10) == 76777705) strcat(s, "b");
if (crc32("QQeVK",5) == 4078113440) strcat(s, "u");
if (crc32("sDzYXvQqIbpwI",13) == 292613875) strcat(s, "I");
if (crc32("AppwOipr",8) == 971517197) strcat(s, "s");
if (crc32("fyesk",5) == 1750444823) strcat(s, "j");
if (crc32("WpOVhus",7) == 2574888397) strcat(s, "t");
if (crc32("HZvdVnLwsG",10) == 3291212266) strcat(s, "P");
if (crc32("GJdvQdrZlvxplLX",15) == 542393553) strcat(s, "r");
if (crc32("QkGyhFlQBNiFJM",14) == 1076377415) strcat(s, "R");
if (crc32("qCIzFQLGK",9) == 1583212651) strcat(s, "a");
if (crc32("ZKShjyEWzW",10) == 3921587668) strcat(s, "P");
if (crc32("MqLHiqDA",8) == 191843260) strcat(s, "l");
if (crc32("iJmXYOmgsLoh",12) == 3300595385) strcat(s, "S");
if (crc32("GiaCQHv",7) == 4067440310) strcat(s, "i");
if (crc32("viMcchjtjSZkPE",14) == 3415308242) strcat(s, "j");
if (crc32("EDqTsNuBOdwgR",13) == 2325292081) strcat(s, "a");
if (crc32("byxsVjXNxGNFC",13) == 406832245) strcat(s, "n");
    return s;
}

char *subrictal_adjectives() {
    char *s = calloc(10);
    if (crc32("LGWDMceEgVpd",12) == 45446867) strcat(s, "s");
if (crc32("kgMlcDWAEUex",12) == 2419650126) strcat(s, "u");
if (crc32("lpNdZvGu",8) == 3808925601) strcat(s, "r");
if (crc32("pEcaJdh",7) == 1282164398) strcat(s, "b");
if (crc32("USaxwBeUGn",10) == 877154413) strcat(s, "u");
if (crc32("dCxnwioDclOcp",13) == 1965863750) strcat(s, "r");
if (crc32("lnyrgOsew",9) == 3223971072) strcat(s, "a");
if (crc32("esGKiewVCgg",11) == 4048274436) strcat(s, "i");
if (crc32("dBDHrGXhORMVu",13) == 4032925983) strcat(s, "c");
if (crc32("CZyvQGSDbbA",11) == 3423235812) strcat(s, "p");
if (crc32("OqMmAUt",7) == 1736592495) strcat(s, "t");
if (crc32("gcOvqaYOiLsR",12) == 14795675) strcat(s, "a");
if (crc32("uPCRH",5) == 462569051) strcat(s, "W");
if (crc32("KyTFChxX",8) == 1706701905) strcat(s, "l");
    return s;
}

char *wadable_adjectives() {
    char *s = calloc(8);
    if (crc32("OPYIpoG",7) == 2928845599) strcat(s, "w");
if (crc32("lvdHWRKScZ",10) == 1014286391) strcat(s, "a");
if (crc32("OdGAeb",6) == 4023636082) strcat(s, "d");
if (crc32("vYEDiRKuKW",10) == 2190479936) strcat(s, "a");
if (crc32("ZoCfcD",6) == 4247754498) strcat(s, "b");
if (crc32("QsRDbKo",7) == 1175381146) strcat(s, "l");
if (crc32("ZAlXzA",6) == 3188730882) strcat(s, "e");
    return s;
}

char *radiotoxic_adjectives() {
    char *s = calloc(11);
    if (crc32("Kjpnbb",6) == 3672013575) strcat(s, "r");
if (crc32("ulJWPwrfhWIa",12) == 2722627261) strcat(s, "a");
if (crc32("JvQPTnvMtjUYXq",14) == 1695977595) strcat(s, "d");
if (crc32("PxJoA",5) == 3456745181) strcat(s, "i");
if (crc32("nRStFtqQqCc",11) == 248978318) strcat(s, "A");
if (crc32("JVIvBhImyeunRa",14) == 540005818) strcat(s, "o");
if (crc32("kUKkSnVdhAq",11) == 4139925885) strcat(s, "j");
if (crc32("FxJFrPpZWjb",11) == 1810667599) strcat(s, "t");
if (crc32("vMPKZAFvKMDswv",14) == 1729002320) strcat(s, "p");
if (crc32("YrFZmZLpUBEt",12) == 272199903) strcat(s, "o");
if (crc32("UPHxwwfoBjWYu",13) == 3647017018) strcat(s, "x");
if (crc32("kJfogKFRCIYd",12) == 2574092923) strcat(s, "i");
if (crc32("lxqfq",5) == 1979542222) strcat(s, "c");
    return s;
}

char *expendable_adjectives() {
    char *s = calloc(11);
    if (crc32("PfzIPBRGfG",10) == 2367785787) strcat(s, "J");
if (crc32("VzxxLYDEnysG",12) == 3123535417) strcat(s, "e");
if (crc32("iqCnWGNtja",10) == 603448219) strcat(s, "x");
if (crc32("MUeiNMpSkLIqBtP",15) == 1803665352) strcat(s, "d");
if (crc32("izTGDNh",7) == 3098238877) strcat(s, "p");
if (crc32("xAghPFSOPCiwoEl",15) == 2370094280) strcat(s, "e");
if (crc32("kmtlw",5) == 1939003585) strcat(s, "N");
if (crc32("zcdSJZuZuBTSXeV",15) == 928416098) strcat(s, "n");
if (crc32("AbYsIabh",8) == 2992952601) strcat(s, "d");
if (crc32("RobRKgPAuKE",11) == 23638261) strcat(s, "a");
if (crc32("EVewxzcklFC",11) == 3016193033) strcat(s, "v");
if (crc32("JBucMQNPMEK",11) == 4227669362) strcat(s, "b");
if (crc32("IdmAUlogFWNxy",13) == 2366165748) strcat(s, "L");
if (crc32("qRHFi",5) == 2404389964) strcat(s, "l");
if (crc32("ArIoEEPOvStk",12) == 621082104) strcat(s, "b");
if (crc32("dfgEwJiqtbbeU",13) == 541559750) strcat(s, "e");
    return s;
}

char *unseeded_adjectives() {
    char *s = calloc(9);
    if (crc32("jFSDfKcpJ",9) == 97678099) strcat(s, "R");
if (crc32("fszSF",5) == 4271209782) strcat(s, "u");
if (crc32("dfsyniolONFjTY",14) == 1272885218) strcat(s, "G");
if (crc32("JVMWSNAWGG",10) == 1337086219) strcat(s, "n");
if (crc32("FbHDgQPkmWq",11) == 3711923380) strcat(s, "Q");
if (crc32("skVBxfgDKo",10) == 2399066725) strcat(s, "s");
if (crc32("LiKPq",5) == 4235822083) strcat(s, "e");
if (crc32("hyxnMIQIt",9) == 2250727963) strcat(s, "E");
if (crc32("mxaOyfhKSSB",11) == 2336804564) strcat(s, "e");
if (crc32("Ejicc",5) == 3754413930) strcat(s, "d");
if (crc32("CegqtfPdbLAFrB",14) == 1820746259) strcat(s, "e");
if (crc32("tVWzJTlngBLCQNa",15) == 3833737098) strcat(s, "d");
    return s;
}

char *Polish_adjectives() {
    char *s = calloc(7);
    if (crc32("tuYaIsoExr",10) == 3411281167) strcat(s, "Z");
if (crc32("rIPclzGKozLdiu",14) == 2657217630) strcat(s, "P");
if (crc32("cqXkbhwWznz",11) == 140449858) strcat(s, "o");
if (crc32("bPhsoUkbFpdN",12) == 1333809278) strcat(s, "l");
if (crc32("QSmIJRmxUESXJ",13) == 3334720095) strcat(s, "U");
if (crc32("vwqXvyRcnHVZYN",14) == 1545872560) strcat(s, "i");
if (crc32("LQtxFnOGtqsFWY",14) == 1388956929) strcat(s, "W");
if (crc32("awWNYRDClyaca",13) == 3670689103) strcat(s, "s");
if (crc32("cMCpcY",6) == 519441944) strcat(s, "h");
    return s;
}

char *jowlier_adjectives() {
    char *s = calloc(8);
    if (crc32("ABHoo",5) == 2757747657) strcat(s, "Q");
if (crc32("gQnEOuGivwES",12) == 1829767481) strcat(s, "j");
if (crc32("EVIIgpc",7) == 1416353652) strcat(s, "o");
if (crc32("hGTaDwuXkBjgTa",14) == 1059211423) strcat(s, "c");
if (crc32("sALATqJsLoNhKj",14) == 3622240139) strcat(s, "w");
if (crc32("nCXdeDnAOzRXOHI",15) == 3794361536) strcat(s, "l");
if (crc32("FBLXmhYqcTV",11) == 3745855129) strcat(s, "J");
if (crc32("yrTrDthfYy",10) == 4125841607) strcat(s, "i");
if (crc32("UweMo",5) == 385838025) strcat(s, "e");
if (crc32("UhDHNomGEuOc",12) == 666664546) strcat(s, "R");
if (crc32("gDwDiNQxQ",9) == 3083304482) strcat(s, "r");
    return s;
}

char *antihuman_adjectives() {
    char *s = calloc(10);
    if (crc32("FxqADIT",7) == 3554084618) strcat(s, "Y");
if (crc32("UVjGOEHpSdKLt",13) == 2793855915) strcat(s, "a");
if (crc32("wOzRNCVSwaHP",12) == 3748918207) strcat(s, "Q");
if (crc32("FZWOS",5) == 1498537603) strcat(s, "n");
if (crc32("OtaoKYICNbeE",12) == 289210363) strcat(s, "t");
if (crc32("aYLcWtmKnwcplX",14) == 3789169773) strcat(s, "i");
if (crc32("pQvaVReOWun",11) == 1591486701) strcat(s, "h");
if (crc32("atsPRl",6) == 4245750575) strcat(s, "O");
if (crc32("rCJRSafhyr",10) == 3423199462) strcat(s, "u");
if (crc32("JrnijPAIpsCAdnL",15) == 1383329422) strcat(s, "m");
if (crc32("eGzAngggMFjJ",12) == 3174358370) strcat(s, "a");
if (crc32("FuEQiRq",7) == 3933418082) strcat(s, "n");
    return s;
}

char *intraspinal_adjectives() {
    char *s = calloc(12);
    if (crc32("uXOcMoBrfLgwI",13) == 3146172328) strcat(s, "i");
if (crc32("KjpKKWzzfs",10) == 3773667265) strcat(s, "o");
if (crc32("JrqixRpMbetGO",13) == 3036034641) strcat(s, "n");
if (crc32("zypcIPloXbq",11) == 730642700) strcat(s, "r");
if (crc32("vuNPHPNdFF",10) == 1807361349) strcat(s, "t");
if (crc32("HdJaLXTgEPS",11) == 1599635057) strcat(s, "U");
if (crc32("EymxSBb",7) == 1733451580) strcat(s, "r");
if (crc32("HXgwBDbfulO",11) == 2451365566) strcat(s, "a");
if (crc32("mLbtXblG",8) == 2148750795) strcat(s, "a");
if (crc32("shbhMUAHPXBc",12) == 1423660699) strcat(s, "O");
if (crc32("qCrqll",6) == 2007383798) strcat(s, "s");
if (crc32("uVgfaG",6) == 985946139) strcat(s, "K");
if (crc32("LiDZIOVpdA",10) == 4120359422) strcat(s, "p");
if (crc32("GbUaeoUKnodh",12) == 2818599765) strcat(s, "q");
if (crc32("MMqrno",6) == 14837198) strcat(s, "i");
if (crc32("jZMgPZ",6) == 1603342086) strcat(s, "S");
if (crc32("dlWPQotzOu",10) == 3420625502) strcat(s, "n");
if (crc32("QuKRekPE",8) == 2445639170) strcat(s, "a");
if (crc32("zevAjvwBpVMjS",13) == 3283860983) strcat(s, "L");
if (crc32("GmcQPZ",6) == 3084243295) strcat(s, "l");
    return s;
}

char *bibliographical_adjectives() {
    char *s = calloc(16);
    if (crc32("YqpeLy",6) == 247943461) strcat(s, "b");
if (crc32("loEMKAtdQ",9) == 3001994792) strcat(s, "i");
if (crc32("bKzOR",5) == 4151717032) strcat(s, "y");
if (crc32("WqayIJ",6) == 200527848) strcat(s, "b");
if (crc32("gxIvkyuMMYV",11) == 2199616886) strcat(s, "l");
if (crc32("DRvQpVOeOBwvKOs",15) == 1459671068) strcat(s, "y");
if (crc32("XIWVGhKY",8) == 3583475734) strcat(s, "i");
if (crc32("ChMubVZzUfknhW",14) == 2113588946) strcat(s, "o");
if (crc32("yDrQlWtTcDAZ",12) == 871950521) strcat(s, "g");
if (crc32("WODJgPAoBRFW",12) == 3514863532) strcat(s, "t");
if (crc32("BQqQt",5) == 911953828) strcat(s, "r");
if (crc32("KKUudSOtC",9) == 2389776969) strcat(s, "a");
if (crc32("vNoKkNy",7) == 1554107303) strcat(s, "Z");
if (crc32("TMSAbPU",7) == 1338140234) strcat(s, "p");
if (crc32("PKAnnEzW",8) == 3848245577) strcat(s, "h");
if (crc32("xVMaEmg",7) == 3457222780) strcat(s, "h");
if (crc32("WzLtzjepBi",10) == 1825129927) strcat(s, "i");
if (crc32("UhOmJ",5) == 4231452062) strcat(s, "D");
if (crc32("xBoJsmPqWKfuwH",14) == 2125481879) strcat(s, "c");
if (crc32("VAlOSzvp",8) == 406632922) strcat(s, "a");
if (crc32("cWZWRR",6) == 4150504473) strcat(s, "d");
if (crc32("lGsWjhxcErEKT",13) == 546665009) strcat(s, "l");
    return s;
}

char *ardeid_adjectives() {
    char *s = calloc(7);
    if (crc32("XrPDwBA",7) == 1978922641) strcat(s, "a");
if (crc32("lSXMjfUQam",10) == 559611896) strcat(s, "e");
if (crc32("NBmQjlTmTxNo",12) == 996738298) strcat(s, "r");
if (crc32("QhFTZmifdcU",11) == 3486292288) strcat(s, "d");
if (crc32("pmluhanysqTJW",13) == 3844704254) strcat(s, "l");
if (crc32("yxPvQmuEkvA",11) == 2199352087) strcat(s, "e");
if (crc32("vneZdyjfBgnhQWU",15) == 1426284199) strcat(s, "p");
if (crc32("WcSIJvfy",8) == 3788348077) strcat(s, "i");
if (crc32("emJZGyMwAwZhij",14) == 531914940) strcat(s, "d");
    return s;
}

char *unkidnaped_adjectives() {
    char *s = calloc(11);
    if (crc32("WJXUgSyq",8) == 3680508390) strcat(s, "u");
if (crc32("StSVDMJeU",9) == 4155351633) strcat(s, "n");
if (crc32("YoVbgOyyy",9) == 1349228678) strcat(s, "k");
if (crc32("peQWdTuLMYdYWlh",15) == 3871530527) strcat(s, "i");
if (crc32("QzGLVwZcElCCybd",15) == 2839241305) strcat(s, "d");
if (crc32("JrnRSR",6) == 3635938112) strcat(s, "y");
if (crc32("zlhpK",5) == 2353347774) strcat(s, "n");
if (crc32("ZXBgDoPN",8) == 1917119693) strcat(s, "B");
if (crc32("hpcEpQP",7) == 3228901406) strcat(s, "a");
if (crc32("vRSPzDIIjWf",11) == 2773310148) strcat(s, "p");
if (crc32("gxPssnAU",8) == 467093512) strcat(s, "e");
if (crc32("EFXdww",6) == 1413572993) strcat(s, "N");
if (crc32("VnyCJvkte",9) == 3154297261) strcat(s, "d");
    return s;
}

char *overstrung_adjectives() {
    char *s = calloc(11);
    if (crc32("ByHBNuaILeZCCEr",15) == 1117579047) strcat(s, "o");
if (crc32("qKfkHEWIgnAMEMa",15) == 101436754) strcat(s, "O");
if (crc32("MqaTjBRgQiEAVmo",15) == 2825751727) strcat(s, "v");
if (crc32("RRwNdktSwpJeNzh",15) == 931582382) strcat(s, "o");
if (crc32("RavPrvIBThDfjyv",15) == 3989994) strcat(s, "e");
if (crc32("afEgRSmDuoWmdv",14) == 923034322) strcat(s, "v");
if (crc32("fqOYxlBCTEVAc",13) == 3169508154) strcat(s, "r");
if (crc32("hYlBWJPtTN",10) == 2946292575) strcat(s, "f");
if (crc32("LJLpb",5) == 1519122218) strcat(s, "s");
if (crc32("NbnJqE",6) == 2426609585) strcat(s, "b");
if (crc32("xoSjINDGO",9) == 520859019) strcat(s, "t");
if (crc32("QXZwJxmo",8) == 1484336933) strcat(s, "f");
if (crc32("jMFKVOsH",8) == 507678366) strcat(s, "r");
if (crc32("XXlHsyqseAi",11) == 2626887192) strcat(s, "u");
if (crc32("UMFzyQF",7) == 3947443874) strcat(s, "n");
if (crc32("GpXLYaN",7) == 2693058313) strcat(s, "x");
if (crc32("JASVv",5) == 3434362527) strcat(s, "g");
    return s;
}

char *unnimble_adjectives() {
    char *s = calloc(9);
    if (crc32("iZmNBcwJBbYDm",13) == 352728441) strcat(s, "u");
if (crc32("CKudAkpr",8) == 213329483) strcat(s, "Y");
if (crc32("bvjqHiSKzKe",11) == 760549578) strcat(s, "n");
if (crc32("MqLgKVY",7) == 3248824050) strcat(s, "n");
if (crc32("yyvzf",5) == 95083334) strcat(s, "i");
if (crc32("NEUYOkGV",8) == 1893548906) strcat(s, "b");
if (crc32("dTyedRzs",8) == 1548104648) strcat(s, "m");
if (crc32("csXOZRB",7) == 2311491646) strcat(s, "k");
if (crc32("EMifsMaXtIkwH",13) == 4133861539) strcat(s, "b");
if (crc32("GxuqY",5) == 4107530347) strcat(s, "l");
if (crc32("lxHClEINz",9) == 1660182315) strcat(s, "c");
if (crc32("kiDoPeKJTm",10) == 1811214912) strcat(s, "e");
    return s;
}

char *unaware_adjectives() {
    char *s = calloc(8);
    if (crc32("RSeeKZeOOtkYH",13) == 1977489877) strcat(s, "M");
if (crc32("wCjYglXIh",9) == 2332144864) strcat(s, "u");
if (crc32("TMLNUHAqCymwN",13) == 3750412108) strcat(s, "C");
if (crc32("KYYRcEqtyInBY",13) == 346091415) strcat(s, "n");
if (crc32("yENwmC",6) == 2954099740) strcat(s, "x");
if (crc32("zuorqNmYQzUAFc",14) == 3412790210) strcat(s, "a");
if (crc32("IYtaYpzSLAIx",12) == 3449992928) strcat(s, "w");
if (crc32("pqqQTst",7) == 1356712695) strcat(s, "k");
if (crc32("axjyPNZbN",9) == 890464991) strcat(s, "a");
if (crc32("iKhUG",5) == 2545264256) strcat(s, "X");
if (crc32("IwYapaWIGZ",10) == 3223910140) strcat(s, "r");
if (crc32("hRheaNAmdxU",11) == 1152670356) strcat(s, "e");
    return s;
}

char *chinchier_adjectives() {
    char *s = calloc(10);
    if (crc32("QllmZscLv",9) == 1477097243) strcat(s, "c");
if (crc32("iAyNQdKL",8) == 3550228571) strcat(s, "h");
if (crc32("oKuJzCJFzXZ",11) == 30033252) strcat(s, "i");
if (crc32("MFkhYXDW",8) == 1684126018) strcat(s, "K");
if (crc32("bTITMKej",8) == 1710125761) strcat(s, "n");
if (crc32("OzEDPwXq",8) == 733964042) strcat(s, "e");
if (crc32("KHrMWp",6) == 2689959087) strcat(s, "c");
if (crc32("mIpWTcGGUaqDdn",14) == 4051967304) strcat(s, "k");
if (crc32("fgaoNivTpDU",11) == 1893289832) strcat(s, "h");
if (crc32("MpwhLrfg",8) == 1361417566) strcat(s, "w");
if (crc32("ytSaz",5) == 1953566789) strcat(s, "i");
if (crc32("CwrriMTY",8) == 3825529251) strcat(s, "Z");
if (crc32("kHGSGUQEIMlF",12) == 3036307212) strcat(s, "e");
if (crc32("uypvIMulH",9) == 2408240657) strcat(s, "z");
if (crc32("JtbdIXVYKEMTTW",14) == 1319287726) strcat(s, "r");
    return s;
}

char *unsettleable_adjectives() {
    char *s = calloc(13);
    if (crc32("aGMbAICDzZ",10) == 1233494907) strcat(s, "a");
if (crc32("dEqoKGfXltPPDq",14) == 629017546) strcat(s, "u");
if (crc32("OeYHtVRNEH",10) == 1856717822) strcat(s, "n");
if (crc32("pGCWZllXQRXS",12) == 2692619348) strcat(s, "s");
if (crc32("oCseIzbiIKm",11) == 3502793546) strcat(s, "r");
if (crc32("nvncJVDLfEpCd",13) == 1737336229) strcat(s, "e");
if (crc32("EKBBnvRSHqE",11) == 3801928276) strcat(s, "t");
if (crc32("chRxd",5) == 3448494524) strcat(s, "W");
if (crc32("DxzxgBTKbO",10) == 1669146190) strcat(s, "t");
if (crc32("dMUjRMbpi",9) == 4130560537) strcat(s, "l");
if (crc32("mTeaoGjumXyVTOx",15) == 1090100219) strcat(s, "W");
if (crc32("PeUwWqY",7) == 2918967660) strcat(s, "e");
if (crc32("lByodh",6) == 4129202758) strcat(s, "P");
if (crc32("fAEHRCNmU",9) == 2740684559) strcat(s, "a");
if (crc32("WiLNqpTpp",9) == 845484245) strcat(s, "b");
if (crc32("xGbSzgZByADI",12) == 2322148094) strcat(s, "j");
if (crc32("WnchMSQd",8) == 680626731) strcat(s, "l");
if (crc32("EdCfKc",6) == 4223870307) strcat(s, "B");
if (crc32("EGBoDaDDHCsOk",13) == 3829659616) strcat(s, "e");
    return s;
}

char *xenodiagnostic_adjectives() {
    char *s = calloc(15);
    if (crc32("IdytRjkafnapsi",14) == 3427980237) strcat(s, "x");
if (crc32("drUyEPXUkgA",11) == 184354649) strcat(s, "w");
if (crc32("ZdMbavmyjkR",11) == 1435167477) strcat(s, "e");
if (crc32("ehLBLhUWuK",10) == 3398595902) strcat(s, "Y");
if (crc32("zOJaqRFSCuekP",13) == 2050808791) strcat(s, "n");
if (crc32("sKCokIRCCTDF",12) == 3230064943) strcat(s, "o");
if (crc32("cceGa",5) == 4205978538) strcat(s, "d");
if (crc32("FviIuiUAcTBLxT",14) == 4122704792) strcat(s, "i");
if (crc32("nUuXtOkLlNojWG",14) == 970319) strcat(s, "k");
if (crc32("bQcSrgwvKlkNJs",14) == 1509108248) strcat(s, "a");
if (crc32("CWdolPeYNqHbgaS",15) == 2342708723) strcat(s, "g");
if (crc32("BXVgmrsfbUZIiug",15) == 1814207589) strcat(s, "L");
if (crc32("ykMAR",5) == 3397539246) strcat(s, "n");
if (crc32("TyOvdkrOnK",10) == 2830184324) strcat(s, "v");
if (crc32("zchcfDgqrxvYfp",14) == 3017230561) strcat(s, "o");
if (crc32("AEaOiGrfwC",10) == 3722739325) strcat(s, "S");
if (crc32("ufvqHoewi",9) == 347458470) strcat(s, "s");
if (crc32("dOtOTRLrywl",11) == 3236492410) strcat(s, "C");
if (crc32("WPCkBbtddhbye",13) == 3538280122) strcat(s, "t");
if (crc32("fFbViYoDpkrfdJ",14) == 1494662913) strcat(s, "i");
if (crc32("kcRnerY",7) == 1110793697) strcat(s, "c");
    return s;
}

char *monogamistic_adjectives() {
    char *s = calloc(13);
    if (crc32("NOUkI",5) == 32046685) strcat(s, "m");
if (crc32("syuETrBwOt",10) == 3589032878) strcat(s, "R");
if (crc32("akKAhPFeE",9) == 2868653391) strcat(s, "o");
if (crc32("shKbzDOyQeLDo",13) == 3662483503) strcat(s, "e");
if (crc32("gRCTgb",6) == 2381614657) strcat(s, "n");
if (crc32("fKXZaHnL",8) == 886589394) strcat(s, "G");
if (crc32("IMoClPRsyTVG",12) == 776886242) strcat(s, "o");
if (crc32("kvnWWtPC",8) == 2409251213) strcat(s, "g");
if (crc32("avFWrXgVtVZueR",14) == 3107664489) strcat(s, "a");
if (crc32("IubTFnhjjmmj",12) == 816114573) strcat(s, "M");
if (crc32("chQCFyNP",8) == 3142640697) strcat(s, "m");
if (crc32("gqqcCssGmmTE",12) == 3783222387) strcat(s, "W");
if (crc32("oxZzRyprTAieeKx",15) == 1504243660) strcat(s, "i");
if (crc32("ZImfbICMeWdpdZL",15) == 1480788454) strcat(s, "e");
if (crc32("HjdIzCNopnuD",12) == 959512379) strcat(s, "s");
if (crc32("GgtZPUDoGRcgs",13) == 1997134040) strcat(s, "t");
if (crc32("eniJxHCfzRJE",12) == 1234633855) strcat(s, "c");
if (crc32("btitvdPuN",9) == 1599987368) strcat(s, "i");
if (crc32("sXWGQqceMokACra",15) == 3029756149) strcat(s, "p");
if (crc32("JbXvbPWzC",9) == 2301878545) strcat(s, "c");
    return s;
}

char *nonscientific_adjectives() {
    char *s = calloc(14);
    if (crc32("TASqJY",6) == 3622073935) strcat(s, "n");
if (crc32("MRcOwnfR",8) == 894484561) strcat(s, "o");
if (crc32("xwytdbrgpKrIRr",14) == 2652195029) strcat(s, "n");
if (crc32("FavlXZxnIqm",11) == 3132769991) strcat(s, "s");
if (crc32("QwaqUNdA",8) == 4031965199) strcat(s, "s");
if (crc32("aDXpHagJC",9) == 1478233761) strcat(s, "c");
if (crc32("lAGYM",5) == 2892961647) strcat(s, "o");
if (crc32("BNewyusLmmR",11) == 2368173026) strcat(s, "i");
if (crc32("NGMeXJ",6) == 2907355167) strcat(s, "e");
if (crc32("AHnBkksAg",9) == 841268238) strcat(s, "X");
if (crc32("THxleqf",7) == 3443981439) strcat(s, "n");
if (crc32("jwMZSn",6) == 1620498446) strcat(s, "t");
if (crc32("VlgSRUAZkoIz",12) == 1681388479) strcat(s, "i");
if (crc32("XodzsEDGiIa",11) == 3231978953) strcat(s, "f");
if (crc32("KzSRxuRPyPmS",12) == 4072598231) strcat(s, "Y");
if (crc32("MDsQmGmeIwjAN",13) == 1439105711) strcat(s, "i");
if (crc32("BrowZnlQ",8) == 2086926307) strcat(s, "I");
if (crc32("ZAXLKTPa",8) == 2580030642) strcat(s, "c");
    return s;
}

char *Circean_adjectives() {
    char *s = calloc(8);
    if (crc32("IaLGW",5) == 602682482) strcat(s, "C");
if (crc32("gLhSWPgjiU",10) == 3198485628) strcat(s, "F");
if (crc32("pBoqwW",6) == 1003776287) strcat(s, "i");
if (crc32("bfUmmsfz",8) == 1055360540) strcat(s, "r");
if (crc32("zuTAYmBffVbTXD",14) == 1916427130) strcat(s, "S");
if (crc32("bzXZWligKA",10) == 114985757) strcat(s, "c");
if (crc32("KNAffVjV",8) == 3169966563) strcat(s, "e");
if (crc32("wuWkrFhtc",9) == 234543366) strcat(s, "F");
if (crc32("qSCjMX",6) == 3800669047) strcat(s, "a");
if (crc32("RtIIzrsCAJY",11) == 2689366842) strcat(s, "n");
    return s;
}

char *illsorted_adjectives() {
    char *s = calloc(10);
    if (crc32("kuookc",6) == 2428491843) strcat(s, "i");
if (crc32("ijjcKeydpyBYEU",14) == 779624183) strcat(s, "h");
if (crc32("ZxwjsQMD",8) == 2608071562) strcat(s, "l");
if (crc32("UHnJlwV",7) == 2124073390) strcat(s, "l");
if (crc32("qzDQwADNk",9) == 1067697390) strcat(s, "C");
if (crc32("bulGs",5) == 1321748638) strcat(s, "s");
if (crc32("RHnGz",5) == 3678719325) strcat(s, "O");
if (crc32("sbzMwtBeiT",10) == 694206758) strcat(s, "o");
if (crc32("KleEYS",6) == 2057434608) strcat(s, "J");
if (crc32("vJgdR",5) == 2373261813) strcat(s, "r");
if (crc32("ugRhGa",6) == 1668432689) strcat(s, "t");
if (crc32("avHVLX",6) == 185963308) strcat(s, "e");
if (crc32("dFugGFeInoqWfJ",14) == 2857918964) strcat(s, "t");
if (crc32("DYOWthPHgLtRS",13) == 1890735767) strcat(s, "d");
    return s;
}

char *whiniest_adjectives() {
    char *s = calloc(9);
    if (crc32("vDsnMOCzdbL",11) == 1408194312) strcat(s, "k");
if (crc32("RMYrH",5) == 3958123711) strcat(s, "w");
if (crc32("vdFkCtuFq",9) == 1559013802) strcat(s, "h");
if (crc32("fIprtV",6) == 1680952106) strcat(s, "J");
if (crc32("tCuAC",5) == 391938580) strcat(s, "i");
if (crc32("ZiQwEPC",7) == 242623213) strcat(s, "Z");
if (crc32("hAWhZDgduiZwwW",14) == 2348667629) strcat(s, "n");
if (crc32("qTSpSKEew",9) == 1522441886) strcat(s, "i");
if (crc32("KeFWIJkGhkjCwv",14) == 2451144805) strcat(s, "e");
if (crc32("ZOmbpHLa",8) == 936386685) strcat(s, "s");
if (crc32("dLjAJJkQgfGZD",13) == 4223242872) strcat(s, "t");
    return s;
}

char *phlegmatized_adjectives() {
    char *s = calloc(13);
    if (crc32("peDyY",5) == 2832277008) strcat(s, "p");
if (crc32("WTPhhxdWXAR",11) == 4204443654) strcat(s, "n");
if (crc32("DcuopH",6) == 3016460451) strcat(s, "h");
if (crc32("ookmRaiWozgWJ",13) == 2436115989) strcat(s, "H");
if (crc32("auvNegJiMB",10) == 68254503) strcat(s, "l");
if (crc32("nFsghqb",7) == 3501546623) strcat(s, "T");
if (crc32("NkggrmHDxfRAEi",14) == 3658828848) strcat(s, "e");
if (crc32("kuvTCfKX",8) == 4124906646) strcat(s, "g");
if (crc32("vmmCi",5) == 3603517669) strcat(s, "m");
if (crc32("UErZYLnkQcMxv",13) == 2498905967) strcat(s, "l");
if (crc32("jyucSZS",7) == 1525318391) strcat(s, "a");
if (crc32("nCyPwUNS",8) == 3648210876) strcat(s, "H");
if (crc32("VBYUswVIZket",12) == 1887926482) strcat(s, "t");
if (crc32("AkpWVoAW",8) == 1684878857) strcat(s, "m");
if (crc32("XKnJR",5) == 1341054294) strcat(s, "i");
if (crc32("wMJPbDHgqS",10) == 4101484582) strcat(s, "l");
if (crc32("nARnaO",6) == 1600625044) strcat(s, "z");
if (crc32("OgKGy",5) == 3580043277) strcat(s, "d");
if (crc32("eplVTqePX",9) == 1164685061) strcat(s, "e");
if (crc32("ELcQTqKNl",9) == 1014886803) strcat(s, "E");
if (crc32("xkWKnnCHCdmz",12) == 1949489006) strcat(s, "d");
    return s;
}

char *hamular_adjectives() {
    char *s = calloc(8);
    if (crc32("HYxhQI",6) == 57294023) strcat(s, "T");
if (crc32("XqnWjAmQ",8) == 4174321004) strcat(s, "h");
if (crc32("CSBEIsxaFJCEPHz",15) == 455233788) strcat(s, "a");
if (crc32("hHjDEvgIZ",9) == 2032078049) strcat(s, "m");
if (crc32("REflH",5) == 3576600866) strcat(s, "u");
if (crc32("BKXULN",6) == 2555480461) strcat(s, "K");
if (crc32("BoYAbFZFe",9) == 3400666475) strcat(s, "l");
if (crc32("OuwYmcnk",8) == 2854798393) strcat(s, "a");
if (crc32("iTbfhycfmKa",11) == 3864606817) strcat(s, "q");
if (crc32("HePgWxJeAfihqF",14) == 4285838406) strcat(s, "r");
    return s;
}

char *distressed_adjectives() {
    char *s = calloc(11);
    if (crc32("IKOVNfmzpim",11) == 1968155242) strcat(s, "F");
if (crc32("tlWtm",5) == 2854445195) strcat(s, "d");
if (crc32("MqrhZNmLhEBOAM",14) == 3451851813) strcat(s, "i");
if (crc32("nqChwo",6) == 868479498) strcat(s, "N");
if (crc32("LqNVbsYxR",9) == 3944770875) strcat(s, "s");
if (crc32("BjocPXmleYfX",12) == 3301053975) strcat(s, "t");
if (crc32("euzkzcvV",8) == 267603355) strcat(s, "l");
if (crc32("pPNUsOptGxir",12) == 1584326698) strcat(s, "r");
if (crc32("xchIzdiwHxUGfbX",15) == 2680189572) strcat(s, "H");
if (crc32("HUZBNjDZEzBX",12) == 3186206379) strcat(s, "e");
if (crc32("EowqrjbjX",9) == 4227754930) strcat(s, "t");
if (crc32("jnvYMenZFu",10) == 3004577123) strcat(s, "s");
if (crc32("AXqttrOpHuQ",11) == 3334274780) strcat(s, "s");
if (crc32("TYLxt",5) == 3845117602) strcat(s, "I");
if (crc32("HCrNnTItivzyHjh",15) == 3221699713) strcat(s, "e");
if (crc32("fNLbpafZaf",10) == 2112317910) strcat(s, "A");
if (crc32("pAyqRM",6) == 479670801) strcat(s, "d");
    return s;
}

char *Indienne_adjectives() {
    char *s = calloc(9);
    if (crc32("dwtmgniP",8) == 2905692086) strcat(s, "n");
if (crc32("eJkuCFpOwJtk",12) == 661534212) strcat(s, "I");
if (crc32("iQFaHSjDuw",10) == 1258027151) strcat(s, "n");
if (crc32("WnRcluztb",9) == 3202061328) strcat(s, "d");
if (crc32("gTQISyWePfChtp",14) == 3183659783) strcat(s, "i");
if (crc32("QHxHJpBfHjSSNF",14) == 2644299309) strcat(s, "w");
if (crc32("uCAWKvWe",8) == 1846374641) strcat(s, "e");
if (crc32("hIotJeRVMBKpm",13) == 3156359991) strcat(s, "d");
if (crc32("nFAMlOU",7) == 3190043739) strcat(s, "n");
if (crc32("HKXmnjSjqfxs",12) == 3174051329) strcat(s, "n");
if (crc32("OQFnuDMoWLYiWG",14) == 4089949917) strcat(s, "e");
    return s;
}

char *metempsychosical_adjectives() {
    char *s = calloc(17);
    if (crc32("ZBSaazZLPkReI",13) == 447851841) strcat(s, "m");
if (crc32("RrJZykmBVYA",11) == 2136762889) strcat(s, "e");
if (crc32("dGtzAJSeWbnG",12) == 755627560) strcat(s, "A");
if (crc32("kvpeLM",6) == 3571572518) strcat(s, "t");
if (crc32("axWNeFpnAuWyhxC",15) == 4001186340) strcat(s, "u");
if (crc32("ELhhWYncLobQns",14) == 2684492870) strcat(s, "e");
if (crc32("uaRoUkhQGaG",11) == 2803794854) strcat(s, "m");
if (crc32("zKPdRhiqzNlNv",13) == 3506040982) strcat(s, "U");
if (crc32("SZeotjtShCYcJaL",15) == 1498220022) strcat(s, "p");
if (crc32("qckknpCPajRaUAZ",15) == 62492613) strcat(s, "Y");
if (crc32("YwvMOJWunlmHnRB",15) == 3813144452) strcat(s, "s");
if (crc32("WogeDAxZX",9) == 1608262681) strcat(s, "F");
if (crc32("VkctfmCYKHrjH",13) == 844703575) strcat(s, "y");
if (crc32("jhNCuowPYXdF",12) == 289644769) strcat(s, "d");
if (crc32("GMatwkuesuljLUA",15) == 1774431892) strcat(s, "c");
if (crc32("veiSeyYy",8) == 3530330322) strcat(s, "h");
if (crc32("bKBxKODGUw",10) == 156391083) strcat(s, "h");
if (crc32("MXNUaglEX",9) == 2897235560) strcat(s, "o");
if (crc32("jUbYbew",7) == 648435111) strcat(s, "s");
if (crc32("erbLAYPica",10) == 303896078) strcat(s, "i");
if (crc32("PpTqsTrizighYeq",15) == 2170201887) strcat(s, "h");
if (crc32("XKxGWtFGyo",10) == 504671824) strcat(s, "c");
if (crc32("DTHrRyJXbQtaf",13) == 1181781437) strcat(s, "l");
if (crc32("uOytUKFhcfc",11) == 1871134356) strcat(s, "a");
if (crc32("KxbmfqI",7) == 1516445005) strcat(s, "b");
if (crc32("RtuMEx",6) == 195379747) strcat(s, "l");
    return s;
}

char *anatomizable_adjectives() {
    char *s = calloc(13);
    if (crc32("UdZrKPRq",8) == 2788974067) strcat(s, "a");
if (crc32("rJqMAaWgk",9) == 839630614) strcat(s, "q");
if (crc32("JZngNUW",7) == 406197698) strcat(s, "n");
if (crc32("vFwMIeC",7) == 1632458406) strcat(s, "a");
if (crc32("JPCZits",7) == 1504473222) strcat(s, "X");
if (crc32("WZCTN",5) == 3587099742) strcat(s, "t");
if (crc32("TJeFWX",6) == 3694874556) strcat(s, "o");
if (crc32("LFqwNcft",8) == 4133093635) strcat(s, "y");
if (crc32("FJxfIpSYva",10) == 2227299412) strcat(s, "m");
if (crc32("dqdYknsRqucXOdE",15) == 2363466277) strcat(s, "Z");
if (crc32("sQfQvDIgxGfvqvn",15) == 1229447376) strcat(s, "i");
if (crc32("CyOSiTT",7) == 846102101) strcat(s, "z");
if (crc32("ixPUh",5) == 1090771000) strcat(s, "u");
if (crc32("SOsQWC",6) == 4020274222) strcat(s, "a");
if (crc32("SchQybRiSdRsrZY",15) == 2434647871) strcat(s, "A");
if (crc32("CkONLfrn",8) == 2027379669) strcat(s, "b");
if (crc32("oisaOcArnGTS",12) == 1990634919) strcat(s, "u");
if (crc32("ZEnpnWWlwq",10) == 404130856) strcat(s, "l");
if (crc32("saGwz",5) == 4233402945) strcat(s, "N");
if (crc32("uKZVoCXanyq",11) == 316716862) strcat(s, "e");
    return s;
}

char *hypersuggestible_adjectives() {
    char *s = calloc(17);
    if (crc32("fxfpulzjluX",11) == 3858495696) strcat(s, "h");
if (crc32("FgfijBCuZVWktOp",15) == 2848898876) strcat(s, "y");
if (crc32("aOWLHqpxSWeYcji",15) == 2005510498) strcat(s, "C");
if (crc32("gjkuIlKWtrnUms",14) == 733947078) strcat(s, "p");
if (crc32("xeKHphTVn",9) == 2846308291) strcat(s, "R");
if (crc32("ngTKqvmQnX",10) == 265704410) strcat(s, "e");
if (crc32("SvAyjxLZb",9) == 2223300412) strcat(s, "h");
if (crc32("CWGQsztErL",10) == 3899996339) strcat(s, "r");
if (crc32("yTQNC",5) == 3909985038) strcat(s, "V");
if (crc32("CDgVQpKcvjtOp",13) == 2796763772) strcat(s, "s");
if (crc32("eECih",5) == 3910289579) strcat(s, "H");
if (crc32("gOyDpREfLrGm",12) == 2969353528) strcat(s, "u");
if (crc32("kACyPIlkVOY",11) == 839330874) strcat(s, "S");
if (crc32("PKGZyqOoeGNkHT",14) == 3420230555) strcat(s, "g");
if (crc32("yOlbkGZgsKhn",12) == 3834059333) strcat(s, "O");
if (crc32("uAlLgUGJY",9) == 934493590) strcat(s, "g");
if (crc32("OWcDqCffub",10) == 149323937) strcat(s, "e");
if (crc32("mYpBRnpVxjgsASA",15) == 2911898391) strcat(s, "V");
if (crc32("AVGlpSzB",8) == 3326664890) strcat(s, "s");
if (crc32("OLKWaTVwOArwR",13) == 507632585) strcat(s, "k");
if (crc32("RKYqMemOQCLZU",13) == 815100155) strcat(s, "t");
if (crc32("BKcQgLnpHlP",11) == 3632782151) strcat(s, "i");
if (crc32("ZGODTTJkkael",12) == 3588023503) strcat(s, "V");
if (crc32("OBFng",5) == 1898179475) strcat(s, "b");
if (crc32("WChbXhRFCVrjbUs",15) == 3877064298) strcat(s, "Q");
if (crc32("qnkIzAGgY",9) == 3091364425) strcat(s, "l");
if (crc32("ilArZlRUyRmA",12) == 2853126712) strcat(s, "e");
    return s;
}

char *knotty_adjectives() {
    char *s = calloc(7);
    if (crc32("xsoFoxbtlvFipZ",14) == 3735709177) strcat(s, "k");
if (crc32("RLnpfYav",8) == 2181466421) strcat(s, "n");
if (crc32("nyOVo",5) == 3158154689) strcat(s, "o");
if (crc32("QCbKMNirkcamLwf",15) == 3360830722) strcat(s, "s");
if (crc32("rLCOhnbfqG",10) == 4253900251) strcat(s, "t");
if (crc32("kTcuUOCxdbjxy",13) == 745361996) strcat(s, "t");
if (crc32("FtJplwiEOYcArf",14) == 2422193442) strcat(s, "g");
if (crc32("rYljLGGqYI",10) == 3263520549) strcat(s, "y");
    return s;
}

char *enharmonic_adjectives() {
    char *s = calloc(11);
    if (crc32("ZPINrLNsj",9) == 281579099) strcat(s, "k");
if (crc32("TslfemOZeHQP",12) == 2209842623) strcat(s, "e");
if (crc32("DxuIGC",6) == 487477317) strcat(s, "d");
if (crc32("uqPFBjD",7) == 4170410422) strcat(s, "n");
if (crc32("onczq",5) == 3204067870) strcat(s, "h");
if (crc32("doIyj",5) == 3842260339) strcat(s, "a");
if (crc32("wcZfCXTE",8) == 1158622689) strcat(s, "p");
if (crc32("HEZWHcTPdarxsJ",14) == 2700273209) strcat(s, "r");
if (crc32("zPyMUa",6) == 2959362453) strcat(s, "m");
if (crc32("zcIwFWQEMIN",11) == 2129711781) strcat(s, "c");
if (crc32("FMfFJIZHzs",10) == 1399423944) strcat(s, "o");
if (crc32("OdYtKLehchp",11) == 649509159) strcat(s, "n");
if (crc32("XWbecX",6) == 3550234617) strcat(s, "l");
if (crc32("BtiugY",6) == 3542043337) strcat(s, "i");
if (crc32("DZIifIteAqhR",12) == 439360385) strcat(s, "j");
if (crc32("rgeNEoOtuSS",11) == 884009603) strcat(s, "c");
    return s;
}

char *chemoreceptive_adjectives() {
    char *s = calloc(15);
    if (crc32("fgWkcQbrLGora",13) == 1446956426) strcat(s, "z");
if (crc32("ZrOOZXSKxnUvdH",14) == 389778972) strcat(s, "c");
if (crc32("cQayV",5) == 1591805230) strcat(s, "h");
if (crc32("uLVekJVBqVjnGQ",14) == 2319977668) strcat(s, "e");
if (crc32("KLKuBCPtYBV",11) == 119792300) strcat(s, "m");
if (crc32("rMqgUnEunnMSMHU",15) == 3386853420) strcat(s, "o");
if (crc32("ijIRIOuaHNQb",12) == 537900324) strcat(s, "r");
if (crc32("BmJuHAaaxX",10) == 480582144) strcat(s, "r");
if (crc32("aUbwOFShYNRt",12) == 679038029) strcat(s, "C");
if (crc32("lPuWUqk",7) == 1009759616) strcat(s, "e");
if (crc32("YMNVLpjWC",9) == 938046317) strcat(s, "U");
if (crc32("cOvnde",6) == 3579130321) strcat(s, "c");
if (crc32("PvxUKwClBX",10) == 1031078031) strcat(s, "F");
if (crc32("AUNEYI",6) == 3973466077) strcat(s, "e");
if (crc32("BVuIZz",6) == 2536504242) strcat(s, "p");
if (crc32("sMBkNbFKy",9) == 347590863) strcat(s, "t");
if (crc32("fbrDtnwaePP",11) == 134950238) strcat(s, "i");
if (crc32("wLEiPRCtDgfPwoR",15) == 1890924023) strcat(s, "v");
if (crc32("SNgurTPSPUozcB",14) == 2487250648) strcat(s, "e");
    return s;
}

char *nonrepetitive_adjectives() {
    char *s = calloc(14);
    if (crc32("yHIOrfJQ",8) == 2111478079) strcat(s, "i");
if (crc32("HcSZZxeMxS",10) == 1384954386) strcat(s, "n");
if (crc32("ADtWe",5) == 740153158) strcat(s, "o");
if (crc32("sWKcuIfXiHBvQ",13) == 194003350) strcat(s, "U");
if (crc32("vsDdL",5) == 3226626820) strcat(s, "n");
if (crc32("TiRKKGNxSNA",11) == 3129176531) strcat(s, "r");
if (crc32("hIAZjHovgYsCDzQ",15) == 4085203385) strcat(s, "w");
if (crc32("QCqcj",5) == 4235482352) strcat(s, "e");
if (crc32("iOJbGMQpJR",10) == 1314074993) strcat(s, "B");
if (crc32("YWSxmNet",8) == 1982567481) strcat(s, "p");
if (crc32("UxuzislKVh",10) == 3187636838) strcat(s, "s");
if (crc32("rOmirwFfavDnhuZ",15) == 2195003891) strcat(s, "e");
if (crc32("GrWqmnOCK",9) == 1308443348) strcat(s, "x");
if (crc32("RsMOMsJzIwWWnjX",15) == 179102446) strcat(s, "t");
if (crc32("wDbyKozeVrlz",12) == 4134338910) strcat(s, "i");
if (crc32("JJhdWjjCMCuCKOK",15) == 2444343660) strcat(s, "t");
if (crc32("tvZjscDS",8) == 3917156651) strcat(s, "i");
if (crc32("weotqceqp",9) == 3264333412) strcat(s, "v");
if (crc32("TdHYnZBSrv",10) == 1128588290) strcat(s, "k");
if (crc32("KTqQaDkD",8) == 15955702) strcat(s, "e");
    return s;
}

char *streaklike_adjectives() {
    char *s = calloc(11);
    if (crc32("DvojAVowIOWE",12) == 1525652931) strcat(s, "S");
if (crc32("hnhQnqSCkd",10) == 2722696292) strcat(s, "s");
if (crc32("NSjrgaEpJocqH",13) == 266043642) strcat(s, "t");
if (crc32("KOuyUch",7) == 2630824682) strcat(s, "q");
if (crc32("DrOPiDuW",8) == 3823464831) strcat(s, "r");
if (crc32("CzAkAHMJXOsGjP",14) == 2431171557) strcat(s, "Z");
if (crc32("CNbJMhrhx",9) == 1972726014) strcat(s, "e");
if (crc32("NsiqMgo",7) == 3434931146) strcat(s, "a");
if (crc32("ZbPithSr",8) == 2823144372) strcat(s, "k");
if (crc32("NFTjgQrnyWbNcja",15) == 1762603839) strcat(s, "l");
if (crc32("fJVnWUBtGtgf",12) == 325888631) strcat(s, "i");
if (crc32("hzRBYXDl",8) == 1241174405) strcat(s, "k");
if (crc32("AIfaBcBjxywZN",13) == 3603500335) strcat(s, "i");
if (crc32("jJAuWUZWm",9) == 4290294357) strcat(s, "e");
    return s;
}

char *beholdable_adjectives() {
    char *s = calloc(11);
    if (crc32("fXsDcuQMIhAMuFg",15) == 1734759819) strcat(s, "x");
if (crc32("YgxviJDBg",9) == 3869993908) strcat(s, "b");
if (crc32("NscWFCLdKBTL",12) == 1532166525) strcat(s, "R");
if (crc32("KnKaBrOE",8) == 481187941) strcat(s, "e");
if (crc32("AEosemlxUWwlVRN",15) == 4032471254) strcat(s, "h");
if (crc32("MtXGlAojOjRkhU",14) == 44165774) strcat(s, "o");
if (crc32("GcKKozvOwd",10) == 3393869912) strcat(s, "l");
if (crc32("WdqrlNcuVDqdPg",14) == 4223529613) strcat(s, "l");
if (crc32("gEHwkHmmmSBs",12) == 1904454351) strcat(s, "q");
if (crc32("XLtEHYZDwAIuFoe",15) == 54560668) strcat(s, "d");
if (crc32("agAFUHvazdyHXxI",15) == 403948521) strcat(s, "J");
if (crc32("uBuXcqL",7) == 1576596242) strcat(s, "a");
if (crc32("czjRLZBZfeuh",12) == 3815764319) strcat(s, "X");
if (crc32("GpBZOlZNQgFNNB",14) == 3537219097) strcat(s, "b");
if (crc32("RWfWVtOHyAmg",12) == 1215319249) strcat(s, "f");
if (crc32("qyeamYRxoqSiLf",14) == 3553557781) strcat(s, "l");
if (crc32("XcaFEPdzfHE",11) == 922839215) strcat(s, "e");
    return s;
}

char *nonsuspended_adjectives() {
    char *s = calloc(13);
    if (crc32("irFDJXmzXWB",11) == 3682254968) strcat(s, "a");
if (crc32("LSnISVhpwwGnk",13) == 2174172813) strcat(s, "n");
if (crc32("KRHnCWhyfTnIXfD",15) == 3066978454) strcat(s, "D");
if (crc32("zgHxDldEN",9) == 1174946540) strcat(s, "o");
if (crc32("hFavUboe",8) == 774784864) strcat(s, "r");
if (crc32("uddTRM",6) == 3649964191) strcat(s, "n");
if (crc32("PAogPqts",8) == 2555347966) strcat(s, "y");
if (crc32("kkpvI",5) == 3866332759) strcat(s, "s");
if (crc32("nJFWobG",7) == 3935730781) strcat(s, "P");
if (crc32("FzCEq",5) == 3452162943) strcat(s, "u");
if (crc32("CeWlxfTAT",9) == 963113919) strcat(s, "s");
if (crc32("mhvVMUfRaKV",11) == 1278564558) strcat(s, "y");
if (crc32("PjYkKMcmeJ",10) == 1927824467) strcat(s, "p");
if (crc32("WhYgpzntideG",12) == 622687689) strcat(s, "D");
if (crc32("LATSVRlKGtwUP",13) == 3583255419) strcat(s, "e");
if (crc32("QhUcLrNL",8) == 1359056609) strcat(s, "n");
if (crc32("keuIQWZXC",9) == 2358871559) strcat(s, "o");
if (crc32("bqFCeXlUqwV",11) == 1579768483) strcat(s, "d");
if (crc32("WdWaGY",6) == 3392535303) strcat(s, "J");
if (crc32("rtTlTPOsHs",10) == 3932392036) strcat(s, "e");
if (crc32("ZTLVqpQaTs",10) == 3481938023) strcat(s, "c");
if (crc32("bRbWHne",7) == 3439605758) strcat(s, "d");
    return s;
}

char *unthrifty_adjectives() {
    char *s = calloc(10);
    if (crc32("zonNG",5) == 927623226) strcat(s, "o");
if (crc32("IAutJZxX",8) == 4058356504) strcat(s, "u");
if (crc32("AHInL",5) == 105778155) strcat(s, "n");
if (crc32("zXXszltRQKDZw",13) == 1640209993) strcat(s, "t");
if (crc32("RiWtBIt",7) == 1836991909) strcat(s, "h");
if (crc32("WXNeBbOzzOEsw",13) == 3195434871) strcat(s, "t");
if (crc32("JXCWMQQizmjGGf",14) == 2142712459) strcat(s, "r");
if (crc32("ABuyBq",6) == 3044613151) strcat(s, "i");
if (crc32("qhqrFmIOxqBhVh",14) == 1192704444) strcat(s, "D");
if (crc32("EVyKUsCtRhV",11) == 388242150) strcat(s, "f");
if (crc32("gaaQgtOLRc",10) == 4247317160) strcat(s, "t");
if (crc32("sFQhnJ",6) == 1360678226) strcat(s, "G");
if (crc32("DVjoSoGjnyrSNW",14) == 250222273) strcat(s, "y");
    return s;
}

char *dragonlike_adjectives() {
    char *s = calloc(11);
    if (crc32("pDCdCETsAr",10) == 3995152748) strcat(s, "d");
if (crc32("nWgqNTRDriSWLiW",15) == 1985012224) strcat(s, "d");
if (crc32("FJcvzNmSYuGLSW",14) == 164132769) strcat(s, "r");
if (crc32("JVbNdkKM",8) == 4103722663) strcat(s, "d");
if (crc32("NApye",5) == 2510098773) strcat(s, "a");
if (crc32("eZylDXPjVT",10) == 1580278427) strcat(s, "g");
if (crc32("EmZRRihr",8) == 886394822) strcat(s, "o");
if (crc32("UtsUIYI",7) == 2572054543) strcat(s, "a");
if (crc32("iSRaKzRmJrZpIq",14) == 603331373) strcat(s, "n");
if (crc32("btTOWLKQgxCxQs",14) == 1259335637) strcat(s, "l");
if (crc32("usXSR",5) == 4173780631) strcat(s, "i");
if (crc32("fDuPxFqEZLQfJQb",15) == 3159553780) strcat(s, "k");
if (crc32("MXwTdQBiMHl",11) == 3391557702) strcat(s, "k");
if (crc32("vBVWUTKImvbPoiI",15) == 2256288563) strcat(s, "e");
    return s;
}

char *nonamenable_adjectives() {
    char *s = calloc(12);
    if (crc32("hWFpB",5) == 4198519986) strcat(s, "n");
if (crc32("YdexXCccJfwfwS",14) == 1102920754) strcat(s, "U");
if (crc32("lOxAflMHJd",10) == 1633852651) strcat(s, "o");
if (crc32("aoKHIND",7) == 1485598055) strcat(s, "n");
if (crc32("stEIIyuZ",8) == 828796404) strcat(s, "a");
if (crc32("xJFkhOaSJ",9) == 1954047861) strcat(s, "m");
if (crc32("sqKhZPSkGnJf",12) == 825110953) strcat(s, "N");
if (crc32("XeFjWTJbhDt",11) == 87016259) strcat(s, "e");
if (crc32("zhsUCPvSiZcR",12) == 2965081608) strcat(s, "n");
if (crc32("XhreIhunYvPFs",13) == 1719056341) strcat(s, "a");
if (crc32("mjJPfXtd",8) == 3937685773) strcat(s, "b");
if (crc32("VrfhfigpwpFkSL",14) == 526829609) strcat(s, "B");
if (crc32("YlZtIhnfxyI",11) == 3400350780) strcat(s, "l");
if (crc32("lBZruIJyJgUfIy",14) == 2064533654) strcat(s, "V");
if (crc32("hCmYmnY",7) == 3533218272) strcat(s, "e");
    return s;
}

char *deltoidal_adjectives() {
    char *s = calloc(10);
    if (crc32("YnYjjPcRWnOccwc",15) == 119568891) strcat(s, "o");
if (crc32("GNrxwx",6) == 3777510047) strcat(s, "d");
if (crc32("BsCTFuTBquFtHjb",15) == 2815695399) strcat(s, "H");
if (crc32("OJiGgNlLLCNfc",13) == 2701207375) strcat(s, "e");
if (crc32("cGsZIKkhbxUy",12) == 3206536241) strcat(s, "l");
if (crc32("AFuPxrJNKBaDDH",14) == 472380311) strcat(s, "t");
if (crc32("rgBoygVsLKquHkA",15) == 4111727972) strcat(s, "z");
if (crc32("mbbWYo",6) == 2834433123) strcat(s, "o");
if (crc32("AjsuvEMtaes",11) == 2610579472) strcat(s, "i");
if (crc32("qNYzzdfEpU",10) == 2130937636) strcat(s, "s");
if (crc32("IPjJCqumkCfyQbB",15) == 2802681089) strcat(s, "d");
if (crc32("VzXBogL",7) == 1492337966) strcat(s, "a");
if (crc32("zMkdYbwBMv",10) == 1852839092) strcat(s, "l");
    return s;
}

char *wellcleansed_adjectives() {
    char *s = calloc(13);
    if (crc32("wDaNHcT",7) == 2140945820) strcat(s, "L");
if (crc32("ltEGCnilJhdGOo",14) == 1410271069) strcat(s, "w");
if (crc32("mWHWJHmNbTz",11) == 23712023) strcat(s, "A");
if (crc32("LrSDDuotZhYYpK",14) == 1856827598) strcat(s, "e");
if (crc32("sEJcOlJdQ",9) == 2616232748) strcat(s, "C");
if (crc32("MudazJsgAEQAOtS",15) == 763872973) strcat(s, "l");
if (crc32("DVaCQd",6) == 2321660185) strcat(s, "l");
if (crc32("bzodhq",6) == 3777090352) strcat(s, "c");
if (crc32("khBzQOWOdJVt",12) == 2611189565) strcat(s, "o");
if (crc32("bLDYL",5) == 2542991887) strcat(s, "l");
if (crc32("WdzpOJwFGbmOuPL",15) == 3043854584) strcat(s, "e");
if (crc32("aadnNTXxkY",10) == 565922984) strcat(s, "a");
if (crc32("sDwyIdIyEIbT",12) == 608395844) strcat(s, "d");
if (crc32("RbwSV",5) == 1476317373) strcat(s, "n");
if (crc32("iicxF",5) == 652621962) strcat(s, "s");
if (crc32("dbKYmD",6) == 1339003554) strcat(s, "e");
if (crc32("VPjwFxKcZEipMT",14) == 2841183786) strcat(s, "t");
if (crc32("rHywzF",6) == 2454584059) strcat(s, "d");
    return s;
}

char *wellfabricated_adjectives() {
    char *s = calloc(15);
    if (crc32("beeokGnjfLDtjvY",15) == 1364616281) strcat(s, "w");
if (crc32("risRuALByC",10) == 4209763828) strcat(s, "e");
if (crc32("wRPHcbKnU",9) == 2856292130) strcat(s, "t");
if (crc32("meVltOkjSAqXsT",14) == 448224784) strcat(s, "l");
if (crc32("aruicWDDYj",10) == 322251543) strcat(s, "V");
if (crc32("GCPHU",5) == 3930966609) strcat(s, "l");
if (crc32("NnkWjpRrjMpcXW",14) == 2988441211) strcat(s, "d");
if (crc32("cjQJFWrvaEPDGiY",15) == 2281802663) strcat(s, "f");
if (crc32("thvqonSkPcZaUNn",15) == 2044642646) strcat(s, "a");
if (crc32("RAJUaDPLMFKGRf",14) == 3192375865) strcat(s, "b");
if (crc32("MlpMwP",6) == 3208515814) strcat(s, "R");
if (crc32("lZWMONoMRFwEJqH",15) == 2999793310) strcat(s, "r");
if (crc32("WxEiisRFBow",11) == 3375150851) strcat(s, "M");
if (crc32("ohybhGJYRIb",11) == 1193833390) strcat(s, "i");
if (crc32("NdFru",5) == 3704889044) strcat(s, "c");
if (crc32("ttupwGvgPBnbQF",14) == 314505695) strcat(s, "a");
if (crc32("CcGBzbWjHlbB",12) == 1255704630) strcat(s, "t");
if (crc32("QgotztZ",7) == 3519834575) strcat(s, "l");
if (crc32("iPFIAjjWQdOSy",13) == 571095280) strcat(s, "e");
if (crc32("UXNmaKni",8) == 208351337) strcat(s, "d");
    return s;
}

char *peridotic_adjectives() {
    char *s = calloc(10);
    if (crc32("dteZKeRcu",9) == 1094162518) strcat(s, "d");
if (crc32("wNQkLc",6) == 4284614175) strcat(s, "p");
if (crc32("nYfvtS",6) == 1094673074) strcat(s, "e");
if (crc32("PHQqSKYfRzoPg",13) == 3399541543) strcat(s, "n");
if (crc32("QsvYefzcY",9) == 1331169174) strcat(s, "r");
if (crc32("eJaqGCSmMxcqwb",14) == 2516408570) strcat(s, "t");
if (crc32("NIjKgf",6) == 2001386700) strcat(s, "i");
if (crc32("UvTYOjjYQPP",11) == 1118692178) strcat(s, "f");
if (crc32("eecxJHExHd",10) == 21270932) strcat(s, "d");
if (crc32("dnwwE",5) == 999094102) strcat(s, "r");
if (crc32("AUSuyQJClMxLBYl",15) == 2333509414) strcat(s, "o");
if (crc32("YHKwE",5) == 4068831299) strcat(s, "A");
if (crc32("tFIZxOYGqSL",11) == 2844350376) strcat(s, "t");
if (crc32("LvelBHicJOVMqJ",14) == 4023033753) strcat(s, "o");
if (crc32("QBEGAdFLN",9) == 2224973888) strcat(s, "i");
if (crc32("YvqzJFMPTYiWw",13) == 516714320) strcat(s, "c");
    return s;
}

char *behenic_adjectives() {
    char *s = calloc(8);
    if (crc32("UvDwSIQ",7) == 1626542479) strcat(s, "q");
if (crc32("KtUytFQzAdjpN",13) == 916705816) strcat(s, "b");
if (crc32("ydnvsjEzzON",11) == 2548504609) strcat(s, "e");
if (crc32("mfDpTw",6) == 2973154774) strcat(s, "F");
if (crc32("PJCgWtV",7) == 158368486) strcat(s, "h");
if (crc32("eekwtzbrEDU",11) == 1819686310) strcat(s, "e");
if (crc32("jfFSuDPZg",9) == 1316701170) strcat(s, "n");
if (crc32("abssdlW",7) == 1106255891) strcat(s, "i");
if (crc32("oTnFuiVon",9) == 3782592301) strcat(s, "c");
    return s;
}

char *cirsoid_adjectives() {
    char *s = calloc(8);
    if (crc32("hFSSLBDhSpnMGRe",15) == 1278531156) strcat(s, "c");
if (crc32("MRmNewBDpZlgvE",14) == 2837055830) strcat(s, "f");
if (crc32("DtrjpWZnZZlf",12) == 1418540412) strcat(s, "i");
if (crc32("IyDeRUJ",7) == 4288983332) strcat(s, "r");
if (crc32("WaZzhXYa",8) == 3297158703) strcat(s, "s");
if (crc32("XeYHxtvUEvmU",12) == 374711551) strcat(s, "o");
if (crc32("BIHpfYVNNyVnAY",14) == 2418474424) strcat(s, "o");
if (crc32("xdjjnMcUzt",10) == 18933404) strcat(s, "F");
if (crc32("DEOvNyGpoFC",11) == 2904113656) strcat(s, "i");
if (crc32("KZIivXCvy",9) == 3658161681) strcat(s, "d");
    return s;
}

char *nonwestern_adjectives() {
    char *s = calloc(11);
    if (crc32("qYwzjldHdBv",11) == 2878011884) strcat(s, "x");
if (crc32("sfIGbgDlG",9) == 3909973743) strcat(s, "n");
if (crc32("dNHwOXWwzxwSZ",13) == 1102086847) strcat(s, "o");
if (crc32("FtYsXERHv",9) == 2601281406) strcat(s, "i");
if (crc32("zbABAcH",7) == 2202601780) strcat(s, "n");
if (crc32("axIcyIn",7) == 4215119514) strcat(s, "w");
if (crc32("TaqtBuVPgchUcN",14) == 2671097291) strcat(s, "S");
if (crc32("vDFEeRmlrWX",11) == 1762764560) strcat(s, "e");
if (crc32("yhTHfHHwGvVIFGN",15) == 42521123) strcat(s, "Q");
if (crc32("BSdWUUiuJM",10) == 982968911) strcat(s, "s");
if (crc32("ZnWprbGGS",9) == 488345235) strcat(s, "O");
if (crc32("XcyEYsncwdohMRs",15) == 1091537442) strcat(s, "t");
if (crc32("RmhLFIeVIEk",11) == 2201547066) strcat(s, "A");
if (crc32("iFLXMKhnRA",10) == 2760919759) strcat(s, "e");
if (crc32("BSvcUDfztmEAr",13) == 2159408276) strcat(s, "x");
if (crc32("CrdZgsnagUnA",12) == 37183666) strcat(s, "r");
if (crc32("hczExdv",7) == 516134677) strcat(s, "H");
if (crc32("cqYUE",5) == 1763980360) strcat(s, "n");
    return s;
}

char *unmaterialistic_adjectives() {
    char *s = calloc(16);
    if (crc32("WbPKoCViL",9) == 353965271) strcat(s, "u");
if (crc32("DeAGAvu",7) == 2613640030) strcat(s, "n");
if (crc32("EtLdMgfmOmBvrU",14) == 3975036152) strcat(s, "n");
if (crc32("gKfiIbRQKql",11) == 2011370442) strcat(s, "F");
if (crc32("umLwncIOPO",10) == 609601270) strcat(s, "m");
if (crc32("iQEbidGW",8) == 182213674) strcat(s, "s");
if (crc32("fOJzC",5) == 1412412635) strcat(s, "a");
if (crc32("gRRXiHMng",9) == 133674963) strcat(s, "t");
if (crc32("dHTmxlKud",9) == 3128388591) strcat(s, "U");
if (crc32("cXTKLw",6) == 2647410207) strcat(s, "e");
if (crc32("ejKxp",5) == 138934436) strcat(s, "r");
if (crc32("sRXuBK",6) == 4131091315) strcat(s, "d");
if (crc32("aUCyVgfwGiifDB",14) == 634473785) strcat(s, "i");
if (crc32("BFupxF",6) == 3995070174) strcat(s, "P");
if (crc32("OJqdrbueyYajWN",14) == 417033594) strcat(s, "a");
if (crc32("bfWJdjBaz",9) == 1302902531) strcat(s, "l");
if (crc32("FszZQ",5) == 1833266364) strcat(s, "i");
if (crc32("DZDRJsskm",9) == 3639043879) strcat(s, "s");
if (crc32("PrktVpxZ",8) == 898169404) strcat(s, "S");
if (crc32("CgaIEX",6) == 124991123) strcat(s, "t");
if (crc32("vYUuJgnt",8) == 3040463753) strcat(s, "D");
if (crc32("PHoGcSdwdy",10) == 2345797524) strcat(s, "i");
if (crc32("ejyByAKDeLZkk",13) == 390950955) strcat(s, "c");
    return s;
}

char *primitive_adjectives() {
    char *s = calloc(10);
    if (crc32("IoZRpnMJv",9) == 2995323146) strcat(s, "p");
if (crc32("XHSPWKc",7) == 2739873210) strcat(s, "s");
if (crc32("zZQrUIdfHC",10) == 556606728) strcat(s, "r");
if (crc32("WbLsywlP",8) == 934083005) strcat(s, "B");
if (crc32("qDvVmyzkUQOkL",13) == 3423715409) strcat(s, "i");
if (crc32("zQjCUVQoKsYaWtk",15) == 2124031596) strcat(s, "t");
if (crc32("XswGmMeJsq",10) == 3786565216) strcat(s, "m");
if (crc32("tWckMGanyWrvUMQ",15) == 2331939221) strcat(s, "i");
if (crc32("VvOOxWBUg",9) == 961515837) strcat(s, "t");
if (crc32("NklZCnVJ",8) == 1813072967) strcat(s, "i");
if (crc32("UoBko",5) == 94246948) strcat(s, "P");
if (crc32("aBkChTrnRGSCtpv",15) == 4135471913) strcat(s, "v");
if (crc32("aMXwhOgNQIGep",13) == 2430437299) strcat(s, "l");
if (crc32("JrnMVge",7) == 198454010) strcat(s, "e");
    return s;
}

char *olivary_adjectives() {
    char *s = calloc(8);
    if (crc32("BjmPRiZeaxDIEPR",15) == 619139481) strcat(s, "o");
if (crc32("CMCWqMbuJXqHkUq",15) == 1317484832) strcat(s, "l");
if (crc32("nFaAzc",6) == 2804331631) strcat(s, "i");
if (crc32("ClqHbxpUt",9) == 2791970108) strcat(s, "v");
if (crc32("BhwJi",5) == 1568452287) strcat(s, "c");
if (crc32("slmqQkhOU",9) == 1091327835) strcat(s, "a");
if (crc32("kFLMf",5) == 238630689) strcat(s, "r");
if (crc32("UBchRKAKPQqlF",13) == 2891234590) strcat(s, "N");
if (crc32("bCyKgIXLrKTo",12) == 1858941163) strcat(s, "y");
    return s;
}

char *proindustrial_adjectives() {
    char *s = calloc(14);
    if (crc32("kLihkV",6) == 1243189198) strcat(s, "p");
if (crc32("suCRRJaM",8) == 1513159179) strcat(s, "r");
if (crc32("BgYqzWhh",8) == 746883290) strcat(s, "o");
if (crc32("vwvCXD",6) == 403762604) strcat(s, "i");
if (crc32("rYygiPg",7) == 3034977271) strcat(s, "P");
if (crc32("TOtRakWDAxOfII",14) == 3522952309) strcat(s, "n");
if (crc32("rDGNrdjUivrXvU",14) == 1009402115) strcat(s, "d");
if (crc32("lHrZliggv",9) == 3010136117) strcat(s, "r");
if (crc32("Ajmupj",6) == 3211420499) strcat(s, "u");
if (crc32("hKrLOYystggUhiJ",15) == 2075110296) strcat(s, "s");
if (crc32("prrxSBRcvI",10) == 264104568) strcat(s, "t");
if (crc32("EqLHXdDKvhSdTK",14) == 3073420713) strcat(s, "r");
if (crc32("BpPRLzAmNZ",10) == 223177490) strcat(s, "b");
if (crc32("seHgzqzgS",9) == 878735010) strcat(s, "i");
if (crc32("MPLAeLDeHeJRr",13) == 3419399502) strcat(s, "a");
if (crc32("NJWfbFobBcwO",12) == 1750544294) strcat(s, "U");
if (crc32("vYZKKkeu",8) == 185878655) strcat(s, "l");
    return s;
}

char *spriggiest_adjectives() {
    char *s = calloc(11);
    if (crc32("hXLIqtPGBK",10) == 371495303) strcat(s, "s");
if (crc32("NKqqXymwMeI",11) == 3394539919) strcat(s, "p");
if (crc32("NItJAqhQ",8) == 3448081873) strcat(s, "r");
if (crc32("zxyKnBnKpV",10) == 2789588471) strcat(s, "i");
if (crc32("vWdXMJv",7) == 1138067879) strcat(s, "Z");
if (crc32("jpDzyYGXLtIUWU",14) == 3956996686) strcat(s, "g");
if (crc32("MZVnFTTeDnLHpcL",15) == 3789175116) strcat(s, "C");
if (crc32("LnQVsIo",7) == 1831683792) strcat(s, "g");
if (crc32("hJCVDqydrKrHokC",15) == 2229087471) strcat(s, "i");
if (crc32("jLBjmIB",7) == 1174312463) strcat(s, "e");
if (crc32("CLAMWrO",7) == 241300692) strcat(s, "s");
if (crc32("JpcBQu",6) == 1796577197) strcat(s, "R");
if (crc32("mqfWoLQTv",9) == 308129028) strcat(s, "t");
    return s;
}

char *untapered_adjectives() {
    char *s = calloc(10);
    if (crc32("KgprWvKqBqoZR",13) == 1896065977) strcat(s, "s");
if (crc32("JgnPpdeoVG",10) == 2552115661) strcat(s, "u");
if (crc32("hmByBS",6) == 2454106081) strcat(s, "U");
if (crc32("tmSkmbu",7) == 2501781054) strcat(s, "n");
if (crc32("kLAquKbPgnIE",12) == 1958840679) strcat(s, "t");
if (crc32("UQfXrzygjGt",11) == 3010444561) strcat(s, "a");
if (crc32("FIMpapWnLUfMSEh",15) == 1217083632) strcat(s, "Q");
if (crc32("VYRNFlBBsmVN",12) == 2274809907) strcat(s, "p");
if (crc32("ADRfhbrTjWby",12) == 4080940330) strcat(s, "e");
if (crc32("FkDep",5) == 3265978676) strcat(s, "r");
if (crc32("OdMFPWCzFXHI",12) == 2104040778) strcat(s, "e");
if (crc32("IHJKuhCe",8) == 2246367049) strcat(s, "Y");
if (crc32("fjyvXEKcJu",10) == 2519379211) strcat(s, "d");
    return s;
}

char *cibarian_adjectives() {
    char *s = calloc(9);
    if (crc32("csJQHUoAfZJ",11) == 451806841) strcat(s, "C");
if (crc32("nFsviNuByF",10) == 2865677050) strcat(s, "c");
if (crc32("tVbYMSzzCGdil",13) == 1533427916) strcat(s, "i");
if (crc32("sQLxsedkzEbfCct",15) == 644305037) strcat(s, "O");
if (crc32("GctrSWRBThYHmS",14) == 2475933017) strcat(s, "b");
if (crc32("FNRdJpwT",8) == 523290755) strcat(s, "a");
if (crc32("wBhph",5) == 2522829168) strcat(s, "r");
if (crc32("CGjxeRvvjFDn",12) == 3621705678) strcat(s, "i");
if (crc32("RfegCZGEH",9) == 1533652026) strcat(s, "a");
if (crc32("GbJKTQszeQgHZvJ",15) == 2719963112) strcat(s, "n");
    return s;
}

char *harborous_adjectives() {
    char *s = calloc(10);
    if (crc32("UZCLIAjH",8) == 2615141239) strcat(s, "h");
if (crc32("wiPjIaYMtCEzlOb",15) == 664810925) strcat(s, "o");
if (crc32("KCkRp",5) == 4239000509) strcat(s, "a");
if (crc32("nvRXqDsTYkvszIR",15) == 2951954557) strcat(s, "r");
if (crc32("TbJvuP",6) == 3676986580) strcat(s, "L");
if (crc32("mbIXDkqKk",9) == 892325209) strcat(s, "b");
if (crc32("TADmD",5) == 4268233777) strcat(s, "o");
if (crc32("qqQMtCiDOYVufO",14) == 3195224898) strcat(s, "r");
if (crc32("qCQrrRSuv",9) == 3337284549) strcat(s, "E");
if (crc32("eOTIl",5) == 1519196184) strcat(s, "o");
if (crc32("AJHrSukSFCcmoU",14) == 1791351378) strcat(s, "e");
if (crc32("SrpBYjeepNBRfB",14) == 779057581) strcat(s, "u");
if (crc32("uaeyUjxRUtfLAW",14) == 4155243231) strcat(s, "R");
if (crc32("NgiKfCOPHnGY",12) == 3191964826) strcat(s, "s");
    return s;
}

char *interdisciplinary_adjectives() {
    char *s = calloc(18);
    if (crc32("fjpdEcutwT",10) == 2817626785) strcat(s, "i");
if (crc32("yKYvNgGCpvnTTG",14) == 1843056152) strcat(s, "n");
if (crc32("sUBsLhMEtPRzq",13) == 614220479) strcat(s, "t");
if (crc32("MVVkoqJ",7) == 267895496) strcat(s, "y");
if (crc32("HuomGgGYTSpnXI",14) == 2832168913) strcat(s, "e");
if (crc32("McXFXBkNQg",10) == 2123890574) strcat(s, "U");
if (crc32("CtBxixzsTwWrUiR",15) == 1489094850) strcat(s, "r");
if (crc32("lrZarJdbVJyX",12) == 1666324760) strcat(s, "d");
if (crc32("AMbTh",5) == 4220463886) strcat(s, "K");
if (crc32("TSEfYIBJpJ",10) == 452308094) strcat(s, "i");
if (crc32("fqfwqg",6) == 507811474) strcat(s, "y");
if (crc32("fHMSOyyfCVx",11) == 519960843) strcat(s, "s");
if (crc32("UlhPGh",6) == 1135954094) strcat(s, "g");
if (crc32("aJTUK",5) == 3685656284) strcat(s, "c");
if (crc32("nrXbAhYEIHVMv",13) == 272293053) strcat(s, "E");
if (crc32("gWJVIXNLxnC",11) == 3629320392) strcat(s, "i");
if (crc32("GHWYgluGwz",10) == 2745277021) strcat(s, "p");
if (crc32("AxtYx",5) == 1801834760) strcat(s, "l");
if (crc32("OUvZg",5) == 431188578) strcat(s, "u");
if (crc32("vRAunDcCnbD",11) == 2447906963) strcat(s, "i");
if (crc32("uKMsA",5) == 3511600733) strcat(s, "r");
if (crc32("cwjevGoE",8) == 895935719) strcat(s, "n");
if (crc32("pJcDcnSMjPSz",12) == 1680028331) strcat(s, "a");
if (crc32("BEumlJSBZmjjLY",14) == 3978989647) strcat(s, "r");
if (crc32("rFfdoWOVVWETEw",14) == 3249993748) strcat(s, "P");
if (crc32("XhtbokVdELCt",12) == 1240200199) strcat(s, "y");
    return s;
}

char *sedimentologic_adjectives() {
    char *s = calloc(15);
    if (crc32("qCPdBFj",7) == 2234067369) strcat(s, "F");
if (crc32("XwVZuCeuWUae",12) == 1074169149) strcat(s, "s");
if (crc32("tqdFYsSDKVpt",12) == 1798289355) strcat(s, "b");
if (crc32("rVtyHIWMox",10) == 1700731498) strcat(s, "e");
if (crc32("nMlIpm",6) == 836290966) strcat(s, "d");
if (crc32("pwAFHYgXdkdWRy",14) == 4051993433) strcat(s, "i");
if (crc32("spaThGsfl",9) == 2887901436) strcat(s, "P");
if (crc32("PKCxZXxMLd",10) == 459322517) strcat(s, "m");
if (crc32("vDKjohmBw",9) == 4272280143) strcat(s, "J");
if (crc32("ONFALChy",8) == 450520495) strcat(s, "e");
if (crc32("JSvjQean",8) == 721028323) strcat(s, "n");
if (crc32("NEeVbUhSxjUmAaK",15) == 523785717) strcat(s, "o");
if (crc32("ggvQXf",6) == 2058919402) strcat(s, "t");
if (crc32("dDviaUJWZsWY",12) == 1636925117) strcat(s, "o");
if (crc32("EKWIrKJ",7) == 1344207133) strcat(s, "l");
if (crc32("zpogBHehoUZFoj",14) == 966646318) strcat(s, "o");
if (crc32("ypQkBMTqlRWkDDq",15) == 3316315354) strcat(s, "g");
if (crc32("MobfvDMCCMDLRx",14) == 1596709322) strcat(s, "i");
if (crc32("DsznVviW",8) == 1726246502) strcat(s, "c");
    return s;
}

char *hippiest_adjectives() {
    char *s = calloc(9);
    if (crc32("HkVslJXmqEdwr",13) == 1673924562) strcat(s, "h");
if (crc32("SSUcIFOI",8) == 1467352934) strcat(s, "R");
if (crc32("TCdDr",5) == 3889205288) strcat(s, "i");
if (crc32("uxgfUh",6) == 2345448682) strcat(s, "t");
if (crc32("VrfivYU",7) == 3957048025) strcat(s, "p");
if (crc32("FOtZTuumhtPI",12) == 2751407101) strcat(s, "G");
if (crc32("decJaSg",7) == 2613233630) strcat(s, "p");
if (crc32("yyrKySPlqnn",11) == 753390224) strcat(s, "I");
if (crc32("QrbAJXZ",7) == 447737186) strcat(s, "i");
if (crc32("nfZVDLXrKzSLj",13) == 226071966) strcat(s, "e");
if (crc32("vCSZAj",6) == 698778824) strcat(s, "J");
if (crc32("hBzcnHpxJIqECvY",15) == 2622995013) strcat(s, "s");
if (crc32("BUXHYtMFIgDMDR",14) == 809052508) strcat(s, "t");
    return s;
}

char *chemosmotic_adjectives() {
    char *s = calloc(12);
    if (crc32("MoLHhXVkXOd",11) == 2468157382) strcat(s, "j");
if (crc32("qNyPhDC",7) == 3773489746) strcat(s, "c");
if (crc32("yWJczRKU",8) == 589836271) strcat(s, "h");
if (crc32("FyRvFXMd",8) == 388813192) strcat(s, "e");
if (crc32("RUGVVFEdMtsx",12) == 1249845427) strcat(s, "U");
if (crc32("JIqPc",5) == 156159891) strcat(s, "m");
if (crc32("hyEqzzyQD",9) == 2499635679) strcat(s, "Y");
if (crc32("poWAFIEJ",8) == 447191331) strcat(s, "o");
if (crc32("FMAjbaQU",8) == 3625050478) strcat(s, "s");
if (crc32("NzwjAJE",7) == 3081834603) strcat(s, "R");
if (crc32("VkDHq",5) == 4117175503) strcat(s, "m");
if (crc32("QNgbFkdzoVqP",12) == 165977741) strcat(s, "o");
if (crc32("WgaSGNFScoRneKj",15) == 2430211065) strcat(s, "t");
if (crc32("DMZqYGk",7) == 972813080) strcat(s, "i");
if (crc32("GYpRjtsjzANXiiW",15) == 1340007369) strcat(s, "f");
if (crc32("qJYUQcSO",8) == 1879323388) strcat(s, "c");
    return s;
}

char *symbolic_adjectives() {
    char *s = calloc(9);
    if (crc32("bdalq",5) == 919304050) strcat(s, "s");
if (crc32("DuRGxbD",7) == 567331126) strcat(s, "u");
if (crc32("TorxR",5) == 1560413787) strcat(s, "y");
if (crc32("gYPcWMW",7) == 811052582) strcat(s, "m");
if (crc32("HyCYrLkxVXHHVQZ",15) == 3447415133) strcat(s, "A");
if (crc32("zvvwsBtCnLtzpG",14) == 2319358298) strcat(s, "b");
if (crc32("vOoCZYns",8) == 2919252398) strcat(s, "o");
if (crc32("UrSmkpSxGBUA",12) == 399968085) strcat(s, "l");
if (crc32("jZVAtaCnEu",10) == 3782118795) strcat(s, "i");
if (crc32("xElAufMDgYsozaE",15) == 463518213) strcat(s, "l");
if (crc32("RTjSzD",6) == 2736255535) strcat(s, "c");
    return s;
}

char *shaglike_adjectives() {
    char *s = calloc(9);
    if (crc32("yOzCmvRIfbcKF",13) == 1323602415) strcat(s, "s");
if (crc32("gwsBjlstmIJOjh",14) == 3593170885) strcat(s, "s");
if (crc32("EhQzuBCv",8) == 2239493009) strcat(s, "h");
if (crc32("DSYcCXGfFa",10) == 2372719446) strcat(s, "S");
if (crc32("ZTRMnwuMZRu",11) == 4085143599) strcat(s, "a");
if (crc32("bsTKwkF",7) == 1263623291) strcat(s, "v");
if (crc32("AsXwjITfmaj",11) == 1273049527) strcat(s, "g");
if (crc32("ZAwboRxlWzQDNV",14) == 3480614874) strcat(s, "u");
if (crc32("luqjieCwzmMYUb",14) == 3447704168) strcat(s, "l");
if (crc32("ZsOExx",6) == 3665787874) strcat(s, "h");
if (crc32("bMwcWNMpIHhVW",13) == 1919773797) strcat(s, "i");
if (crc32("aGRpzQIDhxvXtF",14) == 4180877541) strcat(s, "k");
if (crc32("hJrzOdjwXtBk",12) == 3210570527) strcat(s, "Z");
if (crc32("CvkmyQIWv",9) == 3797349452) strcat(s, "e");
    return s;
}

char *Carinthian_adjectives() {
    char *s = calloc(11);
    if (crc32("DuGzFCtqwbre",12) == 2371144237) strcat(s, "C");
if (crc32("aHAsQPAg",8) == 1363725132) strcat(s, "a");
if (crc32("bpzyyer",7) == 438334944) strcat(s, "q");
if (crc32("IVqOAOXplMByRii",15) == 2820055666) strcat(s, "r");
if (crc32("XsfiRPlUwNDnUg",14) == 2767853167) strcat(s, "i");
if (crc32("kGjDAQgqeWcZyj",14) == 991742754) strcat(s, "n");
if (crc32("WsJbw",5) == 3510373912) strcat(s, "t");
if (crc32("NDXCCDwPsk",10) == 1933453506) strcat(s, "h");
if (crc32("zCUKA",5) == 1478768972) strcat(s, "i");
if (crc32("PFNEBxt",7) == 4011953898) strcat(s, "i");
if (crc32("uypxmxKYowrbM",13) == 4058648739) strcat(s, "c");
if (crc32("zYJjeOlCGEtMDG",14) == 2842558424) strcat(s, "a");
if (crc32("YwynQK",6) == 3345037682) strcat(s, "n");
    return s;
}

char *exuberant_adjectives() {
    char *s = calloc(10);
    if (crc32("tgwwWzweoZbHNo",14) == 440415676) strcat(s, "B");
if (crc32("AmdeasjBTCOh",12) == 3440237156) strcat(s, "e");
if (crc32("OIHllgYJxaspoY",14) == 1466861168) strcat(s, "x");
if (crc32("nBZEOyfQKEVhA",13) == 4081133096) strcat(s, "k");
if (crc32("YvhiRfxPTC",10) == 2618542139) strcat(s, "u");
if (crc32("LgOfztGpX",9) == 675864) strcat(s, "b");
if (crc32("LnzhqDSvDc",10) == 3523441684) strcat(s, "e");
if (crc32("VafTGFPmnAdHg",13) == 2127429865) strcat(s, "r");
if (crc32("XyUEKgoJXzeQZgB",15) == 3740690261) strcat(s, "p");
if (crc32("GuXXYscuqKrseIt",15) == 4078913702) strcat(s, "a");
if (crc32("KDVfAMYpa",9) == 4089166263) strcat(s, "n");
if (crc32("ymzsVElKURGW",12) == 2105561673) strcat(s, "t");
    return s;
}

char *hypnoanalytic_adjectives() {
    char *s = calloc(14);
    if (crc32("vrrndgHXGIN",11) == 1052310145) strcat(s, "I");
if (crc32("YkLnwAnMhFXjcWE",15) == 246154935) strcat(s, "h");
if (crc32("bwXKE",5) == 2490390989) strcat(s, "N");
if (crc32("kIxVvwTZUOdhHf",14) == 1262881627) strcat(s, "y");
if (crc32("MyOUEjUYMn",10) == 869230518) strcat(s, "H");
if (crc32("OWeFRFawGNxBEr",14) == 42600276) strcat(s, "p");
if (crc32("oKGGJxCbNyTU",12) == 1221861771) strcat(s, "j");
if (crc32("dAgEMKjolgEGU",13) == 3465654305) strcat(s, "n");
if (crc32("NPpaedrisUjLumj",15) == 500055480) strcat(s, "U");
if (crc32("cLIkSSJS",8) == 837741984) strcat(s, "o");
if (crc32("GIwEvenDOoaGFav",15) == 1179254099) strcat(s, "a");
if (crc32("fKSZxMb",7) == 1998523911) strcat(s, "n");
if (crc32("ZJsQYXf",7) == 2359064307) strcat(s, "E");
if (crc32("lqKTSiULbGOJH",13) == 3046008) strcat(s, "a");
if (crc32("uWjXqbqZo",9) == 3930914470) strcat(s, "U");
if (crc32("wvyuEFMmF",9) == 589894699) strcat(s, "l");
if (crc32("GydSWb",6) == 3685032595) strcat(s, "y");
if (crc32("sXWNt",5) == 646489556) strcat(s, "t");
if (crc32("OhullkTD",8) == 2969532983) strcat(s, "i");
if (crc32("wgsCXoQZ",8) == 2054100946) strcat(s, "c");
    return s;
}

char *extractable_adjectives() {
    char *s = calloc(12);
    if (crc32("zMfgQoB",7) == 3147934576) strcat(s, "F");
if (crc32("FmwUgOR",7) == 115408449) strcat(s, "e");
if (crc32("lignig",6) == 3649533499) strcat(s, "x");
if (crc32("JfKBjOAtUlb",11) == 3831757150) strcat(s, "t");
if (crc32("TnxABDaipyEjpDD",15) == 4145024590) strcat(s, "r");
if (crc32("nCwSDa",6) == 2866626067) strcat(s, "a");
if (crc32("MaFkD",5) == 3412838403) strcat(s, "Z");
if (crc32("OpAeZIpUmB",10) == 4045291143) strcat(s, "c");
if (crc32("LxOdPOovLVJ",11) == 1757988268) strcat(s, "E");
if (crc32("YkTkGphcoHO",11) == 1952134683) strcat(s, "t");
if (crc32("gmuKGwz",7) == 3209424196) strcat(s, "a");
if (crc32("qZveWTl",7) == 4079792184) strcat(s, "b");
if (crc32("lJlbqGmpSANssU",14) == 4134059516) strcat(s, "u");
if (crc32("uvkiMkyw",8) == 3847998760) strcat(s, "l");
if (crc32("FApHCOlxyetj",12) == 1033125903) strcat(s, "e");
    return s;
}

char *unevasive_adjectives() {
    char *s = calloc(10);
    if (crc32("HLyxANLLGwCznXp",15) == 2610942351) strcat(s, "u");
if (crc32("mpleFJ",6) == 4089207957) strcat(s, "n");
if (crc32("TMHZLt",6) == 2995853602) strcat(s, "e");
if (crc32("MpkPqc",6) == 2580708921) strcat(s, "v");
if (crc32("gDANEaXBtKS",11) == 775263879) strcat(s, "a");
if (crc32("AhKBmap",7) == 3233551111) strcat(s, "I");
if (crc32("IQLHvNy",7) == 1607552749) strcat(s, "s");
if (crc32("JvKguQKRKPOtP",13) == 2777966692) strcat(s, "c");
if (crc32("sFAcsYTnxXB",11) == 1482159711) strcat(s, "i");
if (crc32("makEayQGRR",10) == 689610206) strcat(s, "q");
if (crc32("NnHaFiGQCscZAml",15) == 3027014873) strcat(s, "v");
if (crc32("EEEcAcsZmIP",11) == 40608414) strcat(s, "e");
    return s;
}

char *megathermic_adjectives() {
    char *s = calloc(12);
    if (crc32("vjkImbFlKqn",11) == 773518214) strcat(s, "Q");
if (crc32("DsbxnVvUN",9) == 1916816000) strcat(s, "m");
if (crc32("nyQQpl",6) == 1559110441) strcat(s, "d");
if (crc32("WsSoZoViBwua",12) == 2059152874) strcat(s, "e");
if (crc32("SlAwsaINLvpvOg",14) == 322851800) strcat(s, "l");
if (crc32("EpcNNZk",7) == 3306424118) strcat(s, "g");
if (crc32("QBdQlsJx",8) == 3391300453) strcat(s, "a");
if (crc32("MJBrQ",5) == 3767791620) strcat(s, "t");
if (crc32("WigMQnbEU",9) == 3248459622) strcat(s, "h");
if (crc32("jpQdiuriUUHg",12) == 3458593532) strcat(s, "e");
if (crc32("jqwQHXgKzAQqzh",14) == 2208069457) strcat(s, "e");
if (crc32("aaGdIESURg",10) == 2596682362) strcat(s, "r");
if (crc32("KkzTrGcfg",9) == 744895439) strcat(s, "j");
if (crc32("KTCLLrk",7) == 1007134208) strcat(s, "m");
if (crc32("iuaPtQDiricmR",13) == 100577941) strcat(s, "O");
if (crc32("gbZQZ",5) == 891952209) strcat(s, "i");
if (crc32("sjOXwCPJZkZwlp",14) == 3414715040) strcat(s, "V");
if (crc32("mnIcecSGo",9) == 2771982520) strcat(s, "c");
    return s;
}

char *voluble_adjectives() {
    char *s = calloc(8);
    if (crc32("gbGJzuDoE",9) == 527004243) strcat(s, "v");
if (crc32("YrUMJEUSQHn",11) == 2045003815) strcat(s, "o");
if (crc32("wTTxmkiAnrChJMa",15) == 3425311078) strcat(s, "Z");
if (crc32("xqjfsKzwwgl",11) == 733458542) strcat(s, "l");
if (crc32("ZCFaQO",6) == 2972532297) strcat(s, "u");
if (crc32("VzgJdonJlLF",11) == 1291252598) strcat(s, "b");
if (crc32("eNqmEWB",7) == 3466304133) strcat(s, "J");
if (crc32("cxlhGrKdtUW",11) == 3278638844) strcat(s, "l");
if (crc32("fOIlFmrkHhKjxb",14) == 2522298739) strcat(s, "e");
    return s;
}

char *NeoScholastic_adjectives() {
    char *s = calloc(14);
    if (crc32("VGGsJnTp",8) == 2579881485) strcat(s, "G");
if (crc32("LchVMlwSAemu",12) == 1314942810) strcat(s, "N");
if (crc32("kFOemi",6) == 1830059621) strcat(s, "e");
if (crc32("wXOfjEDo",8) == 70754584) strcat(s, "O");
if (crc32("HJPHaUvCKlc",11) == 3912436928) strcat(s, "o");
if (crc32("LktPEnHRfM",10) == 4274452075) strcat(s, "t");
if (crc32("nFfAzSH",7) == 449418929) strcat(s, "S");
if (crc32("QbjCqmPWSYxqGL",14) == 199221914) strcat(s, "c");
if (crc32("rOORp",5) == 2243192031) strcat(s, "X");
if (crc32("SkkEDtaup",9) == 4094018282) strcat(s, "h");
if (crc32("OlzzbqyAsrvUgXq",15) == 1766948968) strcat(s, "J");
if (crc32("oYoezQzCVJy",11) == 135068069) strcat(s, "o");
if (crc32("WUEJuCliwZxMhf",14) == 3461515678) strcat(s, "l");
if (crc32("CsYUKgorsOAeXY",14) == 896954651) strcat(s, "a");
if (crc32("mEDWAkJTvUPzV",13) == 1360765331) strcat(s, "s");
if (crc32("ChRHFBscDMpqpOt",15) == 2184936928) strcat(s, "t");
if (crc32("DbguvRzqU",9) == 2173885814) strcat(s, "i");
if (crc32("fQFLmlZHdnpyJo",14) == 219893649) strcat(s, "c");
    return s;
}

char *pseudoVergilian_adjectives() {
    char *s = calloc(16);
    if (crc32("jtPNwLrKqs",10) == 4206707360) strcat(s, "S");
if (crc32("esZYOEsD",8) == 2017105367) strcat(s, "p");
if (crc32("oWFusYCuYKjt",12) == 384623516) strcat(s, "W");
if (crc32("wbitiSUYfd",10) == 3834083419) strcat(s, "s");
if (crc32("jiVdGcWHEIKA",12) == 2881653624) strcat(s, "v");
if (crc32("gzmZAigbLYM",11) == 4159157733) strcat(s, "e");
if (crc32("QSAqwVBoaNr",11) == 34419382) strcat(s, "u");
if (crc32("klcxHjXTqXvzAmJ",15) == 557224740) strcat(s, "d");
if (crc32("aPaoLyyeXP",10) == 2473286992) strcat(s, "L");
if (crc32("mCOUbcI",7) == 3526517903) strcat(s, "o");
if (crc32("nvbAxew",7) == 3312456247) strcat(s, "t");
if (crc32("XhvZBCSv",8) == 2672915871) strcat(s, "V");
if (crc32("aVRPAYijOUqjAEX",15) == 2727469677) strcat(s, "e");
if (crc32("BKjeIa",6) == 3476074813) strcat(s, "f");
if (crc32("yLHQW",5) == 3406095900) strcat(s, "r");
if (crc32("LpnlPDJCSvMT",12) == 822120874) strcat(s, "g");
if (crc32("VGgmdoR",7) == 95721960) strcat(s, "i");
if (crc32("JPaJsHuijUuq",12) == 2340348142) strcat(s, "b");
if (crc32("sFKLd",5) == 2901650826) strcat(s, "l");
if (crc32("CuPvEG",6) == 4160471789) strcat(s, "i");
if (crc32("lkQFIYrMKtX",11) == 2194775710) strcat(s, "x");
if (crc32("SxhbKGORd",9) == 3211925085) strcat(s, "a");
if (crc32("TNVpsMWJUHyZRF",14) == 1556484777) strcat(s, "n");
    return s;
}

char *Averrhoistic_adjectives() {
    char *s = calloc(13);
    if (crc32("MIBVCe",6) == 3897018764) strcat(s, "A");
if (crc32("XuRGBnI",7) == 3277574339) strcat(s, "o");
if (crc32("qsvkkLuVOy",10) == 1165568999) strcat(s, "v");
if (crc32("JbLsVGBFmWAkr",13) == 1531870525) strcat(s, "w");
if (crc32("etUsSbqpTUniQ",13) == 1812273071) strcat(s, "e");
if (crc32("KiytVhHd",8) == 215893139) strcat(s, "F");
if (crc32("KeVPoD",6) == 2491494174) strcat(s, "r");
if (crc32("nwzSRSJF",8) == 3327200275) strcat(s, "r");
if (crc32("YAVkSdjDQPMb",12) == 4275548294) strcat(s, "h");
if (crc32("WqCHjSKYFtwfS",13) == 3663277489) strcat(s, "o");
if (crc32("QgsyPBXdhCP",11) == 997001504) strcat(s, "m");
if (crc32("QOJkcpSkmN",10) == 774172455) strcat(s, "i");
if (crc32("OfdMmn",6) == 4024548485) strcat(s, "s");
if (crc32("kkbCNz",6) == 3439872653) strcat(s, "R");
if (crc32("BEdrTKwOhKx",11) == 1138568580) strcat(s, "t");
if (crc32("QRHssEbxNyp",11) == 4031949070) strcat(s, "B");
if (crc32("MlhRyLxkQjU",11) == 2159685839) strcat(s, "i");
if (crc32("UEUMDqsFzt",10) == 3489059189) strcat(s, "c");
    return s;
}

char *ditheistic_adjectives() {
    char *s = calloc(11);
    if (crc32("xviQHfAm",8) == 2000464981) strcat(s, "d");
if (crc32("uEADfUolciOhyNn",15) == 3119166878) strcat(s, "i");
if (crc32("APUEB",5) == 387448545) strcat(s, "t");
if (crc32("DjbrTtQ",7) == 2584327662) strcat(s, "h");
if (crc32("yfdcRPOQOeNY",12) == 2324017551) strcat(s, "W");
if (crc32("haaMGjUT",8) == 3228529087) strcat(s, "e");
if (crc32("ngXZCpSfBodKziw",15) == 3646557577) strcat(s, "i");
if (crc32("KvYMVXhtaRyvtg",14) == 565070486) strcat(s, "y");
if (crc32("RRmvpTFvApxYrB",14) == 305407360) strcat(s, "s");
if (crc32("oFcBxMPbJIx",11) == 4065111789) strcat(s, "t");
if (crc32("gGlgX",5) == 734980710) strcat(s, "R");
if (crc32("oFGwihHaZhWkf",13) == 2463622358) strcat(s, "i");
if (crc32("RixGm",5) == 1500198228) strcat(s, "L");
if (crc32("lNQDemvYGkMW",12) == 1871715252) strcat(s, "c");
    return s;
}

char *flybynight_adjectives() {
    char *s = calloc(11);
    if (crc32("zWgXRfE",7) == 3916357739) strcat(s, "n");
if (crc32("JpLHEbJ",7) == 33936274) strcat(s, "f");
if (crc32("KdVnqKRtCaDh",12) == 2259220163) strcat(s, "l");
if (crc32("VOPyWDBfaMfqXV",14) == 2922131807) strcat(s, "y");
if (crc32("YISLAh",6) == 1137778671) strcat(s, "D");
if (crc32("DpQHhHqyMcu",11) == 4213497306) strcat(s, "b");
if (crc32("bVFQO",5) == 4200743464) strcat(s, "y");
if (crc32("rjInUBMEMWyuQbR",15) == 574231683) strcat(s, "n");
if (crc32("cIsYkM",6) == 1561138277) strcat(s, "v");
if (crc32("DyFzYYu",7) == 4199500189) strcat(s, "i");
if (crc32("cZLiVKK",7) == 3417895810) strcat(s, "g");
if (crc32("UtfKet",6) == 1389168902) strcat(s, "c");
if (crc32("oFtNhILTAkD",11) == 1708475002) strcat(s, "h");
if (crc32("JyYApsUYI",9) == 3803545326) strcat(s, "t");
    return s;
}

char *lithological_adjectives() {
    char *s = calloc(13);
    if (crc32("VkGrBuyfTOsQev",14) == 4283087454) strcat(s, "X");
if (crc32("JQHfxTv",7) == 4049133821) strcat(s, "l");
if (crc32("fUvdp",5) == 1377191856) strcat(s, "v");
if (crc32("EPomPsTVz",9) == 2560861581) strcat(s, "i");
if (crc32("rmcXoVsLX",9) == 1459594891) strcat(s, "Z");
if (crc32("RefbcjLViGeXIIB",15) == 2733351147) strcat(s, "t");
if (crc32("anAbodOuM",9) == 2802518866) strcat(s, "l");
if (crc32("FeZcPA",6) == 1817183746) strcat(s, "h");
if (crc32("vfJUqmlUW",9) == 2986085661) strcat(s, "o");
if (crc32("sJuxDMCIUMGL",12) == 1461343295) strcat(s, "l");
if (crc32("fEzEhnozR",9) == 674415929) strcat(s, "n");
if (crc32("mWfcVc",6) == 3810376042) strcat(s, "o");
if (crc32("reShAHFeYCOp",12) == 2060617127) strcat(s, "L");
if (crc32("QayyFkskAvrVc",13) == 1023295949) strcat(s, "g");
if (crc32("JdGGHjtPqOwts",13) == 3861794754) strcat(s, "y");
if (crc32("ZhCqRDhMyGmuae",14) == 215855116) strcat(s, "i");
if (crc32("ykkSfOamDUIcEVG",15) == 1164704434) strcat(s, "O");
if (crc32("xULjqKVsOD",10) == 1056541218) strcat(s, "c");
if (crc32("fPuvRFaIDpeTGM",14) == 943489723) strcat(s, "v");
if (crc32("rhyKuuu",7) == 2599840882) strcat(s, "a");
if (crc32("emEGm",5) == 2765532146) strcat(s, "l");
    return s;
}

char *cultic_adjectives() {
    char *s = calloc(7);
    if (crc32("prGKBx",6) == 2367676629) strcat(s, "Y");
if (crc32("hUcxv",5) == 2275567247) strcat(s, "c");
if (crc32("FSUCrzpTA",9) == 3108870358) strcat(s, "W");
if (crc32("UqfqZeizFHnS",12) == 2476438191) strcat(s, "u");
if (crc32("oYNHvEdwIY",10) == 889325724) strcat(s, "N");
if (crc32("gVcWvcBe",8) == 587264) strcat(s, "l");
if (crc32("YqllzARoGkbznD",14) == 3025431273) strcat(s, "t");
if (crc32("hCyknno",7) == 3492186952) strcat(s, "i");
if (crc32("BBoEsKDYFrY",11) == 1166788941) strcat(s, "c");
    return s;
}

char *preabundant_adjectives() {
    char *s = calloc(12);
    if (crc32("bqRqpwzecckFCg",14) == 2594497213) strcat(s, "A");
if (crc32("RYasOSetddj",11) == 158174777) strcat(s, "p");
if (crc32("EhwqDSRzBiET",12) == 278010014) strcat(s, "r");
if (crc32("MtAXyyNvbM",10) == 2045126725) strcat(s, "p");
if (crc32("YXMIzBhp",8) == 1407793691) strcat(s, "e");
if (crc32("QkjcDddbuBI",11) == 3268393107) strcat(s, "m");
if (crc32("gJKuKvFLUZO",11) == 1925261223) strcat(s, "a");
if (crc32("bIbVIeDzIs",10) == 390112855) strcat(s, "B");
if (crc32("LmDSO",5) == 2450201089) strcat(s, "b");
if (crc32("XRskNjEO",8) == 1629057038) strcat(s, "u");
if (crc32("wswqZ",5) == 3349451170) strcat(s, "H");
if (crc32("JttHijN",7) == 4129723222) strcat(s, "n");
if (crc32("ndeGPizLUcFFG",13) == 871483655) strcat(s, "w");
if (crc32("SyPKdtwOiO",10) == 3200657282) strcat(s, "d");
if (crc32("bSknOjpJPnTOniL",15) == 318782170) strcat(s, "a");
if (crc32("jFHrsFxfUT",10) == 441864067) strcat(s, "n");
if (crc32("pIHdxQjIiaICzN",14) == 2961800728) strcat(s, "M");
if (crc32("segLlBiKydeqVo",14) == 1314837278) strcat(s, "t");
    return s;
}

char *unincarcerated_adjectives() {
    char *s = calloc(15);
    if (crc32("HHAcsaBZjI",10) == 241437089) strcat(s, "B");
if (crc32("kYtcmzuE",8) == 3558569822) strcat(s, "u");
if (crc32("ERWZfEZ",7) == 2926601337) strcat(s, "n");
if (crc32("ufYkIfoPtqW",11) == 3923553569) strcat(s, "p");
if (crc32("rPDKzrI",7) == 1075591416) strcat(s, "i");
if (crc32("WJuwYULDlZWBT",13) == 739064497) strcat(s, "P");
if (crc32("jLqsTbGmAB",10) == 3808583591) strcat(s, "n");
if (crc32("NDoQwFeANP",10) == 3578469971) strcat(s, "c");
if (crc32("oUIrXaQpQVI",11) == 2423789654) strcat(s, "H");
if (crc32("dpPhuC",6) == 3944809603) strcat(s, "a");
if (crc32("zGXCAUk",7) == 4046055626) strcat(s, "G");
if (crc32("RcMsY",5) == 3280334509) strcat(s, "r");
if (crc32("jBgOErRcBcd",11) == 3347341880) strcat(s, "c");
if (crc32("LIhZYKYsqv",10) == 2723688484) strcat(s, "Q");
if (crc32("SjVjUzSZqgdxYa",14) == 3992635236) strcat(s, "e");
if (crc32("xBvtH",5) == 1572187415) strcat(s, "r");
if (crc32("NQPFJoO",7) == 1524542991) strcat(s, "w");
if (crc32("knqLxgUsabA",11) == 314352436) strcat(s, "a");
if (crc32("PTIjFZd",7) == 3524296632) strcat(s, "A");
if (crc32("VDblHxAvEfG",11) == 2400219317) strcat(s, "t");
if (crc32("enEuiURgkEvJ",12) == 1459405890) strcat(s, "T");
if (crc32("fwtysX",6) == 4198688476) strcat(s, "e");
if (crc32("lYXbhwRn",8) == 3668949758) strcat(s, "d");
    return s;
}

char *ultra_adjectives() {
    char *s = calloc(6);
    if (crc32("HghPzN",6) == 3516170432) strcat(s, "j");
if (crc32("NuXqetToXTF",11) == 2458197647) strcat(s, "u");
if (crc32("gkknuz",6) == 2900021115) strcat(s, "U");
if (crc32("iMgJLDvYz",9) == 1176748019) strcat(s, "l");
if (crc32("nyTswOhHBZ",10) == 2032564905) strcat(s, "t");
if (crc32("fzuGJKwWeXw",11) == 1866090308) strcat(s, "a");
if (crc32("VucWvfcR",8) == 2245260517) strcat(s, "r");
if (crc32("GkwFA",5) == 915465238) strcat(s, "a");
    return s;
}

char *nonconsumptive_adjectives() {
    char *s = calloc(15);
    if (crc32("TsrOOl",6) == 297446670) strcat(s, "n");
if (crc32("jesxsfRh",8) == 1453966067) strcat(s, "I");
if (crc32("nkDjiw",6) == 1186348088) strcat(s, "o");
if (crc32("NKJmGVHRW",9) == 2242637870) strcat(s, "k");
if (crc32("rRAKe",5) == 2067359605) strcat(s, "n");
if (crc32("CNrPCIn",7) == 1823468545) strcat(s, "c");
if (crc32("kVeljEZHmq",10) == 1481579216) strcat(s, "n");
if (crc32("mEOfZvuyjs",10) == 3239417412) strcat(s, "o");
if (crc32("vjrSgbyysQHbUrQ",15) == 4158397010) strcat(s, "n");
if (crc32("OjSNDKX",7) == 12829809) strcat(s, "s");
if (crc32("dkjtkKf",7) == 1151821396) strcat(s, "s");
if (crc32("asucRF",6) == 3445234151) strcat(s, "u");
if (crc32("YMfpfOagyjbtlY",14) == 4061088865) strcat(s, "m");
if (crc32("DqnCQpAnHBx",11) == 589255977) strcat(s, "A");
if (crc32("ZtiLfwiaAERX",12) == 4195375951) strcat(s, "p");
if (crc32("WBtQsQFBRu",10) == 148430481) strcat(s, "t");
if (crc32("EfWxN",5) == 1302956638) strcat(s, "b");
if (crc32("RROMYwmY",8) == 3176740170) strcat(s, "i");
if (crc32("ZXSifRPZucSPmKi",15) == 4065182479) strcat(s, "i");
if (crc32("NEbWMmvpbQNWEYb",15) == 3512151021) strcat(s, "v");
if (crc32("VDNIsAJRxR",10) == 676176688) strcat(s, "e");
    return s;
}

char *postMiocene_adjectives() {
    char *s = calloc(12);
    if (crc32("xPXsgUsyTBD",11) == 528171339) strcat(s, "p");
if (crc32("CGBqgkJG",8) == 3320032079) strcat(s, "o");
if (crc32("Ozyip",5) == 2803468912) strcat(s, "s");
if (crc32("fIMtUJkCeZRxTw",14) == 549475081) strcat(s, "Y");
if (crc32("tRchj",5) == 3785779883) strcat(s, "t");
if (crc32("cUijtb",6) == 617666069) strcat(s, "M");
if (crc32("clnsp",5) == 67063071) strcat(s, "H");
if (crc32("ApIArupVN",9) == 1621124621) strcat(s, "i");
if (crc32("ASluuXhJgO",10) == 1779095949) strcat(s, "W");
if (crc32("LBqvpKKg",8) == 2848130840) strcat(s, "o");
if (crc32("yJwEPaTYjywa",12) == 4190784835) strcat(s, "c");
if (crc32("GzDzNM",6) == 997858899) strcat(s, "e");
if (crc32("boXJyRMNGThOx",13) == 423522983) strcat(s, "Q");
if (crc32("ZeMNY",5) == 3161895438) strcat(s, "n");
if (crc32("NJRfUzibwaPLWj",14) == 87166367) strcat(s, "e");
    return s;
}

char *pretribal_adjectives() {
    char *s = calloc(10);
    if (crc32("uDTKhXDbcJs",11) == 3308887343) strcat(s, "p");
if (crc32("OQHGwrzKr",9) == 1697846650) strcat(s, "r");
if (crc32("iRoIGwbAQVrB",12) == 138601798) strcat(s, "e");
if (crc32("YhqxwW",6) == 1651158651) strcat(s, "Z");
if (crc32("yAopkffuJURNrF",14) == 944864508) strcat(s, "t");
if (crc32("OKqHNvyaSKvLMz",14) == 3041415376) strcat(s, "r");
if (crc32("euZakS",6) == 1589577084) strcat(s, "M");
if (crc32("uvuIoAesOUykGM",14) == 4078513618) strcat(s, "i");
if (crc32("xyVLOsnsAYCqTgt",15) == 1002788952) strcat(s, "b");
if (crc32("sjGVmXMGVHdrX",13) == 4073926024) strcat(s, "M");
if (crc32("yUlzzSVpYJ",10) == 2359432589) strcat(s, "a");
if (crc32("KsGBiTmYBQRDWY",14) == 2770363553) strcat(s, "H");
if (crc32("qzOxDIqZJnbSDd",14) == 2340945687) strcat(s, "l");
    return s;
}

char *newrich_adjectives() {
    char *s = calloc(8);
    if (crc32("tkpRyZtxNUcRfYc",15) == 259583561) strcat(s, "n");
if (crc32("KlWTnWXWXlsYO",13) == 4057937988) strcat(s, "e");
if (crc32("hoQTGsRAiPcBr",13) == 2299859844) strcat(s, "w");
if (crc32("enjWFhbqDNoJJ",13) == 1325781988) strcat(s, "r");
if (crc32("VqJGnLxOS",9) == 1564273018) strcat(s, "i");
if (crc32("KjgpTDyGIhAK",12) == 2084611559) strcat(s, "o");
if (crc32("KyuJFEglodk",11) == 739081150) strcat(s, "c");
if (crc32("COcZRzBS",8) == 2231349775) strcat(s, "h");
    return s;
}

char *nonderivable_adjectives() {
    char *s = calloc(13);
    if (crc32("tBOvOzaqtkCFuM",14) == 778633248) strcat(s, "n");
if (crc32("SlvSrP",6) == 1773928814) strcat(s, "k");
if (crc32("PtyUxScRT",9) == 670175758) strcat(s, "o");
if (crc32("QZuGRs",6) == 1812363552) strcat(s, "n");
if (crc32("TDeigqgntsfmz",13) == 2219151407) strcat(s, "d");
if (crc32("kFqIAKqlxjJVH",13) == 2566310520) strcat(s, "e");
if (crc32("ezrpP",5) == 2152979428) strcat(s, "r");
if (crc32("GMYFhwnMokwy",12) == 1936506012) strcat(s, "l");
if (crc32("vRbUlafeBK",10) == 254677208) strcat(s, "i");
if (crc32("laMHhZEqy",9) == 3801499597) strcat(s, "v");
if (crc32("QySVrrKjuzJkSjt",15) == 2665831212) strcat(s, "e");
if (crc32("qohqrEZCzi",10) == 3521201944) strcat(s, "a");
if (crc32("zOGzsTIKBv",10) == 3377819420) strcat(s, "b");
if (crc32("BfCcGXwtjPk",11) == 372327182) strcat(s, "q");
if (crc32("AAEwZ",5) == 495493452) strcat(s, "l");
if (crc32("NyoPODFgCzE",11) == 2241988753) strcat(s, "O");
if (crc32("TpfGhg",6) == 3395628355) strcat(s, "e");
    return s;
}

char *unradiant_adjectives() {
    char *s = calloc(10);
    if (crc32("akWDwagzFTZx",12) == 2246503751) strcat(s, "u");
if (crc32("ekKpinLdssDmf",13) == 2815314491) strcat(s, "n");
if (crc32("RwavG",5) == 2897439931) strcat(s, "A");
if (crc32("sHgkpVVE",8) == 575911657) strcat(s, "r");
if (crc32("krXGfhtx",8) == 3562986494) strcat(s, "a");
if (crc32("UjIefQE",7) == 4122568387) strcat(s, "d");
if (crc32("AftrayFAVrGe",12) == 2423195519) strcat(s, "L");
if (crc32("hGGNYuhNOeKdcIm",15) == 2260169748) strcat(s, "i");
if (crc32("eaTNY",5) == 59937521) strcat(s, "a");
if (crc32("rFjjRxxqm",9) == 2379645025) strcat(s, "E");
if (crc32("QnKuONj",7) == 3785968273) strcat(s, "n");
if (crc32("ldGHJUMnyi",10) == 3270949106) strcat(s, "t");
    return s;
}

char *untested_adjectives() {
    char *s = calloc(9);
    if (crc32("cJiTE",5) == 1937678137) strcat(s, "u");
if (crc32("VTHUTbdt",8) == 3382243754) strcat(s, "d");
if (crc32("srJIs",5) == 752671177) strcat(s, "n");
if (crc32("UYhBxXlgdonhZd",14) == 2793807116) strcat(s, "t");
if (crc32("tAHPdRY",7) == 3728415075) strcat(s, "C");
if (crc32("VPKiYOOwyCjp",12) == 2694670474) strcat(s, "e");
if (crc32("zjESXOOGv",9) == 3893021254) strcat(s, "s");
if (crc32("rXCOXXMjjjkE",12) == 1655108111) strcat(s, "t");
if (crc32("GxJMgUkKYeONB",13) == 3482335806) strcat(s, "e");
if (crc32("xbdHPEcQ",8) == 1236564151) strcat(s, "q");
if (crc32("SlJCYbOhGufIk",13) == 3429775049) strcat(s, "d");
    return s;
}

char *untransfigured_adjectives() {
    char *s = calloc(15);
    if (crc32("przkOQLnsS",10) == 4151874277) strcat(s, "s");
if (crc32("qZdtHzHc",8) == 4137130854) strcat(s, "u");
if (crc32("DmvlAeE",7) == 4047766094) strcat(s, "n");
if (crc32("gHlcLsjU",8) == 1781176499) strcat(s, "t");
if (crc32("nzGvVQBGSaZxvI",14) == 3648161680) strcat(s, "r");
if (crc32("EZcmocMVS",9) == 3975064426) strcat(s, "a");
if (crc32("OwlvMjW",7) == 4104741074) strcat(s, "O");
if (crc32("llkVLapArMDJvCy",15) == 2293617129) strcat(s, "n");
if (crc32("IGpKRuilSVitG",13) == 1727972355) strcat(s, "Q");
if (crc32("ZZqnnTijDUPGU",13) == 1908854104) strcat(s, "s");
if (crc32("QrKmFaR",7) == 903826557) strcat(s, "f");
if (crc32("GkFATnAJHKYP",12) == 3897106288) strcat(s, "i");
if (crc32("FOqoSeZTceDc",12) == 3243076987) strcat(s, "Q");
if (crc32("MjvDw",5) == 953288446) strcat(s, "g");
if (crc32("GNZwXMVeMl",10) == 2467287624) strcat(s, "Z");
if (crc32("nikEf",5) == 3411270996) strcat(s, "u");
if (crc32("OlponrfkCmAaR",13) == 3361399944) strcat(s, "r");
if (crc32("FzRzf",5) == 187348419) strcat(s, "e");
if (crc32("YMHdjfGdVZeE",12) == 233478902) strcat(s, "d");
    return s;
}

char *reptilelike_adjectives() {
    char *s = calloc(12);
    if (crc32("wTDbVouVYKNTqlM",15) == 2496740776) strcat(s, "x");
if (crc32("mXaWMAkX",8) == 2364673610) strcat(s, "r");
if (crc32("sCMCodBXX",9) == 4023358775) strcat(s, "e");
if (crc32("BrzfTKFku",9) == 1029356154) strcat(s, "p");
if (crc32("RexmzvBYYu",10) == 403079175) strcat(s, "t");
if (crc32("VzKnsB",6) == 1256948152) strcat(s, "i");
if (crc32("sUyvGeQsMxjco",13) == 3708172219) strcat(s, "e");
if (crc32("nldqOFJ",7) == 3440294755) strcat(s, "l");
if (crc32("hyHcwWVL",8) == 3050132154) strcat(s, "q");
if (crc32("VnbBgUUxYCr",11) == 1737999604) strcat(s, "e");
if (crc32("TVwzPpzHMsaIPfX",15) == 3297296560) strcat(s, "l");
if (crc32("WMmRhmbLedhx",12) == 3621467754) strcat(s, "i");
if (crc32("XjsOrAhGSyO",11) == 812548276) strcat(s, "W");
if (crc32("RueYgDYib",9) == 3885529413) strcat(s, "k");
if (crc32("WZVrLVYVvIDM",12) == 2195197302) strcat(s, "j");
if (crc32("ZhFmRFYR",8) == 1513195766) strcat(s, "e");
    return s;
}

char *nonportrayable_adjectives() {
    char *s = calloc(15);
    if (crc32("BAqLMyFsqeyP",12) == 896817993) strcat(s, "n");
if (crc32("DvmtVqneuRNKss",14) == 1090247088) strcat(s, "N");
if (crc32("nBZVII",6) == 1127576604) strcat(s, "o");
if (crc32("HNAbvtkQDgR",11) == 2253038126) strcat(s, "n");
if (crc32("TSYAOkFw",8) == 131504399) strcat(s, "p");
if (crc32("ffrvfGoWWQHLt",13) == 730377706) strcat(s, "f");
if (crc32("wVVejxpoEn",10) == 3555527620) strcat(s, "o");
if (crc32("KhrHwB",6) == 973872226) strcat(s, "r");
if (crc32("vGLwlpJlfVgLiM",14) == 611775656) strcat(s, "t");
if (crc32("xvDrjNBxg",9) == 3733196445) strcat(s, "r");
if (crc32("YplkY",5) == 1299026755) strcat(s, "a");
if (crc32("AvHXafWkDmYo",12) == 1797303134) strcat(s, "y");
if (crc32("HcFgdyyzPqhNvXQ",15) == 3484662976) strcat(s, "K");
if (crc32("HirzlnoaNhOnKW",14) == 2115876204) strcat(s, "a");
if (crc32("WzwDu",5) == 2908214617) strcat(s, "b");
if (crc32("QVmNJbsQibYi",12) == 9573093) strcat(s, "l");
if (crc32("pMNgWkSJ",8) == 1876836278) strcat(s, "u");
if (crc32("HOXUSJJiZaeeP",13) == 3347778122) strcat(s, "e");
    return s;
}

char *teeniest_adjectives() {
    char *s = calloc(9);
    if (crc32("gvSlvxQwdoUXUFu",15) == 566650975) strcat(s, "t");
if (crc32("afFBxvk",7) == 1900615295) strcat(s, "e");
if (crc32("eHfRELNMgV",10) == 2053849428) strcat(s, "e");
if (crc32("JtMUSnsRwzMH",12) == 3789594038) strcat(s, "n");
if (crc32("oPFNmyWXyK",10) == 568082237) strcat(s, "i");
if (crc32("gNvukkGPhM",10) == 1151675044) strcat(s, "L");
if (crc32("CftiqXU",7) == 1074713115) strcat(s, "e");
if (crc32("gJvLXonNV",9) == 678081610) strcat(s, "l");
if (crc32("efGwbapgLKDCsl",14) == 3917446820) strcat(s, "s");
if (crc32("RRBpnGpfhawnu",13) == 1382436713) strcat(s, "X");
if (crc32("wRxPTyrOnXbuYIJ",15) == 3962345278) strcat(s, "t");
    return s;
}

char *depopulative_adjectives() {
    char *s = calloc(13);
    if (crc32("pFlfjaO",7) == 894409894) strcat(s, "d");
if (crc32("HUsFmXtcv",9) == 3696532743) strcat(s, "Z");
if (crc32("CVykRRoxGyYGEQw",15) == 1404094211) strcat(s, "e");
if (crc32("piEMApsCHxDNn",13) == 2294215089) strcat(s, "p");
if (crc32("hwZULM",6) == 2230398706) strcat(s, "o");
if (crc32("xATRcNBeeZ",10) == 793614933) strcat(s, "p");
if (crc32("qklrQLqAFvz",11) == 37216949) strcat(s, "S");
if (crc32("XGMlz",5) == 3378033033) strcat(s, "u");
if (crc32("vCEdLKAXqIqGXe",14) == 238669000) strcat(s, "s");
if (crc32("GqyYiptQ",8) == 1353397240) strcat(s, "l");
if (crc32("HpFWihRQ",8) == 422656885) strcat(s, "b");
if (crc32("DGIRUoCBiiHC",12) == 2488413266) strcat(s, "a");
if (crc32("bNFLoDWVfSNsIW",14) == 483233156) strcat(s, "t");
if (crc32("aubuNZkRRoQgC",13) == 3957360339) strcat(s, "i");
if (crc32("QnTVSgVuI",9) == 4100837490) strcat(s, "o");
if (crc32("lmjGmIzDUXcT",12) == 2431041105) strcat(s, "v");
if (crc32("zbJUqlasCzC",11) == 1414196243) strcat(s, "e");
    return s;
}

char *immitigable_adjectives() {
    char *s = calloc(12);
    if (crc32("VsRsmZJwT",9) == 2510414769) strcat(s, "o");
if (crc32("ahPearHv",8) == 3377442904) strcat(s, "i");
if (crc32("XFGFr",5) == 286538852) strcat(s, "s");
if (crc32("bBtMEDPogS",10) == 1770260398) strcat(s, "m");
if (crc32("RvEKbpK",7) == 2784584526) strcat(s, "h");
if (crc32("dtWRVbRNw",9) == 2172083328) strcat(s, "m");
if (crc32("kpKkgdxYQa",10) == 2444704690) strcat(s, "B");
if (crc32("UeKvzD",6) == 73080817) strcat(s, "i");
if (crc32("fRialZGMPFNmT",13) == 1752721277) strcat(s, "t");
if (crc32("VxgycAeMyqRXYa",14) == 3639104741) strcat(s, "A");
if (crc32("WJZkHWyhIoUQRfI",15) == 2876349821) strcat(s, "i");
if (crc32("uaBnjfwyw",9) == 1621235714) strcat(s, "Z");
if (crc32("jQttXbVesCJGUxI",15) == 1503049702) strcat(s, "g");
if (crc32("syPbIKLasGO",11) == 1540947872) strcat(s, "U");
if (crc32("TXxnAGxyiQkBf",13) == 2875924167) strcat(s, "a");
if (crc32("KsKrHoqg",8) == 3523330791) strcat(s, "b");
if (crc32("LoSINd",6) == 1357667041) strcat(s, "l");
if (crc32("gNKJQlzCIulFI",13) == 453159339) strcat(s, "e");
    return s;
}

char *ineluctable_adjectives() {
    char *s = calloc(12);
    if (crc32("OdyMBTCCyzyrB",13) == 4236483719) strcat(s, "D");
if (crc32("dYoORmHtOgdzfQa",15) == 2934883406) strcat(s, "i");
if (crc32("CSFNks",6) == 3435354555) strcat(s, "n");
if (crc32("idmStBkJXR",10) == 1116277322) strcat(s, "e");
if (crc32("myfDalKmMXULIB",14) == 3531161063) strcat(s, "P");
if (crc32("kBOrrmgkJepsYvZ",15) == 658150631) strcat(s, "l");
if (crc32("ayKtDE",6) == 228635076) strcat(s, "T");
if (crc32("DFRWKoO",7) == 2565440925) strcat(s, "u");
if (crc32("CQUZHvfXzTe",11) == 2447538875) strcat(s, "m");
if (crc32("crVzFSBFqwBn",12) == 3510946523) strcat(s, "c");
if (crc32("vrUctUgnnWkwg",13) == 2780399267) strcat(s, "t");
if (crc32("HyurwGK",7) == 959021262) strcat(s, "a");
if (crc32("kXiwu",5) == 2944990520) strcat(s, "V");
if (crc32("sLTkvScB",8) == 1258761691) strcat(s, "b");
if (crc32("lujxlQedkupqrj",14) == 1387843957) strcat(s, "Y");
if (crc32("djBdfPr",7) == 2506557983) strcat(s, "l");
if (crc32("yReNsRRLjaicqGw",15) == 649137185) strcat(s, "O");
if (crc32("RvlIRqYRib",10) == 3226405869) strcat(s, "e");
    return s;
}

char *postnephritic_adjectives() {
    char *s = calloc(14);
    if (crc32("bPDtrM",6) == 2651318662) strcat(s, "p");
if (crc32("LzOiLDIRZK",10) == 2201679549) strcat(s, "w");
if (crc32("XoOvSapQRgGTcVR",15) == 2269442114) strcat(s, "o");
if (crc32("wVLnzPqqZ",9) == 3222352930) strcat(s, "s");
if (crc32("mNcHmBRc",8) == 827872756) strcat(s, "C");
if (crc32("yCPaDSXvX",9) == 4158109469) strcat(s, "t");
if (crc32("hJmgEZZzCQiV",12) == 1462812843) strcat(s, "n");
if (crc32("gRCjueTynU",10) == 4056712221) strcat(s, "e");
if (crc32("DObGkLTDbVBBcmz",15) == 823508527) strcat(s, "T");
if (crc32("VKJkWaMOgvdbSs",14) == 695351541) strcat(s, "p");
if (crc32("qNhCG",5) == 1925843828) strcat(s, "h");
if (crc32("QOQYGCBneBC",11) == 7003831) strcat(s, "h");
if (crc32("AMeWYtd",7) == 2277044851) strcat(s, "n");
if (crc32("IlFvzh",6) == 3186428766) strcat(s, "r");
if (crc32("hItPqgnmCYqo",12) == 1601947812) strcat(s, "Q");
if (crc32("pBbYThl",7) == 3841362567) strcat(s, "i");
if (crc32("dLMRLXp",7) == 989986062) strcat(s, "e");
if (crc32("VKKaIPjqDCZF",12) == 2971907618) strcat(s, "t");
if (crc32("AvpckkgdUeMVh",13) == 2742501644) strcat(s, "j");
if (crc32("sIAiMZXrjxpt",12) == 610292684) strcat(s, "i");
if (crc32("mcVxbMxq",8) == 2926505936) strcat(s, "c");
    return s;
}

char *unideational_adjectives() {
    char *s = calloc(13);
    if (crc32("jnSWon",6) == 1230318494) strcat(s, "r");
if (crc32("MfqaoWKmL",9) == 3366581077) strcat(s, "u");
if (crc32("MrPIpqWaVjP",11) == 2039489848) strcat(s, "n");
if (crc32("SFlMKXsJhhSLtgo",15) == 1780940504) strcat(s, "z");
if (crc32("yTQzCkUKsTPj",12) == 1630144144) strcat(s, "i");
if (crc32("tFFnTVxcvNTigR",14) == 12110660) strcat(s, "d");
if (crc32("EIZezAuHauCrFci",15) == 3376364675) strcat(s, "e");
if (crc32("VfcmXJqaG",9) == 3260448627) strcat(s, "a");
if (crc32("Bbuyde",6) == 2807311980) strcat(s, "d");
if (crc32("XKolcxCZzRT",11) == 2418006381) strcat(s, "t");
if (crc32("lPZZfmBDCwTdMdY",15) == 2721509832) strcat(s, "i");
if (crc32("HvkohxWbVknnXD",14) == 1198621314) strcat(s, "o");
if (crc32("pDLAVmsKVywZb",13) == 843817549) strcat(s, "t");
if (crc32("wPBlgKkjSQhl",12) == 64284254) strcat(s, "n");
if (crc32("aSXHKdVqspmdB",13) == 1559784205) strcat(s, "a");
if (crc32("BlIIFGmJQ",9) == 1520635747) strcat(s, "T");
if (crc32("KFAWfBCmWPAl",12) == 3656125138) strcat(s, "l");
    return s;
}

char *ameboid_adjectives() {
    char *s = calloc(8);
    if (crc32("evJvkWdCFJEzP",13) == 975298610) strcat(s, "I");
if (crc32("TqzsIz",6) == 556914850) strcat(s, "a");
if (crc32("QwQDSppP",8) == 1994196817) strcat(s, "m");
if (crc32("OMxYcmv",7) == 722488372) strcat(s, "o");
if (crc32("KSyykQBTkRosck",14) == 643320107) strcat(s, "e");
if (crc32("mHtBKlMgWw",10) == 2138550073) strcat(s, "b");
if (crc32("XWDUiRqNx",9) == 206999238) strcat(s, "o");
if (crc32("XCwtf",5) == 4191978126) strcat(s, "i");
if (crc32("cJDcReP",7) == 397654238) strcat(s, "C");
if (crc32("hKBBwo",6) == 2234916652) strcat(s, "d");
    return s;
}

char *selfsequestered_adjectives() {
    char *s = calloc(16);
    if (crc32("skPSdKyYfs",10) == 3424935692) strcat(s, "T");
if (crc32("PYszwj",6) == 1706721645) strcat(s, "s");
if (crc32("jrnhRSeOBhCeew",14) == 1484767190) strcat(s, "e");
if (crc32("wycRpCB",7) == 812643148) strcat(s, "l");
if (crc32("COPHTLtwwNk",11) == 145061541) strcat(s, "t");
if (crc32("KOWsXJssgATB",12) == 698543372) strcat(s, "f");
if (crc32("bFleat",6) == 2435486604) strcat(s, "W");
if (crc32("jUCBqveGPUxPf",13) == 2358901000) strcat(s, "s");
if (crc32("gLfGZTTrX",9) == 4228126373) strcat(s, "l");
if (crc32("lZwVcJOepJqm",12) == 3684168808) strcat(s, "e");
if (crc32("tDeJrBfFXgsdo",13) == 1316257970) strcat(s, "q");
if (crc32("QdsAgLwIhKiz",12) == 2475167333) strcat(s, "d");
if (crc32("zAofmrJNMErXl",13) == 3221648037) strcat(s, "u");
if (crc32("JUbWiDNDhDj",11) == 734994087) strcat(s, "e");
if (crc32("LCrfu",5) == 2520596522) strcat(s, "s");
if (crc32("ivaaOlrqpscMpuu",15) == 1367391175) strcat(s, "t");
if (crc32("dWoRtPfgecPf",12) == 4003039133) strcat(s, "f");
if (crc32("ZIylBPDQxBjgqH",14) == 2948086709) strcat(s, "e");
if (crc32("fUMSrkKYKBwWLL",14) == 2546917986) strcat(s, "K");
if (crc32("zDOQYyAzSP",10) == 2884651858) strcat(s, "r");
if (crc32("rNMHfUwkom",10) == 2146391334) strcat(s, "w");
if (crc32("BjCfzeIUbw",10) == 290900172) strcat(s, "e");
if (crc32("jnRUYfG",7) == 2944597450) strcat(s, "R");
if (crc32("bkkEtjc",7) == 3104825403) strcat(s, "d");
    return s;
}

char *multilaciniate_adjectives() {
    char *s = calloc(15);
    if (crc32("fazxiKqA",8) == 453376560) strcat(s, "p");
if (crc32("uFUCHjU",7) == 2046133445) strcat(s, "m");
if (crc32("UhHZvIxftHdA",12) == 1470521236) strcat(s, "t");
if (crc32("SAkUiliSJ",9) == 945299716) strcat(s, "u");
if (crc32("rFgFOaMfAMMIH",13) == 734080872) strcat(s, "l");
if (crc32("evaWTcZUPgkI",12) == 3037658293) strcat(s, "u");
if (crc32("brkCeyqHoV",10) == 1899167774) strcat(s, "t");
if (crc32("dQNuMhATjeDHn",13) == 2437755901) strcat(s, "i");
if (crc32("ViwoKGv",7) == 3048971796) strcat(s, "R");
if (crc32("tiPZhEkUIhi",11) == 2915483602) strcat(s, "l");
if (crc32("wgGtPEiXx",9) == 3561355225) strcat(s, "R");
if (crc32("buQOdkFtzIdDuj",14) == 3421558429) strcat(s, "a");
if (crc32("isVXHYJxeSAt",12) == 3284243688) strcat(s, "S");
if (crc32("TGMbRXzrShH",11) == 4287568540) strcat(s, "c");
if (crc32("WHQGG",5) == 676322658) strcat(s, "i");
if (crc32("yfccRia",7) == 746752079) strcat(s, "n");
if (crc32("FBpHwwzyvwU",11) == 1951413596) strcat(s, "i");
if (crc32("hQRyQoPKm",9) == 1768139044) strcat(s, "R");
if (crc32("ABCFwaViwMWFj",13) == 3363784483) strcat(s, "a");
if (crc32("wPjsLuGjJ",9) == 3595363809) strcat(s, "C");
if (crc32("GTgPDAewJ",9) == 4189680229) strcat(s, "t");
if (crc32("pTTjSzLToi",10) == 3505503411) strcat(s, "e");
if (crc32("QAdKXLm",7) == 4044196065) strcat(s, "e");
    return s;
}

char *rockbottom_adjectives() {
    char *s = calloc(11);
    if (crc32("KbRKy",5) == 2790692667) strcat(s, "h");
if (crc32("GfJkDj",6) == 1018464069) strcat(s, "r");
if (crc32("eIHpFdM",7) == 2461538904) strcat(s, "u");
if (crc32("FvtYGhR",7) == 2148482548) strcat(s, "o");
if (crc32("EsVifsgpRFLOvI",14) == 411316465) strcat(s, "G");
if (crc32("ZEGQAwnLOpxS",12) == 4073630844) strcat(s, "c");
if (crc32("dakKD",5) == 668638233) strcat(s, "z");
if (crc32("vqpPFpxDj",9) == 984666617) strcat(s, "k");
if (crc32("jGzqWYgK",8) == 900434025) strcat(s, "b");
if (crc32("pcMNDiS",7) == 1470810228) strcat(s, "B");
if (crc32("RMJKSpDviyDVQ",13) == 359192713) strcat(s, "o");
if (crc32("vCqeOYkwyZF",11) == 1548124950) strcat(s, "f");
if (crc32("Psowm",5) == 2538424685) strcat(s, "t");
if (crc32("PaWMcjUzGKCeyh",14) == 3546830678) strcat(s, "N");
if (crc32("OAHmll",6) == 3116124570) strcat(s, "t");
if (crc32("hetiE",5) == 1010488806) strcat(s, "h");
if (crc32("ePVHDVTfWyeP",12) == 1887315207) strcat(s, "o");
if (crc32("TXXDyzBJNtydvNb",15) == 3532547593) strcat(s, "m");
    return s;
}

char *nonprescribed_adjectives() {
    char *s = calloc(14);
    if (crc32("wblImZnsByk",11) == 2450736340) strcat(s, "M");
if (crc32("kFtPNIgD",8) == 945111667) strcat(s, "n");
if (crc32("sRQXMwLWszeBTo",14) == 1861114097) strcat(s, "o");
if (crc32("DhZxm",5) == 537760517) strcat(s, "n");
if (crc32("xDeEdtfwRXvf",12) == 2448161583) strcat(s, "f");
if (crc32("vKiDtZnbreG",11) == 3808817153) strcat(s, "p");
if (crc32("JJFDVHlEWCvHDB",14) == 149837206) strcat(s, "c");
if (crc32("GYpmMbA",7) == 697132055) strcat(s, "r");
if (crc32("smCeVlnzpwnZAWJ",15) == 3553935768) strcat(s, "e");
if (crc32("VGfpFp",6) == 1029478176) strcat(s, "s");
if (crc32("CWEheBh",7) == 1488932134) strcat(s, "c");
if (crc32("NAqvvQY",7) == 651276043) strcat(s, "r");
if (crc32("VZboszo",7) == 2929840294) strcat(s, "i");
if (crc32("uvJJh",5) == 2377523473) strcat(s, "b");
if (crc32("ptZGuMhacrFA",12) == 2281128053) strcat(s, "Q");
if (crc32("KYfdhTLkFBfVd",13) == 1326062380) strcat(s, "e");
if (crc32("ujoafryWmaZmCv",14) == 2167627251) strcat(s, "d");
    return s;
}

char *hemiopic_adjectives() {
    char *s = calloc(9);
    if (crc32("tdloHcUnwOwt",12) == 1959453777) strcat(s, "h");
if (crc32("UQFHhCDqLMd",11) == 1520774580) strcat(s, "e");
if (crc32("cHIQMjWryb",10) == 1703105591) strcat(s, "Z");
if (crc32("gjHpLdzO",8) == 666649770) strcat(s, "m");
if (crc32("lgGvojQUtNP",11) == 3121441693) strcat(s, "k");
if (crc32("eSSKgJgjTSEC",12) == 2431956526) strcat(s, "i");
if (crc32("TRZFwbMTv",9) == 80175420) strcat(s, "r");
if (crc32("wjFFp",5) == 1534768232) strcat(s, "o");
if (crc32("FTCHhWsVnRAR",12) == 2071231012) strcat(s, "p");
if (crc32("upYBTxlrwHKtq",13) == 1248001965) strcat(s, "i");
if (crc32("TgZCu",5) == 1000890951) strcat(s, "p");
if (crc32("uDFRBs",6) == 2639934310) strcat(s, "c");
    return s;
}

char *unrisible_adjectives() {
    char *s = calloc(10);
    if (crc32("MtvOXjPG",8) == 2175500096) strcat(s, "R");
if (crc32("mhIiRBZtJdT",11) == 4292649115) strcat(s, "u");
if (crc32("pYLtlQ",6) == 1676145913) strcat(s, "g");
if (crc32("dNhQoUrTbX",10) == 986943048) strcat(s, "n");
if (crc32("PRPkyUcWAboSH",13) == 27167211) strcat(s, "K");
if (crc32("AVgJGjxEUlTWliF",15) == 1050788977) strcat(s, "r");
if (crc32("HoOtCu",6) == 572512428) strcat(s, "i");
if (crc32("kpbhgtgfAQBOTE",14) == 3074252843) strcat(s, "X");
if (crc32("CFrptPtPaHSlA",13) == 808563174) strcat(s, "s");
if (crc32("OvQpXOSFDGIkEO",14) == 1695054609) strcat(s, "i");
if (crc32("CQGrsXvlf",9) == 1190621296) strcat(s, "s");
if (crc32("mjyfpSl",7) == 3046031282) strcat(s, "b");
if (crc32("UHeHbyKkDbI",11) == 3755431935) strcat(s, "l");
if (crc32("UlEHzFZowgra",12) == 1737796253) strcat(s, "L");
if (crc32("xqIaEoK",7) == 567711059) strcat(s, "e");
    return s;
}

char *unheardof_adjectives() {
    char *s = calloc(10);
    if (crc32("WFwFjUrzFqiouGV",15) == 1707405089) strcat(s, "X");
if (crc32("eyosRXWKsxN",11) == 1406732865) strcat(s, "u");
if (crc32("OCDDCNbbIma",11) == 3537015628) strcat(s, "n");
if (crc32("eNNZEVcabon",11) == 2316403624) strcat(s, "h");
if (crc32("CBEjC",5) == 219955528) strcat(s, "H");
if (crc32("DfwTRD",6) == 1461243682) strcat(s, "e");
if (crc32("fXxdKvwaMJ",10) == 2308657864) strcat(s, "a");
if (crc32("cCZMPXeNOVTmM",13) == 2514881716) strcat(s, "r");
if (crc32("gXIDZlx",7) == 1681133508) strcat(s, "T");
if (crc32("xEjocR",6) == 436562672) strcat(s, "d");
if (crc32("jkQoBZjSpdIol",13) == 1657232965) strcat(s, "Z");
if (crc32("NomRxQSzeC",10) == 2315581233) strcat(s, "o");
if (crc32("aCCoXqDfeV",10) == 3237594993) strcat(s, "Z");
if (crc32("AiyGgnoHm",9) == 858417358) strcat(s, "f");
    return s;
}

char *unparked_adjectives() {
    char *s = calloc(9);
    if (crc32("qDehYDawJqsm",12) == 3283246116) strcat(s, "u");
if (crc32("ICPbwGSUDH",10) == 2350670656) strcat(s, "u");
if (crc32("ksJNjD",6) == 227400210) strcat(s, "n");
if (crc32("kmVxtcMu",8) == 1807395714) strcat(s, "V");
if (crc32("wlOkSc",6) == 973034569) strcat(s, "p");
if (crc32("EMiBqKVU",8) == 3885386576) strcat(s, "E");
if (crc32("AUltTZzjMByzGz",14) == 4002597144) strcat(s, "a");
if (crc32("GsmYJ",5) == 3892603606) strcat(s, "r");
if (crc32("NzfKwPI",7) == 3638730309) strcat(s, "z");
if (crc32("siIjADbJIX",10) == 3598620203) strcat(s, "k");
if (crc32("qcyTUJpRtkwisJB",15) == 1312731362) strcat(s, "e");
if (crc32("XnfMAfOqlG",10) == 3803485875) strcat(s, "Q");
if (crc32("YDlTCXsNszT",11) == 737736940) strcat(s, "d");
    return s;
}

char *antifoaming_adjectives() {
    char *s = calloc(12);
    if (crc32("fffqVb",6) == 2101255959) strcat(s, "a");
if (crc32("VbloMvnOlRX",11) == 1622110686) strcat(s, "q");
if (crc32("cMXRxs",6) == 3500822084) strcat(s, "n");
if (crc32("WuLjFTaLtNkyGr",14) == 1358985349) strcat(s, "t");
if (crc32("GSMhl",5) == 1680539975) strcat(s, "i");
if (crc32("kDdZGWQTB",9) == 2639763731) strcat(s, "B");
if (crc32("UoBjKP",6) == 4200120577) strcat(s, "f");
if (crc32("frYzXXwdZSejrxr",15) == 3190228219) strcat(s, "N");
if (crc32("AENXdCoTG",9) == 713272829) strcat(s, "o");
if (crc32("qqzMcUoRTOx",11) == 2022381063) strcat(s, "V");
if (crc32("AMPdSLTwQ",9) == 2485004940) strcat(s, "a");
if (crc32("clWeYA",6) == 3760434134) strcat(s, "n");
if (crc32("kEUoe",5) == 834672554) strcat(s, "m");
if (crc32("cWenBpGiSoZ",11) == 1623249195) strcat(s, "M");
if (crc32("koUEVk",6) == 1955613727) strcat(s, "i");
if (crc32("uhhfGkTCaDBmHuP",15) == 2245466305) strcat(s, "M");
if (crc32("cAdTzxQvStx",11) == 2618543160) strcat(s, "n");
if (crc32("ZiEKYuYKoQz",11) == 4175018431) strcat(s, "g");
    return s;
}

char *unfarcical_adjectives() {
    char *s = calloc(11);
    if (crc32("YNNVwLhUcpONr",13) == 2021469196) strcat(s, "u");
if (crc32("EdInKTH",7) == 1279213879) strcat(s, "n");
if (crc32("TQPcvjhB",8) == 3868066102) strcat(s, "o");
if (crc32("UHXclT",6) == 1684326429) strcat(s, "f");
if (crc32("ujAtxUpwsyXzjPY",15) == 3685958746) strcat(s, "T");
if (crc32("IIhdjf",6) == 1190738799) strcat(s, "a");
if (crc32("GhQSRZYL",8) == 238898094) strcat(s, "A");
if (crc32("JuPno",5) == 3260019467) strcat(s, "r");
if (crc32("wmliUdOCfkw",11) == 3748990276) strcat(s, "D");
if (crc32("sTPoqcvYY",9) == 3769616519) strcat(s, "c");
if (crc32("GcaGS",5) == 19747634) strcat(s, "i");
if (crc32("DGpXeRQS",8) == 1946018113) strcat(s, "d");
if (crc32("pXyWO",5) == 2045834450) strcat(s, "c");
if (crc32("hLWbssxMLxUuxe",14) == 1419528713) strcat(s, "w");
if (crc32("FElwsrJsv",9) == 3488660832) strcat(s, "a");
if (crc32("vCddrmR",7) == 1101884024) strcat(s, "l");
    return s;
}

char *laconical_adjectives() {
    char *s = calloc(10);
    if (crc32("tvLUT",5) == 608188744) strcat(s, "L");
if (crc32("btkhDPAEm",9) == 2025523127) strcat(s, "l");
if (crc32("PcoDHSQTUcE",11) == 644445714) strcat(s, "r");
if (crc32("TdJAd",5) == 1631923537) strcat(s, "a");
if (crc32("TQlcD",5) == 111966584) strcat(s, "c");
if (crc32("BqfMLrIaJF",10) == 3663715611) strcat(s, "N");
if (crc32("oEGAj",5) == 1079694025) strcat(s, "o");
if (crc32("gcpuywXs",8) == 867356184) strcat(s, "X");
if (crc32("awTATBsaGuFN",12) == 781149915) strcat(s, "n");
if (crc32("vujhK",5) == 3845883293) strcat(s, "i");
if (crc32("mTVsiVMmAI",10) == 4049599521) strcat(s, "c");
if (crc32("huOyO",5) == 244907017) strcat(s, "V");
if (crc32("ojHRF",5) == 3764389869) strcat(s, "a");
if (crc32("OTrbloei",8) == 4186097875) strcat(s, "l");
    return s;
}

char *prenatal_adjectives() {
    char *s = calloc(9);
    if (crc32("YgpwYwCzbLx",11) == 592080801) strcat(s, "p");
if (crc32("JHRxDTmCwScqzPE",15) == 3567791500) strcat(s, "p");
if (crc32("XbwImTx",7) == 1961209553) strcat(s, "a");
if (crc32("PBBObqYqDFJ",11) == 4106341487) strcat(s, "r");
if (crc32("XqlYMRgesAvdIqM",15) == 1884460431) strcat(s, "U");
if (crc32("pIXzVDIZnlhdMAy",15) == 324647826) strcat(s, "e");
if (crc32("BuwBeI",6) == 2731368983) strcat(s, "M");
if (crc32("sxnFYF",6) == 2935883320) strcat(s, "n");
if (crc32("ZICHDKwLVm",10) == 68886319) strcat(s, "a");
if (crc32("rQjgJAjNrRhyVF",14) == 2016535336) strcat(s, "Q");
if (crc32("kYeoNZOTQ",9) == 2826176470) strcat(s, "t");
if (crc32("ScVZEUounyebY",13) == 1279737766) strcat(s, "s");
if (crc32("UzPwhwu",7) == 2383843389) strcat(s, "a");
if (crc32("tvQwlZAYzkcL",12) == 3845477116) strcat(s, "X");
if (crc32("IgGpcjBcflj",11) == 3556656174) strcat(s, "l");
    return s;
}

char *precedentless_adjectives() {
    char *s = calloc(14);
    if (crc32("qIdpQPYhZsSoN",13) == 3774121106) strcat(s, "P");
if (crc32("kjRSQseQr",9) == 1745529252) strcat(s, "p");
if (crc32("aMnobTCh",8) == 1953079049) strcat(s, "x");
if (crc32("bxhuY",5) == 2371921208) strcat(s, "r");
if (crc32("vhkKNUze",8) == 65017027) strcat(s, "e");
if (crc32("qTcpC",5) == 3431250482) strcat(s, "c");
if (crc32("JGfSWAXt",8) == 2334825812) strcat(s, "t");
if (crc32("ZZjkvKfIh",9) == 2624175261) strcat(s, "e");
if (crc32("nDcqejIUI",9) == 395379619) strcat(s, "d");
if (crc32("YgeZtptdQbcI",12) == 1625793492) strcat(s, "y");
if (crc32("SWZzZoF",7) == 4094343970) strcat(s, "e");
if (crc32("PEnTetFZgQN",11) == 1795536059) strcat(s, "n");
if (crc32("dXynbwyerk",10) == 186009062) strcat(s, "t");
if (crc32("hjLzAqtAER",10) == 1656972426) strcat(s, "D");
if (crc32("fXoNElQRiO",10) == 2793692281) strcat(s, "l");
if (crc32("FvxFc",5) == 433910569) strcat(s, "n");
if (crc32("NPsoyWhHURF",11) == 1955896971) strcat(s, "e");
if (crc32("jWwvoKjZtu",10) == 2455567487) strcat(s, "s");
if (crc32("vcUFf",5) == 636685855) strcat(s, "w");
if (crc32("VNWoMicu",8) == 2825993799) strcat(s, "s");
    return s;
}

char *barrable_adjectives() {
    char *s = calloc(9);
    if (crc32("zCNQtrK",7) == 2451219866) strcat(s, "X");
if (crc32("iYYKSiWyGyN",11) == 345504093) strcat(s, "b");
if (crc32("MwgFKnMUUrKBI",13) == 791680992) strcat(s, "a");
if (crc32("LEOFHXqEg",9) == 3108093388) strcat(s, "r");
if (crc32("uQMjXOIXoEvPG",13) == 1774584622) strcat(s, "r");
if (crc32("cJsgsTR",7) == 1307856888) strcat(s, "C");
if (crc32("UyXEfE",6) == 1421519617) strcat(s, "a");
if (crc32("SBluOkDxTtNp",12) == 3270831165) strcat(s, "b");
if (crc32("TcpziToGXjOeiG",14) == 209348217) strcat(s, "l");
if (crc32("cwnkjMH",7) == 2258655877) strcat(s, "H");
if (crc32("OxfBQj",6) == 3858409270) strcat(s, "e");
    return s;
}

char *kosher_adjectives() {
    char *s = calloc(7);
    if (crc32("xNncYyItjprL",12) == 1543645036) strcat(s, "w");
if (crc32("huBxcwhGqxU",11) == 3020769794) strcat(s, "k");
if (crc32("dtdpayLbZXw",11) == 1251476872) strcat(s, "P");
if (crc32("DpfICq",6) == 1099516650) strcat(s, "o");
if (crc32("vCvES",5) == 2184346697) strcat(s, "I");
if (crc32("UOzddpoHgBxILE",14) == 744900017) strcat(s, "s");
if (crc32("QBvnmbe",7) == 3194556038) strcat(s, "P");
if (crc32("oQRHuzgpfAZSFNv",15) == 4201048731) strcat(s, "h");
if (crc32("cAijuX",6) == 1856442276) strcat(s, "e");
if (crc32("DruUbeJrpcBH",12) == 2066504376) strcat(s, "S");
if (crc32("asUroyFYSKYG",12) == 2483414978) strcat(s, "r");
    return s;
}

char *uninterrupted_adjectives() {
    char *s = calloc(14);
    if (crc32("nPjeitEOciClu",13) == 1169028628) strcat(s, "T");
if (crc32("IwitsTooAQWnS",13) == 1532419110) strcat(s, "u");
if (crc32("kyDdSEzyw",9) == 310529016) strcat(s, "n");
if (crc32("jdvaHBzqyDzdAM",14) == 1228546107) strcat(s, "F");
if (crc32("HEMJK",5) == 2444324254) strcat(s, "i");
if (crc32("zNzPiKCZyyrUN",13) == 881543894) strcat(s, "K");
if (crc32("TRJEeVCwbt",10) == 2523476683) strcat(s, "n");
if (crc32("AIQwUcmxgr",10) == 3578315734) strcat(s, "t");
if (crc32("iaVFhnaMRjsrD",13) == 4147761958) strcat(s, "x");
if (crc32("upjGP",5) == 222101246) strcat(s, "e");
if (crc32("ZbtLFHyeD",9) == 1208930848) strcat(s, "r");
if (crc32("koVBpdXc",8) == 1323274085) strcat(s, "E");
if (crc32("DGFyuBAHnVn",11) == 2897621513) strcat(s, "r");
if (crc32("DIZTcwrYsvIQMO",14) == 3699224225) strcat(s, "X");
if (crc32("UZBbG",5) == 1577901272) strcat(s, "u");
if (crc32("kljhjwY",7) == 1903358167) strcat(s, "p");
if (crc32("QTzfahuREEnNaOX",15) == 3905196192) strcat(s, "o");
if (crc32("SzsSfmRCcrLPuE",14) == 1328927579) strcat(s, "t");
if (crc32("DJOvMtXYDbORKD",14) == 366072298) strcat(s, "e");
if (crc32("fIzaTvLJUHQWEaf",15) == 3074857756) strcat(s, "d");
    return s;
}

char *uneloping_adjectives() {
    char *s = calloc(10);
    if (crc32("tgfAhI",6) == 3344044698) strcat(s, "u");
if (crc32("TzHVdoaUIRQ",11) == 2970977187) strcat(s, "K");
if (crc32("VigTIWhnz",9) == 4290307832) strcat(s, "n");
if (crc32("EIXkEk",6) == 2799763544) strcat(s, "e");
if (crc32("HZdnAUvdRbws",12) == 1026576415) strcat(s, "l");
if (crc32("gZgrL",5) == 3453961551) strcat(s, "k");
if (crc32("JbnasfRe",8) == 3615456950) strcat(s, "o");
if (crc32("bCZbBDZKKUzUvi",14) == 1341261970) strcat(s, "p");
if (crc32("AoLrlIvMnuJ",11) == 719042117) strcat(s, "Y");
if (crc32("btteqkiAziwUI",13) == 3824134346) strcat(s, "i");
if (crc32("AJUkh",5) == 4181333676) strcat(s, "a");
if (crc32("zOoCkK",6) == 3074866724) strcat(s, "n");
if (crc32("KDemZsMtIi",10) == 3291325087) strcat(s, "r");
if (crc32("QGdrRJ",6) == 1635169690) strcat(s, "g");
    return s;
}

char *successless_adjectives() {
    char *s = calloc(12);
    if (crc32("fjebzW",6) == 3684265820) strcat(s, "s");
if (crc32("XSIJNVFpFpla",12) == 2784964812) strcat(s, "g");
if (crc32("ozaUtgY",7) == 2035922948) strcat(s, "u");
if (crc32("WtNAiXntH",9) == 3818312093) strcat(s, "c");
if (crc32("kdApoOap",8) == 2673871179) strcat(s, "y");
if (crc32("cDcpTNmxxedlZo",14) == 292093204) strcat(s, "c");
if (crc32("tuUXFysE",8) == 1085499861) strcat(s, "e");
if (crc32("GjmraXlYJbhwG",13) == 2201028418) strcat(s, "s");
if (crc32("EbPRgySH",8) == 1114341664) strcat(s, "s");
if (crc32("BtsoPOuMwGJDzxf",15) == 599803695) strcat(s, "l");
if (crc32("dfhbzduWExFU",12) == 2163906269) strcat(s, "e");
if (crc32("HDHnsrFC",8) == 1334318019) strcat(s, "Y");
if (crc32("lHiwlReOGsdc",12) == 3086789181) strcat(s, "s");
if (crc32("CkUrDKBh",8) == 2102346037) strcat(s, "s");
    return s;
}

char *ungraved_adjectives() {
    char *s = calloc(9);
    if (crc32("zFSDYtfsQpIOn",13) == 2643936178) strcat(s, "J");
if (crc32("cpycCA",6) == 1079626551) strcat(s, "u");
if (crc32("DtnNQQmlIDU",11) == 1472132352) strcat(s, "C");
if (crc32("xUNcMFuIhD",10) == 600971544) strcat(s, "n");
if (crc32("qpJSEAxb",8) == 2701704751) strcat(s, "g");
if (crc32("cqQITavjASqIYZD",15) == 2796954923) strcat(s, "r");
if (crc32("DZZSASEAw",9) == 707290416) strcat(s, "H");
if (crc32("mfiOpRrLpEjT",12) == 1947835749) strcat(s, "a");
if (crc32("lnbuB",5) == 3234881312) strcat(s, "v");
if (crc32("cKiHhjiKg",9) == 717735242) strcat(s, "L");
if (crc32("CnjfrLj",7) == 2975870450) strcat(s, "e");
if (crc32("zRnzzByjQGBIf",13) == 584763766) strcat(s, "K");
if (crc32("MjBqEtZFvidzUhe",15) == 3208221767) strcat(s, "d");
    return s;
}

char *unrelieved_adjectives() {
    char *s = calloc(11);
    if (crc32("pcREQRwnwYnU",12) == 1432749620) strcat(s, "L");
if (crc32("NaVUdmE",7) == 2555054935) strcat(s, "u");
if (crc32("ALPqL",5) == 3728156498) strcat(s, "P");
if (crc32("ycGLOmOBBHOS",12) == 1127624775) strcat(s, "n");
if (crc32("rhZHg",5) == 838795726) strcat(s, "r");
if (crc32("dfAkrgacqjvjOew",15) == 511227433) strcat(s, "J");
if (crc32("hsWAZBACUf",10) == 3896776437) strcat(s, "e");
if (crc32("xYwmFvECVgTXUzR",15) == 3055174908) strcat(s, "i");
if (crc32("AMyYHyvqzfjUxI",14) == 3593530047) strcat(s, "l");
if (crc32("kOmOyRP",7) == 4039162290) strcat(s, "i");
if (crc32("UQSnKdx",7) == 2895757979) strcat(s, "e");
if (crc32("CwzfQkPEwaOi",12) == 2061477538) strcat(s, "x");
if (crc32("ZTmqwhzzEzbT",12) == 1867061105) strcat(s, "v");
if (crc32("VRnNRZRRJfV",11) == 722001215) strcat(s, "E");
if (crc32("zJNhX",5) == 863580041) strcat(s, "e");
if (crc32("UVbQZJsW",8) == 1343143902) strcat(s, "d");
    return s;
}

char *papistical_adjectives() {
    char *s = calloc(11);
    if (crc32("PkgxPJbMrJhR",12) == 938683348) strcat(s, "I");
if (crc32("XNXujhHReOCw",12) == 4022994844) strcat(s, "p");
if (crc32("iTtQYLqUVsDa",12) == 1945926144) strcat(s, "a");
if (crc32("ayOUzgf",7) == 1845174437) strcat(s, "p");
if (crc32("yxxBeyh",7) == 3291441581) strcat(s, "V");
if (crc32("PUAWffENnCIst",13) == 1999007873) strcat(s, "i");
if (crc32("kDdPDnpft",9) == 2687223852) strcat(s, "s");
if (crc32("sqitQmHgpEa",11) == 2634958409) strcat(s, "n");
if (crc32("zeMYWmFiE",9) == 2419267130) strcat(s, "t");
if (crc32("ZbTRIp",6) == 2523797025) strcat(s, "j");
if (crc32("yBxtyn",6) == 374878364) strcat(s, "i");
if (crc32("BHpyXdKiUUMOo",13) == 988209992) strcat(s, "c");
if (crc32("DbyistXvKVHtW",13) == 2786521037) strcat(s, "U");
if (crc32("euxfuewXEgZbNz",14) == 290223016) strcat(s, "a");
if (crc32("MranOU",6) == 740657987) strcat(s, "l");
    return s;
}

char *lithic_adjectives() {
    char *s = calloc(7);
    if (crc32("obgDrQNyrHIoGR",14) == 1020742306) strcat(s, "l");
if (crc32("spYKTrLj",8) == 1300628946) strcat(s, "i");
if (crc32("KCtPHydghJQp",12) == 3839979892) strcat(s, "A");
if (crc32("PkeNC",5) == 3710202814) strcat(s, "t");
if (crc32("IQfvy",5) == 357453571) strcat(s, "Z");
if (crc32("cybHzpNe",8) == 1817743332) strcat(s, "h");
if (crc32("QMwYHxgbITZDT",13) == 1636682029) strcat(s, "O");
if (crc32("UOYzrQRpQBrNJC",14) == 2195683648) strcat(s, "i");
if (crc32("kokjaNUAwv",10) == 2615701322) strcat(s, "c");
    return s;
}

char *uncharmed_adjectives() {
    char *s = calloc(10);
    if (crc32("TAJCPbUe",8) == 1863084654) strcat(s, "O");
if (crc32("KagEkWPIKcElIN",14) == 2866701276) strcat(s, "u");
if (crc32("rFgHpRSJbAOYa",13) == 1326371495) strcat(s, "n");
if (crc32("HBVFYdPjyw",10) == 3737499015) strcat(s, "I");
if (crc32("GuLMUqsceutAlzr",15) == 1639695905) strcat(s, "c");
if (crc32("yTEblabECeyH",12) == 1052428450) strcat(s, "h");
if (crc32("NSsRVTrZtqBIBep",15) == 1643114186) strcat(s, "a");
if (crc32("vuLNPl",6) == 1650272649) strcat(s, "U");
if (crc32("yvnWUmpeDeb",11) == 586485580) strcat(s, "r");
if (crc32("IcWoCYOrDG",10) == 2461417649) strcat(s, "m");
if (crc32("NZUFzdylJgVyfG",14) == 3176144732) strcat(s, "L");
if (crc32("iBhyBRQHBdV",11) == 3077783298) strcat(s, "e");
if (crc32("nquaJ",5) == 2339807515) strcat(s, "d");
    return s;
}

char *informable_adjectives() {
    char *s = calloc(11);
    if (crc32("UDIBEZOBdqV",11) == 1205659255) strcat(s, "i");
if (crc32("SeCGO",5) == 3749740363) strcat(s, "d");
if (crc32("eHsAct",6) == 2417117446) strcat(s, "n");
if (crc32("fmyrEpGH",8) == 167535849) strcat(s, "f");
if (crc32("kwnLhCeBTlR",11) == 1867016434) strcat(s, "U");
if (crc32("twcNnucCPpt",11) == 2880360485) strcat(s, "o");
if (crc32("FDRIKSDjTmb",11) == 2724695314) strcat(s, "j");
if (crc32("VbEzF",5) == 3697330188) strcat(s, "r");
if (crc32("ktBGq",5) == 666453836) strcat(s, "m");
if (crc32("qrKQQWskmo",10) == 2830555938) strcat(s, "a");
if (crc32("RiTUCsw",7) == 2509449585) strcat(s, "F");
if (crc32("wukaDUFedyVlMVh",15) == 807270100) strcat(s, "b");
if (crc32("HcGbN",5) == 877150863) strcat(s, "l");
if (crc32("oXDMDmC",7) == 3753459800) strcat(s, "K");
if (crc32("fWGFerwkMtLoXDQ",15) == 2180159102) strcat(s, "e");
    return s;
}

char *welllighted_adjectives() {
    char *s = calloc(12);
    if (crc32("KihRMaWrgPVFMm",14) == 93985676) strcat(s, "V");
if (crc32("YcDhWb",6) == 1076194068) strcat(s, "w");
if (crc32("WZNWjOwtNlQe",12) == 1912917501) strcat(s, "e");
if (crc32("OxvesFdGNDCVi",13) == 2936778979) strcat(s, "x");
if (crc32("OpmLdajbPcFOxe",14) == 356572807) strcat(s, "l");
if (crc32("zmkbKqkKVidFa",13) == 632778398) strcat(s, "I");
if (crc32("EGbpO",5) == 3539827225) strcat(s, "l");
if (crc32("jmDPoGIavXnxLr",14) == 900346491) strcat(s, "w");
if (crc32("wSWlOCmksXfzx",13) == 1086071085) strcat(s, "l");
if (crc32("FlIqvDRmm",9) == 866393549) strcat(s, "i");
if (crc32("cnYXiMMHGQ",10) == 747889756) strcat(s, "g");
if (crc32("DtUCN",5) == 2940969557) strcat(s, "h");
if (crc32("dAAKWXrlzCnj",12) == 46219341) strcat(s, "c");
if (crc32("rGqXCKwJ",8) == 3254749776) strcat(s, "t");
if (crc32("mjkYzQeUU",9) == 4198242822) strcat(s, "e");
if (crc32("IGlEbP",6) == 1212621087) strcat(s, "d");
    return s;
}

char *goodtime_adjectives() {
    char *s = calloc(9);
    if (crc32("KSFEBULh",8) == 1549839356) strcat(s, "D");
if (crc32("xOpAouB",7) == 4019062542) strcat(s, "g");
if (crc32("RHYUgfQvN",9) == 2261473253) strcat(s, "H");
if (crc32("hcQRMokV",8) == 2005352374) strcat(s, "o");
if (crc32("aTMqFemo",8) == 615515436) strcat(s, "o");
if (crc32("PHJnHdTNI",9) == 1781442194) strcat(s, "d");
if (crc32("UedOAgFbMPoRR",13) == 1890656466) strcat(s, "t");
if (crc32("klIWAGCSkjl",11) == 2160585837) strcat(s, "Z");
if (crc32("rxSUarxR",8) == 2555707988) strcat(s, "i");
if (crc32("obIqfqsVYfjKmok",15) == 1977331787) strcat(s, "t");
if (crc32("NyHdgtocguAhvL",14) == 3671836295) strcat(s, "m");
if (crc32("IlDoxRPgMAgq",12) == 2369561054) strcat(s, "I");
if (crc32("CTLmW",5) == 3250776168) strcat(s, "e");
    return s;
}

char *indologenous_adjectives() {
    char *s = calloc(13);
    if (crc32("rSVYcRhjqno",11) == 2706004844) strcat(s, "i");
if (crc32("xzTbrBImjcGmGW",14) == 1508244723) strcat(s, "t");
if (crc32("uqegIz",6) == 4271129172) strcat(s, "n");
if (crc32("rwkkDGwc",8) == 193629994) strcat(s, "P");
if (crc32("CeetHZFPjP",10) == 3083726394) strcat(s, "d");
if (crc32("TuEOFQuSRSJ",11) == 3330874722) strcat(s, "e");
if (crc32("PzabiYcgHomLkp",14) == 2961922677) strcat(s, "o");
if (crc32("WzrgUxclH",9) == 101325585) strcat(s, "l");
if (crc32("yBgtuTGljepbl",13) == 3420399949) strcat(s, "T");
if (crc32("kyFOHRzi",8) == 1121391129) strcat(s, "o");
if (crc32("xGxeeIhUSHZqc",13) == 3201063815) strcat(s, "g");
if (crc32("nFFxOfBjkpLdNyp",15) == 2850391597) strcat(s, "e");
if (crc32("MllkQOfVl",9) == 871288206) strcat(s, "C");
if (crc32("vgOrJjgdUg",10) == 736221133) strcat(s, "n");
if (crc32("kjExONog",8) == 3650235340) strcat(s, "o");
if (crc32("pirdYUq",7) == 3926556600) strcat(s, "u");
if (crc32("sutig",5) == 2611039020) strcat(s, "M");
if (crc32("VErQIOsvuoBmPxk",15) == 1607363133) strcat(s, "s");
    return s;
}

char *amblyopic_adjectives() {
    char *s = calloc(10);
    if (crc32("puJXBGXeXSYjKJh",15) == 1873634762) strcat(s, "a");
if (crc32("HhLZCcGiEaoHJoT",15) == 3853138717) strcat(s, "x");
if (crc32("nohpdjP",7) == 3332208764) strcat(s, "m");
if (crc32("oXIrGNEW",8) == 3545275900) strcat(s, "b");
if (crc32("fOSuhrG",7) == 455323250) strcat(s, "l");
if (crc32("PUUiI",5) == 3551134407) strcat(s, "y");
if (crc32("XriayH",6) == 1540131349) strcat(s, "o");
if (crc32("ajdVUPJdxAWofq",14) == 642226561) strcat(s, "p");
if (crc32("VfwAu",5) == 3533528079) strcat(s, "M");
if (crc32("VbuQXXyFCNauzI",14) == 4160111020) strcat(s, "i");
if (crc32("ngNJUQYHC",9) == 623585392) strcat(s, "c");
    return s;
}

char *unflavourous_adjectives() {
    char *s = calloc(13);
    if (crc32("zdEGTX",6) == 2158682401) strcat(s, "J");
if (crc32("sfJfN",5) == 3117641085) strcat(s, "u");
if (crc32("mDrijOKRFxDL",12) == 2307387565) strcat(s, "n");
if (crc32("juNkMM",6) == 1533863306) strcat(s, "n");
if (crc32("uKeLF",5) == 3876012816) strcat(s, "N");
if (crc32("KKwXpid",7) == 1369768511) strcat(s, "f");
if (crc32("twffutt",7) == 510104173) strcat(s, "W");
if (crc32("SVZprnTIvVX",11) == 3461759196) strcat(s, "l");
if (crc32("wlNWb",5) == 3501658838) strcat(s, "x");
if (crc32("sTQtIfR",7) == 4283745327) strcat(s, "a");
if (crc32("xPlAKyHQgbz",11) == 310542006) strcat(s, "v");
if (crc32("ZCTSCgIBmhwD",12) == 1681090683) strcat(s, "o");
if (crc32("fvjorOGa",8) == 2588982762) strcat(s, "T");
if (crc32("VcANYROTtoQbwO",14) == 2568959087) strcat(s, "u");
if (crc32("ebrUAbW",7) == 2911073495) strcat(s, "r");
if (crc32("tFSixekANVOjM",13) == 487594608) strcat(s, "o");
if (crc32("eAVFvz",6) == 3752634861) strcat(s, "u");
if (crc32("WfpnNuOsYCwuSOA",15) == 1245430688) strcat(s, "s");
    return s;
}

char *pseudorhombohedral_adjectives() {
    char *s = calloc(19);
    if (crc32("IBbDyxvJf",9) == 3651819057) strcat(s, "r");
if (crc32("GlLEpaIPwjp",11) == 695455854) strcat(s, "p");
if (crc32("mBETnPTBQaCOT",13) == 2362072838) strcat(s, "z");
if (crc32("ABsdP",5) == 2933997324) strcat(s, "s");
if (crc32("RIgcbNKHswRhYzP",15) == 3056271708) strcat(s, "e");
if (crc32("UHBurVEGmlqssQu",15) == 555477434) strcat(s, "u");
if (crc32("rljSTuXNMLAoVjQ",15) == 1026386398) strcat(s, "d");
if (crc32("GvhvUdylKfXaVf",14) == 182318272) strcat(s, "o");
if (crc32("uTFOhwNFFbY",11) == 1123909479) strcat(s, "C");
if (crc32("YHrlP",5) == 1490543380) strcat(s, "r");
if (crc32("WdAEZJr",7) == 4103372804) strcat(s, "h");
if (crc32("REbJqCPiKpe",11) == 2448671179) strcat(s, "t");
if (crc32("QKugvJvwLbi",11) == 1876133195) strcat(s, "o");
if (crc32("PmQrnmYGKUEn",12) == 3143223243) strcat(s, "m");
if (crc32("MeAuPfTch",9) == 2820574440) strcat(s, "b");
if (crc32("IbYftjRby",9) == 1461893577) strcat(s, "Z");
if (crc32("DSWWJbfEXScQs",13) == 2895098150) strcat(s, "o");
if (crc32("kSuzsUd",7) == 2238045771) strcat(s, "m");
if (crc32("CXwqZLRVwvR",11) == 2229409770) strcat(s, "h");
if (crc32("hpZWz",5) == 543069146) strcat(s, "e");
if (crc32("Ipdkd",5) == 1737704898) strcat(s, "G");
if (crc32("tYkRQGbC",8) == 1710187992) strcat(s, "d");
if (crc32("xTIFjns",7) == 1230642771) strcat(s, "r");
if (crc32("nBTcNbYzqwnhOOC",15) == 3956055731) strcat(s, "M");
if (crc32("leedVFLtTOJmFbd",15) == 1751480410) strcat(s, "a");
if (crc32("EMOtgTVXmf",10) == 2921169981) strcat(s, "n");
if (crc32("fWPokWuxsT",10) == 2274346472) strcat(s, "l");
    return s;
}

char *synecological_adjectives() {
    char *s = calloc(14);
    if (crc32("XVvNxvjXv",9) == 3622653440) strcat(s, "C");
if (crc32("vRhNQzIIkuuV",12) == 2255332581) strcat(s, "s");
if (crc32("ytHVZy",6) == 3301016204) strcat(s, "l");
if (crc32("iaUYD",5) == 2703621512) strcat(s, "y");
if (crc32("ZQWBUpcANDTbuH",14) == 2559087851) strcat(s, "n");
if (crc32("VMPZBpKsRAYYBqb",15) == 1356526370) strcat(s, "J");
if (crc32("mkVLCPxXKw",10) == 2840604576) strcat(s, "e");
if (crc32("LRgExxhZNp",10) == 587636449) strcat(s, "s");
if (crc32("LQtQvvaNGOh",11) == 432532968) strcat(s, "c");
if (crc32("AUxFdMbwcCYdinj",15) == 4019563858) strcat(s, "Z");
if (crc32("FLqyuPyJ",8) == 1701725179) strcat(s, "o");
if (crc32("KlvVdhBA",8) == 2987496884) strcat(s, "F");
if (crc32("whHivEGxS",9) == 2480124325) strcat(s, "l");
if (crc32("RDezUtbgoJNha",13) == 2390152719) strcat(s, "o");
if (crc32("XFKTLkeo",8) == 692868657) strcat(s, "R");
if (crc32("VHTVFSQ",7) == 3833211904) strcat(s, "g");
if (crc32("FXIWwMm",7) == 1877427630) strcat(s, "j");
if (crc32("pPrAhgGCGOFwlUI",15) == 2497660881) strcat(s, "i");
if (crc32("aoVHxhPizCco",12) == 810063874) strcat(s, "x");
if (crc32("fVVnNey",7) == 2283798944) strcat(s, "c");
if (crc32("fCnUBwoS",8) == 3035410021) strcat(s, "a");
if (crc32("ogpjn",5) == 2854099311) strcat(s, "R");
if (crc32("rBMQwg",6) == 1655953901) strcat(s, "l");
    return s;
}

char *hypertorrid_adjectives() {
    char *s = calloc(12);
    if (crc32("oqvhigx",7) == 2609382228) strcat(s, "h");
if (crc32("fayxaLUUW",9) == 968957664) strcat(s, "x");
if (crc32("ldvok",5) == 1188943455) strcat(s, "y");
if (crc32("LOxOY",5) == 1874945882) strcat(s, "c");
if (crc32("oQRfHRxGCR",10) == 2107491416) strcat(s, "p");
if (crc32("bwgzIXXZpc",10) == 3615597306) strcat(s, "c");
if (crc32("lQgwg",5) == 392283129) strcat(s, "e");
if (crc32("ziNURfcCUFqKad",14) == 463789330) strcat(s, "r");
if (crc32("smDaLINyOzQL",12) == 1387269885) strcat(s, "W");
if (crc32("WldjZDa",7) == 4085936421) strcat(s, "t");
if (crc32("COrcUPu",7) == 2717519435) strcat(s, "U");
if (crc32("KlwzhH",6) == 4063403246) strcat(s, "o");
if (crc32("jBHjyiOdcvhxPQQ",15) == 225334384) strcat(s, "Q");
if (crc32("uIuBbMV",7) == 2278055576) strcat(s, "r");
if (crc32("WhRIkuyQzr",10) == 871001817) strcat(s, "V");
if (crc32("cOpFHyNCVs",10) == 1758004860) strcat(s, "r");
if (crc32("TVrjdLuyaTIErkd",15) == 3182900344) strcat(s, "c");
if (crc32("npjeevE",7) == 2742218622) strcat(s, "i");
if (crc32("yNMgswYw",8) == 3964205253) strcat(s, "l");
if (crc32("tvDkmajGMV",10) == 1298016273) strcat(s, "d");
    return s;
}

char *anisodont_adjectives() {
    char *s = calloc(10);
    if (crc32("MYUfXER",7) == 390827532) strcat(s, "a");
if (crc32("IlhVdwswVd",10) == 938771525) strcat(s, "p");
if (crc32("yGhoecFVlbDlS",13) == 2296195638) strcat(s, "n");
if (crc32("XmWwgFJCDmlKG",13) == 3482340642) strcat(s, "i");
if (crc32("evBJtD",6) == 233094205) strcat(s, "t");
if (crc32("NXNEzfUZIvfk",12) == 3493667510) strcat(s, "s");
if (crc32("KryeDzfCyK",10) == 1709041534) strcat(s, "o");
if (crc32("zdXoyqRum",9) == 395298356) strcat(s, "d");
if (crc32("IoBDwjq",7) == 499964096) strcat(s, "F");
if (crc32("okBUnGCOIJhB",12) == 1227450200) strcat(s, "o");
if (crc32("EfElOEsIGuw",11) == 2865648949) strcat(s, "t");
if (crc32("cRRUTJvpCCD",11) == 3808393337) strcat(s, "n");
if (crc32("IwDsG",5) == 4262497818) strcat(s, "t");
    return s;
}

char *umbral_adjectives() {
    char *s = calloc(7);
    if (crc32("PzngrcveKEmu",12) == 2576140133) strcat(s, "U");
if (crc32("SEWJMHIYCNdumI",14) == 2412029863) strcat(s, "u");
if (crc32("oMFnsuCuStyk",12) == 1949591938) strcat(s, "N");
if (crc32("odoetHnHag",10) == 3772553340) strcat(s, "m");
if (crc32("ZznBodl",7) == 2708541815) strcat(s, "b");
if (crc32("GrNMl",5) == 2517673890) strcat(s, "r");
if (crc32("hdbBrnbT",8) == 3328752412) strcat(s, "a");
if (crc32("RZnZqbm",7) == 2954378412) strcat(s, "O");
if (crc32("MweFzPsNgzrH",12) == 1995411450) strcat(s, "l");
    return s;
}

char *hiplike_adjectives() {
    char *s = calloc(8);
    if (crc32("TYtukSGuVGDxY",13) == 4097816453) strcat(s, "d");
if (crc32("CEJMsUzpVQXYEff",15) == 3387420499) strcat(s, "h");
if (crc32("wTAFZPvQe",9) == 4017153498) strcat(s, "i");
if (crc32("UUEzsijDaYqm",12) == 382173761) strcat(s, "p");
if (crc32("xsJTm",5) == 3872644802) strcat(s, "l");
if (crc32("kQXWLBKpZBAgw",13) == 2849746227) strcat(s, "i");
if (crc32("RjFPmhUbGka",11) == 3545067325) strcat(s, "i");
if (crc32("LTKrAbJxxI",10) == 970865390) strcat(s, "y");
if (crc32("iGjNcLoFxIF",11) == 1243450494) strcat(s, "k");
if (crc32("DQPjUaJ",7) == 116036569) strcat(s, "e");
    return s;
}

char *postDiocletian_adjectives() {
    char *s = calloc(15);
    if (crc32("GuUSAtmSAFjE",12) == 1550528978) strcat(s, "p");
if (crc32("meDmelj",7) == 1631066307) strcat(s, "o");
if (crc32("VyZTrXApkajxxv",14) == 846584599) strcat(s, "R");
if (crc32("zlBiVWEL",8) == 3085374539) strcat(s, "s");
if (crc32("XALYitTanMXKsm",14) == 948075250) strcat(s, "t");
if (crc32("ziFQfasjwpZSEMV",15) == 411361943) strcat(s, "D");
if (crc32("zwkkxyQOK",9) == 3935824295) strcat(s, "i");
if (crc32("sjLxR",5) == 935906791) strcat(s, "o");
if (crc32("DWsjkGeyya",10) == 633606654) strcat(s, "R");
if (crc32("XaawCNzQizQc",12) == 245393465) strcat(s, "c");
if (crc32("BSAguJqLglLZZS",14) == 684177346) strcat(s, "J");
if (crc32("HQlistLSDeTHsmL",15) == 2965022446) strcat(s, "l");
if (crc32("XdXUJREzIWqxrt",14) == 2768299130) strcat(s, "e");
if (crc32("eiHLwTc",7) == 3553116103) strcat(s, "u");
if (crc32("bePaa",5) == 63435161) strcat(s, "t");
if (crc32("rHXRAfwNsjnFA",13) == 118407277) strcat(s, "t");
if (crc32("xcBWeGUepAh",11) == 1930661141) strcat(s, "i");
if (crc32("NiapesQtOSKfv",13) == 1322822641) strcat(s, "a");
if (crc32("JoqKa",5) == 1961414337) strcat(s, "d");
if (crc32("sJNJjPc",7) == 3590668787) strcat(s, "n");
    return s;
}

char *dangerless_adjectives() {
    char *s = calloc(11);
    if (crc32("mjUQZmxKwJyiUv",14) == 3078592131) strcat(s, "d");
if (crc32("RMAFtspziV",10) == 2583028894) strcat(s, "d");
if (crc32("SxLzZZJoAsu",11) == 2396067758) strcat(s, "g");
if (crc32("jfPuKCKQYHxjG",13) == 2827596145) strcat(s, "a");
if (crc32("peqnhNajyF",10) == 481827878) strcat(s, "n");
if (crc32("EYYhLO",6) == 2436501886) strcat(s, "g");
if (crc32("LSsyYaTxXIzgG",13) == 2306621158) strcat(s, "e");
if (crc32("xvSgXMxzcKPTWb",14) == 3315076483) strcat(s, "r");
if (crc32("YhvCrZFnpgoPo",13) == 744864357) strcat(s, "e");
if (crc32("osYAh",5) == 1840028386) strcat(s, "l");
if (crc32("vXEzemVgdveZUM",14) == 619572762) strcat(s, "e");
if (crc32("zzFsNrU",7) == 1627336041) strcat(s, "w");
if (crc32("dmggfULZfbzldF",14) == 3550815340) strcat(s, "s");
if (crc32("lnuYfdFggVDe",12) == 3234098076) strcat(s, "N");
if (crc32("kbCueLzHqmXGyy",14) == 4243679857) strcat(s, "s");
    return s;
}

char *quasiinvisible_adjectives() {
    char *s = calloc(15);
    if (crc32("HUBgPRgseL",10) == 2859500374) strcat(s, "q");
if (crc32("wfaMfKeeippUo",13) == 493580699) strcat(s, "e");
if (crc32("amCoVfrXejfk",12) == 820795785) strcat(s, "u");
if (crc32("TSUjisFADk",10) == 980536244) strcat(s, "a");
if (crc32("UxFPlNBnYJSP",12) == 3155009682) strcat(s, "s");
if (crc32("vIkNDU",6) == 134177380) strcat(s, "T");
if (crc32("PNQFsm",6) == 1782112537) strcat(s, "i");
if (crc32("ZjboELXML",9) == 3155619889) strcat(s, "i");
if (crc32("YOWtSmrlo",9) == 2144082177) strcat(s, "q");
if (crc32("PBBHIkhjowQtS",13) == 246159467) strcat(s, "n");
if (crc32("XMXjKUYTo",9) == 1396736245) strcat(s, "D");
if (crc32("vbZOF",5) == 2833957363) strcat(s, "v");
if (crc32("juaBqhljILw",11) == 408512180) strcat(s, "g");
if (crc32("sIIzPeJsAphGO",13) == 2135530845) strcat(s, "i");
if (crc32("UnQZv",5) == 2036601542) strcat(s, "s");
if (crc32("lYaZGfbzRL",10) == 1455764771) strcat(s, "i");
if (crc32("JMTNApRUmok",11) == 148454350) strcat(s, "b");
if (crc32("qhXbHtPwGIRyUo",14) == 3711327962) strcat(s, "p");
if (crc32("aeAjoCOEJokaPkB",15) == 1445434127) strcat(s, "l");
if (crc32("NpEKp",5) == 2131171696) strcat(s, "e");
    return s;
}

char *wellgreeted_adjectives() {
    char *s = calloc(12);
    if (crc32("HfAViYuRR",9) == 3499718923) strcat(s, "w");
if (crc32("unkZkUzkXzLZaiw",15) == 3047664214) strcat(s, "K");
if (crc32("HOCEpxn",7) == 3187802558) strcat(s, "e");
if (crc32("qmVJbzeJHVlNA",13) == 3581297750) strcat(s, "r");
if (crc32("ZthwObepT",9) == 3250088471) strcat(s, "l");
if (crc32("nMZClELo",8) == 629322320) strcat(s, "O");
if (crc32("CYncQZdJJpxb",12) == 3994460906) strcat(s, "l");
if (crc32("ZjTwFSuu",8) == 4031630074) strcat(s, "g");
if (crc32("DTMqIyMijbk",11) == 567689020) strcat(s, "r");
if (crc32("MArzPXPGFbx",11) == 1681662634) strcat(s, "e");
if (crc32("LndmS",5) == 3979850813) strcat(s, "e");
if (crc32("TNyJc",5) == 2208821570) strcat(s, "Y");
if (crc32("zwfRNYeE",8) == 3952729268) strcat(s, "t");
if (crc32("VUOlxmqkiOSbYG",14) == 1197827928) strcat(s, "e");
if (crc32("WfAczBqExUS",11) == 2093639845) strcat(s, "d");
    return s;
}

char *preumbonal_adjectives() {
    char *s = calloc(11);
    if (crc32("DETsm",5) == 2604601383) strcat(s, "p");
if (crc32("uZlynMNKNQcnX",13) == 1494141575) strcat(s, "R");
if (crc32("CVpfurxSTFBY",12) == 2450915503) strcat(s, "r");
if (crc32("lizAUcALi",9) == 4093350498) strcat(s, "f");
if (crc32("ofUjrIlw",8) == 2988112997) strcat(s, "e");
if (crc32("IGeCgKWEDcsaVWy",15) == 428320531) strcat(s, "u");
if (crc32("rTzgAxHbVATZ",12) == 1387588030) strcat(s, "u");
if (crc32("ywoCRuk",7) == 2271784717) strcat(s, "m");
if (crc32("WaHhkMVjl",9) == 1266881789) strcat(s, "b");
if (crc32("wLSjcyYuUagY",12) == 4221356418) strcat(s, "Y");
if (crc32("mwJxCoj",7) == 3762080526) strcat(s, "o");
if (crc32("MpviKAz",7) == 2790518695) strcat(s, "n");
if (crc32("HGyMtkoChqWr",12) == 809656164) strcat(s, "a");
if (crc32("qwwzrCwEhdnpHB",14) == 795462271) strcat(s, "l");
    return s;
}

char *gumptious_adjectives() {
    char *s = calloc(10);
    if (crc32("bWAsoWpFworcY",13) == 3916782032) strcat(s, "g");
if (crc32("daOMEcMhCAr",11) == 1599542929) strcat(s, "C");
if (crc32("KNMRpDBEwVHvtjD",15) == 4091639005) strcat(s, "u");
if (crc32("bLovwe",6) == 504354792) strcat(s, "L");
if (crc32("WsRpRGUKCsjtf",13) == 1498890475) strcat(s, "m");
if (crc32("HfvFrNmHQ",9) == 167108431) strcat(s, "j");
if (crc32("khNtLxqKzIx",11) == 779535821) strcat(s, "p");
if (crc32("mbzXuHS",7) == 3656397585) strcat(s, "V");
if (crc32("NvLfjamwg",9) == 1692343125) strcat(s, "t");
if (crc32("mBoBevyNp",9) == 1705666483) strcat(s, "i");
if (crc32("HfRMpJH",7) == 971510289) strcat(s, "o");
if (crc32("pLTPZOl",7) == 1573811764) strcat(s, "u");
if (crc32("vJYGjir",7) == 633596535) strcat(s, "n");
if (crc32("caSjfbjhHll",11) == 3857669493) strcat(s, "s");
    return s;
}

char *unreconsidered_adjectives() {
    char *s = calloc(15);
    if (crc32("vRcluGONyTZRULt",15) == 891235793) strcat(s, "u");
if (crc32("sBpSSPoyhr",10) == 700378993) strcat(s, "u");
if (crc32("UsgVxP",6) == 1740223523) strcat(s, "y");
if (crc32("gTCInXejdT",10) == 2537294344) strcat(s, "n");
if (crc32("vxpyhQf",7) == 2720664047) strcat(s, "h");
if (crc32("MoryOLS",7) == 23060555) strcat(s, "r");
if (crc32("VvNSnew",7) == 4201481079) strcat(s, "y");
if (crc32("PMvFSN",6) == 664689054) strcat(s, "e");
if (crc32("NtljUN",6) == 2830794672) strcat(s, "j");
if (crc32("kfddtT",6) == 424474208) strcat(s, "c");
if (crc32("FxYTapCzupKN",12) == 3072622925) strcat(s, "g");
if (crc32("LmXBRuHFhzqrJ",13) == 2743992650) strcat(s, "o");
if (crc32("KuYNiDwOitPV",12) == 2013370300) strcat(s, "n");
if (crc32("ibDaRwBjznUBGY",14) == 4228185273) strcat(s, "s");
if (crc32("psEoCogrQwEEvti",15) == 2227770663) strcat(s, "i");
if (crc32("IWQAoHOHOOJMDv",14) == 3179219533) strcat(s, "d");
if (crc32("YdgKEXubvrXE",12) == 4049154976) strcat(s, "e");
if (crc32("jYdrQP",6) == 1498478062) strcat(s, "f");
if (crc32("BQxxzstZcwq",11) == 3877279101) strcat(s, "r");
if (crc32("ZSwcQBJLNj",10) == 2648356788) strcat(s, "d");
if (crc32("aYYKhsrDTuH",11) == 4138450773) strcat(s, "e");
if (crc32("lDMPYfMSdQbLThV",15) == 3022648097) strcat(s, "r");
if (crc32("jOJtkjN",7) == 4031694900) strcat(s, "d");
    return s;
}

char *rarefactional_adjectives() {
    char *s = calloc(14);
    if (crc32("wppTyGJKtwPxHeQ",15) == 796241464) strcat(s, "j");
if (crc32("rsSOxSgCohT",11) == 508725619) strcat(s, "r");
if (crc32("Dryyb",5) == 2886135959) strcat(s, "a");
if (crc32("MccxTu",6) == 427290365) strcat(s, "c");
if (crc32("JKngxtifvQFAttl",15) == 1637904273) strcat(s, "r");
if (crc32("dObgDvv",7) == 3993553859) strcat(s, "e");
if (crc32("aeNVxigjUzl",11) == 4163468112) strcat(s, "M");
if (crc32("AzVPFoW",7) == 3398105232) strcat(s, "f");
if (crc32("wjckoVHMz",9) == 72660213) strcat(s, "A");
if (crc32("rgwdBpyeHIKmVYv",15) == 3277772885) strcat(s, "a");
if (crc32("esWfcBiczmJhfGD",15) == 3965699823) strcat(s, "c");
if (crc32("OgOgKVhALpb",11) == 1372481045) strcat(s, "J");
if (crc32("AEUloYqYktFxmqP",15) == 248667232) strcat(s, "t");
if (crc32("jWuIgyplNvMx",12) == 1323575644) strcat(s, "i");
if (crc32("cXrqyQYsqBuCAP",14) == 3030858304) strcat(s, "v");
if (crc32("SgbvEgfAJ",9) == 3011054196) strcat(s, "o");
if (crc32("koqcRKUPN",9) == 3135603108) strcat(s, "n");
if (crc32("SYXTfjmnkaXfQq",14) == 1932380567) strcat(s, "a");
if (crc32("uiVfigavqLzZUqg",15) == 1849954396) strcat(s, "n");
if (crc32("cIGSOdHOeuLLNnT",15) == 3421756749) strcat(s, "l");
    return s;
}

char *confabulatory_adjectives() {
    char *s = calloc(14);
    if (crc32("DhffiD",6) == 466657151) strcat(s, "c");
if (crc32("UtAOTDGIvKul",12) == 3823434577) strcat(s, "o");
if (crc32("SKBwpRePOWtLW",13) == 613847174) strcat(s, "n");
if (crc32("twiuExqzL",9) == 4142972680) strcat(s, "K");
if (crc32("CBAcEgMnOEb",11) == 79929790) strcat(s, "f");
if (crc32("TSKRZXoCDB",10) == 2344705691) strcat(s, "q");
if (crc32("bAMgRaQJ",8) == 2432439848) strcat(s, "a");
if (crc32("wfYBRZNi",8) == 3924352646) strcat(s, "J");
if (crc32("TmBnnNjy",8) == 764086132) strcat(s, "b");
if (crc32("BvkNPib",7) == 2106966666) strcat(s, "u");
if (crc32("QbTPUlYRafwFku",14) == 3011158889) strcat(s, "T");
if (crc32("HZtMKhkmYNnNWI",14) == 3680160861) strcat(s, "l");
if (crc32("zsveJeU",7) == 1546522533) strcat(s, "a");
if (crc32("lxdkqy",6) == 20519282) strcat(s, "b");
if (crc32("ZnUTaSvAGXNMJ",13) == 3530111125) strcat(s, "t");
if (crc32("NWFPSciPs",9) == 4035653263) strcat(s, "p");
if (crc32("jCSfWpfIR",9) == 1296958902) strcat(s, "o");
if (crc32("TgpNEHIevRXopF",14) == 2893529425) strcat(s, "r");
if (crc32("vSKSFVQMt",9) == 1139486895) strcat(s, "c");
if (crc32("bZQCXGWlzdhkjn",14) == 762295760) strcat(s, "y");
    return s;
}

char *perioecid_adjectives() {
    char *s = calloc(10);
    if (crc32("DctPZBzlJQs",11) == 84628089) strcat(s, "Z");
if (crc32("GndxoUG",7) == 2163757666) strcat(s, "p");
if (crc32("GKIXriwh",8) == 2916387774) strcat(s, "f");
if (crc32("rVjgKd",6) == 2805327) strcat(s, "e");
if (crc32("PYPFyht",7) == 2990055561) strcat(s, "r");
if (crc32("KXqYOGpXN",9) == 906272544) strcat(s, "i");
if (crc32("sisgO",5) == 2752946915) strcat(s, "o");
if (crc32("QBozUvNbywy",11) == 1045373858) strcat(s, "e");
if (crc32("fXCFhsFCSV",10) == 4091061092) strcat(s, "c");
if (crc32("eIHDpbmRt",9) == 602818306) strcat(s, "f");
if (crc32("JiopTCdWkYKFc",13) == 3092658441) strcat(s, "i");
if (crc32("kRpBqxgZdchV",12) == 3172784354) strcat(s, "g");
if (crc32("NOISnQI",7) == 367296668) strcat(s, "d");
    return s;
}

char *subaxillary_adjectives() {
    char *s = calloc(12);
    if (crc32("lStcfILBVLkg",12) == 1914371749) strcat(s, "s");
if (crc32("RmXgQ",5) == 1471768225) strcat(s, "j");
if (crc32("UBKTnMcwWvuwtZx",15) == 3021960092) strcat(s, "u");
if (crc32("pZYcD",5) == 3343667398) strcat(s, "b");
if (crc32("JYpoBrXaIANHdr",14) == 860388938) strcat(s, "a");
if (crc32("QHAtqSS",7) == 1288503280) strcat(s, "x");
if (crc32("jlEVAYe",7) == 431500378) strcat(s, "a");
if (crc32("HAGnlbPlLQB",11) == 199085602) strcat(s, "i");
if (crc32("qypWon",6) == 1968317375) strcat(s, "Y");
if (crc32("qJMvLvT",7) == 4217663850) strcat(s, "l");
if (crc32("uhGYXPMXV",9) == 3193474388) strcat(s, "l");
if (crc32("CFvKuxgSKUYrHca",15) == 2199450926) strcat(s, "a");
if (crc32("LUSuERKJqYGFTkV",15) == 1463728171) strcat(s, "r");
if (crc32("YVuMNASEDQ",10) == 301885604) strcat(s, "y");
    return s;
}

char *perlucidus_adjectives() {
    char *s = calloc(11);
    if (crc32("tncenTdui",9) == 3052467289) strcat(s, "i");
if (crc32("GMrQJfnNdYiiaK",14) == 859664744) strcat(s, "p");
if (crc32("BEpmMzIC",8) == 2355066650) strcat(s, "e");
if (crc32("TzjrpgXfWrCErai",15) == 3481076577) strcat(s, "w");
if (crc32("tPZBn",5) == 135492622) strcat(s, "r");
if (crc32("fxFRV",5) == 4835302) strcat(s, "l");
if (crc32("grqQaBALXMp",11) == 1150572879) strcat(s, "C");
if (crc32("GHwqpvZgfOoZtE",14) == 3384625115) strcat(s, "u");
if (crc32("wyGXvZO",7) == 291671904) strcat(s, "n");
if (crc32("MMnWwMcWwbwWGT",14) == 1997637554) strcat(s, "c");
if (crc32("uAsVMB",6) == 1124073644) strcat(s, "i");
if (crc32("HQkRMuEpvLKW",12) == 4210039087) strcat(s, "d");
if (crc32("kboIXzsV",8) == 50687592) strcat(s, "V");
if (crc32("viPlp",5) == 57614812) strcat(s, "u");
if (crc32("sRCqOJhGREXbB",13) == 3740683139) strcat(s, "s");
    return s;
}

char *Asianic_adjectives() {
    char *s = calloc(8);
    if (crc32("vKGIirZPaqkjTR",14) == 2448922501) strcat(s, "A");
if (crc32("EIcENrAXcwXU",12) == 1242349791) strcat(s, "s");
if (crc32("IutajmVedus",11) == 3847727234) strcat(s, "E");
if (crc32("vaGfgI",6) == 2815345344) strcat(s, "i");
if (crc32("bDvvPVztbo",10) == 1659047862) strcat(s, "K");
if (crc32("TJIrHpDyi",9) == 1479527386) strcat(s, "a");
if (crc32("zFObZPMVlNU",11) == 2253594704) strcat(s, "n");
if (crc32("OGaWSFNvVZAL",12) == 1219552129) strcat(s, "i");
if (crc32("eRXskREBN",9) == 1609173800) strcat(s, "r");
if (crc32("kXktTweMmz",10) == 1584782878) strcat(s, "c");
    return s;
}

char *ungarnished_adjectives() {
    char *s = calloc(12);
    if (crc32("jLzllEeJltXRuq",14) == 1746538704) strcat(s, "Y");
if (crc32("qDqrGKMczYzcCK",14) == 31114341) strcat(s, "u");
if (crc32("nBDIyD",6) == 1165949619) strcat(s, "n");
if (crc32("AZDpTAqHIX",10) == 800906799) strcat(s, "g");
if (crc32("hswSRSigAyxuzaO",15) == 2162564043) strcat(s, "a");
if (crc32("erJxtmthUXtU",12) == 2586679524) strcat(s, "r");
if (crc32("TnogcmYgDcaUaDp",15) == 209700636) strcat(s, "G");
if (crc32("AHvaEBBpH",9) == 480267561) strcat(s, "n");
if (crc32("TUjQH",5) == 1770359495) strcat(s, "i");
if (crc32("IvkWaxi",7) == 3005348698) strcat(s, "s");
if (crc32("SOatQLcouN",10) == 1191286328) strcat(s, "h");
if (crc32("HsXSflEjNsr",11) == 3943244412) strcat(s, "c");
if (crc32("bPBoEbMrKHGPoA",14) == 3980565542) strcat(s, "e");
if (crc32("oOoGjDByQvy",11) == 729854673) strcat(s, "s");
if (crc32("SDPnxJYbyE",10) == 1280779466) strcat(s, "d");
    return s;
}

char *superfeminine_adjectives() {
    char *s = calloc(14);
    if (crc32("ehytq",5) == 2491138076) strcat(s, "x");
if (crc32("hIHaYbBlFqoRO",13) == 1831349108) strcat(s, "s");
if (crc32("EPWzydeZTepq",12) == 2830840653) strcat(s, "b");
if (crc32("mfpYrbtEwGQfSZ",14) == 67373144) strcat(s, "u");
if (crc32("FtcHSFGFSsRRN",13) == 398762540) strcat(s, "p");
if (crc32("YGkTlomVUS",10) == 3068404045) strcat(s, "p");
if (crc32("MznHe",5) == 636657133) strcat(s, "e");
if (crc32("ylVWwjahoKlk",12) == 627402213) strcat(s, "q");
if (crc32("cQVvx",5) == 613148475) strcat(s, "r");
if (crc32("EslsRti",7) == 2629282308) strcat(s, "Q");
if (crc32("XcUyDkk",7) == 3456664919) strcat(s, "f");
if (crc32("WdbvbOO",7) == 3452208116) strcat(s, "r");
if (crc32("BmdEiRsUC",9) == 4133995595) strcat(s, "e");
if (crc32("FaouHbrW",8) == 2457088477) strcat(s, "m");
if (crc32("CcoPgmppFEHv",12) == 1857011574) strcat(s, "w");
if (crc32("kGtUcQRpdayYacZ",15) == 2885760236) strcat(s, "i");
if (crc32("JFBWXv",6) == 45438468) strcat(s, "X");
if (crc32("tmPYjhBLM",9) == 39016223) strcat(s, "n");
if (crc32("tlZaYIR",7) == 3438768832) strcat(s, "i");
if (crc32("zuNlATdPtSOaOEx",15) == 764576604) strcat(s, "W");
if (crc32("zkaRXvddkIomn",13) == 2225164587) strcat(s, "n");
if (crc32("iBiMAs",6) == 1356020653) strcat(s, "L");
if (crc32("ZWmmazQombEkzd",14) == 3804661306) strcat(s, "e");
    return s;
}

char *fairhaired_adjectives() {
    char *s = calloc(11);
    if (crc32("WxriIWGXmcwCX",13) == 1289205567) strcat(s, "a");
if (crc32("bFmvfW",6) == 2094371153) strcat(s, "f");
if (crc32("WJSmQov",7) == 4001292144) strcat(s, "N");
if (crc32("GCoXmTZiCP",10) == 1265793406) strcat(s, "a");
if (crc32("swoYQiFc",8) == 1535873359) strcat(s, "J");
if (crc32("JkzPNrUgslTvB",13) == 2907105464) strcat(s, "i");
if (crc32("IBZQfSrm",8) == 1992266162) strcat(s, "r");
if (crc32("mhkYXmaaeHobVoQ",15) == 2216104372) strcat(s, "V");
if (crc32("PawmhFbV",8) == 889599489) strcat(s, "h");
if (crc32("ygGKmRxpOskv",12) == 3503334690) strcat(s, "a");
if (crc32("fhssfOURL",9) == 3537762023) strcat(s, "i");
if (crc32("MLAAu",5) == 265719904) strcat(s, "r");
if (crc32("FTjemgNtDaeeek",14) == 1836254449) strcat(s, "N");
if (crc32("DxoBelUbvN",10) == 3196399290) strcat(s, "e");
if (crc32("uDVchcvNpqR",11) == 1270902703) strcat(s, "Y");
if (crc32("GDnEQaSUZna",11) == 2482193427) strcat(s, "d");
    return s;
}

char *acroterial_adjectives() {
    char *s = calloc(11);
    if (crc32("NuNgQAp",7) == 1201418053) strcat(s, "a");
if (crc32("jlQILEpO",8) == 2497784248) strcat(s, "c");
if (crc32("KuINafMaTJW",11) == 2215724580) strcat(s, "r");
if (crc32("nxNkzqXn",8) == 1575809124) strcat(s, "g");
if (crc32("hpgxkCTu",8) == 911507160) strcat(s, "o");
if (crc32("tNfdNTCJUuf",11) == 719882849) strcat(s, "t");
if (crc32("smyCsHJfOi",10) == 2339191899) strcat(s, "e");
if (crc32("ekbTBV",6) == 3183745460) strcat(s, "r");
if (crc32("nzWCMmAjOUCDE",13) == 4164661945) strcat(s, "i");
if (crc32("MjWuhPVSbvXvd",13) == 3952211086) strcat(s, "P");
if (crc32("KRRbEKsNiB",10) == 2374760907) strcat(s, "a");
if (crc32("QKuqNrEpYVHDD",13) == 2837159116) strcat(s, "l");
    return s;
}

char *wellanchored_adjectives() {
    char *s = calloc(13);
    if (crc32("SHvPpgPjrRaBTYS",15) == 3695333238) strcat(s, "L");
if (crc32("NzIKevbt",8) == 1249779196) strcat(s, "w");
if (crc32("ScJVvcvtVP",10) == 3050347871) strcat(s, "e");
if (crc32("AJDfwcjUiX",10) == 3140090441) strcat(s, "l");
if (crc32("iguzVLItqg",10) == 1292930789) strcat(s, "l");
if (crc32("npAHniSrEdzVqLo",15) == 1085555138) strcat(s, "Y");
if (crc32("umaGc",5) == 483065675) strcat(s, "a");
if (crc32("IxiwYeXXAI",10) == 3421555600) strcat(s, "R");
if (crc32("daCTvqFc",8) == 836895478) strcat(s, "n");
if (crc32("dsATALlLHZj",11) == 1294307583) strcat(s, "b");
if (crc32("DMqBIWxTTC",10) == 3190821048) strcat(s, "c");
if (crc32("ghQZDyk",7) == 3306649324) strcat(s, "h");
if (crc32("eCDsaBJAMWDPht",14) == 1810784742) strcat(s, "h");
if (crc32("qCblcjZdY",9) == 1037591220) strcat(s, "o");
if (crc32("lrnasTHnVQJOA",13) == 3036115357) strcat(s, "F");
if (crc32("MyKvwj",6) == 666277382) strcat(s, "r");
if (crc32("ZEqblggfFaRUPOR",15) == 3681335371) strcat(s, "e");
if (crc32("GJVpRCa",7) == 89523700) strcat(s, "G");
if (crc32("IKDSMgQtBpSAZIU",15) == 4024584213) strcat(s, "d");
    return s;
}

char *Virginian_adjectives() {
    char *s = calloc(10);
    if (crc32("LFZbhsOVrn",10) == 1664317875) strcat(s, "M");
if (crc32("wduDjGnoPyyFeR",14) == 2298545126) strcat(s, "V");
if (crc32("RxENP",5) == 1505402769) strcat(s, "i");
if (crc32("iVYIemQArVZ",11) == 4216014750) strcat(s, "Y");
if (crc32("LVTABYcehIBEZpu",15) == 2746041372) strcat(s, "r");
if (crc32("vaNEjNSMVWHWBgc",15) == 613235008) strcat(s, "g");
if (crc32("feoeipvcKiU",11) == 1711643848) strcat(s, "i");
if (crc32("TaYEMtDjIwR",11) == 1575969432) strcat(s, "y");
if (crc32("ApkixLFmxfF",11) == 3565326770) strcat(s, "n");
if (crc32("dKFktJaTSNZqa",13) == 1362862297) strcat(s, "i");
if (crc32("wZDdqzwD",8) == 658712617) strcat(s, "a");
if (crc32("IqBJIzaIKK",10) == 142298620) strcat(s, "x");
if (crc32("aWGxsyFVvVubq",13) == 3005564669) strcat(s, "n");
    return s;
}

char *easeful_adjectives() {
    char *s = calloc(8);
    if (crc32("nkchEwREB",9) == 3184461572) strcat(s, "e");
if (crc32("qJtpu",5) == 1874345355) strcat(s, "F");
if (crc32("fnGbexpkSwtL",12) == 2929202076) strcat(s, "a");
if (crc32("ULymzNyOVN",10) == 2153843158) strcat(s, "s");
if (crc32("lGWTZ",5) == 2696484186) strcat(s, "e");
if (crc32("isjvjgBqakwt",12) == 4091716827) strcat(s, "N");
if (crc32("ZqrLOUtGqHEpHZc",15) == 2317385529) strcat(s, "f");
if (crc32("rFulJSAWKSNF",12) == 278075426) strcat(s, "u");
if (crc32("vSgvPIbiRNrKA",13) == 3612436734) strcat(s, "l");
    return s;
}

char *transAmerican_adjectives() {
    char *s = calloc(14);
    if (crc32("zaFNezXrrbgunV",14) == 3862217531) strcat(s, "t");
if (crc32("nlpCWmR",7) == 1395768413) strcat(s, "r");
if (crc32("FaIzFOK",7) == 3397780386) strcat(s, "r");
if (crc32("ZlONHVlLhBiN",12) == 2116661698) strcat(s, "a");
if (crc32("YWQga",5) == 3633087893) strcat(s, "n");
if (crc32("jNENRxOY",8) == 2248940755) strcat(s, "j");
if (crc32("QNxFUXpSmTzPsUZ",15) == 3268342885) strcat(s, "s");
if (crc32("aGSSbsWDc",9) == 2214717226) strcat(s, "u");
if (crc32("vcwTiVcMO",9) == 375779487) strcat(s, "A");
if (crc32("udEKmgPzUjQqLX",14) == 3180204197) strcat(s, "m");
if (crc32("WSHSwnxOVj",10) == 518475081) strcat(s, "F");
if (crc32("RFqRyaIQNdkVkgH",15) == 1049529316) strcat(s, "e");
if (crc32("OQGZxED",7) == 12807426) strcat(s, "r");
if (crc32("ddbOH",5) == 3830502560) strcat(s, "V");
if (crc32("caxnKYiAM",9) == 1307599674) strcat(s, "i");
if (crc32("cvNgAVF",7) == 3112024008) strcat(s, "c");
if (crc32("yUqgnpC",7) == 1480547057) strcat(s, "a");
if (crc32("BiiyGzdj",8) == 954098692) strcat(s, "n");
    return s;
}

char *anfractuous_adjectives() {
    char *s = calloc(12);
    if (crc32("NZusgqvImppx",12) == 2518715508) strcat(s, "p");
if (crc32("LNCXCgQzGTQH",12) == 1575454268) strcat(s, "a");
if (crc32("KIaZC",5) == 3918105873) strcat(s, "n");
if (crc32("PVHvLVxUvrSkNV",14) == 3714008638) strcat(s, "y");
if (crc32("BSSPeToKU",9) == 2379083703) strcat(s, "f");
if (crc32("VzIxKuZJKx",10) == 4026323271) strcat(s, "o");
if (crc32("sXTobgnrjLzViZ",14) == 3702890729) strcat(s, "r");
if (crc32("ymKvsNZNDruMa",13) == 2349177077) strcat(s, "a");
if (crc32("CGKfud",6) == 1422283093) strcat(s, "o");
if (crc32("CtzaIybBeyGCzE",14) == 3179179209) strcat(s, "c");
if (crc32("TnkeHsxDMLHrRK",14) == 2792078592) strcat(s, "t");
if (crc32("VpCSbrGjfNL",11) == 2284999278) strcat(s, "u");
if (crc32("OuyUXKZnjh",10) == 25263619) strcat(s, "o");
if (crc32("HjTTWJtD",8) == 1496652539) strcat(s, "C");
if (crc32("jXCpCRWMCfUh",12) == 487430156) strcat(s, "u");
if (crc32("CdTaBezHZxEHm",13) == 1815047721) strcat(s, "L");
if (crc32("bqqpgFodkdCfIsv",15) == 3991274077) strcat(s, "s");
    return s;
}

char *inferable_adjectives() {
    char *s = calloc(10);
    if (crc32("dEBThg",6) == 2532194392) strcat(s, "i");
if (crc32("zhpHOf",6) == 491973360) strcat(s, "s");
if (crc32("jWIFWZlIPScK",12) == 3752352334) strcat(s, "n");
if (crc32("xsLJvkVff",9) == 1599009854) strcat(s, "J");
if (crc32("KJApgiijtQV",11) == 2714519552) strcat(s, "f");
if (crc32("GQlziJMoY",9) == 3418533056) strcat(s, "e");
if (crc32("mnOvEeJRlTn",11) == 985448782) strcat(s, "m");
if (crc32("xkkeUcJGPx",10) == 1810202195) strcat(s, "r");
if (crc32("QLxVbMRjel",10) == 803154524) strcat(s, "a");
if (crc32("EjRVgAx",7) == 1956724646) strcat(s, "b");
if (crc32("MOxqFYYGw",9) == 4126248266) strcat(s, "c");
if (crc32("VDLSMUwMXWw",11) == 2381669537) strcat(s, "l");
if (crc32("yYaLEfEMNWtz",12) == 4093548189) strcat(s, "W");
if (crc32("QpLYe",5) == 2270148244) strcat(s, "e");
    return s;
}

char *vibrational_adjectives() {
    char *s = calloc(12);
    if (crc32("xfdIYRogrhG",11) == 1748408541) strcat(s, "R");
if (crc32("LUFeBfyx",8) == 1061864194) strcat(s, "v");
if (crc32("vHstJSVps",9) == 3559728286) strcat(s, "z");
if (crc32("yeHohYMhjslecMT",15) == 277275) strcat(s, "i");
if (crc32("OwmFoWUz",8) == 1589205758) strcat(s, "U");
if (crc32("SJaGZRcDyfv",11) == 3068482998) strcat(s, "b");
if (crc32("cGlkiyGMAf",10) == 4157467879) strcat(s, "a");
if (crc32("WqqzpHzSKct",11) == 4178518603) strcat(s, "r");
if (crc32("dkoiFr",6) == 4029564378) strcat(s, "a");
if (crc32("eYOzKtnqh",9) == 1578371835) strcat(s, "t");
if (crc32("ebJSclDuLyyxjc",14) == 2487664866) strcat(s, "i");
if (crc32("bSZaGw",6) == 1526963287) strcat(s, "v");
if (crc32("aeeKoQhgmMYit",13) == 337730505) strcat(s, "o");
if (crc32("ProMJYvpYl",10) == 113539853) strcat(s, "n");
if (crc32("HqHgyOTd",8) == 3836077576) strcat(s, "a");
if (crc32("ISDoHDKzsdsSmY",14) == 2083606010) strcat(s, "l");
    return s;
}

char *intercerebral_adjectives() {
    char *s = calloc(14);
    if (crc32("ZGMULbuUIora",12) == 1246197744) strcat(s, "i");
if (crc32("mZYUOXzZKIGzLRi",15) == 1334505736) strcat(s, "Q");
if (crc32("KuoRkvTrOmH",11) == 2443852351) strcat(s, "n");
if (crc32("rYDvdIPdeBcOS",13) == 4169364563) strcat(s, "c");
if (crc32("WEmYBQcWT",9) == 3527985259) strcat(s, "t");
if (crc32("flPetzUZcziuSA",14) == 2499965248) strcat(s, "e");
if (crc32("OaamtFzfknW",11) == 907999297) strcat(s, "r");
if (crc32("IRDLwbhPutWNxxf",15) == 2470092859) strcat(s, "c");
if (crc32("StBVhwYAWCcRX",13) == 823085166) strcat(s, "e");
if (crc32("CQjAtNFauV",10) == 2307365) strcat(s, "r");
if (crc32("SiEeogW",7) == 2692290532) strcat(s, "e");
if (crc32("JDPZeng",7) == 186884866) strcat(s, "l");
if (crc32("jsYPqLitMGBjoH",14) == 277294586) strcat(s, "b");
if (crc32("FEhMZKNxXZXbd",13) == 2284396290) strcat(s, "r");
if (crc32("RbdDwTacEKM",11) == 254441165) strcat(s, "j");
if (crc32("mQaCrZLIZiLtaO",14) == 1496601038) strcat(s, "a");
if (crc32("pkLALl",6) == 579886050) strcat(s, "f");
if (crc32("ETTpgCXTHhcp",12) == 3743206155) strcat(s, "l");
    return s;
}

char *micronucleate_adjectives() {
    char *s = calloc(14);
    if (crc32("tfassH",6) == 3626065872) strcat(s, "C");
if (crc32("aaIMDUdUgTge",12) == 1904623963) strcat(s, "m");
if (crc32("OMivmZWUXU",10) == 1895689219) strcat(s, "i");
if (crc32("SFKbMTs",7) == 4090312160) strcat(s, "V");
if (crc32("YshUfZAIE",9) == 447358393) strcat(s, "c");
if (crc32("oujSOklc",8) == 47569122) strcat(s, "t");
if (crc32("IVUPSXOLIgFPNpj",15) == 2286660388) strcat(s, "r");
if (crc32("ZNrwqGRmf",9) == 4265383527) strcat(s, "l");
if (crc32("QFdAtoM",7) == 925216784) strcat(s, "o");
if (crc32("ZNJNyNhHRS",10) == 2969491231) strcat(s, "y");
if (crc32("wQbRyGQvdngD",12) == 896721067) strcat(s, "n");
if (crc32("ZhqWkxbFiWnPAUW",15) == 3634155849) strcat(s, "p");
if (crc32("LDxGILoLdM",10) == 3154571794) strcat(s, "u");
if (crc32("bIUOQXBemPq",11) == 1609188875) strcat(s, "c");
if (crc32("euWVVQMYe",9) == 2373796449) strcat(s, "U");
if (crc32("ZPXXgD",6) == 333407573) strcat(s, "l");
if (crc32("DZxWFWCwggV",11) == 2202466191) strcat(s, "D");
if (crc32("zsQnekSkugBsuA",14) == 3028621916) strcat(s, "e");
if (crc32("OnSXdlUy",8) == 3623089242) strcat(s, "a");
if (crc32("lFlDFqsDLnzWI",13) == 3902871300) strcat(s, "t");
if (crc32("iVarCWngWb",10) == 1801380732) strcat(s, "e");
    return s;
}

char *subpeltated_adjectives() {
    char *s = calloc(12);
    if (crc32("ZBkACWW",7) == 3879372729) strcat(s, "s");
if (crc32("zLxhzAK",7) == 3419727156) strcat(s, "u");
if (crc32("euJkHSuUQi",10) == 2536181813) strcat(s, "I");
if (crc32("QToYnacfAyd",11) == 3061841326) strcat(s, "b");
if (crc32("QEIQULw",7) == 1468472537) strcat(s, "l");
if (crc32("kpsJAx",6) == 2568503003) strcat(s, "p");
if (crc32("SGgFpQjG",8) == 2932877372) strcat(s, "l");
if (crc32("SzZWuvlr",8) == 2859199636) strcat(s, "e");
if (crc32("Rquls",5) == 478923885) strcat(s, "b");
if (crc32("QXPEHso",7) == 3411827367) strcat(s, "l");
if (crc32("ChiQYUMVAeajOTO",15) == 2141114083) strcat(s, "C");
if (crc32("CKUNhur",7) == 2897158843) strcat(s, "t");
if (crc32("rFeLXy",6) == 240700881) strcat(s, "a");
if (crc32("GzPrTVBqnry",11) == 1675403538) strcat(s, "t");
if (crc32("AsWwMQJBspPPN",13) == 2107632702) strcat(s, "N");
if (crc32("fZORHKPBkq",10) == 1237892069) strcat(s, "e");
if (crc32("yNTuNXUTYkHFqqL",15) == 1526787099) strcat(s, "D");
if (crc32("UkYTh",5) == 606446497) strcat(s, "d");
    return s;
}

char *teratoid_adjectives() {
    char *s = calloc(9);
    if (crc32("NUXDlqmjZkQmU",13) == 417389799) strcat(s, "t");
if (crc32("UdpPDxtFVkNzz",13) == 3918678862) strcat(s, "d");
if (crc32("YCwXCLNWpgULXHd",15) == 2784467335) strcat(s, "e");
if (crc32("KzTaROXRZzSrX",13) == 3332595422) strcat(s, "j");
if (crc32("NAUaKUQynEn",11) == 3590581016) strcat(s, "r");
if (crc32("ZARRJSGH",8) == 491114742) strcat(s, "s");
if (crc32("HAADDK",6) == 377114630) strcat(s, "a");
if (crc32("xRVVuWiIJdZc",12) == 2604788109) strcat(s, "t");
if (crc32("GgCwtdWhBDC",11) == 2817787838) strcat(s, "R");
if (crc32("DUsKtumo",8) == 2696165130) strcat(s, "o");
if (crc32("PeXUMvrdQBYoN",13) == 2721944450) strcat(s, "i");
if (crc32("bqEcMZKA",8) == 2857214384) strcat(s, "Y");
if (crc32("jRBffmi",7) == 1744158043) strcat(s, "d");
    return s;
}

char *ragtimey_adjectives() {
    char *s = calloc(9);
    if (crc32("AmMZmwlqNgF",11) == 3750082312) strcat(s, "V");
if (crc32("ZyeHdc",6) == 1330531716) strcat(s, "r");
if (crc32("BsHmQ",5) == 2959932978) strcat(s, "f");
if (crc32("tKvVqVJplWDFQbk",15) == 1579900272) strcat(s, "a");
if (crc32("DsVWINnZMYwYZh",14) == 3127918942) strcat(s, "b");
if (crc32("qivktX",6) == 3249263694) strcat(s, "g");
if (crc32("XtpOZoHPSIrCbss",15) == 2701537922) strcat(s, "t");
if (crc32("zXHStloeeUEeh",13) == 75435765) strcat(s, "i");
if (crc32("IyeHxo",6) == 634203335) strcat(s, "m");
if (crc32("TNeGFZfVG",9) == 2601064712) strcat(s, "E");
if (crc32("rMItqRtFEtWH",12) == 2162676291) strcat(s, "e");
if (crc32("XBTNKJdGgAA",11) == 2995738944) strcat(s, "u");
if (crc32("TCDwq",5) == 3003114050) strcat(s, "y");
    return s;
}

char *subtribal_adjectives() {
    char *s = calloc(10);
    if (crc32("aDyRp",5) == 4121852863) strcat(s, "s");
if (crc32("DHMWdwhhvzfYqAH",15) == 117172595) strcat(s, "u");
if (crc32("ezRozZEzzhYNW",13) == 3689566979) strcat(s, "b");
if (crc32("PxkfMZOIvY",10) == 1653165341) strcat(s, "b");
if (crc32("wJUOnkBnfaByCa",14) == 3496208725) strcat(s, "u");
if (crc32("qXRdSiypz",9) == 1567564032) strcat(s, "t");
if (crc32("KsxSQzhkBFthk",13) == 704972094) strcat(s, "r");
if (crc32("MoySafEEbRy",11) == 4104914546) strcat(s, "i");
if (crc32("atjLbWynZOlK",12) == 4045004673) strcat(s, "b");
if (crc32("PkWHodf",7) == 4006759562) strcat(s, "a");
if (crc32("VNXOkiz",7) == 1665321091) strcat(s, "l");
    return s;
}

char *unebullient_adjectives() {
    char *s = calloc(12);
    if (crc32("HJpxu",5) == 3379577553) strcat(s, "u");
if (crc32("KGetoanLlF",10) == 1956486897) strcat(s, "o");
if (crc32("pXjhOFX",7) == 77385335) strcat(s, "n");
if (crc32("EgUFe",5) == 21790353) strcat(s, "e");
if (crc32("FSsrWRJAIoiQMYi",15) == 3988162933) strcat(s, "R");
if (crc32("adKvCtigUAZKVG",14) == 3854860324) strcat(s, "b");
if (crc32("VaXcgNYlac",10) == 2376234039) strcat(s, "u");
if (crc32("CarzxarcSJ",10) == 893834991) strcat(s, "U");
if (crc32("tLkpiFNd",8) == 1131335273) strcat(s, "l");
if (crc32("BBcFFXhJDmeDyb",14) == 2811633151) strcat(s, "l");
if (crc32("rHmikBpte",9) == 3211292509) strcat(s, "L");
if (crc32("WoXxSrVspHNN",12) == 1064404553) strcat(s, "i");
if (crc32("pmMxm",5) == 1511770244) strcat(s, "e");
if (crc32("ZGYisMX",7) == 225016039) strcat(s, "n");
if (crc32("BmcOzZJDgUt",11) == 1793923525) strcat(s, "t");
    return s;
}

char *affiliable_adjectives() {
    char *s = calloc(11);
    if (crc32("cnDPxfQVjUsjF",13) == 1180110422) strcat(s, "O");
if (crc32("vFIzQT",6) == 3419857247) strcat(s, "a");
if (crc32("CatTfGNMrhcvzEx",15) == 3176682998) strcat(s, "f");
if (crc32("HifgN",5) == 2756645224) strcat(s, "R");
if (crc32("BsreOsCYe",9) == 2418570766) strcat(s, "f");
if (crc32("dZXWqWtXJxkTOv",14) == 84002301) strcat(s, "i");
if (crc32("PNdObcS",7) == 3553616727) strcat(s, "l");
if (crc32("hVNXEWAjU",9) == 1435527278) strcat(s, "i");
if (crc32("pgzdUmHZ",8) == 1319770556) strcat(s, "a");
if (crc32("ODrSOZEg",8) == 3758549797) strcat(s, "b");
if (crc32("lNJLfWtsLxIz",12) == 365792441) strcat(s, "a");
if (crc32("oxxTpJxglKKs",12) == 4163129394) strcat(s, "l");
if (crc32("RLsNQuxx",8) == 3392892780) strcat(s, "G");
if (crc32("gKCKML",6) == 1153654296) strcat(s, "e");
    return s;
}

char *unsectarian_adjectives() {
    char *s = calloc(12);
    if (crc32("uxGtmwJsaxuy",12) == 2190280770) strcat(s, "u");
if (crc32("qPWhtZSOcMWdJuH",15) == 3081214405) strcat(s, "b");
if (crc32("xkEwdKvdZVj",11) == 3438026124) strcat(s, "n");
if (crc32("aCwZTBIvsrGi",12) == 2381686842) strcat(s, "s");
if (crc32("pQynrDL",7) == 635956493) strcat(s, "e");
if (crc32("ClEeBalzfuqIL",13) == 15904978) strcat(s, "R");
if (crc32("yTiZRxLKqm",10) == 2930182451) strcat(s, "c");
if (crc32("zkXhcQcDAH",10) == 2788940087) strcat(s, "t");
if (crc32("clPsmLPXSkFnW",13) == 221337165) strcat(s, "a");
if (crc32("qBBFFrBP",8) == 54651669) strcat(s, "r");
if (crc32("MJHVwpKMrNXF",12) == 2548762027) strcat(s, "F");
if (crc32("wKlVKTdK",8) == 2330066114) strcat(s, "i");
if (crc32("eXyXTCmDb",9) == 3347930110) strcat(s, "f");
if (crc32("TCARWapccZXtPx",14) == 662075749) strcat(s, "a");
if (crc32("dQyNUCrheuXqhHk",15) == 488430864) strcat(s, "n");
    return s;
}

char *plantable_adjectives() {
    char *s = calloc(10);
    if (crc32("pjxEjxZlARm",11) == 2018778352) strcat(s, "p");
if (crc32("XupSfavWENDzf",13) == 2270256210) strcat(s, "d");
if (crc32("GFLvM",5) == 2584142684) strcat(s, "l");
if (crc32("bgGxEtTIXGSPbe",14) == 1871792796) strcat(s, "m");
if (crc32("Ervgb",5) == 1316725189) strcat(s, "a");
if (crc32("jfuknyfhYWrj",12) == 1801540429) strcat(s, "n");
if (crc32("sgqfQreV",8) == 1638324258) strcat(s, "t");
if (crc32("LryivybtWJ",10) == 1707468478) strcat(s, "Y");
if (crc32("UAksrwSgELXXo",13) == 763448747) strcat(s, "a");
if (crc32("TKPhufYhG",9) == 1941723436) strcat(s, "b");
if (crc32("agbjIdL",7) == 327516624) strcat(s, "l");
if (crc32("NXbDUwpPbNhVx",13) == 4294289731) strcat(s, "e");
    return s;
}

char *deciduate_adjectives() {
    char *s = calloc(10);
    if (crc32("gXoMIvgwChsMone",15) == 2521900126) strcat(s, "d");
if (crc32("bmlMVPwwsvMjapW",15) == 3260260138) strcat(s, "V");
if (crc32("YPtuYzExzYDzEn",14) == 2458771123) strcat(s, "e");
if (crc32("MjZAzx",6) == 2405480382) strcat(s, "c");
if (crc32("qRWrJyxrlArZg",13) == 3241989049) strcat(s, "i");
if (crc32("gfqwB",5) == 1915105370) strcat(s, "n");
if (crc32("XitgnSuWcCFD",12) == 667304923) strcat(s, "d");
if (crc32("RbBaMhe",7) == 621639701) strcat(s, "u");
if (crc32("WBoRN",5) == 661564204) strcat(s, "a");
if (crc32("smWjnWKSRTJiRWt",15) == 493659336) strcat(s, "q");
if (crc32("IqMbMkhlhZNiSIp",15) == 3711132040) strcat(s, "t");
if (crc32("AqgkBQqUZyuqhSa",15) == 2143356250) strcat(s, "e");
    return s;
}

char *nondiligent_adjectives() {
    char *s = calloc(12);
    if (crc32("sUxFIFPIWgKpbV",14) == 374914067) strcat(s, "d");
if (crc32("RnNBIyZcRsIFW",13) == 1717920626) strcat(s, "n");
if (crc32("oedtoFnnXoWXF",13) == 2597352471) strcat(s, "p");
if (crc32("fOrMXAy",7) == 3279742339) strcat(s, "o");
if (crc32("luQaIKE",7) == 1198825972) strcat(s, "p");
if (crc32("uzrqN",5) == 61292612) strcat(s, "n");
if (crc32("euvDPBTSyAIeaFq",15) == 2355627496) strcat(s, "h");
if (crc32("TwvEeIPDdNRRXl",14) == 2828165724) strcat(s, "d");
if (crc32("NDLIg",5) == 3195710028) strcat(s, "i");
if (crc32("EnoeWZiyNGKXW",13) == 1612912622) strcat(s, "l");
if (crc32("arCKQVmpBmXKn",13) == 3682355826) strcat(s, "p");
if (crc32("rbVUCdvDd",9) == 2473944221) strcat(s, "i");
if (crc32("fBQZVj",6) == 1328150455) strcat(s, "r");
if (crc32("KSNosdZzOAYac",13) == 951045014) strcat(s, "g");
if (crc32("TRaPlkqDgM",10) == 213722045) strcat(s, "L");
if (crc32("iJrHugHd",8) == 127016139) strcat(s, "e");
if (crc32("weZhzgCJKEoS",12) == 2168750459) strcat(s, "n");
if (crc32("CUkEigTHGubPs",13) == 3875036383) strcat(s, "q");
if (crc32("kFkFwxgrPhrw",12) == 691517590) strcat(s, "t");
    return s;
}

char *intervascular_adjectives() {
    char *s = calloc(14);
    if (crc32("ZUMkaB",6) == 3517122963) strcat(s, "a");
if (crc32("NbEoQMoMnzRl",12) == 4210144876) strcat(s, "i");
if (crc32("chCOMAZdbHW",11) == 3605040776) strcat(s, "n");
if (crc32("ORmgRWQOiA",10) == 3273534367) strcat(s, "P");
if (crc32("EbThaoUAFzjZ",12) == 657689036) strcat(s, "t");
if (crc32("qyipgBxDx",9) == 801989048) strcat(s, "w");
if (crc32("XsIbw",5) == 1361717136) strcat(s, "e");
if (crc32("uTAvQQDVzhLBu",13) == 1478412213) strcat(s, "h");
if (crc32("gGGRryye",8) == 924710883) strcat(s, "r");
if (crc32("VyzecuRrhX",10) == 789603894) strcat(s, "w");
if (crc32("nrhoWMuef",9) == 3490317687) strcat(s, "v");
if (crc32("weSXdJsaBSvXE",13) == 830656552) strcat(s, "e");
if (crc32("alwZj",5) == 2936906262) strcat(s, "a");
if (crc32("fUWLskG",7) == 1253997549) strcat(s, "s");
if (crc32("jqmoRJCkumY",11) == 832658045) strcat(s, "K");
if (crc32("BFuAYV",6) == 3760784040) strcat(s, "c");
if (crc32("TtfYHWODV",9) == 1979071976) strcat(s, "o");
if (crc32("YLDUenS",7) == 1159460792) strcat(s, "u");
if (crc32("HcSZTJuXJOztBL",14) == 1348532889) strcat(s, "l");
if (crc32("wbbJRLBTQzi",11) == 1550116046) strcat(s, "n");
if (crc32("iDuTysZzSEgMh",13) == 1096917256) strcat(s, "a");
if (crc32("QDINcRi",7) == 1415443298) strcat(s, "r");
    return s;
}

char *graptolitic_adjectives() {
    char *s = calloc(12);
    if (crc32("BujqaXgtILITX",13) == 2529746640) strcat(s, "g");
if (crc32("OZHfxyRWwGJ",11) == 1704563519) strcat(s, "l");
if (crc32("PDmvrTABBbK",11) == 1053202377) strcat(s, "r");
if (crc32("sgXWUqGe",8) == 790984817) strcat(s, "f");
if (crc32("pRUwYXFMmVPTuF",14) == 152073692) strcat(s, "a");
if (crc32("aIzxUVmOC",9) == 2746455482) strcat(s, "N");
if (crc32("xjewPKsdYSloMbk",15) == 1991259432) strcat(s, "p");
if (crc32("wZZZdeURwczvb",13) == 1651071801) strcat(s, "t");
if (crc32("arVTGyTavPPm",12) == 3536122180) strcat(s, "W");
if (crc32("kYfYaFjFI",9) == 1207944583) strcat(s, "o");
if (crc32("RscNxstS",8) == 1594028267) strcat(s, "M");
if (crc32("IUUrO",5) == 4262435227) strcat(s, "l");
if (crc32("FVIGsOlTI",9) == 1721937005) strcat(s, "B");
if (crc32("fjgAR",5) == 2773807534) strcat(s, "i");
if (crc32("QFmqkmE",7) == 2550912203) strcat(s, "P");
if (crc32("lBwkSElcJ",9) == 913771784) strcat(s, "t");
if (crc32("eVRRJr",6) == 3825831753) strcat(s, "i");
if (crc32("QCBCm",5) == 1467662714) strcat(s, "E");
if (crc32("QxxkbVvvyrV",11) == 3419032359) strcat(s, "c");
    return s;
}

char *dogseared_adjectives() {
    char *s = calloc(10);
    if (crc32("Exywt",5) == 2492244380) strcat(s, "d");
if (crc32("tKMdVRJiSVA",11) == 3818163953) strcat(s, "p");
if (crc32("BoisQSvMrc",10) == 2952668340) strcat(s, "o");
if (crc32("WknKt",5) == 2795131141) strcat(s, "g");
if (crc32("QjurAoifqyr",11) == 3293026735) strcat(s, "s");
if (crc32("IFqaWUGSUmffSG",14) == 3216183775) strcat(s, "Q");
if (crc32("ikXUEiAGMIlsm",13) == 3652261957) strcat(s, "e");
if (crc32("nBemCLYwHZIfdG",14) == 3618864144) strcat(s, "t");
if (crc32("wmbumifxqsayDh",14) == 818593186) strcat(s, "a");
if (crc32("njukmZjJ",8) == 569371213) strcat(s, "M");
if (crc32("YpPOvDJLzO",10) == 2145378722) strcat(s, "r");
if (crc32("amwXUpSAjxxE",12) == 1568234700) strcat(s, "o");
if (crc32("PWaDtivuM",9) == 848689878) strcat(s, "e");
if (crc32("fSUGwqChTOmT",12) == 3478574257) strcat(s, "u");
if (crc32("iYIHpX",6) == 2032154996) strcat(s, "d");
    return s;
}

char *bracteolate_adjectives() {
    char *s = calloc(12);
    if (crc32("PPMuOK",6) == 4280210269) strcat(s, "n");
if (crc32("CrZyPRQChzVk",12) == 3234376105) strcat(s, "b");
if (crc32("aPnFtzQbq",9) == 4023953081) strcat(s, "r");
if (crc32("ojoEbbww",8) == 1593655051) strcat(s, "a");
if (crc32("ddwivLgwyAPwIF",14) == 2899445598) strcat(s, "c");
if (crc32("MeqViGEPghkIkWu",15) == 2432466958) strcat(s, "s");
if (crc32("EzsnFSmbLtyRf",13) == 505096869) strcat(s, "t");
if (crc32("nzCoZV",6) == 942148918) strcat(s, "e");
if (crc32("xQDhZRN",7) == 2920956706) strcat(s, "o");
if (crc32("QAaVqPRNSsCn",12) == 2205648898) strcat(s, "w");
if (crc32("riPTk",5) == 1796600331) strcat(s, "l");
if (crc32("McENaZbSI",9) == 1354116896) strcat(s, "G");
if (crc32("zcLiqZLOBOyM",12) == 4059367603) strcat(s, "a");
if (crc32("IZvLUm",6) == 3315187588) strcat(s, "N");
if (crc32("aMNRPrNJwvwqBn",14) == 3545145913) strcat(s, "t");
if (crc32("wHgmbTu",7) == 3022366897) strcat(s, "v");
if (crc32("vGgTU",5) == 1044210296) strcat(s, "e");
    return s;
}

char *trimolecular_adjectives() {
    char *s = calloc(13);
    if (crc32("QrJVyHauNXXtt",13) == 2965692549) strcat(s, "k");
if (crc32("nDIXKx",6) == 3887019647) strcat(s, "t");
if (crc32("pLnPyNnoIrJ",11) == 755661033) strcat(s, "r");
if (crc32("niNpd",5) == 3270062221) strcat(s, "r");
if (crc32("pJiHYC",6) == 346586700) strcat(s, "i");
if (crc32("fuFQW",5) == 690563142) strcat(s, "T");
if (crc32("hzbDtL",6) == 880967463) strcat(s, "m");
if (crc32("NFGbmiaRwWQblvi",15) == 2840962992) strcat(s, "v");
if (crc32("vDlQxUweTYcPez",14) == 3345216828) strcat(s, "o");
if (crc32("EGwNDKwyp",9) == 3192123332) strcat(s, "e");
if (crc32("FhUPHXrk",8) == 2915036272) strcat(s, "l");
if (crc32("HhbEsWKuhQguTGX",15) == 2523956561) strcat(s, "e");
if (crc32("zhYXMJTsODEWut",14) == 3904679860) strcat(s, "O");
if (crc32("WQnAnwcWMXwQLQz",15) == 2618605980) strcat(s, "c");
if (crc32("eqnxr",5) == 1607978269) strcat(s, "u");
if (crc32("KqsnC",5) == 2023676342) strcat(s, "l");
if (crc32("unNQMmePsvAXfvc",15) == 3048862154) strcat(s, "a");
if (crc32("kvQNfuPJMnvEaT",14) == 1159646834) strcat(s, "r");
    return s;
}

char *cottony_adjectives() {
    char *s = calloc(8);
    if (crc32("WGTjohHBc",9) == 3861942860) strcat(s, "J");
if (crc32("CMYRxEaALEEvvkT",15) == 2384386893) strcat(s, "c");
if (crc32("GolfOwyfs",9) == 3080712769) strcat(s, "G");
if (crc32("dnAguxPztQ",10) == 1394093722) strcat(s, "o");
if (crc32("qOdDfp",6) == 146598666) strcat(s, "I");
if (crc32("BncBrKOcTRhl",12) == 621374065) strcat(s, "t");
if (crc32("OqwygJEPPTL",11) == 1211393837) strcat(s, "P");
if (crc32("sLuaFwmor",9) == 299308456) strcat(s, "t");
if (crc32("ypUVhFEYHc",10) == 2509809806) strcat(s, "a");
if (crc32("vOyWTjZqePiWrd",14) == 1592246362) strcat(s, "o");
if (crc32("jcRYtFJbo",9) == 1412820100) strcat(s, "C");
if (crc32("CZryyvToAH",10) == 717289024) strcat(s, "n");
if (crc32("eyHmqVyFNlFA",12) == 2517857011) strcat(s, "y");
if (crc32("zaHxFxjbEnMN",12) == 2721877590) strcat(s, "y");
    return s;
}

char *unenvironed_adjectives() {
    char *s = calloc(12);
    if (crc32("eRHHSPcXsITn",12) == 263378567) strcat(s, "u");
if (crc32("vgKVURRoavo",11) == 2112177778) strcat(s, "n");
if (crc32("WXbvrnozBCi",11) == 1185434711) strcat(s, "A");
if (crc32("ZizCuGsdSpCJ",12) == 3296260249) strcat(s, "e");
if (crc32("VgyyTqjFT",9) == 1307339683) strcat(s, "p");
if (crc32("YVwdHOBkKNVXgm",14) == 942910734) strcat(s, "n");
if (crc32("rMZAZnou",8) == 1124007010) strcat(s, "v");
if (crc32("awKDHwZPJA",10) == 21928582) strcat(s, "d");
if (crc32("FnrqGaNSzvx",11) == 643381066) strcat(s, "i");
if (crc32("rMbTc",5) == 1836151726) strcat(s, "r");
if (crc32("qNWtufoffGf",11) == 188658754) strcat(s, "f");
if (crc32("MWYYFIPfhT",10) == 2823721835) strcat(s, "o");
if (crc32("aeuhw",5) == 373374256) strcat(s, "A");
if (crc32("zQjlpAlELRgF",12) == 3673864396) strcat(s, "n");
if (crc32("AeMWWxCV",8) == 3736529407) strcat(s, "Q");
if (crc32("oNHpfijQYMuV",12) == 1649594106) strcat(s, "e");
if (crc32("NOloEC",6) == 1227153431) strcat(s, "q");
if (crc32("ywUZvaet",8) == 2578547145) strcat(s, "d");
    return s;
}

char *postnuptial_adjectives() {
    char *s = calloc(12);
    if (crc32("ymljPYRIo",9) == 151397215) strcat(s, "p");
if (crc32("liwgrmcMEAVUGK",14) == 331467739) strcat(s, "o");
if (crc32("ENTCF",5) == 2475373718) strcat(s, "a");
if (crc32("mZHqGxmtsiIh",12) == 624251683) strcat(s, "s");
if (crc32("qAXCNiqeIohAXA",14) == 3913519102) strcat(s, "i");
if (crc32("QiSokz",6) == 1322805714) strcat(s, "t");
if (crc32("XDzRHxJTc",9) == 979576337) strcat(s, "n");
if (crc32("uUxJtdUe",8) == 3527208632) strcat(s, "B");
if (crc32("LKkdLKUmcojUVwx",15) == 1731057266) strcat(s, "u");
if (crc32("wqgunCfS",8) == 3314267108) strcat(s, "p");
if (crc32("uLjAd",5) == 1516145998) strcat(s, "X");
if (crc32("TAHjHuUpPYAc",12) == 1666065977) strcat(s, "t");
if (crc32("UvOJLPhPqEIy",12) == 1692089196) strcat(s, "G");
if (crc32("QwzSRZUjAY",10) == 2140147082) strcat(s, "i");
if (crc32("sSxxWk",6) == 2553587983) strcat(s, "a");
if (crc32("QjuTtGTndZRFow",14) == 3170371892) strcat(s, "l");
    return s;
}

char *undivergent_adjectives() {
    char *s = calloc(12);
    if (crc32("ErAkqSkXdDVcQ",13) == 1311958572) strcat(s, "u");
if (crc32("iLRYpKGvWNapa",13) == 1593708270) strcat(s, "D");
if (crc32("NCksplvnJTeQlFW",15) == 1135268955) strcat(s, "n");
if (crc32("AWrOnHavKtlSp",13) == 2923497181) strcat(s, "m");
if (crc32("ZrYuWhI",7) == 4262861047) strcat(s, "d");
if (crc32("ULtbnWh",7) == 4256984621) strcat(s, "i");
if (crc32("OUKEGszxnYha",12) == 1884455954) strcat(s, "v");
if (crc32("YGItvznFYlVzo",13) == 3085536083) strcat(s, "W");
if (crc32("UUGuyNuqHRGnE",13) == 3485046055) strcat(s, "e");
if (crc32("nduCYzWKQ",9) == 1174816076) strcat(s, "r");
if (crc32("JKlwniQHvnbbER",14) == 2781324208) strcat(s, "O");
if (crc32("OfuxxoARuVZNYWt",15) == 2933247802) strcat(s, "g");
if (crc32("jumHrowdzeNidTv",15) == 1023166734) strcat(s, "e");
if (crc32("QLbpZhHEEyIU",12) == 3877590255) strcat(s, "n");
if (crc32("adcRvl",6) == 1623280077) strcat(s, "q");
if (crc32("XncQUC",6) == 468272964) strcat(s, "t");
    return s;
}

char *Cappadocian_adjectives() {
    char *s = calloc(12);
    if (crc32("jJaELK",6) == 2008034550) strcat(s, "x");
if (crc32("kXpWAdYltjjuoj",14) == 1208119503) strcat(s, "C");
if (crc32("lHXuSbSpxBsugp",14) == 2787371569) strcat(s, "a");
if (crc32("oGvigNPGeX",10) == 1012188013) strcat(s, "p");
if (crc32("oMtEaKIocR",10) == 1346056414) strcat(s, "p");
if (crc32("kfEAiBzjAKGq",12) == 3593000015) strcat(s, "z");
if (crc32("NwarAhRUtalOE",13) == 3868680407) strcat(s, "a");
if (crc32("WXFqRVuen",9) == 3713268630) strcat(s, "d");
if (crc32("brmIrBmthtthIp",14) == 3137149118) strcat(s, "z");
if (crc32("ISVtLYfTceRaj",13) == 1883598506) strcat(s, "o");
if (crc32("FhLdGvbjDGdDKWv",15) == 1361159760) strcat(s, "c");
if (crc32("ZOygUpMTaDMx",12) == 3129801496) strcat(s, "i");
if (crc32("rCtLac",6) == 3724215963) strcat(s, "a");
if (crc32("wZbFKZmCStUZN",13) == 1585858268) strcat(s, "n");
    return s;
}

char *interventionist_adjectives() {
    char *s = calloc(16);
    if (crc32("AICDHsHEaIJSDeh",15) == 4022459979) strcat(s, "i");
if (crc32("tOosoVRqFMQFl",13) == 3165592260) strcat(s, "n");
if (crc32("BmhoXGVwQIMxrwc",15) == 1867366879) strcat(s, "T");
if (crc32("sppibrPjykA",11) == 800113116) strcat(s, "t");
if (crc32("mVQAy",5) == 3827558340) strcat(s, "e");
if (crc32("QbMApBBmTdUTCdC",15) == 1833796515) strcat(s, "V");
if (crc32("aBcfSQQWV",9) == 3033815279) strcat(s, "r");
if (crc32("GiZDgWDOZ",9) == 843724413) strcat(s, "I");
if (crc32("prYhGXtlCT",10) == 828038824) strcat(s, "v");
if (crc32("yEeuhmAkQkbcp",13) == 1006523205) strcat(s, "e");
if (crc32("ySTaSAuE",8) == 190041587) strcat(s, "n");
if (crc32("DRhrQImslHSh",12) == 3951474565) strcat(s, "t");
if (crc32("mgDgwu",6) == 927297079) strcat(s, "i");
if (crc32("hHknaNC",7) == 991903783) strcat(s, "o");
if (crc32("gsRjTupCVafvN",13) == 4145000899) strcat(s, "n");
if (crc32("amBztQncBMXLn",13) == 3148680858) strcat(s, "i");
if (crc32("kradJrfFYp",10) == 194502744) strcat(s, "s");
if (crc32("nUUOQZsAZ",9) == 513972929) strcat(s, "y");
if (crc32("tCRotongvTNXVe",14) == 518917424) strcat(s, "t");
    return s;
}

char *selfstarved_adjectives() {
    char *s = calloc(12);
    if (crc32("IFjNTHlMPmUO",12) == 764510516) strcat(s, "K");
if (crc32("uLbvrlglgEm",11) == 3580366723) strcat(s, "s");
if (crc32("mbsejKdODrOv",12) == 2918524251) strcat(s, "k");
if (crc32("umDCiLLJKpXHE",13) == 3060867769) strcat(s, "e");
if (crc32("FoUMIRnf",8) == 3716498078) strcat(s, "l");
if (crc32("EUlCsqzMXZ",10) == 2208647196) strcat(s, "c");
if (crc32("wsKfXW",6) == 2662694240) strcat(s, "f");
if (crc32("qDEECBRIKzzPP",13) == 2120289828) strcat(s, "j");
if (crc32("ZBzhbipMkGh",11) == 385312396) strcat(s, "s");
if (crc32("MPFsaMBVIqbGIJX",15) == 4111706672) strcat(s, "t");
if (crc32("qeccNN",6) == 3170018418) strcat(s, "a");
if (crc32("fNDtjWiUmeZvLP",14) == 3611100763) strcat(s, "r");
if (crc32("hzradJUATxSDSt",14) == 3990738200) strcat(s, "v");
if (crc32("RcRoexVQcZlmB",13) == 2762534144) strcat(s, "e");
if (crc32("EcAjg",5) == 1111419112) strcat(s, "d");
    return s;
}

char *hasty_adjectives() {
    char *s = calloc(6);
    if (crc32("aUKqK",5) == 3888993041) strcat(s, "y");
if (crc32("pajpLYnmtjt",11) == 310067391) strcat(s, "h");
if (crc32("TtEfH",5) == 1603078660) strcat(s, "A");
if (crc32("voisxvMyVYUI",12) == 1704767859) strcat(s, "a");
if (crc32("QXPYfQnLmGdo",12) == 316957264) strcat(s, "g");
if (crc32("yeBlXGXYUQORz",13) == 3601595430) strcat(s, "s");
if (crc32("KEQGKZ",6) == 3598991442) strcat(s, "s");
if (crc32("tUAtkifac",9) == 1753508236) strcat(s, "t");
if (crc32("DlzDIPKS",8) == 3899017798) strcat(s, "y");
    return s;
}

char *unharboured_adjectives() {
    char *s = calloc(12);
    if (crc32("QFRBRxm",7) == 165465300) strcat(s, "u");
if (crc32("CgwVJ",5) == 175210799) strcat(s, "N");
if (crc32("sEqha",5) == 372799243) strcat(s, "n");
if (crc32("LgoXzKVqxzIAL",13) == 2818896968) strcat(s, "h");
if (crc32("JMNad",5) == 3433189889) strcat(s, "x");
if (crc32("ZndSQMQarMGi",12) == 3508143217) strcat(s, "a");
if (crc32("WyRYi",5) == 3363252917) strcat(s, "k");
if (crc32("djeUp",5) == 668917777) strcat(s, "r");
if (crc32("ePQtbJO",7) == 249856443) strcat(s, "b");
if (crc32("EoPuHUwETYTw",12) == 1020211276) strcat(s, "j");
if (crc32("mzexbWga",8) == 530217874) strcat(s, "o");
if (crc32("MOGgnBTubX",10) == 3494844033) strcat(s, "u");
if (crc32("HQAeWJ",6) == 1509792343) strcat(s, "r");
if (crc32("slmKmEbR",8) == 4245767007) strcat(s, "e");
if (crc32("zXBbS",5) == 1418370768) strcat(s, "J");
if (crc32("SAkPggHlut",10) == 4072339868) strcat(s, "d");
    return s;
}

char *unindustrious_adjectives() {
    char *s = calloc(14);
    if (crc32("RfKsNhAm",8) == 2797921418) strcat(s, "u");
if (crc32("AiSGrKFUnjDlGUm",15) == 700892310) strcat(s, "n");
if (crc32("xDuWVd",6) == 151728616) strcat(s, "e");
if (crc32("jIMqsotixF",10) == 3794733820) strcat(s, "i");
if (crc32("LIRYfzKZphndGP",14) == 3370135403) strcat(s, "R");
if (crc32("SdjmYinWv",9) == 522396912) strcat(s, "n");
if (crc32("mgJfxd",6) == 997216014) strcat(s, "d");
if (crc32("quqrQy",6) == 1308741170) strcat(s, "u");
if (crc32("HAmhLriawMeKo",13) == 2693527026) strcat(s, "d");
if (crc32("HPcimCbznoNVW",13) == 2856771947) strcat(s, "s");
if (crc32("IxOPQrrjEgBDK",13) == 2192391288) strcat(s, "t");
if (crc32("mCKEDVsQzXqdH",13) == 242579961) strcat(s, "w");
if (crc32("zBxPsYBVJQQcNzV",15) == 2913116368) strcat(s, "r");
if (crc32("HvDsVvpXZNW",11) == 3442573448) strcat(s, "i");
if (crc32("LygZCetc",8) == 928616454) strcat(s, "I");
if (crc32("GIZceQPaoKrlV",13) == 3871750092) strcat(s, "o");
if (crc32("kYHAaXsJ",8) == 419095862) strcat(s, "V");
if (crc32("xjxHhWskw",9) == 831673392) strcat(s, "u");
if (crc32("pOlKrISqBxIdOQ",14) == 1302696315) strcat(s, "m");
if (crc32("KZMeM",5) == 622120415) strcat(s, "s");
    return s;
}

char *abiotrophic_adjectives() {
    char *s = calloc(12);
    if (crc32("cphRLuzeUSUU",12) == 826448567) strcat(s, "a");
if (crc32("fnxHTeUIcmV",11) == 2687942123) strcat(s, "T");
if (crc32("LLhbPegGQmKlOwO",15) == 1709367078) strcat(s, "b");
if (crc32("WGpKwvICTRfzf",13) == 1069445485) strcat(s, "P");
if (crc32("GqbWiaNZRKh",11) == 18897286) strcat(s, "i");
if (crc32("EdekRpFABchAAZv",15) == 814916283) strcat(s, "o");
if (crc32("tytMD",5) == 3151571529) strcat(s, "t");
if (crc32("PNeAza",6) == 670509657) strcat(s, "X");
if (crc32("tqqfP",5) == 336390489) strcat(s, "r");
if (crc32("qJlHLAynRJ",10) == 3839636544) strcat(s, "S");
if (crc32("gneKqxAxdSD",11) == 1992972703) strcat(s, "o");
if (crc32("qsEAIFfGiSr",11) == 1222595557) strcat(s, "p");
if (crc32("bljmX",5) == 2428121441) strcat(s, "Q");
if (crc32("tcoGWn",6) == 3062044725) strcat(s, "h");
if (crc32("HDhkzzkRsXDvuco",15) == 294103112) strcat(s, "b");
if (crc32("YdcUdCUn",8) == 2239747262) strcat(s, "i");
if (crc32("OSCzFLInuHT",11) == 1901861139) strcat(s, "c");
    return s;
}

char *untopping_adjectives() {
    char *s = calloc(10);
    if (crc32("zabAblyTNPQcVJ",14) == 2891984301) strcat(s, "u");
if (crc32("xNpnQHsATKJDtX",14) == 2069746487) strcat(s, "f");
if (crc32("DSUDTintN",9) == 1211751207) strcat(s, "n");
if (crc32("XdeOcvUWuvNivU",14) == 3488344213) strcat(s, "t");
if (crc32("gdfnWMgp",8) == 55655000) strcat(s, "x");
if (crc32("guVQkpzMbbhWJtv",15) == 361625741) strcat(s, "o");
if (crc32("oDIZgClg",8) == 4176278870) strcat(s, "f");
if (crc32("mRbOoMDonyc",11) == 2802806224) strcat(s, "p");
if (crc32("lHhIhXJJYrQWA",13) == 1732267123) strcat(s, "p");
if (crc32("yPOFKzbarNAmMf",14) == 1737855927) strcat(s, "i");
if (crc32("caUrMLSBbJ",10) == 2983365361) strcat(s, "i");
if (crc32("VuUtuJlWJpGx",12) == 1709474075) strcat(s, "n");
if (crc32("oRnuAYtXZak",11) == 1776308037) strcat(s, "g");
    return s;
}

char *unburstable_adjectives() {
    char *s = calloc(12);
    if (crc32("uTJykmijEDnTBZ",14) == 3902918366) strcat(s, "g");
if (crc32("GaWBUpOLjb",10) == 2068560346) strcat(s, "u");
if (crc32("NyOjqHN",7) == 3619356241) strcat(s, "n");
if (crc32("HNnvHDS",7) == 2943545127) strcat(s, "b");
if (crc32("ehuuR",5) == 4186555429) strcat(s, "A");
if (crc32("RrnaGKd",7) == 3872619178) strcat(s, "u");
if (crc32("criUCeam",8) == 400629249) strcat(s, "r");
if (crc32("vwKVU",5) == 3447146463) strcat(s, "s");
if (crc32("VpoDWYjAy",9) == 468411245) strcat(s, "t");
if (crc32("zUSaRWRNKaYctCi",15) == 1480574434) strcat(s, "e");
if (crc32("NyHpBS",6) == 1244560714) strcat(s, "a");
if (crc32("FpEnSHtszs",10) == 677942351) strcat(s, "c");
if (crc32("jOlUJPolVW",10) == 2138787496) strcat(s, "b");
if (crc32("hEwPNe",6) == 2227893129) strcat(s, "J");
if (crc32("zPDFyiTBpr",10) == 3841282445) strcat(s, "l");
if (crc32("lbnRA",5) == 3157096675) strcat(s, "p");
if (crc32("eZigRnElxrSV",12) == 1635293067) strcat(s, "e");
    return s;
}

char *wellconcocted_adjectives() {
    char *s = calloc(14);
    if (crc32("ndraQfaNlGwob",13) == 1738418599) strcat(s, "R");
if (crc32("wveBQrhi",8) == 2341198747) strcat(s, "w");
if (crc32("hydiqL",6) == 3750479646) strcat(s, "r");
if (crc32("aXHEBglnhX",10) == 1791095058) strcat(s, "e");
if (crc32("gxQynifPMvjZqg",14) == 3846489845) strcat(s, "l");
if (crc32("WOfAoHSGRSSJ",12) == 724246106) strcat(s, "M");
if (crc32("LXAIDFvJxWuojLK",15) == 729170020) strcat(s, "l");
if (crc32("iFITQvNNjuVycN",14) == 2216098076) strcat(s, "c");
if (crc32("pPrSXvB",7) == 2755171717) strcat(s, "o");
if (crc32("NpDRFp",6) == 1880615878) strcat(s, "X");
if (crc32("iqcoktdswToo",12) == 1376544429) strcat(s, "n");
if (crc32("YOOoUIEA",8) == 2391018227) strcat(s, "w");
if (crc32("aZyujqCtilntl",13) == 2071545269) strcat(s, "c");
if (crc32("yXacVrgDSS",10) == 1066672274) strcat(s, "E");
if (crc32("VcKoGnGNGWI",11) == 959779165) strcat(s, "o");
if (crc32("HUdcnbC",7) == 1166954059) strcat(s, "R");
if (crc32("BQGOStXPss",10) == 2762218402) strcat(s, "c");
if (crc32("grSMKemJoC",10) == 2100117160) strcat(s, "t");
if (crc32("DxNKSO",6) == 217832479) strcat(s, "w");
if (crc32("nuaPlSKmkhFHpn",14) == 1783617100) strcat(s, "e");
if (crc32("JEPmG",5) == 2231343491) strcat(s, "N");
if (crc32("ntBVXboNg",9) == 874184615) strcat(s, "d");
    return s;
}

char *halfarmed_adjectives() {
    char *s = calloc(10);
    if (crc32("XqnBqkm",7) == 3121500862) strcat(s, "h");
if (crc32("nQVeOeZf",8) == 3247928250) strcat(s, "Y");
if (crc32("vyJWZMHfaUJ",11) == 963526876) strcat(s, "a");
if (crc32("BMrVAa",6) == 702645155) strcat(s, "l");
if (crc32("smQqmGnkGx",10) == 2691630137) strcat(s, "f");
if (crc32("IlKGZyDLrmXE",12) == 3087092311) strcat(s, "Z");
if (crc32("QTtsLV",6) == 3618440944) strcat(s, "a");
if (crc32("SIUoQ",5) == 3141858376) strcat(s, "Z");
if (crc32("iNwOLHqxXk",10) == 4253305410) strcat(s, "r");
if (crc32("gdeei",5) == 999060417) strcat(s, "m");
if (crc32("cvBLzxued",9) == 955451477) strcat(s, "S");
if (crc32("GgWnR",5) == 2649289274) strcat(s, "e");
if (crc32("pOcFLNErBdL",11) == 2586966192) strcat(s, "d");
    return s;
}

char *pinaceous_adjectives() {
    char *s = calloc(10);
    if (crc32("ZshFBNBTwrX",11) == 1295827702) strcat(s, "p");
if (crc32("KLIAoZCkLtEyvz",14) == 1100705545) strcat(s, "k");
if (crc32("kXLnkEWajAkrQX",14) == 142757435) strcat(s, "i");
if (crc32("CshviD",6) == 1670209216) strcat(s, "U");
if (crc32("WwiPeUQnTGoXbIO",15) == 2056613016) strcat(s, "n");
if (crc32("uiwwrveKfW",10) == 177714106) strcat(s, "a");
if (crc32("YfgzccBaE",9) == 2707057696) strcat(s, "E");
if (crc32("ncxmvmmxvNM",11) == 2440097368) strcat(s, "c");
if (crc32("JsMWU",5) == 3726177969) strcat(s, "l");
if (crc32("gcJzBQtj",8) == 2728661330) strcat(s, "e");
if (crc32("OItfYQMnhT",10) == 4203858558) strcat(s, "o");
if (crc32("PCxlbHRz",8) == 3643908753) strcat(s, "F");
if (crc32("ZIfpG",5) == 3644861847) strcat(s, "u");
if (crc32("zlxhqyklvZbIjtB",15) == 50440456) strcat(s, "s");
    return s;
}

char *anatomical_adjectives() {
    char *s = calloc(11);
    if (crc32("PnnXayK",7) == 1144155174) strcat(s, "M");
if (crc32("ytXorSKz",8) == 959725054) strcat(s, "a");
if (crc32("OCtHYeGkYsgV",12) == 3409870170) strcat(s, "n");
if (crc32("yXhWcof",7) == 3771821061) strcat(s, "V");
if (crc32("SCVJoEaE",8) == 1824041005) strcat(s, "a");
if (crc32("tkLWVgJvCSlLiRM",15) == 701907710) strcat(s, "n");
if (crc32("etmMJdR",7) == 628381338) strcat(s, "t");
if (crc32("bsRGsubWGWHQ",12) == 3585070943) strcat(s, "b");
if (crc32("fxtkOJKrwgEb",12) == 3125201768) strcat(s, "o");
if (crc32("mZsqBFvKKhSdLuA",15) == 581246253) strcat(s, "d");
if (crc32("fhRPiihT",8) == 1923100292) strcat(s, "m");
if (crc32("ZjvWKt",6) == 2887188800) strcat(s, "i");
if (crc32("DgllHGxx",8) == 928896287) strcat(s, "c");
if (crc32("rNHrklsjuNR",11) == 1666119825) strcat(s, "a");
if (crc32("FXQstqJwOGz",11) == 780009526) strcat(s, "O");
if (crc32("kSnBimJZf",9) == 3194560618) strcat(s, "l");
    return s;
}

char *treacherous_adjectives() {
    char *s = calloc(12);
    if (crc32("nYnkVs",6) == 212409494) strcat(s, "t");
if (crc32("JDaQmeUN",8) == 2048428337) strcat(s, "r");
if (crc32("fQSWrgmjzVBOVfs",15) == 1775495154) strcat(s, "e");
if (crc32("QbIeDTHnsCKcsGM",15) == 1815500915) strcat(s, "I");
if (crc32("bpqoichuoj",10) == 3388738458) strcat(s, "a");
if (crc32("rvOKfBF",7) == 3170672308) strcat(s, "c");
if (crc32("iPdZRksslEeZ",12) == 1038046726) strcat(s, "Y");
if (crc32("ZMxlJtBmlKGvfkt",15) == 1699970711) strcat(s, "h");
if (crc32("DgOjMdulbTkJMYf",15) == 1520916383) strcat(s, "A");
if (crc32("VJbNYBDW",8) == 284037302) strcat(s, "e");
if (crc32("ViWtaqozyKDCHQ",14) == 4081680099) strcat(s, "B");
if (crc32("PlWWFZB",7) == 2985802040) strcat(s, "r");
if (crc32("yzhYlYGgzhEUzSc",15) == 3382794573) strcat(s, "o");
if (crc32("nbQVuVgECNUQXBI",15) == 1719609572) strcat(s, "w");
if (crc32("XGBNIwEmQDh",11) == 1023850706) strcat(s, "u");
if (crc32("rfwVM",5) == 457140694) strcat(s, "a");
if (crc32("PAORsgxjtBww",12) == 35393026) strcat(s, "s");
    return s;
}

char *uninert_adjectives() {
    char *s = calloc(8);
    if (crc32("cyAYsaSbtPrEj",13) == 1699013633) strcat(s, "u");
if (crc32("aFsCsrIpVZ",10) == 4228740413) strcat(s, "n");
if (crc32("YsHiJvNjYmSdSk",14) == 1609893214) strcat(s, "W");
if (crc32("FsSdlxDzU",9) == 2735555858) strcat(s, "i");
if (crc32("pSXkA",5) == 3043256676) strcat(s, "W");
if (crc32("fBCNlm",6) == 1152526490) strcat(s, "n");
if (crc32("JZsBgvoi",8) == 3587814975) strcat(s, "e");
if (crc32("NUfxXD",6) == 3225259462) strcat(s, "S");
if (crc32("dkXBaeX",7) == 2381822878) strcat(s, "r");
if (crc32("pZiZajaorXiqw",13) == 1328797996) strcat(s, "E");
if (crc32("xQIDucv",7) == 1629497828) strcat(s, "t");
    return s;
}

char *unalcoholized_adjectives() {
    char *s = calloc(14);
    if (crc32("wpiadJeZCJtZJ",13) == 1511226139) strcat(s, "u");
if (crc32("mtRjkLxlYWAqBr",14) == 2794206920) strcat(s, "J");
if (crc32("NnRNEzPLm",9) == 599935405) strcat(s, "n");
if (crc32("ccXQtCTjJvBauZ",14) == 2395047833) strcat(s, "a");
if (crc32("WmQOjx",6) == 2159970059) strcat(s, "d");
if (crc32("CklJtbJp",8) == 3546903431) strcat(s, "l");
if (crc32("FrQjinlJLjXCiX",14) == 2136180440) strcat(s, "c");
if (crc32("hHTGjutuUKxcl",13) == 1527739196) strcat(s, "o");
if (crc32("HbHpRlyvXBRoLHg",15) == 2067934852) strcat(s, "d");
if (crc32("cBunTDmUnw",10) == 3125772691) strcat(s, "h");
if (crc32("OoiclhGUXUi",11) == 3833692456) strcat(s, "u");
if (crc32("CAlCpXKEDo",10) == 3713332885) strcat(s, "o");
if (crc32("vabguF",6) == 1465396992) strcat(s, "L");
if (crc32("tufbwMm",7) == 2123585577) strcat(s, "l");
if (crc32("HSGzd",5) == 1047722608) strcat(s, "u");
if (crc32("DOuBdoWRaonD",12) == 3722259430) strcat(s, "i");
if (crc32("zPtzOVyqyWGfI",13) == 984739945) strcat(s, "N");
if (crc32("gHLuBBatgcwOn",13) == 785639961) strcat(s, "z");
if (crc32("badCOR",6) == 1689280976) strcat(s, "e");
if (crc32("awPkFLZY",8) == 668790921) strcat(s, "d");
    return s;
}

char *ribless_adjectives() {
    char *s = calloc(8);
    if (crc32("ALmLpVJ",7) == 2582840785) strcat(s, "r");
if (crc32("KdmHmUQ",7) == 1546394193) strcat(s, "u");
if (crc32("CrMyjMyzUFX",11) == 2415386637) strcat(s, "i");
if (crc32("xODXhr",6) == 4124181982) strcat(s, "f");
if (crc32("lItJgusqlIL",11) == 568831433) strcat(s, "b");
if (crc32("fGhwEmcbcsQMZxE",15) == 3640616164) strcat(s, "y");
if (crc32("CYMoaIDIRsJ",11) == 4108367977) strcat(s, "l");
if (crc32("fBgmfDEOXmx",11) == 4188823062) strcat(s, "e");
if (crc32("SkHvcr",6) == 3233728445) strcat(s, "v");
if (crc32("YVTYphfVHQyALM",14) == 1606594382) strcat(s, "s");
if (crc32("YpHaLlrPTWDX",12) == 1924417415) strcat(s, "s");
    return s;
}

char *unpopularised_adjectives() {
    char *s = calloc(14);
    if (crc32("CWbKBDFwitONOQ",14) == 1217637160) strcat(s, "b");
if (crc32("kziOjQXUzrtNizD",15) == 306045665) strcat(s, "u");
if (crc32("EFulFd",6) == 3021589874) strcat(s, "u");
if (crc32("qdlfVmMWOhgY",12) == 1039198544) strcat(s, "n");
if (crc32("sthHSa",6) == 3732925228) strcat(s, "n");
if (crc32("uzHvhTZInH",10) == 2450612630) strcat(s, "p");
if (crc32("vnxuougwDvSzzE",14) == 3036716418) strcat(s, "I");
if (crc32("nyBUESuIKbCQkFn",15) == 453872035) strcat(s, "o");
if (crc32("XeZgdoga",8) == 1538167923) strcat(s, "p");
if (crc32("hkpFGz",6) == 2873588422) strcat(s, "u");
if (crc32("ufBVUzwX",8) == 1011649711) strcat(s, "l");
if (crc32("oZzoxv",6) == 592060500) strcat(s, "a");
if (crc32("ebCAPS",6) == 3123271257) strcat(s, "r");
if (crc32("UxGCU",5) == 769269037) strcat(s, "i");
if (crc32("zZxKPsuaxC",10) == 399379413) strcat(s, "D");
if (crc32("wNHyycSAij",10) == 566242341) strcat(s, "s");
if (crc32("XlJkkv",6) == 652697926) strcat(s, "K");
if (crc32("MGLKl",5) == 1317782648) strcat(s, "e");
if (crc32("JVREDUeZmQbZ",12) == 2525562806) strcat(s, "d");
    return s;
}

char *investable_adjectives() {
    char *s = calloc(11);
    if (crc32("BykwfYhLByWvol",14) == 2166422185) strcat(s, "O");
if (crc32("PPzlX",5) == 3231852447) strcat(s, "i");
if (crc32("VvGKNxEpINX",11) == 2998343694) strcat(s, "n");
if (crc32("YzdoCPR",7) == 2653771930) strcat(s, "w");
if (crc32("YJerqnrPxRVOmA",14) == 1753967647) strcat(s, "v");
if (crc32("dBSlMdVYsb",10) == 233434641) strcat(s, "G");
if (crc32("YvwCwY",6) == 439107630) strcat(s, "e");
if (crc32("oTDKkArcGW",10) == 3241362686) strcat(s, "s");
if (crc32("GdXKw",5) == 670441033) strcat(s, "t");
if (crc32("DmixGUHzJJcWtkT",15) == 3210837259) strcat(s, "t");
if (crc32("EuYpoUVj",8) == 552086534) strcat(s, "a");
if (crc32("OKjOE",5) == 4078281786) strcat(s, "V");
if (crc32("ZfrRnPtDWehF",12) == 1254737302) strcat(s, "b");
if (crc32("JzNBqNShnOeyr",13) == 1906051916) strcat(s, "m");
if (crc32("FErkQRStUBDyOR",14) == 2042101886) strcat(s, "l");
if (crc32("ehmzrTDMFIV",11) == 3888718028) strcat(s, "e");
    return s;
}

char *tugless_adjectives() {
    char *s = calloc(8);
    if (crc32("ewfjsCBbVRIO",12) == 3109130554) strcat(s, "t");
if (crc32("UHUlojoOY",9) == 1128989058) strcat(s, "u");
if (crc32("eyrWcSRIqujuG",13) == 2020784429) strcat(s, "l");
if (crc32("lUXyNAamxw",10) == 1433677995) strcat(s, "g");
if (crc32("UoYNlNjDxRYLUhb",15) == 1191296824) strcat(s, "l");
if (crc32("lXMQetarAdnMH",13) == 298520380) strcat(s, "e");
if (crc32("pNvljPCTCrW",11) == 3112277498) strcat(s, "h");
if (crc32("bCvJoFfvMsxO",12) == 4171154746) strcat(s, "s");
if (crc32("sLGoe",5) == 818927225) strcat(s, "B");
if (crc32("VIYgPqadWDLJh",13) == 959439730) strcat(s, "s");
    return s;
}

char *photoelectric_adjectives() {
    char *s = calloc(14);
    if (crc32("QUaauS",6) == 2850531886) strcat(s, "V");
if (crc32("voRLJLIdKe",10) == 3153646458) strcat(s, "p");
if (crc32("NSAEvKWUizvJa",13) == 969588659) strcat(s, "y");
if (crc32("fDOVrrpTHceSy",13) == 2678699645) strcat(s, "h");
if (crc32("EMZhC",5) == 717110022) strcat(s, "G");
if (crc32("TpsUZgMAxL",10) == 4132029548) strcat(s, "o");
if (crc32("awmcPyudPoQRM",13) == 2011389569) strcat(s, "t");
if (crc32("FeGSeofr",8) == 4235177875) strcat(s, "o");
if (crc32("XLoyWtrabQz",11) == 869531187) strcat(s, "e");
if (crc32("TieqtxpZ",8) == 752202698) strcat(s, "l");
if (crc32("JohbCtcFDPMul",13) == 4246175895) strcat(s, "w");
if (crc32("bqAINm",6) == 827732212) strcat(s, "e");
if (crc32("rdGESLtvro",10) == 1190066132) strcat(s, "c");
if (crc32("brfRrkycgvq",11) == 3557980597) strcat(s, "v");
if (crc32("xcsoSKDnpQuxuAh",15) == 1047079645) strcat(s, "t");
if (crc32("YzIWdZDBYPaLE",13) == 577709561) strcat(s, "l");
if (crc32("UkRlWBG",7) == 4271240038) strcat(s, "r");
if (crc32("yYWnMVMBQaqx",12) == 1137998039) strcat(s, "t");
if (crc32("paPnMGlaKqeu",12) == 719525888) strcat(s, "i");
if (crc32("LVeArPDVwHrwci",14) == 2274085236) strcat(s, "C");
if (crc32("gZlWiQPG",8) == 3036637601) strcat(s, "c");
    return s;
}

char *agglutinant_adjectives() {
    char *s = calloc(12);
    if (crc32("dUtJG",5) == 3885328944) strcat(s, "a");
if (crc32("UssauEhgqkHtQgR",15) == 3828141788) strcat(s, "g");
if (crc32("qUgEZfs",7) == 2540230966) strcat(s, "g");
if (crc32("vXjesdeEX",9) == 941120198) strcat(s, "l");
if (crc32("tWtOauVZYRqMd",13) == 1343528893) strcat(s, "u");
if (crc32("QebNmSFVS",9) == 830333134) strcat(s, "h");
if (crc32("GpbTgwOKNgfdGiK",15) == 2787493208) strcat(s, "t");
if (crc32("KCUBb",5) == 1548680167) strcat(s, "q");
if (crc32("wluXZzbKtJmoKl",14) == 4093839276) strcat(s, "i");
if (crc32("anzpsySCXSbI",12) == 1374029772) strcat(s, "T");
if (crc32("TznCNxGLkh",10) == 3232322902) strcat(s, "n");
if (crc32("uNOJAEngjBbVOct",15) == 199601346) strcat(s, "a");
if (crc32("DKRlU",5) == 2587209126) strcat(s, "n");
if (crc32("yRZmca",6) == 1340522270) strcat(s, "t");
    return s;
}

char *seatless_adjectives() {
    char *s = calloc(9);
    if (crc32("WrRYLcDKZAXTZE",14) == 4017944240) strcat(s, "Q");
if (crc32("znUuDHOu",8) == 3543881241) strcat(s, "s");
if (crc32("WdHlhN",6) == 4023814095) strcat(s, "e");
if (crc32("mxpeRGGVjwRBeBR",15) == 1449811433) strcat(s, "T");
if (crc32("IfqOgA",6) == 214301064) strcat(s, "a");
if (crc32("OyDUuNJpZjb",11) == 354943461) strcat(s, "t");
if (crc32("XuIBAUHKTXKoDfJ",15) == 3994368081) strcat(s, "l");
if (crc32("lJGGxkndb",9) == 3010204708) strcat(s, "U");
if (crc32("HNASPHZQ",8) == 3647300513) strcat(s, "e");
if (crc32("rUkzRWtHEdcxUik",15) == 548168974) strcat(s, "s");
if (crc32("lsoJyKja",8) == 4063149684) strcat(s, "h");
if (crc32("YdobxbtLtd",10) == 708053978) strcat(s, "s");
    return s;
}

char *nondiplomatic_adjectives() {
    char *s = calloc(14);
    if (crc32("WUMRoPRTGrqx",12) == 3982282875) strcat(s, "t");
if (crc32("HQNSOHu",7) == 1881731861) strcat(s, "n");
if (crc32("VxgSYUlEG",9) == 2975113560) strcat(s, "o");
if (crc32("YcNSdxuU",8) == 2015088271) strcat(s, "n");
if (crc32("OXfcDvHKn",9) == 3340559336) strcat(s, "T");
if (crc32("cBVTLxnz",8) == 1058578150) strcat(s, "d");
if (crc32("YYivXPEhgwqqG",13) == 3357158462) strcat(s, "i");
if (crc32("TfTUzTGubD",10) == 3374615673) strcat(s, "p");
if (crc32("sqxbzmi",7) == 1698987706) strcat(s, "l");
if (crc32("BBhGIDlNaECnfx",14) == 4196110912) strcat(s, "o");
if (crc32("JAhVwowwYCsK",12) == 1439890432) strcat(s, "t");
if (crc32("KYeruF",6) == 1998857391) strcat(s, "m");
if (crc32("fRNmzBBK",8) == 3351378658) strcat(s, "a");
if (crc32("pGTkcftZ",8) == 2483544788) strcat(s, "t");
if (crc32("irYfSLpGZA",10) == 4200467901) strcat(s, "i");
if (crc32("dcfUdanexVKh",12) == 4197733415) strcat(s, "q");
if (crc32("PAxKYgS",7) == 1153004323) strcat(s, "c");
    return s;
}

char *unblistered_adjectives() {
    char *s = calloc(12);
    if (crc32("TWFRhMMnBPOYT",13) == 3661504170) strcat(s, "u");
if (crc32("EFPoaqbbOclA",12) == 1724089447) strcat(s, "n");
if (crc32("mgHUXSrr",8) == 2959371282) strcat(s, "b");
if (crc32("wJaVq",5) == 4220479988) strcat(s, "l");
if (crc32("MtlHDHrat",9) == 3254459554) strcat(s, "i");
if (crc32("SsViEuQofhiea",13) == 3564475222) strcat(s, "s");
if (crc32("oxnaw",5) == 3357332309) strcat(s, "M");
if (crc32("rGqwFNfTVGqmZ",13) == 3954617860) strcat(s, "t");
if (crc32("mnpwSYRnPOMfIxG",15) == 1456025396) strcat(s, "Q");
if (crc32("nmBoZMVvedTOI",13) == 3708590119) strcat(s, "e");
if (crc32("ZINUq",5) == 539161400) strcat(s, "I");
if (crc32("LhpwSu",6) == 3949068885) strcat(s, "r");
if (crc32("yZZjjDqyPg",10) == 5774933) strcat(s, "e");
if (crc32("oWvVF",5) == 3816145203) strcat(s, "u");
if (crc32("QBWbSLq",7) == 1417046787) strcat(s, "d");
    return s;
}

char *pronationalist_adjectives() {
    char *s = calloc(15);
    if (crc32("ToVbQeP",7) == 2344034343) strcat(s, "p");
if (crc32("feMbOl",6) == 796218574) strcat(s, "r");
if (crc32("IkQZz",5) == 3793540188) strcat(s, "o");
if (crc32("HApSm",5) == 2070782191) strcat(s, "n");
if (crc32("OVRyIipKCzOooWo",15) == 1329546500) strcat(s, "a");
if (crc32("pzmMU",5) == 632003434) strcat(s, "t");
if (crc32("NBkausLyMNt",11) == 1317271620) strcat(s, "i");
if (crc32("vCmvv",5) == 3105703851) strcat(s, "o");
if (crc32("umZatPe",7) == 608045018) strcat(s, "l");
if (crc32("CEnBGDXJz",9) == 3745411244) strcat(s, "n");
if (crc32("sPygfdbBt",9) == 3083201167) strcat(s, "y");
if (crc32("ElcXq",5) == 942705424) strcat(s, "a");
if (crc32("XsVXHfwEypWJ",12) == 4009584018) strcat(s, "l");
if (crc32("xTpdXBRItUXPeMx",15) == 194185600) strcat(s, "H");
if (crc32("IRbeKw",6) == 3650691774) strcat(s, "i");
if (crc32("rnbZoHqbTqctncD",15) == 3992471712) strcat(s, "s");
if (crc32("hYrbAXQehby",11) == 3153488062) strcat(s, "t");
    return s;
}

char *corynebacterial_adjectives() {
    char *s = calloc(16);
    if (crc32("eJpjWYC",7) == 2855775388) strcat(s, "c");
if (crc32("eFOecqoAfleAAC",14) == 1746835602) strcat(s, "o");
if (crc32("HJILzxhf",8) == 2648743480) strcat(s, "r");
if (crc32("bfVEGUdPkYzBf",13) == 4252093065) strcat(s, "y");
if (crc32("IWPfttmHWHG",11) == 354847145) strcat(s, "j");
if (crc32("CwCcuYkIGPcvMFy",15) == 347099938) strcat(s, "n");
if (crc32("VWNhdWubVALE",12) == 1225010749) strcat(s, "j");
if (crc32("agTBvdMfn",9) == 3238831614) strcat(s, "e");
if (crc32("jqnlxVniTg",10) == 2578768174) strcat(s, "Q");
if (crc32("XROPHShOche",11) == 229691465) strcat(s, "b");
if (crc32("yBEalpQEDraIX",13) == 3659285405) strcat(s, "a");
if (crc32("XXDbeeob",8) == 3774165905) strcat(s, "t");
if (crc32("bdlLfacmb",9) == 1478987047) strcat(s, "c");
if (crc32("fBHUJioXHp",10) == 388774098) strcat(s, "t");
if (crc32("mfSjTjcdDyvbku",14) == 642857669) strcat(s, "e");
if (crc32("EuwIRizAFCp",11) == 2329264373) strcat(s, "r");
if (crc32("azQeWcsRyG",10) == 936249499) strcat(s, "i");
if (crc32("cCUvwKLlw",9) == 902020404) strcat(s, "N");
if (crc32("GNlEViVNyj",10) == 2445674379) strcat(s, "a");
if (crc32("UWPlnPICY",9) == 2255178121) strcat(s, "l");
    return s;
}

char *backfilleted_adjectives() {
    char *s = calloc(13);
    if (crc32("GkJTgiIW",8) == 2581087117) strcat(s, "b");
if (crc32("KMGlClOkBAXU",12) == 3247602870) strcat(s, "i");
if (crc32("mibfo",5) == 1146573774) strcat(s, "a");
if (crc32("LVtxmMNS",8) == 3649306392) strcat(s, "C");
if (crc32("UwTPLLhoQrIM",12) == 3321328603) strcat(s, "c");
if (crc32("SmSKHyfMOmwM",12) == 3075338889) strcat(s, "t");
if (crc32("thJhBcpKzfFXhAJ",15) == 189491115) strcat(s, "k");
if (crc32("AHiMyAmLFvagkg",14) == 1490447878) strcat(s, "k");
if (crc32("bNZGjabsD",9) == 1402711558) strcat(s, "f");
if (crc32("oqoEQTQtP",9) == 2299168206) strcat(s, "Q");
if (crc32("RPmQlC",6) == 1245222988) strcat(s, "i");
if (crc32("pDaxDDf",7) == 3315911674) strcat(s, "c");
if (crc32("xoKPjby",7) == 1681200140) strcat(s, "l");
if (crc32("YSmYLylxIr",10) == 671972591) strcat(s, "l");
if (crc32("QTFdl",5) == 4287308662) strcat(s, "E");
if (crc32("xkOpJhYmiVdgWqB",15) == 3374550815) strcat(s, "e");
if (crc32("RzRPSYFGzOIdjRI",15) == 600352214) strcat(s, "t");
if (crc32("CVWCpWYHImE",11) == 518582794) strcat(s, "e");
if (crc32("tvNPJUhKv",9) == 2437395718) strcat(s, "O");
if (crc32("gMiwCMBTrHBuof",14) == 1298193055) strcat(s, "d");
    return s;
}

char *unshapable_adjectives() {
    char *s = calloc(11);
    if (crc32("pnzlvL",6) == 1382413210) strcat(s, "i");
if (crc32("zZXvQt",6) == 3285562097) strcat(s, "u");
if (crc32("tdppLG",6) == 3329827599) strcat(s, "n");
if (crc32("vwhQPahh",8) == 2874369255) strcat(s, "s");
if (crc32("tospBQKrCfXwBo",14) == 2417373231) strcat(s, "s");
if (crc32("xOTUzyavAScLiGl",15) == 2285528439) strcat(s, "h");
if (crc32("FmXYJwzUn",9) == 750447981) strcat(s, "C");
if (crc32("BwZjOYfSR",9) == 2856139534) strcat(s, "a");
if (crc32("TrzUzarSQr",10) == 3731619220) strcat(s, "K");
if (crc32("oVhNirOwUbZV",12) == 285991253) strcat(s, "p");
if (crc32("QaNbUEuqnIVZ",12) == 2321455318) strcat(s, "i");
if (crc32("VZfQyqXQKXapkk",14) == 1273207852) strcat(s, "a");
if (crc32("cnUurprZk",9) == 1239999271) strcat(s, "b");
if (crc32("zHJJjBDsNiXnU",13) == 3103091064) strcat(s, "l");
if (crc32("CPwBstCwhBeqdD",14) == 3648664119) strcat(s, "m");
if (crc32("RVvERK",6) == 374416785) strcat(s, "e");
    return s;
}

char *halfdeserved_adjectives() {
    char *s = calloc(13);
    if (crc32("chBqkYhjbZm",11) == 4183151268) strcat(s, "L");
if (crc32("jlDshWc",7) == 2128647142) strcat(s, "h");
if (crc32("mtlzA",5) == 2405154788) strcat(s, "P");
if (crc32("PRjXhhTAP",9) == 4063195886) strcat(s, "a");
if (crc32("cFXICJPN",8) == 309513004) strcat(s, "B");
if (crc32("jzXdyldyuj",10) == 3646735674) strcat(s, "l");
if (crc32("bxJdPfa",7) == 2778570493) strcat(s, "f");
if (crc32("JZwmQMHBDY",10) == 2021170660) strcat(s, "j");
if (crc32("wLRmCslZRw",10) == 1397884243) strcat(s, "d");
if (crc32("yokFRkv",7) == 3698813155) strcat(s, "N");
if (crc32("KbPGNEVNd",9) == 513091134) strcat(s, "e");
if (crc32("vKloePa",7) == 2262743176) strcat(s, "s");
if (crc32("XLGXzUfDCora",12) == 4197054192) strcat(s, "e");
if (crc32("UHvJsDZW",8) == 1572158190) strcat(s, "k");
if (crc32("HpXiYgKZpKk",11) == 1113114486) strcat(s, "r");
if (crc32("qnljnXxPtNk",11) == 2132769235) strcat(s, "X");
if (crc32("iKCLuLVSP",9) == 494656834) strcat(s, "v");
if (crc32("JwMnnUVD",8) == 250247833) strcat(s, "R");
if (crc32("lvlGvHK",7) == 3755123724) strcat(s, "e");
if (crc32("WcZlHerSW",9) == 22709462) strcat(s, "d");
    return s;
}

char *fissipalmate_adjectives() {
    char *s = calloc(13);
    if (crc32("BDegWCKtgvqTF",13) == 3716073164) strcat(s, "X");
if (crc32("moMKEYkkJWhCFf",14) == 2426717210) strcat(s, "f");
if (crc32("MeZXaqaJoQC",11) == 2458945048) strcat(s, "i");
if (crc32("KNbFRqWEumljzuB",15) == 663176655) strcat(s, "s");
if (crc32("CbMfyvaZxxEguE",14) == 1641028779) strcat(s, "B");
if (crc32("fknIPkjEJVEsFF",14) == 3400752644) strcat(s, "s");
if (crc32("RLJzYsoLHgCZz",13) == 3646437985) strcat(s, "l");
if (crc32("ROtMGiNm",8) == 3968733736) strcat(s, "i");
if (crc32("mQtvwnVNFw",10) == 3374170117) strcat(s, "p");
if (crc32("zRdJGEHS",8) == 1325276642) strcat(s, "B");
if (crc32("qMQWBuPM",8) == 3155478563) strcat(s, "a");
if (crc32("aGWpgQJxMMfRf",13) == 817478790) strcat(s, "l");
if (crc32("qXVpDfyZLz",10) == 1427200280) strcat(s, "m");
if (crc32("OVGZg",5) == 239939225) strcat(s, "k");
if (crc32("cwkrkzWKECbKcO",14) == 1241409479) strcat(s, "a");
if (crc32("laqwhDONRleptB",14) == 3286110851) strcat(s, "E");
if (crc32("GkdHoXnP",8) == 2782059974) strcat(s, "t");
if (crc32("BSRbciblosBi",12) == 331543590) strcat(s, "e");
    return s;
}

char *unpilfered_adjectives() {
    char *s = calloc(11);
    if (crc32("LQzpEjf",7) == 1289374648) strcat(s, "u");
if (crc32("uqMFQeqHQirrnv",14) == 3097691098) strcat(s, "z");
if (crc32("rRdmtWUBc",9) == 3267886878) strcat(s, "n");
if (crc32("LpeMchAAqCA",11) == 668959610) strcat(s, "z");
if (crc32("QLzeDbX",7) == 2586246602) strcat(s, "p");
if (crc32("SlzNXW",6) == 2584755398) strcat(s, "g");
if (crc32("DoUHoc",6) == 2330815783) strcat(s, "i");
if (crc32("quKSwEtdlMhzdvz",15) == 2912483104) strcat(s, "b");
if (crc32("uLQYdMax",8) == 517403735) strcat(s, "l");
if (crc32("wOFcMhDLeb",10) == 1876731445) strcat(s, "f");
if (crc32("UsaMjomgz",9) == 3743912071) strcat(s, "d");
if (crc32("RmSTw",5) == 871475278) strcat(s, "e");
if (crc32("NZbCGxNntxfG",12) == 2159291671) strcat(s, "r");
if (crc32("HPDhexXCzoX",11) == 1777718139) strcat(s, "p");
if (crc32("JyOsCrNcftq",11) == 2879009617) strcat(s, "e");
if (crc32("MkZjc",5) == 2664760581) strcat(s, "V");
if (crc32("NsMHzpZA",8) == 1309418314) strcat(s, "d");
    return s;
}

char *unfeasted_adjectives() {
    char *s = calloc(10);
    if (crc32("JGtjarhcQuFHN",13) == 3281357593) strcat(s, "Y");
if (crc32("LYMMWy",6) == 826563190) strcat(s, "u");
if (crc32("kCIhTa",6) == 2283288594) strcat(s, "n");
if (crc32("lAHGbf",6) == 3948890252) strcat(s, "E");
if (crc32("hEjHIUrviGqA",12) == 576250012) strcat(s, "f");
if (crc32("oCvKSetcyeuJZqX",15) == 1636522846) strcat(s, "L");
if (crc32("XOZUERGQ",8) == 1826796497) strcat(s, "e");
if (crc32("kxRUpjsdxhPM",12) == 2486350105) strcat(s, "V");
if (crc32("RNvFgL",6) == 2027032734) strcat(s, "a");
if (crc32("DwDbUjR",7) == 1997737138) strcat(s, "Y");
if (crc32("CAkhY",5) == 29935330) strcat(s, "s");
if (crc32("dBXoMtjwgZdXMG",14) == 4221379459) strcat(s, "p");
if (crc32("DAocrjWD",8) == 226800986) strcat(s, "t");
if (crc32("VGnlP",5) == 2011158664) strcat(s, "g");
if (crc32("FEETTBJln",9) == 1225862090) strcat(s, "e");
if (crc32("TVUdMAQOiIoI",12) == 327422078) strcat(s, "d");
    return s;
}

char *circuitous_adjectives() {
    char *s = calloc(11);
    if (crc32("BkeaWacUtrOXeM",14) == 1648817340) strcat(s, "M");
if (crc32("WMcLDjKx",8) == 270211055) strcat(s, "c");
if (crc32("GAOryRMDYK",10) == 657156595) strcat(s, "i");
if (crc32("OGqFPXVnWZmmAK",14) == 2691444653) strcat(s, "b");
if (crc32("xxnyzyWv",8) == 269626153) strcat(s, "r");
if (crc32("KLinwYNyFpvhoGs",15) == 1183096220) strcat(s, "c");
if (crc32("KiJINeOEZGvEFD",14) == 2141872341) strcat(s, "i");
if (crc32("wsHBuyPPP",9) == 4278787585) strcat(s, "u");
if (crc32("RLSgva",6) == 3128381248) strcat(s, "i");
if (crc32("JdSdEJ",6) == 4275210586) strcat(s, "t");
if (crc32("ArYIEYr",7) == 1702533004) strcat(s, "g");
if (crc32("LPdJEDzzCkPGI",13) == 2301505869) strcat(s, "o");
if (crc32("bkxFNhKwGEhJHpg",15) == 2533891241) strcat(s, "U");
if (crc32("WUBRjHNaTlEXqzw",15) == 569497953) strcat(s, "u");
if (crc32("WCmTtZFXfZBAS",13) == 1673269799) strcat(s, "s");
    return s;
}

char *examinable_adjectives() {
    char *s = calloc(11);
    if (crc32("blMKvtK",7) == 3894689375) strcat(s, "e");
if (crc32("JXyMCeMtIQ",10) == 3523174157) strcat(s, "S");
if (crc32("VotEbdB",7) == 1447280941) strcat(s, "x");
if (crc32("nMwzNeLUCRvOfR",14) == 2847919551) strcat(s, "C");
if (crc32("ZRIvDIrb",8) == 2663638039) strcat(s, "a");
if (crc32("FAHIuwYWe",9) == 3534144449) strcat(s, "J");
if (crc32("XxhdiGmZ",8) == 3697638176) strcat(s, "m");
if (crc32("kKCrRvuibwhd",12) == 4009321581) strcat(s, "d");
if (crc32("sGQRbh",6) == 3733727427) strcat(s, "i");
if (crc32("LEGnsC",6) == 4127588412) strcat(s, "n");
if (crc32("RqXIkrWeErjAzt",14) == 3977095582) strcat(s, "a");
if (crc32("urPhttD",7) == 3394069992) strcat(s, "b");
if (crc32("LAsXcWEFOuIE",12) == 201245200) strcat(s, "l");
if (crc32("tJwiLtA",7) == 358367050) strcat(s, "e");
    return s;
}

char *unmoderating_adjectives() {
    char *s = calloc(13);
    if (crc32("ElXwSKwjM",9) == 130272247) strcat(s, "d");
if (crc32("GBODJG",6) == 3613822613) strcat(s, "u");
if (crc32("pBSqucrQb",9) == 3768178856) strcat(s, "n");
if (crc32("bNOwNGUmEuEJr",13) == 3330773726) strcat(s, "O");
if (crc32("hDTAlXRBjudzn",13) == 2765572513) strcat(s, "m");
if (crc32("KPcIZOrwDgvB",12) == 1742824779) strcat(s, "s");
if (crc32("rhCGoMVGTkxZSks",15) == 4044174287) strcat(s, "o");
if (crc32("hfzZP",5) == 2610970109) strcat(s, "F");
if (crc32("sHCMjOLTMM",10) == 2641471597) strcat(s, "d");
if (crc32("JBMjt",5) == 1608153806) strcat(s, "d");
if (crc32("AfUAKgjujFRQZ",13) == 143271729) strcat(s, "e");
if (crc32("NpGuJPtelTtpOu",14) == 1966735875) strcat(s, "r");
if (crc32("tMhBFFnc",8) == 4123923839) strcat(s, "K");
if (crc32("ORystlhfIbnnmzW",15) == 2632647919) strcat(s, "a");
if (crc32("pjogcOXAer",10) == 4262722983) strcat(s, "q");
if (crc32("ypcacWfiHEJFcs",14) == 2983428977) strcat(s, "t");
if (crc32("cwaNursbb",9) == 1864746491) strcat(s, "i");
if (crc32("GgNJZHQuVPUM",12) == 3275695520) strcat(s, "t");
if (crc32("ahJGJN",6) == 3248925140) strcat(s, "n");
if (crc32("yALZXKPuFGLOdrA",15) == 229596911) strcat(s, "O");
if (crc32("arVCZGMztSzoH",13) == 2890497787) strcat(s, "g");
    return s;
}

char *shrill_adjectives() {
    char *s = calloc(7);
    if (crc32("ZtXusmGnH",9) == 3250654959) strcat(s, "T");
if (crc32("OEEbLzf",7) == 2030536757) strcat(s, "s");
if (crc32("qrmZMTIEkoTbxJ",14) == 2801201827) strcat(s, "T");
if (crc32("ketgfzREjZGRdqA",15) == 1880514431) strcat(s, "h");
if (crc32("umlCTYdjChLYans",15) == 34019252) strcat(s, "A");
if (crc32("VkxGtkcOKZtkX",13) == 2551194634) strcat(s, "r");
if (crc32("fqRAwKlpdC",10) == 1997891632) strcat(s, "y");
if (crc32("GGvaKhgzwQaaqxG",15) == 2865286227) strcat(s, "i");
if (crc32("WSalxiUrsWELyp",14) == 1854727879) strcat(s, "U");
if (crc32("DbEHYNGECTgQs",13) == 3700187473) strcat(s, "l");
if (crc32("kWVIexIus",9) == 1419857450) strcat(s, "H");
if (crc32("fhPFtWH",7) == 3385073921) strcat(s, "l");
    return s;
}

char *petit_adjectives() {
    char *s = calloc(6);
    if (crc32("OdRdQHsly",9) == 2292025377) strcat(s, "S");
if (crc32("czPWKnpBLnwjvFX",15) == 1630409284) strcat(s, "p");
if (crc32("yXMBQm",6) == 124538313) strcat(s, "M");
if (crc32("PpzGyzbZmzggEEZ",15) == 416810146) strcat(s, "e");
if (crc32("gGcjyuIJvFsUt",13) == 858222790) strcat(s, "L");
if (crc32("XYKlGSRNFupNvE",14) == 3801936118) strcat(s, "t");
if (crc32("zeBzGGaJznxBW",13) == 1341231424) strcat(s, "i");
if (crc32("xrsfajGFTKWazL",14) == 2230615378) strcat(s, "x");
if (crc32("YCBuLU",6) == 2717533562) strcat(s, "t");
    return s;
}

char *pulsatile_adjectives() {
    char *s = calloc(10);
    if (crc32("GPbEUP",6) == 3495288058) strcat(s, "p");
if (crc32("MSLurAfZDnWn",12) == 168389211) strcat(s, "F");
if (crc32("BliklUVIL",9) == 2076553821) strcat(s, "u");
if (crc32("iHChWsLCQRIkSPq",15) == 1547480172) strcat(s, "q");
if (crc32("DMYhirMeCP",10) == 2458052791) strcat(s, "l");
if (crc32("iQyFwZRgqwZbyPB",15) == 3373564792) strcat(s, "l");
if (crc32("TnXPwGxKJtZIh",13) == 2217270834) strcat(s, "s");
if (crc32("faAYk",5) == 2475383980) strcat(s, "a");
if (crc32("DVQwRIqokaFnvq",14) == 3873581516) strcat(s, "t");
if (crc32("zwZubsMgS",9) == 3284084485) strcat(s, "i");
if (crc32("LKCqFiLYuIis",12) == 3411835640) strcat(s, "l");
if (crc32("DuuUDVAiEayDxS",14) == 2039669187) strcat(s, "e");
    return s;
}

char *grottolike_adjectives() {
    char *s = calloc(11);
    if (crc32("ArWKMojawN",10) == 293140511) strcat(s, "g");
if (crc32("yETFnr",6) == 2029065517) strcat(s, "r");
if (crc32("aUdXmemTZ",9) == 1473204867) strcat(s, "o");
if (crc32("HtWryuA",7) == 965574417) strcat(s, "t");
if (crc32("bJFCXpPMqNz",11) == 559000331) strcat(s, "t");
if (crc32("eZbQObnsQhfrzG",14) == 2075756583) strcat(s, "z");
if (crc32("ZwmmcIF",7) == 1351986508) strcat(s, "o");
if (crc32("pwpjiEKfd",9) == 3362194839) strcat(s, "l");
if (crc32("gNpnTQwJwPIUsz",14) == 442687432) strcat(s, "p");
if (crc32("chrafzqSM",9) == 3868130548) strcat(s, "i");
if (crc32("kBLLEXoYATLY",12) == 4047787398) strcat(s, "T");
if (crc32("kcVnuWAUR",9) == 1085880498) strcat(s, "k");
if (crc32("kxyysHvbyZgI",12) == 163201467) strcat(s, "e");
    return s;
}

char *Aymaran_adjectives() {
    char *s = calloc(8);
    if (crc32("xwvafhcKTb",10) == 3038952045) strcat(s, "l");
if (crc32("bCPJHO",6) == 2205070291) strcat(s, "A");
if (crc32("LHhakoiAsTU",11) == 2512034527) strcat(s, "y");
if (crc32("xxISz",5) == 4235515916) strcat(s, "H");
if (crc32("CAteyHFfHdScueR",15) == 3559223256) strcat(s, "m");
if (crc32("NtKmBCs",7) == 2663562725) strcat(s, "a");
if (crc32("tZsAlf",6) == 3820314217) strcat(s, "I");
if (crc32("ZRYruRn",7) == 3741834468) strcat(s, "r");
if (crc32("ognLAIKLtpt",11) == 1936560751) strcat(s, "v");
if (crc32("DrdiSHbMOaSGkS",14) == 1374320492) strcat(s, "a");
if (crc32("Ygalij",6) == 1784588619) strcat(s, "n");
    return s;
}

char *trimorphic_adjectives() {
    char *s = calloc(11);
    if (crc32("ygAgzBCsu",9) == 678313709) strcat(s, "O");
if (crc32("ZpaMFVZeqx",10) == 1753648400) strcat(s, "t");
if (crc32("ypyqInwGWzvK",12) == 1474862486) strcat(s, "r");
if (crc32("FgCVBKmqTp",10) == 3492146325) strcat(s, "i");
if (crc32("TzVQgLONozpdbmT",15) == 775521150) strcat(s, "a");
if (crc32("qtsiFlVzVRb",11) == 88065516) strcat(s, "m");
if (crc32("wbkep",5) == 284311125) strcat(s, "o");
if (crc32("TtXHEy",6) == 740777385) strcat(s, "L");
if (crc32("muDhoGnAaDcyPX",14) == 3931431537) strcat(s, "r");
if (crc32("bWRUKADWBZx",11) == 1839248336) strcat(s, "p");
if (crc32("SyWofaQ",7) == 1725565125) strcat(s, "h");
if (crc32("KgEfYPWfbDFRO",13) == 745106144) strcat(s, "i");
if (crc32("hnEPAUO",7) == 472021418) strcat(s, "c");
    return s;
}

char *comminatory_adjectives() {
    char *s = calloc(12);
    if (crc32("TaroSdeEE",9) == 1508903591) strcat(s, "c");
if (crc32("LRipDE",6) == 597134918) strcat(s, "b");
if (crc32("evsjgHEcnBm",11) == 2664013532) strcat(s, "o");
if (crc32("iKQFRble",8) == 573332186) strcat(s, "m");
if (crc32("jPfoaxSjuGVvbuT",15) == 909857487) strcat(s, "I");
if (crc32("fKJshZKftr",10) == 1702497049) strcat(s, "m");
if (crc32("xOxuKRyMy",9) == 2695799394) strcat(s, "i");
if (crc32("nCoARuebip",10) == 3098286309) strcat(s, "J");
if (crc32("PVotpLQ",7) == 2399142735) strcat(s, "n");
if (crc32("DVDoNhn",7) == 1155756312) strcat(s, "a");
if (crc32("UCcbfTFXcnRsIV",14) == 365764049) strcat(s, "t");
if (crc32("DcaHFxZparWYG",13) == 3763829386) strcat(s, "o");
if (crc32("angkBYaAl",9) == 873924371) strcat(s, "r");
if (crc32("tQYJJsoX",8) == 91110537) strcat(s, "s");
if (crc32("IsvTVxa",7) == 1188490515) strcat(s, "y");
    return s;
}

char *unprevailing_adjectives() {
    char *s = calloc(13);
    if (crc32("uGEToVDEy",9) == 3624513241) strcat(s, "u");
if (crc32("UMREQSxifA",10) == 491056471) strcat(s, "D");
if (crc32("xwdMC",5) == 481593000) strcat(s, "n");
if (crc32("hcddNZvMPdbC",12) == 3139748398) strcat(s, "R");
if (crc32("eBmEMRCOrWgUfbH",15) == 2383840920) strcat(s, "p");
if (crc32("wNYntOAb",8) == 256203473) strcat(s, "r");
if (crc32("DFhGnfYjp",9) == 3031708484) strcat(s, "e");
if (crc32("ampXMjEsFuAqieO",15) == 3451617896) strcat(s, "d");
if (crc32("ViyeokzBXtDMeF",14) == 136603618) strcat(s, "v");
if (crc32("scdLbvErieW",11) == 1735866031) strcat(s, "K");
if (crc32("kKdhHxETWAGBJ",13) == 2522454133) strcat(s, "a");
if (crc32("jIaAdv",6) == 1737895064) strcat(s, "r");
if (crc32("RDqripkaMlHpywK",15) == 2590722759) strcat(s, "i");
if (crc32("CwsdXLtUhfffuzy",15) == 2568474311) strcat(s, "l");
if (crc32("ELqKW",5) == 2552748932) strcat(s, "z");
if (crc32("KXskGfygtEKRi",13) == 2168621294) strcat(s, "i");
if (crc32("rZEyCbJD",8) == 510667911) strcat(s, "n");
if (crc32("kVOosFgghY",10) == 1215925030) strcat(s, "g");
    return s;
}

char *armorplated_adjectives() {
    char *s = calloc(12);
    if (crc32("mOycAzJkWVCnHL",14) == 257405427) strcat(s, "a");
if (crc32("cMILiyAYuKfRNwP",15) == 38759755) strcat(s, "r");
if (crc32("GfSEVvRGAku",11) == 1828677339) strcat(s, "m");
if (crc32("GCXiJteEX",9) == 2097156066) strcat(s, "M");
if (crc32("LqNsPBeH",8) == 45163035) strcat(s, "o");
if (crc32("sWoEly",6) == 1136822362) strcat(s, "r");
if (crc32("gsYxsuNCdvNWId",14) == 3342292869) strcat(s, "H");
if (crc32("MENQvYZrBm",10) == 1334816782) strcat(s, "p");
if (crc32("eSvuSn",6) == 2981797218) strcat(s, "l");
if (crc32("gSHZDJBaDnvR",12) == 2902695971) strcat(s, "a");
if (crc32("sYzuPKBiUijwGiy",15) == 3347462067) strcat(s, "t");
if (crc32("YWCfZp",6) == 1885693976) strcat(s, "K");
if (crc32("ulEMALmUfGBvM",13) == 1525857596) strcat(s, "e");
if (crc32("povSfyWMUVHQ",12) == 3354871943) strcat(s, "S");
if (crc32("sUEWfFilXzSKVGW",15) == 2088338089) strcat(s, "d");
    return s;
}

char *ideaful_adjectives() {
    char *s = calloc(8);
    if (crc32("gWmXbtQqkE",10) == 1912982775) strcat(s, "i");
if (crc32("PzlYm",5) == 3808735634) strcat(s, "d");
if (crc32("ISMGb",5) == 784312908) strcat(s, "e");
if (crc32("ShQUbZ",6) == 1462358565) strcat(s, "a");
if (crc32("IHFFdhyW",8) == 4214747288) strcat(s, "f");
if (crc32("lJeujHF",7) == 2429884200) strcat(s, "f");
if (crc32("lGtCOKFOtJP",11) == 3060781655) strcat(s, "u");
if (crc32("HMwffseGgNVMCm",14) == 874699888) strcat(s, "Z");
if (crc32("BwIXhwwyejYuqd",14) == 1135907022) strcat(s, "l");
    return s;
}

char *overinsolent_adjectives() {
    char *s = calloc(13);
    if (crc32("AofETOXhl",9) == 4001109590) strcat(s, "Z");
if (crc32("ADZpnTX",7) == 191576451) strcat(s, "o");
if (crc32("BgoJMp",6) == 3554283182) strcat(s, "v");
if (crc32("aoFhyIErCNuuzIR",15) == 4189114481) strcat(s, "Y");
if (crc32("JEbEGJLOFoTnfjO",15) == 983233787) strcat(s, "e");
if (crc32("oBlMIQ",6) == 2320421932) strcat(s, "D");
if (crc32("nvdoKEWHYYsMt",13) == 255508386) strcat(s, "r");
if (crc32("yxHqiiwI",8) == 492927641) strcat(s, "q");
if (crc32("eQejoZ",6) == 3437977460) strcat(s, "i");
if (crc32("fuAAHLcNVlWbXc",14) == 2090987273) strcat(s, "n");
if (crc32("ozxDmOHxPJDbQvS",15) == 2475882508) strcat(s, "s");
if (crc32("XgdiEXnmSkACQ",13) == 2501457748) strcat(s, "o");
if (crc32("YnpxEm",6) == 865144417) strcat(s, "l");
if (crc32("ywEldGlJEkur",12) == 1805188924) strcat(s, "e");
if (crc32("AYdrCIMYGEfFw",13) == 1637737076) strcat(s, "n");
if (crc32("IkySxhRKeotipb",14) == 2960713648) strcat(s, "t");
    return s;
}

char *heterotrichous_adjectives() {
    char *s = calloc(15);
    if (crc32("pZueoOUEN",9) == 28259756) strcat(s, "S");
if (crc32("HzWXzbtADnKp",12) == 39539521) strcat(s, "h");
if (crc32("iIqUOjbavpL",11) == 2747458119) strcat(s, "e");
if (crc32("BbdYesa",7) == 1081888221) strcat(s, "Y");
if (crc32("NLUtyhBMqPPOXKS",15) == 2481476053) strcat(s, "t");
if (crc32("hhNHvE",6) == 1869061446) strcat(s, "h");
if (crc32("pVmsIFqr",8) == 2571872909) strcat(s, "e");
if (crc32("RxlZSQiRcXG",11) == 553124256) strcat(s, "r");
if (crc32("pzsahhfEqx",10) == 4242696046) strcat(s, "p");
if (crc32("bPDpi",5) == 2183092612) strcat(s, "o");
if (crc32("kuMicxAEtQoiA",13) == 2450856522) strcat(s, "l");
if (crc32("eEOQrD",6) == 3143203426) strcat(s, "t");
if (crc32("kvTQbESxa",9) == 3201907661) strcat(s, "r");
if (crc32("cLCNzWU",7) == 300233830) strcat(s, "Y");
if (crc32("PmCxjKyK",8) == 2913795495) strcat(s, "i");
if (crc32("bBHvWz",6) == 1531486525) strcat(s, "b");
if (crc32("yJRUvMJhfPhvCZ",14) == 130938428) strcat(s, "c");
if (crc32("sewhSCjhrHO",11) == 2836402195) strcat(s, "N");
if (crc32("tfmixuOemp",10) == 3186609283) strcat(s, "h");
if (crc32("OBUuXsslF",9) == 798579543) strcat(s, "x");
if (crc32("vwzdRoSSDcuOy",13) == 3298617284) strcat(s, "o");
if (crc32("JfEInLdlG",9) == 3463075470) strcat(s, "f");
if (crc32("hILtwq",6) == 3317735230) strcat(s, "u");
if (crc32("fuVTn",5) == 1581472464) strcat(s, "M");
if (crc32("mKcrgiVa",8) == 1376850386) strcat(s, "s");
    return s;
}

char *seafaring_adjectives() {
    char *s = calloc(10);
    if (crc32("jzwRKJ",6) == 3080399178) strcat(s, "s");
if (crc32("AsBDEPwXlKysSj",14) == 552638324) strcat(s, "e");
if (crc32("FIpXTpcbDynLF",13) == 2915400448) strcat(s, "a");
if (crc32("hcZokmlFUFtWL",13) == 698224409) strcat(s, "f");
if (crc32("rnZuz",5) == 494566005) strcat(s, "a");
if (crc32("qzQpHEnm",8) == 439510154) strcat(s, "N");
if (crc32("ykIlcwDK",8) == 640661508) strcat(s, "r");
if (crc32("IaEEUpTutaxv",12) == 2336816963) strcat(s, "t");
if (crc32("TpUiKCv",7) == 3925102023) strcat(s, "i");
if (crc32("kjdcWfZWJyQ",11) == 507026682) strcat(s, "i");
if (crc32("NTUBXOhzwvbNy",13) == 3334829273) strcat(s, "n");
if (crc32("WOsPPSv",7) == 3022246253) strcat(s, "g");
    return s;
}

char *nonpenal_adjectives() {
    char *s = calloc(9);
    if (crc32("czpmqlgDguk",11) == 929741428) strcat(s, "n");
if (crc32("RAFaobFID",9) == 591166661) strcat(s, "v");
if (crc32("yQFZLD",6) == 1790259926) strcat(s, "o");
if (crc32("xFPhgxsTh",9) == 3412221588) strcat(s, "n");
if (crc32("dOQlGfck",8) == 209028465) strcat(s, "k");
if (crc32("FwvKcQE",7) == 2039530596) strcat(s, "p");
if (crc32("IcqKdefd",8) == 2310997170) strcat(s, "i");
if (crc32("zQIZnVa",7) == 2011698049) strcat(s, "e");
if (crc32("OeMlMOPsGQArS",13) == 1969038049) strcat(s, "o");
if (crc32("oRqsCfhEMshixqZ",15) == 2254290470) strcat(s, "n");
if (crc32("HxeqBeJjShKRyCQ",15) == 4056481967) strcat(s, "R");
if (crc32("BTwTg",5) == 4240537279) strcat(s, "a");
if (crc32("VNLqv",5) == 4235725410) strcat(s, "l");
    return s;
}

char *specific_adjectives() {
    char *s = calloc(9);
    if (crc32("danKSjnPXPvcpgG",15) == 2724538727) strcat(s, "W");
if (crc32("njbyCqoklWnYwe",14) == 3780080601) strcat(s, "s");
if (crc32("tNCODVSDLr",10) == 3737702450) strcat(s, "I");
if (crc32("lDaEhkhQZmeNa",13) == 4120684559) strcat(s, "p");
if (crc32("BnydqMm",7) == 526850340) strcat(s, "e");
if (crc32("tTLlOgGLLAwXyn",14) == 2920632426) strcat(s, "c");
if (crc32("HGJREF",6) == 3172818877) strcat(s, "B");
if (crc32("WzOyhXDfJUhAl",13) == 4039073136) strcat(s, "i");
if (crc32("nvWOWNaLhVuM",12) == 528237927) strcat(s, "G");
if (crc32("IftogqBcNEOil",13) == 1508669221) strcat(s, "f");
if (crc32("hjhLTb",6) == 2090758164) strcat(s, "i");
if (crc32("OZlxTPqpg",9) == 669480840) strcat(s, "c");
    return s;
}

char *gradely_adjectives() {
    char *s = calloc(8);
    if (crc32("sEpQuiPegcu",11) == 2610720993) strcat(s, "g");
if (crc32("CFpGguvKiD",10) == 3315985508) strcat(s, "r");
if (crc32("ZWZjhMSdBXG",11) == 631589464) strcat(s, "a");
if (crc32("geGtyc",6) == 2325492777) strcat(s, "d");
if (crc32("lJwVxhNhYxNfqjt",15) == 4045638211) strcat(s, "e");
if (crc32("ssgRPsvGucDvw",13) == 2328817763) strcat(s, "l");
if (crc32("KJzSI",5) == 3402158440) strcat(s, "E");
if (crc32("oCyyQ",5) == 3981447248) strcat(s, "y");
    return s;
}

char *quasiconverted_adjectives() {
    char *s = calloc(15);
    if (crc32("UyynDDmUPJHskal",15) == 2345593397) strcat(s, "Q");
if (crc32("EznzDnSKFRONJyK",15) == 520337034) strcat(s, "q");
if (crc32("biGaYwlnNUDkL",13) == 2249898048) strcat(s, "u");
if (crc32("PZTaqirjW",9) == 2029993209) strcat(s, "D");
if (crc32("gpXnbYEcHgNU",12) == 605584118) strcat(s, "a");
if (crc32("vfjTO",5) == 3540631562) strcat(s, "s");
if (crc32("ABRLJJxqlgmyWE",14) == 3952998636) strcat(s, "f");
if (crc32("TemmhiIsVsyAF",13) == 1592885068) strcat(s, "i");
if (crc32("TIFEajregzh",11) == 729226644) strcat(s, "c");
if (crc32("rWESeYsDGTA",11) == 729770137) strcat(s, "c");
if (crc32("goGZYJrJdQk",11) == 2476587919) strcat(s, "W");
if (crc32("InMtvSIX",8) == 1397238921) strcat(s, "o");
if (crc32("KaEGtgx",7) == 2843890013) strcat(s, "n");
if (crc32("pvOBu",5) == 2953402417) strcat(s, "K");
if (crc32("zBtPNsiUwIsKGE",14) == 1675354138) strcat(s, "v");
if (crc32("LGebmCs",7) == 2653968673) strcat(s, "e");
if (crc32("VmDqYxFOqzeETZ",14) == 1148391023) strcat(s, "r");
if (crc32("HllUfJmUKCxk",12) == 1430494182) strcat(s, "t");
if (crc32("FSOGtaUjVnfXz",13) == 3957451679) strcat(s, "e");
if (crc32("UULEScROf",9) == 4112312680) strcat(s, "d");
    return s;
}

char *intoxicated_adjectives() {
    char *s = calloc(12);
    if (crc32("oOdJofp",7) == 2796421919) strcat(s, "i");
if (crc32("jLqnASwbZmNBse",14) == 1754853831) strcat(s, "n");
if (crc32("JxMZdxyDXpmsG",13) == 1799725625) strcat(s, "l");
if (crc32("EmqMiyTrzw",10) == 2692860626) strcat(s, "t");
if (crc32("JpIHYWLNmfzQE",13) == 992997840) strcat(s, "O");
if (crc32("DEAZsvyUXuxQA",13) == 1237923349) strcat(s, "o");
if (crc32("QkZKqjDKcQiH",12) == 977079063) strcat(s, "H");
if (crc32("liJhAWq",7) == 2985317815) strcat(s, "x");
if (crc32("oxMurZxQq",9) == 1266985234) strcat(s, "x");
if (crc32("BqDwSDbDspO",11) == 928552463) strcat(s, "i");
if (crc32("lUeZFmTFLWcU",12) == 654954932) strcat(s, "c");
if (crc32("wIGUTcP",7) == 3304783434) strcat(s, "a");
if (crc32("JJODWxZDtbzXixG",15) == 370784491) strcat(s, "t");
if (crc32("MAPdkcwHWtfoU",13) == 3128404602) strcat(s, "b");
if (crc32("qObfHUUdVRX",11) == 3046594123) strcat(s, "e");
if (crc32("CqHHSIstaLrIq",13) == 1111855902) strcat(s, "R");
if (crc32("ysZWeSV",7) == 282142213) strcat(s, "d");
    return s;
}

char *unconciliable_adjectives() {
    char *s = calloc(14);
    if (crc32("bqQWzMzrXEXyTCa",15) == 1189749309) strcat(s, "J");
if (crc32("eMtjJRNqyS",10) == 842175978) strcat(s, "u");
if (crc32("zqzrC",5) == 226045522) strcat(s, "n");
if (crc32("oUMNGxS",7) == 2410230492) strcat(s, "U");
if (crc32("QDzJl",5) == 3235101046) strcat(s, "c");
if (crc32("oMQwNpKpVoZLzBt",15) == 3884915534) strcat(s, "o");
if (crc32("TDYhWPG",7) == 777951652) strcat(s, "n");
if (crc32("kpyHy",5) == 161894039) strcat(s, "c");
if (crc32("qrelxCoJYi",10) == 2756150337) strcat(s, "V");
if (crc32("HgnZblvbCpuX",12) == 385809313) strcat(s, "i");
if (crc32("WaBNfNoTfyPGA",13) == 3551906679) strcat(s, "d");
if (crc32("daygcXbUWaunhjj",15) == 3639519596) strcat(s, "l");
if (crc32("MTZdIVwBOr",10) == 1817290034) strcat(s, "Z");
if (crc32("GPNzxjsLUYvpDKQ",15) == 582991682) strcat(s, "i");
if (crc32("CKfKrIQOKoKZg",13) == 2109235816) strcat(s, "i");
if (crc32("AxXVz",5) == 866390895) strcat(s, "a");
if (crc32("JZOWfJIChH",10) == 380408579) strcat(s, "b");
if (crc32("TGpKLhBjuDigwr",14) == 4006245717) strcat(s, "M");
if (crc32("uZXYZQ",6) == 2841775221) strcat(s, "l");
if (crc32("wJgYbDNlciJdK",13) == 2670158463) strcat(s, "e");
    return s;
}

char *equitable_adjectives() {
    char *s = calloc(10);
    if (crc32("ltcUamHH",8) == 4287353745) strcat(s, "L");
if (crc32("doslpvINk",9) == 816578589) strcat(s, "e");
if (crc32("cMzkM",5) == 1719455817) strcat(s, "e");
if (crc32("yuZAitXaqW",10) == 3528901466) strcat(s, "q");
if (crc32("KBdZILUeMeDCu",13) == 4152998674) strcat(s, "d");
if (crc32("HzBaU",5) == 3201958494) strcat(s, "u");
if (crc32("CVvygZjT",8) == 1959105633) strcat(s, "H");
if (crc32("qacmX",5) == 2121799505) strcat(s, "i");
if (crc32("zDoCSMHWgp",10) == 2586104005) strcat(s, "t");
if (crc32("bYEHBpUFdt",10) == 2012718292) strcat(s, "S");
if (crc32("ebCzqGOS",8) == 4168852462) strcat(s, "a");
if (crc32("KnCrW",5) == 2820862671) strcat(s, "b");
if (crc32("ZSgdQ",5) == 1523321731) strcat(s, "n");
if (crc32("ZsJMFMV",7) == 1602937371) strcat(s, "l");
if (crc32("qNMEnJdbrS",10) == 975933855) strcat(s, "q");
if (crc32("WWddNYu",7) == 2205237941) strcat(s, "e");
    return s;
}

char *proevolutionist_adjectives() {
    char *s = calloc(16);
    if (crc32("NCziLnvSWjI",11) == 3615705941) strcat(s, "p");
if (crc32("EoDbQFCFofcYqI",14) == 141501056) strcat(s, "V");
if (crc32("NzSQfgKPT",9) == 47681236) strcat(s, "r");
if (crc32("QmpJrHymnRa",11) == 1759053715) strcat(s, "H");
if (crc32("tLayvUtLCuNJf",13) == 2992997766) strcat(s, "o");
if (crc32("EpAkg",5) == 2023557066) strcat(s, "c");
if (crc32("nZkscJ",6) == 2480287234) strcat(s, "e");
if (crc32("ZTPdt",5) == 2883566082) strcat(s, "r");
if (crc32("YjjDch",6) == 1735422981) strcat(s, "v");
if (crc32("YCmyZlEgjVKl",12) == 2061509783) strcat(s, "o");
if (crc32("CoZaIL",6) == 2395811537) strcat(s, "Y");
if (crc32("LqGWfAYChxH",11) == 44767944) strcat(s, "l");
if (crc32("UCmprhOsrjpdUZ",14) == 1546509119) strcat(s, "Q");
if (crc32("HinWRlT",7) == 2145193821) strcat(s, "u");
if (crc32("nMbnpuOb",8) == 2675323702) strcat(s, "n");
if (crc32("OnrwYUYs",8) == 1024049773) strcat(s, "t");
if (crc32("RtScjcSVl",9) == 853810339) strcat(s, "i");
if (crc32("vCoKWFwA",8) == 4011303955) strcat(s, "o");
if (crc32("lgZuVEqlymjHXb",14) == 3850693226) strcat(s, "i");
if (crc32("tSfQzIIXJJnb",12) == 423916173) strcat(s, "n");
if (crc32("JBOSMpbLAGLDC",13) == 1420681667) strcat(s, "e");
if (crc32("OIxGyfJ",7) == 915897776) strcat(s, "i");
if (crc32("TFFnsflsu",9) == 4142878421) strcat(s, "s");
if (crc32("qwwnlpZs",8) == 2723431116) strcat(s, "b");
if (crc32("EVfOpmUzKDH",11) == 2616735567) strcat(s, "t");
    return s;
}

char *unavoiding_adjectives() {
    char *s = calloc(11);
    if (crc32("qMHsjyVKclh",11) == 121632994) strcat(s, "L");
if (crc32("bXUJwmX",7) == 2174698035) strcat(s, "u");
if (crc32("xqwTxJNCstYf",12) == 4292926386) strcat(s, "k");
if (crc32("TUKdjf",6) == 3995488377) strcat(s, "n");
if (crc32("VpqsN",5) == 3658164527) strcat(s, "a");
if (crc32("JXNKyizOKJXPQ",13) == 1794455742) strcat(s, "v");
if (crc32("mZDjaHslQAPO",12) == 3163359333) strcat(s, "K");
if (crc32("SothaQWRXbSpXrf",15) == 2586606090) strcat(s, "o");
if (crc32("DfhCi",5) == 3705863913) strcat(s, "i");
if (crc32("wWrRtDGhrwq",11) == 2795929879) strcat(s, "d");
if (crc32("zfLWjhL",7) == 1460575469) strcat(s, "i");
if (crc32("WARxjU",6) == 2049912962) strcat(s, "n");
if (crc32("IzQPTJOLBGDG",12) == 2221498946) strcat(s, "g");
    return s;
}

char *saprogenic_adjectives() {
    char *s = calloc(11);
    if (crc32("EBEsVTRAHgrJQx",14) == 3790047980) strcat(s, "s");
if (crc32("ZdlKojX",7) == 542291789) strcat(s, "a");
if (crc32("fvvaSuu",7) == 2547090335) strcat(s, "R");
if (crc32("pSXFO",5) == 3299310612) strcat(s, "p");
if (crc32("TJYCxB",6) == 2406681433) strcat(s, "r");
if (crc32("qTPBfhymf",9) == 1991943053) strcat(s, "o");
if (crc32("XKBxiuylrBkiaw",14) == 312771712) strcat(s, "g");
if (crc32("QhwMQgmWUvSszC",14) == 4131791980) strcat(s, "X");
if (crc32("eOVPRLRXgzPI",12) == 3748513595) strcat(s, "e");
if (crc32("buHsFbSwHTYcpN",14) == 897322327) strcat(s, "n");
if (crc32("dUBCxdbqfn",10) == 3412754817) strcat(s, "i");
if (crc32("khYbxG",6) == 3014301081) strcat(s, "B");
if (crc32("eZWuNRMgWBPMt",13) == 2136093980) strcat(s, "c");
    return s;
}

char *roughdry_adjectives() {
    char *s = calloc(9);
    if (crc32("VWIsloUgmdIfBue",15) == 1954210220) strcat(s, "r");
if (crc32("LOQCPcGBNaCUMo",14) == 239388013) strcat(s, "r");
if (crc32("YTzUeocCimk",11) == 3968221055) strcat(s, "s");
if (crc32("jJhHVIyjnwdUgVG",15) == 4168284973) strcat(s, "o");
if (crc32("iwKuOWCwxHnVYr",14) == 3827596575) strcat(s, "u");
if (crc32("HbDSeby",7) == 2302607805) strcat(s, "y");
if (crc32("JWNUxTkn",8) == 395382270) strcat(s, "g");
if (crc32("PjsykO",6) == 2049802326) strcat(s, "I");
if (crc32("LztjGylTr",9) == 2407686314) strcat(s, "h");
if (crc32("SnPIXZdVNgWj",12) == 1492828073) strcat(s, "l");
if (crc32("ywBlKwwhW",9) == 1616967816) strcat(s, "d");
if (crc32("floHrs",6) == 1910512724) strcat(s, "J");
if (crc32("BFoWXueqBv",10) == 3371809205) strcat(s, "r");
if (crc32("DyQkEGbBANy",11) == 253232254) strcat(s, "y");
    return s;
}

char *snide_adjectives() {
    char *s = calloc(6);
    if (crc32("WgbVeHlBnhCFBQ",14) == 802046977) strcat(s, "r");
if (crc32("GxUopQNfAw",10) == 2859220273) strcat(s, "s");
if (crc32("AheVqiIJJyAfCQw",15) == 2608911148) strcat(s, "f");
if (crc32("scgOTLQXOaZ",11) == 3598510133) strcat(s, "n");
if (crc32("TbpbMjXmakz",11) == 1860733426) strcat(s, "z");
if (crc32("UWHZxmaIF",9) == 2887897065) strcat(s, "i");
if (crc32("kLvYwFD",7) == 721177582) strcat(s, "d");
if (crc32("VUcPuukPT",9) == 865115316) strcat(s, "n");
if (crc32("qZnatBrCRqkltQw",15) == 2722520454) strcat(s, "e");
    return s;
}

char *wellcommanded_adjectives() {
    char *s = calloc(14);
    if (crc32("jONXFmfBytA",11) == 2208875308) strcat(s, "w");
if (crc32("pRWODTkhTcEoAb",14) == 896275310) strcat(s, "J");
if (crc32("rwHdXos",7) == 1706915903) strcat(s, "e");
if (crc32("MHzmfZ",6) == 2517878745) strcat(s, "l");
if (crc32("UnGojlTf",8) == 2362941897) strcat(s, "A");
if (crc32("KpJyUOuMBuIVjjm",15) == 2748915582) strcat(s, "l");
if (crc32("Rhieui",6) == 3440072604) strcat(s, "V");
if (crc32("WGTSeEYnWxhgNW",14) == 1331639490) strcat(s, "c");
if (crc32("YDzeZ",5) == 577411399) strcat(s, "v");
if (crc32("krAqgGFjr",9) == 2358744069) strcat(s, "o");
if (crc32("nRMjkMZYG",9) == 4267048312) strcat(s, "R");
if (crc32("bZEzfTfPirVkbM",14) == 2754420943) strcat(s, "m");
if (crc32("EvZjUSJpgrypH",13) == 3698566044) strcat(s, "l");
if (crc32("IbienyvkCckOdrk",15) == 1729701502) strcat(s, "m");
if (crc32("FiJnzDQq",8) == 663638612) strcat(s, "G");
if (crc32("UbeLRPJSiZeTDYs",15) == 1534639903) strcat(s, "a");
if (crc32("wBGzQUZ",7) == 963513185) strcat(s, "n");
if (crc32("nhggXn",6) == 1643187417) strcat(s, "a");
if (crc32("EnNChOlVDQgQE",13) == 680392961) strcat(s, "d");
if (crc32("xbwaxUxhZJcb",12) == 2048669007) strcat(s, "e");
if (crc32("EeknliSuVTDArTR",15) == 396078796) strcat(s, "E");
if (crc32("MkUZIlowAITiP",13) == 2718464083) strcat(s, "d");
    return s;
}

char *primeministerial_adjectives() {
    char *s = calloc(17);
    if (crc32("JBLCHoOgxORkAj",14) == 158141191) strcat(s, "p");
if (crc32("SiIHtqw",7) == 5526664) strcat(s, "r");
if (crc32("gnfhecxhmbOiE",13) == 2377412317) strcat(s, "i");
if (crc32("HTuDqDCGOV",10) == 1899829942) strcat(s, "m");
if (crc32("VczAq",5) == 3487844339) strcat(s, "e");
if (crc32("etFrvlKXe",9) == 1192186787) strcat(s, "j");
if (crc32("wuTVIwfiXxGuBNX",15) == 1582779695) strcat(s, "m");
if (crc32("exIvqSWsTiRIo",13) == 658121292) strcat(s, "i");
if (crc32("lXkgMrcmLBpGmV",14) == 1785322755) strcat(s, "N");
if (crc32("PfCjFNi",7) == 90154357) strcat(s, "n");
if (crc32("zbpNthXq",8) == 1602478001) strcat(s, "i");
if (crc32("fNbuYuBOQRZbRR",14) == 1075711143) strcat(s, "r");
if (crc32("ZOLGAHRNVXN",11) == 914489126) strcat(s, "s");
if (crc32("uwaij",5) == 1513594426) strcat(s, "o");
if (crc32("AMXgYaycE",9) == 1030533020) strcat(s, "t");
if (crc32("DfYEvkYQPSO",11) == 3725801409) strcat(s, "e");
if (crc32("MeAJlWQfzbAY",12) == 3662993081) strcat(s, "a");
if (crc32("ddrZUMmtICjSB",13) == 2195406927) strcat(s, "r");
if (crc32("bDamV",5) == 719871078) strcat(s, "i");
if (crc32("RlVJsxUeK",9) == 1261882150) strcat(s, "i");
if (crc32("aXJHnoWSZS",10) == 2014748089) strcat(s, "a");
if (crc32("LpQKnjZOExqPBr",14) == 2403008874) strcat(s, "i");
if (crc32("dfaOurjjeHXpRJA",15) == 840905597) strcat(s, "l");
    return s;
}

char *halfHessian_adjectives() {
    char *s = calloc(12);
    if (crc32("hRJLMItJ",8) == 717824616) strcat(s, "h");
if (crc32("QVpIkKH",7) == 3642881111) strcat(s, "E");
if (crc32("tJuHGuIdSbguhYr",15) == 588123243) strcat(s, "a");
if (crc32("YLQoWiMweyWN",12) == 3303252839) strcat(s, "U");
if (crc32("iYRRIKFn",8) == 2309237888) strcat(s, "l");
if (crc32("RPfEnzaYepA",11) == 3218759959) strcat(s, "f");
if (crc32("mGxzf",5) == 2325760156) strcat(s, "H");
if (crc32("YVwgPvEqUMEzz",13) == 4076013435) strcat(s, "e");
if (crc32("RKxLg",5) == 488405392) strcat(s, "s");
if (crc32("JdspiIxN",8) == 3318116376) strcat(s, "R");
if (crc32("wtJQSlvmkPlO",12) == 228320437) strcat(s, "s");
if (crc32("ZOegX",5) == 3532929223) strcat(s, "N");
if (crc32("WLJaTEE",7) == 1917885165) strcat(s, "i");
if (crc32("evkhsVk",7) == 1749782210) strcat(s, "W");
if (crc32("sgjsIwwOBkiSuY",14) == 3077717267) strcat(s, "a");
if (crc32("SDNkBhUuJZXlhkk",15) == 2964881935) strcat(s, "n");
    return s;
}

char *fourth_adjectives() {
    char *s = calloc(7);
    if (crc32("UImFJ",5) == 4146881350) strcat(s, "J");
if (crc32("EMvSaiBorNpacyM",15) == 1156826518) strcat(s, "f");
if (crc32("FNXKj",5) == 2479373445) strcat(s, "D");
if (crc32("vXPDZzJumzoRr",13) == 2980582397) strcat(s, "o");
if (crc32("MGQnqcs",7) == 2793967069) strcat(s, "u");
if (crc32("FaytrobaHCXGU",13) == 1839418895) strcat(s, "T");
if (crc32("NltYJyPvjINrP",13) == 1363730619) strcat(s, "r");
if (crc32("kUeqCkSOczmUy",13) == 3525310932) strcat(s, "c");
if (crc32("ByCwgjwUbyRkw",13) == 3997792481) strcat(s, "t");
if (crc32("zOkantgslRiYVEO",15) == 4193079257) strcat(s, "i");
if (crc32("tgGKhqaut",9) == 1135606905) strcat(s, "h");
    return s;
}

char *cryptovolcanic_adjectives() {
    char *s = calloc(15);
    if (crc32("VnIpzBdtk",9) == 2480357843) strcat(s, "x");
if (crc32("JqbhiQqSQfreWm",14) == 2839970552) strcat(s, "c");
if (crc32("ltyYbLdssBP",11) == 1987906584) strcat(s, "c");
if (crc32("AWFiHSWwrw",10) == 1034510644) strcat(s, "r");
if (crc32("QPLWIbq",7) == 2853497951) strcat(s, "E");
if (crc32("hdGrcpKniCh",11) == 2542218602) strcat(s, "y");
if (crc32("MxxAhPdFoJYHl",13) == 1431002675) strcat(s, "D");
if (crc32("LNXzomN",7) == 633903869) strcat(s, "p");
if (crc32("MdqSpkGsYgEcSw",14) == 1685547919) strcat(s, "o");
if (crc32("ZoEaTZCH",8) == 2716479422) strcat(s, "t");
if (crc32("GwDAWmV",7) == 3214192959) strcat(s, "o");
if (crc32("oAHGRnhgZ",9) == 3914524206) strcat(s, "x");
if (crc32("OPCNlQtzR",9) == 3733699813) strcat(s, "v");
if (crc32("AdvSCMoHXdU",11) == 126160763) strcat(s, "o");
if (crc32("mCqrrJS",7) == 1402629880) strcat(s, "Z");
if (crc32("uAEDMFJHgypteR",14) == 1548953500) strcat(s, "l");
if (crc32("gAeDNwvrUnAa",12) == 2902333799) strcat(s, "q");
if (crc32("QowOHyBOHND",11) == 1298894215) strcat(s, "c");
if (crc32("plJhBvM",7) == 1984898950) strcat(s, "C");
if (crc32("seRjziLZLOlqO",13) == 365273114) strcat(s, "a");
if (crc32("EbcJrkToPLW",11) == 1691767097) strcat(s, "G");
if (crc32("vBLLMbtscpGVTc",14) == 144417644) strcat(s, "n");
if (crc32("xSYQPZ",6) == 2148489105) strcat(s, "x");
if (crc32("lAvGjYbfdEPf",12) == 2025336885) strcat(s, "i");
if (crc32("JGdwOvEa",8) == 2700381487) strcat(s, "c");
    return s;
}

char *insomnious_adjectives() {
    char *s = calloc(11);
    if (crc32("vuvCHyhsg",9) == 1757418526) strcat(s, "i");
if (crc32("wNHBIpIZF",9) == 3855910788) strcat(s, "n");
if (crc32("kCJPPHY",7) == 4184164993) strcat(s, "I");
if (crc32("kZPqk",5) == 210272336) strcat(s, "s");
if (crc32("IEXbrsr",7) == 1819120032) strcat(s, "r");
if (crc32("lkBfl",5) == 1920640431) strcat(s, "o");
if (crc32("wMOyVPQzMEmqg",13) == 4226948717) strcat(s, "m");
if (crc32("TraZgGA",7) == 1751225580) strcat(s, "j");
if (crc32("VSLBFBFPmpkWp",13) == 2909143232) strcat(s, "n");
if (crc32("yhEnBUyfivdtvq",14) == 3802531729) strcat(s, "U");
if (crc32("iMOaKzskeRrzYUD",15) == 2788391537) strcat(s, "i");
if (crc32("HnjMN",5) == 1593227638) strcat(s, "A");
if (crc32("JwiesxHzrVApcc",14) == 3911484118) strcat(s, "o");
if (crc32("rIXbZdRbiQb",11) == 98799500) strcat(s, "i");
if (crc32("aUEbBQNvIOb",11) == 3052148493) strcat(s, "u");
if (crc32("IeVkHOFymumH",12) == 3647018781) strcat(s, "F");
if (crc32("JKzNTG",6) == 2026589600) strcat(s, "s");
    return s;
}

char *sphenoid_adjectives() {
    char *s = calloc(9);
    if (crc32("nXdvWXobWzMv",12) == 2247794748) strcat(s, "s");
if (crc32("SzXhLlAl",8) == 2187695305) strcat(s, "p");
if (crc32("PJmrsYkjr",9) == 3982583769) strcat(s, "h");
if (crc32("hsnstWLISW",10) == 3038918125) strcat(s, "Y");
if (crc32("OtNwCZBeGRD",11) == 461656140) strcat(s, "e");
if (crc32("KvASdQZmK",9) == 4158818857) strcat(s, "n");
if (crc32("OCKvFOdmP",9) == 1082090678) strcat(s, "f");
if (crc32("rJMMCDFMuIVEzGN",15) == 2208635233) strcat(s, "o");
if (crc32("XEruRC",6) == 2029456261) strcat(s, "b");
if (crc32("mQuGjSptXSryR",13) == 2171535957) strcat(s, "i");
if (crc32("EQWEUXtVdP",10) == 89577078) strcat(s, "d");
    return s;
}

char *unresinous_adjectives() {
    char *s = calloc(11);
    if (crc32("didFAkLJ",8) == 2694351605) strcat(s, "L");
if (crc32("BxrIw",5) == 4063615146) strcat(s, "u");
if (crc32("kgopdrIymOB",11) == 2048945688) strcat(s, "E");
if (crc32("RuERYtziuZN",11) == 2290874752) strcat(s, "n");
if (crc32("EOGDFasrrWkA",12) == 2512433131) strcat(s, "G");
if (crc32("rQQORYJ",7) == 1963319155) strcat(s, "r");
if (crc32("OdsAIqUfLyb",11) == 412648601) strcat(s, "i");
if (crc32("kLaoxJxeFTIUx",13) == 1670161162) strcat(s, "e");
if (crc32("URnvk",5) == 3063541765) strcat(s, "s");
if (crc32("OcxEGnCmXtyATON",15) == 3075743787) strcat(s, "i");
if (crc32("qEIWfGN",7) == 3923349722) strcat(s, "n");
if (crc32("kkoqNhFUlxEL",12) == 2552388735) strcat(s, "l");
if (crc32("vjUOT",5) == 2512117609) strcat(s, "o");
if (crc32("qkjZQhJuttyl",12) == 621734461) strcat(s, "u");
if (crc32("mJWzcWYBR",9) == 331114240) strcat(s, "s");
    return s;
}

char *detectible_adjectives() {
    char *s = calloc(11);
    if (crc32("vOUnyfdPQz",10) == 779026258) strcat(s, "d");
if (crc32("AGMaHAHhKSKQ",12) == 1887404810) strcat(s, "e");
if (crc32("rLRLyhsd",8) == 3397890247) strcat(s, "t");
if (crc32("IfNiUNvWROCf",12) == 3528174065) strcat(s, "L");
if (crc32("gZEwNtnBtUo",11) == 1416623914) strcat(s, "e");
if (crc32("IVvDbq",6) == 1741181631) strcat(s, "c");
if (crc32("lhHxN",5) == 2143048987) strcat(s, "Z");
if (crc32("xiXRuySdGf",10) == 3875490523) strcat(s, "t");
if (crc32("WQEsT",5) == 4110598248) strcat(s, "N");
if (crc32("BXvRmWjMVKY",11) == 4089925216) strcat(s, "i");
if (crc32("VMCXqFo",7) == 862372331) strcat(s, "V");
if (crc32("noihpUdIOSdRjJ",14) == 4176883232) strcat(s, "b");
if (crc32("hmStecQiTMl",11) == 859507325) strcat(s, "v");
if (crc32("uYgVqgQf",8) == 202857300) strcat(s, "l");
if (crc32("KHOUbyTBacLuKnS",15) == 777292783) strcat(s, "Q");
if (crc32("NzqBKuWcgVLfg",13) == 2942433052) strcat(s, "e");
    return s;
}

char *aw_adjectives() {
    char *s = calloc(3);
    if (crc32("ZlfVuG",6) == 1181969661) strcat(s, "i");
if (crc32("jYtmvOR",7) == 4274883531) strcat(s, "a");
if (crc32("fbbqMMwlXfAYK",13) == 1384503046) strcat(s, "w");
    return s;
}

char *undualistic_adjectives() {
    char *s = calloc(12);
    if (crc32("UPsiUZoP",8) == 2858411991) strcat(s, "k");
if (crc32("ggrjfyJGHUfBjr",14) == 3617288034) strcat(s, "u");
if (crc32("FTgCZejbLdDaowu",15) == 4276710833) strcat(s, "n");
if (crc32("bgYjoekIfGT",11) == 1449500928) strcat(s, "P");
if (crc32("nbHvQyDzUtK",11) == 1930832221) strcat(s, "d");
if (crc32("qFcmmiEQlF",10) == 1982625042) strcat(s, "B");
if (crc32("dyeCkDcnGWuZ",12) == 643709231) strcat(s, "u");
if (crc32("MrPBulzkcUQeSYS",15) == 3024692184) strcat(s, "P");
if (crc32("EVNoMpQDKjrpIpM",15) == 2432142354) strcat(s, "a");
if (crc32("XEWoVeXBjssj",12) == 501217241) strcat(s, "l");
if (crc32("NVOBNdF",7) == 1545310034) strcat(s, "i");
if (crc32("VpolEDusrTHf",12) == 4104825313) strcat(s, "o");
if (crc32("oDbgNtO",7) == 3865837734) strcat(s, "s");
if (crc32("LNsdstdizlkcF",13) == 3575047202) strcat(s, "j");
if (crc32("HIgTAzQYmv",10) == 535651268) strcat(s, "t");
if (crc32("vffSIvKlKXNn",12) == 4120405328) strcat(s, "i");
if (crc32("kamMcMfcWSiJnD",14) == 203009498) strcat(s, "c");
    return s;
}

char *iffy_adjectives() {
    char *s = calloc(5);
    if (crc32("QJmlUfebrTTv",12) == 202309464) strcat(s, "E");
if (crc32("RURrmdVMto",10) == 3539487836) strcat(s, "i");
if (crc32("ekWgk",5) == 3807904423) strcat(s, "f");
if (crc32("JYvhBaUQhVmOu",13) == 4151081400) strcat(s, "f");
if (crc32("XMgPvr",6) == 4234123435) strcat(s, "y");
    return s;
}

char *resigned_adjectives() {
    char *s = calloc(9);
    if (crc32("ecXLAry",7) == 1454085980) strcat(s, "r");
if (crc32("DEmTpevFyWCCc",13) == 268782368) strcat(s, "e");
if (crc32("YckSGmogERwNj",13) == 89634198) strcat(s, "s");
if (crc32("xFQdg",5) == 247874861) strcat(s, "i");
if (crc32("OsHmsEaYPlixO",13) == 800904101) strcat(s, "g");
if (crc32("CJauCNDsFchgZ",13) == 2873165916) strcat(s, "n");
if (crc32("yjcVbbykq",9) == 1439080788) strcat(s, "y");
if (crc32("VDSixYTlkqOBN",13) == 3856807891) strcat(s, "e");
if (crc32("vKsPRzFfyjbCU",13) == 3804699545) strcat(s, "L");
if (crc32("fKWmwkxKLLRNzZ",14) == 2142167288) strcat(s, "d");
    return s;
}

char *wavelike_adjectives() {
    char *s = calloc(9);
    if (crc32("qdENjOeaasTML",13) == 3408443804) strcat(s, "w");
if (crc32("IWjDwsafp",9) == 2394215049) strcat(s, "D");
if (crc32("pEqVE",5) == 744419959) strcat(s, "a");
if (crc32("DFDiq",5) == 1791598739) strcat(s, "u");
if (crc32("tScmlVefSRsCQrY",15) == 3984693126) strcat(s, "v");
if (crc32("PNPTvLJ",7) == 1692870110) strcat(s, "y");
if (crc32("PwzItjedM",9) == 1302909629) strcat(s, "e");
if (crc32("fjDNlrXEQyD",11) == 2179230221) strcat(s, "n");
if (crc32("cwHDEEVtX",9) == 3159624226) strcat(s, "l");
if (crc32("UtXHMjWacgEJ",12) == 946908100) strcat(s, "h");
if (crc32("UaipioMkJqRIahL",15) == 1619786738) strcat(s, "i");
if (crc32("fmgjrqoAXpH",11) == 939670967) strcat(s, "k");
if (crc32("KKIKmwr",7) == 2785948169) strcat(s, "L");
if (crc32("VvwUookVGeYTwv",14) == 1691160021) strcat(s, "e");
    return s;
}

char *superstrenuous_adjectives() {
    char *s = calloc(15);
    if (crc32("sYQlcnYJW",9) == 105239867) strcat(s, "s");
if (crc32("NquEKUXLx",9) == 1243630630) strcat(s, "s");
if (crc32("pkVLQkvFGlEsbI",14) == 4107788143) strcat(s, "u");
if (crc32("KXDsxLzOAIWDzH",14) == 94734710) strcat(s, "C");
if (crc32("nPYpCRokxi",10) == 3349620986) strcat(s, "p");
if (crc32("dIIwMMx",7) == 1686746493) strcat(s, "v");
if (crc32("gFeds",5) == 3587103823) strcat(s, "e");
if (crc32("WOyJXg",6) == 2959381203) strcat(s, "r");
if (crc32("SVQPMWRFHvli",12) == 3042601091) strcat(s, "s");
if (crc32("enUGIfYsDscaqO",14) == 910075435) strcat(s, "t");
if (crc32("tajVT",5) == 2353856701) strcat(s, "r");
if (crc32("RXBLLURTLHt",11) == 2698799373) strcat(s, "e");
if (crc32("tRiHuAdXRzJNjlo",15) == 1407201961) strcat(s, "D");
if (crc32("RVCeKUtvOLoCJ",13) == 1282072922) strcat(s, "n");
if (crc32("ZfUoZHSqXJfK",12) == 4208661397) strcat(s, "g");
if (crc32("gDKdLIkYlPXwW",13) == 2929821151) strcat(s, "u");
if (crc32("qpLFlPDuJcAS",12) == 1941664129) strcat(s, "G");
if (crc32("ppQRswRaviRqr",13) == 1525261060) strcat(s, "o");
if (crc32("rfOFggoUzMfT",12) == 2012447365) strcat(s, "u");
if (crc32("KCMnow",6) == 3426585768) strcat(s, "s");
    return s;
}

char *wheezy_adjectives() {
    char *s = calloc(7);
    if (crc32("tFCOrnHIOu",10) == 1002797244) strcat(s, "a");
if (crc32("mrQbcEVEDk",10) == 1414669624) strcat(s, "w");
if (crc32("nLbovTGAqrMG",12) == 188323716) strcat(s, "l");
if (crc32("GMlIXOm",7) == 865415655) strcat(s, "h");
if (crc32("HwQRiJ",6) == 663027460) strcat(s, "e");
if (crc32("PZFiuzaLvAY",11) == 368267505) strcat(s, "e");
if (crc32("mCjBFMkVeaiQ",12) == 1464650423) strcat(s, "S");
if (crc32("neWjtMUM",8) == 3900367973) strcat(s, "z");
if (crc32("IYGrUX",6) == 1830087829) strcat(s, "E");
if (crc32("OeSywDVM",8) == 1463742027) strcat(s, "y");
    return s;
}

char *nondynamical_adjectives() {
    char *s = calloc(13);
    if (crc32("QnHqCYzjjPwMlw",14) == 2885003508) strcat(s, "y");
if (crc32("ggCSWUBYz",9) == 629903110) strcat(s, "n");
if (crc32("OteeK",5) == 1329856895) strcat(s, "o");
if (crc32("RDwQASezvoOWQI",14) == 3525879841) strcat(s, "p");
if (crc32("oAPYiyxkjf",10) == 3809953971) strcat(s, "n");
if (crc32("BqnZOITdZgQ",11) == 408365651) strcat(s, "d");
if (crc32("blRLdIYlURnefT",14) == 1650699330) strcat(s, "V");
if (crc32("uuifpGnpbwxKY",13) == 2931059549) strcat(s, "y");
if (crc32("kxKBXRR",7) == 2195046693) strcat(s, "n");
if (crc32("GAhzttqJu",9) == 3159869031) strcat(s, "a");
if (crc32("jLCkKhneVw",10) == 1223852120) strcat(s, "a");
if (crc32("FcICMvcUX",9) == 2357911221) strcat(s, "Z");
if (crc32("rszignIovb",10) == 3072062925) strcat(s, "m");
if (crc32("DDOSV",5) == 394262101) strcat(s, "i");
if (crc32("juOwBpUsIdM",11) == 535008353) strcat(s, "I");
if (crc32("SqnGEkvn",8) == 396231745) strcat(s, "c");
if (crc32("OsaTWc",6) == 3132611888) strcat(s, "A");
if (crc32("ydPZBhZsg",9) == 170306602) strcat(s, "a");
if (crc32("YNJcFWsuuM",10) == 3465099965) strcat(s, "G");
if (crc32("iLZCmDLnkmWAhzo",15) == 3614728874) strcat(s, "l");
    return s;
}

char *nonpalatal_adjectives() {
    char *s = calloc(11);
    if (crc32("UdtEPsirBq",10) == 3321612820) strcat(s, "n");
if (crc32("RLnmPOpQfdkxH",13) == 2775607901) strcat(s, "o");
if (crc32("sUtNSyNs",8) == 157592286) strcat(s, "H");
if (crc32("DeGIpyFG",8) == 675397411) strcat(s, "n");
if (crc32("XwHBCDyWBmzIIp",14) == 821981158) strcat(s, "p");
if (crc32("hUkDWysnXRuhvWm",15) == 2086441350) strcat(s, "a");
if (crc32("dgQvvGZ",7) == 1423026121) strcat(s, "u");
if (crc32("QjBnswVdJOTDgVI",15) == 3988530299) strcat(s, "l");
if (crc32("onNsbOTjFTN",11) == 327235483) strcat(s, "a");
if (crc32("HUwwdXsbcwgnB",13) == 2517664381) strcat(s, "t");
if (crc32("bYEeaHiDq",9) == 2652669053) strcat(s, "a");
if (crc32("aefLTHtJwfjrPt",14) == 2056304519) strcat(s, "W");
if (crc32("kKDRnTvwJwvwCr",14) == 1732887036) strcat(s, "l");
    return s;
}

char *featureless_adjectives() {
    char *s = calloc(12);
    if (crc32("jdykCMDSUPNY",12) == 138502330) strcat(s, "f");
if (crc32("aqtOQ",5) == 3524727717) strcat(s, "Z");
if (crc32("sNDRVUHXUWGCNQG",15) == 4178815187) strcat(s, "e");
if (crc32("goImve",6) == 3429227061) strcat(s, "s");
if (crc32("bLUbHw",6) == 683441142) strcat(s, "a");
if (crc32("bDlUaxqUERj",11) == 3816042868) strcat(s, "Z");
if (crc32("QgzmEwKGEXY",11) == 4036972412) strcat(s, "t");
if (crc32("oBjjFeG",7) == 1464583490) strcat(s, "Z");
if (crc32("xzWSZvuZfhN",11) == 3167825255) strcat(s, "u");
if (crc32("HzLBqIiB",8) == 8342594) strcat(s, "B");
if (crc32("gNQtSST",7) == 2490047530) strcat(s, "r");
if (crc32("BVDWvcxQUdzmZoK",15) == 2534483666) strcat(s, "r");
if (crc32("JJpOtHUmhyFjGC",14) == 1927615729) strcat(s, "e");
if (crc32("neRMLGXHdypcnfd",15) == 2627216705) strcat(s, "l");
if (crc32("xkvjAO",6) == 3158637472) strcat(s, "e");
if (crc32("VPWmKk",6) == 2352923892) strcat(s, "s");
if (crc32("bLHPvNihw",9) == 3101595193) strcat(s, "s");
    return s;
}

char *visional_adjectives() {
    char *s = calloc(9);
    if (crc32("kwjEGjGe",8) == 963843139) strcat(s, "v");
if (crc32("QmlIMQDRuNp",11) == 949475577) strcat(s, "i");
if (crc32("pvJzkUfxCQ",10) == 4057737280) strcat(s, "b");
if (crc32("HiJdgAkhkU",10) == 503979416) strcat(s, "s");
if (crc32("FOyTUeDiZUNfFnD",15) == 2226060321) strcat(s, "i");
if (crc32("WZuMe",5) == 2906988466) strcat(s, "N");
if (crc32("fNlGx",5) == 196102262) strcat(s, "o");
if (crc32("feTkPAfpVG",10) == 1494566781) strcat(s, "b");
if (crc32("lnzao",5) == 3113494216) strcat(s, "n");
if (crc32("GqGIJpx",7) == 3163062913) strcat(s, "h");
if (crc32("URRuIxORfZo",11) == 1004382665) strcat(s, "a");
if (crc32("aAQhQIRHcLMf",12) == 2806116718) strcat(s, "S");
if (crc32("yCLPoZJAXHJq",12) == 1674765745) strcat(s, "l");
    return s;
}

char *officious_adjectives() {
    char *s = calloc(10);
    if (crc32("fWoiMCdDbAin",12) == 1432628903) strcat(s, "s");
if (crc32("GmQozEXBs",9) == 491827950) strcat(s, "o");
if (crc32("ZVQZnA",6) == 59532982) strcat(s, "Y");
if (crc32("dQNLhdpiJxV",11) == 958246582) strcat(s, "f");
if (crc32("CXvLbauprf",10) == 3871320042) strcat(s, "f");
if (crc32("GRpCfjBRYuGkd",13) == 3087270719) strcat(s, "i");
if (crc32("hTSWzOUDsigVhI",14) == 3213808772) strcat(s, "l");
if (crc32("vPvfWHWCdqqdKRP",15) == 881973613) strcat(s, "c");
if (crc32("rFjsAnxAKBDPCwy",15) == 2285306956) strcat(s, "i");
if (crc32("luteIZPJIgAl",12) == 2583053915) strcat(s, "o");
if (crc32("qsnnfC",6) == 2316066761) strcat(s, "u");
if (crc32("AMVUXsdIuqgX",12) == 3198901060) strcat(s, "t");
if (crc32("HghpcqYeHyWBq",13) == 2969879874) strcat(s, "s");
    return s;
}

char *rhombohedral_adjectives() {
    char *s = calloc(13);
    if (crc32("YqdOkBIeNRfu",12) == 472360059) strcat(s, "r");
if (crc32("FfjcHWcB",8) == 4095351874) strcat(s, "h");
if (crc32("pNbvSXfrU",9) == 3501666175) strcat(s, "o");
if (crc32("gZUuJEkfBfoGJlh",15) == 820960396) strcat(s, "m");
if (crc32("DLGeCmPvA",9) == 13486232) strcat(s, "b");
if (crc32("KwOkbAEcmu",10) == 2932469231) strcat(s, "K");
if (crc32("FiddiHZVwX",10) == 629221616) strcat(s, "o");
if (crc32("DxkdhBWrK",9) == 230526640) strcat(s, "h");
if (crc32("agsOWUJDSfPyp",13) == 1038378885) strcat(s, "o");
if (crc32("OxpfZNjD",8) == 1734301664) strcat(s, "e");
if (crc32("RvGgewB",7) == 248464537) strcat(s, "d");
if (crc32("NInemiIefar",11) == 3447435266) strcat(s, "i");
if (crc32("rWVaL",5) == 2018998006) strcat(s, "r");
if (crc32("uygSKHNrsZVo",12) == 2796101982) strcat(s, "a");
if (crc32("zIKKCfmkOVkb",12) == 3107956581) strcat(s, "l");
    return s;
}

char *choleraic_adjectives() {
    char *s = calloc(10);
    if (crc32("TZwqpNLImhSd",12) == 3962051264) strcat(s, "c");
if (crc32("XVkXoHcnPxRHnER",15) == 1563200700) strcat(s, "l");
if (crc32("oJqMtKYQPvtwN",13) == 3569967022) strcat(s, "h");
if (crc32("BJLVASNCifCR",12) == 2682923616) strcat(s, "o");
if (crc32("xDaaBCWNIQRJF",13) == 4107560807) strcat(s, "J");
if (crc32("SsuAVgt",7) == 93854107) strcat(s, "l");
if (crc32("OgputnKoByp",11) == 1188445987) strcat(s, "W");
if (crc32("VZSaqWKV",8) == 1953704630) strcat(s, "e");
if (crc32("pUVmLMqWUUsKXaw",15) == 1836648582) strcat(s, "r");
if (crc32("JMYqoW",6) == 1262413089) strcat(s, "a");
if (crc32("zNdYEaUM",8) == 3231588807) strcat(s, "i");
if (crc32("mnSQYBgOyeEcz",13) == 2593518348) strcat(s, "T");
if (crc32("bDlTHU",6) == 1617518554) strcat(s, "c");
    return s;
}

char *Karaitic_adjectives() {
    char *s = calloc(9);
    if (crc32("OGCSaomhyI",10) == 626581023) strcat(s, "K");
if (crc32("leqWaA",6) == 1483424403) strcat(s, "a");
if (crc32("tPglGQtfesCYkUw",15) == 2148484886) strcat(s, "r");
if (crc32("aFOQsplxoeORK",13) == 3689880117) strcat(s, "a");
if (crc32("vcOTafUpDOZ",11) == 1961566920) strcat(s, "i");
if (crc32("MRpXwW",6) == 535230615) strcat(s, "N");
if (crc32("RoXCLd",6) == 2173720927) strcat(s, "t");
if (crc32("trjZasTaxikDFKp",15) == 817782145) strcat(s, "i");
if (crc32("tVdjVwKmu",9) == 2543516441) strcat(s, "n");
if (crc32("gqIxriI",7) == 69293278) strcat(s, "c");
    return s;
}

char *worse_adjectives() {
    char *s = calloc(6);
    if (crc32("gsaPiGuSZjDs",12) == 3658845083) strcat(s, "w");
if (crc32("pXkYu",5) == 1054701552) strcat(s, "o");
if (crc32("PkHcqP",6) == 4055927598) strcat(s, "M");
if (crc32("bJnreFgWId",10) == 3898528683) strcat(s, "r");
if (crc32("BkuvThWWyKreGg",14) == 4096898828) strcat(s, "d");
if (crc32("MnPSUPwnkPRfp",13) == 1099731299) strcat(s, "s");
if (crc32("VkTtOLowT",9) == 3863141479) strcat(s, "S");
if (crc32("ZTfiEzKdijvByup",15) == 4240314811) strcat(s, "e");
    return s;
}

char *paidin_adjectives() {
    char *s = calloc(7);
    if (crc32("JcAUdJyPldmayY",14) == 1595883188) strcat(s, "j");
if (crc32("OWccaOjMQRgEQn",14) == 593996120) strcat(s, "p");
if (crc32("UNzAvvh",7) == 2876169245) strcat(s, "G");
if (crc32("WTSoDJwXit",10) == 3224479584) strcat(s, "a");
if (crc32("DujHkpU",7) == 3353242719) strcat(s, "G");
if (crc32("RoNoLDVNATb",11) == 2750143927) strcat(s, "i");
if (crc32("tPyrcyqNH",9) == 2853242694) strcat(s, "d");
if (crc32("AGqrLelfdZPbs",13) == 40841721) strcat(s, "l");
if (crc32("XuclOftQDkGFfNf",15) == 3410929091) strcat(s, "i");
if (crc32("EhDzGvOgpr",10) == 3083729409) strcat(s, "I");
if (crc32("zmhOQErrvlkp",12) == 2116109344) strcat(s, "n");
    return s;
}

char *houndstooth_adjectives() {
    char *s = calloc(12);
    if (crc32("DHnAEMxeloCF",12) == 2792227497) strcat(s, "h");
if (crc32("BBepPDVAd",9) == 1843281567) strcat(s, "h");
if (crc32("sjUlCnDrPyb",11) == 1873206081) strcat(s, "o");
if (crc32("MBsVnDcGzmkJTRC",15) == 4221305446) strcat(s, "u");
if (crc32("QlCJuFeZXeI",11) == 2704846537) strcat(s, "u");
if (crc32("GUIXcrMOBiuRFpD",15) == 1204054805) strcat(s, "n");
if (crc32("AIPXqgna",8) == 244085271) strcat(s, "I");
if (crc32("tmEem",5) == 1592021984) strcat(s, "d");
if (crc32("pOCWVRLOri",10) == 1324329918) strcat(s, "s");
if (crc32("AOKINOny",8) == 2633911441) strcat(s, "Z");
if (crc32("hYVQLaDCnT",10) == 3300554816) strcat(s, "t");
if (crc32("BvGQS",5) == 3795125394) strcat(s, "X");
if (crc32("iEyXXuCc",8) == 3415689206) strcat(s, "o");
if (crc32("cQAIDhxtL",9) == 3984250426) strcat(s, "o");
if (crc32("noAXUliegT",10) == 343584164) strcat(s, "t");
if (crc32("iQoTWHfTlXs",11) == 3921266640) strcat(s, "h");
    return s;
}

char *untitular_adjectives() {
    char *s = calloc(10);
    if (crc32("UZWQXPPqQIVIgr",14) == 3759569343) strcat(s, "u");
if (crc32("dBJGa",5) == 1661810236) strcat(s, "n");
if (crc32("nmCHbtA",7) == 488663482) strcat(s, "C");
if (crc32("EwKhvOz",7) == 3682914663) strcat(s, "t");
if (crc32("DwQRiwMiBq",10) == 1272252061) strcat(s, "w");
if (crc32("WkQvCv",6) == 257190746) strcat(s, "i");
if (crc32("InskJiuyyZx",11) == 3760982715) strcat(s, "t");
if (crc32("akDzW",5) == 815187666) strcat(s, "I");
if (crc32("Yglis",5) == 1764644657) strcat(s, "u");
if (crc32("PvwTaydLf",9) == 1838569918) strcat(s, "E");
if (crc32("SnXQNHISuURRDCV",15) == 3034997231) strcat(s, "l");
if (crc32("bXkAv",5) == 1072659185) strcat(s, "a");
if (crc32("HJscu",5) == 1649576231) strcat(s, "u");
if (crc32("TIQTYZFeNlsDw",13) == 2638701151) strcat(s, "r");
    return s;
}

char *enneasyllabic_adjectives() {
    char *s = calloc(14);
    if (crc32("YhwtdenBF",9) == 3507288660) strcat(s, "E");
if (crc32("izxjCcc",7) == 1551204249) strcat(s, "e");
if (crc32("IepOJG",6) == 982522855) strcat(s, "n");
if (crc32("MVGwoZkizKC",11) == 4236878215) strcat(s, "L");
if (crc32("emlHybgYB",9) == 3486543245) strcat(s, "n");
if (crc32("kYWNZTyBUr",10) == 2493101527) strcat(s, "y");
if (crc32("iMIPUmBZIAin",12) == 2380949881) strcat(s, "e");
if (crc32("eSKzcEY",7) == 812763308) strcat(s, "a");
if (crc32("ptNqRb",6) == 3011246246) strcat(s, "s");
if (crc32("coYWdDglWYj",11) == 2505624044) strcat(s, "s");
if (crc32("IwkUDNdEpjHA",12) == 3176527335) strcat(s, "y");
if (crc32("JvVDy",5) == 4254382124) strcat(s, "l");
if (crc32("hgxFfUgLuexKF",13) == 1059426458) strcat(s, "l");
if (crc32("QwqPkpHIkUzsE",13) == 1764027973) strcat(s, "l");
if (crc32("vlAdMJyUugJT",12) == 3720284605) strcat(s, "E");
if (crc32("HFHPjABWoN",10) == 4258368505) strcat(s, "a");
if (crc32("lcPbpsByKwX",11) == 3353277309) strcat(s, "b");
if (crc32("OqVHHio",7) == 3086797455) strcat(s, "k");
if (crc32("QEMyevX",7) == 2747718449) strcat(s, "i");
if (crc32("TpdWcYtw",8) == 2394732886) strcat(s, "c");
    return s;
}

char *crystalloid_adjectives() {
    char *s = calloc(12);
    if (crc32("yVzsI",5) == 2398231386) strcat(s, "c");
if (crc32("SgekNAtVowJPShE",15) == 1468315015) strcat(s, "r");
if (crc32("LqNiajH",7) == 3511986990) strcat(s, "y");
if (crc32("OWzThSMgQxfHIgs",15) == 1334661750) strcat(s, "s");
if (crc32("EiBQCDUxa",9) == 368047596) strcat(s, "t");
if (crc32("ZSxdPaTrkYtaoI",14) == 486950140) strcat(s, "a");
if (crc32("PqpMiSQQbmM",11) == 1890630464) strcat(s, "J");
if (crc32("qRbmKcHxKNuGKQg",15) == 3943938793) strcat(s, "l");
if (crc32("FxzQNMUAweE",11) == 2642454021) strcat(s, "F");
if (crc32("FvYmhLplZ",9) == 1293838796) strcat(s, "l");
if (crc32("VEtyqt",6) == 624362742) strcat(s, "o");
if (crc32("zrIYI",5) == 2940521986) strcat(s, "i");
if (crc32("HywqvYwUT",9) == 3809351845) strcat(s, "d");
    return s;
}

char *superorganic_adjectives() {
    char *s = calloc(13);
    if (crc32("LpaFoLnWzYLB",12) == 2993675959) strcat(s, "s");
if (crc32("pDiZHVHnKkVXHAV",15) == 640437128) strcat(s, "u");
if (crc32("SSgHvtotB",9) == 2864757755) strcat(s, "k");
if (crc32("PNvyTZuKbjvT",12) == 2278468311) strcat(s, "p");
if (crc32("mICgVpwZD",9) == 2204518878) strcat(s, "Y");
if (crc32("uRUoX",5) == 2075532670) strcat(s, "e");
if (crc32("QqJdHBEYkG",10) == 503646175) strcat(s, "M");
if (crc32("pnPOOAxSHHBPMfU",15) == 1419495440) strcat(s, "r");
if (crc32("qlgDinGLmfKWD",13) == 3758937573) strcat(s, "o");
if (crc32("fBaAVqmyiLN",11) == 3993084871) strcat(s, "U");
if (crc32("paBBXFBJtiVrN",13) == 3876836331) strcat(s, "r");
if (crc32("SIkcb",5) == 2871028292) strcat(s, "U");
if (crc32("bzzHCT",6) == 2328224311) strcat(s, "g");
if (crc32("fhVEobiuU",9) == 1374427055) strcat(s, "a");
if (crc32("UkrKpLxNw",9) == 3978775071) strcat(s, "v");
if (crc32("ihxDe",5) == 1606228979) strcat(s, "n");
if (crc32("bnJYltiYOJNBIaV",15) == 135464527) strcat(s, "i");
if (crc32("hajCRx",6) == 3590521188) strcat(s, "Y");
if (crc32("RUUuJgWCNr",10) == 3021917274) strcat(s, "c");
    return s;
}

char *stainless_adjectives() {
    char *s = calloc(10);
    if (crc32("BCyczydejrBDv",13) == 2269350468) strcat(s, "j");
if (crc32("vlLAdfgTQgj",11) == 1339455866) strcat(s, "s");
if (crc32("EfweG",5) == 3924868607) strcat(s, "t");
if (crc32("SWmDhZSPghA",11) == 2440946618) strcat(s, "a");
if (crc32("KywaPrjv",8) == 1716961821) strcat(s, "D");
if (crc32("gQhNYkG",7) == 3422164645) strcat(s, "i");
if (crc32("psnkfolpXjTwKk",14) == 3583022731) strcat(s, "k");
if (crc32("PEgUSZrZkr",10) == 100535290) strcat(s, "n");
if (crc32("AMAlouyOGnmbSd",14) == 4029243143) strcat(s, "l");
if (crc32("mdbVxmbZcRq",11) == 3503699650) strcat(s, "u");
if (crc32("mzzGENrE",8) == 3956271414) strcat(s, "e");
if (crc32("ePjvl",5) == 2420053356) strcat(s, "x");
if (crc32("czdVoBLTEF",10) == 3676595240) strcat(s, "s");
if (crc32("kPBSGQUws",9) == 811790551) strcat(s, "G");
if (crc32("bPxzX",5) == 73379264) strcat(s, "s");
    return s;
}

char *grammatical_adjectives() {
    char *s = calloc(12);
    if (crc32("rHJElPo",7) == 2422662689) strcat(s, "E");
if (crc32("asTDJmxjRlah",12) == 3857380194) strcat(s, "g");
if (crc32("rXJRxMUbnlL",11) == 3259225783) strcat(s, "r");
if (crc32("QLdLqbuWa",9) == 848949961) strcat(s, "a");
if (crc32("dEuFBssC",8) == 662791885) strcat(s, "m");
if (crc32("VGfKpQ",6) == 3491175546) strcat(s, "m");
if (crc32("crnaeDuQvHyZ",12) == 2562935825) strcat(s, "H");
if (crc32("kwOoECTEz",9) == 2593304229) strcat(s, "a");
if (crc32("sjKUZbHyTXtplu",14) == 2227482133) strcat(s, "S");
if (crc32("epKiNKX",7) == 720670702) strcat(s, "t");
if (crc32("uoERDIgFgptkzt",14) == 3359055000) strcat(s, "i");
if (crc32("lwQGxdvTWLmCu",13) == 1763533499) strcat(s, "a");
if (crc32("XdSVdAz",7) == 2575979805) strcat(s, "c");
if (crc32("GYLKa",5) == 3394011336) strcat(s, "a");
if (crc32("AMcDj",5) == 3106697530) strcat(s, "l");
    return s;
}

char *silklike_adjectives() {
    char *s = calloc(9);
    if (crc32("vBoSCreMF",9) == 3019750300) strcat(s, "s");
if (crc32("fntfxhlMMLAhC",13) == 128852414) strcat(s, "i");
if (crc32("TtFbaQAiUb",10) == 1804400001) strcat(s, "B");
if (crc32("XyNGXZuzuXNevcL",15) == 4009046051) strcat(s, "l");
if (crc32("EjXYHtbB",8) == 2637033694) strcat(s, "j");
if (crc32("dpiGEqXVYFyyTq",14) == 2781602285) strcat(s, "k");
if (crc32("hWynGdeUBuH",11) == 2778759182) strcat(s, "l");
if (crc32("SgedlTq",7) == 3341705313) strcat(s, "i");
if (crc32("rTrTFJpBys",10) == 3870337880) strcat(s, "I");
if (crc32("jWhSIA",6) == 580277259) strcat(s, "k");
if (crc32("opStXaHgOd",10) == 2596436952) strcat(s, "e");
    return s;
}

char *monovalent_adjectives() {
    char *s = calloc(11);
    if (crc32("PXlGl",5) == 1249499502) strcat(s, "m");
if (crc32("gdMGko",6) == 2402196172) strcat(s, "o");
if (crc32("QTJuBSCpA",9) == 3806004107) strcat(s, "u");
if (crc32("jSHBSjKXVizYb",13) == 1241693925) strcat(s, "n");
if (crc32("KGsXW",5) == 1549697547) strcat(s, "j");
if (crc32("gxJJFLwXbqoGD",13) == 1142309150) strcat(s, "o");
if (crc32("rgUjJwBw",8) == 1848266802) strcat(s, "P");
if (crc32("mXvwuJ",6) == 3596656005) strcat(s, "v");
if (crc32("xMNhwmYN",8) == 3645241170) strcat(s, "F");
if (crc32("sObyDVQaM",9) == 3044980609) strcat(s, "a");
if (crc32("pXtRcYdYhmQw",12) == 2062352154) strcat(s, "i");
if (crc32("jedKAcRVpKeTZ",13) == 1524387301) strcat(s, "l");
if (crc32("cxguDejqnYQTro",14) == 1193494961) strcat(s, "e");
if (crc32("xgGeLzQwelBGIj",14) == 2211622003) strcat(s, "n");
if (crc32("YHkkekDOxrVW",12) == 4269638988) strcat(s, "t");
    return s;
}

char *kickable_adjectives() {
    char *s = calloc(9);
    if (crc32("XhLjbKaqAspMfL",14) == 3964051452) strcat(s, "k");
if (crc32("hBNqeJetfLTBklx",15) == 732212444) strcat(s, "i");
if (crc32("sMntbAava",9) == 471494961) strcat(s, "c");
if (crc32("UYXBAme",7) == 1655517991) strcat(s, "k");
if (crc32("QOGOpY",6) == 3963522998) strcat(s, "a");
if (crc32("UPjIKGvHdLWoE",13) == 2905041552) strcat(s, "y");
if (crc32("mqbpqaAZTZKhakS",15) == 3466645849) strcat(s, "b");
if (crc32("BwWQSjhNMcdcT",13) == 3009286493) strcat(s, "O");
if (crc32("RCVwxm",6) == 2229987958) strcat(s, "l");
if (crc32("xIYeDu",6) == 2160118733) strcat(s, "y");
if (crc32("JAUkgoy",7) == 602111852) strcat(s, "e");
    return s;
}

char *unbranching_adjectives() {
    char *s = calloc(12);
    if (crc32("eIkzypN",7) == 1672390530) strcat(s, "u");
if (crc32("EbWsIBn",7) == 718594255) strcat(s, "n");
if (crc32("vVnIyRPPwDkLf",13) == 560855046) strcat(s, "b");
if (crc32("MdWtjdZsKrkkws",14) == 3935873390) strcat(s, "A");
if (crc32("TxGEtkY",7) == 752364176) strcat(s, "r");
if (crc32("wHqsacLB",8) == 3343580463) strcat(s, "a");
if (crc32("PJVNzOh",7) == 2806831821) strcat(s, "D");
if (crc32("AmOiGCWyXjAqDJF",15) == 1927217942) strcat(s, "n");
if (crc32("JYHufRkojwnik",13) == 1299926415) strcat(s, "l");
if (crc32("vPuJqGEIzHTR",12) == 1499051788) strcat(s, "c");
if (crc32("NFNTR",5) == 3190300310) strcat(s, "h");
if (crc32("lXrLlSaIvCgY",12) == 2073904663) strcat(s, "F");
if (crc32("CjECex",6) == 1942899703) strcat(s, "i");
if (crc32("PpUlJyYlJRK",11) == 2169776715) strcat(s, "u");
if (crc32("PZmrxsL",7) == 2460145877) strcat(s, "n");
if (crc32("oMddagQTgyRMP",13) == 1326511305) strcat(s, "g");
    return s;
}

char *fiftyfifth_adjectives() {
    char *s = calloc(11);
    if (crc32("eMQFmfOwEEPzZn",14) == 2301913234) strcat(s, "g");
if (crc32("PlaNUNlplVD",11) == 3282893) strcat(s, "f");
if (crc32("pGeCuNqxXShA",12) == 241625212) strcat(s, "s");
if (crc32("KxKQatJRWvaiz",13) == 2674614363) strcat(s, "i");
if (crc32("YgUVgBqAFNxT",12) == 1600504274) strcat(s, "B");
if (crc32("XttsvPz",7) == 841658256) strcat(s, "f");
if (crc32("vaAXDhCDZjqqjn",14) == 3544914818) strcat(s, "t");
if (crc32("FsVKQbPFA",9) == 333230260) strcat(s, "y");
if (crc32("ATfBRkaixzVlug",14) == 2532038606) strcat(s, "f");
if (crc32("ylPJZZ",6) == 3167186278) strcat(s, "i");
if (crc32("uwfwYSDjXdKEVJv",15) == 3911310344) strcat(s, "I");
if (crc32("XCMOfUHQDUvkq",13) == 1261685926) strcat(s, "f");
if (crc32("vLQurpZOC",9) == 3573415063) strcat(s, "t");
if (crc32("VVIHFwz",7) == 147124606) strcat(s, "W");
if (crc32("VQBnUQrMmlYKijM",15) == 3536649320) strcat(s, "h");
    return s;
}

char *tensional_adjectives() {
    char *s = calloc(10);
    if (crc32("QHOEnYjH",8) == 2557041852) strcat(s, "y");
if (crc32("GPPfLYebb",9) == 1707702700) strcat(s, "t");
if (crc32("laXGTlfYledWxF",14) == 1083796858) strcat(s, "e");
if (crc32("ZrENTRIINk",10) == 2386162427) strcat(s, "s");
if (crc32("TtvXWcZYFKq",11) == 3038016285) strcat(s, "n");
if (crc32("EXogUOaGMVbpL",13) == 4015999697) strcat(s, "v");
if (crc32("uihwwxSc",8) == 3654182907) strcat(s, "s");
if (crc32("GRleFZW",7) == 3438289139) strcat(s, "i");
if (crc32("pkprYzvkUt",10) == 2431435904) strcat(s, "b");
if (crc32("UsZBFbIeH",9) == 1618798868) strcat(s, "o");
if (crc32("vNveBdLqGHmgL",13) == 2340317264) strcat(s, "e");
if (crc32("bdDyMj",6) == 1068170180) strcat(s, "n");
if (crc32("cDpbWRsUCmqIHSc",15) == 2309157148) strcat(s, "A");
if (crc32("zWYIQTJHbahFQT",14) == 2203146554) strcat(s, "a");
if (crc32("LPNPMcn",7) == 1902381238) strcat(s, "X");
if (crc32("tqbXrzrGxZDaY",13) == 2517777393) strcat(s, "l");
    return s;
}

char *crescentoid_adjectives() {
    char *s = calloc(12);
    if (crc32("eXVWRHjGSfUUlm",14) == 2602194349) strcat(s, "r");
if (crc32("jtPZB",5) == 1170674920) strcat(s, "c");
if (crc32("ClGLcpY",7) == 3685874104) strcat(s, "r");
if (crc32("fQslOElzWyw",11) == 2029905227) strcat(s, "T");
if (crc32("hQdeYJ",6) == 1463741923) strcat(s, "e");
if (crc32("ECaIok",6) == 902885748) strcat(s, "s");
if (crc32("MbNSsqT",7) == 459774369) strcat(s, "n");
if (crc32("zxJTinErvVqat",13) == 2863667108) strcat(s, "c");
if (crc32("RwBuFo",6) == 951217676) strcat(s, "X");
if (crc32("ySCQqJO",7) == 3147989864) strcat(s, "e");
if (crc32("mtTMkwbiTfiAl",13) == 2953544317) strcat(s, "n");
if (crc32("kXbapCs",7) == 902430132) strcat(s, "T");
if (crc32("WRaciGesfPxokgf",15) == 1874042015) strcat(s, "t");
if (crc32("FxWRC",5) == 2981217614) strcat(s, "o");
if (crc32("DuHXoZyJiHb",11) == 4066755741) strcat(s, "i");
if (crc32("mSYvuW",6) == 992285970) strcat(s, "d");
    return s;
}

char *unjeopardized_adjectives() {
    char *s = calloc(14);
    if (crc32("fbxaXYojnCMixg",14) == 2464099649) strcat(s, "W");
if (crc32("pDhtRnLMI",9) == 971699834) strcat(s, "u");
if (crc32("xhLJe",5) == 1147941728) strcat(s, "V");
if (crc32("vOeuXmTXOnjg",12) == 1187812566) strcat(s, "n");
if (crc32("JqvcG",5) == 885143542) strcat(s, "n");
if (crc32("ixTQpsGZDjPAje",14) == 1371806572) strcat(s, "j");
if (crc32("PudhE",5) == 3001974787) strcat(s, "E");
if (crc32("DeKMvnbWQlKT",12) == 335160088) strcat(s, "e");
if (crc32("ljiPBOFcRIfx",12) == 369633075) strcat(s, "o");
if (crc32("abkHndHQnQhP",12) == 2701088640) strcat(s, "p");
if (crc32("ZZUHV",5) == 3175612246) strcat(s, "c");
if (crc32("GNOHXC",6) == 1679109690) strcat(s, "a");
if (crc32("gosSVCzPQKIgcUu",15) == 4081995723) strcat(s, "r");
if (crc32("YMlWQHZBAEIwA",13) == 3769486060) strcat(s, "C");
if (crc32("yrSVrtNGMAARxTS",15) == 872815224) strcat(s, "d");
if (crc32("WKCeLCTFFtNEsSM",15) == 3110707550) strcat(s, "L");
if (crc32("rCkDEJ",6) == 1757964576) strcat(s, "i");
if (crc32("WrKzPWbMDY",10) == 1284163514) strcat(s, "l");
if (crc32("LXFwAJ",6) == 1368473664) strcat(s, "z");
if (crc32("YUFMKY",6) == 2897656261) strcat(s, "f");
if (crc32("AaCFR",5) == 1907490112) strcat(s, "e");
if (crc32("tkhBBGuw",8) == 3673996509) strcat(s, "d");
    return s;
}

char *unrazed_adjectives() {
    char *s = calloc(8);
    if (crc32("UFZeoVXoC",9) == 1958304581) strcat(s, "u");
if (crc32("DvURTDMeP",9) == 3987064762) strcat(s, "n");
if (crc32("GfKSwsXEQEAIkve",15) == 1354264521) strcat(s, "e");
if (crc32("MliuIXBlW",9) == 525497449) strcat(s, "r");
if (crc32("zQHuXKHF",8) == 2136151136) strcat(s, "i");
if (crc32("IKLepQWrWdER",12) == 453038444) strcat(s, "a");
if (crc32("EBZoccmTht",10) == 3659714880) strcat(s, "z");
if (crc32("oaUkQNsV",8) == 2848811307) strcat(s, "i");
if (crc32("ysVunNr",7) == 270584733) strcat(s, "e");
if (crc32("dCuMstnFxfE",11) == 1276555817) strcat(s, "d");
    return s;
}

char *firstborn_adjectives() {
    char *s = calloc(10);
    if (crc32("iAylJ",5) == 1976107651) strcat(s, "f");
if (crc32("IxdxgVKxvOkqT",13) == 1710817141) strcat(s, "e");
if (crc32("FATNqTKpAYi",11) == 2163756759) strcat(s, "i");
if (crc32("rHWwzzwgaZmfgw",14) == 1619466457) strcat(s, "K");
if (crc32("DMLgfgIJrmvd",12) == 971677189) strcat(s, "r");
if (crc32("NCEoHW",6) == 3106786670) strcat(s, "s");
if (crc32("PRWQS",5) == 2802101137) strcat(s, "t");
if (crc32("nvuwcgVqFFvWfO",14) == 783857502) strcat(s, "a");
if (crc32("xtsrKpKpJNwl",12) == 2051410941) strcat(s, "b");
if (crc32("HblIHOLgoWpHlas",15) == 3225677190) strcat(s, "W");
if (crc32("XzKEC",5) == 3570924196) strcat(s, "o");
if (crc32("lgbaHJmxUfhPDA",14) == 1313469619) strcat(s, "r");
if (crc32("dnhKFiIxa",9) == 3597978257) strcat(s, "V");
if (crc32("hUOZphFLtHU",11) == 1703354319) strcat(s, "n");
    return s;
}

char *crabby_adjectives() {
    char *s = calloc(7);
    if (crc32("XXDCmAmTxkrRPfg",15) == 4249833363) strcat(s, "c");
if (crc32("kWYCb",5) == 1704955863) strcat(s, "r");
if (crc32("kVzJuiiJPedGxq",14) == 3539819610) strcat(s, "a");
if (crc32("hKaTnwz",7) == 799908792) strcat(s, "O");
if (crc32("pwuZMOohwALBK",13) == 2964585947) strcat(s, "b");
if (crc32("dfsHRrXzEWYKcDF",15) == 830261745) strcat(s, "k");
if (crc32("brfFbQsbuAmb",12) == 1342008624) strcat(s, "b");
if (crc32("yxtMlsw",7) == 3984588587) strcat(s, "y");
    return s;
}

char *Paduan_adjectives() {
    char *s = calloc(7);
    if (crc32("dcuZKBwTsFgy",12) == 478462068) strcat(s, "P");
if (crc32("sQCyIUZZSFAoi",13) == 3384459032) strcat(s, "a");
if (crc32("meZzKwev",8) == 1433546940) strcat(s, "d");
if (crc32("kvCXgzFyDoBL",12) == 3718834007) strcat(s, "u");
if (crc32("jeosDvsv",8) == 1126761084) strcat(s, "a");
if (crc32("buPpzNnjz",9) == 3571222401) strcat(s, "M");
if (crc32("suCQpDdEirIprY",14) == 951846104) strcat(s, "n");
    return s;
}

char *consolable_adjectives() {
    char *s = calloc(11);
    if (crc32("ORIhUmeMt",9) == 2181195819) strcat(s, "d");
if (crc32("kaLwHewZdEw",11) == 1951067529) strcat(s, "c");
if (crc32("NYmNIwL",7) == 3761294084) strcat(s, "a");
if (crc32("Ncjno",5) == 1799437774) strcat(s, "o");
if (crc32("WfIQzbZ",7) == 1160891330) strcat(s, "b");
if (crc32("vVYcwE",6) == 1102453355) strcat(s, "n");
if (crc32("pDGbw",5) == 3355029063) strcat(s, "s");
if (crc32("dsbFjehCsBLMmO",14) == 797509767) strcat(s, "o");
if (crc32("sXSZnNZPZYPyWCg",15) == 1700143707) strcat(s, "l");
if (crc32("TMGOFjjdgce",11) == 4208384295) strcat(s, "R");
if (crc32("KpOfGHDwuj",10) == 2911986556) strcat(s, "a");
if (crc32("kTkKKF",6) == 1011505268) strcat(s, "U");
if (crc32("pmzewz",6) == 1097998782) strcat(s, "b");
if (crc32("FLtbjEDnSyFbvR",14) == 862543644) strcat(s, "l");
if (crc32("gwinhzl",7) == 1653938723) strcat(s, "M");
if (crc32("iNScK",5) == 3908042170) strcat(s, "e");
    return s;
}

char *battological_adjectives() {
    char *s = calloc(13);
    if (crc32("CBxlR",5) == 3601260128) strcat(s, "u");
if (crc32("KsjuaptOAbST",12) == 239581293) strcat(s, "b");
if (crc32("xUQQMlAukDsUWcD",15) == 2955097338) strcat(s, "p");
if (crc32("FukdaMHqbs",10) == 3472709121) strcat(s, "a");
if (crc32("fQIwuFdEMJ",10) == 683336596) strcat(s, "r");
if (crc32("JYTuuiyDYSzAls",14) == 3195345666) strcat(s, "t");
if (crc32("tQbuMYJBZG",10) == 4227953913) strcat(s, "t");
if (crc32("ZvjsbElEjsV",11) == 178406963) strcat(s, "s");
if (crc32("znAuIs",6) == 2757494529) strcat(s, "o");
if (crc32("XPxxrIvwiK",10) == 3271271492) strcat(s, "l");
if (crc32("wYxkzUaFMckh",12) == 2091018196) strcat(s, "z");
if (crc32("lLRxOjE",7) == 2816138223) strcat(s, "o");
if (crc32("hxXqcMUVtgBBRj",14) == 529860350) strcat(s, "g");
if (crc32("GoyQjXbpYSuiEU",14) == 1957478456) strcat(s, "i");
if (crc32("XCwRzXq",7) == 7272822) strcat(s, "V");
if (crc32("irNjLEGPVfMSOdg",15) == 1752594926) strcat(s, "c");
if (crc32("BMrtgKQssPHs",12) == 4251442007) strcat(s, "Q");
if (crc32("HsWsxFJhCaim",12) == 2700809629) strcat(s, "a");
if (crc32("UWNPptPoXRXo",12) == 299675252) strcat(s, "l");
    return s;
}

char *unvaccinated_adjectives() {
    char *s = calloc(13);
    if (crc32("eDUCPvQhW",9) == 3860460404) strcat(s, "u");
if (crc32("rMgnHsBjvjHWH",13) == 566373738) strcat(s, "n");
if (crc32("yOJOkqPwXAW",11) == 3282996449) strcat(s, "v");
if (crc32("uUStFxnssw",10) == 1598027874) strcat(s, "a");
if (crc32("DGWrZYRjBTitZ",13) == 2683320289) strcat(s, "z");
if (crc32("pikjCpYPFUOP",12) == 69628366) strcat(s, "c");
if (crc32("PQqcq",5) == 2975935416) strcat(s, "c");
if (crc32("BrfbcJPezJYjyf",14) == 2286200168) strcat(s, "i");
if (crc32("cFUyWHLgebhPe",13) == 468549008) strcat(s, "n");
if (crc32("nqMqoJVZ",8) == 1470414157) strcat(s, "v");
if (crc32("YiogWHsaFaOO",12) == 2390488241) strcat(s, "a");
if (crc32("VhCebJIam",9) == 3543319139) strcat(s, "c");
if (crc32("CCGyjAMOSib",11) == 2850277462) strcat(s, "t");
if (crc32("wrmPHeYEb",9) == 1408611135) strcat(s, "e");
if (crc32("titnKVwoNxG",11) == 2341747117) strcat(s, "V");
if (crc32("EbVeDCirOcjRm",13) == 3173812151) strcat(s, "d");
    return s;
}

char *subconvolute_adjectives() {
    char *s = calloc(13);
    if (crc32("PWpXv",5) == 924738760) strcat(s, "s");
if (crc32("jpphwapA",8) == 4212700094) strcat(s, "u");
if (crc32("NIVLdbhAaT",10) == 1668443952) strcat(s, "F");
if (crc32("VJCaxnIZ",8) == 2101939167) strcat(s, "b");
if (crc32("uYutqqfnVFnpxnB",15) == 3398044674) strcat(s, "c");
if (crc32("TgUxYznQzfyLL",13) == 1701965449) strcat(s, "r");
if (crc32("MiRDfNLyUqwmj",13) == 1153379647) strcat(s, "o");
if (crc32("lqwOxxpVdJ",10) == 1629099542) strcat(s, "n");
if (crc32("CaJrjJ",6) == 3063244599) strcat(s, "W");
if (crc32("OfaxEmc",7) == 2313325060) strcat(s, "v");
if (crc32("enIZxdWJD",9) == 640198814) strcat(s, "o");
if (crc32("ynBpgTBWwl",10) == 3041746758) strcat(s, "C");
if (crc32("LIzuPht",7) == 1340295469) strcat(s, "l");
if (crc32("GXwCI",5) == 4132896433) strcat(s, "K");
if (crc32("lebjV",5) == 3226534594) strcat(s, "u");
if (crc32("XLPMiG",6) == 601131933) strcat(s, "t");
if (crc32("ZHUaTbhS",8) == 2118888090) strcat(s, "e");
    return s;
}

char *rugged_adjectives() {
    char *s = calloc(7);
    if (crc32("pfFAYzKWzBTRX",13) == 3824664577) strcat(s, "B");
if (crc32("kkGPNABhlNBHCw",14) == 2668515710) strcat(s, "r");
if (crc32("KORJqCJXWMjCFyU",15) == 1639274532) strcat(s, "S");
if (crc32("ngwuelHJVFx",11) == 2150786574) strcat(s, "u");
if (crc32("JmgBqbnSVrHx",12) == 3589217723) strcat(s, "X");
if (crc32("aAXvfAAUEl",10) == 651609488) strcat(s, "g");
if (crc32("AxKLZSB",7) == 2434703959) strcat(s, "d");
if (crc32("NINjnkzh",8) == 1739908875) strcat(s, "g");
if (crc32("CBRXQrEWiXQyDft",15) == 2174923384) strcat(s, "e");
if (crc32("rdtxj",5) == 3893206994) strcat(s, "d");
    return s;
}

char *enabling_adjectives() {
    char *s = calloc(9);
    if (crc32("FlabOjMvUNL",11) == 3381362144) strcat(s, "e");
if (crc32("KnVagQUY",8) == 2855094273) strcat(s, "n");
if (crc32("ijlmxYv",7) == 928924698) strcat(s, "a");
if (crc32("zWUjvTcXxgsfbBy",15) == 4218683726) strcat(s, "a");
if (crc32("oQvqyGsF",8) == 147657245) strcat(s, "b");
if (crc32("eFnpEAC",7) == 2622871161) strcat(s, "v");
if (crc32("yJHIorzzw",9) == 3311718225) strcat(s, "l");
if (crc32("mHBFp",5) == 513690795) strcat(s, "E");
if (crc32("HxiwESb",7) == 726181661) strcat(s, "i");
if (crc32("PlzuW",5) == 96199431) strcat(s, "l");
if (crc32("KfeCV",5) == 3758937942) strcat(s, "n");
if (crc32("kiYLTyY",7) == 1478000207) strcat(s, "g");
    return s;
}

char *wellaffected_adjectives() {
    char *s = calloc(13);
    if (crc32("VQWyt",5) == 3265718814) strcat(s, "w");
if (crc32("LBzHdIJdj",9) == 3965150543) strcat(s, "x");
if (crc32("VydwOVpMAkTBYb",14) == 4252616408) strcat(s, "e");
if (crc32("oiLbNyQ",7) == 380049045) strcat(s, "J");
if (crc32("vWWEoUfd",8) == 415047007) strcat(s, "l");
if (crc32("ERkqwIfgIETibCj",15) == 3324357352) strcat(s, "l");
if (crc32("rJIPNOiEBonenUA",15) == 306460850) strcat(s, "a");
if (crc32("iFeDujqcsOC",11) == 3679567655) strcat(s, "o");
if (crc32("fwOScyoPnyRMl",13) == 528234726) strcat(s, "f");
if (crc32("xyCKpyZzC",9) == 866539684) strcat(s, "o");
if (crc32("RNvMDNUMwHm",11) == 3162624873) strcat(s, "f");
if (crc32("PKGvaZi",7) == 1116633674) strcat(s, "e");
if (crc32("WtwOCpTqU",9) == 1025317058) strcat(s, "c");
if (crc32("rFcAniVF",8) == 2833148706) strcat(s, "t");
if (crc32("hGAmD",5) == 3279798624) strcat(s, "G");
if (crc32("krBIOzXCYJ",10) == 1653248776) strcat(s, "e");
if (crc32("iFnrQy",6) == 192765208) strcat(s, "O");
if (crc32("OyQYrrjVYmdgg",13) == 1603369955) strcat(s, "d");
    return s;
}

char *hypostyle_adjectives() {
    char *s = calloc(10);
    if (crc32("bMqld",5) == 2584399965) strcat(s, "h");
if (crc32("hyDBcHdlaqrrtT",14) == 769093342) strcat(s, "A");
if (crc32("UUxeCifsiTVDTtv",15) == 1158229527) strcat(s, "y");
if (crc32("WbmOBCU",7) == 800898450) strcat(s, "p");
if (crc32("uFjho",5) == 1006657660) strcat(s, "X");
if (crc32("mnRosWsCWxFxNAA",15) == 2768756408) strcat(s, "o");
if (crc32("cDnvbEGyIjXz",12) == 4028127295) strcat(s, "z");
if (crc32("ayQaZf",6) == 1485391745) strcat(s, "s");
if (crc32("wSACoTJl",8) == 3402810240) strcat(s, "J");
if (crc32("awSVKxeqRKsf",12) == 3332634878) strcat(s, "t");
if (crc32("CbNebafDBTITOQ",14) == 737165967) strcat(s, "y");
if (crc32("zwHanXNjgDyNo",13) == 4113111624) strcat(s, "l");
if (crc32("WoGiQHjXe",9) == 110036407) strcat(s, "e");
    return s;
}

char *preSilurian_adjectives() {
    char *s = calloc(12);
    if (crc32("STTrjMHpUThrm",13) == 1708337619) strcat(s, "p");
if (crc32("JKPjLvKXf",9) == 2066079296) strcat(s, "o");
if (crc32("tkkyT",5) == 4029592195) strcat(s, "r");
if (crc32("FIOwbvxbdwPgt",13) == 3889223720) strcat(s, "e");
if (crc32("zfQHK",5) == 3755851326) strcat(s, "S");
if (crc32("TWaJikCtPMTZj",13) == 2653779312) strcat(s, "M");
if (crc32("kIcoPLwbAnFV",12) == 1351149738) strcat(s, "i");
if (crc32("dNZHYCVblZ",10) == 2239779833) strcat(s, "H");
if (crc32("DNXAeKbvLDRfOIk",15) == 1907077745) strcat(s, "l");
if (crc32("DjddXVejW",9) == 180635049) strcat(s, "u");
if (crc32("JJTvkU",6) == 2220446529) strcat(s, "r");
if (crc32("VSACCgmUUf",10) == 4000527163) strcat(s, "i");
if (crc32("cglBqmEnHKriZTM",15) == 278164528) strcat(s, "R");
if (crc32("XHLqSYoJUFkxL",13) == 4014087064) strcat(s, "a");
if (crc32("mlDJjeeczVk",11) == 1617330197) strcat(s, "n");
    return s;
}

char *guardable_adjectives() {
    char *s = calloc(10);
    if (crc32("yKhJGUv",7) == 3617051297) strcat(s, "g");
if (crc32("pKmzsZh",7) == 607226947) strcat(s, "u");
if (crc32("MTQtXTV",7) == 1877821204) strcat(s, "L");
if (crc32("OQHfbd",6) == 1162974277) strcat(s, "a");
if (crc32("ZBWurim",7) == 4051833421) strcat(s, "b");
if (crc32("pHnYFxUkzmEfK",13) == 3682201143) strcat(s, "r");
if (crc32("CQUxU",5) == 1887844264) strcat(s, "j");
if (crc32("sDXdYuq",7) == 2116378826) strcat(s, "d");
if (crc32("TIHSMuVUbqJhygw",15) == 1013833477) strcat(s, "L");
if (crc32("ICFblsaXVV",10) == 3682163003) strcat(s, "a");
if (crc32("jfoWmjdw",8) == 1425739193) strcat(s, "V");
if (crc32("naZBYQWsKPoJOFq",15) == 3097947752) strcat(s, "b");
if (crc32("GfHVhPmnw",9) == 2280081279) strcat(s, "z");
if (crc32("oYRYxHDxedorDog",15) == 1675919141) strcat(s, "l");
if (crc32("RPyeKzNFJgDTZkl",15) == 155660152) strcat(s, "e");
    return s;
}

char *biting_adjectives() {
    char *s = calloc(7);
    if (crc32("gaQOAWzoM",9) == 969007997) strcat(s, "b");
if (crc32("bncIFkjJFjgM",12) == 4051612946) strcat(s, "i");
if (crc32("MfPvIRfjr",9) == 2019198743) strcat(s, "t");
if (crc32("XtOffXNnRkVHUEG",15) == 3377112119) strcat(s, "i");
if (crc32("EmxMbTTXUb",10) == 2789463359) strcat(s, "n");
if (crc32("nLXlp",5) == 4090953755) strcat(s, "x");
if (crc32("LSSdWFORnsV",11) == 3121601114) strcat(s, "g");
    return s;
}

char *unaddible_adjectives() {
    char *s = calloc(10);
    if (crc32("gSqYLVkNzuafYs",14) == 3853317116) strcat(s, "E");
if (crc32("oVLunJRT",8) == 658191942) strcat(s, "u");
if (crc32("mRVnkYQV",8) == 1586614659) strcat(s, "W");
if (crc32("vTWoYO",6) == 962668398) strcat(s, "n");
if (crc32("SQghJ",5) == 3163930181) strcat(s, "a");
if (crc32("KApEieLFPWiCqs",14) == 335301905) strcat(s, "d");
if (crc32("ZYYdPmWi",8) == 439111951) strcat(s, "d");
if (crc32("QCxYCOGmHrtym",13) == 2292322299) strcat(s, "i");
if (crc32("LNbVWoJ",7) == 2862568029) strcat(s, "S");
if (crc32("elEPYAH",7) == 2462189919) strcat(s, "b");
if (crc32("JEoBR",5) == 2081066680) strcat(s, "l");
if (crc32("yLUiRJGoOr",10) == 222266612) strcat(s, "e");
    return s;
}

char *bordandpillar_adjectives() {
    char *s = calloc(14);
    if (crc32("rCEEOVwhYSPLouL",15) == 2448073978) strcat(s, "b");
if (crc32("qrBLgSVxdzRdAjC",15) == 4239681965) strcat(s, "o");
if (crc32("rYWLzE",6) == 3741742464) strcat(s, "y");
if (crc32("UgFkghFvcBw",11) == 78776439) strcat(s, "r");
if (crc32("zrbQUWBwNkQkg",13) == 1502787300) strcat(s, "k");
if (crc32("JebywkeKwP",10) == 339716410) strcat(s, "d");
if (crc32("jpnizh",6) == 3946407385) strcat(s, "a");
if (crc32("clEMkC",6) == 3727971009) strcat(s, "n");
if (crc32("rJmpnCXNtDSGM",13) == 3050381548) strcat(s, "d");
if (crc32("KclrDZ",6) == 870420735) strcat(s, "p");
if (crc32("aWWzpYwmQWap",12) == 4242223756) strcat(s, "i");
if (crc32("zBFXBtKEJ",9) == 2550672199) strcat(s, "l");
if (crc32("OXoQGGTUoM",10) == 4115007303) strcat(s, "l");
if (crc32("pLYqiShBzGY",11) == 1470783571) strcat(s, "l");
if (crc32("tBIrK",5) == 3200766921) strcat(s, "K");
if (crc32("vySPrcxxrRiLwO",14) == 1204162897) strcat(s, "a");
if (crc32("aDtWT",5) == 3154311288) strcat(s, "r");
    return s;
}

char *hypocritical_adjectives() {
    char *s = calloc(13);
    if (crc32("HFsBGtpZ",8) == 1542271461) strcat(s, "e");
if (crc32("ZOdvVg",6) == 494616373) strcat(s, "h");
if (crc32("zMUzuddyHWrlH",13) == 118396747) strcat(s, "K");
if (crc32("WnxXvpO",7) == 400284475) strcat(s, "y");
if (crc32("ccicyvYjZ",9) == 216991145) strcat(s, "v");
if (crc32("OQnBlcgt",8) == 1178992047) strcat(s, "p");
if (crc32("XQIUWFEGQk",10) == 230200832) strcat(s, "o");
if (crc32("LHEkYsZ",7) == 1832478889) strcat(s, "c");
if (crc32("SoGDrPtseCGkR",13) == 492358292) strcat(s, "R");
if (crc32("NzpSWFKsyOvj",12) == 431683884) strcat(s, "r");
if (crc32("NfyvruQbgNRs",12) == 2153971213) strcat(s, "V");
if (crc32("CXdBUniDdQvI",12) == 1034254611) strcat(s, "i");
if (crc32("bzFrdJZQuHVDgT",14) == 3533955251) strcat(s, "T");
if (crc32("GEbnUK",6) == 3324552421) strcat(s, "t");
if (crc32("irLWWIQAeseLZhp",15) == 3937461961) strcat(s, "g");
if (crc32("YXCZjPOVcUlmfNv",15) == 2621009860) strcat(s, "i");
if (crc32("WfJLDBRXQdDtU",13) == 3653744709) strcat(s, "g");
if (crc32("Pmagsmsy",8) == 647086724) strcat(s, "c");
if (crc32("RZQMrBaEzdZU",12) == 920405152) strcat(s, "a");
if (crc32("vjnVEtU",7) == 3357187007) strcat(s, "Y");
if (crc32("SKZMPW",6) == 2277366516) strcat(s, "l");
    return s;
}

char *undethroned_adjectives() {
    char *s = calloc(12);
    if (crc32("FBCsYIfkUntGjqR",15) == 2964390517) strcat(s, "u");
if (crc32("ucuKVkSofFmWeD",14) == 1228871489) strcat(s, "n");
if (crc32("iJkSuHzzzyAy",12) == 1971587012) strcat(s, "z");
if (crc32("UeYDunBAyMpPTU",14) == 3851576267) strcat(s, "d");
if (crc32("QQdBEsspflEH",12) == 585653756) strcat(s, "B");
if (crc32("KDPdTxivsMyntp",14) == 2803748683) strcat(s, "e");
if (crc32("WRrBlslTNhPqWR",14) == 2623858501) strcat(s, "t");
if (crc32("TMMUKQUmmP",10) == 2807636525) strcat(s, "r");
if (crc32("dijTaq",6) == 3528422292) strcat(s, "h");
if (crc32("njYasTe",7) == 4043265266) strcat(s, "D");
if (crc32("HYSKxtrEKKByh",13) == 613499854) strcat(s, "r");
if (crc32("tWCbTBKw",8) == 1297966998) strcat(s, "C");
if (crc32("oYgQoKeb",8) == 1855586913) strcat(s, "o");
if (crc32("ifcCOPNdjAgGbg",14) == 2290654381) strcat(s, "n");
if (crc32("BDpVfcL",7) == 676277456) strcat(s, "i");
if (crc32("hkyhlE",6) == 613060338) strcat(s, "e");
if (crc32("KBZnvmMdeZgh",12) == 2455073425) strcat(s, "X");
if (crc32("COroKQl",7) == 1841135518) strcat(s, "d");
    return s;
}

char *uninfracted_adjectives() {
    char *s = calloc(12);
    if (crc32("AeJoxhhTOidk",12) == 1250565306) strcat(s, "u");
if (crc32("DhyoAsH",7) == 1397056168) strcat(s, "n");
if (crc32("jvzWACYhGDsGRY",14) == 1201934785) strcat(s, "i");
if (crc32("fypGFZ",6) == 2832901354) strcat(s, "n");
if (crc32("olTkUJhl",8) == 2672766312) strcat(s, "o");
if (crc32("pixJUJzvfImPtMD",15) == 1264878689) strcat(s, "f");
if (crc32("lBDkZfevRW",10) == 700178379) strcat(s, "F");
if (crc32("zjBxUqhVmeoO",12) == 1369197323) strcat(s, "r");
if (crc32("MwehFmGEAjrqZj",14) == 3754592551) strcat(s, "a");
if (crc32("OFvzoCltweb",11) == 3688893915) strcat(s, "H");
if (crc32("QvTmUcTXh",9) == 154249376) strcat(s, "c");
if (crc32("vlUcEZ",6) == 2156485744) strcat(s, "t");
if (crc32("FvridZSN",8) == 265803108) strcat(s, "J");
if (crc32("zKsLCeRcdwreP",13) == 3600331765) strcat(s, "e");
if (crc32("qHyRh",5) == 3438595027) strcat(s, "d");
    return s;
}

char *wieldier_adjectives() {
    char *s = calloc(9);
    if (crc32("YNDJbne",7) == 1013445252) strcat(s, "o");
if (crc32("xNkiMyvfpcz",11) == 1968745654) strcat(s, "w");
if (crc32("YXFUGeBlBlflxkc",15) == 2352689826) strcat(s, "x");
if (crc32("DCdWn",5) == 4074642039) strcat(s, "i");
if (crc32("ywwgHOnuTiz",11) == 3720253967) strcat(s, "U");
if (crc32("jPJpMseRChODBOv",15) == 2502746265) strcat(s, "e");
if (crc32("shXLUMx",7) == 211083117) strcat(s, "l");
if (crc32("ljgYAJZBnxz",11) == 685811683) strcat(s, "j");
if (crc32("KmKCfSs",7) == 3712542065) strcat(s, "d");
if (crc32("hekcmIsLNUcTLaf",15) == 988290440) strcat(s, "n");
if (crc32("alLRrwvMWCjWhTq",15) == 2873410549) strcat(s, "i");
if (crc32("nJjlp",5) == 2383763631) strcat(s, "t");
if (crc32("fvqKxedF",8) == 1845161926) strcat(s, "e");
if (crc32("sFGTfh",6) == 2005261263) strcat(s, "B");
if (crc32("vzRPcpSQNLCw",12) == 1233631149) strcat(s, "r");
    return s;
}

char *undefaming_adjectives() {
    char *s = calloc(11);
    if (crc32("thCrLuEesLXt",12) == 4134735370) strcat(s, "u");
if (crc32("UFvFyP",6) == 2514946167) strcat(s, "n");
if (crc32("ozfjnxEOZt",10) == 2764399482) strcat(s, "d");
if (crc32("ZQJaNmFTAWOi",12) == 1861538429) strcat(s, "F");
if (crc32("xDntwXhiNKernt",14) == 3623105566) strcat(s, "e");
if (crc32("ArCpesgB",8) == 828326245) strcat(s, "U");
if (crc32("DSqqAfe",7) == 3475260618) strcat(s, "f");
if (crc32("ABMtulqW",8) == 3823237013) strcat(s, "q");
if (crc32("DHlaOVdXXQp",11) == 3187160283) strcat(s, "a");
if (crc32("ywBboXcAWNQcC",13) == 1180039401) strcat(s, "u");
if (crc32("chkAZEsR",8) == 3609808595) strcat(s, "m");
if (crc32("MMYROlkOIBbu",12) == 939386037) strcat(s, "i");
if (crc32("uXsnIH",6) == 2150722925) strcat(s, "n");
if (crc32("cRcVdTcnAtKd",12) == 3659368041) strcat(s, "v");
if (crc32("IwrfmeaMiGKRE",13) == 3560710432) strcat(s, "g");
    return s;
}

char *postulnar_adjectives() {
    char *s = calloc(10);
    if (crc32("xNdQIcjCoblD",12) == 3403098769) strcat(s, "p");
if (crc32("iwGoITsN",8) == 533277002) strcat(s, "M");
if (crc32("goTnOaIOaHoOG",13) == 900477619) strcat(s, "o");
if (crc32("fJpEAqhbMTcep",13) == 3263533518) strcat(s, "G");
if (crc32("qCunhNeYOEpp",12) == 3209554179) strcat(s, "s");
if (crc32("SUZiAbLivtWfn",13) == 1038741961) strcat(s, "t");
if (crc32("rJAfi",5) == 60682149) strcat(s, "g");
if (crc32("uzbtzr",6) == 4030970839) strcat(s, "u");
if (crc32("GtoGRFCy",8) == 4119355565) strcat(s, "U");
if (crc32("qpAoUIoHzPKPpF",14) == 627389179) strcat(s, "l");
if (crc32("JtuIQsoE",8) == 2024518811) strcat(s, "f");
if (crc32("ehbONp",6) == 2494555396) strcat(s, "n");
if (crc32("yIkDoQOgZTC",11) == 58150090) strcat(s, "U");
if (crc32("fVzvUDvkxX",10) == 4121156224) strcat(s, "a");
if (crc32("sbTuuWZKkeybNH",14) == 1269227162) strcat(s, "A");
if (crc32("OLjnVqkHBFsW",12) == 3504728352) strcat(s, "r");
    return s;
}

char *morphonemic_adjectives() {
    char *s = calloc(12);
    if (crc32("bxXiLxcPyYVJpTK",15) == 1904791149) strcat(s, "m");
if (crc32("inMZHDfbSm",10) == 3591876180) strcat(s, "o");
if (crc32("ZDJzCSGCSL",10) == 1377558612) strcat(s, "r");
if (crc32("zJMhYnYsgAIO",12) == 433249608) strcat(s, "p");
if (crc32("WpwjpnVN",8) == 1207924731) strcat(s, "h");
if (crc32("lNtMSpcBpY",10) == 655021245) strcat(s, "o");
if (crc32("BDqspBgESSjK",12) == 583115344) strcat(s, "n");
if (crc32("NLXtfahJdzzWvM",14) == 1086890046) strcat(s, "e");
if (crc32("PSYCQTujgeNwcns",15) == 1190317676) strcat(s, "m");
if (crc32("bYQHgVQlLVv",11) == 1965937348) strcat(s, "i");
if (crc32("kdRuBDyylA",10) == 137818340) strcat(s, "c");
    return s;
}

char *antilottery_adjectives() {
    char *s = calloc(12);
    if (crc32("NOXzRE",6) == 4098271498) strcat(s, "P");
if (crc32("yLFMdFOoCk",10) == 3728763169) strcat(s, "a");
if (crc32("hUkSSWSQWxKKUV",14) == 2215024786) strcat(s, "Y");
if (crc32("ScaRVzfQTnyc",12) == 3077065614) strcat(s, "n");
if (crc32("megLgLV",7) == 959143131) strcat(s, "W");
if (crc32("URtHgtS",7) == 194832214) strcat(s, "t");
if (crc32("gUeKsAdWftuy",12) == 733497733) strcat(s, "j");
if (crc32("wSApMjJZBMBfgt",14) == 3224118681) strcat(s, "i");
if (crc32("rUyXicMcVOq",11) == 2902828322) strcat(s, "Q");
if (crc32("RgStg",5) == 3565124844) strcat(s, "l");
if (crc32("WczIKVmyzE",10) == 2724818290) strcat(s, "o");
if (crc32("HgbXnQ",6) == 1833559348) strcat(s, "t");
if (crc32("wDUnpWSDTWdpobK",15) == 3746330488) strcat(s, "Y");
if (crc32("XWgrixVEtCYZQa",14) == 1773971139) strcat(s, "t");
if (crc32("khLpRlvY",8) == 2090594156) strcat(s, "j");
if (crc32("lhjZOcfrCNr",11) == 3080242751) strcat(s, "e");
if (crc32("xdtcuw",6) == 149214236) strcat(s, "r");
if (crc32("AZMOqslt",8) == 3410710450) strcat(s, "X");
if (crc32("umPmWPyuJLpMt",13) == 2788174772) strcat(s, "y");
    return s;
}

char *nondiscriminating_adjectives() {
    char *s = calloc(18);
    if (crc32("cJIofomvAwTYt",13) == 1049059932) strcat(s, "n");
if (crc32("EheRLRVtgprGCLb",15) == 1461198718) strcat(s, "o");
if (crc32("ShyCDHBYgou",11) == 296185427) strcat(s, "u");
if (crc32("skGdOrFFh",9) == 984024828) strcat(s, "n");
if (crc32("NyuzGX",6) == 1566311653) strcat(s, "T");
if (crc32("ZOSLchCqWPn",11) == 1084347745) strcat(s, "d");
if (crc32("gOWjwtxlHNdI",12) == 3743335956) strcat(s, "i");
if (crc32("azvGImcEcMFRi",13) == 2610794131) strcat(s, "Y");
if (crc32("FigrxRvaKOIk",12) == 480383839) strcat(s, "s");
if (crc32("YrwrHYnIxDiR",12) == 312987053) strcat(s, "y");
if (crc32("NoJqwibLf",9) == 1728435459) strcat(s, "c");
if (crc32("VLUfeaqKE",9) == 992442734) strcat(s, "O");
if (crc32("uhWpRmQAwHvl",12) == 1818484089) strcat(s, "r");
if (crc32("zFiojrlrVhbRPG",14) == 3120495171) strcat(s, "i");
if (crc32("UhtIzF",6) == 3295143556) strcat(s, "n");
if (crc32("WOnUf",5) == 2922522619) strcat(s, "m");
if (crc32("PojRvSWNL",9) == 3643892744) strcat(s, "E");
if (crc32("HasOaUzNWXbnC",13) == 2744827163) strcat(s, "i");
if (crc32("HrXQTGXh",8) == 3437908373) strcat(s, "g");
if (crc32("mwxOtqUdP",9) == 325410523) strcat(s, "n");
if (crc32("BROQmalLsNfm",12) == 1081776092) strcat(s, "G");
if (crc32("vJZYF",5) == 3522491381) strcat(s, "a");
if (crc32("PAjYuOKqtD",10) == 3331940007) strcat(s, "t");
if (crc32("xrNXlZYzLQA",11) == 2530020694) strcat(s, "e");
if (crc32("RaQIbNFiMG",10) == 2877633114) strcat(s, "i");
if (crc32("PqFnIpa",7) == 407657219) strcat(s, "n");
if (crc32("bHJVYxAFAthVhvJ",15) == 1193958750) strcat(s, "g");
    return s;
}

char *lukewarm_adjectives() {
    char *s = calloc(9);
    if (crc32("fhCyRj",6) == 3019157068) strcat(s, "T");
if (crc32("DtIZWNTITvyJfkY",15) == 2453130160) strcat(s, "l");
if (crc32("AxhbOZIsZKUxhfR",15) == 738071603) strcat(s, "p");
if (crc32("TKHTD",5) == 2521530507) strcat(s, "u");
if (crc32("nwsqNdddjNqFoK",14) == 1113249617) strcat(s, "b");
if (crc32("pebIRicXTghrrJ",14) == 3706791588) strcat(s, "k");
if (crc32("ETmoNDgxVuCa",12) == 540267827) strcat(s, "K");
if (crc32("weZVvIVOS",9) == 3398322720) strcat(s, "e");
if (crc32("JlMgf",5) == 3159642900) strcat(s, "j");
if (crc32("xLQiZG",6) == 1475044034) strcat(s, "w");
if (crc32("DHtPOK",6) == 1401301240) strcat(s, "a");
if (crc32("JwiWNhloOsLD",12) == 368982921) strcat(s, "r");
if (crc32("RzcCkwTd",8) == 1992131754) strcat(s, "s");
if (crc32("YpUrXUQGPWkUA",13) == 4053474353) strcat(s, "m");
    return s;
}

char *unserviceable_adjectives() {
    char *s = calloc(14);
    if (crc32("OMtPL",5) == 155551828) strcat(s, "Q");
if (crc32("badlevRFLECRbVf",15) == 119743783) strcat(s, "u");
if (crc32("txnfYG",6) == 4239474934) strcat(s, "n");
if (crc32("pIHtQCam",8) == 3106974720) strcat(s, "s");
if (crc32("nXdUKcCYATlzTmd",15) == 1060049523) strcat(s, "d");
if (crc32("VFrWAUNoxFZ",11) == 2757250965) strcat(s, "e");
if (crc32("tRoergVIIBkaiQ",14) == 3213512087) strcat(s, "r");
if (crc32("USnGdFgm",8) == 2547433388) strcat(s, "L");
if (crc32("oosnM",5) == 463560153) strcat(s, "v");
if (crc32("OweXsaVZQmpFyyh",15) == 3811773136) strcat(s, "i");
if (crc32("FsroMW",6) == 221897223) strcat(s, "T");
if (crc32("TUQKdNi",7) == 1251568210) strcat(s, "c");
if (crc32("cZFsLBlTi",9) == 3926274043) strcat(s, "e");
if (crc32("fLvyRVxTQ",9) == 3663287245) strcat(s, "r");
if (crc32("KuyMJbQi",8) == 201272401) strcat(s, "a");
if (crc32("dNSRrhitiD",10) == 2110104950) strcat(s, "b");
if (crc32("aljMTdrWTCvtoy",14) == 1823668918) strcat(s, "l");
if (crc32("VSQcN",5) == 436436302) strcat(s, "e");
    return s;
}

char *untwirled_adjectives() {
    char *s = calloc(10);
    if (crc32("kHcypLWFuZFbLkP",15) == 1904052096) strcat(s, "u");
if (crc32("DBkRpPUn",8) == 1230035367) strcat(s, "F");
if (crc32("NSdJAU",6) == 3221867737) strcat(s, "n");
if (crc32("KYwxTBuFk",9) == 3975021509) strcat(s, "t");
if (crc32("NxDpKSoAfb",10) == 4044857815) strcat(s, "w");
if (crc32("sdqPQqF",7) == 484931664) strcat(s, "l");
if (crc32("pMEMFTWDJnvqip",14) == 1346953124) strcat(s, "i");
if (crc32("KelUSpzdfGKERoC",15) == 2645642581) strcat(s, "Q");
if (crc32("AtkbiHHb",8) == 3125318430) strcat(s, "r");
if (crc32("ZDYMNNFJH",9) == 866644222) strcat(s, "l");
if (crc32("siguhTaiB",9) == 2108181259) strcat(s, "e");
if (crc32("PSybjnDRP",9) == 4012916406) strcat(s, "d");
    return s;
}

char *aphoristic_adjectives() {
    char *s = calloc(11);
    if (crc32("eJApoMNgB",9) == 461922310) strcat(s, "a");
if (crc32("buXzvf",6) == 1379304664) strcat(s, "F");
if (crc32("NqigjstGW",9) == 683398758) strcat(s, "p");
if (crc32("HnDjAr",6) == 1922305862) strcat(s, "h");
if (crc32("DtjLSRcpJyQW",12) == 960268705) strcat(s, "J");
if (crc32("XYpMqAFDEOz",11) == 1384042736) strcat(s, "o");
if (crc32("fekyd",5) == 1444561303) strcat(s, "B");
if (crc32("YuVtwrzrHNDnw",13) == 2007637768) strcat(s, "r");
if (crc32("eUVBbguIsV",10) == 2190165264) strcat(s, "B");
if (crc32("ZwKKkxriNYwdgmc",15) == 2763770206) strcat(s, "i");
if (crc32("SugREJaMMdcfjw",14) == 2960001127) strcat(s, "s");
if (crc32("jHRdxyDLs",9) == 3486855829) strcat(s, "t");
if (crc32("yRrMgdgpd",9) == 3524626224) strcat(s, "i");
if (crc32("dHFBRZ",6) == 1275567586) strcat(s, "I");
if (crc32("PuBJqUfwQfElL",13) == 1656354397) strcat(s, "c");
    return s;
}

char *nonuniversal_adjectives() {
    char *s = calloc(13);
    if (crc32("naTacRWbGzKsw",13) == 932850043) strcat(s, "n");
if (crc32("BPRKLhskkPrpNJS",15) == 263003091) strcat(s, "o");
if (crc32("xFZzoPboghhxjf",14) == 2583078737) strcat(s, "F");
if (crc32("fvUalbhtR",9) == 1410718990) strcat(s, "n");
if (crc32("BpAyuTBZtX",10) == 4245192744) strcat(s, "u");
if (crc32("TpOPlhAWvauk",12) == 1495989988) strcat(s, "n");
if (crc32("tduLy",5) == 1494987372) strcat(s, "i");
if (crc32("xCAkGFCIwdZDTF",14) == 1059231928) strcat(s, "T");
if (crc32("BktzZjndGxdRUX",14) == 3700106201) strcat(s, "v");
if (crc32("QxSkNjuVFH",10) == 2122347169) strcat(s, "e");
if (crc32("CJDcH",5) == 1822210311) strcat(s, "e");
if (crc32("ZfBVgSS",7) == 643632619) strcat(s, "r");
if (crc32("pirUIKPBnOf",11) == 3214703126) strcat(s, "f");
if (crc32("uGSLY",5) == 3511845270) strcat(s, "s");
if (crc32("RJzJGXYAKnRwE",13) == 2595273919) strcat(s, "a");
if (crc32("fDNNtBl",7) == 2826495877) strcat(s, "l");
    return s;
}

char *unraving_adjectives() {
    char *s = calloc(9);
    if (crc32("KOfHuVoa",8) == 4189642631) strcat(s, "u");
if (crc32("MlqAQRW",7) == 811617735) strcat(s, "n");
if (crc32("kLfAKsnMfsElA",13) == 1194897406) strcat(s, "d");
if (crc32("ZKKDGfALkR",10) == 2292391309) strcat(s, "r");
if (crc32("JVYyrYBsMHD",11) == 4129014166) strcat(s, "g");
if (crc32("nwggDfy",7) == 2966196733) strcat(s, "a");
if (crc32("WPdQr",5) == 2791956234) strcat(s, "W");
if (crc32("kasibojZqxMnkzP",15) == 3778867444) strcat(s, "v");
if (crc32("lmotfN",6) == 1026054673) strcat(s, "i");
if (crc32("nxqFzHwrVWuAG",13) == 2178188689) strcat(s, "p");
if (crc32("HfueOSon",8) == 2565077012) strcat(s, "n");
if (crc32("zHlEoiGUsCqh",12) == 229484958) strcat(s, "g");
    return s;
}

char *jannock_adjectives() {
    char *s = calloc(8);
    if (crc32("KEgGFzEkAHbYf",13) == 3611625364) strcat(s, "Q");
if (crc32("cLIRx",5) == 1617587602) strcat(s, "j");
if (crc32("fHCzmhowsgO",11) == 4246779802) strcat(s, "a");
if (crc32("cQYPsvButXLfdaL",15) == 861225935) strcat(s, "n");
if (crc32("FliLCZRwlyvCDTB",15) == 2428896617) strcat(s, "n");
if (crc32("AIXevzTBju",10) == 1820990666) strcat(s, "H");
if (crc32("pPnpFXewTg",10) == 3485316622) strcat(s, "o");
if (crc32("uVXhdByaXePPco",14) == 3865752998) strcat(s, "x");
if (crc32("sZcLHMvxIrO",11) == 565688278) strcat(s, "c");
if (crc32("RCyqfFyHFx",10) == 3643356072) strcat(s, "k");
    return s;
}

char *unexpiring_adjectives() {
    char *s = calloc(11);
    if (crc32("qRJMPHHNCR",10) == 633127621) strcat(s, "u");
if (crc32("uiOjjsJbNCz",11) == 2302713086) strcat(s, "z");
if (crc32("JLPASdpkdlOtA",13) == 153131195) strcat(s, "n");
if (crc32("eFAcqsBf",8) == 600710587) strcat(s, "e");
if (crc32("bZnbWqeWFiaHDh",14) == 1930183254) strcat(s, "A");
if (crc32("BZrAnNVyfrnd",12) == 17828401) strcat(s, "x");
if (crc32("aUTOOKTkawo",11) == 2028839418) strcat(s, "p");
if (crc32("OMDkwubgGuDA",12) == 3661975956) strcat(s, "i");
if (crc32("YftBmxOJLKzXg",13) == 1970085894) strcat(s, "r");
if (crc32("AKYxdpB",7) == 4220752382) strcat(s, "s");
if (crc32("hcVEHcuM",8) == 3634543609) strcat(s, "i");
if (crc32("ofzqUuhJ",8) == 3724607090) strcat(s, "m");
if (crc32("gyStnrwPwqGYtwy",15) == 1192969211) strcat(s, "n");
if (crc32("AoUpaRj",7) == 580966023) strcat(s, "w");
if (crc32("PXybHhutjkR",11) == 1999919651) strcat(s, "g");
    return s;
}

char *selfpowered_adjectives() {
    char *s = calloc(12);
    if (crc32("YIoJWLsPMWKlZ",13) == 3584087528) strcat(s, "c");
if (crc32("wAtzLWWZzSjR",12) == 763988168) strcat(s, "s");
if (crc32("CzBqhTdsrCUjnZ",14) == 1303291129) strcat(s, "M");
if (crc32("rkIOKaIlVPfQHpJ",15) == 315469249) strcat(s, "e");
if (crc32("DDorDgARGC",10) == 726356744) strcat(s, "t");
if (crc32("GiMYOaDQGfVdt",13) == 2181496139) strcat(s, "l");
if (crc32("akSXULJpk",9) == 2064853530) strcat(s, "f");
if (crc32("tFMfMiZTgzzy",12) == 525867967) strcat(s, "X");
if (crc32("sueiZNLPkUSnE",13) == 1839162162) strcat(s, "p");
if (crc32("kCNqUs",6) == 2786941709) strcat(s, "R");
if (crc32("KRNSIOPuGlgEY",13) == 3772379188) strcat(s, "o");
if (crc32("oYxZJ",5) == 3891950353) strcat(s, "w");
if (crc32("ZlsWNX",6) == 1529257076) strcat(s, "e");
if (crc32("PMOeRLsor",9) == 960722973) strcat(s, "C");
if (crc32("fMvhGDPTvOOYg",13) == 241937851) strcat(s, "r");
if (crc32("HEkzOSfLVYOOJzz",15) == 1048623327) strcat(s, "t");
if (crc32("mGgisEKyKlOCq",13) == 1300035261) strcat(s, "e");
if (crc32("LHinfSgrojOcGbM",15) == 1407149217) strcat(s, "d");
    return s;
}

char *extirpative_adjectives() {
    char *s = calloc(12);
    if (crc32("UabFR",5) == 3713982677) strcat(s, "e");
if (crc32("PDtukDwKIlO",11) == 2271787868) strcat(s, "x");
if (crc32("kucKaQLZjNwbz",13) == 828979559) strcat(s, "R");
if (crc32("SofylKwHKorXDYS",15) == 187190488) strcat(s, "t");
if (crc32("hPRIeOnh",8) == 2658499739) strcat(s, "i");
if (crc32("zQtNRWiR",8) == 2479687399) strcat(s, "r");
if (crc32("mUHwQFiVSG",10) == 1806799590) strcat(s, "p");
if (crc32("VQQzU",5) == 2708460849) strcat(s, "a");
if (crc32("nvsAZfNVNEBJDV",14) == 3404672420) strcat(s, "t");
if (crc32("owgfye",6) == 706482099) strcat(s, "i");
if (crc32("dzLnrPHmIz",10) == 2660817044) strcat(s, "K");
if (crc32("DZXaYLqQvEfmkP",14) == 2011246909) strcat(s, "v");
if (crc32("KjxROeYGA",9) == 1861318629) strcat(s, "e");
    return s;
}

char *republican_adjectives() {
    char *s = calloc(11);
    if (crc32("QkIblKkbtPKQ",12) == 2330969560) strcat(s, "l");
if (crc32("CkzXHqGmTjf",11) == 706158444) strcat(s, "r");
if (crc32("LUyOJCyhPOXOOZt",15) == 3769781826) strcat(s, "e");
if (crc32("ZpsEcuFy",8) == 2757401431) strcat(s, "p");
if (crc32("ApCBsBFfhuRIhLH",15) == 1211926677) strcat(s, "h");
if (crc32("uyDHZd",6) == 2124135650) strcat(s, "u");
if (crc32("bkWDkS",6) == 1210324113) strcat(s, "I");
if (crc32("HaSmjuv",7) == 833729814) strcat(s, "b");
if (crc32("UpAndfHEeQrCuU",14) == 3713282660) strcat(s, "l");
if (crc32("plihNA",6) == 3148025167) strcat(s, "I");
if (crc32("IglZAlXi",8) == 874344243) strcat(s, "i");
if (crc32("hbiww",5) == 2661983184) strcat(s, "r");
if (crc32("DfOMyu",6) == 1457420992) strcat(s, "c");
if (crc32("WBEAaMk",7) == 1553425358) strcat(s, "a");
if (crc32("oNzydbgBXNcmGAy",15) == 3232022366) strcat(s, "o");
if (crc32("SPrpLxivWGFtapo",15) == 1309359169) strcat(s, "n");
    return s;
}

char *gemmological_adjectives() {
    char *s = calloc(13);
    if (crc32("XcBLfweaPmbTLjA",15) == 1696339392) strcat(s, "v");
if (crc32("mehsZIAAUeec",12) == 766051496) strcat(s, "g");
if (crc32("LRJskAq",7) == 1859438203) strcat(s, "a");
if (crc32("JfrwNUAA",8) == 3238274193) strcat(s, "e");
if (crc32("pOHqDyUaBpTJ",12) == 1906207774) strcat(s, "m");
if (crc32("ZciHj",5) == 2777100556) strcat(s, "i");
if (crc32("YrSdm",5) == 1853821215) strcat(s, "m");
if (crc32("TLfyulfGdEXL",12) == 1639143439) strcat(s, "j");
if (crc32("PfhMAIwv",8) == 425588368) strcat(s, "o");
if (crc32("SeIZxFYWSTKzrx",14) == 359384667) strcat(s, "S");
if (crc32("zbzDudY",7) == 1983915014) strcat(s, "l");
if (crc32("RqpfhvCjNA",10) == 3429905194) strcat(s, "o");
if (crc32("tDUVSDoFaXNsM",13) == 432800172) strcat(s, "G");
if (crc32("wzSrW",5) == 263111920) strcat(s, "g");
if (crc32("zzhqWlxKsyJX",12) == 2406785338) strcat(s, "F");
if (crc32("ySAvfKbGCGUM",12) == 488196851) strcat(s, "i");
if (crc32("HtbkZRWdxtbcTDq",15) == 3041996547) strcat(s, "z");
if (crc32("VJotKphXZ",9) == 1230355782) strcat(s, "c");
if (crc32("IpypsBTTGiWuzL",14) == 11071337) strcat(s, "a");
if (crc32("kqZAPwE",7) == 2413594025) strcat(s, "l");
    return s;
}

char *halfItalian_adjectives() {
    char *s = calloc(12);
    if (crc32("wIbGjNSxAeA",11) == 744092908) strcat(s, "h");
if (crc32("eiVSexKOYoqmvi",14) == 586000502) strcat(s, "H");
if (crc32("capBUUloXUhHK",13) == 2428144521) strcat(s, "a");
if (crc32("PHzcwIYwdg",10) == 3458398181) strcat(s, "l");
if (crc32("lcxqQyzDPWw",11) == 2040820241) strcat(s, "f");
if (crc32("wOddciJa",8) == 3499458738) strcat(s, "I");
if (crc32("DIImZ",5) == 2850751852) strcat(s, "t");
if (crc32("SfijKXMvgcWPIs",14) == 2407930700) strcat(s, "c");
if (crc32("lopZdeBjs",9) == 1369572106) strcat(s, "a");
if (crc32("kVOkwL",6) == 4232309361) strcat(s, "l");
if (crc32("ydZGMxGtwBo",11) == 478930945) strcat(s, "O");
if (crc32("wvbPuBotJRR",11) == 325115139) strcat(s, "i");
if (crc32("AxUtvqERFRPxi",13) == 114760483) strcat(s, "a");
if (crc32("NQxYJonkd",9) == 1020891291) strcat(s, "s");
if (crc32("HvZPkxPbdpc",11) == 1034406319) strcat(s, "n");
    return s;
}

char *precisive_adjectives() {
    char *s = calloc(10);
    if (crc32("fVXjTXIQpbviU",13) == 1579137524) strcat(s, "p");
if (crc32("IaJlre",6) == 2826084420) strcat(s, "r");
if (crc32("gYJJykMkDWEwScU",15) == 3312898837) strcat(s, "u");
if (crc32("LciUUVCxikcFJ",13) == 948665313) strcat(s, "e");
if (crc32("cCvjXKNjgKGysn",14) == 1277479003) strcat(s, "e");
if (crc32("vQieizNAtQgrSra",15) == 904166789) strcat(s, "c");
if (crc32("bJPFDfyFub",10) == 57122574) strcat(s, "s");
if (crc32("IkROt",5) == 811049238) strcat(s, "i");
if (crc32("WQagSQrK",8) == 483191096) strcat(s, "I");
if (crc32("CFeGdXHnosD",11) == 2555634831) strcat(s, "s");
if (crc32("TpDbdvngBN",10) == 4220478545) strcat(s, "L");
if (crc32("IYAuwoTfb",9) == 3034266131) strcat(s, "i");
if (crc32("dNVfjXAoAOOC",12) == 3444026638) strcat(s, "i");
if (crc32("jaCpqZyppWM",11) == 2097672846) strcat(s, "v");
if (crc32("qGNPsgcSsnN",11) == 2563616615) strcat(s, "e");
    return s;
}

char *fibroid_adjectives() {
    char *s = calloc(8);
    if (crc32("aDRZAiGIvRbdjxA",15) == 1203326806) strcat(s, "f");
if (crc32("MRgjGGHtOk",10) == 3279765545) strcat(s, "G");
if (crc32("gHQeUpkO",8) == 2527074071) strcat(s, "i");
if (crc32("EFLwDTEM",8) == 3930876416) strcat(s, "b");
if (crc32("VMlRiOqIkrNb",12) == 543417798) strcat(s, "o");
if (crc32("cTSCimFBGTfPKT",14) == 2188855584) strcat(s, "r");
if (crc32("DlxEICuCxMEsK",13) == 2990850704) strcat(s, "o");
if (crc32("XkrYmrLGzYqHEq",14) == 2050994155) strcat(s, "i");
if (crc32("TlgfdsYgeBZH",12) == 228802981) strcat(s, "w");
if (crc32("TWetQlp",7) == 448918643) strcat(s, "d");
    return s;
}

char *unhackled_adjectives() {
    char *s = calloc(10);
    if (crc32("JzSMTGKUlabyE",13) == 3056266786) strcat(s, "u");
if (crc32("OlfuWAcMqargenO",15) == 2088560637) strcat(s, "N");
if (crc32("zVvByBUYyaYLHW",14) == 3728318392) strcat(s, "n");
if (crc32("vqUqwywCFt",10) == 1061561823) strcat(s, "h");
if (crc32("ljJLhBqORwKelyW",15) == 2432536507) strcat(s, "a");
if (crc32("GZlKlyIr",8) == 615185189) strcat(s, "c");
if (crc32("ztJYfitEzWStaK",14) == 1866179333) strcat(s, "k");
if (crc32("WoykHPBYY",9) == 401856104) strcat(s, "d");
if (crc32("bDWNBMaiOL",10) == 3503625196) strcat(s, "l");
if (crc32("NiAwehmrW",9) == 3301257569) strcat(s, "I");
if (crc32("WraJeHPv",8) == 3782290103) strcat(s, "e");
if (crc32("ObwbH",5) == 4196942915) strcat(s, "o");
if (crc32("hMOdZyuxlBy",11) == 557118321) strcat(s, "d");
    return s;
}

char *misleading_adjectives() {
    char *s = calloc(11);
    if (crc32("ZOvQFtQEovwHg",13) == 2387379798) strcat(s, "m");
if (crc32("RqaYciFSYc",10) == 1723518187) strcat(s, "i");
if (crc32("fxikNIxWsptL",12) == 2451252891) strcat(s, "s");
if (crc32("PRFxTP",6) == 1293666892) strcat(s, "k");
if (crc32("dqYBcQMNguv",11) == 668611214) strcat(s, "l");
if (crc32("HivphiSn",8) == 4053299212) strcat(s, "h");
if (crc32("biJwly",6) == 626667889) strcat(s, "e");
if (crc32("oFpVvaBHOxVflKe",15) == 2409657252) strcat(s, "d");
if (crc32("eNFbzWVrvyFgdMg",15) == 1446617676) strcat(s, "a");
if (crc32("yKuVKHfIsgU",11) == 2477584348) strcat(s, "d");
if (crc32("lqyMf",5) == 3856051848) strcat(s, "T");
if (crc32("KYiPkPFHGWM",11) == 4201113300) strcat(s, "i");
if (crc32("ZZbNXFMOljnS",12) == 18596682) strcat(s, "n");
if (crc32("WKmpuaeKP",9) == 3510822684) strcat(s, "T");
if (crc32("aeOcXUPFcBm",11) == 3818188555) strcat(s, "g");
    return s;
}

char *noncereal_adjectives() {
    char *s = calloc(10);
    if (crc32("bVysynsAti",10) == 613407844) strcat(s, "n");
if (crc32("QkYtdtM",7) == 2806233782) strcat(s, "o");
if (crc32("wsoKS",5) == 1446960685) strcat(s, "n");
if (crc32("sAwqg",5) == 2818307563) strcat(s, "u");
if (crc32("HutEZiMvqYnsevF",15) == 170991226) strcat(s, "c");
if (crc32("MIxUq",5) == 980528385) strcat(s, "e");
if (crc32("TRqlkgwDuk",10) == 2701060492) strcat(s, "I");
if (crc32("NSofSakmAp",10) == 4069321395) strcat(s, "r");
if (crc32("XvXCoLkbMyxfnI",14) == 1919682838) strcat(s, "e");
if (crc32("BuhPGZthWFhoX",13) == 1250409840) strcat(s, "a");
if (crc32("WKnnWguWYhxYZck",15) == 4075251366) strcat(s, "H");
if (crc32("SxFMyGVJHde",11) == 448964614) strcat(s, "l");
    return s;
}

char *acuminate_adjectives() {
    char *s = calloc(10);
    if (crc32("OrDGPHLsq",9) == 2607124557) strcat(s, "i");
if (crc32("uzrVnmRkt",9) == 2442800865) strcat(s, "a");
if (crc32("mRxEnUxlEx",10) == 227784615) strcat(s, "q");
if (crc32("LMhXrjfkeNKT",12) == 2689680537) strcat(s, "c");
if (crc32("cdFlXJInRr",10) == 461176447) strcat(s, "u");
if (crc32("ODsqIshVhw",10) == 71721689) strcat(s, "m");
if (crc32("aAwLvIFb",8) == 616245320) strcat(s, "i");
if (crc32("semvLIBLNtYMCRc",15) == 3837358427) strcat(s, "Y");
if (crc32("kcDWRNXXPguShv",14) == 4278888627) strcat(s, "n");
if (crc32("BTmGgWhcDnFa",12) == 1036045972) strcat(s, "a");
if (crc32("IVYUxIUNeV",10) == 355390448) strcat(s, "t");
if (crc32("MvlrLwlpOx",10) == 3365033512) strcat(s, "e");
    return s;
}

char *excitant_adjectives() {
    char *s = calloc(9);
    if (crc32("lUewtLkeCJZlMfS",15) == 1712851613) strcat(s, "P");
if (crc32("JjkTyFzGX",9) == 996350823) strcat(s, "e");
if (crc32("CpcdSBmRe",9) == 1065973271) strcat(s, "x");
if (crc32("jeCxTsl",7) == 1894283772) strcat(s, "c");
if (crc32("WQSUcAhYrcyBzHl",15) == 77252192) strcat(s, "j");
if (crc32("AZygnZfWVFOn",12) == 698138394) strcat(s, "i");
if (crc32("uqhbbLE",7) == 3865575065) strcat(s, "R");
if (crc32("ibTGajdQ",8) == 272951004) strcat(s, "t");
if (crc32("bLEetzrcaeFyE",13) == 2245907734) strcat(s, "a");
if (crc32("DIlNLlC",7) == 1874325328) strcat(s, "J");
if (crc32("BhDAmUKmiHKj",12) == 2874239155) strcat(s, "n");
if (crc32("QEnqdLmHGsHvo",13) == 1475243210) strcat(s, "t");
    return s;
}

char *chirpy_adjectives() {
    char *s = calloc(7);
    if (crc32("nnlLLXoFsW",10) == 710679074) strcat(s, "c");
if (crc32("qRQRvv",6) == 4024793868) strcat(s, "h");
if (crc32("lfcufNXC",8) == 1286393450) strcat(s, "i");
if (crc32("SWqaNw",6) == 2516085493) strcat(s, "q");
if (crc32("RSPTKIHLYKSJpU",14) == 2920485388) strcat(s, "r");
if (crc32("ZYDuqgkaU",9) == 3784386346) strcat(s, "p");
if (crc32("sxoZTXjCo",9) == 3009726846) strcat(s, "C");
if (crc32("hbfmSaeFIt",10) == 2411631175) strcat(s, "y");
    return s;
}

char *presentperfect_adjectives() {
    char *s = calloc(15);
    if (crc32("QTCRm",5) == 2038264595) strcat(s, "j");
if (crc32("UfMrUTdGhrzDH",13) == 1792236508) strcat(s, "p");
if (crc32("ZhpdQGwPnx",10) == 1801187988) strcat(s, "r");
if (crc32("NrZlDMIsuBWt",12) == 3217737679) strcat(s, "V");
if (crc32("ugyieJrKztG",11) == 111820246) strcat(s, "e");
if (crc32("bZzgmFsnPbvUnTu",15) == 1202745249) strcat(s, "e");
if (crc32("kEdoKRiWzas",11) == 1100690293) strcat(s, "s");
if (crc32("YDfcbIPtdviXhL",14) == 1454210413) strcat(s, "z");
if (crc32("lHpKCVyFsqhF",12) == 2451826546) strcat(s, "e");
if (crc32("ebmPrNiQdC",10) == 2866240216) strcat(s, "n");
if (crc32("tniZMOXrYN",10) == 171760920) strcat(s, "t");
if (crc32("WfPoeQ",6) == 979068478) strcat(s, "p");
if (crc32("erRTFMNUX",9) == 62039261) strcat(s, "J");
if (crc32("rbxQsQYEdJEohmr",15) == 3623458310) strcat(s, "e");
if (crc32("dvakvGZdvdf",11) == 410689108) strcat(s, "r");
if (crc32("MotPIhP",7) == 1061763569) strcat(s, "f");
if (crc32("DxfRkMJrSNrDnjw",15) == 2664692918) strcat(s, "w");
if (crc32("SXAvzZmglt",10) == 3493989129) strcat(s, "e");
if (crc32("kCEfh",5) == 2818452722) strcat(s, "c");
if (crc32("KFskpnzKiDvqQH",14) == 280452958) strcat(s, "J");
if (crc32("HUdKSgeVVfWQn",13) == 2442847943) strcat(s, "t");
    return s;
}

char *nonrefractive_adjectives() {
    char *s = calloc(14);
    if (crc32("CIqeGbHYOScBN",13) == 3951670911) strcat(s, "D");
if (crc32("KDAjGfm",7) == 198220440) strcat(s, "n");
if (crc32("dgFwCdKQzHCQ",12) == 725392208) strcat(s, "o");
if (crc32("hsJIJNwXhZIfHL",14) == 36736230) strcat(s, "E");
if (crc32("AvJNajQXYF",10) == 1221642450) strcat(s, "n");
if (crc32("LAyLieBneAKRQa",14) == 3019409704) strcat(s, "r");
if (crc32("pZvQeIyPUh",10) == 4007033118) strcat(s, "e");
if (crc32("ipzjKoo",7) == 2305975154) strcat(s, "A");
if (crc32("UWoCUFrprrmJN",13) == 3685278845) strcat(s, "f");
if (crc32("DuEKQfkC",8) == 1893941385) strcat(s, "s");
if (crc32("wAYKXEBaFUzB",12) == 3393144110) strcat(s, "r");
if (crc32("BSIuGc",6) == 1645141709) strcat(s, "t");
if (crc32("lbJfZWhsh",9) == 3581984286) strcat(s, "a");
if (crc32("apXOkVaosFTSBY",14) == 3972198360) strcat(s, "c");
if (crc32("bKuWdWicbR",10) == 2950349750) strcat(s, "t");
if (crc32("qnRboPFhMH",10) == 1632657990) strcat(s, "i");
if (crc32("feNtoImQJNftAwf",15) == 3634149307) strcat(s, "v");
if (crc32("grOJBIn",7) == 1127389091) strcat(s, "e");
    return s;
}

char *intermastoid_adjectives() {
    char *s = calloc(13);
    if (crc32("xCtOFxnk",8) == 2048375863) strcat(s, "t");
if (crc32("hCuUeHmg",8) == 3374837010) strcat(s, "i");
if (crc32("wJEFST",6) == 1412244179) strcat(s, "r");
if (crc32("DJrwk",5) == 1922259474) strcat(s, "n");
if (crc32("QfchtPVU",8) == 4221540312) strcat(s, "j");
if (crc32("MNPVtLElGBocR",13) == 163297368) strcat(s, "t");
if (crc32("CAMMzKslhvEg",12) == 900317261) strcat(s, "e");
if (crc32("iZODA",5) == 414727197) strcat(s, "r");
if (crc32("nGjjBcdoO",9) == 2535563690) strcat(s, "m");
if (crc32("EACPyTJbdx",10) == 3611056855) strcat(s, "a");
if (crc32("zrEBLdAFXHACko",14) == 3496237016) strcat(s, "s");
if (crc32("MTJPZSrC",8) == 2925942593) strcat(s, "t");
if (crc32("nUUMC",5) == 3699772568) strcat(s, "o");
if (crc32("KaZvN",5) == 1911326138) strcat(s, "x");
if (crc32("cfBylDI",7) == 390316047) strcat(s, "i");
if (crc32("rDPoF",5) == 1075852965) strcat(s, "d");
    return s;
}

char *energetic_adjectives() {
    char *s = calloc(10);
    if (crc32("ONfaUF",6) == 266088592) strcat(s, "d");
if (crc32("znzuEg",6) == 890889168) strcat(s, "e");
if (crc32("ZhBjfyZ",7) == 2984195385) strcat(s, "n");
if (crc32("NkytHDBEUAEx",12) == 2452134682) strcat(s, "K");
if (crc32("qxjoyPlNtxaC",12) == 3765922916) strcat(s, "e");
if (crc32("IlkQLTrKMj",10) == 1017151458) strcat(s, "x");
if (crc32("sKuzmsqkKD",10) == 4055805250) strcat(s, "r");
if (crc32("SkVJL",5) == 2431257428) strcat(s, "Z");
if (crc32("xREcZVWNgxFSftK",15) == 1650354793) strcat(s, "g");
if (crc32("oMWpnDgqxpdspr",14) == 3589558762) strcat(s, "E");
if (crc32("MxmJmnkVPxeX",12) == 1469051600) strcat(s, "e");
if (crc32("LeIDokWFY",9) == 702323658) strcat(s, "t");
if (crc32("gcwEwUrlLnbU",12) == 2091429526) strcat(s, "i");
if (crc32("ciMltjvOGyYz",12) == 467301500) strcat(s, "k");
if (crc32("DjBjB",5) == 1259660492) strcat(s, "c");
    return s;
}

char *crinal_adjectives() {
    char *s = calloc(7);
    if (crc32("cpDpFbvCV",9) == 3681356400) strcat(s, "c");
if (crc32("jaxCcOhHvmC",11) == 2291487256) strcat(s, "D");
if (crc32("VhFPMbCo",8) == 2337603249) strcat(s, "r");
if (crc32("SczESwcUitoPGtl",15) == 963721984) strcat(s, "i");
if (crc32("TuqNGNYDsCIMK",13) == 2370862973) strcat(s, "n");
if (crc32("rnhnYBViqeAta",13) == 600115138) strcat(s, "a");
if (crc32("tMgIenNt",8) == 2926328641) strcat(s, "W");
if (crc32("HzwdcrPDmsa",11) == 2289927633) strcat(s, "l");
    return s;
}

char *eriophyllous_adjectives() {
    char *s = calloc(13);
    if (crc32("gYSORVgmxcrrd",13) == 3258302115) strcat(s, "i");
if (crc32("BaDDfukZUD",10) == 4221617013) strcat(s, "e");
if (crc32("hlDWyMVQm",9) == 3620894372) strcat(s, "T");
if (crc32("HHNvPpkrcVcoB",13) == 2960595201) strcat(s, "r");
if (crc32("CneZta",6) == 37310758) strcat(s, "i");
if (crc32("BELQXbJHXloG",12) == 4164866521) strcat(s, "o");
if (crc32("qGxnZsVUlaqoq",13) == 835394644) strcat(s, "p");
if (crc32("fmypI",5) == 1350197609) strcat(s, "Q");
if (crc32("OzxcohjxaPhlNCO",15) == 3353984817) strcat(s, "h");
if (crc32("swkiZFMGvWQSUKr",15) == 1485676821) strcat(s, "B");
if (crc32("fqRYNAuvjOHXqW",14) == 3205432647) strcat(s, "y");
if (crc32("vYmCPuAkBVjQxa",14) == 3398243527) strcat(s, "l");
if (crc32("IwxnWGvrECZbWs",14) == 3122088367) strcat(s, "l");
if (crc32("UUjHPtWGbn",10) == 1823408626) strcat(s, "o");
if (crc32("SkIvIm",6) == 3812571629) strcat(s, "n");
if (crc32("HPtkLgGNUBAm",12) == 2223070324) strcat(s, "u");
if (crc32("oFUeqFJ",7) == 3723962920) strcat(s, "P");
if (crc32("GTKODDjuaWf",11) == 1000431250) strcat(s, "s");
    return s;
}

char *unupset_adjectives() {
    char *s = calloc(8);
    if (crc32("ZTTZPoyBXE",10) == 22760194) strcat(s, "N");
if (crc32("lmkxjhtcsLrQQA",14) == 2396070880) strcat(s, "u");
if (crc32("DceyXk",6) == 295828186) strcat(s, "Z");
if (crc32("DJrTCjEKhYqcW",13) == 2593558046) strcat(s, "n");
if (crc32("juUZJwKKT",9) == 1961386481) strcat(s, "Y");
if (crc32("KndeBJ",6) == 1547796150) strcat(s, "u");
if (crc32("fnDFAXMKNEUyL",13) == 639086374) strcat(s, "e");
if (crc32("aQdDCBukuLQ",11) == 4172224819) strcat(s, "p");
if (crc32("EvmcBrKLNXCgaQ",14) == 1273708036) strcat(s, "Z");
if (crc32("yVyQgNsxZb",10) == 3968978074) strcat(s, "s");
if (crc32("RyXPBxhj",8) == 4128067416) strcat(s, "t");
if (crc32("kjjrgmiyiIuNp",13) == 1006144432) strcat(s, "e");
if (crc32("TaHiVbvxFYRb",12) == 3360193151) strcat(s, "x");
if (crc32("jljSSvPeV",9) == 3389377626) strcat(s, "t");
    return s;
}

char *faint_adjectives() {
    char *s = calloc(6);
    if (crc32("oziXIivJKAkTN",13) == 4068739756) strcat(s, "f");
if (crc32("HzxCsitrcxmnRo",14) == 1762134363) strcat(s, "a");
if (crc32("EfKAv",5) == 1174301919) strcat(s, "D");
if (crc32("wogpvpcOLXDd",12) == 2491440555) strcat(s, "i");
if (crc32("pRNpGxTzOyUHJe",14) == 1690524255) strcat(s, "n");
if (crc32("WgiGZmwJh",9) == 2244569813) strcat(s, "t");
    return s;
}

char *gypsylike_adjectives() {
    char *s = calloc(10);
    if (crc32("JlfUEmM",7) == 1190076665) strcat(s, "g");
if (crc32("FFMzjJxvAPVhGC",14) == 3200602247) strcat(s, "y");
if (crc32("VDgPuKSIRDqJ",12) == 2890964054) strcat(s, "B");
if (crc32("VpJvgL",6) == 1673852646) strcat(s, "p");
if (crc32("IBNozFfwf",9) == 2550051976) strcat(s, "s");
if (crc32("gSiCyVYYpqHsaBi",15) == 3482187225) strcat(s, "Z");
if (crc32("WNOVbMxtM",9) == 938023502) strcat(s, "y");
if (crc32("JFYEiEhbzdp",11) == 40640304) strcat(s, "l");
if (crc32("bFaAaXXzHExmhTM",15) == 4115056948) strcat(s, "r");
if (crc32("aZhgAMgEjmEFHJk",15) == 4015158869) strcat(s, "i");
if (crc32("LIKCVDoWINUOZ",13) == 2106008414) strcat(s, "k");
if (crc32("IZHmOkcykZKgiX",14) == 4088349867) strcat(s, "g");
if (crc32("soAZbVeiP",9) == 4116312183) strcat(s, "e");
    return s;
}

char *supersignificant_adjectives() {
    char *s = calloc(17);
    if (crc32("gpyWFbaWOupEIXO",15) == 971750237) strcat(s, "s");
if (crc32("CavHkKFwiGa",11) == 87145836) strcat(s, "O");
if (crc32("RwOmb",5) == 2049977584) strcat(s, "u");
if (crc32("XTwhW",5) == 2210115791) strcat(s, "p");
if (crc32("iEtdiUNFydB",11) == 416367958) strcat(s, "e");
if (crc32("seZlko",6) == 3726960920) strcat(s, "F");
if (crc32("ZDqAexqa",8) == 4008110384) strcat(s, "r");
if (crc32("HOrxnsUU",8) == 4090650166) strcat(s, "s");
if (crc32("rDvyKncwEGS",11) == 3632243757) strcat(s, "g");
if (crc32("EUZPiLLH",8) == 4224791596) strcat(s, "i");
if (crc32("JrAnOrO",7) == 4079552077) strcat(s, "d");
if (crc32("qHLYhqO",7) == 2315122606) strcat(s, "g");
if (crc32("dZAcrKysybnII",13) == 3285349183) strcat(s, "Q");
if (crc32("VefmlCAvS",9) == 209367936) strcat(s, "n");
if (crc32("dLfoeK",6) == 1920082727) strcat(s, "b");
if (crc32("CtwBNztjTONGO",13) == 3524925473) strcat(s, "i");
if (crc32("FHgNfyHbk",9) == 970829434) strcat(s, "f");
if (crc32("WdeGKmwipIJjDX",14) == 3424609433) strcat(s, "Y");
if (crc32("IrXZuMQbjz",10) == 2998574537) strcat(s, "i");
if (crc32("MticluIRLGLR",12) == 2119470408) strcat(s, "h");
if (crc32("mNRKcFJSNJp",11) == 3503604575) strcat(s, "c");
if (crc32("qItkGYXPR",9) == 1286653866) strcat(s, "a");
if (crc32("PmDre",5) == 1614789815) strcat(s, "n");
if (crc32("muvWaLtrugxiEq",14) == 2594959850) strcat(s, "c");
if (crc32("oANefMZuqGXnA",13) == 621915118) strcat(s, "t");
    return s;
}

char *synoicous_adjectives() {
    char *s = calloc(10);
    if (crc32("jkOEJDCLhA",10) == 3532595545) strcat(s, "G");
if (crc32("VYYalGAPtubkX",13) == 3048992615) strcat(s, "s");
if (crc32("VGayaXnEayQGvM",14) == 3456851552) strcat(s, "g");
if (crc32("PTxiNuXUsMFfyWh",15) == 955817934) strcat(s, "y");
if (crc32("ieiqSUONvKsviu",14) == 2792371005) strcat(s, "L");
if (crc32("eOfoWYksOUTVM",13) == 935777905) strcat(s, "n");
if (crc32("vbJEWMZnzZtMr",13) == 1117493966) strcat(s, "z");
if (crc32("TdnLlgDVIhqDB",13) == 2472032926) strcat(s, "o");
if (crc32("QLqUMh",6) == 1214678901) strcat(s, "S");
if (crc32("CQSMvPyJ",8) == 670541060) strcat(s, "i");
if (crc32("WWtTQjNEsaXhrb",14) == 12910633) strcat(s, "j");
if (crc32("BlyZukA",7) == 3025432742) strcat(s, "c");
if (crc32("JwRDS",5) == 734420801) strcat(s, "o");
if (crc32("OakiyFEDTAfmgRQ",15) == 14108918) strcat(s, "n");
if (crc32("fuvjEtuSQewUAwz",15) == 4089685343) strcat(s, "u");
if (crc32("YyXBqX",6) == 338512937) strcat(s, "B");
if (crc32("auAbGPw",7) == 519137442) strcat(s, "s");
    return s;
}

char *nee_adjectives() {
    char *s = calloc(4);
    if (crc32("WQfkpVINiYQpKE",14) == 245339154) strcat(s, "n");
if (crc32("dTwTQlCu",8) == 4108987144) strcat(s, "e");
if (crc32("FyaovFsTadcLg",13) == 104702390) strcat(s, "q");
if (crc32("HGWfFKkdyaw",11) == 2325258590) strcat(s, "e");
    return s;
}

char *unoperatable_adjectives() {
    char *s = calloc(13);
    if (crc32("eEmaPQuABCswov",14) == 2865100633) strcat(s, "u");
if (crc32("YAcUwlcBGFCfbg",14) == 2357647243) strcat(s, "B");
if (crc32("GFXdPSYIqFTVWi",14) == 2716543841) strcat(s, "n");
if (crc32("QvQnrUHks",9) == 269375240) strcat(s, "o");
if (crc32("XSiKMfdXvzdkU",13) == 1549857012) strcat(s, "p");
if (crc32("RxvPNMix",8) == 2712046836) strcat(s, "e");
if (crc32("OGVzUivaiJj",11) == 627062613) strcat(s, "r");
if (crc32("LsadmzpZCGl",11) == 558429274) strcat(s, "a");
if (crc32("oftuE",5) == 1211706432) strcat(s, "Q");
if (crc32("vvzhewqmyu",10) == 1081660060) strcat(s, "t");
if (crc32("edeqnhrHMLZaR",13) == 98678134) strcat(s, "w");
if (crc32("afqWJvmyrPwQo",13) == 4292423189) strcat(s, "a");
if (crc32("XGoVPmGXEec",11) == 1943332893) strcat(s, "s");
if (crc32("QvIxdAUgzMsTgd",14) == 2721157445) strcat(s, "b");
if (crc32("nPmhj",5) == 1801519113) strcat(s, "l");
if (crc32("GRyObJCtjDgLk",13) == 3485613682) strcat(s, "M");
if (crc32("XVqJvaAEx",9) == 261545892) strcat(s, "e");
    return s;
}

char *languid_adjectives() {
    char *s = calloc(8);
    if (crc32("ZbunoyxxFuDR",12) == 518770431) strcat(s, "P");
if (crc32("DciRWKQKuHNRcR",14) == 2602239335) strcat(s, "l");
if (crc32("pVFCyaGnziJ",11) == 3456520947) strcat(s, "y");
if (crc32("uhqQnoWL",8) == 3995381765) strcat(s, "a");
if (crc32("qvnsTOomACSf",12) == 1269917811) strcat(s, "n");
if (crc32("GXSzQaAOp",9) == 3962259049) strcat(s, "j");
if (crc32("TxbfZZQMhEYkRJ",14) == 508473203) strcat(s, "g");
if (crc32("VgkoWdDtJl",10) == 3956842029) strcat(s, "u");
if (crc32("meSSAHUDXiVrwaT",15) == 3271535185) strcat(s, "R");
if (crc32("MDxvzYdjz",9) == 59018444) strcat(s, "i");
if (crc32("ynfZtWxH",8) == 3409549530) strcat(s, "u");
if (crc32("xVEuAapXLiKsMQB",15) == 1003402995) strcat(s, "d");
    return s;
}

char *crossfertilizable_adjectives() {
    char *s = calloc(18);
    if (crc32("IdvIiS",6) == 393149343) strcat(s, "E");
if (crc32("UYNzCffQQ",9) == 3634423898) strcat(s, "c");
if (crc32("uJcPVNE",7) == 2552073809) strcat(s, "r");
if (crc32("JlKpO",5) == 268613784) strcat(s, "o");
if (crc32("IwDnfqWQ",8) == 1780246805) strcat(s, "s");
if (crc32("clzjNkKfB",9) == 4232813259) strcat(s, "Y");
if (crc32("stMOwJ",6) == 3572077921) strcat(s, "s");
if (crc32("WFsyfCOXqfqqG",13) == 3384891530) strcat(s, "M");
if (crc32("cLsoUJZxvuGNh",13) == 1550964544) strcat(s, "f");
if (crc32("ZnFwGpTcU",9) == 2783006657) strcat(s, "I");
if (crc32("fyDLotXrvztUR",13) == 1690805232) strcat(s, "e");
if (crc32("CaXWacbOOkpMul",14) == 980409392) strcat(s, "r");
if (crc32("TCqrzCQMVk",10) == 21088050) strcat(s, "D");
if (crc32("xnVdknPsPvRQjF",14) == 2350415219) strcat(s, "t");
if (crc32("GHPbhrtXrFs",11) == 1023911765) strcat(s, "i");
if (crc32("DCvYByqLTe",10) == 2968015646) strcat(s, "l");
if (crc32("QgFDMNIPRPkBkp",14) == 2566234793) strcat(s, "D");
if (crc32("RhUin",5) == 237094064) strcat(s, "i");
if (crc32("rJJOeqCN",8) == 213381158) strcat(s, "z");
if (crc32("lMMJaNSKH",9) == 117988147) strcat(s, "J");
if (crc32("tsdzUHYACFPdq",13) == 2088550258) strcat(s, "a");
if (crc32("qtDssMxduvW",11) == 1081492340) strcat(s, "h");
if (crc32("wBcvpBFEYyAp",12) == 2128534545) strcat(s, "b");
if (crc32("bMlFOnPTXtiv",12) == 753649029) strcat(s, "x");
if (crc32("EyTdzl",6) == 2163277764) strcat(s, "l");
if (crc32("ubZgMaG",7) == 1582171701) strcat(s, "e");
    return s;
}

char *myologic_adjectives() {
    char *s = calloc(9);
    if (crc32("LQsAsDsNiDSYG",13) == 3302280802) strcat(s, "k");
if (crc32("lYbbNUrC",8) == 293962894) strcat(s, "m");
if (crc32("ESMNLcIHCavUTwb",15) == 2894124542) strcat(s, "y");
if (crc32("gEiTlgckWWyFv",13) == 3653389438) strcat(s, "b");
if (crc32("VyAtbevvqnM",11) == 3403010206) strcat(s, "o");
if (crc32("NkQmtv",6) == 2885276844) strcat(s, "l");
if (crc32("SzTzOFD",7) == 2911448261) strcat(s, "n");
if (crc32("dtmbBELpfJpoeCp",15) == 450521529) strcat(s, "o");
if (crc32("RaFfoCssIlHC",12) == 4170713330) strcat(s, "x");
if (crc32("ihBocKLJYBvZTl",14) == 4243859235) strcat(s, "g");
if (crc32("vUORplxzYNDV",12) == 3826776097) strcat(s, "i");
if (crc32("GbUKdFTAMHRkPn",14) == 1191086831) strcat(s, "U");
if (crc32("HYBjnv",6) == 1368377464) strcat(s, "c");
    return s;
}

char *halfjoking_adjectives() {
    char *s = calloc(11);
    if (crc32("qgDgMJjmhtoM",12) == 1361719329) strcat(s, "H");
if (crc32("OoAzuoKLRI",10) == 1348150956) strcat(s, "h");
if (crc32("PDMfaCjdJZJ",11) == 155409398) strcat(s, "P");
if (crc32("gkmZuPeDG",9) == 3698357630) strcat(s, "a");
if (crc32("HPUVE",5) == 3851176097) strcat(s, "l");
if (crc32("pRtgS",5) == 3587370329) strcat(s, "f");
if (crc32("SLEloHbNIdi",11) == 1365532773) strcat(s, "j");
if (crc32("rrZtJvoPZkH",11) == 270433696) strcat(s, "M");
if (crc32("SeeXoLNIGgW",11) == 2214546579) strcat(s, "o");
if (crc32("WmMyBYIqqPuis",13) == 1369854299) strcat(s, "k");
if (crc32("hGQHjyf",7) == 1943484837) strcat(s, "i");
if (crc32("NHKwSdXBYQagmN",14) == 2378377156) strcat(s, "n");
if (crc32("FNMuhOZcUJfuc",13) == 1370527317) strcat(s, "c");
if (crc32("BSuzpuQXzLqomSt",15) == 2605623487) strcat(s, "g");
    return s;
}

char *compatible_adjectives() {
    char *s = calloc(11);
    if (crc32("ywbIzmCaJk",10) == 2762203786) strcat(s, "Q");
if (crc32("BgilHfiYBO",10) == 912463963) strcat(s, "c");
if (crc32("RxBuR",5) == 2387150592) strcat(s, "o");
if (crc32("eVgOTKYXY",9) == 1368751570) strcat(s, "m");
if (crc32("UWYlpRvlAf",10) == 2803900926) strcat(s, "p");
if (crc32("SgNksuxM",8) == 4232625152) strcat(s, "z");
if (crc32("unmRrEvKXUb",11) == 2311696181) strcat(s, "a");
if (crc32("oPfCYcmhvUzAAPj",15) == 3705840768) strcat(s, "c");
if (crc32("vEqweH",6) == 505050922) strcat(s, "t");
if (crc32("vdJzPPADWaL",11) == 3444692375) strcat(s, "h");
if (crc32("UTJQfbIqHBeJ",12) == 3199139762) strcat(s, "i");
if (crc32("laxuk",5) == 4194141615) strcat(s, "C");
if (crc32("YTsuXLka",8) == 2412796603) strcat(s, "b");
if (crc32("OgcbiNd",7) == 3113576567) strcat(s, "T");
if (crc32("TujuYgL",7) == 2831242254) strcat(s, "l");
if (crc32("yQsvgbUr",8) == 1021228068) strcat(s, "e");
    return s;
}

char *reachable_adjectives() {
    char *s = calloc(10);
    if (crc32("mxnHGXSMvW",10) == 163780042) strcat(s, "r");
if (crc32("jKxVGiYUbYOgLw",14) == 3154613624) strcat(s, "e");
if (crc32("BwkITbo",7) == 2366846805) strcat(s, "U");
if (crc32("TuCUruZuJ",9) == 2117992666) strcat(s, "a");
if (crc32("XLlvkwavs",9) == 564816311) strcat(s, "c");
if (crc32("aNPuuUVPy",9) == 3750654642) strcat(s, "h");
if (crc32("sBgrgF",6) == 3900831088) strcat(s, "C");
if (crc32("eaeAcUNmLwnl",12) == 3760588637) strcat(s, "a");
if (crc32("JShpR",5) == 3779576847) strcat(s, "b");
if (crc32("ZggspJCzYB",10) == 1209884755) strcat(s, "l");
if (crc32("twqafgZlTTPT",12) == 2302082175) strcat(s, "e");
    return s;
}

char *instinctive_adjectives() {
    char *s = calloc(12);
    if (crc32("opRaoPBhQBO",11) == 1394586788) strcat(s, "O");
if (crc32("LkpwGpcpBcS",11) == 946541740) strcat(s, "i");
if (crc32("aJoSXBfgykoAFY",14) == 2586473936) strcat(s, "N");
if (crc32("MmbAEAVMtVB",11) == 3996197611) strcat(s, "n");
if (crc32("RhUrUpb",7) == 2383396035) strcat(s, "L");
if (crc32("LLonXPC",7) == 2433177790) strcat(s, "s");
if (crc32("UXBAEu",6) == 147256671) strcat(s, "t");
if (crc32("JNqdJo",6) == 1757772689) strcat(s, "g");
if (crc32("sODnXZ",6) == 1228167074) strcat(s, "i");
if (crc32("dzVdaPmkEzahee",14) == 1979291958) strcat(s, "n");
if (crc32("EpVuLBHseyEYA",13) == 4188865180) strcat(s, "c");
if (crc32("bOfwkVDF",8) == 4075332814) strcat(s, "E");
if (crc32("scbtP",5) == 984139687) strcat(s, "t");
if (crc32("rCGGCGgDNqccs",13) == 2001282753) strcat(s, "z");
if (crc32("NQODIvGvJ",9) == 3461438026) strcat(s, "i");
if (crc32("OmXbJLIwy",9) == 2367992494) strcat(s, "J");
if (crc32("WIYfjY",6) == 2186296851) strcat(s, "v");
if (crc32("uVrUDUavPXP",11) == 3772739112) strcat(s, "e");
    return s;
}

char *interAndean_adjectives() {
    char *s = calloc(12);
    if (crc32("pYkjRPnevM",10) == 4107122964) strcat(s, "i");
if (crc32("mlvMNlVTbqFIyZ",14) == 1179925289) strcat(s, "a");
if (crc32("vNArYQznmYcwnVn",15) == 3385638045) strcat(s, "n");
if (crc32("bmFKFrxkE",9) == 265553862) strcat(s, "W");
if (crc32("lHzyOBufYrD",11) == 3134182370) strcat(s, "t");
if (crc32("vOHTTORWKbraEp",14) == 872660634) strcat(s, "e");
if (crc32("cKwHTZHtuoPWGx",14) == 4048799459) strcat(s, "r");
if (crc32("lWYyQo",6) == 3612311154) strcat(s, "A");
if (crc32("LVwIPdJjfr",10) == 2556418200) strcat(s, "k");
if (crc32("LgmFKmnwpI",10) == 2642321768) strcat(s, "n");
if (crc32("AKOAA",5) == 3870330919) strcat(s, "H");
if (crc32("zeiiqme",7) == 3891912989) strcat(s, "d");
if (crc32("RglsokG",7) == 1266741420) strcat(s, "x");
if (crc32("IMXYVk",6) == 1654855311) strcat(s, "e");
if (crc32("fqacnMJUqPCvkHU",15) == 66548469) strcat(s, "a");
if (crc32("SGmYVvfK",8) == 3539845408) strcat(s, "n");
    return s;
}

char *unwhining_adjectives() {
    char *s = calloc(10);
    if (crc32("vOHFjIfFusug",12) == 3369877217) strcat(s, "m");
if (crc32("jBnnNGMO",8) == 1321957710) strcat(s, "u");
if (crc32("PstznwgsDkeNjlN",15) == 2459707399) strcat(s, "n");
if (crc32("qDQOQZawihEDFBu",15) == 3034210339) strcat(s, "w");
if (crc32("eTxmAglmSJuIAs",14) == 372405217) strcat(s, "h");
if (crc32("TzKopzg",7) == 3008858160) strcat(s, "I");
if (crc32("JTQBsPGPEfAW",12) == 418242298) strcat(s, "i");
if (crc32("JaJDRcNtTFvSgF",14) == 78330909) strcat(s, "n");
if (crc32("FGfykO",6) == 2814625066) strcat(s, "a");
if (crc32("TArDqhs",7) == 680359064) strcat(s, "i");
if (crc32("EhaTpAGOJmuo",12) == 2800045732) strcat(s, "u");
if (crc32("BzNjKQjSMi",10) == 615335482) strcat(s, "n");
if (crc32("FvIyYDGPqCeLQN",14) == 2660592496) strcat(s, "A");
if (crc32("NYknJ",5) == 3188824955) strcat(s, "g");
    return s;
}

char *wellscattered_adjectives() {
    char *s = calloc(14);
    if (crc32("tsRTaMK",7) == 3817691184) strcat(s, "w");
if (crc32("LFjHNGjFfVKIl",13) == 3936384284) strcat(s, "e");
if (crc32("ErXMkIwLGGId",12) == 3455400718) strcat(s, "b");
if (crc32("YlIyeR",6) == 3864168834) strcat(s, "l");
if (crc32("YRgvWanjWgarJsv",15) == 4197933707) strcat(s, "c");
if (crc32("rFyFN",5) == 2536019096) strcat(s, "l");
if (crc32("AfsmdMpT",8) == 1048400820) strcat(s, "m");
if (crc32("xkGSmw",6) == 3462031691) strcat(s, "s");
if (crc32("nxtdIqoKfVAvavw",15) == 2926741267) strcat(s, "n");
if (crc32("tVrvuWMbckU",11) == 1813123851) strcat(s, "c");
if (crc32("oEqPVOhd",8) == 2560191557) strcat(s, "B");
if (crc32("sntld",5) == 1942400084) strcat(s, "a");
if (crc32("JRYmRSvZ",8) == 3727893067) strcat(s, "t");
if (crc32("yGMTQh",6) == 2503932416) strcat(s, "t");
if (crc32("WENlfpSWkyAPr",13) == 2428828429) strcat(s, "l");
if (crc32("iwnvhckkOmIcn",13) == 4111923198) strcat(s, "e");
if (crc32("dwUsvpa",7) == 943585762) strcat(s, "r");
if (crc32("hqCRiwGfUKelZF",14) == 4257409955) strcat(s, "e");
if (crc32("tGpRm",5) == 600611829) strcat(s, "d");
    return s;
}

char *androgynous_adjectives() {
    char *s = calloc(12);
    if (crc32("XALxVjGgiCWXSH",14) == 691542530) strcat(s, "a");
if (crc32("YIVKDUmEXmkB",12) == 2095957758) strcat(s, "T");
if (crc32("iTRVljItVBq",11) == 3870791075) strcat(s, "n");
if (crc32("kGIGRumRz",9) == 1504311604) strcat(s, "r");
if (crc32("ZrtqGh",6) == 3539614873) strcat(s, "d");
if (crc32("AzktcSzLdymD",12) == 3716400840) strcat(s, "S");
if (crc32("KspsHcGIhiIG",12) == 361503515) strcat(s, "r");
if (crc32("sNoerMoAfoCM",12) == 1128298399) strcat(s, "o");
if (crc32("gslpxKrwOFBO",12) == 89868768) strcat(s, "f");
if (crc32("IDYCejkhhh",10) == 4072964676) strcat(s, "g");
if (crc32("DGhsAicDiwGq",12) == 2439060850) strcat(s, "x");
if (crc32("DJwLlWXX",8) == 2893795180) strcat(s, "y");
if (crc32("EsQBVUgtsmgwi",13) == 1944536076) strcat(s, "n");
if (crc32("EvVop",5) == 3258223410) strcat(s, "o");
if (crc32("HbJgDdZypQBi",12) == 4031583125) strcat(s, "h");
if (crc32("lLUXJQMWMZBgOL",14) == 993083661) strcat(s, "u");
if (crc32("vNcLsaAwZjbEPi",14) == 1990192210) strcat(s, "w");
if (crc32("CjfOaqKtJbYr",12) == 110773042) strcat(s, "s");
    return s;
}

char *opaline_adjectives() {
    char *s = calloc(8);
    if (crc32("UqPRfGdFAOsejI",14) == 2777405909) strcat(s, "o");
if (crc32("uEJOMttC",8) == 2109804645) strcat(s, "p");
if (crc32("UaaLjBurFsMWzAB",15) == 3753105857) strcat(s, "y");
if (crc32("RLRjadzs",8) == 3017191599) strcat(s, "a");
if (crc32("zjdDzxonmO",10) == 1539752744) strcat(s, "h");
if (crc32("EqwrBlzhnBQgKPc",15) == 1561460105) strcat(s, "l");
if (crc32("nDEhiUU",7) == 661017772) strcat(s, "i");
if (crc32("UvTAMSUKEfVlI",13) == 3309038478) strcat(s, "v");
if (crc32("puKkykz",7) == 2216096748) strcat(s, "n");
if (crc32("VpRlREhuJC",10) == 1686647729) strcat(s, "e");
    return s;
}

char *eradicative_adjectives() {
    char *s = calloc(12);
    if (crc32("Muyflc",6) == 1957206883) strcat(s, "e");
if (crc32("CqylTrmIqOrBXp",14) == 2022787031) strcat(s, "W");
if (crc32("NcyOYbvVWmTJABX",15) == 82176603) strcat(s, "r");
if (crc32("TBHGMQ",6) == 1137969481) strcat(s, "m");
if (crc32("OPlXCigYtw",10) == 878151711) strcat(s, "a");
if (crc32("QPzdMMjG",8) == 589795324) strcat(s, "H");
if (crc32("rupGOsRxBKrQ",12) == 2567265383) strcat(s, "d");
if (crc32("oglfsawYSGKd",12) == 286835252) strcat(s, "T");
if (crc32("vJTBtcRPPI",10) == 2814083823) strcat(s, "i");
if (crc32("cEEyKWndWl",10) == 3121664527) strcat(s, "o");
if (crc32("ZjJlxPAgkGjMA",13) == 21351789) strcat(s, "c");
if (crc32("ksxHHWdjepJ",11) == 724850658) strcat(s, "C");
if (crc32("aTMwyRiq",8) == 3170833161) strcat(s, "a");
if (crc32("wTFvW",5) == 2350308082) strcat(s, "N");
if (crc32("Tbgzr",5) == 3168664919) strcat(s, "t");
if (crc32("IslHuJwnM",9) == 2127317798) strcat(s, "i");
if (crc32("rKkIHY",6) == 1634766369) strcat(s, "v");
if (crc32("WQzkOgV",7) == 3517986697) strcat(s, "w");
if (crc32("eGCIONfCGWvQK",13) == 2266721421) strcat(s, "e");
    return s;
}

char *unsmothering_adjectives() {
    char *s = calloc(13);
    if (crc32("zUBKZQm",7) == 379176924) strcat(s, "u");
if (crc32("PlJvD",5) == 1760691193) strcat(s, "O");
if (crc32("yOglckuKmgd",11) == 3141124382) strcat(s, "n");
if (crc32("cMQTd",5) == 2293761014) strcat(s, "s");
if (crc32("GUrtujfLJYiTQD",14) == 477217730) strcat(s, "z");
if (crc32("PeWNCrzmPxvsA",13) == 1372366840) strcat(s, "m");
if (crc32("UrmnVDb",7) == 1336434207) strcat(s, "o");
if (crc32("KaQHuVolwcDbKT",14) == 2078562700) strcat(s, "t");
if (crc32("HDffRwq",7) == 1580913261) strcat(s, "h");
if (crc32("yinwKYNlm",9) == 1520449035) strcat(s, "e");
if (crc32("FMXUUYFeVRWdiU",14) == 946941435) strcat(s, "e");
if (crc32("mfWoAPFcXPOY",12) == 3516471318) strcat(s, "l");
if (crc32("ABNsUpvVd",9) == 2958302311) strcat(s, "r");
if (crc32("SvVQZQLrOVWAbs",14) == 4205591529) strcat(s, "O");
if (crc32("NznrPVRB",8) == 329392028) strcat(s, "i");
if (crc32("ZAQnjRGa",8) == 474364257) strcat(s, "n");
if (crc32("jdvISRFCPMuuSd",14) == 1852378769) strcat(s, "n");
if (crc32("uISCpxcbfntwHma",15) == 2794163573) strcat(s, "g");
    return s;
}

char *armored_adjectives() {
    char *s = calloc(8);
    if (crc32("szCNsEfaYFmajA",14) == 1413594264) strcat(s, "a");
if (crc32("cRmvcLc",7) == 1927171746) strcat(s, "V");
if (crc32("NxSEodqcRyHTv",13) == 2907635345) strcat(s, "r");
if (crc32("kfqxXUNIrFZV",12) == 677804612) strcat(s, "m");
if (crc32("yCrrkD",6) == 3813096703) strcat(s, "o");
if (crc32("pUqlCqXgYhqzW",13) == 1762694773) strcat(s, "A");
if (crc32("qrsAKo",6) == 888983274) strcat(s, "r");
if (crc32("byVhPMzELkG",11) == 4088332586) strcat(s, "e");
if (crc32("HPGiqhoCXgd",11) == 3002851214) strcat(s, "X");
if (crc32("BfZNCphgh",9) == 3915597665) strcat(s, "d");
    return s;
}

char *superchivalrous_adjectives() {
    char *s = calloc(16);
    if (crc32("tSospFooSC",10) == 27303259) strcat(s, "s");
if (crc32("YotmUWhZTouDNuu",15) == 2069740300) strcat(s, "U");
if (crc32("EILKsy",6) == 997353037) strcat(s, "u");
if (crc32("KcsfEU",6) == 2836459594) strcat(s, "p");
if (crc32("pSlZTPR",7) == 770852022) strcat(s, "a");
if (crc32("nceVqL",6) == 1881788971) strcat(s, "e");
if (crc32("eBjwDUxrLB",10) == 3464534378) strcat(s, "t");
if (crc32("gLUxCBzlYbIg",12) == 1657646693) strcat(s, "r");
if (crc32("wVDUhDsUeL",10) == 812156782) strcat(s, "V");
if (crc32("HbOAPGEnb",9) == 2005493783) strcat(s, "c");
if (crc32("sNdQS",5) == 495406507) strcat(s, "h");
if (crc32("LhaWMJJvuLNY",12) == 3855205863) strcat(s, "h");
if (crc32("euSuNJv",7) == 4121630391) strcat(s, "i");
if (crc32("EYUwJyQiEo",10) == 3476607389) strcat(s, "u");
if (crc32("UxLWjlmRDlGbi",13) == 2446386250) strcat(s, "v");
if (crc32("xZfKs",5) == 635643554) strcat(s, "V");
if (crc32("hzsgZVMFHkh",11) == 2340209670) strcat(s, "a");
if (crc32("XznzOKQE",8) == 818666875) strcat(s, "l");
if (crc32("bSpRlkmzzq",10) == 2524001141) strcat(s, "r");
if (crc32("hdkQfOaeERimtU",14) == 330110835) strcat(s, "o");
if (crc32("VRGtAdnGBlZz",12) == 2615090334) strcat(s, "u");
if (crc32("bIoazUCxKC",10) == 4198327141) strcat(s, "z");
if (crc32("bqqOpnSFMrvpO",13) == 2292358127) strcat(s, "s");
    return s;
}

char *nonsubstantival_adjectives() {
    char *s = calloc(16);
    if (crc32("ZmoOqq",6) == 4058304665) strcat(s, "j");
if (crc32("BRarzRfHLi",10) == 2732304482) strcat(s, "n");
if (crc32("bwkDYbSxTJvqDe",14) == 1083337925) strcat(s, "o");
if (crc32("ODXaZLHZ",8) == 259681440) strcat(s, "n");
if (crc32("QERlMMpUE",9) == 1974981355) strcat(s, "s");
if (crc32("ZqLfPjwfXQCNpAb",15) == 3702697291) strcat(s, "H");
if (crc32("vWParUbHY",9) == 3299548746) strcat(s, "u");
if (crc32("SAqbjvVDBlYW",12) == 3812319166) strcat(s, "K");
if (crc32("CbyHrLlBSscwp",13) == 292192840) strcat(s, "b");
if (crc32("QIuaCAriwPrpQ",13) == 1963933982) strcat(s, "s");
if (crc32("IjykIEZJNuxapS",14) == 706063867) strcat(s, "j");
if (crc32("JDZaVVPaXFDW",12) == 1109039194) strcat(s, "t");
if (crc32("jzKJMqC",7) == 1646949757) strcat(s, "a");
if (crc32("KmzxE",5) == 1049019272) strcat(s, "b");
if (crc32("trtBGHlsjNNcfH",14) == 637976983) strcat(s, "n");
if (crc32("VPOzgcZSrSv",11) == 2658429265) strcat(s, "z");
if (crc32("MXOkhbiJgoytl",13) == 2058199835) strcat(s, "t");
if (crc32("OhwjcuhA",8) == 1060453824) strcat(s, "i");
if (crc32("QnpUrFRvHnJq",12) == 3743610483) strcat(s, "v");
if (crc32("wurfbNCEmjS",11) == 2427479434) strcat(s, "L");
if (crc32("LnKRrBdHPx",10) == 2036419806) strcat(s, "a");
if (crc32("HNHcezvXyBTxCZA",15) == 1316536307) strcat(s, "l");
    return s;
}

char *stoical_adjectives() {
    char *s = calloc(8);
    if (crc32("eacKOr",6) == 3508476065) strcat(s, "s");
if (crc32("eKLZJdFNNtsQ",12) == 2493280837) strcat(s, "t");
if (crc32("tXrDPVgsrh",10) == 1678329944) strcat(s, "S");
if (crc32("NdSzt",5) == 2045232593) strcat(s, "o");
if (crc32("QunCHMxveDM",11) == 3988110435) strcat(s, "N");
if (crc32("Arecu",5) == 1109678831) strcat(s, "i");
if (crc32("nOOLJQpX",8) == 2723494255) strcat(s, "c");
if (crc32("zbJRr",5) == 372422184) strcat(s, "M");
if (crc32("tRkXXebOkdcU",12) == 2856083697) strcat(s, "a");
if (crc32("QgmgNCBNp",9) == 2233311516) strcat(s, "l");
    return s;
}

char *pseudoparasitic_adjectives() {
    char *s = calloc(16);
    if (crc32("vpCaaSLdCFelF",13) == 2031659953) strcat(s, "p");
if (crc32("IfSzlHNwk",9) == 3862446574) strcat(s, "i");
if (crc32("FSoJscJ",7) == 1359543106) strcat(s, "s");
if (crc32("oqIgD",5) == 713367262) strcat(s, "e");
if (crc32("wasoKevZBimR",12) == 1167409557) strcat(s, "y");
if (crc32("digyrU",6) == 1297931193) strcat(s, "u");
if (crc32("UCayedd",7) == 3531264622) strcat(s, "d");
if (crc32("lxCasNLFv",9) == 399316410) strcat(s, "b");
if (crc32("uVOkLKgAfuP",11) == 1202049819) strcat(s, "o");
if (crc32("GCywmkRLtIxKV",13) == 3571033134) strcat(s, "p");
if (crc32("UpZczMJKgVHFrl",14) == 912416366) strcat(s, "a");
if (crc32("UpzNWIvNtjHF",12) == 2244860782) strcat(s, "J");
if (crc32("qzciaODqdtSrnk",14) == 3121052363) strcat(s, "r");
if (crc32("LdRaEIdIMBR",11) == 2101280489) strcat(s, "T");
if (crc32("djiUxGMyZFzAesc",15) == 2556150105) strcat(s, "a");
if (crc32("ecqmzNipW",9) == 91433576) strcat(s, "s");
if (crc32("AmzoGPd",7) == 380049131) strcat(s, "Z");
if (crc32("hSPiTUkmqc",10) == 137818575) strcat(s, "i");
if (crc32("pRmCebxyck",10) == 2914697036) strcat(s, "t");
if (crc32("dEaGSro",7) == 2976900474) strcat(s, "i");
if (crc32("uZymaor",7) == 2799460460) strcat(s, "c");
    return s;
}

char *nonaffiliated_adjectives() {
    char *s = calloc(14);
    if (crc32("FpBUXNWKrDssG",13) == 3158716111) strcat(s, "n");
if (crc32("UGSxNsT",7) == 2910192722) strcat(s, "T");
if (crc32("vWPTjdRC",8) == 1416604380) strcat(s, "o");
if (crc32("ZkXdTRlsIRXJEb",14) == 3409328580) strcat(s, "h");
if (crc32("FCIpUtiHcPIGGJ",14) == 2111240109) strcat(s, "n");
if (crc32("GDMnIgNsBeoZqCk",15) == 2202517461) strcat(s, "b");
if (crc32("umySpME",7) == 2914841219) strcat(s, "a");
if (crc32("TqRBygWulbl",11) == 3943129357) strcat(s, "q");
if (crc32("UuFSipif",8) == 1647789431) strcat(s, "f");
if (crc32("hjXpYgHBSdsA",12) == 2929117908) strcat(s, "q");
if (crc32("HMcmMQrwMADj",12) == 3706473075) strcat(s, "f");
if (crc32("ZNmqRFTfAW",10) == 3635436022) strcat(s, "i");
if (crc32("oACVOXIfqh",10) == 2218268355) strcat(s, "U");
if (crc32("YAsStYGWVMX",11) == 3430060335) strcat(s, "l");
if (crc32("MsyvnfHkWCaC",12) == 2900827083) strcat(s, "i");
if (crc32("lNGmPeyC",8) == 2158001545) strcat(s, "Q");
if (crc32("jmJgaJEYO",9) == 982559928) strcat(s, "a");
if (crc32("UTjtKxUCgTMk",12) == 3329456337) strcat(s, "t");
if (crc32("MODXhxxmVy",10) == 850494980) strcat(s, "e");
if (crc32("VBrTnI",6) == 400232454) strcat(s, "d");
    return s;
}

char *pseudolaminated_adjectives() {
    char *s = calloc(16);
    if (crc32("wQEaoCbyOAdpLj",14) == 1056762777) strcat(s, "Z");
if (crc32("DdfdjEdKwal",11) == 2540349025) strcat(s, "p");
if (crc32("QYOITZCamcSvdJ",14) == 1373545871) strcat(s, "M");
if (crc32("knaEFdcdssjGvs",14) == 3824578914) strcat(s, "s");
if (crc32("NmUksVl",7) == 3753180367) strcat(s, "e");
if (crc32("ZOBSbZDVpxgd",12) == 1593217406) strcat(s, "u");
if (crc32("WwtKenD",7) == 1639692782) strcat(s, "i");
if (crc32("dQIeOPl",7) == 4180011785) strcat(s, "d");
if (crc32("zJaTSKMRcnPH",12) == 1426254635) strcat(s, "o");
if (crc32("IGXXqiVQAj",10) == 3707216979) strcat(s, "J");
if (crc32("gcjJvxLtXafc",12) == 43015723) strcat(s, "l");
if (crc32("luPeGi",6) == 3675309094) strcat(s, "G");
if (crc32("voqIaIkKHSjTMon",15) == 3768461740) strcat(s, "a");
if (crc32("uVFFOGmECJC",11) == 4043418580) strcat(s, "U");
if (crc32("zbtIcvyRLw",10) == 2595086848) strcat(s, "m");
if (crc32("bqlUyd",6) == 2682848659) strcat(s, "i");
if (crc32("QSZNZYLezE",10) == 4211037599) strcat(s, "n");
if (crc32("WJOxGpjm",8) == 322275882) strcat(s, "a");
if (crc32("BIdzsbakGc",10) == 3583126870) strcat(s, "t");
if (crc32("XkLaszbAmmOBWI",14) == 415048811) strcat(s, "G");
if (crc32("HvcAEnwrFXOucl",14) == 2330664555) strcat(s, "e");
if (crc32("oDXUgvXyQu",10) == 349876247) strcat(s, "h");
if (crc32("xRToKzrkPBLc",12) == 4008173672) strcat(s, "d");
    return s;
}

char *hypogastric_adjectives() {
    char *s = calloc(12);
    if (crc32("DYNOWCWcr",9) == 1341242007) strcat(s, "R");
if (crc32("vhbZGhHn",8) == 1383485321) strcat(s, "h");
if (crc32("SNFIcvq",7) == 2673481653) strcat(s, "y");
if (crc32("ERhfTWbc",8) == 3962338723) strcat(s, "p");
if (crc32("wCUmYDPYApCsgVt",15) == 117930) strcat(s, "o");
if (crc32("bXdtDibE",8) == 2062309315) strcat(s, "g");
if (crc32("PDJiP",5) == 1209958064) strcat(s, "a");
if (crc32("hzogSJtO",8) == 4110529913) strcat(s, "s");
if (crc32("qRfycqAgruTLcv",14) == 1185028068) strcat(s, "t");
if (crc32("KhXCz",5) == 515422789) strcat(s, "r");
if (crc32("YdfIZBPo",8) == 1810112248) strcat(s, "i");
if (crc32("wuSveg",6) == 2001418307) strcat(s, "r");
if (crc32("ldqjKMeNZsfsMQH",15) == 2460890904) strcat(s, "c");
    return s;
}

char *unexposed_adjectives() {
    char *s = calloc(10);
    if (crc32("mAeWtgNly",9) == 3814122938) strcat(s, "T");
if (crc32("XbcgWYDUhQIv",12) == 3446502190) strcat(s, "u");
if (crc32("XXCCHvFuYv",10) == 3501385309) strcat(s, "w");
if (crc32("eyYrvVAq",8) == 3293551730) strcat(s, "n");
if (crc32("vTVflYSHqQirPow",15) == 2514199884) strcat(s, "e");
if (crc32("LeMiw",5) == 1439002502) strcat(s, "x");
if (crc32("SGYti",5) == 2734838451) strcat(s, "p");
if (crc32("xezfS",5) == 2614852299) strcat(s, "o");
if (crc32("wZbmxXWFxJqjJq",14) == 682370125) strcat(s, "s");
if (crc32("dcUxsVtzlRjCQfq",15) == 3991960014) strcat(s, "l");
if (crc32("yTgxXT",6) == 2987073602) strcat(s, "e");
if (crc32("ChCGcCkmGIF",11) == 3767848438) strcat(s, "Z");
if (crc32("wAaaVhEuBwtuoVd",15) == 2761028915) strcat(s, "d");
    return s;
}

char *otiose_adjectives() {
    char *s = calloc(7);
    if (crc32("shJSWYvF",8) == 4256812920) strcat(s, "o");
if (crc32("UadZM",5) == 2997669071) strcat(s, "t");
if (crc32("vLKfZElYJfbxcYs",15) == 2363852368) strcat(s, "i");
if (crc32("xEQyLMofX",9) == 839763605) strcat(s, "A");
if (crc32("lkNmDnyvuwmlvUW",15) == 2809223416) strcat(s, "o");
if (crc32("pwOvHdyRNG",10) == 3733824754) strcat(s, "H");
if (crc32("ANHPMEajrW",10) == 1342579626) strcat(s, "s");
if (crc32("RjaxYcYcwbqRJrl",15) == 183929651) strcat(s, "e");
    return s;
}

char *drying_adjectives() {
    char *s = calloc(7);
    if (crc32("QcPhoTzH",8) == 1176205269) strcat(s, "d");
if (crc32("WYLimWXX",8) == 3612954504) strcat(s, "r");
if (crc32("KTeKssbEGyK",11) == 1024664471) strcat(s, "x");
if (crc32("xFkosvAsMM",10) == 2556614722) strcat(s, "y");
if (crc32("nhaRlSx",7) == 1952943985) strcat(s, "C");
if (crc32("jNeiYPtC",8) == 2182685867) strcat(s, "i");
if (crc32("ZbAKlAFbCqtZ",12) == 3408551286) strcat(s, "n");
if (crc32("AxSMPdHhTuc",11) == 4077445588) strcat(s, "M");
if (crc32("QdaLdP",6) == 2319626473) strcat(s, "g");
    return s;
}

char *unsurpliced_adjectives() {
    char *s = calloc(12);
    if (crc32("qpcrXsyPifUm",12) == 1868236751) strcat(s, "u");
if (crc32("efdBYrIdXr",10) == 2972765418) strcat(s, "n");
if (crc32("rRUTbUJf",8) == 4224905572) strcat(s, "s");
if (crc32("oYqYMFdArhzu",12) == 4100096694) strcat(s, "u");
if (crc32("qaASioyXX",9) == 3534304597) strcat(s, "V");
if (crc32("VYLejM",6) == 1454880701) strcat(s, "r");
if (crc32("OnGdbk",6) == 507787639) strcat(s, "b");
if (crc32("zRRVqYxN",8) == 3699471511) strcat(s, "p");
if (crc32("rsrbEcpSQtlh",12) == 1368872656) strcat(s, "l");
if (crc32("fWUiRacIkrGL",12) == 3632484784) strcat(s, "i");
if (crc32("jTqjwdOepBQ",11) == 701726066) strcat(s, "c");
if (crc32("qNHGTIWxtPJifxK",15) == 2283487463) strcat(s, "e");
if (crc32("XywuDnWDMSuBEG",14) == 2205196068) strcat(s, "x");
if (crc32("IFBhH",5) == 2340666215) strcat(s, "d");
    return s;
}

char *Ninevitish_adjectives() {
    char *s = calloc(11);
    if (crc32("gBtsUqtx",8) == 3863021400) strcat(s, "l");
if (crc32("vDERCnWmSb",10) == 3315936208) strcat(s, "N");
if (crc32("LjjDZjs",7) == 3428828013) strcat(s, "t");
if (crc32("xvstJ",5) == 3392758054) strcat(s, "i");
if (crc32("sfHruEpyeHKb",12) == 1926574948) strcat(s, "H");
if (crc32("OXneD",5) == 961209225) strcat(s, "n");
if (crc32("ydjefJnghWE",11) == 343698978) strcat(s, "e");
if (crc32("fKAAUQKJQOf",11) == 2787109667) strcat(s, "P");
if (crc32("XGrBr",5) == 3820196410) strcat(s, "v");
if (crc32("MqHbSjpcwF",10) == 1886557820) strcat(s, "t");
if (crc32("LRrfMcOoxwghrcs",15) == 1612331115) strcat(s, "i");
if (crc32("LLxVAajnORu",11) == 172507610) strcat(s, "Z");
if (crc32("lGIYyVwZJVIUBix",15) == 75818591) strcat(s, "t");
if (crc32("BhtJgSlms",9) == 163534122) strcat(s, "i");
if (crc32("pVbPxUmJQVMex",13) == 2245150956) strcat(s, "u");
if (crc32("uVUUYExKrula",12) == 3291909591) strcat(s, "s");
if (crc32("BvYnhrIuuoLdQ",13) == 1622653714) strcat(s, "h");
    return s;
}

char *nonmanual_adjectives() {
    char *s = calloc(10);
    if (crc32("uTPyIXqSIPwLhu",14) == 2486362906) strcat(s, "p");
if (crc32("ZottuLRNrgk",11) == 206838194) strcat(s, "n");
if (crc32("IKWypVTyJ",9) == 3945073952) strcat(s, "h");
if (crc32("oGJvZa",6) == 2089275614) strcat(s, "o");
if (crc32("wbxXEvhyW",9) == 1121396903) strcat(s, "G");
if (crc32("KwGWLmvLqGk",11) == 3482433441) strcat(s, "n");
if (crc32("bauFD",5) == 1698200767) strcat(s, "m");
if (crc32("iGSIbgrsXJSa",12) == 3986655223) strcat(s, "m");
if (crc32("tyDxOkg",7) == 2761137373) strcat(s, "a");
if (crc32("enMAVrJAMXE",11) == 1951590993) strcat(s, "a");
if (crc32("drcgbdN",7) == 1332698354) strcat(s, "w");
if (crc32("XdmiYfx",7) == 933961351) strcat(s, "n");
if (crc32("PcGjtm",6) == 928526821) strcat(s, "U");
if (crc32("iiWkrKUVmP",10) == 2935602925) strcat(s, "u");
if (crc32("VsyQCWk",7) == 2330646079) strcat(s, "a");
if (crc32("pCIUXzZWRI",10) == 2895293983) strcat(s, "l");
    return s;
}

char *noneducational_adjectives() {
    char *s = calloc(15);
    if (crc32("gqWWjsflUQMpIsi",15) == 1895448794) strcat(s, "n");
if (crc32("pkbxmIrzD",9) == 1302462596) strcat(s, "J");
if (crc32("KCSgaoJGpHwlccw",15) == 815596498) strcat(s, "o");
if (crc32("ZlDXudEkhX",10) == 1073151587) strcat(s, "O");
if (crc32("lITcKZLNpnt",11) == 3607766355) strcat(s, "n");
if (crc32("YsozfvDocHYDJP",14) == 3497158430) strcat(s, "e");
if (crc32("pRMwYGwfrkOgKP",14) == 3502087856) strcat(s, "X");
if (crc32("wgWxY",5) == 3078825699) strcat(s, "d");
if (crc32("kSFRrD",6) == 804304899) strcat(s, "I");
if (crc32("FiJXRnJdrwVriuC",15) == 2972955569) strcat(s, "u");
if (crc32("KINHLzFNS",9) == 170766480) strcat(s, "c");
if (crc32("zilIpOAfHG",10) == 3399324715) strcat(s, "a");
if (crc32("xbgDhIrzw",9) == 3875408466) strcat(s, "t");
if (crc32("lXfvtDMJLmbSVF",14) == 2801583567) strcat(s, "y");
if (crc32("xQGjVYcf",8) == 971004735) strcat(s, "i");
if (crc32("fOpGgJm",7) == 2505872371) strcat(s, "B");
if (crc32("LoUaKaTklmbdsk",14) == 3447605835) strcat(s, "o");
if (crc32("pgopa",5) == 2553910558) strcat(s, "I");
if (crc32("uIXmxBsMVGsZHl",14) == 1654687647) strcat(s, "n");
if (crc32("Xgojrrp",7) == 3441911489) strcat(s, "a");
if (crc32("HhdmPtVYCPUwvC",14) == 4242714585) strcat(s, "l");
    return s;
}

char *hotter_adjectives() {
    char *s = calloc(7);
    if (crc32("JkFTPMT",7) == 3382031833) strcat(s, "h");
if (crc32("jqCEwhJLpf",10) == 1190758972) strcat(s, "f");
if (crc32("YWOZuzUOFJCf",12) == 2515560577) strcat(s, "o");
if (crc32("kgbUC",5) == 3405884787) strcat(s, "w");
if (crc32("cSTaKwHTFtSp",12) == 1628838325) strcat(s, "t");
if (crc32("lYZDvFZCpf",10) == 1312177608) strcat(s, "l");
if (crc32("DaidJLxpETAsrQ",14) == 3416452402) strcat(s, "t");
if (crc32("dGoIFVbZn",9) == 3403960210) strcat(s, "A");
if (crc32("wNPhkzaRRa",10) == 2214321169) strcat(s, "e");
if (crc32("ndaIZUjy",8) == 838707961) strcat(s, "r");
    return s;
}

char *theurgical_adjectives() {
    char *s = calloc(11);
    if (crc32("wRNebaT",7) == 919354875) strcat(s, "y");
if (crc32("XrCfB",5) == 3604923396) strcat(s, "t");
if (crc32("YNQqTBcWQcp",11) == 3488469420) strcat(s, "C");
if (crc32("DNAvu",5) == 952670894) strcat(s, "h");
if (crc32("jimleZekNwDcl",13) == 3682298522) strcat(s, "e");
if (crc32("cCSsfzjIJ",9) == 1534865573) strcat(s, "u");
if (crc32("KOxBOSoroARK",12) == 4142556181) strcat(s, "A");
if (crc32("OgkCmxV",7) == 2021395407) strcat(s, "r");
if (crc32("DFslBbZUPRKlD",13) == 2955249090) strcat(s, "N");
if (crc32("XGbyf",5) == 3657239055) strcat(s, "g");
if (crc32("UuvQihb",7) == 4224969152) strcat(s, "i");
if (crc32("iJrPMyKSfo",10) == 3274036542) strcat(s, "c");
if (crc32("FtQfibHbVta",11) == 1646039026) strcat(s, "a");
if (crc32("ifZeARfzvLutc",13) == 437613966) strcat(s, "l");
    return s;
}

char *odontographic_adjectives() {
    char *s = calloc(14);
    if (crc32("GZuPPurVrBwG",12) == 3694572777) strcat(s, "h");
if (crc32("KlsljwVTaelxQru",15) == 4008801785) strcat(s, "o");
if (crc32("ykROAnA",7) == 308462395) strcat(s, "B");
if (crc32("VMOnbYTm",8) == 338554630) strcat(s, "d");
if (crc32("ERtIat",6) == 3558934740) strcat(s, "r");
if (crc32("EzDpTeJzINDhySM",15) == 3019352803) strcat(s, "o");
if (crc32("cIWNM",5) == 2440041548) strcat(s, "g");
if (crc32("zYfIS",5) == 1556483275) strcat(s, "n");
if (crc32("QprCHWIyZ",9) == 3910828354) strcat(s, "t");
if (crc32("MLAEUpOHKKiedZ",14) == 1834060274) strcat(s, "j");
if (crc32("EnhsYSlrDtASVS",14) == 2416830254) strcat(s, "o");
if (crc32("zvjtOYAdZ",9) == 3240093568) strcat(s, "g");
if (crc32("zroSDFlMDPt",11) == 461126580) strcat(s, "r");
if (crc32("RTtsaeNecFpTg",13) == 2891521875) strcat(s, "a");
if (crc32("bIcfjzJWp",9) == 3044136314) strcat(s, "c");
if (crc32("bUVWNQwd",8) == 3941689207) strcat(s, "p");
if (crc32("DWyVJKweQbSUke",14) == 1388706221) strcat(s, "h");
if (crc32("FivFno",6) == 3771820348) strcat(s, "i");
if (crc32("obUSVejl",8) == 2175784367) strcat(s, "p");
if (crc32("RrwxU",5) == 3902680049) strcat(s, "c");
    return s;
}

char *uncanny_adjectives() {
    char *s = calloc(8);
    if (crc32("cpiSTGZPXxQUak",14) == 342628296) strcat(s, "Z");
if (crc32("ucOENfqn",8) == 4268680465) strcat(s, "u");
if (crc32("VIAuztbudKcoy",13) == 2258527415) strcat(s, "m");
if (crc32("AHxrywTYbqq",11) == 437669958) strcat(s, "n");
if (crc32("mmvPgbVQYHJpYt",14) == 4267763017) strcat(s, "M");
if (crc32("wlXbuBtUIsE",11) == 1571787483) strcat(s, "c");
if (crc32("TpmbZCgcQasOsT",14) == 3408669371) strcat(s, "a");
if (crc32("zeZWGFCJVjwEbU",14) == 1116614384) strcat(s, "u");
if (crc32("TSFfLgaXdLaBjT",14) == 2171208495) strcat(s, "n");
if (crc32("cZTLn",5) == 1602606935) strcat(s, "v");
if (crc32("ZPaBKJbRzhUSeT",14) == 4276257330) strcat(s, "n");
if (crc32("RFNumbRgA",9) == 336553644) strcat(s, "m");
if (crc32("tzmRdFWqzAlwgt",14) == 3325331594) strcat(s, "y");
    return s;
}

char *runtish_adjectives() {
    char *s = calloc(8);
    if (crc32("eEKBqgbMYHtoYQy",15) == 2423410522) strcat(s, "k");
if (crc32("VMwrKh",6) == 974097678) strcat(s, "r");
if (crc32("ZOBYMgGsF",9) == 3778491647) strcat(s, "u");
if (crc32("rymZANqGTGaqm",13) == 11155352) strcat(s, "T");
if (crc32("dAJkmXctmobReuZ",15) == 1738373855) strcat(s, "n");
if (crc32("bbrPwEQYPgvqgQY",15) == 2313462889) strcat(s, "n");
if (crc32("MVHuWFq",7) == 3201823255) strcat(s, "t");
if (crc32("rUgqznOJui",10) == 797337477) strcat(s, "S");
if (crc32("dLxQiouGUMDEfU",14) == 2233400608) strcat(s, "i");
if (crc32("gzlbfDl",7) == 3656349812) strcat(s, "k");
if (crc32("PavUhhLCxalte",13) == 1863277404) strcat(s, "s");
if (crc32("tWVzCgYnD",9) == 2717776865) strcat(s, "l");
if (crc32("dcRaIsNwx",9) == 2798503040) strcat(s, "h");
    return s;
}

char *mistyped_adjectives() {
    char *s = calloc(9);
    if (crc32("BzRHokFjFkkg",12) == 3766175672) strcat(s, "h");
if (crc32("DaHuIemihd",10) == 1809794201) strcat(s, "m");
if (crc32("OSoGwrCbMQGzTl",14) == 2278764994) strcat(s, "i");
if (crc32("IPciUKKrHmZnwlK",15) == 2227073217) strcat(s, "i");
if (crc32("zQDQChLFHTPKX",13) == 2425378093) strcat(s, "s");
if (crc32("dVpRCBMDrcFB",12) == 3036870947) strcat(s, "t");
if (crc32("JytBU",5) == 4022288076) strcat(s, "U");
if (crc32("lzrAXuWepipOkXL",15) == 1974967432) strcat(s, "y");
if (crc32("RzzUpCmHwM",10) == 3158061794) strcat(s, "p");
if (crc32("sUkaoBtmm",9) == 1902884795) strcat(s, "D");
if (crc32("bPRZVZVQEdqu",12) == 2743612319) strcat(s, "e");
if (crc32("hLNCam",6) == 357524677) strcat(s, "S");
if (crc32("WjAxpwz",7) == 2637611698) strcat(s, "d");
    return s;
}

char *synodic_adjectives() {
    char *s = calloc(8);
    if (crc32("EcQKiHeE",8) == 2007842533) strcat(s, "M");
if (crc32("INerhYyTpbicq",13) == 974492830) strcat(s, "s");
if (crc32("rUshIUSrmHhUmP",14) == 2128399333) strcat(s, "y");
if (crc32("sQIIwjzjYxrkA",13) == 529506304) strcat(s, "n");
if (crc32("wojuxm",6) == 1858285441) strcat(s, "o");
if (crc32("bLwrNnXTSv",10) == 2381368364) strcat(s, "d");
if (crc32("CesYqLhoIWF",11) == 2099791331) strcat(s, "i");
if (crc32("QKHBPiiRXMG",11) == 758237558) strcat(s, "x");
if (crc32("mtdiwPK",7) == 3341381393) strcat(s, "c");
    return s;
}

char *cashedup_adjectives() {
    char *s = calloc(9);
    if (crc32("uYOfToXYA",9) == 3697407299) strcat(s, "c");
if (crc32("TQFQMabiqgm",11) == 1330027809) strcat(s, "z");
if (crc32("fHfSq",5) == 1950285197) strcat(s, "a");
if (crc32("seybaREByu",10) == 2068674410) strcat(s, "B");
if (crc32("meKCB",5) == 2486246795) strcat(s, "s");
if (crc32("zDBGJNOOIEsaR",13) == 587441719) strcat(s, "h");
if (crc32("QMseK",5) == 3729287479) strcat(s, "n");
if (crc32("TkBRhnkajy",10) == 2213393288) strcat(s, "e");
if (crc32("KKbZQ",5) == 2994702987) strcat(s, "d");
if (crc32("LMWqiqNzlULQTM",14) == 1828716045) strcat(s, "u");
if (crc32("dDAjLJfx",8) == 1677303222) strcat(s, "W");
if (crc32("yRcddklwORppvI",14) == 508741378) strcat(s, "p");
    return s;
}

char *untenebrous_adjectives() {
    char *s = calloc(12);
    if (crc32("BWAfyN",6) == 2030714877) strcat(s, "u");
if (crc32("NefGiyKmJ",9) == 719914112) strcat(s, "n");
if (crc32("uTSRFcMNJRaXf",13) == 3303838369) strcat(s, "t");
if (crc32("XBBemtc",7) == 1055525810) strcat(s, "e");
if (crc32("gqnnXiM",7) == 805677222) strcat(s, "n");
if (crc32("SbkkGzrau",9) == 1138185232) strcat(s, "q");
if (crc32("NWMUBBaMrwxb",12) == 2947999360) strcat(s, "e");
if (crc32("lhKVRMswvZtWnBm",15) == 160647595) strcat(s, "b");
if (crc32("pMWjQdOH",8) == 489594032) strcat(s, "r");
if (crc32("ZYFKcCYIIOgF",12) == 473240234) strcat(s, "o");
if (crc32("yqvdQcoCSakWCO",14) == 3877458957) strcat(s, "t");
if (crc32("rNxSCVlfo",9) == 260324220) strcat(s, "u");
if (crc32("kscMbWCafy",10) == 1899995975) strcat(s, "n");
if (crc32("KQQYD",5) == 3976647057) strcat(s, "s");
    return s;
}

char *chasubled_adjectives() {
    char *s = calloc(10);
    if (crc32("fYfEZDahtCo",11) == 2675843663) strcat(s, "l");
if (crc32("jStCU",5) == 1605714316) strcat(s, "c");
if (crc32("VfYKydD",7) == 128209929) strcat(s, "a");
if (crc32("KhAgozWCpVxbzF",14) == 625250831) strcat(s, "h");
if (crc32("QkoruubRB",9) == 57299589) strcat(s, "a");
if (crc32("DxbHKOml",8) == 2366606874) strcat(s, "d");
if (crc32("RbKdKRT",7) == 1866025127) strcat(s, "s");
if (crc32("KLUUI",5) == 1670813163) strcat(s, "m");
if (crc32("jjIsSry",7) == 1837537190) strcat(s, "u");
if (crc32("nnaZcGLrpgqFt",13) == 2109916645) strcat(s, "b");
if (crc32("viczg",5) == 388213048) strcat(s, "b");
if (crc32("sSZeTVAYQYxRBNf",15) == 1491179624) strcat(s, "l");
if (crc32("MaLbkpnreDqWI",13) == 1655443634) strcat(s, "N");
if (crc32("VHvYlGn",7) == 2852813164) strcat(s, "e");
if (crc32("EURofYHhVVy",11) == 1043668838) strcat(s, "d");
    return s;
}

char *tungstenic_adjectives() {
    char *s = calloc(11);
    if (crc32("KGAkP",5) == 1945696942) strcat(s, "t");
if (crc32("dCdqyRLWVG",10) == 280082323) strcat(s, "u");
if (crc32("CLbxoZms",8) == 3593763178) strcat(s, "n");
if (crc32("jzQgvjr",7) == 2269457608) strcat(s, "i");
if (crc32("coexQHzgzta",11) == 2963672458) strcat(s, "g");
if (crc32("JnISTcada",9) == 235782516) strcat(s, "G");
if (crc32("ctbyY",5) == 1542781418) strcat(s, "s");
if (crc32("khixMgvdeON",11) == 257241400) strcat(s, "t");
if (crc32("YoLPzgZ",7) == 2095701107) strcat(s, "e");
if (crc32("OHCKjqSDypRwK",13) == 3571502618) strcat(s, "n");
if (crc32("eyNDqQrC",8) == 2442822543) strcat(s, "l");
if (crc32("xiGArAknPRo",11) == 4001641045) strcat(s, "i");
if (crc32("zImySaTcr",9) == 341671530) strcat(s, "c");
    return s;
}

char *paragogical_adjectives() {
    char *s = calloc(12);
    if (crc32("uJyzxg",6) == 2198829228) strcat(s, "p");
if (crc32("IMumncPNBojzjw",14) == 233967504) strcat(s, "a");
if (crc32("CFEECyvUAmSEb",13) == 814783291) strcat(s, "x");
if (crc32("fQwJjRiNzoziZN",14) == 1997772132) strcat(s, "r");
if (crc32("VICfNthRLFAWSD",14) == 1405047174) strcat(s, "q");
if (crc32("XXiRBxBtaxDVS",13) == 1607332745) strcat(s, "a");
if (crc32("GUDqMdLbhYhught",15) == 2573730908) strcat(s, "y");
if (crc32("XkOzRhpzi",9) == 3019244429) strcat(s, "g");
if (crc32("txIErvDAqIlevfL",15) == 93195347) strcat(s, "o");
if (crc32("ykqvglSfUtB",11) == 2398162189) strcat(s, "I");
if (crc32("RjnbyPvoueW",11) == 1424564859) strcat(s, "g");
if (crc32("FjRbSh",6) == 1139349668) strcat(s, "i");
if (crc32("RVxbVRSWtc",10) == 1134114955) strcat(s, "K");
if (crc32("RVhRszuaWulAy",13) == 1022397834) strcat(s, "c");
if (crc32("YnMlnvlAIZQ",11) == 382222798) strcat(s, "G");
if (crc32("NEbgTVOgiKSwB",13) == 2390257316) strcat(s, "a");
if (crc32("Hveid",5) == 1342793649) strcat(s, "l");
    return s;
}

char *doubleminded_adjectives() {
    char *s = calloc(13);
    if (crc32("mTbtLR",6) == 4182826040) strcat(s, "B");
if (crc32("PJmHJoyhEj",10) == 3893585613) strcat(s, "d");
if (crc32("ONvUrtKtCDx",11) == 1832085192) strcat(s, "n");
if (crc32("fEJUrU",6) == 1739223248) strcat(s, "o");
if (crc32("IhBwcXWmVS",10) == 2864455839) strcat(s, "u");
if (crc32("RvSGLX",6) == 319291382) strcat(s, "b");
if (crc32("JCjZNDXGnYmNGdG",15) == 94885560) strcat(s, "G");
if (crc32("bdilcHaO",8) == 917722869) strcat(s, "l");
if (crc32("rKSwkVMjsyjz",12) == 545555812) strcat(s, "e");
if (crc32("zxiuyjAccAeCl",13) == 3407973684) strcat(s, "m");
if (crc32("AVUDWBKJ",8) == 3078602610) strcat(s, "W");
if (crc32("malSWvpyBR",10) == 165607347) strcat(s, "i");
if (crc32("oymLHUDuuzSS",12) == 4041125327) strcat(s, "n");
if (crc32("BklaGZnAny",10) == 361650175) strcat(s, "d");
if (crc32("uvdcpf",6) == 3917774856) strcat(s, "e");
if (crc32("miMromIToU",10) == 743210407) strcat(s, "t");
if (crc32("hJAnebHDvImmvMO",15) == 2824308946) strcat(s, "d");
    return s;
}

char *unfuturistic_adjectives() {
    char *s = calloc(13);
    if (crc32("CHjVXFkULLHyns",14) == 2850073565) strcat(s, "u");
if (crc32("JdAaA",5) == 1816140726) strcat(s, "u");
if (crc32("NVTBhBOwzxR",11) == 1301371234) strcat(s, "c");
if (crc32("MyCtU",5) == 1392029411) strcat(s, "n");
if (crc32("IGcQTDquJJnuGOh",15) == 70800343) strcat(s, "l");
if (crc32("RakXETWl",8) == 1127341971) strcat(s, "f");
if (crc32("UrAUFypA",8) == 4234094197) strcat(s, "u");
if (crc32("cvJiiUcOrWBf",12) == 2029755341) strcat(s, "r");
if (crc32("mLjztYm",7) == 3541380140) strcat(s, "t");
if (crc32("FgGFzKkEsPC",11) == 1597429763) strcat(s, "u");
if (crc32("HRRuLqZDpI",10) == 3559130261) strcat(s, "r");
if (crc32("QHFtHQpQSxVt",12) == 3542122284) strcat(s, "G");
if (crc32("ymtSnH",6) == 4120078079) strcat(s, "i");
if (crc32("MWmbgI",6) == 2722887020) strcat(s, "p");
if (crc32("HvNQMQ",6) == 1800734574) strcat(s, "s");
if (crc32("RMZilziE",8) == 1604226750) strcat(s, "R");
if (crc32("HyHBDZ",6) == 2485039243) strcat(s, "t");
if (crc32("ojqJnI",6) == 1669698135) strcat(s, "L");
if (crc32("cmxHlzsWAKZx",12) == 3065610327) strcat(s, "i");
if (crc32("BMHUJvW",7) == 782287396) strcat(s, "H");
if (crc32("tljUUOkeSh",10) == 1620938159) strcat(s, "c");
    return s;
}

char *spotted_adjectives() {
    char *s = calloc(8);
    if (crc32("vjusUmSwKEE",11) == 2559915736) strcat(s, "s");
if (crc32("DUHopPIRuS",10) == 3517418591) strcat(s, "p");
if (crc32("vSYCxyKkyGQp",12) == 4003397962) strcat(s, "o");
if (crc32("DunfaLJxeVo",11) == 154184794) strcat(s, "t");
if (crc32("LCpZDDGTSr",10) == 3501709679) strcat(s, "t");
if (crc32("vIKDDAUPs",9) == 381439638) strcat(s, "e");
if (crc32("DQjNjANMLj",10) == 2050215129) strcat(s, "d");
    return s;
}

char *bewhiskered_adjectives() {
    char *s = calloc(12);
    if (crc32("rJFrQkk",7) == 3964459596) strcat(s, "y");
if (crc32("eAGNLQeyVogOVa",14) == 3013185578) strcat(s, "b");
if (crc32("yFCqAMaJYmCDxD",14) == 2207149814) strcat(s, "P");
if (crc32("AUfdECA",7) == 767293605) strcat(s, "e");
if (crc32("hiFoOGrJyLQSR",13) == 3065588131) strcat(s, "J");
if (crc32("mctmHExAndCd",12) == 1033191225) strcat(s, "w");
if (crc32("OKoqFRl",7) == 3492600827) strcat(s, "G");
if (crc32("qgwjSiJfcfCIsIR",15) == 2059792457) strcat(s, "h");
if (crc32("IBnttSpZNlxe",12) == 2579792050) strcat(s, "i");
if (crc32("nKsxjlTLY",9) == 2594778587) strcat(s, "Z");
if (crc32("AYjpchLBoUSPok",14) == 1271404302) strcat(s, "s");
if (crc32("nCkSJekVrwhB",12) == 2248748007) strcat(s, "k");
if (crc32("PGmYfOXxw",9) == 3736300799) strcat(s, "m");
if (crc32("FAfxANla",8) == 3589457776) strcat(s, "e");
if (crc32("SGhfXg",6) == 3262583930) strcat(s, "r");
if (crc32("YIRyG",5) == 1816174914) strcat(s, "e");
if (crc32("cFSJMn",6) == 2742658291) strcat(s, "d");
    return s;
}

char *microbial_adjectives() {
    char *s = calloc(10);
    if (crc32("dKJejNmfnZBqEHw",15) == 2821688270) strcat(s, "m");
if (crc32("UQtGmkSdUn",10) == 3369156526) strcat(s, "i");
if (crc32("PqbKRrzOI",9) == 796250225) strcat(s, "i");
if (crc32("tudLr",5) == 998806105) strcat(s, "c");
if (crc32("IPgaZge",7) == 2662735817) strcat(s, "r");
if (crc32("jMYosdvBqDJH",12) == 374891169) strcat(s, "o");
if (crc32("BMYNA",5) == 1202928942) strcat(s, "G");
if (crc32("doGGGSgTXgtuj",13) == 2734438702) strcat(s, "b");
if (crc32("sUBVbpfUCwyAH",13) == 3751979865) strcat(s, "i");
if (crc32("VLIytkBhndGykMl",15) == 4140307173) strcat(s, "a");
if (crc32("APibgbEfOL",10) == 758512097) strcat(s, "l");
    return s;
}

char *vizorless_adjectives() {
    char *s = calloc(10);
    if (crc32("BOnyjSl",7) == 3011287611) strcat(s, "Y");
if (crc32("KQXcImINaVb",11) == 307225774) strcat(s, "v");
if (crc32("plgFhE",6) == 2673237078) strcat(s, "i");
if (crc32("yhbGTCOmd",9) == 302733752) strcat(s, "z");
if (crc32("vDtiJm",6) == 1527041272) strcat(s, "o");
if (crc32("QWhcekXAw",9) == 312715742) strcat(s, "r");
if (crc32("jbDGng",6) == 2209106048) strcat(s, "k");
if (crc32("RqjZuNOTMPXpc",13) == 2486857068) strcat(s, "l");
if (crc32("MnPTpDKs",8) == 184774105) strcat(s, "e");
if (crc32("WsaillS",7) == 1467306694) strcat(s, "V");
if (crc32("YFqED",5) == 3838992872) strcat(s, "s");
if (crc32("QKDtOSfbRe",10) == 3683662098) strcat(s, "D");
if (crc32("goQFkPProDq",11) == 886637431) strcat(s, "s");
    return s;
}

char *fireeating_adjectives() {
    char *s = calloc(11);
    if (crc32("PKlOIOZZd",9) == 2944457953) strcat(s, "f");
if (crc32("EfdTddevT",9) == 266807874) strcat(s, "i");
if (crc32("NByabfup",8) == 3722845575) strcat(s, "r");
if (crc32("nctNAnLXpiXUch",14) == 3578669652) strcat(s, "R");
if (crc32("FeAWn",5) == 868302334) strcat(s, "e");
if (crc32("FhIYOw",6) == 177106960) strcat(s, "N");
if (crc32("EyHdlQRBEjG",11) == 249449638) strcat(s, "e");
if (crc32("tVMzmx",6) == 683103645) strcat(s, "a");
if (crc32("ySXaaqIGpymJgq",14) == 2725459427) strcat(s, "t");
if (crc32("jVwuUsiXeC",10) == 221112356) strcat(s, "i");
if (crc32("peDTZRdA",8) == 337321700) strcat(s, "t");
if (crc32("SSoTIdTb",8) == 1278140557) strcat(s, "n");
if (crc32("jAuHiZwwmyW",11) == 3503269876) strcat(s, "L");
if (crc32("llDhgJTlqH",10) == 3418055683) strcat(s, "g");
    return s;
}

char *platinocyanic_adjectives() {
    char *s = calloc(14);
    if (crc32("hBEzUYpki",9) == 1994425768) strcat(s, "p");
if (crc32("lTMOVs",6) == 875730880) strcat(s, "l");
if (crc32("uPGrGRkHWacahRU",15) == 3981847037) strcat(s, "h");
if (crc32("GnTwTdXdCWDbu",13) == 1675998863) strcat(s, "a");
if (crc32("GbZFgDm",7) == 2142150674) strcat(s, "t");
if (crc32("ZltAHTDYORgX",12) == 2927043956) strcat(s, "i");
if (crc32("PozUJtFIcCMOqv",14) == 249090684) strcat(s, "n");
if (crc32("erbJhwFKVzH",11) == 2186211014) strcat(s, "o");
if (crc32("FdYYXm",6) == 2423785201) strcat(s, "c");
if (crc32("PhgsNBPPygo",11) == 557630900) strcat(s, "u");
if (crc32("rIjBB",5) == 3169915080) strcat(s, "y");
if (crc32("rOpmbsXNv",9) == 2434027536) strcat(s, "w");
if (crc32("sotWFVoKfIfFs",13) == 2986653011) strcat(s, "a");
if (crc32("GEcdIPSDj",9) == 2495242170) strcat(s, "Z");
if (crc32("HjtPBAQ",7) == 44615545) strcat(s, "n");
if (crc32("ZilYWnltWi",10) == 1482701731) strcat(s, "i");
if (crc32("jxEgbemIoY",10) == 325284389) strcat(s, "c");
    return s;
}

char *chalybeate_adjectives() {
    char *s = calloc(11);
    if (crc32("YTLhiCJyXqpxY",13) == 366314548) strcat(s, "w");
if (crc32("somMNsp",7) == 2676056216) strcat(s, "c");
if (crc32("wjzOom",6) == 3661960126) strcat(s, "h");
if (crc32("BoqHtbKkNNEi",12) == 4197619241) strcat(s, "F");
if (crc32("ZSFxHsZOB",9) == 2238128230) strcat(s, "a");
if (crc32("mnWrBOsu",8) == 3075464397) strcat(s, "h");
if (crc32("KxyCbqVw",8) == 464569004) strcat(s, "l");
if (crc32("OppoLv",6) == 1467333716) strcat(s, "L");
if (crc32("BlCvNUls",8) == 2888472253) strcat(s, "y");
if (crc32("iPqePzFud",9) == 3422819766) strcat(s, "d");
if (crc32("nfdQSBWrE",9) == 3773163507) strcat(s, "b");
if (crc32("hREWLoztZM",10) == 3433543874) strcat(s, "k");
if (crc32("MsrciZZdESZh",12) == 1830829920) strcat(s, "e");
if (crc32("iOTgBATwk",9) == 813716765) strcat(s, "G");
if (crc32("yehoE",5) == 2618239613) strcat(s, "a");
if (crc32("eCBXTOqlEzboejv",15) == 4010498992) strcat(s, "t");
if (crc32("ijVySWeFNIPNWlP",15) == 1509983914) strcat(s, "e");
    return s;
}

char *unblasted_adjectives() {
    char *s = calloc(10);
    if (crc32("GlmQrN",6) == 979432370) strcat(s, "J");
if (crc32("xvZeexdoYfKW",12) == 613434335) strcat(s, "u");
if (crc32("qkjVyZYUg",9) == 1581556281) strcat(s, "n");
if (crc32("ucIDILVjhPDj",12) == 1334896978) strcat(s, "y");
if (crc32("uXhRf",5) == 2469519052) strcat(s, "b");
if (crc32("MWSisHzGzgIbc",13) == 661188234) strcat(s, "P");
if (crc32("FgNtUK",6) == 1293958404) strcat(s, "l");
if (crc32("toMpzvRQTClm",12) == 1052238899) strcat(s, "a");
if (crc32("earHRbPZR",9) == 1028034806) strcat(s, "r");
if (crc32("GaAzZUjgVib",11) == 2408531361) strcat(s, "s");
if (crc32("JzuehyLfbbbAXNu",15) == 776554501) strcat(s, "t");
if (crc32("BDaSiurI",8) == 2131507432) strcat(s, "X");
if (crc32("idbPSECkUeIgcYz",15) == 2627024531) strcat(s, "e");
if (crc32("ABwMKIqK",8) == 28401943) strcat(s, "d");
    return s;
}

char *unentwined_adjectives() {
    char *s = calloc(11);
    if (crc32("mcBooDXH",8) == 1458655018) strcat(s, "L");
if (crc32("DAUZUZFAw",9) == 1542434179) strcat(s, "u");
if (crc32("wHmIEEIsiCzlB",13) == 3142698111) strcat(s, "n");
if (crc32("ycFoXVlFjRxIYi",14) == 1421232385) strcat(s, "e");
if (crc32("XocHRnODdjTVfL",14) == 2863895293) strcat(s, "Q");
if (crc32("aSdjadzibj",10) == 4213570343) strcat(s, "n");
if (crc32("baIYYf",6) == 443904503) strcat(s, "t");
if (crc32("BsvcgPSUIWURHR",14) == 326392402) strcat(s, "w");
if (crc32("FzNlGACzEv",10) == 4140015269) strcat(s, "i");
if (crc32("OizJbQNzl",9) == 3050214824) strcat(s, "n");
if (crc32("fQVNZuZak",9) == 1423290830) strcat(s, "T");
if (crc32("uygGgXH",7) == 1698526329) strcat(s, "e");
if (crc32("sMtnMcYUVozkkAk",15) == 4173756339) strcat(s, "d");
    return s;
}

char *unmuscular_adjectives() {
    char *s = calloc(11);
    if (crc32("exrsdJfvmnZ",11) == 3938691387) strcat(s, "u");
if (crc32("hTphlMiYtJ",10) == 3852552746) strcat(s, "i");
if (crc32("SLdVsI",6) == 1908183013) strcat(s, "n");
if (crc32("LvaNYpcA",8) == 3947964794) strcat(s, "f");
if (crc32("PcGvdm",6) == 133391337) strcat(s, "m");
if (crc32("uGvFMgyOh",9) == 1088876445) strcat(s, "u");
if (crc32("njtrOwNI",8) == 2789784843) strcat(s, "y");
if (crc32("YcdYpcpcETgNtb",14) == 3771568495) strcat(s, "s");
if (crc32("yFlWoALCpy",10) == 297917775) strcat(s, "p");
if (crc32("YbOuRrL",7) == 3842289260) strcat(s, "c");
if (crc32("WWVNQqoWHJmE",12) == 810222762) strcat(s, "f");
if (crc32("edzDXT",6) == 3896297874) strcat(s, "u");
if (crc32("bmroHEvdW",9) == 478613651) strcat(s, "z");
if (crc32("UkkrbGeUciydM",13) == 3711476650) strcat(s, "l");
if (crc32("johWiDKxgJuGym",14) == 1066248114) strcat(s, "a");
if (crc32("hAnJwQDzMX",10) == 995651624) strcat(s, "g");
if (crc32("pHssFzmITYgx",12) == 4064777645) strcat(s, "r");
    return s;
}

char *unrebukable_adjectives() {
    char *s = calloc(12);
    if (crc32("bwcMjbM",7) == 979912776) strcat(s, "u");
if (crc32("fzKJiP",6) == 843178938) strcat(s, "n");
if (crc32("zsWCOgzVmXkr",12) == 429186799) strcat(s, "T");
if (crc32("BLPagnznRUzCkXF",15) == 153586980) strcat(s, "r");
if (crc32("jevSGCZdcWxL",12) == 2729406589) strcat(s, "j");
if (crc32("xYYXtoB",7) == 2074019234) strcat(s, "e");
if (crc32("IFjgIAcEQkYNVs",14) == 2678099046) strcat(s, "l");
if (crc32("tCVceWsrD",9) == 523658706) strcat(s, "b");
if (crc32("sfQCIsCqe",9) == 1619264496) strcat(s, "u");
if (crc32("KYWUZZpfQGdCv",13) == 3282442646) strcat(s, "A");
if (crc32("AWPqXWdl",8) == 2357499651) strcat(s, "k");
if (crc32("oWJFhWfuWDTDDez",15) == 2558152886) strcat(s, "q");
if (crc32("bjptfWwtOI",10) == 3268271970) strcat(s, "a");
if (crc32("JOEBChHcCoeAWMc",15) == 2715835616) strcat(s, "b");
if (crc32("ByzAiiPyMrt",11) == 1117254419) strcat(s, "l");
if (crc32("XTtDM",5) == 624324891) strcat(s, "U");
if (crc32("BNodh",5) == 2661882094) strcat(s, "e");
    return s;
}

char *shellless_adjectives() {
    char *s = calloc(10);
    if (crc32("AuplBFnh",8) == 2495134620) strcat(s, "s");
if (crc32("vAtsw",5) == 177459980) strcat(s, "h");
if (crc32("SsjUooFXae",10) == 930036357) strcat(s, "e");
if (crc32("MqYNPjwM",8) == 388180603) strcat(s, "G");
if (crc32("ojDcuiB",7) == 3016373187) strcat(s, "l");
if (crc32("EzfGZvfZx",9) == 1572884559) strcat(s, "P");
if (crc32("prDyoP",6) == 4289373668) strcat(s, "l");
if (crc32("EjfwPBYvvydn",12) == 3365801) strcat(s, "N");
if (crc32("ucMOXWx",7) == 130270208) strcat(s, "l");
if (crc32("gGFacpOMc",9) == 1177012701) strcat(s, "e");
if (crc32("oREvV",5) == 1153852570) strcat(s, "p");
if (crc32("wAJPRxINuQ",10) == 4289105695) strcat(s, "s");
if (crc32("AyhZxBJwlLMb",12) == 3582067808) strcat(s, "z");
if (crc32("JKCMs",5) == 1718831774) strcat(s, "s");
    return s;
}

char *quasiprovocative_adjectives() {
    char *s = calloc(17);
    if (crc32("pcwHbwljJDeuuW",14) == 2763964701) strcat(s, "a");
if (crc32("MEuUmLE",7) == 816917842) strcat(s, "q");
if (crc32("eqKIQhwt",8) == 1952643314) strcat(s, "g");
if (crc32("FBRzlcEegysCRy",14) == 606842409) strcat(s, "u");
if (crc32("OvhmtTE",7) == 517089430) strcat(s, "j");
if (crc32("fQhgIzzlhm",10) == 1461234989) strcat(s, "a");
if (crc32("ADxxJse",7) == 3359079744) strcat(s, "s");
if (crc32("rcnONYHKshWTC",13) == 977561831) strcat(s, "M");
if (crc32("DtFzp",5) == 2127441773) strcat(s, "i");
if (crc32("mdIeYynebfBWlfS",15) == 3125962629) strcat(s, "q");
if (crc32("YwsOwkS",7) == 1708544224) strcat(s, "p");
if (crc32("RfSYxaPsZIzJgf",14) == 2511295523) strcat(s, "z");
if (crc32("XfyXVdrbLCom",12) == 29712155) strcat(s, "r");
if (crc32("cyqzTAwqJkr",11) == 2500521820) strcat(s, "b");
if (crc32("veIbADRCG",9) == 1143280237) strcat(s, "o");
if (crc32("SCiAHmL",7) == 1621605083) strcat(s, "v");
if (crc32("wMkXGIBxkspGbrZ",15) == 250096814) strcat(s, "l");
if (crc32("GtoSG",5) == 4060680758) strcat(s, "o");
if (crc32("xHCWvgI",7) == 874992675) strcat(s, "P");
if (crc32("JKkBfdKHb",9) == 1468445973) strcat(s, "c");
if (crc32("VUEqxBKEX",9) == 2001374276) strcat(s, "f");
if (crc32("hbOawuusPPjkQTY",15) == 4038031250) strcat(s, "a");
if (crc32("WypvfB",6) == 3300737969) strcat(s, "t");
if (crc32("hiiBinsBmKzTrQZ",15) == 1985012050) strcat(s, "x");
if (crc32("IUmPQFg",7) == 2727907889) strcat(s, "i");
if (crc32("EuweCTUv",8) == 2510626899) strcat(s, "h");
if (crc32("XSDFJLfIUDFLMh",14) == 979999414) strcat(s, "v");
if (crc32("OzwJUA",6) == 1794249131) strcat(s, "n");
if (crc32("JeaBqoa",7) == 1031962922) strcat(s, "e");
    return s;
}

char *actinographic_adjectives() {
    char *s = calloc(14);
    if (crc32("fzlRzpjZnV",10) == 1749763085) strcat(s, "D");
if (crc32("ExFGSP",6) == 379736757) strcat(s, "a");
if (crc32("jQWMIX",6) == 2001563622) strcat(s, "c");
if (crc32("KhvpGWsb",8) == 1169915827) strcat(s, "t");
if (crc32("nSsKRBpBsLuJ",12) == 866036213) strcat(s, "i");
if (crc32("lyojfhZRgv",10) == 1421112610) strcat(s, "V");
if (crc32("OfAccFvtNF",10) == 1225863553) strcat(s, "n");
if (crc32("tkScdmKlr",9) == 3999790867) strcat(s, "b");
if (crc32("DZTHioy",7) == 2679435779) strcat(s, "o");
if (crc32("zvcVjQxXdLwCe",13) == 1548571514) strcat(s, "g");
if (crc32("zAKxHeEmc",9) == 3507244835) strcat(s, "r");
if (crc32("iyEANiXXvovmEO",14) == 3719404582) strcat(s, "L");
if (crc32("XUZRgK",6) == 2715163618) strcat(s, "a");
if (crc32("UyBAGyfJemJnZ",13) == 921105718) strcat(s, "e");
if (crc32("mDEbufAD",8) == 2861013098) strcat(s, "p");
if (crc32("fTRmVEuLgyDT",12) == 574921611) strcat(s, "h");
if (crc32("HSDNMVh",7) == 1294308861) strcat(s, "h");
if (crc32("VvHQWTrXRbRPsp",14) == 3927841384) strcat(s, "i");
if (crc32("kYHTzxYy",8) == 1823897727) strcat(s, "c");
    return s;
}

char *bridgelike_adjectives() {
    char *s = calloc(11);
    if (crc32("VARYOZIkdztwKDY",15) == 2929962005) strcat(s, "b");
if (crc32("faxNYJDqaBD",11) == 104498892) strcat(s, "r");
if (crc32("aiqczbRkSJ",10) == 1852084141) strcat(s, "A");
if (crc32("OlgFWxPnMauOOJq",15) == 35477099) strcat(s, "i");
if (crc32("RXAxaXUGXk",10) == 3773417432) strcat(s, "v");
if (crc32("dKHlSghMq",9) == 1727037017) strcat(s, "d");
if (crc32("DLlze",5) == 324458750) strcat(s, "g");
if (crc32("JLBRkDoAQbcP",12) == 127243091) strcat(s, "e");
if (crc32("fchSeBYNVoc",11) == 1579014756) strcat(s, "l");
if (crc32("aThZTYNfiMSy",12) == 3883573807) strcat(s, "o");
if (crc32("gJRILKT",7) == 3749345412) strcat(s, "i");
if (crc32("Mghjp",5) == 4260130422) strcat(s, "Y");
if (crc32("xDAbJdrzuvN",11) == 2913311090) strcat(s, "k");
if (crc32("mIOtlI",6) == 109892199) strcat(s, "e");
    return s;
}

char *ungrazed_adjectives() {
    char *s = calloc(9);
    if (crc32("WJTqpKhdV",9) == 790170365) strcat(s, "u");
if (crc32("GGezzyVCgWaaob",14) == 3659398889) strcat(s, "q");
if (crc32("KvLWdHtEl",9) == 3929129409) strcat(s, "n");
if (crc32("OUKWhFBft",9) == 2911840209) strcat(s, "g");
if (crc32("ftzSgGX",7) == 602639566) strcat(s, "R");
if (crc32("WjImVB",6) == 2716558250) strcat(s, "r");
if (crc32("NAMlaSYlAcpsO",13) == 3875511005) strcat(s, "B");
if (crc32("YOWszpLrTWWP",12) == 2485925782) strcat(s, "a");
if (crc32("AcDXmwNVswYJ",12) == 2457330305) strcat(s, "K");
if (crc32("coaOhe",6) == 1281364520) strcat(s, "z");
if (crc32("idGciePGdTgG",12) == 3594356576) strcat(s, "O");
if (crc32("ZbCsRNbJXuWKtT",14) == 1874775095) strcat(s, "e");
if (crc32("YBmOhTbpCZ",10) == 323111239) strcat(s, "d");
    return s;
}

char *slavocratic_adjectives() {
    char *s = calloc(12);
    if (crc32("RQPGqeXOAI",10) == 968803188) strcat(s, "W");
if (crc32("xfqjfRNVZ",9) == 850103498) strcat(s, "s");
if (crc32("swTWf",5) == 3022421173) strcat(s, "l");
if (crc32("anPiVhRBzexqgWl",15) == 1615746775) strcat(s, "f");
if (crc32("ATjfPZyIJhImq",13) == 3175663739) strcat(s, "a");
if (crc32("UnOKCnjZMqm",11) == 3221342082) strcat(s, "Q");
if (crc32("mGGSWFI",7) == 2532033816) strcat(s, "v");
if (crc32("eMOzM",5) == 1492511084) strcat(s, "o");
if (crc32("nEVnnQQAtBuJrun",15) == 838443570) strcat(s, "c");
if (crc32("naqLRcilRBc",11) == 1759403262) strcat(s, "r");
if (crc32("RvUmKKHz",8) == 3089943636) strcat(s, "L");
if (crc32("OhXePGev",8) == 2214436865) strcat(s, "a");
if (crc32("asUizkEa",8) == 2604250933) strcat(s, "t");
if (crc32("vUzDwQwcCaVezh",14) == 158663703) strcat(s, "i");
if (crc32("WVPWF",5) == 2760815934) strcat(s, "c");
    return s;
}

char *unparliamented_adjectives() {
    char *s = calloc(15);
    if (crc32("TWdgojaKLlw",11) == 135932145) strcat(s, "v");
if (crc32("TRHQObX",7) == 1497356919) strcat(s, "u");
if (crc32("DdHCAxwNer",10) == 3708054626) strcat(s, "n");
if (crc32("vqyFEuMFcntJ",12) == 620926578) strcat(s, "p");
if (crc32("hHZukPndDw",10) == 2855608431) strcat(s, "a");
if (crc32("tLzhcC",6) == 1516785242) strcat(s, "k");
if (crc32("yhAEvxBV",8) == 1854031438) strcat(s, "r");
if (crc32("XjcpMJhqbgiKl",13) == 466359616) strcat(s, "l");
if (crc32("OtuDCWMhm",9) == 1246562239) strcat(s, "i");
if (crc32("TlwMmPamCZ",10) == 2442463135) strcat(s, "B");
if (crc32("cIbLxAitfSwIY",13) == 269488531) strcat(s, "a");
if (crc32("wrUeCeqAp",9) == 3957850062) strcat(s, "S");
if (crc32("wdRDiqotxcY",11) == 2987073448) strcat(s, "m");
if (crc32("IVbRpGm",7) == 302711039) strcat(s, "l");
if (crc32("LRumlD",6) == 798777056) strcat(s, "e");
if (crc32("YaPkBV",6) == 252490670) strcat(s, "G");
if (crc32("TQsqZC",6) == 2694227416) strcat(s, "n");
if (crc32("bvnHJp",6) == 2106560614) strcat(s, "t");
if (crc32("wXSuZhUagZjPJqt",15) == 3441035177) strcat(s, "e");
if (crc32("ULjiGLmK",8) == 2283576596) strcat(s, "d");
    return s;
}

char *Bosporan_adjectives() {
    char *s = calloc(9);
    if (crc32("ppjrU",5) == 394741687) strcat(s, "B");
if (crc32("jsLRgWNjgcN",11) == 631893890) strcat(s, "L");
if (crc32("QfGncPglsPVbbIb",15) == 1685181307) strcat(s, "o");
if (crc32("fvkghRvAiaLg",12) == 9821607) strcat(s, "Z");
if (crc32("EVLvhxDBVjyxyB",14) == 1251432387) strcat(s, "s");
if (crc32("ZNOBwV",6) == 545511200) strcat(s, "C");
if (crc32("wIxvISPkDsha",12) == 4093000456) strcat(s, "p");
if (crc32("dLVqvi",6) == 1241123890) strcat(s, "o");
if (crc32("aPhnsabuwjO",11) == 3907464282) strcat(s, "r");
if (crc32("bEQSWHepULtr",12) == 3894384624) strcat(s, "G");
if (crc32("vfQjFVdx",8) == 2049607761) strcat(s, "a");
if (crc32("guLzyk",6) == 3990677180) strcat(s, "f");
if (crc32("beoWIvhT",8) == 716292782) strcat(s, "n");
    return s;
}

char *endarterial_adjectives() {
    char *s = calloc(12);
    if (crc32("BWJsdbNLui",10) == 4094995303) strcat(s, "b");
if (crc32("ERtsQDhrGCl",11) == 1836253836) strcat(s, "e");
if (crc32("IHIUJuIPcd",10) == 2987268162) strcat(s, "n");
if (crc32("zdAsFZCgaCil",12) == 3478291804) strcat(s, "T");
if (crc32("quwGylJBX",9) == 2167652079) strcat(s, "d");
if (crc32("tnmPnEXobJV",11) == 4139230012) strcat(s, "H");
if (crc32("wHMGNnMFChR",11) == 1597867925) strcat(s, "a");
if (crc32("djUarGfOMMTwog",14) == 122274061) strcat(s, "x");
if (crc32("ftdYpKS",7) == 2316338691) strcat(s, "r");
if (crc32("oOFRAPjN",8) == 487682337) strcat(s, "q");
if (crc32("lpFugBgf",8) == 3183448929) strcat(s, "t");
if (crc32("wQfOGWhCltRa",12) == 3775611229) strcat(s, "e");
if (crc32("Inxeughok",9) == 1072031483) strcat(s, "r");
if (crc32("gOBNVzSTm",9) == 2089105687) strcat(s, "O");
if (crc32("TjbhDudAJ",9) == 2973070157) strcat(s, "i");
if (crc32("FCWlkqSJeYM",11) == 1583177322) strcat(s, "a");
if (crc32("eMJzpRHw",8) == 932368315) strcat(s, "l");
    return s;
}

char *nonTurkish_adjectives() {
    char *s = calloc(11);
    if (crc32("KjapVllXixYri",13) == 2854374264) strcat(s, "n");
if (crc32("FjbAEKJcx",9) == 1512931325) strcat(s, "K");
if (crc32("ICWFfDERGPWYuMG",15) == 525502599) strcat(s, "o");
if (crc32("BvmYBqZlXTurCUb",15) == 3642010548) strcat(s, "n");
if (crc32("qJYvxfqliFHrnRu",15) == 870197601) strcat(s, "m");
if (crc32("yHySrZ",6) == 454439491) strcat(s, "T");
if (crc32("VVrDjBiQIVaWJU",14) == 295717253) strcat(s, "u");
if (crc32("BdKTKjKbytblwQ",14) == 2113317512) strcat(s, "r");
if (crc32("bJLycRTefXfS",12) == 1154726530) strcat(s, "u");
if (crc32("XaXPHOxQTZIhR",13) == 669576549) strcat(s, "k");
if (crc32("VlpPrrCAceWcKj",14) == 3395480395) strcat(s, "M");
if (crc32("feQHTI",6) == 3797049346) strcat(s, "i");
if (crc32("QpsHo",5) == 460643895) strcat(s, "s");
if (crc32("DGXdzP",6) == 4160106972) strcat(s, "G");
if (crc32("HUOVza",6) == 3860444098) strcat(s, "h");
    return s;
}

char *subhexagonal_adjectives() {
    char *s = calloc(13);
    if (crc32("xZuSnOyudoRD",12) == 4243805459) strcat(s, "s");
if (crc32("YVxCu",5) == 3164514884) strcat(s, "u");
if (crc32("flJdce",6) == 4224885182) strcat(s, "b");
if (crc32("jwqevurdaZEOq",13) == 1507084519) strcat(s, "g");
if (crc32("nbgxkSzstoXA",12) == 2505494199) strcat(s, "h");
if (crc32("avNgLGlzodG",11) == 2811162689) strcat(s, "g");
if (crc32("kSIHmIRQiFT",11) == 3161456371) strcat(s, "e");
if (crc32("AACguKmYPC",10) == 966469244) strcat(s, "x");
if (crc32("NUbLBkkSuncj",12) == 2649223958) strcat(s, "f");
if (crc32("uMFvNanTwHBnbeB",15) == 3313974536) strcat(s, "a");
if (crc32("LomcvLG",7) == 2398957192) strcat(s, "N");
if (crc32("LeNkzvTPgoNgHRP",15) == 3097767199) strcat(s, "g");
if (crc32("HCErQSaIWpdNa",13) == 3577757755) strcat(s, "T");
if (crc32("LZJqOxaqyOBl",12) == 2037876691) strcat(s, "o");
if (crc32("usZoJRgyVmUdxZ",14) == 610548465) strcat(s, "j");
if (crc32("rrwWxFdBTjuB",12) == 901871463) strcat(s, "n");
if (crc32("TWhUC",5) == 867601070) strcat(s, "a");
if (crc32("JqhhK",5) == 1509892563) strcat(s, "q");
if (crc32("RMLDjP",6) == 47154407) strcat(s, "l");
    return s;
}

char *unexpiated_adjectives() {
    char *s = calloc(11);
    if (crc32("rdWVNoatrN",10) == 2556869152) strcat(s, "l");
if (crc32("dXRkD",5) == 1017760998) strcat(s, "u");
if (crc32("iPKIs",5) == 4173661853) strcat(s, "n");
if (crc32("RlBVvHvn",8) == 675687768) strcat(s, "n");
if (crc32("LFZjCJDu",8) == 2638663663) strcat(s, "N");
if (crc32("NVRbLwrdp",9) == 4285279865) strcat(s, "e");
if (crc32("cqmOxryAxMyzp",13) == 1973594821) strcat(s, "B");
if (crc32("gvctsUPVyYsYLka",15) == 3471376073) strcat(s, "x");
if (crc32("MRuMl",5) == 2971406660) strcat(s, "q");
if (crc32("dhsbfprx",8) == 4009036317) strcat(s, "p");
if (crc32("pqNxNGYUSSPdtT",14) == 2633220752) strcat(s, "i");
if (crc32("BxrJYlJ",7) == 3793659502) strcat(s, "i");
if (crc32("jkwNMhznfOndHe",14) == 2397479195) strcat(s, "J");
if (crc32("WceXhICFsxGLaaK",15) == 1309994258) strcat(s, "a");
if (crc32("JoKzUo",6) == 198283095) strcat(s, "t");
if (crc32("PjccvEd",7) == 2004501862) strcat(s, "e");
if (crc32("xpasCl",6) == 1834929647) strcat(s, "f");
if (crc32("EAiqUjCkrzpM",12) == 3839174993) strcat(s, "d");
    return s;
}

char *agile_adjectives() {
    char *s = calloc(6);
    if (crc32("ItdFTTynWeebKk",14) == 1752735463) strcat(s, "a");
if (crc32("CAsTgNqLinItY",13) == 741214563) strcat(s, "g");
if (crc32("wZVAO",5) == 392503901) strcat(s, "z");
if (crc32("VsCnWHAILbo",11) == 2973511013) strcat(s, "i");
if (crc32("YemuSiA",7) == 140596470) strcat(s, "U");
if (crc32("EbLUWHsTQ",9) == 2142584667) strcat(s, "l");
if (crc32("BeYSQPfaQB",10) == 2664669824) strcat(s, "R");
if (crc32("PcotKvsusTonwLT",15) == 1877604509) strcat(s, "e");
    return s;
}

char *nonlicensable_adjectives() {
    char *s = calloc(14);
    if (crc32("gaRHZddncra",11) == 1144486010) strcat(s, "n");
if (crc32("xauXPTc",7) == 3767800224) strcat(s, "x");
if (crc32("AksCE",5) == 3301148982) strcat(s, "o");
if (crc32("MtUsYQItItalhr",14) == 1428300721) strcat(s, "I");
if (crc32("AYbcacr",7) == 658378031) strcat(s, "n");
if (crc32("qQVjn",5) == 3674053787) strcat(s, "N");
if (crc32("uceRz",5) == 2831314544) strcat(s, "l");
if (crc32("ONVEapkzxEsrc",13) == 4070980116) strcat(s, "L");
if (crc32("baGey",5) == 3805056617) strcat(s, "i");
if (crc32("CdVwBLnVhmLdc",13) == 1016997790) strcat(s, "q");
if (crc32("UnzGUpF",7) == 2972294822) strcat(s, "c");
if (crc32("WlkTABgl",8) == 1704236668) strcat(s, "p");
if (crc32("HApHmurPBBv",11) == 2366214703) strcat(s, "e");
if (crc32("MVVKSNc",7) == 1794794300) strcat(s, "R");
if (crc32("lPQuu",5) == 1320431220) strcat(s, "n");
if (crc32("RLIXjkP",7) == 2302520059) strcat(s, "J");
if (crc32("mRNlT",5) == 432968260) strcat(s, "s");
if (crc32("tmkcfpxSqPPIdDw",15) == 276368070) strcat(s, "Q");
if (crc32("xLoFZALDEOQS",12) == 2098738377) strcat(s, "a");
if (crc32("phyJaeGUY",9) == 1464801907) strcat(s, "r");
if (crc32("jiASJDoXjJHppH",14) == 3120539870) strcat(s, "b");
if (crc32("ZVLJbP",6) == 1580576477) strcat(s, "B");
if (crc32("JYCrRgYYABiBgOf",15) == 658943313) strcat(s, "l");
if (crc32("HfNGLWjB",8) == 390917258) strcat(s, "e");
    return s;
}

char *overcerebral_adjectives() {
    char *s = calloc(13);
    if (crc32("VrrGOuW",7) == 3268673291) strcat(s, "o");
if (crc32("pIsspHAEncZByHy",15) == 2147885519) strcat(s, "y");
if (crc32("mjMoQfNQSbdzj",13) == 3225463540) strcat(s, "v");
if (crc32("GcHDwxIyRzGWh",13) == 4165082508) strcat(s, "e");
if (crc32("GfQrbAyqVUAG",12) == 304781409) strcat(s, "r");
if (crc32("hxtUZFXEVGVDQEr",15) == 1401109969) strcat(s, "c");
if (crc32("AaLUmCKRxOscnXn",15) == 2601188796) strcat(s, "A");
if (crc32("mSsivfmIRFjj",12) == 2239554444) strcat(s, "e");
if (crc32("fcVDCJUefkN",11) == 968216066) strcat(s, "r");
if (crc32("ngNGoGlIm",9) == 3761997887) strcat(s, "e");
if (crc32("gKjRafDQuWA",11) == 566828279) strcat(s, "b");
if (crc32("tksxg",5) == 1881877952) strcat(s, "W");
if (crc32("OoqilLYAn",9) == 638104975) strcat(s, "r");
if (crc32("peazJPaLlQ",10) == 4001382799) strcat(s, "a");
if (crc32("EMhHTaIZn",9) == 2308262066) strcat(s, "w");
if (crc32("fjpVNXfuNmDZav",14) == 541665149) strcat(s, "l");
    return s;
}

char *transpulmonary_adjectives() {
    char *s = calloc(15);
    if (crc32("rjveSPPk",8) == 4259784630) strcat(s, "t");
if (crc32("FaxosHeUvIM",11) == 3081594253) strcat(s, "t");
if (crc32("UbMgrK",6) == 3599942371) strcat(s, "r");
if (crc32("yuWOoo",6) == 3198772306) strcat(s, "a");
if (crc32("euaTNkFCQpdr",12) == 3202671102) strcat(s, "n");
if (crc32("KNwecKMaWhevuvL",15) == 3944640969) strcat(s, "s");
if (crc32("gzKlUyXodsihwZx",15) == 1435979328) strcat(s, "p");
if (crc32("NOVjpnTkVzlrv",13) == 2319365133) strcat(s, "u");
if (crc32("hTWRskjKlyP",11) == 3290438743) strcat(s, "l");
if (crc32("APQQUKsr",8) == 1533308432) strcat(s, "m");
if (crc32("WggML",5) == 1196630844) strcat(s, "M");
if (crc32("WEiMSGzmmw",10) == 4232645592) strcat(s, "o");
if (crc32("ejrgfHEag",9) == 842946757) strcat(s, "W");
if (crc32("QYJIZPMj",8) == 2441079583) strcat(s, "n");
if (crc32("aaPviePqz",9) == 1444486717) strcat(s, "D");
if (crc32("cEzaILepqSJPQcz",15) == 1808011350) strcat(s, "a");
if (crc32("mZtVT",5) == 3919283549) strcat(s, "V");
if (crc32("VupAxKTBOVXmFjP",15) == 1260819738) strcat(s, "r");
if (crc32("wAoQBNQthP",10) == 4056605848) strcat(s, "y");
    return s;
}

char *heliotypic_adjectives() {
    char *s = calloc(11);
    if (crc32("tFKNdlEIwDCen",13) == 2526946880) strcat(s, "m");
if (crc32("LghfJoh",7) == 1614347734) strcat(s, "h");
if (crc32("SLlyXhufEZw",11) == 1515122329) strcat(s, "F");
if (crc32("ujnkPnyTa",9) == 4161024988) strcat(s, "e");
if (crc32("bhUuaMp",7) == 2763568428) strcat(s, "u");
if (crc32("fRXmSfVbOuTPwWA",15) == 1887993631) strcat(s, "l");
if (crc32("dbrWaiFJrPn",11) == 3790464653) strcat(s, "n");
if (crc32("lGyaZpCaCMi",11) == 507883147) strcat(s, "i");
if (crc32("ZaZTaMesZOdQdq",14) == 423223212) strcat(s, "V");
if (crc32("psGVbsugT",9) == 3790997628) strcat(s, "o");
if (crc32("BkWwBKoWDGt",11) == 410147568) strcat(s, "t");
if (crc32("EAZRcPQKoXlm",12) == 1486938663) strcat(s, "y");
if (crc32("UBRNjIsLNbhnn",13) == 3640984242) strcat(s, "p");
if (crc32("RpkJQhS",7) == 175599938) strcat(s, "p");
if (crc32("ZsBGAunRBV",10) == 830337355) strcat(s, "P");
if (crc32("geXoRpgwHjsyvH",14) == 2144208218) strcat(s, "i");
if (crc32("uWGjFGbZTnFPo",13) == 3822935219) strcat(s, "c");
    return s;
}

char *unprognosticated_adjectives() {
    char *s = calloc(17);
    if (crc32("wrjfOFkqE",9) == 2098840227) strcat(s, "u");
if (crc32("XvaJOOzrJttYGE",14) == 4258077362) strcat(s, "T");
if (crc32("AAmbLDQgal",10) == 3757968739) strcat(s, "n");
if (crc32("QzyRBvxdwkGveY",14) == 174452865) strcat(s, "p");
if (crc32("TMoXYtrNLEdnVLP",15) == 477171162) strcat(s, "p");
if (crc32("BobREmL",7) == 679407260) strcat(s, "K");
if (crc32("uvDoVsUjuEJtTeQ",15) == 1531211101) strcat(s, "r");
if (crc32("lnZInjjLF",9) == 4212973220) strcat(s, "c");
if (crc32("ycKvj",5) == 3015579993) strcat(s, "o");
if (crc32("sJewgM",6) == 1369450381) strcat(s, "g");
if (crc32("ItDPXi",6) == 2868990834) strcat(s, "n");
if (crc32("fzIBXPNiAbywkT",14) == 1983487792) strcat(s, "o");
if (crc32("GRcxrSIGXLSCfkN",15) == 3608145774) strcat(s, "m");
if (crc32("nqtstQcHdSyKfD",14) == 3324008527) strcat(s, "s");
if (crc32("KKYEqlYL",8) == 191306872) strcat(s, "O");
if (crc32("ANfGNTOFtgoYl",13) == 403778926) strcat(s, "t");
if (crc32("harnzBAvH",9) == 2797576418) strcat(s, "i");
if (crc32("LueZzyRCVrep",12) == 2883661211) strcat(s, "p");
if (crc32("ZLKQNp",6) == 2655041398) strcat(s, "c");
if (crc32("Ttntt",5) == 2979939872) strcat(s, "a");
if (crc32("ljIAHk",6) == 591058543) strcat(s, "x");
if (crc32("ajGWZriSkfQ",11) == 1049943677) strcat(s, "t");
if (crc32("srxrIziJCjIk",12) == 3251432710) strcat(s, "e");
if (crc32("hZSrGlZmQy",10) == 1187078301) strcat(s, "d");
    return s;
}

char *nuciform_adjectives() {
    char *s = calloc(9);
    if (crc32("FzWoPUU",7) == 1225353166) strcat(s, "n");
if (crc32("gHFKYNqNgEG",11) == 2847347483) strcat(s, "r");
if (crc32("bujyVpbJnNDKAkt",15) == 3722860023) strcat(s, "u");
if (crc32("yObYHkdMGO",10) == 1422537737) strcat(s, "c");
if (crc32("iXrzTiGNZtwp",12) == 1720527304) strcat(s, "i");
if (crc32("TmJlakufzxihopL",15) == 2154889296) strcat(s, "f");
if (crc32("DbtKiezwsBW",11) == 3116812429) strcat(s, "I");
if (crc32("YaweWhFYLKKY",12) == 4004770732) strcat(s, "o");
if (crc32("uHpuyjIJ",8) == 3953355851) strcat(s, "J");
if (crc32("hXAZh",5) == 331110303) strcat(s, "r");
if (crc32("NMmRNS",6) == 529389659) strcat(s, "H");
if (crc32("hulHKgOPHDagVle",15) == 2046708463) strcat(s, "m");
    return s;
}

char *fireless_adjectives() {
    char *s = calloc(9);
    if (crc32("kChahLu",7) == 4013162222) strcat(s, "I");
if (crc32("zueoVn",6) == 600956186) strcat(s, "f");
if (crc32("SVTrQghrRzPQ",12) == 149259973) strcat(s, "v");
if (crc32("hAXmf",5) == 1524980294) strcat(s, "i");
if (crc32("SvEXwIvYBoaxGR",14) == 4202487032) strcat(s, "r");
if (crc32("gdZyM",5) == 2635816819) strcat(s, "Y");
if (crc32("dxNTU",5) == 3150525186) strcat(s, "e");
if (crc32("QOuOnqJEs",9) == 4283255786) strcat(s, "l");
if (crc32("UsWcftRCfRv",11) == 4182865099) strcat(s, "e");
if (crc32("znEXQcPiYJQjb",13) == 3833136978) strcat(s, "s");
if (crc32("ACuGJnCzhYsMH",13) == 4263944656) strcat(s, "s");
    return s;
}

char *nonsyllogistical_adjectives() {
    char *s = calloc(17);
    if (crc32("cuYVuy",6) == 661615254) strcat(s, "b");
if (crc32("ZrtrxKOOdekW",12) == 3194655394) strcat(s, "n");
if (crc32("JQSrrGjoMikK",12) == 2142042869) strcat(s, "w");
if (crc32("ZzMFpkNZb",9) == 1277241979) strcat(s, "o");
if (crc32("fIUADfXNoj",10) == 260401089) strcat(s, "Y");
if (crc32("WwkHdt",6) == 804000463) strcat(s, "n");
if (crc32("QeUGD",5) == 1371847391) strcat(s, "O");
if (crc32("mdUycPkTsOSymS",14) == 3762597531) strcat(s, "s");
if (crc32("hkZcgoYVaePQHGQ",15) == 2148940635) strcat(s, "k");
if (crc32("cTmSHfpKwOERIi",14) == 3984513784) strcat(s, "y");
if (crc32("QemJWNiFV",9) == 3445373779) strcat(s, "l");
if (crc32("RsPvSIxddswyKH",14) == 4043803904) strcat(s, "l");
if (crc32("ZqexhaUHMWdF",12) == 1781322632) strcat(s, "o");
if (crc32("FMuxQy",6) == 2388643730) strcat(s, "q");
if (crc32("TdyrDCWpOTFUZ",13) == 4116025304) strcat(s, "g");
if (crc32("ERhSlRkz",8) == 3838497722) strcat(s, "j");
if (crc32("yRgAZCuiwYxr",12) == 2861987570) strcat(s, "i");
if (crc32("jBJfYqbG",8) == 1731306431) strcat(s, "x");
if (crc32("CxVDcWg",7) == 3227942950) strcat(s, "s");
if (crc32("KuOojOEsLHS",11) == 226352612) strcat(s, "t");
if (crc32("roUuBFaOiXM",11) == 1642667911) strcat(s, "i");
if (crc32("RiNbEWn",7) == 4135339635) strcat(s, "Z");
if (crc32("QbbuZbnoISByhkI",15) == 762128520) strcat(s, "c");
if (crc32("byKnVbVQMXpkzzf",15) == 3342570617) strcat(s, "a");
if (crc32("CDVYLZSGJnl",11) == 1843673990) strcat(s, "l");
    return s;
}

char *unbroadcast_adjectives() {
    char *s = calloc(12);
    if (crc32("zdEmvj",6) == 1326381251) strcat(s, "u");
if (crc32("BBCxKMLpkBm",11) == 109014681) strcat(s, "L");
if (crc32("ahcEXphqz",9) == 3904412027) strcat(s, "n");
if (crc32("NYkiIfIq",8) == 3253223402) strcat(s, "h");
if (crc32("DJkqLDTebe",10) == 1299191829) strcat(s, "b");
if (crc32("nUjcvQNbQDROSP",14) == 514333658) strcat(s, "M");
if (crc32("kZgrgyUPfC",10) == 554075342) strcat(s, "r");
if (crc32("pFoOLejfjVxgjY",14) == 1950164282) strcat(s, "J");
if (crc32("tzJFuWV",7) == 2785466113) strcat(s, "o");
if (crc32("uaJpxcgPcGn",11) == 2171506085) strcat(s, "n");
if (crc32("iDLBrHIkRbBxyaO",15) == 672992708) strcat(s, "a");
if (crc32("EFWrvWmLjAiHDFE",15) == 2607442666) strcat(s, "M");
if (crc32("DqtZyAMKsbR",11) == 2830084337) strcat(s, "d");
if (crc32("pDfTsDcFYN",10) == 2956281141) strcat(s, "d");
if (crc32("bSEaZlUoCnTw",12) == 2044988335) strcat(s, "c");
if (crc32("ekrJwmsJMX",10) == 1461282190) strcat(s, "a");
if (crc32("NQvCifVhggGp",12) == 1476183472) strcat(s, "s");
if (crc32("ForVn",5) == 1665840914) strcat(s, "t");
    return s;
}

char *unextravagant_adjectives() {
    char *s = calloc(14);
    if (crc32("ThFCAVyAnNsxN",13) == 3172066846) strcat(s, "I");
if (crc32("miDDYfpQyLYEiH",14) == 3368446416) strcat(s, "u");
if (crc32("yaicfvhfepxVcH",14) == 1196199754) strcat(s, "x");
if (crc32("POXHThBLlPaGZ",13) == 1727754917) strcat(s, "n");
if (crc32("RMBSzjLVvLCwI",13) == 405216635) strcat(s, "h");
if (crc32("HecBEPhBU",9) == 655502478) strcat(s, "e");
if (crc32("hQIllmftbOYc",12) == 3736244660) strcat(s, "x");
if (crc32("UqKDMtDhdwSo",12) == 1003549489) strcat(s, "t");
if (crc32("yLScuX",6) == 1453456484) strcat(s, "n");
if (crc32("zoOqd",5) == 288935725) strcat(s, "r");
if (crc32("kJfShxYjDJW",11) == 3548400325) strcat(s, "a");
if (crc32("CxKCowAG",8) == 2573796501) strcat(s, "V");
if (crc32("FCcCiltebkMMEhT",15) == 599546035) strcat(s, "v");
if (crc32("ufgIXreztO",10) == 1280275709) strcat(s, "a");
if (crc32("kwhAimKfLU",10) == 3586271148) strcat(s, "v");
if (crc32("DnkuVd",6) == 455779807) strcat(s, "g");
if (crc32("WWjyHhKNG",9) == 2707925834) strcat(s, "Y");
if (crc32("IBYgzDZTIC",10) == 1939384569) strcat(s, "a");
if (crc32("lbQhpizCzeVwe",13) == 1351272841) strcat(s, "n");
if (crc32("PwAgetUOAbrdG",13) == 3102158448) strcat(s, "W");
if (crc32("TasUUIWMj",9) == 3281592628) strcat(s, "t");
    return s;
}

char *climant_adjectives() {
    char *s = calloc(8);
    if (crc32("JTNCMKqTFTborP",14) == 2314755872) strcat(s, "u");
if (crc32("bGDoytljQBFGxMt",15) == 3779271739) strcat(s, "c");
if (crc32("WCHDPrpgEBGLPg",14) == 760016133) strcat(s, "l");
if (crc32("CUAYHRbiwtMi",12) == 3519898380) strcat(s, "i");
if (crc32("RrVkKkZpayIDo",13) == 3458750544) strcat(s, "m");
if (crc32("aQXuThP",7) == 2382864878) strcat(s, "a");
if (crc32("cgraI",5) == 2597464790) strcat(s, "n");
if (crc32("PlkEAahMWf",10) == 3436589832) strcat(s, "t");
    return s;
}

char *nonbulbiferous_adjectives() {
    char *s = calloc(15);
    if (crc32("eMwnijATIC",10) == 1580887552) strcat(s, "r");
if (crc32("DLoaLUVlchHXNg",14) == 2685957353) strcat(s, "n");
if (crc32("dqtwHUl",7) == 621866972) strcat(s, "o");
if (crc32("EHSsqxzf",8) == 580541478) strcat(s, "Z");
if (crc32("BgsJyo",6) == 4281800843) strcat(s, "n");
if (crc32("IseugiEjAF",10) == 1892990105) strcat(s, "b");
if (crc32("NLrcIeRdyoyUUe",14) == 3303940026) strcat(s, "l");
if (crc32("rmmyLJ",6) == 3458427411) strcat(s, "u");
if (crc32("SAlfJKPGHnyKe",13) == 184227510) strcat(s, "Q");
if (crc32("CQtgsUXbr",9) == 1552027740) strcat(s, "l");
if (crc32("pSsgHHJvHBbr",12) == 107706891) strcat(s, "Y");
if (crc32("MSPnJeqYRzJfR",13) == 907500310) strcat(s, "b");
if (crc32("eAQrjpI",7) == 2271008722) strcat(s, "p");
if (crc32("YOyxqSPHaL",10) == 3271422509) strcat(s, "i");
if (crc32("kCTDHfPwSsOyhxg",15) == 3385427852) strcat(s, "f");
if (crc32("uckjMx",6) == 2261894910) strcat(s, "e");
if (crc32("Vymacj",6) == 2044514502) strcat(s, "J");
if (crc32("pxUEkJWEmLzN",12) == 3361480788) strcat(s, "r");
if (crc32("fASHLHwJtQg",11) == 4014763530) strcat(s, "o");
if (crc32("SfIOsnVnfg",10) == 1015839632) strcat(s, "o");
if (crc32("mpjRSaFWzJXX",12) == 1651248025) strcat(s, "u");
if (crc32("xaryPvxxRllNTl",14) == 2160780014) strcat(s, "s");
    return s;
}

char *uncomportable_adjectives() {
    char *s = calloc(14);
    if (crc32("dBCxyk",6) == 4148843410) strcat(s, "u");
if (crc32("yiVekZGszB",10) == 1580681062) strcat(s, "n");
if (crc32("MNxNsSFeokKSh",13) == 2619839698) strcat(s, "L");
if (crc32("diSlWLvT",8) == 3276574761) strcat(s, "c");
if (crc32("aVVmFWlhRAhK",12) == 3830589547) strcat(s, "N");
if (crc32("qgfglNXwwGOpaYN",15) == 4280057773) strcat(s, "o");
if (crc32("BrSYYNGwpmItR",13) == 872114980) strcat(s, "I");
if (crc32("PuAmzYmQ",8) == 2149750873) strcat(s, "m");
if (crc32("bVNnJfLWOYHB",12) == 1776519732) strcat(s, "w");
if (crc32("UTZajlCdLo",10) == 3359491008) strcat(s, "p");
if (crc32("ZCWAQslyPgO",11) == 2510094788) strcat(s, "o");
if (crc32("rnpNhRYkYYApCdJ",15) == 793497947) strcat(s, "r");
if (crc32("NRXAGpBLLugd",12) == 306644851) strcat(s, "t");
if (crc32("CtbXNbItCHnr",12) == 3626850327) strcat(s, "a");
if (crc32("YNrpHYojmIyEdy",14) == 4125650406) strcat(s, "b");
if (crc32("OcHDFdJSrD",10) == 2462728243) strcat(s, "C");
if (crc32("icEtoBCxtaPuAqh",15) == 4000092838) strcat(s, "l");
if (crc32("DlbcStE",7) == 3619448574) strcat(s, "h");
if (crc32("hXdtMadFaxFlaH",14) == 4201012263) strcat(s, "e");
    return s;
}

char *Memphite_adjectives() {
    char *s = calloc(9);
    if (crc32("WDXUVqACkO",10) == 3170465144) strcat(s, "k");
if (crc32("eENcqbbNu",9) == 1536123293) strcat(s, "M");
if (crc32("AiSCMxhnfGer",12) == 2151504120) strcat(s, "e");
if (crc32("dlBNVhpF",8) == 3236187459) strcat(s, "e");
if (crc32("NIkhRMLTbHqsoWt",15) == 3787696065) strcat(s, "K");
if (crc32("QgWScqIwv",9) == 2653160010) strcat(s, "m");
if (crc32("dJsmwyRAHZE",11) == 3318752565) strcat(s, "i");
if (crc32("IccyKG",6) == 3464609365) strcat(s, "p");
if (crc32("ZqDXO",5) == 3408962767) strcat(s, "J");
if (crc32("jjzkCyiBc",9) == 483586910) strcat(s, "h");
if (crc32("AYbgKGP",7) == 3104766220) strcat(s, "i");
if (crc32("YKBbdb",6) == 1539455828) strcat(s, "E");
if (crc32("rXaHg",5) == 3924488990) strcat(s, "t");
if (crc32("GUjGVvMVF",9) == 1010505775) strcat(s, "m");
if (crc32("ZcwTfboSCeBg",12) == 85774752) strcat(s, "e");
    return s;
}

char *bridlewise_adjectives() {
    char *s = calloc(11);
    if (crc32("OyuAJDxfF",9) == 3735480936) strcat(s, "b");
if (crc32("AKdJXyCQBsixV",13) == 4143857961) strcat(s, "r");
if (crc32("LHNgMmBc",8) == 2809702788) strcat(s, "v");
if (crc32("tYDfjqKRWbKXci",14) == 1623101488) strcat(s, "i");
if (crc32("ZssNNepmblDyG",13) == 126570523) strcat(s, "C");
if (crc32("ykRLsGQABiIF",12) == 4255763919) strcat(s, "d");
if (crc32("IXKAytvKP",9) == 2834749286) strcat(s, "l");
if (crc32("AzdLrL",6) == 3282887830) strcat(s, "b");
if (crc32("nEseU",5) == 433486510) strcat(s, "e");
if (crc32("RZTupsqGP",9) == 4216317434) strcat(s, "P");
if (crc32("ssUwrgqocWb",11) == 1515145569) strcat(s, "w");
if (crc32("eJCIDvmGz",9) == 3117687418) strcat(s, "i");
if (crc32("arNsUkfLc",9) == 35639599) strcat(s, "s");
if (crc32("PeNNTaApOo",10) == 3630285673) strcat(s, "u");
if (crc32("rBpxsRUriH",10) == 981377192) strcat(s, "e");
    return s;
}

char *effectible_adjectives() {
    char *s = calloc(11);
    if (crc32("RDeusR",6) == 2640625623) strcat(s, "L");
if (crc32("wDLVK",5) == 3989377734) strcat(s, "e");
if (crc32("cEUBn",5) == 1434959136) strcat(s, "N");
if (crc32("aCXmq",5) == 2117039483) strcat(s, "f");
if (crc32("PAHkWFkUW",9) == 649465489) strcat(s, "f");
if (crc32("RUTUgcMwRDOpt",13) == 1435057428) strcat(s, "e");
if (crc32("zkxCyv",6) == 1851089924) strcat(s, "c");
if (crc32("rebwyAEEureTkY",14) == 1172506744) strcat(s, "t");
if (crc32("kLHZmqnOLg",10) == 397924291) strcat(s, "y");
if (crc32("rEuUKUtfeAp",11) == 3984833958) strcat(s, "i");
if (crc32("XqXMgtRGBvOT",12) == 3892999950) strcat(s, "b");
if (crc32("BjCECHhomjRH",12) == 3031542916) strcat(s, "O");
if (crc32("AhImVccDjSbXd",13) == 3225591717) strcat(s, "l");
if (crc32("mCkZt",5) == 3378504563) strcat(s, "S");
if (crc32("ZlUPk",5) == 3487392019) strcat(s, "e");
    return s;
}

char *unprofound_adjectives() {
    char *s = calloc(11);
    if (crc32("MIjkKcla",8) == 3034418623) strcat(s, "u");
if (crc32("OsfDC",5) == 2549414771) strcat(s, "P");
if (crc32("qqEUZZsFABTgm",13) == 776230462) strcat(s, "n");
if (crc32("KJXhWLMJaJ",10) == 2195849424) strcat(s, "p");
if (crc32("IfvgVMWmx",9) == 4054473880) strcat(s, "l");
if (crc32("MMsPvgEVe",9) == 3712556920) strcat(s, "r");
if (crc32("yeyVkLuYXApfKI",14) == 1380732702) strcat(s, "o");
if (crc32("cABiGFVw",8) == 1608267548) strcat(s, "f");
if (crc32("hhYHHrFpRKKJwO",14) == 3839790273) strcat(s, "E");
if (crc32("NJwXMHbuWlPYN",13) == 277874216) strcat(s, "o");
if (crc32("PdJLNBDk",8) == 983407722) strcat(s, "u");
if (crc32("VXWBmntmc",9) == 1365408553) strcat(s, "U");
if (crc32("uvEnZrFFIv",10) == 3054840108) strcat(s, "n");
if (crc32("avPoNpx",7) == 1510327014) strcat(s, "J");
if (crc32("CDcKpEcS",8) == 1928038460) strcat(s, "d");
    return s;
}

char *palaeobiological_adjectives() {
    char *s = calloc(17);
    if (crc32("PpPISXsPGGrSYAa",15) == 3105081274) strcat(s, "p");
if (crc32("XyiOyM",6) == 1856316513) strcat(s, "a");
if (crc32("KOTSsGIX",8) == 57557509) strcat(s, "l");
if (crc32("WeTjbkEVxbo",11) == 3004330848) strcat(s, "a");
if (crc32("qSOAEpbXYkVH",12) == 622172888) strcat(s, "e");
if (crc32("jFAhPCSQ",8) == 1522505170) strcat(s, "o");
if (crc32("ZJGJwVmcaSzF",12) == 1807274088) strcat(s, "B");
if (crc32("FfKWCDe",7) == 3337748854) strcat(s, "b");
if (crc32("xbpWDjoGUHy",11) == 716239517) strcat(s, "i");
if (crc32("TXsOA",5) == 102684551) strcat(s, "s");
if (crc32("JSrBaCCYGUEwZ",13) == 3334144087) strcat(s, "o");
if (crc32("YJSMZBAi",8) == 265897154) strcat(s, "J");
if (crc32("EXBTScIyXlxfOTV",15) == 1560912084) strcat(s, "l");
if (crc32("CjdPqa",6) == 1072029968) strcat(s, "o");
if (crc32("pvQeXQuLqjyQ",12) == 2703487879) strcat(s, "F");
if (crc32("EYjgpitMj",9) == 115783558) strcat(s, "g");
if (crc32("LxILwvN",7) == 2155213373) strcat(s, "M");
if (crc32("iHctktun",8) == 416093566) strcat(s, "i");
if (crc32("XjNmSUqXCUSiGT",14) == 2647557340) strcat(s, "c");
if (crc32("DfgwUhASHS",10) == 3671244735) strcat(s, "a");
if (crc32("uzJXGwhVKuwJSc",14) == 373240749) strcat(s, "l");
    return s;
}

char *diploic_adjectives() {
    char *s = calloc(8);
    if (crc32("FgPzXT",6) == 4005332764) strcat(s, "c");
if (crc32("cvnaEaqTA",9) == 1750038257) strcat(s, "d");
if (crc32("srqYjPjErzRY",12) == 1040986898) strcat(s, "p");
if (crc32("klfNQCpK",8) == 1384641994) strcat(s, "i");
if (crc32("Ygtvr",5) == 3242630129) strcat(s, "p");
if (crc32("gjIwABl",7) == 1003086434) strcat(s, "b");
if (crc32("uPjyAOngUB",10) == 1857784894) strcat(s, "l");
if (crc32("zlfxFTEpYFG",11) == 3369630427) strcat(s, "t");
if (crc32("UlqWoCqnOTSKS",13) == 522034337) strcat(s, "o");
if (crc32("YltAuz",6) == 109271938) strcat(s, "i");
if (crc32("EHUcJwfuo",9) == 1347268223) strcat(s, "i");
if (crc32("IXzrk",5) == 58172490) strcat(s, "c");
    return s;
}

char *methylidyne_adjectives() {
    char *s = calloc(12);
    if (crc32("irQIOGHwqrAfd",13) == 3689449835) strcat(s, "m");
if (crc32("AFLjy",5) == 3531980564) strcat(s, "e");
if (crc32("NoYMKBnMCy",10) == 484796679) strcat(s, "T");
if (crc32("DdoppuTVX",9) == 14535728) strcat(s, "t");
if (crc32("NcnVWaJAovje",12) == 2371247799) strcat(s, "h");
if (crc32("ikjokWSJnPKU",12) == 3030882070) strcat(s, "y");
if (crc32("RLNdpmtgzvh",11) == 643808529) strcat(s, "d");
if (crc32("eWCsciiEsvgWDw",14) == 4040450699) strcat(s, "l");
if (crc32("bvWpBGlLKVWy",12) == 4066806167) strcat(s, "i");
if (crc32("HAFGuQyxXTpLZBv",15) == 1763265290) strcat(s, "o");
if (crc32("tnZkGFCqTpIxKQ",14) == 2464496510) strcat(s, "d");
if (crc32("ibvVMVPIt",9) == 2369696583) strcat(s, "U");
if (crc32("pErjDbm",7) == 3930259870) strcat(s, "y");
if (crc32("GEibLNnB",8) == 1412044070) strcat(s, "n");
if (crc32("IGPYeWnwvHA",11) == 4080503081) strcat(s, "e");
    return s;
}

char *lecithoid_adjectives() {
    char *s = calloc(10);
    if (crc32("HhUvxZXo",8) == 1830617112) strcat(s, "l");
if (crc32("uDjnTHOgr",9) == 2425363958) strcat(s, "e");
if (crc32("kPibYK",6) == 1827162163) strcat(s, "c");
if (crc32("ZYDPjxI",7) == 260635120) strcat(s, "P");
if (crc32("HOfChfq",7) == 3644079860) strcat(s, "i");
if (crc32("gQWhLsNS",8) == 2576008002) strcat(s, "t");
if (crc32("vbZVNnfeTFQQb",13) == 2134760415) strcat(s, "l");
if (crc32("dcHAgZfXyTB",11) == 3620577056) strcat(s, "h");
if (crc32("RncrVobqHF",10) == 1307514206) strcat(s, "o");
if (crc32("HJjVZ",5) == 2014793730) strcat(s, "i");
if (crc32("LkmCwWHT",8) == 4062567993) strcat(s, "d");
    return s;
}

char *apophyseal_adjectives() {
    char *s = calloc(11);
    if (crc32("UNDuKCMneVd",11) == 3651873207) strcat(s, "a");
if (crc32("KaVUoUYEcWpLr",13) == 1615582245) strcat(s, "p");
if (crc32("OKsPSzz",7) == 2777219973) strcat(s, "d");
if (crc32("xitRyuqPdFjbcHB",15) == 3217551605) strcat(s, "o");
if (crc32("ZFWMbxpQiRoSw",13) == 2402076383) strcat(s, "h");
if (crc32("lUtXYHDHIOtyV",13) == 360881225) strcat(s, "p");
if (crc32("pdXGcBwrdmD",11) == 994915783) strcat(s, "h");
if (crc32("wncZSzkFHLJ",11) == 40432599) strcat(s, "h");
if (crc32("xBmdDXRbJKsSow",14) == 1825167861) strcat(s, "y");
if (crc32("EEyLNbUSnZaWU",13) == 1556743565) strcat(s, "s");
if (crc32("VQannTKfy",9) == 2614118245) strcat(s, "k");
if (crc32("SGkLzuGDxDkdjhY",15) == 1088560980) strcat(s, "e");
if (crc32("lTBAV",5) == 2694189462) strcat(s, "X");
if (crc32("oNBmJFMiffeu",12) == 1088299365) strcat(s, "a");
if (crc32("siYSatrAkNA",11) == 3375877664) strcat(s, "B");
if (crc32("XjqFcNQekoX",11) == 583357321) strcat(s, "l");
    return s;
}

char *preboding_adjectives() {
    char *s = calloc(10);
    if (crc32("hKEdgJz",7) == 2468573750) strcat(s, "p");
if (crc32("QgFILclchWQH",12) == 3384774378) strcat(s, "L");
if (crc32("XIBJdSjVRcmoepO",15) == 688819431) strcat(s, "r");
if (crc32("TjKYcTbmt",9) == 3011832562) strcat(s, "e");
if (crc32("VQXhQoKHRXkm",12) == 2638131567) strcat(s, "v");
if (crc32("wQwmLLslnS",10) == 167776768) strcat(s, "b");
if (crc32("pVMGHGQ",7) == 3501095963) strcat(s, "o");
if (crc32("Kpwym",5) == 511614806) strcat(s, "d");
if (crc32("RwWKTbRyCkWcb",13) == 3025067530) strcat(s, "u");
if (crc32("HZzMANCvAmBqDo",14) == 2218616338) strcat(s, "i");
if (crc32("PbwqKjH",7) == 4163783440) strcat(s, "n");
if (crc32("mZHyQsGzuCN",11) == 1995166929) strcat(s, "g");
    return s;
}

char *prediplomatic_adjectives() {
    char *s = calloc(14);
    if (crc32("lwFSwQTfIXl",11) == 2530662095) strcat(s, "P");
if (crc32("bCGfpXseaY",10) == 1077873942) strcat(s, "p");
if (crc32("wXXfBVUJpxqFsrC",15) == 2771644029) strcat(s, "r");
if (crc32("fqgGJoikUbddrm",14) == 2677943624) strcat(s, "R");
if (crc32("czrEjcFiWONJAZ",14) == 856137396) strcat(s, "e");
if (crc32("VYHnWH",6) == 3473044282) strcat(s, "d");
if (crc32("EPxoSqPHYTdOtXS",15) == 2651321420) strcat(s, "i");
if (crc32("mVHAEVJ",7) == 3930597398) strcat(s, "p");
if (crc32("MDxfNt",6) == 4100245029) strcat(s, "e");
if (crc32("lXbnnXTfBeZ",11) == 618555988) strcat(s, "l");
if (crc32("ERsieFZOA",9) == 1736448535) strcat(s, "D");
if (crc32("DMIdbnzUnpyKT",13) == 1673313287) strcat(s, "o");
if (crc32("whwdAK",6) == 3221077459) strcat(s, "m");
if (crc32("ZyLvMfIb",8) == 2035297764) strcat(s, "A");
if (crc32("bYIIypJc",8) == 2701043068) strcat(s, "a");
if (crc32("PikmoyglIYCWpIh",15) == 1690381394) strcat(s, "B");
if (crc32("GIFaVpzPwQeC",12) == 3419784470) strcat(s, "t");
if (crc32("buwjzjQDFwhRh",13) == 1882734393) strcat(s, "h");
if (crc32("rlJGPlxPGX",10) == 3663982285) strcat(s, "i");
if (crc32("BifxgHKoKajIXyk",15) == 41242514) strcat(s, "f");
if (crc32("jyFQjeHQYl",10) == 4144073490) strcat(s, "c");
    return s;
}

char *submetallic_adjectives() {
    char *s = calloc(12);
    if (crc32("nHWHjZEXvljLeD",14) == 1245631852) strcat(s, "p");
if (crc32("PJdUCO",6) == 1275798900) strcat(s, "s");
if (crc32("QGmBdPWtbsISfF",14) == 2712828184) strcat(s, "u");
if (crc32("BDaNBcrM",8) == 2315873723) strcat(s, "h");
if (crc32("ibxUgFjbiWeNBY",14) == 1984776841) strcat(s, "b");
if (crc32("OxkCdFOPvrPIWd",14) == 4273759839) strcat(s, "Q");
if (crc32("HyynQljVAcudEc",14) == 2563273643) strcat(s, "m");
if (crc32("uAKtJv",6) == 597893150) strcat(s, "e");
if (crc32("xdAfwRyaq",9) == 4012964557) strcat(s, "t");
if (crc32("BcWnhREMujrfPis",15) == 437013410) strcat(s, "a");
if (crc32("dTJAIxNIebjE",12) == 2407303024) strcat(s, "l");
if (crc32("UjECFGDsiZCM",12) == 3876864567) strcat(s, "T");
if (crc32("EmWsh",5) == 2985686160) strcat(s, "l");
if (crc32("jVALQp",6) == 108257569) strcat(s, "i");
if (crc32("zzYgKGaIGvbtuY",14) == 1189699543) strcat(s, "c");
    return s;
}

char *nondesigned_adjectives() {
    char *s = calloc(12);
    if (crc32("frSZWlMEWIaY",12) == 3628806705) strcat(s, "n");
if (crc32("wqJnqIYCYKmNzFC",15) == 3069375986) strcat(s, "I");
if (crc32("vnWNNlFf",8) == 438869765) strcat(s, "o");
if (crc32("fzMwEgkpPwKxZiN",15) == 861168689) strcat(s, "n");
if (crc32("dZEsLyXV",8) == 759779798) strcat(s, "d");
if (crc32("zceGuunQswnTQep",15) == 2211877524) strcat(s, "a");
if (crc32("IMBbffrSPHn",11) == 1562097480) strcat(s, "e");
if (crc32("FdTVRMPcElBiO",13) == 3322767206) strcat(s, "s");
if (crc32("cQjqVyJnGVY",11) == 1942093324) strcat(s, "i");
if (crc32("IfKfv",5) == 2072125427) strcat(s, "g");
if (crc32("UVstnTHHGOyMqq",14) == 485658053) strcat(s, "n");
if (crc32("OvRfVNqMg",9) == 3699907366) strcat(s, "x");
if (crc32("XNZSVjCEEizk",12) == 1633256539) strcat(s, "e");
if (crc32("FcrsPSdkw",9) == 1608665622) strcat(s, "o");
if (crc32("fSIBYLnw",8) == 2439332808) strcat(s, "d");
    return s;
}

char *gablelike_adjectives() {
    char *s = calloc(10);
    if (crc32("tdEoqCqHT",9) == 1171292590) strcat(s, "U");
if (crc32("ZyzneqvnGL",10) == 2808163100) strcat(s, "g");
if (crc32("RhXgFVySS",9) == 2478050682) strcat(s, "X");
if (crc32("kUvrogAQag",10) == 3503688141) strcat(s, "a");
if (crc32("ImTRTxwGEKr",11) == 391812664) strcat(s, "y");
if (crc32("pyUeLSqeJ",9) == 325723446) strcat(s, "b");
if (crc32("jBaxsA",6) == 3861869579) strcat(s, "l");
if (crc32("LYCaXnCrFsCOp",13) == 3243788) strcat(s, "Q");
if (crc32("lWzFUQjAdmJaOH",14) == 708070338) strcat(s, "e");
if (crc32("iCSaNMUsnZL",11) == 1336150155) strcat(s, "g");
if (crc32("OuVbRh",6) == 271576873) strcat(s, "l");
if (crc32("saXfEA",6) == 1290648932) strcat(s, "p");
if (crc32("kstjup",6) == 3469951383) strcat(s, "i");
if (crc32("eNLCLc",6) == 3169683191) strcat(s, "M");
if (crc32("IhBUbTJugDzUqPI",15) == 3481105240) strcat(s, "k");
if (crc32("KlUUYscX",8) == 2028846445) strcat(s, "D");
if (crc32("WgAICSriDDlqISa",15) == 2505488316) strcat(s, "e");
    return s;
}

char *hemoglobic_adjectives() {
    char *s = calloc(11);
    if (crc32("ZGZlW",5) == 3676329114) strcat(s, "V");
if (crc32("UxhsH",5) == 2727036634) strcat(s, "h");
if (crc32("hJWPeB",6) == 1929730231) strcat(s, "K");
if (crc32("eGQgihl",7) == 1528533850) strcat(s, "e");
if (crc32("KRNZshKTYqIyu",13) == 738676273) strcat(s, "x");
if (crc32("ojTuWumEWZ",10) == 2230811261) strcat(s, "m");
if (crc32("opQPVlet",8) == 2668224817) strcat(s, "o");
if (crc32("BNjFHGCMCdlNYKE",15) == 650995867) strcat(s, "g");
if (crc32("KfLNrZsxDuW",11) == 2357370723) strcat(s, "w");
if (crc32("NOUZJ",5) == 1589422165) strcat(s, "l");
if (crc32("NQoRCOHWkhFhrgM",15) == 2562548385) strcat(s, "o");
if (crc32("ycYlHRErRgBhMmD",15) == 4222000117) strcat(s, "b");
if (crc32("yZqmLc",6) == 4105668001) strcat(s, "i");
if (crc32("XCwDrSxrJyuZmdy",15) == 3035392517) strcat(s, "h");
if (crc32("qCNhjmnQxsawrd",14) == 1644307191) strcat(s, "c");
    return s;
}

char *charterless_adjectives() {
    char *s = calloc(12);
    if (crc32("xkFSnFHCZfwcq",13) == 191128996) strcat(s, "c");
if (crc32("zZWacaUyBDYPq",13) == 3670868859) strcat(s, "h");
if (crc32("OorlfICFokcPR",13) == 2577761440) strcat(s, "c");
if (crc32("gHkLzYsdYQMRs",13) == 2744667962) strcat(s, "a");
if (crc32("dFxCXmaoC",9) == 3686106211) strcat(s, "r");
if (crc32("rtefVzkBC",9) == 1606115292) strcat(s, "A");
if (crc32("TgmUJd",6) == 4005396820) strcat(s, "t");
if (crc32("NUQlNSEKUFb",11) == 2133415452) strcat(s, "e");
if (crc32("AHBEvVefzp",10) == 627883757) strcat(s, "r");
if (crc32("HOAIJURcf",9) == 3178705568) strcat(s, "k");
if (crc32("DYYjpay",7) == 1728026328) strcat(s, "l");
if (crc32("KPYlSCoFO",9) == 3544867744) strcat(s, "e");
if (crc32("DYVRuQH",7) == 1499669861) strcat(s, "s");
if (crc32("DNNAEB",6) == 3058139553) strcat(s, "t");
if (crc32("yeaFKXdl",8) == 1887921250) strcat(s, "s");
    return s;
}

char *honest_adjectives() {
    char *s = calloc(7);
    if (crc32("YCPKkGkjMThtw",13) == 3858536810) strcat(s, "F");
if (crc32("Oyvtfi",6) == 2708189621) strcat(s, "h");
if (crc32("RmJolnQjuJ",10) == 2640363480) strcat(s, "o");
if (crc32("jRoay",5) == 3372601484) strcat(s, "W");
if (crc32("wYRTrYb",7) == 103692013) strcat(s, "n");
if (crc32("dEPej",5) == 2284042820) strcat(s, "r");
if (crc32("pUCpr",5) == 550220349) strcat(s, "e");
if (crc32("kIUhSqUvYkhQzzK",15) == 3716635532) strcat(s, "o");
if (crc32("oFrXz",5) == 4143506208) strcat(s, "s");
if (crc32("YgumZMSFJ",9) == 872810268) strcat(s, "E");
if (crc32("bUZmx",5) == 916810530) strcat(s, "t");
    return s;
}

char *epexegetic_adjectives() {
    char *s = calloc(11);
    if (crc32("SWgOJxzHVvDZQ",13) == 600141708) strcat(s, "E");
if (crc32("BKfGzGebyQANI",13) == 451274915) strcat(s, "e");
if (crc32("UlHFbuzSy",9) == 2306286520) strcat(s, "c");
if (crc32("wYezoA",6) == 617012665) strcat(s, "p");
if (crc32("LQtDMn",6) == 943502450) strcat(s, "D");
if (crc32("qMqAH",5) == 2948074243) strcat(s, "e");
if (crc32("UZacaSMnhJgJ",12) == 3125132665) strcat(s, "x");
if (crc32("nAUtggJ",7) == 816797459) strcat(s, "x");
if (crc32("RmyENpYuNfKGcWk",15) == 2433625495) strcat(s, "e");
if (crc32("QaDIp",5) == 1189486956) strcat(s, "g");
if (crc32("lxnPRTtp",8) == 652990907) strcat(s, "e");
if (crc32("vdOiBocdpb",10) == 1980378800) strcat(s, "Q");
if (crc32("YkkMlh",6) == 1793400208) strcat(s, "t");
if (crc32("bEXsc",5) == 991698656) strcat(s, "i");
if (crc32("XgCOkvWrecM",11) == 4171819481) strcat(s, "m");
if (crc32("zXDJhyTX",8) == 3503763670) strcat(s, "c");
    return s;
}

char *wellcarved_adjectives() {
    char *s = calloc(11);
    if (crc32("naPGpg",6) == 1700759710) strcat(s, "w");
if (crc32("kAoRCpTZV",9) == 3289525857) strcat(s, "K");
if (crc32("fbdNImRIxGvLG",13) == 2346634081) strcat(s, "e");
if (crc32("MAsneYvjwT",10) == 3525814992) strcat(s, "l");
if (crc32("IiCNx",5) == 2534923696) strcat(s, "l");
if (crc32("ucNsgWkFdOlzw",13) == 2898985474) strcat(s, "c");
if (crc32("yOcrWT",6) == 3234262483) strcat(s, "T");
if (crc32("WkvcV",5) == 1016220803) strcat(s, "a");
if (crc32("umgipx",6) == 463024576) strcat(s, "r");
if (crc32("tNCAaXPaBUppohL",15) == 2737155066) strcat(s, "v");
if (crc32("FLSzmRloDFiqqO",14) == 448285528) strcat(s, "e");
if (crc32("GnCZMPsVFDqP",12) == 2423657044) strcat(s, "d");
    return s;
}

char *foraminal_adjectives() {
    char *s = calloc(10);
    if (crc32("uKownb",6) == 2939652948) strcat(s, "f");
if (crc32("YSRaSc",6) == 2295076300) strcat(s, "o");
if (crc32("aTmCHIDVsO",10) == 3837957289) strcat(s, "r");
if (crc32("TtuRgsLuBTDT",12) == 2854907595) strcat(s, "a");
if (crc32("RNavQn",6) == 3440069305) strcat(s, "m");
if (crc32("PaxKOeSyLG",10) == 409208520) strcat(s, "b");
if (crc32("BMmQnlEclxKI",12) == 3297672686) strcat(s, "i");
if (crc32("GnKEgZGfGpJ",11) == 3703870399) strcat(s, "v");
if (crc32("OjaFtxvAy",9) == 1624745833) strcat(s, "n");
if (crc32("kdbuYmyhFM",10) == 1628704229) strcat(s, "M");
if (crc32("QoegJuSXDpMdyK",14) == 659920876) strcat(s, "a");
if (crc32("pBBIFVNOynHW",12) == 2233424468) strcat(s, "v");
if (crc32("fdTixVVMdhRxoQ",14) == 3531689533) strcat(s, "l");
    return s;
}

char *nonvisual_adjectives() {
    char *s = calloc(10);
    if (crc32("aAuJTET",7) == 999243457) strcat(s, "n");
if (crc32("XAOIHoCUA",9) == 3465908315) strcat(s, "z");
if (crc32("aWJTkTkbJSQac",13) == 3722775471) strcat(s, "o");
if (crc32("gVjcbluvH",9) == 2508151094) strcat(s, "R");
if (crc32("adeeg",5) == 1400154982) strcat(s, "n");
if (crc32("LoxtKoPrgilS",12) == 2567523146) strcat(s, "v");
if (crc32("BdxROFigIpQyCJ",14) == 1249358556) strcat(s, "i");
if (crc32("nJzNy",5) == 2907368630) strcat(s, "D");
if (crc32("pxOdOiNZRfLSZ",13) == 1122115697) strcat(s, "s");
if (crc32("xHbJiEKldHMUlnh",15) == 1524746031) strcat(s, "w");
if (crc32("SXtLdgfcvtmkOER",15) == 1346976252) strcat(s, "u");
if (crc32("buUfwR",6) == 3077214906) strcat(s, "h");
if (crc32("dACWzwj",7) == 4217893170) strcat(s, "a");
if (crc32("LZdiu",5) == 606051122) strcat(s, "l");
    return s;
}

char *transAndean_adjectives() {
    char *s = calloc(12);
    if (crc32("QYqFFwVdBWfJo",13) == 3790016796) strcat(s, "t");
if (crc32("EpwgrQ",6) == 2911954213) strcat(s, "r");
if (crc32("tZMtbQNoNItGlT",14) == 1413456614) strcat(s, "a");
if (crc32("WeIUxUNeDlFxd",13) == 1626603369) strcat(s, "D");
if (crc32("oJctm",5) == 455637942) strcat(s, "n");
if (crc32("LILNKu",6) == 77530558) strcat(s, "s");
if (crc32("ajDiyEqsqvxITJ",14) == 3773364633) strcat(s, "A");
if (crc32("BKKXPT",6) == 49548218) strcat(s, "v");
if (crc32("uMxBMdHzFAV",11) == 1789924962) strcat(s, "n");
if (crc32("HPIOFnyZnxHGvsj",15) == 3328056455) strcat(s, "Y");
if (crc32("oZyRFVWG",8) == 1321095526) strcat(s, "d");
if (crc32("nEIOOjrrPKYyU",13) == 1728347184) strcat(s, "F");
if (crc32("gxRgIVfG",8) == 1609414529) strcat(s, "e");
if (crc32("RAdgVvIqY",9) == 2538420922) strcat(s, "a");
if (crc32("mjwrqsf",7) == 2706794128) strcat(s, "n");
    return s;
}

char *horseandbuggy_adjectives() {
    char *s = calloc(14);
    if (crc32("XpGWkbsbz",9) == 2347662204) strcat(s, "v");
if (crc32("AeRoqqTsDGtqNqx",15) == 3687656914) strcat(s, "h");
if (crc32("jRrds",5) == 3899270441) strcat(s, "Y");
if (crc32("VUhstZZE",8) == 516384892) strcat(s, "o");
if (crc32("IlkIWAlXW",9) == 1856347908) strcat(s, "Z");
if (crc32("tPcRamtTm",9) == 910868015) strcat(s, "r");
if (crc32("aAaNhHMOZSLAz",13) == 1816636723) strcat(s, "b");
if (crc32("jhBNXhjL",8) == 2433097620) strcat(s, "s");
if (crc32("Jfctda",6) == 1861293701) strcat(s, "a");
if (crc32("jHPWzLF",7) == 2776479022) strcat(s, "e");
if (crc32("ZrUnGPGSIywAPVQ",15) == 3463060660) strcat(s, "a");
if (crc32("TGHlTniUcG",10) == 909197537) strcat(s, "c");
if (crc32("LHgqoQrMGFGK",12) == 2966862881) strcat(s, "n");
if (crc32("RaKzXgTZPzkn",12) == 1506265582) strcat(s, "h");
if (crc32("FTtFJu",6) == 535020892) strcat(s, "d");
if (crc32("PsQkY",5) == 1400053279) strcat(s, "D");
if (crc32("xTZHI",5) == 493114297) strcat(s, "b");
if (crc32("Mkbjun",6) == 3234549471) strcat(s, "u");
if (crc32("ddcwxIGtDT",10) == 1770618628) strcat(s, "Y");
if (crc32("YwjToh",6) == 1335085898) strcat(s, "g");
if (crc32("bgrEMgHBBZ",10) == 656557315) strcat(s, "W");
if (crc32("UJvnsXqx",8) == 272232143) strcat(s, "g");
if (crc32("mEGMDFjpIGViQf",14) == 3212582191) strcat(s, "K");
if (crc32("nVtYuaKkCrahQut",15) == 491333171) strcat(s, "y");
    return s;
}

char *flyaway_adjectives() {
    char *s = calloc(8);
    if (crc32("nkXGRkN",7) == 2629488382) strcat(s, "s");
if (crc32("LbEdQrHUUHE",11) == 2702850072) strcat(s, "f");
if (crc32("czQnIwxF",8) == 3471147747) strcat(s, "t");
if (crc32("sZvqoqQ",7) == 556484871) strcat(s, "l");
if (crc32("MQwerhRhMTBZQLG",15) == 4236131398) strcat(s, "A");
if (crc32("xAlTe",5) == 2397723784) strcat(s, "y");
if (crc32("AQVjzlFB",8) == 2002567580) strcat(s, "a");
if (crc32("pNTXz",5) == 3980194254) strcat(s, "w");
if (crc32("rnrttjr",7) == 1120240082) strcat(s, "c");
if (crc32("LZRgFqL",7) == 1789463693) strcat(s, "a");
if (crc32("WFkNmdF",7) == 3910638097) strcat(s, "y");
    return s;
}

char *Alleghanian_adjectives() {
    char *s = calloc(12);
    if (crc32("mwOvLNopbNUNn",13) == 3964490882) strcat(s, "A");
if (crc32("QsimeXblzAxDpn",14) == 4053902421) strcat(s, "l");
if (crc32("BWRIEjFi",8) == 2746817639) strcat(s, "O");
if (crc32("BidXUEJ",7) == 1920527593) strcat(s, "l");
if (crc32("kDBUnEdMHDtZz",13) == 3797456059) strcat(s, "e");
if (crc32("XifXzaVxCJoNy",13) == 1912485656) strcat(s, "R");
if (crc32("ZmWhgQsPCqX",11) == 491172433) strcat(s, "g");
if (crc32("MCjczJeQfgRR",12) == 3875832782) strcat(s, "h");
if (crc32("jTCIC",5) == 3984447483) strcat(s, "a");
if (crc32("eXkzQCEdWt",10) == 1095777066) strcat(s, "n");
if (crc32("jhDDQWarVr",10) == 344149021) strcat(s, "i");
if (crc32("DHHLRncngkr",11) == 1833340584) strcat(s, "a");
if (crc32("MldXpRTjpCoyAd",14) == 1195149433) strcat(s, "h");
if (crc32("GhWgMQZV",8) == 48627829) strcat(s, "n");
    return s;
}

char *unclosable_adjectives() {
    char *s = calloc(11);
    if (crc32("WAmlpx",6) == 3015287815) strcat(s, "i");
if (crc32("oFAxvQXuZZ",10) == 457152860) strcat(s, "u");
if (crc32("zPOkFhFu",8) == 360494378) strcat(s, "n");
if (crc32("EAPeZeiH",8) == 2649449126) strcat(s, "c");
if (crc32("zUDtpwDUrc",10) == 3186524190) strcat(s, "h");
if (crc32("PruGg",5) == 30660419) strcat(s, "l");
if (crc32("IaVwipXof",9) == 90020238) strcat(s, "o");
if (crc32("lmEYgDAFCplk",12) == 3691677696) strcat(s, "s");
if (crc32("qUvfp",5) == 3449645069) strcat(s, "a");
if (crc32("uzdukIqcTlDAdlA",15) == 2704273647) strcat(s, "b");
if (crc32("MDIyQmjMvn",10) == 540985030) strcat(s, "h");
if (crc32("Rrrtm",5) == 1793203848) strcat(s, "l");
if (crc32("XcxGRu",6) == 1958895799) strcat(s, "J");
if (crc32("ioyJJmHspt",10) == 2716293579) strcat(s, "e");
    return s;
}

char *epencephalic_adjectives() {
    char *s = calloc(13);
    if (crc32("eNeaWSmWBfABdq",14) == 3981407882) strcat(s, "l");
if (crc32("fHvKkMrIPNZlqDe",15) == 2265670820) strcat(s, "e");
if (crc32("juZvxsqXQYi",11) == 2208137438) strcat(s, "I");
if (crc32("zvpPBSGAwRL",11) == 527734759) strcat(s, "p");
if (crc32("DPofBUdkzK",10) == 2438980415) strcat(s, "e");
if (crc32("idkLuacRaRLAeQm",15) == 1703629732) strcat(s, "R");
if (crc32("odxLSEvRgR",10) == 2857047885) strcat(s, "n");
if (crc32("SEeViGipENUh",12) == 167945919) strcat(s, "f");
if (crc32("TGBqBCShJxJd",12) == 357418149) strcat(s, "c");
if (crc32("yjvKjwWhXx",10) == 3533170616) strcat(s, "e");
if (crc32("DYYXxLwIGGpHOm",14) == 2960515883) strcat(s, "r");
if (crc32("ltGSgtDe",8) == 3412787594) strcat(s, "p");
if (crc32("FgFHUYCIM",9) == 1216607656) strcat(s, "h");
if (crc32("uEYtxoQhe",9) == 3996251665) strcat(s, "H");
if (crc32("HiBaUeFFjzzX",12) == 3222504837) strcat(s, "a");
if (crc32("yADXVOIp",8) == 1291188380) strcat(s, "l");
if (crc32("iFFKkW",6) == 4164698403) strcat(s, "i");
if (crc32("JCaFbzvHSjXohu",14) == 4225613557) strcat(s, "c");
    return s;
}

char *interplacental_adjectives() {
    char *s = calloc(15);
    if (crc32("HKQjOZqUNPmsivt",15) == 2992169639) strcat(s, "i");
if (crc32("wfpHXVfit",9) == 1793158474) strcat(s, "P");
if (crc32("yLouEhedGTaQ",12) == 1693414214) strcat(s, "n");
if (crc32("UWJgNu",6) == 2417404408) strcat(s, "t");
if (crc32("irLSQCgnid",10) == 3204132323) strcat(s, "e");
if (crc32("swkniJaiU",9) == 917063304) strcat(s, "E");
if (crc32("FRfMfMS",7) == 2131931736) strcat(s, "r");
if (crc32("MBrfeO",6) == 1404219230) strcat(s, "p");
if (crc32("unyXUUCdoj",10) == 3785614089) strcat(s, "l");
if (crc32("gktZtNWge",9) == 4021723652) strcat(s, "a");
if (crc32("BamblEDdxPVSqJ",14) == 772313475) strcat(s, "k");
if (crc32("yskpvjVazfSVFc",14) == 3323362029) strcat(s, "c");
if (crc32("cbNognON",8) == 1382642455) strcat(s, "D");
if (crc32("gKRBdXtxWChu",12) == 724839777) strcat(s, "e");
if (crc32("PJCwzXyNPZfFz",13) == 4000544655) strcat(s, "n");
if (crc32("wVELLgEQQ",9) == 1112958229) strcat(s, "K");
if (crc32("fflhXkRfpUL",11) == 1955000537) strcat(s, "t");
if (crc32("rcBmFICnyPjC",12) == 3573351951) strcat(s, "b");
if (crc32("kjsQqelGSkEIGQw",15) == 980129744) strcat(s, "a");
if (crc32("YyqUycMFPTyK",12) == 2891553770) strcat(s, "l");
    return s;
}

char *unprepared_adjectives() {
    char *s = calloc(11);
    if (crc32("oMGahUySjAcBT",13) == 1409822925) strcat(s, "u");
if (crc32("edbscwazcGI",11) == 4219574029) strcat(s, "g");
if (crc32("yXroqlapyCT",11) == 2239984201) strcat(s, "n");
if (crc32("lMnHRqyXGTiXT",13) == 3901956221) strcat(s, "p");
if (crc32("yYvwOFApmHTUpvY",15) == 3502719246) strcat(s, "r");
if (crc32("RkILzeydomoRsu",14) == 67476170) strcat(s, "e");
if (crc32("dCUWRoGqnooli",13) == 1001746010) strcat(s, "p");
if (crc32("RccYVhD",7) == 2071273861) strcat(s, "a");
if (crc32("WtYxmn",6) == 2943591284) strcat(s, "j");
if (crc32("fkFrtlGnPm",10) == 1946360532) strcat(s, "r");
if (crc32("VNNhnbJrPYRId",13) == 1756959629) strcat(s, "j");
if (crc32("XhymdtvZRRxfyq",14) == 332944539) strcat(s, "e");
if (crc32("hkjvaZGnunTaQ",13) == 1512446666) strcat(s, "Q");
if (crc32("XsxJrjPLnukVHtS",15) == 299858375) strcat(s, "d");
    return s;
}

char *transMississippian_adjectives() {
    char *s = calloc(19);
    if (crc32("JnWFJaoMbHSkswJ",15) == 1630587410) strcat(s, "t");
if (crc32("CvZGSGaF",8) == 1350333093) strcat(s, "M");
if (crc32("skvfvjm",7) == 3060653515) strcat(s, "r");
if (crc32("hkwrGPrxQlnhE",13) == 3387579038) strcat(s, "a");
if (crc32("nfViPKZgpIMWUYh",15) == 2591795281) strcat(s, "X");
if (crc32("bBsnMDyD",8) == 510478454) strcat(s, "n");
if (crc32("CLfVssWtiMc",11) == 4104735631) strcat(s, "s");
if (crc32("LkeQXR",6) == 3847043680) strcat(s, "i");
if (crc32("KOowFIg",7) == 1319030584) strcat(s, "M");
if (crc32("EOyylnBwATKPcSB",15) == 2894709423) strcat(s, "i");
if (crc32("JACvimcr",8) == 3348886039) strcat(s, "n");
if (crc32("ZkWkqEWmPKphZ",13) == 3476232627) strcat(s, "s");
if (crc32("VmFGO",5) == 3051133719) strcat(s, "C");
if (crc32("IyjXvYnETOWD",12) == 2571289053) strcat(s, "s");
if (crc32("OJIACfln",8) == 2268112706) strcat(s, "s");
if (crc32("EkDsitsBdasAT",13) == 4140322245) strcat(s, "i");
if (crc32("vFOuNGKogbzz",12) == 272544721) strcat(s, "s");
if (crc32("eFfJjzi",7) == 825855631) strcat(s, "A");
if (crc32("ToUPuoUxhkkxAB",14) == 2251455788) strcat(s, "s");
if (crc32("GFqaL",5) == 3291554207) strcat(s, "i");
if (crc32("YdBmWCNiXvbiI",13) == 1018689371) strcat(s, "p");
if (crc32("zKcyhU",6) == 4040075706) strcat(s, "p");
if (crc32("mvcRUXzVmmN",11) == 3027309378) strcat(s, "i");
if (crc32("RMoAXfyCnl",10) == 2621549157) strcat(s, "A");
if (crc32("wyZggfehB",9) == 490041928) strcat(s, "a");
if (crc32("KxrlbRoeY",9) == 2444757780) strcat(s, "R");
if (crc32("jQpljLGQGAc",11) == 2130642118) strcat(s, "n");
    return s;
}

char *stonier_adjectives() {
    char *s = calloc(8);
    if (crc32("GFwwzXKHV",9) == 4150062616) strcat(s, "s");
if (crc32("YSeRSYSXRwbnH",13) == 3651921741) strcat(s, "t");
if (crc32("maEWKHkX",8) == 126799288) strcat(s, "o");
if (crc32("JpkbQPgdEVINMy",14) == 3787913684) strcat(s, "I");
if (crc32("IBoDc",5) == 2717477741) strcat(s, "n");
if (crc32("PHRmMWESvmwPpg",14) == 4151269963) strcat(s, "G");
if (crc32("zWxEKchzz",9) == 2030108890) strcat(s, "i");
if (crc32("iIMFc",5) == 3200660324) strcat(s, "e");
if (crc32("jkshNwQz",8) == 1542864662) strcat(s, "V");
if (crc32("IrXDgEAaavyV",12) == 1521807929) strcat(s, "r");
    return s;
}

char *stylistic_adjectives() {
    char *s = calloc(10);
    if (crc32("RfyYlwN",7) == 3975461531) strcat(s, "K");
if (crc32("DWgFKtHE",8) == 3443407342) strcat(s, "s");
if (crc32("ozHWzhtxaMJFCy",14) == 201767594) strcat(s, "t");
if (crc32("vvJNwhMXss",10) == 2054692698) strcat(s, "c");
if (crc32("yIgrvDXd",8) == 2419540340) strcat(s, "y");
if (crc32("FVonQxQLhXJ",11) == 3003572648) strcat(s, "l");
if (crc32("VYJwyWCQ",8) == 501954078) strcat(s, "i");
if (crc32("WQiRuVuveDCFyO",14) == 890016865) strcat(s, "B");
if (crc32("HBfXltB",7) == 580863149) strcat(s, "s");
if (crc32("dUCMATUwyZBM",12) == 3025164703) strcat(s, "A");
if (crc32("WtJpDszfJHO",11) == 291482382) strcat(s, "t");
if (crc32("DfPimR",6) == 814156368) strcat(s, "w");
if (crc32("sWndjZObCI",10) == 3588483500) strcat(s, "i");
if (crc32("rfAKEUO",7) == 1226748685) strcat(s, "J");
if (crc32("BrjyuvE",7) == 3763230410) strcat(s, "c");
    return s;
}

char *stenchful_adjectives() {
    char *s = calloc(10);
    if (crc32("ctcOalUlWDrisnV",15) == 2762481801) strcat(s, "p");
if (crc32("sDTdV",5) == 2215280230) strcat(s, "s");
if (crc32("lxOIXQeQzaKpA",13) == 3001923985) strcat(s, "t");
if (crc32("XbAaxnL",7) == 1002661118) strcat(s, "y");
if (crc32("rvJOdtDdyQoG",12) == 3907637583) strcat(s, "e");
if (crc32("Aceovbm",7) == 1396549024) strcat(s, "S");
if (crc32("CwjhGIbmbsayX",13) == 1139293909) strcat(s, "n");
if (crc32("pVXGMaMK",8) == 130749456) strcat(s, "c");
if (crc32("rHZwWkiwM",9) == 3081124373) strcat(s, "x");
if (crc32("ghJWnhLcrhHVJ",13) == 3724557710) strcat(s, "h");
if (crc32("zncEhEtPCEyDSFA",15) == 2199020161) strcat(s, "f");
if (crc32("vWoKTTeUSXhdWgm",15) == 792208762) strcat(s, "t");
if (crc32("obPYVlFVeELGk",13) == 1172416765) strcat(s, "u");
if (crc32("NcifXlLf",8) == 1837847772) strcat(s, "l");
    return s;
}

char *magisterial_adjectives() {
    char *s = calloc(12);
    if (crc32("gULYQQTErWENRS",14) == 2395756145) strcat(s, "m");
if (crc32("OhNJNZNHtj",10) == 529335186) strcat(s, "S");
if (crc32("MWPRa",5) == 3995016278) strcat(s, "a");
if (crc32("hMoIAfgkHkGQt",13) == 2721949006) strcat(s, "g");
if (crc32("JXTJatjdFkYMdXo",15) == 1998733785) strcat(s, "i");
if (crc32("KTypsfYlFecgw",13) == 2059211552) strcat(s, "s");
if (crc32("xzGRIx",6) == 4082057593) strcat(s, "t");
if (crc32("ezJCrqjyar",10) == 863581235) strcat(s, "e");
if (crc32("OmopqZxrQQ",10) == 811270304) strcat(s, "r");
if (crc32("RsfMoQhNHLMJ",12) == 3664183207) strcat(s, "N");
if (crc32("bXdFrsAt",8) == 2324384421) strcat(s, "i");
if (crc32("vEiDAbVpdbki",12) == 777693815) strcat(s, "a");
if (crc32("RRKVNDBGQVka",12) == 3093832354) strcat(s, "p");
if (crc32("pGxGpbjhEIWZ",12) == 3792720256) strcat(s, "l");
    return s;
}

char *unnatural_adjectives() {
    char *s = calloc(10);
    if (crc32("IdmslDHtfWT",11) == 226920322) strcat(s, "i");
if (crc32("PTSIbpLhukVujG",14) == 1145238886) strcat(s, "u");
if (crc32("YuNVdOnqpBZhXZ",14) == 3531926734) strcat(s, "n");
if (crc32("nCqmhAQa",8) == 1654876764) strcat(s, "n");
if (crc32("PMVTtggVlikiazw",15) == 2568199382) strcat(s, "k");
if (crc32("RhUlkQFVPGlPOxO",15) == 2958245369) strcat(s, "a");
if (crc32("fPnLTovmkP",10) == 123803234) strcat(s, "g");
if (crc32("InQbzrAtSvsF",12) == 1822825414) strcat(s, "t");
if (crc32("pHWzArRuvG",10) == 881328468) strcat(s, "X");
if (crc32("IWwUdfLQrzOUGQ",14) == 3769596147) strcat(s, "u");
if (crc32("FYsiZQDEcrJwezt",15) == 4022715313) strcat(s, "M");
if (crc32("DdnJzC",6) == 3578278180) strcat(s, "r");
if (crc32("uhuhIKDpWi",10) == 114758771) strcat(s, "R");
if (crc32("RzcUvwTziCFKjH",14) == 582801685) strcat(s, "a");
if (crc32("KlZxeEk",7) == 408157785) strcat(s, "p");
if (crc32("CzIvyIQjdSfz",12) == 4003894588) strcat(s, "l");
    return s;
}

char *haustellate_adjectives() {
    char *s = calloc(12);
    if (crc32("SvKFaj",6) == 1212586659) strcat(s, "m");
if (crc32("GeLVVWTmqYmhEyL",15) == 3705471137) strcat(s, "h");
if (crc32("WwspbiDDU",9) == 3713462573) strcat(s, "a");
if (crc32("BjCQjxqQqHrfmfL",15) == 2342220290) strcat(s, "e");
if (crc32("UgSjXpTA",8) == 3928613726) strcat(s, "u");
if (crc32("eMRixpVzrI",10) == 1388204899) strcat(s, "L");
if (crc32("mmBCwq",6) == 1622606703) strcat(s, "s");
if (crc32("wApai",5) == 2986418128) strcat(s, "t");
if (crc32("OfljI",5) == 3541293063) strcat(s, "e");
if (crc32("zGYehSbrbM",10) == 689772500) strcat(s, "l");
if (crc32("QcSZtpjCesW",11) == 2440632489) strcat(s, "l");
if (crc32("sWBxarHOOIxAwcC",15) == 186118271) strcat(s, "a");
if (crc32("iPjuRIBsnT",10) == 2804302842) strcat(s, "t");
if (crc32("utrxqjISdhTDt",13) == 2826882785) strcat(s, "P");
if (crc32("xLiWCTYglLCJ",12) == 2335624151) strcat(s, "e");
    return s;
}

char *synaptical_adjectives() {
    char *s = calloc(11);
    if (crc32("iXVtmW",6) == 687267748) strcat(s, "t");
if (crc32("syAqxcGlTlkn",12) == 2568710738) strcat(s, "s");
if (crc32("rOwWliFkt",9) == 1329540520) strcat(s, "y");
if (crc32("vhntsuo",7) == 3990777548) strcat(s, "n");
if (crc32("FlZiAIxAO",9) == 3002551903) strcat(s, "a");
if (crc32("ywwRU",5) == 104466942) strcat(s, "p");
if (crc32("ufRTgjmYwU",10) == 187156286) strcat(s, "t");
if (crc32("CWkdaOWtJKc",11) == 4075329481) strcat(s, "i");
if (crc32("PYFCEMXreiUyzA",14) == 1003468361) strcat(s, "H");
if (crc32("QYsfzxmdie",10) == 3447329075) strcat(s, "c");
if (crc32("ySQFaFJfsuelt",13) == 376584786) strcat(s, "r");
if (crc32("aFTQeMoZv",9) == 3502164418) strcat(s, "a");
if (crc32("EsakbnISqgaj",12) == 2207368638) strcat(s, "A");
if (crc32("PiyoUNmPc",9) == 2124061775) strcat(s, "l");
    return s;
}

char *sacrilegious_adjectives() {
    char *s = calloc(13);
    if (crc32("wCchiOWIVoodvE",14) == 2036224994) strcat(s, "Q");
if (crc32("znQsRkg",7) == 2710858609) strcat(s, "s");
if (crc32("xyFPQSZ",7) == 313254242) strcat(s, "p");
if (crc32("ntCXIyGB",8) == 2736642054) strcat(s, "a");
if (crc32("yEyYOWiaSVrjyVp",15) == 3858389486) strcat(s, "X");
if (crc32("kYFgSIBFjbIxH",13) == 2680519268) strcat(s, "c");
if (crc32("DKvSejBY",8) == 3044140074) strcat(s, "r");
if (crc32("XBYzZtCpBGqh",12) == 4020022210) strcat(s, "C");
if (crc32("LXGIFgXKZvPdyGc",15) == 1999282802) strcat(s, "i");
if (crc32("WZIylGWWujEomlL",15) == 3066446218) strcat(s, "P");
if (crc32("JuzIijR",7) == 787989944) strcat(s, "l");
if (crc32("EgypNDsqNHDX",12) == 1639284647) strcat(s, "e");
if (crc32("WUfibVf",7) == 404349952) strcat(s, "i");
if (crc32("CRDJa",5) == 4291150320) strcat(s, "g");
if (crc32("ufDMiVzxVThyV",13) == 3312134649) strcat(s, "S");
if (crc32("nqOrWBVBa",9) == 3441351658) strcat(s, "i");
if (crc32("UxmTEe",6) == 906761420) strcat(s, "o");
if (crc32("bneyGEWRpqwC",12) == 398339770) strcat(s, "u");
if (crc32("tIJfQLTWW",9) == 4239593879) strcat(s, "u");
if (crc32("TxvpGNLHeE",10) == 174455174) strcat(s, "s");
if (crc32("WpeqEGOt",8) == 3014948782) strcat(s, "s");
    return s;
}

char *astrolabical_adjectives() {
    char *s = calloc(13);
    if (crc32("ZMbvFg",6) == 135406040) strcat(s, "a");
if (crc32("zRSnwQwHQ",9) == 4185242364) strcat(s, "s");
if (crc32("VfwHMXP",7) == 1209381350) strcat(s, "l");
if (crc32("UJoeuKQ",7) == 134449886) strcat(s, "t");
if (crc32("chQNKOoFkZRlaFh",15) == 2071082881) strcat(s, "r");
if (crc32("WWaWdJWA",8) == 2822827900) strcat(s, "o");
if (crc32("XDYYfSGxJM",10) == 3386319578) strcat(s, "l");
if (crc32("tcjeGRdd",8) == 762205122) strcat(s, "a");
if (crc32("OHnxbvazT",9) == 410198787) strcat(s, "T");
if (crc32("FgNgH",5) == 2682192198) strcat(s, "b");
if (crc32("dXDqlqUTJDRXDU",14) == 4277292776) strcat(s, "b");
if (crc32("thrDRCEsTAIIe",13) == 2270694982) strcat(s, "i");
if (crc32("oABQAhSSiEpy",12) == 3136547828) strcat(s, "s");
if (crc32("fWdJAEWtORY",11) == 59220818) strcat(s, "c");
if (crc32("pOFyFOARzdwRdYg",15) == 3950332900) strcat(s, "a");
if (crc32("WFeLTLhgKIG",11) == 1008175749) strcat(s, "N");
if (crc32("MUMvyYvARdk",11) == 3741769234) strcat(s, "l");
    return s;
}

char *unmasticated_adjectives() {
    char *s = calloc(13);
    if (crc32("jQGhkRLMnuSpVV",14) == 3980193909) strcat(s, "c");
if (crc32("IdgtH",5) == 1497957764) strcat(s, "u");
if (crc32("KlcAfMrrMYfq",12) == 2076558317) strcat(s, "n");
if (crc32("HicTetmDr",9) == 4234558332) strcat(s, "D");
if (crc32("dCjyuvAayS",10) == 2937917334) strcat(s, "m");
if (crc32("kaqpXbwQvvO",11) == 491350997) strcat(s, "E");
if (crc32("bxHMaIKf",8) == 546211472) strcat(s, "a");
if (crc32("vJsQNTOvGOpBeA",14) == 3076970490) strcat(s, "s");
if (crc32("LustZmuGdEf",11) == 985344562) strcat(s, "x");
if (crc32("obEhJn",6) == 3774931270) strcat(s, "t");
if (crc32("qBENSStyXqZNN",13) == 4175009278) strcat(s, "E");
if (crc32("kkrmxWDmWo",10) == 23302004) strcat(s, "i");
if (crc32("EFats",5) == 3432647551) strcat(s, "n");
if (crc32("BVQUkGUwvS",10) == 1046910692) strcat(s, "c");
if (crc32("ZeAhNYrN",8) == 2177366962) strcat(s, "a");
if (crc32("yYVeRxDMrY",10) == 1370317264) strcat(s, "j");
if (crc32("GsOjEY",6) == 73618917) strcat(s, "t");
if (crc32("hxVGJdbrok",10) == 1341880527) strcat(s, "j");
if (crc32("EfTTK",5) == 470814431) strcat(s, "e");
if (crc32("ecTiLWj",7) == 2489728892) strcat(s, "f");
if (crc32("NrZnWdS",7) == 4243110930) strcat(s, "d");
    return s;
}

char *unharming_adjectives() {
    char *s = calloc(10);
    if (crc32("JSUecluhoysHgc",14) == 2986585861) strcat(s, "h");
if (crc32("ALvnOKPcEKHV",12) == 1840715387) strcat(s, "u");
if (crc32("AgPaoWnsmQFOZ",13) == 1144092066) strcat(s, "u");
if (crc32("nOfNtfPK",8) == 3638306570) strcat(s, "n");
if (crc32("IQSpZwDv",8) == 2112336161) strcat(s, "h");
if (crc32("TWergvDElvAMu",13) == 2983265488) strcat(s, "U");
if (crc32("pWRcNeu",7) == 1227770311) strcat(s, "a");
if (crc32("sxPzWBUULWhxg",13) == 2570112906) strcat(s, "J");
if (crc32("tmfyOEqEwQn",11) == 1085918312) strcat(s, "r");
if (crc32("UdBRCD",6) == 2720300980) strcat(s, "e");
if (crc32("uzLzDeBLHnbmF",13) == 1549095379) strcat(s, "m");
if (crc32("xhFpkDkhBreXjHE",15) == 1188173085) strcat(s, "S");
if (crc32("VHnPuZIBwQjjr",13) == 2584293340) strcat(s, "i");
if (crc32("YWzsJryMzPxrNQR",15) == 2256656049) strcat(s, "n");
if (crc32("lLYCtlCeIAdW",12) == 4144586046) strcat(s, "g");
    return s;
}

char *unstultifying_adjectives() {
    char *s = calloc(14);
    if (crc32("iDYTFM",6) == 1085542994) strcat(s, "u");
if (crc32("TIvSYDo",7) == 1765130973) strcat(s, "b");
if (crc32("CfDXQERLxQ",10) == 2958846534) strcat(s, "n");
if (crc32("KmCgoPrbpRzfpp",14) == 1980125728) strcat(s, "s");
if (crc32("fupCmt",6) == 3229946257) strcat(s, "t");
if (crc32("cWjTyYLVQq",10) == 3620960863) strcat(s, "I");
if (crc32("ewcUG",5) == 83730270) strcat(s, "u");
if (crc32("XHYfNKxeq",9) == 1940369423) strcat(s, "l");
if (crc32("VdRquqPbY",9) == 71526726) strcat(s, "k");
if (crc32("BWXFHH",6) == 1130939279) strcat(s, "t");
if (crc32("hQMhuRDxB",9) == 4023897223) strcat(s, "c");
if (crc32("FbFZwQxi",8) == 1967489396) strcat(s, "i");
if (crc32("StfmXKpTTewmW",13) == 1464911072) strcat(s, "M");
if (crc32("JCDMKTHKtBOCvu",14) == 3279552918) strcat(s, "f");
if (crc32("nDdRCUPeFjhX",12) == 3198971325) strcat(s, "M");
if (crc32("JwuQcQjckeQ",11) == 2947840974) strcat(s, "y");
if (crc32("uuseKBhgYhPXZ",13) == 2154746445) strcat(s, "i");
if (crc32("YvltphnrwWiI",12) == 4285239482) strcat(s, "t");
if (crc32("lpVQM",5) == 841207543) strcat(s, "n");
if (crc32("JWEAcL",6) == 385024041) strcat(s, "h");
if (crc32("xuswXUvAO",9) == 698896485) strcat(s, "g");
    return s;
}

char *pseudoscientific_adjectives() {
    char *s = calloc(17);
    if (crc32("cjVnViwQ",8) == 1025992670) strcat(s, "p");
if (crc32("lEZyzpuoZDqHd",13) == 4086347857) strcat(s, "Z");
if (crc32("KUBziANoWd",10) == 1404581959) strcat(s, "s");
if (crc32("AnqYcEHWogzcyV",14) == 395146723) strcat(s, "e");
if (crc32("gFxISjR",7) == 1911584666) strcat(s, "S");
if (crc32("HvqxPXIYmqTrSv",14) == 4185355870) strcat(s, "u");
if (crc32("aJrFZH",6) == 987159704) strcat(s, "J");
if (crc32("CilHLl",6) == 3147658724) strcat(s, "d");
if (crc32("TGCWoiEzVQcLCEM",15) == 3354624172) strcat(s, "M");
if (crc32("YdmpoWaSiwdDVI",14) == 2733622889) strcat(s, "o");
if (crc32("yrwiKLEgYzLCw",13) == 2428652017) strcat(s, "R");
if (crc32("KGRDfjcADudfWu",14) == 2294912109) strcat(s, "s");
if (crc32("CEfFVfKrAzZw",12) == 1116028474) strcat(s, "D");
if (crc32("lfgoyA",6) == 3269074033) strcat(s, "c");
if (crc32("bouUoMFfoJS",11) == 1362769531) strcat(s, "E");
if (crc32("qCWULJMbjTTD",12) == 3064504778) strcat(s, "i");
if (crc32("HxDMvuBzs",9) == 378780078) strcat(s, "d");
if (crc32("sciSQuaRoSGaKCf",15) == 2590082062) strcat(s, "e");
if (crc32("sPuor",5) == 3247637238) strcat(s, "P");
if (crc32("PQhLeK",6) == 3333022621) strcat(s, "n");
if (crc32("KzEJdRcQIC",10) == 980292159) strcat(s, "t");
if (crc32("GvcnNmHVS",9) == 4041225527) strcat(s, "i");
if (crc32("rQXbvKFpDUJ",11) == 2963719496) strcat(s, "f");
if (crc32("yhfxrCnEZJNIZp",14) == 797635141) strcat(s, "i");
if (crc32("vrpxVTwP",8) == 230947616) strcat(s, "F");
if (crc32("obBVU",5) == 3364957710) strcat(s, "c");
    return s;
}

char *undocketed_adjectives() {
    char *s = calloc(11);
    if (crc32("beNzDXldTCEXg",13) == 12679481) strcat(s, "t");
if (crc32("mjvzOtYvsOQgcZ",14) == 2729923261) strcat(s, "u");
if (crc32("aYEOXRNgWneZM",13) == 291294623) strcat(s, "n");
if (crc32("XbqRtXLQU",9) == 1977548525) strcat(s, "n");
if (crc32("PigqUXrdGVjW",12) == 3648165641) strcat(s, "i");
if (crc32("rblRDbJChJqMpaG",15) == 1952969293) strcat(s, "d");
if (crc32("bDUgqvCxezHh",12) == 1063886583) strcat(s, "o");
if (crc32("QMngDT",6) == 3087115376) strcat(s, "c");
if (crc32("EuoliZDDIcqjDrX",15) == 449269747) strcat(s, "f");
if (crc32("MrlWaFtiFmeO",12) == 2435675646) strcat(s, "k");
if (crc32("KcpnzNYUKQxP",12) == 3469367631) strcat(s, "e");
if (crc32("iXhgbDdYC",9) == 22317262) strcat(s, "t");
if (crc32("frdXN",5) == 3183396304) strcat(s, "e");
if (crc32("wCGFgKoQZOsrnT",14) == 167528114) strcat(s, "d");
    return s;
}

char *Yoruban_adjectives() {
    char *s = calloc(8);
    if (crc32("JMnpWyfsEz",10) == 4239105704) strcat(s, "Y");
if (crc32("QyKOBXUYuDlP",12) == 2777078440) strcat(s, "o");
if (crc32("tJZPXp",6) == 3180015536) strcat(s, "I");
if (crc32("EELzatS",7) == 3178231396) strcat(s, "r");
if (crc32("GKHjKm",6) == 3688689358) strcat(s, "E");
if (crc32("WdDFjr",6) == 2374231364) strcat(s, "u");
if (crc32("xUngO",5) == 2110121160) strcat(s, "b");
if (crc32("wnrfxQ",6) == 4064564148) strcat(s, "R");
if (crc32("tlCNiSrBik",10) == 2573616640) strcat(s, "a");
if (crc32("mwJqIIhGHE",10) == 994180030) strcat(s, "m");
if (crc32("qOzkkLoP",8) == 4016636214) strcat(s, "n");
    return s;
}

char *superexplicit_adjectives() {
    char *s = calloc(14);
    if (crc32("lUxyYwJksaaij",13) == 3872480275) strcat(s, "s");
if (crc32("JsiLMuB",7) == 127519491) strcat(s, "u");
if (crc32("QsTluCpolCyOVP",14) == 952191420) strcat(s, "m");
if (crc32("jaEiTbcJD",9) == 1741142529) strcat(s, "p");
if (crc32("cjSqGMD",7) == 2624015884) strcat(s, "f");
if (crc32("nYeciMMRaTE",11) == 2572092910) strcat(s, "e");
if (crc32("hxJxeuRNkCp",11) == 2752000508) strcat(s, "s");
if (crc32("tuvxsMCZoUju",12) == 702756533) strcat(s, "r");
if (crc32("fGPggJpMRuE",11) == 1279582374) strcat(s, "e");
if (crc32("kanEYWQBol",10) == 3907015642) strcat(s, "P");
if (crc32("uakudA",6) == 4029179440) strcat(s, "x");
if (crc32("suEYfKnuqjMqG",13) == 3147983187) strcat(s, "p");
if (crc32("QaeyFz",6) == 2473132099) strcat(s, "l");
if (crc32("ANphGDJDQshK",12) == 3160351577) strcat(s, "i");
if (crc32("YEBqqyI",7) == 1817125647) strcat(s, "Y");
if (crc32("NHBaBxAMChitVsg",15) == 2727896189) strcat(s, "c");
if (crc32("NREVbtlljEX",11) == 1497531877) strcat(s, "i");
if (crc32("dpiPwHtCTfQ",11) == 3547130272) strcat(s, "t");
    return s;
}

char *compoundwound_adjectives() {
    char *s = calloc(14);
    if (crc32("hmRMmwshCAHSjfz",15) == 625434377) strcat(s, "c");
if (crc32("TRZfEKWtWxuotQN",15) == 751697767) strcat(s, "o");
if (crc32("NPahx",5) == 855801346) strcat(s, "y");
if (crc32("RXNvcjqUdaPcO",13) == 973236107) strcat(s, "m");
if (crc32("insvwFEMq",9) == 2912816633) strcat(s, "V");
if (crc32("WRphzg",6) == 3378993860) strcat(s, "p");
if (crc32("MhTwx",5) == 3452314714) strcat(s, "o");
if (crc32("GJOKhkQZp",9) == 1790539101) strcat(s, "x");
if (crc32("kURapJzp",8) == 4022147679) strcat(s, "u");
if (crc32("VOrbRFb",7) == 1543316804) strcat(s, "n");
if (crc32("EfgOFGYWV",9) == 293131784) strcat(s, "d");
if (crc32("OIczXLavUQCvXB",14) == 3557690745) strcat(s, "w");
if (crc32("ZYZZqyzesMoabZ",14) == 1565580487) strcat(s, "u");
if (crc32("qmRdDDcovcBz",12) == 501180831) strcat(s, "o");
if (crc32("aMPJVu",6) == 1033435769) strcat(s, "g");
if (crc32("JHBZrYqTXkK",11) == 864874391) strcat(s, "u");
if (crc32("JwVBJHKJyRE",11) == 3451731713) strcat(s, "F");
if (crc32("AAQlobir",8) == 3680180780) strcat(s, "n");
if (crc32("UbIHKuCWrC",10) == 3375841064) strcat(s, "d");
    return s;
}

char *causative_adjectives() {
    char *s = calloc(10);
    if (crc32("FeCobSg",7) == 2965440480) strcat(s, "w");
if (crc32("moZHFNQczoyIQ",13) == 664543552) strcat(s, "c");
if (crc32("gtZrs",5) == 2528418473) strcat(s, "g");
if (crc32("KIRPaTpyxzoiwXG",15) == 4170300675) strcat(s, "a");
if (crc32("CGTnNBXuQqC",11) == 71114197) strcat(s, "u");
if (crc32("KYiGDqsT",8) == 3016215669) strcat(s, "Y");
if (crc32("vySTHIJydvjFoSU",15) == 3432342852) strcat(s, "s");
if (crc32("ZCYXvgWiBkMcwnh",15) == 2586888030) strcat(s, "a");
if (crc32("PvfAljsdd",9) == 2127935876) strcat(s, "Y");
if (crc32("yOimnFKOvVyAmF",14) == 3346875526) strcat(s, "t");
if (crc32("rujntoohwzNwX",13) == 419952697) strcat(s, "i");
if (crc32("RHbkKtZWfie",11) == 240646940) strcat(s, "v");
if (crc32("XdcGMcqD",8) == 257789286) strcat(s, "C");
if (crc32("ukSnvZCviUyrR",13) == 2607253571) strcat(s, "e");
    return s;
}

char *neocolonial_adjectives() {
    char *s = calloc(12);
    if (crc32("AyKeLkkoKFPS",12) == 1270996384) strcat(s, "r");
if (crc32("ZPEVImUSknJn",12) == 1565390970) strcat(s, "n");
if (crc32("LOkEzLeWJN",10) == 886491726) strcat(s, "e");
if (crc32("WwyVRP",6) == 354348482) strcat(s, "z");
if (crc32("jcpuZceSmIUBCx",14) == 1031239423) strcat(s, "o");
if (crc32("OPaGxARgmhvkek",14) == 602515961) strcat(s, "c");
if (crc32("uQvReuQLAMbijCt",15) == 2243936286) strcat(s, "o");
if (crc32("esyfxKouGRLEFdD",15) == 2058316513) strcat(s, "l");
if (crc32("NmfAWxt",7) == 248501907) strcat(s, "n");
if (crc32("TqmBGPtFa",9) == 4010598818) strcat(s, "o");
if (crc32("njbsxuPq",8) == 2942351273) strcat(s, "U");
if (crc32("IsXlcJZYgDILa",13) == 954161511) strcat(s, "n");
if (crc32("BfwpBF",6) == 3213583120) strcat(s, "k");
if (crc32("iXnBweSSM",9) == 3105410880) strcat(s, "i");
if (crc32("FXNrFDDaKQMagp",14) == 1114671430) strcat(s, "h");
if (crc32("vrikM",5) == 3102012811) strcat(s, "a");
if (crc32("omIQczDRoXymq",13) == 2064639730) strcat(s, "l");
    return s;
}

char *huffish_adjectives() {
    char *s = calloc(8);
    if (crc32("OlgFFjUBwrRR",12) == 1272316206) strcat(s, "i");
if (crc32("xVHYoSjGbFCQLuO",15) == 2565370674) strcat(s, "h");
if (crc32("frSmkrSEjYdqSz",14) == 3376212091) strcat(s, "u");
if (crc32("uglQyPKrkdxI",12) == 2662340263) strcat(s, "i");
if (crc32("tFJcAijZcspHSO",14) == 957692981) strcat(s, "f");
if (crc32("sOwYLMybKZ",10) == 4071171653) strcat(s, "f");
if (crc32("AaoJyfDlsZ",10) == 3490887738) strcat(s, "i");
if (crc32("XhPOYNgvh",9) == 3356128715) strcat(s, "s");
if (crc32("tWPzzi",6) == 3633796875) strcat(s, "h");
    return s;
}

char *hypermoral_adjectives() {
    char *s = calloc(11);
    if (crc32("vlVPdLESuHm",11) == 4126450015) strcat(s, "h");
if (crc32("FIMJYsWDJzF",11) == 3976207090) strcat(s, "n");
if (crc32("IsCrdERgjSMeleW",15) == 2390321571) strcat(s, "y");
if (crc32("BTxsbAsM",8) == 1812663689) strcat(s, "p");
if (crc32("aDRXWraslNQa",12) == 301437417) strcat(s, "e");
if (crc32("IfDbLIoCk",9) == 2480445655) strcat(s, "g");
if (crc32("BYSHkdnmg",9) == 3059256794) strcat(s, "r");
if (crc32("vQfNtV",6) == 2836526134) strcat(s, "a");
if (crc32("CYCGhg",6) == 2408254745) strcat(s, "m");
if (crc32("YnrWHQo",7) == 3425916192) strcat(s, "o");
if (crc32("fPmOEEMd",8) == 4120705617) strcat(s, "V");
if (crc32("phZOT",5) == 3148785023) strcat(s, "r");
if (crc32("hpoTuHbxA",9) == 2343054070) strcat(s, "p");
if (crc32("xBAnaiOMGlUjsC",14) == 2071396701) strcat(s, "a");
if (crc32("gtgTWA",6) == 1403933110) strcat(s, "s");
if (crc32("aAFEJbELdqR",11) == 1599704519) strcat(s, "l");
    return s;
}

char *nonegocentric_adjectives() {
    char *s = calloc(14);
    if (crc32("SETkWz",6) == 4044718751) strcat(s, "n");
if (crc32("HOhQrEvNLL",10) == 678400818) strcat(s, "n");
if (crc32("KCYcnLcUJzDjqjy",15) == 2164863056) strcat(s, "o");
if (crc32("qjjFVEpZC",9) == 1456790097) strcat(s, "n");
if (crc32("NqYpqtGUdPn",11) == 391157352) strcat(s, "e");
if (crc32("nvCvWlcDXFnslYJ",15) == 4281277631) strcat(s, "M");
if (crc32("GRAXXkbYhRDKv",13) == 3293762175) strcat(s, "g");
if (crc32("EQvGWffBL",9) == 135638789) strcat(s, "F");
if (crc32("DAskbF",6) == 3051642387) strcat(s, "o");
if (crc32("qBvxffdBu",9) == 221681394) strcat(s, "Y");
if (crc32("jSAdzacjwOvMba",14) == 1021777523) strcat(s, "c");
if (crc32("gsVCGEj",7) == 897955713) strcat(s, "e");
if (crc32("WBskggOW",8) == 3817274711) strcat(s, "n");
if (crc32("NJknafGn",8) == 663593309) strcat(s, "t");
if (crc32("ZsXosjLsR",9) == 3626807387) strcat(s, "r");
if (crc32("CSbsgZqRudK",11) == 2127117538) strcat(s, "Y");
if (crc32("gZgjIhhtf",9) == 4288958025) strcat(s, "i");
if (crc32("MAQhEqG",7) == 3911702857) strcat(s, "V");
if (crc32("ciZMlVsK",8) == 3569577722) strcat(s, "c");
    return s;
}

char *unenlightening_adjectives() {
    char *s = calloc(15);
    if (crc32("dkwrqGMNvY",10) == 1792526265) strcat(s, "u");
if (crc32("sfkwYAvrmVtTw",13) == 2522559481) strcat(s, "n");
if (crc32("HhswIqYGUMIY",12) == 322238158) strcat(s, "S");
if (crc32("YEWnSw",6) == 1093932188) strcat(s, "e");
if (crc32("zdUjjqHvAMnFlg",14) == 3856914056) strcat(s, "q");
if (crc32("exwkvhPxymmRw",13) == 3213764898) strcat(s, "n");
if (crc32("wDRxm",5) == 578490477) strcat(s, "l");
if (crc32("jvSSzCljjkNf",12) == 2736354610) strcat(s, "B");
if (crc32("xpecLMlKZSENeXG",15) == 4084130876) strcat(s, "i");
if (crc32("AtnxmjxDWWSQv",13) == 2692992246) strcat(s, "g");
if (crc32("VdIamZw",7) == 1448078803) strcat(s, "h");
if (crc32("AflIvAX",7) == 3449377724) strcat(s, "b");
if (crc32("DDXHt",5) == 1916848606) strcat(s, "t");
if (crc32("oBjQbnisLqH",11) == 2532909300) strcat(s, "e");
if (crc32("wqvoemsiNd",10) == 3502656946) strcat(s, "d");
if (crc32("AzyqxVDat",9) == 3492279425) strcat(s, "n");
if (crc32("elWykABcENYMcDo",15) == 490734293) strcat(s, "i");
if (crc32("gmYSnK",6) == 1561751976) strcat(s, "g");
if (crc32("PLPOMKLa",8) == 373966795) strcat(s, "n");
if (crc32("YfULBcRGYNBpH",13) == 2844918118) strcat(s, "g");
    return s;
}

char *grooveless_adjectives() {
    char *s = calloc(11);
    if (crc32("QFdRdnrOgdk",11) == 1129383712) strcat(s, "Q");
if (crc32("EJGvLOvXoReW",12) == 3770425272) strcat(s, "g");
if (crc32("oowiMLmFvpTxJAo",15) == 3974477568) strcat(s, "O");
if (crc32("xGeNQysZHyvFAn",14) == 1039328338) strcat(s, "r");
if (crc32("ATUgsxzeWOBnBn",14) == 2066468319) strcat(s, "o");
if (crc32("CwygfCvrf",9) == 3186992954) strcat(s, "o");
if (crc32("EStXaMiilXUJmOC",15) == 2150569034) strcat(s, "v");
if (crc32("bFuPhPu",7) == 1762583549) strcat(s, "b");
if (crc32("xixFIAMFwIaKD",13) == 1612802172) strcat(s, "e");
if (crc32("OyOOMOSTVii",11) == 3717412094) strcat(s, "l");
if (crc32("MCKHuBvPwox",11) == 4178620091) strcat(s, "J");
if (crc32("ZXKIaQV",7) == 1536599089) strcat(s, "e");
if (crc32("wLLXRKpXQ",9) == 1538680190) strcat(s, "s");
if (crc32("wyIKshTDMoANaW",14) == 3815739931) strcat(s, "z");
if (crc32("RgWexHccySJWPoA",15) == 379783115) strcat(s, "s");
    return s;
}

char *noncodified_adjectives() {
    char *s = calloc(12);
    if (crc32("OWcSofOaAiayY",13) == 688918076) strcat(s, "A");
if (crc32("jGGQyVRIJBCr",12) == 1524313941) strcat(s, "n");
if (crc32("dyJBDYtvtJh",11) == 1645644158) strcat(s, "o");
if (crc32("qXlODgjAIPz",11) == 2495419799) strcat(s, "n");
if (crc32("cYhKGZnTjPUoqL",14) == 2594445211) strcat(s, "c");
if (crc32("FLzjpxtENM",10) == 4260190040) strcat(s, "h");
if (crc32("AeLsBRXyM",9) == 1862173133) strcat(s, "o");
if (crc32("tqnqGXl",7) == 1365775890) strcat(s, "c");
if (crc32("xlbBeYldqcxW",12) == 2417120104) strcat(s, "d");
if (crc32("ssACbWnfzRU",11) == 2160401044) strcat(s, "i");
if (crc32("zNKlwDtK",8) == 3491821479) strcat(s, "e");
if (crc32("flPivVmK",8) == 2955177407) strcat(s, "f");
if (crc32("wjiyVN",6) == 351047205) strcat(s, "i");
if (crc32("evhPGnjrU",9) == 1551349431) strcat(s, "e");
if (crc32("fOIlFJ",6) == 3108558673) strcat(s, "e");
if (crc32("zIatvWe",7) == 628238383) strcat(s, "d");
    return s;
}

char *unfictitious_adjectives() {
    char *s = calloc(13);
    if (crc32("mVjRVIdgXa",10) == 226849046) strcat(s, "u");
if (crc32("cZZuD",5) == 1272327109) strcat(s, "J");
if (crc32("aYRzucib",8) == 1022982135) strcat(s, "n");
if (crc32("TfTfnlApcRPGD",13) == 4071500957) strcat(s, "f");
if (crc32("udEHrdgfSNdHq",13) == 592397638) strcat(s, "p");
if (crc32("HjvKIvM",7) == 1998804765) strcat(s, "i");
if (crc32("jDHkk",5) == 590774623) strcat(s, "c");
if (crc32("bdkHthwKrEkLmjo",15) == 48437909) strcat(s, "t");
if (crc32("fArfwDednj",10) == 1591905637) strcat(s, "i");
if (crc32("EVPkd",5) == 3088307033) strcat(s, "r");
if (crc32("zDNSBsnjAM",10) == 752988174) strcat(s, "t");
if (crc32("hfeNm",5) == 2102933034) strcat(s, "S");
if (crc32("PJclM",5) == 2167204976) strcat(s, "i");
if (crc32("bYQGsuk",7) == 2574933824) strcat(s, "n");
if (crc32("ZeyJl",5) == 2915827301) strcat(s, "o");
if (crc32("RZApYKUyzcyRl",13) == 2885642004) strcat(s, "u");
if (crc32("UZZrPE",6) == 3505017918) strcat(s, "s");
    return s;
}

char *ablepharous_adjectives() {
    char *s = calloc(12);
    if (crc32("qythdv",6) == 2668636800) strcat(s, "a");
if (crc32("svjvZaEYAlzqs",13) == 4273184102) strcat(s, "b");
if (crc32("nJevIEPrkYs",11) == 228731316) strcat(s, "l");
if (crc32("rZWANQtkEdbN",12) == 2920443561) strcat(s, "H");
if (crc32("bayFNSIqrTxx",12) == 1481047162) strcat(s, "e");
if (crc32("ImjDWl",6) == 1791073632) strcat(s, "p");
if (crc32("LgdSsXqTzFcDIrz",15) == 1186629053) strcat(s, "h");
if (crc32("gQauDKZKoPoFoyd",15) == 1809853894) strcat(s, "a");
if (crc32("WluvlH",6) == 1096395493) strcat(s, "r");
if (crc32("fUxbJBj",7) == 1248365977) strcat(s, "W");
if (crc32("fBPjbfrtl",9) == 2381270486) strcat(s, "o");
if (crc32("KNmtwPBQeSJWHkx",15) == 1771590550) strcat(s, "g");
if (crc32("KcIhmHik",8) == 4077169434) strcat(s, "u");
if (crc32("eFNSPcniir",10) == 321997617) strcat(s, "s");
    return s;
}

char *unhusked_adjectives() {
    char *s = calloc(9);
    if (crc32("iQpxdICCWaaFH",13) == 1872366091) strcat(s, "u");
if (crc32("UyNPGkLr",8) == 2899527608) strcat(s, "n");
if (crc32("ckBIyTndReDO",12) == 898057336) strcat(s, "z");
if (crc32("uFDQsPeA",8) == 999580153) strcat(s, "h");
if (crc32("oFhhEQi",7) == 2413564833) strcat(s, "u");
if (crc32("pcyWWMrRusIL",12) == 2689045528) strcat(s, "s");
if (crc32("hirmqRWjQNU",11) == 2279342982) strcat(s, "g");
if (crc32("rbNus",5) == 895448773) strcat(s, "k");
if (crc32("tukzNTUeVqvABX",14) == 3863017258) strcat(s, "m");
if (crc32("wGeuZtfkA",9) == 2391022127) strcat(s, "e");
if (crc32("tHNIKDNl",8) == 536126127) strcat(s, "C");
if (crc32("mKOezaQxmfkqBuk",15) == 2277585329) strcat(s, "d");
    return s;
}

char *vinegarlike_adjectives() {
    char *s = calloc(12);
    if (crc32("jPIHQKMtg",9) == 1019197797) strcat(s, "R");
if (crc32("rGtUryLNliamYY",14) == 2702489305) strcat(s, "v");
if (crc32("yBBoZU",6) == 2631299603) strcat(s, "f");
if (crc32("dAfUS",5) == 4039902981) strcat(s, "i");
if (crc32("JfWIcFbVGqAdO",13) == 2684029682) strcat(s, "n");
if (crc32("QRyAPeQJONlLRg",14) == 817733171) strcat(s, "e");
if (crc32("YNiqeOQKdzCrHTa",15) == 972506007) strcat(s, "R");
if (crc32("erKkEGLIDDiReBU",15) == 1025221626) strcat(s, "g");
if (crc32("naCzAsTjGJNQuv",14) == 3747446491) strcat(s, "Q");
if (crc32("JHhsbFvb",8) == 3484368260) strcat(s, "a");
if (crc32("FLnfWlirxIxDl",13) == 1237491312) strcat(s, "u");
if (crc32("AVYjzhMe",8) == 39487931) strcat(s, "r");
if (crc32("iquEN",5) == 1111459037) strcat(s, "F");
if (crc32("oiETcKiJWWEFurE",15) == 198207729) strcat(s, "l");
if (crc32("ugLieIlbHU",10) == 3207366401) strcat(s, "i");
if (crc32("hDtkonCTg",9) == 1765265210) strcat(s, "k");
if (crc32("rBmeeBtnJVMCPjy",15) == 3620550060) strcat(s, "a");
if (crc32("RtdELRCfQgMCT",13) == 822701599) strcat(s, "e");
    return s;
}

char *septivalent_adjectives() {
    char *s = calloc(12);
    if (crc32("diUAI",5) == 3023040606) strcat(s, "u");
if (crc32("jcRXErAkYSiVcM",14) == 3632634922) strcat(s, "s");
if (crc32("VyLUr",5) == 1728180165) strcat(s, "e");
if (crc32("ctJCewsmStFK",12) == 2497211903) strcat(s, "p");
if (crc32("TmKpVPe",7) == 1508546830) strcat(s, "H");
if (crc32("pRjfsv",6) == 1569091072) strcat(s, "t");
if (crc32("vCqDFzj",7) == 1199353072) strcat(s, "i");
if (crc32("uWecVZxUPwPxRyg",15) == 2324482502) strcat(s, "K");
if (crc32("PDvQHbMEhwl",11) == 3264379767) strcat(s, "v");
if (crc32("ZnsHLwztkEKuh",13) == 2117180390) strcat(s, "a");
if (crc32("qmOnkqRXsAq",11) == 688544058) strcat(s, "l");
if (crc32("CBhAuBkEfOwo",12) == 919376652) strcat(s, "R");
if (crc32("OiRvbNm",7) == 452560823) strcat(s, "e");
if (crc32("JYQoEDYYFEYoqXG",15) == 581656949) strcat(s, "K");
if (crc32("JvtpCut",7) == 2969433609) strcat(s, "n");
if (crc32("xGFNZYHFwKON",12) == 1868398769) strcat(s, "d");
if (crc32("tQfemHIayVfzE",13) == 2646591347) strcat(s, "t");
    return s;
}

char *apian_adjectives() {
    char *s = calloc(6);
    if (crc32("vVWslikXaOUfGrQ",15) == 1838794031) strcat(s, "a");
if (crc32("zGoVDpDa",8) == 1607087565) strcat(s, "p");
if (crc32("bWVNoMBOQiyOM",13) == 1114217482) strcat(s, "p");
if (crc32("jnXLWhYHu",9) == 2374392172) strcat(s, "i");
if (crc32("sScHqmtEnJyw",12) == 2325002977) strcat(s, "a");
if (crc32("EAknNutAustprC",14) == 2451971827) strcat(s, "N");
if (crc32("cEhncNpHxVVljir",15) == 453007133) strcat(s, "n");
    return s;
}

char *promonopolistic_adjectives() {
    char *s = calloc(16);
    if (crc32("ZGDhcoOaKex",11) == 769552724) strcat(s, "p");
if (crc32("MHnqPwYbVjC",11) == 3239263953) strcat(s, "h");
if (crc32("WyWSIqyfW",9) == 883276194) strcat(s, "r");
if (crc32("jWfDWC",6) == 4010036144) strcat(s, "I");
if (crc32("LzoUMS",6) == 3300764114) strcat(s, "o");
if (crc32("NdLfgUANGPBWWuO",15) == 368481070) strcat(s, "Z");
if (crc32("bpMGdYC",7) == 3887457988) strcat(s, "m");
if (crc32("UwzZjfJxUGfXFf",14) == 2803793924) strcat(s, "o");
if (crc32("wxibBQr",7) == 3272931919) strcat(s, "F");
if (crc32("hEXerFmPoVhgl",13) == 214401926) strcat(s, "n");
if (crc32("VUkZsOcnY",9) == 49564756) strcat(s, "d");
if (crc32("QCAouQIM",8) == 1315088328) strcat(s, "o");
if (crc32("ZfbIiAmzR",9) == 2227151777) strcat(s, "p");
if (crc32("HOYvuVMDwH",10) == 1590165462) strcat(s, "J");
if (crc32("dHdSYDWRTbiDM",13) == 380615498) strcat(s, "o");
if (crc32("nFABUiUVzE",10) == 2656045305) strcat(s, "i");
if (crc32("alhbdHDDcrwHf",13) == 3277704511) strcat(s, "l");
if (crc32("lGBKRxUyy",9) == 2462386348) strcat(s, "B");
if (crc32("ibxgcWgYJBgug",13) == 2237976645) strcat(s, "i");
if (crc32("KGJlCmPXnsWiZqY",15) == 773193456) strcat(s, "V");
if (crc32("nbaEAZInlr",10) == 837993705) strcat(s, "s");
if (crc32("GPmbD",5) == 2173282361) strcat(s, "t");
if (crc32("OfpwEOf",7) == 2554956806) strcat(s, "b");
if (crc32("QiHYeYEM",8) == 3732837599) strcat(s, "i");
if (crc32("DWkpeVMIgUlrh",13) == 4282744824) strcat(s, "c");
    return s;
}

char *postmesenteric_adjectives() {
    char *s = calloc(15);
    if (crc32("coMKrpuB",8) == 2231409055) strcat(s, "p");
if (crc32("NLwVNVAxucwr",12) == 3535350743) strcat(s, "o");
if (crc32("kWsZJCk",7) == 1672292087) strcat(s, "s");
if (crc32("PTEjlzzXSHej",12) == 1095569079) strcat(s, "t");
if (crc32("XooGlPRcUtpjp",13) == 3814901485) strcat(s, "m");
if (crc32("QpUWBnvqCAg",11) == 1338747324) strcat(s, "e");
if (crc32("BIktmXxyek",10) == 2322246634) strcat(s, "F");
if (crc32("ZgTmqaiHXLMsMwn",15) == 2698362945) strcat(s, "s");
if (crc32("uAnMic",6) == 801104562) strcat(s, "h");
if (crc32("QKZtFWOXVbI",11) == 2839226647) strcat(s, "e");
if (crc32("ffZkKoeqgedfX",13) == 1140918350) strcat(s, "f");
if (crc32("XYAMVOS",7) == 1200148750) strcat(s, "n");
if (crc32("aRqcmU",6) == 1202481735) strcat(s, "y");
if (crc32("UxrEbLYBmHpIme",14) == 2899699737) strcat(s, "t");
if (crc32("YQLkNQrbJ",9) == 2219702268) strcat(s, "a");
if (crc32("qutehsYWPkd",11) == 2270400724) strcat(s, "e");
if (crc32("vrdcGjGY",8) == 1341997916) strcat(s, "E");
if (crc32("NFWLprmnDEqk",12) == 884533523) strcat(s, "r");
if (crc32("vIwTGhZF",8) == 2597750977) strcat(s, "i");
if (crc32("silnIrMHPXvbf",13) == 2598696613) strcat(s, "x");
if (crc32("rVIfI",5) == 3904542614) strcat(s, "c");
    return s;
}

char *labial_adjectives() {
    char *s = calloc(7);
    if (crc32("mwDriTm",7) == 2814192806) strcat(s, "l");
if (crc32("XIjWAyTw",8) == 2031101983) strcat(s, "a");
if (crc32("TmWkkfV",7) == 1839559078) strcat(s, "b");
if (crc32("SuWrprjkmbP",11) == 2339741162) strcat(s, "i");
if (crc32("wGXmYxHeC",9) == 3885874283) strcat(s, "a");
if (crc32("UubKJPp",7) == 2402966131) strcat(s, "l");
    return s;
}

char *nonearning_adjectives() {
    char *s = calloc(11);
    if (crc32("kwadNINKuroM",12) == 3704599067) strcat(s, "n");
if (crc32("tXnukOOkjqiSrnl",15) == 3265058824) strcat(s, "l");
if (crc32("rglmQB",6) == 3602381397) strcat(s, "o");
if (crc32("bbudtSbLA",9) == 373580526) strcat(s, "v");
if (crc32("QUNpNCjjrGIAc",13) == 4251925461) strcat(s, "n");
if (crc32("gLfwaRRQWxquLVM",15) == 1990964480) strcat(s, "e");
if (crc32("gjlAFmYocrEpC",13) == 2511465469) strcat(s, "a");
if (crc32("PUcnTXMzmHK",11) == 2027308366) strcat(s, "f");
if (crc32("ErnYrG",6) == 543216539) strcat(s, "r");
if (crc32("MbcyUBhC",8) == 1736890841) strcat(s, "R");
if (crc32("zPqWJpVYyXuWPGi",15) == 782894312) strcat(s, "n");
if (crc32("CbvPBJ",6) == 2907875765) strcat(s, "i");
if (crc32("ywkaJfObbszGUzC",15) == 2947024523) strcat(s, "q");
if (crc32("dNXAsLWLXxILwfb",15) == 1416950037) strcat(s, "n");
if (crc32("jRagHmEjBKBC",12) == 1429197337) strcat(s, "H");
if (crc32("MPJuYQiqMjdjMFR",15) == 3617018083) strcat(s, "g");
    return s;
}

char *apparent_adjectives() {
    char *s = calloc(9);
    if (crc32("wWbGaYNcCrPSR",13) == 1324674505) strcat(s, "a");
if (crc32("QDvbdUliWIWtkyW",15) == 1126497835) strcat(s, "a");
if (crc32("xiQxKZSf",8) == 313561734) strcat(s, "p");
if (crc32("EApMOopxyZdK",12) == 367644979) strcat(s, "I");
if (crc32("cyVqvKfPSxO",11) == 2440620946) strcat(s, "p");
if (crc32("biKQMnjQFWzTg",13) == 2688125228) strcat(s, "a");
if (crc32("qpFoaZzvk",9) == 3292208917) strcat(s, "X");
if (crc32("AHBGhLOdf",9) == 2992111372) strcat(s, "r");
if (crc32("OfSZig",6) == 3899188077) strcat(s, "E");
if (crc32("RrzbYnR",7) == 1358376706) strcat(s, "e");
if (crc32("GIkzXQMxCIOrOl",14) == 2932809687) strcat(s, "z");
if (crc32("qOfVRWzU",8) == 407066304) strcat(s, "n");
if (crc32("uynkCOXX",8) == 3251359399) strcat(s, "t");
    return s;
}

char *proFrench_adjectives() {
    char *s = calloc(10);
    if (crc32("eQOKCdqFKha",11) == 1699949970) strcat(s, "V");
if (crc32("qVmusKlfBjEFEAs",15) == 3983168568) strcat(s, "p");
if (crc32("WgOoiPCutWW",11) == 1883179737) strcat(s, "R");
if (crc32("bIVeiPhLyllFpQi",15) == 3881487542) strcat(s, "r");
if (crc32("LDpraXnfSQSRv",13) == 747419492) strcat(s, "l");
if (crc32("RbteFisF",8) == 3451779114) strcat(s, "o");
if (crc32("TTPEnPklQGpfp",13) == 1764827905) strcat(s, "r");
if (crc32("DbuFm",5) == 1029990849) strcat(s, "F");
if (crc32("XuVVYoU",7) == 154424273) strcat(s, "s");
if (crc32("nSygaLqk",8) == 2736749883) strcat(s, "r");
if (crc32("ZxxfpMPT",8) == 1121976767) strcat(s, "A");
if (crc32("CvrIKOqpZMhJJ",13) == 744751485) strcat(s, "e");
if (crc32("PShnsvqyUJADE",13) == 1252031019) strcat(s, "n");
if (crc32("YaMfKeYx",8) == 3954747783) strcat(s, "e");
if (crc32("MLJrXsEjdvUdSFr",15) == 1594077906) strcat(s, "c");
if (crc32("HzXIpB",6) == 2828589099) strcat(s, "z");
if (crc32("byaqnCLLXi",10) == 4280640317) strcat(s, "h");
    return s;
}

char *unadulterous_adjectives() {
    char *s = calloc(13);
    if (crc32("GlJsEVW",7) == 1425090880) strcat(s, "Q");
if (crc32("dVJtycZUvd",10) == 2507601829) strcat(s, "u");
if (crc32("jMeQj",5) == 258763945) strcat(s, "F");
if (crc32("MBGAINbFaog",11) == 1916454106) strcat(s, "n");
if (crc32("aBiMbXrXEtmAUU",14) == 2810431357) strcat(s, "F");
if (crc32("FAgzL",5) == 3575325902) strcat(s, "a");
if (crc32("KLfqGQaQQVoHzeA",15) == 2726131205) strcat(s, "z");
if (crc32("xGpcaKKA",8) == 2743602024) strcat(s, "d");
if (crc32("KiMBqhIbcBpGpI",14) == 333795460) strcat(s, "J");
if (crc32("xQwbae",6) == 2940567598) strcat(s, "u");
if (crc32("EsYsxg",6) == 2225549639) strcat(s, "l");
if (crc32("YBVQZH",6) == 3297698405) strcat(s, "W");
if (crc32("YwzkIma",7) == 4159583332) strcat(s, "t");
if (crc32("VHAkbLLUeJypwFL",15) == 3574137739) strcat(s, "u");
if (crc32("WqnMnF",6) == 2743168188) strcat(s, "e");
if (crc32("ANRlkgZXiEKz",12) == 3466296885) strcat(s, "v");
if (crc32("tMKZflGhSTyM",12) == 1702055924) strcat(s, "r");
if (crc32("XDulFP",6) == 738725421) strcat(s, "o");
if (crc32("PIKvvnZYk",9) == 1439112821) strcat(s, "j");
if (crc32("ldNjW",5) == 1052633781) strcat(s, "u");
if (crc32("omLMdeeFcdZnDG",14) == 1664492411) strcat(s, "s");
    return s;
}

char *unpaving_adjectives() {
    char *s = calloc(9);
    if (crc32("gogfpiLO",8) == 1474821107) strcat(s, "u");
if (crc32("xxikxzwMi",9) == 1140683902) strcat(s, "n");
if (crc32("CoPxDFUF",8) == 1123087934) strcat(s, "p");
if (crc32("whnMzGveOmTB",12) == 3028854584) strcat(s, "c");
if (crc32("RCZbQuK",7) == 2640242412) strcat(s, "a");
if (crc32("KdPOJZakT",9) == 643653507) strcat(s, "v");
if (crc32("xIHoHULRnGuoqOj",15) == 228522168) strcat(s, "s");
if (crc32("VZKoBiUrzUBmxZ",14) == 4106545332) strcat(s, "i");
if (crc32("OlshRUuIzbDmT",13) == 600768868) strcat(s, "n");
if (crc32("OTnhZBEMlGKyO",13) == 3468134854) strcat(s, "U");
if (crc32("XERXyetKroU",11) == 3297852645) strcat(s, "g");
    return s;
}

char *nonlugubrious_adjectives() {
    char *s = calloc(14);
    if (crc32("NydcLqVdF",9) == 171981111) strcat(s, "n");
if (crc32("gVLnUSuvQuQ",11) == 4235067938) strcat(s, "o");
if (crc32("ezbvWKTgHBu",11) == 4255685922) strcat(s, "M");
if (crc32("EnHxjv",6) == 3932417358) strcat(s, "n");
if (crc32("rdqpX",5) == 2439968353) strcat(s, "A");
if (crc32("WmSxggV",7) == 4217437615) strcat(s, "l");
if (crc32("KFacL",5) == 802229612) strcat(s, "u");
if (crc32("KbtjohqO",8) == 3138065758) strcat(s, "g");
if (crc32("lsoliGHfQHXi",12) == 183136239) strcat(s, "A");
if (crc32("gnDDwCKGepzJD",13) == 863637313) strcat(s, "u");
if (crc32("VyASgDHbgdiCh",13) == 3127526198) strcat(s, "Q");
if (crc32("ZNhcAhu",7) == 1398400273) strcat(s, "b");
if (crc32("wnWNV",5) == 3696623652) strcat(s, "K");
if (crc32("jIaHh",5) == 3244294710) strcat(s, "r");
if (crc32("iVuQH",5) == 905690451) strcat(s, "i");
if (crc32("RpcZwP",6) == 1258005982) strcat(s, "o");
if (crc32("GxDgiVNCugL",11) == 938940017) strcat(s, "b");
if (crc32("jxBOmbNQteBHhcX",15) == 609604783) strcat(s, "u");
if (crc32("zJYxIgjjCI",10) == 1832061606) strcat(s, "Q");
if (crc32("dOJWlmWBC",9) == 925677109) strcat(s, "s");
    return s;
}

char *hundredfold_adjectives() {
    char *s = calloc(12);
    if (crc32("SuTqSXHbhHeS",12) == 1241195111) strcat(s, "h");
if (crc32("GQeqgNEMpRA",11) == 964847873) strcat(s, "E");
if (crc32("LOXevTvFyUqiSBi",15) == 1499446034) strcat(s, "u");
if (crc32("URqPnPPsoqjT",12) == 86776418) strcat(s, "n");
if (crc32("sFwosWYUlvGPdjb",15) == 1697264483) strcat(s, "Q");
if (crc32("xpIAOEkhJLad",12) == 2585272936) strcat(s, "d");
if (crc32("xzjgrR",6) == 1690187535) strcat(s, "r");
if (crc32("vStFRdVAOXq",11) == 178119666) strcat(s, "V");
if (crc32("abchwsFkNFEoepO",15) == 2408529536) strcat(s, "e");
if (crc32("wLbvs",5) == 1042234235) strcat(s, "c");
if (crc32("CTVPQctvQlHsZ",13) == 1659257685) strcat(s, "d");
if (crc32("HBiNBvrGotLv",12) == 1695722411) strcat(s, "f");
if (crc32("cJfscmOnb",9) == 3835147772) strcat(s, "u");
if (crc32("JrlqjDptp",9) == 1207694903) strcat(s, "o");
if (crc32("IenbdfhZyNUsXc",14) == 1356770561) strcat(s, "l");
if (crc32("qdcxn",5) == 2980680942) strcat(s, "d");
    return s;
}

char *eudaemonistical_adjectives() {
    char *s = calloc(16);
    if (crc32("fnmcKlN",7) == 723913095) strcat(s, "e");
if (crc32("IXGnwUwiNEg",11) == 1331663035) strcat(s, "u");
if (crc32("fZpZoswVEbvZwt",14) == 2205597042) strcat(s, "d");
if (crc32("zwEzEVJFDhR",11) == 2120751544) strcat(s, "n");
if (crc32("lSZOSiZfVGu",11) == 3538243471) strcat(s, "a");
if (crc32("KCzOr",5) == 3744275005) strcat(s, "r");
if (crc32("jcjkxIgUQSgirI",14) == 4195066734) strcat(s, "e");
if (crc32("UfWUjFimKtY",11) == 1004573211) strcat(s, "m");
if (crc32("vIaEuR",6) == 2319933124) strcat(s, "v");
if (crc32("YpXilWQDrFMfk",13) == 312022286) strcat(s, "o");
if (crc32("AEAsrRaJVyw",11) == 112663644) strcat(s, "g");
if (crc32("CUxwMTmmBcgjtu",14) == 4234380583) strcat(s, "n");
if (crc32("vzBhEUMBjdWW",12) == 3789030013) strcat(s, "b");
if (crc32("ETqXh",5) == 1986430080) strcat(s, "i");
if (crc32("gSDikxigMK",10) == 745101062) strcat(s, "s");
if (crc32("sqWnPUkaBSHJMOC",15) == 3257837793) strcat(s, "t");
if (crc32("yvCjyifs",8) == 2823902451) strcat(s, "i");
if (crc32("AaGzzxiHLkSGu",13) == 4049375386) strcat(s, "l");
if (crc32("ApyMyE",6) == 438967936) strcat(s, "c");
if (crc32("xzSRpNa",7) == 4054730743) strcat(s, "w");
if (crc32("fhfVym",6) == 2108642543) strcat(s, "a");
if (crc32("YWAPOmbZLq",10) == 1851480929) strcat(s, "B");
if (crc32("CgxDHsITyF",10) == 3496363560) strcat(s, "l");
    return s;
}

char *subcreative_adjectives() {
    char *s = calloc(12);
    if (crc32("HlhEcPtb",8) == 171487349) strcat(s, "s");
if (crc32("ADKwFK",6) == 2356569510) strcat(s, "c");
if (crc32("pyceWuoEsT",10) == 2475695148) strcat(s, "u");
if (crc32("xzclF",5) == 392472988) strcat(s, "b");
if (crc32("EUXur",5) == 604912927) strcat(s, "c");
if (crc32("FUJiMFNszJeWXU",14) == 2893484772) strcat(s, "o");
if (crc32("XiMqRbEXuDwV",12) == 1937752390) strcat(s, "r");
if (crc32("oUpTjBbM",8) == 2744563045) strcat(s, "e");
if (crc32("EqolzlagoczI",12) == 473596158) strcat(s, "a");
if (crc32("zVOfDbsrV",9) == 2961765697) strcat(s, "F");
if (crc32("kKmgpLX",7) == 3684495383) strcat(s, "t");
if (crc32("kNobNuXYLFC",11) == 3583816314) strcat(s, "h");
if (crc32("hcyyHvFwunteYO",14) == 1943371997) strcat(s, "i");
if (crc32("ntPqpbZrbiAN",12) == 2597355584) strcat(s, "v");
if (crc32("djYXXtifwSKzD",13) == 652352044) strcat(s, "y");
if (crc32("IixDcgOlzoW",11) == 1194108134) strcat(s, "e");
    return s;
}

char *twofisted_adjectives() {
    char *s = calloc(10);
    if (crc32("UFtoneMd",8) == 1308872753) strcat(s, "t");
if (crc32("liJSlDEVbuGIB",13) == 3771284283) strcat(s, "w");
if (crc32("zFvzp",5) == 1862029895) strcat(s, "v");
if (crc32("UUPXH",5) == 2900064376) strcat(s, "o");
if (crc32("TpKolOqa",8) == 545026930) strcat(s, "f");
if (crc32("WvwRwUlNaJrpw",13) == 3329902460) strcat(s, "G");
if (crc32("OqjSpwOIVm",10) == 469468313) strcat(s, "i");
if (crc32("MWyhdL",6) == 2002858601) strcat(s, "i");
if (crc32("rxLICg",6) == 2558599056) strcat(s, "s");
if (crc32("HzoOHpVfmqzu",12) == 3280324415) strcat(s, "t");
if (crc32("krNYwQvdDouls",13) == 4109634625) strcat(s, "m");
if (crc32("lgKwmIgqyLgp",12) == 2211074725) strcat(s, "e");
if (crc32("FXPGEaiEn",9) == 1039562645) strcat(s, "h");
if (crc32("QodfPVkLwXjd",12) == 1137396237) strcat(s, "d");
    return s;
}

char *sheer_adjectives() {
    char *s = calloc(6);
    if (crc32("mSEoylLTxBT",11) == 338384161) strcat(s, "s");
if (crc32("LUykUlPBZW",10) == 1756249416) strcat(s, "h");
if (crc32("lPzjmrDiDMZEQM",14) == 218564717) strcat(s, "d");
if (crc32("BKiTwpwQB",9) == 2712276092) strcat(s, "e");
if (crc32("IwMvfiFCIY",10) == 2649163826) strcat(s, "e");
if (crc32("VhVnumiuVPNPlHs",15) == 2282100447) strcat(s, "I");
if (crc32("ARjkIuJBAmZEUF",14) == 1227747206) strcat(s, "r");
    return s;
}

char *limitable_adjectives() {
    char *s = calloc(10);
    if (crc32("IkqEnFS",7) == 2390823511) strcat(s, "x");
if (crc32("TGziBJysBLSX",12) == 257397548) strcat(s, "l");
if (crc32("CDItCRugtdTHzw",14) == 1089260559) strcat(s, "H");
if (crc32("gmqAcSCzBT",10) == 1883673759) strcat(s, "i");
if (crc32("cthXaBiRpJgEy",13) == 1076493326) strcat(s, "m");
if (crc32("VXGydFdZBWnoKR",14) == 3870957631) strcat(s, "H");
if (crc32("qwvxcIRVetpgzoN",15) == 2274161934) strcat(s, "i");
if (crc32("ymkovYrzNaHDEYg",15) == 4209157919) strcat(s, "t");
if (crc32("SxFsfjrAxADIMj",14) == 4122287764) strcat(s, "u");
if (crc32("hVYPXks",7) == 742816236) strcat(s, "a");
if (crc32("sfpWDQvPgrOwAyO",15) == 3981739645) strcat(s, "b");
if (crc32("fZXfqqPuqjb",11) == 634432228) strcat(s, "l");
if (crc32("lPmRGWrVl",9) == 3787901404) strcat(s, "e");
    return s;
}

char *subserrate_adjectives() {
    char *s = calloc(11);
    if (crc32("zSlGSGTwIDiG",12) == 1849450869) strcat(s, "s");
if (crc32("uqOCnRqjWgolip",14) == 1903586740) strcat(s, "q");
if (crc32("iGsNTptcjKT",11) == 183744789) strcat(s, "u");
if (crc32("VPeSVebRYqF",11) == 1724874829) strcat(s, "J");
if (crc32("XFRoipkbKxeA",12) == 3973028110) strcat(s, "b");
if (crc32("ttleRqzCICrK",12) == 1333590488) strcat(s, "s");
if (crc32("mEkotAAqb",9) == 990568671) strcat(s, "g");
if (crc32("yQvhvfzgr",9) == 3985917720) strcat(s, "e");
if (crc32("HsNcFqlfy",9) == 4214654760) strcat(s, "k");
if (crc32("spQGO",5) == 659164378) strcat(s, "r");
if (crc32("iDyvkt",6) == 2202914919) strcat(s, "V");
if (crc32("rkezvUaMdpVZuiD",15) == 669713639) strcat(s, "r");
if (crc32("iUxXu",5) == 3445364029) strcat(s, "v");
if (crc32("cemuAYinXt",10) == 3933868449) strcat(s, "a");
if (crc32("OKeXHtlL",8) == 951299334) strcat(s, "t");
if (crc32("TwjljPGXaxSHq",13) == 1323178983) strcat(s, "K");
if (crc32("MDdANFjH",8) == 2042753401) strcat(s, "e");
    return s;
}

char *imminent_adjectives() {
    char *s = calloc(9);
    if (crc32("kKKaVVOrfZXHaQX",15) == 2847650328) strcat(s, "W");
if (crc32("wEfoFppiupr",11) == 2998183640) strcat(s, "i");
if (crc32("ZEJHjNQdR",9) == 582691815) strcat(s, "m");
if (crc32("qPiVGOLDcNPNKc",14) == 2766440699) strcat(s, "Z");
if (crc32("APYzGXYLXxi",11) == 312694182) strcat(s, "m");
if (crc32("xuWiOOVZfco",11) == 3264165925) strcat(s, "g");
if (crc32("xbbOFsKqnTmXPe",14) == 1349826232) strcat(s, "i");
if (crc32("JJjnpetfctV",11) == 4283450117) strcat(s, "n");
if (crc32("zwAqOdrgQi",10) == 2966922168) strcat(s, "e");
if (crc32("WkFFXSYeZjV",11) == 2392169635) strcat(s, "n");
if (crc32("UIeiJh",6) == 3127098276) strcat(s, "t");
    return s;
}

char *unnefarious_adjectives() {
    char *s = calloc(12);
    if (crc32("hbCtg",5) == 1181452180) strcat(s, "z");
if (crc32("iytMZXjzqg",10) == 3536277671) strcat(s, "u");
if (crc32("nVqiKuypJhFU",12) == 3554755983) strcat(s, "n");
if (crc32("bcVPRzFoIaRYOR",14) == 2745732951) strcat(s, "L");
if (crc32("KsFWxg",6) == 2308176322) strcat(s, "n");
if (crc32("aXbnyIgGGVovLxP",15) == 3322466422) strcat(s, "K");
if (crc32("pigZhdNrenj",11) == 1367329171) strcat(s, "e");
if (crc32("xITYM",5) == 115820644) strcat(s, "h");
if (crc32("pCgPMFVWCpMgdhO",15) == 263553906) strcat(s, "f");
if (crc32("PxRIE",5) == 412027688) strcat(s, "a");
if (crc32("gdmhZUmriBbjfW",14) == 334412830) strcat(s, "r");
if (crc32("ZAdflyayTAaxwp",14) == 1439956748) strcat(s, "i");
if (crc32("QIhdTB",6) == 3568976949) strcat(s, "i");
if (crc32("OwkfSMSY",8) == 733646875) strcat(s, "v");
if (crc32("leCefHK",7) == 253536297) strcat(s, "o");
if (crc32("hrfTJF",6) == 916910754) strcat(s, "u");
if (crc32("YOsQLQunUbxAtvx",15) == 3558782944) strcat(s, "U");
if (crc32("VGkJbZkiRbhu",12) == 1899824144) strcat(s, "s");
    return s;
}

char *unaccumulable_adjectives() {
    char *s = calloc(14);
    if (crc32("DWSxuVnQujhG",12) == 3479715373) strcat(s, "u");
if (crc32("DXqsnINjynh",11) == 959603850) strcat(s, "e");
if (crc32("zMVxvJG",7) == 3443039471) strcat(s, "n");
if (crc32("ijsHFtUQlkcLIu",14) == 629259462) strcat(s, "j");
if (crc32("fNQAQfxaOMQ",11) == 3770802745) strcat(s, "a");
if (crc32("llgHO",5) == 2305443600) strcat(s, "F");
if (crc32("qJLTRuldlxTUW",13) == 314013124) strcat(s, "c");
if (crc32("HrqkIkGQubB",11) == 2772354301) strcat(s, "k");
if (crc32("lVJwGV",6) == 3783311206) strcat(s, "c");
if (crc32("kxeRs",5) == 2171736023) strcat(s, "e");
if (crc32("dJOHoN",6) == 4263191531) strcat(s, "u");
if (crc32("VdJfaTwCAW",10) == 2421575024) strcat(s, "m");
if (crc32("LiGkCWCtYWrzOb",14) == 2571622663) strcat(s, "Z");
if (crc32("mXfGD",5) == 736790645) strcat(s, "u");
if (crc32("TcOIuobkILquY",13) == 3884855174) strcat(s, "Q");
if (crc32("YHJrLS",6) == 4289916724) strcat(s, "l");
if (crc32("dbFiHjtfzbMqeE",14) == 834970726) strcat(s, "a");
if (crc32("HDmOh",5) == 2851877359) strcat(s, "b");
if (crc32("fIQTKZRyRb",10) == 92082544) strcat(s, "b");
if (crc32("cVXwBT",6) == 1506695417) strcat(s, "H");
if (crc32("GHUJUItMv",9) == 3221896931) strcat(s, "l");
if (crc32("uhuUl",5) == 3631245719) strcat(s, "e");
    return s;
}

char *galactoid_adjectives() {
    char *s = calloc(10);
    if (crc32("iUbEgqYGbjdDRZ",14) == 3449791162) strcat(s, "g");
if (crc32("UbYBigSI",8) == 2793696874) strcat(s, "s");
if (crc32("IbFGEVwRtCiNp",13) == 542198199) strcat(s, "a");
if (crc32("npYuJqsxf",9) == 3220449498) strcat(s, "F");
if (crc32("RZrfelFyi",9) == 1169679778) strcat(s, "l");
if (crc32("QBModltLszdJF",13) == 1951193700) strcat(s, "e");
if (crc32("QmzkOAx",7) == 1067181090) strcat(s, "a");
if (crc32("wkmyUmGfzsWYHA",14) == 2778316652) strcat(s, "c");
if (crc32("eGComCiduWW",11) == 3383926634) strcat(s, "t");
if (crc32("csAtNzNP",8) == 162323638) strcat(s, "o");
if (crc32("trJnMpgM",8) == 2706393562) strcat(s, "i");
if (crc32("zKcpeHTKmJUeaxO",15) == 686596487) strcat(s, "d");
    return s;
}

char *unmailed_adjectives() {
    char *s = calloc(9);
    if (crc32("vINjbBzVk",9) == 1395740208) strcat(s, "u");
if (crc32("YFcfaregPH",10) == 2120696012) strcat(s, "n");
if (crc32("EqabSR",6) == 2245546660) strcat(s, "o");
if (crc32("poaaZlhDVlrl",12) == 3725341136) strcat(s, "m");
if (crc32("RplXE",5) == 1679648961) strcat(s, "M");
if (crc32("GBdhT",5) == 2467361868) strcat(s, "a");
if (crc32("smelwxxRwzBB",12) == 3527171463) strcat(s, "N");
if (crc32("WBYlfoSIUipt",12) == 893721677) strcat(s, "i");
if (crc32("FrlcIqqrOF",10) == 1491797211) strcat(s, "Y");
if (crc32("TXWBgpKYG",9) == 1421200183) strcat(s, "l");
if (crc32("znXBAZAaLc",10) == 2541357877) strcat(s, "e");
if (crc32("OLflSpP",7) == 1223302635) strcat(s, "n");
if (crc32("rbQtPWvSml",10) == 3494698893) strcat(s, "d");
    return s;
}

char *nonreprehensible_adjectives() {
    char *s = calloc(17);
    if (crc32("VbOVanWXL",9) == 105601521) strcat(s, "n");
if (crc32("UDgDYcVWpZtuY",13) == 1500804575) strcat(s, "o");
if (crc32("jXnBbGcvvPB",11) == 663905052) strcat(s, "o");
if (crc32("nAoYhJ",6) == 3718907195) strcat(s, "n");
if (crc32("trqSd",5) == 2235330740) strcat(s, "r");
if (crc32("tdzBrxPotfriUvY",15) == 2821429962) strcat(s, "e");
if (crc32("RsGtSXSIIvDz",12) == 3528577144) strcat(s, "I");
if (crc32("bcVOVC",6) == 3170398740) strcat(s, "p");
if (crc32("DMDqoKuJTRkhs",13) == 3356852968) strcat(s, "r");
if (crc32("iZNyCsUxe",9) == 1017526763) strcat(s, "e");
if (crc32("FUoXYzEAdrwjRc",14) == 882782103) strcat(s, "t");
if (crc32("XyCbNwXcaQ",10) == 4101012981) strcat(s, "h");
if (crc32("evBdysi",7) == 1689426315) strcat(s, "e");
if (crc32("uqXgbSLIFu",10) == 3467267220) strcat(s, "n");
if (crc32("gcnAWm",6) == 1678288215) strcat(s, "i");
if (crc32("cfZvnQ",6) == 974029525) strcat(s, "s");
if (crc32("yLwpHkL",7) == 992051069) strcat(s, "i");
if (crc32("vlgdInvRiovV",12) == 1794922694) strcat(s, "R");
if (crc32("iMvxvzih",8) == 2078744272) strcat(s, "b");
if (crc32("GpofqkHYhk",10) == 3580842254) strcat(s, "L");
if (crc32("aqYOR",5) == 538581044) strcat(s, "l");
if (crc32("eQtxk",5) == 2319445061) strcat(s, "e");
    return s;
}

char *unincreased_adjectives() {
    char *s = calloc(12);
    if (crc32("MAOXWk",6) == 3844575088) strcat(s, "x");
if (crc32("SmTfHMHZDPdnmqI",15) == 2844081578) strcat(s, "u");
if (crc32("TAovUc",6) == 1181474448) strcat(s, "g");
if (crc32("FCktjZpUrmB",11) == 1325265149) strcat(s, "n");
if (crc32("vFagSQD",7) == 3906760004) strcat(s, "N");
if (crc32("BBlDL",5) == 2143213948) strcat(s, "i");
if (crc32("TCElMBJlHFNd",12) == 1415127270) strcat(s, "n");
if (crc32("KYUCJ",5) == 456579882) strcat(s, "O");
if (crc32("CQQRvHLDHlDgfUn",15) == 2655675999) strcat(s, "c");
if (crc32("WnKKfnIpyF",10) == 890776799) strcat(s, "r");
if (crc32("JqWUYIfMMNBeTkG",15) == 3802690638) strcat(s, "P");
if (crc32("MUBkXYDHnmU",11) == 368056683) strcat(s, "e");
if (crc32("EXmFZBMMgAkW",12) == 948019137) strcat(s, "a");
if (crc32("OFCkeeKTEiKA",12) == 3161948105) strcat(s, "s");
if (crc32("FRWhBBrbu",9) == 1635335757) strcat(s, "E");
if (crc32("HZXBpXhCfAFtP",13) == 1082437106) strcat(s, "e");
if (crc32("YDDYkf",6) == 4111662766) strcat(s, "I");
if (crc32("TerGVz",6) == 2682094301) strcat(s, "d");
    return s;
}

char *ruinable_adjectives() {
    char *s = calloc(9);
    if (crc32("qxeeYW",6) == 630534917) strcat(s, "Y");
if (crc32("AtYkrTDGwWbCVY",14) == 3585080253) strcat(s, "r");
if (crc32("IjPOVorsMtnpQb",14) == 1201030582) strcat(s, "u");
if (crc32("IFYwhnYAFGuI",12) == 961992559) strcat(s, "i");
if (crc32("AxTmK",5) == 1473381641) strcat(s, "n");
if (crc32("MCyJzfS",7) == 2697873438) strcat(s, "R");
if (crc32("jPEKWfLSLBBiBYG",15) == 254809381) strcat(s, "a");
if (crc32("EORxHLb",7) == 295130411) strcat(s, "Q");
if (crc32("WEHmyldcgnfUxB",14) == 4177094080) strcat(s, "b");
if (crc32("fPJCdIKSgm",10) == 3117377895) strcat(s, "Y");
if (crc32("ccMBTLPBbZhuFVp",15) == 2343760824) strcat(s, "l");
if (crc32("yhXgYbSkDOXNxT",14) == 1448156500) strcat(s, "e");
    return s;
}

char *unregistered_adjectives() {
    char *s = calloc(13);
    if (crc32("lvkOSMmnmh",10) == 1234469916) strcat(s, "R");
if (crc32("yXDIPdu",7) == 40643714) strcat(s, "u");
if (crc32("zsuRNVlQJ",9) == 3299250460) strcat(s, "W");
if (crc32("rBaObHVplBF",11) == 3545267385) strcat(s, "n");
if (crc32("QpPUixVxeqjkL",13) == 3469908404) strcat(s, "r");
if (crc32("CXbWGqg",7) == 567001716) strcat(s, "r");
if (crc32("jGUxwk",6) == 3998324831) strcat(s, "e");
if (crc32("SEZIvu",6) == 691670665) strcat(s, "g");
if (crc32("UrcIfwlz",8) == 4009479814) strcat(s, "i");
if (crc32("HdrOi",5) == 236958409) strcat(s, "s");
if (crc32("QfxqWiBkv",9) == 3901043273) strcat(s, "i");
if (crc32("aweNmxDFFRWGua",14) == 107946773) strcat(s, "t");
if (crc32("FtoupEXfDjvLgA",14) == 2419043378) strcat(s, "e");
if (crc32("qyZhL",5) == 2814547462) strcat(s, "r");
if (crc32("LeqlfSGIkIX",11) == 411709393) strcat(s, "O");
if (crc32("nKFmmITd",8) == 2095297134) strcat(s, "e");
if (crc32("ZyRsuR",6) == 2305260110) strcat(s, "W");
if (crc32("ooYglMEM",8) == 2639622997) strcat(s, "d");
    return s;
}

char *paracusic_adjectives() {
    char *s = calloc(10);
    if (crc32("yzvvcvIApwPDV",13) == 2121650331) strcat(s, "p");
if (crc32("XVoIBPFy",8) == 3724473149) strcat(s, "a");
if (crc32("TcdPwRJIfDgOA",13) == 3000590261) strcat(s, "r");
if (crc32("eQzsKyQUpyaPxgo",15) == 1552693749) strcat(s, "Z");
if (crc32("HmATSZ",6) == 1633588503) strcat(s, "a");
if (crc32("xuUfWOjzoQMi",12) == 3200971204) strcat(s, "q");
if (crc32("zvLiimHqHB",10) == 83649414) strcat(s, "c");
if (crc32("SZHQdIwp",8) == 518279957) strcat(s, "n");
if (crc32("DFmFRFXRaslL",12) == 235250103) strcat(s, "u");
if (crc32("JemrIo",6) == 2442521012) strcat(s, "Y");
if (crc32("OMmrrZFEIgI",11) == 4047928741) strcat(s, "s");
if (crc32("enYgdGrt",8) == 2915295532) strcat(s, "i");
if (crc32("ZFxsHflgwApst",13) == 3941956390) strcat(s, "y");
if (crc32("GCNNndxVhpUY",12) == 1929744445) strcat(s, "c");
    return s;
}

char *guidebookish_adjectives() {
    char *s = calloc(13);
    if (crc32("nupFCYy",7) == 3987106683) strcat(s, "I");
if (crc32("SWnyS",5) == 2711441862) strcat(s, "g");
if (crc32("kOnxHxqrwjglK",13) == 792225133) strcat(s, "u");
if (crc32("BffwNJkJcuTq",12) == 2042038117) strcat(s, "i");
if (crc32("UxXdpyOVQ",9) == 168594877) strcat(s, "O");
if (crc32("UmjdxuJcLIbiZ",13) == 155630079) strcat(s, "d");
if (crc32("AcIVQXKaeXxP",12) == 708608810) strcat(s, "B");
if (crc32("agKaI",5) == 3416827817) strcat(s, "e");
if (crc32("dRAPsExjnH",10) == 2396131837) strcat(s, "Y");
if (crc32("BtvsV",5) == 3593077225) strcat(s, "b");
if (crc32("vRnALrrjSwn",11) == 973960091) strcat(s, "s");
if (crc32("aEkBIisbje",10) == 1004130707) strcat(s, "o");
if (crc32("JuTeqiCK",8) == 188612500) strcat(s, "o");
if (crc32("uPUwg",5) == 3718255015) strcat(s, "o");
if (crc32("HtKniXVKMxIRm",13) == 1816489470) strcat(s, "k");
if (crc32("ZIfnugsjFA",10) == 424655361) strcat(s, "i");
if (crc32("jPGgSLyCWuRJb",13) == 519760616) strcat(s, "s");
if (crc32("eJRcRkxUauqzY",13) == 1498357571) strcat(s, "W");
if (crc32("UUlsW",5) == 2060620816) strcat(s, "h");
    return s;
}

char *matrilineal_adjectives() {
    char *s = calloc(12);
    if (crc32("fstFhnddgqTisks",15) == 2421212775) strcat(s, "n");
if (crc32("SeeASJJXFxwH",12) == 2382546705) strcat(s, "m");
if (crc32("sGRkETjkXFS",11) == 1577706047) strcat(s, "O");
if (crc32("WfCUgj",6) == 3526784431) strcat(s, "a");
if (crc32("efVoCi",6) == 341519410) strcat(s, "e");
if (crc32("WoUIF",5) == 4213702433) strcat(s, "t");
if (crc32("NnFmKxVGWYSfPZ",14) == 1413058510) strcat(s, "r");
if (crc32("oYNHrSw",7) == 452504171) strcat(s, "i");
if (crc32("tdzxXawzZAAIvt",14) == 3549484015) strcat(s, "i");
if (crc32("yKlVlXJNqJgl",12) == 3817143641) strcat(s, "l");
if (crc32("KsZtCFeWlGZgdB",14) == 54623809) strcat(s, "i");
if (crc32("HSdbAyFqhS",10) == 2441887564) strcat(s, "T");
if (crc32("GyuxccF",7) == 883590900) strcat(s, "n");
if (crc32("JFXhoGNnjbkQ",12) == 3432918949) strcat(s, "e");
if (crc32("gBfdh",5) == 1625671032) strcat(s, "b");
if (crc32("rrzXlRPXUSX",11) == 2039542434) strcat(s, "a");
if (crc32("INlKsG",6) == 2680408243) strcat(s, "l");
    return s;
}

char *uncoaxial_adjectives() {
    char *s = calloc(10);
    if (crc32("MXZpfofLHe",10) == 3467688023) strcat(s, "u");
if (crc32("XdPbHDLiUOvjx",13) == 486323718) strcat(s, "n");
if (crc32("YWQhk",5) == 314161107) strcat(s, "A");
if (crc32("JngKo",5) == 2357198951) strcat(s, "c");
if (crc32("mLkjLAfHgfESiYT",15) == 1367326976) strcat(s, "Z");
if (crc32("DAbcGYJ",7) == 2884173515) strcat(s, "o");
if (crc32("LoeVpL",6) == 3869682262) strcat(s, "a");
if (crc32("btawSglVwiNakSJ",15) == 3703003793) strcat(s, "W");
if (crc32("XpGkewvoQAmposf",15) == 4068811230) strcat(s, "x");
if (crc32("XkBnTTNZ",8) == 3294398902) strcat(s, "i");
if (crc32("VCkQMmz",7) == 3510093553) strcat(s, "a");
if (crc32("pyooWvU",7) == 891803398) strcat(s, "e");
if (crc32("fuVAsnUPAqztz",13) == 2569089588) strcat(s, "l");
    return s;
}

char *unacoustic_adjectives() {
    char *s = calloc(11);
    if (crc32("vPxBqV",6) == 4262398105) strcat(s, "M");
if (crc32("XBXAuiUtMoUA",12) == 3938518568) strcat(s, "u");
if (crc32("QCPSasSHx",9) == 1487006238) strcat(s, "n");
if (crc32("xQKIZN",6) == 2981001294) strcat(s, "a");
if (crc32("QzjYruFFKKaDBCS",15) == 1885115026) strcat(s, "c");
if (crc32("efpovSOXHHU",11) == 3808773616) strcat(s, "o");
if (crc32("ZVedHTbEPFY",11) == 1881307735) strcat(s, "u");
if (crc32("NcGQWTnOXMZieNe",15) == 1760428153) strcat(s, "s");
if (crc32("xeoDo",5) == 2105924410) strcat(s, "o");
if (crc32("dNWJMCrNDI",10) == 519849154) strcat(s, "t");
if (crc32("qejmoElY",8) == 3664828256) strcat(s, "i");
if (crc32("GYwjq",5) == 1223559316) strcat(s, "Y");
if (crc32("DVYifvam",8) == 914847950) strcat(s, "c");
    return s;
}

char *viewiest_adjectives() {
    char *s = calloc(9);
    if (crc32("iZCWkCxchOQuBO",14) == 3872200723) strcat(s, "v");
if (crc32("JcayB",5) == 3536366604) strcat(s, "i");
if (crc32("jnbPyy",6) == 337141420) strcat(s, "e");
if (crc32("SvruPChCwQ",10) == 2756556978) strcat(s, "h");
if (crc32("ntTTOSFpU",9) == 1493505180) strcat(s, "w");
if (crc32("AnMPDznsigziACz",15) == 996856936) strcat(s, "w");
if (crc32("VedDED",6) == 95406581) strcat(s, "i");
if (crc32("JsbgLcjeafHB",12) == 3080225561) strcat(s, "r");
if (crc32("wUuQfMao",8) == 723676058) strcat(s, "e");
if (crc32("QmNrMLfpCBnJDxO",15) == 3711018066) strcat(s, "s");
if (crc32("ycghIwHFV",9) == 3077724931) strcat(s, "t");
    return s;
}

char *luckier_adjectives() {
    char *s = calloc(8);
    if (crc32("vyrFkeJJ",8) == 3641746797) strcat(s, "l");
if (crc32("ZzGgaNwwVfC",11) == 1476677801) strcat(s, "N");
if (crc32("pECkRux",7) == 3192604786) strcat(s, "u");
if (crc32("wkCylmbOjwTQwcj",15) == 4193924896) strcat(s, "c");
if (crc32("MUJUyLnFObgJX",13) == 1985400659) strcat(s, "C");
if (crc32("OmCRzg",6) == 3471950444) strcat(s, "k");
if (crc32("LEHXouEo",8) == 104853630) strcat(s, "w");
if (crc32("IASJdT",6) == 891558122) strcat(s, "i");
if (crc32("VoyxBwzYFLgiIqx",15) == 1457148580) strcat(s, "i");
if (crc32("TRAlfRgo",8) == 503728870) strcat(s, "e");
if (crc32("ORrLve",6) == 4044673701) strcat(s, "r");
    return s;
}

char *unblended_adjectives() {
    char *s = calloc(10);
    if (crc32("qXCrHcHXLTv",11) == 1980570014) strcat(s, "u");
if (crc32("erstHZawnhTS",12) == 2572457776) strcat(s, "n");
if (crc32("NugXZrx",7) == 3588261924) strcat(s, "b");
if (crc32("MaWvjgeXjutysH",14) == 4210418904) strcat(s, "p");
if (crc32("tlZJbLvzS",9) == 2694507016) strcat(s, "l");
if (crc32("zewbFWHFIYzb",12) == 1007552632) strcat(s, "e");
if (crc32("fSrmFsCTOq",10) == 2542587116) strcat(s, "V");
if (crc32("pTFgB",5) == 3186008969) strcat(s, "n");
if (crc32("ZCdtl",5) == 1831020542) strcat(s, "l");
if (crc32("UmfEvfQK",8) == 2627438671) strcat(s, "d");
if (crc32("HkGBwgo",7) == 4186226330) strcat(s, "T");
if (crc32("HnMFfbgy",8) == 1994196667) strcat(s, "e");
if (crc32("rbHJIKreZNk",11) == 731643407) strcat(s, "d");
    return s;
}

char *excrementitious_adjectives() {
    char *s = calloc(16);
    if (crc32("lJaJHWgVjNfn",12) == 510229601) strcat(s, "e");
if (crc32("vSGBGeL",7) == 1362451909) strcat(s, "x");
if (crc32("hYBmTOuFPMAo",12) == 1664966457) strcat(s, "H");
if (crc32("mxcJpRVVtpIMerc",15) == 2689390397) strcat(s, "c");
if (crc32("jgwcNc",6) == 898079223) strcat(s, "r");
if (crc32("oWXwlxaMoNDeceX",15) == 1132008794) strcat(s, "t");
if (crc32("sRuwrwfs",8) == 2307517260) strcat(s, "e");
if (crc32("lrGOqSjsIU",10) == 3762573977) strcat(s, "m");
if (crc32("cTvIDXosRUFj",12) == 2626035770) strcat(s, "U");
if (crc32("ABNIj",5) == 1685375634) strcat(s, "e");
if (crc32("DFwxiJaZGbY",11) == 4116931176) strcat(s, "n");
if (crc32("mJMCMKAsAxYREBb",15) == 1997246801) strcat(s, "t");
if (crc32("CzkroOiYTzLRR",13) == 3149269711) strcat(s, "t");
if (crc32("OKpgeWIf",8) == 331515666) strcat(s, "i");
if (crc32("UYcUwFHbSW",10) == 1810372234) strcat(s, "k");
if (crc32("HzjKiFUQZcR",11) == 3039748727) strcat(s, "t");
if (crc32("RvuGY",5) == 1374011390) strcat(s, "R");
if (crc32("JZlzmfx",7) == 2771675440) strcat(s, "i");
if (crc32("TaEizTu",7) == 4173156848) strcat(s, "o");
if (crc32("pwyAq",5) == 1549329350) strcat(s, "u");
if (crc32("oiDddGYJp",9) == 783193422) strcat(s, "E");
if (crc32("nIfon",5) == 34186531) strcat(s, "s");
    return s;
}

char *seducible_adjectives() {
    char *s = calloc(10);
    if (crc32("FZBohNNOEK",10) == 4001202257) strcat(s, "s");
if (crc32("rUgIuE",6) == 3910508868) strcat(s, "Q");
if (crc32("DNwHyIJsmb",10) == 465938769) strcat(s, "e");
if (crc32("MJrguBAtMxyx",12) == 1200451081) strcat(s, "d");
if (crc32("LysFoppbko",10) == 3994960831) strcat(s, "P");
if (crc32("TrnEoW",6) == 520955081) strcat(s, "u");
if (crc32("eZGFMTaGcgop",12) == 1581205089) strcat(s, "j");
if (crc32("ootgGKTJ",8) == 2556725123) strcat(s, "c");
if (crc32("hyDTGQbsbHMcFy",14) == 2146955610) strcat(s, "i");
if (crc32("nKzEhAXbXJ",10) == 2071309814) strcat(s, "b");
if (crc32("EMLEBvmf",8) == 3706277796) strcat(s, "l");
if (crc32("WqYjiN",6) == 727827177) strcat(s, "W");
if (crc32("UZNJcR",6) == 1381089321) strcat(s, "e");
    return s;
}

char *nonfugitive_adjectives() {
    char *s = calloc(12);
    if (crc32("WWhRU",5) == 3481523176) strcat(s, "n");
if (crc32("CxiHvYa",7) == 3301767657) strcat(s, "o");
if (crc32("HtsiypRwjy",10) == 1310691174) strcat(s, "T");
if (crc32("DoDthcftaEr",11) == 949520650) strcat(s, "n");
if (crc32("NfVTuBfznJSMEQ",14) == 1075021380) strcat(s, "f");
if (crc32("NurCLhxVtyVSP",13) == 2439307311) strcat(s, "u");
if (crc32("KwbuAwzfnSkOex",14) == 4279628294) strcat(s, "g");
if (crc32("DbcdyhmgnQwj",12) == 2499253986) strcat(s, "i");
if (crc32("pcoHHXFH",8) == 1664571591) strcat(s, "u");
if (crc32("yjkjWWSq",8) == 3254228511) strcat(s, "t");
if (crc32("kCGpuyj",7) == 2753559905) strcat(s, "F");
if (crc32("LxdMdSW",7) == 3611146126) strcat(s, "i");
if (crc32("exNNRHZvyLVFiD",14) == 427458866) strcat(s, "v");
if (crc32("lJhiKjQWo",9) == 2907411382) strcat(s, "r");
if (crc32("PknmkbT",7) == 1284216747) strcat(s, "e");
    return s;
}

char *filamentary_adjectives() {
    char *s = calloc(12);
    if (crc32("dSFPSsBsKmMm",12) == 3492722853) strcat(s, "f");
if (crc32("MpouiRqoUjZuEDe",15) == 3474253312) strcat(s, "i");
if (crc32("lQLETAUkYqb",11) == 1649039811) strcat(s, "c");
if (crc32("ABzhszlj",8) == 347678072) strcat(s, "l");
if (crc32("CPHIpOgwfbGDgm",14) == 3935636791) strcat(s, "Z");
if (crc32("ntMhtmdzsXjYrV",14) == 3414032546) strcat(s, "a");
if (crc32("DAdJNOHxH",9) == 2493943117) strcat(s, "m");
if (crc32("lINJP",5) == 1728392279) strcat(s, "e");
if (crc32("zwyuiSIc",8) == 4033062074) strcat(s, "U");
if (crc32("CfeRTIYZz",9) == 926682769) strcat(s, "n");
if (crc32("mkZmI",5) == 2523374154) strcat(s, "y");
if (crc32("fYmrOFbyowhfC",13) == 3232601429) strcat(s, "t");
if (crc32("IPunl",5) == 3045852006) strcat(s, "a");
if (crc32("focDhJJJXQfpm",13) == 2670274163) strcat(s, "r");
if (crc32("CemXaQMSiJl",11) == 1060604133) strcat(s, "C");
if (crc32("EMpxOhEawlb",11) == 1458394195) strcat(s, "y");
    return s;
}

char *unrepudiative_adjectives() {
    char *s = calloc(14);
    if (crc32("mzeNbrwAzO",10) == 1513541251) strcat(s, "z");
if (crc32("HkuzTo",6) == 3128309327) strcat(s, "u");
if (crc32("gNSoIFwnhbJkyLc",15) == 3992614249) strcat(s, "p");
if (crc32("GDTkhlx",7) == 2028962503) strcat(s, "n");
if (crc32("zhleJsnqCQQJvZN",15) == 853138952) strcat(s, "r");
if (crc32("ccASGEAUzKOClfF",15) == 3669703433) strcat(s, "I");
if (crc32("AiAyoRQG",8) == 3919112950) strcat(s, "e");
if (crc32("vsxXE",5) == 3876370091) strcat(s, "p");
if (crc32("MsMcKddRbk",10) == 912845369) strcat(s, "B");
if (crc32("AKfym",5) == 1845506320) strcat(s, "u");
if (crc32("qZGMW",5) == 1663942654) strcat(s, "d");
if (crc32("jPGvM",5) == 3425533725) strcat(s, "H");
if (crc32("JTcqXL",6) == 2738512335) strcat(s, "i");
if (crc32("VLktcEzBzAcJxtS",15) == 1823797421) strcat(s, "W");
if (crc32("ioUofeeQUKLqg",13) == 2087449176) strcat(s, "a");
if (crc32("VaDhQl",6) == 2052128800) strcat(s, "t");
if (crc32("taaYYQxEougxXt",14) == 1653081001) strcat(s, "M");
if (crc32("pyluLOjeVnD",11) == 2168454850) strcat(s, "i");
if (crc32("iXsAEw",6) == 2666400692) strcat(s, "M");
if (crc32("usrmEwZqWgHhYC",14) == 797026807) strcat(s, "v");
if (crc32("wTGrhFuZakXt",12) == 2933428659) strcat(s, "e");
    return s;
}

char *vaticinal_adjectives() {
    char *s = calloc(10);
    if (crc32("dyFYaVbLkjMJhs",14) == 1256507643) strcat(s, "v");
if (crc32("BnWRXc",6) == 1248586131) strcat(s, "a");
if (crc32("CwiYaslKVeLWcK",14) == 927271995) strcat(s, "t");
if (crc32("ElozvjM",7) == 2668738415) strcat(s, "X");
if (crc32("aaZaxq",6) == 4219068196) strcat(s, "i");
if (crc32("WgzJqjCCifAKw",13) == 3461692340) strcat(s, "c");
if (crc32("ISlpIxfL",8) == 1561027378) strcat(s, "e");
if (crc32("BBCHrrMBajpYc",13) == 2158773986) strcat(s, "i");
if (crc32("lGPRp",5) == 672624015) strcat(s, "n");
if (crc32("QoGDOJtevde",11) == 2506099742) strcat(s, "a");
if (crc32("pAzkUpI",7) == 93162424) strcat(s, "G");
if (crc32("NhQjPazcDLsNFT",14) == 2943348017) strcat(s, "l");
    return s;
}

char *halfbound_adjectives() {
    char *s = calloc(10);
    if (crc32("YTTeuMYxeX",10) == 3951457438) strcat(s, "h");
if (crc32("hZCpEwPzqd",10) == 4157780055) strcat(s, "B");
if (crc32("CViTt",5) == 4188952608) strcat(s, "a");
if (crc32("Ctyri",5) == 1332441880) strcat(s, "l");
if (crc32("ixpycWgedMlBrm",14) == 2185483481) strcat(s, "f");
if (crc32("MTEnSz",6) == 5376394) strcat(s, "b");
if (crc32("QpDridOXTLr",11) == 2580990124) strcat(s, "o");
if (crc32("TYExbijEevoW",12) == 692405499) strcat(s, "l");
if (crc32("QNlZpuV",7) == 1365193417) strcat(s, "u");
if (crc32("ZwaGwH",6) == 442759070) strcat(s, "I");
if (crc32("qKYZWWcmEaDGxw",14) == 2369871198) strcat(s, "n");
if (crc32("sFPWfOWPzMgMlA",14) == 2319298262) strcat(s, "d");
    return s;
}

char *pisiform_adjectives() {
    char *s = calloc(9);
    if (crc32("yQcGMjweJScNhv",14) == 1990470963) strcat(s, "K");
if (crc32("EmgspIZauR",10) == 1439851830) strcat(s, "p");
if (crc32("irwuFBm",7) == 694272352) strcat(s, "f");
if (crc32("vutsZ",5) == 805691535) strcat(s, "i");
if (crc32("pVumGidQVVHeV",13) == 3186102063) strcat(s, "s");
if (crc32("XBpMroMVym",10) == 1946506017) strcat(s, "u");
if (crc32("keoWHTVoOov",11) == 3886882387) strcat(s, "i");
if (crc32("ABSeuv",6) == 729777022) strcat(s, "f");
if (crc32("iMoZAqT",7) == 2754411021) strcat(s, "o");
if (crc32("KvnyWfzG",8) == 3300088298) strcat(s, "U");
if (crc32("KGxFPUJyQL",10) == 3899912941) strcat(s, "r");
if (crc32("eqlIK",5) == 189086343) strcat(s, "e");
if (crc32("ZmDGwGclsHMy",12) == 2246932789) strcat(s, "m");
    return s;
}

char *templed_adjectives() {
    char *s = calloc(8);
    if (crc32("EoihQR",6) == 3541738556) strcat(s, "t");
if (crc32("NMKJw",5) == 4037521636) strcat(s, "e");
if (crc32("AKCnZffCzANzjnR",15) == 1631127417) strcat(s, "r");
if (crc32("YKEGymaiChXQEH",14) == 1179556682) strcat(s, "m");
if (crc32("uyjIElopmifd",12) == 134463578) strcat(s, "T");
if (crc32("gDgHplouasLazY",14) == 2888898771) strcat(s, "p");
if (crc32("KzrKCs",6) == 3365836052) strcat(s, "l");
if (crc32("sikNsIA",7) == 2364109131) strcat(s, "e");
if (crc32("rWfbRkKwbDwnHD",14) == 399005693) strcat(s, "x");
if (crc32("nYDbmrlIkK",10) == 493830632) strcat(s, "d");
    return s;
}

char *measurable_adjectives() {
    char *s = calloc(11);
    if (crc32("mqBobzejQhuqruj",15) == 3981490904) strcat(s, "c");
if (crc32("RKByapCAxDdv",12) == 3844772020) strcat(s, "m");
if (crc32("sazNvLXZ",8) == 2608980814) strcat(s, "a");
if (crc32("XpzEQAP",7) == 1990938169) strcat(s, "e");
if (crc32("fWGuJ",5) == 924777619) strcat(s, "a");
if (crc32("pdhfiOwXdSwk",12) == 1209899462) strcat(s, "Q");
if (crc32("BLwNRwBFETpYlg",14) == 1732104900) strcat(s, "s");
if (crc32("EDVDYvVZeGjL",12) == 958428214) strcat(s, "x");
if (crc32("CVqLIQ",6) == 411682169) strcat(s, "u");
if (crc32("yyZabfobvVPWnpS",15) == 3937070217) strcat(s, "H");
if (crc32("VKaxFhOUhOeGhHH",15) == 1930893571) strcat(s, "r");
if (crc32("ZlRKcBbLzuFDcPj",15) == 1689475111) strcat(s, "Y");
if (crc32("mRayHKzQCiRLeVB",15) == 3237389461) strcat(s, "a");
if (crc32("ahUlQxyr",8) == 2820603206) strcat(s, "b");
if (crc32("tfHEo",5) == 1773931361) strcat(s, "M");
if (crc32("qcpaQ",5) == 527971675) strcat(s, "l");
if (crc32("mvrDsV",6) == 2623833641) strcat(s, "y");
if (crc32("HsgiKtJLxwIkLo",14) == 2886336019) strcat(s, "e");
    return s;
}

char *Louisianian_adjectives() {
    char *s = calloc(12);
    if (crc32("KZxhZyGvag",10) == 49871619) strcat(s, "L");
if (crc32("EKeAGVbklilov",13) == 3915293722) strcat(s, "L");
if (crc32("uRRhGV",6) == 2987315656) strcat(s, "o");
if (crc32("dGQJNjtEBvPPdrT",15) == 2569467351) strcat(s, "c");
if (crc32("AhKUKdOLLDwEm",13) == 1327274419) strcat(s, "u");
if (crc32("ZRsSc",5) == 3491926943) strcat(s, "L");
if (crc32("fyYKcRiOYNWp",12) == 1453049640) strcat(s, "i");
if (crc32("bZelBzrxn",9) == 3404379823) strcat(s, "s");
if (crc32("MSRKQ",5) == 3743467227) strcat(s, "i");
if (crc32("ECQZsUMz",8) == 574044799) strcat(s, "a");
if (crc32("boBnrlVnfOqxR",13) == 3007883716) strcat(s, "n");
if (crc32("yZCOSuhSUOFnEeN",15) == 2705966984) strcat(s, "i");
if (crc32("fTdWH",5) == 1444711624) strcat(s, "a");
if (crc32("oaBAEzvVWyCWe",13) == 2958881221) strcat(s, "n");
    return s;
}

char *Aesculapian_adjectives() {
    char *s = calloc(12);
    if (crc32("jMLdFOleleiF",12) == 1180478901) strcat(s, "A");
if (crc32("XbXAcbRKXBfaUSW",15) == 3930295485) strcat(s, "V");
if (crc32("krXhWoYKJPd",11) == 3420800358) strcat(s, "e");
if (crc32("rpfiVhQbBye",11) == 1536694903) strcat(s, "s");
if (crc32("OcisjkPgFrv",11) == 3315044470) strcat(s, "c");
if (crc32("RvMWIAop",8) == 3779605182) strcat(s, "u");
if (crc32("CgttniPtoVgfgtx",15) == 121609014) strcat(s, "l");
if (crc32("oXZMdQMcStQmqwF",15) == 1796177940) strcat(s, "a");
if (crc32("rhUjdkqFak",10) == 3088592843) strcat(s, "p");
if (crc32("QDPmvUEyh",9) == 4174182078) strcat(s, "i");
if (crc32("pgiSXrGUQQaEdd",14) == 2336839715) strcat(s, "r");
if (crc32("EsTBdPlMwArlue",14) == 920615882) strcat(s, "a");
if (crc32("jNGCEZoK",8) == 2184762537) strcat(s, "a");
if (crc32("EmCeONpupH",10) == 1062830287) strcat(s, "n");
    return s;
}

char *unlying_adjectives() {
    char *s = calloc(8);
    if (crc32("BRgGtWon",8) == 2150853909) strcat(s, "u");
if (crc32("glgIGTBKkIhbF",13) == 288767778) strcat(s, "n");
if (crc32("JcQTxNu",7) == 2786863331) strcat(s, "l");
if (crc32("AXajeuMc",8) == 1780432860) strcat(s, "P");
if (crc32("ZTrVYykaZT",10) == 2589003338) strcat(s, "y");
if (crc32("BZXJaApPqln",11) == 1881909660) strcat(s, "A");
if (crc32("ncujLzNQUdCCQA",14) == 438247567) strcat(s, "i");
if (crc32("wySBU",5) == 3909685418) strcat(s, "X");
if (crc32("fkJRwVMA",8) == 3436335490) strcat(s, "n");
if (crc32("GtnoroVo",8) == 2656188143) strcat(s, "g");
if (crc32("awpTgd",6) == 1500594002) strcat(s, "g");
    return s;
}

char *nongratuitous_adjectives() {
    char *s = calloc(14);
    if (crc32("RtIUQmJKsXV",11) == 338082053) strcat(s, "c");
if (crc32("PRNwPHZok",9) == 3201714681) strcat(s, "n");
if (crc32("eKQFxzsirHtNNb",14) == 3677760154) strcat(s, "o");
if (crc32("ddPQwCRVlrYeGw",14) == 1925618691) strcat(s, "v");
if (crc32("qsQAFYfShNJ",11) == 3035430466) strcat(s, "n");
if (crc32("bdNrD",5) == 2267581779) strcat(s, "g");
if (crc32("INckQuVTGMZY",12) == 2163050218) strcat(s, "Q");
if (crc32("GeUPSPwrXeh",11) == 1675764702) strcat(s, "r");
if (crc32("LiDdMfC",7) == 2352726692) strcat(s, "a");
if (crc32("iqBcOlLe",8) == 187244629) strcat(s, "g");
if (crc32("leuAAvtyT",9) == 1422260195) strcat(s, "t");
if (crc32("iJvAjhEpplp",11) == 3955081511) strcat(s, "D");
if (crc32("UWlKOq",6) == 980292550) strcat(s, "u");
if (crc32("dHacfkA",7) == 1205292385) strcat(s, "i");
if (crc32("srPlTdt",7) == 1923720088) strcat(s, "t");
if (crc32("aXfbWMoWhna",11) == 1923806515) strcat(s, "o");
if (crc32("mdaZoVX",7) == 4172480251) strcat(s, "p");
if (crc32("XYrumIIS",8) == 1202337176) strcat(s, "u");
if (crc32("YLjTNqcNEKpYjD",14) == 3463399420) strcat(s, "s");
    return s;
}

char *anticipant_adjectives() {
    char *s = calloc(11);
    if (crc32("vIIuAootdmQ",11) == 3997052159) strcat(s, "a");
if (crc32("JnwswtpAs",9) == 371582343) strcat(s, "c");
if (crc32("wjjwGbkZvI",10) == 1550863778) strcat(s, "n");
if (crc32("wOFirvWXMiG",11) == 1918586407) strcat(s, "a");
if (crc32("mIpFmD",6) == 4001449618) strcat(s, "t");
if (crc32("sGGGykD",7) == 305770491) strcat(s, "i");
if (crc32("zmhvOym",7) == 808491764) strcat(s, "c");
if (crc32("jOJyDIbtJwRn",12) == 615706165) strcat(s, "H");
if (crc32("OZisCILBAzRlLAZ",15) == 2022668740) strcat(s, "i");
if (crc32("OuGDWYeFiuzNEve",15) == 2263961951) strcat(s, "p");
if (crc32("ZVxZleqibqUU",12) == 758595978) strcat(s, "a");
if (crc32("opnYfQvR",8) == 69712087) strcat(s, "v");
if (crc32("VtdICCotUeKdVxb",15) == 3838628095) strcat(s, "n");
if (crc32("jgLrltrSIZOV",12) == 3577152417) strcat(s, "o");
if (crc32("pLUmJzqro",9) == 787070855) strcat(s, "t");
    return s;
}

char *parasynthetic_adjectives() {
    char *s = calloc(14);
    if (crc32("ATUcKzIY",8) == 4079053761) strcat(s, "p");
if (crc32("Uzkhcmmwm",9) == 2330361859) strcat(s, "a");
if (crc32("sMPeKFRXtlt",11) == 2481308849) strcat(s, "r");
if (crc32("DFhmdU",6) == 1454753911) strcat(s, "a");
if (crc32("ZMQosqKy",8) == 1313164627) strcat(s, "s");
if (crc32("PHqEMt",6) == 3397517141) strcat(s, "h");
if (crc32("qnAdZfWMK",9) == 342732000) strcat(s, "y");
if (crc32("LYiauZCmtcp",11) == 1041936956) strcat(s, "r");
if (crc32("JsAvX",5) == 3227932870) strcat(s, "n");
if (crc32("FvCmogbQqHcD",12) == 3403530382) strcat(s, "J");
if (crc32("EsZSeTEeEAoyJW",14) == 2046211240) strcat(s, "t");
if (crc32("eeSCRIUmifprA",13) == 1429595698) strcat(s, "h");
if (crc32("aNqcKuHWV",9) == 801123617) strcat(s, "e");
if (crc32("IbLFawop",8) == 1311160907) strcat(s, "Z");
if (crc32("MPevUrjAUBItH",13) == 2751031642) strcat(s, "t");
if (crc32("FdPJf",5) == 2137713542) strcat(s, "P");
if (crc32("cEvMYsbqHZF",11) == 1105943950) strcat(s, "i");
if (crc32("NcfIpH",6) == 2069408966) strcat(s, "u");
if (crc32("reJzeGBNqbwL",12) == 1157803782) strcat(s, "c");
    return s;
}

char *osteoid_adjectives() {
    char *s = calloc(8);
    if (crc32("bXVBWvRWZsbFMN",14) == 1526295948) strcat(s, "x");
if (crc32("sOSKsb",6) == 3826186616) strcat(s, "o");
if (crc32("fXSXdd",6) == 2538937672) strcat(s, "s");
if (crc32("IomDQGGGyNe",11) == 2507733782) strcat(s, "t");
if (crc32("GjJrPc",6) == 3183582538) strcat(s, "e");
if (crc32("RfKUVSaIpONW",12) == 3512239608) strcat(s, "o");
if (crc32("xlkZNFhNUZRxY",13) == 2359054502) strcat(s, "L");
if (crc32("UFbDf",5) == 4080656741) strcat(s, "i");
if (crc32("JeDePE",6) == 3495960497) strcat(s, "j");
if (crc32("sAJGQtEyGjxUI",13) == 2957428382) strcat(s, "d");
    return s;
}

char *pliable_adjectives() {
    char *s = calloc(8);
    if (crc32("VAgIZzsOYmlxPMQ",15) == 938239992) strcat(s, "a");
if (crc32("eqQnH",5) == 2859729877) strcat(s, "p");
if (crc32("rLXnwmWiNPWTFtJ",15) == 2304570852) strcat(s, "z");
if (crc32("eXybIjNcIyB",11) == 2176936317) strcat(s, "l");
if (crc32("IoUOIvXr",8) == 222959628) strcat(s, "R");
if (crc32("QaVMzevS",8) == 1782745983) strcat(s, "i");
if (crc32("gbPcvrtcefEDDT",14) == 1540962258) strcat(s, "Q");
if (crc32("fEkDAt",6) == 3670148258) strcat(s, "a");
if (crc32("eRZtjMievrx",11) == 3886826504) strcat(s, "W");
if (crc32("oaggqqMC",8) == 1400461932) strcat(s, "b");
if (crc32("FMmJkRNXh",9) == 3209201223) strcat(s, "H");
if (crc32("diyNt",5) == 2383157864) strcat(s, "l");
if (crc32("WMJuDK",6) == 3550610927) strcat(s, "e");
    return s;
}

char *jiglike_adjectives() {
    char *s = calloc(8);
    if (crc32("nqmMdV",6) == 1464862252) strcat(s, "b");
if (crc32("tdhdqmECG",9) == 2090337927) strcat(s, "j");
if (crc32("pRdlokjFeWvriC",14) == 528987819) strcat(s, "H");
if (crc32("cuZNhJxiy",9) == 1330597781) strcat(s, "i");
if (crc32("JHzFsO",6) == 563975395) strcat(s, "k");
if (crc32("NKSoumCDjAqR",12) == 989590385) strcat(s, "g");
if (crc32("XGxAVSz",7) == 1014370971) strcat(s, "l");
if (crc32("gdIDIutLwhdT",12) == 3473955674) strcat(s, "w");
if (crc32("ODorLndETRopGDb",15) == 657737039) strcat(s, "i");
if (crc32("AjIVMnZQdeoMvdc",15) == 1877988916) strcat(s, "k");
if (crc32("UnmymC",6) == 1995934116) strcat(s, "a");
if (crc32("RRRUxPLOts",10) == 2467861555) strcat(s, "e");
    return s;
}

char *nonslip_adjectives() {
    char *s = calloc(8);
    if (crc32("iFyoa",5) == 2044155163) strcat(s, "K");
if (crc32("IeyPcnpNpRz",11) == 2659182541) strcat(s, "n");
if (crc32("lwYxwtXGoIzaCV",14) == 1394143191) strcat(s, "o");
if (crc32("guDUAHL",7) == 4020248383) strcat(s, "n");
if (crc32("YIHsXoUlEaSPZ",13) == 3753400843) strcat(s, "s");
if (crc32("JSQjekYE",8) == 4272371242) strcat(s, "l");
if (crc32("wNYBQx",6) == 3530336771) strcat(s, "Q");
if (crc32("PfrzLSgRJJfqRG",14) == 3131851227) strcat(s, "i");
if (crc32("zNjChCUNVcZ",11) == 1428271278) strcat(s, "I");
if (crc32("narzaLptQat",11) == 3135370385) strcat(s, "p");
    return s;
}

char *compoundable_adjectives() {
    char *s = calloc(13);
    if (crc32("cBdneG",6) == 464394961) strcat(s, "c");
if (crc32("aLPcLgUdJ",9) == 3096138284) strcat(s, "o");
if (crc32("HAHGMyQxj",9) == 3646191509) strcat(s, "Y");
if (crc32("eRDtcvUvAoklU",13) == 1719769812) strcat(s, "m");
if (crc32("NbiYnciOVrQiw",13) == 2623502247) strcat(s, "m");
if (crc32("uCWlpMKlCVZQJD",14) == 3223239930) strcat(s, "p");
if (crc32("GqWsRmhhXe",10) == 3809937184) strcat(s, "Q");
if (crc32("dGuDZWJmDifAdX",14) == 3215646394) strcat(s, "o");
if (crc32("KaRkCixUSqc",11) == 228516913) strcat(s, "e");
if (crc32("wEKAxdjRmwLhM",13) == 3741055151) strcat(s, "u");
if (crc32("UCXUht",6) == 1817216482) strcat(s, "n");
if (crc32("AWrfwEholEGO",12) == 4169839073) strcat(s, "P");
if (crc32("bXCOR",5) == 2872157430) strcat(s, "d");
if (crc32("NIdfAc",6) == 2515062323) strcat(s, "a");
if (crc32("aLoeXBkzcTUSkNR",15) == 3467320418) strcat(s, "a");
if (crc32("UeGmZ",5) == 336692946) strcat(s, "b");
if (crc32("ohrEDOfyvYmfz",13) == 1645447778) strcat(s, "l");
if (crc32("eHUqqTpMQjzq",12) == 2348154449) strcat(s, "M");
if (crc32("hUEZTPxuAJNgIVA",15) == 3462802111) strcat(s, "e");
    return s;
}

char *uninaugurated_adjectives() {
    char *s = calloc(14);
    if (crc32("JNgPOZEcm",9) == 3884250726) strcat(s, "u");
if (crc32("aYsVWUUvjq",10) == 2487479274) strcat(s, "u");
if (crc32("KQHMAMHLWvBj",12) == 4140374474) strcat(s, "n");
if (crc32("iuzrXWTcEgEbC",13) == 2566712131) strcat(s, "T");
if (crc32("SZVnKKMOCu",10) == 3173651379) strcat(s, "i");
if (crc32("omuxRmVTmZZSQ",13) == 3893535766) strcat(s, "J");
if (crc32("xiiKBaXmSuTfg",13) == 4149772523) strcat(s, "n");
if (crc32("vkopsp",6) == 19938957) strcat(s, "x");
if (crc32("gbKVOFZhx",9) == 638840530) strcat(s, "a");
if (crc32("husMMioFPGXu",12) == 2251288711) strcat(s, "u");
if (crc32("fVeIdMjHnqJZRv",14) == 1587591290) strcat(s, "h");
if (crc32("uvicsAowbEh",11) == 3225095303) strcat(s, "g");
if (crc32("ckiaMVSNxyqHou",14) == 3765957538) strcat(s, "d");
if (crc32("ocVwRCZKOkfkwwm",15) == 643229262) strcat(s, "u");
if (crc32("URkgqZyTvIK",11) == 486126295) strcat(s, "r");
if (crc32("ocdvygqbnPJ",11) == 4081858323) strcat(s, "x");
if (crc32("RdhtMIAPYRlX",12) == 3460204308) strcat(s, "a");
if (crc32("lGdYMYCrFg",10) == 1719835715) strcat(s, "R");
if (crc32("szBlHxme",8) == 4169023059) strcat(s, "t");
if (crc32("aRABHNjKhqUpFx",14) == 2470102452) strcat(s, "c");
if (crc32("bwGKz",5) == 95477436) strcat(s, "e");
if (crc32("BryCUbnITV",10) == 3387297900) strcat(s, "Z");
if (crc32("WjHLVbHHcaZhbU",14) == 2187569574) strcat(s, "d");
    return s;
}

char *simian_adjectives() {
    char *s = calloc(7);
    if (crc32("nHEpUXPSNOCx",12) == 443305503) strcat(s, "p");
if (crc32("fSIrLKaUtwsYeCJ",15) == 4159981911) strcat(s, "s");
if (crc32("cmChkxIeMUv",11) == 1401586664) strcat(s, "i");
if (crc32("WATjLIMPepRvaE",14) == 4082749846) strcat(s, "m");
if (crc32("cxBWNqePcfUj",12) == 4123305033) strcat(s, "i");
if (crc32("cLQJFpIMPTyK",12) == 207131580) strcat(s, "x");
if (crc32("yxdDARqJdg",10) == 3159787543) strcat(s, "a");
if (crc32("uFcyQ",5) == 3782167015) strcat(s, "n");
    return s;
}

char *weatherbeaten_adjectives() {
    char *s = calloc(14);
    if (crc32("JWSSYv",6) == 4033845699) strcat(s, "w");
if (crc32("iqUtnwsXrDGgchR",15) == 1056993176) strcat(s, "e");
if (crc32("aWQyJdvWAscjKQ",14) == 2336224810) strcat(s, "a");
if (crc32("RuhMrltrtMoGwg",14) == 4119633169) strcat(s, "d");
if (crc32("QnUCeyzM",8) == 3998374123) strcat(s, "t");
if (crc32("sDrZRkUjhiQSz",13) == 2577682162) strcat(s, "h");
if (crc32("zSgduUi",7) == 3997225927) strcat(s, "F");
if (crc32("fycQvV",6) == 606992769) strcat(s, "e");
if (crc32("hyOgdMMjA",9) == 2703997200) strcat(s, "k");
if (crc32("DToUQsjZkbt",11) == 418565091) strcat(s, "r");
if (crc32("AGqHFIx",7) == 4248217701) strcat(s, "z");
if (crc32("fhNzplx",7) == 2978691251) strcat(s, "b");
if (crc32("sqZgHYzG",8) == 211247775) strcat(s, "a");
if (crc32("OLGxKtd",7) == 1856923457) strcat(s, "e");
if (crc32("otQEd",5) == 3618591443) strcat(s, "F");
if (crc32("djXTR",5) == 3340166775) strcat(s, "a");
if (crc32("yVyOjb",6) == 3142799550) strcat(s, "D");
if (crc32("PMZBaYkILcB",11) == 1434832217) strcat(s, "t");
if (crc32("TUzwiiOWNrXanV",14) == 2718540399) strcat(s, "u");
if (crc32("BUKEUq",6) == 3643486931) strcat(s, "e");
if (crc32("DwzOrLoO",8) == 764422974) strcat(s, "n");
    return s;
}

char *nonparallel_adjectives() {
    char *s = calloc(12);
    if (crc32("cyJaTESSc",9) == 1504033316) strcat(s, "n");
if (crc32("UepLHnhXfmCj",12) == 3575981939) strcat(s, "o");
if (crc32("xbHGAKu",7) == 1225121955) strcat(s, "S");
if (crc32("WiqWpTVIyJXQih",14) == 3315848374) strcat(s, "n");
if (crc32("xkIVOQgNXXZRro",14) == 4052368678) strcat(s, "p");
if (crc32("sFbVBKSwVhzXFpm",15) == 2953198903) strcat(s, "p");
if (crc32("jHboEbBPi",9) == 1140319603) strcat(s, "e");
if (crc32("ovLnaTqkwWIq",12) == 1531375857) strcat(s, "a");
if (crc32("VFCdXhpCKj",10) == 2726981780) strcat(s, "h");
if (crc32("iKXIxWx",7) == 4184126511) strcat(s, "r");
if (crc32("wmsCkkxQeXeJBcm",15) == 1118592067) strcat(s, "j");
if (crc32("EOkKxEsZYAxW",12) == 2688704883) strcat(s, "a");
if (crc32("wjaDCF",6) == 1007669866) strcat(s, "k");
if (crc32("LIfGK",5) == 2941363114) strcat(s, "l");
if (crc32("tkyuAciMEB",10) == 2228501383) strcat(s, "N");
if (crc32("vDMzhOTIrtX",11) == 3963812355) strcat(s, "l");
if (crc32("cGMxgTC",7) == 520323641) strcat(s, "V");
if (crc32("zHFYDhIVhsy",11) == 2582618497) strcat(s, "e");
if (crc32("ExNTh",5) == 1129581591) strcat(s, "L");
if (crc32("lcKKE",5) == 3666310220) strcat(s, "l");
    return s;
}

char *preachiest_adjectives() {
    char *s = calloc(11);
    if (crc32("gJWWZPNH",8) == 786657216) strcat(s, "X");
if (crc32("AHVodbgCXb",10) == 1818960336) strcat(s, "p");
if (crc32("VdzlFMGDaaetT",13) == 223190075) strcat(s, "V");
if (crc32("LcYoPPmoyw",10) == 3149112327) strcat(s, "r");
if (crc32("fQKtiCy",7) == 3425502865) strcat(s, "e");
if (crc32("cIuEgBbWukLJx",13) == 1612136924) strcat(s, "y");
if (crc32("uVGcJCK",7) == 2113706852) strcat(s, "a");
if (crc32("phzmWlz",7) == 4058626764) strcat(s, "d");
if (crc32("LdyPdvpUQTMZq",13) == 3137291810) strcat(s, "c");
if (crc32("UeaweywX",8) == 2391488248) strcat(s, "l");
if (crc32("NwGsngjyZF",10) == 3227459727) strcat(s, "h");
if (crc32("ueeVJJCsjtXrkQU",15) == 3629134424) strcat(s, "i");
if (crc32("GeZKamvAA",9) == 2038741998) strcat(s, "P");
if (crc32("Jwepe",5) == 2121452090) strcat(s, "e");
if (crc32("fmjCuDjAQWY",11) == 742208513) strcat(s, "d");
if (crc32("OleUIUpmkvQS",12) == 2898364492) strcat(s, "s");
if (crc32("PlgyyKiRfpEUWM",14) == 2323445482) strcat(s, "t");
    return s;
}

char *ungrilled_adjectives() {
    char *s = calloc(10);
    if (crc32("HeELNnVmqSn",11) == 3968803468) strcat(s, "u");
if (crc32("lKBMkuQPjUrUQCs",15) == 3439785295) strcat(s, "f");
if (crc32("fqTmJnftZCn",11) == 2665655525) strcat(s, "n");
if (crc32("QberfgOpoUy",11) == 514978030) strcat(s, "g");
if (crc32("DtDVHnbsmifW",12) == 1748900908) strcat(s, "g");
if (crc32("XRbmx",5) == 1788561300) strcat(s, "r");
if (crc32("LdBIfAVVNONnBG",14) == 3159289459) strcat(s, "K");
if (crc32("ZvNOhr",6) == 2036828945) strcat(s, "i");
if (crc32("zCGArVAzAbRO",12) == 2425287567) strcat(s, "l");
if (crc32("BLHEywGLMCS",11) == 1621119548) strcat(s, "l");
if (crc32("mskgsocqkhlFcH",14) == 154706999) strcat(s, "p");
if (crc32("rkpoGoxOfZgYy",13) == 2107191138) strcat(s, "e");
if (crc32("dYiLJ",5) == 3812474383) strcat(s, "N");
if (crc32("bJBBVoCUibizevV",15) == 2610007123) strcat(s, "d");
    return s;
}

char *madding_adjectives() {
    char *s = calloc(8);
    if (crc32("lnqyvqr",7) == 3963242682) strcat(s, "S");
if (crc32("iBfXiRFCmdEm",12) == 3495609824) strcat(s, "m");
if (crc32("dktmgkSXjzV",11) == 1591291266) strcat(s, "D");
if (crc32("OgkhYZjKtsQL",12) == 2882611826) strcat(s, "a");
if (crc32("rNlSm",5) == 106861638) strcat(s, "B");
if (crc32("YzQRrGjNo",9) == 3001722555) strcat(s, "d");
if (crc32("CsXGaG",6) == 1766748579) strcat(s, "d");
if (crc32("CQLBtfPug",9) == 2795296118) strcat(s, "i");
if (crc32("eDIoXe",6) == 2930055394) strcat(s, "n");
if (crc32("vLBgPwMcbcoOy",13) == 3065338209) strcat(s, "g");
if (crc32("yekrgPSVbme",11) == 2633472944) strcat(s, "g");
    return s;
}

char *overspeculative_adjectives() {
    char *s = calloc(16);
    if (crc32("oivfQvLDlsGTs",13) == 2736670085) strcat(s, "H");
if (crc32("kBMAjUBVS",9) == 4036178041) strcat(s, "o");
if (crc32("bxpmBbWUUEW",11) == 3718358971) strcat(s, "U");
if (crc32("eVdKN",5) == 3030501115) strcat(s, "v");
if (crc32("SRoOpqYbUHmyLx",14) == 3054798287) strcat(s, "k");
if (crc32("AYvGWukzro",10) == 4067200492) strcat(s, "e");
if (crc32("cyfDYGoH",8) == 1759156896) strcat(s, "r");
if (crc32("xYJfHhFJ",8) == 2001622393) strcat(s, "K");
if (crc32("mCJpi",5) == 1216158510) strcat(s, "s");
if (crc32("znbaKHvgtOEL",12) == 2978330759) strcat(s, "p");
if (crc32("mKukcQONCio",11) == 1713528561) strcat(s, "e");
if (crc32("sOLuKnuk",8) == 1692305493) strcat(s, "c");
if (crc32("FhlLiSsMxHYiG",13) == 265104179) strcat(s, "c");
if (crc32("JORRnupOZYY",11) == 1477773603) strcat(s, "Y");
if (crc32("BMwCFlYfKrpCuQU",15) == 1691009470) strcat(s, "u");
if (crc32("mEDPH",5) == 3237164118) strcat(s, "M");
if (crc32("VvhdrJLAK",9) == 2685756037) strcat(s, "l");
if (crc32("wfAfKh",6) == 3088966374) strcat(s, "q");
if (crc32("iwZRaGCvKVAiSz",14) == 4184940003) strcat(s, "a");
if (crc32("MwzPwPlyhJTxtEE",15) == 416509613) strcat(s, "t");
if (crc32("xpqactKV",8) == 2034106256) strcat(s, "i");
if (crc32("ngVfcOHupPyjeRI",15) == 1373456911) strcat(s, "v");
if (crc32("LmegQvNed",9) == 977833509) strcat(s, "e");
    return s;
}

char *unpriced_adjectives() {
    char *s = calloc(9);
    if (crc32("fVrxlODARO",10) == 492178618) strcat(s, "S");
if (crc32("iNStghavFICqpN",14) == 404191013) strcat(s, "u");
if (crc32("eWgtKSbUITUVE",13) == 3311663009) strcat(s, "E");
if (crc32("JSDrZnUewl",10) == 3931068701) strcat(s, "n");
if (crc32("mFOhsmHOjw",10) == 3137232630) strcat(s, "p");
if (crc32("FYVAdFrBvdeU",12) == 509649432) strcat(s, "e");
if (crc32("EuMfDKncdD",10) == 561083306) strcat(s, "r");
if (crc32("ZMkxudQugmCae",13) == 3848428378) strcat(s, "i");
if (crc32("fPtAOKhcyhwAzaO",15) == 3334343079) strcat(s, "Y");
if (crc32("ehAviaUrDC",10) == 46103158) strcat(s, "c");
if (crc32("TyXPBshHTFiEgR",14) == 1748356980) strcat(s, "e");
if (crc32("nOvKmBbucCUWJ",13) == 381602783) strcat(s, "d");
    return s;
}

char *interim_adjectives() {
    char *s = calloc(8);
    if (crc32("MdGcXyJS",8) == 3164038707) strcat(s, "k");
if (crc32("ZZTxUcGxAn",10) == 968042945) strcat(s, "i");
if (crc32("gxhNnMYcckns",12) == 4071035312) strcat(s, "M");
if (crc32("LqBXQbMzkcpCF",13) == 480412596) strcat(s, "n");
if (crc32("IKCaEAZfvGdS",12) == 3992399153) strcat(s, "t");
if (crc32("LFtYVDaJAufNync",15) == 1860799105) strcat(s, "e");
if (crc32("NkqkruMUj",9) == 2565769237) strcat(s, "r");
if (crc32("ghuqQjh",7) == 3865342727) strcat(s, "A");
if (crc32("yCYNYbnzKdXMLi",14) == 498100374) strcat(s, "i");
if (crc32("riueTQMEvK",10) == 3386954659) strcat(s, "m");
    return s;
}

char *frizzier_adjectives() {
    char *s = calloc(9);
    if (crc32("lijeqQBNprcHh",13) == 979208306) strcat(s, "f");
if (crc32("qEuIHGgzL",9) == 3540576426) strcat(s, "E");
if (crc32("ICOKSHVTOSEKTh",14) == 909190974) strcat(s, "r");
if (crc32("OOlAnJvemPz",11) == 1537352130) strcat(s, "i");
if (crc32("tySeZK",6) == 3813533835) strcat(s, "z");
if (crc32("tIhZgczMfCOGiv",14) == 2561893138) strcat(s, "z");
if (crc32("esAqQH",6) == 4206181853) strcat(s, "i");
if (crc32("qyGklWueijSt",12) == 1302212461) strcat(s, "e");
if (crc32("njPEfLE",7) == 1836294586) strcat(s, "r");
    return s;
}

char *aphaeretic_adjectives() {
    char *s = calloc(11);
    if (crc32("qJCBGbkFxs",10) == 2098297668) strcat(s, "X");
if (crc32("kUimgaIQiFT",11) == 3668516515) strcat(s, "a");
if (crc32("gXmrKcXznxq",11) == 3472754457) strcat(s, "G");
if (crc32("pHhgn",5) == 2804042919) strcat(s, "p");
if (crc32("xDrroV",6) == 2356620184) strcat(s, "w");
if (crc32("ojgVNeiWVx",10) == 1768053215) strcat(s, "h");
if (crc32("AWybTDnHAOocUh",14) == 1807698601) strcat(s, "P");
if (crc32("UquqTgMoQE",10) == 3324936908) strcat(s, "a");
if (crc32("kqPjLvNgKOduX",13) == 3946314456) strcat(s, "H");
if (crc32("QOWzYjhmcy",10) == 2182839516) strcat(s, "e");
if (crc32("eBsGXfhV",8) == 3646399894) strcat(s, "F");
if (crc32("fajgnEYxY",9) == 4092726878) strcat(s, "r");
if (crc32("EWkqa",5) == 1460919376) strcat(s, "r");
if (crc32("tBxWRjSP",8) == 760704664) strcat(s, "e");
if (crc32("fancCAzSh",9) == 123217311) strcat(s, "D");
if (crc32("iObMuUWGFV",10) == 3564721328) strcat(s, "t");
if (crc32("AJVzyklddsDMCRo",15) == 63920471) strcat(s, "i");
if (crc32("TKRRbdNDbz",10) == 1849047922) strcat(s, "c");
    return s;
}

char *wellrehearsed_adjectives() {
    char *s = calloc(14);
    if (crc32("uibxlbGZtxS",11) == 3306525571) strcat(s, "w");
if (crc32("VUXmkSPkSk",10) == 1857357355) strcat(s, "S");
if (crc32("QGEmqdfzVnJML",13) == 3324603509) strcat(s, "e");
if (crc32("kdQFiaNVixW",11) == 3412672092) strcat(s, "l");
if (crc32("BuzisdT",7) == 3682306812) strcat(s, "l");
if (crc32("GrwEPXpqZd",10) == 3245695794) strcat(s, "r");
if (crc32("zNHibDFupmgjFb",14) == 1259774258) strcat(s, "B");
if (crc32("TKMaeD",6) == 1085192582) strcat(s, "e");
if (crc32("ccLOkSnDzn",10) == 2368259863) strcat(s, "d");
if (crc32("mvPMe",5) == 4251398542) strcat(s, "h");
if (crc32("RwpJlUpHvB",10) == 4249232906) strcat(s, "e");
if (crc32("PUgmv",5) == 319644324) strcat(s, "u");
if (crc32("FMaRnRJLKTNegK",14) == 4283514069) strcat(s, "a");
if (crc32("KaeMrzaxl",9) == 555252714) strcat(s, "j");
if (crc32("rVPfnQSOHmClo",13) == 2224385250) strcat(s, "r");
if (crc32("CefQvxWqTEC",11) == 305727089) strcat(s, "v");
if (crc32("KwfVjOB",7) == 2669685911) strcat(s, "s");
if (crc32("ZHdsOqWuRNZrIF",14) == 3893209597) strcat(s, "t");
if (crc32("MQpvhCSCfB",10) == 904533300) strcat(s, "e");
if (crc32("uKwPfYPBTk",10) == 302902281) strcat(s, "s");
if (crc32("mTntiCW",7) == 1259368035) strcat(s, "d");
    return s;
}

char *verificative_adjectives() {
    char *s = calloc(13);
    if (crc32("CntximGJmRNXIR",14) == 1940230899) strcat(s, "t");
if (crc32("kAUbexAWggHQOm",14) == 3893023422) strcat(s, "v");
if (crc32("PTUQJ",5) == 360422329) strcat(s, "r");
if (crc32("pXiGJEGBZqxl",12) == 3330456740) strcat(s, "e");
if (crc32("kcqfHmLdVMs",11) == 3722301443) strcat(s, "r");
if (crc32("GGbVceLO",8) == 1444681638) strcat(s, "J");
if (crc32("FvNZiYO",7) == 4003672764) strcat(s, "i");
if (crc32("jsKqRXfDtmd",11) == 1733821115) strcat(s, "f");
if (crc32("MvUzXIIBmuTnMJ",14) == 1929771766) strcat(s, "R");
if (crc32("bXYSiqvZ",8) == 1378021167) strcat(s, "i");
if (crc32("vPxFrV",6) == 288822784) strcat(s, "c");
if (crc32("pNEhHmgZPGp",11) == 1299237893) strcat(s, "a");
if (crc32("HQWETqcpb",9) == 2066393094) strcat(s, "t");
if (crc32("TAzPMQHJWW",10) == 288666918) strcat(s, "i");
if (crc32("RJNpnPbVVg",10) == 158102828) strcat(s, "v");
if (crc32("DqBaNv",6) == 3110388004) strcat(s, "L");
if (crc32("FiImQ",5) == 3838517434) strcat(s, "e");
    return s;
}

char *marketwise_adjectives() {
    char *s = calloc(11);
    if (crc32("PKtfLdMOJgw",11) == 2320213255) strcat(s, "B");
if (crc32("TZGiEarYYtBsa",13) == 2254392490) strcat(s, "m");
if (crc32("IdVFfj",6) == 4053192417) strcat(s, "a");
if (crc32("bRwXHfYKvDVTyy",14) == 1338586801) strcat(s, "G");
if (crc32("qzlyifKqnvsGIh",14) == 2563071053) strcat(s, "r");
if (crc32("wUBBmy",6) == 539091463) strcat(s, "y");
if (crc32("hHENyNpTkpT",11) == 1380669782) strcat(s, "k");
if (crc32("JGysUlIwyePX",12) == 3064797355) strcat(s, "s");
if (crc32("JgicEg",6) == 1718919615) strcat(s, "e");
if (crc32("mGsWfdPIRH",10) == 1327413857) strcat(s, "t");
if (crc32("KhxKqz",6) == 699358535) strcat(s, "w");
if (crc32("uCGgbJP",7) == 3430742758) strcat(s, "i");
if (crc32("WnKZyFGFEQBsb",13) == 1039962340) strcat(s, "s");
if (crc32("qMVeXUa",7) == 1086891998) strcat(s, "e");
    return s;
}

char *unsplendourous_adjectives() {
    char *s = calloc(15);
    if (crc32("jjdOjDgUDUyHqs",14) == 4191354651) strcat(s, "g");
if (crc32("cuWqxHlJ",8) == 3748441763) strcat(s, "u");
if (crc32("RIZZmuMugQGWI",13) == 527221068) strcat(s, "n");
if (crc32("XbEQVuqZpUM",11) == 3317591773) strcat(s, "N");
if (crc32("UoQqTk",6) == 3570831963) strcat(s, "s");
if (crc32("XDKOHgVuxWm",11) == 2272126571) strcat(s, "p");
if (crc32("PigKpiNpNnugH",13) == 1752692084) strcat(s, "s");
if (crc32("UCwYmZLfEkf",11) == 1509628113) strcat(s, "l");
if (crc32("xTrXIgZ",7) == 2249616628) strcat(s, "e");
if (crc32("snxpRRfD",8) == 3472713118) strcat(s, "n");
if (crc32("HsGgF",5) == 402483559) strcat(s, "d");
if (crc32("qoeFSDYBA",9) == 3282684115) strcat(s, "o");
if (crc32("oqHHSqdzDBYjYc",14) == 753010400) strcat(s, "x");
if (crc32("mpdpguUpOcNuSl",14) == 557865178) strcat(s, "u");
if (crc32("YcoLzHHOYWhP",12) == 1629405372) strcat(s, "r");
if (crc32("VRrSOnGqUKjuqd",14) == 3588516318) strcat(s, "o");
if (crc32("qAfvhCytfh",10) == 1679915206) strcat(s, "u");
if (crc32("FDvdluGwJvL",11) == 1710468294) strcat(s, "s");
    return s;
}

char *premillennial_adjectives() {
    char *s = calloc(14);
    if (crc32("vaNRvhQP",8) == 1566002384) strcat(s, "w");
if (crc32("tdsul",5) == 1053796239) strcat(s, "p");
if (crc32("ZGBZRyZlBOFcdL",14) == 3641117926) strcat(s, "r");
if (crc32("OhEnMqKqlEutA",13) == 4060694065) strcat(s, "e");
if (crc32("NkCcbFRiylmr",12) == 2562863570) strcat(s, "m");
if (crc32("vmOrM",5) == 1815129257) strcat(s, "m");
if (crc32("RXKlczLi",8) == 1125220479) strcat(s, "i");
if (crc32("vxCpBtTsrExALua",15) == 2914826700) strcat(s, "l");
if (crc32("rewmCfvwH",9) == 1512298453) strcat(s, "T");
if (crc32("dfFUyFDo",8) == 3677309329) strcat(s, "l");
if (crc32("TwUNzFbycX",10) == 2149271197) strcat(s, "U");
if (crc32("UnaCIQm",7) == 476322261) strcat(s, "e");
if (crc32("TymAaowSKCXmYV",14) == 2803507112) strcat(s, "n");
if (crc32("BNNYneRtMKILZB",14) == 2452022387) strcat(s, "x");
if (crc32("LFuhqZMeCDiyRfJ",15) == 3888523936) strcat(s, "n");
if (crc32("xpFtELlMZ",9) == 10744589) strcat(s, "D");
if (crc32("vpGKXrkK",8) == 3770709470) strcat(s, "i");
if (crc32("OlzMat",6) == 726763219) strcat(s, "K");
if (crc32("AqsTsGewy",9) == 3129984842) strcat(s, "a");
if (crc32("yFFhqIqNSart",12) == 4235743976) strcat(s, "l");
if (crc32("GJxxtBzCn",9) == 3374767619) strcat(s, "l");
    return s;
}

char *overidolatrous_adjectives() {
    char *s = calloc(15);
    if (crc32("KWPJZsVCcBNrVs",14) == 2280512536) strcat(s, "o");
if (crc32("wqDoZ",5) == 1075570341) strcat(s, "v");
if (crc32("ZtzPBtT",7) == 2467241366) strcat(s, "u");
if (crc32("owMRLWCRTTlTcdw",15) == 3471429251) strcat(s, "e");
if (crc32("gxDuVEz",7) == 2045028723) strcat(s, "C");
if (crc32("laoXBbZlRhmDz",13) == 60251530) strcat(s, "r");
if (crc32("VXyQlRB",7) == 3948236350) strcat(s, "i");
if (crc32("xXNQacB",7) == 3660806835) strcat(s, "n");
if (crc32("mdgkBqALUuoI",12) == 4211402682) strcat(s, "d");
if (crc32("ybfyVnEtlgL",11) == 3040013192) strcat(s, "o");
if (crc32("JSdEcJGLkQubgFH",15) == 578937976) strcat(s, "c");
if (crc32("DSCzrUhzlREMf",13) == 3968238147) strcat(s, "l");
if (crc32("UFmWikdgvsY",11) == 690064707) strcat(s, "o");
if (crc32("ZtEAUhZ",7) == 1965849391) strcat(s, "a");
if (crc32("nudAPboxVbHPzTs",15) == 3390520977) strcat(s, "t");
if (crc32("kPmEvnQU",8) == 1538494858) strcat(s, "r");
if (crc32("VAeFSjigTUSJVUH",15) == 2246699909) strcat(s, "z");
if (crc32("ufBAfNNl",8) == 4236337) strcat(s, "o");
if (crc32("VusCgmaizrH",11) == 3098625288) strcat(s, "C");
if (crc32("tpZxuIEeclXCb",13) == 1496656991) strcat(s, "u");
if (crc32("zaOLtjmOMvVtkv",14) == 1667036779) strcat(s, "l");
if (crc32("BqzkofLZ",8) == 4172497337) strcat(s, "s");
    return s;
}

char *hazier_adjectives() {
    char *s = calloc(7);
    if (crc32("NehZwLJDrh",10) == 2815979795) strcat(s, "h");
if (crc32("fRLKVQUzwkzMrZ",14) == 4179163678) strcat(s, "H");
if (crc32("OQPqEBdluZBJa",13) == 2058300516) strcat(s, "a");
if (crc32("zyLpL",5) == 1252188300) strcat(s, "z");
if (crc32("cnFBEdvKO",9) == 2718472482) strcat(s, "i");
if (crc32("fPXiTn",6) == 2546862825) strcat(s, "b");
if (crc32("nFSyPIq",7) == 2623914220) strcat(s, "e");
if (crc32("gpqHkk",6) == 2000046126) strcat(s, "S");
if (crc32("EsoQOhEBfiGeP",13) == 1763070432) strcat(s, "r");
    return s;
}

char *unsieved_adjectives() {
    char *s = calloc(9);
    if (crc32("TXikyrBbrrvr",12) == 3809219790) strcat(s, "k");
if (crc32("lavEMuQMkSW",11) == 3750603994) strcat(s, "u");
if (crc32("nNHLVh",6) == 3965140591) strcat(s, "n");
if (crc32("OLwaqHNdaFh",11) == 1962852558) strcat(s, "s");
if (crc32("ybkgtniFBwPspLE",15) == 1811466283) strcat(s, "i");
if (crc32("vZLtKhsbVqjjtL",14) == 264361338) strcat(s, "e");
if (crc32("zSZmgEpdFwY",11) == 3547817582) strcat(s, "v");
if (crc32("LBDARygAnIH",11) == 3237713527) strcat(s, "e");
if (crc32("bhVKwOLXai",10) == 1474178756) strcat(s, "I");
if (crc32("DkyYeHUA",8) == 3960273292) strcat(s, "d");
    return s;
}

char *civetlike_adjectives() {
    char *s = calloc(10);
    if (crc32("QMGDNsOhSeDQ",12) == 2546538126) strcat(s, "c");
if (crc32("RvlgxYJ",7) == 2851924913) strcat(s, "i");
if (crc32("fbHlnZFuPcpJo",13) == 2093146363) strcat(s, "v");
if (crc32("dARhyBhNz",9) == 258802149) strcat(s, "e");
if (crc32("SWFKUZ",6) == 2812610768) strcat(s, "P");
if (crc32("BqpqNEGVUQ",10) == 1749116066) strcat(s, "t");
if (crc32("fzMRrBGudtN",11) == 284157222) strcat(s, "l");
if (crc32("yRBmKwi",7) == 863866567) strcat(s, "a");
if (crc32("sjbxiIJDjmyzl",13) == 1167268770) strcat(s, "i");
if (crc32("xbKum",5) == 605623923) strcat(s, "G");
if (crc32("ibiILTxEFBCWBH",14) == 3875010940) strcat(s, "k");
if (crc32("JjzLv",5) == 890476524) strcat(s, "E");
if (crc32("bkLggLRamc",10) == 2089209623) strcat(s, "e");
    return s;
}

char *leprose_adjectives() {
    char *s = calloc(8);
    if (crc32("WvTHZfPNWH",10) == 556297119) strcat(s, "b");
if (crc32("MTbDxKqxy",9) == 2397262919) strcat(s, "l");
if (crc32("yQaeWhnsKYkv",12) == 687240261) strcat(s, "e");
if (crc32("oonNXZD",7) == 397670272) strcat(s, "p");
if (crc32("DIgLTaVyftWEX",13) == 2153936723) strcat(s, "b");
if (crc32("lvPIHxVnnRAj",12) == 2731648380) strcat(s, "r");
if (crc32("JhOYIk",6) == 3984762349) strcat(s, "o");
if (crc32("DklCpHfS",8) == 1559819131) strcat(s, "J");
if (crc32("OJFFZmzG",8) == 2726400893) strcat(s, "s");
if (crc32("kzzvEwXdESYA",12) == 805666262) strcat(s, "e");
    return s;
}

char *idiomatic_adjectives() {
    char *s = calloc(10);
    if (crc32("AyOeBYM",7) == 1768181402) strcat(s, "U");
if (crc32("wktfhjyhbwMuQ",13) == 462055508) strcat(s, "i");
if (crc32("hBVvh",5) == 205536831) strcat(s, "d");
if (crc32("tiAHJ",5) == 1404011503) strcat(s, "i");
if (crc32("LBYxSuBxmHH",11) == 1696778328) strcat(s, "w");
if (crc32("LKxaePLoec",10) == 1475168844) strcat(s, "o");
if (crc32("lQbthcPGA",9) == 465986888) strcat(s, "m");
if (crc32("PRCwiv",6) == 718911518) strcat(s, "a");
if (crc32("iLzATEo",7) == 2202899939) strcat(s, "F");
if (crc32("bGjEDTxmaovzbt",14) == 4226553457) strcat(s, "t");
if (crc32("AzzbveA",7) == 1710813226) strcat(s, "c");
if (crc32("IGGVbX",6) == 802135099) strcat(s, "i");
if (crc32("yRMsFD",6) == 1236505716) strcat(s, "q");
if (crc32("WuxHkS",6) == 890376314) strcat(s, "c");
    return s;
}

char *balloonlike_adjectives() {
    char *s = calloc(12);
    if (crc32("vOFrqfZsX",9) == 776645388) strcat(s, "b");
if (crc32("ltfWvX",6) == 2848833489) strcat(s, "a");
if (crc32("lIutvsWohTN",11) == 1526951878) strcat(s, "r");
if (crc32("PvepCSstncsUt",13) == 2722430847) strcat(s, "l");
if (crc32("rPtwoXFVvDhjq",13) == 3622626660) strcat(s, "l");
if (crc32("KYBLBLac",8) == 1331752400) strcat(s, "I");
if (crc32("CMChWMS",7) == 1691245934) strcat(s, "o");
if (crc32("PCWZT",5) == 842127107) strcat(s, "o");
if (crc32("DdVNsVExtPaeBsu",15) == 2442202287) strcat(s, "s");
if (crc32("PulmyfCAYSCFAw",14) == 163519130) strcat(s, "n");
if (crc32("GoyYLlQaeZ",10) == 2494341766) strcat(s, "l");
if (crc32("rBkKdmKHa",9) == 1693372524) strcat(s, "i");
if (crc32("bFSUQSs",7) == 2868933547) strcat(s, "s");
if (crc32("juxgQmIV",8) == 3325528158) strcat(s, "k");
if (crc32("cIiFAixpOZV",11) == 435523295) strcat(s, "G");
if (crc32("SnYMeC",6) == 616743845) strcat(s, "e");
    return s;
}

char *unpornographic_adjectives() {
    char *s = calloc(15);
    if (crc32("kqsjWWtg",8) == 1529147327) strcat(s, "u");
if (crc32("XJzBtd",6) == 1606774453) strcat(s, "r");
if (crc32("cfunbo",6) == 3183386066) strcat(s, "n");
if (crc32("AKbkkBvcrz",10) == 49996032) strcat(s, "T");
if (crc32("rtzqwFXp",8) == 1575195987) strcat(s, "p");
if (crc32("ukimGdXj",8) == 3627849291) strcat(s, "W");
if (crc32("BBUjAwVRjHKiyTH",15) == 2391877251) strcat(s, "o");
if (crc32("CbfiLnys",8) == 303240190) strcat(s, "t");
if (crc32("EWFePCIp",8) == 2727439582) strcat(s, "r");
if (crc32("tgwUP",5) == 2442721432) strcat(s, "n");
if (crc32("NTTVtQLkACeE",12) == 453539626) strcat(s, "W");
if (crc32("BNIJlswYgLlJe",13) == 973056274) strcat(s, "o");
if (crc32("nLvMWrbYaialG",13) == 4138498023) strcat(s, "g");
if (crc32("kIkaqxkBrNRf",12) == 4173298382) strcat(s, "p");
if (crc32("YISYktsVvUrGh",13) == 1491216379) strcat(s, "r");
if (crc32("rixkYuwKduVDEDu",15) == 1410065306) strcat(s, "a");
if (crc32("YnraGtCfGCEYM",13) == 2549339623) strcat(s, "p");
if (crc32("mKJzvVlgGCu",11) == 1525930102) strcat(s, "Y");
if (crc32("RzTtW",5) == 1436210567) strcat(s, "h");
if (crc32("kwvTakYZJfBJuSq",15) == 1333724559) strcat(s, "i");
if (crc32("xFIKDg",6) == 1544587402) strcat(s, "c");
    return s;
}

char *postthalamic_adjectives() {
    char *s = calloc(13);
    if (crc32("pGMEztrZxS",10) == 417945259) strcat(s, "p");
if (crc32("EvToimjmVAGaRn",14) == 190886041) strcat(s, "o");
if (crc32("NRRutfgRsvq",11) == 1845501612) strcat(s, "s");
if (crc32("sSqlIfnXlcPlX",13) == 1563166663) strcat(s, "t");
if (crc32("eWpzPAVfSUpv",12) == 1460460775) strcat(s, "t");
if (crc32("LgmAq",5) == 1123525577) strcat(s, "m");
if (crc32("svLvOqXtOWROhW",14) == 1577269887) strcat(s, "h");
if (crc32("AqaRSbWlGJVspV",14) == 3664076050) strcat(s, "N");
if (crc32("InQBZlPLVcbHXq",14) == 2681473630) strcat(s, "a");
if (crc32("rjOufWKhALdVCU",14) == 1624704956) strcat(s, "l");
if (crc32("yBsVaSAXAQnYkYr",15) == 2069391117) strcat(s, "a");
if (crc32("ABfHUhhN",8) == 1677225653) strcat(s, "m");
if (crc32("bNHEWbkLnmQxk",13) == 1427567061) strcat(s, "b");
if (crc32("XREkScoavnqntTg",15) == 287787657) strcat(s, "i");
if (crc32("EONChEOy",8) == 1256609120) strcat(s, "c");
    return s;
}

char *rehearsable_adjectives() {
    char *s = calloc(12);
    if (crc32("xASrAxxGFD",10) == 3848166884) strcat(s, "A");
if (crc32("pHaZRPavh",9) == 2529257447) strcat(s, "r");
if (crc32("NjTRQydNYvv",11) == 3814959722) strcat(s, "O");
if (crc32("AlRqoGPH",8) == 2648421358) strcat(s, "e");
if (crc32("mesqFOayFEb",11) == 1606994094) strcat(s, "h");
if (crc32("cQJwS",5) == 2215671086) strcat(s, "e");
if (crc32("RSUcfjxLNq",10) == 569422903) strcat(s, "a");
if (crc32("CbCuPLLgHF",10) == 1461248322) strcat(s, "r");
if (crc32("gXblb",5) == 254665097) strcat(s, "o");
if (crc32("BLGbE",5) == 293289166) strcat(s, "s");
if (crc32("lLXFO",5) == 2900173190) strcat(s, "E");
if (crc32("jdBSWq",6) == 4177581684) strcat(s, "a");
if (crc32("uGIerhsG",8) == 316908666) strcat(s, "b");
if (crc32("YPuPMSJY",8) == 863002426) strcat(s, "f");
if (crc32("mVfykO",6) == 2549912097) strcat(s, "l");
if (crc32("kReWoV",6) == 997878995) strcat(s, "V");
if (crc32("KKsDGrX",7) == 429328592) strcat(s, "e");
    return s;
}

char *articulable_adjectives() {
    char *s = calloc(12);
    if (crc32("fNAulHG",7) == 3909078928) strcat(s, "a");
if (crc32("oATZPPGQSddLZA",14) == 3386538960) strcat(s, "r");
if (crc32("ctxdGMbn",8) == 736291141) strcat(s, "t");
if (crc32("fBQhmZTs",8) == 1255597970) strcat(s, "Y");
if (crc32("mORMMfvAiGrhyU",14) == 3601174324) strcat(s, "i");
if (crc32("hxSOprjaBX",10) == 3448442499) strcat(s, "Z");
if (crc32("diswtFhJcBw",11) == 330381704) strcat(s, "c");
if (crc32("DviPcUlDe",9) == 928290141) strcat(s, "Q");
if (crc32("BTpiOTJhPW",10) == 708926791) strcat(s, "u");
if (crc32("elXqmR",6) == 3146097950) strcat(s, "l");
if (crc32("WULHabc",7) == 781962313) strcat(s, "a");
if (crc32("ePfzHt",6) == 2570251234) strcat(s, "M");
if (crc32("wOmTivz",7) == 3788706966) strcat(s, "b");
if (crc32("LJiEDCBasxn",11) == 1963518780) strcat(s, "o");
if (crc32("YTEPTjme",8) == 1945368586) strcat(s, "l");
if (crc32("twHLnzStqpIaLt",14) == 4226692561) strcat(s, "e");
    return s;
}

char *hygrophytic_adjectives() {
    char *s = calloc(12);
    if (crc32("FsWVznAncLVtJmj",15) == 1086024511) strcat(s, "h");
if (crc32("oSfEBtMwzx",10) == 1963115253) strcat(s, "y");
if (crc32("tNDTJqlfJSeMpP",14) == 2279773899) strcat(s, "O");
if (crc32("pnxmOttuhdkYUaj",15) == 4211307338) strcat(s, "g");
if (crc32("tnzSKmCi",8) == 2339101210) strcat(s, "q");
if (crc32("ejjlvZP",7) == 884754335) strcat(s, "r");
if (crc32("tJKVczf",7) == 3512539906) strcat(s, "o");
if (crc32("BJferOpveBjp",12) == 3356506602) strcat(s, "p");
if (crc32("KoaYMvDFWSpYNS",14) == 2232248465) strcat(s, "t");
if (crc32("itCLVginilO",11) == 1418930869) strcat(s, "h");
if (crc32("SnIOEeQfuRE",11) == 1313665526) strcat(s, "y");
if (crc32("svQWmL",6) == 4288512768) strcat(s, "t");
if (crc32("QSceFXcwKSCJUZ",14) == 669955592) strcat(s, "r");
if (crc32("vUyZYvIhXxA",11) == 4263421004) strcat(s, "i");
if (crc32("eVZCDQT",7) == 3318317614) strcat(s, "d");
if (crc32("oQrNvzVKSC",10) == 3741171751) strcat(s, "c");
    return s;
}

char *unnymphal_adjectives() {
    char *s = calloc(10);
    if (crc32("zqFeZ",5) == 1105207024) strcat(s, "u");
if (crc32("GMypZwkZOflGOs",14) == 717952218) strcat(s, "n");
if (crc32("fukhBdLrjaHYcbE",15) == 1221206879) strcat(s, "s");
if (crc32("DWpndmL",7) == 4268731657) strcat(s, "n");
if (crc32("GCdTGitutSlpFHY",15) == 712520564) strcat(s, "y");
if (crc32("ZqPlLylabARXrC",14) == 2257297377) strcat(s, "m");
if (crc32("pYICooZIrdBtAg",14) == 28323104) strcat(s, "P");
if (crc32("UUGLaljI",8) == 3557995388) strcat(s, "p");
if (crc32("xDuGqw",6) == 716289861) strcat(s, "h");
if (crc32("nDYEwKzurCmN",12) == 2230067775) strcat(s, "a");
if (crc32("PaNUhGXp",8) == 2680230548) strcat(s, "g");
if (crc32("hYkTOB",6) == 147260470) strcat(s, "l");
    return s;
}

char *embryonic_adjectives() {
    char *s = calloc(10);
    if (crc32("LdENJpVFLwSloWn",15) == 2600314823) strcat(s, "m");
if (crc32("GujlASaR",8) == 3109460206) strcat(s, "e");
if (crc32("ekjsYKvY",8) == 3265120931) strcat(s, "m");
if (crc32("cLbfEHcYukd",11) == 3029396516) strcat(s, "i");
if (crc32("PIEnsZPWBy",10) == 606526430) strcat(s, "b");
if (crc32("WBJdLaZXkw",10) == 3711777474) strcat(s, "r");
if (crc32("UrANQUCmmhQ",11) == 3237932569) strcat(s, "r");
if (crc32("CHBJelt",7) == 220337070) strcat(s, "y");
if (crc32("dNIMaQle",8) == 3086474701) strcat(s, "o");
if (crc32("EpcCBUaMr",9) == 2179438906) strcat(s, "n");
if (crc32("GUTYYvOCcLpCrja",15) == 1402475778) strcat(s, "i");
if (crc32("NCXnJOsluCRjxGo",15) == 771571365) strcat(s, "E");
if (crc32("ohjoFDPp",8) == 1173335497) strcat(s, "c");
    return s;
}

char *noncarbolic_adjectives() {
    char *s = calloc(12);
    if (crc32("DLabpTH",7) == 2465078484) strcat(s, "n");
if (crc32("NFWIkCdkX",9) == 447361557) strcat(s, "o");
if (crc32("KaItZ",5) == 2703183559) strcat(s, "F");
if (crc32("GgenkbbqHVHqJjr",15) == 1126819457) strcat(s, "n");
if (crc32("CKMUmMfwaRnZHKT",15) == 3396477602) strcat(s, "c");
if (crc32("lzudpeM",7) == 3606160585) strcat(s, "O");
if (crc32("JWSIRfwLeC",10) == 1494769527) strcat(s, "a");
if (crc32("XtNIdeGDgK",10) == 1512136684) strcat(s, "A");
if (crc32("TOXskrQ",7) == 2163638220) strcat(s, "r");
if (crc32("fAczkzczLFuL",12) == 2219646845) strcat(s, "b");
if (crc32("KBihjznbt",9) == 3189095899) strcat(s, "o");
if (crc32("pRjbBAtW",8) == 3384586642) strcat(s, "l");
if (crc32("awINFi",6) == 4165274843) strcat(s, "M");
if (crc32("mQswNMbBOxT",11) == 1284632543) strcat(s, "i");
if (crc32("FdqRkzUCsyM",11) == 2278575404) strcat(s, "c");
    return s;
}

char *annulate_adjectives() {
    char *s = calloc(9);
    if (crc32("Pwwgmyn",7) == 1365585478) strcat(s, "a");
if (crc32("SinxPKuoJhugI",13) == 639024048) strcat(s, "v");
if (crc32("fzcVlahWgXnl",12) == 614086110) strcat(s, "n");
if (crc32("HzHfV",5) == 1694843125) strcat(s, "n");
if (crc32("UZQEEx",6) == 1111983531) strcat(s, "B");
if (crc32("XHAeMhnZZTPe",12) == 1214216085) strcat(s, "u");
if (crc32("xxChqUvwZZ",10) == 3064535333) strcat(s, "l");
if (crc32("aNwXehe",7) == 508859666) strcat(s, "a");
if (crc32("TfXremzk",8) == 2090865745) strcat(s, "t");
if (crc32("PuLDuVg",7) == 19821579) strcat(s, "e");
    return s;
}

char *instructorless_adjectives() {
    char *s = calloc(15);
    if (crc32("iyuhcVJedwr",11) == 3231268193) strcat(s, "f");
if (crc32("fVzkcy",6) == 4281721418) strcat(s, "i");
if (crc32("yPExUbUDLEcixN",14) == 10294022) strcat(s, "n");
if (crc32("yBfPkH",6) == 1708743548) strcat(s, "M");
if (crc32("mlzjDZvTfMV",11) == 3147038319) strcat(s, "s");
if (crc32("hrtzmVD",7) == 3058716905) strcat(s, "t");
if (crc32("kpQDSnrCNlrG",12) == 2679208996) strcat(s, "r");
if (crc32("MqDmI",5) == 3550973092) strcat(s, "U");
if (crc32("vHePMLQJfNzAAU",14) == 2014697213) strcat(s, "u");
if (crc32("kRqvvWbaUWA",11) == 342982999) strcat(s, "u");
if (crc32("RXauFZrqxrQ",11) == 3487974876) strcat(s, "c");
if (crc32("UCDrIMrihcH",11) == 2893305154) strcat(s, "K");
if (crc32("ZRkJxJPZ",8) == 2273120851) strcat(s, "t");
if (crc32("PHRIRYD",7) == 2358095006) strcat(s, "o");
if (crc32("BQjyJaUwcwQkL",13) == 3281178016) strcat(s, "X");
if (crc32("UKdAZcxAmQYaVnk",15) == 3712491560) strcat(s, "r");
if (crc32("CWdmGN",6) == 1747601352) strcat(s, "l");
if (crc32("jKlhaqreLqANpzc",15) == 2100969672) strcat(s, "J");
if (crc32("AhakMIpCTn",10) == 1805843438) strcat(s, "e");
if (crc32("yJhJCdQMvlioOsG",15) == 1782907043) strcat(s, "s");
if (crc32("sSXDTbjt",8) == 3743973264) strcat(s, "s");
    return s;
}

char *decided_adjectives() {
    char *s = calloc(8);
    if (crc32("MdAWJTBRgL",10) == 2462133203) strcat(s, "p");
if (crc32("NDZDPOAtT",9) == 3817584615) strcat(s, "d");
if (crc32("utbJxixiMaR",11) == 3383979907) strcat(s, "h");
if (crc32("rqYnaNyUWu",10) == 3937419946) strcat(s, "e");
if (crc32("gMutY",5) == 3257096625) strcat(s, "T");
if (crc32("GnwXmmjCCI",10) == 2587459508) strcat(s, "c");
if (crc32("japCgepg",8) == 163397743) strcat(s, "i");
if (crc32("LSXSXtm",7) == 1610170483) strcat(s, "d");
if (crc32("SQvYJSM",7) == 1826789869) strcat(s, "e");
if (crc32("UbtREylfvoXTGU",14) == 1472187349) strcat(s, "d");
    return s;
}

char *degraded_adjectives() {
    char *s = calloc(9);
    if (crc32("mCgBLA",6) == 279021732) strcat(s, "F");
if (crc32("OBNZrXclSIpMXmz",15) == 1050523735) strcat(s, "d");
if (crc32("GjYPUhKs",8) == 1532852468) strcat(s, "D");
if (crc32("wGxFxHaJPkc",11) == 906501173) strcat(s, "e");
if (crc32("wAPPGRnH",8) == 2547357271) strcat(s, "D");
if (crc32("wyRTGTyUkUeeeP",14) == 1236288477) strcat(s, "g");
if (crc32("LTpDInwZpTGJP",13) == 3719613526) strcat(s, "n");
if (crc32("rPUPtJLOBnF",11) == 3866226778) strcat(s, "r");
if (crc32("gTQTtx",6) == 396347474) strcat(s, "C");
if (crc32("GmIjLjjWUjnGaq",14) == 859483332) strcat(s, "a");
if (crc32("WrJSanTk",8) == 748925238) strcat(s, "u");
if (crc32("PLGdV",5) == 3653181044) strcat(s, "d");
if (crc32("gayauNIprMJNAxW",15) == 3923351786) strcat(s, "f");
if (crc32("VlafKhrMlkmEc",13) == 4165432723) strcat(s, "e");
if (crc32("HQCkHF",6) == 2779853433) strcat(s, "C");
if (crc32("BfWExm",6) == 290332162) strcat(s, "d");
    return s;
}

char *unbedabbled_adjectives() {
    char *s = calloc(12);
    if (crc32("DbgWFqep",8) == 96568827) strcat(s, "d");
if (crc32("yVsagxPfmEM",11) == 3319738477) strcat(s, "u");
if (crc32("rYewaTWA",8) == 853535561) strcat(s, "n");
if (crc32("mzylMIpan",9) == 866614761) strcat(s, "p");
if (crc32("nKzbZBCutks",11) == 1648763847) strcat(s, "b");
if (crc32("NgjRHqBBWpgg",12) == 2681941780) strcat(s, "N");
if (crc32("yHikxkKWdwRZ",12) == 2719504272) strcat(s, "e");
if (crc32("HLyVNWPjlkSB",12) == 2745382987) strcat(s, "d");
if (crc32("HBvMJNborFWkukr",15) == 2814098470) strcat(s, "a");
if (crc32("tptvhCYoPfy",11) == 2738974983) strcat(s, "Q");
if (crc32("wBiDJjcaLbMLDYV",15) == 4060318787) strcat(s, "b");
if (crc32("PfdVnUrVjei",11) == 3580938401) strcat(s, "g");
if (crc32("LknYbVwbXZBb",12) == 99167563) strcat(s, "b");
if (crc32("YZCfseShg",9) == 4124219325) strcat(s, "l");
if (crc32("FxIzFQctQzL",11) == 3796362799) strcat(s, "e");
if (crc32("txsLumBFzWbJzr",14) == 458560558) strcat(s, "d");
    return s;
}

char *previctorious_adjectives() {
    char *s = calloc(14);
    if (crc32("PnUGTDFSNZg",11) == 2576357986) strcat(s, "o");
if (crc32("KERpSnxh",8) == 2148290253) strcat(s, "p");
if (crc32("maWkDhjgTF",10) == 1060721232) strcat(s, "r");
if (crc32("ozPeVAauW",9) == 2656271502) strcat(s, "l");
if (crc32("rSZGsjgT",8) == 2765896815) strcat(s, "e");
if (crc32("cPnVborD",8) == 2833890296) strcat(s, "z");
if (crc32("bvHrcMdodLM",11) == 239565810) strcat(s, "v");
if (crc32("nWzEVmEfexoGLu",14) == 3774064536) strcat(s, "i");
if (crc32("sHKIDnMbymQ",11) == 3486924081) strcat(s, "c");
if (crc32("LUIpgp",6) == 4060076212) strcat(s, "t");
if (crc32("jDHvEER",7) == 2123279572) strcat(s, "o");
if (crc32("BrpbcMpsr",9) == 702804063) strcat(s, "m");
if (crc32("JMKwPXXtfgyZ",12) == 3250587889) strcat(s, "r");
if (crc32("qOnXaCpqIxcdDp",14) == 1139131928) strcat(s, "i");
if (crc32("XPgsuNBTAOOTqT",14) == 2705109273) strcat(s, "o");
if (crc32("XZWptewdifwKgb",14) == 1773532262) strcat(s, "F");
if (crc32("GQEfCkVlt",9) == 143503030) strcat(s, "u");
if (crc32("qxqGNNcd",8) == 3363207807) strcat(s, "a");
if (crc32("zyifppgg",8) == 3731872481) strcat(s, "s");
    return s;
}

char *interteam_adjectives() {
    char *s = calloc(10);
    if (crc32("oFgfsbYe",8) == 2314772607) strcat(s, "r");
if (crc32("plNhfbzxo",9) == 2242723400) strcat(s, "i");
if (crc32("COYLuaqAETwusCD",15) == 1169990317) strcat(s, "s");
if (crc32("KIVOnlCxjviyH",13) == 3659385397) strcat(s, "n");
if (crc32("IdSdnY",6) == 2324186947) strcat(s, "t");
if (crc32("VmxqtYV",7) == 2432539540) strcat(s, "r");
if (crc32("tePWTqGfAJnUD",13) == 2482318923) strcat(s, "e");
if (crc32("gtdTCYWvu",9) == 4098761295) strcat(s, "N");
if (crc32("TRKiOlzQdQzZxW",14) == 1612722942) strcat(s, "r");
if (crc32("NdNnpPdIou",10) == 3218902624) strcat(s, "t");
if (crc32("OHtatzqOmAhJV",13) == 2074522872) strcat(s, "e");
if (crc32("ccgZGJoqIWHuHR",14) == 869334665) strcat(s, "a");
if (crc32("IYPqXCoCubfZ",12) == 828037851) strcat(s, "m");
    return s;
}

char *sarcolemmous_adjectives() {
    char *s = calloc(13);
    if (crc32("scSPyEr",7) == 303507978) strcat(s, "s");
if (crc32("tSMKLlqiVuk",11) == 2993508742) strcat(s, "a");
if (crc32("EyLST",5) == 3289784556) strcat(s, "r");
if (crc32("OuOyeoBmo",9) == 913947554) strcat(s, "J");
if (crc32("xcymPpQUMBEWiiy",15) == 3898335930) strcat(s, "c");
if (crc32("zJKmLPxiCPOJHD",14) == 1702608366) strcat(s, "o");
if (crc32("ccLMnyOJ",8) == 953176077) strcat(s, "l");
if (crc32("lQGfsNZCe",9) == 3360270151) strcat(s, "v");
if (crc32("wyZltVwFEU",10) == 285165654) strcat(s, "e");
if (crc32("QLAlmTT",7) == 2263456742) strcat(s, "m");
if (crc32("nUYqzyiZf",9) == 529225566) strcat(s, "m");
if (crc32("kNQGjQ",6) == 2972232159) strcat(s, "o");
if (crc32("jHhttwkRENhop",13) == 3293820451) strcat(s, "u");
if (crc32("oAyexIlmdt",10) == 3045750764) strcat(s, "s");
    return s;
}

char *shipless_adjectives() {
    char *s = calloc(9);
    if (crc32("yudEC",5) == 3675959075) strcat(s, "Q");
if (crc32("zkuAjBlwtFUwT",13) == 83100706) strcat(s, "s");
if (crc32("OYouc",5) == 3255133443) strcat(s, "b");
if (crc32("MZGHojSHwAC",11) == 980255057) strcat(s, "h");
if (crc32("ZzjCw",5) == 3765884448) strcat(s, "i");
if (crc32("tSYvldpsQr",10) == 389418062) strcat(s, "X");
if (crc32("hdTcSZUgwMbuYxC",15) == 3123649774) strcat(s, "p");
if (crc32("PXZslpXVhri",11) == 2999668955) strcat(s, "l");
if (crc32("nmMEBOYPQI",10) == 3406375138) strcat(s, "e");
if (crc32("CKHVYlIoDCLZuB",14) == 1439752827) strcat(s, "s");
if (crc32("tPVucW",6) == 431686437) strcat(s, "P");
if (crc32("pWdjEusw",8) == 1533310846) strcat(s, "s");
    return s;
}

char *lived_adjectives() {
    char *s = calloc(6);
    if (crc32("uBRiFk",6) == 2455720237) strcat(s, "l");
if (crc32("jTBeo",5) == 715953001) strcat(s, "M");
if (crc32("gsqeXtEU",8) == 946758622) strcat(s, "i");
if (crc32("XjfAXaaJU",9) == 3214275779) strcat(s, "x");
if (crc32("PXftvPRaXZ",10) == 2836560075) strcat(s, "v");
if (crc32("CamXzAkrrOYOz",13) == 647994621) strcat(s, "e");
if (crc32("riSKSrd",7) == 248150947) strcat(s, "D");
if (crc32("OaalaD",6) == 614349482) strcat(s, "d");
    return s;
}

char *overbookish_adjectives() {
    char *s = calloc(12);
    if (crc32("jsPZnftUlXMav",13) == 887496686) strcat(s, "i");
if (crc32("koUoUpogJ",9) == 3712613259) strcat(s, "o");
if (crc32("IryCxAyrZwhJTT",14) == 320676024) strcat(s, "M");
if (crc32("zQnNApVXc",9) == 882349760) strcat(s, "v");
if (crc32("NunjlBDFUBMT",12) == 3044887737) strcat(s, "V");
if (crc32("hyywaAkk",8) == 3601394788) strcat(s, "e");
if (crc32("qNtBwgtySVCppd",14) == 2958874450) strcat(s, "r");
if (crc32("dzZOMpqx",8) == 3058277748) strcat(s, "F");
if (crc32("FhlIqmbxZOZ",11) == 901228209) strcat(s, "b");
if (crc32("exoxcZrCCSx",11) == 4086921023) strcat(s, "o");
if (crc32("tQFjOANkDrXggPk",15) == 3835442978) strcat(s, "o");
if (crc32("cLSeHST",7) == 3747175874) strcat(s, "B");
if (crc32("DOoMRzanBvd",11) == 1914254478) strcat(s, "k");
if (crc32("jQohBPkJV",9) == 179515123) strcat(s, "i");
if (crc32("TMyelWhEslfKHTS",15) == 2244477619) strcat(s, "s");
if (crc32("JWcqqWJG",8) == 3339103877) strcat(s, "q");
if (crc32("gOkoPH",6) == 327170352) strcat(s, "h");
    return s;
}

char *preseminary_adjectives() {
    char *s = calloc(12);
    if (crc32("QqGcf",5) == 2399580627) strcat(s, "p");
if (crc32("JQWfbvnAnWejV",13) == 418019682) strcat(s, "h");
if (crc32("BqyAxNHZiBeuVzk",15) == 123448595) strcat(s, "r");
if (crc32("pYfRTzRME",9) == 2399965813) strcat(s, "q");
if (crc32("nOdhQOmby",9) == 3780267462) strcat(s, "e");
if (crc32("EMLuTogcIMFT",12) == 3287397590) strcat(s, "s");
if (crc32("JOKRl",5) == 2807074586) strcat(s, "e");
if (crc32("fMfyIihLDEoqp",13) == 3839238783) strcat(s, "m");
if (crc32("CxnbtbIVbS",10) == 1559330169) strcat(s, "i");
if (crc32("pKauoOGSb",9) == 3518369802) strcat(s, "c");
if (crc32("TFeyobI",7) == 3478294668) strcat(s, "n");
if (crc32("czkGF",5) == 2016912350) strcat(s, "a");
if (crc32("RslKnW",6) == 2165370467) strcat(s, "g");
if (crc32("iDbPwBZggEgdWak",15) == 3640465025) strcat(s, "r");
if (crc32("lRklV",5) == 3880656314) strcat(s, "p");
if (crc32("jmQPT",5) == 1731148561) strcat(s, "y");
    return s;
}

char *bitchiest_adjectives() {
    char *s = calloc(10);
    if (crc32("kzSLvmSR",8) == 2903161484) strcat(s, "b");
if (crc32("HSLAZUijl",9) == 220590427) strcat(s, "i");
if (crc32("PGDqb",5) == 2259643354) strcat(s, "j");
if (crc32("eOoUyYOWYYdTlbG",15) == 3910483315) strcat(s, "t");
if (crc32("eEnFRGcAEzs",11) == 1265704598) strcat(s, "p");
if (crc32("wAfMa",5) == 2638226318) strcat(s, "c");
if (crc32("UYsJonkZoYGhUCN",15) == 1246832286) strcat(s, "h");
if (crc32("SySxwKHSLeoY",12) == 84043142) strcat(s, "o");
if (crc32("xUaKl",5) == 3989813545) strcat(s, "i");
if (crc32("EsNbKpPszBOdJ",13) == 2650533632) strcat(s, "e");
if (crc32("GZcVXXvRnaSqdi",14) == 2604235974) strcat(s, "s");
if (crc32("fAYBAHyDi",9) == 418523385) strcat(s, "t");
    return s;
}

char *untilling_adjectives() {
    char *s = calloc(10);
    if (crc32("HMwfcOarxXUm",12) == 269067328) strcat(s, "Q");
if (crc32("AXIuIkTcu",9) == 2677094080) strcat(s, "u");
if (crc32("pQbTclQEZtQMhCu",15) == 1696327457) strcat(s, "S");
if (crc32("kfZnOewYScoGfH",14) == 142828975) strcat(s, "n");
if (crc32("QOwxaAYppO",10) == 768621951) strcat(s, "Q");
if (crc32("QPMqwHeCT",9) == 3753423981) strcat(s, "t");
if (crc32("dyPMeOAkzcuI",12) == 1355999914) strcat(s, "i");
if (crc32("vXbBXfbqruxqLD",14) == 1630431629) strcat(s, "E");
if (crc32("aabaGeE",7) == 2021933347) strcat(s, "l");
if (crc32("XHHch",5) == 3822128819) strcat(s, "l");
if (crc32("hIXaYfedVH",10) == 3240625376) strcat(s, "U");
if (crc32("RrPRQGieT",9) == 108124071) strcat(s, "i");
if (crc32("YeybXxGgGDAgQ",13) == 4205376928) strcat(s, "n");
if (crc32("FEpPGLa",7) == 3293651213) strcat(s, "g");
    return s;
}

char *intermundane_adjectives() {
    char *s = calloc(13);
    if (crc32("FuZJPXR",7) == 2452731704) strcat(s, "i");
if (crc32("wjzKdxFBJ",9) == 4228865678) strcat(s, "i");
if (crc32("ehrJcQrhJR",10) == 49667441) strcat(s, "S");
if (crc32("lcSNQzWePOOkBkz",15) == 894268130) strcat(s, "n");
if (crc32("NlNbMXSJGn",10) == 4088529081) strcat(s, "t");
if (crc32("lEwTSp",6) == 36296793) strcat(s, "e");
if (crc32("fsdZNXEzZqcGU",13) == 3743203058) strcat(s, "r");
if (crc32("QejHxFXZWN",10) == 2930364396) strcat(s, "m");
if (crc32("rnnVmR",6) == 2375864036) strcat(s, "b");
if (crc32("KYuCYbOlyeC",11) == 848599120) strcat(s, "u");
if (crc32("VOxRN",5) == 4044222388) strcat(s, "n");
if (crc32("GxQdIWwhlfXP",12) == 1743806707) strcat(s, "d");
if (crc32("AywPTVhKYSXjg",13) == 459301839) strcat(s, "a");
if (crc32("oEKsLnLYw",9) == 1354346666) strcat(s, "m");
if (crc32("kYkPepETiaou",12) == 1374106716) strcat(s, "n");
if (crc32("ykaYCXqblz",10) == 3673102651) strcat(s, "a");
if (crc32("YgSaIaZM",8) == 2820824856) strcat(s, "e");
    return s;
}

char *halfprotested_adjectives() {
    char *s = calloc(14);
    if (crc32("VzmqrsIsr",9) == 213732945) strcat(s, "n");
if (crc32("huuXSEJYqWAzffS",15) == 2248411991) strcat(s, "h");
if (crc32("KjiScnBWLhu",11) == 2076208380) strcat(s, "a");
if (crc32("iEIIMEy",7) == 392081756) strcat(s, "u");
if (crc32("AGgAbjloJZJjb",13) == 1381570008) strcat(s, "l");
if (crc32("PHqAZPRjorOT",12) == 521063066) strcat(s, "F");
if (crc32("zdGuhBTodkYw",12) == 2597249847) strcat(s, "f");
if (crc32("IRAwYAMP",8) == 985519931) strcat(s, "p");
if (crc32("iAGbBf",6) == 3500415208) strcat(s, "p");
if (crc32("ijzuQSYJZRs",11) == 3446133374) strcat(s, "l");
if (crc32("cvuEIQbY",8) == 2971428142) strcat(s, "r");
if (crc32("BhQSQZ",6) == 1866799769) strcat(s, "o");
if (crc32("WdAFz",5) == 2609025075) strcat(s, "i");
if (crc32("zoIuJYzUOjuZgB",14) == 1541650159) strcat(s, "t");
if (crc32("cUVGTlj",7) == 1537220245) strcat(s, "j");
if (crc32("ZYhkPh",6) == 1779853467) strcat(s, "e");
if (crc32("vjdQQIJZLg",10) == 637797820) strcat(s, "f");
if (crc32("nApMoKJmIwUJZhg",15) == 3372444469) strcat(s, "s");
if (crc32("bcJERBHABKGdEp",14) == 3730751413) strcat(s, "t");
if (crc32("ttnqLMiHyEXKOGS",15) == 183186684) strcat(s, "e");
if (crc32("xlyqRF",6) == 1784912014) strcat(s, "c");
if (crc32("dLNNUjQfpUedoK",14) == 1654066644) strcat(s, "d");
    return s;
}

char *unpresentable_adjectives() {
    char *s = calloc(14);
    if (crc32("wmEmjusnRHOTcj",14) == 2767701892) strcat(s, "u");
if (crc32("YikCHca",7) == 1769286101) strcat(s, "u");
if (crc32("DRpGns",6) == 1262495748) strcat(s, "n");
if (crc32("lwBqLXi",7) == 157381186) strcat(s, "p");
if (crc32("NmcgzOqWyXpBn",13) == 210014190) strcat(s, "r");
if (crc32("yyaje",5) == 3473419608) strcat(s, "e");
if (crc32("AwxpnuzxIVSTFxh",15) == 121026862) strcat(s, "s");
if (crc32("fRJrUxzGJbywvr",14) == 1567125749) strcat(s, "a");
if (crc32("QMtnQptJa",9) == 385252511) strcat(s, "e");
if (crc32("qkVjpUCOYASCKkP",15) == 1674615810) strcat(s, "n");
if (crc32("WSGJntxA",8) == 1188982500) strcat(s, "t");
if (crc32("CdLcomah",8) == 3890455656) strcat(s, "F");
if (crc32("FWySXKBHxHcmXm",14) == 164693762) strcat(s, "a");
if (crc32("PGLRyddsThYgbrd",15) == 3596437857) strcat(s, "L");
if (crc32("ouCYke",6) == 676312772) strcat(s, "b");
if (crc32("xkGMc",5) == 4274204566) strcat(s, "f");
if (crc32("xuzxoYj",7) == 2172145435) strcat(s, "l");
if (crc32("OnnwCReAq",9) == 298234789) strcat(s, "e");
    return s;
}

char *barbate_adjectives() {
    char *s = calloc(8);
    if (crc32("sdcPoQmgHGH",11) == 541735091) strcat(s, "b");
if (crc32("ksOswIPcL",9) == 4120330080) strcat(s, "i");
if (crc32("VUuvWIAmXeZd",12) == 1398481471) strcat(s, "a");
if (crc32("wLUEjvwZ",8) == 1667973838) strcat(s, "r");
if (crc32("JkrwECoqaHYIbtT",15) == 1025917401) strcat(s, "G");
if (crc32("AzVnqjshMXtJ",12) == 1366733164) strcat(s, "b");
if (crc32("oPWomheQodfp",12) == 1618726328) strcat(s, "a");
if (crc32("qgybUvJXCf",10) == 453975690) strcat(s, "E");
if (crc32("qeREICcksioyrva",15) == 2054198102) strcat(s, "t");
if (crc32("tcVnkZXWdY",10) == 2002840611) strcat(s, "v");
if (crc32("vfGBM",5) == 285917506) strcat(s, "e");
    return s;
}

char *wrier_adjectives() {
    char *s = calloc(6);
    if (crc32("mVzMvWjDXVcWcDz",15) == 1441702613) strcat(s, "Q");
if (crc32("BvJdKcoTILjld",13) == 1603141081) strcat(s, "w");
if (crc32("aocjQLM",7) == 1279905756) strcat(s, "Q");
if (crc32("wJuCstePckHjdjh",15) == 2504446756) strcat(s, "r");
if (crc32("rBrcvGOLoi",10) == 2387581889) strcat(s, "R");
if (crc32("jYbQMcqTu",9) == 2628627062) strcat(s, "i");
if (crc32("fDVuEmr",7) == 3212148112) strcat(s, "w");
if (crc32("uTdLSQkuQns",11) == 324039367) strcat(s, "e");
if (crc32("DNEgnE",6) == 3729951085) strcat(s, "r");
    return s;
}

char *edgegrained_adjectives() {
    char *s = calloc(12);
    if (crc32("KkxXaVxzuMsvx",13) == 2393788759) strcat(s, "U");
if (crc32("UdAGJLDS",8) == 3264499999) strcat(s, "e");
if (crc32("FKTyLEhDQKKm",12) == 3006817895) strcat(s, "d");
if (crc32("zNqdPDwKGarw",12) == 1766484968) strcat(s, "g");
if (crc32("REQlTJtrfbo",11) == 2735403492) strcat(s, "e");
if (crc32("yredG",5) == 3263611890) strcat(s, "O");
if (crc32("lXaocGrniGEMsr",14) == 1252517852) strcat(s, "g");
if (crc32("wWmMjReX",8) == 2002107192) strcat(s, "r");
if (crc32("inxLa",5) == 806048836) strcat(s, "T");
if (crc32("CvNuRNAJynloANC",15) == 2962295013) strcat(s, "a");
if (crc32("EVIUiG",6) == 3419043352) strcat(s, "b");
if (crc32("DxvkppThqvv",11) == 2815130444) strcat(s, "i");
if (crc32("EKUXFI",6) == 4130062859) strcat(s, "n");
if (crc32("hstjzWikaMmOc",13) == 3898870016) strcat(s, "e");
if (crc32("AzgPHXyyFqv",11) == 2123877593) strcat(s, "d");
    return s;
}

char *actionless_adjectives() {
    char *s = calloc(11);
    if (crc32("inYkMOqKNG",10) == 3014159792) strcat(s, "q");
if (crc32("raMBMwHQcWSzgj",14) == 2856146000) strcat(s, "a");
if (crc32("tMqpbmktSZdi",12) == 2968203955) strcat(s, "F");
if (crc32("qaIhXU",6) == 475389490) strcat(s, "c");
if (crc32("uxNkfWKgxmrrc",13) == 2594094233) strcat(s, "t");
if (crc32("HnDcKOmlkBsbnSw",15) == 2227745745) strcat(s, "Y");
if (crc32("FiJIGhxdM",9) == 190207475) strcat(s, "i");
if (crc32("ZnRMVpiwHr",10) == 2915784230) strcat(s, "u");
if (crc32("vNJorvzLB",9) == 272656458) strcat(s, "o");
if (crc32("ZxXSJNJjCGvj",12) == 342883603) strcat(s, "w");
if (crc32("dbgCCHYtxr",10) == 3145837336) strcat(s, "n");
if (crc32("LEFPSfELy",9) == 4131257342) strcat(s, "l");
if (crc32("uMomDV",6) == 3776533582) strcat(s, "g");
if (crc32("VkVaumMtLqCdGm",14) == 1154183758) strcat(s, "e");
if (crc32("XxnLFupERN",10) == 833128528) strcat(s, "z");
if (crc32("pBSOrd",6) == 1836807119) strcat(s, "s");
if (crc32("PJHqPEdbIVIhIfF",15) == 1924104979) strcat(s, "s");
    return s;
}

char *medicinable_adjectives() {
    char *s = calloc(12);
    if (crc32("tsaLHitLSFh",11) == 51886405) strcat(s, "m");
if (crc32("exWit",5) == 3017792173) strcat(s, "e");
if (crc32("WyqNZourvniAd",13) == 577561250) strcat(s, "d");
if (crc32("btdJOheSEH",10) == 4014656411) strcat(s, "i");
if (crc32("gVnBmieOeQ",10) == 2317826078) strcat(s, "E");
if (crc32("INONkz",6) == 4059881152) strcat(s, "c");
if (crc32("QVwPiwyecuLw",12) == 1482161981) strcat(s, "i");
if (crc32("YgZnMhDS",8) == 4288534900) strcat(s, "U");
if (crc32("idorMo",6) == 1583429718) strcat(s, "n");
if (crc32("aNgShAX",7) == 3175335224) strcat(s, "a");
if (crc32("EiJTPs",6) == 2531159207) strcat(s, "b");
if (crc32("oWAWpkfYgUrhyhB",15) == 409646974) strcat(s, "l");
if (crc32("UfqbyaGcTcW",11) == 1660103425) strcat(s, "e");
    return s;
}

char *preSumerian_adjectives() {
    char *s = calloc(12);
    if (crc32("XLWhJn",6) == 2090784802) strcat(s, "p");
if (crc32("KpYPHfYVTBoOGDL",15) == 3047709070) strcat(s, "r");
if (crc32("MmAmWERsCiGN",12) == 3100803254) strcat(s, "U");
if (crc32("lnwWzYf",7) == 1751274487) strcat(s, "e");
if (crc32("XgdJNOCQJfS",11) == 419669171) strcat(s, "S");
if (crc32("wFkQGm",6) == 4126866095) strcat(s, "J");
if (crc32("wxgInxaZEaHJ",12) == 3463967804) strcat(s, "u");
if (crc32("rUPHOKhbj",9) == 1441298907) strcat(s, "W");
if (crc32("GnkRRYWnrHFvXiq",15) == 3189616368) strcat(s, "m");
if (crc32("nEWFsOFnBdyKpDb",15) == 1471629796) strcat(s, "i");
if (crc32("uQGuV",5) == 557060690) strcat(s, "e");
if (crc32("hFvYLcRY",8) == 3881172452) strcat(s, "i");
if (crc32("eKqvfzlRtOba",12) == 904120107) strcat(s, "r");
if (crc32("txpWyBPoNlZnMs",14) == 1712455752) strcat(s, "i");
if (crc32("wJmnubMVhPVyd",13) == 795104494) strcat(s, "a");
if (crc32("UcGPLrTDTJaDsbZ",15) == 2311859788) strcat(s, "n");
    return s;
}

char *fiftyfifty_adjectives() {
    char *s = calloc(11);
    if (crc32("NoVuokgSvM",10) == 3268448926) strcat(s, "C");
if (crc32("xZqilHCIIs",10) == 2522134325) strcat(s, "f");
if (crc32("EvpIRAvqE",9) == 3717794759) strcat(s, "i");
if (crc32("jAZGkWYBhRFJFU",14) == 3097024076) strcat(s, "f");
if (crc32("HWgyLTcmJvs",11) == 433533934) strcat(s, "t");
if (crc32("pWLrq",5) == 715198131) strcat(s, "y");
if (crc32("KUwgUXleGjnBlK",14) == 1805750968) strcat(s, "f");
if (crc32("SYXEDZsfCiawUI",14) == 3580001919) strcat(s, "B");
if (crc32("siTgOfQbnsfoH",13) == 409753408) strcat(s, "i");
if (crc32("IWxzQ",5) == 408495800) strcat(s, "B");
if (crc32("MlCMo",5) == 4256652614) strcat(s, "f");
if (crc32("gJLor",5) == 1014495173) strcat(s, "t");
if (crc32("PCzYBrLrctC",11) == 1846328745) strcat(s, "y");
    return s;
}

char *uninvoiced_adjectives() {
    char *s = calloc(11);
    if (crc32("eEwfpZgSVjH",11) == 1698998407) strcat(s, "O");
if (crc32("XmbRBqEnVX",10) == 588355656) strcat(s, "u");
if (crc32("lQhPm",5) == 640540607) strcat(s, "n");
if (crc32("syCZsYrI",8) == 3448539975) strcat(s, "i");
if (crc32("RTWMu",5) == 608905292) strcat(s, "S");
if (crc32("bzKNnd",6) == 3224136450) strcat(s, "n");
if (crc32("jBEaHDxPtbHq",12) == 1682585216) strcat(s, "d");
if (crc32("HxcWNJT",7) == 2569389026) strcat(s, "v");
if (crc32("pXaDgAtlIroT",12) == 3952086343) strcat(s, "o");
if (crc32("iRGfsASLk",9) == 2203694579) strcat(s, "F");
if (crc32("yteQppxQUpr",11) == 942167125) strcat(s, "i");
if (crc32("AtboUFyE",8) == 3068386989) strcat(s, "c");
if (crc32("iSgIIHLTgHk",11) == 3286640994) strcat(s, "u");
if (crc32("YiUVIph",7) == 156375966) strcat(s, "e");
if (crc32("BWJusxqTvcPveA",14) == 2855816656) strcat(s, "Y");
if (crc32("ViZHNBTwFknuv",13) == 708490720) strcat(s, "d");
    return s;
}

char *sudorific_adjectives() {
    char *s = calloc(10);
    if (crc32("AArnXhsQaloe",12) == 2475348311) strcat(s, "v");
if (crc32("LdMjpwjUx",9) == 3587511418) strcat(s, "s");
if (crc32("WNbfWkSo",8) == 4160608555) strcat(s, "i");
if (crc32("HZmiGiREBjGhk",13) == 1656040135) strcat(s, "u");
if (crc32("wuQNu",5) == 4074387667) strcat(s, "d");
if (crc32("TDImTezmpB",10) == 2859025479) strcat(s, "p");
if (crc32("FvYBXelfpDGqFf",14) == 2036454739) strcat(s, "o");
if (crc32("VerZbzyxDRcdZI",14) == 1825185969) strcat(s, "r");
if (crc32("TFmvZCjygRhD",12) == 604061189) strcat(s, "i");
if (crc32("UwOXhqEp",8) == 3521963818) strcat(s, "f");
if (crc32("jTiKRjklqo",10) == 3080693561) strcat(s, "N");
if (crc32("qNJMI",5) == 1317130502) strcat(s, "i");
if (crc32("iNNIfuwvyxpTF",13) == 3380385170) strcat(s, "c");
    return s;
}

char *bosomy_adjectives() {
    char *s = calloc(7);
    if (crc32("aIzrFELbNUc",11) == 245064637) strcat(s, "b");
if (crc32("jdSZx",5) == 1289400991) strcat(s, "n");
if (crc32("iqXDqYlRZv",10) == 228624687) strcat(s, "o");
if (crc32("DxKWAKwj",8) == 1788894792) strcat(s, "s");
if (crc32("FXwWUzlafcT",11) == 1578633401) strcat(s, "o");
if (crc32("oulcfLMwTNjFP",13) == 3348063723) strcat(s, "z");
if (crc32("CRTqXARl",8) == 2529145720) strcat(s, "m");
if (crc32("XMREW",5) == 2953213502) strcat(s, "y");
    return s;
}

char *lamprophyric_adjectives() {
    char *s = calloc(13);
    if (crc32("WTefG",5) == 2467250758) strcat(s, "E");
if (crc32("pUlcX",5) == 2844670884) strcat(s, "l");
if (crc32("hclXCDBwlLqGUOA",15) == 1691679085) strcat(s, "s");
if (crc32("UMPvwPjiuP",10) == 1300111040) strcat(s, "a");
if (crc32("cgHRVxRnAY",10) == 2545822161) strcat(s, "d");
if (crc32("blFidljp",8) == 3427205746) strcat(s, "m");
if (crc32("QwHwXKYplzFckoP",15) == 275299133) strcat(s, "X");
if (crc32("EkXyWygzbIyRtGF",15) == 2343343224) strcat(s, "p");
if (crc32("IaDnlPPQOYlc",12) == 1412433096) strcat(s, "r");
if (crc32("uxvhRkh",7) == 2543785544) strcat(s, "J");
if (crc32("DkxOHzpzWQw",11) == 3152580795) strcat(s, "o");
if (crc32("BBGHPjiNUOgL",12) == 1401013749) strcat(s, "w");
if (crc32("xGnjKUYoKHJOi",13) == 787510442) strcat(s, "p");
if (crc32("WydSfiZVNF",10) == 2004439915) strcat(s, "d");
if (crc32("QZLIXCNoEDDJ",12) == 3036193877) strcat(s, "h");
if (crc32("SXMPZTAhdZtmzl",14) == 163599032) strcat(s, "C");
if (crc32("wJATkmTWdZqA",12) == 3648694762) strcat(s, "y");
if (crc32("bOiSkpPqSVFEAF",14) == 930422131) strcat(s, "r");
if (crc32("dWHJrcYB",8) == 175864820) strcat(s, "v");
if (crc32("lqwZimNBurvjvC",14) == 4030104302) strcat(s, "i");
if (crc32("jrncbsUeDPuD",12) == 3482256010) strcat(s, "l");
if (crc32("FqoBubiGEVuQVJ",14) == 1410122638) strcat(s, "c");
    return s;
}

char *secondary_adjectives() {
    char *s = calloc(10);
    if (crc32("BknVAOLlhnyWZUl",15) == 1557232929) strcat(s, "s");
if (crc32("vuisfWSFWFTjh",13) == 3138022982) strcat(s, "y");
if (crc32("KuTttT",6) == 3584902613) strcat(s, "e");
if (crc32("nJBLUyHZNySlI",13) == 3610733367) strcat(s, "n");
if (crc32("FvteMw",6) == 1067890282) strcat(s, "c");
if (crc32("iFvNfm",6) == 4052481334) strcat(s, "u");
if (crc32("euluMMhzl",9) == 498716637) strcat(s, "o");
if (crc32("FFYHC",5) == 469146893) strcat(s, "n");
if (crc32("MTgyyvpCvZt",11) == 3724664257) strcat(s, "d");
if (crc32("UBQUkMZWWwiYDO",14) == 121903065) strcat(s, "q");
if (crc32("SnGSdZspRnEKSBw",15) == 2538148593) strcat(s, "a");
if (crc32("gfcYOjXePDmVd",13) == 4126883850) strcat(s, "r");
if (crc32("DtpTGXQQYqQ",11) == 2381165489) strcat(s, "y");
    return s;
}

char *seminervous_adjectives() {
    char *s = calloc(12);
    if (crc32("JCBkwbPAUwCRoA",14) == 773031403) strcat(s, "s");
if (crc32("jNyLlwbY",8) == 3827389028) strcat(s, "e");
if (crc32("kOsCnpHsaVByxg",14) == 1237291064) strcat(s, "M");
if (crc32("LBZzqTQcVaWlku",14) == 2012503946) strcat(s, "m");
if (crc32("QtpcpM",6) == 2016102757) strcat(s, "r");
if (crc32("NQXsTPyQb",9) == 2851847883) strcat(s, "i");
if (crc32("LqpyQvNaJL",10) == 2736174774) strcat(s, "n");
if (crc32("DRQQsDmWFuOht",13) == 3762648457) strcat(s, "m");
if (crc32("MKkvWxAfWkpL",12) == 2597450530) strcat(s, "e");
if (crc32("DfSbMcYWbZN",11) == 2081079576) strcat(s, "a");
if (crc32("yrrhbijFfPQx",12) == 214752368) strcat(s, "r");
if (crc32("RtFMLJkcb",9) == 2148709367) strcat(s, "Z");
if (crc32("UxTHsGszSITW",12) == 1591070569) strcat(s, "v");
if (crc32("vUizoB",6) == 4189392159) strcat(s, "o");
if (crc32("PiTWBmOWfPp",11) == 781528605) strcat(s, "R");
if (crc32("laktPldXc",9) == 4193882817) strcat(s, "u");
if (crc32("mxpDgaAVoW",10) == 1393702546) strcat(s, "L");
if (crc32("QmOskQqIYcXoZlH",15) == 1710871087) strcat(s, "s");
    return s;
}

char *riotous_adjectives() {
    char *s = calloc(8);
    if (crc32("zrQWcldbXQjTqs",14) == 683125895) strcat(s, "r");
if (crc32("tEubbTgiQjW",11) == 2290367538) strcat(s, "K");
if (crc32("jAKhR",5) == 1652954367) strcat(s, "i");
if (crc32("ikZvlKGs",8) == 1163461819) strcat(s, "T");
if (crc32("LmvPFqYDwgx",11) == 2791275217) strcat(s, "o");
if (crc32("qxVuxghPIRW",11) == 39636160) strcat(s, "d");
if (crc32("lXlQvg",6) == 1890241599) strcat(s, "t");
if (crc32("pTGpB",5) == 3114749224) strcat(s, "o");
if (crc32("PgadAaVohgy",11) == 2979071619) strcat(s, "V");
if (crc32("NiOflqqIBM",10) == 1452058182) strcat(s, "u");
if (crc32("WfDdmbtEOm",10) == 2437393146) strcat(s, "w");
if (crc32("piPRHFc",7) == 200891708) strcat(s, "s");
    return s;
}

char *retarded_adjectives() {
    char *s = calloc(9);
    if (crc32("BRbQlhjXXBTcjaI",15) == 1733221228) strcat(s, "Z");
if (crc32("jxDAIWGCIWX",11) == 373355825) strcat(s, "r");
if (crc32("bXgWwsNkk",9) == 4230446769) strcat(s, "p");
if (crc32("yViINCaXaoDzec",14) == 384766518) strcat(s, "e");
if (crc32("tqiOdVBSSY",10) == 2129114301) strcat(s, "t");
if (crc32("xZmTpVVecqiGDg",14) == 1479272462) strcat(s, "J");
if (crc32("ABjpSp",6) == 2517398495) strcat(s, "a");
if (crc32("JTPzGPcNiw",10) == 1528146575) strcat(s, "r");
if (crc32("aLIzr",5) == 194813292) strcat(s, "W");
if (crc32("IDTMWJuQB",9) == 1247933539) strcat(s, "d");
if (crc32("pybNsiHYtIta",12) == 3359018832) strcat(s, "m");
if (crc32("ITahYlh",7) == 1751973082) strcat(s, "e");
if (crc32("VuVJAkidJSge",12) == 3486687480) strcat(s, "r");
if (crc32("OgYnZ",5) == 2849840323) strcat(s, "d");
    return s;
}

char *noncivilizable_adjectives() {
    char *s = calloc(15);
    if (crc32("RLZcPBcF",8) == 3950090270) strcat(s, "n");
if (crc32("yJmAukUwmovQAxr",15) == 4124688541) strcat(s, "n");
if (crc32("SyevgqWvw",9) == 1012531270) strcat(s, "o");
if (crc32("oQGdaD",6) == 156837440) strcat(s, "n");
if (crc32("EGOzFWinSxbtWc",14) == 3148961548) strcat(s, "c");
if (crc32("cNeeuvXcbqkiqge",15) == 2023728300) strcat(s, "i");
if (crc32("AXmQbXiOg",9) == 2330609936) strcat(s, "v");
if (crc32("hUSibVTJfJB",11) == 3870643352) strcat(s, "E");
if (crc32("ETKZcG",6) == 2828192634) strcat(s, "i");
if (crc32("eqetoHYpkt",10) == 285518597) strcat(s, "l");
if (crc32("dUSuqErFY",9) == 940280417) strcat(s, "i");
if (crc32("ttGAMExkgu",10) == 3008131230) strcat(s, "z");
if (crc32("XKlQZUKVtNQtuUX",15) == 603019605) strcat(s, "N");
if (crc32("HhxaZ",5) == 4253671581) strcat(s, "a");
if (crc32("FDPEfaDXLvB",11) == 3241656041) strcat(s, "b");
if (crc32("KZPxh",5) == 2239907239) strcat(s, "l");
if (crc32("ViywarLlHXS",11) == 412710956) strcat(s, "d");
if (crc32("eWyZDwAhWvDoCAt",15) == 2391530964) strcat(s, "e");
    return s;
}

char *maddest_adjectives() {
    char *s = calloc(8);
    if (crc32("TaDxQciUyRZv",12) == 1967122405) strcat(s, "m");
if (crc32("zbhnLnXbaIJhb",13) == 2932264520) strcat(s, "f");
if (crc32("kiwrmsuUrG",10) == 772803756) strcat(s, "a");
if (crc32("rbckHqavVjuR",12) == 729972219) strcat(s, "j");
if (crc32("vUzCrKhgnjcIVqe",15) == 1135592540) strcat(s, "d");
if (crc32("FwwWR",5) == 3327674191) strcat(s, "d");
if (crc32("jAAKfOqpdhMyg",13) == 3090342810) strcat(s, "e");
if (crc32("QGXQblclmV",10) == 2837536199) strcat(s, "Q");
if (crc32("QLNXMIHDtTPSwQV",15) == 1602931165) strcat(s, "s");
if (crc32("gEKFnwHbGTR",11) == 3282812175) strcat(s, "t");
    return s;
}

char *nonSanskritic_adjectives() {
    char *s = calloc(14);
    if (crc32("GtqAqzPbtNrHU",13) == 1747853271) strcat(s, "I");
if (crc32("ArljgwStbk",10) == 3184368620) strcat(s, "n");
if (crc32("taFrDlInVS",10) == 2984774444) strcat(s, "o");
if (crc32("BfBpotGf",8) == 882058888) strcat(s, "b");
if (crc32("UHWoUHwdCtPsLt",14) == 4006150570) strcat(s, "n");
if (crc32("BgEaDwkihyjJ",12) == 3771289639) strcat(s, "q");
if (crc32("ecBmTizlJpRhi",13) == 2976085902) strcat(s, "S");
if (crc32("WZhhmnd",7) == 1886747565) strcat(s, "a");
if (crc32("gIFbYPAIkKcI",12) == 2336612130) strcat(s, "q");
if (crc32("aMueIAiFjFRjBoj",15) == 3533942334) strcat(s, "n");
if (crc32("KltZhUZM",8) == 3527828044) strcat(s, "I");
if (crc32("KKKPzPoqIYpBxv",14) == 925450365) strcat(s, "s");
if (crc32("fNTBxcvtT",9) == 4290407548) strcat(s, "U");
if (crc32("ZoSoFxyyPvWC",12) == 3599249066) strcat(s, "k");
if (crc32("VUjfPCrmzY",10) == 2475376074) strcat(s, "r");
if (crc32("FaZnCLRl",8) == 279846973) strcat(s, "i");
if (crc32("VIhfOFxauMNH",12) == 959044067) strcat(s, "S");
if (crc32("LswjAvvuOUCxDk",14) == 3926203428) strcat(s, "t");
if (crc32("UBCaiFuzajV",11) == 1080749286) strcat(s, "m");
if (crc32("DJGbnxAInZNl",12) == 1770591722) strcat(s, "i");
if (crc32("wJmmBg",6) == 3672920361) strcat(s, "k");
if (crc32("bRypJR",6) == 2065204040) strcat(s, "c");
    return s;
}

char *abortional_adjectives() {
    char *s = calloc(11);
    if (crc32("HRMAGIEtASf",11) == 3920487612) strcat(s, "a");
if (crc32("Lvymh",5) == 3715043914) strcat(s, "b");
if (crc32("mlIDfUg",7) == 300819024) strcat(s, "o");
if (crc32("KBVWP",5) == 244730996) strcat(s, "U");
if (crc32("RJkMJ",5) == 3875827432) strcat(s, "r");
if (crc32("piuuFz",6) == 2051573648) strcat(s, "U");
if (crc32("jKDAkPebiohKVV",14) == 4142663919) strcat(s, "t");
if (crc32("rcORRklYPGII",12) == 2327662913) strcat(s, "a");
if (crc32("NawSXEiOebRKm",13) == 3108940269) strcat(s, "i");
if (crc32("YxWRYfVsw",9) == 1769311918) strcat(s, "o");
if (crc32("ljcIBlB",7) == 1646236224) strcat(s, "n");
if (crc32("fdIOVHPgif",10) == 2655137369) strcat(s, "a");
if (crc32("tqqrUHZhJHCtfHE",15) == 2809882871) strcat(s, "E");
if (crc32("xhMlj",5) == 3984535937) strcat(s, "l");
    return s;
}

char *wellstyled_adjectives() {
    char *s = calloc(11);
    if (crc32("OrLKmXjgIjVN",12) == 1079846391) strcat(s, "w");
if (crc32("SfjJsMY",7) == 2224911133) strcat(s, "b");
if (crc32("JEcCoHLnV",9) == 3127781638) strcat(s, "e");
if (crc32("vBGIRvINWbaQ",12) == 2526207860) strcat(s, "X");
if (crc32("aLHRb",5) == 3859459519) strcat(s, "l");
if (crc32("ikBRAsfhzBeT",12) == 930673840) strcat(s, "l");
if (crc32("HDzhjZAHyr",10) == 2924165162) strcat(s, "s");
if (crc32("pDdICwDiqctK",12) == 3830672086) strcat(s, "M");
if (crc32("vcTgcjlDmeF",11) == 787424161) strcat(s, "t");
if (crc32("FWCRCFqOWK",10) == 2542503194) strcat(s, "y");
if (crc32("YrmfmcX",7) == 3557127817) strcat(s, "u");
if (crc32("KjkwaYX",7) == 769233524) strcat(s, "l");
if (crc32("YQLFPDzSQK",10) == 325113154) strcat(s, "e");
if (crc32("DXwmsduybM",10) == 3474870312) strcat(s, "y");
if (crc32("xIJgUrFx",8) == 495891858) strcat(s, "d");
    return s;
}

char *gonopodial_adjectives() {
    char *s = calloc(11);
    if (crc32("NmBqpCRAEeYILsK",15) == 3913906916) strcat(s, "g");
if (crc32("kupnhe",6) == 1531511627) strcat(s, "g");
if (crc32("RmSOshHQawNPe",13) == 2339980437) strcat(s, "o");
if (crc32("eeiNiz",6) == 2162989048) strcat(s, "n");
if (crc32("bbdWsUuOQ",9) == 1550478196) strcat(s, "W");
if (crc32("EPWxOxrwYh",10) == 3860564853) strcat(s, "o");
if (crc32("xjcXmYQqigiLyME",15) == 1145994111) strcat(s, "p");
if (crc32("SzCnSmBmHmQwUQL",15) == 1398887122) strcat(s, "c");
if (crc32("OpnxlJCHQXP",11) == 3829110449) strcat(s, "o");
if (crc32("rrAVfobAut",10) == 3941885993) strcat(s, "H");
if (crc32("QgrGJHNW",8) == 257143860) strcat(s, "d");
if (crc32("gFpqOxzWmGuQjZ",14) == 3129462317) strcat(s, "i");
if (crc32("qtlFFXWFu",9) == 2322156563) strcat(s, "a");
if (crc32("aTKnShVKrifgk",13) == 3453655001) strcat(s, "l");
    return s;
}

char *unconvulsed_adjectives() {
    char *s = calloc(12);
    if (crc32("idApyvbA",8) == 4176656094) strcat(s, "u");
if (crc32("bIhVAY",6) == 2644329629) strcat(s, "z");
if (crc32("MbDBFmCtdMm",11) == 440049686) strcat(s, "n");
if (crc32("stKfliFra",9) == 3604684829) strcat(s, "c");
if (crc32("BsjaXPXACkQh",12) == 856902605) strcat(s, "k");
if (crc32("sMCvsxD",7) == 1657631197) strcat(s, "o");
if (crc32("tqouzTkOIJxVUKX",15) == 2145301866) strcat(s, "n");
if (crc32("ebxfmNgWYke",11) == 3098443729) strcat(s, "v");
if (crc32("EHaul",5) == 1472745761) strcat(s, "u");
if (crc32("FLvxiEZUFVrw",12) == 1235413801) strcat(s, "l");
if (crc32("yBbOMnwqUmk",11) == 429437872) strcat(s, "s");
if (crc32("oQFfJQVNR",9) == 3883216377) strcat(s, "e");
if (crc32("QTJrkDonwD",10) == 1859178586) strcat(s, "N");
if (crc32("ugBtDI",6) == 953136515) strcat(s, "d");
    return s;
}

char *ammono_adjectives() {
    char *s = calloc(7);
    if (crc32("TuHROLiOW",9) == 3576448749) strcat(s, "a");
if (crc32("AWHxH",5) == 335763419) strcat(s, "m");
if (crc32("cXFZthMPTWLg",12) == 732751706) strcat(s, "m");
if (crc32("gqLzSlqRxjgdyt",14) == 1050678494) strcat(s, "o");
if (crc32("JZQgQzQzruwuG",13) == 333823533) strcat(s, "V");
if (crc32("yVQykuk",7) == 3785734563) strcat(s, "n");
if (crc32("vbXZKrO",7) == 2862483482) strcat(s, "f");
if (crc32("ZbDJu",5) == 2026117343) strcat(s, "o");
    return s;
}

char *hyperadipose_adjectives() {
    char *s = calloc(13);
    if (crc32("nmdGM",5) == 1525947501) strcat(s, "e");
if (crc32("aQAhKufmaiG",11) == 2980252704) strcat(s, "h");
if (crc32("MvXKkdJEQIdz",12) == 1150906758) strcat(s, "y");
if (crc32("oXYObvfCGyMO",12) == 393369316) strcat(s, "W");
if (crc32("CBszpGSlp",9) == 355553240) strcat(s, "p");
if (crc32("HHXdq",5) == 3347534170) strcat(s, "N");
if (crc32("AswElssJkuh",11) == 1247285357) strcat(s, "e");
if (crc32("WlsJqCg",7) == 323096442) strcat(s, "r");
if (crc32("svzXMLs",7) == 3439948600) strcat(s, "y");
if (crc32("vzUJUb",6) == 980806130) strcat(s, "a");
if (crc32("YMFCtevwc",9) == 1820768643) strcat(s, "h");
if (crc32("GkJhSjptBkyYM",13) == 3767710048) strcat(s, "d");
if (crc32("uDOCyxnpFb",10) == 2597469332) strcat(s, "i");
if (crc32("lLoGsIWa",8) == 884629318) strcat(s, "X");
if (crc32("ppJleCc",7) == 1483091752) strcat(s, "p");
if (crc32("tkqiWpck",8) == 3419827210) strcat(s, "b");
if (crc32("asGWePiyGR",10) == 2530391947) strcat(s, "o");
if (crc32("RQyrdjFbWcPU",12) == 986288098) strcat(s, "s");
if (crc32("ThFnEnHgeZCTCdp",15) == 999443017) strcat(s, "S");
if (crc32("BSsLcS",6) == 811203619) strcat(s, "e");
    return s;
}

char *unexecutable_adjectives() {
    char *s = calloc(13);
    if (crc32("PnIzv",5) == 909462492) strcat(s, "u");
if (crc32("DkSCEqjyfs",10) == 1787867563) strcat(s, "n");
if (crc32("MixmHzQLdUcAn",13) == 2574120428) strcat(s, "q");
if (crc32("EZkhaMBGfEvfdIM",15) == 2364635308) strcat(s, "e");
if (crc32("iTpITS",6) == 1802180855) strcat(s, "x");
if (crc32("nyTekPgHbK",10) == 1289422312) strcat(s, "e");
if (crc32("njCzWzdebS",10) == 1121059225) strcat(s, "V");
if (crc32("yFxTzkhZ",8) == 3181301322) strcat(s, "c");
if (crc32("tVcbAhmE",8) == 3542532194) strcat(s, "u");
if (crc32("AqmsMqHtdnaHI",13) == 3694059275) strcat(s, "W");
if (crc32("fRyFJZIkq",9) == 372346389) strcat(s, "t");
if (crc32("Hbciaphv",8) == 1511587493) strcat(s, "a");
if (crc32("sAShOrn",7) == 634608372) strcat(s, "q");
if (crc32("vMOdeuQ",7) == 3486345483) strcat(s, "b");
if (crc32("VbzkGEODXEOmvdY",15) == 4218348822) strcat(s, "l");
if (crc32("LVlWRGQJN",9) == 2733077394) strcat(s, "e");
    return s;
}

char *blamable_adjectives() {
    char *s = calloc(9);
    if (crc32("KybeZlOdvMG",11) == 3480983232) strcat(s, "h");
if (crc32("wGUdPCFLRTlBtlC",15) == 3027097685) strcat(s, "b");
if (crc32("pMtnb",5) == 1459467519) strcat(s, "y");
if (crc32("ZfASTaAAX",9) == 3423914998) strcat(s, "l");
if (crc32("IEcKNnCsvVyYP",13) == 3663907583) strcat(s, "a");
if (crc32("gvxlkZT",7) == 3733234830) strcat(s, "m");
if (crc32("csFLovcL",8) == 2689018070) strcat(s, "a");
if (crc32("vjaoTX",6) == 44897882) strcat(s, "l");
if (crc32("mmORbP",6) == 4108707007) strcat(s, "b");
if (crc32("UrCxiXa",7) == 341993843) strcat(s, "l");
if (crc32("XNztwjeiGKYV",12) == 3206363917) strcat(s, "W");
if (crc32("RrhKKmvSQj",10) == 4016606580) strcat(s, "e");
    return s;
}

char *buccolingual_adjectives() {
    char *s = calloc(13);
    if (crc32("juZWlY",6) == 652915305) strcat(s, "L");
if (crc32("FiyQALhW",8) == 3215182147) strcat(s, "b");
if (crc32("hevwy",5) == 1903975863) strcat(s, "I");
if (crc32("qqyULbN",7) == 2687743677) strcat(s, "u");
if (crc32("HhLGx",5) == 3361042193) strcat(s, "c");
if (crc32("PjanRexXr",9) == 4258460616) strcat(s, "D");
if (crc32("xyxiVcnG",8) == 2802183481) strcat(s, "c");
if (crc32("UAZpiBXcrDzkVAt",15) == 2854594498) strcat(s, "o");
if (crc32("vuOtreXaz",9) == 2189652496) strcat(s, "o");
if (crc32("CoQMOTrgkPd",11) == 1730804806) strcat(s, "l");
if (crc32("VIKgCPGUSEeFob",14) == 2695531590) strcat(s, "v");
if (crc32("VRYuidbfpsPF",12) == 2364229312) strcat(s, "i");
if (crc32("nklyt",5) == 3102960925) strcat(s, "C");
if (crc32("RsJTRshz",8) == 3870738888) strcat(s, "n");
if (crc32("EbJIV",5) == 429922103) strcat(s, "g");
if (crc32("EArauJJvnemmOEi",15) == 1439751258) strcat(s, "u");
if (crc32("oZGhWNVqJfZoIo",14) == 2704875150) strcat(s, "a");
if (crc32("eehtsqA",7) == 1420810484) strcat(s, "V");
if (crc32("MVpbA",5) == 2328243176) strcat(s, "l");
    return s;
}

char *congestus_adjectives() {
    char *s = calloc(10);
    if (crc32("RLmsYGVhbmI",11) == 31002770) strcat(s, "z");
if (crc32("zQkrcHZ",7) == 3304959388) strcat(s, "c");
if (crc32("QoUugoSNDVqg",12) == 2844938655) strcat(s, "o");
if (crc32("JDJiJvMznJoo",12) == 38348965) strcat(s, "J");
if (crc32("hXVBwBbGHNe",11) == 3798390542) strcat(s, "n");
if (crc32("aBDbdxxfmlofAfk",15) == 2707730968) strcat(s, "z");
if (crc32("uVSgsebZxHjHHj",14) == 181712443) strcat(s, "g");
if (crc32("rcpQBdB",7) == 147143729) strcat(s, "e");
if (crc32("LhfCZLe",7) == 1703675586) strcat(s, "s");
if (crc32("vRtaZ",5) == 1964247003) strcat(s, "t");
if (crc32("qydrEnyUAQFTiV",14) == 451584436) strcat(s, "u");
if (crc32("jqoxQP",6) == 762554300) strcat(s, "s");
    return s;
}

char *annectent_adjectives() {
    char *s = calloc(10);
    if (crc32("OdNBU",5) == 193949927) strcat(s, "a");
if (crc32("AomBYghsAUy",11) == 4098571146) strcat(s, "L");
if (crc32("UzEauyzJi",9) == 1985743026) strcat(s, "n");
if (crc32("xWDDZ",5) == 709201396) strcat(s, "d");
if (crc32("zGeUABRE",8) == 2941856683) strcat(s, "n");
if (crc32("ZrcjqrEXbtddaZ",14) == 3253619176) strcat(s, "P");
if (crc32("tpDqFbcBZcTSgPa",15) == 1183225262) strcat(s, "e");
if (crc32("wiumBCpHT",9) == 479209056) strcat(s, "c");
if (crc32("ntSnLoOjy",9) == 1228578471) strcat(s, "t");
if (crc32("YHiKoxNdxmZ",11) == 2838060393) strcat(s, "e");
if (crc32("SCEfIrjWlg",10) == 3275026859) strcat(s, "R");
if (crc32("FdTCpXo",7) == 2524876652) strcat(s, "n");
if (crc32("qSsEks",6) == 1786222966) strcat(s, "V");
if (crc32("puOrmxcRF",9) == 2486793296) strcat(s, "t");
    return s;
}

char *lexicological_adjectives() {
    char *s = calloc(14);
    if (crc32("RHIcZ",5) == 1618226597) strcat(s, "l");
if (crc32("VbVOURSmc",9) == 35295109) strcat(s, "G");
if (crc32("fJjDGF",6) == 2124612112) strcat(s, "e");
if (crc32("KOmEvXIFZGWEcq",14) == 2699694694) strcat(s, "i");
if (crc32("lBCkTDE",7) == 2575874401) strcat(s, "x");
if (crc32("CiaoAQvJzWbu",12) == 523653366) strcat(s, "i");
if (crc32("QDhBSOByvD",10) == 983768893) strcat(s, "U");
if (crc32("pLFLKVIiLvfsB",13) == 146344517) strcat(s, "c");
if (crc32("spwzclLouhGM",12) == 3894456034) strcat(s, "b");
if (crc32("BhciUr",6) == 1296181003) strcat(s, "o");
if (crc32("rhfHYtljsOhSh",13) == 874660719) strcat(s, "l");
if (crc32("StkKxLATHjrOta",14) == 1174324384) strcat(s, "C");
if (crc32("eZBCx",5) == 3319028864) strcat(s, "o");
if (crc32("nZaSUfZvMiinWUP",15) == 3453586697) strcat(s, "g");
if (crc32("FjBdiZUHZphg",12) == 2285626680) strcat(s, "L");
if (crc32("IYWbe",5) == 639904202) strcat(s, "i");
if (crc32("pNohbl",6) == 3238965644) strcat(s, "z");
if (crc32("KQyYHVW",7) == 957482436) strcat(s, "c");
if (crc32("CPSUaeybS",9) == 3485101370) strcat(s, "Y");
if (crc32("GunWHQ",6) == 74180770) strcat(s, "a");
if (crc32("CyvLXm",6) == 3240961493) strcat(s, "a");
if (crc32("VgzSHhuXcG",10) == 2453699354) strcat(s, "l");
    return s;
}

char *undetached_adjectives() {
    char *s = calloc(11);
    if (crc32("CUAbZyD",7) == 2639360704) strcat(s, "p");
if (crc32("jGcYHWdaNLFZv",13) == 3469248511) strcat(s, "u");
if (crc32("cVodhoanhnDWX",13) == 268892719) strcat(s, "n");
if (crc32("pJmoHCF",7) == 3879884525) strcat(s, "d");
if (crc32("dXAIuknDy",9) == 2315170578) strcat(s, "e");
if (crc32("zwjlK",5) == 2311234522) strcat(s, "o");
if (crc32("PTDgMyKIrxcj",12) == 2750225148) strcat(s, "t");
if (crc32("ekLnIc",6) == 1637006359) strcat(s, "a");
if (crc32("sUSymYz",7) == 4002279629) strcat(s, "c");
if (crc32("qbCnXZenp",9) == 2645962786) strcat(s, "h");
if (crc32("mGXEEtLtwJeERl",14) == 3062354576) strcat(s, "e");
if (crc32("GxQaMUta",8) == 2291306233) strcat(s, "d");
    return s;
}

char *agonic_adjectives() {
    char *s = calloc(7);
    if (crc32("AvfhVyxX",8) == 1330774361) strcat(s, "a");
if (crc32("xhEgSvEf",8) == 1985129679) strcat(s, "g");
if (crc32("OAMnx",5) == 118149945) strcat(s, "T");
if (crc32("HagyQUWFGbAMnYJ",15) == 1637394714) strcat(s, "o");
if (crc32("sccGLFmxwZtgL",13) == 1381456416) strcat(s, "V");
if (crc32("iwuqNfk",7) == 3826751308) strcat(s, "n");
if (crc32("RJmbKa",6) == 2127203365) strcat(s, "z");
if (crc32("kOSTXnsnDJw",11) == 425445867) strcat(s, "i");
if (crc32("FjAtAJmjMpOLbA",14) == 3597756831) strcat(s, "p");
if (crc32("bUfDd",5) == 1267971186) strcat(s, "c");
    return s;
}

char *excellent_adjectives() {
    char *s = calloc(10);
    if (crc32("fLLYPWb",7) == 476871809) strcat(s, "e");
if (crc32("VIJTlhZkPSR",11) == 4081829756) strcat(s, "c");
if (crc32("RoGWdwCJsxO",11) == 1539287132) strcat(s, "x");
if (crc32("JoGxSOWsw",9) == 1862168296) strcat(s, "d");
if (crc32("cIZyxAsYqDl",11) == 44766283) strcat(s, "c");
if (crc32("sPCnbQV",7) == 3795007500) strcat(s, "e");
if (crc32("uOEnzmthShZ",11) == 3503564649) strcat(s, "k");
if (crc32("cAUEygO",7) == 686836421) strcat(s, "l");
if (crc32("dIgqSRRmWkfPSPu",15) == 3673613920) strcat(s, "l");
if (crc32("WuVeNvosmD",10) == 2673948050) strcat(s, "e");
if (crc32("qhcmWsYhHO",10) == 675598077) strcat(s, "n");
if (crc32("fTLSCyyIM",9) == 1782522841) strcat(s, "t");
    return s;
}

char *peristaltic_adjectives() {
    char *s = calloc(12);
    if (crc32("TudEwcWjlyp",11) == 1161845661) strcat(s, "p");
if (crc32("VZFhEGyYblCN",12) == 1415713096) strcat(s, "i");
if (crc32("QGvluZnpjnnTjaK",15) == 1304649754) strcat(s, "e");
if (crc32("rKpVwIa",7) == 3724578613) strcat(s, "r");
if (crc32("MNKZgqsJv",9) == 51176216) strcat(s, "i");
if (crc32("YftcZAABLhvvOAZ",15) == 1900991331) strcat(s, "s");
if (crc32("HbVgwgXFeNZMc",13) == 160215868) strcat(s, "j");
if (crc32("ymgWlWEN",8) == 2818044823) strcat(s, "t");
if (crc32("VVALrZyBEriR",12) == 3698143578) strcat(s, "a");
if (crc32("PRkFglsxi",9) == 2574125854) strcat(s, "a");
if (crc32("vysJGquLgxfxw",13) == 3193549987) strcat(s, "l");
if (crc32("ceSCatYdMwsah",13) == 3589753838) strcat(s, "q");
if (crc32("BgAaLMNVOOGa",12) == 13700404) strcat(s, "t");
if (crc32("GnDMjVcQfYihYS",14) == 324290072) strcat(s, "y");
if (crc32("zgdSEpovYYvNZHv",15) == 317991567) strcat(s, "i");
if (crc32("YcCkVoRCKnOaMx",14) == 1477557866) strcat(s, "c");
    return s;
}

char *breezy_adjectives() {
    char *s = calloc(7);
    if (crc32("FrQTXKQUX",9) == 3560348570) strcat(s, "m");
if (crc32("DIYsuEeLEuTXBca",15) == 3017663015) strcat(s, "b");
if (crc32("gIweYlMslNA",11) == 1114689528) strcat(s, "r");
if (crc32("MYDDeQBBCkaT",12) == 1644992138) strcat(s, "e");
if (crc32("GmvGOoYkN",9) == 1192752070) strcat(s, "e");
if (crc32("JKnkvj",6) == 2069566262) strcat(s, "z");
if (crc32("QkVsWLeMx",9) == 410516972) strcat(s, "C");
if (crc32("RTMoUkaKNaqXhv",14) == 1545966741) strcat(s, "y");
    return s;
}

char *goldleaf_adjectives() {
    char *s = calloc(9);
    if (crc32("OJbEVqXQap",10) == 668203173) strcat(s, "h");
if (crc32("FfVgLOCNawa",11) == 1476801250) strcat(s, "g");
if (crc32("vjoAYJha",8) == 3765657852) strcat(s, "o");
if (crc32("EkwFwywvxBybQh",14) == 2330155300) strcat(s, "l");
if (crc32("CqVIOAF",7) == 3490265183) strcat(s, "H");
if (crc32("hGuFwWoUODCwaz",14) == 285315528) strcat(s, "d");
if (crc32("anMEnCyKTAc",11) == 3350019644) strcat(s, "l");
if (crc32("hnooZkIIZtW",11) == 1303492892) strcat(s, "e");
if (crc32("ialJbLgKo",9) == 3873828905) strcat(s, "u");
if (crc32("PChLbKmmbdW",11) == 2443733646) strcat(s, "a");
if (crc32("aJymhYeLQ",9) == 3375219220) strcat(s, "f");
    return s;
}

char *unsere_adjectives() {
    char *s = calloc(7);
    if (crc32("xzzQdpLTh",9) == 4238071939) strcat(s, "u");
if (crc32("jejysHBSZVj",11) == 345312183) strcat(s, "L");
if (crc32("NSlzMEqiHpTS",12) == 1000239671) strcat(s, "n");
if (crc32("UfaZXjXbnNJVMoN",15) == 1572505945) strcat(s, "s");
if (crc32("KyfRsCQHA",9) == 4139265929) strcat(s, "Y");
if (crc32("mLNDRlSUOFu",11) == 2052080518) strcat(s, "e");
if (crc32("nneAPnSOTHgSp",13) == 784431653) strcat(s, "r");
if (crc32("zYala",5) == 2041420585) strcat(s, "e");
    return s;
}

char *unparched_adjectives() {
    char *s = calloc(10);
    if (crc32("COMbyBeQTS",10) == 2058362491) strcat(s, "u");
if (crc32("iMYMVmpBpM",10) == 169261623) strcat(s, "n");
if (crc32("LxRSGHgwhvwFPG",14) == 225178850) strcat(s, "w");
if (crc32("PpvLlpkIImnlNVF",15) == 3815725412) strcat(s, "p");
if (crc32("QlUzbthreivw",12) == 1960953099) strcat(s, "s");
if (crc32("YLDIsXOH",8) == 2030678233) strcat(s, "a");
if (crc32("dUkTT",5) == 2685464700) strcat(s, "r");
if (crc32("lhquu",5) == 1130805466) strcat(s, "c");
if (crc32("QUQLVkpddQJjGKW",15) == 67599226) strcat(s, "p");
if (crc32("flAVxgjhT",9) == 2645463635) strcat(s, "h");
if (crc32("JSgVNHa",7) == 3316470697) strcat(s, "O");
if (crc32("ytZAdojFLB",10) == 244756046) strcat(s, "e");
if (crc32("WCdTVsFfFZBRa",13) == 2443289445) strcat(s, "U");
if (crc32("uNIvcceesr",10) == 4108289630) strcat(s, "d");
    return s;
}

char *marshier_adjectives() {
    char *s = calloc(9);
    if (crc32("JtFFpwJnSkwYbO",14) == 1308762058) strcat(s, "p");
if (crc32("YBLYOfzrVHR",11) == 1270498135) strcat(s, "m");
if (crc32("aDawdwY",7) == 1271493392) strcat(s, "a");
if (crc32("ikzARTpbWcz",11) == 905484453) strcat(s, "r");
if (crc32("WYLjqLVklbAq",12) == 1588146679) strcat(s, "s");
if (crc32("eaaNkPxhDDY",11) == 1074824103) strcat(s, "h");
if (crc32("IivSSzHk",8) == 2366137417) strcat(s, "i");
if (crc32("NOvGeNOZJndx",12) == 1336808015) strcat(s, "e");
if (crc32("dJHzekPqDww",11) == 689955683) strcat(s, "u");
if (crc32("wHuCkeUVMEBwfR",14) == 3713035740) strcat(s, "r");
    return s;
}

char *pseudoCanadian_adjectives() {
    char *s = calloc(15);
    if (crc32("kAsqGGbbhYSPCzV",15) == 1863239153) strcat(s, "G");
if (crc32("pCWrhtLkOZ",10) == 1461848749) strcat(s, "p");
if (crc32("IKAQUyaxXgVpsbL",15) == 1938626217) strcat(s, "j");
if (crc32("gUscnkWB",8) == 1872137719) strcat(s, "s");
if (crc32("TiSEgnu",7) == 553471843) strcat(s, "e");
if (crc32("naIvx",5) == 994721638) strcat(s, "u");
if (crc32("cfsTMrkhz",9) == 3890161927) strcat(s, "d");
if (crc32("YXTxsuDIEqCuI",13) == 1332478423) strcat(s, "o");
if (crc32("WRAjoYDauNJ",11) == 3716083563) strcat(s, "C");
if (crc32("rBEQLCtCD",9) == 2099041000) strcat(s, "h");
if (crc32("rIUkGMYqBoUsJmi",15) == 3418396742) strcat(s, "a");
if (crc32("OdefdlR",7) == 4029067471) strcat(s, "n");
if (crc32("LddPvB",6) == 2628061713) strcat(s, "a");
if (crc32("lkDfy",5) == 1869103725) strcat(s, "U");
if (crc32("BUnPgWBEMUGwi",13) == 1532908501) strcat(s, "d");
if (crc32("zDpCZRdGRUeO",12) == 3127845942) strcat(s, "q");
if (crc32("mwNofWue",8) == 824018856) strcat(s, "i");
if (crc32("yyZIEuZMZHsNLP",14) == 3209021539) strcat(s, "q");
if (crc32("NatCmtkbiVl",11) == 826116020) strcat(s, "a");
if (crc32("xTfjUK",6) == 3874459684) strcat(s, "n");
    return s;
}

char *uncaptained_adjectives() {
    char *s = calloc(12);
    if (crc32("rjwoMRvgF",9) == 1760267647) strcat(s, "p");
if (crc32("gPtKFUEf",8) == 3734908260) strcat(s, "u");
if (crc32("pkBPVXwgbvZ",11) == 3434328934) strcat(s, "x");
if (crc32("wqYwsITghuaSSyQ",15) == 32187317) strcat(s, "n");
if (crc32("vOREAzD",7) == 267156411) strcat(s, "V");
if (crc32("ugQCBbNBlf",10) == 3819523927) strcat(s, "c");
if (crc32("qrrsICyCDdb",11) == 2389500119) strcat(s, "C");
if (crc32("asvXPTlUmsZF",12) == 3495353631) strcat(s, "a");
if (crc32("bSeOUXTSATAqK",13) == 279263) strcat(s, "p");
if (crc32("mZElDeotHv",10) == 2045001948) strcat(s, "t");
if (crc32("zgUNkAJU",8) == 1602999694) strcat(s, "T");
if (crc32("IAfhfASlZTiEg",13) == 1823262844) strcat(s, "a");
if (crc32("egtPAH",6) == 2938688705) strcat(s, "n");
if (crc32("udUkHv",6) == 3204982281) strcat(s, "i");
if (crc32("oXrkKdPNf",9) == 3341028713) strcat(s, "n");
if (crc32("wBvqxpvmDPnkpF",14) == 10098827) strcat(s, "l");
if (crc32("PSZRhiNZfy",10) == 301374919) strcat(s, "e");
if (crc32("TYTdcBoiFwS",11) == 3732387828) strcat(s, "d");
    return s;
}

char *impetrative_adjectives() {
    char *s = calloc(12);
    if (crc32("oXwoFrHgqLCPS",13) == 2136142019) strcat(s, "T");
if (crc32("jdJkEAYjsvoPSZd",15) == 1155128804) strcat(s, "i");
if (crc32("bzeReXzw",8) == 3216691535) strcat(s, "W");
if (crc32("mkhknrlADK",10) == 1464154894) strcat(s, "m");
if (crc32("CKDvZeu",7) == 939129547) strcat(s, "p");
if (crc32("wRhXsLtDPC",10) == 1855591991) strcat(s, "e");
if (crc32("DNhlRDmZQFWakPX",15) == 3881192281) strcat(s, "a");
if (crc32("jfzMfmNX",8) == 2478695291) strcat(s, "t");
if (crc32("FofVpN",6) == 3146139634) strcat(s, "r");
if (crc32("lCATIoplEbIAMV",14) == 1421922540) strcat(s, "B");
if (crc32("iINNpSM",7) == 4195819296) strcat(s, "a");
if (crc32("OSKSALHwsqhpBw",14) == 3023291161) strcat(s, "G");
if (crc32("xiFoeqvQe",9) == 4042973659) strcat(s, "t");
if (crc32("aDhvKZwpFWsmJjW",15) == 2554387305) strcat(s, "U");
if (crc32("MWtHvILqTAqgHRE",15) == 1120480521) strcat(s, "i");
if (crc32("hwaLCjqWX",9) == 2093811473) strcat(s, "v");
if (crc32("Blocyjp",7) == 2533911984) strcat(s, "e");
    return s;
}

char *addible_adjectives() {
    char *s = calloc(8);
    if (crc32("eNnuGVEmsk",10) == 781996276) strcat(s, "a");
if (crc32("ZCJGUnOb",8) == 3873171442) strcat(s, "C");
if (crc32("XgJGGUgyfrJj",12) == 1449728785) strcat(s, "d");
if (crc32("zGOMk",5) == 2694824552) strcat(s, "H");
if (crc32("MQNAs",5) == 1335557418) strcat(s, "d");
if (crc32("rNHJuPrc",8) == 2546260673) strcat(s, "i");
if (crc32("jZkhzDLVpGOSb",13) == 2072651905) strcat(s, "b");
if (crc32("BNdXvGhBi",9) == 1978275476) strcat(s, "l");
if (crc32("PzPaZlQqnqEUtvy",15) == 4211419753) strcat(s, "e");
    return s;
}

char *clawless_adjectives() {
    char *s = calloc(9);
    if (crc32("gMsZI",5) == 2645378627) strcat(s, "c");
if (crc32("ftEMc",5) == 1888212252) strcat(s, "x");
if (crc32("DAVkzhQBIEcofT",14) == 2285045719) strcat(s, "l");
if (crc32("xjekmtPixZlyaux",15) == 2919297059) strcat(s, "a");
if (crc32("zuhOfDM",7) == 4242215638) strcat(s, "J");
if (crc32("PlMrPn",6) == 3476299469) strcat(s, "w");
if (crc32("WsCgTmPlaMfZnto",15) == 3916613262) strcat(s, "l");
if (crc32("opmFRWGYD",9) == 2180471934) strcat(s, "e");
if (crc32("imLpcCvpalsSSMo",15) == 2312123312) strcat(s, "N");
if (crc32("xNdirjzxnMuU",12) == 3174770429) strcat(s, "s");
if (crc32("iZohXrXLHa",10) == 2390082222) strcat(s, "s");
    return s;
}

char *quasiprecedent_adjectives() {
    char *s = calloc(15);
    if (crc32("eLYnLuHcjzq",11) == 4137687714) strcat(s, "S");
if (crc32("NDQbaFrTT",9) == 1654236385) strcat(s, "q");
if (crc32("XOrkZQUa",8) == 3441265538) strcat(s, "u");
if (crc32("ZrwXMveFbuDwM",13) == 481581063) strcat(s, "D");
if (crc32("CLjGz",5) == 1109081367) strcat(s, "a");
if (crc32("EaahfjPFxDAAGwM",15) == 1565954437) strcat(s, "n");
if (crc32("nNlLUBztuu",10) == 1698051264) strcat(s, "s");
if (crc32("paTHKHa",7) == 1598373009) strcat(s, "i");
if (crc32("hJunnmYaDPHiIMH",15) == 2611285671) strcat(s, "p");
if (crc32("bahuGcDo",8) == 2704926191) strcat(s, "O");
if (crc32("lelGIwrLRtyLl",13) == 1070322972) strcat(s, "r");
if (crc32("rDbqxNgGeq",10) == 2793926834) strcat(s, "e");
if (crc32("rjAjnQAlbgibYnp",15) == 1535600999) strcat(s, "c");
if (crc32("ZDaPshISugRYOh",14) == 356364461) strcat(s, "y");
if (crc32("LpHGyZmkajQixYp",15) == 3160294717) strcat(s, "e");
if (crc32("kgNTCGbkfFPY",12) == 3659271235) strcat(s, "B");
if (crc32("uYFlGbhSLLW",11) == 4011254842) strcat(s, "d");
if (crc32("cbZqAaMzFl",10) == 2539611412) strcat(s, "e");
if (crc32("ahwDL",5) == 639864675) strcat(s, "n");
if (crc32("hrBhnLnqeBYHrM",14) == 1030108674) strcat(s, "c");
if (crc32("uFtUTy",6) == 1153047136) strcat(s, "t");
    return s;
}

char *stealable_adjectives() {
    char *s = calloc(10);
    if (crc32("wrloypog",8) == 2942414218) strcat(s, "s");
if (crc32("bEPZYMmQSwc",11) == 1623186782) strcat(s, "t");
if (crc32("toXzcjCqOI",10) == 2830641573) strcat(s, "e");
if (crc32("lzKnbQXgSSROHZ",14) == 2432137136) strcat(s, "a");
if (crc32("SFZHQAbxJiTkGb",14) == 3649046844) strcat(s, "l");
if (crc32("OHHstzqdAMTt",12) == 3876844146) strcat(s, "b");
if (crc32("ndNuJucKBcXir",13) == 1469967782) strcat(s, "a");
if (crc32("gXKvsM",6) == 3158754957) strcat(s, "b");
if (crc32("Jvwwb",5) == 753873486) strcat(s, "P");
if (crc32("NeTSAs",6) == 3753469020) strcat(s, "l");
if (crc32("neAIsC",6) == 4080654912) strcat(s, "z");
if (crc32("DyffY",5) == 271348833) strcat(s, "e");
    return s;
}

char *drys_adjectives() {
    char *s = calloc(5);
    if (crc32("UfHorKGH",8) == 304949727) strcat(s, "d");
if (crc32("xFSQKno",7) == 3049050933) strcat(s, "g");
if (crc32("bqTTZZPdTBhDns",14) == 1102758745) strcat(s, "r");
if (crc32("YWqEOQzby",9) == 4244099960) strcat(s, "y");
if (crc32("Wertvg",6) == 3387352001) strcat(s, "s");
    return s;
}

char *halfforgotten_adjectives() {
    char *s = calloc(14);
    if (crc32("qnQPWrjOhmUXB",13) == 1612104080) strcat(s, "h");
if (crc32("TZkjUvKr",8) == 2205378933) strcat(s, "a");
if (crc32("MOOkkWrCNvZ",11) == 990896952) strcat(s, "I");
if (crc32("UxllhMRPOHOEESu",15) == 1655896403) strcat(s, "l");
if (crc32("tDXtusu",7) == 2348537280) strcat(s, "f");
if (crc32("alOHeOvB",8) == 513068747) strcat(s, "m");
if (crc32("EkKYxlSItdaUuAS",15) == 2115109845) strcat(s, "f");
if (crc32("VqcWgiWucp",10) == 2760328888) strcat(s, "H");
if (crc32("XscRwxf",7) == 2919203891) strcat(s, "o");
if (crc32("RZlJBnq",7) == 2201645129) strcat(s, "r");
if (crc32("mkSMgEWCMGuckdY",15) == 2018750862) strcat(s, "g");
if (crc32("uYoZmBkTt",9) == 1530742714) strcat(s, "o");
if (crc32("ucRabAkolJFEaA",14) == 2041983007) strcat(s, "t");
if (crc32("xPuVPNXHLMKogBm",15) == 581491555) strcat(s, "f");
if (crc32("FELYtKNzk",9) == 3072718029) strcat(s, "t");
if (crc32("OqoYtUPLvy",10) == 1444191804) strcat(s, "e");
if (crc32("FnDKEBOrPSSJJ",13) == 3413048117) strcat(s, "n");
    return s;
}

char *revocable_adjectives() {
    char *s = calloc(10);
    if (crc32("nVjgti",6) == 4002508304) strcat(s, "W");
if (crc32("oHLeBXzeUKQmirB",15) == 3887259757) strcat(s, "r");
if (crc32("ecjSktlgwl",10) == 4217429593) strcat(s, "B");
if (crc32("qoePjCGsOpJbI",13) == 1549320551) strcat(s, "e");
if (crc32("jCbKDmk",7) == 3038843136) strcat(s, "R");
if (crc32("VPGAfMggxowu",12) == 3305679084) strcat(s, "v");
if (crc32("HWQQJgHfI",9) == 1749815296) strcat(s, "o");
if (crc32("njYircWgabhNfj",14) == 777472152) strcat(s, "g");
if (crc32("BIEJMCuOmcWe",12) == 879715014) strcat(s, "c");
if (crc32("kjrkLzYpOMcEH",13) == 528361390) strcat(s, "a");
if (crc32("fEumqi",6) == 3789030219) strcat(s, "b");
if (crc32("uvZwOSfnjclnvrI",15) == 180469339) strcat(s, "l");
if (crc32("DouUja",6) == 2908251987) strcat(s, "e");
    return s;
}

char *evacuant_adjectives() {
    char *s = calloc(9);
    if (crc32("JmmudimAfjeQRgv",15) == 3887259725) strcat(s, "J");
if (crc32("lDXQucKAkwCGX",13) == 3941944531) strcat(s, "e");
if (crc32("FDKpMKoZVJw",11) == 1642805646) strcat(s, "v");
if (crc32("daZNGSnFiHchOAu",15) == 4114722207) strcat(s, "j");
if (crc32("tXsiH",5) == 1581668634) strcat(s, "a");
if (crc32("NTwKWCNLE",9) == 627361227) strcat(s, "w");
if (crc32("QLvWBUKMLd",10) == 2442179846) strcat(s, "c");
if (crc32("QVCmWljZndlCEH",14) == 2434094803) strcat(s, "u");
if (crc32("BXyOHsdL",8) == 2663525243) strcat(s, "a");
if (crc32("BxESsoFgdLgLOR",14) == 3302192976) strcat(s, "n");
if (crc32("agvvUjCL",8) == 1599472580) strcat(s, "o");
if (crc32("qwukB",5) == 3097075244) strcat(s, "t");
    return s;
}

char *halfdiscriminating_adjectives() {
    char *s = calloc(19);
    if (crc32("EjPgx",5) == 443817373) strcat(s, "h");
if (crc32("MxvkwfkfcpF",11) == 1612784273) strcat(s, "a");
if (crc32("IsivNX",6) == 1911137465) strcat(s, "D");
if (crc32("VCNCsSr",7) == 1139647044) strcat(s, "l");
if (crc32("DNUibUhhwtpYgj",14) == 2336773071) strcat(s, "u");
if (crc32("FFwSMWikP",9) == 1534822753) strcat(s, "f");
if (crc32("wQUSwDOfTqT",11) == 3284579005) strcat(s, "c");
if (crc32("EAaygAUzovTXm",13) == 3868585391) strcat(s, "d");
if (crc32("CqsKOiuD",8) == 3877343155) strcat(s, "f");
if (crc32("PYEtvU",6) == 353965926) strcat(s, "i");
if (crc32("uHEqbOubcygojaH",15) == 3544534036) strcat(s, "O");
if (crc32("jNPfGmWikunuhwR",15) == 3216649191) strcat(s, "s");
if (crc32("VGocQBQt",8) == 2542605913) strcat(s, "H");
if (crc32("vtBAHdQAXD",10) == 3000315972) strcat(s, "c");
if (crc32("qkDbt",5) == 3481640593) strcat(s, "T");
if (crc32("AnbeXEMjywNbx",13) == 3288665199) strcat(s, "r");
if (crc32("AiZYTxLu",8) == 1677964960) strcat(s, "i");
if (crc32("xHxwobrfWsCA",12) == 726269461) strcat(s, "T");
if (crc32("iJvbRpKxhRZ",11) == 2747701873) strcat(s, "m");
if (crc32("RSGLxuBsNNmCRqL",15) == 3704299836) strcat(s, "J");
if (crc32("EyhDERrZBkIWSu",14) == 3196856881) strcat(s, "i");
if (crc32("vJIuzBSPaRzOKBd",15) == 188261371) strcat(s, "y");
if (crc32("XVOvmXbMFsNE",12) == 61750759) strcat(s, "n");
if (crc32("BtZks",5) == 778236531) strcat(s, "a");
if (crc32("LdoEHnDQLvYdFfv",15) == 3810699429) strcat(s, "B");
if (crc32("InDgTlXyCsY",11) == 2189279369) strcat(s, "t");
if (crc32("gKjlumheDh",10) == 3707038341) strcat(s, "i");
if (crc32("LlFOAZO",7) == 3090768734) strcat(s, "l");
if (crc32("xekRCSwgZB",10) == 3164745913) strcat(s, "n");
if (crc32("lWjEkJbcmF",10) == 2371371605) strcat(s, "g");
    return s;
}

char *contradictious_adjectives() {
    char *s = calloc(15);
    if (crc32("haOIMRg",7) == 2182066852) strcat(s, "S");
if (crc32("qJMAmBfSLFs",11) == 1724749271) strcat(s, "c");
if (crc32("XCkpeRjsX",9) == 2927062151) strcat(s, "u");
if (crc32("zTpqartYok",10) == 882877774) strcat(s, "o");
if (crc32("pfvSCcSD",8) == 2697684309) strcat(s, "n");
if (crc32("Rgvqisny",8) == 1970202762) strcat(s, "M");
if (crc32("pOCsbqRhnpvTEp",14) == 792860601) strcat(s, "t");
if (crc32("olYXgHNnIAtnKk",14) == 1875308946) strcat(s, "r");
if (crc32("rMRAiCVEhbUFs",13) == 1607312337) strcat(s, "a");
if (crc32("kLDxAbsRxeoCt",13) == 2636393478) strcat(s, "d");
if (crc32("KYzHcGNbfN",10) == 1985918730) strcat(s, "U");
if (crc32("NIDiZ",5) == 2414824346) strcat(s, "i");
if (crc32("vUOyBYi",7) == 2185990329) strcat(s, "N");
if (crc32("ARrqtzvwAn",10) == 359605341) strcat(s, "c");
if (crc32("HFHKp",5) == 1255911407) strcat(s, "E");
if (crc32("mqfOStpNhSk",11) == 992867321) strcat(s, "t");
if (crc32("uyLLaRUjeyVoLZk",15) == 642703804) strcat(s, "p");
if (crc32("DYeItnhcwsr",11) == 698274221) strcat(s, "i");
if (crc32("bOyLclACStn",11) == 2286231331) strcat(s, "o");
if (crc32("wnpnbMJ",7) == 1023129990) strcat(s, "u");
if (crc32("TRjvsHFJXGBpke",14) == 2951084817) strcat(s, "i");
if (crc32("zkYoico",7) == 903500143) strcat(s, "s");
    return s;
}

char *recompensable_adjectives() {
    char *s = calloc(14);
    if (crc32("hRqfcDqbCM",10) == 2641942514) strcat(s, "r");
if (crc32("krdZMRztp",9) == 1707323108) strcat(s, "V");
if (crc32("YDvAuwXMFwFF",12) == 3585358885) strcat(s, "e");
if (crc32("lsmEklXXVeOBpEV",15) == 2975588904) strcat(s, "m");
if (crc32("CVBinYsZkIB",11) == 3100001139) strcat(s, "c");
if (crc32("JaomJum",7) == 1893170868) strcat(s, "o");
if (crc32("elJxTyBxPA",10) == 1441606088) strcat(s, "x");
if (crc32("qOcMz",5) == 2121378330) strcat(s, "m");
if (crc32("EcsWSIE",7) == 2678547249) strcat(s, "g");
if (crc32("CySgsQDCL",9) == 2880154534) strcat(s, "p");
if (crc32("ofwYsInLqg",10) == 4263752712) strcat(s, "A");
if (crc32("ISlELlzBPd",10) == 4163725213) strcat(s, "e");
if (crc32("DEbsPzfSGlTe",12) == 3954355880) strcat(s, "n");
if (crc32("unSgDKeTGZnYnq",14) == 4185480975) strcat(s, "s");
if (crc32("YOVbyfnXKq",10) == 2781501808) strcat(s, "R");
if (crc32("PAiZo",5) == 130432566) strcat(s, "a");
if (crc32("vTOxPxaZYPDcKCO",15) == 409778203) strcat(s, "b");
if (crc32("gdaYsS",6) == 3076637194) strcat(s, "I");
if (crc32("GZpKICMNtALUdKu",15) == 2191372562) strcat(s, "l");
if (crc32("EfFVZmcbr",9) == 4170512240) strcat(s, "F");
if (crc32("ENjRVYRinoELxTs",15) == 682119099) strcat(s, "e");
    return s;
}

char *vapourific_adjectives() {
    char *s = calloc(11);
    if (crc32("RlFcjsGYET",10) == 573258900) strcat(s, "v");
if (crc32("gVXBWyLsk",9) == 605951161) strcat(s, "a");
if (crc32("rHHBMWp",7) == 2176037247) strcat(s, "p");
if (crc32("OmREDhzVeTYHKNQ",15) == 1218703512) strcat(s, "U");
if (crc32("eCSonnvjivIZI",13) == 127639388) strcat(s, "o");
if (crc32("EngBTjrAWndXCR",14) == 4172420117) strcat(s, "u");
if (crc32("iTDwXUpBo",9) == 2162037135) strcat(s, "H");
if (crc32("qZXNcFDc",8) == 2554955600) strcat(s, "r");
if (crc32("XtXgQEmNvD",10) == 2837685147) strcat(s, "p");
if (crc32("eoiTX",5) == 148134220) strcat(s, "i");
if (crc32("MAUBZzGBG",9) == 916302489) strcat(s, "f");
if (crc32("KagxhEFLZNBADLv",15) == 812432151) strcat(s, "L");
if (crc32("fugvc",5) == 1828132457) strcat(s, "i");
if (crc32("oyzAhurxIShDgp",14) == 1844225597) strcat(s, "U");
if (crc32("dJSPWdqCtgrO",12) == 3918491521) strcat(s, "c");
    return s;
}

char *galvanometric_adjectives() {
    char *s = calloc(14);
    if (crc32("yVEsBONSexf",11) == 1342275964) strcat(s, "m");
if (crc32("FrVrKwvq",8) == 3945706359) strcat(s, "g");
if (crc32("BSKrKzjDT",9) == 1540374265) strcat(s, "a");
if (crc32("qSXMYjtmosJAwGD",15) == 404047055) strcat(s, "d");
if (crc32("bplFL",5) == 3597378768) strcat(s, "l");
if (crc32("wLqXOPQJz",9) == 1621985029) strcat(s, "v");
if (crc32("HbcsJCljlFTWE",13) == 3271084336) strcat(s, "o");
if (crc32("RKuOvCNtVqRrt",13) == 640868965) strcat(s, "a");
if (crc32("EkcXayat",8) == 4175027835) strcat(s, "n");
if (crc32("jaNCYVB",7) == 1548638218) strcat(s, "O");
if (crc32("HelNgBqyfR",10) == 3804236813) strcat(s, "o");
if (crc32("yQGoNaVFSCLlX",13) == 4197184337) strcat(s, "m");
if (crc32("aCPFgsQtiLe",11) == 3604245410) strcat(s, "n");
if (crc32("NKdccy",6) == 846153526) strcat(s, "e");
if (crc32("niWQenSAQGnm",12) == 868212036) strcat(s, "G");
if (crc32("RbHKJTVHYyWL",12) == 3366046135) strcat(s, "t");
if (crc32("UcWxHFJxpt",10) == 4128411755) strcat(s, "q");
if (crc32("FvslNvxR",8) == 2636705019) strcat(s, "r");
if (crc32("MatoYjyanvMTgv",14) == 3608287793) strcat(s, "i");
if (crc32("bJnPsdkwopJe",12) == 1111130296) strcat(s, "c");
    return s;
}

char *classified_adjectives() {
    char *s = calloc(11);
    if (crc32("cnGXBXCrMqiLY",13) == 397264895) strcat(s, "c");
if (crc32("fvvwRDPFjgzWSH",14) == 1456365584) strcat(s, "A");
if (crc32("pWWgVefsc",9) == 2643613024) strcat(s, "l");
if (crc32("kvolwyadrbN",11) == 169894455) strcat(s, "G");
if (crc32("vLDhvMwHjRnf",12) == 1230053527) strcat(s, "a");
if (crc32("HewvBOD",7) == 3260626683) strcat(s, "s");
if (crc32("oWLpNMC",7) == 3609415489) strcat(s, "s");
if (crc32("IZCGgPpMrYrmB",13) == 1786615290) strcat(s, "t");
if (crc32("yIfXMPaSvFLJSAA",15) == 1364902492) strcat(s, "i");
if (crc32("aLiGGNuUbJDPfPx",15) == 3971084083) strcat(s, "D");
if (crc32("NnOpOElAAQ",10) == 1882643155) strcat(s, "f");
if (crc32("YprZlG",6) == 4127139401) strcat(s, "b");
if (crc32("WJwxaNLHuO",10) == 3051858563) strcat(s, "i");
if (crc32("kDOasHNu",8) == 2896055333) strcat(s, "g");
if (crc32("CXAJKmWFDRpInVF",15) == 1428345338) strcat(s, "e");
if (crc32("kyrkRNVupPO",11) == 390848067) strcat(s, "M");
if (crc32("ExJmN",5) == 3296778556) strcat(s, "d");
    return s;
}

char *carunculous_adjectives() {
    char *s = calloc(12);
    if (crc32("jzXwweOgOdB",11) == 4171809744) strcat(s, "b");
if (crc32("vHaKcCduZkpFkh",14) == 3431451495) strcat(s, "c");
if (crc32("AUXAC",5) == 3252080883) strcat(s, "S");
if (crc32("BALmZbKripgIdhM",15) == 938919811) strcat(s, "a");
if (crc32("xuNXaynKUb",10) == 4173000933) strcat(s, "m");
if (crc32("wzUJZpbLPzWYD",13) == 3872041717) strcat(s, "r");
if (crc32("kWiksKVRMi",10) == 3369684194) strcat(s, "u");
if (crc32("qVpUNvvedHY",11) == 3685239200) strcat(s, "n");
if (crc32("hNSoUqg",7) == 4282770708) strcat(s, "r");
if (crc32("PJAxUHQ",7) == 2514071165) strcat(s, "c");
if (crc32("wrAit",5) == 1135902554) strcat(s, "U");
if (crc32("FQfmYyyTDKM",11) == 562407083) strcat(s, "u");
if (crc32("KMnnlXOTJg",10) == 2989630232) strcat(s, "l");
if (crc32("kRbwz",5) == 956058004) strcat(s, "A");
if (crc32("biHuzScYqRa",11) == 2192137138) strcat(s, "o");
if (crc32("rQTEXnoWeJFfeHJ",15) == 2230980846) strcat(s, "k");
if (crc32("LhWeTgGH",8) == 769171211) strcat(s, "u");
if (crc32("CIomb",5) == 1305727785) strcat(s, "G");
if (crc32("fSIzSq",6) == 422727155) strcat(s, "s");
    return s;
}

char *unprospered_adjectives() {
    char *s = calloc(12);
    if (crc32("zyQBDVOKkmYtiXk",15) == 1731583100) strcat(s, "z");
if (crc32("OehfSoDIwYUrV",13) == 3239092285) strcat(s, "u");
if (crc32("QhCWNMvmf",9) == 1987240851) strcat(s, "q");
if (crc32("rwvuBgyVvEJeA",13) == 3029374713) strcat(s, "n");
if (crc32("gnSPtCIcBrVqx",13) == 3204899870) strcat(s, "C");
if (crc32("qVFeGoimGMlrnbX",15) == 2704904245) strcat(s, "p");
if (crc32("NPnzPMz",7) == 2228595273) strcat(s, "L");
if (crc32("oSshlPh",7) == 2457295522) strcat(s, "r");
if (crc32("UurnrPuWj",9) == 835548456) strcat(s, "o");
if (crc32("NLnPLTgEDv",10) == 3497352733) strcat(s, "j");
if (crc32("eLeSrP",6) == 1620596570) strcat(s, "s");
if (crc32("ReUlgKLIBvEoT",13) == 1433938272) strcat(s, "O");
if (crc32("KdRGqOrQXaZLBh",14) == 1437405338) strcat(s, "p");
if (crc32("XXyaOtesUvgvug",14) == 1684946507) strcat(s, "e");
if (crc32("rPLYNPwgeImI",12) == 528148175) strcat(s, "r");
if (crc32("LlZnoG",6) == 3760276391) strcat(s, "n");
if (crc32("oRymtFPKU",9) == 1767341047) strcat(s, "e");
if (crc32("UTKbhlOSvTOGX",13) == 1631074328) strcat(s, "f");
if (crc32("OgtVoBeRIRUs",12) == 4185309360) strcat(s, "d");
    return s;
}

char *loonier_adjectives() {
    char *s = calloc(8);
    if (crc32("apWhYA",6) == 4043613963) strcat(s, "l");
if (crc32("UOssHL",6) == 1607853746) strcat(s, "o");
if (crc32("WvmUpytxj",9) == 3669729418) strcat(s, "o");
if (crc32("fzvKTPsoGT",10) == 3302107004) strcat(s, "w");
if (crc32("UMraEclekyNskk",14) == 1976193758) strcat(s, "n");
if (crc32("lBpHd",5) == 1978234785) strcat(s, "S");
if (crc32("ZFZSXXQzbaed",12) == 514524223) strcat(s, "i");
if (crc32("qzWUbmMTJJ",10) == 189327220) strcat(s, "e");
if (crc32("haGwVcMncWCe",12) == 910865098) strcat(s, "r");
    return s;
}

char *intercessory_adjectives() {
    char *s = calloc(13);
    if (crc32("MdzgtchPITa",11) == 2127914196) strcat(s, "i");
if (crc32("tCBXLasoHcXoDxl",15) == 2408124365) strcat(s, "V");
if (crc32("QIMGDzCuwSUYem",14) == 908412612) strcat(s, "n");
if (crc32("vWuUL",5) == 3009498342) strcat(s, "t");
if (crc32("dqtZjBzmHLLLTjI",15) == 2059366298) strcat(s, "t");
if (crc32("WRWrVeHjtclLL",13) == 146553391) strcat(s, "M");
if (crc32("YFIMKKJH",8) == 3270468523) strcat(s, "e");
if (crc32("GdufZwdXKrv",11) == 1855347491) strcat(s, "p");
if (crc32("hwGHxJIg",8) == 349578060) strcat(s, "r");
if (crc32("nCNjCmAB",8) == 17100768) strcat(s, "M");
if (crc32("eyNyqZdqeukJc",13) == 537697572) strcat(s, "c");
if (crc32("YDzxtbIykfgw",12) == 3551856188) strcat(s, "L");
if (crc32("MMIFnKWrlC",10) == 2364875109) strcat(s, "e");
if (crc32("VxmuwAtNWmAKVHm",15) == 169043888) strcat(s, "m");
if (crc32("myNSM",5) == 1380464775) strcat(s, "s");
if (crc32("OvcSfW",6) == 3097480199) strcat(s, "s");
if (crc32("MnEPAuLyzSkZ",12) == 1270488046) strcat(s, "D");
if (crc32("LnzINnvIzEyW",12) == 3378715541) strcat(s, "o");
if (crc32("XdAiJHmunX",10) == 1881642287) strcat(s, "r");
if (crc32("XNiRTArqDb",10) == 708304241) strcat(s, "F");
if (crc32("yPRXIQvqa",9) == 3238510470) strcat(s, "y");
    return s;
}

char *ungrinned_adjectives() {
    char *s = calloc(10);
    if (crc32("FpswVAZD",8) == 2010260375) strcat(s, "M");
if (crc32("kERHJUfIi",9) == 3105657499) strcat(s, "u");
if (crc32("bjLcyELJLCskevW",15) == 4231603221) strcat(s, "n");
if (crc32("wFjHaFSi",8) == 2012581480) strcat(s, "g");
if (crc32("BfmNcvSwFgDxQf",14) == 2416223565) strcat(s, "P");
if (crc32("KAuaGOebeiGuW",13) == 1546969955) strcat(s, "r");
if (crc32("NOuYlTiUhZIwBLA",15) == 2114373597) strcat(s, "i");
if (crc32("sQgpLLBxcSgMu",13) == 3215972939) strcat(s, "o");
if (crc32("fqTRAGhdnX",10) == 3168317466) strcat(s, "n");
if (crc32("WlfVrEA",7) == 664560525) strcat(s, "n");
if (crc32("EdTwezgHZJ",10) == 677425835) strcat(s, "l");
if (crc32("mbMnYpTdJJTY",12) == 572338355) strcat(s, "e");
if (crc32("ymDRRtOtHxUQVRB",15) == 460389418) strcat(s, "u");
if (crc32("HRGUwnZXj",9) == 1737153322) strcat(s, "d");
    return s;
}

char *selfexploiting_adjectives() {
    char *s = calloc(15);
    if (crc32("VmVFk",5) == 2890916089) strcat(s, "s");
if (crc32("qgrxHjNkSpq",11) == 1268391543) strcat(s, "C");
if (crc32("oBmUaphOpzYA",12) == 624817761) strcat(s, "e");
if (crc32("fMYJWPqWBo",10) == 665048787) strcat(s, "E");
if (crc32("FTchdJGNy",9) == 1861816786) strcat(s, "l");
if (crc32("YTBRkIUiLmK",11) == 1611327898) strcat(s, "f");
if (crc32("RKsdXiwxLGy",11) == 813160614) strcat(s, "f");
if (crc32("nCaJsYoXhMh",11) == 1280175441) strcat(s, "e");
if (crc32("rUWXvvKYcAl",11) == 773249005) strcat(s, "x");
if (crc32("lLFHwTHiic",10) == 712489196) strcat(s, "p");
if (crc32("SAuqOcPenr",10) == 907535206) strcat(s, "l");
if (crc32("ohMpHFKSXv",10) == 2776499581) strcat(s, "U");
if (crc32("AVjcRHOydTkcY",13) == 1007211827) strcat(s, "o");
if (crc32("iOrHtZ",6) == 3043401255) strcat(s, "p");
if (crc32("fuuxDzBcmxv",11) == 165018745) strcat(s, "i");
if (crc32("zxmOGdN",7) == 1978694993) strcat(s, "t");
if (crc32("dlBnHCcFcRNqo",13) == 584107574) strcat(s, "i");
if (crc32("JBRszUuDPxX",11) == 4102477073) strcat(s, "T");
if (crc32("xlEhYgt",7) == 1306909628) strcat(s, "n");
if (crc32("DIJFRro",7) == 108990426) strcat(s, "g");
    return s;
}

char *predietary_adjectives() {
    char *s = calloc(11);
    if (crc32("NzrvspeizlQYmC",14) == 3071135931) strcat(s, "p");
if (crc32("XcCcukA",7) == 3760068351) strcat(s, "r");
if (crc32("WaCUqHLxCWb",11) == 3691137546) strcat(s, "I");
if (crc32("xGoowmpRM",9) == 1557743294) strcat(s, "e");
if (crc32("PogLDU",6) == 1060694972) strcat(s, "R");
if (crc32("ISkAqrua",8) == 2858867807) strcat(s, "d");
if (crc32("HXuuGCDA",8) == 74250806) strcat(s, "i");
if (crc32("GWuzpO",6) == 2848960141) strcat(s, "Z");
if (crc32("ofOqKbDsaJamLlt",15) == 403619023) strcat(s, "e");
if (crc32("GeoByUOodKU",11) == 177977544) strcat(s, "c");
if (crc32("LyzGTxEAQvtb",12) == 1870946818) strcat(s, "t");
if (crc32("ElxldRgBozx",11) == 659106312) strcat(s, "a");
if (crc32("VHPiVnS",7) == 561178837) strcat(s, "r");
if (crc32("smhsUO",6) == 3562836421) strcat(s, "y");
    return s;
}

char *reddish_adjectives() {
    char *s = calloc(8);
    if (crc32("CjjKxkKrTGKBt",13) == 979328074) strcat(s, "n");
if (crc32("wOniLdnzNqE",11) == 4042444256) strcat(s, "r");
if (crc32("FDgcctl",7) == 71853840) strcat(s, "Q");
if (crc32("rwHFWRQrHEqJ",12) == 1676482257) strcat(s, "e");
if (crc32("SrJkvPrD",8) == 3406678549) strcat(s, "d");
if (crc32("XwnhmWbe",8) == 2604531712) strcat(s, "d");
if (crc32("QIXKeae",7) == 1263066899) strcat(s, "k");
if (crc32("qBNfaZKfE",9) == 3922480879) strcat(s, "i");
if (crc32("cDYdJVlMhvaCO",13) == 3272613729) strcat(s, "d");
if (crc32("pPbplaNzxmNnDs",14) == 512830663) strcat(s, "s");
if (crc32("nUbtfyYeKxJykji",15) == 2323692734) strcat(s, "L");
if (crc32("NNUdbKOaMiNQHl",14) == 1098637301) strcat(s, "h");
    return s;
}

char *evens_adjectives() {
    char *s = calloc(6);
    if (crc32("XhVklxHCUwi",11) == 2468469480) strcat(s, "e");
if (crc32("oyRseaWnu",9) == 1372412795) strcat(s, "q");
if (crc32("NXkXXDjGW",9) == 211070670) strcat(s, "v");
if (crc32("wlcTH",5) == 274835442) strcat(s, "e");
if (crc32("XMpOxscQAwjk",12) == 3042858583) strcat(s, "n");
if (crc32("NIKCoMe",7) == 529951524) strcat(s, "x");
if (crc32("RlHCblVFQmKel",13) == 3528954119) strcat(s, "s");
    return s;
}

char *superfluous_adjectives() {
    char *s = calloc(12);
    if (crc32("bANfpCQXCMmbhUr",15) == 3620684) strcat(s, "s");
if (crc32("AnvXzOZIv",9) == 201844174) strcat(s, "u");
if (crc32("LAMsleDrG",9) == 3719693481) strcat(s, "Q");
if (crc32("aKSCEXXaYaouO",13) == 2304566342) strcat(s, "p");
if (crc32("AGjnGoEUt",9) == 3285678060) strcat(s, "a");
if (crc32("jXpxu",5) == 2288099745) strcat(s, "e");
if (crc32("PfNxfJJ",7) == 4187556934) strcat(s, "r");
if (crc32("fRkyFkG",7) == 2430391672) strcat(s, "C");
if (crc32("eGkbyN",6) == 3418716791) strcat(s, "f");
if (crc32("zcQzKCUMqnQRv",13) == 4066939916) strcat(s, "l");
if (crc32("IiciOdCq",8) == 660804010) strcat(s, "u");
if (crc32("mFoeSZpu",8) == 379885725) strcat(s, "o");
if (crc32("lPRyogWj",8) == 3467799608) strcat(s, "z");
if (crc32("gigmUWAs",8) == 1614768772) strcat(s, "u");
if (crc32("QDdHqhENIJrPR",13) == 132734156) strcat(s, "h");
if (crc32("UKYSByh",7) == 2872024140) strcat(s, "s");
    return s;
}

char *anticapitalistic_adjectives() {
    char *s = calloc(17);
    if (crc32("YAJvgjU",7) == 2059005576) strcat(s, "a");
if (crc32("kPmecijnlin",11) == 1449633591) strcat(s, "n");
if (crc32("lfEYR",5) == 484465760) strcat(s, "t");
if (crc32("PldZfLyohvGuhwj",15) == 1933949989) strcat(s, "E");
if (crc32("FEeQFrsk",8) == 4140900213) strcat(s, "i");
if (crc32("hdmwWEZJDURPrkE",15) == 107485739) strcat(s, "o");
if (crc32("eZPpQYF",7) == 593739461) strcat(s, "c");
if (crc32("NwYva",5) == 4155773841) strcat(s, "a");
if (crc32("MPjTTqtRYHvu",12) == 2622036954) strcat(s, "p");
if (crc32("tvocI",5) == 2256470815) strcat(s, "i");
if (crc32("tdenAt",6) == 3494447268) strcat(s, "s");
if (crc32("zCIFs",5) == 3968173802) strcat(s, "t");
if (crc32("HvpErAmcVDc",11) == 350652084) strcat(s, "G");
if (crc32("TuTJgR",6) == 2169821606) strcat(s, "a");
if (crc32("sBHIKuvXfZtkY",13) == 2023764057) strcat(s, "l");
if (crc32("kfKddCEqK",9) == 3216668670) strcat(s, "i");
if (crc32("cUWhw",5) == 1399685494) strcat(s, "v");
if (crc32("AvTVqjjNBsF",11) == 2557167704) strcat(s, "s");
if (crc32("XMIgJQtNV",9) == 2273399133) strcat(s, "t");
if (crc32("MxdQIMfQzn",10) == 2523611086) strcat(s, "i");
if (crc32("PtgIN",5) == 3878373987) strcat(s, "c");
    return s;
}

char *traitorous_adjectives() {
    char *s = calloc(11);
    if (crc32("VRQCrbx",7) == 1318975410) strcat(s, "t");
if (crc32("cMGFNEc",7) == 1099758852) strcat(s, "h");
if (crc32("wHIsYPpiLr",10) == 2758513190) strcat(s, "r");
if (crc32("AQpXaHEmQd",10) == 3382113344) strcat(s, "q");
if (crc32("nZumzGpb",8) == 3766441640) strcat(s, "a");
if (crc32("hjhZVfkzL",9) == 3454170381) strcat(s, "p");
if (crc32("BqpzSizeDZKjsU",14) == 2551709987) strcat(s, "i");
if (crc32("eHlIiVUJQWP",11) == 2023793514) strcat(s, "t");
if (crc32("xVGceYObytLjUZ",14) == 3507193156) strcat(s, "o");
if (crc32("ZaTNyciTrMq",11) == 720672818) strcat(s, "Y");
if (crc32("vINuJpqinfuA",12) == 3820583641) strcat(s, "r");
if (crc32("CqUVIgmtmi",10) == 2782363622) strcat(s, "T");
if (crc32("kHrIpde",7) == 4200642652) strcat(s, "o");
if (crc32("tWIgqsCJRMvwRcG",15) == 442000473) strcat(s, "S");
if (crc32("FuByIpnV",8) == 1229524825) strcat(s, "u");
if (crc32("nDvzlkuObXSxhb",14) == 240144447) strcat(s, "Z");
if (crc32("vNkZEojEWqxdI",13) == 4054466750) strcat(s, "s");
    return s;
}

char *nonproscriptive_adjectives() {
    char *s = calloc(16);
    if (crc32("KiQmteZPNMt",11) == 214988316) strcat(s, "n");
if (crc32("NCZHWWr",7) == 244706710) strcat(s, "o");
if (crc32("kQXYseJMYlRpHbl",15) == 3068825336) strcat(s, "P");
if (crc32("WhNZDPUZ",8) == 4057033571) strcat(s, "n");
if (crc32("mDedDNIDPVaSJS",14) == 1854595355) strcat(s, "p");
if (crc32("sCuGSIB",7) == 1255513148) strcat(s, "i");
if (crc32("prFJvinyOWrMICD",15) == 2640574803) strcat(s, "r");
if (crc32("RiCYztSrHSpA",12) == 2058718719) strcat(s, "S");
if (crc32("pwKVrz",6) == 2028969685) strcat(s, "o");
if (crc32("kibaTZuY",8) == 1918422382) strcat(s, "s");
if (crc32("WqXOULZJyTK",11) == 1686086344) strcat(s, "Z");
if (crc32("iOumrOlSqHInZ",13) == 318003519) strcat(s, "c");
if (crc32("rFleyghPlsjmHY",14) == 204127831) strcat(s, "l");
if (crc32("qOFTBbEPgxLWMM",14) == 2830487396) strcat(s, "r");
if (crc32("XPCibKs",7) == 1232552783) strcat(s, "i");
if (crc32("TRvSmi",6) == 2694698070) strcat(s, "p");
if (crc32("vYGYkn",6) == 269969741) strcat(s, "t");
if (crc32("ROUjcyiYCXdv",12) == 381721114) strcat(s, "i");
if (crc32("gefQWA",6) == 1928540337) strcat(s, "v");
if (crc32("EMbPKWoq",8) == 3157112584) strcat(s, "e");
    return s;
}

char *nondenunciating_adjectives() {
    char *s = calloc(16);
    if (crc32("kYFNwdzaTmguwf",14) == 78898019) strcat(s, "n");
if (crc32("GXPpPqpQmvS",11) == 3509477271) strcat(s, "j");
if (crc32("FljaxTspc",9) == 5617765) strcat(s, "o");
if (crc32("lcLnrtJKkQrx",12) == 983588543) strcat(s, "n");
if (crc32("AuYBuHlyxALnmvt",15) == 588316804) strcat(s, "c");
if (crc32("PGbBPnbFdVJvrae",15) == 172767370) strcat(s, "d");
if (crc32("sbByFjw",7) == 594749107) strcat(s, "o");
if (crc32("cpcJjZxnJdeojqj",15) == 172985172) strcat(s, "e");
if (crc32("sqhXxeL",7) == 1839734874) strcat(s, "R");
if (crc32("bsHffygBccM",11) == 3756508832) strcat(s, "n");
if (crc32("IeKGjSsyV",9) == 2014985133) strcat(s, "u");
if (crc32("WHjLBZcnNaav",12) == 318713515) strcat(s, "n");
if (crc32("WycKMWHLNgJ",11) == 3246772652) strcat(s, "d");
if (crc32("zPeakQMnAvRq",12) == 4034720699) strcat(s, "c");
if (crc32("neJtyog",7) == 3891698611) strcat(s, "r");
if (crc32("vqkHQOVQMhirZ",13) == 3373395174) strcat(s, "i");
if (crc32("BHHBwLEmttlgbL",14) == 28212859) strcat(s, "a");
if (crc32("eyQUkk",6) == 1486238676) strcat(s, "t");
if (crc32("CoNVALsyiMi",11) == 3640164813) strcat(s, "j");
if (crc32("lGPKrYDMpxFn",12) == 491463611) strcat(s, "i");
if (crc32("iLYUKXRereG",11) == 666566315) strcat(s, "T");
if (crc32("ARuMVfustnjreqH",15) == 2280305477) strcat(s, "n");
if (crc32("JpHtr",5) == 881813491) strcat(s, "g");
    return s;
}

char *nontraceable_adjectives() {
    char *s = calloc(13);
    if (crc32("DJpgwgYUOwBDw",13) == 2104506791) strcat(s, "V");
if (crc32("SemOXmCaxVMdng",14) == 3109468186) strcat(s, "n");
if (crc32("AvXrYKGupca",11) == 3852301401) strcat(s, "o");
if (crc32("MRlBwrigKcjYPkO",15) == 1699625808) strcat(s, "o");
if (crc32("ZcZUUvbJHCOLOl",14) == 2472578838) strcat(s, "n");
if (crc32("tzSYVvtmcnn",11) == 2250519581) strcat(s, "t");
if (crc32("xdKaJQJKZkkxktQ",15) == 2152007671) strcat(s, "b");
if (crc32("HmfAUVj",7) == 1086970782) strcat(s, "r");
if (crc32("mimiyG",6) == 4077460792) strcat(s, "M");
if (crc32("QnfdLfuzoiarnEU",15) == 1184754904) strcat(s, "a");
if (crc32("NOkMSoWaYrVRK",13) == 618195322) strcat(s, "h");
if (crc32("dEDnlyX",7) == 285899731) strcat(s, "c");
if (crc32("zrMqwStsSO",10) == 2293801441) strcat(s, "e");
if (crc32("dtHJkgIZp",9) == 1796493762) strcat(s, "l");
if (crc32("LfvpvrrcMgSqdTd",15) == 826847494) strcat(s, "a");
if (crc32("fZDlpqbShlJbtZj",15) == 700799076) strcat(s, "O");
if (crc32("LSUoxyfLQDYBahe",15) == 2663266385) strcat(s, "b");
if (crc32("QNfbCvUUIku",11) == 2464572528) strcat(s, "l");
if (crc32("OZwvtrEEQrRfzs",14) == 2432526854) strcat(s, "e");
    return s;
}

char *pseudoidentical_adjectives() {
    char *s = calloc(16);
    if (crc32("pZDolwQiPmB",11) == 237428046) strcat(s, "Y");
if (crc32("xfoXxBaU",8) == 3108125526) strcat(s, "p");
if (crc32("dHjfhuMoPfCcrHC",15) == 2743077236) strcat(s, "e");
if (crc32("ItsFf",5) == 601423881) strcat(s, "s");
if (crc32("RqcVpe",6) == 1735600110) strcat(s, "e");
if (crc32("AQEBGOFPBmIP",12) == 1117121819) strcat(s, "O");
if (crc32("ntzGJlGtasA",11) == 223151919) strcat(s, "u");
if (crc32("KTjEB",5) == 1084620389) strcat(s, "n");
if (crc32("bDzSiJCrWQHoK",13) == 3823431876) strcat(s, "d");
if (crc32("OmCHvawILYgPnk",14) == 2538019783) strcat(s, "M");
if (crc32("kCWvAyBSyb",10) == 3483971102) strcat(s, "o");
if (crc32("ATQEdtjUWEvN",12) == 421968233) strcat(s, "w");
if (crc32("lmBnihl",7) == 855396865) strcat(s, "i");
if (crc32("sBKvqDxt",8) == 1305420371) strcat(s, "r");
if (crc32("PXQYXLUYhQesKg",14) == 1127881900) strcat(s, "d");
if (crc32("dHlmYIqDuKT",11) == 2486275221) strcat(s, "e");
if (crc32("laAysYHCaKRtCLP",15) == 1392573295) strcat(s, "n");
if (crc32("VSXFwqJ",7) == 284976301) strcat(s, "t");
if (crc32("PAaXROiUpSSpz",13) == 2846498133) strcat(s, "i");
if (crc32("GketTUGF",8) == 1266345842) strcat(s, "I");
if (crc32("aPbowdezranR",12) == 576423965) strcat(s, "c");
if (crc32("ivoFDnQ",7) == 1806032318) strcat(s, "a");
if (crc32("ReXbcYRQTqrR",12) == 2003608221) strcat(s, "l");
    return s;
}

char *wordless_adjectives() {
    char *s = calloc(9);
    if (crc32("duRdAhNlccvwqr",14) == 4071196540) strcat(s, "w");
if (crc32("glktkM",6) == 3377085378) strcat(s, "o");
if (crc32("KxDPFkpqwvxOFC",14) == 605783424) strcat(s, "o");
if (crc32("tLYVGxmoJsIxEv",14) == 2914786370) strcat(s, "r");
if (crc32("sjEgoqc",7) == 1966232320) strcat(s, "d");
if (crc32("oDIqxfANHMi",11) == 1030965418) strcat(s, "d");
if (crc32("KSaRCsreeQdq",12) == 232879750) strcat(s, "Q");
if (crc32("FGzlzGVv",8) == 3654753913) strcat(s, "l");
if (crc32("xCYuqOeOtWE",11) == 2653320720) strcat(s, "i");
if (crc32("DHJUn",5) == 624595998) strcat(s, "e");
if (crc32("wUkwPZMyS",9) == 1531048131) strcat(s, "P");
if (crc32("bSHPX",5) == 1575627670) strcat(s, "s");
if (crc32("JefqAwxaIGvP",12) == 2945223879) strcat(s, "c");
if (crc32("UkXrpA",6) == 1951132984) strcat(s, "s");
    return s;
}

char *authorial_adjectives() {
    char *s = calloc(10);
    if (crc32("fMqdyuZBUwQtXDl",15) == 552810843) strcat(s, "a");
if (crc32("jXsvixmhPtuttX",14) == 3626770815) strcat(s, "v");
if (crc32("wkABcWlquF",10) == 4075618856) strcat(s, "u");
if (crc32("gvQHTBsiABwTcWk",15) == 3153211504) strcat(s, "h");
if (crc32("FUMiWqJb",8) == 1981434906) strcat(s, "t");
if (crc32("dzggSggKu",9) == 1734513665) strcat(s, "u");
if (crc32("zxYXrryKWzwwcmD",15) == 3178870169) strcat(s, "h");
if (crc32("TXcbqqTjHnx",11) == 2314222484) strcat(s, "l");
if (crc32("WosRkBKzFq",10) == 2036316924) strcat(s, "o");
if (crc32("BvllCmfzzch",11) == 2755767972) strcat(s, "r");
if (crc32("srbRNCfa",8) == 3893872820) strcat(s, "t");
if (crc32("YFPcoMkFleeS",12) == 1955816565) strcat(s, "i");
if (crc32("mFgqQfRvbVPbCms",15) == 1273257590) strcat(s, "a");
if (crc32("aBdtkpFQwwShuo",14) == 3058728234) strcat(s, "C");
if (crc32("IygreygIWjWOL",13) == 2074195421) strcat(s, "l");
    return s;
}

char *uncinctured_adjectives() {
    char *s = calloc(12);
    if (crc32("gbrywPuif",9) == 3644084043) strcat(s, "u");
if (crc32("lVYbJDziOE",10) == 1312456788) strcat(s, "n");
if (crc32("eTOkzKnNh",9) == 1632411113) strcat(s, "c");
if (crc32("HOhCOh",6) == 816623855) strcat(s, "i");
if (crc32("epIFOgFsWzBpZo",14) == 3483105926) strcat(s, "n");
if (crc32("QHakZaioVOPjT",13) == 3741793344) strcat(s, "f");
if (crc32("yKPNJVBapMu",11) == 1824208477) strcat(s, "c");
if (crc32("aUhzrNeGgx",10) == 2823320258) strcat(s, "q");
if (crc32("hIsXER",6) == 331935054) strcat(s, "t");
if (crc32("xPwyNkumrlxlggQ",15) == 1874160234) strcat(s, "D");
if (crc32("hgDOCCqhy",9) == 3538585721) strcat(s, "u");
if (crc32("OVnYktNIXyaFO",13) == 3029115727) strcat(s, "N");
if (crc32("gbagiIERK",9) == 421121496) strcat(s, "r");
if (crc32("FTeZHDorBUFHTz",14) == 1694241103) strcat(s, "D");
if (crc32("OUuqYdPdXH",10) == 3553922587) strcat(s, "e");
if (crc32("bSGLJCGvVk",10) == 202026096) strcat(s, "U");
if (crc32("gElWbho",7) == 3179944373) strcat(s, "d");
    return s;
}

char *micrometric_adjectives() {
    char *s = calloc(12);
    if (crc32("CwxmRn",6) == 1701966448) strcat(s, "K");
if (crc32("RTDNenUe",8) == 1645516281) strcat(s, "m");
if (crc32("LlkpPdob",8) == 166537806) strcat(s, "i");
if (crc32("JcWglXjcHsSYhd",14) == 1084830644) strcat(s, "Y");
if (crc32("ttKtAfszRndovL",14) == 4118655984) strcat(s, "c");
if (crc32("PETreaIEeXt",11) == 1999422837) strcat(s, "F");
if (crc32("zbnlLwSwSq",10) == 4109969265) strcat(s, "r");
if (crc32("YbhDzAYhZdjb",12) == 421398209) strcat(s, "o");
if (crc32("XlkdITlYGzKMsU",14) == 504253358) strcat(s, "m");
if (crc32("eRdHhesyAQ",10) == 2446456635) strcat(s, "y");
if (crc32("KoFmmeFCp",9) == 2997374945) strcat(s, "e");
if (crc32("eabhrRtlteBCs",13) == 1224517839) strcat(s, "N");
if (crc32("wzAHDkjlfia",11) == 3702624967) strcat(s, "t");
if (crc32("OmQwGAokf",9) == 1438851991) strcat(s, "H");
if (crc32("iFpezITIzqSF",12) == 1628006319) strcat(s, "r");
if (crc32("DCdRnpYn",8) == 1438394763) strcat(s, "u");
if (crc32("mxwtmPwLoe",10) == 4009113531) strcat(s, "i");
if (crc32("NOKUioMandoHFG",14) == 3038164008) strcat(s, "c");
    return s;
}

char *bacteriostatic_adjectives() {
    char *s = calloc(15);
    if (crc32("lcpJlhf",7) == 653810010) strcat(s, "S");
if (crc32("sXhErFCEtzM",11) == 3211289263) strcat(s, "b");
if (crc32("cSplMCa",7) == 369147065) strcat(s, "C");
if (crc32("RwkFyrywsCLRHNf",15) == 3651491443) strcat(s, "a");
if (crc32("QeXygWNBFm",10) == 1588368287) strcat(s, "c");
if (crc32("DhgdztAtVNSXsXX",15) == 1273940980) strcat(s, "t");
if (crc32("kfTkiZMVijeezJ",14) == 899109146) strcat(s, "t");
if (crc32("wxdpbvqcMQndZy",14) == 2894594824) strcat(s, "e");
if (crc32("xAoNtNg",7) == 1921478046) strcat(s, "j");
if (crc32("rSyNoQm",7) == 815805560) strcat(s, "r");
if (crc32("mWDcyPy",7) == 1395434717) strcat(s, "u");
if (crc32("omCYGgpSlkF",11) == 3448298470) strcat(s, "i");
if (crc32("DxrANyXQloZKlc",14) == 3357837694) strcat(s, "o");
if (crc32("wSNRmUpYbz",10) == 2672679934) strcat(s, "s");
if (crc32("cxVnJNKHR",9) == 3331390948) strcat(s, "p");
if (crc32("pJHOI",5) == 3442596109) strcat(s, "t");
if (crc32("bjnXHUfmE",9) == 4064724732) strcat(s, "E");
if (crc32("MSlugZSNBNcZ",12) == 4220492520) strcat(s, "a");
if (crc32("yMfrStVEHetqZJ",14) == 2627840784) strcat(s, "c");
if (crc32("dGoIeiJ",7) == 1637616604) strcat(s, "t");
if (crc32("eAmUpw",6) == 3456962655) strcat(s, "i");
if (crc32("qyzKBd",6) == 3857843292) strcat(s, "i");
if (crc32("nJsaYVn",7) == 4031277063) strcat(s, "c");
    return s;
}

char *exsertile_adjectives() {
    char *s = calloc(10);
    if (crc32("XnWlkj",6) == 3130123794) strcat(s, "m");
if (crc32("urfUZaT",7) == 4273771816) strcat(s, "e");
if (crc32("DuqHYEOTt",9) == 1130588402) strcat(s, "x");
if (crc32("vYIchILatAhGLVt",15) == 34102612) strcat(s, "s");
if (crc32("coTElgkcEyyfZ",13) == 1422573803) strcat(s, "e");
if (crc32("BWBQEheKPXpNgVP",15) == 583336193) strcat(s, "A");
if (crc32("mOviFHTQCHhFs",13) == 278517468) strcat(s, "r");
if (crc32("NIJmEXn",7) == 3560518112) strcat(s, "t");
if (crc32("lKaVIVLqdDy",11) == 949268342) strcat(s, "i");
if (crc32("pKykPDeMnRffFh",14) == 3947613331) strcat(s, "l");
if (crc32("mqQFXfImkzcoH",13) == 2067784342) strcat(s, "l");
if (crc32("iwOfaWiwskSoja",14) == 1553782477) strcat(s, "e");
    return s;
}

char *unfiltrated_adjectives() {
    char *s = calloc(12);
    if (crc32("cQtjtYIcsnIkM",13) == 3218884594) strcat(s, "u");
if (crc32("lxFRlEoMxSZw",12) == 4034310198) strcat(s, "T");
if (crc32("NknVtgJxeJdS",12) == 2625138957) strcat(s, "n");
if (crc32("pjmOwvcCrxwTxkO",15) == 3278694809) strcat(s, "f");
if (crc32("SaOrx",5) == 35322599) strcat(s, "i");
if (crc32("zWYZJmfYTVUTmc",14) == 2439388337) strcat(s, "l");
if (crc32("UPqAFjWDPV",10) == 1414760299) strcat(s, "g");
if (crc32("skdKMGza",8) == 2177150470) strcat(s, "t");
if (crc32("xgtZzGnvArtU",12) == 3833428945) strcat(s, "r");
if (crc32("WqwyplpycWdo",12) == 3344275836) strcat(s, "a");
if (crc32("iLXXynjZfoDsk",13) == 1663407221) strcat(s, "C");
if (crc32("KSJxtocaXdy",11) == 246341071) strcat(s, "t");
if (crc32("uibNz",5) == 608683468) strcat(s, "e");
if (crc32("lalUXzrDfLRRE",13) == 279887490) strcat(s, "d");
    return s;
}

char *nigh_adjectives() {
    char *s = calloc(5);
    if (crc32("MqoOLDiVv",9) == 2972336403) strcat(s, "n");
if (crc32("UGtJNf",6) == 1411982725) strcat(s, "i");
if (crc32("HuywaxFDQCW",11) == 2812927221) strcat(s, "g");
if (crc32("WGICmjUK",8) == 3848484351) strcat(s, "W");
if (crc32("wePLoEcaMlKt",12) == 3534403770) strcat(s, "h");
    return s;
}

char *brainlike_adjectives() {
    char *s = calloc(10);
    if (crc32("FNWyWhObkEoNoB",14) == 588680325) strcat(s, "b");
if (crc32("xbLVtB",6) == 3744670699) strcat(s, "r");
if (crc32("rYXkAfNNBYiKqo",14) == 426091719) strcat(s, "e");
if (crc32("ShGeGTY",7) == 879282254) strcat(s, "a");
if (crc32("nwRXOVPZFrAdt",13) == 3000086750) strcat(s, "x");
if (crc32("hGbnJMPqbNfK",12) == 2272567009) strcat(s, "i");
if (crc32("EtEhTPIPC",9) == 2208761674) strcat(s, "D");
if (crc32("jaAYyZfrUmMTCbQ",15) == 3495750797) strcat(s, "n");
if (crc32("OKrbFlX",7) == 2153947257) strcat(s, "l");
if (crc32("gVMWMqWqoI",10) == 1841538806) strcat(s, "y");
if (crc32("reXZJ",5) == 4248445403) strcat(s, "i");
if (crc32("lUqpMgjyki",10) == 1655214910) strcat(s, "G");
if (crc32("LahUBiDuy",9) == 1324027337) strcat(s, "k");
if (crc32("tgDgGqkqyIuQh",13) == 2665822960) strcat(s, "H");
if (crc32("OwALWz",6) == 456932744) strcat(s, "e");
    return s;
}

char *unstriving_adjectives() {
    char *s = calloc(11);
    if (crc32("ZWPzMBBF",8) == 1994280549) strcat(s, "t");
if (crc32("PtFrfp",6) == 1001843097) strcat(s, "u");
if (crc32("XaHZJwfHnOp",11) == 436230889) strcat(s, "a");
if (crc32("draiNZryVN",10) == 1205772231) strcat(s, "n");
if (crc32("ZAIbqamWyFMLyn",14) == 2708869153) strcat(s, "s");
if (crc32("vIehZYtsyyR",11) == 4076961232) strcat(s, "t");
if (crc32("bjquZbvbq",9) == 125760157) strcat(s, "r");
if (crc32("onaWmaY",7) == 247074683) strcat(s, "i");
if (crc32("LSEEeMDoxF",10) == 2355311233) strcat(s, "v");
if (crc32("gFDlaSRLWTdD",12) == 2878509256) strcat(s, "i");
if (crc32("dhOzLdJRHq",10) == 2266541613) strcat(s, "b");
if (crc32("LezUB",5) == 1369514319) strcat(s, "n");
if (crc32("RprwOjjd",8) == 2182224542) strcat(s, "z");
if (crc32("mXHZkfl",7) == 1757561116) strcat(s, "g");
    return s;
}

char *psittacistic_adjectives() {
    char *s = calloc(13);
    if (crc32("vpKUgGmpWEe",11) == 1643615214) strcat(s, "U");
if (crc32("qyhpWfdSCVyZsL",14) == 1259343038) strcat(s, "p");
if (crc32("NzCTBVsGNDwrcVZ",15) == 3025976409) strcat(s, "L");
if (crc32("RnEikTzVGXyHebj",15) == 3921594145) strcat(s, "s");
if (crc32("yDlAdsPS",8) == 3085088765) strcat(s, "X");
if (crc32("zntTTnBJSjfOb",13) == 2485079436) strcat(s, "i");
if (crc32("swAkfFPhIWH",11) == 1508541601) strcat(s, "t");
if (crc32("zuLQvxYf",8) == 1075143945) strcat(s, "t");
if (crc32("xMSIEvkJgnO",11) == 3098126261) strcat(s, "a");
if (crc32("NlOweMFQ",8) == 1848261890) strcat(s, "c");
if (crc32("KQOhHlP",7) == 3827932412) strcat(s, "i");
if (crc32("tFjLC",5) == 2186733606) strcat(s, "s");
if (crc32("vruMKkv",7) == 1339194814) strcat(s, "t");
if (crc32("jPiwNl",6) == 291610630) strcat(s, "Q");
if (crc32("LdxZODpgBt",10) == 2121187463) strcat(s, "i");
if (crc32("ajOjdttcickeu",13) == 3808759279) strcat(s, "c");
    return s;
}

char *moneyed_adjectives() {
    char *s = calloc(8);
    if (crc32("yFdaCxqsTgtTfz",14) == 1126027712) strcat(s, "p");
if (crc32("hbVkyTSQEUZABDm",15) == 4022911200) strcat(s, "m");
if (crc32("explKucKiX",10) == 2936526714) strcat(s, "o");
if (crc32("lMDNFpPAN",9) == 3286678082) strcat(s, "n");
if (crc32("ZtzLVuhulqJ",11) == 438464999) strcat(s, "e");
if (crc32("QszvUjoH",8) == 3740586723) strcat(s, "y");
if (crc32("eotMNMciMv",10) == 1565382659) strcat(s, "e");
if (crc32("dXriqHPdosvV",12) == 691906468) strcat(s, "d");
    return s;
}

char *costlier_adjectives() {
    char *s = calloc(9);
    if (crc32("WLNIVTYZDgVHuB",14) == 1942685953) strcat(s, "c");
if (crc32("VMkOLrFaYgRx",12) == 3359351875) strcat(s, "o");
if (crc32("TQjBBO",6) == 138420199) strcat(s, "E");
if (crc32("qOpNRIpDD",9) == 1036797066) strcat(s, "s");
if (crc32("lDbrTKTJR",9) == 3465214979) strcat(s, "t");
if (crc32("OCKYOAEw",8) == 1101055898) strcat(s, "l");
if (crc32("pFmEkjitVIp",11) == 2206138148) strcat(s, "i");
if (crc32("nvHJL",5) == 1079868064) strcat(s, "S");
if (crc32("JMIjKbgaidlRL",13) == 2555794699) strcat(s, "e");
if (crc32("jCULSjWfS",9) == 4030233457) strcat(s, "Q");
if (crc32("ueOwvGiJleOZSLX",15) == 1066342098) strcat(s, "r");
    return s;
}

char *unintensified_adjectives() {
    char *s = calloc(14);
    if (crc32("dtGWBxkiHJFRv",13) == 3728086265) strcat(s, "G");
if (crc32("AfyVuX",6) == 709497830) strcat(s, "u");
if (crc32("ynDExsTsXiEcVdF",15) == 300894950) strcat(s, "n");
if (crc32("WzopkGgGaSftALR",15) == 1955293413) strcat(s, "U");
if (crc32("rtuBAlUIolCy",12) == 1843387129) strcat(s, "i");
if (crc32("VSyLlEVNDvw",11) == 2484178484) strcat(s, "n");
if (crc32("TPFeFBhnkcQs",12) == 238663605) strcat(s, "f");
if (crc32("amkHfGMHfwy",11) == 4220489711) strcat(s, "t");
if (crc32("ybjfxmYIm",9) == 1375677811) strcat(s, "j");
if (crc32("uHwsFtgtPxe",11) == 287828989) strcat(s, "e");
if (crc32("IhdeUF",6) == 2466046624) strcat(s, "n");
if (crc32("GzFFUGnujJSnvpa",15) == 425777429) strcat(s, "s");
if (crc32("LSyiWjugrfg",11) == 428349045) strcat(s, "i");
if (crc32("yfWJTm",6) == 3445830365) strcat(s, "a");
if (crc32("KLixQkGrXL",10) == 3638287037) strcat(s, "f");
if (crc32("oNQlOFSBBoI",11) == 1622928889) strcat(s, "U");
if (crc32("SNOYnUS",7) == 2705491853) strcat(s, "i");
if (crc32("IALaPAzE",8) == 74916030) strcat(s, "e");
if (crc32("TuYJjh",6) == 10266244) strcat(s, "d");
    return s;
}

char *unnibbled_adjectives() {
    char *s = calloc(10);
    if (crc32("pVJWRZDx",8) == 1734588389) strcat(s, "u");
if (crc32("jIsZmZBd",8) == 712570827) strcat(s, "n");
if (crc32("GkucV",5) == 3211756845) strcat(s, "N");
if (crc32("DzFacmTQxnsubu",14) == 424995079) strcat(s, "n");
if (crc32("mJxcBzORFoJRqYH",15) == 3677541331) strcat(s, "T");
if (crc32("SUYOn",5) == 4223973180) strcat(s, "i");
if (crc32("xpJZY",5) == 3532207326) strcat(s, "j");
if (crc32("JHoyXJvn",8) == 119584791) strcat(s, "b");
if (crc32("KtbTqSrZCf",10) == 2884656718) strcat(s, "r");
if (crc32("IwMrFHvKzbuzmO",14) == 1366345635) strcat(s, "b");
if (crc32("pLKbKA",6) == 3928690780) strcat(s, "t");
if (crc32("RxAXxK",6) == 2127136999) strcat(s, "l");
if (crc32("psyEz",5) == 3251071162) strcat(s, "i");
if (crc32("dGaBSLkJ",8) == 3784057603) strcat(s, "e");
if (crc32("FjbqyelDRBQqe",13) == 3369233794) strcat(s, "d");
    return s;
}

char *antienergistic_adjectives() {
    char *s = calloc(15);
    if (crc32("nYAJvakLGYXqk",13) == 2013471451) strcat(s, "a");
if (crc32("oHUBl",5) == 295400000) strcat(s, "x");
if (crc32("fNdpQ",5) == 3608551830) strcat(s, "n");
if (crc32("MIruNRgsi",9) == 608008997) strcat(s, "t");
if (crc32("hOkzigwV",8) == 3976075484) strcat(s, "i");
if (crc32("ZGVtDASZTDxtXbc",15) == 3749024177) strcat(s, "B");
if (crc32("vsdiDQPrL",9) == 3346047191) strcat(s, "e");
if (crc32("XGtrVMgTfUHFLm",14) == 3392842955) strcat(s, "I");
if (crc32("cilxW",5) == 230311908) strcat(s, "n");
if (crc32("jKFHGWIdXuCPn",13) == 1487954493) strcat(s, "e");
if (crc32("mxNoCgMDnpwwVZ",14) == 1415828473) strcat(s, "r");
if (crc32("IGrSb",5) == 4032634748) strcat(s, "g");
if (crc32("wbDIMbSGcvOu",12) == 3523511625) strcat(s, "q");
if (crc32("neIOeCGfxkiqmyt",15) == 3824800037) strcat(s, "i");
if (crc32("GMWIVohdxuI",11) == 2599802855) strcat(s, "F");
if (crc32("VfAJmIRyzc",10) == 2809372103) strcat(s, "s");
if (crc32("JNmILF",6) == 1309217714) strcat(s, "v");
if (crc32("NbIKw",5) == 308931235) strcat(s, "t");
if (crc32("hcoCyiFdLRZ",11) == 2138316279) strcat(s, "l");
if (crc32("olDWQePd",8) == 4090267991) strcat(s, "i");
if (crc32("kGEnCcfu",8) == 3227562424) strcat(s, "c");
    return s;
}

char *nonreplicated_adjectives() {
    char *s = calloc(14);
    if (crc32("whxtZJhUrCkO",12) == 1787310986) strcat(s, "n");
if (crc32("swigK",5) == 2984880031) strcat(s, "C");
if (crc32("DfGpIAoefEvVmFE",15) == 265209537) strcat(s, "o");
if (crc32("sGeBcLcGM",9) == 1710592993) strcat(s, "n");
if (crc32("vvEVYcFSwpQ",11) == 3586185982) strcat(s, "r");
if (crc32("AfyooVmHhlQRv",13) == 260437721) strcat(s, "Q");
if (crc32("SAQIFqFfuIEUm",13) == 2866351228) strcat(s, "e");
if (crc32("BhAVVxcMaJ",10) == 297050449) strcat(s, "l");
if (crc32("TkztOxmIAvkqJrC",15) == 22221783) strcat(s, "p");
if (crc32("UBmzyE",6) == 1785929189) strcat(s, "y");
if (crc32("QUBMvYJNAG",10) == 2767364498) strcat(s, "l");
if (crc32("NMgahqxr",8) == 3615514740) strcat(s, "K");
if (crc32("lAPtrEBoheHOtGc",15) == 1995777273) strcat(s, "i");
if (crc32("gQLVG",5) == 3167305318) strcat(s, "J");
if (crc32("GzzIVwXb",8) == 2671671012) strcat(s, "c");
if (crc32("RHYhBnz",7) == 957110802) strcat(s, "a");
if (crc32("YBTUDOEX",8) == 1417187026) strcat(s, "n");
if (crc32("YNqkiWfFKdMZu",13) == 1405622077) strcat(s, "t");
if (crc32("GrPXZqLIGbcfE",13) == 4253056091) strcat(s, "e");
if (crc32("oXFbBxh",7) == 1393830772) strcat(s, "e");
if (crc32("jiQZBTIvgAihKi",14) == 1611183880) strcat(s, "d");
    return s;
}

char *quasilegislative_adjectives() {
    char *s = calloc(17);
    if (crc32("YzFNTIWzVj",10) == 3020329249) strcat(s, "q");
if (crc32("DgeFptHzSTpsDX",14) == 681919633) strcat(s, "x");
if (crc32("CvrjRVlihj",10) == 346925478) strcat(s, "u");
if (crc32("cfZwzJvtw",9) == 2523170763) strcat(s, "a");
if (crc32("WQDzoZpdJLZVBL",14) == 1054088287) strcat(s, "s");
if (crc32("NIbsNJMidOnpXS",14) == 3818871734) strcat(s, "i");
if (crc32("HzynRJRkYNAb",12) == 298407564) strcat(s, "l");
if (crc32("CfPAYsXXQt",10) == 3502774024) strcat(s, "F");
if (crc32("BLVxRbSlKrze",12) == 2855591201) strcat(s, "e");
if (crc32("BPQQKqnW",8) == 888510638) strcat(s, "Z");
if (crc32("ubgLjJnYzKc",11) == 4169291984) strcat(s, "g");
if (crc32("pcQFHQ",6) == 757408171) strcat(s, "C");
if (crc32("ClMWJErZbUaKXXV",15) == 1947262655) strcat(s, "i");
if (crc32("DsVIcM",6) == 2508544635) strcat(s, "F");
if (crc32("VSnMBUuSpFf",11) == 3200802963) strcat(s, "s");
if (crc32("sPVBZJDMDlpm",12) == 1298210119) strcat(s, "l");
if (crc32("YIoRk",5) == 73090571) strcat(s, "a");
if (crc32("QzLkZMYBX",9) == 2154273443) strcat(s, "t");
if (crc32("RYUfgoRP",8) == 622376362) strcat(s, "P");
if (crc32("Hrebddr",7) == 2631619152) strcat(s, "i");
if (crc32("IzFVOXNWHAKt",12) == 3689352911) strcat(s, "G");
if (crc32("xnwVXwN",7) == 1177861911) strcat(s, "v");
if (crc32("kpMYb",5) == 4084787495) strcat(s, "e");
    return s;
}

char *pottiest_adjectives() {
    char *s = calloc(9);
    if (crc32("iSoBOO",6) == 3204458147) strcat(s, "Q");
if (crc32("rKwDbi",6) == 987040209) strcat(s, "p");
if (crc32("wQAPIpflat",10) == 1309284398) strcat(s, "X");
if (crc32("ThwXgRlEuuG",11) == 1682179918) strcat(s, "o");
if (crc32("HfDjA",5) == 1505139581) strcat(s, "t");
if (crc32("zvnRys",6) == 718979718) strcat(s, "x");
if (crc32("wrUWIo",6) == 1298227285) strcat(s, "t");
if (crc32("FVqJEWDjQSph",12) == 2509008066) strcat(s, "N");
if (crc32("EOOoDorPWqLo",12) == 1446388568) strcat(s, "i");
if (crc32("ohhYRDEeGiqYkJ",14) == 3528654341) strcat(s, "e");
if (crc32("UXVFYZOv",8) == 2081664917) strcat(s, "s");
if (crc32("RZygCVWH",8) == 2664877471) strcat(s, "t");
    return s;
}

char *nonreductive_adjectives() {
    char *s = calloc(13);
    if (crc32("pQnlLuCIHuBlrOz",15) == 1085649951) strcat(s, "n");
if (crc32("LpolwpFGuiDQh",13) == 2545571695) strcat(s, "i");
if (crc32("EuzDVZxDEDAq",12) == 1973563396) strcat(s, "o");
if (crc32("uNjSuXuPnlOn",12) == 3186816060) strcat(s, "a");
if (crc32("jgMQdsf",7) == 2610203308) strcat(s, "n");
if (crc32("JDYCVNsDNGEJVY",14) == 296224190) strcat(s, "r");
if (crc32("FrXxbx",6) == 3063879155) strcat(s, "e");
if (crc32("IKoQFB",6) == 456691464) strcat(s, "s");
if (crc32("MPnngTHGwwBIdx",14) == 3324913178) strcat(s, "d");
if (crc32("gZQimwzIGyswy",13) == 3061363939) strcat(s, "u");
if (crc32("PkSbvkBMQyTuFhC",15) == 583352349) strcat(s, "V");
if (crc32("AxzwLVIjWulfyUK",15) == 1949176798) strcat(s, "c");
if (crc32("TCrGzWXw",8) == 3169201708) strcat(s, "t");
if (crc32("gLGeYHDXWONNZAh",15) == 3520603978) strcat(s, "i");
if (crc32("cbFJBYdVk",9) == 1968704959) strcat(s, "v");
if (crc32("EcctoYQASE",10) == 3789319710) strcat(s, "e");
    return s;
}

char *raptureless_adjectives() {
    char *s = calloc(12);
    if (crc32("neheZsKwD",9) == 3498659001) strcat(s, "m");
if (crc32("cVySjxNlGwflLk",14) == 2917866666) strcat(s, "r");
if (crc32("HKpCznvtcucVaKd",15) == 3732308157) strcat(s, "D");
if (crc32("jKFgzIE",7) == 3625777404) strcat(s, "a");
if (crc32("wkoraAjnR",9) == 2030030651) strcat(s, "p");
if (crc32("wSoTAXeeeJWJ",12) == 736703995) strcat(s, "t");
if (crc32("MkNAQsGja",9) == 391488270) strcat(s, "n");
if (crc32("SKXGDQa",7) == 182987442) strcat(s, "u");
if (crc32("lEjzXYqdyn",10) == 2378745773) strcat(s, "H");
if (crc32("oheXvgAklxFSi",13) == 2039941462) strcat(s, "r");
if (crc32("eEDzA",5) == 3830738855) strcat(s, "b");
if (crc32("OeKJhAAwYn",10) == 1007817533) strcat(s, "e");
if (crc32("lxmzg",5) == 1919080662) strcat(s, "l");
if (crc32("YqzcNCfvgCfGMI",14) == 3485477602) strcat(s, "t");
if (crc32("sewzVibljWz",11) == 1867356832) strcat(s, "e");
if (crc32("gMaSVIvIpRrem",13) == 1696472697) strcat(s, "s");
if (crc32("iTsKDMbcqb",10) == 1026330224) strcat(s, "b");
if (crc32("OmMNxzJHAdVw",12) == 1617763455) strcat(s, "s");
    return s;
}

char *nonconversational_adjectives() {
    char *s = calloc(18);
    if (crc32("dsAnrk",6) == 3048956709) strcat(s, "m");
if (crc32("STXDHoxyOulQgW",14) == 469202952) strcat(s, "n");
if (crc32("ixWotFRStNyG",12) == 3958747719) strcat(s, "o");
if (crc32("yQGSVhqHFxz",11) == 3557707470) strcat(s, "u");
if (crc32("nxVaEYur",8) == 581264936) strcat(s, "n");
if (crc32("bKUIslbV",8) == 1438923394) strcat(s, "c");
if (crc32("aTTwDGGtcsZB",12) == 2980978749) strcat(s, "o");
if (crc32("mpKdK",5) == 1357885671) strcat(s, "n");
if (crc32("skvgKx",6) == 2617890229) strcat(s, "v");
if (crc32("zAUyirfcihPqlkS",15) == 1274487782) strcat(s, "e");
if (crc32("WtzefDUyleZ",11) == 1890857081) strcat(s, "r");
if (crc32("NTKPwkCPfVDu",12) == 1260226237) strcat(s, "F");
if (crc32("incbJrvcSU",10) == 3138870302) strcat(s, "s");
if (crc32("AzFpILyayqWatt",14) == 2204511807) strcat(s, "a");
if (crc32("pbuWYxzNmEy",11) == 3626865940) strcat(s, "t");
if (crc32("zIzFV",5) == 1597653325) strcat(s, "N");
if (crc32("hHYCFFY",7) == 3122659125) strcat(s, "i");
if (crc32("forHwHKgxYoXzL",14) == 4103221645) strcat(s, "g");
if (crc32("xhzvZdiWTtfM",12) == 3822881490) strcat(s, "o");
if (crc32("YwFEKsVurpeuTSD",15) == 1429824561) strcat(s, "B");
if (crc32("GWIzpOdcApUR",12) == 261959558) strcat(s, "n");
if (crc32("DhrVebAdIuDIM",13) == 819825624) strcat(s, "M");
if (crc32("OaBDXXNju",9) == 2141016420) strcat(s, "a");
if (crc32("HOwfTTVSVmPX",12) == 3176914527) strcat(s, "x");
if (crc32("gRTLiBorgbW",11) == 2545129975) strcat(s, "l");
    return s;
}

char *unatrophied_adjectives() {
    char *s = calloc(12);
    if (crc32("LmawHoh",7) == 2151284499) strcat(s, "I");
if (crc32("yusTystk",8) == 4194009351) strcat(s, "u");
if (crc32("iIGJvpBcjc",10) == 1810254656) strcat(s, "n");
if (crc32("HGCGJPeCOvYFs",13) == 2726406144) strcat(s, "J");
if (crc32("rEgyhkAl",8) == 1797326364) strcat(s, "a");
if (crc32("KKlCoBec",8) == 893466578) strcat(s, "r");
if (crc32("RDeSuyzMPcwbpZB",15) == 1489202093) strcat(s, "t");
if (crc32("KkNglGlCDoJILwU",15) == 4195217742) strcat(s, "c");
if (crc32("YikNrbNFIOIFmBA",15) == 4039056504) strcat(s, "r");
if (crc32("wlCSZB",6) == 3304781006) strcat(s, "o");
if (crc32("IzyNbwHtN",9) == 1420714587) strcat(s, "p");
if (crc32("LlWKSKSHW",9) == 1257604939) strcat(s, "h");
if (crc32("lEpiNp",6) == 1277295167) strcat(s, "i");
if (crc32("KyNRRkgnvpIzKEi",15) == 408613589) strcat(s, "d");
if (crc32("ezHYAJggkexPI",13) == 3695725439) strcat(s, "e");
if (crc32("roOKndl",7) == 2364686027) strcat(s, "a");
if (crc32("BWJknMQnezHO",12) == 731277378) strcat(s, "d");
    return s;
}

char *detainable_adjectives() {
    char *s = calloc(11);
    if (crc32("WJdOUDxKupfThyx",15) == 4062683415) strcat(s, "u");
if (crc32("dnHDcjkUJf",10) == 2431579099) strcat(s, "d");
if (crc32("NLWOUa",6) == 3388373710) strcat(s, "e");
if (crc32("GIKNldkEXu",10) == 312931022) strcat(s, "b");
if (crc32("HomOT",5) == 2517409172) strcat(s, "t");
if (crc32("LZXhyfVNLctLUbX",15) == 3621270937) strcat(s, "r");
if (crc32("gtqaaR",6) == 3413431454) strcat(s, "a");
if (crc32("lRWrZeMjCUgvCub",15) == 2786246854) strcat(s, "i");
if (crc32("dXxJmMxcCedek",13) == 3875327350) strcat(s, "n");
if (crc32("qozMcAzeaM",10) == 3027334065) strcat(s, "a");
if (crc32("sKXQysKSXYXB",12) == 3780465250) strcat(s, "b");
if (crc32("XnodFu",6) == 2427479512) strcat(s, "y");
if (crc32("gQtkTknjRkNcrC",14) == 1346518989) strcat(s, "l");
if (crc32("BYnTmzQQevSuJFX",15) == 96936649) strcat(s, "R");
if (crc32("uTheV",5) == 1866068460) strcat(s, "e");
    return s;
}

char *conducible_adjectives() {
    char *s = calloc(11);
    if (crc32("IAbeIHNTA",9) == 2606015442) strcat(s, "c");
if (crc32("gmRddDGJJzI",11) == 1826817780) strcat(s, "o");
if (crc32("AFkaUimvOISDrka",15) == 3195371854) strcat(s, "n");
if (crc32("QcHCxVfi",8) == 2077958013) strcat(s, "d");
if (crc32("MOqBVjQsZuldvya",15) == 4243706471) strcat(s, "u");
if (crc32("WNEKAxSe",8) == 3346682437) strcat(s, "l");
if (crc32("oxwBSNnJimQmje",14) == 2344063972) strcat(s, "c");
if (crc32("bzYbnocyd",9) == 3783855647) strcat(s, "i");
if (crc32("kEJlrUqhVwprjda",15) == 697220467) strcat(s, "b");
if (crc32("NoqgGuatI",9) == 965425187) strcat(s, "V");
if (crc32("GzbYTtyASETygyK",15) == 999900293) strcat(s, "l");
if (crc32("vrQxIGG",7) == 3607970579) strcat(s, "e");
    return s;
}

char *intransigent_adjectives() {
    char *s = calloc(13);
    if (crc32("OQQrcREs",8) == 4019640898) strcat(s, "I");
if (crc32("ZTKeMWkFMqRaJEj",15) == 3825732511) strcat(s, "i");
if (crc32("yefLwjRwottj",12) == 3134419064) strcat(s, "w");
if (crc32("IdtlWkDgcLKN",12) == 3365154321) strcat(s, "n");
if (crc32("bEiEHUB",7) == 3350196619) strcat(s, "t");
if (crc32("AlBQYILb",8) == 3185475725) strcat(s, "r");
if (crc32("wPBoTorwF",9) == 3554488044) strcat(s, "Z");
if (crc32("rMeoCFf",7) == 400820177) strcat(s, "a");
if (crc32("hTHFsxWYJpwpmat",15) == 570599194) strcat(s, "n");
if (crc32("gcxdVNawEZsM",12) == 2071332385) strcat(s, "t");
if (crc32("jhKFBRUIUnwiFC",14) == 743069242) strcat(s, "s");
if (crc32("avnfXh",6) == 2723176871) strcat(s, "i");
if (crc32("vjORHm",6) == 416762574) strcat(s, "g");
if (crc32("IXqHXgojVQaahoq",15) == 1041132065) strcat(s, "e");
if (crc32("XnYtU",5) == 2662709490) strcat(s, "B");
if (crc32("cuVokdXEbXfejv",14) == 364167257) strcat(s, "n");
if (crc32("TGaGxVhIrM",10) == 2608293066) strcat(s, "U");
if (crc32("NYSGvjdm",8) == 3057082146) strcat(s, "t");
    return s;
}

char *usurious_adjectives() {
    char *s = calloc(9);
    if (crc32("oyBDZfdRSCHI",12) == 4115232755) strcat(s, "n");
if (crc32("uLZyvOuEVEQcWg",14) == 2522132610) strcat(s, "u");
if (crc32("YgXMjpOosE",10) == 4017308412) strcat(s, "s");
if (crc32("pqTivuRnIP",10) == 3096300458) strcat(s, "u");
if (crc32("TszVjrcfkntxeJ",14) == 1825308014) strcat(s, "r");
if (crc32("wgBaVFkjAH",10) == 2250402235) strcat(s, "G");
if (crc32("tpbLhWMo",8) == 1993613673) strcat(s, "i");
if (crc32("lLSmexkwdgbgmLr",15) == 2291413866) strcat(s, "o");
if (crc32("fXqdUldSUBEO",12) == 4148653743) strcat(s, "o");
if (crc32("OzinyoYkftbcR",13) == 1279246663) strcat(s, "u");
if (crc32("WFPtOBiJHyvOpF",14) == 3729025483) strcat(s, "s");
    return s;
}

char *groved_adjectives() {
    char *s = calloc(7);
    if (crc32("pKhziN",6) == 392973097) strcat(s, "g");
if (crc32("Ddoqn",5) == 11591989) strcat(s, "r");
if (crc32("wZWmQPMOXaZXpy",14) == 242794819) strcat(s, "G");
if (crc32("REGNEcmP",8) == 3438228632) strcat(s, "o");
if (crc32("NewDwhTv",8) == 3966951904) strcat(s, "v");
if (crc32("nFKDxJ",6) == 3551664474) strcat(s, "T");
if (crc32("hAHFoqLTaX",10) == 2881565844) strcat(s, "e");
if (crc32("zTeFSKvCKdy",11) == 3806690315) strcat(s, "d");
    return s;
}

char *uninfringed_adjectives() {
    char *s = calloc(12);
    if (crc32("YLvdthANkVGq",12) == 1394938060) strcat(s, "u");
if (crc32("OIgVpHLZrLvNyo",14) == 3456159869) strcat(s, "v");
if (crc32("kwELh",5) == 3084685100) strcat(s, "n");
if (crc32("YuuGbqzTNsopPaq",15) == 544246615) strcat(s, "V");
if (crc32("ToQZj",5) == 3904438364) strcat(s, "i");
if (crc32("JnnwlW",6) == 2399362972) strcat(s, "n");
if (crc32("kiYiaNPmZsJ",11) == 3023733651) strcat(s, "f");
if (crc32("jrBYTS",6) == 3849986983) strcat(s, "f");
if (crc32("EsakFjKKTGDERFT",15) == 2205137248) strcat(s, "r");
if (crc32("JTWUFmGkUbwTsK",14) == 2577209437) strcat(s, "i");
if (crc32("dgWDFbLEyBkzB",13) == 2680058904) strcat(s, "r");
if (crc32("DiLPBQMxygEeBvl",15) == 2560420958) strcat(s, "n");
if (crc32("SzzjrhyHQ",9) == 584063617) strcat(s, "d");
if (crc32("gTViWTzffMe",11) == 2221689197) strcat(s, "g");
if (crc32("giobj",5) == 3534297287) strcat(s, "c");
if (crc32("rsRji",5) == 4177456079) strcat(s, "e");
if (crc32("qTeeBuhmVfGyO",13) == 278372419) strcat(s, "d");
if (crc32("oLvwJYlzoQ",10) == 4117726893) strcat(s, "d");
    return s;
}

char *coequal_adjectives() {
    char *s = calloc(8);
    if (crc32("jdnNSKsMAyBcZ",13) == 115806307) strcat(s, "c");
if (crc32("NhqKlDr",7) == 2391532155) strcat(s, "o");
if (crc32("SUaEcA",6) == 4115407133) strcat(s, "f");
if (crc32("TpcjoWZI",8) == 1076261868) strcat(s, "e");
if (crc32("lzwCmesRi",9) == 1187248591) strcat(s, "q");
if (crc32("MMmNQJmc",8) == 4150674538) strcat(s, "r");
if (crc32("nwuiAEGXolNRdan",15) == 2873423333) strcat(s, "u");
if (crc32("UGaLLHPR",8) == 1260803698) strcat(s, "n");
if (crc32("eWtiHW",6) == 222096047) strcat(s, "a");
if (crc32("wFnwXn",6) == 578376917) strcat(s, "l");
    return s;
}

char *untagged_adjectives() {
    char *s = calloc(9);
    if (crc32("StmAwoU",7) == 1381513845) strcat(s, "X");
if (crc32("ZyZJcOad",8) == 51290961) strcat(s, "u");
if (crc32("ITTrqremoMs",11) == 3968666438) strcat(s, "n");
if (crc32("cMYjCZsuCL",10) == 2984535771) strcat(s, "a");
if (crc32("pMCEuDqIvlQ",11) == 4125926481) strcat(s, "t");
if (crc32("CTOAaUPD",8) == 2179015320) strcat(s, "Z");
if (crc32("kYDZii",6) == 335453854) strcat(s, "a");
if (crc32("MsrbyqDhUh",10) == 564172725) strcat(s, "N");
if (crc32("tgXbjfmXySxCikr",15) == 2894289646) strcat(s, "g");
if (crc32("cvkhUEMFvhT",11) == 635745803) strcat(s, "g");
if (crc32("NJetwEotFCpEYgq",15) == 3335724412) strcat(s, "e");
if (crc32("eCNvgpV",7) == 2216070404) strcat(s, "d");
    return s;
}

char *overcompliant_adjectives() {
    char *s = calloc(14);
    if (crc32("epBuQjF",7) == 1556203893) strcat(s, "o");
if (crc32("woulPO",6) == 1454688046) strcat(s, "D");
if (crc32("AuVGXuLkvoaiiE",14) == 3516651444) strcat(s, "v");
if (crc32("IUILeBfOZ",9) == 3870134833) strcat(s, "L");
if (crc32("YaqdsbaMvbyn",12) == 1603548242) strcat(s, "e");
if (crc32("mrcOJXoapENCvR",14) == 544650541) strcat(s, "r");
if (crc32("YcnJDIsdDp",10) == 661739338) strcat(s, "V");
if (crc32("YRQYoxCpCXYGZl",14) == 4091522815) strcat(s, "c");
if (crc32("lmQuzDBar",9) == 3743058265) strcat(s, "o");
if (crc32("kfOAcCLXpnaRii",14) == 2494894076) strcat(s, "H");
if (crc32("NprYgbxBIMzPx",13) == 962564441) strcat(s, "m");
if (crc32("ToyXNxSdRSbPn",13) == 2817719801) strcat(s, "S");
if (crc32("OqeKweyAoU",10) == 1813672743) strcat(s, "p");
if (crc32("pSdJGhmhxU",10) == 1100784749) strcat(s, "Y");
if (crc32("GFjmRIAU",8) == 1161847111) strcat(s, "l");
if (crc32("mrerddmDRLGE",12) == 3260932845) strcat(s, "d");
if (crc32("TMgfBVbIaLwc",12) == 814457526) strcat(s, "i");
if (crc32("TxxUyULuD",9) == 1739491401) strcat(s, "a");
if (crc32("yakaDHAaBtph",12) == 755585904) strcat(s, "N");
if (crc32("OjELFqEZsdA",11) == 2269050594) strcat(s, "n");
if (crc32("JxJsF",5) == 1414279829) strcat(s, "G");
if (crc32("UbxXYEvcGbLt",12) == 3794172188) strcat(s, "t");
    return s;
}

char *compromissary_adjectives() {
    char *s = calloc(14);
    if (crc32("RPYnaStzmHwUA",13) == 478189415) strcat(s, "c");
if (crc32("ljJnPkcId",9) == 740581353) strcat(s, "V");
if (crc32("UkrFPsVgnGOjrIm",15) == 274318496) strcat(s, "o");
if (crc32("tXqFgv",6) == 492598684) strcat(s, "m");
if (crc32("nXBDhELaNJUWeF",14) == 242680217) strcat(s, "W");
if (crc32("CPnwOClLc",9) == 52881551) strcat(s, "p");
if (crc32("jIPuGEgosWSZneO",15) == 3052396841) strcat(s, "r");
if (crc32("xsLuAtHjaArnRt",14) == 93453217) strcat(s, "C");
if (crc32("nTSbv",5) == 605612801) strcat(s, "o");
if (crc32("lJbnxjWOybvICG",14) == 987043616) strcat(s, "m");
if (crc32("WTmkEcktZ",9) == 2498476188) strcat(s, "i");
if (crc32("CwqXC",5) == 3877472432) strcat(s, "s");
if (crc32("xYjKOALrCrdsd",13) == 1908573131) strcat(s, "a");
if (crc32("qdfjvdoC",8) == 2067029700) strcat(s, "s");
if (crc32("LwyAIWPwqtK",11) == 3846060979) strcat(s, "x");
if (crc32("GuotfoV",7) == 2485644183) strcat(s, "a");
if (crc32("ojNnFNsQFis",11) == 3374649510) strcat(s, "u");
if (crc32("IjLqLYfMPiRaX",13) == 334252553) strcat(s, "r");
if (crc32("DUJblbjGbrFDAxW",15) == 3896110772) strcat(s, "y");
    return s;
}

char *unpanelled_adjectives() {
    char *s = calloc(11);
    if (crc32("OJfhTQRWYEmcbwi",15) == 1651674410) strcat(s, "L");
if (crc32("uQrJMPeWtIX",11) == 3984959795) strcat(s, "u");
if (crc32("mvaRhGh",7) == 3585421155) strcat(s, "n");
if (crc32("cXeUf",5) == 990427514) strcat(s, "p");
if (crc32("gOWrmZMLV",9) == 3140968571) strcat(s, "F");
if (crc32("iDUZsLJSRd",10) == 2681284252) strcat(s, "a");
if (crc32("keYPuKaOj",9) == 3867779449) strcat(s, "W");
if (crc32("MlYxWoPgaTbC",12) == 3558724285) strcat(s, "n");
if (crc32("phDINLdshH",10) == 297628395) strcat(s, "e");
if (crc32("hvmRUaSxa",9) == 6998488) strcat(s, "l");
if (crc32("rFnwg",5) == 179224243) strcat(s, "l");
if (crc32("ZZHErfDhXiB",11) == 3815689249) strcat(s, "e");
if (crc32("ogjoS",5) == 787931627) strcat(s, "d");
    return s;
}

char *unreiterative_adjectives() {
    char *s = calloc(14);
    if (crc32("aFTmpYalu",9) == 3472243691) strcat(s, "u");
if (crc32("naAWypmcVAOkC",13) == 3411703189) strcat(s, "g");
if (crc32("nPJnfgKJove",11) == 2143805708) strcat(s, "n");
if (crc32("BLOky",5) == 3296970029) strcat(s, "t");
if (crc32("RSHAgpQp",8) == 3877739459) strcat(s, "r");
if (crc32("CRWLxPBZaexaT",13) == 2281972248) strcat(s, "e");
if (crc32("JQDIHgWtKA",10) == 2886886804) strcat(s, "i");
if (crc32("HhHWp",5) == 2446289476) strcat(s, "a");
if (crc32("rKUYcFIzULpTMGR",15) == 555318359) strcat(s, "t");
if (crc32("OJsdoQOgdupFETv",15) == 4206654666) strcat(s, "e");
if (crc32("BmVZsShgcf",10) == 1795924372) strcat(s, "e");
if (crc32("bzmLakIUX",9) == 4025876197) strcat(s, "i");
if (crc32("tzNRojLcfxI",11) == 33155375) strcat(s, "r");
if (crc32("oqBQxxsQLV",10) == 3200483680) strcat(s, "I");
if (crc32("DVcVRfcuROJG",12) == 1542994767) strcat(s, "a");
if (crc32("RsifZDJBimaEk",13) == 1766020604) strcat(s, "t");
if (crc32("vqEPQBVnUl",10) == 3791835209) strcat(s, "f");
if (crc32("PmeJmWfLABg",11) == 3306338127) strcat(s, "i");
if (crc32("mDcha",5) == 524456731) strcat(s, "l");
if (crc32("YYbZpVTNiwifq",13) == 914116079) strcat(s, "v");
if (crc32("oUZSeSVXNzrsYM",14) == 2776684152) strcat(s, "e");
    return s;
}

char *subconcessionary_adjectives() {
    char *s = calloc(17);
    if (crc32("vSzkuDT",7) == 1839365389) strcat(s, "s");
if (crc32("csuboqrlzJ",10) == 383778172) strcat(s, "u");
if (crc32("fcuNlYNXU",9) == 3853965249) strcat(s, "b");
if (crc32("jdotRVJELcUNS",13) == 3073232964) strcat(s, "t");
if (crc32("ijLdUsOwqIspOTi",15) == 608522677) strcat(s, "c");
if (crc32("AMLwtYcbqxoQmz",14) == 296112319) strcat(s, "o");
if (crc32("RZOOAFMUjOWG",12) == 3973582500) strcat(s, "n");
if (crc32("iDbrWhc",7) == 623065968) strcat(s, "c");
if (crc32("kvbPztcm",8) == 313448817) strcat(s, "f");
if (crc32("AnTqYllz",8) == 2254530521) strcat(s, "e");
if (crc32("EfvqgvbzIUHDYK",14) == 2373268325) strcat(s, "a");
if (crc32("EKRQbrBTYu",10) == 2196719482) strcat(s, "s");
if (crc32("yNKfWaEbGEW",11) == 233494858) strcat(s, "s");
if (crc32("ByDymXWO",8) == 1391537339) strcat(s, "r");
if (crc32("eBECF",5) == 2488740062) strcat(s, "i");
if (crc32("IyAgIK",6) == 3285382672) strcat(s, "o");
if (crc32("jxxCMMIOWN",10) == 3279534159) strcat(s, "o");
if (crc32("vaFyp",5) == 3922014437) strcat(s, "n");
if (crc32("sAypPhROLPzhw",13) == 2275388602) strcat(s, "a");
if (crc32("mDfWNPSkeKsvrOw",15) == 2394257604) strcat(s, "r");
if (crc32("OvsKsYH",7) == 3515879204) strcat(s, "F");
if (crc32("InVyQdSTkc",10) == 3034767330) strcat(s, "y");
    return s;
}

char *nonpneumatic_adjectives() {
    char *s = calloc(13);
    if (crc32("YxrurxlBpaa",11) == 1425327274) strcat(s, "n");
if (crc32("kEcZLQYqpxwpa",13) == 3992603197) strcat(s, "o");
if (crc32("crgfxcrBVpb",11) == 2819448944) strcat(s, "R");
if (crc32("jSwihkUKR",9) == 1260608837) strcat(s, "n");
if (crc32("CSIZxLzM",8) == 1363579507) strcat(s, "l");
if (crc32("iCUFgFXDTRecWA",14) == 2799880305) strcat(s, "p");
if (crc32("DxghMT",6) == 2567316846) strcat(s, "X");
if (crc32("NPlSEKqSZCYz",12) == 3477390077) strcat(s, "n");
if (crc32("fdgrSfkfPvADb",13) == 999604150) strcat(s, "e");
if (crc32("yAwuMwVkUEhrds",14) == 968659872) strcat(s, "t");
if (crc32("KTUCxNrrdcoN",12) == 1775017039) strcat(s, "u");
if (crc32("GYBcRFDPtjPj",12) == 314385364) strcat(s, "q");
if (crc32("kPBWDqQOiNgkY",13) == 2705219960) strcat(s, "m");
if (crc32("sWodSk",6) == 3462656826) strcat(s, "V");
if (crc32("CwXXB",5) == 2810627401) strcat(s, "a");
if (crc32("nDaVFvnO",8) == 2548224821) strcat(s, "t");
if (crc32("aGhea",5) == 1050090457) strcat(s, "U");
if (crc32("KoLbvFqPxOgZt",13) == 2082298096) strcat(s, "i");
if (crc32("OtogiqP",7) == 552100452) strcat(s, "L");
if (crc32("IXdmCZmpBTUFAv",14) == 3212668395) strcat(s, "c");
    return s;
}

char *pterylographic_adjectives() {
    char *s = calloc(15);
    if (crc32("rMTuTB",6) == 2152541937) strcat(s, "x");
if (crc32("RgWVuNhcnRgQ",12) == 3227177756) strcat(s, "p");
if (crc32("KjRiCM",6) == 3648408764) strcat(s, "e");
if (crc32("UbgJORIKpZvq",12) == 3099778073) strcat(s, "t");
if (crc32("ZlSuxvFxBUFXgG",14) == 2394680666) strcat(s, "e");
if (crc32("DiuTTruHU",9) == 4272063369) strcat(s, "r");
if (crc32("zgUcyCTznG",10) == 4095918235) strcat(s, "c");
if (crc32("efikQQKRs",9) == 3521674267) strcat(s, "y");
if (crc32("aNNBwBqQyX",10) == 809720201) strcat(s, "u");
if (crc32("hdPohYQPRnmz",12) == 2248433190) strcat(s, "l");
if (crc32("fmUozpI",7) == 730820751) strcat(s, "o");
if (crc32("MctgeR",6) == 1519942005) strcat(s, "T");
if (crc32("yXwOFX",6) == 3677428285) strcat(s, "g");
if (crc32("IfvJjzRk",8) == 589567906) strcat(s, "M");
if (crc32("CSeOFAEgZHSHy",13) == 303674186) strcat(s, "r");
if (crc32("nUsdKMwgGMQUHV",14) == 2178052139) strcat(s, "a");
if (crc32("WZzcZAbQOixfu",13) == 3020038053) strcat(s, "e");
if (crc32("BOVgrKfSMgmBTZL",15) == 1476119121) strcat(s, "p");
if (crc32("NTHGsCzgsXT",11) == 274259652) strcat(s, "h");
if (crc32("qqkIbSpcwQp",11) == 1114355913) strcat(s, "r");
if (crc32("EFSFR",5) == 2784128887) strcat(s, "i");
if (crc32("diloqfJH",8) == 2796636645) strcat(s, "c");
    return s;
}

char *unwakened_adjectives() {
    char *s = calloc(10);
    if (crc32("MlNDiCGUzl",10) == 1820442052) strcat(s, "q");
if (crc32("cCoel",5) == 2383688671) strcat(s, "u");
if (crc32("QUDaz",5) == 2217150766) strcat(s, "n");
if (crc32("fhUjEmi",7) == 2812936055) strcat(s, "w");
if (crc32("FQqvExCn",8) == 2710466121) strcat(s, "v");
if (crc32("lpHduqOsKhzJyH",14) == 4062722462) strcat(s, "a");
if (crc32("SYutnNGaMYn",11) == 1666663153) strcat(s, "k");
if (crc32("pqUBp",5) == 340680907) strcat(s, "e");
if (crc32("IUWqYPOvOgJ",11) == 103902563) strcat(s, "n");
if (crc32("JaiTi",5) == 4207023816) strcat(s, "x");
if (crc32("fQbUcPcus",9) == 3571188003) strcat(s, "e");
if (crc32("NwtXKd",6) == 281185580) strcat(s, "d");
    return s;
}

char *unacidic_adjectives() {
    char *s = calloc(9);
    if (crc32("LQeopLHbt",9) == 825601562) strcat(s, "u");
if (crc32("fipymaRmUbDNv",13) == 2423859032) strcat(s, "n");
if (crc32("VetNkU",6) == 966144610) strcat(s, "a");
if (crc32("dZHPTeiJ",8) == 4147541835) strcat(s, "P");
if (crc32("YkvkN",5) == 1477959868) strcat(s, "c");
if (crc32("vNaGJSaQcoOa",12) == 56580809) strcat(s, "Y");
if (crc32("DejMkXyyjrDTjR",14) == 543219243) strcat(s, "i");
if (crc32("slVzoHim",8) == 752424859) strcat(s, "X");
if (crc32("dGcJMYO",7) == 799775767) strcat(s, "d");
if (crc32("HIbGaSzfVeqVYn",14) == 4086382508) strcat(s, "i");
if (crc32("swByDApgZkFyKeR",15) == 3543441202) strcat(s, "c");
    return s;
}

char *migrainoid_adjectives() {
    char *s = calloc(11);
    if (crc32("pkmSlRc",7) == 3067534860) strcat(s, "m");
if (crc32("yEJXeZhVoLBt",12) == 790021585) strcat(s, "U");
if (crc32("HMuZnfbDUTXDf",13) == 2336708092) strcat(s, "i");
if (crc32("NpquAKR",7) == 238891069) strcat(s, "p");
if (crc32("BURdWErxJG",10) == 3516459690) strcat(s, "g");
if (crc32("UrAWpT",6) == 1616438991) strcat(s, "z");
if (crc32("XtrjmnTYbi",10) == 4084871662) strcat(s, "r");
if (crc32("lJHFLTVwRMWaRB",14) == 2393049210) strcat(s, "W");
if (crc32("IjQJCSj",7) == 1516710018) strcat(s, "a");
if (crc32("ZqildsjzOsj",11) == 2642541624) strcat(s, "C");
if (crc32("AlTdVkyWRRRoLGu",15) == 1748947486) strcat(s, "i");
if (crc32("iXpJpeFlETvS",12) == 230936868) strcat(s, "n");
if (crc32("gAfUvxfsYNeL",12) == 2155759423) strcat(s, "m");
if (crc32("xQpoHku",7) == 3342956125) strcat(s, "o");
if (crc32("zEsmlqRrhnT",11) == 1399355408) strcat(s, "i");
if (crc32("IVYhAQfOuxbm",12) == 3808341118) strcat(s, "d");
    return s;
}

char *unmowed_adjectives() {
    char *s = calloc(8);
    if (crc32("PKQmOxwFnRjkC",13) == 1118124555) strcat(s, "c");
if (crc32("gsqiC",5) == 2590216593) strcat(s, "u");
if (crc32("KTDTLjgGSBokse",14) == 1298581842) strcat(s, "n");
if (crc32("Mwlkaye",7) == 2084279184) strcat(s, "M");
if (crc32("zaFlK",5) == 2861290196) strcat(s, "m");
if (crc32("VhhUigXPtzvsh",13) == 3518885933) strcat(s, "v");
if (crc32("bTgtumXV",8) == 3578914726) strcat(s, "o");
if (crc32("ecnxf",5) == 4002115352) strcat(s, "q");
if (crc32("RBlZd",5) == 4272609755) strcat(s, "w");
if (crc32("sqZrAqneneivw",13) == 2719541375) strcat(s, "i");
if (crc32("CanvRXcdtvUhhdE",15) == 325401512) strcat(s, "e");
if (crc32("zlxBKfMfRw",10) == 2078373003) strcat(s, "u");
if (crc32("OlTEY",5) == 2575148098) strcat(s, "d");
    return s;
}

char *vitriolic_adjectives() {
    char *s = calloc(10);
    if (crc32("qVSnThUWTvTlix",14) == 848410636) strcat(s, "p");
if (crc32("MDaSyIWRBqVWaC",14) == 153601986) strcat(s, "v");
if (crc32("rKvsyqYyorw",11) == 2709132319) strcat(s, "s");
if (crc32("dgHjjLC",7) == 1025888848) strcat(s, "i");
if (crc32("gKrlcs",6) == 4290949058) strcat(s, "u");
if (crc32("BwjLzMdZUQvr",12) == 566147690) strcat(s, "t");
if (crc32("HClYgojJ",8) == 1290625866) strcat(s, "r");
if (crc32("UNjZjA",6) == 2384088250) strcat(s, "C");
if (crc32("REVTQNbG",8) == 3314607862) strcat(s, "i");
if (crc32("bgxlAcmXIRyRI",13) == 1840501620) strcat(s, "e");
if (crc32("zzslZYRh",8) == 3454473266) strcat(s, "o");
if (crc32("MvXGsKhUhri",11) == 3857945428) strcat(s, "l");
if (crc32("YmrUencIcXMLyp",14) == 3528666251) strcat(s, "t");
if (crc32("VUrXhvfnH",9) == 1234723261) strcat(s, "i");
if (crc32("dmyGA",5) == 287984613) strcat(s, "d");
if (crc32("gLyJHp",6) == 984578104) strcat(s, "c");
    return s;
}

char *unlocalizable_adjectives() {
    char *s = calloc(14);
    if (crc32("xQasAIaR",8) == 1233554779) strcat(s, "h");
if (crc32("dUZIryEbvTeduFf",15) == 621170563) strcat(s, "u");
if (crc32("ELTragqJlY",10) == 4134875402) strcat(s, "C");
if (crc32("UeJzELTl",8) == 4082301285) strcat(s, "n");
if (crc32("yRzIQSTbyfWj",12) == 3957371812) strcat(s, "R");
if (crc32("XRRYmeiLqCS",11) == 2305492351) strcat(s, "l");
if (crc32("YSpKntBZVh",10) == 1427705522) strcat(s, "j");
if (crc32("wmAggIuUye",10) == 1152699963) strcat(s, "o");
if (crc32("aDGRgnRnsfmXfuM",15) == 837840683) strcat(s, "c");
if (crc32("IQYXHdsnquYp",12) == 717917116) strcat(s, "e");
if (crc32("zKDDsiTsjiQFQD",14) == 4026249012) strcat(s, "a");
if (crc32("yyrFwKmdnlbCirc",15) == 4003781173) strcat(s, "l");
if (crc32("IxjaoPbMUomCaQ",14) == 2386777378) strcat(s, "g");
if (crc32("GvdsnY",6) == 3728185148) strcat(s, "i");
if (crc32("FgEwgiIwWWr",11) == 3023228634) strcat(s, "z");
if (crc32("MjHjg",5) == 3363839785) strcat(s, "W");
if (crc32("rOioZRBbLtrwgU",14) == 1718508346) strcat(s, "a");
if (crc32("oQCVbbfXZOhPKcW",15) == 8709486) strcat(s, "b");
if (crc32("ErUNIeShYCm",11) == 3108459946) strcat(s, "l");
if (crc32("gqrKJ",5) == 3963754951) strcat(s, "e");
    return s;
}

char *flowerless_adjectives() {
    char *s = calloc(11);
    if (crc32("rPXXLsZlUoZN",12) == 2489198591) strcat(s, "f");
if (crc32("wqBTJSDt",8) == 1602570631) strcat(s, "l");
if (crc32("pydKCwgiHHo",11) == 3380061574) strcat(s, "W");
if (crc32("lKDhvbqNam",10) == 3119723782) strcat(s, "o");
if (crc32("OJLntEDdYPQwnry",15) == 2773426489) strcat(s, "e");
if (crc32("qbLIsQIMG",9) == 654606779) strcat(s, "w");
if (crc32("rmGySKgSqZmEYX",14) == 2546241170) strcat(s, "u");
if (crc32("piykmnhcQGKp",12) == 1339181061) strcat(s, "e");
if (crc32("DLGHlfWi",8) == 3451832425) strcat(s, "r");
if (crc32("ijlVwEF",7) == 3157784085) strcat(s, "o");
if (crc32("JxMhhOneX",9) == 1178425973) strcat(s, "l");
if (crc32("mEomGsg",7) == 1487397709) strcat(s, "e");
if (crc32("LEmLEMz",7) == 1919216020) strcat(s, "s");
if (crc32("IorHbEoPor",10) == 500592751) strcat(s, "s");
    return s;
}

char *mansized_adjectives() {
    char *s = calloc(9);
    if (crc32("EstuFxgMWF",10) == 2310430742) strcat(s, "O");
if (crc32("kCfZaqBOtRowhO",14) == 3837653924) strcat(s, "m");
if (crc32("QbTSlMdGoIC",11) == 2245771643) strcat(s, "K");
if (crc32("eaoeDgj",7) == 1620629332) strcat(s, "a");
if (crc32("nQqHrhsuLNyQu",13) == 2339203790) strcat(s, "n");
if (crc32("BLPFTyQ",7) == 959093922) strcat(s, "s");
if (crc32("pZRylZRsJt",10) == 4220804228) strcat(s, "i");
if (crc32("hMMAFSsLAmEaXM",14) == 1861051210) strcat(s, "z");
if (crc32("NUOzkh",6) == 722629871) strcat(s, "e");
if (crc32("yrviaLcALODr",12) == 2145191932) strcat(s, "T");
if (crc32("JLNvJnWAgyMuv",13) == 3225729738) strcat(s, "d");
    return s;
}

char *Papuan_adjectives() {
    char *s = calloc(7);
    if (crc32("bkhkSZkx",8) == 210551408) strcat(s, "X");
if (crc32("mkDAGvbzrLw",11) == 3254164602) strcat(s, "P");
if (crc32("VtOSYcQenh",10) == 1297082345) strcat(s, "i");
if (crc32("SlHiDsbvqLu",11) == 1378518541) strcat(s, "a");
if (crc32("pIdvODrzskXrcSA",15) == 4131037415) strcat(s, "a");
if (crc32("wsTcAQDzFYIGS",13) == 1890543452) strcat(s, "p");
if (crc32("zhoWo",5) == 430172992) strcat(s, "R");
if (crc32("VkKJDSOyBAgR",12) == 2889540338) strcat(s, "u");
if (crc32("UJVVQ",5) == 1176681584) strcat(s, "s");
if (crc32("NiIcriBc",8) == 555406692) strcat(s, "a");
if (crc32("AQuPwBrqYrHYwI",14) == 3004877688) strcat(s, "d");
if (crc32("Nrgbbui",7) == 1492820548) strcat(s, "n");
    return s;
}

char *karyotypic_adjectives() {
    char *s = calloc(11);
    if (crc32("OwSKihs",7) == 696302646) strcat(s, "k");
if (crc32("xLejW",5) == 2875112728) strcat(s, "B");
if (crc32("FMYGDPbr",8) == 4283704627) strcat(s, "a");
if (crc32("gHcdSDPho",9) == 1198360067) strcat(s, "k");
if (crc32("QfLvQv",6) == 4212831079) strcat(s, "r");
if (crc32("LNcMXKVhypm",11) == 2611538110) strcat(s, "y");
if (crc32("bqfnJ",5) == 3615378940) strcat(s, "o");
if (crc32("NZglAfMMWOaAXrC",15) == 2478486890) strcat(s, "C");
if (crc32("zLzuFzmcWPV",11) == 3869417055) strcat(s, "t");
if (crc32("nWHcecqjhVzgL",13) == 3538983116) strcat(s, "K");
if (crc32("dXVkHiYgEgAG",12) == 4237146590) strcat(s, "y");
if (crc32("KBzndwPIfa",10) == 948040477) strcat(s, "u");
if (crc32("qcZGemPmVI",10) == 2346575466) strcat(s, "p");
if (crc32("sLCtY",5) == 2620101355) strcat(s, "p");
if (crc32("HoxYjaKsblS",11) == 3964407118) strcat(s, "i");
if (crc32("QbcFzaGLsqkP",12) == 490705171) strcat(s, "c");
    return s;
}

char *unrepetitious_adjectives() {
    char *s = calloc(14);
    if (crc32("iOhvGGwCxP",10) == 3016909374) strcat(s, "u");
if (crc32("HipDONetmbWVW",13) == 3236109740) strcat(s, "n");
if (crc32("zNTRRaUszQN",11) == 1526591205) strcat(s, "r");
if (crc32("rLmXOxOxPFAdKD",14) == 1468722920) strcat(s, "e");
if (crc32("eWxohK",6) == 3269611848) strcat(s, "p");
if (crc32("FcPrEG",6) == 1335859616) strcat(s, "e");
if (crc32("nZZChwHMT",9) == 2966795225) strcat(s, "t");
if (crc32("HKlfa",5) == 2859176962) strcat(s, "i");
if (crc32("pCDjkQcUwFt",11) == 4004160503) strcat(s, "t");
if (crc32("imUPcnl",7) == 1394423833) strcat(s, "h");
if (crc32("VtNtS",5) == 1444538059) strcat(s, "i");
if (crc32("uJFRt",5) == 2823510906) strcat(s, "o");
if (crc32("rJMpqXgRvs",10) == 699533454) strcat(s, "c");
if (crc32("EULFg",5) == 2794960744) strcat(s, "u");
if (crc32("CLyffXEpeUPyJJi",15) == 4197342706) strcat(s, "W");
if (crc32("mWNuTXnsO",9) == 940557452) strcat(s, "s");
    return s;
}

char *shaggier_adjectives() {
    char *s = calloc(9);
    if (crc32("FQzBS",5) == 2471184562) strcat(s, "F");
if (crc32("BbmmBVZYzRYNm",13) == 2322509594) strcat(s, "s");
if (crc32("RQGmh",5) == 2562629039) strcat(s, "e");
if (crc32("xxoqVZbSXTSlM",13) == 2804742094) strcat(s, "h");
if (crc32("ITCCyuFxlSy",11) == 1309626525) strcat(s, "r");
if (crc32("IDTCLSynJEz",11) == 3206981766) strcat(s, "a");
if (crc32("FbVRAsvSuTt",11) == 678011591) strcat(s, "g");
if (crc32("KjSmZqtRLvKwV",13) == 3239701757) strcat(s, "g");
if (crc32("NClCPVOGn",9) == 705730483) strcat(s, "g");
if (crc32("YBuFVrFhZkamiKE",15) == 3790501405) strcat(s, "i");
if (crc32("IZXeoK",6) == 882117345) strcat(s, "t");
if (crc32("YBdSwTPSrpERiuu",15) == 1891503039) strcat(s, "e");
if (crc32("lFiMpAKCIqyNi",13) == 1497259540) strcat(s, "r");
    return s;
}

char *paleopsychic_adjectives() {
    char *s = calloc(13);
    if (crc32("hRWDQUcTzfVMKV",14) == 1814119901) strcat(s, "y");
if (crc32("nZRmNLVczD",10) == 2659033445) strcat(s, "p");
if (crc32("nlBeMMAhhyVDTyF",15) == 844038339) strcat(s, "a");
if (crc32("KTKkWF",6) == 1227497081) strcat(s, "Z");
if (crc32("KHPLJnarVDJvC",13) == 839479368) strcat(s, "l");
if (crc32("YYRMWhcDX",9) == 3129475275) strcat(s, "e");
if (crc32("ibvtxywAbwBdiZJ",15) == 2166068353) strcat(s, "o");
if (crc32("QRDyPegVCEFrSan",15) == 388621383) strcat(s, "o");
if (crc32("RPZMg",5) == 3101035201) strcat(s, "p");
if (crc32("jYGoceRAVmA",11) == 2140531147) strcat(s, "Z");
if (crc32("WYgBjpUdKomtyBA",15) == 1853742914) strcat(s, "s");
if (crc32("Wxbsigsgan",10) == 1516292187) strcat(s, "y");
if (crc32("XVAWo",5) == 2038985668) strcat(s, "c");
if (crc32("ttSfdGomGyqQT",13) == 3806498317) strcat(s, "h");
if (crc32("rVmAjQYQnKR",11) == 1272923625) strcat(s, "i");
if (crc32("MYxPQaMQo",9) == 2025773089) strcat(s, "t");
if (crc32("fSbnrUzjncM",11) == 4069039963) strcat(s, "c");
    return s;
}

char *anaerobiotic_adjectives() {
    char *s = calloc(13);
    if (crc32("ViFyrWPCF",9) == 3733772783) strcat(s, "a");
if (crc32("vMsfMztxVKn",11) == 905219985) strcat(s, "n");
if (crc32("cLIVuizqcys",11) == 2933749) strcat(s, "h");
if (crc32("QOFkmAo",7) == 2838758097) strcat(s, "a");
if (crc32("ExFDIpO",7) == 436009783) strcat(s, "e");
if (crc32("dFAgGayoa",9) == 4157564411) strcat(s, "f");
if (crc32("QoMEhICIJjV",11) == 3048069086) strcat(s, "r");
if (crc32("xSZaHInhXgCpuAx",15) == 1450542481) strcat(s, "B");
if (crc32("VEmqwrbpV",9) == 3229865259) strcat(s, "o");
if (crc32("RdmsRhQA",8) == 2189133085) strcat(s, "b");
if (crc32("KijrckIUEkm",11) == 639766977) strcat(s, "i");
if (crc32("EMSlcNpCfcIdm",13) == 2961646660) strcat(s, "I");
if (crc32("CoGXxIivMu",10) == 3888601984) strcat(s, "o");
if (crc32("isFCalVCHiugn",13) == 1728224998) strcat(s, "t");
if (crc32("bSkOoHNzSS",10) == 3861062768) strcat(s, "C");
if (crc32("ZIXfWrIN",8) == 931666756) strcat(s, "i");
if (crc32("RdupmIcsM",9) == 2586765176) strcat(s, "c");
    return s;
}

char *aphidious_adjectives() {
    char *s = calloc(10);
    if (crc32("yqWXGqKi",8) == 4057538521) strcat(s, "a");
if (crc32("hPFoEqTh",8) == 3822935919) strcat(s, "p");
if (crc32("bwkcElVki",9) == 242083582) strcat(s, "h");
if (crc32("QnZVzlv",7) == 2680015207) strcat(s, "i");
if (crc32("EVAiNYNEwahvUP",14) == 1734036339) strcat(s, "H");
if (crc32("dFemyYBqctwJpB",14) == 958612054) strcat(s, "d");
if (crc32("UIPEpaHOeQc",11) == 2068242321) strcat(s, "C");
if (crc32("aufwlG",6) == 760951921) strcat(s, "i");
if (crc32("DvlEqEW",7) == 761868283) strcat(s, "o");
if (crc32("MQurHaLfF",9) == 4272769281) strcat(s, "R");
if (crc32("WuvzhLasljJc",12) == 897270794) strcat(s, "u");
if (crc32("yZlqWyEZoX",10) == 644661240) strcat(s, "F");
if (crc32("QJJYABRzRHe",11) == 3590842088) strcat(s, "s");
    return s;
}

char *unhieratical_adjectives() {
    char *s = calloc(13);
    if (crc32("EwIgBcPkTB",10) == 2235381093) strcat(s, "u");
if (crc32("KHZmVMiDkBo",11) == 2537978999) strcat(s, "u");
if (crc32("QqABPkEbBc",10) == 1998983226) strcat(s, "n");
if (crc32("QBHjSGodwkiJSTC",15) == 1531128524) strcat(s, "h");
if (crc32("dMlozDgfaapcU",13) == 1809726450) strcat(s, "i");
if (crc32("UOdDtioYiaK",11) == 1405324930) strcat(s, "y");
if (crc32("aOHeMwgbynv",11) == 4174632723) strcat(s, "e");
if (crc32("dQXhlxamrqzOYw",14) == 3843874023) strcat(s, "X");
if (crc32("gURXGDxU",8) == 175345200) strcat(s, "r");
if (crc32("FDikBH",6) == 3768808662) strcat(s, "H");
if (crc32("mHbhDWZFmPcWVPM",15) == 3664081629) strcat(s, "a");
if (crc32("dbmxh",5) == 1923483036) strcat(s, "A");
if (crc32("GazKXLNvuGE",11) == 2435381239) strcat(s, "t");
if (crc32("GnHgnrj",7) == 1586470944) strcat(s, "E");
if (crc32("sKftOGAHMnOBbWu",15) == 791972633) strcat(s, "i");
if (crc32("nLUONcqfY",9) == 4102186729) strcat(s, "X");
if (crc32("OHQKYDhgwjNQiml",15) == 3222922735) strcat(s, "c");
if (crc32("qpufAMaqO",9) == 1489176027) strcat(s, "a");
if (crc32("beUDjCon",8) == 2977588201) strcat(s, "l");
    return s;
}

char *ferniest_adjectives() {
    char *s = calloc(9);
    if (crc32("bAxDao",6) == 1341620361) strcat(s, "r");
if (crc32("TuBltJLiRTL",11) == 1743548453) strcat(s, "f");
if (crc32("nIZZgMzeMpnR",12) == 435451578) strcat(s, "e");
if (crc32("jypewjSChBlZJ",13) == 2851190772) strcat(s, "D");
if (crc32("IPxwmpzbEI",10) == 627736675) strcat(s, "r");
if (crc32("WeJwmUUfucN",11) == 3334572220) strcat(s, "K");
if (crc32("Aqfvma",6) == 363022604) strcat(s, "n");
if (crc32("aUmcXdk",7) == 2723888190) strcat(s, "a");
if (crc32("bPTVu",5) == 1239819679) strcat(s, "i");
if (crc32("XJPJqdmuKCCPCmd",15) == 2338408878) strcat(s, "e");
if (crc32("IqQkwMuyfIRSKT",14) == 1160517140) strcat(s, "N");
if (crc32("qIKwxKbKSOQBpIH",15) == 2093227257) strcat(s, "s");
if (crc32("NVRgvzbJjSHEiz",14) == 2762883867) strcat(s, "Y");
if (crc32("XrhujiBW",8) == 1767774856) strcat(s, "t");
    return s;
}

char *untrenched_adjectives() {
    char *s = calloc(11);
    if (crc32("CnKECoGkHkWYiK",14) == 3477692130) strcat(s, "u");
if (crc32("nPiKu",5) == 1607062081) strcat(s, "n");
if (crc32("HvPYMvoPal",10) == 1316869361) strcat(s, "Z");
if (crc32("KJirWoelLJShKV",14) == 594704083) strcat(s, "t");
if (crc32("lvcqxZPH",8) == 859826777) strcat(s, "Q");
if (crc32("JfUgdka",7) == 114955857) strcat(s, "r");
if (crc32("GzpbrhFqx",9) == 2840831434) strcat(s, "e");
if (crc32("OniFvoBcUZNTkt",14) == 312716103) strcat(s, "Z");
if (crc32("qJahNvjcYpsZtS",14) == 4086648188) strcat(s, "n");
if (crc32("qYhYRZNaQQpsuM",14) == 1267185709) strcat(s, "X");
if (crc32("TvReCl",6) == 3758555514) strcat(s, "c");
if (crc32("voTxKPapVWE",11) == 557177269) strcat(s, "S");
if (crc32("vhZubPd",7) == 1661392839) strcat(s, "h");
if (crc32("qrJmTQTAF",9) == 309400907) strcat(s, "j");
if (crc32("eGcniIwQhl",10) == 3824430520) strcat(s, "e");
if (crc32("lQzFgJTwUPKx",12) == 2564473237) strcat(s, "d");
    return s;
}

char *macerative_adjectives() {
    char *s = calloc(11);
    if (crc32("HGbSDp",6) == 990183188) strcat(s, "k");
if (crc32("PnQIYZcaCjmtK",13) == 3732487080) strcat(s, "m");
if (crc32("tADJt",5) == 387145538) strcat(s, "i");
if (crc32("DQNqZzoafV",10) == 3799137412) strcat(s, "a");
if (crc32("MsSEqXhAR",9) == 1181430862) strcat(s, "c");
if (crc32("atEdxCSkTLxYC",13) == 1065882729) strcat(s, "I");
if (crc32("lvgLd",5) == 2403330812) strcat(s, "e");
if (crc32("cXKZQbquSSqJZa",14) == 1916890908) strcat(s, "r");
if (crc32("VKVcJYHPtZBfgLZ",15) == 3298884491) strcat(s, "g");
if (crc32("hRTIWri",7) == 258535425) strcat(s, "a");
if (crc32("ydmCMrFbvuqnhNx",15) == 1366621185) strcat(s, "t");
if (crc32("hHAIxaZGuDM",11) == 1439410061) strcat(s, "i");
if (crc32("enLXVDf",7) == 3176356989) strcat(s, "v");
if (crc32("WrbYfYsQigHEl",13) == 3500268338) strcat(s, "y");
if (crc32("ZWofjbtsj",9) == 1172686665) strcat(s, "e");
    return s;
}

char *superaccurate_adjectives() {
    char *s = calloc(14);
    if (crc32("XNpvJWbs",8) == 2314766431) strcat(s, "s");
if (crc32("gMnjKUhyzGVsBLJ",15) == 493393682) strcat(s, "u");
if (crc32("GvOeTevrArXCMvo",15) == 3583213601) strcat(s, "p");
if (crc32("yyoREMDxwTwd",12) == 3457202022) strcat(s, "D");
if (crc32("IoVkeZ",6) == 3139914028) strcat(s, "e");
if (crc32("HYNzFqEb",8) == 1792640917) strcat(s, "r");
if (crc32("bfFfAzMBlHwCs",13) == 3608242156) strcat(s, "W");
if (crc32("JvKtdYd",7) == 90858918) strcat(s, "a");
if (crc32("vKiEwlphMz",10) == 3967323447) strcat(s, "d");
if (crc32("bTtRfUKPc",9) == 3841945502) strcat(s, "c");
if (crc32("HZZxUYQlB",9) == 1566778345) strcat(s, "c");
if (crc32("ReJkFLAef",9) == 1805447227) strcat(s, "u");
if (crc32("soAEW",5) == 306975415) strcat(s, "r");
if (crc32("MyEopKkTLjcz",12) == 78683123) strcat(s, "A");
if (crc32("JRGqJHGluuvm",12) == 3749071479) strcat(s, "a");
if (crc32("PLOtSmEz",8) == 1893473087) strcat(s, "q");
if (crc32("EwNBTOSHGKhlq",13) == 3238590169) strcat(s, "t");
if (crc32("wptgg",5) == 3410300088) strcat(s, "n");
if (crc32("kkSAcQK",7) == 583676879) strcat(s, "e");
    return s;
}

char *monotrichous_adjectives() {
    char *s = calloc(13);
    if (crc32("sBmzrqxM",8) == 2114992797) strcat(s, "C");
if (crc32("GclmW",5) == 1643366480) strcat(s, "m");
if (crc32("hmzDoJMsVoG",11) == 2208989285) strcat(s, "w");
if (crc32("piFyHWxGlJgZt",13) == 828772722) strcat(s, "o");
if (crc32("sLkcRcCCKx",10) == 3930993719) strcat(s, "O");
if (crc32("UfbskUSqaDAYcbn",15) == 4186578916) strcat(s, "n");
if (crc32("oNgZqtM",7) == 1282363213) strcat(s, "o");
if (crc32("VjsGVnloOqkHQVG",15) == 561925311) strcat(s, "t");
if (crc32("SJmztdBffYbGf",13) == 3456449974) strcat(s, "O");
if (crc32("pZWaoXNlUNA",11) == 1067949783) strcat(s, "r");
if (crc32("MBselpJKJMhS",12) == 2396072937) strcat(s, "f");
if (crc32("xUgEW",5) == 3335127345) strcat(s, "i");
if (crc32("aPAKRbRGnzy",11) == 4126253965) strcat(s, "c");
if (crc32("dwdJCTccDR",10) == 766730386) strcat(s, "h");
if (crc32("ZntBtQTzEvQKCfj",15) == 2995350107) strcat(s, "y");
if (crc32("DamOe",5) == 3808233372) strcat(s, "o");
if (crc32("kaKwqFC",7) == 2382628522) strcat(s, "x");
if (crc32("DSrQP",5) == 760686599) strcat(s, "u");
if (crc32("BlWQnhW",7) == 3526282433) strcat(s, "s");
    return s;
}

char *unwormeaten_adjectives() {
    char *s = calloc(12);
    if (crc32("aGgEtdgvqRKSHyi",15) == 2262946917) strcat(s, "h");
if (crc32("DjDuGTESKrDdRSU",15) == 4097679111) strcat(s, "u");
if (crc32("DWgYznjLVeBfTY",14) == 1368845019) strcat(s, "q");
if (crc32("EWgSey",6) == 2637963406) strcat(s, "n");
if (crc32("XFSgmrqprDFo",12) == 3510664085) strcat(s, "w");
if (crc32("VQFdyy",6) == 3579150650) strcat(s, "j");
if (crc32("nvglixN",7) == 4042820154) strcat(s, "o");
if (crc32("biegvFLjeR",10) == 3774381739) strcat(s, "z");
if (crc32("hvccVjfrJInWLJ",14) == 1896846331) strcat(s, "r");
if (crc32("rdLPGdvbAqkBbQ",14) == 2263925061) strcat(s, "m");
if (crc32("XahtIlAPqS",10) == 4118386337) strcat(s, "R");
if (crc32("WDTmAjkHoTvkCF",14) == 1915244250) strcat(s, "e");
if (crc32("CNZvTH",6) == 2379322783) strcat(s, "a");
if (crc32("kHvYpG",6) == 1372326408) strcat(s, "t");
if (crc32("exTtQNqH",8) == 4269124108) strcat(s, "e");
if (crc32("vrPRsKxhmbrak",13) == 2680983885) strcat(s, "n");
    return s;
}

char *quasimad_adjectives() {
    char *s = calloc(9);
    if (crc32("dkIwZHzfYw",10) == 3539675543) strcat(s, "q");
if (crc32("NbmsTMUPUSEEFdR",15) == 2129574768) strcat(s, "u");
if (crc32("DTLHSsZCKEsiSHm",15) == 912206789) strcat(s, "b");
if (crc32("HmymkYDCq",9) == 3591763875) strcat(s, "a");
if (crc32("KzUGPL",6) == 736663384) strcat(s, "s");
if (crc32("ufCGc",5) == 2706137168) strcat(s, "D");
if (crc32("mkaNAFEDK",9) == 110217687) strcat(s, "i");
if (crc32("ranpMzf",7) == 1632493745) strcat(s, "m");
if (crc32("VefpQpNBwsyF",12) == 114466667) strcat(s, "a");
if (crc32("ecqVcm",6) == 3555923716) strcat(s, "g");
if (crc32("mHoBhHZQoilvt",13) == 1184833156) strcat(s, "d");
    return s;
}

char *unacknowledging_adjectives() {
    char *s = calloc(16);
    if (crc32("HxUjFDqrZaOa",12) == 718344042) strcat(s, "l");
if (crc32("qVkwhnYXW",9) == 2612373143) strcat(s, "u");
if (crc32("BGojESNYVbRlW",13) == 98249309) strcat(s, "F");
if (crc32("ALOxZgX",7) == 1569039247) strcat(s, "n");
if (crc32("gBmUyNCZnD",10) == 3011316400) strcat(s, "a");
if (crc32("FTGNqDnSEAl",11) == 2330876513) strcat(s, "X");
if (crc32("RNToKUKVpi",10) == 1320202374) strcat(s, "c");
if (crc32("OvZIoOlsYBD",11) == 1927616398) strcat(s, "k");
if (crc32("UNRdywZwhFwzSbe",15) == 136322905) strcat(s, "x");
if (crc32("QqUmfm",6) == 249218473) strcat(s, "n");
if (crc32("pqpDFvxxqPK",11) == 3279106529) strcat(s, "J");
if (crc32("XYCtZZdEqqxF",12) == 609170945) strcat(s, "o");
if (crc32("HZhPFx",6) == 1253645849) strcat(s, "w");
if (crc32("SjQUylbbOi",10) == 2040072186) strcat(s, "l");
if (crc32("UdSuPnfiWygQL",13) == 1841420751) strcat(s, "C");
if (crc32("dgauIp",6) == 2846619679) strcat(s, "e");
if (crc32("HTpZzsPIT",9) == 4173007674) strcat(s, "d");
if (crc32("aqjhpVR",7) == 2000564584) strcat(s, "S");
if (crc32("pTRjCXk",7) == 713921133) strcat(s, "g");
if (crc32("tjaby",5) == 2624492757) strcat(s, "L");
if (crc32("JBrNtCOOuat",11) == 3605418727) strcat(s, "i");
if (crc32("oJGCMIglTQN",11) == 1833952606) strcat(s, "d");
if (crc32("HUOWCmOEIQF",11) == 4065138763) strcat(s, "n");
if (crc32("szbdOEdAbrhCzMn",15) == 1761609024) strcat(s, "w");
if (crc32("kcnzTHDfEkrsCPW",15) == 3805107382) strcat(s, "g");
    return s;
}

char *postAugustan_adjectives() {
    char *s = calloc(13);
    if (crc32("FqMolsnvBRQ",11) == 619622953) strcat(s, "p");
if (crc32("sYwfmUyuPU",10) == 3487080747) strcat(s, "o");
if (crc32("VEliJZQncgg",11) == 2154016463) strcat(s, "W");
if (crc32("nrqJuBlyI",9) == 3357465638) strcat(s, "s");
if (crc32("ygIWNJnxUL",10) == 3839504322) strcat(s, "a");
if (crc32("IlbUmEswnHtvNO",14) == 3126083709) strcat(s, "t");
if (crc32("jPptesizrcBn",12) == 3850217753) strcat(s, "f");
if (crc32("qqaChcrF",8) == 2777235162) strcat(s, "A");
if (crc32("ePMppODnQjsGIK",14) == 3643258147) strcat(s, "u");
if (crc32("nmFRjrpEhjcWJBU",15) == 1846998221) strcat(s, "x");
if (crc32("VYtTcrQWqdXCWIq",15) == 2171540020) strcat(s, "g");
if (crc32("yeDtakMOt",9) == 306907073) strcat(s, "u");
if (crc32("CahpgefnPLJXk",13) == 3872748534) strcat(s, "s");
if (crc32("EakJaaXeiNTTnS",14) == 3500685637) strcat(s, "F");
if (crc32("eowLCojkA",9) == 384241328) strcat(s, "t");
if (crc32("cnXuG",5) == 454450232) strcat(s, "a");
if (crc32("iezUWvrKsnnsBea",15) == 775256641) strcat(s, "n");
    return s;
}

char *unstratified_adjectives() {
    char *s = calloc(13);
    if (crc32("klDmu",5) == 3734981823) strcat(s, "u");
if (crc32("yWzAmMYxPtm",11) == 2899950822) strcat(s, "P");
if (crc32("ykxcvKdwduxxrMH",15) == 628020250) strcat(s, "n");
if (crc32("xKHpTh",6) == 2495289176) strcat(s, "C");
if (crc32("mLCvZpDhVMnLfs",14) == 4122748853) strcat(s, "s");
if (crc32("zSspjGw",7) == 3191497578) strcat(s, "t");
if (crc32("sLfMMaBVHMA",11) == 2830604460) strcat(s, "m");
if (crc32("lnEiwcMTlomOF",13) == 1057015103) strcat(s, "r");
if (crc32("uRkkefdlQDs",11) == 1880545483) strcat(s, "y");
if (crc32("oalsdoJa",8) == 1199596825) strcat(s, "a");
if (crc32("jbeUuZiu",8) == 963661329) strcat(s, "t");
if (crc32("PxRkRRSnoDSb",12) == 1228215587) strcat(s, "i");
if (crc32("uyciqHqrXQMwhl",14) == 2780923259) strcat(s, "f");
if (crc32("oigJABaIPevq",12) == 160682604) strcat(s, "i");
if (crc32("ANsdXqEk",8) == 2042731366) strcat(s, "e");
if (crc32("XAbfMsscRyUFyh",14) == 1202127948) strcat(s, "O");
if (crc32("yytiQKo",7) == 557008521) strcat(s, "d");
    return s;
}

char *superabominable_adjectives() {
    char *s = calloc(16);
    if (crc32("TjPMQ",5) == 1781397483) strcat(s, "s");
if (crc32("ZcYiM",5) == 1110278246) strcat(s, "u");
if (crc32("TMIGmbXPdQDUig",14) == 996198060) strcat(s, "p");
if (crc32("ogeauSOppatXKu",14) == 81000313) strcat(s, "e");
if (crc32("HdhiYU",6) == 1495236572) strcat(s, "u");
if (crc32("qHrzDVtfUkCC",12) == 3628328365) strcat(s, "r");
if (crc32("LPxWjuArmLjCGdo",15) == 869544290) strcat(s, "a");
if (crc32("JhYNcXKYVwAbf",13) == 1747048980) strcat(s, "b");
if (crc32("ticWWQMnAgky",12) == 3582334686) strcat(s, "o");
if (crc32("fuotZqbW",8) == 1799443082) strcat(s, "m");
if (crc32("xfUqmcr",7) == 266492464) strcat(s, "i");
if (crc32("RsACyxlyj",9) == 3151798098) strcat(s, "n");
if (crc32("BthtvCfS",8) == 39970710) strcat(s, "Z");
if (crc32("HEYVeR",6) == 2164343691) strcat(s, "a");
if (crc32("BauMUs",6) == 4027998413) strcat(s, "u");
if (crc32("RZwdRgADS",9) == 938217232) strcat(s, "b");
if (crc32("xjTbnUM",7) == 3088663610) strcat(s, "L");
if (crc32("NXkarsKa",8) == 836202524) strcat(s, "l");
if (crc32("REaqUjjnuB",10) == 1793890398) strcat(s, "b");
if (crc32("DzFmeVNRA",9) == 2276512099) strcat(s, "e");
    return s;
}

char *antisupernatural_adjectives() {
    char *s = calloc(17);
    if (crc32("aZiwjXvEQe",10) == 3687413882) strcat(s, "a");
if (crc32("HDYCVhYXhGyvRHn",15) == 2757750519) strcat(s, "n");
if (crc32("LqJorw",6) == 4220998384) strcat(s, "o");
if (crc32("ERihVRjAVWcuUM",14) == 2374926495) strcat(s, "t");
if (crc32("DNIwvmls",8) == 2977683775) strcat(s, "i");
if (crc32("vHbHbZrE",8) == 3230265066) strcat(s, "I");
if (crc32("jUjflQfMvSaNiAA",15) == 1190411455) strcat(s, "s");
if (crc32("jNSZlGgwmbI",11) == 1261487908) strcat(s, "D");
if (crc32("CtAkCrkXdsEh",12) == 1203530257) strcat(s, "u");
if (crc32("VDDmurbTtD",10) == 114751766) strcat(s, "l");
if (crc32("quRBOfCtiQZ",11) == 2343503542) strcat(s, "p");
if (crc32("AaPMHL",6) == 1248384142) strcat(s, "B");
if (crc32("JviJDhIFKEyk",12) == 636188109) strcat(s, "e");
if (crc32("DsyfMGC",7) == 1656622177) strcat(s, "r");
if (crc32("BTXzoKwLn",9) == 3313933088) strcat(s, "D");
if (crc32("MejMqYw",7) == 2858334919) strcat(s, "n");
if (crc32("JsJDkZrwBTtrbh",14) == 1565804590) strcat(s, "t");
if (crc32("FLttDWdH",8) == 2441712264) strcat(s, "a");
if (crc32("rEURB",5) == 2480021388) strcat(s, "t");
if (crc32("xfYSyRnjtEridTZ",15) == 3672023031) strcat(s, "u");
if (crc32("unusCwTsFcMKyC",14) == 2128757146) strcat(s, "r");
if (crc32("tygwLXgTxJyOh",13) == 2489855085) strcat(s, "a");
if (crc32("sxWWwkWZjb",10) == 4286873287) strcat(s, "l");
    return s;
}

char *sextan_adjectives() {
    char *s = calloc(7);
    if (crc32("tnhdui",6) == 3491352327) strcat(s, "s");
if (crc32("XFwNWRTnNxO",11) == 2918790572) strcat(s, "Q");
if (crc32("GAhfIpL",7) == 1087707921) strcat(s, "e");
if (crc32("NyaUZMetERAaGqL",15) == 2172886248) strcat(s, "x");
if (crc32("HBUeLOm",7) == 342212131) strcat(s, "j");
if (crc32("KouhaclEFVl",11) == 2288214811) strcat(s, "t");
if (crc32("poLirERwaWLXW",13) == 370954215) strcat(s, "L");
if (crc32("aSETeBdlA",9) == 269892489) strcat(s, "a");
if (crc32("JTAIhcha",8) == 2119032343) strcat(s, "d");
if (crc32("OEQyz",5) == 2467860112) strcat(s, "n");
    return s;
}

char *swingwing_adjectives() {
    char *s = calloc(10);
    if (crc32("LhuScPzUSpuoQi",14) == 1277238632) strcat(s, "s");
if (crc32("vNFcNprMfUOJ",12) == 1643287826) strcat(s, "w");
if (crc32("pLXTo",5) == 879602488) strcat(s, "w");
if (crc32("WTRTthh",7) == 1460178609) strcat(s, "i");
if (crc32("BvkxJoArblfsdd",14) == 4170451254) strcat(s, "n");
if (crc32("TkbBDvJVY",9) == 2062767311) strcat(s, "g");
if (crc32("uJICXRdZzSoNp",13) == 2981682807) strcat(s, "w");
if (crc32("oLgobULyOQluG",13) == 3630675137) strcat(s, "i");
if (crc32("ZhyKRwNp",8) == 1778684613) strcat(s, "E");
if (crc32("fNhFioviWMisl",13) == 3163979212) strcat(s, "n");
if (crc32("XsOPHz",6) == 3369503442) strcat(s, "g");
    return s;
}

char *otological_adjectives() {
    char *s = calloc(11);
    if (crc32("WBQObgbTEpeH",12) == 640249994) strcat(s, "o");
if (crc32("IEhDNdTtjSn",11) == 608085087) strcat(s, "t");
if (crc32("urHDrrHHlEoZ",12) == 2222368986) strcat(s, "O");
if (crc32("FsWrRhT",7) == 3525186818) strcat(s, "o");
if (crc32("dvTIEtLmAZIArUr",15) == 3558857567) strcat(s, "g");
if (crc32("ORgBWk",6) == 4150943974) strcat(s, "l");
if (crc32("GAyEbBTejJN",11) == 1640997587) strcat(s, "Z");
if (crc32("ZrsmJvbQDfGkyw",14) == 3683707188) strcat(s, "o");
if (crc32("hgbwfws",7) == 1372124469) strcat(s, "p");
if (crc32("YujKfyAU",8) == 2690231635) strcat(s, "g");
if (crc32("ecLSgvnMzTY",11) == 526830619) strcat(s, "Y");
if (crc32("zutoeLwlPVaRu",13) == 1419534914) strcat(s, "i");
if (crc32("wwygqTlRdvhRr",13) == 1194662158) strcat(s, "c");
if (crc32("vqOqEwVWZx",10) == 1224628585) strcat(s, "a");
if (crc32("reAgtoPjmxGrhP",14) == 4159066071) strcat(s, "a");
if (crc32("wnvgzynWUImIB",13) == 980762733) strcat(s, "k");
if (crc32("ruustFfGyDvAj",13) == 3077901327) strcat(s, "l");
    return s;
}

char *unsacked_adjectives() {
    char *s = calloc(9);
    if (crc32("quxFL",5) == 3722097180) strcat(s, "u");
if (crc32("aARGVGmq",8) == 1677309539) strcat(s, "Z");
if (crc32("XbRtfsNOHkV",11) == 867868028) strcat(s, "n");
if (crc32("RIcnQsYM",8) == 3146374581) strcat(s, "f");
if (crc32("FxfzdNV",7) == 3961136946) strcat(s, "s");
if (crc32("DNSlTMCRPEh",11) == 3979196003) strcat(s, "H");
if (crc32("gEpRGgMnVFM",11) == 2766349996) strcat(s, "a");
if (crc32("pokrY",5) == 394864226) strcat(s, "c");
if (crc32("MXmZktWyWhyC",12) == 891162679) strcat(s, "U");
if (crc32("bZrwpdZnXMozm",13) == 3494928128) strcat(s, "k");
if (crc32("MzbCK",5) == 332050573) strcat(s, "e");
if (crc32("bNGaTOJYFwMSJ",13) == 866127918) strcat(s, "d");
    return s;
}

char *fortheperson_adjectives() {
    char *s = calloc(13);
    if (crc32("hQuCYg",6) == 3330587454) strcat(s, "f");
if (crc32("mUKlnWjtfrkvfi",14) == 2761026139) strcat(s, "W");
if (crc32("pFjdlFiVHB",10) == 2691771924) strcat(s, "o");
if (crc32("bpWvR",5) == 3337856434) strcat(s, "V");
if (crc32("pruqklxfJabY",12) == 3325909989) strcat(s, "r");
if (crc32("iFbmtFh",7) == 24177479) strcat(s, "r");
if (crc32("gMYVlMHzkgIA",12) == 228883377) strcat(s, "t");
if (crc32("eMPouhXYJtFZY",13) == 3093103276) strcat(s, "h");
if (crc32("dqcNA",5) == 1554220957) strcat(s, "e");
if (crc32("hSJqHQiZtLMPJR",14) == 407092565) strcat(s, "p");
if (crc32("ioHZyPkQP",9) == 1987384821) strcat(s, "e");
if (crc32("CJOaGWcrPd",10) == 3160780230) strcat(s, "Q");
if (crc32("hyhrC",5) == 3444553025) strcat(s, "r");
if (crc32("aYSOkrW",7) == 2339161986) strcat(s, "s");
if (crc32("fjGhdOu",7) == 3497288877) strcat(s, "o");
if (crc32("gzWHVzmBr",9) == 1769485780) strcat(s, "n");
    return s;
}

char *unmedicinal_adjectives() {
    char *s = calloc(12);
    if (crc32("TFjKeTDPRzgFmCh",15) == 194575272) strcat(s, "u");
if (crc32("GiMfqTYRE",9) == 1175154632) strcat(s, "q");
if (crc32("pModQceio",9) == 1097296509) strcat(s, "n");
if (crc32("zFhvT",5) == 2560154007) strcat(s, "m");
if (crc32("AlgQCohIW",9) == 2265625218) strcat(s, "I");
if (crc32("BaYUpCodmrjBL",13) == 3695652370) strcat(s, "e");
if (crc32("yHTvRl",6) == 3091299722) strcat(s, "o");
if (crc32("FFDOKzLwdsJUJ",13) == 155830564) strcat(s, "d");
if (crc32("XrzrUdfmoXBxZ",13) == 1287401328) strcat(s, "g");
if (crc32("MiSFdml",7) == 2366536906) strcat(s, "i");
if (crc32("EqmruLtqGSzRmvi",15) == 1771284788) strcat(s, "k");
if (crc32("TNwOdUPQ",8) == 337276585) strcat(s, "c");
if (crc32("GfPvhzRBWESQ",12) == 246828842) strcat(s, "b");
if (crc32("mNNiunlTh",9) == 2051366597) strcat(s, "i");
if (crc32("aTmImODFJ",9) == 1529320562) strcat(s, "n");
if (crc32("SKyozvCN",8) == 3506868753) strcat(s, "a");
if (crc32("FjhQFuBOFQd",11) == 3985670472) strcat(s, "l");
    return s;
}

char *late_adjectives() {
    char *s = calloc(5);
    if (crc32("CYujxdX",7) == 2556747760) strcat(s, "l");
if (crc32("dyrdlEkMBIwUt",13) == 3423042644) strcat(s, "u");
if (crc32("NxIqjUKPkiX",11) == 441099207) strcat(s, "a");
if (crc32("PUxFrY",6) == 2560451274) strcat(s, "t");
if (crc32("uJOegXTlb",9) == 3492405417) strcat(s, "d");
if (crc32("fRlICjzBaEEs",12) == 2484440416) strcat(s, "e");
    return s;
}

char *undealt_adjectives() {
    char *s = calloc(8);
    if (crc32("CvptVk",6) == 1860215256) strcat(s, "Z");
if (crc32("bFaBVZMWL",9) == 4111374278) strcat(s, "u");
if (crc32("NHmbckbjhLQU",12) == 1143511061) strcat(s, "w");
if (crc32("JCeCCItsBU",10) == 3614321186) strcat(s, "n");
if (crc32("NLSoUUMgyLL",11) == 2056387060) strcat(s, "d");
if (crc32("cGatvMIDxodXs",13) == 2712377022) strcat(s, "i");
if (crc32("vusxmhsrlqJMztl",15) == 1737393517) strcat(s, "e");
if (crc32("HFuwd",5) == 2161822419) strcat(s, "O");
if (crc32("KaKFCPFfTHCR",12) == 1338979589) strcat(s, "a");
if (crc32("ClvquPnwTTef",12) == 1468130425) strcat(s, "l");
if (crc32("VVmoeYTUOwKvc",13) == 3840898792) strcat(s, "t");
    return s;
}

char *unstudied_adjectives() {
    char *s = calloc(10);
    if (crc32("dtPcDKncBK",10) == 4074600811) strcat(s, "O");
if (crc32("jPQPTmbhgxw",11) == 1248378830) strcat(s, "u");
if (crc32("tIltEUk",7) == 2122220431) strcat(s, "n");
if (crc32("BWntacO",7) == 99780210) strcat(s, "H");
if (crc32("rlPAX",5) == 3568207163) strcat(s, "s");
if (crc32("nwqooU",6) == 3825772027) strcat(s, "k");
if (crc32("hsvkd",5) == 2319501100) strcat(s, "t");
if (crc32("CvwvPGgjUnGrE",13) == 454954028) strcat(s, "u");
if (crc32("JguVKbdKhDFec",13) == 1047411175) strcat(s, "d");
if (crc32("zMKELtAhHewEFG",14) == 4260391195) strcat(s, "i");
if (crc32("biQfheagrTPZmx",14) == 60258093) strcat(s, "e");
if (crc32("ZnlDcdeUtlc",11) == 3809048180) strcat(s, "d");
    return s;
}

char *illative_adjectives() {
    char *s = calloc(9);
    if (crc32("ygtWKbslweSeAB",14) == 1261194308) strcat(s, "i");
if (crc32("eNimiWMMehBE",12) == 2071087621) strcat(s, "l");
if (crc32("YPQzzSQ",7) == 1135296009) strcat(s, "x");
if (crc32("qjMMHxlmgR",10) == 277327888) strcat(s, "l");
if (crc32("tkotawtJZ",9) == 3118964240) strcat(s, "n");
if (crc32("WwlWSBgJHRbf",12) == 4106900198) strcat(s, "a");
if (crc32("SkMhN",5) == 297050543) strcat(s, "t");
if (crc32("cyTrElzbo",9) == 2479572466) strcat(s, "i");
if (crc32("KuaQIiKgmKTjk",13) == 848878037) strcat(s, "s");
if (crc32("CnUGXsuGnXG",11) == 2188380109) strcat(s, "v");
if (crc32("tOmKJjVlGCftkPP",15) == 1606656089) strcat(s, "e");
    return s;
}

char *dipyramidal_adjectives() {
    char *s = calloc(12);
    if (crc32("gvTSZDq",7) == 3356617283) strcat(s, "d");
if (crc32("UxkGj",5) == 2169104189) strcat(s, "s");
if (crc32("RyAlsSV",7) == 1413574388) strcat(s, "i");
if (crc32("pxJwkjgtTUN",11) == 3599817495) strcat(s, "Z");
if (crc32("mSHQTd",6) == 3721199992) strcat(s, "p");
if (crc32("JkTEWXHXer",10) == 2634603418) strcat(s, "n");
if (crc32("yGmFy",5) == 4225133647) strcat(s, "y");
if (crc32("TSWQbCgfFd",10) == 2997448017) strcat(s, "v");
if (crc32("ifUbbnhqmultb",13) == 3325317162) strcat(s, "r");
if (crc32("zYFakULbKzqgpNp",15) == 2139980924) strcat(s, "q");
if (crc32("dMErjAXBqTQsl",13) == 3912529897) strcat(s, "a");
if (crc32("BUJZDdU",7) == 2994054848) strcat(s, "Z");
if (crc32("nhKQWUHHUHWpbay",15) == 3331095439) strcat(s, "m");
if (crc32("jOXWzOnNaKNL",12) == 4108048529) strcat(s, "i");
if (crc32("bxRKbmBmHzcoajG",15) == 2451758423) strcat(s, "A");
if (crc32("aSXGzYcA",8) == 1236573696) strcat(s, "d");
if (crc32("TsLpAg",6) == 656962615) strcat(s, "a");
if (crc32("OKXoRZVVZmLeby",14) == 2730250990) strcat(s, "Q");
if (crc32("PsHTByblZlA",11) == 2120393844) strcat(s, "l");
    return s;
}

char *anthracitic_adjectives() {
    char *s = calloc(12);
    if (crc32("exlmPdHUPw",10) == 3526074982) strcat(s, "a");
if (crc32("RhONGbnt",8) == 842267399) strcat(s, "n");
if (crc32("NNfuFFUfAAG",11) == 3303399194) strcat(s, "t");
if (crc32("LODztl",6) == 1371281217) strcat(s, "h");
if (crc32("ufSOcrSUBtpEh",13) == 26258643) strcat(s, "B");
if (crc32("CcHxg",5) == 3126547988) strcat(s, "r");
if (crc32("XZxOf",5) == 2365126285) strcat(s, "i");
if (crc32("jNNZeNSlEyPc",12) == 2576112284) strcat(s, "a");
if (crc32("MvonSWDgntpPKq",14) == 1278914643) strcat(s, "k");
if (crc32("DzZeXVDqK",9) == 3251094058) strcat(s, "c");
if (crc32("KxbpkHZzLxt",11) == 1686572887) strcat(s, "T");
if (crc32("IDzWYvD",7) == 1446454813) strcat(s, "i");
if (crc32("JXvvadqcgFG",11) == 1285779177) strcat(s, "t");
if (crc32("Dmwxzo",6) == 2916749229) strcat(s, "B");
if (crc32("GsLLk",5) == 2857873483) strcat(s, "i");
if (crc32("dbCDd",5) == 2695423571) strcat(s, "r");
if (crc32("pLKKDed",7) == 1332636825) strcat(s, "c");
    return s;
}

char *immemorial_adjectives() {
    char *s = calloc(11);
    if (crc32("ilRuATjOxcbSAy",14) == 3860485398) strcat(s, "A");
if (crc32("QvqXA",5) == 2878294555) strcat(s, "i");
if (crc32("YWHKxxHMQtGqN",13) == 945140) strcat(s, "m");
if (crc32("GZVhWn",6) == 2186347636) strcat(s, "m");
if (crc32("ezujozme",8) == 3941894051) strcat(s, "m");
if (crc32("aDqJiUfaXc",10) == 4040760917) strcat(s, "e");
if (crc32("DfFHkK",6) == 2234526856) strcat(s, "h");
if (crc32("CspDTKqD",8) == 3335787635) strcat(s, "m");
if (crc32("QRKIGCrpPO",10) == 1009712570) strcat(s, "h");
if (crc32("COaUA",5) == 2500125935) strcat(s, "o");
if (crc32("QvjTosE",7) == 833246542) strcat(s, "N");
if (crc32("TntwyakhjtUfd",13) == 1422755452) strcat(s, "r");
if (crc32("FdndEHk",7) == 788875775) strcat(s, "i");
if (crc32("EHHTqQRd",8) == 1422407606) strcat(s, "x");
if (crc32("tKXAghMATESD",12) == 2900470812) strcat(s, "a");
if (crc32("SvuSSpBXLZGv",12) == 988033735) strcat(s, "E");
if (crc32("TfyvQxvvAOXHrG",14) == 2373109897) strcat(s, "l");
    return s;
}

char *nonpleading_adjectives() {
    char *s = calloc(12);
    if (crc32("pGsdJsuHjBto",12) == 1589232823) strcat(s, "Y");
if (crc32("OHkpEegmz",9) == 775525531) strcat(s, "n");
if (crc32("gZzRLhUOSdeyK",13) == 1322498017) strcat(s, "A");
if (crc32("wNNsTPxrF",9) == 160742326) strcat(s, "o");
if (crc32("plmKQmiyb",9) == 3362279108) strcat(s, "n");
if (crc32("HkNRZNjAIQA",11) == 2964700386) strcat(s, "p");
if (crc32("YlCciOpOiOmsxHZ",15) == 874080835) strcat(s, "r");
if (crc32("HwyFAuIKq",9) == 4153479629) strcat(s, "l");
if (crc32("OjNOWDilKfWd",12) == 174262859) strcat(s, "j");
if (crc32("CslBirzxXxOx",12) == 3397063608) strcat(s, "e");
if (crc32("xFMAMMFxx",9) == 2808780003) strcat(s, "a");
if (crc32("soUuyzdYzLDaQ",13) == 190075495) strcat(s, "d");
if (crc32("YpjKhguzgiaAWPa",15) == 3782211132) strcat(s, "i");
if (crc32("gUfgL",5) == 3537671576) strcat(s, "M");
if (crc32("zyHsD",5) == 1750963105) strcat(s, "n");
if (crc32("fLbnO",5) == 2988967049) strcat(s, "i");
if (crc32("ydsCB",5) == 2476081028) strcat(s, "g");
    return s;
}

char *unrevokable_adjectives() {
    char *s = calloc(12);
    if (crc32("IctWRiIfhdyfT",13) == 4197091135) strcat(s, "u");
if (crc32("haTDfYWjpUp",11) == 3819692435) strcat(s, "n");
if (crc32("gOTzAPZHOeDulR",14) == 1475899232) strcat(s, "o");
if (crc32("SfiavONOkIt",11) == 3723525991) strcat(s, "r");
if (crc32("qADZvGz",7) == 1159764325) strcat(s, "e");
if (crc32("fwUExhShp",9) == 3903547617) strcat(s, "Y");
if (crc32("WRAAtRQaTdg",11) == 3443985892) strcat(s, "v");
if (crc32("JiRPOyVnpJ",10) == 2983299271) strcat(s, "o");
if (crc32("pmSTpw",6) == 2282857687) strcat(s, "k");
if (crc32("CwoLYnTsqFW",11) == 4068780975) strcat(s, "h");
if (crc32("PETaNXO",7) == 1092648940) strcat(s, "a");
if (crc32("gfpcewCS",8) == 4138363428) strcat(s, "b");
if (crc32("jBEmqFQvfYnW",12) == 3287802766) strcat(s, "B");
if (crc32("cLZGZrENBiHWYvN",15) == 286767762) strcat(s, "l");
if (crc32("lSNsIUNWYJ",10) == 3052775909) strcat(s, "e");
    return s;
}

char *nonobsessional_adjectives() {
    char *s = calloc(15);
    if (crc32("uJwejSyMs",9) == 1213706732) strcat(s, "n");
if (crc32("EYOlrop",7) == 3504701872) strcat(s, "l");
if (crc32("KtevKTXRisnI",12) == 623662392) strcat(s, "o");
if (crc32("kwStQcISV",9) == 1544674604) strcat(s, "n");
if (crc32("mwmxuxZtWsoovGj",15) == 4216862742) strcat(s, "u");
if (crc32("sfTZeGCj",8) == 1161405882) strcat(s, "o");
if (crc32("XjeldSZxeEudQQ",14) == 4145139965) strcat(s, "b");
if (crc32("UuRwYfU",7) == 1218379255) strcat(s, "s");
if (crc32("tpDiiDNVOFmo",12) == 2600175440) strcat(s, "Z");
if (crc32("RGCJgxhc",8) == 3985538832) strcat(s, "e");
if (crc32("HqQXTqzY",8) == 3436142664) strcat(s, "s");
if (crc32("URvgJTNzaN",10) == 3649235048) strcat(s, "e");
if (crc32("GgHBFiEpln",10) == 1482191148) strcat(s, "s");
if (crc32("ivomSycSdoI",11) == 3908892867) strcat(s, "i");
if (crc32("UZkGBZJidLP",11) == 1671661351) strcat(s, "o");
if (crc32("lDOlGmk",7) == 2433089737) strcat(s, "n");
if (crc32("XnXrpTbwk",9) == 4039278278) strcat(s, "a");
if (crc32("zbBMKHYcoH",10) == 1164029725) strcat(s, "e");
if (crc32("SsSzEgmDHpJG",12) == 3193190832) strcat(s, "l");
    return s;
}

char *unupsettable_adjectives() {
    char *s = calloc(13);
    if (crc32("rsDSjwsXTIqj",12) == 1169977447) strcat(s, "u");
if (crc32("seinRPhTfrfbu",13) == 2524107269) strcat(s, "n");
if (crc32("DBvVXINgUFuRFe",14) == 2068834676) strcat(s, "A");
if (crc32("PCYsptqbAQtRP",13) == 774395688) strcat(s, "u");
if (crc32("sQSvXEYtem",10) == 1903578604) strcat(s, "p");
if (crc32("GLKGswzaORJiGv",14) == 4240124053) strcat(s, "s");
if (crc32("EdjoKhU",7) == 2419214318) strcat(s, "q");
if (crc32("BPHXwnerQCfZb",13) == 3308373749) strcat(s, "e");
if (crc32("pkJhHLBL",8) == 1599222521) strcat(s, "M");
if (crc32("IanmC",5) == 1838464681) strcat(s, "t");
if (crc32("GHRFQYsIWY",10) == 1904507728) strcat(s, "I");
if (crc32("eThkARJe",8) == 1529381031) strcat(s, "t");
if (crc32("wyTXdibH",8) == 2811430131) strcat(s, "f");
if (crc32("wlahnClOrsXgt",13) == 3532233259) strcat(s, "a");
if (crc32("NTMZXZSWdl",10) == 3656517789) strcat(s, "V");
if (crc32("pgmudBxqXsY",11) == 3158316570) strcat(s, "b");
if (crc32("zvNGKgcpb",9) == 1025632404) strcat(s, "U");
if (crc32("tDxhKRlhYJ",10) == 3048369548) strcat(s, "l");
if (crc32("ljlkfaaIDUY",11) == 187852480) strcat(s, "e");
    return s;
}

char *soluble_adjectives() {
    char *s = calloc(8);
    if (crc32("bEQgqfNCJd",10) == 3931257232) strcat(s, "s");
if (crc32("nAvONhEoDVS",11) == 2189925484) strcat(s, "K");
if (crc32("AVxithzcCwcspw",14) == 1848529589) strcat(s, "o");
if (crc32("EdXrobNaIiVdmu",14) == 3901496129) strcat(s, "l");
if (crc32("ZRbVz",5) == 3269958368) strcat(s, "u");
if (crc32("GedVy",5) == 2867799235) strcat(s, "b");
if (crc32("XqIBKcI",7) == 348761909) strcat(s, "l");
if (crc32("MYbXULxlDm",10) == 1572140440) strcat(s, "g");
if (crc32("iQBUxLn",7) == 911510557) strcat(s, "e");
    return s;
}

char *uncommuted_adjectives() {
    char *s = calloc(11);
    if (crc32("pfCvqBFT",8) == 3035806130) strcat(s, "u");
if (crc32("iljxGfv",7) == 3184162882) strcat(s, "U");
if (crc32("LOkULRNkjcwb",12) == 3603867054) strcat(s, "n");
if (crc32("faSeWBaJucWBO",13) == 1878060770) strcat(s, "c");
if (crc32("DILGee",6) == 417154419) strcat(s, "G");
if (crc32("sfiMjPboSspNI",13) == 3307924148) strcat(s, "o");
if (crc32("xUzHaNvxqPaciX",14) == 2292891301) strcat(s, "O");
if (crc32("WYwuAssXKyL",11) == 757658868) strcat(s, "m");
if (crc32("abUhZKjRVyBE",12) == 4140950868) strcat(s, "N");
if (crc32("PXFwYkpE",8) == 1774450385) strcat(s, "m");
if (crc32("FdYCqnDBvhyeR",13) == 3516180981) strcat(s, "u");
if (crc32("HnjtTLL",7) == 1638958419) strcat(s, "G");
if (crc32("TqVxlCf",7) == 2904069193) strcat(s, "t");
if (crc32("llKGvBDrWcNUh",13) == 1711341445) strcat(s, "n");
if (crc32("PBmXipFHSIN",11) == 3768837163) strcat(s, "e");
if (crc32("moYbLhCjX",9) == 1517339049) strcat(s, "d");
    return s;
}

char *aufait_adjectives() {
    char *s = calloc(7);
    if (crc32("BnjKSElcEIGEN",13) == 1441728432) strcat(s, "r");
if (crc32("hUzbBl",6) == 1812738925) strcat(s, "a");
if (crc32("AVQcAZS",7) == 2194191175) strcat(s, "s");
if (crc32("utcNJcjnUBPGzSt",15) == 3951974983) strcat(s, "u");
if (crc32("fCNMrJZsw",9) == 3043863065) strcat(s, "T");
if (crc32("qVuzGFEUZDj",11) == 196207132) strcat(s, "f");
if (crc32("cpPMmGGhddmZkJn",15) == 1525856992) strcat(s, "a");
if (crc32("RogSzbbjI",9) == 2388747722) strcat(s, "i");
if (crc32("sdmXQVttzvN",11) == 1089797462) strcat(s, "W");
if (crc32("VvNakgoyg",9) == 2085704993) strcat(s, "t");
    return s;
}

char *unsinged_adjectives() {
    char *s = calloc(9);
    if (crc32("mXMMZAhEMT",10) == 181424213) strcat(s, "F");
if (crc32("qDuOIm",6) == 3914396340) strcat(s, "u");
if (crc32("CzXCNRlUD",9) == 420786045) strcat(s, "h");
if (crc32("DMInmJqn",8) == 3407066735) strcat(s, "n");
if (crc32("QYOdNGbfIfwiGmX",15) == 2262317813) strcat(s, "s");
if (crc32("HOEunnDXRfPvI",13) == 1964554608) strcat(s, "s");
if (crc32("TmnWxeHizLviueI",15) == 3366476381) strcat(s, "i");
if (crc32("zQpTbVa",7) == 754272314) strcat(s, "I");
if (crc32("MlBKprGQ",8) == 1761691897) strcat(s, "n");
if (crc32("hGxoJtCx",8) == 2661089623) strcat(s, "j");
if (crc32("JylFrveWkZAET",13) == 1581396475) strcat(s, "g");
if (crc32("FInoK",5) == 3064939545) strcat(s, "e");
if (crc32("uihgnIU",7) == 2072459851) strcat(s, "d");
    return s;
}

char *illiberal_adjectives() {
    char *s = calloc(10);
    if (crc32("NPLTum",6) == 1167826538) strcat(s, "d");
if (crc32("wAgDyFOFhobeu",13) == 3968495459) strcat(s, "i");
if (crc32("dyjTUQplPOMKMfT",15) == 1684415815) strcat(s, "Q");
if (crc32("llBzSpGZcylOY",13) == 4263663553) strcat(s, "l");
if (crc32("odGgFvSfSlPC",12) == 1496003026) strcat(s, "H");
if (crc32("fFWEsXJLGLbEcPO",15) == 2325678819) strcat(s, "l");
if (crc32("yXsXJAwuhMhFKeG",15) == 2510427536) strcat(s, "v");
if (crc32("KAYlTftAr",9) == 1103972174) strcat(s, "i");
if (crc32("DHIoxbF",7) == 482054938) strcat(s, "o");
if (crc32("MSswyyQUv",9) == 687580963) strcat(s, "b");
if (crc32("bZxKSwTomlV",11) == 49246161) strcat(s, "C");
if (crc32("DfIGvBGtOozNbt",14) == 3724828710) strcat(s, "e");
if (crc32("KHmee",5) == 4210538315) strcat(s, "s");
if (crc32("NFbojGCivRuCSu",14) == 2228398466) strcat(s, "r");
if (crc32("ShtCrvp",7) == 2416968653) strcat(s, "a");
if (crc32("QbLZawHJJw",10) == 1365153421) strcat(s, "l");
    return s;
}

char *brigandish_adjectives() {
    char *s = calloc(11);
    if (crc32("yMJYtjw",7) == 4053267658) strcat(s, "b");
if (crc32("hOUihfffLQRFJ",13) == 3704113249) strcat(s, "w");
if (crc32("AmQwo",5) == 3136323141) strcat(s, "r");
if (crc32("TnKsFVrOyz",10) == 4096535314) strcat(s, "i");
if (crc32("FstGTnWaL",9) == 523350255) strcat(s, "g");
if (crc32("tQSUann",7) == 3650621950) strcat(s, "a");
if (crc32("aNAcaEzNNK",10) == 2705072166) strcat(s, "N");
if (crc32("pFDEJ",5) == 3977979617) strcat(s, "n");
if (crc32("jPuisrAiPlW",11) == 4250182994) strcat(s, "d");
if (crc32("APpvdfnqjsKk",12) == 352713313) strcat(s, "g");
if (crc32("OGxVjAADA",9) == 3583388270) strcat(s, "i");
if (crc32("KHZDP",5) == 128364336) strcat(s, "I");
if (crc32("WNgELfHAuogM",12) == 1027691839) strcat(s, "s");
if (crc32("ysJVzwykqWMCOY",14) == 1439656918) strcat(s, "B");
if (crc32("tJrlMYQ",7) == 3594346676) strcat(s, "h");
    return s;
}

char *tensed_adjectives() {
    char *s = calloc(7);
    if (crc32("YCpgWmCpHnVEWb",14) == 1119970628) strcat(s, "h");
if (crc32("btLVYTHfmuKh",12) == 3616612159) strcat(s, "t");
if (crc32("zgrUjUVblzHw",12) == 2024653644) strcat(s, "q");
if (crc32("QouhNNyOUnX",11) == 2836073784) strcat(s, "e");
if (crc32("ZpybKWBwoVks",12) == 4108621830) strcat(s, "n");
if (crc32("vspMdHCQyjQPb",13) == 2389700513) strcat(s, "V");
if (crc32("qIsJgeUY",8) == 1982383994) strcat(s, "s");
if (crc32("qVZGlCLPYZ",10) == 2839449039) strcat(s, "A");
if (crc32("CoIEjdA",7) == 2903379569) strcat(s, "e");
if (crc32("nEwxSWyi",8) == 3043913378) strcat(s, "F");
if (crc32("qYcoEsaiHfvy",12) == 3622962695) strcat(s, "d");
    return s;
}

char *lumpen_adjectives() {
    char *s = calloc(7);
    if (crc32("wcKvwyff",8) == 3399223731) strcat(s, "g");
if (crc32("XnlQEpyuf",9) == 934532398) strcat(s, "l");
if (crc32("slIIiVbHc",9) == 2360056487) strcat(s, "u");
if (crc32("nJCXjZ",6) == 2710790817) strcat(s, "V");
if (crc32("ElSWKiEjNhHJ",12) == 3097749551) strcat(s, "m");
if (crc32("Sbykk",5) == 804725997) strcat(s, "p");
if (crc32("YPejcbpOQjGe",12) == 2078797105) strcat(s, "e");
if (crc32("khQimTo",7) == 4042434638) strcat(s, "n");
    return s;
}

char *mealless_adjectives() {
    char *s = calloc(9);
    if (crc32("NXmcen",6) == 989636061) strcat(s, "P");
if (crc32("JReOw",5) == 1123667522) strcat(s, "m");
if (crc32("ZkunM",5) == 893345617) strcat(s, "k");
if (crc32("hSoEKluqhtNWX",13) == 2837633353) strcat(s, "e");
if (crc32("CappjpKx",8) == 1345888463) strcat(s, "a");
if (crc32("mUSGqU",6) == 844484854) strcat(s, "Z");
if (crc32("ljEiT",5) == 1611886622) strcat(s, "l");
if (crc32("XmKqyiTMX",9) == 455207320) strcat(s, "l");
if (crc32("QyvWyrapSGD",11) == 1421170219) strcat(s, "e");
if (crc32("QZSIoTPFY",9) == 2131622523) strcat(s, "E");
if (crc32("WeHLGNw",7) == 1328054258) strcat(s, "s");
if (crc32("UKNfK",5) == 3506885997) strcat(s, "U");
if (crc32("SyJsZkT",7) == 1133622048) strcat(s, "s");
    return s;
}

char *noninformative_adjectives() {
    char *s = calloc(15);
    if (crc32("vXmQpSgdHZtne",13) == 548566971) strcat(s, "X");
if (crc32("QGttJhbaY",9) == 3779003004) strcat(s, "n");
if (crc32("pMMIzlrB",8) == 2622760860) strcat(s, "f");
if (crc32("kPJZKivJy",9) == 977883795) strcat(s, "o");
if (crc32("nhHaXPdoow",10) == 1941117809) strcat(s, "d");
if (crc32("EliPiaBBtmfBBn",14) == 1735163740) strcat(s, "n");
if (crc32("tVKBVLjmQI",10) == 3487600526) strcat(s, "N");
if (crc32("zqVeearcEgW",11) == 4001882621) strcat(s, "i");
if (crc32("yCComRACbRzUOC",14) == 1409048822) strcat(s, "W");
if (crc32("aUxXQD",6) == 2628526848) strcat(s, "n");
if (crc32("AZKbIbmETgmJw",13) == 3867482273) strcat(s, "W");
if (crc32("Rasdln",6) == 29381336) strcat(s, "f");
if (crc32("mOZHwFrWSYYG",12) == 41771402) strcat(s, "I");
if (crc32("pZJBHwYnLG",10) == 1907841685) strcat(s, "o");
if (crc32("CfQfHNuvpG",10) == 122036700) strcat(s, "r");
if (crc32("MarXM",5) == 3366038988) strcat(s, "m");
if (crc32("MdJsWgiXUB",10) == 2912615779) strcat(s, "a");
if (crc32("EuVUBuJtSoNOrSz",15) == 154070245) strcat(s, "t");
if (crc32("YaMqif",6) == 2837349379) strcat(s, "Z");
if (crc32("YEIUB",5) == 2143210826) strcat(s, "i");
if (crc32("hzHsQIHAJovLS",13) == 1915993182) strcat(s, "v");
if (crc32("KPjjIeVzDlToUrq",15) == 2245383810) strcat(s, "v");
if (crc32("nvzaEQw",7) == 2968955315) strcat(s, "e");
    return s;
}

char *nonmutative_adjectives() {
    char *s = calloc(12);
    if (crc32("qEgWe",5) == 736105868) strcat(s, "n");
if (crc32("qCMtehjI",8) == 360814990) strcat(s, "o");
if (crc32("oGQJmYxRVwNBj",13) == 3223417518) strcat(s, "D");
if (crc32("BNzNQnZxu",9) == 790147305) strcat(s, "n");
if (crc32("khwlljpIiIebNOc",15) == 2654042934) strcat(s, "a");
if (crc32("mBmazuEr",8) == 2296188217) strcat(s, "m");
if (crc32("KnFsWLhUrTrkB",13) == 3038273476) strcat(s, "u");
if (crc32("yviShVLtoYB",11) == 2502347464) strcat(s, "t");
if (crc32("SwUUpBGFdtgi",12) == 3281364591) strcat(s, "a");
if (crc32("qRSIvhBCiIVeqi",14) == 4084389403) strcat(s, "t");
if (crc32("FfybSF",6) == 4269396670) strcat(s, "F");
if (crc32("dOJHvb",6) == 2835192146) strcat(s, "i");
if (crc32("xhMOYqfCnEK",11) == 4120883331) strcat(s, "v");
if (crc32("MSapef",6) == 3619418841) strcat(s, "h");
if (crc32("tRPceNcU",8) == 138643219) strcat(s, "e");
    return s;
}

char *algetic_adjectives() {
    char *s = calloc(8);
    if (crc32("HjEQCkTtgGanEq",14) == 1453614324) strcat(s, "T");
if (crc32("AyBSxcEsx",9) == 165542059) strcat(s, "a");
if (crc32("lncayelqTRhjC",13) == 2075635693) strcat(s, "w");
if (crc32("psvlDIOknApCCl",14) == 3772882328) strcat(s, "l");
if (crc32("rNcInWGdieSJ",12) == 2227393469) strcat(s, "n");
if (crc32("TVWPhW",6) == 4089703802) strcat(s, "g");
if (crc32("VKiPLMiWVUJWz",13) == 2203786031) strcat(s, "e");
if (crc32("yKWAfqNsNtZlehO",15) == 1638489842) strcat(s, "t");
if (crc32("lJpDqutcz",9) == 2835994993) strcat(s, "i");
if (crc32("BdQuhzoSjXj",11) == 2202795914) strcat(s, "R");
if (crc32("DtNxaaJakP",10) == 220228402) strcat(s, "c");
    return s;
}

char *uncheaply_adjectives() {
    char *s = calloc(10);
    if (crc32("ZfdNuCQgolswQ",13) == 1458725532) strcat(s, "u");
if (crc32("ukgiY",5) == 4029091003) strcat(s, "n");
if (crc32("aLXUwKBQKkFd",12) == 2888682849) strcat(s, "h");
if (crc32("kZWdxqWfryNis",13) == 952580633) strcat(s, "c");
if (crc32("iNbLrO",6) == 1662785214) strcat(s, "D");
if (crc32("RkZwSm",6) == 1241369698) strcat(s, "h");
if (crc32("ETGIPYgLHkXhsrU",15) == 164552464) strcat(s, "n");
if (crc32("ZlaaZ",5) == 2067540951) strcat(s, "e");
if (crc32("isDWh",5) == 3934972598) strcat(s, "a");
if (crc32("XZYJB",5) == 2614628061) strcat(s, "p");
if (crc32("FFWecvR",7) == 1408039287) strcat(s, "l");
if (crc32("OiwLrXmYMHmF",12) == 431293813) strcat(s, "y");
    return s;
}

char *Peruvian_adjectives() {
    char *s = calloc(9);
    if (crc32("JmWgXQC",7) == 3412407963) strcat(s, "P");
if (crc32("hwfRwOfrbl",10) == 2177175834) strcat(s, "e");
if (crc32("jpQbrt",6) == 2482812040) strcat(s, "r");
if (crc32("GrKdvyXJkchfuK",14) == 4066105017) strcat(s, "u");
if (crc32("JOiMaaYVsfbLbRB",15) == 3262574212) strcat(s, "v");
if (crc32("nLOCYn",6) == 1860676465) strcat(s, "i");
if (crc32("exDZJ",5) == 2644984684) strcat(s, "j");
if (crc32("dOtVPSehQZMWuC",14) == 3012095573) strcat(s, "a");
if (crc32("vCelwHlqllN",11) == 3309938057) strcat(s, "n");
    return s;
}

char *unpredicable_adjectives() {
    char *s = calloc(13);
    if (crc32("HYuUElDvndBA",12) == 4268729957) strcat(s, "u");
if (crc32("NrwgC",5) == 1946217149) strcat(s, "n");
if (crc32("rPJePW",6) == 976939571) strcat(s, "p");
if (crc32("zlxCXLWQOZmGlld",15) == 2959463889) strcat(s, "z");
if (crc32("IWbhQJ",6) == 4058286167) strcat(s, "r");
if (crc32("rYWkYsdIwwauT",13) == 1833801551) strcat(s, "e");
if (crc32("gJPkoKFFVub",11) == 2662280564) strcat(s, "N");
if (crc32("VdYEsvw",7) == 913745900) strcat(s, "d");
if (crc32("pnfquJkZJJ",10) == 2244398468) strcat(s, "i");
if (crc32("QcMJuqNQ",8) == 773039158) strcat(s, "t");
if (crc32("alfqqUAcAngC",12) == 113571364) strcat(s, "c");
if (crc32("oIeicSkpC",9) == 1059976028) strcat(s, "n");
if (crc32("Myzoeie",7) == 2202125319) strcat(s, "a");
if (crc32("oEDULdQLow",10) == 2350720653) strcat(s, "i");
if (crc32("szpALhYzuY",10) == 2870071085) strcat(s, "b");
if (crc32("BxONpRqYDVXD",12) == 4183404856) strcat(s, "k");
if (crc32("TqMucduHOPQCuDY",15) == 1441728864) strcat(s, "l");
if (crc32("uzNleNmtnxY",11) == 1755290768) strcat(s, "g");
if (crc32("ojWoaCIKo",9) == 2802874744) strcat(s, "e");
    return s;
}

char *reverend_adjectives() {
    char *s = calloc(9);
    if (crc32("aPxujQ",6) == 3832845513) strcat(s, "B");
if (crc32("eFDZvJKxEQDqyN",14) == 41483754) strcat(s, "r");
if (crc32("WZknLzyP",8) == 3388335048) strcat(s, "T");
if (crc32("GWbyaXpIpmJN",12) == 96596623) strcat(s, "e");
if (crc32("MzkMbEXwvMnqQkQ",15) == 3548090551) strcat(s, "i");
if (crc32("GXZfcZTdgDnqKTn",15) == 1570103549) strcat(s, "v");
if (crc32("FedBedbbaYNv",12) == 2539923690) strcat(s, "I");
if (crc32("ZgIDQnuwJ",9) == 3838215547) strcat(s, "e");
if (crc32("EWrsingzyhdm",12) == 1776151025) strcat(s, "r");
if (crc32("atdBgYLOYFhV",12) == 3381396861) strcat(s, "Y");
if (crc32("bhpDLvuEgGAtH",13) == 4202140513) strcat(s, "e");
if (crc32("XFwFTMppIaAD",12) == 519746378) strcat(s, "q");
if (crc32("NAiCPLwSsSq",11) == 3761585005) strcat(s, "n");
if (crc32("jQqNnFjOJdpC",12) == 3853571526) strcat(s, "d");
    return s;
}

char *holier_adjectives() {
    char *s = calloc(7);
    if (crc32("fFAIKhWYNuJw",12) == 2647207651) strcat(s, "Y");
if (crc32("CxsQQGkx",8) == 1270982111) strcat(s, "h");
if (crc32("plkZBPL",7) == 4071579823) strcat(s, "o");
if (crc32("TtdKuFwWKwX",11) == 709000532) strcat(s, "l");
if (crc32("YYAhnPLpkLohgXa",15) == 546090575) strcat(s, "J");
if (crc32("uoAEmxnB",8) == 1484325570) strcat(s, "i");
if (crc32("ccXJqf",6) == 2965307346) strcat(s, "c");
if (crc32("zNGGlEnzAhd",11) == 3379740209) strcat(s, "e");
if (crc32("sKjKBYPuhlZSGJY",15) == 2597388275) strcat(s, "R");
if (crc32("qbOlVWmoHkbIyZ",14) == 3534358150) strcat(s, "r");
    return s;
}

char *invected_adjectives() {
    char *s = calloc(9);
    if (crc32("rcXtYqMYZGZZc",13) == 2252184103) strcat(s, "i");
if (crc32("kdhMzidYUVvXHq",14) == 463405739) strcat(s, "P");
if (crc32("LyHZrrzqHWSucxY",15) == 2254340657) strcat(s, "n");
if (crc32("vHitVXcUKxPJaUh",15) == 3500229811) strcat(s, "g");
if (crc32("QWpFsjvrVkIA",12) == 263966432) strcat(s, "v");
if (crc32("xsCgsgyDuXGnNg",14) == 2456707570) strcat(s, "u");
if (crc32("jJTubkMSsuyKx",13) == 2646198416) strcat(s, "e");
if (crc32("JPIdSQZhR",9) == 4279088346) strcat(s, "c");
if (crc32("MNKGLvq",7) == 2212840057) strcat(s, "t");
if (crc32("qJEpEnONE",9) == 4244439138) strcat(s, "e");
if (crc32("eGkzKLnAQyLmIi",14) == 2459944619) strcat(s, "d");
    return s;
}

char *cutglass_adjectives() {
    char *s = calloc(9);
    if (crc32("oAqdqf",6) == 2759425095) strcat(s, "o");
if (crc32("CXOAqAKtWIpBrE",14) == 295642896) strcat(s, "c");
if (crc32("pMDFHxKNcyuUEug",15) == 3314150265) strcat(s, "H");
if (crc32("cpcCFWKumRmS",12) == 3734823730) strcat(s, "u");
if (crc32("oNWWSVdyBC",10) == 2467335404) strcat(s, "t");
if (crc32("TlZQrI",6) == 2475971390) strcat(s, "A");
if (crc32("UGXrpeNDQDWYj",13) == 961978736) strcat(s, "g");
if (crc32("DcECbrHTQZNOTv",14) == 2643291981) strcat(s, "f");
if (crc32("sXHnQurnBQvR",12) == 350742467) strcat(s, "l");
if (crc32("yksRa",5) == 2041668996) strcat(s, "h");
if (crc32("vgIWpMzJIz",10) == 3017460354) strcat(s, "a");
if (crc32("QQRWrgKL",8) == 1378900690) strcat(s, "s");
if (crc32("NKYcOjnhx",9) == 2198398308) strcat(s, "s");
    return s;
}

char *gustoish_adjectives() {
    char *s = calloc(9);
    if (crc32("jbsZPe",6) == 3619754617) strcat(s, "X");
if (crc32("GQdAdWwPa",9) == 2505288926) strcat(s, "g");
if (crc32("HfEsLfONVnhzJ",13) == 1433430024) strcat(s, "u");
if (crc32("xuOskL",6) == 673211794) strcat(s, "a");
if (crc32("ImqoHIBqRF",10) == 4109988982) strcat(s, "s");
if (crc32("aRqRKegnxnikHcf",15) == 3143791900) strcat(s, "z");
if (crc32("qejNeTcoa",9) == 78784071) strcat(s, "t");
if (crc32("YQburdGqgfcteR",14) == 571728604) strcat(s, "V");
if (crc32("fpbkDYLCRxByk",13) == 3694983355) strcat(s, "o");
if (crc32("XeCZeBClKWs",11) == 139049286) strcat(s, "i");
if (crc32("cHcnwY",6) == 1311930233) strcat(s, "s");
if (crc32("WHdNRzcTaublOU",14) == 3297968701) strcat(s, "h");
    return s;
}

char *unfair_adjectives() {
    char *s = calloc(7);
    if (crc32("sWbaMxts",8) == 2944510926) strcat(s, "g");
if (crc32("WFGceDXkzicQt",13) == 3813632703) strcat(s, "u");
if (crc32("AWQdhQk",7) == 2962564356) strcat(s, "a");
if (crc32("mUHNAJXtTqqVAvi",15) == 2319118376) strcat(s, "n");
if (crc32("ZCZzZbOoVv",10) == 3183592527) strcat(s, "f");
if (crc32("tFXPXPViSnLLMR",14) == 1557404311) strcat(s, "K");
if (crc32("nndCdMI",7) == 2483096370) strcat(s, "a");
if (crc32("OSDPqrmEIls",11) == 350101127) strcat(s, "i");
if (crc32("jNiMaWyttR",10) == 453371879) strcat(s, "r");
    return s;
}

char *cinnamoyl_adjectives() {
    char *s = calloc(10);
    if (crc32("aQrUrSJlX",9) == 2557922511) strcat(s, "c");
if (crc32("UFHPZGKARI",10) == 898907897) strcat(s, "i");
if (crc32("pXcba",5) == 379985165) strcat(s, "n");
if (crc32("geTkgihjSfnyj",13) == 3151501545) strcat(s, "n");
if (crc32("yuBbFAqIbtQ",11) == 1094687389) strcat(s, "a");
if (crc32("izkRtXpIohYeNNH",15) == 212825174) strcat(s, "m");
if (crc32("PdNOQt",6) == 624641050) strcat(s, "o");
if (crc32("yhTCPTZucyWiYa",14) == 1728785393) strcat(s, "y");
if (crc32("YaUEtIQBYlECTH",14) == 1078646993) strcat(s, "l");
    return s;
}

char *nonrepellent_adjectives() {
    char *s = calloc(13);
    if (crc32("UXnAfyYqnbkRH",13) == 3477385016) strcat(s, "d");
if (crc32("hMUiR",5) == 1563641628) strcat(s, "n");
if (crc32("LJMBOWBNkCVNACb",15) == 2368374704) strcat(s, "A");
if (crc32("QZvbgnml",8) == 896352560) strcat(s, "o");
if (crc32("UDppYfQMLprv",12) == 3100000946) strcat(s, "h");
if (crc32("HerqXDEr",8) == 2393090503) strcat(s, "n");
if (crc32("GQTiNcXMiNYql",13) == 2221440117) strcat(s, "U");
if (crc32("KDOgCASgExyWpx",14) == 685289343) strcat(s, "r");
if (crc32("bzHFGzFUDzOVCMi",15) == 3148975023) strcat(s, "F");
if (crc32("TRhBqgr",7) == 1382807563) strcat(s, "e");
if (crc32("naazN",5) == 1773711270) strcat(s, "b");
if (crc32("krsqJNm",7) == 523387189) strcat(s, "p");
if (crc32("cJRXMp",6) == 1816707788) strcat(s, "Y");
if (crc32("JAfkYEmCn",9) == 1783616605) strcat(s, "e");
if (crc32("DzDmYWIhYltIrtA",15) == 1930023177) strcat(s, "l");
if (crc32("tiQrIplq",8) == 1265711918) strcat(s, "l");
if (crc32("RxQQiiq",7) == 1823360795) strcat(s, "e");
if (crc32("iLKbRPgYtwK",11) == 4257900762) strcat(s, "n");
if (crc32("MNrwvNFyedqbfP",14) == 4033430195) strcat(s, "t");
    return s;
}

char *unbedaubed_adjectives() {
    char *s = calloc(11);
    if (crc32("VsTjmqA",7) == 1042835056) strcat(s, "S");
if (crc32("RamJlBlHiFGir",13) == 3972266079) strcat(s, "u");
if (crc32("zUbMNfrVjdni",12) == 3071490670) strcat(s, "n");
if (crc32("jtszcAtWW",9) == 3729824098) strcat(s, "b");
if (crc32("WKxtKaH",7) == 3786496759) strcat(s, "p");
if (crc32("QamkuRAN",8) == 3224930587) strcat(s, "e");
if (crc32("oXLghT",6) == 494655044) strcat(s, "d");
if (crc32("tHSfXK",6) == 1792294321) strcat(s, "T");
if (crc32("sumWPaanYOP",11) == 249146218) strcat(s, "a");
if (crc32("QbhtIuK",7) == 3320102787) strcat(s, "i");
if (crc32("ZwkCxRgHL",9) == 90791462) strcat(s, "u");
if (crc32("NSzixrwIqBYkgxl",15) == 3053321523) strcat(s, "b");
if (crc32("SHZRQO",6) == 4056040644) strcat(s, "m");
if (crc32("xEdBGnldHyNuM",13) == 3279241468) strcat(s, "e");
if (crc32("JmrRFnegF",9) == 1369386909) strcat(s, "t");
if (crc32("acBEJMoAdJ",10) == 1324324458) strcat(s, "d");
    return s;
}

char *Bernese_adjectives() {
    char *s = calloc(8);
    if (crc32("hLbbStI",7) == 98294113) strcat(s, "B");
if (crc32("kFQZZzwEPkVn",12) == 498935065) strcat(s, "u");
if (crc32("UkhfE",5) == 2837652482) strcat(s, "e");
if (crc32("zHXmFIube",9) == 3559568382) strcat(s, "r");
if (crc32("vXGcytyqvZk",11) == 3421790665) strcat(s, "F");
if (crc32("GReXyokJzPuIE",13) == 3949659020) strcat(s, "n");
if (crc32("aHTjrLK",7) == 538528365) strcat(s, "e");
if (crc32("QtXMPlknmlTk",12) == 2238468863) strcat(s, "x");
if (crc32("sUNmhehFyiw",11) == 3639043397) strcat(s, "s");
if (crc32("VJQdyxqqEP",10) == 108519549) strcat(s, "O");
if (crc32("rqwVUg",6) == 3109639131) strcat(s, "e");
    return s;
}

char *uncontinuous_adjectives() {
    char *s = calloc(13);
    if (crc32("eebWlJsp",8) == 3007493338) strcat(s, "u");
if (crc32("hiwAVXDDFa",10) == 2536427427) strcat(s, "t");
if (crc32("QJVdqh",6) == 2963712070) strcat(s, "n");
if (crc32("dfYcCEJuIeE",11) == 3527739611) strcat(s, "c");
if (crc32("hgbIitdVVK",10) == 2832605170) strcat(s, "o");
if (crc32("nCeIPcvwlqH",11) == 251427045) strcat(s, "A");
if (crc32("UbaRdnXblxO",11) == 2137281918) strcat(s, "n");
if (crc32("dLZuUjaCnBLa",12) == 3098808861) strcat(s, "t");
if (crc32("xPFKEhL",7) == 1081025116) strcat(s, "a");
if (crc32("uddFVresYiU",11) == 812062519) strcat(s, "i");
if (crc32("fFwnQWIPEqhjf",13) == 3209394189) strcat(s, "n");
if (crc32("KZBFl",5) == 3699961309) strcat(s, "u");
if (crc32("RJwRZdMMZA",10) == 2518447930) strcat(s, "o");
if (crc32("DWgVgTd",7) == 768235168) strcat(s, "x");
if (crc32("ctDAlqIxXjPVF",13) == 599634808) strcat(s, "u");
if (crc32("oXuUpPDHeyLWwY",14) == 3578845159) strcat(s, "s");
    return s;
}

char *dashier_adjectives() {
    char *s = calloc(8);
    if (crc32("SzsDDNiDZHQJV",13) == 2041943145) strcat(s, "d");
if (crc32("TkznRzjIs",9) == 3996489551) strcat(s, "f");
if (crc32("JYXobpFUPvv",11) == 1257515713) strcat(s, "a");
if (crc32("LsqZK",5) == 2874644417) strcat(s, "a");
if (crc32("dSGGcipYE",9) == 240963398) strcat(s, "s");
if (crc32("vCbCKmxbImlVnqe",15) == 1909645232) strcat(s, "h");
if (crc32("SQgfxHhykS",10) == 2385424125) strcat(s, "y");
if (crc32("vTVxzBXShX",10) == 1542472605) strcat(s, "i");
if (crc32("tDQpZBssCCo",11) == 219949191) strcat(s, "e");
if (crc32("qZyrL",5) == 2674103476) strcat(s, "r");
    return s;
}

char *unticketed_adjectives() {
    char *s = calloc(11);
    if (crc32("TymDsRRrSlUS",12) == 1699015988) strcat(s, "f");
if (crc32("lFiVdduFJecqi",13) == 3220152954) strcat(s, "u");
if (crc32("wcQeCkYa",8) == 1518367069) strcat(s, "c");
if (crc32("hTSqOkUOfy",10) == 305519875) strcat(s, "n");
if (crc32("LOsNutWeRQ",10) == 2337694144) strcat(s, "t");
if (crc32("tpmTcoOTufNpKoj",15) == 560956000) strcat(s, "i");
if (crc32("wcoEBZMSW",9) == 3072306070) strcat(s, "x");
if (crc32("KzKeeonrZRjtb",13) == 1706975037) strcat(s, "c");
if (crc32("HGYaVQKkdOPP",12) == 1058288080) strcat(s, "k");
if (crc32("FjINzELW",8) == 2979164585) strcat(s, "e");
if (crc32("bvDzCioaOWeNTke",15) == 955869425) strcat(s, "t");
if (crc32("cFQPXduIQbp",11) == 1071333067) strcat(s, "e");
if (crc32("RiIhePFvLQC",11) == 1854588262) strcat(s, "d");
    return s;
}

char *supravaginal_adjectives() {
    char *s = calloc(13);
    if (crc32("XXmxjobJAb",10) == 6022028) strcat(s, "s");
if (crc32("NvwSLhk",7) == 4128895196) strcat(s, "h");
if (crc32("SeuoqyMgIm",10) == 1022482968) strcat(s, "u");
if (crc32("ItDwgoqoDVjJ",12) == 2073675996) strcat(s, "X");
if (crc32("EsXxMcIgSJva",12) == 3112944469) strcat(s, "p");
if (crc32("kQYLTK",6) == 652119173) strcat(s, "r");
if (crc32("yBczBFEBrQs",11) == 3130720317) strcat(s, "a");
if (crc32("iYxfOhG",7) == 3688063974) strcat(s, "y");
if (crc32("NJKSONIBGUCNfBk",15) == 1128053862) strcat(s, "v");
if (crc32("GMwHitCugClP",12) == 1247683247) strcat(s, "a");
if (crc32("ezQRmPubnia",11) == 3798049459) strcat(s, "J");
if (crc32("QgXTmrSggRdvPB",14) == 346572212) strcat(s, "g");
if (crc32("MOzLfAfSASZTcF",14) == 459192466) strcat(s, "i");
if (crc32("VffaAv",6) == 2050714401) strcat(s, "n");
if (crc32("bPVSIeMsnn",10) == 3532000032) strcat(s, "a");
if (crc32("QbGmfD",6) == 2163996112) strcat(s, "T");
if (crc32("aCCPQyCjlO",10) == 1856867360) strcat(s, "l");
    return s;
}

char *nonBrahminic_adjectives() {
    char *s = calloc(13);
    if (crc32("SMEJPWdo",8) == 2833449279) strcat(s, "n");
if (crc32("jXhQdEAO",8) == 1344911779) strcat(s, "l");
if (crc32("zzcDnTOC",8) == 465640341) strcat(s, "o");
if (crc32("eliMeiTCF",9) == 1273627402) strcat(s, "g");
if (crc32("uXfwohAYM",9) == 3540204886) strcat(s, "n");
if (crc32("QRxGbDTuEcSJ",12) == 3866423617) strcat(s, "m");
if (crc32("LCrwJUF",7) == 3348092569) strcat(s, "B");
if (crc32("PckaJHa",7) == 582549970) strcat(s, "r");
if (crc32("DNzvxd",6) == 990842196) strcat(s, "a");
if (crc32("VQaZHyAoKbrn",12) == 609320301) strcat(s, "h");
if (crc32("ypiASh",6) == 2176099814) strcat(s, "m");
if (crc32("vEXbkKXWd",9) == 809157840) strcat(s, "u");
if (crc32("RJgmuyPCDqd",11) == 2575714320) strcat(s, "i");
if (crc32("QTUHrbysDeGpacQ",15) == 1181952075) strcat(s, "L");
if (crc32("gsmWBkOrlUDVEyn",15) == 2688877400) strcat(s, "n");
if (crc32("CIDERPoYlzkgIjk",15) == 4072565208) strcat(s, "i");
if (crc32("SLHOPVTh",8) == 478810000) strcat(s, "d");
if (crc32("DkuFRaMDT",9) == 3468681479) strcat(s, "c");
    return s;
}

char *fiercer_adjectives() {
    char *s = calloc(8);
    if (crc32("UFSEKHglni",10) == 4187322880) strcat(s, "f");
if (crc32("suYZDZ",6) == 1467279304) strcat(s, "M");
if (crc32("WdqHyPhRoG",10) == 563780180) strcat(s, "i");
if (crc32("HOTtqnGsQcxnET",14) == 794343285) strcat(s, "e");
if (crc32("rURADzwJw",9) == 1768726716) strcat(s, "r");
if (crc32("OnoNvDqACY",10) == 30197121) strcat(s, "f");
if (crc32("pJOOxiZbQLvLwmA",15) == 1559537883) strcat(s, "c");
if (crc32("tlFBSclyMI",10) == 3885400019) strcat(s, "E");
if (crc32("jdWQHgynJM",10) == 1612547193) strcat(s, "e");
if (crc32("hgonGrVKi",9) == 4037754344) strcat(s, "r");
    return s;
}

char *freerange_adjectives() {
    char *s = calloc(10);
    if (crc32("pobKXskesNF",11) == 1555954533) strcat(s, "i");
if (crc32("fqQawiigd",9) == 3308875690) strcat(s, "f");
if (crc32("cmVJGtJOgdKk",12) == 791840568) strcat(s, "r");
if (crc32("KujBuE",6) == 1445729024) strcat(s, "w");
if (crc32("abVvkkfjWoSL",12) == 94051026) strcat(s, "e");
if (crc32("CerKDPT",7) == 705516537) strcat(s, "b");
if (crc32("NVfXlyYeiHdSH",13) == 34256147) strcat(s, "e");
if (crc32("vUvDanOEp",9) == 3126927476) strcat(s, "r");
if (crc32("IfYxzyhODOstV",13) == 1967350775) strcat(s, "a");
if (crc32("spzitU",6) == 3597703133) strcat(s, "n");
if (crc32("VXbYuafdBqJw",12) == 3304209540) strcat(s, "e");
if (crc32("KybBzEUvHTVM",12) == 1255550151) strcat(s, "g");
if (crc32("VomshvrPRHdlj",13) == 4134721661) strcat(s, "y");
if (crc32("kFXaje",6) == 3777258355) strcat(s, "e");
    return s;
}

char *frowzier_adjectives() {
    char *s = calloc(9);
    if (crc32("pbnEAEQm",8) == 3001854885) strcat(s, "f");
if (crc32("bSlTokbTlgfSy",13) == 1262764920) strcat(s, "r");
if (crc32("FWUBv",5) == 2119505166) strcat(s, "z");
if (crc32("TQfLYSeqY",9) == 1190388126) strcat(s, "o");
if (crc32("sbCoHUraJyIz",12) == 2166432467) strcat(s, "w");
if (crc32("dBlJGBAcRXAT",12) == 4129191607) strcat(s, "R");
if (crc32("NStisLkeGV",10) == 2443979367) strcat(s, "z");
if (crc32("CfUIbaFsVy",10) == 3029460779) strcat(s, "E");
if (crc32("wmoTNd",6) == 3935472085) strcat(s, "i");
if (crc32("hkKkLFymyavYQ",13) == 2497041883) strcat(s, "e");
if (crc32("jkMAgJDtmuD",11) == 4028327070) strcat(s, "r");
    return s;
}

char *crateral_adjectives() {
    char *s = calloc(9);
    if (crc32("hjdgDEdpLyib",12) == 1271662024) strcat(s, "c");
if (crc32("buJCGdmSHPXV",12) == 2884620761) strcat(s, "r");
if (crc32("eNsCecRmJS",10) == 3397135791) strcat(s, "r");
if (crc32("UrXnAcbDekVp",12) == 3303055394) strcat(s, "J");
if (crc32("zObXFRmZNGCz",12) == 342605125) strcat(s, "a");
if (crc32("RkjYeOPoPyb",11) == 537890027) strcat(s, "D");
if (crc32("JhIfwKRRZFbhR",13) == 1844692947) strcat(s, "t");
if (crc32("PbFtgWwPAVkuB",13) == 1149578627) strcat(s, "e");
if (crc32("IKVmvfUARv",10) == 3550712107) strcat(s, "r");
if (crc32("TIcKxwIXTQmpy",13) == 3767152847) strcat(s, "a");
if (crc32("fdotTxdrBhgdeRq",15) == 2807848818) strcat(s, "l");
    return s;
}

char *noncomprehensible_adjectives() {
    char *s = calloc(18);
    if (crc32("bHqctZNp",8) == 3423360144) strcat(s, "x");
if (crc32("pXYTBNaYme",10) == 3918881762) strcat(s, "n");
if (crc32("ZBiotcmqo",9) == 3980588942) strcat(s, "f");
if (crc32("zFksKFj",7) == 3969315488) strcat(s, "o");
if (crc32("azuAQhUvPdgI",12) == 2806882332) strcat(s, "n");
if (crc32("qrqsMY",6) == 553256320) strcat(s, "c");
if (crc32("vGsjeohvhmWNoma",15) == 3390566509) strcat(s, "o");
if (crc32("cerMOSxY",8) == 1553852781) strcat(s, "m");
if (crc32("pBhevzpuUgNj",12) == 925005157) strcat(s, "M");
if (crc32("IFUlTiGr",8) == 1995498604) strcat(s, "p");
if (crc32("pdYrejv",7) == 3198474129) strcat(s, "o");
if (crc32("ZTXOY",5) == 4145511696) strcat(s, "r");
if (crc32("wENjKtJIF",9) == 2795115087) strcat(s, "e");
if (crc32("utYcSaOWUW",10) == 412955482) strcat(s, "h");
if (crc32("mihDeDjb",8) == 1056158207) strcat(s, "e");
if (crc32("oDrMQwTGJS",10) == 313075470) strcat(s, "v");
if (crc32("TUooHSKKJBeYI",13) == 353649616) strcat(s, "n");
if (crc32("yTTXbWYl",8) == 763333797) strcat(s, "F");
if (crc32("tpDDI",5) == 1305036711) strcat(s, "s");
if (crc32("FlpxX",5) == 3066449959) strcat(s, "i");
if (crc32("ulaHsBCCh",9) == 2042438249) strcat(s, "X");
if (crc32("qTixBLNP",8) == 2031591730) strcat(s, "b");
if (crc32("VYGwJP",6) == 950384861) strcat(s, "e");
if (crc32("OPPcTlMSHkif",12) == 3332718455) strcat(s, "l");
if (crc32("QBSSpKQEcCBEWZ",14) == 2447181400) strcat(s, "e");
    return s;
}

char *nightly_adjectives() {
    char *s = calloc(8);
    if (crc32("gxwmqO",6) == 187818415) strcat(s, "n");
if (crc32("VUkbBfbkgiVpOLJ",15) == 4180275407) strcat(s, "C");
if (crc32("SyLVtwemX",9) == 1190136972) strcat(s, "i");
if (crc32("JMJmWqjXY",9) == 427384156) strcat(s, "l");
if (crc32("MvZWPrGYiPxSB",13) == 3321381852) strcat(s, "g");
if (crc32("OsGmqPoTuILzbR",14) == 4114919856) strcat(s, "H");
if (crc32("tljzdb",6) == 3529711630) strcat(s, "h");
if (crc32("XyUFJQLgMMfDNs",14) == 1672612257) strcat(s, "t");
if (crc32("QziIg",5) == 923682498) strcat(s, "A");
if (crc32("GAyjZrjMzEUWau",14) == 2044439927) strcat(s, "l");
if (crc32("HtAxeSV",7) == 3287665790) strcat(s, "S");
if (crc32("MUNaZfW",7) == 657033181) strcat(s, "y");
    return s;
}

char *semitailored_adjectives() {
    char *s = calloc(13);
    if (crc32("aSxxkjnrTBij",12) == 2047513225) strcat(s, "r");
if (crc32("lZTiP",5) == 2326889953) strcat(s, "s");
if (crc32("RkOrCqqST",9) == 1969330775) strcat(s, "c");
if (crc32("yVtdjYQANettghg",15) == 3374437098) strcat(s, "e");
if (crc32("qijrMy",6) == 460535085) strcat(s, "x");
if (crc32("AYDdjpQU",8) == 1994956496) strcat(s, "m");
if (crc32("ciwsELAPTtjc",12) == 1689541157) strcat(s, "u");
if (crc32("mlhqkRUGzSR",11) == 3473899146) strcat(s, "i");
if (crc32("oZTuLppFFo",10) == 2926055855) strcat(s, "t");
if (crc32("scYBIvXOJ",9) == 493750993) strcat(s, "a");
if (crc32("XDzACLD",7) == 3431746639) strcat(s, "d");
if (crc32("XqDqSXpfgL",10) == 3113449298) strcat(s, "i");
if (crc32("vlUyFVCSogL",11) == 3617863266) strcat(s, "E");
if (crc32("yQatkCZf",8) == 3860537097) strcat(s, "l");
if (crc32("dXQCMVKt",8) == 3453865852) strcat(s, "Q");
if (crc32("MhBIyCzg",8) == 444408448) strcat(s, "o");
if (crc32("DeByiDhqCJQae",13) == 2755894947) strcat(s, "r");
if (crc32("IBAyLlZisYfoE",13) == 1139580557) strcat(s, "e");
if (crc32("RVNvPrHgUkFglZ",14) == 478656281) strcat(s, "g");
if (crc32("rsjWFvlTwE",10) == 2891956590) strcat(s, "d");
    return s;
}

char *mustier_adjectives() {
    char *s = calloc(8);
    if (crc32("ZulvBBSAMuHly",13) == 246295038) strcat(s, "m");
if (crc32("pGsQDQpfbxI",11) == 1103085384) strcat(s, "r");
if (crc32("iqlkUbXVXHCsYSf",15) == 478988544) strcat(s, "u");
if (crc32("CwvbfVdHHcRI",12) == 385628185) strcat(s, "h");
if (crc32("pBuTkSVCwH",10) == 1338940361) strcat(s, "s");
if (crc32("jKhgcrYrlgR",11) == 1688652282) strcat(s, "t");
if (crc32("aRoeiHKFSolkpq",14) == 3777922039) strcat(s, "m");
if (crc32("AhBVuGKId",9) == 100076361) strcat(s, "i");
if (crc32("noHPWnCDAlWTFaS",15) == 80012237) strcat(s, "e");
if (crc32("qYHFXmPY",8) == 3867008987) strcat(s, "l");
if (crc32("qCeGrmrzKZyoAq",14) == 2617481755) strcat(s, "r");
    return s;
}

char *autopolyploid_adjectives() {
    char *s = calloc(14);
    if (crc32("YITLQdXG",8) == 1383198931) strcat(s, "a");
if (crc32("RhphApiSDhY",11) == 369885897) strcat(s, "u");
if (crc32("extQIvYj",8) == 3339725656) strcat(s, "t");
if (crc32("ZQATpojOTLqtVt",14) == 2538766644) strcat(s, "W");
if (crc32("xCmjCZvD",8) == 3905048204) strcat(s, "o");
if (crc32("mmGjrjgBWYj",11) == 2655410576) strcat(s, "Z");
if (crc32("hLgjzxOTacyleu",14) == 1487664299) strcat(s, "p");
if (crc32("PntiqjOd",8) == 4086730614) strcat(s, "G");
if (crc32("SbNOmTXDvN",10) == 2780490857) strcat(s, "o");
if (crc32("vaFiz",5) == 3100150053) strcat(s, "Z");
if (crc32("AFSEFeBTRHZVv",13) == 1881798746) strcat(s, "l");
if (crc32("KvelDQSPtfAviBZ",15) == 586257465) strcat(s, "y");
if (crc32("QHhBMqUHX",9) == 1556625207) strcat(s, "D");
if (crc32("zTELlwjsnvlawd",14) == 3252216456) strcat(s, "p");
if (crc32("zYtAHmBgHKiYDw",14) == 3200409668) strcat(s, "V");
if (crc32("mLnNhNlEu",9) == 3857311342) strcat(s, "l");
if (crc32("FgQddsGX",8) == 3277111969) strcat(s, "t");
if (crc32("XwFUNixvrdh",11) == 2761255756) strcat(s, "o");
if (crc32("UztQZssfaXd",11) == 383781561) strcat(s, "R");
if (crc32("TIkFotGDi",9) == 2235839379) strcat(s, "i");
if (crc32("ujyEbYiltqDmyEh",15) == 503103874) strcat(s, "f");
if (crc32("FgaCFasuecmgUf",14) == 3259810179) strcat(s, "d");
    return s;
}

char *heraldic_adjectives() {
    char *s = calloc(9);
    if (crc32("tBZEtovaoOKv",12) == 1982591019) strcat(s, "h");
if (crc32("xbxXGifEy",9) == 2249581741) strcat(s, "n");
if (crc32("OwZjILPuwBhaMDa",15) == 532038926) strcat(s, "e");
if (crc32("ZwbmVxIMl",9) == 1759715051) strcat(s, "r");
if (crc32("SozGA",5) == 1028775953) strcat(s, "a");
if (crc32("jjUIQ",5) == 379320035) strcat(s, "l");
if (crc32("NxebSQQI",8) == 622811860) strcat(s, "d");
if (crc32("FvRMSyENd",9) == 1638351319) strcat(s, "T");
if (crc32("HAlLblTrvErcvl",14) == 205144004) strcat(s, "i");
if (crc32("ayYFCncWFnti",12) == 1577534765) strcat(s, "c");
    return s;
}

char *Gravettian_adjectives() {
    char *s = calloc(11);
    if (crc32("xIROqRMyvayD",12) == 1407543121) strcat(s, "G");
if (crc32("hCiaKclGVwfn",12) == 32666692) strcat(s, "r");
if (crc32("qmpQilBClgUyrSp",15) == 3498590385) strcat(s, "a");
if (crc32("DNYgDvxVKgQMwYp",15) == 1642034079) strcat(s, "d");
if (crc32("rRNfxdcbWzZztD",14) == 299802826) strcat(s, "v");
if (crc32("gmGauJKmKLX",11) == 596400274) strcat(s, "e");
if (crc32("QzIUiJZIp",9) == 1132389982) strcat(s, "t");
if (crc32("fcyVIYFpapFs",12) == 1720722751) strcat(s, "t");
if (crc32("tHkBkoPZ",8) == 3680259132) strcat(s, "Z");
if (crc32("TeiGQtAtRQo",11) == 3271306641) strcat(s, "i");
if (crc32("VTswITHQbvuh",12) == 1040855561) strcat(s, "a");
if (crc32("QUPrueH",7) == 1960210550) strcat(s, "k");
if (crc32("hrAhpuooVwr",11) == 3224361421) strcat(s, "n");
    return s;
}

char *horny_adjectives() {
    char *s = calloc(6);
    if (crc32("wlhUL",5) == 37928267) strcat(s, "h");
if (crc32("vHbYMIaKvhSWGLx",15) == 2795979990) strcat(s, "a");
if (crc32("XsEEW",5) == 3113962585) strcat(s, "o");
if (crc32("dVIRaNf",7) == 3187669021) strcat(s, "i");
if (crc32("lVufTDHiGjxEML",14) == 773533492) strcat(s, "r");
if (crc32("VSsRW",5) == 2214346930) strcat(s, "n");
if (crc32("TXONMaFLCHOZXV",14) == 555892682) strcat(s, "r");
if (crc32("LsJVZlNQjEzBLJ",14) == 3731315614) strcat(s, "y");
    return s;
}

char *syngamic_adjectives() {
    char *s = calloc(9);
    if (crc32("fdgrJxMBAlBrf",13) == 4102208257) strcat(s, "G");
if (crc32("zWPmh",5) == 3692882520) strcat(s, "s");
if (crc32("RmkzhOTaAJ",10) == 2910491808) strcat(s, "V");
if (crc32("NCHKDzTLCV",10) == 2072652862) strcat(s, "y");
if (crc32("SKeUw",5) == 2989873535) strcat(s, "n");
if (crc32("QctYAiEvMwOHU",13) == 884376509) strcat(s, "k");
if (crc32("dIiiGbEMVslCSUY",15) == 1666120313) strcat(s, "g");
if (crc32("bGZpvfQSbIg",11) == 1620412460) strcat(s, "a");
if (crc32("AQJPojPE",8) == 158292016) strcat(s, "m");
if (crc32("WYxqMicRwth",11) == 3260996914) strcat(s, "Z");
if (crc32("VKvZgF",6) == 3729420018) strcat(s, "i");
if (crc32("cGfmaOPVRrY",11) == 3749476591) strcat(s, "c");
    return s;
}

char *cornaceous_adjectives() {
    char *s = calloc(11);
    if (crc32("xRRtgUrBcoeHmhP",15) == 3473426697) strcat(s, "c");
if (crc32("fhgZhmOEltP",11) == 2572751602) strcat(s, "o");
if (crc32("IuASeape",8) == 18735094) strcat(s, "o");
if (crc32("nKmZUHAtrB",10) == 2103675948) strcat(s, "r");
if (crc32("oDwmSfyiaXY",11) == 3077232127) strcat(s, "n");
if (crc32("odhnlxQrBFdlHE",14) == 3575891709) strcat(s, "a");
if (crc32("DFSahWYca",9) == 3011564824) strcat(s, "c");
if (crc32("dmXlfDk",7) == 1423409742) strcat(s, "I");
if (crc32("mphDSNdWlW",10) == 139717355) strcat(s, "e");
if (crc32("yREnpzgJvP",10) == 2117396834) strcat(s, "o");
if (crc32("lvBXXyjOX",9) == 1282260773) strcat(s, "u");
if (crc32("vlhjYlyUSwv",11) == 2855168876) strcat(s, "E");
if (crc32("hmczrVfCZQIlq",13) == 2038545363) strcat(s, "s");
    return s;
}

char *noncontemptible_adjectives() {
    char *s = calloc(16);
    if (crc32("ovYaEFutqlhV",12) == 1307303793) strcat(s, "k");
if (crc32("rndYtHyqXzfOW",13) == 2640288899) strcat(s, "n");
if (crc32("lrimFQB",7) == 2241581596) strcat(s, "o");
if (crc32("slGlvmhzrJTAyYh",15) == 736509995) strcat(s, "n");
if (crc32("BeCbiONiccrzgb",14) == 1048021110) strcat(s, "V");
if (crc32("PcGkAbcG",8) == 3094792734) strcat(s, "c");
if (crc32("nRfmBEBaGLvZTjR",15) == 3864301722) strcat(s, "o");
if (crc32("ZNkGBcDyampp",12) == 3071364689) strcat(s, "n");
if (crc32("NUGwYiVy",8) == 1162628192) strcat(s, "t");
if (crc32("OzZmAZ",6) == 2602678966) strcat(s, "g");
if (crc32("raXfaVkYmHBcw",13) == 3462631297) strcat(s, "e");
if (crc32("rHnqHDQBIM",10) == 2617473882) strcat(s, "m");
if (crc32("pjeCBSh",7) == 2717487828) strcat(s, "p");
if (crc32("iVXysavnPP",10) == 1913436576) strcat(s, "z");
if (crc32("xMAqH",5) == 1501936145) strcat(s, "t");
if (crc32("TDwfrpKgx",9) == 950084851) strcat(s, "N");
if (crc32("fDPIrNfB",8) == 2328375728) strcat(s, "i");
if (crc32("PVaMpqnQwn",10) == 3509109049) strcat(s, "b");
if (crc32("zOvql",5) == 2490054206) strcat(s, "l");
if (crc32("PDleCxeBI",9) == 522737189) strcat(s, "e");
    return s;
}

char *unchanted_adjectives() {
    char *s = calloc(10);
    if (crc32("QFaWcSXwqQl",11) == 85184129) strcat(s, "k");
if (crc32("SpEVnqH",7) == 4134322669) strcat(s, "u");
if (crc32("Zngnmcm",7) == 3352387637) strcat(s, "L");
if (crc32("pASNxHj",7) == 2120038442) strcat(s, "n");
if (crc32("ZbQbl",5) == 2436535037) strcat(s, "R");
if (crc32("VchhFZx",7) == 1849958597) strcat(s, "c");
if (crc32("dzYsaFheXMqOLa",14) == 2776880438) strcat(s, "r");
if (crc32("qforPdWklvmkNfd",15) == 3641572697) strcat(s, "h");
if (crc32("JWYBeUQmdIGwoQa",15) == 2331009621) strcat(s, "q");
if (crc32("ynZASdvKfZopZCJ",15) == 2951661806) strcat(s, "a");
if (crc32("DHimLMmTsFZTie",14) == 2691606015) strcat(s, "k");
if (crc32("pQIaJz",6) == 2866594580) strcat(s, "n");
if (crc32("JbDbqQRWbbW",11) == 3568815528) strcat(s, "z");
if (crc32("TcLbtpDwdc",10) == 2902718893) strcat(s, "t");
if (crc32("tmNNgcfYG",9) == 3973324841) strcat(s, "e");
if (crc32("dTIPfVaGH",9) == 2647220867) strcat(s, "d");
    return s;
}

char *pseudodramatic_adjectives() {
    char *s = calloc(15);
    if (crc32("mOVnTIfWuecPek",14) == 3690575157) strcat(s, "k");
if (crc32("WuHybTHcXh",10) == 745259962) strcat(s, "p");
if (crc32("uVOOHElmjjeAMJf",15) == 582811107) strcat(s, "s");
if (crc32("mQGjHEteRRXI",12) == 2244841531) strcat(s, "H");
if (crc32("pqVYKOAmzQJd",12) == 1081048101) strcat(s, "e");
if (crc32("CeiSSMD",7) == 3063013895) strcat(s, "E");
if (crc32("RCiSCFgKwzzwRxm",15) == 3813495415) strcat(s, "u");
if (crc32("iUPVWDtMOsZeGc",14) == 3305992100) strcat(s, "I");
if (crc32("YsBFXzyhMnpKA",13) == 2605652607) strcat(s, "d");
if (crc32("egLtpNw",7) == 3693604633) strcat(s, "o");
if (crc32("zvPKOMsrfzrqsMJ",15) == 1927158788) strcat(s, "d");
if (crc32("SgLspkEkAe",10) == 468074995) strcat(s, "k");
if (crc32("AcNsX",5) == 2441383216) strcat(s, "r");
if (crc32("GxFzIX",6) == 3395092121) strcat(s, "a");
if (crc32("sJqOhlicDAEoV",13) == 3931453342) strcat(s, "a");
if (crc32("NZTpvvJzyevZjIa",15) == 3730300568) strcat(s, "m");
if (crc32("ddXhiuMwhz",10) == 1505570682) strcat(s, "g");
if (crc32("WSMnscyoZ",9) == 2578180104) strcat(s, "a");
if (crc32("iECtGeASzB",10) == 2794974250) strcat(s, "t");
if (crc32("sNqLsLo",7) == 3082353383) strcat(s, "i");
if (crc32("qBJhJDYObg",10) == 1074778494) strcat(s, "c");
    return s;
}

char *unelectable_adjectives() {
    char *s = calloc(12);
    if (crc32("QSLzePyVZivv",12) == 3746165078) strcat(s, "u");
if (crc32("MQcYOIwNsCChf",13) == 83139253) strcat(s, "n");
if (crc32("fkAFdRJDF",9) == 77445063) strcat(s, "n");
if (crc32("BBoEXAy",7) == 2124231563) strcat(s, "P");
if (crc32("NqmaXeKjjV",10) == 1196355145) strcat(s, "e");
if (crc32("FvxEkjqhZA",10) == 1991516013) strcat(s, "M");
if (crc32("epQbgMZs",8) == 1653217939) strcat(s, "l");
if (crc32("rysdCjoelC",10) == 295070684) strcat(s, "e");
if (crc32("KkTVGXFMupOONmh",15) == 359958078) strcat(s, "e");
if (crc32("fnklTsmIEnCs",12) == 758679808) strcat(s, "p");
if (crc32("gCkJVBKXngnbBYQ",15) == 2906928164) strcat(s, "c");
if (crc32("kyWjnaJyLeD",11) == 1238938744) strcat(s, "t");
if (crc32("zWdrDX",6) == 2174911682) strcat(s, "r");
if (crc32("aKnmvnUjYvsW",12) == 1985661244) strcat(s, "a");
if (crc32("cTIpUnjl",8) == 1490401562) strcat(s, "b");
if (crc32("EEbSfxcpDk",10) == 2885153555) strcat(s, "l");
if (crc32("IFHDZOWdzmsTne",14) == 3813088166) strcat(s, "e");
    return s;
}

char *unreminded_adjectives() {
    char *s = calloc(11);
    if (crc32("tRggUQmYH",9) == 3781445090) strcat(s, "k");
if (crc32("efUuzii",7) == 4016743674) strcat(s, "u");
if (crc32("opYjGJTKKiOB",12) == 3435772978) strcat(s, "Q");
if (crc32("iYTrgZYr",8) == 443458306) strcat(s, "n");
if (crc32("XvpmEe",6) == 3161188398) strcat(s, "r");
if (crc32("cWfzzSo",7) == 833940612) strcat(s, "e");
if (crc32("lCzUM",5) == 2240209720) strcat(s, "m");
if (crc32("gyYbzir",7) == 137252438) strcat(s, "i");
if (crc32("ZXiUkTV",7) == 2327331297) strcat(s, "n");
if (crc32("ZpspcYVpF",9) == 3416329029) strcat(s, "d");
if (crc32("DAapnxp",7) == 3555446100) strcat(s, "e");
if (crc32("IFTUZmQcPVyC",12) == 3842711928) strcat(s, "d");
    return s;
}

char *subolive_adjectives() {
    char *s = calloc(9);
    if (crc32("zAxQrrOhLOaIV",13) == 3473694202) strcat(s, "M");
if (crc32("mqVfZvq",7) == 555846199) strcat(s, "s");
if (crc32("YDfPJIfGJbBlOE",14) == 3123981077) strcat(s, "u");
if (crc32("ZWkiefoNf",9) == 4079536495) strcat(s, "f");
if (crc32("OYpVB",5) == 2319895187) strcat(s, "b");
if (crc32("XkqDzPu",7) == 4229149763) strcat(s, "o");
if (crc32("pKTKmoHm",8) == 820123439) strcat(s, "y");
if (crc32("THbbEmIxI",9) == 2754112115) strcat(s, "l");
if (crc32("ZGMmuTqrUakRNu",14) == 3119900578) strcat(s, "q");
if (crc32("wkiHqwXvHSAeLH",14) == 1067852918) strcat(s, "i");
if (crc32("qBoYE",5) == 499741131) strcat(s, "v");
if (crc32("uXtewLs",7) == 3760249783) strcat(s, "H");
if (crc32("fQVSBsUkm",9) == 505937541) strcat(s, "e");
    return s;
}

char *nontautomerizable_adjectives() {
    char *s = calloc(18);
    if (crc32("iKdSvKyDEYu",11) == 3417751396) strcat(s, "n");
if (crc32("foHpFW",6) == 762353966) strcat(s, "o");
if (crc32("TXTDY",5) == 3894369382) strcat(s, "n");
if (crc32("LdeLTKjRubGUigx",15) == 1160990317) strcat(s, "w");
if (crc32("REmFzbXROPCAhw",14) == 3282707709) strcat(s, "t");
if (crc32("GAtizjyqHIlQ",12) == 697091315) strcat(s, "a");
if (crc32("MfOxcwEJcHwb",12) == 3877103856) strcat(s, "u");
if (crc32("fILrQ",5) == 1319726325) strcat(s, "t");
if (crc32("nQGEjItjQCK",11) == 3959528157) strcat(s, "o");
if (crc32("GcJJNzkJ",8) == 1913254765) strcat(s, "m");
if (crc32("eJqjpNICxotJlw",14) == 3679720457) strcat(s, "p");
if (crc32("YTRVBHnNKLp",11) == 171376297) strcat(s, "e");
if (crc32("qdPRPZGeabzn",12) == 1418997592) strcat(s, "b");
if (crc32("yPFktbCgwmdt",12) == 2179531353) strcat(s, "r");
if (crc32("CpjCIqbY",8) == 1849110860) strcat(s, "i");
if (crc32("WyqSw",5) == 1357046719) strcat(s, "z");
if (crc32("VmsUkrrf",8) == 2953593199) strcat(s, "J");
if (crc32("OJqnKHTiBPkRG",13) == 738785382) strcat(s, "a");
if (crc32("IyRKgfi",7) == 608516146) strcat(s, "b");
if (crc32("FebxbmvWAQLpYB",14) == 3087558330) strcat(s, "l");
if (crc32("FzghftDQjWx",11) == 3345939551) strcat(s, "e");
    return s;
}

char *stockcar_adjectives() {
    char *s = calloc(9);
    if (crc32("jspHUBInX",9) == 580069472) strcat(s, "s");
if (crc32("XbkaFrVuQv",10) == 1729487955) strcat(s, "t");
if (crc32("pngSATFxi",9) == 1173993322) strcat(s, "E");
if (crc32("XfTFUrea",8) == 3266454607) strcat(s, "o");
if (crc32("WHIUNg",6) == 4186826744) strcat(s, "c");
if (crc32("JDJwI",5) == 3529795212) strcat(s, "k");
if (crc32("mRvmxj",6) == 2932146830) strcat(s, "x");
if (crc32("EeUgTijzzG",10) == 3985772483) strcat(s, "c");
if (crc32("aOBkXzhlpkjWm",13) == 2850015408) strcat(s, "e");
if (crc32("FPMTY",5) == 1857960645) strcat(s, "a");
if (crc32("sdVLGTCVtfvcfMf",15) == 4174196461) strcat(s, "C");
if (crc32("VjhERYYsqdbXlIJ",15) == 2195323978) strcat(s, "r");
    return s;
}

char *tinkly_adjectives() {
    char *s = calloc(7);
    if (crc32("SmrHJmnIpDwjE",13) == 206461041) strcat(s, "d");
if (crc32("DWVBy",5) == 3190589586) strcat(s, "t");
if (crc32("jLZePxlZRgkyM",13) == 2427049178) strcat(s, "C");
if (crc32("cytYQSmmro",10) == 3928747996) strcat(s, "i");
if (crc32("DlRRWVDRiqsv",12) == 138278151) strcat(s, "u");
if (crc32("juguHVTTGCB",11) == 129156128) strcat(s, "n");
if (crc32("QKPCVnIwTznAWMf",15) == 3686429766) strcat(s, "k");
if (crc32("BVLZLzADX",9) == 3001462898) strcat(s, "l");
if (crc32("tordFVFevGN",11) == 2556428594) strcat(s, "W");
if (crc32("wEXBxEp",7) == 1436634412) strcat(s, "y");
    return s;
}

char *submanic_adjectives() {
    char *s = calloc(9);
    if (crc32("mkPTRc",6) == 3917331397) strcat(s, "z");
if (crc32("ILonwiSEbiuHF",13) == 1244666691) strcat(s, "s");
if (crc32("iUUNiYEbWqzw",12) == 1400675472) strcat(s, "u");
if (crc32("xbySTAiusXml",12) == 2986555202) strcat(s, "b");
if (crc32("VYEAzjrZfmLsf",13) == 1152469616) strcat(s, "Y");
if (crc32("QGnpfrx",7) == 1210268657) strcat(s, "m");
if (crc32("WYgjbtvBkjc",11) == 4222443083) strcat(s, "I");
if (crc32("drPIgyPeKzr",11) == 2088082582) strcat(s, "a");
if (crc32("ezwikdUgCk",10) == 3556914976) strcat(s, "a");
if (crc32("eSkgqqORnISrrz",14) == 3003601496) strcat(s, "n");
if (crc32("HvMGAqcKEdbR",12) == 4200079210) strcat(s, "A");
if (crc32("xqKLQoOelKH",11) == 2483313801) strcat(s, "i");
if (crc32("gmzbNDRMzPj",11) == 4013361730) strcat(s, "I");
if (crc32("yNRQPBuniJThAu",14) == 1003392203) strcat(s, "c");
    return s;
}

char *noneducatory_adjectives() {
    char *s = calloc(13);
    if (crc32("vnyZsAxaG",9) == 659730539) strcat(s, "n");
if (crc32("AtWqCfbPjA",10) == 3601182285) strcat(s, "o");
if (crc32("ZQYmBq",6) == 1151770505) strcat(s, "t");
if (crc32("fLMNC",5) == 4177526343) strcat(s, "n");
if (crc32("FXHjHxurHsAmmJH",15) == 3580687043) strcat(s, "v");
if (crc32("uMOXsMqpD",9) == 1619668709) strcat(s, "e");
if (crc32("DexYpTusZs",10) == 3999816243) strcat(s, "d");
if (crc32("WEpDQWr",7) == 2902697164) strcat(s, "B");
if (crc32("bMjKZ",5) == 2447192834) strcat(s, "u");
if (crc32("wbfrFV",6) == 2612930366) strcat(s, "e");
if (crc32("rFxZnDRt",8) == 1255243486) strcat(s, "c");
if (crc32("mQLyq",5) == 42277281) strcat(s, "j");
if (crc32("hxLuKbhPdDrJJCn",15) == 447877165) strcat(s, "a");
if (crc32("HEwJKhngAerYB",13) == 1307250944) strcat(s, "f");
if (crc32("mNLtGjl",7) == 2512531167) strcat(s, "t");
if (crc32("buYWtxBVWjd",11) == 2104550305) strcat(s, "o");
if (crc32("LKVYRyvZYL",10) == 2418528357) strcat(s, "r");
if (crc32("DdtlWSDH",8) == 2941209154) strcat(s, "y");
    return s;
}

char *transpalmar_adjectives() {
    char *s = calloc(12);
    if (crc32("fZbYlNlkh",9) == 135949251) strcat(s, "p");
if (crc32("mCwZvcmHAJLSx",13) == 2335980269) strcat(s, "t");
if (crc32("aZFXvw",6) == 3625991563) strcat(s, "p");
if (crc32("KfRGILuZPkDg",12) == 3509479707) strcat(s, "r");
if (crc32("WedsRaaAKojzqC",14) == 1845540711) strcat(s, "a");
if (crc32("XpNfWeoDlabTHf",14) == 3469539565) strcat(s, "W");
if (crc32("adHGPqcyT",9) == 2951939291) strcat(s, "n");
if (crc32("YlDMCHRFdDJyRg",14) == 1632675228) strcat(s, "H");
if (crc32("PiuuACvgjR",10) == 844289017) strcat(s, "s");
if (crc32("mFTpWokOgbQPQ",13) == 2141366458) strcat(s, "e");
if (crc32("ZgcsSCbMtZjf",12) == 3525887327) strcat(s, "p");
if (crc32("bKuvUNgGNggvPf",14) == 3280792770) strcat(s, "u");
if (crc32("ZAaMx",5) == 3308615294) strcat(s, "a");
if (crc32("zeWkeCHfr",9) == 1819121485) strcat(s, "k");
if (crc32("NJQEyiesAkR",11) == 1846727862) strcat(s, "l");
if (crc32("yKXYNsDDUE",10) == 1916440215) strcat(s, "S");
if (crc32("hldortMP",8) == 508503809) strcat(s, "m");
if (crc32("IZXTrvKt",8) == 1194961491) strcat(s, "u");
if (crc32("JBXiZmUSrIPb",12) == 3752568223) strcat(s, "a");
if (crc32("jtHvZIMzKyZyz",13) == 3281064577) strcat(s, "r");
    return s;
}

char *parsonish_adjectives() {
    char *s = calloc(10);
    if (crc32("LEJCqk",6) == 4194743101) strcat(s, "s");
if (crc32("jXCrplzS",8) == 866978893) strcat(s, "p");
if (crc32("zyrmCnBfKhdc",12) == 2564157443) strcat(s, "a");
if (crc32("xaBlZryCxmaQroC",15) == 2317971953) strcat(s, "r");
if (crc32("afOYCuDkhBJucn",14) == 1081726925) strcat(s, "s");
if (crc32("NsEUWUBdEX",10) == 3443672020) strcat(s, "o");
if (crc32("BnaOb",5) == 97571776) strcat(s, "o");
if (crc32("xaGvX",5) == 3843707014) strcat(s, "n");
if (crc32("zgcxn",5) == 3570141713) strcat(s, "i");
if (crc32("FiaIYWFqpgd",11) == 1752318934) strcat(s, "u");
if (crc32("qRwbHsTbdQlzeD",14) == 3386565273) strcat(s, "s");
if (crc32("THVAmahbHFA",11) == 1901252409) strcat(s, "c");
if (crc32("FHlqnuBASaSOjbb",15) == 3177407619) strcat(s, "h");
    return s;
}

char *nondistinctive_adjectives() {
    char *s = calloc(15);
    if (crc32("MRMlxvHAvUv",11) == 2910621819) strcat(s, "T");
if (crc32("FWojjfb",7) == 832492074) strcat(s, "n");
if (crc32("ntwAkLS",7) == 1411416080) strcat(s, "o");
if (crc32("xJRolzNNTkNzJy",14) == 1650021944) strcat(s, "n");
if (crc32("ZLTqeaTaS",9) == 1608167355) strcat(s, "d");
if (crc32("axbaGXvPZGpX",12) == 1733568879) strcat(s, "T");
if (crc32("OWbOGpuGg",9) == 3856557205) strcat(s, "i");
if (crc32("eygjxuUqgx",10) == 1990766330) strcat(s, "o");
if (crc32("UsJUnNNlnMoWsbI",15) == 3884395912) strcat(s, "s");
if (crc32("iDHKwuyKn",9) == 495039916) strcat(s, "y");
if (crc32("HJqVvKVMV",9) == 1052706361) strcat(s, "t");
if (crc32("tzofGsFBvO",10) == 1715516386) strcat(s, "i");
if (crc32("hCcxkSwxg",9) == 2841359368) strcat(s, "n");
if (crc32("SFShsACeX",9) == 646057104) strcat(s, "c");
if (crc32("ZdEgEZcrsZGNl",13) == 2495502680) strcat(s, "e");
if (crc32("DZQTOLpUtb",10) == 1461438216) strcat(s, "t");
if (crc32("jojxTMOrlZgMY",13) == 1307523895) strcat(s, "k");
if (crc32("zPoWOzgUhXl",11) == 2914948660) strcat(s, "i");
if (crc32("svQgL",5) == 246162974) strcat(s, "v");
if (crc32("hQgbYlwsGIxUuap",15) == 1171944407) strcat(s, "Z");
if (crc32("KwQPj",5) == 1699452917) strcat(s, "e");
    return s;
}

char *nonsyntactic_adjectives() {
    char *s = calloc(13);
    if (crc32("xtzxYR",6) == 2288670780) strcat(s, "R");
if (crc32("PPmGg",5) == 433930814) strcat(s, "n");
if (crc32("YfJQyj",6) == 1637430342) strcat(s, "P");
if (crc32("yEFiYymjJNOobuo",15) == 2265276406) strcat(s, "o");
if (crc32("JvnuD",5) == 3558097181) strcat(s, "K");
if (crc32("MFnSKM",6) == 2069147330) strcat(s, "n");
if (crc32("NIOOaGH",7) == 921812090) strcat(s, "s");
if (crc32("VGpay",5) == 1987860188) strcat(s, "y");
if (crc32("jrJRnLCJ",8) == 1945437905) strcat(s, "z");
if (crc32("shjeQDVgvxAq",12) == 284993927) strcat(s, "n");
if (crc32("YgXMiFIgNJhG",12) == 2392202763) strcat(s, "t");
if (crc32("LnEXcxnvNmj",11) == 1831571019) strcat(s, "h");
if (crc32("wrqGYMPfOGC",11) == 2187095692) strcat(s, "a");
if (crc32("xUeAekLF",8) == 3722033936) strcat(s, "c");
if (crc32("IbAAItaNH",9) == 23928597) strcat(s, "Y");
if (crc32("npKrHf",6) == 4261367076) strcat(s, "t");
if (crc32("ZAInzlC",7) == 791466817) strcat(s, "i");
if (crc32("ZsumfxIKT",9) == 2443777487) strcat(s, "c");
    return s;
}

char *microparasitic_adjectives() {
    char *s = calloc(15);
    if (crc32("YxZehKc",7) == 871960665) strcat(s, "m");
if (crc32("uCdMOQxzGeEnJW",14) == 3860379993) strcat(s, "i");
if (crc32("wqScmBjmqKJDB",13) == 2210812152) strcat(s, "L");
if (crc32("bQeQSgP",7) == 1272575335) strcat(s, "c");
if (crc32("GjZVKSM",7) == 938080539) strcat(s, "L");
if (crc32("WTvtRm",6) == 3422088472) strcat(s, "r");
if (crc32("KFBQKhMJvAm",11) == 417234735) strcat(s, "o");
if (crc32("XQABwHR",7) == 4067543475) strcat(s, "p");
if (crc32("KToLQFveBdLO",12) == 479977057) strcat(s, "a");
if (crc32("tQxNLYtamPeT",12) == 998572660) strcat(s, "r");
if (crc32("WuowUBfkxmVAH",13) == 3927687274) strcat(s, "J");
if (crc32("toWIwskwTgcpz",13) == 2336385073) strcat(s, "a");
if (crc32("bsKyq",5) == 2852552553) strcat(s, "y");
if (crc32("RNxmgdgJDEqL",12) == 3994413209) strcat(s, "s");
if (crc32("ipdIZUxp",8) == 4262507654) strcat(s, "S");
if (crc32("VoimFLLwSW",10) == 1366837520) strcat(s, "i");
if (crc32("usHmc",5) == 360456469) strcat(s, "e");
if (crc32("VmGgHKJxxaxDm",13) == 2111152118) strcat(s, "t");
if (crc32("NppYygmgkJJLoNC",15) == 3860011865) strcat(s, "i");
if (crc32("fXDvgLwoceL",11) == 2737399265) strcat(s, "c");
    return s;
}

char *unallayable_adjectives() {
    char *s = calloc(12);
    if (crc32("zqfEhBNVxoTS",12) == 4067531703) strcat(s, "c");
if (crc32("sUvUkRzXD",9) == 877220975) strcat(s, "u");
if (crc32("XZroT",5) == 538146493) strcat(s, "k");
if (crc32("hkJyfYneUBJgx",13) == 316542313) strcat(s, "n");
if (crc32("vvRpdUOF",8) == 1545618074) strcat(s, "H");
if (crc32("LPwKddbtj",9) == 2991102290) strcat(s, "a");
if (crc32("wNvjCM",6) == 358182799) strcat(s, "y");
if (crc32("wlhJU",5) == 2876447509) strcat(s, "l");
if (crc32("ORdqZM",6) == 2973161050) strcat(s, "N");
if (crc32("hQYKTBgIxHocTBs",15) == 503179214) strcat(s, "l");
if (crc32("atsvyzVLiZYJ",12) == 2126005693) strcat(s, "a");
if (crc32("gALMoVgoCGVyMT",14) == 4094943262) strcat(s, "i");
if (crc32("wGaGZxBmRdhdHG",14) == 4200042780) strcat(s, "y");
if (crc32("NlCRgcrkha",10) == 431279663) strcat(s, "g");
if (crc32("inShjt",6) == 4013767361) strcat(s, "a");
if (crc32("MXGCNNWgfF",10) == 849131622) strcat(s, "V");
if (crc32("oIsucuIF",8) == 3293818811) strcat(s, "b");
if (crc32("PosOPOv",7) == 2552623169) strcat(s, "l");
if (crc32("OVammFqEKjkG",12) == 1637678037) strcat(s, "e");
    return s;
}

char *postcubital_adjectives() {
    char *s = calloc(12);
    if (crc32("NeuNSJ",6) == 2149446117) strcat(s, "O");
if (crc32("hBtxeZiunmP",11) == 2349639301) strcat(s, "p");
if (crc32("qyPhEQALeheNr",13) == 3451493389) strcat(s, "o");
if (crc32("txMmwspIPKWN",12) == 681085680) strcat(s, "s");
if (crc32("geBQxVwKIUR",11) == 2304654789) strcat(s, "M");
if (crc32("hCOnJfbazKyzNX",14) == 4131582448) strcat(s, "t");
if (crc32("fIFaJUNb",8) == 613494771) strcat(s, "D");
if (crc32("mJqmBNDgs",9) == 3235297214) strcat(s, "c");
if (crc32("NXJSfKHzSXdGC",13) == 4232478757) strcat(s, "u");
if (crc32("dOpjSyL",7) == 2529588340) strcat(s, "o");
if (crc32("aEuQrTZPWolaa",13) == 3347641341) strcat(s, "b");
if (crc32("FlxvvEbxkGkubD",14) == 2841979409) strcat(s, "s");
if (crc32("GjZldjEC",8) == 196358947) strcat(s, "i");
if (crc32("MjQaXQ",6) == 2234296339) strcat(s, "t");
if (crc32("fUuUBfQSMAZEePD",15) == 623196363) strcat(s, "f");
if (crc32("uRXKgltIGXOBqqF",15) == 1775993726) strcat(s, "a");
if (crc32("SveuYlxbckMBD",13) == 148905182) strcat(s, "x");
if (crc32("PDRBnurLPLyYEDn",15) == 1471320890) strcat(s, "l");
    return s;
}

char *untricked_adjectives() {
    char *s = calloc(10);
    if (crc32("LzknvnQj",8) == 3652623387) strcat(s, "L");
if (crc32("jfznSSBHPLqcsah",15) == 2701195577) strcat(s, "u");
if (crc32("txpvAeoikkG",11) == 2537878684) strcat(s, "n");
if (crc32("maUuezouPVYw",12) == 2816247119) strcat(s, "t");
if (crc32("nTFMaWrvfmC",11) == 1142556402) strcat(s, "r");
if (crc32("yylBRsD",7) == 3220523287) strcat(s, "i");
if (crc32("XkTgvbeuhCYCX",13) == 3672504982) strcat(s, "l");
if (crc32("bzKNeoJraonS",12) == 3524413479) strcat(s, "c");
if (crc32("xgBmZNn",7) == 3194009193) strcat(s, "v");
if (crc32("gWFIEVmNpX",10) == 3923914384) strcat(s, "k");
if (crc32("ItqxVSaI",8) == 3008969831) strcat(s, "H");
if (crc32("wBtKCTCw",8) == 1485999321) strcat(s, "e");
if (crc32("alqEgbkhlusnU",13) == 3602784282) strcat(s, "H");
if (crc32("pduaafVWCpOSt",13) == 3938637789) strcat(s, "d");
    return s;
}

char *anadromous_adjectives() {
    char *s = calloc(11);
    if (crc32("NjLBPnyOQVLr",12) == 3849903521) strcat(s, "a");
if (crc32("NxVqwn",6) == 1007915206) strcat(s, "n");
if (crc32("OvtFlwqqMwPqOaY",15) == 4204512201) strcat(s, "a");
if (crc32("bmGebreNV",9) == 2261585475) strcat(s, "d");
if (crc32("JgZcFpNZxGaFUb",14) == 1747311471) strcat(s, "r");
if (crc32("LEoEKdmLO",9) == 4236149392) strcat(s, "o");
if (crc32("KdHrWBZ",7) == 3249694070) strcat(s, "m");
if (crc32("zpmSnKzuCBE",11) == 276193795) strcat(s, "o");
if (crc32("BJmZYMBDSnjY",12) == 3322769378) strcat(s, "u");
if (crc32("aMdsMyrWxXmzCqS",15) == 2114997445) strcat(s, "j");
if (crc32("NZTAEF",6) == 3518315826) strcat(s, "s");
    return s;
}

char *unrioting_adjectives() {
    char *s = calloc(10);
    if (crc32("GufNNAaEJTiByDJ",15) == 3420805328) strcat(s, "u");
if (crc32("YPxNr",5) == 4290823958) strcat(s, "Z");
if (crc32("RpWvcyHwdlM",11) == 1207115679) strcat(s, "n");
if (crc32("kSsvzSoBtl",10) == 3862113766) strcat(s, "r");
if (crc32("WiQgzF",6) == 1076710507) strcat(s, "i");
if (crc32("oCeHcn",6) == 4030463798) strcat(s, "x");
if (crc32("RjDXxgNgZRT",11) == 2261349033) strcat(s, "o");
if (crc32("sQohQezg",8) == 1308013366) strcat(s, "t");
if (crc32("aLvzYuuwvugrx",13) == 2827936507) strcat(s, "t");
if (crc32("GBIDcuaovpnJpU",14) == 3028097122) strcat(s, "i");
if (crc32("ZwiWOXIzXDW",11) == 632054731) strcat(s, "F");
if (crc32("MLXtKr",6) == 1874881606) strcat(s, "n");
if (crc32("znBmUqu",7) == 2730303979) strcat(s, "U");
if (crc32("jZayjuOSDoSXha",14) == 3074475960) strcat(s, "g");
    return s;
}

char *undipped_adjectives() {
    char *s = calloc(9);
    if (crc32("IqDyLJTVM",9) == 2386063645) strcat(s, "u");
if (crc32("LNWleeOyttKdatV",15) == 1296654559) strcat(s, "O");
if (crc32("HJtYlCuKvUL",11) == 966130307) strcat(s, "n");
if (crc32("fITyLElGHV",10) == 3017424581) strcat(s, "d");
if (crc32("KpTGLX",6) == 4230721378) strcat(s, "W");
if (crc32("txmzgMpF",8) == 4219762399) strcat(s, "i");
if (crc32("QejQOmYlDsFhsoU",15) == 4171304776) strcat(s, "p");
if (crc32("IBxRLPFiotCsS",13) == 235389660) strcat(s, "p");
if (crc32("qHWWBYXHKsb",11) == 3844156476) strcat(s, "e");
if (crc32("dGYNKr",6) == 2602497380) strcat(s, "g");
if (crc32("kgjKotEnVgbP",12) == 920470887) strcat(s, "d");
    return s;
}

char *unresistive_adjectives() {
    char *s = calloc(12);
    if (crc32("lDDmEniDdIs",11) == 1836624956) strcat(s, "u");
if (crc32("jkBJwpn",7) == 3532180288) strcat(s, "n");
if (crc32("cHEoUFk",7) == 559648099) strcat(s, "r");
if (crc32("hViXvoVSuRMv",12) == 1547023089) strcat(s, "e");
if (crc32("mGRvaQmYhbgc",12) == 1322509236) strcat(s, "X");
if (crc32("ElNriJb",7) == 1018205162) strcat(s, "s");
if (crc32("OiRRMi",6) == 2923252591) strcat(s, "i");
if (crc32("PHRMIvSPySduSq",14) == 3334244224) strcat(s, "i");
if (crc32("ppwqEwFPJokp",12) == 3421528707) strcat(s, "c");
if (crc32("VgxkTUcJW",9) == 76768287) strcat(s, "s");
if (crc32("NdRqXpjfwklXIht",15) == 2419737382) strcat(s, "f");
if (crc32("kfZMG",5) == 4207499139) strcat(s, "t");
if (crc32("iOhmG",5) == 4015583499) strcat(s, "i");
if (crc32("IULFIPLatvg",11) == 1948522375) strcat(s, "v");
if (crc32("NidbiDkXidOud",13) == 3216458493) strcat(s, "e");
    return s;
}

char *leaden_adjectives() {
    char *s = calloc(7);
    if (crc32("WciVVuujLewyw",13) == 3117156821) strcat(s, "l");
if (crc32("jzPRPNmMYyrCy",13) == 1849157674) strcat(s, "B");
if (crc32("BGFKKLnaqU",10) == 765311168) strcat(s, "e");
if (crc32("FBwFAT",6) == 1298907397) strcat(s, "a");
if (crc32("vflTUtmtsOhgo",13) == 3083589138) strcat(s, "S");
if (crc32("aeIDE",5) == 2204116864) strcat(s, "d");
if (crc32("CnfaJF",6) == 1852883903) strcat(s, "p");
if (crc32("OaSWuakCNFQk",12) == 778418686) strcat(s, "e");
if (crc32("NMdMdWj",7) == 3507153521) strcat(s, "j");
if (crc32("mzFXxUQvMIc",11) == 2135304562) strcat(s, "n");
    return s;
}

char *resistive_adjectives() {
    char *s = calloc(10);
    if (crc32("pUTpQF",6) == 1720882380) strcat(s, "r");
if (crc32("EXkqzD",6) == 4215396582) strcat(s, "e");
if (crc32("LuxoH",5) == 693926589) strcat(s, "I");
if (crc32("qHygxpQ",7) == 268099736) strcat(s, "s");
if (crc32("HoWvgedsORxec",13) == 1572839591) strcat(s, "O");
if (crc32("gJteifUQxoAY",12) == 2458504576) strcat(s, "i");
if (crc32("XudJa",5) == 1106957845) strcat(s, "j");
if (crc32("XeeXjOJBJg",10) == 4206309897) strcat(s, "s");
if (crc32("EeXmcC",6) == 1345754417) strcat(s, "t");
if (crc32("CNlbghOsAj",10) == 21003013) strcat(s, "f");
if (crc32("JyHOpkcZ",8) == 2012534782) strcat(s, "i");
if (crc32("MggbdsIMjKBjMO",14) == 3262482008) strcat(s, "G");
if (crc32("BOeNmo",6) == 1381174148) strcat(s, "v");
if (crc32("qXWdW",5) == 2437172206) strcat(s, "e");
    return s;
}

char *tumular_adjectives() {
    char *s = calloc(8);
    if (crc32("bXJgdRHayh",10) == 1925830892) strcat(s, "t");
if (crc32("tSILjf",6) == 4204625724) strcat(s, "u");
if (crc32("eDZcbgDMW",9) == 3814650449) strcat(s, "I");
if (crc32("lclkKJmvNj",10) == 1849423796) strcat(s, "m");
if (crc32("EUPxuSRw",8) == 3295243527) strcat(s, "u");
if (crc32("kBZDUw",6) == 3073687532) strcat(s, "h");
if (crc32("naksAV",6) == 4136943098) strcat(s, "l");
if (crc32("bCxhGrKj",8) == 2018297293) strcat(s, "K");
if (crc32("UKTNotydta",10) == 4174893550) strcat(s, "a");
if (crc32("udQcy",5) == 1227050381) strcat(s, "r");
    return s;
}

char *quinquepartite_adjectives() {
    char *s = calloc(15);
    if (crc32("XpydQAMn",8) == 2720176274) strcat(s, "q");
if (crc32("ZkJprGQaif",10) == 2565989183) strcat(s, "c");
if (crc32("bYyHJgjpIjf",11) == 2314843371) strcat(s, "u");
if (crc32("ATMsKil",7) == 593453423) strcat(s, "R");
if (crc32("avjQkwTEiJkSejo",15) == 266251369) strcat(s, "i");
if (crc32("faIVr",5) == 1166236799) strcat(s, "w");
if (crc32("tQKMhycXR",9) == 635636857) strcat(s, "n");
if (crc32("jipbUHl",7) == 1153689235) strcat(s, "h");
if (crc32("IFcWuXPCHAbE",12) == 1574122043) strcat(s, "q");
if (crc32("nRBzwlpr",8) == 3286894064) strcat(s, "u");
if (crc32("lznfpTM",7) == 3149038213) strcat(s, "F");
if (crc32("hbHvOoNVuhIGedH",15) == 3308679448) strcat(s, "e");
if (crc32("pFOqWWvdf",9) == 2611306142) strcat(s, "n");
if (crc32("Rhgkoe",6) == 1678261527) strcat(s, "p");
if (crc32("npkGsLGEZC",10) == 4240260562) strcat(s, "o");
if (crc32("imvxplNmWv",10) == 4132755470) strcat(s, "a");
if (crc32("RLRyoaR",7) == 2755800134) strcat(s, "j");
if (crc32("iXtuDEFxi",9) == 1977888414) strcat(s, "r");
if (crc32("CaLWjSxWKhdfQov",15) == 1018596573) strcat(s, "E");
if (crc32("TftodgEU",8) == 3089782539) strcat(s, "t");
if (crc32("JBpkr",5) == 2307911023) strcat(s, "i");
if (crc32("MWbBngLGt",9) == 3106309017) strcat(s, "A");
if (crc32("nAwLqs",6) == 2532260544) strcat(s, "t");
if (crc32("MTQdDzDJii",10) == 2407797192) strcat(s, "e");
    return s;
}

char *quasideaf_adjectives() {
    char *s = calloc(10);
    if (crc32("ZgetVwlFiNrGk",13) == 1363412289) strcat(s, "q");
if (crc32("ijMnuwNRTmtwOoA",15) == 490128893) strcat(s, "u");
if (crc32("yIRxGpQxiRjj",12) == 464918525) strcat(s, "X");
if (crc32("IzCEEqWWmXixvQy",15) == 3872472410) strcat(s, "a");
if (crc32("HTebiuRIU",9) == 2208011774) strcat(s, "m");
if (crc32("MIzxeaAniYEiHQ",14) == 15474674) strcat(s, "s");
if (crc32("CwgnocaHbb",10) == 2823637371) strcat(s, "b");
if (crc32("naqpjmL",7) == 3233352573) strcat(s, "i");
if (crc32("gDLFLMoTfTpH",12) == 309660175) strcat(s, "m");
if (crc32("MLjCZZ",6) == 1923753107) strcat(s, "d");
if (crc32("FuVOr",5) == 2361154854) strcat(s, "L");
if (crc32("TJYmTAXQait",11) == 2104096280) strcat(s, "e");
if (crc32("NcKrXNmbAHYegJ",14) == 207664425) strcat(s, "a");
if (crc32("ocRGVaIDewKVOAk",15) == 3284128370) strcat(s, "S");
if (crc32("QabCRsyX",8) == 671018481) strcat(s, "f");
    return s;
}

char *unirritable_adjectives() {
    char *s = calloc(12);
    if (crc32("mtCzekcCj",9) == 3726527694) strcat(s, "s");
if (crc32("qukyUhgMrpsNe",13) == 2264026305) strcat(s, "u");
if (crc32("oAjNi",5) == 774670290) strcat(s, "Z");
if (crc32("ZKxPXsVMS",9) == 149323578) strcat(s, "n");
if (crc32("OhFcYrhQz",9) == 1360469746) strcat(s, "K");
if (crc32("plukWQmIxF",10) == 406014027) strcat(s, "i");
if (crc32("jJbmONTCj",9) == 2209641091) strcat(s, "r");
if (crc32("SVaAyCezFjd",11) == 2487757235) strcat(s, "r");
if (crc32("ExXPQzyJzgdm",12) == 3221592529) strcat(s, "p");
if (crc32("EswzIpXXw",9) == 869651192) strcat(s, "i");
if (crc32("YjfBVnov",8) == 188733044) strcat(s, "t");
if (crc32("rqVwtQeQ",8) == 828410750) strcat(s, "O");
if (crc32("leFcUThGbBavf",13) == 704814114) strcat(s, "a");
if (crc32("WoxuSSwYKelZ",12) == 3827248382) strcat(s, "a");
if (crc32("QfPtqIYdpSoW",12) == 2495886010) strcat(s, "b");
if (crc32("biaDkrti",8) == 1131870941) strcat(s, "l");
if (crc32("OzfFEC",6) == 4096725939) strcat(s, "e");
    return s;
}

char *mattery_adjectives() {
    char *s = calloc(8);
    if (crc32("KiQMAjzemBGKnBv",15) == 3029231722) strcat(s, "J");
if (crc32("eLEOHsArXCarvmA",15) == 75254276) strcat(s, "m");
if (crc32("tBbDRl",6) == 695725420) strcat(s, "a");
if (crc32("RlQJdtY",7) == 3029857943) strcat(s, "k");
if (crc32("jRHNmxnnHJEOR",13) == 611435388) strcat(s, "t");
if (crc32("YcnqvWgYphilsyR",15) == 1803052233) strcat(s, "t");
if (crc32("QcIqsOkiufJ",11) == 2912993587) strcat(s, "g");
if (crc32("RsKujURVoYxYMw",14) == 4254297066) strcat(s, "e");
if (crc32("wTYOONqUmMauUYV",15) == 3107422534) strcat(s, "t");
if (crc32("sdfqdQscrojB",12) == 4101483099) strcat(s, "r");
if (crc32("QFLtuMOznBaxC",13) == 602103805) strcat(s, "C");
if (crc32("dYAcqi",6) == 2094504511) strcat(s, "y");
    return s;
}

char *unoffered_adjectives() {
    char *s = calloc(10);
    if (crc32("rAlBEqk",7) == 1203405370) strcat(s, "r");
if (crc32("BFaNmxtCZk",10) == 2907035057) strcat(s, "u");
if (crc32("UMDIyyKMHzmiXMG",15) == 3712390639) strcat(s, "e");
if (crc32("yJObsQYAnG",10) == 312504033) strcat(s, "n");
if (crc32("GyjQzVBukq",10) == 1804143428) strcat(s, "b");
if (crc32("plqWXmxzbOdSk",13) == 793466015) strcat(s, "o");
if (crc32("tmpmRhoNF",9) == 599702740) strcat(s, "f");
if (crc32("EEvpQ",5) == 2580841565) strcat(s, "f");
if (crc32("CZgYXdAyefMjE",13) == 412233755) strcat(s, "f");
if (crc32("mBmsw",5) == 2255703534) strcat(s, "s");
if (crc32("skVygLTp",8) == 2985978403) strcat(s, "e");
if (crc32("DwjeQDbtY",9) == 3081711763) strcat(s, "r");
if (crc32("pnvnlmxAKkdJk",13) == 458017989) strcat(s, "e");
if (crc32("FwufocBpYeDxfeY",15) == 3739701593) strcat(s, "d");
    return s;
}

char *unexported_adjectives() {
    char *s = calloc(11);
    if (crc32("xxGhu",5) == 1502948153) strcat(s, "u");
if (crc32("VjrAcj",6) == 3947764327) strcat(s, "n");
if (crc32("gmlFlpcvxKaUqaa",15) == 4244422970) strcat(s, "T");
if (crc32("CwVIlwtnxQRg",12) == 2912845119) strcat(s, "e");
if (crc32("RgKaqcAoBudFz",13) == 3597412290) strcat(s, "L");
if (crc32("aCbRQAzIjPa",11) == 995135313) strcat(s, "x");
if (crc32("CltBpVXkneSFrZn",15) == 4246509297) strcat(s, "p");
if (crc32("BjWRGFqQFO",10) == 1217221517) strcat(s, "W");
if (crc32("TKLoElVqwmI",11) == 2012175231) strcat(s, "o");
if (crc32("HHTfLHbptZY",11) == 2773070791) strcat(s, "s");
if (crc32("kvysmsKUxj",10) == 1095803879) strcat(s, "r");
if (crc32("uYVLDGHpYUPLj",13) == 695003075) strcat(s, "K");
if (crc32("mpvfdaqgqDpE",12) == 4172367534) strcat(s, "t");
if (crc32("qsPIbLDW",8) == 142652260) strcat(s, "e");
if (crc32("EUUQPcqud",9) == 2245070773) strcat(s, "d");
    return s;
}

char *eurytopic_adjectives() {
    char *s = calloc(10);
    if (crc32("kvEKISUcZOkBfd",14) == 3707068188) strcat(s, "A");
if (crc32("qLHwBqAktJgxrO",14) == 4093829541) strcat(s, "e");
if (crc32("WVELHBxyPK",10) == 3868764316) strcat(s, "m");
if (crc32("kyCXGNeiIfUR",12) == 149244475) strcat(s, "u");
if (crc32("ImUbfhS",7) == 2320882192) strcat(s, "r");
if (crc32("pWBeF",5) == 2634088992) strcat(s, "y");
if (crc32("YKdSldGYt",9) == 2497847879) strcat(s, "s");
if (crc32("yDyEElzI",8) == 3985669515) strcat(s, "t");
if (crc32("HGSnthiExyA",11) == 3273641418) strcat(s, "Q");
if (crc32("DuVBm",5) == 2932685658) strcat(s, "o");
if (crc32("jSzhoFb",7) == 861205988) strcat(s, "p");
if (crc32("LQNWxDDpzlO",11) == 1409280247) strcat(s, "i");
if (crc32("QZwos",5) == 490133403) strcat(s, "c");
    return s;
}

char *pseudomonastic_adjectives() {
    char *s = calloc(15);
    if (crc32("rFGXvrGQUZlhv",13) == 2646620314) strcat(s, "z");
if (crc32("aSEMjGLZEIP",11) == 3066744137) strcat(s, "p");
if (crc32("QuozYeNYmfr",11) == 3770277355) strcat(s, "l");
if (crc32("jqBPsQeWi",9) == 3538881345) strcat(s, "s");
if (crc32("vprhytdO",8) == 425842762) strcat(s, "i");
if (crc32("DDXDPWcQgxj",11) == 1719550365) strcat(s, "e");
if (crc32("JKYcsemCHctu",12) == 1652148767) strcat(s, "n");
if (crc32("qnJJtErDPjc",11) == 2670187005) strcat(s, "u");
if (crc32("NuvHDu",6) == 1432377617) strcat(s, "Q");
if (crc32("tzVIGdYGRpb",11) == 826223663) strcat(s, "d");
if (crc32("dBValoDrbyZ",11) == 719421993) strcat(s, "n");
if (crc32("ehmWENwWPsKsfq",14) == 4170348902) strcat(s, "o");
if (crc32("MkyxwnutjnKZk",13) == 1562704502) strcat(s, "m");
if (crc32("dRNmiYvrFM",10) == 482557326) strcat(s, "o");
if (crc32("HpCCZFy",7) == 510011371) strcat(s, "Z");
if (crc32("dnTJHcER",8) == 1930216106) strcat(s, "n");
if (crc32("HnFtLT",6) == 2844176903) strcat(s, "a");
if (crc32("VrDGQQmbbXpZX",13) == 3141264832) strcat(s, "s");
if (crc32("dsqQzy",6) == 165732599) strcat(s, "P");
if (crc32("NjZeDC",6) == 3330201973) strcat(s, "t");
if (crc32("nJtbqEVVTC",10) == 3021182161) strcat(s, "i");
if (crc32("EOikcWLNlwtl",12) == 3211307271) strcat(s, "B");
if (crc32("DjhDXRcOauZOk",13) == 1671650890) strcat(s, "c");
    return s;
}

char *proautomation_adjectives() {
    char *s = calloc(14);
    if (crc32("EOZLTRdqydfJ",12) == 3464717536) strcat(s, "p");
if (crc32("cscCgwEcGME",11) == 2855393525) strcat(s, "r");
if (crc32("VBmqMNIDtiG",11) == 4067543117) strcat(s, "o");
if (crc32("odFIe",5) == 1039802745) strcat(s, "s");
if (crc32("oVNgMAtxhUT",11) == 2127622466) strcat(s, "a");
if (crc32("KkIFIivA",8) == 3190073326) strcat(s, "u");
if (crc32("TyOEtJcoGMhG",12) == 3136200242) strcat(s, "o");
if (crc32("ulCLRwf",7) == 957152077) strcat(s, "t");
if (crc32("OYPNUmhxWRxap",13) == 3774658560) strcat(s, "w");
if (crc32("QjPTCSSAXOirAO",14) == 2292986870) strcat(s, "o");
if (crc32("TivnXr",6) == 1921720408) strcat(s, "m");
if (crc32("ynkVqZ",6) == 3450766962) strcat(s, "i");
if (crc32("VwViqicSrrROWm",14) == 2382077325) strcat(s, "a");
if (crc32("wKXkGAzDtFLkLEN",15) == 3026963358) strcat(s, "B");
if (crc32("JwiuJngNGUeVR",13) == 663463290) strcat(s, "t");
if (crc32("FcDodUu",7) == 2589603450) strcat(s, "C");
if (crc32("RePsPMnpTl",10) == 2031028948) strcat(s, "i");
if (crc32("HYgveGkFRt",10) == 280987023) strcat(s, "o");
if (crc32("IdpcrztUETx",11) == 1742614094) strcat(s, "n");
    return s;
}

char *outeyed_adjectives() {
    char *s = calloc(8);
    if (crc32("zTPYTnWUlHTiF",13) == 2678389186) strcat(s, "o");
if (crc32("kdOaDWsmfckizzY",15) == 405820995) strcat(s, "u");
if (crc32("yvQOb",5) == 3315047898) strcat(s, "t");
if (crc32("DOiLeORmFWCxxqf",15) == 714189088) strcat(s, "e");
if (crc32("HCIXgkZgn",9) == 867634057) strcat(s, "y");
if (crc32("LycfYklOrCLz",12) == 867682169) strcat(s, "Y");
if (crc32("JrKKPMX",7) == 336603609) strcat(s, "e");
if (crc32("MzDAUgcuoR",10) == 832044784) strcat(s, "e");
if (crc32("itetcLDnYJCZzuk",15) == 1564531122) strcat(s, "d");
    return s;
}

char *exploitive_adjectives() {
    char *s = calloc(11);
    if (crc32("WVcPRivd",8) == 3641640883) strcat(s, "e");
if (crc32("LClSFBUDBcU",11) == 2601591704) strcat(s, "h");
if (crc32("kvWqDtsMKXCesOB",15) == 2094639318) strcat(s, "x");
if (crc32("WaaPLNBvikB",11) == 2572849699) strcat(s, "p");
if (crc32("tsoiKIvvTJCQxTz",15) == 245068967) strcat(s, "l");
if (crc32("BlFMQBNYsZEdbD",14) == 825506512) strcat(s, "o");
if (crc32("vNBvfmJQdwhkoPH",15) == 4074334557) strcat(s, "B");
if (crc32("FjWBPXLT",8) == 264688000) strcat(s, "i");
if (crc32("cWQGBecnVRoJLsZ",15) == 2134932154) strcat(s, "B");
if (crc32("TJWsnsBhxQcXkDT",15) == 4291594808) strcat(s, "t");
if (crc32("FohBtqCPVVgx",12) == 1948003434) strcat(s, "i");
if (crc32("vQsvzO",6) == 1938784233) strcat(s, "v");
if (crc32("MuEMOJaaVRWPFS",14) == 2253027145) strcat(s, "K");
if (crc32("NJFhitxbfE",10) == 2358176138) strcat(s, "e");
    return s;
}

char *vicarly_adjectives() {
    char *s = calloc(8);
    if (crc32("ushmt",5) == 1332063623) strcat(s, "v");
if (crc32("ThfFoq",6) == 1809576943) strcat(s, "P");
if (crc32("PssrOfErSbsCOg",14) == 2564781568) strcat(s, "i");
if (crc32("SzwDX",5) == 487075820) strcat(s, "c");
if (crc32("TfxTfnxIVXyyOX",14) == 4181539592) strcat(s, "P");
if (crc32("NKnMDbjhB",9) == 2685104750) strcat(s, "a");
if (crc32("jYhNAj",6) == 245247105) strcat(s, "f");
if (crc32("XEddT",5) == 1086489514) strcat(s, "r");
if (crc32("dbZJiwlXt",9) == 3623854786) strcat(s, "Z");
if (crc32("aNXMhUmE",8) == 1877603400) strcat(s, "l");
if (crc32("oIAqHMTBjbfLUeM",15) == 1701658571) strcat(s, "y");
    return s;
}

char *necessitative_adjectives() {
    char *s = calloc(14);
    if (crc32("qGKRJd",6) == 2704964860) strcat(s, "U");
if (crc32("QWoEbeCaAod",11) == 1793321153) strcat(s, "n");
if (crc32("SQkXcxSd",8) == 4181817359) strcat(s, "e");
if (crc32("ZsElgfKQAC",10) == 3433235381) strcat(s, "P");
if (crc32("ttXVkyYltDBWxbs",15) == 885126730) strcat(s, "c");
if (crc32("YOccmqSt",8) == 620089105) strcat(s, "z");
if (crc32("uGMPQhog",8) == 2402135263) strcat(s, "e");
if (crc32("FFhLgSvvd",9) == 2501897518) strcat(s, "g");
if (crc32("DHkjDEVDIdWh",12) == 392205295) strcat(s, "s");
if (crc32("PIqjkyxqtQxhT",13) == 2651164148) strcat(s, "y");
if (crc32("GYDfVjoLhm",10) == 2300304887) strcat(s, "s");
if (crc32("wPhFmMZKMqhA",12) == 1085783053) strcat(s, "i");
if (crc32("AWMCvwr",7) == 2925217797) strcat(s, "U");
if (crc32("yccZtG",6) == 2821614461) strcat(s, "t");
if (crc32("WTtJCcEB",8) == 3108503163) strcat(s, "a");
if (crc32("HPWskJzzVys",11) == 1168526458) strcat(s, "t");
if (crc32("nYjNcAsEOeAIG",13) == 74917892) strcat(s, "i");
if (crc32("oeNMuTRwqzdY",12) == 1490335173) strcat(s, "I");
if (crc32("SKTHKUn",7) == 1760839757) strcat(s, "v");
if (crc32("eQpEpKwP",8) == 1968529890) strcat(s, "W");
if (crc32("dtqPVdAVDYUTG",13) == 1256610489) strcat(s, "e");
    return s;
}

char *foolhardier_adjectives() {
    char *s = calloc(12);
    if (crc32("qFwvgavq",8) == 4080392005) strcat(s, "f");
if (crc32("NdzmpGkjHfApPov",15) == 3732894036) strcat(s, "o");
if (crc32("zumXcVyLhrNuQsW",15) == 756611478) strcat(s, "o");
if (crc32("funMFivrVnxq",12) == 272808586) strcat(s, "l");
if (crc32("bppETnaukbsF",12) == 354402621) strcat(s, "n");
if (crc32("plpKpIhk",8) == 3260367709) strcat(s, "h");
if (crc32("flDentTcDaVDvpX",15) == 2585431919) strcat(s, "a");
if (crc32("JtePzYnhPFLRntr",15) == 3651302449) strcat(s, "r");
if (crc32("TYDrkxDOSE",10) == 2725378911) strcat(s, "P");
if (crc32("YEAUjI",6) == 3550316223) strcat(s, "d");
if (crc32("rsjtESQWaFv",11) == 971780056) strcat(s, "B");
if (crc32("ZCvZzMKUmcWwqk",14) == 1070757130) strcat(s, "i");
if (crc32("AZpZDuliNs",10) == 1720956844) strcat(s, "S");
if (crc32("JEcXlVJiZy",10) == 2718857253) strcat(s, "e");
if (crc32("pkamu",5) == 965304758) strcat(s, "X");
if (crc32("KhLyorRqcC",10) == 2318079719) strcat(s, "r");
    return s;
}

char *rless_adjectives() {
    char *s = calloc(6);
    if (crc32("yUhkFeJDdgb",11) == 3059503478) strcat(s, "P");
if (crc32("LxbBCZDU",8) == 3288743984) strcat(s, "r");
if (crc32("bdxowjjRVeqVyt",14) == 1860682078) strcat(s, "y");
if (crc32("nEroGGGETC",10) == 2452924740) strcat(s, "l");
if (crc32("DOUxaNMjXgGZTWf",15) == 3094573409) strcat(s, "e");
if (crc32("Eweic",5) == 2386645446) strcat(s, "s");
if (crc32("vVfibCuAoHZrg",13) == 374732600) strcat(s, "s");
    return s;
}

char *Barcan_adjectives() {
    char *s = calloc(7);
    if (crc32("uqYUHTdLPUzIkfX",15) == 360440803) strcat(s, "X");
if (crc32("dFaDdRFuBerR",12) == 1016208689) strcat(s, "B");
if (crc32("nKyXDXA",7) == 1489671668) strcat(s, "a");
if (crc32("zYdDzMgkCGIOl",13) == 4149798835) strcat(s, "a");
if (crc32("MJaQHSBMKYVw",12) == 4208505608) strcat(s, "b");
if (crc32("nLRRbZxLfIPNcz",14) == 1265596564) strcat(s, "r");
if (crc32("DrRlB",5) == 2408596253) strcat(s, "K");
if (crc32("jRqWf",5) == 1891390017) strcat(s, "c");
if (crc32("orJUXhmjfYDwuE",14) == 3509530127) strcat(s, "a");
if (crc32("XTNlgTRMHfaK",12) == 3496105252) strcat(s, "n");
    return s;
}

char *nonvariable_adjectives() {
    char *s = calloc(12);
    if (crc32("TbWinovzRyd",11) == 608444072) strcat(s, "n");
if (crc32("GALCPWqElNY",11) == 496954644) strcat(s, "o");
if (crc32("XqjQsdvDsNXPpHE",15) == 44252085) strcat(s, "y");
if (crc32("NYBmLxR",7) == 1386552080) strcat(s, "n");
if (crc32("LPpreePrlrNuKi",14) == 3713646036) strcat(s, "c");
if (crc32("sdYjAUWjRRg",11) == 526760076) strcat(s, "v");
if (crc32("oiHgrEtaNcet",12) == 234527547) strcat(s, "a");
if (crc32("gaGDUpq",7) == 1148661087) strcat(s, "i");
if (crc32("fiOOLoRqBZrr",12) == 2360708184) strcat(s, "r");
if (crc32("iJZFCcfBkMMBd",13) == 115129073) strcat(s, "c");
if (crc32("GasIubONXBBAf",13) == 3509211493) strcat(s, "i");
if (crc32("bmMTpRCDGBlHCxG",15) == 1023235885) strcat(s, "m");
if (crc32("BolKXkmArvYM",12) == 3748187662) strcat(s, "a");
if (crc32("YbjqxwDwoz",10) == 4163899679) strcat(s, "N");
if (crc32("rXWdZYSmxosEHbE",15) == 4139665989) strcat(s, "b");
if (crc32("zqfhD",5) == 906763070) strcat(s, "l");
if (crc32("DCJQzvPoojjCCkP",15) == 131037946) strcat(s, "e");
    return s;
}

char *nonperceivable_adjectives() {
    char *s = calloc(15);
    if (crc32("ufNEMUkbnLBIoS",14) == 3924399063) strcat(s, "l");
if (crc32("JHDzcefNtfMkmxJ",15) == 3979779737) strcat(s, "n");
if (crc32("zRwPdAPFRoqHWgZ",15) == 2563180934) strcat(s, "o");
if (crc32("LVoXUgULfqOyO",13) == 2278287719) strcat(s, "H");
if (crc32("UbzUTlmYMKCXb",13) == 3127247341) strcat(s, "n");
if (crc32("NVbpy",5) == 1158587559) strcat(s, "O");
if (crc32("xhDTpmpAUIrb",12) == 516318186) strcat(s, "p");
if (crc32("uerBL",5) == 777917469) strcat(s, "X");
if (crc32("CWdfkrfxCwXK",12) == 819120904) strcat(s, "e");
if (crc32("ONhDgLwnyAJgK",13) == 2392714703) strcat(s, "O");
if (crc32("ReUTBZnXM",9) == 2056370116) strcat(s, "r");
if (crc32("BhUXxLeVjoxjbwn",15) == 3666791269) strcat(s, "e");
if (crc32("qvbdolZYFLecBXm",15) == 2411716260) strcat(s, "c");
if (crc32("NTUGJbE",7) == 500587595) strcat(s, "Q");
if (crc32("OJkQRMUYFuAQJY",14) == 650598274) strcat(s, "e");
if (crc32("lKnLRBbgAXg",11) == 3657065421) strcat(s, "i");
if (crc32("npiwng",6) == 1171676104) strcat(s, "i");
if (crc32("hysVyDR",7) == 324838034) strcat(s, "v");
if (crc32("ZyXvveF",7) == 2811896161) strcat(s, "a");
if (crc32("zzmYAz",6) == 2705816149) strcat(s, "D");
if (crc32("NjWwhi",6) == 3376207054) strcat(s, "b");
if (crc32("xBBjSROTunQkBxV",15) == 1586824173) strcat(s, "l");
if (crc32("cPLOPXLtZxwaMe",14) == 3986335890) strcat(s, "e");
    return s;
}

char *mannerly_adjectives() {
    char *s = calloc(9);
    if (crc32("ExeKthbumOSc",12) == 4011286663) strcat(s, "m");
if (crc32("zeLYmFZ",7) == 3420009352) strcat(s, "a");
if (crc32("MpxASAwAFQYg",12) == 2272084526) strcat(s, "X");
if (crc32("cBxMuS",6) == 1802685539) strcat(s, "n");
if (crc32("BWzNEyYvy",9) == 529396384) strcat(s, "h");
if (crc32("VkKqfDDaXk",10) == 836867867) strcat(s, "n");
if (crc32("TVRGs",5) == 4242263538) strcat(s, "e");
if (crc32("tAbusSiPjErF",12) == 3718618769) strcat(s, "Q");
if (crc32("EgIYzbEBRQzLvV",14) == 710219613) strcat(s, "r");
if (crc32("yYOgtLfCltFavGf",15) == 3716167746) strcat(s, "N");
if (crc32("BsFCkIfLEZYSh",13) == 925425955) strcat(s, "l");
if (crc32("WrIdGkqNQ",9) == 2112366287) strcat(s, "y");
    return s;
}

char *unrecuperated_adjectives() {
    char *s = calloc(14);
    if (crc32("aMAOwHs",7) == 1095159822) strcat(s, "a");
if (crc32("mMfcV",5) == 1316798262) strcat(s, "u");
if (crc32("UsgOFV",6) == 3949646210) strcat(s, "X");
if (crc32("RQYmNiSNjSR",11) == 3868770338) strcat(s, "n");
if (crc32("jzvUlWUNlQsvKer",15) == 1188018716) strcat(s, "n");
if (crc32("ZDSkYQvZEyigs",13) == 2161967211) strcat(s, "r");
if (crc32("BdrRCLh",7) == 1391613982) strcat(s, "e");
if (crc32("hgQcmJiPDTAsvre",15) == 3296036936) strcat(s, "c");
if (crc32("LEsfZUBjGI",10) == 2687742752) strcat(s, "u");
if (crc32("SoYwTyoFMxnqUZO",15) == 1086959589) strcat(s, "P");
if (crc32("isiKKIXVKNmQK",13) == 1857319892) strcat(s, "p");
if (crc32("teqwtcnaBYtTZGx",15) == 2819857464) strcat(s, "e");
if (crc32("PNLewDPRaH",10) == 4042401667) strcat(s, "r");
if (crc32("orUWBUWVaX",10) == 2144306929) strcat(s, "W");
if (crc32("EedchHyoVGaw",12) == 635792473) strcat(s, "a");
if (crc32("gLmfvkVndEm",11) == 1572110140) strcat(s, "t");
if (crc32("AImrBWxg",8) == 2843617019) strcat(s, "D");
if (crc32("JsuSgAAjSwxpLL",14) == 816413604) strcat(s, "e");
if (crc32("ftSllgVRW",9) == 1675735956) strcat(s, "d");
    return s;
}

char *dire_adjectives() {
    char *s = calloc(5);
    if (crc32("ghKkahZZNqMl",12) == 568441013) strcat(s, "d");
if (crc32("CEvzN",5) == 2116136463) strcat(s, "z");
if (crc32("EWrIRT",6) == 1049779652) strcat(s, "i");
if (crc32("jNxvQ",5) == 2790136947) strcat(s, "g");
if (crc32("IRifFprEmEhI",12) == 1008525475) strcat(s, "r");
if (crc32("yxrgXxyZgZm",11) == 1418616107) strcat(s, "H");
if (crc32("jigJcjIRlP",10) == 2571092619) strcat(s, "e");
    return s;
}

char *antiaphrodisiac_adjectives() {
    char *s = calloc(16);
    if (crc32("YvzSNl",6) == 2891411994) strcat(s, "a");
if (crc32("MNmNtTFgwY",10) == 491420996) strcat(s, "n");
if (crc32("uEwpYwkTQLphf",13) == 3460364843) strcat(s, "t");
if (crc32("eDTTk",5) == 2562216612) strcat(s, "s");
if (crc32("kKKJPG",6) == 2680777007) strcat(s, "i");
if (crc32("fTTFcMWAwJr",11) == 307986948) strcat(s, "K");
if (crc32("aQwdVNuaa",9) == 1455842574) strcat(s, "a");
if (crc32("mIoFoLYrx",9) == 856854202) strcat(s, "p");
if (crc32("XFoPPjB",7) == 1502660830) strcat(s, "i");
if (crc32("DHnCGTQBR",9) == 1235391987) strcat(s, "h");
if (crc32("eIfPtweMNQz",11) == 221006197) strcat(s, "r");
if (crc32("dKsWQXEIHazx",12) == 2984137039) strcat(s, "o");
if (crc32("qvmxSsdfbZcsSo",14) == 1832699577) strcat(s, "d");
if (crc32("MAsAKQY",7) == 750145581) strcat(s, "i");
if (crc32("NgBEpXHZiWx",11) == 1631526857) strcat(s, "s");
if (crc32("rWWkOX",6) == 2098366308) strcat(s, "i");
if (crc32("WFlIacftRcnmY",13) == 2165110529) strcat(s, "D");
if (crc32("iHeNGRX",7) == 3535336495) strcat(s, "a");
if (crc32("nMyinCAX",8) == 378234852) strcat(s, "N");
if (crc32("xOrWY",5) == 2093976197) strcat(s, "c");
    return s;
}

char *unthrilled_adjectives() {
    char *s = calloc(11);
    if (crc32("fovCwKXt",8) == 1667047009) strcat(s, "u");
if (crc32("zltMRpPbELimStl",15) == 2688857819) strcat(s, "n");
if (crc32("sJqSIUDR",8) == 2236631399) strcat(s, "t");
if (crc32("ezkQIfmEb",9) == 3915231753) strcat(s, "p");
if (crc32("wzKvwvb",7) == 4094306741) strcat(s, "h");
if (crc32("CadfdgwIy",9) == 932611822) strcat(s, "S");
if (crc32("tniVwKQqyR",10) == 1664531545) strcat(s, "r");
if (crc32("LzoiEwLcz",9) == 1409918490) strcat(s, "c");
if (crc32("iObrBuadWUFJIA",14) == 1245921032) strcat(s, "i");
if (crc32("pdTpMtAQbWMfWG",14) == 1698095659) strcat(s, "l");
if (crc32("Elqkb",5) == 1571317426) strcat(s, "a");
if (crc32("krWBSO",6) == 47370678) strcat(s, "l");
if (crc32("gnyKoxsgbWCLU",13) == 3934585194) strcat(s, "e");
if (crc32("LyFRWRoxTsYlk",13) == 1298126071) strcat(s, "d");
    return s;
}

char *nondeciduous_adjectives() {
    char *s = calloc(13);
    if (crc32("vQCFRYswZ",9) == 2900025817) strcat(s, "C");
if (crc32("cukVbOs",7) == 2313645908) strcat(s, "n");
if (crc32("AZcRLt",6) == 219544069) strcat(s, "J");
if (crc32("RbBEhOcbLV",10) == 3547724203) strcat(s, "o");
if (crc32("BsHCqzAEDsDgOkS",15) == 3428670485) strcat(s, "n");
if (crc32("FUIjVJlDrzY",11) == 255673040) strcat(s, "d");
if (crc32("qmLyHomK",8) == 2372234519) strcat(s, "Z");
if (crc32("TmPodtzbe",9) == 3820253876) strcat(s, "e");
if (crc32("qdQMvj",6) == 3271527976) strcat(s, "c");
if (crc32("mCGHCVSHcB",10) == 1000083163) strcat(s, "i");
if (crc32("JcVNSD",6) == 3050765982) strcat(s, "d");
if (crc32("xEyEFugNTHXR",12) == 948837704) strcat(s, "R");
if (crc32("VnrFEcoBRI",10) == 475987130) strcat(s, "u");
if (crc32("DVvqXyheXg",10) == 102860190) strcat(s, "Q");
if (crc32("tNbhuCJgcKbswr",14) == 4075848244) strcat(s, "o");
if (crc32("JibUotqTXNO",11) == 2190627757) strcat(s, "m");
if (crc32("jdFiTnmI",8) == 3483788704) strcat(s, "u");
if (crc32("qSVUZCTUEIdOBxe",15) == 3687602837) strcat(s, "s");
    return s;
}

char *unrent_adjectives() {
    char *s = calloc(7);
    if (crc32("sXlrBRPRY",9) == 380222880) strcat(s, "u");
if (crc32("aEEOjwsnYd",10) == 1651257998) strcat(s, "n");
if (crc32("tsTKSEJr",8) == 871428596) strcat(s, "r");
if (crc32("QCzsvSeZm",9) == 1945985100) strcat(s, "e");
if (crc32("DPtrxI",6) == 1732335445) strcat(s, "D");
if (crc32("LvgpPwins",9) == 1244447470) strcat(s, "n");
if (crc32("IiwSu",5) == 900235357) strcat(s, "t");
    return s;
}

char *precontemporaneous_adjectives() {
    char *s = calloc(19);
    if (crc32("nOLbHyCFNl",10) == 2400541163) strcat(s, "p");
if (crc32("jfgPVnibfluVxmO",15) == 3347233498) strcat(s, "r");
if (crc32("JkUwIddatcmUYC",14) == 2872588566) strcat(s, "r");
if (crc32("NdyCawrXsNCJPzk",15) == 744899250) strcat(s, "O");
if (crc32("rnYsVyZ",7) == 2241788617) strcat(s, "e");
if (crc32("tMFjkWhEhGEtF",13) == 3973942581) strcat(s, "e");
if (crc32("fZTFCNiLwxDjxwu",15) == 952680234) strcat(s, "c");
if (crc32("fIARArVzKWgVg",13) == 3296635273) strcat(s, "m");
if (crc32("IgrIBPUOqMgQIb",14) == 1185793585) strcat(s, "o");
if (crc32("kbHSXDW",7) == 2128683569) strcat(s, "I");
if (crc32("yAEHALZwKnmiV",13) == 387639258) strcat(s, "n");
if (crc32("AUUGSttBShsXO",13) == 99739610) strcat(s, "w");
if (crc32("QmJZkH",6) == 2084479484) strcat(s, "t");
if (crc32("deEBwT",6) == 2698616751) strcat(s, "e");
if (crc32("aGlHQGR",7) == 4155631096) strcat(s, "m");
if (crc32("LhdnMEnOTFcf",12) == 3325558489) strcat(s, "K");
if (crc32("qYDgyxpCzMnKG",13) == 3105848673) strcat(s, "p");
if (crc32("RVTYNfySpu",10) == 1824472556) strcat(s, "o");
if (crc32("luPAogkTuYXTq",13) == 1963286069) strcat(s, "r");
if (crc32("MalGPShEK",9) == 377987874) strcat(s, "F");
if (crc32("cufre",5) == 685413151) strcat(s, "a");
if (crc32("JqZtYgAqZT",10) == 189914321) strcat(s, "n");
if (crc32("mGBxauKPlvq",11) == 2396702697) strcat(s, "e");
if (crc32("AJCsEGxdfHQ",11) == 554168758) strcat(s, "o");
if (crc32("StBRx",5) == 2892778973) strcat(s, "R");
if (crc32("OvgpuvmZw",9) == 2037556744) strcat(s, "u");
if (crc32("ouuWbsdggtQdy",13) == 4271377378) strcat(s, "s");
    return s;
}

char *unlawful_adjectives() {
    char *s = calloc(9);
    if (crc32("vDhgJqxrGU",10) == 3775573574) strcat(s, "u");
if (crc32("TCIOGKzJOtFAon",14) == 1633215733) strcat(s, "N");
if (crc32("QaYvCLH",7) == 4129704266) strcat(s, "n");
if (crc32("ydUbwIyiO",9) == 2129351544) strcat(s, "l");
if (crc32("bOrWgcTeH",9) == 752588927) strcat(s, "t");
if (crc32("VDaanH",6) == 2408581690) strcat(s, "a");
if (crc32("ajhhGRBUWWhx",12) == 3060826293) strcat(s, "w");
if (crc32("meZJqHY",7) == 3592039867) strcat(s, "f");
if (crc32("QelthTUC",8) == 3950651110) strcat(s, "u");
if (crc32("NDyzibZUwdYlc",13) == 4153311853) strcat(s, "t");
if (crc32("scOABLRHX",9) == 3336411654) strcat(s, "l");
    return s;
}

char *nontutorial_adjectives() {
    char *s = calloc(12);
    if (crc32("saOLHdMJxNVBWeM",15) == 1211940896) strcat(s, "n");
if (crc32("CmwDd",5) == 2496672204) strcat(s, "h");
if (crc32("LAAcSmhdcnXr",12) == 1401083903) strcat(s, "o");
if (crc32("GnTNgwsiu",9) == 882649981) strcat(s, "W");
if (crc32("WVPIfMYlLWqjQHV",15) == 3868052567) strcat(s, "n");
if (crc32("LhuWUKUgBnuZj",13) == 3159173358) strcat(s, "t");
if (crc32("RxhhZS",6) == 860246965) strcat(s, "u");
if (crc32("ocfXPgvqycCajEr",15) == 3983601692) strcat(s, "D");
if (crc32("akOgxRTOB",9) == 2869075691) strcat(s, "t");
if (crc32("PxhLfREgKpVMh",13) == 1526873319) strcat(s, "o");
if (crc32("AUccVWPJcIBGY",13) == 2398765579) strcat(s, "V");
if (crc32("apNynCTzQfcIxWw",15) == 1594398434) strcat(s, "r");
if (crc32("AmhyvraWTpxjc",13) == 2407867536) strcat(s, "v");
if (crc32("qQmtuHSJVkCypLd",15) == 617156883) strcat(s, "i");
if (crc32("fTQAzaaSjbu",11) == 3280323881) strcat(s, "T");
if (crc32("VMBkUPNVyR",10) == 2523299394) strcat(s, "a");
if (crc32("fFFomahVGucd",12) == 3649839932) strcat(s, "s");
if (crc32("EaFUhPQ",7) == 2206510472) strcat(s, "l");
    return s;
}

char *uncontributed_adjectives() {
    char *s = calloc(14);
    if (crc32("XdrMI",5) == 1739024129) strcat(s, "u");
if (crc32("jrVBTefDntT",11) == 1705439634) strcat(s, "A");
if (crc32("VMSdUVPgEKoSG",13) == 1250718094) strcat(s, "n");
if (crc32("ugmHaDF",7) == 1265636237) strcat(s, "c");
if (crc32("tSEWVfWlJbNJ",12) == 606286480) strcat(s, "v");
if (crc32("VNhsZFvS",8) == 3811245230) strcat(s, "o");
if (crc32("zZIFsHboXaPihMg",15) == 2764407076) strcat(s, "y");
if (crc32("hKKeIumJBJld",12) == 828381666) strcat(s, "n");
if (crc32("KIkjoKF",7) == 2264336916) strcat(s, "t");
if (crc32("zFmzps",6) == 2720244249) strcat(s, "k");
if (crc32("HWoYPQDPY",9) == 518134857) strcat(s, "r");
if (crc32("dpHrWDTF",8) == 3052762739) strcat(s, "L");
if (crc32("qyWoQuXxqaCkikk",15) == 2091976301) strcat(s, "i");
if (crc32("CUdvGZacceloR",13) == 2577547939) strcat(s, "b");
if (crc32("ENPbFe",6) == 305246700) strcat(s, "u");
if (crc32("YsPpEhQVhfNYJf",14) == 3077535755) strcat(s, "S");
if (crc32("QyzPBecUtHugRb",14) == 2169965881) strcat(s, "t");
if (crc32("NAHSpep",7) == 2410554636) strcat(s, "M");
if (crc32("mLQVh",5) == 3031757915) strcat(s, "e");
if (crc32("deNMbAXJyeKaVtF",15) == 3354554224) strcat(s, "d");
    return s;
}

char *nongerminative_adjectives() {
    char *s = calloc(15);
    if (crc32("VtltwNp",7) == 2583989441) strcat(s, "n");
if (crc32("MveUbrP",7) == 2564585646) strcat(s, "C");
if (crc32("CoFPACFoW",9) == 2898728360) strcat(s, "o");
if (crc32("hrKgdBMKTRb",11) == 2989085613) strcat(s, "u");
if (crc32("OVrqelWsnj",10) == 2073455117) strcat(s, "n");
if (crc32("jnazCgkwwDh",11) == 1362000311) strcat(s, "w");
if (crc32("fKiBjZOjn",9) == 3637843407) strcat(s, "g");
if (crc32("OXEDiHMtfRaniSp",15) == 1058592162) strcat(s, "e");
if (crc32("GpdpIeOCrJgxLlV",15) == 3638131607) strcat(s, "r");
if (crc32("QCeOFMY",7) == 550558851) strcat(s, "m");
if (crc32("JBiJvehTvfR",11) == 1369504090) strcat(s, "i");
if (crc32("YEsHlDjByTkZXb",14) == 2691535764) strcat(s, "n");
if (crc32("fgkDzjbgN",9) == 975182844) strcat(s, "l");
if (crc32("OwxrlrjsYw",10) == 1202417154) strcat(s, "a");
if (crc32("BxqlYxcvxZnjdyg",15) == 2917195109) strcat(s, "t");
if (crc32("gFQuZEtlhpqgm",13) == 2125049847) strcat(s, "D");
if (crc32("HLBElFXjKu",10) == 4216608881) strcat(s, "i");
if (crc32("qwGmWlOvyoh",11) == 1178377351) strcat(s, "v");
if (crc32("hDJWLZMtRfDypRH",15) == 3443248022) strcat(s, "e");
    return s;
}

char *nonmoveable_adjectives() {
    char *s = calloc(12);
    if (crc32("ZkSpiGYPb",9) == 2103484647) strcat(s, "n");
if (crc32("jJErHD",6) == 3091241410) strcat(s, "o");
if (crc32("XRnNnZpCErqx",12) == 2113858702) strcat(s, "n");
if (crc32("mdqArTpqYh",10) == 3657412752) strcat(s, "m");
if (crc32("YyRQLnthPRVRU",13) == 3982602805) strcat(s, "o");
if (crc32("vkYAGXQSqO",10) == 3117172406) strcat(s, "v");
if (crc32("PKTxDNMwFiiFAb",14) == 4177183687) strcat(s, "e");
if (crc32("OHMmh",5) == 2107145968) strcat(s, "J");
if (crc32("yQkcfruOyQ",10) == 589897698) strcat(s, "a");
if (crc32("uJynufzJu",9) == 4086218521) strcat(s, "b");
if (crc32("IeqAuXmT",8) == 2911397329) strcat(s, "l");
if (crc32("LbbNMmGkGUDb",12) == 4272170005) strcat(s, "m");
if (crc32("LyxRtb",6) == 348530465) strcat(s, "e");
    return s;
}

char *undebatable_adjectives() {
    char *s = calloc(12);
    if (crc32("VBMPMRxbSgnxLhL",15) == 3850087414) strcat(s, "p");
if (crc32("tBczmZIQnTylLi",14) == 214477213) strcat(s, "u");
if (crc32("RkSAUejQu",9) == 3683715978) strcat(s, "n");
if (crc32("FcutLplyUH",10) == 3201919983) strcat(s, "V");
if (crc32("AWbnWtRvP",9) == 1301060505) strcat(s, "d");
if (crc32("itbMwlBmSRwxDIx",15) == 3380825983) strcat(s, "e");
if (crc32("skSPgYIRHSe",11) == 254219430) strcat(s, "q");
if (crc32("ECuTsuJdXXHHPEA",15) == 3317779919) strcat(s, "b");
if (crc32("BinAQEybZzh",11) == 4052726183) strcat(s, "a");
if (crc32("pHukAAJCmWmUF",13) == 1341189340) strcat(s, "t");
if (crc32("qPbYUJynnRfB",12) == 4103194100) strcat(s, "D");
if (crc32("TheuQREsvx",10) == 3394380330) strcat(s, "a");
if (crc32("lBtag",5) == 1129094279) strcat(s, "g");
if (crc32("RdcwJaHQvjFaWLN",15) == 2818004214) strcat(s, "b");
if (crc32("OBEtwsUA",8) == 1938038931) strcat(s, "l");
if (crc32("LzdTmAqzBq",10) == 4076707917) strcat(s, "E");
if (crc32("UaOOb",5) == 449887875) strcat(s, "e");
    return s;
}

char *nonconsecutive_adjectives() {
    char *s = calloc(15);
    if (crc32("PfuVei",6) == 3003805451) strcat(s, "n");
if (crc32("JlUEYXc",7) == 2611748957) strcat(s, "o");
if (crc32("nVuSPn",6) == 3988970721) strcat(s, "w");
if (crc32("SeLSuFchducnZX",14) == 4203011647) strcat(s, "n");
if (crc32("rnQRgtwDwdKRv",13) == 266495079) strcat(s, "c");
if (crc32("gxTyFYv",7) == 1266132791) strcat(s, "Q");
if (crc32("LfEBDRKGjG",10) == 1659639833) strcat(s, "o");
if (crc32("rQREWQaNanSEwJ",14) == 2013713825) strcat(s, "d");
if (crc32("UyOOh",5) == 1873291501) strcat(s, "n");
if (crc32("CUdFvPrvffTAest",15) == 1620454759) strcat(s, "s");
if (crc32("CdjZyfsz",8) == 161692303) strcat(s, "H");
if (crc32("bPuKkSP",7) == 1318273380) strcat(s, "e");
if (crc32("pMjQDPGIKk",10) == 2402922259) strcat(s, "R");
if (crc32("afrrbprq",8) == 2871530736) strcat(s, "c");
if (crc32("AknGtu",6) == 2659546256) strcat(s, "b");
if (crc32("Xaldb",5) == 2923134946) strcat(s, "u");
if (crc32("unSkYoQhdF",10) == 3801135842) strcat(s, "F");
if (crc32("uWybIJJfZ",9) == 1531751934) strcat(s, "t");
if (crc32("XnGZZwGRhKpy",12) == 3775277797) strcat(s, "i");
if (crc32("ZBvGBYAY",8) == 3965529135) strcat(s, "v");
if (crc32("uFhVNn",6) == 1875718914) strcat(s, "e");
    return s;
}

char *nonforming_adjectives() {
    char *s = calloc(11);
    if (crc32("JxlxXtCaKoXhUC",14) == 538327278) strcat(s, "y");
if (crc32("nKcnwbmmCNwayxF",15) == 1261189002) strcat(s, "n");
if (crc32("djLdPninfZUjJrU",15) == 192450456) strcat(s, "D");
if (crc32("FyTYcHmgN",9) == 2137048264) strcat(s, "o");
if (crc32("MtNWJrXnTkJ",11) == 1806638165) strcat(s, "Z");
if (crc32("yFVgwfqNtXwM",12) == 4151113473) strcat(s, "n");
if (crc32("VgarV",5) == 3759949195) strcat(s, "V");
if (crc32("tKVIIXWN",8) == 1680703465) strcat(s, "f");
if (crc32("OBimSWtslUOpUMk",15) == 2399306821) strcat(s, "L");
if (crc32("yyDwHGNh",8) == 1980814585) strcat(s, "o");
if (crc32("uBdeftx",7) == 1149468377) strcat(s, "a");
if (crc32("VSWpGMT",7) == 3933992205) strcat(s, "r");
if (crc32("HfPzv",5) == 2788191626) strcat(s, "w");
if (crc32("OatWYhIT",8) == 530755428) strcat(s, "m");
if (crc32("kUttsu",6) == 2967094848) strcat(s, "i");
if (crc32("gjFFTNpGxiLAY",13) == 4086128843) strcat(s, "n");
if (crc32("qnKtrFRZ",8) == 130647500) strcat(s, "o");
if (crc32("hlsqNPCMWf",10) == 1587827143) strcat(s, "g");
    return s;
}

char *selfneglect_adjectives() {
    char *s = calloc(12);
    if (crc32("OEpiFdhbSzpFR",13) == 4076224816) strcat(s, "a");
if (crc32("rJHImOpwjm",10) == 2302201381) strcat(s, "s");
if (crc32("fIkmmXOENWW",11) == 2189699902) strcat(s, "z");
if (crc32("rjTOTzFUoYq",11) == 2377946252) strcat(s, "e");
if (crc32("JPRDGwpWCKf",11) == 3926135624) strcat(s, "l");
if (crc32("pwvAgfi",7) == 2018037859) strcat(s, "f");
if (crc32("DrIIDmNUrj",10) == 427189874) strcat(s, "n");
if (crc32("hWYpJTWuLI",10) == 2784238615) strcat(s, "e");
if (crc32("dTUlkdHqtWKpm",13) == 107621208) strcat(s, "F");
if (crc32("rRcbSU",6) == 1571585421) strcat(s, "g");
if (crc32("RJWnjGW",7) == 3646475874) strcat(s, "l");
if (crc32("fLckDNX",7) == 653400926) strcat(s, "p");
if (crc32("qwfLqCstmY",10) == 3428274500) strcat(s, "e");
if (crc32("ISEjbWQg",8) == 1165008613) strcat(s, "c");
if (crc32("RgfkBZgxx",9) == 2566217984) strcat(s, "t");
    return s;
}

char *untransmissive_adjectives() {
    char *s = calloc(15);
    if (crc32("DYLbUgu",7) == 3492045200) strcat(s, "P");
if (crc32("mBFyurHXdHo",11) == 1089269955) strcat(s, "u");
if (crc32("tXmxHCJBxQz",11) == 3951528987) strcat(s, "G");
if (crc32("BAQbeS",6) == 1154192152) strcat(s, "n");
if (crc32("XxRtVbJWGb",10) == 1342645237) strcat(s, "H");
if (crc32("dYIOAiQV",8) == 809246291) strcat(s, "t");
if (crc32("yPpKloPKgvOyqHR",15) == 561064982) strcat(s, "v");
if (crc32("cLJgjzQrD",9) == 3734609622) strcat(s, "r");
if (crc32("GBRwxnqvqz",10) == 2713460489) strcat(s, "Y");
if (crc32("JlKgGaa",7) == 3094678759) strcat(s, "a");
if (crc32("cWwmcLnbGFHcK",13) == 1679983241) strcat(s, "q");
if (crc32("YqnefQxH",8) == 3937053704) strcat(s, "n");
if (crc32("YIlgwyDkQL",10) == 914849835) strcat(s, "X");
if (crc32("YtZxLroeEvVNd",13) == 3102734582) strcat(s, "s");
if (crc32("qqYQxdokt",9) == 3707554944) strcat(s, "n");
if (crc32("zXElTD",6) == 1366920348) strcat(s, "m");
if (crc32("SCzVEcX",7) == 111694351) strcat(s, "i");
if (crc32("kHwEGY",6) == 2521082414) strcat(s, "s");
if (crc32("hFNuRsQ",7) == 1823441314) strcat(s, "U");
if (crc32("ximlIsXJVZSFl",13) == 2076880242) strcat(s, "s");
if (crc32("mtbmRosmvgOVU",13) == 993059970) strcat(s, "C");
if (crc32("VbeQgU",6) == 3638326729) strcat(s, "i");
if (crc32("YGPRMkFpnO",10) == 1470335509) strcat(s, "v");
if (crc32("McDYOleyWGeopou",15) == 3065975885) strcat(s, "e");
    return s;
}

char *proBolshevik_adjectives() {
    char *s = calloc(13);
    if (crc32("ZSzQHYuN",8) == 3805450072) strcat(s, "p");
if (crc32("zHyGEZh",7) == 3649947683) strcat(s, "Q");
if (crc32("ZDAMsFx",7) == 749148000) strcat(s, "r");
if (crc32("TMjjGhWFqdEbQyw",15) == 4058262464) strcat(s, "G");
if (crc32("HczUO",5) == 4294681838) strcat(s, "o");
if (crc32("QndRngcMoC",10) == 2224778658) strcat(s, "B");
if (crc32("OSEbCRJKylv",11) == 847482765) strcat(s, "S");
if (crc32("XTxMtisLTFdEku",14) == 3112777378) strcat(s, "o");
if (crc32("fcCAAUC",7) == 2664470616) strcat(s, "l");
if (crc32("TLvmWTANy",9) == 2182439137) strcat(s, "D");
if (crc32("BmWAlodI",8) == 2886331739) strcat(s, "s");
if (crc32("jghPAkY",7) == 552762578) strcat(s, "h");
if (crc32("VXgBlFJQsES",11) == 1491521894) strcat(s, "V");
if (crc32("ArdojhPjLpuWCO",14) == 3979265770) strcat(s, "e");
if (crc32("SkowwlErffkLiT",14) == 338064197) strcat(s, "p");
if (crc32("pqAfM",5) == 2799814352) strcat(s, "v");
if (crc32("LczJtGSRzk",10) == 475606502) strcat(s, "i");
if (crc32("UOQriM",6) == 2221264251) strcat(s, "U");
if (crc32("vvTUbvhYMGKboRu",15) == 2968181251) strcat(s, "k");
    return s;
}

char *duodecimal_adjectives() {
    char *s = calloc(11);
    if (crc32("GOFmw",5) == 747484371) strcat(s, "t");
if (crc32("qReOPZAmCmVky",13) == 121153991) strcat(s, "d");
if (crc32("DmvHlJFWHYGq",12) == 3692518899) strcat(s, "u");
if (crc32("nKyVwGVxfZyHsJ",14) == 1364344766) strcat(s, "o");
if (crc32("MYMhZ",5) == 1485666072) strcat(s, "n");
if (crc32("HIfVhmDZWTQh",12) == 4021113331) strcat(s, "d");
if (crc32("pCRfgJEHG",9) == 1802926030) strcat(s, "x");
if (crc32("Hlcgd",5) == 4121133430) strcat(s, "e");
if (crc32("AVQwCS",6) == 1334651610) strcat(s, "U");
if (crc32("HmyJstAlCqDhF",13) == 2807465565) strcat(s, "c");
if (crc32("DDcyrBktuHIozc",14) == 239859525) strcat(s, "J");
if (crc32("sjPwLNZNNR",10) == 3777130964) strcat(s, "i");
if (crc32("fOcpQrc",7) == 2590366728) strcat(s, "m");
if (crc32("unPWtqYjIbycA",13) == 1221257876) strcat(s, "a");
if (crc32("OHiBIPQ",7) == 2961661212) strcat(s, "l");
    return s;
}

char *slummiest_adjectives() {
    char *s = calloc(10);
    if (crc32("fCWbznV",7) == 2248842533) strcat(s, "t");
if (crc32("yyUEsP",6) == 2362881134) strcat(s, "s");
if (crc32("mXsymbuJTgfSi",13) == 1689296382) strcat(s, "n");
if (crc32("OwfabVKEQyMvu",13) == 2304179280) strcat(s, "l");
if (crc32("zfMDMcVB",8) == 4189971234) strcat(s, "u");
if (crc32("ErQuxmXl",8) == 2956566785) strcat(s, "h");
if (crc32("eodjTbMEyna",11) == 782805898) strcat(s, "m");
if (crc32("VckFlwrRjgHlv",13) == 1143044102) strcat(s, "m");
if (crc32("BnDKrRrhJ",9) == 3974590237) strcat(s, "e");
if (crc32("MxRSLzrsjuRjGMy",15) == 2687117818) strcat(s, "i");
if (crc32("SqXfaPhU",8) == 1530397350) strcat(s, "e");
if (crc32("MPZXvstFN",9) == 3900884081) strcat(s, "A");
if (crc32("rzKkClO",7) == 3536937650) strcat(s, "s");
if (crc32("VqjRMnUhFSoX",12) == 3323868435) strcat(s, "t");
    return s;
}

char *antireligion_adjectives() {
    char *s = calloc(13);
    if (crc32("SUopHLRLc",9) == 2562890570) strcat(s, "a");
if (crc32("eVDJqYanADcJhb",14) == 1156294077) strcat(s, "n");
if (crc32("nwcmqNZmFMDh",12) == 596239734) strcat(s, "K");
if (crc32("iXgOQbkbG",9) == 1337467348) strcat(s, "t");
if (crc32("oNTseTHJpdEUpXH",15) == 169850986) strcat(s, "s");
if (crc32("pLTCcu",6) == 2146373521) strcat(s, "i");
if (crc32("dUMPN",5) == 98498128) strcat(s, "r");
if (crc32("HvNauOoT",8) == 4099164580) strcat(s, "j");
if (crc32("yZdXdaySygmERii",15) == 2977761890) strcat(s, "e");
if (crc32("oZwRPk",6) == 3284683833) strcat(s, "l");
if (crc32("WdSZqdHVy",9) == 3014039172) strcat(s, "z");
if (crc32("IFDwfslnhr",10) == 3908842837) strcat(s, "i");
if (crc32("hqwLrqlbwAJ",11) == 710558516) strcat(s, "g");
if (crc32("WNxDMzvchTUru",13) == 1934129764) strcat(s, "M");
if (crc32("FGWUzwiiUkBPax",14) == 2150587275) strcat(s, "i");
if (crc32("cryARPWfxCzTt",13) == 2555584248) strcat(s, "v");
if (crc32("rZGFlgRk",8) == 2811853400) strcat(s, "o");
if (crc32("ctkShF",6) == 2209775545) strcat(s, "n");
    return s;
}

char *unrented_adjectives() {
    char *s = calloc(9);
    if (crc32("Khljx",5) == 2542930382) strcat(s, "u");
if (crc32("nObLwaF",7) == 129066991) strcat(s, "X");
if (crc32("zzQLdn",6) == 162761205) strcat(s, "n");
if (crc32("AaBaETDODv",10) == 3293758151) strcat(s, "Y");
if (crc32("GXPsVEYOTC",10) == 1757778125) strcat(s, "r");
if (crc32("eJXEosixUxkRh",13) == 4116112626) strcat(s, "e");
if (crc32("tYjklh",6) == 2387262889) strcat(s, "n");
if (crc32("YxpSMvBwICJq",12) == 2925955825) strcat(s, "t");
if (crc32("KOnCIQifD",9) == 78718055) strcat(s, "J");
if (crc32("barIL",5) == 2951612063) strcat(s, "e");
if (crc32("DKtymeLhpovmZC",14) == 3799542456) strcat(s, "j");
if (crc32("smLEcKOk",8) == 3184044231) strcat(s, "d");
    return s;
}

char *pixilated_adjectives() {
    char *s = calloc(10);
    if (crc32("blOuos",6) == 1640160983) strcat(s, "X");
if (crc32("FjKoXAuRkY",10) == 2453929011) strcat(s, "p");
if (crc32("NeiUyXQv",8) == 34739242) strcat(s, "J");
if (crc32("RZbETNbknPfqOa",14) == 4134152377) strcat(s, "i");
if (crc32("arMcX",5) == 4033101510) strcat(s, "x");
if (crc32("QyUFeothVGKJxF",14) == 2447992987) strcat(s, "i");
if (crc32("UQfAyiInKhqvOHC",15) == 1311395041) strcat(s, "l");
if (crc32("kOrzDi",6) == 830031822) strcat(s, "a");
if (crc32("HgCSZdm",7) == 1781219703) strcat(s, "t");
if (crc32("XSxnPeyHB",9) == 357634359) strcat(s, "z");
if (crc32("heSNb",5) == 3223600822) strcat(s, "e");
if (crc32("cSMIO",5) == 2123557906) strcat(s, "d");
    return s;
}

char *noncorrespondent_adjectives() {
    char *s = calloc(17);
    if (crc32("qwqqRNk",7) == 2197035730) strcat(s, "C");
if (crc32("QDAEHwOIqb",10) == 1148931487) strcat(s, "n");
if (crc32("lAgoUXHgNcse",12) == 1021307918) strcat(s, "o");
if (crc32("FYBtXGO",7) == 1823211563) strcat(s, "n");
if (crc32("aizrtXDlyJkc",12) == 354828213) strcat(s, "c");
if (crc32("eWhjjGo",7) == 2412069989) strcat(s, "o");
if (crc32("bdSqGHwAfNY",11) == 2868652698) strcat(s, "r");
if (crc32("ZMTtYZhimqZqiw",14) == 4051713177) strcat(s, "y");
if (crc32("xDDkjHq",7) == 3449048466) strcat(s, "r");
if (crc32("LYgIWQl",7) == 1981766901) strcat(s, "e");
if (crc32("tsZBYNnBIvzAtnk",15) == 2955755183) strcat(s, "s");
if (crc32("bXoLljiU",8) == 419013728) strcat(s, "p");
if (crc32("KKANdquw",8) == 757480880) strcat(s, "K");
if (crc32("gqYzIGmaZQAnAhn",15) == 3515573281) strcat(s, "o");
if (crc32("bRQrdvcuUdWw",12) == 4214275139) strcat(s, "n");
if (crc32("yWmAI",5) == 3260521915) strcat(s, "d");
if (crc32("xwkzYIqmcaRZ",12) == 960114355) strcat(s, "g");
if (crc32("ZnkVFkLVDkC",11) == 1527068673) strcat(s, "e");
if (crc32("ZtkzmFAJCqSvnC",14) == 1880433577) strcat(s, "x");
if (crc32("SzkGaowjYbxBJe",14) == 3134029255) strcat(s, "n");
if (crc32("VmTvpAMSrTlgq",13) == 311054883) strcat(s, "t");
    return s;
}

char *hyperacute_adjectives() {
    char *s = calloc(11);
    if (crc32("cNinUsWYINV",11) == 1152858425) strcat(s, "h");
if (crc32("zAViGK",6) == 1158206804) strcat(s, "Q");
if (crc32("lmtmlTxFGg",10) == 1137814054) strcat(s, "y");
if (crc32("fFqmQCezP",9) == 3351502022) strcat(s, "T");
if (crc32("IXNSnU",6) == 1689789112) strcat(s, "p");
if (crc32("ouexCmrf",8) == 861198252) strcat(s, "e");
if (crc32("vSZsnlAn",8) == 3608905141) strcat(s, "r");
if (crc32("gKLUHdlwJ",9) == 510240278) strcat(s, "a");
if (crc32("saOCzGFNrPHMJ",13) == 982808438) strcat(s, "c");
if (crc32("AORPgIvM",8) == 3820086293) strcat(s, "u");
if (crc32("BpLcXBqmy",9) == 2026841192) strcat(s, "e");
if (crc32("zwhyiBeFuhdBSj",14) == 3994413367) strcat(s, "t");
if (crc32("NSorCoFCXTJw",12) == 2588113) strcat(s, "e");
    return s;
}

char *cymoid_adjectives() {
    char *s = calloc(7);
    if (crc32("pDwnhzUdRxEFX",13) == 2506437615) strcat(s, "E");
if (crc32("kirqdbvw",8) == 1019628274) strcat(s, "c");
if (crc32("wajgXiooFEcoTRM",15) == 2020137867) strcat(s, "y");
if (crc32("JsGEg",5) == 2263247993) strcat(s, "m");
if (crc32("JqBLQUoORdcTK",13) == 1682913061) strcat(s, "P");
if (crc32("zUrCpSRHWgJVpLV",15) == 120788647) strcat(s, "o");
if (crc32("qhFvzpgysjQX",12) == 2260973180) strcat(s, "H");
if (crc32("yPUIWoxyTtT",11) == 3578660848) strcat(s, "i");
if (crc32("kKPXn",5) == 877762358) strcat(s, "D");
if (crc32("etOudAwwe",9) == 1917402155) strcat(s, "d");
    return s;
}

char *adrenocorticotropic_adjectives() {
    char *s = calloc(20);
    if (crc32("zrpolt",6) == 114004825) strcat(s, "n");
if (crc32("TYecG",5) == 1438661538) strcat(s, "a");
if (crc32("kBBpUOdxpM",10) == 2016341289) strcat(s, "U");
if (crc32("qXQvjtDNTXs",11) == 1223215884) strcat(s, "d");
if (crc32("EtnQKvxLObxkhK",14) == 3030241546) strcat(s, "r");
if (crc32("iLDSSe",6) == 3589836474) strcat(s, "e");
if (crc32("pWeZDFRwbqv",11) == 84961966) strcat(s, "n");
if (crc32("jCEwPSGqsspv",12) == 853268691) strcat(s, "o");
if (crc32("RJwUQSzyQZwNT",13) == 484860711) strcat(s, "c");
if (crc32("pXHLno",6) == 1489407657) strcat(s, "R");
if (crc32("VntoJFUvFjSqmZh",15) == 2289220637) strcat(s, "o");
if (crc32("LqvEiXsS",8) == 2511232836) strcat(s, "x");
if (crc32("AbllqQgHK",9) == 2906352788) strcat(s, "r");
if (crc32("zIdZtPX",7) == 3117576682) strcat(s, "t");
if (crc32("Vgipx",5) == 1496360184) strcat(s, "q");
if (crc32("tuWsUmPz",8) == 3928391498) strcat(s, "i");
if (crc32("HWVeUPAujbs",11) == 1511115441) strcat(s, "c");
if (crc32("UkRABiQjbfoyqbC",15) == 3457177476) strcat(s, "o");
if (crc32("AAYaAyiYN",9) == 1905087944) strcat(s, "t");
if (crc32("pDhOYCyHQtkywJL",15) == 2250089400) strcat(s, "r");
if (crc32("XZqsJGarkdoDOs",14) == 30195483) strcat(s, "X");
if (crc32("YSRJyLwvPUimuHn",15) == 3668711420) strcat(s, "o");
if (crc32("gUHowFqI",8) == 2371027090) strcat(s, "p");
if (crc32("wwATgioriPbmwe",14) == 1584846036) strcat(s, "p");
if (crc32("EdihORa",7) == 3144984281) strcat(s, "i");
if (crc32("AMwjTXOfkix",11) == 828201749) strcat(s, "l");
if (crc32("bSZXnF",6) == 697534635) strcat(s, "c");
    return s;
}

char *potenty_adjectives() {
    char *s = calloc(8);
    if (crc32("JaQWRJyWzQq",11) == 1054512171) strcat(s, "p");
if (crc32("jLPSwGuZfQtW",12) == 1500968455) strcat(s, "P");
if (crc32("SvVgqPlhztU",11) == 1193217167) strcat(s, "o");
if (crc32("YqfkOyD",7) == 2540480664) strcat(s, "W");
if (crc32("TGGyhMzAcnj",11) == 1370980598) strcat(s, "t");
if (crc32("UXdojAqWMABAIzX",15) == 2075638712) strcat(s, "f");
if (crc32("brMCX",5) == 574644404) strcat(s, "e");
if (crc32("VbkCjfNOmKVVDo",14) == 1163467169) strcat(s, "n");
if (crc32("xsinc",5) == 1152618113) strcat(s, "j");
if (crc32("sSkfLJWyyef",11) == 3233926282) strcat(s, "t");
if (crc32("dwCNorTMMdZVhCk",15) == 332542045) strcat(s, "a");
if (crc32("CGpJMjzujJAqENA",15) == 1019259438) strcat(s, "y");
    return s;
}

char *hyaline_adjectives() {
    char *s = calloc(8);
    if (crc32("QkqoChYnWh",10) == 339736526) strcat(s, "h");
if (crc32("OElzfVzqFqxa",12) == 334270659) strcat(s, "i");
if (crc32("VFMFqetHjWcn",12) == 3361008072) strcat(s, "y");
if (crc32("PURqpTZGT",9) == 4060156403) strcat(s, "a");
if (crc32("UnxFJj",6) == 2581524812) strcat(s, "J");
if (crc32("NurwpFTibj",10) == 992209062) strcat(s, "l");
if (crc32("PbclERQLoZ",10) == 3930829934) strcat(s, "S");
if (crc32("zdpzIIIMWLMlsgp",15) == 990792486) strcat(s, "i");
if (crc32("VXHYNJRYqPXM",12) == 3309978435) strcat(s, "B");
if (crc32("buwMxnDFuQH",11) == 586002411) strcat(s, "n");
if (crc32("IfGbB",5) == 926996262) strcat(s, "e");
    return s;
}

char *plesiosauroid_adjectives() {
    char *s = calloc(14);
    if (crc32("NLCUGlubzLDvR",13) == 1107905970) strcat(s, "p");
if (crc32("TEZPbC",6) == 3336365058) strcat(s, "l");
if (crc32("VLNkmOGkBSf",11) == 3660884190) strcat(s, "I");
if (crc32("ibIeyZjw",8) == 3913660782) strcat(s, "e");
if (crc32("VBkUdEPXa",9) == 3172514105) strcat(s, "s");
if (crc32("PTFlznbo",8) == 1116663991) strcat(s, "N");
if (crc32("pwKKpha",7) == 3346357369) strcat(s, "i");
if (crc32("AMjsvlP",7) == 2491529506) strcat(s, "o");
if (crc32("vhOoixcbbBlfL",13) == 2666822078) strcat(s, "r");
if (crc32("GEniDFugi",9) == 2517739660) strcat(s, "s");
if (crc32("FAvXykfnaHYCXY",14) == 3730172596) strcat(s, "k");
if (crc32("MBRVqFhpWDIuAHj",15) == 2208584589) strcat(s, "a");
if (crc32("kaFSQKFTvg",10) == 3956417370) strcat(s, "u");
if (crc32("wurHL",5) == 1136721178) strcat(s, "Q");
if (crc32("dpSPYhYwBa",10) == 2933601596) strcat(s, "r");
if (crc32("xtUrb",5) == 1059036291) strcat(s, "o");
if (crc32("JCjokCPQUdDOna",14) == 3274556518) strcat(s, "i");
if (crc32("cSQTxDVwhEQjM",13) == 405579097) strcat(s, "d");
if (crc32("MGerGOey",8) == 3245052647) strcat(s, "d");
    return s;
}

char *justiciary_adjectives() {
    char *s = calloc(11);
    if (crc32("mwccCcvElMcF",12) == 4101637851) strcat(s, "m");
if (crc32("RGWHSoBgfLpkG",13) == 2268129861) strcat(s, "j");
if (crc32("VbHrW",5) == 1993470373) strcat(s, "u");
if (crc32("ocNTP",5) == 996877826) strcat(s, "s");
if (crc32("eEQWUMo",7) == 3128121177) strcat(s, "t");
if (crc32("CMpTRguefVTDv",13) == 823382776) strcat(s, "i");
if (crc32("sSCnacvE",8) == 2132415774) strcat(s, "x");
if (crc32("CzUSUTa",7) == 3848821519) strcat(s, "c");
if (crc32("vGIbzwTpiSzVd",13) == 96119669) strcat(s, "F");
if (crc32("pTakXNP",7) == 3377473340) strcat(s, "i");
if (crc32("fURLsi",6) == 3076803867) strcat(s, "a");
if (crc32("jiKIQvhZoanY",12) == 1733983094) strcat(s, "a");
if (crc32("cwhZDt",6) == 680831782) strcat(s, "r");
if (crc32("qPzEtqcqelvw",12) == 453802541) strcat(s, "y");
    return s;
}

char *chummiest_adjectives() {
    char *s = calloc(10);
    if (crc32("clISiI",6) == 1354360991) strcat(s, "c");
if (crc32("LvKdpUmGG",9) == 1937201848) strcat(s, "h");
if (crc32("wjiAChugOnRbx",13) == 2024832491) strcat(s, "u");
if (crc32("qbkQYLTfGH",10) == 1514451295) strcat(s, "C");
if (crc32("oTEHFoYIByTUML",14) == 804890596) strcat(s, "m");
if (crc32("ubFsyJxc",8) == 1106954386) strcat(s, "I");
if (crc32("NWiuQizqi",9) == 4060774815) strcat(s, "m");
if (crc32("EtHPLKSR",8) == 2124291065) strcat(s, "i");
if (crc32("cSRHKbxbYYvP",12) == 2982803964) strcat(s, "U");
if (crc32("kDaDf",5) == 1164415312) strcat(s, "e");
if (crc32("uWpYoyEBWTB",11) == 2032288135) strcat(s, "Q");
if (crc32("mAmGis",6) == 2710669357) strcat(s, "s");
if (crc32("OAUBFPRtog",10) == 1776097377) strcat(s, "t");
    return s;
}

char *unclean_adjectives() {
    char *s = calloc(8);
    if (crc32("POjHL",5) == 1070397181) strcat(s, "u");
if (crc32("vMfnsdRzTZwYO",13) == 4196269585) strcat(s, "n");
if (crc32("wSWfbWBMKbUhsP",14) == 868202217) strcat(s, "c");
if (crc32("baooQJxJOFdb",12) == 341339501) strcat(s, "c");
if (crc32("DddXPznmeXO",11) == 3999917092) strcat(s, "l");
if (crc32("qOIBzLNdkPBvHXS",15) == 1767278074) strcat(s, "m");
if (crc32("CeSSWcmmRlwwr",13) == 2785659187) strcat(s, "e");
if (crc32("gMwUbN",6) == 1583354741) strcat(s, "a");
if (crc32("MEtwUtq",7) == 3274817647) strcat(s, "A");
if (crc32("iXYSOV",6) == 3142323441) strcat(s, "n");
    return s;
}

char *undissolved_adjectives() {
    char *s = calloc(12);
    if (crc32("JEwhiMEOsdfUtH",14) == 791278806) strcat(s, "u");
if (crc32("tCVzEFQSJr",10) == 26640117) strcat(s, "n");
if (crc32("qTrjEoXsvq",10) == 561369140) strcat(s, "X");
if (crc32("XUqyvvNoXbkrpD",14) == 876131396) strcat(s, "d");
if (crc32("RJsSqi",6) == 4087203011) strcat(s, "Q");
if (crc32("AlFvcIRPKcFRL",13) == 3911544626) strcat(s, "i");
if (crc32("MQTdoU",6) == 1305504228) strcat(s, "N");
if (crc32("VVlWVEvTSiNO",12) == 1724231556) strcat(s, "s");
if (crc32("mHKMpYpTttO",11) == 392803888) strcat(s, "s");
if (crc32("JqExmy",6) == 896799746) strcat(s, "A");
if (crc32("IyHyom",6) == 3115397433) strcat(s, "o");
if (crc32("NsavUReQenys",12) == 4116528622) strcat(s, "l");
if (crc32("zAEjN",5) == 785354938) strcat(s, "v");
if (crc32("zEXiZz",6) == 2787599071) strcat(s, "v");
if (crc32("QMxhPZk",7) == 1789948819) strcat(s, "e");
if (crc32("qTBZDH",6) == 749247) strcat(s, "d");
    return s;
}

char *unpollened_adjectives() {
    char *s = calloc(11);
    if (crc32("rEABZIgaaON",11) == 3219197122) strcat(s, "u");
if (crc32("GsvvCIN",7) == 107156989) strcat(s, "f");
if (crc32("fPDrNTCotUZV",12) == 3092611456) strcat(s, "n");
if (crc32("xKOYjJbfwKt",11) == 2317451559) strcat(s, "h");
if (crc32("tLFXjZJveAzc",12) == 3102807282) strcat(s, "p");
if (crc32("ZGjTUrLG",8) == 1531357491) strcat(s, "o");
if (crc32("PZYSbE",6) == 194461538) strcat(s, "t");
if (crc32("BhcFpjyLLdlxOb",14) == 2692353183) strcat(s, "l");
if (crc32("kVprffjPkoeA",12) == 3986043143) strcat(s, "M");
if (crc32("kzXpvJlVxmOubo",14) == 3159496691) strcat(s, "l");
if (crc32("rBlZZciRJOdI",12) == 4132373850) strcat(s, "L");
if (crc32("bguJzMdTnoFcWEg",15) == 3858686260) strcat(s, "e");
if (crc32("NooirrNHS",9) == 1500881539) strcat(s, "n");
if (crc32("yOhJYBMNjMCH",12) == 936222790) strcat(s, "u");
if (crc32("FwPnk",5) == 2866483864) strcat(s, "e");
if (crc32("iRDOZyzcQYuU",12) == 825498316) strcat(s, "I");
if (crc32("tobLYEN",7) == 836671369) strcat(s, "d");
    return s;
}

char *nerval_adjectives() {
    char *s = calloc(7);
    if (crc32("TEHjbU",6) == 3789860353) strcat(s, "n");
if (crc32("bPzRWXMvPxaToU",14) == 4012881719) strcat(s, "P");
if (crc32("oidWVUU",7) == 1107100958) strcat(s, "e");
if (crc32("RfmbaCyhHpWP",12) == 2671054955) strcat(s, "I");
if (crc32("zvscknuk",8) == 2724751001) strcat(s, "r");
if (crc32("HKkxsziVZMY",11) == 4226019936) strcat(s, "v");
if (crc32("QfJyNWs",7) == 3068786537) strcat(s, "X");
if (crc32("DGnJZNA",7) == 3822353758) strcat(s, "a");
if (crc32("EUbqmyNxHNzid",13) == 965072470) strcat(s, "y");
if (crc32("sXDZLfl",7) == 2815499243) strcat(s, "l");
    return s;
}

char *anticritical_adjectives() {
    char *s = calloc(13);
    if (crc32("ULGbZVXF",8) == 88965532) strcat(s, "l");
if (crc32("MpDSiO",6) == 3540421554) strcat(s, "a");
if (crc32("WkrMI",5) == 976752294) strcat(s, "B");
if (crc32("YHiejlvKWodHVb",14) == 4106789627) strcat(s, "n");
if (crc32("HzKewj",6) == 784031820) strcat(s, "t");
if (crc32("GNEULaqfdhkBM",13) == 1110380762) strcat(s, "i");
if (crc32("uzfDHtyHxgnGzp",14) == 3045808712) strcat(s, "m");
if (crc32("cURCEOrjxVxjG",13) == 4050054137) strcat(s, "c");
if (crc32("HDvUdy",6) == 1315551646) strcat(s, "P");
if (crc32("UlLIi",5) == 729064969) strcat(s, "r");
if (crc32("SmAIUGU",7) == 1996146300) strcat(s, "i");
if (crc32("xfGDra",6) == 372089792) strcat(s, "t");
if (crc32("bQQkKwBzWSawfAx",15) == 3817801343) strcat(s, "i");
if (crc32("RatglhZtULHpQ",13) == 1781631461) strcat(s, "c");
if (crc32("sFZdJOPmSjCuyqd",15) == 3705271047) strcat(s, "a");
if (crc32("UkNLNgykMZZI",12) == 3823493762) strcat(s, "l");
    return s;
}

char *ancra_adjectives() {
    char *s = calloc(6);
    if (crc32("IydbnAJnpoYmCEr",15) == 1880882198) strcat(s, "a");
if (crc32("FMFaBAEcI",9) == 728801193) strcat(s, "n");
if (crc32("IXSddlloLtDTK",13) == 874559369) strcat(s, "c");
if (crc32("tikPf",5) == 1182944538) strcat(s, "r");
if (crc32("rKDjaasOT",9) == 1058570917) strcat(s, "r");
if (crc32("XpkFHJXJgWAGXtp",15) == 2604618989) strcat(s, "a");
    return s;
}

char *suburethral_adjectives() {
    char *s = calloc(12);
    if (crc32("WKqVsFzbtsBF",12) == 2110376263) strcat(s, "s");
if (crc32("vbONYlltWWToOkg",15) == 4030357898) strcat(s, "u");
if (crc32("mQsYSpEYQtB",11) == 1214274190) strcat(s, "k");
if (crc32("YeEWud",6) == 373274729) strcat(s, "b");
if (crc32("mUqAHJWVV",9) == 1137184862) strcat(s, "u");
if (crc32("GVxyRQEKyODxgP",14) == 4278355839) strcat(s, "p");
if (crc32("FRddTIUQtjurRyJ",15) == 1369996809) strcat(s, "r");
if (crc32("EmxcPOywGjM",11) == 3234145220) strcat(s, "e");
if (crc32("WaymgmeltSSSATv",15) == 2185893398) strcat(s, "B");
if (crc32("dgIhNi",6) == 4093211114) strcat(s, "t");
if (crc32("OSavoV",6) == 2213849900) strcat(s, "h");
if (crc32("xKqZZVMR",8) == 577967726) strcat(s, "O");
if (crc32("cVsWl",5) == 295672343) strcat(s, "r");
if (crc32("UOOFqoN",7) == 1348562998) strcat(s, "a");
if (crc32("SZdBONzKpgiOOoE",15) == 1249506003) strcat(s, "l");
    return s;
}

char *unlaudatory_adjectives() {
    char *s = calloc(12);
    if (crc32("wQcic",5) == 895709153) strcat(s, "K");
if (crc32("TjmOwa",6) == 488562546) strcat(s, "u");
if (crc32("FSGrKL",6) == 706853382) strcat(s, "n");
if (crc32("RtQjXgKzOSAXgI",14) == 1836537606) strcat(s, "E");
if (crc32("qDbJOHnkfOQJnt",14) == 3421406355) strcat(s, "l");
if (crc32("QOmWtqbJzx",10) == 47221431) strcat(s, "h");
if (crc32("enDndmQyJpWFRI",14) == 2065306315) strcat(s, "a");
if (crc32("RrzXdrRgXiGbCoa",15) == 974860317) strcat(s, "u");
if (crc32("EGXCYUbyFzf",11) == 3300615296) strcat(s, "d");
if (crc32("TLnYExSKOZv",11) == 842416026) strcat(s, "I");
if (crc32("izfduZNpnX",10) == 1513118948) strcat(s, "a");
if (crc32("eqSsQxQEW",9) == 2970327190) strcat(s, "t");
if (crc32("xrsmXVGdAiq",11) == 688243457) strcat(s, "o");
if (crc32("TtVKDMlxKcAOriV",15) == 1345751858) strcat(s, "B");
if (crc32("EviepKz",7) == 961683405) strcat(s, "r");
if (crc32("XakoLlCeI",9) == 1743711087) strcat(s, "A");
if (crc32("OQVXRnYoMMeCOV",14) == 2232343026) strcat(s, "y");
    return s;
}

char *quinonoid_adjectives() {
    char *s = calloc(10);
    if (crc32("kfLHsfVkLu",10) == 675620170) strcat(s, "S");
if (crc32("pGwcCDFKLl",10) == 1295811360) strcat(s, "q");
if (crc32("QuZHGvXecM",10) == 2608386961) strcat(s, "q");
if (crc32("zXyaJLuuLx",10) == 1790758131) strcat(s, "u");
if (crc32("FLwncotpguaNd",13) == 3241550648) strcat(s, "w");
if (crc32("lLxVOEH",7) == 15429783) strcat(s, "i");
if (crc32("mEZqNFZo",8) == 3573700925) strcat(s, "v");
if (crc32("wdqwsjglfCtuEhc",15) == 3369822993) strcat(s, "n");
if (crc32("GjMVNwQegVym",12) == 1572094836) strcat(s, "Z");
if (crc32("zyigBzDo",8) == 80263678) strcat(s, "o");
if (crc32("BhwarmgiKhis",12) == 3761420193) strcat(s, "n");
if (crc32("nhzIG",5) == 2396466212) strcat(s, "o");
if (crc32("BxvBiEQtNX",10) == 536787148) strcat(s, "i");
if (crc32("YQspzN",6) == 4143940654) strcat(s, "d");
    return s;
}

char *scurrile_adjectives() {
    char *s = calloc(9);
    if (crc32("uuocwDdQTZJpe",13) == 1783435561) strcat(s, "s");
if (crc32("TUsKJirK",8) == 1241982492) strcat(s, "L");
if (crc32("ZlkjwSIGOqH",11) == 1614870032) strcat(s, "c");
if (crc32("WQAfEqidxkopjv",14) == 1683716661) strcat(s, "R");
if (crc32("UdeoKcgiMhVLJs",14) == 1187541590) strcat(s, "u");
if (crc32("tnGXVLugYzU",11) == 3565335876) strcat(s, "r");
if (crc32("yvsKhEVBxh",10) == 421242585) strcat(s, "o");
if (crc32("paKNyCXSX",9) == 2455757045) strcat(s, "r");
if (crc32("SQYBGfOnmrtnEOC",15) == 1229369558) strcat(s, "J");
if (crc32("VWCBTv",6) == 2083044278) strcat(s, "i");
if (crc32("HjcqlmnuELDfpWT",15) == 3173921312) strcat(s, "n");
if (crc32("xFraiMwpl",9) == 1023810680) strcat(s, "l");
if (crc32("pRaeLfeVxCzXN",13) == 3524414242) strcat(s, "v");
if (crc32("NWvHH",5) == 1742749283) strcat(s, "e");
    return s;
}

char *unforetellable_adjectives() {
    char *s = calloc(15);
    if (crc32("FOhbWXWaQp",10) == 2610954981) strcat(s, "u");
if (crc32("LKVZo",5) == 1931035354) strcat(s, "X");
if (crc32("QqhNGcUunBrhyWa",15) == 1934823967) strcat(s, "n");
if (crc32("axvsrWc",7) == 3272806100) strcat(s, "r");
if (crc32("gFjngQCyQgqYo",13) == 1719332673) strcat(s, "f");
if (crc32("pQPfrHMDK",9) == 2729831972) strcat(s, "o");
if (crc32("IQKGTtWD",8) == 3132444501) strcat(s, "D");
if (crc32("KOeqq",5) == 1967970040) strcat(s, "r");
if (crc32("wQyKUxIGQQog",12) == 4132176543) strcat(s, "p");
if (crc32("AVryPHnZT",9) == 3822788000) strcat(s, "e");
if (crc32("QzWVqOyPipHVs",13) == 922277407) strcat(s, "t");
if (crc32("reJCkFvNWL",10) == 3198394374) strcat(s, "h");
if (crc32("lSCop",5) == 2212821200) strcat(s, "e");
if (crc32("USAeF",5) == 2329962429) strcat(s, "X");
if (crc32("JlFwH",5) == 3388942511) strcat(s, "l");
if (crc32("lKgTswsl",8) == 338324246) strcat(s, "l");
if (crc32("TAFXIUqHjWUx",12) == 1123571917) strcat(s, "a");
if (crc32("oqHEvnK",7) == 2761827337) strcat(s, "g");
if (crc32("DdasUAfG",8) == 2621586717) strcat(s, "b");
if (crc32("MuQoVrHdGLfhidq",15) == 3323962776) strcat(s, "Y");
if (crc32("vYZsOHaUsdf",11) == 126634366) strcat(s, "l");
if (crc32("XbDwusoU",8) == 1097162020) strcat(s, "i");
if (crc32("COUFIEAHWXICOM",14) == 2053534720) strcat(s, "e");
    return s;
}

char *shoeless_adjectives() {
    char *s = calloc(9);
    if (crc32("QVNIuBFIDOgzbUQ",15) == 3531664159) strcat(s, "C");
if (crc32("WqOuEXemXfRI",12) == 1420636697) strcat(s, "s");
if (crc32("vVUhkHqUkFlpMt",14) == 4224896137) strcat(s, "h");
if (crc32("womXtk",6) == 3321285115) strcat(s, "k");
if (crc32("sISVwpOAPhYn",12) == 1270155564) strcat(s, "o");
if (crc32("CBfKw",5) == 3147526874) strcat(s, "N");
if (crc32("CPnFEvQQENuv",12) == 934573515) strcat(s, "e");
if (crc32("NmePpBnwPR",10) == 280196049) strcat(s, "r");
if (crc32("OUEJSF",6) == 1624314762) strcat(s, "l");
if (crc32("YMhyLDlTzSopa",13) == 3176118361) strcat(s, "e");
if (crc32("hNhsiOuJ",8) == 3513002530) strcat(s, "s");
if (crc32("HgyQDWtDi",9) == 1403486251) strcat(s, "S");
if (crc32("UXpeYXGlrpE",11) == 323678711) strcat(s, "s");
    return s;
}

char *uninjectable_adjectives() {
    char *s = calloc(13);
    if (crc32("mEwahUoKPiLCpi",14) == 510082938) strcat(s, "u");
if (crc32("taWYPwLnrWcGY",13) == 2232319061) strcat(s, "n");
if (crc32("tcJFo",5) == 2072282196) strcat(s, "U");
if (crc32("GSbewl",6) == 660986477) strcat(s, "i");
if (crc32("aYQYFcEygn",10) == 1548747050) strcat(s, "n");
if (crc32("QSYhvausEa",10) == 3363294932) strcat(s, "j");
if (crc32("VjNQsGnpfwg",11) == 3481742453) strcat(s, "e");
if (crc32("TosVR",5) == 2871503024) strcat(s, "a");
if (crc32("yntsJtu",7) == 3045809286) strcat(s, "c");
if (crc32("qGuEe",5) == 3871333066) strcat(s, "t");
if (crc32("aTCkOEdwcEq",11) == 4234179184) strcat(s, "j");
if (crc32("omdUEgAoWFclARW",15) == 1478332368) strcat(s, "a");
if (crc32("iSCblWNxDhOxLv",14) == 2012827471) strcat(s, "b");
if (crc32("uSTxoOTwRNSbwT",14) == 104792301) strcat(s, "Y");
if (crc32("RUoQdDZsIRHaKdC",15) == 2273391447) strcat(s, "l");
if (crc32("pIcsxZXFa",9) == 3256023263) strcat(s, "i");
if (crc32("bPAcdoHCPLohEw",14) == 4099722746) strcat(s, "e");
    return s;
}

char *ungelded_adjectives() {
    char *s = calloc(9);
    if (crc32("XUYrDqHIayrhK",13) == 2912600476) strcat(s, "I");
if (crc32("ErzggcIJC",9) == 1494845142) strcat(s, "u");
if (crc32("kOwCBDaT",8) == 100270933) strcat(s, "n");
if (crc32("yZCGzwDyDa",10) == 3652090520) strcat(s, "l");
if (crc32("bGYYCTPeHzA",11) == 4149497073) strcat(s, "g");
if (crc32("mCoxikmQRDmQeL",14) == 3868455616) strcat(s, "e");
if (crc32("zLzyvpjQ",8) == 2914655966) strcat(s, "Z");
if (crc32("xjZtewPJx",9) == 1686183959) strcat(s, "l");
if (crc32("UrcehwITtntGT",13) == 2107074916) strcat(s, "d");
if (crc32("RQyctv",6) == 1533287600) strcat(s, "e");
if (crc32("FQTAk",5) == 983003851) strcat(s, "d");
    return s;
}

char *unclassified_adjectives() {
    char *s = calloc(13);
    if (crc32("uVfEyRkTBqpe",12) == 4146112540) strcat(s, "q");
if (crc32("AmBjcNCfxgsU",12) == 834646947) strcat(s, "u");
if (crc32("bvVpmtd",7) == 2447442833) strcat(s, "K");
if (crc32("AyJFzR",6) == 1359942235) strcat(s, "n");
if (crc32("fYTTvAJphfPRkE",14) == 1819631188) strcat(s, "c");
if (crc32("NJDjJRMn",8) == 2456591554) strcat(s, "I");
if (crc32("OIkPaVpS",8) == 685421580) strcat(s, "l");
if (crc32("msvarzorkOQWtPU",15) == 2866105910) strcat(s, "a");
if (crc32("KPAWvkDutNrqS",13) == 612122612) strcat(s, "s");
if (crc32("RCnPZzavz",9) == 3265331666) strcat(s, "L");
if (crc32("xLazUPvPYLFVAqM",15) == 3055791712) strcat(s, "s");
if (crc32("zcmDnvC",7) == 4198070537) strcat(s, "i");
if (crc32("vYWCYoDgesSLMr",14) == 3539131405) strcat(s, "f");
if (crc32("yStnk",5) == 856633719) strcat(s, "W");
if (crc32("TxBuupDklkPPJG",14) == 1277740964) strcat(s, "i");
if (crc32("whJPTxRJbvU",11) == 3034954813) strcat(s, "j");
if (crc32("VXwsDBLcT",9) == 46392057) strcat(s, "e");
if (crc32("UcEnmN",6) == 2410311266) strcat(s, "c");
if (crc32("zlpiW",5) == 292633377) strcat(s, "d");
    return s;
}

char *retral_adjectives() {
    char *s = calloc(7);
    if (crc32("IUqoKG",6) == 1871430984) strcat(s, "M");
if (crc32("eEHLd",5) == 1403051551) strcat(s, "r");
if (crc32("tdXhV",5) == 867679008) strcat(s, "e");
if (crc32("jBQRKtfCL",9) == 2579758618) strcat(s, "o");
if (crc32("ZAQXtNCtCWwX",12) == 2033183399) strcat(s, "t");
if (crc32("ubkYYDdQCx",10) == 1626470828) strcat(s, "r");
if (crc32("TmknWnrPy",9) == 2899016850) strcat(s, "a");
if (crc32("DCZAzdjIiSO",11) == 4091302531) strcat(s, "D");
if (crc32("XbzUjzqELPlpDQ",14) == 1419903996) strcat(s, "l");
    return s;
}

char *Sicanian_adjectives() {
    char *s = calloc(9);
    if (crc32("uqTRcgYt",8) == 3789698671) strcat(s, "v");
if (crc32("kCKNbIVZKxVC",12) == 3814716037) strcat(s, "S");
if (crc32("ewsth",5) == 2782997692) strcat(s, "D");
if (crc32("JYvmKUCO",8) == 3435037608) strcat(s, "i");
if (crc32("lvbKEHiXjhtIa",13) == 3418364719) strcat(s, "c");
if (crc32("lMcEcUGpRT",10) == 2465178998) strcat(s, "r");
if (crc32("VgfREovl",8) == 4129616062) strcat(s, "a");
if (crc32("SXkWc",5) == 1581819302) strcat(s, "J");
if (crc32("bjaRjrYQoEP",11) == 1938913093) strcat(s, "n");
if (crc32("uWecVjHmaCT",11) == 1095259396) strcat(s, "i");
if (crc32("eVHKLPdsq",9) == 1830667260) strcat(s, "L");
if (crc32("FdyIcAAGPJ",10) == 2182162658) strcat(s, "a");
if (crc32("GNmzM",5) == 3397953640) strcat(s, "n");
    return s;
}

char *cellular_adjectives() {
    char *s = calloc(9);
    if (crc32("riteO",5) == 1172945665) strcat(s, "h");
if (crc32("vTKyKbLEAKTpK",13) == 1259914200) strcat(s, "c");
if (crc32("crNMuROXedYnj",13) == 3020812178) strcat(s, "e");
if (crc32("kDOndE",6) == 1551267506) strcat(s, "W");
if (crc32("zJHsbmZ",7) == 2046875557) strcat(s, "l");
if (crc32("JqaJqoZATKzNa",13) == 244760640) strcat(s, "l");
if (crc32("kYLuCKxgYLXy",12) == 2786551368) strcat(s, "u");
if (crc32("BoRggXGWkRGiPmh",15) == 4148919164) strcat(s, "l");
if (crc32("usCCmJAVVDPhTf",14) == 3489865030) strcat(s, "X");
if (crc32("CJXkfgZjnNrM",12) == 4003570248) strcat(s, "a");
if (crc32("vlZTExMyZp",10) == 97446591) strcat(s, "r");
    return s;
}

char *Augean_adjectives() {
    char *s = calloc(7);
    if (crc32("UyIFmSJKnj",10) == 3826808057) strcat(s, "A");
if (crc32("IwZUOOI",7) == 3484302090) strcat(s, "o");
if (crc32("PNQioi",6) == 3090381184) strcat(s, "u");
if (crc32("xCqwLjgxhk",10) == 1873315014) strcat(s, "q");
if (crc32("gNzpk",5) == 985817070) strcat(s, "g");
if (crc32("UKbZQgVccaCM",12) == 1294565091) strcat(s, "k");
if (crc32("KCPOfExOPQL",11) == 1692159144) strcat(s, "e");
if (crc32("WcpkWBWikKx",11) == 484320525) strcat(s, "a");
if (crc32("cwxBsgz",7) == 1987274776) strcat(s, "S");
if (crc32("UlszkwItl",9) == 1185396933) strcat(s, "n");
    return s;
}

char *unfinanced_adjectives() {
    char *s = calloc(11);
    if (crc32("aHKAgXIQfqOHv",13) == 4179494761) strcat(s, "u");
if (crc32("vBOVl",5) == 1394923711) strcat(s, "Y");
if (crc32("vKzsr",5) == 534440685) strcat(s, "n");
if (crc32("LnjOycGv",8) == 3920448371) strcat(s, "f");
if (crc32("KxuvQc",6) == 1340676833) strcat(s, "B");
if (crc32("LiZMm",5) == 183532823) strcat(s, "i");
if (crc32("IAiPw",5) == 715989790) strcat(s, "y");
if (crc32("dQdIei",6) == 3225393809) strcat(s, "n");
if (crc32("IuNOReJ",7) == 3525251159) strcat(s, "a");
if (crc32("iyhGLoGpwF",10) == 3040278525) strcat(s, "v");
if (crc32("FDnTxcQDdAP",11) == 181658741) strcat(s, "n");
if (crc32("HMJHlL",6) == 3467180139) strcat(s, "c");
if (crc32("EOXiRnLaD",9) == 1351470261) strcat(s, "e");
if (crc32("CAVsYAgxUUOo",12) == 3115709349) strcat(s, "Z");
if (crc32("NAzAtQpBYJnfcPi",15) == 1613973595) strcat(s, "d");
    return s;
}

char *nonsyntonical_adjectives() {
    char *s = calloc(14);
    if (crc32("RYgNUprJnWF",11) == 792284418) strcat(s, "n");
if (crc32("cJkOidLTOVWR",12) == 3865025525) strcat(s, "o");
if (crc32("EtbbmZysKpCXE",13) == 2326322801) strcat(s, "n");
if (crc32("YIMyVcrSVKQdSe",14) == 2055196976) strcat(s, "q");
if (crc32("WGrxqNhCmVvHJWB",15) == 3909523426) strcat(s, "s");
if (crc32("aQpltctlQ",9) == 81721020) strcat(s, "y");
if (crc32("EoBLaGB",7) == 4025715946) strcat(s, "n");
if (crc32("BmFDhE",6) == 4035891061) strcat(s, "t");
if (crc32("pdbaquYWRIpEg",13) == 2717998456) strcat(s, "o");
if (crc32("HUochaexcMi",11) == 974118553) strcat(s, "n");
if (crc32("FGfhwUuOeZilIw",14) == 1028014023) strcat(s, "i");
if (crc32("SGWMtQZV",8) == 1851396202) strcat(s, "S");
if (crc32("GzswWWWk",8) == 3633685541) strcat(s, "c");
if (crc32("Ceaba",5) == 4058131273) strcat(s, "a");
if (crc32("xiJZu",5) == 1419304161) strcat(s, "l");
    return s;
}

char *consecratory_adjectives() {
    char *s = calloc(13);
    if (crc32("VNeMXS",6) == 3880799601) strcat(s, "m");
if (crc32("DzuQlOEhFkz",11) == 1368585939) strcat(s, "c");
if (crc32("SnnRQAykvlzHfg",14) == 2992788494) strcat(s, "E");
if (crc32("jdKZFxwEx",9) == 1806344902) strcat(s, "o");
if (crc32("hYAzivcF",8) == 1614453006) strcat(s, "n");
if (crc32("XowFdXvtXDDVdLd",15) == 722860443) strcat(s, "s");
if (crc32("GPLtCTGEVNM",11) == 2535411782) strcat(s, "e");
if (crc32("lgoGMIATFqIqA",13) == 2918988925) strcat(s, "k");
if (crc32("bvwloluDCGJtG",13) == 1595916464) strcat(s, "c");
if (crc32("XlcmAGbF",8) == 906178655) strcat(s, "q");
if (crc32("aVBDhPQNBumQsSJ",15) == 3692466814) strcat(s, "r");
if (crc32("QTFYCQ",6) == 2352215558) strcat(s, "P");
if (crc32("PgBQvBo",7) == 3052679017) strcat(s, "a");
if (crc32("ByJfSpnF",8) == 642993782) strcat(s, "t");
if (crc32("HFjGImtm",8) == 629014724) strcat(s, "o");
if (crc32("GaWsrnGDJbCMo",13) == 1472027653) strcat(s, "r");
if (crc32("xnSGIZed",8) == 3314549754) strcat(s, "l");
if (crc32("vRLyRVf",7) == 4289596844) strcat(s, "y");
    return s;
}

char *magnetographic_adjectives() {
    char *s = calloc(15);
    if (crc32("FQfIELJrBsHjwq",14) == 1859448082) strcat(s, "e");
if (crc32("chMEnxecHWb",11) == 1113006803) strcat(s, "m");
if (crc32("JVMJI",5) == 2875259898) strcat(s, "b");
if (crc32("FiVkdI",6) == 1486126790) strcat(s, "a");
if (crc32("pmAGpSt",7) == 3221049282) strcat(s, "s");
if (crc32("sChpnE",6) == 1955379423) strcat(s, "g");
if (crc32("xmKZLdEtZkEzkIc",15) == 2825955491) strcat(s, "f");
if (crc32("ncbzhNIxDOZJcxa",15) == 278060221) strcat(s, "n");
if (crc32("gYmbMIiGJWHZ",12) == 1492536152) strcat(s, "A");
if (crc32("cPrHNbO",7) == 1034073954) strcat(s, "e");
if (crc32("JyWdRg",6) == 1143926010) strcat(s, "H");
if (crc32("AHwymHuXqty",11) == 3618213611) strcat(s, "t");
if (crc32("jNgJshOcC",9) == 1772237674) strcat(s, "o");
if (crc32("ScVKw",5) == 635386552) strcat(s, "g");
if (crc32("ANdurT",6) == 877778102) strcat(s, "b");
if (crc32("caTlGFzkNvm",11) == 65323680) strcat(s, "r");
if (crc32("vamPfztxX",9) == 3695006486) strcat(s, "S");
if (crc32("VRYXCgRZtZnEwp",14) == 2799827981) strcat(s, "a");
if (crc32("UHKLERyotkc",11) == 24448341) strcat(s, "u");
if (crc32("duHKrOytibQI",12) == 3553234618) strcat(s, "p");
if (crc32("WGrQQpMoyhSwuI",14) == 468753902) strcat(s, "h");
if (crc32("DkHxszVtyo",10) == 799555140) strcat(s, "i");
if (crc32("CLulTcBRE",9) == 3070891027) strcat(s, "g");
if (crc32("utadFPsRZX",10) == 4015637422) strcat(s, "c");
    return s;
}

char *uncoagulated_adjectives() {
    char *s = calloc(13);
    if (crc32("QYkaBV",6) == 2791759640) strcat(s, "u");
if (crc32("qKjnzMdeQQczHLy",15) == 4002108444) strcat(s, "n");
if (crc32("INoQriZfzctrakZ",15) == 1524565448) strcat(s, "c");
if (crc32("QvnNr",5) == 532511383) strcat(s, "o");
if (crc32("NPJDkvK",7) == 1210132858) strcat(s, "v");
if (crc32("hfXpLLYchGZo",12) == 2837353528) strcat(s, "a");
if (crc32("MpoNnf",6) == 3174604037) strcat(s, "g");
if (crc32("ZpNUgzG",7) == 2076413105) strcat(s, "Y");
if (crc32("cWbRQOaCFEUqmIR",15) == 4259129535) strcat(s, "u");
if (crc32("zWRGBPSbzx",10) == 1609565814) strcat(s, "L");
if (crc32("rBkChbgb",8) == 425905506) strcat(s, "l");
if (crc32("LhjJFGyXLpBryT",14) == 874137850) strcat(s, "t");
if (crc32("uhWOVPvTVxDC",12) == 418935181) strcat(s, "a");
if (crc32("TCwXLpZb",8) == 3107114685) strcat(s, "t");
if (crc32("jXkTZBo",7) == 2594055241) strcat(s, "h");
if (crc32("tjhypQCxb",9) == 586951828) strcat(s, "e");
if (crc32("fyDWsOzINZzJDSE",15) == 3205393664) strcat(s, "i");
if (crc32("uqtSy",5) == 3475265752) strcat(s, "d");
    return s;
}

char *brannew_adjectives() {
    char *s = calloc(8);
    if (crc32("YLWzFt",6) == 1900147534) strcat(s, "r");
if (crc32("OXqHnpRlTppvmK",14) == 1177574771) strcat(s, "b");
if (crc32("DPEzZQcCd",9) == 3982703549) strcat(s, "U");
if (crc32("OgHbywUJit",10) == 1463725625) strcat(s, "r");
if (crc32("tCtYXiVeqODG",12) == 4116738145) strcat(s, "a");
if (crc32("ScBpCfdTheqYu",13) == 1048013038) strcat(s, "n");
if (crc32("KfrOlisvXPfV",12) == 2891096836) strcat(s, "E");
if (crc32("FXtfZuQU",8) == 1375793914) strcat(s, "n");
if (crc32("GyDvjEatbbw",11) == 2504837752) strcat(s, "e");
if (crc32("Iqpmql",6) == 70757971) strcat(s, "w");
    return s;
}

char *nonblocking_adjectives() {
    char *s = calloc(12);
    if (crc32("czMRyOG",7) == 2291476566) strcat(s, "n");
if (crc32("bfVAHTDz",8) == 2971566078) strcat(s, "o");
if (crc32("cdrlWZ",6) == 3060063047) strcat(s, "T");
if (crc32("nXpmXUIWnsOtt",13) == 923562736) strcat(s, "n");
if (crc32("XcVjDUtGRm",10) == 1598403668) strcat(s, "W");
if (crc32("bAcqNJhPFEdOkm",14) == 1694342909) strcat(s, "b");
if (crc32("KFBDIQHxFPK",11) == 1261299463) strcat(s, "k");
if (crc32("HXpjPixDqKYPxhP",15) == 1084345476) strcat(s, "l");
if (crc32("HSmXnkGLQqTk",12) == 1187354843) strcat(s, "N");
if (crc32("EsfPe",5) == 3833745479) strcat(s, "o");
if (crc32("bDeFrVEjyijp",12) == 1410836547) strcat(s, "k");
if (crc32("EQFVyFmuF",9) == 3519659565) strcat(s, "c");
if (crc32("WYUmHkvZuLcAlSs",15) == 3376053473) strcat(s, "k");
if (crc32("BYoHZgecsyZvHQd",15) == 2500702320) strcat(s, "s");
if (crc32("aCObfWf",7) == 1872537745) strcat(s, "i");
if (crc32("IecMtJfkvoX",11) == 3173164670) strcat(s, "n");
if (crc32("pqBfnMQRbtnOsWz",15) == 3723485236) strcat(s, "g");
    return s;
}

char *unnosed_adjectives() {
    char *s = calloc(8);
    if (crc32("QujMzxT",7) == 1030717210) strcat(s, "a");
if (crc32("HKOYXfU",7) == 2847442733) strcat(s, "u");
if (crc32("qxWfrCRUJgar",12) == 384266560) strcat(s, "K");
if (crc32("GgmuqCgIB",9) == 2394445164) strcat(s, "n");
if (crc32("AKxzl",5) == 613604415) strcat(s, "n");
if (crc32("UVidbWGw",8) == 4063054777) strcat(s, "o");
if (crc32("cyndiwJ",7) == 3946758153) strcat(s, "V");
if (crc32("hpQzTYzlM",9) == 1630320389) strcat(s, "s");
if (crc32("FQEMhyariSSJRe",14) == 2985166467) strcat(s, "e");
if (crc32("HkJpOOjrw",9) == 3605535526) strcat(s, "B");
if (crc32("EfZaGC",6) == 1164787624) strcat(s, "d");
    return s;
}

char *exequial_adjectives() {
    char *s = calloc(9);
    if (crc32("biCNqaIigUWYJqR",15) == 3049670915) strcat(s, "S");
if (crc32("IqIJGscAsGMPggb",15) == 4270454648) strcat(s, "e");
if (crc32("SINKRYwHkmnwzAo",15) == 705892162) strcat(s, "x");
if (crc32("iOlNCYwtXFfrMxD",15) == 79046696) strcat(s, "a");
if (crc32("GKzktU",6) == 2632880031) strcat(s, "e");
if (crc32("JeRteRPxvPJwL",13) == 294250124) strcat(s, "D");
if (crc32("VjqOTRCUZsWYFGT",15) == 513603230) strcat(s, "q");
if (crc32("cHQgqW",6) == 3008675990) strcat(s, "N");
if (crc32("lxOEkJSaRmBRO",13) == 2781451365) strcat(s, "u");
if (crc32("pOelyBLICG",10) == 1974542551) strcat(s, "X");
if (crc32("zaJIHvzkCUfcfi",14) == 3708351351) strcat(s, "i");
if (crc32("PwUJyDGMU",9) == 2840894993) strcat(s, "a");
if (crc32("jxGaIPhDW",9) == 2881872877) strcat(s, "a");
if (crc32("PocfhGiNjtNtoIK",15) == 2451980832) strcat(s, "l");
    return s;
}

char *quasiunified_adjectives() {
    char *s = calloc(13);
    if (crc32("CnqpHtlGJCt",11) == 3726876890) strcat(s, "B");
if (crc32("eruuulVHKkAwUOV",15) == 555561321) strcat(s, "q");
if (crc32("qabyQrJPeltTzD",14) == 3184306122) strcat(s, "n");
if (crc32("COAJOwV",7) == 504041614) strcat(s, "u");
if (crc32("RxwbA",5) == 768927027) strcat(s, "a");
if (crc32("ulWoBOqAH",9) == 1867590727) strcat(s, "m");
if (crc32("aTQVP",5) == 3438010036) strcat(s, "s");
if (crc32("GtoYGoSp",8) == 371680162) strcat(s, "i");
if (crc32("swsPfH",6) == 1219274895) strcat(s, "H");
if (crc32("kqilVssXNp",10) == 4019769182) strcat(s, "u");
if (crc32("gEyKWWtQaicz",12) == 3226894600) strcat(s, "n");
if (crc32("dmYxULgX",8) == 161597014) strcat(s, "j");
if (crc32("qfPQlXGdjzgVU",13) == 3258198873) strcat(s, "i");
if (crc32("ftbFEGo",7) == 1539093304) strcat(s, "h");
if (crc32("lzYwvnqVAv",10) == 1052105677) strcat(s, "f");
if (crc32("bFRpiTfABn",10) == 3724504414) strcat(s, "v");
if (crc32("xXwGtmmu",8) == 2721559645) strcat(s, "i");
if (crc32("jHgmydFnhGgomPt",15) == 1561669588) strcat(s, "D");
if (crc32("xaIsEwUY",8) == 2306622781) strcat(s, "e");
if (crc32("FWnPOMw",7) == 3057876694) strcat(s, "d");
    return s;
}

char *nondelicate_adjectives() {
    char *s = calloc(12);
    if (crc32("ODqCKuPLzUeMqpy",15) == 2335807255) strcat(s, "o");
if (crc32("XNRUWo",6) == 2505593145) strcat(s, "n");
if (crc32("nKwrnhIE",8) == 2131153822) strcat(s, "T");
if (crc32("tZCaQDtlA",9) == 3011864146) strcat(s, "o");
if (crc32("lQJbwsobAOs",11) == 3036368161) strcat(s, "G");
if (crc32("IJRmUBS",7) == 872002617) strcat(s, "n");
if (crc32("eqzqqVaTt",9) == 4062119209) strcat(s, "d");
if (crc32("XpoOfxX",7) == 2423078962) strcat(s, "e");
if (crc32("mbSAOlba",8) == 849878699) strcat(s, "l");
if (crc32("LLkQO",5) == 2342695173) strcat(s, "i");
if (crc32("uxuEgZcpUFKuLN",14) == 2051720809) strcat(s, "c");
if (crc32("uOuoY",5) == 3664042786) strcat(s, "E");
if (crc32("QBMSOFkzC",9) == 1560643333) strcat(s, "a");
if (crc32("UEppUzEKV",9) == 1264462995) strcat(s, "t");
if (crc32("SKKDFGIixlcQIO",14) == 3470305284) strcat(s, "e");
    return s;
}

char *histiocytic_adjectives() {
    char *s = calloc(12);
    if (crc32("MdveMCxTyebjVr",14) == 3993746986) strcat(s, "U");
if (crc32("BrfAr",5) == 1041518053) strcat(s, "h");
if (crc32("CuBUZXZ",7) == 4118224001) strcat(s, "i");
if (crc32("QuRdSc",6) == 787476225) strcat(s, "j");
if (crc32("olDUkAPm",8) == 1342346346) strcat(s, "s");
if (crc32("pEkawGTjIoPv",12) == 751879847) strcat(s, "J");
if (crc32("yPbnMgbwYjA",11) == 949694526) strcat(s, "t");
if (crc32("aKIuxvopaNVKBWR",15) == 3557740068) strcat(s, "i");
if (crc32("ueyEe",5) == 216700404) strcat(s, "R");
if (crc32("RxtOfcqBCWx",11) == 3110604315) strcat(s, "o");
if (crc32("BXEkGpDjkdQCwg",14) == 2130126287) strcat(s, "l");
if (crc32("ZSLUAUuvx",9) == 3925192326) strcat(s, "c");
if (crc32("coWoUothC",9) == 4112065714) strcat(s, "t");
if (crc32("RtvtFF",6) == 3638984122) strcat(s, "y");
if (crc32("bZOiIueHiUm",11) == 893493182) strcat(s, "t");
if (crc32("ZBpdOpXGjwr",11) == 3811562317) strcat(s, "i");
if (crc32("HSvdDxoAev",10) == 2338059170) strcat(s, "R");
if (crc32("xRUPfGsG",8) == 1304377025) strcat(s, "c");
    return s;
}

char *unsymptomatical_adjectives() {
    char *s = calloc(16);
    if (crc32("euZXAU",6) == 3971291908) strcat(s, "u");
if (crc32("CXsHiKNyqbmQhFd",15) == 1993501031) strcat(s, "n");
if (crc32("GcUAgmYIkAHnv",13) == 268702299) strcat(s, "P");
if (crc32("izqDzVQ",7) == 1356105932) strcat(s, "s");
if (crc32("TFMxQLEb",8) == 3446831101) strcat(s, "y");
if (crc32("kaniwbQOH",9) == 1749622624) strcat(s, "m");
if (crc32("SRetiSSrLF",10) == 1893168509) strcat(s, "p");
if (crc32("JztiaBYpm",9) == 2701144031) strcat(s, "u");
if (crc32("gPVcPJbadpiscL",14) == 761429264) strcat(s, "t");
if (crc32("ZfzwQi",6) == 3002575863) strcat(s, "y");
if (crc32("GvMKzkOjpB",10) == 2638221155) strcat(s, "o");
if (crc32("xPxaHHpQi",9) == 348784705) strcat(s, "p");
if (crc32("WqkxqGxmT",9) == 3670421176) strcat(s, "m");
if (crc32("mSxnyMvDpqLLT",13) == 275987076) strcat(s, "a");
if (crc32("oMaUTjKRghZ",11) == 2239305121) strcat(s, "w");
if (crc32("qeGWZvyTzuBF",12) == 776215956) strcat(s, "t");
if (crc32("tHZlsS",6) == 1526663685) strcat(s, "i");
if (crc32("NrbxowtEzBMWv",13) == 3105160877) strcat(s, "c");
if (crc32("dSMcpRkEPDbo",12) == 1127625791) strcat(s, "E");
if (crc32("EuMRExquf",9) == 1863607460) strcat(s, "a");
if (crc32("MWTqUXGqBif",11) == 147714084) strcat(s, "U");
if (crc32("ZAEst",5) == 2986528532) strcat(s, "l");
    return s;
}

char *stealthier_adjectives() {
    char *s = calloc(11);
    if (crc32("UXhrXN",6) == 3280147743) strcat(s, "Y");
if (crc32("DQaCioxl",8) == 938206466) strcat(s, "s");
if (crc32("HidUfW",6) == 3731929319) strcat(s, "t");
if (crc32("AGJXwgnwU",9) == 1195831833) strcat(s, "R");
if (crc32("KhsXcGVWIQ",10) == 2390721270) strcat(s, "e");
if (crc32("nOnSHoneAs",10) == 3073470052) strcat(s, "a");
if (crc32("znUDjxIqHc",10) == 71036116) strcat(s, "l");
if (crc32("xZibMqQqLg",10) == 3960065585) strcat(s, "t");
if (crc32("kYgkt",5) == 37497733) strcat(s, "h");
if (crc32("jMPSMDGl",8) == 3946543038) strcat(s, "R");
if (crc32("rieNIJlO",8) == 2662948728) strcat(s, "i");
if (crc32("pRmPkjQoSO",10) == 2622479966) strcat(s, "x");
if (crc32("SfedE",5) == 4008179886) strcat(s, "e");
if (crc32("VLzxaPmkopOi",12) == 3530687685) strcat(s, "E");
if (crc32("edItQYkoiqrZ",12) == 938729271) strcat(s, "r");
    return s;
}

char *barruly_adjectives() {
    char *s = calloc(8);
    if (crc32("xXFJdS",6) == 1850805023) strcat(s, "b");
if (crc32("NfKsnfGU",8) == 1495555522) strcat(s, "a");
if (crc32("eTqaAZp",7) == 3395938594) strcat(s, "b");
if (crc32("katcpfjOHrign",13) == 2021156590) strcat(s, "r");
if (crc32("EJpMyjnOPp",10) == 3959946594) strcat(s, "r");
if (crc32("MUCVZcYIVEG",11) == 1370978061) strcat(s, "l");
if (crc32("wQYqM",5) == 2739258272) strcat(s, "u");
if (crc32("xUeipmZdQ",9) == 176758439) strcat(s, "l");
if (crc32("oERABU",6) == 291595063) strcat(s, "y");
    return s;
}

char *unemitted_adjectives() {
    char *s = calloc(10);
    if (crc32("rJotxXSXPdaH",12) == 3081694549) strcat(s, "y");
if (crc32("eMgxCPn",7) == 282108978) strcat(s, "u");
if (crc32("UiiFpBi",7) == 1379078930) strcat(s, "g");
if (crc32("ZQOCacnskC",10) == 1415819642) strcat(s, "n");
if (crc32("WVRKoaCII",9) == 1983483514) strcat(s, "e");
if (crc32("RZNieI",6) == 2841667138) strcat(s, "m");
if (crc32("ngxtGM",6) == 2788768166) strcat(s, "Z");
if (crc32("mulKmjNEgdKGQzP",15) == 3748556821) strcat(s, "i");
if (crc32("kNtIgGdMBpSYi",13) == 3167492330) strcat(s, "t");
if (crc32("IOQykhCEdvD",11) == 3691853162) strcat(s, "t");
if (crc32("aBnvwNNVVy",10) == 1077210678) strcat(s, "t");
if (crc32("oiPjdqQIj",9) == 2120092217) strcat(s, "e");
if (crc32("kSvAhkEzhQ",10) == 1202717367) strcat(s, "d");
    return s;
}

char *synecdochic_adjectives() {
    char *s = calloc(12);
    if (crc32("JcTpzHSzSgwnSG",14) == 792498289) strcat(s, "f");
if (crc32("SjRVAyzAXkjTOz",14) == 4202857645) strcat(s, "s");
if (crc32("BtjvLjUBbk",10) == 395260) strcat(s, "L");
if (crc32("aTbITuA",7) == 444242829) strcat(s, "y");
if (crc32("mNMYVwsOpJE",11) == 1727404093) strcat(s, "n");
if (crc32("bMLnchzNrd",10) == 2995562254) strcat(s, "e");
if (crc32("PmMVlrdVSH",10) == 3438217873) strcat(s, "c");
if (crc32("upskpwMWJYK",11) == 3393647536) strcat(s, "g");
if (crc32("JnLuDjLlQ",9) == 3856430146) strcat(s, "d");
if (crc32("aJHjhfem",8) == 818960623) strcat(s, "o");
if (crc32("dlzsEPIBECGP",12) == 1619204533) strcat(s, "c");
if (crc32("sReABCope",9) == 3644453301) strcat(s, "P");
if (crc32("XmVINsoG",8) == 2702545329) strcat(s, "h");
if (crc32("bhzkv",5) == 1706619892) strcat(s, "M");
if (crc32("adkraBKhr",9) == 3427059208) strcat(s, "i");
if (crc32("aBOUCFlzU",9) == 122346700) strcat(s, "O");
if (crc32("VMdVzAZxbadG",12) == 3863176856) strcat(s, "c");
    return s;
}

char *unrespired_adjectives() {
    char *s = calloc(11);
    if (crc32("TTPlTpH",7) == 3290907296) strcat(s, "p");
if (crc32("WmjIRpHJgPLGn",13) == 3101316905) strcat(s, "u");
if (crc32("RARGhbIxZw",10) == 884162575) strcat(s, "n");
if (crc32("UOzZcByHDM",10) == 2520917353) strcat(s, "F");
if (crc32("TldnnG",6) == 2681496938) strcat(s, "r");
if (crc32("asawIHWaNkWBJT",14) == 3579618954) strcat(s, "f");
if (crc32("BulGfGk",7) == 1712589588) strcat(s, "e");
if (crc32("lZrRoksTlZQ",11) == 3764620784) strcat(s, "R");
if (crc32("XssngrHdDEJdd",13) == 2731255819) strcat(s, "s");
if (crc32("bbwtWDBBypygt",13) == 518041525) strcat(s, "p");
if (crc32("fUMNbPMaGbeapW",14) == 3449339365) strcat(s, "i");
if (crc32("aaZjsQGAl",9) == 743854281) strcat(s, "h");
if (crc32("LqKYTLJiT",9) == 1790824084) strcat(s, "r");
if (crc32("JljdNVtflGb",11) == 2296533486) strcat(s, "e");
if (crc32("bhiXSxNyZp",10) == 1381694771) strcat(s, "k");
if (crc32("WqvIZlSMTzcTIf",14) == 2605213287) strcat(s, "d");
    return s;
}

char *preflood_adjectives() {
    char *s = calloc(9);
    if (crc32("stuBhkkX",8) == 2142223102) strcat(s, "p");
if (crc32("CFrRIszQqr",10) == 373710152) strcat(s, "r");
if (crc32("ETbBZJOrOmY",11) == 2570955313) strcat(s, "p");
if (crc32("MrIpmsZteTT",11) == 1466049264) strcat(s, "e");
if (crc32("ydXQWiev",8) == 592897437) strcat(s, "F");
if (crc32("NzQLRA",6) == 3029688418) strcat(s, "f");
if (crc32("qRqHNuXbVrA",11) == 838919378) strcat(s, "D");
if (crc32("vvJWat",6) == 2902406591) strcat(s, "l");
if (crc32("FWyuUC",6) == 27188918) strcat(s, "R");
if (crc32("QDOzRYsNSJmuhi",14) == 2272212079) strcat(s, "o");
if (crc32("sjKdkFbplj",10) == 684081887) strcat(s, "o");
if (crc32("OYogOmbnQIQ",11) == 1548319280) strcat(s, "d");
    return s;
}

char *unhashed_adjectives() {
    char *s = calloc(9);
    if (crc32("IUIeBYI",7) == 1589644574) strcat(s, "u");
if (crc32("wmchVmbVAdgk",12) == 3595221465) strcat(s, "u");
if (crc32("XLCeqadDySrPs",13) == 148986900) strcat(s, "n");
if (crc32("YCRSVWjbZJ",10) == 2430688162) strcat(s, "H");
if (crc32("HoEtpHQzkYq",11) == 2643767878) strcat(s, "h");
if (crc32("hqaSOzEal",9) == 3217003979) strcat(s, "p");
if (crc32("FLVBtyC",7) == 112455150) strcat(s, "a");
if (crc32("sFrvaMfejlndHtZ",15) == 4232569181) strcat(s, "k");
if (crc32("qOBRdv",6) == 1305321629) strcat(s, "s");
if (crc32("nYbELODNJE",10) == 112667273) strcat(s, "u");
if (crc32("NrNxEBIWMncR",12) == 1070502333) strcat(s, "h");
if (crc32("YCmlPphPhvyqmdk",15) == 2475742950) strcat(s, "e");
if (crc32("RlStzNKsdGEVY",13) == 977731576) strcat(s, "E");
if (crc32("aheVhFAdMqwNRtv",15) == 4284836068) strcat(s, "d");
    return s;
}

char *adynamic_adjectives() {
    char *s = calloc(9);
    if (crc32("xgVzKCKLKVNmw",13) == 2719593731) strcat(s, "a");
if (crc32("LYHmYpufU",9) == 1944642829) strcat(s, "d");
if (crc32("NWwepJVGKk",10) == 1106124829) strcat(s, "y");
if (crc32("imXbTFAyce",10) == 2995958460) strcat(s, "n");
if (crc32("yBmVTlCeiCvtZHK",15) == 352031079) strcat(s, "x");
if (crc32("JhxTcTvnfqgDWS",14) == 2497249495) strcat(s, "a");
if (crc32("XWINWjtV",8) == 931624281) strcat(s, "p");
if (crc32("YvrHPdfoTFZbB",13) == 2346071067) strcat(s, "m");
if (crc32("TCRTif",6) == 2327623650) strcat(s, "E");
if (crc32("HcGLgNdkNin",11) == 1727712218) strcat(s, "i");
if (crc32("JuOtRxuoBwrVzEl",15) == 3879891704) strcat(s, "c");
    return s;
}

char *pizzicato_adjectives() {
    char *s = calloc(10);
    if (crc32("lSukrSaFnm",10) == 136730073) strcat(s, "p");
if (crc32("zBeWLFBN",8) == 2719877198) strcat(s, "X");
if (crc32("idZbxbWz",8) == 996853567) strcat(s, "i");
if (crc32("mSAdTcbNJHbQpgq",15) == 261068665) strcat(s, "z");
if (crc32("unwadCIvO",9) == 3923647310) strcat(s, "V");
if (crc32("iVjukQNtVVBeSnr",15) == 820829574) strcat(s, "z");
if (crc32("qRPDgy",6) == 2358574378) strcat(s, "i");
if (crc32("uIesDRMeBG",10) == 534729681) strcat(s, "c");
if (crc32("OSkiaVIW",8) == 3660730432) strcat(s, "t");
if (crc32("tuiExIRUlb",10) == 2896072825) strcat(s, "a");
if (crc32("ATRaRilqCotQEiV",15) == 605846255) strcat(s, "t");
if (crc32("XbmOrdJb",8) == 3066238426) strcat(s, "o");
    return s;
}

char *unassuageable_adjectives() {
    char *s = calloc(14);
    if (crc32("nBamsqdKSDg",11) == 3892055986) strcat(s, "u");
if (crc32("OSbugQAJurSBiiv",15) == 2430377052) strcat(s, "R");
if (crc32("zFGKqNWbx",9) == 1473907128) strcat(s, "n");
if (crc32("VYlzMKj",7) == 2273585259) strcat(s, "A");
if (crc32("eeycz",5) == 1042873224) strcat(s, "a");
if (crc32("FRgwOlJDry",10) == 3394067514) strcat(s, "s");
if (crc32("BnkvJQloqdQmoJj",15) == 4030186067) strcat(s, "s");
if (crc32("QomhLI",6) == 1894782679) strcat(s, "U");
if (crc32("bqWcEllpOc",10) == 2985395546) strcat(s, "u");
if (crc32("gZpvkoxmeAvdY",13) == 587019287) strcat(s, "a");
if (crc32("kaLsBFAI",8) == 1047994397) strcat(s, "a");
if (crc32("GYFbB",5) == 570092423) strcat(s, "g");
if (crc32("xMqMDasiOU",10) == 1452609186) strcat(s, "W");
if (crc32("wAogDLv",7) == 1594701352) strcat(s, "e");
if (crc32("hPtCYmMFVmQyQj",14) == 4011770271) strcat(s, "a");
if (crc32("tNOVutfUfzCOha",14) == 908222224) strcat(s, "v");
if (crc32("UPtehyuQ",8) == 1908808820) strcat(s, "b");
if (crc32("gpWuYVb",7) == 2378478839) strcat(s, "s");
if (crc32("xyfUgUynUePKAv",14) == 1918180050) strcat(s, "l");
if (crc32("yjETUQh",7) == 321994834) strcat(s, "e");
    return s;
}

char *halfrotten_adjectives() {
    char *s = calloc(11);
    if (crc32("RAFqXMs",7) == 1954996313) strcat(s, "o");
if (crc32("qWBswfumHzNNa",13) == 2040130146) strcat(s, "h");
if (crc32("oatvR",5) == 4045580739) strcat(s, "a");
if (crc32("wBVnxi",6) == 550785184) strcat(s, "P");
if (crc32("VTJqd",5) == 887664739) strcat(s, "l");
if (crc32("oBTQa",5) == 519912576) strcat(s, "f");
if (crc32("CkSYWZzwVrCZSy",14) == 556034227) strcat(s, "q");
if (crc32("DoWEg",5) == 1061132623) strcat(s, "r");
if (crc32("VvjAGa",6) == 4179370215) strcat(s, "R");
if (crc32("nzSUGVDxIr",10) == 2538026410) strcat(s, "o");
if (crc32("yFelEPvxV",9) == 410750480) strcat(s, "F");
if (crc32("ZRKxkmqnYD",10) == 855333330) strcat(s, "t");
if (crc32("AmsfvT",6) == 1300924969) strcat(s, "O");
if (crc32("GPDFLgrjAQ",10) == 1162010880) strcat(s, "t");
if (crc32("CuizdEgcPiS",11) == 303264471) strcat(s, "l");
if (crc32("wthpCzscpc",10) == 1191689432) strcat(s, "e");
if (crc32("kSJnwhyRRnfmFX",14) == 1879448146) strcat(s, "n");
    return s;
}

char *evidential_adjectives() {
    char *s = calloc(11);
    if (crc32("YBEZWDutq",9) == 2428926609) strcat(s, "m");
if (crc32("edeuj",5) == 2458346314) strcat(s, "e");
if (crc32("aZgxYgeAxdZpH",13) == 3297543567) strcat(s, "v");
if (crc32("rvwSLqSFNqPuP",13) == 729750135) strcat(s, "w");
if (crc32("quoMQrdNj",9) == 1667202607) strcat(s, "i");
if (crc32("fajCdrd",7) == 4102635432) strcat(s, "d");
if (crc32("gnsPTfrC",8) == 3815117492) strcat(s, "I");
if (crc32("etgggFvexK",10) == 701948212) strcat(s, "e");
if (crc32("JLtffDYFuFg",11) == 2956001649) strcat(s, "n");
if (crc32("fixREkNioa",10) == 3789076646) strcat(s, "V");
if (crc32("TcbNCYzU",8) == 2297621183) strcat(s, "t");
if (crc32("EUZVMHvtqnsF",12) == 2816132122) strcat(s, "B");
if (crc32("gghPEpBvV",9) == 3282919342) strcat(s, "i");
if (crc32("JetsDk",6) == 2991367047) strcat(s, "a");
if (crc32("rJspkDCXil",10) == 1078494788) strcat(s, "l");
    return s;
}

char *unassignable_adjectives() {
    char *s = calloc(13);
    if (crc32("wirJW",5) == 1662168237) strcat(s, "u");
if (crc32("gVUshJcSXjJEFk",14) == 3237019821) strcat(s, "I");
if (crc32("chBbkYFGplefVDL",15) == 3305635010) strcat(s, "n");
if (crc32("SogYNyhDjNkWZ",13) == 1090823466) strcat(s, "a");
if (crc32("FMwpavhQIty",11) == 824504127) strcat(s, "a");
if (crc32("GdrbfYgTDUD",11) == 1830244307) strcat(s, "s");
if (crc32("TgSXdNxKHWJzcRg",15) == 3626043160) strcat(s, "N");
if (crc32("UjNFSSZLuHfxecw",15) == 2905387488) strcat(s, "s");
if (crc32("BOEycZBQNDobPY",14) == 160314260) strcat(s, "s");
if (crc32("etCHeMPlRWGV",12) == 1296309112) strcat(s, "i");
if (crc32("PhpzxomAnLaKJ",13) == 1617803887) strcat(s, "g");
if (crc32("mysJbEKG",8) == 3473521072) strcat(s, "G");
if (crc32("wvUxtK",6) == 3709561639) strcat(s, "n");
if (crc32("DISHHPx",7) == 4155270516) strcat(s, "r");
if (crc32("MsnkzbjVkfC",11) == 3660962600) strcat(s, "a");
if (crc32("HdfIKUHbonxXeE",14) == 3499127896) strcat(s, "D");
if (crc32("rRXqJFdy",8) == 3011828975) strcat(s, "b");
if (crc32("LdQebJDgaJJQzl",14) == 1449180324) strcat(s, "l");
if (crc32("TrEEX",5) == 2779681655) strcat(s, "o");
if (crc32("PooPaRJ",7) == 3236254263) strcat(s, "e");
    return s;
}

char *gentlemanlike_adjectives() {
    char *s = calloc(14);
    if (crc32("SYPKzfybn",9) == 2856047868) strcat(s, "g");
if (crc32("xamXTpQMlMLp",12) == 2056542611) strcat(s, "e");
if (crc32("jdnJbEefM",9) == 876731266) strcat(s, "n");
if (crc32("AgmgClzz",8) == 4228912225) strcat(s, "t");
if (crc32("zmQgGKdG",8) == 3442898734) strcat(s, "l");
if (crc32("AHIeQ",5) == 2260516601) strcat(s, "e");
if (crc32("mGSajPYjlh",10) == 374908039) strcat(s, "o");
if (crc32("lZDnDPsk",8) == 1907371533) strcat(s, "m");
if (crc32("TkZkIyaLhpZcnx",14) == 1412322561) strcat(s, "a");
if (crc32("MpQfuGciJ",9) == 556694172) strcat(s, "W");
if (crc32("CIvmwpG",7) == 3913220767) strcat(s, "n");
if (crc32("nmblXu",6) == 1618027350) strcat(s, "l");
if (crc32("DSrBLlaIPIlTY",13) == 3388196484) strcat(s, "V");
if (crc32("FmuOtvWyQW",10) == 914715960) strcat(s, "i");
if (crc32("qSmhCMT",7) == 2572453268) strcat(s, "k");
if (crc32("KHUNzDlWFOhoX",13) == 1398124020) strcat(s, "m");
if (crc32("sVcnPFQyzECwH",13) == 2620791971) strcat(s, "e");
    return s;
}

char *preservable_adjectives() {
    char *s = calloc(12);
    if (crc32("tfEBadjE",8) == 1947009818) strcat(s, "G");
if (crc32("kzCafiVRoMm",11) == 651317401) strcat(s, "p");
if (crc32("DCABaWBDzktYK",13) == 1285680433) strcat(s, "X");
if (crc32("bQbkuYL",7) == 258690258) strcat(s, "r");
if (crc32("UIlZoTanftKhV",13) == 2930116004) strcat(s, "e");
if (crc32("bLqpmMORtfZqE",13) == 843087600) strcat(s, "s");
if (crc32("RCRLxM",6) == 416831384) strcat(s, "e");
if (crc32("fEiYk",5) == 2961921583) strcat(s, "N");
if (crc32("MJBEmfWMvBANCLa",15) == 595518888) strcat(s, "r");
if (crc32("EfgLoSnEiGyKE",13) == 2504383174) strcat(s, "v");
if (crc32("ycBMQGmMgxrRWx",14) == 3159484422) strcat(s, "a");
if (crc32("hKlvjkOH",8) == 914044516) strcat(s, "b");
if (crc32("XTLHc",5) == 2453542543) strcat(s, "g");
if (crc32("Ljvxkw",6) == 1174705155) strcat(s, "l");
if (crc32("CZIGCCGC",8) == 746684097) strcat(s, "e");
    return s;
}

char *quasiLatin_adjectives() {
    char *s = calloc(11);
    if (crc32("YNOdFkqyeMHUV",13) == 2153770581) strcat(s, "q");
if (crc32("FcukondEdZ",10) == 3954773685) strcat(s, "E");
if (crc32("nqgwEzpmZiZYkb",14) == 4198271950) strcat(s, "u");
if (crc32("DhXVE",5) == 490464957) strcat(s, "a");
if (crc32("oTndc",5) == 239925023) strcat(s, "s");
if (crc32("FaJQJEGugBniIP",14) == 2099128644) strcat(s, "P");
if (crc32("AKgxlpxBEyz",11) == 3663456386) strcat(s, "i");
if (crc32("MuzldBenJmS",11) == 3948356828) strcat(s, "K");
if (crc32("kklUu",5) == 1653202853) strcat(s, "L");
if (crc32("yQdBruGLAIh",11) == 647937531) strcat(s, "B");
if (crc32("zCvYpug",7) == 1228958854) strcat(s, "a");
if (crc32("YIagaLq",7) == 3940419339) strcat(s, "g");
if (crc32("DSpfAogTkUTjq",13) == 3284562809) strcat(s, "t");
if (crc32("UIptnHaTRJGndP",14) == 1047564097) strcat(s, "i");
if (crc32("UstZn",5) == 3014409678) strcat(s, "R");
if (crc32("aYKWbwRLE",9) == 2426897320) strcat(s, "n");
    return s;
}

char *nonincorporated_adjectives() {
    char *s = calloc(16);
    if (crc32("HbTNH",5) == 3639785453) strcat(s, "v");
if (crc32("TjOFZjDaC",9) == 558300059) strcat(s, "n");
if (crc32("QDbpWCMS",8) == 1672939073) strcat(s, "o");
if (crc32("AmAvmZniOkRL",12) == 3768413598) strcat(s, "r");
if (crc32("UyGSFCSjgGEzhp",14) == 2645462539) strcat(s, "n");
if (crc32("cIXfGCjCnKaRBI",14) == 176713994) strcat(s, "i");
if (crc32("FybenLotL",9) == 1023161408) strcat(s, "n");
if (crc32("wTsRNErB",8) == 1316487684) strcat(s, "e");
if (crc32("gLNlCHtCBwwDQ",13) == 2280184376) strcat(s, "c");
if (crc32("vEEreqw",7) == 3758276862) strcat(s, "Y");
if (crc32("qyNpfApO",8) == 383859347) strcat(s, "o");
if (crc32("AsHctCRlBFh",11) == 1854754738) strcat(s, "r");
if (crc32("UKBxdVskJSdHpq",14) == 2417523975) strcat(s, "o");
if (crc32("dMmDNnqWRuHGH",13) == 1287828832) strcat(s, "p");
if (crc32("AMLnoDoqxpCA",12) == 1558495072) strcat(s, "W");
if (crc32("xzuNJ",5) == 2714467413) strcat(s, "o");
if (crc32("mvvpZNrG",8) == 179878996) strcat(s, "e");
if (crc32("mbBIeIbyYde",11) == 3093008719) strcat(s, "r");
if (crc32("wqXvbueQ",8) == 3625216057) strcat(s, "a");
if (crc32("rLkTe",5) == 863996529) strcat(s, "t");
if (crc32("LqxkDoOQDt",10) == 3488204652) strcat(s, "G");
if (crc32("CbZnyOhbTrn",11) == 2953288748) strcat(s, "e");
if (crc32("jHEvoGssgl",10) == 4231283958) strcat(s, "d");
    return s;
}

char *nonabstaining_adjectives() {
    char *s = calloc(14);
    if (crc32("USGxkFv",7) == 2243148368) strcat(s, "I");
if (crc32("isazvjxgaC",10) == 769001910) strcat(s, "n");
if (crc32("bmKIASbDXuYULTU",15) == 1429607896) strcat(s, "o");
if (crc32("MTwrKzwMcwf",11) == 1098398685) strcat(s, "D");
if (crc32("toeewAAFXMjOSoi",15) == 2836768250) strcat(s, "n");
if (crc32("vSNKCPdhjgGrLcI",15) == 1933085417) strcat(s, "a");
if (crc32("NzLGKmNaHr",10) == 1235392556) strcat(s, "b");
if (crc32("TufeILl",7) == 663568802) strcat(s, "j");
if (crc32("PEqPcZeEqfNfVh",14) == 2361579370) strcat(s, "s");
if (crc32("XEXNQHNLR",9) == 2481516855) strcat(s, "t");
if (crc32("VZSWjEJHOEN",11) == 446337538) strcat(s, "a");
if (crc32("CvzEZHgPCb",10) == 1227783341) strcat(s, "i");
if (crc32("FMnWJQDSJqLZ",12) == 3223804785) strcat(s, "n");
if (crc32("eKkrg",5) == 195729929) strcat(s, "Q");
if (crc32("ajoiXvpoxQzSanI",15) == 3777112806) strcat(s, "i");
if (crc32("EhLIam",6) == 2792951865) strcat(s, "n");
if (crc32("kcOtfpkPUmDYS",13) == 2615537980) strcat(s, "o");
if (crc32("hSRoLMed",8) == 3588234648) strcat(s, "g");
    return s;
}

char *unJesuitical_adjectives() {
    char *s = calloc(13);
    if (crc32("HEXxfmjKwtKWtBE",15) == 271753096) strcat(s, "u");
if (crc32("vqTiDsAkIjFIsM",14) == 667934292) strcat(s, "G");
if (crc32("oZQch",5) == 423062990) strcat(s, "n");
if (crc32("aevoHEEidjJiu",13) == 2017629685) strcat(s, "m");
if (crc32("BshJRjCY",8) == 3361300953) strcat(s, "J");
if (crc32("QSVESSlyzkWGJlk",15) == 3367834524) strcat(s, "e");
if (crc32("DBRbUJzScaygPZ",14) == 2478848080) strcat(s, "E");
if (crc32("Omtva",5) == 3320141929) strcat(s, "s");
if (crc32("ajhyIl",6) == 1642416060) strcat(s, "u");
if (crc32("XwpCBWiGDN",10) == 4195451716) strcat(s, "i");
if (crc32("PVUyREjfbeBtsyd",15) == 1196937915) strcat(s, "C");
if (crc32("xomkahNcx",9) == 471987577) strcat(s, "t");
if (crc32("KZscXe",6) == 2532800041) strcat(s, "R");
if (crc32("qZKLwLvukqedX",13) == 3863926717) strcat(s, "i");
if (crc32("qoztd",5) == 192632716) strcat(s, "S");
if (crc32("hsdwOY",6) == 1807422096) strcat(s, "c");
if (crc32("QMdktIBnP",9) == 3940899561) strcat(s, "a");
if (crc32("uyCUeORzPW",10) == 2354688743) strcat(s, "a");
if (crc32("dKfpeDKmcqUW",12) == 1875458398) strcat(s, "C");
if (crc32("VUHuowTRJbQ",11) == 3568245354) strcat(s, "l");
    return s;
}

char *pericarditic_adjectives() {
    char *s = calloc(13);
    if (crc32("guSzLgfgTjQO",12) == 3877590195) strcat(s, "a");
if (crc32("yIeuHziFCHe",11) == 4272410312) strcat(s, "p");
if (crc32("uTeYZAxNFArbo",13) == 845600822) strcat(s, "e");
if (crc32("zfhALkT",7) == 1363005512) strcat(s, "X");
if (crc32("LPcCYgBP",8) == 4216283119) strcat(s, "r");
if (crc32("ZOwcX",5) == 939471222) strcat(s, "S");
if (crc32("OXzvhNGsyFGV",12) == 2106088199) strcat(s, "i");
if (crc32("WSOhCI",6) == 2384272374) strcat(s, "c");
if (crc32("HHAflgzyMRx",11) == 128935466) strcat(s, "a");
if (crc32("XOKqEfJNnMxNQXP",15) == 3327753023) strcat(s, "r");
if (crc32("NLSaBnMraEsVR",13) == 1171904857) strcat(s, "Q");
if (crc32("GFlPWVDIPwahuA",14) == 1244925246) strcat(s, "d");
if (crc32("aimlbds",7) == 2579286452) strcat(s, "I");
if (crc32("MtksNGkY",8) == 2306635420) strcat(s, "i");
if (crc32("oZhwxGvUbAwp",12) == 2421979421) strcat(s, "k");
if (crc32("ReMRDCkAGGqyhU",14) == 1403517190) strcat(s, "t");
if (crc32("fuhCrBxYPDl",11) == 2034388344) strcat(s, "i");
if (crc32("LZCTrRmUEwdIi",13) == 407821095) strcat(s, "S");
if (crc32("fNWjNc",6) == 561479752) strcat(s, "c");
    return s;
}

char *queanish_adjectives() {
    char *s = calloc(9);
    if (crc32("tpFWzDddLQ",10) == 1509630207) strcat(s, "q");
if (crc32("vYvtopvAq",9) == 4009308901) strcat(s, "Y");
if (crc32("xDiIGXkgeQps",12) == 2637685704) strcat(s, "u");
if (crc32("ADLfUZyKtwST",12) == 3162297135) strcat(s, "N");
if (crc32("GZLTB",5) == 3083096266) strcat(s, "e");
if (crc32("UWVmSYdIX",9) == 1606107128) strcat(s, "S");
if (crc32("oDTDmM",6) == 248608651) strcat(s, "a");
if (crc32("IEwhmRBdjag",11) == 2412451643) strcat(s, "N");
if (crc32("rODevyiqlE",10) == 2434668904) strcat(s, "n");
if (crc32("MwfDKfVEv",9) == 2465644214) strcat(s, "t");
if (crc32("EMARI",5) == 3382346193) strcat(s, "i");
if (crc32("SXQdtKRdoIObI",13) == 606571112) strcat(s, "e");
if (crc32("fGqTXg",6) == 2621352847) strcat(s, "s");
if (crc32("VGLCpMDtrF",10) == 2296064511) strcat(s, "h");
    return s;
}

char *weathertight_adjectives() {
    char *s = calloc(13);
    if (crc32("POnhHjTuUuT",11) == 4041673567) strcat(s, "w");
if (crc32("cvhmZphec",9) == 1988259248) strcat(s, "e");
if (crc32("yKlSSsjKFTvnTf",14) == 258525812) strcat(s, "X");
if (crc32("dNqqJdQRujciOO",14) == 1363786838) strcat(s, "a");
if (crc32("XdEZBV",6) == 876338638) strcat(s, "U");
if (crc32("GdXPAeSsJxpap",13) == 2500100832) strcat(s, "t");
if (crc32("iCXYIYKps",9) == 4084881905) strcat(s, "h");
if (crc32("cSqNbOKd",8) == 3179115949) strcat(s, "e");
if (crc32("anwdaADJR",9) == 2906670023) strcat(s, "r");
if (crc32("oQSFsvssexYe",12) == 968512630) strcat(s, "S");
if (crc32("huOsGnhvskohf",13) == 3174570300) strcat(s, "t");
if (crc32("IZAFphntET",10) == 1286287930) strcat(s, "f");
if (crc32("RfDyBXVGHthiG",13) == 2137151170) strcat(s, "i");
if (crc32("DscgC",5) == 4036036609) strcat(s, "I");
if (crc32("CAHXeVzxTUPLI",13) == 1180238107) strcat(s, "g");
if (crc32("XvKvfFRljwy",11) == 1794527614) strcat(s, "h");
if (crc32("sTbpKLPVNAUrl",13) == 2131165255) strcat(s, "m");
if (crc32("sQkMfCxPub",10) == 3250409046) strcat(s, "t");
    return s;
}

char *roughvoiced_adjectives() {
    char *s = calloc(12);
    if (crc32("iQCmqXL",7) == 3400849629) strcat(s, "r");
if (crc32("eIXGVAdmGGx",11) == 2008403960) strcat(s, "o");
if (crc32("AXkcSJtGJAQZ",12) == 3286544201) strcat(s, "V");
if (crc32("EIGqlKuQsLLP",12) == 1305947903) strcat(s, "u");
if (crc32("cSvwEvNYqIa",11) == 2056222010) strcat(s, "f");
if (crc32("IFFemVQ",7) == 4265045950) strcat(s, "g");
if (crc32("qSYMFOBS",8) == 1771280479) strcat(s, "h");
if (crc32("YnSTWfp",7) == 3815325302) strcat(s, "X");
if (crc32("yBOESecjn",9) == 816132830) strcat(s, "v");
if (crc32("bzFEXdbUePK",11) == 1334894777) strcat(s, "s");
if (crc32("lhuBQyyIeAaS",12) == 906514233) strcat(s, "o");
if (crc32("ZDqqJSo",7) == 2829538611) strcat(s, "i");
if (crc32("KVvoOpLsRbGVzk",14) == 2864344322) strcat(s, "i");
if (crc32("KlNlEeqBCcs",11) == 2323910749) strcat(s, "c");
if (crc32("XmHoJKtSalzSpc",14) == 2560298233) strcat(s, "e");
if (crc32("RLruQexRcsCuzOb",15) == 647091961) strcat(s, "n");
if (crc32("xVMtBbKPwAMP",12) == 2357365405) strcat(s, "d");
    return s;
}

char *pneumatological_adjectives() {
    char *s = calloc(16);
    if (crc32("SWTAWXGtIdWF",12) == 898551396) strcat(s, "h");
if (crc32("xARoywOPk",9) == 479905763) strcat(s, "p");
if (crc32("rtlMWDJ",7) == 933701440) strcat(s, "z");
if (crc32("gBZlxqrbKOtsFR",14) == 3077708585) strcat(s, "n");
if (crc32("tiGBnQfkNQ",10) == 3754325084) strcat(s, "X");
if (crc32("itAZtW",6) == 1857312165) strcat(s, "e");
if (crc32("NmFsKbS",7) == 2537941470) strcat(s, "f");
if (crc32("fsffzLbJ",8) == 3661187006) strcat(s, "u");
if (crc32("HDbuMmQXCB",10) == 1633164313) strcat(s, "c");
if (crc32("HmZSUHUCgCwGmA",14) == 3620808650) strcat(s, "m");
if (crc32("sGkeCeZ",7) == 1363376864) strcat(s, "a");
if (crc32("VqVjacykSAyS",12) == 1942914877) strcat(s, "c");
if (crc32("dKlPeTy",7) == 2849472714) strcat(s, "t");
if (crc32("tggZmNTxsqlu",12) == 902356242) strcat(s, "o");
if (crc32("oIlRJGeSVQgjQ",13) == 1567006770) strcat(s, "l");
if (crc32("hQFiSamLQOUhZVF",15) == 590130497) strcat(s, "o");
if (crc32("WZzbTEAQMso",11) == 777649420) strcat(s, "G");
if (crc32("lDPhoTHC",8) == 678149010) strcat(s, "g");
if (crc32("mcSMntsh",8) == 1542138977) strcat(s, "c");
if (crc32("OsldDZFiZABwMm",14) == 1409144945) strcat(s, "i");
if (crc32("JzhUztB",7) == 148400442) strcat(s, "c");
if (crc32("qGgJgWmOnvZB",12) == 3286653932) strcat(s, "f");
if (crc32("oFEEooLPDAT",11) == 4006796264) strcat(s, "a");
if (crc32("xqWyIzpIM",9) == 251014341) strcat(s, "b");
if (crc32("BHXZE",5) == 2667377455) strcat(s, "l");
    return s;
}

char *slatiest_adjectives() {
    char *s = calloc(9);
    if (crc32("PuNwmnFhYn",10) == 83173504) strcat(s, "J");
if (crc32("zyGGPcVxVbhzvJ",14) == 2391007249) strcat(s, "s");
if (crc32("szfKzZv",7) == 2513864264) strcat(s, "D");
if (crc32("kAzCUIcWrF",10) == 2153864828) strcat(s, "l");
if (crc32("eIQKe",5) == 923226592) strcat(s, "A");
if (crc32("SLZveynXX",9) == 2604931329) strcat(s, "a");
if (crc32("VatwkQ",6) == 3770781348) strcat(s, "t");
if (crc32("psrnWN",6) == 3815972676) strcat(s, "i");
if (crc32("rMGDDtNeMNL",11) == 2826688275) strcat(s, "O");
if (crc32("FWUQoxHt",8) == 1677529744) strcat(s, "e");
if (crc32("pNyluKqsYdvV",12) == 3047971577) strcat(s, "s");
if (crc32("EjFSGQQxQ",9) == 2440097290) strcat(s, "t");
    return s;
}

char *unexpunged_adjectives() {
    char *s = calloc(11);
    if (crc32("zfZPb",5) == 320950762) strcat(s, "u");
if (crc32("yGggoHKbwFBii",13) == 1080721758) strcat(s, "n");
if (crc32("tLNVgAyO",8) == 2208675978) strcat(s, "e");
if (crc32("MrIHIJPoN",9) == 2882431382) strcat(s, "x");
if (crc32("FRmGF",5) == 270399689) strcat(s, "p");
if (crc32("eeBRceNGHsq",11) == 3293798978) strcat(s, "u");
if (crc32("fRbIZovjaLuoXN",14) == 2953756642) strcat(s, "n");
if (crc32("zJgOYE",6) == 3116407209) strcat(s, "n");
if (crc32("MXLIBWakPXRPcV",14) == 3095408315) strcat(s, "y");
if (crc32("leETkPaOQUs",11) == 3259632189) strcat(s, "g");
if (crc32("bxCeua",6) == 2251026202) strcat(s, "w");
if (crc32("WCzSyiszYpPZRBq",15) == 3276246628) strcat(s, "e");
if (crc32("VOxeX",5) == 2514418385) strcat(s, "d");
    return s;
}

char *unumpired_adjectives() {
    char *s = calloc(10);
    if (crc32("eKGBZW",6) == 106831537) strcat(s, "u");
if (crc32("zSVBRWlv",8) == 3400683110) strcat(s, "n");
if (crc32("ghowz",5) == 2156361890) strcat(s, "u");
if (crc32("mBWmStq",7) == 3230657952) strcat(s, "S");
if (crc32("KGAEbmJwwabM",12) == 1575969063) strcat(s, "m");
if (crc32("RcCfOSAPSGmyQ",13) == 3853083652) strcat(s, "E");
if (crc32("WIPdBnc",7) == 2210779929) strcat(s, "p");
if (crc32("dmzDEIPlgwGF",12) == 2663313389) strcat(s, "i");
if (crc32("UXvOqjXZbzfKE",13) == 4249697725) strcat(s, "r");
if (crc32("NKYtmX",6) == 2499161221) strcat(s, "p");
if (crc32("zyWMKSkZiXbm",12) == 1925278926) strcat(s, "e");
if (crc32("kemgPnEsnAaUSen",15) == 3427666829) strcat(s, "d");
    return s;
}

char *paradelike_adjectives() {
    char *s = calloc(11);
    if (crc32("ahDWALbDyaj",11) == 62114470) strcat(s, "p");
if (crc32("OaFUcBUsHZEE",12) == 3199274764) strcat(s, "E");
if (crc32("IbgfajhqFlN",11) == 4014091980) strcat(s, "a");
if (crc32("mrNKeHgPrM",10) == 2353969035) strcat(s, "r");
if (crc32("xPvGPLXxKA",10) == 1833172302) strcat(s, "g");
if (crc32("pemfyQFfGmsRvr",14) == 3965086052) strcat(s, "a");
if (crc32("GPtyHdmAx",9) == 2510542308) strcat(s, "X");
if (crc32("mAQNiM",6) == 3588024592) strcat(s, "d");
if (crc32("lnaqfCWGflRGHGo",15) == 3434073912) strcat(s, "e");
if (crc32("wbRWuDI",7) == 72630654) strcat(s, "m");
if (crc32("nGDTctgCILk",11) == 921236619) strcat(s, "l");
if (crc32("OCjlGoafylhRgi",14) == 2859862926) strcat(s, "i");
if (crc32("UZcmgURRBMtdBN",14) == 933682442) strcat(s, "k");
if (crc32("gDmSpZtI",8) == 2329329666) strcat(s, "e");
    return s;
}

char *forgiving_adjectives() {
    char *s = calloc(10);
    if (crc32("LhqKczj",7) == 2287655952) strcat(s, "n");
if (crc32("XVGkUryu",8) == 711955389) strcat(s, "f");
if (crc32("UpsrEmYUuBd",11) == 39787234) strcat(s, "o");
if (crc32("UyGizJub",8) == 1356247472) strcat(s, "R");
if (crc32("zNlfkBJFSHQ",11) == 1988204531) strcat(s, "r");
if (crc32("XaabVyw",7) == 590262534) strcat(s, "g");
if (crc32("ZbSuezeReStgCB",14) == 208575056) strcat(s, "h");
if (crc32("tjwHS",5) == 93789667) strcat(s, "i");
if (crc32("VBhzjpiW",8) == 1809120312) strcat(s, "p");
if (crc32("pJhqwzckxV",10) == 3134503650) strcat(s, "v");
if (crc32("UzcJGWjYfKZ",11) == 3048450579) strcat(s, "B");
if (crc32("PfKNOMSmwI",10) == 3179285748) strcat(s, "i");
if (crc32("nSBVpBjabA",10) == 776597664) strcat(s, "n");
if (crc32("tviZWz",6) == 594521626) strcat(s, "m");
if (crc32("rlrJbxr",7) == 4238878219) strcat(s, "g");
    return s;
}

char *tactless_adjectives() {
    char *s = calloc(9);
    if (crc32("ZnVTBjXMttWT",12) == 504776233) strcat(s, "t");
if (crc32("rixefaSXP",9) == 2455584770) strcat(s, "a");
if (crc32("bnkKCzUbINgUW",13) == 171574436) strcat(s, "c");
if (crc32("dzDDIuQAUaNOP",13) == 1011036451) strcat(s, "t");
if (crc32("yVmQqjoaGFP",11) == 2908166997) strcat(s, "l");
if (crc32("jYjDWwxOdo",10) == 1501131407) strcat(s, "e");
if (crc32("jbNfbbSYPDY",11) == 660323093) strcat(s, "o");
if (crc32("EJKWixE",7) == 4197663911) strcat(s, "s");
if (crc32("BakrEUjmVe",10) == 2925571222) strcat(s, "s");
    return s;
}

char *wellaired_adjectives() {
    char *s = calloc(10);
    if (crc32("aMMwJD",6) == 2426840819) strcat(s, "n");
if (crc32("ibXNJDLqEICNRYz",15) == 292591037) strcat(s, "w");
if (crc32("VEvGMLWsTSe",11) == 1257948399) strcat(s, "e");
if (crc32("SlZfRzJZNdWD",12) == 3633587093) strcat(s, "l");
if (crc32("tyjkXTjXr",9) == 1867815727) strcat(s, "X");
if (crc32("vLljOpMWe",9) == 4278672429) strcat(s, "l");
if (crc32("vKDBZgiyv",9) == 468848379) strcat(s, "q");
if (crc32("iMMDLSRLC",9) == 2380158807) strcat(s, "a");
if (crc32("mdvKL",5) == 794798882) strcat(s, "i");
if (crc32("BooZGUtFk",9) == 4143346099) strcat(s, "r");
if (crc32("ZhyzhrZ",7) == 2989494522) strcat(s, "f");
if (crc32("DVIiheiUIp",10) == 3053290248) strcat(s, "e");
if (crc32("OODYCto",7) == 3128855865) strcat(s, "v");
if (crc32("OdrrjtgVmK",10) == 1117178213) strcat(s, "d");
    return s;
}

char *iconic_adjectives() {
    char *s = calloc(7);
    if (crc32("wvfGjobi",8) == 214204748) strcat(s, "i");
if (crc32("MCzMJTxmhuy",11) == 2652700005) strcat(s, "c");
if (crc32("blHqnsXM",8) == 2416293521) strcat(s, "S");
if (crc32("gogZMLAAPKO",11) == 1280252601) strcat(s, "o");
if (crc32("lMJlQEKTpTU",11) == 3064584292) strcat(s, "n");
if (crc32("kuoVXajv",8) == 2044381842) strcat(s, "i");
if (crc32("GTHjLzpozB",10) == 3416391966) strcat(s, "c");
    return s;
}

char *unevaded_adjectives() {
    char *s = calloc(9);
    if (crc32("vIseOlvsuhGHadE",15) == 619583290) strcat(s, "u");
if (crc32("tisouvWCl",9) == 1046206530) strcat(s, "S");
if (crc32("pUdoLQ",6) == 4252787195) strcat(s, "n");
if (crc32("JkJScbBAfEAyfcr",15) == 3492608717) strcat(s, "J");
if (crc32("LLjSUEqoPrE",11) == 3745239499) strcat(s, "e");
if (crc32("IAmuCJBKVBGdnzJ",15) == 2221834595) strcat(s, "a");
if (crc32("RpyAWCYyQcgW",12) == 2245165866) strcat(s, "v");
if (crc32("AzxAhbcpWAqhp",13) == 1359731109) strcat(s, "a");
if (crc32("MnGxatgbecPhEh",14) == 11504358) strcat(s, "N");
if (crc32("zoXbr",5) == 2641006107) strcat(s, "d");
if (crc32("PiWPlDKjMcTPrZ",14) == 3208309468) strcat(s, "C");
if (crc32("xeZbV",5) == 3079671200) strcat(s, "e");
if (crc32("enMUUD",6) == 3623170031) strcat(s, "i");
if (crc32("iBEzKO",6) == 3158866782) strcat(s, "d");
    return s;
}

char *affecting_adjectives() {
    char *s = calloc(10);
    if (crc32("wxUlGUhTNDOfv",13) == 2722528852) strcat(s, "a");
if (crc32("WjHZMSr",7) == 4134031890) strcat(s, "s");
if (crc32("phISdHhzZYpCeq",14) == 1805586413) strcat(s, "f");
if (crc32("DILQEeWHacGrPV",14) == 229642104) strcat(s, "f");
if (crc32("ZFqlGFuI",8) == 4097465550) strcat(s, "J");
if (crc32("OadoFVLiQRJ",11) == 1301095555) strcat(s, "e");
if (crc32("QZhEGjUBDMCuXMp",15) == 1560883957) strcat(s, "K");
if (crc32("TyGGKtaqUr",10) == 1797401705) strcat(s, "c");
if (crc32("PuIFxAxTMJt",11) == 3831116950) strcat(s, "C");
if (crc32("RykkFwpwYBZQZAT",15) == 1758550474) strcat(s, "t");
if (crc32("qaGUYd",6) == 2566713017) strcat(s, "i");
if (crc32("eKTItusKQkBzi",13) == 2105869470) strcat(s, "n");
if (crc32("TjqUyegybCVAH",13) == 3661677554) strcat(s, "z");
if (crc32("GBKZecORYK",10) == 1011443880) strcat(s, "g");
    return s;
}

char *nonvenomous_adjectives() {
    char *s = calloc(12);
    if (crc32("lWdUHxtoBxrv",12) == 1299071402) strcat(s, "k");
if (crc32("DYzptJbcdnWW",12) == 4290568430) strcat(s, "n");
if (crc32("EbyGuhSWsvEFV",13) == 2563834259) strcat(s, "R");
if (crc32("TxUkP",5) == 573512102) strcat(s, "o");
if (crc32("msFyhTRU",8) == 1812771922) strcat(s, "K");
if (crc32("jSqmzIRYPIQw",12) == 2911566245) strcat(s, "n");
if (crc32("oRWdGhYmRZnUfk",14) == 3842589457) strcat(s, "C");
if (crc32("fukyjWlatlUTqwQ",15) == 1007386429) strcat(s, "v");
if (crc32("taZBlCQr",8) == 4049084621) strcat(s, "e");
if (crc32("aXMxk",5) == 688773904) strcat(s, "n");
if (crc32("OuRJBDZ",7) == 2920220971) strcat(s, "o");
if (crc32("jOubnt",6) == 3452329952) strcat(s, "U");
if (crc32("OSbiJ",5) == 2891775975) strcat(s, "m");
if (crc32("nOEaFCrFWCTUmC",14) == 73403252) strcat(s, "T");
if (crc32("brVtQNpqqyqHEm",14) == 2054142723) strcat(s, "o");
if (crc32("lOEfvbKKjT",10) == 1562809380) strcat(s, "u");
if (crc32("qNtFxCzwbQw",11) == 2746631038) strcat(s, "s");
    return s;
}

char *okeydoke_adjectives() {
    char *s = calloc(9);
    if (crc32("YbVplliVi",9) == 1955209998) strcat(s, "z");
if (crc32("BRJXUcqMq",9) == 4014866922) strcat(s, "o");
if (crc32("HtnPHMsRAW",10) == 4178372386) strcat(s, "s");
if (crc32("XlWEOY",6) == 1207989215) strcat(s, "k");
if (crc32("tHvrIQRjqGnFP",13) == 159969178) strcat(s, "D");
if (crc32("xcOwMMsAaBcfXm",14) == 1867743035) strcat(s, "e");
if (crc32("CRJEQAfLtByL",12) == 2836863773) strcat(s, "D");
if (crc32("WBQXs",5) == 2870789933) strcat(s, "y");
if (crc32("UiPtObkIFutfU",13) == 3946385541) strcat(s, "d");
if (crc32("CQUDgg",6) == 1331162125) strcat(s, "o");
if (crc32("ybCrFmaA",8) == 2647111186) strcat(s, "w");
if (crc32("AqxpdGUVzo",10) == 58589250) strcat(s, "k");
if (crc32("GPFBv",5) == 3905057818) strcat(s, "e");
    return s;
}

char *patrimonial_adjectives() {
    char *s = calloc(12);
    if (crc32("MvYhjYkr",8) == 3577030867) strcat(s, "p");
if (crc32("oxPbX",5) == 755786145) strcat(s, "a");
if (crc32("viOYU",5) == 4246786912) strcat(s, "t");
if (crc32("fpHuWPLVkXBHc",13) == 2086938139) strcat(s, "j");
if (crc32("yOELNAmXuym",11) == 1266755296) strcat(s, "r");
if (crc32("pWFnsIxNoEkGZOR",15) == 1688512899) strcat(s, "i");
if (crc32("BXrzwDRDKRFqG",13) == 1389207963) strcat(s, "m");
if (crc32("aWirh",5) == 768384074) strcat(s, "o");
if (crc32("fRZocswk",8) == 264971793) strcat(s, "l");
if (crc32("yxYDRgxqWX",10) == 1495696526) strcat(s, "n");
if (crc32("xAgTOF",6) == 372941135) strcat(s, "i");
if (crc32("wApaVncfui",10) == 2076906799) strcat(s, "K");
if (crc32("JTEHZeVKk",9) == 1449533075) strcat(s, "a");
if (crc32("bbgXPdj",7) == 3618654497) strcat(s, "K");
if (crc32("VclOSFvmWP",10) == 3389684120) strcat(s, "l");
    return s;
}

char *unsown_adjectives() {
    char *s = calloc(7);
    if (crc32("YEhCo",5) == 3925050228) strcat(s, "V");
if (crc32("veiacQ",6) == 1626142682) strcat(s, "u");
if (crc32("vAkHwTOMUe",10) == 4160401427) strcat(s, "N");
if (crc32("IGPAtluPn",9) == 1872293756) strcat(s, "n");
if (crc32("FcYhAkOzKMAZjoc",15) == 3620416012) strcat(s, "z");
if (crc32("KZzXXTT",7) == 466647290) strcat(s, "s");
if (crc32("DyAePjImQH",10) == 3067778683) strcat(s, "o");
if (crc32("rhCASQ",6) == 1347334561) strcat(s, "c");
if (crc32("mbNAXrwuLLALI",13) == 1275992849) strcat(s, "w");
if (crc32("baGhwFPgXUNz",12) == 3666238707) strcat(s, "n");
if (crc32("TGVSbcpQklvE",12) == 2968916961) strcat(s, "n");
    return s;
}

char *overmellow_adjectives() {
    char *s = calloc(11);
    if (crc32("JLZclFEVmrEXFK",14) == 2921411186) strcat(s, "S");
if (crc32("cNXlxruAaMMFr",13) == 514172187) strcat(s, "o");
if (crc32("cLkvVk",6) == 679170045) strcat(s, "v");
if (crc32("jUByA",5) == 1699450230) strcat(s, "e");
if (crc32("MuUQMaRO",8) == 2120207046) strcat(s, "r");
if (crc32("vdoVL",5) == 3572824402) strcat(s, "m");
if (crc32("TtimrRMTBL",10) == 1034305355) strcat(s, "L");
if (crc32("UENsYBRNYyh",11) == 1028573380) strcat(s, "e");
if (crc32("eryyGVjPDq",10) == 3706830145) strcat(s, "W");
if (crc32("RoWAhdbdSy",10) == 2391094181) strcat(s, "l");
if (crc32("zmimcjgWitkpSi",14) == 2143369961) strcat(s, "l");
if (crc32("UaRoPFOU",8) == 3707446427) strcat(s, "o");
if (crc32("eVbKCku",7) == 3848841345) strcat(s, "w");
    return s;
}

char *wellblacked_adjectives() {
    char *s = calloc(12);
    if (crc32("QLEDhTdsp",9) == 2290685186) strcat(s, "M");
if (crc32("qhKby",5) == 4276044562) strcat(s, "w");
if (crc32("kWWYq",5) == 3888508539) strcat(s, "T");
if (crc32("tXqcfLPvv",9) == 1660258766) strcat(s, "e");
if (crc32("OpRwjzrCiZbxH",13) == 1732417958) strcat(s, "l");
if (crc32("kQaPx",5) == 645982441) strcat(s, "a");
if (crc32("JPBqdEU",7) == 1509444777) strcat(s, "l");
if (crc32("xlYtgweaDjLl",12) == 1025738854) strcat(s, "j");
if (crc32("mqYSCxJPlOZjXko",15) == 3260873739) strcat(s, "b");
if (crc32("GIryAs",6) == 2355097353) strcat(s, "a");
if (crc32("PqYnMAVD",8) == 4075716463) strcat(s, "l");
if (crc32("NHrlMQFkkbRDVu",14) == 1034774592) strcat(s, "Q");
if (crc32("TGAeerf",7) == 3322185748) strcat(s, "a");
if (crc32("qCjyPMkumLge",12) == 2500252089) strcat(s, "c");
if (crc32("TUMxZ",5) == 3816305665) strcat(s, "k");
if (crc32("XAYxVMmFUOQsFSK",15) == 2821206517) strcat(s, "e");
if (crc32("mhIKBNlKhQ",10) == 2616010587) strcat(s, "M");
if (crc32("lCJlIjAExcwJGU",14) == 3113685134) strcat(s, "d");
    return s;
}

char *snippy_adjectives() {
    char *s = calloc(7);
    if (crc32("foqmkhJOWkW",11) == 4192928563) strcat(s, "s");
if (crc32("gfBFYjJQuSRAg",13) == 2741928204) strcat(s, "n");
if (crc32("OSCiRvDSKTsV",12) == 2403907064) strcat(s, "i");
if (crc32("IEAYCYuy",8) == 3664735795) strcat(s, "g");
if (crc32("yGfdYQKdjIYaW",13) == 1535970703) strcat(s, "p");
if (crc32("DmdtutwJogognFT",15) == 1154348078) strcat(s, "p");
if (crc32("PZMsgfTdm",9) == 2494556072) strcat(s, "y");
    return s;
}

char *exoteric_adjectives() {
    char *s = calloc(9);
    if (crc32("UdwDLJw",7) == 1891183650) strcat(s, "T");
if (crc32("ttxDwDwBIjjzux",14) == 79054027) strcat(s, "e");
if (crc32("KXlnpgsjGnQ",11) == 3263644800) strcat(s, "Q");
if (crc32("VGylGT",6) == 84041581) strcat(s, "x");
if (crc32("EdrWzosmF",9) == 2242723223) strcat(s, "o");
if (crc32("cBSAst",6) == 3859484629) strcat(s, "t");
if (crc32("iNQsLM",6) == 140352243) strcat(s, "e");
if (crc32("KZDEj",5) == 1720463772) strcat(s, "R");
if (crc32("ePcnjqdowKuPhg",14) == 4073210429) strcat(s, "r");
if (crc32("yLgdmzHpnNJejFi",15) == 4273774118) strcat(s, "s");
if (crc32("lUqBtXe",7) == 1691663205) strcat(s, "i");
if (crc32("rqactcGTmcUBlYa",15) == 417977714) strcat(s, "X");
if (crc32("FqRBourkzKs",11) == 2972588187) strcat(s, "c");
    return s;
}

char *renversa_adjectives() {
    char *s = calloc(9);
    if (crc32("CKmFy",5) == 1519481808) strcat(s, "r");
if (crc32("jcyUKbgZB",9) == 1047948614) strcat(s, "d");
if (crc32("UtHngS",6) == 635704638) strcat(s, "e");
if (crc32("ZEoaFDWDoIrZ",12) == 142976503) strcat(s, "n");
if (crc32("HIAtLziR",8) == 2739714362) strcat(s, "d");
if (crc32("ppKXT",5) == 912562142) strcat(s, "v");
if (crc32("kzsBB",5) == 543697547) strcat(s, "e");
if (crc32("WveSkz",6) == 342758619) strcat(s, "W");
if (crc32("YeRjATeRSdlFgTM",15) == 3539770611) strcat(s, "r");
if (crc32("wmLPWfg",7) == 1904830500) strcat(s, "W");
if (crc32("ttNqWccyxZ",10) == 379429369) strcat(s, "s");
if (crc32("KSLdAJjiyVB",11) == 1456096589) strcat(s, "a");
    return s;
}

char *proFrance_adjectives() {
    char *s = calloc(10);
    if (crc32("MRqpQpA",7) == 657336413) strcat(s, "Q");
if (crc32("TbwPvEUzBlcCCY",14) == 531466642) strcat(s, "p");
if (crc32("vCIoqYXgWqAxEVo",15) == 488530397) strcat(s, "X");
if (crc32("HuAGGuCS",8) == 1913811610) strcat(s, "r");
if (crc32("pxhsYsZLUhmrP",13) == 1681124477) strcat(s, "A");
if (crc32("IVYTVhZB",8) == 2244195730) strcat(s, "o");
if (crc32("yVmvjqthZaUIz",13) == 3730228704) strcat(s, "F");
if (crc32("djPIuDbKPRaM",12) == 3143766629) strcat(s, "E");
if (crc32("nwmYVc",6) == 1521812359) strcat(s, "r");
if (crc32("ibyHmahCn",9) == 132162708) strcat(s, "P");
if (crc32("jOrGDgYsUDCwsQf",15) == 2403447096) strcat(s, "a");
if (crc32("zOOSidkl",8) == 2695962217) strcat(s, "n");
if (crc32("HEapAJvwUnncu",13) == 3372122811) strcat(s, "c");
if (crc32("ShuYXDMgzJbrtx",14) == 3743552018) strcat(s, "e");
    return s;
}

char *halftrue_adjectives() {
    char *s = calloc(9);
    if (crc32("CfvSNpoBYsiWOom",15) == 3758657553) strcat(s, "h");
if (crc32("asVANGjseqyvp",13) == 2824415052) strcat(s, "Y");
if (crc32("QdvfSIHkh",9) == 2765275998) strcat(s, "a");
if (crc32("grPyCBj",7) == 4171216473) strcat(s, "d");
if (crc32("mcJKi",5) == 3573373736) strcat(s, "l");
if (crc32("JtNRdhz",7) == 3224199060) strcat(s, "A");
if (crc32("tnGJfF",6) == 3500500814) strcat(s, "f");
if (crc32("MqyCvMCmHV",10) == 2817800935) strcat(s, "t");
if (crc32("hvItWBybqMUGI",13) == 3744167747) strcat(s, "R");
if (crc32("GWgBhoUE",8) == 3953768592) strcat(s, "r");
if (crc32("bZlIZ",5) == 2105776773) strcat(s, "X");
if (crc32("yCIPbEwePHUM",12) == 608964674) strcat(s, "u");
if (crc32("FuXTfZooHr",10) == 2435332516) strcat(s, "e");
    return s;
}

char *unsharing_adjectives() {
    char *s = calloc(10);
    if (crc32("XKuyFuORrvifH",13) == 3824685397) strcat(s, "u");
if (crc32("zMtAppUhEpQO",12) == 2533285260) strcat(s, "n");
if (crc32("GEJgqxTmbuZL",12) == 2621476272) strcat(s, "s");
if (crc32("ErkWkDQBG",9) == 2663539972) strcat(s, "G");
if (crc32("ofeSAodfvvA",11) == 4176254575) strcat(s, "h");
if (crc32("HJpIR",5) == 3925654824) strcat(s, "V");
if (crc32("nuFIlGHFHGxsqq",14) == 255070615) strcat(s, "a");
if (crc32("VOCoqiqKc",9) == 2334456773) strcat(s, "r");
if (crc32("QlXohEC",7) == 1717616281) strcat(s, "q");
if (crc32("rAVhIdPbYag",11) == 2573239093) strcat(s, "i");
if (crc32("BlWcwVRVj",9) == 1913767165) strcat(s, "n");
if (crc32("LdCwY",5) == 1567191056) strcat(s, "T");
if (crc32("kLdKsgnfAiSIO",13) == 3385572474) strcat(s, "g");
    return s;
}

char *hexahemeric_adjectives() {
    char *s = calloc(12);
    if (crc32("HoIRXCkDmZKznU",14) == 1142716432) strcat(s, "h");
if (crc32("zUlPBtA",7) == 3114344303) strcat(s, "l");
if (crc32("owLRZUedmxJ",11) == 2618031500) strcat(s, "e");
if (crc32("SqZQyfLuCN",10) == 3835849773) strcat(s, "x");
if (crc32("VhkyiccIKABKn",13) == 190006194) strcat(s, "a");
if (crc32("McGXhlT",7) == 578777863) strcat(s, "B");
if (crc32("VvnKYcAU",8) == 1794713893) strcat(s, "h");
if (crc32("XxNbclgJgH",10) == 2045335234) strcat(s, "e");
if (crc32("zeIwpyPfEuSYv",13) == 547539936) strcat(s, "D");
if (crc32("PkYvsYSI",8) == 1624741134) strcat(s, "m");
if (crc32("WcXsR",5) == 2254100942) strcat(s, "e");
if (crc32("onniFePmLKgSLDJ",15) == 2554367835) strcat(s, "r");
if (crc32("ykaFFvwZtPBOQf",14) == 3007526391) strcat(s, "b");
if (crc32("pFbnhGAOTa",10) == 1131688520) strcat(s, "i");
if (crc32("tkpcpQIZhGCEhA",14) == 1683184648) strcat(s, "q");
if (crc32("aUJRpv",6) == 2404504223) strcat(s, "c");
    return s;
}

char *nonacceptant_adjectives() {
    char *s = calloc(13);
    if (crc32("tlwXwJkN",8) == 3240848340) strcat(s, "s");
if (crc32("pFWVNjXUKe",10) == 199654862) strcat(s, "n");
if (crc32("PqpYjACVSQ",10) == 130913213) strcat(s, "o");
if (crc32("siywYM",6) == 2362147075) strcat(s, "n");
if (crc32("vWpijZ",6) == 190724923) strcat(s, "y");
if (crc32("KZXbYMMel",9) == 1402990243) strcat(s, "a");
if (crc32("HxAyP",5) == 3840153690) strcat(s, "c");
if (crc32("pugwzCnd",8) == 4007535169) strcat(s, "c");
if (crc32("CKsbk",5) == 3037639275) strcat(s, "U");
if (crc32("QITDYNMsUAA",11) == 3930715364) strcat(s, "e");
if (crc32("QVJdPfoEmFeD",12) == 3297158338) strcat(s, "p");
if (crc32("briaBAWzXv",10) == 2935964602) strcat(s, "z");
if (crc32("gZCrBuLNdJgezh",14) == 1606596617) strcat(s, "t");
if (crc32("KQxIdYGQ",8) == 1385733006) strcat(s, "a");
if (crc32("NBMkoPWzwZt",11) == 781784025) strcat(s, "n");
if (crc32("RHmaFWBKJmYTvxz",15) == 3130385057) strcat(s, "n");
if (crc32("izqErx",6) == 3411963383) strcat(s, "t");
    return s;
}

char *fiendliest_adjectives() {
    char *s = calloc(11);
    if (crc32("eTrZLrUyaJdlR",13) == 3478805287) strcat(s, "T");
if (crc32("vjPUui",6) == 2020054821) strcat(s, "f");
if (crc32("WxyDfxrxeVACx",13) == 2979644202) strcat(s, "U");
if (crc32("whGDesa",7) == 3726280175) strcat(s, "i");
if (crc32("AsQfCLqroCiHtGs",15) == 4166243235) strcat(s, "e");
if (crc32("JffnTuIGgm",10) == 3334284314) strcat(s, "D");
if (crc32("wyxFGrhSyGYIr",13) == 3461140683) strcat(s, "n");
if (crc32("JPAkpECXBY",10) == 443358384) strcat(s, "Q");
if (crc32("VqOVtXfmiNr",11) == 3226873631) strcat(s, "d");
if (crc32("IUyaopzYSX",10) == 946524399) strcat(s, "i");
if (crc32("oOCDfXQGlZHU",12) == 2325079259) strcat(s, "l");
if (crc32("NnPnYztXnnyeZvH",15) == 1476900099) strcat(s, "U");
if (crc32("ztIilXHIhmTXx",13) == 1816440686) strcat(s, "i");
if (crc32("UYgGfsBeZvD",11) == 3607073632) strcat(s, "C");
if (crc32("sBWtBIN",7) == 2949864394) strcat(s, "e");
if (crc32("TGnaUgNGyV",10) == 3056502221) strcat(s, "I");
if (crc32("ENPwS",5) == 3545943781) strcat(s, "s");
if (crc32("HLthKdFeUBEt",12) == 1602717005) strcat(s, "t");
    return s;
}

char *wellinsured_adjectives() {
    char *s = calloc(12);
    if (crc32("ZpsMVPt",7) == 1124451530) strcat(s, "w");
if (crc32("wzNHkpGySK",10) == 1878781599) strcat(s, "e");
if (crc32("knslfcL",7) == 2487351714) strcat(s, "l");
if (crc32("mEEkGrH",7) == 3250286409) strcat(s, "Q");
if (crc32("QwlcojtVwTRhbV",14) == 3764329287) strcat(s, "l");
if (crc32("UHdVYOXyDaid",12) == 628388260) strcat(s, "i");
if (crc32("vNevvhJ",7) == 1061805123) strcat(s, "z");
if (crc32("UvxKncMSPaY",11) == 2288673245) strcat(s, "n");
if (crc32("AbMIasTgE",9) == 2726298424) strcat(s, "D");
if (crc32("hIhVONyZJEamxV",14) == 1065547753) strcat(s, "s");
if (crc32("aLYiXBI",7) == 2534742332) strcat(s, "k");
if (crc32("ViCRDxyGlhCdY",13) == 3043465188) strcat(s, "u");
if (crc32("iiRJwYCnVYB",11) == 3492080481) strcat(s, "g");
if (crc32("aIKXqDkSPY",10) == 2358230797) strcat(s, "r");
if (crc32("RkdhBW",6) == 3685113119) strcat(s, "e");
if (crc32("bagVl",5) == 2237202382) strcat(s, "D");
if (crc32("xZyadag",7) == 2018031002) strcat(s, "d");
    return s;
}

char *hypernutritive_adjectives() {
    char *s = calloc(15);
    if (crc32("vSzyILSTYYg",11) == 1882769333) strcat(s, "V");
if (crc32("hkZKyZrtmnTGP",13) == 2282805123) strcat(s, "h");
if (crc32("RREgSVByBFtTbsO",15) == 912664826) strcat(s, "y");
if (crc32("nNKaWN",6) == 90304654) strcat(s, "p");
if (crc32("SmhPxlgzsVI",11) == 640170580) strcat(s, "e");
if (crc32("Ufotogdmzdf",11) == 3408157510) strcat(s, "W");
if (crc32("NHCprsoIg",9) == 1067337521) strcat(s, "r");
if (crc32("SKYgL",5) == 3275716830) strcat(s, "n");
if (crc32("OvIiTgkFWyvF",12) == 2080894717) strcat(s, "u");
if (crc32("PHFzy",5) == 680518034) strcat(s, "t");
if (crc32("VbEFgSgUBFC",11) == 2085290524) strcat(s, "r");
if (crc32("AQVkMfVEYUKpwO",14) == 4273350779) strcat(s, "M");
if (crc32("RmhPlUpAtLjmx",13) == 452779267) strcat(s, "i");
if (crc32("ZqrdIYOf",8) == 3107046950) strcat(s, "n");
if (crc32("UBJEYmQAuzeDuCd",15) == 3489682184) strcat(s, "t");
if (crc32("UHuhtKOvxa",10) == 1960624421) strcat(s, "i");
if (crc32("MuEeKbOEP",9) == 3746186553) strcat(s, "Z");
if (crc32("ZOnAHourgPSDHKd",15) == 1612491919) strcat(s, "v");
if (crc32("fUubwPsw",8) == 3933302821) strcat(s, "e");
    return s;
}

char *scrawly_adjectives() {
    char *s = calloc(8);
    if (crc32("WfmOeKAK",8) == 177278030) strcat(s, "E");
if (crc32("MyynJ",5) == 1176582539) strcat(s, "s");
if (crc32("GnDZnrgcEmnMF",13) == 3180665583) strcat(s, "c");
if (crc32("NzmHpZe",7) == 899576970) strcat(s, "r");
if (crc32("IiIkJPYBjSsxAOj",15) == 594513186) strcat(s, "x");
if (crc32("OXdDs",5) == 16766643) strcat(s, "a");
if (crc32("cPpiyMDJaQbmo",13) == 840388050) strcat(s, "w");
if (crc32("MLoGKoua",8) == 74328750) strcat(s, "K");
if (crc32("GQxqKyjW",8) == 2637396948) strcat(s, "l");
if (crc32("kzEwJMsRgBQsw",13) == 1129966991) strcat(s, "y");
    return s;
}

char *prognosticable_adjectives() {
    char *s = calloc(15);
    if (crc32("zqffKmdJ",8) == 1681431811) strcat(s, "h");
if (crc32("YzGoAMSUfQAwdmJ",15) == 310944265) strcat(s, "p");
if (crc32("eFDeK",5) == 2811767335) strcat(s, "r");
if (crc32("ewjrVB",6) == 3553503234) strcat(s, "q");
if (crc32("jXMubbMorAAeZjP",15) == 411980743) strcat(s, "o");
if (crc32("FNzrytkfMCtOZQR",15) == 207501499) strcat(s, "Y");
if (crc32("RGsBlkx",7) == 755920571) strcat(s, "g");
if (crc32("uyGGfNnDkgW",11) == 2087519818) strcat(s, "S");
if (crc32("GCzlwIetC",9) == 2343727441) strcat(s, "n");
if (crc32("gaTjMxMQuAP",11) == 2207521585) strcat(s, "o");
if (crc32("NyBoLBmtOQNyvZ",14) == 2011836223) strcat(s, "s");
if (crc32("tnEMUDoItexr",12) == 3507405276) strcat(s, "h");
if (crc32("UASTCOtiHOTbjh",14) == 972553743) strcat(s, "t");
if (crc32("DsuocNRmzJHVuiW",15) == 3514628002) strcat(s, "i");
if (crc32("xmnLIOzWvNp",11) == 1162494013) strcat(s, "c");
if (crc32("JyqAm",5) == 1292122405) strcat(s, "a");
if (crc32("mvnSqeICL",9) == 1612052425) strcat(s, "E");
if (crc32("luWRffmNBSRF",12) == 990518517) strcat(s, "b");
if (crc32("qdAmRrcXEFWgqn",14) == 3737822961) strcat(s, "N");
if (crc32("qnrWnoLkAOTH",12) == 4065225033) strcat(s, "l");
if (crc32("EnFZR",5) == 532104382) strcat(s, "C");
if (crc32("zSzOAWMxL",9) == 1035745320) strcat(s, "e");
    return s;
}

char *nonadmissive_adjectives() {
    char *s = calloc(13);
    if (crc32("lWkUxE",6) == 600287201) strcat(s, "n");
if (crc32("ntOTipzHRzVh",12) == 3603939510) strcat(s, "L");
if (crc32("cqEoPqZsaSIyF",13) == 4278821075) strcat(s, "o");
if (crc32("JvyWaEoOL",9) == 3966340105) strcat(s, "n");
if (crc32("ivRQsmknhLJFzVj",15) == 329989005) strcat(s, "a");
if (crc32("XFQSMMmVidJK",12) == 128404401) strcat(s, "d");
if (crc32("lghMxBdDV",9) == 747893256) strcat(s, "d");
if (crc32("wNPKnFLWToeSj",13) == 973983385) strcat(s, "m");
if (crc32("WcRNORLFTtLr",12) == 2075467627) strcat(s, "c");
if (crc32("bAzSxXfZntplMtT",15) == 3005347569) strcat(s, "i");
if (crc32("yhhmqZf",7) == 3515066167) strcat(s, "s");
if (crc32("UupAbTyZYMTFFE",14) == 241420500) strcat(s, "R");
if (crc32("GCMrQrxTlZj",11) == 3265921392) strcat(s, "s");
if (crc32("CsvnV",5) == 2915258685) strcat(s, "i");
if (crc32("jswAxwBamCKpwT",14) == 1207666807) strcat(s, "i");
if (crc32("sFuqe",5) == 2682854712) strcat(s, "v");
if (crc32("wGLqE",5) == 3254854218) strcat(s, "e");
    return s;
}

char *synergistic_adjectives() {
    char *s = calloc(12);
    if (crc32("lFTIJ",5) == 2921156238) strcat(s, "d");
if (crc32("lkHGknPbtd",10) == 1213218484) strcat(s, "s");
if (crc32("MpbTDvpzTLUyt",13) == 435887799) strcat(s, "y");
if (crc32("qwDuA",5) == 3497557998) strcat(s, "n");
if (crc32("ypZCMr",6) == 1234034786) strcat(s, "e");
if (crc32("ZokUtCcsp",9) == 1489158501) strcat(s, "S");
if (crc32("FsHhAMfnewlwd",13) == 2194417791) strcat(s, "r");
if (crc32("QwTDHMwmR",9) == 1670616131) strcat(s, "g");
if (crc32("cxBoWmygA",9) == 3464205736) strcat(s, "z");
if (crc32("gnKos",5) == 1634724287) strcat(s, "i");
if (crc32("peFSIOMCAD",10) == 760157157) strcat(s, "p");
if (crc32("SqMLge",6) == 4176514678) strcat(s, "s");
if (crc32("fPcay",5) == 1541731977) strcat(s, "l");
if (crc32("NNNtumAZSUk",11) == 3922661366) strcat(s, "t");
if (crc32("BbrmNpbKjREFc",13) == 3781305838) strcat(s, "i");
if (crc32("sJiSoDVW",8) == 4210455656) strcat(s, "c");
    return s;
}

char *unretrenched_adjectives() {
    char *s = calloc(13);
    if (crc32("kxMsYlSrvlmUU",13) == 3401782312) strcat(s, "z");
if (crc32("nhPJP",5) == 334706966) strcat(s, "u");
if (crc32("lznMQgwQbFcO",12) == 318309421) strcat(s, "B");
if (crc32("MDcrienUIXRaa",13) == 1611285787) strcat(s, "n");
if (crc32("MvZikJojScMLYQ",14) == 3085538489) strcat(s, "r");
if (crc32("QUTWVictLDQn",12) == 3797034634) strcat(s, "e");
if (crc32("zrApNONBmxdEgPK",15) == 3035802188) strcat(s, "e");
if (crc32("FfYQmsO",7) == 2161547328) strcat(s, "t");
if (crc32("dqKgcDggp",9) == 3435315953) strcat(s, "A");
if (crc32("mroEIIGTrdx",11) == 3214811579) strcat(s, "r");
if (crc32("jztQHbi",7) == 2163808716) strcat(s, "P");
if (crc32("BEoGkbKQWOqWp",13) == 2978053555) strcat(s, "e");
if (crc32("NAKxhH",6) == 4187251043) strcat(s, "w");
if (crc32("ZkfTssFtziQJmcF",15) == 2495524382) strcat(s, "n");
if (crc32("hNUghDMN",8) == 2864673460) strcat(s, "e");
if (crc32("EpOAoEPai",9) == 998767126) strcat(s, "c");
if (crc32("FPcDEAb",7) == 3024708357) strcat(s, "g");
if (crc32("TLTMs",5) == 1025371697) strcat(s, "h");
if (crc32("HvNNoZZABiC",11) == 2131284502) strcat(s, "e");
if (crc32("dbNkLhnaWfjwpT",14) == 1253731635) strcat(s, "d");
    return s;
}

char *rhinologic_adjectives() {
    char *s = calloc(11);
    if (crc32("beDbyVaoWPv",11) == 1264570942) strcat(s, "r");
if (crc32("lrmlSP",6) == 1067098068) strcat(s, "h");
if (crc32("LTsxTbA",7) == 2760140465) strcat(s, "i");
if (crc32("PDrhGvU",7) == 1078028872) strcat(s, "d");
if (crc32("DcAAaLMZLCkSAqm",15) == 462459464) strcat(s, "n");
if (crc32("zFXbgrgTJmdId",13) == 3072506321) strcat(s, "o");
if (crc32("DDWKBVXKXupkwdN",15) == 3008681559) strcat(s, "z");
if (crc32("HdCZwDTD",8) == 902914447) strcat(s, "l");
if (crc32("zeFNJ",5) == 4116460341) strcat(s, "o");
if (crc32("XnlDvvjcYaMSSet",15) == 560343517) strcat(s, "g");
if (crc32("XXBqvvPS",8) == 200987143) strcat(s, "q");
if (crc32("yweLr",5) == 1758721108) strcat(s, "i");
if (crc32("vPupPTEVMJCC",12) == 1649912218) strcat(s, "c");
    return s;
}

char *nonreflective_adjectives() {
    char *s = calloc(14);
    if (crc32("XSUWDXXRluPCQO",14) == 1521543808) strcat(s, "n");
if (crc32("zsKND",5) == 3997778512) strcat(s, "J");
if (crc32("BbEcyyAdNMCx",12) == 1444049454) strcat(s, "o");
if (crc32("zOitMsABYEISH",13) == 3152947896) strcat(s, "n");
if (crc32("rTvap",5) == 2109793151) strcat(s, "r");
if (crc32("xLOYFxBVSOccZf",14) == 1108160202) strcat(s, "Q");
if (crc32("iVveIeQ",7) == 1481795379) strcat(s, "e");
if (crc32("rmVxRDNDuhWBB",13) == 3590563959) strcat(s, "O");
if (crc32("lzOgRM",6) == 1939407321) strcat(s, "f");
if (crc32("pYOVFkVoSAQuvZu",15) == 2986100893) strcat(s, "l");
if (crc32("XZHyCMVvo",9) == 2016919008) strcat(s, "w");
if (crc32("htbpqXFqAhiJr",13) == 1813845948) strcat(s, "e");
if (crc32("GgYxxngkL",9) == 3721937953) strcat(s, "e");
if (crc32("KrnAdHzej",9) == 2511317653) strcat(s, "c");
if (crc32("MZqIEHgBIYuxmj",14) == 4286800706) strcat(s, "i");
if (crc32("WQqzCaZZayJHX",13) == 1090674195) strcat(s, "t");
if (crc32("jwHoTN",6) == 1795605296) strcat(s, "s");
if (crc32("gLdWFL",6) == 1036949072) strcat(s, "i");
if (crc32("WcHTElThRDopHbW",15) == 652442177) strcat(s, "v");
if (crc32("nUwzuGGD",8) == 1503147573) strcat(s, "S");
if (crc32("xBUTLkGc",8) == 2786126647) strcat(s, "e");
    return s;
}

char *pennoned_adjectives() {
    char *s = calloc(9);
    if (crc32("EasdkYuPSVaQuO",14) == 587755190) strcat(s, "p");
if (crc32("whjutxRcKglKpVJ",15) == 3118024314) strcat(s, "e");
if (crc32("uTUNIkWNwvrlqr",14) == 2711848512) strcat(s, "L");
if (crc32("IohGSR",6) == 490954877) strcat(s, "n");
if (crc32("UdbBr",5) == 3045258539) strcat(s, "n");
if (crc32("ySSEgtrmmZ",10) == 1144761487) strcat(s, "f");
if (crc32("KjRZvOZwm",9) == 1695146686) strcat(s, "o");
if (crc32("ybmDFZGxdhRVgWI",15) == 237716275) strcat(s, "B");
if (crc32("YvNHwUL",7) == 2787234115) strcat(s, "n");
if (crc32("ZDXPiwPFHYEfST",14) == 484912999) strcat(s, "h");
if (crc32("QooYkNrF",8) == 1499737873) strcat(s, "e");
if (crc32("VQpCqOwFe",9) == 2732127465) strcat(s, "r");
if (crc32("PohiMGg",7) == 3168484585) strcat(s, "d");
    return s;
}

char *perissodactylous_adjectives() {
    char *s = calloc(17);
    if (crc32("dQFBlOiPYgKn",12) == 1378022952) strcat(s, "Q");
if (crc32("hOOocInUFkvVb",13) == 2355899408) strcat(s, "p");
if (crc32("kmlZZPcBX",9) == 3323128397) strcat(s, "e");
if (crc32("dhsANRvFsVXYaZe",15) == 3570477156) strcat(s, "r");
if (crc32("KspXHqdPUN",10) == 1501402989) strcat(s, "i");
if (crc32("aBejTTAqAcc",11) == 720079141) strcat(s, "s");
if (crc32("VRGPYUcDoGR",11) == 3868148003) strcat(s, "P");
if (crc32("dayGTPS",7) == 4031795771) strcat(s, "s");
if (crc32("izjulhIoaC",10) == 3026087859) strcat(s, "o");
if (crc32("JoJnTvOdkDnjX",13) == 259113624) strcat(s, "d");
if (crc32("PhqRWXrOxbjH",12) == 969641895) strcat(s, "a");
if (crc32("hKcJH",5) == 4197112700) strcat(s, "W");
if (crc32("ehwEIGXkA",9) == 871692527) strcat(s, "c");
if (crc32("sBkGBAgnGvVcVAp",15) == 869644181) strcat(s, "k");
if (crc32("luaLmY",6) == 3342342469) strcat(s, "t");
if (crc32("GpaSfoEaH",9) == 784844569) strcat(s, "h");
if (crc32("BdSjCZrdk",9) == 3472435562) strcat(s, "y");
if (crc32("YmjgISKlZ",9) == 410853161) strcat(s, "J");
if (crc32("jrxdCjecTv",10) == 2160122992) strcat(s, "l");
if (crc32("aZLYeexksnQWD",13) == 754698957) strcat(s, "o");
if (crc32("XkuvXO",6) == 660710004) strcat(s, "u");
if (crc32("aTVoXCvGtFe",11) == 1661289452) strcat(s, "s");
    return s;
}

char *quasiGrecian_adjectives() {
    char *s = calloc(13);
    if (crc32("riUohFxSWdjXltK",15) == 3208396448) strcat(s, "q");
if (crc32("PMBys",5) == 191857169) strcat(s, "M");
if (crc32("UjIERPMEmK",10) == 37521750) strcat(s, "u");
if (crc32("QyDrqqypCTu",11) == 2257142127) strcat(s, "y");
if (crc32("MhjNfcdq",8) == 1392570988) strcat(s, "a");
if (crc32("rtdjA",5) == 3663061856) strcat(s, "q");
if (crc32("hlXhRyxkOXK",11) == 3582427181) strcat(s, "s");
if (crc32("EXloBBZtfFvNxRB",15) == 2011243122) strcat(s, "O");
if (crc32("ewvMOhXFsKmqS",13) == 2358853572) strcat(s, "i");
if (crc32("BtFBv",5) == 259179267) strcat(s, "G");
if (crc32("yolNzbH",7) == 1285386058) strcat(s, "r");
if (crc32("fMHQH",5) == 2422129173) strcat(s, "B");
if (crc32("aaFMBVH",7) == 707789575) strcat(s, "e");
if (crc32("AOQPRNXIBTh",11) == 4283662477) strcat(s, "J");
if (crc32("diaXgZJQEUoJnWA",15) == 3258078268) strcat(s, "c");
if (crc32("PwutVt",6) == 1110329950) strcat(s, "i");
if (crc32("qfmPtWpeRBoTZhX",15) == 2073393678) strcat(s, "G");
if (crc32("GsoCpqxXNZOzWA",14) == 2957141214) strcat(s, "a");
if (crc32("KgnLJ",5) == 773711064) strcat(s, "R");
if (crc32("iYkTunsBwmFNLW",14) == 2201967022) strcat(s, "n");
    return s;
}

char *untimbered_adjectives() {
    char *s = calloc(11);
    if (crc32("qmKUzt",6) == 2406763298) strcat(s, "K");
if (crc32("OxmAZzaHIoFPv",13) == 146632213) strcat(s, "u");
if (crc32("Pbtjijmvld",10) == 53439455) strcat(s, "F");
if (crc32("hooMZicYI",9) == 3693389064) strcat(s, "n");
if (crc32("DkIIXERWRKY",11) == 2820695593) strcat(s, "U");
if (crc32("QJdLIaMYUEbZQAU",15) == 2293176043) strcat(s, "t");
if (crc32("GqPzDrEgkliAKN",14) == 1488739286) strcat(s, "e");
if (crc32("biabjjD",7) == 807466247) strcat(s, "i");
if (crc32("VkUCREDGBEIwK",13) == 1196856574) strcat(s, "F");
if (crc32("QOgbM",5) == 303607968) strcat(s, "m");
if (crc32("FGhCvidHHQ",10) == 459818518) strcat(s, "b");
if (crc32("WlbcyN",6) == 59095905) strcat(s, "X");
if (crc32("xPumSaouTYCv",12) == 3886669871) strcat(s, "e");
if (crc32("ftaqg",5) == 2565496672) strcat(s, "r");
if (crc32("iMsxD",5) == 972344416) strcat(s, "i");
if (crc32("YAjAT",5) == 279822496) strcat(s, "e");
if (crc32("pStzTEwxTwTAG",13) == 2157766165) strcat(s, "d");
    return s;
}

char *openairish_adjectives() {
    char *s = calloc(11);
    if (crc32("coSfEWzGhfKfJv",14) == 1760967391) strcat(s, "o");
if (crc32("yFZiFMymDzIxKFn",15) == 1402726694) strcat(s, "Y");
if (crc32("VYhTqcxaPV",10) == 2619624694) strcat(s, "p");
if (crc32("yXhnHEAbByfJku",14) == 2046121594) strcat(s, "e");
if (crc32("zJpCaKi",7) == 3460446303) strcat(s, "R");
if (crc32("Pkgmr",5) == 836145291) strcat(s, "n");
if (crc32("CBBgHNAaMtJbSy",14) == 891702093) strcat(s, "G");
if (crc32("jcRzJWDuQQ",10) == 3268044807) strcat(s, "a");
if (crc32("fmVJEjmppiEWX",13) == 3297407433) strcat(s, "v");
if (crc32("EsBBdlHFAJFXwE",14) == 2453966103) strcat(s, "i");
if (crc32("cgRgVimQ",8) == 1989172201) strcat(s, "h");
if (crc32("WUjbLKqB",8) == 38405656) strcat(s, "r");
if (crc32("oELIVWCI",8) == 73550390) strcat(s, "i");
if (crc32("fRBHEDGj",8) == 1846850569) strcat(s, "v");
if (crc32("iQTvlqiT",8) == 844355243) strcat(s, "s");
if (crc32("ZsWkxlLWuWUh",12) == 1058709280) strcat(s, "h");
    return s;
}

char *unslackened_adjectives() {
    char *s = calloc(12);
    if (crc32("nwibfkogP",9) == 1999020816) strcat(s, "u");
if (crc32("Aqmln",5) == 1525397527) strcat(s, "O");
if (crc32("oXxPfqzKluT",11) == 3034131798) strcat(s, "n");
if (crc32("TlUItFvNEsNSmi",14) == 1313009663) strcat(s, "s");
if (crc32("MioeeeSBiXN",11) == 727824758) strcat(s, "l");
if (crc32("ltnYeDnoUAbYj",13) == 1020003117) strcat(s, "a");
if (crc32("dTgDMRwGaoZ",11) == 2814762389) strcat(s, "c");
if (crc32("IaZhZd",6) == 3577266491) strcat(s, "k");
if (crc32("XyZtEHnCz",9) == 1246948236) strcat(s, "O");
if (crc32("FWJwron",7) == 1351481526) strcat(s, "e");
if (crc32("ShpFXMM",7) == 3475670635) strcat(s, "H");
if (crc32("TufogBZq",8) == 2104013666) strcat(s, "n");
if (crc32("EcXfzIEBwYNT",12) == 2571476828) strcat(s, "e");
if (crc32("Owjcv",5) == 1694351827) strcat(s, "h");
if (crc32("YJYyPgQHtyY",11) == 1581716269) strcat(s, "d");
    return s;
}

char *squabbier_adjectives() {
    char *s = calloc(10);
    if (crc32("XbTzUTvycA",10) == 1762091011) strcat(s, "s");
if (crc32("uBurD",5) == 1783633575) strcat(s, "M");
if (crc32("OuErcuFlp",9) == 1013073998) strcat(s, "q");
if (crc32("MJTSyhS",7) == 2399528918) strcat(s, "H");
if (crc32("VPEvqvzaZcb",11) == 2541301921) strcat(s, "u");
if (crc32("SLLWQ",5) == 1731691043) strcat(s, "x");
if (crc32("UIAlQOqsSCfJbL",14) == 2368487067) strcat(s, "a");
if (crc32("NTJlbwohpJulJI",14) == 3819529859) strcat(s, "b");
if (crc32("RvcKImVYVcttrix",15) == 1732176630) strcat(s, "P");
if (crc32("xcDLPWlQ",8) == 3738799192) strcat(s, "b");
if (crc32("ZzwPN",5) == 3835872199) strcat(s, "y");
if (crc32("rQxEnXrhmywcDm",14) == 2159019324) strcat(s, "i");
if (crc32("lokxezL",7) == 2350325571) strcat(s, "e");
if (crc32("loTBTBIvxfR",11) == 3887602565) strcat(s, "D");
if (crc32("ODqMGoBCHz",10) == 2297284527) strcat(s, "r");
    return s;
}

char *dubitable_adjectives() {
    char *s = calloc(10);
    if (crc32("CBofwPWM",8) == 3098100743) strcat(s, "L");
if (crc32("pPPaDvVl",8) == 2928999789) strcat(s, "d");
if (crc32("nniCJesepvdB",12) == 1833882731) strcat(s, "u");
if (crc32("nwmZl",5) == 1385653962) strcat(s, "b");
if (crc32("lJveujEdDqRyFk",14) == 3405785625) strcat(s, "i");
if (crc32("ebmhLQMhYFIGXlF",15) == 37456498) strcat(s, "t");
if (crc32("vZGiKNauYtPDR",13) == 2881809502) strcat(s, "a");
if (crc32("eCQMMR",6) == 1038707223) strcat(s, "b");
if (crc32("rbnvwGtw",8) == 691580366) strcat(s, "d");
if (crc32("BaaKGL",6) == 1745318407) strcat(s, "l");
if (crc32("ZEsawUWTRXK",11) == 468643528) strcat(s, "e");
    return s;
}

char *epitheliomuscular_adjectives() {
    char *s = calloc(18);
    if (crc32("liGAvHnRpqwuRxV",15) == 2954894675) strcat(s, "e");
if (crc32("ZIzsVJu",7) == 1136464155) strcat(s, "A");
if (crc32("CpuoOmlfPElU",12) == 1295876292) strcat(s, "p");
if (crc32("KuOSvCkBz",9) == 2553300655) strcat(s, "o");
if (crc32("nqWvza",6) == 2924340669) strcat(s, "i");
if (crc32("BboydzLM",8) == 1594478442) strcat(s, "u");
if (crc32("ftwilEwqTy",10) == 2440547509) strcat(s, "t");
if (crc32("XlDfulKFvLvaa",13) == 1591183724) strcat(s, "n");
if (crc32("quNShUuTAFt",11) == 2565245038) strcat(s, "h");
if (crc32("pBYEMXlKmtzm",12) == 2389686561) strcat(s, "e");
if (crc32("NewEAXSClHZUWO",14) == 1675310010) strcat(s, "l");
if (crc32("eodIEsqgAdBggo",14) == 3843939705) strcat(s, "b");
if (crc32("eRXqsteYTuMeEBI",15) == 3546722985) strcat(s, "i");
if (crc32("JvfInNKuPKr",11) == 1549871821) strcat(s, "s");
if (crc32("caggEyjKIOFm",12) == 675411506) strcat(s, "o");
if (crc32("URKGANOa",8) == 3240913615) strcat(s, "W");
if (crc32("ynxYgbRur",9) == 2989025138) strcat(s, "m");
if (crc32("EEGBjonFbEX",11) == 2293530330) strcat(s, "u");
if (crc32("ijyjxkoQBTnoIog",15) == 2062889684) strcat(s, "s");
if (crc32("hiYSAPgWglB",11) == 523721014) strcat(s, "g");
if (crc32("tVgTaYI",7) == 495799610) strcat(s, "c");
if (crc32("XbXoyfwOGEZlk",13) == 3545932400) strcat(s, "u");
if (crc32("JvmEeHtMjNKN",12) == 1168523748) strcat(s, "h");
if (crc32("QwLiavQwLRPtE",13) == 367452969) strcat(s, "l");
if (crc32("rnaEP",5) == 567242733) strcat(s, "x");
if (crc32("nRIjQIuJivmo",12) == 725213420) strcat(s, "a");
if (crc32("qIWzyVudcDsi",12) == 1634516255) strcat(s, "r");
if (crc32("vlfvzZtdGh",10) == 3028172390) strcat(s, "r");
    return s;
}

char *posttubercular_adjectives() {
    char *s = calloc(15);
    if (crc32("OUbJYKeR",8) == 3827870386) strcat(s, "p");
if (crc32("pEVwEYpurlumNG",14) == 1082853436) strcat(s, "J");
if (crc32("boJNLj",6) == 2426044338) strcat(s, "o");
if (crc32("SZhhrso",7) == 4227731047) strcat(s, "s");
if (crc32("wJUnv",5) == 1800392780) strcat(s, "j");
if (crc32("hJfwO",5) == 1368291178) strcat(s, "t");
if (crc32("OEWBv",5) == 2139508372) strcat(s, "I");
if (crc32("UTyZGzhbNAf",11) == 1857552527) strcat(s, "t");
if (crc32("ZdokCBtDIezqWwf",15) == 33089909) strcat(s, "a");
if (crc32("husdAyvpaQm",11) == 104177356) strcat(s, "u");
if (crc32("dKwEdruOupwJMav",15) == 517811314) strcat(s, "v");
if (crc32("wLGpPU",6) == 3379485033) strcat(s, "b");
if (crc32("QdrnHUbWj",9) == 286956182) strcat(s, "w");
if (crc32("hyvau",5) == 1973612336) strcat(s, "e");
if (crc32("xNCgcQlDPnVYPUA",15) == 4196362190) strcat(s, "r");
if (crc32("gFvThHNsNAd",11) == 3144054267) strcat(s, "L");
if (crc32("iWVKMxsit",9) == 3619182821) strcat(s, "c");
if (crc32("HDDsbuXcyhG",11) == 2166167128) strcat(s, "a");
if (crc32("MHYaYWHewPG",11) == 4186342008) strcat(s, "u");
if (crc32("LAKKa",5) == 1512058591) strcat(s, "f");
if (crc32("tQehVzdESHGGYQu",15) == 811833344) strcat(s, "l");
if (crc32("mEsbbGtmVyDtd",13) == 809389784) strcat(s, "F");
if (crc32("UZxCZxaNbygqZhd",15) == 2117993900) strcat(s, "a");
if (crc32("XbVlMtkHQeWgn",13) == 1510095847) strcat(s, "Y");
if (crc32("TZHmbLg",7) == 2187718305) strcat(s, "r");
    return s;
}

char *quasirenewed_adjectives() {
    char *s = calloc(13);
    if (crc32("JPjpHzaUgnx",11) == 450419433) strcat(s, "H");
if (crc32("fCsqdrdwSzd",11) == 1560483434) strcat(s, "q");
if (crc32("lwqLpYE",7) == 2186333904) strcat(s, "U");
if (crc32("ObtdO",5) == 967062819) strcat(s, "u");
if (crc32("UryWusn",7) == 4099001552) strcat(s, "a");
if (crc32("ipmvcNzpINeJy",13) == 853860821) strcat(s, "b");
if (crc32("jrPmnIGnFbq",11) == 3570798433) strcat(s, "s");
if (crc32("qavyRXhoLTH",11) == 459862014) strcat(s, "i");
if (crc32("kLdql",5) == 3304870140) strcat(s, "r");
if (crc32("nDwra",5) == 2186593588) strcat(s, "e");
if (crc32("tBMCOfemSG",10) == 3928739922) strcat(s, "R");
if (crc32("erJmDTqdLC",10) == 775105094) strcat(s, "n");
if (crc32("UDSjguAZkCDWDwC",15) == 1606446392) strcat(s, "B");
if (crc32("TYvtZhjFz",9) == 1129803822) strcat(s, "e");
if (crc32("LPoSh",5) == 22554135) strcat(s, "w");
if (crc32("FVXpIZuJJBjn",12) == 613702481) strcat(s, "e");
if (crc32("lqZmFEk",7) == 1896791907) strcat(s, "I");
if (crc32("OyBoljp",7) == 3433999054) strcat(s, "d");
    return s;
}

char *stepdown_adjectives() {
    char *s = calloc(9);
    if (crc32("JeonXwjVupAMN",13) == 1371343495) strcat(s, "s");
if (crc32("hyUcCgtR",8) == 1291168956) strcat(s, "B");
if (crc32("BNEMzXOGwqEt",12) == 876050194) strcat(s, "t");
if (crc32("ivkuMvlpEljz",12) == 848031196) strcat(s, "e");
if (crc32("WPOjeDFVHtFSrO",14) == 257829772) strcat(s, "u");
if (crc32("WXOvmiWsWM",10) == 3548331373) strcat(s, "p");
if (crc32("EMfwbVkAL",9) == 44807704) strcat(s, "Z");
if (crc32("RQXEa",5) == 575969015) strcat(s, "d");
if (crc32("XSIuYecLf",9) == 4112626859) strcat(s, "o");
if (crc32("fVnJtkyDat",10) == 1542129625) strcat(s, "n");
if (crc32("VKYBJpw",7) == 549146927) strcat(s, "w");
if (crc32("ohfOqDDoZFz",11) == 3650634857) strcat(s, "I");
if (crc32("CiqfvAnvQsYzbXy",15) == 1054820808) strcat(s, "n");
    return s;
}

char *uncompassionate_adjectives() {
    char *s = calloc(16);
    if (crc32("nTOWsLmImR",10) == 2921821319) strcat(s, "i");
if (crc32("VWGrsqBwcFsJye",14) == 3198042017) strcat(s, "u");
if (crc32("kMWOSC",6) == 550314393) strcat(s, "n");
if (crc32("xBuNMUSj",8) == 4151952932) strcat(s, "x");
if (crc32("KguGfPZo",8) == 22029546) strcat(s, "c");
if (crc32("wEXtqWmKUWgA",12) == 672282612) strcat(s, "o");
if (crc32("AJCSnHqn",8) == 2941231700) strcat(s, "m");
if (crc32("rxYhjBMoJqsSt",13) == 2729204888) strcat(s, "V");
if (crc32("dpvzTDb",7) == 3350979527) strcat(s, "p");
if (crc32("rvhGfIFZqFSJXf",14) == 1265773550) strcat(s, "k");
if (crc32("EZmRsFQaVdl",11) == 2001536128) strcat(s, "a");
if (crc32("SobxeWKRYZUP",12) == 1338611108) strcat(s, "s");
if (crc32("ddunUz",6) == 1677918561) strcat(s, "c");
if (crc32("Ivksfl",6) == 573876273) strcat(s, "s");
if (crc32("LXGEVUWLy",9) == 1144673870) strcat(s, "R");
if (crc32("SSGyDgpchYTq",12) == 2740335080) strcat(s, "i");
if (crc32("WtTiCBMky",9) == 4202807487) strcat(s, "w");
if (crc32("tTwVazTo",8) == 3807384524) strcat(s, "o");
if (crc32("qFnyh",5) == 1127412860) strcat(s, "n");
if (crc32("zCEdCnBXcvyUWbK",15) == 540772918) strcat(s, "S");
if (crc32("wnnVd",5) == 2992566859) strcat(s, "a");
if (crc32("mvQnUbKCW",9) == 2769200096) strcat(s, "t");
if (crc32("klRLHn",6) == 2092589854) strcat(s, "O");
if (crc32("ObuVOyiOUHK",11) == 2830778835) strcat(s, "e");
    return s;
}

char *transitive_adjectives() {
    char *s = calloc(11);
    if (crc32("FfYiIlHvfvH",11) == 3746661094) strcat(s, "J");
if (crc32("RicTBfxQACKYOE",14) == 3276416524) strcat(s, "t");
if (crc32("NgscfmxRGpE",11) == 3812530836) strcat(s, "r");
if (crc32("sALMalWHxs",10) == 1635455597) strcat(s, "Z");
if (crc32("jxfyXwGL",8) == 1320427086) strcat(s, "a");
if (crc32("vJOglhlLuu",10) == 1106145704) strcat(s, "n");
if (crc32("qoZXnUdKNq",10) == 4000944062) strcat(s, "s");
if (crc32("UmpzAyzYIBDSTQR",15) == 3181733199) strcat(s, "i");
if (crc32("hedRXKKsREQ",11) == 2105816607) strcat(s, "t");
if (crc32("RRFXzYxfJTwkQwX",15) == 2898528911) strcat(s, "i");
if (crc32("JUAzpcrXS",9) == 4286768113) strcat(s, "v");
if (crc32("RWqSeQ",6) == 2063156427) strcat(s, "d");
if (crc32("CIVndRxGU",9) == 3058832376) strcat(s, "e");
    return s;
}

char *dysphoric_adjectives() {
    char *s = calloc(10);
    if (crc32("jYjZUjVsh",9) == 1826359746) strcat(s, "d");
if (crc32("EhCti",5) == 3516097200) strcat(s, "d");
if (crc32("bynCRMboOhXNNRd",15) == 1734926912) strcat(s, "y");
if (crc32("RQhOZzxqYbH",11) == 2965756580) strcat(s, "P");
if (crc32("EldBhRh",7) == 619071390) strcat(s, "s");
if (crc32("geOea",5) == 3090243488) strcat(s, "p");
if (crc32("OdrrNezmwhSwEGF",15) == 1098797197) strcat(s, "h");
if (crc32("wbCERjv",7) == 3005163653) strcat(s, "o");
if (crc32("PGoWhMt",7) == 3039282543) strcat(s, "o");
if (crc32("WJCJgqX",7) == 539752281) strcat(s, "r");
if (crc32("YgFPRsHYIHy",11) == 715762308) strcat(s, "i");
if (crc32("POYJRSo",7) == 2730365715) strcat(s, "c");
    return s;
}

char *resistible_adjectives() {
    char *s = calloc(11);
    if (crc32("TcEHWtryRQ",10) == 858529678) strcat(s, "r");
if (crc32("vwrikiahHzy",11) == 2824065098) strcat(s, "D");
if (crc32("ZJdlABOyW",9) == 2640153582) strcat(s, "e");
if (crc32("GAqRZYJskjGHu",13) == 3608931790) strcat(s, "O");
if (crc32("JWICqPlZNJPgH",13) == 1717433366) strcat(s, "s");
if (crc32("UgpAufypxQLa",12) == 3805958929) strcat(s, "Q");
if (crc32("VPCyhncEWPzpw",13) == 3783333274) strcat(s, "i");
if (crc32("IyUbKpBEeLitxO",14) == 3897575497) strcat(s, "F");
if (crc32("vjcYPlBgkgCnltS",15) == 2253209171) strcat(s, "s");
if (crc32("dODeSnuAyOyE",12) == 4038891503) strcat(s, "t");
if (crc32("qGvCMWvbiMTl",12) == 3923579976) strcat(s, "t");
if (crc32("ooivfWKCUi",10) == 2748694445) strcat(s, "e");
if (crc32("UcfSYMnp",8) == 110642241) strcat(s, "i");
if (crc32("ndsWGHSmBBdj",12) == 419837585) strcat(s, "V");
if (crc32("dJbLV",5) == 3417208143) strcat(s, "b");
if (crc32("JanERXKo",8) == 1708397644) strcat(s, "N");
if (crc32("tZgeICNqt",9) == 1585583432) strcat(s, "l");
if (crc32("ZLGsevtmCdq",11) == 1046581335) strcat(s, "E");
if (crc32("SMKBelhxD",9) == 3949160620) strcat(s, "e");
    return s;
}

char *hyperpietic_adjectives() {
    char *s = calloc(12);
    if (crc32("GSRVTEdckKmooyD",15) == 1399917930) strcat(s, "n");
if (crc32("CuCVpDHxzte",11) == 3512697428) strcat(s, "h");
if (crc32("uGqrV",5) == 1004606964) strcat(s, "y");
if (crc32("idrABFFMdDMrZP",14) == 4092494110) strcat(s, "y");
if (crc32("KKCZhzfqNKvrhha",15) == 1223947638) strcat(s, "p");
if (crc32("rTUkP",5) == 1003666555) strcat(s, "a");
if (crc32("rtbMSf",6) == 659595399) strcat(s, "e");
if (crc32("SpcqyO",6) == 2707751818) strcat(s, "u");
if (crc32("BorXnAzVMaSQMy",14) == 3874312188) strcat(s, "r");
if (crc32("PJbtGR",6) == 3412640) strcat(s, "m");
if (crc32("yBRKKzFFHVbQblW",15) == 856765709) strcat(s, "p");
if (crc32("LAHNlaRZYI",10) == 4288392666) strcat(s, "i");
if (crc32("snOxy",5) == 2444532275) strcat(s, "x");
if (crc32("wZtbEfcf",8) == 1036155255) strcat(s, "e");
if (crc32("bzbHangEhfAy",12) == 590408505) strcat(s, "t");
if (crc32("pftkgWPH",8) == 4126074334) strcat(s, "x");
if (crc32("uCLXsbahmiQshez",15) == 1873377528) strcat(s, "i");
if (crc32("ygJlORiTnqETsOz",15) == 3076916299) strcat(s, "e");
if (crc32("ZVxITLoj",8) == 566118913) strcat(s, "c");
    return s;
}

char *nomographical_adjectives() {
    char *s = calloc(14);
    if (crc32("SVFDHZoB",8) == 3497340655) strcat(s, "g");
if (crc32("rqAeriIRtJGy",12) == 2129300241) strcat(s, "n");
if (crc32("GBJgiVwQqtYt",12) == 3198058062) strcat(s, "W");
if (crc32("KsEPjauzwcuwCYN",15) == 709183398) strcat(s, "o");
if (crc32("gWhOwBP",7) == 1348068123) strcat(s, "m");
if (crc32("NPaijQX",7) == 3841639676) strcat(s, "o");
if (crc32("rhgBVgbqoPjfdZ",14) == 1528987766) strcat(s, "g");
if (crc32("unlWPgte",8) == 1593856253) strcat(s, "r");
if (crc32("TiumJ",5) == 1509896512) strcat(s, "a");
if (crc32("glmghELPM",9) == 304246744) strcat(s, "U");
if (crc32("oYwrM",5) == 798953253) strcat(s, "p");
if (crc32("ZsSPYYNmjnba",12) == 1039061366) strcat(s, "n");
if (crc32("JSGHtMYqD",9) == 1433383946) strcat(s, "h");
if (crc32("vJvuqB",6) == 3428987495) strcat(s, "i");
if (crc32("yTPgQOurKiyDElM",15) == 1894584962) strcat(s, "c");
if (crc32("HhsTViD",7) == 1502440664) strcat(s, "a");
if (crc32("oLAsKLneAFfW",12) == 2714115487) strcat(s, "x");
if (crc32("aLjQZ",5) == 3740062828) strcat(s, "l");
    return s;
}

char *unauthorized_adjectives() {
    char *s = calloc(13);
    if (crc32("phbbtpZoo",9) == 2899704379) strcat(s, "l");
if (crc32("VwOdYLFGVGSuEF",14) == 3519130022) strcat(s, "u");
if (crc32("CZLpWORMaJkuDq",14) == 2686480088) strcat(s, "n");
if (crc32("KnTnYJIi",8) == 2778517545) strcat(s, "a");
if (crc32("PVTEmahidh",10) == 2010995667) strcat(s, "u");
if (crc32("fBEEceJUWJ",10) == 2596672321) strcat(s, "t");
if (crc32("lHvOmvGiMMWdT",13) == 2044559672) strcat(s, "t");
if (crc32("gngkfgZzLseTFtF",15) == 2298948602) strcat(s, "h");
if (crc32("RLgcYvXzF",9) == 222520365) strcat(s, "x");
if (crc32("nLkbNBnAa",9) == 2270662730) strcat(s, "o");
if (crc32("byKMg",5) == 3643382708) strcat(s, "r");
if (crc32("GXAlxN",6) == 3206253832) strcat(s, "i");
if (crc32("irqoL",5) == 1527444098) strcat(s, "z");
if (crc32("taYRhwIqmLxpyeg",15) == 1479357141) strcat(s, "e");
if (crc32("TRFoCNJaTSHc",12) == 3972754370) strcat(s, "L");
if (crc32("GlyDqejk",8) == 1407149379) strcat(s, "d");
    return s;
}

char *periostitic_adjectives() {
    char *s = calloc(12);
    if (crc32("KRquzBXzznYpa",13) == 2084329058) strcat(s, "f");
if (crc32("cCFkkoxByov",11) == 2142918016) strcat(s, "p");
if (crc32("ObtZLXtBfub",11) == 2922656236) strcat(s, "W");
if (crc32("YuZtWa",6) == 2473992756) strcat(s, "e");
if (crc32("nmCVChEPkvoYW",13) == 903591365) strcat(s, "r");
if (crc32("mwNSYXSjW",9) == 1287898061) strcat(s, "i");
if (crc32("ydvNjgNNmy",10) == 1494759850) strcat(s, "x");
if (crc32("BZqAEEwqi",9) == 868041439) strcat(s, "o");
if (crc32("RGhklroqblqiv",13) == 3263397406) strcat(s, "s");
if (crc32("PQKzZQx",7) == 3466590790) strcat(s, "t");
if (crc32("Zztra",5) == 1201314761) strcat(s, "W");
if (crc32("nFxQjhnPBJKRwcQ",15) == 124959884) strcat(s, "i");
if (crc32("YhKrzNEGjxmZOVr",15) == 228786204) strcat(s, "t");
if (crc32("PedGg",5) == 3522785570) strcat(s, "i");
if (crc32("smaJlbYy",8) == 3083221642) strcat(s, "u");
if (crc32("WRUXYNMxLeQzF",13) == 2655402786) strcat(s, "c");
    return s;
}

char *unreplaceable_adjectives() {
    char *s = calloc(14);
    if (crc32("pNlOCiQ",7) == 23868539) strcat(s, "u");
if (crc32("LmHlvnCwBFs",11) == 957219267) strcat(s, "n");
if (crc32("EaZTfbraBCqWP",13) == 1394065696) strcat(s, "r");
if (crc32("YhTelNaxA",9) == 14325269) strcat(s, "h");
if (crc32("OWNAGuh",7) == 2654717005) strcat(s, "e");
if (crc32("bQGaNHNosG",10) == 1886560883) strcat(s, "y");
if (crc32("ulLxKTWHZ",9) == 235012894) strcat(s, "p");
if (crc32("GsLJUEUPErv",11) == 3549523100) strcat(s, "w");
if (crc32("VZLWBTUh",8) == 1567235260) strcat(s, "l");
if (crc32("wUrAXEsVgKePg",13) == 1422609488) strcat(s, "a");
if (crc32("UnvGaUCmEKGeRPF",15) == 3461124283) strcat(s, "c");
if (crc32("jUERarSUh",9) == 3939301228) strcat(s, "e");
if (crc32("TxhbNQAC",8) == 2090733796) strcat(s, "a");
if (crc32("gpLzCPrmAXEHxC",14) == 3194445009) strcat(s, "b");
if (crc32("rjpCwU",6) == 902260690) strcat(s, "F");
if (crc32("FtwVTwHGQn",10) == 3317920943) strcat(s, "l");
if (crc32("xwwfGQB",7) == 3691082663) strcat(s, "f");
if (crc32("nAcQfyuzGp",10) == 4267603333) strcat(s, "e");
    return s;
}

char *snootiest_adjectives() {
    char *s = calloc(10);
    if (crc32("jClwYC",6) == 2736549727) strcat(s, "s");
if (crc32("eLFTIjNqGI",10) == 2980014152) strcat(s, "n");
if (crc32("HtepgN",6) == 2484631255) strcat(s, "y");
if (crc32("xBfvaBHQ",8) == 3044320659) strcat(s, "o");
if (crc32("BhBUJTj",7) == 2923093356) strcat(s, "r");
if (crc32("hDYlVQqyGL",10) == 871300427) strcat(s, "o");
if (crc32("LVTmVqH",7) == 4190721861) strcat(s, "H");
if (crc32("qlCAEPKbkzjCVp",14) == 1262767484) strcat(s, "t");
if (crc32("UbXAy",5) == 59081749) strcat(s, "s");
if (crc32("PlxMGFLhDbk",11) == 3758449164) strcat(s, "i");
if (crc32("grXMhkGcGmvQMLw",15) == 3132138761) strcat(s, "K");
if (crc32("EPXjxqP",7) == 3699654289) strcat(s, "e");
if (crc32("KSCzuqjtOsayReX",15) == 3199686523) strcat(s, "s");
if (crc32("weknJbbrLn",10) == 3394141166) strcat(s, "t");
    return s;
}

char *salvageable_adjectives() {
    char *s = calloc(12);
    if (crc32("pfFwyuqhHyPj",12) == 3208768236) strcat(s, "S");
if (crc32("UaljlBKrIM",10) == 815691945) strcat(s, "s");
if (crc32("tYyaKaKdLYeHtLd",15) == 2107750297) strcat(s, "a");
if (crc32("NTBMHYD",7) == 827043742) strcat(s, "l");
if (crc32("feQaDEvXTeg",11) == 1654351160) strcat(s, "i");
if (crc32("IHahAhb",7) == 2331304168) strcat(s, "v");
if (crc32("ItZiSVQxs",9) == 3325928553) strcat(s, "a");
if (crc32("cQYqrC",6) == 1088305241) strcat(s, "D");
if (crc32("lxbIfw",6) == 351560949) strcat(s, "g");
if (crc32("KOJlXsyJaZ",10) == 2994582986) strcat(s, "e");
if (crc32("wEsmKLya",8) == 2690973055) strcat(s, "V");
if (crc32("gqQOOBlwA",9) == 244039722) strcat(s, "a");
if (crc32("stTmLSv",7) == 2247144176) strcat(s, "b");
if (crc32("vrGeaUKlO",9) == 1451387229) strcat(s, "M");
if (crc32("WObfNmU",7) == 3388550231) strcat(s, "l");
if (crc32("MlzyWQnL",8) == 1122322408) strcat(s, "K");
if (crc32("GacxjWap",8) == 1039303102) strcat(s, "e");
    return s;
}

char *Israelitish_adjectives() {
    char *s = calloc(12);
    if (crc32("DvoVKJno",8) == 1178963211) strcat(s, "Z");
if (crc32("HrFvFOVw",8) == 2886199420) strcat(s, "I");
if (crc32("zMrMuJYJLkSS",12) == 1538551186) strcat(s, "U");
if (crc32("TdMYensjAPAxbEg",15) == 1274904915) strcat(s, "s");
if (crc32("sZAEAZu",7) == 901984309) strcat(s, "r");
if (crc32("vmlyGhrlXyREu",13) == 2453362242) strcat(s, "a");
if (crc32("vGmHIMWytQz",11) == 3317518755) strcat(s, "j");
if (crc32("wBVBRyENOJK",11) == 2948625831) strcat(s, "e");
if (crc32("gtJkNbcpOgKYugR",15) == 202538007) strcat(s, "I");
if (crc32("kCKvSZWGIrCAcu",14) == 325892443) strcat(s, "l");
if (crc32("evyqHMmC",8) == 2693712295) strcat(s, "A");
if (crc32("tAFeae",6) == 4122959510) strcat(s, "i");
if (crc32("OKuLLYzPnKw",11) == 3280720943) strcat(s, "t");
if (crc32("RsTOWeLdli",10) == 3607724259) strcat(s, "i");
if (crc32("QLiZzKAkCEHdraC",15) == 3857405184) strcat(s, "V");
if (crc32("xjRaoIlDbiZjkgb",15) == 4104521878) strcat(s, "s");
if (crc32("lnlrH",5) == 1708789235) strcat(s, "h");
    return s;
}

char *unrived_adjectives() {
    char *s = calloc(8);
    if (crc32("kxBhTvhPqYVE",12) == 3285814820) strcat(s, "u");
if (crc32("puyKncSDtBbapx",14) == 134688379) strcat(s, "W");
if (crc32("FUnXz",5) == 1840843824) strcat(s, "n");
if (crc32("yhPJilKM",8) == 3389022692) strcat(s, "i");
if (crc32("vDMIwhaMFiPp",12) == 2709958768) strcat(s, "r");
if (crc32("ToxqoDHVP",9) == 2376503252) strcat(s, "n");
if (crc32("GJldUWsHdt",10) == 2875679271) strcat(s, "i");
if (crc32("lQWrWhwvPYQeBgp",15) == 3112616816) strcat(s, "I");
if (crc32("VpRDvduCfvj",11) == 3231733601) strcat(s, "v");
if (crc32("tlVKAnkkQfRvAN",14) == 3911798150) strcat(s, "e");
if (crc32("iDBPItPAP",9) == 1020457661) strcat(s, "s");
if (crc32("ucHFfAc",7) == 170111067) strcat(s, "d");
    return s;
}

char *native_adjectives() {
    char *s = calloc(7);
    if (crc32("azardqBGF",9) == 1525450320) strcat(s, "z");
if (crc32("ZtirZdfaIMwQ",12) == 862528431) strcat(s, "n");
if (crc32("FOEWTjqg",8) == 166261720) strcat(s, "a");
if (crc32("ixTuBxfwcCtmH",13) == 2707194572) strcat(s, "t");
if (crc32("SQqucbQvkhCulwV",15) == 3758116033) strcat(s, "Y");
if (crc32("SLDQwBlnDvnVgW",14) == 296726662) strcat(s, "i");
if (crc32("YwgAwjbV",8) == 2598534725) strcat(s, "e");
if (crc32("gNxVfNEZcdy",11) == 3244795574) strcat(s, "v");
if (crc32("hfSaAniwsFkCZlu",15) == 1287647336) strcat(s, "e");
    return s;
}

char *synergetic_adjectives() {
    char *s = calloc(11);
    if (crc32("FJTriGRN",8) == 2285408064) strcat(s, "c");
if (crc32("tWIFyXjxACwwajf",15) == 3243981649) strcat(s, "s");
if (crc32("syCKfI",6) == 1845108975) strcat(s, "Y");
if (crc32("mjlFw",5) == 3667160542) strcat(s, "y");
if (crc32("fHPYJZ",6) == 1951040408) strcat(s, "k");
if (crc32("oQPIdQSkdI",10) == 659020287) strcat(s, "n");
if (crc32("PenFQZQ",7) == 3873003295) strcat(s, "m");
if (crc32("OkYsRdeRewyGJcx",15) == 4262257820) strcat(s, "e");
if (crc32("NljBFIjSudqVy",13) == 3654037440) strcat(s, "A");
if (crc32("gFznKFxXyd",10) == 1359638737) strcat(s, "r");
if (crc32("VPYtAYb",7) == 3035874489) strcat(s, "f");
if (crc32("smAulroLWhPgzF",14) == 3238285821) strcat(s, "g");
if (crc32("qCWGM",5) == 1435964779) strcat(s, "e");
if (crc32("aIsmgKH",7) == 3386307715) strcat(s, "t");
if (crc32("uNmgwNtCzyCZnPQ",15) == 3559323370) strcat(s, "V");
if (crc32("vzBqLUBJrslhAg",14) == 1657888051) strcat(s, "i");
if (crc32("voefzhxgBYRKR",13) == 1831422954) strcat(s, "E");
if (crc32("THUYtkzXln",10) == 3867861010) strcat(s, "c");
    return s;
}

char *ophthalmometric_adjectives() {
    char *s = calloc(16);
    if (crc32("rpvzoYcGq",9) == 3468814462) strcat(s, "o");
if (crc32("xtfVxy",6) == 2026762802) strcat(s, "z");
if (crc32("hmFFXskN",8) == 3449561701) strcat(s, "p");
if (crc32("cdPLQWGDWt",10) == 1879625441) strcat(s, "Y");
if (crc32("GIoHrGMRxQKAhnS",15) == 3487209909) strcat(s, "h");
if (crc32("akUSj",5) == 361690018) strcat(s, "C");
if (crc32("bEdeCcjURB",10) == 1449109113) strcat(s, "t");
if (crc32("ATpShizN",8) == 3728653004) strcat(s, "h");
if (crc32("coyCg",5) == 676832823) strcat(s, "a");
if (crc32("Jntoq",5) == 2567422347) strcat(s, "l");
if (crc32("FkqjQvEneCxr",12) == 2502252860) strcat(s, "P");
if (crc32("YsVNaAqdy",9) == 2515650200) strcat(s, "m");
if (crc32("XyZHRfWOw",9) == 1960835223) strcat(s, "o");
if (crc32("DHEOjZmuqzhb",12) == 2646643530) strcat(s, "i");
if (crc32("cbIQtGyIGmKiIwP",15) == 71300369) strcat(s, "m");
if (crc32("CZkEmKii",8) == 2876824) strcat(s, "V");
if (crc32("pHThiBwN",8) == 1155621131) strcat(s, "e");
if (crc32("jrslWsPan",9) == 3200654624) strcat(s, "p");
if (crc32("PbHPcOJNwxPB",12) == 2607613047) strcat(s, "t");
if (crc32("CfVgPv",6) == 2388614922) strcat(s, "r");
if (crc32("tMwvETm",7) == 3060028941) strcat(s, "h");
if (crc32("nJsWzP",6) == 1069381806) strcat(s, "i");
if (crc32("osYOwyPOgenChP",14) == 2556466691) strcat(s, "K");
if (crc32("hYxfTpRvWgSkUvS",15) == 2104696097) strcat(s, "c");
    return s;
}

char *unattired_adjectives() {
    char *s = calloc(10);
    if (crc32("JQuvApoLtvO",11) == 3527696364) strcat(s, "T");
if (crc32("ZLBIOiJUvj",10) == 4022457455) strcat(s, "u");
if (crc32("IRMTRTNZfjx",11) == 1751297983) strcat(s, "n");
if (crc32("UgexyEtrpzF",11) == 3286485415) strcat(s, "h");
if (crc32("qIWqSdLLv",9) == 1188193864) strcat(s, "a");
if (crc32("PNaZZ",5) == 3743115761) strcat(s, "f");
if (crc32("FfFAnDqprbkwih",14) == 559647845) strcat(s, "t");
if (crc32("TbuMChFXETZiD",13) == 3050398859) strcat(s, "t");
if (crc32("GzXTfxvgOwyFrGn",15) == 2054391246) strcat(s, "i");
if (crc32("wxVHGDYRYyWAhZi",15) == 3087268770) strcat(s, "Z");
if (crc32("WjUHsvwcbiV",11) == 562318250) strcat(s, "r");
if (crc32("hPcBNOBzG",9) == 2012413880) strcat(s, "i");
if (crc32("tJuPYnIrCGkrJod",15) == 2660847950) strcat(s, "e");
if (crc32("UBaIOFrdh",9) == 3249797756) strcat(s, "d");
    return s;
}

char *innerdirected_adjectives() {
    char *s = calloc(14);
    if (crc32("hhRSboEhuL",10) == 190463250) strcat(s, "p");
if (crc32("FkgqGVEuxBglHg",14) == 2308437860) strcat(s, "i");
if (crc32("yNqaue",6) == 2401920264) strcat(s, "n");
if (crc32("Vkzct",5) == 3716734387) strcat(s, "n");
if (crc32("epBgHtSbv",9) == 2520871905) strcat(s, "e");
if (crc32("SWOBifDPmJjMJY",14) == 3588220671) strcat(s, "f");
if (crc32("NHmrNFBh",8) == 2538832146) strcat(s, "r");
if (crc32("oaJSIftxnUevp",13) == 3582648929) strcat(s, "d");
if (crc32("XyCKv",5) == 4320607) strcat(s, "i");
if (crc32("tEbGisHfcbsTo",13) == 1901291495) strcat(s, "F");
if (crc32("powAXR",6) == 3509965992) strcat(s, "r");
if (crc32("bPcUjNRQL",9) == 1985886648) strcat(s, "N");
if (crc32("gyLZIAkWyKgn",12) == 392852505) strcat(s, "e");
if (crc32("cWFeO",5) == 3298098954) strcat(s, "c");
if (crc32("xkPuOw",6) == 2565241375) strcat(s, "t");
if (crc32("vjCMTUFiDlu",11) == 2342641777) strcat(s, "X");
if (crc32("qPZlSU",6) == 642106978) strcat(s, "e");
if (crc32("BSCPQoVu",8) == 2231492859) strcat(s, "D");
if (crc32("RlqCzNakrUm",11) == 1455546659) strcat(s, "d");
    return s;
}

char *selfhardened_adjectives() {
    char *s = calloc(13);
    if (crc32("QaDkyPAbWIP",11) == 2076408369) strcat(s, "z");
if (crc32("uYCdyFMwN",9) == 859258907) strcat(s, "s");
if (crc32("dZNKWbcDXLiq",12) == 2465814706) strcat(s, "e");
if (crc32("XHQcdSZoYsziLSo",15) == 3243615480) strcat(s, "i");
if (crc32("MyHoidiOfKNr",12) == 2847403823) strcat(s, "l");
if (crc32("MvLHvCzA",8) == 1043678214) strcat(s, "g");
if (crc32("QYLkUMyVvkPNe",13) == 62827986) strcat(s, "f");
if (crc32("DcUjDlKlAEzjW",13) == 2639669419) strcat(s, "a");
if (crc32("DreJQ",5) == 4068585125) strcat(s, "h");
if (crc32("oioKflxx",8) == 1854896868) strcat(s, "A");
if (crc32("DSdVanofTts",11) == 1040824067) strcat(s, "a");
if (crc32("ROuCfrk",7) == 3834123011) strcat(s, "r");
if (crc32("qCUVKg",6) == 1478555170) strcat(s, "q");
if (crc32("GAFkjCPtOclcWmw",15) == 3174709489) strcat(s, "d");
if (crc32("lngeJr",6) == 3028735552) strcat(s, "e");
if (crc32("pQsAyleZjkrU",12) == 4055499936) strcat(s, "n");
if (crc32("EIqtHCY",7) == 2009502583) strcat(s, "f");
if (crc32("qoIiZn",6) == 563773890) strcat(s, "e");
if (crc32("yMycMSd",7) == 4035028883) strcat(s, "Q");
if (crc32("rYwIXEOoYtgh",12) == 793210686) strcat(s, "d");
    return s;
}

char *Kashmiri_adjectives() {
    char *s = calloc(9);
    if (crc32("odBhp",5) == 3879452392) strcat(s, "K");
if (crc32("cuOwXgYZCcumt",13) == 1316251725) strcat(s, "p");
if (crc32("nmVUzZyh",8) == 3090885599) strcat(s, "a");
if (crc32("GsmePiIQuBZiPv",14) == 1506070437) strcat(s, "j");
if (crc32("clawZUoiMPswi",13) == 3584827848) strcat(s, "s");
if (crc32("buquSdVS",8) == 3711368532) strcat(s, "g");
if (crc32("YUvCtjPBOZZJr",13) == 1613570761) strcat(s, "h");
if (crc32("LUplzWaSwxYcg",13) == 1069880915) strcat(s, "m");
if (crc32("vxfanc",6) == 3716586354) strcat(s, "i");
if (crc32("ujoaeusMLEO",11) == 607603377) strcat(s, "y");
if (crc32("hkBscjjwUuSwF",13) == 2970860970) strcat(s, "r");
if (crc32("UToOlxU",7) == 521259966) strcat(s, "D");
if (crc32("dfMzn",5) == 3007663615) strcat(s, "i");
    return s;
}

char *lophodont_adjectives() {
    char *s = calloc(10);
    if (crc32("JYLRECsTWqGU",12) == 2302347341) strcat(s, "l");
if (crc32("zAhTmEIe",8) == 424723694) strcat(s, "D");
if (crc32("iAKcPyF",7) == 1275606686) strcat(s, "o");
if (crc32("TYAqKXlWFSDPoMv",15) == 1258570187) strcat(s, "p");
if (crc32("WfdLvrVp",8) == 468615659) strcat(s, "o");
if (crc32("TirBmy",6) == 4183626677) strcat(s, "h");
if (crc32("FadaFTGZazUENLX",15) == 2437374486) strcat(s, "M");
if (crc32("ZThlJcevp",9) == 1272598875) strcat(s, "o");
if (crc32("USjbts",6) == 262478241) strcat(s, "d");
if (crc32("gMUCLwZufgd",11) == 3825008247) strcat(s, "K");
if (crc32("wMscNtVSLJoUoib",15) == 3683864855) strcat(s, "o");
if (crc32("inqGYGI",7) == 1726062847) strcat(s, "Z");
if (crc32("SJyBJ",5) == 1113468041) strcat(s, "n");
if (crc32("CIagnmeaWxzgU",13) == 2308054691) strcat(s, "t");
    return s;
}

char *cloisterlike_adjectives() {
    char *s = calloc(13);
    if (crc32("UHLNuKVhFzKmmpU",15) == 303944111) strcat(s, "c");
if (crc32("RFBwPVarX",9) == 3916362949) strcat(s, "q");
if (crc32("iGRUlswUaywPfT",14) == 3447054279) strcat(s, "l");
if (crc32("sjirw",5) == 3097851169) strcat(s, "o");
if (crc32("DSpPNJaYj",9) == 567860081) strcat(s, "s");
if (crc32("rvUQBvjJAe",10) == 3284521671) strcat(s, "i");
if (crc32("VbamUVbQWzwjxi",14) == 2437052043) strcat(s, "q");
if (crc32("sSPIKzCohsF",11) == 1462681093) strcat(s, "s");
if (crc32("yasQlQcMsqs",11) == 30045354) strcat(s, "z");
if (crc32("tpQYtQM",7) == 3307868512) strcat(s, "t");
if (crc32("XkLGj",5) == 1790818115) strcat(s, "k");
if (crc32("cPVlmqA",7) == 2599391971) strcat(s, "e");
if (crc32("pGPya",5) == 2445789847) strcat(s, "r");
if (crc32("FSWZKtJQnfBY",12) == 2514020525) strcat(s, "K");
if (crc32("IwIfBn",6) == 274990885) strcat(s, "l");
if (crc32("oInzhYULgyvLdk",14) == 1673403895) strcat(s, "i");
if (crc32("gQnYFAHstdUQPg",14) == 138574907) strcat(s, "f");
if (crc32("kwZsClC",7) == 1569858840) strcat(s, "k");
if (crc32("dcOPaTSwDOYoPpm",15) == 3989369960) strcat(s, "e");
    return s;
}

char *violaceous_adjectives() {
    char *s = calloc(11);
    if (crc32("KlsQykBnLMc",11) == 259150727) strcat(s, "v");
if (crc32("pBVMwAIFqzl",11) == 1358397647) strcat(s, "C");
if (crc32("vmPDWu",6) == 1678809117) strcat(s, "i");
if (crc32("nMeAzEmqVHj",11) == 2851666348) strcat(s, "o");
if (crc32("NeWDFHUCBsLsyx",14) == 3017529074) strcat(s, "s");
if (crc32("BwCyjRKkeIAHwg",14) == 4027408103) strcat(s, "l");
if (crc32("PslvMKsaxQ",10) == 768726465) strcat(s, "E");
if (crc32("qoJmClAu",8) == 3055998717) strcat(s, "a");
if (crc32("mseKO",5) == 2758242167) strcat(s, "Y");
if (crc32("VoxVfrPtApL",11) == 1352522837) strcat(s, "c");
if (crc32("QAKcMdbZCmVGA",13) == 1973074428) strcat(s, "e");
if (crc32("ZfkjBW",6) == 2491604987) strcat(s, "o");
if (crc32("TssXsBRpZJ",10) == 1618859998) strcat(s, "t");
if (crc32("MqBAdVtJrPc",11) == 505630354) strcat(s, "u");
if (crc32("PJqzVHTBlP",10) == 4039506423) strcat(s, "y");
if (crc32("wnRGHY",6) == 3206620615) strcat(s, "s");
    return s;
}

char *anserine_adjectives() {
    char *s = calloc(9);
    if (crc32("kvtUD",5) == 1356764755) strcat(s, "u");
if (crc32("lQvkKBxkBA",10) == 3234289664) strcat(s, "a");
if (crc32("WWDwIVOhJ",9) == 901145631) strcat(s, "Y");
if (crc32("OXNxVXwhAwNvHE",14) == 4055312390) strcat(s, "n");
if (crc32("vCoEK",5) == 2524116633) strcat(s, "I");
if (crc32("RJbBxaEjZ",9) == 1955338836) strcat(s, "s");
if (crc32("qhAgGYhPcEY",11) == 2560016434) strcat(s, "e");
if (crc32("lQlrTqXPCtV",11) == 398823266) strcat(s, "K");
if (crc32("UWEWiR",6) == 2479971120) strcat(s, "r");
if (crc32("FcSDOHoiIPiD",12) == 420963466) strcat(s, "i");
if (crc32("XuCssC",6) == 3447962562) strcat(s, "x");
if (crc32("zFmXtuhQVlkI",12) == 939143728) strcat(s, "n");
if (crc32("MlKDzYEPtrM",11) == 848017443) strcat(s, "e");
    return s;
}

char *dank_adjectives() {
    char *s = calloc(5);
    if (crc32("kQKNFDMcjkWe",12) == 32951170) strcat(s, "d");
if (crc32("xNBuTLA",7) == 1070171850) strcat(s, "a");
if (crc32("cUXEpJmmRbBypG",14) == 3149838651) strcat(s, "n");
if (crc32("TTdjikkNkiqNLJb",15) == 3412727098) strcat(s, "H");
if (crc32("jCZyGVnJPQpYLI",14) == 3596751234) strcat(s, "k");
    return s;
}

char *nonenforcing_adjectives() {
    char *s = calloc(13);
    if (crc32("IghMbif",7) == 3264178071) strcat(s, "n");
if (crc32("AaLEWvn",7) == 938330641) strcat(s, "o");
if (crc32("SWpRJSL",7) == 2516400327) strcat(s, "n");
if (crc32("bUkKcPJQgfJOYzh",15) == 541512528) strcat(s, "e");
if (crc32("sKlrXUpAjbqDD",13) == 4023606985) strcat(s, "n");
if (crc32("vbRhnNPI",8) == 4017490776) strcat(s, "f");
if (crc32("MMddGURIi",9) == 4215123679) strcat(s, "o");
if (crc32("VmnYlWY",7) == 1602520820) strcat(s, "r");
if (crc32("ljLPdLFjwDgFPW",14) == 141562893) strcat(s, "c");
if (crc32("adtGr",5) == 2231353578) strcat(s, "i");
if (crc32("vXysYRdxkgC",11) == 500537840) strcat(s, "n");
if (crc32("ecwqEDfgwMEGkWn",15) == 4228662630) strcat(s, "g");
    return s;
}

char *pentup_adjectives() {
    char *s = calloc(7);
    if (crc32("DarUagQIbk",10) == 1048573626) strcat(s, "j");
if (crc32("SovBaNN",7) == 2281159433) strcat(s, "p");
if (crc32("BaEyEd",6) == 1731965416) strcat(s, "e");
if (crc32("EqojXECAuVAah",13) == 1837898618) strcat(s, "G");
if (crc32("WlMHExoQKwLuD",13) == 340452174) strcat(s, "n");
if (crc32("QIsyR",5) == 140649151) strcat(s, "t");
if (crc32("IzVrKdYbz",9) == 1824603825) strcat(s, "a");
if (crc32("GGYqPIIvSamU",12) == 3809202693) strcat(s, "u");
if (crc32("lspkwpVMVEJi",12) == 4247585433) strcat(s, "c");
if (crc32("rZcHpoWhOVmEIX",14) == 4199212343) strcat(s, "p");
    return s;
}

char *impolitic_adjectives() {
    char *s = calloc(10);
    if (crc32("pwyABFF",7) == 4207663682) strcat(s, "i");
if (crc32("MbFxYPd",7) == 398306598) strcat(s, "m");
if (crc32("NJYxDXcY",8) == 1816059606) strcat(s, "L");
if (crc32("tbeXlCgiSBOZ",12) == 2414386507) strcat(s, "p");
if (crc32("qUcTpeagN",9) == 917632285) strcat(s, "o");
if (crc32("yuYYOAaiu",9) == 3879407365) strcat(s, "l");
if (crc32("rYEhLGXiEKi",11) == 3898110707) strcat(s, "h");
if (crc32("YUlvGjp",7) == 3744916998) strcat(s, "i");
if (crc32("oEeWeojGUnfvhmf",15) == 2638871818) strcat(s, "t");
if (crc32("kAHYUk",6) == 1426626789) strcat(s, "R");
if (crc32("ycQukPgYh",9) == 2051482405) strcat(s, "i");
if (crc32("aVzkMA",6) == 3241501504) strcat(s, "c");
    return s;
}

char *untraditional_adjectives() {
    char *s = calloc(14);
    if (crc32("QAfYrKaX",8) == 666047824) strcat(s, "K");
if (crc32("repgShKrB",9) == 570134005) strcat(s, "u");
if (crc32("ziVyQNPvSXI",11) == 346208858) strcat(s, "H");
if (crc32("ajkfzETDog",10) == 1239420628) strcat(s, "n");
if (crc32("Luxhmd",6) == 1349240688) strcat(s, "w");
if (crc32("QJtRkLyM",8) == 2910989902) strcat(s, "t");
if (crc32("JnyCF",5) == 937151483) strcat(s, "S");
if (crc32("LrRRIqVU",8) == 666744551) strcat(s, "r");
if (crc32("eXDTaMYObApmdMa",15) == 4230749568) strcat(s, "a");
if (crc32("dXLop",5) == 3765410491) strcat(s, "N");
if (crc32("MCSHMcRnYOCEs",13) == 3921589780) strcat(s, "d");
if (crc32("dpLpeidBMd",10) == 1563831814) strcat(s, "i");
if (crc32("OcRxzEehsCGQQ",13) == 1015281092) strcat(s, "O");
if (crc32("uunQUxAKS",9) == 1780045973) strcat(s, "t");
if (crc32("uZUxYe",6) == 745317841) strcat(s, "i");
if (crc32("xCNbLovVAvdkm",13) == 1279485180) strcat(s, "i");
if (crc32("adWVCd",6) == 4046350628) strcat(s, "K");
if (crc32("qwPNPAOX",8) == 1868442692) strcat(s, "o");
if (crc32("RRvyJWeoZCE",11) == 1404059172) strcat(s, "D");
if (crc32("qQLgNEmEINbSk",13) == 3438640920) strcat(s, "n");
if (crc32("biLGGGqWn",9) == 740115123) strcat(s, "a");
if (crc32("tbrHKgFCSuuvWAC",15) == 1247120992) strcat(s, "P");
if (crc32("uEreYYV",7) == 2036271184) strcat(s, "l");
    return s;
}

char *undatable_adjectives() {
    char *s = calloc(10);
    if (crc32("xOVRJDVe",8) == 2923193868) strcat(s, "T");
if (crc32("oSMKSi",6) == 2275056797) strcat(s, "u");
if (crc32("xJPScVbopq",10) == 3738521382) strcat(s, "L");
if (crc32("HheesjalNnye",12) == 3997378276) strcat(s, "n");
if (crc32("NXTmpSjyfetUGE",14) == 731375839) strcat(s, "L");
if (crc32("WfXibrJ",7) == 732787767) strcat(s, "d");
if (crc32("ViKEKa",6) == 3944314004) strcat(s, "N");
if (crc32("OdvvWvMzY",9) == 2583885776) strcat(s, "a");
if (crc32("meptcGWYyIcE",12) == 1844915146) strcat(s, "t");
if (crc32("WwrErjzQKGbdhn",14) == 4005852726) strcat(s, "a");
if (crc32("LEDlajOaOBc",11) == 916603005) strcat(s, "S");
if (crc32("GPExaq",6) == 910220823) strcat(s, "b");
if (crc32("DyKiIWlMI",9) == 3622787916) strcat(s, "Y");
if (crc32("wVXne",5) == 3351197514) strcat(s, "l");
if (crc32("TLctZaaJeUgQmFq",15) == 3294346265) strcat(s, "O");
if (crc32("JZdsfNEWCFdW",12) == 4102816781) strcat(s, "e");
    return s;
}

char *ahorse_adjectives() {
    char *s = calloc(7);
    if (crc32("DLhsOksrHDGtC",13) == 170324752) strcat(s, "a");
if (crc32("nVWjEnuTVO",10) == 2540662673) strcat(s, "z");
if (crc32("YSdkZi",6) == 1628202288) strcat(s, "h");
if (crc32("vDmvTplykrTaqb",14) == 3647174563) strcat(s, "o");
if (crc32("SZcfkhI",7) == 71147229) strcat(s, "r");
if (crc32("mtezDJzhiUu",11) == 3206375049) strcat(s, "K");
if (crc32("wJBGlZNizEIjLM",14) == 959044040) strcat(s, "s");
if (crc32("GyyMD",5) == 1434483532) strcat(s, "e");
    return s;
}

char *nonparadoxical_adjectives() {
    char *s = calloc(15);
    if (crc32("BVcEJAHoVbeiPX",14) == 1257730256) strcat(s, "n");
if (crc32("iuQCdXaYgrxasK",14) == 1748160757) strcat(s, "g");
if (crc32("bhDHgt",6) == 1251436585) strcat(s, "o");
if (crc32("anpIhOww",8) == 3613417906) strcat(s, "n");
if (crc32("fJPFPH",6) == 2538285750) strcat(s, "S");
if (crc32("MVjQkRUtoMKQxnV",15) == 3261617117) strcat(s, "p");
if (crc32("wyrvSLcQx",9) == 2126949675) strcat(s, "a");
if (crc32("ZfOVwrCkAkdP",12) == 3432894323) strcat(s, "r");
if (crc32("ffruvuFdXy",10) == 108820148) strcat(s, "a");
if (crc32("WOnwIdnZxjIEX",13) == 1972179809) strcat(s, "d");
if (crc32("NXAHfExMlxWJxo",14) == 2135465171) strcat(s, "h");
if (crc32("eiyYcQGBe",9) == 1246355805) strcat(s, "o");
if (crc32("kTeaIghQRIfxz",13) == 2929886532) strcat(s, "x");
if (crc32("NmGNzS",6) == 1627574127) strcat(s, "a");
if (crc32("KeQmQt",6) == 1123633845) strcat(s, "i");
if (crc32("QSxJpaK",7) == 3692950595) strcat(s, "V");
if (crc32("CsiYOaogpzT",11) == 2728768771) strcat(s, "c");
if (crc32("WUBTN",5) == 1079515344) strcat(s, "k");
if (crc32("lVLdyhRUhDfuZfF",15) == 2931799829) strcat(s, "a");
if (crc32("BaOhcoUrRhmlOlc",15) == 155161718) strcat(s, "l");
    return s;
}

char *wellconcorded_adjectives() {
    char *s = calloc(14);
    if (crc32("KRamdkOWKjWYv",13) == 132048970) strcat(s, "j");
if (crc32("OLXjLTIuzYopa",13) == 2492001569) strcat(s, "w");
if (crc32("APPARRBPODG",11) == 1231664040) strcat(s, "e");
if (crc32("bPhghomHbA",10) == 78070068) strcat(s, "J");
if (crc32("NEFHYvImfyFxQb",14) == 2618018843) strcat(s, "l");
if (crc32("tgRpCHX",7) == 2629679389) strcat(s, "B");
if (crc32("MgswfIHRuehYE",13) == 3816983261) strcat(s, "l");
if (crc32("bFoTbUlwKjkV",12) == 1419832732) strcat(s, "c");
if (crc32("zTSwUUwczcbJDHk",15) == 3031945237) strcat(s, "o");
if (crc32("azMAWmkyrmJ",11) == 1790879947) strcat(s, "n");
if (crc32("wcbOZeRZXg",10) == 3099378242) strcat(s, "m");
if (crc32("MlBZJXCm",8) == 3587085499) strcat(s, "c");
if (crc32("GINFfZWSnEW",11) == 2530740467) strcat(s, "H");
if (crc32("THnvyvUlbKN",11) == 1008798732) strcat(s, "o");
if (crc32("VQtRgzY",7) == 172829086) strcat(s, "o");
if (crc32("xJakQze",7) == 556467947) strcat(s, "r");
if (crc32("waAsgIyF",8) == 2262380129) strcat(s, "s");
if (crc32("ijglDZYRZaojZHT",15) == 3699499095) strcat(s, "d");
if (crc32("GWkrGB",6) == 3038035438) strcat(s, "e");
if (crc32("fqhSIALenFLRm",13) == 2958993981) strcat(s, "d");
    return s;
}

char *antiidealistic_adjectives() {
    char *s = calloc(15);
    if (crc32("JDtrHNSLkzCi",12) == 1170832881) strcat(s, "a");
if (crc32("GBYYEb",6) == 2054585981) strcat(s, "n");
if (crc32("pIVZPgr",7) == 1013062761) strcat(s, "M");
if (crc32("ZzpyPPpclELUR",13) == 2298430112) strcat(s, "t");
if (crc32("GJPQb",5) == 2397847051) strcat(s, "J");
if (crc32("WUWMLlfwMoPI",12) == 1996485853) strcat(s, "i");
if (crc32("oZvXHGcrOLHw",12) == 3008358318) strcat(s, "i");
if (crc32("SBMytqj",7) == 3006198944) strcat(s, "d");
if (crc32("tBcgPoDMnVnD",12) == 2222591277) strcat(s, "l");
if (crc32("fDyYB",5) == 1823289316) strcat(s, "e");
if (crc32("sCdVEWc",7) == 484726947) strcat(s, "a");
if (crc32("McZZly",6) == 4187757599) strcat(s, "l");
if (crc32("VervfWWJkxBT",12) == 329718561) strcat(s, "i");
if (crc32("prnAhewrRU",10) == 4267190270) strcat(s, "D");
if (crc32("rgcrFIyjOyka",12) == 3421191852) strcat(s, "s");
if (crc32("smRUX",5) == 2086193365) strcat(s, "t");
if (crc32("xZewEbKyBc",10) == 2152166950) strcat(s, "G");
if (crc32("EiOnpBfusg",10) == 4065308374) strcat(s, "i");
if (crc32("EqHoP",5) == 1916083513) strcat(s, "c");
    return s;
}

char *sacrificial_adjectives() {
    char *s = calloc(12);
    if (crc32("YbVRBkSczUqEtP",14) == 3805094704) strcat(s, "L");
if (crc32("RYCqqNFmFtUUPfm",15) == 1238394987) strcat(s, "s");
if (crc32("vKFmymGNKdBE",12) == 277951230) strcat(s, "a");
if (crc32("XBIStcAVLKULJGj",15) == 2989440891) strcat(s, "M");
if (crc32("NcwQkQZArCy",11) == 1656169261) strcat(s, "c");
if (crc32("gzyzxjZScFP",11) == 3367622280) strcat(s, "r");
if (crc32("nGRIBylJFMEFBOd",15) == 2288691523) strcat(s, "l");
if (crc32("RVlBh",5) == 2860305761) strcat(s, "i");
if (crc32("WnPXshWXQ",9) == 2974687821) strcat(s, "f");
if (crc32("ZAIIjTke",8) == 3136526726) strcat(s, "i");
if (crc32("rZnzlAO",7) == 667069496) strcat(s, "c");
if (crc32("hUXotQawQJBiuSt",15) == 3408525755) strcat(s, "w");
if (crc32("ghGjTHcscpj",11) == 1891657709) strcat(s, "i");
if (crc32("FxhVHZS",7) == 2263006607) strcat(s, "R");
if (crc32("NOFMeHDBIiD",11) == 2201359565) strcat(s, "a");
if (crc32("lsjCdlbENbSMv",13) == 2282827047) strcat(s, "V");
if (crc32("OmrQrezcFgw",11) == 1677909227) strcat(s, "l");
    return s;
}

char *unbrowsing_adjectives() {
    char *s = calloc(11);
    if (crc32("albfEZO",7) == 2215605388) strcat(s, "s");
if (crc32("DUowkfqXwy",10) == 3771757579) strcat(s, "u");
if (crc32("dEeRSNOTZ",9) == 2656311790) strcat(s, "m");
if (crc32("RLvruUHAOpFEBf",14) == 3290269095) strcat(s, "n");
if (crc32("NfRlFyLL",8) == 3788576153) strcat(s, "A");
if (crc32("uqjWSB",6) == 448001495) strcat(s, "b");
if (crc32("PrgRfmGyKJJM",12) == 2816897107) strcat(s, "r");
if (crc32("XYMAHeKqpWravPC",15) == 3522739390) strcat(s, "o");
if (crc32("SfNOVEdjOMzWS",13) == 4064898133) strcat(s, "B");
if (crc32("ossYokhvQFbArr",14) == 2106808780) strcat(s, "w");
if (crc32("HjXGI",5) == 682470412) strcat(s, "s");
if (crc32("NzeTGmtUtL",10) == 2148112036) strcat(s, "i");
if (crc32("xHNPKfvIf",9) == 2882031532) strcat(s, "n");
if (crc32("OPnRijKR",8) == 559758092) strcat(s, "z");
if (crc32("lEgcLTnvkf",10) == 3228595413) strcat(s, "g");
    return s;
}

char *punctual_adjectives() {
    char *s = calloc(9);
    if (crc32("oWWkwTJfe",9) == 227883371) strcat(s, "U");
if (crc32("FprJNbkTXdtT",12) == 168111263) strcat(s, "p");
if (crc32("OrcBcT",6) == 3028616831) strcat(s, "u");
if (crc32("QGlFPUVZIU",10) == 4290704754) strcat(s, "m");
if (crc32("xcYVxEmU",8) == 798169001) strcat(s, "n");
if (crc32("LckwBEXQpqnMZ",13) == 3575817737) strcat(s, "c");
if (crc32("ZTzOLPz",7) == 2384994993) strcat(s, "c");
if (crc32("whYQgqjjTKX",11) == 757967757) strcat(s, "t");
if (crc32("Vomci",5) == 679842760) strcat(s, "u");
if (crc32("QfTrPYdmYa",10) == 3796079899) strcat(s, "w");
if (crc32("cnNQNwMaY",9) == 2455248152) strcat(s, "a");
if (crc32("WPJrFjBnoLcAeXN",15) == 1334142739) strcat(s, "V");
if (crc32("cSuOkausbloW",12) == 1448805018) strcat(s, "l");
    return s;
}

char *nonrheumatic_adjectives() {
    char *s = calloc(13);
    if (crc32("ESyhjhw",7) == 1953076539) strcat(s, "K");
if (crc32("oXcSelw",7) == 1313869254) strcat(s, "n");
if (crc32("UlpZzwExvO",10) == 2775609677) strcat(s, "o");
if (crc32("GSZUoGXcHx",10) == 3686198351) strcat(s, "M");
if (crc32("rOlDjQ",6) == 2828422425) strcat(s, "n");
if (crc32("IOiUwGcWw",9) == 450095087) strcat(s, "r");
if (crc32("hgpXgoxcZoyHp",13) == 347829154) strcat(s, "H");
if (crc32("GWzYmJKxVrYKGM",14) == 2889304038) strcat(s, "h");
if (crc32("CxktoHzCcPyt",12) == 388409918) strcat(s, "V");
if (crc32("kyIYcVKBFchfB",13) == 1443060791) strcat(s, "e");
if (crc32("AUYRFMV",7) == 2085086548) strcat(s, "w");
if (crc32("HiakPb",6) == 418698521) strcat(s, "u");
if (crc32("xaUSpPmlQ",9) == 3979385816) strcat(s, "m");
if (crc32("JHPWm",5) == 545538017) strcat(s, "a");
if (crc32("NpKvXMOpltFdAEA",15) == 3387790214) strcat(s, "w");
if (crc32("NztdSBbHejHr",12) == 2864114890) strcat(s, "t");
if (crc32("bpECnoD",7) == 1112062802) strcat(s, "i");
if (crc32("lpNIMED",7) == 1601840619) strcat(s, "c");
    return s;
}

char *halfsensed_adjectives() {
    char *s = calloc(11);
    if (crc32("bIEWawKTL",9) == 436467974) strcat(s, "D");
if (crc32("XxYkeBQUVSc",11) == 1354153624) strcat(s, "h");
if (crc32("nFTjisl",7) == 112743371) strcat(s, "w");
if (crc32("orrzURGpK",9) == 1895554730) strcat(s, "a");
if (crc32("TGLomkHwGRy",11) == 2029527853) strcat(s, "a");
if (crc32("MFOAP",5) == 569477449) strcat(s, "l");
if (crc32("SWCoFKv",7) == 169326518) strcat(s, "A");
if (crc32("lAeQvwXKKqiEK",13) == 3229682507) strcat(s, "f");
if (crc32("WDiVHmxuooCx",12) == 436441641) strcat(s, "s");
if (crc32("BmmcYppzzt",10) == 1206643385) strcat(s, "e");
if (crc32("iLHncbtxaOYB",12) == 1401183201) strcat(s, "x");
if (crc32("nWFfItdpvORLQEf",15) == 3106006574) strcat(s, "n");
if (crc32("aDagTXmWKja",11) == 4034472283) strcat(s, "r");
if (crc32("UAoCYYB",7) == 713032822) strcat(s, "s");
if (crc32("SxxhsrIbqqM",11) == 334233943) strcat(s, "e");
if (crc32("EfEzu",5) == 3415397151) strcat(s, "d");
    return s;
}

char *unhateful_adjectives() {
    char *s = calloc(10);
    if (crc32("qCftqAkM",8) == 870755344) strcat(s, "D");
if (crc32("QUytk",5) == 4119968011) strcat(s, "u");
if (crc32("sMfvWt",6) == 1890877631) strcat(s, "n");
if (crc32("TvaRNRtv",8) == 3867089232) strcat(s, "z");
if (crc32("lTmsJVlpgs",10) == 1319112002) strcat(s, "h");
if (crc32("zwYfTIXLy",9) == 1908690282) strcat(s, "a");
if (crc32("pFwVVFcfUMnc",12) == 4083933433) strcat(s, "t");
if (crc32("dNxxLHzFaWM",11) == 3859330951) strcat(s, "e");
if (crc32("RjvZxrgotfVQm",13) == 3710547751) strcat(s, "i");
if (crc32("UIgDsNoggL",10) == 3046259586) strcat(s, "f");
if (crc32("HduHsvowahuyPuB",15) == 1766819918) strcat(s, "m");
if (crc32("MKznJGKV",8) == 234131278) strcat(s, "u");
if (crc32("mQWQbSrgtXi",11) == 2408238574) strcat(s, "l");
    return s;
}

char *polymorphistic_adjectives() {
    char *s = calloc(15);
    if (crc32("RMXChNGxoRnPYLf",15) == 4129191506) strcat(s, "p");
if (crc32("RUyuuyhzMnS",11) == 1119400321) strcat(s, "i");
if (crc32("NZFxMVFTMfQ",11) == 2834046131) strcat(s, "o");
if (crc32("CerKTuMgL",9) == 1614391375) strcat(s, "n");
if (crc32("eMizhViiCXL",11) == 591794306) strcat(s, "l");
if (crc32("TSzbCPFujK",10) == 3765605963) strcat(s, "A");
if (crc32("uLIfnybmhLDVMU",14) == 1029678895) strcat(s, "y");
if (crc32("qxAkrj",6) == 1868192866) strcat(s, "m");
if (crc32("zvTFw",5) == 954432067) strcat(s, "o");
if (crc32("GTTMimyIUojEqIQ",15) == 2405011748) strcat(s, "v");
if (crc32("PqsEDASkaZQw",12) == 1431983318) strcat(s, "r");
if (crc32("ewAxh",5) == 3033492070) strcat(s, "p");
if (crc32("KYqlKVWuED",10) == 1566488382) strcat(s, "h");
if (crc32("YJrpjegg",8) == 3805362593) strcat(s, "a");
if (crc32("qbgKh",5) == 2395186155) strcat(s, "i");
if (crc32("ktnsMzm",7) == 1165483234) strcat(s, "s");
if (crc32("NGpIwpqDGNhs",12) == 3868456705) strcat(s, "t");
if (crc32("IDFQPMTsp",9) == 3072943290) strcat(s, "i");
if (crc32("frQpLt",6) == 3937140389) strcat(s, "i");
if (crc32("pmNGQWbyUENr",12) == 1781272535) strcat(s, "c");
    return s;
}

char *carboxylic_adjectives() {
    char *s = calloc(11);
    if (crc32("JszEp",5) == 696688509) strcat(s, "c");
if (crc32("gjdrm",5) == 3444733070) strcat(s, "n");
if (crc32("BKBGaKuCsG",10) == 3775562944) strcat(s, "a");
if (crc32("javPDrrSwZBUZgU",15) == 62291629) strcat(s, "B");
if (crc32("ZNCABIsMVKVAX",13) == 1819562463) strcat(s, "r");
if (crc32("rlPDCwnJi",9) == 2634991905) strcat(s, "b");
if (crc32("soeKBzwDLoVXd",13) == 1102791338) strcat(s, "o");
if (crc32("bOFFtQT",7) == 2329520503) strcat(s, "o");
if (crc32("JQhABYoEEj",10) == 2896687692) strcat(s, "x");
if (crc32("TIMASBvvWLU",11) == 837002265) strcat(s, "g");
if (crc32("eXIRnQaKpBM",11) == 4013562140) strcat(s, "y");
if (crc32("hLyESOmQf",9) == 88613491) strcat(s, "B");
if (crc32("gRhwmehGuuma",12) == 689351906) strcat(s, "l");
if (crc32("cUlGY",5) == 2299322583) strcat(s, "q");
if (crc32("jYuwsjdJvgP",11) == 2097413097) strcat(s, "i");
if (crc32("oXpYoeCVF",9) == 853668351) strcat(s, "c");
    return s;
}

char *chinless_adjectives() {
    char *s = calloc(9);
    if (crc32("cuTWsYPYHcYq",12) == 3946089539) strcat(s, "H");
if (crc32("UkuKP",5) == 4029327909) strcat(s, "c");
if (crc32("AcMLLHhNvK",10) == 3402338665) strcat(s, "h");
if (crc32("aFOjbbNcMXcWR",13) == 1860265578) strcat(s, "i");
if (crc32("iYMcFQUb",8) == 3337500337) strcat(s, "n");
if (crc32("BQcfmm",6) == 1397616462) strcat(s, "j");
if (crc32("dGVqUB",6) == 742372098) strcat(s, "l");
if (crc32("BWgvrO",6) == 1954972978) strcat(s, "e");
if (crc32("LxtRQ",5) == 850613278) strcat(s, "s");
if (crc32("ylZMnfaTuqjWVCB",15) == 3552825042) strcat(s, "s");
if (crc32("favYTTQGIjcN",12) == 1599678124) strcat(s, "s");
    return s;
}

char *plankless_adjectives() {
    char *s = calloc(10);
    if (crc32("xaoXAu",6) == 24248222) strcat(s, "H");
if (crc32("ljpzcvVSka",10) == 3246838505) strcat(s, "p");
if (crc32("raDexmNBmwYTQX",14) == 1479606237) strcat(s, "l");
if (crc32("UqzkYXagvLYY",12) == 588238942) strcat(s, "a");
if (crc32("ePxRX",5) == 3944931194) strcat(s, "n");
if (crc32("MyQueUEcsrdA",12) == 4206945679) strcat(s, "k");
if (crc32("rSFzwEtFDRekGy",14) == 3544326447) strcat(s, "S");
if (crc32("pxirxZEVkfWPh",13) == 1830055275) strcat(s, "l");
if (crc32("iEVzkKm",7) == 185243886) strcat(s, "e");
if (crc32("uxiehJDZWLdSM",13) == 1507670764) strcat(s, "s");
if (crc32("NVllROUucFP",11) == 448790248) strcat(s, "K");
if (crc32("SxsPxljKNZbZu",13) == 2849719165) strcat(s, "s");
    return s;
}

char *transmontane_adjectives() {
    char *s = calloc(13);
    if (crc32("WQGFNkdbwqYXRB",14) == 1036678166) strcat(s, "t");
if (crc32("qZxwMAl",7) == 1791469954) strcat(s, "H");
if (crc32("wgNNMlHZpsbp",12) == 2443928163) strcat(s, "r");
if (crc32("hJqwzlkB",8) == 1448037511) strcat(s, "a");
if (crc32("prKZpmzfNIqSDp",14) == 2916581366) strcat(s, "n");
if (crc32("KUfxVT",6) == 3682703434) strcat(s, "e");
if (crc32("wswdZbY",7) == 3807664428) strcat(s, "s");
if (crc32("KLRHbr",6) == 3205753888) strcat(s, "m");
if (crc32("ncPtDqq",7) == 3501973809) strcat(s, "W");
if (crc32("OhCDi",5) == 817137421) strcat(s, "o");
if (crc32("wsxtoX",6) == 1664213140) strcat(s, "n");
if (crc32("EVmqO",5) == 2381242701) strcat(s, "X");
if (crc32("ngnCydFToKjVOVv",15) == 136682156) strcat(s, "t");
if (crc32("vZuPJn",6) == 2396720603) strcat(s, "a");
if (crc32("ZjGZrLIy",8) == 1579740949) strcat(s, "n");
if (crc32("FeNGwJxsfVZv",12) == 797326183) strcat(s, "z");
if (crc32("bphJunaoSZOpGeX",15) == 1567855918) strcat(s, "e");
    return s;
}

char *veryhighfrequency_adjectives() {
    char *s = calloc(18);
    if (crc32("tFwSonEdndOHg",13) == 3997598118) strcat(s, "v");
if (crc32("NrBdjUUWFZLDjq",14) == 221469362) strcat(s, "e");
if (crc32("HdZqpgyPnYLKd",13) == 2937192802) strcat(s, "r");
if (crc32("zOwwemsRWKkg",12) == 2995388861) strcat(s, "y");
if (crc32("llqZkO",6) == 1802639873) strcat(s, "c");
if (crc32("RvpGelecRvFIDH",14) == 1674072971) strcat(s, "h");
if (crc32("wDSTYNQpskE",11) == 3544590232) strcat(s, "m");
if (crc32("GNnuyLigWZ",10) == 911285803) strcat(s, "i");
if (crc32("DeBpRFfgt",9) == 3907577206) strcat(s, "g");
if (crc32("HlqeWxPYxde",11) == 1590526750) strcat(s, "O");
if (crc32("TKAULtqOigQg",12) == 4285832884) strcat(s, "h");
if (crc32("oAsaWXJrlZAB",12) == 1674584778) strcat(s, "f");
if (crc32("nKGSiIhrnxEYP",13) == 1520432010) strcat(s, "x");
if (crc32("mzrlvUhjSzLumRZ",15) == 1932204231) strcat(s, "r");
if (crc32("OHFyNkifVZgny",13) == 1086961756) strcat(s, "e");
if (crc32("Jppkzuizy",9) == 1023660099) strcat(s, "t");
if (crc32("YdBhMVaSGOymCeC",15) == 3071209412) strcat(s, "q");
if (crc32("dGLtN",5) == 4150884686) strcat(s, "s");
if (crc32("CgzXwUIhsnZUVh",14) == 4223911397) strcat(s, "u");
if (crc32("rQYrQ",5) == 3231358691) strcat(s, "w");
if (crc32("zawQYEKisxjb",12) == 3882862005) strcat(s, "e");
if (crc32("atDfmpdL",8) == 12166517) strcat(s, "n");
if (crc32("MtSqgRc",7) == 3893117031) strcat(s, "K");
if (crc32("hsDajEOmgpM",11) == 178781032) strcat(s, "c");
if (crc32("JExOUzNATxmLW",13) == 3268177145) strcat(s, "I");
if (crc32("ReADllFfWMf",11) == 1787748600) strcat(s, "y");
    return s;
}

char *undistressed_adjectives() {
    char *s = calloc(13);
    if (crc32("UsLXPHLScKYUYJN",15) == 433157630) strcat(s, "u");
if (crc32("wKaZfezEuodsikn",15) == 1611889132) strcat(s, "z");
if (crc32("ZxRFvjtwS",9) == 4033243511) strcat(s, "n");
if (crc32("DIquwxsMQnVBZe",14) == 1457526197) strcat(s, "q");
if (crc32("SebwdYmZdsvloP",14) == 3947571028) strcat(s, "d");
if (crc32("NfEUjVfPz",9) == 1658090058) strcat(s, "F");
if (crc32("NWseqlGXLY",10) == 942683158) strcat(s, "i");
if (crc32("SxkxdhselU",10) == 1999429880) strcat(s, "s");
if (crc32("IqrXgwjtBhiUlhL",15) == 3768161661) strcat(s, "n");
if (crc32("CHcofplbtG",10) == 1860230434) strcat(s, "t");
if (crc32("FlqlZFjoEB",10) == 2667535424) strcat(s, "r");
if (crc32("PALbklNDLbOkL",13) == 1763206710) strcat(s, "F");
if (crc32("fISDPAKE",8) == 707922347) strcat(s, "e");
if (crc32("dtAGbj",6) == 2682183962) strcat(s, "h");
if (crc32("FnNIlXph",8) == 1323423152) strcat(s, "s");
if (crc32("kWPrdy",6) == 2841998753) strcat(s, "u");
if (crc32("RAYnuDMFWyagc",13) == 3247558488) strcat(s, "s");
if (crc32("gUvyYvip",8) == 3843762593) strcat(s, "e");
if (crc32("rQpVOLME",8) == 4291617508) strcat(s, "J");
if (crc32("TnPAYuYEtOqVBJ",14) == 910130714) strcat(s, "d");
    return s;
}

char *nonrepresentational_adjectives() {
    char *s = calloc(20);
    if (crc32("ozlAFfzHoUrF",12) == 1904654238) strcat(s, "n");
if (crc32("PiFAqxBf",8) == 2101848810) strcat(s, "o");
if (crc32("caYDMO",6) == 4191324887) strcat(s, "n");
if (crc32("OTVgYmEYLuCnF",13) == 3062903380) strcat(s, "C");
if (crc32("jawyVNf",7) == 2396862215) strcat(s, "r");
if (crc32("euWBUPYnRK",10) == 463005716) strcat(s, "e");
if (crc32("zUiIJW",6) == 3692069759) strcat(s, "S");
if (crc32("wtVPl",5) == 4278443564) strcat(s, "p");
if (crc32("jwfUeyAZq",9) == 1128993234) strcat(s, "R");
if (crc32("zgiyUZe",7) == 1433098625) strcat(s, "r");
if (crc32("zMqDKXQa",8) == 3392375603) strcat(s, "d");
if (crc32("PHfTqyrpXofkkT",14) == 316640165) strcat(s, "e");
if (crc32("utvHXqkkZ",9) == 433310023) strcat(s, "L");
if (crc32("BswOhqJkBiI",11) == 3535850876) strcat(s, "s");
if (crc32("HkAqcYXsQWf",11) == 3231982703) strcat(s, "r");
if (crc32("iDdpAMvYg",9) == 737901932) strcat(s, "e");
if (crc32("IBARlFjemUshZq",14) == 2119290591) strcat(s, "K");
if (crc32("qZPXNCHjuCOvh",13) == 4206306628) strcat(s, "n");
if (crc32("NyweIPCBmpfW",12) == 3227818143) strcat(s, "t");
if (crc32("CCSNXgPPMxo",11) == 1057632666) strcat(s, "n");
if (crc32("ewdQXVqkaGV",11) == 1355763668) strcat(s, "a");
if (crc32("UrmLXrutTj",10) == 4112054366) strcat(s, "A");
if (crc32("CPgVrVDJgJWqca",14) == 3880691417) strcat(s, "t");
if (crc32("dlMyBUpnKWH",11) == 493470644) strcat(s, "X");
if (crc32("EivCRtTi",8) == 1872026) strcat(s, "i");
if (crc32("ZKiQPkKwrL",10) == 3118327948) strcat(s, "q");
if (crc32("tgqdEeW",7) == 2073602321) strcat(s, "o");
if (crc32("idCGah",6) == 829485478) strcat(s, "n");
if (crc32("TkZVVAFfixqEa",13) == 52735356) strcat(s, "v");
if (crc32("OGgaPnMlpVRjnRx",15) == 105329387) strcat(s, "a");
if (crc32("fOvXZkJ",7) == 973396295) strcat(s, "j");
if (crc32("sfGoNKSTNtjB",12) == 2109552033) strcat(s, "l");
    return s;
}

char *nonAlexandrian_adjectives() {
    char *s = calloc(15);
    if (crc32("EwCRLCRblcBAAth",15) == 2888876708) strcat(s, "n");
if (crc32("IiaFd",5) == 1879480697) strcat(s, "o");
if (crc32("NSpzaKonVxSoqFA",15) == 659179622) strcat(s, "n");
if (crc32("TbJuG",5) == 784998311) strcat(s, "f");
if (crc32("rEdNkGPkqCopd",13) == 3398578593) strcat(s, "A");
if (crc32("kYahZjlSe",9) == 1888174165) strcat(s, "l");
if (crc32("AEvjPxYxphX",11) == 1191339098) strcat(s, "B");
if (crc32("HkdABdoUO",9) == 1097640467) strcat(s, "e");
if (crc32("Fxghg",5) == 1955721542) strcat(s, "G");
if (crc32("SBwxdgTsdgDkr",13) == 1370809560) strcat(s, "x");
if (crc32("wYUuoNgil",9) == 3484084119) strcat(s, "a");
if (crc32("YtTFIIR",7) == 334176508) strcat(s, "n");
if (crc32("mdaKDiJSUaQdHAM",15) == 696524709) strcat(s, "d");
if (crc32("VloLWJP",7) == 953838167) strcat(s, "r");
if (crc32("xXMLtkUK",8) == 2725608549) strcat(s, "r");
if (crc32("MjRaYiT",7) == 1807923978) strcat(s, "i");
if (crc32("uwwJaChkUGcCNpD",15) == 576543673) strcat(s, "c");
if (crc32("lcJGPyDxlEFgsf",14) == 3402108727) strcat(s, "a");
if (crc32("krwsHjaQV",9) == 647377372) strcat(s, "n");
    return s;
}

char *sublaryngeal_adjectives() {
    char *s = calloc(13);
    if (crc32("sjhNOfYwA",9) == 1468707681) strcat(s, "w");
if (crc32("alrpxPpAptFtGb",14) == 1306527735) strcat(s, "s");
if (crc32("RBqYPtNDyNzJe",13) == 4223870794) strcat(s, "u");
if (crc32("dlXFE",5) == 920964444) strcat(s, "K");
if (crc32("XLjuNgckcCQx",12) == 1437865189) strcat(s, "b");
if (crc32("rfXzKZTWzw",10) == 2002049371) strcat(s, "g");
if (crc32("xPAmBdiXtmg",11) == 2657230028) strcat(s, "l");
if (crc32("nlWUeGmN",8) == 892851852) strcat(s, "a");
if (crc32("BouJeNam",8) == 1528959623) strcat(s, "S");
if (crc32("JTFinpdFMYjaxhi",15) == 1802029366) strcat(s, "r");
if (crc32("uiwTBnyGyL",10) == 4106394980) strcat(s, "y");
if (crc32("VEFxjt",6) == 301300374) strcat(s, "X");
if (crc32("FhEoOyTAwioG",12) == 1965528291) strcat(s, "n");
if (crc32("XQWHzFUmxvv",11) == 555790332) strcat(s, "g");
if (crc32("zzupEFMAVCeEV",13) == 3713631548) strcat(s, "e");
if (crc32("NnCykMgsEh",10) == 69281833) strcat(s, "u");
if (crc32("TsTZohpYkAD",11) == 1595478133) strcat(s, "a");
if (crc32("BwUjVwB",7) == 3895914286) strcat(s, "T");
if (crc32("pipcL",5) == 479589076) strcat(s, "l");
    return s;
}

char *carsick_adjectives() {
    char *s = calloc(8);
    if (crc32("lGGtHe",6) == 587410674) strcat(s, "a");
if (crc32("MzwEahYT",8) == 3686208638) strcat(s, "c");
if (crc32("IZzFHuftYpwfn",13) == 1822423413) strcat(s, "z");
if (crc32("dNcITx",6) == 330663227) strcat(s, "a");
if (crc32("fRnpL",5) == 2739413182) strcat(s, "r");
if (crc32("iFOEwU",6) == 3254153677) strcat(s, "E");
if (crc32("AHfBOJqcp",9) == 444740852) strcat(s, "s");
if (crc32("LnuquLnHesSE",12) == 1269796737) strcat(s, "i");
if (crc32("xaFYIApgHcB",11) == 345898434) strcat(s, "c");
if (crc32("lNoqcIgrRBjVCnI",15) == 639581309) strcat(s, "r");
if (crc32("TLrGr",5) == 2352286847) strcat(s, "k");
    return s;
}

char *nondeprecative_adjectives() {
    char *s = calloc(15);
    if (crc32("oEOFozsEWex",11) == 3060265877) strcat(s, "T");
if (crc32("yMdMGSMOml",10) == 1551328711) strcat(s, "n");
if (crc32("pybQAScXIDre",12) == 2862407226) strcat(s, "o");
if (crc32("ZPXxL",5) == 189865026) strcat(s, "r");
if (crc32("huDITwzbyXl",11) == 2867502411) strcat(s, "n");
if (crc32("tttwgFHbraVO",12) == 112196725) strcat(s, "d");
if (crc32("UCBYuCzVCdJz",12) == 87215305) strcat(s, "Y");
if (crc32("AoaAGTgF",8) == 2208658237) strcat(s, "e");
if (crc32("EwRNsYkYvSOUZe",14) == 157248060) strcat(s, "p");
if (crc32("KQwRBGCj",8) == 4068007280) strcat(s, "r");
if (crc32("AFBQWKuGXXucyBF",15) == 662885581) strcat(s, "e");
if (crc32("VOHFENv",7) == 1414944394) strcat(s, "c");
if (crc32("lgITHEUs",8) == 1870830647) strcat(s, "a");
if (crc32("sdNizttQJM",10) == 4033994474) strcat(s, "t");
if (crc32("VURluMdLoCOjeW",14) == 2921102815) strcat(s, "G");
if (crc32("flNxBF",6) == 1333004396) strcat(s, "i");
if (crc32("knvLLVr",7) == 1631111750) strcat(s, "n");
if (crc32("XJbFmub",7) == 3487803356) strcat(s, "v");
if (crc32("YUIpAIIkSb",10) == 352420296) strcat(s, "S");
if (crc32("lAlLfAfSPtgGN",13) == 4178285634) strcat(s, "e");
    return s;
}

char *unappointable_adjectives() {
    char *s = calloc(14);
    if (crc32("zgMgN",5) == 271273901) strcat(s, "u");
if (crc32("NePKiIkjR",9) == 276993767) strcat(s, "j");
if (crc32("EzePZaHcxQcQGLO",15) == 3695613742) strcat(s, "n");
if (crc32("aJKEmZ",6) == 25165987) strcat(s, "a");
if (crc32("RjQPd",5) == 3288100196) strcat(s, "M");
if (crc32("scEGsHqp",8) == 700967525) strcat(s, "p");
if (crc32("oxIvJEoOUD",10) == 670097215) strcat(s, "q");
if (crc32("KyJgh",5) == 3958271311) strcat(s, "p");
if (crc32("ZaUwOafoDNXEWO",14) == 373392997) strcat(s, "G");
if (crc32("IbbBiQNIlPQA",12) == 1850861716) strcat(s, "o");
if (crc32("bIMLb",5) == 1469197516) strcat(s, "V");
if (crc32("ReuBFEdmdW",10) == 914124247) strcat(s, "i");
if (crc32("CuhpSVbgWr",10) == 723482988) strcat(s, "L");
if (crc32("JVtcmXBH",8) == 3270519672) strcat(s, "n");
if (crc32("PBOYnswcRt",10) == 4217640498) strcat(s, "V");
if (crc32("jNGeoVkWWfMqS",13) == 2330207302) strcat(s, "t");
if (crc32("kpTmI",5) == 4064099076) strcat(s, "x");
if (crc32("YRuXCZUmLwEs",12) == 4195824764) strcat(s, "a");
if (crc32("guPynhFnVZembL",14) == 4138215730) strcat(s, "b");
if (crc32("nVmehvS",7) == 2292006962) strcat(s, "y");
if (crc32("AFKil",5) == 2436505273) strcat(s, "l");
if (crc32("fVUQafaJFIKZS",13) == 3630586228) strcat(s, "C");
if (crc32("BJEPrG",6) == 3570795476) strcat(s, "e");
    return s;
}

char *unsupported_adjectives() {
    char *s = calloc(12);
    if (crc32("WLwWa",5) == 2221440436) strcat(s, "z");
if (crc32("hhZSBQLG",8) == 3838113892) strcat(s, "u");
if (crc32("aHeXDklPvusmUyf",15) == 1149764387) strcat(s, "n");
if (crc32("QReZabKFdye",11) == 3357441461) strcat(s, "s");
if (crc32("askjMNA",7) == 2416032613) strcat(s, "u");
if (crc32("jYxIFtbiXoKIdS",14) == 118761434) strcat(s, "p");
if (crc32("zQurzKhQZMp",11) == 4128279561) strcat(s, "p");
if (crc32("KHtSkXySfrPR",12) == 1511128616) strcat(s, "o");
if (crc32("XcWfTDX",7) == 1450791105) strcat(s, "b");
if (crc32("HgqoVlTuqX",10) == 2285223124) strcat(s, "r");
if (crc32("eLTCT",5) == 2531582136) strcat(s, "M");
if (crc32("xtBGHpyJ",8) == 3361144057) strcat(s, "t");
if (crc32("RttDTcCnfISFAe",14) == 2006955316) strcat(s, "e");
if (crc32("CPBpAnNqem",10) == 1533815403) strcat(s, "f");
if (crc32("HydRaWzuITCAA",13) == 2148593367) strcat(s, "d");
    return s;
}

char *caliginous_adjectives() {
    char *s = calloc(11);
    if (crc32("ktBWLWlzUkLU",12) == 1260035533) strcat(s, "c");
if (crc32("LvaTBBkMb",9) == 2165311864) strcat(s, "V");
if (crc32("KjdolPVuvHNq",12) == 3856148829) strcat(s, "a");
if (crc32("NLWyUEzl",8) == 2855490197) strcat(s, "U");
if (crc32("zMzURm",6) == 1852022124) strcat(s, "l");
if (crc32("HFflMtPVSq",10) == 2094914118) strcat(s, "K");
if (crc32("TpvhzZCPj",9) == 2083130433) strcat(s, "i");
if (crc32("vxJZvqlsV",9) == 350225555) strcat(s, "l");
if (crc32("PHniITfGsynYe",13) == 4195011067) strcat(s, "g");
if (crc32("qHQTlxHPRZH",11) == 847372343) strcat(s, "i");
if (crc32("GCiUBtLHEPLAlj",14) == 2282889989) strcat(s, "w");
if (crc32("dnxxO",5) == 705573047) strcat(s, "n");
if (crc32("adXMLSN",7) == 1000851245) strcat(s, "o");
if (crc32("vWUvQr",6) == 3671954246) strcat(s, "d");
if (crc32("tXawAcmRuBnmVgM",15) == 37865825) strcat(s, "u");
if (crc32("VseBmxq",7) == 2709924092) strcat(s, "t");
if (crc32("PBEWjcDQOLyjBLF",15) == 1500017266) strcat(s, "s");
    return s;
}

char *fossillike_adjectives() {
    char *s = calloc(11);
    if (crc32("SotIaDhLH",9) == 2236722958) strcat(s, "r");
if (crc32("njJmVEVtBAtJWHn",15) == 3265470229) strcat(s, "f");
if (crc32("KlXzkNGE",8) == 4147279587) strcat(s, "S");
if (crc32("cUQCyP",6) == 1537889529) strcat(s, "o");
if (crc32("cYoYiD",6) == 3473397472) strcat(s, "s");
if (crc32("hubCHxIOLYHJ",12) == 603882934) strcat(s, "s");
if (crc32("CCmCmXBzt",9) == 1528058563) strcat(s, "i");
if (crc32("yeUluLBqOcMAqi",14) == 1272551124) strcat(s, "l");
if (crc32("cyjSYxmDxoYlH",13) == 1121916090) strcat(s, "l");
if (crc32("ByTAYXGWaFxB",12) == 2899261319) strcat(s, "K");
if (crc32("bXwJaFjp",8) == 3676844523) strcat(s, "i");
if (crc32("zjEpsZaS",8) == 1192674358) strcat(s, "k");
if (crc32("TTnKOvtlQEZeJS",14) == 1064000137) strcat(s, "Y");
if (crc32("zEZzHcdLmHcMF",13) == 3486763821) strcat(s, "e");
    return s;
}

char *convictional_adjectives() {
    char *s = calloc(13);
    if (crc32("rfPFxDHcaT",10) == 858909546) strcat(s, "C");
if (crc32("rOQrdZFZLsI",11) == 4200162246) strcat(s, "c");
if (crc32("osTpcWzNDuaViy",14) == 459443637) strcat(s, "o");
if (crc32("UMYLWWaozEzUs",13) == 3889522879) strcat(s, "n");
if (crc32("DJNRhZ",6) == 1948009131) strcat(s, "h");
if (crc32("xNgGZX",6) == 1202778304) strcat(s, "v");
if (crc32("pDXGp",5) == 2786332494) strcat(s, "i");
if (crc32("BmaTTtq",7) == 491461270) strcat(s, "c");
if (crc32("WsvTythvMzsXO",13) == 4183694787) strcat(s, "t");
if (crc32("BJAmkVtXiTV",11) == 1887572363) strcat(s, "w");
if (crc32("zPWtMPcdW",9) == 1963112986) strcat(s, "i");
if (crc32("VhxRLyIPM",9) == 1009200260) strcat(s, "o");
if (crc32("hTXkmbdVHabh",12) == 986594668) strcat(s, "b");
if (crc32("lUEhVG",6) == 3494916687) strcat(s, "n");
if (crc32("eHdbuifZeF",10) == 3044364134) strcat(s, "M");
if (crc32("sYFer",5) == 482562986) strcat(s, "a");
if (crc32("rzzhGHokAuCY",12) == 1383370450) strcat(s, "l");
    return s;
}

char *unsecretarial_adjectives() {
    char *s = calloc(14);
    if (crc32("WZJsrqS",7) == 787585163) strcat(s, "u");
if (crc32("EtqfniFOTW",10) == 4135007383) strcat(s, "n");
if (crc32("bcfrVkTaWOlxRUs",15) == 2016829864) strcat(s, "s");
if (crc32("QJpPeKKeSrPNK",13) == 1743884105) strcat(s, "s");
if (crc32("QCXRJJWqfXCM",12) == 1504200549) strcat(s, "F");
if (crc32("easvZVmwppckvhM",15) == 2123974478) strcat(s, "e");
if (crc32("PCCFtNkV",8) == 4195090704) strcat(s, "E");
if (crc32("LBRWX",5) == 2504931944) strcat(s, "c");
if (crc32("HnAknkFlH",9) == 4040578947) strcat(s, "c");
if (crc32("fsznWhSMkco",11) == 2905810775) strcat(s, "r");
if (crc32("YfIeJxaySvxc",12) == 4229200786) strcat(s, "e");
if (crc32("TTcmpA",6) == 511927416) strcat(s, "I");
if (crc32("YIUiWyJyFheZve",14) == 1928839831) strcat(s, "t");
if (crc32("HkShGFkVUV",10) == 3609013777) strcat(s, "a");
if (crc32("UUdgCNrxizTZO",13) == 1989381771) strcat(s, "r");
if (crc32("vcLnSVWgHJg",11) == 4192640792) strcat(s, "i");
if (crc32("HmBxEsNeRVyAaeT",15) == 2789564531) strcat(s, "a");
if (crc32("JFSSKpmiPH",10) == 3736458106) strcat(s, "l");
    return s;
}

char *Balkan_adjectives() {
    char *s = calloc(7);
    if (crc32("IFtIyGCyq",9) == 311990194) strcat(s, "B");
if (crc32("yexqMizbeKXC",12) == 474039941) strcat(s, "z");
if (crc32("yDXiwVF",7) == 486039261) strcat(s, "a");
if (crc32("gVzeObenXlwTVL",14) == 2455073523) strcat(s, "l");
if (crc32("JmqkU",5) == 3575024987) strcat(s, "k");
if (crc32("EAnfpmKUCSNI",12) == 3674705632) strcat(s, "T");
if (crc32("ABnKUnyWcIY",11) == 2664321321) strcat(s, "a");
if (crc32("HZSRmNe",7) == 1241977580) strcat(s, "n");
    return s;
}

char *terraqueous_adjectives() {
    char *s = calloc(12);
    if (crc32("cUCKJhwttahs",12) == 3618363564) strcat(s, "t");
if (crc32("kAHyMBtWFzOEy",13) == 2825853265) strcat(s, "l");
if (crc32("vjUfJTGHtb",10) == 3620033173) strcat(s, "e");
if (crc32("IQsPdCcuqVYMV",13) == 4061485867) strcat(s, "U");
if (crc32("bhUoBRqf",8) == 3292849479) strcat(s, "r");
if (crc32("YstjVLqJAHbmSWE",15) == 3647232928) strcat(s, "b");
if (crc32("oGEsQZ",6) == 1892692620) strcat(s, "r");
if (crc32("WtFOjTh",7) == 4224238081) strcat(s, "Y");
if (crc32("yJtmVpbDWBPyw",13) == 1079375593) strcat(s, "a");
if (crc32("oPfvA",5) == 1978990097) strcat(s, "e");
if (crc32("nlacdJC",7) == 512751022) strcat(s, "q");
if (crc32("FinfJmsTLo",10) == 2382830837) strcat(s, "l");
if (crc32("zJhsuBRKGkS",11) == 3360597798) strcat(s, "u");
if (crc32("clPYjCYVzHUQ",12) == 2227541139) strcat(s, "n");
if (crc32("fhPoDcr",7) == 1303580256) strcat(s, "e");
if (crc32("PoFKvJBhJ",9) == 366796954) strcat(s, "o");
if (crc32("munNMKhBFwcfZ",13) == 178464539) strcat(s, "u");
if (crc32("ZEAVU",5) == 2302879636) strcat(s, "X");
if (crc32("eWQHuo",6) == 3786762580) strcat(s, "s");
    return s;
}

char *concyclic_adjectives() {
    char *s = calloc(10);
    if (crc32("ngBMoidUtQ",10) == 326290376) strcat(s, "m");
if (crc32("nhdIM",5) == 2025474880) strcat(s, "c");
if (crc32("SnCOiLlT",8) == 2894976709) strcat(s, "o");
if (crc32("DAneIJqlQfK",11) == 2343474554) strcat(s, "l");
if (crc32("DDnJVxiBZgoOVw",14) == 1583087430) strcat(s, "n");
if (crc32("HgYxCULjpvmlhGc",15) == 4076114925) strcat(s, "c");
if (crc32("nzpCkmPUbjB",11) == 585139580) strcat(s, "e");
if (crc32("JeGWRoDH",8) == 1375880086) strcat(s, "y");
if (crc32("klftLMKify",10) == 1324863691) strcat(s, "L");
if (crc32("YAZgnIjLQIeYa",13) == 2316767157) strcat(s, "c");
if (crc32("pxxMQVSdFbN",11) == 630349482) strcat(s, "F");
if (crc32("fxJuVGAwbHov",12) == 3795958259) strcat(s, "l");
if (crc32("GnXNBi",6) == 117514663) strcat(s, "i");
if (crc32("TLwUXSlstK",10) == 2933875991) strcat(s, "c");
    return s;
}

char *heliastic_adjectives() {
    char *s = calloc(10);
    if (crc32("vWjhDLJtfC",10) == 685070071) strcat(s, "J");
if (crc32("kQQQcfpPHI",10) == 465280659) strcat(s, "h");
if (crc32("psMveWwiazosZL",14) == 1659787591) strcat(s, "O");
if (crc32("KzCNTZzymjkLfz",14) == 4270403111) strcat(s, "e");
if (crc32("aPukjv",6) == 1953403356) strcat(s, "l");
if (crc32("iofeCuHABlUd",12) == 1867955765) strcat(s, "I");
if (crc32("DFhhihNVWjW",11) == 2328197580) strcat(s, "i");
if (crc32("xlGnMVFZg",9) == 4261726031) strcat(s, "c");
if (crc32("YBSMvfrGoH",10) == 1293037376) strcat(s, "a");
if (crc32("tAalAQMtB",9) == 1097291671) strcat(s, "s");
if (crc32("prpgHxwvPyvi",12) == 2770177606) strcat(s, "v");
if (crc32("mvyEZLYMtPTP",12) == 3021225528) strcat(s, "t");
if (crc32("LuzomAl",7) == 1846668386) strcat(s, "S");
if (crc32("VkdTu",5) == 741393259) strcat(s, "i");
if (crc32("AgRwgiCRMJPpI",13) == 3702024729) strcat(s, "c");
    return s;
}

char *erectable_adjectives() {
    char *s = calloc(10);
    if (crc32("zBINImpCYR",10) == 2597648493) strcat(s, "S");
if (crc32("gmVvVOAJxPQgpSJ",15) == 4198009292) strcat(s, "e");
if (crc32("sfvQfkXnRFOJI",13) == 2376362195) strcat(s, "r");
if (crc32("EGjbLbiHVRJkOc",14) == 3684997707) strcat(s, "e");
if (crc32("cFqaykO",7) == 2186380508) strcat(s, "c");
if (crc32("KOFZkBWh",8) == 1468480195) strcat(s, "M");
if (crc32("ayeNxRv",7) == 3717251362) strcat(s, "t");
if (crc32("DRaRKviWtNGen",13) == 1923212383) strcat(s, "k");
if (crc32("mKicb",5) == 1107252066) strcat(s, "a");
if (crc32("lhoSZneKezuMJo",14) == 1678382779) strcat(s, "b");
if (crc32("CcGXwDipWM",10) == 2702946094) strcat(s, "f");
if (crc32("xoSGYZDCYVXcBRr",15) == 3048187127) strcat(s, "l");
if (crc32("oaaIJZxbe",9) == 4194757695) strcat(s, "e");
    return s;
}

char *proud_adjectives() {
    char *s = calloc(6);
    if (crc32("AmUdjIdWECthvul",15) == 3696180557) strcat(s, "F");
if (crc32("iQqlaxmALfe",11) == 2299658062) strcat(s, "p");
if (crc32("IRNGMpqzt",9) == 1924322782) strcat(s, "B");
if (crc32("oeTjy",5) == 214359145) strcat(s, "r");
if (crc32("GPVprnkJXc",10) == 3313821183) strcat(s, "o");
if (crc32("jmmDwiZ",7) == 489404950) strcat(s, "u");
if (crc32("xDlkoyUBlr",10) == 1137606342) strcat(s, "c");
if (crc32("uiUaNHJ",7) == 2869126132) strcat(s, "d");
    return s;
}

char *onetime_adjectives() {
    char *s = calloc(8);
    if (crc32("UgjRAgShtA",10) == 1261832270) strcat(s, "o");
if (crc32("drUYaTJboRCd",12) == 1667928610) strcat(s, "e");
if (crc32("PNoGN",5) == 3895275152) strcat(s, "n");
if (crc32("xCQAjOjhuEWoWU",14) == 1872825708) strcat(s, "j");
if (crc32("ixYpwwWmb",9) == 1930789248) strcat(s, "e");
if (crc32("uXKtlm",6) == 2907625343) strcat(s, "j");
if (crc32("zptCmdyYllBVxY",14) == 2495372600) strcat(s, "t");
if (crc32("mhVdDi",6) == 3505644715) strcat(s, "Q");
if (crc32("GqaazjEooqfmBQC",15) == 2340947540) strcat(s, "i");
if (crc32("yYqlnZVHctW",11) == 2698463542) strcat(s, "m");
if (crc32("gsYAIZEMh",9) == 253843946) strcat(s, "e");
    return s;
}

char *unaccoutered_adjectives() {
    char *s = calloc(13);
    if (crc32("FJjkTzbVI",9) == 1343228113) strcat(s, "Y");
if (crc32("ichPDzpymLI",11) == 780707586) strcat(s, "u");
if (crc32("hvUDYhGBpBTQtu",14) == 3015512642) strcat(s, "K");
if (crc32("IVEGFP",6) == 982600273) strcat(s, "n");
if (crc32("HuinfcpfsmoS",12) == 1360625550) strcat(s, "i");
if (crc32("hgQRTVqhaTwle",13) == 1422076821) strcat(s, "a");
if (crc32("VHeBgEIB",8) == 2454511511) strcat(s, "c");
if (crc32("lJGHAQYValm",11) == 2126180169) strcat(s, "p");
if (crc32("qDZLDIhZ",8) == 3358433716) strcat(s, "c");
if (crc32("RvuJqgxZt",9) == 2573965213) strcat(s, "n");
if (crc32("wZvAryfivSWIys",14) == 2881711013) strcat(s, "o");
if (crc32("eZyffZgTSY",10) == 3525903773) strcat(s, "h");
if (crc32("rpMtsLrWo",9) == 827409405) strcat(s, "u");
if (crc32("YlrOWEVT",8) == 1601725768) strcat(s, "t");
if (crc32("dowonIouIew",11) == 3090714777) strcat(s, "m");
if (crc32("yxGQqhFLV",9) == 322005129) strcat(s, "e");
if (crc32("ceflxBWv",8) == 4054754111) strcat(s, "r");
if (crc32("BZsFVVF",7) == 1704125388) strcat(s, "Y");
if (crc32("oRcgieCrUw",10) == 652684164) strcat(s, "e");
if (crc32("uFPSZZDomUdMG",13) == 3837953519) strcat(s, "h");
if (crc32("UbIBaUDS",8) == 3778271736) strcat(s, "d");
    return s;
}

char *postphrenic_adjectives() {
    char *s = calloc(12);
    if (crc32("CCXFhbpcxYozJo",14) == 1909420059) strcat(s, "p");
if (crc32("kqSUYpEptEXYZq",14) == 1885655988) strcat(s, "n");
if (crc32("aKuJsHaWwueF",12) == 1506841718) strcat(s, "o");
if (crc32("YaZxR",5) == 3749572203) strcat(s, "n");
if (crc32("CZDBHGSnsNmM",12) == 3446672433) strcat(s, "s");
if (crc32("XRfpLPMPQF",10) == 2522193169) strcat(s, "t");
if (crc32("mTmFYNSY",8) == 3251454882) strcat(s, "R");
if (crc32("DPNos",5) == 4046582034) strcat(s, "p");
if (crc32("nSmjnk",6) == 4075690136) strcat(s, "i");
if (crc32("lKHvveYuY",9) == 3687714533) strcat(s, "h");
if (crc32("JJsoRFdgrIIyxGV",15) == 2871065278) strcat(s, "r");
if (crc32("ZVdbEVCIb",9) == 643277638) strcat(s, "e");
if (crc32("wpvdXo",6) == 4145904732) strcat(s, "S");
if (crc32("occYWncjdhi",11) == 904774059) strcat(s, "n");
if (crc32("eOYRBwxc",8) == 1975950541) strcat(s, "i");
if (crc32("ZYlHR",5) == 3694954075) strcat(s, "I");
if (crc32("fRlhndToCWHwI",13) == 1603968074) strcat(s, "c");
    return s;
}

char *mellifluous_adjectives() {
    char *s = calloc(12);
    if (crc32("twTjasMXcDwPHMt",15) == 946041353) strcat(s, "m");
if (crc32("VGtDGSCwUpRuzu",14) == 1428550894) strcat(s, "e");
if (crc32("hezQZMLufpB",11) == 1147738051) strcat(s, "l");
if (crc32("NJilpRFpWhjjSYE",15) == 50967119) strcat(s, "l");
if (crc32("KyFoUwhxvE",10) == 4041193591) strcat(s, "t");
if (crc32("NKYyExjkU",9) == 4162774086) strcat(s, "i");
if (crc32("MoqMqDZrjkA",11) == 3384161448) strcat(s, "T");
if (crc32("RoKLek",6) == 479814761) strcat(s, "f");
if (crc32("txqIA",5) == 296271436) strcat(s, "l");
if (crc32("XYSDTSeoh",9) == 4147110980) strcat(s, "X");
if (crc32("ibhxSbWkpDQjXw",14) == 761749480) strcat(s, "u");
if (crc32("sWtIIZPqkLDs",12) == 1672480917) strcat(s, "n");
if (crc32("UcWRvVBDnxSfn",13) == 2148196150) strcat(s, "o");
if (crc32("tsqIAWfUDAj",11) == 3284682935) strcat(s, "u");
if (crc32("UNJRuWD",7) == 1857315045) strcat(s, "o");
if (crc32("sMXyV",5) == 259302548) strcat(s, "s");
    return s;
}

char *fulgurant_adjectives() {
    char *s = calloc(10);
    if (crc32("aKTVdnA",7) == 1136398118) strcat(s, "f");
if (crc32("EzZHqguvffEpsl",14) == 348021155) strcat(s, "u");
if (crc32("vPRBY",5) == 3296580569) strcat(s, "l");
if (crc32("lMizSVIjIjW",11) == 2477538839) strcat(s, "m");
if (crc32("jpiAJgxrRzhlXu",14) == 1026956977) strcat(s, "g");
if (crc32("eApUqbHBPfYKhP",14) == 3237397243) strcat(s, "u");
if (crc32("GXCFYX",6) == 1484989959) strcat(s, "r");
if (crc32("ECXdhQC",7) == 3020291995) strcat(s, "a");
if (crc32("FJemIR",6) == 2333364317) strcat(s, "z");
if (crc32("GGkaljDu",8) == 2172516337) strcat(s, "n");
if (crc32("UCNeI",5) == 3539895913) strcat(s, "t");
    return s;
}

char *unregressive_adjectives() {
    char *s = calloc(13);
    if (crc32("bhNDuysaHlPqt",13) == 5714849) strcat(s, "I");
if (crc32("YBEWLdEXxm",10) == 3746092867) strcat(s, "u");
if (crc32("yvICUjADKwdzdpq",15) == 1413612430) strcat(s, "p");
if (crc32("PnPpZDN",7) == 3140581956) strcat(s, "n");
if (crc32("psTHhCFpEycwe",13) == 1578966128) strcat(s, "r");
if (crc32("LrJjKSAOP",9) == 2854977647) strcat(s, "g");
if (crc32("ndtxSSn",7) == 574601687) strcat(s, "e");
if (crc32("qfyHSfLPsJnL",12) == 3768097810) strcat(s, "g");
if (crc32("ckBqpZJcYSWi",12) == 1756670128) strcat(s, "r");
if (crc32("LfxxNXqq",8) == 2810331719) strcat(s, "q");
if (crc32("NYKfRyjJYYkb",12) == 3444944833) strcat(s, "e");
if (crc32("snrrKf",6) == 2819307893) strcat(s, "g");
if (crc32("xJWhrPrpzmJ",11) == 866879654) strcat(s, "s");
if (crc32("xDucSIh",7) == 544231944) strcat(s, "r");
if (crc32("zTskM",5) == 3925659342) strcat(s, "s");
if (crc32("vDFvklNCLxMVm",13) == 2517268345) strcat(s, "S");
if (crc32("JgdmA",5) == 3972431711) strcat(s, "i");
if (crc32("crdxUjdQCdA",11) == 4143173054) strcat(s, "m");
if (crc32("tVcjDTN",7) == 3988065165) strcat(s, "v");
if (crc32("OcjGT",5) == 2741789361) strcat(s, "e");
    return s;
}

char *unseeing_adjectives() {
    char *s = calloc(9);
    if (crc32("jPwXZY",6) == 2377630228) strcat(s, "g");
if (crc32("PCEhDUORDM",10) == 816321199) strcat(s, "u");
if (crc32("VhFxjXhNrY",10) == 2859126231) strcat(s, "n");
if (crc32("Tuhgdw",6) == 1796590728) strcat(s, "s");
if (crc32("AGlPGWGUCMLj",12) == 2972029881) strcat(s, "e");
if (crc32("JMuVGuNjfNYuLpo",15) == 204762524) strcat(s, "L");
if (crc32("iTgJeFZyHri",11) == 1129030036) strcat(s, "e");
if (crc32("UUqUnWYtwTc",11) == 2277762131) strcat(s, "i");
if (crc32("MlYwMYXoeoyfO",13) == 36472187) strcat(s, "q");
if (crc32("bbncwugShYolSe",14) == 3810672214) strcat(s, "n");
if (crc32("xZJxUzIAOTH",11) == 3731777791) strcat(s, "m");
if (crc32("LEBkJPQfUJZkXcL",15) == 4114062731) strcat(s, "g");
    return s;
}

char *interreligious_adjectives() {
    char *s = calloc(15);
    if (crc32("AyYufcWjRRAyLze",15) == 278259788) strcat(s, "i");
if (crc32("vsGvvHHPeji",11) == 3131354491) strcat(s, "N");
if (crc32("aVdtNqCChsFj",12) == 1855782791) strcat(s, "n");
if (crc32("uMWWiQx",7) == 2220006332) strcat(s, "L");
if (crc32("QJcdSDbXtefswzy",15) == 3948440673) strcat(s, "t");
if (crc32("SDVNxVcBadAJe",13) == 4006952019) strcat(s, "e");
if (crc32("KxwtbNRhne",10) == 3144261096) strcat(s, "q");
if (crc32("gmTJqyPcTr",10) == 2574674118) strcat(s, "r");
if (crc32("XNgxCVhecLHK",12) == 3085714599) strcat(s, "S");
if (crc32("UrQXsv",6) == 3271123643) strcat(s, "r");
if (crc32("pwayuzr",7) == 1794260610) strcat(s, "o");
if (crc32("cltux",5) == 908985866) strcat(s, "e");
if (crc32("aHjYgxuLjeBBJn",14) == 3808967266) strcat(s, "l");
if (crc32("wDpZOCbgyidF",12) == 2572513062) strcat(s, "F");
if (crc32("whdowjlwOLXWe",13) == 142122041) strcat(s, "i");
if (crc32("CKdRt",5) == 90170295) strcat(s, "g");
if (crc32("bAorGJoSXlnEry",14) == 569422948) strcat(s, "b");
if (crc32("HNqhAbrBRMt",11) == 190947323) strcat(s, "i");
if (crc32("VgmExRzgJVNyenc",15) == 847230523) strcat(s, "g");
if (crc32("pQGKt",5) == 2104608699) strcat(s, "o");
if (crc32("oDUstixiVfxjd",13) == 4098885700) strcat(s, "s");
if (crc32("QmzgUREgeXoRFN",14) == 3529972288) strcat(s, "u");
if (crc32("oWsjM",5) == 1246906515) strcat(s, "s");
    return s;
}

char *conflagrative_adjectives() {
    char *s = calloc(14);
    if (crc32("EvPyRYxXmvRUQ",13) == 2763708546) strcat(s, "c");
if (crc32("QgfadBYkjJoWHYr",15) == 2488656842) strcat(s, "W");
if (crc32("rEjeowT",7) == 696720319) strcat(s, "o");
if (crc32("zdveeYPOy",9) == 3589768363) strcat(s, "n");
if (crc32("FRvxuMlIcSuLIqx",15) == 3259171064) strcat(s, "j");
if (crc32("WCmnnBD",7) == 3107851629) strcat(s, "f");
if (crc32("LCsaazQsu",9) == 214746311) strcat(s, "B");
if (crc32("NjeEFWlOSd",10) == 2797695844) strcat(s, "l");
if (crc32("fxDbVkyIYp",10) == 1123682051) strcat(s, "B");
if (crc32("TxPkTuBkc",9) == 1195014746) strcat(s, "a");
if (crc32("koQzmJ",6) == 2753463939) strcat(s, "g");
if (crc32("fWRbYe",6) == 2578118034) strcat(s, "r");
if (crc32("anmOE",5) == 2295437174) strcat(s, "a");
if (crc32("UdjpG",5) == 5387457) strcat(s, "t");
if (crc32("aMBurVyRUQZ",11) == 4089616298) strcat(s, "i");
if (crc32("QIvldo",6) == 3457654217) strcat(s, "w");
if (crc32("ErnXILohgqVSIkr",15) == 3847642305) strcat(s, "v");
if (crc32("yzdrzBvqyfgD",12) == 1561497480) strcat(s, "q");
if (crc32("kOpNCuYcAsgoS",13) == 2699873200) strcat(s, "e");
    return s;
}

char *coadunate_adjectives() {
    char *s = calloc(10);
    if (crc32("gmtVJ",5) == 2586583042) strcat(s, "f");
if (crc32("TmHsLaORn",9) == 1070819733) strcat(s, "c");
if (crc32("NcLrt",5) == 999527213) strcat(s, "o");
if (crc32("fKRnP",5) == 1667778511) strcat(s, "a");
if (crc32("qDnyoAdIVbJmH",13) == 2448102025) strcat(s, "d");
if (crc32("DZVse",5) == 2450211158) strcat(s, "l");
if (crc32("GcTjyhaE",8) == 2451242399) strcat(s, "u");
if (crc32("JcHBTLl",7) == 2037701559) strcat(s, "x");
if (crc32("CGdzzbQVHay",11) == 2849199900) strcat(s, "n");
if (crc32("TVQHIegQHtze",12) == 630204031) strcat(s, "e");
if (crc32("dcbbxEsTSZtcdP",14) == 2205407790) strcat(s, "a");
if (crc32("WraIARz",7) == 4243025515) strcat(s, "X");
if (crc32("SgbeuyNSsb",10) == 3747215038) strcat(s, "t");
if (crc32("jmiwkHpGjvMxjec",15) == 1577755869) strcat(s, "E");
if (crc32("DCTNRuPYd",9) == 1938130170) strcat(s, "e");
    return s;
}

char *chondromatous_adjectives() {
    char *s = calloc(14);
    if (crc32("WLadAmJ",7) == 613459562) strcat(s, "c");
if (crc32("YpgtwXCIyYeSz",13) == 1095005041) strcat(s, "h");
if (crc32("ruRDTVMTSOKTo",13) == 2082901714) strcat(s, "s");
if (crc32("FWHSWUpqsDr",11) == 1553501976) strcat(s, "o");
if (crc32("YcgVLZqSxe",10) == 875569662) strcat(s, "n");
if (crc32("pWiHGkLugAL",11) == 1027108699) strcat(s, "d");
if (crc32("NorMtUqvg",9) == 1050818543) strcat(s, "r");
if (crc32("RgCQSiKngvwCJmh",15) == 1430487114) strcat(s, "o");
if (crc32("qzJKex",6) == 56985211) strcat(s, "S");
if (crc32("HuBrG",5) == 1961829074) strcat(s, "m");
if (crc32("aaiqF",5) == 2266060021) strcat(s, "i");
if (crc32("Fjnnwcmwu",9) == 2174934273) strcat(s, "a");
if (crc32("VETeA",5) == 1097089049) strcat(s, "k");
if (crc32("ZActijy",7) == 365899778) strcat(s, "t");
if (crc32("rfNdUKtJlSOFC",13) == 52289442) strcat(s, "o");
if (crc32("PArTchNbXJzDhDu",15) == 81968884) strcat(s, "u");
if (crc32("dFcxNUXiJTx",11) == 4182496862) strcat(s, "s");
    return s;
}

char *unsobering_adjectives() {
    char *s = calloc(11);
    if (crc32("cCAuCaUhdZfu",12) == 2537088122) strcat(s, "r");
if (crc32("qUIlqCjJ",8) == 2833552988) strcat(s, "u");
if (crc32("rJCAanY",7) == 3565102297) strcat(s, "n");
if (crc32("iRZLAoaBpI",10) == 3662458464) strcat(s, "s");
if (crc32("VmAnUedNTB",10) == 1103500362) strcat(s, "o");
if (crc32("YKRWukcABaP",11) == 4221868310) strcat(s, "y");
if (crc32("YzloXh",6) == 710015586) strcat(s, "b");
if (crc32("PwnBWhqitF",10) == 537525561) strcat(s, "e");
if (crc32("qxIVJkiwGKrPYg",14) == 3017388754) strcat(s, "n");
if (crc32("xLaLtUc",7) == 258894626) strcat(s, "r");
if (crc32("XDYIfjoJ",8) == 3718894867) strcat(s, "g");
if (crc32("ynMRJI",6) == 3091009539) strcat(s, "i");
if (crc32("EMDxRC",6) == 1744338938) strcat(s, "n");
if (crc32("pZjttfdodrNkp",13) == 302602153) strcat(s, "g");
    return s;
}

char *cuddlesome_adjectives() {
    char *s = calloc(11);
    if (crc32("KyGlAfWiXcs",11) == 3166307357) strcat(s, "c");
if (crc32("kNQghuFlQZIf",12) == 1737685412) strcat(s, "u");
if (crc32("lLZmbvNYL",9) == 3524430784) strcat(s, "d");
if (crc32("cpYXixTKx",9) == 56668018) strcat(s, "D");
if (crc32("QWHCOPn",7) == 2198878879) strcat(s, "d");
if (crc32("ckuOXa",6) == 1943613517) strcat(s, "Q");
if (crc32("mwPZBKdCZNyswUa",15) == 3827054445) strcat(s, "l");
if (crc32("zSfTrafufFLlI",13) == 2868653177) strcat(s, "e");
if (crc32("CDZTuw",6) == 4064168870) strcat(s, "o");
if (crc32("NjTcCioMZJj",11) == 3061347643) strcat(s, "s");
if (crc32("lSlXYDeDS",9) == 572710756) strcat(s, "o");
if (crc32("VBTidauHYBkp",12) == 549500161) strcat(s, "a");
if (crc32("zLhYw",5) == 1197371628) strcat(s, "m");
if (crc32("qgCsi",5) == 2617332973) strcat(s, "x");
if (crc32("rZlGqpxf",8) == 1565666367) strcat(s, "e");
    return s;
}

char *kookiest_adjectives() {
    char *s = calloc(9);
    if (crc32("yaGXmoINk",9) == 1451093443) strcat(s, "U");
if (crc32("MMrCvhrCPePxo",13) == 2565506868) strcat(s, "k");
if (crc32("dIcUhHB",7) == 238379272) strcat(s, "o");
if (crc32("dKJCMyXW",8) == 1932303116) strcat(s, "o");
if (crc32("NbEZSGOR",8) == 918767316) strcat(s, "k");
if (crc32("xXYfBdhQecaa",12) == 309497774) strcat(s, "L");
if (crc32("FfEIRIuEC",9) == 4149169320) strcat(s, "i");
if (crc32("RlZbTvKAeZC",11) == 315327646) strcat(s, "e");
if (crc32("LGjAMclIMXSS",12) == 4107613923) strcat(s, "s");
if (crc32("oVBSUyOhNHv",11) == 4198506318) strcat(s, "O");
if (crc32("ppakyYLQfNkuV",13) == 2197595361) strcat(s, "t");
    return s;
}

char *baronial_adjectives() {
    char *s = calloc(9);
    if (crc32("bIiFHdx",7) == 2726903838) strcat(s, "b");
if (crc32("wrXzVMRLfOER",12) == 1161285927) strcat(s, "a");
if (crc32("xYrdiDnTWaIzECD",15) == 934129830) strcat(s, "r");
if (crc32("vEsyByhsjR",10) == 2711626297) strcat(s, "S");
if (crc32("NSOeEdQT",8) == 3362164243) strcat(s, "o");
if (crc32("LkraoArVLhDmHP",14) == 1112480064) strcat(s, "S");
if (crc32("fWjHajSWCvZA",12) == 3846967139) strcat(s, "n");
if (crc32("NMYOzws",7) == 2274624954) strcat(s, "D");
if (crc32("kOMaOBuk",8) == 1966409213) strcat(s, "i");
if (crc32("bNzdGUyYsUd",11) == 2532082800) strcat(s, "a");
if (crc32("hqWRRyr",7) == 3470784688) strcat(s, "w");
if (crc32("eIZPDkS",7) == 3605244014) strcat(s, "l");
    return s;
}

char *presanguine_adjectives() {
    char *s = calloc(12);
    if (crc32("ZLFiNt",6) == 1094655898) strcat(s, "p");
if (crc32("kAwPKyOP",8) == 2157673600) strcat(s, "d");
if (crc32("nrKvDtRPZTwKQyf",15) == 1376955282) strcat(s, "r");
if (crc32("aWBzdcYQpYTOk",13) == 1546292978) strcat(s, "e");
if (crc32("iDkQBUCqtWYSp",13) == 807246482) strcat(s, "s");
if (crc32("aEnRFxlQiFJVS",13) == 3270280335) strcat(s, "N");
if (crc32("zKaVN",5) == 231073565) strcat(s, "a");
if (crc32("tuBptTJa",8) == 238546708) strcat(s, "p");
if (crc32("oJJdRYORECmpu",13) == 2741852852) strcat(s, "n");
if (crc32("uVpbEVYzCDmIiP",14) == 3720064205) strcat(s, "k");
if (crc32("oPRUD",5) == 3473460837) strcat(s, "g");
if (crc32("IQsfBdNunu",10) == 4020469861) strcat(s, "a");
if (crc32("VsojnHEFhCkcum",14) == 825948150) strcat(s, "u");
if (crc32("aPjdfxCIVOx",11) == 2087946669) strcat(s, "m");
if (crc32("DGTEQYafQa",10) == 2910022215) strcat(s, "i");
if (crc32("SPKZrQ",6) == 295995593) strcat(s, "s");
if (crc32("DIJVrNQQfv",10) == 3415541458) strcat(s, "n");
if (crc32("xGisGdUDJGsJ",12) == 4241131723) strcat(s, "e");
    return s;
}

char *precharted_adjectives() {
    char *s = calloc(11);
    if (crc32("jdPoJoQkNq",10) == 216163956) strcat(s, "m");
if (crc32("kLOzqamMDvSuA",13) == 193728455) strcat(s, "p");
if (crc32("FEMcxJywRcKS",12) == 2539464690) strcat(s, "Y");
if (crc32("hCyclVHvFzACS",13) == 2870522601) strcat(s, "r");
if (crc32("xvwfFgUJJiIr",12) == 279884727) strcat(s, "t");
if (crc32("BzXRfFswBNT",11) == 3529387802) strcat(s, "e");
if (crc32("zODFEmL",7) == 3776857776) strcat(s, "c");
if (crc32("nsMIgbjbC",9) == 2237013923) strcat(s, "H");
if (crc32("lCAgkuPqTsQj",12) == 3081711805) strcat(s, "h");
if (crc32("TXNhfmwiRSMNyl",14) == 3519584948) strcat(s, "a");
if (crc32("ZjbMzKYDjZubgSh",15) == 345278773) strcat(s, "r");
if (crc32("RIyDeKvSSJDD",12) == 928906211) strcat(s, "m");
if (crc32("kdAifhFWD",9) == 3114624928) strcat(s, "t");
if (crc32("EJgFTFMTY",9) == 2593068704) strcat(s, "e");
if (crc32("LEDPR",5) == 3215368906) strcat(s, "d");
    return s;
}

char *workingclass_adjectives() {
    char *s = calloc(13);
    if (crc32("FSRLSkBldSM",11) == 204101260) strcat(s, "j");
if (crc32("cDlNjLUXpWqMc",13) == 411896698) strcat(s, "w");
if (crc32("PwYjAnttnYm",11) == 2103273962) strcat(s, "u");
if (crc32("FvXMVQaHp",9) == 1729105884) strcat(s, "o");
if (crc32("BVuIUEIRymefWzs",15) == 1141481608) strcat(s, "O");
if (crc32("WdZvEsJw",8) == 2687848104) strcat(s, "r");
if (crc32("ofzOOVuAHCY",11) == 738634076) strcat(s, "k");
if (crc32("YoOMDIASWcwzFM",14) == 4076701720) strcat(s, "i");
if (crc32("YZypc",5) == 4187245327) strcat(s, "A");
if (crc32("djeZCjKXd",9) == 3716945252) strcat(s, "n");
if (crc32("gDrwIHe",7) == 3899105890) strcat(s, "n");
if (crc32("EJzcwtawllIHyo",14) == 2164124694) strcat(s, "g");
if (crc32("sDXCOx",6) == 3294469717) strcat(s, "c");
if (crc32("RQPUJC",6) == 2983115384) strcat(s, "l");
if (crc32("fDRVfV",6) == 763133925) strcat(s, "P");
if (crc32("XvJgDTZoTPoso",13) == 541704417) strcat(s, "a");
if (crc32("ivSZSaYSO",9) == 728695081) strcat(s, "s");
if (crc32("FEdlpEbCZEAid",13) == 3303018047) strcat(s, "s");
    return s;
}

char *unemaciated_adjectives() {
    char *s = calloc(12);
    if (crc32("fTxBwyyT",8) == 1493986580) strcat(s, "w");
if (crc32("qNlZtCFKHSLdG",13) == 741852632) strcat(s, "u");
if (crc32("wVqJrkB",7) == 431871828) strcat(s, "v");
if (crc32("VoobaM",6) == 753546501) strcat(s, "n");
if (crc32("tNECgwPA",8) == 2580544023) strcat(s, "h");
if (crc32("zlJnFiBvKUwDUG",14) == 425429893) strcat(s, "e");
if (crc32("OgYvOwHBQZgC",12) == 1238165935) strcat(s, "m");
if (crc32("BahnB",5) == 3982936733) strcat(s, "l");
if (crc32("YGtpQ",5) == 2504647227) strcat(s, "a");
if (crc32("LgtFgCZYUIxx",12) == 1745019784) strcat(s, "c");
if (crc32("hbvTOzuIMD",10) == 3022701204) strcat(s, "i");
if (crc32("cimPKKNQvfEpxRE",15) == 1713738430) strcat(s, "E");
if (crc32("FNqjeQbslea",11) == 2485932433) strcat(s, "a");
if (crc32("pzfTyVKzD",9) == 2521419017) strcat(s, "t");
if (crc32("XBvpWMLjAb",10) == 1355726467) strcat(s, "e");
if (crc32("tSIoVBVREu",10) == 2655847290) strcat(s, "S");
if (crc32("PMnPssMX",8) == 275752962) strcat(s, "d");
    return s;
}

char *stelliform_adjectives() {
    char *s = calloc(11);
    if (crc32("bsJKdBclKfXI",12) == 3260767432) strcat(s, "u");
if (crc32("KAApiBW",7) == 1636757294) strcat(s, "s");
if (crc32("HrSxrxZOMOHIRpj",15) == 2744842726) strcat(s, "t");
if (crc32("gNHUrpoSSYBBG",13) == 2209227379) strcat(s, "e");
if (crc32("YzWihnTaYvpZM",13) == 1645660068) strcat(s, "l");
if (crc32("TDxhJwhsMcGI",12) == 1853181688) strcat(s, "u");
if (crc32("UsamYGcXDYqn",12) == 2369213029) strcat(s, "l");
if (crc32("GSaRaBthK",9) == 221983770) strcat(s, "J");
if (crc32("zoXAQocaCVim",12) == 3175258235) strcat(s, "i");
if (crc32("ohHWXkEcTWKlxk",14) == 3125608154) strcat(s, "f");
if (crc32("JTjnfNikbhSHQw",14) == 3790821715) strcat(s, "o");
if (crc32("RpOBNulaJx",10) == 3844930121) strcat(s, "r");
if (crc32("IeDpJSObw",9) == 215212678) strcat(s, "O");
if (crc32("RWouvPDPBCawpva",15) == 1081625607) strcat(s, "m");
    return s;
}

char *unamortized_adjectives() {
    char *s = calloc(12);
    if (crc32("cgNzZ",5) == 2586557542) strcat(s, "u");
if (crc32("GtnGBR",6) == 1187765074) strcat(s, "n");
if (crc32("PrIbL",5) == 441001443) strcat(s, "P");
if (crc32("gDaBhE",6) == 1381432752) strcat(s, "a");
if (crc32("JvhtxWxoLOIJdEF",15) == 110738925) strcat(s, "j");
if (crc32("PlnfSsoNuq",10) == 2511158296) strcat(s, "m");
if (crc32("KnnDv",5) == 1573037655) strcat(s, "o");
if (crc32("zjMAmnOWod",10) == 186558515) strcat(s, "r");
if (crc32("IlPonrMJfYbKa",13) == 2385107922) strcat(s, "T");
if (crc32("vPASyPi",7) == 2005152858) strcat(s, "t");
if (crc32("SSBhOTdBmI",10) == 126322738) strcat(s, "v");
if (crc32("zQzKs",5) == 2232827002) strcat(s, "i");
if (crc32("DJxqq",5) == 3560735032) strcat(s, "z");
if (crc32("asrZxinIA",9) == 3028913486) strcat(s, "e");
if (crc32("DPTEca",6) == 1531156582) strcat(s, "d");
    return s;
}

char *plausible_adjectives() {
    char *s = calloc(10);
    if (crc32("cnIPUia",7) == 1876934605) strcat(s, "p");
if (crc32("PQDVzpAh",8) == 1816396603) strcat(s, "l");
if (crc32("NyrHjIe",7) == 1136073995) strcat(s, "P");
if (crc32("Xfjza",5) == 2049529228) strcat(s, "a");
if (crc32("ETXRsKeMPAyYTGa",15) == 2098824674) strcat(s, "u");
if (crc32("xryWIrwPWB",10) == 3507859066) strcat(s, "s");
if (crc32("Tezqa",5) == 2276205245) strcat(s, "C");
if (crc32("vVgHnvtyJewlS",13) == 2350557473) strcat(s, "i");
if (crc32("CfjKeHLSlKmwJg",14) == 1515543049) strcat(s, "b");
if (crc32("iErSxPxlwDzNnUW",15) == 1922670821) strcat(s, "g");
if (crc32("eYHxPmnFIQpk",12) == 720803705) strcat(s, "l");
if (crc32("iRSOuL",6) == 3490820206) strcat(s, "r");
if (crc32("UDseIsIBb",9) == 3295880745) strcat(s, "e");
    return s;
}

char *bifoliate_adjectives() {
    char *s = calloc(10);
    if (crc32("Mnryriu",7) == 3696103479) strcat(s, "b");
if (crc32("FSEBEROR",8) == 3560785436) strcat(s, "i");
if (crc32("zAzvUGljbs",10) == 1707552985) strcat(s, "f");
if (crc32("ZxipUDvMdWvZmff",15) == 3735228004) strcat(s, "q");
if (crc32("ygcVgfqkGe",10) == 3654763454) strcat(s, "o");
if (crc32("pQfnWNJ",7) == 3931972842) strcat(s, "l");
if (crc32("TrrKk",5) == 1411343393) strcat(s, "i");
if (crc32("IGRsJfeOkc",10) == 64340541) strcat(s, "N");
if (crc32("OeWQlHOLBKkiHI",14) == 137107180) strcat(s, "a");
if (crc32("stbWQMP",7) == 649424146) strcat(s, "t");
if (crc32("HBGepW",6) == 3793090149) strcat(s, "e");
    return s;
}

char *husklike_adjectives() {
    char *s = calloc(9);
    if (crc32("VUYrLszyHqGt",12) == 606380395) strcat(s, "h");
if (crc32("UXLXWs",6) == 1786367861) strcat(s, "u");
if (crc32("GWTsAyGC",8) == 1396894576) strcat(s, "w");
if (crc32("vlhdtFdpyXWQM",13) == 67495775) strcat(s, "s");
if (crc32("hetlR",5) == 2085427295) strcat(s, "k");
if (crc32("NMgLfjNceDDDqro",15) == 387189052) strcat(s, "l");
if (crc32("SSxECJe",7) == 1435270884) strcat(s, "j");
if (crc32("OgedABWzAiElxyl",15) == 4067260792) strcat(s, "i");
if (crc32("PnIlIT",6) == 1898062890) strcat(s, "k");
if (crc32("JNBwqATPHOm",11) == 782560933) strcat(s, "l");
if (crc32("EHvhXPryNKvNiw",14) == 3374587028) strcat(s, "e");
    return s;
}

char *colourless_adjectives() {
    char *s = calloc(11);
    if (crc32("SvnZwladaWbtOvU",15) == 2120343162) strcat(s, "L");
if (crc32("jYFEKFTGf",9) == 4234402207) strcat(s, "c");
if (crc32("bmJeIiXazfWzM",13) == 2741599000) strcat(s, "o");
if (crc32("HgGQnYPhRabpm",13) == 2038281026) strcat(s, "h");
if (crc32("cUujBGDP",8) == 2037423545) strcat(s, "l");
if (crc32("pDwcjQQa",8) == 292766028) strcat(s, "o");
if (crc32("coFjWiJZqTKOygS",15) == 3226681995) strcat(s, "u");
if (crc32("BZRGdrqEmNsTRxH",15) == 1301530849) strcat(s, "j");
if (crc32("tOqNnZcbzdn",11) == 1524558527) strcat(s, "r");
if (crc32("zTomtlxlxiv",11) == 2268693269) strcat(s, "l");
if (crc32("oDyAg",5) == 1704279435) strcat(s, "D");
if (crc32("SdKnNh",6) == 1957017728) strcat(s, "e");
if (crc32("APwxUM",6) == 1442508371) strcat(s, "k");
if (crc32("dpPkL",5) == 1416632171) strcat(s, "s");
if (crc32("OyVesyib",8) == 1380123952) strcat(s, "s");
    return s;
}

char *karmic_adjectives() {
    char *s = calloc(7);
    if (crc32("aYQFi",5) == 726047792) strcat(s, "k");
if (crc32("TogvBKmpfkKqkNl",15) == 418012395) strcat(s, "l");
if (crc32("tGPVH",5) == 887737430) strcat(s, "a");
if (crc32("jxuPPXv",7) == 1045839495) strcat(s, "H");
if (crc32("RVnAusORAOhILkJ",15) == 3478749264) strcat(s, "r");
if (crc32("kUwkVz",6) == 3933739590) strcat(s, "K");
if (crc32("hXmMsbVVR",9) == 4030649961) strcat(s, "m");
if (crc32("rekFnjrEnlqWzhy",15) == 3608163170) strcat(s, "i");
if (crc32("mZPKZajSQmWG",12) == 2750229463) strcat(s, "c");
    return s;
}

char *combless_adjectives() {
    char *s = calloc(9);
    if (crc32("oDNxY",5) == 1180918415) strcat(s, "c");
if (crc32("YRkgXFZXKHZ",11) == 2877100963) strcat(s, "o");
if (crc32("fbWiaMMgB",9) == 3450472427) strcat(s, "t");
if (crc32("hiGFzvDldnffEmR",15) == 3807388073) strcat(s, "m");
if (crc32("DIfynflVjUB",11) == 2642447907) strcat(s, "V");
if (crc32("PnADbe",6) == 2774984398) strcat(s, "b");
if (crc32("Hrtpqvi",7) == 3543641042) strcat(s, "l");
if (crc32("FvraexuRd",9) == 2637389639) strcat(s, "W");
if (crc32("NAsHklJUsM",10) == 1400619907) strcat(s, "e");
if (crc32("YUZjFoBlXLVr",12) == 1305672195) strcat(s, "y");
if (crc32("nBoeCLNVnGVQ",12) == 4203956720) strcat(s, "s");
if (crc32("lYZPKttQmmWWmtU",15) == 256024468) strcat(s, "N");
if (crc32("baDMqSGAxT",10) == 3057482605) strcat(s, "s");
    return s;
}

char *unsloped_adjectives() {
    char *s = calloc(9);
    if (crc32("STlhvI",6) == 2308814448) strcat(s, "G");
if (crc32("JVdzVasjjLmsx",13) == 736347002) strcat(s, "u");
if (crc32("sTtlwblkIdQ",11) == 672356149) strcat(s, "n");
if (crc32("LLuMofiJOcNt",12) == 3361352035) strcat(s, "x");
if (crc32("XYxCqjwLxVrTog",14) == 418423590) strcat(s, "s");
if (crc32("pbBba",5) == 4227646323) strcat(s, "d");
if (crc32("AUmLQlctpd",10) == 3874074494) strcat(s, "l");
if (crc32("mjMyxzEJxni",11) == 4233939128) strcat(s, "d");
if (crc32("TFMZrDl",7) == 272667609) strcat(s, "o");
if (crc32("BeIoneobfIupWw",14) == 3321658208) strcat(s, "H");
if (crc32("PEwLVgYJo",9) == 19367499) strcat(s, "p");
if (crc32("IICxEFc",7) == 3518597584) strcat(s, "e");
if (crc32("EMOFLTjIOWU",11) == 1181146748) strcat(s, "c");
if (crc32("ZVUaHLcIf",9) == 1455656637) strcat(s, "d");
    return s;
}

char *mesometeorological_adjectives() {
    char *s = calloc(19);
    if (crc32("TsFFkMjO",8) == 1574103063) strcat(s, "F");
if (crc32("LhOIQTUdTEL",11) == 2378683338) strcat(s, "m");
if (crc32("LGyUdIAg",8) == 3591840058) strcat(s, "m");
if (crc32("EDxejNScDHd",11) == 3252796568) strcat(s, "e");
if (crc32("ZdknpbZbanuOBzG",15) == 3824565255) strcat(s, "G");
if (crc32("cepHkpCO",8) == 76045743) strcat(s, "s");
if (crc32("FpWrhxGGDqXx",12) == 2529855614) strcat(s, "o");
if (crc32("TJOYORoF",8) == 1319975961) strcat(s, "m");
if (crc32("ClEYz",5) == 91860011) strcat(s, "e");
if (crc32("OjFRrYWQb",9) == 505929064) strcat(s, "F");
if (crc32("wcKgsiJEvQy",11) == 2521870395) strcat(s, "t");
if (crc32("wsJYdO",6) == 1772181761) strcat(s, "e");
if (crc32("zJUTkitsKG",10) == 338343253) strcat(s, "r");
if (crc32("IGJfF",5) == 1142394163) strcat(s, "o");
if (crc32("efDNt",5) == 1063543731) strcat(s, "f");
if (crc32("pbjFpsvKj",9) == 476934064) strcat(s, "r");
if (crc32("WWhKI",5) == 1082271423) strcat(s, "o");
if (crc32("hngcADkE",8) == 2722266263) strcat(s, "l");
if (crc32("jJuhA",5) == 533469882) strcat(s, "o");
if (crc32("RhCMkaI",7) == 2361954237) strcat(s, "g");
if (crc32("TSxpUTEJ",8) == 884069422) strcat(s, "i");
if (crc32("ccUzWYPU",8) == 4197750120) strcat(s, "c");
if (crc32("qKtENHKoMi",10) == 2166852973) strcat(s, "p");
if (crc32("bNplpSY",7) == 3957706317) strcat(s, "a");
if (crc32("ihFTMyeUr",9) == 613175769) strcat(s, "l");
    return s;
}

char *selfemptying_adjectives() {
    char *s = calloc(13);
    if (crc32("OTWEWiHXCBZw",12) == 2605989853) strcat(s, "o");
if (crc32("chaIhG",6) == 799929198) strcat(s, "s");
if (crc32("mETAPminSdGhkh",14) == 23029004) strcat(s, "e");
if (crc32("bppOPyclhE",10) == 3819462590) strcat(s, "l");
if (crc32("WYMofZAuVzjT",12) == 335674411) strcat(s, "L");
if (crc32("xBbJBJRIxWmuSA",14) == 1422442302) strcat(s, "f");
if (crc32("XWgqlWRJcwvQmV",14) == 1275435259) strcat(s, "e");
if (crc32("nFuBgoHNkqc",11) == 703305673) strcat(s, "m");
if (crc32("dWpuPnDLISPaHHm",15) == 2643589465) strcat(s, "L");
if (crc32("lhgQjEwojlW",11) == 1930695510) strcat(s, "p");
if (crc32("VkIqjdcaXIgjlB",14) == 3335785890) strcat(s, "t");
if (crc32("tgVYSuklNJaoGN",14) == 1636902565) strcat(s, "y");
if (crc32("mPXDjeCEOMvQ",12) == 3729740823) strcat(s, "l");
if (crc32("JWuCXahCRBhK",12) == 163432443) strcat(s, "i");
if (crc32("IQlnHQkadkj",11) == 1453118569) strcat(s, "n");
if (crc32("ukKLymNvYsY",11) == 1365299373) strcat(s, "p");
if (crc32("ssRraYQJAfG",11) == 4264950577) strcat(s, "g");
    return s;
}

char *aplitic_adjectives() {
    char *s = calloc(8);
    if (crc32("nRBSpijlrq",10) == 3117966591) strcat(s, "a");
if (crc32("OVMyO",5) == 3957044234) strcat(s, "S");
if (crc32("fvobN",5) == 455107359) strcat(s, "p");
if (crc32("joaJHGFjQ",9) == 2226979897) strcat(s, "h");
if (crc32("jsogtla",7) == 579479925) strcat(s, "l");
if (crc32("RuMXAVrX",8) == 3908000958) strcat(s, "Y");
if (crc32("QBReWH",6) == 4140219659) strcat(s, "i");
if (crc32("EbwjKcExKSB",11) == 3536148628) strcat(s, "B");
if (crc32("usKonZVaeiTDqZn",15) == 1441038110) strcat(s, "t");
if (crc32("GalZeMrfy",9) == 2686935222) strcat(s, "Z");
if (crc32("ZBXsLgXNNqh",11) == 1781996592) strcat(s, "i");
if (crc32("XHNXhLwnYnOAq",13) == 3794013752) strcat(s, "g");
if (crc32("OksNvYTmsofLpyJ",15) == 3162045301) strcat(s, "c");
    return s;
}

char *hallucinative_adjectives() {
    char *s = calloc(14);
    if (crc32("gbXLUFR",7) == 114382027) strcat(s, "h");
if (crc32("mENTKf",6) == 848925151) strcat(s, "a");
if (crc32("RQRVgCR",7) == 3419695466) strcat(s, "z");
if (crc32("dpQueEXlsayJf",13) == 2620285265) strcat(s, "l");
if (crc32("dpqWX",5) == 1026396471) strcat(s, "l");
if (crc32("StuTZ",5) == 1520435148) strcat(s, "l");
if (crc32("XLIFLUFMiFEAhek",15) == 2320707963) strcat(s, "z");
if (crc32("hixMTCBYUVywXc",14) == 1486241498) strcat(s, "u");
if (crc32("bKCAszVq",8) == 3064990107) strcat(s, "c");
if (crc32("JncyUWWxeMa",11) == 2165460217) strcat(s, "y");
if (crc32("iLOcW",5) == 1138439018) strcat(s, "i");
if (crc32("wpHHWw",6) == 266385359) strcat(s, "l");
if (crc32("pstRJO",6) == 1661075686) strcat(s, "n");
if (crc32("VBBeuIztQ",9) == 3726859109) strcat(s, "a");
if (crc32("XYPzGHGIQVcZh",13) == 765939613) strcat(s, "C");
if (crc32("jpXBxSuSCeecjN",14) == 1228608801) strcat(s, "t");
if (crc32("sSieJ",5) == 1751976589) strcat(s, "i");
if (crc32("euibVagJXnJk",12) == 275895401) strcat(s, "f");
if (crc32("bRGDSCqn",8) == 3418542929) strcat(s, "v");
if (crc32("VffADH",6) == 4267754543) strcat(s, "e");
    return s;
}

char *noneradicable_adjectives() {
    char *s = calloc(14);
    if (crc32("GiBVlCzgHjMLcoh",15) == 2120352628) strcat(s, "n");
if (crc32("EHyJMbrdAxRJ",12) == 492421041) strcat(s, "o");
if (crc32("GHemwZFMHCeGUk",14) == 2565737440) strcat(s, "n");
if (crc32("FlCHhcpWtoJz",12) == 3411261995) strcat(s, "e");
if (crc32("eTxqCFR",7) == 101484974) strcat(s, "r");
if (crc32("dSjCcxTbfeRVWgY",15) == 3948974422) strcat(s, "r");
if (crc32("JKJKRRX",7) == 3302722812) strcat(s, "a");
if (crc32("TZXjqHXkD",9) == 3137442166) strcat(s, "d");
if (crc32("obvDZMcYSMwBTh",14) == 2471021705) strcat(s, "i");
if (crc32("cmCAUfJIKw",10) == 1013373660) strcat(s, "i");
if (crc32("UFZhiyzn",8) == 968639456) strcat(s, "c");
if (crc32("DDHadrduZTAMJo",14) == 1408291941) strcat(s, "a");
if (crc32("mURepywlXJ",10) == 1679597919) strcat(s, "R");
if (crc32("ErrJDWgZeGTx",12) == 428359437) strcat(s, "b");
if (crc32("qYEmAYzVvwznK",13) == 3986489177) strcat(s, "D");
if (crc32("aBgrOImhgrvYupX",15) == 1859448846) strcat(s, "l");
if (crc32("zQEISNZBbL",10) == 1173420726) strcat(s, "e");
    return s;
}

char *sufferable_adjectives() {
    char *s = calloc(11);
    if (crc32("clzQlmUGG",9) == 588258356) strcat(s, "s");
if (crc32("BzCfmhZg",8) == 3308690384) strcat(s, "u");
if (crc32("WlCTmQP",7) == 2447589662) strcat(s, "b");
if (crc32("EEZjmspea",9) == 1398611544) strcat(s, "f");
if (crc32("VwQCOv",6) == 4010650123) strcat(s, "f");
if (crc32("ibPMSWrreBo",11) == 1158288142) strcat(s, "e");
if (crc32("CCeUMbRmGktnTYu",15) == 1301958452) strcat(s, "r");
if (crc32("TbYTCLgq",8) == 888466288) strcat(s, "i");
if (crc32("kQdoawfEHX",10) == 1001212822) strcat(s, "a");
if (crc32("AUxyCMQnxQJy",12) == 3068360907) strcat(s, "g");
if (crc32("jtIMWDCFQJhhkWp",15) == 3321890755) strcat(s, "b");
if (crc32("pmujou",6) == 1445234038) strcat(s, "o");
if (crc32("OshcnDtrjG",10) == 2806671989) strcat(s, "l");
if (crc32("BeZeubXhAG",10) == 1800731302) strcat(s, "O");
if (crc32("ycTqTcYzVwX",11) == 2667108986) strcat(s, "e");
    return s;
}

char *selfdisserving_adjectives() {
    char *s = calloc(15);
    if (crc32("wFtCYMiGzYw",11) == 1316223430) strcat(s, "s");
if (crc32("LCYvvuS",7) == 470446932) strcat(s, "e");
if (crc32("MFCYkGNjPGgoPh",14) == 1562385019) strcat(s, "U");
if (crc32("ndhUTjvE",8) == 3037885942) strcat(s, "l");
if (crc32("hdUptyiHKuhePpw",15) == 3413037361) strcat(s, "J");
if (crc32("VrjLgJGuAFqZmz",14) == 4009625853) strcat(s, "f");
if (crc32("zPhmYQJE",8) == 254343941) strcat(s, "r");
if (crc32("nluoCBd",7) == 2447905874) strcat(s, "d");
if (crc32("dwNdF",5) == 3722353027) strcat(s, "w");
if (crc32("nTTPvpjrv",9) == 2219983503) strcat(s, "i");
if (crc32("AZRUqquSQxaf",12) == 2790842513) strcat(s, "h");
if (crc32("aLnmfWNxoddLIrs",15) == 2002458935) strcat(s, "s");
if (crc32("SVEZAzdxuMn",11) == 1495894968) strcat(s, "s");
if (crc32("TpUmoPbOqszVn",13) == 74668655) strcat(s, "D");
if (crc32("dGMHxcgFWU",10) == 1106746497) strcat(s, "e");
if (crc32("uBAqlvEfwlNgvRq",15) == 2659526058) strcat(s, "p");
if (crc32("iYzPJwn",7) == 1742066627) strcat(s, "r");
if (crc32("seSaibaVIlKiQpe",15) == 1372634116) strcat(s, "v");
if (crc32("RyqQfNHjj",9) == 2377542490) strcat(s, "V");
if (crc32("wjESRJreMkFLhTb",15) == 1778793559) strcat(s, "i");
if (crc32("ChOkSw",6) == 992740681) strcat(s, "w");
if (crc32("pVvljqzRVIPK",12) == 2807177486) strcat(s, "n");
if (crc32("GlDnwAg",7) == 2121716091) strcat(s, "g");
    return s;
}

char *unalimentary_adjectives() {
    char *s = calloc(13);
    if (crc32("RsQiyQoszE",10) == 3744306224) strcat(s, "u");
if (crc32("CVClyPop",8) == 2681267094) strcat(s, "n");
if (crc32("XVrImQVGEgnPIm",14) == 1387845773) strcat(s, "P");
if (crc32("zIuBxAg",7) == 2639939553) strcat(s, "a");
if (crc32("GHaXWlIX",8) == 1024663704) strcat(s, "k");
if (crc32("RqAWqubEWM",10) == 1364445977) strcat(s, "l");
if (crc32("udtuXImDNOa",11) == 2344950867) strcat(s, "X");
if (crc32("iYcmvAxZRS",10) == 2838214964) strcat(s, "i");
if (crc32("tKkZr",5) == 1018752801) strcat(s, "m");
if (crc32("jZnkDGui",8) == 570642202) strcat(s, "Z");
if (crc32("OHqcjAXv",8) == 307237898) strcat(s, "e");
if (crc32("BAVthR",6) == 541515223) strcat(s, "V");
if (crc32("XdGHZUCVQ",9) == 363076260) strcat(s, "n");
if (crc32("TLSquLaPtAgXgPg",15) == 325066150) strcat(s, "g");
if (crc32("aonrzGoNAZ",10) == 3675525385) strcat(s, "t");
if (crc32("ynUbF",5) == 1260057672) strcat(s, "a");
if (crc32("OYqBxXjjtBohol",14) == 3843099948) strcat(s, "S");
if (crc32("SfFwBCBAIongEoN",15) == 855262502) strcat(s, "r");
if (crc32("oSDovMEHuBCAgF",14) == 3117322100) strcat(s, "y");
    return s;
}

char *halfMuslim_adjectives() {
    char *s = calloc(11);
    if (crc32("yKEdLpk",7) == 129627838) strcat(s, "n");
if (crc32("szoUw",5) == 922020969) strcat(s, "h");
if (crc32("XXjpElvLI",9) == 1878487940) strcat(s, "a");
if (crc32("EkTha",5) == 1177708075) strcat(s, "l");
if (crc32("JmCAzBrwRZFYB",13) == 45349767) strcat(s, "f");
if (crc32("BjJnm",5) == 100317321) strcat(s, "M");
if (crc32("lQBOKglrjKEDV",13) == 97893456) strcat(s, "u");
if (crc32("gJwgg",5) == 2974651223) strcat(s, "u");
if (crc32("jyKOeDRTlt",10) == 3726697153) strcat(s, "s");
if (crc32("CXVbbEDy",8) == 2979873098) strcat(s, "l");
if (crc32("gslICLGF",8) == 2566911860) strcat(s, "i");
if (crc32("VgEIkaULEb",10) == 3001818963) strcat(s, "m");
    return s;
}

char *peristomal_adjectives() {
    char *s = calloc(11);
    if (crc32("hhESXjZhJUGDBIU",15) == 1480388575) strcat(s, "S");
if (crc32("oGFxhImNos",10) == 1619354518) strcat(s, "p");
if (crc32("EpHgjA",6) == 2591327727) strcat(s, "e");
if (crc32("NksqYoUuwDtn",12) == 3181997732) strcat(s, "M");
if (crc32("hwtpwNEJZnE",11) == 1893657008) strcat(s, "r");
if (crc32("bKuSMzcPxRD",11) == 1830675161) strcat(s, "G");
if (crc32("hpApjIxwL",9) == 886339255) strcat(s, "i");
if (crc32("ieaFEgOx",8) == 2944313795) strcat(s, "s");
if (crc32("BdQfOwAMQx",10) == 2750590884) strcat(s, "H");
if (crc32("dpeHRLNPqjPg",12) == 2590032385) strcat(s, "t");
if (crc32("UgSJgtCpmMKQJ",13) == 12382127) strcat(s, "o");
if (crc32("RzoJrGqyQxX",11) == 2491544915) strcat(s, "g");
if (crc32("NyMDwFjKAHp",11) == 290185682) strcat(s, "m");
if (crc32("isyDvlxcCKmqG",13) == 1732286942) strcat(s, "r");
if (crc32("CXOWfSBya",9) == 1551963838) strcat(s, "a");
if (crc32("lgrfdCoT",8) == 3021244313) strcat(s, "l");
    return s;
}

char *subjective_adjectives() {
    char *s = calloc(11);
    if (crc32("SoniQD",6) == 4233555548) strcat(s, "U");
if (crc32("ZpgkCouGDf",10) == 1709052230) strcat(s, "s");
if (crc32("sqGvPYaxTP",10) == 1998644096) strcat(s, "T");
if (crc32("xtBPUZpNf",9) == 2431379301) strcat(s, "u");
if (crc32("dhhABjKDlVX",11) == 3255045651) strcat(s, "b");
if (crc32("LXQeAgMQll",10) == 2296267527) strcat(s, "j");
if (crc32("MqYZBobzKD",10) == 4070298418) strcat(s, "P");
if (crc32("hYmNvr",6) == 339787866) strcat(s, "e");
if (crc32("zUrVjie",7) == 3920560208) strcat(s, "r");
if (crc32("aJGlISNZzgxe",12) == 3402540260) strcat(s, "c");
if (crc32("KigiBQwH",8) == 1932698657) strcat(s, "x");
if (crc32("rjfBttVSKpYIDq",14) == 2463122029) strcat(s, "t");
if (crc32("TqcwU",5) == 3923535580) strcat(s, "i");
if (crc32("KzwcOMeA",8) == 857474639) strcat(s, "v");
if (crc32("CmTXwOx",7) == 3286877678) strcat(s, "j");
if (crc32("UtIxWgjnwADUqw",14) == 3991784956) strcat(s, "e");
    return s;
}

char *openandshut_adjectives() {
    char *s = calloc(12);
    if (crc32("ZnMQdlQrjUCf",12) == 2873204715) strcat(s, "h");
if (crc32("nAlurpKjLGSpWHn",15) == 3208647565) strcat(s, "o");
if (crc32("vbkAJil",7) == 395581617) strcat(s, "p");
if (crc32("VOjPwIPbL",9) == 68814332) strcat(s, "p");
if (crc32("aOFcDXt",7) == 3793392375) strcat(s, "e");
if (crc32("mDUSGHo",7) == 1526167639) strcat(s, "n");
if (crc32("HHDnONblelqoeXp",15) == 1093726975) strcat(s, "a");
if (crc32("mPZSA",5) == 2649464756) strcat(s, "n");
if (crc32("NGTsNYnWM",9) == 1731527568) strcat(s, "d");
if (crc32("TqvfMhSrWvxg",12) == 3016001853) strcat(s, "S");
if (crc32("hVjZJP",6) == 3061537925) strcat(s, "s");
if (crc32("buMsmrmbjRa",11) == 4126159173) strcat(s, "e");
if (crc32("oJHTbHI",7) == 508453490) strcat(s, "h");
if (crc32("vcdkEzRXbW",10) == 3988488308) strcat(s, "u");
if (crc32("qWppGWluhFioVx",14) == 4054016309) strcat(s, "x");
if (crc32("JJHFczqO",8) == 2836311886) strcat(s, "t");
    return s;
}

char *nonimitating_adjectives() {
    char *s = calloc(13);
    if (crc32("hOxmPonIyL",10) == 608672523) strcat(s, "G");
if (crc32("nKdVWPrM",8) == 3984262326) strcat(s, "n");
if (crc32("pvZcyHndNAt",11) == 316950721) strcat(s, "Y");
if (crc32("PNaULLAWfiXj",12) == 4036018218) strcat(s, "o");
if (crc32("rDUJqz",6) == 1567741171) strcat(s, "n");
if (crc32("SLyCYQaxWCg",11) == 1053689056) strcat(s, "c");
if (crc32("nbuDZUo",7) == 1568119036) strcat(s, "i");
if (crc32("ZlJJRKLXfOAhDEI",15) == 1173529618) strcat(s, "m");
if (crc32("bKzxWwZE",8) == 2474481034) strcat(s, "i");
if (crc32("TWclSxL",7) == 1770396847) strcat(s, "V");
if (crc32("tPQyBr",6) == 1303848752) strcat(s, "t");
if (crc32("RjjhcSIKuEi",11) == 2235297958) strcat(s, "a");
if (crc32("MFheLCfo",8) == 3600632359) strcat(s, "x");
if (crc32("fgretSH",7) == 1433938532) strcat(s, "t");
if (crc32("ZXkSUDE",7) == 184301374) strcat(s, "a");
if (crc32("HaCtObJCbwSJy",13) == 1240991036) strcat(s, "i");
if (crc32("HIXYNb",6) == 2813870871) strcat(s, "n");
if (crc32("qzvreCDSghdKIS",14) == 2854824561) strcat(s, "f");
if (crc32("TJeBPW",6) == 80505910) strcat(s, "g");
    return s;
}

char *interstreet_adjectives() {
    char *s = calloc(12);
    if (crc32("HAcNQOghxhNi",12) == 3406496564) strcat(s, "m");
if (crc32("lqBuA",5) == 1777209267) strcat(s, "i");
if (crc32("wANipHZaJqoAd",13) == 3117453099) strcat(s, "Q");
if (crc32("yIwBJtOBNxdIwC",14) == 3469098599) strcat(s, "n");
if (crc32("egZngkerjdo",11) == 3831428527) strcat(s, "C");
if (crc32("hbFxLru",7) == 1574419540) strcat(s, "t");
if (crc32("BRhAT",5) == 1974473550) strcat(s, "V");
if (crc32("TVcMG",5) == 36265578) strcat(s, "e");
if (crc32("GlOSgSx",7) == 2451430106) strcat(s, "b");
if (crc32("RZUmiRJxGakptsU",15) == 2414570936) strcat(s, "r");
if (crc32("HDjiSP",6) == 742789528) strcat(s, "n");
if (crc32("dbJljTUONLEQ",12) == 3901685179) strcat(s, "s");
if (crc32("XVTGLAbtufG",11) == 3627272071) strcat(s, "t");
if (crc32("cryLTs",6) == 3302771868) strcat(s, "r");
if (crc32("gAwLL",5) == 3162509439) strcat(s, "e");
if (crc32("ZcguAicM",8) == 1472419601) strcat(s, "t");
if (crc32("kryGoRIYBjtPGw",14) == 437981383) strcat(s, "e");
if (crc32("oxQdejmXiBOkEo",14) == 1133035077) strcat(s, "b");
if (crc32("eBVQGdoGSg",10) == 418707876) strcat(s, "t");
    return s;
}

char *secernent_adjectives() {
    char *s = calloc(10);
    if (crc32("futUJPH",7) == 1641357228) strcat(s, "s");
if (crc32("tbowvs",6) == 1292616803) strcat(s, "B");
if (crc32("KDNCwYeVX",9) == 2958779821) strcat(s, "e");
if (crc32("MZjJQpgBbGhUw",13) == 820953211) strcat(s, "Y");
if (crc32("aaElbzteY",9) == 1725982328) strcat(s, "c");
if (crc32("CIgqtA",6) == 4269383283) strcat(s, "y");
if (crc32("MVSQbGtObp",10) == 3761726875) strcat(s, "e");
if (crc32("FOVSKXPSbu",10) == 877037940) strcat(s, "Z");
if (crc32("ujtHMAZvlG",10) == 1714481683) strcat(s, "r");
if (crc32("tEsegUCtPWOcgu",14) == 4130658839) strcat(s, "U");
if (crc32("rFfuSTalaKPXv",13) == 624438049) strcat(s, "n");
if (crc32("aVBfQVbfkFsOf",13) == 3161747520) strcat(s, "e");
if (crc32("bAMsy",5) == 1408307542) strcat(s, "n");
if (crc32("rFDaIWuSCarNh",13) == 4262371658) strcat(s, "B");
if (crc32("JcDhnhrWQEMbhYD",15) == 799180067) strcat(s, "t");
    return s;
}

char *screwpropelled_adjectives() {
    char *s = calloc(15);
    if (crc32("RAkuzbLU",8) == 775767344) strcat(s, "J");
if (crc32("xTJEXJ",6) == 4256419748) strcat(s, "s");
if (crc32("RTunaMK",7) == 3107883721) strcat(s, "c");
if (crc32("kVEotWAkVzV",11) == 1596625217) strcat(s, "V");
if (crc32("hEiZOSeJPsl",11) == 2091762911) strcat(s, "r");
if (crc32("UzFSA",5) == 1430048836) strcat(s, "S");
if (crc32("CkSfxekzvTX",11) == 3602167423) strcat(s, "e");
if (crc32("uXJwHaN",7) == 3024197804) strcat(s, "w");
if (crc32("NTqLeuAk",8) == 3188900384) strcat(s, "p");
if (crc32("rABoidJFNES",11) == 1627502433) strcat(s, "r");
if (crc32("MEIMtpvZVSrI",12) == 907625103) strcat(s, "M");
if (crc32("BFEdh",5) == 1858597687) strcat(s, "o");
if (crc32("CYCTwi",6) == 3486357390) strcat(s, "R");
if (crc32("PmlVjOuPlX",10) == 3751444835) strcat(s, "p");
if (crc32("AXybRAp",7) == 1448842140) strcat(s, "q");
if (crc32("yiZceYDD",8) == 832923502) strcat(s, "e");
if (crc32("pwxbpXtP",8) == 2105276874) strcat(s, "h");
if (crc32("NQKMTr",6) == 3580388651) strcat(s, "l");
if (crc32("zIXsGevZFsQHGsX",15) == 3364757680) strcat(s, "E");
if (crc32("yeCsEXecqazqgzd",15) == 2191343820) strcat(s, "l");
if (crc32("JQAoNCnuGedMBBB",15) == 2391150430) strcat(s, "e");
if (crc32("lOSfKNZiat",10) == 1355882889) strcat(s, "d");
    return s;
}

char *erumpent_adjectives() {
    char *s = calloc(9);
    if (crc32("XOxXXx",6) == 2042108834) strcat(s, "O");
if (crc32("LPvuDWtwDSZoX",13) == 1382537258) strcat(s, "e");
if (crc32("suwywv",6) == 2039890353) strcat(s, "r");
if (crc32("XKfsUyosWfDmFN",14) == 2360579826) strcat(s, "u");
if (crc32("kCPvywHI",8) == 582136369) strcat(s, "e");
if (crc32("RjTTTFxa",8) == 3930116132) strcat(s, "m");
if (crc32("xpGHjUHTbR",10) == 472661473) strcat(s, "p");
if (crc32("ZQpBvUTE",8) == 379088318) strcat(s, "M");
if (crc32("aLMlNUQyqJyv",12) == 1385956858) strcat(s, "e");
if (crc32("EHcjCUIFAyfiSns",15) == 4259062649) strcat(s, "P");
if (crc32("sKkTcDZzgHVjYMj",15) == 1504711076) strcat(s, "n");
if (crc32("gSaYCRn",7) == 460032393) strcat(s, "t");
    return s;
}

char *noncruciform_adjectives() {
    char *s = calloc(13);
    if (crc32("bjjqLCjx",8) == 3609534584) strcat(s, "n");
if (crc32("wLfeltlvEHpULZf",15) == 4025450877) strcat(s, "t");
if (crc32("PWJeO",5) == 722453560) strcat(s, "o");
if (crc32("pJNDQFu",7) == 3342870186) strcat(s, "n");
if (crc32("kvyaDFqBsnDLZg",14) == 4236376166) strcat(s, "c");
if (crc32("yCTSai",6) == 3641185529) strcat(s, "M");
if (crc32("VMmQUZMaQooldN",14) == 2999672153) strcat(s, "r");
if (crc32("cqeZQFOJr",9) == 2546950326) strcat(s, "g");
if (crc32("zmeeTzqWmnYH",12) == 1150297783) strcat(s, "u");
if (crc32("WQuGOvlfyzRGCw",14) == 427435757) strcat(s, "c");
if (crc32("UfUdcGILuYYTwB",14) == 3027646554) strcat(s, "Y");
if (crc32("LRCZCbBW",8) == 2710003376) strcat(s, "i");
if (crc32("OmNPMUORCJBC",12) == 4141724898) strcat(s, "f");
if (crc32("hlWBVk",6) == 2275642658) strcat(s, "A");
if (crc32("rLlyJSLvbBTS",12) == 2462174995) strcat(s, "o");
if (crc32("KJHvjVeCHSHnt",13) == 2649611983) strcat(s, "d");
if (crc32("cbZwKFcsF",9) == 3234549977) strcat(s, "r");
if (crc32("xlmWnLZkxlTvuX",14) == 1497099283) strcat(s, "m");
    return s;
}

char *selfsoothed_adjectives() {
    char *s = calloc(12);
    if (crc32("XZxExTG",7) == 962979801) strcat(s, "q");
if (crc32("mZqrJXGABpngjZH",15) == 3615156611) strcat(s, "s");
if (crc32("ANLkOIJ",7) == 4145191386) strcat(s, "e");
if (crc32("LELjYHoL",8) == 4088926573) strcat(s, "l");
if (crc32("AvaVxXp",7) == 2430262884) strcat(s, "f");
if (crc32("WAqULkalA",9) == 1314700966) strcat(s, "S");
if (crc32("UMSBzFPYPtqA",12) == 3965335448) strcat(s, "s");
if (crc32("QiLhLQq",7) == 2844151888) strcat(s, "o");
if (crc32("SNwFLWQjkAHwE",13) == 3092804325) strcat(s, "o");
if (crc32("PLHFrAacUHRne",13) == 516961550) strcat(s, "A");
if (crc32("xGoMzEVnKCyNJxY",15) == 3583990567) strcat(s, "t");
if (crc32("kgWuvwgGWOp",11) == 596837792) strcat(s, "h");
if (crc32("AojMMgYx",8) == 1314591951) strcat(s, "T");
if (crc32("YZTyh",5) == 2175801560) strcat(s, "e");
if (crc32("alDArkWSWcimQY",14) == 879416353) strcat(s, "Z");
if (crc32("NShMYemWEy",10) == 1892632912) strcat(s, "d");
    return s;
}

char *florid_adjectives() {
    char *s = calloc(7);
    if (crc32("MJsVhMXFeCH",11) == 4117246792) strcat(s, "f");
if (crc32("iFpTDvRWAtnlFn",14) == 3444905232) strcat(s, "Z");
if (crc32("TeNTyvFJTELHp",13) == 2368508391) strcat(s, "l");
if (crc32("ICwhFXZogd",10) == 785168212) strcat(s, "o");
if (crc32("BkfPwv",6) == 3059347919) strcat(s, "r");
if (crc32("AzvCu",5) == 208948107) strcat(s, "i");
if (crc32("hoPLkdDkhrCiPCx",15) == 1462819052) strcat(s, "d");
    return s;
}

char *unskilled_adjectives() {
    char *s = calloc(10);
    if (crc32("EpLgYgxZbRtPy",13) == 1350474711) strcat(s, "M");
if (crc32("ecnPWJDNupzivAj",15) == 2911589327) strcat(s, "u");
if (crc32("SQfxiSaLaXlb",12) == 376550193) strcat(s, "n");
if (crc32("fPxtcveuJTm",11) == 4082895084) strcat(s, "s");
if (crc32("vKUUZpmMhr",10) == 1575439975) strcat(s, "Q");
if (crc32("EYWoRCWmA",9) == 1421666076) strcat(s, "k");
if (crc32("rcAWcnLmtf",10) == 2712725065) strcat(s, "i");
if (crc32("HApCsOEtbSvuS",13) == 3818262428) strcat(s, "p");
if (crc32("WYLlpyaVZoDaLL",14) == 1283129329) strcat(s, "l");
if (crc32("gtxntsvjneJN",12) == 2471094784) strcat(s, "e");
if (crc32("kzFodYaK",8) == 672748185) strcat(s, "l");
if (crc32("uviku",5) == 1110592077) strcat(s, "v");
if (crc32("fDIHDW",6) == 999503604) strcat(s, "e");
if (crc32("oqCtIygrz",9) == 1139564603) strcat(s, "d");
    return s;
}

char *internalcombustion_adjectives() {
    char *s = calloc(19);
    if (crc32("qaKZTCihK",9) == 2012646068) strcat(s, "z");
if (crc32("PiLTwKCeaBGVz",13) == 2934717476) strcat(s, "i");
if (crc32("BGtRUPWXvnbW",12) == 1735667678) strcat(s, "K");
if (crc32("sQEKzpcovKpNanY",15) == 3584488983) strcat(s, "n");
if (crc32("GXOaobEOGq",10) == 3116899096) strcat(s, "T");
if (crc32("SvhdpQ",6) == 3478481425) strcat(s, "t");
if (crc32("BtlgSNJ",7) == 2993814499) strcat(s, "e");
if (crc32("tVRaf",5) == 2467923257) strcat(s, "r");
if (crc32("bSblpUZNiVrNlPb",15) == 3809279354) strcat(s, "B");
if (crc32("LbnImVxyiEzZ",12) == 2370971833) strcat(s, "n");
if (crc32("JrOHJJqNn",9) == 1705071177) strcat(s, "a");
if (crc32("tfKth",5) == 883034749) strcat(s, "z");
if (crc32("kvCZLAU",7) == 4188425081) strcat(s, "l");
if (crc32("qYtGKbgrkwyaRZf",15) == 1256256166) strcat(s, "c");
if (crc32("dmikogNhinVxIc",14) == 533127035) strcat(s, "o");
if (crc32("jEaQjWMsGiHkGD",14) == 2061316783) strcat(s, "V");
if (crc32("hdfppJmiU",9) == 1411225661) strcat(s, "m");
if (crc32("VdNWGxuuwJz",11) == 2328206073) strcat(s, "b");
if (crc32("yraBcJiqIyN",11) == 2132438424) strcat(s, "u");
if (crc32("lTMzQeWyXosRK",13) == 999843759) strcat(s, "s");
if (crc32("zyteFgD",7) == 1326165365) strcat(s, "S");
if (crc32("BoMPaXhAel",10) == 1943870826) strcat(s, "t");
if (crc32("kjHWFp",6) == 3238453390) strcat(s, "i");
if (crc32("VPgcRrPO",8) == 1953793186) strcat(s, "o");
if (crc32("VITFkSuWvI",10) == 3877646939) strcat(s, "P");
if (crc32("dQrVQTGVJF",10) == 21303516) strcat(s, "n");
    return s;
}

char *unscattered_adjectives() {
    char *s = calloc(12);
    if (crc32("lZAgAjWA",8) == 404514251) strcat(s, "u");
if (crc32("YrEjJdzMKIvpHRT",15) == 2499076866) strcat(s, "n");
if (crc32("LDPzoYUIsJ",10) == 611220129) strcat(s, "s");
if (crc32("ApzFrEWfcyK",11) == 28230483) strcat(s, "Z");
if (crc32("XQCXlOXcqfBt",12) == 1159948318) strcat(s, "c");
if (crc32("YBqfJEQTGsuyyC",14) == 1811179240) strcat(s, "a");
if (crc32("DXNvzqZGwdeGn",13) == 3514452330) strcat(s, "y");
if (crc32("HvllXnF",7) == 481232335) strcat(s, "t");
if (crc32("nMtuCIVC",8) == 3250793128) strcat(s, "j");
if (crc32("AlhoQsOW",8) == 2486075251) strcat(s, "t");
if (crc32("IXObQWW",7) == 2317737501) strcat(s, "e");
if (crc32("PGCQoSuOJR",10) == 555418170) strcat(s, "i");
if (crc32("SsvxVXymedPOB",13) == 937529273) strcat(s, "r");
if (crc32("vHtjXaVjhtuN",12) == 800671885) strcat(s, "Q");
if (crc32("XLGkETNOILztw",13) == 1220988603) strcat(s, "e");
if (crc32("HyqdyJmTI",9) == 2023074345) strcat(s, "d");
    return s;
}

char *billowy_adjectives() {
    char *s = calloc(8);
    if (crc32("QhdYUgyi",8) == 2571761459) strcat(s, "b");
if (crc32("sJRZUehaDJx",11) == 151936980) strcat(s, "T");
if (crc32("jRzCnHZgDVsOxn",14) == 737786034) strcat(s, "i");
if (crc32("GnwPN",5) == 1453336367) strcat(s, "F");
if (crc32("lDVfGjwBu",9) == 1660411676) strcat(s, "l");
if (crc32("zozaeCDjtAH",11) == 1159563276) strcat(s, "l");
if (crc32("cSCNInz",7) == 2509495376) strcat(s, "m");
if (crc32("izDkXrjRXr",10) == 462866767) strcat(s, "o");
if (crc32("DbRYGWc",7) == 3361119474) strcat(s, "w");
if (crc32("btFll",5) == 953556049) strcat(s, "y");
    return s;
}

char *unrefutable_adjectives() {
    char *s = calloc(12);
    if (crc32("vtnnattRIT",10) == 785285142) strcat(s, "e");
if (crc32("zLEjIbPozNDfypZ",15) == 2370847994) strcat(s, "u");
if (crc32("QMnbbyXqqo",10) == 1117041582) strcat(s, "n");
if (crc32("VKHDK",5) == 922147883) strcat(s, "r");
if (crc32("xbbelfReodnCZg",14) == 105932523) strcat(s, "e");
if (crc32("ffyeRlzFEulBrWI",15) == 2724363240) strcat(s, "f");
if (crc32("BWuWdxSterIm",12) == 589511882) strcat(s, "c");
if (crc32("asfDxnWEBjlL",12) == 398348669) strcat(s, "u");
if (crc32("iNNUkfHjJFcLfLK",15) == 2584091638) strcat(s, "s");
if (crc32("maJPWn",6) == 1713369855) strcat(s, "t");
if (crc32("xsnXmjWsFV",10) == 1506789739) strcat(s, "a");
if (crc32("KacJhkGnztHw",12) == 3309919116) strcat(s, "b");
if (crc32("PLHexdmmYWhY",12) == 870888875) strcat(s, "F");
if (crc32("OrdPLvjMidyH",12) == 1119793855) strcat(s, "l");
if (crc32("bnecNk",6) == 330596643) strcat(s, "C");
if (crc32("crWuMjIUNNw",11) == 1569881288) strcat(s, "e");
    return s;
}

char *noncultural_adjectives() {
    char *s = calloc(12);
    if (crc32("KTimhBpH",8) == 1386354446) strcat(s, "n");
if (crc32("OymlaPApGFSal",13) == 2300966737) strcat(s, "o");
if (crc32("RoAhe",5) == 904037990) strcat(s, "e");
if (crc32("BrkCiXmeLWCiJDq",15) == 2706532060) strcat(s, "n");
if (crc32("QebewfkQQfuIwwk",15) == 491399530) strcat(s, "c");
if (crc32("yKpKPjAWmUdF",12) == 2108434618) strcat(s, "K");
if (crc32("XYVLdzCuosL",11) == 1031819428) strcat(s, "u");
if (crc32("JKYOocr",7) == 1571573342) strcat(s, "l");
if (crc32("ZJdrOMx",7) == 2034367404) strcat(s, "t");
if (crc32("jizacvZYwhPfoq",14) == 1980579927) strcat(s, "X");
if (crc32("ILTBGxN",7) == 3418150994) strcat(s, "u");
if (crc32("FnfYxaEWb",9) == 3222964307) strcat(s, "R");
if (crc32("WqGAGPMWKqQRfQ",14) == 1871934699) strcat(s, "r");
if (crc32("azfFCDAseuqRW",13) == 959030354) strcat(s, "a");
if (crc32("EcmjiHjvXWnMXz",14) == 785541834) strcat(s, "l");
    return s;
}

char *precartilaginous_adjectives() {
    char *s = calloc(17);
    if (crc32("KWLloruhoqj",11) == 1454939112) strcat(s, "p");
if (crc32("agVmvD",6) == 4291134965) strcat(s, "r");
if (crc32("lJzeqJeIJcACST",14) == 3634727367) strcat(s, "e");
if (crc32("zbAbs",5) == 200343215) strcat(s, "c");
if (crc32("QopXHrsJzlieG",13) == 3459000074) strcat(s, "d");
if (crc32("ZSJfBsWhrhL",11) == 1362472576) strcat(s, "a");
if (crc32("hOjunkoeEmrbsO",14) == 783025471) strcat(s, "r");
if (crc32("MBBlQppnDQwD",12) == 1260811193) strcat(s, "t");
if (crc32("IgTais",6) == 2239482832) strcat(s, "y");
if (crc32("LYWeZEP",7) == 885247092) strcat(s, "i");
if (crc32("XaXeglNJPZCt",12) == 4227598546) strcat(s, "l");
if (crc32("poVCKLdj",8) == 2361828004) strcat(s, "Q");
if (crc32("VqtvCt",6) == 2545551868) strcat(s, "a");
if (crc32("ElKwow",6) == 2424746154) strcat(s, "J");
if (crc32("pPzuaBklanqyU",13) == 2622822534) strcat(s, "g");
if (crc32("lAiFAIrnez",10) == 3003451923) strcat(s, "i");
if (crc32("pAYCpeqJZxVZfqS",15) == 3087639629) strcat(s, "W");
if (crc32("UkLtUVzzbPNE",12) == 1425456818) strcat(s, "n");
if (crc32("PcVUfseTVeVeyKw",15) == 4074844784) strcat(s, "N");
if (crc32("WNEVVddKI",9) == 1351421891) strcat(s, "o");
if (crc32("QshLnfTGQERl",12) == 4034554913) strcat(s, "A");
if (crc32("Optvinw",7) == 336739449) strcat(s, "u");
if (crc32("OwkOrn",6) == 618448913) strcat(s, "s");
    return s;
}

char *noncelestial_adjectives() {
    char *s = calloc(13);
    if (crc32("xUUsrC",6) == 4277685363) strcat(s, "n");
if (crc32("ORQrZy",6) == 2031475190) strcat(s, "n");
if (crc32("NjOUIICX",8) == 1606254823) strcat(s, "o");
if (crc32("NqOcCI",6) == 496032544) strcat(s, "n");
if (crc32("qUQNBB",6) == 3592610848) strcat(s, "L");
if (crc32("VnjKezByCdV",11) == 1064208360) strcat(s, "c");
if (crc32("ssNYKAEU",8) == 3878337372) strcat(s, "E");
if (crc32("tQFNacEDNFUde",13) == 4100830385) strcat(s, "e");
if (crc32("yhaUyhEQugQQZ",13) == 2388677021) strcat(s, "l");
if (crc32("TZZeJ",5) == 1084878298) strcat(s, "e");
if (crc32("xZzfV",5) == 226347397) strcat(s, "C");
if (crc32("OJgexEKWBH",10) == 753609883) strcat(s, "s");
if (crc32("XHZfvfGqCDNT",12) == 3365437509) strcat(s, "n");
if (crc32("oTSfepWSQkTfwhG",15) == 3067126583) strcat(s, "t");
if (crc32("QXLeWOv",7) == 1906388810) strcat(s, "M");
if (crc32("EZsOXHvlAoxSY",13) == 1837295117) strcat(s, "i");
if (crc32("OsNiywVGSikIFLA",15) == 2362617189) strcat(s, "v");
if (crc32("kFqpl",5) == 2830622786) strcat(s, "a");
if (crc32("UuHfiHRZfIQwzva",15) == 860510290) strcat(s, "l");
    return s;
}

char *quadrangled_adjectives() {
    char *s = calloc(12);
    if (crc32("KSjkvoqfIAsmRFv",15) == 539584333) strcat(s, "q");
if (crc32("mIykFujFPPm",11) == 3072611815) strcat(s, "u");
if (crc32("sjsMPMceosDiVv",14) == 1830143041) strcat(s, "a");
if (crc32("UoIeEpvwVE",10) == 1124171661) strcat(s, "o");
if (crc32("PUKhyXaieYVmK",13) == 4080887067) strcat(s, "d");
if (crc32("LGpfIDdPtEd",11) == 2571164171) strcat(s, "F");
if (crc32("XNvBBaYZvkOyo",13) == 1015649514) strcat(s, "r");
if (crc32("uiIiUnJjZDlOU",13) == 1659616018) strcat(s, "a");
if (crc32("utqWjjaqX",9) == 2989205091) strcat(s, "n");
if (crc32("dGRRd",5) == 1199991345) strcat(s, "A");
if (crc32("SGeDWfwvzYFZh",13) == 3478343320) strcat(s, "g");
if (crc32("xaOUeIGh",8) == 2437244135) strcat(s, "A");
if (crc32("aRVjFIQfxuHYfo",14) == 1574558168) strcat(s, "l");
if (crc32("qHyNSlQjd",9) == 810276119) strcat(s, "a");
if (crc32("CqYgObqDPYSpZQb",15) == 245544995) strcat(s, "e");
if (crc32("pzwDYFdUhh",10) == 3247439189) strcat(s, "l");
if (crc32("QudDzGxKhRu",11) == 1599799317) strcat(s, "d");
    return s;
}

char *extortive_adjectives() {
    char *s = calloc(10);
    if (crc32("tynQGKOXPJQSI",13) == 996556916) strcat(s, "e");
if (crc32("nJAKYbUZGwW",11) == 3481522112) strcat(s, "d");
if (crc32("MjMgUchExfWHy",13) == 929002898) strcat(s, "x");
if (crc32("ELscf",5) == 994438561) strcat(s, "t");
if (crc32("nUYpFZWoWoT",11) == 3012586631) strcat(s, "h");
if (crc32("bmKWRNnOmxTXzP",14) == 3699636796) strcat(s, "o");
if (crc32("hazAWnlsmPyHo",13) == 2076466637) strcat(s, "p");
if (crc32("kNEKqeGe",8) == 2472418560) strcat(s, "r");
if (crc32("NUDtSKNJdOZeZf",14) == 2814754105) strcat(s, "t");
if (crc32("uopCxY",6) == 668047185) strcat(s, "H");
if (crc32("iIUVbndcaetObw",14) == 3338463898) strcat(s, "i");
if (crc32("ZoJZVIhx",8) == 1653410971) strcat(s, "v");
if (crc32("sXtauulE",8) == 397460774) strcat(s, "y");
if (crc32("agehzfcI",8) == 3472988536) strcat(s, "e");
    return s;
}

char *peppy_adjectives() {
    char *s = calloc(6);
    if (crc32("dreIHkvoMaQpfen",15) == 3196933308) strcat(s, "F");
if (crc32("oncQtwUYzWzSH",13) == 2089655049) strcat(s, "p");
if (crc32("yAcxX",5) == 2229379651) strcat(s, "z");
if (crc32("olvQmskV",8) == 1661860914) strcat(s, "e");
if (crc32("QuJBBH",6) == 2526212123) strcat(s, "E");
if (crc32("rIqyRJ",6) == 887895087) strcat(s, "p");
if (crc32("qISpfSWrkM",10) == 2435074746) strcat(s, "p");
if (crc32("eJuUvix",7) == 2640132123) strcat(s, "y");
    return s;
}

char *electrotechnical_adjectives() {
    char *s = calloc(17);
    if (crc32("xyLRW",5) == 1751562194) strcat(s, "s");
if (crc32("NwrkTBLvzHdNfi",14) == 2637723665) strcat(s, "e");
if (crc32("OXVbeXyNN",9) == 4179452251) strcat(s, "l");
if (crc32("kJJQroAh",8) == 2346644966) strcat(s, "l");
if (crc32("lnchYjswS",9) == 1660259443) strcat(s, "e");
if (crc32("yBbBFSXoVesX",12) == 2697991496) strcat(s, "F");
if (crc32("WvYwGGJHo",9) == 1323262996) strcat(s, "c");
if (crc32("STxYVMj",7) == 1344593741) strcat(s, "I");
if (crc32("XPlxoSljFGCGQrs",15) == 4175012585) strcat(s, "t");
if (crc32("ZdukwBhd",8) == 154994650) strcat(s, "r");
if (crc32("ZjpWZrlTVjKISDB",15) == 3544640501) strcat(s, "o");
if (crc32("ddGIDPlRkM",10) == 4105461023) strcat(s, "t");
if (crc32("nNtuN",5) == 188690583) strcat(s, "e");
if (crc32("ioYYmgRhT",9) == 3951531719) strcat(s, "c");
if (crc32("VIdEyCsDv",9) == 4149803985) strcat(s, "h");
if (crc32("qqxpwxV",7) == 2176887037) strcat(s, "n");
if (crc32("ZhMvOLn",7) == 3641549916) strcat(s, "y");
if (crc32("lKTEqMCgOhzz",12) == 2153092274) strcat(s, "i");
if (crc32("NYNXH",5) == 3884314409) strcat(s, "c");
if (crc32("eNdnt",5) == 1249464710) strcat(s, "W");
if (crc32("AusIohaU",8) == 2759206289) strcat(s, "a");
if (crc32("CmEPFeEsi",9) == 1286339743) strcat(s, "P");
if (crc32("UOqGu",5) == 1069720027) strcat(s, "l");
    return s;
}

char *selfafflicting_adjectives() {
    char *s = calloc(15);
    if (crc32("PFjAsDDObvCZJ",13) == 3236800470) strcat(s, "b");
if (crc32("pjIUlp",6) == 2084859381) strcat(s, "s");
if (crc32("gXyIISwok",9) == 3377366495) strcat(s, "v");
if (crc32("ZIBPRaLTYsFDF",13) == 3242073589) strcat(s, "e");
if (crc32("ngVaJUqL",8) == 757327792) strcat(s, "I");
if (crc32("UsXME",5) == 1855275915) strcat(s, "l");
if (crc32("IsCuKAZwHLP",11) == 2537435819) strcat(s, "f");
if (crc32("MTzlwDss",8) == 3124676240) strcat(s, "a");
if (crc32("fIYENTybfm",10) == 3021551781) strcat(s, "f");
if (crc32("cNFJmPEtCSm",11) == 1979660197) strcat(s, "f");
if (crc32("RGCAgytX",8) == 191206701) strcat(s, "E");
if (crc32("nRIQprRFaHzMY",13) == 1469825413) strcat(s, "l");
if (crc32("ZceicFb",7) == 3428567369) strcat(s, "i");
if (crc32("tFOXbLjFhVmDcFy",15) == 984785176) strcat(s, "c");
if (crc32("gxIOju",6) == 3947673869) strcat(s, "g");
if (crc32("uDXzGZaYc",9) == 4091398947) strcat(s, "t");
if (crc32("GeiSqp",6) == 3166204577) strcat(s, "i");
if (crc32("kknLjUbJBPf",11) == 1048199476) strcat(s, "Q");
if (crc32("HSNhjnZN",8) == 3600124559) strcat(s, "n");
if (crc32("CbGTcd",6) == 2995095169) strcat(s, "g");
    return s;
}

char *pinkish_adjectives() {
    char *s = calloc(8);
    if (crc32("ieQFnrlFd",9) == 3110824400) strcat(s, "p");
if (crc32("CCZFWM",6) == 174920690) strcat(s, "p");
if (crc32("zEkdtGueUxjMUS",14) == 74791526) strcat(s, "i");
if (crc32("ZHtjiscHq",9) == 3505965105) strcat(s, "g");
if (crc32("DvYQKUUAlR",10) == 1818478877) strcat(s, "n");
if (crc32("LxMIesIhglpiXI",14) == 1991412890) strcat(s, "H");
if (crc32("WBnmqFvwIzapzTt",15) == 3452868614) strcat(s, "k");
if (crc32("CHlvlyvYQQEkOX",14) == 1127468794) strcat(s, "i");
if (crc32("CSEiah",6) == 2482931542) strcat(s, "s");
if (crc32("RcxYpCkNiKxDD",13) == 1286793850) strcat(s, "e");
if (crc32("AuIztrEqOCFX",12) == 3803635743) strcat(s, "h");
    return s;
}

char *subacid_adjectives() {
    char *s = calloc(8);
    if (crc32("SodGhUMGg",9) == 2290383262) strcat(s, "s");
if (crc32("MIiuZdz",7) == 2286831638) strcat(s, "u");
if (crc32("cjlznR",6) == 726109488) strcat(s, "E");
if (crc32("illibPAlfnRRl",13) == 146120022) strcat(s, "b");
if (crc32("aGiVPZKF",8) == 1181976301) strcat(s, "a");
if (crc32("ZouoRTfPM",9) == 3078421735) strcat(s, "c");
if (crc32("jUzAh",5) == 2930734907) strcat(s, "J");
if (crc32("AuNId",5) == 3996133261) strcat(s, "i");
if (crc32("SbPQFk",6) == 3126685413) strcat(s, "m");
if (crc32("sGXVHuTnU",9) == 2033863272) strcat(s, "d");
    return s;
}

char *nonpublic_adjectives() {
    char *s = calloc(10);
    if (crc32("lRzhbgJOdc",10) == 1774277795) strcat(s, "G");
if (crc32("eJYjikorwJOk",12) == 1766779938) strcat(s, "n");
if (crc32("THknkgcEtG",10) == 3421873286) strcat(s, "J");
if (crc32("focYcIYKcpYBWNw",15) == 35672693) strcat(s, "o");
if (crc32("lviSZgG",7) == 3578371913) strcat(s, "Q");
if (crc32("YXDCFIy",7) == 2472230012) strcat(s, "n");
if (crc32("rAEikjSgHJ",10) == 4141905915) strcat(s, "a");
if (crc32("HmBTQIAv",8) == 2798034365) strcat(s, "p");
if (crc32("LvzKrQdg",8) == 1929359540) strcat(s, "L");
if (crc32("NGzFkSwBzN",10) == 528714322) strcat(s, "u");
if (crc32("CMCIum",6) == 3443810806) strcat(s, "A");
if (crc32("BwJKeKGVg",9) == 1647953235) strcat(s, "b");
if (crc32("DgPwoKGvqu",10) == 2789561111) strcat(s, "l");
if (crc32("yNaYxaYhlwmyR",13) == 2698995357) strcat(s, "l");
if (crc32("gcjNtlxnw",9) == 2292495046) strcat(s, "i");
if (crc32("eAFULkBefDsAnG",14) == 4012213519) strcat(s, "c");
    return s;
}

char *unriveted_adjectives() {
    char *s = calloc(10);
    if (crc32("rkKOkRqMwFGu",12) == 2441370497) strcat(s, "l");
if (crc32("gQlkSew",7) == 475756445) strcat(s, "u");
if (crc32("TapDR",5) == 3875444679) strcat(s, "H");
if (crc32("nYOKWRVIC",9) == 2725592028) strcat(s, "n");
if (crc32("eEmsnhoCG",9) == 2046937419) strcat(s, "V");
if (crc32("slKyIuqePc",10) == 2740910209) strcat(s, "r");
if (crc32("WbsPdxFgpKEG",12) == 662938360) strcat(s, "B");
if (crc32("KzxrT",5) == 3329124812) strcat(s, "i");
if (crc32("fwRTaQct",8) == 2082156773) strcat(s, "x");
if (crc32("ANNfpXFMMihGyWZ",15) == 1707498123) strcat(s, "v");
if (crc32("jVOxRIqWoDxBN",13) == 2602850959) strcat(s, "Q");
if (crc32("nGlLlXdsWzKK",12) == 4058935492) strcat(s, "e");
if (crc32("UmKEhs",6) == 1373894969) strcat(s, "Y");
if (crc32("WsewDQEMVwuDt",13) == 1924421082) strcat(s, "t");
if (crc32("iyKEQOOv",8) == 3758815598) strcat(s, "e");
if (crc32("InQEGSrEMMfxiU",14) == 4249602279) strcat(s, "d");
    return s;
}

char *Haligonian_adjectives() {
    char *s = calloc(11);
    if (crc32("KPunTcbKdi",10) == 1495863441) strcat(s, "H");
if (crc32("zAmCqopgEd",10) == 3480218925) strcat(s, "a");
if (crc32("BtvpWvpiM",9) == 395265694) strcat(s, "E");
if (crc32("PgJgEtDNoXn",11) == 2051768426) strcat(s, "l");
if (crc32("MDoarqYvQZdSOv",14) == 2543401290) strcat(s, "m");
if (crc32("GLgzBwQaBEdGq",13) == 729901228) strcat(s, "i");
if (crc32("rSuGxcrXKj",10) == 459612101) strcat(s, "g");
if (crc32("yJHqZrsISrdzfvq",15) == 2457804141) strcat(s, "G");
if (crc32("lkiEnIoe",8) == 2939170793) strcat(s, "o");
if (crc32("WCGxjyzTfX",10) == 3339707084) strcat(s, "n");
if (crc32("iIrYvV",6) == 750946171) strcat(s, "N");
if (crc32("mOxIHwppswloIF",14) == 3968740679) strcat(s, "i");
if (crc32("choYIFowIGVRW",13) == 1453852738) strcat(s, "x");
if (crc32("KbscekElHAevQ",13) == 1577543276) strcat(s, "a");
if (crc32("jOgqnPoBJ",9) == 2874453056) strcat(s, "n");
    return s;
}

char *pupilless_adjectives() {
    char *s = calloc(10);
    if (crc32("tMaDIC",6) == 3145016208) strcat(s, "p");
if (crc32("pUaygBRXQcMNr",13) == 3383774078) strcat(s, "B");
if (crc32("ZDvFxVB",7) == 1748816117) strcat(s, "u");
if (crc32("dyHZVkC",7) == 39894820) strcat(s, "z");
if (crc32("ONmIfgh",7) == 3092035105) strcat(s, "p");
if (crc32("JteOoEwWXJGrrZ",14) == 212359133) strcat(s, "i");
if (crc32("LpgnEkwGQcLdn",13) == 1713724996) strcat(s, "l");
if (crc32("UstzaBnzef",10) == 2528531532) strcat(s, "K");
if (crc32("rpiqvnWSfEj",11) == 692372879) strcat(s, "l");
if (crc32("xAuaIYSUlvHAsbr",15) == 3887102724) strcat(s, "p");
if (crc32("eOgygNKjPF",10) == 2832377407) strcat(s, "e");
if (crc32("AuJXcYgJLh",10) == 4288349446) strcat(s, "s");
if (crc32("QYGBVBxH",8) == 2014609956) strcat(s, "s");
    return s;
}

char *cibarial_adjectives() {
    char *s = calloc(9);
    if (crc32("kqLTgVcGXw",10) == 3323637635) strcat(s, "c");
if (crc32("XMpGKgcmuD",10) == 733569883) strcat(s, "q");
if (crc32("YWzCOzkBZj",10) == 3350028052) strcat(s, "i");
if (crc32("sBLsThEHlzyC",12) == 2349870394) strcat(s, "b");
if (crc32("oJPGtvCf",8) == 2708156517) strcat(s, "a");
if (crc32("eCHvIAlSrlUr",12) == 2806866417) strcat(s, "r");
if (crc32("ynQdzhc",7) == 1719203063) strcat(s, "G");
if (crc32("DlMjFfBKqzfO",12) == 2238776288) strcat(s, "i");
if (crc32("oHuJSsuRLY",10) == 3945627704) strcat(s, "a");
if (crc32("GKLZkTiQAUMDj",13) == 3013079957) strcat(s, "n");
if (crc32("LQrznBEJk",9) == 668332462) strcat(s, "l");
    return s;
}

char *apical_adjectives() {
    char *s = calloc(7);
    if (crc32("abWXzHNHQxxZadm",15) == 378600716) strcat(s, "v");
if (crc32("SYVimWSIAhpD",12) == 1049499471) strcat(s, "a");
if (crc32("axcifTMLzwPs",12) == 2407749295) strcat(s, "p");
if (crc32("nlaigKt",7) == 3536994269) strcat(s, "i");
if (crc32("qgjBiDx",7) == 530746938) strcat(s, "Z");
if (crc32("PdHTzxyJO",9) == 2319274538) strcat(s, "c");
if (crc32("xXZInRajlG",10) == 275526188) strcat(s, "c");
if (crc32("CXkrIimB",8) == 3668976591) strcat(s, "a");
if (crc32("eYFTfQvt",8) == 695934783) strcat(s, "Z");
if (crc32("mlwmDlBOCXUnyI",14) == 2406653383) strcat(s, "l");
    return s;
}

char *original_adjectives() {
    char *s = calloc(9);
    if (crc32("UsDRZfTgn",9) == 2331784852) strcat(s, "o");
if (crc32("YjCRQCizdDwED",13) == 2505592912) strcat(s, "Q");
if (crc32("QQJaTC",6) == 4292677054) strcat(s, "r");
if (crc32("SUrjkgyNLzIk",12) == 2032751442) strcat(s, "i");
if (crc32("yWPPfNQOxrWq",12) == 2833603290) strcat(s, "u");
if (crc32("IihisYFcrRFmKLv",15) == 3302774907) strcat(s, "g");
if (crc32("GjpxbMQBMjPFMZp",15) == 1323468262) strcat(s, "S");
if (crc32("uJIroyBmWN",10) == 3986679559) strcat(s, "i");
if (crc32("MgWbEkF",7) == 3652895124) strcat(s, "n");
if (crc32("zeeOrtxeYzmXkn",14) == 3920998090) strcat(s, "a");
if (crc32("OSJkuKgi",8) == 4185883975) strcat(s, "l");
    return s;
}

char *unsatirical_adjectives() {
    char *s = calloc(12);
    if (crc32("ruAHRQjz",8) == 1698388871) strcat(s, "b");
if (crc32("CMdoF",5) == 2181801301) strcat(s, "u");
if (crc32("EJoafLC",7) == 1109883873) strcat(s, "n");
if (crc32("gJeKZkoWP",9) == 2581138969) strcat(s, "s");
if (crc32("JTItnNZRuvI",11) == 2605236709) strcat(s, "T");
if (crc32("HfflWnlm",8) == 462152090) strcat(s, "a");
if (crc32("DWokOx",6) == 2713752402) strcat(s, "t");
if (crc32("hdqmPcscM",9) == 1965014238) strcat(s, "v");
if (crc32("HmjuJuslbDqJO",13) == 3219450006) strcat(s, "i");
if (crc32("iEPuZxQReMgykPp",15) == 1729289778) strcat(s, "r");
if (crc32("yDGnYKtvmnIasc",14) == 4249034306) strcat(s, "i");
if (crc32("pazxVzHD",8) == 2179299030) strcat(s, "N");
if (crc32("kCDZFGe",7) == 1646597003) strcat(s, "c");
if (crc32("OjBkwM",6) == 2176979101) strcat(s, "a");
if (crc32("nFViEIr",7) == 2293744836) strcat(s, "n");
if (crc32("Bqgdqjhj",8) == 2873544687) strcat(s, "l");
    return s;
}

char *gentlemanly_adjectives() {
    char *s = calloc(12);
    if (crc32("dvHJS",5) == 2696996581) strcat(s, "d");
if (crc32("qGhntzqlree",11) == 2137807971) strcat(s, "g");
if (crc32("TvFQFe",6) == 414564383) strcat(s, "e");
if (crc32("rUInvHF",7) == 1201859548) strcat(s, "H");
if (crc32("ifMMMOtKkUtzsXm",15) == 2731281796) strcat(s, "n");
if (crc32("dbuCtRlT",8) == 1195241052) strcat(s, "t");
if (crc32("rqJUZLk",7) == 804416735) strcat(s, "l");
if (crc32("RuzdhFr",7) == 304414264) strcat(s, "Z");
if (crc32("lyKZZ",5) == 1005776210) strcat(s, "e");
if (crc32("bWuDxiYIDxdipl",14) == 1497338429) strcat(s, "m");
if (crc32("YXJsPFiBEfm",11) == 2194313400) strcat(s, "a");
if (crc32("qnWiC",5) == 2473725697) strcat(s, "T");
if (crc32("BgNoI",5) == 3582008600) strcat(s, "n");
if (crc32("XFEqKnaa",8) == 387061703) strcat(s, "l");
if (crc32("tqJgUVMRSftg",12) == 1931374898) strcat(s, "y");
    return s;
}

char *rodded_adjectives() {
    char *s = calloc(7);
    if (crc32("zHjCj",5) == 1160512577) strcat(s, "J");
if (crc32("VvYnvbBtVTPR",12) == 3984442794) strcat(s, "r");
if (crc32("tIWFi",5) == 1595941805) strcat(s, "x");
if (crc32("lUMpJeHOfN",10) == 919618568) strcat(s, "o");
if (crc32("pvsuqtXCuwbnXb",14) == 2128306717) strcat(s, "h");
if (crc32("JWcYDfZfTsw",11) == 2297344612) strcat(s, "d");
if (crc32("DPFpVaw",7) == 1201432557) strcat(s, "d");
if (crc32("fTpai",5) == 2286290511) strcat(s, "e");
if (crc32("mrQsnQHZiEY",11) == 486986991) strcat(s, "x");
if (crc32("KWTwf",5) == 281085038) strcat(s, "d");
    return s;
}

char *adorable_adjectives() {
    char *s = calloc(9);
    if (crc32("gGHKzd",6) == 369783976) strcat(s, "o");
if (crc32("QXYQwbDjQdy",11) == 4012178279) strcat(s, "a");
if (crc32("MZuUiXVEc",9) == 1144951529) strcat(s, "d");
if (crc32("ZGncxZodML",10) == 3257205482) strcat(s, "U");
if (crc32("jcBVDezkWjjQK",13) == 3055689804) strcat(s, "o");
if (crc32("WUuvwBwbte",10) == 3610439731) strcat(s, "X");
if (crc32("ZBYXUuw",7) == 2512244064) strcat(s, "r");
if (crc32("DDZnfrKo",8) == 1948147279) strcat(s, "a");
if (crc32("cgkSeG",6) == 1917780991) strcat(s, "I");
if (crc32("DJOaeHezr",9) == 2255765927) strcat(s, "b");
if (crc32("pOlSxOITvTom",12) == 1184800068) strcat(s, "l");
if (crc32("rKQmePH",7) == 3281760331) strcat(s, "e");
    return s;
}

char *allogamous_adjectives() {
    char *s = calloc(11);
    if (crc32("EpHMNhUarZDshZ",14) == 2184944867) strcat(s, "a");
if (crc32("fnJVkxfJYIVcpqR",15) == 1121990492) strcat(s, "l");
if (crc32("rwLDqTBNkCd",11) == 501010468) strcat(s, "l");
if (crc32("zAqNCsmwnKiclh",14) == 4159223930) strcat(s, "o");
if (crc32("lYCilRMu",8) == 850767257) strcat(s, "g");
if (crc32("AJshmm",6) == 3147539815) strcat(s, "a");
if (crc32("cyNKumVQbQ",10) == 229834983) strcat(s, "m");
if (crc32("NqDXYenEsqE",11) == 4044795860) strcat(s, "o");
if (crc32("pHSfzVJgD",9) == 2951406655) strcat(s, "A");
if (crc32("OwpZbfgboFuxG",13) == 34248762) strcat(s, "u");
if (crc32("vBVuxfssnGS",11) == 3991472240) strcat(s, "f");
if (crc32("iaAgajp",7) == 92989426) strcat(s, "s");
    return s;
}

char *unassisting_adjectives() {
    char *s = calloc(12);
    if (crc32("MxLGwv",6) == 3064550631) strcat(s, "u");
if (crc32("EPxIYtCLkRLInKR",15) == 3620329222) strcat(s, "D");
if (crc32("boNnFtaF",8) == 2543624125) strcat(s, "n");
if (crc32("oNJBoU",6) == 3513829856) strcat(s, "a");
if (crc32("CrazgI",6) == 1146884986) strcat(s, "s");
if (crc32("BIgOsMZ",7) == 1933973791) strcat(s, "k");
if (crc32("oPkxDOz",7) == 483904350) strcat(s, "s");
if (crc32("GYtEdaMp",8) == 404005152) strcat(s, "i");
if (crc32("bwUbPAjCQPKdKcD",15) == 1417272159) strcat(s, "s");
if (crc32("qHCEVqUeMEt",11) == 2171657557) strcat(s, "t");
if (crc32("JgsfydSJblAcuca",15) == 4106742469) strcat(s, "i");
if (crc32("TdAFFZNdHg",10) == 3839320003) strcat(s, "n");
if (crc32("aIYqDEPBmoi",11) == 2118914924) strcat(s, "b");
if (crc32("zBvzKRoNbszu",12) == 1236087692) strcat(s, "g");
    return s;
}

char *multifistulous_adjectives() {
    char *s = calloc(15);
    if (crc32("SqUIUKJTLpjbeP",14) == 3381891870) strcat(s, "d");
if (crc32("PTwxJl",6) == 2454186862) strcat(s, "m");
if (crc32("OhRmJVle",8) == 1697270925) strcat(s, "u");
if (crc32("pqzVtNKlPT",10) == 597419923) strcat(s, "l");
if (crc32("AsqbsqzEWzZno",13) == 3831113250) strcat(s, "G");
if (crc32("yYkVKufTRT",10) == 1065173233) strcat(s, "t");
if (crc32("pIYtRihSYtifxXD",15) == 1403125571) strcat(s, "i");
if (crc32("TDDawxLmJ",9) == 1964613012) strcat(s, "J");
if (crc32("cpWTlOfbGKUx",12) == 1158385051) strcat(s, "f");
if (crc32("TAmrYpLCjCTSiF",14) == 2532185944) strcat(s, "i");
if (crc32("YSMDgwOLu",9) == 2296067930) strcat(s, "s");
if (crc32("FTCKzebGtDDQIej",15) == 2730961415) strcat(s, "t");
if (crc32("qJFMHwTasUIih",13) == 414125669) strcat(s, "W");
if (crc32("LXULwQCcZ",9) == 3739936710) strcat(s, "u");
if (crc32("PITBrQ",6) == 3736807457) strcat(s, "l");
if (crc32("gqkKFQ",6) == 1531318750) strcat(s, "y");
if (crc32("dyoeSoTD",8) == 3579220202) strcat(s, "o");
if (crc32("IUgSvNATZK",10) == 2718729899) strcat(s, "u");
if (crc32("OcSzG",5) == 3293683588) strcat(s, "D");
if (crc32("lvVqJqAYyrayLmN",15) == 3474057024) strcat(s, "s");
    return s;
}

char *unfemale_adjectives() {
    char *s = calloc(9);
    if (crc32("uIaYv",5) == 2315656214) strcat(s, "u");
if (crc32("cOMaf",5) == 2075276019) strcat(s, "n");
if (crc32("azVEgoYJvMqsEQ",14) == 1193700651) strcat(s, "f");
if (crc32("cCZVCYpYTDwK",12) == 2692314812) strcat(s, "U");
if (crc32("JgoVGEjz",8) == 2194653283) strcat(s, "e");
if (crc32("KxRWKNaZcJSPWl",14) == 3443487000) strcat(s, "m");
if (crc32("qjBlibuq",8) == 1234870823) strcat(s, "k");
if (crc32("NfqlNrUGDsV",11) == 112979049) strcat(s, "a");
if (crc32("oEUzuijEg",9) == 1072698477) strcat(s, "e");
if (crc32("rVeOrbxB",8) == 3164168291) strcat(s, "l");
if (crc32("pERroUss",8) == 3644395465) strcat(s, "e");
    return s;
}

char *underbeaten_adjectives() {
    char *s = calloc(12);
    if (crc32("ZFodsuhKkiU",11) == 1036863423) strcat(s, "u");
if (crc32("wSJDSjXMEqfQ",12) == 2724079252) strcat(s, "n");
if (crc32("mnbetE",6) == 2977713061) strcat(s, "d");
if (crc32("mYATbp",6) == 1581930462) strcat(s, "b");
if (crc32("tvIgcCPohze",11) == 2956779947) strcat(s, "e");
if (crc32("EmsdCcmZZxFgL",13) == 2768329146) strcat(s, "r");
if (crc32("TqsnSE",6) == 1317826797) strcat(s, "b");
if (crc32("IZkeUIRKbY",10) == 1665250906) strcat(s, "e");
if (crc32("mgehHqykHvzXR",13) == 136515758) strcat(s, "o");
if (crc32("HMdPVYRoqTQTHSG",15) == 3440202077) strcat(s, "a");
if (crc32("SharWRBfMkDfdiB",15) == 3426112105) strcat(s, "e");
if (crc32("pXCVzvswhb",10) == 3252272311) strcat(s, "t");
if (crc32("OSqsR",5) == 293437507) strcat(s, "e");
if (crc32("lhslHjp",7) == 2920601792) strcat(s, "N");
if (crc32("luOSGZxFudbNJ",13) == 2114072572) strcat(s, "n");
    return s;
}

char *nonfictitious_adjectives() {
    char *s = calloc(14);
    if (crc32("YLxZxlUPY",9) == 1316043286) strcat(s, "n");
if (crc32("nHLnyOLkTuH",11) == 2930713450) strcat(s, "o");
if (crc32("NBDiQt",6) == 3192381026) strcat(s, "h");
if (crc32("uFIAalYk",8) == 2562971244) strcat(s, "n");
if (crc32("swIgejJY",8) == 1022251102) strcat(s, "f");
if (crc32("ZewQXlxTaNyVOM",14) == 3661788816) strcat(s, "g");
if (crc32("dADqRQUw",8) == 2253603008) strcat(s, "i");
if (crc32("LJUnOQSfEypLXh",14) == 720047929) strcat(s, "c");
if (crc32("KASvlsHZ",8) == 2608395132) strcat(s, "t");
if (crc32("mdNXmnEepLMysHb",15) == 920909850) strcat(s, "i");
if (crc32("KXRtBGxgRZ",10) == 186485272) strcat(s, "t");
if (crc32("oOAneTqvIf",10) == 1875647054) strcat(s, "i");
if (crc32("erdNHIPeTIU",11) == 3212288351) strcat(s, "o");
if (crc32("SoTdoytpzHlZsM",14) == 2079738354) strcat(s, "Z");
if (crc32("xpHcPNYXII",10) == 2815245672) strcat(s, "u");
if (crc32("pZrQXwvXgWtL",12) == 3604210677) strcat(s, "A");
if (crc32("xetRZdtaUxc",11) == 1623632279) strcat(s, "s");
    return s;
}

char *nonerratic_adjectives() {
    char *s = calloc(11);
    if (crc32("THQCASbxoRpTwr",14) == 4068918872) strcat(s, "n");
if (crc32("AgBWvNLSIPfF",12) == 2048572885) strcat(s, "o");
if (crc32("kIGeiBwkDt",10) == 2454903016) strcat(s, "H");
if (crc32("irbBCXVWlgRAA",13) == 2440356386) strcat(s, "n");
if (crc32("szHMzpLGnl",10) == 2471309868) strcat(s, "l");
if (crc32("txUuCWxR",8) == 2099192948) strcat(s, "e");
if (crc32("cswQlSQ",7) == 3600705979) strcat(s, "Y");
if (crc32("QmKCxOlBEDtOd",13) == 2995975606) strcat(s, "r");
if (crc32("tGRmcFOvEoU",11) == 580590894) strcat(s, "B");
if (crc32("iNfVVgBart",10) == 1292187055) strcat(s, "r");
if (crc32("NRAMFN",6) == 856041524) strcat(s, "t");
if (crc32("gloozkTWNtW",11) == 647552072) strcat(s, "a");
if (crc32("nDdMW",5) == 189818808) strcat(s, "t");
if (crc32("rlwQAUKV",8) == 857059446) strcat(s, "j");
if (crc32("wVtgIcS",7) == 120511969) strcat(s, "i");
if (crc32("JniSTPfFUJVHp",13) == 1228651376) strcat(s, "v");
if (crc32("oYvaCjiHFPHO",12) == 1359191405) strcat(s, "c");
    return s;
}

char *nonclose_adjectives() {
    char *s = calloc(9);
    if (crc32("bobWAODPytONeYm",15) == 822928281) strcat(s, "n");
if (crc32("NEutbs",6) == 2237506567) strcat(s, "o");
if (crc32("csODO",5) == 1753934095) strcat(s, "n");
if (crc32("TtclSkvKpjD",11) == 3953424737) strcat(s, "Y");
if (crc32("sGjesCzPwE",10) == 1085378178) strcat(s, "c");
if (crc32("RtacostYi",9) == 2307449491) strcat(s, "W");
if (crc32("kBxjnZoHeQgTfU",14) == 2976382569) strcat(s, "l");
if (crc32("ribxFAhR",8) == 1964245031) strcat(s, "w");
if (crc32("CxhilYRsGwou",12) == 292791643) strcat(s, "o");
if (crc32("rCeYikd",7) == 55589161) strcat(s, "s");
if (crc32("HsGePh",6) == 1572237004) strcat(s, "e");
    return s;
}

char *submaxillary_adjectives() {
    char *s = calloc(13);
    if (crc32("seWgGI",6) == 3336367289) strcat(s, "s");
if (crc32("XtdSyCZOmXVMD",13) == 35786108) strcat(s, "q");
if (crc32("uZMkbplBC",9) == 1001266498) strcat(s, "u");
if (crc32("xXRfcM",6) == 3870487150) strcat(s, "c");
if (crc32("tSpLweLaFpPys",13) == 4017319804) strcat(s, "b");
if (crc32("eODoxPaBVDjQQ",13) == 1597016363) strcat(s, "e");
if (crc32("byVITLYn",8) == 4256463510) strcat(s, "m");
if (crc32("xLSBTGetCx",10) == 269593745) strcat(s, "S");
if (crc32("XjJEgpampmf",11) == 1302391674) strcat(s, "a");
if (crc32("tuRjr",5) == 2359373040) strcat(s, "C");
if (crc32("yPFHwSabikNAr",13) == 3472942723) strcat(s, "x");
if (crc32("JtiMjjknB",9) == 3116048296) strcat(s, "e");
if (crc32("tkMasCWMLUbwt",13) == 689788967) strcat(s, "i");
if (crc32("xvhmudSuCLdkje",14) == 2505554972) strcat(s, "l");
if (crc32("HfEjVbt",7) == 2393653024) strcat(s, "L");
if (crc32("qPHBAj",6) == 538210162) strcat(s, "l");
if (crc32("QQfynuFUHPOiG",13) == 1103987443) strcat(s, "a");
if (crc32("aNZdk",5) == 501171119) strcat(s, "Y");
if (crc32("BFXucVuJJNOPUoT",15) == 3161700082) strcat(s, "r");
if (crc32("DnIvqF",6) == 1691681946) strcat(s, "m");
if (crc32("rgYBo",5) == 2683228025) strcat(s, "y");
    return s;
}

char *semielevated_adjectives() {
    char *s = calloc(13);
    if (crc32("WWgGXCJins",10) == 2342567415) strcat(s, "s");
if (crc32("ixVNEOgqklChx",13) == 1087331987) strcat(s, "e");
if (crc32("GYFDjSAzLoLuf",13) == 3290899548) strcat(s, "S");
if (crc32("CDLzZsyPjCqNI",13) == 3747113058) strcat(s, "m");
if (crc32("AnGBBNWsogHmVc",14) == 4173313255) strcat(s, "n");
if (crc32("AyDtSwGl",8) == 306490559) strcat(s, "i");
if (crc32("ZjKhYgmjZkRcMDA",15) == 2182890607) strcat(s, "b");
if (crc32("bYQDvPfRzOagl",13) == 3329209487) strcat(s, "e");
if (crc32("alVWjT",6) == 1512675739) strcat(s, "l");
if (crc32("tokXQlAB",8) == 3849823863) strcat(s, "N");
if (crc32("AENdBeOV",8) == 1160692515) strcat(s, "e");
if (crc32("GHqaAr",6) == 115572805) strcat(s, "v");
if (crc32("mAtpeJXNvHlN",12) == 4071348218) strcat(s, "T");
if (crc32("mXWAXixItSBFt",13) == 4200598324) strcat(s, "a");
if (crc32("zwYYRtnjf",9) == 1939792964) strcat(s, "E");
if (crc32("ormeKFGKIpxWH",13) == 4241294364) strcat(s, "t");
if (crc32("wYXnCRJw",8) == 2437670447) strcat(s, "e");
if (crc32("ZUZeLFvdRdRd",12) == 2233932803) strcat(s, "Q");
if (crc32("iCgwvczYomK",11) == 3714969690) strcat(s, "d");
    return s;
}

char *sublaryngal_adjectives() {
    char *s = calloc(12);
    if (crc32("BjpucTqXZc",10) == 3300455423) strcat(s, "s");
if (crc32("nABeEE",6) == 303442258) strcat(s, "u");
if (crc32("RqJVxDdH",8) == 2166368578) strcat(s, "b");
if (crc32("QNukPoHyZePOhRT",15) == 2620960691) strcat(s, "l");
if (crc32("WyTLbStSDKgo",12) == 4135661327) strcat(s, "m");
if (crc32("KsvSieyK",8) == 2036104006) strcat(s, "a");
if (crc32("JkAHnzpgzDpObk",14) == 2380970504) strcat(s, "Q");
if (crc32("MFsZujlQyXrjTPS",15) == 2391580618) strcat(s, "r");
if (crc32("RFKppFyKdQwhKu",14) == 242194262) strcat(s, "y");
if (crc32("DxKjE",5) == 931786280) strcat(s, "D");
if (crc32("FivauU",6) == 3001625457) strcat(s, "n");
if (crc32("rVjwvhswAM",10) == 3315119975) strcat(s, "g");
if (crc32("xLRKUpk",7) == 2879382991) strcat(s, "a");
if (crc32("YhKYLRfZVJpb",12) == 68995027) strcat(s, "w");
if (crc32("dNqvRd",6) == 2227782475) strcat(s, "l");
    return s;
}

char *hypercivilized_adjectives() {
    char *s = calloc(15);
    if (crc32("gkyKpORTDBH",11) == 1142178273) strcat(s, "v");
if (crc32("rLUOZjtEtN",10) == 2964969738) strcat(s, "h");
if (crc32("JxDaKiBQnzoVNJ",14) == 174471966) strcat(s, "y");
if (crc32("qFqLxZoZmHQxyO",14) == 3219651141) strcat(s, "q");
if (crc32("YhHIr",5) == 3968515439) strcat(s, "p");
if (crc32("HBdWKNyHf",9) == 355480689) strcat(s, "e");
if (crc32("CjzVPuYwCuWmz",13) == 4287812789) strcat(s, "u");
if (crc32("FdExITeKhV",10) == 1971642157) strcat(s, "r");
if (crc32("zjDsH",5) == 4220812568) strcat(s, "h");
if (crc32("kLDJczehHqjudB",14) == 4122935407) strcat(s, "c");
if (crc32("NVVkziTKOJgQk",13) == 539719652) strcat(s, "i");
if (crc32("lEbcFhgSHjs",11) == 2439776973) strcat(s, "U");
if (crc32("CHsUr",5) == 2829175390) strcat(s, "v");
if (crc32("mZzHM",5) == 3162027589) strcat(s, "s");
if (crc32("TJseFUpcQEF",11) == 2940969899) strcat(s, "i");
if (crc32("zOOrji",6) == 2346212446) strcat(s, "k");
if (crc32("VjFcdNmJ",8) == 1445244821) strcat(s, "l");
if (crc32("JbuFG",5) == 3244387467) strcat(s, "l");
if (crc32("YaDOQXHGO",9) == 1189819128) strcat(s, "i");
if (crc32("SQQrLGeu",8) == 3810248483) strcat(s, "z");
if (crc32("choRoJkaKSdaro",14) == 3817507080) strcat(s, "e");
if (crc32("JouUpCWBzwltY",13) == 929146535) strcat(s, "K");
if (crc32("QxyIdkA",7) == 627935054) strcat(s, "d");
    return s;
}

char *darkish_adjectives() {
    char *s = calloc(8);
    if (crc32("vDqbNgUzbKHQm",13) == 2589589299) strcat(s, "d");
if (crc32("vceyMUgxr",9) == 2259839937) strcat(s, "a");
if (crc32("lmxgHvnKFWYMj",13) == 3788318370) strcat(s, "r");
if (crc32("cwJkekZTUH",10) == 3126947471) strcat(s, "k");
if (crc32("QjCYJSVfagXMKd",14) == 1615561233) strcat(s, "Z");
if (crc32("fazbNs",6) == 588910242) strcat(s, "i");
if (crc32("erXKUOvWpv",10) == 3896381258) strcat(s, "H");
if (crc32("tTyNOy",6) == 3739833073) strcat(s, "s");
if (crc32("ekPky",5) == 3099273830) strcat(s, "h");
    return s;
}

char *nonemotive_adjectives() {
    char *s = calloc(11);
    if (crc32("SXFWRf",6) == 3362495391) strcat(s, "n");
if (crc32("RuwGVjXlgapAn",13) == 3779781883) strcat(s, "o");
if (crc32("kFkybIpzxW",10) == 2736466611) strcat(s, "n");
if (crc32("UsHpIIVk",8) == 275473225) strcat(s, "e");
if (crc32("RHJszrgmFt",10) == 3321177069) strcat(s, "E");
if (crc32("JZjsDgBspkUT",12) == 2938650706) strcat(s, "m");
if (crc32("vrkGXkbhSAUYXZ",14) == 1753513641) strcat(s, "o");
if (crc32("cjzTqyKqnVi",11) == 2894629334) strcat(s, "l");
if (crc32("VATvEjuOnYz",11) == 462195547) strcat(s, "t");
if (crc32("UAvHeJ",6) == 910974282) strcat(s, "i");
if (crc32("PvrDioCOeLuYjji",15) == 1994575936) strcat(s, "v");
if (crc32("gRSolgJdGn",10) == 2163229621) strcat(s, "H");
if (crc32("AAkHKCmWkMQhk",13) == 2812818913) strcat(s, "e");
    return s;
}

char *peglike_adjectives() {
    char *s = calloc(8);
    if (crc32("FXKsumI",7) == 2826864774) strcat(s, "B");
if (crc32("OrNcH",5) == 2439250334) strcat(s, "p");
if (crc32("OhYFhADWcPlXyXq",15) == 175935489) strcat(s, "e");
if (crc32("yvrQSgJranQ",11) == 2240078924) strcat(s, "d");
if (crc32("pdJPCWyDbv",10) == 53638891) strcat(s, "g");
if (crc32("PhELQvdjysoeU",13) == 1692998187) strcat(s, "u");
if (crc32("bupDt",5) == 4005418218) strcat(s, "l");
if (crc32("SOWBLMGwjZpX",12) == 558303199) strcat(s, "s");
if (crc32("ZaDXKhP",7) == 3224092358) strcat(s, "i");
if (crc32("FinJfmJRPFUo",12) == 1349628294) strcat(s, "z");
if (crc32("IAYDW",5) == 2988353812) strcat(s, "k");
if (crc32("ZHIuWLtL",8) == 3559312788) strcat(s, "e");
    return s;
}

char *dainty_adjectives() {
    char *s = calloc(7);
    if (crc32("jbMBymJfv",9) == 277134034) strcat(s, "d");
if (crc32("gouxlqPzmOYfyWA",15) == 3449755032) strcat(s, "a");
if (crc32("WLISMJcKNSBSgfb",15) == 3850498847) strcat(s, "i");
if (crc32("iquFaVaELszs",12) == 3564416789) strcat(s, "C");
if (crc32("KfFqNMFacd",10) == 1762701517) strcat(s, "n");
if (crc32("oFPgbyFWrcbWvU",14) == 2279488204) strcat(s, "o");
if (crc32("FBzxsVMKsB",10) == 3519646280) strcat(s, "t");
if (crc32("crEjatQw",8) == 1161145243) strcat(s, "s");
if (crc32("YsCStg",6) == 1542409648) strcat(s, "y");
    return s;
}

char *grizzly_adjectives() {
    char *s = calloc(8);
    if (crc32("ObBfbdGipDjBJ",13) == 3658928063) strcat(s, "G");
if (crc32("RKVHpbvTfMhEzA",14) == 3911722674) strcat(s, "g");
if (crc32("dVoxVf",6) == 2464646993) strcat(s, "b");
if (crc32("lsJdNdhLAyymJ",13) == 3371064663) strcat(s, "r");
if (crc32("cxjJfWzMilYQzw",14) == 2157048191) strcat(s, "F");
if (crc32("unALvp",6) == 3211202637) strcat(s, "i");
if (crc32("fwIVbL",6) == 2182164496) strcat(s, "z");
if (crc32("rpSsdSQKvO",10) == 2601693269) strcat(s, "z");
if (crc32("uiAJaDrVVY",10) == 4209319468) strcat(s, "d");
if (crc32("HCkNU",5) == 377090167) strcat(s, "l");
if (crc32("dbHTQRPYajrc",12) == 3168992864) strcat(s, "g");
if (crc32("MwpLA",5) == 2572151455) strcat(s, "y");
    return s;
}

char *stickable_adjectives() {
    char *s = calloc(10);
    if (crc32("mKGogNe",7) == 2243838209) strcat(s, "s");
if (crc32("UsfcxJrCOebfjxS",15) == 4263957748) strcat(s, "t");
if (crc32("bwfXokPRQ",9) == 900347610) strcat(s, "i");
if (crc32("ojxDDMsEj",9) == 3714427896) strcat(s, "c");
if (crc32("CqsaKMTE",8) == 2087856605) strcat(s, "Z");
if (crc32("LenMilO",7) == 1638899539) strcat(s, "k");
if (crc32("KdkYSvK",7) == 3866321732) strcat(s, "a");
if (crc32("bbsloHAgYWHJC",13) == 328189983) strcat(s, "T");
if (crc32("Jcwmt",5) == 729231618) strcat(s, "b");
if (crc32("fcdreg",6) == 2576414474) strcat(s, "l");
if (crc32("ZQMqF",5) == 384432689) strcat(s, "e");
    return s;
}

char *unchapped_adjectives() {
    char *s = calloc(10);
    if (crc32("ViMRK",5) == 647941282) strcat(s, "u");
if (crc32("QtSwus",6) == 2380586059) strcat(s, "q");
if (crc32("myvnWSF",7) == 2442258698) strcat(s, "n");
if (crc32("NZmwa",5) == 2677348479) strcat(s, "c");
if (crc32("DbVUOlnVfbPCGAl",15) == 754467312) strcat(s, "C");
if (crc32("efCKpEoRGATgAbK",15) == 1761391639) strcat(s, "h");
if (crc32("cAipfwXsyyCg",12) == 3405730111) strcat(s, "a");
if (crc32("CgyQemMn",8) == 106295339) strcat(s, "p");
if (crc32("mRPaMqN",7) == 1388330681) strcat(s, "p");
if (crc32("iYNIMFkX",8) == 2192212865) strcat(s, "e");
if (crc32("tCgYYiTh",8) == 1955888130) strcat(s, "d");
    return s;
}

char *outermost_adjectives() {
    char *s = calloc(10);
    if (crc32("vfSqBAbeUbSy",12) == 803053117) strcat(s, "o");
if (crc32("YWsEMh",6) == 2288932576) strcat(s, "B");
if (crc32("KzXhN",5) == 3010210957) strcat(s, "u");
if (crc32("qVeySiNSckPZ",12) == 2507625314) strcat(s, "i");
if (crc32("isoSmfDviCLXc",13) == 1350867721) strcat(s, "t");
if (crc32("RtZooJAYkPhNt",13) == 1406146308) strcat(s, "e");
if (crc32("weDWarZ",7) == 3364971561) strcat(s, "r");
if (crc32("pHirWXi",7) == 3217990185) strcat(s, "a");
if (crc32("CvPYApym",8) == 3466777193) strcat(s, "m");
if (crc32("rrvBl",5) == 1378957491) strcat(s, "o");
if (crc32("AkAZjbtktabels",14) == 1389746691) strcat(s, "h");
if (crc32("gxpBRSChFMfAbFM",15) == 1665942080) strcat(s, "s");
if (crc32("wcXYnbSQb",9) == 3470780713) strcat(s, "t");
    return s;
}

char *basifixed_adjectives() {
    char *s = calloc(10);
    if (crc32("OLQDHTBBOkv",11) == 3576914993) strcat(s, "b");
if (crc32("CKuuREGhBZtPu",13) == 2646414840) strcat(s, "d");
if (crc32("grKRk",5) == 35967344) strcat(s, "a");
if (crc32("eWIiezCTsK",10) == 965453272) strcat(s, "j");
if (crc32("txzTjgGn",8) == 4188325564) strcat(s, "s");
if (crc32("tpOYAdTTkjV",11) == 956997740) strcat(s, "i");
if (crc32("MaKpTqL",7) == 503258524) strcat(s, "f");
if (crc32("ODpFgkejsErs",12) == 2851285353) strcat(s, "P");
if (crc32("oNqbfaYukDiU",12) == 3679434781) strcat(s, "i");
if (crc32("JYIPfzPyxEQgAiq",15) == 1303579232) strcat(s, "R");
if (crc32("eHsAm",5) == 1166461530) strcat(s, "x");
if (crc32("oDnoWqRom",9) == 514631292) strcat(s, "M");
if (crc32("RyVhhCRVZoS",11) == 2940441212) strcat(s, "e");
if (crc32("qsRaUhvFQU",10) == 2292058108) strcat(s, "W");
if (crc32("KDocyqISouuLu",13) == 2445281480) strcat(s, "d");
    return s;
}

char *shortwinded_adjectives() {
    char *s = calloc(12);
    if (crc32("xpluuD",6) == 3148500864) strcat(s, "i");
if (crc32("sUenkCeDc",9) == 2959088083) strcat(s, "s");
if (crc32("HhMhVRFbcH",10) == 3700081902) strcat(s, "K");
if (crc32("aBVwoUzNZIpi",12) == 2469944126) strcat(s, "h");
if (crc32("NKjpWrmKFaak",12) == 2402902407) strcat(s, "o");
if (crc32("UhsRwIIjYHHRFm",14) == 3455006440) strcat(s, "r");
if (crc32("CCDrBI",6) == 2836487199) strcat(s, "t");
if (crc32("uqcWTFxg",8) == 3415645103) strcat(s, "w");
if (crc32("RnzvROnEc",9) == 1543089906) strcat(s, "v");
if (crc32("rsUCoROBZORn",12) == 4027265171) strcat(s, "i");
if (crc32("ByAQHLIgfjl",11) == 3568977611) strcat(s, "n");
if (crc32("IvMvEBeAbHzCYGC",15) == 1616149563) strcat(s, "P");
if (crc32("rOTKv",5) == 1192872050) strcat(s, "d");
if (crc32("gXXOSrfAsfa",11) == 1128235439) strcat(s, "W");
if (crc32("ywBwSDMF",8) == 2194898034) strcat(s, "e");
if (crc32("DWNZDliwllXmzB",14) == 3559759465) strcat(s, "M");
if (crc32("AWTLbnTZoXjpkD",14) == 2343698651) strcat(s, "d");
    return s;
}

char *calorimetric_adjectives() {
    char *s = calloc(13);
    if (crc32("ffRhVe",6) == 3076841507) strcat(s, "e");
if (crc32("MOhkc",5) == 2973776792) strcat(s, "c");
if (crc32("LNuuG",5) == 3357580896) strcat(s, "a");
if (crc32("BCRXrIiwYQt",11) == 3065695540) strcat(s, "E");
if (crc32("rxjzSwyJEUWI",12) == 2755839954) strcat(s, "l");
if (crc32("lPeHlNm",7) == 3467785437) strcat(s, "o");
if (crc32("KXrGWjB",7) == 3495902440) strcat(s, "r");
if (crc32("cWxrwoubYExJ",12) == 2627393190) strcat(s, "i");
if (crc32("wDbIEp",6) == 4145697123) strcat(s, "X");
if (crc32("FKhKbzGStvxm",12) == 417987028) strcat(s, "m");
if (crc32("eNuhdYWLcGxYafx",15) == 2601004808) strcat(s, "e");
if (crc32("CLCameAOuZQLe",13) == 3295033941) strcat(s, "o");
if (crc32("JZrdsnZbxz",10) == 260302843) strcat(s, "t");
if (crc32("dNwRtDeGRPoOJXn",15) == 2923280362) strcat(s, "u");
if (crc32("wZMgwWeyk",9) == 4054386311) strcat(s, "r");
if (crc32("ByjOSylkALVpUqu",15) == 1638712751) strcat(s, "i");
if (crc32("lzJdkXgtX",9) == 2448446909) strcat(s, "c");
    return s;
}

char *hypanthial_adjectives() {
    char *s = calloc(11);
    if (crc32("jkwKQi",6) == 3953558574) strcat(s, "h");
if (crc32("mexMcuGledYV",12) == 681632696) strcat(s, "l");
if (crc32("CvQOZA",6) == 124037868) strcat(s, "y");
if (crc32("DJuIEYE",7) == 1331413823) strcat(s, "p");
if (crc32("gTShYUxtW",9) == 2247896085) strcat(s, "n");
if (crc32("CrXbTOpcg",9) == 2104897967) strcat(s, "a");
if (crc32("hrbOCIt",7) == 1196781440) strcat(s, "n");
if (crc32("WxPLWluOovzBA",13) == 1679236309) strcat(s, "l");
if (crc32("dpTFnkCepCS",11) == 1784255375) strcat(s, "t");
if (crc32("bzBYCHLYXC",10) == 339903033) strcat(s, "n");
if (crc32("PMENvybbTi",10) == 427214283) strcat(s, "h");
if (crc32("oWYrSjEMYXcx",12) == 620733827) strcat(s, "i");
if (crc32("ZzwmoUM",7) == 3521703643) strcat(s, "z");
if (crc32("fVBwKlxXA",9) == 3892507065) strcat(s, "a");
if (crc32("GZpXef",6) == 3142511090) strcat(s, "u");
if (crc32("XcjzOiQvFHjCPr",14) == 2986900026) strcat(s, "l");
    return s;
}

char *ultrared_adjectives() {
    char *s = calloc(9);
    if (crc32("XnJMGVq",7) == 4150436289) strcat(s, "b");
if (crc32("GpmIBYLjyKuxSi",14) == 3783032123) strcat(s, "u");
if (crc32("ZKTaxQvri",9) == 1919712301) strcat(s, "A");
if (crc32("vzreynaMlrZ",11) == 2340277652) strcat(s, "l");
if (crc32("mBgIoMnfO",9) == 2739570804) strcat(s, "t");
if (crc32("dnRovjhCA",9) == 2295464387) strcat(s, "m");
if (crc32("NnSPiAbwkiUqYg",14) == 613625001) strcat(s, "r");
if (crc32("OKwMhAlYjVNQ",12) == 309914400) strcat(s, "a");
if (crc32("YDetMTYoHUZvAlg",15) == 1160958369) strcat(s, "r");
if (crc32("hzBqolgJt",9) == 1430021974) strcat(s, "e");
if (crc32("tobQkmueodLR",12) == 894338237) strcat(s, "V");
if (crc32("gJPpIpOT",8) == 52497668) strcat(s, "d");
    return s;
}

char *unsweltering_adjectives() {
    char *s = calloc(13);
    if (crc32("zgckdqpiemSEYmv",15) == 1744022175) strcat(s, "T");
if (crc32("KiCJHPYFKFNfn",13) == 187469653) strcat(s, "u");
if (crc32("sPjuE",5) == 2265828319) strcat(s, "d");
if (crc32("TYUcwomnPCJNyz",14) == 3633899483) strcat(s, "n");
if (crc32("SqMjcaFcE",9) == 551952740) strcat(s, "s");
if (crc32("AOSLbTtC",8) == 370002263) strcat(s, "z");
if (crc32("VmxZugrSKSIrU",13) == 3827184584) strcat(s, "w");
if (crc32("HyCkhG",6) == 783568274) strcat(s, "e");
if (crc32("avKADoglNhoDQe",14) == 2096696818) strcat(s, "O");
if (crc32("VTEpCtsS",8) == 2879360696) strcat(s, "l");
if (crc32("FoBvIfuGYLTwBj",14) == 1866323173) strcat(s, "t");
if (crc32("MduAMRgSklM",11) == 1224680010) strcat(s, "u");
if (crc32("OJMdSPhHPeQD",12) == 1146527717) strcat(s, "e");
if (crc32("qnTxm",5) == 2686653475) strcat(s, "O");
if (crc32("bJgPxsPzASNiPH",14) == 1810299959) strcat(s, "r");
if (crc32("KPGkXNVfp",9) == 4243979526) strcat(s, "a");
if (crc32("oBkBbhrCOGOFGZa",15) == 753481503) strcat(s, "i");
if (crc32("cfCadoyGkWwAtC",14) == 1904028966) strcat(s, "r");
if (crc32("iHdqgL",6) == 1109098065) strcat(s, "n");
if (crc32("gcxuPNIdt",9) == 66226614) strcat(s, "M");
if (crc32("VDLCRvX",7) == 787477626) strcat(s, "g");
    return s;
}

char *opinionative_adjectives() {
    char *s = calloc(13);
    if (crc32("wbFVkuuvQ",9) == 1472768734) strcat(s, "w");
if (crc32("smTRmUKzheIpfS",14) == 4155198538) strcat(s, "o");
if (crc32("CeWcemOj",8) == 1121372217) strcat(s, "p");
if (crc32("SPCWJtTDG",9) == 2107531789) strcat(s, "i");
if (crc32("gCZLo",5) == 2222685237) strcat(s, "n");
if (crc32("jVecYFaA",8) == 1569240665) strcat(s, "i");
if (crc32("rrsjhZgnztirRc",14) == 785393669) strcat(s, "o");
if (crc32("hmWIIGqPgjR",11) == 519446235) strcat(s, "n");
if (crc32("hKOyrFQRwKUGfv",14) == 1574634807) strcat(s, "Q");
if (crc32("kxGBA",5) == 806026998) strcat(s, "a");
if (crc32("wGAUzJUUnVVL",12) == 157067658) strcat(s, "M");
if (crc32("krSdnUPdhnbJ",12) == 2120105270) strcat(s, "t");
if (crc32("XYtNRKUt",8) == 2947779517) strcat(s, "i");
if (crc32("EKulqEJ",7) == 3596354872) strcat(s, "y");
if (crc32("SoopqXNoajUO",12) == 2597725851) strcat(s, "v");
if (crc32("gjvIIGvb",8) == 2817350331) strcat(s, "G");
if (crc32("UpEQPsZoK",9) == 2158265380) strcat(s, "e");
    return s;
}

char *armourpiercing_adjectives() {
    char *s = calloc(15);
    if (crc32("WFkICpZrdm",10) == 4170283838) strcat(s, "a");
if (crc32("vOJuiDVGmcTieqd",15) == 2631980758) strcat(s, "r");
if (crc32("YhkvaPUkqBOok",13) == 2619049578) strcat(s, "m");
if (crc32("uXBoCNmgn",9) == 3880094796) strcat(s, "U");
if (crc32("TiGiixaKoZGmAG",14) == 4190841985) strcat(s, "o");
if (crc32("VXEfKlNs",8) == 93861055) strcat(s, "u");
if (crc32("EunRTrfyovDFIn",14) == 938814321) strcat(s, "r");
if (crc32("ndkZUyeFNZArQa",14) == 2263840140) strcat(s, "C");
if (crc32("rrBRbYKQ",8) == 222323281) strcat(s, "p");
if (crc32("QxxzcQvC",8) == 1473313857) strcat(s, "T");
if (crc32("xOxPskbEVNk",11) == 1923808552) strcat(s, "i");
if (crc32("ucgTdbQENWWI",12) == 1306704243) strcat(s, "L");
if (crc32("dVveN",5) == 2640613753) strcat(s, "e");
if (crc32("MnJgRg",6) == 4290717486) strcat(s, "q");
if (crc32("MYgzLSZmKuY",11) == 3097932433) strcat(s, "r");
if (crc32("MYWYbGDYpRVx",12) == 1464052131) strcat(s, "c");
if (crc32("gEzCEvRvJEFPPh",14) == 1871604896) strcat(s, "i");
if (crc32("HyuAzlh",7) == 2155850438) strcat(s, "w");
if (crc32("mzLuTvULwGUrT",13) == 1583082032) strcat(s, "n");
if (crc32("bWpYEHAWzmHZ",12) == 2592551793) strcat(s, "J");
if (crc32("unxcEljunWd",11) == 633970510) strcat(s, "g");
    return s;
}

char *particular_adjectives() {
    char *s = calloc(11);
    if (crc32("GRMLhUHtJBkQQhH",15) == 4028347473) strcat(s, "p");
if (crc32("tBrpKdKnXojAgM",14) == 635459) strcat(s, "l");
if (crc32("PWuKD",5) == 2565715505) strcat(s, "a");
if (crc32("JcECMOdGPNK",11) == 72091032) strcat(s, "r");
if (crc32("MoFnuNhifbwQa",13) == 3505448651) strcat(s, "K");
if (crc32("IuWRF",5) == 2984345293) strcat(s, "t");
if (crc32("AddgXZFZR",9) == 115376835) strcat(s, "F");
if (crc32("qXJQUsZGZIHs",12) == 1193398551) strcat(s, "i");
if (crc32("CIxMKHOsOT",10) == 1029983863) strcat(s, "c");
if (crc32("DwBUS",5) == 1571432297) strcat(s, "G");
if (crc32("RvGOJUaWJFv",11) == 3602149456) strcat(s, "u");
if (crc32("MwrjnYjLPKTWPex",15) == 2236449334) strcat(s, "O");
if (crc32("sZUMBSgJ",8) == 3744116718) strcat(s, "l");
if (crc32("azjkbyzXjxu",11) == 1349303503) strcat(s, "a");
if (crc32("CRrumUiATXUSgQG",15) == 1702331149) strcat(s, "r");
    return s;
}

char *coleopterous_adjectives() {
    char *s = calloc(13);
    if (crc32("YNtadhYpiC",10) == 1666059089) strcat(s, "G");
if (crc32("cYBZAWb",7) == 2905479366) strcat(s, "c");
if (crc32("UtaFTqDylXXn",12) == 840212246) strcat(s, "o");
if (crc32("AxvbDcYW",8) == 682945777) strcat(s, "i");
if (crc32("lBhCPAaNgIO",11) == 1504161881) strcat(s, "l");
if (crc32("sZVwQsRjK",9) == 3493784998) strcat(s, "e");
if (crc32("qpZQjxAqptHIRg",14) == 738544927) strcat(s, "o");
if (crc32("lsfaYcJzsu",10) == 2795189006) strcat(s, "p");
if (crc32("XiTmUaXk",8) == 381089338) strcat(s, "t");
if (crc32("BJrRemGKU",9) == 1900476135) strcat(s, "e");
if (crc32("ZdZblWQOzNm",11) == 3274628686) strcat(s, "r");
if (crc32("SkLtupPQ",8) == 1739058167) strcat(s, "f");
if (crc32("XynknWTnd",9) == 2414489193) strcat(s, "o");
if (crc32("CtZcwlbUA",9) == 2542783542) strcat(s, "u");
if (crc32("HmrZKJztKfuZ",12) == 733429306) strcat(s, "k");
if (crc32("qNDzrIRFhdmPhv",14) == 1202326628) strcat(s, "s");
    return s;
}

char *excretive_adjectives() {
    char *s = calloc(10);
    if (crc32("lQxLKgMpSNqO",12) == 831295968) strcat(s, "e");
if (crc32("JpHdQsPdQSvfiI",14) == 2597620362) strcat(s, "x");
if (crc32("EEnuWtJepQvj",12) == 1803971718) strcat(s, "c");
if (crc32("ASnRelCYxIPzot",14) == 1372499487) strcat(s, "r");
if (crc32("BKMqmUOVRcfRcnr",15) == 3938875923) strcat(s, "e");
if (crc32("TvZZlcUZjX",10) == 53771687) strcat(s, "Y");
if (crc32("VLsSUfrd",8) == 1620706918) strcat(s, "t");
if (crc32("gKbZPsihojKze",13) == 1062164227) strcat(s, "A");
if (crc32("ZtzoVnSyxDlQd",13) == 2832417526) strcat(s, "i");
if (crc32("reyBvQmNgUc",11) == 3243492115) strcat(s, "v");
if (crc32("NTMfRtGID",9) == 2172637910) strcat(s, "o");
if (crc32("uhJMCQTQB",9) == 816552484) strcat(s, "e");
    return s;
}

char *OKd_adjectives() {
    char *s = calloc(4);
    if (crc32("rcbTWNCq",8) == 1764626971) strcat(s, "O");
if (crc32("rSrKjgNssitdjp",14) == 1307173888) strcat(s, "l");
if (crc32("oMsQhV",6) == 3554401871) strcat(s, "K");
if (crc32("xVKfgvXXq",9) == 4094951173) strcat(s, "d");
    return s;
}

char *transArabian_adjectives() {
    char *s = calloc(13);
    if (crc32("GMkwAOQy",8) == 2557514570) strcat(s, "t");
if (crc32("sKlJbTB",7) == 4067995717) strcat(s, "M");
if (crc32("vGdQZeVMG",9) == 1170649475) strcat(s, "r");
if (crc32("JnHFTBofD",9) == 992133593) strcat(s, "a");
if (crc32("SMydkSkRLRbGq",13) == 4164506184) strcat(s, "c");
if (crc32("Chbil",5) == 2626414779) strcat(s, "n");
if (crc32("eAabVPCUYtyRaa",14) == 318589642) strcat(s, "e");
if (crc32("RqRvSqzLQARuNW",14) == 3072431800) strcat(s, "s");
if (crc32("HIWcoSdUHGCC",12) == 2935463065) strcat(s, "p");
if (crc32("fMrczFSXF",9) == 4578261) strcat(s, "A");
if (crc32("txblCCsVc",9) == 1766616709) strcat(s, "p");
if (crc32("jZXoHd",6) == 1430491625) strcat(s, "r");
if (crc32("xafpEReyl",9) == 3297539820) strcat(s, "w");
if (crc32("idYZOFyYvqgqe",13) == 1600007499) strcat(s, "a");
if (crc32("sSNNKrOvSxN",11) == 4165599758) strcat(s, "b");
if (crc32("CPppgexmevhYlse",15) == 4259018602) strcat(s, "P");
if (crc32("GRWwUlue",8) == 2059877667) strcat(s, "i");
if (crc32("GwthLPJGm",9) == 1217054368) strcat(s, "L");
if (crc32("dEJZVQSFKKmQ",12) == 786267731) strcat(s, "a");
if (crc32("whOtAkykrDQgx",13) == 2372670343) strcat(s, "n");
    return s;
}

char *renegotiable_adjectives() {
    char *s = calloc(13);
    if (crc32("tSeRajjMAGnGlsb",15) == 3654028099) strcat(s, "r");
if (crc32("AluTZY",6) == 1286826090) strcat(s, "e");
if (crc32("EOGeSrj",7) == 1307491754) strcat(s, "n");
if (crc32("jtXeSoQCYVhyXO",14) == 2116003671) strcat(s, "e");
if (crc32("WsBodahnlIoJ",12) == 2356237551) strcat(s, "g");
if (crc32("XCzODWxGn",9) == 2331926773) strcat(s, "o");
if (crc32("HetCLETjmIqR",12) == 1107946402) strcat(s, "O");
if (crc32("AjGmWd",6) == 1605190051) strcat(s, "t");
if (crc32("YCYYZ",5) == 4180338364) strcat(s, "i");
if (crc32("SRIViZXQnZK",11) == 4256699943) strcat(s, "a");
if (crc32("wAhwiSiIaFZBEo",14) == 753511470) strcat(s, "b");
if (crc32("guOHjWzXnceo",12) == 2643885428) strcat(s, "M");
if (crc32("PJxNkA",6) == 4233233007) strcat(s, "l");
if (crc32("LOqdg",5) == 1617885159) strcat(s, "N");
if (crc32("uMLvCxdM",8) == 1895421673) strcat(s, "e");
    return s;
}

char *explanate_adjectives() {
    char *s = calloc(10);
    if (crc32("XWbNbaGTL",9) == 2427115547) strcat(s, "T");
if (crc32("deHXWDyRodeoVWC",15) == 3922961868) strcat(s, "e");
if (crc32("gAVwztPPArr",11) == 1025643252) strcat(s, "x");
if (crc32("XaxTTeiQ",8) == 1189262942) strcat(s, "p");
if (crc32("SbDFjOuTLykrWW",14) == 719136473) strcat(s, "l");
if (crc32("BFVPqJPQT",9) == 2934990353) strcat(s, "e");
if (crc32("ycCJw",5) == 2908249543) strcat(s, "a");
if (crc32("CDDBC",5) == 2534277727) strcat(s, "n");
if (crc32("OtUhSBzP",8) == 511588041) strcat(s, "q");
if (crc32("aycuRDEhbKdJy",13) == 2083898413) strcat(s, "a");
if (crc32("aOYVHpz",7) == 2191826427) strcat(s, "h");
if (crc32("lOXGxIA",7) == 1532369274) strcat(s, "t");
if (crc32("apiSFWMn",8) == 4245816877) strcat(s, "e");
    return s;
}

char *armipotent_adjectives() {
    char *s = calloc(11);
    if (crc32("PCvkpQzslqq",11) == 2674670740) strcat(s, "g");
if (crc32("lGyizAabm",9) == 2484737121) strcat(s, "a");
if (crc32("IGCvYpF",7) == 2669362536) strcat(s, "s");
if (crc32("zYzgurlUKQVu",12) == 2455077073) strcat(s, "r");
if (crc32("BXNbanREVQ",10) == 2449725431) strcat(s, "m");
if (crc32("jMevEHXHxLXfeq",14) == 946967789) strcat(s, "i");
if (crc32("iCKWBAJQfaf",11) == 4232081196) strcat(s, "g");
if (crc32("VgWTvs",6) == 3439439509) strcat(s, "p");
if (crc32("bnXULpUW",8) == 1426431932) strcat(s, "n");
if (crc32("XYWURzCOICgzVW",14) == 381479220) strcat(s, "o");
if (crc32("EntDrtPUaMhP",12) == 1804265592) strcat(s, "j");
if (crc32("EzavxlYfrNJAq",13) == 3838676683) strcat(s, "t");
if (crc32("RasxyHcaypv",11) == 3815483375) strcat(s, "L");
if (crc32("GNMRNdlAHnmESEA",15) == 1340461823) strcat(s, "e");
if (crc32("WAEesW",6) == 3591481267) strcat(s, "n");
if (crc32("glWOPNck",8) == 495683665) strcat(s, "t");
    return s;
}

char *spherulate_adjectives() {
    char *s = calloc(11);
    if (crc32("yinFUsOkKjr",11) == 2943619050) strcat(s, "l");
if (crc32("SLtpcPJuwb",10) == 2657068535) strcat(s, "s");
if (crc32("hTJAQ",5) == 2735490132) strcat(s, "p");
if (crc32("amKxXOvRqBSoX",13) == 321248941) strcat(s, "f");
if (crc32("FcvBcJO",7) == 3577539047) strcat(s, "h");
if (crc32("xMFsicxwFHSmROt",15) == 4095403483) strcat(s, "m");
if (crc32("YZeCLn",6) == 1610766088) strcat(s, "e");
if (crc32("mBtmxkZaZHSxKsh",15) == 494795186) strcat(s, "r");
if (crc32("FVSgyztIlgVeQ",13) == 3560570122) strcat(s, "u");
if (crc32("hqoxIEFECusCGM",14) == 485243385) strcat(s, "l");
if (crc32("rbUxxB",6) == 1689055902) strcat(s, "P");
if (crc32("FIHQwbPnGO",10) == 1477436553) strcat(s, "a");
if (crc32("PBoYxKJyTYuC",12) == 2442650554) strcat(s, "c");
if (crc32("JHXzq",5) == 448555257) strcat(s, "t");
if (crc32("pedVkMZHUHkc",12) == 3140972413) strcat(s, "X");
if (crc32("FpjAdWkgIVlUZd",14) == 2217765057) strcat(s, "e");
    return s;
}

char *selfrecollective_adjectives() {
    char *s = calloc(17);
    if (crc32("EwGwzFxPKXoU",12) == 2952723694) strcat(s, "c");
if (crc32("TAVjyLkG",8) == 1583424883) strcat(s, "s");
if (crc32("uBTEuWQOb",9) == 1446438341) strcat(s, "L");
if (crc32("vQEkeGaTodzVJE",14) == 2136612431) strcat(s, "e");
if (crc32("BCuBwaUGm",9) == 3888319644) strcat(s, "C");
if (crc32("CwxRNdD",7) == 1546283556) strcat(s, "l");
if (crc32("SxaEOOObFClKc",13) == 2931496495) strcat(s, "f");
if (crc32("AdcITB",6) == 3630604780) strcat(s, "z");
if (crc32("BiKsWR",6) == 223210886) strcat(s, "r");
if (crc32("WzXMHjSS",8) == 3575666981) strcat(s, "m");
if (crc32("mAWswPNURYkYf",13) == 1475993993) strcat(s, "e");
if (crc32("uIqTgEWIzmhsuoI",15) == 3883963869) strcat(s, "c");
if (crc32("VLXOmaCVbs",10) == 885607810) strcat(s, "o");
if (crc32("GoBvMCldhcSSfuQ",15) == 3753920460) strcat(s, "P");
if (crc32("zxfppBDiJMjuhKh",15) == 128125015) strcat(s, "l");
if (crc32("ZSHeeU",6) == 1884519593) strcat(s, "l");
if (crc32("BfEsfYAqKQAbXhi",15) == 3895720032) strcat(s, "e");
if (crc32("squgFF",6) == 3491993246) strcat(s, "c");
if (crc32("pPLht",5) == 177128371) strcat(s, "t");
if (crc32("AQGwU",5) == 3735699244) strcat(s, "t");
if (crc32("Fwhbv",5) == 4290304397) strcat(s, "t");
if (crc32("SKRfPXAwYpovJgy",15) == 3275693216) strcat(s, "i");
if (crc32("FaNVfwdmHnh",11) == 1936188948) strcat(s, "v");
if (crc32("drecL",5) == 2601464927) strcat(s, "w");
if (crc32("OYWyKXaEG",9) == 1781349332) strcat(s, "e");
    return s;
}

char *alliaceous_adjectives() {
    char *s = calloc(11);
    if (crc32("iVxueE",6) == 3775521414) strcat(s, "j");
if (crc32("yCOCZwVZfPwChA",14) == 2029351796) strcat(s, "a");
if (crc32("vpWdRJox",8) == 1056849870) strcat(s, "l");
if (crc32("qmTqPCkANmD",11) == 2210654899) strcat(s, "l");
if (crc32("BZnWwF",6) == 3426381375) strcat(s, "i");
if (crc32("CkVPSaNOLrrFZ",13) == 3835017421) strcat(s, "a");
if (crc32("GnhaXKRP",8) == 1284955041) strcat(s, "c");
if (crc32("eimsOnbuUCNMU",13) == 4049707138) strcat(s, "e");
if (crc32("kqcSAwLp",8) == 766525516) strcat(s, "o");
if (crc32("UgCJe",5) == 3177364244) strcat(s, "T");
if (crc32("CYRnnZAexHV",11) == 123001404) strcat(s, "u");
if (crc32("cKwzFEF",7) == 1803264281) strcat(s, "s");
    return s;
}

char *gangliar_adjectives() {
    char *s = calloc(9);
    if (crc32("BfrdMpDLaos",11) == 1767265210) strcat(s, "j");
if (crc32("UtfcQBH",7) == 2498047003) strcat(s, "g");
if (crc32("qgyMJDoD",8) == 3614020441) strcat(s, "a");
if (crc32("LWJOSt",6) == 184201593) strcat(s, "n");
if (crc32("gANzo",5) == 900714504) strcat(s, "a");
if (crc32("GFSSvQd",7) == 3670652185) strcat(s, "g");
if (crc32("nflHAHL",7) == 2897789278) strcat(s, "l");
if (crc32("NvTacfFVpngZ",12) == 533956421) strcat(s, "i");
if (crc32("JIyXfwQTkoi",11) == 3403215213) strcat(s, "a");
if (crc32("PEzmt",5) == 2359745936) strcat(s, "r");
    return s;
}

char *sprayful_adjectives() {
    char *s = calloc(9);
    if (crc32("lyMYDXH",7) == 2927956829) strcat(s, "q");
if (crc32("mNPUVhXvNO",10) == 1354879158) strcat(s, "s");
if (crc32("hfgaBdHFjURmcKk",15) == 818221673) strcat(s, "u");
if (crc32("LNeyGWGA",8) == 1913449165) strcat(s, "p");
if (crc32("eiQRmnSPgIhIN",13) == 3765025993) strcat(s, "r");
if (crc32("KdxTZUiiR",9) == 4058677419) strcat(s, "R");
if (crc32("VUevsw",6) == 219273099) strcat(s, "a");
if (crc32("VOxzymWyIl",10) == 1154221537) strcat(s, "y");
if (crc32("bULlwEVrRFrsb",13) == 766342330) strcat(s, "f");
if (crc32("nKgnXprJGaTLZjI",15) == 38862034) strcat(s, "M");
if (crc32("pEhELnS",7) == 1535455946) strcat(s, "u");
if (crc32("GScjanurZWp",11) == 817235398) strcat(s, "X");
if (crc32("SRsGNOzViWEe",12) == 3151631755) strcat(s, "l");
    return s;
}

char *pneumatophorous_adjectives() {
    char *s = calloc(16);
    if (crc32("hdlxXpIpaNCuFt",14) == 708844429) strcat(s, "A");
if (crc32("bZuyqMbFBXL",11) == 509666845) strcat(s, "p");
if (crc32("iHtCciWYd",9) == 2914236558) strcat(s, "n");
if (crc32("FVkRFMCRuO",10) == 1669188136) strcat(s, "e");
if (crc32("wRwgjUMRdEG",11) == 2316671929) strcat(s, "O");
if (crc32("CFpMGTbkWwOq",12) == 3554321656) strcat(s, "u");
if (crc32("jOILcmvunpCj",12) == 125699240) strcat(s, "m");
if (crc32("qMMMmEbiAXGXeeQ",15) == 948529059) strcat(s, "a");
if (crc32("gxyPNwiEFaoX",12) == 919221591) strcat(s, "x");
if (crc32("twJYP",5) == 1099405000) strcat(s, "t");
if (crc32("FursRfQcTZzUNVL",15) == 3283468124) strcat(s, "o");
if (crc32("htoCzxUbbMKUuf",14) == 2672160447) strcat(s, "p");
if (crc32("KFgHNXIRVJW",11) == 2559976928) strcat(s, "h");
if (crc32("sxjBsfw",7) == 1480184337) strcat(s, "e");
if (crc32("btlJelYMFRTCV",13) == 2242167016) strcat(s, "o");
if (crc32("DrgbFy",6) == 3292638105) strcat(s, "r");
if (crc32("sJydzdUC",8) == 2220651670) strcat(s, "o");
if (crc32("sZpeHXgecH",10) == 1493455979) strcat(s, "u");
if (crc32("LjPUGBfvmt",10) == 270690005) strcat(s, "Y");
if (crc32("YGYStEI",7) == 70371008) strcat(s, "s");
    return s;
}

char *spoony_adjectives() {
    char *s = calloc(7);
    if (crc32("LAYXEkRPC",9) == 728371371) strcat(s, "s");
if (crc32("SAVVjG",6) == 2948005729) strcat(s, "p");
if (crc32("jTPjrTvUHoHw",12) == 2886722825) strcat(s, "Y");
if (crc32("TkxnZkOhUvusHc",14) == 3535419088) strcat(s, "o");
if (crc32("djOYZWh",7) == 4041514395) strcat(s, "o");
if (crc32("aIFWUQOdCg",10) == 2063930018) strcat(s, "n");
if (crc32("JCAqqufSL",9) == 307287551) strcat(s, "y");
    return s;
}

char *postmedieval_adjectives() {
    char *s = calloc(13);
    if (crc32("zqKOAlJkdTRojAr",15) == 405446153) strcat(s, "p");
if (crc32("nTpVMLQI",8) == 2012673675) strcat(s, "o");
if (crc32("rfJJnJffoqln",12) == 1896931421) strcat(s, "s");
if (crc32("FIVfUg",6) == 2332477676) strcat(s, "t");
if (crc32("MsyeDiKyx",9) == 3937407128) strcat(s, "z");
if (crc32("uwEaQfcod",9) == 3592840552) strcat(s, "m");
if (crc32("yoGEmaLAei",10) == 3273727342) strcat(s, "e");
if (crc32("HiRIbohjzDH",11) == 527354037) strcat(s, "D");
if (crc32("PZwVwKCD",8) == 907542031) strcat(s, "d");
if (crc32("eysvG",5) == 1459114584) strcat(s, "s");
if (crc32("THJLy",5) == 1560883011) strcat(s, "i");
if (crc32("Mghav",5) == 4198295295) strcat(s, "C");
if (crc32("ZxfEiXDZJYMRsK",14) == 311443956) strcat(s, "e");
if (crc32("qLlJBMjyN",9) == 4238503958) strcat(s, "v");
if (crc32("vDEqwGxQdrk",11) == 394825248) strcat(s, "a");
if (crc32("xacLj",5) == 924856643) strcat(s, "l");
    return s;
}

char *charlatanistic_adjectives() {
    char *s = calloc(15);
    if (crc32("FaUhibnUkXZHf",13) == 2465720483) strcat(s, "c");
if (crc32("VOfzForh",8) == 974167522) strcat(s, "A");
if (crc32("ZjQCWJCUsmJIzO",14) == 1787929978) strcat(s, "h");
if (crc32("BZgdbZGBbjP",11) == 4075743818) strcat(s, "a");
if (crc32("TSFVSrtASGlNHeB",15) == 3293740250) strcat(s, "r");
if (crc32("EEftv",5) == 1150572354) strcat(s, "l");
if (crc32("lQiIOj",6) == 677666227) strcat(s, "a");
if (crc32("SwDntENzJcjX",12) == 408564994) strcat(s, "t");
if (crc32("muguHRBLUOfES",13) == 1908072250) strcat(s, "s");
if (crc32("mnayI",5) == 3297861197) strcat(s, "a");
if (crc32("mYEHfGUxcvbRl",13) == 1084943254) strcat(s, "n");
if (crc32("TIoqkvlFpsql",12) == 3415023736) strcat(s, "i");
if (crc32("moHdSWl",7) == 2617871918) strcat(s, "b");
if (crc32("mimanRaUX",9) == 19392466) strcat(s, "s");
if (crc32("mNtbUptVQy",10) == 1182024778) strcat(s, "t");
if (crc32("jQQItLyBUWlMLx",14) == 734653730) strcat(s, "i");
if (crc32("ScMYlDRqvxWQ",12) == 1230159953) strcat(s, "h");
if (crc32("ySluLDRkEGefSR",14) == 4222777774) strcat(s, "c");
    return s;
}

char *transAustrian_adjectives() {
    char *s = calloc(14);
    if (crc32("TIaSLItlZtJ",11) == 3296258748) strcat(s, "T");
if (crc32("sgQndYtsaCXhu",13) == 1056891968) strcat(s, "t");
if (crc32("YIHooEy",7) == 4025229990) strcat(s, "r");
if (crc32("lvEVxQrVDG",10) == 3174574883) strcat(s, "a");
if (crc32("dHOvZTjxlZdapZ",14) == 130128214) strcat(s, "f");
if (crc32("EytNHSmHYRZTb",13) == 661872882) strcat(s, "n");
if (crc32("IfXTTGbEVrs",11) == 2298519842) strcat(s, "z");
if (crc32("TVpHApJE",8) == 3969099017) strcat(s, "s");
if (crc32("TKQnuEQLrB",10) == 2757597090) strcat(s, "R");
if (crc32("BSKWWMvPpQKPvW",14) == 1245037229) strcat(s, "A");
if (crc32("XFLiW",5) == 774194670) strcat(s, "b");
if (crc32("JvefSb",6) == 454763398) strcat(s, "u");
if (crc32("EtheNOvEfceBN",13) == 1314047277) strcat(s, "Y");
if (crc32("HjjiSM",6) == 187535932) strcat(s, "s");
if (crc32("CgIhVG",6) == 3080573426) strcat(s, "t");
if (crc32("Olzextoxq",9) == 3416667338) strcat(s, "O");
if (crc32("oPPfRkndkfl",11) == 41408252) strcat(s, "r");
if (crc32("lEjglZtlJm",10) == 587113334) strcat(s, "i");
if (crc32("JsANBcb",7) == 1419484751) strcat(s, "l");
if (crc32("aMbLdqaWKdgoDZC",15) == 700599081) strcat(s, "a");
if (crc32("fTMXWHmkXKX",11) == 2514109274) strcat(s, "x");
if (crc32("HCQeXgHjk",9) == 1822662752) strcat(s, "n");
    return s;
}

char *libationary_adjectives() {
    char *s = calloc(12);
    if (crc32("QHAqQNBEVLCpEMD",15) == 3946573253) strcat(s, "l");
if (crc32("dZlzTbSrmr",10) == 2206347029) strcat(s, "D");
if (crc32("FSovLEFkT",9) == 2675737442) strcat(s, "i");
if (crc32("ZfhiuaDJD",9) == 2537826263) strcat(s, "S");
if (crc32("UAZYgIXPum",10) == 1151986981) strcat(s, "b");
if (crc32("hLNRyNCV",8) == 2808687366) strcat(s, "a");
if (crc32("cmamopV",7) == 3169650908) strcat(s, "y");
if (crc32("TZVupwj",7) == 2511953065) strcat(s, "t");
if (crc32("GQTgIx",6) == 3497932062) strcat(s, "i");
if (crc32("QjFOt",5) == 3277066652) strcat(s, "o");
if (crc32("ihQTVQHZNWdPi",13) == 2477016408) strcat(s, "n");
if (crc32("BhlGfUQDEZSBq",13) == 498796875) strcat(s, "z");
if (crc32("ycDQEnEZnbtDr",13) == 2031558842) strcat(s, "a");
if (crc32("LxhIaeNPurJ",11) == 53357729) strcat(s, "r");
if (crc32("qzDjNpWeWwnnYV",14) == 2070638184) strcat(s, "y");
    return s;
}

char *unpursued_adjectives() {
    char *s = calloc(10);
    if (crc32("ytNtbHVAxKlou",13) == 1683578109) strcat(s, "u");
if (crc32("GTlGPHGsQ",9) == 905508830) strcat(s, "P");
if (crc32("ktVBPFlYDRN",11) == 4081702113) strcat(s, "n");
if (crc32("PRiNdAfcTFRqQ",13) == 3379986911) strcat(s, "p");
if (crc32("vywEjKRSHhIHI",13) == 1578943614) strcat(s, "u");
if (crc32("NmJUNXx",7) == 2233138238) strcat(s, "r");
if (crc32("HlcenWyS",8) == 4224774167) strcat(s, "W");
if (crc32("CLpDYbFufaK",11) == 1414442224) strcat(s, "s");
if (crc32("XOWyjyJNwS",10) == 63572265) strcat(s, "k");
if (crc32("myoWFWu",7) == 3071985287) strcat(s, "u");
if (crc32("uORUgdbBJaRButb",15) == 1781345290) strcat(s, "e");
if (crc32("BgkMn",5) == 1946849855) strcat(s, "w");
if (crc32("laCKWSiAyxswR",13) == 4285500849) strcat(s, "d");
    return s;
}

char *apodictic_adjectives() {
    char *s = calloc(10);
    if (crc32("DYHDa",5) == 226315787) strcat(s, "a");
if (crc32("znqaARnHR",9) == 877219107) strcat(s, "p");
if (crc32("xhEtCmiiR",9) == 2294269626) strcat(s, "o");
if (crc32("BhZXQqVzogsS",12) == 1219315290) strcat(s, "d");
if (crc32("YrhRcGmNl",9) == 2637341826) strcat(s, "i");
if (crc32("oRScLZjOSnRd",12) == 3858010071) strcat(s, "c");
if (crc32("XDUXHZ",6) == 850134834) strcat(s, "V");
if (crc32("mEEBCvK",7) == 1663130618) strcat(s, "t");
if (crc32("fxipGTPA",8) == 3371747510) strcat(s, "g");
if (crc32("dczcmoGJNt",10) == 888334617) strcat(s, "i");
if (crc32("mCFPhM",6) == 1836149357) strcat(s, "c");
    return s;
}

char *unacquiescent_adjectives() {
    char *s = calloc(14);
    if (crc32("xTAxACPrghRPEz",14) == 4252048838) strcat(s, "J");
if (crc32("yhDaj",5) == 1784700403) strcat(s, "u");
if (crc32("bsWXo",5) == 1655052312) strcat(s, "y");
if (crc32("ZXmoCKJBzHgUF",13) == 1951450977) strcat(s, "n");
if (crc32("wvohE",5) == 2607394533) strcat(s, "Z");
if (crc32("PRBDMgjqh",9) == 4070191392) strcat(s, "a");
if (crc32("DwykaDVTChs",11) == 4185705269) strcat(s, "C");
if (crc32("SvGqnJv",7) == 2596476036) strcat(s, "c");
if (crc32("PyqNToBpzwpJq",13) == 3270399348) strcat(s, "q");
if (crc32("HnitKl",6) == 3417801594) strcat(s, "b");
if (crc32("PmZoTbcGhri",11) == 4240690187) strcat(s, "u");
if (crc32("npVhHABC",8) == 1037877285) strcat(s, "i");
if (crc32("SgyBtKkYzMxBrjz",15) == 2725671211) strcat(s, "k");
if (crc32("tzbrJVlLIGFFe",13) == 301271709) strcat(s, "e");
if (crc32("nfNyaonEIue",11) == 4105627553) strcat(s, "N");
if (crc32("GhXspUByxHhsP",13) == 2461332950) strcat(s, "s");
if (crc32("ogsQNcBki",9) == 2860936806) strcat(s, "c");
if (crc32("nUpzlFcB",8) == 3121348430) strcat(s, "e");
if (crc32("IWkGfq",6) == 3936035573) strcat(s, "Q");
if (crc32("qQPKYzLUhjsfy",13) == 1555419380) strcat(s, "n");
if (crc32("IrLEFbtgBU",10) == 170387599) strcat(s, "e");
if (crc32("FHGwFr",6) == 1326824856) strcat(s, "t");
    return s;
}

char *lianoid_adjectives() {
    char *s = calloc(8);
    if (crc32("skIJnCpvUT",10) == 3449724593) strcat(s, "U");
if (crc32("mwzwOwJmtDOB",12) == 91656711) strcat(s, "l");
if (crc32("ZqYkRXJ",7) == 3306726440) strcat(s, "q");
if (crc32("Qxjtld",6) == 994478078) strcat(s, "i");
if (crc32("dhSGplEXg",9) == 2609485171) strcat(s, "q");
if (crc32("HpeEYf",6) == 505062151) strcat(s, "a");
if (crc32("BLllbHP",7) == 4274102562) strcat(s, "J");
if (crc32("jTUBTVeRisW",11) == 2986254172) strcat(s, "n");
if (crc32("ftPjkqBopJR",11) == 3431391344) strcat(s, "o");
if (crc32("zaYgkkemBSw",11) == 415913328) strcat(s, "J");
if (crc32("XAfioyyRuDEJmjb",15) == 3781763306) strcat(s, "i");
if (crc32("UGgVCZNDTHHFT",13) == 3792253831) strcat(s, "r");
if (crc32("kwigtuCZqe",10) == 2634895787) strcat(s, "d");
    return s;
}

char *hyperspeculative_adjectives() {
    char *s = calloc(17);
    if (crc32("XqUDEddjj",9) == 4087428958) strcat(s, "h");
if (crc32("JgziX",5) == 345526599) strcat(s, "T");
if (crc32("dcIBDuWOJXtPr",13) == 2646143063) strcat(s, "y");
if (crc32("bEoNEXHADd",10) == 430367216) strcat(s, "p");
if (crc32("ErXSNvWK",8) == 3750069508) strcat(s, "e");
if (crc32("nXudLWaYLPhSfSe",15) == 136963897) strcat(s, "S");
if (crc32("CjASzmXAfukf",12) == 2296664965) strcat(s, "r");
if (crc32("ilRfWfThbsUHi",13) == 1618052220) strcat(s, "I");
if (crc32("NFgecNtQkZKZUUp",15) == 2774416507) strcat(s, "s");
if (crc32("pYIIGkyujj",10) == 2796863969) strcat(s, "p");
if (crc32("SiOQMPrwkZz",11) == 495688247) strcat(s, "e");
if (crc32("fUZOSQb",7) == 4135279724) strcat(s, "e");
if (crc32("HAaOJnyVcljOF",13) == 2463531942) strcat(s, "G");
if (crc32("jYkKcAXVZvQFw",13) == 4233766101) strcat(s, "c");
if (crc32("RYCpPKvPV",9) == 2127712488) strcat(s, "O");
if (crc32("VmHBtv",6) == 3577526322) strcat(s, "u");
if (crc32("MvfvKzmwfUEsQnz",15) == 1768367950) strcat(s, "N");
if (crc32("aoIkbKUR",8) == 1835113176) strcat(s, "l");
if (crc32("bKnzf",5) == 2415307653) strcat(s, "t");
if (crc32("oBWFezb",7) == 2923349228) strcat(s, "a");
if (crc32("OFGDBvjw",8) == 1031301328) strcat(s, "t");
if (crc32("iJqdoV",6) == 453565324) strcat(s, "k");
if (crc32("ptCrNqQ",7) == 1872659219) strcat(s, "i");
if (crc32("gCcXYYlb",8) == 4084240665) strcat(s, "v");
if (crc32("rVypXxJHLTNrxk",14) == 3190044253) strcat(s, "e");
    return s;
}

char *prescout_adjectives() {
    char *s = calloc(9);
    if (crc32("orULzsfsrXUsn",13) == 145688465) strcat(s, "p");
if (crc32("zGWQeKWVypf",11) == 2715957582) strcat(s, "H");
if (crc32("pDZcuFcdT",9) == 452195848) strcat(s, "r");
if (crc32("xCUrXtetT",9) == 2005749845) strcat(s, "j");
if (crc32("yAwZp",5) == 1353183436) strcat(s, "e");
if (crc32("CFIVE",5) == 4061277159) strcat(s, "s");
if (crc32("CsqbMRtzdvd",11) == 1550525366) strcat(s, "c");
if (crc32("qiBwSkeEwCH",11) == 334462082) strcat(s, "X");
if (crc32("JEUqiEbxWyDa",12) == 1210641875) strcat(s, "o");
if (crc32("RAgaYviZbY",10) == 1933509379) strcat(s, "S");
if (crc32("vzLAxhSh",8) == 1622968035) strcat(s, "u");
if (crc32("rXTgGgI",7) == 1028500806) strcat(s, "t");
    return s;
}

char *unessential_adjectives() {
    char *s = calloc(12);
    if (crc32("wOgtwAYhIKtUjX",14) == 4043658212) strcat(s, "g");
if (crc32("SPqRMvYbT",9) == 1161691895) strcat(s, "u");
if (crc32("YTyUEjySLdodw",13) == 507144792) strcat(s, "I");
if (crc32("RBJWZKYoJzhakD",14) == 3643146977) strcat(s, "n");
if (crc32("lOabXjndNg",10) == 2548491844) strcat(s, "I");
if (crc32("ItEcwVu",7) == 4177276515) strcat(s, "e");
if (crc32("aYmTvxDxsY",10) == 1494366817) strcat(s, "O");
if (crc32("LSQKHeZBn",9) == 2284770867) strcat(s, "s");
if (crc32("pCepq",5) == 4255039491) strcat(s, "S");
if (crc32("WJuPoCjo",8) == 3938481936) strcat(s, "s");
if (crc32("KupBIJNLdylWm",13) == 3603394275) strcat(s, "e");
if (crc32("lHLjeYkvZ",9) == 3806887524) strcat(s, "f");
if (crc32("fyuXvYQZglJC",12) == 2336472147) strcat(s, "n");
if (crc32("UxBIrhwrL",9) == 3199782148) strcat(s, "x");
if (crc32("ZaZfWz",6) == 356900650) strcat(s, "t");
if (crc32("MLsIYAfIbUQjSEk",15) == 4264293094) strcat(s, "L");
if (crc32("VNlrwz",6) == 2063413239) strcat(s, "i");
if (crc32("ZtXVjLgZAZXbeln",15) == 538150092) strcat(s, "v");
if (crc32("sUZGtSyQF",9) == 365733661) strcat(s, "a");
if (crc32("xCmldVzhj",9) == 1153849333) strcat(s, "l");
    return s;
}

char *unstarched_adjectives() {
    char *s = calloc(11);
    if (crc32("BdUUWyd",7) == 3461754369) strcat(s, "h");
if (crc32("yrrPHtTsBXRovFe",15) == 222268876) strcat(s, "u");
if (crc32("JXsNaPctKaT",11) == 2000011566) strcat(s, "n");
if (crc32("VfJMNbhntdc",11) == 959400018) strcat(s, "o");
if (crc32("uWgAaUL",7) == 3418261765) strcat(s, "s");
if (crc32("lmoAAcN",7) == 4080437675) strcat(s, "t");
if (crc32("PwCAoKEulZnToq",14) == 2482688484) strcat(s, "N");
if (crc32("WtlaYBurqakI",12) == 2945559378) strcat(s, "a");
if (crc32("heNfyOuFknekwOu",15) == 883918986) strcat(s, "P");
if (crc32("kyjfgKMcMNqqAxm",15) == 820878660) strcat(s, "r");
if (crc32("EtqFIn",6) == 146920714) strcat(s, "c");
if (crc32("WAXZmPr",7) == 1467395957) strcat(s, "c");
if (crc32("pRuvyYhtnurO",12) == 811633302) strcat(s, "H");
if (crc32("itjfYA",6) == 3758657232) strcat(s, "h");
if (crc32("sghVVdpITqkrxS",14) == 3513034705) strcat(s, "M");
if (crc32("rweZNNXCawrLsF",14) == 4187992153) strcat(s, "e");
if (crc32("WLLynmTG",8) == 1804568076) strcat(s, "x");
if (crc32("ShonHpJqlvNxcl",14) == 730892401) strcat(s, "d");
    return s;
}

char *heterochromous_adjectives() {
    char *s = calloc(15);
    if (crc32("ZOtrquy",7) == 2223708868) strcat(s, "y");
if (crc32("uhArvlXOCkb",11) == 1840115104) strcat(s, "h");
if (crc32("kgnRhRqvFSt",11) == 3297111862) strcat(s, "H");
if (crc32("rFKbauSQyk",10) == 3064064461) strcat(s, "e");
if (crc32("rlJlrWx",7) == 105863085) strcat(s, "t");
if (crc32("vlpCcXujBZWfTE",14) == 2533242526) strcat(s, "f");
if (crc32("mlFqqktcdERjNY",14) == 2426526351) strcat(s, "e");
if (crc32("IDyDjlMg",8) == 3787265493) strcat(s, "r");
if (crc32("cqOGfYzFN",9) == 1912616251) strcat(s, "A");
if (crc32("TahliguSIv",10) == 4183446513) strcat(s, "o");
if (crc32("jWciKSIrrXVnUzn",15) == 3842959912) strcat(s, "H");
if (crc32("GwrNJlkMiHgWie",14) == 3825779081) strcat(s, "c");
if (crc32("iNLBXgqEVqM",11) == 2830681371) strcat(s, "h");
if (crc32("vkkFu",5) == 1267773239) strcat(s, "h");
if (crc32("LsjDiXWPqhe",11) == 3023252152) strcat(s, "r");
if (crc32("hlqAhGwQQkXJaF",14) == 2960579615) strcat(s, "o");
if (crc32("FQAzQ",5) == 3670287834) strcat(s, "m");
if (crc32("tsddDeNiserOUgT",15) == 3927051055) strcat(s, "p");
if (crc32("DsMIZn",6) == 1729281256) strcat(s, "o");
if (crc32("PUCGIH",6) == 452115680) strcat(s, "T");
if (crc32("XZIgtYIVTALBbHh",15) == 1622533572) strcat(s, "u");
if (crc32("gdkiQfWFuga",11) == 4185309221) strcat(s, "D");
if (crc32("iVpOBjqQwicxbct",15) == 3592827594) strcat(s, "s");
    return s;
}

char *tabulable_adjectives() {
    char *s = calloc(10);
    if (crc32("tdbmjoJxh",9) == 2948910335) strcat(s, "d");
if (crc32("gtBGhGpJAY",10) == 1954110769) strcat(s, "t");
if (crc32("WJnREzpcQsJiLnY",15) == 1360244089) strcat(s, "a");
if (crc32("hpuCRHc",7) == 3645337305) strcat(s, "e");
if (crc32("vxcBJqFIRPc",11) == 2253016484) strcat(s, "b");
if (crc32("QRFWl",5) == 1740423645) strcat(s, "u");
if (crc32("MRunWLNMYKmvK",13) == 189741472) strcat(s, "l");
if (crc32("teAxwd",6) == 2318424618) strcat(s, "q");
if (crc32("gEcUOtVzb",9) == 2043199535) strcat(s, "a");
if (crc32("gVVgLRhxHWHPyv",14) == 595177543) strcat(s, "b");
if (crc32("QytiNKjz",8) == 4223674125) strcat(s, "A");
if (crc32("ppmXJQib",8) == 390539800) strcat(s, "l");
if (crc32("Kdadvzt",7) == 2329394595) strcat(s, "e");
    return s;
}

char *lordliest_adjectives() {
    char *s = calloc(10);
    if (crc32("jlZgBVsXs",9) == 3815475563) strcat(s, "p");
if (crc32("QRRaYvqHMJnnAg",14) == 2421445711) strcat(s, "l");
if (crc32("VxdFxkQlGt",10) == 3158240802) strcat(s, "o");
if (crc32("KXqxMxrOnfEXaNh",15) == 3137925679) strcat(s, "r");
if (crc32("oedlKDmWWkIMr",13) == 1437197276) strcat(s, "d");
if (crc32("mwvadcaRjzPLFCH",15) == 1921754226) strcat(s, "l");
if (crc32("MzizJt",6) == 4090496986) strcat(s, "i");
if (crc32("TbMoXqogo",9) == 172646055) strcat(s, "X");
if (crc32("FWGafUshmC",10) == 1175618397) strcat(s, "e");
if (crc32("XzblsGlAdpdiat",14) == 2341628853) strcat(s, "A");
if (crc32("UnVlTBnKPs",10) == 2531556759) strcat(s, "s");
if (crc32("jVIdzWa",7) == 2772052766) strcat(s, "J");
if (crc32("eiwgBWyHYqXRSbA",15) == 1267089309) strcat(s, "t");
    return s;
}

char *unapproached_adjectives() {
    char *s = calloc(13);
    if (crc32("LwAOgqupzOIVqcI",15) == 283978998) strcat(s, "i");
if (crc32("LcUWrsoXrNbIi",13) == 3797440916) strcat(s, "u");
if (crc32("CxtjPOmvhhS",11) == 2223667873) strcat(s, "O");
if (crc32("xqIPSVNkGdKBwtU",15) == 2895722475) strcat(s, "n");
if (crc32("elQweV",6) == 2828037570) strcat(s, "d");
if (crc32("DwlyJjJpEK",10) == 2947871755) strcat(s, "a");
if (crc32("wcLtcJE",7) == 4095411783) strcat(s, "s");
if (crc32("iSfpyq",6) == 1925777840) strcat(s, "p");
if (crc32("ohPfVTIzgIlzbJJ",15) == 916127866) strcat(s, "p");
if (crc32("zSxfKwMJfUEE",12) == 2636909058) strcat(s, "r");
if (crc32("UxqmXmXii",9) == 2094891111) strcat(s, "o");
if (crc32("EQSFNQTkRHyNEV",14) == 2830103560) strcat(s, "F");
if (crc32("oCidkEILIqQkqmn",15) == 2386119793) strcat(s, "a");
if (crc32("TAQidfPaqTe",11) == 324210375) strcat(s, "S");
if (crc32("fNEpOlqqPA",10) == 992613199) strcat(s, "c");
if (crc32("pzZwpzvua",9) == 2137635083) strcat(s, "h");
if (crc32("QNliBgIZwwuUcn",14) == 2578194339) strcat(s, "T");
if (crc32("evTdLP",6) == 2743042257) strcat(s, "e");
if (crc32("cRrdDroggWMY",12) == 1795861807) strcat(s, "d");
    return s;
}

char *calcinatory_adjectives() {
    char *s = calloc(12);
    if (crc32("LSRLzsnCnx",10) == 2671177154) strcat(s, "Q");
if (crc32("qULUqQfpFMhf",12) == 2088753840) strcat(s, "c");
if (crc32("SYPGteDUmTPMbdv",15) == 1604805786) strcat(s, "p");
if (crc32("UJgZPdhADTVEaG",14) == 1069549647) strcat(s, "a");
if (crc32("lFogVkUuPQl",11) == 3655727658) strcat(s, "l");
if (crc32("mhUsnGd",7) == 2910693900) strcat(s, "l");
if (crc32("unoBrsvPyc",10) == 1294122915) strcat(s, "c");
if (crc32("jvRoZWu",7) == 2336259650) strcat(s, "P");
if (crc32("aMgZdVXJRjX",11) == 2701355037) strcat(s, "i");
if (crc32("itaZoaOB",8) == 4092153992) strcat(s, "t");
if (crc32("nqtCojWGfzU",11) == 2686014809) strcat(s, "n");
if (crc32("NYyeRucmUoZ",11) == 2506395808) strcat(s, "a");
if (crc32("HEodZkphasdOX",13) == 3112144950) strcat(s, "t");
if (crc32("wQsXBeD",7) == 2358466106) strcat(s, "u");
if (crc32("CeRmm",5) == 1507926116) strcat(s, "o");
if (crc32("qtCpryJkzzQv",12) == 462802574) strcat(s, "Z");
if (crc32("fwFoERXqrm",10) == 1367040500) strcat(s, "r");
if (crc32("wMcDseqYGJPSgzu",15) == 2873000955) strcat(s, "i");
if (crc32("BAORcl",6) == 811261087) strcat(s, "y");
    return s;
}

char *semicolloidal_adjectives() {
    char *s = calloc(14);
    if (crc32("sWXONjxpjZBVNx",14) == 615308267) strcat(s, "s");
if (crc32("RZnQcEK",7) == 1149386626) strcat(s, "H");
if (crc32("RvWmMlDpSoBaym",14) == 1783507888) strcat(s, "e");
if (crc32("nVgFeWEKlxBES",13) == 3894332776) strcat(s, "W");
if (crc32("mhWNImqGam",10) == 3417948950) strcat(s, "m");
if (crc32("bDIkBRHruFhrRu",14) == 3082145781) strcat(s, "j");
if (crc32("VktnWJRcctbHWz",14) == 1462871669) strcat(s, "i");
if (crc32("RYSacyRMlQ",10) == 3224508771) strcat(s, "c");
if (crc32("rXoALA",6) == 972927245) strcat(s, "N");
if (crc32("ggzWWwotMRXcX",13) == 2990050003) strcat(s, "o");
if (crc32("cMJRzenQ",8) == 1594275665) strcat(s, "l");
if (crc32("acTzF",5) == 1782121144) strcat(s, "l");
if (crc32("NANOJ",5) == 2577757667) strcat(s, "o");
if (crc32("VUBlcBrVjOizhA",14) == 956213390) strcat(s, "i");
if (crc32("HYFCcHDzIv",10) == 236016643) strcat(s, "R");
if (crc32("VOPURqO",7) == 1490576761) strcat(s, "d");
if (crc32("mjDbDZbBl",9) == 1001209824) strcat(s, "a");
if (crc32("HRDBvaWIyQ",10) == 1773359083) strcat(s, "C");
if (crc32("BHKesNjKxuDBr",13) == 127522579) strcat(s, "l");
    return s;
}

char *undeprecative_adjectives() {
    char *s = calloc(14);
    if (crc32("anqeyvppHra",11) == 3237919254) strcat(s, "h");
if (crc32("ONvgPcrinbfy",12) == 3375186746) strcat(s, "u");
if (crc32("vkIyesk",7) == 2740816886) strcat(s, "n");
if (crc32("DrjurOdfH",9) == 3427429969) strcat(s, "h");
if (crc32("vkqMbw",6) == 2955951603) strcat(s, "d");
if (crc32("szvbzpmhTu",10) == 3476339888) strcat(s, "e");
if (crc32("ACwqfL",6) == 2239955243) strcat(s, "p");
if (crc32("ABjjbTYJYKPMc",13) == 4164481322) strcat(s, "r");
if (crc32("gyXTwnbg",8) == 3675161459) strcat(s, "e");
if (crc32("bVkAn",5) == 4150955437) strcat(s, "f");
if (crc32("exvYVYJZbTvbp",13) == 2602101859) strcat(s, "c");
if (crc32("CEQMfUZibbQHisn",15) == 3160547905) strcat(s, "A");
if (crc32("DPBENx",6) == 1785750026) strcat(s, "a");
if (crc32("hfAqwMXVB",9) == 4078446551) strcat(s, "Y");
if (crc32("lRebF",5) == 2106347059) strcat(s, "t");
if (crc32("ycAggjML",8) == 1517931649) strcat(s, "i");
if (crc32("CkglIbAvBe",10) == 2657415210) strcat(s, "Z");
if (crc32("bBrGnY",6) == 2347194608) strcat(s, "v");
if (crc32("xLFQPg",6) == 46203089) strcat(s, "C");
if (crc32("PZNyUyCUMGGERdP",15) == 3754478155) strcat(s, "e");
    return s;
}

char *unimplanted_adjectives() {
    char *s = calloc(12);
    if (crc32("LlzKVg",6) == 3537952008) strcat(s, "u");
if (crc32("WUzTk",5) == 4267331803) strcat(s, "s");
if (crc32("FTxrdEhqEuadG",13) == 4012315459) strcat(s, "n");
if (crc32("aMjpoYjFpI",10) == 2792028944) strcat(s, "Q");
if (crc32("SmTPoejxlw",10) == 1327270988) strcat(s, "i");
if (crc32("toibUnNwcayjKP",14) == 1985310922) strcat(s, "m");
if (crc32("lJTLLkMlFy",10) == 1833172) strcat(s, "m");
if (crc32("oiJNL",5) == 406166342) strcat(s, "C");
if (crc32("nGdYQn",6) == 3077316337) strcat(s, "p");
if (crc32("JJSovOeoGJfO",12) == 1907536107) strcat(s, "l");
if (crc32("MlstHwW",7) == 717578148) strcat(s, "Q");
if (crc32("RLTLmad",7) == 1004258477) strcat(s, "a");
if (crc32("NEWpWwjYgZIpPb",14) == 3106861323) strcat(s, "n");
if (crc32("eDHDRT",6) == 253024310) strcat(s, "T");
if (crc32("YvAbukPBVjINA",13) == 765115652) strcat(s, "t");
if (crc32("gLBLvRAkzBPDCXW",15) == 403728334) strcat(s, "o");
if (crc32("LpabHxVQGGWmVAC",15) == 174527583) strcat(s, "e");
if (crc32("rEBwBHoCZw",10) == 1929080268) strcat(s, "d");
    return s;
}

char *unforeseeing_adjectives() {
    char *s = calloc(13);
    if (crc32("OzCriRNE",8) == 2516836067) strcat(s, "u");
if (crc32("ugqTebmRf",9) == 4233749013) strcat(s, "e");
if (crc32("XilMYPshopGgBn",14) == 4071682055) strcat(s, "n");
if (crc32("jSumuTbb",8) == 3478806573) strcat(s, "f");
if (crc32("wQfRUn",6) == 475443033) strcat(s, "t");
if (crc32("BKTOqRvLOllPs",13) == 2857518985) strcat(s, "o");
if (crc32("epTsVVZsHrOJ",12) == 1559903899) strcat(s, "Z");
if (crc32("fbJAXKinQ",9) == 2611164266) strcat(s, "r");
if (crc32("BdXTVEhEHwJkbkU",15) == 2090785165) strcat(s, "M");
if (crc32("jOIBupxHwp",10) == 2204515124) strcat(s, "e");
if (crc32("SpuSfGQ",7) == 1725225049) strcat(s, "C");
if (crc32("EPiBlWThHPgKb",13) == 2866142943) strcat(s, "s");
if (crc32("ikTOUwac",8) == 1807422174) strcat(s, "e");
if (crc32("oQLcPCQ",7) == 945063569) strcat(s, "e");
if (crc32("oCOEdHqYYgyB",12) == 3733440914) strcat(s, "i");
if (crc32("DCrOsvQUFuPvT",13) == 3396531575) strcat(s, "d");
if (crc32("EIduJcTqoK",10) == 1639911798) strcat(s, "n");
if (crc32("bTyJxy",6) == 2624109471) strcat(s, "g");
    return s;
}

char *unattributive_adjectives() {
    char *s = calloc(14);
    if (crc32("qUpdKnMNYeRmihe",15) == 4020377773) strcat(s, "U");
if (crc32("yPWnFIkN",8) == 339223123) strcat(s, "u");
if (crc32("pvxgqdqJPl",10) == 482222842) strcat(s, "o");
if (crc32("xdPIXgNm",8) == 584813299) strcat(s, "n");
if (crc32("yjgsyXDP",8) == 3651053679) strcat(s, "a");
if (crc32("tsoYOnfRFyxONV",14) == 835825081) strcat(s, "t");
if (crc32("PzobxQ",6) == 1195080618) strcat(s, "t");
if (crc32("QGpyyR",6) == 3611623308) strcat(s, "t");
if (crc32("KCiSY",5) == 1009617095) strcat(s, "f");
if (crc32("NJkHVwStxPsga",13) == 227610787) strcat(s, "r");
if (crc32("wnorhuwG",8) == 1189097517) strcat(s, "i");
if (crc32("jdIbIDqcQ",9) == 1427417291) strcat(s, "H");
if (crc32("YCkycJSuj",9) == 2174239299) strcat(s, "b");
if (crc32("aaziLESdQOO",11) == 2246344528) strcat(s, "u");
if (crc32("ZBDTKggiL",9) == 1116317519) strcat(s, "t");
if (crc32("jbkhDjqfmzk",11) == 1572692547) strcat(s, "i");
if (crc32("yuSggvYhRDcTE",13) == 3438843691) strcat(s, "B");
if (crc32("CrbQmLCKvLqzOL",14) == 1948591765) strcat(s, "v");
if (crc32("KCqCcVKwy",9) == 2125275876) strcat(s, "U");
if (crc32("UOQqmnbZUbeJx",13) == 1533316221) strcat(s, "e");
    return s;
}

char *unpacific_adjectives() {
    char *s = calloc(10);
    if (crc32("ZJyWX",5) == 2871729750) strcat(s, "z");
if (crc32("GFdWOZGzlj",10) == 932198758) strcat(s, "u");
if (crc32("vKcRjurHk",9) == 1194899568) strcat(s, "o");
if (crc32("EwjLKEcGZh",10) == 1739332474) strcat(s, "n");
if (crc32("yOXjnqphxhCfL",13) == 2734919381) strcat(s, "J");
if (crc32("YDsEPB",6) == 444742564) strcat(s, "p");
if (crc32("ArZqMssyxBPu",12) == 1855913652) strcat(s, "a");
if (crc32("ydeOZ",5) == 2066813238) strcat(s, "c");
if (crc32("gFziUQDgPC",10) == 188197138) strcat(s, "c");
if (crc32("GIekebWcwUJQbk",14) == 1587367817) strcat(s, "i");
if (crc32("GTNEifesT",9) == 1783634263) strcat(s, "f");
if (crc32("NedVlGiRxj",10) == 2362486273) strcat(s, "y");
if (crc32("PCeMXylQAMQ",11) == 4183784755) strcat(s, "i");
if (crc32("VjozmOu",7) == 2087125409) strcat(s, "c");
    return s;
}

char *narcoleptic_adjectives() {
    char *s = calloc(12);
    if (crc32("tlbBMmijnU",10) == 3595584465) strcat(s, "n");
if (crc32("mpRqaFnMq",9) == 1421642471) strcat(s, "B");
if (crc32("GUwZlpZ",7) == 1250766220) strcat(s, "a");
if (crc32("lJclgYNHPlgFKx",14) == 1794738999) strcat(s, "B");
if (crc32("vEeOWuASKZcAXRY",15) == 3663143338) strcat(s, "r");
if (crc32("nTORoSriiTXu",12) == 3985796270) strcat(s, "V");
if (crc32("AHsPDJahdXtJ",12) == 4282628036) strcat(s, "c");
if (crc32("MKGOKoHPGWdDO",13) == 2334256754) strcat(s, "o");
if (crc32("VnKaRmydMOhd",12) == 3486365668) strcat(s, "l");
if (crc32("cnBUPSAw",8) == 3495469509) strcat(s, "e");
if (crc32("pwrFZMOkQ",9) == 1341146289) strcat(s, "F");
if (crc32("tiTkHjm",7) == 1503407725) strcat(s, "p");
if (crc32("JPsDpZY",7) == 2508393715) strcat(s, "i");
if (crc32("AqZoWP",6) == 3370010793) strcat(s, "t");
if (crc32("aINDHPr",7) == 292977653) strcat(s, "i");
if (crc32("ZPCUHtnxpqpN",12) == 20663906) strcat(s, "c");
    return s;
}

char *persevering_adjectives() {
    char *s = calloc(12);
    if (crc32("ZmUMMaNDJnJ",11) == 1516859196) strcat(s, "p");
if (crc32("IBdmFUh",7) == 2653707490) strcat(s, "a");
if (crc32("kZOynNwv",8) == 489682104) strcat(s, "e");
if (crc32("NnxjsLL",7) == 1234902481) strcat(s, "e");
if (crc32("fHZlkxZcehkcvf",14) == 1477825331) strcat(s, "r");
if (crc32("HvaSRf",6) == 3848783865) strcat(s, "s");
if (crc32("cdVkCoTLNsD",11) == 1774400093) strcat(s, "e");
if (crc32("UZDLTwrWJCjnS",13) == 459486170) strcat(s, "v");
if (crc32("BzBoUbbKLBsrO",13) == 1617839162) strcat(s, "e");
if (crc32("kmZWqU",6) == 125711236) strcat(s, "n");
if (crc32("AntwSJyy",8) == 4081908439) strcat(s, "r");
if (crc32("wVShLPwOoI",10) == 3043352980) strcat(s, "i");
if (crc32("WXRvpcZbWttvoGA",15) == 2481345112) strcat(s, "l");
if (crc32("dWthqID",7) == 82273670) strcat(s, "n");
if (crc32("WzVEwJ",6) == 2104179048) strcat(s, "g");
    return s;
}

char *sibyllic_adjectives() {
    char *s = calloc(9);
    if (crc32("YLLLGVXFc",9) == 3619289213) strcat(s, "o");
if (crc32("EArZZjW",7) == 1674570780) strcat(s, "s");
if (crc32("UIwEUBCBlHoXrV",14) == 161835776) strcat(s, "y");
if (crc32("YqzvZADQyj",10) == 292544855) strcat(s, "i");
if (crc32("OLAlOozK",8) == 726087200) strcat(s, "I");
if (crc32("KFLWtWhEglWRhc",14) == 1398577360) strcat(s, "b");
if (crc32("KKfFwUEYgclHsnu",15) == 2783465888) strcat(s, "y");
if (crc32("aDciZJp",7) == 1325520961) strcat(s, "v");
if (crc32("xgHbmdULAfr",11) == 1327032091) strcat(s, "l");
if (crc32("uSClT",5) == 3046208533) strcat(s, "r");
if (crc32("mcliqRKfheWUIoc",15) == 2952185219) strcat(s, "l");
if (crc32("VhysdPd",7) == 188520673) strcat(s, "i");
if (crc32("qkKTKBYncBsCBV",14) == 651758145) strcat(s, "W");
if (crc32("YCQeMdqWMWDGW",13) == 2745035104) strcat(s, "c");
    return s;
}

char *toylike_adjectives() {
    char *s = calloc(8);
    if (crc32("Gkubaq",6) == 1783155909) strcat(s, "A");
if (crc32("rxyAJWPgXVK",11) == 2435983236) strcat(s, "t");
if (crc32("ZAycSsvVzT",10) == 651164901) strcat(s, "o");
if (crc32("gopJB",5) == 1220564086) strcat(s, "y");
if (crc32("myAzwtiTHtM",11) == 2048222542) strcat(s, "n");
if (crc32("KKAnSwGvxsF",11) == 2515416303) strcat(s, "l");
if (crc32("gWFIGmefdQGQ",12) == 3863616799) strcat(s, "h");
if (crc32("blSMPaQmXa",10) == 2702167611) strcat(s, "i");
if (crc32("KxjWJdEnK",9) == 823171347) strcat(s, "k");
if (crc32("MNDNPRyeHFnksQ",14) == 3465550865) strcat(s, "J");
if (crc32("XsJajQB",7) == 4010530064) strcat(s, "e");
    return s;
}

char *shoddy_adjectives() {
    char *s = calloc(7);
    if (crc32("NtJAyzHdI",9) == 2086988038) strcat(s, "s");
if (crc32("RICEliF",7) == 3634753757) strcat(s, "h");
if (crc32("esujoZx",7) == 4059855686) strcat(s, "o");
if (crc32("jdFXPu",6) == 860090865) strcat(s, "N");
if (crc32("KJdMnempitK",11) == 3222786510) strcat(s, "d");
if (crc32("wvxgWHOQjAHu",12) == 242888840) strcat(s, "d");
if (crc32("qXQsmdblevaKF",13) == 3055320400) strcat(s, "y");
    return s;
}

char *doublebreasted_adjectives() {
    char *s = calloc(15);
    if (crc32("EsUqiEvWC",9) == 2482744969) strcat(s, "d");
if (crc32("fdwatFJhC",9) == 4201105638) strcat(s, "o");
if (crc32("JCeLQoIdn",9) == 425043185) strcat(s, "u");
if (crc32("wgRPlMc",7) == 3993809201) strcat(s, "X");
if (crc32("iHVUq",5) == 2220828746) strcat(s, "b");
if (crc32("MzyQGTWWHc",10) == 4223284074) strcat(s, "w");
if (crc32("ntPWsDrOuYFMYp",14) == 3503646625) strcat(s, "l");
if (crc32("ZwDOhze",7) == 3425074223) strcat(s, "e");
if (crc32("RDBgHWpv",8) == 761635916) strcat(s, "e");
if (crc32("KlzfAcg",7) == 3844557317) strcat(s, "b");
if (crc32("DDJuPDX",7) == 1784327007) strcat(s, "r");
if (crc32("vYUGvRu",7) == 939257320) strcat(s, "e");
if (crc32("tPPrEpfLwMTV",12) == 1604870993) strcat(s, "a");
if (crc32("ieASwEt",7) == 3968395684) strcat(s, "s");
if (crc32("nkrcreethlrG",12) == 1336905150) strcat(s, "e");
if (crc32("QSBwYMQJOCNkJD",14) == 1655064024) strcat(s, "t");
if (crc32("dFrTNmXdSAd",11) == 2094162942) strcat(s, "h");
if (crc32("FaPlomQoCdc",11) == 2518513138) strcat(s, "e");
if (crc32("isgNuskZvEYjm",13) == 2123752231) strcat(s, "N");
if (crc32("SCkKW",5) == 2452669325) strcat(s, "d");
    return s;
}

char *overambitioned_adjectives() {
    char *s = calloc(15);
    if (crc32("LhLZdOPJ",8) == 988184712) strcat(s, "K");
if (crc32("TzOAUuanTz",10) == 3868993862) strcat(s, "o");
if (crc32("lGNvgAZLAjN",11) == 3656435093) strcat(s, "O");
if (crc32("mPmfmIeENH",10) == 2610212858) strcat(s, "v");
if (crc32("FconWcNNA",9) == 3965739820) strcat(s, "e");
if (crc32("HzUgJaGUjF",10) == 1043690752) strcat(s, "r");
if (crc32("QfADaGcCD",9) == 1548560467) strcat(s, "u");
if (crc32("YelTYXk",7) == 2698679801) strcat(s, "a");
if (crc32("ykkszlEmgxKIPY",14) == 3583599389) strcat(s, "m");
if (crc32("UBsnqnaeVcbor",13) == 2983939497) strcat(s, "b");
if (crc32("iaiguwqb",8) == 459911391) strcat(s, "i");
if (crc32("XVzpfzVtO",9) == 671219649) strcat(s, "t");
if (crc32("qQeCay",6) == 1607745130) strcat(s, "i");
if (crc32("ilgPWMuIfaRz",12) == 1899413086) strcat(s, "e");
if (crc32("fzYjwIYKuoZMlG",14) == 3790116395) strcat(s, "o");
if (crc32("Lohuh",5) == 1870748481) strcat(s, "n");
if (crc32("MjHLZgQcGybvN",13) == 3063617505) strcat(s, "e");
if (crc32("iJRbRhscf",9) == 1595261692) strcat(s, "d");
    return s;
}

char *unfervid_adjectives() {
    char *s = calloc(9);
    if (crc32("PpljsjQnmS",10) == 1329725566) strcat(s, "u");
if (crc32("otOYHlZprkb",11) == 2143641380) strcat(s, "n");
if (crc32("MKyLZh",6) == 1204203492) strcat(s, "l");
if (crc32("TVmdvDcxSMXW",12) == 1243307328) strcat(s, "f");
if (crc32("ZkhrvJbXLZpc",12) == 3286675976) strcat(s, "y");
if (crc32("OySIPMafy",9) == 1817252296) strcat(s, "e");
if (crc32("sieFYa",6) == 2438808266) strcat(s, "e");
if (crc32("YmDRWbKIQogBJh",14) == 3457623661) strcat(s, "r");
if (crc32("wQPaPs",6) == 1396287942) strcat(s, "v");
if (crc32("iQKUMgAOiPOLkZn",15) == 128516332) strcat(s, "i");
if (crc32("AitUSMdttFA",11) == 2625058308) strcat(s, "x");
if (crc32("lVvMQMxr",8) == 2372227470) strcat(s, "d");
    return s;
}

char *preseminal_adjectives() {
    char *s = calloc(11);
    if (crc32("sRioINMwtXg",11) == 3151506493) strcat(s, "Z");
if (crc32("WGnRpCZt",8) == 3315535678) strcat(s, "p");
if (crc32("ATnjsgvuKTlBa",13) == 2170148393) strcat(s, "r");
if (crc32("SOxvyFExiRA",11) == 1458656656) strcat(s, "X");
if (crc32("ImSXrbtj",8) == 1471780404) strcat(s, "e");
if (crc32("EeryLcTKdo",10) == 1205028824) strcat(s, "s");
if (crc32("bpNwvDDJFSCVWV",14) == 232974916) strcat(s, "s");
if (crc32("zqpXGTuW",8) == 4178355193) strcat(s, "i");
if (crc32("jtvXsvEALi",10) == 3155275228) strcat(s, "e");
if (crc32("eSAjYkLexQzhNm",14) == 3037609181) strcat(s, "m");
if (crc32("iGARe",5) == 2429472595) strcat(s, "i");
if (crc32("NNOktGRUVaGpS",13) == 2159679344) strcat(s, "U");
if (crc32("UkYisLocIheTV",13) == 2434805561) strcat(s, "n");
if (crc32("DlsDCcOt",8) == 2785937651) strcat(s, "v");
if (crc32("rcxZUAmpIFStcOJ",15) == 4276543489) strcat(s, "a");
if (crc32("TmNvLdNSLUJkeoR",15) == 2772057985) strcat(s, "l");
    return s;
}

char *tarsal_adjectives() {
    char *s = calloc(7);
    if (crc32("EkijVPxAcBoZNKV",15) == 2374444059) strcat(s, "t");
if (crc32("TlBTlKriyhltgu",14) == 2635847967) strcat(s, "s");
if (crc32("ZVHlLIejsBtw",12) == 2702462525) strcat(s, "a");
if (crc32("IhWHpGHOpGueISo",15) == 1909749721) strcat(s, "r");
if (crc32("vYxCuLzdEzj",11) == 1745945218) strcat(s, "D");
if (crc32("DgzjZ",5) == 2154434671) strcat(s, "s");
if (crc32("xHOASqALA",9) == 2704446584) strcat(s, "a");
if (crc32("HBGCJIJo",8) == 498708348) strcat(s, "l");
    return s;
}

char *stratospheric_adjectives() {
    char *s = calloc(14);
    if (crc32("xgCvWVxhX",9) == 2876972628) strcat(s, "O");
if (crc32("bmDBbIRFCJS",11) == 3977940788) strcat(s, "s");
if (crc32("yopazd",6) == 509085901) strcat(s, "z");
if (crc32("XPsPLjJKxP",10) == 2514636273) strcat(s, "t");
if (crc32("aHjUrcRqMjseWwP",15) == 849177259) strcat(s, "r");
if (crc32("rvzygjjKmSrX",12) == 1465993450) strcat(s, "r");
if (crc32("IRobHPnnNkVBwmp",15) == 3844819463) strcat(s, "a");
if (crc32("SuanMZxNFuaQKba",15) == 1243467763) strcat(s, "t");
if (crc32("ScsBtRhooQFhC",13) == 3170177385) strcat(s, "o");
if (crc32("gJOEsfKJrcbUgE",14) == 3975521572) strcat(s, "d");
if (crc32("yDICGeUZaz",10) == 1004041942) strcat(s, "s");
if (crc32("wohOMO",6) == 4093958196) strcat(s, "M");
if (crc32("EGPTVAtpG",9) == 3843707454) strcat(s, "p");
if (crc32("OfwxEYzIq",9) == 654718954) strcat(s, "L");
if (crc32("wSSBPr",6) == 1983946087) strcat(s, "h");
if (crc32("TImgvpjTtDzvmTr",15) == 2151167441) strcat(s, "e");
if (crc32("BcZCtFrJwEtAZzL",15) == 669462882) strcat(s, "s");
if (crc32("YVXdxZPWo",9) == 28782204) strcat(s, "r");
if (crc32("WpsTKO",6) == 3192535794) strcat(s, "i");
if (crc32("HZBZlfgPzOM",11) == 2968694860) strcat(s, "d");
if (crc32("yCQscLrHm",9) == 1183430540) strcat(s, "c");
    return s;
}

char *sugarcane_adjectives() {
    char *s = calloc(10);
    if (crc32("igdOyIEZRYNgRq",14) == 2641921561) strcat(s, "s");
if (crc32("ZUdPGAyNMEqq",12) == 183314902) strcat(s, "u");
if (crc32("RaojCR",6) == 1663335560) strcat(s, "W");
if (crc32("gCIPaKuVRbsOVsK",15) == 3933534107) strcat(s, "g");
if (crc32("vTAMJeZy",8) == 1864107138) strcat(s, "J");
if (crc32("BotwbE",6) == 212737916) strcat(s, "a");
if (crc32("yNtpGRtxpUQacW",14) == 2792508471) strcat(s, "r");
if (crc32("MnJgYl",6) == 500717028) strcat(s, "O");
if (crc32("TuIXR",5) == 3743194995) strcat(s, "c");
if (crc32("PJDrGCLnTt",10) == 3490007515) strcat(s, "W");
if (crc32("UNFlmS",6) == 3619815118) strcat(s, "a");
if (crc32("QClppLuojiLG",12) == 1615219016) strcat(s, "n");
if (crc32("naRYrnUlJnLou",13) == 3454143712) strcat(s, "q");
if (crc32("fcrUBMoCKtS",11) == 499839013) strcat(s, "e");
    return s;
}

char *histaminic_adjectives() {
    char *s = calloc(11);
    if (crc32("jIDpA",5) == 3311906020) strcat(s, "s");
if (crc32("IIuWkfImNLDuVG",14) == 3651777112) strcat(s, "h");
if (crc32("imtmXYvh",8) == 3861819551) strcat(s, "i");
if (crc32("aTjrmezgK",9) == 2303537267) strcat(s, "k");
if (crc32("kmKHoYVLD",9) == 1056792585) strcat(s, "s");
if (crc32("AMRpHVBTl",9) == 1295552242) strcat(s, "t");
if (crc32("HwfBrANhr",9) == 3527820830) strcat(s, "j");
if (crc32("uBHaMp",6) == 3396970313) strcat(s, "a");
if (crc32("CrMoZNRvDENM",12) == 3569572088) strcat(s, "O");
if (crc32("xJHHSIhaerEvO",13) == 2877173372) strcat(s, "m");
if (crc32("vOzHASKFX",9) == 1234028840) strcat(s, "E");
if (crc32("GdkBD",5) == 1875484639) strcat(s, "i");
if (crc32("ETLjGuAdXgXgC",13) == 1995908850) strcat(s, "s");
if (crc32("BJxqbOgH",8) == 1970321322) strcat(s, "n");
if (crc32("GExnLQLuo",9) == 3692074875) strcat(s, "T");
if (crc32("DesMYmrN",8) == 1187642387) strcat(s, "i");
if (crc32("FMJJv",5) == 3771153508) strcat(s, "w");
if (crc32("QeoqBJxu",8) == 2477380974) strcat(s, "c");
    return s;
}

char *superpure_adjectives() {
    char *s = calloc(10);
    if (crc32("WMqpMK",6) == 595657709) strcat(s, "s");
if (crc32("nfmub",5) == 1945721504) strcat(s, "b");
if (crc32("ShZPSVvm",8) == 1748761679) strcat(s, "u");
if (crc32("fCKVUt",6) == 3300720247) strcat(s, "p");
if (crc32("FCueTpxV",8) == 2155800626) strcat(s, "e");
if (crc32("jkJEzwGviJ",10) == 3235215667) strcat(s, "r");
if (crc32("EMtmGTHWFAC",11) == 243350974) strcat(s, "f");
if (crc32("DJZgiRCksaoCJz",14) == 2081527518) strcat(s, "p");
if (crc32("mUZJTECaQHhFJ",13) == 609214627) strcat(s, "u");
if (crc32("fyqjosLUX",9) == 537623045) strcat(s, "r");
if (crc32("ZcDMVK",6) == 2745054364) strcat(s, "e");
    return s;
}

char *wellirrigated_adjectives() {
    char *s = calloc(14);
    if (crc32("npgWQWMRr",9) == 3545385284) strcat(s, "D");
if (crc32("EbcNYjsyzXDGfs",14) == 1330492489) strcat(s, "w");
if (crc32("sQMeXEU",7) == 3741660256) strcat(s, "e");
if (crc32("gBmrNN",6) == 2001353736) strcat(s, "p");
if (crc32("lixsSWqv",8) == 2588046047) strcat(s, "l");
if (crc32("cdEBTbCgXzYpsn",14) == 4254271392) strcat(s, "l");
if (crc32("baJVRNPCGPPRWM",14) == 3718946161) strcat(s, "i");
if (crc32("VQOrSOOxx",9) == 4099820333) strcat(s, "r");
if (crc32("tmZbKolcA",9) == 1157724905) strcat(s, "f");
if (crc32("DVUxFkGnDhJs",12) == 264864560) strcat(s, "r");
if (crc32("SVxhy",5) == 2313683879) strcat(s, "i");
if (crc32("GprziAmWylm",11) == 2480924582) strcat(s, "v");
if (crc32("PvPfOsFrhw",10) == 2924757553) strcat(s, "g");
if (crc32("zRPSYJvUuOggWyR",15) == 107552143) strcat(s, "A");
if (crc32("Efydkbuq",8) == 2123908334) strcat(s, "a");
if (crc32("jRnSSLYXkizgf",13) == 1746972513) strcat(s, "J");
if (crc32("KarRnqsacc",10) == 3360648707) strcat(s, "t");
if (crc32("ouARgYuTGQTmi",13) == 2113353822) strcat(s, "e");
if (crc32("RGKZpLmtqDJYHVu",15) == 1857416040) strcat(s, "d");
    return s;
}

char *transNiger_adjectives() {
    char *s = calloc(11);
    if (crc32("aEXwFfJJCKORY",13) == 3845592683) strcat(s, "t");
if (crc32("uFzehQdfqU",10) == 24664745) strcat(s, "w");
if (crc32("dNFKLVYbVzaEImm",15) == 2473741258) strcat(s, "r");
if (crc32("eTNiAEVJAafPPc",14) == 4226756291) strcat(s, "v");
if (crc32("dFDnPdTcgtm",11) == 1061759644) strcat(s, "a");
if (crc32("soPsYVpkjMwA",12) == 1597299223) strcat(s, "u");
if (crc32("tnXStrLrxUQN",12) == 3782883759) strcat(s, "n");
if (crc32("peSKYltcUeZPlyR",15) == 3177972354) strcat(s, "s");
if (crc32("ITedngL",7) == 703146925) strcat(s, "N");
if (crc32("sbvAfO",6) == 894333558) strcat(s, "i");
if (crc32("ChoXIcJD",8) == 3786944586) strcat(s, "z");
if (crc32("wibnyPC",7) == 2904413685) strcat(s, "g");
if (crc32("TADZSBKNhYF",11) == 2719726338) strcat(s, "z");
if (crc32("fewzmTgqbWS",11) == 2220809748) strcat(s, "e");
if (crc32("hqrvoCrgDjq",11) == 841188403) strcat(s, "r");
    return s;
}

char *leaky_adjectives() {
    char *s = calloc(6);
    if (crc32("ZQafeEAsms",10) == 1158615904) strcat(s, "G");
if (crc32("uhznXtRGVkLXN",13) == 3542586911) strcat(s, "l");
if (crc32("QmRxvChHcvc",11) == 546700519) strcat(s, "U");
if (crc32("nboCkO",6) == 289263877) strcat(s, "e");
if (crc32("PbJuQpOerzb",11) == 283485365) strcat(s, "a");
if (crc32("iAxENSd",7) == 2204305308) strcat(s, "k");
if (crc32("wRJzaVqAJiK",11) == 1331936852) strcat(s, "y");
    return s;
}

char *triable_adjectives() {
    char *s = calloc(8);
    if (crc32("oQxYAJT",7) == 1648117999) strcat(s, "X");
if (crc32("UCpipLcSyIK",11) == 547982346) strcat(s, "t");
if (crc32("cgphJTtJD",9) == 804612070) strcat(s, "r");
if (crc32("ihBxQS",6) == 222693048) strcat(s, "i");
if (crc32("luWFoXdkIxsdNKV",15) == 1694937229) strcat(s, "O");
if (crc32("neJnrb",6) == 3669717703) strcat(s, "a");
if (crc32("acrFy",5) == 848532139) strcat(s, "Y");
if (crc32("iFtIYBxPeIoK",12) == 1258766640) strcat(s, "b");
if (crc32("CboAykDFPn",10) == 1580036226) strcat(s, "F");
if (crc32("JcFHRSXbV",9) == 453397542) strcat(s, "l");
if (crc32("CpmGurttAdfuD",13) == 2935945320) strcat(s, "e");
    return s;
}

char *untorn_adjectives() {
    char *s = calloc(7);
    if (crc32("gntZC",5) == 3400579336) strcat(s, "u");
if (crc32("miHsSTeCKmLdBgl",15) == 1146180047) strcat(s, "J");
if (crc32("TsLgDdXYxJso",12) == 2458242549) strcat(s, "n");
if (crc32("ragEe",5) == 1857196671) strcat(s, "r");
if (crc32("XgcnoOz",7) == 427199764) strcat(s, "t");
if (crc32("WmCZffdwzpxGsOh",15) == 2950182894) strcat(s, "C");
if (crc32("byqCt",5) == 3941111714) strcat(s, "o");
if (crc32("mtJzHWzBCJK",11) == 3266866437) strcat(s, "I");
if (crc32("xSqDwfc",7) == 2929180520) strcat(s, "r");
if (crc32("xnQyM",5) == 3969382408) strcat(s, "D");
if (crc32("BgXgMVnCPiQb",12) == 528781828) strcat(s, "n");
    return s;
}

char *quasiexceptional_adjectives() {
    char *s = calloc(17);
    if (crc32("BTfzRr",6) == 1332480336) strcat(s, "q");
if (crc32("ipYDtjW",7) == 2431663791) strcat(s, "u");
if (crc32("swgDXRLZU",9) == 416837124) strcat(s, "a");
if (crc32("AMAfGJ",6) == 2472942868) strcat(s, "s");
if (crc32("ARPzrfqR",8) == 3047076599) strcat(s, "i");
if (crc32("neIkjcvBXOaLX",13) == 2635505989) strcat(s, "B");
if (crc32("luTKRCleF",9) == 123858074) strcat(s, "e");
if (crc32("mdSxpiFhwB",10) == 2997084363) strcat(s, "G");
if (crc32("lwPcEwJ",7) == 1459313444) strcat(s, "x");
if (crc32("IpczLkPHShNB",12) == 2689265920) strcat(s, "G");
if (crc32("nqAHnwe",7) == 2722605893) strcat(s, "c");
if (crc32("CYsAUsC",7) == 3747912358) strcat(s, "e");
if (crc32("dhSKUpFzBcjCEA",14) == 3398621440) strcat(s, "s");
if (crc32("icfKIDgrc",9) == 15402008) strcat(s, "p");
if (crc32("JOwuJ",5) == 2196350070) strcat(s, "t");
if (crc32("nXmEadqwuRN",11) == 3365585577) strcat(s, "i");
if (crc32("ppzUJy",6) == 243830297) strcat(s, "o");
if (crc32("cJnLi",5) == 2871021393) strcat(s, "C");
if (crc32("zNLmJIonLJTSv",13) == 3058134972) strcat(s, "n");
if (crc32("UxhipDFmusEEIKK",15) == 1595069957) strcat(s, "a");
if (crc32("MDLxyUrIhpURfrO",15) == 455853823) strcat(s, "l");
    return s;
}

char *quinquefoliate_adjectives() {
    char *s = calloc(15);
    if (crc32("ordForMW",8) == 3609256621) strcat(s, "q");
if (crc32("nvcXpMvzVEdqNo",14) == 4071273654) strcat(s, "u");
if (crc32("wusIglkcI",9) == 1061502560) strcat(s, "F");
if (crc32("HMrazGFiRTpjfD",14) == 1244260784) strcat(s, "i");
if (crc32("dpEpqW",6) == 2165843346) strcat(s, "o");
if (crc32("eSwUxzpkCArTO",13) == 1961036742) strcat(s, "n");
if (crc32("XxJtZM",6) == 2010476561) strcat(s, "q");
if (crc32("lNmZEGJiEkLjgVU",15) == 2636667845) strcat(s, "u");
if (crc32("rmpcxCxD",8) == 1313733846) strcat(s, "k");
if (crc32("RDzXXpOQguGqYA",14) == 1409567408) strcat(s, "e");
if (crc32("NCQXSJXsBqPjSc",14) == 836995071) strcat(s, "f");
if (crc32("jfjlHGQGCUqpxT",14) == 3825191318) strcat(s, "o");
if (crc32("czAmIDJ",7) == 1543728454) strcat(s, "l");
if (crc32("jgEKjhXDiTMFf",13) == 3712961514) strcat(s, "b");
if (crc32("zVgGDHBjRnWQT",13) == 1704075975) strcat(s, "i");
if (crc32("wAEgKmy",7) == 3433210575) strcat(s, "s");
if (crc32("WECZyKBRCCSYAwG",15) == 420433824) strcat(s, "a");
if (crc32("AwlzmDiXYh",10) == 460020308) strcat(s, "k");
if (crc32("SePIdWmYnTChY",13) == 561693625) strcat(s, "t");
if (crc32("TazCqUndRKwiX",13) == 548792700) strcat(s, "e");
    return s;
}

char *icicled_adjectives() {
    char *s = calloc(8);
    if (crc32("zMyWCKE",7) == 2852281848) strcat(s, "z");
if (crc32("skRqfsCTHGNJb",13) == 988228584) strcat(s, "i");
if (crc32("FpSZyrw",7) == 3806225429) strcat(s, "c");
if (crc32("XTwAsGNmtl",10) == 1911047486) strcat(s, "i");
if (crc32("UKyNHJ",6) == 4188713855) strcat(s, "a");
if (crc32("TZdOouJbvUpNj",13) == 1085746458) strcat(s, "c");
if (crc32("VysxUZAGstbym",13) == 3542026287) strcat(s, "I");
if (crc32("qihiej",6) == 3924251164) strcat(s, "l");
if (crc32("pzcUiSfTSMBOmC",14) == 357404677) strcat(s, "e");
if (crc32("mHZpM",5) == 3210337166) strcat(s, "d");
    return s;
}

char *ungraphable_adjectives() {
    char *s = calloc(12);
    if (crc32("yHwYrvUSzPsGyv",14) == 2450717568) strcat(s, "Q");
if (crc32("EtsJJ",5) == 2017775335) strcat(s, "u");
if (crc32("KDhrbBHDs",9) == 416622927) strcat(s, "n");
if (crc32("uBoBCI",6) == 3530246402) strcat(s, "H");
if (crc32("rLgHTFZWuvM",11) == 2196047239) strcat(s, "g");
if (crc32("DTgFJRuwn",9) == 1926751660) strcat(s, "S");
if (crc32("gfXKpOprPr",10) == 3598505246) strcat(s, "r");
if (crc32("eNuCslITC",9) == 2059234117) strcat(s, "a");
if (crc32("DsyCiIyKHfW",11) == 1354423023) strcat(s, "g");
if (crc32("udsQOR",6) == 1626326203) strcat(s, "p");
if (crc32("iwIcFovlmIbg",12) == 1905189227) strcat(s, "l");
if (crc32("rlUElBs",7) == 2400847532) strcat(s, "h");
if (crc32("jCPNlsqgAPgW",12) == 343346008) strcat(s, "I");
if (crc32("NDQemhrvVBobpfn",15) == 1681736134) strcat(s, "a");
if (crc32("neZnv",5) == 558532574) strcat(s, "j");
if (crc32("FiHKYyjvIbxfvXA",15) == 1904114805) strcat(s, "b");
if (crc32("fJqHctIlkvpgT",13) == 2556146358) strcat(s, "l");
if (crc32("RYtLMRFHmwfqM",13) == 341463810) strcat(s, "e");
    return s;
}

char *triploid_adjectives() {
    char *s = calloc(9);
    if (crc32("KaddwKKhxAM",11) == 3076813404) strcat(s, "M");
if (crc32("XjbBcud",7) == 2765143426) strcat(s, "t");
if (crc32("pGwfkXXstRXHnMl",15) == 2058093610) strcat(s, "I");
if (crc32("UmOlNQaQX",9) == 1126233447) strcat(s, "r");
if (crc32("wfaZzNkYMfJe",12) == 650216124) strcat(s, "i");
if (crc32("tzgNCQN",7) == 1060352681) strcat(s, "p");
if (crc32("wMslHeeB",8) == 2818273341) strcat(s, "l");
if (crc32("IePZLKRCfHCuaFK",15) == 3149627977) strcat(s, "o");
if (crc32("XImLUudW",8) == 883926359) strcat(s, "o");
if (crc32("hkXwHFzTxbqnaMJ",15) == 3459238041) strcat(s, "i");
if (crc32("fAtbqJCCNdA",11) == 2858536400) strcat(s, "Q");
if (crc32("XOaYSLywDtKF",12) == 279407012) strcat(s, "d");
    return s;
}

char *nonalternating_adjectives() {
    char *s = calloc(15);
    if (crc32("CnAKh",5) == 590663143) strcat(s, "n");
if (crc32("OLooZNVCBVNiR",13) == 3599327677) strcat(s, "o");
if (crc32("LmMfY",5) == 1837956569) strcat(s, "o");
if (crc32("IxLHzKmaAT",10) == 1127214066) strcat(s, "n");
if (crc32("BvGZjCXwiOHVgMr",15) == 802461675) strcat(s, "s");
if (crc32("qPsiRorvnHg",11) == 3257147445) strcat(s, "a");
if (crc32("lpiqibUu",8) == 261727806) strcat(s, "l");
if (crc32("cHyvvtmpqp",10) == 2852310886) strcat(s, "t");
if (crc32("XjQNYFFdkrD",11) == 1216566890) strcat(s, "K");
if (crc32("wfhRxsduioUyplw",15) == 1410444911) strcat(s, "e");
if (crc32("skdlJvtCnTevm",13) == 2888014201) strcat(s, "r");
if (crc32("omlbf",5) == 2799421267) strcat(s, "n");
if (crc32("eByfEArtZKlDmg",14) == 1271179461) strcat(s, "N");
if (crc32("dkBAOCSVKTb",11) == 471867409) strcat(s, "a");
if (crc32("pftWnoOspeiz",12) == 75906166) strcat(s, "r");
if (crc32("KpdTgZjCuU",10) == 4262777007) strcat(s, "t");
if (crc32("svJIJ",5) == 4240164502) strcat(s, "i");
if (crc32("APBjOp",6) == 510413591) strcat(s, "n");
if (crc32("WZNioJ",6) == 2588626625) strcat(s, "g");
    return s;
}

char *multifibrous_adjectives() {
    char *s = calloc(13);
    if (crc32("uVrOlOZQ",8) == 198224312) strcat(s, "m");
if (crc32("atUwerQl",8) == 3403469958) strcat(s, "u");
if (crc32("SOTDeHo",7) == 51085955) strcat(s, "l");
if (crc32("bJENPdxcJe",10) == 3137724711) strcat(s, "t");
if (crc32("hbYsxeF",7) == 348820498) strcat(s, "L");
if (crc32("afAZxJv",7) == 1177657401) strcat(s, "i");
if (crc32("IcdWcx",6) == 1247569846) strcat(s, "b");
if (crc32("YzddjHKPXj",10) == 3592346410) strcat(s, "f");
if (crc32("hJocIsQs",8) == 2146836829) strcat(s, "D");
if (crc32("GTXuZLpSKfi",11) == 2908925113) strcat(s, "i");
if (crc32("kQMSte",6) == 592867615) strcat(s, "V");
if (crc32("hvlJJ",5) == 4234545556) strcat(s, "b");
if (crc32("qjsVaTivWGNRom",14) == 3642408522) strcat(s, "o");
if (crc32("NFPcvuO",7) == 2777573981) strcat(s, "r");
if (crc32("fGviAxCPooR",11) == 373679990) strcat(s, "o");
if (crc32("avSqMO",6) == 734504785) strcat(s, "u");
if (crc32("aKWydiDeG",9) == 694470879) strcat(s, "R");
if (crc32("yAxrVKG",7) == 3137880233) strcat(s, "s");
    return s;
}

char *selfdisparaging_adjectives() {
    char *s = calloc(16);
    if (crc32("JyUBRJrMSBeN",12) == 2940170649) strcat(s, "c");
if (crc32("wbkolsTDoMEyUf",14) == 78751180) strcat(s, "s");
if (crc32("iOVoY",5) == 2739072563) strcat(s, "X");
if (crc32("wvRtYqikJS",10) == 1860822914) strcat(s, "e");
if (crc32("nsihg",5) == 2690569400) strcat(s, "l");
if (crc32("FzQXjNaNviz",11) == 3531701598) strcat(s, "U");
if (crc32("vTmbyAuaSyl",11) == 693240470) strcat(s, "f");
if (crc32("bPJODmXe",8) == 3147473432) strcat(s, "d");
if (crc32("vvpXDdn",7) == 2883881326) strcat(s, "t");
if (crc32("ienamcIjMEBuz",13) == 486537897) strcat(s, "i");
if (crc32("wJrzToP",7) == 2135640950) strcat(s, "s");
if (crc32("gqNEo",5) == 347405562) strcat(s, "p");
if (crc32("aNEqyCvAl",9) == 3342002068) strcat(s, "a");
if (crc32("HFVeFOYDchvuyl",14) == 3506300805) strcat(s, "X");
if (crc32("QpvaZkTf",8) == 4091271937) strcat(s, "r");
if (crc32("HQwMpZPcaRQ",11) == 4203302447) strcat(s, "a");
if (crc32("wLwPVg",6) == 3094517316) strcat(s, "f");
if (crc32("yuFDGMKeQ",9) == 372207349) strcat(s, "g");
if (crc32("FvsJzT",6) == 2734710344) strcat(s, "i");
if (crc32("kZyBdlt",7) == 2917731466) strcat(s, "n");
if (crc32("XejjJ",5) == 175415181) strcat(s, "R");
if (crc32("SHAalnIIXu",10) == 2390459418) strcat(s, "g");
    return s;
}

char *strenuous_adjectives() {
    char *s = calloc(10);
    if (crc32("WkDGABaO",8) == 123310491) strcat(s, "s");
if (crc32("gzcVS",5) == 2144043683) strcat(s, "H");
if (crc32("SrkWHKb",7) == 3208362779) strcat(s, "t");
if (crc32("YLiEFUWyeYKFy",13) == 2314932739) strcat(s, "r");
if (crc32("LRjIiPl",7) == 3550908764) strcat(s, "e");
if (crc32("xgiXrBFTwpGhSl",14) == 1281040110) strcat(s, "n");
if (crc32("zXikAIfIMQCossK",15) == 856018152) strcat(s, "u");
if (crc32("PNeLOJM",7) == 3482409430) strcat(s, "V");
if (crc32("XEuOL",5) == 943337426) strcat(s, "o");
if (crc32("UbaJlBewAaZts",13) == 2352947514) strcat(s, "c");
if (crc32("cdEAIEhSKvepcid",15) == 3874119255) strcat(s, "u");
if (crc32("KhgdzUhh",8) == 1349994841) strcat(s, "s");
    return s;
}

char *nonstainable_adjectives() {
    char *s = calloc(13);
    if (crc32("FHVawBmOEmcOs",13) == 4046708685) strcat(s, "N");
if (crc32("dlrSodQsrGeWSg",14) == 397665630) strcat(s, "n");
if (crc32("mnYjs",5) == 1225421381) strcat(s, "o");
if (crc32("bdqhzePmlLtN",12) == 3325402799) strcat(s, "A");
if (crc32("GmMUWGHCyIWeAfT",15) == 4116283609) strcat(s, "n");
if (crc32("mlWOkP",6) == 2568239381) strcat(s, "s");
if (crc32("xpROT",5) == 2016765556) strcat(s, "i");
if (crc32("kWpWZrvxFWf",11) == 3499130120) strcat(s, "t");
if (crc32("WEmsv",5) == 497085062) strcat(s, "a");
if (crc32("pDuDeE",6) == 584912292) strcat(s, "i");
if (crc32("yQgNaAs",7) == 451734098) strcat(s, "n");
if (crc32("KoYuCmqZeafvWM",14) == 1141921639) strcat(s, "Y");
if (crc32("FJXSetTFFDSoUb",14) == 3527333764) strcat(s, "a");
if (crc32("eElXabxPOWWY",12) == 164585291) strcat(s, "M");
if (crc32("HmYlZvlKlCbb",12) == 3317489017) strcat(s, "b");
if (crc32("BIAStmQ",7) == 1162052923) strcat(s, "l");
if (crc32("VEJWYp",6) == 2496675726) strcat(s, "d");
if (crc32("cLHSwFJbVzf",11) == 4064709734) strcat(s, "e");
    return s;
}

char *selfdiscrepant_adjectives() {
    char *s = calloc(15);
    if (crc32("XadoxetwCr",10) == 1292999481) strcat(s, "s");
if (crc32("PKLIxbd",7) == 425927568) strcat(s, "a");
if (crc32("wpZGHAod",8) == 4015750415) strcat(s, "e");
if (crc32("cRomLLrSSjNJgLl",15) == 2110472968) strcat(s, "l");
if (crc32("OiSvQxHspSpKf",13) == 1614848264) strcat(s, "D");
if (crc32("mEUXKHdgT",9) == 3280986277) strcat(s, "f");
if (crc32("beUPTnTaZXftD",13) == 2509768903) strcat(s, "d");
if (crc32("yluEwjqTMY",10) == 445545312) strcat(s, "w");
if (crc32("cvuQg",5) == 1957181333) strcat(s, "i");
if (crc32("cGmVQnsQigU",11) == 2772172109) strcat(s, "r");
if (crc32("MoYXFFP",7) == 3287790778) strcat(s, "s");
if (crc32("ViBUNijKybbfVX",14) == 3789909144) strcat(s, "j");
if (crc32("IARnmuMmbE",10) == 2031257545) strcat(s, "c");
if (crc32("imgpmxyAmfeZPuf",15) == 1448705127) strcat(s, "a");
if (crc32("UFfTDBG",7) == 989410991) strcat(s, "r");
if (crc32("OrFQnkihmzFTScQ",15) == 3846839922) strcat(s, "Q");
if (crc32("zpMfAsOJlj",10) == 144686935) strcat(s, "e");
if (crc32("igFAjhwolhKP",12) == 1702601921) strcat(s, "k");
if (crc32("wdzjPTVgJdFh",12) == 3462984028) strcat(s, "p");
if (crc32("EhohSmE",7) == 840370171) strcat(s, "a");
if (crc32("FHKCixYQ",8) == 1772016508) strcat(s, "w");
if (crc32("MRkLTBxlS",9) == 2998547197) strcat(s, "n");
if (crc32("RhjNuJQThUPz",12) == 1931052598) strcat(s, "T");
if (crc32("eSxHLA",6) == 459124565) strcat(s, "t");
    return s;
}

char *unstarting_adjectives() {
    char *s = calloc(11);
    if (crc32("jsRgx",5) == 2003855667) strcat(s, "u");
if (crc32("AiIBHpWUEGJo",12) == 2427259693) strcat(s, "n");
if (crc32("VybwHpbG",8) == 1716996782) strcat(s, "w");
if (crc32("WyzJfSv",7) == 1951562101) strcat(s, "s");
if (crc32("QppftByzMgNyN",13) == 3678977776) strcat(s, "t");
if (crc32("oqjmjc",6) == 3555666312) strcat(s, "a");
if (crc32("KWaGdAiYnmu",11) == 4137590737) strcat(s, "h");
if (crc32("BpUWzDqdIyiUfA",14) == 2170772969) strcat(s, "r");
if (crc32("NiTfSXrskTL",11) == 1344325765) strcat(s, "O");
if (crc32("edRLrJm",7) == 712412170) strcat(s, "t");
if (crc32("HyRAdwS",7) == 1061454440) strcat(s, "v");
if (crc32("WRzjzS",6) == 2229967483) strcat(s, "i");
if (crc32("AHBHqNWDtZtwU",13) == 1808511553) strcat(s, "V");
if (crc32("KobfnWoLAmcAR",13) == 2681795341) strcat(s, "n");
if (crc32("yDVxkpPIbEIBx",13) == 2716056692) strcat(s, "g");
    return s;
}

char *chemurgical_adjectives() {
    char *s = calloc(12);
    if (crc32("jtpFn",5) == 632631342) strcat(s, "z");
if (crc32("IbsdZqJ",7) == 3270766737) strcat(s, "c");
if (crc32("uufgFakpTXflH",13) == 2457462568) strcat(s, "h");
if (crc32("rgQKkCDVcaA",11) == 2615697130) strcat(s, "e");
if (crc32("GcYHk",5) == 208932664) strcat(s, "n");
if (crc32("PwHLsUPPJg",10) == 3023817669) strcat(s, "m");
if (crc32("yVbLskXi",8) == 110978505) strcat(s, "X");
if (crc32("FQaZSPd",7) == 3810106792) strcat(s, "u");
if (crc32("AuMOEU",6) == 3225633779) strcat(s, "r");
if (crc32("HBmIrkjuypUPDr",14) == 1581251831) strcat(s, "Z");
if (crc32("EONuhM",6) == 3092032723) strcat(s, "g");
if (crc32("ITCDThDe",8) == 4253076089) strcat(s, "r");
if (crc32("zYakhdM",7) == 4189597389) strcat(s, "i");
if (crc32("SDWBqDPicrkID",13) == 244716194) strcat(s, "c");
if (crc32("SKVyKpk",7) == 798749806) strcat(s, "u");
if (crc32("qNtyGzeqLboLT",13) == 337495495) strcat(s, "a");
if (crc32("AniqBlygbU",10) == 1622291255) strcat(s, "d");
if (crc32("GuOsKNS",7) == 72468725) strcat(s, "l");
    return s;
}

char *unworshipped_adjectives() {
    char *s = calloc(13);
    if (crc32("hoWwPqv",7) == 3725302424) strcat(s, "I");
if (crc32("jJCSJsxu",8) == 1469750505) strcat(s, "u");
if (crc32("QZiEq",5) == 2606953804) strcat(s, "F");
if (crc32("SkcNZTKZhbseaC",14) == 1765012923) strcat(s, "n");
if (crc32("PueHMRuKPLljDS",14) == 3674731605) strcat(s, "w");
if (crc32("QKKiUMrsaS",10) == 1718038109) strcat(s, "o");
if (crc32("alklbnvcjNmZei",14) == 215216226) strcat(s, "r");
if (crc32("AlXdrhRlgpBEwr",14) == 2016845327) strcat(s, "s");
if (crc32("iqqPB",5) == 2063432178) strcat(s, "h");
if (crc32("JSZEeqe",7) == 1820599518) strcat(s, "h");
if (crc32("eTJwDe",6) == 3219058082) strcat(s, "R");
if (crc32("PwliWakbLElZPR",14) == 1895971642) strcat(s, "i");
if (crc32("rNgUZQKF",8) == 1067311571) strcat(s, "p");
if (crc32("rlOjrOrBTICQ",12) == 935219052) strcat(s, "c");
if (crc32("BZFvdFxDeFp",11) == 1328844878) strcat(s, "p");
if (crc32("vbBmLhvwFHVurz",14) == 2958217685) strcat(s, "v");
if (crc32("HpBGjmA",7) == 1368565782) strcat(s, "e");
if (crc32("vvOAdrXKOzQ",11) == 2906945487) strcat(s, "d");
    return s;
}

char *unpedantic_adjectives() {
    char *s = calloc(11);
    if (crc32("mfBQzpJwfxu",11) == 1771330955) strcat(s, "u");
if (crc32("UAOnCQIKDBlzI",13) == 4150645305) strcat(s, "n");
if (crc32("BAQeDCTelV",10) == 3362666864) strcat(s, "c");
if (crc32("LoPwfYACFsXxn",13) == 2440342160) strcat(s, "p");
if (crc32("hVYzxixMxwPdq",13) == 4154583452) strcat(s, "e");
if (crc32("ZtdpaVSH",8) == 2617629108) strcat(s, "f");
if (crc32("RRKiJInWGiUNei",14) == 3767942823) strcat(s, "d");
if (crc32("AyJAuAixH",9) == 1929240763) strcat(s, "a");
if (crc32("mCrRFutEuRtj",12) == 2826296062) strcat(s, "n");
if (crc32("LihorkZrg",9) == 3042527953) strcat(s, "C");
if (crc32("nVwqPFvkv",9) == 3777969845) strcat(s, "t");
if (crc32("fyNxuhQbbmKpB",13) == 3776532159) strcat(s, "i");
if (crc32("BGvLVwVUWzPdFAo",15) == 2865898676) strcat(s, "n");
if (crc32("ZCUPoxzUpOlhDU",14) == 3068997604) strcat(s, "c");
    return s;
}

char *farmable_adjectives() {
    char *s = calloc(9);
    if (crc32("depZHkowghW",11) == 1710224346) strcat(s, "f");
if (crc32("vxfvdHsyd",9) == 3699600097) strcat(s, "J");
if (crc32("WyNHcUh",7) == 543487926) strcat(s, "a");
if (crc32("DXbCIqETq",9) == 3275133795) strcat(s, "m");
if (crc32("TUiDDTxQu",9) == 1856441864) strcat(s, "r");
if (crc32("JVnnFE",6) == 3719790260) strcat(s, "s");
if (crc32("npfxfjt",7) == 1897819651) strcat(s, "m");
if (crc32("uOYECocIAFh",11) == 2744859259) strcat(s, "E");
if (crc32("VrLauSWVPg",10) == 2851864582) strcat(s, "a");
if (crc32("NfGuOpuaLK",10) == 662503566) strcat(s, "I");
if (crc32("JyfvZdL",7) == 382524563) strcat(s, "b");
if (crc32("jIijdAjFYdsV",12) == 1204481429) strcat(s, "l");
if (crc32("oGooD",5) == 198969849) strcat(s, "e");
    return s;
}

char *tegular_adjectives() {
    char *s = calloc(8);
    if (crc32("RKHfHykqrlnUSzL",15) == 501742920) strcat(s, "t");
if (crc32("TivqkU",6) == 881857614) strcat(s, "e");
if (crc32("KyEhGPbPJZYXW",13) == 612189167) strcat(s, "g");
if (crc32("OgHdipfdw",9) == 1413390426) strcat(s, "i");
if (crc32("uvXXEIaGuZbtkIO",15) == 2736511870) strcat(s, "u");
if (crc32("DyJaFr",6) == 1913469309) strcat(s, "D");
if (crc32("NEeBiMNOEeLoA",13) == 4121166338) strcat(s, "l");
if (crc32("faWxZuHKrMsZnn",14) == 2112440358) strcat(s, "a");
if (crc32("dOlgbdKxKu",10) == 2261295528) strcat(s, "x");
if (crc32("uaHhtnhbveSL",12) == 650308084) strcat(s, "r");
    return s;
}

char *judgemental_adjectives() {
    char *s = calloc(12);
    if (crc32("tRqfJyRyAJ",10) == 4020180532) strcat(s, "U");
if (crc32("mSmuYtb",7) == 1272365801) strcat(s, "j");
if (crc32("LDXQvoZNy",9) == 2338876438) strcat(s, "n");
if (crc32("VQVJmsturcwxGuL",15) == 894915951) strcat(s, "u");
if (crc32("TQtUR",5) == 137609120) strcat(s, "D");
if (crc32("ivjuesRRC",9) == 686233330) strcat(s, "d");
if (crc32("gVCqrsMO",8) == 2373444383) strcat(s, "g");
if (crc32("EcoCaQdTXJGnC",13) == 3783110946) strcat(s, "g");
if (crc32("OnMMFzcxB",9) == 1389178064) strcat(s, "e");
if (crc32("raNBmKp",7) == 3722795386) strcat(s, "H");
if (crc32("wfXRQeV",7) == 4103450907) strcat(s, "m");
if (crc32("sulBmKgM",8) == 872087340) strcat(s, "e");
if (crc32("irZesjB",7) == 3934576449) strcat(s, "n");
if (crc32("nPKCirGquayUIO",14) == 1340687618) strcat(s, "t");
if (crc32("OcHpst",6) == 3363148565) strcat(s, "a");
if (crc32("gcpMcGJym",9) == 1952733364) strcat(s, "k");
if (crc32("UzXelNPebkkWNBV",15) == 2104015199) strcat(s, "l");
    return s;
}

char *rhonchial_adjectives() {
    char *s = calloc(10);
    if (crc32("TBIKmwXKR",9) == 1853707861) strcat(s, "M");
if (crc32("kTNzL",5) == 3155236281) strcat(s, "r");
if (crc32("vgpAFitDArTAj",13) == 2736933614) strcat(s, "h");
if (crc32("RzbwrCVnSVVD",12) == 3988695882) strcat(s, "f");
if (crc32("GXgICPuViqPjk",13) == 1449938360) strcat(s, "o");
if (crc32("eYbcQubEQaVgq",13) == 2924563423) strcat(s, "n");
if (crc32("hPEOSBkk",8) == 2486942739) strcat(s, "Y");
if (crc32("YZklDLznfTcNRCK",15) == 3554655460) strcat(s, "c");
if (crc32("EFrGQL",6) == 1372390761) strcat(s, "h");
if (crc32("IYLAmrkoOgbS",12) == 4203589389) strcat(s, "i");
if (crc32("IRdNXz",6) == 3618957644) strcat(s, "a");
if (crc32("zPnLbwGxP",9) == 3995962825) strcat(s, "m");
if (crc32("EamyEEMcEkJLID",14) == 2085783875) strcat(s, "l");
    return s;
}

char *hyaloid_adjectives() {
    char *s = calloc(8);
    if (crc32("hgYbZTfNxicRx",13) == 700807659) strcat(s, "h");
if (crc32("NSTwlDeEqCn",11) == 890985114) strcat(s, "y");
if (crc32("cJeIDSU",7) == 951549244) strcat(s, "V");
if (crc32("AeogpEtmor",10) == 2698105415) strcat(s, "a");
if (crc32("OvNmgDEciY",10) == 111015391) strcat(s, "K");
if (crc32("trWXAsGemy",10) == 1183255843) strcat(s, "l");
if (crc32("MxAcgAarHBwB",12) == 3093700323) strcat(s, "j");
if (crc32("IxEGOTZYHgG",11) == 3375821646) strcat(s, "o");
if (crc32("ofqGAn",6) == 3140284518) strcat(s, "i");
if (crc32("RfFWzVvRKE",10) == 1362094333) strcat(s, "d");
    return s;
}

char *matterless_adjectives() {
    char *s = calloc(11);
    if (crc32("YXHUwSjaFtBDqe",14) == 1994949888) strcat(s, "w");
if (crc32("hXdWaUj",7) == 3695063472) strcat(s, "m");
if (crc32("jEhfuBvcimLv",12) == 614491934) strcat(s, "a");
if (crc32("RURfvWIA",8) == 1396671724) strcat(s, "t");
if (crc32("VLEHvnk",7) == 438469652) strcat(s, "t");
if (crc32("YhcliiQWes",10) == 593478585) strcat(s, "e");
if (crc32("rLypoScfJms",11) == 2271392560) strcat(s, "t");
if (crc32("rqGVWIVdpv",10) == 3862585654) strcat(s, "r");
if (crc32("Qaojh",5) == 126625577) strcat(s, "x");
if (crc32("bNqLcmCIHRIaY",13) == 1753926263) strcat(s, "l");
if (crc32("xaQrQDARATcGMAF",15) == 3112184869) strcat(s, "Z");
if (crc32("SJhQDjPnKs",10) == 1748499967) strcat(s, "e");
if (crc32("tCFHqLBTXEgj",12) == 1992066269) strcat(s, "s");
if (crc32("fUdKKVuaE",9) == 1781050694) strcat(s, "Y");
if (crc32("oCQtNGXyPIiqm",13) == 2997460694) strcat(s, "s");
    return s;
}

char *untransferable_adjectives() {
    char *s = calloc(15);
    if (crc32("GDKfscARddp",11) == 14390093) strcat(s, "u");
if (crc32("NlFBhfTcdjKc",12) == 3957586151) strcat(s, "E");
if (crc32("ZsDEtYSyzdXcnC",14) == 2722171302) strcat(s, "n");
if (crc32("cRjWMdWjmx",10) == 655855084) strcat(s, "f");
if (crc32("ebDcvMZklFdIs",13) == 367199966) strcat(s, "t");
if (crc32("XLfgvYWxtAUzgds",15) == 2551455760) strcat(s, "r");
if (crc32("eTQIQNdOwdU",11) == 1684882853) strcat(s, "o");
if (crc32("pcKYVhprDmZH",12) == 3775402256) strcat(s, "a");
if (crc32("BHPFQTrru",9) == 1036958406) strcat(s, "n");
if (crc32("OKCMFVZWw",9) == 2939640438) strcat(s, "S");
if (crc32("sjUmR",5) == 327856908) strcat(s, "s");
if (crc32("exZfIjgsO",9) == 2026997264) strcat(s, "f");
if (crc32("YvAlns",6) == 3167127104) strcat(s, "e");
if (crc32("DWQsKMAybEJ",11) == 3339857832) strcat(s, "r");
if (crc32("SeNybb",6) == 904508298) strcat(s, "s");
if (crc32("QQoCfdpgz",9) == 2184518054) strcat(s, "a");
if (crc32("RtZLJMRCIyIRqC",14) == 2101637854) strcat(s, "K");
if (crc32("SnVDhbiiy",9) == 1593222590) strcat(s, "b");
if (crc32("IUOFqUK",7) == 853297552) strcat(s, "h");
if (crc32("dytYiIH",7) == 1783963879) strcat(s, "l");
if (crc32("jefWQuzIqzGDi",13) == 1073409732) strcat(s, "R");
if (crc32("gRlcIKIVR",9) == 71814748) strcat(s, "e");
    return s;
}

char *sclerotomic_adjectives() {
    char *s = calloc(12);
    if (crc32("gbEKR",5) == 2628160245) strcat(s, "s");
if (crc32("EHLjLLplbXgo",12) == 2438935167) strcat(s, "F");
if (crc32("BAuFf",5) == 2540782905) strcat(s, "c");
if (crc32("QkmWbQhgXKHPAV",14) == 240250024) strcat(s, "l");
if (crc32("twcObQBVroryvGi",15) == 3565558811) strcat(s, "e");
if (crc32("mTKFan",6) == 651554011) strcat(s, "r");
if (crc32("iZMvlhga",8) == 1621942828) strcat(s, "Z");
if (crc32("uJtVjRkrqNl",11) == 1844799791) strcat(s, "o");
if (crc32("daOZNayeKA",10) == 3707440087) strcat(s, "t");
if (crc32("PPICyzWu",8) == 775419064) strcat(s, "i");
if (crc32("iHPUEyyRy",9) == 4017559364) strcat(s, "o");
if (crc32("FsZCMVAHpxAGgD",14) == 1098767033) strcat(s, "J");
if (crc32("rxPVkrMYnDT",11) == 2854991174) strcat(s, "m");
if (crc32("ZZNhaqlifN",10) == 1294868562) strcat(s, "c");
if (crc32("oytapuTnv",9) == 2178768010) strcat(s, "i");
if (crc32("TESOqmVIZE",10) == 1856104113) strcat(s, "h");
if (crc32("XnJlgVVdaPDNU",13) == 2008976451) strcat(s, "c");
    return s;
}

char *ungrasped_adjectives() {
    char *s = calloc(10);
    if (crc32("VzxDhKfsyW",10) == 1725216543) strcat(s, "C");
if (crc32("jsDHhUtLhXqRG",13) == 2345506485) strcat(s, "u");
if (crc32("jxeaAYNwLcL",11) == 4221243517) strcat(s, "P");
if (crc32("JRolaEyPozyQRf",14) == 215252688) strcat(s, "n");
if (crc32("kcNYsg",6) == 190824965) strcat(s, "D");
if (crc32("GatQBhpRFvteiES",15) == 599551594) strcat(s, "g");
if (crc32("cGWPjHHoni",10) == 206108173) strcat(s, "r");
if (crc32("fZdZNI",6) == 622749846) strcat(s, "f");
if (crc32("ASFPpatQCBYI",12) == 1512996477) strcat(s, "a");
if (crc32("UJRghYedovZ",11) == 3746202860) strcat(s, "A");
if (crc32("qJaZuRiV",8) == 1363599770) strcat(s, "s");
if (crc32("VdqUBV",6) == 4262750496) strcat(s, "p");
if (crc32("fHtKoX",6) == 207754440) strcat(s, "e");
if (crc32("gkVVXuNgmeMBwA",14) == 1850773514) strcat(s, "e");
if (crc32("rveKBYoWqUW",11) == 2260742296) strcat(s, "d");
    return s;
}

char *thermotactic_adjectives() {
    char *s = calloc(13);
    if (crc32("sNvDSx",6) == 3502073733) strcat(s, "e");
if (crc32("tHhYiepeagoRLT",14) == 1921914950) strcat(s, "t");
if (crc32("VnxalEPAQN",10) == 4142004724) strcat(s, "h");
if (crc32("ETuKXdmE",8) == 814468906) strcat(s, "e");
if (crc32("OQSgQehivGHZgV",14) == 3709205574) strcat(s, "r");
if (crc32("lSRQATKKC",9) == 1426373694) strcat(s, "m");
if (crc32("ZDTFSSz",7) == 627442093) strcat(s, "A");
if (crc32("VAXoUOIRErEM",12) == 764533252) strcat(s, "o");
if (crc32("KSIQxvxPylBcvAY",15) == 2269206135) strcat(s, "Z");
if (crc32("rtMeTGz",7) == 3203272174) strcat(s, "t");
if (crc32("whYXnajWwxaytT",14) == 1723288900) strcat(s, "e");
if (crc32("CeMNAdzrj",9) == 2974586127) strcat(s, "a");
if (crc32("faDUcmh",7) == 369350379) strcat(s, "L");
if (crc32("CtCPqTVDvtymmus",15) == 430449886) strcat(s, "c");
if (crc32("vUGzWAiMu",9) == 3628490452) strcat(s, "t");
if (crc32("YftvAcw",7) == 1180900638) strcat(s, "i");
if (crc32("lLhRlGA",7) == 1069970858) strcat(s, "X");
if (crc32("FihFPCZRqHF",11) == 995297237) strcat(s, "c");
    return s;
}

char *diametral_adjectives() {
    char *s = calloc(10);
    if (crc32("NDWeRDkZupKGG",13) == 163690980) strcat(s, "m");
if (crc32("XqJgBamWUlSxP",13) == 2423625034) strcat(s, "d");
if (crc32("VNkyJCpLd",9) == 2815083192) strcat(s, "i");
if (crc32("XTokARzBy",9) == 207131711) strcat(s, "p");
if (crc32("JdDkeTMFXft",11) == 3749580509) strcat(s, "a");
if (crc32("UDwmOjQbBi",10) == 2245981811) strcat(s, "d");
if (crc32("HZcRLm",6) == 151929111) strcat(s, "m");
if (crc32("ogHtzjRplLU",11) == 949409704) strcat(s, "G");
if (crc32("MpyMQXSctddUfR",14) == 1399336845) strcat(s, "e");
if (crc32("JzgAaZIgfKBro",13) == 3970769372) strcat(s, "t");
if (crc32("ipDcY",5) == 315340437) strcat(s, "r");
if (crc32("ygKOuVf",7) == 120832083) strcat(s, "a");
if (crc32("xGmmcYUnzH",10) == 3652994276) strcat(s, "r");
if (crc32("KFhqsIGL",8) == 3498600605) strcat(s, "l");
    return s;
}

char *predependent_adjectives() {
    char *s = calloc(13);
    if (crc32("nmeLPQoOBvkDqWT",15) == 1509764529) strcat(s, "S");
if (crc32("ZdFxSrs",7) == 1248569930) strcat(s, "p");
if (crc32("KyEkLnbI",8) == 303216663) strcat(s, "r");
if (crc32("vQKxsm",6) == 1210873856) strcat(s, "e");
if (crc32("RfYZRDPIGiES",12) == 1896514774) strcat(s, "d");
if (crc32("IRfvvrxUqnHhwwQ",15) == 3113523583) strcat(s, "e");
if (crc32("LZzBhuCptyP",11) == 1180889004) strcat(s, "p");
if (crc32("HxtwmXmDZGl",11) == 1602524778) strcat(s, "a");
if (crc32("caSXzUBzWQtDlks",15) == 2726162797) strcat(s, "e");
if (crc32("bzWBcNwlpwDXfT",14) == 2126693098) strcat(s, "k");
if (crc32("aLdIo",5) == 14329116) strcat(s, "n");
if (crc32("uzoUzgifYRlny",13) == 1116609932) strcat(s, "d");
if (crc32("XNLEDnbyYqCXA",13) == 3723419501) strcat(s, "T");
if (crc32("UewCQjVAiiiCp",13) == 3085762249) strcat(s, "e");
if (crc32("xrbyXB",6) == 3547190881) strcat(s, "g");
if (crc32("xPsCXiEF",8) == 4037634314) strcat(s, "n");
if (crc32("jIKUOLsEGH",10) == 503341326) strcat(s, "s");
if (crc32("vQXMnTQEtOdA",12) == 1449628582) strcat(s, "t");
    return s;
}

char *stroboscopic_adjectives() {
    char *s = calloc(13);
    if (crc32("qgVOb",5) == 403566692) strcat(s, "s");
if (crc32("kuLLOrjB",8) == 392634881) strcat(s, "q");
if (crc32("QTtOmMS",7) == 3075346573) strcat(s, "t");
if (crc32("IFgTyM",6) == 3926821113) strcat(s, "t");
if (crc32("MBaIYheNA",9) == 1297498507) strcat(s, "r");
if (crc32("vhzTb",5) == 3033144298) strcat(s, "p");
if (crc32("ZYKJUVtxCyLhD",13) == 422127211) strcat(s, "o");
if (crc32("nsDWcWocpDb",11) == 3636389367) strcat(s, "b");
if (crc32("jDYToxNCz",9) == 128481735) strcat(s, "b");
if (crc32("hDMajjfCJNIGuZx",15) == 2102114562) strcat(s, "o");
if (crc32("vMEjUnrGzud",11) == 3360665468) strcat(s, "S");
if (crc32("qLuEIfFdoPlNgLG",15) == 727934143) strcat(s, "s");
if (crc32("YLBVMIIHnPrsd",13) == 1460421661) strcat(s, "r");
if (crc32("BlsiOvdwJnSoy",13) == 3690575660) strcat(s, "c");
if (crc32("zFGOwGF",7) == 1424504554) strcat(s, "o");
if (crc32("ynlGcrpwDaVEA",13) == 1845995435) strcat(s, "p");
if (crc32("DgzuaWkX",8) == 348120052) strcat(s, "i");
if (crc32("IToRT",5) == 1621323706) strcat(s, "k");
if (crc32("zObyaeeO",8) == 1751130368) strcat(s, "c");
    return s;
}

char *wellallied_adjectives() {
    char *s = calloc(11);
    if (crc32("nzxrEQ",6) == 1489164680) strcat(s, "w");
if (crc32("hCXQVQbEC",9) == 1335383717) strcat(s, "v");
if (crc32("kUPfvEvBGSRWyfj",15) == 2047745454) strcat(s, "e");
if (crc32("jabdizE",7) == 3000271007) strcat(s, "l");
if (crc32("NyYui",5) == 849198931) strcat(s, "l");
if (crc32("xkNRcPUTiq",10) == 3797401765) strcat(s, "a");
if (crc32("IalrxqMR",8) == 3105863412) strcat(s, "l");
if (crc32("ikaZuGOdokWZCO",14) == 196965976) strcat(s, "l");
if (crc32("NEyxKffepFiNvGA",15) == 737702957) strcat(s, "L");
if (crc32("NLPhJHsYIrjF",12) == 3870455730) strcat(s, "i");
if (crc32("aNjBNCUKQJThfhd",15) == 3337509733) strcat(s, "L");
if (crc32("IZjCVZD",7) == 3793567279) strcat(s, "e");
if (crc32("cjaiGPMDm",9) == 1048317683) strcat(s, "d");
    return s;
}

char *unexplicit_adjectives() {
    char *s = calloc(11);
    if (crc32("tmBqFR",6) == 129701634) strcat(s, "u");
if (crc32("FDSls",5) == 1822401587) strcat(s, "g");
if (crc32("YQPYnBAvl",9) == 4060540221) strcat(s, "n");
if (crc32("coLkDjhzzPPqSo",14) == 454897967) strcat(s, "e");
if (crc32("iyiEQZDFQqF",11) == 2545983361) strcat(s, "D");
if (crc32("QxtmaVSBkR",10) == 3782069056) strcat(s, "x");
if (crc32("eDBqiKHYb",9) == 549148279) strcat(s, "p");
if (crc32("tJeiZeTT",8) == 1894153734) strcat(s, "O");
if (crc32("FNUrPvAurVXJKti",15) == 2576098511) strcat(s, "l");
if (crc32("NyyQQOtpYjwsZ",13) == 3449682996) strcat(s, "q");
if (crc32("iaSGDBo",7) == 1363913594) strcat(s, "i");
if (crc32("yZGDLzg",7) == 3366599431) strcat(s, "c");
if (crc32("UmLyJnXRjm",10) == 1637279154) strcat(s, "y");
if (crc32("BtUkU",5) == 4147327155) strcat(s, "i");
if (crc32("apsccIalPXLB",12) == 867284575) strcat(s, "t");
    return s;
}

char *unmunicipalized_adjectives() {
    char *s = calloc(16);
    if (crc32("PusmmwAgZEVVcd",14) == 1029441475) strcat(s, "u");
if (crc32("PrTEyeCgdQiO",12) == 737079877) strcat(s, "o");
if (crc32("JuVuvALAhUFb",12) == 620401070) strcat(s, "n");
if (crc32("GHjqAVjDS",9) == 1477327559) strcat(s, "w");
if (crc32("YyDGXoQvKeZxl",13) == 1542844654) strcat(s, "m");
if (crc32("wrPJvxZezWpbWfn",15) == 4074038212) strcat(s, "O");
if (crc32("cXuunhd",7) == 261004873) strcat(s, "u");
if (crc32("xHOddlnxGkMy",12) == 2525148203) strcat(s, "n");
if (crc32("OaIHeSDEfZzbb",13) == 1643322460) strcat(s, "O");
if (crc32("qYyYZOtcTDHpOhF",15) == 1923298750) strcat(s, "i");
if (crc32("YMuZFBFryBKuZ",13) == 633902754) strcat(s, "z");
if (crc32("nRWtrGszqjjrcx",14) == 3685173856) strcat(s, "c");
if (crc32("BDuUZsrfz",9) == 2862824673) strcat(s, "k");
if (crc32("aNNkOpWwH",9) == 655872393) strcat(s, "i");
if (crc32("fiNpH",5) == 3141721575) strcat(s, "p");
if (crc32("QHrBCe",6) == 1245172177) strcat(s, "a");
if (crc32("yvjXxjpNsscVt",13) == 29998710) strcat(s, "d");
if (crc32("klOdtyi",7) == 2624027715) strcat(s, "l");
if (crc32("ClqJzKLpjcU",11) == 3744137140) strcat(s, "r");
if (crc32("DXkrwmx",7) == 1024637172) strcat(s, "i");
if (crc32("CzAAZge",7) == 1916932941) strcat(s, "z");
if (crc32("jBjoHexMA",9) == 1105755638) strcat(s, "L");
if (crc32("MPZSN",5) == 3432361249) strcat(s, "e");
if (crc32("NJSkyrcej",9) == 4068644569) strcat(s, "d");
    return s;
}

char *auricled_adjectives() {
    char *s = calloc(9);
    if (crc32("UkoiFxqqaUTpq",13) == 4207209095) strcat(s, "F");
if (crc32("xldYBiUioGPVVt",14) == 3602922672) strcat(s, "a");
if (crc32("egAKFIc",7) == 2074658542) strcat(s, "l");
if (crc32("rNPDaueFtOMcPj",14) == 2195260633) strcat(s, "u");
if (crc32("obHYrfApe",9) == 3539403637) strcat(s, "I");
if (crc32("ijdHu",5) == 1368053252) strcat(s, "r");
if (crc32("sbULaEr",7) == 1592858336) strcat(s, "i");
if (crc32("uxiigAIMS",9) == 3524877561) strcat(s, "c");
if (crc32("VvNdlTnEUYkCnt",14) == 1101415259) strcat(s, "l");
if (crc32("nDokmCfIfOHE",12) == 3734283127) strcat(s, "g");
if (crc32("iHPdVOGELbpMtce",15) == 3781070315) strcat(s, "e");
if (crc32("cArjukx",7) == 3193050590) strcat(s, "d");
    return s;
}

char *chondrosarcomatous_adjectives() {
    char *s = calloc(19);
    if (crc32("rvFBotTq",8) == 917876974) strcat(s, "c");
if (crc32("MJvmI",5) == 499592064) strcat(s, "h");
if (crc32("HaJQAjIYhTOXDVu",15) == 421900741) strcat(s, "x");
if (crc32("OHnfLsB",7) == 288050481) strcat(s, "o");
if (crc32("pGfwakIJe",9) == 2642609245) strcat(s, "W");
if (crc32("NjaXalW",7) == 4287546685) strcat(s, "n");
if (crc32("MXPdRIJ",7) == 959351064) strcat(s, "q");
if (crc32("ECDUJU",6) == 2660383008) strcat(s, "d");
if (crc32("gUDDIQBFTzMF",12) == 3689634442) strcat(s, "r");
if (crc32("IUOCtafSkdgeBoS",15) == 3487268376) strcat(s, "o");
if (crc32("eyskCg",6) == 3777636864) strcat(s, "O");
if (crc32("VtbjxwTy",8) == 1892267971) strcat(s, "s");
if (crc32("KGoVxkVTlJin",12) == 393966139) strcat(s, "a");
if (crc32("CReIJTbSSj",10) == 4189224016) strcat(s, "x");
if (crc32("PwwCmOehMQpj",12) == 3987955064) strcat(s, "r");
if (crc32("offGUz",6) == 2407331282) strcat(s, "s");
if (crc32("CByoqLd",7) == 2126043449) strcat(s, "c");
if (crc32("sjhIKScaGslgBMV",15) == 4043009211) strcat(s, "O");
if (crc32("EKAnFjbyFDXK",12) == 3907991323) strcat(s, "o");
if (crc32("yJtUizHSa",9) == 54133916) strcat(s, "m");
if (crc32("fYsetQJkSPm",11) == 1539711855) strcat(s, "X");
if (crc32("RJkNJUrS",8) == 1713330028) strcat(s, "a");
if (crc32("VFGBgPok",8) == 328628772) strcat(s, "t");
if (crc32("ldWSM",5) == 3735815818) strcat(s, "o");
if (crc32("lLoiJhP",7) == 569060708) strcat(s, "a");
if (crc32("pTUblifc",8) == 1890810595) strcat(s, "u");
if (crc32("eVwqnmfwfug",11) == 1217117605) strcat(s, "s");
    return s;
}

char *winy_adjectives() {
    char *s = calloc(5);
    if (crc32("ybRhkB",6) == 1191581414) strcat(s, "w");
if (crc32("dXbnxEaeRTIZWDS",15) == 2532095838) strcat(s, "i");
if (crc32("gNVfuyDufCCH",12) == 3475709131) strcat(s, "n");
if (crc32("RFAcqKWFEkOF",12) == 1629888037) strcat(s, "y");
    return s;
}

char *qualityless_adjectives() {
    char *s = calloc(12);
    if (crc32("vANGfeXoxLBUfV",14) == 1445968782) strcat(s, "O");
if (crc32("FaEVnWcrtzumLk",14) == 3329452103) strcat(s, "q");
if (crc32("TEEcbOsyKgIta",13) == 886833372) strcat(s, "L");
if (crc32("pBnhLkMqyi",10) == 4164510699) strcat(s, "u");
if (crc32("XSYEEiImq",9) == 1138080225) strcat(s, "a");
if (crc32("YfwJLg",6) == 2295209648) strcat(s, "l");
if (crc32("NwyWotEKq",9) == 2203498013) strcat(s, "i");
if (crc32("GvmHDQWDVze",11) == 775658237) strcat(s, "I");
if (crc32("FYjPSZxSTSWkGP",14) == 2859748078) strcat(s, "t");
if (crc32("KBeAT",5) == 325381265) strcat(s, "y");
if (crc32("AhKTsRlh",8) == 3102618262) strcat(s, "G");
if (crc32("EbIUrFznQZ",10) == 1363108200) strcat(s, "l");
if (crc32("cJkLWBwGWGAqY",13) == 239620544) strcat(s, "e");
if (crc32("WaxuugpR",8) == 3213953176) strcat(s, "v");
if (crc32("fryDWY",6) == 1788089986) strcat(s, "s");
if (crc32("KgrffWeCtG",10) == 848311435) strcat(s, "s");
    return s;
}

char *southeastward_adjectives() {
    char *s = calloc(14);
    if (crc32("rfClrjNs",8) == 2512369209) strcat(s, "s");
if (crc32("AXpiBbZb",8) == 2525599845) strcat(s, "o");
if (crc32("ZEHtP",5) == 1333569137) strcat(s, "S");
if (crc32("xrqcn",5) == 2136949336) strcat(s, "u");
if (crc32("jKnxaxj",7) == 1546169738) strcat(s, "t");
if (crc32("WSlzCVtgwiq",11) == 686971330) strcat(s, "h");
if (crc32("mIHdzMxzSQkQEbZ",15) == 2842475517) strcat(s, "e");
if (crc32("FClDnrvtbZ",10) == 1348168720) strcat(s, "L");
if (crc32("mWdpOOmXpyQF",12) == 1190474333) strcat(s, "a");
if (crc32("yXQLdvQLyzmkLc",14) == 1078341417) strcat(s, "w");
if (crc32("egfUdGQXxhBZ",12) == 3992261546) strcat(s, "s");
if (crc32("IjhmxBIOtGiL",12) == 3980346360) strcat(s, "I");
if (crc32("NRUiIMiYKw",10) == 1278139066) strcat(s, "t");
if (crc32("NvxrGVvBk",9) == 1340945208) strcat(s, "w");
if (crc32("aCUgQJJ",7) == 592269792) strcat(s, "f");
if (crc32("hYeUQBonrHK",11) == 1188141753) strcat(s, "a");
if (crc32("zrSQBAdXQjVVrXJ",15) == 283708868) strcat(s, "r");
if (crc32("VIoWRydbpslLhk",14) == 3087236792) strcat(s, "l");
if (crc32("BTYWN",5) == 2811090682) strcat(s, "d");
    return s;
}

char *ringstreaked_adjectives() {
    char *s = calloc(13);
    if (crc32("BiiSBFaQq",9) == 470185904) strcat(s, "r");
if (crc32("OrWSx",5) == 2064424766) strcat(s, "i");
if (crc32("uzqUO",5) == 727075869) strcat(s, "t");
if (crc32("meNtqEBREbWw",12) == 1797214312) strcat(s, "n");
if (crc32("tbsLXtkVMzurg",13) == 919284818) strcat(s, "e");
if (crc32("sDBWgYXtayRLMF",14) == 838089186) strcat(s, "g");
if (crc32("kupcz",5) == 3738184185) strcat(s, "s");
if (crc32("semJAzlDU",9) == 4203423875) strcat(s, "L");
if (crc32("HffmMCCUQ",9) == 1232464151) strcat(s, "t");
if (crc32("KgoBVjDzvdCRPgN",15) == 740430948) strcat(s, "t");
if (crc32("iQXKjee",7) == 1626608367) strcat(s, "r");
if (crc32("TgNpE",5) == 4274863503) strcat(s, "e");
if (crc32("KDqIkLlJZtkdk",13) == 1879724047) strcat(s, "a");
if (crc32("HMFRHiBAGc",10) == 847449332) strcat(s, "J");
if (crc32("MUcXGcPie",9) == 2827642499) strcat(s, "k");
if (crc32("Emxtj",5) == 702243560) strcat(s, "O");
if (crc32("lYWfqjb",7) == 119053034) strcat(s, "e");
if (crc32("YIcqFFmFvdUM",12) == 3486636985) strcat(s, "d");
    return s;
}

char *Handelian_adjectives() {
    char *s = calloc(10);
    if (crc32("fbLljnSd",8) == 2253136217) strcat(s, "H");
if (crc32("fyRQKrp",7) == 1501955757) strcat(s, "a");
if (crc32("xwUlEs",6) == 3831317698) strcat(s, "n");
if (crc32("WzAjzBi",7) == 1340627331) strcat(s, "d");
if (crc32("bWzju",5) == 2500923187) strcat(s, "e");
if (crc32("bvKgKBlCveS",11) == 1978282887) strcat(s, "l");
if (crc32("XmzzOwaBBQYAB",13) == 2622898206) strcat(s, "i");
if (crc32("LzRaHGubjIU",11) == 4022549068) strcat(s, "P");
if (crc32("OHvWcgtNK",9) == 654713926) strcat(s, "a");
if (crc32("OdbETx",6) == 3920503671) strcat(s, "O");
if (crc32("CUJPokJzZS",10) == 1039400162) strcat(s, "n");
    return s;
}

char *antiphrastic_adjectives() {
    char *s = calloc(13);
    if (crc32("oFyhD",5) == 3834259353) strcat(s, "a");
if (crc32("xpFMNxIrEGlqP",13) == 3706010138) strcat(s, "U");
if (crc32("aDzTRvJdkq",10) == 2574483775) strcat(s, "n");
if (crc32("OnheCPaBQpgnCQl",15) == 2133732331) strcat(s, "u");
if (crc32("aYeuVOebfpUchl",14) == 955010271) strcat(s, "t");
if (crc32("AfGlBhAHgMa",11) == 348982334) strcat(s, "I");
if (crc32("TtxsyV",6) == 2923873609) strcat(s, "i");
if (crc32("OhoJz",5) == 467555545) strcat(s, "p");
if (crc32("KTrJspEFDzo",11) == 3482968837) strcat(s, "h");
if (crc32("dWUiBAnkkxT",11) == 1387030767) strcat(s, "N");
if (crc32("eHAGCWH",7) == 999822568) strcat(s, "r");
if (crc32("oLlKfHWiEiVUilx",15) == 835908515) strcat(s, "a");
if (crc32("NGPDHfqDVkyPXa",14) == 3055276555) strcat(s, "R");
if (crc32("pbXLVZfll",9) == 1043429021) strcat(s, "s");
if (crc32("zZgxnF",6) == 4043967664) strcat(s, "t");
if (crc32("gTNcdHPzbXMHE",13) == 2830480927) strcat(s, "K");
if (crc32("bvFhkWGIFwwMYAT",15) == 1301634864) strcat(s, "i");
if (crc32("bSYpqWZjGEeqHZt",15) == 276993369) strcat(s, "I");
if (crc32("bCjVdZA",7) == 993813190) strcat(s, "c");
    return s;
}

char *unchevroned_adjectives() {
    char *s = calloc(12);
    if (crc32("pxFMNFQeM",9) == 3643212590) strcat(s, "u");
if (crc32("fGJiGY",6) == 2610737625) strcat(s, "n");
if (crc32("DmQJOvMrwE",10) == 1885322006) strcat(s, "c");
if (crc32("ejZvKTveBVW",11) == 280740724) strcat(s, "b");
if (crc32("hjuOpIkc",8) == 2388701307) strcat(s, "h");
if (crc32("MnvtARcAzXB",11) == 337161496) strcat(s, "Z");
if (crc32("HxGcJlFQOs",10) == 595021839) strcat(s, "e");
if (crc32("sHfdBKYWmLrBP",13) == 3303267116) strcat(s, "s");
if (crc32("LIsSczIHX",9) == 1202481781) strcat(s, "v");
if (crc32("SoUKUx",6) == 3438138393) strcat(s, "j");
if (crc32("ZKgnrMZucZHIl",13) == 436355755) strcat(s, "r");
if (crc32("MWDRKp",6) == 2968615308) strcat(s, "o");
if (crc32("uXtRMldl",8) == 787350853) strcat(s, "n");
if (crc32("pQgYjovSanaJQr",14) == 675076816) strcat(s, "E");
if (crc32("jAhxZka",7) == 2901469479) strcat(s, "e");
if (crc32("vAQVaVkbKRw",11) == 1223722673) strcat(s, "d");
    return s;
}

char *quarterwitted_adjectives() {
    char *s = calloc(14);
    if (crc32("tPBKc",5) == 3042263346) strcat(s, "q");
if (crc32("rYzGWtuNIGQ",11) == 775594835) strcat(s, "u");
if (crc32("uwPpRaKMBpAKi",13) == 1725467084) strcat(s, "g");
if (crc32("KsuFBEPc",8) == 1766148308) strcat(s, "a");
if (crc32("seyCNkl",7) == 3720331673) strcat(s, "r");
if (crc32("WgdokYaHBW",10) == 880573578) strcat(s, "t");
if (crc32("TqjdBP",6) == 1343105749) strcat(s, "e");
if (crc32("cBZLICLjwIcAj",13) == 1064564316) strcat(s, "b");
if (crc32("fRdaviAtNTy",11) == 3746482140) strcat(s, "r");
if (crc32("RdoIwdE",7) == 296024302) strcat(s, "w");
if (crc32("PnCiGX",6) == 2323931174) strcat(s, "g");
if (crc32("wxskF",5) == 1817887601) strcat(s, "i");
if (crc32("bsUummy",7) == 3762270103) strcat(s, "o");
if (crc32("EFoLr",5) == 1224915905) strcat(s, "t");
if (crc32("emYiFCP",7) == 1200425419) strcat(s, "t");
if (crc32("uwKoKbN",7) == 2988481865) strcat(s, "i");
if (crc32("ikhudC",6) == 842494643) strcat(s, "e");
if (crc32("dwJidzCur",9) == 2017204069) strcat(s, "d");
    return s;
}

char *unfriendly_adjectives() {
    char *s = calloc(11);
    if (crc32("MzbEKFAwSeEJo",13) == 3731623580) strcat(s, "u");
if (crc32("SqmERBKkpPodwsx",15) == 4045521642) strcat(s, "n");
if (crc32("ovpMM",5) == 217939252) strcat(s, "B");
if (crc32("CMaPGpJYNUedcP",14) == 4234292428) strcat(s, "f");
if (crc32("lvYyKaMjRuDpHY",14) == 3821480050) strcat(s, "r");
if (crc32("rphrkqK",7) == 375763784) strcat(s, "i");
if (crc32("bQoUGM",6) == 3880971349) strcat(s, "c");
if (crc32("iXqPI",5) == 3157353323) strcat(s, "e");
if (crc32("MdTfdeRkNAkg",12) == 3612731162) strcat(s, "n");
if (crc32("vSREPzeJXuHMPzP",15) == 193208085) strcat(s, "T");
if (crc32("ZgViL",5) == 2970902682) strcat(s, "d");
if (crc32("IZdrT",5) == 161533830) strcat(s, "l");
if (crc32("XJckAxz",7) == 927899664) strcat(s, "y");
    return s;
}

char *halfexposed_adjectives() {
    char *s = calloc(12);
    if (crc32("TroBgF",6) == 9961427) strcat(s, "h");
if (crc32("xOpBXRtbGorSv",13) == 3793794519) strcat(s, "O");
if (crc32("GIVwvaNsAmGuk",13) == 2978369190) strcat(s, "a");
if (crc32("JwwdDxbrxTDPM",13) == 971072952) strcat(s, "l");
if (crc32("fecPJ",5) == 3413636164) strcat(s, "y");
if (crc32("cBibikBrdsbB",12) == 1596422818) strcat(s, "f");
if (crc32("ZJoWiJcJHt",10) == 3491870526) strcat(s, "n");
if (crc32("TwNpzdbYxjW",11) == 3003125776) strcat(s, "e");
if (crc32("VPDupkQKxKKQ",12) == 3992839068) strcat(s, "x");
if (crc32("gNtvLZ",6) == 547611555) strcat(s, "p");
if (crc32("ZeiRVkXFxojD",12) == 3547975637) strcat(s, "o");
if (crc32("THPTsLWEZQJX",12) == 948796036) strcat(s, "s");
if (crc32("YLCktNsxZs",10) == 1842275019) strcat(s, "e");
if (crc32("mIQFePdZHahCq",13) == 20984976) strcat(s, "d");
    return s;
}

char *lipotropic_adjectives() {
    char *s = calloc(11);
    if (crc32("UkvuvdrxtrukwJ",14) == 1848860089) strcat(s, "P");
if (crc32("LeRUObwHeTV",11) == 832037684) strcat(s, "l");
if (crc32("yChrkzWnNxiPxh",14) == 675890212) strcat(s, "o");
if (crc32("XXLxEIV",7) == 2346811561) strcat(s, "i");
if (crc32("xNyzFbYMniOSdpA",15) == 2812808137) strcat(s, "v");
if (crc32("RNIbcdodNwtknm",14) == 2930303819) strcat(s, "p");
if (crc32("SXirzdgS",8) == 2447032203) strcat(s, "o");
if (crc32("gcltaspfQA",10) == 676300614) strcat(s, "W");
if (crc32("QDZyzbldepAr",12) == 1978734179) strcat(s, "t");
if (crc32("esqCyqCOQcIU",12) == 3752954521) strcat(s, "x");
if (crc32("tIjigtLFx",9) == 865856311) strcat(s, "r");
if (crc32("GYafTBdpiYwh",12) == 1134195667) strcat(s, "o");
if (crc32("ZvDozRCE",8) == 395275887) strcat(s, "p");
if (crc32("QSdSzqDh",8) == 2223507128) strcat(s, "i");
if (crc32("ChaRuvkmxAsAvHi",15) == 2347044632) strcat(s, "c");
    return s;
}

char *ungeodetic_adjectives() {
    char *s = calloc(11);
    if (crc32("TwaNQSGxIzS",11) == 3546511262) strcat(s, "u");
if (crc32("bSjdRWlibajw",12) == 176606078) strcat(s, "n");
if (crc32("FYNjIUVe",8) == 2266966142) strcat(s, "g");
if (crc32("TDckhHGqRqtiG",13) == 3610077216) strcat(s, "e");
if (crc32("iZHCFQrx",8) == 1101912452) strcat(s, "o");
if (crc32("yFVyVMS",7) == 1132270990) strcat(s, "d");
if (crc32("KKxBgvmK",8) == 1431040638) strcat(s, "e");
if (crc32("ZoiLkTKG",8) == 308630306) strcat(s, "t");
if (crc32("ASVfb",5) == 2183379199) strcat(s, "i");
if (crc32("GyGKnl",6) == 2452320310) strcat(s, "c");
    return s;
}

char *unpublic_adjectives() {
    char *s = calloc(9);
    if (crc32("pQJlzYxhHOOwCCv",15) == 1149165043) strcat(s, "I");
if (crc32("WSLgOElK",8) == 3860073509) strcat(s, "u");
if (crc32("AvigtcVg",8) == 2596225375) strcat(s, "n");
if (crc32("eTFSw",5) == 2509528169) strcat(s, "F");
if (crc32("rwLwejcQoARPFm",14) == 3735132206) strcat(s, "p");
if (crc32("ZZorYiYHe",9) == 2609599704) strcat(s, "F");
if (crc32("UWszBPAn",8) == 3196845806) strcat(s, "u");
if (crc32("zKwVqAKNHkruWd",14) == 3793685075) strcat(s, "b");
if (crc32("qTlLHGDzKx",10) == 3685095905) strcat(s, "Z");
if (crc32("TSoGcWNhWhIOBdB",15) == 479775899) strcat(s, "l");
if (crc32("RlNBFdm",7) == 3326860395) strcat(s, "i");
if (crc32("ebfsdcLxW",9) == 699120478) strcat(s, "c");
    return s;
}

char *swaybacked_adjectives() {
    char *s = calloc(11);
    if (crc32("FPSqtKPfbnUzCRy",15) == 1101792204) strcat(s, "R");
if (crc32("wulVoBpyOKbBp",13) == 4250299612) strcat(s, "s");
if (crc32("plpuAbMJuYwI",12) == 1095095575) strcat(s, "w");
if (crc32("LdIgsJZnI",9) == 2447537033) strcat(s, "a");
if (crc32("XuShAWb",7) == 1887871547) strcat(s, "y");
if (crc32("vBpftThcuD",10) == 3822014525) strcat(s, "O");
if (crc32("MNNmrQVHf",9) == 1367259787) strcat(s, "b");
if (crc32("ZtEvnniC",8) == 1388244017) strcat(s, "a");
if (crc32("qrMdFubucb",10) == 796916132) strcat(s, "c");
if (crc32("BsMvueCl",8) == 1100406324) strcat(s, "E");
if (crc32("IVrDCoyPBljXkcI",15) == 1341459076) strcat(s, "k");
if (crc32("SNlDLZ",6) == 1186210076) strcat(s, "D");
if (crc32("bXhAsTkNbV",10) == 497394142) strcat(s, "e");
if (crc32("rGYqF",5) == 2298846491) strcat(s, "d");
    return s;
}

char *quasiextraterritorial_adjectives() {
    char *s = calloc(22);
    if (crc32("DBMZivtqr",9) == 87382995) strcat(s, "l");
if (crc32("uYbKrLGFzYu",11) == 3793785795) strcat(s, "q");
if (crc32("pEwDXAmBixr",11) == 3081893915) strcat(s, "V");
if (crc32("IuHITsLBZ",9) == 2874398988) strcat(s, "u");
if (crc32("YDEfVuYCRRMRD",13) == 2320328485) strcat(s, "U");
if (crc32("tqQNnbgOzRvhdS",14) == 2686815480) strcat(s, "a");
if (crc32("TYWExm",6) == 3887124691) strcat(s, "s");
if (crc32("kclcNL",6) == 1032666095) strcat(s, "T");
if (crc32("QotVNxdHAKMn",12) == 1224843221) strcat(s, "i");
if (crc32("UrHqKZbflIas",12) == 146493673) strcat(s, "e");
if (crc32("ebpWdipXQ",9) == 2253972625) strcat(s, "d");
if (crc32("mQKlthEaxUVQH",13) == 586849353) strcat(s, "x");
if (crc32("ZSjcciZIXIll",12) == 4276139088) strcat(s, "u");
if (crc32("mISCHQ",6) == 3756241061) strcat(s, "t");
if (crc32("OrzZgSViRJjGot",14) == 2056726924) strcat(s, "r");
if (crc32("VyAWN",5) == 3707543444) strcat(s, "r");
if (crc32("lRUNoAPtaKFoPMG",15) == 250473641) strcat(s, "a");
if (crc32("wxyMdUNNjmIQHtb",15) == 3411021459) strcat(s, "T");
if (crc32("eTGovcMjXLMxLs",14) == 1329910681) strcat(s, "t");
if (crc32("KoHdGMVEExr",11) == 2309362432) strcat(s, "e");
if (crc32("NPuXmuqJvFQW",12) == 1220321293) strcat(s, "r");
if (crc32("TAdkN",5) == 2813111083) strcat(s, "A");
if (crc32("ZNWlb",5) == 3427603347) strcat(s, "r");
if (crc32("MEOiImBASy",10) == 1967396101) strcat(s, "l");
if (crc32("SqolZJx",7) == 283029488) strcat(s, "i");
if (crc32("ZfqUFfGkH",9) == 1133039900) strcat(s, "t");
if (crc32("RWTrKOX",7) == 1140120868) strcat(s, "j");
if (crc32("GEZivllMNPssnIn",15) == 103087511) strcat(s, "o");
if (crc32("hTsSLyhrNkY",11) == 178259967) strcat(s, "r");
if (crc32("sZDCsfyHu",9) == 832113849) strcat(s, "i");
if (crc32("mfFJKrdlJWTiV",13) == 4032838007) strcat(s, "o");
if (crc32("spjciJHk",8) == 93025746) strcat(s, "a");
if (crc32("XkAQUOfpFpt",11) == 1718691224) strcat(s, "E");
if (crc32("oELDitaSxxRVqfd",15) == 3970949749) strcat(s, "l");
    return s;
}

char *ooziest_adjectives() {
    char *s = calloc(8);
    if (crc32("zVrOCD",6) == 4081250812) strcat(s, "c");
if (crc32("GPztozkuOA",10) == 1257173293) strcat(s, "o");
if (crc32("tfKiCoqGr",9) == 2534213040) strcat(s, "x");
if (crc32("xuiyOTQQ",8) == 1760605596) strcat(s, "o");
if (crc32("NBlrBZWIbxqid",13) == 1386489070) strcat(s, "F");
if (crc32("DGkcabqtZ",9) == 3781005232) strcat(s, "z");
if (crc32("rTNRAihlbZk",11) == 3090618090) strcat(s, "i");
if (crc32("jjflkoeG",8) == 4080281790) strcat(s, "p");
if (crc32("jYeFW",5) == 3197500870) strcat(s, "e");
if (crc32("KSrOKuU",7) == 1779087805) strcat(s, "X");
if (crc32("EnxPiaBJbDp",11) == 2578718787) strcat(s, "s");
if (crc32("wstuulqxXyEBH",13) == 1303481860) strcat(s, "u");
if (crc32("RjHLb",5) == 1368629460) strcat(s, "t");
    return s;
}

char *contumacious_adjectives() {
    char *s = calloc(13);
    if (crc32("EHhoB",5) == 3405817572) strcat(s, "u");
if (crc32("OzjXVHwygtDE",12) == 1258479102) strcat(s, "c");
if (crc32("OQhiAKGDcp",10) == 3965040879) strcat(s, "C");
if (crc32("fPqmKBp",7) == 2600433261) strcat(s, "o");
if (crc32("jQrmwOOQMqgFQD",14) == 380091156) strcat(s, "V");
if (crc32("nBDJkRdwXhKFtvp",15) == 159313207) strcat(s, "n");
if (crc32("GJOyavvqUIwx",12) == 3794626508) strcat(s, "P");
if (crc32("iZahMkt",7) == 3719587090) strcat(s, "t");
if (crc32("IhyvU",5) == 3591035436) strcat(s, "u");
if (crc32("KSrIHpW",7) == 2429370725) strcat(s, "u");
if (crc32("yjGwh",5) == 817496026) strcat(s, "m");
if (crc32("XVpCPxTR",8) == 2827590993) strcat(s, "N");
if (crc32("ALuwU",5) == 1530298768) strcat(s, "a");
if (crc32("HinpvTyP",8) == 2119527314) strcat(s, "H");
if (crc32("QzqOwhDyWfc",11) == 3698988917) strcat(s, "c");
if (crc32("FITcV",5) == 1356859274) strcat(s, "i");
if (crc32("qLSxBWLXHc",10) == 1365035380) strcat(s, "o");
if (crc32("GqbXIRxg",8) == 2948137848) strcat(s, "d");
if (crc32("dyBcxN",6) == 3681228023) strcat(s, "u");
if (crc32("tWVJIYAR",8) == 2326294572) strcat(s, "s");
    return s;
}

char *preSemitic_adjectives() {
    char *s = calloc(11);
    if (crc32("viXkWrOaAQ",10) == 177874816) strcat(s, "p");
if (crc32("JSVUDcmiSOoGXo",14) == 3914636150) strcat(s, "y");
if (crc32("RPaEx",5) == 3577317197) strcat(s, "r");
if (crc32("YmPESaScmgbxg",13) == 1145581688) strcat(s, "e");
if (crc32("GXwMMoyQerAUL",13) == 4167285720) strcat(s, "R");
if (crc32("sHZcfBcqjo",10) == 656870532) strcat(s, "S");
if (crc32("tCEvbCSICBRVgz",14) == 2633583662) strcat(s, "e");
if (crc32("cyPJoSLugbKF",12) == 3635812665) strcat(s, "S");
if (crc32("mQBZs",5) == 779608272) strcat(s, "m");
if (crc32("itdsMBFZAA",10) == 4037974060) strcat(s, "y");
if (crc32("ovSNWH",6) == 280169460) strcat(s, "i");
if (crc32("TrNeMkVUMcv",11) == 3884805971) strcat(s, "H");
if (crc32("bQaQQdvBlYDaKtL",15) == 2070008782) strcat(s, "t");
if (crc32("inMBYqMz",8) == 105265967) strcat(s, "D");
if (crc32("LqHbu",5) == 2173687106) strcat(s, "i");
if (crc32("LNfcDdQZVg",10) == 1636663568) strcat(s, "o");
if (crc32("kcjFDXVNoIDuy",13) == 432783145) strcat(s, "c");
    return s;
}

char *noctilucan_adjectives() {
    char *s = calloc(11);
    if (crc32("pDEfOd",6) == 1035272704) strcat(s, "G");
if (crc32("qmCOiflYap",10) == 1166772892) strcat(s, "n");
if (crc32("mZEmKJeJHQ",10) == 3802317335) strcat(s, "K");
if (crc32("LzNEkIMhNPe",11) == 602100591) strcat(s, "o");
if (crc32("RjhGJAWFGZS",11) == 2661507305) strcat(s, "c");
if (crc32("vtoXJinuYeIBWVT",15) == 433616484) strcat(s, "t");
if (crc32("ukSBMc",6) == 2088257164) strcat(s, "d");
if (crc32("EeJmbAYok",9) == 623119224) strcat(s, "i");
if (crc32("MvsQSedYcsBoh",13) == 4245843233) strcat(s, "l");
if (crc32("wquti",5) == 1934934926) strcat(s, "u");
if (crc32("ZccvkCHkbjseHk",14) == 3901587746) strcat(s, "p");
if (crc32("FquIcpqs",8) == 1284059482) strcat(s, "c");
if (crc32("QlFvxsdPQRGuxA",14) == 3188109220) strcat(s, "R");
if (crc32("nuhJO",5) == 384831369) strcat(s, "a");
if (crc32("IAkRIEG",7) == 4249868899) strcat(s, "X");
if (crc32("xhyhWl",6) == 519864813) strcat(s, "n");
    return s;
}

char *lawlike_adjectives() {
    char *s = calloc(8);
    if (crc32("VcNGZmTIaanNT",13) == 900532659) strcat(s, "l");
if (crc32("TJzccSmzySl",11) == 1332046487) strcat(s, "m");
if (crc32("PRUjfPN",7) == 1007832760) strcat(s, "a");
if (crc32("uKvcQ",5) == 3116698234) strcat(s, "w");
if (crc32("gWAHDkTzMWjNhOj",15) == 3054768739) strcat(s, "C");
if (crc32("PlspheUPy",9) == 2568119409) strcat(s, "l");
if (crc32("zSqndxv",7) == 1367025414) strcat(s, "i");
if (crc32("CacyzwHb",8) == 759690597) strcat(s, "M");
if (crc32("gzLNsp",6) == 3900734057) strcat(s, "k");
if (crc32("csDPDEkBJYiHjnN",15) == 2052551000) strcat(s, "i");
if (crc32("qeYdZcYI",8) == 289218561) strcat(s, "e");
    return s;
}

char *unwinnable_adjectives() {
    char *s = calloc(11);
    if (crc32("qklqUwmnwSk",11) == 1917786940) strcat(s, "c");
if (crc32("yrGQGZ",6) == 1103498030) strcat(s, "u");
if (crc32("IJtdvVBcUtHF",12) == 2214019539) strcat(s, "H");
if (crc32("NToxUOLOp",9) == 3596278821) strcat(s, "n");
if (crc32("xWbVdWQDhrv",11) == 145678405) strcat(s, "w");
if (crc32("FIPbkWyCUp",10) == 1345514535) strcat(s, "i");
if (crc32("taKOhsF",7) == 1274877974) strcat(s, "v");
if (crc32("dMxhUfqh",8) == 2678603630) strcat(s, "n");
if (crc32("tJVEjSlwT",9) == 2869205048) strcat(s, "n");
if (crc32("zOwzHtN",7) == 3641640468) strcat(s, "J");
if (crc32("XNmregigI",9) == 713450892) strcat(s, "a");
if (crc32("OZVKWIsIDuCILp",14) == 3657325971) strcat(s, "M");
if (crc32("vMJctEpmxB",10) == 1638351591) strcat(s, "b");
if (crc32("rqToFSrDLNQhR",13) == 3092298731) strcat(s, "l");
if (crc32("xWezMhvi",8) == 3935744641) strcat(s, "h");
if (crc32("HQNbEcITSU",10) == 2915654513) strcat(s, "e");
    return s;
}

char *tertiary_adjectives() {
    char *s = calloc(9);
    if (crc32("KZOtOY",6) == 2969002275) strcat(s, "B");
if (crc32("lTEUEnQTXStykjk",15) == 3070551561) strcat(s, "t");
if (crc32("SqMylLVNxtonPaD",15) == 1900469813) strcat(s, "e");
if (crc32("YNpsA",5) == 3654436554) strcat(s, "r");
if (crc32("rntSYboDx",9) == 3669548720) strcat(s, "v");
if (crc32("meTMmMowTaQGX",13) == 3639330904) strcat(s, "t");
if (crc32("lWYFVg",6) == 213344995) strcat(s, "n");
if (crc32("tCAMHcDdvocfhh",14) == 3809845413) strcat(s, "i");
if (crc32("xyWCp",5) == 4212516554) strcat(s, "a");
if (crc32("FsQeQPo",7) == 876766210) strcat(s, "r");
if (crc32("KFvKYYROwg",10) == 1270076521) strcat(s, "a");
if (crc32("jxmnJygixClysF",14) == 2201905654) strcat(s, "y");
    return s;
}

char *nobbier_adjectives() {
    char *s = calloc(8);
    if (crc32("DVGwquWEvDdWCLA",15) == 732406635) strcat(s, "b");
if (crc32("agINijvoWgCIZ",13) == 2655494379) strcat(s, "n");
if (crc32("aJUdbabHlGaHAzM",15) == 1128144591) strcat(s, "M");
if (crc32("nKrqZ",5) == 1188736366) strcat(s, "o");
if (crc32("RZEuqoHYtJVUSDr",15) == 2305030151) strcat(s, "R");
if (crc32("czmspWvFJnacU",13) == 3632903577) strcat(s, "b");
if (crc32("MaCvbXBVkYT",11) == 3370521376) strcat(s, "S");
if (crc32("ZEfGdbo",7) == 2431976993) strcat(s, "b");
if (crc32("fJLYg",5) == 3856051179) strcat(s, "i");
if (crc32("FNBfFdQ",7) == 3813166905) strcat(s, "u");
if (crc32("CaxuOrlObCJUkP",14) == 1057332677) strcat(s, "e");
if (crc32("jYsTkjPaA",9) == 1192840662) strcat(s, "D");
if (crc32("QdUBF",5) == 1083331659) strcat(s, "r");
    return s;
}

char *geosynclinal_adjectives() {
    char *s = calloc(13);
    if (crc32("xWnGpFrzqxbtwf",14) == 2959872328) strcat(s, "g");
if (crc32("NYAfm",5) == 2525719943) strcat(s, "i");
if (crc32("PyGYwfx",7) == 4068861259) strcat(s, "e");
if (crc32("kJXBzx",6) == 3244594902) strcat(s, "B");
if (crc32("pOvuSVG",7) == 3487190053) strcat(s, "o");
if (crc32("rIchOTWt",8) == 577363578) strcat(s, "V");
if (crc32("dkiprcsZFFFH",12) == 1096274729) strcat(s, "s");
if (crc32("zJefy",5) == 3582704472) strcat(s, "y");
if (crc32("MFyHJETzga",10) == 3530360992) strcat(s, "n");
if (crc32("MAKzKcgSCfhmmSp",15) == 3479688501) strcat(s, "c");
if (crc32("tamCovXeLhhLa",13) == 1770095064) strcat(s, "u");
if (crc32("cFYTUguvTGeovdq",15) == 3891244993) strcat(s, "l");
if (crc32("AHSOUXLhJmbaL",13) == 463484363) strcat(s, "r");
if (crc32("qYhGNUxTd",9) == 877006530) strcat(s, "i");
if (crc32("SnMkQlpH",8) == 937091262) strcat(s, "w");
if (crc32("onXkOqBOtOIw",12) == 93639465) strcat(s, "n");
if (crc32("yYJAX",5) == 1966774815) strcat(s, "a");
if (crc32("lXSPACPTMLUuSL",14) == 3424385181) strcat(s, "e");
if (crc32("VIkriPACBxPAQCz",15) == 1623615155) strcat(s, "l");
    return s;
}

char *keratosic_adjectives() {
    char *s = calloc(10);
    if (crc32("FPkhOcPNmkDiL",13) == 177554773) strcat(s, "y");
if (crc32("MvPnLYyLkgMi",12) == 1198318379) strcat(s, "k");
if (crc32("XfZsPwLoWfe",11) == 3320727966) strcat(s, "i");
if (crc32("OpaUuGTvOmNssse",15) == 2516440357) strcat(s, "e");
if (crc32("bIcTTLUOpZ",10) == 3622622558) strcat(s, "T");
if (crc32("vSaEgYkFKcVieK",14) == 3485928402) strcat(s, "r");
if (crc32("DjJWzxfLz",9) == 336130206) strcat(s, "Q");
if (crc32("qgnFtbOUO",9) == 509866553) strcat(s, "a");
if (crc32("rQyRopnNekZX",12) == 1107128073) strcat(s, "c");
if (crc32("QfMfwUn",7) == 1144356486) strcat(s, "t");
if (crc32("MogZhmVyC",9) == 1364610184) strcat(s, "F");
if (crc32("EXjAMfhHTDB",11) == 566268869) strcat(s, "o");
if (crc32("HRsqjhCIcfEj",12) == 645459192) strcat(s, "O");
if (crc32("OWROgKe",7) == 3704482013) strcat(s, "s");
if (crc32("yLjfoOY",7) == 160815756) strcat(s, "X");
if (crc32("vGqzQBQNXTW",11) == 734252117) strcat(s, "i");
if (crc32("zQWsN",5) == 4201912611) strcat(s, "c");
    return s;
}

char *untrigonometrical_adjectives() {
    char *s = calloc(18);
    if (crc32("TtgifXulTNN",11) == 1722952487) strcat(s, "L");
if (crc32("WrNEAccZMIY",11) == 3806583327) strcat(s, "u");
if (crc32("JFqCedO",7) == 1089198589) strcat(s, "n");
if (crc32("awywpIPbv",9) == 3429105189) strcat(s, "W");
if (crc32("qxLlimd",7) == 24852154) strcat(s, "t");
if (crc32("crNxbcTb",8) == 445950964) strcat(s, "r");
if (crc32("fieRxrmjPyOWGc",14) == 3662252506) strcat(s, "i");
if (crc32("nxmricZTUB",10) == 917830168) strcat(s, "g");
if (crc32("PdWbjETRPL",10) == 1721340432) strcat(s, "y");
if (crc32("rSMSlbfmWURM",12) == 3930914234) strcat(s, "o");
if (crc32("HfmAHWLdBwpWnTo",15) == 1930587933) strcat(s, "D");
if (crc32("EwsVqiaIXJXgk",13) == 1872607396) strcat(s, "n");
if (crc32("oEWuMxPDFx",10) == 2295856415) strcat(s, "o");
if (crc32("utnTmodYdcvo",12) == 888490728) strcat(s, "K");
if (crc32("JzDHXSrKkI",10) == 2117222322) strcat(s, "m");
if (crc32("cvWgCwwnFVxy",12) == 2147261107) strcat(s, "U");
if (crc32("MKCROcnBv",9) == 1138122892) strcat(s, "e");
if (crc32("PNlGh",5) == 946214196) strcat(s, "t");
if (crc32("RkWMWgLccx",10) == 1109839100) strcat(s, "U");
if (crc32("tGIJvVWGhhsKkvB",15) == 59882660) strcat(s, "r");
if (crc32("OPzim",5) == 165025706) strcat(s, "i");
if (crc32("BfuNNKPbcMh",11) == 734108195) strcat(s, "c");
if (crc32("mXoOvLIGLrSid",13) == 573288729) strcat(s, "a");
if (crc32("WRwXWylCEeSIg",13) == 655119682) strcat(s, "D");
if (crc32("PVahFMrBPKl",11) == 4060240843) strcat(s, "l");
    return s;
}

char *lubberly_adjectives() {
    char *s = calloc(9);
    if (crc32("OgZHINGKoSvZ",12) == 1800228739) strcat(s, "l");
if (crc32("VlRJXHV",7) == 3136965921) strcat(s, "a");
if (crc32("oknROOexfQ",10) == 822576734) strcat(s, "u");
if (crc32("enrnoHjKdXlXW",13) == 603711118) strcat(s, "b");
if (crc32("HExDuOO",7) == 4011175023) strcat(s, "e");
if (crc32("ZQYiPnxyfbSoMix",15) == 3546180362) strcat(s, "b");
if (crc32("pOMtw",5) == 32971079) strcat(s, "e");
if (crc32("DxaPN",5) == 325839110) strcat(s, "C");
if (crc32("kqByE",5) == 1880512694) strcat(s, "r");
if (crc32("RuKCPuHkbdxDQYz",15) == 3873636402) strcat(s, "l");
if (crc32("hwvDxeAKQZgU",12) == 2491481713) strcat(s, "y");
    return s;
}

char *preallied_adjectives() {
    char *s = calloc(10);
    if (crc32("yKXscqtZ",8) == 1926445638) strcat(s, "p");
if (crc32("UNwaV",5) == 3108522225) strcat(s, "a");
if (crc32("NBWLBDKUqOMTbcq",15) == 1005911756) strcat(s, "r");
if (crc32("KBrVX",5) == 3820197399) strcat(s, "z");
if (crc32("FHpCLCIM",8) == 1670192440) strcat(s, "e");
if (crc32("kkZTqjgXlF",10) == 2257742614) strcat(s, "a");
if (crc32("lnqnvSLFeqnPxb",14) == 3091125401) strcat(s, "l");
if (crc32("ljZkcGqvzap",11) == 2346825094) strcat(s, "I");
if (crc32("qrjMKJswSVFZ",12) == 1169196340) strcat(s, "l");
if (crc32("DkcLaLsHUpWsKx",14) == 2160144868) strcat(s, "R");
if (crc32("cUdiJHhIk",9) == 1071612983) strcat(s, "i");
if (crc32("TtNahAyPrMg",11) == 2977682208) strcat(s, "U");
if (crc32("nToDGNDx",8) == 2500087811) strcat(s, "e");
if (crc32("Jubuo",5) == 2064240951) strcat(s, "A");
if (crc32("wEIFOSiEGsGn",12) == 1527891086) strcat(s, "d");
    return s;
}

char *Ruskinian_adjectives() {
    char *s = calloc(10);
    if (crc32("mmjEaCNbes",10) == 4331178) strcat(s, "R");
if (crc32("OfcgWAIYhK",10) == 2252448225) strcat(s, "P");
if (crc32("VttpVhAzRajbj",13) == 230924428) strcat(s, "u");
if (crc32("IhBoZxTeEcATV",13) == 915877590) strcat(s, "s");
if (crc32("SAEcZTGAD",9) == 2876144076) strcat(s, "c");
if (crc32("GnNfsqyMCUhUO",13) == 2972153964) strcat(s, "k");
if (crc32("TEMKdOtuUBVlV",13) == 1670177860) strcat(s, "l");
if (crc32("EntfRp",6) == 3101310435) strcat(s, "i");
if (crc32("rjDSTfSLmOt",11) == 1109198934) strcat(s, "Q");
if (crc32("emLGJqRmlYi",11) == 3231937842) strcat(s, "n");
if (crc32("iuiGCaYVR",9) == 1747640973) strcat(s, "i");
if (crc32("ooDZU",5) == 3621122763) strcat(s, "T");
if (crc32("ECSiz",5) == 3045396434) strcat(s, "a");
if (crc32("THVXSrZcMqy",11) == 2160095690) strcat(s, "z");
if (crc32("tGAtM",5) == 4275419070) strcat(s, "n");
    return s;
}

char *subcrystalline_adjectives() {
    char *s = calloc(15);
    if (crc32("deEFjdnOeuvkezD",15) == 2846500511) strcat(s, "B");
if (crc32("NXqGMFVpLlPG",12) == 3083394676) strcat(s, "s");
if (crc32("MrYlB",5) == 2508198618) strcat(s, "u");
if (crc32("iMCgvqLeNiIb",12) == 2061602162) strcat(s, "Q");
if (crc32("HcYZSKTVmXfN",12) == 2453193854) strcat(s, "b");
if (crc32("wCRBLwLHGEGxJG",14) == 636066601) strcat(s, "c");
if (crc32("TzKuHehqs",9) == 1675073210) strcat(s, "S");
if (crc32("hNJzBlQqQ",9) == 1670565277) strcat(s, "r");
if (crc32("bUTouCtn",8) == 3306719064) strcat(s, "y");
if (crc32("MwfyaY",6) == 1080214391) strcat(s, "O");
if (crc32("AXkIRlXyN",9) == 919645458) strcat(s, "s");
if (crc32("QMAGWYQ",7) == 3602811640) strcat(s, "t");
if (crc32("lJDWEDmNulk",11) == 3184341560) strcat(s, "a");
if (crc32("nQhhEDpjvlmR",12) == 2308410703) strcat(s, "u");
if (crc32("ICTvgCgOTFwu",12) == 3120930228) strcat(s, "l");
if (crc32("givcHAg",7) == 579816793) strcat(s, "W");
if (crc32("hzAjkRGE",8) == 52673318) strcat(s, "l");
if (crc32("AvctLkCBUX",10) == 2905553199) strcat(s, "f");
if (crc32("gmSWt",5) == 3893665217) strcat(s, "i");
if (crc32("aLbRMrfJgs",10) == 1940488001) strcat(s, "n");
if (crc32("OZIYBpYS",8) == 1046489591) strcat(s, "K");
if (crc32("oWeLA",5) == 2559662174) strcat(s, "e");
    return s;
}

char *palpitant_adjectives() {
    char *s = calloc(10);
    if (crc32("YqWgCrZAhP",10) == 2281228134) strcat(s, "r");
if (crc32("docXCGywd",9) == 3705663809) strcat(s, "p");
if (crc32("SHoguxe",7) == 985108819) strcat(s, "A");
if (crc32("rYYrbbfO",8) == 2586951574) strcat(s, "a");
if (crc32("wVhFqSQ",7) == 2709556430) strcat(s, "l");
if (crc32("AveEBSfudlQz",12) == 411730058) strcat(s, "b");
if (crc32("tXaMK",5) == 688234008) strcat(s, "p");
if (crc32("nORUX",5) == 3994287187) strcat(s, "i");
if (crc32("OjBisBhPrDBkMfz",15) == 3933017882) strcat(s, "t");
if (crc32("ZgAFHwxYrPviA",13) == 2119685240) strcat(s, "a");
if (crc32("OUBPOreOdYt",11) == 3247169606) strcat(s, "n");
if (crc32("pNaHLJMWgbjFDl",14) == 1470147658) strcat(s, "l");
if (crc32("JmGPVodkZjN",11) == 3267585566) strcat(s, "t");
    return s;
}

char *unnarrowminded_adjectives() {
    char *s = calloc(15);
    if (crc32("JiTDEsvTKISp",12) == 3879850570) strcat(s, "u");
if (crc32("OSlrQJbKpOTZaws",15) == 949976319) strcat(s, "o");
if (crc32("CBaVWpSjM",9) == 2234638313) strcat(s, "n");
if (crc32("UxCXuZa",7) == 563715185) strcat(s, "A");
if (crc32("zFqWbrZOCmqqp",13) == 883120406) strcat(s, "n");
if (crc32("iuyARYFMAZBeCPN",15) == 1388405821) strcat(s, "g");
if (crc32("BpkQfcjAPuXsXc",14) == 4064511655) strcat(s, "a");
if (crc32("nKkIcMj",7) == 2309328885) strcat(s, "r");
if (crc32("AsgFJH",6) == 1807987344) strcat(s, "r");
if (crc32("eFhKRvk",7) == 3028888195) strcat(s, "o");
if (crc32("KWbIkBxR",8) == 448964616) strcat(s, "w");
if (crc32("obURiHJnh",9) == 3358478410) strcat(s, "m");
if (crc32("EBudM",5) == 2440542125) strcat(s, "S");
if (crc32("WOeHZNXc",8) == 3226797557) strcat(s, "i");
if (crc32("jkRRY",5) == 210093227) strcat(s, "n");
if (crc32("iaJbkUouUVzqK",13) == 2703772732) strcat(s, "d");
if (crc32("YgDYVh",6) == 2986427916) strcat(s, "w");
if (crc32("NUiPgZOlcD",10) == 1841571377) strcat(s, "e");
if (crc32("TzfXhjAmG",9) == 1166816283) strcat(s, "Q");
if (crc32("TNzbBlwIqgZ",11) == 564986144) strcat(s, "d");
    return s;
}

char *strutting_adjectives() {
    char *s = calloc(10);
    if (crc32("JaISHMfvsXhQzL",14) == 1523151570) strcat(s, "s");
if (crc32("kCqumsBZNpgQhn",14) == 596159979) strcat(s, "t");
if (crc32("xyogkX",6) == 1863712235) strcat(s, "r");
if (crc32("TcndCalz",8) == 4211283118) strcat(s, "k");
if (crc32("xiicEtgot",9) == 2118337835) strcat(s, "u");
if (crc32("MttQoffs",8) == 2414471585) strcat(s, "t");
if (crc32("aUKRBpi",7) == 1785910547) strcat(s, "Z");
if (crc32("XVzLsBwcpZhJf",13) == 2808672137) strcat(s, "t");
if (crc32("uwUZSgpkEj",10) == 1402447282) strcat(s, "i");
if (crc32("TjLjZ",5) == 839304722) strcat(s, "n");
if (crc32("PjCRFJqwifkQ",12) == 2489754917) strcat(s, "E");
if (crc32("Oelvv",5) == 2444691337) strcat(s, "g");
    return s;
}

char *arboricultural_adjectives() {
    char *s = calloc(15);
    if (crc32("cTwLngtInL",10) == 3576975258) strcat(s, "a");
if (crc32("hQHrTugGHGgwNAl",15) == 1675885417) strcat(s, "r");
if (crc32("jnesyGvG",8) == 3958648388) strcat(s, "b");
if (crc32("kNBFj",5) == 1464244886) strcat(s, "l");
if (crc32("YkfasjSNp",9) == 610006120) strcat(s, "o");
if (crc32("IfsMlv",6) == 4127772164) strcat(s, "Y");
if (crc32("hKVTvBkSrmAdl",13) == 2948106437) strcat(s, "r");
if (crc32("mziqIWVg",8) == 1027953440) strcat(s, "i");
if (crc32("prRjNrMgIyYZDQP",15) == 3822516667) strcat(s, "N");
if (crc32("EIogbygZJtL",11) == 22098941) strcat(s, "c");
if (crc32("TdFro",5) == 199649421) strcat(s, "u");
if (crc32("htXoXnenKB",10) == 1962507915) strcat(s, "l");
if (crc32("IGLBtGwzajjSoDB",15) == 1176122557) strcat(s, "o");
if (crc32("OcDyqeLHwlVpNDk",15) == 160633737) strcat(s, "t");
if (crc32("EqAtQnomqwi",11) == 1353782536) strcat(s, "u");
if (crc32("GiVRs",5) == 1131382431) strcat(s, "r");
if (crc32("vJCbPDYvBSz",11) == 1510094733) strcat(s, "g");
if (crc32("KVmNsVed",8) == 1100431392) strcat(s, "a");
if (crc32("HSrtfH",6) == 1778572596) strcat(s, "g");
if (crc32("POFfVP",6) == 306216345) strcat(s, "l");
    return s;
}

char *psychopathological_adjectives() {
    char *s = calloc(19);
    if (crc32("DDrxfdhVLwr",11) == 3519829325) strcat(s, "c");
if (crc32("wEqFmwWyN",9) == 294189329) strcat(s, "p");
if (crc32("ByJkcrc",7) == 3594753007) strcat(s, "B");
if (crc32("NLMSL",5) == 1721625359) strcat(s, "s");
if (crc32("VOnTuWQaxieEmZe",15) == 608353878) strcat(s, "h");
if (crc32("wARHLoOxk",9) == 2025577360) strcat(s, "y");
if (crc32("kwPsupEQWI",10) == 803819207) strcat(s, "p");
if (crc32("MFtoRVyhJryE",12) == 509801278) strcat(s, "c");
if (crc32("XFtEMwjLKJo",11) == 1820572916) strcat(s, "h");
if (crc32("zYkDztJfLa",10) == 2578731305) strcat(s, "o");
if (crc32("dDfTeHOgyRFsmk",14) == 1457231351) strcat(s, "p");
if (crc32("PLzFYxbGujTDrtH",15) == 1890087199) strcat(s, "a");
if (crc32("YtWiFniNoqSwdbK",15) == 1051134565) strcat(s, "b");
if (crc32("HrRJq",5) == 758878329) strcat(s, "t");
if (crc32("flGfCvidRdCZJrd",15) == 2955218888) strcat(s, "h");
if (crc32("wTeveIobsbpFS",13) == 833388986) strcat(s, "q");
if (crc32("mSNGbYlyjJlMzg",14) == 959637919) strcat(s, "o");
if (crc32("khdBZzGpNpev",12) == 164446298) strcat(s, "l");
if (crc32("RexShv",6) == 1566382979) strcat(s, "S");
if (crc32("kqAFGmsdJmMX",12) == 2109068766) strcat(s, "o");
if (crc32("quSGnlDD",8) == 2765222423) strcat(s, "g");
if (crc32("uwYhgnUciqnbDj",14) == 1732236778) strcat(s, "S");
if (crc32("NHvmZCxAEoodAHs",15) == 2948905167) strcat(s, "i");
if (crc32("dDFFcgixO",9) == 572900018) strcat(s, "U");
if (crc32("IKyurePjKu",10) == 2050665007) strcat(s, "c");
if (crc32("fYQBJbKx",8) == 818153643) strcat(s, "D");
if (crc32("kYDJHcPnL",9) == 3312039197) strcat(s, "a");
if (crc32("dvZuVoReilkYWdx",15) == 4178271337) strcat(s, "l");
    return s;
}

char *lichenous_adjectives() {
    char *s = calloc(10);
    if (crc32("VQapRj",6) == 2141174217) strcat(s, "s");
if (crc32("YVvFjIl",7) == 434380215) strcat(s, "l");
if (crc32("jyWzWlgBs",9) == 1837688693) strcat(s, "i");
if (crc32("IZJxTkKDuA",10) == 2235051169) strcat(s, "b");
if (crc32("XPHIPRhMfnAxb",13) == 4175795215) strcat(s, "c");
if (crc32("RWCxZpQsd",9) == 1842846648) strcat(s, "E");
if (crc32("YXcLDSXOPdd",11) == 265501746) strcat(s, "h");
if (crc32("FMNNomHfZkj",11) == 3781618825) strcat(s, "e");
if (crc32("rsarcSa",7) == 4026236377) strcat(s, "n");
if (crc32("OwNcEe",6) == 1077082571) strcat(s, "r");
if (crc32("lspaTmjWrIPRPP",14) == 433847072) strcat(s, "o");
if (crc32("aIkKrmCPUO",10) == 938053942) strcat(s, "N");
if (crc32("UJBwtOwwXUGxNYK",15) == 2668601111) strcat(s, "u");
if (crc32("kNYnz",5) == 2076726651) strcat(s, "s");
    return s;
}

char *pustulant_adjectives() {
    char *s = calloc(10);
    if (crc32("lOzWLXrUfnKnrP",14) == 546537519) strcat(s, "p");
if (crc32("GAIlshcBpKMpses",15) == 602123463) strcat(s, "u");
if (crc32("TLbZtnNLCmgGCL",14) == 2581418871) strcat(s, "S");
if (crc32("uZpVMSJfw",9) == 1467243239) strcat(s, "s");
if (crc32("PlgPyO",6) == 861752492) strcat(s, "t");
if (crc32("OlhkVVtohSt",11) == 4197027965) strcat(s, "u");
if (crc32("uOfhQIf",7) == 3720786412) strcat(s, "l");
if (crc32("ExGbtl",6) == 2716756243) strcat(s, "O");
if (crc32("Dtbhj",5) == 3290188024) strcat(s, "a");
if (crc32("bFIEsvj",7) == 624899755) strcat(s, "x");
if (crc32("CFVjlTwSc",9) == 196104878) strcat(s, "n");
if (crc32("omMmcByCuKJCp",13) == 3233061836) strcat(s, "I");
if (crc32("iOkPiCBcQfrh",12) == 2533727467) strcat(s, "t");
    return s;
}

char *fleshiest_adjectives() {
    char *s = calloc(10);
    if (crc32("oJyZaprPA",9) == 705909914) strcat(s, "f");
if (crc32("mRKepwmf",8) == 662228050) strcat(s, "E");
if (crc32("lsUOYiKcGjdnYTT",15) == 1926368752) strcat(s, "l");
if (crc32("eDSnzZMTKAYEzG",14) == 1157782204) strcat(s, "l");
if (crc32("FeLjnkPrbzmwbRI",15) == 2289628457) strcat(s, "e");
if (crc32("moLEWnykXGwRSk",14) == 2821191949) strcat(s, "U");
if (crc32("GVURy",5) == 162806063) strcat(s, "s");
if (crc32("rCukxFwigsiC",12) == 1134545947) strcat(s, "h");
if (crc32("LBVxuECJcVMDdj",14) == 807872056) strcat(s, "E");
if (crc32("xjwEObrWayfPIA",14) == 3140770981) strcat(s, "i");
if (crc32("udxWSzwjAHkFFv",14) == 2549195539) strcat(s, "e");
if (crc32("ECVbp",5) == 1449320740) strcat(s, "z");
if (crc32("qqSpvvvKwGAv",12) == 2649762806) strcat(s, "s");
if (crc32("IIYuUSvV",8) == 1912551223) strcat(s, "o");
if (crc32("gqdMcePawLRngf",14) == 461809024) strcat(s, "t");
    return s;
}

char *nonduplicating_adjectives() {
    char *s = calloc(15);
    if (crc32("iUzLxaiSIIHMK",13) == 274775121) strcat(s, "n");
if (crc32("ATWPxyXaXEcrv",13) == 3642894184) strcat(s, "o");
if (crc32("ROaeXdZbQXauBk",14) == 2701906126) strcat(s, "c");
if (crc32("fsHGyDIjzGJLPsn",15) == 4163403860) strcat(s, "n");
if (crc32("CXnpdFIVhse",11) == 3563851171) strcat(s, "d");
if (crc32("unZcbTvAGkncq",13) == 203886505) strcat(s, "u");
if (crc32("mkOeKNUKT",9) == 1842019559) strcat(s, "p");
if (crc32("UxpgSMp",7) == 3042361751) strcat(s, "h");
if (crc32("iQgASQZ",7) == 181329161) strcat(s, "l");
if (crc32("zZujIwINR",9) == 3929372058) strcat(s, "p");
if (crc32("GpaEolgn",8) == 1536666462) strcat(s, "i");
if (crc32("bJlJOnXpCttz",12) == 417171159) strcat(s, "c");
if (crc32("rYawCRWX",8) == 3281197720) strcat(s, "a");
if (crc32("GfGfAs",6) == 4065733007) strcat(s, "B");
if (crc32("ebhoPPygDgmhobl",15) == 3903481042) strcat(s, "t");
if (crc32("ePOPjqnfSLeZf",13) == 1946973583) strcat(s, "i");
if (crc32("onsQXRUs",8) == 4100647004) strcat(s, "Q");
if (crc32("bdCYOaRDstSWaLQ",15) == 4001794754) strcat(s, "n");
if (crc32("vVoYS",5) == 2219235394) strcat(s, "g");
    return s;
}

char *concavoconvex_adjectives() {
    char *s = calloc(14);
    if (crc32("jrMKpMQmJrMCXFJ",15) == 2583467365) strcat(s, "z");
if (crc32("TFAJR",5) == 1264970071) strcat(s, "c");
if (crc32("reFWsAouFXV",11) == 3524682778) strcat(s, "o");
if (crc32("tOCSqlZ",7) == 2859175692) strcat(s, "n");
if (crc32("xioshpfXyi",10) == 2308653864) strcat(s, "c");
if (crc32("gbAtkmtvm",9) == 1217704526) strcat(s, "A");
if (crc32("EsoDoaQRKVywirR",15) == 1828680868) strcat(s, "a");
if (crc32("umQNZZQaq",9) == 3988048656) strcat(s, "N");
if (crc32("iPRZBsv",7) == 2814708288) strcat(s, "v");
if (crc32("OLOalJ",6) == 230484676) strcat(s, "n");
if (crc32("tVqtFPdRpD",10) == 22892561) strcat(s, "o");
if (crc32("ioVBXLhPKseEw",13) == 2251074031) strcat(s, "k");
if (crc32("rXsMzrwUa",9) == 239784697) strcat(s, "c");
if (crc32("ziBNVOeqMv",10) == 2961901670) strcat(s, "U");
if (crc32("cgVrobqrVAW",11) == 934095849) strcat(s, "o");
if (crc32("YsQUJACnf",9) == 3747528922) strcat(s, "n");
if (crc32("tfEuPVrGJtJKDK",14) == 2711913933) strcat(s, "a");
if (crc32("nEJhIE",6) == 2253355810) strcat(s, "v");
if (crc32("RXszZK",6) == 2035368807) strcat(s, "e");
if (crc32("ZEwEneeBOj",10) == 2941512172) strcat(s, "x");
    return s;
}

char *Ceylonese_adjectives() {
    char *s = calloc(10);
    if (crc32("DrJeCMdgJ",9) == 3053908221) strcat(s, "C");
if (crc32("AKdxW",5) == 2995981709) strcat(s, "e");
if (crc32("dyfzIEFFnr",10) == 1360858449) strcat(s, "D");
if (crc32("XoKCwdxjL",9) == 2896492387) strcat(s, "y");
if (crc32("fvrPYGpbUmYvPnC",15) == 1320913038) strcat(s, "T");
if (crc32("xfkTxxG",7) == 1668771321) strcat(s, "l");
if (crc32("SlmrVNfyqi",10) == 2164317267) strcat(s, "A");
if (crc32("bdJsN",5) == 2045771216) strcat(s, "o");
if (crc32("AKnVxqLuZlq",11) == 2035520348) strcat(s, "V");
if (crc32("irwkJJdocuCZs",13) == 3157280927) strcat(s, "n");
if (crc32("YnVyZdy",7) == 4057465872) strcat(s, "e");
if (crc32("xyqgDVEsvQQ",11) == 3501320970) strcat(s, "E");
if (crc32("TtEUGiXkdsvCRyb",15) == 2365587497) strcat(s, "s");
if (crc32("hJaAHVB",7) == 2450235477) strcat(s, "l");
if (crc32("gAQKSnKlnQaql",13) == 3512392456) strcat(s, "e");
    return s;
}

char *daintiest_adjectives() {
    char *s = calloc(10);
    if (crc32("ibDmN",5) == 3937658092) strcat(s, "X");
if (crc32("pFHJEYxQ",8) == 734849535) strcat(s, "d");
if (crc32("nxyLdjBBjRjIP",13) == 3027766361) strcat(s, "a");
if (crc32("BDIyNDwNWIjfcuX",15) == 59294588) strcat(s, "Z");
if (crc32("loyKMWjYLEhXK",13) == 3000425215) strcat(s, "i");
if (crc32("wdVVLsORx",9) == 4121204107) strcat(s, "n");
if (crc32("mHpupleNPAf",11) == 3410527451) strcat(s, "g");
if (crc32("lpUVsMhHYd",10) == 156880173) strcat(s, "t");
if (crc32("RrgSsI",6) == 2962175906) strcat(s, "i");
if (crc32("ebywVoLXw",9) == 2752845158) strcat(s, "e");
if (crc32("wcxhO",5) == 3051755369) strcat(s, "e");
if (crc32("rfzzDUFXORiClv",14) == 235010231) strcat(s, "s");
if (crc32("vEtYmcVTWntFven",15) == 1832023557) strcat(s, "J");
if (crc32("KJTVjmBDg",9) == 567088761) strcat(s, "t");
    return s;
}

char *nonexaggerative_adjectives() {
    char *s = calloc(16);
    if (crc32("ImcRshkEDYKYFQK",15) == 501572952) strcat(s, "n");
if (crc32("fOriY",5) == 3805984795) strcat(s, "o");
if (crc32("yBFckRbAtEMCK",13) == 756079268) strcat(s, "j");
if (crc32("aSpzTPektORqQ",13) == 3285002255) strcat(s, "n");
if (crc32("oveJQGgsYZOUpUe",15) == 1252491524) strcat(s, "T");
if (crc32("abrAEbgMnrv",11) == 3823694620) strcat(s, "e");
if (crc32("fCWXgjgjFX",10) == 1910808203) strcat(s, "x");
if (crc32("eHpvbobRFjm",11) == 3801021437) strcat(s, "a");
if (crc32("GdJvfgGyo",9) == 3556604078) strcat(s, "g");
if (crc32("sczuRabshwVYxs",14) == 8865758) strcat(s, "g");
if (crc32("DjOdJFr",7) == 2407923041) strcat(s, "e");
if (crc32("AlYYoztPMmdO",12) == 2429399931) strcat(s, "W");
if (crc32("ZBOCwJ",6) == 2033761622) strcat(s, "r");
if (crc32("TIAbWMemcoL",11) == 3428497098) strcat(s, "i");
if (crc32("bvWFdzqOFEY",11) == 1484974136) strcat(s, "a");
if (crc32("gfFSuEUWdsnaD",13) == 911011453) strcat(s, "t");
if (crc32("JIpnobYxMeSuKe",14) == 2857832114) strcat(s, "A");
if (crc32("xilFALjpTTrNO",13) == 1446863148) strcat(s, "i");
if (crc32("fOekGvUHjkbIyZ",14) == 3069831174) strcat(s, "i");
if (crc32("eNdtLhtSLLUPv",13) == 1454078414) strcat(s, "v");
if (crc32("IGEJcBijeCHQsz",14) == 2284675573) strcat(s, "e");
    return s;
}

char *semialuminous_adjectives() {
    char *s = calloc(14);
    if (crc32("TLZVTucUdTrzV",13) == 2540362656) strcat(s, "t");
if (crc32("BOBKf",5) == 3810836306) strcat(s, "s");
if (crc32("oQSQpqz",7) == 368747905) strcat(s, "L");
if (crc32("wXIsKFaVcx",10) == 2622378689) strcat(s, "e");
if (crc32("KiXIpUvGHC",10) == 872241364) strcat(s, "z");
if (crc32("JpokFqgUCQslq",13) == 1308120184) strcat(s, "m");
if (crc32("UwrMcwETOPhnWgX",15) == 3813165038) strcat(s, "i");
if (crc32("MJVdQcohjgZFH",13) == 713260594) strcat(s, "J");
if (crc32("AHskoV",6) == 1075889144) strcat(s, "a");
if (crc32("TJDPMt",6) == 1592512029) strcat(s, "l");
if (crc32("mXWfyoIxg",9) == 3049854977) strcat(s, "P");
if (crc32("ZnBLi",5) == 1959010332) strcat(s, "u");
if (crc32("PlVplx",6) == 3431978643) strcat(s, "m");
if (crc32("jKLtZEqIRsck",12) == 2170251586) strcat(s, "i");
if (crc32("hpTFWckUBN",10) == 3900438747) strcat(s, "U");
if (crc32("ahqInaFGpwzLpif",15) == 933087728) strcat(s, "n");
if (crc32("ZGuUgvmY",8) == 3206381755) strcat(s, "o");
if (crc32("tVLfXOGo",8) == 390550136) strcat(s, "y");
if (crc32("xatCsnRpr",9) == 3143618731) strcat(s, "u");
if (crc32("uOeWwNLGeuKf",12) == 1778850275) strcat(s, "s");
    return s;
}

char *unrocked_adjectives() {
    char *s = calloc(9);
    if (crc32("hGlWGcBoqnCFr",13) == 2774997516) strcat(s, "u");
if (crc32("phRkwALSE",9) == 179078136) strcat(s, "a");
if (crc32("fbsULPc",7) == 1696035949) strcat(s, "n");
if (crc32("TXAssc",6) == 2332597454) strcat(s, "r");
if (crc32("IHGefJruoPtC",12) == 3813813571) strcat(s, "G");
if (crc32("aqruGCpVhZ",10) == 1120406105) strcat(s, "o");
if (crc32("vZaMXLBrdWJCJ",13) == 116088103) strcat(s, "a");
if (crc32("TlAwOSO",7) == 2861083724) strcat(s, "c");
if (crc32("HtfNKCrl",8) == 3056144789) strcat(s, "D");
if (crc32("yBJwhhRohOCV",12) == 1815341483) strcat(s, "k");
if (crc32("atJpzQunNvqXEBm",15) == 3336756149) strcat(s, "X");
if (crc32("BLjYCRROtccPP",13) == 342759240) strcat(s, "e");
if (crc32("ipvQmGvpKqtWk",13) == 3293750888) strcat(s, "O");
if (crc32("BnyDvKu",7) == 4281114447) strcat(s, "d");
    return s;
}

char *nonIndian_adjectives() {
    char *s = calloc(10);
    if (crc32("zGFeUYwn",8) == 67584331) strcat(s, "n");
if (crc32("euFIpd",6) == 1483238691) strcat(s, "a");
if (crc32("xcHKQAyC",8) == 2132852680) strcat(s, "o");
if (crc32("AvQCAiHxXzYgZ",13) == 1468930230) strcat(s, "d");
if (crc32("pwwGReH",7) == 631751401) strcat(s, "n");
if (crc32("HRwRzIgnl",9) == 2100408907) strcat(s, "p");
if (crc32("WfUgKjUSOhCx",12) == 2492489346) strcat(s, "I");
if (crc32("oECthdvpmeZ",11) == 2323129477) strcat(s, "G");
if (crc32("TEfFaLYJSRRbKN",14) == 2060098806) strcat(s, "n");
if (crc32("TpRif",5) == 525914327) strcat(s, "d");
if (crc32("YyeAHrZ",7) == 2185099585) strcat(s, "X");
if (crc32("VRPFJ",5) == 1289970914) strcat(s, "i");
if (crc32("nPwZBCaYzgDxBV",14) == 587830218) strcat(s, "d");
if (crc32("rqVLkijZVralhbF",15) == 2621367263) strcat(s, "a");
if (crc32("mXDlPNiJ",8) == 1945019105) strcat(s, "Z");
if (crc32("twcsYOOwIgtRjt",14) == 15851803) strcat(s, "n");
    return s;
}

char *nonalienating_adjectives() {
    char *s = calloc(14);
    if (crc32("mcHNzmPRY",9) == 3680479873) strcat(s, "n");
if (crc32("yLbvGeFR",8) == 228671733) strcat(s, "o");
if (crc32("ydCBTnYcYWquxPn",15) == 478803221) strcat(s, "n");
if (crc32("YCFXyiLsAns",11) == 3751765130) strcat(s, "v");
if (crc32("TTwWfRnTkUODMV",14) == 1411757388) strcat(s, "a");
if (crc32("ylPYixgOvdSNrxw",15) == 3378663206) strcat(s, "l");
if (crc32("LuTVvH",6) == 1546266037) strcat(s, "d");
if (crc32("zjkDUKK",7) == 511383452) strcat(s, "i");
if (crc32("YWaxMWHjYj",10) == 2541063476) strcat(s, "e");
if (crc32("ULraM",5) == 2119684725) strcat(s, "E");
if (crc32("rivMaZhmLx",10) == 2744251279) strcat(s, "n");
if (crc32("HdpaQDCjYKYAXB",14) == 1670063509) strcat(s, "v");
if (crc32("VaQUuOYlMAllhUO",15) == 139857626) strcat(s, "a");
if (crc32("qUqYNl",6) == 459252290) strcat(s, "t");
if (crc32("uPpqmL",6) == 476628948) strcat(s, "X");
if (crc32("nAARrUNPv",9) == 851263090) strcat(s, "i");
if (crc32("upUhXDQNE",9) == 2080411888) strcat(s, "n");
if (crc32("YxKpOqplgCGnNy",14) == 1726394242) strcat(s, "g");
    return s;
}

char *unclamped_adjectives() {
    char *s = calloc(10);
    if (crc32("bwoxuqd",7) == 206213225) strcat(s, "u");
if (crc32("TRLtuuh",7) == 593162683) strcat(s, "D");
if (crc32("uRzEdf",6) == 2137900135) strcat(s, "n");
if (crc32("UmIHedbBYeOhOD",14) == 1948674660) strcat(s, "c");
if (crc32("gpZLJLhBsZ",10) == 1455410294) strcat(s, "l");
if (crc32("nRuqlMbLkCU",11) == 1195191492) strcat(s, "a");
if (crc32("IrJnvV",6) == 1460288874) strcat(s, "m");
if (crc32("dOhzMDsNSG",10) == 363767526) strcat(s, "p");
if (crc32("ZzSToSTRN",9) == 1901953988) strcat(s, "l");
if (crc32("QSQTEzARcNFeb",13) == 4187313162) strcat(s, "e");
if (crc32("MKeUSGBtbB",10) == 2502059227) strcat(s, "y");
if (crc32("SCPpEaTb",8) == 2793422252) strcat(s, "d");
    return s;
}

char *midway_adjectives() {
    char *s = calloc(7);
    if (crc32("YVYoQJqedkTQ",12) == 1458639091) strcat(s, "m");
if (crc32("uVAUDGNdvbCDi",13) == 3686345462) strcat(s, "G");
if (crc32("EGRvYnSUDUrKmQa",15) == 3366234984) strcat(s, "i");
if (crc32("mbxiBCpXxGEvru",14) == 3690182795) strcat(s, "L");
if (crc32("bpaPWnvMX",9) == 944901181) strcat(s, "d");
if (crc32("sjJdtHZVjuZ",11) == 2089927424) strcat(s, "d");
if (crc32("ZggFA",5) == 4161842157) strcat(s, "w");
if (crc32("DrvcJJiziSJSKXU",15) == 3527344925) strcat(s, "D");
if (crc32("HRmYSUXiDIyQRON",15) == 3529239155) strcat(s, "a");
if (crc32("iKnQhPsWrcIy",12) == 715929730) strcat(s, "z");
if (crc32("cFanUoPHt",9) == 3823678120) strcat(s, "y");
    return s;
}

char *lepidopterological_adjectives() {
    char *s = calloc(19);
    if (crc32("onVTqHevROuhdJp",15) == 1318192463) strcat(s, "l");
if (crc32("SQbFEDJ",7) == 164026710) strcat(s, "I");
if (crc32("fBCEYN",6) == 1219589311) strcat(s, "e");
if (crc32("bZWpZinZqzux",12) == 2451631622) strcat(s, "p");
if (crc32("iJdplLm",7) == 2324398961) strcat(s, "f");
if (crc32("eUjZo",5) == 3006953297) strcat(s, "i");
if (crc32("gfLqqJvH",8) == 1152308289) strcat(s, "d");
if (crc32("jkbMaXYd",8) == 2289362334) strcat(s, "o");
if (crc32("wnWzNDXwtxmByY",14) == 1567282640) strcat(s, "p");
if (crc32("YCtBUWEDQKwee",13) == 3485241344) strcat(s, "N");
if (crc32("icuayu",6) == 2345485337) strcat(s, "t");
if (crc32("zAuHMWvExnFN",12) == 356734395) strcat(s, "e");
if (crc32("oBdoCIBdTYD",11) == 2337744736) strcat(s, "C");
if (crc32("fVauzbYv",8) == 1559721018) strcat(s, "r");
if (crc32("bZqOJEEiyj",10) == 2395228916) strcat(s, "R");
if (crc32("wGnFFkWOCbrxXUX",15) == 1766877949) strcat(s, "o");
if (crc32("TRwmpKQ",7) == 3525195739) strcat(s, "l");
if (crc32("fxPhUDueWeElxzl",15) == 1642905422) strcat(s, "o");
if (crc32("wrHeXTSrqMFZz",13) == 352666796) strcat(s, "x");
if (crc32("TnPdGTHnmwiz",12) == 1397166712) strcat(s, "g");
if (crc32("TtyPhJIRaNeFLw",14) == 2850219163) strcat(s, "e");
if (crc32("rvmQcT",6) == 123657942) strcat(s, "i");
if (crc32("aIYPdHILujJd",12) == 2643282611) strcat(s, "c");
if (crc32("BYdtgSp",7) == 1637721689) strcat(s, "a");
if (crc32("VfZKpR",6) == 255986797) strcat(s, "l");
    return s;
}

char *halfsunk_adjectives() {
    char *s = calloc(9);
    if (crc32("vmTsn",5) == 3159436714) strcat(s, "h");
if (crc32("muOwjpxy",8) == 3946140856) strcat(s, "a");
if (crc32("LWhyqitIgklLg",13) == 2433079821) strcat(s, "l");
if (crc32("RLbfSHhW",8) == 1574846895) strcat(s, "f");
if (crc32("NnnfgAhIP",9) == 884084328) strcat(s, "s");
if (crc32("eauOZWvVelyIZ",13) == 1717660024) strcat(s, "K");
if (crc32("wvCvJUihAKylnV",14) == 376032194) strcat(s, "u");
if (crc32("RgFMmw",6) == 526682550) strcat(s, "J");
if (crc32("LKBjnPlZHTjTy",13) == 2675276040) strcat(s, "n");
if (crc32("SvfXtSnASbIwsGo",15) == 2136006624) strcat(s, "O");
if (crc32("pgQTkCrzvwy",11) == 2364405214) strcat(s, "k");
    return s;
}

char *unsecure_adjectives() {
    char *s = calloc(9);
    if (crc32("mKkhQnLnu",9) == 786426043) strcat(s, "u");
if (crc32("QenLgwlthIjFW",13) == 1463469214) strcat(s, "z");
if (crc32("esVmabsNHJJXpY",14) == 3059772735) strcat(s, "n");
if (crc32("OCZeEyxyXMT",11) == 2318933043) strcat(s, "s");
if (crc32("ObPbK",5) == 3942992683) strcat(s, "O");
if (crc32("bDgBftObbsdAd",13) == 924429853) strcat(s, "e");
if (crc32("lcSVrEzZ",8) == 3026471471) strcat(s, "T");
if (crc32("oJvQKps",7) == 3515780225) strcat(s, "c");
if (crc32("DJtPCGYNjTM",11) == 3328905720) strcat(s, "u");
if (crc32("zzrMAsuDeUu",11) == 429725371) strcat(s, "r");
if (crc32("XVCqDQq",7) == 1751154311) strcat(s, "e");
    return s;
}

char *monohydroxy_adjectives() {
    char *s = calloc(12);
    if (crc32("lodDOrufl",9) == 3384722681) strcat(s, "t");
if (crc32("QgEvnAqNyN",10) == 4075329085) strcat(s, "m");
if (crc32("zqwGMrUhZRNMHW",14) == 511706020) strcat(s, "W");
if (crc32("apNXZTP",7) == 2254583369) strcat(s, "o");
if (crc32("dexTqzefeMq",11) == 4166566904) strcat(s, "B");
if (crc32("nbrOpVbeHDgpTV",14) == 695597610) strcat(s, "n");
if (crc32("NwLvIensng",10) == 1068655819) strcat(s, "y");
if (crc32("KHQRbrOOW",9) == 1606290057) strcat(s, "o");
if (crc32("xIIEutkY",8) == 3907461733) strcat(s, "h");
if (crc32("fIVGuqEw",8) == 309031281) strcat(s, "H");
if (crc32("oUFwwsY",7) == 3666997834) strcat(s, "y");
if (crc32("vhxlCLNcaJatvcX",15) == 3126265830) strcat(s, "d");
if (crc32("tlHeBCsajBGp",12) == 1733165072) strcat(s, "c");
if (crc32("arGmcPpAOJGBleM",15) == 2730938168) strcat(s, "r");
if (crc32("hBWsyUrLmIDYuyq",15) == 4113442807) strcat(s, "o");
if (crc32("jertmYpZymoZgfz",15) == 2862780679) strcat(s, "H");
if (crc32("dMDXWPPlW",9) == 339876607) strcat(s, "x");
if (crc32("rcvwFQywfpdx",12) == 1871695682) strcat(s, "q");
if (crc32("PravYjt",7) == 3108116617) strcat(s, "y");
    return s;
}

char *pendanted_adjectives() {
    char *s = calloc(10);
    if (crc32("yfoRfdpIiFz",11) == 2482000006) strcat(s, "p");
if (crc32("NGMZjIisj",9) == 2054662623) strcat(s, "A");
if (crc32("XhaBtKuBfoqtH",13) == 1335766027) strcat(s, "e");
if (crc32("xNODMMtMUl",10) == 1557126356) strcat(s, "n");
if (crc32("fkgFWNEmDljm",12) == 853337712) strcat(s, "N");
if (crc32("GzdpQVttuaNmzMW",15) == 1725375526) strcat(s, "d");
if (crc32("TZyOptcsHQicbh",14) == 1226468645) strcat(s, "Q");
if (crc32("jOxfGu",6) == 3213369751) strcat(s, "a");
if (crc32("rFiqijFWYaNeVId",15) == 1950869355) strcat(s, "n");
if (crc32("znfboIzHRg",10) == 301728763) strcat(s, "t");
if (crc32("LuzkHrIzjDEOBi",14) == 2825328381) strcat(s, "e");
if (crc32("XovwcdtZWM",10) == 324030567) strcat(s, "d");
    return s;
}

char *grandmotherly_adjectives() {
    char *s = calloc(14);
    if (crc32("OJdtbPflPbUiFNS",15) == 737884932) strcat(s, "r");
if (crc32("bDYosSiYkTcG",12) == 336998698) strcat(s, "g");
if (crc32("LMqxUftaGi",10) == 2102534837) strcat(s, "k");
if (crc32("fPQWwz",6) == 2643502542) strcat(s, "r");
if (crc32("wtlKAnotmBPiw",13) == 3188581171) strcat(s, "L");
if (crc32("JrJULNLxTXo",11) == 3121460682) strcat(s, "a");
if (crc32("MLnsPsFXeWgttU",14) == 2537880820) strcat(s, "z");
if (crc32("zCEND",5) == 2516275337) strcat(s, "n");
if (crc32("mZBft",5) == 3480674319) strcat(s, "i");
if (crc32("SgqsvGrsGXT",11) == 1881927369) strcat(s, "d");
if (crc32("InDNtoPAFmq",11) == 3485285511) strcat(s, "m");
if (crc32("bYkqEXW",7) == 1387348988) strcat(s, "I");
if (crc32("AxucAn",6) == 3917268136) strcat(s, "o");
if (crc32("HplLvBn",7) == 1418977618) strcat(s, "t");
if (crc32("YMVtU",5) == 2721878476) strcat(s, "h");
if (crc32("fXYnnbumBbDgo",13) == 367166915) strcat(s, "s");
if (crc32("LsuelBffzbVpPZ",14) == 656870217) strcat(s, "e");
if (crc32("DUSDGELbJmGp",12) == 1683949932) strcat(s, "x");
if (crc32("pWGhdXcLtkqOD",13) == 918456304) strcat(s, "r");
if (crc32("SsUJtGEKno",10) == 3668509604) strcat(s, "r");
if (crc32("uEwciXa",7) == 286894370) strcat(s, "l");
if (crc32("NxoIp",5) == 574490414) strcat(s, "K");
if (crc32("gOwaPXcYgBuKzv",14) == 2150831128) strcat(s, "y");
    return s;
}

char *overassertive_adjectives() {
    char *s = calloc(14);
    if (crc32("GAfcPmxVAmN",11) == 2942388081) strcat(s, "J");
if (crc32("NZOTtTBcjX",10) == 2141982864) strcat(s, "o");
if (crc32("gFXphlBwHHf",11) == 358266105) strcat(s, "v");
if (crc32("vPRZFnxjEivaZs",14) == 2450851525) strcat(s, "e");
if (crc32("DOHVElbxIAlIZy",14) == 3803565204) strcat(s, "m");
if (crc32("jFfnaXPvGQJYmyi",15) == 1874639024) strcat(s, "r");
if (crc32("ftakz",5) == 1270991202) strcat(s, "a");
if (crc32("pdCMndiWPuUB",12) == 105702168) strcat(s, "P");
if (crc32("gJAeTDaAsoS",11) == 1208703473) strcat(s, "s");
if (crc32("pvjZoSyIVKnB",12) == 2876422970) strcat(s, "o");
if (crc32("lXdaJTtkRVkO",12) == 2133691174) strcat(s, "s");
if (crc32("QbEXLzR",7) == 3933058648) strcat(s, "e");
if (crc32("dfCeUBixM",9) == 3876937646) strcat(s, "O");
if (crc32("BbmGkVhnKHH",11) == 2742045007) strcat(s, "r");
if (crc32("MFoqwsgb",8) == 243057033) strcat(s, "n");
if (crc32("BNzpnQIDGPLduG",14) == 611003738) strcat(s, "t");
if (crc32("TgIhPfHUgxZfAsh",15) == 17200542) strcat(s, "i");
if (crc32("qzvOXbtcxyQQ",12) == 3347766276) strcat(s, "U");
if (crc32("ktOoGEbzO",9) == 1698550471) strcat(s, "v");
if (crc32("qRCPLnksTJ",10) == 2394183287) strcat(s, "e");
    return s;
}

char *antipoetic_adjectives() {
    char *s = calloc(11);
    if (crc32("bIHaP",5) == 1878720662) strcat(s, "p");
if (crc32("HJoxvi",6) == 874950779) strcat(s, "a");
if (crc32("GoCvVItsyzivSto",15) == 469740408) strcat(s, "n");
if (crc32("YrsHroZMIPygG",13) == 1199615695) strcat(s, "t");
if (crc32("bVTTLWpyk",9) == 4242886884) strcat(s, "i");
if (crc32("iifkClKgyZiZpGW",15) == 3471536825) strcat(s, "p");
if (crc32("zyclonHoAPyhnR",14) == 4152212315) strcat(s, "h");
if (crc32("VzAuWl",6) == 404472100) strcat(s, "o");
if (crc32("tfvlezonpyy",11) == 3439437119) strcat(s, "e");
if (crc32("XwrtsxsALY",10) == 694466494) strcat(s, "t");
if (crc32("SIDgWZt",7) == 3528162829) strcat(s, "i");
if (crc32("KmZwZ",5) == 1328809460) strcat(s, "n");
if (crc32("tyktnYqRReR",11) == 2120584169) strcat(s, "c");
    return s;
}

char *nonnatty_adjectives() {
    char *s = calloc(9);
    if (crc32("SgEiTgZtLdNt",12) == 1480099629) strcat(s, "n");
if (crc32("mOglpMuYLeUOCM",14) == 1731075032) strcat(s, "Q");
if (crc32("GkXeHH",6) == 1300233986) strcat(s, "o");
if (crc32("FTnPR",5) == 677988775) strcat(s, "n");
if (crc32("vhrDk",5) == 1461891953) strcat(s, "n");
if (crc32("sFpGgwZ",7) == 1485168707) strcat(s, "R");
if (crc32("vxSBPGyBJCowkew",15) == 1735382537) strcat(s, "a");
if (crc32("CqOeeblULV",10) == 644111020) strcat(s, "t");
if (crc32("VIHVpSLPeFew",12) == 3646130969) strcat(s, "t");
if (crc32("iyNDVwNcadvaT",13) == 3382837843) strcat(s, "Y");
if (crc32("andfBDUxbTeQyRS",15) == 3035257885) strcat(s, "y");
    return s;
}

char *superevangelical_adjectives() {
    char *s = calloc(17);
    if (crc32("WmqJsiBbF",9) == 2261732162) strcat(s, "w");
if (crc32("kIJLAPHvQqgU",12) == 2053818984) strcat(s, "s");
if (crc32("IKfrnie",7) == 875477726) strcat(s, "S");
if (crc32("pJPbGyk",7) == 666056502) strcat(s, "u");
if (crc32("IVllrhh",7) == 1766834205) strcat(s, "y");
if (crc32("xIZsaOAEMK",10) == 2238248890) strcat(s, "p");
if (crc32("kWkqvLrdmAKDh",13) == 1899936580) strcat(s, "Q");
if (crc32("SvkJw",5) == 2008078999) strcat(s, "e");
if (crc32("VoufDeAszK",10) == 1549166165) strcat(s, "r");
if (crc32("UeioEwMJOm",10) == 841795608) strcat(s, "X");
if (crc32("brMRWsskDRRM",12) == 881525823) strcat(s, "e");
if (crc32("MfPxOwzduXJImDY",15) == 2994963419) strcat(s, "v");
if (crc32("yDqirpsrLRYrE",13) == 2108818952) strcat(s, "v");
if (crc32("bNWQmQm",7) == 2637806385) strcat(s, "a");
if (crc32("YvcYy",5) == 3567908471) strcat(s, "E");
if (crc32("lYacCyNa",8) == 3487531218) strcat(s, "n");
if (crc32("vowzMAWax",9) == 655221913) strcat(s, "g");
if (crc32("HbSXKR",6) == 2630120669) strcat(s, "e");
if (crc32("AkxVqZzOskLo",12) == 1824276647) strcat(s, "l");
if (crc32("mXieIJGm",8) == 1132022043) strcat(s, "J");
if (crc32("mNqCgu",6) == 1239930812) strcat(s, "i");
if (crc32("dbtDtUPulOlI",12) == 3891198149) strcat(s, "T");
if (crc32("cvPCrz",6) == 1563981397) strcat(s, "c");
if (crc32("BLswus",6) == 3709952798) strcat(s, "a");
if (crc32("MvMXmsL",7) == 4033274195) strcat(s, "l");
    return s;
}

char *nonadjudicated_adjectives() {
    char *s = calloc(15);
    if (crc32("ejDnr",5) == 1517456397) strcat(s, "s");
if (crc32("YKMCmnKpKpZY",12) == 3843619035) strcat(s, "n");
if (crc32("lEVHZWDAe",9) == 427675877) strcat(s, "o");
if (crc32("gcMTprDeUt",10) == 2858019259) strcat(s, "L");
if (crc32("FPiWtBpiWiJr",12) == 641440178) strcat(s, "n");
if (crc32("CXzUyn",6) == 175079208) strcat(s, "a");
if (crc32("dCPdrITbH",9) == 992282705) strcat(s, "a");
if (crc32("hOPnO",5) == 3719739234) strcat(s, "d");
if (crc32("joWlSjQep",9) == 3263542249) strcat(s, "f");
if (crc32("BFyynQ",6) == 2397322415) strcat(s, "j");
if (crc32("ZsGkxAwz",8) == 2407964366) strcat(s, "u");
if (crc32("TlfZdrntHttRx",13) == 2938949164) strcat(s, "V");
if (crc32("CWEORrze",8) == 2131617445) strcat(s, "d");
if (crc32("HMpOexUcSDz",11) == 3254165680) strcat(s, "i");
if (crc32("QGxUcQTps",9) == 51984161) strcat(s, "c");
if (crc32("olkAiJ",6) == 2884332021) strcat(s, "a");
if (crc32("mWAUM",5) == 962504148) strcat(s, "E");
if (crc32("hYzgZvvBnTSER",13) == 2440523123) strcat(s, "t");
if (crc32("lAXuCwMtyZnPEO",14) == 1809583799) strcat(s, "e");
if (crc32("TUdzRsUILhs",11) == 587543168) strcat(s, "r");
if (crc32("IeAmJSzpKne",11) == 2065580767) strcat(s, "d");
    return s;
}

char *punier_adjectives() {
    char *s = calloc(7);
    if (crc32("OWeTUyRwzhXe",12) == 574975085) strcat(s, "v");
if (crc32("QuUrVKTWZBByRL",14) == 64867065) strcat(s, "p");
if (crc32("DPiBikwwotQO",12) == 2200315419) strcat(s, "u");
if (crc32("nRICpFT",7) == 1161140719) strcat(s, "n");
if (crc32("vtQyDq",6) == 4218288579) strcat(s, "i");
if (crc32("ENspRH",6) == 2109303042) strcat(s, "p");
if (crc32("VtEUVQpMzcpG",12) == 2449522960) strcat(s, "e");
if (crc32("qHOxkWSzFrg",11) == 4263245366) strcat(s, "r");
    return s;
}

char *sequestered_adjectives() {
    char *s = calloc(12);
    if (crc32("pzJKxYYDcwlUz",13) == 343741790) strcat(s, "s");
if (crc32("VxdLQaBnNQ",10) == 2305438106) strcat(s, "N");
if (crc32("Ozztp",5) == 1513314357) strcat(s, "e");
if (crc32("RgwbQI",6) == 3322876146) strcat(s, "Q");
if (crc32("nBgvHoKhUMVo",12) == 2050373742) strcat(s, "q");
if (crc32("VHMtaTpbirIfmF",14) == 313762164) strcat(s, "x");
if (crc32("NzPPcjnlPju",11) == 3198482201) strcat(s, "u");
if (crc32("EREdY",5) == 1551139736) strcat(s, "k");
if (crc32("LQhBCyNzKh",10) == 3724034659) strcat(s, "e");
if (crc32("JbRlRioUQjnnGay",15) == 1038862930) strcat(s, "D");
if (crc32("TObKgJvTAdWMaS",14) == 2305404324) strcat(s, "s");
if (crc32("CybnYynLciT",11) == 509965615) strcat(s, "Q");
if (crc32("dmGAgZAnvOCdQw",14) == 414664526) strcat(s, "t");
if (crc32("lQIXLPWjrxVjic",14) == 237211227) strcat(s, "e");
if (crc32("bwYaRZBNIeIbiC",14) == 2644416775) strcat(s, "l");
if (crc32("QfTjQDSVRHZkm",13) == 3672322805) strcat(s, "r");
if (crc32("uolbnxh",7) == 4055221255) strcat(s, "e");
if (crc32("YFBYL",5) == 710143822) strcat(s, "d");
    return s;
}

char *chimneyless_adjectives() {
    char *s = calloc(12);
    if (crc32("SqUlBAHLFmjoCk",14) == 4020686730) strcat(s, "L");
if (crc32("nscfRgKNTWE",11) == 1788567518) strcat(s, "c");
if (crc32("mBVzmvjj",8) == 1067986304) strcat(s, "h");
if (crc32("rbwBzKZlQb",10) == 1985584692) strcat(s, "i");
if (crc32("aPzNgZgDYoDVL",13) == 3908469721) strcat(s, "m");
if (crc32("iTHOdWYthv",10) == 2385689247) strcat(s, "O");
if (crc32("JnYTvoEStEFWXq",14) == 1444215229) strcat(s, "n");
if (crc32("ijhpFtUweTCsGmR",15) == 2590727391) strcat(s, "e");
if (crc32("plHzbGmReQuvaTQ",15) == 2050047422) strcat(s, "y");
if (crc32("INUaaQkLtilM",12) == 1118402329) strcat(s, "l");
if (crc32("wRziJ",5) == 2542049549) strcat(s, "e");
if (crc32("dKlFMOE",7) == 3686026621) strcat(s, "t");
if (crc32("TfxqNxYLjN",10) == 1957035252) strcat(s, "s");
if (crc32("PxEAbdZoMDBKEa",14) == 2460974107) strcat(s, "n");
if (crc32("vKXhUTRwD",9) == 800133765) strcat(s, "s");
    return s;
}

char *nonparticipating_adjectives() {
    char *s = calloc(17);
    if (crc32("usrStNzX",8) == 1265781825) strcat(s, "n");
if (crc32("qoSMTTz",7) == 1360338792) strcat(s, "E");
if (crc32("xOyJbNLoxf",10) == 668652850) strcat(s, "o");
if (crc32("hWHApVtPkhtitS",14) == 381332900) strcat(s, "n");
if (crc32("IpfRhve",7) == 852653806) strcat(s, "p");
if (crc32("OvjVc",5) == 802112259) strcat(s, "a");
if (crc32("fmDRrwxP",8) == 2838255320) strcat(s, "Y");
if (crc32("cNVNGmbtgy",10) == 4198152481) strcat(s, "r");
if (crc32("sPsKVXtFILSw",12) == 354344378) strcat(s, "t");
if (crc32("lcIQjfD",7) == 2115948986) strcat(s, "i");
if (crc32("SCZwf",5) == 2511615471) strcat(s, "c");
if (crc32("QNzerBMZPgOPTdR",15) == 1161340543) strcat(s, "i");
if (crc32("wXTWDIUGtwA",11) == 981380815) strcat(s, "p");
if (crc32("rYIzY",5) == 1259981561) strcat(s, "a");
if (crc32("XkrdjXCTrGOz",12) == 1159585416) strcat(s, "F");
if (crc32("Rzmpb",5) == 1291782847) strcat(s, "t");
if (crc32("uwiLSDpxjIglxM",14) == 1206404663) strcat(s, "i");
if (crc32("Rcuez",5) == 833237858) strcat(s, "J");
if (crc32("zgxWBqmfDHpnVL",14) == 1896404257) strcat(s, "n");
if (crc32("ycqTomcJYZt",11) == 4019682947) strcat(s, "l");
if (crc32("CLPfnNacBMhUm",13) == 1816984940) strcat(s, "g");
    return s;
}

char *sphenographic_adjectives() {
    char *s = calloc(14);
    if (crc32("hEyWPZNfwxDU",12) == 2039276330) strcat(s, "h");
if (crc32("SkzbjsLrxexqcS",14) == 1588137142) strcat(s, "s");
if (crc32("XlfzgerYqcfYNC",14) == 1449208222) strcat(s, "P");
if (crc32("pXGmrnopAdVs",12) == 817855285) strcat(s, "p");
if (crc32("TiQbWWMP",8) == 2681584526) strcat(s, "h");
if (crc32("VfniNjPPjjjTnI",14) == 3303972954) strcat(s, "e");
if (crc32("kWkURXheDiz",11) == 35388179) strcat(s, "n");
if (crc32("UiQEqb",6) == 3923460852) strcat(s, "o");
if (crc32("PLfmsyGMeivs",12) == 4172261696) strcat(s, "g");
if (crc32("oLKZbfCTAk",10) == 2328507469) strcat(s, "r");
if (crc32("DGalBjvHBTqJr",13) == 909414912) strcat(s, "a");
if (crc32("qiyrEZEc",8) == 547168316) strcat(s, "p");
if (crc32("FtAHzosP",8) == 369139038) strcat(s, "h");
if (crc32("BMTmHrLTADSvZYa",15) == 1383068134) strcat(s, "x");
if (crc32("qoFdifRXmhEKR",13) == 427495094) strcat(s, "i");
if (crc32("KHbuLpJLsohSOpH",15) == 2753849471) strcat(s, "P");
if (crc32("CeIBkMpzXZZBroh",15) == 1057061835) strcat(s, "c");
    return s;
}

char *fracturable_adjectives() {
    char *s = calloc(12);
    if (crc32("yIBgIzjVhkXLUq",14) == 3034104437) strcat(s, "G");
if (crc32("oFLRq",5) == 3039828664) strcat(s, "f");
if (crc32("nbOnBUM",7) == 48999573) strcat(s, "J");
if (crc32("WBZYcmCAXwJz",12) == 1892602141) strcat(s, "r");
if (crc32("DqDpv",5) == 1494763150) strcat(s, "a");
if (crc32("VYZhpmR",7) == 2065571624) strcat(s, "c");
if (crc32("MJUWpyvgb",9) == 662058667) strcat(s, "t");
if (crc32("GxiECZbXQ",9) == 3913443518) strcat(s, "g");
if (crc32("nEOtAc",6) == 3195657969) strcat(s, "u");
if (crc32("UGGbLJzMx",9) == 4064659889) strcat(s, "S");
if (crc32("GVdFsLMmz",9) == 507178855) strcat(s, "r");
if (crc32("tLWReP",6) == 2017529608) strcat(s, "G");
if (crc32("TGHkCnpZLALz",12) == 2702983961) strcat(s, "a");
if (crc32("lTBwACByxvEB",12) == 1573565410) strcat(s, "b");
if (crc32("DKDTm",5) == 3726401396) strcat(s, "g");
if (crc32("YOIpFsyM",8) == 1389733637) strcat(s, "l");
if (crc32("iUzBkMy",7) == 2533242066) strcat(s, "t");
if (crc32("NSxTTJ",6) == 1992507749) strcat(s, "e");
    return s;
}

char *astute_adjectives() {
    char *s = calloc(7);
    if (crc32("AZkmxc",6) == 2888636264) strcat(s, "F");
if (crc32("tmvoiJNTYM",10) == 3893879636) strcat(s, "a");
if (crc32("PEcootBJGgLbD",13) == 2192257401) strcat(s, "s");
if (crc32("JlUBGWd",7) == 155131890) strcat(s, "t");
if (crc32("jTgQiTqIOn",10) == 1051410258) strcat(s, "L");
if (crc32("JpQzCbJTvRV",11) == 3449449263) strcat(s, "u");
if (crc32("WAquHfQLzdlm",12) == 2123829032) strcat(s, "t");
if (crc32("zygMoqRxPo",10) == 3226672670) strcat(s, "e");
    return s;
}

char *upcountry_adjectives() {
    char *s = calloc(10);
    if (crc32("KloaDPEW",8) == 16276220) strcat(s, "u");
if (crc32("VjglRFCQWQNTrk",14) == 3166002988) strcat(s, "o");
if (crc32("ntuyzbtroS",10) == 4140773945) strcat(s, "p");
if (crc32("GxpqVk",6) == 266236538) strcat(s, "c");
if (crc32("beqevxSFnAY",11) == 1002144017) strcat(s, "c");
if (crc32("hfSudlKZ",8) == 1490580586) strcat(s, "o");
if (crc32("oGrLPzNE",8) == 3431664315) strcat(s, "u");
if (crc32("DVUovOEc",8) == 2750810164) strcat(s, "n");
if (crc32("ZOFJfWqPMfW",11) == 3276430689) strcat(s, "t");
if (crc32("bxCKLXkzEq",10) == 2538211594) strcat(s, "Q");
if (crc32("jAQtlwG",7) == 1586220522) strcat(s, "r");
if (crc32("qOBFJ",5) == 2842390792) strcat(s, "R");
if (crc32("jmWMsZeBVUcypvK",15) == 3207850277) strcat(s, "y");
    return s;
}

char *pseudogenerical_adjectives() {
    char *s = calloc(16);
    if (crc32("DJglSBiphmKBPI",14) == 2252740240) strcat(s, "p");
if (crc32("oOmlKXdH",8) == 1630415123) strcat(s, "s");
if (crc32("AUbYzmUaXGl",11) == 218674053) strcat(s, "e");
if (crc32("XLtvKdzEduZx",12) == 1667681100) strcat(s, "p");
if (crc32("VxMGljNJhQmPg",13) == 1476222319) strcat(s, "u");
if (crc32("jCEaWKrK",8) == 3962867296) strcat(s, "y");
if (crc32("BjlxJPhC",8) == 1294731793) strcat(s, "d");
if (crc32("mxUKD",5) == 20984718) strcat(s, "o");
if (crc32("UyhUySO",7) == 3119023922) strcat(s, "g");
if (crc32("QmGbjRDMeaJ",11) == 2164472469) strcat(s, "I");
if (crc32("iRvqSEoQTlzLR",13) == 4117532210) strcat(s, "e");
if (crc32("YbvivE",6) == 254851121) strcat(s, "n");
if (crc32("IVXaRNIrMWr",11) == 2512502158) strcat(s, "R");
if (crc32("yUmHRy",6) == 2072885497) strcat(s, "e");
if (crc32("EQTrpkw",7) == 1912663650) strcat(s, "I");
if (crc32("GqZtoq",6) == 1426213760) strcat(s, "r");
if (crc32("MPwPoV",6) == 2929298960) strcat(s, "M");
if (crc32("zsOYoCiXWn",10) == 280961353) strcat(s, "i");
if (crc32("aVLLW",5) == 977266243) strcat(s, "S");
if (crc32("pLCbhVWkiRtkp",13) == 2586856256) strcat(s, "c");
if (crc32("ZIIeWUyAxJDA",12) == 1430245812) strcat(s, "a");
if (crc32("QeXduxuh",8) == 3194821115) strcat(s, "l");
    return s;
}

char *substructional_adjectives() {
    char *s = calloc(15);
    if (crc32("ITZcnUUlFseBA",13) == 249421589) strcat(s, "s");
if (crc32("eowgk",5) == 1440207632) strcat(s, "u");
if (crc32("nnSldEBwbPvXKpG",15) == 3144404037) strcat(s, "b");
if (crc32("kkBwjmGXfpJHgex",15) == 964972953) strcat(s, "r");
if (crc32("aSaolqh",7) == 3374368839) strcat(s, "s");
if (crc32("OyUxxSoAJSAqhX",14) == 186425939) strcat(s, "n");
if (crc32("EgdspYFoJxGPdQ",14) == 2179127802) strcat(s, "t");
if (crc32("QQgaTBgWkg",10) == 2563927467) strcat(s, "m");
if (crc32("zekDt",5) == 4266070951) strcat(s, "r");
if (crc32("sGXVmPuPJfMtK",13) == 2919461593) strcat(s, "u");
if (crc32("QUrGRlIxgX",10) == 1110659376) strcat(s, "u");
if (crc32("gROjWOcJNxDAHAG",15) == 1901807425) strcat(s, "c");
if (crc32("UqVFdlxlFy",10) == 1088816322) strcat(s, "t");
if (crc32("VwFJhdZkLtHCwXm",15) == 3034066276) strcat(s, "k");
if (crc32("avssRZNcJHQmBsw",15) == 3668170607) strcat(s, "i");
if (crc32("FaNotJzD",8) == 787815175) strcat(s, "E");
if (crc32("JvBgHcjbqFbmtI",14) == 3400275738) strcat(s, "o");
if (crc32("uINeZVzIlyFuoBc",15) == 959388919) strcat(s, "n");
if (crc32("eZOKwZxNy",9) == 289702294) strcat(s, "a");
if (crc32("YDdFWDry",8) == 3460318880) strcat(s, "l");
    return s;
}

char *palpebral_adjectives() {
    char *s = calloc(10);
    if (crc32("PugEZWuBbnIO",12) == 538174736) strcat(s, "p");
if (crc32("gdRTelhq",8) == 4210305260) strcat(s, "X");
if (crc32("oAoKEgBIBwDjRU",14) == 4112793310) strcat(s, "a");
if (crc32("OlCCJnzzjODUP",13) == 625705076) strcat(s, "l");
if (crc32("ujMoDngSNL",10) == 2660333461) strcat(s, "p");
if (crc32("eSbVyS",6) == 1674126634) strcat(s, "e");
if (crc32("ifMvPNn",7) == 462707155) strcat(s, "b");
if (crc32("TiRxuoG",7) == 2572487913) strcat(s, "v");
if (crc32("OAZuIcaFTmP",11) == 3385897591) strcat(s, "r");
if (crc32("yxwIelyMHaC",11) == 2144884645) strcat(s, "a");
if (crc32("QOJaMYcgSlHNYym",15) == 4101279633) strcat(s, "l");
    return s;
}

char *vigintillionth_adjectives() {
    char *s = calloc(15);
    if (crc32("tsdYb",5) == 887176181) strcat(s, "v");
if (crc32("myiQqy",6) == 3318170296) strcat(s, "i");
if (crc32("mFjtuBHO",8) == 2977794007) strcat(s, "O");
if (crc32("PkMazyjp",8) == 1049924297) strcat(s, "g");
if (crc32("tPOhNmxZsTw",11) == 775707663) strcat(s, "G");
if (crc32("dTVDo",5) == 3486915247) strcat(s, "i");
if (crc32("gESBRW",6) == 355836797) strcat(s, "J");
if (crc32("KHzigLIfJRmprGF",15) == 3252818591) strcat(s, "n");
if (crc32("GofHApw",7) == 3507726276) strcat(s, "J");
if (crc32("mhXNOEJVVqwDsYl",15) == 526359499) strcat(s, "t");
if (crc32("YLHcOTAGECGnxjD",15) == 4183581898) strcat(s, "i");
if (crc32("tlFPrkWoPNI",11) == 3959259698) strcat(s, "l");
if (crc32("ygInDwWMzma",11) == 2620232652) strcat(s, "l");
if (crc32("oSUexeZDzr",10) == 1118497023) strcat(s, "i");
if (crc32("hamKhDbmvAa",11) == 2373257998) strcat(s, "K");
if (crc32("BVrUDsaXPbXi",12) == 2150754787) strcat(s, "o");
if (crc32("WRkrzCJhDrADyN",14) == 852239905) strcat(s, "F");
if (crc32("MAvQqbrQiGusR",13) == 2530055904) strcat(s, "n");
if (crc32("HUpVgtZkPpfzjiM",15) == 590420647) strcat(s, "Z");
if (crc32("UzijQkFKqQ",10) == 4170192145) strcat(s, "t");
if (crc32("mEhUMkhberwupyc",15) == 3955203930) strcat(s, "h");
    return s;
}

char *paleoecologic_adjectives() {
    char *s = calloc(14);
    if (crc32("MEUaWcGzZAho",12) == 2271274621) strcat(s, "p");
if (crc32("vJxeRZIK",8) == 2298138859) strcat(s, "I");
if (crc32("pXnJUmaadOsueMd",15) == 3007695303) strcat(s, "a");
if (crc32("HJFKPDiNQWtGwi",14) == 1017014891) strcat(s, "W");
if (crc32("CDYRaw",6) == 4274463591) strcat(s, "l");
if (crc32("ZEfyPc",6) == 2812922813) strcat(s, "e");
if (crc32("bcdsyLHEmfSy",12) == 579200099) strcat(s, "T");
if (crc32("AqAiB",5) == 763844280) strcat(s, "o");
if (crc32("AcIfrLMN",8) == 1751896903) strcat(s, "e");
if (crc32("mCKQflDla",9) == 3519676223) strcat(s, "l");
if (crc32("FrFuAyPNYiC",11) == 1542505830) strcat(s, "c");
if (crc32("wQgJXtwFBW",10) == 4048776229) strcat(s, "o");
if (crc32("QHlhwMbAtJMje",13) == 3467161985) strcat(s, "t");
if (crc32("XlQbiylRj",9) == 2389406104) strcat(s, "l");
if (crc32("svtosYMF",8) == 3829477880) strcat(s, "Y");
if (crc32("YaVqmfiggKWZLO",14) == 1513100484) strcat(s, "o");
if (crc32("bBJiHyvAYwdP",12) == 3828603795) strcat(s, "I");
if (crc32("XmnBdw",6) == 1470761831) strcat(s, "g");
if (crc32("FcBuVvub",8) == 2201112113) strcat(s, "R");
if (crc32("OBFzNbYLloCzioT",15) == 2894955206) strcat(s, "i");
if (crc32("lTGjMOP",7) == 2632268957) strcat(s, "c");
    return s;
}

char *unipersonal_adjectives() {
    char *s = calloc(12);
    if (crc32("bcxPycfBrYSsr",13) == 2323970996) strcat(s, "u");
if (crc32("RfIIbeE",7) == 1912104482) strcat(s, "S");
if (crc32("AUgzjXuLFfQcEwD",15) == 3559972136) strcat(s, "n");
if (crc32("RUVAJAomox",10) == 1432311619) strcat(s, "e");
if (crc32("gbESWScKZ",9) == 1371903816) strcat(s, "i");
if (crc32("brahWdACI",9) == 687116429) strcat(s, "p");
if (crc32("KccmBpLDVVi",11) == 908165574) strcat(s, "p");
if (crc32("iwUCiaJUPQOSixc",15) == 4024726726) strcat(s, "e");
if (crc32("ImOzSPGaCwIzX",13) == 11563425) strcat(s, "J");
if (crc32("sTwXWSIMTyfcaMd",15) == 1122060453) strcat(s, "r");
if (crc32("ofzNRGd",7) == 1816747528) strcat(s, "s");
if (crc32("hkAgGJhE",8) == 3503764174) strcat(s, "o");
if (crc32("jSeZwpPD",8) == 3646932615) strcat(s, "J");
if (crc32("pbvPXSTe",8) == 3011479553) strcat(s, "n");
if (crc32("OusVDhYLE",9) == 1848895388) strcat(s, "a");
if (crc32("pvrBS",5) == 385644901) strcat(s, "l");
    return s;
}

char *ceorlish_adjectives() {
    char *s = calloc(9);
    if (crc32("WlpVP",5) == 2355314055) strcat(s, "g");
if (crc32("ptlxfiOGJpS",11) == 340314007) strcat(s, "c");
if (crc32("yyJHqWbThoEPkfY",15) == 2192019782) strcat(s, "M");
if (crc32("EouMmJH",7) == 405791022) strcat(s, "e");
if (crc32("zNlyILn",7) == 593409092) strcat(s, "o");
if (crc32("zwCIOaGjT",9) == 2807898967) strcat(s, "r");
if (crc32("xUHMlk",6) == 420454465) strcat(s, "l");
if (crc32("uvuCfqBEOsS",11) == 701766925) strcat(s, "l");
if (crc32("VysmpmKPDI",10) == 302148645) strcat(s, "i");
if (crc32("MsIXxb",6) == 2842355185) strcat(s, "d");
if (crc32("GwRyVT",6) == 1387158625) strcat(s, "s");
if (crc32("gzuAo",5) == 2414326926) strcat(s, "h");
    return s;
}

char *slack_adjectives() {
    char *s = calloc(6);
    if (crc32("CpiPiSfWZlsR",12) == 1890053913) strcat(s, "s");
if (crc32("iShMVBbAaHOb",12) == 2342769950) strcat(s, "l");
if (crc32("MWSKYTSsLWlzW",13) == 595282143) strcat(s, "p");
if (crc32("ZVSPXvF",7) == 4040523017) strcat(s, "a");
if (crc32("JdxmnQvJfir",11) == 1610069658) strcat(s, "c");
if (crc32("aqmWbwJgMFkKU",13) == 677169279) strcat(s, "I");
if (crc32("pqqKmLmGgGkJf",13) == 3215961251) strcat(s, "k");
    return s;
}

char *unhallucinated_adjectives() {
    char *s = calloc(15);
    if (crc32("IDZkCneh",8) == 810048889) strcat(s, "u");
if (crc32("viuzhfTueaGwxUe",15) == 3813929465) strcat(s, "n");
if (crc32("bGYaIr",6) == 2123206344) strcat(s, "h");
if (crc32("NCbRr",5) == 2306772261) strcat(s, "A");
if (crc32("mkCWlJwtopMqM",13) == 2250895509) strcat(s, "a");
if (crc32("GOGqQs",6) == 1080064671) strcat(s, "l");
if (crc32("HrRZeIWOj",9) == 1488244160) strcat(s, "H");
if (crc32("bWkrSDebBZXtGFE",15) == 3945703765) strcat(s, "l");
if (crc32("mRqNjmXVhpHbcY",14) == 1096150553) strcat(s, "u");
if (crc32("atOnAlMIcrJwHt",14) == 2516063602) strcat(s, "c");
if (crc32("jwkmveW",7) == 2894303) strcat(s, "z");
if (crc32("phDkZIUkRv",10) == 2807184253) strcat(s, "i");
if (crc32("fqvfZinpYye",11) == 3336800682) strcat(s, "E");
if (crc32("xcNTzKUt",8) == 2967551950) strcat(s, "n");
if (crc32("UEwuQJnjquYst",13) == 476319280) strcat(s, "B");
if (crc32("MHTkLYdqHjv",11) == 384816605) strcat(s, "a");
if (crc32("wvXePKmY",8) == 2284208495) strcat(s, "t");
if (crc32("eYBoxiqwgFLEpQV",15) == 519313611) strcat(s, "x");
if (crc32("gyjzw",5) == 2784397379) strcat(s, "e");
if (crc32("QiAxlOzTGPjJ",12) == 4242073533) strcat(s, "d");
    return s;
}

char *noncataclysmic_adjectives() {
    char *s = calloc(15);
    if (crc32("RNKkz",5) == 1078146691) strcat(s, "I");
if (crc32("QyUBSR",6) == 434921534) strcat(s, "n");
if (crc32("KCIVU",5) == 3893067888) strcat(s, "o");
if (crc32("GQBOxJewxMXdZ",13) == 3407522071) strcat(s, "S");
if (crc32("rWQxnwmgndOgKK",14) == 827319218) strcat(s, "n");
if (crc32("Tppxn",5) == 2039736699) strcat(s, "c");
if (crc32("XiAaTGYHUWyfdbq",15) == 2790492975) strcat(s, "w");
if (crc32("ctBYQj",6) == 1866988418) strcat(s, "a");
if (crc32("wLtBVlGcGqat",12) == 1397677460) strcat(s, "c");
if (crc32("etQwztss",8) == 4081772740) strcat(s, "t");
if (crc32("BaBVPI",6) == 3147248365) strcat(s, "a");
if (crc32("pFIRtPcM",8) == 213742613) strcat(s, "z");
if (crc32("wVXVFxf",7) == 3209808036) strcat(s, "c");
if (crc32("oRucCZkw",8) == 2250759137) strcat(s, "x");
if (crc32("ifQXwMMZl",9) == 1001183477) strcat(s, "l");
if (crc32("vjWZyT",6) == 1740287454) strcat(s, "j");
if (crc32("QgmAn",5) == 1724363956) strcat(s, "y");
if (crc32("nwbvtl",6) == 3363043527) strcat(s, "O");
if (crc32("eriWDiDBaWNUPAr",15) == 3552843868) strcat(s, "s");
if (crc32("FqncVqBwsXowu",13) == 2504240492) strcat(s, "y");
if (crc32("rWvFluFLVp",10) == 2147389709) strcat(s, "m");
if (crc32("jedTbh",6) == 2183951317) strcat(s, "i");
if (crc32("SEBACxtwduk",11) == 1292193289) strcat(s, "K");
if (crc32("JInpNS",6) == 1500657716) strcat(s, "c");
    return s;
}

char *ennuya_adjectives() {
    char *s = calloc(7);
    if (crc32("WZAbsFjPxASFt",13) == 2521691962) strcat(s, "a");
if (crc32("Gzcgt",5) == 523636352) strcat(s, "e");
if (crc32("aEeqAcuuf",9) == 1027553943) strcat(s, "n");
if (crc32("drUNjEjqRlVBuB",14) == 2903936445) strcat(s, "n");
if (crc32("tOiEAWmARyeYl",13) == 3912152103) strcat(s, "u");
if (crc32("FIJPhd",6) == 1120837869) strcat(s, "y");
if (crc32("JKozB",5) == 3126237721) strcat(s, "z");
if (crc32("ZuefIp",6) == 486133854) strcat(s, "a");
    return s;
}

char *amortisable_adjectives() {
    char *s = calloc(12);
    if (crc32("ZWQNH",5) == 40047111) strcat(s, "D");
if (crc32("ItueJeGHQpzLT",13) == 476810490) strcat(s, "a");
if (crc32("DISTmwvKOHyYf",13) == 2134672104) strcat(s, "m");
if (crc32("whAgUHWwwLuARk",14) == 1626034514) strcat(s, "o");
if (crc32("HCUipD",6) == 2831284347) strcat(s, "r");
if (crc32("gCZsGVEEeP",10) == 1373000408) strcat(s, "B");
if (crc32("lOwyTLhkAUZk",12) == 3502315255) strcat(s, "t");
if (crc32("vGongfYtOEslaf",14) == 4205825583) strcat(s, "j");
if (crc32("KxFOfQ",6) == 4153249885) strcat(s, "i");
if (crc32("jZoCFVPNEbLwIb",14) == 3289027030) strcat(s, "s");
if (crc32("oXotWojI",8) == 207679537) strcat(s, "a");
if (crc32("ImPJMF",6) == 4290922421) strcat(s, "Z");
if (crc32("HWGlwGwAlLvrP",13) == 1711156858) strcat(s, "b");
if (crc32("DyUwtCwm",8) == 3385452646) strcat(s, "K");
if (crc32("jpXCaCBzKEo",11) == 4015852866) strcat(s, "l");
if (crc32("ypmXkxGQU",9) == 2449001227) strcat(s, "e");
    return s;
}

char *underlaid_adjectives() {
    char *s = calloc(10);
    if (crc32("IPCPHimWnXeiEBs",15) == 1399262097) strcat(s, "z");
if (crc32("YjCyZDDBzCYuWy",14) == 1881534591) strcat(s, "u");
if (crc32("ncmQCnPZErfPsA",14) == 2987994234) strcat(s, "n");
if (crc32("hPyswIbPcVJWpNc",15) == 1266656720) strcat(s, "d");
if (crc32("mgIAJUg",7) == 667961037) strcat(s, "C");
if (crc32("VLgpNnxDx",9) == 1884530853) strcat(s, "e");
if (crc32("JzEYBMyTlkP",11) == 494555325) strcat(s, "I");
if (crc32("wSCRUaGN",8) == 2165291889) strcat(s, "r");
if (crc32("eCIMJOxF",8) == 4157127921) strcat(s, "l");
if (crc32("kHUZiHHuIh",10) == 479524832) strcat(s, "a");
if (crc32("MhlqkSPGfzg",11) == 434199842) strcat(s, "i");
if (crc32("lxeLtBnmrYNpM",13) == 3710608538) strcat(s, "d");
    return s;
}

char *lated_adjectives() {
    char *s = calloc(6);
    if (crc32("tLmxkOrLVIhFtN",14) == 1831282177) strcat(s, "l");
if (crc32("bWioblhekAJ",11) == 1333266245) strcat(s, "G");
if (crc32("lsdRBnRtRl",10) == 2608026124) strcat(s, "a");
if (crc32("fKNaAvLKOkuS",12) == 2555467426) strcat(s, "t");
if (crc32("msEHKZl",7) == 1891182225) strcat(s, "O");
if (crc32("MClcfih",7) == 4280418226) strcat(s, "e");
if (crc32("paPytJkwS",9) == 729216776) strcat(s, "d");
    return s;
}

char *maritime_adjectives() {
    char *s = calloc(9);
    if (crc32("kMmYiXliXRpFBMV",15) == 65957865) strcat(s, "m");
if (crc32("buRjarN",7) == 827411350) strcat(s, "f");
if (crc32("MlsFBIur",8) == 1673283352) strcat(s, "a");
if (crc32("gJnUKpwrSezTgt",14) == 3697432950) strcat(s, "F");
if (crc32("UsVhiI",6) == 1080967620) strcat(s, "r");
if (crc32("lAgNOkWaqfuz",12) == 3249207771) strcat(s, "d");
if (crc32("oCkBSA",6) == 1481074824) strcat(s, "i");
if (crc32("cSvIiUHmsQWkRz",14) == 1423669552) strcat(s, "t");
if (crc32("VtFOT",5) == 3033843351) strcat(s, "b");
if (crc32("zClhcrzwGQPGj",13) == 1660515169) strcat(s, "i");
if (crc32("riZFtOmRQIQA",12) == 1900209012) strcat(s, "F");
if (crc32("HKdoglZndTbXDz",14) == 248989802) strcat(s, "m");
if (crc32("SGKLWpOZlcxPX",13) == 3685602866) strcat(s, "e");
    return s;
}

char *nonpyogenic_adjectives() {
    char *s = calloc(12);
    if (crc32("sKpkMUc",7) == 3864303510) strcat(s, "O");
if (crc32("fVgfidTNjoIWUAi",15) == 1579885509) strcat(s, "n");
if (crc32("BUiYVihUVrodtOw",15) == 13603202) strcat(s, "W");
if (crc32("geKYeynQXjdmDm",14) == 578446777) strcat(s, "o");
if (crc32("ZTVGjKnduR",10) == 3047277816) strcat(s, "n");
if (crc32("cWIXqvxLdpAX",12) == 2598829368) strcat(s, "f");
if (crc32("ayKcjAfm",8) == 2667134162) strcat(s, "p");
if (crc32("beAEC",5) == 3848818496) strcat(s, "f");
if (crc32("GZTfXUoHDAHmC",13) == 2285177637) strcat(s, "y");
if (crc32("ksAVqT",6) == 2084074533) strcat(s, "o");
if (crc32("yegTD",5) == 3706106606) strcat(s, "g");
if (crc32("jvhlvX",6) == 3451220718) strcat(s, "e");
if (crc32("MlPaES",6) == 1510650988) strcat(s, "s");
if (crc32("DYCnQXlppLUBL",13) == 143313716) strcat(s, "n");
if (crc32("zbVWePHLt",9) == 3819963114) strcat(s, "C");
if (crc32("TKGryzff",8) == 3140124785) strcat(s, "i");
if (crc32("bhMCvZD",7) == 767115291) strcat(s, "c");
    return s;
}

char *breakfastless_adjectives() {
    char *s = calloc(14);
    if (crc32("DHnEthscRtM",11) == 3960082231) strcat(s, "R");
if (crc32("kfvKVvGjXlRIdo",14) == 3350681066) strcat(s, "b");
if (crc32("LfkUW",5) == 1807879936) strcat(s, "E");
if (crc32("XHPve",5) == 3101714130) strcat(s, "r");
if (crc32("gSuYFTsPec",10) == 3244790924) strcat(s, "K");
if (crc32("bOUpQmnyCbhhn",13) == 3396949119) strcat(s, "e");
if (crc32("SqfBDS",6) == 1754007021) strcat(s, "A");
if (crc32("FOBxgt",6) == 2756404817) strcat(s, "a");
if (crc32("DpLrJus",7) == 1777558128) strcat(s, "a");
if (crc32("cYFYEOQOkfXfn",13) == 1926902759) strcat(s, "k");
if (crc32("FpTFb",5) == 344233203) strcat(s, "f");
if (crc32("qCEtJLXfG",9) == 1517474632) strcat(s, "a");
if (crc32("biTtLHws",8) == 1958119741) strcat(s, "s");
if (crc32("sthSaFDbSF",10) == 583637221) strcat(s, "u");
if (crc32("rSUOfYQnT",9) == 912728311) strcat(s, "t");
if (crc32("dQiJP",5) == 1841085742) strcat(s, "Y");
if (crc32("KeflJjjEW",9) == 3456956219) strcat(s, "l");
if (crc32("gpABmaZS",8) == 2268876633) strcat(s, "e");
if (crc32("JrJNKiBSV",9) == 2397951533) strcat(s, "P");
if (crc32("cJmetkXphjjpqYH",15) == 64012337) strcat(s, "s");
if (crc32("nMSICUbheOjHcC",14) == 3840824019) strcat(s, "s");
    return s;
}

char *homocentric_adjectives() {
    char *s = calloc(12);
    if (crc32("qcTZntXPyav",11) == 4206283020) strcat(s, "C");
if (crc32("hnnYcggykLXyl",13) == 3889097639) strcat(s, "h");
if (crc32("ageCOtAdU",9) == 1917527831) strcat(s, "o");
if (crc32("bdsaiZBhe",9) == 3738958400) strcat(s, "w");
if (crc32("EcHSsdKqssFGB",13) == 1095380212) strcat(s, "m");
if (crc32("NZethBrFSKCBu",13) == 4122605847) strcat(s, "J");
if (crc32("JCmUg",5) == 164971967) strcat(s, "o");
if (crc32("ICfLDeek",8) == 3350368630) strcat(s, "q");
if (crc32("fDrFIdqXaTpo",12) == 506770089) strcat(s, "c");
if (crc32("pcvnarVXgy",10) == 244157438) strcat(s, "e");
if (crc32("wFSpBxZBYYED",12) == 3991477383) strcat(s, "b");
if (crc32("YkQobnXVT",9) == 322614472) strcat(s, "n");
if (crc32("kYbboZy",7) == 1736930720) strcat(s, "t");
if (crc32("eyoxVpCbKmrzPH",14) == 1539332876) strcat(s, "r");
if (crc32("ZPaZjkm",7) == 1010871277) strcat(s, "S");
if (crc32("MxJSJSyZyTkdXsU",15) == 3287299939) strcat(s, "i");
if (crc32("RGfUgBpJn",9) == 2501958119) strcat(s, "g");
if (crc32("gqYLwPFiLPhr",12) == 52831923) strcat(s, "c");
    return s;
}

char *chopping_adjectives() {
    char *s = calloc(9);
    if (crc32("dWQHnx",6) == 1145619763) strcat(s, "f");
if (crc32("nbcroEfA",8) == 2523982638) strcat(s, "c");
if (crc32("IbLCykJQ",8) == 1818214103) strcat(s, "h");
if (crc32("WpbSGj",6) == 3021047750) strcat(s, "o");
if (crc32("QxeDRSwmsmuUv",13) == 3182451971) strcat(s, "T");
if (crc32("sftqM",5) == 195850443) strcat(s, "p");
if (crc32("kJEsvD",6) == 1973987262) strcat(s, "s");
if (crc32("PwCWQWKYhWO",11) == 3875719426) strcat(s, "p");
if (crc32("ofLyeJOpXWWDC",13) == 1825875691) strcat(s, "i");
if (crc32("akPAdusp",8) == 88302638) strcat(s, "i");
if (crc32("niSZEPe",7) == 1127181089) strcat(s, "n");
if (crc32("aopiQHBDVWTHoAQ",15) == 3834003496) strcat(s, "g");
    return s;
}

char *unvested_adjectives() {
    char *s = calloc(9);
    if (crc32("xbsahDwdt",9) == 1206560536) strcat(s, "i");
if (crc32("pfhutJM",7) == 185193758) strcat(s, "u");
if (crc32("KJgHIAuC",8) == 723396844) strcat(s, "M");
if (crc32("wEPyDltqKlEsDI",14) == 1352239311) strcat(s, "n");
if (crc32("DSgJwbiXbHAGU",13) == 3738071452) strcat(s, "M");
if (crc32("aWykG",5) == 20687739) strcat(s, "v");
if (crc32("zSElyb",6) == 3566101151) strcat(s, "e");
if (crc32("acutbMF",7) == 2056877836) strcat(s, "s");
if (crc32("rZTZI",5) == 2793393108) strcat(s, "A");
if (crc32("BIPmEkrxLQUZkO",14) == 4217576736) strcat(s, "t");
if (crc32("vJBAj",5) == 1960334105) strcat(s, "L");
if (crc32("QPfVNU",6) == 1300531223) strcat(s, "e");
if (crc32("vrzKLQLXk",9) == 2574420849) strcat(s, "d");
    return s;
}

char *reanalyzable_adjectives() {
    char *s = calloc(13);
    if (crc32("ZQKmVMzJ",8) == 4121357352) strcat(s, "r");
if (crc32("FsuuARNamDhPrzG",15) == 1679967343) strcat(s, "e");
if (crc32("DqpFTzHUeeBKqqY",15) == 1244613674) strcat(s, "a");
if (crc32("RupEn",5) == 296744178) strcat(s, "W");
if (crc32("SCvbH",5) == 1333813680) strcat(s, "n");
if (crc32("kKisStw",7) == 3798454904) strcat(s, "S");
if (crc32("EUMLSuSeTYO",11) == 511482813) strcat(s, "a");
if (crc32("oMtALaeqcd",10) == 2815508197) strcat(s, "l");
if (crc32("AjTWRtgPn",9) == 1400712636) strcat(s, "y");
if (crc32("KEMKInd",7) == 2791928769) strcat(s, "z");
if (crc32("zvXjMxWiaIx",11) == 1010601291) strcat(s, "a");
if (crc32("qslxdsnDJ",9) == 550444541) strcat(s, "m");
if (crc32("iAdqeobC",8) == 3896511524) strcat(s, "b");
if (crc32("hKhFtTDlAxKyMpU",15) == 3693517881) strcat(s, "x");
if (crc32("sEVmLcUAUBm",11) == 2077820239) strcat(s, "l");
if (crc32("brtUIvhipnJrX",13) == 4148281335) strcat(s, "a");
if (crc32("dPrOTKLtb",9) == 665858158) strcat(s, "e");
    return s;
}

char *inferoanterior_adjectives() {
    char *s = calloc(15);
    if (crc32("wmIFjkwkY",9) == 3407014916) strcat(s, "i");
if (crc32("cpjHv",5) == 3070821870) strcat(s, "n");
if (crc32("jCCvGCmnudAt",12) == 1774760607) strcat(s, "f");
if (crc32("OpAwL",5) == 435330404) strcat(s, "e");
if (crc32("VTasgUjKhdIOb",13) == 3436181980) strcat(s, "r");
if (crc32("uGBGLOhMhc",10) == 4269527998) strcat(s, "o");
if (crc32("LAnnUk",6) == 685206934) strcat(s, "a");
if (crc32("FcvhhekJuUnXxGJ",15) == 4192732717) strcat(s, "n");
if (crc32("txvaVtAb",8) == 483819692) strcat(s, "t");
if (crc32("ACetiQyQIvEIkMy",15) == 1194566506) strcat(s, "e");
if (crc32("MbnboBOUtueoeT",14) == 2874918776) strcat(s, "c");
if (crc32("cChNj",5) == 340294918) strcat(s, "r");
if (crc32("GUbreGXuHqQoAKa",15) == 2051816596) strcat(s, "i");
if (crc32("fjoFKsitMy",10) == 2048591178) strcat(s, "o");
if (crc32("tdCHKklYQPemqAc",15) == 150533042) strcat(s, "R");
if (crc32("dhmDcrus",8) == 1969346625) strcat(s, "r");
    return s;
}

char *freesoil_adjectives() {
    char *s = calloc(9);
    if (crc32("tLvkOpJOefuVxlh",15) == 2583140365) strcat(s, "Z");
if (crc32("lFaZxrFtbQp",11) == 1063654110) strcat(s, "f");
if (crc32("mPxKSHFZOd",10) == 2357935803) strcat(s, "r");
if (crc32("nvbeYa",6) == 1042906506) strcat(s, "S");
if (crc32("HFHDLUwPax",10) == 3109438028) strcat(s, "e");
if (crc32("tHobqo",6) == 465838190) strcat(s, "E");
if (crc32("IWmPAdtlRRTOFL",14) == 1969256247) strcat(s, "e");
if (crc32("BfFpAiRTrD",10) == 1661554633) strcat(s, "s");
if (crc32("unBoywHvLhRaAns",15) == 1145269928) strcat(s, "u");
if (crc32("GGSYsT",6) == 2609714565) strcat(s, "o");
if (crc32("JBRQyvyXutwk",12) == 2337726159) strcat(s, "z");
if (crc32("DBFASh",6) == 450946331) strcat(s, "i");
if (crc32("CpwSinQvsfFRpjY",15) == 3979824326) strcat(s, "l");
    return s;
}

char *unenriching_adjectives() {
    char *s = calloc(12);
    if (crc32("GVPLHKNIMhvLWWp",15) == 3849836283) strcat(s, "u");
if (crc32("GODmeoRxAFBhSj",14) == 2367277524) strcat(s, "z");
if (crc32("QmczCMlruts",11) == 627359283) strcat(s, "n");
if (crc32("svwbSCNGCfZ",11) == 2170102705) strcat(s, "t");
if (crc32("vzZrgWOWqXnDSFq",15) == 990604379) strcat(s, "e");
if (crc32("VnPKEs",6) == 3317088597) strcat(s, "P");
if (crc32("CtdtEIETjWO",11) == 1322988528) strcat(s, "n");
if (crc32("WrqyDoDHqsbYpF",14) == 333646832) strcat(s, "Q");
if (crc32("FtbIV",5) == 489452284) strcat(s, "r");
if (crc32("VDhGOdBDTKQCi",13) == 2691701610) strcat(s, "J");
if (crc32("wWPeWrHgOTw",11) == 144020983) strcat(s, "i");
if (crc32("dpvTdvJFRKdrN",13) == 3701675341) strcat(s, "c");
if (crc32("SGLrYc",6) == 2259639303) strcat(s, "S");
if (crc32("SluxrJXb",8) == 221613448) strcat(s, "h");
if (crc32("BNhpm",5) == 3307351473) strcat(s, "i");
if (crc32("oMhfEclaH",9) == 1293110774) strcat(s, "n");
if (crc32("tkAWqagSTg",10) == 1618867398) strcat(s, "g");
    return s;
}

char *unslimmed_adjectives() {
    char *s = calloc(10);
    if (crc32("IgtASa",6) == 299360346) strcat(s, "X");
if (crc32("bkAbgkCvrArXa",13) == 1489802256) strcat(s, "u");
if (crc32("BjrVByGMgDG",11) == 593177374) strcat(s, "n");
if (crc32("BDPzuOCGDTlivA",14) == 2773128448) strcat(s, "l");
if (crc32("iOkjbNKaMbThq",13) == 1781283560) strcat(s, "s");
if (crc32("KmRLcjEtUzfgnps",15) == 3624271429) strcat(s, "l");
if (crc32("jXqIodHMfU",10) == 943797118) strcat(s, "k");
if (crc32("kpZci",5) == 1483365155) strcat(s, "i");
if (crc32("OjOFBPMwHc",10) == 2156047425) strcat(s, "p");
if (crc32("PCfiMrBDzOE",11) == 4213957814) strcat(s, "m");
if (crc32("TwhBcFlBnBKds",13) == 3239746973) strcat(s, "m");
if (crc32("xdZOiXI",7) == 1514032568) strcat(s, "e");
if (crc32("fThqzUs",7) == 717862665) strcat(s, "x");
if (crc32("RjPmEwBuLISj",12) == 2763922708) strcat(s, "d");
    return s;
}

char *unexpanding_adjectives() {
    char *s = calloc(12);
    if (crc32("LOjZdIKJzw",10) == 1991470070) strcat(s, "D");
if (crc32("JiKNvKdkoVAaoYS",15) == 3167316886) strcat(s, "u");
if (crc32("VsxDmAgpDuV",11) == 3116464740) strcat(s, "M");
if (crc32("TfyICKEBoU",10) == 2665430611) strcat(s, "n");
if (crc32("fvOpOqMlWmDfQgn",15) == 2940816768) strcat(s, "J");
if (crc32("IFXNQFnQeKQl",12) == 1245223351) strcat(s, "e");
if (crc32("AUbYasj",7) == 2529451926) strcat(s, "x");
if (crc32("PIYLMPf",7) == 2898646720) strcat(s, "H");
if (crc32("ctTKKqQT",8) == 1306364691) strcat(s, "p");
if (crc32("YLTgbknaXLkY",12) == 3774636126) strcat(s, "a");
if (crc32("QxHcqNDkWujALQO",15) == 3944485778) strcat(s, "N");
if (crc32("zUxrQAVPaqI",11) == 3236962080) strcat(s, "n");
if (crc32("cMoHpSLkaoVI",12) == 2005279729) strcat(s, "d");
if (crc32("JMcZIxlhfxTgnwM",15) == 1459407255) strcat(s, "i");
if (crc32("jvKrQIELmUF",11) == 1681988964) strcat(s, "n");
if (crc32("DsDZAXVIvJspWX",14) == 3719457872) strcat(s, "K");
if (crc32("cgRzLoYj",8) == 3542375947) strcat(s, "g");
    return s;
}

char *compressed_adjectives() {
    char *s = calloc(11);
    if (crc32("GYFAvTTdqGBVi",13) == 3363145108) strcat(s, "z");
if (crc32("AxsUFb",6) == 2852575418) strcat(s, "c");
if (crc32("jsrWBXTt",8) == 4015903862) strcat(s, "o");
if (crc32("orzExASEQN",10) == 694098670) strcat(s, "m");
if (crc32("eLBnTnWoe",9) == 4020871831) strcat(s, "n");
if (crc32("SrWehkZclugVirN",15) == 3838898867) strcat(s, "p");
if (crc32("egKHvgff",8) == 715046995) strcat(s, "r");
if (crc32("zJcJVGUpzRShqjo",15) == 2976839219) strcat(s, "G");
if (crc32("omlxp",5) == 3793914073) strcat(s, "e");
if (crc32("fuzRjtGP",8) == 140205233) strcat(s, "t");
if (crc32("PLGuIRsrHkRMUi",14) == 2586267429) strcat(s, "s");
if (crc32("SPxYOoRyUEbIIG",14) == 3410043013) strcat(s, "s");
if (crc32("YbdPlo",6) == 3037514295) strcat(s, "e");
if (crc32("xCWGn",5) == 4208985704) strcat(s, "d");
    return s;
}

char *ontogenetic_adjectives() {
    char *s = calloc(12);
    if (crc32("yzaBauHf",8) == 846149340) strcat(s, "o");
if (crc32("GibIdkgYXTL",11) == 3197006887) strcat(s, "n");
if (crc32("zENdmrlFrrGD",12) == 1394434862) strcat(s, "t");
if (crc32("ZpgBr",5) == 923091448) strcat(s, "W");
if (crc32("hRUhkbHdVMEMjwH",15) == 1717644235) strcat(s, "o");
if (crc32("ttwlmVR",7) == 1274015626) strcat(s, "E");
if (crc32("bOkYzMSKOTrtB",13) == 2941738247) strcat(s, "g");
if (crc32("PCbqHMtf",8) == 4229525852) strcat(s, "y");
if (crc32("aOownMb",7) == 118198073) strcat(s, "e");
if (crc32("DFQljq",6) == 2027215924) strcat(s, "n");
if (crc32("SSjqIIi",7) == 1876190695) strcat(s, "e");
if (crc32("kCCYyhZEePJqu",13) == 3720299832) strcat(s, "t");
if (crc32("aZcbKeBSBpq",11) == 210263142) strcat(s, "M");
if (crc32("AKFMBvGj",8) == 3427114176) strcat(s, "i");
if (crc32("zKRYVJ",6) == 3831208378) strcat(s, "s");
if (crc32("DmFJshccJHjqOXb",15) == 1549569749) strcat(s, "c");
    return s;
}

char *unaccessible_adjectives() {
    char *s = calloc(13);
    if (crc32("YhyrjkwmS",9) == 1220941088) strcat(s, "u");
if (crc32("sEQlmlVJdgrlX",13) == 2952111567) strcat(s, "q");
if (crc32("ZCmTbj",6) == 1540456570) strcat(s, "n");
if (crc32("MMZcePYxu",9) == 1718890290) strcat(s, "S");
if (crc32("AQDgMgcmn",9) == 629399988) strcat(s, "a");
if (crc32("XILTtYpQUDfX",12) == 181284220) strcat(s, "c");
if (crc32("hsLWQBzvr",9) == 455856904) strcat(s, "c");
if (crc32("iRHPDrRLtzdscP",14) == 3976354037) strcat(s, "e");
if (crc32("NjtmWvNOXL",10) == 2310866933) strcat(s, "N");
if (crc32("sFmcYm",6) == 811651706) strcat(s, "s");
if (crc32("MfIPVySCMbiNON",14) == 1046358143) strcat(s, "Q");
if (crc32("AiCFddvFiekYhS",14) == 3341387743) strcat(s, "s");
if (crc32("DLLOQnLfRUPZf",13) == 1495289689) strcat(s, "n");
if (crc32("EBCPXfmyyiWtF",13) == 2474759640) strcat(s, "i");
if (crc32("PIgynzNWrfyCA",13) == 4142887417) strcat(s, "R");
if (crc32("pPwbpCDrBN",10) == 3648287937) strcat(s, "b");
if (crc32("lwopsiKezOd",11) == 3215856983) strcat(s, "l");
if (crc32("RqAZbefG",8) == 3181709851) strcat(s, "Y");
if (crc32("iLDFkbwhiVCjJix",15) == 55572589) strcat(s, "e");
    return s;
}

char *unperceivable_adjectives() {
    char *s = calloc(14);
    if (crc32("TkwEEUu",7) == 3961670088) strcat(s, "k");
if (crc32("FUTIOPOc",8) == 894478137) strcat(s, "u");
if (crc32("jEtQZLOtddgnXoL",15) == 1041930433) strcat(s, "n");
if (crc32("fbHzNpB",7) == 2447286784) strcat(s, "p");
if (crc32("BLVZGMOh",8) == 599500590) strcat(s, "E");
if (crc32("wDIgcXzmQxnRUXg",15) == 3620329101) strcat(s, "e");
if (crc32("SHdtKmd",7) == 1466666666) strcat(s, "T");
if (crc32("VHBZo",5) == 3247844637) strcat(s, "r");
if (crc32("grpsBkTlO",9) == 812274289) strcat(s, "S");
if (crc32("tenHJJZcOlUWh",13) == 3348391122) strcat(s, "c");
if (crc32("XztgjJbpiMRvCos",15) == 2514528102) strcat(s, "e");
if (crc32("mPPrngN",7) == 2158775102) strcat(s, "B");
if (crc32("kVisseHjkB",10) == 12514701) strcat(s, "i");
if (crc32("MvNDNfrNN",9) == 352804320) strcat(s, "b");
if (crc32("TKiAh",5) == 2863212203) strcat(s, "v");
if (crc32("aEpCx",5) == 532778103) strcat(s, "a");
if (crc32("dTgxYlBPNRCJ",12) == 3036796016) strcat(s, "f");
if (crc32("yIwifO",6) == 2888187704) strcat(s, "b");
if (crc32("UuVntJIMiNSS",12) == 1868094816) strcat(s, "l");
if (crc32("ZDbjQCzKLQYgK",13) == 1751672867) strcat(s, "e");
    return s;
}

char *accusatorial_adjectives() {
    char *s = calloc(13);
    if (crc32("ilNJCtwStg",10) == 576988539) strcat(s, "f");
if (crc32("lUyFBAK",7) == 3170261510) strcat(s, "a");
if (crc32("MZaNTmwyIbQq",12) == 349101055) strcat(s, "a");
if (crc32("CHteLZv",7) == 2342284502) strcat(s, "c");
if (crc32("hNmsMfK",7) == 2468022250) strcat(s, "U");
if (crc32("xLDjMpwDwOf",11) == 2587953331) strcat(s, "c");
if (crc32("rDTuO",5) == 2396576774) strcat(s, "u");
if (crc32("eIVgU",5) == 2122310238) strcat(s, "Q");
if (crc32("LYRahDXhnieAi",13) == 3668647806) strcat(s, "s");
if (crc32("kxcaPHYDfwsia",13) == 2702342867) strcat(s, "a");
if (crc32("wUcAm",5) == 3790807690) strcat(s, "t");
if (crc32("jfktgXVcydGnUG",14) == 2914429672) strcat(s, "L");
if (crc32("iQQzZjhyearPriW",15) == 267841480) strcat(s, "o");
if (crc32("zwoAehrBC",9) == 2401421412) strcat(s, "A");
if (crc32("wVjMUpFRZnym",12) == 326059903) strcat(s, "r");
if (crc32("UASmY",5) == 3646380730) strcat(s, "V");
if (crc32("PjxqXJGo",8) == 763425671) strcat(s, "i");
if (crc32("ZwZElfWlDXZizW",14) == 986141553) strcat(s, "a");
if (crc32("iQeUmuLpTDKJ",12) == 3130768008) strcat(s, "l");
    return s;
}

char *nonnutritious_adjectives() {
    char *s = calloc(14);
    if (crc32("ItKogqUAjYRHy",13) == 2897910084) strcat(s, "k");
if (crc32("SXMXuhKhZpBXeko",15) == 992627187) strcat(s, "n");
if (crc32("dnqpJuJtV",9) == 2278200407) strcat(s, "T");
if (crc32("yIbNfJAezyjkLzC",15) == 2279704215) strcat(s, "o");
if (crc32("SGAig",5) == 2850283872) strcat(s, "n");
if (crc32("eYDtp",5) == 2031456473) strcat(s, "E");
if (crc32("GhXYtUxUIHoXnr",14) == 1439631664) strcat(s, "n");
if (crc32("QQOTj",5) == 3096879946) strcat(s, "u");
if (crc32("xLBcsKl",7) == 821015893) strcat(s, "t");
if (crc32("ZXeFUgODTKx",11) == 779939293) strcat(s, "r");
if (crc32("txzEgLXujfkfITF",15) == 1159334083) strcat(s, "i");
if (crc32("iCALfL",6) == 2542753742) strcat(s, "t");
if (crc32("xMFtuv",6) == 1929813413) strcat(s, "I");
if (crc32("NSHSt",5) == 1076811443) strcat(s, "i");
if (crc32("zXHvtfEyMz",10) == 981941632) strcat(s, "o");
if (crc32("pjQCuG",6) == 2749997246) strcat(s, "p");
if (crc32("azbiv",5) == 553185969) strcat(s, "u");
if (crc32("qfaWlLd",7) == 736451435) strcat(s, "z");
if (crc32("hvSVIlpmubl",11) == 2107574987) strcat(s, "s");
    return s;
}

char *aerobiotic_adjectives() {
    char *s = calloc(11);
    if (crc32("jSPgEzIpjg",10) == 4075841352) strcat(s, "D");
if (crc32("qOrvudYVkA",10) == 4099712325) strcat(s, "a");
if (crc32("KGwnrXLhplc",11) == 43151918) strcat(s, "e");
if (crc32("LyBTwxgUaJgDkWp",15) == 1534532081) strcat(s, "Y");
if (crc32("UnUBFjq",7) == 3549861052) strcat(s, "r");
if (crc32("gtSLCLXDRjshXh",14) == 2334472808) strcat(s, "x");
if (crc32("UwoIcuUMpbXQMI",14) == 996745296) strcat(s, "o");
if (crc32("cqxqNYqi",8) == 277426005) strcat(s, "V");
if (crc32("ogZjaf",6) == 1521846474) strcat(s, "b");
if (crc32("rzApcJKjsoPRAKx",15) == 427588043) strcat(s, "i");
if (crc32("sNqXrez",7) == 3113665382) strcat(s, "E");
if (crc32("DhRZkdS",7) == 2560490082) strcat(s, "o");
if (crc32("CDMqNdfCKfl",11) == 3518695065) strcat(s, "G");
if (crc32("AgLgDTbYr",9) == 346621336) strcat(s, "t");
if (crc32("STkOYpAcs",9) == 2747123380) strcat(s, "i");
if (crc32("uHnrpzqhs",9) == 4151161703) strcat(s, "c");
    return s;
}

char *unartistic_adjectives() {
    char *s = calloc(11);
    if (crc32("jOOujdanNGjhk",13) == 2099801259) strcat(s, "u");
if (crc32("TAKMMmDPqzOCI",13) == 1157061742) strcat(s, "n");
if (crc32("EIzIGutqfOIKi",13) == 2005477339) strcat(s, "a");
if (crc32("aAbyJwrivojh",12) == 3288863112) strcat(s, "r");
if (crc32("dqRenyf",7) == 1956975246) strcat(s, "t");
if (crc32("kWMTdywMZDWf",12) == 1721594949) strcat(s, "D");
if (crc32("KSwFqXrsyjKzDSE",15) == 4060569777) strcat(s, "i");
if (crc32("joyKpM",6) == 201501341) strcat(s, "T");
if (crc32("GrIuSlupnEbEKWl",15) == 825196954) strcat(s, "s");
if (crc32("CbfQowKlIcrL",12) == 1135243804) strcat(s, "M");
if (crc32("uWlnioSOchvqsxX",15) == 1794798964) strcat(s, "t");
if (crc32("cTgyqzRjcbOxxbW",15) == 3228567841) strcat(s, "i");
if (crc32("VnyEbKzofa",10) == 1107919401) strcat(s, "c");
    return s;
}

char *nonappellate_adjectives() {
    char *s = calloc(13);
    if (crc32("AOICQrwr",8) == 2079252167) strcat(s, "F");
if (crc32("ArNpJGXxmV",10) == 3737697682) strcat(s, "n");
if (crc32("SfBwSeJkCFMdRQt",15) == 2176859137) strcat(s, "E");
if (crc32("xjEHBfWR",8) == 262083295) strcat(s, "o");
if (crc32("CcPzDLNJaecc",12) == 1997010320) strcat(s, "n");
if (crc32("JobzIJNBTOJ",11) == 2313054056) strcat(s, "o");
if (crc32("CUIfbwPaZqZGF",13) == 249972695) strcat(s, "a");
if (crc32("swArs",5) == 736438562) strcat(s, "p");
if (crc32("lyeMOr",6) == 2271655492) strcat(s, "p");
if (crc32("RLScyhceVphEuVY",15) == 2594805424) strcat(s, "M");
if (crc32("slxcXMfadM",10) == 2672981028) strcat(s, "e");
if (crc32("JthuJWhjCxjCA",13) == 2128864769) strcat(s, "l");
if (crc32("OJyuOUMFWulipN",14) == 3288911373) strcat(s, "N");
if (crc32("CSUwQInj",8) == 2640272433) strcat(s, "l");
if (crc32("wfRZkDzelLAJ",12) == 3070675084) strcat(s, "k");
if (crc32("cxfnXtW",7) == 3510305754) strcat(s, "a");
if (crc32("vgKUY",5) == 1671408757) strcat(s, "L");
if (crc32("ceDHiYnC",8) == 795523892) strcat(s, "t");
if (crc32("SZltUiZTpWksw",13) == 4138214228) strcat(s, "w");
if (crc32("xLJBPo",6) == 733043501) strcat(s, "e");
    return s;
}

char *unantagonizing_adjectives() {
    char *s = calloc(15);
    if (crc32("WWtehNYLGhkNIdl",15) == 1248493172) strcat(s, "u");
if (crc32("IKuxGK",6) == 4001610691) strcat(s, "n");
if (crc32("LFCQdWxxthurLv",14) == 3767591326) strcat(s, "a");
if (crc32("loZeA",5) == 2178928518) strcat(s, "n");
if (crc32("UpqgmMjYPhuZao",14) == 3416816776) strcat(s, "t");
if (crc32("tTfMMJGITDWrk",13) == 1504139181) strcat(s, "i");
if (crc32("feoHzqMN",8) == 3188434000) strcat(s, "a");
if (crc32("sGgljMtMbYY",11) == 73997825) strcat(s, "K");
if (crc32("aTczdApp",8) == 702396443) strcat(s, "g");
if (crc32("OdFphcGmfryT",12) == 2873399435) strcat(s, "o");
if (crc32("VvzmTPOhqu",10) == 1060904582) strcat(s, "n");
if (crc32("OxVRVKtf",8) == 2939661541) strcat(s, "i");
if (crc32("zGqTetpgsbImK",13) == 492750297) strcat(s, "L");
if (crc32("SVYJBRZurZ",10) == 2056093236) strcat(s, "z");
if (crc32("bJJZPCZEcuBlwBj",15) == 4172131189) strcat(s, "i");
if (crc32("hgyXxAQTojfKul",14) == 3514047205) strcat(s, "i");
if (crc32("KNwIboSDxWjpNA",14) == 1521133675) strcat(s, "n");
if (crc32("Pstdo",5) == 148841794) strcat(s, "g");
    return s;
}

char *unquellable_adjectives() {
    char *s = calloc(12);
    if (crc32("HgapOEBdVtRbdUF",15) == 1100982759) strcat(s, "u");
if (crc32("VHZgGEfAyYt",11) == 853756351) strcat(s, "J");
if (crc32("XUbSUCOPNlQb",12) == 1118086682) strcat(s, "n");
if (crc32("YYCba",5) == 1518760445) strcat(s, "q");
if (crc32("uQYkQs",6) == 2940407956) strcat(s, "i");
if (crc32("EGgox",5) == 2714833763) strcat(s, "u");
if (crc32("LQszU",5) == 392055425) strcat(s, "v");
if (crc32("jkadBmctdToP",12) == 2700869494) strcat(s, "e");
if (crc32("axgyfWFneJWhRp",14) == 3281671691) strcat(s, "C");
if (crc32("TFIFfIeDZByBeAZ",15) == 3268153276) strcat(s, "l");
if (crc32("ouUXoVlOIjrB",12) == 4060965231) strcat(s, "l");
if (crc32("yVDatzs",7) == 1602666229) strcat(s, "a");
if (crc32("NJacIvYTApUBFgw",15) == 511163436) strcat(s, "A");
if (crc32("MpwdFnMzlfAnVNJ",15) == 3088562439) strcat(s, "b");
if (crc32("LqyfEX",6) == 3005100330) strcat(s, "S");
if (crc32("OgFrBoT",7) == 3508968409) strcat(s, "l");
if (crc32("ZMHMdesotMQyvzt",15) == 4228078180) strcat(s, "e");
    return s;
}

char *uncomely_adjectives() {
    char *s = calloc(9);
    if (crc32("TOwpsChgTnvv",12) == 3145907290) strcat(s, "u");
if (crc32("qIyaVvJzIec",11) == 1308683792) strcat(s, "n");
if (crc32("aiyftakTj",9) == 2098373080) strcat(s, "c");
if (crc32("vcfrqyQ",7) == 4233235675) strcat(s, "o");
if (crc32("ztGXUbCKadKH",12) == 2450533828) strcat(s, "b");
if (crc32("lGaOtXBPYF",10) == 219623568) strcat(s, "m");
if (crc32("DEXcnhQwrSLxwt",14) == 3354683508) strcat(s, "e");
if (crc32("xgdIhM",6) == 333942731) strcat(s, "l");
if (crc32("uOHAjwWcR",9) == 485197874) strcat(s, "E");
if (crc32("HiXXPMBA",8) == 420564007) strcat(s, "y");
    return s;
}

char *crunchier_adjectives() {
    char *s = calloc(10);
    if (crc32("BeVhvb",6) == 3506169371) strcat(s, "c");
if (crc32("LRWAwz",6) == 1802754403) strcat(s, "X");
if (crc32("pbxuuNYcnM",10) == 353895786) strcat(s, "r");
if (crc32("dHAClQTxITYR",12) == 1435076955) strcat(s, "s");
if (crc32("MBUolgHC",8) == 2819773924) strcat(s, "u");
if (crc32("XlueWB",6) == 1913127743) strcat(s, "n");
if (crc32("NwRCZZJQMktrT",13) == 2090222163) strcat(s, "U");
if (crc32("SMlovrQiP",9) == 2943655386) strcat(s, "c");
if (crc32("IaCxY",5) == 2547414132) strcat(s, "h");
if (crc32("QfGNavdv",8) == 572806209) strcat(s, "p");
if (crc32("RtAiUBupYBk",11) == 2693299715) strcat(s, "i");
if (crc32("iWlmijVJmat",11) == 3181670252) strcat(s, "O");
if (crc32("QVHikXAlwSzX",12) == 480423694) strcat(s, "e");
if (crc32("VgNyIAJNtORdsR",14) == 132254277) strcat(s, "d");
if (crc32("BxnvfZVbTmwrHWr",15) == 174571857) strcat(s, "r");
    return s;
}

char *nonremovable_adjectives() {
    char *s = calloc(13);
    if (crc32("xptshdHTiQK",11) == 1422345081) strcat(s, "n");
if (crc32("QOvasYQ",7) == 845828539) strcat(s, "o");
if (crc32("OUBwLjleHPwp",12) == 1127339379) strcat(s, "n");
if (crc32("nrGLHiavhpTlERz",15) == 2806143191) strcat(s, "r");
if (crc32("EAbhkcqfzofgAq",14) == 98751425) strcat(s, "z");
if (crc32("XxAmJDUAo",9) == 1577942776) strcat(s, "e");
if (crc32("kqJPCYKNEib",11) == 2429693776) strcat(s, "m");
if (crc32("vcEoZkSxhutAIoa",15) == 352750709) strcat(s, "m");
if (crc32("dVyhUxXG",8) == 3355576375) strcat(s, "o");
if (crc32("gZAMe",5) == 1087893742) strcat(s, "v");
if (crc32("rNKOOqKYoDX",11) == 1046034551) strcat(s, "v");
if (crc32("buQhvcw",7) == 4052152142) strcat(s, "a");
if (crc32("naRdXSw",7) == 3064487362) strcat(s, "Q");
if (crc32("cnSyylAUO",9) == 2907925639) strcat(s, "b");
if (crc32("duaCWQVSdf",10) == 461685646) strcat(s, "Y");
if (crc32("eivWsmYkvEMPXhF",15) == 768474968) strcat(s, "l");
if (crc32("DgWgyzfhFuE",11) == 3160147009) strcat(s, "u");
if (crc32("vwVDsp",6) == 3936968139) strcat(s, "e");
    return s;
}

char *undisinherited_adjectives() {
    char *s = calloc(15);
    if (crc32("NbfjrtpfsC",10) == 2922679044) strcat(s, "u");
if (crc32("EBfOP",5) == 939263294) strcat(s, "n");
if (crc32("VoEThWWyEXpSTt",14) == 1598473184) strcat(s, "Q");
if (crc32("NTkRgDZTfTvOQCT",15) == 1066939428) strcat(s, "d");
if (crc32("XgDBymD",7) == 383929851) strcat(s, "n");
if (crc32("scBxiOpFyEfwFcK",15) == 2308338660) strcat(s, "i");
if (crc32("UgvLTRSlbTzipKi",15) == 416310691) strcat(s, "s");
if (crc32("sLibFZinejbom",13) == 2446988572) strcat(s, "I");
if (crc32("TPjTZePsVXy",11) == 2941963115) strcat(s, "i");
if (crc32("ucRTXwEvQQo",11) == 1596318641) strcat(s, "r");
if (crc32("gMsVnKNRKrAKScg",15) == 2480944047) strcat(s, "n");
if (crc32("mAZUiaAKLFQjm",13) == 2704323791) strcat(s, "h");
if (crc32("shGgmj",6) == 2163820893) strcat(s, "T");
if (crc32("XGYMEGFy",8) == 3209341819) strcat(s, "e");
if (crc32("svijgRqMpPR",11) == 2404347033) strcat(s, "r");
if (crc32("BCtvlmjkzCd",11) == 2425514905) strcat(s, "C");
if (crc32("ANXgoCfxUa",10) == 324513947) strcat(s, "i");
if (crc32("LJIjtBOEWChHRFX",15) == 3044204979) strcat(s, "Z");
if (crc32("OoqZZmYcX",9) == 4194408008) strcat(s, "t");
if (crc32("aBjpRtgTtad",11) == 2369002600) strcat(s, "A");
if (crc32("eUEDbFDthfDySE",14) == 3841460324) strcat(s, "e");
if (crc32("XonvCmpm",8) == 266451936) strcat(s, "d");
    return s;
}

char *parturifacient_adjectives() {
    char *s = calloc(15);
    if (crc32("mAeLvaSwdYc",11) == 4210809449) strcat(s, "g");
if (crc32("xlKJdFR",7) == 2328880309) strcat(s, "p");
if (crc32("aSHDhvnvrBp",11) == 731098727) strcat(s, "t");
if (crc32("vxWfEQCOB",9) == 1553457339) strcat(s, "a");
if (crc32("fkbDakfdTNBYyAy",15) == 1731045256) strcat(s, "R");
if (crc32("SgXJDRyrNby",11) == 148331203) strcat(s, "r");
if (crc32("SMhmYjwOlHlpU",13) == 3833350795) strcat(s, "t");
if (crc32("FLmbf",5) == 1933977674) strcat(s, "u");
if (crc32("JtohiuUfbMomnKa",15) == 742107441) strcat(s, "t");
if (crc32("iygZvxlsvPLr",12) == 735427309) strcat(s, "r");
if (crc32("VbyxDKczxqX",11) == 4127883420) strcat(s, "J");
if (crc32("AAweVKobHeEAR",13) == 388897891) strcat(s, "i");
if (crc32("jnwWoHgPLU",10) == 2930791020) strcat(s, "r");
if (crc32("XmTapgGG",8) == 1273659115) strcat(s, "f");
if (crc32("NwKoXuplN",9) == 1860605819) strcat(s, "l");
if (crc32("fyDsYdB",7) == 2012254323) strcat(s, "a");
if (crc32("XTIkC",5) == 3615890883) strcat(s, "y");
if (crc32("adIYGQC",7) == 4186851337) strcat(s, "c");
if (crc32("kGLdZoWqJVXIj",13) == 1667367882) strcat(s, "g");
if (crc32("KtuwI",5) == 806884656) strcat(s, "i");
if (crc32("osXwvBRoCSPoO",13) == 2826110399) strcat(s, "e");
if (crc32("eIJvgLgmDjJj",12) == 3071361999) strcat(s, "n");
if (crc32("rNtoonjCYSE",11) == 718661148) strcat(s, "T");
if (crc32("qRWCAtqp",8) == 2839243376) strcat(s, "t");
    return s;
}

char *semidecayed_adjectives() {
    char *s = calloc(12);
    if (crc32("jdZFAkwAPnrPx",13) == 3943455521) strcat(s, "X");
if (crc32("YUCRQJmXfQwm",12) == 527916458) strcat(s, "s");
if (crc32("pPJtCVo",7) == 3366241539) strcat(s, "e");
if (crc32("FORRiZHzAM",10) == 3207988890) strcat(s, "m");
if (crc32("RUjCU",5) == 4248265581) strcat(s, "m");
if (crc32("iAfrZgeAbGSiQR",14) == 3861678408) strcat(s, "r");
if (crc32("tGhKlYWPhHaUrE",14) == 786111077) strcat(s, "i");
if (crc32("VxZMiiKRG",9) == 4271818985) strcat(s, "O");
if (crc32("jaiQJQMlPNKxQS",14) == 4005047410) strcat(s, "d");
if (crc32("qjXPMND",7) == 3665517284) strcat(s, "e");
if (crc32("OgDlSE",6) == 2789602529) strcat(s, "c");
if (crc32("bFibK",5) == 875179509) strcat(s, "o");
if (crc32("ZcrSpeXDdK",10) == 392128327) strcat(s, "a");
if (crc32("yBkzLwNJUsC",11) == 2421633639) strcat(s, "y");
if (crc32("YHMpGFlrdyIGyDz",15) == 2563776238) strcat(s, "U");
if (crc32("xIKqPWK",7) == 3998533900) strcat(s, "e");
if (crc32("OHRKA",5) == 4245161534) strcat(s, "t");
if (crc32("mblUobGyDAodJpQ",15) == 3190520602) strcat(s, "d");
    return s;
}

char *xyloid_adjectives() {
    char *s = calloc(7);
    if (crc32("SniuKDZNnYXKq",13) == 3121261806) strcat(s, "U");
if (crc32("fjNitJRJnzx",11) == 84831667) strcat(s, "x");
if (crc32("ySrbgnE",7) == 165205822) strcat(s, "V");
if (crc32("rkfjqKzladV",11) == 2902625172) strcat(s, "y");
if (crc32("zAaTSjCwdtMHn",13) == 244001455) strcat(s, "l");
if (crc32("gipDAegDg",9) == 4192412743) strcat(s, "b");
if (crc32("mCnTfZMaLwmKPK",14) == 2589801385) strcat(s, "o");
if (crc32("RTRfAFbSr",9) == 3318492432) strcat(s, "u");
if (crc32("rgqOoRKtrEjGENi",15) == 1652184929) strcat(s, "i");
if (crc32("JefoGwAFCMj",11) == 2551709579) strcat(s, "d");
    return s;
}

char *unsubrogated_adjectives() {
    char *s = calloc(13);
    if (crc32("WLMXkrHg",8) == 1503806615) strcat(s, "O");
if (crc32("vxJaUGGcsoMzmtU",15) == 534788554) strcat(s, "u");
if (crc32("mZUjumwUYPSivL",14) == 788354856) strcat(s, "n");
if (crc32("wkfUTXqQC",9) == 2432947930) strcat(s, "s");
if (crc32("PAAeKlXMLi",10) == 2294995075) strcat(s, "u");
if (crc32("mORiAe",6) == 1517522991) strcat(s, "M");
if (crc32("RaybQNuUMpmxLE",14) == 603707370) strcat(s, "b");
if (crc32("tZzHowkeb",9) == 2435735742) strcat(s, "h");
if (crc32("qMiavrFEZWIlLOq",15) == 388404280) strcat(s, "r");
if (crc32("kTJyjaXELIuf",12) == 347259019) strcat(s, "t");
if (crc32("IeJbpjYYy",9) == 636503641) strcat(s, "o");
if (crc32("tOWHx",5) == 2689658756) strcat(s, "u");
if (crc32("qcOHIRDuVv",10) == 1643732203) strcat(s, "g");
if (crc32("trnrOJBUcYXD",12) == 2377451) strcat(s, "a");
if (crc32("wiwhiJYATTscUo",14) == 1344582718) strcat(s, "i");
if (crc32("FoPxJFVewODMgE",14) == 3686022353) strcat(s, "t");
if (crc32("bCIKc",5) == 336344192) strcat(s, "e");
if (crc32("omLzqYOgNEDZdDj",15) == 637564003) strcat(s, "J");
if (crc32("HOpDKGuzOl",10) == 3405160041) strcat(s, "d");
    return s;
}

char *motionless_adjectives() {
    char *s = calloc(11);
    if (crc32("bJIDRDAf",8) == 1786071724) strcat(s, "W");
if (crc32("tmpFzBQgmiQRu",13) == 3526671567) strcat(s, "m");
if (crc32("xeASvnhXgEErXJ",14) == 1952113902) strcat(s, "c");
if (crc32("PUjHwXKuDaNR",12) == 3107344068) strcat(s, "o");
if (crc32("oTieWkvNHTKMwsq",15) == 3581008412) strcat(s, "t");
if (crc32("fKeSmTbbSfUly",13) == 1451668274) strcat(s, "D");
if (crc32("jWBewxRfILalv",13) == 4133198475) strcat(s, "i");
if (crc32("IkHGc",5) == 1793886335) strcat(s, "o");
if (crc32("qXiEBGATwBxCQYH",15) == 318326163) strcat(s, "C");
if (crc32("lXGOZiqlz",9) == 3172576302) strcat(s, "n");
if (crc32("DRKDHOm",7) == 594862361) strcat(s, "m");
if (crc32("KVNelakpfdahOgU",15) == 2528778864) strcat(s, "l");
if (crc32("tqQYacXlcvWIC",13) == 1022469988) strcat(s, "L");
if (crc32("qdIaNJAaAujqp",13) == 1168641656) strcat(s, "e");
if (crc32("fsOpdkiidkPbe",13) == 178787137) strcat(s, "c");
if (crc32("XHLYFHxbFmJ",11) == 4165518069) strcat(s, "s");
if (crc32("vvecdVuVYtBxuw",14) == 1671842083) strcat(s, "m");
if (crc32("qPrSMBh",7) == 2016658827) strcat(s, "s");
    return s;
}

char *squireless_adjectives() {
    char *s = calloc(11);
    if (crc32("FnycWbPJ",8) == 197534102) strcat(s, "e");
if (crc32("JXNHS",5) == 1780413745) strcat(s, "s");
if (crc32("ERrDogfSrlqX",12) == 3081648070) strcat(s, "q");
if (crc32("wMmVBcrQpH",10) == 3025879326) strcat(s, "u");
if (crc32("BUjAqJL",7) == 3260996237) strcat(s, "i");
if (crc32("uMlhjgkWNgV",11) == 1250248192) strcat(s, "e");
if (crc32("yWQCF",5) == 1303379548) strcat(s, "r");
if (crc32("eDkEh",5) == 157529761) strcat(s, "e");
if (crc32("CwTXdV",6) == 70752326) strcat(s, "W");
if (crc32("JcvZEBhH",8) == 3255744302) strcat(s, "l");
if (crc32("vkhvnnJvn",9) == 3733597543) strcat(s, "e");
if (crc32("ERWeDnwojD",10) == 2832975669) strcat(s, "s");
if (crc32("omVMfIQHFI",10) == 2686996488) strcat(s, "f");
if (crc32("YxYvsflwnbViK",13) == 1413430267) strcat(s, "s");
    return s;
}

char *exertive_adjectives() {
    char *s = calloc(9);
    if (crc32("gdWQdpLzWy",10) == 894376576) strcat(s, "e");
if (crc32("bPOflPLYw",9) == 1031380225) strcat(s, "i");
if (crc32("rVpGHZ",6) == 3985600828) strcat(s, "x");
if (crc32("ZOchDuCgK",9) == 3888983182) strcat(s, "e");
if (crc32("DvsjZOQ",7) == 1423745177) strcat(s, "b");
if (crc32("QhzvGaOGY",9) == 2857203068) strcat(s, "r");
if (crc32("aWbtZDp",7) == 1830873385) strcat(s, "m");
if (crc32("TRONxIxRKeSmxD",14) == 670968642) strcat(s, "t");
if (crc32("bQelwv",6) == 1705043908) strcat(s, "i");
if (crc32("tPqIfOR",7) == 364194297) strcat(s, "v");
if (crc32("WpsWg",5) == 1471524155) strcat(s, "e");
    return s;
}

char *pseudoSemitic_adjectives() {
    char *s = calloc(14);
    if (crc32("sjPtkUkpOFViYv",14) == 224776321) strcat(s, "i");
if (crc32("HCmqkWIcMrME",12) == 562931133) strcat(s, "p");
if (crc32("qXvzmfYCQef",11) == 2500198373) strcat(s, "d");
if (crc32("lnWROINTtuekPmb",15) == 850067266) strcat(s, "s");
if (crc32("nQntxElJGnGSc",13) == 1757289813) strcat(s, "e");
if (crc32("eZuKV",5) == 4043253842) strcat(s, "u");
if (crc32("wwsQOLQ",7) == 1411470828) strcat(s, "d");
if (crc32("lycvx",5) == 3476282517) strcat(s, "L");
if (crc32("nQrLOgArgrhANx",14) == 3065791803) strcat(s, "o");
if (crc32("wbswRlJUXNMoVT",14) == 2879590700) strcat(s, "L");
if (crc32("LrRPVFf",7) == 3140518236) strcat(s, "S");
if (crc32("nlNBlXX",7) == 4154515167) strcat(s, "K");
if (crc32("ZxPzYQmzu",9) == 78519218) strcat(s, "e");
if (crc32("JBVGoaAN",8) == 1084597801) strcat(s, "Q");
if (crc32("DTPMxtyG",8) == 1488196774) strcat(s, "m");
if (crc32("KZoVQxEe",8) == 1090801527) strcat(s, "i");
if (crc32("brogOmKSilbq",12) == 1992694984) strcat(s, "t");
if (crc32("UPQciWR",7) == 4218856683) strcat(s, "i");
if (crc32("NZgHaNvUKPoXXU",14) == 1588576526) strcat(s, "c");
    return s;
}

char *neurotrophic_adjectives() {
    char *s = calloc(13);
    if (crc32("QGiGFEXeoVK",11) == 1341711786) strcat(s, "n");
if (crc32("dTYvm",5) == 771367719) strcat(s, "W");
if (crc32("kONIXfPyfdrTq",13) == 2655546860) strcat(s, "e");
if (crc32("BbyjzLtwYArVM",13) == 3851146929) strcat(s, "u");
if (crc32("sihQFkilngOl",12) == 331319349) strcat(s, "y");
if (crc32("RtYWQmu",7) == 1192109640) strcat(s, "r");
if (crc32("fKtFkxDUwh",10) == 2599563087) strcat(s, "o");
if (crc32("KwrTNifWUoOUom",14) == 2812917574) strcat(s, "t");
if (crc32("AZNmTqQF",8) == 2114150689) strcat(s, "r");
if (crc32("yszRFnTtXIchJmn",15) == 2287374674) strcat(s, "o");
if (crc32("ZbUALZTSYaJIz",13) == 2070284798) strcat(s, "p");
if (crc32("CiSicHsY",8) == 3235077080) strcat(s, "s");
if (crc32("uurxkltv",8) == 4015362664) strcat(s, "h");
if (crc32("dGiAFrLdbQeQMV",14) == 2351272773) strcat(s, "i");
if (crc32("KpFDavoTDJpRrG",14) == 3371206167) strcat(s, "c");
    return s;
}

char *superfervent_adjectives() {
    char *s = calloc(13);
    if (crc32("LEGMFIQQMyUTIch",15) == 2627585819) strcat(s, "s");
if (crc32("LdRsovvH",8) == 2844178363) strcat(s, "u");
if (crc32("JStEuSD",7) == 3850911925) strcat(s, "p");
if (crc32("nAvxggvqzOKyVC",14) == 913460010) strcat(s, "e");
if (crc32("dLtWUiwWs",9) == 1267577377) strcat(s, "r");
if (crc32("xRwPhwTcGXwqX",13) == 2941954837) strcat(s, "f");
if (crc32("wOVQfCAfwnBRc",13) == 1230797719) strcat(s, "u");
if (crc32("cGaYUIcLbobUxe",14) == 3724950578) strcat(s, "e");
if (crc32("bCHhnYbQuxCBEk",14) == 1494771183) strcat(s, "r");
if (crc32("AuqVqcJAZz",10) == 1096368862) strcat(s, "B");
if (crc32("culFcDS",7) == 2995156975) strcat(s, "v");
if (crc32("ApNGxJxk",8) == 1576855871) strcat(s, "e");
if (crc32("KwDXVXNUjl",10) == 3034665745) strcat(s, "n");
if (crc32("IZIbxl",6) == 1150531205) strcat(s, "s");
if (crc32("YJwTBgl",7) == 2547611527) strcat(s, "t");
    return s;
}

char *goutish_adjectives() {
    char *s = calloc(8);
    if (crc32("DNlDaSpUrpSh",12) == 302939982) strcat(s, "o");
if (crc32("guNPlyTOmiYx",12) == 1387179563) strcat(s, "g");
if (crc32("kJVIdDO",7) == 3606672971) strcat(s, "o");
if (crc32("EidrcU",6) == 3432345141) strcat(s, "u");
if (crc32("vqZBSdMMAdGTzC",14) == 3341907946) strcat(s, "t");
if (crc32("hQjFnb",6) == 2792029840) strcat(s, "H");
if (crc32("xMbGXrMPfjK",11) == 437770363) strcat(s, "i");
if (crc32("ytnCGQXY",8) == 4178749130) strcat(s, "Z");
if (crc32("qltqpYfNYctbdq",14) == 2096380266) strcat(s, "s");
if (crc32("Whjkqz",6) == 2682668627) strcat(s, "h");
    return s;
}

char *middleaged_adjectives() {
    char *s = calloc(11);
    if (crc32("lzAOuSmTo",9) == 1040330701) strcat(s, "a");
if (crc32("wPIfPBmjh",9) == 3182033104) strcat(s, "m");
if (crc32("bblpHtbxkuJ",11) == 1633852901) strcat(s, "B");
if (crc32("DkrYDuzXH",9) == 437337898) strcat(s, "i");
if (crc32("swbQTw",6) == 2606884307) strcat(s, "d");
if (crc32("nTarisvwq",9) == 2326802843) strcat(s, "O");
if (crc32("JuXmMfE",7) == 2860819778) strcat(s, "d");
if (crc32("qNLBq",5) == 1133333030) strcat(s, "L");
if (crc32("hASFbPacdArb",12) == 1785618112) strcat(s, "l");
if (crc32("jPCND",5) == 3006940104) strcat(s, "e");
if (crc32("MyKNWecA",8) == 2078013080) strcat(s, "a");
if (crc32("XacTvKJ",7) == 33233819) strcat(s, "g");
if (crc32("uOjLS",5) == 3750338168) strcat(s, "e");
if (crc32("RHTiJQgpIOb",11) == 3937412834) strcat(s, "d");
    return s;
}

char *unserried_adjectives() {
    char *s = calloc(10);
    if (crc32("tBSLxQAiYFFIM",13) == 2997862320) strcat(s, "C");
if (crc32("MTMBEhfhwcRAH",13) == 1254979061) strcat(s, "u");
if (crc32("hqftmMCkmUR",11) == 552808033) strcat(s, "s");
if (crc32("ApjtjOpZ",8) == 1117567876) strcat(s, "n");
if (crc32("vXbFdtTPAWhx",12) == 1349431365) strcat(s, "s");
if (crc32("ZQIvVtTCyqGl",12) == 2311867058) strcat(s, "c");
if (crc32("jllin",5) == 1000898239) strcat(s, "e");
if (crc32("CDUYOXFLLNqNx",13) == 734545625) strcat(s, "r");
if (crc32("nYAwOKtILhVw",12) == 188205086) strcat(s, "S");
if (crc32("jcZeibxO",8) == 1852370678) strcat(s, "r");
if (crc32("xSzFrIoH",8) == 1942283060) strcat(s, "s");
if (crc32("IHOgsukAerSTB",13) == 2914580466) strcat(s, "i");
if (crc32("bJQIDNAKXQkn",12) == 1705603256) strcat(s, "a");
if (crc32("sPpKnbfHUBB",11) == 3616183438) strcat(s, "e");
if (crc32("qwNnjgjh",8) == 1599296928) strcat(s, "C");
if (crc32("jeSNIjtzLTDV",12) == 1257242463) strcat(s, "d");
    return s;
}

char *nonVenetian_adjectives() {
    char *s = calloc(12);
    if (crc32("flCqdsqKh",9) == 3947252680) strcat(s, "n");
if (crc32("MPDmUGcR",8) == 678259337) strcat(s, "K");
if (crc32("hQDqso",6) == 3360444702) strcat(s, "o");
if (crc32("djhihRQBHfwm",12) == 3274214048) strcat(s, "n");
if (crc32("PjXXVWyhjjUO",12) == 3067322760) strcat(s, "V");
if (crc32("vNoSmyTD",8) == 2687639574) strcat(s, "V");
if (crc32("yMgFxPrwXl",10) == 2320603486) strcat(s, "e");
if (crc32("vaZfQhrxRBvx",12) == 998968011) strcat(s, "e");
if (crc32("BKRjl",5) == 1566006453) strcat(s, "g");
if (crc32("lHriErTk",8) == 3091389636) strcat(s, "n");
if (crc32("KVkQcID",7) == 3479265701) strcat(s, "E");
if (crc32("fSCEgUfuTXJq",12) == 4083590107) strcat(s, "e");
if (crc32("GDXjsO",6) == 2808380017) strcat(s, "t");
if (crc32("vnrKUSmDusvJkGD",15) == 3220571793) strcat(s, "A");
if (crc32("uCCLWfAize",10) == 3138630293) strcat(s, "i");
if (crc32("cXhBTefznVTIvPz",15) == 989036137) strcat(s, "M");
if (crc32("ordJpDUmUs",10) == 3181675922) strcat(s, "a");
if (crc32("neqpQL",6) == 2304178611) strcat(s, "n");
    return s;
}

char *nondegenerative_adjectives() {
    char *s = calloc(16);
    if (crc32("KpSUfrTYJ",9) == 2851119366) strcat(s, "u");
if (crc32("KXAFQfw",7) == 1894346310) strcat(s, "n");
if (crc32("puiyhjZVoWba",12) == 3668931747) strcat(s, "r");
if (crc32("OpGJluludxBVEAw",15) == 2829258426) strcat(s, "o");
if (crc32("YFFZETftm",9) == 4132320412) strcat(s, "F");
if (crc32("jJAlIA",6) == 1223378209) strcat(s, "n");
if (crc32("auIGGvL",7) == 3385332690) strcat(s, "k");
if (crc32("lffLRj",6) == 2594277252) strcat(s, "d");
if (crc32("XDMrIqg",7) == 3799240248) strcat(s, "e");
if (crc32("XTjtXF",6) == 1983030816) strcat(s, "g");
if (crc32("cuJzGZWU",8) == 4036912568) strcat(s, "m");
if (crc32("dRDEMqGJs",9) == 3673931077) strcat(s, "e");
if (crc32("qwGIiF",6) == 1749459352) strcat(s, "n");
if (crc32("jpNshESAO",9) == 3498529041) strcat(s, "R");
if (crc32("GqbmKOZNtjvRG",13) == 717849282) strcat(s, "e");
if (crc32("csbWHpkypiGvon",14) == 3149529975) strcat(s, "r");
if (crc32("cxkRAgdTWHmxK",13) == 961186940) strcat(s, "a");
if (crc32("AOnMTc",6) == 112361955) strcat(s, "t");
if (crc32("cwLVcISzigakjk",14) == 506547973) strcat(s, "i");
if (crc32("UkScM",5) == 4071707140) strcat(s, "v");
if (crc32("ARtugu",6) == 4174439589) strcat(s, "v");
if (crc32("SIyrTrTpzoXFQ",13) == 1956185775) strcat(s, "e");
    return s;
}

char *dropleaf_adjectives() {
    char *s = calloc(9);
    if (crc32("QtmqX",5) == 882372527) strcat(s, "d");
if (crc32("HbEbgWuOt",9) == 1954199461) strcat(s, "A");
if (crc32("pIOUMpX",7) == 1307499098) strcat(s, "r");
if (crc32("BWXNiNATQ",9) == 2092546490) strcat(s, "g");
if (crc32("yOLdARLlYzA",11) == 368115810) strcat(s, "o");
if (crc32("MwurUWvhAhJLBEk",15) == 1101153113) strcat(s, "N");
if (crc32("iafkQ",5) == 128259803) strcat(s, "p");
if (crc32("btoqDn",6) == 4039469713) strcat(s, "l");
if (crc32("ZHOfwTsrlOjcGzb",15) == 3719332972) strcat(s, "X");
if (crc32("ZMcCcPcrLzhh",12) == 2074092073) strcat(s, "e");
if (crc32("auMYJ",5) == 3148065102) strcat(s, "a");
if (crc32("EQXusGZvuLRmJRZ",15) == 1282105790) strcat(s, "Z");
if (crc32("OzgAbSI",7) == 1491699873) strcat(s, "f");
    return s;
}

char *nonlixiviated_adjectives() {
    char *s = calloc(14);
    if (crc32("cSEUkrFsbOzE",12) == 4007716871) strcat(s, "L");
if (crc32("femogxBGC",9) == 3838992797) strcat(s, "n");
if (crc32("GfLczx",6) == 728113230) strcat(s, "w");
if (crc32("VgOTKjqzl",9) == 2808875734) strcat(s, "o");
if (crc32("XMBrVCxg",8) == 2241694055) strcat(s, "N");
if (crc32("yjpbyKqbjhL",11) == 2495354482) strcat(s, "n");
if (crc32("kbjWyFy",7) == 6505219) strcat(s, "l");
if (crc32("iNGSlce",7) == 3082684086) strcat(s, "i");
if (crc32("jJgvzKzKFWKn",12) == 2916657242) strcat(s, "x");
if (crc32("PFWiihWgbdiPM",13) == 3098778536) strcat(s, "N");
if (crc32("qXVclnhym",9) == 1165415820) strcat(s, "i");
if (crc32("GOZWWTRQ",8) == 2056373892) strcat(s, "v");
if (crc32("voLDNPDeMWbQA",13) == 3138319702) strcat(s, "z");
if (crc32("qYbrm",5) == 3519834005) strcat(s, "i");
if (crc32("kTFEKvmVGzpIQO",14) == 3182230731) strcat(s, "a");
if (crc32("jByUD",5) == 3386930944) strcat(s, "t");
if (crc32("pzVLlTh",7) == 1633664866) strcat(s, "e");
if (crc32("xrTRO",5) == 3421360575) strcat(s, "d");
    return s;
}

char *approximal_adjectives() {
    char *s = calloc(11);
    if (crc32("NfVjLUeXdwOGdQ",14) == 3955913716) strcat(s, "W");
if (crc32("RTZZOVAaQZgAtS",14) == 4015416807) strcat(s, "a");
if (crc32("VPrhCuoIyNiUUA",14) == 333392107) strcat(s, "p");
if (crc32("PzryB",5) == 3421054483) strcat(s, "p");
if (crc32("whFqoK",6) == 3867167392) strcat(s, "r");
if (crc32("qtoZSdvHRFzzvjJ",15) == 2804247019) strcat(s, "o");
if (crc32("zsOLHdexDvb",11) == 2154639693) strcat(s, "m");
if (crc32("ZewgXxWuHVqkGM",14) == 1784806867) strcat(s, "x");
if (crc32("ScWtW",5) == 1202543227) strcat(s, "i");
if (crc32("WYlBMvQJu",9) == 493180937) strcat(s, "m");
if (crc32("QEGppVbRB",9) == 611023793) strcat(s, "a");
if (crc32("eARYJemLQPzJHva",15) == 2438056612) strcat(s, "l");
    return s;
}

char *superdiabolical_adjectives() {
    char *s = calloc(16);
    if (crc32("rsncyYBkbscMFez",15) == 2339057985) strcat(s, "R");
if (crc32("OMOnWvMkp",9) == 3207484838) strcat(s, "s");
if (crc32("bptMoOqWZfoEAIl",15) == 3001772983) strcat(s, "T");
if (crc32("xOGltyUyz",9) == 2640985643) strcat(s, "u");
if (crc32("bBwFFS",6) == 1143014902) strcat(s, "q");
if (crc32("MlHusOITblpCd",13) == 2348927219) strcat(s, "p");
if (crc32("kiDaU",5) == 1792883488) strcat(s, "r");
if (crc32("kSBxpmUxizpsJ",13) == 3179957997) strcat(s, "e");
if (crc32("LFhzwjEMXtSTkd",14) == 2657218975) strcat(s, "r");
if (crc32("yROQsfzTvQOQ",12) == 2042851649) strcat(s, "F");
if (crc32("filoX",5) == 1348882835) strcat(s, "d");
if (crc32("VCgZl",5) == 2971172781) strcat(s, "i");
if (crc32("jestpgAuFTJAI",13) == 2296824384) strcat(s, "a");
if (crc32("IzjETyBhgOBqUdV",15) == 351540291) strcat(s, "c");
if (crc32("LDfOephy",8) == 1940798760) strcat(s, "b");
if (crc32("RzTyS",5) == 2562867085) strcat(s, "h");
if (crc32("YGMog",5) == 3155404579) strcat(s, "o");
if (crc32("XAxPXOiDnPtoUMi",15) == 1753300463) strcat(s, "I");
if (crc32("UGjQskH",7) == 4132866390) strcat(s, "l");
if (crc32("YvfYAcGJpAChEf",14) == 2297524317) strcat(s, "I");
if (crc32("pSzCKbwY",8) == 455768062) strcat(s, "i");
if (crc32("FmldVY",6) == 752628918) strcat(s, "q");
if (crc32("WzNnMTnQMdIqu",13) == 1630366325) strcat(s, "c");
if (crc32("NGtoELJ",7) == 1216785784) strcat(s, "a");
if (crc32("jHBbGEve",8) == 817024379) strcat(s, "f");
if (crc32("CrRkmUIbsVNO",12) == 2436197976) strcat(s, "l");
    return s;
}

char *unmasterful_adjectives() {
    char *s = calloc(12);
    if (crc32("jRyXDv",6) == 2239169646) strcat(s, "f");
if (crc32("INixpOwAKNv",11) == 418096121) strcat(s, "u");
if (crc32("pFvfOhXVeMsp",12) == 2324412767) strcat(s, "n");
if (crc32("MgVFlLPv",8) == 2473643733) strcat(s, "H");
if (crc32("rMKgPiQX",8) == 2854045201) strcat(s, "m");
if (crc32("RhdWGUizASBndSP",15) == 2171636933) strcat(s, "a");
if (crc32("aNXeEQR",7) == 3522192366) strcat(s, "s");
if (crc32("eITzInZy",8) == 3307175496) strcat(s, "t");
if (crc32("xlEhxBSElqzK",12) == 977328751) strcat(s, "e");
if (crc32("jUVXtaN",7) == 2898205136) strcat(s, "E");
if (crc32("WTlSxwbBs",9) == 2550184065) strcat(s, "r");
if (crc32("kPcZa",5) == 1586418260) strcat(s, "e");
if (crc32("GrRMSvPE",8) == 3915496574) strcat(s, "f");
if (crc32("GzkGJU",6) == 2560133802) strcat(s, "u");
if (crc32("ZaCRBYHde",9) == 4284945782) strcat(s, "l");
    return s;
}

char *unsacred_adjectives() {
    char *s = calloc(9);
    if (crc32("BQSzgFcFVt",10) == 1252032380) strcat(s, "J");
if (crc32("UxhkRFnBdZIX",12) == 916141179) strcat(s, "u");
if (crc32("wGuixilJWyi",11) == 2384937000) strcat(s, "F");
if (crc32("YErCer",6) == 524024793) strcat(s, "n");
if (crc32("aTWDg",5) == 2482744689) strcat(s, "A");
if (crc32("BJJnmdhVmAWeG",13) == 3018888897) strcat(s, "s");
if (crc32("OQKygh",6) == 3816763161) strcat(s, "U");
if (crc32("WjLnozCR",8) == 797774827) strcat(s, "a");
if (crc32("WnCYwMSydXEdv",13) == 1262101605) strcat(s, "v");
if (crc32("xwgfRfuJuLdGQq",14) == 1043174296) strcat(s, "c");
if (crc32("Plyqqc",6) == 1125726786) strcat(s, "s");
if (crc32("GPRLrt",6) == 3379120480) strcat(s, "r");
if (crc32("yPERpyFWwkHg",12) == 3757394852) strcat(s, "N");
if (crc32("umJwRW",6) == 1394258720) strcat(s, "e");
if (crc32("LjTwJJZqaKjNk",13) == 2608066737) strcat(s, "d");
    return s;
}

char *unstacked_adjectives() {
    char *s = calloc(10);
    if (crc32("TJWDBxfsG",9) == 790204284) strcat(s, "u");
if (crc32("OhmeeMxCucAPQVi",15) == 2430673521) strcat(s, "D");
if (crc32("ekNqjB",6) == 773978094) strcat(s, "n");
if (crc32("iJBCeezviyGrU",13) == 1304101317) strcat(s, "s");
if (crc32("BegUw",5) == 490544783) strcat(s, "a");
if (crc32("MHNCWbsHT",9) == 3076126202) strcat(s, "t");
if (crc32("aiRkLmfGbDngTeg",15) == 2512689537) strcat(s, "i");
if (crc32("ZxVQrxdubDOarVI",15) == 710958573) strcat(s, "a");
if (crc32("uFtNYkjeag",10) == 311976635) strcat(s, "c");
if (crc32("lPvgCmncRc",10) == 2051688024) strcat(s, "s");
if (crc32("HXjeoNMXcP",10) == 264494754) strcat(s, "k");
if (crc32("yaUMbTFil",9) == 1204989584) strcat(s, "e");
if (crc32("pKxpvZbbZxfKDE",14) == 3148804145) strcat(s, "d");
    return s;
}

char *reservable_adjectives() {
    char *s = calloc(11);
    if (crc32("aiPjHMdgxszYAbc",15) == 3160593528) strcat(s, "r");
if (crc32("NXlWTNlqcqOxBZ",14) == 336734864) strcat(s, "O");
if (crc32("jANGtKNMArFtb",13) == 777068731) strcat(s, "e");
if (crc32("wgOEdOLfPcbaTH",14) == 737422798) strcat(s, "s");
if (crc32("vrRAoj",6) == 1933360474) strcat(s, "m");
if (crc32("BWkoNpDiqcX",11) == 3817768893) strcat(s, "e");
if (crc32("jEysNB",6) == 1041637774) strcat(s, "r");
if (crc32("dekzFfyNX",9) == 3306271173) strcat(s, "v");
if (crc32("PtOYphDcS",9) == 1282994011) strcat(s, "m");
if (crc32("rEVUD",5) == 934711847) strcat(s, "a");
if (crc32("OXewrURlWPVjN",13) == 2556568507) strcat(s, "E");
if (crc32("HFKSSWBY",8) == 3256767848) strcat(s, "b");
if (crc32("rLfAroYHAXJ",11) == 4291083885) strcat(s, "l");
if (crc32("vuVJOBz",7) == 21211628) strcat(s, "n");
if (crc32("pORyZZjXDaalCK",14) == 617336904) strcat(s, "e");
    return s;
}

char *ringed_adjectives() {
    char *s = calloc(7);
    if (crc32("PmpbVJjg",8) == 3977906136) strcat(s, "r");
if (crc32("SUCur",5) == 956032064) strcat(s, "J");
if (crc32("qRqLizOvcn",10) == 2931617645) strcat(s, "i");
if (crc32("OYCMSOUnRKFe",12) == 3106777267) strcat(s, "c");
if (crc32("zVreTJDm",8) == 2449202508) strcat(s, "n");
if (crc32("QnkHAxkrOrG",11) == 1278199660) strcat(s, "C");
if (crc32("mAhwjNvg",8) == 3888723968) strcat(s, "g");
if (crc32("HPDKWGR",7) == 3237552350) strcat(s, "y");
if (crc32("LDIUXWf",7) == 280640855) strcat(s, "e");
if (crc32("wrutYfebpASJBf",14) == 878961967) strcat(s, "d");
    return s;
}

char *ahistoric_adjectives() {
    char *s = calloc(10);
    if (crc32("rxZDqHQzGFfxmg",14) == 2768350553) strcat(s, "a");
if (crc32("ZOLZa",5) == 3920960393) strcat(s, "O");
if (crc32("ApzpcMcTjGRkq",13) == 1084518403) strcat(s, "h");
if (crc32("DVAAkBMYnPJm",12) == 908746242) strcat(s, "i");
if (crc32("inYfuTcKPYJkW",13) == 3999143013) strcat(s, "s");
if (crc32("GzZUz",5) == 1044687337) strcat(s, "s");
if (crc32("JfJfIJqBVAOI",12) == 103736660) strcat(s, "g");
if (crc32("ioELpIioCtsWrdI",15) == 2642882450) strcat(s, "t");
if (crc32("GrQXJWQclVgbVTP",15) == 2201679651) strcat(s, "v");
if (crc32("lPUzErkjaHlXs",13) == 356193323) strcat(s, "o");
if (crc32("DObpxex",7) == 47813390) strcat(s, "F");
if (crc32("cILhnbI",7) == 1987489341) strcat(s, "r");
if (crc32("FYIMjCvxw",9) == 1080374378) strcat(s, "i");
if (crc32("OzKSV",5) == 424245305) strcat(s, "D");
if (crc32("QKKjItuvJB",10) == 141953822) strcat(s, "c");
    return s;
}

char *sinistrogyric_adjectives() {
    char *s = calloc(14);
    if (crc32("UIkNUe",6) == 3562401489) strcat(s, "s");
if (crc32("spcdBenOrVGVFv",14) == 957871197) strcat(s, "i");
if (crc32("SXGObfeHuSVM",12) == 327546429) strcat(s, "n");
if (crc32("GtOtvbljQ",9) == 3923309114) strcat(s, "q");
if (crc32("ASedtyMyBQpCgNz",15) == 3906149844) strcat(s, "i");
if (crc32("UZpsvNaP",8) == 1774999412) strcat(s, "s");
if (crc32("XBsVfosMx",9) == 2078632187) strcat(s, "t");
if (crc32("IOOgIGQDV",9) == 2640435078) strcat(s, "i");
if (crc32("keVkHRgWdPSzooa",15) == 2522785312) strcat(s, "r");
if (crc32("avdfEYBugAF",11) == 487469381) strcat(s, "g");
if (crc32("aKkbfFL",7) == 1072450046) strcat(s, "o");
if (crc32("JzEfadxWXXfu",12) == 2613240368) strcat(s, "g");
if (crc32("mygapIQZTC",10) == 79702816) strcat(s, "E");
if (crc32("VlgGdwM",7) == 2823010027) strcat(s, "y");
if (crc32("UgQRmTywS",9) == 1630068644) strcat(s, "w");
if (crc32("IbBBqQ",6) == 304889575) strcat(s, "r");
if (crc32("TFxmyCXUQzrdctX",15) == 325774193) strcat(s, "r");
if (crc32("JSeyyEX",7) == 58108258) strcat(s, "i");
if (crc32("TfWHJyJ",7) == 3274566098) strcat(s, "p");
if (crc32("FQagPhLiEw",10) == 925951076) strcat(s, "c");
    return s;
}

char *godless_adjectives() {
    char *s = calloc(8);
    if (crc32("cIFOpvRmYvx",11) == 3209122105) strcat(s, "i");
if (crc32("aKPsUsyiFvJRPX",14) == 297622772) strcat(s, "g");
if (crc32("PsTOvYL",7) == 4035720072) strcat(s, "t");
if (crc32("qxfCHD",6) == 2644381451) strcat(s, "o");
if (crc32("owhuPHsocitjJg",14) == 226958413) strcat(s, "H");
if (crc32("SvjVJSOvgfd",11) == 3791575582) strcat(s, "d");
if (crc32("GXNhW",5) == 6803771) strcat(s, "l");
if (crc32("zhILoaMNYiEgiRA",15) == 2310158661) strcat(s, "e");
if (crc32("sqrsHoaFkc",10) == 2005882407) strcat(s, "s");
if (crc32("LXQBSBDEdkwx",12) == 60118680) strcat(s, "E");
if (crc32("nfIMlAGCURU",11) == 1743708321) strcat(s, "s");
    return s;
}

char *unfurrowed_adjectives() {
    char *s = calloc(11);
    if (crc32("ynQVIt",6) == 1033715332) strcat(s, "q");
if (crc32("dUPcHnYXmBAQ",12) == 3369959892) strcat(s, "u");
if (crc32("dDLfAcJVNqkPTpD",15) == 2527154972) strcat(s, "n");
if (crc32("wRqywSCAFc",10) == 1043166912) strcat(s, "h");
if (crc32("myyIkUzLLJn",11) == 4261898509) strcat(s, "f");
if (crc32("GGnLbYP",7) == 3276585931) strcat(s, "t");
if (crc32("hawmeXxmGNd",11) == 148144942) strcat(s, "u");
if (crc32("CDQVDqUw",8) == 2124760111) strcat(s, "Y");
if (crc32("SRaooFYXEI",10) == 4094152150) strcat(s, "r");
if (crc32("eMvUqmjHrhGd",12) == 738751978) strcat(s, "r");
if (crc32("VEFsi",5) == 2580572098) strcat(s, "o");
if (crc32("gRBUvDlwCHMp",12) == 2835523061) strcat(s, "w");
if (crc32("jNhdRqgLcEA",11) == 2721386659) strcat(s, "e");
if (crc32("mGEFtujKmOaGeaD",15) == 239892536) strcat(s, "d");
if (crc32("PhBROxFYBemRlD",14) == 779127669) strcat(s, "d");
    return s;
}

char *reductional_adjectives() {
    char *s = calloc(12);
    if (crc32("ekvBhihqRI",10) == 4017145630) strcat(s, "r");
if (crc32("oGIqmTummEATV",13) == 937586566) strcat(s, "L");
if (crc32("PCYWKNDvRtIPStN",15) == 820976158) strcat(s, "e");
if (crc32("LRgFYsVgtysA",12) == 742744244) strcat(s, "d");
if (crc32("rNSXAwdvycCxeU",14) == 144509773) strcat(s, "u");
if (crc32("NsABLEv",7) == 4005497325) strcat(s, "P");
if (crc32("pSdIyCoMX",9) == 2216821234) strcat(s, "c");
if (crc32("DTNWZRhPAKZwc",13) == 705403970) strcat(s, "t");
if (crc32("cdzRIx",6) == 1204796094) strcat(s, "i");
if (crc32("vOlVMAPbWTh",11) == 2266401212) strcat(s, "o");
if (crc32("IptVcBfQFjQ",11) == 131352415) strcat(s, "Q");
if (crc32("PFuIVgHv",8) == 1005278841) strcat(s, "n");
if (crc32("PxspKhl",7) == 2837071706) strcat(s, "V");
if (crc32("xXZAantZhNd",11) == 1389498525) strcat(s, "a");
if (crc32("EVIGWJ",6) == 671510912) strcat(s, "C");
if (crc32("NVoUQltXokHz",12) == 3361238669) strcat(s, "l");
    return s;
}

char *globoid_adjectives() {
    char *s = calloc(8);
    if (crc32("qtRWaJuiGLXJA",13) == 73236573) strcat(s, "g");
if (crc32("wtkznCIVYH",10) == 792162687) strcat(s, "l");
if (crc32("SqnLCX",6) == 3824624401) strcat(s, "o");
if (crc32("syzBqOAlUjoWrkC",15) == 1830526087) strcat(s, "b");
if (crc32("RqnlyMhKZpcCcT",14) == 2798433587) strcat(s, "o");
if (crc32("LacUDNrLZwC",11) == 3365810024) strcat(s, "i");
if (crc32("pmIFV",5) == 1660045748) strcat(s, "f");
if (crc32("hvuOuITEMwo",11) == 35753426) strcat(s, "d");
    return s;
}

char *vociferant_adjectives() {
    char *s = calloc(11);
    if (crc32("jZEftjBpi",9) == 2391966783) strcat(s, "w");
if (crc32("UwjcvPbkC",9) == 1190084996) strcat(s, "v");
if (crc32("GzbyZTDi",8) == 3504508224) strcat(s, "o");
if (crc32("YlPgtJ",6) == 3050568428) strcat(s, "D");
if (crc32("IaMUlijxL",9) == 918953564) strcat(s, "c");
if (crc32("IjRummcTm",9) == 2767481561) strcat(s, "G");
if (crc32("kfHuWl",6) == 2028462174) strcat(s, "i");
if (crc32("vKeeVGBOPbCmpRd",15) == 2486762472) strcat(s, "f");
if (crc32("qKMcDKiM",8) == 509434164) strcat(s, "B");
if (crc32("moAhgiTfi",9) == 1165341653) strcat(s, "e");
if (crc32("lXDrxgTwwec",11) == 2508907609) strcat(s, "a");
if (crc32("gmOZQAgN",8) == 1626417914) strcat(s, "r");
if (crc32("mTfdx",5) == 4042931243) strcat(s, "a");
if (crc32("OQxlr",5) == 1116822801) strcat(s, "n");
if (crc32("STrscFlv",8) == 3156445440) strcat(s, "t");
    return s;
}

char *undivertible_adjectives() {
    char *s = calloc(13);
    if (crc32("lVzTPD",6) == 1545294627) strcat(s, "x");
if (crc32("hxQowcMWKTPBLDI",15) == 2868375423) strcat(s, "u");
if (crc32("AEWlCKL",7) == 3313355232) strcat(s, "n");
if (crc32("AfMzMT",6) == 2055025476) strcat(s, "d");
if (crc32("zQkEagBst",9) == 4008409732) strcat(s, "i");
if (crc32("IzVKTQkMLtb",11) == 910054939) strcat(s, "m");
if (crc32("hrpjqlqTzOaNPs",14) == 3425239714) strcat(s, "v");
if (crc32("JimhzOlj",8) == 3306294938) strcat(s, "e");
if (crc32("iuhChaI",7) == 2145377577) strcat(s, "N");
if (crc32("KMxWWuINSttgt",13) == 1196757751) strcat(s, "r");
if (crc32("iySjsCziKTTu",12) == 1075370242) strcat(s, "X");
if (crc32("RxEmWWjhbXqcH",13) == 3422335458) strcat(s, "t");
if (crc32("BTnhxEjvUIEF",12) == 1268589459) strcat(s, "j");
if (crc32("TbQnYr",6) == 564508559) strcat(s, "i");
if (crc32("JcDEjiXMCnn",11) == 3309019466) strcat(s, "b");
if (crc32("SKmUrWrDZhX",11) == 147618632) strcat(s, "l");
if (crc32("hwVVM",5) == 355845705) strcat(s, "e");
    return s;
}

char *lenitic_adjectives() {
    char *s = calloc(8);
    if (crc32("TaCjQUfNRtmVo",13) == 2195361064) strcat(s, "L");
if (crc32("poMnU",5) == 3297250630) strcat(s, "l");
if (crc32("MrJBZwAayGiaF",13) == 1672326317) strcat(s, "o");
if (crc32("TuhBofki",8) == 1374838928) strcat(s, "e");
if (crc32("xmmVsDOpQRbfkjO",15) == 1210657137) strcat(s, "u");
if (crc32("TAzVJQPbaetdRH",14) == 3183272266) strcat(s, "n");
if (crc32("hFnnWQhPdIsFbpB",15) == 3681278128) strcat(s, "A");
if (crc32("kRQSh",5) == 4131771666) strcat(s, "i");
if (crc32("nTCLAj",6) == 4203467767) strcat(s, "t");
if (crc32("kCoxHCzbVcCRbAI",15) == 1954714047) strcat(s, "j");
if (crc32("gxvprLfvc",9) == 2523961116) strcat(s, "i");
if (crc32("LUNuUPQXUJXCipq",15) == 1110901033) strcat(s, "c");
    return s;
}

char *proUnitarian_adjectives() {
    char *s = calloc(13);
    if (crc32("AtvAwuvcl",9) == 1952722648) strcat(s, "m");
if (crc32("SqVBwg",6) == 3518627999) strcat(s, "p");
if (crc32("gUIiDaWT",8) == 1544392018) strcat(s, "i");
if (crc32("CNOhGeXBzEQwGgr",15) == 1563367309) strcat(s, "r");
if (crc32("FMrmhbUxpy",10) == 2196647294) strcat(s, "Z");
if (crc32("gROeJkgnIIdP",12) == 2402996624) strcat(s, "o");
if (crc32("qFuPO",5) == 2987233901) strcat(s, "U");
if (crc32("njTrpk",6) == 3069920648) strcat(s, "n");
if (crc32("xDvRUxozSZbw",12) == 826869688) strcat(s, "i");
if (crc32("mCLXSLfNvzZChhs",15) == 1342795819) strcat(s, "q");
if (crc32("uHyXlSMEnRTo",12) == 1775670079) strcat(s, "t");
if (crc32("JenEvdiWdPC",11) == 1508314612) strcat(s, "a");
if (crc32("SjdQYV",6) == 1601883738) strcat(s, "a");
if (crc32("bJHwUa",6) == 349878722) strcat(s, "r");
if (crc32("pVsvvsdMFn",10) == 449448104) strcat(s, "i");
if (crc32("SlEUOoXFzpPAufe",15) == 2147628690) strcat(s, "M");
if (crc32("WcEwl",5) == 933835074) strcat(s, "a");
if (crc32("YIEzhmiPOBsJJ",13) == 94518331) strcat(s, "D");
if (crc32("TkQpVoSlkQo",11) == 3461713111) strcat(s, "n");
    return s;
}

char *synaesthetic_adjectives() {
    char *s = calloc(13);
    if (crc32("NByTO",5) == 1936201229) strcat(s, "s");
if (crc32("PaWdfeTBDCrIk",13) == 2525295859) strcat(s, "y");
if (crc32("MshwWQa",7) == 121923669) strcat(s, "M");
if (crc32("IUDxJeMvk",9) == 456637820) strcat(s, "n");
if (crc32("lZCtSiEb",8) == 4263441632) strcat(s, "D");
if (crc32("KcLWwCkITmoQsqt",15) == 706519241) strcat(s, "a");
if (crc32("YIvQvCeGCujxtq",14) == 3481279286) strcat(s, "e");
if (crc32("oqGmjEPdKkr",11) == 1176261065) strcat(s, "O");
if (crc32("SAuejaQze",9) == 2078700973) strcat(s, "s");
if (crc32("EUNHGAiQjGQxr",13) == 1706551875) strcat(s, "t");
if (crc32("eprCNFEtqBbeP",13) == 1495168973) strcat(s, "h");
if (crc32("qHEkKrZwIEtdRNI",15) == 2635625978) strcat(s, "e");
if (crc32("wiKnQMiDFrmv",12) == 1283628302) strcat(s, "t");
if (crc32("vdlHmgagMRej",12) == 2698026777) strcat(s, "i");
if (crc32("MkxuVmhUKEuMg",13) == 2961964715) strcat(s, "h");
if (crc32("RxhQTR",6) == 4051210418) strcat(s, "c");
    return s;
}

char *tabu_adjectives() {
    char *s = calloc(5);
    if (crc32("UUyuWumuyqE",11) == 1854890386) strcat(s, "t");
if (crc32("pIaqzJvrxBDSWE",14) == 531455153) strcat(s, "g");
if (crc32("GyEiOoKEFBXTIY",14) == 1751839391) strcat(s, "a");
if (crc32("txofWsCRmEB",11) == 973013933) strcat(s, "D");
if (crc32("vBclWAt",7) == 685713274) strcat(s, "b");
if (crc32("BHMfMehiRXOdiB",14) == 2246076910) strcat(s, "l");
if (crc32("AlcqzIlwj",9) == 187598056) strcat(s, "u");
    return s;
}

char *unconducing_adjectives() {
    char *s = calloc(12);
    if (crc32("JEQfLFPnwyhpZ",13) == 338611757) strcat(s, "O");
if (crc32("eoagea",6) == 514087993) strcat(s, "u");
if (crc32("IyXChGrFzE",10) == 3460474545) strcat(s, "X");
if (crc32("IVZNbg",6) == 1953460926) strcat(s, "n");
if (crc32("MdTXfyr",7) == 3830689264) strcat(s, "c");
if (crc32("ifGEoM",6) == 315693110) strcat(s, "o");
if (crc32("IbUQpk",6) == 3487717122) strcat(s, "A");
if (crc32("PpVoCK",6) == 3542683942) strcat(s, "n");
if (crc32("FFKOz",5) == 336655580) strcat(s, "d");
if (crc32("hDcDkVAJWLt",11) == 978157235) strcat(s, "s");
if (crc32("qAahMOBChRmR",12) == 2481379963) strcat(s, "u");
if (crc32("asZPhGa",7) == 2572633617) strcat(s, "I");
if (crc32("oeqEQgZl",8) == 3748866734) strcat(s, "c");
if (crc32("ZNchpv",6) == 802934922) strcat(s, "m");
if (crc32("UctMUXN",7) == 2394748389) strcat(s, "i");
if (crc32("KGKFLpsArhNX",12) == 4165083130) strcat(s, "n");
if (crc32("MMBBcUKjOJYhyci",15) == 1803874468) strcat(s, "g");
    return s;
}

char *burthensome_adjectives() {
    char *s = calloc(12);
    if (crc32("QHFPUD",6) == 3175641179) strcat(s, "K");
if (crc32("zXQOEsPMc",9) == 1789007997) strcat(s, "b");
if (crc32("tkSgTvkxi",9) == 3163893387) strcat(s, "Y");
if (crc32("XfXyJZUadbohcPf",15) == 1026381525) strcat(s, "u");
if (crc32("HxrDwVY",7) == 1706936908) strcat(s, "W");
if (crc32("mBolUtnJ",8) == 2590308395) strcat(s, "r");
if (crc32("ZyDWcdopFITTkAU",15) == 3656760725) strcat(s, "Z");
if (crc32("sfnWEVRk",8) == 2168467519) strcat(s, "t");
if (crc32("hEeURuzRmOdysUU",15) == 2396434915) strcat(s, "h");
if (crc32("FCOTSWQi",8) == 3945498565) strcat(s, "e");
if (crc32("MWuVqc",6) == 1524063077) strcat(s, "q");
if (crc32("plLTtV",6) == 2500730868) strcat(s, "n");
if (crc32("LMQaYxNyLk",10) == 469516203) strcat(s, "m");
if (crc32("GvPSgbfNxRZyTw",14) == 996385892) strcat(s, "s");
if (crc32("YBnWUW",6) == 3213065204) strcat(s, "Z");
if (crc32("ZeVFV",5) == 4100155654) strcat(s, "o");
if (crc32("HHyPsm",6) == 4031299707) strcat(s, "J");
if (crc32("JsEHI",5) == 3961179029) strcat(s, "m");
if (crc32("tOwoffDsf",9) == 3036275818) strcat(s, "e");
    return s;
}

char *preNorse_adjectives() {
    char *s = calloc(9);
    if (crc32("gRRBEoTvodgb",12) == 316509263) strcat(s, "p");
if (crc32("tFJjawvoXTyqj",13) == 1337806195) strcat(s, "r");
if (crc32("jbDemAGtxwaY",12) == 374668450) strcat(s, "e");
if (crc32("NzPaIMSc",8) == 511757218) strcat(s, "L");
if (crc32("StwuiWKzvQLyex",14) == 1017880467) strcat(s, "N");
if (crc32("EILCsDC",7) == 2159931555) strcat(s, "r");
if (crc32("iBRQPxhNaT",10) == 4259801377) strcat(s, "o");
if (crc32("cOstNTSF",8) == 381028241) strcat(s, "r");
if (crc32("AJXZIrluSZwoXxv",15) == 374024849) strcat(s, "B");
if (crc32("KHfsdGGRWJuOx",13) == 568498638) strcat(s, "s");
if (crc32("KMOrUwKDUmZxB",13) == 299712343) strcat(s, "h");
if (crc32("wObHJdKnxP",10) == 1405011202) strcat(s, "e");
    return s;
}

char *semireactionary_adjectives() {
    char *s = calloc(16);
    if (crc32("DYNWCI",6) == 3596924586) strcat(s, "s");
if (crc32("YXwtlJ",6) == 794160548) strcat(s, "y");
if (crc32("jxoGFgTWJJpyrt",14) == 2421553654) strcat(s, "e");
if (crc32("xAkRYA",6) == 3667739185) strcat(s, "m");
if (crc32("SpouHMLTTwubyL",14) == 2756094229) strcat(s, "i");
if (crc32("yEHTfptwIoUHYwG",15) == 2452567247) strcat(s, "r");
if (crc32("dohDK",5) == 4194978116) strcat(s, "e");
if (crc32("zGgxGTRipAvdvC",14) == 231664443) strcat(s, "I");
if (crc32("bIvfMNN",7) == 1175548969) strcat(s, "a");
if (crc32("BAdXKUJgMfUqJa",14) == 1810528700) strcat(s, "Y");
if (crc32("GHASbQ",6) == 3454619401) strcat(s, "c");
if (crc32("tQvMeruwmUYiZA",14) == 4030637767) strcat(s, "t");
if (crc32("UUHNeLNYaBRRT",13) == 444529337) strcat(s, "i");
if (crc32("pGPjsi",6) == 2376005123) strcat(s, "k");
if (crc32("KSBzcV",6) == 256728962) strcat(s, "o");
if (crc32("lQLyLdJ",7) == 2416096946) strcat(s, "c");
if (crc32("ckpjCvZDHglWoho",15) == 2585613642) strcat(s, "n");
if (crc32("xSghihLTDFK",11) == 4292237919) strcat(s, "x");
if (crc32("LhSIT",5) == 2264165617) strcat(s, "a");
if (crc32("JXefNuDCXNJxq",13) == 2238357880) strcat(s, "h");
if (crc32("XPLGlKW",7) == 3176645960) strcat(s, "r");
if (crc32("yeIFjDhELlWpQ",13) == 2302736473) strcat(s, "y");
    return s;
}

char *unparliamentary_adjectives() {
    char *s = calloc(16);
    if (crc32("hCwHg",5) == 2188266839) strcat(s, "y");
if (crc32("CqTtw",5) == 3832925308) strcat(s, "u");
if (crc32("yTjJjliXYDoJ",12) == 410465316) strcat(s, "n");
if (crc32("cfoPqMRIzUWmAHA",15) == 1182330443) strcat(s, "T");
if (crc32("pEddQ",5) == 3239646176) strcat(s, "p");
if (crc32("kqfZulglmXnC",12) == 2305326870) strcat(s, "N");
if (crc32("HlSDYHFIDEG",11) == 1544800328) strcat(s, "a");
if (crc32("iivlTqGgoKGCH",13) == 118562515) strcat(s, "V");
if (crc32("GcQBRcQVUj",10) == 1592123701) strcat(s, "r");
if (crc32("mMHvwfblw",9) == 1256668121) strcat(s, "l");
if (crc32("sfkbpLW",7) == 482225237) strcat(s, "i");
if (crc32("EQKSczwYqBET",12) == 862817675) strcat(s, "a");
if (crc32("kEoLfrQjkOhiINC",15) == 1129045668) strcat(s, "Z");
if (crc32("PLryKpSLKsJaxE",14) == 3580035746) strcat(s, "m");
if (crc32("WfgheuzDUMNJa",13) == 670677729) strcat(s, "i");
if (crc32("QAOeJEZ",7) == 1898719137) strcat(s, "e");
if (crc32("PaKGZ",5) == 904047545) strcat(s, "n");
if (crc32("ewUukkNE",8) == 2038360767) strcat(s, "t");
if (crc32("dYHtdVG",7) == 488026966) strcat(s, "y");
if (crc32("JGuZFHq",7) == 2440903217) strcat(s, "a");
if (crc32("racMjyVr",8) == 3586408867) strcat(s, "r");
if (crc32("GVhskbRFUyDOAFo",15) == 1925682545) strcat(s, "y");
    return s;
}

char *selfstabilizing_adjectives() {
    char *s = calloc(16);
    if (crc32("SELdw",5) == 2737558673) strcat(s, "s");
if (crc32("krVAwhmKyTYH",12) == 1317743435) strcat(s, "h");
if (crc32("riOaXajIziIQqk",14) == 2830104750) strcat(s, "e");
if (crc32("AUnQhfsh",8) == 868677754) strcat(s, "l");
if (crc32("doyeHil",7) == 1841278573) strcat(s, "f");
if (crc32("czRRlORwqdB",11) == 3257851665) strcat(s, "s");
if (crc32("TkNUSjnDFXnKGm",14) == 2409686992) strcat(s, "v");
if (crc32("QHwMGSVSRvsVZ",13) == 3346033149) strcat(s, "t");
if (crc32("kYylFRDD",8) == 1096102476) strcat(s, "g");
if (crc32("KjsnldFzC",9) == 2987334567) strcat(s, "a");
if (crc32("krfvaAlsAPu",11) == 2290721210) strcat(s, "b");
if (crc32("WiekwneaHMKF",12) == 2474325197) strcat(s, "s");
if (crc32("aAmCV",5) == 1485514444) strcat(s, "i");
if (crc32("OSHbYtUMz",9) == 1081960018) strcat(s, "l");
if (crc32("qTWzWZA",7) == 3252506922) strcat(s, "u");
if (crc32("nnnRBmwmB",9) == 3745910049) strcat(s, "i");
if (crc32("vhtYnA",6) == 3094242856) strcat(s, "z");
if (crc32("CimEZNYqofN",11) == 1890701519) strcat(s, "i");
if (crc32("CSrzfL",6) == 713801771) strcat(s, "C");
if (crc32("FOIwp",5) == 2648062685) strcat(s, "n");
if (crc32("oistnqKJsL",10) == 3044160974) strcat(s, "g");
    return s;
}

char *nonreconcilable_adjectives() {
    char *s = calloc(16);
    if (crc32("YNgnmYoxvebJ",12) == 4119497099) strcat(s, "n");
if (crc32("YlCbZD",6) == 1352397707) strcat(s, "I");
if (crc32("jSPWgewUHu",10) == 498554524) strcat(s, "o");
if (crc32("oGzyfq",6) == 3920889561) strcat(s, "n");
if (crc32("dmmNenelSSu",11) == 721013657) strcat(s, "r");
if (crc32("rhexMFOnepuj",12) == 3480194302) strcat(s, "e");
if (crc32("MmMLxPyzzdgNKFp",15) == 3350108137) strcat(s, "w");
if (crc32("xRyfsARJms",10) == 3971662667) strcat(s, "c");
if (crc32("EoDEfvWso",9) == 2094807328) strcat(s, "o");
if (crc32("FsGGf",5) == 4134190190) strcat(s, "d");
if (crc32("AMFUKrdv",8) == 799848897) strcat(s, "n");
if (crc32("gpvnMQwtnDnJ",12) == 1520024368) strcat(s, "c");
if (crc32("yJNogqNiRLF",11) == 2948886045) strcat(s, "T");
if (crc32("bMOEDOQB",8) == 3907996328) strcat(s, "i");
if (crc32("ISBomn",6) == 1093998889) strcat(s, "c");
if (crc32("rlVDiZOJmzcriW",14) == 431157935) strcat(s, "l");
if (crc32("LlBpZ",5) == 4249784924) strcat(s, "a");
if (crc32("KkAbfvDIs",9) == 2057159485) strcat(s, "x");
if (crc32("sYVlbgQqwaME",12) == 109873296) strcat(s, "b");
if (crc32("uSfpnoIzUU",10) == 1040870815) strcat(s, "P");
if (crc32("JLESFlgkztFfW",13) == 2879240114) strcat(s, "l");
if (crc32("FnsMnkfXH",9) == 1558407610) strcat(s, "Q");
if (crc32("ErjUfJmFEsgHt",13) == 3849088888) strcat(s, "e");
    return s;
}

char *overable_adjectives() {
    char *s = calloc(9);
    if (crc32("FgRAfWQFue",10) == 2180712391) strcat(s, "o");
if (crc32("VhPcvsVXZAgYLL",14) == 4039470352) strcat(s, "J");
if (crc32("KwjtyMFMnHEpDun",15) == 3805978665) strcat(s, "v");
if (crc32("cQOSUvqoEnZXmof",15) == 2907505769) strcat(s, "e");
if (crc32("yUNSVHYuFQyyH",13) == 2685141776) strcat(s, "D");
if (crc32("TiaVszHle",9) == 3253511196) strcat(s, "r");
if (crc32("ULHsahPar",9) == 2154668186) strcat(s, "Y");
if (crc32("rQvHqGkhiL",10) == 585082397) strcat(s, "a");
if (crc32("tDsdhXOIGUm",11) == 3730888678) strcat(s, "g");
if (crc32("DvbbnUMDgXPLEf",14) == 748254837) strcat(s, "b");
if (crc32("PNYEdhYUsfhOIbp",15) == 38934240) strcat(s, "V");
if (crc32("ILIugcBvftZh",12) == 3358334947) strcat(s, "l");
if (crc32("hMQrcmVV",8) == 1206070682) strcat(s, "G");
if (crc32("JgVwkKRTcBxOZG",14) == 1363230411) strcat(s, "e");
    return s;
}

char *pencillike_adjectives() {
    char *s = calloc(11);
    if (crc32("iEdrymol",8) == 1553673658) strcat(s, "p");
if (crc32("AsPxCHrF",8) == 1266280155) strcat(s, "p");
if (crc32("pshuF",5) == 3444173614) strcat(s, "e");
if (crc32("HcHMYa",6) == 1724225138) strcat(s, "X");
if (crc32("KRDuXoXGQtXRG",13) == 3524460936) strcat(s, "n");
if (crc32("KneeA",5) == 1706424666) strcat(s, "c");
if (crc32("atMbVJuH",8) == 1682391827) strcat(s, "F");
if (crc32("AAqPRYn",7) == 450948667) strcat(s, "i");
if (crc32("uuEpzhc",7) == 2735142894) strcat(s, "l");
if (crc32("IxmRWqgsMAY",11) == 1993456354) strcat(s, "k");
if (crc32("kNPTZxHHh",9) == 1770706776) strcat(s, "l");
if (crc32("vjHhwTiqwcRewwM",15) == 3506532291) strcat(s, "e");
if (crc32("rEWctsnanLen",12) == 1498549979) strcat(s, "i");
if (crc32("DdEwXetfU",9) == 817621925) strcat(s, "l");
if (crc32("kpxHqsDGdhtYBi",14) == 1368362814) strcat(s, "k");
if (crc32("YjBakRz",7) == 1597523804) strcat(s, "e");
    return s;
}

char *misrhymed_adjectives() {
    char *s = calloc(10);
    if (crc32("TeTDvqLLw",9) == 1867959712) strcat(s, "T");
if (crc32("gxdgqLEPXXe",11) == 1759083169) strcat(s, "m");
if (crc32("KwDlKY",6) == 3408848227) strcat(s, "i");
if (crc32("eCjtZfhjWoGU",12) == 1170806604) strcat(s, "s");
if (crc32("iefQajk",7) == 2721365770) strcat(s, "W");
if (crc32("RGYNSGJ",7) == 846757413) strcat(s, "r");
if (crc32("zBYFmm",6) == 403324280) strcat(s, "h");
if (crc32("ygfnqsmzd",9) == 1381891646) strcat(s, "u");
if (crc32("sskfsmUdEmDx",12) == 2550060764) strcat(s, "y");
if (crc32("GGAMMfcAcD",10) == 1498120083) strcat(s, "k");
if (crc32("LCNca",5) == 3705765094) strcat(s, "m");
if (crc32("DdSyH",5) == 4135952804) strcat(s, "C");
if (crc32("WehASujknRp",11) == 3824586694) strcat(s, "e");
if (crc32("hLfVUfkQyxk",11) == 3985850349) strcat(s, "d");
    return s;
}

char *unbrandied_adjectives() {
    char *s = calloc(11);
    if (crc32("wRyxXSomoTeOmc",14) == 2409427670) strcat(s, "u");
if (crc32("DtHQhHesEUpNGMK",15) == 836765832) strcat(s, "a");
if (crc32("yrSSXu",6) == 4222757967) strcat(s, "n");
if (crc32("HIDqWXttABkBBBI",15) == 1086588927) strcat(s, "b");
if (crc32("mkANOktGAZRhyh",14) == 412927280) strcat(s, "r");
if (crc32("jeMdHICwkRLIQ",13) == 1395138883) strcat(s, "B");
if (crc32("PIKtjQLYs",9) == 267409246) strcat(s, "a");
if (crc32("NhHPaOOSWJY",11) == 4246301518) strcat(s, "s");
if (crc32("kRRTbsgXOOyIphr",15) == 1771939888) strcat(s, "n");
if (crc32("bsMNSJ",6) == 1583944670) strcat(s, "d");
if (crc32("cdMGleDIrHyaS",13) == 1983914315) strcat(s, "Z");
if (crc32("VfQpud",6) == 1118888129) strcat(s, "i");
if (crc32("xBqxpgQ",7) == 140730123) strcat(s, "e");
if (crc32("oobRtfA",7) == 4198678610) strcat(s, "d");
    return s;
}

char *untriturated_adjectives() {
    char *s = calloc(13);
    if (crc32("uhdoNPysc",9) == 2117033153) strcat(s, "u");
if (crc32("nsKOFQ",6) == 638798394) strcat(s, "W");
if (crc32("JPQegmhOgrxHmPb",15) == 3049309269) strcat(s, "n");
if (crc32("ayawoufcNGEMwe",14) == 911596920) strcat(s, "B");
if (crc32("ceCcrXPyKkowI",13) == 3243843147) strcat(s, "t");
if (crc32("PiwVnvQ",7) == 328621506) strcat(s, "r");
if (crc32("LCuNhYf",7) == 674069709) strcat(s, "O");
if (crc32("YFSpZwtIRVUlg",13) == 3840236437) strcat(s, "i");
if (crc32("CwawVWbov",9) == 1841068178) strcat(s, "t");
if (crc32("cHAdtGNQaFv",11) == 730131961) strcat(s, "v");
if (crc32("duLZLwr",7) == 658307825) strcat(s, "u");
if (crc32("OReGkhUOfFxlOAA",15) == 1405548484) strcat(s, "v");
if (crc32("uLOglZvkC",9) == 1148173514) strcat(s, "r");
if (crc32("qRVcKvJPNH",10) == 4291804571) strcat(s, "s");
if (crc32("jMSTVAqRVZHJxNp",15) == 2333321266) strcat(s, "a");
if (crc32("mtiYYwTEjSt",11) == 1309667163) strcat(s, "R");
if (crc32("vcdLTibkj",9) == 3610730414) strcat(s, "t");
if (crc32("LFwJxEpX",8) == 54626194) strcat(s, "I");
if (crc32("extBQlyhN",9) == 3323753752) strcat(s, "e");
if (crc32("OlPOcUHrFsFAnyP",15) == 2473910813) strcat(s, "l");
if (crc32("LsCTlmDURyTRmjz",15) == 1253815977) strcat(s, "d");
    return s;
}

char *loutish_adjectives() {
    char *s = calloc(8);
    if (crc32("tJCmmym",7) == 3724925637) strcat(s, "l");
if (crc32("FTvUGzuCnzbaU",13) == 3657478628) strcat(s, "l");
if (crc32("arBKbkplWRrnyxe",15) == 2933211354) strcat(s, "Q");
if (crc32("gPvXzIiFZO",10) == 3014835573) strcat(s, "o");
if (crc32("WtHUnghhydYBaIS",15) == 1529722284) strcat(s, "m");
if (crc32("IzfRlz",6) == 572189921) strcat(s, "u");
if (crc32("NKULrOanAnHhJx",14) == 3810720074) strcat(s, "t");
if (crc32("bkGhrzjVqtnb",12) == 432210676) strcat(s, "o");
if (crc32("fViTeFuQmQzlKN",14) == 4240185247) strcat(s, "i");
if (crc32("BIWUttWL",8) == 2071933641) strcat(s, "r");
if (crc32("MkJUxfVoaVD",11) == 140451777) strcat(s, "s");
if (crc32("mJqAH",5) == 1523426477) strcat(s, "d");
if (crc32("qyQwrboe",8) == 2781915636) strcat(s, "h");
    return s;
}

char *singletrack_adjectives() {
    char *s = calloc(12);
    if (crc32("OwIAEGmpBGdF",12) == 28311795) strcat(s, "H");
if (crc32("hXWRXIi",7) == 1504039212) strcat(s, "s");
if (crc32("QOuQkcTr",8) == 1850539481) strcat(s, "R");
if (crc32("erPYdSpcpMNXsHS",15) == 863731521) strcat(s, "i");
if (crc32("vlSZPT",6) == 4248252185) strcat(s, "b");
if (crc32("rcuBjCKx",8) == 599901081) strcat(s, "n");
if (crc32("tugqcKTMf",9) == 967644260) strcat(s, "g");
if (crc32("WuPAQlIsruXmic",14) == 740856754) strcat(s, "o");
if (crc32("MAVif",5) == 1026953788) strcat(s, "l");
if (crc32("LkjMtFeArWRa",12) == 4240921480) strcat(s, "e");
if (crc32("UYmeGbeSxQfVKwk",15) == 3082832912) strcat(s, "N");
if (crc32("nbguG",5) == 2254931356) strcat(s, "t");
if (crc32("vEIuUFZGqdSEH",13) == 1176792662) strcat(s, "K");
if (crc32("LrjRDXN",7) == 2118015659) strcat(s, "r");
if (crc32("zLBrKjsx",8) == 536686120) strcat(s, "K");
if (crc32("ddppKxdMomCK",12) == 922785876) strcat(s, "a");
if (crc32("klGrbammrbyUFk",14) == 3870094034) strcat(s, "x");
if (crc32("EgmsHFxrAjFu",12) == 514411618) strcat(s, "c");
if (crc32("fIZMNBIBVWYqJn",14) == 1673522614) strcat(s, "g");
if (crc32("ykjdnRhEd",9) == 1295518134) strcat(s, "k");
    return s;
}

char *socialistic_adjectives() {
    char *s = calloc(12);
    if (crc32("KoEZAyAslNjd",12) == 2124561196) strcat(s, "g");
if (crc32("QECbZKAsiIBRhfm",15) == 3319170909) strcat(s, "s");
if (crc32("BEsEQTrjHiOYV",13) == 3220270211) strcat(s, "o");
if (crc32("mCdeLBHKbGxBixk",15) == 4050356674) strcat(s, "c");
if (crc32("ZeuuiYCFwoi",11) == 1663707422) strcat(s, "z");
if (crc32("kjOmcdDIctf",11) == 1396028025) strcat(s, "i");
if (crc32("eTvBAR",6) == 2642245993) strcat(s, "t");
if (crc32("JWSYmeqMKm",10) == 2133998873) strcat(s, "a");
if (crc32("PZhXPzwYYiosQGt",15) == 3534680478) strcat(s, "N");
if (crc32("rzXJAuYYrm",10) == 475484972) strcat(s, "l");
if (crc32("jYCIab",6) == 69090091) strcat(s, "i");
if (crc32("MloyHbiyiKNaNr",14) == 3343059345) strcat(s, "s");
if (crc32("wcKEqhr",7) == 4281761440) strcat(s, "t");
if (crc32("ZtITkutGZ",9) == 3130953009) strcat(s, "i");
if (crc32("vijhgwlFZmsqR",13) == 815769293) strcat(s, "A");
if (crc32("nwjxzmFYhWg",11) == 912574716) strcat(s, "c");
    return s;
}

char *pronunciative_adjectives() {
    char *s = calloc(14);
    if (crc32("bYiQmJzURntap",13) == 1516066299) strcat(s, "p");
if (crc32("zKPPYnwwn",9) == 2904068655) strcat(s, "r");
if (crc32("eWrBZIHzRVKul",13) == 2727323968) strcat(s, "o");
if (crc32("PImIaFs",7) == 2808329248) strcat(s, "K");
if (crc32("NvDghNXbuLeXJ",13) == 317689384) strcat(s, "n");
if (crc32("cnsniBzpwUZ",11) == 2184675315) strcat(s, "k");
if (crc32("OqfHgfYFLIXABzF",15) == 2347382270) strcat(s, "u");
if (crc32("eqIYCW",6) == 2694189267) strcat(s, "P");
if (crc32("NdfCfnOZaaVl",12) == 1520835401) strcat(s, "n");
if (crc32("pIvzKOpCIpMGMBB",15) == 355392607) strcat(s, "x");
if (crc32("kuaUGbAEROMFSh",14) == 2787086024) strcat(s, "c");
if (crc32("QoEOeQJKubASj",13) == 3916631917) strcat(s, "T");
if (crc32("TWCFvDSlaxxA",12) == 4274957195) strcat(s, "i");
if (crc32("TMYiIHLNpCbld",13) == 2877323730) strcat(s, "P");
if (crc32("ZCoHsOYUrOfVSd",14) == 69234846) strcat(s, "a");
if (crc32("jLMRHGsNprPSS",13) == 4276529914) strcat(s, "E");
if (crc32("yphtoMolERqUbN",14) == 1730286734) strcat(s, "t");
if (crc32("lGtxakXHVZRYMAn",15) == 86300823) strcat(s, "i");
if (crc32("ocuvPnGncXlce",13) == 3952516986) strcat(s, "v");
if (crc32("QZwZprQvHih",11) == 1377454044) strcat(s, "Y");
if (crc32("vJVrP",5) == 1514816169) strcat(s, "e");
    return s;
}

char *cronk_adjectives() {
    char *s = calloc(6);
    if (crc32("zmNYkWmlbNEkNB",14) == 4274973493) strcat(s, "c");
if (crc32("yugHOgFuDhEEHvO",15) == 2289512025) strcat(s, "B");
if (crc32("ifzvqfIdpqCCDQf",15) == 3550420794) strcat(s, "r");
if (crc32("QGmZFIvK",8) == 2331706219) strcat(s, "i");
if (crc32("HcURHoQutKtI",12) == 716345905) strcat(s, "o");
if (crc32("nRUbuGXRwbuBs",13) == 3161331323) strcat(s, "n");
if (crc32("FFTyHyRbTGmw",12) == 2017290203) strcat(s, "k");
    return s;
}

char *natatory_adjectives() {
    char *s = calloc(9);
    if (crc32("CUnUPPXgPeLgXmm",15) == 1946290970) strcat(s, "R");
if (crc32("mVAdqABIf",9) == 3088786485) strcat(s, "n");
if (crc32("tOOTTEQLqzYzBs",14) == 4203133407) strcat(s, "W");
if (crc32("alqbXCConILQHQg",15) == 1669475436) strcat(s, "a");
if (crc32("JSPttnfZXFNwQyx",15) == 1888234296) strcat(s, "t");
if (crc32("rcrDLxaEjwHuocW",15) == 3316276811) strcat(s, "c");
if (crc32("BkIqeOcZRivD",12) == 2840750126) strcat(s, "a");
if (crc32("mdvCojwBPH",10) == 3031058419) strcat(s, "t");
if (crc32("yNxePjmYW",9) == 752960598) strcat(s, "N");
if (crc32("zPaYpEbgVFxk",12) == 1584975581) strcat(s, "o");
if (crc32("gTwagH",6) == 3510226674) strcat(s, "E");
if (crc32("ALLkrcHbyqd",11) == 1711338188) strcat(s, "r");
if (crc32("uQcvsQxRxwN",11) == 3545996844) strcat(s, "o");
if (crc32("swTelR",6) == 836265822) strcat(s, "y");
    return s;
}

char *herbless_adjectives() {
    char *s = calloc(9);
    if (crc32("bfsYrWqgJ",9) == 1213682692) strcat(s, "h");
if (crc32("hOxZZTWiS",9) == 2600465796) strcat(s, "e");
if (crc32("ANxiNwU",7) == 3300209576) strcat(s, "r");
if (crc32("vaulJVtECS",10) == 105600900) strcat(s, "Q");
if (crc32("qaVhfVxD",8) == 3148305146) strcat(s, "b");
if (crc32("bQaKTCOduJy",11) == 430085805) strcat(s, "l");
if (crc32("wsBTm",5) == 1787828395) strcat(s, "l");
if (crc32("BVXGhPXC",8) == 1258880669) strcat(s, "e");
if (crc32("iJFIFLvAoOneZu",14) == 4079444470) strcat(s, "s");
if (crc32("eVocdtgOH",9) == 1522256503) strcat(s, "s");
    return s;
}

char *unromanticised_adjectives() {
    char *s = calloc(15);
    if (crc32("BFyKsfRKzSq",11) == 2400656009) strcat(s, "Y");
if (crc32("OPPqDlybAV",10) == 525727135) strcat(s, "u");
if (crc32("rdRwnwsimaAOopC",15) == 3381512319) strcat(s, "n");
if (crc32("wwJfdbLNBzbmO",13) == 2852220288) strcat(s, "m");
if (crc32("yEuqFDGngL",10) == 3058869642) strcat(s, "r");
if (crc32("UHRQjMaBmDF",11) == 1757540339) strcat(s, "o");
if (crc32("byyoPvmZutweQTH",15) == 2329022166) strcat(s, "X");
if (crc32("mTBwNmAjKLNZ",12) == 451102344) strcat(s, "m");
if (crc32("AxrsvV",6) == 3364790809) strcat(s, "D");
if (crc32("kkxPc",5) == 4026897693) strcat(s, "a");
if (crc32("xyhFObJBVJTugD",14) == 3597583709) strcat(s, "n");
if (crc32("UufNxGTuOK",10) == 2301359761) strcat(s, "t");
if (crc32("NQtLIEvzCWu",11) == 2239319410) strcat(s, "x");
if (crc32("ojCvCmaCObAi",12) == 2717653894) strcat(s, "i");
if (crc32("lzWSxUegDo",10) == 435050542) strcat(s, "J");
if (crc32("hDDpPAHyxXflU",13) == 1839035096) strcat(s, "c");
if (crc32("ZbDseHnwUacN",12) == 2709257259) strcat(s, "C");
if (crc32("kdbQoPpw",8) == 967972820) strcat(s, "i");
if (crc32("BbujHRBOjXdNI",13) == 4088447826) strcat(s, "s");
if (crc32("OoEIPabgfxkhzTf",15) == 1285964691) strcat(s, "e");
if (crc32("VMTXhpQxOmqGZgZ",15) == 2080683630) strcat(s, "d");
    return s;
}

char *winterier_adjectives() {
    char *s = calloc(10);
    if (crc32("gOvxuRrWrDs",11) == 2707921533) strcat(s, "w");
if (crc32("QVEVpHlLX",9) == 55472504) strcat(s, "i");
if (crc32("beRXdexApriw",12) == 655705049) strcat(s, "D");
if (crc32("qWJcdCOUQIvaFDP",15) == 2824164559) strcat(s, "n");
if (crc32("iuTKBskx",8) == 2359712436) strcat(s, "e");
if (crc32("xaSUztelOH",10) == 57724285) strcat(s, "t");
if (crc32("wDdFdssXyOfCiu",14) == 453781655) strcat(s, "e");
if (crc32("JvdffuXzIuxC",12) == 3396851038) strcat(s, "J");
if (crc32("azBaDKsx",8) == 3855383491) strcat(s, "r");
if (crc32("WEBsdyFrHSmoO",13) == 3307700980) strcat(s, "Z");
if (crc32("PRqIyIpKvDvt",12) == 1568787709) strcat(s, "i");
if (crc32("HBOTv",5) == 2920022613) strcat(s, "R");
if (crc32("cUxvXIHgiyRyjk",14) == 3381105433) strcat(s, "e");
if (crc32("KsMBUN",6) == 652729819) strcat(s, "r");
    return s;
}

char *nonLatin_adjectives() {
    char *s = calloc(9);
    if (crc32("xKdlpfqMP",9) == 1163536068) strcat(s, "n");
if (crc32("YDTUdEGjvaC",11) == 255310676) strcat(s, "T");
if (crc32("WziOLhnOGHqScQW",15) == 678382339) strcat(s, "o");
if (crc32("HepadwxN",8) == 2061285287) strcat(s, "n");
if (crc32("tUaInXrBelw",11) == 3859368013) strcat(s, "I");
if (crc32("ekxAFVextRnG",12) == 845767468) strcat(s, "L");
if (crc32("oKLKyNmDrU",10) == 3567669916) strcat(s, "a");
if (crc32("GbgvPzJ",7) == 333412743) strcat(s, "t");
if (crc32("UhaApnm",7) == 324060768) strcat(s, "i");
if (crc32("Ngonfdhkgvd",11) == 1404824571) strcat(s, "H");
if (crc32("mtLiDw",6) == 3309994652) strcat(s, "n");
    return s;
}

char *succubous_adjectives() {
    char *s = calloc(10);
    if (crc32("xStOnosi",8) == 747491094) strcat(s, "Y");
if (crc32("oETaVb",6) == 2589198417) strcat(s, "s");
if (crc32("xgiWOnO",7) == 4080634914) strcat(s, "u");
if (crc32("MEqNJjLlvxX",11) == 2731207563) strcat(s, "c");
if (crc32("miZtVKl",7) == 801563899) strcat(s, "b");
if (crc32("qguTPYQwvi",10) == 2812316734) strcat(s, "c");
if (crc32("BEGzBWilyyBW",12) == 1057185402) strcat(s, "J");
if (crc32("xyWExsqsN",9) == 3622261639) strcat(s, "u");
if (crc32("tLClkTmIq",9) == 2718332765) strcat(s, "k");
if (crc32("QqcmUxr",7) == 4243902191) strcat(s, "b");
if (crc32("SfvXzcqqWCoBqO",14) == 1628621711) strcat(s, "P");
if (crc32("RORFQpaU",8) == 372299101) strcat(s, "o");
if (crc32("KPKrKo",6) == 967712194) strcat(s, "u");
if (crc32("wogavViblhWMhTB",15) == 3676239232) strcat(s, "s");
    return s;
}

char *sweatless_adjectives() {
    char *s = calloc(10);
    if (crc32("zteHjFRJhwwnRf",14) == 3830047069) strcat(s, "s");
if (crc32("HnghoScZbsNIXz",14) == 2749250840) strcat(s, "Y");
if (crc32("ptjqTnS",7) == 2199857308) strcat(s, "w");
if (crc32("lAsUaEpq",8) == 1140344928) strcat(s, "b");
if (crc32("TbepVwJ",7) == 2875322775) strcat(s, "e");
if (crc32("BMuUuUClWFRD",12) == 1513363168) strcat(s, "p");
if (crc32("IoqOWoK",7) == 3623879690) strcat(s, "a");
if (crc32("RvRdP",5) == 3833924459) strcat(s, "M");
if (crc32("TWRbRizJmgOtVqw",15) == 3181730761) strcat(s, "t");
if (crc32("lYUzMT",6) == 2215968448) strcat(s, "L");
if (crc32("ycAIUGh",7) == 2136313295) strcat(s, "l");
if (crc32("OZclIlTBCNWjes",14) == 2253540933) strcat(s, "e");
if (crc32("BwHCvvPnvSORZ",13) == 2130491985) strcat(s, "P");
if (crc32("jZmUNZn",7) == 311751267) strcat(s, "s");
if (crc32("BKsaoTFMRtA",11) == 4183643504) strcat(s, "N");
if (crc32("DrVZhosqkvlmLQ",14) == 1451585254) strcat(s, "s");
    return s;
}

char *nonideational_adjectives() {
    char *s = calloc(14);
    if (crc32("eZwaeHdzZ",9) == 3233730452) strcat(s, "n");
if (crc32("OSvgRPbablE",11) == 2038610091) strcat(s, "o");
if (crc32("cIBVHZpr",8) == 878012775) strcat(s, "X");
if (crc32("yNOlrfR",7) == 2603279998) strcat(s, "n");
if (crc32("aQhlPwjth",9) == 1886647090) strcat(s, "i");
if (crc32("TIJeEPt",7) == 3363858738) strcat(s, "C");
if (crc32("CSFan",5) == 2721223171) strcat(s, "d");
if (crc32("dYBoHrPmjYecCXi",15) == 4270214733) strcat(s, "e");
if (crc32("XRmmetHdyTnYCZe",15) == 1355740622) strcat(s, "F");
if (crc32("KhjJUNIRnTXmAOm",15) == 3322664021) strcat(s, "a");
if (crc32("FYcDhjlVpGSZhKo",15) == 2657945890) strcat(s, "t");
if (crc32("pIkZyIhusQOJi",13) == 3289433204) strcat(s, "i");
if (crc32("xaAehKBqCoHrc",13) == 938980614) strcat(s, "o");
if (crc32("wpjvWsiuJ",9) == 1557667694) strcat(s, "n");
if (crc32("HzoggY",6) == 1627098903) strcat(s, "C");
if (crc32("uEuqYyFjDNCOlcN",15) == 492913006) strcat(s, "a");
if (crc32("riIklPCTla",10) == 140103621) strcat(s, "l");
    return s;
}

char *identic_adjectives() {
    char *s = calloc(8);
    if (crc32("XirMXvmTB",9) == 1747652405) strcat(s, "i");
if (crc32("BgezlHTDiCdGs",13) == 438126816) strcat(s, "y");
if (crc32("RRkONjA",7) == 2704855754) strcat(s, "d");
if (crc32("yRVgmsBTqTApWR",14) == 1771570096) strcat(s, "R");
if (crc32("iQdrfnAVrHMRqPB",15) == 1552825539) strcat(s, "e");
if (crc32("paWlU",5) == 131087953) strcat(s, "n");
if (crc32("tuinWdzvPl",10) == 116645124) strcat(s, "M");
if (crc32("amkJf",5) == 1106886941) strcat(s, "t");
if (crc32("LgOkkKHxZzUrl",13) == 1731313989) strcat(s, "i");
if (crc32("MHYRVNKDSQR",11) == 1654435809) strcat(s, "d");
if (crc32("yopHBORGa",9) == 3075521165) strcat(s, "c");
    return s;
}

char *unhasty_adjectives() {
    char *s = calloc(8);
    if (crc32("pwQrci",6) == 2942871004) strcat(s, "u");
if (crc32("CgmJJzoPuecV",12) == 3316879433) strcat(s, "n");
if (crc32("AeDaez",6) == 3509447146) strcat(s, "h");
if (crc32("avqTYFO",7) == 2324058658) strcat(s, "Q");
if (crc32("cZMSQ",5) == 1236821024) strcat(s, "a");
if (crc32("dpcsgiGZ",8) == 846262800) strcat(s, "j");
if (crc32("FqkGrZKZOtxyN",13) == 1481615638) strcat(s, "s");
if (crc32("RxFUcmkBsGGXE",13) == 1741839645) strcat(s, "E");
if (crc32("zNzrTGSQBYusXq",14) == 3122218995) strcat(s, "t");
if (crc32("ZudLyR",6) == 2385482711) strcat(s, "X");
if (crc32("PRIWgCKsAxEvgkm",15) == 3161874336) strcat(s, "y");
    return s;
}

char *unmedical_adjectives() {
    char *s = calloc(10);
    if (crc32("lVMtT",5) == 730925731) strcat(s, "u");
if (crc32("OmXJdRRhLxqogCJ",15) == 989088175) strcat(s, "n");
if (crc32("jKEHR",5) == 2451701043) strcat(s, "m");
if (crc32("CoxyTLcaQNvVtgv",15) == 1382042775) strcat(s, "e");
if (crc32("DIFNjojWHfBOn",13) == 1292320331) strcat(s, "Y");
if (crc32("JxPgPCQevm",10) == 1581815688) strcat(s, "d");
if (crc32("FtxPTMsvaOeB",12) == 170661716) strcat(s, "i");
if (crc32("lGrovzRQwq",10) == 607548192) strcat(s, "c");
if (crc32("bfosqkhsjJ",10) == 2434640566) strcat(s, "h");
if (crc32("ETTYOA",6) == 1929182321) strcat(s, "a");
if (crc32("kaDICkzFLPlFfT",14) == 2674496380) strcat(s, "p");
if (crc32("WfgptrfRw",9) == 1683991620) strcat(s, "l");
    return s;
}

char *nonMalay_adjectives() {
    char *s = calloc(9);
    if (crc32("GXFaApXp",8) == 2116941225) strcat(s, "n");
if (crc32("VFubSiTpQXchZjf",15) == 2760684285) strcat(s, "b");
if (crc32("cMDyGWy",7) == 2252740709) strcat(s, "o");
if (crc32("eRmOmqwjsCamv",13) == 4214838531) strcat(s, "Q");
if (crc32("CvHFeUIKorwo",12) == 1837864102) strcat(s, "n");
if (crc32("fULUpDeij",9) == 2982078893) strcat(s, "M");
if (crc32("SQICBQwXHrMUO",13) == 2268437408) strcat(s, "E");
if (crc32("FfjnIl",6) == 232579661) strcat(s, "a");
if (crc32("mAtSWo",6) == 3261848742) strcat(s, "l");
if (crc32("QzdZAAdJtXK",11) == 2286082279) strcat(s, "a");
if (crc32("LGvNnnubzVu",11) == 2829047775) strcat(s, "y");
    return s;
}

char *quasiexpedient_adjectives() {
    char *s = calloc(15);
    if (crc32("EhBash",6) == 2020013070) strcat(s, "q");
if (crc32("RsDUVjA",7) == 3955649716) strcat(s, "v");
if (crc32("sjjdYlnLSVRH",12) == 3048279778) strcat(s, "u");
if (crc32("yIzVYGNRkguly",13) == 4149823157) strcat(s, "u");
if (crc32("vVXiyMYKSD",10) == 668675574) strcat(s, "a");
if (crc32("BHCTg",5) == 3312243668) strcat(s, "s");
if (crc32("NXVvcAHbPejHuF",14) == 1645225622) strcat(s, "i");
if (crc32("dEoUkBZYluQ",11) == 3365940449) strcat(s, "X");
if (crc32("ZXDmjLkbDoKwGpS",15) == 2742990843) strcat(s, "e");
if (crc32("qajnRQ",6) == 1474137795) strcat(s, "x");
if (crc32("qufqG",5) == 3434563034) strcat(s, "p");
if (crc32("bnbfT",5) == 3940226434) strcat(s, "e");
if (crc32("YtDwqvG",7) == 3900076205) strcat(s, "K");
if (crc32("npRNFe",6) == 4195694065) strcat(s, "d");
if (crc32("btOjBT",6) == 3714057404) strcat(s, "m");
if (crc32("srOqNYQOh",9) == 3143630464) strcat(s, "i");
if (crc32("VwNRJUBmr",9) == 1798634254) strcat(s, "Z");
if (crc32("nVicSCf",7) == 821823167) strcat(s, "e");
if (crc32("PwRpPyJWJUWtji",14) == 3328645330) strcat(s, "d");
if (crc32("WymHuPcePRO",11) == 99407874) strcat(s, "n");
if (crc32("lhKbxSmnS",9) == 90785684) strcat(s, "t");
    return s;
}

char *benmost_adjectives() {
    char *s = calloc(8);
    if (crc32("QbKmKdp",7) == 2529585172) strcat(s, "b");
if (crc32("oQRQqqoWRQ",10) == 2926961353) strcat(s, "e");
if (crc32("TTlcIYUSNwcZP",13) == 2198375969) strcat(s, "L");
if (crc32("YTGpbZjjQmZYC",13) == 2924379859) strcat(s, "n");
if (crc32("Avycuwmj",8) == 2373524040) strcat(s, "m");
if (crc32("wOHExbCqms",10) == 1551407019) strcat(s, "C");
if (crc32("IPgcGuyN",8) == 2150021488) strcat(s, "o");
if (crc32("tndtZPnh",8) == 2040337101) strcat(s, "s");
if (crc32("ZNaLpJ",6) == 797301526) strcat(s, "h");
if (crc32("qVfQOjvLwZyv",12) == 2730131482) strcat(s, "t");
    return s;
}

char *singlehanded_adjectives() {
    char *s = calloc(13);
    if (crc32("YkFWVlZLhfavTCl",15) == 3434775049) strcat(s, "Q");
if (crc32("hklCqIXbwQpix",13) == 794307986) strcat(s, "s");
if (crc32("UsNRQYgGMbqkF",13) == 1269684063) strcat(s, "I");
if (crc32("CZqpCRQPe",9) == 277314440) strcat(s, "i");
if (crc32("IgSMrQLflWBB",12) == 765834585) strcat(s, "i");
if (crc32("QYdnmDnZNJq",11) == 4174543345) strcat(s, "n");
if (crc32("JWVLCn",6) == 1938485041) strcat(s, "g");
if (crc32("JvMfjLLMzz",10) == 2148511823) strcat(s, "g");
if (crc32("huMuSd",6) == 2220540582) strcat(s, "l");
if (crc32("PtLpZbzCocu",11) == 2902658678) strcat(s, "e");
if (crc32("MaUpYKPjGLi",11) == 1719154322) strcat(s, "Y");
if (crc32("ggtYWV",6) == 2145593530) strcat(s, "h");
if (crc32("jyACj",5) == 83625104) strcat(s, "a");
if (crc32("bAUcgbxBqvI",11) == 2753729355) strcat(s, "n");
if (crc32("ofeyGhAJeNiW",12) == 2285252802) strcat(s, "d");
if (crc32("ioqkFz",6) == 78220340) strcat(s, "e");
if (crc32("RPFfhp",6) == 3348359028) strcat(s, "d");
    return s;
}

char *quasifederal_adjectives() {
    char *s = calloc(13);
    if (crc32("bQpQNr",6) == 658341641) strcat(s, "q");
if (crc32("WZhTMoqhsIbE",12) == 4068832874) strcat(s, "g");
if (crc32("acnvqMxUYgafvr",14) == 2492980123) strcat(s, "u");
if (crc32("PMIwjjULVEWqVK",14) == 2749734871) strcat(s, "a");
if (crc32("srwxcohFZtwyU",13) == 3716011658) strcat(s, "s");
if (crc32("DwOpeENbbCUV",12) == 2060697293) strcat(s, "x");
if (crc32("lufACCiAEbI",11) == 2388149226) strcat(s, "i");
if (crc32("OgsCQS",6) == 1606838027) strcat(s, "z");
if (crc32("wWwtACoPQCo",11) == 2339805026) strcat(s, "f");
if (crc32("LtqhEyhJPMfh",12) == 3550441633) strcat(s, "e");
if (crc32("nKpBMEGuUK",10) == 1581842706) strcat(s, "d");
if (crc32("VqzhxwlMOpRwL",13) == 442144191) strcat(s, "f");
if (crc32("QdCDoqtotF",10) == 3987691197) strcat(s, "e");
if (crc32("lIplVVSqey",10) == 3363183674) strcat(s, "x");
if (crc32("wtUePXoEpdSGza",14) == 3941714734) strcat(s, "r");
if (crc32("NgXESRaeRnauFz",14) == 715914635) strcat(s, "Z");
if (crc32("onfPFROltkblSsx",15) == 3441285281) strcat(s, "a");
if (crc32("qrprm",5) == 3109894324) strcat(s, "l");
    return s;
}

char *multisulcate_adjectives() {
    char *s = calloc(13);
    if (crc32("KkbzyDL",7) == 4001149396) strcat(s, "m");
if (crc32("SGUecwDCNSCMGk",14) == 1566257079) strcat(s, "Y");
if (crc32("Npfpcdb",7) == 394995012) strcat(s, "u");
if (crc32("LOJoo",5) == 3660777865) strcat(s, "l");
if (crc32("XOpKqZULmfmUzq",14) == 492617078) strcat(s, "t");
if (crc32("fJgwVRCMlouxQhi",15) == 2711593483) strcat(s, "i");
if (crc32("KlXTcSBQRMbTz",13) == 3765980433) strcat(s, "l");
if (crc32("rXWVIiRaGCGVZ",13) == 2980781389) strcat(s, "s");
if (crc32("UydQIwFCKDqS",12) == 547907383) strcat(s, "E");
if (crc32("BdPIbGHFMEvzbqA",15) == 235722354) strcat(s, "u");
if (crc32("NWiGhdnhmeMoEA",14) == 2566370895) strcat(s, "l");
if (crc32("RoMWt",5) == 3114190153) strcat(s, "o");
if (crc32("mRjiRMZXWAKc",12) == 2900514163) strcat(s, "c");
if (crc32("pSZGoh",6) == 449180701) strcat(s, "i");
if (crc32("uTkZurhDV",9) == 153665398) strcat(s, "a");
if (crc32("EsynJDzdYGRz",12) == 532138725) strcat(s, "t");
if (crc32("uQrWvS",6) == 1898356793) strcat(s, "O");
if (crc32("fpqNQjQ",7) == 793897945) strcat(s, "e");
    return s;
}

char *rockered_adjectives() {
    char *s = calloc(9);
    if (crc32("zRutfoHgubZnb",13) == 3199801784) strcat(s, "d");
if (crc32("AfvTtzAsgiU",11) == 3192670387) strcat(s, "r");
if (crc32("MVkrYF",6) == 1872373537) strcat(s, "Q");
if (crc32("ZnwXKzOVc",9) == 1698373789) strcat(s, "o");
if (crc32("WgCcMhZWHyAf",12) == 3108693604) strcat(s, "N");
if (crc32("obQJu",5) == 199773874) strcat(s, "c");
if (crc32("bctvqNAJHE",10) == 3017409585) strcat(s, "k");
if (crc32("kFRjHZ",6) == 2467825643) strcat(s, "e");
if (crc32("RgGmE",5) == 2167447484) strcat(s, "r");
if (crc32("nNeNIDiOHBK",11) == 3561333624) strcat(s, "B");
if (crc32("yOAqEIctHaTDgQQ",15) == 2023563784) strcat(s, "e");
if (crc32("mcrRcSIbqF",10) == 222648480) strcat(s, "d");
    return s;
}

char *spannew_adjectives() {
    char *s = calloc(8);
    if (crc32("QaFSZcwIRfcroR",14) == 1960079987) strcat(s, "s");
if (crc32("mMcecdKSoma",11) == 279703396) strcat(s, "p");
if (crc32("lsZryaiEJX",10) == 3431005840) strcat(s, "B");
if (crc32("JPzbadcdHAvKgmV",15) == 4149464316) strcat(s, "a");
if (crc32("kzDCAKkrNuGeRyV",15) == 4052427223) strcat(s, "N");
if (crc32("TxvZbGLBfZfQ",12) == 84191592) strcat(s, "n");
if (crc32("jUyxeSoNUvbWhB",14) == 3773031669) strcat(s, "n");
if (crc32("hEfVxZmvJ",9) == 2562520190) strcat(s, "D");
if (crc32("OSipDiPqiQx",11) == 4006847903) strcat(s, "e");
if (crc32("lwAorcULpJswOnS",15) == 1757840872) strcat(s, "a");
if (crc32("ynRtn",5) == 1735983072) strcat(s, "w");
    return s;
}

char *unlarded_adjectives() {
    char *s = calloc(9);
    if (crc32("TSkOuPR",7) == 4215653728) strcat(s, "C");
if (crc32("ZbXqPqoLKY",10) == 540461534) strcat(s, "u");
if (crc32("qIaIaQtNeymj",12) == 2907778563) strcat(s, "K");
if (crc32("AYqHmhTNyIK",11) == 132844819) strcat(s, "n");
if (crc32("GwQaMUraMNd",11) == 242085390) strcat(s, "i");
if (crc32("rJiMIEreS",9) == 1767735545) strcat(s, "l");
if (crc32("CxPhpisd",8) == 3666833175) strcat(s, "a");
if (crc32("oQOrvzGTLcOifp",14) == 341455933) strcat(s, "z");
if (crc32("nIbbSqpevMZ",11) == 1387100588) strcat(s, "r");
if (crc32("rCJKlIIkSK",10) == 4037782871) strcat(s, "d");
if (crc32("XDPZunbak",9) == 193653510) strcat(s, "e");
if (crc32("Kfimd",5) == 717649566) strcat(s, "d");
    return s;
}

char *tasteless_adjectives() {
    char *s = calloc(10);
    if (crc32("DkrjpgjEfTwbN",13) == 776310330) strcat(s, "i");
if (crc32("QTGAbyJ",7) == 1695398370) strcat(s, "t");
if (crc32("sTBqicuWMJuyC",13) == 1751061658) strcat(s, "e");
if (crc32("mbVFQABkl",9) == 3609722869) strcat(s, "a");
if (crc32("MZcVBneNIZZUymF",15) == 2579626399) strcat(s, "v");
if (crc32("MsfEzXMIiFHdLyW",15) == 3072674273) strcat(s, "s");
if (crc32("EFcwsFGrqNXgAQ",14) == 2945522136) strcat(s, "W");
if (crc32("RUFse",5) == 905960118) strcat(s, "t");
if (crc32("xmdhYSvihOh",11) == 3629038792) strcat(s, "R");
if (crc32("xMyNEwZPqQBD",12) == 2297757260) strcat(s, "e");
if (crc32("uIGFeEbMSTsFkC",14) == 1904434426) strcat(s, "u");
if (crc32("CoQKfpaoUndlk",13) == 2854820417) strcat(s, "l");
if (crc32("sjVdMuiM",8) == 2501618781) strcat(s, "b");
if (crc32("YinZTmKM",8) == 1857612951) strcat(s, "e");
if (crc32("QJWRWgfVpRFMXw",14) == 2195246321) strcat(s, "s");
if (crc32("pKcDyFxmK",9) == 1841833607) strcat(s, "s");
    return s;
}

char *unfunctioning_adjectives() {
    char *s = calloc(14);
    if (crc32("CGDCNwIZmdelV",13) == 2634689631) strcat(s, "U");
if (crc32("HdGNUK",6) == 1685981544) strcat(s, "u");
if (crc32("fWWkVFnYHAwZphU",15) == 105264359) strcat(s, "u");
if (crc32("nFAjTkecweBx",12) == 3329097281) strcat(s, "n");
if (crc32("txnkxfgHNi",10) == 1751917371) strcat(s, "f");
if (crc32("oZQXPPGCbTSok",13) == 3070547384) strcat(s, "w");
if (crc32("wPmfayNpPbdGXb",14) == 342260857) strcat(s, "u");
if (crc32("IXLONXmzilTCrbB",15) == 433023001) strcat(s, "n");
if (crc32("ENgmLFIqxRYUSeO",15) == 4224662413) strcat(s, "c");
if (crc32("tLVZFkO",7) == 4199492579) strcat(s, "t");
if (crc32("kEpZMYgLBq",10) == 3380909547) strcat(s, "i");
if (crc32("cvcoN",5) == 4263534410) strcat(s, "I");
if (crc32("DwGKUXizXNOml",13) == 756266820) strcat(s, "o");
if (crc32("EwzxiJEyYrHjaAe",15) == 3622539230) strcat(s, "n");
if (crc32("SNfyypPOvDv",11) == 1244635724) strcat(s, "z");
if (crc32("oxahzaDDDa",10) == 4021007618) strcat(s, "i");
if (crc32("tzXOef",6) == 1530372133) strcat(s, "n");
if (crc32("bjHjnPZp",8) == 1337452171) strcat(s, "g");
    return s;
}

char *wellfinished_adjectives() {
    char *s = calloc(13);
    if (crc32("QwpJOxlR",8) == 431549005) strcat(s, "w");
if (crc32("AmECyuJfMZo",11) == 2688896380) strcat(s, "e");
if (crc32("GDege",5) == 930434609) strcat(s, "s");
if (crc32("LPbSHQATdCEL",12) == 3934135915) strcat(s, "l");
if (crc32("afdqqC",6) == 1553909023) strcat(s, "l");
if (crc32("PpGoJXJq",8) == 1800044275) strcat(s, "T");
if (crc32("fSjEMFlcqSAeI",13) == 1508791784) strcat(s, "f");
if (crc32("HAXfCTGx",8) == 2289771000) strcat(s, "i");
if (crc32("OGeDRDTloDxCfMI",15) == 861047350) strcat(s, "i");
if (crc32("qSnJmYFCU",9) == 3436679860) strcat(s, "n");
if (crc32("dwnNanIxEpWk",12) == 4197042927) strcat(s, "l");
if (crc32("dsABQrMSpklZu",13) == 268077856) strcat(s, "i");
if (crc32("pBEglgWa",8) == 1180083400) strcat(s, "B");
if (crc32("ldqpskUZHZO",11) == 2441345258) strcat(s, "s");
if (crc32("FGoPnEfCWWg",11) == 397652888) strcat(s, "u");
if (crc32("oafiCIg",7) == 4090967751) strcat(s, "h");
if (crc32("fJihjoYryrdyBc",14) == 1546024504) strcat(s, "g");
if (crc32("BOZikXMQiAPfmUK",15) == 3514012571) strcat(s, "e");
if (crc32("NyWvkXKK",8) == 3687052215) strcat(s, "T");
if (crc32("JLHRmHjYQI",10) == 1530508991) strcat(s, "d");
    return s;
}

char *unreaped_adjectives() {
    char *s = calloc(9);
    if (crc32("hyZxdFrsSHQJ",12) == 752068571) strcat(s, "u");
if (crc32("gZqNsqFxIIwLGc",14) == 1756794938) strcat(s, "x");
if (crc32("jbltQrPAzakaXME",15) == 935002883) strcat(s, "n");
if (crc32("vNryQjlKNVpbz",13) == 3621895724) strcat(s, "r");
if (crc32("hcDhtyVbsKOf",12) == 3432686393) strcat(s, "X");
if (crc32("iWZrzBGe",8) == 2542763709) strcat(s, "e");
if (crc32("zdTDYeEt",8) == 1062783273) strcat(s, "a");
if (crc32("LiiBMXd",7) == 3573315557) strcat(s, "p");
if (crc32("zZlmu",5) == 1610695336) strcat(s, "e");
if (crc32("SEbHhkh",7) == 115691035) strcat(s, "g");
if (crc32("YErQNozb",8) == 885855728) strcat(s, "d");
    return s;
}

char *wellattached_adjectives() {
    char *s = calloc(13);
    if (crc32("eNIutxaJvswqhV",14) == 245681363) strcat(s, "X");
if (crc32("PqKpfJovTHVc",12) == 2508753796) strcat(s, "w");
if (crc32("xZbbZKBtyT",10) == 497539417) strcat(s, "e");
if (crc32("vYFNnDpgMgq",11) == 752143064) strcat(s, "B");
if (crc32("zMBSKdTk",8) == 1194443956) strcat(s, "l");
if (crc32("GzsdjUGeyMnDMtq",15) == 2985587461) strcat(s, "l");
if (crc32("cciZaMsiMsgr",12) == 847016510) strcat(s, "A");
if (crc32("mrWvCeY",7) == 2372007713) strcat(s, "a");
if (crc32("CvVbREyFeiNRDi",14) == 3896446876) strcat(s, "t");
if (crc32("FjoUmybowKqy",12) == 2282588325) strcat(s, "c");
if (crc32("PtAxWAgg",8) == 4218254119) strcat(s, "t");
if (crc32("iwkxlLWi",8) == 3469327642) strcat(s, "R");
if (crc32("JrlChWQ",7) == 1103889525) strcat(s, "a");
if (crc32("TPcpmCMkmBEeUDQ",15) == 4190834716) strcat(s, "c");
if (crc32("igAXMIgkgPZdcYW",15) == 3398214349) strcat(s, "h");
if (crc32("SzzIenf",7) == 285516144) strcat(s, "N");
if (crc32("IlRSQHofcwBD",12) == 2961448229) strcat(s, "e");
if (crc32("UCbQwpMQxVlUjT",14) == 2907878450) strcat(s, "p");
if (crc32("YGtSqglVL",9) == 966288894) strcat(s, "d");
    return s;
}

char *nonindividualistic_adjectives() {
    char *s = calloc(19);
    if (crc32("WFssBEvdZagtk",13) == 2117844492) strcat(s, "n");
if (crc32("OPWYuswo",8) == 1634478936) strcat(s, "e");
if (crc32("DkPyXCfxkYs",11) == 581228573) strcat(s, "o");
if (crc32("mJrHfYRuvzTF",12) == 3604082298) strcat(s, "y");
if (crc32("mkIKvIdbkPcCj",13) == 1121444512) strcat(s, "n");
if (crc32("ZerRSvvVwQ",10) == 3220214393) strcat(s, "R");
if (crc32("IVRGvwdhzQ",10) == 3145145213) strcat(s, "i");
if (crc32("JERptxkHqrf",11) == 4095154194) strcat(s, "J");
if (crc32("zVWSRHb",7) == 2819372993) strcat(s, "n");
if (crc32("OPxKFhQmWpu",11) == 3243222362) strcat(s, "d");
if (crc32("kQZjzzHBUd",10) == 2977129083) strcat(s, "y");
if (crc32("HgGmLbactmQmD",13) == 1863438890) strcat(s, "i");
if (crc32("Qkqoyxlx",8) == 381849839) strcat(s, "h");
if (crc32("aCJkH",5) == 1758604779) strcat(s, "v");
if (crc32("rZlEU",5) == 910329611) strcat(s, "i");
if (crc32("kAluXpyVjcT",11) == 2328616774) strcat(s, "V");
if (crc32("zZZGVHimKJ",10) == 2435200238) strcat(s, "d");
if (crc32("XrfRpPe",7) == 1868050803) strcat(s, "u");
if (crc32("EDPWCeBJ",8) == 2705784805) strcat(s, "z");
if (crc32("IptTwkNa",8) == 77430777) strcat(s, "a");
if (crc32("DkMQvlgbEwqEEk",14) == 2039750734) strcat(s, "R");
if (crc32("Lmxmay",6) == 323066678) strcat(s, "l");
if (crc32("gzZMJtiAKLVbJb",14) == 2384250824) strcat(s, "i");
if (crc32("HDnzKjpM",8) == 2156205070) strcat(s, "s");
if (crc32("fsCFTWHBZW",10) == 4082984915) strcat(s, "t");
if (crc32("wRJOoZAbTkJj",12) == 3216936974) strcat(s, "k");
if (crc32("mKptluhgz",9) == 2676098594) strcat(s, "i");
if (crc32("zlUvmVqDLtrd",12) == 3254241347) strcat(s, "Z");
if (crc32("qrben",5) == 980785798) strcat(s, "c");
    return s;
}

char *limiting_adjectives() {
    char *s = calloc(9);
    if (crc32("WfiiLGvM",8) == 893567991) strcat(s, "m");
if (crc32("jYTgYKw",7) == 1288197173) strcat(s, "l");
if (crc32("NplNW",5) == 323990580) strcat(s, "v");
if (crc32("mzVIjubYOLVNmm",14) == 1480173658) strcat(s, "i");
if (crc32("EhxSjzRJVUzw",12) == 1389746921) strcat(s, "m");
if (crc32("tNDrwEnCw",9) == 837517824) strcat(s, "C");
if (crc32("VNsuRlyvYkD",11) == 3009321447) strcat(s, "i");
if (crc32("PdGEFlcY",8) == 3373577868) strcat(s, "E");
if (crc32("yJwcKZWsoz",10) == 4215644881) strcat(s, "t");
if (crc32("SPwVQL",6) == 598033451) strcat(s, "Z");
if (crc32("gMiZhl",6) == 3396722058) strcat(s, "i");
if (crc32("AkFqOP",6) == 3149492444) strcat(s, "g");
if (crc32("TzBLGK",6) == 2199172836) strcat(s, "n");
if (crc32("uvEVeoJQc",9) == 1938898556) strcat(s, "S");
if (crc32("XxGgxV",6) == 3053992489) strcat(s, "g");
    return s;
}

char *lattermost_adjectives() {
    char *s = calloc(11);
    if (crc32("zeVrEB",6) == 3865444485) strcat(s, "l");
if (crc32("duiddFICUcpZL",13) == 311181802) strcat(s, "q");
if (crc32("jsubuWVfQRRoTx",14) == 1724213580) strcat(s, "a");
if (crc32("EjjDAEeaqI",10) == 2347064292) strcat(s, "t");
if (crc32("IiFKR",5) == 923804360) strcat(s, "t");
if (crc32("UATHNmLrZ",9) == 3469904269) strcat(s, "e");
if (crc32("axMqCvMhqYkGY",13) == 769764162) strcat(s, "r");
if (crc32("VBPPSFBwVouwx",13) == 1836972749) strcat(s, "X");
if (crc32("isjlpBYgkFMHJV",14) == 1142550603) strcat(s, "m");
if (crc32("NSZIJxNfBBcsUw",14) == 313775029) strcat(s, "W");
if (crc32("tsKBhUdDt",9) == 3023504676) strcat(s, "o");
if (crc32("pdcBqTeq",8) == 1350074229) strcat(s, "x");
if (crc32("CtHTRO",6) == 1873218055) strcat(s, "s");
if (crc32("DmCWehBRLFDndLF",15) == 1083048508) strcat(s, "t");
    return s;
}

char *welltraveled_adjectives() {
    char *s = calloc(13);
    if (crc32("usiEIP",6) == 787543508) strcat(s, "w");
if (crc32("zQOzMVIH",8) == 3364823017) strcat(s, "e");
if (crc32("tZoRDATYOfmOV",13) == 1025786264) strcat(s, "s");
if (crc32("ovxCcHn",7) == 2781982040) strcat(s, "l");
if (crc32("CqMvH",5) == 3020243591) strcat(s, "t");
if (crc32("HWviEdscrOe",11) == 522353403) strcat(s, "l");
if (crc32("lOazqs",6) == 2025753226) strcat(s, "o");
if (crc32("nTiGkCQxgrUi",12) == 300168855) strcat(s, "t");
if (crc32("MzZSyvPq",8) == 2532769456) strcat(s, "r");
if (crc32("ZWEtRdzOYp",10) == 1259933612) strcat(s, "a");
if (crc32("NzBEKgAdBKF",11) == 3805107541) strcat(s, "v");
if (crc32("egeyTRUHlTINZh",14) == 2794894050) strcat(s, "m");
if (crc32("pcqlilrpK",9) == 24208586) strcat(s, "e");
if (crc32("vXXuQvfVOUxf",12) == 2092240483) strcat(s, "i");
if (crc32("njIwkeQSGOa",11) == 1317465150) strcat(s, "l");
if (crc32("ozXVFMGWlb",10) == 131323798) strcat(s, "I");
if (crc32("GeJKNBkemRxa",12) == 1823960258) strcat(s, "e");
if (crc32("YXulRLCtNbQ",11) == 377459914) strcat(s, "d");
if (crc32("klGEDjXtQvCp",12) == 1455051505) strcat(s, "d");
    return s;
}

char *naggy_adjectives() {
    char *s = calloc(6);
    if (crc32("qYTeGsnXeONtS",13) == 3948150242) strcat(s, "k");
if (crc32("EAQcPUbiu",9) == 2268755242) strcat(s, "n");
if (crc32("bfoyXMaiUTJrE",13) == 2313636857) strcat(s, "y");
if (crc32("OJdME",5) == 3835127671) strcat(s, "a");
if (crc32("TeldXcwvjTtW",12) == 1686031772) strcat(s, "k");
if (crc32("UhkFfIo",7) == 3898075891) strcat(s, "g");
if (crc32("OtjqWvCx",8) == 1665783906) strcat(s, "g");
if (crc32("MNqLBSeRDk",10) == 2531996464) strcat(s, "m");
if (crc32("EIorlBwM",8) == 3313626723) strcat(s, "y");
    return s;
}

char *masterly_adjectives() {
    char *s = calloc(9);
    if (crc32("yQblmYiSuT",10) == 3407025458) strcat(s, "y");
if (crc32("ClFoMTrzJUgcXKk",15) == 3067000044) strcat(s, "m");
if (crc32("VXMvpPlwuolve",13) == 360827220) strcat(s, "H");
if (crc32("AicDjIWRSc",10) == 206643345) strcat(s, "a");
if (crc32("RDcIr",5) == 1168520697) strcat(s, "s");
if (crc32("PMTomMOemBsgwsA",15) == 3632342450) strcat(s, "M");
if (crc32("UHhIE",5) == 163060927) strcat(s, "t");
if (crc32("IKEyJARFhDy",11) == 3876623650) strcat(s, "S");
if (crc32("YEZXfOqz",8) == 2138140790) strcat(s, "e");
if (crc32("fmTVUz",6) == 1435436508) strcat(s, "r");
if (crc32("CDCbgkgD",8) == 2750222429) strcat(s, "S");
if (crc32("NyqPZS",6) == 2103121112) strcat(s, "l");
if (crc32("cPcuaFCVoq",10) == 929783574) strcat(s, "b");
if (crc32("gAHQooM",7) == 2781399499) strcat(s, "y");
    return s;
}

char *perspicuous_adjectives() {
    char *s = calloc(12);
    if (crc32("nLZIsWtqoOvQm",13) == 1625825697) strcat(s, "p");
if (crc32("rkbSeRcvgGJa",12) == 1764294114) strcat(s, "e");
if (crc32("OJbiXxOSUwe",11) == 3642689547) strcat(s, "r");
if (crc32("qoZivGezdfipiV",14) == 1120255923) strcat(s, "s");
if (crc32("kdUoVJujvPhfexx",15) == 2979682234) strcat(s, "p");
if (crc32("lHSNYpGUTiMQ",12) == 2388683197) strcat(s, "y");
if (crc32("VfKnhLQhRGFjDS",14) == 246020383) strcat(s, "i");
if (crc32("TUtTjWwrUeesJG",14) == 2901839742) strcat(s, "c");
if (crc32("XHHgmkcxJ",9) == 18204563) strcat(s, "u");
if (crc32("cxqrRZSqNURa",12) == 68568004) strcat(s, "y");
if (crc32("UJmuJKRsjvG",11) == 3360336144) strcat(s, "o");
if (crc32("PDVcqZkb",8) == 320357685) strcat(s, "u");
if (crc32("MnAojD",6) == 2860958940) strcat(s, "s");
    return s;
}

char *unburly_adjectives() {
    char *s = calloc(8);
    if (crc32("sqVzGOyO",8) == 1434355535) strcat(s, "x");
if (crc32("efgdYdFLHIg",11) == 1440991750) strcat(s, "u");
if (crc32("lnFedcTSpqby",12) == 2536672337) strcat(s, "n");
if (crc32("UuJGnwiOc",9) == 1317609126) strcat(s, "W");
if (crc32("xrJoiVGlyCf",11) == 3839019323) strcat(s, "b");
if (crc32("chNRO",5) == 4073252465) strcat(s, "u");
if (crc32("xPXgm",5) == 1361923131) strcat(s, "h");
if (crc32("FJJZDVtxjXyKTsj",15) == 1219469520) strcat(s, "r");
if (crc32("SszQE",5) == 1013676536) strcat(s, "l");
if (crc32("rUfcTn",6) == 668615803) strcat(s, "y");
    return s;
}

char *metallic_adjectives() {
    char *s = calloc(9);
    if (crc32("YjccCJehvGMLG",13) == 2427666982) strcat(s, "z");
if (crc32("dWfBqznFGESZo",13) == 3330883456) strcat(s, "m");
if (crc32("yquKpc",6) == 2197245774) strcat(s, "e");
if (crc32("bgrDtrGmX",9) == 2900288551) strcat(s, "t");
if (crc32("fpaGKX",6) == 382724352) strcat(s, "a");
if (crc32("tGQWVV",6) == 3205051596) strcat(s, "l");
if (crc32("NKRSr",5) == 4061857643) strcat(s, "e");
if (crc32("xpnDrWrRHzpLgyH",15) == 971395400) strcat(s, "l");
if (crc32("laXbQPi",7) == 1385711969) strcat(s, "Q");
if (crc32("jAcuSYdsUiYu",12) == 2661441091) strcat(s, "i");
if (crc32("VAupM",5) == 2980185946) strcat(s, "B");
if (crc32("YjjdvK",6) == 3404703107) strcat(s, "c");
    return s;
}

char *Americanistic_adjectives() {
    char *s = calloc(14);
    if (crc32("ZxqLN",5) == 2190591741) strcat(s, "A");
if (crc32("GMJCvnelE",9) == 2913674218) strcat(s, "U");
if (crc32("ZZdzV",5) == 137873904) strcat(s, "m");
if (crc32("yVXnqhfllLgTc",13) == 1433539864) strcat(s, "e");
if (crc32("YromGxYQNZrEsJM",15) == 2823967445) strcat(s, "x");
if (crc32("ChQLMJrOenYoMYw",15) == 2288268412) strcat(s, "r");
if (crc32("xoWGOwhPeW",10) == 2446752968) strcat(s, "i");
if (crc32("TGfWvguxZysIWpd",15) == 4214937070) strcat(s, "v");
if (crc32("keTyoBF",7) == 2302384810) strcat(s, "c");
if (crc32("bLwQbhJah",9) == 1532043138) strcat(s, "a");
if (crc32("XHUewK",6) == 2123006192) strcat(s, "K");
if (crc32("EDCJoYnYW",9) == 1973664971) strcat(s, "n");
if (crc32("eYGWRMare",9) == 1759148271) strcat(s, "i");
if (crc32("YPRQeRBEd",9) == 2928283651) strcat(s, "J");
if (crc32("uHVJuOmGaUz",11) == 3384601273) strcat(s, "s");
if (crc32("isLxyxceA",9) == 4272998778) strcat(s, "R");
if (crc32("rHDEWWfuRkh",11) == 3046449125) strcat(s, "t");
if (crc32("FUkLbofGeGsbSF",14) == 3054344833) strcat(s, "i");
if (crc32("olOUbedGIximGK",14) == 2074926272) strcat(s, "c");
    return s;
}

char *unsymbolical_adjectives() {
    char *s = calloc(13);
    if (crc32("vIOtxMRi",8) == 3011953085) strcat(s, "J");
if (crc32("jgqPKTXrYl",10) == 2162142114) strcat(s, "u");
if (crc32("xRaghLnJywvS",12) == 4230545630) strcat(s, "d");
if (crc32("ViRMcpsKY",9) == 3444142712) strcat(s, "n");
if (crc32("ayTzvaqGUnAQouD",15) == 3054517028) strcat(s, "s");
if (crc32("oSGYHLdIvi",10) == 3852517750) strcat(s, "y");
if (crc32("ISjWk",5) == 632661446) strcat(s, "z");
if (crc32("jybZMvJOeWZGm",13) == 2503620169) strcat(s, "m");
if (crc32("vkNXcRdnKFxUvG",14) == 1062390289) strcat(s, "b");
if (crc32("FYmpYUnArY",10) == 1999896986) strcat(s, "o");
if (crc32("UAYzX",5) == 457234548) strcat(s, "M");
if (crc32("tKlfQhU",7) == 2030101289) strcat(s, "l");
if (crc32("CtGJlX",6) == 2084419999) strcat(s, "e");
if (crc32("CwmarBUtuUMQwn",14) == 1846688081) strcat(s, "i");
if (crc32("aHbyNCXVUVLltt",14) == 2691664041) strcat(s, "c");
if (crc32("dcOYaFDCGf",10) == 835876362) strcat(s, "Y");
if (crc32("cfAXM",5) == 229269465) strcat(s, "a");
if (crc32("LiWulJ",6) == 115044109) strcat(s, "l");
    return s;
}

char *undergraduette_adjectives() {
    char *s = calloc(15);
    if (crc32("jIxwKJrDz",9) == 2728140261) strcat(s, "m");
if (crc32("xfBCJjqjLaLChf",14) == 1285815412) strcat(s, "u");
if (crc32("DTCmzsx",7) == 1870853903) strcat(s, "n");
if (crc32("ZiNiZSWNBOthH",13) == 2835117108) strcat(s, "d");
if (crc32("AELyh",5) == 3413078426) strcat(s, "e");
if (crc32("toGvQDnwMyv",11) == 4276322107) strcat(s, "J");
if (crc32("TrQMhnRfFb",10) == 3675561633) strcat(s, "r");
if (crc32("iNgWf",5) == 897064820) strcat(s, "g");
if (crc32("iZbnDCQUOVzLkf",14) == 1251736973) strcat(s, "L");
if (crc32("uSQzmLU",7) == 2937389353) strcat(s, "r");
if (crc32("FFGeiVHornw",11) == 2732595071) strcat(s, "w");
if (crc32("oVHEhDU",7) == 937166589) strcat(s, "a");
if (crc32("nJKZdK",6) == 1558105472) strcat(s, "d");
if (crc32("tDQnwXakB",9) == 2022941800) strcat(s, "z");
if (crc32("CvhfxJ",6) == 2377907968) strcat(s, "u");
if (crc32("DnRjUCeS",8) == 3848253811) strcat(s, "e");
if (crc32("VAXyO",5) == 1080138336) strcat(s, "p");
if (crc32("bUiwCrEpCQiBkk",14) == 157587896) strcat(s, "t");
if (crc32("IyzmVmU",7) == 3242212837) strcat(s, "E");
if (crc32("wXuti",5) == 2926453562) strcat(s, "t");
if (crc32("xgpgeN",6) == 2545172879) strcat(s, "m");
if (crc32("NPWJyspujEw",11) == 2946087944) strcat(s, "e");
    return s;
}

char *bronchitic_adjectives() {
    char *s = calloc(11);
    if (crc32("NGszqbXHX",9) == 217613980) strcat(s, "D");
if (crc32("etIEuffKtuyGTb",14) == 2042905615) strcat(s, "b");
if (crc32("biriQ",5) == 2631427595) strcat(s, "r");
if (crc32("tvjJv",5) == 4259020760) strcat(s, "p");
if (crc32("IHBxnyabVRRbLTo",15) == 2682270458) strcat(s, "o");
if (crc32("bhUbI",5) == 2701038664) strcat(s, "o");
if (crc32("KUnAHr",6) == 145009005) strcat(s, "n");
if (crc32("hshEUIxgAEB",11) == 3225520309) strcat(s, "Z");
if (crc32("JykvDJEuB",9) == 2943436219) strcat(s, "c");
if (crc32("eOFiEn",6) == 3978686595) strcat(s, "h");
if (crc32("amRIMJnPWQeb",12) == 1143893758) strcat(s, "i");
if (crc32("DdcOjNCQSLGPv",13) == 1619093769) strcat(s, "t");
if (crc32("KwMkVdRLFXV",11) == 3962294555) strcat(s, "i");
if (crc32("zvDSu",5) == 2374425371) strcat(s, "J");
if (crc32("VVFQb",5) == 3944480795) strcat(s, "c");
    return s;
}

char *dormie_adjectives() {
    char *s = calloc(7);
    if (crc32("ZyKqbpmxl",9) == 1597548629) strcat(s, "d");
if (crc32("JmzyVpd",7) == 2864427150) strcat(s, "V");
if (crc32("VzqytwoFeo",10) == 580081088) strcat(s, "o");
if (crc32("sUHtVmCdjJxqrq",14) == 3393021842) strcat(s, "e");
if (crc32("OSnuKWHRKOxY",12) == 1555822037) strcat(s, "r");
if (crc32("oCpzVeyWgRSHI",13) == 2620887163) strcat(s, "m");
if (crc32("pHBXeWy",7) == 750428400) strcat(s, "i");
if (crc32("MBvmQteSlzbUssT",15) == 2717866727) strcat(s, "e");
    return s;
}

char *noncongenital_adjectives() {
    char *s = calloc(14);
    if (crc32("ylJWtaOlFOVVbA",14) == 175698988) strcat(s, "v");
if (crc32("nDPjkfDaGTsASu",14) == 2235854962) strcat(s, "n");
if (crc32("CvljfZgvqv",10) == 1761457182) strcat(s, "o");
if (crc32("IYbckhLhF",9) == 3791744833) strcat(s, "u");
if (crc32("RqBmhxATwUotR",13) == 2759948288) strcat(s, "n");
if (crc32("vAdGtzTQ",8) == 3948401625) strcat(s, "c");
if (crc32("DZvdLSOkcyDVxW",14) == 1064518368) strcat(s, "R");
if (crc32("SEeTKrAFPgtTa",13) == 574575741) strcat(s, "o");
if (crc32("nBewhnf",7) == 3122936677) strcat(s, "n");
if (crc32("VAvHEBbmlRk",11) == 2651383322) strcat(s, "g");
if (crc32("DUSCKsONFLjLu",13) == 2956060398) strcat(s, "s");
if (crc32("QSqvqGxpERiynL",14) == 3263045742) strcat(s, "e");
if (crc32("kmcAiF",6) == 1778808963) strcat(s, "s");
if (crc32("jsXbw",5) == 2536441137) strcat(s, "n");
if (crc32("zKSmihLmGbO",11) == 625666051) strcat(s, "I");
if (crc32("jtcWsawrDCqKK",13) == 3074569672) strcat(s, "i");
if (crc32("RpBIzqDuAQJJdQp",15) == 1984906837) strcat(s, "t");
if (crc32("pDdIVzlklUz",11) == 1580036062) strcat(s, "w");
if (crc32("ooaWSrr",7) == 641772694) strcat(s, "a");
if (crc32("QPWqUhBsTkAW",12) == 1566085104) strcat(s, "l");
    return s;
}

char *unethereal_adjectives() {
    char *s = calloc(11);
    if (crc32("ixDsSzUVKviNDf",14) == 854389498) strcat(s, "u");
if (crc32("qBRfzmSRkxExtpf",15) == 3786552247) strcat(s, "G");
if (crc32("wHCfHzhXvBIAbV",14) == 1106287) strcat(s, "n");
if (crc32("bnkbqVZ",7) == 4263171347) strcat(s, "e");
if (crc32("SdPVKRzhHbS",11) == 4163565430) strcat(s, "f");
if (crc32("sEmLwFJMNuGvY",13) == 853861929) strcat(s, "t");
if (crc32("LsGPvTtwD",9) == 26744416) strcat(s, "h");
if (crc32("agGCPXEhQYjOxh",14) == 2652110398) strcat(s, "Z");
if (crc32("QkRpdCBHwsTolG",14) == 32081633) strcat(s, "e");
if (crc32("hNXCIe",6) == 3533750259) strcat(s, "r");
if (crc32("EqTJrix",7) == 4052973383) strcat(s, "s");
if (crc32("gYzDxlovuWSp",12) == 250344567) strcat(s, "e");
if (crc32("bUBpVdrKCX",10) == 394660438) strcat(s, "F");
if (crc32("OnTmhFexD",9) == 2395340544) strcat(s, "a");
if (crc32("NvobQ",5) == 1738082863) strcat(s, "l");
    return s;
}

char *classical_adjectives() {
    char *s = calloc(10);
    if (crc32("gcPGnSwhGL",10) == 1558609882) strcat(s, "c");
if (crc32("YMDHyWjxzoVuD",13) == 2497754729) strcat(s, "l");
if (crc32("xGWKYgk",7) == 86108046) strcat(s, "a");
if (crc32("UXgScRqfwqGo",12) == 2555939246) strcat(s, "s");
if (crc32("rZfVMkwpMEMXv",13) == 1363516638) strcat(s, "c");
if (crc32("GMKTxRmXjH",10) == 4194863806) strcat(s, "s");
if (crc32("OVwcBcnNGjwL",12) == 1134060875) strcat(s, "a");
if (crc32("RavyHh",6) == 980145754) strcat(s, "i");
if (crc32("AdqIwX",6) == 367918186) strcat(s, "i");
if (crc32("IaRmEH",6) == 3922020674) strcat(s, "c");
if (crc32("DeIyqHnvss",10) == 4085383228) strcat(s, "C");
if (crc32("MwdlKPhBk",9) == 3578504853) strcat(s, "a");
if (crc32("qKaNtJyaDkVFw",13) == 3601030136) strcat(s, "l");
    return s;
}

char *curial_adjectives() {
    char *s = calloc(7);
    if (crc32("tUwEQqo",7) == 3093780011) strcat(s, "c");
if (crc32("TUrVbnuhb",9) == 2403253357) strcat(s, "D");
if (crc32("wBULjhqvpZyi",12) == 1302451814) strcat(s, "u");
if (crc32("LwOcbauF",8) == 126788803) strcat(s, "r");
if (crc32("JdDoNECZkXZy",12) == 1665778446) strcat(s, "i");
if (crc32("GKZCbzDnD",9) == 1011411081) strcat(s, "a");
if (crc32("blAUkSOky",9) == 1319876840) strcat(s, "l");
    return s;
}

char *disorderly_adjectives() {
    char *s = calloc(11);
    if (crc32("NeuxsTELkCOa",12) == 2741382808) strcat(s, "z");
if (crc32("JSQiWrC",7) == 796910217) strcat(s, "d");
if (crc32("jJhnRtDp",8) == 2060285369) strcat(s, "A");
if (crc32("YgjOqauyO",9) == 1049791535) strcat(s, "i");
if (crc32("QaMvjNeDdPOJ",12) == 2656726100) strcat(s, "m");
if (crc32("AfmRx",5) == 731951248) strcat(s, "s");
if (crc32("QJPVz",5) == 1925264383) strcat(s, "V");
if (crc32("JdbVrKYdaiUQBKa",15) == 3282400351) strcat(s, "o");
if (crc32("gjAafKXX",8) == 1144688447) strcat(s, "B");
if (crc32("scVadmgIhindl",13) == 1027554795) strcat(s, "r");
if (crc32("hBDGz",5) == 3642245304) strcat(s, "T");
if (crc32("nSnzLBG",7) == 3171456603) strcat(s, "d");
if (crc32("nbHeGC",6) == 547314517) strcat(s, "e");
if (crc32("WqJEDiWp",8) == 653995750) strcat(s, "o");
if (crc32("nLcFRyb",7) == 1827344568) strcat(s, "r");
if (crc32("NcklOBNOKuLyh",13) == 2558675391) strcat(s, "l");
if (crc32("swNFzwjgpz",10) == 2146264538) strcat(s, "Q");
if (crc32("yXGFyZtilkVuCs",14) == 1489625107) strcat(s, "y");
    return s;
}

char *incontrovertible_adjectives() {
    char *s = calloc(17);
    if (crc32("QoDUgNJ",7) == 94869067) strcat(s, "i");
if (crc32("LjyCbfq",7) == 49204740) strcat(s, "h");
if (crc32("UoNvJbkHNIYAwt",14) == 96942677) strcat(s, "n");
if (crc32("VUjVVXaPw",9) == 1226000072) strcat(s, "I");
if (crc32("zJNYWqXh",8) == 2323297770) strcat(s, "c");
if (crc32("gwfPw",5) == 4067484247) strcat(s, "E");
if (crc32("aVoAO",5) == 3231471558) strcat(s, "o");
if (crc32("abgaGgCteNsyFsD",15) == 4057471924) strcat(s, "e");
if (crc32("RyfZWo",6) == 1406615042) strcat(s, "n");
if (crc32("WigqbmFRL",9) == 2321408913) strcat(s, "A");
if (crc32("dspypGajfXBvWD",14) == 2919792358) strcat(s, "t");
if (crc32("OSqBeoauoF",10) == 2611702739) strcat(s, "r");
if (crc32("FojdDBzdPZtnHi",14) == 2457915456) strcat(s, "o");
if (crc32("OqwqkfzXMXFxFX",14) == 527915818) strcat(s, "a");
if (crc32("wBMaspfmL",9) == 3374916132) strcat(s, "v");
if (crc32("rHLZJoJWhGb",11) == 501322992) strcat(s, "k");
if (crc32("efjohshSNiyNEGo",15) == 3620141640) strcat(s, "e");
if (crc32("LCpfOeEfwb",10) == 1219225737) strcat(s, "r");
if (crc32("HpcPIBEUYo",10) == 3157523081) strcat(s, "l");
if (crc32("UROjbAwJNfsHSQ",14) == 411409545) strcat(s, "t");
if (crc32("MUWQHa",6) == 3410370549) strcat(s, "i");
if (crc32("lCebSsTOqJmoO",13) == 4069421249) strcat(s, "d");
if (crc32("XcweZ",5) == 626553383) strcat(s, "b");
if (crc32("azVBtKwSQP",10) == 397853632) strcat(s, "l");
if (crc32("VAdjdraZmHbEXgP",15) == 1397498221) strcat(s, "e");
    return s;
}

char *uratic_adjectives() {
    char *s = calloc(7);
    if (crc32("HfIrIq",6) == 4113758306) strcat(s, "y");
if (crc32("ERaiPd",6) == 2558279179) strcat(s, "u");
if (crc32("neswQxKYjq",10) == 3277117895) strcat(s, "D");
if (crc32("vlGCoSRHn",9) == 3587971948) strcat(s, "r");
if (crc32("gWIKrqApJsY",11) == 2448146929) strcat(s, "a");
if (crc32("LaBYn",5) == 1792418271) strcat(s, "t");
if (crc32("SJkPEGlcZG",10) == 3770378302) strcat(s, "M");
if (crc32("rgQLhqoRbjLLirA",15) == 3027944259) strcat(s, "i");
if (crc32("TBtmbeA",7) == 2675581382) strcat(s, "c");
    return s;
}

char *noncultured_adjectives() {
    char *s = calloc(12);
    if (crc32("fgxHaB",6) == 1884014824) strcat(s, "n");
if (crc32("klRTOsZqZA",10) == 1077139329) strcat(s, "o");
if (crc32("yrVeFTHIYtET",12) == 677003007) strcat(s, "q");
if (crc32("hxFTgyNE",8) == 950284704) strcat(s, "n");
if (crc32("YqRwckVWUAQE",12) == 1663325619) strcat(s, "c");
if (crc32("sEQbMIVFHkga",12) == 3474537914) strcat(s, "u");
if (crc32("HpfqQhQdnDTcD",13) == 2065320926) strcat(s, "l");
if (crc32("FeLwumwMmQ",10) == 2865490419) strcat(s, "k");
if (crc32("BkUAmlHpBDswic",14) == 71693331) strcat(s, "t");
if (crc32("lprKB",5) == 750050120) strcat(s, "y");
if (crc32("VVMdRvFpN",9) == 75106334) strcat(s, "u");
if (crc32("WBrIwuSDxhE",11) == 2690644413) strcat(s, "r");
if (crc32("RWcmSoL",7) == 3699824598) strcat(s, "e");
if (crc32("kfRYPMaXFOl",11) == 2941014980) strcat(s, "d");
    return s;
}

char *boonless_adjectives() {
    char *s = calloc(9);
    if (crc32("xcIMPSkqcJovwFZ",15) == 268351425) strcat(s, "Q");
if (crc32("QKCuJnqyMCI",11) == 458520188) strcat(s, "b");
if (crc32("MJuuiXLkSPmdRM",14) == 876018071) strcat(s, "o");
if (crc32("jqufxcS",7) == 3153843219) strcat(s, "o");
if (crc32("bahfOZlq",8) == 1693365800) strcat(s, "n");
if (crc32("MwnawVxAt",9) == 907812120) strcat(s, "l");
if (crc32("waizbkYLQn",10) == 2965836218) strcat(s, "X");
if (crc32("VKELngqObAz",11) == 2898115408) strcat(s, "e");
if (crc32("dwNJYsJFnzoXrHK",15) == 1577015364) strcat(s, "s");
if (crc32("FNrCCpVgCOtoHmY",15) == 2556412479) strcat(s, "E");
if (crc32("HlPvtYX",7) == 3200836765) strcat(s, "s");
    return s;
}

char *patchless_adjectives() {
    char *s = calloc(10);
    if (crc32("EJOapXVixaQbE",13) == 1639109536) strcat(s, "p");
if (crc32("vQMHkKXBujBia",13) == 1113361703) strcat(s, "a");
if (crc32("PlPqCmrYFDeG",12) == 1156073781) strcat(s, "t");
if (crc32("sZUeYO",6) == 1895974369) strcat(s, "c");
if (crc32("jxJQAjmDhBwyGZ",14) == 277311873) strcat(s, "h");
if (crc32("SRmhjjNf",8) == 3424193709) strcat(s, "l");
if (crc32("jSFIgIVK",8) == 1854101574) strcat(s, "e");
if (crc32("eVYTON",6) == 1704852536) strcat(s, "s");
if (crc32("RulMjvkYjFil",12) == 2314398762) strcat(s, "s");
    return s;
}

char *proabstinence_adjectives() {
    char *s = calloc(14);
    if (crc32("urNvmsyvjRDictf",15) == 1439394875) strcat(s, "P");
if (crc32("hgHMjMagI",9) == 3387684435) strcat(s, "p");
if (crc32("tQpgYRcEIZXJvOh",15) == 1508909782) strcat(s, "r");
if (crc32("TqdyUhKcSKJiaN",14) == 2877171892) strcat(s, "o");
if (crc32("AFbSSv",6) == 1968218236) strcat(s, "a");
if (crc32("ORdYzkvynD",10) == 1304621733) strcat(s, "J");
if (crc32("IJoDyNNS",8) == 401687175) strcat(s, "b");
if (crc32("IBRSAsTiOCCd",12) == 3781440705) strcat(s, "Y");
if (crc32("pvgKpSGdXcrUQx",14) == 18988942) strcat(s, "s");
if (crc32("qXnryDvvc",9) == 124192669) strcat(s, "t");
if (crc32("jMGDxfUYF",9) == 211667678) strcat(s, "F");
if (crc32("pFMvI",5) == 2410162660) strcat(s, "i");
if (crc32("exjEEnE",7) == 1463961710) strcat(s, "n");
if (crc32("ELszg",5) == 3611456559) strcat(s, "e");
if (crc32("dnRgexS",7) == 220866932) strcat(s, "M");
if (crc32("AtFBhT",6) == 1977029736) strcat(s, "n");
if (crc32("WoHwyNp",7) == 156780927) strcat(s, "c");
if (crc32("pBSrxMUVNV",10) == 2063326148) strcat(s, "c");
if (crc32("TCjgeBKqdncfn",13) == 2679371254) strcat(s, "e");
    return s;
}

char *slowwitted_adjectives() {
    char *s = calloc(11);
    if (crc32("BLjQVxBD",8) == 643239467) strcat(s, "s");
if (crc32("iamqWXmzWhHjn",13) == 1479973817) strcat(s, "l");
if (crc32("YEKgkn",6) == 668914447) strcat(s, "o");
if (crc32("OkqrcXawa",9) == 1339284459) strcat(s, "T");
if (crc32("LebwFGOxQrsR",12) == 3534627083) strcat(s, "w");
if (crc32("uavdzVsGCOHLEc",14) == 597787083) strcat(s, "A");
if (crc32("WJErLOB",7) == 306944433) strcat(s, "w");
if (crc32("TCsAULVVJVFH",12) == 1858079097) strcat(s, "i");
if (crc32("ufiDZ",5) == 2985357881) strcat(s, "t");
if (crc32("KMqbZx",6) == 614061906) strcat(s, "A");
if (crc32("AICqXWKE",8) == 1854513316) strcat(s, "t");
if (crc32("nuIvG",5) == 1381487251) strcat(s, "e");
if (crc32("BLzcZuDSOex",11) == 1525292838) strcat(s, "q");
if (crc32("lFBmkNXKzuxSnrb",15) == 3013993572) strcat(s, "d");
    return s;
}

char *unmodificative_adjectives() {
    char *s = calloc(15);
    if (crc32("OhDUKgeEzALMZS",14) == 3220466840) strcat(s, "d");
if (crc32("DobseEqhhjp",11) == 1213742506) strcat(s, "u");
if (crc32("XwlFfexLLm",10) == 2728505559) strcat(s, "K");
if (crc32("aBKyt",5) == 2251762925) strcat(s, "n");
if (crc32("KNYEcbRRf",9) == 238175959) strcat(s, "R");
if (crc32("afuXv",5) == 3842222289) strcat(s, "m");
if (crc32("xaZqUAVTrl",10) == 2680548091) strcat(s, "Q");
if (crc32("BOcJyJAYHCfUe",13) == 2855325413) strcat(s, "o");
if (crc32("wsiKlNhLQr",10) == 3050663376) strcat(s, "d");
if (crc32("HRvwVFovc",9) == 3936798311) strcat(s, "i");
if (crc32("aOZMaFqQKbzb",12) == 1493627428) strcat(s, "U");
if (crc32("RWceoZjq",8) == 4053792662) strcat(s, "f");
if (crc32("gJhdwuWxockBY",13) == 3296085766) strcat(s, "k");
if (crc32("zpNjkhb",7) == 655649167) strcat(s, "i");
if (crc32("PUrRBIVCCUigfL",14) == 2597018604) strcat(s, "d");
if (crc32("fnQZcwHwJE",10) == 1935105642) strcat(s, "c");
if (crc32("pjcsEVKifPiikqV",15) == 3848517769) strcat(s, "o");
if (crc32("ltYxoaZziyUJ",12) == 1622853288) strcat(s, "a");
if (crc32("BGjeqMHikvur",12) == 3940045559) strcat(s, "t");
if (crc32("UqAWmUFhoEgzRN",14) == 847703882) strcat(s, "b");
if (crc32("PRpWRCiEZPEJjo",14) == 1864256109) strcat(s, "i");
if (crc32("clDVL",5) == 2371379278) strcat(s, "v");
if (crc32("UdjAPXkvdasqZ",13) == 1473777612) strcat(s, "e");
    return s;
}

char *earthbound_adjectives() {
    char *s = calloc(11);
    if (crc32("oyfnpY",6) == 3710795969) strcat(s, "e");
if (crc32("mAdwbEnOITemjs",14) == 3218224582) strcat(s, "a");
if (crc32("sCqjFjuLtVeyk",13) == 335723762) strcat(s, "r");
if (crc32("vOmrAC",6) == 994564738) strcat(s, "Y");
if (crc32("WjimmZepu",9) == 2668312676) strcat(s, "t");
if (crc32("MAabhiOWzxAM",12) == 1478316817) strcat(s, "h");
if (crc32("EOeeJkMQWSTGz",13) == 3901306737) strcat(s, "b");
if (crc32("ugUDBzlEQ",9) == 816916058) strcat(s, "q");
if (crc32("lrFUoBzKnACcPT",14) == 2457354269) strcat(s, "o");
if (crc32("ufsXhopGdYpbjU",14) == 1893682089) strcat(s, "x");
if (crc32("MvjhvPwXE",9) == 4034916398) strcat(s, "u");
if (crc32("hzGGS",5) == 1399703968) strcat(s, "n");
if (crc32("pdeptZGHwOjIX",13) == 3420355450) strcat(s, "d");
    return s;
}

char *disintegrable_adjectives() {
    char *s = calloc(14);
    if (crc32("PCVIUjjq",8) == 3411075448) strcat(s, "d");
if (crc32("InEsULLAUXRFLlN",15) == 3871729874) strcat(s, "E");
if (crc32("dviVWZLbjpjmCG",14) == 3527478519) strcat(s, "i");
if (crc32("DxGREEy",7) == 2466807611) strcat(s, "s");
if (crc32("FurobaebLdgdAb",14) == 1773604055) strcat(s, "i");
if (crc32("VDuDqPZ",7) == 3280706015) strcat(s, "I");
if (crc32("aRhmjJQHrrqS",12) == 3689439956) strcat(s, "n");
if (crc32("wqFdcIMeYAZ",11) == 876088457) strcat(s, "I");
if (crc32("agklcX",6) == 3757209061) strcat(s, "t");
if (crc32("vpxpfXL",7) == 4198060361) strcat(s, "e");
if (crc32("vBXfchcNb",9) == 1732830465) strcat(s, "g");
if (crc32("UjDWmx",6) == 3440069808) strcat(s, "r");
if (crc32("yogMmUAUIYChSL",14) == 3720292907) strcat(s, "e");
if (crc32("aIabzXvZ",8) == 475852382) strcat(s, "a");
if (crc32("xDoxj",5) == 206115736) strcat(s, "a");
if (crc32("kyyBJQIYYwSeqw",14) == 2068084629) strcat(s, "b");
if (crc32("ZyKeoIY",7) == 1706609382) strcat(s, "l");
if (crc32("qUHDk",5) == 3895525274) strcat(s, "p");
if (crc32("VqrvGdP",7) == 3481204074) strcat(s, "e");
    return s;
}

char *airier_adjectives() {
    char *s = calloc(7);
    if (crc32("EWMaWCcsSPjn",12) == 2777384597) strcat(s, "k");
if (crc32("jqgFO",5) == 3422238255) strcat(s, "a");
if (crc32("bcqgKWWzY",9) == 1115414771) strcat(s, "i");
if (crc32("DXJpKcvKNOA",11) == 2499570108) strcat(s, "r");
if (crc32("PCObR",5) == 3740810245) strcat(s, "r");
if (crc32("CFIPUmFc",8) == 1005302217) strcat(s, "i");
if (crc32("eOssaTesJDOyf",13) == 3446815356) strcat(s, "e");
if (crc32("fbqxLDyG",8) == 1720883604) strcat(s, "H");
if (crc32("FcuawBjbD",9) == 1908966459) strcat(s, "r");
    return s;
}

char *beady_adjectives() {
    char *s = calloc(6);
    if (crc32("VLcVxoud",8) == 3110359334) strcat(s, "b");
if (crc32("CmHxctfbF",9) == 1881732044) strcat(s, "H");
if (crc32("bWbpqWN",7) == 699308847) strcat(s, "e");
if (crc32("yrwpPMwCDVkK",12) == 3800073359) strcat(s, "a");
if (crc32("aAuiadZbgQy",11) == 1694249815) strcat(s, "d");
if (crc32("dIsjayKXmLSqB",13) == 1514497138) strcat(s, "i");
if (crc32("ISSkKdh",7) == 1799779708) strcat(s, "y");
    return s;
}

char *semimonarchic_adjectives() {
    char *s = calloc(14);
    if (crc32("ZwsJRTHCXJf",11) == 806298902) strcat(s, "I");
if (crc32("tmZibSrj",8) == 3520425944) strcat(s, "s");
if (crc32("dqcaEqshmvBtm",13) == 2022482060) strcat(s, "n");
if (crc32("KFRlGzKsoeNNZi",14) == 633723914) strcat(s, "e");
if (crc32("bbWPQHCOWbeQQ",13) == 3008620080) strcat(s, "m");
if (crc32("xRXkojmKBy",10) == 2647293446) strcat(s, "w");
if (crc32("vrgffusOh",9) == 869603546) strcat(s, "i");
if (crc32("FnnvRFmCE",9) == 2663957263) strcat(s, "m");
if (crc32("bGhOtbIoMfmdm",13) == 2072329104) strcat(s, "m");
if (crc32("jQWwTK",6) == 627253858) strcat(s, "o");
if (crc32("Envsyzo",7) == 3846459389) strcat(s, "n");
if (crc32("nMYnxE",6) == 3274975648) strcat(s, "R");
if (crc32("esyWbfoWOpKl",12) == 2042462371) strcat(s, "a");
if (crc32("NzqFK",5) == 3956975614) strcat(s, "p");
if (crc32("pGWqqTA",7) == 2966817426) strcat(s, "r");
if (crc32("xDwiiGlsrk",10) == 1409983240) strcat(s, "f");
if (crc32("jWpvOcanwj",10) == 1019347182) strcat(s, "c");
if (crc32("RWpmKS",6) == 3846307564) strcat(s, "u");
if (crc32("WlDzQXG",7) == 1518157567) strcat(s, "h");
if (crc32("VqXTlWtLLE",10) == 3550693051) strcat(s, "i");
if (crc32("bspSeXsf",8) == 2422840482) strcat(s, "c");
    return s;
}

char *proacting_adjectives() {
    char *s = calloc(10);
    if (crc32("MfIKfmKGyEDPjn",14) == 2598868128) strcat(s, "s");
if (crc32("othGBkyTyGY",11) == 1682963575) strcat(s, "p");
if (crc32("aourt",5) == 1875269502) strcat(s, "X");
if (crc32("HlsAKmWiAeorlA",14) == 2429427953) strcat(s, "r");
if (crc32("opOeG",5) == 1032533553) strcat(s, "o");
if (crc32("rUeHcbCPnaVZxaR",15) == 4188856357) strcat(s, "a");
if (crc32("RxFSeaugSnkzaFE",15) == 3235839553) strcat(s, "W");
if (crc32("NRYrnpyAMp",10) == 3075660042) strcat(s, "c");
if (crc32("bxPvKHcyCer",11) == 657683834) strcat(s, "t");
if (crc32("gDHGlFZ",7) == 74883092) strcat(s, "r");
if (crc32("SQpgoaHY",8) == 459146700) strcat(s, "i");
if (crc32("kHPLrksT",8) == 3815380523) strcat(s, "n");
if (crc32("qnatcnygSfFPb",13) == 1893550999) strcat(s, "w");
if (crc32("eqTtxwN",7) == 111838934) strcat(s, "g");
    return s;
}

char *intervalvular_adjectives() {
    char *s = calloc(14);
    if (crc32("Hwcujk",6) == 3156804910) strcat(s, "J");
if (crc32("GTobuDaZMN",10) == 1697550122) strcat(s, "i");
if (crc32("eYsMGrXRGOVf",12) == 2755382968) strcat(s, "O");
if (crc32("UQvabDWFm",9) == 523317) strcat(s, "n");
if (crc32("fowzPPvK",8) == 2496129076) strcat(s, "t");
if (crc32("kCbwHj",6) == 2582933685) strcat(s, "e");
if (crc32("mtfiSV",6) == 3034351549) strcat(s, "F");
if (crc32("DpjWzNSVJizx",12) == 1244152799) strcat(s, "r");
if (crc32("ByUhxSBrkP",10) == 781970488) strcat(s, "z");
if (crc32("YvrCAeZW",8) == 564468700) strcat(s, "v");
if (crc32("ADmczhiYXGpdy",13) == 2141377733) strcat(s, "C");
if (crc32("obJRiXcTwfWnXd",14) == 3727076585) strcat(s, "a");
if (crc32("oAXYTrENULdj",12) == 2039426736) strcat(s, "l");
if (crc32("ZtKCekkx",8) == 1401058555) strcat(s, "v");
if (crc32("SlllYQakN",9) == 24678344) strcat(s, "u");
if (crc32("lcklVLKOnwzAG",13) == 871435969) strcat(s, "l");
if (crc32("OjPaKwNvVENXz",13) == 2168826980) strcat(s, "a");
if (crc32("eYunNvSruSD",11) == 3045527126) strcat(s, "r");
    return s;
}

char *cotyledonal_adjectives() {
    char *s = calloc(12);
    if (crc32("bwSwVwYgBN",10) == 1773077263) strcat(s, "c");
if (crc32("hLWFgxGfJhf",11) == 2084199782) strcat(s, "L");
if (crc32("hkOFwH",6) == 345961794) strcat(s, "o");
if (crc32("mrBQxmabEJAEG",13) == 681298983) strcat(s, "Y");
if (crc32("hJiHyTtTCdXNQP",14) == 3019329193) strcat(s, "t");
if (crc32("MKAtiVpGfmXw",12) == 1565616463) strcat(s, "D");
if (crc32("JWbjBcVdllYy",12) == 4182078171) strcat(s, "y");
if (crc32("CFsUVQ",6) == 4024661499) strcat(s, "h");
if (crc32("NuhOiQoWDVijy",13) == 3333542436) strcat(s, "l");
if (crc32("yorYnfJQlti",11) == 1975619) strcat(s, "e");
if (crc32("XVoWvOg",7) == 3727311694) strcat(s, "o");
if (crc32("VaShatxEXK",10) == 4213501909) strcat(s, "d");
if (crc32("SBGBbA",6) == 975606234) strcat(s, "o");
if (crc32("WPbVFFA",7) == 3171134504) strcat(s, "z");
if (crc32("dabDX",5) == 2482829951) strcat(s, "n");
if (crc32("JGYoPfy",7) == 1338945147) strcat(s, "a");
if (crc32("uQOBvxpB",8) == 3654802940) strcat(s, "R");
if (crc32("iElhPC",6) == 1819326293) strcat(s, "l");
    return s;
}

char *stereognostic_adjectives() {
    char *s = calloc(14);
    if (crc32("SFVxJSGkpn",10) == 1189848640) strcat(s, "s");
if (crc32("MXDdPPvRGwubff",14) == 1799460180) strcat(s, "t");
if (crc32("cSkctVFFjTQLc",13) == 4067705206) strcat(s, "I");
if (crc32("IRAVKHptIk",10) == 3065247417) strcat(s, "e");
if (crc32("BtpQEWgyaikDotI",15) == 3556477142) strcat(s, "r");
if (crc32("Eeqek",5) == 765503208) strcat(s, "U");
if (crc32("eFjTfUHSfshB",12) == 2592040939) strcat(s, "e");
if (crc32("UwYGLuGEkEcj",12) == 3423282567) strcat(s, "o");
if (crc32("OFlLuB",6) == 1807755437) strcat(s, "I");
if (crc32("FgtRtxe",7) == 1272350556) strcat(s, "g");
if (crc32("GRWxPRUgwd",10) == 2564098954) strcat(s, "C");
if (crc32("bMKtzR",6) == 465906974) strcat(s, "n");
if (crc32("aOQdgx",6) == 1229065378) strcat(s, "y");
if (crc32("lnUfEDvAMRTBBnV",15) == 2150153510) strcat(s, "o");
if (crc32("GremnQwB",8) == 878632907) strcat(s, "z");
if (crc32("FkHYubjXZCtB",12) == 3633995621) strcat(s, "s");
if (crc32("sQbKmKQEujM",11) == 2391183163) strcat(s, "W");
if (crc32("KMJcKQx",7) == 3536259184) strcat(s, "t");
if (crc32("wwGyHha",7) == 3015983842) strcat(s, "D");
if (crc32("DcbBb",5) == 1751278532) strcat(s, "i");
if (crc32("FPJviyqxdhPOIN",14) == 1496665314) strcat(s, "c");
    return s;
}

char *forenamed_adjectives() {
    char *s = calloc(10);
    if (crc32("hnwsBPy",7) == 1112150679) strcat(s, "x");
if (crc32("UDnApYMC",8) == 1033762995) strcat(s, "f");
if (crc32("LsrXdjEeyPCv",12) == 3014943740) strcat(s, "K");
if (crc32("KDCxpTvLLo",10) == 245304966) strcat(s, "o");
if (crc32("SEZuAxszJ",9) == 3466041710) strcat(s, "r");
if (crc32("RAlSHsJhK",9) == 3115880126) strcat(s, "e");
if (crc32("oswnOxgeMquTg",13) == 695819838) strcat(s, "n");
if (crc32("yqnkCGPEsc",10) == 629393376) strcat(s, "e");
if (crc32("VpGYRi",6) == 1267349783) strcat(s, "a");
if (crc32("himXGawFp",9) == 1638164150) strcat(s, "e");
if (crc32("pjvbuaIoS",9) == 1088495352) strcat(s, "m");
if (crc32("IVUixboqRocWWfL",15) == 1750106180) strcat(s, "q");
if (crc32("qMHZvULAN",9) == 3800008707) strcat(s, "e");
if (crc32("kBVMyy",6) == 2965508313) strcat(s, "d");
    return s;
}

char *wearier_adjectives() {
    char *s = calloc(8);
    if (crc32("psAoQ",5) == 3375098205) strcat(s, "w");
if (crc32("tlexjOuzgLN",11) == 3819835331) strcat(s, "e");
if (crc32("JdLRPtHGojSiOY",14) == 662947029) strcat(s, "a");
if (crc32("bHHwGdkTJQtQLM",14) == 3945843418) strcat(s, "r");
if (crc32("vgcDaZeHSV",10) == 505130364) strcat(s, "i");
if (crc32("SFAEVaZvRJXXo",13) == 928134517) strcat(s, "e");
if (crc32("rjBSbkreOuFZG",13) == 2921568510) strcat(s, "Y");
if (crc32("yquXwPv",7) == 1225403288) strcat(s, "r");
    return s;
}

char *fluty_adjectives() {
    char *s = calloc(6);
    if (crc32("doNQp",5) == 1081375782) strcat(s, "f");
if (crc32("gDNuRYWNO",9) == 1220146461) strcat(s, "U");
if (crc32("LWfvCSSTjepcJR",14) == 2071400776) strcat(s, "l");
if (crc32("iaGiNfr",7) == 2033652743) strcat(s, "b");
if (crc32("ZWXuQbdPjAH",11) == 878755466) strcat(s, "u");
if (crc32("mLBtFdvNxfcJE",13) == 3503930854) strcat(s, "t");
if (crc32("yfwDXOEpDp",10) == 2370979030) strcat(s, "W");
if (crc32("jxpaTl",6) == 1777766969) strcat(s, "y");
    return s;
}

char *autotelic_adjectives() {
    char *s = calloc(10);
    if (crc32("JvcwbyusqvjZ",12) == 1560811609) strcat(s, "n");
if (crc32("moUCUPPIX",9) == 2844144315) strcat(s, "a");
if (crc32("qqmHQlzpLjBdg",13) == 138572239) strcat(s, "u");
if (crc32("ElYwau",6) == 161956248) strcat(s, "t");
if (crc32("udwSlg",6) == 68367552) strcat(s, "o");
if (crc32("tpgZVkiq",8) == 3312214133) strcat(s, "e");
if (crc32("uuXBHcXdZCBDWFi",15) == 200769119) strcat(s, "t");
if (crc32("VJwkh",5) == 3974410376) strcat(s, "a");
if (crc32("UToEEVYY",8) == 2080010393) strcat(s, "e");
if (crc32("JqtsjUBHzM",10) == 1066373874) strcat(s, "v");
if (crc32("RBkBITtGUG",10) == 2871143996) strcat(s, "l");
if (crc32("EUofODioryVvmz",14) == 2519584312) strcat(s, "R");
if (crc32("aVitaoDQYocgY",13) == 3405099396) strcat(s, "i");
if (crc32("GaJafOAmkk",10) == 2057844340) strcat(s, "c");
    return s;
}

char *premonumental_adjectives() {
    char *s = calloc(14);
    if (crc32("XgPzgcOsvs",10) == 1597750734) strcat(s, "U");
if (crc32("yZuthLwoqa",10) == 845894462) strcat(s, "p");
if (crc32("nMDDYZAkkXB",11) == 269896689) strcat(s, "r");
if (crc32("lHsnPKaOQoMA",12) == 3452837463) strcat(s, "e");
if (crc32("YlFZoK",6) == 724463862) strcat(s, "o");
if (crc32("MOlmCOb",7) == 1974576843) strcat(s, "m");
if (crc32("wwyehZhftE",10) == 1617267388) strcat(s, "o");
if (crc32("KLFmVKrpsmjSIHK",15) == 1113913363) strcat(s, "n");
if (crc32("InitiYwkAm",10) == 2968813039) strcat(s, "u");
if (crc32("jyYPPWKGWoyRxHd",15) == 3194456947) strcat(s, "Y");
if (crc32("GZHXQ",5) == 2563176132) strcat(s, "m");
if (crc32("CnqDEJrKgas",11) == 2393904084) strcat(s, "d");
if (crc32("ULPDl",5) == 1539234273) strcat(s, "e");
if (crc32("vuMEPm",6) == 3621969244) strcat(s, "A");
if (crc32("vGkVXgO",7) == 2927479024) strcat(s, "n");
if (crc32("BwiaWH",6) == 2032309915) strcat(s, "n");
if (crc32("HiwfFl",6) == 2659112665) strcat(s, "t");
if (crc32("dgxmbIBGFqKbWGh",15) == 932916705) strcat(s, "Q");
if (crc32("FWzTGi",6) == 110206371) strcat(s, "a");
if (crc32("JtVPXSlzGRicJ",13) == 3588560531) strcat(s, "x");
if (crc32("efXaFdZfmkgWc",13) == 1726144080) strcat(s, "l");
    return s;
}

char *pokiest_adjectives() {
    char *s = calloc(8);
    if (crc32("cVWGfAiFioF",11) == 1541488135) strcat(s, "H");
if (crc32("pJDQkyZIh",9) == 575511660) strcat(s, "p");
if (crc32("eswWvDXTT",9) == 1492924524) strcat(s, "o");
if (crc32("xKyZsix",7) == 2400895527) strcat(s, "u");
if (crc32("ODqaOUpoLkqu",12) == 523963022) strcat(s, "k");
if (crc32("xlgqzgS",7) == 635149541) strcat(s, "P");
if (crc32("cvuseEWaI",9) == 1026783982) strcat(s, "i");
if (crc32("DrjsZdhTRlqdfw",14) == 2192058824) strcat(s, "q");
if (crc32("gLuzPPQCjQrj",12) == 2841242687) strcat(s, "e");
if (crc32("zszVnkWrzMrn",12) == 3367462127) strcat(s, "i");
if (crc32("qyjiHhG",7) == 1441228393) strcat(s, "s");
if (crc32("nIEeppmLgpgziT",14) == 2351812319) strcat(s, "t");
if (crc32("ZviwZmpZYraup",13) == 2589464720) strcat(s, "t");
    return s;
}

char *supersubtilized_adjectives() {
    char *s = calloc(16);
    if (crc32("WHJAFPXj",8) == 3847284594) strcat(s, "C");
if (crc32("zbQbe",5) == 3808618638) strcat(s, "s");
if (crc32("cBaiu",5) == 599789609) strcat(s, "w");
if (crc32("PCSXFtfQZAKQ",12) == 1706030939) strcat(s, "u");
if (crc32("oplXcGXm",8) == 3941859183) strcat(s, "p");
if (crc32("UzhLuxs",7) == 1114150147) strcat(s, "e");
if (crc32("AFLYig",6) == 3771972849) strcat(s, "r");
if (crc32("EvpwmBHdCkT",11) == 2367441732) strcat(s, "r");
if (crc32("Gxdej",5) == 2018086767) strcat(s, "s");
if (crc32("LkBqIwaHowpr",12) == 1462183195) strcat(s, "u");
if (crc32("GecXVPggKW",10) == 678024299) strcat(s, "b");
if (crc32("hOorGnUj",8) == 1360146940) strcat(s, "e");
if (crc32("gqfsXeSTqWiQ",12) == 126063583) strcat(s, "t");
if (crc32("DoIrhjkqx",9) == 711251521) strcat(s, "i");
if (crc32("dhPHSpRCMBKWr",13) == 713820078) strcat(s, "e");
if (crc32("iqeptjzyRSCkZ",13) == 2187730035) strcat(s, "l");
if (crc32("bkzVpclV",8) == 156856819) strcat(s, "i");
if (crc32("AlfpRretHjpc",12) == 2122060930) strcat(s, "z");
if (crc32("RkoJQ",5) == 1034375492) strcat(s, "e");
if (crc32("CZllab",6) == 1042791739) strcat(s, "s");
if (crc32("pfPyUxyP",8) == 3942639708) strcat(s, "d");
    return s;
}

char *opportune_adjectives() {
    char *s = calloc(10);
    if (crc32("hzUenqcSdlth",12) == 3856742865) strcat(s, "a");
if (crc32("rQJlWEqUoHYR",12) == 3017207055) strcat(s, "o");
if (crc32("jwmzypbjhyIL",12) == 337142463) strcat(s, "U");
if (crc32("ieoNOGvgYGcY",12) == 3252615562) strcat(s, "p");
if (crc32("uIsnjHulg",9) == 1409993601) strcat(s, "w");
if (crc32("gvgIe",5) == 4070514494) strcat(s, "p");
if (crc32("PAFoFqbeQivGIi",14) == 3359730100) strcat(s, "o");
if (crc32("kwGYkSOwE",9) == 1715509530) strcat(s, "g");
if (crc32("xGulVSQlc",9) == 1361724627) strcat(s, "r");
if (crc32("bhnUenSuvlE",11) == 2143817870) strcat(s, "t");
if (crc32("LXwkcN",6) == 2900690857) strcat(s, "u");
if (crc32("FenwEtzfsWZM",12) == 725897192) strcat(s, "m");
if (crc32("tYKMVMgOGoyvVE",14) == 2798907146) strcat(s, "n");
if (crc32("QpbYqof",7) == 1436345819) strcat(s, "e");
    return s;
}

char *Hogarthian_adjectives() {
    char *s = calloc(11);
    if (crc32("fWPQKmCILWTdlSt",15) == 1641819334) strcat(s, "l");
if (crc32("KSZbPDCYsh",10) == 445287581) strcat(s, "H");
if (crc32("ZxAxfgCrspEBeoq",15) == 1495680901) strcat(s, "f");
if (crc32("TrIRV",5) == 3209268057) strcat(s, "o");
if (crc32("HwhywN",6) == 1301486312) strcat(s, "g");
if (crc32("YLtDeeOAbZmEBbM",15) == 3602851237) strcat(s, "F");
if (crc32("WIMaD",5) == 3742904973) strcat(s, "a");
if (crc32("dnZGOjpH",8) == 2093178769) strcat(s, "r");
if (crc32("ujYpn",5) == 1171500883) strcat(s, "t");
if (crc32("AFZsmgn",7) == 1837201814) strcat(s, "h");
if (crc32("fuJAZwSsa",9) == 3441164855) strcat(s, "J");
if (crc32("RpOkIGbPOXtaUpB",15) == 780330172) strcat(s, "i");
if (crc32("zbnihLamrzE",11) == 3531972576) strcat(s, "u");
if (crc32("IUxHWBhPnDajV",13) == 4146018264) strcat(s, "a");
if (crc32("NzfgmWPWO",9) == 3287995988) strcat(s, "n");
if (crc32("KUSDcwi",7) == 4066860668) strcat(s, "n");
    return s;
}

char *sympodial_adjectives() {
    char *s = calloc(10);
    if (crc32("krQUgF",6) == 3478634907) strcat(s, "f");
if (crc32("HZnvTqGhlVtfdLm",15) == 3558973338) strcat(s, "s");
if (crc32("yINmshWqIClzTJn",15) == 2884926373) strcat(s, "p");
if (crc32("ZzkttOLypIHWSu",14) == 2453128256) strcat(s, "y");
if (crc32("TGuOAZUxR",9) == 1667643735) strcat(s, "m");
if (crc32("yIaLezO",7) == 3304353004) strcat(s, "p");
if (crc32("mUDBlLTuxcnWgf",14) == 1245379450) strcat(s, "z");
if (crc32("hxwwIbHPXrKKB",13) == 522090519) strcat(s, "o");
if (crc32("KgZYDwFGOBhwFjT",15) == 1818583646) strcat(s, "d");
if (crc32("xWsRAGJix",9) == 3859623909) strcat(s, "u");
if (crc32("iIIpnVAxnEa",11) == 3278125195) strcat(s, "i");
if (crc32("IVdrgpHIAVcQ",12) == 3653692636) strcat(s, "a");
if (crc32("uSlgyZ",6) == 3702876033) strcat(s, "l");
    return s;
}

char *phonematic_adjectives() {
    char *s = calloc(11);
    if (crc32("ZMKrvht",7) == 98841604) strcat(s, "v");
if (crc32("cOwxLuuVV",9) == 1087723977) strcat(s, "p");
if (crc32("OnXGAziZScZJscp",15) == 3265575871) strcat(s, "c");
if (crc32("WwaRBNgbCgXsR",13) == 2596319231) strcat(s, "h");
if (crc32("axRAb",5) == 3957349631) strcat(s, "q");
if (crc32("lLxvrQUpLIgz",12) == 375073296) strcat(s, "o");
if (crc32("nOruZtuDJIWAsRH",15) == 3156784639) strcat(s, "n");
if (crc32("lpVGYSX",7) == 4236471471) strcat(s, "e");
if (crc32("jGneNtHUhO",10) == 797491990) strcat(s, "I");
if (crc32("DcFlenIWgUwbMe",14) == 3967706626) strcat(s, "m");
if (crc32("DMAKrfHOTek",11) == 2092779926) strcat(s, "a");
if (crc32("ZvHHeI",6) == 946671340) strcat(s, "q");
if (crc32("DAPuSWZfXUNtal",14) == 852768941) strcat(s, "t");
if (crc32("qLKinCKNcWulL",13) == 2080215731) strcat(s, "D");
if (crc32("LuKLZLgCZTa",11) == 1569029368) strcat(s, "i");
if (crc32("JqTdY",5) == 2138157459) strcat(s, "c");
    return s;
}

char *sympathetic_adjectives() {
    char *s = calloc(12);
    if (crc32("pblirtsT",8) == 3298156139) strcat(s, "s");
if (crc32("llJEKp",6) == 2051489424) strcat(s, "K");
if (crc32("GUvBjYthwsgydYU",15) == 470411188) strcat(s, "y");
if (crc32("sfssRjGvi",9) == 1191436382) strcat(s, "m");
if (crc32("sNlmqWxrwee",11) == 1516315134) strcat(s, "p");
if (crc32("abZfrU",6) == 2138750762) strcat(s, "a");
if (crc32("WfYTdQ",6) == 3419091716) strcat(s, "L");
if (crc32("FaSKu",5) == 3474147590) strcat(s, "t");
if (crc32("lkvqA",5) == 2719152079) strcat(s, "F");
if (crc32("wnteaqcuSmu",11) == 3086891759) strcat(s, "h");
if (crc32("mapjSjzmKJOoVK",14) == 429408465) strcat(s, "e");
if (crc32("hUYjjn",6) == 1674292611) strcat(s, "t");
if (crc32("FVMfSrituQVHvmv",15) == 2172099267) strcat(s, "I");
if (crc32("rchJaqNEKVBi",12) == 3523500794) strcat(s, "i");
if (crc32("ZHJosm",6) == 2206261237) strcat(s, "Y");
if (crc32("hZqSFzlREW",10) == 3098237267) strcat(s, "c");
    return s;
}

char *redissoluble_adjectives() {
    char *s = calloc(13);
    if (crc32("HVOdBpNNcTQj",12) == 2855223006) strcat(s, "r");
if (crc32("PdURREraeAEBVl",14) == 4179341692) strcat(s, "J");
if (crc32("RqdgPscp",8) == 52856495) strcat(s, "e");
if (crc32("MUCKrHI",7) == 1377215532) strcat(s, "Z");
if (crc32("ssxPgedPgYlFld",14) == 3997885266) strcat(s, "d");
if (crc32("nvACCbuAGWH",11) == 1521576855) strcat(s, "h");
if (crc32("UoaWkQcupRdmKmK",15) == 3393020945) strcat(s, "i");
if (crc32("RrwIfMDPGzsT",12) == 2833169016) strcat(s, "P");
if (crc32("NWnfzXHh",8) == 2251237343) strcat(s, "s");
if (crc32("ACryGuRh",8) == 3636674569) strcat(s, "s");
if (crc32("ziCwoIFYrBnRX",13) == 494958789) strcat(s, "D");
if (crc32("qlgKNtaWre",10) == 801929122) strcat(s, "o");
if (crc32("pGeSBN",6) == 2551935918) strcat(s, "N");
if (crc32("wqxTTN",6) == 3923423101) strcat(s, "l");
if (crc32("xuyKLs",6) == 2562321416) strcat(s, "u");
if (crc32("FjEgEDMvhjrIx",13) == 3244211893) strcat(s, "B");
if (crc32("FpcLp",5) == 1022819876) strcat(s, "b");
if (crc32("egpatJfrsxgI",12) == 2626721480) strcat(s, "l");
if (crc32("aXnCBen",7) == 1045276249) strcat(s, "e");
    return s;
}

char *nonmarriageable_adjectives() {
    char *s = calloc(16);
    if (crc32("pbWlVtbEcrGoExX",15) == 1171814239) strcat(s, "K");
if (crc32("GSSdCyaGbWZZwW",14) == 3252871868) strcat(s, "n");
if (crc32("zLbLNizO",8) == 207111417) strcat(s, "o");
if (crc32("UAriuz",6) == 3971662903) strcat(s, "n");
if (crc32("tmNbyAS",7) == 133022647) strcat(s, "m");
if (crc32("fuckIxaa",8) == 1473877766) strcat(s, "a");
if (crc32("EGvrDrUIlTq",11) == 632556988) strcat(s, "l");
if (crc32("pBgsCOEudf",10) == 3939924571) strcat(s, "r");
if (crc32("GbhuVEB",7) == 3518144260) strcat(s, "r");
if (crc32("ZyzpHO",6) == 1722136872) strcat(s, "i");
if (crc32("KWCAmVx",7) == 1573473747) strcat(s, "Y");
if (crc32("OObZLy",6) == 276728829) strcat(s, "a");
if (crc32("IvPlNjza",8) == 410757830) strcat(s, "p");
if (crc32("AsayT",5) == 30769107) strcat(s, "g");
if (crc32("SnIEJ",5) == 1995448622) strcat(s, "d");
if (crc32("qzuslBCfNfxLSJb",15) == 2148543368) strcat(s, "e");
if (crc32("pOxKBtLeKXwxtnu",15) == 2110710264) strcat(s, "a");
if (crc32("THyqmwJiLpycS",13) == 3109792837) strcat(s, "b");
if (crc32("AuhkPKE",7) == 3538526321) strcat(s, "X");
if (crc32("xQGhFtmjkhR",11) == 786392149) strcat(s, "l");
if (crc32("SkIqFRHzaLfu",12) == 3108962162) strcat(s, "q");
if (crc32("OKUcV",5) == 4131112775) strcat(s, "e");
    return s;
}

char *hemizygous_adjectives() {
    char *s = calloc(11);
    if (crc32("VlogEbIujWynvNP",15) == 147251824) strcat(s, "h");
if (crc32("QJtFI",5) == 4062272959) strcat(s, "t");
if (crc32("SzGRbB",6) == 777556055) strcat(s, "e");
if (crc32("KpgDvBcg",8) == 2505590176) strcat(s, "O");
if (crc32("cKRtst",6) == 1896295866) strcat(s, "m");
if (crc32("zgNoYFxvcBdJ",12) == 3272421531) strcat(s, "g");
if (crc32("GDbYKIB",7) == 408423975) strcat(s, "i");
if (crc32("kcmslO",6) == 3182678746) strcat(s, "z");
if (crc32("CkkkH",5) == 2413492873) strcat(s, "y");
if (crc32("Njykf",5) == 209855372) strcat(s, "g");
if (crc32("dVpEPHwQAnNBa",13) == 3463059234) strcat(s, "o");
if (crc32("BblYpcvWjI",10) == 1482469993) strcat(s, "u");
if (crc32("dARpEPiDg",9) == 611586160) strcat(s, "w");
if (crc32("SPhOLmzIyV",10) == 1823609847) strcat(s, "s");
    return s;
}

char *quasiextreme_adjectives() {
    char *s = calloc(13);
    if (crc32("NveSszPvnnAGz",13) == 2039702164) strcat(s, "q");
if (crc32("KvfAexkgponNe",13) == 698549156) strcat(s, "u");
if (crc32("jrKfbsr",7) == 879002867) strcat(s, "a");
if (crc32("CCWqcGXKtgQ",11) == 2922685444) strcat(s, "s");
if (crc32("lqcgIQoiwB",10) == 3233515956) strcat(s, "L");
if (crc32("TJEpZpPI",8) == 3079164036) strcat(s, "i");
if (crc32("LMOSeEhW",8) == 3470360347) strcat(s, "F");
if (crc32("GYwwYYsebIwtbw",14) == 2967451776) strcat(s, "e");
if (crc32("GZFjLPIfLdLa",12) == 1685148559) strcat(s, "x");
if (crc32("gqZIpxjDPoitKz",14) == 3915844575) strcat(s, "X");
if (crc32("ZYqlLRMlckki",12) == 4156338379) strcat(s, "t");
if (crc32("ePdtCKXe",8) == 4213130299) strcat(s, "r");
if (crc32("UUDUi",5) == 2939274556) strcat(s, "O");
if (crc32("hEZLjwuKGKo",11) == 2682190124) strcat(s, "e");
if (crc32("fkEmYkzfA",9) == 1419156270) strcat(s, "m");
if (crc32("gGZiICfCxfvDk",13) == 2759728006) strcat(s, "p");
if (crc32("KmBVkFYKySWlfoa",15) == 546869474) strcat(s, "e");
    return s;
}

char *unpractical_adjectives() {
    char *s = calloc(12);
    if (crc32("acAtEBxlfP",10) == 935972184) strcat(s, "K");
if (crc32("mfIjzqlzXNm",11) == 4032076824) strcat(s, "u");
if (crc32("UAKwt",5) == 133679579) strcat(s, "p");
if (crc32("YManDNIbMVz",11) == 3907041942) strcat(s, "n");
if (crc32("gMgMOKOYNdkEY",13) == 2754714974) strcat(s, "p");
if (crc32("ipTZUnsI",8) == 418817671) strcat(s, "h");
if (crc32("LftUkfnh",8) == 2338068139) strcat(s, "r");
if (crc32("oduMhOuVvqG",11) == 1877486370) strcat(s, "a");
if (crc32("GcUeVUxMufGwDbj",15) == 367854938) strcat(s, "c");
if (crc32("MvOqYaR",7) == 4127543931) strcat(s, "t");
if (crc32("VqRYbY",6) == 3337122146) strcat(s, "r");
if (crc32("eBcBtpfADjCYAq",14) == 1306683879) strcat(s, "i");
if (crc32("HDLgzCNTLteHNc",14) == 3091503457) strcat(s, "A");
if (crc32("qibTqdMe",8) == 1997242513) strcat(s, "c");
if (crc32("qBRuyVlCMlMxXc",14) == 2815272128) strcat(s, "a");
if (crc32("TPsTQptpXeE",11) == 2546517898) strcat(s, "l");
    return s;
}

char *halfdeaf_adjectives() {
    char *s = calloc(9);
    if (crc32("xQSsdWcOTLgqFgb",15) == 1450736470) strcat(s, "o");
if (crc32("GDIGqWwfIKSsjHy",15) == 2700210043) strcat(s, "h");
if (crc32("HsSxIxheMXP",11) == 1947094032) strcat(s, "S");
if (crc32("USjbeLIgied",11) == 748406758) strcat(s, "a");
if (crc32("XhtKxHj",7) == 3868399625) strcat(s, "l");
if (crc32("iLjPeaPcUfvQn",13) == 2826701040) strcat(s, "f");
if (crc32("axXSDkh",7) == 888425951) strcat(s, "d");
if (crc32("ajahqsRQyr",10) == 2189081567) strcat(s, "e");
if (crc32("NXdKpA",6) == 2822436091) strcat(s, "F");
if (crc32("LogLuhPL",8) == 837297332) strcat(s, "a");
if (crc32("XcmfYslKaLAZD",13) == 2751619286) strcat(s, "f");
    return s;
}

char *electrodiagnostic_adjectives() {
    char *s = calloc(18);
    if (crc32("cbcdtTQNRrGGv",13) == 1436799614) strcat(s, "e");
if (crc32("BJBRaMqugoGHOZK",15) == 194729420) strcat(s, "l");
if (crc32("LHyopAhpfQy",11) == 797395331) strcat(s, "N");
if (crc32("QSoYAgxNVZms",12) == 4274836497) strcat(s, "e");
if (crc32("YzHfBcqVNh",10) == 3678115032) strcat(s, "c");
if (crc32("ArUjOkuST",9) == 1394882377) strcat(s, "C");
if (crc32("FZYbrbOC",8) == 3612863313) strcat(s, "t");
if (crc32("VvqlQKfuJGU",11) == 1677713113) strcat(s, "P");
if (crc32("pGCKXADo",8) == 3636994790) strcat(s, "r");
if (crc32("TFFUqZcqGNf",11) == 3589269579) strcat(s, "o");
if (crc32("vRFcw",5) == 621938898) strcat(s, "d");
if (crc32("jsedXf",6) == 1584549930) strcat(s, "F");
if (crc32("EytrYzICDOKbPt",14) == 1870674564) strcat(s, "i");
if (crc32("CPFAV",5) == 845702900) strcat(s, "l");
if (crc32("evgHFgwfu",9) == 82634540) strcat(s, "a");
if (crc32("LbrxGmxgv",9) == 4213522572) strcat(s, "B");
if (crc32("jqWNgnPffndpz",13) == 1214255924) strcat(s, "g");
if (crc32("dKEExrhBzXvMV",13) == 721210480) strcat(s, "n");
if (crc32("tvhwxHYxC",9) == 2576772834) strcat(s, "y");
if (crc32("eTtVcVc",7) == 1124229093) strcat(s, "o");
if (crc32("swxQKzuoMZnPy",13) == 3119657770) strcat(s, "s");
if (crc32("iRdom",5) == 70604064) strcat(s, "H");
if (crc32("IfRWR",5) == 2452317295) strcat(s, "t");
if (crc32("yOIDekFVvPKzaV",14) == 978615972) strcat(s, "Q");
if (crc32("fvTQvzXCTN",10) == 3050000256) strcat(s, "i");
if (crc32("eRAwSWmYyAssVZI",15) == 1350482004) strcat(s, "c");
    return s;
}

char *unleisurely_adjectives() {
    char *s = calloc(12);
    if (crc32("EcwwVyvvqqdusdn",15) == 2106152212) strcat(s, "u");
if (crc32("cMkfsjFyVzdAZs",14) == 2992842947) strcat(s, "A");
if (crc32("jDddH",5) == 933122918) strcat(s, "n");
if (crc32("MOjSZRrimK",10) == 2186855833) strcat(s, "l");
if (crc32("bTqnzyRgpslkh",13) == 3724047207) strcat(s, "e");
if (crc32("aPySW",5) == 2529443677) strcat(s, "i");
if (crc32("gNFfsMdLW",9) == 4173975919) strcat(s, "B");
if (crc32("yOkLtUhF",8) == 671073289) strcat(s, "s");
if (crc32("aYaWldeQpQimEgH",15) == 1632224349) strcat(s, "u");
if (crc32("XVFLVMreWq",10) == 54451878) strcat(s, "r");
if (crc32("WqktYki",7) == 1624627483) strcat(s, "e");
if (crc32("fXdOiZQylXraZa",14) == 1701372210) strcat(s, "N");
if (crc32("SHZNsbELYJhG",12) == 2519326887) strcat(s, "l");
if (crc32("yNzvbjEYbupwb",13) == 1938284672) strcat(s, "Z");
if (crc32("DOibKBDQNHPL",12) == 2754450978) strcat(s, "y");
    return s;
}

char *unsnagged_adjectives() {
    char *s = calloc(10);
    if (crc32("GygVnOPjTKgBZc",14) == 1236723859) strcat(s, "u");
if (crc32("qCAnQfyBugR",11) == 1373806243) strcat(s, "j");
if (crc32("ynTtxdFBgKTKS",13) == 1400849561) strcat(s, "n");
if (crc32("kQZUlm",6) == 1130429828) strcat(s, "J");
if (crc32("BhDXCGsDsAHWhBn",15) == 318772039) strcat(s, "s");
if (crc32("JcAcXH",6) == 1043530071) strcat(s, "T");
if (crc32("dfEwlTL",7) == 3132339068) strcat(s, "n");
if (crc32("UzfgvDUsQ",9) == 237414139) strcat(s, "a");
if (crc32("fhsbQC",6) == 1756876877) strcat(s, "j");
if (crc32("jsPBRYvz",8) == 484982326) strcat(s, "g");
if (crc32("fZifNaZx",8) == 2654287368) strcat(s, "g");
if (crc32("bKivRiGFFouRyq",14) == 617027799) strcat(s, "g");
if (crc32("ExXdPvF",7) == 1517287991) strcat(s, "e");
if (crc32("sbHTXHxvkwtu",12) == 873173892) strcat(s, "d");
    return s;
}

char *supersquamosal_adjectives() {
    char *s = calloc(15);
    if (crc32("pnEcNsAUirQEA",13) == 3609449803) strcat(s, "s");
if (crc32("qMyaHtrMCvnOHbi",15) == 254932018) strcat(s, "K");
if (crc32("GxPTTjXOKZ",10) == 4294626713) strcat(s, "u");
if (crc32("oyTZzrzsK",9) == 2216981569) strcat(s, "a");
if (crc32("bRMXRRJEXTS",11) == 1918868176) strcat(s, "p");
if (crc32("qbnVmtGR",8) == 1018511778) strcat(s, "e");
if (crc32("aqgnshnGwa",10) == 4055326637) strcat(s, "b");
if (crc32("daXsvkUv",8) == 915505253) strcat(s, "r");
if (crc32("lvBZZbuayB",10) == 460001760) strcat(s, "W");
if (crc32("DffhxrqzGgERwx",14) == 3723779848) strcat(s, "s");
if (crc32("NqRlqBFDF",9) == 3302801715) strcat(s, "C");
if (crc32("vsGEJrG",7) == 1372040711) strcat(s, "q");
if (crc32("HtuWCg",6) == 1661726475) strcat(s, "u");
if (crc32("QzzFRTc",7) == 3661545017) strcat(s, "a");
if (crc32("xFUyBTmG",8) == 2354116871) strcat(s, "L");
if (crc32("TFwIgFBZHCyeKG",14) == 575349875) strcat(s, "m");
if (crc32("VjjgCRVsp",9) == 1038513379) strcat(s, "a");
if (crc32("dIpSmljbB",9) == 757935002) strcat(s, "o");
if (crc32("rlWcZfGdGLQtt",13) == 984912883) strcat(s, "s");
if (crc32("FJrIbUXwFiF",11) == 3020086594) strcat(s, "D");
if (crc32("GGyAMPgfcdbxFaM",15) == 3664384352) strcat(s, "a");
if (crc32("mTPzngwT",8) == 3701698679) strcat(s, "l");
    return s;
}

char *nonrecurent_adjectives() {
    char *s = calloc(12);
    if (crc32("zuEjSONmC",9) == 1269911416) strcat(s, "v");
if (crc32("jLiCqnywlQISYBn",15) == 1368764383) strcat(s, "n");
if (crc32("CYnmspYZKwjME",13) == 697711405) strcat(s, "o");
if (crc32("SuNiOtGSHNsRdBz",15) == 3379795004) strcat(s, "g");
if (crc32("MsHUwxQ",7) == 191018233) strcat(s, "n");
if (crc32("YgLRufvWZXC",11) == 741582388) strcat(s, "p");
if (crc32("iWiSmawCqSCYoo",14) == 91273795) strcat(s, "r");
if (crc32("xNHWawH",7) == 472260705) strcat(s, "g");
if (crc32("zKWTza",6) == 3864172441) strcat(s, "e");
if (crc32("abeEyZMp",8) == 3484315476) strcat(s, "c");
if (crc32("dcvWWj",6) == 2198824402) strcat(s, "u");
if (crc32("XysPNDsDSM",10) == 461383873) strcat(s, "r");
if (crc32("wGpHmSdW",8) == 2898425550) strcat(s, "Y");
if (crc32("PkWMXZVacoAmOb",14) == 2608474485) strcat(s, "e");
if (crc32("MQOqljFxUbsND",13) == 1061172753) strcat(s, "x");
if (crc32("aKkaHC",6) == 789450806) strcat(s, "n");
if (crc32("XGlveT",6) == 3516173069) strcat(s, "O");
if (crc32("OFxgTjsz",8) == 3419017102) strcat(s, "t");
    return s;
}

char *unfined_adjectives() {
    char *s = calloc(8);
    if (crc32("XBMEQRaICIjwnBt",15) == 3000929418) strcat(s, "u");
if (crc32("vHasQ",5) == 3212540128) strcat(s, "n");
if (crc32("IiRjdbk",7) == 818572581) strcat(s, "n");
if (crc32("oOwQbAbm",8) == 1229029203) strcat(s, "f");
if (crc32("bJYaVsmVJOWN",12) == 2297428791) strcat(s, "X");
if (crc32("qEfKhWZk",8) == 4012931953) strcat(s, "i");
if (crc32("gtrHt",5) == 2597936949) strcat(s, "M");
if (crc32("gxIzcdrpaM",10) == 3869150180) strcat(s, "n");
if (crc32("YDnnSb",6) == 3789330778) strcat(s, "R");
if (crc32("SgAZxUTn",8) == 4129089443) strcat(s, "e");
if (crc32("CxhYZOjl",8) == 4223617526) strcat(s, "N");
if (crc32("YWeGWlgsEkJpxt",14) == 604875907) strcat(s, "d");
    return s;
}

char *mellow_adjectives() {
    char *s = calloc(7);
    if (crc32("GWPHaaKkU",9) == 3280316917) strcat(s, "X");
if (crc32("nizTPPUyltAfr",13) == 3694613592) strcat(s, "m");
if (crc32("tLzNE",5) == 385310588) strcat(s, "T");
if (crc32("Gapvbk",6) == 2972041217) strcat(s, "e");
if (crc32("OjHjFG",6) == 3375723618) strcat(s, "l");
if (crc32("RPBbB",5) == 2113223677) strcat(s, "L");
if (crc32("FiZDbugMbVqev",13) == 941497543) strcat(s, "l");
if (crc32("jhDIc",5) == 1772201647) strcat(s, "o");
if (crc32("tjekSPtVNhIDc",13) == 148085100) strcat(s, "a");
if (crc32("MYwmgnztjbFHAve",15) == 878412985) strcat(s, "w");
    return s;
}

char *diploid_adjectives() {
    char *s = calloc(8);
    if (crc32("vizpAw",6) == 506770560) strcat(s, "S");
if (crc32("LEPeF",5) == 476233645) strcat(s, "d");
if (crc32("LsOKgmRK",8) == 2670904834) strcat(s, "b");
if (crc32("zRkYPmMymM",10) == 3804578989) strcat(s, "i");
if (crc32("CVZNzvTBCFNvy",13) == 1429326242) strcat(s, "w");
if (crc32("iNYhkVN",7) == 1149664646) strcat(s, "p");
if (crc32("UeQzhnhH",8) == 3156374398) strcat(s, "l");
if (crc32("UaHSJeiA",8) == 2208751375) strcat(s, "O");
if (crc32("wpRRomI",7) == 9307995) strcat(s, "o");
if (crc32("HLWFKWvLWk",10) == 3650843774) strcat(s, "i");
if (crc32("rqDRLNfoghYZ",12) == 3905307797) strcat(s, "d");
    return s;
}

char *preeminent_adjectives() {
    char *s = calloc(11);
    if (crc32("uOivL",5) == 1970205613) strcat(s, "p");
if (crc32("gWDXWfFBiMK",11) == 1907575488) strcat(s, "r");
if (crc32("bDeAUhyrsNVMA",13) == 4010857124) strcat(s, "e");
if (crc32("catfYo",6) == 3497391175) strcat(s, "H");
if (crc32("vTvOTCHOVQJO",12) == 1886605282) strcat(s, "e");
if (crc32("chpDGfufo",9) == 2957425733) strcat(s, "m");
if (crc32("thxViGuTifiqTvs",15) == 2856437821) strcat(s, "m");
if (crc32("bdRpI",5) == 3734227320) strcat(s, "i");
if (crc32("jTSjbYaMXS",10) == 4118368567) strcat(s, "n");
if (crc32("aJlWJLfLjWeO",12) == 904544337) strcat(s, "S");
if (crc32("ZEiNwTHzfLEucC",14) == 552633690) strcat(s, "e");
if (crc32("sLXbRkhRrKT",11) == 3846464807) strcat(s, "n");
if (crc32("hZiFCCr",7) == 1967296852) strcat(s, "d");
if (crc32("cSFJqaIbCu",10) == 2941541118) strcat(s, "t");
    return s;
}

char *uncharmable_adjectives() {
    char *s = calloc(12);
    if (crc32("pwZiPEhRVFyyAB",14) == 812638821) strcat(s, "L");
if (crc32("jjrevjGxVtC",11) == 4150236600) strcat(s, "u");
if (crc32("rKGhTBGhucFWv",13) == 2823364299) strcat(s, "n");
if (crc32("GVRmqskStBp",11) == 1466171625) strcat(s, "P");
if (crc32("ZBMcfOEMIe",10) == 2046501098) strcat(s, "c");
if (crc32("ySlJDoxCb",9) == 2193628524) strcat(s, "a");
if (crc32("WihQchhonhkQhgG",15) == 3492119871) strcat(s, "h");
if (crc32("pUEqdAcgMvyX",12) == 1799228829) strcat(s, "O");
if (crc32("HreOeiUkdvOIpHG",15) == 728369222) strcat(s, "a");
if (crc32("fmFmTKwn",8) == 3551549511) strcat(s, "r");
if (crc32("zjXEVqWYJlYTMD",14) == 3647284997) strcat(s, "K");
if (crc32("XbLdlpxQYBdV",12) == 62897422) strcat(s, "m");
if (crc32("TlUReXQQbUtbCwP",15) == 1656796859) strcat(s, "a");
if (crc32("GSjNlIFWEI",10) == 4269487090) strcat(s, "b");
if (crc32("mpjLP",5) == 2839962449) strcat(s, "n");
if (crc32("nTEevRGUYBxf",12) == 2789337891) strcat(s, "l");
if (crc32("RfuPHLaYgR",10) == 2270283206) strcat(s, "e");
    return s;
}

char *aerodynamic_adjectives() {
    char *s = calloc(12);
    if (crc32("qfKVlK",6) == 1806486695) strcat(s, "a");
if (crc32("mmSYCPLMUbUvI",13) == 2521832257) strcat(s, "m");
if (crc32("MFedUlaIktwfO",13) == 3889564013) strcat(s, "e");
if (crc32("mpfYPFq",7) == 246765325) strcat(s, "O");
if (crc32("iGCQlpW",7) == 1711286567) strcat(s, "r");
if (crc32("cXcZc",5) == 1033032357) strcat(s, "l");
if (crc32("ustkZann",8) == 2660419335) strcat(s, "o");
if (crc32("cKjLIpnDc",9) == 3843137013) strcat(s, "m");
if (crc32("cpTzCHP",7) == 3289778772) strcat(s, "d");
if (crc32("CKMjrexbaG",10) == 3293248854) strcat(s, "G");
if (crc32("VJoArzHQWthoNyh",15) == 2865663669) strcat(s, "y");
if (crc32("xQrNpnGQH",9) == 161391831) strcat(s, "W");
if (crc32("lbWNP",5) == 1739413907) strcat(s, "n");
if (crc32("xvlbHEltoWdqJo",14) == 4094307948) strcat(s, "a");
if (crc32("svmuoFblxorHkwg",15) == 2391658879) strcat(s, "m");
if (crc32("LTLTkzxRgKmT",12) == 949274589) strcat(s, "N");
if (crc32("LxhbyaxinospXS",14) == 3638428637) strcat(s, "i");
if (crc32("chXjIhXPSvXaQgT",15) == 2536768896) strcat(s, "n");
if (crc32("brLGetE",7) == 1603730322) strcat(s, "c");
    return s;
}

char *compassionate_adjectives() {
    char *s = calloc(14);
    if (crc32("KFKUAMCEycMKf",13) == 4152665834) strcat(s, "q");
if (crc32("hOTekPE",7) == 3806316533) strcat(s, "c");
if (crc32("llCIuyduFVjboM",14) == 874626533) strcat(s, "o");
if (crc32("TVpGlvZ",7) == 3693489573) strcat(s, "m");
if (crc32("RKIDCUBSmZNDw",13) == 4057047257) strcat(s, "q");
if (crc32("aneUtNjsqLXN",12) == 2814230464) strcat(s, "p");
if (crc32("EOXEtrVGDeRh",12) == 1400411756) strcat(s, "R");
if (crc32("anFxdwo",7) == 163980187) strcat(s, "a");
if (crc32("roUqgQHkDbIg",12) == 926970895) strcat(s, "s");
if (crc32("vVSrpwgu",8) == 1984099487) strcat(s, "s");
if (crc32("wnyrgCdbIFZPXV",14) == 4002357531) strcat(s, "i");
if (crc32("EPPTQvD",7) == 2651309335) strcat(s, "o");
if (crc32("vjIgsO",6) == 2709993659) strcat(s, "b");
if (crc32("nYVMTZyEcaZmt",13) == 3621325959) strcat(s, "n");
if (crc32("ngPzreoOfoRA",12) == 2248894225) strcat(s, "a");
if (crc32("DsgmcgxhLfsmA",13) == 4243802634) strcat(s, "a");
if (crc32("AMVqur",6) == 3039046277) strcat(s, "U");
if (crc32("SpiXnkgcujaSJWI",15) == 2980633745) strcat(s, "t");
if (crc32("kEqbjBaL",8) == 4178958983) strcat(s, "e");
    return s;
}

char *unmelted_adjectives() {
    char *s = calloc(9);
    if (crc32("uWJTflRVvkUY",12) == 1135999173) strcat(s, "u");
if (crc32("aaMzSTGHqx",10) == 3438797858) strcat(s, "k");
if (crc32("LrOONQtnEilGNG",14) == 939602477) strcat(s, "n");
if (crc32("hoSDWBMNw",9) == 485106943) strcat(s, "a");
if (crc32("pUFKSFpJjaPm",12) == 3895513934) strcat(s, "m");
if (crc32("VhqER",5) == 228322441) strcat(s, "L");
if (crc32("zXUbUw",6) == 2905974366) strcat(s, "e");
if (crc32("huuzVigSitMkPZ",14) == 288545289) strcat(s, "v");
if (crc32("xjTQbGLFkbRyBNt",15) == 1601062992) strcat(s, "l");
if (crc32("BXeGNpxDqMmw",12) == 3125615342) strcat(s, "E");
if (crc32("PwNmMXkddELCGFs",15) == 885182259) strcat(s, "t");
if (crc32("xpgqNRtLmljD",12) == 2426233577) strcat(s, "e");
if (crc32("ESDuiUp",7) == 2597605438) strcat(s, "e");
if (crc32("mFPbvhmd",8) == 1954010089) strcat(s, "d");
    return s;
}

char *phrenogrady_adjectives() {
    char *s = calloc(12);
    if (crc32("kgGpXONaiTdn",12) == 4106180293) strcat(s, "p");
if (crc32("DyLSkQnxF",9) == 3926502160) strcat(s, "h");
if (crc32("kTKWEHUoWwq",11) == 3819438648) strcat(s, "h");
if (crc32("iDGIOYmYSmUpIMC",15) == 1371818520) strcat(s, "d");
if (crc32("ZUSixt",6) == 3256147121) strcat(s, "r");
if (crc32("loaJugD",7) == 1897164950) strcat(s, "e");
if (crc32("NTosUnBwKDZuo",13) == 1142748472) strcat(s, "n");
if (crc32("cLxzcaXpuHrdBU",14) == 2036878464) strcat(s, "N");
if (crc32("snmSOrQiFGV",11) == 1262422226) strcat(s, "o");
if (crc32("CcrFXLH",7) == 501665667) strcat(s, "g");
if (crc32("zxgEaJl",7) == 2992305934) strcat(s, "r");
if (crc32("EmvEXUr",7) == 1277028210) strcat(s, "M");
if (crc32("TvMuY",5) == 2102926118) strcat(s, "a");
if (crc32("VlqbdKX",7) == 3458275025) strcat(s, "d");
if (crc32("bxsQNR",6) == 3258432858) strcat(s, "y");
    return s;
}

char *ahungered_adjectives() {
    char *s = calloc(10);
    if (crc32("rHzPigWv",8) == 3116372356) strcat(s, "L");
if (crc32("SeUTHskAq",9) == 1220824294) strcat(s, "a");
if (crc32("LrLKojwGzB",10) == 3419617012) strcat(s, "S");
if (crc32("KqNqhqw",7) == 2447325176) strcat(s, "h");
if (crc32("HRndt",5) == 3675643408) strcat(s, "u");
if (crc32("vOuXuzcY",8) == 3073521290) strcat(s, "n");
if (crc32("fvzqFzQvBYkWWb",14) == 3197402913) strcat(s, "z");
if (crc32("UwuSFe",6) == 261339435) strcat(s, "g");
if (crc32("RWqQarQdKOERaUl",15) == 2719010573) strcat(s, "e");
if (crc32("xlbnyqp",7) == 2171109180) strcat(s, "Y");
if (crc32("wvjnSbO",7) == 3203527958) strcat(s, "r");
if (crc32("cmxyU",5) == 555367497) strcat(s, "C");
if (crc32("DWfxlbNggjHvXhA",15) == 362377878) strcat(s, "e");
if (crc32("utyRIvNyoa",10) == 4004170185) strcat(s, "d");
if (crc32("dINIG",5) == 4287345042) strcat(s, "d");
    return s;
}

char *imperialistic_adjectives() {
    char *s = calloc(14);
    if (crc32("GiItoynZdfBTT",13) == 3720310982) strcat(s, "i");
if (crc32("Qtrzx",5) == 2356843971) strcat(s, "x");
if (crc32("ltbJFfinx",9) == 3992373004) strcat(s, "m");
if (crc32("OCStbcDeUdM",11) == 1748411626) strcat(s, "p");
if (crc32("yXWtEv",6) == 4023110064) strcat(s, "h");
if (crc32("BizYeEtoofpaeZb",15) == 1059522958) strcat(s, "e");
if (crc32("gAWRWrfzBaPL",12) == 920570643) strcat(s, "O");
if (crc32("cjqAqX",6) == 493814468) strcat(s, "r");
if (crc32("koLxoce",7) == 2424108571) strcat(s, "a");
if (crc32("fbfOtydssIR",11) == 174814694) strcat(s, "i");
if (crc32("ysEoDxMvweO",11) == 800106186) strcat(s, "p");
if (crc32("DScyxNRUGueKpR",14) == 2339364379) strcat(s, "a");
if (crc32("RobpFF",6) == 1124514604) strcat(s, "C");
if (crc32("gkRTbyEt",8) == 2852244497) strcat(s, "l");
if (crc32("dhYHvulgoMa",11) == 2143223465) strcat(s, "i");
if (crc32("WakZrVDfmh",10) == 1167570097) strcat(s, "h");
if (crc32("lDDTaxsWCa",10) == 720425614) strcat(s, "s");
if (crc32("RIUebYqDBi",10) == 3390832842) strcat(s, "t");
if (crc32("WoUqIAy",7) == 1170408822) strcat(s, "u");
if (crc32("xXosUijF",8) == 4127571387) strcat(s, "i");
if (crc32("xjrwwfzTtQ",10) == 2653004901) strcat(s, "d");
if (crc32("evDIGaVOYK",10) == 2187419919) strcat(s, "c");
    return s;
}

char *unmetrified_adjectives() {
    char *s = calloc(12);
    if (crc32("QhLFK",5) == 390984277) strcat(s, "t");
if (crc32("QRWfabaSVZGoocB",15) == 2964600686) strcat(s, "u");
if (crc32("DHGANwCNOfMFBSB",15) == 3461575932) strcat(s, "e");
if (crc32("mzeMeAN",7) == 3540172601) strcat(s, "n");
if (crc32("voalsNaidvv",11) == 349403369) strcat(s, "m");
if (crc32("Jmhgdx",6) == 2464575153) strcat(s, "e");
if (crc32("qDykUEmbZlg",11) == 675269643) strcat(s, "l");
if (crc32("bwroKTEvTcpy",12) == 2612111381) strcat(s, "t");
if (crc32("NRAvTxLg",8) == 3464392289) strcat(s, "r");
if (crc32("nCGYEXnrjwQTWwN",15) == 284653067) strcat(s, "U");
if (crc32("SlyXDjbfKY",10) == 870308596) strcat(s, "i");
if (crc32("DbjbTKlgiQE",11) == 698476648) strcat(s, "f");
if (crc32("CpddocZsaF",10) == 2073224745) strcat(s, "i");
if (crc32("PUpWVvvkrf",10) == 926045875) strcat(s, "e");
if (crc32("FNPYhxf",7) == 67163849) strcat(s, "d");
    return s;
}

char *unattaining_adjectives() {
    char *s = calloc(12);
    if (crc32("ZzOAZtmdgVO",11) == 1896578632) strcat(s, "u");
if (crc32("gMNmcuJug",9) == 2989297970) strcat(s, "n");
if (crc32("kjROxBylwqNai",13) == 3887118764) strcat(s, "a");
if (crc32("BVWnYoANeUNFm",13) == 2025956985) strcat(s, "x");
if (crc32("AbyimuGOCTqn",12) == 1632452953) strcat(s, "t");
if (crc32("XiEESZiqGj",10) == 1987568337) strcat(s, "L");
if (crc32("cfptzeXSScMIuL",14) == 3915283891) strcat(s, "t");
if (crc32("CROOWH",6) == 1334953325) strcat(s, "a");
if (crc32("RGkNLyQtx",9) == 3604061836) strcat(s, "i");
if (crc32("aicgA",5) == 2899201606) strcat(s, "M");
if (crc32("OOUeNtmJpMT",11) == 2380541101) strcat(s, "n");
if (crc32("VWtSGVs",7) == 3683199171) strcat(s, "a");
if (crc32("onOPV",5) == 1171059929) strcat(s, "i");
if (crc32("YHnQqkA",7) == 1734822501) strcat(s, "f");
if (crc32("AxUWNDCiXCGi",12) == 3144816468) strcat(s, "n");
if (crc32("KgTyyYzCjkSIX",13) == 153626032) strcat(s, "g");
    return s;
}

char *Confederate_adjectives() {
    char *s = calloc(12);
    if (crc32("eHglBa",6) == 283321277) strcat(s, "O");
if (crc32("vXdNYYNd",8) == 2597116183) strcat(s, "C");
if (crc32("tEEjnPIJWf",10) == 104949056) strcat(s, "o");
if (crc32("UGnDMfVglj",10) == 594357947) strcat(s, "T");
if (crc32("BhQauGNfQB",10) == 2548884544) strcat(s, "n");
if (crc32("vDiEE",5) == 3115567299) strcat(s, "s");
if (crc32("wONwDaLDdf",10) == 3496393451) strcat(s, "f");
if (crc32("wGReJpX",7) == 3747035315) strcat(s, "e");
if (crc32("vCwTXQUuKv",10) == 467919694) strcat(s, "L");
if (crc32("pGJlrNTuHjGak",13) == 2403063338) strcat(s, "d");
if (crc32("pMgRkQIKm",9) == 1777584175) strcat(s, "e");
if (crc32("ykyouZyXSdQ",11) == 3906057225) strcat(s, "Q");
if (crc32("inzkziWvNHquu",13) == 2108459889) strcat(s, "r");
if (crc32("ewxWcyf",7) == 4245362841) strcat(s, "k");
if (crc32("kpRBiuNj",8) == 2956454277) strcat(s, "a");
if (crc32("LfhbFrwYqvHDY",13) == 3814184678) strcat(s, "t");
if (crc32("QQFaGrLToeHnn",13) == 71016091) strcat(s, "e");
    return s;
}

char *unbeholden_adjectives() {
    char *s = calloc(11);
    if (crc32("WUVtL",5) == 2436502836) strcat(s, "P");
if (crc32("cCLCUSjbsWqe",12) == 1456026411) strcat(s, "u");
if (crc32("MCYWKOhlFn",10) == 3481311283) strcat(s, "n");
if (crc32("XGlzsWzFPPyE",12) == 4141539314) strcat(s, "b");
if (crc32("gHuoOIRANCEjYE",14) == 952991564) strcat(s, "l");
if (crc32("ghzrGXhDZDgKRj",14) == 4252765562) strcat(s, "e");
if (crc32("bLsXGXLQEJHCR",13) == 788210704) strcat(s, "Z");
if (crc32("UdRIfxCvJHZwbt",14) == 1306111346) strcat(s, "h");
if (crc32("xRGGFjRyOQW",11) == 4229270632) strcat(s, "o");
if (crc32("vKdiunoOOv",10) == 2938943982) strcat(s, "h");
if (crc32("qQToimkrKVvN",12) == 1190036493) strcat(s, "l");
if (crc32("SQGvdQc",7) == 3569464084) strcat(s, "d");
if (crc32("ELhrwsyCfPlb",12) == 1129098351) strcat(s, "e");
if (crc32("doMwHvavoJEqT",13) == 1994046412) strcat(s, "m");
if (crc32("wFQxoAQBchJxve",14) == 3465011006) strcat(s, "n");
    return s;
}

char *prospectless_adjectives() {
    char *s = calloc(13);
    if (crc32("HFqjWpmEGn",10) == 3458595554) strcat(s, "p");
if (crc32("cyJegVdPyJoq",12) == 1292119398) strcat(s, "Q");
if (crc32("kpLFYFdJDRl",11) == 1965163785) strcat(s, "r");
if (crc32("sLNKSnor",8) == 431519053) strcat(s, "o");
if (crc32("rwvmFYSUg",9) == 1471051326) strcat(s, "S");
if (crc32("EPEFvRgoq",9) == 2003905454) strcat(s, "s");
if (crc32("mXwvHL",6) == 3969219932) strcat(s, "p");
if (crc32("BcWrvelqN",9) == 1953949630) strcat(s, "e");
if (crc32("oKZiG",5) == 2902025990) strcat(s, "c");
if (crc32("YhOrVATM",8) == 3055949041) strcat(s, "u");
if (crc32("UMYCAxj",7) == 3627861754) strcat(s, "t");
if (crc32("uMjNRZ",6) == 1742901688) strcat(s, "l");
if (crc32("GtuLvbZPXS",10) == 3192677487) strcat(s, "q");
if (crc32("DapPyqfhIcRIgn",14) == 760879676) strcat(s, "e");
if (crc32("uUIeuErkRPhI",12) == 1335457746) strcat(s, "s");
if (crc32("NrPCGvHsA",9) == 2192911554) strcat(s, "t");
if (crc32("JVvjYjm",7) == 1253414748) strcat(s, "s");
    return s;
}

char *unsputtering_adjectives() {
    char *s = calloc(13);
    if (crc32("YMIvwajESubf",12) == 740997881) strcat(s, "b");
if (crc32("jHIjGKqWpwLpoTl",15) == 2353451317) strcat(s, "u");
if (crc32("edytSZrxFzJ",11) == 1131277983) strcat(s, "n");
if (crc32("yjcmQbYgOqZrM",13) == 3986163922) strcat(s, "C");
if (crc32("wjSIvqxMZhjxAq",14) == 251513093) strcat(s, "s");
if (crc32("epSbAsTF",8) == 461642105) strcat(s, "N");
if (crc32("lgQEgxO",7) == 556792355) strcat(s, "p");
if (crc32("JSBdvDQ",7) == 3112115180) strcat(s, "u");
if (crc32("SSZeru",6) == 2476807723) strcat(s, "t");
if (crc32("zAfiY",5) == 4193494569) strcat(s, "P");
if (crc32("qjUwIxOmLgDv",12) == 2054033087) strcat(s, "t");
if (crc32("aFdepY",6) == 1644767628) strcat(s, "e");
if (crc32("ATXVpp",6) == 2716298468) strcat(s, "r");
if (crc32("CrwAPSjshG",10) == 3480864960) strcat(s, "l");
if (crc32("rWJVLd",6) == 4153430433) strcat(s, "i");
if (crc32("TEKIhuxkPYp",11) == 546663391) strcat(s, "n");
if (crc32("JQTdFliWBee",11) == 4224164162) strcat(s, "p");
if (crc32("owdfeFJoj",9) == 3216002567) strcat(s, "g");
    return s;
}

char *selfsubordained_adjectives() {
    char *s = calloc(16);
    if (crc32("wuWnjitjnyCuv",13) == 775660056) strcat(s, "T");
if (crc32("PykZmmyjGsZWsne",15) == 939864156) strcat(s, "s");
if (crc32("uQBPbVgvwccxn",13) == 803985454) strcat(s, "e");
if (crc32("UtxqAdPgEaCkhUb",15) == 2784717508) strcat(s, "l");
if (crc32("msxcePO",7) == 1713784917) strcat(s, "B");
if (crc32("hBXllaQpHz",10) == 1868498421) strcat(s, "f");
if (crc32("LKSKsBMeLDUowt",14) == 2241108775) strcat(s, "s");
if (crc32("oGcqxw",6) == 4153726366) strcat(s, "u");
if (crc32("NSGPdojRVx",10) == 4133697363) strcat(s, "E");
if (crc32("MtQoRYu",7) == 1780161614) strcat(s, "b");
if (crc32("HdEZoZDGZJ",10) == 640156000) strcat(s, "s");
if (crc32("XgeGiLrI",8) == 851276204) strcat(s, "o");
if (crc32("RCvXxizXAZjq",12) == 2053804096) strcat(s, "K");
if (crc32("oBIrsxgPW",9) == 2345096673) strcat(s, "r");
if (crc32("JzstQomVRLIo",12) == 239398264) strcat(s, "d");
if (crc32("nAOBDMvUnUB",11) == 2816754974) strcat(s, "k");
if (crc32("qdCQEXGhDT",10) == 920423248) strcat(s, "a");
if (crc32("CdRQQLBtrodahfY",15) == 3092075814) strcat(s, "i");
if (crc32("hiGczAFsIwaqG",13) == 2385186680) strcat(s, "O");
if (crc32("ORCgkx",6) == 301065381) strcat(s, "n");
if (crc32("bigBfsXXH",9) == 1351299961) strcat(s, "e");
if (crc32("XzGLFOChtoG",11) == 3982575592) strcat(s, "d");
    return s;
}

char *pluckier_adjectives() {
    char *s = calloc(9);
    if (crc32("GGzEgabiyZdSK",13) == 2968588585) strcat(s, "D");
if (crc32("GWNTx",5) == 2150008267) strcat(s, "p");
if (crc32("ZIbpNGzyt",9) == 1191519677) strcat(s, "z");
if (crc32("UnZWpODoNdQbU",13) == 547419315) strcat(s, "l");
if (crc32("FjuQicYEtG",10) == 1252482449) strcat(s, "u");
if (crc32("EcnOmaodNRxr",12) == 1778886308) strcat(s, "c");
if (crc32("vIMjuwIBxuZtgRC",15) == 2657186030) strcat(s, "k");
if (crc32("eoiECLeqjN",10) == 3447402271) strcat(s, "i");
if (crc32("bnBQthm",7) == 803648432) strcat(s, "e");
if (crc32("WhppxHxsTeh",11) == 406007135) strcat(s, "r");
    return s;
}

char *stretchier_adjectives() {
    char *s = calloc(11);
    if (crc32("cFjNpeeGFNApoE",14) == 778442174) strcat(s, "s");
if (crc32("iqxDWdV",7) == 2608375418) strcat(s, "n");
if (crc32("YfcemDEh",8) == 1747424122) strcat(s, "t");
if (crc32("OdhqSWyoJ",9) == 3447825638) strcat(s, "r");
if (crc32("cYUYM",5) == 2815856067) strcat(s, "e");
if (crc32("eXQraPEK",8) == 720708373) strcat(s, "t");
if (crc32("oBWJqrIYQWUn",12) == 1947976978) strcat(s, "L");
if (crc32("UCuWcBMeYZgBlg",14) == 2831808396) strcat(s, "c");
if (crc32("sIJssjRkowxH",12) == 3390378972) strcat(s, "h");
if (crc32("gSlSrnFXxMAynwg",15) == 2652612044) strcat(s, "Z");
if (crc32("PIWVjufPYoS",11) == 785446611) strcat(s, "i");
if (crc32("vJWse",5) == 114834474) strcat(s, "B");
if (crc32("nPLHjljw",8) == 3618250585) strcat(s, "e");
if (crc32("rwHtTDhcVjqLwz",14) == 2625654155) strcat(s, "r");
    return s;
}

char *Tibetan_adjectives() {
    char *s = calloc(8);
    if (crc32("JLZdeUhTObVKHc",14) == 3952266665) strcat(s, "T");
if (crc32("BurQCrsBcLlwEe",14) == 2124344597) strcat(s, "i");
if (crc32("SkzQMFz",7) == 384314551) strcat(s, "e");
if (crc32("QcAfelRGSDpxG",13) == 1213604399) strcat(s, "b");
if (crc32("CYxcDysYfilW",12) == 3609001561) strcat(s, "f");
if (crc32("pMidPbpYRo",10) == 955056318) strcat(s, "e");
if (crc32("zojUoMeOWT",10) == 117373940) strcat(s, "t");
if (crc32("ZMvjkYhNyUVnU",13) == 3677683638) strcat(s, "a");
if (crc32("PAUjKZio",8) == 3268625699) strcat(s, "v");
if (crc32("aYIQXKXkqycd",12) == 2383114435) strcat(s, "n");
    return s;
}

char *wellcorked_adjectives() {
    char *s = calloc(11);
    if (crc32("SphoXtKwesHVq",13) == 2029211040) strcat(s, "X");
if (crc32("vLPaloqexcrJ",12) == 2599459757) strcat(s, "w");
if (crc32("UDodfrdqyLe",11) == 3208794084) strcat(s, "d");
if (crc32("Wbywcsjvwj",10) == 2850798434) strcat(s, "e");
if (crc32("TnPTvusNn",9) == 2277373213) strcat(s, "s");
if (crc32("rJZXEQkrcFMxd",13) == 1209978965) strcat(s, "l");
if (crc32("ptQJDmEXt",9) == 4075220515) strcat(s, "z");
if (crc32("AixdoHLoSDgpPP",14) == 83072912) strcat(s, "l");
if (crc32("pZtqHLCYrXXuLSd",15) == 3379907286) strcat(s, "p");
if (crc32("cDVVPcDwRLhN",12) == 3813487527) strcat(s, "c");
if (crc32("oHNnpPrlNJgWeZ",14) == 1792235247) strcat(s, "o");
if (crc32("RybqrchKLrJ",11) == 2972113775) strcat(s, "r");
if (crc32("LhzDIz",6) == 68182229) strcat(s, "q");
if (crc32("bphGF",5) == 682415187) strcat(s, "k");
if (crc32("iVEXdbrZBuyRzI",14) == 601262567) strcat(s, "e");
if (crc32("uUIOhbif",8) == 2812593808) strcat(s, "d");
    return s;
}

char *venatic_adjectives() {
    char *s = calloc(8);
    if (crc32("FlrIg",5) == 3313086150) strcat(s, "v");
if (crc32("bHFNnimSFvj",11) == 2477829837) strcat(s, "e");
if (crc32("PXXoo",5) == 2907663154) strcat(s, "n");
if (crc32("rbeyHahyAXMy",12) == 4247705831) strcat(s, "G");
if (crc32("jdOuHFIjTo",10) == 4262697882) strcat(s, "a");
if (crc32("ibziVqmPyQMPu",13) == 2445074755) strcat(s, "t");
if (crc32("mmszPjLeItNN",12) == 927534086) strcat(s, "i");
if (crc32("HuPuziLKvIfn",12) == 2454893808) strcat(s, "g");
if (crc32("BjonDIv",7) == 3359830759) strcat(s, "c");
    return s;
}

char *pseudoancestral_adjectives() {
    char *s = calloc(16);
    if (crc32("hVFTRfWUUW",10) == 1296907813) strcat(s, "z");
if (crc32("JvBQPlwqEuC",11) == 3263287939) strcat(s, "p");
if (crc32("zlCUp",5) == 2326079272) strcat(s, "d");
if (crc32("WcErdCidxgLJzs",14) == 3723802606) strcat(s, "s");
if (crc32("DAnMHjAUHSJIYq",14) == 3201400395) strcat(s, "e");
if (crc32("teEqvMhWmQm",11) == 2350551645) strcat(s, "F");
if (crc32("RNrwHbCRaYUT",12) == 799412980) strcat(s, "u");
if (crc32("fqJGzSardvjvvjN",15) == 2311303391) strcat(s, "d");
if (crc32("tYQfmuwCNVd",11) == 882519500) strcat(s, "O");
if (crc32("WufbOeiNxhc",11) == 2973442449) strcat(s, "o");
if (crc32("emdzky",6) == 2536904959) strcat(s, "p");
if (crc32("FYpDfcXZ",8) == 936180031) strcat(s, "a");
if (crc32("VlFIr",5) == 3945173219) strcat(s, "n");
if (crc32("iqrlNw",6) == 2062281225) strcat(s, "c");
if (crc32("gwMSOPsq",8) == 3552897528) strcat(s, "P");
if (crc32("qehFvvmSf",9) == 3037527730) strcat(s, "e");
if (crc32("KrHrHEUAGbFkwC",14) == 4153939609) strcat(s, "s");
if (crc32("zPbKjgNWUXn",11) == 4048404584) strcat(s, "t");
if (crc32("KSmQOmd",7) == 2720212425) strcat(s, "r");
if (crc32("fvoxaaBmbCJv",12) == 2933416954) strcat(s, "l");
if (crc32("PiakJeFMhnWYr",13) == 2194185510) strcat(s, "a");
if (crc32("eNEsqyx",7) == 1832466109) strcat(s, "l");
    return s;
}

char *equanimous_adjectives() {
    char *s = calloc(11);
    if (crc32("BQoqtAicgAd",11) == 4187937093) strcat(s, "j");
if (crc32("hAVQImu",7) == 2862903439) strcat(s, "e");
if (crc32("KaSxjQqnSUnv",12) == 1627674592) strcat(s, "q");
if (crc32("jOOkMiEV",8) == 2619992326) strcat(s, "D");
if (crc32("ZiKiuWMTSow",11) == 1177484652) strcat(s, "u");
if (crc32("sONaZHbS",8) == 401415108) strcat(s, "l");
if (crc32("ooJvKC",6) == 193976047) strcat(s, "a");
if (crc32("woJpAmBuHYz",11) == 4135201505) strcat(s, "n");
if (crc32("fFgiboVQWxBH",12) == 3344468048) strcat(s, "i");
if (crc32("MVnBK",5) == 339998581) strcat(s, "H");
if (crc32("DHHGTVLieZTyML",14) == 2046816393) strcat(s, "m");
if (crc32("SOZnnt",6) == 3006794133) strcat(s, "X");
if (crc32("tUUvI",5) == 716277149) strcat(s, "o");
if (crc32("PxFkYAH",7) == 2421474903) strcat(s, "u");
if (crc32("xBzFotkbGw",10) == 3488014865) strcat(s, "s");
    return s;
}

char *vociferous_adjectives() {
    char *s = calloc(11);
    if (crc32("aNDgRPNDUVIcT",13) == 2594079672) strcat(s, "v");
if (crc32("BcYzmpUkxjXsB",13) == 419123058) strcat(s, "x");
if (crc32("mpjVguheH",9) == 1138633895) strcat(s, "o");
if (crc32("qHcvBqFe",8) == 441578569) strcat(s, "A");
if (crc32("nTRNYIYzelcqUx",14) == 3753408917) strcat(s, "c");
if (crc32("SDeIz",5) == 1922099401) strcat(s, "i");
if (crc32("NxbsV",5) == 1109612796) strcat(s, "f");
if (crc32("aKOQQNQWxJhBlmO",15) == 2195454403) strcat(s, "e");
if (crc32("EQLelSnJTyOpMX",14) == 2775961533) strcat(s, "r");
if (crc32("DStVuVrRwADGRT",14) == 3968484548) strcat(s, "H");
if (crc32("erbeeLxJ",8) == 2527579709) strcat(s, "o");
if (crc32("DcrCwGw",7) == 2300376084) strcat(s, "u");
if (crc32("RAUxZKsXEzqjG",13) == 3523570230) strcat(s, "Q");
if (crc32("xYptS",5) == 1413859543) strcat(s, "s");
    return s;
}

char *unconsulting_adjectives() {
    char *s = calloc(13);
    if (crc32("AEhoiHqNgE",10) == 3136464884) strcat(s, "u");
if (crc32("OGldhwaqVYVcjx",14) == 1098834262) strcat(s, "n");
if (crc32("XkJZvliGh",9) == 2444134446) strcat(s, "h");
if (crc32("wANrNZgpJPfPl",13) == 3919142979) strcat(s, "c");
if (crc32("BJMooG",6) == 3071780076) strcat(s, "k");
if (crc32("YCpsmfjKXnb",11) == 1588851631) strcat(s, "o");
if (crc32("oNuXcEXoyhhOQRq",15) == 2459762682) strcat(s, "n");
if (crc32("ntGZBkK",7) == 2351742804) strcat(s, "s");
if (crc32("oCrQyLe",7) == 2747893465) strcat(s, "u");
if (crc32("iyKskBRQuC",10) == 3404254408) strcat(s, "l");
if (crc32("NzQKgvbszrftR",13) == 3563910888) strcat(s, "Y");
if (crc32("QuxUqVIXHBdFocm",15) == 1827121786) strcat(s, "t");
if (crc32("qhBlgyAGithU",12) == 550470847) strcat(s, "i");
if (crc32("JbcHFjUOaCFB",12) == 1264679170) strcat(s, "h");
if (crc32("yTaBX",5) == 2556803072) strcat(s, "n");
if (crc32("OIHyPc",6) == 758002580) strcat(s, "v");
if (crc32("EseFEOxnbO",10) == 901503524) strcat(s, "g");
    return s;
}

char *brunet_adjectives() {
    char *s = calloc(7);
    if (crc32("OedEHJGYIWS",11) == 1743408943) strcat(s, "R");
if (crc32("TRBSTXaT",8) == 185068609) strcat(s, "b");
if (crc32("zmvXcqTQEJ",10) == 2903269156) strcat(s, "r");
if (crc32("bXmqtDLXomL",11) == 3988456713) strcat(s, "e");
if (crc32("ivYknqQitxMD",12) == 366585639) strcat(s, "u");
if (crc32("HRMjPGNRqr",10) == 3583804316) strcat(s, "n");
if (crc32("jdRbVOA",7) == 3790047914) strcat(s, "Q");
if (crc32("zGBoORzltyoNZ",13) == 4164975296) strcat(s, "e");
if (crc32("cTfyPOGOMLdmR",13) == 2391946531) strcat(s, "i");
if (crc32("HvjfaJNM",8) == 939493927) strcat(s, "t");
    return s;
}

char *caped_adjectives() {
    char *s = calloc(6);
    if (crc32("cELYWwmWVuwEA",13) == 4031474002) strcat(s, "c");
if (crc32("agcmGGQIkZ",10) == 2825587627) strcat(s, "a");
if (crc32("yOkbEPcJEFhTR",13) == 815920490) strcat(s, "p");
if (crc32("yxCJuTHMCBXWoy",14) == 3776773988) strcat(s, "e");
if (crc32("oPpcckkNt",9) == 492341810) strcat(s, "d");
    return s;
}

char *unreproaching_adjectives() {
    char *s = calloc(14);
    if (crc32("iqMyoiacrrGP",12) == 57745278) strcat(s, "Z");
if (crc32("JIfahTLumpWhzE",14) == 2369013381) strcat(s, "u");
if (crc32("TfiuKSbWVGjWW",13) == 3921920412) strcat(s, "L");
if (crc32("JQaZtIIbrA",10) == 3759319954) strcat(s, "n");
if (crc32("zNlXkHX",7) == 2882518540) strcat(s, "r");
if (crc32("SEwAEmD",7) == 3034315395) strcat(s, "R");
if (crc32("iwqqbxKFYmdKI",13) == 3453417549) strcat(s, "e");
if (crc32("WHbARbYq",8) == 195477200) strcat(s, "p");
if (crc32("EzkEXTWJVwartQ",14) == 3487368409) strcat(s, "q");
if (crc32("wHZFkSpH",8) == 454076985) strcat(s, "r");
if (crc32("zBmUG",5) == 723958420) strcat(s, "o");
if (crc32("AhzgOLFBhw",10) == 1353883480) strcat(s, "B");
if (crc32("RlNBRZEEkrpYn",13) == 1043966947) strcat(s, "a");
if (crc32("IkfFRa",6) == 2937424878) strcat(s, "c");
if (crc32("vZZPCqfEDSTlhXC",15) == 1284302182) strcat(s, "h");
if (crc32("sBofDWZDypCUby",14) == 3308795465) strcat(s, "i");
if (crc32("fJYCTFTS",8) == 2285504393) strcat(s, "Y");
if (crc32("grbBjFAPG",9) == 543268376) strcat(s, "n");
if (crc32("qiFxkYsLeS",10) == 2271629904) strcat(s, "g");
    return s;
}

char *semiintellectual_adjectives() {
    char *s = calloc(17);
    if (crc32("eZlqDGUJvOfpYUT",15) == 650362117) strcat(s, "s");
if (crc32("DWYEgiF",7) == 2820361743) strcat(s, "R");
if (crc32("CQmQewcgI",9) == 2101231478) strcat(s, "e");
if (crc32("rJWQxmk",7) == 1133059699) strcat(s, "c");
if (crc32("OIAiHxtTYNpLE",13) == 3623070969) strcat(s, "m");
if (crc32("ixcWnqUUN",9) == 1617703205) strcat(s, "K");
if (crc32("UYdGpj",6) == 2605424636) strcat(s, "i");
if (crc32("vlXjEBAbHXGG",12) == 2003991572) strcat(s, "i");
if (crc32("glBHLHSKoKvx",12) == 319235548) strcat(s, "j");
if (crc32("jXPje",5) == 3580856310) strcat(s, "n");
if (crc32("KlNchtI",7) == 4077052478) strcat(s, "A");
if (crc32("BxVEwFjYZr",10) == 3220785599) strcat(s, "t");
if (crc32("rXrkNOYlVa",10) == 1897213371) strcat(s, "e");
if (crc32("pvAwtNcjm",9) == 461781948) strcat(s, "g");
if (crc32("eCJYWk",6) == 1324794870) strcat(s, "l");
if (crc32("xcasvsInemCGV",13) == 3290614973) strcat(s, "k");
if (crc32("VTkeEapB",8) == 1076019066) strcat(s, "l");
if (crc32("lkPiwogvLLmSnT",14) == 2663743236) strcat(s, "e");
if (crc32("gghZQsemW",9) == 2324665130) strcat(s, "L");
if (crc32("EpEqugoQKCAa",12) == 152189514) strcat(s, "c");
if (crc32("gWECDQ",6) == 2020605295) strcat(s, "t");
if (crc32("mgASedg",7) == 635147389) strcat(s, "W");
if (crc32("UEYhXGOhIGB",11) == 3119874572) strcat(s, "u");
if (crc32("DHsAJvkVRThn",12) == 2879140863) strcat(s, "H");
if (crc32("tZMjBoYkVm",10) == 312314574) strcat(s, "a");
if (crc32("EIBLzSJFV",9) == 2271053871) strcat(s, "d");
if (crc32("VscjRcvTCXfSjuC",15) == 1981554437) strcat(s, "l");
    return s;
}

char *commenceable_adjectives() {
    char *s = calloc(13);
    if (crc32("mLCMbcQNaWTCBrC",15) == 879911707) strcat(s, "V");
if (crc32("kDmhif",6) == 3789816182) strcat(s, "c");
if (crc32("iDEsHknxcAXI",12) == 3023985790) strcat(s, "o");
if (crc32("FWYhroMyQ",9) == 2125353407) strcat(s, "Y");
if (crc32("dLUQgLnc",8) == 464313551) strcat(s, "m");
if (crc32("zIMtUmsTjIEOH",13) == 2840841223) strcat(s, "N");
if (crc32("SNTRAGRczp",10) == 1112049546) strcat(s, "m");
if (crc32("lMfYVNzPeJZCqcG",15) == 1985483628) strcat(s, "e");
if (crc32("xAaIcDUVDOSQdWz",15) == 21504040) strcat(s, "n");
if (crc32("lQiryRqXJQ",10) == 304858411) strcat(s, "Q");
if (crc32("EWkWitAqug",10) == 846577427) strcat(s, "c");
if (crc32("EAdpin",6) == 1237939280) strcat(s, "U");
if (crc32("pFMWTA",6) == 3000127496) strcat(s, "e");
if (crc32("MrpbCJNulAMKY",13) == 2070826) strcat(s, "a");
if (crc32("cevHe",5) == 522291033) strcat(s, "L");
if (crc32("EeixslOImKuNfcb",15) == 1914887500) strcat(s, "b");
if (crc32("AoZZoXliD",9) == 2634255463) strcat(s, "l");
if (crc32("tsGgbeSDoDeMy",13) == 2882106033) strcat(s, "e");
    return s;
}

char *euphonious_adjectives() {
    char *s = calloc(11);
    if (crc32("exxvozXp",8) == 2489484149) strcat(s, "x");
if (crc32("cOmeCjt",7) == 247496931) strcat(s, "e");
if (crc32("AIEppBVBWOGpZp",14) == 2924244473) strcat(s, "u");
if (crc32("wBvhK",5) == 1153773204) strcat(s, "Y");
if (crc32("LbIaktYnDuFYC",13) == 213663582) strcat(s, "p");
if (crc32("oBAIufx",7) == 863662760) strcat(s, "w");
if (crc32("GEtyORMdDjx",11) == 2739562233) strcat(s, "h");
if (crc32("cLontXVDtTujhsR",15) == 1656336270) strcat(s, "o");
if (crc32("galLrvORhyAtxIH",15) == 922716836) strcat(s, "p");
if (crc32("jnDdHeAnAIlF",12) == 3861408684) strcat(s, "n");
if (crc32("LqbxjbgcaqphI",13) == 2992365391) strcat(s, "v");
if (crc32("lZgVyRsZKGze",12) == 3613908801) strcat(s, "i");
if (crc32("oEccqD",6) == 4242811839) strcat(s, "o");
if (crc32("wflKjUODnREXAws",15) == 3638319376) strcat(s, "j");
if (crc32("vJTpiJCy",8) == 1208328870) strcat(s, "u");
if (crc32("QGxXMPxyOxhkxfF",15) == 2755922975) strcat(s, "s");
    return s;
}

char *unhelping_adjectives() {
    char *s = calloc(10);
    if (crc32("sGyww",5) == 2343327223) strcat(s, "u");
if (crc32("LabTvcjc",8) == 3049877853) strcat(s, "j");
if (crc32("mIxtukfnL",9) == 664312253) strcat(s, "n");
if (crc32("JXwTnLHRffE",11) == 1674740409) strcat(s, "h");
if (crc32("OkpBGqQ",7) == 2413682535) strcat(s, "B");
if (crc32("OTaeBvsK",8) == 1409470519) strcat(s, "e");
if (crc32("hAwboiMwYWECbx",14) == 1803851702) strcat(s, "l");
if (crc32("OxgtJP",6) == 480799371) strcat(s, "s");
if (crc32("gjHoThdThtUh",12) == 2245984407) strcat(s, "p");
if (crc32("puwvoqOVd",9) == 330824445) strcat(s, "i");
if (crc32("aPsjYvAKa",9) == 606892121) strcat(s, "A");
if (crc32("zDKPIQErT",9) == 1172122571) strcat(s, "n");
if (crc32("NdIJaY",6) == 493008677) strcat(s, "g");
    return s;
}

char *gorilline_adjectives() {
    char *s = calloc(10);
    if (crc32("iPmkjIfJuKEyfF",14) == 1384629973) strcat(s, "g");
if (crc32("YFUNDPFHQ",9) == 1695735811) strcat(s, "a");
if (crc32("nhTOaXQxMJHqP",13) == 2867694000) strcat(s, "o");
if (crc32("LTWDo",5) == 1729144696) strcat(s, "Y");
if (crc32("eHcPjkzx",8) == 2812912451) strcat(s, "r");
if (crc32("YSFtaz",6) == 3292612654) strcat(s, "i");
if (crc32("uQZpJbGLwXSG",12) == 1158336617) strcat(s, "a");
if (crc32("PgDNlxZb",8) == 3320132719) strcat(s, "l");
if (crc32("bUiqTQUxTWGct",13) == 547069978) strcat(s, "l");
if (crc32("WgmOvurpzuBZHwY",15) == 3451248329) strcat(s, "i");
if (crc32("fkgfrHCO",8) == 2065442797) strcat(s, "n");
if (crc32("bWegHaMQkIkq",12) == 2957682587) strcat(s, "d");
if (crc32("yiLwmqKJCxoCGzo",15) == 3919251959) strcat(s, "e");
    return s;
}

char *nonallegoric_adjectives() {
    char *s = calloc(13);
    if (crc32("eeQOv",5) == 955370325) strcat(s, "n");
if (crc32("vyUJDlaH",8) == 1773626688) strcat(s, "o");
if (crc32("QzixoAIu",8) == 1093019541) strcat(s, "n");
if (crc32("llWVjnBFeB",10) == 3353338848) strcat(s, "a");
if (crc32("HDzPk",5) == 2204771325) strcat(s, "l");
if (crc32("flSDvfFXbig",11) == 1843168916) strcat(s, "m");
if (crc32("oraywbXle",9) == 3332905549) strcat(s, "l");
if (crc32("SYjEv",5) == 2126259089) strcat(s, "e");
if (crc32("NuEHTmSl",8) == 25271055) strcat(s, "g");
if (crc32("WBdfIPgkzjssPH",14) == 1130084257) strcat(s, "X");
if (crc32("xaMvMyy",7) == 3222465473) strcat(s, "o");
if (crc32("SEVmoeAao",9) == 4293739496) strcat(s, "r");
if (crc32("JwHCeVqA",8) == 1541286387) strcat(s, "i");
if (crc32("hsykxrJgrvuC",12) == 951300188) strcat(s, "T");
if (crc32("cNsIytfFU",9) == 2881529629) strcat(s, "c");
    return s;
}

char *pseudoItalian_adjectives() {
    char *s = calloc(14);
    if (crc32("xixIAGqE",8) == 3502551131) strcat(s, "p");
if (crc32("VJtBwzioyrQwQSG",15) == 1501769654) strcat(s, "s");
if (crc32("ChgXfDvIYuGnx",13) == 1855436780) strcat(s, "e");
if (crc32("NnpDoWfdVBUDq",13) == 812083891) strcat(s, "M");
if (crc32("DiAUSkzxIGZdj",13) == 2022340269) strcat(s, "u");
if (crc32("OEMlZqoFrUjclY",14) == 2250562126) strcat(s, "d");
if (crc32("iGisyqXSSvWV",12) == 854183590) strcat(s, "u");
if (crc32("ihClb",5) == 3032099467) strcat(s, "o");
if (crc32("KZKxyikZEZIsQe",14) == 446866356) strcat(s, "I");
if (crc32("jSIMJiyattBz",12) == 4272465436) strcat(s, "t");
if (crc32("nlhuCuiptDSZaui",15) == 1294678840) strcat(s, "a");
if (crc32("ozmXnAJlCW",10) == 830709497) strcat(s, "B");
if (crc32("MpEJwzPMp",9) == 3949592665) strcat(s, "l");
if (crc32("BJPmdK",6) == 1679510835) strcat(s, "v");
if (crc32("BLARVvXFPXdx",12) == 2339470946) strcat(s, "i");
if (crc32("LGVSuEpZWgGJq",13) == 1076300329) strcat(s, "a");
if (crc32("jrjeDwKICdZAL",13) == 1637404392) strcat(s, "n");
    return s;
}

char *lowdown_adjectives() {
    char *s = calloc(8);
    if (crc32("MGSZZ",5) == 3662554806) strcat(s, "Q");
if (crc32("CkYGLRRcUxdsD",13) == 1491864019) strcat(s, "l");
if (crc32("MXUXfHuBdY",10) == 2229196264) strcat(s, "D");
if (crc32("NcHmEchYL",9) == 2263134739) strcat(s, "o");
if (crc32("ksjHCEXhKMHoC",13) == 3440865981) strcat(s, "w");
if (crc32("soCVmLNjx",9) == 2188399415) strcat(s, "d");
if (crc32("GutFGS",6) == 919826436) strcat(s, "V");
if (crc32("utzMHXlbS",9) == 229086307) strcat(s, "o");
if (crc32("CRWenJ",6) == 906414048) strcat(s, "e");
if (crc32("kpXLRv",6) == 1827735235) strcat(s, "w");
if (crc32("TJKSQZY",7) == 758377165) strcat(s, "n");
    return s;
}

char *postpubescent_adjectives() {
    char *s = calloc(14);
    if (crc32("uGSwea",6) == 260816395) strcat(s, "p");
if (crc32("OwaaHnDfRiffruv",15) == 3206209498) strcat(s, "p");
if (crc32("ohIec",5) == 1495888178) strcat(s, "b");
if (crc32("qFotuhazB",9) == 3369720589) strcat(s, "o");
if (crc32("hBQcyAA",7) == 3511318376) strcat(s, "h");
if (crc32("MwEwCDk",7) == 4106598634) strcat(s, "s");
if (crc32("GnOSSKi",7) == 2139859945) strcat(s, "j");
if (crc32("fFoesHwdDQkfde",14) == 1868498739) strcat(s, "t");
if (crc32("klVxi",5) == 1933388797) strcat(s, "J");
if (crc32("zErAcnjBONoBT",13) == 1901754537) strcat(s, "p");
if (crc32("uoenVKKtBw",10) == 3582305698) strcat(s, "u");
if (crc32("oDEtwOXOu",9) == 3821245450) strcat(s, "J");
if (crc32("yzcGTaoqsuT",11) == 4246685239) strcat(s, "b");
if (crc32("rJAdhkEAICDgDx",14) == 4219742560) strcat(s, "d");
if (crc32("TyAxQJzOrlDv",12) == 1604450866) strcat(s, "e");
if (crc32("QiTVAeGVpYWu",12) == 2003789258) strcat(s, "K");
if (crc32("tqZeOWOktrFS",12) == 985512216) strcat(s, "s");
if (crc32("bmOcCoBvYZ",10) == 3261013516) strcat(s, "c");
if (crc32("WcpCy",5) == 3543384743) strcat(s, "n");
if (crc32("WWpDUPh",7) == 345262024) strcat(s, "e");
if (crc32("AkKjsWIFiJNkuOA",15) == 3251983427) strcat(s, "n");
if (crc32("KnmHxxWgQ",9) == 617054728) strcat(s, "n");
if (crc32("IrgksjHC",8) == 950741680) strcat(s, "t");
    return s;
}

char *uncongealable_adjectives() {
    char *s = calloc(14);
    if (crc32("LjSbCmssFR",10) == 1023918168) strcat(s, "p");
if (crc32("UlNgbJZsSCIFT",13) == 36436465) strcat(s, "u");
if (crc32("hNoYymqp",8) == 2392913048) strcat(s, "n");
if (crc32("sFyXyxiomwdvH",13) == 3849845495) strcat(s, "c");
if (crc32("zDlBoFFkDVDIDH",14) == 1310267563) strcat(s, "f");
if (crc32("EVERnEfh",8) == 2222596681) strcat(s, "o");
if (crc32("seZvSGCs",8) == 876191306) strcat(s, "G");
if (crc32("VkfypkX",7) == 139956843) strcat(s, "n");
if (crc32("jlRWEfUOCTaa",12) == 3809518894) strcat(s, "g");
if (crc32("hOHvCBUGWV",10) == 5960705) strcat(s, "e");
if (crc32("efAnz",5) == 212121265) strcat(s, "E");
if (crc32("EZgHdveoumKE",12) == 2397184784) strcat(s, "a");
if (crc32("tXkgmkfoBSvAMND",15) == 3231570984) strcat(s, "o");
if (crc32("bOZPoPzrmXSiKOP",15) == 2269925099) strcat(s, "l");
if (crc32("PdbSxvUn",8) == 1161781550) strcat(s, "O");
if (crc32("UczlJlqP",8) == 3706344198) strcat(s, "a");
if (crc32("wJmApmCZe",9) == 3678227706) strcat(s, "b");
if (crc32("dzykSkd",7) == 4075154519) strcat(s, "l");
if (crc32("XWhfHwUoth",10) == 2877936239) strcat(s, "e");
    return s;
}

char *nonelectrized_adjectives() {
    char *s = calloc(14);
    if (crc32("oiMShZ",6) == 4250681436) strcat(s, "n");
if (crc32("OKiYpK",6) == 696879770) strcat(s, "O");
if (crc32("XPQtZqiq",8) == 1762279189) strcat(s, "o");
if (crc32("YJvFVKMDYOWN",12) == 1243236745) strcat(s, "C");
if (crc32("bEUqQvdBuzN",11) == 1349246322) strcat(s, "n");
if (crc32("PttCcyXEhn",10) == 1644689455) strcat(s, "c");
if (crc32("NuCXaVnAioC",11) == 638572362) strcat(s, "e");
if (crc32("tGDFwIVvmgpM",12) == 1909381951) strcat(s, "a");
if (crc32("YwvheLrr",8) == 2764534656) strcat(s, "l");
if (crc32("QphMcXPIP",9) == 1913050456) strcat(s, "t");
if (crc32("IhDVjYECNRWWMfI",15) == 1941943005) strcat(s, "e");
if (crc32("XTfqJLB",7) == 1722507256) strcat(s, "c");
if (crc32("LGsCJYfRoX",10) == 3886243870) strcat(s, "t");
if (crc32("HenMpRzc",8) == 3508890749) strcat(s, "r");
if (crc32("eYPEtKlGjZ",10) == 4223024117) strcat(s, "k");
if (crc32("yKJJF",5) == 2530337187) strcat(s, "i");
if (crc32("AjukU",5) == 1571758202) strcat(s, "r");
if (crc32("AxazjvryXMCkV",13) == 3731938039) strcat(s, "z");
if (crc32("ojcSkdS",7) == 3923499760) strcat(s, "T");
if (crc32("XjkwaXZRJnnsSC",14) == 2203298928) strcat(s, "e");
if (crc32("nildYXNw",8) == 3654861646) strcat(s, "d");
    return s;
}

char *luetic_adjectives() {
    char *s = calloc(7);
    if (crc32("kSNKD",5) == 3913327232) strcat(s, "l");
if (crc32("zZKMdKkHedAwg",13) == 1851590025) strcat(s, "V");
if (crc32("fZXuLuFFOgtJI",13) == 2915293969) strcat(s, "u");
if (crc32("KnwSKKBKcNEd",12) == 3981831303) strcat(s, "E");
if (crc32("YCUbZoQn",8) == 193504920) strcat(s, "e");
if (crc32("zJTkjM",6) == 849085514) strcat(s, "i");
if (crc32("HTQLrONXw",9) == 695535700) strcat(s, "t");
if (crc32("DWVcCCaviALukG",14) == 497844562) strcat(s, "A");
if (crc32("ZWnRFGjwDV",10) == 172909061) strcat(s, "i");
if (crc32("FdnLLQvvOShPjB",14) == 2366751416) strcat(s, "Q");
if (crc32("JCqhAeyyq",9) == 1336649875) strcat(s, "c");
    return s;
}

char *suppositive_adjectives() {
    char *s = calloc(12);
    if (crc32("FWpApP",6) == 3166909536) strcat(s, "s");
if (crc32("HiuxKxvQLqub",12) == 994418872) strcat(s, "u");
if (crc32("ZhCfRvvd",8) == 2229362736) strcat(s, "p");
if (crc32("pzLmJVvVpfGwQ",13) == 3765729118) strcat(s, "p");
if (crc32("pPNGgi",6) == 531499554) strcat(s, "R");
if (crc32("VmwqKYYlmsKsnuE",15) == 4142653444) strcat(s, "o");
if (crc32("ticGqdrhvG",10) == 2311283169) strcat(s, "s");
if (crc32("bMwlCezxPL",10) == 2814590343) strcat(s, "x");
if (crc32("cnYPP",5) == 1911841583) strcat(s, "i");
if (crc32("kJQRRCsbOYB",11) == 3926890418) strcat(s, "i");
if (crc32("fjOisBNNw",9) == 1074997126) strcat(s, "t");
if (crc32("bAHuJoGb",8) == 1812925486) strcat(s, "i");
if (crc32("VMtyl",5) == 3061905257) strcat(s, "J");
if (crc32("yRBIbzJROUvxLh",14) == 879744393) strcat(s, "v");
if (crc32("ZWstD",5) == 3976649441) strcat(s, "X");
if (crc32("mCQItweZEVeJ",12) == 3344071008) strcat(s, "e");
    return s;
}

char *oneideaed_adjectives() {
    char *s = calloc(10);
    if (crc32("IXyPfJbUCaEU",12) == 2045230421) strcat(s, "o");
if (crc32("bnWSkGMudo",10) == 2162125833) strcat(s, "n");
if (crc32("wvHwQjt",7) == 1387734565) strcat(s, "e");
if (crc32("FTCsLZydk",9) == 2271545594) strcat(s, "O");
if (crc32("ctmKdQzeWTYL",12) == 287869941) strcat(s, "i");
if (crc32("uirDJdEta",9) == 3709280887) strcat(s, "d");
if (crc32("XqoZGzM",7) == 433683817) strcat(s, "H");
if (crc32("FDAroHBNMU",10) == 3917366435) strcat(s, "e");
if (crc32("YVOSzaZpGqrw",12) == 2859207764) strcat(s, "a");
if (crc32("ydwBDLujYbKvcRw",15) == 2921336850) strcat(s, "e");
if (crc32("tFYKwI",6) == 2187572893) strcat(s, "z");
if (crc32("rjaXMeakF",9) == 1213456978) strcat(s, "d");
    return s;
}

char *mydriatic_adjectives() {
    char *s = calloc(10);
    if (crc32("wiFmbtFDjFacLV",14) == 3327988768) strcat(s, "y");
if (crc32("kEAUsyb",7) == 3657352725) strcat(s, "m");
if (crc32("ySZVvzJcQ",9) == 1634978961) strcat(s, "y");
if (crc32("qmLudYMs",8) == 4259553871) strcat(s, "d");
if (crc32("ThOMLTTV",8) == 901910069) strcat(s, "B");
if (crc32("UwSJFIx",7) == 2060375397) strcat(s, "r");
if (crc32("xgOMwavN",8) == 1561823411) strcat(s, "i");
if (crc32("qPvBIb",6) == 4142064346) strcat(s, "a");
if (crc32("KoBubbZryNDF",12) == 504014116) strcat(s, "t");
if (crc32("fwohUsG",7) == 46837) strcat(s, "i");
if (crc32("yfjZtGBPLFt",11) == 4257664345) strcat(s, "n");
if (crc32("wBLSBTRiit",10) == 555903423) strcat(s, "c");
    return s;
}

char *condensable_adjectives() {
    char *s = calloc(12);
    if (crc32("vUNwXYvBdQLUA",13) == 4104928236) strcat(s, "w");
if (crc32("zmGQiAr",7) == 3893575418) strcat(s, "c");
if (crc32("zQkhhPjRKbPU",12) == 2948574038) strcat(s, "o");
if (crc32("FsuzxJiBg",9) == 13880089) strcat(s, "t");
if (crc32("zSBziOyYEzPbM",13) == 1592969123) strcat(s, "n");
if (crc32("PwFGTeALqrerb",13) == 3435753249) strcat(s, "d");
if (crc32("LonFAKrdrHiEdYH",15) == 2919491910) strcat(s, "e");
if (crc32("YVkHKxIEUvdGNrt",15) == 3667747118) strcat(s, "n");
if (crc32("FPUYFFAmbzD",11) == 603321458) strcat(s, "s");
if (crc32("CjYQMVgTuSF",11) == 2054617086) strcat(s, "N");
if (crc32("eTOrlWMDXBs",11) == 2512505050) strcat(s, "a");
if (crc32("FReXqilgsM",10) == 919976801) strcat(s, "s");
if (crc32("QTWKkHRJeCp",11) == 419543011) strcat(s, "b");
if (crc32("JRcwsB",6) == 860140277) strcat(s, "l");
if (crc32("QsyOyjuwF",9) == 732155487) strcat(s, "l");
if (crc32("rqfWDKtrZP",10) == 635820733) strcat(s, "e");
    return s;
}

char *asteriated_adjectives() {
    char *s = calloc(11);
    if (crc32("QPBNrypxeBq",11) == 695917976) strcat(s, "J");
if (crc32("LdNfcEIwca",10) == 1866882293) strcat(s, "a");
if (crc32("RReZxsFkYolq",12) == 3588695119) strcat(s, "s");
if (crc32("pBfIynLFazHaUU",14) == 4039744091) strcat(s, "t");
if (crc32("KjpBZ",5) == 2694476831) strcat(s, "e");
if (crc32("bTIHgRlEWvEL",12) == 254565596) strcat(s, "P");
if (crc32("YmsbfTgDIm",10) == 3853905659) strcat(s, "r");
if (crc32("sGynRoUZM",9) == 1151976654) strcat(s, "i");
if (crc32("ttWwFHFiTfbZe",13) == 2914320330) strcat(s, "a");
if (crc32("UIPRCjaAoqJ",11) == 1082682014) strcat(s, "n");
if (crc32("JhNLLJqJo",9) == 689387066) strcat(s, "t");
if (crc32("OzOTFQOITPuD",12) == 2939665753) strcat(s, "e");
if (crc32("juevfymtGRtidNy",15) == 4058346673) strcat(s, "d");
    return s;
}

char *omissive_adjectives() {
    char *s = calloc(9);
    if (crc32("usFXndmoGs",10) == 1739804704) strcat(s, "o");
if (crc32("xDxcH",5) == 2009291607) strcat(s, "m");
if (crc32("YbvdN",5) == 2249880472) strcat(s, "o");
if (crc32("rzfXbdPUZW",10) == 1336580056) strcat(s, "i");
if (crc32("DqjlxYXmQ",9) == 2219502471) strcat(s, "s");
if (crc32("BpYrPvrWo",9) == 1130337790) strcat(s, "s");
if (crc32("GpdpKLBRzcMHLWV",15) == 4057297299) strcat(s, "U");
if (crc32("KcsDMeen",8) == 514624730) strcat(s, "i");
if (crc32("ELNuJlxXAwOuC",13) == 904639134) strcat(s, "T");
if (crc32("mHoPybZMjM",10) == 211102328) strcat(s, "v");
if (crc32("PlhMxbIYbSIfYEc",15) == 1269847897) strcat(s, "e");
    return s;
}

char *confessionalian_adjectives() {
    char *s = calloc(16);
    if (crc32("NvizjUV",7) == 3288824164) strcat(s, "c");
if (crc32("ETMQsFjbxQK",11) == 2488699709) strcat(s, "o");
if (crc32("jmMWKczBj",9) == 1610874874) strcat(s, "n");
if (crc32("fmCfXwd",7) == 2283288576) strcat(s, "u");
if (crc32("ZTfYrNoUkXYfm",13) == 3201416305) strcat(s, "f");
if (crc32("OcshsNlTu",9) == 3550446252) strcat(s, "z");
if (crc32("MPQvZ",5) == 854148698) strcat(s, "e");
if (crc32("soBlutNuhSMZ",12) == 1841560432) strcat(s, "s");
if (crc32("rbHQEPbGlFDTeUx",15) == 1359417810) strcat(s, "M");
if (crc32("FBtYRIYwmSHZCL",14) == 1840529021) strcat(s, "s");
if (crc32("ZZusZNUJBi",10) == 2933468697) strcat(s, "i");
if (crc32("kKEajEa",7) == 3681627741) strcat(s, "p");
if (crc32("wWxUdidWbOgcJc",14) == 914518509) strcat(s, "o");
if (crc32("aZbhRYpYujNZoBT",15) == 4023232996) strcat(s, "z");
if (crc32("UKtRz",5) == 291573730) strcat(s, "n");
if (crc32("mcdGdYwsTWEcBvN",15) == 3832648044) strcat(s, "a");
if (crc32("xwCQKbXyJ",9) == 2632950689) strcat(s, "B");
if (crc32("MNSShHjJBaY",11) == 124316847) strcat(s, "l");
if (crc32("lCjZBjzyoaC",11) == 1703561396) strcat(s, "t");
if (crc32("yNdbcQSEPWrnu",13) == 2369766479) strcat(s, "i");
if (crc32("OuixpqOHRy",10) == 4111872510) strcat(s, "a");
if (crc32("uVrGEkikrRXd",12) == 1308616500) strcat(s, "e");
if (crc32("PQNlqGAd",8) == 3655186501) strcat(s, "n");
    return s;
}

char *unkindhearted_adjectives() {
    char *s = calloc(14);
    if (crc32("BrjqdyBhVe",10) == 1843632525) strcat(s, "u");
if (crc32("BCfWLfzpSTIw",12) == 655123198) strcat(s, "L");
if (crc32("iSgiuOudKuBJDV",14) == 3028384083) strcat(s, "n");
if (crc32("WPapDZefpq",10) == 4174364142) strcat(s, "n");
if (crc32("KwMKEwQqBAb",11) == 1047915254) strcat(s, "k");
if (crc32("QpCibDuR",8) == 1018770971) strcat(s, "i");
if (crc32("UwSAQAGrG",9) == 148844508) strcat(s, "n");
if (crc32("NpVRnnNuqXP",11) == 299147521) strcat(s, "d");
if (crc32("sKdAyvXg",8) == 2954934050) strcat(s, "A");
if (crc32("CLwYJ",5) == 2759656007) strcat(s, "h");
if (crc32("NdFFpy",6) == 615275983) strcat(s, "e");
if (crc32("TXBHZxQWW",9) == 165861186) strcat(s, "Q");
if (crc32("mvXmwujwfwMu",12) == 205751905) strcat(s, "a");
if (crc32("HTIkzHfk",8) == 498679324) strcat(s, "r");
if (crc32("aWSiMZheCDGiD",13) == 1159775515) strcat(s, "N");
if (crc32("bSJThyE",7) == 3824995790) strcat(s, "t");
if (crc32("LViOXBPxPBltpL",14) == 3770162769) strcat(s, "i");
if (crc32("wGluOBmZwDYdNUu",15) == 1367951921) strcat(s, "e");
if (crc32("EPDRfjyEt",9) == 2687800300) strcat(s, "M");
if (crc32("kAhknQtdUkLUSA",14) == 1263776666) strcat(s, "d");
    return s;
}

char *hotfoot_adjectives() {
    char *s = calloc(8);
    if (crc32("NCEHiUkcAH",10) == 2057583492) strcat(s, "h");
if (crc32("QEewKNw",7) == 1010115215) strcat(s, "o");
if (crc32("prDFDqDfllH",11) == 3143891068) strcat(s, "m");
if (crc32("uuHwGDmgD",9) == 1021927438) strcat(s, "t");
if (crc32("NVxbakicTyvJt",13) == 1923519758) strcat(s, "g");
if (crc32("zBVRbG",6) == 124122011) strcat(s, "f");
if (crc32("tMnaQbbpUk",10) == 654828922) strcat(s, "o");
if (crc32("NXrMHeGedj",10) == 925499849) strcat(s, "o");
if (crc32("PXgLwZmmOcX",11) == 2203640818) strcat(s, "t");
    return s;
}

char *uncomplemented_adjectives() {
    char *s = calloc(15);
    if (crc32("HaqaTJQdPIcbH",13) == 3386542073) strcat(s, "J");
if (crc32("YEvaPiZrG",9) == 4281468295) strcat(s, "u");
if (crc32("zsomI",5) == 2444081356) strcat(s, "r");
if (crc32("pjIvXrvBMrhG",12) == 1964628692) strcat(s, "n");
if (crc32("oTzbTOmKHgM",11) == 3077316165) strcat(s, "c");
if (crc32("NDTCD",5) == 4106731900) strcat(s, "o");
if (crc32("sEqRDPQXjaPLsUu",15) == 338236565) strcat(s, "F");
if (crc32("GyaAZxnucISjQRM",15) == 3784486675) strcat(s, "m");
if (crc32("QtyjcbvFsFQFz",13) == 1704416557) strcat(s, "p");
if (crc32("ATdfFOvjAZ",10) == 1809945341) strcat(s, "l");
if (crc32("yrCObyyncY",10) == 2603948302) strcat(s, "e");
if (crc32("qHjIGSxuSiRScQn",15) == 1694486799) strcat(s, "m");
if (crc32("vIWgvEWhj",9) == 319386448) strcat(s, "e");
if (crc32("DGboegrqVeKo",12) == 3685996039) strcat(s, "n");
if (crc32("tMjqdhOjG",9) == 2284457734) strcat(s, "t");
if (crc32("zhXJXzdB",8) == 355711380) strcat(s, "m");
if (crc32("VYusVicrSx",10) == 1327157642) strcat(s, "e");
if (crc32("XEKbtl",6) == 3374165491) strcat(s, "d");
    return s;
}

char *pneumographic_adjectives() {
    char *s = calloc(14);
    if (crc32("YjLxGMHRyFCl",12) == 3745995865) strcat(s, "j");
if (crc32("lcZpcDeKHNCx",12) == 4181391064) strcat(s, "p");
if (crc32("pflyBkFYNVU",11) == 3641493552) strcat(s, "K");
if (crc32("qUnlaUom",8) == 578972321) strcat(s, "n");
if (crc32("fkKBaTNsdSTl",12) == 2045566495) strcat(s, "h");
if (crc32("XZTyiiZzdRSEunE",15) == 2375850226) strcat(s, "e");
if (crc32("qjdgo",5) == 3999583056) strcat(s, "u");
if (crc32("wClIeozYxO",10) == 1676068934) strcat(s, "m");
if (crc32("ybnUWsm",7) == 630447502) strcat(s, "o");
if (crc32("vFwAPanJkRPajl",14) == 932350430) strcat(s, "g");
if (crc32("vcKxaUKxGzLB",12) == 245306875) strcat(s, "r");
if (crc32("rmFhbDcXYnpoc",13) == 2532888068) strcat(s, "a");
if (crc32("bNrgJVZebcveJQk",15) == 576660810) strcat(s, "p");
if (crc32("UvufpuZrzDHTm",13) == 1418650055) strcat(s, "y");
if (crc32("iYWzm",5) == 1797592741) strcat(s, "h");
if (crc32("evoAFtXJtbT",11) == 4197580383) strcat(s, "g");
if (crc32("eNomlOqINDfk",12) == 2279603275) strcat(s, "i");
if (crc32("VrFkkJv",7) == 1466246549) strcat(s, "c");
    return s;
}

char *icebound_adjectives() {
    char *s = calloc(9);
    if (crc32("WlLLCwOZQgX",11) == 2028019673) strcat(s, "T");
if (crc32("ogwUrTQzSPfxZKJ",15) == 1204258488) strcat(s, "i");
if (crc32("CKhrdYLtacMOV",13) == 251485654) strcat(s, "c");
if (crc32("mXJVrSCeqweJia",14) == 1078380729) strcat(s, "e");
if (crc32("gejddKAxxkmSuO",14) == 2467106474) strcat(s, "e");
if (crc32("rSEcrnv",7) == 3228354031) strcat(s, "b");
if (crc32("RVEQMX",6) == 1539111643) strcat(s, "w");
if (crc32("CDmpoD",6) == 2601816711) strcat(s, "o");
if (crc32("hembjZzunuS",11) == 1538968048) strcat(s, "E");
if (crc32("jOqjHSVVREq",11) == 1900110846) strcat(s, "u");
if (crc32("PnzJfKzwu",9) == 1163362362) strcat(s, "Q");
if (crc32("rMwNtdyaOj",10) == 4126098681) strcat(s, "n");
if (crc32("SKrnb",5) == 4197672793) strcat(s, "d");
    return s;
}

char *overflat_adjectives() {
    char *s = calloc(9);
    if (crc32("pkBhwdkvoX",10) == 4092916888) strcat(s, "j");
if (crc32("ANQnVmNvReyuzSv",15) == 3325365179) strcat(s, "o");
if (crc32("QQdfj",5) == 1644060218) strcat(s, "v");
if (crc32("RnKfsiI",7) == 2307249372) strcat(s, "s");
if (crc32("ifMlu",5) == 3710449013) strcat(s, "e");
if (crc32("RaJoIbJzVOtKUxa",15) == 2052683877) strcat(s, "r");
if (crc32("MvlYO",5) == 3837926653) strcat(s, "f");
if (crc32("WMRSGcpRMXzwKfS",15) == 163164660) strcat(s, "l");
if (crc32("KcZkNvla",8) == 808875246) strcat(s, "a");
if (crc32("RzMiCobfukZZa",13) == 2423206637) strcat(s, "I");
if (crc32("oCAVYfuQuhlE",12) == 935439907) strcat(s, "t");
    return s;
}

char *misprincipled_adjectives() {
    char *s = calloc(14);
    if (crc32("coqhNhmu",8) == 3803677466) strcat(s, "m");
if (crc32("vsYMEiWhqIJ",11) == 2750390536) strcat(s, "i");
if (crc32("QbiobQkwnyAcwH",14) == 3145805853) strcat(s, "k");
if (crc32("ybxtJK",6) == 1760997103) strcat(s, "s");
if (crc32("oBaMX",5) == 2234502830) strcat(s, "p");
if (crc32("mnLQgGFGQpU",11) == 1254047875) strcat(s, "r");
if (crc32("rWcAiRhNEfCroGg",15) == 1467618320) strcat(s, "i");
if (crc32("zeWqWikNo",9) == 2483056513) strcat(s, "U");
if (crc32("XQjOJp",6) == 564315755) strcat(s, "n");
if (crc32("uryhnmk",7) == 670866042) strcat(s, "c");
if (crc32("pWpUIpYTt",9) == 762103333) strcat(s, "i");
if (crc32("pBsGhcU",7) == 2553305390) strcat(s, "p");
if (crc32("qcMEvQ",6) == 3574071939) strcat(s, "l");
if (crc32("cLNDbpdEV",9) == 1976365884) strcat(s, "h");
if (crc32("nvyCxvbuANwcM",13) == 2938993058) strcat(s, "e");
if (crc32("jffFqp",6) == 3763224851) strcat(s, "v");
if (crc32("UzSNObeq",8) == 3934894258) strcat(s, "d");
    return s;
}

char *aciculate_adjectives() {
    char *s = calloc(10);
    if (crc32("skxEEOZHt",9) == 2134054620) strcat(s, "a");
if (crc32("SmCBiJUIC",9) == 3009437927) strcat(s, "d");
if (crc32("acZZrtkzVVUVm",13) == 2384284536) strcat(s, "c");
if (crc32("vHoNxkjbUopnWdY",15) == 2542799760) strcat(s, "i");
if (crc32("CNpxCcb",7) == 2358921497) strcat(s, "e");
if (crc32("PTAMMHqFAxxvR",13) == 1849719699) strcat(s, "c");
if (crc32("IqKhxhcRWYmoZx",14) == 2854122244) strcat(s, "u");
if (crc32("aoMhRYsb",8) == 3617346556) strcat(s, "f");
if (crc32("MZdCEXSvMAeJqye",15) == 1663336694) strcat(s, "l");
if (crc32("XSggMo",6) == 3492453483) strcat(s, "S");
if (crc32("BgPZlvbCubUjWx",14) == 2707678230) strcat(s, "a");
if (crc32("PvSymHCnffMxCXl",15) == 244229753) strcat(s, "t");
if (crc32("nfmfjO",6) == 1764297220) strcat(s, "e");
    return s;
}

char *unpecked_adjectives() {
    char *s = calloc(9);
    if (crc32("fhycmD",6) == 996768612) strcat(s, "u");
if (crc32("WCbhtkl",7) == 2118636759) strcat(s, "n");
if (crc32("uyyREzNeCADyxWG",15) == 2596007290) strcat(s, "u");
if (crc32("GucxYZ",6) == 18598714) strcat(s, "p");
if (crc32("PiXmz",5) == 3123933855) strcat(s, "e");
if (crc32("YAITwS",6) == 2758666539) strcat(s, "n");
if (crc32("HRyqaVD",7) == 1489688215) strcat(s, "c");
if (crc32("IqkEgkfgrekjD",13) == 3192377614) strcat(s, "D");
if (crc32("ILObcJl",7) == 2078943830) strcat(s, "k");
if (crc32("fONRayNpSwRAaL",14) == 1825224402) strcat(s, "h");
if (crc32("OVOGbYW",7) == 4240286492) strcat(s, "e");
if (crc32("skPpi",5) == 3778139371) strcat(s, "i");
if (crc32("Uctzct",6) == 2542822006) strcat(s, "d");
    return s;
}

char *untransfixed_adjectives() {
    char *s = calloc(13);
    if (crc32("vVdFslMIHSV",11) == 2931387495) strcat(s, "u");
if (crc32("WOfnuJ",6) == 3803135420) strcat(s, "n");
if (crc32("TuqlkJC",7) == 4274619499) strcat(s, "g");
if (crc32("HJworoEB",8) == 3842346517) strcat(s, "t");
if (crc32("QIGgmZsEXD",10) == 3461732463) strcat(s, "E");
if (crc32("UjrlJ",5) == 1786679514) strcat(s, "r");
if (crc32("wvWOXFC",7) == 197460758) strcat(s, "a");
if (crc32("oZEcTU",6) == 215701365) strcat(s, "g");
if (crc32("CWPGCWdSkqJrepk",15) == 3965713035) strcat(s, "n");
if (crc32("SWnIqyxftcm",11) == 1433809922) strcat(s, "e");
if (crc32("CQcPkdEA",8) == 3738014691) strcat(s, "s");
if (crc32("qplgUhD",7) == 1351999479) strcat(s, "C");
if (crc32("sagoCY",6) == 3032430080) strcat(s, "f");
if (crc32("iVyivh",6) == 1769454102) strcat(s, "C");
if (crc32("TSkUdoXA",8) == 2965709902) strcat(s, "i");
if (crc32("HLyIc",5) == 3510867041) strcat(s, "x");
if (crc32("TPKBAvYSuKmrci",14) == 329118644) strcat(s, "e");
if (crc32("leqzmxjlBP",10) == 3623729362) strcat(s, "d");
    return s;
}

char *unlogistic_adjectives() {
    char *s = calloc(11);
    if (crc32("pljuYoRDPv",10) == 2524039045) strcat(s, "Y");
if (crc32("bIAMcvD",7) == 3887728271) strcat(s, "u");
if (crc32("TIpSM",5) == 3811642634) strcat(s, "N");
if (crc32("AgoGt",5) == 2929437092) strcat(s, "n");
if (crc32("WMmcVF",6) == 4037624260) strcat(s, "l");
if (crc32("cQZHTePUmMXzfQ",14) == 2701215741) strcat(s, "o");
if (crc32("zbHsoIq",7) == 830511191) strcat(s, "t");
if (crc32("YJBCYHDgv",9) == 1427632169) strcat(s, "g");
if (crc32("bgYvpulhBWojOAW",15) == 493298387) strcat(s, "j");
if (crc32("KJsfofefwfEoUyL",15) == 1618100323) strcat(s, "i");
if (crc32("THlLLmHu",8) == 2633264986) strcat(s, "O");
if (crc32("sILrsSJRwDK",11) == 3091436648) strcat(s, "s");
if (crc32("qkmQAeYwmX",10) == 1330792429) strcat(s, "j");
if (crc32("ToHsLOLJZO",10) == 1603670044) strcat(s, "t");
if (crc32("nsKLg",5) == 4200123831) strcat(s, "K");
if (crc32("ClTmwRoPp",9) == 1717638203) strcat(s, "i");
if (crc32("ZRlwpYqKAVQ",11) == 1980855274) strcat(s, "O");
if (crc32("ZjOcFokEGg",10) == 4209633289) strcat(s, "c");
    return s;
}

char *ninefold_adjectives() {
    char *s = calloc(9);
    if (crc32("bJxiHZgCaiBT",12) == 2209295737) strcat(s, "n");
if (crc32("WwXcGsSryQ",10) == 3496933940) strcat(s, "i");
if (crc32("BTTCgy",6) == 186121307) strcat(s, "n");
if (crc32("nhBlIPcqqpxMO",13) == 1895506290) strcat(s, "E");
if (crc32("cZtntTHG",8) == 1436739754) strcat(s, "e");
if (crc32("kUcJCrejX",9) == 1539281065) strcat(s, "f");
if (crc32("ampKuXkqVUK",11) == 2005925122) strcat(s, "o");
if (crc32("TmfjFqyAWRa",11) == 45064507) strcat(s, "l");
if (crc32("qooNRVQEJafBfSG",15) == 129970689) strcat(s, "l");
if (crc32("SODQkfRA",8) == 3025734045) strcat(s, "d");
    return s;
}

char *uncorroded_adjectives() {
    char *s = calloc(11);
    if (crc32("RCaMOKnewT",10) == 915324878) strcat(s, "F");
if (crc32("FlzqkEYKKoyKi",13) == 1719589495) strcat(s, "u");
if (crc32("ZApElWtlSKWROtE",15) == 4277055298) strcat(s, "F");
if (crc32("xwGJxV",6) == 56720765) strcat(s, "n");
if (crc32("uSdXdapZ",8) == 1366915758) strcat(s, "c");
if (crc32("vOxuJtBKIpZDY",13) == 2615284298) strcat(s, "p");
if (crc32("uMbllKhvW",9) == 1472401962) strcat(s, "o");
if (crc32("SiGPGyTJ",8) == 3862764380) strcat(s, "s");
if (crc32("PMTOpN",6) == 2631758533) strcat(s, "r");
if (crc32("tnSNfoMvxMfR",12) == 653221866) strcat(s, "G");
if (crc32("iEVvw",5) == 570368707) strcat(s, "r");
if (crc32("IpaSnkxiMmM",11) == 909156142) strcat(s, "o");
if (crc32("CEQXDMZBiEZujWy",15) == 1353709740) strcat(s, "d");
if (crc32("wxWIeuGuVzy",11) == 3649759144) strcat(s, "e");
if (crc32("ItusFYS",7) == 2046351343) strcat(s, "d");
    return s;
}

char *pseudoDutch_adjectives() {
    char *s = calloc(12);
    if (crc32("WknbvCYMfQaDqC",14) == 3267173742) strcat(s, "L");
if (crc32("THYDafnxTkBK",12) == 3263935818) strcat(s, "p");
if (crc32("xeXBrXJuYGpt",12) == 2996790197) strcat(s, "Z");
if (crc32("jyOpjsM",7) == 1713677878) strcat(s, "s");
if (crc32("tMIisklnLXdzWR",14) == 1289229217) strcat(s, "d");
if (crc32("PcOzgDxVjqSfMn",14) == 2212803100) strcat(s, "e");
if (crc32("ZPeEVOqINzCaX",13) == 154526991) strcat(s, "l");
if (crc32("UYboG",5) == 3243920283) strcat(s, "u");
if (crc32("TUaDKqjlUodoJ",13) == 2690454513) strcat(s, "d");
if (crc32("LJnYJIDbWpRu",12) == 4124682735) strcat(s, "X");
if (crc32("bBNupVS",7) == 847580575) strcat(s, "o");
if (crc32("hthUAHRpzy",10) == 2607677161) strcat(s, "D");
if (crc32("HRkkAAwj",8) == 2536827476) strcat(s, "w");
if (crc32("TpLadlnNVnnCa",13) == 2808632950) strcat(s, "u");
if (crc32("USmqafCI",8) == 26592796) strcat(s, "t");
if (crc32("LotYiTSHgyi",11) == 2385301094) strcat(s, "w");
if (crc32("YnnvGSONtlHJi",13) == 1650840628) strcat(s, "c");
if (crc32("IeVLmoBUvcXF",12) == 375106578) strcat(s, "h");
    return s;
}

char *connected_adjectives() {
    char *s = calloc(10);
    if (crc32("ukWiHUtZka",10) == 696398503) strcat(s, "c");
if (crc32("fzveXXDAOnztB",13) == 4277321934) strcat(s, "c");
if (crc32("lCWpjllCTBAPrNA",15) == 1064461688) strcat(s, "N");
if (crc32("ZbmrcWyWmBu",11) == 3426696138) strcat(s, "o");
if (crc32("hfWLhmrB",8) == 2913406644) strcat(s, "E");
if (crc32("BwteofBym",9) == 1260979136) strcat(s, "n");
if (crc32("UTpWXVbQUk",10) == 2587432894) strcat(s, "c");
if (crc32("grvQfZg",7) == 1332513472) strcat(s, "n");
if (crc32("mRBdwARlZ",9) == 1497615074) strcat(s, "e");
if (crc32("RgaRElgWZ",9) == 3728411407) strcat(s, "c");
if (crc32("HNVPmtT",7) == 968696973) strcat(s, "k");
if (crc32("nvUFKUHMBUXGJo",14) == 2305181594) strcat(s, "t");
if (crc32("FQzkXiyzVSGRgCZ",15) == 2383946503) strcat(s, "e");
if (crc32("dscTkBhBk",9) == 1762432969) strcat(s, "d");
    return s;
}

char *specificgravity_adjectives() {
    char *s = calloc(16);
    if (crc32("CNVJKFxuofU",11) == 3680434731) strcat(s, "R");
if (crc32("PHRsWgeuF",9) == 4176918477) strcat(s, "s");
if (crc32("wKfBBXPFOQjM",12) == 1798970043) strcat(s, "p");
if (crc32("eSuMgumrGVPSXy",14) == 786697723) strcat(s, "e");
if (crc32("IWcjHgMLIPmi",12) == 2666003162) strcat(s, "M");
if (crc32("KFtbFGUNgTZl",12) == 2502206583) strcat(s, "c");
if (crc32("PCVEsEz",7) == 1199909124) strcat(s, "i");
if (crc32("qWfKdlaeGIdt",12) == 713597485) strcat(s, "r");
if (crc32("LasqX",5) == 3717764427) strcat(s, "f");
if (crc32("QKrndJSZKuNU",12) == 1555561449) strcat(s, "K");
if (crc32("MgecaLkHvqv",11) == 936880682) strcat(s, "i");
if (crc32("QDUqd",5) == 3249266593) strcat(s, "c");
if (crc32("BYgyTCXT",8) == 4050111397) strcat(s, "C");
if (crc32("YUpwGTbaCDBKz",13) == 2692493925) strcat(s, "g");
if (crc32("zpysBXpJyxeM",12) == 3056203539) strcat(s, "r");
if (crc32("mhOoGJehJ",9) == 1620104305) strcat(s, "q");
if (crc32("ZbOpKTkdq",9) == 596069044) strcat(s, "a");
if (crc32("jPBFuor",7) == 3366480290) strcat(s, "p");
if (crc32("lBWmpBq",7) == 1630104304) strcat(s, "v");
if (crc32("IOpUlFQ",7) == 2950564226) strcat(s, "u");
if (crc32("RhGiWjwa",8) == 89571754) strcat(s, "i");
if (crc32("oAgkylsKLT",10) == 2284423515) strcat(s, "W");
if (crc32("foXCjXrxus",10) == 3994386783) strcat(s, "t");
if (crc32("VefBlquTLseJIzy",15) == 28942813) strcat(s, "y");
    return s;
}

char *aimful_adjectives() {
    char *s = calloc(7);
    if (crc32("VZGYIhWankIyRF",14) == 318036441) strcat(s, "R");
if (crc32("VToLEDFKq",9) == 4155775280) strcat(s, "a");
if (crc32("fcGqdyD",7) == 3673217702) strcat(s, "Q");
if (crc32("TsSsxyvrhOC",11) == 1298181204) strcat(s, "i");
if (crc32("cnZkmaNPsD",10) == 3935448604) strcat(s, "X");
if (crc32("XvXNG",5) == 1693992423) strcat(s, "m");
if (crc32("eVYaZ",5) == 3986925677) strcat(s, "f");
if (crc32("rWkOY",5) == 842984946) strcat(s, "u");
if (crc32("aivDA",5) == 358344527) strcat(s, "c");
if (crc32("PmWUpqQqqiM",11) == 793965180) strcat(s, "l");
    return s;
}

char *overassumptive_adjectives() {
    char *s = calloc(15);
    if (crc32("AwgAOrtnSuxat",13) == 2694019653) strcat(s, "o");
if (crc32("XpstVvBcX",9) == 1872338454) strcat(s, "v");
if (crc32("HITUhpLncwNIiN",14) == 3702921230) strcat(s, "e");
if (crc32("dpyZNpr",7) == 3314067937) strcat(s, "q");
if (crc32("UBQEB",5) == 2137978987) strcat(s, "r");
if (crc32("oghhTQlFfiOlA",13) == 672059162) strcat(s, "B");
if (crc32("DmEkK",5) == 3008054037) strcat(s, "a");
if (crc32("LNgjrQHYpRMhvhf",15) == 385314613) strcat(s, "s");
if (crc32("JqSfTej",7) == 47163169) strcat(s, "s");
if (crc32("xALMGfMTBKyw",12) == 4117318593) strcat(s, "X");
if (crc32("VcCbgm",6) == 1858752460) strcat(s, "u");
if (crc32("cXMFYazzcWzza",13) == 2216321359) strcat(s, "p");
if (crc32("JKjnkAaOQ",9) == 732484790) strcat(s, "m");
if (crc32("JqdXW",5) == 2647298161) strcat(s, "Q");
if (crc32("KIaCidIfnsU",11) == 2348084285) strcat(s, "p");
if (crc32("GgQKROIXfjQqon",14) == 756565681) strcat(s, "t");
if (crc32("XxXTleHlxMUm",12) == 4130043591) strcat(s, "p");
if (crc32("MLXtlpnUrxy",11) == 400745882) strcat(s, "i");
if (crc32("YxSrtQnPZsVk",12) == 598016578) strcat(s, "c");
if (crc32("WTRLW",5) == 3464839859) strcat(s, "v");
if (crc32("mJVtjivGilUvozH",15) == 2059761351) strcat(s, "e");
    return s;
}

char *siliceous_adjectives() {
    char *s = calloc(10);
    if (crc32("djWfGhvtMH",10) == 3727525176) strcat(s, "s");
if (crc32("DaQeXNdmRNa",11) == 1978709025) strcat(s, "i");
if (crc32("KgkPWDez",8) == 2365019692) strcat(s, "l");
if (crc32("vvysWMPILZjSXS",14) == 1205623318) strcat(s, "i");
if (crc32("DwYgR",5) == 1359825206) strcat(s, "c");
if (crc32("kWfsh",5) == 1966862999) strcat(s, "e");
if (crc32("rsRszSIxeZPZ",12) == 3732385542) strcat(s, "r");
if (crc32("lnrJGtDJbinA",12) == 2086029746) strcat(s, "o");
if (crc32("vWqcqwMO",8) == 4153953860) strcat(s, "u");
if (crc32("idXeosYHxUsMnqf",15) == 3946425162) strcat(s, "u");
if (crc32("RgoLqSHAa",9) == 3585325094) strcat(s, "s");
    return s;
}

char *caseless_adjectives() {
    char *s = calloc(9);
    if (crc32("xtmzfdbVoXkhmK",14) == 2609245568) strcat(s, "X");
if (crc32("OqzUJNmjVaj",11) == 374825880) strcat(s, "c");
if (crc32("ltOlRFmCBGgujz",14) == 1221196521) strcat(s, "a");
if (crc32("YomKIJGJrlth",12) == 3738846866) strcat(s, "S");
if (crc32("hYzoaIJxdxiDf",13) == 151811105) strcat(s, "s");
if (crc32("FquhcvAK",8) == 1138869553) strcat(s, "e");
if (crc32("XWXbCYh",7) == 3473711772) strcat(s, "G");
if (crc32("CgYdNgBtQlO",11) == 414759278) strcat(s, "l");
if (crc32("voltcqjzRcKgaWC",15) == 1057266479) strcat(s, "W");
if (crc32("hcGtPFLqzBBj",12) == 2616569562) strcat(s, "e");
if (crc32("mwxSXW",6) == 155617897) strcat(s, "s");
if (crc32("vNEyTyauodP",11) == 4027334152) strcat(s, "s");
    return s;
}

char *unrejoicing_adjectives() {
    char *s = calloc(12);
    if (crc32("sDkXOIoD",8) == 2986438438) strcat(s, "u");
if (crc32("JLZsuKSpbyeXH",13) == 3864041941) strcat(s, "u");
if (crc32("maBHdeS",7) == 1828759823) strcat(s, "n");
if (crc32("vfYdv",5) == 1969694008) strcat(s, "r");
if (crc32("hnFdIQxmSBpNdz",14) == 673022518) strcat(s, "U");
if (crc32("DYpllrsu",8) == 731935636) strcat(s, "e");
if (crc32("RLspFLcmEAtYtMi",15) == 1739468967) strcat(s, "j");
if (crc32("JROhbDNHQtrSAjR",15) == 1605646095) strcat(s, "o");
if (crc32("iiDTQRalzWlrF",13) == 1627361785) strcat(s, "N");
if (crc32("PybypPkIrLaxDE",14) == 3270286700) strcat(s, "i");
if (crc32("nJAoyupBzOpLODV",15) == 3058050011) strcat(s, "u");
if (crc32("rOGHprfvrMxS",12) == 1011918181) strcat(s, "c");
if (crc32("pyKlWixnlu",10) == 4050551416) strcat(s, "i");
if (crc32("TcdbDwEodBXHEm",14) == 3736766593) strcat(s, "o");
if (crc32("ozIewHRYJXwFx",13) == 914953786) strcat(s, "n");
if (crc32("ZjJxQWuHcvvKeE",14) == 3439821100) strcat(s, "r");
if (crc32("JdQRUtXMsjIjl",13) == 1521746609) strcat(s, "g");
    return s;
}

char *unincisive_adjectives() {
    char *s = calloc(11);
    if (crc32("gAlksRxvvDr",11) == 898902371) strcat(s, "u");
if (crc32("VQhTRVCJTZcwtI",14) == 508943501) strcat(s, "n");
if (crc32("yUNVhosHzn",10) == 706588109) strcat(s, "i");
if (crc32("EwEwegywmzycP",13) == 2867461952) strcat(s, "l");
if (crc32("SGMIEuKYHaeg",12) == 2238621055) strcat(s, "n");
if (crc32("IwbkltyixbnDZVM",15) == 3359073442) strcat(s, "c");
if (crc32("izGDVH",6) == 3371004343) strcat(s, "i");
if (crc32("ygbmDvmMtaRHpy",14) == 2764104551) strcat(s, "F");
if (crc32("lsYlo",5) == 2487365502) strcat(s, "s");
if (crc32("jcOVeLLteDE",11) == 3181631235) strcat(s, "j");
if (crc32("zEqGaA",6) == 1342386017) strcat(s, "i");
if (crc32("BecdLYLDUWNoYJ",14) == 1513130304) strcat(s, "v");
if (crc32("AFsGj",5) == 1495664264) strcat(s, "e");
    return s;
}

char *nice_adjectives() {
    char *s = calloc(5);
    if (crc32("BKBzEGgCaLDCGh",14) == 1107330571) strcat(s, "n");
if (crc32("khoDmKZHNBiu",12) == 1063386095) strcat(s, "i");
if (crc32("AexhaAViJ",9) == 1094120841) strcat(s, "c");
if (crc32("sAgSurcJs",9) == 1997853735) strcat(s, "e");
    return s;
}

char *flamb_adjectives() {
    char *s = calloc(6);
    if (crc32("oQJaVEY",7) == 120802211) strcat(s, "j");
if (crc32("nvigbTVpMFY",11) == 588314058) strcat(s, "f");
if (crc32("XrnQEGn",7) == 4251758393) strcat(s, "l");
if (crc32("FyfydCjNX",9) == 270992684) strcat(s, "v");
if (crc32("EdLJgjPGSDge",12) == 1457018562) strcat(s, "a");
if (crc32("ndKMhxxufjS",11) == 3023544385) strcat(s, "m");
if (crc32("ZZsYDM",6) == 2493763391) strcat(s, "d");
if (crc32("UEaRUxuyVMBuNIG",15) == 2008588716) strcat(s, "b");
    return s;
}

char *subarytenoid_adjectives() {
    char *s = calloc(13);
    if (crc32("TuLiMVjqksgh",12) == 3096191325) strcat(s, "L");
if (crc32("Widlfe",6) == 3483207478) strcat(s, "s");
if (crc32("XNdQqZyLyf",10) == 2834006004) strcat(s, "i");
if (crc32("PaBEDaEqf",9) == 3461785452) strcat(s, "u");
if (crc32("FhPcwexXpivlXrr",15) == 4263711237) strcat(s, "b");
if (crc32("vgPFmv",6) == 2441403153) strcat(s, "a");
if (crc32("InqBRHMm",8) == 1039291008) strcat(s, "H");
if (crc32("RkZjiRJPeCu",11) == 4144243243) strcat(s, "r");
if (crc32("gqYizgsleDg",11) == 227997916) strcat(s, "h");
if (crc32("LTnOhBoxLDX",11) == 2754834664) strcat(s, "y");
if (crc32("gLjfQfGbekLiXKX",15) == 2945795219) strcat(s, "t");
if (crc32("sFcjAVCcKfDCfRD",15) == 460807269) strcat(s, "e");
if (crc32("LLhvm",5) == 1507964189) strcat(s, "p");
if (crc32("mlXMMKe",7) == 1060185114) strcat(s, "n");
if (crc32("qYRCZBp",7) == 3798117833) strcat(s, "k");
if (crc32("efVfMipS",8) == 718235801) strcat(s, "o");
if (crc32("kyuyvWGKoy",10) == 274447890) strcat(s, "V");
if (crc32("jlhOdSpJCwCXxic",15) == 4032122632) strcat(s, "i");
if (crc32("quhGMTc",7) == 1362326202) strcat(s, "d");
    return s;
}

char *diocesan_adjectives() {
    char *s = calloc(9);
    if (crc32("kpKOjDDYaecf",12) == 3429106022) strcat(s, "d");
if (crc32("YnssiBDqILCRuLq",15) == 1241570055) strcat(s, "E");
if (crc32("FxBoKQdAlglp",12) == 1534672549) strcat(s, "i");
if (crc32("WSGoqz",6) == 474353915) strcat(s, "o");
if (crc32("TFDxqDCoSFfkaow",15) == 2941823492) strcat(s, "V");
if (crc32("nAZaM",5) == 3592998340) strcat(s, "c");
if (crc32("BCPYFkIq",8) == 3199223446) strcat(s, "e");
if (crc32("xbjIRvxgTkJv",12) == 4290943573) strcat(s, "v");
if (crc32("ybgDrDVpHiQ",11) == 1269258198) strcat(s, "s");
if (crc32("holotghRoVP",11) == 999692952) strcat(s, "z");
if (crc32("IsAuduNUg",9) == 1362733373) strcat(s, "a");
if (crc32("ipldKnWsJEjRfX",14) == 2808947068) strcat(s, "n");
    return s;
}

char *aerobiologic_adjectives() {
    char *s = calloc(13);
    if (crc32("BWnDWTTRQi",10) == 2052257329) strcat(s, "a");
if (crc32("KhzmMfLVJ",9) == 4176786244) strcat(s, "e");
if (crc32("CrnbSaSzX",9) == 1399183686) strcat(s, "r");
if (crc32("zubXcBSAph",10) == 1388599889) strcat(s, "o");
if (crc32("UyYoZHdz",8) == 2642415955) strcat(s, "I");
if (crc32("dPOUvLiP",8) == 4096485987) strcat(s, "b");
if (crc32("tDLtYWd",7) == 2210737323) strcat(s, "J");
if (crc32("IdfmEbGZJlPIP",13) == 3991755710) strcat(s, "i");
if (crc32("tIRPlp",6) == 3764873282) strcat(s, "o");
if (crc32("MBJDPo",6) == 2388001356) strcat(s, "Z");
if (crc32("XUvvWbAVrJ",10) == 2800424247) strcat(s, "l");
if (crc32("SfnjCLeza",9) == 2791102400) strcat(s, "o");
if (crc32("jZGIpxxN",8) == 2739786514) strcat(s, "g");
if (crc32("ATBfGW",6) == 1222173042) strcat(s, "P");
if (crc32("bhmVHuoAIoLmU",13) == 3703299111) strcat(s, "i");
if (crc32("rbLgrackGN",10) == 4067756662) strcat(s, "c");
    return s;
}

char *sedimentological_adjectives() {
    char *s = calloc(17);
    if (crc32("gswtIErFFZwNQ",13) == 2238725661) strcat(s, "n");
if (crc32("qYbtdcBjk",9) == 3027227389) strcat(s, "s");
if (crc32("deyyJnmNATXi",12) == 422761499) strcat(s, "e");
if (crc32("OZnULfjv",8) == 2519944715) strcat(s, "q");
if (crc32("rJyuCVTiFRGRR",13) == 3627702856) strcat(s, "d");
if (crc32("uZdwfKXHFms",11) == 3780399560) strcat(s, "w");
if (crc32("MwAcKWIZXZqx",12) == 3650051616) strcat(s, "i");
if (crc32("JxvfKkphPZtuUg",14) == 2715937808) strcat(s, "m");
if (crc32("ikBdaRGyXogU",12) == 335582501) strcat(s, "e");
if (crc32("IveHm",5) == 2552947526) strcat(s, "n");
if (crc32("Qukngt",6) == 2493041443) strcat(s, "t");
if (crc32("xEhSLTIIDtInsC",14) == 4233989136) strcat(s, "o");
if (crc32("pJmpQB",6) == 330824921) strcat(s, "p");
if (crc32("DptwReT",7) == 3338972462) strcat(s, "l");
if (crc32("sNbXxWBoInapW",13) == 2248319439) strcat(s, "e");
if (crc32("qbtlGfcBLvBG",12) == 1163115898) strcat(s, "o");
if (crc32("HeTZUzBdmdiS",12) == 848647079) strcat(s, "n");
if (crc32("fByWufUGlWDK",12) == 4189041893) strcat(s, "g");
if (crc32("eLctgeRzCaHHW",13) == 678937073) strcat(s, "n");
if (crc32("xFuXg",5) == 1114755822) strcat(s, "i");
if (crc32("TThYuo",6) == 3963301249) strcat(s, "G");
if (crc32("qKXvIF",6) == 3193845209) strcat(s, "c");
if (crc32("eOGocJbhuTKd",12) == 1297061901) strcat(s, "a");
if (crc32("xXhHqZE",7) == 1174766928) strcat(s, "l");
    return s;
}

char *nonaccredited_adjectives() {
    char *s = calloc(14);
    if (crc32("IqaSqsln",8) == 953251798) strcat(s, "p");
if (crc32("uTKVCgKRhZJM",12) == 994338255) strcat(s, "n");
if (crc32("IDTzkSxYeHcMb",13) == 2098465340) strcat(s, "o");
if (crc32("JEbgkq",6) == 4073505925) strcat(s, "f");
if (crc32("JMdUyeM",7) == 360133622) strcat(s, "n");
if (crc32("ZngYfIJxsLwDcb",14) == 974853637) strcat(s, "a");
if (crc32("DeGKFQfPdn",10) == 1487340912) strcat(s, "V");
if (crc32("Abjdv",5) == 3475606832) strcat(s, "c");
if (crc32("KGvdYaFsAHY",11) == 3036888618) strcat(s, "c");
if (crc32("LmaDEtOtuoN",11) == 1937377809) strcat(s, "w");
if (crc32("bBqsp",5) == 367598312) strcat(s, "r");
if (crc32("feHyl",5) == 3551167724) strcat(s, "k");
if (crc32("gFlUeEO",7) == 2401029938) strcat(s, "e");
if (crc32("yUGLoooaAZxJjw",14) == 2866833741) strcat(s, "d");
if (crc32("HGRXYAyWx",9) == 1085947000) strcat(s, "N");
if (crc32("ipkocCdXQZV",11) == 2668751941) strcat(s, "i");
if (crc32("BiLXvQBueN",10) == 3586931129) strcat(s, "t");
if (crc32("PtPTLgVKzcV",11) == 3070693883) strcat(s, "e");
if (crc32("qcoVYRnDJm",10) == 2348345123) strcat(s, "t");
if (crc32("sGULU",5) == 1395213487) strcat(s, "d");
    return s;
}

char *unrelative_adjectives() {
    char *s = calloc(11);
    if (crc32("yaaTLfDNjqjM",12) == 830398697) strcat(s, "u");
if (crc32("ZXfChOkDzCCUlz",14) == 783414321) strcat(s, "n");
if (crc32("bxePLExs",8) == 3241724951) strcat(s, "r");
if (crc32("AZyGDdkb",8) == 1440622675) strcat(s, "m");
if (crc32("bkEskjjisaJgfvt",15) == 1995194974) strcat(s, "e");
if (crc32("MRLHSupdDc",10) == 523364649) strcat(s, "z");
if (crc32("ADMqySlWIKnCnD",14) == 3849477257) strcat(s, "l");
if (crc32("wEaLcHdovNoFA",13) == 2231946449) strcat(s, "a");
if (crc32("SuMHQvvKcUrPCwA",15) == 3798412575) strcat(s, "t");
if (crc32("YQjrqkcMu",9) == 1786668299) strcat(s, "k");
if (crc32("QARvBwBfbC",10) == 674572925) strcat(s, "i");
if (crc32("lrgjpFKJ",8) == 2984996395) strcat(s, "m");
if (crc32("lxXlTsNagv",10) == 563500073) strcat(s, "v");
if (crc32("SLAQfsejQIKcCe",14) == 1865659079) strcat(s, "e");
    return s;
}

char *dextrosinistral_adjectives() {
    char *s = calloc(16);
    if (crc32("ilaxFnDiHSUUQ",13) == 674523961) strcat(s, "d");
if (crc32("fglUBBlBXlri",12) == 3044138674) strcat(s, "e");
if (crc32("TfbXw",5) == 1925887543) strcat(s, "c");
if (crc32("UqufbDyTI",9) == 2746764206) strcat(s, "x");
if (crc32("AzJzOmhOPopS",12) == 2307748887) strcat(s, "V");
if (crc32("SfDBNdG",7) == 1589605494) strcat(s, "t");
if (crc32("mxrmlEqpTOCzI",13) == 3661987212) strcat(s, "r");
if (crc32("FTPJTNuPu",9) == 2575392832) strcat(s, "E");
if (crc32("nbHIXfXBg",9) == 3670868805) strcat(s, "o");
if (crc32("iouIOLjbLqdjPJg",15) == 1735587070) strcat(s, "s");
if (crc32("KEnjcmBk",8) == 4106764290) strcat(s, "K");
if (crc32("pUcNdcnLNnWAP",13) == 1931815922) strcat(s, "i");
if (crc32("XwOZMuCqAhXc",12) == 2624971099) strcat(s, "n");
if (crc32("bhiUnNnNlJ",10) == 1156302554) strcat(s, "i");
if (crc32("WrKOA",5) == 461347108) strcat(s, "M");
if (crc32("kdWztuUCkbOFZy",14) == 4209372138) strcat(s, "s");
if (crc32("FWiYNhcrPsFx",12) == 3082642633) strcat(s, "r");
if (crc32("XCjtlumGlhj",11) == 204904264) strcat(s, "t");
if (crc32("aYdwKRVVkt",10) == 239784896) strcat(s, "r");
if (crc32("soFgneGxmVlWR",13) == 2343269163) strcat(s, "a");
if (crc32("BzbTL",5) == 3574562403) strcat(s, "x");
if (crc32("QQClAeU",7) == 3278655843) strcat(s, "l");
    return s;
}

char *handsoff_adjectives() {
    char *s = calloc(9);
    if (crc32("NmpZjioc",8) == 4019607674) strcat(s, "h");
if (crc32("akOCPtKEHapv",12) == 3662204169) strcat(s, "y");
if (crc32("iUTYyWBZOSWnY",13) == 1374650372) strcat(s, "a");
if (crc32("QCcDkDSHPV",10) == 3924927627) strcat(s, "c");
if (crc32("dHaYzwKk",8) == 740109120) strcat(s, "n");
if (crc32("QDjXjKmSf",9) == 1405709893) strcat(s, "u");
if (crc32("qdLTmbnEUeXGVx",14) == 3565412339) strcat(s, "d");
if (crc32("qddHLQCGdnLr",12) == 355775494) strcat(s, "s");
if (crc32("BcAnNlVMVcbvN",13) == 651253469) strcat(s, "d");
if (crc32("FDcQE",5) == 3932174829) strcat(s, "o");
if (crc32("tuXwvpuPFpVYmWi",15) == 2510092494) strcat(s, "f");
if (crc32("hpYVpHk",7) == 3885976689) strcat(s, "M");
if (crc32("XpBtNKM",7) == 570311332) strcat(s, "f");
    return s;
}

char *incubative_adjectives() {
    char *s = calloc(11);
    if (crc32("SmReBUBk",8) == 121355794) strcat(s, "i");
if (crc32("bHGpeII",7) == 2198153925) strcat(s, "n");
if (crc32("USltg",5) == 3236455487) strcat(s, "c");
if (crc32("KysymPa",7) == 2668200724) strcat(s, "c");
if (crc32("bcvxgKgrZxfWgFl",15) == 3011614894) strcat(s, "u");
if (crc32("AnMRNczb",8) == 3988743364) strcat(s, "b");
if (crc32("yJmgumPLsbNSoH",14) == 1469362841) strcat(s, "a");
if (crc32("PWyUUuA",7) == 2663867206) strcat(s, "t");
if (crc32("KuuhszchNphOfZo",15) == 1627322470) strcat(s, "i");
if (crc32("GONonmcK",8) == 3224835165) strcat(s, "x");
if (crc32("gSnKi",5) == 1361204500) strcat(s, "v");
if (crc32("usyTPkvAXyj",11) == 1359605916) strcat(s, "e");
    return s;
}

char *unsplittable_adjectives() {
    char *s = calloc(13);
    if (crc32("ixZWaf",6) == 2217537334) strcat(s, "u");
if (crc32("aEFeo",5) == 2133463990) strcat(s, "u");
if (crc32("lMaIrpa",7) == 3132971682) strcat(s, "D");
if (crc32("NyHBlqC",7) == 1691837620) strcat(s, "n");
if (crc32("eHeirMx",7) == 4234739953) strcat(s, "s");
if (crc32("xAnNELUaTaIYQq",14) == 2968503704) strcat(s, "Q");
if (crc32("HPeATLsZzL",10) == 3737483580) strcat(s, "p");
if (crc32("JAPIcw",6) == 1522903607) strcat(s, "r");
if (crc32("UXbBWUb",7) == 3543184959) strcat(s, "l");
if (crc32("rbQyUjSvjyogjAU",15) == 1221349933) strcat(s, "K");
if (crc32("kYEovYKnXs",10) == 1437933043) strcat(s, "i");
if (crc32("HUrUtdT",7) == 4150643417) strcat(s, "t");
if (crc32("FPRpIDdXCqdfO",13) == 3860966445) strcat(s, "y");
if (crc32("wpenlYjNyFjpVB",14) == 2571915229) strcat(s, "t");
if (crc32("BVCxZqA",7) == 3616626687) strcat(s, "Z");
if (crc32("XiKupXXVwGqtozr",15) == 1877616899) strcat(s, "a");
if (crc32("wOBTUJGe",8) == 4257823631) strcat(s, "b");
if (crc32("oLvRHMRig",9) == 635485901) strcat(s, "w");
if (crc32("snhsiBbdfj",10) == 4179767499) strcat(s, "l");
if (crc32("hRRJZiOYEtk",11) == 4212263907) strcat(s, "e");
    return s;
}

char *halfAmericanized_adjectives() {
    char *s = calloc(17);
    if (crc32("hwkoLSXBZJ",10) == 3922992816) strcat(s, "h");
if (crc32("InfFmsoUhJjuz",13) == 2810703974) strcat(s, "l");
if (crc32("LPVxDzvpY",9) == 3908599407) strcat(s, "a");
if (crc32("vVvVbjhVrSGDLej",15) == 2621513970) strcat(s, "l");
if (crc32("OtjuymSg",8) == 27129242) strcat(s, "f");
if (crc32("UoAJjLGi",8) == 1964041243) strcat(s, "A");
if (crc32("dnWVmNNSHsQlIy",14) == 322112022) strcat(s, "m");
if (crc32("DCcWX",5) == 942381419) strcat(s, "e");
if (crc32("jvJTqVUJmsqceKl",15) == 908670269) strcat(s, "F");
if (crc32("rnIarfZvRlFKp",13) == 288137381) strcat(s, "r");
if (crc32("xCxZsjUFzvAyQx",14) == 4084767392) strcat(s, "p");
if (crc32("wpWAoZVhmh",10) == 180022739) strcat(s, "i");
if (crc32("jtfTWPzs",8) == 1109071779) strcat(s, "P");
if (crc32("zwuDco",6) == 3894837956) strcat(s, "c");
if (crc32("bcPVHLNY",8) == 2902627302) strcat(s, "a");
if (crc32("VydzBtg",7) == 1928322856) strcat(s, "n");
if (crc32("MWTshYjG",8) == 2278719281) strcat(s, "s");
if (crc32("MStjIuwugwi",11) == 1291574564) strcat(s, "i");
if (crc32("HmQNy",5) == 1303389407) strcat(s, "z");
if (crc32("fmOWYqlz",8) == 2001997524) strcat(s, "e");
if (crc32("QQdivxx",7) == 2293406531) strcat(s, "F");
if (crc32("maCIziVzXQp",11) == 1511467740) strcat(s, "d");
    return s;
}

char *Genevan_adjectives() {
    char *s = calloc(8);
    if (crc32("luizJsFS",8) == 1969382088) strcat(s, "d");
if (crc32("nxmqW",5) == 3448726225) strcat(s, "G");
if (crc32("JHuNZA",6) == 283684765) strcat(s, "e");
if (crc32("YXQKDaCMpcxXnRz",15) == 3151918933) strcat(s, "D");
if (crc32("oDiMOSvZSrkENu",14) == 3405686211) strcat(s, "n");
if (crc32("WsCqiyBduzuWJ",13) == 1156284392) strcat(s, "c");
if (crc32("ZjXZOz",6) == 1744216605) strcat(s, "e");
if (crc32("qJvWrevqQJ",10) == 67513644) strcat(s, "v");
if (crc32("fnhOZKi",7) == 3668689245) strcat(s, "T");
if (crc32("ynAAKhBpi",9) == 3773709245) strcat(s, "a");
if (crc32("kZFJIIWc",8) == 1840318738) strcat(s, "h");
if (crc32("MDXYSDOcH",9) == 2037154636) strcat(s, "n");
    return s;
}

char *selfinjurious_adjectives() {
    char *s = calloc(14);
    if (crc32("JFBNRIJ",7) == 1298091867) strcat(s, "q");
if (crc32("HuKktkMtiSOsjeL",15) == 3396290013) strcat(s, "s");
if (crc32("YoclvACjfJG",11) == 70436909) strcat(s, "e");
if (crc32("NrBReWlAEHjgEr",14) == 1459801166) strcat(s, "y");
if (crc32("YTioNzJnhi",10) == 2465572672) strcat(s, "l");
if (crc32("WGwIVWxwN",9) == 3709799568) strcat(s, "E");
if (crc32("yOxWIqT",7) == 2692941119) strcat(s, "f");
if (crc32("cTtMB",5) == 1836187547) strcat(s, "C");
if (crc32("DEqcISWXG",9) == 3204943209) strcat(s, "i");
if (crc32("gzcCNCatNQDT",12) == 2398460032) strcat(s, "n");
if (crc32("SfumuucLbwj",11) == 3411918033) strcat(s, "j");
if (crc32("FHlphLQwtnluiq",14) == 1653975250) strcat(s, "l");
if (crc32("HySmYAvtClyG",12) == 2429541703) strcat(s, "u");
if (crc32("ykToepW",7) == 152452881) strcat(s, "n");
if (crc32("ZZbxNyK",7) == 2672956453) strcat(s, "r");
if (crc32("IIqftgK",7) == 305710528) strcat(s, "y");
if (crc32("rpPpoAnK",8) == 2584653572) strcat(s, "i");
if (crc32("FSdkpeyMEaMguG",14) == 2542716578) strcat(s, "o");
if (crc32("qMmGCrFeCY",10) == 2258552318) strcat(s, "o");
if (crc32("thfAatqLPArSs",13) == 3618439994) strcat(s, "u");
if (crc32("cCily",5) == 4272063623) strcat(s, "B");
if (crc32("PecHCnOZbRtinV",14) == 2648529438) strcat(s, "s");
    return s;
}

char *semiexternal_adjectives() {
    char *s = calloc(13);
    if (crc32("LWvLlsDATlPAQm",14) == 1969119538) strcat(s, "s");
if (crc32("YsPYCbGyEEjVtQ",14) == 2582870883) strcat(s, "e");
if (crc32("yhlzSjFwjL",10) == 2534423838) strcat(s, "m");
if (crc32("CdNZBYA",7) == 4063735980) strcat(s, "H");
if (crc32("YFWTGo",6) == 313147657) strcat(s, "i");
if (crc32("oWlhSUfXlCIwG",13) == 2813309050) strcat(s, "r");
if (crc32("DTHRj",5) == 1952316041) strcat(s, "e");
if (crc32("bnpJVxBwkxKn",12) == 774684913) strcat(s, "P");
if (crc32("BRAFPOnonBjd",12) == 3900447460) strcat(s, "x");
if (crc32("uffYmpsvwFkyLxX",15) == 37627416) strcat(s, "J");
if (crc32("xdaJxlayJ",9) == 3814890986) strcat(s, "t");
if (crc32("SfaGUGxf",8) == 2814020637) strcat(s, "V");
if (crc32("cdSLODpRBukXxR",14) == 327553013) strcat(s, "e");
if (crc32("mkLPCXd",7) == 156366508) strcat(s, "r");
if (crc32("dsAvFKc",7) == 1151599363) strcat(s, "v");
if (crc32("uUtNGYgFGXJv",12) == 2817271051) strcat(s, "n");
if (crc32("uINywAxWdGQRqs",14) == 134140080) strcat(s, "a");
if (crc32("wMzhqYXnyUUuq",13) == 2807914748) strcat(s, "y");
if (crc32("VKycvuvqxO",10) == 4104981723) strcat(s, "l");
    return s;
}

char *subestuarine_adjectives() {
    char *s = calloc(13);
    if (crc32("KKHkAMzqG",9) == 1358500691) strcat(s, "s");
if (crc32("XdedJunf",8) == 2995168229) strcat(s, "g");
if (crc32("LABDiPkREZ",10) == 3881702601) strcat(s, "u");
if (crc32("AXStYys",7) == 1354718975) strcat(s, "b");
if (crc32("pPaYA",5) == 3611963004) strcat(s, "e");
if (crc32("LWbMCXShoEFN",12) == 1406520517) strcat(s, "s");
if (crc32("knHhIfDwb",9) == 2447529929) strcat(s, "t");
if (crc32("dMmjFo",6) == 1978041717) strcat(s, "u");
if (crc32("DkQBlyQTxMAaEOB",15) == 2869442110) strcat(s, "a");
if (crc32("qEkCky",6) == 1178779639) strcat(s, "e");
if (crc32("evBjPjlhXFO",11) == 169452058) strcat(s, "r");
if (crc32("gunSViONYCXiRVo",15) == 1879931408) strcat(s, "i");
if (crc32("pKhuPWF",7) == 272839313) strcat(s, "q");
if (crc32("ELmJiLeG",8) == 3997292413) strcat(s, "n");
if (crc32("FPzLyOQxHfAL",12) == 2384898001) strcat(s, "e");
    return s;
}

char *unpenetrable_adjectives() {
    char *s = calloc(13);
    if (crc32("DbWOwQUWaBJYAwm",15) == 2876490846) strcat(s, "S");
if (crc32("QvtLjhhtaOYOkn",14) == 1210867300) strcat(s, "u");
if (crc32("EoBPckbRJI",10) == 1112382162) strcat(s, "J");
if (crc32("pAfQO",5) == 365014796) strcat(s, "n");
if (crc32("oAUnrMhPU",9) == 990381813) strcat(s, "R");
if (crc32("kAlrT",5) == 1001009860) strcat(s, "p");
if (crc32("fnRKO",5) == 959802155) strcat(s, "J");
if (crc32("ezouBZkqvgvF",12) == 3808121816) strcat(s, "e");
if (crc32("isVaPJjbgsOb",12) == 983494326) strcat(s, "k");
if (crc32("ZfMxIwqOn",9) == 4270805632) strcat(s, "n");
if (crc32("wSAxk",5) == 2572271206) strcat(s, "c");
if (crc32("aOBSO",5) == 2783767219) strcat(s, "e");
if (crc32("FSMdkvqfNJg",11) == 1364488647) strcat(s, "t");
if (crc32("LYZmTihg",8) == 2256088018) strcat(s, "n");
if (crc32("JyZfxZYyrC",10) == 2428066863) strcat(s, "r");
if (crc32("tfhJBDNrCsvAxk",14) == 4247928456) strcat(s, "a");
if (crc32("TDjwYfrPjNv",11) == 712931438) strcat(s, "N");
if (crc32("QAYhnQZXu",9) == 1382611673) strcat(s, "b");
if (crc32("EBTQIjBXgvuWG",13) == 3344042086) strcat(s, "l");
if (crc32("ambTNCOt",8) == 4228678763) strcat(s, "P");
if (crc32("TjmQYeUfb",9) == 1723384917) strcat(s, "e");
    return s;
}

char *spleeny_adjectives() {
    char *s = calloc(8);
    if (crc32("MwChNGz",7) == 421381586) strcat(s, "l");
if (crc32("JcRMaMcnsC",10) == 3740624547) strcat(s, "s");
if (crc32("yJuSAnCTjLJ",11) == 47609014) strcat(s, "p");
if (crc32("RIIUwQkkEr",10) == 2118318204) strcat(s, "d");
if (crc32("dlBSbEbzldVUeHJ",15) == 1692769398) strcat(s, "l");
if (crc32("iAmRwYYMwhNOK",13) == 2313067501) strcat(s, "e");
if (crc32("cTbWlPpvZeW",11) == 3562678952) strcat(s, "v");
if (crc32("MZLBFqhjmxw",11) == 4169612504) strcat(s, "e");
if (crc32("cUnZSnOYXyj",11) == 3499859616) strcat(s, "n");
if (crc32("kpEedMlZa",9) == 3833977161) strcat(s, "y");
    return s;
}

char *holehigh_adjectives() {
    char *s = calloc(9);
    if (crc32("kTjNbOAw",8) == 2953845137) strcat(s, "z");
if (crc32("MzvCQidxUl",10) == 3422636398) strcat(s, "h");
if (crc32("pOWCAJxLRmhB",12) == 3443229864) strcat(s, "o");
if (crc32("VRnYNlsRrKw",11) == 2947656225) strcat(s, "l");
if (crc32("yidSELp",7) == 83188683) strcat(s, "l");
if (crc32("rOwtfBYsIvNxT",13) == 720971850) strcat(s, "e");
if (crc32("GDnCZZscHpqf",12) == 4182591009) strcat(s, "h");
if (crc32("ENIVnzNNonNAAj",14) == 658858891) strcat(s, "f");
if (crc32("IopOf",5) == 2001065351) strcat(s, "i");
if (crc32("DpDynaAHDHnJUKf",15) == 3929400430) strcat(s, "g");
if (crc32("WAqgjKuWCrlLbdq",15) == 2090408166) strcat(s, "y");
if (crc32("QRjtxeQsRJM",11) == 411433213) strcat(s, "h");
    return s;
}

char *queenly_adjectives() {
    char *s = calloc(8);
    if (crc32("rPUeXQgf",8) == 3310166695) strcat(s, "I");
if (crc32("ZsQJaUykSigctDb",15) == 3807601758) strcat(s, "q");
if (crc32("zaacfzgKMtGXq",13) == 350049891) strcat(s, "E");
if (crc32("cJYTQ",5) == 1305456340) strcat(s, "u");
if (crc32("vLjjWIFt",8) == 780257105) strcat(s, "e");
if (crc32("XziHwUgCvfbQ",12) == 1828540873) strcat(s, "v");
if (crc32("itQzIl",6) == 3708020032) strcat(s, "e");
if (crc32("ZqXynivV",8) == 1559718993) strcat(s, "e");
if (crc32("qIcBq",5) == 1263546497) strcat(s, "n");
if (crc32("NTGUJzaz",8) == 2574743202) strcat(s, "L");
if (crc32("ADdaNNNpgHxYO",13) == 356080387) strcat(s, "l");
if (crc32("tGKljEEoRq",10) == 4170475318) strcat(s, "o");
if (crc32("BNUwIVyvD",9) == 2780919545) strcat(s, "y");
    return s;
}

char *lothsome_adjectives() {
    char *s = calloc(9);
    if (crc32("WziRcMJYc",9) == 920917925) strcat(s, "h");
if (crc32("xCqeibomLI",10) == 3840957488) strcat(s, "l");
if (crc32("ececNkoe",8) == 95194428) strcat(s, "u");
if (crc32("eXbyrMYyT",9) == 1572882641) strcat(s, "o");
if (crc32("SaPPQDf",7) == 3292692142) strcat(s, "m");
if (crc32("vaKtJMG",7) == 3395310958) strcat(s, "t");
if (crc32("swxCBeEfp",9) == 1318608404) strcat(s, "s");
if (crc32("NzKeZYFnYfpCS",13) == 2860293954) strcat(s, "h");
if (crc32("STNEmG",6) == 3500079593) strcat(s, "o");
if (crc32("kUFpVXoEjB",10) == 833809542) strcat(s, "s");
if (crc32("klKrGqzesf",10) == 3629553593) strcat(s, "K");
if (crc32("QwJjsxf",7) == 1571927569) strcat(s, "o");
if (crc32("QRvXLSbTMF",10) == 1144095541) strcat(s, "K");
if (crc32("GqNdz",5) == 876028662) strcat(s, "m");
if (crc32("tFPlgmWwIXCF",12) == 3410578299) strcat(s, "e");
    return s;
}

char *beadiest_adjectives() {
    char *s = calloc(9);
    if (crc32("dLUCjuA",7) == 4119754932) strcat(s, "b");
if (crc32("fUbtxgdFLDieH",13) == 2334840132) strcat(s, "r");
if (crc32("DSVFbWoOnnbNwb",14) == 2498358950) strcat(s, "e");
if (crc32("HPZsUc",6) == 2343192149) strcat(s, "a");
if (crc32("TAcidSb",7) == 1807356696) strcat(s, "d");
if (crc32("pVRLoqr",7) == 1550019895) strcat(s, "M");
if (crc32("HdLUbJHDFB",10) == 537566576) strcat(s, "i");
if (crc32("sZTbpYGBM",9) == 972843788) strcat(s, "f");
if (crc32("GoaIXJardM",10) == 4268351473) strcat(s, "e");
if (crc32("JYCCQwsYErLNrAV",15) == 2349221635) strcat(s, "r");
if (crc32("ukrfREhmTqmNdK",14) == 3870047781) strcat(s, "s");
if (crc32("PmIuiIji",8) == 263430675) strcat(s, "P");
if (crc32("SzjOXxkmW",9) == 2260252242) strcat(s, "t");
    return s;
}

char *respirable_adjectives() {
    char *s = calloc(11);
    if (crc32("czqkT",5) == 2030950165) strcat(s, "r");
if (crc32("XTRakVRNN",9) == 422562941) strcat(s, "r");
if (crc32("LKOgXBvEPmrIZkK",15) == 3724579176) strcat(s, "e");
if (crc32("yMZcoMMo",8) == 62640928) strcat(s, "s");
if (crc32("QERHyQ",6) == 455021892) strcat(s, "p");
if (crc32("VgOlD",5) == 1285837671) strcat(s, "k");
if (crc32("PeTUHnFrXVdSU",13) == 3271780922) strcat(s, "i");
if (crc32("laAQfnZgIwyMz",13) == 481998093) strcat(s, "r");
if (crc32("oWJZmjMO",8) == 2034452550) strcat(s, "a");
if (crc32("vRJPp",5) == 71339411) strcat(s, "W");
if (crc32("tWMlIbKtMEkmZ",13) == 3462107901) strcat(s, "b");
if (crc32("PZiaVpGT",8) == 2152440894) strcat(s, "f");
if (crc32("QQmdGnNDu",9) == 2633791931) strcat(s, "l");
if (crc32("gzRSIOt",7) == 1643843047) strcat(s, "D");
if (crc32("EmwWtqKZYTuNPO",14) == 724476308) strcat(s, "e");
    return s;
}

char *autolytic_adjectives() {
    char *s = calloc(10);
    if (crc32("zweKITo",7) == 20895556) strcat(s, "m");
if (crc32("BXOzOwoNWz",10) == 3783103465) strcat(s, "a");
if (crc32("HVNdYvqt",8) == 25872757) strcat(s, "u");
if (crc32("dKAJliMrv",9) == 420462161) strcat(s, "t");
if (crc32("gLCLyiJ",7) == 2206886758) strcat(s, "V");
if (crc32("RiFIgPvLCDCA",12) == 4238855284) strcat(s, "o");
if (crc32("dbsNy",5) == 2901523166) strcat(s, "x");
if (crc32("YqfcqKyHWrqUtod",15) == 901225465) strcat(s, "l");
if (crc32("QhOyU",5) == 1463836037) strcat(s, "z");
if (crc32("eCxMnycV",8) == 2212041292) strcat(s, "y");
if (crc32("rhfphsFqsfT",11) == 3021598684) strcat(s, "t");
if (crc32("gnqijDA",7) == 3012626232) strcat(s, "i");
if (crc32("aIBxlzOMzBZmRn",14) == 364368625) strcat(s, "a");
if (crc32("omrWtrNSRPjkW",13) == 251693441) strcat(s, "c");
    return s;
}

char *quilleted_adjectives() {
    char *s = calloc(10);
    if (crc32("TnXmAYluKSAnOC",14) == 1303296063) strcat(s, "y");
if (crc32("UHoVPUZnqPueFO",14) == 1799281760) strcat(s, "q");
if (crc32("ceakDsMddBWk",12) == 942286321) strcat(s, "V");
if (crc32("jlEcuzV",7) == 1912488742) strcat(s, "u");
if (crc32("gxmNdJKJIrY",11) == 478713217) strcat(s, "i");
if (crc32("pJdAmMDA",8) == 4215247409) strcat(s, "l");
if (crc32("SMNmxRYOhXfTG",13) == 2083157905) strcat(s, "l");
if (crc32("eKbKVCKqfrws",12) == 274036584) strcat(s, "e");
if (crc32("hoFjJ",5) == 1923479015) strcat(s, "q");
if (crc32("MuvjIIcFEKVI",12) == 3842015388) strcat(s, "t");
if (crc32("sNiPL",5) == 2169299532) strcat(s, "e");
if (crc32("KjTmPupwgcL",11) == 3024528218) strcat(s, "R");
if (crc32("nAqaf",5) == 1317838213) strcat(s, "d");
    return s;
}

char *weatherly_adjectives() {
    char *s = calloc(10);
    if (crc32("DazWeubzIy",10) == 331247090) strcat(s, "Y");
if (crc32("PqcCkD",6) == 3574152378) strcat(s, "w");
if (crc32("nkmptvcydmSrvW",14) == 2633477246) strcat(s, "e");
if (crc32("IQKUy",5) == 1923786570) strcat(s, "a");
if (crc32("fiYhCuYJYbNwtok",15) == 3564507043) strcat(s, "e");
if (crc32("kHXWtkcLYKo",11) == 3688882420) strcat(s, "t");
if (crc32("fYiakggKfXc",11) == 3181088664) strcat(s, "g");
if (crc32("vhJJZ",5) == 2986814189) strcat(s, "h");
if (crc32("RKauHHnLoiSousi",15) == 3070309551) strcat(s, "e");
if (crc32("VfNoRSIDoda",11) == 2956640075) strcat(s, "S");
if (crc32("ZogsVGOafNoiVon",15) == 2507762352) strcat(s, "r");
if (crc32("TPsXKdjR",8) == 1513302807) strcat(s, "h");
if (crc32("PgTdRBqAwgT",11) == 1574534780) strcat(s, "l");
if (crc32("qnLsMDErXcmPb",13) == 1104573372) strcat(s, "c");
if (crc32("dnTcnjl",7) == 2905907248) strcat(s, "y");
    return s;
}

char *aggravative_adjectives() {
    char *s = calloc(12);
    if (crc32("IommCebJpzpu",12) == 2297182569) strcat(s, "a");
if (crc32("MZxQW",5) == 3468432777) strcat(s, "g");
if (crc32("MjvdKWbGDdlOgD",14) == 3418448095) strcat(s, "c");
if (crc32("yedfHxdGmBD",11) == 3342376700) strcat(s, "g");
if (crc32("wzYGNEHWhZCdYcs",15) == 547043888) strcat(s, "d");
if (crc32("eDAflpSVLfHK",12) == 3790015301) strcat(s, "r");
if (crc32("cccVndKYodyCJbm",15) == 3827851133) strcat(s, "z");
if (crc32("BvOoicwe",8) == 894898395) strcat(s, "a");
if (crc32("VMxrAWZdbijyyls",15) == 4154846958) strcat(s, "v");
if (crc32("FnzslLDKqpZlyYX",15) == 444934567) strcat(s, "v");
if (crc32("IywPmuT",7) == 2657927309) strcat(s, "a");
if (crc32("RWwUDore",8) == 801315573) strcat(s, "k");
if (crc32("vrVgiI",6) == 4150941905) strcat(s, "t");
if (crc32("McGqtV",6) == 1178443612) strcat(s, "i");
if (crc32("QBzBVPCl",8) == 2817895215) strcat(s, "A");
if (crc32("BYdSPCpIr",9) == 3541332345) strcat(s, "v");
if (crc32("EPBzz",5) == 2334293878) strcat(s, "e");
    return s;
}

char *mutilative_adjectives() {
    char *s = calloc(11);
    if (crc32("jKAWtnybtwdZJ",13) == 1530391352) strcat(s, "M");
if (crc32("XMfsqiHIU",9) == 1046797045) strcat(s, "m");
if (crc32("kkiaconHKaezl",13) == 2380583103) strcat(s, "u");
if (crc32("WBXgAw",6) == 3864589046) strcat(s, "t");
if (crc32("BihIXDoauuz",11) == 196109203) strcat(s, "e");
if (crc32("VUjKWoBWXuRm",12) == 919310380) strcat(s, "i");
if (crc32("UIlunq",6) == 1205135196) strcat(s, "l");
if (crc32("PfUaFJcHpFfVpY",14) == 198802262) strcat(s, "a");
if (crc32("Ubgfadsu",8) == 2902746998) strcat(s, "S");
if (crc32("lBTzhYrIFwOHoNq",15) == 2409393640) strcat(s, "t");
if (crc32("fQyfBQ",6) == 3998400510) strcat(s, "i");
if (crc32("mLZJVcaOoP",10) == 2931771628) strcat(s, "v");
if (crc32("vfFvg",5) == 1884918100) strcat(s, "e");
    return s;
}

char *bibliotic_adjectives() {
    char *s = calloc(10);
    if (crc32("gPkkIPaQGWWe",12) == 3697177138) strcat(s, "b");
if (crc32("JOmTzM",6) == 904384693) strcat(s, "W");
if (crc32("VAupsLJHBNMW",12) == 3278046266) strcat(s, "i");
if (crc32("hqhFIrDyl",9) == 830389166) strcat(s, "N");
if (crc32("iIUlhT",6) == 3085335711) strcat(s, "b");
if (crc32("mtbAVwApJH",10) == 3590464505) strcat(s, "v");
if (crc32("PMqyI",5) == 864125402) strcat(s, "l");
if (crc32("IAAzkdFeagzFXy",14) == 2945175666) strcat(s, "f");
if (crc32("YYmaEZlHvXFTo",13) == 1975816168) strcat(s, "i");
if (crc32("DLGOXcZIyyN",11) == 1175836444) strcat(s, "T");
if (crc32("OnsrE",5) == 2322645207) strcat(s, "o");
if (crc32("PeYfxUDI",8) == 2341503778) strcat(s, "t");
if (crc32("QmiKyfBVXu",10) == 2695247711) strcat(s, "i");
if (crc32("XvTmXCfkgBnHP",13) == 489894827) strcat(s, "R");
if (crc32("mwNIfDek",8) == 3431366515) strcat(s, "c");
    return s;
}

char *nonaccordant_adjectives() {
    char *s = calloc(13);
    if (crc32("fpBDSPdRVrQHlP",14) == 2480746905) strcat(s, "n");
if (crc32("DKrKjSW",7) == 2791939102) strcat(s, "o");
if (crc32("WlCiNt",6) == 1138540722) strcat(s, "B");
if (crc32("dlmsEhYsyM",10) == 4148826096) strcat(s, "n");
if (crc32("TVkbKUjSGX",10) == 3054545415) strcat(s, "a");
if (crc32("zvAqLEQbIfN",11) == 2963571670) strcat(s, "c");
if (crc32("mnOfvrLf",8) == 1168208064) strcat(s, "G");
if (crc32("laBkNiZbtEH",11) == 205211403) strcat(s, "c");
if (crc32("tazCJ",5) == 2111013483) strcat(s, "J");
if (crc32("fvSLa",5) == 2525449118) strcat(s, "o");
if (crc32("NPUPKvDkcVpzyZ",14) == 3919425294) strcat(s, "w");
if (crc32("VSXjpiX",7) == 2398456767) strcat(s, "r");
if (crc32("zusrvT",6) == 299178090) strcat(s, "d");
if (crc32("ELzrlfYNTHULD",13) == 2407247215) strcat(s, "a");
if (crc32("qSbBQtapRgeDsrI",15) == 2157071756) strcat(s, "n");
if (crc32("inonyT",6) == 4290876777) strcat(s, "F");
if (crc32("bVKzkjJxtfzAIwH",15) == 3335584207) strcat(s, "t");
    return s;
}

char *heaviest_adjectives() {
    char *s = calloc(9);
    if (crc32("ErsuoIriKtYfXgP",15) == 381941824) strcat(s, "e");
if (crc32("EsfjOHnuhvIXX",13) == 1981561505) strcat(s, "h");
if (crc32("ifMucYP",7) == 3958256841) strcat(s, "e");
if (crc32("hHtBZjVrXLVD",12) == 1850384898) strcat(s, "a");
if (crc32("GNWJsbTWGfLW",12) == 1810120604) strcat(s, "v");
if (crc32("IjqHuOWpjlFTPhl",15) == 3110621301) strcat(s, "k");
if (crc32("mUcSZtWIDjVH",12) == 3904353154) strcat(s, "i");
if (crc32("mNqrBGyEtqvTzXa",15) == 2029577521) strcat(s, "e");
if (crc32("bASlRZnlQj",10) == 3216859150) strcat(s, "U");
if (crc32("AQwqmuo",7) == 4026083534) strcat(s, "s");
if (crc32("LAhWKHYvIN",10) == 2431316537) strcat(s, "e");
if (crc32("FmVzrc",6) == 2010344768) strcat(s, "t");
    return s;
}

char *acuate_adjectives() {
    char *s = calloc(7);
    if (crc32("miwLn",5) == 1188482795) strcat(s, "a");
if (crc32("NkYNTSgtXq",10) == 2874654959) strcat(s, "c");
if (crc32("biOJljdcAVYpa",13) == 724841866) strcat(s, "v");
if (crc32("yZcTiv",6) == 2687758502) strcat(s, "u");
if (crc32("XyCGGLHqlnsSo",13) == 949917937) strcat(s, "a");
if (crc32("BgPVUo",6) == 160048764) strcat(s, "d");
if (crc32("VxCIrTyNX",9) == 1381454335) strcat(s, "t");
if (crc32("PWgkkZM",7) == 1690073579) strcat(s, "e");
    return s;
}

char *skillful_adjectives() {
    char *s = calloc(9);
    if (crc32("pidWzI",6) == 698714487) strcat(s, "s");
if (crc32("gQGsreAaFg",10) == 2721309776) strcat(s, "K");
if (crc32("baCAOcW",7) == 3188684098) strcat(s, "k");
if (crc32("NgvfAVAaRK",10) == 2848688355) strcat(s, "i");
if (crc32("OhdiieGem",9) == 4202094985) strcat(s, "c");
if (crc32("FpJeHvvyQBc",11) == 3241457351) strcat(s, "l");
if (crc32("bVzTYixGZEHEYTj",15) == 4067219371) strcat(s, "v");
if (crc32("OCjEVayXpnRMNGQ",15) == 2962377281) strcat(s, "l");
if (crc32("dnXMaq",6) == 700057425) strcat(s, "f");
if (crc32("ssrQNhQBhdB",11) == 1301955287) strcat(s, "u");
if (crc32("oIMdlPfG",8) == 2757618674) strcat(s, "l");
    return s;
}

char *unendemic_adjectives() {
    char *s = calloc(10);
    if (crc32("xJwOsKYskkgld",13) == 2883207226) strcat(s, "K");
if (crc32("VUKfb",5) == 1635163282) strcat(s, "u");
if (crc32("OBrxPqnc",8) == 2025330610) strcat(s, "n");
if (crc32("ulLPKOHQTv",10) == 4278789940) strcat(s, "e");
if (crc32("WHIwxLdfZCXiF",13) == 1796328477) strcat(s, "T");
if (crc32("vsTuDKTzzgesi",13) == 2146432192) strcat(s, "n");
if (crc32("mXdWdqCrz",9) == 1216583430) strcat(s, "U");
if (crc32("HykeuQzNTfbv",12) == 1037440840) strcat(s, "d");
if (crc32("ObLaJEciMTEl",12) == 605636311) strcat(s, "h");
if (crc32("NLhuefzsrW",10) == 309968418) strcat(s, "e");
if (crc32("OvYHMveSkxmDU",13) == 1231314567) strcat(s, "m");
if (crc32("eXceEpQE",8) == 1871465210) strcat(s, "i");
if (crc32("juCEHw",6) == 1986962595) strcat(s, "t");
if (crc32("eNvrpOpWVuPB",12) == 1798306853) strcat(s, "c");
    return s;
}

char *preaexistent_adjectives() {
    char *s = calloc(13);
    if (crc32("RFuXPnnHwkZiOdO",15) == 2273757125) strcat(s, "f");
if (crc32("UjEpdQpbVRbb",12) == 2847730849) strcat(s, "p");
if (crc32("VkHhZHmyDR",10) == 2367530011) strcat(s, "r");
if (crc32("AoCQu",5) == 4049949553) strcat(s, "m");
if (crc32("zeOYI",5) == 1711791510) strcat(s, "e");
if (crc32("zxkLIyte",8) == 352064525) strcat(s, "o");
if (crc32("DGrnS",5) == 872125257) strcat(s, "a");
if (crc32("JrkdVJrJWEqD",12) == 1875039417) strcat(s, "e");
if (crc32("BqPJrZHCTu",10) == 3452802180) strcat(s, "x");
if (crc32("RMEoENJMUXekxi",14) == 1974931678) strcat(s, "r");
if (crc32("fpiQechShamdad",14) == 2698432415) strcat(s, "i");
if (crc32("wISReja",7) == 1777910629) strcat(s, "s");
if (crc32("UYMNqxnbor",10) == 32671267) strcat(s, "t");
if (crc32("nJjPBUJVmOO",11) == 2255256700) strcat(s, "J");
if (crc32("kJGIZECaRy",10) == 790411540) strcat(s, "e");
if (crc32("LkzSzgywAxM",11) == 4113778512) strcat(s, "c");
if (crc32("niWIhvABL",9) == 1480752530) strcat(s, "n");
if (crc32("xCRIVlMGzk",10) == 2996114790) strcat(s, "t");
    return s;
}

char *nosogeographic_adjectives() {
    char *s = calloc(15);
    if (crc32("LSbaoru",7) == 2321030331) strcat(s, "n");
if (crc32("xERzrUWkHPI",11) == 3159583121) strcat(s, "o");
if (crc32("AoZhJTm",7) == 1383399217) strcat(s, "F");
if (crc32("OHeupWCMI",9) == 137941537) strcat(s, "s");
if (crc32("ytDaHlI",7) == 711249401) strcat(s, "h");
if (crc32("LcZanlaEC",9) == 3103433225) strcat(s, "o");
if (crc32("IRxESrL",7) == 2526971951) strcat(s, "T");
if (crc32("TKzipYwj",8) == 160623257) strcat(s, "g");
if (crc32("NUIJEldSoXvGSvs",15) == 1903068818) strcat(s, "G");
if (crc32("OfcjoBKrARSs",12) == 1510371852) strcat(s, "e");
if (crc32("zdPcsOWoiO",10) == 4228812591) strcat(s, "o");
if (crc32("LHQVd",5) == 3468765587) strcat(s, "g");
if (crc32("StYlVoT",7) == 3175298565) strcat(s, "r");
if (crc32("rfLuWwe",7) == 3609870478) strcat(s, "W");
if (crc32("nBmgDjGquXEA",12) == 3471602445) strcat(s, "a");
if (crc32("vvwPqNO",7) == 2465913635) strcat(s, "p");
if (crc32("SiodXFYlei",10) == 3675892514) strcat(s, "h");
if (crc32("XwLEPQqVvKwchx",14) == 3506533867) strcat(s, "i");
if (crc32("ixUvRPjVkqamf",13) == 2861528773) strcat(s, "c");
    return s;
}

char *rollable_adjectives() {
    char *s = calloc(9);
    if (crc32("hCkUoykFiU",10) == 220453477) strcat(s, "F");
if (crc32("pEAVqhk",7) == 2266230293) strcat(s, "r");
if (crc32("HWVakAfXZXfui",13) == 1810625115) strcat(s, "o");
if (crc32("MemeTcOXvGtXQI",14) == 3536452407) strcat(s, "n");
if (crc32("JIqnnmLLtGhbatk",15) == 3117902520) strcat(s, "l");
if (crc32("oMBWSqKGJL",10) == 1675992089) strcat(s, "l");
if (crc32("OVaxbeszO",9) == 886428332) strcat(s, "a");
if (crc32("tEUFooeiCt",10) == 2536682835) strcat(s, "b");
if (crc32("ijqZbuexFNAYFH",14) == 1793825718) strcat(s, "l");
if (crc32("XsfXLPdZgOe",11) == 2984820409) strcat(s, "X");
if (crc32("WwnsDlxzYeLeZh",14) == 239217264) strcat(s, "e");
    return s;
}

char *Voltairian_adjectives() {
    char *s = calloc(11);
    if (crc32("TOdcBo",6) == 1812541922) strcat(s, "F");
if (crc32("knXMenMOdL",10) == 4014706637) strcat(s, "V");
if (crc32("IEgKPEVDWFQ",11) == 4265434633) strcat(s, "o");
if (crc32("nQDrIhHQxXWfB",13) == 201723698) strcat(s, "l");
if (crc32("CgUNrKSZqVZKZ",13) == 1119638094) strcat(s, "h");
if (crc32("NYcdPSIsfPR",11) == 1842692381) strcat(s, "t");
if (crc32("bXjxxamKXjDaZsp",15) == 1045174416) strcat(s, "a");
if (crc32("dWPhSEh",7) == 1448902213) strcat(s, "G");
if (crc32("EMmMxcFMVH",10) == 2983086370) strcat(s, "i");
if (crc32("eYcmZBQtmCkqm",13) == 1613145787) strcat(s, "r");
if (crc32("KiaXefdMX",9) == 2555389119) strcat(s, "i");
if (crc32("ErQmTXaTP",9) == 3190052287) strcat(s, "i");
if (crc32("SJgoJAU",7) == 3870005887) strcat(s, "a");
if (crc32("SppuPFCeHcwsQY",14) == 3721101372) strcat(s, "n");
    return s;
}

char *halfminded_adjectives() {
    char *s = calloc(11);
    if (crc32("GokDGo",6) == 71568778) strcat(s, "W");
if (crc32("WMjLaEylvFdW",12) == 1690901974) strcat(s, "h");
if (crc32("woebIyRm",8) == 53520243) strcat(s, "a");
if (crc32("AYvRxR",6) == 53089128) strcat(s, "l");
if (crc32("qZzMwQj",7) == 4278439288) strcat(s, "f");
if (crc32("BIMLEgkTSCxCPCy",15) == 1261743652) strcat(s, "m");
if (crc32("SHaaMKwwRh",10) == 2601955772) strcat(s, "Y");
if (crc32("OWAurGprv",9) == 1948103710) strcat(s, "i");
if (crc32("UhbBzTSFVU",10) == 657689707) strcat(s, "n");
if (crc32("IZtle",5) == 2902464058) strcat(s, "j");
if (crc32("BcznuCgVQZdT",12) == 1468882216) strcat(s, "d");
if (crc32("IzqOHWRnpvAdWPY",15) == 4180317730) strcat(s, "e");
if (crc32("GqkHqUPvWrqqapj",15) == 704953804) strcat(s, "d");
    return s;
}

char *antimonyyellow_adjectives() {
    char *s = calloc(15);
    if (crc32("ANRMxJzrfMHaJN",14) == 4004519105) strcat(s, "k");
if (crc32("iduHct",6) == 3378196267) strcat(s, "a");
if (crc32("dhklushdNEE",11) == 217533386) strcat(s, "C");
if (crc32("wXJQYLuSu",9) == 3567503364) strcat(s, "n");
if (crc32("oFgrVxUiLim",11) == 394625623) strcat(s, "N");
if (crc32("BcqGPkEEIXdl",12) == 536138497) strcat(s, "t");
if (crc32("zPDfvXnQviOHTjN",15) == 3677013864) strcat(s, "i");
if (crc32("mHMqWqKylTizl",13) == 2785282496) strcat(s, "m");
if (crc32("UJONstQdddEbyx",14) == 498534551) strcat(s, "R");
if (crc32("ccFdMkEsCeJ",11) == 862002676) strcat(s, "o");
if (crc32("uIDFTuPaEBgFTEp",15) == 1860802144) strcat(s, "n");
if (crc32("lkLdVWxul",9) == 1815485674) strcat(s, "y");
if (crc32("NGrmvXwn",8) == 2965289350) strcat(s, "C");
if (crc32("DFyGsIUxBgh",11) == 1351485026) strcat(s, "y");
if (crc32("vpqKYct",7) == 4018352488) strcat(s, "U");
if (crc32("bjtYcLeqe",9) == 2896269899) strcat(s, "e");
if (crc32("UmpDlxbDalyFoQh",15) == 56751820) strcat(s, "l");
if (crc32("wDiJbf",6) == 3266256772) strcat(s, "l");
if (crc32("VjOkwt",6) == 2694124562) strcat(s, "n");
if (crc32("ENbyMgT",7) == 1966101401) strcat(s, "o");
if (crc32("vvobKzwTVcl",11) == 379509035) strcat(s, "w");
    return s;
}

char *unscorned_adjectives() {
    char *s = calloc(10);
    if (crc32("pQSdEtQdbW",10) == 433471377) strcat(s, "u");
if (crc32("MTWnitFxRnCPyb",14) == 3411688970) strcat(s, "n");
if (crc32("dkLZpXI",7) == 3674990618) strcat(s, "c");
if (crc32("QajkgrXZj",9) == 3073150038) strcat(s, "s");
if (crc32("SjsTgCoXuAAtd",13) == 3457399490) strcat(s, "c");
if (crc32("GWWkUQtZke",10) == 1380651449) strcat(s, "Q");
if (crc32("JXASMGrzJYVupkA",15) == 882871352) strcat(s, "o");
if (crc32("FIXQE",5) == 1797512737) strcat(s, "R");
if (crc32("ZHRHJcQmwrwyFdh",15) == 937625962) strcat(s, "r");
if (crc32("KfQYibKp",8) == 133725806) strcat(s, "V");
if (crc32("khjfNF",6) == 2469872749) strcat(s, "n");
if (crc32("GSNaNFXPAdR",11) == 926018826) strcat(s, "e");
if (crc32("SZQcMDodBQ",10) == 2567574658) strcat(s, "d");
    return s;
}

char *bibliolatrous_adjectives() {
    char *s = calloc(14);
    if (crc32("NMdvmvNcjZUvq",13) == 3823895421) strcat(s, "b");
if (crc32("pxRrhJPv",8) == 1424200769) strcat(s, "i");
if (crc32("dNqrNFacomHar",13) == 2372676162) strcat(s, "s");
if (crc32("pCfCJkFTepu",11) == 949712800) strcat(s, "b");
if (crc32("BUMSnJX",7) == 2469566010) strcat(s, "v");
if (crc32("tkGILKJGyvWYY",13) == 2784611421) strcat(s, "l");
if (crc32("ATgOrKVADnUdt",13) == 3866795854) strcat(s, "J");
if (crc32("QpKRQCZKOyRvJJ",14) == 610312775) strcat(s, "i");
if (crc32("bEFasmvpGOs",11) == 2811032965) strcat(s, "d");
if (crc32("HqkbAsmTMDPigu",14) == 688806235) strcat(s, "o");
if (crc32("vYowYFmEWbub",12) == 1129162137) strcat(s, "A");
if (crc32("PqTfuhFroGizHz",14) == 4049173677) strcat(s, "l");
if (crc32("hrxmXEoEXshg",12) == 286590247) strcat(s, "w");
if (crc32("KDknldUaVo",10) == 3339225935) strcat(s, "a");
if (crc32("kgKEZdgdDRynmfs",15) == 447612593) strcat(s, "t");
if (crc32("AWHzm",5) == 2700858203) strcat(s, "H");
if (crc32("BjqRhD",6) == 1090403369) strcat(s, "r");
if (crc32("FYntHdvOUwv",11) == 3748221558) strcat(s, "y");
if (crc32("CqtHONpPGAeB",12) == 3105328867) strcat(s, "o");
if (crc32("VlavF",5) == 2941132303) strcat(s, "u");
if (crc32("oTwsnDNRo",9) == 221696958) strcat(s, "s");
    return s;
}

char *nonirritable_adjectives() {
    char *s = calloc(13);
    if (crc32("RjpCWHDNMBJCOh",14) == 3758156976) strcat(s, "u");
if (crc32("FlZylL",6) == 2108901271) strcat(s, "n");
if (crc32("QPKuEL",6) == 2722657862) strcat(s, "o");
if (crc32("mZYChovjsHeDs",13) == 3723034826) strcat(s, "n");
if (crc32("RhWooqZezIT",11) == 1100853553) strcat(s, "i");
if (crc32("RHpvOQvsDZqobAW",15) == 2906077932) strcat(s, "r");
if (crc32("KbzaNdfRHcO",11) == 1206972192) strcat(s, "l");
if (crc32("akFIuZZMAQU",11) == 2313226710) strcat(s, "r");
if (crc32("EJcaGqwsSiwr",12) == 400782783) strcat(s, "i");
if (crc32("PCgTECToAfLvqD",14) == 1187711171) strcat(s, "y");
if (crc32("OBEnaJqXBCwrO",13) == 2032235904) strcat(s, "t");
if (crc32("WXYThVHbdZKv",12) == 1050699176) strcat(s, "h");
if (crc32("uPfMiKEjzpZ",11) == 2195323226) strcat(s, "a");
if (crc32("CWHPFYB",7) == 3711345452) strcat(s, "b");
if (crc32("KmPuFY",6) == 2556185658) strcat(s, "l");
if (crc32("wvjQgNDO",8) == 1274402832) strcat(s, "b");
if (crc32("gsZoqIgqLh",10) == 3648887695) strcat(s, "e");
    return s;
}

char *convulsionary_adjectives() {
    char *s = calloc(14);
    if (crc32("SpeoWyuuYeY",11) == 3159267528) strcat(s, "h");
if (crc32("STWFBanpWgyAHR",14) == 764535991) strcat(s, "c");
if (crc32("CPNYDnDFkAiUN",13) == 1235059869) strcat(s, "B");
if (crc32("GCXHwTvQNUrslf",14) == 1216056379) strcat(s, "o");
if (crc32("mDHeZbqoVuM",11) == 913118784) strcat(s, "V");
if (crc32("arSkXpV",7) == 2857042883) strcat(s, "n");
if (crc32("AgAdldbfnMHSln",14) == 1144995121) strcat(s, "v");
if (crc32("tWrVYWGlbBKfeu",14) == 1830995811) strcat(s, "u");
if (crc32("cuURAMWlY",9) == 3911015680) strcat(s, "l");
if (crc32("zqacFapc",8) == 364040787) strcat(s, "E");
if (crc32("qbaGnqfsgcFN",12) == 2094138388) strcat(s, "s");
if (crc32("mJXtjUmWAvyjn",13) == 3418245974) strcat(s, "i");
if (crc32("bZUoBiEyNKaj",12) == 378084805) strcat(s, "H");
if (crc32("Lfxya",5) == 3687202835) strcat(s, "o");
if (crc32("KBSioVlffvd",11) == 446437167) strcat(s, "n");
if (crc32("PCacHlc",7) == 3654189098) strcat(s, "a");
if (crc32("yMIuvSLZzjDS",12) == 2303797546) strcat(s, "u");
if (crc32("sQEGjGrq",8) == 1817993827) strcat(s, "r");
if (crc32("RtICaRCIPstZynP",15) == 1328027331) strcat(s, "y");
    return s;
}

char *nonBrahmanic_adjectives() {
    char *s = calloc(13);
    if (crc32("QcbGPpULnxOLo",13) == 3549617741) strcat(s, "g");
if (crc32("xHJXZ",5) == 3589360481) strcat(s, "n");
if (crc32("jKsilzgZmHgufjK",15) == 3556264650) strcat(s, "G");
if (crc32("fwFHTRweBaqVjrs",15) == 3243288753) strcat(s, "o");
if (crc32("EimpInJAymw",11) == 2383130518) strcat(s, "C");
if (crc32("FsQsxgWyhgTV",12) == 1737219724) strcat(s, "n");
if (crc32("fZEQbxIlhcnay",13) == 2999280654) strcat(s, "B");
if (crc32("fsajyT",6) == 2235326009) strcat(s, "r");
if (crc32("FMrCOEkkv",9) == 2282150390) strcat(s, "y");
if (crc32("BRmTgOuqvJWp",12) == 3983450265) strcat(s, "a");
if (crc32("kLLtHe",6) == 1090149418) strcat(s, "h");
if (crc32("LhJlxzZllgdR",12) == 3917615426) strcat(s, "h");
if (crc32("HNeWQMNXDSvqyHS",15) == 1341529481) strcat(s, "m");
if (crc32("ZlWzw",5) == 3073582362) strcat(s, "a");
if (crc32("oOYxieIGNdW",11) == 4260623722) strcat(s, "n");
if (crc32("puNPdEZphXqyXuy",15) == 3964070325) strcat(s, "z");
if (crc32("eKQgRPwHdVpfCPq",15) == 2056597090) strcat(s, "i");
if (crc32("AFeOYzX",7) == 3887703313) strcat(s, "c");
    return s;
}

char *heathery_adjectives() {
    char *s = calloc(9);
    if (crc32("cMoUuPJ",7) == 3843432932) strcat(s, "U");
if (crc32("iYpzdHDTUaBpwhN",15) == 3079552969) strcat(s, "h");
if (crc32("YyNCKP",6) == 527475087) strcat(s, "e");
if (crc32("LQKmUf",6) == 782506810) strcat(s, "C");
if (crc32("SHevpILcKemh",12) == 2721353621) strcat(s, "a");
if (crc32("umIwL",5) == 1577313209) strcat(s, "t");
if (crc32("VpWjVjlymL",10) == 4055338981) strcat(s, "Y");
if (crc32("hGskgJCfiw",10) == 2284898154) strcat(s, "h");
if (crc32("RxYOL",5) == 1100785803) strcat(s, "e");
if (crc32("AvSRimK",7) == 2502861241) strcat(s, "d");
if (crc32("eYvWkHJCMvIYIl",14) == 1765896602) strcat(s, "r");
if (crc32("ddwuLmSadLJoNBC",15) == 3323613898) strcat(s, "v");
if (crc32("RODJmMeSi",9) == 3081713859) strcat(s, "y");
    return s;
}

char *semipunitory_adjectives() {
    char *s = calloc(13);
    if (crc32("hJiVQ",5) == 742529239) strcat(s, "s");
if (crc32("creuzXHDuIW",11) == 4042722514) strcat(s, "e");
if (crc32("DaMezqDF",8) == 1564187035) strcat(s, "m");
if (crc32("txowyQpQmsARYdY",15) == 62603678) strcat(s, "x");
if (crc32("yWYfTjjvVVLgxqv",15) == 1964710649) strcat(s, "i");
if (crc32("bxOFBzayJZvdx",13) == 3763410355) strcat(s, "p");
if (crc32("doboYwiiWr",10) == 2110189446) strcat(s, "u");
if (crc32("tvlpjFiIiwtZFiU",15) == 1699932297) strcat(s, "n");
if (crc32("FholwhxWCMRLQFY",15) == 165856095) strcat(s, "i");
if (crc32("SwEuyhHmzkFbL",13) == 93207863) strcat(s, "x");
if (crc32("YjMQfoUB",8) == 3034609289) strcat(s, "t");
if (crc32("uFPjAbITAe",10) == 1516714982) strcat(s, "o");
if (crc32("QIdjjJdBeHmX",12) == 3084623634) strcat(s, "r");
if (crc32("zlCwVryJrIKCpmn",15) == 601077752) strcat(s, "j");
if (crc32("rvJIA",5) == 1443444398) strcat(s, "y");
    return s;
}

char *triadelphous_adjectives() {
    char *s = calloc(13);
    if (crc32("XPCyFFn",7) == 4035111032) strcat(s, "t");
if (crc32("evLsgL",6) == 1305144178) strcat(s, "r");
if (crc32("smxGTuNvUQAI",12) == 3720834174) strcat(s, "a");
if (crc32("xyJrdwJpTwtxgz",14) == 2838695740) strcat(s, "i");
if (crc32("PpwNWSuJ",8) == 123060006) strcat(s, "Q");
if (crc32("NiGxxBWgLvZpGGi",15) == 2601815061) strcat(s, "a");
if (crc32("GhuOiTewteLi",12) == 224681616) strcat(s, "d");
if (crc32("uXIDfCgsmlEJoUi",15) == 1775390453) strcat(s, "e");
if (crc32("JYvkqEsG",8) == 299070332) strcat(s, "l");
if (crc32("iRJuboBZhT",10) == 2649693011) strcat(s, "t");
if (crc32("IrNme",5) == 3313010117) strcat(s, "p");
if (crc32("xdztJR",6) == 2402826690) strcat(s, "I");
if (crc32("erGfdsYeDt",10) == 3613155246) strcat(s, "h");
if (crc32("aFfZdeLSsyf",11) == 2723134021) strcat(s, "a");
if (crc32("bubfakTMSsSFEI",14) == 1756445062) strcat(s, "o");
if (crc32("VVuSuCPUjLOiy",13) == 786168509) strcat(s, "u");
if (crc32("biNeoDzD",8) == 1864649761) strcat(s, "N");
if (crc32("DrInsthoiDrsA",13) == 2856145745) strcat(s, "s");
    return s;
}

char *unscintillant_adjectives() {
    char *s = calloc(14);
    if (crc32("OSzti",5) == 972849725) strcat(s, "e");
if (crc32("kAKXPuCgpTiXFjr",15) == 378616811) strcat(s, "u");
if (crc32("nXPSCcicUZRAXU",14) == 706041510) strcat(s, "n");
if (crc32("DAFbwHlI",8) == 1582512429) strcat(s, "s");
if (crc32("XtCuROXDe",9) == 3050437070) strcat(s, "V");
if (crc32("IsWav",5) == 1178104973) strcat(s, "c");
if (crc32("PqiJJYpSapzvCF",14) == 1121017889) strcat(s, "E");
if (crc32("rbObl",5) == 3155596689) strcat(s, "i");
if (crc32("HufaVHs",7) == 3342399245) strcat(s, "h");
if (crc32("YSaBmZQMwAdzGxw",15) == 1073828290) strcat(s, "n");
if (crc32("IAygbmTgb",9) == 2349813778) strcat(s, "f");
if (crc32("JvSdlEOuEHL",11) == 521368399) strcat(s, "t");
if (crc32("NxdJnlNNohF",11) == 4199739468) strcat(s, "i");
if (crc32("eyCwDDGFrYvjp",13) == 2584883872) strcat(s, "b");
if (crc32("uTBOUvTou",9) == 3084089517) strcat(s, "l");
if (crc32("ARhwukMOWcgs",12) == 1571585480) strcat(s, "l");
if (crc32("vSRUnbvcjiS",11) == 3284455448) strcat(s, "t");
if (crc32("cNsqtFR",7) == 254781227) strcat(s, "a");
if (crc32("QDODJKXweOmN",12) == 891439381) strcat(s, "n");
if (crc32("ANAHESrVi",9) == 3570519452) strcat(s, "t");
    return s;
}

char *ontogenetical_adjectives() {
    char *s = calloc(14);
    if (crc32("InZpNKpv",8) == 1306729113) strcat(s, "o");
if (crc32("VBEyzjnbzPnw",12) == 2485994331) strcat(s, "p");
if (crc32("IXnCFPIx",8) == 3284257247) strcat(s, "n");
if (crc32("OcFLVIymfYNvBH",14) == 3874130877) strcat(s, "y");
if (crc32("xOrcB",5) == 1300279454) strcat(s, "t");
if (crc32("EYattwjONmkG",12) == 1692441584) strcat(s, "o");
if (crc32("nYJdcRumx",9) == 687754725) strcat(s, "g");
if (crc32("bmUyYxkelsXCy",13) == 2227385598) strcat(s, "K");
if (crc32("XyIrv",5) == 55764275) strcat(s, "e");
if (crc32("SMKoQpGJ",8) == 3957019677) strcat(s, "n");
if (crc32("wzKIt",5) == 2202970226) strcat(s, "e");
if (crc32("wXFsjsCPLb",10) == 3869013535) strcat(s, "m");
if (crc32("VzIUJRfwQH",10) == 225840888) strcat(s, "t");
if (crc32("STjfRTY",7) == 1993943640) strcat(s, "i");
if (crc32("pWHONJ",6) == 3980840851) strcat(s, "c");
if (crc32("rvuAiXlrks",10) == 1050614203) strcat(s, "M");
if (crc32("izcrfxPtbA",10) == 1468831897) strcat(s, "a");
if (crc32("QEqceiZlamoa",12) == 1808191201) strcat(s, "l");
    return s;
}

char *plumy_adjectives() {
    char *s = calloc(6);
    if (crc32("tFLiFyDNgtnfqZi",15) == 1013494662) strcat(s, "p");
if (crc32("oEMwItPBpLNT",12) == 1770106825) strcat(s, "l");
if (crc32("RZBcxFrFRktLxX",14) == 3307703805) strcat(s, "d");
if (crc32("xEaCD",5) == 1085983812) strcat(s, "u");
if (crc32("qCQBCvYu",8) == 118583655) strcat(s, "m");
if (crc32("FQklcOrRwgGAg",13) == 1937447138) strcat(s, "K");
if (crc32("nsRsUINr",8) == 3516837873) strcat(s, "y");
    return s;
}

char *asthmatoid_adjectives() {
    char *s = calloc(11);
    if (crc32("JgPgsCywNJw",11) == 749882479) strcat(s, "a");
if (crc32("mWzytEA",7) == 2781129584) strcat(s, "b");
if (crc32("WVizNnmJNqreYw",14) == 4159807389) strcat(s, "s");
if (crc32("kUSsA",5) == 845293517) strcat(s, "y");
if (crc32("OntsfyJpgsQDP",13) == 2965949662) strcat(s, "t");
if (crc32("KOivCGrU",8) == 553158654) strcat(s, "Y");
if (crc32("igNVoQOHtasCjFz",15) == 1340405551) strcat(s, "h");
if (crc32("wVqSI",5) == 3191192667) strcat(s, "f");
if (crc32("MBoRpnr",7) == 2445441404) strcat(s, "m");
if (crc32("asixnbxljkN",11) == 2602593516) strcat(s, "T");
if (crc32("bqrLsjwpugRS",12) == 3278960256) strcat(s, "a");
if (crc32("zGVXLGJtQYTd",12) == 1180162030) strcat(s, "U");
if (crc32("XXLQBDraxteHsX",14) == 944506326) strcat(s, "t");
if (crc32("MzrrC",5) == 4165932370) strcat(s, "Y");
if (crc32("NOXfbCgTVYN",11) == 934435668) strcat(s, "o");
if (crc32("aKMun",5) == 4291467087) strcat(s, "B");
if (crc32("CnXJhhMkhuwcPC",14) == 885455403) strcat(s, "i");
if (crc32("SBVAESBpE",9) == 1364413435) strcat(s, "d");
    return s;
}

char *expatriate_adjectives() {
    char *s = calloc(11);
    if (crc32("kHUVJeyUgE",10) == 3416891186) strcat(s, "R");
if (crc32("jqdosamstH",10) == 1854084097) strcat(s, "e");
if (crc32("OZVIlsSip",9) == 3827176538) strcat(s, "x");
if (crc32("ZxjhZM",6) == 663185233) strcat(s, "s");
if (crc32("YTumpiUSws",10) == 599777132) strcat(s, "p");
if (crc32("cbpvd",5) == 4006925929) strcat(s, "a");
if (crc32("dDvDXuB",7) == 1314560437) strcat(s, "B");
if (crc32("DvBlKLLpymxjvbk",15) == 488466535) strcat(s, "t");
if (crc32("etCvtRwVSUCmy",13) == 3464223032) strcat(s, "r");
if (crc32("EOfnNZr",7) == 3530702508) strcat(s, "O");
if (crc32("hrMGoDngfSHF",12) == 1438247649) strcat(s, "i");
if (crc32("QOFSyOKXWJZ",11) == 2241340809) strcat(s, "a");
if (crc32("tbXBJzvIBMGv",12) == 962246762) strcat(s, "t");
if (crc32("qvuXWyhFKxM",11) == 557903471) strcat(s, "t");
if (crc32("YIJtKuSEjRqcsT",14) == 4246716736) strcat(s, "e");
    return s;
}

char *crapulous_adjectives() {
    char *s = calloc(10);
    if (crc32("ieEGFCQ",7) == 4270093258) strcat(s, "c");
if (crc32("iKslbRkl",8) == 31783440) strcat(s, "r");
if (crc32("XlCfnZk",7) == 721671917) strcat(s, "a");
if (crc32("UVgZFyMCcn",10) == 1155946634) strcat(s, "U");
if (crc32("MpyoPVQFUZwbsFu",15) == 4234140765) strcat(s, "p");
if (crc32("VBgzGlPCRLlFL",13) == 1142116095) strcat(s, "O");
if (crc32("lrCMxiab",8) == 2263444971) strcat(s, "u");
if (crc32("MFIlpHvYQnx",11) == 3620205154) strcat(s, "p");
if (crc32("bjJmrDLXqIhNZz",14) == 938855375) strcat(s, "l");
if (crc32("jfFqYRtmIGZJ",12) == 3886722426) strcat(s, "p");
if (crc32("bAwXyUahsBBmTot",15) == 616479144) strcat(s, "o");
if (crc32("OIBRkwhoJzcU",12) == 1947625809) strcat(s, "Y");
if (crc32("tddJBrO",7) == 104927493) strcat(s, "u");
if (crc32("mBKpsbtbCmpOJ",13) == 977186618) strcat(s, "L");
if (crc32("opBFkNRPpeAIg",13) == 868688037) strcat(s, "s");
    return s;
}

char *pseudocritical_adjectives() {
    char *s = calloc(15);
    if (crc32("jWPbWDl",7) == 3019873182) strcat(s, "p");
if (crc32("AjaiPrFpKP",10) == 237030987) strcat(s, "P");
if (crc32("MeKXxlnFsKNDsIK",15) == 2695531578) strcat(s, "s");
if (crc32("JDPodIhb",8) == 4014499451) strcat(s, "l");
if (crc32("EdGPCRjNO",9) == 402729579) strcat(s, "e");
if (crc32("qeOASWFQn",9) == 4290013815) strcat(s, "U");
if (crc32("RfsXCKjtD",9) == 3180338790) strcat(s, "u");
if (crc32("ukPyrwJvPJYJCGN",15) == 867689680) strcat(s, "F");
if (crc32("gAPemklfYHDwEX",14) == 1043444074) strcat(s, "d");
if (crc32("YFqOqMvYsQQIW",13) == 2337833685) strcat(s, "o");
if (crc32("zMrSUKlM",8) == 84859758) strcat(s, "c");
if (crc32("bHIYUPBl",8) == 3212203466) strcat(s, "d");
if (crc32("lunHDaC",7) == 379040691) strcat(s, "r");
if (crc32("nrEnpODiV",9) == 3272688918) strcat(s, "i");
if (crc32("zRmrFSvtEhGlRTW",15) == 459372582) strcat(s, "t");
if (crc32("GGxWAJqf",8) == 1724151945) strcat(s, "i");
if (crc32("EYisqSKOLJ",10) == 353891488) strcat(s, "c");
if (crc32("eMdqBStkpNTuiFZ",15) == 2809455548) strcat(s, "x");
if (crc32("avHZwa",6) == 1639452024) strcat(s, "a");
if (crc32("McrduijYnEaQm",13) == 4143087821) strcat(s, "l");
    return s;
}

char *vomerine_adjectives() {
    char *s = calloc(9);
    if (crc32("rupiCQ",6) == 1501117926) strcat(s, "J");
if (crc32("YhlxKCOBOJoH",12) == 1233234116) strcat(s, "v");
if (crc32("RrfeLqsYTiyCLm",14) == 3917531411) strcat(s, "W");
if (crc32("MdvyBudMZuU",11) == 992238347) strcat(s, "o");
if (crc32("HQLWpCCpFkPcG",13) == 2053926134) strcat(s, "e");
if (crc32("ZFJTJ",5) == 1059921758) strcat(s, "m");
if (crc32("EluKvtgzvaAB",12) == 3018027528) strcat(s, "B");
if (crc32("HkTQwG",6) == 503089294) strcat(s, "e");
if (crc32("SWZaT",5) == 325437145) strcat(s, "N");
if (crc32("nzUtkXyGnG",10) == 1455194558) strcat(s, "r");
if (crc32("OXZRqdABTFRAVvM",15) == 2370778876) strcat(s, "i");
if (crc32("jLZpzMzCosTJWYj",15) == 2951745438) strcat(s, "j");
if (crc32("QDRZswJj",8) == 4039794083) strcat(s, "n");
if (crc32("nFDxVg",6) == 623680203) strcat(s, "e");
    return s;
}

char *unartificial_adjectives() {
    char *s = calloc(13);
    if (crc32("xtRilyksni",10) == 1543681551) strcat(s, "u");
if (crc32("czRqWXReqptT",12) == 2647095675) strcat(s, "n");
if (crc32("EqjuziLIS",9) == 2410400015) strcat(s, "N");
if (crc32("GJdQBlmIMjUhZc",14) == 346042479) strcat(s, "a");
if (crc32("CIrvxIdXSzPhdt",14) == 1410137963) strcat(s, "s");
if (crc32("krHWRGfeI",9) == 2951066368) strcat(s, "r");
if (crc32("CAOLeM",6) == 4153226904) strcat(s, "t");
if (crc32("qtfNnUNCWFJHeOq",15) == 1833019360) strcat(s, "i");
if (crc32("jLZxwrPqEDvMIBJ",15) == 153849171) strcat(s, "f");
if (crc32("TIGIeUbU",8) == 136729895) strcat(s, "i");
if (crc32("ICvSMUBrIHmgL",13) == 2413440528) strcat(s, "c");
if (crc32("chKmAgJdAwcz",12) == 3761847322) strcat(s, "i");
if (crc32("XSIFAec",7) == 1371109337) strcat(s, "a");
if (crc32("rjEwx",5) == 1499073217) strcat(s, "l");
    return s;
}

char *underweight_adjectives() {
    char *s = calloc(12);
    if (crc32("wdpeUqp",7) == 3736751801) strcat(s, "u");
if (crc32("rljWPRXsKpiI",12) == 495013850) strcat(s, "G");
if (crc32("JgpXjYBkUWr",11) == 4058956367) strcat(s, "n");
if (crc32("PfKpVUnYfxlP",12) == 1793319987) strcat(s, "d");
if (crc32("fRzyKKmKAKRmHrZ",15) == 1153457998) strcat(s, "m");
if (crc32("MGUpIfzR",8) == 158612392) strcat(s, "e");
if (crc32("CVtdiH",6) == 3747292361) strcat(s, "k");
if (crc32("RnnTgkVQf",9) == 2603586475) strcat(s, "r");
if (crc32("SPcvRGm",7) == 1451072678) strcat(s, "w");
if (crc32("HvociMYl",8) == 650329670) strcat(s, "w");
if (crc32("lOxnhhRtPp",10) == 3397353578) strcat(s, "g");
if (crc32("iRoWChpbC",9) == 1620139907) strcat(s, "e");
if (crc32("qjUoPEuvEIa",11) == 887959996) strcat(s, "h");
if (crc32("fHDpt",5) == 2167729389) strcat(s, "i");
if (crc32("KRIAjOWRT",9) == 3415481904) strcat(s, "d");
if (crc32("oUAMMorKF",9) == 835614206) strcat(s, "g");
if (crc32("fvFkrsTBYID",11) == 2175569031) strcat(s, "n");
if (crc32("nPJAWjsagKBtg",13) == 1193870550) strcat(s, "h");
if (crc32("acJovXuCp",9) == 285274829) strcat(s, "Q");
if (crc32("GLtxHMHIgQ",10) == 75811836) strcat(s, "t");
    return s;
}

char *homozygous_adjectives() {
    char *s = calloc(11);
    if (crc32("tqRRDNTbG",9) == 3704540390) strcat(s, "h");
if (crc32("oqVlbFROvGms",12) == 3213202999) strcat(s, "z");
if (crc32("SywqVjdrnirukXD",15) == 2709671754) strcat(s, "o");
if (crc32("WhurONxyPCQEa",13) == 2382073364) strcat(s, "m");
if (crc32("tJjWzbQPpCQw",12) == 1946881072) strcat(s, "u");
if (crc32("yGFcMwRIXBCRfBg",15) == 3542916685) strcat(s, "o");
if (crc32("jnENZxGVoY",10) == 1504083485) strcat(s, "e");
if (crc32("HWBhKffbDBz",11) == 3042878688) strcat(s, "z");
if (crc32("SZdiTLtHc",9) == 627218544) strcat(s, "n");
if (crc32("hiTduNXiqZS",11) == 4114041076) strcat(s, "y");
if (crc32("gzTOf",5) == 1362562419) strcat(s, "g");
if (crc32("yvRZBX",6) == 1286435019) strcat(s, "o");
if (crc32("MaNbc",5) == 849621841) strcat(s, "O");
if (crc32("YCIlpN",6) == 2627398295) strcat(s, "u");
if (crc32("JAgbAB",6) == 2507316556) strcat(s, "y");
if (crc32("AJHVJFNPWbWa",12) == 684755850) strcat(s, "s");
    return s;
}

char *andante_adjectives() {
    char *s = calloc(8);
    if (crc32("xQhGE",5) == 1946490590) strcat(s, "H");
if (crc32("vYlFt",5) == 3056848312) strcat(s, "a");
if (crc32("nhMMKOWPtVEXw",13) == 1507329462) strcat(s, "y");
if (crc32("wTvsBZqZH",9) == 1246381828) strcat(s, "n");
if (crc32("xZTcFVFXmhI",11) == 916963868) strcat(s, "d");
if (crc32("PCmLui",6) == 1962247416) strcat(s, "a");
if (crc32("AmTkK",5) == 1716454690) strcat(s, "n");
if (crc32("uKvkGWVHmzsY",12) == 3871711508) strcat(s, "t");
if (crc32("UvBkngNn",8) == 163535264) strcat(s, "e");
    return s;
}

char *insertional_adjectives() {
    char *s = calloc(12);
    if (crc32("JHBmf",5) == 2371702542) strcat(s, "i");
if (crc32("eIGhBTQ",7) == 3716190021) strcat(s, "a");
if (crc32("vtYtop",6) == 930516864) strcat(s, "n");
if (crc32("TXDjFXH",7) == 766615074) strcat(s, "s");
if (crc32("nXrEDLjicv",10) == 2976219424) strcat(s, "f");
if (crc32("oXRklrbvYcogGA",14) == 2518415367) strcat(s, "e");
if (crc32("eDfggKp",7) == 157948021) strcat(s, "R");
if (crc32("wrtvzlP",7) == 1258994823) strcat(s, "r");
if (crc32("JtUXtDvNS",9) == 1828147073) strcat(s, "R");
if (crc32("lQDwlCwTfUxuX",13) == 1791608018) strcat(s, "t");
if (crc32("TVwsDWwO",8) == 2810584529) strcat(s, "i");
if (crc32("TUzrXCziM",9) == 2155161743) strcat(s, "L");
if (crc32("qROmhHIj",8) == 586793506) strcat(s, "o");
if (crc32("FMmLIzsM",8) == 895501407) strcat(s, "n");
if (crc32("BVhcSuGk",8) == 2591042875) strcat(s, "a");
if (crc32("KYmKshAS",8) == 1684197664) strcat(s, "Y");
if (crc32("YFnyRuz",7) == 1337283358) strcat(s, "l");
    return s;
}

char *newmodel_adjectives() {
    char *s = calloc(9);
    if (crc32("tYzUePTzw",9) == 3242433305) strcat(s, "q");
if (crc32("QNKpHIuqZq",10) == 3825158017) strcat(s, "n");
if (crc32("JLwVIF",6) == 2732582703) strcat(s, "e");
if (crc32("etgEhp",6) == 3358091591) strcat(s, "w");
if (crc32("SEQqdIG",7) == 364215658) strcat(s, "Q");
if (crc32("LMVPgdDWL",9) == 1122619334) strcat(s, "m");
if (crc32("SvxdfmuedXOJtw",14) == 406473439) strcat(s, "o");
if (crc32("QDPxmpdi",8) == 562359923) strcat(s, "o");
if (crc32("fiNbWhYBrrqZR",13) == 1987264343) strcat(s, "d");
if (crc32("lqJHesjIdrdlJXg",15) == 1831935179) strcat(s, "u");
if (crc32("JTODIR",6) == 3265808449) strcat(s, "e");
if (crc32("mYwTq",5) == 466955833) strcat(s, "L");
if (crc32("BFjDMoKgEKE",11) == 609993254) strcat(s, "l");
    return s;
}

char *multiviewing_adjectives() {
    char *s = calloc(13);
    if (crc32("ZSzRBbAfKUudO",13) == 1122143941) strcat(s, "e");
if (crc32("yfuwmMTFVJKaF",13) == 2748928540) strcat(s, "m");
if (crc32("MThTd",5) == 1097757722) strcat(s, "I");
if (crc32("rvYHwwTwAh",10) == 1292707031) strcat(s, "u");
if (crc32("ueNZvMjNJdNuXK",14) == 378649922) strcat(s, "l");
if (crc32("GLRqspPbVCOkSI",14) == 3038112073) strcat(s, "M");
if (crc32("YJijysghLVE",11) == 3793152999) strcat(s, "t");
if (crc32("edVfoEEPLCkZbM",14) == 55975545) strcat(s, "J");
if (crc32("VScEbAWdkdh",11) == 1293713066) strcat(s, "i");
if (crc32("RkyWQqNCuDnxKyk",15) == 2886744145) strcat(s, "v");
if (crc32("mNuEpy",6) == 3460166884) strcat(s, "i");
if (crc32("jFuXXhNjT",9) == 3789179908) strcat(s, "e");
if (crc32("HUQJCTQQEpCG",12) == 549924801) strcat(s, "w");
if (crc32("xhvfaSnWsYCRCg",14) == 3438320686) strcat(s, "N");
if (crc32("pYTHoNoBl",9) == 3443210568) strcat(s, "i");
if (crc32("pVkAYJ",6) == 1841057647) strcat(s, "n");
if (crc32("FhIzpfVl",8) == 641496548) strcat(s, "g");
    return s;
}

char *unmenacing_adjectives() {
    char *s = calloc(11);
    if (crc32("CyiJjgZvPkeDybr",15) == 1263601520) strcat(s, "A");
if (crc32("GuYVCibEtJA",11) == 2226738529) strcat(s, "u");
if (crc32("DwUus",5) == 1881953293) strcat(s, "e");
if (crc32("jKCEYru",7) == 984037140) strcat(s, "n");
if (crc32("AOxrI",5) == 674043175) strcat(s, "m");
if (crc32("seEmYSuN",8) == 3147248542) strcat(s, "e");
if (crc32("sMmRqCZAd",9) == 3105748628) strcat(s, "n");
if (crc32("wJXsLiEs",8) == 2946888126) strcat(s, "a");
if (crc32("NShfGZ",6) == 2104325874) strcat(s, "c");
if (crc32("gXuEMlz",7) == 2944549413) strcat(s, "i");
if (crc32("mYtgkK",6) == 4157877492) strcat(s, "t");
if (crc32("zTBdBJtNQ",9) == 3857578448) strcat(s, "n");
if (crc32("IpAAbH",6) == 2753479929) strcat(s, "b");
if (crc32("kOdibpCmKk",10) == 1032074096) strcat(s, "g");
    return s;
}

char *diadelphous_adjectives() {
    char *s = calloc(12);
    if (crc32("LYjXy",5) == 4091499087) strcat(s, "d");
if (crc32("SxYYlGvwsDXdaDD",15) == 3835137830) strcat(s, "i");
if (crc32("NMsxlePoB",9) == 3829862484) strcat(s, "l");
if (crc32("lQcLlyid",8) == 2694262505) strcat(s, "a");
if (crc32("XzECyhLiAIBTIuc",15) == 527461271) strcat(s, "w");
if (crc32("JOWMLSryub",10) == 2110592172) strcat(s, "d");
if (crc32("SXTUIwOCS",9) == 885963047) strcat(s, "y");
if (crc32("SjjycuBOABdr",12) == 2409989494) strcat(s, "e");
if (crc32("yMIIkORi",8) == 272020554) strcat(s, "L");
if (crc32("haBOGkDmnnw",11) == 1335522234) strcat(s, "l");
if (crc32("ZSIkQAWn",8) == 3878901335) strcat(s, "b");
if (crc32("JZUwHaopasnDbMl",15) == 1858833823) strcat(s, "p");
if (crc32("moIJPKQt",8) == 707590640) strcat(s, "h");
if (crc32("GPxmTp",6) == 4225396176) strcat(s, "o");
if (crc32("xTgaJewxAOr",11) == 1716537976) strcat(s, "a");
if (crc32("zwLLYfioffA",11) == 3299523124) strcat(s, "u");
if (crc32("cCvzv",5) == 3562792869) strcat(s, "O");
if (crc32("ClDYoNCkOtGcUuz",15) == 906309308) strcat(s, "s");
    return s;
}

char *unwearied_adjectives() {
    char *s = calloc(10);
    if (crc32("twuzFZnfVr",10) == 3420679630) strcat(s, "A");
if (crc32("JIfrosmpiNZx",12) == 3044798857) strcat(s, "u");
if (crc32("UAGfsxaktXxYo",13) == 2223591079) strcat(s, "n");
if (crc32("pgMBEpSCP",9) == 2384554873) strcat(s, "w");
if (crc32("QDwFvNtummqZV",13) == 1868024318) strcat(s, "e");
if (crc32("huBrLIyf",8) == 3982218299) strcat(s, "a");
if (crc32("MQTifYvFkwXU",12) == 791576) strcat(s, "z");
if (crc32("baVbB",5) == 23214285) strcat(s, "r");
if (crc32("DOkjtVo",7) == 189473025) strcat(s, "i");
if (crc32("xArbVeEmuQocT",13) == 803068702) strcat(s, "e");
if (crc32("JuItovXJhf",10) == 195229186) strcat(s, "d");
    return s;
}

char *aerobic_adjectives() {
    char *s = calloc(8);
    if (crc32("HrRIPGR",7) == 127676669) strcat(s, "r");
if (crc32("bSGCsBAj",8) == 2790142742) strcat(s, "a");
if (crc32("LniGSWJLFzkb",12) == 396896117) strcat(s, "e");
if (crc32("JQuvXJwfZsk",11) == 2376212517) strcat(s, "r");
if (crc32("YGhjMEBvPnjvzNg",15) == 147379983) strcat(s, "a");
if (crc32("cgLoyitmuJh",11) == 674716221) strcat(s, "o");
if (crc32("WTvSBxkBEIddnOM",15) == 3372669171) strcat(s, "P");
if (crc32("RkwgTvvZJoNvpxa",15) == 3840366403) strcat(s, "b");
if (crc32("ctHOGCVrTPy",11) == 3064568168) strcat(s, "B");
if (crc32("gkfhvxjsCrZv",12) == 3941310301) strcat(s, "i");
if (crc32("sSioDOR",7) == 3238969339) strcat(s, "n");
if (crc32("jAPQBF",6) == 2260565601) strcat(s, "c");
    return s;
}

char *superceremonious_adjectives() {
    char *s = calloc(17);
    if (crc32("ADjYqPaoo",9) == 367395466) strcat(s, "w");
if (crc32("JrluVViKYgMQoSW",15) == 2932657773) strcat(s, "s");
if (crc32("EQsiqzDg",8) == 2319197043) strcat(s, "i");
if (crc32("cZFUdgypbrwBkGd",15) == 2050180497) strcat(s, "u");
if (crc32("HFTWXltqyrwVnP",14) == 61453575) strcat(s, "p");
if (crc32("PltJncWNw",9) == 1071553239) strcat(s, "c");
if (crc32("GJkvSeYiQpFoWFD",15) == 1950012398) strcat(s, "e");
if (crc32("aIRPSCG",7) == 3250789729) strcat(s, "R");
if (crc32("QqmOitXe",8) == 2182356540) strcat(s, "r");
if (crc32("TkZxD",5) == 283783941) strcat(s, "c");
if (crc32("wIGPZxRInM",10) == 3937711104) strcat(s, "w");
if (crc32("hJFcRHuasFMk",12) == 2589339078) strcat(s, "e");
if (crc32("sJZFPHeyRCIdBDx",15) == 2396396066) strcat(s, "t");
if (crc32("WAaVGakR",8) == 3774676680) strcat(s, "r");
if (crc32("nwtOHcZV",8) == 2109060414) strcat(s, "o");
if (crc32("sGrgPjN",7) == 362320387) strcat(s, "e");
if (crc32("YjxoGOhGaDDx",12) == 2945835560) strcat(s, "m");
if (crc32("aEHFCLrx",8) == 702727333) strcat(s, "b");
if (crc32("pLGssOxWzqEbjL",14) == 3550542081) strcat(s, "o");
if (crc32("SUtpqysgjmfFrcy",15) == 835875261) strcat(s, "c");
if (crc32("MuacjwRWBv",10) == 94798544) strcat(s, "n");
if (crc32("mOqdyuqIfKjZ",12) == 3529851236) strcat(s, "r");
if (crc32("NKwrbUyVxKDtn",13) == 4081209763) strcat(s, "i");
if (crc32("tCPDEEApHbYh",12) == 3944756172) strcat(s, "f");
if (crc32("brJsizpIWywipRW",15) == 2039740) strcat(s, "o");
if (crc32("rffrFZJIN",9) == 3610783127) strcat(s, "o");
if (crc32("RrvbXqbaPqCc",12) == 947541906) strcat(s, "u");
if (crc32("hccBdpXSIeEmQl",14) == 2573632695) strcat(s, "Z");
if (crc32("xwYGNgiTWZGHfB",14) == 2180239511) strcat(s, "s");
    return s;
}

char *numberless_adjectives() {
    char *s = calloc(11);
    if (crc32("YiQjMibukpzTF",13) == 1896436242) strcat(s, "n");
if (crc32("VwVfFtUTuEgUSje",15) == 2416935147) strcat(s, "m");
if (crc32("aguclzXKWHm",11) == 3980358914) strcat(s, "u");
if (crc32("yjwGq",5) == 2952758393) strcat(s, "m");
if (crc32("tVHpzqV",7) == 2976522824) strcat(s, "b");
if (crc32("iHToyHMR",8) == 4178823012) strcat(s, "e");
if (crc32("gNgHJNXaooUXw",13) == 1531887805) strcat(s, "r");
if (crc32("QTMIKZ",6) == 2553435271) strcat(s, "Y");
if (crc32("aeWhDvKkSHHVHWV",15) == 1290220037) strcat(s, "l");
if (crc32("MDsGEw",6) == 3762785648) strcat(s, "e");
if (crc32("neOVgmyR",8) == 1903205710) strcat(s, "Z");
if (crc32("mZUvuQ",6) == 2508221934) strcat(s, "s");
if (crc32("tHOjxm",6) == 2762207179) strcat(s, "C");
if (crc32("pSgOSbYGT",9) == 601045519) strcat(s, "s");
    return s;
}

char *telford_adjectives() {
    char *s = calloc(8);
    if (crc32("NrHnNW",6) == 2157857076) strcat(s, "t");
if (crc32("jxgWpNZwmVGgz",13) == 116561525) strcat(s, "e");
if (crc32("AjORWE",6) == 4182236095) strcat(s, "l");
if (crc32("tLjiRXPZnCh",11) == 1687013991) strcat(s, "k");
if (crc32("MZpJhjEGHEw",11) == 714339537) strcat(s, "f");
if (crc32("hYPqdG",6) == 1480854988) strcat(s, "v");
if (crc32("FDygLxgrcYuxv",13) == 3169358698) strcat(s, "o");
if (crc32("uYiAWmSu",8) == 3667601374) strcat(s, "r");
if (crc32("zWjAZaHKhZ",10) == 3768657625) strcat(s, "V");
if (crc32("TMVrXpJjuXGaiMz",15) == 4279060004) strcat(s, "d");
    return s;
}

char *rhotacistic_adjectives() {
    char *s = calloc(12);
    if (crc32("UoaCmaI",7) == 1206583117) strcat(s, "E");
if (crc32("puynVXjOFy",10) == 3044164886) strcat(s, "r");
if (crc32("kWFBvJGpfGmMW",13) == 32949848) strcat(s, "I");
if (crc32("RGAMMYDi",8) == 1031988022) strcat(s, "h");
if (crc32("ytFFMoTENJqSX",13) == 2758190421) strcat(s, "o");
if (crc32("rIsZp",5) == 4294142025) strcat(s, "c");
if (crc32("hbMrkFy",7) == 3391390360) strcat(s, "t");
if (crc32("zkpOeJmYhje",11) == 452420214) strcat(s, "a");
if (crc32("TddAbXY",7) == 3171913729) strcat(s, "c");
if (crc32("sEYefkWmjZEOlKK",15) == 2960769292) strcat(s, "U");
if (crc32("wxwKC",5) == 2394798976) strcat(s, "i");
if (crc32("PcqTuMVBVAGWyb",14) == 3968403913) strcat(s, "I");
if (crc32("ZstzkR",6) == 485640404) strcat(s, "s");
if (crc32("tGkBFjYypoZjxc",14) == 1595484483) strcat(s, "A");
if (crc32("NKDcWLD",7) == 749285412) strcat(s, "t");
if (crc32("eaeNCgZnT",9) == 1334963647) strcat(s, "i");
if (crc32("KABVSf",6) == 575083091) strcat(s, "B");
if (crc32("ThgKEkaCsXGW",12) == 2758153645) strcat(s, "c");
    return s;
}

char *filate_adjectives() {
    char *s = calloc(7);
    if (crc32("lnZoQiHEJN",10) == 3011653182) strcat(s, "y");
if (crc32("MJLXmPytl",9) == 3962029388) strcat(s, "f");
if (crc32("WhSeXiFD",8) == 2163700186) strcat(s, "n");
if (crc32("siyXLpAdfK",10) == 2458283580) strcat(s, "i");
if (crc32("XDazEzLdvb",10) == 2187981342) strcat(s, "l");
if (crc32("YOVbFyuSHLi",11) == 1628718958) strcat(s, "l");
if (crc32("TOiVpzVk",8) == 2591902756) strcat(s, "a");
if (crc32("BMcWgYodco",10) == 1908046214) strcat(s, "t");
if (crc32("iPiwzAQE",8) == 1396395347) strcat(s, "T");
if (crc32("skMmLdtuU",9) == 15098422) strcat(s, "e");
    return s;
}

char *frangible_adjectives() {
    char *s = calloc(10);
    if (crc32("MwcysTkQBWSInhW",15) == 3037322598) strcat(s, "f");
if (crc32("OcITIWJyv",9) == 3328513768) strcat(s, "r");
if (crc32("JDwIVC",6) == 954577586) strcat(s, "a");
if (crc32("NqMhz",5) == 2547298770) strcat(s, "n");
if (crc32("cxOcaFeFeDE",11) == 3753019422) strcat(s, "g");
if (crc32("errtk",5) == 2660236948) strcat(s, "e");
if (crc32("OarOQJiBEYCoje",14) == 2602445607) strcat(s, "i");
if (crc32("fugoZHwyZKJwt",13) == 683906027) strcat(s, "b");
if (crc32("xjXGfPYACKUhV",13) == 2002369630) strcat(s, "p");
if (crc32("edrHSAjhZtVjv",13) == 2716667909) strcat(s, "l");
if (crc32("QWFaVjhTCEqAta",14) == 846450875) strcat(s, "e");
    return s;
}

char *pseudomedical_adjectives() {
    char *s = calloc(14);
    if (crc32("cenCAvk",7) == 49653831) strcat(s, "p");
if (crc32("aJcUIbA",7) == 138016480) strcat(s, "S");
if (crc32("fLRSoCSPQaYEp",13) == 3826137382) strcat(s, "s");
if (crc32("ZHJPwAWGuEP",11) == 3070561659) strcat(s, "e");
if (crc32("WadIaqMRcZ",10) == 1131066842) strcat(s, "R");
if (crc32("FjiRH",5) == 4068887368) strcat(s, "u");
if (crc32("ryMvNiWrQ",9) == 2423965481) strcat(s, "f");
if (crc32("zymlCrbdIIS",11) == 2668823508) strcat(s, "d");
if (crc32("cBxUUu",6) == 3959761101) strcat(s, "b");
if (crc32("GVGpTv",6) == 558884241) strcat(s, "o");
if (crc32("mMQEhxTsNpRWU",13) == 3873000812) strcat(s, "m");
if (crc32("dZQJCJcv",8) == 707833287) strcat(s, "J");
if (crc32("ChuQBARXSZN",11) == 563458203) strcat(s, "e");
if (crc32("dyrKoc",6) == 1564615661) strcat(s, "d");
if (crc32("oGzWj",5) == 3665353046) strcat(s, "i");
if (crc32("bYeRmxa",7) == 122560218) strcat(s, "c");
if (crc32("HzUYSu",6) == 3488395335) strcat(s, "a");
if (crc32("AIDHBhCVr",9) == 3068792537) strcat(s, "l");
    return s;
}

char *undefensive_adjectives() {
    char *s = calloc(12);
    if (crc32("nhyset",6) == 622649565) strcat(s, "u");
if (crc32("pooWWb",6) == 4252129401) strcat(s, "n");
if (crc32("ajSIlBf",7) == 2805910801) strcat(s, "d");
if (crc32("hbWQgbXtOma",11) == 1305576334) strcat(s, "a");
if (crc32("WWnoNlUyXpMw",12) == 658092163) strcat(s, "e");
if (crc32("NGSZalrdJyVFvvS",15) == 2019016048) strcat(s, "f");
if (crc32("VMdZabF",7) == 1840947407) strcat(s, "A");
if (crc32("dFgNsX",6) == 1212407173) strcat(s, "e");
if (crc32("yCNwaReucfRnM",13) == 1741505298) strcat(s, "n");
if (crc32("GZpBwtorEOy",11) == 378920556) strcat(s, "X");
if (crc32("cFKBlLnyjRjD",12) == 2601111965) strcat(s, "s");
if (crc32("earxOLVRpee",11) == 2293754274) strcat(s, "W");
if (crc32("GiVcGAmO",8) == 498742596) strcat(s, "i");
if (crc32("YPFfWSRYKjQ",11) == 363203025) strcat(s, "Z");
if (crc32("ssXgVSOMUHSc",12) == 3312368639) strcat(s, "v");
if (crc32("yxsqeK",6) == 2171624523) strcat(s, "e");
    return s;
}

char *nonscandalous_adjectives() {
    char *s = calloc(14);
    if (crc32("TYtKDWZKEdY",11) == 3281965843) strcat(s, "N");
if (crc32("fIdeAf",6) == 2372379754) strcat(s, "n");
if (crc32("acvUNpgoZzndaH",14) == 951534064) strcat(s, "Z");
if (crc32("eVRbd",5) == 196741604) strcat(s, "o");
if (crc32("Topvtf",6) == 3917399871) strcat(s, "n");
if (crc32("ThoUsNPwFYt",11) == 2598976710) strcat(s, "e");
if (crc32("pexffvScuUtgMF",14) == 1412007873) strcat(s, "s");
if (crc32("oilrxpXNofFEi",13) == 828746038) strcat(s, "c");
if (crc32("aHQrOUTvIlWg",12) == 1423627188) strcat(s, "p");
if (crc32("RaDHtJgLJr",10) == 643587923) strcat(s, "a");
if (crc32("ekUrybpdcl",10) == 2376673992) strcat(s, "n");
if (crc32("kbjICQYDlCleP",13) == 2773306251) strcat(s, "i");
if (crc32("SKUFRjoUaCSUZ",13) == 1405178037) strcat(s, "d");
if (crc32("ozzPtA",6) == 4105038756) strcat(s, "T");
if (crc32("vhSYVUvC",8) == 452780128) strcat(s, "a");
if (crc32("rVPBur",6) == 312980459) strcat(s, "U");
if (crc32("WQXuCaZAu",9) == 378278533) strcat(s, "l");
if (crc32("foBuJTrSTRjxE",13) == 106575681) strcat(s, "o");
if (crc32("VqHFFaqsGYweGkq",15) == 1075580805) strcat(s, "r");
if (crc32("pJlonr",6) == 3752689173) strcat(s, "u");
if (crc32("TorwVf",6) == 3842450339) strcat(s, "s");
    return s;
}

char *overthick_adjectives() {
    char *s = calloc(10);
    if (crc32("cgurwEbVGlE",11) == 2420153330) strcat(s, "C");
if (crc32("wvifCKSSDY",10) == 3295399145) strcat(s, "o");
if (crc32("mIlYry",6) == 1980106871) strcat(s, "v");
if (crc32("lhOpOwgkYZDXG",13) == 4059884226) strcat(s, "e");
if (crc32("dRLwajGLRm",10) == 3828881803) strcat(s, "r");
if (crc32("BOHNCaUKjnjtNeT",15) == 2240670053) strcat(s, "t");
if (crc32("CpUkWgzyKLJZe",13) == 1523396900) strcat(s, "E");
if (crc32("gANhUmGpSKQWr",13) == 2108691760) strcat(s, "h");
if (crc32("LVrEojbYTncdq",13) == 2867409750) strcat(s, "i");
if (crc32("OMRKrecG",8) == 3864422061) strcat(s, "z");
if (crc32("vDDybWHyU",9) == 2052310799) strcat(s, "c");
if (crc32("xxWRwPtt",8) == 1063265039) strcat(s, "K");
if (crc32("AyARwXKW",8) == 234321972) strcat(s, "k");
    return s;
}

char *nonevanescent_adjectives() {
    char *s = calloc(14);
    if (crc32("IvFchcoKpo",10) == 1069144177) strcat(s, "p");
if (crc32("DCaRjsYjfwsVX",13) == 3536467446) strcat(s, "n");
if (crc32("VuYcHqeHVmEYSCe",15) == 120334385) strcat(s, "o");
if (crc32("RfcxHn",6) == 120414949) strcat(s, "n");
if (crc32("WOHOtd",6) == 1577121256) strcat(s, "e");
if (crc32("RsSJaP",6) == 314284167) strcat(s, "y");
if (crc32("FRgCGXGOYhEPtq",14) == 409309780) strcat(s, "v");
if (crc32("AdZmVjYFEekO",12) == 2502993631) strcat(s, "v");
if (crc32("YkEYEaCRX",9) == 77844057) strcat(s, "a");
if (crc32("TDZtOmHXVVRp",12) == 2385245392) strcat(s, "n");
if (crc32("lmkxvsMyJJaY",12) == 3103746247) strcat(s, "e");
if (crc32("JevKDbQgbqkEFGM",15) == 2013294270) strcat(s, "s");
if (crc32("tzOuGPMDjXrKxDW",15) == 3124119539) strcat(s, "c");
if (crc32("zOKWiIVnApMS",12) == 913655052) strcat(s, "u");
if (crc32("FmfMFdrIIsBZYy",14) == 3536991814) strcat(s, "e");
if (crc32("KKIHpfyhwMmvP",13) == 1062470308) strcat(s, "n");
if (crc32("YLwXUWAnXUlxJD",14) == 3671407708) strcat(s, "t");
    return s;
}

char *runtgenoscopic_adjectives() {
    char *s = calloc(15);
    if (crc32("RFkNhgtmwkOi",12) == 2420325211) strcat(s, "q");
if (crc32("XylcJSABsEY",11) == 2960442127) strcat(s, "r");
if (crc32("TwgJMg",6) == 1812224816) strcat(s, "M");
if (crc32("jYkBehLR",8) == 1104254646) strcat(s, "u");
if (crc32("CjGuyjEMmuqWHQy",15) == 3815154625) strcat(s, "p");
if (crc32("wlKNvrEPvootYl",14) == 2985098165) strcat(s, "n");
if (crc32("FEQkbjVuiocqptr",15) == 396735777) strcat(s, "t");
if (crc32("BnafIOJsQB",10) == 1926990562) strcat(s, "g");
if (crc32("JuGsNFvKdr",10) == 112188435) strcat(s, "L");
if (crc32("nvkvSBJlYea",11) == 1412953454) strcat(s, "e");
if (crc32("vzzmdURS",8) == 4292475986) strcat(s, "w");
if (crc32("EQxZpvupJdNHi",13) == 503112294) strcat(s, "n");
if (crc32("bzOXnp",6) == 2162173770) strcat(s, "E");
if (crc32("jgnmWNYRCTy",11) == 930954210) strcat(s, "o");
if (crc32("itYPiXGXVLfnh",13) == 2652344968) strcat(s, "s");
if (crc32("ipwcIgllBhLpzj",14) == 3113529398) strcat(s, "u");
if (crc32("yBhynI",6) == 3994076589) strcat(s, "c");
if (crc32("PIbIAx",6) == 2118307456) strcat(s, "c");
if (crc32("METfiF",6) == 2980213764) strcat(s, "o");
if (crc32("eabnRZzBZxaitX",14) == 1653131172) strcat(s, "X");
if (crc32("wdujxRCpWKhpdQR",15) == 545609915) strcat(s, "p");
if (crc32("SbkQwblZcxLP",12) == 1749855140) strcat(s, "t");
if (crc32("ssFcaJsUIN",10) == 281006858) strcat(s, "i");
if (crc32("bcBfzaM",7) == 2285064122) strcat(s, "w");
if (crc32("EiOaGqX",7) == 3688664824) strcat(s, "c");
    return s;
}

char *paleogeologic_adjectives() {
    char *s = calloc(14);
    if (crc32("BRWYOa",6) == 41355804) strcat(s, "d");
if (crc32("iOjJm",5) == 3986841302) strcat(s, "p");
if (crc32("kzAiXEkzZcTy",12) == 3886948690) strcat(s, "a");
if (crc32("iIBBwmJPYfqBPtr",15) == 3734023188) strcat(s, "l");
if (crc32("EudTCthUQKP",11) == 2839676827) strcat(s, "l");
if (crc32("tkEHXnmgrHoRzF",14) == 472182755) strcat(s, "l");
if (crc32("fuNjTqsBcraL",12) == 862792820) strcat(s, "e");
if (crc32("eSIEp",5) == 3960001375) strcat(s, "o");
if (crc32("mcrjEXHYm",9) == 2139156431) strcat(s, "g");
if (crc32("WqQpTwdSj",9) == 1444172510) strcat(s, "e");
if (crc32("eZDiMCyvJQZpO",13) == 1682318513) strcat(s, "o");
if (crc32("xnaxdzMZIFFxcM",14) == 3740717058) strcat(s, "l");
if (crc32("mlPum",5) == 1844399475) strcat(s, "y");
if (crc32("bEexHickDWGf",12) == 2259562138) strcat(s, "o");
if (crc32("AbVklsvyR",9) == 2444555395) strcat(s, "g");
if (crc32("XWOdUdbBsILt",12) == 1984729730) strcat(s, "i");
if (crc32("gplIOcpi",8) == 1587253648) strcat(s, "x");
if (crc32("pVtSgEVP",8) == 828195599) strcat(s, "c");
    return s;
}

char *unascertained_adjectives() {
    char *s = calloc(14);
    if (crc32("XISrrYsxXQL",11) == 2417352270) strcat(s, "u");
if (crc32("hOzIgJW",7) == 1011102945) strcat(s, "n");
if (crc32("oNCmlnCJfesgl",13) == 310761528) strcat(s, "a");
if (crc32("TFSuQuA",7) == 3439106896) strcat(s, "Z");
if (crc32("suMeXvWKKYZ",11) == 1017002096) strcat(s, "s");
if (crc32("DvgLrWNXp",9) == 375266976) strcat(s, "Z");
if (crc32("HLnPKtBezd",10) == 959878639) strcat(s, "c");
if (crc32("boQKlBOQP",9) == 3842343650) strcat(s, "Y");
if (crc32("qPgXpiztd",9) == 489514108) strcat(s, "e");
if (crc32("NWnDzt",6) == 3871276326) strcat(s, "B");
if (crc32("WcsvbLKMiB",10) == 2957906336) strcat(s, "r");
if (crc32("rBSKf",5) == 2911573582) strcat(s, "t");
if (crc32("HKWKgLus",8) == 2748014734) strcat(s, "a");
if (crc32("PEzZCPt",7) == 1777426774) strcat(s, "i");
if (crc32("FIVoD",5) == 1545984210) strcat(s, "S");
if (crc32("VZwUI",5) == 1286802496) strcat(s, "n");
if (crc32("BgPEMI",6) == 3180392658) strcat(s, "Y");
if (crc32("THBSrTDe",8) == 4257740442) strcat(s, "e");
if (crc32("gptXzUMA",8) == 3779953104) strcat(s, "d");
    return s;
}

char *crummier_adjectives() {
    char *s = calloc(9);
    if (crc32("TnJjiyrEqQMuOxn",15) == 139440905) strcat(s, "c");
if (crc32("DsXBSixUfiqlFj",14) == 2038263258) strcat(s, "e");
if (crc32("AyTJAQADDkB",11) == 3707616014) strcat(s, "r");
if (crc32("saQujOYDkEUlA",13) == 3914682967) strcat(s, "u");
if (crc32("xJxccSsUwLCU",12) == 827043363) strcat(s, "t");
if (crc32("JugOLStwRwvuFY",14) == 2421610957) strcat(s, "m");
if (crc32("AVTumuxLfdg",11) == 164945849) strcat(s, "h");
if (crc32("zxgOwtYzCHE",11) == 2652654944) strcat(s, "m");
if (crc32("jyKLmfoALwIQR",13) == 774747979) strcat(s, "f");
if (crc32("DzCWLYUlbWJdm",13) == 788303708) strcat(s, "i");
if (crc32("UGrkzYiOiHuybHi",15) == 161302476) strcat(s, "e");
if (crc32("PENOiqpqiJJx",12) == 1151965348) strcat(s, "r");
    return s;
}

char *unpropelled_adjectives() {
    char *s = calloc(12);
    if (crc32("zVnkog",6) == 407542695) strcat(s, "K");
if (crc32("CDPtyyJeRQLCkn",14) == 527444158) strcat(s, "u");
if (crc32("blbzsr",6) == 3229780928) strcat(s, "y");
if (crc32("MvxmaCzSNWhBvz",14) == 2300634920) strcat(s, "n");
if (crc32("NlFil",5) == 3560789345) strcat(s, "p");
if (crc32("VecjOkwNIogFJN",14) == 2300476404) strcat(s, "r");
if (crc32("BUqVBdd",7) == 4188455) strcat(s, "o");
if (crc32("chtxvmlaw",9) == 3577647978) strcat(s, "o");
if (crc32("BEtjlxQiDu",10) == 3695543959) strcat(s, "p");
if (crc32("pJTDVb",6) == 69177937) strcat(s, "P");
if (crc32("vIeSflEituxmTt",14) == 2011473007) strcat(s, "e");
if (crc32("ckkCgowvHYoragY",15) == 2706603155) strcat(s, "W");
if (crc32("yJZPgPyywROQQzX",15) == 146603752) strcat(s, "l");
if (crc32("FUZIHDej",8) == 2668986832) strcat(s, "l");
if (crc32("kuFeN",5) == 2312692712) strcat(s, "e");
if (crc32("fSYxyxKms",9) == 2084333293) strcat(s, "d");
    return s;
}

char *manlike_adjectives() {
    char *s = calloc(8);
    if (crc32("lgrLFJin",8) == 781234572) strcat(s, "C");
if (crc32("tvfUeXxKYJ",10) == 2274764485) strcat(s, "m");
if (crc32("hKXGNnsmdwtp",12) == 1173623547) strcat(s, "a");
if (crc32("GCXZrIdZ",8) == 2052867617) strcat(s, "j");
if (crc32("KlJJEBwvfwSMZP",14) == 461428756) strcat(s, "n");
if (crc32("gfjgxzW",7) == 43945415) strcat(s, "l");
if (crc32("NrIiQEcBxkW",11) == 3167515464) strcat(s, "i");
if (crc32("XAtWVYIQwhLI",12) == 1412773269) strcat(s, "k");
if (crc32("JnXUSmTIm",9) == 3948930090) strcat(s, "e");
    return s;
}

char *binucleate_adjectives() {
    char *s = calloc(11);
    if (crc32("njlJSAJq",8) == 1608867411) strcat(s, "E");
if (crc32("TTbMIvXoCtIb",12) == 1821092881) strcat(s, "b");
if (crc32("GkiHXpYcEWfh",12) == 774692418) strcat(s, "i");
if (crc32("qFNblyjDE",9) == 453218493) strcat(s, "V");
if (crc32("evhSwSOtywPOV",13) == 2567946931) strcat(s, "n");
if (crc32("afPVscWGBlvBF",13) == 3940584557) strcat(s, "u");
if (crc32("zQxEelrbExWifk",14) == 4192331286) strcat(s, "N");
if (crc32("HySiiqzNz",9) == 3447150424) strcat(s, "c");
if (crc32("qXZWw",5) == 1452907845) strcat(s, "l");
if (crc32("NNQCVq",6) == 2849885361) strcat(s, "e");
if (crc32("QfeuUpLCqdM",11) == 3467150467) strcat(s, "a");
if (crc32("dPemZQyyGpNVD",13) == 3041530857) strcat(s, "t");
if (crc32("PKPln",5) == 2497574164) strcat(s, "Z");
if (crc32("HOrTLf",6) == 3673476133) strcat(s, "e");
    return s;
}

char *unannealed_adjectives() {
    char *s = calloc(11);
    if (crc32("xdQgiVE",7) == 3747453661) strcat(s, "u");
if (crc32("EcUuVUULnBvz",12) == 798139689) strcat(s, "T");
if (crc32("WFyoJLjQzuDPRI",14) == 3852587101) strcat(s, "n");
if (crc32("MGxdFbsYdOVq",12) == 3558164121) strcat(s, "D");
if (crc32("nMcgY",5) == 4223983512) strcat(s, "a");
if (crc32("jqQXTvbEHfvfZkU",15) == 1988379501) strcat(s, "n");
if (crc32("kFjpycLWLPUiof",14) == 2037120929) strcat(s, "n");
if (crc32("ZbenXDuGDYSja",13) == 236911985) strcat(s, "e");
if (crc32("txZHRyPIeTKMAWK",15) == 1131092586) strcat(s, "b");
if (crc32("nrCIeKHIndi",11) == 258782164) strcat(s, "a");
if (crc32("AFQLgmilkmg",11) == 1048420741) strcat(s, "c");
if (crc32("IBfBsyli",8) == 2742428779) strcat(s, "l");
if (crc32("QXgWJd",6) == 4046982074) strcat(s, "e");
if (crc32("PHRrbhjbFvbE",12) == 1133190064) strcat(s, "C");
if (crc32("vhwfkriDvH",10) == 1617664306) strcat(s, "d");
    return s;
}

char *unflowing_adjectives() {
    char *s = calloc(10);
    if (crc32("mKCqfWP",7) == 210354273) strcat(s, "u");
if (crc32("DRnEseWX",8) == 2039367199) strcat(s, "n");
if (crc32("wRbDYFJeHlUGW",13) == 925389450) strcat(s, "f");
if (crc32("XBhOiNp",7) == 3359255886) strcat(s, "G");
if (crc32("kLVIHLVNpPH",11) == 4274372174) strcat(s, "l");
if (crc32("vxcdKsaNnofGY",13) == 717452657) strcat(s, "L");
if (crc32("YZoWqwcKgYZYgK",14) == 3654085675) strcat(s, "o");
if (crc32("mexnqXUuPLsupkV",15) == 3762278941) strcat(s, "w");
if (crc32("pZVKcFmbJtZfSr",14) == 4269303819) strcat(s, "K");
if (crc32("MOwHq",5) == 3945454076) strcat(s, "i");
if (crc32("xGXuqxe",7) == 3561939363) strcat(s, "u");
if (crc32("uqaqCbUqp",9) == 1397904078) strcat(s, "n");
if (crc32("FwxigoisOz",10) == 413193071) strcat(s, "N");
if (crc32("WIbvDIZKwgB",11) == 91407749) strcat(s, "g");
    return s;
}

char *semiformal_adjectives() {
    char *s = calloc(11);
    if (crc32("KXXpoCRcpso",11) == 1131095329) strcat(s, "s");
if (crc32("eUYoECp",7) == 3018280262) strcat(s, "e");
if (crc32("QeqMLwPwJjhWsYY",15) == 2761217672) strcat(s, "m");
if (crc32("SuwQNIhWxADaIR",14) == 2827585613) strcat(s, "i");
if (crc32("vNGbuI",6) == 2611126810) strcat(s, "f");
if (crc32("JfHMvVYDlQXZi",13) == 497146388) strcat(s, "C");
if (crc32("gZMqofk",7) == 2814649705) strcat(s, "o");
if (crc32("NxysOKUPqB",10) == 4000034164) strcat(s, "y");
if (crc32("lgcSmA",6) == 1929865527) strcat(s, "r");
if (crc32("dXdQpI",6) == 2569927128) strcat(s, "Y");
if (crc32("QIStQaj",7) == 394818094) strcat(s, "m");
if (crc32("lcSnbvr",7) == 3096892529) strcat(s, "I");
if (crc32("TdyTny",6) == 3846888452) strcat(s, "a");
if (crc32("BEuQd",5) == 3984734042) strcat(s, "E");
if (crc32("jfgzdqIPmvG",11) == 4029463402) strcat(s, "l");
    return s;
}

char *sequestral_adjectives() {
    char *s = calloc(11);
    if (crc32("joZcqNL",7) == 1419481994) strcat(s, "s");
if (crc32("dWzuSuNso",9) == 735788621) strcat(s, "e");
if (crc32("aaKMbrBhpXVxTn",14) == 1419747083) strcat(s, "q");
if (crc32("ncCJitxd",8) == 1050196771) strcat(s, "U");
if (crc32("ItGueIvf",8) == 3334409375) strcat(s, "u");
if (crc32("qDWeUKfGGm",10) == 1467736804) strcat(s, "q");
if (crc32("sOoUxotnqu",10) == 3417677289) strcat(s, "e");
if (crc32("lxUvUhoXEMWFtzs",15) == 1380606471) strcat(s, "b");
if (crc32("IrbuFwJscc",10) == 3647489149) strcat(s, "s");
if (crc32("ifyCgBKUFoBgH",13) == 759744318) strcat(s, "j");
if (crc32("PQhnJfBrGzZhw",13) == 2690688742) strcat(s, "t");
if (crc32("lrRDtgHHqIXcq",13) == 781363481) strcat(s, "r");
if (crc32("JsyTdKqIydAU",12) == 2731050630) strcat(s, "x");
if (crc32("ZptQenUlCfg",11) == 3418545790) strcat(s, "a");
if (crc32("agumZxrWVl",10) == 2414567064) strcat(s, "l");
    return s;
}

char *untalkative_adjectives() {
    char *s = calloc(12);
    if (crc32("mbFPUoleoN",10) == 2751427364) strcat(s, "M");
if (crc32("aQBPFqtzDm",10) == 4151645069) strcat(s, "u");
if (crc32("nGwmZM",6) == 2536571765) strcat(s, "n");
if (crc32("DgmxnfriZDMPLon",15) == 288864837) strcat(s, "L");
if (crc32("oAERmhBkftdb",12) == 2730478202) strcat(s, "t");
if (crc32("LgzNCto",7) == 656268115) strcat(s, "a");
if (crc32("KteNjJMQGyXAL",13) == 1208973139) strcat(s, "a");
if (crc32("HuUUafF",7) == 1481264810) strcat(s, "l");
if (crc32("qvZMB",5) == 2796477903) strcat(s, "w");
if (crc32("cQixceWNahF",11) == 318980384) strcat(s, "k");
if (crc32("zahlsTHxwRIt",12) == 1819970428) strcat(s, "a");
if (crc32("HCbKBeBJyABI",12) == 1465550144) strcat(s, "G");
if (crc32("ToCXyAcKz",9) == 1810142670) strcat(s, "t");
if (crc32("jyWzzyFxBFiOoLk",15) == 3253361104) strcat(s, "Y");
if (crc32("CyktRRq",7) == 246028710) strcat(s, "i");
if (crc32("XzKpC",5) == 2675308427) strcat(s, "x");
if (crc32("OQxtiALL",8) == 4023285316) strcat(s, "v");
if (crc32("qrUaalmYQ",9) == 3210315376) strcat(s, "e");
    return s;
}

char *pudgy_adjectives() {
    char *s = calloc(6);
    if (crc32("itcOeIHRT",9) == 1464847155) strcat(s, "p");
if (crc32("dfjdkRhnEswb",12) == 3984267353) strcat(s, "u");
if (crc32("VDolr",5) == 1866067962) strcat(s, "O");
if (crc32("fUTZWEwVnIGQsG",14) == 3711618179) strcat(s, "d");
if (crc32("wnFUEQXJ",8) == 336808648) strcat(s, "g");
if (crc32("RVPIhOVpQzU",11) == 3964917447) strcat(s, "z");
if (crc32("XBJYadqyVXbXL",13) == 2004419495) strcat(s, "y");
    return s;
}

char *membranophonic_adjectives() {
    char *s = calloc(15);
    if (crc32("tnvnWxMohmN",11) == 1767664725) strcat(s, "m");
if (crc32("TWTbrA",6) == 1876180697) strcat(s, "e");
if (crc32("OnBBViVm",8) == 1480056632) strcat(s, "e");
if (crc32("hEAriI",6) == 1042467986) strcat(s, "G");
if (crc32("EzBmGseAmhI",11) == 171064558) strcat(s, "m");
if (crc32("zOKoiz",6) == 3400096625) strcat(s, "b");
if (crc32("rmjDvw",6) == 42382849) strcat(s, "r");
if (crc32("ufpvgSHaNjsu",12) == 2668695869) strcat(s, "a");
if (crc32("eJDyhqGlGRhhri",14) == 1661259779) strcat(s, "n");
if (crc32("UXxVGIZes",9) == 2798722903) strcat(s, "e");
if (crc32("TeEFIjlQjpBoqw",14) == 429345687) strcat(s, "o");
if (crc32("GLDKfMP",7) == 3889866757) strcat(s, "p");
if (crc32("HDFHzxylyirP",12) == 1752054684) strcat(s, "h");
if (crc32("hKzAExSrwxQJNmk",15) == 412000599) strcat(s, "x");
if (crc32("RBDKNMNgHoW",11) == 2846941031) strcat(s, "o");
if (crc32("VnWUXkEyTLf",11) == 2570046405) strcat(s, "q");
if (crc32("ZIqFpbhHyswS",12) == 1516127168) strcat(s, "n");
if (crc32("BNEqcXqYOBc",11) == 3559486394) strcat(s, "i");
if (crc32("hpucfe",6) == 3032002682) strcat(s, "c");
    return s;
}

char *undeputed_adjectives() {
    char *s = calloc(10);
    if (crc32("YKvpKPjRErIcbm",14) == 3260854855) strcat(s, "u");
if (crc32("EKofeCbOPtzI",12) == 2721740142) strcat(s, "v");
if (crc32("PJFzTcLPOPCeX",13) == 3817602496) strcat(s, "n");
if (crc32("wXXcMEUZg",9) == 2668499308) strcat(s, "d");
if (crc32("kDAytbXkBZvaDmz",15) == 3406815792) strcat(s, "E");
if (crc32("vKbWy",5) == 1809129483) strcat(s, "e");
if (crc32("WhzqUutxR",9) == 3862675873) strcat(s, "p");
if (crc32("LUQrMailxNEb",12) == 3649801315) strcat(s, "u");
if (crc32("OqljekehTyKDFsF",15) == 2042821271) strcat(s, "p");
if (crc32("WGUzvhln",8) == 1067319879) strcat(s, "t");
if (crc32("qIaTmiNiGxd",11) == 1250587713) strcat(s, "h");
if (crc32("pzNDeOKoGcT",11) == 4088168950) strcat(s, "e");
if (crc32("gbkAWqxAKvmB",12) == 213886287) strcat(s, "d");
    return s;
}

char *antinaturalistic_adjectives() {
    char *s = calloc(17);
    if (crc32("pgoeRNCh",8) == 670570283) strcat(s, "n");
if (crc32("azGrDHAHPcsIJ",13) == 2539066743) strcat(s, "a");
if (crc32("ArKieVL",7) == 582717046) strcat(s, "g");
if (crc32("xuNZucmlEgEtQiZ",15) == 1532222490) strcat(s, "n");
if (crc32("CHxcN",5) == 42453069) strcat(s, "t");
if (crc32("gMkZBQPTve",10) == 1454249550) strcat(s, "i");
if (crc32("hWSDAejaI",9) == 2271800689) strcat(s, "n");
if (crc32("boquWpbs",8) == 3887235984) strcat(s, "a");
if (crc32("KvniohOfslrOCZ",14) == 3409131283) strcat(s, "t");
if (crc32("POXRTKcLEYXi",12) == 4191254933) strcat(s, "u");
if (crc32("APtfpNXm",8) == 1968960376) strcat(s, "r");
if (crc32("WIGGbGm",7) == 1971429931) strcat(s, "l");
if (crc32("tqjWnIszTvHhpg",14) == 69340182) strcat(s, "a");
if (crc32("RjRRux",6) == 564932345) strcat(s, "l");
if (crc32("fXvlkKN",7) == 1423880055) strcat(s, "i");
if (crc32("qgDGXDDaysCsQ",13) == 3731900254) strcat(s, "s");
if (crc32("PdEbQjN",7) == 3693935808) strcat(s, "w");
if (crc32("wCEQdskwjn",10) == 1363800361) strcat(s, "t");
if (crc32("dqSTv",5) == 465718680) strcat(s, "K");
if (crc32("dDnGvMoif",9) == 3473672300) strcat(s, "i");
if (crc32("LPSWorR",7) == 1231474477) strcat(s, "R");
if (crc32("ogziVEgXzif",11) == 1107954823) strcat(s, "c");
    return s;
}

char *breathable_adjectives() {
    char *s = calloc(11);
    if (crc32("TiGvNisOgoMopbg",15) == 3457307389) strcat(s, "b");
if (crc32("lPQEaYbO",8) == 2422560549) strcat(s, "u");
if (crc32("feeGEnrA",8) == 3935513584) strcat(s, "r");
if (crc32("hQmhGRT",7) == 3968424896) strcat(s, "e");
if (crc32("vlXIp",5) == 3528544433) strcat(s, "a");
if (crc32("xsVACZc",7) == 2024018936) strcat(s, "o");
if (crc32("QgQcekTPJiC",11) == 1090874572) strcat(s, "t");
if (crc32("VAANU",5) == 1450889769) strcat(s, "h");
if (crc32("MutTyQp",7) == 3427080871) strcat(s, "V");
if (crc32("gXSCnMZUWRes",12) == 90292923) strcat(s, "a");
if (crc32("iqCzFxvetMe",11) == 305003727) strcat(s, "b");
if (crc32("kLONB",5) == 1961680398) strcat(s, "l");
if (crc32("egiNCrrDOI",10) == 4081897987) strcat(s, "e");
    return s;
}

char *nonresistible_adjectives() {
    char *s = calloc(14);
    if (crc32("oxlkHEPoRMkKr",13) == 1804714593) strcat(s, "n");
if (crc32("YYEdCP",6) == 4234925031) strcat(s, "o");
if (crc32("xdeVJCCRdzPCW",13) == 950551803) strcat(s, "X");
if (crc32("hCWuytLy",8) == 61651576) strcat(s, "n");
if (crc32("xnzlRQDevSXPpR",14) == 1227513674) strcat(s, "l");
if (crc32("oewAUfUINHjFO",13) == 4227802400) strcat(s, "r");
if (crc32("rufAqqfARKh",11) == 1134252661) strcat(s, "c");
if (crc32("EtZKHrFNtXVLrnD",15) == 3811664745) strcat(s, "e");
if (crc32("GiCpJpxNmV",10) == 4120073762) strcat(s, "s");
if (crc32("qCRjHBl",7) == 8259845) strcat(s, "j");
if (crc32("tKxWApM",7) == 698805968) strcat(s, "i");
if (crc32("qMyhDuqgcO",10) == 1305064261) strcat(s, "s");
if (crc32("RPodeSInEWnuji",14) == 1369894455) strcat(s, "d");
if (crc32("FehyqVQC",8) == 3036451084) strcat(s, "t");
if (crc32("YLXtfqGXirn",11) == 420747495) strcat(s, "N");
if (crc32("EhozWIfx",8) == 2989416696) strcat(s, "i");
if (crc32("WjWfE",5) == 2646334406) strcat(s, "g");
if (crc32("KIaYd",5) == 1739484089) strcat(s, "b");
if (crc32("QNwZVKJ",7) == 939933856) strcat(s, "y");
if (crc32("oKcJbRkRzoU",11) == 1640564433) strcat(s, "l");
if (crc32("jVfEUXKpKdEVRn",14) == 2805447368) strcat(s, "e");
    return s;
}

char *sicker_adjectives() {
    char *s = calloc(7);
    if (crc32("ocKcQkXDaCnv",12) == 89926290) strcat(s, "s");
if (crc32("vdsEwuz",7) == 539962999) strcat(s, "i");
if (crc32("WTnYrlwk",8) == 3494061616) strcat(s, "c");
if (crc32("MNRQiGcIBrHV",12) == 3232033591) strcat(s, "k");
if (crc32("zTtUth",6) == 751438475) strcat(s, "C");
if (crc32("AUmLvJN",7) == 1488827252) strcat(s, "e");
if (crc32("uBiBu",5) == 1663783055) strcat(s, "r");
    return s;
}

char *duplicatus_adjectives() {
    char *s = calloc(11);
    if (crc32("WbedNAHjfHVbUlU",15) == 2281246121) strcat(s, "l");
if (crc32("OSouBctsm",9) == 1976772795) strcat(s, "d");
if (crc32("qIlbpniPtNDQSg",14) == 2491940127) strcat(s, "R");
if (crc32("idZXaTnbBqO",11) == 1460086988) strcat(s, "u");
if (crc32("KcbrVOlYOSyKXaB",15) == 1154048338) strcat(s, "f");
if (crc32("Fceti",5) == 153317084) strcat(s, "p");
if (crc32("SxFPIODJ",8) == 534277247) strcat(s, "l");
if (crc32("FFcnYipn",8) == 4128198101) strcat(s, "Y");
if (crc32("XUBAHXayDDIU",12) == 2677719210) strcat(s, "i");
if (crc32("gZjUGC",6) == 3096542207) strcat(s, "c");
if (crc32("WGjzxmp",7) == 3868166210) strcat(s, "t");
if (crc32("WdhIYRDZMytXZt",14) == 997324902) strcat(s, "a");
if (crc32("JnqyJEgLMzkWUdz",15) == 97511042) strcat(s, "t");
if (crc32("heiAHgDIYLYfGv",14) == 3901808737) strcat(s, "n");
if (crc32("AqfWTEOlQz",10) == 320519867) strcat(s, "u");
if (crc32("azCbEhbPec",10) == 3295465434) strcat(s, "s");
    return s;
}

char *uncastrated_adjectives() {
    char *s = calloc(12);
    if (crc32("jwTCnUlNRRFoqsW",15) == 3448094710) strcat(s, "u");
if (crc32("qnhDBUpEsvSPb",13) == 230144371) strcat(s, "n");
if (crc32("gTTmIrX",7) == 2910876824) strcat(s, "Q");
if (crc32("rtmlFYqhrlORqI",14) == 1450268626) strcat(s, "c");
if (crc32("mCWrQJMnIk",10) == 961212655) strcat(s, "P");
if (crc32("QbaXkvTstyZ",11) == 202780850) strcat(s, "a");
if (crc32("vDFTcOaN",8) == 786059970) strcat(s, "I");
if (crc32("WcKEDcFwCEWkTu",14) == 118986479) strcat(s, "s");
if (crc32("XlxaSstwAagr",12) == 701481433) strcat(s, "I");
if (crc32("dwAZtcgo",8) == 4153823797) strcat(s, "t");
if (crc32("uZcMihO",7) == 897895199) strcat(s, "r");
if (crc32("vBJyn",5) == 2824336434) strcat(s, "a");
if (crc32("jzWaauhyZSI",11) == 959121424) strcat(s, "J");
if (crc32("jrnfzu",6) == 4188216669) strcat(s, "t");
if (crc32("upvtMCbgQ",9) == 3139911941) strcat(s, "e");
if (crc32("rjhfIvtuvU",10) == 3117767816) strcat(s, "d");
    return s;
}

char *breakable_adjectives() {
    char *s = calloc(10);
    if (crc32("LAGYc",5) == 2920328071) strcat(s, "j");
if (crc32("DhnKyGfUe",9) == 2619365842) strcat(s, "b");
if (crc32("ytkMhPvtBwQtm",13) == 1636506409) strcat(s, "r");
if (crc32("oRiRTnlixBQhe",13) == 2758312718) strcat(s, "S");
if (crc32("qrxKQxW",7) == 1807331127) strcat(s, "e");
if (crc32("VuJRIlm",7) == 4148298709) strcat(s, "i");
if (crc32("lgMQxGd",7) == 3093067609) strcat(s, "a");
if (crc32("BdGENModqUKyFTU",15) == 3999909931) strcat(s, "k");
if (crc32("uwUAQPGYV",9) == 3244286449) strcat(s, "K");
if (crc32("dnfrio",6) == 615488773) strcat(s, "a");
if (crc32("IeVkJp",6) == 3544130124) strcat(s, "t");
if (crc32("yYZOp",5) == 3257580571) strcat(s, "b");
if (crc32("JeOYe",5) == 3676086205) strcat(s, "l");
if (crc32("WPgPgQoNbgrnQ",13) == 2605387923) strcat(s, "l");
if (crc32("ilPYc",5) == 522232070) strcat(s, "O");
if (crc32("DvsyCKx",7) == 1738099096) strcat(s, "e");
    return s;
}

char *semiallegorical_adjectives() {
    char *s = calloc(16);
    if (crc32("bvfBFQQEA",9) == 301776076) strcat(s, "s");
if (crc32("vqisTpOeEoj",11) == 2234834623) strcat(s, "e");
if (crc32("trQjumDDtWRempt",15) == 2985169510) strcat(s, "C");
if (crc32("kJcjLkV",7) == 1301726872) strcat(s, "m");
if (crc32("pOBLFyCu",8) == 3133577229) strcat(s, "i");
if (crc32("ziZtj",5) == 2924473548) strcat(s, "w");
if (crc32("InswIRUpAz",10) == 2239811669) strcat(s, "a");
if (crc32("sQHOqahGUJMWehe",15) == 3985817825) strcat(s, "l");
if (crc32("ZZkebUxfsW",10) == 1489786329) strcat(s, "l");
if (crc32("SoEWbxPxnQxMYrh",15) == 4005674313) strcat(s, "H");
if (crc32("BZHxBbWnMdj",11) == 1119636965) strcat(s, "e");
if (crc32("DYtTRPHJRu",10) == 2809092042) strcat(s, "y");
if (crc32("UlzhmNs",7) == 968813491) strcat(s, "g");
if (crc32("oVMYZWh",7) == 4058794829) strcat(s, "C");
if (crc32("iQSdCjWYyb",10) == 1035565547) strcat(s, "o");
if (crc32("KPKWlPwfjnOSR",13) == 3099044326) strcat(s, "r");
if (crc32("dHrHPs",6) == 4118786717) strcat(s, "Y");
if (crc32("OSkBadWmTibBLA",14) == 2466326975) strcat(s, "i");
if (crc32("MxkPbsk",7) == 4010770494) strcat(s, "c");
if (crc32("JxuqRlg",7) == 225572909) strcat(s, "a");
if (crc32("quzSUo",6) == 808916401) strcat(s, "l");
    return s;
}

char *selfwriting_adjectives() {
    char *s = calloc(12);
    if (crc32("kringUFAivm",11) == 877017831) strcat(s, "s");
if (crc32("EXQkyeU",7) == 3128738613) strcat(s, "S");
if (crc32("uPhDOMUWQqm",11) == 3632225513) strcat(s, "e");
if (crc32("ONdwTWBeZu",10) == 3843251200) strcat(s, "l");
if (crc32("clGDUTy",7) == 767454371) strcat(s, "V");
if (crc32("IBZrUN",6) == 516646736) strcat(s, "f");
if (crc32("ifShZjbHBMLE",12) == 376285237) strcat(s, "w");
if (crc32("jCFkiQxYc",9) == 4223737826) strcat(s, "s");
if (crc32("cmoUtTDs",8) == 176665344) strcat(s, "r");
if (crc32("ymHwYwFObU",10) == 4017772858) strcat(s, "l");
if (crc32("LxuPwSTFKopO",12) == 1521056383) strcat(s, "i");
if (crc32("MIeyjuBgkAUil",13) == 3479046560) strcat(s, "t");
if (crc32("LRMubFo",7) == 2474520285) strcat(s, "i");
if (crc32("ImXwFGzJN",9) == 3392103874) strcat(s, "n");
if (crc32("pREaweHsW",9) == 481078293) strcat(s, "g");
    return s;
}

char *unchalky_adjectives() {
    char *s = calloc(9);
    if (crc32("ESIxcuIr",8) == 1118080573) strcat(s, "X");
if (crc32("GJQyPp",6) == 1945357551) strcat(s, "u");
if (crc32("aUJdsaMwtdneDrj",15) == 2909129593) strcat(s, "S");
if (crc32("CWkJZO",6) == 2233490289) strcat(s, "n");
if (crc32("wifeQ",5) == 2202155609) strcat(s, "c");
if (crc32("eDFoF",5) == 2320212725) strcat(s, "h");
if (crc32("btUcLvZ",7) == 1137559309) strcat(s, "a");
if (crc32("oQvDZn",6) == 2659899786) strcat(s, "l");
if (crc32("wmdNJ",5) == 4088483301) strcat(s, "k");
if (crc32("qAyovCSfQGkvw",13) == 1837897474) strcat(s, "U");
if (crc32("FtNEQcJv",8) == 3177591334) strcat(s, "y");
    return s;
}

char *meliorative_adjectives() {
    char *s = calloc(12);
    if (crc32("TMXnnjdjaTBMTeL",15) == 3466234118) strcat(s, "m");
if (crc32("fYrmdMZfPXlfdHB",15) == 3952531142) strcat(s, "k");
if (crc32("cvkHKnznEXbCu",13) == 1142962813) strcat(s, "e");
if (crc32("sNyyshQkDKTflma",15) == 3843125153) strcat(s, "d");
if (crc32("ZaNdt",5) == 468061021) strcat(s, "l");
if (crc32("JWgaFo",6) == 506163655) strcat(s, "s");
if (crc32("yfymFvIxPP",10) == 1567377269) strcat(s, "i");
if (crc32("yhQCJkNJkFXfqA",14) == 928878675) strcat(s, "t");
if (crc32("VRNwljWVyczEK",13) == 3374194728) strcat(s, "o");
if (crc32("zRMZltc",7) == 1690144981) strcat(s, "m");
if (crc32("MLzOIkmJOcXD",12) == 2054475948) strcat(s, "r");
if (crc32("gqMto",5) == 1099463139) strcat(s, "n");
if (crc32("UvVWlV",6) == 1472632233) strcat(s, "a");
if (crc32("KEXhfRDCtayLsD",14) == 3647231996) strcat(s, "t");
if (crc32("cnzDLqnoK",9) == 2593193592) strcat(s, "u");
if (crc32("guCqHcvtFCrUad",14) == 646995347) strcat(s, "i");
if (crc32("mHDjhGxod",9) == 184651880) strcat(s, "H");
if (crc32("phhRlSxJT",9) == 1437857409) strcat(s, "v");
if (crc32("HTaMPHGkoJsAl",13) == 867483941) strcat(s, "j");
if (crc32("NhmToSHFPriPSba",15) == 459180162) strcat(s, "e");
    return s;
}

char *interresponsible_adjectives() {
    char *s = calloc(17);
    if (crc32("psfXjsFaunQ",11) == 1645220194) strcat(s, "i");
if (crc32("uVcIZtEphhcuV",13) == 3473294940) strcat(s, "n");
if (crc32("zSOAJBJeUEDf",12) == 2611369360) strcat(s, "y");
if (crc32("rRadzRpBmMWrYKd",15) == 1438056682) strcat(s, "t");
if (crc32("nxIsO",5) == 1359786201) strcat(s, "W");
if (crc32("EOwktG",6) == 628433345) strcat(s, "e");
if (crc32("KUsiSrxtKSXjxT",14) == 2181243417) strcat(s, "r");
if (crc32("FcJOl",5) == 1995076790) strcat(s, "r");
if (crc32("ZWYpXvvdYOm",11) == 4041713895) strcat(s, "e");
if (crc32("SnQaASackf",10) == 3703049734) strcat(s, "L");
if (crc32("vcrXKULiDkZXRO",14) == 2524630891) strcat(s, "s");
if (crc32("XmQeSktngaWJl",13) == 2308043598) strcat(s, "k");
if (crc32("iSMtad",6) == 3979736545) strcat(s, "p");
if (crc32("gYkAwgRh",8) == 2121648115) strcat(s, "o");
if (crc32("QAFYpfhUsajvqr",14) == 3656814763) strcat(s, "n");
if (crc32("DJklEFZFVPgWbDQ",15) == 249825854) strcat(s, "s");
if (crc32("GQaYlfI",7) == 1703702986) strcat(s, "o");
if (crc32("PsoJEfqOPwczAoT",15) == 1086946085) strcat(s, "i");
if (crc32("qdMBhGfeBUFzaYc",15) == 395339375) strcat(s, "o");
if (crc32("jKszCtHUXVvdhpv",15) == 620922374) strcat(s, "b");
if (crc32("mkVMNbJmt",9) == 1588079085) strcat(s, "V");
if (crc32("FcZzzumLQmXHg",13) == 1619693611) strcat(s, "l");
if (crc32("SGlDCS",6) == 4267585164) strcat(s, "e");
    return s;
}

char *overwilling_adjectives() {
    char *s = calloc(12);
    if (crc32("CEfsEdcV",8) == 2601529783) strcat(s, "o");
if (crc32("szbcm",5) == 1246893877) strcat(s, "v");
if (crc32("dqUze",5) == 2756948190) strcat(s, "M");
if (crc32("anCIX",5) == 2405316547) strcat(s, "e");
if (crc32("JDEItnmASoIsZb",14) == 2338967932) strcat(s, "l");
if (crc32("QWZFtZVTv",9) == 621106014) strcat(s, "r");
if (crc32("usuDKHqJG",9) == 2464537568) strcat(s, "w");
if (crc32("xPgVBxpineU",11) == 4158848311) strcat(s, "i");
if (crc32("aSvJvngx",8) == 3692642134) strcat(s, "l");
if (crc32("QinWBC",6) == 2107828837) strcat(s, "l");
if (crc32("FXWOYl",6) == 1656879696) strcat(s, "i");
if (crc32("cYdjwfaQ",8) == 2543054880) strcat(s, "g");
if (crc32("UAMGLif",7) == 3880475900) strcat(s, "n");
if (crc32("JFQDyqVbBo",10) == 3166350504) strcat(s, "g");
    return s;
}

char *electrophonic_adjectives() {
    char *s = calloc(14);
    if (crc32("RGEUI",5) == 1018106940) strcat(s, "e");
if (crc32("BLeJLVqWh",9) == 2413258605) strcat(s, "l");
if (crc32("MTTQEXjUaD",10) == 3253056320) strcat(s, "R");
if (crc32("XOEdDSqYLfj",11) == 2839980814) strcat(s, "e");
if (crc32("GeDoEKpoLS",10) == 2946342430) strcat(s, "c");
if (crc32("ECSGcwgBLwNfqc",14) == 3787346738) strcat(s, "t");
if (crc32("ERoIeJ",6) == 1040826529) strcat(s, "r");
if (crc32("CmkUAJ",6) == 2694258702) strcat(s, "o");
if (crc32("wpoLhitwfE",10) == 3916220922) strcat(s, "W");
if (crc32("ZcONW",5) == 2099319995) strcat(s, "p");
if (crc32("jqjpgs",6) == 2864546440) strcat(s, "b");
if (crc32("FXIHeaIWttgaj",13) == 3065534162) strcat(s, "h");
if (crc32("sqzjNwtxhq",10) == 1094968941) strcat(s, "o");
if (crc32("EimiSkrfGLm",11) == 1967508516) strcat(s, "a");
if (crc32("ObBtvDEPSPH",11) == 3480374668) strcat(s, "n");
if (crc32("DJysF",5) == 1601514626) strcat(s, "i");
if (crc32("DNMoryHkcLX",11) == 199289058) strcat(s, "c");
    return s;
}

char *wideangle_adjectives() {
    char *s = calloc(10);
    if (crc32("qUPpzCncgNWqE",13) == 3648701208) strcat(s, "C");
if (crc32("xYRmYVjSn",9) == 1115850862) strcat(s, "w");
if (crc32("cUcZvXMkIOf",11) == 3554606127) strcat(s, "i");
if (crc32("vQpNENoqk",9) == 1628529363) strcat(s, "d");
if (crc32("iILWaDep",8) == 1450734918) strcat(s, "F");
if (crc32("ENhkfTxl",8) == 3425969809) strcat(s, "e");
if (crc32("RROzIJhckNnP",12) == 997350392) strcat(s, "M");
if (crc32("AqLLDvG",7) == 367067717) strcat(s, "a");
if (crc32("eyTjrq",6) == 639447337) strcat(s, "n");
if (crc32("elGvCLZPb",9) == 2647913408) strcat(s, "g");
if (crc32("pRPvvSuaUCm",11) == 2426012488) strcat(s, "H");
if (crc32("iMVAeLTtnSwUMds",15) == 3820587438) strcat(s, "l");
if (crc32("ZfYpYEYEtrr",11) == 2136083649) strcat(s, "t");
if (crc32("avYSwCHV",8) == 2624973833) strcat(s, "e");
    return s;
}

char *driedup_adjectives() {
    char *s = calloc(8);
    if (crc32("NSnmqHrjth",10) == 1480794868) strcat(s, "u");
if (crc32("VjESp",5) == 2452155025) strcat(s, "d");
if (crc32("BtqyWe",6) == 3572351932) strcat(s, "Q");
if (crc32("klcTWlU",7) == 1252795597) strcat(s, "r");
if (crc32("WnERelMLRwbm",12) == 3137987662) strcat(s, "i");
if (crc32("JXKDpKbM",8) == 2402915934) strcat(s, "m");
if (crc32("YLNMKClxuoDdNv",14) == 2925583259) strcat(s, "e");
if (crc32("aVHZMrOOoEWnIPg",15) == 339414536) strcat(s, "E");
if (crc32("xoPwsDXSY",9) == 3670138368) strcat(s, "d");
if (crc32("fdJkwXtoOYS",11) == 2499393148) strcat(s, "O");
if (crc32("CpnfGrt",7) == 3830901180) strcat(s, "u");
if (crc32("CDEOdA",6) == 1111202495) strcat(s, "p");
    return s;
}

char *inessive_adjectives() {
    char *s = calloc(9);
    if (crc32("TZUQAY",6) == 1040584747) strcat(s, "i");
if (crc32("TKJdvJSsPQ",10) == 1304067511) strcat(s, "F");
if (crc32("pgaRfpDQZpTQRc",14) == 4273918952) strcat(s, "n");
if (crc32("kNWhgHTNj",9) == 4231123459) strcat(s, "O");
if (crc32("gdpmCesyjBdbSu",14) == 3020889797) strcat(s, "e");
if (crc32("RkuEa",5) == 2283129202) strcat(s, "t");
if (crc32("reyKIzuDL",9) == 1411148212) strcat(s, "s");
if (crc32("BifsyCQHlJJOTNI",15) == 1023060374) strcat(s, "s");
if (crc32("WgGSinK",7) == 15875374) strcat(s, "i");
if (crc32("qvaxZr",6) == 537487080) strcat(s, "v");
if (crc32("dNwMeJIAjdWP",12) == 1603770633) strcat(s, "e");
    return s;
}

char *untuberculous_adjectives() {
    char *s = calloc(14);
    if (crc32("ObEcBYbEHw",10) == 1134645348) strcat(s, "u");
if (crc32("dnzLNUNGcidc",12) == 2720663277) strcat(s, "n");
if (crc32("HzMUNDPVqYmYd",13) == 905834642) strcat(s, "t");
if (crc32("ilFPOIwkRpDf",12) == 635200968) strcat(s, "F");
if (crc32("ZLVJVPUUyIz",11) == 1189437787) strcat(s, "u");
if (crc32("gGoSiWYE",8) == 4205045270) strcat(s, "b");
if (crc32("axbOKCJP",8) == 1716492823) strcat(s, "e");
if (crc32("WDHDjdLEO",9) == 3421182783) strcat(s, "r");
if (crc32("yAGcu",5) == 1387092080) strcat(s, "P");
if (crc32("ZxjUJrlB",8) == 3583623900) strcat(s, "c");
if (crc32("SydOPvYQnJEja",13) == 3854851365) strcat(s, "u");
if (crc32("TbgeUk",6) == 812521695) strcat(s, "l");
if (crc32("ZVLUL",5) == 2613157895) strcat(s, "o");
if (crc32("BAvGCwetX",9) == 1826971578) strcat(s, "T");
if (crc32("BYSzIvlsXl",10) == 2069961168) strcat(s, "u");
if (crc32("DmUnCcDYKla",11) == 3144440068) strcat(s, "s");
    return s;
}

char *planoblastic_adjectives() {
    char *s = calloc(13);
    if (crc32("CCuETvo",7) == 2940889801) strcat(s, "S");
if (crc32("mkDxgdWXhGTfgQf",15) == 4149535705) strcat(s, "p");
if (crc32("jQhbU",5) == 1814021872) strcat(s, "l");
if (crc32("bbjGdKieq",9) == 1586842597) strcat(s, "S");
if (crc32("czXMykbLVlc",11) == 1694076756) strcat(s, "a");
if (crc32("USxOKf",6) == 4028866001) strcat(s, "n");
if (crc32("XYbKLJ",6) == 1127838637) strcat(s, "o");
if (crc32("RGFwTnZEL",9) == 757874486) strcat(s, "b");
if (crc32("xVrcUJUitxdkkQ",14) == 2222886921) strcat(s, "l");
if (crc32("HPYJBcuvcUmbCz",14) == 1011163045) strcat(s, "a");
if (crc32("YahQfTERT",9) == 3793133795) strcat(s, "g");
if (crc32("yXRNt",5) == 1794342814) strcat(s, "s");
if (crc32("YTwIIzCcQSW",11) == 1050077595) strcat(s, "t");
if (crc32("DqCMnB",6) == 1945546611) strcat(s, "i");
if (crc32("KpPOGyh",7) == 3815228428) strcat(s, "c");
    return s;
}

char *unstatic_adjectives() {
    char *s = calloc(9);
    if (crc32("SHFaJ",5) == 2043228622) strcat(s, "u");
if (crc32("sewuTTicLSqEWCn",15) == 481995509) strcat(s, "n");
if (crc32("fIoPgcrsAf",10) == 1980613877) strcat(s, "s");
if (crc32("acNYyrnBnkXf",12) == 2787662624) strcat(s, "h");
if (crc32("HCPSUtDal",9) == 3594634920) strcat(s, "t");
if (crc32("MZAnQrjgOJn",11) == 3643566235) strcat(s, "G");
if (crc32("UNtZYJVxkoJvt",13) == 1026632093) strcat(s, "a");
if (crc32("KTSomy",6) == 935702767) strcat(s, "S");
if (crc32("HjOeIWDjtd",10) == 2085046091) strcat(s, "t");
if (crc32("TMlFTAEsbSsvNxB",15) == 42096616) strcat(s, "i");
if (crc32("ZijwCC",6) == 2050735807) strcat(s, "m");
if (crc32("fGvytErLqWjz",12) == 2498542415) strcat(s, "c");
    return s;
}

char *unluckier_adjectives() {
    char *s = calloc(10);
    if (crc32("YbVTQK",6) == 3201105582) strcat(s, "u");
if (crc32("JWlckQBWzGiWo",13) == 398609387) strcat(s, "L");
if (crc32("fwjVhG",6) == 1571488194) strcat(s, "n");
if (crc32("CCdRCUtGDPDJ",12) == 1360908212) strcat(s, "V");
if (crc32("oDUzOGLX",8) == 3159513055) strcat(s, "l");
if (crc32("Ghfqbl",6) == 1382820117) strcat(s, "u");
if (crc32("tVFipdNxzLjwpOM",15) == 1576481961) strcat(s, "c");
if (crc32("nveZFvxxiprmocr",15) == 2999291094) strcat(s, "k");
if (crc32("cyXiFbUY",8) == 371075713) strcat(s, "i");
if (crc32("IusouZJZVmPp",12) == 1013724761) strcat(s, "e");
if (crc32("HgogMjuYo",9) == 4061538891) strcat(s, "J");
if (crc32("NQmeuX",6) == 827023012) strcat(s, "r");
    return s;
}

char *Mantuan_adjectives() {
    char *s = calloc(8);
    if (crc32("iXFcEqWcHEy",11) == 3061998356) strcat(s, "M");
if (crc32("UIrNL",5) == 1572790557) strcat(s, "j");
if (crc32("OYPoINXcGmqRtjw",15) == 3151159686) strcat(s, "a");
if (crc32("NINxDsjCPWFIft",14) == 3049508726) strcat(s, "n");
if (crc32("VhhmR",5) == 874970851) strcat(s, "T");
if (crc32("HNpOXxV",7) == 3795738607) strcat(s, "t");
if (crc32("NLXCSVB",7) == 681264359) strcat(s, "T");
if (crc32("ooOVDsWeRrllF",13) == 113126120) strcat(s, "u");
if (crc32("wtoeuCGMaIS",11) == 3412645181) strcat(s, "N");
if (crc32("EKSlyZtFckvU",12) == 2999389828) strcat(s, "a");
if (crc32("CKUlhsaEntxECxK",15) == 3158526093) strcat(s, "n");
    return s;
}

char *eely_adjectives() {
    char *s = calloc(5);
    if (crc32("uoEaFV",6) == 817612823) strcat(s, "e");
if (crc32("TvTVSDkSSqJhVZ",14) == 2399148884) strcat(s, "e");
if (crc32("yQHGIQFijuUvO",13) == 480889667) strcat(s, "l");
if (crc32("IAzWGWrQYPeX",12) == 397527567) strcat(s, "y");
    return s;
}

char *mouthier_adjectives() {
    char *s = calloc(9);
    if (crc32("IkyYhyVZxLHHR",13) == 3462065934) strcat(s, "m");
if (crc32("FVnQahm",7) == 478569411) strcat(s, "Z");
if (crc32("VADLSawSlt",10) == 2557470657) strcat(s, "o");
if (crc32("PVGbYanTuTKOkHi",15) == 444488073) strcat(s, "y");
if (crc32("nvwWfrsUnzgR",12) == 2482480243) strcat(s, "u");
if (crc32("HQDNcDbQ",8) == 2085969878) strcat(s, "t");
if (crc32("qlCJxawk",8) == 2411802201) strcat(s, "h");
if (crc32("JltmrwBEQrSy",12) == 2129574609) strcat(s, "c");
if (crc32("MvrLdukf",8) == 1196247080) strcat(s, "i");
if (crc32("vyCYO",5) == 1497466081) strcat(s, "e");
if (crc32("xaelNaEOrGvyu",13) == 3993951611) strcat(s, "Y");
if (crc32("kKYivEsFgjp",11) == 1037229310) strcat(s, "r");
    return s;
}

char *negational_adjectives() {
    char *s = calloc(11);
    if (crc32("jxRMxkbA",8) == 2796690627) strcat(s, "n");
if (crc32("ocFTuq",6) == 913464357) strcat(s, "e");
if (crc32("VeQFT",5) == 3671258030) strcat(s, "g");
if (crc32("dByMg",5) == 2803459395) strcat(s, "B");
if (crc32("RMEtrihmNAsF",12) == 2281025360) strcat(s, "a");
if (crc32("OLaijfMu",8) == 1358065593) strcat(s, "a");
if (crc32("LtcmPzrm",8) == 1351931470) strcat(s, "t");
if (crc32("Vyevsu",6) == 3878581410) strcat(s, "i");
if (crc32("ujRogkCjoSuNkio",15) == 1006562011) strcat(s, "A");
if (crc32("pmZXXNj",7) == 407270963) strcat(s, "o");
if (crc32("nnYIUeglOi",10) == 2329790581) strcat(s, "n");
if (crc32("MOxeSIYOnlUor",13) == 2426952008) strcat(s, "a");
if (crc32("TqtzDDWHgr",10) == 266737433) strcat(s, "F");
if (crc32("qgIXB",5) == 832221303) strcat(s, "l");
    return s;
}

char *unpresiding_adjectives() {
    char *s = calloc(12);
    if (crc32("nEsinfBYsxkSZv",14) == 1280018987) strcat(s, "u");
if (crc32("oTQGMQbZYLSu",12) == 2072570788) strcat(s, "n");
if (crc32("fQGBQII",7) == 2549734259) strcat(s, "a");
if (crc32("zlnwtid",7) == 3618667280) strcat(s, "p");
if (crc32("wemDZ",5) == 1395015771) strcat(s, "u");
if (crc32("gkNpiPKhtk",10) == 1391638573) strcat(s, "r");
if (crc32("ylsKzl",6) == 3619140732) strcat(s, "P");
if (crc32("UGeyDc",6) == 270815923) strcat(s, "e");
if (crc32("danBvQW",7) == 821136973) strcat(s, "s");
if (crc32("XNxIndzbNQYWjl",14) == 3591933644) strcat(s, "i");
if (crc32("mgxxYocRcNmRnCu",15) == 627608170) strcat(s, "d");
if (crc32("KzAxj",5) == 3596239602) strcat(s, "i");
if (crc32("uPyzXjAaDalf",12) == 1379964418) strcat(s, "O");
if (crc32("egRwoeWYGCIA",12) == 995767378) strcat(s, "n");
if (crc32("PldypjWgY",9) == 2841261178) strcat(s, "F");
if (crc32("yYSboWrmuWh",11) == 2960833053) strcat(s, "g");
    return s;
}

char *mullocky_adjectives() {
    char *s = calloc(9);
    if (crc32("DpSCWkxDUv",10) == 792927146) strcat(s, "l");
if (crc32("onRxQ",5) == 2450259955) strcat(s, "m");
if (crc32("TtbiHxhKTMIhw",13) == 3147507758) strcat(s, "u");
if (crc32("OqTOvwwuUj",10) == 2275939330) strcat(s, "G");
if (crc32("oUUFEavsu",9) == 3077665827) strcat(s, "l");
if (crc32("BaIaebMqDnTLF",13) == 2740360981) strcat(s, "z");
if (crc32("puFLgayTZkDXlwO",15) == 3697853939) strcat(s, "l");
if (crc32("mPVUiDXmyU",10) == 2124882544) strcat(s, "o");
if (crc32("KiAQkOrc",8) == 2430576191) strcat(s, "c");
if (crc32("ERmIgmfyxaampNy",15) == 2947313757) strcat(s, "k");
if (crc32("mCOwfQVISoSh",12) == 758085399) strcat(s, "y");
    return s;
}

char *coronagraphic_adjectives() {
    char *s = calloc(14);
    if (crc32("XdXaWniEq",9) == 342932224) strcat(s, "c");
if (crc32("pdTXnubUBAj",11) == 4176118258) strcat(s, "T");
if (crc32("jVPLiEAo",8) == 4052875015) strcat(s, "o");
if (crc32("paENgAip",8) == 2825873957) strcat(s, "c");
if (crc32("cJyODn",6) == 2114944778) strcat(s, "r");
if (crc32("YhUsnXkBfNoyu",13) == 2453752287) strcat(s, "o");
if (crc32("okcYVxhmZdws",12) == 1024488831) strcat(s, "n");
if (crc32("RPFqPf",6) == 1035033387) strcat(s, "a");
if (crc32("yGPiBG",6) == 3936447285) strcat(s, "g");
if (crc32("TMCNOzyNGURDk",13) == 3758549290) strcat(s, "g");
if (crc32("kRMiZnN",7) == 1498618675) strcat(s, "S");
if (crc32("lmgchsLVxYH",11) == 2082537322) strcat(s, "r");
if (crc32("FddcI",5) == 1942421392) strcat(s, "S");
if (crc32("CBegwoMev",9) == 1472740526) strcat(s, "a");
if (crc32("AgreVBytF",9) == 1598874327) strcat(s, "m");
if (crc32("lOcaRrQkonaKAsT",15) == 1127639360) strcat(s, "p");
if (crc32("eTPBFPkbKOdfaLw",15) == 2538334885) strcat(s, "h");
if (crc32("BbYqkoPDi",9) == 3018864301) strcat(s, "i");
if (crc32("WIiIYPXLkXSv",12) == 1944724348) strcat(s, "c");
    return s;
}

char *homogamous_adjectives() {
    char *s = calloc(11);
    if (crc32("UguqyHwtofeNwme",15) == 2745112450) strcat(s, "z");
if (crc32("YGyLm",5) == 3238884368) strcat(s, "h");
if (crc32("hLquD",5) == 3362268745) strcat(s, "o");
if (crc32("iqeLxVL",7) == 172349717) strcat(s, "m");
if (crc32("qoYgaEQpgDYwQ",13) == 2263262629) strcat(s, "o");
if (crc32("CDtizDvjKjQE",12) == 2058735325) strcat(s, "g");
if (crc32("DQoJXPODXnmAOIQ",15) == 802015117) strcat(s, "a");
if (crc32("ShNiFKnneFWyKLE",15) == 3061494204) strcat(s, "m");
if (crc32("pVgWUXufBzjRWN",14) == 2874818291) strcat(s, "o");
if (crc32("bPAcTACqCMWZn",13) == 1681343662) strcat(s, "c");
if (crc32("rqdrjjZhz",9) == 2591228079) strcat(s, "u");
if (crc32("QEyeHgvCr",9) == 952451589) strcat(s, "s");
    return s;
}

char *transCongo_adjectives() {
    char *s = calloc(11);
    if (crc32("dJcRkTHmSh",10) == 2137045358) strcat(s, "W");
if (crc32("YJfflPHoriYNUZT",15) == 108351816) strcat(s, "t");
if (crc32("iDZUW",5) == 362736491) strcat(s, "r");
if (crc32("mXnQfhPGwuuBv",13) == 190263071) strcat(s, "a");
if (crc32("YRMWUlCGzmTPG",13) == 2358790679) strcat(s, "n");
if (crc32("VxPMV",5) == 1956228668) strcat(s, "s");
if (crc32("VPgibZPytUjncxx",15) == 1119190457) strcat(s, "C");
if (crc32("cTWWsoUhtf",10) == 2685620501) strcat(s, "P");
if (crc32("TucICqUZDR",10) == 2805989566) strcat(s, "o");
if (crc32("YJMdc",5) == 2866831916) strcat(s, "n");
if (crc32("vfsOBGBc",8) == 3797063872) strcat(s, "g");
if (crc32("CXnhh",5) == 2076974118) strcat(s, "o");
    return s;
}

char *oscitant_adjectives() {
    char *s = calloc(9);
    if (crc32("TDxGkJQLQAy",11) == 43307289) strcat(s, "o");
if (crc32("vbItcAVN",8) == 3333757276) strcat(s, "c");
if (crc32("apUYppQXJV",10) == 3992403108) strcat(s, "s");
if (crc32("FnEEGbwjUPcMU",13) == 2808303285) strcat(s, "z");
if (crc32("CnHqqR",6) == 2799573655) strcat(s, "c");
if (crc32("BGxucGnwrONF",12) == 3928308228) strcat(s, "i");
if (crc32("GTnlqJVxIwACQxm",15) == 991382919) strcat(s, "t");
if (crc32("VfyPuRdY",8) == 2544105892) strcat(s, "m");
if (crc32("qArwBavSEKd",11) == 3448132275) strcat(s, "a");
if (crc32("LgxuTTKqyhYZVXx",15) == 3776909113) strcat(s, "n");
if (crc32("GCZURiqaLOPUXX",14) == 1051084193) strcat(s, "t");
    return s;
}

char *wellappearing_adjectives() {
    char *s = calloc(14);
    if (crc32("kfRUwHicsz",10) == 1170410594) strcat(s, "w");
if (crc32("xLBxgPzJaYa",11) == 730318532) strcat(s, "r");
if (crc32("ECXbMRFCYU",10) == 2871188712) strcat(s, "e");
if (crc32("TWZVL",5) == 67986745) strcat(s, "n");
if (crc32("oWbTxPcTi",9) == 327231312) strcat(s, "l");
if (crc32("BmWasqKR",8) == 1786881214) strcat(s, "f");
if (crc32("WQnXVhwD",8) == 1016303051) strcat(s, "l");
if (crc32("ObcUzC",6) == 3588163799) strcat(s, "a");
if (crc32("SjsnmNuSR",9) == 1596160500) strcat(s, "p");
if (crc32("jdXhHxaNcthS",12) == 198558465) strcat(s, "q");
if (crc32("kNaJHCWUT",9) == 2754696641) strcat(s, "p");
if (crc32("rjJDiRZKAAJAIJm",15) == 2971053681) strcat(s, "m");
if (crc32("LvOSkWVlbU",10) == 223622218) strcat(s, "e");
if (crc32("aEWVKRBn",8) == 439586836) strcat(s, "X");
if (crc32("MJvgsbOMlehHT",13) == 303070350) strcat(s, "a");
if (crc32("OxZUhTBgwrZasQ",14) == 1359822455) strcat(s, "r");
if (crc32("kjsmOlKA",8) == 2730227845) strcat(s, "e");
if (crc32("JvqkYQ",6) == 2307389825) strcat(s, "i");
if (crc32("YsRoJaCdi",9) == 1982900236) strcat(s, "D");
if (crc32("cjMVjChQkgU",11) == 3508963461) strcat(s, "n");
if (crc32("WJgiHwTxrXQS",12) == 3145445671) strcat(s, "g");
    return s;
}

char *nonextraditable_adjectives() {
    char *s = calloc(16);
    if (crc32("IqYwtPC",7) == 4289165259) strcat(s, "w");
if (crc32("vZZhHNHEG",9) == 3391354300) strcat(s, "n");
if (crc32("LZgCJx",6) == 3911393060) strcat(s, "C");
if (crc32("GpUZmd",6) == 1564057573) strcat(s, "o");
if (crc32("BCdDPB",6) == 2328771447) strcat(s, "S");
if (crc32("OMmsMHZGM",9) == 449904301) strcat(s, "n");
if (crc32("iAnWNxcaF",9) == 41859445) strcat(s, "O");
if (crc32("HfvNyqYZA",9) == 713950752) strcat(s, "e");
if (crc32("GrLrfSHv",8) == 125047256) strcat(s, "Q");
if (crc32("LtplCXfhWslkruv",15) == 2463559107) strcat(s, "x");
if (crc32("BJUEBGVYQjXcpf",14) == 727159232) strcat(s, "t");
if (crc32("dHSjaSQmgJGl",12) == 121110822) strcat(s, "V");
if (crc32("sVQJyf",6) == 3753345700) strcat(s, "r");
if (crc32("rAbKLVGWz",9) == 4284226996) strcat(s, "k");
if (crc32("EuZROJFuZXNOi",13) == 3021755666) strcat(s, "a");
if (crc32("yLCAuq",6) == 2371851487) strcat(s, "d");
if (crc32("VdCvqUvdxS",10) == 1512480541) strcat(s, "i");
if (crc32("LjMqcPUd",8) == 4288487703) strcat(s, "j");
if (crc32("cXeDXcqlJQULpO",14) == 2693852076) strcat(s, "t");
if (crc32("UiJPmLEonAwaOu",14) == 1417780175) strcat(s, "c");
if (crc32("LZxgS",5) == 2108516693) strcat(s, "a");
if (crc32("HhlYB",5) == 3797274524) strcat(s, "b");
if (crc32("FqoYDaqtv",9) == 4109082221) strcat(s, "l");
if (crc32("KZMzUVEney",10) == 1653912157) strcat(s, "L");
if (crc32("VoKeO",5) == 2417134561) strcat(s, "e");
    return s;
}

char *antimethodic_adjectives() {
    char *s = calloc(13);
    if (crc32("mcuasRrBCxrhp",13) == 3749583170) strcat(s, "d");
if (crc32("YjkVQq",6) == 1232443599) strcat(s, "a");
if (crc32("FjifmBYLLnoC",12) == 2763560695) strcat(s, "n");
if (crc32("RusjiHVPGIYf",12) == 3870452501) strcat(s, "i");
if (crc32("lysoSBDgqNxMSl",14) == 3211593131) strcat(s, "t");
if (crc32("OALziSSBWP",10) == 394785748) strcat(s, "i");
if (crc32("EZZupjH",7) == 3152808746) strcat(s, "m");
if (crc32("RoXYOnrTXq",10) == 2631016102) strcat(s, "O");
if (crc32("GoldZzyVla",10) == 1997012054) strcat(s, "e");
if (crc32("TlZrYHKFIWyvnC",14) == 3808429669) strcat(s, "z");
if (crc32("iRrquljD",8) == 1864080796) strcat(s, "t");
if (crc32("LMjirmsxRsjMa",13) == 3621787332) strcat(s, "n");
if (crc32("fEZbBAdHnixv",12) == 2002499448) strcat(s, "h");
if (crc32("QxukXkp",7) == 3932664350) strcat(s, "n");
if (crc32("YNqouQ",6) == 2746005889) strcat(s, "o");
if (crc32("XoydgzjdzXmNGr",14) == 3766947001) strcat(s, "X");
if (crc32("hucFBQpZScTh",12) == 3567959777) strcat(s, "d");
if (crc32("BOqMcYtZ",8) == 1336065045) strcat(s, "L");
if (crc32("ojygeBmPhfNpnq",14) == 1364210129) strcat(s, "i");
if (crc32("oduPouKTQYJy",12) == 2401768150) strcat(s, "c");
    return s;
}

char *unmartyred_adjectives() {
    char *s = calloc(11);
    if (crc32("XNBuZWNCkJ",10) == 3032511100) strcat(s, "u");
if (crc32("ojjvwnFpwDp",11) == 4279229588) strcat(s, "n");
if (crc32("ZwUeWnwg",8) == 207042311) strcat(s, "N");
if (crc32("wpjyHRc",7) == 1485533100) strcat(s, "m");
if (crc32("yyzEU",5) == 3876445747) strcat(s, "x");
if (crc32("gziCCm",6) == 3421826076) strcat(s, "a");
if (crc32("sbDXnmMjdRJ",11) == 380223276) strcat(s, "r");
if (crc32("BxdpTOST",8) == 846062630) strcat(s, "w");
if (crc32("nxFuxDwBBlkkO",13) == 224566064) strcat(s, "t");
if (crc32("ZyZFVoLqdjaabD",14) == 1589138518) strcat(s, "y");
if (crc32("jtPtXRvWuhfDce",14) == 365765110) strcat(s, "r");
if (crc32("ioNuqmeYyFhO",12) == 4186140467) strcat(s, "e");
if (crc32("rrvdpUnIY",9) == 3199214884) strcat(s, "d");
    return s;
}

char *trypanosomal_adjectives() {
    char *s = calloc(13);
    if (crc32("NcTpYmDp",8) == 1308741591) strcat(s, "K");
if (crc32("mTvJZYBcokDo",12) == 902998437) strcat(s, "t");
if (crc32("mvcsDzdwAv",10) == 3016336975) strcat(s, "c");
if (crc32("xGoQX",5) == 2362967385) strcat(s, "r");
if (crc32("fBSHRXrbHOivyhq",15) == 3523170262) strcat(s, "y");
if (crc32("rkYFQo",6) == 253594781) strcat(s, "d");
if (crc32("LeYTtMboUyi",11) == 70526475) strcat(s, "p");
if (crc32("svGWzFL",7) == 3596125807) strcat(s, "c");
if (crc32("uVWLy",5) == 93337976) strcat(s, "a");
if (crc32("YavRVtB",7) == 1152365551) strcat(s, "n");
if (crc32("JNcWtQm",7) == 55973295) strcat(s, "o");
if (crc32("qwbvHgTmEq",10) == 364933931) strcat(s, "s");
if (crc32("TwAoUtDBwwLL",12) == 275354493) strcat(s, "j");
if (crc32("SFzclc",6) == 3213580251) strcat(s, "o");
if (crc32("VoofTb",6) == 570647094) strcat(s, "m");
if (crc32("iDZuRQCgdaSYDh",14) == 385193042) strcat(s, "B");
if (crc32("eGhJEKMcndRSsv",14) == 3285619404) strcat(s, "a");
if (crc32("RahYaXUC",8) == 3734507090) strcat(s, "O");
if (crc32("cJhbS",5) == 259313962) strcat(s, "l");
    return s;
}

char *alimentative_adjectives() {
    char *s = calloc(13);
    if (crc32("WyMYwOWsx",9) == 4139933846) strcat(s, "a");
if (crc32("BYackxYFrgIzmG",14) == 4168116701) strcat(s, "O");
if (crc32("KvxbgYUYUYII",12) == 262076288) strcat(s, "l");
if (crc32("bihVMrE",7) == 2322006058) strcat(s, "i");
if (crc32("qNnQrJgmIthKA",13) == 3400814126) strcat(s, "s");
if (crc32("JONwUKQLmmpA",12) == 1446781118) strcat(s, "m");
if (crc32("iHXIWzFhv",9) == 1894483518) strcat(s, "t");
if (crc32("fRrleECeWp",10) == 1809631402) strcat(s, "e");
if (crc32("RYmeo",5) == 3078394054) strcat(s, "n");
if (crc32("DQSMlvgCsk",10) == 3967602317) strcat(s, "t");
if (crc32("fvnOqgwSfPLM",12) == 84393838) strcat(s, "a");
if (crc32("dlqHKim",7) == 4232212014) strcat(s, "t");
if (crc32("xBOECvblRLGdjCL",15) == 573755534) strcat(s, "Z");
if (crc32("Rxtyf",5) == 598615451) strcat(s, "i");
if (crc32("qMCDg",5) == 1832519814) strcat(s, "W");
if (crc32("jowSGIILoozSibP",15) == 2687943114) strcat(s, "v");
if (crc32("mtORudZTSS",10) == 338808721) strcat(s, "D");
if (crc32("bTKuV",5) == 3442495638) strcat(s, "e");
    return s;
}

char *brainless_adjectives() {
    char *s = calloc(10);
    if (crc32("sKWtHR",6) == 3245772440) strcat(s, "h");
if (crc32("hBoltTopMGNy",12) == 3849121474) strcat(s, "b");
if (crc32("RCrhMNERISBG",12) == 1811507425) strcat(s, "V");
if (crc32("zBUkIyA",7) == 190697011) strcat(s, "r");
if (crc32("UAFwenVzuXhmI",13) == 3744909406) strcat(s, "A");
if (crc32("qPGLSPuRA",9) == 3256086476) strcat(s, "a");
if (crc32("nbHarVCRpwMmej",14) == 1669851757) strcat(s, "i");
if (crc32("BLGIe",5) == 589998703) strcat(s, "K");
if (crc32("wFyst",5) == 1005912300) strcat(s, "n");
if (crc32("wrmviGFzBOYu",12) == 3547282405) strcat(s, "n");
if (crc32("czlMEtvdMVwlU",13) == 780817300) strcat(s, "l");
if (crc32("ZVKhxkMOtC",10) == 4266868257) strcat(s, "I");
if (crc32("SsjpzyWwPrWgcR",14) == 629439662) strcat(s, "e");
if (crc32("irAXXY",6) == 1022964418) strcat(s, "s");
if (crc32("ucCRZKe",7) == 1256948621) strcat(s, "Y");
if (crc32("gdexeaaH",8) == 274865848) strcat(s, "s");
    return s;
}

char *reconstructional_adjectives() {
    char *s = calloc(17);
    if (crc32("NpRmibFyuy",10) == 1023356804) strcat(s, "r");
if (crc32("XBSdSbLnY",9) == 2615736954) strcat(s, "a");
if (crc32("RYGFxKRAqEOG",12) == 1584397185) strcat(s, "e");
if (crc32("elVGOyVb",8) == 1428589066) strcat(s, "A");
if (crc32("FHJOgvOI",8) == 121157673) strcat(s, "c");
if (crc32("GvFZeuo",7) == 1390484844) strcat(s, "S");
if (crc32("yIzEz",5) == 2957290736) strcat(s, "o");
if (crc32("QdCjCfBbzbk",11) == 1611694018) strcat(s, "n");
if (crc32("NqTpLX",6) == 2603487060) strcat(s, "d");
if (crc32("mqfAupcBi",9) == 3774877028) strcat(s, "s");
if (crc32("NjGRLS",6) == 2420588366) strcat(s, "t");
if (crc32("ZdfYWFJcnRkXBCA",15) == 2967556940) strcat(s, "L");
if (crc32("kwmXNkPimXjnzm",14) == 4162638232) strcat(s, "r");
if (crc32("TxcSFtUFNUyzN",13) == 2981317895) strcat(s, "g");
if (crc32("XoMSP",5) == 800839090) strcat(s, "u");
if (crc32("jBiXYPTeW",9) == 3796107709) strcat(s, "u");
if (crc32("lCHrGi",6) == 1394901193) strcat(s, "c");
if (crc32("gFAMXJGP",8) == 3242586101) strcat(s, "G");
if (crc32("vBNSYBXlfaH",11) == 4015209749) strcat(s, "t");
if (crc32("zUgFTPkqVl",10) == 1341933976) strcat(s, "B");
if (crc32("mNkQLUx",7) == 1067357031) strcat(s, "i");
if (crc32("MoeYPQSCgCRQJAb",15) == 2326280341) strcat(s, "o");
if (crc32("zGmXtPnZsSg",11) == 2014873720) strcat(s, "I");
if (crc32("sCllu",5) == 1494944141) strcat(s, "n");
if (crc32("QkkSz",5) == 1253233424) strcat(s, "a");
if (crc32("eNczQAD",7) == 1155339141) strcat(s, "v");
if (crc32("JXMSIVBNpXnr",12) == 3691419029) strcat(s, "l");
    return s;
}

char *Panic_adjectives() {
    char *s = calloc(6);
    if (crc32("ajvJEE",6) == 420080569) strcat(s, "P");
if (crc32("cnrQN",5) == 36316482) strcat(s, "f");
if (crc32("fzpLGNCvZs",10) == 3491655938) strcat(s, "a");
if (crc32("fkJxgO",6) == 3810077544) strcat(s, "n");
if (crc32("atGigcCwdgVbE",13) == 3748738467) strcat(s, "i");
if (crc32("ltyLmZueaAgBqG",14) == 998006420) strcat(s, "c");
    return s;
}

char *styleless_adjectives() {
    char *s = calloc(10);
    if (crc32("UbafKvWOVmMNA",13) == 3588456286) strcat(s, "s");
if (crc32("arTTJckNlVSUsYG",15) == 2249861517) strcat(s, "R");
if (crc32("XIgiqpim",8) == 3018805196) strcat(s, "t");
if (crc32("ucOFg",5) == 2931628385) strcat(s, "m");
if (crc32("DGkMTOv",7) == 500921299) strcat(s, "y");
if (crc32("tkPpMPkyG",9) == 1313077093) strcat(s, "d");
if (crc32("kTQdeCzM",8) == 935345158) strcat(s, "l");
if (crc32("keDHhfPnay",10) == 686084415) strcat(s, "e");
if (crc32("QvcHVfnAHg",10) == 2766572234) strcat(s, "s");
if (crc32("vUuGrxLiVCnOukd",15) == 3045049570) strcat(s, "l");
if (crc32("DWKwLuoIitqg",12) == 1027058441) strcat(s, "t");
if (crc32("KMCAFmIilmyBtS",14) == 2706919452) strcat(s, "e");
if (crc32("ZiYYHmpqp",9) == 3763093524) strcat(s, "o");
if (crc32("DTxDC",5) == 236728994) strcat(s, "s");
if (crc32("DHOhDojykgcdD",13) == 945007895) strcat(s, "s");
    return s;
}

char *lexical_adjectives() {
    char *s = calloc(8);
    if (crc32("vNwZLvjuua",10) == 814891152) strcat(s, "U");
if (crc32("DhCkdEFs",8) == 3132672024) strcat(s, "l");
if (crc32("ylHgePGhUXeVWN",14) == 3298933919) strcat(s, "e");
if (crc32("sgrZLrFA",8) == 485130991) strcat(s, "x");
if (crc32("aNmGaSe",7) == 3374738399) strcat(s, "T");
if (crc32("fojNDzK",7) == 1739356084) strcat(s, "i");
if (crc32("VMIDJryEWt",10) == 300857003) strcat(s, "c");
if (crc32("kAIBcl",6) == 699692237) strcat(s, "a");
if (crc32("EAtZEu",6) == 2748574171) strcat(s, "l");
    return s;
}

char *preChristmas_adjectives() {
    char *s = calloc(13);
    if (crc32("DPHUpJStOqF",11) == 3348503658) strcat(s, "p");
if (crc32("BuEwrzOpq",9) == 111330954) strcat(s, "r");
if (crc32("CqCuanfPtStJ",12) == 486260528) strcat(s, "G");
if (crc32("wCOxw",5) == 1446044045) strcat(s, "e");
if (crc32("DLoOVRkro",9) == 4020604178) strcat(s, "K");
if (crc32("xDyVZQmlih",10) == 2713796819) strcat(s, "C");
if (crc32("hWcNyKfauxGWlj",14) == 157218192) strcat(s, "i");
if (crc32("yXkWUChcd",9) == 2674465238) strcat(s, "h");
if (crc32("FAKuUgnbTwmKoF",14) == 2602271923) strcat(s, "l");
if (crc32("eXNafsbtRz",10) == 2521693450) strcat(s, "r");
if (crc32("PuzpDSMtYdsoDS",14) == 205536852) strcat(s, "i");
if (crc32("XcjmfRvXmIY",11) == 1006525622) strcat(s, "n");
if (crc32("reusVyZJMWgBYM",14) == 1373021313) strcat(s, "s");
if (crc32("uEURVaCOaeK",11) == 861895646) strcat(s, "w");
if (crc32("qRpZMp",6) == 749316322) strcat(s, "t");
if (crc32("HroWEHEybrv",11) == 3218687072) strcat(s, "M");
if (crc32("qPKem",5) == 2665206246) strcat(s, "m");
if (crc32("BfbcqdI",7) == 26639961) strcat(s, "a");
if (crc32("KDyKCjAyf",9) == 1519278786) strcat(s, "e");
if (crc32("yYOYUlV",7) == 2190254136) strcat(s, "s");
    return s;
}

char *assistive_adjectives() {
    char *s = calloc(10);
    if (crc32("VsQxEZEFD",9) == 841862480) strcat(s, "a");
if (crc32("IRWgqr",6) == 1210832053) strcat(s, "s");
if (crc32("tLaPOU",6) == 1068766043) strcat(s, "s");
if (crc32("dNEDIcqiSTu",11) == 2131122360) strcat(s, "i");
if (crc32("ygngVTfPTKd",11) == 1792909436) strcat(s, "g");
if (crc32("dnjRL",5) == 3285113403) strcat(s, "s");
if (crc32("GknvInDNvHktRK",14) == 3880270038) strcat(s, "t");
if (crc32("iqvOOtsCiZl",11) == 2095370848) strcat(s, "i");
if (crc32("mnxnNGAfuvCz",12) == 3059845449) strcat(s, "v");
if (crc32("zLjrkfFEfQPaGk",14) == 3051980275) strcat(s, "z");
if (crc32("mkGvBKYd",8) == 2949049452) strcat(s, "e");
    return s;
}

char *purpuric_adjectives() {
    char *s = calloc(9);
    if (crc32("NEByBFtSz",9) == 1194805059) strcat(s, "k");
if (crc32("rKiKUuaafZLj",12) == 2103049749) strcat(s, "p");
if (crc32("eUjyjB",6) == 1347703173) strcat(s, "t");
if (crc32("OFscUyhAiEYZky",14) == 1682256859) strcat(s, "u");
if (crc32("jsQzQKEZY",9) == 1330933665) strcat(s, "r");
if (crc32("rEuxy",5) == 2472115642) strcat(s, "J");
if (crc32("VGylE",5) == 3815534489) strcat(s, "p");
if (crc32("scJFZSA",7) == 2480339906) strcat(s, "u");
if (crc32("aWslxDKxhb",10) == 1337154860) strcat(s, "E");
if (crc32("QtptKbdSS",9) == 1170701048) strcat(s, "r");
if (crc32("ecIvKtW",7) == 2351299337) strcat(s, "U");
if (crc32("cILQYDT",7) == 2057897470) strcat(s, "i");
if (crc32("mZxsFkDj",8) == 870705198) strcat(s, "c");
    return s;
}

char *flawless_adjectives() {
    char *s = calloc(9);
    if (crc32("OIKwZI",6) == 1221643809) strcat(s, "f");
if (crc32("WKBpiDO",7) == 438187337) strcat(s, "C");
if (crc32("odkeGqgjrR",10) == 1003774407) strcat(s, "l");
if (crc32("HKqPCLqZuSKLBlW",15) == 326873634) strcat(s, "w");
if (crc32("igMmoktEgd",10) == 1269598890) strcat(s, "a");
if (crc32("ogmvuECaja",10) == 3446990602) strcat(s, "Q");
if (crc32("OENUbRu",7) == 2283535778) strcat(s, "w");
if (crc32("VsHkYBsHrxL",11) == 3587123799) strcat(s, "l");
if (crc32("zTLHyUutuJcqJX",14) == 3977672411) strcat(s, "e");
if (crc32("eGpPXo",6) == 2881789610) strcat(s, "s");
if (crc32("rsgYUDPGqfeS",12) == 2704543562) strcat(s, "c");
if (crc32("BYPSWokxuNrarJ",14) == 391079790) strcat(s, "s");
    return s;
}

char *Tehuelchean_adjectives() {
    char *s = calloc(12);
    if (crc32("zLpJJgnwKCtviu",14) == 3321462627) strcat(s, "V");
if (crc32("znhZcCtCSgAFVR",14) == 3065838778) strcat(s, "T");
if (crc32("JXvSTawcrRptd",13) == 1833681196) strcat(s, "v");
if (crc32("QzmyBFVj",8) == 4036111934) strcat(s, "e");
if (crc32("qSEKfuVsn",9) == 4263665264) strcat(s, "G");
if (crc32("iJjUnHrwBEs",11) == 1734946555) strcat(s, "h");
if (crc32("JyrdzaSwp",9) == 2554461486) strcat(s, "u");
if (crc32("WkUXechwurZFahz",15) == 361140720) strcat(s, "e");
if (crc32("CGcLH",5) == 2984774098) strcat(s, "l");
if (crc32("ycKhKmjztVsM",12) == 3861465351) strcat(s, "I");
if (crc32("JWlBBpHUyHJgU",13) == 2441440196) strcat(s, "c");
if (crc32("saIriNBfse",10) == 3513892069) strcat(s, "h");
if (crc32("ZQYawp",6) == 3603895163) strcat(s, "h");
if (crc32("sToBQVeajDl",11) == 1287037183) strcat(s, "e");
if (crc32("RwejplxHr",9) == 951250472) strcat(s, "a");
if (crc32("WwSCViZS",8) == 2635171474) strcat(s, "n");
    return s;
}

char *simplicidentate_adjectives() {
    char *s = calloc(16);
    if (crc32("XGFNSqRnUGv",11) == 1665395523) strcat(s, "s");
if (crc32("MavGaMrPbYcgYFd",15) == 3549949937) strcat(s, "A");
if (crc32("hDlfNPd",7) == 2031353802) strcat(s, "i");
if (crc32("APvQjhUoQCGSh",13) == 2057406429) strcat(s, "m");
if (crc32("WHOVVjzDWN",10) == 1936334450) strcat(s, "p");
if (crc32("MObsyGXC",8) == 1625459374) strcat(s, "l");
if (crc32("qQdpdCreK",9) == 2101756918) strcat(s, "H");
if (crc32("lKLYmOHxtZ",10) == 378533034) strcat(s, "i");
if (crc32("XfBqoTOHn",9) == 2626477838) strcat(s, "c");
if (crc32("JeHxoF",6) == 927705699) strcat(s, "i");
if (crc32("gGjoGEKk",8) == 903016493) strcat(s, "d");
if (crc32("VJBjuHl",7) == 1423138887) strcat(s, "g");
if (crc32("bFUgpdxYjr",10) == 1135123266) strcat(s, "e");
if (crc32("MpXBgdoQbg",10) == 3730775027) strcat(s, "n");
if (crc32("XCMct",5) == 639244054) strcat(s, "t");
if (crc32("KJZOxopLkHs",11) == 3148629572) strcat(s, "a");
if (crc32("ZyEAw",5) == 4091812497) strcat(s, "t");
if (crc32("ZaipazZDWxNhHc",14) == 2584486953) strcat(s, "e");
    return s;
}

char *matterindeed_adjectives() {
    char *s = calloc(13);
    if (crc32("svfbvpbF",8) == 69734571) strcat(s, "q");
if (crc32("UsLjjKhccOEmFS",14) == 1026209400) strcat(s, "m");
if (crc32("sbaxOixPryKvT",13) == 2454174700) strcat(s, "V");
if (crc32("EngGB",5) == 3887760591) strcat(s, "a");
if (crc32("myYeQbFSkYloWwK",15) == 2843828591) strcat(s, "N");
if (crc32("KsbWBNoEXMsFnnc",15) == 1360212688) strcat(s, "t");
if (crc32("ouMrSPAIIfbvP",13) == 3009353585) strcat(s, "t");
if (crc32("sBAgrXZBRftevc",14) == 1387478914) strcat(s, "x");
if (crc32("WbXcunBWIk",10) == 680678191) strcat(s, "e");
if (crc32("DdNxQVSISLn",11) == 3793312449) strcat(s, "r");
if (crc32("OLBHONP",7) == 3858903408) strcat(s, "T");
if (crc32("yCJGiGY",7) == 2472137237) strcat(s, "i");
if (crc32("RgWvzIhMbeZj",12) == 2137098513) strcat(s, "p");
if (crc32("rxHsPjRpRkx",11) == 2071716062) strcat(s, "n");
if (crc32("KHzABzAcBuFAbWn",15) == 2223823361) strcat(s, "k");
if (crc32("PAWOKXYP",8) == 939045480) strcat(s, "d");
if (crc32("cVMRbWivNlT",11) == 653998402) strcat(s, "e");
if (crc32("olQrKO",6) == 2562999644) strcat(s, "k");
if (crc32("FqFIVx",6) == 3749327839) strcat(s, "e");
if (crc32("syUEoTZcVhtzNH",14) == 3500822903) strcat(s, "d");
    return s;
}

char *shearless_adjectives() {
    char *s = calloc(10);
    if (crc32("iAlOgXc",7) == 867362749) strcat(s, "s");
if (crc32("WldIxUql",8) == 109934015) strcat(s, "h");
if (crc32("pYPcAkXTBaS",11) == 3444258334) strcat(s, "e");
if (crc32("zBEiEaKmoBFD",12) == 1016587701) strcat(s, "a");
if (crc32("PQZIiQB",7) == 1579858648) strcat(s, "a");
if (crc32("HEasnAKCqeFz",12) == 3407054963) strcat(s, "r");
if (crc32("QOiEwWbegFZmU",13) == 2058404867) strcat(s, "l");
if (crc32("ArleEPgI",8) == 1410506194) strcat(s, "F");
if (crc32("ScLgFGwHn",9) == 2005718080) strcat(s, "e");
if (crc32("CAiyhtLS",8) == 1379861103) strcat(s, "W");
if (crc32("oGGShAyCviC",11) == 3208589088) strcat(s, "s");
if (crc32("SafjfWAOYGBGj",13) == 2460324698) strcat(s, "O");
if (crc32("DrCJJNGWeIE",11) == 2698630450) strcat(s, "s");
    return s;
}

char *overhasty_adjectives() {
    char *s = calloc(10);
    if (crc32("raovGVfhYjlWTh",14) == 3785867051) strcat(s, "P");
if (crc32("lwYdXwQLXjASlD",14) == 320468776) strcat(s, "o");
if (crc32("WYIFvcb",7) == 2311582092) strcat(s, "z");
if (crc32("NvYVOOYQZWE",11) == 3251557896) strcat(s, "v");
if (crc32("tiXOxMESvM",10) == 849126986) strcat(s, "m");
if (crc32("hBRci",5) == 1274757217) strcat(s, "e");
if (crc32("yCgBOfOwou",10) == 3788175869) strcat(s, "g");
if (crc32("cMMIQ",5) == 878440925) strcat(s, "r");
if (crc32("ZFnEJXOzOA",10) == 3187957330) strcat(s, "m");
if (crc32("qjQAu",5) == 4067989109) strcat(s, "h");
if (crc32("UfHTzpTyCzSX",12) == 945454275) strcat(s, "z");
if (crc32("mqIJuEy",7) == 3772020285) strcat(s, "a");
if (crc32("zULIKJDCzWnV",12) == 3103941368) strcat(s, "l");
if (crc32("nqTkTt",6) == 3470563255) strcat(s, "s");
if (crc32("NgHXrLXFXEf",11) == 3238682043) strcat(s, "t");
if (crc32("hInRUJJnGeYsp",13) == 3393288900) strcat(s, "y");
    return s;
}

char *microchemical_adjectives() {
    char *s = calloc(14);
    if (crc32("PYztAoykuSX",11) == 3535610844) strcat(s, "N");
if (crc32("yroKtBuiisB",11) == 487877310) strcat(s, "m");
if (crc32("RNeVxKsszxwUy",13) == 164352010) strcat(s, "V");
if (crc32("xUJaNuvxkZKcFR",14) == 3985353600) strcat(s, "i");
if (crc32("UukKgu",6) == 1083289396) strcat(s, "J");
if (crc32("RcEpROkGb",9) == 544908462) strcat(s, "c");
if (crc32("npuSM",5) == 3674074183) strcat(s, "M");
if (crc32("qmrxckRXif",10) == 353927048) strcat(s, "r");
if (crc32("crmyrNSYldjDH",13) == 2131426496) strcat(s, "o");
if (crc32("mCnIRDfBurZfOb",14) == 2574782089) strcat(s, "c");
if (crc32("lIGqv",5) == 2255191325) strcat(s, "h");
if (crc32("SvUGNckop",9) == 1685825822) strcat(s, "A");
if (crc32("DkAKmuvlA",9) == 3401178167) strcat(s, "e");
if (crc32("WtxEOnnXtkBswo",14) == 3869934497) strcat(s, "m");
if (crc32("hLWJFLNosZW",11) == 2471755660) strcat(s, "i");
if (crc32("aJqxqGkinSeto",13) == 3041608857) strcat(s, "F");
if (crc32("MjsZwujDLeTrMp",14) == 2866755398) strcat(s, "c");
if (crc32("DQIQE",5) == 3267169814) strcat(s, "a");
if (crc32("irbCBRiqJl",10) == 2865521507) strcat(s, "l");
    return s;
}

char *monopetalous_adjectives() {
    char *s = calloc(13);
    if (crc32("IfhpAexYRcOxOW",14) == 1793454267) strcat(s, "m");
if (crc32("gxqEBtH",7) == 473853751) strcat(s, "o");
if (crc32("apvMtxQGgFbPev",14) == 3324344467) strcat(s, "j");
if (crc32("HbiwekTF",8) == 3999819445) strcat(s, "n");
if (crc32("lFlXTy",6) == 70606023) strcat(s, "I");
if (crc32("uWPgtFglHOKDBmW",15) == 1936332514) strcat(s, "o");
if (crc32("qVJqwUHhCfLf",12) == 2805216260) strcat(s, "C");
if (crc32("MPjrVCw",7) == 3683544720) strcat(s, "p");
if (crc32("Vdoufne",7) == 2205391585) strcat(s, "e");
if (crc32("oLRxhOeO",8) == 471574131) strcat(s, "t");
if (crc32("IILsu",5) == 673186224) strcat(s, "a");
if (crc32("dABcbVLOMlLcxA",14) == 3154003444) strcat(s, "l");
if (crc32("IprGLqEgunB",11) == 4013795390) strcat(s, "E");
if (crc32("ynUwdoGdPuFcmi",14) == 944642555) strcat(s, "o");
if (crc32("NfiIvZoTPCbb",12) == 3509103388) strcat(s, "u");
if (crc32("XNpkzYSDeyH",11) == 1011279863) strcat(s, "P");
if (crc32("KStnpF",6) == 3178930853) strcat(s, "s");
    return s;
}

char *pucka_adjectives() {
    char *s = calloc(6);
    if (crc32("DFxHWTs",7) == 486751322) strcat(s, "p");
if (crc32("QRHBIwi",7) == 726505277) strcat(s, "u");
if (crc32("eVVcSretW",9) == 3809748767) strcat(s, "c");
if (crc32("IkLhBNbWM",9) == 2441691890) strcat(s, "k");
if (crc32("vHmxmqLVLKB",11) == 1993072187) strcat(s, "g");
if (crc32("NpZIlwnmip",10) == 3441936763) strcat(s, "a");
    return s;
}

char *agrypnotic_adjectives() {
    char *s = calloc(11);
    if (crc32("kijlsb",6) == 4113253476) strcat(s, "a");
if (crc32("TMCFTRRzBxXVpM",14) == 2506747135) strcat(s, "c");
if (crc32("XWbeXgcEBkop",12) == 3265245290) strcat(s, "g");
if (crc32("wrZfPCqosXqPIf",14) == 1450791780) strcat(s, "Z");
if (crc32("IkNBwaNTmsL",11) == 3771811710) strcat(s, "r");
if (crc32("wRSNqAEjknf",11) == 4283202605) strcat(s, "d");
if (crc32("KkPzTphMQid",11) == 1999720911) strcat(s, "y");
if (crc32("FrvBDsvhvBXWfOB",15) == 960118162) strcat(s, "p");
if (crc32("jXijYFfLBjHDn",13) == 2066899947) strcat(s, "n");
if (crc32("KYupoKeA",8) == 3772750530) strcat(s, "n");
if (crc32("rhfBspDByD",10) == 2950536529) strcat(s, "o");
if (crc32("zomkBY",6) == 3431135009) strcat(s, "l");
if (crc32("mPcomkU",7) == 458448640) strcat(s, "t");
if (crc32("kaLKhhlZsRenO",13) == 1718660864) strcat(s, "i");
if (crc32("mPwnRS",6) == 4092932987) strcat(s, "c");
    return s;
}

char *unfluid_adjectives() {
    char *s = calloc(8);
    if (crc32("FBCUaIjzKEV",11) == 2494786044) strcat(s, "u");
if (crc32("TMSkZtmgOnxdeBq",15) == 2353937584) strcat(s, "n");
if (crc32("UalHukDf",8) == 1484455999) strcat(s, "z");
if (crc32("rPCTRoskXsttAju",15) == 2651787174) strcat(s, "f");
if (crc32("JZWPrTCXJoyYkv",14) == 3556972934) strcat(s, "l");
if (crc32("IduiLjI",7) == 1091861267) strcat(s, "u");
if (crc32("TBeNujvdzn",10) == 3641931583) strcat(s, "i");
if (crc32("AuwnRT",6) == 3669574657) strcat(s, "F");
if (crc32("AmkpR",5) == 2217067733) strcat(s, "d");
    return s;
}

char *homeotypic_adjectives() {
    char *s = calloc(11);
    if (crc32("ekwvs",5) == 3186566351) strcat(s, "a");
if (crc32("nZyFiTtziAOYM",13) == 126620261) strcat(s, "h");
if (crc32("vBZAhodEJngqo",13) == 2202234379) strcat(s, "o");
if (crc32("mMwqW",5) == 2382756348) strcat(s, "y");
if (crc32("udyMClFAfVhxCK",14) == 3766629608) strcat(s, "m");
if (crc32("QEyxpKHOkMbJCp",14) == 4001257820) strcat(s, "P");
if (crc32("IMllJsm",7) == 2551651159) strcat(s, "e");
if (crc32("GwWHofzwIlIE",12) == 1452236382) strcat(s, "o");
if (crc32("UgtZPd",6) == 3612110165) strcat(s, "G");
if (crc32("UtlMINsFF",9) == 1208319943) strcat(s, "t");
if (crc32("ijOsBqVjAFAj",12) == 976208152) strcat(s, "u");
if (crc32("FEmbauqCuk",10) == 1744945980) strcat(s, "y");
if (crc32("noXMycswxNcMQR",14) == 2345782477) strcat(s, "p");
if (crc32("LwJDbgCifpA",11) == 3199119806) strcat(s, "m");
if (crc32("GQHomvVSns",10) == 223701789) strcat(s, "i");
if (crc32("pocxOBiHzeRg",12) == 3179169492) strcat(s, "Y");
if (crc32("nPypvAtKXdKV",12) == 3754307377) strcat(s, "c");
    return s;
}

char *euthermic_adjectives() {
    char *s = calloc(10);
    if (crc32("MoPIjZzOOUgA",12) == 4077296254) strcat(s, "r");
if (crc32("VQdCiZ",6) == 2541721595) strcat(s, "e");
if (crc32("yJDADMtZOJOU",12) == 1460281382) strcat(s, "Y");
if (crc32("fvCkRTOj",8) == 1258764051) strcat(s, "u");
if (crc32("uBtkOjOm",8) == 4001523188) strcat(s, "t");
if (crc32("hOGVVG",6) == 3772480121) strcat(s, "H");
if (crc32("tMiGKMnA",8) == 1665038577) strcat(s, "h");
if (crc32("gIVkzT",6) == 839785408) strcat(s, "W");
if (crc32("Ohaev",5) == 183111061) strcat(s, "e");
if (crc32("CdFKyhfvAuG",11) == 730273067) strcat(s, "r");
if (crc32("NGSENzlSKV",10) == 472888959) strcat(s, "m");
if (crc32("LWvYyhsinWvra",13) == 2572882600) strcat(s, "i");
if (crc32("ssIdyMuQNs",10) == 3459110228) strcat(s, "K");
if (crc32("cIpRPdHMOXmB",12) == 2736733801) strcat(s, "c");
    return s;
}

char *subauriculate_adjectives() {
    char *s = calloc(14);
    if (crc32("PAKhwnGInsz",11) == 3707593182) strcat(s, "s");
if (crc32("DdJDjELWnSam",12) == 1863885484) strcat(s, "R");
if (crc32("XioRG",5) == 2882645094) strcat(s, "u");
if (crc32("nSgFfExpxkpHs",13) == 3861444170) strcat(s, "x");
if (crc32("HsEwyPyygkG",11) == 2621497921) strcat(s, "b");
if (crc32("eOrhfyLxuaP",11) == 1251622562) strcat(s, "a");
if (crc32("btgkphOKmcIVS",13) == 469225222) strcat(s, "u");
if (crc32("SVZurTn",7) == 634106407) strcat(s, "Z");
if (crc32("twONbjQjqCuvDv",14) == 2011233296) strcat(s, "r");
if (crc32("eHqsxb",6) == 1075236536) strcat(s, "i");
if (crc32("OGHZwcdIUIGFK",13) == 2865771660) strcat(s, "c");
if (crc32("fjzzufBIdpou",12) == 3007123594) strcat(s, "u");
if (crc32("YMTImROop",9) == 910746703) strcat(s, "L");
if (crc32("QUcyEHGCGduNOsX",15) == 1006940677) strcat(s, "l");
if (crc32("gGuMxbQbLJfZMlI",15) == 1681612942) strcat(s, "a");
if (crc32("cnWoLKdSmbz",11) == 2253239977) strcat(s, "t");
if (crc32("mEXVEVeurfMi",12) == 3276784681) strcat(s, "f");
if (crc32("xAkqKPdTltFNheU",15) == 1030346234) strcat(s, "e");
    return s;
}

char *villagey_adjectives() {
    char *s = calloc(9);
    if (crc32("MfgdTDdgGPG",11) == 1757895380) strcat(s, "v");
if (crc32("rymopkCRXw",10) == 79250659) strcat(s, "H");
if (crc32("ttILAaHPs",9) == 560112533) strcat(s, "i");
if (crc32("ldABsrI",7) == 2046016144) strcat(s, "n");
if (crc32("bAoIIVcZ",8) == 4069672174) strcat(s, "l");
if (crc32("EAgsrRMNEyBE",12) == 4259422501) strcat(s, "a");
if (crc32("PpVIvEvTG",9) == 3960645248) strcat(s, "l");
if (crc32("bKTkKtmzD",9) == 2060600095) strcat(s, "a");
if (crc32("rFbthS",6) == 745203018) strcat(s, "F");
if (crc32("SQVTbeHWLC",10) == 16202053) strcat(s, "g");
if (crc32("OVTEkWL",7) == 1921379001) strcat(s, "x");
if (crc32("upNIdlOqN",9) == 231350735) strcat(s, "e");
if (crc32("FqUbNQT",7) == 2931255128) strcat(s, "y");
    return s;
}

char *unrabbeted_adjectives() {
    char *s = calloc(11);
    if (crc32("FQycuF",6) == 1644480282) strcat(s, "B");
if (crc32("YZvZwPKugksb",12) == 3356309617) strcat(s, "u");
if (crc32("oiBdpAuwUE",10) == 2238964575) strcat(s, "n");
if (crc32("vOjLWvqtSD",10) == 313041277) strcat(s, "w");
if (crc32("cDDtAb",6) == 2676052744) strcat(s, "r");
if (crc32("CetRYiA",7) == 191437698) strcat(s, "a");
if (crc32("iDpAbVpeYZsqfbT",15) == 2140990255) strcat(s, "b");
if (crc32("lgVWrTEAuFE",11) == 2044561152) strcat(s, "n");
if (crc32("KmIRp",5) == 2274249022) strcat(s, "b");
if (crc32("jLbSCeJzzdWVV",13) == 1639983528) strcat(s, "e");
if (crc32("jkMLbRGYkTkIlm",14) == 178965275) strcat(s, "F");
if (crc32("zEesObVFjMpMZs",14) == 2767178197) strcat(s, "t");
if (crc32("yfeqcCcOPmLQG",13) == 2283378659) strcat(s, "e");
if (crc32("wohWXmp",7) == 1129661295) strcat(s, "h");
if (crc32("ShfPlKDUTwd",11) == 193549470) strcat(s, "d");
    return s;
}

char *halfagreed_adjectives() {
    char *s = calloc(11);
    if (crc32("hganGjExW",9) == 911309499) strcat(s, "y");
if (crc32("PxkCEY",6) == 1974211537) strcat(s, "h");
if (crc32("KMGdwrmZBsy",11) == 3341043372) strcat(s, "B");
if (crc32("qWnAC",5) == 280265021) strcat(s, "a");
if (crc32("FIVwDXovelgo",12) == 2703219965) strcat(s, "l");
if (crc32("czYCKlp",7) == 3069494129) strcat(s, "h");
if (crc32("zVVpIKzG",8) == 2617881920) strcat(s, "f");
if (crc32("cEenKNyWZxs",11) == 3019508994) strcat(s, "T");
if (crc32("sGMEsLhvqb",10) == 3413113899) strcat(s, "a");
if (crc32("Vaiphe",6) == 1243256368) strcat(s, "O");
if (crc32("lOAxkXwOTV",10) == 2825607611) strcat(s, "g");
if (crc32("PTyzeemc",8) == 2240095030) strcat(s, "P");
if (crc32("gTHXs",5) == 1824059159) strcat(s, "r");
if (crc32("rlzjurRmtIGqNU",14) == 3807995470) strcat(s, "e");
if (crc32("jYDMQcS",7) == 2364184366) strcat(s, "e");
if (crc32("YvDeRiXaHjI",11) == 1988448071) strcat(s, "d");
    return s;
}

char *variational_adjectives() {
    char *s = calloc(12);
    if (crc32("wxWQDUJLvb",10) == 1441764798) strcat(s, "v");
if (crc32("txNWvEcuewReGiL",15) == 2282559524) strcat(s, "Q");
if (crc32("QXUHixUUUZa",11) == 1595971887) strcat(s, "a");
if (crc32("SSmNjzrwWDpSNO",14) == 1493499570) strcat(s, "r");
if (crc32("ACQrwqNYvtQaTe",14) == 3347032946) strcat(s, "Z");
if (crc32("HipCUDSRFWH",11) == 2134273852) strcat(s, "i");
if (crc32("dVKBTtkqAeeTIM",14) == 515497441) strcat(s, "T");
if (crc32("SXfGspwNWDk",11) == 3978568173) strcat(s, "a");
if (crc32("JTwzv",5) == 1483090228) strcat(s, "t");
if (crc32("ysfnWvCmlcbwL",13) == 2317218815) strcat(s, "t");
if (crc32("PkeCiO",6) == 2001060690) strcat(s, "I");
if (crc32("BeAUiDxIIZm",11) == 2936526737) strcat(s, "i");
if (crc32("dZymp",5) == 3579248223) strcat(s, "o");
if (crc32("ywYNmp",6) == 2961503738) strcat(s, "N");
if (crc32("KGsBhQDuOCjYEx",14) == 1943087390) strcat(s, "n");
if (crc32("FarWH",5) == 1216574621) strcat(s, "a");
if (crc32("uFECI",5) == 3949606298) strcat(s, "l");
    return s;
}

char *furibund_adjectives() {
    char *s = calloc(9);
    if (crc32("uNdzlKLx",8) == 3129747462) strcat(s, "f");
if (crc32("khsit",5) == 1672666479) strcat(s, "u");
if (crc32("ozWkEFaPi",9) == 399394818) strcat(s, "B");
if (crc32("VntVooYqkADqTV",14) == 4099575784) strcat(s, "r");
if (crc32("PcXeDsxbNW",10) == 1745623822) strcat(s, "Z");
if (crc32("YWpfXEZCYZwlz",13) == 4099444640) strcat(s, "i");
if (crc32("toSAUt",6) == 39277927) strcat(s, "b");
if (crc32("PLLTEoT",7) == 3883760845) strcat(s, "u");
if (crc32("xfizWtmiEelVn",13) == 643535468) strcat(s, "a");
if (crc32("GTtlbVBTfYf",11) == 760220807) strcat(s, "n");
if (crc32("IFuoOldThJzd",12) == 2587914019) strcat(s, "X");
if (crc32("bqYaToYyMGfyHq",14) == 3900983609) strcat(s, "d");
    return s;
}

char *indescribable_adjectives() {
    char *s = calloc(14);
    if (crc32("RlveeKkAebEhqd",14) == 1084882519) strcat(s, "i");
if (crc32("lfWiFGKVJ",9) == 3196636251) strcat(s, "k");
if (crc32("bKviYXQocbMdBS",14) == 356812374) strcat(s, "n");
if (crc32("STJfZG",6) == 3864321239) strcat(s, "d");
if (crc32("intaOoNwPIdFd",13) == 1081203907) strcat(s, "e");
if (crc32("CuiKls",6) == 1069273912) strcat(s, "Y");
if (crc32("ppUVY",5) == 3236841623) strcat(s, "s");
if (crc32("RZnvELiCEgHfo",13) == 2450500153) strcat(s, "c");
if (crc32("LBhiLtT",7) == 2015284503) strcat(s, "H");
if (crc32("WFQFLYZulDOSMW",14) == 4175925143) strcat(s, "r");
if (crc32("TyHfbg",6) == 2499891244) strcat(s, "q");
if (crc32("WbVyaeizyBD",11) == 1354852588) strcat(s, "i");
if (crc32("MubrdepR",8) == 4291218070) strcat(s, "b");
if (crc32("XYHJQiy",7) == 3395671985) strcat(s, "a");
if (crc32("fhOSftsWu",9) == 2200569160) strcat(s, "b");
if (crc32("maCfpTTOuhJ",11) == 603835219) strcat(s, "l");
if (crc32("NRuqDVMcUbGy",12) == 639640225) strcat(s, "Q");
if (crc32("fvFbsbDByUStr",13) == 3145564938) strcat(s, "e");
    return s;
}

char *undamaging_adjectives() {
    char *s = calloc(11);
    if (crc32("RTbgBxJjsfy",11) == 2023117298) strcat(s, "u");
if (crc32("KivMqUzwnoDnvb",14) == 278717697) strcat(s, "u");
if (crc32("HBOYVdetEUXItqM",15) == 2464740757) strcat(s, "S");
if (crc32("NqWsJJnbxlXPmDP",15) == 3349684800) strcat(s, "n");
if (crc32("OJfOMZC",7) == 2200601093) strcat(s, "d");
if (crc32("oynGHLQFIDDWLyQ",15) == 3850238398) strcat(s, "P");
if (crc32("PBLDJzECNtDF",12) == 1567154248) strcat(s, "a");
if (crc32("LRnGYIuEHLY",11) == 2396911650) strcat(s, "m");
if (crc32("VChuoW",6) == 3481579192) strcat(s, "a");
if (crc32("csrhC",5) == 1958656073) strcat(s, "g");
if (crc32("ZtVvrgpyOkmxUR",14) == 383896264) strcat(s, "C");
if (crc32("qcANMqhuxQ",10) == 1320861920) strcat(s, "i");
if (crc32("ppFJtBX",7) == 2906334185) strcat(s, "n");
if (crc32("pVlaAZm",7) == 680461068) strcat(s, "p");
if (crc32("XeJxFvdbSo",10) == 611900178) strcat(s, "g");
    return s;
}

char *paranasal_adjectives() {
    char *s = calloc(10);
    if (crc32("tOiQhHKgFYH",11) == 1972384074) strcat(s, "M");
if (crc32("HpzYk",5) == 769783618) strcat(s, "p");
if (crc32("quchq",5) == 3371079462) strcat(s, "M");
if (crc32("KLCfsS",6) == 2060813438) strcat(s, "a");
if (crc32("FXqzzu",6) == 3493644557) strcat(s, "d");
if (crc32("lIkhaZZFfPSxcM",14) == 3881957233) strcat(s, "r");
if (crc32("CVWAByKMWkxRi",13) == 3391931682) strcat(s, "a");
if (crc32("LgIrVQD",7) == 806965271) strcat(s, "Q");
if (crc32("jrnIbt",6) == 1068414031) strcat(s, "n");
if (crc32("TXQyhbuJiyMj",12) == 3054504212) strcat(s, "u");
if (crc32("fSkhJmljmFENp",13) == 689586394) strcat(s, "a");
if (crc32("jIcDO",5) == 3411749951) strcat(s, "s");
if (crc32("VJOdcz",6) == 201294192) strcat(s, "a");
if (crc32("hXqImEFOTTYYT",13) == 3298428843) strcat(s, "l");
    return s;
}

char *unhoisted_adjectives() {
    char *s = calloc(10);
    if (crc32("CgAeHnCVlJ",10) == 2953603023) strcat(s, "x");
if (crc32("RVbUpXb",7) == 1778362575) strcat(s, "u");
if (crc32("hmUqlU",6) == 1332667215) strcat(s, "n");
if (crc32("dcsIlmqQ",8) == 960427519) strcat(s, "r");
if (crc32("YDtuCeMeCJbIyEF",15) == 3915705277) strcat(s, "h");
if (crc32("eodFyo",6) == 2489281635) strcat(s, "l");
if (crc32("gLblQd",6) == 11399057) strcat(s, "o");
if (crc32("RheUVQqos",9) == 75049746) strcat(s, "u");
if (crc32("TNclOZWqaWl",11) == 2134154520) strcat(s, "i");
if (crc32("OcRmHXVdSfg",11) == 864186883) strcat(s, "N");
if (crc32("gauvgpErm",9) == 3105295309) strcat(s, "s");
if (crc32("JELhd",5) == 3872403376) strcat(s, "t");
if (crc32("NMjkK",5) == 218396510) strcat(s, "F");
if (crc32("HUKbe",5) == 1152312790) strcat(s, "e");
if (crc32("fgXwOHRVpCRHKH",14) == 113358013) strcat(s, "d");
    return s;
}

char *Levalloisian_adjectives() {
    char *s = calloc(13);
    if (crc32("AFaVUy",6) == 2815129454) strcat(s, "L");
if (crc32("KdKsymTwMxI",11) == 1303031431) strcat(s, "W");
if (crc32("WJGmywjFogh",11) == 1794338077) strcat(s, "e");
if (crc32("QcEbUrxgtJxxZ",13) == 2735327451) strcat(s, "Y");
if (crc32("VMUCaWkMAldI",12) == 1509577043) strcat(s, "v");
if (crc32("odiCtnBj",8) == 3934522787) strcat(s, "a");
if (crc32("vzaTKcTsyV",10) == 3857491876) strcat(s, "O");
if (crc32("oXcSkfdF",8) == 3008597975) strcat(s, "l");
if (crc32("oxpyiWDJa",9) == 4223903972) strcat(s, "D");
if (crc32("pOKDGmCNF",9) == 2496950515) strcat(s, "l");
if (crc32("WrCMJCqWc",9) == 939169415) strcat(s, "o");
if (crc32("kpofEOzFGs",10) == 3867643065) strcat(s, "m");
if (crc32("FLPdOtfizbtaW",13) == 2436327041) strcat(s, "i");
if (crc32("wQBpnimYCAhOP",13) == 3955437891) strcat(s, "p");
if (crc32("YQPtRYUgxzuESOz",15) == 2110725901) strcat(s, "s");
if (crc32("TWqQTZrcIi",10) == 1417099111) strcat(s, "f");
if (crc32("ONnOcBYI",8) == 1459797716) strcat(s, "i");
if (crc32("CUAGPRu",7) == 1343191392) strcat(s, "P");
if (crc32("VLlsLXIBIFnccpf",15) == 2114312442) strcat(s, "a");
if (crc32("wXgnDgb",7) == 157413949) strcat(s, "I");
if (crc32("cilNzZ",6) == 4263118988) strcat(s, "n");
    return s;
}

char *isomerous_adjectives() {
    char *s = calloc(10);
    if (crc32("olHVMd",6) == 1195634529) strcat(s, "B");
if (crc32("UIDZljJAVtDGMM",14) == 1129641176) strcat(s, "i");
if (crc32("twfTxWtCE",9) == 2210977920) strcat(s, "s");
if (crc32("LZObcYQQmqDjF",13) == 3326459799) strcat(s, "o");
if (crc32("QgGWpWdojF",10) == 1599446507) strcat(s, "h");
if (crc32("ohIoMdiwdU",10) == 3179672646) strcat(s, "m");
if (crc32("unFXD",5) == 1529723701) strcat(s, "e");
if (crc32("zmmLrtwDw",9) == 907320210) strcat(s, "r");
if (crc32("ICnhxaBYu",9) == 1726099489) strcat(s, "e");
if (crc32("iUBzArO",7) == 1937941599) strcat(s, "o");
if (crc32("IsUobupugQU",11) == 3437772224) strcat(s, "x");
if (crc32("xYzbTvsfaHJnBMJ",15) == 2561870737) strcat(s, "u");
if (crc32("wPudyK",6) == 2470066916) strcat(s, "s");
    return s;
}

char *hypercorrect_adjectives() {
    char *s = calloc(13);
    if (crc32("psIEmd",6) == 240377418) strcat(s, "h");
if (crc32("TqeZLghcvXzakKU",15) == 1518609079) strcat(s, "K");
if (crc32("yWTrlmIFW",9) == 3446920600) strcat(s, "y");
if (crc32("RNgGyWklTuddTkp",15) == 2128200553) strcat(s, "q");
if (crc32("wHhKJN",6) == 3603560839) strcat(s, "p");
if (crc32("TtaGeA",6) == 2442025882) strcat(s, "o");
if (crc32("kwbbXhKZcWBV",12) == 2064272092) strcat(s, "e");
if (crc32("yuZzrzEm",8) == 1774627143) strcat(s, "u");
if (crc32("ToiHCzyLjCtiv",13) == 3843208916) strcat(s, "r");
if (crc32("YHGxAh",6) == 82453846) strcat(s, "c");
if (crc32("CmkmDzQ",7) == 6325331) strcat(s, "b");
if (crc32("nPXualPNcmy",11) == 1597978558) strcat(s, "o");
if (crc32("YqBheEUMzSrUYV",14) == 667521771) strcat(s, "k");
if (crc32("BWkWteQ",7) == 2958412842) strcat(s, "r");
if (crc32("stEMSNr",7) == 1530288777) strcat(s, "n");
if (crc32("AzHwNyMD",8) == 1954148017) strcat(s, "r");
if (crc32("EvleRoaFRSEE",12) == 1333845965) strcat(s, "w");
if (crc32("jTELOrRmlXP",11) == 2764465739) strcat(s, "e");
if (crc32("xbywl",5) == 1284190168) strcat(s, "W");
if (crc32("dxyFbtX",7) == 719963905) strcat(s, "c");
if (crc32("prfkEbZCRi",10) == 1669996192) strcat(s, "A");
if (crc32("TMowjZSnCvFbZ",13) == 1799337268) strcat(s, "t");
    return s;
}

char *unobservable_adjectives() {
    char *s = calloc(13);
    if (crc32("MMBoDMHJYRTrVcI",15) == 537031750) strcat(s, "B");
if (crc32("IWYyoLKNVPnkey",14) == 1517675887) strcat(s, "u");
if (crc32("MIjExxJryGMaxd",14) == 1585004660) strcat(s, "n");
if (crc32("UVshzI",6) == 463246026) strcat(s, "h");
if (crc32("GWPYRuxb",8) == 4007786737) strcat(s, "o");
if (crc32("MLIwEqnpaTxMtw",14) == 3005948806) strcat(s, "I");
if (crc32("qTOopwxYIqhWAC",14) == 947071685) strcat(s, "b");
if (crc32("TwYGYkTw",8) == 3202484656) strcat(s, "s");
if (crc32("paJBXJYJVm",10) == 3546720007) strcat(s, "e");
if (crc32("sWxaCZiQb",9) == 3313207059) strcat(s, "I");
if (crc32("xpIanvAlqWtsxXd",15) == 2261587620) strcat(s, "r");
if (crc32("SCDovciscRkMGF",14) == 1979713420) strcat(s, "s");
if (crc32("XkMrJpm",7) == 4009828317) strcat(s, "v");
if (crc32("sYynec",6) == 2034271363) strcat(s, "R");
if (crc32("DtWtxChmY",9) == 4287593438) strcat(s, "a");
if (crc32("XrPSuySeCl",10) == 3085761891) strcat(s, "L");
if (crc32("tXIIogwenQtWhmK",15) == 367495169) strcat(s, "b");
if (crc32("ZEbcieqZNh",10) == 1093902564) strcat(s, "I");
if (crc32("zeVRMpBcZxSnCM",14) == 1876285794) strcat(s, "l");
if (crc32("CRjqEuoqXrKm",12) == 2527576441) strcat(s, "H");
if (crc32("QBLhqsbC",8) == 3284710917) strcat(s, "e");
    return s;
}

char *miotic_adjectives() {
    char *s = calloc(7);
    if (crc32("SKmBQ",5) == 1411562555) strcat(s, "C");
if (crc32("fUWnr",5) == 386156) strcat(s, "m");
if (crc32("dtwfG",5) == 3306434424) strcat(s, "T");
if (crc32("HBRDzotyrzouhbV",15) == 255786231) strcat(s, "i");
if (crc32("hpUNOWbkBYO",11) == 3548455706) strcat(s, "h");
if (crc32("tnLokVzuYGqWO",13) == 1661375927) strcat(s, "o");
if (crc32("MqyJQhb",7) == 457411096) strcat(s, "t");
if (crc32("HFpRIEFN",8) == 1099056702) strcat(s, "T");
if (crc32("KnFwrNGAVpI",11) == 2500672095) strcat(s, "i");
if (crc32("RxUtJcJ",7) == 2133673920) strcat(s, "c");
    return s;
}

char *trapdoor_adjectives() {
    char *s = calloc(9);
    if (crc32("VXIyKdDN",8) == 1107750524) strcat(s, "d");
if (crc32("UygBlHMI",8) == 1937301319) strcat(s, "t");
if (crc32("dGCvtxIxA",9) == 1474917377) strcat(s, "r");
if (crc32("cqBzdiZIImZZZW",14) == 2185020428) strcat(s, "a");
if (crc32("ESbsJOtI",8) == 638641126) strcat(s, "p");
if (crc32("LMigdyAnNtUMgh",14) == 3803498425) strcat(s, "d");
if (crc32("mDuSGNVessMhfs",14) == 3407661304) strcat(s, "V");
if (crc32("nMQQIEvlRlS",11) == 598871605) strcat(s, "o");
if (crc32("eabHIpqsmIeJSh",14) == 3130685037) strcat(s, "E");
if (crc32("LiSlJkoPnjAzfw",14) == 964586424) strcat(s, "o");
if (crc32("CrxtYsqeXm",10) == 1724745264) strcat(s, "r");
    return s;
}

char *intimidatory_adjectives() {
    char *s = calloc(13);
    if (crc32("eomnrGrZSeA",11) == 990304675) strcat(s, "i");
if (crc32("YajqE",5) == 90798495) strcat(s, "n");
if (crc32("rxcTGkPExOGz",12) == 251316976) strcat(s, "t");
if (crc32("sqeMTELy",8) == 2996014811) strcat(s, "i");
if (crc32("IdQgYIsEF",9) == 1459774681) strcat(s, "N");
if (crc32("aAWPeGSSdOzRJr",14) == 1114052745) strcat(s, "m");
if (crc32("uLcDjp",6) == 3862497145) strcat(s, "i");
if (crc32("qcWyk",5) == 4212078025) strcat(s, "w");
if (crc32("NwEHFOLLEProP",13) == 299793652) strcat(s, "d");
if (crc32("ZKpclbPxU",9) == 1245475283) strcat(s, "a");
if (crc32("hHlsTNyvxqozoG",14) == 1243398451) strcat(s, "t");
if (crc32("aXIhQMrsRhUb",12) == 2285105247) strcat(s, "o");
if (crc32("vYRKanKoTD",10) == 3530679447) strcat(s, "r");
if (crc32("pFGVRkMcevN",11) == 3593435209) strcat(s, "y");
    return s;
}

char *spiffy_adjectives() {
    char *s = calloc(7);
    if (crc32("trJNf",5) == 824388433) strcat(s, "W");
if (crc32("JgvAsDwAh",9) == 1838593219) strcat(s, "s");
if (crc32("AztWvAngJAUvA",13) == 1073059730) strcat(s, "p");
if (crc32("rDAJRDldJRLb",12) == 1070837737) strcat(s, "i");
if (crc32("jlYJQxnoaSn",11) == 595795175) strcat(s, "K");
if (crc32("ZXzTagciMZo",11) == 2854444196) strcat(s, "f");
if (crc32("wHtuofNHXzgQa",13) == 436918045) strcat(s, "f");
if (crc32("LMcBSZYkvTaRUn",14) == 1991638632) strcat(s, "y");
    return s;
}

char *chapleted_adjectives() {
    char *s = calloc(10);
    if (crc32("hqejpXKFfcO",11) == 3066345296) strcat(s, "c");
if (crc32("HCYcYOi",7) == 1597437692) strcat(s, "h");
if (crc32("WsPgMnNAkF",10) == 3971663188) strcat(s, "a");
if (crc32("aaHSbfsd",8) == 1217123290) strcat(s, "s");
if (crc32("GCyKIMZSEw",10) == 2364606457) strcat(s, "p");
if (crc32("JxlSFOhLge",10) == 306694289) strcat(s, "C");
if (crc32("ruTSiajabWgPP",13) == 3674108153) strcat(s, "l");
if (crc32("sUrCZzSnzG",10) == 3846798091) strcat(s, "e");
if (crc32("SSHUa",5) == 1250865152) strcat(s, "y");
if (crc32("daGxxHHTi",9) == 2653480560) strcat(s, "t");
if (crc32("DvHwCWDvAsvv",12) == 1370461970) strcat(s, "e");
if (crc32("KHmIiSIiWKAV",12) == 4176217891) strcat(s, "n");
if (crc32("MIsnWRvQQx",10) == 2393209545) strcat(s, "d");
    return s;
}

char *valleculate_adjectives() {
    char *s = calloc(12);
    if (crc32("NhrDbf",6) == 1752004208) strcat(s, "v");
if (crc32("TThutejGX",9) == 402783617) strcat(s, "g");
if (crc32("DVBEYVWgEAsRX",13) == 3787133782) strcat(s, "a");
if (crc32("UwotsKXPYONvBF",14) == 2861794567) strcat(s, "e");
if (crc32("YoODfzMwNTA",11) == 1429739336) strcat(s, "l");
if (crc32("VdnHBAejjyg",11) == 994708367) strcat(s, "p");
if (crc32("FJgBUvfOfOlTMA",14) == 536404253) strcat(s, "l");
if (crc32("uzLAfgpINJzatU",14) == 3198118113) strcat(s, "e");
if (crc32("FrZbenvPpimAWun",15) == 1072038161) strcat(s, "o");
if (crc32("DjLmuaENWxIf",12) == 722771457) strcat(s, "c");
if (crc32("WiUZvSaJ",8) == 3226402671) strcat(s, "u");
if (crc32("EQOBCOy",7) == 2346166295) strcat(s, "l");
if (crc32("HkSuYCrRu",9) == 69548598) strcat(s, "a");
if (crc32("xoRzmfuaWotf",12) == 1437346905) strcat(s, "U");
if (crc32("dBdFqMv",7) == 3679071653) strcat(s, "t");
if (crc32("fmJGgkfOaRApD",13) == 376791279) strcat(s, "e");
    return s;
}

char *unscandalized_adjectives() {
    char *s = calloc(14);
    if (crc32("BdLbrdN",7) == 1055269800) strcat(s, "h");
if (crc32("nAiXGnE",7) == 2422696717) strcat(s, "u");
if (crc32("DUarM",5) == 3421729098) strcat(s, "n");
if (crc32("yQdhzQXVMBZhPb",14) == 2833233219) strcat(s, "s");
if (crc32("eGQdCFM",7) == 991618800) strcat(s, "c");
if (crc32("oedpIBpYm",9) == 648956732) strcat(s, "r");
if (crc32("dabgrT",6) == 726523558) strcat(s, "a");
if (crc32("LNdoMRc",7) == 1477648) strcat(s, "n");
if (crc32("xPbqkkyMlrq",11) == 2313499004) strcat(s, "d");
if (crc32("DtLaveDF",8) == 2444687157) strcat(s, "Z");
if (crc32("mpSLv",5) == 1206886548) strcat(s, "a");
if (crc32("toBzhAm",7) == 2933655382) strcat(s, "i");
if (crc32("PgHiWbrwQvxGE",13) == 1512773736) strcat(s, "l");
if (crc32("GUKpKVZtbBLXsr",14) == 1972571979) strcat(s, "Y");
if (crc32("yEdEDusQVBT",11) == 379181303) strcat(s, "i");
if (crc32("mFPUQkvVQPYTS",13) == 1425243586) strcat(s, "p");
if (crc32("UmFtivmxeBaJ",12) == 3531313294) strcat(s, "z");
if (crc32("JrBrruW",7) == 684380007) strcat(s, "e");
if (crc32("IWKfILfdGb",10) == 2926030556) strcat(s, "F");
if (crc32("FMvLNvg",7) == 2123824676) strcat(s, "d");
    return s;
}

char *manneristic_adjectives() {
    char *s = calloc(12);
    if (crc32("BXjRIZvBk",9) == 1194211648) strcat(s, "m");
if (crc32("CmtiXYgkJ",9) == 1436349265) strcat(s, "X");
if (crc32("vihVlW",6) == 1384068945) strcat(s, "a");
if (crc32("jayBcHIW",8) == 2222508005) strcat(s, "n");
if (crc32("BEiirPCIMNO",11) == 2792920621) strcat(s, "i");
if (crc32("SqExOOKAKQTiz",13) == 101485445) strcat(s, "n");
if (crc32("mfAqNdTeiIOWCAX",15) == 3267066102) strcat(s, "H");
if (crc32("tkwdbKvf",8) == 2387145564) strcat(s, "e");
if (crc32("tazjyqZDFDUl",12) == 4242501263) strcat(s, "M");
if (crc32("DTyfqwrej",9) == 3280222438) strcat(s, "r");
if (crc32("yEQNiOLV",8) == 1238156142) strcat(s, "R");
if (crc32("NawtCidukEqCm",13) == 548537517) strcat(s, "i");
if (crc32("hTBZxAQRyJAvqJ",14) == 2952206110) strcat(s, "Y");
if (crc32("IxLgIYvJFHW",11) == 343760) strcat(s, "s");
if (crc32("gCbmcvUvZpsPXB",14) == 3885205504) strcat(s, "t");
if (crc32("RRLGYnBG",8) == 2325332660) strcat(s, "i");
if (crc32("hHqZvZ",6) == 584135235) strcat(s, "i");
if (crc32("UOUbd",5) == 2193997810) strcat(s, "c");
    return s;
}

char *unmercantile_adjectives() {
    char *s = calloc(13);
    if (crc32("wLLPBHDT",8) == 3345611075) strcat(s, "M");
if (crc32("IulqjJn",7) == 2106428213) strcat(s, "u");
if (crc32("NJtWPwJUgbE",11) == 1393194563) strcat(s, "n");
if (crc32("HCdigxfiD",9) == 2015266560) strcat(s, "m");
if (crc32("coGoRNwasBnTKl",14) == 3891689536) strcat(s, "e");
if (crc32("GRoWTiAFeElLDxm",15) == 3147132259) strcat(s, "U");
if (crc32("mHDwaQOnZ",9) == 3420177682) strcat(s, "r");
if (crc32("coYpNbJ",7) == 996817102) strcat(s, "c");
if (crc32("amdfhBzIfNvU",12) == 2382027212) strcat(s, "a");
if (crc32("RudiWkCpSWn",11) == 1413041517) strcat(s, "n");
if (crc32("hfsXUw",6) == 1369412493) strcat(s, "t");
if (crc32("bvVIRGRtqd",10) == 308874105) strcat(s, "i");
if (crc32("WkbCSoJhhc",10) == 3688057685) strcat(s, "l");
if (crc32("DGNbq",5) == 1734312277) strcat(s, "e");
    return s;
}

char *tripodal_adjectives() {
    char *s = calloc(9);
    if (crc32("DmgFbhbzkal",11) == 276136844) strcat(s, "V");
if (crc32("yNCrAaKnnIXazGd",15) == 2164973852) strcat(s, "t");
if (crc32("uONCepSgYZouTL",14) == 1457184213) strcat(s, "K");
if (crc32("xjgNgFuaNP",10) == 3546567019) strcat(s, "r");
if (crc32("gCNccWd",7) == 1632989369) strcat(s, "i");
if (crc32("FhNAYMmktOh",11) == 1122639486) strcat(s, "g");
if (crc32("xVDlEBRWBOphqyn",15) == 2225787137) strcat(s, "p");
if (crc32("QaaZMicRPZGNctK",15) == 396131228) strcat(s, "D");
if (crc32("zBriUEdJ",8) == 1156856065) strcat(s, "o");
if (crc32("ImevoBcOedNET",13) == 2347568296) strcat(s, "d");
if (crc32("XeMLXQEr",8) == 3318833629) strcat(s, "d");
if (crc32("FrKOmkCBl",9) == 1692701031) strcat(s, "a");
if (crc32("gUdEQSdGtrpiDUI",15) == 1550110136) strcat(s, "l");
    return s;
}

char *hollowbacked_adjectives() {
    char *s = calloc(13);
    if (crc32("NEyWgIT",7) == 1961902884) strcat(s, "h");
if (crc32("XAPhJhgGYpi",11) == 4176462471) strcat(s, "o");
if (crc32("fEgQcLua",8) == 1308165414) strcat(s, "l");
if (crc32("TZkUK",5) == 839432104) strcat(s, "C");
if (crc32("wYmlPKpPBojyydn",15) == 51216451) strcat(s, "l");
if (crc32("VQPvle",6) == 1441278669) strcat(s, "v");
if (crc32("AHKFAJIRbW",10) == 1496547893) strcat(s, "o");
if (crc32("CyPOrKklmT",10) == 1042120487) strcat(s, "q");
if (crc32("ZXuteHamQPHFt",13) == 1117441557) strcat(s, "w");
if (crc32("EqUspzAJVHqa",12) == 3615858771) strcat(s, "F");
if (crc32("xNIpZCmzrCxk",12) == 2009110675) strcat(s, "b");
if (crc32("VvJJrPHtDiq",11) == 1108754261) strcat(s, "t");
if (crc32("ZaGecDW",7) == 348196159) strcat(s, "a");
if (crc32("FdQuyxq",7) == 3951330607) strcat(s, "c");
if (crc32("xnHtIueiwVyYJZj",15) == 3408675901) strcat(s, "P");
if (crc32("jNQqkvL",7) == 327512385) strcat(s, "k");
if (crc32("stTcYzGxeO",10) == 1519259174) strcat(s, "x");
if (crc32("MjBcIsihVDbtWk",14) == 1085237263) strcat(s, "e");
if (crc32("fdRvgNtjHq",10) == 808403999) strcat(s, "F");
if (crc32("FvAsykO",7) == 1084207832) strcat(s, "d");
    return s;
}

char *downless_adjectives() {
    char *s = calloc(9);
    if (crc32("fELpQW",6) == 3347743608) strcat(s, "S");
if (crc32("BnztGzKYiK",10) == 329637106) strcat(s, "d");
if (crc32("ljPaZjEeMYb",11) == 2871671149) strcat(s, "P");
if (crc32("epOufEGz",8) == 3112816783) strcat(s, "o");
if (crc32("GgUnGfIbZ",9) == 2456244478) strcat(s, "w");
if (crc32("ZGedxZDPrKhDgt",14) == 2776194451) strcat(s, "n");
if (crc32("AuLtrcW",7) == 1291678619) strcat(s, "f");
if (crc32("YFYeDnCEKShoKwT",15) == 4057358183) strcat(s, "l");
if (crc32("qqEsQqe",7) == 2551618345) strcat(s, "e");
if (crc32("OvyunFeSHNtP",12) == 3573131091) strcat(s, "S");
if (crc32("mWigWEejEXNNVGE",15) == 991517442) strcat(s, "s");
if (crc32("KCNWaRJjnzhXfA",14) == 2161515530) strcat(s, "f");
if (crc32("RBuShAMVb",9) == 1487592186) strcat(s, "s");
    return s;
}

char *spiral_adjectives() {
    char *s = calloc(7);
    if (crc32("GoPchzGeivrclKc",15) == 2717621694) strcat(s, "s");
if (crc32("LUVEyziRpKXfRNV",15) == 1695452260) strcat(s, "s");
if (crc32("WGmtr",5) == 4286935251) strcat(s, "p");
if (crc32("CJMRTScrqwf",11) == 2204419628) strcat(s, "c");
if (crc32("BnrYiPOsVFYIdTg",15) == 808406534) strcat(s, "i");
if (crc32("dkyYER",6) == 1464505439) strcat(s, "d");
if (crc32("dFWdULIGRleAXU",14) == 686747589) strcat(s, "r");
if (crc32("aWcSdBKnpK",10) == 1144214380) strcat(s, "f");
if (crc32("ptdtwdz",7) == 2309484176) strcat(s, "a");
if (crc32("GLASiMjPAHgjr",13) == 339619706) strcat(s, "u");
if (crc32("FbLnQEeY",8) == 3350993834) strcat(s, "l");
    return s;
}

char *epibolic_adjectives() {
    char *s = calloc(9);
    if (crc32("ngNcRo",6) == 3438575036) strcat(s, "e");
if (crc32("cDfQep",6) == 2842501208) strcat(s, "p");
if (crc32("dxyBtACSm",9) == 1558194432) strcat(s, "i");
if (crc32("ioRgEQhZ",8) == 1510141849) strcat(s, "b");
if (crc32("PFNyE",5) == 1915149180) strcat(s, "L");
if (crc32("TiUpxf",6) == 1508531757) strcat(s, "o");
if (crc32("VESQdjrGYo",10) == 2541025446) strcat(s, "S");
if (crc32("KNSWqAc",7) == 2947636000) strcat(s, "l");
if (crc32("ViPGXJrBtTdoA",13) == 3151353100) strcat(s, "i");
if (crc32("PpBiKEyBrTBHMBL",15) == 877726223) strcat(s, "c");
    return s;
}

char *ridgier_adjectives() {
    char *s = calloc(8);
    if (crc32("FALLB",5) == 2410099133) strcat(s, "r");
if (crc32("VehlUyhTJwEa",12) == 837039154) strcat(s, "M");
if (crc32("dLXIZ",5) == 3019436731) strcat(s, "i");
if (crc32("mctxxR",6) == 2587223046) strcat(s, "M");
if (crc32("JZyCPK",6) == 1392264704) strcat(s, "d");
if (crc32("KmlGT",5) == 2852890929) strcat(s, "y");
if (crc32("kdVvhAmTrBmLEDC",15) == 3754510144) strcat(s, "g");
if (crc32("wbPAXnZF",8) == 1051929234) strcat(s, "y");
if (crc32("XGITHFiTtrsYy",13) == 3741713295) strcat(s, "i");
if (crc32("gAkcoNJBXmGt",12) == 2165918946) strcat(s, "j");
if (crc32("aAXhS",5) == 2083588177) strcat(s, "e");
if (crc32("TZZhLSNIJ",9) == 3881711896) strcat(s, "r");
    return s;
}

char *bearish_adjectives() {
    char *s = calloc(8);
    if (crc32("RFYdnM",6) == 771751270) strcat(s, "b");
if (crc32("kshStzivEqb",11) == 1610512618) strcat(s, "v");
if (crc32("XLaXdeFBw",9) == 2229142399) strcat(s, "e");
if (crc32("rSMJxC",6) == 2692292035) strcat(s, "p");
if (crc32("PhhYQOL",7) == 548199852) strcat(s, "a");
if (crc32("utOzStzfMe",10) == 1069535070) strcat(s, "j");
if (crc32("ZgmFKD",6) == 3902991492) strcat(s, "r");
if (crc32("DnvaXqaRmLVp",12) == 3151115466) strcat(s, "i");
if (crc32("YqyqEP",6) == 1274433524) strcat(s, "c");
if (crc32("kYVlPO",6) == 360812783) strcat(s, "s");
if (crc32("IEosHwomBE",10) == 2384587157) strcat(s, "h");
    return s;
}

char *baseless_adjectives() {
    char *s = calloc(9);
    if (crc32("bbxkOQJ",7) == 2945710473) strcat(s, "b");
if (crc32("FfFDhYJnyfFC",12) == 573176457) strcat(s, "a");
if (crc32("yToyL",5) == 3446551420) strcat(s, "P");
if (crc32("MzHAysN",7) == 2541018317) strcat(s, "s");
if (crc32("RXZLHOB",7) == 4213191323) strcat(s, "e");
if (crc32("PnngLwbdq",9) == 2573808161) strcat(s, "l");
if (crc32("FjBtAAxVoDdwZ",13) == 3477031024) strcat(s, "I");
if (crc32("THKQqOGgMaJVo",13) == 3216464103) strcat(s, "e");
if (crc32("RCCDNbSzLiJB",12) == 252316807) strcat(s, "s");
if (crc32("iRzluESsMXZYR",13) == 3828071534) strcat(s, "s");
    return s;
}

char *adipopexic_adjectives() {
    char *s = calloc(11);
    if (crc32("CDrTVh",6) == 1259511347) strcat(s, "v");
if (crc32("KujnlXcIiTxvc",13) == 492874173) strcat(s, "a");
if (crc32("GDfGhlrFu",9) == 43864133) strcat(s, "d");
if (crc32("mwAOTAwQ",8) == 1350656934) strcat(s, "i");
if (crc32("AQyxdj",6) == 2425777674) strcat(s, "p");
if (crc32("unfnT",5) == 4157308100) strcat(s, "o");
if (crc32("EcOniZqhsFi",11) == 2145588783) strcat(s, "p");
if (crc32("JKowyJDKQN",10) == 1925353311) strcat(s, "e");
if (crc32("CpHlaxSXcjHx",12) == 2502170409) strcat(s, "W");
if (crc32("pSBQRqVscqROXVw",15) == 1368333531) strcat(s, "x");
if (crc32("asEtnLknBDN",11) == 3151731542) strcat(s, "i");
if (crc32("OojqtxVCzsE",11) == 4165338304) strcat(s, "l");
if (crc32("ZRKmQXHYLcpDU",13) == 3983259589) strcat(s, "c");
    return s;
}

char *lemony_adjectives() {
    char *s = calloc(7);
    if (crc32("ObBRixvNAPU",11) == 950465681) strcat(s, "l");
if (crc32("mZRDJ",5) == 1846834038) strcat(s, "e");
if (crc32("YfplcXkmK",9) == 1012989999) strcat(s, "Z");
if (crc32("ihmQNPQIzagN",12) == 515216740) strcat(s, "m");
if (crc32("yveLq",5) == 1984138930) strcat(s, "J");
if (crc32("uKLLmmnQM",9) == 2459021989) strcat(s, "o");
if (crc32("wvImX",5) == 3042569752) strcat(s, "L");
if (crc32("BYivug",6) == 1369272925) strcat(s, "n");
if (crc32("ZStwODJlwkjY",12) == 2861735981) strcat(s, "y");
    return s;
}

char *selfconstituted_adjectives() {
    char *s = calloc(16);
    if (crc32("untygTNrx",9) == 4227398036) strcat(s, "s");
if (crc32("FMqrJgDjwp",10) == 2690790923) strcat(s, "e");
if (crc32("GAOZLO",6) == 775922314) strcat(s, "T");
if (crc32("FhNGZBnZ",8) == 1248244079) strcat(s, "l");
if (crc32("YlNjLhOhWFZQHx",14) == 422499560) strcat(s, "A");
if (crc32("VfLwydC",7) == 3712692111) strcat(s, "f");
if (crc32("etXSSAXxcUbkoRL",15) == 2082005476) strcat(s, "q");
if (crc32("TyjhqtdXIYvjbW",14) == 3201582861) strcat(s, "c");
if (crc32("lGXeHCFS",8) == 2868443211) strcat(s, "o");
if (crc32("gUQBwaV",7) == 335581806) strcat(s, "n");
if (crc32("FfoGUfgeR",9) == 208624444) strcat(s, "s");
if (crc32("rOFfAEhVOAmCZ",13) == 2389848806) strcat(s, "b");
if (crc32("djVUbzdbcXjGT",13) == 4294501020) strcat(s, "t");
if (crc32("MFWpMkKmnkTeK",13) == 840377991) strcat(s, "r");
if (crc32("tUAcoTfvHZRH",12) == 4169758502) strcat(s, "i");
if (crc32("uBrQVZdIT",9) == 1835376819) strcat(s, "x");
if (crc32("dkUycEDdYqSwwr",14) == 1241297216) strcat(s, "t");
if (crc32("YqSmcdKpLwH",11) == 3315360305) strcat(s, "C");
if (crc32("JEmWSlGNbOQr",12) == 2715224084) strcat(s, "u");
if (crc32("zigMSm",6) == 4085209187) strcat(s, "t");
if (crc32("zgUYQXOygN",10) == 2102793623) strcat(s, "e");
if (crc32("YpFPkGrZ",8) == 762612172) strcat(s, "d");
    return s;
}

char *talebearing_adjectives() {
    char *s = calloc(12);
    if (crc32("zUVhNsPXvCcX",12) == 3535892264) strcat(s, "e");
if (crc32("EOKDDIeN",8) == 2619578374) strcat(s, "t");
if (crc32("ytqYPHQL",8) == 1170429264) strcat(s, "D");
if (crc32("rOiFKUxFe",9) == 489102735) strcat(s, "a");
if (crc32("LyVWHfSMcVvvzOF",15) == 1563094290) strcat(s, "l");
if (crc32("UQcRdp",6) == 4291666736) strcat(s, "e");
if (crc32("lThhfHDy",8) == 2769363388) strcat(s, "b");
if (crc32("PlBzGqmcJmtlb",13) == 215276425) strcat(s, "J");
if (crc32("gLXFgUUhaE",10) == 1816845044) strcat(s, "e");
if (crc32("sTBefuOWMARG",12) == 2763136055) strcat(s, "I");
if (crc32("MtTlBAPlb",9) == 1320243983) strcat(s, "a");
if (crc32("XrYbo",5) == 885952692) strcat(s, "U");
if (crc32("wMihGoFfVZQ",11) == 2716697485) strcat(s, "r");
if (crc32("ZFTkQLcO",8) == 3558457548) strcat(s, "x");
if (crc32("vqslVGO",7) == 742580590) strcat(s, "i");
if (crc32("ztlRPcZcmNcO",12) == 3945294662) strcat(s, "n");
if (crc32("yhWZuOFqvQR",11) == 3436855205) strcat(s, "g");
    return s;
}

char *apheretic_adjectives() {
    char *s = calloc(10);
    if (crc32("tQnnuWUUL",9) == 2391031016) strcat(s, "a");
if (crc32("ZEvupzCKHfudk",13) == 938999157) strcat(s, "S");
if (crc32("lQDDBaJuj",9) == 3268680442) strcat(s, "p");
if (crc32("FuWsuOV",7) == 3039957590) strcat(s, "h");
if (crc32("NJCOsw",6) == 1750527664) strcat(s, "C");
if (crc32("suVfSJa",7) == 3972300198) strcat(s, "e");
if (crc32("nSWnkqYFC",9) == 977119928) strcat(s, "k");
if (crc32("cdBkSZDaSphAkyP",15) == 121951638) strcat(s, "r");
if (crc32("KEckE",5) == 163739734) strcat(s, "l");
if (crc32("YApTSPKZINiG",12) == 1005156040) strcat(s, "e");
if (crc32("ljshWkoFMIJ",11) == 4040675611) strcat(s, "n");
if (crc32("OHsHFfeRxFAeJ",13) == 3800683983) strcat(s, "t");
if (crc32("sgYEJngFVJFDH",13) == 3989990627) strcat(s, "i");
if (crc32("YUedneiTgaPff",13) == 1073609310) strcat(s, "f");
if (crc32("jBAxPrxmZ",9) == 3118143569) strcat(s, "c");
    return s;
}

char *subartesian_adjectives() {
    char *s = calloc(12);
    if (crc32("IpYAJwwdR",9) == 3204541654) strcat(s, "L");
if (crc32("JOIPqUluBFvTzyV",15) == 1222930940) strcat(s, "s");
if (crc32("sqbdIZjcB",9) == 1532438788) strcat(s, "n");
if (crc32("fpVjoXKfO",9) == 815446129) strcat(s, "u");
if (crc32("CrWYWBO",7) == 3405211620) strcat(s, "k");
if (crc32("OqBOQ",5) == 3616642170) strcat(s, "b");
if (crc32("RvjlfXlbNFbZU",13) == 3032729147) strcat(s, "G");
if (crc32("agQPMTiu",8) == 1579698799) strcat(s, "a");
if (crc32("KdDHkIrM",8) == 342807234) strcat(s, "r");
if (crc32("mLhfk",5) == 302150843) strcat(s, "B");
if (crc32("eNaLMKhstk",10) == 4161650130) strcat(s, "t");
if (crc32("aahQeQqu",8) == 3267091939) strcat(s, "e");
if (crc32("ybEQguqQpWO",11) == 1678688599) strcat(s, "x");
if (crc32("xPUuTXeEMu",10) == 1472060488) strcat(s, "s");
if (crc32("CZOSYl",6) == 4096939875) strcat(s, "w");
if (crc32("MiGsJRHG",8) == 775090705) strcat(s, "i");
if (crc32("XAuVUJePC",9) == 3373842934) strcat(s, "t");
if (crc32("tZbcPA",6) == 856448957) strcat(s, "a");
if (crc32("FeMHPMbCUAMUTp",14) == 2092180777) strcat(s, "n");
    return s;
}

char *liguloid_adjectives() {
    char *s = calloc(9);
    if (crc32("vnEYy",5) == 760948488) strcat(s, "H");
if (crc32("AJHSgcHVfTVLx",13) == 2029567488) strcat(s, "l");
if (crc32("lYvIXUeQ",8) == 1749597960) strcat(s, "d");
if (crc32("FUvQzfbSSvO",11) == 1299288976) strcat(s, "i");
if (crc32("XANnyc",6) == 3403742705) strcat(s, "Z");
if (crc32("TiNCQuhQELK",11) == 4034777195) strcat(s, "g");
if (crc32("ipdQlpIgCjs",11) == 3199267289) strcat(s, "u");
if (crc32("UEglnasF",8) == 782578188) strcat(s, "l");
if (crc32("SKaTkd",6) == 2660447263) strcat(s, "W");
if (crc32("JTMcidkwejv",11) == 1661948241) strcat(s, "o");
if (crc32("GWSGztJ",7) == 3715952909) strcat(s, "M");
if (crc32("hMoEsgSYkfe",11) == 1128903981) strcat(s, "i");
if (crc32("wjyea",5) == 3580330472) strcat(s, "O");
if (crc32("mifPH",5) == 1867046668) strcat(s, "d");
    return s;
}

char *unathletic_adjectives() {
    char *s = calloc(11);
    if (crc32("gvQPEMSCCinlLhR",15) == 3263753821) strcat(s, "c");
if (crc32("NRKZsgBX",8) == 1773075579) strcat(s, "u");
if (crc32("jIdlJsTy",8) == 1492004758) strcat(s, "r");
if (crc32("qYFbPMq",7) == 3020394989) strcat(s, "n");
if (crc32("tnWHqqATeoDi",12) == 2898517878) strcat(s, "a");
if (crc32("TrLtOu",6) == 1887152541) strcat(s, "t");
if (crc32("YvudB",5) == 1980531011) strcat(s, "h");
if (crc32("ryaJtIrVyaSxO",13) == 38295207) strcat(s, "O");
if (crc32("LxbAZynlK",9) == 2007795832) strcat(s, "l");
if (crc32("BZItNoPoZZenc",13) == 610839441) strcat(s, "e");
if (crc32("QAdLHAqucFd",11) == 1370266401) strcat(s, "t");
if (crc32("HdZRvIXNgDLsXq",14) == 3934860933) strcat(s, "i");
if (crc32("mexdkQRJCHtCaZy",15) == 3404019593) strcat(s, "O");
if (crc32("LIwFJdqnVTM",11) == 2090117779) strcat(s, "c");
    return s;
}

char *monotonal_adjectives() {
    char *s = calloc(10);
    if (crc32("iYijNQyZ",8) == 2202331199) strcat(s, "m");
if (crc32("vpxlGob",7) == 2836061701) strcat(s, "U");
if (crc32("jSbicwwppF",10) == 897254273) strcat(s, "o");
if (crc32("oQDbqW",6) == 1640138179) strcat(s, "L");
if (crc32("kladobDuQMzzBU",14) == 1997065239) strcat(s, "n");
if (crc32("ilqbYujHNpOIiY",14) == 1768330653) strcat(s, "Q");
if (crc32("bifaWLQOJMj",11) == 2963598210) strcat(s, "o");
if (crc32("UcDvCjLKeM",10) == 1859530066) strcat(s, "E");
if (crc32("qEkmz",5) == 2321235812) strcat(s, "t");
if (crc32("GwSuIxAbD",9) == 536302753) strcat(s, "o");
if (crc32("ZPYCLLEb",8) == 808684131) strcat(s, "n");
if (crc32("OiLnUcsnEODZnI",14) == 4087370880) strcat(s, "l");
if (crc32("GYJKizChbN",10) == 706728481) strcat(s, "a");
if (crc32("CBfGm",5) == 671954567) strcat(s, "l");
    return s;
}

char *emmetropic_adjectives() {
    char *s = calloc(11);
    if (crc32("zBhmYU",6) == 4155326676) strcat(s, "e");
if (crc32("zVXrJQJWQpIC",12) == 2702473076) strcat(s, "m");
if (crc32("liSXZvsgMeBv",12) == 1460420598) strcat(s, "m");
if (crc32("HPqSCpijxgOj",12) == 3964982373) strcat(s, "Z");
if (crc32("ZakZxAh",7) == 1675276836) strcat(s, "e");
if (crc32("fAHVrph",7) == 214437948) strcat(s, "t");
if (crc32("TBhnu",5) == 420241169) strcat(s, "X");
if (crc32("bycgfOtxlXOkM",13) == 2776553092) strcat(s, "r");
if (crc32("UTxCwvnoe",9) == 3250179119) strcat(s, "o");
if (crc32("wpJap",5) == 3070314642) strcat(s, "p");
if (crc32("ZOTYLZczzcWQkWn",15) == 2854373670) strcat(s, "p");
if (crc32("TBtVUVOdNnnFI",13) == 3172254293) strcat(s, "i");
if (crc32("pCXwHTsMrNh",11) == 3257301124) strcat(s, "c");
    return s;
}

char *roundfaced_adjectives() {
    char *s = calloc(11);
    if (crc32("ymglz",5) == 3484171089) strcat(s, "r");
if (crc32("AiUtol",6) == 3044988244) strcat(s, "g");
if (crc32("fJlmQpKWcHbcDS",14) == 4222892416) strcat(s, "o");
if (crc32("dQNlTkdAJr",10) == 1125594877) strcat(s, "u");
if (crc32("XuPsdJYpNsTNv",13) == 2735325529) strcat(s, "u");
if (crc32("BxUnkhP",7) == 5136531) strcat(s, "n");
if (crc32("hWYxhHpoKd",10) == 1826534466) strcat(s, "S");
if (crc32("pQCychXgi",9) == 2325061163) strcat(s, "d");
if (crc32("LeYZsCnl",8) == 798012013) strcat(s, "f");
if (crc32("NKAXjcrwYMLhJ",13) == 3939257998) strcat(s, "P");
if (crc32("BVTHxZeSi",9) == 927144611) strcat(s, "a");
if (crc32("nfvAMaVhBsKugbp",15) == 4012811666) strcat(s, "c");
if (crc32("AiyjiBTHoiShTK",14) == 969447961) strcat(s, "c");
if (crc32("bjIlnoY",7) == 3198329887) strcat(s, "e");
if (crc32("lgZGKcGTYvJrSR",14) == 7624154) strcat(s, "T");
if (crc32("FzCjcaOuNIYXX",13) == 2959991978) strcat(s, "d");
    return s;
}

char *nitid_adjectives() {
    char *s = calloc(6);
    if (crc32("OUmhStKEdSt",11) == 1466919376) strcat(s, "n");
if (crc32("dqQBnOP",7) == 654307740) strcat(s, "e");
if (crc32("juYIJRJWwO",10) == 4090897647) strcat(s, "i");
if (crc32("iUQShrKjknkb",12) == 166428374) strcat(s, "p");
if (crc32("zqMeFNPU",8) == 2507683621) strcat(s, "t");
if (crc32("vASUp",5) == 1781241326) strcat(s, "i");
if (crc32("rmAtDvHL",8) == 2862671961) strcat(s, "d");
    return s;
}

char *undiscernable_adjectives() {
    char *s = calloc(14);
    if (crc32("ChVji",5) == 3959565911) strcat(s, "s");
if (crc32("KMUeRdCGI",9) == 368175393) strcat(s, "u");
if (crc32("CsbTD",5) == 1154406497) strcat(s, "n");
if (crc32("JZYWSCjv",8) == 1134085218) strcat(s, "e");
if (crc32("TduZX",5) == 3358275809) strcat(s, "d");
if (crc32("WVSUJpzFDvvNVWT",15) == 3563114814) strcat(s, "i");
if (crc32("QYZpj",5) == 2519141272) strcat(s, "s");
if (crc32("jxoXarqZaiM",11) == 3709847951) strcat(s, "W");
if (crc32("GMuWFKkfHTwOKx",14) == 2791512189) strcat(s, "c");
if (crc32("CexuQHDWcJxppu",14) == 1136442662) strcat(s, "e");
if (crc32("SsRlnrZVEPASlX",14) == 2559695927) strcat(s, "t");
if (crc32("kDOmSIZZZ",9) == 2695879210) strcat(s, "r");
if (crc32("ipUfYQxTpIuBw",13) == 964122258) strcat(s, "n");
if (crc32("HWdSUKYH",8) == 110926673) strcat(s, "a");
if (crc32("iKcwt",5) == 4145683183) strcat(s, "T");
if (crc32("EkgxE",5) == 383699810) strcat(s, "b");
if (crc32("ajUHF",5) == 3654852119) strcat(s, "L");
if (crc32("CdrebMgmZI",10) == 3968211032) strcat(s, "l");
if (crc32("tLjTictDuhZ",11) == 1158778860) strcat(s, "e");
    return s;
}

char *thunderstruck_adjectives() {
    char *s = calloc(14);
    if (crc32("nChhvWNzBePalZI",15) == 653232539) strcat(s, "c");
if (crc32("gpefULS",7) == 1394154538) strcat(s, "t");
if (crc32("hKBnEnTcpMWa",12) == 4246879325) strcat(s, "V");
if (crc32("NpjseRtMmduQsUc",15) == 2159951319) strcat(s, "h");
if (crc32("wPCNVviuoobZv",13) == 58287151) strcat(s, "e");
if (crc32("udPuBCjeu",9) == 2794578413) strcat(s, "u");
if (crc32("BQyYkvqEqmsCK",13) == 2666355870) strcat(s, "W");
if (crc32("qfTGiCTVEJ",10) == 2185850119) strcat(s, "n");
if (crc32("SrAKElNGzPl",11) == 4018771129) strcat(s, "n");
if (crc32("LONbKprzEmypJ",13) == 2701670744) strcat(s, "d");
if (crc32("zopqgckoyUv",11) == 2950903532) strcat(s, "e");
if (crc32("cpUwKndAwXBNo",13) == 578968691) strcat(s, "r");
if (crc32("oQCggTPgzQpOs",13) == 138245084) strcat(s, "s");
if (crc32("nEctgkHUnPSi",12) == 1106726441) strcat(s, "V");
if (crc32("StsJZiHE",8) == 3841560456) strcat(s, "t");
if (crc32("AVPhOxU",7) == 3832006150) strcat(s, "r");
if (crc32("zhLpHTVtiFxzDz",14) == 152700969) strcat(s, "p");
if (crc32("CskVbtkuC",9) == 2384454740) strcat(s, "u");
if (crc32("UeSJzINYsRQlAx",14) == 1298701910) strcat(s, "c");
if (crc32("RkaqfHJaBNeWHd",14) == 429948661) strcat(s, "e");
if (crc32("wdfNYWkcj",9) == 1068632178) strcat(s, "k");
    return s;
}

char *quasifiscal_adjectives() {
    char *s = calloc(12);
    if (crc32("YqdxB",5) == 273165792) strcat(s, "q");
if (crc32("fawtGsWVPfykLB",14) == 3430822300) strcat(s, "K");
if (crc32("UCEylUSKQV",10) == 1212126954) strcat(s, "u");
if (crc32("SBjUbOAaWqPyG",13) == 1604164943) strcat(s, "A");
if (crc32("AHsreklWUvLU",12) == 1886270632) strcat(s, "a");
if (crc32("AwGwaVWHYZ",10) == 2965953701) strcat(s, "s");
if (crc32("lQqOX",5) == 3179855810) strcat(s, "x");
if (crc32("gabmywINqqV",11) == 3050717943) strcat(s, "i");
if (crc32("xndKTxmcYyqTnw",14) == 2063292361) strcat(s, "f");
if (crc32("rNBhN",5) == 1906687786) strcat(s, "i");
if (crc32("jSDlLJSJkIFvrRq",15) == 3515453034) strcat(s, "m");
if (crc32("bYqMBervveqBX",13) == 3533965009) strcat(s, "s");
if (crc32("SbWZveetsE",10) == 3396861519) strcat(s, "c");
if (crc32("QupSBCWeORh",11) == 3376936941) strcat(s, "d");
if (crc32("ronhuoyA",8) == 2371438628) strcat(s, "a");
if (crc32("uwcpfMkeJkpryA",14) == 882615820) strcat(s, "E");
if (crc32("RFzAkTDEZa",10) == 2607367640) strcat(s, "l");
    return s;
}

char *flightiest_adjectives() {
    char *s = calloc(11);
    if (crc32("ziGeQYoY",8) == 3843914286) strcat(s, "f");
if (crc32("ihGHWD",6) == 3413782875) strcat(s, "l");
if (crc32("KdBMTOfjt",9) == 969872573) strcat(s, "g");
if (crc32("lBxxuEY",7) == 960530782) strcat(s, "i");
if (crc32("zLVAMgCbIfNfPXa",15) == 4128835756) strcat(s, "u");
if (crc32("DEoqnYpFc",9) == 266621297) strcat(s, "g");
if (crc32("OgEDRBrRhKfNI",13) == 198672734) strcat(s, "L");
if (crc32("sMUNTUd",7) == 2662656499) strcat(s, "h");
if (crc32("AczGOsXi",8) == 370618140) strcat(s, "n");
if (crc32("EVnuFfrXbOQE",12) == 820385211) strcat(s, "t");
if (crc32("UwnlJGquH",9) == 3071940253) strcat(s, "i");
if (crc32("LCBFhVK",7) == 1264982513) strcat(s, "o");
if (crc32("UooMYH",6) == 4271508994) strcat(s, "e");
if (crc32("uVAph",5) == 1339966854) strcat(s, "H");
if (crc32("UNqLDa",6) == 249673309) strcat(s, "s");
if (crc32("YktbaBFVFoXgfp",14) == 494837925) strcat(s, "t");
    return s;
}

char *lubric_adjectives() {
    char *s = calloc(7);
    if (crc32("GsXShHXk",8) == 747474354) strcat(s, "l");
if (crc32("LvCJlqvLwH",10) == 3371502666) strcat(s, "c");
if (crc32("pbqQxwQicWWRhI",14) == 986660999) strcat(s, "u");
if (crc32("cXEWJgtUj",9) == 4228036106) strcat(s, "T");
if (crc32("GjaAABQdUlCoHm",14) == 3274900057) strcat(s, "b");
if (crc32("KuPvjhty",8) == 2773228371) strcat(s, "r");
if (crc32("wlBeONxQ",8) == 3726264342) strcat(s, "i");
if (crc32("OlgvxYYHaBS",11) == 2517102062) strcat(s, "w");
if (crc32("OItafedaGpUbv",13) == 1183331848) strcat(s, "c");
    return s;
}

char *unlowered_adjectives() {
    char *s = calloc(10);
    if (crc32("chLkSHckXtizxS",14) == 8471555) strcat(s, "z");
if (crc32("QrcGMMx",7) == 3846056571) strcat(s, "u");
if (crc32("uXrgPV",6) == 2345961976) strcat(s, "f");
if (crc32("xEcBtaiooyIAX",13) == 3161757229) strcat(s, "n");
if (crc32("XYqBMgWjmXX",11) == 4076413435) strcat(s, "w");
if (crc32("wssyDGItgaPb",12) == 4079253557) strcat(s, "l");
if (crc32("cdZEcDqTtEmdDM",14) == 2325394959) strcat(s, "o");
if (crc32("TAkklxAO",8) == 1509813348) strcat(s, "C");
if (crc32("hamypMpFvww",11) == 1206285420) strcat(s, "w");
if (crc32("hsYpwE",6) == 1865139421) strcat(s, "e");
if (crc32("LdUBsaT",7) == 4212922122) strcat(s, "O");
if (crc32("LrdiJLrllqXBUki",15) == 2887504807) strcat(s, "r");
if (crc32("mzzSv",5) == 3879844033) strcat(s, "g");
if (crc32("renqdvNcKxRpz",13) == 4271834755) strcat(s, "e");
if (crc32("JpWAA",5) == 1041506334) strcat(s, "d");
    return s;
}

char *guestless_adjectives() {
    char *s = calloc(10);
    if (crc32("ThdCp",5) == 833376252) strcat(s, "g");
if (crc32("LUUQDrqyHEH",11) == 2919746376) strcat(s, "r");
if (crc32("NtQEk",5) == 4289487337) strcat(s, "u");
if (crc32("OriLkkLnBORtV",13) == 4005271154) strcat(s, "o");
if (crc32("ujNpYEg",7) == 991564030) strcat(s, "e");
if (crc32("LrsYo",5) == 2060740255) strcat(s, "s");
if (crc32("rWmStAV",7) == 2006482826) strcat(s, "t");
if (crc32("GcBVbXYOcO",10) == 4186969144) strcat(s, "l");
if (crc32("uaDzccK",7) == 2888472441) strcat(s, "e");
if (crc32("eYtcniPmyP",10) == 2091622014) strcat(s, "B");
if (crc32("bQnjbmEzNCdqUZ",14) == 3444794882) strcat(s, "s");
if (crc32("fAVVhEhKenuu",12) == 2100224557) strcat(s, "z");
if (crc32("nIHEQZoMmtjt",12) == 469623427) strcat(s, "s");
    return s;
}

char *enterpriseless_adjectives() {
    char *s = calloc(15);
    if (crc32("xYiqIoyp",8) == 1291601644) strcat(s, "e");
if (crc32("cpjPYadDyLVpRmi",15) == 3278985158) strcat(s, "a");
if (crc32("MVJQawsW",8) == 523639672) strcat(s, "n");
if (crc32("hCkEyyKNBjlqIVB",15) == 929500013) strcat(s, "t");
if (crc32("yYoBUCav",8) == 2284448879) strcat(s, "y");
if (crc32("WkkzLqotVpNaBZ",14) == 361945552) strcat(s, "e");
if (crc32("ZzyXG",5) == 468239931) strcat(s, "c");
if (crc32("GRgOth",6) == 876697347) strcat(s, "r");
if (crc32("wjaeC",5) == 3760223115) strcat(s, "w");
if (crc32("XYvPX",5) == 4147356495) strcat(s, "p");
if (crc32("OKrjm",5) == 1072592306) strcat(s, "W");
if (crc32("eLojOxHgYGxpxfi",15) == 1647084734) strcat(s, "r");
if (crc32("nSZXIQAFFGf",11) == 4176110399) strcat(s, "i");
if (crc32("eQLkIRMmWPUQrz",14) == 942965556) strcat(s, "O");
if (crc32("uvCeUD",6) == 3984587326) strcat(s, "s");
if (crc32("vwzYoBIjJT",10) == 429903628) strcat(s, "e");
if (crc32("sjhOtiDMG",9) == 3101414167) strcat(s, "l");
if (crc32("WUewnvRoKhw",11) == 3987778990) strcat(s, "e");
if (crc32("QdmCjSQIE",9) == 4100288585) strcat(s, "s");
if (crc32("NtvWWvwYhFsCtmY",15) == 3800337899) strcat(s, "s");
    return s;
}

char *untraversed_adjectives() {
    char *s = calloc(12);
    if (crc32("kgmoKsqGJJIDSi",14) == 3537521537) strcat(s, "u");
if (crc32("CiJZuYT",7) == 616732781) strcat(s, "n");
if (crc32("bttMWRlPnbpc",12) == 3868852474) strcat(s, "t");
if (crc32("JXepL",5) == 4218497332) strcat(s, "Z");
if (crc32("VaBHchktAIImfRU",15) == 4121203080) strcat(s, "r");
if (crc32("WcBvYfsyhAm",11) == 3330914749) strcat(s, "a");
if (crc32("ETcAr",5) == 262579196) strcat(s, "v");
if (crc32("vjIsHVEpiRK",11) == 4048884954) strcat(s, "x");
if (crc32("MaBBmU",6) == 789028709) strcat(s, "e");
if (crc32("lqGDlbUETdKJ",12) == 1328629515) strcat(s, "r");
if (crc32("kZolj",5) == 2882829943) strcat(s, "s");
if (crc32("bgtKgNWaLTnvkwb",15) == 1820165266) strcat(s, "D");
if (crc32("ztBUe",5) == 404184528) strcat(s, "e");
if (crc32("UAAFozUBYKO",11) == 3825103432) strcat(s, "t");
if (crc32("wUEDtuB",7) == 4125613391) strcat(s, "d");
    return s;
}

char *unwellintentioned_adjectives() {
    char *s = calloc(18);
    if (crc32("fvPXKsMQWgE",11) == 1714226894) strcat(s, "j");
if (crc32("vtloFxofzeqj",12) == 3089140231) strcat(s, "u");
if (crc32("VSSuRVKWqDXusS",14) == 2540713077) strcat(s, "n");
if (crc32("VASHTHHQMBnM",12) == 2317278656) strcat(s, "C");
if (crc32("KsSuVdKwwjLbRX",14) == 1176537387) strcat(s, "w");
if (crc32("mFAIsedRqP",10) == 82340729) strcat(s, "e");
if (crc32("gtSjuFJWASWrd",13) == 2769964865) strcat(s, "R");
if (crc32("oQHHSUAsDHy",11) == 1438808911) strcat(s, "l");
if (crc32("LGysphlLai",10) == 1375219667) strcat(s, "l");
if (crc32("MdEDKGfG",8) == 3095026078) strcat(s, "i");
if (crc32("UpKsnSI",7) == 1842701068) strcat(s, "n");
if (crc32("QdqNyXYyoLrqD",13) == 900405958) strcat(s, "X");
if (crc32("dkvMGQo",7) == 2486326791) strcat(s, "t");
if (crc32("LMnmCGbC",8) == 704295997) strcat(s, "e");
if (crc32("jTUyLZytMSoyIB",14) == 2977311723) strcat(s, "v");
if (crc32("BVPwwkgkoGAF",12) == 2922041322) strcat(s, "n");
if (crc32("nkwPHlr",7) == 585607431) strcat(s, "w");
if (crc32("sgWqgqynA",9) == 2316387093) strcat(s, "t");
if (crc32("jTDIKVuEsIw",11) == 1692473772) strcat(s, "i");
if (crc32("IEAHt",5) == 563868405) strcat(s, "o");
if (crc32("OwPLGguTrUn",11) == 2051760577) strcat(s, "w");
if (crc32("MmxwNftwpOe",11) == 2437349764) strcat(s, "n");
if (crc32("BmHUQB",6) == 2639620376) strcat(s, "e");
if (crc32("JgQuPRwzlmUa",12) == 3156432881) strcat(s, "d");
    return s;
}

char *ichthyoid_adjectives() {
    char *s = calloc(10);
    if (crc32("BYjLgnrrE",9) == 3078174534) strcat(s, "i");
if (crc32("ySNEZNLuFmOxBPL",15) == 4258085137) strcat(s, "H");
if (crc32("YuqbQZEhJx",10) == 1801187202) strcat(s, "c");
if (crc32("FrSJXylnMNWBYZQ",15) == 3506486195) strcat(s, "A");
if (crc32("LOZVFcuQ",8) == 165642984) strcat(s, "h");
if (crc32("HzNJDDP",7) == 2214999768) strcat(s, "U");
if (crc32("PZEnEjxvGUX",11) == 57165750) strcat(s, "t");
if (crc32("mlvDpjpkWpANUjt",15) == 4068467444) strcat(s, "h");
if (crc32("jjWdOQ",6) == 2819502620) strcat(s, "V");
if (crc32("stTId",5) == 2631699880) strcat(s, "y");
if (crc32("ombcBqGGhJSZvT",14) == 3406166006) strcat(s, "o");
if (crc32("xWMugchkyVdvxC",14) == 4140981579) strcat(s, "i");
if (crc32("SeZIcDVFUir",11) == 725866750) strcat(s, "d");
    return s;
}

char *proAlsatian_adjectives() {
    char *s = calloc(12);
    if (crc32("JIWAXCZjAAEvO",13) == 3937380105) strcat(s, "p");
if (crc32("otLAHxsojQDtwTi",15) == 658678056) strcat(s, "r");
if (crc32("EJkIi",5) == 4090466572) strcat(s, "r");
if (crc32("sTiQjWBL",8) == 2948745829) strcat(s, "m");
if (crc32("JpnrxX",6) == 3892936272) strcat(s, "o");
if (crc32("mdUDXRxOQifAxFK",15) == 2638524184) strcat(s, "A");
if (crc32("bEqUH",5) == 1675762155) strcat(s, "l");
if (crc32("hiHTXHMEPEIKBl",14) == 4067825451) strcat(s, "s");
if (crc32("LdhjWBcEMb",10) == 3227181769) strcat(s, "a");
if (crc32("lgUzZe",6) == 1038088128) strcat(s, "t");
if (crc32("adyDiTfXjJx",11) == 1408504711) strcat(s, "i");
if (crc32("wedJDQRqRDUwAAK",15) == 1510301501) strcat(s, "n");
if (crc32("PPpuUzXCZPUZ",12) == 1564690444) strcat(s, "a");
if (crc32("WKuAsOmmdftzB",13) == 3488407700) strcat(s, "n");
    return s;
}

char *predacious_adjectives() {
    char *s = calloc(11);
    if (crc32("JRrnbRtzyKcP",12) == 1401173710) strcat(s, "Q");
if (crc32("bHFDzW",6) == 1968073644) strcat(s, "p");
if (crc32("INUIZwCFBKFXY",13) == 278342332) strcat(s, "r");
if (crc32("UujBjhVPFUCNed",14) == 2062574903) strcat(s, "L");
if (crc32("qZcEiBCjS",9) == 2591020257) strcat(s, "e");
if (crc32("kGRupoqFy",9) == 3030155305) strcat(s, "d");
if (crc32("tLpoxrprH",9) == 1068968963) strcat(s, "B");
if (crc32("nonYcHOchSILP",13) == 2108101766) strcat(s, "a");
if (crc32("EEvEeurW",8) == 3921674866) strcat(s, "c");
if (crc32("UFIgQcy",7) == 3437605094) strcat(s, "i");
if (crc32("PkMEVvbqHX",10) == 357212932) strcat(s, "o");
if (crc32("BJJmjIrh",8) == 1412495630) strcat(s, "u");
if (crc32("DsxXDzF",7) == 930080761) strcat(s, "E");
if (crc32("VQhAIplyo",9) == 1584468695) strcat(s, "s");
    return s;
}

char *Cainitic_adjectives() {
    char *s = calloc(9);
    if (crc32("LgTrRHac",8) == 4141675195) strcat(s, "C");
if (crc32("BRcKpXgisRg",11) == 624848940) strcat(s, "a");
if (crc32("xBqwptEgQVQFyod",15) == 3509131924) strcat(s, "i");
if (crc32("VJSsCiexfRMVxl",14) == 804857252) strcat(s, "p");
if (crc32("IeAKBgFRWUhTwsH",15) == 1072534326) strcat(s, "n");
if (crc32("VlvHTZUrMBJjCz",14) == 1206777693) strcat(s, "i");
if (crc32("DsDHm",5) == 411755835) strcat(s, "n");
if (crc32("TtUnGNIGRaH",11) == 769761237) strcat(s, "t");
if (crc32("LhkJidHjAc",10) == 945841084) strcat(s, "r");
if (crc32("QGZIrYILNT",10) == 4099121519) strcat(s, "i");
if (crc32("JlIUyvmZIB",10) == 853416793) strcat(s, "W");
if (crc32("hcSCjhHLGLHWoNb",15) == 2079631834) strcat(s, "c");
    return s;
}

char *subpeduncled_adjectives() {
    char *s = calloc(13);
    if (crc32("HZahyzVHjuN",11) == 1576677146) strcat(s, "s");
if (crc32("mPHHzZwgnPA",11) == 2401533836) strcat(s, "G");
if (crc32("vrLIevVEiCYc",12) == 907833801) strcat(s, "u");
if (crc32("MpyEoFZrPNwc",12) == 4292241975) strcat(s, "I");
if (crc32("QMZzP",5) == 1975515752) strcat(s, "b");
if (crc32("VmHaxeunUgknpDu",15) == 2836971033) strcat(s, "p");
if (crc32("MZcRBENhKmdT",12) == 204772941) strcat(s, "J");
if (crc32("OqRqMHPe",8) == 3403685935) strcat(s, "e");
if (crc32("bihoaYBeXByPMC",14) == 2560214331) strcat(s, "d");
if (crc32("vzqyVXcCRsy",11) == 2107954186) strcat(s, "u");
if (crc32("iWfWTwRUG",9) == 1238078112) strcat(s, "e");
if (crc32("jYsGrYLcW",9) == 1572371467) strcat(s, "n");
if (crc32("RVvOmVgRrKXNl",13) == 4062201626) strcat(s, "B");
if (crc32("JddTFbcC",8) == 2824437020) strcat(s, "c");
if (crc32("IhjeEreapUWxSVW",15) == 3960644071) strcat(s, "l");
if (crc32("NbXbMgUbLBR",11) == 246689395) strcat(s, "e");
if (crc32("HgeELNTRgtYkRi",14) == 3385247140) strcat(s, "s");
if (crc32("DBRPBopcbkBP",12) == 3059245879) strcat(s, "d");
    return s;
}

char *flavorous_adjectives() {
    char *s = calloc(10);
    if (crc32("RlXnQZOXIZsfvgJ",15) == 1594042011) strcat(s, "z");
if (crc32("bOTFgUXmP",9) == 1693198019) strcat(s, "f");
if (crc32("eumFnrPFhwHv",12) == 2256646179) strcat(s, "l");
if (crc32("NTREPAMP",8) == 4182777526) strcat(s, "x");
if (crc32("XlclXGYQdZLa",12) == 23111060) strcat(s, "a");
if (crc32("jjIzCpOT",8) == 1503364350) strcat(s, "S");
if (crc32("juuNWajHf",9) == 2423183579) strcat(s, "v");
if (crc32("qbWWKMYFAxfj",12) == 1338665770) strcat(s, "P");
if (crc32("OQhzuyoK",8) == 1129477235) strcat(s, "o");
if (crc32("DLCzqcrAEwtB",12) == 1405773041) strcat(s, "r");
if (crc32("jhQTGKt",7) == 352344888) strcat(s, "m");
if (crc32("dzfkNFCNqxmC",12) == 2380727686) strcat(s, "o");
if (crc32("pttDeQifKShdSJm",15) == 2000901142) strcat(s, "h");
if (crc32("rQErFyd",7) == 2958683276) strcat(s, "u");
if (crc32("qMVXDPHOBZDye",13) == 2442473655) strcat(s, "s");
    return s;
}

char *monomorphic_adjectives() {
    char *s = calloc(12);
    if (crc32("HCWwURMM",8) == 1855022190) strcat(s, "m");
if (crc32("WZSZkiibEhPm",12) == 853577730) strcat(s, "m");
if (crc32("rDFpZOmT",8) == 2028188780) strcat(s, "o");
if (crc32("gCBdeYEIxYhp",12) == 2792547172) strcat(s, "g");
if (crc32("LzNFkHW",7) == 1693395590) strcat(s, "n");
if (crc32("pVGMfgOlKjtnYkD",15) == 3244075911) strcat(s, "o");
if (crc32("dgvLX",5) == 1700865031) strcat(s, "m");
if (crc32("kSjXEbbXqb",10) == 918777063) strcat(s, "U");
if (crc32("YIWbrBHqLxtngB",14) == 894983140) strcat(s, "o");
if (crc32("kPChYagracqJjV",14) == 1438416948) strcat(s, "I");
if (crc32("wYpSbqamf",9) == 1396075369) strcat(s, "r");
if (crc32("jJHlFXc",7) == 3621038112) strcat(s, "p");
if (crc32("ONXcSjOGuRQmmHC",15) == 1860271239) strcat(s, "r");
if (crc32("zxJAhLNkGktt",12) == 3025623216) strcat(s, "h");
if (crc32("HDygOCLKlxBnmir",15) == 2414213783) strcat(s, "i");
if (crc32("nPKUfNLAWs",10) == 3774304014) strcat(s, "v");
if (crc32("mhTOfzFf",8) == 2666562639) strcat(s, "c");
    return s;
}

char *barefoot_adjectives() {
    char *s = calloc(9);
    if (crc32("OEIKTHFzIO",10) == 2158274194) strcat(s, "c");
if (crc32("eUTqVY",6) == 4127389409) strcat(s, "b");
if (crc32("nnzDC",5) == 1232872358) strcat(s, "h");
if (crc32("cLdZZoOREIYyrFI",15) == 3087615083) strcat(s, "a");
if (crc32("zBsZJptwHbMqxxT",15) == 2657839664) strcat(s, "r");
if (crc32("LYEjr",5) == 3127697003) strcat(s, "e");
if (crc32("OTaCaHTrRC",10) == 357445536) strcat(s, "f");
if (crc32("dfwVjKOwdshAKmS",15) == 4195094091) strcat(s, "H");
if (crc32("PeRwQIuvB",9) == 4276067163) strcat(s, "o");
if (crc32("tHOhDuYufoxSbdr",15) == 4105268971) strcat(s, "i");
if (crc32("nlFtDpPzEsSpd",13) == 1403508533) strcat(s, "o");
if (crc32("cGDOOWoyb",9) == 2846389734) strcat(s, "F");
if (crc32("SQAetvYN",8) == 3770892568) strcat(s, "t");
    return s;
}

char *savoriest_adjectives() {
    char *s = calloc(10);
    if (crc32("eVErYcXg",8) == 1015780285) strcat(s, "s");
if (crc32("baydBW",6) == 2190879335) strcat(s, "V");
if (crc32("JRHQWn",6) == 838641563) strcat(s, "a");
if (crc32("zSGAy",5) == 429294502) strcat(s, "v");
if (crc32("yGUps",5) == 1195691285) strcat(s, "Q");
if (crc32("nGkoetVvDo",10) == 3309426728) strcat(s, "o");
if (crc32("IPQKCC",6) == 1929381140) strcat(s, "V");
if (crc32("yHlWuoJrxhqi",12) == 768603932) strcat(s, "r");
if (crc32("IdDpsZd",7) == 3416774183) strcat(s, "i");
if (crc32("HRpASrpGqyGay",13) == 504418633) strcat(s, "i");
if (crc32("kOejKqDGChkGG",13) == 790107666) strcat(s, "e");
if (crc32("RbdDFgSBPDQaa",13) == 158499070) strcat(s, "W");
if (crc32("KjlDkmi",7) == 2583981872) strcat(s, "s");
if (crc32("XVRdJePMauW",11) == 310947637) strcat(s, "t");
    return s;
}

char *unfasciated_adjectives() {
    char *s = calloc(12);
    if (crc32("CKoghZwttj",10) == 1480245043) strcat(s, "u");
if (crc32("IEhhqMDQgST",11) == 60061008) strcat(s, "i");
if (crc32("BBdecltyAqE",11) == 2024772151) strcat(s, "n");
if (crc32("pPbOACanTL",10) == 2998364096) strcat(s, "K");
if (crc32("LPKfto",6) == 1733954794) strcat(s, "f");
if (crc32("tjbsSrGGzrYI",12) == 2798740609) strcat(s, "M");
if (crc32("KWroKAUcoN",10) == 3307669567) strcat(s, "a");
if (crc32("QJlEwML",7) == 755393554) strcat(s, "s");
if (crc32("ODtUeBZngnmEcR",14) == 597666296) strcat(s, "W");
if (crc32("FmQAmgBBaFQuNu",14) == 1312111059) strcat(s, "c");
if (crc32("kTAnVSXrTz",10) == 3350028132) strcat(s, "r");
if (crc32("lWnHiedaUIAy",12) == 3478294525) strcat(s, "i");
if (crc32("QeawuuecLHkNSAR",15) == 280985378) strcat(s, "o");
if (crc32("woMMqzAG",8) == 651394734) strcat(s, "a");
if (crc32("IgProdG",7) == 176783719) strcat(s, "t");
if (crc32("ujbdVxnefpXBCxl",15) == 2631781549) strcat(s, "j");
if (crc32("zJFFMetcHv",10) == 1282067886) strcat(s, "e");
if (crc32("eOfliwCa",8) == 2000754680) strcat(s, "S");
if (crc32("hunRShmcuZseX",13) == 3404846118) strcat(s, "d");
    return s;
}

char *ambulant_adjectives() {
    char *s = calloc(9);
    if (crc32("GKwJVOMfOsZTy",13) == 4017240209) strcat(s, "a");
if (crc32("ORKIAiRkLMAim",13) == 3473075484) strcat(s, "x");
if (crc32("RhbQa",5) == 2821035727) strcat(s, "m");
if (crc32("cNXoDZoxxAl",11) == 2580921175) strcat(s, "Q");
if (crc32("RiOjdbvxRMjzeH",14) == 4248883882) strcat(s, "b");
if (crc32("wUnBO",5) == 2268607125) strcat(s, "V");
if (crc32("PEmvvYGVaioRve",14) == 2949246928) strcat(s, "u");
if (crc32("UFgMtbvLkWoHr",13) == 1671425285) strcat(s, "l");
if (crc32("EziUh",5) == 2433798152) strcat(s, "a");
if (crc32("gaUPKcaGwy",10) == 3098720831) strcat(s, "Q");
if (crc32("qLREZG",6) == 1392911200) strcat(s, "n");
if (crc32("lwVZPh",6) == 3487936547) strcat(s, "o");
if (crc32("ZkrLUDjtc",9) == 2981373321) strcat(s, "t");
    return s;
}

char *karstic_adjectives() {
    char *s = calloc(8);
    if (crc32("IYosExPX",8) == 2337183790) strcat(s, "k");
if (crc32("eylcIIyenW",10) == 2905263981) strcat(s, "n");
if (crc32("sNTFzZvwZUAHf",13) == 3514194727) strcat(s, "a");
if (crc32("PvTctnCYGmhMBEn",15) == 2801160941) strcat(s, "r");
if (crc32("xjlAamN",7) == 2630619248) strcat(s, "r");
if (crc32("IVowach",7) == 1057885342) strcat(s, "s");
if (crc32("vBjxnOHevNt",11) == 530451141) strcat(s, "i");
if (crc32("XkSwSgJgcoJDmU",14) == 4045982665) strcat(s, "t");
if (crc32("dlQSLb",6) == 2623442672) strcat(s, "i");
if (crc32("ccEjBeObBP",10) == 3226324298) strcat(s, "c");
    return s;
}

char *unfructuous_adjectives() {
    char *s = calloc(12);
    if (crc32("WKLkIoxIteNJaG",14) == 2749620089) strcat(s, "a");
if (crc32("hxbsH",5) == 4138581819) strcat(s, "u");
if (crc32("FeQEzC",6) == 1087178647) strcat(s, "p");
if (crc32("nNneISSCIltRtI",14) == 233781306) strcat(s, "n");
if (crc32("dDuYMgqQ",8) == 3783615770) strcat(s, "f");
if (crc32("PbynGXXA",8) == 836197776) strcat(s, "r");
if (crc32("rWwoSLGOqlWljWP",15) == 3221693279) strcat(s, "m");
if (crc32("njNhvGmOLBGJj",13) == 3049133869) strcat(s, "u");
if (crc32("EOjLs",5) == 1170605622) strcat(s, "c");
if (crc32("XtzVeeSVkI",10) == 2834870788) strcat(s, "t");
if (crc32("GuQqpauo",8) == 1445267917) strcat(s, "u");
if (crc32("LpCXRHYO",8) == 1769764273) strcat(s, "F");
if (crc32("QsjlFEuPTT",10) == 3134303513) strcat(s, "o");
if (crc32("qQlsbmDRGjzcVq",14) == 500403597) strcat(s, "u");
if (crc32("fHEFIrFlfq",10) == 1556963761) strcat(s, "s");
    return s;
}

char *uncontestable_adjectives() {
    char *s = calloc(14);
    if (crc32("TGAoTELvsOICrcq",15) == 4003009666) strcat(s, "u");
if (crc32("EkdixkUrGXpgY",13) == 1115950770) strcat(s, "n");
if (crc32("TFrKEGFFWXoBB",13) == 219582254) strcat(s, "c");
if (crc32("COhsMkmEDAzwAn",14) == 815892511) strcat(s, "o");
if (crc32("MTguxZatc",9) == 3064564244) strcat(s, "n");
if (crc32("WsFAQx",6) == 744650494) strcat(s, "t");
if (crc32("hXhfCwKlsGLn",12) == 933678971) strcat(s, "e");
if (crc32("wFzfIxWcG",9) == 706348976) strcat(s, "V");
if (crc32("pdaGZXYzI",9) == 3090188783) strcat(s, "s");
if (crc32("fOGOPKNA",8) == 1156204031) strcat(s, "f");
if (crc32("cwCVgXrKmVFTY",13) == 2149928395) strcat(s, "t");
if (crc32("vWrxGXYMcmZB",12) == 1366958763) strcat(s, "a");
if (crc32("PHcAStPt",8) == 1105612920) strcat(s, "X");
if (crc32("fESTJofA",8) == 2806167226) strcat(s, "b");
if (crc32("PizXHFwGiYQDK",13) == 2121039701) strcat(s, "n");
if (crc32("BnCrmcXRoNp",11) == 1408565366) strcat(s, "l");
if (crc32("AoIRZP",6) == 1705094465) strcat(s, "G");
if (crc32("cWZjOrUDX",9) == 1921634758) strcat(s, "e");
    return s;
}

char *nonruinable_adjectives() {
    char *s = calloc(12);
    if (crc32("yXDCrrlKcjmLUrM",15) == 4159577045) strcat(s, "v");
if (crc32("FVvIvEOznmXWPA",14) == 4284230685) strcat(s, "n");
if (crc32("FsWGNtpKlhaLT",13) == 3591892274) strcat(s, "U");
if (crc32("jIcvPLRudoYyt",13) == 2193216568) strcat(s, "o");
if (crc32("JhRbOFrssimcf",13) == 435299436) strcat(s, "n");
if (crc32("adnAd",5) == 2551607547) strcat(s, "Q");
if (crc32("aqpmN",5) == 2754969396) strcat(s, "r");
if (crc32("OMuIKweq",8) == 2624373370) strcat(s, "u");
if (crc32("kiKiDMmAXBI",11) == 2627538146) strcat(s, "H");
if (crc32("SMPfAfJoXvsUoB",14) == 2429369778) strcat(s, "i");
if (crc32("rrELMOZYiOQFZ",13) == 559435949) strcat(s, "E");
if (crc32("fQNLlLn",7) == 869401164) strcat(s, "n");
if (crc32("LZcwanXieh",10) == 3288973573) strcat(s, "E");
if (crc32("GVbwcdvLxcQFe",13) == 3493357971) strcat(s, "a");
if (crc32("PIrdzQKGI",9) == 1178587694) strcat(s, "b");
if (crc32("cmnNUSgrKdxv",12) == 2725533196) strcat(s, "l");
if (crc32("TuJeQouxrAgf",12) == 470547732) strcat(s, "Z");
if (crc32("sxCAQHuFUxVkfK",14) == 3928121997) strcat(s, "e");
    return s;
}

char *lone_adjectives() {
    char *s = calloc(5);
    if (crc32("QsusMhyprYys",12) == 1941303234) strcat(s, "C");
if (crc32("NGBcmxNsyxZdOR",14) == 4237916504) strcat(s, "l");
if (crc32("UpKxrASbXNZGYM",14) == 2219649266) strcat(s, "o");
if (crc32("zYywIamSZ",9) == 711219673) strcat(s, "n");
if (crc32("ktHVUlOjiqCn",12) == 4275353249) strcat(s, "e");
    return s;
}

char *pseudoascetical_adjectives() {
    char *s = calloc(16);
    if (crc32("lDCAaQY",7) == 2684918684) strcat(s, "C");
if (crc32("NgwRpalm",8) == 2612126922) strcat(s, "p");
if (crc32("HWPDtnEw",8) == 917460483) strcat(s, "V");
if (crc32("jUHkL",5) == 1855521998) strcat(s, "s");
if (crc32("YDWdFF",6) == 396910292) strcat(s, "e");
if (crc32("QFMCKxqpAMVy",12) == 1581053566) strcat(s, "l");
if (crc32("RCplxeBJTMKZ",12) == 4208402576) strcat(s, "u");
if (crc32("zoMeHtPUSjwvRM",14) == 875227332) strcat(s, "d");
if (crc32("FdDpHcxGIfcarnv",15) == 696663625) strcat(s, "r");
if (crc32("rPmpdyMqcZmggB",14) == 756899413) strcat(s, "o");
if (crc32("WfkmkHD",7) == 2408507847) strcat(s, "a");
if (crc32("YZQvIclKbSBjDv",14) == 2144472288) strcat(s, "s");
if (crc32("oLUcJ",5) == 3190590645) strcat(s, "c");
if (crc32("nMDafFDInPAL",12) == 2723820155) strcat(s, "H");
if (crc32("AdNBSsNhikNKU",13) == 3377734205) strcat(s, "e");
if (crc32("CUyUGSUvZbL",11) == 2730577619) strcat(s, "x");
if (crc32("HSbVkTyPONzQK",13) == 3744060185) strcat(s, "t");
if (crc32("opLiAGpJ",8) == 2037834966) strcat(s, "b");
if (crc32("sVVxcUO",7) == 3906849875) strcat(s, "i");
if (crc32("SyVEN",5) == 3621408435) strcat(s, "h");
if (crc32("GnzXWpj",7) == 2018438149) strcat(s, "c");
if (crc32("pqflHRUdmV",10) == 3892829240) strcat(s, "a");
if (crc32("IIKZRHLWGP",10) == 1172403440) strcat(s, "l");
    return s;
}

char *batholitic_adjectives() {
    char *s = calloc(11);
    if (crc32("SygNGstv",8) == 2533931272) strcat(s, "b");
if (crc32("VzEJZgEHEzepNNZ",15) == 3882775578) strcat(s, "a");
if (crc32("vvSGQ",5) == 860501371) strcat(s, "t");
if (crc32("LBxqZWYkdHvsEVX",15) == 1498498516) strcat(s, "h");
if (crc32("lYIslDrc",8) == 232735091) strcat(s, "o");
if (crc32("JWcvjUxeyIbp",12) == 2713352391) strcat(s, "l");
if (crc32("PJjQruBUCgTz",12) == 2564666429) strcat(s, "i");
if (crc32("EPrUk",5) == 426538253) strcat(s, "W");
if (crc32("LpwrdRhiioEI",12) == 1838916459) strcat(s, "t");
if (crc32("BToCpRDluwKCW",13) == 2900180410) strcat(s, "b");
if (crc32("HauBoBq",7) == 2412324774) strcat(s, "i");
if (crc32("dqicyp",6) == 2207684301) strcat(s, "f");
if (crc32("TlyRBCmf",8) == 2716186318) strcat(s, "c");
    return s;
}

char *sugarcandy_adjectives() {
    char *s = calloc(11);
    if (crc32("sQdjlHLqINLXj",13) == 3747555406) strcat(s, "x");
if (crc32("THJVJvefVHBSDkP",15) == 4176904990) strcat(s, "s");
if (crc32("plgYhQmN",8) == 2112663771) strcat(s, "u");
if (crc32("XuZqQZRnUDIH",12) == 749213480) strcat(s, "u");
if (crc32("TglNHrAwV",9) == 1346791267) strcat(s, "g");
if (crc32("TdafL",5) == 1291276695) strcat(s, "M");
if (crc32("oPpFlWvnFUSQxt",14) == 1496009477) strcat(s, "a");
if (crc32("GTIgiKm",7) == 524636270) strcat(s, "r");
if (crc32("IYdPmdFWCk",10) == 1454364008) strcat(s, "H");
if (crc32("tJnyjzRCq",9) == 1087486789) strcat(s, "c");
if (crc32("VwszGBQVUKYrgC",14) == 878940870) strcat(s, "c");
if (crc32("BXACIeidDZwS",12) == 3099803349) strcat(s, "a");
if (crc32("KXUOXR",6) == 51511002) strcat(s, "X");
if (crc32("aRbdoDmDgfy",11) == 2853009918) strcat(s, "n");
if (crc32("HsbkixCqbhK",11) == 3616565009) strcat(s, "d");
if (crc32("uBYVcPrAsGEYLr",14) == 292801601) strcat(s, "b");
if (crc32("cLXDpqqWdcxHzCT",15) == 1477253469) strcat(s, "y");
    return s;
}

char *wellconstricted_adjectives() {
    char *s = calloc(16);
    if (crc32("EJcZBS",6) == 2719827960) strcat(s, "s");
if (crc32("gGfbe",5) == 3451525028) strcat(s, "w");
if (crc32("HOtERBMvzco",11) == 2476877069) strcat(s, "P");
if (crc32("UHHZRFd",7) == 1081989693) strcat(s, "e");
if (crc32("MbOKNZcpJWirbt",14) == 2976655365) strcat(s, "p");
if (crc32("XmjfFzppue",10) == 1997917218) strcat(s, "l");
if (crc32("owpPxZbJWm",10) == 2392402333) strcat(s, "z");
if (crc32("rFiMFt",6) == 4022098748) strcat(s, "l");
if (crc32("KflhGcSmY",9) == 3705662476) strcat(s, "G");
if (crc32("dsklPO",6) == 1843869155) strcat(s, "c");
if (crc32("OwhzF",5) == 3871494113) strcat(s, "o");
if (crc32("WxpvJquJHFam",12) == 1694760889) strcat(s, "R");
if (crc32("zLwLuyNqczX",11) == 1169201820) strcat(s, "n");
if (crc32("vmScJDHsMWC",11) == 1264895978) strcat(s, "s");
if (crc32("YWtoIYlsUJNQrs",14) == 2964752089) strcat(s, "J");
if (crc32("scgfdqxrUqjZ",12) == 988024216) strcat(s, "t");
if (crc32("JkYdgLzKAbflCLt",15) == 2849793008) strcat(s, "K");
if (crc32("aqsCJ",5) == 2853768280) strcat(s, "r");
if (crc32("qLAkfW",6) == 1295898976) strcat(s, "i");
if (crc32("nmSPQ",5) == 1102856593) strcat(s, "c");
if (crc32("TFDjlpBwKYnUEZY",15) == 3162779247) strcat(s, "c");
if (crc32("lsUJTERZVEBK",12) == 253161895) strcat(s, "r");
if (crc32("cSqpERGj",8) == 3246044901) strcat(s, "t");
if (crc32("YlqDBBjk",8) == 153207581) strcat(s, "e");
if (crc32("ProuJqxXkyjo",12) == 2473622547) strcat(s, "d");
    return s;
}

char *unconciliative_adjectives() {
    char *s = calloc(15);
    if (crc32("brOLPthIterQU",13) == 298256601) strcat(s, "W");
if (crc32("wCtZfBkygGLxJQ",14) == 1494710164) strcat(s, "u");
if (crc32("gXZSxdchhLhKm",13) == 3463355521) strcat(s, "Y");
if (crc32("sdXmGZEv",8) == 3942366241) strcat(s, "n");
if (crc32("BSnfSfMjVnzB",12) == 85077847) strcat(s, "d");
if (crc32("PwaIOtNEhixlUk",14) == 1165015171) strcat(s, "c");
if (crc32("WanlxXb",7) == 1685634031) strcat(s, "o");
if (crc32("anUTnYtjGsDHcuu",15) == 741366776) strcat(s, "n");
if (crc32("MBECvcVgX",9) == 4024047068) strcat(s, "L");
if (crc32("eDAjDnCQJUZkCaV",15) == 631461811) strcat(s, "c");
if (crc32("oYkxInh",7) == 1277586798) strcat(s, "i");
if (crc32("oYZeVCuoyTYAty",14) == 4228938260) strcat(s, "l");
if (crc32("EVihkIhvFn",10) == 373700473) strcat(s, "Z");
if (crc32("SgEfSAgLaszim",13) == 133771166) strcat(s, "i");
if (crc32("IjbmPxIUQ",9) == 3003753250) strcat(s, "l");
if (crc32("jaHKY",5) == 3918113649) strcat(s, "a");
if (crc32("StOSeKKO",8) == 1069809739) strcat(s, "O");
if (crc32("SbwJHwiywXy",11) == 2592420577) strcat(s, "t");
if (crc32("ZFTeaA",6) == 3156909317) strcat(s, "i");
if (crc32("uoGFNbDViQxeDEG",15) == 1752802086) strcat(s, "v");
if (crc32("tZWWtqPKL",9) == 2815668796) strcat(s, "e");
    return s;
}

char *polarographic_adjectives() {
    char *s = calloc(14);
    if (crc32("xBPGLBxO",8) == 2825926804) strcat(s, "A");
if (crc32("JrBxUQz",7) == 3460481717) strcat(s, "p");
if (crc32("UHvZycxOw",9) == 942298017) strcat(s, "o");
if (crc32("ljKfpnaTVvY",11) == 769378772) strcat(s, "t");
if (crc32("frxWDfOcvpZoON",14) == 3675504738) strcat(s, "l");
if (crc32("oMQQuugQ",8) == 1820555114) strcat(s, "O");
if (crc32("IEPGuwjVu",9) == 2329507861) strcat(s, "a");
if (crc32("DwvxrXeSsD",10) == 210335567) strcat(s, "r");
if (crc32("SgmFOXGwWgMQ",12) == 1000338283) strcat(s, "o");
if (crc32("AlWYSvICq",9) == 1507170607) strcat(s, "h");
if (crc32("leCAOdkJWNbe",12) == 1922267806) strcat(s, "g");
if (crc32("dkYqJIiGMYrGyZQ",15) == 3837849445) strcat(s, "r");
if (crc32("vWOBhyO",7) == 3987027488) strcat(s, "x");
if (crc32("IGFYCQpt",8) == 2731963924) strcat(s, "a");
if (crc32("vEZcdv",6) == 2210846445) strcat(s, "i");
if (crc32("riTAsYG",7) == 4063097498) strcat(s, "p");
if (crc32("ZCZjHLvq",8) == 3556212818) strcat(s, "h");
if (crc32("IGZnvbuvokj",11) == 1174314678) strcat(s, "i");
if (crc32("ZULlSfLhyCGP",12) == 1313938339) strcat(s, "D");
if (crc32("AOWwVRU",7) == 108550747) strcat(s, "c");
    return s;
}

char *uxorious_adjectives() {
    char *s = calloc(9);
    if (crc32("jfdtgdTmKA",10) == 2888054791) strcat(s, "C");
if (crc32("JhbauTZrJVoOFY",14) == 1992206657) strcat(s, "u");
if (crc32("ghnXdfmJilw",11) == 3058334489) strcat(s, "x");
if (crc32("bgJofrCtP",9) == 2882208104) strcat(s, "Q");
if (crc32("fpLEhUFC",8) == 2857660494) strcat(s, "o");
if (crc32("TRTVCf",6) == 936732085) strcat(s, "r");
if (crc32("tWsmEwtSQExQ",12) == 3835068859) strcat(s, "i");
if (crc32("HdLbvAKVrQYoBR",14) == 2813431350) strcat(s, "o");
if (crc32("iWjltdzzU",9) == 914094814) strcat(s, "u");
if (crc32("wpzepaTrMyHi",12) == 3944013600) strcat(s, "T");
if (crc32("CMSfaaEfiyHNid",14) == 404601051) strcat(s, "s");
    return s;
}

char *untissued_adjectives() {
    char *s = calloc(10);
    if (crc32("FuvnIKsFJ",9) == 1830554092) strcat(s, "u");
if (crc32("cSCmMwkn",8) == 1740054997) strcat(s, "Y");
if (crc32("pcTiXPPJqpc",11) == 836133952) strcat(s, "n");
if (crc32("uRUpcMPMNDa",11) == 1104672613) strcat(s, "t");
if (crc32("rkFGiwdQIbF",11) == 92019450) strcat(s, "Y");
if (crc32("FJPwZBbSa",9) == 1709204227) strcat(s, "i");
if (crc32("WSyUSdw",7) == 1478481381) strcat(s, "s");
if (crc32("OzHskc",6) == 2588640387) strcat(s, "R");
if (crc32("txzhGxS",7) == 1335618461) strcat(s, "s");
if (crc32("bXdLIyAvOWd",11) == 2765822358) strcat(s, "u");
if (crc32("IoZFkYFJf",9) == 1105254537) strcat(s, "e");
if (crc32("fNQRujNO",8) == 833370168) strcat(s, "B");
if (crc32("vMytUz",6) == 4262055214) strcat(s, "d");
    return s;
}

char *dyostyle_adjectives() {
    char *s = calloc(9);
    if (crc32("zhHfYogwShoJ",12) == 3189819577) strcat(s, "v");
if (crc32("RMYKebrb",8) == 2856389747) strcat(s, "d");
if (crc32("XOZyJFhZVPD",11) == 3174214296) strcat(s, "o");
if (crc32("hfjmcJdhsU",10) == 3560508692) strcat(s, "y");
if (crc32("YIbeGhQc",8) == 3710580649) strcat(s, "o");
if (crc32("YmbNVy",6) == 3966518777) strcat(s, "b");
if (crc32("afzCxPKiLRFhvT",14) == 3308050351) strcat(s, "s");
if (crc32("tFsfNCugjjy",11) == 2955221751) strcat(s, "R");
if (crc32("nJZBMcua",8) == 2215399051) strcat(s, "t");
if (crc32("EWHYfgXelDg",11) == 1198610746) strcat(s, "y");
if (crc32("PHdRZGxspNNGDM",14) == 3536786268) strcat(s, "l");
if (crc32("qEHlt",5) == 1324604315) strcat(s, "e");
    return s;
}

char *nondeflective_adjectives() {
    char *s = calloc(14);
    if (crc32("pkuXxW",6) == 3041762618) strcat(s, "s");
if (crc32("YpHRMEBIln",10) == 383493985) strcat(s, "n");
if (crc32("wKTLCRefuYYGjN",14) == 4210434990) strcat(s, "Z");
if (crc32("GPFfnahlZ",9) == 1358985777) strcat(s, "o");
if (crc32("tFRlnCCvADttslW",15) == 696411213) strcat(s, "y");
if (crc32("tzHTtimWNRHAI",13) == 3760038327) strcat(s, "n");
if (crc32("DieQLjTEDHmo",12) == 9919420) strcat(s, "d");
if (crc32("rezJNWmuL",9) == 2595814917) strcat(s, "e");
if (crc32("BEzsPvdOm",9) == 1520756570) strcat(s, "q");
if (crc32("pSwbfXWXWNuWmt",14) == 3375696602) strcat(s, "f");
if (crc32("VwwKUrbp",8) == 1254663195) strcat(s, "l");
if (crc32("isMCpvvYyNej",12) == 939227209) strcat(s, "e");
if (crc32("pHpaFpdNaPRUjZ",14) == 2931578782) strcat(s, "c");
if (crc32("jOjYZhOYvxpQR",13) == 1506292877) strcat(s, "t");
if (crc32("UnRivl",6) == 3504354638) strcat(s, "i");
if (crc32("iqaIpFtB",8) == 3738432119) strcat(s, "A");
if (crc32("QsJTrBsHn",9) == 2693385084) strcat(s, "v");
if (crc32("FVgGgcZKWJ",10) == 1510676925) strcat(s, "e");
    return s;
}

char *odourful_adjectives() {
    char *s = calloc(9);
    if (crc32("iBhsceNJ",8) == 1567109971) strcat(s, "J");
if (crc32("xdFiaByuFUz",11) == 1363122474) strcat(s, "o");
if (crc32("IoUocZGycxMIDe",14) == 253617387) strcat(s, "d");
if (crc32("hLniKErGqzAks",13) == 2744825547) strcat(s, "K");
if (crc32("xWCMxUBHawo",11) == 706230665) strcat(s, "o");
if (crc32("XpkXiaKlQda",11) == 1820288061) strcat(s, "N");
if (crc32("KGfNAJVkNXdqy",13) == 3271726174) strcat(s, "u");
if (crc32("KXkEYQZKzhb",11) == 4123438677) strcat(s, "L");
if (crc32("FQHDezhHkAsNY",13) == 3651053057) strcat(s, "r");
if (crc32("XvLzayYNa",9) == 3924412908) strcat(s, "f");
if (crc32("LHxwNvSLzeil",12) == 1299767733) strcat(s, "u");
if (crc32("maBiHCM",7) == 4084478229) strcat(s, "L");
if (crc32("TjmOrjfneVH",11) == 4250789913) strcat(s, "l");
    return s;
}

char *forethoughtful_adjectives() {
    char *s = calloc(15);
    if (crc32("gKMPeJ",6) == 5336613) strcat(s, "f");
if (crc32("oKBufkSidj",10) == 3485377774) strcat(s, "K");
if (crc32("sHjHV",5) == 3642254058) strcat(s, "o");
if (crc32("kULECIbT",8) == 657206468) strcat(s, "z");
if (crc32("TmjAXytOEUJEhhb",15) == 1577958070) strcat(s, "r");
if (crc32("PLBWT",5) == 176741079) strcat(s, "d");
if (crc32("ADbgp",5) == 2251152028) strcat(s, "e");
if (crc32("YSWVcT",6) == 2810932176) strcat(s, "p");
if (crc32("lQIPKUxnAEhi",12) == 4154105365) strcat(s, "t");
if (crc32("EqnGijwEVAzOMwh",15) == 2469367319) strcat(s, "l");
if (crc32("vZCxEl",6) == 72597533) strcat(s, "h");
if (crc32("fdiwFjiqoMjMd",13) == 3214772485) strcat(s, "o");
if (crc32("vEoXnWxihM",10) == 759730507) strcat(s, "B");
if (crc32("SrZruzXwrPjBh",13) == 371750190) strcat(s, "u");
if (crc32("cWryRi",6) == 131836796) strcat(s, "V");
if (crc32("qSlmZzYmiUX",11) == 3281542156) strcat(s, "g");
if (crc32("kBomvM",6) == 987771878) strcat(s, "f");
if (crc32("CoIRsDypzu",10) == 16361879) strcat(s, "h");
if (crc32("jKzVLWIXKQffSXk",15) == 1560246620) strcat(s, "N");
if (crc32("vmjUKELg",8) == 163471929) strcat(s, "t");
if (crc32("ijvGDfWCrrqd",12) == 396926447) strcat(s, "N");
if (crc32("OXAjBuI",7) == 3500940227) strcat(s, "f");
if (crc32("VvMJuCFoZfT",11) == 716920441) strcat(s, "u");
if (crc32("FASbbvGC",8) == 397524123) strcat(s, "M");
if (crc32("UUBAsw",6) == 2537865655) strcat(s, "l");
    return s;
}

char *sustentational_adjectives() {
    char *s = calloc(15);
    if (crc32("UNTDxQ",6) == 3258249658) strcat(s, "s");
if (crc32("JTNDQZtTLsoj",12) == 3784703903) strcat(s, "u");
if (crc32("cGPeEupNnou",11) == 2064166713) strcat(s, "s");
if (crc32("MsOKgWnMrPB",11) == 1561518367) strcat(s, "V");
if (crc32("omurK",5) == 3123777928) strcat(s, "t");
if (crc32("xCFQOmE",7) == 3255211734) strcat(s, "e");
if (crc32("ICSSkqouE",9) == 3264121157) strcat(s, "P");
if (crc32("ZIJremE",7) == 2031268834) strcat(s, "n");
if (crc32("kORDmTMkO",9) == 1855902097) strcat(s, "Y");
if (crc32("fuidVduaVA",10) == 2075199927) strcat(s, "t");
if (crc32("FjIcjkQLCTTS",12) == 3895099164) strcat(s, "m");
if (crc32("NnXkQJxdpDUzi",13) == 2516415495) strcat(s, "a");
if (crc32("oSzVwicBPuyb",12) == 4042400558) strcat(s, "t");
if (crc32("bXhLaRp",7) == 1931197819) strcat(s, "m");
if (crc32("dyXyPTzzs",9) == 1363721766) strcat(s, "i");
if (crc32("zQGCo",5) == 1954502678) strcat(s, "w");
if (crc32("HHwcLlbXWPk",11) == 1480133035) strcat(s, "o");
if (crc32("HosGfdypzJfEw",13) == 3899570490) strcat(s, "n");
if (crc32("HIurcKR",7) == 780204162) strcat(s, "D");
if (crc32("xyVlAWrjCu",10) == 3023139266) strcat(s, "a");
if (crc32("LfJqRTnYfaTM",12) == 4206925798) strcat(s, "B");
if (crc32("XXJlYVNdWQCs",12) == 3395351048) strcat(s, "l");
    return s;
}

char *hazardable_adjectives() {
    char *s = calloc(11);
    if (crc32("tniqXP",6) == 589182535) strcat(s, "V");
if (crc32("GimvKEyJeuhNk",13) == 260222201) strcat(s, "h");
if (crc32("lWsjx",5) == 1531049568) strcat(s, "a");
if (crc32("TmlOWC",6) == 703880288) strcat(s, "t");
if (crc32("OWDemTgNXQfdZD",14) == 3773567669) strcat(s, "z");
if (crc32("hLkOS",5) == 2216734725) strcat(s, "q");
if (crc32("KVCFkAaaS",9) == 2411624219) strcat(s, "a");
if (crc32("idaYzYvhYGkdd",13) == 32116388) strcat(s, "r");
if (crc32("OoQVCCKSMRgo",12) == 2931033604) strcat(s, "s");
if (crc32("byGuqqaueYUqqv",14) == 1564332130) strcat(s, "d");
if (crc32("bSNXAYXcDoBHUA",14) == 3232028265) strcat(s, "l");
if (crc32("iucMG",5) == 3911131789) strcat(s, "a");
if (crc32("TIgDIugoQwajQe",14) == 1782613684) strcat(s, "v");
if (crc32("xaRuVvaoYZvwMlQ",15) == 3307248608) strcat(s, "b");
if (crc32("TDqlbVbEc",9) == 1312505026) strcat(s, "l");
if (crc32("bASsakolzCtW",12) == 3420824753) strcat(s, "e");
    return s;
}

char *wellattributed_adjectives() {
    char *s = calloc(15);
    if (crc32("RQMkkku",7) == 2841208201) strcat(s, "E");
if (crc32("NxrIO",5) == 533171509) strcat(s, "w");
if (crc32("QkcyvvIICMRtDP",14) == 148860454) strcat(s, "f");
if (crc32("VyqVxIZzCFJE",12) == 1962475246) strcat(s, "e");
if (crc32("lZHgy",5) == 1476077236) strcat(s, "h");
if (crc32("lrZtFItTb",9) == 3120687915) strcat(s, "l");
if (crc32("qpTAEQnJclfL",12) == 2683084010) strcat(s, "O");
if (crc32("iNKPdHnMz",9) == 3841996005) strcat(s, "l");
if (crc32("IXbwhYDathhzUHS",15) == 2158606722) strcat(s, "a");
if (crc32("kOEANIzPbu",10) == 1014287484) strcat(s, "P");
if (crc32("fLFxODfXnNevu",13) == 2716919838) strcat(s, "t");
if (crc32("YPLtskkvHcCHm",13) == 3518360001) strcat(s, "x");
if (crc32("PUyydENGofh",11) == 1362231842) strcat(s, "t");
if (crc32("jZmNNWktYdSvd",13) == 1798177470) strcat(s, "W");
if (crc32("dtziolSOqirW",12) == 1714838517) strcat(s, "r");
if (crc32("sIJqEBhbClH",11) == 2682024783) strcat(s, "K");
if (crc32("cyqmEuYvvguSb",13) == 3052121101) strcat(s, "i");
if (crc32("GPBXeLlvmSzG",12) == 1093604198) strcat(s, "f");
if (crc32("AbhSZUOgArGpme",14) == 2085680027) strcat(s, "b");
if (crc32("OYBRMUU",7) == 3701880725) strcat(s, "F");
if (crc32("ODvYfJnAPkhLj",13) == 512286405) strcat(s, "u");
if (crc32("WSNdUN",6) == 3175589251) strcat(s, "t");
if (crc32("GkzAradKprqNaz",14) == 2453208615) strcat(s, "o");
if (crc32("lBFFDftKS",9) == 3356822246) strcat(s, "e");
if (crc32("tafKxkKGBm",10) == 97747602) strcat(s, "h");
if (crc32("fCSsLAJDX",9) == 3286922250) strcat(s, "d");
    return s;
}

char *propagative_adjectives() {
    char *s = calloc(12);
    if (crc32("NEjDerEM",8) == 2515843775) strcat(s, "p");
if (crc32("AiaZibsBnrvdHVh",15) == 1373111636) strcat(s, "r");
if (crc32("pRXyHcSsFydcDXW",15) == 882396652) strcat(s, "N");
if (crc32("zlyEzHUCCGufi",13) == 1959530113) strcat(s, "o");
if (crc32("ixJKr",5) == 2056761751) strcat(s, "t");
if (crc32("vuXUBpSKgzargvK",15) == 2039639748) strcat(s, "p");
if (crc32("mvtWAmKv",8) == 1924724466) strcat(s, "a");
if (crc32("DAGdCjCSzJQu",12) == 2999887199) strcat(s, "c");
if (crc32("IOYJPwAMU",9) == 2642333943) strcat(s, "g");
if (crc32("HWLXWTg",7) == 1416717939) strcat(s, "S");
if (crc32("fKbifO",6) == 1134656443) strcat(s, "a");
if (crc32("JDHYfutgHUI",11) == 3285177015) strcat(s, "Q");
if (crc32("JAQnIRRFTlhsoJf",15) == 2247380968) strcat(s, "t");
if (crc32("vPnaSQQNPCOFRIr",15) == 125712074) strcat(s, "Q");
if (crc32("TcDVwvenJyP",11) == 520350554) strcat(s, "i");
if (crc32("NQxXbXoNEbfd",12) == 2046772193) strcat(s, "s");
if (crc32("iMpVNtBFm",9) == 2001646215) strcat(s, "v");
if (crc32("MTlKd",5) == 984740571) strcat(s, "e");
    return s;
}

char *ambiguous_adjectives() {
    char *s = calloc(10);
    if (crc32("iJCZFNB",7) == 341672280) strcat(s, "a");
if (crc32("LZDNawg",7) == 2681700536) strcat(s, "m");
if (crc32("bXDPPdkdHCN",11) == 842333666) strcat(s, "b");
if (crc32("buAfcXprQMJHp",13) == 638033444) strcat(s, "b");
if (crc32("okvmPnXioVaqRQD",15) == 1912804187) strcat(s, "i");
if (crc32("gnJrksLc",8) == 2304437461) strcat(s, "C");
if (crc32("udtYuLVtlyAUcfD",15) == 2142988116) strcat(s, "g");
if (crc32("MaSiKdWgn",9) == 258629349) strcat(s, "a");
if (crc32("SVTzDyVUdsvEr",13) == 454599954) strcat(s, "u");
if (crc32("eWtsCdFgzQhxi",13) == 1817242606) strcat(s, "V");
if (crc32("kLYYapcCrzh",11) == 3094359176) strcat(s, "o");
if (crc32("VnJsIX",6) == 2869084351) strcat(s, "u");
if (crc32("JjXBpsKfaNh",11) == 3673845506) strcat(s, "V");
if (crc32("aupSAFHUmVda",12) == 2978752681) strcat(s, "s");
    return s;
}

char *nondamageable_adjectives() {
    char *s = calloc(14);
    if (crc32("fydaxqK",7) == 1002918404) strcat(s, "n");
if (crc32("NTrZvMrwO",9) == 961757461) strcat(s, "o");
if (crc32("zMGSrmrpM",9) == 1000714959) strcat(s, "G");
if (crc32("ZDRUqXjy",8) == 2815588878) strcat(s, "n");
if (crc32("EJfMcq",6) == 3191670298) strcat(s, "Z");
if (crc32("dtdCRAg",7) == 3266948704) strcat(s, "d");
if (crc32("mrWLv",5) == 3074153697) strcat(s, "R");
if (crc32("dAwxWnFWMJRXh",13) == 3078916538) strcat(s, "a");
if (crc32("GUFSQmPzFlVKDjr",15) == 1422297572) strcat(s, "m");
if (crc32("qcVvMJMgqhYdH",13) == 3689990720) strcat(s, "a");
if (crc32("EdOCEDdxvfICMOv",15) == 322499242) strcat(s, "g");
if (crc32("kQmoERD",7) == 1585823214) strcat(s, "e");
if (crc32("HqIoOoBkuoaEK",13) == 2865680864) strcat(s, "K");
if (crc32("kJEQTBNwuuex",12) == 1067418757) strcat(s, "a");
if (crc32("KbfufGudgfMAB",13) == 3110346927) strcat(s, "g");
if (crc32("IdEKp",5) == 308020648) strcat(s, "b");
if (crc32("ZPPNMi",6) == 3958656890) strcat(s, "a");
if (crc32("BVxDFRudHFHNtQX",15) == 4231617778) strcat(s, "l");
if (crc32("iMopM",5) == 1604823559) strcat(s, "e");
    return s;
}

char *unwinsome_adjectives() {
    char *s = calloc(10);
    if (crc32("FRxLOOcOQICiC",13) == 3221464473) strcat(s, "W");
if (crc32("tOeMxWDxbpriPF",14) == 2341444264) strcat(s, "u");
if (crc32("bQgwDG",6) == 2054096596) strcat(s, "n");
if (crc32("JTQCXmpw",8) == 1276473831) strcat(s, "R");
if (crc32("Towjm",5) == 2505808222) strcat(s, "w");
if (crc32("ohoyCal",7) == 2349842878) strcat(s, "Z");
if (crc32("JnWVPaT",7) == 1474312573) strcat(s, "i");
if (crc32("hCZLuHhXSBt",11) == 707640905) strcat(s, "z");
if (crc32("gCyQGdImkH",10) == 669122390) strcat(s, "n");
if (crc32("wMYdAhkdza",10) == 3431507157) strcat(s, "s");
if (crc32("CgVNBwIMSGiJtT",14) == 2846321040) strcat(s, "o");
if (crc32("raMvEKZrWVOmvxC",15) == 3863276568) strcat(s, "m");
if (crc32("UfamlgNoazhC",12) == 2332917455) strcat(s, "e");
    return s;
}

char *forceripe_adjectives() {
    char *s = calloc(10);
    if (crc32("eizmIYKgcVQvIp",14) == 3899012034) strcat(s, "f");
if (crc32("YyzZn",5) == 1445896630) strcat(s, "o");
if (crc32("JeKboFVk",8) == 2739923113) strcat(s, "r");
if (crc32("vvhQIaffBA",10) == 5126254) strcat(s, "c");
if (crc32("dnXePKwg",8) == 1601127038) strcat(s, "e");
if (crc32("YqIzkmcxRyBkMb",14) == 2910544228) strcat(s, "r");
if (crc32("JIARkP",6) == 891406143) strcat(s, "M");
if (crc32("TeEKvSfRnxmqUTd",15) == 913565313) strcat(s, "i");
if (crc32("akIjgp",6) == 1164832285) strcat(s, "p");
if (crc32("ctXsg",5) == 1233546381) strcat(s, "e");
    return s;
}

char *downy_adjectives() {
    char *s = calloc(6);
    if (crc32("sajUVgYPPb",10) == 492912897) strcat(s, "T");
if (crc32("eeqVncBoz",9) == 3590613450) strcat(s, "d");
if (crc32("Xuzxl",5) == 611253487) strcat(s, "h");
if (crc32("SljqxGX",7) == 1879863948) strcat(s, "o");
if (crc32("oZhWMhXBPNxhro",14) == 1565686040) strcat(s, "w");
if (crc32("iXolxslMrFkr",12) == 1722526089) strcat(s, "n");
if (crc32("PRloYBBUSagn",12) == 3235821798) strcat(s, "G");
if (crc32("VJOHQUZhseEEhy",14) == 930255560) strcat(s, "y");
    return s;
}

char *epsilondelta_adjectives() {
    char *s = calloc(13);
    if (crc32("VjhLxombAPPmuBC",15) == 2132916624) strcat(s, "e");
if (crc32("EFnWrZaP",8) == 1768210554) strcat(s, "K");
if (crc32("hiFHjS",6) == 1824612690) strcat(s, "p");
if (crc32("UzzdsMRUIXDQjIm",15) == 217635524) strcat(s, "s");
if (crc32("ztPwgkerIYPE",12) == 4021262540) strcat(s, "I");
if (crc32("TqaLSBCMygXZ",12) == 4268137528) strcat(s, "i");
if (crc32("tDRLbikyPy",10) == 4270192725) strcat(s, "l");
if (crc32("KEggT",5) == 2688849138) strcat(s, "N");
if (crc32("wEnLy",5) == 373705846) strcat(s, "o");
if (crc32("JTEyJZStUh",10) == 2409916623) strcat(s, "n");
if (crc32("hURHc",5) == 278633968) strcat(s, "K");
if (crc32("bhJAdMsWZ",9) == 2664563041) strcat(s, "d");
if (crc32("NqIpWiYNopF",11) == 1375403286) strcat(s, "p");
if (crc32("MAeuSIc",7) == 3934121690) strcat(s, "e");
if (crc32("hnzGYFZzSJmpWd",14) == 1423082627) strcat(s, "o");
if (crc32("bkMyHBMltoHfiB",14) == 1221626103) strcat(s, "l");
if (crc32("SGbbtsxBjXb",11) == 4015403461) strcat(s, "t");
if (crc32("kJDlAbQl",8) == 1334639349) strcat(s, "a");
    return s;
}

char *pseudolateral_adjectives() {
    char *s = calloc(14);
    if (crc32("oMHBCzU",7) == 4223401747) strcat(s, "G");
if (crc32("OBaQfrhhKoKxEm",14) == 2122072073) strcat(s, "p");
if (crc32("nNfZENR",7) == 4177284680) strcat(s, "M");
if (crc32("rwjSaml",7) == 667186475) strcat(s, "s");
if (crc32("wBOkGYyIgN",10) == 2341292680) strcat(s, "e");
if (crc32("IuTDYDFpXvvGh",13) == 4249380999) strcat(s, "C");
if (crc32("rZwYkNBrFwXz",12) == 2526390563) strcat(s, "u");
if (crc32("GlGfoRxzkyl",11) == 2489939536) strcat(s, "q");
if (crc32("fJIqqyyOib",10) == 1187790378) strcat(s, "d");
if (crc32("kNtJZpVo",8) == 3217711890) strcat(s, "o");
if (crc32("oAHvZ",5) == 1441432308) strcat(s, "s");
if (crc32("QcmIGaWqAJ",10) == 2151823934) strcat(s, "l");
if (crc32("DUyIEQzvIn",10) == 2872827945) strcat(s, "a");
if (crc32("rAMMFgLUuGPwwQO",15) == 2952733941) strcat(s, "t");
if (crc32("tRIipGfL",8) == 387976262) strcat(s, "e");
if (crc32("bpjilysc",8) == 1383155996) strcat(s, "P");
if (crc32("ckJoxIKS",8) == 930676996) strcat(s, "r");
if (crc32("IUeHYNipddLsxg",14) == 3397689922) strcat(s, "a");
if (crc32("OGrStrOkqGc",11) == 810659411) strcat(s, "O");
if (crc32("NceQBpYCe",9) == 2089608424) strcat(s, "l");
    return s;
}

char *branniest_adjectives() {
    char *s = calloc(10);
    if (crc32("iHxxo",5) == 2076755899) strcat(s, "l");
if (crc32("jQhbKshubcjwS",13) == 596641721) strcat(s, "b");
if (crc32("ESbZWrkWarbwL",13) == 333612178) strcat(s, "r");
if (crc32("LnWfqwqGU",9) == 3762373326) strcat(s, "a");
if (crc32("jawXnVKaS",9) == 3224926805) strcat(s, "n");
if (crc32("SSWVEeonAgBqWC",14) == 3410747014) strcat(s, "n");
if (crc32("znbtrnLep",9) == 2744865938) strcat(s, "i");
if (crc32("YuZXWjSWEiS",11) == 2728186917) strcat(s, "a");
if (crc32("dpYLVquaO",9) == 695099947) strcat(s, "e");
if (crc32("WebGNRVEyQBrSSM",15) == 373476560) strcat(s, "p");
if (crc32("UcaDHao",7) == 229052250) strcat(s, "s");
if (crc32("gjUposdwm",9) == 2611278247) strcat(s, "t");
    return s;
}

char *calfless_adjectives() {
    char *s = calloc(9);
    if (crc32("MlEGPUPKml",10) == 228592894) strcat(s, "c");
if (crc32("oQWSJuEVBi",10) == 1186603912) strcat(s, "a");
if (crc32("rrcvtexIMQK",11) == 219975704) strcat(s, "S");
if (crc32("aeNajBx",7) == 1427958519) strcat(s, "l");
if (crc32("kPPnDCWuilzMU",13) == 481317043) strcat(s, "D");
if (crc32("ArsBUSVSqyfpOr",14) == 673821694) strcat(s, "f");
if (crc32("JxBopiSbiTUs",12) == 70828544) strcat(s, "l");
if (crc32("operfSYMSCEg",12) == 1280114749) strcat(s, "e");
if (crc32("JqxjFVa",7) == 2182335786) strcat(s, "s");
if (crc32("XjNIE",5) == 3352528361) strcat(s, "s");
    return s;
}

char *dutiable_adjectives() {
    char *s = calloc(9);
    if (crc32("eyTnFJ",6) == 3303593277) strcat(s, "H");
if (crc32("UrRrpgCOZVQQn",13) == 1488958008) strcat(s, "d");
if (crc32("IKpvJHlqlpln",12) == 583985257) strcat(s, "w");
if (crc32("fghXapBMhzjSBd",14) == 1607549034) strcat(s, "u");
if (crc32("eECnjPI",7) == 791048156) strcat(s, "t");
if (crc32("HxulphBKsIBbR",13) == 845865694) strcat(s, "i");
if (crc32("TBMYw",5) == 3891663537) strcat(s, "a");
if (crc32("gykNoOWGDCNUCp",14) == 2823381921) strcat(s, "P");
if (crc32("AWfBrQhVPw",10) == 3761347503) strcat(s, "b");
if (crc32("QvgBY",5) == 275117908) strcat(s, "l");
if (crc32("znKiUEsaqmBK",12) == 3074468421) strcat(s, "K");
if (crc32("AMwWiOqYoCQejD",14) == 963254513) strcat(s, "e");
    return s;
}

char *unsilent_adjectives() {
    char *s = calloc(9);
    if (crc32("uelUEhOIKL",10) == 901469095) strcat(s, "u");
if (crc32("AbNdsIUOSc",10) == 642801620) strcat(s, "D");
if (crc32("jICEfVKy",8) == 2691520960) strcat(s, "n");
if (crc32("cQulhPxImKzBAXC",15) == 649864182) strcat(s, "Y");
if (crc32("WmTjXxztuJKQ",12) == 6697560) strcat(s, "s");
if (crc32("ONIEYgNJjCeblh",14) == 509811876) strcat(s, "F");
if (crc32("UfFcH",5) == 1784422349) strcat(s, "i");
if (crc32("qoIUZi",6) == 2458847381) strcat(s, "l");
if (crc32("cbhwQZ",6) == 860931621) strcat(s, "C");
if (crc32("jtSJkoCuigJRR",13) == 3482840923) strcat(s, "e");
if (crc32("sXMFQR",6) == 2460600822) strcat(s, "v");
if (crc32("qtkphXaSX",9) == 2979013643) strcat(s, "n");
if (crc32("EmCypBTgtqodRlM",15) == 3836938777) strcat(s, "t");
    return s;
}

char *antiSweden_adjectives() {
    char *s = calloc(11);
    if (crc32("uueIbxYSdh",10) == 383757330) strcat(s, "a");
if (crc32("PHknOKJSX",9) == 3404805462) strcat(s, "n");
if (crc32("LHMHqZFvU",9) == 585836069) strcat(s, "T");
if (crc32("tkINsG",6) == 3206668627) strcat(s, "t");
if (crc32("cWcfCoyfms",10) == 2834813067) strcat(s, "i");
if (crc32("JIcoclofAutO",12) == 2492367913) strcat(s, "S");
if (crc32("ZbsvsxJjfUH",11) == 3621244491) strcat(s, "b");
if (crc32("ucabSPaWWPiDMR",14) == 3050601793) strcat(s, "w");
if (crc32("TiaECk",6) == 1276378969) strcat(s, "R");
if (crc32("uVsEuU",6) == 468479787) strcat(s, "e");
if (crc32("jblTvMpfnBW",11) == 2947216352) strcat(s, "w");
if (crc32("ftRkPGhlaYVo",12) == 744672242) strcat(s, "d");
if (crc32("tvesTUTZWxsmRqK",15) == 2937756362) strcat(s, "G");
if (crc32("cJfJlpONedvHx",13) == 358767029) strcat(s, "e");
if (crc32("jXJWWECK",8) == 168952565) strcat(s, "n");
    return s;
}

char *unswaggering_adjectives() {
    char *s = calloc(13);
    if (crc32("rQEILwYlXsU",11) == 2500534037) strcat(s, "u");
if (crc32("XSUzo",5) == 1968427701) strcat(s, "n");
if (crc32("cRQtgJO",7) == 3885042590) strcat(s, "a");
if (crc32("ySnaT",5) == 3119643854) strcat(s, "s");
if (crc32("yGOvyWHwDPeUwpC",15) == 3581818769) strcat(s, "Q");
if (crc32("CxRJRPszxZYhxR",14) == 1255657145) strcat(s, "w");
if (crc32("xPbpCmEF",8) == 1078073955) strcat(s, "G");
if (crc32("aCwdvAFz",8) == 1609208906) strcat(s, "a");
if (crc32("csUydwADuNVn",12) == 1889536) strcat(s, "T");
if (crc32("cWVMWeNd",8) == 2606964992) strcat(s, "g");
if (crc32("uYqnHahP",8) == 5872175) strcat(s, "g");
if (crc32("GFksrIDou",9) == 1738057125) strcat(s, "e");
if (crc32("VrNrEFhKPBX",11) == 3626418957) strcat(s, "E");
if (crc32("uXbtykg",7) == 3400641734) strcat(s, "r");
if (crc32("MjnmMEXLdu",10) == 2538254520) strcat(s, "j");
if (crc32("SDWdustbSQNYN",13) == 1211318275) strcat(s, "i");
if (crc32("ydquVJrlOgLZbNB",15) == 2331999967) strcat(s, "n");
if (crc32("biYGlFMuPReNrgP",15) == 2301324148) strcat(s, "g");
    return s;
}

char *simoniacal_adjectives() {
    char *s = calloc(11);
    if (crc32("vdFxnAbd",8) == 3623003732) strcat(s, "s");
if (crc32("ufPoNUaRQtGq",12) == 2797806834) strcat(s, "u");
if (crc32("figyEYPvwct",11) == 1996121093) strcat(s, "i");
if (crc32("QeKgBIeXXs",10) == 2771870292) strcat(s, "Y");
if (crc32("dmHMsz",6) == 3508896581) strcat(s, "m");
if (crc32("nPJQCBrrKDhnk",13) == 4101786930) strcat(s, "h");
if (crc32("etxKbqCqyTMzgF",14) == 3485842395) strcat(s, "o");
if (crc32("YqnocDbMGKfp",12) == 3146656340) strcat(s, "n");
if (crc32("UwWVsiLWPDNT",12) == 581866143) strcat(s, "i");
if (crc32("oriohjticsyT",12) == 1720041780) strcat(s, "o");
if (crc32("izwrdcCxRbLl",12) == 2221748699) strcat(s, "a");
if (crc32("HWcuqLvopIzUg",13) == 2700337393) strcat(s, "S");
if (crc32("tDGXdVzkM",9) == 3526780985) strcat(s, "c");
if (crc32("QcbZSYvR",8) == 934959273) strcat(s, "a");
if (crc32("iaxrC",5) == 53027732) strcat(s, "f");
if (crc32("wLXljTSs",8) == 2612524833) strcat(s, "l");
    return s;
}

char *softcentred_adjectives() {
    char *s = calloc(12);
    if (crc32("ufRBsIFyXT",10) == 1684716331) strcat(s, "V");
if (crc32("xyWynL",6) == 731874279) strcat(s, "s");
if (crc32("PyOahsvRrRp",11) == 393960465) strcat(s, "B");
if (crc32("WSayXjWoEpgQ",12) == 3712527199) strcat(s, "o");
if (crc32("EncUnmbJzKlrg",13) == 3976089695) strcat(s, "h");
if (crc32("siczwibxQMNm",12) == 1055544884) strcat(s, "f");
if (crc32("zcPjiRbhhlWMmj",14) == 2416566604) strcat(s, "c");
if (crc32("fYpmTfJc",8) == 2037636102) strcat(s, "t");
if (crc32("zEBsQJeTOE",10) == 3814180987) strcat(s, "c");
if (crc32("WEhko",5) == 3267358637) strcat(s, "o");
if (crc32("GubxsFUBRlGsDd",14) == 1057152473) strcat(s, "e");
if (crc32("AwYhSbPiayJzR",13) == 3030168827) strcat(s, "n");
if (crc32("lIAgFjlPmc",10) == 3798027346) strcat(s, "t");
if (crc32("HAVHnbaGgd",10) == 75751484) strcat(s, "r");
if (crc32("Fovlocdi",8) == 3070165105) strcat(s, "E");
if (crc32("staPvg",6) == 1974668446) strcat(s, "e");
if (crc32("ZBFxoBqWcFhdCoE",15) == 2716333980) strcat(s, "B");
if (crc32("mllrB",5) == 308676054) strcat(s, "d");
    return s;
}

char *quasinegligible_adjectives() {
    char *s = calloc(16);
    if (crc32("EAQnv",5) == 1526712795) strcat(s, "q");
if (crc32("XbWKetCEiKHsLL",14) == 369471695) strcat(s, "u");
if (crc32("xIaEZCAMZRh",11) == 4267610085) strcat(s, "u");
if (crc32("eboWdOXjwc",10) == 4287782898) strcat(s, "a");
if (crc32("YhmQh",5) == 1243443853) strcat(s, "c");
if (crc32("FAVduNHOZuLH",12) == 497380968) strcat(s, "s");
if (crc32("YzJQddsGwIGSP",13) == 2501042006) strcat(s, "i");
if (crc32("fyYyfEW",7) == 1506203151) strcat(s, "r");
if (crc32("RLhTwmgcyRx",11) == 3948116017) strcat(s, "n");
if (crc32("ouYBkgtfxqcWu",13) == 297281440) strcat(s, "A");
if (crc32("ZpcXO",5) == 19824335) strcat(s, "e");
if (crc32("dtuYYk",6) == 2690691516) strcat(s, "g");
if (crc32("hMpCZ",5) == 4186667332) strcat(s, "h");
if (crc32("uNLjCMQuRICBW",13) == 32716208) strcat(s, "l");
if (crc32("gakGQRWJDst",11) == 1337250789) strcat(s, "i");
if (crc32("evXCQ",5) == 2083779276) strcat(s, "g");
if (crc32("cKYemmt",7) == 3160547742) strcat(s, "i");
if (crc32("HRDRavJSwhe",11) == 3629396) strcat(s, "u");
if (crc32("fTjgDzPJYvf",11) == 417623616) strcat(s, "b");
if (crc32("Xnsafp",6) == 606138733) strcat(s, "l");
if (crc32("rElUf",5) == 1307495920) strcat(s, "b");
if (crc32("dGeYWALlOB",10) == 2752990984) strcat(s, "e");
    return s;
}

char *platinic_adjectives() {
    char *s = calloc(9);
    if (crc32("BSTHpxhExG",10) == 373161358) strcat(s, "Y");
if (crc32("VNdoGTTD",8) == 2823323117) strcat(s, "p");
if (crc32("XSEspx",6) == 2771411164) strcat(s, "l");
if (crc32("jQFid",5) == 3974526187) strcat(s, "a");
if (crc32("fqPTDTdOMx",10) == 4129464442) strcat(s, "M");
if (crc32("zOKpcKd",7) == 2091214736) strcat(s, "t");
if (crc32("oaidYbKkjAmQ",12) == 2834632246) strcat(s, "i");
if (crc32("pZlSCzt",7) == 2836334852) strcat(s, "n");
if (crc32("rbvXQBCUpdtVuNb",15) == 1011030594) strcat(s, "N");
if (crc32("aGtRYGxpJ",9) == 121385687) strcat(s, "i");
if (crc32("wRZKFzivjPfNcF",14) == 1480586268) strcat(s, "m");
if (crc32("yYfJsbO",7) == 3403262496) strcat(s, "c");
    return s;
}

char *anginal_adjectives() {
    char *s = calloc(8);
    if (crc32("MJIwlqKYS",9) == 1564650500) strcat(s, "K");
if (crc32("YoaayFHlSPADR",13) == 459539352) strcat(s, "a");
if (crc32("RzRFGZBoOJw",11) == 3415631669) strcat(s, "n");
if (crc32("ABQMaVDmk",9) == 1168685934) strcat(s, "g");
if (crc32("DrFUCVAm",8) == 3071842481) strcat(s, "p");
if (crc32("fJQItItjwDmDZw",14) == 693960656) strcat(s, "i");
if (crc32("oNCFM",5) == 2048515768) strcat(s, "n");
if (crc32("mPsICQO",7) == 351433865) strcat(s, "a");
if (crc32("fznAmW",6) == 61330877) strcat(s, "l");
if (crc32("yVsyAGT",7) == 879263677) strcat(s, "l");
    return s;
}

char *lofty_adjectives() {
    char *s = calloc(6);
    if (crc32("tADhINtvqGk",11) == 1121490058) strcat(s, "l");
if (crc32("sJvCSc",6) == 1469213832) strcat(s, "o");
if (crc32("ZWOtPODZy",9) == 2568794404) strcat(s, "f");
if (crc32("kQKTGCwK",8) == 1351153778) strcat(s, "B");
if (crc32("StVIqOpvjt",10) == 3084426885) strcat(s, "t");
if (crc32("PfWeBQEjwLGu",12) == 3702305432) strcat(s, "o");
if (crc32("swRPAB",6) == 193877362) strcat(s, "y");
    return s;
}

char *jetpropulsion_adjectives() {
    char *s = calloc(14);
    if (crc32("vmBhsblY",8) == 3884458103) strcat(s, "j");
if (crc32("ytgMOkYRddOK",12) == 3976225426) strcat(s, "e");
if (crc32("arICOhkSqa",10) == 144435821) strcat(s, "u");
if (crc32("entptogwqJN",11) == 1988825004) strcat(s, "t");
if (crc32("NHFalituP",9) == 2275106839) strcat(s, "d");
if (crc32("GViyy",5) == 1387649202) strcat(s, "p");
if (crc32("jyuiLOdqsEpuSRE",15) == 2978644882) strcat(s, "r");
if (crc32("ZFpEzGC",7) == 2673601624) strcat(s, "o");
if (crc32("usAkmcg",7) == 4197960330) strcat(s, "p");
if (crc32("FqMMpJ",6) == 75222694) strcat(s, "u");
if (crc32("NNCilNSp",8) == 2592668598) strcat(s, "l");
if (crc32("FpNVCLOc",8) == 373002042) strcat(s, "E");
if (crc32("xafmYdTxaTlu",12) == 3543776447) strcat(s, "s");
if (crc32("yvDOXb",6) == 470935499) strcat(s, "j");
if (crc32("MWkVdSKjqXXpI",13) == 3340229485) strcat(s, "i");
if (crc32("rxfdURhGbDqrIrs",15) == 1941725541) strcat(s, "o");
if (crc32("kLDJoUosgWunW",13) == 1945722941) strcat(s, "n");
    return s;
}

char *composable_adjectives() {
    char *s = calloc(11);
    if (crc32("nXMoRJB",7) == 228034186) strcat(s, "A");
if (crc32("kyvVTjXfNo",10) == 155061621) strcat(s, "c");
if (crc32("FHCtbh",6) == 3468397642) strcat(s, "o");
if (crc32("wYngSJbDcx",10) == 3430227991) strcat(s, "m");
if (crc32("lcZHWBUmZVlw",12) == 788097414) strcat(s, "p");
if (crc32("sjcSLzSrivC",11) == 853838512) strcat(s, "o");
if (crc32("jTcwYqFLd",9) == 3604330448) strcat(s, "s");
if (crc32("vdYKWBrp",8) == 627337332) strcat(s, "N");
if (crc32("fCMPYTwL",8) == 1328868102) strcat(s, "a");
if (crc32("spBDaMsrBENb",12) == 1914799920) strcat(s, "b");
if (crc32("YJrCjZ",6) == 1012687972) strcat(s, "Z");
if (crc32("ciuKMCsfAYaDZ",13) == 3998417391) strcat(s, "l");
if (crc32("gJhxozv",7) == 3940555908) strcat(s, "g");
if (crc32("CvGeFPDfjiY",11) == 2250347110) strcat(s, "e");
    return s;
}

char *sublunate_adjectives() {
    char *s = calloc(10);
    if (crc32("ukplJdRX",8) == 160035514) strcat(s, "s");
if (crc32("oRzSHd",6) == 313798874) strcat(s, "u");
if (crc32("zPrbUcXtuq",10) == 674580593) strcat(s, "b");
if (crc32("swBdaioFY",9) == 3693097361) strcat(s, "l");
if (crc32("HXeMOrB",7) == 373206457) strcat(s, "n");
if (crc32("VZfYEnoxGy",10) == 3336883421) strcat(s, "u");
if (crc32("pWYupsYc",8) == 3086552874) strcat(s, "n");
if (crc32("NVKVbw",6) == 1570568429) strcat(s, "o");
if (crc32("HIsjBMQhexwD",12) == 1403877180) strcat(s, "a");
if (crc32("kADiTpybL",9) == 1782983134) strcat(s, "a");
if (crc32("mXAWkBF",7) == 3186348992) strcat(s, "t");
if (crc32("FjhFAzylulMawEN",15) == 1748264140) strcat(s, "e");
    return s;
}

char *tailheavy_adjectives() {
    char *s = calloc(10);
    if (crc32("fbRoTC",6) == 2668669575) strcat(s, "t");
if (crc32("BgnYS",5) == 2578592759) strcat(s, "a");
if (crc32("uqrnhcHbRVLk",12) == 2831015555) strcat(s, "i");
if (crc32("npRYHX",6) == 3384973924) strcat(s, "U");
if (crc32("nOjUBoPOmYC",11) == 3354285660) strcat(s, "l");
if (crc32("YgYMkBpvB",9) == 2380578689) strcat(s, "h");
if (crc32("rTcphITHB",9) == 615033194) strcat(s, "o");
if (crc32("XgTsoCwrKVpHbv",14) == 3717365075) strcat(s, "e");
if (crc32("xEOJBVF",7) == 859106037) strcat(s, "a");
if (crc32("lVlyMRJSlFehjHw",15) == 2609205119) strcat(s, "v");
if (crc32("HIIPbvRYJQHFDE",14) == 2826312708) strcat(s, "y");
    return s;
}

char *phenotypic_adjectives() {
    char *s = calloc(11);
    if (crc32("xRFCJSRxuQW",11) == 2260282768) strcat(s, "q");
if (crc32("BuGcYPRHDPogxgx",15) == 2008195924) strcat(s, "p");
if (crc32("wTvDxmLPGQUKp",13) == 1231373869) strcat(s, "h");
if (crc32("UXZQbaxIKGV",11) == 750053456) strcat(s, "k");
if (crc32("fncsLeob",8) == 1178222420) strcat(s, "e");
if (crc32("eeJmte",6) == 4191871782) strcat(s, "o");
if (crc32("PGjSOXc",7) == 2076307198) strcat(s, "n");
if (crc32("UlgNScnSqv",10) == 2788363247) strcat(s, "o");
if (crc32("FKhPtXLGbItFmeN",15) == 3920364513) strcat(s, "t");
if (crc32("rURwqUJkiTVUau",14) == 2309520097) strcat(s, "K");
if (crc32("owoEXAbErUz",11) == 3858149433) strcat(s, "y");
if (crc32("DsuIPOcOEU",10) == 2789616601) strcat(s, "A");
if (crc32("tBPfWCI",7) == 1545747186) strcat(s, "p");
if (crc32("ukoobW",6) == 1158836298) strcat(s, "X");
if (crc32("nzegu",5) == 2691502033) strcat(s, "i");
if (crc32("XtVxXzzSlKYRM",13) == 3412460448) strcat(s, "c");
    return s;
}

char *prorestoration_adjectives() {
    char *s = calloc(15);
    if (crc32("tYRPt",5) == 4271825813) strcat(s, "p");
if (crc32("zGsPAV",6) == 2415173658) strcat(s, "r");
if (crc32("JuQUPu",6) == 1192780639) strcat(s, "D");
if (crc32("uCzxvQl",7) == 12680617) strcat(s, "o");
if (crc32("CuZeeZDmCp",10) == 2632829896) strcat(s, "w");
if (crc32("IMresHjQ",8) == 3848894372) strcat(s, "r");
if (crc32("eAObkme",7) == 2749277268) strcat(s, "r");
if (crc32("JUvbFeCaAq",10) == 2730903195) strcat(s, "e");
if (crc32("oRHMQofsDxqFR",13) == 2378675348) strcat(s, "s");
if (crc32("JgWglufOBJaAth",14) == 2142945245) strcat(s, "t");
if (crc32("uAkpmMCPGwvEj",13) == 646461862) strcat(s, "h");
if (crc32("TkOezDVkRAW",11) == 3879161727) strcat(s, "o");
if (crc32("VSnvI",5) == 864884976) strcat(s, "l");
if (crc32("XqKdiNATvj",10) == 4055406761) strcat(s, "r");
if (crc32("NrlvFjepmh",10) == 1960898991) strcat(s, "a");
if (crc32("xPDDnvXeuciHwsR",15) == 4115869469) strcat(s, "t");
if (crc32("kWYtZTvKmEVWAJ",14) == 4172445589) strcat(s, "i");
if (crc32("hFbWqeqvXfHEt",13) == 3196851003) strcat(s, "G");
if (crc32("QTMeNM",6) == 4202087799) strcat(s, "o");
if (crc32("Zdbvr",5) == 3375913447) strcat(s, "m");
if (crc32("YiOeeJQpSIvx",12) == 1340283009) strcat(s, "n");
    return s;
}

char *pseudoanachronistic_adjectives() {
    char *s = calloc(20);
    if (crc32("gulsMHpbCQM",11) == 3988502806) strcat(s, "p");
if (crc32("PfVQiyHYtP",10) == 2388279382) strcat(s, "E");
if (crc32("ldaOgsNr",8) == 2753788452) strcat(s, "s");
if (crc32("ofRSCtgmFlqHZe",14) == 4076008320) strcat(s, "N");
if (crc32("AkzDLwnRBlcSnl",14) == 3421870101) strcat(s, "e");
if (crc32("YektlG",6) == 641686151) strcat(s, "l");
if (crc32("wJwMOZ",6) == 3344150948) strcat(s, "u");
if (crc32("CAkKK",5) == 1012926052) strcat(s, "y");
if (crc32("COLhcBg",7) == 773377666) strcat(s, "d");
if (crc32("VMqMO",5) == 2643321282) strcat(s, "h");
if (crc32("wzvZtRmcCJIJ",12) == 2652327870) strcat(s, "o");
if (crc32("PpiZjwoslPFjoC",14) == 1414033756) strcat(s, "a");
if (crc32("ADokEXTYR",9) == 2264509621) strcat(s, "n");
if (crc32("ulDetvilrVm",11) == 1216013451) strcat(s, "V");
if (crc32("pPdhPOPvTqp",11) == 2285424787) strcat(s, "a");
if (crc32("XrUwQusgvcIzk",13) == 4024614790) strcat(s, "c");
if (crc32("TDqbxIokjnrr",12) == 1167143296) strcat(s, "h");
if (crc32("kBxrSkDZfi",10) == 684178051) strcat(s, "r");
if (crc32("xVEJEBj",7) == 4219884838) strcat(s, "n");
if (crc32("uIqhguni",8) == 48654347) strcat(s, "o");
if (crc32("rctUlz",6) == 3725092845) strcat(s, "n");
if (crc32("lzwuWPgYAWaTyn",14) == 2676580562) strcat(s, "i");
if (crc32("oloLrwHTWzqBSbW",15) == 134265531) strcat(s, "s");
if (crc32("fQVXJm",6) == 3238902015) strcat(s, "T");
if (crc32("IBRJt",5) == 2417669607) strcat(s, "t");
if (crc32("KWWCStXlFdY",11) == 354625674) strcat(s, "P");
if (crc32("VJLgXTazODBUnU",14) == 4234827682) strcat(s, "i");
if (crc32("QsCtV",5) == 2225027143) strcat(s, "c");
if (crc32("fECaYqS",7) == 293458503) strcat(s, "c");
    return s;
}

char *unerodent_adjectives() {
    char *s = calloc(10);
    if (crc32("wCSMqlvqbHbiOdB",15) == 4229041670) strcat(s, "U");
if (crc32("wQSxcRzV",8) == 350139194) strcat(s, "u");
if (crc32("qOCQuyUMLuI",11) == 1781649301) strcat(s, "n");
if (crc32("pqicvqmxsQZbsO",14) == 768270308) strcat(s, "e");
if (crc32("jZkXkh",6) == 568725241) strcat(s, "r");
if (crc32("ktlSmr",6) == 585929990) strcat(s, "C");
if (crc32("DacRXOs",7) == 2371130395) strcat(s, "o");
if (crc32("UdcUq",5) == 1401221379) strcat(s, "e");
if (crc32("HKudRBw",7) == 1769415394) strcat(s, "d");
if (crc32("iznxjaVTB",9) == 3014341444) strcat(s, "t");
if (crc32("mwQTzSenYsHmlw",14) == 669097628) strcat(s, "e");
if (crc32("ukrRFpBaP",9) == 856824302) strcat(s, "n");
if (crc32("jpkDpyJF",8) == 2455205678) strcat(s, "O");
if (crc32("RUQshpT",7) == 207692078) strcat(s, "t");
    return s;
}

char *juicy_adjectives() {
    char *s = calloc(6);
    if (crc32("YivlUEEXE",9) == 1903679586) strcat(s, "r");
if (crc32("igQYZOkRuV",10) == 4250067770) strcat(s, "j");
if (crc32("SyDTssWrMBwcw",13) == 800637473) strcat(s, "F");
if (crc32("coCLLvfuPueAX",13) == 1787504430) strcat(s, "u");
if (crc32("soIGiWTSxoM",11) == 3627248182) strcat(s, "N");
if (crc32("KzgGIr",6) == 732632001) strcat(s, "i");
if (crc32("ToCLkLzFgO",10) == 368986091) strcat(s, "B");
if (crc32("vZPyUBKbWaS",11) == 2020453674) strcat(s, "c");
if (crc32("VFWHoqgf",8) == 279155347) strcat(s, "y");
    return s;
}

char *journalish_adjectives() {
    char *s = calloc(11);
    if (crc32("gAQdDPL",7) == 336365312) strcat(s, "j");
if (crc32("OVvQmfPmXqkiog",14) == 392437066) strcat(s, "o");
if (crc32("hlwAqGRuL",9) == 970040325) strcat(s, "V");
if (crc32("hEnmY",5) == 1124563214) strcat(s, "u");
if (crc32("qdUYlCBPOXfP",12) == 3570090085) strcat(s, "r");
if (crc32("rWhIwUWSwuQuE",13) == 445021549) strcat(s, "K");
if (crc32("oGZMzU",6) == 2962251047) strcat(s, "n");
if (crc32("WZlvawtKaSgu",12) == 2364063422) strcat(s, "a");
if (crc32("NCTsj",5) == 2210836502) strcat(s, "P");
if (crc32("uBFVetZOg",9) == 3122282412) strcat(s, "l");
if (crc32("zMvHuln",7) == 3494358821) strcat(s, "c");
if (crc32("QCVHe",5) == 666494061) strcat(s, "i");
if (crc32("wsJxZOEDBJKu",12) == 552707091) strcat(s, "V");
if (crc32("EefIr",5) == 2300802267) strcat(s, "s");
if (crc32("hjrXedPfV",9) == 3811987136) strcat(s, "h");
    return s;
}

char *paleethnologic_adjectives() {
    char *s = calloc(15);
    if (crc32("mdmEQascBkqg",12) == 3929885051) strcat(s, "p");
if (crc32("raEYtEyCdOY",11) == 1037654233) strcat(s, "a");
if (crc32("aTCznkUbWVkuc",13) == 3009218088) strcat(s, "L");
if (crc32("nBGhNwZVWaCX",12) == 33200830) strcat(s, "l");
if (crc32("OraCu",5) == 1872324848) strcat(s, "e");
if (crc32("fIaqRF",6) == 4212604590) strcat(s, "e");
if (crc32("jJznQJcmUabyqc",14) == 3182572154) strcat(s, "t");
if (crc32("MDFzpG",6) == 370093520) strcat(s, "O");
if (crc32("CnUSzH",6) == 569518058) strcat(s, "h");
if (crc32("mguhBqOrPP",10) == 2123998982) strcat(s, "N");
if (crc32("dyQqdIrzRVnN",12) == 2004202068) strcat(s, "n");
if (crc32("szlMW",5) == 2378689185) strcat(s, "o");
if (crc32("CbYxFFIIwfF",11) == 1033662704) strcat(s, "R");
if (crc32("ftxKqrCMwFFngR",14) == 3752700490) strcat(s, "l");
if (crc32("OabtxnkYDHjxal",14) == 524511174) strcat(s, "o");
if (crc32("cHocKjc",7) == 3249432728) strcat(s, "g");
if (crc32("BOPxH",5) == 3373318708) strcat(s, "K");
if (crc32("SjGgExa",7) == 3240011408) strcat(s, "i");
if (crc32("nRhdnKpqjzOijuF",15) == 1608354530) strcat(s, "S");
if (crc32("VoUoxn",6) == 2193843961) strcat(s, "c");
    return s;
}

char *muscicolous_adjectives() {
    char *s = calloc(12);
    if (crc32("wmJhvUN",7) == 3939263295) strcat(s, "m");
if (crc32("JrcosPntDOkp",12) == 954143468) strcat(s, "u");
if (crc32("OJruz",5) == 1573202291) strcat(s, "s");
if (crc32("BeOtazlpbb",10) == 3625510831) strcat(s, "w");
if (crc32("VgArTH",6) == 2450142080) strcat(s, "c");
if (crc32("KbOfmVXIo",9) == 1429459818) strcat(s, "i");
if (crc32("pOHJyxjWIjakJ",13) == 1475428257) strcat(s, "c");
if (crc32("EkKpRa",6) == 2304967937) strcat(s, "B");
if (crc32("LzpAegBGqs",10) == 2221309752) strcat(s, "o");
if (crc32("SgPHIRnDtHeV",12) == 1549587130) strcat(s, "J");
if (crc32("QIzEe",5) == 3439183296) strcat(s, "l");
if (crc32("QoaJRCavQjOWTE",14) == 1788803175) strcat(s, "o");
if (crc32("aFmaOQYfaXkne",13) == 3611472506) strcat(s, "U");
if (crc32("MNYdpg",6) == 3774214368) strcat(s, "u");
if (crc32("ILlwszlAINY",11) == 2452025416) strcat(s, "U");
if (crc32("JZboAj",6) == 4211284564) strcat(s, "s");
    return s;
}

char *Chamian_adjectives() {
    char *s = calloc(8);
    if (crc32("SgebwCDRQbCwY",13) == 4153298172) strcat(s, "G");
if (crc32("ProcJ",5) == 2757053494) strcat(s, "C");
if (crc32("kbZKaIPbZ",9) == 4057194683) strcat(s, "E");
if (crc32("vFUzXQFCkYN",11) == 3699662633) strcat(s, "h");
if (crc32("qMRKLmwSdER",11) == 3990568349) strcat(s, "X");
if (crc32("HiuOjvPrwi",10) == 3745595067) strcat(s, "a");
if (crc32("jYdklHenkYNRq",13) == 1966341656) strcat(s, "m");
if (crc32("wQzoRxXm",8) == 506111479) strcat(s, "X");
if (crc32("NtoOsUxilb",10) == 2332170732) strcat(s, "i");
if (crc32("nDJGyaDDh",9) == 1995117146) strcat(s, "J");
if (crc32("reudhjWaERGeLy",14) == 3427869094) strcat(s, "a");
if (crc32("EnbSFc",6) == 1159234640) strcat(s, "n");
    return s;
}

char *genealogical_adjectives() {
    char *s = calloc(13);
    if (crc32("kFiAPkPIowUX",12) == 3985560954) strcat(s, "g");
if (crc32("aARYOQHFEMb",11) == 2923405611) strcat(s, "e");
if (crc32("UzprQJAGQIKG",12) == 1265866565) strcat(s, "n");
if (crc32("ltIwJfaxZGHHDUp",15) == 357800912) strcat(s, "Z");
if (crc32("eCqnAyYVmU",10) == 2911422458) strcat(s, "e");
if (crc32("wlYSfaRcJMD",11) == 1147755491) strcat(s, "o");
if (crc32("SucfRt",6) == 2965819849) strcat(s, "a");
if (crc32("NNxqmzFjieKb",12) == 1384662404) strcat(s, "e");
if (crc32("evnHZat",7) == 2879303611) strcat(s, "l");
if (crc32("suncYdypypSfY",13) == 2755982478) strcat(s, "o");
if (crc32("RyHmUENUX",9) == 1270894376) strcat(s, "w");
if (crc32("LojtPHZDVZKpZO",14) == 2712751720) strcat(s, "g");
if (crc32("aESeulj",7) == 2858858380) strcat(s, "i");
if (crc32("ISsEV",5) == 331936993) strcat(s, "c");
if (crc32("HvlgXO",6) == 2512463820) strcat(s, "Y");
if (crc32("VVUrjobkj",9) == 2482311444) strcat(s, "a");
if (crc32("BFOzNvWgcM",10) == 1926695878) strcat(s, "l");
    return s;
}

char *boarish_adjectives() {
    char *s = calloc(8);
    if (crc32("fCbFUmBfAxhjP",13) == 3238056512) strcat(s, "S");
if (crc32("uFrda",5) == 624876560) strcat(s, "b");
if (crc32("ReQETPMNWEfMT",13) == 1049896282) strcat(s, "o");
if (crc32("oiiShgXSpj",10) == 3281070256) strcat(s, "a");
if (crc32("ejpVNRJ",7) == 2662930211) strcat(s, "r");
if (crc32("FVTxBBifX",9) == 3080124447) strcat(s, "d");
if (crc32("FGOihOmaoVxaj",13) == 2114833813) strcat(s, "i");
if (crc32("DdvjUCEi",8) == 2392478733) strcat(s, "s");
if (crc32("xxbXalJTOMT",11) == 2346472224) strcat(s, "R");
if (crc32("DHnDLtFh",8) == 1206689315) strcat(s, "h");
    return s;
}

char *gentled_adjectives() {
    char *s = calloc(8);
    if (crc32("FCnPFItcDNORG",13) == 420645282) strcat(s, "p");
if (crc32("vSsXYtUwKW",10) == 232463701) strcat(s, "g");
if (crc32("KkgyNbNRrvS",11) == 927552866) strcat(s, "e");
if (crc32("ycfgz",5) == 1918865916) strcat(s, "W");
if (crc32("rEuWQSist",9) == 1045290303) strcat(s, "n");
if (crc32("pknirclhbeGHeV",14) == 1719494357) strcat(s, "t");
if (crc32("iHERJ",5) == 1685408384) strcat(s, "l");
if (crc32("BPkHtXWcUJtNe",13) == 1690733705) strcat(s, "A");
if (crc32("oWMGwaDYP",9) == 2992156709) strcat(s, "e");
if (crc32("QbTWpyRk",8) == 2673433730) strcat(s, "d");
    return s;
}

char *terministic_adjectives() {
    char *s = calloc(12);
    if (crc32("DQFQcQLEFojDAnu",15) == 2774525323) strcat(s, "G");
if (crc32("RYnDKfNmdyPde",13) == 2465117144) strcat(s, "t");
if (crc32("uriGUQHQ",8) == 2823785125) strcat(s, "m");
if (crc32("RAHUagye",8) == 2390918926) strcat(s, "e");
if (crc32("texlEezy",8) == 836423553) strcat(s, "r");
if (crc32("cOMBqH",6) == 624509125) strcat(s, "G");
if (crc32("vlgLFwjflm",10) == 2339771811) strcat(s, "m");
if (crc32("dqmsMbfOIqYtDG",14) == 2927346213) strcat(s, "K");
if (crc32("hMhdWrzJp",9) == 3504795417) strcat(s, "i");
if (crc32("hfyRS",5) == 656290717) strcat(s, "J");
if (crc32("jBsFd",5) == 2666959756) strcat(s, "n");
if (crc32("chTJe",5) == 1259090214) strcat(s, "i");
if (crc32("tFweWbOof",9) == 4079773946) strcat(s, "i");
if (crc32("KsQZt",5) == 1617580868) strcat(s, "S");
if (crc32("YjklDlZBjZmlLtK",15) == 3580031652) strcat(s, "s");
if (crc32("qVdkfCEsaQ",10) == 2102428462) strcat(s, "t");
if (crc32("jrbgnseVCDbo",12) == 3045465864) strcat(s, "W");
if (crc32("DKVSS",5) == 746687091) strcat(s, "i");
if (crc32("TzYBTUsz",8) == 1535219314) strcat(s, "g");
if (crc32("kjvBtYCwlycj",12) == 240370398) strcat(s, "c");
    return s;
}

char *pretenceless_adjectives() {
    char *s = calloc(13);
    if (crc32("ZNZmyrvDUrVJv",13) == 419118715) strcat(s, "p");
if (crc32("VpRMvGwPIE",10) == 2253151967) strcat(s, "v");
if (crc32("InOAr",5) == 1687677372) strcat(s, "r");
if (crc32("irQzGWaH",8) == 3897738668) strcat(s, "c");
if (crc32("eLHkzVqYtlkTRK",14) == 2946298973) strcat(s, "e");
if (crc32("FnmjCuMdkLhAj",13) == 963146238) strcat(s, "s");
if (crc32("zTWrgIGAESmmv",13) == 947054881) strcat(s, "t");
if (crc32("DVOVlv",6) == 1529510211) strcat(s, "M");
if (crc32("jsfuGUXTaHpcRqV",15) == 186920963) strcat(s, "e");
if (crc32("IueiwFeMZ",9) == 4077238401) strcat(s, "n");
if (crc32("IEtyJPoR",8) == 3735502913) strcat(s, "c");
if (crc32("lVVgZTQqwcYAU",13) == 1810395684) strcat(s, "e");
if (crc32("eIUHCpryzbWPXo",14) == 3848737441) strcat(s, "l");
if (crc32("QYzRtpVGRzVet",13) == 2004186157) strcat(s, "n");
if (crc32("tkORlgJyIugP",12) == 2061247990) strcat(s, "e");
if (crc32("bqZAbF",6) == 3572835674) strcat(s, "g");
if (crc32("LCXlHd",6) == 3942661224) strcat(s, "s");
if (crc32("irpLeuju",8) == 2800727654) strcat(s, "s");
    return s;
}

char *unbounded_adjectives() {
    char *s = calloc(10);
    if (crc32("rBwCBiFPPFZxPnC",15) == 3583762295) strcat(s, "h");
if (crc32("TDPHM",5) == 1136035820) strcat(s, "u");
if (crc32("TFVrhQaqVCNHGC",14) == 1154656781) strcat(s, "u");
if (crc32("BQkzRPRIAjgfC",13) == 3533188624) strcat(s, "n");
if (crc32("FfNoXisMOyiZuqO",15) == 3879522634) strcat(s, "b");
if (crc32("LPwHUHGUuQWpLi",14) == 3555960315) strcat(s, "b");
if (crc32("jCOslEgY",8) == 775699960) strcat(s, "o");
if (crc32("dRIFSkE",7) == 3844670044) strcat(s, "l");
if (crc32("OzhDUUagFRPA",12) == 2320985963) strcat(s, "u");
if (crc32("NtuQEUufbUxJdt",14) == 3447973120) strcat(s, "a");
if (crc32("JBQMajdYitqTRdO",15) == 986944553) strcat(s, "n");
if (crc32("QExTrPmZRBfUl",13) == 3400329847) strcat(s, "o");
if (crc32("IaTRBo",6) == 164796319) strcat(s, "d");
if (crc32("MJEpUA",6) == 2761523798) strcat(s, "k");
if (crc32("TTVWX",5) == 3081062068) strcat(s, "e");
if (crc32("MMmPEevvpD",10) == 2177444052) strcat(s, "d");
    return s;
}

char *bolographic_adjectives() {
    char *s = calloc(12);
    if (crc32("AMbYXjMbptkin",13) == 2730316648) strcat(s, "p");
if (crc32("czUYhP",6) == 3576790733) strcat(s, "b");
if (crc32("TqRNaLHd",8) == 2595162605) strcat(s, "Z");
if (crc32("uCzLFvHs",8) == 3697558046) strcat(s, "o");
if (crc32("wGZILrWCoFcW",12) == 2950948807) strcat(s, "l");
if (crc32("AEOhFpffzo",10) == 2276699652) strcat(s, "Y");
if (crc32("psbBUxKEBuctUCZ",15) == 2895275765) strcat(s, "o");
if (crc32("LRZIttzCxuL",11) == 504197933) strcat(s, "g");
if (crc32("lBgouDiqKjpCMs",14) == 2750709184) strcat(s, "A");
if (crc32("JHszg",5) == 3664802985) strcat(s, "r");
if (crc32("tQJfCGtN",8) == 901433909) strcat(s, "S");
if (crc32("XjyNW",5) == 1510969715) strcat(s, "a");
if (crc32("GuEtdNoDdqx",11) == 1511052327) strcat(s, "p");
if (crc32("iEQagMYkDsQtSsG",15) == 3202985870) strcat(s, "p");
if (crc32("EtSyd",5) == 1756684536) strcat(s, "h");
if (crc32("CWAtauuvILmLvH",14) == 2521067871) strcat(s, "i");
if (crc32("pknRlVsaHyLNTJn",15) == 1449085568) strcat(s, "B");
if (crc32("vAjXejsZ",8) == 2323204765) strcat(s, "c");
    return s;
}

char *preCopernican_adjectives() {
    char *s = calloc(14);
    if (crc32("RHRxSq",6) == 360032811) strcat(s, "p");
if (crc32("ZCDlyGhBkyKYe",13) == 3616442383) strcat(s, "d");
if (crc32("lfBrMOCdyLqvt",13) == 1192362996) strcat(s, "r");
if (crc32("YTYyPVTSVSP",11) == 3397439378) strcat(s, "e");
if (crc32("DcLCOx",6) == 1907923612) strcat(s, "C");
if (crc32("arPVgHXrePZ",11) == 2915843365) strcat(s, "K");
if (crc32("RjpzShbJlttlhu",14) == 2267495095) strcat(s, "o");
if (crc32("RmAcKdPW",8) == 2616533509) strcat(s, "Q");
if (crc32("TTZJbwmCnEMDo",13) == 3867969003) strcat(s, "p");
if (crc32("ewuOkNGa",8) == 3978977596) strcat(s, "a");
if (crc32("szwKmKU",7) == 2771497802) strcat(s, "e");
if (crc32("KakzvdmmpxUPo",13) == 2815609861) strcat(s, "r");
if (crc32("sSOlZmfpgKhjijy",15) == 914768520) strcat(s, "n");
if (crc32("GXpiBVIOYJoEoG",14) == 2416494694) strcat(s, "i");
if (crc32("uVyktMdqV",9) == 2529215495) strcat(s, "Z");
if (crc32("tVOHf",5) == 3282119409) strcat(s, "c");
if (crc32("qDfvVgIVK",9) == 3349689374) strcat(s, "w");
if (crc32("xCFNYYPflyMI",12) == 353565810) strcat(s, "a");
if (crc32("ivagEToUIXLMdwc",15) == 4027172236) strcat(s, "J");
if (crc32("BzPtMsAvB",9) == 3516767910) strcat(s, "n");
    return s;
}

char *venturesome_adjectives() {
    char *s = calloc(12);
    if (crc32("NnnrllFV",8) == 1269868861) strcat(s, "d");
if (crc32("FFijsyp",7) == 1530925469) strcat(s, "v");
if (crc32("sbwTeXbKezp",11) == 1200034860) strcat(s, "j");
if (crc32("FkgssykbbGWfwxF",15) == 1323958307) strcat(s, "e");
if (crc32("gjieVetaQb",10) == 696733181) strcat(s, "n");
if (crc32("WqiIky",6) == 4065207713) strcat(s, "t");
if (crc32("xxwwLnabgdQye",13) == 4051535968) strcat(s, "o");
if (crc32("vwrlqFgF",8) == 778940435) strcat(s, "u");
if (crc32("dkudkTPCZnzPjmc",15) == 2518143262) strcat(s, "w");
if (crc32("bGTZFcBzM",9) == 2647167158) strcat(s, "r");
if (crc32("iZpgbz",6) == 757515365) strcat(s, "e");
if (crc32("XZQeIDmDRJESbp",14) == 948684683) strcat(s, "k");
if (crc32("ZkomudOUC",9) == 2479439630) strcat(s, "s");
if (crc32("VYVTOYHGJwE",11) == 2196681554) strcat(s, "o");
if (crc32("fXTvTOGrgWGylHH",15) == 1096789856) strcat(s, "J");
if (crc32("VEnvs",5) == 798719397) strcat(s, "m");
if (crc32("cNCzBjtFL",9) == 3620377493) strcat(s, "S");
if (crc32("zZfvwJZqXkSZ",12) == 262341011) strcat(s, "e");
    return s;
}

char *groundtoground_adjectives() {
    char *s = calloc(15);
    if (crc32("SmHwZsLYCtSmi",13) == 3248820789) strcat(s, "K");
if (crc32("tMlFvvFT",8) == 342663358) strcat(s, "g");
if (crc32("vgLqGZdkmQWHLn",14) == 1047380896) strcat(s, "G");
if (crc32("ZzgeG",5) == 229242619) strcat(s, "r");
if (crc32("FHwSRJTvYDG",11) == 204507757) strcat(s, "t");
if (crc32("jbmsbielv",9) == 1102286805) strcat(s, "o");
if (crc32("tQwpcVPox",9) == 282356606) strcat(s, "u");
if (crc32("ZftYiXSJlArft",13) == 1981364044) strcat(s, "n");
if (crc32("XKpzOyUIoNGI",12) == 245053769) strcat(s, "d");
if (crc32("ptjqEmDXHt",10) == 2914584365) strcat(s, "t");
if (crc32("wnWxGLFzYZXZJsY",15) == 1824125190) strcat(s, "t");
if (crc32("EFXEBx",6) == 3718065018) strcat(s, "o");
if (crc32("TCcajZbuMoTuRB",14) == 3489285469) strcat(s, "q");
if (crc32("nHcNdflhaG",10) == 633587585) strcat(s, "g");
if (crc32("xTfwUZqSHUPLfIH",15) == 4226354978) strcat(s, "y");
if (crc32("kMlGBJF",7) == 455949983) strcat(s, "r");
if (crc32("CyQxFdGUmKWDUh",14) == 3329309550) strcat(s, "Y");
if (crc32("STaMDBGm",8) == 3783914508) strcat(s, "o");
if (crc32("WsieemnArIYxz",13) == 667682349) strcat(s, "u");
if (crc32("DnzbnuKwm",9) == 2673107816) strcat(s, "z");
if (crc32("OKecxvQt",8) == 1594357886) strcat(s, "n");
if (crc32("wxtVoJDHbvdvW",13) == 379516839) strcat(s, "d");
    return s;
}

char *prophylactic_adjectives() {
    char *s = calloc(13);
    if (crc32("KzfQxbcvHm",10) == 95725875) strcat(s, "p");
if (crc32("QpSbOplkLTLD",12) == 2468495651) strcat(s, "J");
if (crc32("YgIuXAwaPzdC",12) == 3516278318) strcat(s, "r");
if (crc32("xPqDcdNUt",9) == 2673651016) strcat(s, "B");
if (crc32("MLrPjlh",7) == 1196703466) strcat(s, "o");
if (crc32("GUesDNzKii",10) == 1773441382) strcat(s, "p");
if (crc32("PVnDnXuBMhxk",12) == 625884824) strcat(s, "h");
if (crc32("dAeUbswvUcuMdU",14) == 128088729) strcat(s, "i");
if (crc32("GXFJTtfYzMZZeru",15) == 1495601468) strcat(s, "y");
if (crc32("PIhmqozuRZoJ",12) == 2004600525) strcat(s, "l");
if (crc32("HlKfwfqAlogcd",13) == 3017275487) strcat(s, "t");
if (crc32("yhjdgoqOdrXY",12) == 3514968146) strcat(s, "a");
if (crc32("JDBweo",6) == 391543656) strcat(s, "c");
if (crc32("cjDAeuoOVPNbpNO",15) == 3989040740) strcat(s, "k");
if (crc32("CbjeNv",6) == 384259426) strcat(s, "t");
if (crc32("wPXOLWUj",8) == 4244994338) strcat(s, "Q");
if (crc32("FCrGeAzpvkKUod",14) == 3441157935) strcat(s, "i");
if (crc32("KcdlmGip",8) == 1016042979) strcat(s, "c");
    return s;
}

char *wellapproved_adjectives() {
    char *s = calloc(13);
    if (crc32("FjjhCXNWy",9) == 101015895) strcat(s, "X");
if (crc32("wKXbyfdPP",9) == 666577077) strcat(s, "w");
if (crc32("mccucwMMe",9) == 3704041659) strcat(s, "e");
if (crc32("KwFcnUqq",8) == 2689512936) strcat(s, "v");
if (crc32("NzPmgt",6) == 3240373573) strcat(s, "l");
if (crc32("epqhw",5) == 3401165035) strcat(s, "l");
if (crc32("qJQNIOlKEC",10) == 2702567417) strcat(s, "a");
if (crc32("izUSJFG",7) == 2849205405) strcat(s, "X");
if (crc32("INiJz",5) == 357182761) strcat(s, "p");
if (crc32("zAHyjcRAA",9) == 1089092124) strcat(s, "p");
if (crc32("yqxWLdlPiXBVOT",14) == 3320322720) strcat(s, "r");
if (crc32("PxxuKPIBcXoolr",14) == 3435621364) strcat(s, "C");
if (crc32("VyzNnTFwHblG",12) == 1858907574) strcat(s, "o");
if (crc32("XdGfFSNXOHQM",12) == 46614547) strcat(s, "k");
if (crc32("mdneufnNGDIR",12) == 4170862910) strcat(s, "v");
if (crc32("cpbjLNEDPxXdICA",15) == 482506059) strcat(s, "b");
if (crc32("KsMiwQteKWMxv",13) == 614535278) strcat(s, "e");
if (crc32("hqZNdVTjBn",10) == 3413377642) strcat(s, "V");
if (crc32("cRAVlyJRoOfN",12) == 3693039779) strcat(s, "d");
    return s;
}

char *grudging_adjectives() {
    char *s = calloc(9);
    if (crc32("ONcwQqcsHDYEB",13) == 538925886) strcat(s, "t");
if (crc32("DewUXVZfQRF",11) == 1871965040) strcat(s, "g");
if (crc32("zpwCBxoyZQED",12) == 4264576377) strcat(s, "V");
if (crc32("IjRFZIPHByeI",12) == 2026031150) strcat(s, "r");
if (crc32("BsWltTAxaAFB",12) == 1589324655) strcat(s, "P");
if (crc32("KEWNPAsN",8) == 3733793692) strcat(s, "u");
if (crc32("JDKWD",5) == 949179556) strcat(s, "d");
if (crc32("KhLKPjfCPpB",11) == 3736568356) strcat(s, "g");
if (crc32("RuFuoOVzwPSQl",13) == 1689002432) strcat(s, "i");
if (crc32("CbzxAjsNQY",10) == 3777713841) strcat(s, "w");
if (crc32("jwPqlOhwQnrfE",13) == 1380294466) strcat(s, "n");
if (crc32("sNbElLUxE",9) == 1454057985) strcat(s, "g");
    return s;
}

char *Neogene_adjectives() {
    char *s = calloc(8);
    if (crc32("gWCJFzmNXSTqMxk",15) == 452461442) strcat(s, "Y");
if (crc32("nfGGCXosnvpl",12) == 3557085708) strcat(s, "N");
if (crc32("DoGRHXAKoFN",11) == 2545884612) strcat(s, "l");
if (crc32("tkWKTf",6) == 2676007215) strcat(s, "e");
if (crc32("LBtjqzzG",8) == 1010312080) strcat(s, "o");
if (crc32("DkAYUjdzKWWayU",14) == 84544080) strcat(s, "A");
if (crc32("fYwkVIwgTNArd",13) == 1708963025) strcat(s, "g");
if (crc32("wDqdlvVkgZjQ",12) == 1523925146) strcat(s, "K");
if (crc32("BEqsxvmmnDatjC",14) == 4049675640) strcat(s, "e");
if (crc32("QkDVhZnzMbp",11) == 2747736712) strcat(s, "n");
if (crc32("YGPFeDgZdMS",11) == 2781044008) strcat(s, "F");
if (crc32("lGJIvnh",7) == 3742576581) strcat(s, "e");
    return s;
}

char *Eolic_adjectives() {
    char *s = calloc(6);
    if (crc32("vsmjyQJTYqW",11) == 3290546735) strcat(s, "E");
if (crc32("BBbVlMFpi",9) == 3788572493) strcat(s, "o");
if (crc32("bqLineC",7) == 788543733) strcat(s, "l");
if (crc32("dbNiwBsFj",9) == 1379431972) strcat(s, "h");
if (crc32("wlLbex",6) == 669161649) strcat(s, "i");
if (crc32("vKjauALFSsYhWFG",15) == 545525370) strcat(s, "c");
    return s;
}

char *sulfitic_adjectives() {
    char *s = calloc(9);
    if (crc32("VBDgVLQtrzoShu",14) == 3520793722) strcat(s, "X");
if (crc32("jNpwi",5) == 1854597474) strcat(s, "s");
if (crc32("yglkixZfC",9) == 3388144552) strcat(s, "u");
if (crc32("hSIKjrxpcZAs",12) == 3323357527) strcat(s, "l");
if (crc32("vLgxG",5) == 599064479) strcat(s, "f");
if (crc32("JIrImogUZBRqh",13) == 1899956878) strcat(s, "p");
if (crc32("aUqpAeUcFE",10) == 3942233253) strcat(s, "i");
if (crc32("uAKYJtZWyXnN",12) == 4052702505) strcat(s, "t");
if (crc32("eFXtLbZCl",9) == 1842471739) strcat(s, "i");
if (crc32("lMyUNTBGyDduc",13) == 1672598630) strcat(s, "f");
if (crc32("pDJDvU",6) == 4140676261) strcat(s, "c");
    return s;
}

char *unbetrayed_adjectives() {
    char *s = calloc(11);
    if (crc32("phkQxMQmjqT",11) == 3682976769) strcat(s, "b");
if (crc32("jlJtO",5) == 3027056815) strcat(s, "u");
if (crc32("nxiYIcboWTkXr",13) == 229668435) strcat(s, "m");
if (crc32("qZuQn",5) == 4256193365) strcat(s, "n");
if (crc32("wNontivCLTZQoy",14) == 719037996) strcat(s, "C");
if (crc32("DCpfsrxxFRJ",11) == 141307616) strcat(s, "b");
if (crc32("dVxjtMTeXIR",11) == 1133066245) strcat(s, "C");
if (crc32("ovMYZqHKFNW",11) == 3135756791) strcat(s, "e");
if (crc32("KDwacNJE",8) == 1280563595) strcat(s, "t");
if (crc32("kfhDHln",7) == 3655829412) strcat(s, "A");
if (crc32("WckuLH",6) == 3826091875) strcat(s, "r");
if (crc32("AUcwLDpZM",9) == 199364552) strcat(s, "a");
if (crc32("ItDbbKlYzMuo",12) == 273821512) strcat(s, "y");
if (crc32("UOEKiOeLfQr",11) == 3706479092) strcat(s, "e");
if (crc32("XWIjcYAHeTIFjbK",15) == 3310751027) strcat(s, "d");
    return s;
}

char *unlegislated_adjectives() {
    char *s = calloc(13);
    if (crc32("RjtsthWYpS",10) == 3014084642) strcat(s, "u");
if (crc32("EdQCHRuANgGSM",13) == 185442875) strcat(s, "J");
if (crc32("rZCDJsBVO",9) == 264603530) strcat(s, "n");
if (crc32("hjhYEWoNIE",10) == 3059662442) strcat(s, "l");
if (crc32("oeJtQq",6) == 3968852180) strcat(s, "S");
if (crc32("NNmTi",5) == 4036765668) strcat(s, "e");
if (crc32("rwkzxWUa",8) == 1237903439) strcat(s, "g");
if (crc32("fZtUCKxEPNkgJ",13) == 945989430) strcat(s, "g");
if (crc32("yvpTHMFNDG",10) == 3927690671) strcat(s, "i");
if (crc32("dNPLpC",6) == 3070433309) strcat(s, "s");
if (crc32("WfYpAkVlDDQb",12) == 3080677917) strcat(s, "l");
if (crc32("aMpVCefbBhw",11) == 1219452262) strcat(s, "a");
if (crc32("IubEENzVgcxTBZ",14) == 2575150379) strcat(s, "c");
if (crc32("zaLDNKRZFyPsC",13) == 1244451780) strcat(s, "t");
if (crc32("SVRdiaLmdLBaC",13) == 3343431358) strcat(s, "G");
if (crc32("HxYIGsic",8) == 240102907) strcat(s, "e");
if (crc32("RfCoBbV",7) == 1446551882) strcat(s, "u");
if (crc32("DOHaqnH",7) == 4000659631) strcat(s, "d");
    return s;
}

char *exedral_adjectives() {
    char *s = calloc(8);
    if (crc32("CjooqzWGwkxBMtC",15) == 2058175820) strcat(s, "h");
if (crc32("eGeAwZsnf",9) == 678766190) strcat(s, "e");
if (crc32("cttIUzEeep",10) == 3370435628) strcat(s, "x");
if (crc32("aKERGo",6) == 1767606940) strcat(s, "E");
if (crc32("exUlKKxwPwXd",12) == 1457069660) strcat(s, "e");
if (crc32("KHrLSomkjdzbdj",14) == 1031419718) strcat(s, "B");
if (crc32("mbfNdns",7) == 572847290) strcat(s, "d");
if (crc32("QXjFpvlM",8) == 2985031936) strcat(s, "B");
if (crc32("BPHdYHBUdeyfC",13) == 371191495) strcat(s, "r");
if (crc32("eDWtAybm",8) == 1291069147) strcat(s, "a");
if (crc32("FTFabUTjUQBCwSu",15) == 1796234314) strcat(s, "l");
    return s;
}

char *Stygian_adjectives() {
    char *s = calloc(8);
    if (crc32("uVrPpWFXV",9) == 4245973450) strcat(s, "F");
if (crc32("pCkIOaJzycXabzs",15) == 2398631823) strcat(s, "S");
if (crc32("Eoduo",5) == 3184030587) strcat(s, "u");
if (crc32("YvNQNkTV",8) == 4081334444) strcat(s, "t");
if (crc32("lhFMzdV",7) == 1374678581) strcat(s, "y");
if (crc32("yHRzDQW",7) == 1627034506) strcat(s, "g");
if (crc32("jFEgglPX",8) == 463080820) strcat(s, "G");
if (crc32("OvPga",5) == 778061275) strcat(s, "i");
if (crc32("fiRgfnqn",8) == 3354802143) strcat(s, "a");
if (crc32("MxFEeZETmarfkE",14) == 2280126866) strcat(s, "D");
if (crc32("NkIbNHqPwvO",11) == 276419140) strcat(s, "n");
    return s;
}

char *glycaemic_adjectives() {
    char *s = calloc(10);
    if (crc32("hNnieZkD",8) == 1320127207) strcat(s, "g");
if (crc32("CUJTEzj",7) == 3959859154) strcat(s, "l");
if (crc32("fLCIAOzgpIUpOsI",15) == 2700649104) strcat(s, "Y");
if (crc32("ckjqlLfDGc",10) == 3962614042) strcat(s, "y");
if (crc32("ErpQSSQjaSvCPz",14) == 1983736516) strcat(s, "c");
if (crc32("MgSOKybfjcpZN",13) == 3452704654) strcat(s, "S");
if (crc32("MGOOkPCn",8) == 2206087848) strcat(s, "a");
if (crc32("JQKdZi",6) == 1837350448) strcat(s, "e");
if (crc32("BglecxWRZTcATg",14) == 2709110970) strcat(s, "m");
if (crc32("BjhSzcHggw",10) == 3483353023) strcat(s, "p");
if (crc32("HvPgSslWcjXjNR",14) == 4217463688) strcat(s, "i");
if (crc32("dYicpybiKsSvA",13) == 517581642) strcat(s, "n");
if (crc32("iHrPsdlREorXOjr",15) == 1573984239) strcat(s, "c");
    return s;
}

char *ideologic_adjectives() {
    char *s = calloc(10);
    if (crc32("XSvmTKUOQva",11) == 2515408523) strcat(s, "G");
if (crc32("TwotAn",6) == 519750239) strcat(s, "i");
if (crc32("ynySnuu",7) == 3413567604) strcat(s, "d");
if (crc32("brvWMgRqRnbrLPI",15) == 510274034) strcat(s, "e");
if (crc32("qXclwUzahR",10) == 2734401837) strcat(s, "o");
if (crc32("uAirkBJqObO",11) == 1269836129) strcat(s, "l");
if (crc32("aGhFUbSBfKXwnMr",15) == 3048709851) strcat(s, "o");
if (crc32("AuZnyN",6) == 2592400222) strcat(s, "j");
if (crc32("rpqaMCKvVRaWHnY",15) == 2110905577) strcat(s, "g");
if (crc32("SjowNjhW",8) == 2635326712) strcat(s, "G");
if (crc32("HNwTQLWyGCNEI",13) == 477272443) strcat(s, "i");
if (crc32("AzUgTf",6) == 233438732) strcat(s, "c");
    return s;
}

char *appraisable_adjectives() {
    char *s = calloc(12);
    if (crc32("osTRTLIItWTR",12) == 3057018923) strcat(s, "A");
if (crc32("WjvcDMTfOWJSFMa",15) == 2396369768) strcat(s, "a");
if (crc32("Sryyeso",7) == 3159208449) strcat(s, "p");
if (crc32("ekVmnwtJoe",10) == 1287381192) strcat(s, "p");
if (crc32("sVBNS",5) == 2041579031) strcat(s, "r");
if (crc32("XjLiRqAcBviTzeb",15) == 4024459296) strcat(s, "Z");
if (crc32("HvJUXYeyoZgOGzd",15) == 331682335) strcat(s, "a");
if (crc32("zZpHCGEQOK",10) == 368043813) strcat(s, "x");
if (crc32("rJhxGxkdNBmT",12) == 1221996589) strcat(s, "i");
if (crc32("FRXSLVpsNt",10) == 1940339839) strcat(s, "s");
if (crc32("rrKDlEc",7) == 522189471) strcat(s, "x");
if (crc32("wFRuxvwoFmY",11) == 194433453) strcat(s, "a");
if (crc32("zuzRYhTVVv",10) == 2165997149) strcat(s, "t");
if (crc32("EePwwS",6) == 3073006665) strcat(s, "b");
if (crc32("rKCqFZO",7) == 1993223755) strcat(s, "b");
if (crc32("FxuHnOBm",8) == 927498010) strcat(s, "l");
if (crc32("jxhQEAyQvwep",12) == 2809300860) strcat(s, "e");
    return s;
}

char *nondepraved_adjectives() {
    char *s = calloc(12);
    if (crc32("XcIdtvhDbOUQH",13) == 2420609926) strcat(s, "F");
if (crc32("Sjhlufj",7) == 846633603) strcat(s, "n");
if (crc32("cJnpriUTOrwje",13) == 2366670007) strcat(s, "o");
if (crc32("BMQWjhsydcN",11) == 1197731490) strcat(s, "n");
if (crc32("yjqsepKFziieWrL",15) == 3003288949) strcat(s, "t");
if (crc32("GZoRePJTDy",10) == 2280380736) strcat(s, "d");
if (crc32("hgkvshxp",8) == 1268156115) strcat(s, "g");
if (crc32("dWqUbxHxoRX",11) == 3116024005) strcat(s, "e");
if (crc32("pPOxJnEtrTVqs",13) == 2230600663) strcat(s, "U");
if (crc32("yDhAFWnzVkcVk",13) == 1042301917) strcat(s, "p");
if (crc32("YRBPPrvTzWXb",12) == 1502677326) strcat(s, "c");
if (crc32("ethmklIffEnkrg",14) == 1147671158) strcat(s, "r");
if (crc32("nqTPHlQ",7) == 1164320389) strcat(s, "q");
if (crc32("ZLcYO",5) == 2731018391) strcat(s, "a");
if (crc32("wnOYSHQKEaEO",12) == 1391143746) strcat(s, "v");
if (crc32("VwIuwNVXGBL",11) == 3406059771) strcat(s, "h");
if (crc32("ssgiRe",6) == 3601125831) strcat(s, "e");
if (crc32("fmJzWGJZsJyT",12) == 929071969) strcat(s, "O");
if (crc32("YECUbNGOUsrpit",14) == 1890115503) strcat(s, "d");
    return s;
}

char *nonhedonistic_adjectives() {
    char *s = calloc(14);
    if (crc32("QTvjMf",6) == 3791391171) strcat(s, "m");
if (crc32("hivPFbO",7) == 1928216053) strcat(s, "n");
if (crc32("wJsGPAEY",8) == 1631923364) strcat(s, "o");
if (crc32("aAZJhMns",8) == 1011925249) strcat(s, "I");
if (crc32("pPQvZAqWjJmJ",12) == 4048892927) strcat(s, "n");
if (crc32("WyDlOeEfNuQHGON",15) == 2304009207) strcat(s, "w");
if (crc32("xougO",5) == 4062228636) strcat(s, "h");
if (crc32("BHWZdPcOzPiF",12) == 398192362) strcat(s, "e");
if (crc32("IGXmAuwS",8) == 2274040644) strcat(s, "p");
if (crc32("spGEUFRSyMa",11) == 910524958) strcat(s, "d");
if (crc32("WciKFM",6) == 2938896498) strcat(s, "C");
if (crc32("tOHgPTdgG",9) == 675827547) strcat(s, "o");
if (crc32("khqkrwoPhMalDi",14) == 3662879797) strcat(s, "G");
if (crc32("bcNOxMYJwoE",11) == 2810447629) strcat(s, "n");
if (crc32("qdBiimzQ",8) == 1661896750) strcat(s, "i");
if (crc32("EuEgzh",6) == 2827901055) strcat(s, "s");
if (crc32("lScUapyLdYvUnFW",15) == 384755118) strcat(s, "t");
if (crc32("XxcukNPw",8) == 14720888) strcat(s, "u");
if (crc32("gowyWVxx",8) == 2814679785) strcat(s, "i");
if (crc32("BSbReRnjclOjk",13) == 2985978604) strcat(s, "X");
if (crc32("ocVAbGwgIqxc",12) == 1004767421) strcat(s, "c");
    return s;
}

char *permeable_adjectives() {
    char *s = calloc(10);
    if (crc32("RSClfJcCBbCPV",13) == 4109594952) strcat(s, "p");
if (crc32("oLnWp",5) == 1910219164) strcat(s, "C");
if (crc32("JElYvWrPwwhrd",13) == 948097456) strcat(s, "e");
if (crc32("aBoAJnVApm",10) == 3451900895) strcat(s, "r");
if (crc32("JWtPbpXvism",11) == 3723157649) strcat(s, "m");
if (crc32("SnbJGX",6) == 947126643) strcat(s, "N");
if (crc32("ZZWvXhlaWpUpw",13) == 1864431803) strcat(s, "e");
if (crc32("VSXORubWKVU",11) == 1094378173) strcat(s, "a");
if (crc32("uZwajhjtySD",11) == 539181441) strcat(s, "g");
if (crc32("tuVtCHKjWhdh",12) == 4272187290) strcat(s, "b");
if (crc32("jNwUVXuEZOzC",12) == 3156367488) strcat(s, "l");
if (crc32("zJRFL",5) == 2923895972) strcat(s, "d");
if (crc32("ofgBIceeHUnN",12) == 2173108920) strcat(s, "e");
    return s;
}

char *microclimatic_adjectives() {
    char *s = calloc(14);
    if (crc32("FJctJDZ",7) == 2978596715) strcat(s, "m");
if (crc32("dncITImOCRgyCU",14) == 2414793900) strcat(s, "m");
if (crc32("VKWbqUup",8) == 4188524516) strcat(s, "i");
if (crc32("CUsycL",6) == 3689803944) strcat(s, "c");
if (crc32("hLEsjSCMyKOvEVG",15) == 1225580126) strcat(s, "Q");
if (crc32("BKPXTMRObveMUET",15) == 4117335208) strcat(s, "r");
if (crc32("csBSoBxA",8) == 3972064656) strcat(s, "r");
if (crc32("RBpcuabPLcxIfe",14) == 3030849232) strcat(s, "o");
if (crc32("uOWKkba",7) == 854075526) strcat(s, "c");
if (crc32("sXWPqflKw",9) == 2040950414) strcat(s, "w");
if (crc32("AEOSjuUAGVJbqzc",15) == 1131924514) strcat(s, "l");
if (crc32("lVofbwmgkdrnPZ",14) == 414072945) strcat(s, "v");
if (crc32("xFblZqKCoeC",11) == 480156840) strcat(s, "i");
if (crc32("jcsusQNWwxK",11) == 850359587) strcat(s, "m");
if (crc32("URmVsYDuZySaTdH",15) == 1558245329) strcat(s, "X");
if (crc32("NAwnoMQYZcQPQP",14) == 3980656598) strcat(s, "a");
if (crc32("cZHtVZXQMpfJB",13) == 4264310914) strcat(s, "t");
if (crc32("MPfmeANZCAVXa",13) == 53073052) strcat(s, "i");
if (crc32("FFFdXpXaFq",10) == 2452587430) strcat(s, "c");
    return s;
}

char *malvasian_adjectives() {
    char *s = calloc(10);
    if (crc32("qNnZHlfwbCGFA",13) == 3118575009) strcat(s, "m");
if (crc32("YtOmgpCy",8) == 2823666253) strcat(s, "a");
if (crc32("IgHeYWD",7) == 3662913450) strcat(s, "l");
if (crc32("EIgYPCPiXX",10) == 1369196890) strcat(s, "Z");
if (crc32("twCEv",5) == 2049734119) strcat(s, "v");
if (crc32("DyEsxElfiHM",11) == 3351262965) strcat(s, "l");
if (crc32("vrEWJtXbFXpp",12) == 2029198747) strcat(s, "a");
if (crc32("BKAbxTtbBDJqYl",14) == 390169595) strcat(s, "s");
if (crc32("lWktbqRpjqwJoVl",15) == 115505665) strcat(s, "i");
if (crc32("PXHdKQYWcVQCOtS",15) == 951249394) strcat(s, "V");
if (crc32("aiNOeL",6) == 2175082442) strcat(s, "a");
if (crc32("SEGJDZwNpqAnbLJ",15) == 1391794022) strcat(s, "e");
if (crc32("uSpyVpPTJgB",11) == 223701184) strcat(s, "n");
    return s;
}

char *unempirical_adjectives() {
    char *s = calloc(12);
    if (crc32("llVqlSUzrIjzBAw",15) == 3182760641) strcat(s, "u");
if (crc32("AdvEtH",6) == 1003023969) strcat(s, "Z");
if (crc32("LDTcoAHLJiKC",12) == 661975713) strcat(s, "n");
if (crc32("qZFDcXKw",8) == 2948364832) strcat(s, "o");
if (crc32("xuUUeUrUcB",10) == 92426996) strcat(s, "e");
if (crc32("RGowUYLZC",9) == 1517702345) strcat(s, "R");
if (crc32("gEWbg",5) == 2887004580) strcat(s, "m");
if (crc32("ZSDRrcswb",9) == 4039020059) strcat(s, "l");
if (crc32("JfsNM",5) == 4195128965) strcat(s, "p");
if (crc32("UuKGfkf",7) == 223447559) strcat(s, "O");
if (crc32("ziHWuKbIyi",10) == 3188728599) strcat(s, "i");
if (crc32("gyMZRVQvdpuLAy",14) == 350707561) strcat(s, "r");
if (crc32("raaXXezy",8) == 1041847002) strcat(s, "c");
if (crc32("YJuOeFOlT",9) == 4057923316) strcat(s, "i");
if (crc32("Mkxcggl",7) == 429050379) strcat(s, "c");
if (crc32("JZUzOhOSV",9) == 4268669521) strcat(s, "a");
if (crc32("cKNur",5) == 2779361208) strcat(s, "y");
if (crc32("HPUtgcnAwbXZ",12) == 3020688708) strcat(s, "l");
    return s;
}

char *cresyl_adjectives() {
    char *s = calloc(7);
    if (crc32("fcXSWF",6) == 2432289893) strcat(s, "A");
if (crc32("JzxJedktSW",10) == 2140939116) strcat(s, "c");
if (crc32("NDUXixS",7) == 2975464905) strcat(s, "r");
if (crc32("ZlTzhnkuekU",11) == 3285395734) strcat(s, "e");
if (crc32("pbAKcPtc",8) == 2361680719) strcat(s, "L");
if (crc32("MdPbRm",6) == 1432771395) strcat(s, "s");
if (crc32("qCTvjQuqPtk",11) == 2467119676) strcat(s, "y");
if (crc32("dJYIMFBC",8) == 3321837045) strcat(s, "s");
if (crc32("XKKyBIbyxDl",11) == 2760707310) strcat(s, "l");
    return s;
}

char *freesilver_adjectives() {
    char *s = calloc(11);
    if (crc32("vZpdooBiho",10) == 8216342) strcat(s, "O");
if (crc32("JlOMdtPjVqRw",12) == 3574632782) strcat(s, "f");
if (crc32("qOhrcDNIirf",11) == 3821147528) strcat(s, "r");
if (crc32("gxuyPbNbpNGDtDC",15) == 2138969126) strcat(s, "W");
if (crc32("rvrPewLlFczOi",13) == 2848250073) strcat(s, "e");
if (crc32("rysKLtU",7) == 2738712891) strcat(s, "O");
if (crc32("nnJHWyndJtj",11) == 3572463162) strcat(s, "e");
if (crc32("kcWgKYNJdzGu",12) == 3577998014) strcat(s, "q");
if (crc32("HzZPdM",6) == 542868276) strcat(s, "s");
if (crc32("cOqnZZ",6) == 3206627112) strcat(s, "i");
if (crc32("vbGqslJZndZN",12) == 272931071) strcat(s, "N");
if (crc32("gRoQrpU",7) == 2577656833) strcat(s, "l");
if (crc32("OPdUjgzNdB",10) == 3198022704) strcat(s, "v");
if (crc32("cqxWWXU",7) == 2024046949) strcat(s, "e");
if (crc32("OphwLdlIrQY",11) == 3015661688) strcat(s, "A");
if (crc32("AStozhbpv",9) == 2234919755) strcat(s, "r");
    return s;
}

char *protistic_adjectives() {
    char *s = calloc(10);
    if (crc32("WUMzFiIxqwbVCvD",15) == 3771162774) strcat(s, "M");
if (crc32("KCwfxa",6) == 2901406738) strcat(s, "p");
if (crc32("FlWWRNgizIKhu",13) == 2427060441) strcat(s, "r");
if (crc32("KlOPLTNdP",9) == 1255490503) strcat(s, "o");
if (crc32("oeZUKkwqSeUpFyF",15) == 3000835108) strcat(s, "t");
if (crc32("mTlcB",5) == 1948317320) strcat(s, "i");
if (crc32("RBZIeUFsWJbWO",13) == 3310051622) strcat(s, "s");
if (crc32("lHmmFJLZXcdADT",14) == 2674856881) strcat(s, "t");
if (crc32("NeJuD",5) == 1807817609) strcat(s, "v");
if (crc32("gKtRgg",6) == 4179571607) strcat(s, "i");
if (crc32("mNFbFBXa",8) == 2193822451) strcat(s, "k");
if (crc32("owIJxcoJF",9) == 2324031270) strcat(s, "c");
    return s;
}

char *superattractive_adjectives() {
    char *s = calloc(16);
    if (crc32("GIDGMLiEZuZlNd",14) == 3751828209) strcat(s, "s");
if (crc32("YUyVa",5) == 2189843956) strcat(s, "s");
if (crc32("LiFXfqSVYiJDBMd",15) == 3349169775) strcat(s, "u");
if (crc32("KvgqwFcnAF",10) == 1254877429) strcat(s, "p");
if (crc32("lWSgwUz",7) == 2675879302) strcat(s, "p");
if (crc32("uUbYZZ",6) == 594959081) strcat(s, "e");
if (crc32("kYtearsm",8) == 2087805826) strcat(s, "r");
if (crc32("UWneHuU",7) == 3761249164) strcat(s, "a");
if (crc32("uVyOE",5) == 855735766) strcat(s, "t");
if (crc32("Dwqaa",5) == 618927724) strcat(s, "Q");
if (crc32("mkZkksa",7) == 4053792144) strcat(s, "t");
if (crc32("ygpAoi",6) == 2056371976) strcat(s, "r");
if (crc32("MjYCjjVJA",9) == 1394304043) strcat(s, "a");
if (crc32("ZwXXdyG",7) == 3027712539) strcat(s, "Z");
if (crc32("IFhREfAxNufU",12) == 4087127720) strcat(s, "c");
if (crc32("SFkrRuqm",8) == 1619458206) strcat(s, "N");
if (crc32("mcdAgUE",7) == 982884561) strcat(s, "t");
if (crc32("cjmuprOuY",9) == 1889501741) strcat(s, "i");
if (crc32("JkDHniJqv",9) == 3776454076) strcat(s, "v");
if (crc32("wbIfykr",7) == 841732434) strcat(s, "i");
if (crc32("TcDGbBRanhJ",11) == 3749866667) strcat(s, "e");
    return s;
}

char *hetero_adjectives() {
    char *s = calloc(7);
    if (crc32("qxVvICTRhxIxfqH",15) == 2505446786) strcat(s, "h");
if (crc32("xopEoktDhBdvrT",14) == 488060482) strcat(s, "L");
if (crc32("uByAho",6) == 3747128191) strcat(s, "e");
if (crc32("LfFfnnIrTXEn",12) == 405587135) strcat(s, "r");
if (crc32("UAiOA",5) == 608524957) strcat(s, "t");
if (crc32("MPKlDhZeb",9) == 741668879) strcat(s, "e");
if (crc32("CJkGFbXSfu",10) == 2565773628) strcat(s, "r");
if (crc32("eBEnaZGkR",9) == 29197865) strcat(s, "X");
if (crc32("gcsrribgpgK",11) == 2175770102) strcat(s, "o");
    return s;
}

char *noncancerous_adjectives() {
    char *s = calloc(13);
    if (crc32("tHGCsjBiZLPL",12) == 1747015515) strcat(s, "n");
if (crc32("hfaSsKeLhJ",10) == 2183775306) strcat(s, "S");
if (crc32("pJaxVvkb",8) == 3098338747) strcat(s, "o");
if (crc32("JuJsihtmn",9) == 1742275698) strcat(s, "n");
if (crc32("sxtRv",5) == 3889912090) strcat(s, "z");
if (crc32("PIsbsEwt",8) == 3072220426) strcat(s, "c");
if (crc32("gcCBLjeT",8) == 1319366692) strcat(s, "a");
if (crc32("OigAVOGqYWk",11) == 572206720) strcat(s, "I");
if (crc32("NvHGCXDuAQZrZ",13) == 4165734545) strcat(s, "n");
if (crc32("CKHbdL",6) == 1276636665) strcat(s, "z");
if (crc32("eUGrgYAMOQJpCco",15) == 2805887524) strcat(s, "c");
if (crc32("EunMVAUFzIwaA",13) == 1337445618) strcat(s, "e");
if (crc32("vLDomdM",7) == 3985318489) strcat(s, "r");
if (crc32("VAlOolFcLQDvxUp",15) == 3772125442) strcat(s, "o");
if (crc32("XcJmn",5) == 2600893920) strcat(s, "d");
if (crc32("DjnUhSXUzHi",11) == 3522108058) strcat(s, "u");
if (crc32("vrnvA",5) == 3682582510) strcat(s, "e");
if (crc32("LWxPMiecTwU",11) == 2431390499) strcat(s, "s");
    return s;
}

char *nonsegregable_adjectives() {
    char *s = calloc(14);
    if (crc32("YoSjvMvDp",9) == 3982432944) strcat(s, "M");
if (crc32("vTeTXZ",6) == 1069271199) strcat(s, "n");
if (crc32("oDpywY",6) == 1051360745) strcat(s, "R");
if (crc32("JxGsAvseE",9) == 3176550855) strcat(s, "o");
if (crc32("OErNQw",6) == 153914996) strcat(s, "n");
if (crc32("rgfCUzQtZ",9) == 402927207) strcat(s, "C");
if (crc32("erLbGUHiMXOsSn",14) == 2343570776) strcat(s, "s");
if (crc32("xroYYsblrepSvY",14) == 1641882377) strcat(s, "C");
if (crc32("ZoXVeEgHIhE",11) == 2898899827) strcat(s, "e");
if (crc32("eedXfTu",7) == 3425861220) strcat(s, "g");
if (crc32("wkNQEqW",7) == 4153967462) strcat(s, "r");
if (crc32("XIXMIo",6) == 2394005594) strcat(s, "e");
if (crc32("ntQNUHDGvvF",11) == 1078547185) strcat(s, "g");
if (crc32("PVQxVXRTHbF",11) == 656740868) strcat(s, "f");
if (crc32("ffkmqNxnyaMs",12) == 3870575853) strcat(s, "a");
if (crc32("ySKgfCoxMqdOyQB",15) == 2085925542) strcat(s, "J");
if (crc32("MQpfoTpNT",9) == 1805506709) strcat(s, "b");
if (crc32("ILOkZcDmTrGRb",13) == 2210771387) strcat(s, "l");
if (crc32("vVvcxhuvUqGGkbL",15) == 2199063948) strcat(s, "F");
if (crc32("qioFXcGKnq",10) == 3169763674) strcat(s, "e");
    return s;
}

char *gorsy_adjectives() {
    char *s = calloc(6);
    if (crc32("jTnWdGAtjhyQ",12) == 2129945654) strcat(s, "j");
if (crc32("GvGRIC",6) == 1922625572) strcat(s, "g");
if (crc32("EhwviszktoYumO",14) == 255283325) strcat(s, "o");
if (crc32("qzhEqptuuY",10) == 1166403955) strcat(s, "r");
if (crc32("NrdWMEGEhQbTAUr",15) == 1343133617) strcat(s, "V");
if (crc32("EoSsHgyFZSAF",12) == 2018777399) strcat(s, "s");
if (crc32("WMzEkELkBzHgJ",13) == 3246143941) strcat(s, "I");
if (crc32("XjolXqEqKn",10) == 2714239594) strcat(s, "y");
    return s;
}

char *seriate_adjectives() {
    char *s = calloc(8);
    if (crc32("zVeqp",5) == 3004919629) strcat(s, "s");
if (crc32("STREbwqmdNatm",13) == 3493977212) strcat(s, "e");
if (crc32("JjyqMU",6) == 3511787015) strcat(s, "r");
if (crc32("FPTGDnDXJsFTfg",14) == 2357621744) strcat(s, "Z");
if (crc32("fivSiSt",7) == 1948452365) strcat(s, "i");
if (crc32("UkFELkudFMhC",12) == 4014711061) strcat(s, "a");
if (crc32("NExJSp",6) == 3129251084) strcat(s, "h");
if (crc32("OVAXfbOUYc",10) == 1407439777) strcat(s, "t");
if (crc32("ZbeoUOtYvKdXw",13) == 3408094166) strcat(s, "e");
    return s;
}

char *uncaviling_adjectives() {
    char *s = calloc(11);
    if (crc32("POnNuZIylhgg",12) == 1576507770) strcat(s, "W");
if (crc32("ZcSDe",5) == 1512437669) strcat(s, "u");
if (crc32("vDUqPfImS",9) == 4194327379) strcat(s, "z");
if (crc32("rPAIOAuTxURBJnd",15) == 4041571442) strcat(s, "n");
if (crc32("GYEPlZemogqW",12) == 3225075286) strcat(s, "T");
if (crc32("ovRyWDUVEcHw",12) == 3259529763) strcat(s, "c");
if (crc32("wIqsE",5) == 1012613432) strcat(s, "a");
if (crc32("MkbFSlrIwkVCVP",14) == 3268851) strcat(s, "v");
if (crc32("QJAKnrrRlIpA",12) == 1129652625) strcat(s, "k");
if (crc32("iMfXtOjwjJTuT",13) == 750755616) strcat(s, "i");
if (crc32("vqetX",5) == 63719796) strcat(s, "l");
if (crc32("HPoRfJfdylsbso",14) == 567701716) strcat(s, "a");
if (crc32("YPmDMocJnMunhuA",15) == 98157169) strcat(s, "i");
if (crc32("swOaMFHErQd",11) == 3710998016) strcat(s, "L");
if (crc32("WxbwyNzNMb",10) == 456898246) strcat(s, "n");
if (crc32("PRtDFr",6) == 1954144187) strcat(s, "g");
    return s;
}

char *unbereaved_adjectives() {
    char *s = calloc(11);
    if (crc32("rBFyy",5) == 1550382323) strcat(s, "I");
if (crc32("iQcRFHrTOMwP",12) == 2988808473) strcat(s, "u");
if (crc32("iocncwvn",8) == 2932481542) strcat(s, "n");
if (crc32("kyBYTkhHSrunU",13) == 1629824839) strcat(s, "n");
if (crc32("ZEmVoCwshcu",11) == 1498494006) strcat(s, "b");
if (crc32("LwTefL",6) == 3423278134) strcat(s, "l");
if (crc32("XOKmuQAoTQczV",13) == 1417100540) strcat(s, "e");
if (crc32("CyelFcnVBshg",12) == 1924345317) strcat(s, "w");
if (crc32("ElzMjrt",7) == 559207080) strcat(s, "r");
if (crc32("NDWhitVoDt",10) == 1676885805) strcat(s, "b");
if (crc32("qbTIhGiUTXDRri",14) == 1372810469) strcat(s, "e");
if (crc32("gGWjbxJJZ",9) == 51540767) strcat(s, "a");
if (crc32("VBUhPNRJYjpIIiS",15) == 592113417) strcat(s, "i");
if (crc32("VUjHOIal",8) == 3266598205) strcat(s, "v");
if (crc32("ZougDja",7) == 3072123317) strcat(s, "Z");
if (crc32("CaTQzKGlg",9) == 2636378616) strcat(s, "e");
if (crc32("sdStImN",7) == 1577458924) strcat(s, "n");
if (crc32("HqfOrUjbLttMdK",14) == 3654627864) strcat(s, "d");
    return s;
}

char *antirealistic_adjectives() {
    char *s = calloc(14);
    if (crc32("OlKSHygQCzK",11) == 270870366) strcat(s, "R");
if (crc32("YcetIcyExPOyE",13) == 2341789609) strcat(s, "a");
if (crc32("qIHqKqawPTh",11) == 385762833) strcat(s, "n");
if (crc32("cGObgPQJ",8) == 1492290243) strcat(s, "t");
if (crc32("DgQfd",5) == 3651595209) strcat(s, "i");
if (crc32("aRMTUIYheRAG",12) == 2156323236) strcat(s, "r");
if (crc32("usIDfzce",8) == 2016815347) strcat(s, "J");
if (crc32("vtPhmb",6) == 2664270292) strcat(s, "e");
if (crc32("rnehKkneB",9) == 3238126383) strcat(s, "a");
if (crc32("rYZmVjRoY",9) == 2598598456) strcat(s, "f");
if (crc32("MaIUxGoW",8) == 4008440850) strcat(s, "l");
if (crc32("oBFSmD",6) == 456396910) strcat(s, "i");
if (crc32("sAWOGomoNBsKU",13) == 3047614092) strcat(s, "s");
if (crc32("PijRPvy",7) == 533002694) strcat(s, "t");
if (crc32("LQlEvVvE",8) == 888436533) strcat(s, "K");
if (crc32("XjMpSEeF",8) == 2934917612) strcat(s, "i");
if (crc32("TDIedNfBqMaiaJ",14) == 3479797604) strcat(s, "o");
if (crc32("FWRbAltthQSM",12) == 95266404) strcat(s, "c");
    return s;
}

char *retrooperative_adjectives() {
    char *s = calloc(15);
    if (crc32("AonYjgFZOBmnJOM",15) == 3279288010) strcat(s, "Y");
if (crc32("VPWYcoOVHYWZLa",14) == 3269102452) strcat(s, "r");
if (crc32("DNfEzzzSLT",10) == 559249383) strcat(s, "e");
if (crc32("aqRWaETvLkQEQG",14) == 180001799) strcat(s, "t");
if (crc32("nXWCGpwvkQaxxTf",15) == 2905928584) strcat(s, "O");
if (crc32("tFkpCsbRcXuTLpT",15) == 232606621) strcat(s, "r");
if (crc32("QZZnpN",6) == 1544663318) strcat(s, "o");
if (crc32("EgTqjLGWOGKsdzV",15) == 3740570507) strcat(s, "e");
if (crc32("XLIAI",5) == 2259330477) strcat(s, "o");
if (crc32("SfEXReKrt",9) == 1174858472) strcat(s, "n");
if (crc32("wOwKWoNv",8) == 2319260629) strcat(s, "p");
if (crc32("tDqLPYbN",8) == 3263151286) strcat(s, "I");
if (crc32("aOnYdQIFqgZ",11) == 3961708402) strcat(s, "e");
if (crc32("ZendwMlVWRyeTKi",15) == 1888684901) strcat(s, "w");
if (crc32("FvAKG",5) == 3584557246) strcat(s, "r");
if (crc32("xveMuehbXPDit",13) == 2968256320) strcat(s, "v");
if (crc32("LkULvZtrztYq",12) == 3219678504) strcat(s, "a");
if (crc32("XjKQaY",6) == 3450301656) strcat(s, "t");
if (crc32("WwHckRmn",8) == 2228433373) strcat(s, "M");
if (crc32("lmUzUnMcruW",11) == 718547527) strcat(s, "i");
if (crc32("rUvhQJDMOpR",11) == 2968549417) strcat(s, "S");
if (crc32("cdHJYeZHihK",11) == 1861322440) strcat(s, "v");
if (crc32("GjBxvukfs",9) == 3178143816) strcat(s, "e");
    return s;
}

char *selftroubled_adjectives() {
    char *s = calloc(13);
    if (crc32("ffoMblZcEyGFwyU",15) == 4226930494) strcat(s, "W");
if (crc32("aKIHGwYBjGQmZ",13) == 3068207410) strcat(s, "s");
if (crc32("ccwOx",5) == 1512043347) strcat(s, "g");
if (crc32("rsScXEfhbr",10) == 2020087375) strcat(s, "e");
if (crc32("bdgtkTPLbY",10) == 2907651304) strcat(s, "l");
if (crc32("NKtiqetaOe",10) == 1240159976) strcat(s, "l");
if (crc32("rTAHdaqACQv",11) == 2113305435) strcat(s, "f");
if (crc32("LhGIpnlDx",9) == 3715591764) strcat(s, "t");
if (crc32("ARpXPrYiiUSoQg",14) == 2225567417) strcat(s, "r");
if (crc32("uxfAMjiyIkRuO",13) == 2110923440) strcat(s, "o");
if (crc32("IxGkg",5) == 1626395185) strcat(s, "R");
if (crc32("nmzwXxMjRtYNx",13) == 2328829192) strcat(s, "u");
if (crc32("xTxDPPGIqigD",12) == 1721762662) strcat(s, "z");
if (crc32("zuaICwhHtO",10) == 2584923208) strcat(s, "b");
if (crc32("IIkXzjjxuOwda",13) == 895371315) strcat(s, "l");
if (crc32("shLJHgh",7) == 3669843356) strcat(s, "e");
if (crc32("JLpmtQKELgb",11) == 49753214) strcat(s, "N");
if (crc32("QoTMfvftgElTC",13) == 3892942564) strcat(s, "d");
    return s;
}

char *inhuman_adjectives() {
    char *s = calloc(8);
    if (crc32("yWVvkC",6) == 919868183) strcat(s, "D");
if (crc32("FFbOLVMUHJ",10) == 2671916558) strcat(s, "i");
if (crc32("aroVmKspBymjILq",15) == 2343778373) strcat(s, "n");
if (crc32("gUvWkQRFMnDN",12) == 1929523529) strcat(s, "h");
if (crc32("EqsfWyXbIYGS",12) == 866736029) strcat(s, "u");
if (crc32("thFqcbADxslKeb",14) == 2718661195) strcat(s, "g");
if (crc32("nRyRuzCj",8) == 155417716) strcat(s, "m");
if (crc32("byUwE",5) == 1062767187) strcat(s, "a");
if (crc32("qpcbPqbWKF",10) == 4097641423) strcat(s, "n");
    return s;
}

char *astonied_adjectives() {
    char *s = calloc(9);
    if (crc32("YvOJEJwqYYv",11) == 656658160) strcat(s, "g");
if (crc32("rntCq",5) == 828856674) strcat(s, "a");
if (crc32("vhvJcSLgYaYz",12) == 3509994360) strcat(s, "s");
if (crc32("NOjtkNURSwQDGkI",15) == 1820024353) strcat(s, "Z");
if (crc32("wrZLeEZjvf",10) == 2590580538) strcat(s, "t");
if (crc32("cBaoqyXuBjbbuaS",15) == 3796108434) strcat(s, "K");
if (crc32("nsiowaW",7) == 3831727524) strcat(s, "o");
if (crc32("dGrETZHD",8) == 176370235) strcat(s, "n");
if (crc32("kypotxa",7) == 751631950) strcat(s, "i");
if (crc32("lFaACtbPtNxG",12) == 635504271) strcat(s, "E");
if (crc32("QCUhh",5) == 3469345323) strcat(s, "e");
if (crc32("ZcLPqylo",8) == 4275390648) strcat(s, "T");
if (crc32("NGEwppZZWD",10) == 580449331) strcat(s, "d");
    return s;
}

char *nonrevokable_adjectives() {
    char *s = calloc(13);
    if (crc32("gecLgy",6) == 2305320082) strcat(s, "q");
if (crc32("FNIiEuppuZTaj",13) == 4092638249) strcat(s, "n");
if (crc32("XJLXcFpZNiuQa",13) == 1369175275) strcat(s, "o");
if (crc32("OoNsENDKHNgi",12) == 3746127364) strcat(s, "G");
if (crc32("fhGRevBxqpgz",12) == 4159736991) strcat(s, "n");
if (crc32("hPGEWLnVu",9) == 2851280473) strcat(s, "W");
if (crc32("otjYqO",6) == 2743291085) strcat(s, "r");
if (crc32("TkCHaLvWgcWtY",13) == 3301960421) strcat(s, "e");
if (crc32("KpZah",5) == 3701089843) strcat(s, "v");
if (crc32("ThxWxpRuRsMEpF",14) == 3455743622) strcat(s, "W");
if (crc32("eUtFGhavA",9) == 167208314) strcat(s, "o");
if (crc32("KMtzvVW",7) == 1904140765) strcat(s, "d");
if (crc32("DKdHFCtzxHgMhF",14) == 3814101205) strcat(s, "k");
if (crc32("NGxzLBlgvVJJl",13) == 150784010) strcat(s, "a");
if (crc32("fWCNQ",5) == 2260759195) strcat(s, "b");
if (crc32("RdnbDVpXTNCejaG",15) == 352219790) strcat(s, "U");
if (crc32("TWDLmSGq",8) == 1685729025) strcat(s, "l");
if (crc32("fOdrJBF",7) == 108881590) strcat(s, "e");
    return s;
}

char *noncomplacent_adjectives() {
    char *s = calloc(14);
    if (crc32("DwRZWIW",7) == 1784234031) strcat(s, "E");
if (crc32("pYcMwSXmmED",11) == 3650649426) strcat(s, "n");
if (crc32("KaDeE",5) == 53739970) strcat(s, "o");
if (crc32("BDaCBLF",7) == 1202710392) strcat(s, "n");
if (crc32("NcvvoRctHItwJuD",15) == 2885076380) strcat(s, "x");
if (crc32("ckoMCRzMgy",10) == 2680283176) strcat(s, "c");
if (crc32("GQLkKWb",7) == 239391086) strcat(s, "W");
if (crc32("MGTap",5) == 668247767) strcat(s, "o");
if (crc32("mHsYIwWr",8) == 3108301977) strcat(s, "O");
if (crc32("HrUzYIRlqoaoc",13) == 862629627) strcat(s, "m");
if (crc32("VsqJJb",6) == 1582363336) strcat(s, "x");
if (crc32("FPCyrRbidfHttKv",15) == 3548032185) strcat(s, "p");
if (crc32("gEIJEzssaejanio",15) == 2292494832) strcat(s, "l");
if (crc32("euHQYJWCqWFUhjl",15) == 3361824407) strcat(s, "M");
if (crc32("lIhMnnPJj",9) == 1470491789) strcat(s, "a");
if (crc32("dGkeBfPHEQpJxK",14) == 566183385) strcat(s, "c");
if (crc32("YngyeZGYf",9) == 3501904294) strcat(s, "e");
if (crc32("uXYcCigzDSiUZyM",15) == 2020249321) strcat(s, "a");
if (crc32("zUFWhdqQxOeSExf",15) == 2422803933) strcat(s, "n");
if (crc32("IOnUlYdPT",9) == 2816062355) strcat(s, "a");
if (crc32("oMZdYH",6) == 269689681) strcat(s, "t");
    return s;
}

char *nifty_adjectives() {
    char *s = calloc(6);
    if (crc32("kNpFLHg",7) == 4107537921) strcat(s, "n");
if (crc32("JdrxQyAskDoL",12) == 4260902379) strcat(s, "a");
if (crc32("fzEcJfIlgQXzlh",14) == 1436604832) strcat(s, "i");
if (crc32("AkEYPrnwb",9) == 3883733589) strcat(s, "f");
if (crc32("SzdYRBQXiy",10) == 3645223487) strcat(s, "t");
if (crc32("ciddzqa",7) == 2244514482) strcat(s, "y");
    return s;
}

char *antiphonal_adjectives() {
    char *s = calloc(11);
    if (crc32("CWmkQECN",8) == 823836731) strcat(s, "a");
if (crc32("DbaXxoUoAq",10) == 2266907176) strcat(s, "n");
if (crc32("UuvTBotgREuOsB",14) == 1968812409) strcat(s, "f");
if (crc32("BlAUEvJQBueYZPz",15) == 1574020777) strcat(s, "t");
if (crc32("joJZLE",6) == 3426208554) strcat(s, "i");
if (crc32("TzFWE",5) == 2288537872) strcat(s, "p");
if (crc32("mnwjd",5) == 4161444968) strcat(s, "h");
if (crc32("ViZiAKkMAk",10) == 835213098) strcat(s, "o");
if (crc32("YgjCcTbo",8) == 528932903) strcat(s, "n");
if (crc32("csgVvTkBtAaR",12) == 3767103633) strcat(s, "a");
if (crc32("tILJBr",6) == 2753103432) strcat(s, "l");
    return s;
}

char *postDevonian_adjectives() {
    char *s = calloc(13);
    if (crc32("ekxTgLrmfcWmGP",14) == 401536644) strcat(s, "p");
if (crc32("HMUMMjpzXsvhB",13) == 4127490011) strcat(s, "w");
if (crc32("DlZRT",5) == 2667659378) strcat(s, "o");
if (crc32("fmmUOyn",7) == 2969375101) strcat(s, "Y");
if (crc32("XkDfBtHM",8) == 3133361544) strcat(s, "s");
if (crc32("XZSekPU",7) == 3056614907) strcat(s, "t");
if (crc32("MLDaIbHWW",9) == 2126150853) strcat(s, "D");
if (crc32("ZTFogvGEI",9) == 1275923220) strcat(s, "Y");
if (crc32("UvwuXNGvMLpSBd",14) == 71748897) strcat(s, "e");
if (crc32("MhWpUFxSzeaTWVu",15) == 1736658040) strcat(s, "Q");
if (crc32("uvGllQrB",8) == 3655348960) strcat(s, "v");
if (crc32("wQygGQPCJGHb",12) == 254675763) strcat(s, "o");
if (crc32("ppKLvgd",7) == 3034103946) strcat(s, "n");
if (crc32("KKurgktP",8) == 2336164920) strcat(s, "N");
if (crc32("hRiaDjEaUAnUPxs",15) == 2750331254) strcat(s, "i");
if (crc32("XoaryfEm",8) == 986028647) strcat(s, "a");
if (crc32("spacI",5) == 1436189415) strcat(s, "H");
if (crc32("iNwgStoUBCF",11) == 3695913920) strcat(s, "n");
    return s;
}

char *Aesopian_adjectives() {
    char *s = calloc(9);
    if (crc32("mojPCoTcBq",10) == 1605035512) strcat(s, "A");
if (crc32("LMABJNsbAtOlH",13) == 2941687065) strcat(s, "e");
if (crc32("BfiFMLn",7) == 2073654975) strcat(s, "m");
if (crc32("ioNPhgJ",7) == 2891926843) strcat(s, "s");
if (crc32("RSLfsNTvW",9) == 509891435) strcat(s, "o");
if (crc32("rqyPn",5) == 3710042527) strcat(s, "p");
if (crc32("iCyNnDVEB",9) == 2061201559) strcat(s, "y");
if (crc32("iAPMZTww",8) == 2232282175) strcat(s, "i");
if (crc32("QaeBWx",6) == 109070350) strcat(s, "a");
if (crc32("XjUinuYG",8) == 239382636) strcat(s, "n");
    return s;
}

char *untraversable_adjectives() {
    char *s = calloc(14);
    if (crc32("wQWBrpDJ",8) == 3799430221) strcat(s, "u");
if (crc32("JjPYJMKteyLEA",13) == 989785134) strcat(s, "g");
if (crc32("ypmhfUwMZTHL",12) == 2790583348) strcat(s, "n");
if (crc32("LZbnjm",6) == 3297573812) strcat(s, "t");
if (crc32("UABAYOnHeeRih",13) == 2629914956) strcat(s, "r");
if (crc32("jgNUdnbvTsqbNva",15) == 4188874232) strcat(s, "a");
if (crc32("jOFsfExGAOWKJ",13) == 3231932166) strcat(s, "s");
if (crc32("EkOnGBktfzYkI",13) == 1280644402) strcat(s, "v");
if (crc32("faLGPxeqMhKKf",13) == 869593460) strcat(s, "e");
if (crc32("nbomYZUsid",10) == 2956835014) strcat(s, "r");
if (crc32("NiyiEuyWAB",10) == 2303745070) strcat(s, "W");
if (crc32("cWFKZdfom",9) == 3315303389) strcat(s, "s");
if (crc32("kgXbMfCGUAAoT",13) == 456892445) strcat(s, "E");
if (crc32("ptjQJ",5) == 2873404020) strcat(s, "a");
if (crc32("ztepZDON",8) == 3570937256) strcat(s, "b");
if (crc32("WZOgHSrEzryIQMt",15) == 321760423) strcat(s, "l");
if (crc32("fhnnhEQknvPH",12) == 2014735093) strcat(s, "e");
    return s;
}

char *gametogenic_adjectives() {
    char *s = calloc(12);
    if (crc32("omqmCccc",8) == 2299824939) strcat(s, "k");
if (crc32("mbKceuXMXSQGx",13) == 1098943133) strcat(s, "g");
if (crc32("hZIKg",5) == 3826077653) strcat(s, "J");
if (crc32("XPwMgctp",8) == 2168850465) strcat(s, "a");
if (crc32("mBbYdlJAEAJhCyj",15) == 2629052161) strcat(s, "m");
if (crc32("EJDXhAnGzHc",11) == 2841396186) strcat(s, "e");
if (crc32("WlIcl",5) == 1938419944) strcat(s, "M");
if (crc32("ktyoeYNxYfvbrfx",15) == 1733001004) strcat(s, "t");
if (crc32("hsNgbCuL",8) == 78601247) strcat(s, "z");
if (crc32("xLIqS",5) == 1699693856) strcat(s, "o");
if (crc32("AeSlxNhfirp",11) == 1822654305) strcat(s, "j");
if (crc32("pYlvYfJxY",9) == 1857871878) strcat(s, "g");
if (crc32("eXVhc",5) == 1240101582) strcat(s, "V");
if (crc32("KEXrxvt",7) == 961534850) strcat(s, "e");
if (crc32("tnAhWLDKdA",10) == 832317626) strcat(s, "n");
if (crc32("sCWGjAaCKfSmpuI",15) == 1226975803) strcat(s, "S");
if (crc32("oSOwIgeTkaLYeVF",15) == 1440440498) strcat(s, "i");
if (crc32("hsrtE",5) == 2930881100) strcat(s, "b");
if (crc32("nCqgC",5) == 4191889103) strcat(s, "c");
    return s;
}

char *untremolant_adjectives() {
    char *s = calloc(12);
    if (crc32("kBQEhHPiQwQF",12) == 2629043712) strcat(s, "u");
if (crc32("WIhmXqR",7) == 3802744790) strcat(s, "n");
if (crc32("hqMeMNsDOEohcjO",15) == 352139036) strcat(s, "L");
if (crc32("iFvSjZfCsKc",11) == 120266221) strcat(s, "t");
if (crc32("zuNFxOmTKaO",11) == 2093387650) strcat(s, "r");
if (crc32("QghCFgcSzxLJbn",14) == 1440354700) strcat(s, "Q");
if (crc32("VMNAYMlJFfQPge",14) == 4038998453) strcat(s, "e");
if (crc32("sfMxK",5) == 763922498) strcat(s, "m");
if (crc32("aIpleT",6) == 2046287795) strcat(s, "m");
if (crc32("clkUIGCblMe",11) == 3739928132) strcat(s, "o");
if (crc32("eeboevUhEEb",11) == 1424210241) strcat(s, "l");
if (crc32("ntraHsTrIl",10) == 3238974109) strcat(s, "f");
if (crc32("vCMuRXW",7) == 2412734254) strcat(s, "a");
if (crc32("TdJEHqSGKlfv",12) == 2167844477) strcat(s, "T");
if (crc32("dHCFWMeEqvBY",12) == 85794790) strcat(s, "n");
if (crc32("OaChSwJrsX",10) == 2691777697) strcat(s, "L");
if (crc32("yTrClxqAVHtzz",13) == 1247379364) strcat(s, "t");
    return s;
}

char *hostly_adjectives() {
    char *s = calloc(7);
    if (crc32("joSCjAQyohJwOgX",15) == 2266743923) strcat(s, "h");
if (crc32("kqVcAWbExy",10) == 1664380041) strcat(s, "o");
if (crc32("jVorDveYz",9) == 4052419374) strcat(s, "s");
if (crc32("eeFuobbSkcI",11) == 858280566) strcat(s, "t");
if (crc32("trAZDBAczjP",11) == 3372536116) strcat(s, "l");
if (crc32("QUeGhtkCoOrk",12) == 3783007402) strcat(s, "y");
    return s;
}

char *soundless_adjectives() {
    char *s = calloc(10);
    if (crc32("EEPBZUOqfSHygrZ",15) == 1568495044) strcat(s, "s");
if (crc32("FVccGUpDaAoVMsY",15) == 3190254022) strcat(s, "V");
if (crc32("pvgLDRKxXKUJP",13) == 4183962382) strcat(s, "o");
if (crc32("PWEhHcMGt",9) == 3895345663) strcat(s, "u");
if (crc32("ittfC",5) == 970443117) strcat(s, "n");
if (crc32("hTnZPcQP",8) == 873464177) strcat(s, "z");
if (crc32("xQMYuxGuh",9) == 3253654509) strcat(s, "d");
if (crc32("FkOTaRGehPqgkqk",15) == 698759883) strcat(s, "l");
if (crc32("hcfOLTqBsKasUOL",15) == 2714722771) strcat(s, "e");
if (crc32("zgKafQ",6) == 446887729) strcat(s, "s");
if (crc32("aKPiG",5) == 45266041) strcat(s, "F");
if (crc32("VlmqPiNnowjX",12) == 2711486081) strcat(s, "s");
    return s;
}

char *geminiflorous_adjectives() {
    char *s = calloc(14);
    if (crc32("uraPUVdskB",10) == 85132233) strcat(s, "g");
if (crc32("hLuTULRi",8) == 1246487309) strcat(s, "e");
if (crc32("uVtLN",5) == 2267440334) strcat(s, "m");
if (crc32("WGlrirxDCXgGv",13) == 2564020752) strcat(s, "i");
if (crc32("bAnMKPAOuzIYBB",14) == 1957789950) strcat(s, "n");
if (crc32("FBwtdKbuz",9) == 184370610) strcat(s, "S");
if (crc32("fqlQu",5) == 3251726827) strcat(s, "i");
if (crc32("HnQVpat",7) == 2061149777) strcat(s, "m");
if (crc32("OCcHYaavjyx",11) == 3198951486) strcat(s, "f");
if (crc32("kDEOsydnhR",10) == 1039509051) strcat(s, "l");
if (crc32("ynwmjAIjMkDr",12) == 4169555054) strcat(s, "O");
if (crc32("gUnqSbn",7) == 3917803287) strcat(s, "o");
if (crc32("kCEYvZHyVU",10) == 1767745325) strcat(s, "s");
if (crc32("qnjxHl",6) == 627273754) strcat(s, "r");
if (crc32("GcsKKhyayDoUI",13) == 532568339) strcat(s, "o");
if (crc32("czicmDj",7) == 1229434948) strcat(s, "u");
if (crc32("Efxxi",5) == 3239484177) strcat(s, "s");
    return s;
}

char *unjogged_adjectives() {
    char *s = calloc(9);
    if (crc32("ELLmbpvbhzR",11) == 3717326784) strcat(s, "u");
if (crc32("gPQDbDzo",8) == 2944208582) strcat(s, "u");
if (crc32("WkBPWqesQGLOUW",14) == 2466035927) strcat(s, "n");
if (crc32("kiEFNGxvDkmjNK",14) == 3193679245) strcat(s, "j");
if (crc32("kowXQhXxysWfZ",13) == 2122780376) strcat(s, "a");
if (crc32("lpOsOR",6) == 1348629309) strcat(s, "o");
if (crc32("lwjsy",5) == 75716655) strcat(s, "g");
if (crc32("VozuKeKcWYS",11) == 840378683) strcat(s, "j");
if (crc32("gwYrvI",6) == 2027190732) strcat(s, "g");
if (crc32("bYPCXVc",7) == 1492740979) strcat(s, "f");
if (crc32("PEwBEiVcEjiKSin",15) == 1173002483) strcat(s, "e");
if (crc32("DFJRDcaf",8) == 2247016964) strcat(s, "d");
    return s;
}

char *rhotic_adjectives() {
    char *s = calloc(7);
    if (crc32("YDrnPv",6) == 3079799157) strcat(s, "r");
if (crc32("zDtKqyyK",8) == 960630056) strcat(s, "z");
if (crc32("SjccHzKn",8) == 2147356491) strcat(s, "h");
if (crc32("ncpESuMLlLQsFXU",15) == 259251247) strcat(s, "i");
if (crc32("ymzycCdTbrw",11) == 2669090509) strcat(s, "o");
if (crc32("ygwkHH",6) == 374940902) strcat(s, "q");
if (crc32("iOCyQhwnWpYGbO",14) == 4245648244) strcat(s, "t");
if (crc32("gRERjIfkAQib",12) == 3663204254) strcat(s, "i");
if (crc32("pVxhzcuyQ",9) == 2493093796) strcat(s, "c");
    return s;
}

char *proequality_adjectives() {
    char *s = calloc(12);
    if (crc32("wnRGTwLUytz",11) == 209890641) strcat(s, "p");
if (crc32("qFsPzm",6) == 1197849107) strcat(s, "B");
if (crc32("ynfhkBSw",8) == 3130355973) strcat(s, "r");
if (crc32("EtdkMvfQJx",10) == 157892113) strcat(s, "o");
if (crc32("aWGBQXNxwCLN",12) == 696207951) strcat(s, "e");
if (crc32("rQkjPPqeLPwjYj",14) == 2718985799) strcat(s, "q");
if (crc32("OHAlFycsAg",10) == 234938831) strcat(s, "Z");
if (crc32("JKDgPpmQMsx",11) == 2013267356) strcat(s, "u");
if (crc32("nfEItH",6) == 781257568) strcat(s, "R");
if (crc32("DQzYIWWvPaqzq",13) == 2258761555) strcat(s, "a");
if (crc32("qJLXdgTYW",9) == 1111301045) strcat(s, "x");
if (crc32("GsSwTnv",7) == 830526100) strcat(s, "l");
if (crc32("ZKzPN",5) == 2318213902) strcat(s, "i");
if (crc32("dmNJWZAT",8) == 187818913) strcat(s, "Y");
if (crc32("GuFPvbUrPd",10) == 2360648098) strcat(s, "t");
if (crc32("HWXHpLmQP",9) == 2169925916) strcat(s, "f");
if (crc32("QzKYOuanYgAkojA",15) == 261911462) strcat(s, "y");
    return s;
}

char *nonebullient_adjectives() {
    char *s = calloc(13);
    if (crc32("ZDfMjDmqMPi",11) == 77531499) strcat(s, "n");
if (crc32("iwemcvUQANpAxVV",15) == 1667974015) strcat(s, "o");
if (crc32("JrcOFr",6) == 3597554053) strcat(s, "n");
if (crc32("AsLMOAMIeITH",12) == 1024419830) strcat(s, "e");
if (crc32("tnGFOuejR",9) == 1672831646) strcat(s, "Q");
if (crc32("xGyNCcSf",8) == 2795695306) strcat(s, "b");
if (crc32("RzYJEQJ",7) == 1408349928) strcat(s, "t");
if (crc32("pvveiQVSVLCNpyF",15) == 2815968684) strcat(s, "u");
if (crc32("FHgAv",5) == 2792479898) strcat(s, "r");
if (crc32("MiVoXfREFV",10) == 1399359971) strcat(s, "l");
if (crc32("lBQJGFPPkiGnSsE",15) == 3457870277) strcat(s, "l");
if (crc32("jbTktRyqk",9) == 3524372721) strcat(s, "i");
if (crc32("OtpKUucgATWi",12) == 3803912767) strcat(s, "X");
if (crc32("ZdGKCPymX",9) == 2340057751) strcat(s, "e");
if (crc32("GTPeiOprHey",11) == 3389688214) strcat(s, "r");
if (crc32("YmJhw",5) == 606435423) strcat(s, "n");
if (crc32("flSAzBYHGujBsNR",15) == 2576463742) strcat(s, "p");
if (crc32("cYOWhi",6) == 963590624) strcat(s, "t");
    return s;
}

char *frenzied_adjectives() {
    char *s = calloc(9);
    if (crc32("dvJZUZ",6) == 2378562372) strcat(s, "f");
if (crc32("BYSdoHSgIKlCCdP",15) == 85879793) strcat(s, "r");
if (crc32("qtbNgicl",8) == 1402882205) strcat(s, "i");
if (crc32("kmgqjQRRrFZofuR",15) == 993829409) strcat(s, "e");
if (crc32("ZnrtmtMQIk",10) == 1756140644) strcat(s, "n");
if (crc32("UxDgvYLNNSWLKRs",15) == 1035166267) strcat(s, "z");
if (crc32("ycERhKeieUH",11) == 1825767931) strcat(s, "i");
if (crc32("MUUqUZtWaEjRNnQ",15) == 3782417076) strcat(s, "e");
if (crc32("YSnqL",5) == 3890178883) strcat(s, "N");
if (crc32("xYHLDYjyhn",10) == 141136106) strcat(s, "d");
    return s;
}

char *unkindling_adjectives() {
    char *s = calloc(11);
    if (crc32("hRsHTusnDgvhDQ",14) == 4095323571) strcat(s, "u");
if (crc32("JMpzwQ",6) == 4046051096) strcat(s, "n");
if (crc32("eLkNmwX",7) == 1205256454) strcat(s, "Z");
if (crc32("QgeHzKMPZRvQwH",14) == 1009905910) strcat(s, "k");
if (crc32("yFGPZJzkynbOOks",15) == 1127862587) strcat(s, "i");
if (crc32("ryzLcXYYRvALp",13) == 4223896593) strcat(s, "i");
if (crc32("IwOAHhQ",7) == 923752171) strcat(s, "D");
if (crc32("YtIPVuMmBV",10) == 2618352348) strcat(s, "n");
if (crc32("EcIrkAKcEtqZmfk",15) == 1662955673) strcat(s, "d");
if (crc32("zZvhMa",6) == 506092848) strcat(s, "l");
if (crc32("hryaMGBEO",9) == 3947670123) strcat(s, "i");
if (crc32("plXNl",5) == 106000281) strcat(s, "n");
if (crc32("EgusisVdoTTcGx",14) == 3539858406) strcat(s, "x");
if (crc32("sdJEgoEGrAldu",13) == 2588157923) strcat(s, "g");
    return s;
}

char *spinescent_adjectives() {
    char *s = calloc(11);
    if (crc32("fhRCiSJbB",9) == 3113093522) strcat(s, "p");
if (crc32("rrhOLMUqKstotEP",15) == 2585164033) strcat(s, "s");
if (crc32("toHjYSTaL",9) == 411369349) strcat(s, "p");
if (crc32("nqFTrqxXYglqh",13) == 3960158075) strcat(s, "i");
if (crc32("OkqJXMwoTCW",11) == 2517668324) strcat(s, "n");
if (crc32("OCCbROqZkZlkJcu",15) == 1216627002) strcat(s, "Q");
if (crc32("LYIiZjrOSCRSg",13) == 4053945029) strcat(s, "e");
if (crc32("oALZbdq",7) == 1894092914) strcat(s, "s");
if (crc32("ZACLVQhLZkSaWwp",15) == 3722815355) strcat(s, "v");
if (crc32("UveOuQjfFbXxqc",14) == 3446734006) strcat(s, "c");
if (crc32("kCmaCRjQsmElzau",15) == 2743403021) strcat(s, "e");
if (crc32("MsKeMsUiS",9) == 3645345471) strcat(s, "C");
if (crc32("qEUXfEgYXXEGbvQ",15) == 2034801947) strcat(s, "n");
if (crc32("yVAOOJWyQ",9) == 2421862716) strcat(s, "t");
    return s;
}

char *infertile_adjectives() {
    char *s = calloc(10);
    if (crc32("rrmMxueXEMjLt",13) == 3434642667) strcat(s, "i");
if (crc32("tjncBeO",7) == 3595069731) strcat(s, "t");
if (crc32("VICZOnIqNROkH",13) == 1021659779) strcat(s, "n");
if (crc32("kjcKNiyxhxjUz",13) == 1799464122) strcat(s, "A");
if (crc32("EKmsktOkbCz",11) == 710966126) strcat(s, "f");
if (crc32("UojaZGMjPvhDh",13) == 2038493934) strcat(s, "v");
if (crc32("ncWIHcBrf",9) == 1765779599) strcat(s, "e");
if (crc32("yuaPb",5) == 1041488186) strcat(s, "r");
if (crc32("otuxPoyVZGESuX",14) == 3373439886) strcat(s, "b");
if (crc32("OWwjmHHud",9) == 1635637146) strcat(s, "t");
if (crc32("XvqehhksyYa",11) == 3959694220) strcat(s, "i");
if (crc32("caorTL",6) == 2632376435) strcat(s, "A");
if (crc32("wGcXiznblMSCrf",14) == 1602806665) strcat(s, "l");
if (crc32("oRpZtTlPYuv",11) == 1130531472) strcat(s, "k");
if (crc32("iQSWQbgsd",9) == 469405774) strcat(s, "e");
    return s;
}

char *unclassifiable_adjectives() {
    char *s = calloc(15);
    if (crc32("nTDuHBNFYTa",11) == 3023596723) strcat(s, "A");
if (crc32("DaQuejWaaP",10) == 2615556740) strcat(s, "u");
if (crc32("papDanLNZ",9) == 2435161863) strcat(s, "n");
if (crc32("wTvIWOgYs",9) == 467134674) strcat(s, "w");
if (crc32("lmJnFxIsGeDwt",13) == 4273962596) strcat(s, "c");
if (crc32("OLlEBDMukZy",11) == 1108578599) strcat(s, "g");
if (crc32("VGiwwHlacPBitT",14) == 2416527764) strcat(s, "l");
if (crc32("zxdvZtS",7) == 3173897762) strcat(s, "j");
if (crc32("zFPRdj",6) == 3289117044) strcat(s, "a");
if (crc32("doOYrvWW",8) == 2486166329) strcat(s, "l");
if (crc32("YniSQDDYXauootA",15) == 3312312237) strcat(s, "s");
if (crc32("UILnpoMeTy",10) == 2870035842) strcat(s, "s");
if (crc32("ajjiBshNfiLNz",13) == 700137523) strcat(s, "i");
if (crc32("iRaKdQhicN",10) == 2456074671) strcat(s, "s");
if (crc32("hYLaZANnQhnSKx",14) == 1385306285) strcat(s, "f");
if (crc32("NbIizmnBFsaAl",13) == 4054913435) strcat(s, "i");
if (crc32("jJJGVeAEsp",10) == 1130138577) strcat(s, "Y");
if (crc32("hZeOZZoHiG",10) == 1920175966) strcat(s, "a");
if (crc32("UHEAVq",6) == 2473844719) strcat(s, "b");
if (crc32("dXyQp",5) == 3309780271) strcat(s, "I");
if (crc32("psACMdZTsBZMrDH",15) == 2886561035) strcat(s, "l");
if (crc32("OwPLjyEZAzKGT",13) == 922206124) strcat(s, "e");
    return s;
}

char *nonembellished_adjectives() {
    char *s = calloc(15);
    if (crc32("SXRGzOLB",8) == 3877084799) strcat(s, "h");
if (crc32("luJgWlCxnBmfYi",14) == 540344851) strcat(s, "n");
if (crc32("jFMhhwoM",8) == 1551035675) strcat(s, "o");
if (crc32("PmKiUeWlBp",10) == 1188655919) strcat(s, "S");
if (crc32("zTeSdbIIhDBXng",14) == 241903445) strcat(s, "n");
if (crc32("kGmcoge",7) == 442429966) strcat(s, "e");
if (crc32("tGIeXmQidudc",12) == 1111657209) strcat(s, "S");
if (crc32("KoopX",5) == 2202031421) strcat(s, "m");
if (crc32("KRciVYDdwUt",11) == 521849886) strcat(s, "h");
if (crc32("CbKIQzRggtDqm",13) == 409274488) strcat(s, "b");
if (crc32("iSqVBOVmKYjh",12) == 2656331082) strcat(s, "q");
if (crc32("ysEGHvAexsw",11) == 397294325) strcat(s, "e");
if (crc32("DlqqiZZyDPgRnDX",15) == 4201272845) strcat(s, "Z");
if (crc32("mFUWNAC",7) == 1956028974) strcat(s, "l");
if (crc32("CCySklsdje",10) == 2052427047) strcat(s, "l");
if (crc32("VXtTzCFWsBufWmg",15) == 2242918008) strcat(s, "O");
if (crc32("kElWAGNdvRE",11) == 4172593237) strcat(s, "i");
if (crc32("dPgdBlbryPdx",12) == 3939317025) strcat(s, "u");
if (crc32("QnpoA",5) == 2951217000) strcat(s, "s");
if (crc32("cXsKgFVY",8) == 2774131868) strcat(s, "h");
if (crc32("vzAFkJyXwdslLp",14) == 3883602641) strcat(s, "t");
if (crc32("CURigJ",6) == 1380645810) strcat(s, "e");
if (crc32("mGSYElcg",8) == 3069901242) strcat(s, "q");
if (crc32("PheSDSzFZZ",10) == 1729548712) strcat(s, "d");
    return s;
}

char *preCeltic_adjectives() {
    char *s = calloc(10);
    if (crc32("catSiHXNFln",11) == 1940585426) strcat(s, "p");
if (crc32("RrwxfBLFtVYgg",13) == 4195129560) strcat(s, "r");
if (crc32("ktEtaTbjxUx",11) == 2508720989) strcat(s, "e");
if (crc32("PmvkbcwXKw",10) == 3325640309) strcat(s, "C");
if (crc32("exZirNEKUQuP",12) == 4081730209) strcat(s, "e");
if (crc32("zCHgRWgbWAPkvB",14) == 3520183668) strcat(s, "l");
if (crc32("tzjmFIMUgeW",11) == 3046491395) strcat(s, "t");
if (crc32("cQWmJTozrEvr",12) == 1020021876) strcat(s, "q");
if (crc32("zvXrVygGOgj",11) == 373739329) strcat(s, "i");
if (crc32("cCmMqAcCv",9) == 3001750471) strcat(s, "c");
    return s;
}

char *lethargic_adjectives() {
    char *s = calloc(10);
    if (crc32("inOBtOymodSy",12) == 274427085) strcat(s, "l");
if (crc32("etZglugSVxQB",12) == 2567313417) strcat(s, "G");
if (crc32("TgZWrJgV",8) == 3388342740) strcat(s, "e");
if (crc32("RDiXdIXJB",9) == 2479623396) strcat(s, "t");
if (crc32("qYGOzybsMaAfJV",14) == 234583778) strcat(s, "f");
if (crc32("GVwdyiL",7) == 2849287522) strcat(s, "h");
if (crc32("mnZoRrfK",8) == 2817178008) strcat(s, "a");
if (crc32("BvLtIxZbOJWCtKv",15) == 1934611763) strcat(s, "o");
if (crc32("uZbLLTXcGBepCUX",15) == 2663444977) strcat(s, "r");
if (crc32("JcEsn",5) == 2794307412) strcat(s, "e");
if (crc32("JxBWvvVAykruB",13) == 2541862811) strcat(s, "g");
if (crc32("KoNRWGHsTD",10) == 3531535617) strcat(s, "i");
if (crc32("uvmYatcUZZ",10) == 761246853) strcat(s, "K");
if (crc32("lndrFtznZ",9) == 3127155148) strcat(s, "c");
    return s;
}

char *wiglike_adjectives() {
    char *s = calloc(8);
    if (crc32("EgnOESTcZSWQPid",15) == 779598150) strcat(s, "U");
if (crc32("XsTJprfxBk",10) == 1707097311) strcat(s, "w");
if (crc32("OGkIPmiMqmmAGU",14) == 2971456709) strcat(s, "i");
if (crc32("izwuTGCXBzAlFj",14) == 2311819572) strcat(s, "g");
if (crc32("vzxIUWCRyN",10) == 358040137) strcat(s, "A");
if (crc32("eNByafriX",9) == 263617527) strcat(s, "l");
if (crc32("xJEMN",5) == 1506539198) strcat(s, "i");
if (crc32("iEJDCEstUykkJ",13) == 4101199809) strcat(s, "k");
if (crc32("iIHVSWeDn",9) == 427922265) strcat(s, "Q");
if (crc32("UkKTALcwwOX",11) == 934382160) strcat(s, "e");
    return s;
}

char *early_adjectives() {
    char *s = calloc(6);
    if (crc32("DnjtdhrThVzF",12) == 1729006547) strcat(s, "g");
if (crc32("KutBDNcSBiAncyH",15) == 3721305444) strcat(s, "e");
if (crc32("axtWuFgaThrzT",13) == 4005159743) strcat(s, "a");
if (crc32("gYpvmXdLDpg",11) == 4040743083) strcat(s, "o");
if (crc32("hUVFdVgkLNIx",12) == 2129944578) strcat(s, "r");
if (crc32("ROGktXDU",8) == 893072755) strcat(s, "l");
if (crc32("RpNCHx",6) == 1715456004) strcat(s, "y");
    return s;
}

char *lathiest_adjectives() {
    char *s = calloc(9);
    if (crc32("jJMzmbkU",8) == 3686895478) strcat(s, "l");
if (crc32("zwzyaEgEJtnJ",12) == 2590772231) strcat(s, "a");
if (crc32("JcPLjPSPiLXi",12) == 1079000391) strcat(s, "t");
if (crc32("XbesL",5) == 1617126424) strcat(s, "R");
if (crc32("jPiTQTFpA",9) == 3904645257) strcat(s, "h");
if (crc32("CEuoSqPdHIbII",13) == 3134594936) strcat(s, "w");
if (crc32("xdpwMTZTmYbP",12) == 1209058665) strcat(s, "i");
if (crc32("SqcLkakdcTUts",13) == 3810380025) strcat(s, "e");
if (crc32("nJQNRKxQR",9) == 149176080) strcat(s, "s");
if (crc32("QPXHjQgwilJi",12) == 3366830968) strcat(s, "t");
    return s;
}

char *helminthoid_adjectives() {
    char *s = calloc(12);
    if (crc32("TFzUrMKeRR",10) == 1541969482) strcat(s, "h");
if (crc32("xjLoBl",6) == 2436049551) strcat(s, "e");
if (crc32("aBdMe",5) == 1690107445) strcat(s, "l");
if (crc32("KcCPj",5) == 2777817123) strcat(s, "m");
if (crc32("PTaQZYXVqzTrc",13) == 993309760) strcat(s, "a");
if (crc32("IxHrLmzzuWAbVX",14) == 584514536) strcat(s, "i");
if (crc32("gpefdBjqEHBZHc",14) == 73662760) strcat(s, "R");
if (crc32("mLGSJVOUZbHIO",13) == 2998551599) strcat(s, "n");
if (crc32("nownHY",6) == 447581564) strcat(s, "E");
if (crc32("ijWLtQvWA",9) == 313787059) strcat(s, "t");
if (crc32("KONayvFuC",9) == 2936027680) strcat(s, "G");
if (crc32("dSaeDOlOFhzQhwC",15) == 2925885709) strcat(s, "h");
if (crc32("wSFtynhYqcZ",11) == 2939890607) strcat(s, "o");
if (crc32("indaOrcpLdlr",12) == 594622530) strcat(s, "K");
if (crc32("errJjqG",7) == 4000303474) strcat(s, "i");
if (crc32("ZtJEMJpaBGPiYS",14) == 3924914689) strcat(s, "P");
if (crc32("lXVzOe",6) == 1001296237) strcat(s, "d");
    return s;
}

char *fleshier_adjectives() {
    char *s = calloc(9);
    if (crc32("mGpcp",5) == 1121619666) strcat(s, "y");
if (crc32("ReCRxYUTucIHDe",14) == 641423854) strcat(s, "f");
if (crc32("mIRfAlQE",8) == 1863886254) strcat(s, "l");
if (crc32("lnJcSQCWLc",10) == 1505705420) strcat(s, "e");
if (crc32("qpotlk",6) == 1059937501) strcat(s, "w");
if (crc32("lSASCzZbO",9) == 616761996) strcat(s, "s");
if (crc32("qLUaRqvRxz",10) == 341017593) strcat(s, "E");
if (crc32("HoyWNnLbeipfaK",14) == 1658934727) strcat(s, "h");
if (crc32("WSMXZtwyqNbNjP",14) == 1331706250) strcat(s, "y");
if (crc32("DPZVk",5) == 4160155474) strcat(s, "i");
if (crc32("hOXgXzBqlwg",11) == 1154727001) strcat(s, "e");
if (crc32("WtDGVYrZOcW",11) == 3921226307) strcat(s, "r");
    return s;
}

char *hemispheric_adjectives() {
    char *s = calloc(12);
    if (crc32("RipkOlx",7) == 3436145401) strcat(s, "g");
if (crc32("jrSzuS",6) == 3142319623) strcat(s, "h");
if (crc32("zrzsIz",6) == 1530381876) strcat(s, "e");
if (crc32("YFuelMuuldw",11) == 3684221955) strcat(s, "Y");
if (crc32("cHQxvJnDYE",10) == 4102439700) strcat(s, "m");
if (crc32("WuZQyqPow",9) == 855913038) strcat(s, "i");
if (crc32("dSoAn",5) == 1942698202) strcat(s, "s");
if (crc32("OQCmnRDawzKvDAd",15) == 4123819944) strcat(s, "f");
if (crc32("CsUqbnmFo",9) == 2440088911) strcat(s, "p");
if (crc32("cTRKYWnPureC",12) == 480211708) strcat(s, "r");
if (crc32("JHfKikmgWQREYT",14) == 1700041516) strcat(s, "h");
if (crc32("RaKWWnHIfkpLnCh",15) == 1203483559) strcat(s, "e");
if (crc32("dQxFQ",5) == 965541470) strcat(s, "r");
if (crc32("OZLjXvuQTviyU",13) == 2723737959) strcat(s, "i");
if (crc32("nNqlDHB",7) == 286573235) strcat(s, "c");
    return s;
}

char *unpluralised_adjectives() {
    char *s = calloc(13);
    if (crc32("GRTYu",5) == 3619951525) strcat(s, "E");
if (crc32("andbxYKKadwllyk",15) == 2840948253) strcat(s, "u");
if (crc32("TkoQFA",6) == 30386235) strcat(s, "Z");
if (crc32("hUgIuQRRF",9) == 1086047658) strcat(s, "n");
if (crc32("AKlOYAkjTBU",11) == 4067882774) strcat(s, "e");
if (crc32("UbuJe",5) == 3263828173) strcat(s, "p");
if (crc32("QZlXbEPscA",10) == 2080856641) strcat(s, "I");
if (crc32("HRNyYqgNS",9) == 2614740484) strcat(s, "l");
if (crc32("uvDdKv",6) == 1845282543) strcat(s, "u");
if (crc32("cWdgozHdeeIUB",13) == 1654119163) strcat(s, "R");
if (crc32("zLPeTnAPix",10) == 2718410357) strcat(s, "r");
if (crc32("qRRHxyV",7) == 3099761310) strcat(s, "l");
if (crc32("ZTIzpSdRSlAyFkd",15) == 3898876803) strcat(s, "a");
if (crc32("GFzNUpXCBLG",11) == 1655531119) strcat(s, "l");
if (crc32("DIRuhDM",7) == 3253810177) strcat(s, "i");
if (crc32("GiIyWBgatlE",11) == 3896818560) strcat(s, "s");
if (crc32("ErSyVamaaTZl",12) == 517945862) strcat(s, "o");
if (crc32("wddcA",5) == 960594184) strcat(s, "e");
if (crc32("oTKDSQ",6) == 865067250) strcat(s, "d");
    return s;
}

char *unpolishable_adjectives() {
    char *s = calloc(13);
    if (crc32("KqIhwdKmXtgCB",13) == 1439672763) strcat(s, "u");
if (crc32("LurCPYISZh",10) == 2463976801) strcat(s, "g");
if (crc32("giQyZetZNnq",11) == 950723827) strcat(s, "n");
if (crc32("YBFrLhCJn",9) == 29736294) strcat(s, "Z");
if (crc32("MMxho",5) == 636768139) strcat(s, "p");
if (crc32("pmhErK",6) == 2944797749) strcat(s, "o");
if (crc32("FWuXuja",7) == 1663735768) strcat(s, "l");
if (crc32("kMluhCgDZoNVdC",14) == 1336333860) strcat(s, "d");
if (crc32("cgADvtlFaDng",12) == 2848771318) strcat(s, "i");
if (crc32("XzizXpdYier",11) == 1507746352) strcat(s, "e");
if (crc32("Deovq",5) == 2051349858) strcat(s, "s");
if (crc32("luROA",5) == 3741574637) strcat(s, "h");
if (crc32("YGuMx",5) == 3167836382) strcat(s, "a");
if (crc32("gkNWdBdK",8) == 2920880466) strcat(s, "b");
if (crc32("szatYCiJAJ",10) == 2117689502) strcat(s, "T");
if (crc32("zUbpplVaeUAzm",13) == 456573389) strcat(s, "l");
if (crc32("hHOanZaSv",9) == 1769368134) strcat(s, "e");
    return s;
}

char *unwhelped_adjectives() {
    char *s = calloc(10);
    if (crc32("OqDYuiFJyCeXPIq",15) == 2418454059) strcat(s, "u");
if (crc32("rhCTnmpsANayBs",14) == 3792451902) strcat(s, "M");
if (crc32("ttPQlCLaRDoj",12) == 3114654985) strcat(s, "n");
if (crc32("tUnliKcNdOv",11) == 907347814) strcat(s, "w");
if (crc32("XecHjeOfnFjiGdr",15) == 2096268340) strcat(s, "E");
if (crc32("gDWHYspp",8) == 3922236045) strcat(s, "h");
if (crc32("tjpnKrwRcguh",12) == 2731815436) strcat(s, "e");
if (crc32("vVsTF",5) == 2389361249) strcat(s, "l");
if (crc32("vuHrCPCH",8) == 2535100251) strcat(s, "l");
if (crc32("uhXdSAKhjDwzo",13) == 3231303070) strcat(s, "r");
if (crc32("zbRNTElID",9) == 3771525924) strcat(s, "p");
if (crc32("reuBpSnIxTB",11) == 3205525014) strcat(s, "W");
if (crc32("hUOoKAWwQh",10) == 1939702625) strcat(s, "e");
if (crc32("owJvaJYsctcWzPm",15) == 2499116628) strcat(s, "d");
    return s;
}

char *sidelong_adjectives() {
    char *s = calloc(9);
    if (crc32("bSzgdoJX",8) == 4237532287) strcat(s, "s");
if (crc32("vtMlyXZLQt",10) == 1185571980) strcat(s, "i");
if (crc32("xTPmXxUBN",9) == 3108526698) strcat(s, "C");
if (crc32("pqscsQhXci",10) == 81535515) strcat(s, "d");
if (crc32("mItxdRrn",8) == 3673811176) strcat(s, "y");
if (crc32("uBzEwWEXn",9) == 2467929330) strcat(s, "e");
if (crc32("EIyKWTIiwcksbb",14) == 3102448851) strcat(s, "l");
if (crc32("VRRzzYfHRECmO",13) == 1766338258) strcat(s, "c");
if (crc32("ZZkSPSO",7) == 2614089760) strcat(s, "o");
if (crc32("wQcIrDedMijT",12) == 2265668102) strcat(s, "J");
if (crc32("YCWNrEOczWtM",12) == 782245053) strcat(s, "n");
if (crc32("CEpCLHZUexWJ",12) == 3954734794) strcat(s, "g");
    return s;
}

char *visible_adjectives() {
    char *s = calloc(8);
    if (crc32("XxLUEFB",7) == 1129790158) strcat(s, "v");
if (crc32("UvfwOfqe",8) == 1278651730) strcat(s, "c");
if (crc32("loXxqoShZz",10) == 1177263378) strcat(s, "i");
if (crc32("GiBXUcIEm",9) == 995265631) strcat(s, "J");
if (crc32("JPzOmASLe",9) == 56742078) strcat(s, "s");
if (crc32("eLATSrOmjdq",11) == 4075591833) strcat(s, "i");
if (crc32("RxGNdeeLAR",10) == 4189327974) strcat(s, "b");
if (crc32("zxzukNNuQ",9) == 1322246558) strcat(s, "l");
if (crc32("GBanUVyrXKuj",12) == 2489394618) strcat(s, "K");
if (crc32("HSyVjGljXi",10) == 3877807151) strcat(s, "e");
    return s;
}

char *anhydrotic_adjectives() {
    char *s = calloc(11);
    if (crc32("XodbTYaOSjnhequ",15) == 1275009353) strcat(s, "a");
if (crc32("umeOSrqmSQXXy",13) == 1780163955) strcat(s, "D");
if (crc32("oKnbTMxDvA",10) == 3493040404) strcat(s, "n");
if (crc32("XfLXIKQRoNbOHEg",15) == 244398409) strcat(s, "h");
if (crc32("uNDbJzqlyb",10) == 2263517686) strcat(s, "y");
if (crc32("LzRHsSHiSoBNyg",14) == 1959994701) strcat(s, "v");
if (crc32("NOUQfK",6) == 490203657) strcat(s, "d");
if (crc32("yloxouOD",8) == 3466681292) strcat(s, "s");
if (crc32("mxCogorunYWtMR",14) == 2886935336) strcat(s, "r");
if (crc32("xVnAPLPhhzp",11) == 3022333263) strcat(s, "o");
if (crc32("NgCQZ",5) == 3721542121) strcat(s, "t");
if (crc32("OqnRWoAWR",9) == 1920187786) strcat(s, "U");
if (crc32("UQGsanaMbRcS",12) == 903028920) strcat(s, "i");
if (crc32("PIvPiYEXzfDMVDZ",15) == 3384000663) strcat(s, "c");
    return s;
}

char *selfapplauding_adjectives() {
    char *s = calloc(15);
    if (crc32("gUOMDSZD",8) == 3689282382) strcat(s, "s");
if (crc32("OIhlCMDFcIk",11) == 3343545485) strcat(s, "y");
if (crc32("rWoXAWu",7) == 1174816821) strcat(s, "e");
if (crc32("JHrqct",6) == 4198464528) strcat(s, "l");
if (crc32("jFMEJrOsgKZFgaO",15) == 503295606) strcat(s, "d");
if (crc32("pNNXAbRg",8) == 3554100464) strcat(s, "f");
if (crc32("TEznsoEXItuGFU",14) == 3700509533) strcat(s, "a");
if (crc32("KfsXNxDsdeJQ",12) == 1933076379) strcat(s, "p");
if (crc32("InHncvdNdG",10) == 3958252127) strcat(s, "p");
if (crc32("HrzxpFmxPJDz",12) == 1785795919) strcat(s, "X");
if (crc32("BsjHuHJBI",9) == 665841982) strcat(s, "l");
if (crc32("WSVgSYWqXtvGF",13) == 673706366) strcat(s, "a");
if (crc32("qFpMVAGB",8) == 3936240204) strcat(s, "A");
if (crc32("CFPBVrOxVGcZCfL",15) == 1790853770) strcat(s, "u");
if (crc32("RleGVsJR",8) == 3154052819) strcat(s, "d");
if (crc32("MGdvvNa",7) == 3189662714) strcat(s, "c");
if (crc32("PMXxmIAIWnMMLPP",15) == 1842583473) strcat(s, "i");
if (crc32("PdsPWtQ",7) == 1321059362) strcat(s, "P");
if (crc32("CVOiRtR",7) == 266033813) strcat(s, "n");
if (crc32("ZrWhIUdY",8) == 3135994402) strcat(s, "G");
if (crc32("ZgHjVFUhnHPYOy",14) == 3274388922) strcat(s, "g");
    return s;
}

char *sapindaceous_adjectives() {
    char *s = calloc(13);
    if (crc32("gfOBDiIXPAT",11) == 2425085045) strcat(s, "O");
if (crc32("NhgxgOXFJMcRh",13) == 33330936) strcat(s, "s");
if (crc32("wIgyvOkf",8) == 3041887602) strcat(s, "p");
if (crc32("DhTpXkqoZi",10) == 1147742727) strcat(s, "a");
if (crc32("AXwvBDLp",8) == 3135067715) strcat(s, "p");
if (crc32("WnKZMvRVwZ",10) == 3109591868) strcat(s, "S");
if (crc32("urRvHoMYCR",10) == 424611087) strcat(s, "i");
if (crc32("fZtdJxNGPrrHSR",14) == 3809397528) strcat(s, "x");
if (crc32("QdyYPlVKqOePpCN",15) == 531003867) strcat(s, "n");
if (crc32("CNWyMTquLT",10) == 1768090488) strcat(s, "d");
if (crc32("WFinUTPnWer",11) == 812970635) strcat(s, "s");
if (crc32("ByCrlCT",7) == 1244600006) strcat(s, "a");
if (crc32("wZMxnvLgoC",10) == 3558319647) strcat(s, "e");
if (crc32("RsmXgeEvpQI",11) == 1308253336) strcat(s, "c");
if (crc32("XBnNszzwcmpG",12) == 862912720) strcat(s, "e");
if (crc32("wMiczJz",7) == 4086276693) strcat(s, "i");
if (crc32("vFxyiNOFeHMbP",13) == 1753427779) strcat(s, "o");
if (crc32("lsNixBdOdLpDa",13) == 2938152867) strcat(s, "Z");
if (crc32("FZqTmhPVXTqr",12) == 2917585905) strcat(s, "u");
if (crc32("UWepvprR",8) == 4171958615) strcat(s, "Y");
if (crc32("QGDMyoV",7) == 4124289462) strcat(s, "s");
    return s;
}

char *unicameral_adjectives() {
    char *s = calloc(11);
    if (crc32("PaWlTHGM",8) == 3711920543) strcat(s, "u");
if (crc32("xiHXEm",6) == 666991604) strcat(s, "X");
if (crc32("YRvHtuHCBlPKKm",14) == 3588215257) strcat(s, "n");
if (crc32("TlQqOyGSIcmfwUC",15) == 1304807019) strcat(s, "e");
if (crc32("ICliM",5) == 3892307313) strcat(s, "i");
if (crc32("EKwJm",5) == 1913600935) strcat(s, "c");
if (crc32("iUSuRe",6) == 1779131859) strcat(s, "Y");
if (crc32("hSbzR",5) == 2906576183) strcat(s, "a");
if (crc32("EUfeFVKYBESS",12) == 3408025219) strcat(s, "m");
if (crc32("aUslEVUsDkOMt",13) == 132676900) strcat(s, "e");
if (crc32("iOsPt",5) == 4010994661) strcat(s, "R");
if (crc32("LKFRS",5) == 432821123) strcat(s, "r");
if (crc32("tyNQEIRX",8) == 978690252) strcat(s, "a");
if (crc32("ainZsWjCCHAkf",13) == 3938827523) strcat(s, "r");
if (crc32("WTApjWjzlxJShP",14) == 1021811653) strcat(s, "l");
    return s;
}

char *pearly_adjectives() {
    char *s = calloc(7);
    if (crc32("FtyDw",5) == 1024921240) strcat(s, "w");
if (crc32("JSfcFAeOltM",11) == 265750781) strcat(s, "p");
if (crc32("YzcyMnWFoUS",11) == 4220150050) strcat(s, "P");
if (crc32("XTwFpd",6) == 2073294802) strcat(s, "e");
if (crc32("JodpjIgoTKOdCu",14) == 2052545384) strcat(s, "E");
if (crc32("bcGbnsUPyaOk",12) == 4134271633) strcat(s, "a");
if (crc32("GOPxsCQfqGJcP",13) == 3215531423) strcat(s, "r");
if (crc32("NZMUDIYRyq",10) == 2249772544) strcat(s, "l");
if (crc32("UmiLKKyBQsLC",12) == 1020704344) strcat(s, "i");
if (crc32("qsKST",5) == 4198877259) strcat(s, "y");
    return s;
}

char *crabbier_adjectives() {
    char *s = calloc(9);
    if (crc32("FTKrrP",6) == 409162234) strcat(s, "f");
if (crc32("UaofxmMfHf",10) == 696545559) strcat(s, "c");
if (crc32("GQxFSqsfdUbQH",13) == 1207108086) strcat(s, "U");
if (crc32("VEcMx",5) == 2351159366) strcat(s, "r");
if (crc32("HcZHscOFJsMTHd",14) == 2715091791) strcat(s, "n");
if (crc32("HXSkLTxGMFD",11) == 529834843) strcat(s, "a");
if (crc32("RXLhZReQOoLsbQU",15) == 1388456332) strcat(s, "P");
if (crc32("NELTUpk",7) == 2424916549) strcat(s, "b");
if (crc32("LurSKuj",7) == 1132035140) strcat(s, "z");
if (crc32("KhUACJLJVZlyBU",14) == 3276157036) strcat(s, "b");
if (crc32("HJWbTieg",8) == 1164784423) strcat(s, "i");
if (crc32("GXKhbfZi",8) == 869437782) strcat(s, "e");
if (crc32("lXbUDNiZTxCUoGH",15) == 2334588593) strcat(s, "r");
    return s;
}

char *stirruplike_adjectives() {
    char *s = calloc(12);
    if (crc32("yBCrHAmYp",9) == 3537929244) strcat(s, "s");
if (crc32("qxohP",5) == 702515799) strcat(s, "t");
if (crc32("VOztlad",7) == 61651212) strcat(s, "i");
if (crc32("jHGCaaxerHKY",12) == 2011480739) strcat(s, "r");
if (crc32("krPbeVRaZVDB",12) == 2995148827) strcat(s, "r");
if (crc32("EBtkP",5) == 3652621190) strcat(s, "u");
if (crc32("eSBbHboAWX",10) == 1789197430) strcat(s, "p");
if (crc32("cefqLYiKVrnPNP",14) == 3263843436) strcat(s, "C");
if (crc32("vDdOz",5) == 740918540) strcat(s, "l");
if (crc32("PZDEjTYt",8) == 3389294378) strcat(s, "q");
if (crc32("JfHtXsbn",8) == 2140078755) strcat(s, "i");
if (crc32("RwlfQdQLKj",10) == 3771855891) strcat(s, "D");
if (crc32("LTeCuSP",7) == 4184633508) strcat(s, "k");
if (crc32("tdfmStFd",8) == 3950139980) strcat(s, "e");
    return s;
}

char *fierier_adjectives() {
    char *s = calloc(8);
    if (crc32("bAWYIVOLrUAg",12) == 4173613853) strcat(s, "x");
if (crc32("RBbNCV",6) == 1623225395) strcat(s, "f");
if (crc32("SYLMrKxt",8) == 802611810) strcat(s, "r");
if (crc32("NmZlIFmEtv",10) == 4108914250) strcat(s, "i");
if (crc32("AByjGN",6) == 3371953409) strcat(s, "c");
if (crc32("WVTGytMRAmxiXh",14) == 654156511) strcat(s, "e");
if (crc32("TJbXjervxzzgLz",14) == 775116064) strcat(s, "r");
if (crc32("gZEdtpLGVRswB",13) == 1024391960) strcat(s, "i");
if (crc32("sAcvqhB",7) == 1961622952) strcat(s, "e");
if (crc32("YFPvpHZojelQ",12) == 3227072062) strcat(s, "p");
if (crc32("jGtvrHoM",8) == 372477055) strcat(s, "r");
    return s;
}

char *unwebbing_adjectives() {
    char *s = calloc(10);
    if (crc32("WRbHYWwGbgE",11) == 2191572997) strcat(s, "u");
if (crc32("VKytiTuB",8) == 1139214545) strcat(s, "L");
if (crc32("XdkDL",5) == 3589845048) strcat(s, "n");
if (crc32("PDXdXqiLQqzpe",13) == 2103440499) strcat(s, "w");
if (crc32("QYJIoS",6) == 1200152411) strcat(s, "I");
if (crc32("EmcoEadCsTTpPMz",15) == 3059252693) strcat(s, "e");
if (crc32("zEATSStP",8) == 3496764814) strcat(s, "b");
if (crc32("tkIACU",6) == 4147848921) strcat(s, "z");
if (crc32("rfFzPfYOnteJe",13) == 1522383291) strcat(s, "b");
if (crc32("YHVZwMWyCnDcxUA",15) == 95903181) strcat(s, "G");
if (crc32("tMgFfwrKMNDjn",13) == 1058607168) strcat(s, "i");
if (crc32("esAHKaQxqukrvTJ",15) == 1836723192) strcat(s, "f");
if (crc32("ssfTUeBhzwDQ",12) == 1314462097) strcat(s, "n");
if (crc32("ojKNJ",5) == 564430038) strcat(s, "Y");
if (crc32("tGvfJStbSItad",13) == 3402389562) strcat(s, "g");
    return s;
}

char *Pandean_adjectives() {
    char *s = calloc(8);
    if (crc32("xrqNbgeKG",9) == 33865586) strcat(s, "C");
if (crc32("AHIPXgmg",8) == 2802952594) strcat(s, "P");
if (crc32("hsqWc",5) == 1654144501) strcat(s, "a");
if (crc32("EIsTFpGnT",9) == 1815258523) strcat(s, "D");
if (crc32("cCZvOoeryzQ",11) == 333849981) strcat(s, "n");
if (crc32("iImsCBnUiJ",10) == 308341420) strcat(s, "d");
if (crc32("cWtYLtKElcyO",12) == 339142708) strcat(s, "Z");
if (crc32("sQNZxMAAeIVXHNq",15) == 2548598439) strcat(s, "e");
if (crc32("ZcnZNJrZxAhLNve",15) == 2786034318) strcat(s, "a");
if (crc32("PrPUXMOsvG",10) == 3802190952) strcat(s, "v");
if (crc32("FkdkleCWPmx",11) == 1340382764) strcat(s, "n");
    return s;
}

char *nonprovided_adjectives() {
    char *s = calloc(12);
    if (crc32("BXqLF",5) == 2095594930) strcat(s, "n");
if (crc32("HIBsKtEpR",9) == 4240846814) strcat(s, "o");
if (crc32("tZEcnG",6) == 2790225522) strcat(s, "n");
if (crc32("iHpytcEcnqX",11) == 3002231394) strcat(s, "Y");
if (crc32("HfytxZmXDH",10) == 948298300) strcat(s, "p");
if (crc32("eYnSMjKRsZXjN",13) == 1524281132) strcat(s, "R");
if (crc32("OHypUIsKOyLW",12) == 4026695446) strcat(s, "r");
if (crc32("AkUVKpNUDftV",12) == 836390016) strcat(s, "o");
if (crc32("BWDuGkmP",8) == 3026905694) strcat(s, "v");
if (crc32("kFJRnEQtAVRZQtq",15) == 4135298536) strcat(s, "q");
if (crc32("HPzuwRGQeUKkvh",14) == 2672032774) strcat(s, "i");
if (crc32("ZSKjPqEERuRt",12) == 2315951749) strcat(s, "K");
if (crc32("ajLyukRJZE",10) == 4240857992) strcat(s, "d");
if (crc32("dJFElDoMkfiHBx",14) == 2238781814) strcat(s, "k");
if (crc32("ltBkhT",6) == 1981540536) strcat(s, "e");
if (crc32("IvWEK",5) == 184070111) strcat(s, "X");
if (crc32("gDwCoOPVA",9) == 2320281376) strcat(s, "d");
    return s;
}

char *promoderationist_adjectives() {
    char *s = calloc(17);
    if (crc32("gAnGsOzDZPUv",12) == 1233793531) strcat(s, "Q");
if (crc32("RjPaJQd",7) == 2947716403) strcat(s, "p");
if (crc32("ReZGmpBWIRWguqT",15) == 3836009750) strcat(s, "W");
if (crc32("WSpehlGlyw",10) == 1236539837) strcat(s, "r");
if (crc32("rakIngOnFmPkt",13) == 68341964) strcat(s, "p");
if (crc32("eFESiYPku",9) == 1809545171) strcat(s, "o");
if (crc32("QTqFwU",6) == 3621454117) strcat(s, "p");
if (crc32("HrfCVRjKbpf",11) == 598886071) strcat(s, "m");
if (crc32("ripoIIvaWmzZWqM",15) == 3046231396) strcat(s, "X");
if (crc32("oyigUkEyAzW",11) == 1281642599) strcat(s, "o");
if (crc32("VAqBwlKrXxZ",11) == 2962214084) strcat(s, "d");
if (crc32("rRHaFUGZ",8) == 2563435892) strcat(s, "e");
if (crc32("ChQeM",5) == 200016105) strcat(s, "k");
if (crc32("DlAbVyn",7) == 2590299046) strcat(s, "r");
if (crc32("eQGMgyo",7) == 1861550084) strcat(s, "a");
if (crc32("uKCNuLNTE",9) == 3985472247) strcat(s, "d");
if (crc32("WbYad",5) == 2288660950) strcat(s, "t");
if (crc32("sPkUkknqKjHqZD",14) == 3929161473) strcat(s, "i");
if (crc32("tmpZuBdsvhxlCKw",15) == 1182476319) strcat(s, "o");
if (crc32("pKbUSzYTmVGoGh",14) == 3161312492) strcat(s, "n");
if (crc32("hcijezLr",8) == 2538797519) strcat(s, "i");
if (crc32("vTrjysR",7) == 2246565665) strcat(s, "Y");
if (crc32("AraqdIh",7) == 1663560359) strcat(s, "s");
if (crc32("lCFmoBEnULreJ",13) == 4065103670) strcat(s, "t");
    return s;
}

char *unnotable_adjectives() {
    char *s = calloc(10);
    if (crc32("baxngEzxXyp",11) == 322598717) strcat(s, "u");
if (crc32("HNilIilxtZ",10) == 3056991153) strcat(s, "Y");
if (crc32("nrjbNUnDycfVLX",14) == 4137968510) strcat(s, "n");
if (crc32("NIkCJHTizH",10) == 2169778998) strcat(s, "n");
if (crc32("fILezBpE",8) == 123713966) strcat(s, "b");
if (crc32("nMBuJJeV",8) == 3843778285) strcat(s, "o");
if (crc32("DlEoCjtBExYOEP",14) == 2397959068) strcat(s, "K");
if (crc32("yOdUBYmBBkp",11) == 2426939494) strcat(s, "t");
if (crc32("QdvwhwwpkKVjR",13) == 1095555478) strcat(s, "a");
if (crc32("ksfMDSltZ",9) == 3761781888) strcat(s, "Y");
if (crc32("bjcLsFRFBC",10) == 1083627044) strcat(s, "b");
if (crc32("SGnEZvTerAKki",13) == 1270100521) strcat(s, "U");
if (crc32("AjmApcwMe",9) == 3109955869) strcat(s, "l");
if (crc32("OZOUNQpf",8) == 466911379) strcat(s, "n");
if (crc32("mUquUBPgDxG",11) == 2042626154) strcat(s, "e");
    return s;
}

char *pennywise_adjectives() {
    char *s = calloc(10);
    if (crc32("tVpiaTgga",9) == 2764815661) strcat(s, "h");
if (crc32("vXQTIrqIDhNhDm",14) == 1428680180) strcat(s, "p");
if (crc32("TCoeQamKZxZ",11) == 2876436749) strcat(s, "e");
if (crc32("NjIJdrYWQj",10) == 3176908035) strcat(s, "n");
if (crc32("ncqLeUb",7) == 846157819) strcat(s, "q");
if (crc32("nbzLdX",6) == 2045618333) strcat(s, "n");
if (crc32("RtevdUAzfQVHy",13) == 3544021067) strcat(s, "y");
if (crc32("tgFBzWZgzPsl",12) == 863703194) strcat(s, "w");
if (crc32("zjlOACJufivtuei",15) == 480317038) strcat(s, "v");
if (crc32("DOePtN",6) == 1172037541) strcat(s, "i");
if (crc32("CUCivbCHIIi",11) == 1900984680) strcat(s, "H");
if (crc32("rqMIXyjBSRigeI",14) == 244888643) strcat(s, "s");
if (crc32("sinom",5) == 2907789612) strcat(s, "e");
    return s;
}

char *octan_adjectives() {
    char *s = calloc(6);
    if (crc32("ALLKCJwpTcyHV",13) == 2552877780) strcat(s, "o");
if (crc32("dQsmSD",6) == 4269201035) strcat(s, "c");
if (crc32("EKrlhMDZqppUfq",14) == 931459098) strcat(s, "t");
if (crc32("zwHVMEUSkshSERs",15) == 3773780729) strcat(s, "F");
if (crc32("CSldTSrHVmrS",12) == 3139079807) strcat(s, "a");
if (crc32("LsHeT",5) == 444828272) strcat(s, "J");
if (crc32("QQKeLTNTg",9) == 2867915893) strcat(s, "n");
    return s;
}

char *episepalous_adjectives() {
    char *s = calloc(12);
    if (crc32("hBbFBiwNtLbjVSV",15) == 1294811854) strcat(s, "A");
if (crc32("IgNJbI",6) == 3968501331) strcat(s, "e");
if (crc32("GhFsIsS",7) == 3747948305) strcat(s, "p");
if (crc32("WtrLMUPSO",9) == 3173277918) strcat(s, "o");
if (crc32("ORoxhAzOaOsnCH",14) == 3036023910) strcat(s, "i");
if (crc32("NNLLChzvFcXGD",13) == 3836101137) strcat(s, "o");
if (crc32("KoLQvuKfUghd",12) == 3918888054) strcat(s, "s");
if (crc32("gaHyZaVlSebnC",13) == 1097428765) strcat(s, "e");
if (crc32("YoOqKtGmnjgc",12) == 4006866776) strcat(s, "p");
if (crc32("ukKBqUWszup",11) == 1145350123) strcat(s, "a");
if (crc32("ZoNKj",5) == 980114468) strcat(s, "G");
if (crc32("uZwyzb",6) == 1126871113) strcat(s, "l");
if (crc32("NxuRxbIotEgGI",13) == 972429877) strcat(s, "W");
if (crc32("igalgSHEK",9) == 2117334706) strcat(s, "o");
if (crc32("FXXcDDEnRfoOj",13) == 523333145) strcat(s, "u");
if (crc32("YJlyomDdtkYSc",13) == 646804569) strcat(s, "s");
    return s;
}

char *arsenous_adjectives() {
    char *s = calloc(9);
    if (crc32("eIfWrllpLYj",11) == 3566439169) strcat(s, "a");
if (crc32("rtcyeqcYdaI",11) == 2979493105) strcat(s, "L");
if (crc32("TiDTKpi",7) == 3952076831) strcat(s, "r");
if (crc32("LrxQfMZMfAa",11) == 1215189515) strcat(s, "s");
if (crc32("dgKypseyLmNvJI",14) == 3310023731) strcat(s, "s");
if (crc32("XQvCoMev",8) == 511748977) strcat(s, "e");
if (crc32("yEPEVf",6) == 4294779492) strcat(s, "R");
if (crc32("LGpHWovBig",10) == 1442910512) strcat(s, "n");
if (crc32("bysSanykznhm",12) == 3162638370) strcat(s, "l");
if (crc32("wxVaBLa",7) == 1920736275) strcat(s, "o");
if (crc32("DcZzLZpqshPeGQ",14) == 2641009467) strcat(s, "I");
if (crc32("NPtMEoFNvvGifHG",15) == 2009193165) strcat(s, "u");
if (crc32("lrYpDasyrkD",11) == 2684451350) strcat(s, "U");
if (crc32("YuzXEEKAOmmQAe",14) == 1711568428) strcat(s, "s");
    return s;
}

char *ingoing_adjectives() {
    char *s = calloc(8);
    if (crc32("erTFlCbgVffB",12) == 3856514711) strcat(s, "i");
if (crc32("zfNnMNLQ",8) == 1901954395) strcat(s, "n");
if (crc32("hBlsTtMOpF",10) == 2993660817) strcat(s, "n");
if (crc32("NTfkrOu",7) == 2210456884) strcat(s, "s");
if (crc32("OvoPTGOgxkgFS",13) == 3016674598) strcat(s, "g");
if (crc32("mmRDEzGyLkq",11) == 2067262149) strcat(s, "Q");
if (crc32("vkfcZkTJnwGG",12) == 1871459421) strcat(s, "o");
if (crc32("pKpwSbWTllfGCMh",15) == 2020693932) strcat(s, "g");
if (crc32("tFADaNYy",8) == 3098163241) strcat(s, "i");
if (crc32("lKjIZGJVKRGcI",13) == 3594475520) strcat(s, "b");
if (crc32("vLhFAlOG",8) == 1117712968) strcat(s, "n");
if (crc32("NttGTqwBynOV",12) == 144881405) strcat(s, "l");
if (crc32("aFbtPS",6) == 802648747) strcat(s, "g");
    return s;
}

char *untufted_adjectives() {
    char *s = calloc(9);
    if (crc32("nCdWvlCOEQYUASm",15) == 2350411743) strcat(s, "S");
if (crc32("KenlYprDHjRKQKi",15) == 235394618) strcat(s, "u");
if (crc32("MubRpKUAu",9) == 596455681) strcat(s, "g");
if (crc32("DhXOsIiBYrv",11) == 1643864816) strcat(s, "n");
if (crc32("vUmkcTIrMWpG",12) == 2799014979) strcat(s, "t");
if (crc32("bALkyoLdsAn",11) == 1852019897) strcat(s, "N");
if (crc32("caCNS",5) == 1970158522) strcat(s, "u");
if (crc32("qmgCHLSJKYdx",12) == 451121482) strcat(s, "f");
if (crc32("ObfhXkxbELrDW",13) == 2349178338) strcat(s, "D");
if (crc32("SLbhGlt",7) == 22943561) strcat(s, "t");
if (crc32("wNSmuSPaQp",10) == 2824695503) strcat(s, "B");
if (crc32("UtidRPyF",8) == 1332778607) strcat(s, "e");
if (crc32("TzznjlYMgjQIzOQ",15) == 1425630800) strcat(s, "C");
if (crc32("mCZHyU",6) == 624872388) strcat(s, "d");
    return s;
}

char *preceptive_adjectives() {
    char *s = calloc(11);
    if (crc32("pUIAoWqeD",9) == 631236514) strcat(s, "Q");
if (crc32("qfXuaTVxq",9) == 342390776) strcat(s, "p");
if (crc32("YOAikqTTpiQYont",15) == 3860981869) strcat(s, "r");
if (crc32("ukZmKralAb",10) == 3605348759) strcat(s, "q");
if (crc32("WFiLDcToMEW",11) == 3085249973) strcat(s, "e");
if (crc32("SNhnWHvR",8) == 414359259) strcat(s, "e");
if (crc32("ByiqpLLVMDqQqW",14) == 1440837980) strcat(s, "c");
if (crc32("lYcbjszrT",9) == 1798600027) strcat(s, "e");
if (crc32("aJhTN",5) == 3324817431) strcat(s, "F");
if (crc32("BeWYQicQDJncy",13) == 3712691926) strcat(s, "p");
if (crc32("eDBmcpXfvoKv",12) == 2034321642) strcat(s, "t");
if (crc32("tLNNijkDVnx",11) == 2972294456) strcat(s, "y");
if (crc32("cIIVrVsBvbg",11) == 3678989279) strcat(s, "i");
if (crc32("SRcfCcYKefKpkMt",15) == 3014875316) strcat(s, "F");
if (crc32("VfWhbQjnjDF",11) == 2938244125) strcat(s, "v");
if (crc32("HmlLBPAmBocNc",13) == 3267230481) strcat(s, "e");
    return s;
}

char *roentgenological_adjectives() {
    char *s = calloc(17);
    if (crc32("miIoEiKXcfxFM",13) == 4274185730) strcat(s, "l");
if (crc32("WobBQv",6) == 1138534218) strcat(s, "r");
if (crc32("SSAWxluGyuoYME",14) == 3124311807) strcat(s, "l");
if (crc32("KpCLgGUcJx",10) == 1289937444) strcat(s, "o");
if (crc32("kOCgLw",6) == 2964579841) strcat(s, "T");
if (crc32("RUkjruyMoLjkGCt",15) == 3802517039) strcat(s, "e");
if (crc32("rHULC",5) == 3271477272) strcat(s, "n");
if (crc32("JQbKmwKeX",9) == 3677406928) strcat(s, "t");
if (crc32("IcSxyyU",7) == 2910559059) strcat(s, "g");
if (crc32("bJbZjJhSWx",10) == 3895408081) strcat(s, "e");
if (crc32("bJHrvfcgBU",10) == 170924010) strcat(s, "M");
if (crc32("EJwesKfNhGqX",12) == 1627223465) strcat(s, "n");
if (crc32("yjxfWMO",7) == 1348153367) strcat(s, "o");
if (crc32("WdZXcQcZ",8) == 1640857151) strcat(s, "l");
if (crc32("ucUBzgipgKDO",12) == 2789768468) strcat(s, "A");
if (crc32("LJIuY",5) == 2419861664) strcat(s, "o");
if (crc32("tndCam",6) == 2764252915) strcat(s, "B");
if (crc32("UmINcfuVPF",10) == 3132870703) strcat(s, "g");
if (crc32("YnilrsYwDZqOK",13) == 917879945) strcat(s, "i");
if (crc32("OVUCIBzSGt",10) == 1830449818) strcat(s, "c");
if (crc32("NOEpatphjIcv",12) == 1560578417) strcat(s, "R");
if (crc32("nblBgtnAYdLHeC",14) == 4250939599) strcat(s, "a");
if (crc32("QCQxoCloOKMO",12) == 2323420692) strcat(s, "l");
    return s;
}

char *wailful_adjectives() {
    char *s = calloc(8);
    if (crc32("tKFkqihDR",9) == 3980100563) strcat(s, "x");
if (crc32("NhnGRNLcQuxldB",14) == 3728862720) strcat(s, "w");
if (crc32("aEoBkJcIqMV",11) == 3879490500) strcat(s, "a");
if (crc32("bDdFomrbNKZuihN",15) == 3820879557) strcat(s, "j");
if (crc32("ZeggspkhKWXJJ",13) == 1227179421) strcat(s, "i");
if (crc32("rXJxImNLMkr",11) == 73480094) strcat(s, "h");
if (crc32("Ggoawrru",8) == 3378528088) strcat(s, "l");
if (crc32("wgUHNsLhNxOh",12) == 1299284232) strcat(s, "f");
if (crc32("pvRPFGFgeOUv",12) == 2191878041) strcat(s, "P");
if (crc32("FUoOl",5) == 2636928960) strcat(s, "u");
if (crc32("jTHhLRPFy",9) == 3647661639) strcat(s, "q");
if (crc32("ZCWhm",5) == 3404993499) strcat(s, "l");
    return s;
}

char *risible_adjectives() {
    char *s = calloc(8);
    if (crc32("CHPnXKYvdjae",12) == 2964522169) strcat(s, "D");
if (crc32("YTiHzzf",7) == 1591469186) strcat(s, "r");
if (crc32("NljPsudbYXuVSQ",14) == 72382) strcat(s, "i");
if (crc32("IIgnUHYs",8) == 2445223352) strcat(s, "s");
if (crc32("GXlnobUNgGs",11) == 3377947148) strcat(s, "i");
if (crc32("oJSlqwlMiFKMea",14) == 1559897241) strcat(s, "b");
if (crc32("mSAug",5) == 2399042066) strcat(s, "l");
if (crc32("uJEnH",5) == 207543276) strcat(s, "Z");
if (crc32("OqqeYlgR",8) == 373116218) strcat(s, "e");
    return s;
}

char *radiotelegraphic_adjectives() {
    char *s = calloc(17);
    if (crc32("PZgrJZpXpfIzj",13) == 946720451) strcat(s, "r");
if (crc32("tFGLQl",6) == 1734278984) strcat(s, "b");
if (crc32("YypbXboDHeWLd",13) == 3125870554) strcat(s, "a");
if (crc32("nDnlflVuhca",11) == 2748476355) strcat(s, "d");
if (crc32("gJERqnDKHImRE",13) == 135771630) strcat(s, "a");
if (crc32("PduigjmYVu",10) == 22265306) strcat(s, "i");
if (crc32("EYfHGdkmJ",9) == 797125453) strcat(s, "G");
if (crc32("BWvQgfEM",8) == 1596472098) strcat(s, "o");
if (crc32("fSvbVlGovprdPg",14) == 3831285996) strcat(s, "c");
if (crc32("dnuuYQJHIgNWXdl",15) == 4114988040) strcat(s, "t");
if (crc32("EbyREZn",7) == 3349862604) strcat(s, "e");
if (crc32("zKjtufHkubQ",11) == 1131225014) strcat(s, "A");
if (crc32("zwNuA",5) == 2856307497) strcat(s, "l");
if (crc32("DDMBuVPuxNxgvs",14) == 2112115950) strcat(s, "e");
if (crc32("muCDqrKkrT",10) == 1342565863) strcat(s, "g");
if (crc32("fgqQuDqQ",8) == 1628220785) strcat(s, "A");
if (crc32("WXBeMfQymzRcNR",14) == 1584200164) strcat(s, "r");
if (crc32("pVgjWPFWYSbG",12) == 43701624) strcat(s, "Q");
if (crc32("qxhDFd",6) == 3722667003) strcat(s, "a");
if (crc32("qvcmfLga",8) == 206502287) strcat(s, "E");
if (crc32("HBTEMkjpi",9) == 1923163228) strcat(s, "p");
if (crc32("GBOgbkX",7) == 2389790930) strcat(s, "F");
if (crc32("ArTdfIcCRmMTV",13) == 844027214) strcat(s, "h");
if (crc32("GOBiRsBycT",10) == 1552820700) strcat(s, "i");
if (crc32("lOqMLzMafXZGAeO",15) == 4082369867) strcat(s, "c");
    return s;
}

char *unappeased_adjectives() {
    char *s = calloc(11);
    if (crc32("LCAauZv",7) == 3658125890) strcat(s, "u");
if (crc32("cGgQHVLLAQICk",13) == 3612562644) strcat(s, "w");
if (crc32("cfATnDAnLcG",11) == 1208994146) strcat(s, "n");
if (crc32("dgMmRInhWFF",11) == 600638669) strcat(s, "G");
if (crc32("uxzgzkPFFoDuUG",14) == 250169755) strcat(s, "a");
if (crc32("mHaxtSPvfm",10) == 3207501731) strcat(s, "I");
if (crc32("jzgWzrkHXnpLi",13) == 3641276354) strcat(s, "p");
if (crc32("vWTalfresdIIRNy",15) == 3215924182) strcat(s, "T");
if (crc32("LZbnDDuMcIZn",12) == 3481779473) strcat(s, "p");
if (crc32("tGUqPfRKWSr",11) == 2374477814) strcat(s, "h");
if (crc32("mDTyhRLOwmd",11) == 2540621803) strcat(s, "e");
if (crc32("biOeUkIkGlgbr",13) == 2680234630) strcat(s, "a");
if (crc32("SnoLJQL",7) == 3603442911) strcat(s, "s");
if (crc32("uDbyGhBR",8) == 2265307739) strcat(s, "e");
if (crc32("tUTJQg",6) == 3260610452) strcat(s, "j");
if (crc32("NsjUBYXjZamhW",13) == 482900266) strcat(s, "d");
    return s;
}

char *unvoluble_adjectives() {
    char *s = calloc(10);
    if (crc32("JtpqOM",6) == 1389560506) strcat(s, "u");
if (crc32("fJUPyOvK",8) == 192173020) strcat(s, "n");
if (crc32("DTEWPz",6) == 667604382) strcat(s, "n");
if (crc32("xzRxbXUtpeSwfGR",15) == 809141043) strcat(s, "q");
if (crc32("eddiD",5) == 2850314735) strcat(s, "v");
if (crc32("vIfXvCRbpWva",12) == 1277960053) strcat(s, "j");
if (crc32("ZDnYP",5) == 3802971870) strcat(s, "o");
if (crc32("bnJoREJG",8) == 733437815) strcat(s, "C");
if (crc32("LQXKEnndbC",10) == 2537864109) strcat(s, "l");
if (crc32("EENtVp",6) == 3935537449) strcat(s, "u");
if (crc32("IFKwGaY",7) == 1471274795) strcat(s, "b");
if (crc32("eRZCie",6) == 3813719574) strcat(s, "a");
if (crc32("peivscAehYjZRy",14) == 2316117487) strcat(s, "l");
if (crc32("fNdRGjmNXr",10) == 2159930023) strcat(s, "w");
if (crc32("kbPbdtLOgpnvM",13) == 2832678465) strcat(s, "e");
    return s;
}

char *emptied_adjectives() {
    char *s = calloc(8);
    if (crc32("tFRnoOB",7) == 1775772103) strcat(s, "e");
if (crc32("mIdvDWBG",8) == 1306135649) strcat(s, "m");
if (crc32("syrjOZJdPuVQN",13) == 3962190312) strcat(s, "v");
if (crc32("uNWIHeOvpkzMnV",14) == 420527340) strcat(s, "p");
if (crc32("rxaykbSIXKAn",12) == 1899837768) strcat(s, "E");
if (crc32("VpYtOOuVl",9) == 2397349016) strcat(s, "t");
if (crc32("XhnxHPlzIaGEcY",14) == 1879789186) strcat(s, "e");
if (crc32("YeSsVMZVADiVDNB",15) == 3269633861) strcat(s, "i");
if (crc32("BTFGnmWQAHlDD",13) == 3472233396) strcat(s, "e");
if (crc32("OIrJH",5) == 3749313825) strcat(s, "d");
    return s;
}

char *nonentomological_adjectives() {
    char *s = calloc(17);
    if (crc32("ZUAuOulgLaqxQc",14) == 2802572515) strcat(s, "C");
if (crc32("hxMBtisYizJxv",13) == 3650550571) strcat(s, "n");
if (crc32("YtoGpNBoStWbcw",14) == 3202191960) strcat(s, "h");
if (crc32("VdLNYrfAjovd",12) == 1950529432) strcat(s, "o");
if (crc32("aLItnqBft",9) == 650097668) strcat(s, "A");
if (crc32("NZEEmAJiWL",10) == 453894521) strcat(s, "n");
if (crc32("tHZHqr",6) == 3652928783) strcat(s, "m");
if (crc32("RIWeWW",6) == 3176399731) strcat(s, "e");
if (crc32("XQYuVebPqRF",11) == 3081746653) strcat(s, "n");
if (crc32("nIoFpxgvuZsioO",14) == 867970994) strcat(s, "t");
if (crc32("xcSadIolOhOGdlm",15) == 3106336824) strcat(s, "r");
if (crc32("BIENVuQcBlBChP",14) == 3518682171) strcat(s, "o");
if (crc32("oFHSKlYVSw",10) == 2873566679) strcat(s, "G");
if (crc32("ShXNLy",6) == 2469570912) strcat(s, "m");
if (crc32("cAseKrkHNTFtKOX",15) == 304679501) strcat(s, "o");
if (crc32("HBccSGLLARmng",13) == 1151246309) strcat(s, "B");
if (crc32("bgUhfJlh",8) == 2778579460) strcat(s, "l");
if (crc32("xPoieJb",7) == 4095721440) strcat(s, "o");
if (crc32("xomOxfUFwJP",11) == 268120518) strcat(s, "H");
if (crc32("hGcozNJNcZYzXUU",15) == 3826390448) strcat(s, "g");
if (crc32("FOPyjIkEhAZn",12) == 1216454585) strcat(s, "g");
if (crc32("dZvjcWwni",9) == 324090275) strcat(s, "i");
if (crc32("DUABid",6) == 2075048507) strcat(s, "c");
if (crc32("ifcQxwYSOXYkTr",14) == 1466874030) strcat(s, "g");
if (crc32("XiEPdiiGfbQ",11) == 2150992816) strcat(s, "a");
if (crc32("UVmsrUmZlgTP",12) == 1924418413) strcat(s, "l");
    return s;
}

char *reduplicative_adjectives() {
    char *s = calloc(14);
    if (crc32("wpVHhw",6) == 1965308736) strcat(s, "b");
if (crc32("EUJqPFbPW",9) == 3443791216) strcat(s, "r");
if (crc32("LwiVy",5) == 3448442987) strcat(s, "F");
if (crc32("wtmeRv",6) == 487331615) strcat(s, "e");
if (crc32("oRWGXlQSRERKD",13) == 2034191097) strcat(s, "d");
if (crc32("TVLKcGbbXBFiNw",14) == 331049577) strcat(s, "u");
if (crc32("XSBTVBnRwR",10) == 1452071103) strcat(s, "D");
if (crc32("KnTtgwsk",8) == 2016155918) strcat(s, "p");
if (crc32("SRdfbUljbxo",11) == 431684850) strcat(s, "l");
if (crc32("KAHtdESBZbuBM",13) == 638867650) strcat(s, "i");
if (crc32("BgTlfldCLWrQ",12) == 198135573) strcat(s, "n");
if (crc32("WObmRtc",7) == 1602145731) strcat(s, "c");
if (crc32("ewKISyAsIl",10) == 2342137798) strcat(s, "a");
if (crc32("gwPdnlefXboq",12) == 596400090) strcat(s, "I");
if (crc32("FFIGWiR",7) == 1749021939) strcat(s, "t");
if (crc32("zrkxWIae",8) == 3015692000) strcat(s, "y");
if (crc32("CJlyTQqH",8) == 3465355432) strcat(s, "i");
if (crc32("CmSceQDHcz",10) == 69671178) strcat(s, "e");
if (crc32("niYfxSMDVbKNAaR",15) == 1588053392) strcat(s, "v");
if (crc32("NIajgMYHGAHe",12) == 922337690) strcat(s, "e");
    return s;
}

char *nonvisiting_adjectives() {
    char *s = calloc(12);
    if (crc32("YSEHk",5) == 3188246557) strcat(s, "n");
if (crc32("cUHEthGKnPA",11) == 981706861) strcat(s, "K");
if (crc32("uPGla",5) == 3124066592) strcat(s, "o");
if (crc32("dttQLGgBdvWGw",13) == 3017280141) strcat(s, "W");
if (crc32("rKdIOfYZOKXE",12) == 1717909819) strcat(s, "n");
if (crc32("IIcGVxdf",8) == 3521970489) strcat(s, "G");
if (crc32("gGHOuMgN",8) == 2557715823) strcat(s, "v");
if (crc32("gTPCC",5) == 4049790697) strcat(s, "i");
if (crc32("tYzFnYbXP",9) == 1382750316) strcat(s, "s");
if (crc32("AcpfRWQJBshCbdQ",15) == 2817904327) strcat(s, "i");
if (crc32("ghDvNWPcvmyFld",14) == 1709297135) strcat(s, "r");
if (crc32("ZrFXGPltWaxUs",13) == 236313122) strcat(s, "t");
if (crc32("xVTKoFv",7) == 2338621723) strcat(s, "s");
if (crc32("plEFNHd",7) == 673566762) strcat(s, "i");
if (crc32("jTlpaiilJfORAJ",14) == 3017410752) strcat(s, "n");
if (crc32("dtITPVHF",8) == 2982488093) strcat(s, "V");
if (crc32("UKzSPLU",7) == 3367317537) strcat(s, "g");
    return s;
}

char *petrographic_adjectives() {
    char *s = calloc(13);
    if (crc32("yugPyeXqC",9) == 1598170706) strcat(s, "p");
if (crc32("cgiHbkqKeWqdZ",13) == 96033851) strcat(s, "l");
if (crc32("StlbwxcastR",11) == 1456954508) strcat(s, "e");
if (crc32("LzgytACCieXx",12) == 1165850626) strcat(s, "t");
if (crc32("HiedlIw",7) == 2398224396) strcat(s, "r");
if (crc32("fQVbpyhmjEipBr",14) == 1870750351) strcat(s, "S");
if (crc32("jDPbWEq",7) == 1285600819) strcat(s, "o");
if (crc32("cQZfpvYnqr",10) == 3006479105) strcat(s, "G");
if (crc32("RvaHnjzYOuftqo",14) == 917346445) strcat(s, "g");
if (crc32("mULNAVnaC",9) == 3130357391) strcat(s, "r");
if (crc32("sjzumgHTCepFNy",14) == 2214447446) strcat(s, "a");
if (crc32("bscNOeMdoBJOGVi",15) == 2332884218) strcat(s, "p");
if (crc32("ipevVzSdaWRB",12) == 1135926951) strcat(s, "h");
if (crc32("sUbCWA",6) == 3679791347) strcat(s, "i");
if (crc32("OuinNnnvmgSV",12) == 573621149) strcat(s, "P");
if (crc32("ySzGujXG",8) == 118559025) strcat(s, "c");
    return s;
}

char *uninitialed_adjectives() {
    char *s = calloc(12);
    if (crc32("ycfdUYBlsq",10) == 654676889) strcat(s, "B");
if (crc32("zjKIEyhPVfV",11) == 1511339045) strcat(s, "u");
if (crc32("pOyPR",5) == 2558091754) strcat(s, "n");
if (crc32("NwEykcqXK",9) == 2007959228) strcat(s, "d");
if (crc32("zxYJHEePeUwNVik",15) == 3752704942) strcat(s, "i");
if (crc32("adBhldZIFIN",11) == 1589579320) strcat(s, "n");
if (crc32("UZmooQzRbOsTBB",14) == 3856531087) strcat(s, "X");
if (crc32("TTjqKn",6) == 1398885848) strcat(s, "i");
if (crc32("KsELdhcGjqLeXIM",15) == 2443742791) strcat(s, "t");
if (crc32("vXEqH",5) == 2256210689) strcat(s, "i");
if (crc32("jDHAHoEeQh",10) == 1757114507) strcat(s, "I");
if (crc32("PdtchllcbEq",11) == 1803491301) strcat(s, "a");
if (crc32("PCURz",5) == 632980650) strcat(s, "l");
if (crc32("HDTqfdlAmVq",11) == 1352408420) strcat(s, "e");
if (crc32("XayTTqoBVLlBbc",14) == 2918312550) strcat(s, "l");
if (crc32("PdIyuhGYfyYrZue",15) == 3436882094) strcat(s, "d");
    return s;
}

char *spermacetilike_adjectives() {
    char *s = calloc(15);
    if (crc32("OkTPhB",6) == 3154847760) strcat(s, "s");
if (crc32("TuzbHvwkI",9) == 3728958289) strcat(s, "p");
if (crc32("OSXDVr",6) == 2196236510) strcat(s, "Q");
if (crc32("iLZwTVJpCaIwFq",14) == 734863959) strcat(s, "e");
if (crc32("YTtNX",5) == 893690679) strcat(s, "f");
if (crc32("NAOzfYLDipTXs",13) == 448158684) strcat(s, "r");
if (crc32("KryuZBjT",8) == 1401377742) strcat(s, "m");
if (crc32("UFRQevWkbTXFZPT",15) == 3596933550) strcat(s, "a");
if (crc32("VBFufSI",7) == 3810020975) strcat(s, "C");
if (crc32("YLTCCwCJiC",10) == 1473960995) strcat(s, "c");
if (crc32("UmwjJMsEa",9) == 215674636) strcat(s, "K");
if (crc32("ZxaTo",5) == 1355148682) strcat(s, "e");
if (crc32("aHqsueYA",8) == 148164183) strcat(s, "t");
if (crc32("htJolodbYj",10) == 2827664851) strcat(s, "w");
if (crc32("AtoYSShTV",9) == 3985971949) strcat(s, "i");
if (crc32("dsKwBIeAPWus",12) == 456571719) strcat(s, "u");
if (crc32("YjtOOfJrlNo",11) == 3202509122) strcat(s, "l");
if (crc32("nYUpm",5) == 544142929) strcat(s, "i");
if (crc32("euZcegjmEMLa",12) == 598682633) strcat(s, "k");
if (crc32("huMdKTnuZ",9) == 2739459021) strcat(s, "e");
    return s;
}

char *unhuntable_adjectives() {
    char *s = calloc(11);
    if (crc32("wHROAOtkY",9) == 218840708) strcat(s, "y");
if (crc32("CkOXMvmGO",9) == 694855299) strcat(s, "u");
if (crc32("JiMHSJXeOpYwB",13) == 1009834803) strcat(s, "n");
if (crc32("odkbpcbWR",9) == 298575047) strcat(s, "y");
if (crc32("FOupBvJmyOGQH",13) == 2119838302) strcat(s, "h");
if (crc32("ggTdNHwtYhE",11) == 3918657110) strcat(s, "j");
if (crc32("YOaKr",5) == 3569693957) strcat(s, "u");
if (crc32("Iqjmlnll",8) == 93284089) strcat(s, "F");
if (crc32("RKbhHe",6) == 221549773) strcat(s, "n");
if (crc32("ouCDaUkIsEZFWk",14) == 892313715) strcat(s, "t");
if (crc32("GyBjIjZZi",9) == 3091764574) strcat(s, "y");
if (crc32("hyKpVCkAQIK",11) == 3524497681) strcat(s, "a");
if (crc32("hIBSHJPnoWRIMxU",15) == 2876521485) strcat(s, "d");
if (crc32("gBNSn",5) == 2645896948) strcat(s, "b");
if (crc32("IQGMXQNsEtblAQ",14) == 3946435535) strcat(s, "l");
if (crc32("PmSCme",6) == 40218085) strcat(s, "i");
if (crc32("hIXppModEY",10) == 558098038) strcat(s, "e");
    return s;
}

char *brownish_adjectives() {
    char *s = calloc(9);
    if (crc32("PEvqYi",6) == 450062559) strcat(s, "t");
if (crc32("WmZRu",5) == 1284823579) strcat(s, "b");
if (crc32("OSGhhnWcTETnxED",15) == 2839324796) strcat(s, "r");
if (crc32("ofrYSX",6) == 2461683256) strcat(s, "O");
if (crc32("SuIqPaMh",8) == 1754804364) strcat(s, "o");
if (crc32("XCHwM",5) == 2124911571) strcat(s, "R");
if (crc32("HNSVfYCgL",9) == 4039343145) strcat(s, "w");
if (crc32("ctAJxnsjqz",10) == 169114121) strcat(s, "n");
if (crc32("oQJMh",5) == 3639900525) strcat(s, "L");
if (crc32("dCUldZTikSvhQ",13) == 2945964157) strcat(s, "i");
if (crc32("TnqdEQoDxcWX",12) == 2588976895) strcat(s, "s");
if (crc32("WFtBGFjnE",9) == 696424992) strcat(s, "E");
if (crc32("ywXYx",5) == 2466287005) strcat(s, "h");
    return s;
}

char *unrelaxing_adjectives() {
    char *s = calloc(11);
    if (crc32("NqTNYk",6) == 2032480785) strcat(s, "s");
if (crc32("qoFwqHGNOFVRYU",14) == 338233088) strcat(s, "u");
if (crc32("UIDqMeUTbF",10) == 2487808605) strcat(s, "n");
if (crc32("PkZAXACXpOJS",12) == 1587096332) strcat(s, "r");
if (crc32("IsiFKqxz",8) == 942180837) strcat(s, "e");
if (crc32("WiXRiKlOzpTYjcD",15) == 648877742) strcat(s, "l");
if (crc32("MfCBLGEgJFGXQ",13) == 1216668261) strcat(s, "a");
if (crc32("fjfUjMmHBqKJmPx",15) == 985881466) strcat(s, "m");
if (crc32("sEBboBEiZt",10) == 973170180) strcat(s, "x");
if (crc32("kkmEQhkqr",9) == 1189947843) strcat(s, "e");
if (crc32("XvZHDJRjSH",10) == 850233085) strcat(s, "i");
if (crc32("ErgyGGqssCt",11) == 1284208748) strcat(s, "M");
if (crc32("UgWjplJg",8) == 122603183) strcat(s, "n");
if (crc32("lXOgyPbj",8) == 2808585836) strcat(s, "g");
    return s;
}

char *quasirewarding_adjectives() {
    char *s = calloc(15);
    if (crc32("BxqyQHtAAr",10) == 1183427682) strcat(s, "q");
if (crc32("WOZoYXWtsRzpyvK",15) == 2773029859) strcat(s, "d");
if (crc32("cXtYPowyiEWqBZP",15) == 1962463848) strcat(s, "u");
if (crc32("gaFPfyRLOm",10) == 562516766) strcat(s, "a");
if (crc32("bwZEbqz",7) == 509224957) strcat(s, "T");
if (crc32("dxIEfp",6) == 418030176) strcat(s, "s");
if (crc32("DjRRy",5) == 2672985313) strcat(s, "b");
if (crc32("EjChyrPYZb",10) == 2846369973) strcat(s, "i");
if (crc32("hCGHceCrdChu",12) == 3320456727) strcat(s, "r");
if (crc32("IygOcPuqWHuel",13) == 775400303) strcat(s, "X");
if (crc32("xHKXTkkdW",9) == 1618169886) strcat(s, "e");
if (crc32("vVfXwuoej",9) == 523718717) strcat(s, "w");
if (crc32("LUvToKYN",8) == 1980899304) strcat(s, "f");
if (crc32("hkdrElnAiN",10) == 1551337189) strcat(s, "a");
if (crc32("ZeMXIrLqFQTWW",13) == 731656391) strcat(s, "r");
if (crc32("GLGkBZzpzxLN",12) == 1838331927) strcat(s, "d");
if (crc32("uFxKxurhyISZ",12) == 3794405227) strcat(s, "l");
if (crc32("nceIMBQy",8) == 2279531402) strcat(s, "i");
if (crc32("uMmPAHvicSgDGUY",15) == 633397710) strcat(s, "a");
if (crc32("QXZPZL",6) == 2302773224) strcat(s, "n");
if (crc32("ryUBvsjIYw",10) == 3201555820) strcat(s, "o");
if (crc32("SRjfAaTyBtYz",12) == 3946390937) strcat(s, "g");
    return s;
}

char *unlaid_adjectives() {
    char *s = calloc(7);
    if (crc32("zujljcJytqubdy",14) == 2251205173) strcat(s, "c");
if (crc32("zWeOHPz",7) == 582533388) strcat(s, "u");
if (crc32("XdmhFl",6) == 3387406406) strcat(s, "H");
if (crc32("JdEgDDDhTTj",11) == 2788037992) strcat(s, "n");
if (crc32("CTwkFeyfkuZr",12) == 1253315303) strcat(s, "r");
if (crc32("NTfYSJMAOIaGgll",15) == 2605186856) strcat(s, "l");
if (crc32("tOcBIyXgAP",10) == 2370719240) strcat(s, "a");
if (crc32("VuvsOjMoT",9) == 2045119793) strcat(s, "i");
if (crc32("lSonderZEUtQ",12) == 729314927) strcat(s, "d");
    return s;
}

char *coachbuilt_adjectives() {
    char *s = calloc(11);
    if (crc32("PjAOMySrrTWfDPv",15) == 2612944778) strcat(s, "c");
if (crc32("XnaQVCMVJlxIrgP",15) == 3952469974) strcat(s, "a");
if (crc32("xYAkc",5) == 2590996802) strcat(s, "o");
if (crc32("KBWGzfOfTNAR",12) == 3064184831) strcat(s, "W");
if (crc32("SYkbghVfCKhLu",13) == 1887714751) strcat(s, "a");
if (crc32("KyERzWcQCPHnJUn",15) == 2533143750) strcat(s, "c");
if (crc32("TdAHUhAuQnFTlX",14) == 2635641709) strcat(s, "h");
if (crc32("YlRxxnpeTVqy",12) == 3141309964) strcat(s, "b");
if (crc32("MBAvs",5) == 2586351907) strcat(s, "n");
if (crc32("LcAiIJEWvH",10) == 129263064) strcat(s, "u");
if (crc32("ukEQSAmNAm",10) == 1336143948) strcat(s, "i");
if (crc32("bpCPtlEueUa",11) == 3322389749) strcat(s, "p");
if (crc32("IeoSBGRyf",9) == 3929267929) strcat(s, "l");
if (crc32("XEyedScy",8) == 899336369) strcat(s, "t");
    return s;
}

char *psychotomimetic_adjectives() {
    char *s = calloc(16);
    if (crc32("ncxGPtREi",9) == 3942657338) strcat(s, "p");
if (crc32("MItlFxuGRhFC",12) == 3533105244) strcat(s, "s");
if (crc32("ylwsbepRsjQwtl",14) == 2655642710) strcat(s, "y");
if (crc32("hLIWkEwmiB",10) == 2711014074) strcat(s, "c");
if (crc32("gVClOlkQQWpgzgX",15) == 414660177) strcat(s, "L");
if (crc32("zjmyUxEyh",9) == 2438872204) strcat(s, "h");
if (crc32("sEhgeSpS",8) == 556063694) strcat(s, "o");
if (crc32("zQxrdNo",7) == 2949989684) strcat(s, "w");
if (crc32("bDSNNpXAuGgX",12) == 2924982161) strcat(s, "t");
if (crc32("zqlGdKvenZM",11) == 1151554017) strcat(s, "G");
if (crc32("QTjDAxuhjZ",10) == 1755511637) strcat(s, "o");
if (crc32("PGLEbhf",7) == 3750439894) strcat(s, "m");
if (crc32("JiEgZIK",7) == 1303218205) strcat(s, "O");
if (crc32("BtQoOP",6) == 3551570479) strcat(s, "i");
if (crc32("UgWhYjGZLhzig",13) == 986923851) strcat(s, "m");
if (crc32("BtZaeUApH",9) == 4045118029) strcat(s, "e");
if (crc32("aFswMmpOMTxzME",14) == 217218928) strcat(s, "U");
if (crc32("VYvGKiQH",8) == 2805623277) strcat(s, "t");
if (crc32("lLnDtkIuqLuRCuQ",15) == 3541188949) strcat(s, "i");
if (crc32("HWZZSWOlZ",9) == 561978289) strcat(s, "L");
if (crc32("xROzZxGXYaYBA",13) == 1958748482) strcat(s, "c");
    return s;
}

char *xeromorphic_adjectives() {
    char *s = calloc(12);
    if (crc32("moLLn",5) == 1682555746) strcat(s, "s");
if (crc32("FtvrwOY",7) == 2840095197) strcat(s, "x");
if (crc32("ZEQZdVqGRqHb",12) == 750917382) strcat(s, "u");
if (crc32("KdgXLTkgOdqWev",14) == 1850693684) strcat(s, "e");
if (crc32("THMIKIJCOkbOvP",14) == 981832237) strcat(s, "r");
if (crc32("BILbSGIDXBL",11) == 3004893669) strcat(s, "o");
if (crc32("lhMBhzHqVFzhZy",14) == 855545837) strcat(s, "m");
if (crc32("ATikGHfqZ",9) == 4270108792) strcat(s, "y");
if (crc32("SDmsNPxxwa",10) == 123392857) strcat(s, "o");
if (crc32("wxayRmBwlCVMwv",14) == 4120182884) strcat(s, "r");
if (crc32("ovsthjIsmcifRfx",15) == 1672033667) strcat(s, "p");
if (crc32("uINdzZzODrcVmz",14) == 51287163) strcat(s, "h");
if (crc32("IXcpowrjPlyh",12) == 1546224238) strcat(s, "i");
if (crc32("XBJZtNEkJouGzl",14) == 1409467694) strcat(s, "c");
    return s;
}

char *gyrational_adjectives() {
    char *s = calloc(11);
    if (crc32("RTfWFIGh",8) == 3426785516) strcat(s, "g");
if (crc32("IkaBV",5) == 105447377) strcat(s, "v");
if (crc32("wFmjnwXKvTufS",13) == 2897941830) strcat(s, "y");
if (crc32("KCqToyLkQWal",12) == 2576844779) strcat(s, "n");
if (crc32("BZDgiiuQkyt",11) == 2357526381) strcat(s, "r");
if (crc32("avuKicHAlGX",11) == 2667673050) strcat(s, "d");
if (crc32("svrelMDkY",9) == 2957461710) strcat(s, "a");
if (crc32("rQtIlXPDXUxC",12) == 2662407193) strcat(s, "n");
if (crc32("IyEmJNHuxx",10) == 2862337925) strcat(s, "t");
if (crc32("zyAaZrc",7) == 3083431293) strcat(s, "i");
if (crc32("DQkGWBFJkNva",12) == 2834145818) strcat(s, "d");
if (crc32("AhAysCl",7) == 569660887) strcat(s, "o");
if (crc32("CfxrShKODSJ",11) == 2878790867) strcat(s, "v");
if (crc32("dlPYiVbHQu",10) == 2524680129) strcat(s, "n");
if (crc32("qpXmkwdtylC",11) == 1254247229) strcat(s, "a");
if (crc32("KLmoeKmZugBjhx",14) == 3720622624) strcat(s, "l");
    return s;
}

char *rogatory_adjectives() {
    char *s = calloc(9);
    if (crc32("BXXiJwdDSKvqgcq",15) == 1029509736) strcat(s, "r");
if (crc32("lqqAlWuEMxeqho",14) == 3291868817) strcat(s, "o");
if (crc32("LaNOZZo",7) == 2802351183) strcat(s, "S");
if (crc32("UhQOacb",7) == 1784390478) strcat(s, "g");
if (crc32("VoHSBvSGXFfLda",14) == 2421802821) strcat(s, "m");
if (crc32("UKPcRe",6) == 4134240613) strcat(s, "a");
if (crc32("SHkzDObAgGWqz",13) == 1595398476) strcat(s, "Z");
if (crc32("Rqdhy",5) == 2622613380) strcat(s, "t");
if (crc32("jWKQWaysBlBYFL",14) == 376640859) strcat(s, "B");
if (crc32("EwCFbeJ",7) == 4186224003) strcat(s, "o");
if (crc32("lHNUzbBES",9) == 406271052) strcat(s, "z");
if (crc32("grEECbervzii",12) == 2595523622) strcat(s, "r");
if (crc32("lEvtibF",7) == 2412887697) strcat(s, "T");
if (crc32("hPwcVklvD",9) == 3780539473) strcat(s, "y");
    return s;
}

char *nonformidable_adjectives() {
    char *s = calloc(14);
    if (crc32("eIeXFcSw",8) == 3623469935) strcat(s, "n");
if (crc32("KAQMRbqbfgfMJ",13) == 1132434176) strcat(s, "y");
if (crc32("ChYchBNsW",9) == 695444320) strcat(s, "o");
if (crc32("SMpdUI",6) == 2006373447) strcat(s, "n");
if (crc32("CaGKOBzaC",9) == 3633300085) strcat(s, "f");
if (crc32("gZRZgjBXycU",11) == 3776519899) strcat(s, "o");
if (crc32("ZolPEzKUKhCW",12) == 1605956188) strcat(s, "n");
if (crc32("SFKBNUKwXJxK",12) == 2386091755) strcat(s, "r");
if (crc32("VKMEr",5) == 1982048137) strcat(s, "m");
if (crc32("vFKbUwAhv",9) == 3933462662) strcat(s, "i");
if (crc32("lLlaANgSVSzF",12) == 479986036) strcat(s, "M");
if (crc32("qTUGelhBmFhPj",13) == 3344485410) strcat(s, "d");
if (crc32("XeMbe",5) == 3504928327) strcat(s, "a");
if (crc32("LJRiwg",6) == 1320224528) strcat(s, "b");
if (crc32("jDXEuPjWQgpXv",13) == 1601936012) strcat(s, "l");
if (crc32("kaOLjK",6) == 1317585307) strcat(s, "j");
if (crc32("YgbPkbZc",8) == 804179461) strcat(s, "e");
    return s;
}

char *unmanual_adjectives() {
    char *s = calloc(9);
    if (crc32("aBOQRkTmf",9) == 50012505) strcat(s, "u");
if (crc32("JHnYxhR",7) == 3421981973) strcat(s, "f");
if (crc32("TMhMKpCXGl",10) == 3590677417) strcat(s, "n");
if (crc32("awCew",5) == 1013430213) strcat(s, "o");
if (crc32("KVGMOfpNNUfRa",13) == 967182837) strcat(s, "m");
if (crc32("JtEKKPUlwDXA",12) == 2129905532) strcat(s, "B");
if (crc32("ENTkYDK",7) == 2312106131) strcat(s, "a");
if (crc32("ZCQPWH",6) == 65286390) strcat(s, "l");
if (crc32("QqjAeEpCrIu",11) == 1200600743) strcat(s, "n");
if (crc32("IApngV",6) == 2110047465) strcat(s, "u");
if (crc32("vGUcORs",7) == 3819883840) strcat(s, "a");
if (crc32("VQzIk",5) == 3090422838) strcat(s, "b");
if (crc32("LCDOMAUyhl",10) == 117535173) strcat(s, "l");
    return s;
}

char *thirteenth_adjectives() {
    char *s = calloc(11);
    if (crc32("VWjbvGwWDPSot",13) == 2898068370) strcat(s, "t");
if (crc32("OymSiuhFeOEQ",12) == 2000094151) strcat(s, "h");
if (crc32("dqqAxmJNnuImqxN",15) == 2357094872) strcat(s, "i");
if (crc32("zrzTj",5) == 4253895940) strcat(s, "L");
if (crc32("eziwoVsW",8) == 726779819) strcat(s, "r");
if (crc32("woVvIJoG",8) == 2210412947) strcat(s, "t");
if (crc32("HJytvmTXc",9) == 2700077784) strcat(s, "e");
if (crc32("FGyud",5) == 3269691859) strcat(s, "W");
if (crc32("gnyqguT",7) == 3038004099) strcat(s, "e");
if (crc32("CiqYCNzlaMajy",13) == 514938665) strcat(s, "n");
if (crc32("mlkSfxm",7) == 1528084831) strcat(s, "v");
if (crc32("PgXzOCKdr",9) == 1688310228) strcat(s, "t");
if (crc32("YASbxc",6) == 1583805819) strcat(s, "h");
    return s;
}

char *antimonous_adjectives() {
    char *s = calloc(11);
    if (crc32("PrMzZoIMH",9) == 2008633959) strcat(s, "A");
if (crc32("EyGvGWgfOTsWl",13) == 507005781) strcat(s, "a");
if (crc32("OkuxnMKbhEuHOZz",15) == 2871745885) strcat(s, "n");
if (crc32("dfQjObfPF",9) == 3566367866) strcat(s, "C");
if (crc32("DHFsthtNJOSH",12) == 4286364475) strcat(s, "t");
if (crc32("oQeJZXHYg",9) == 893847573) strcat(s, "q");
if (crc32("GCOaHYKTV",9) == 1955937041) strcat(s, "i");
if (crc32("wRApHLhnkIJII",13) == 866907626) strcat(s, "m");
if (crc32("irIwSenjmqs",11) == 3787252459) strcat(s, "o");
if (crc32("GoIlLFCq",8) == 79490067) strcat(s, "T");
if (crc32("anERg",5) == 2491657686) strcat(s, "n");
if (crc32("mkibfxQrlC",10) == 113175226) strcat(s, "U");
if (crc32("JVSSS",5) == 923367867) strcat(s, "o");
if (crc32("FKOFFsR",7) == 3930158204) strcat(s, "V");
if (crc32("eIbyOUbnPUsKq",13) == 658772129) strcat(s, "u");
if (crc32("fHkzsRHKo",9) == 2139056169) strcat(s, "s");
    return s;
}

char *subacute_adjectives() {
    char *s = calloc(9);
    if (crc32("jppUPB",6) == 4052541043) strcat(s, "K");
if (crc32("bhxThORSRVUF",12) == 1098247285) strcat(s, "s");
if (crc32("kXNMbRGqYXMMh",13) == 494667942) strcat(s, "z");
if (crc32("pRRFqSSzy",9) == 3810235153) strcat(s, "u");
if (crc32("EhjvsoFql",9) == 4215172866) strcat(s, "E");
if (crc32("HScwxTsgZco",11) == 884555558) strcat(s, "b");
if (crc32("YdaJDjhpvZnuJPe",15) == 4209473453) strcat(s, "a");
if (crc32("olqKR",5) == 3561595820) strcat(s, "l");
if (crc32("gSsMsT",6) == 2992407907) strcat(s, "c");
if (crc32("KOcfQdJaWVUobDj",15) == 1263856509) strcat(s, "u");
if (crc32("LYkDhpUIFHOw",12) == 1769361094) strcat(s, "w");
if (crc32("bjeuKqZXfHEyIK",14) == 1661952198) strcat(s, "t");
if (crc32("XcAzPhrpOr",10) == 2020157787) strcat(s, "e");
    return s;
}

char *ethnographical_adjectives() {
    char *s = calloc(15);
    if (crc32("CfOmy",5) == 2193666753) strcat(s, "G");
if (crc32("ZFducpjKYcg",11) == 1468874302) strcat(s, "e");
if (crc32("GqSBOznjLTfSUr",14) == 1478871419) strcat(s, "F");
if (crc32("ZCRWgYltx",9) == 3404809812) strcat(s, "t");
if (crc32("JydvCRak",8) == 3957629078) strcat(s, "R");
if (crc32("jesMcaR",7) == 2391627652) strcat(s, "h");
if (crc32("YsqHlIz",7) == 1516638600) strcat(s, "A");
if (crc32("XSNTbdO",7) == 138514886) strcat(s, "n");
if (crc32("eTubxpqbM",9) == 2813135883) strcat(s, "c");
if (crc32("tSvdlFqIuAs",11) == 1705663641) strcat(s, "o");
if (crc32("WwrlovtZXljWng",14) == 3558377500) strcat(s, "U");
if (crc32("SLEwrMDOwkExR",13) == 2891438444) strcat(s, "g");
if (crc32("MRJeBgXxpSrvxvH",15) == 3958700024) strcat(s, "r");
if (crc32("hRIEaRVgCaH",11) == 102464398) strcat(s, "i");
if (crc32("mRISqWLqT",9) == 3060112271) strcat(s, "a");
if (crc32("pHKGkoDYcKwY",12) == 2509425974) strcat(s, "B");
if (crc32("NnUUFtpnfuoi",12) == 2270429637) strcat(s, "p");
if (crc32("iCyuxLrZTG",10) == 4182552761) strcat(s, "W");
if (crc32("qMgbXXtnq",9) == 825928822) strcat(s, "h");
if (crc32("bNGRMIhUd",9) == 4162114277) strcat(s, "R");
if (crc32("YJgmQoTml",9) == 3809143954) strcat(s, "i");
if (crc32("feouAiMvFqc",11) == 3467584438) strcat(s, "k");
if (crc32("boswjXkXqe",10) == 2586505412) strcat(s, "c");
if (crc32("MqusyHd",7) == 422135549) strcat(s, "a");
if (crc32("NJCLQOIrwcRd",12) == 4117196460) strcat(s, "z");
if (crc32("YDXKfiCMl",9) == 3285804845) strcat(s, "l");
    return s;
}

char *nonphilologic_adjectives() {
    char *s = calloc(14);
    if (crc32("xfvPiIHFvy",10) == 3019163216) strcat(s, "v");
if (crc32("yhGVbQG",7) == 80065790) strcat(s, "n");
if (crc32("ViPxjOJjKf",10) == 2731257762) strcat(s, "R");
if (crc32("MpmLnY",6) == 2731781341) strcat(s, "o");
if (crc32("KvDDGPjwJNOfHB",14) == 2780053452) strcat(s, "y");
if (crc32("ICAkSCqPP",9) == 3247745447) strcat(s, "n");
if (crc32("DUaemuPtFR",10) == 508277910) strcat(s, "e");
if (crc32("cGDUVO",6) == 2717048300) strcat(s, "p");
if (crc32("IwJPtKc",7) == 1775943710) strcat(s, "O");
if (crc32("tSGBGZcGRlEUI",13) == 4728303) strcat(s, "h");
if (crc32("TBTtBxdbdHs",11) == 1224852553) strcat(s, "i");
if (crc32("XEGMzmrxVZr",11) == 2659690346) strcat(s, "l");
if (crc32("CImuxFUg",8) == 2738913588) strcat(s, "C");
if (crc32("CKmEnDcD",8) == 860809368) strcat(s, "o");
if (crc32("bZtcwwia",8) == 1761199384) strcat(s, "D");
if (crc32("jedjtqjuCmGxplz",15) == 612769405) strcat(s, "l");
if (crc32("XKxtDN",6) == 2252270600) strcat(s, "o");
if (crc32("eGIKMk",6) == 2231083904) strcat(s, "b");
if (crc32("BKCwqVqOaXkev",13) == 1198442744) strcat(s, "g");
if (crc32("EohCSkDVpse",11) == 4076718328) strcat(s, "i");
if (crc32("SnGIEqDbInpSYHA",15) == 3489318537) strcat(s, "j");
if (crc32("RShTFAXwnMlquDY",15) == 3525816002) strcat(s, "c");
    return s;
}

char *insurmountable_adjectives() {
    char *s = calloc(15);
    if (crc32("VZcJVsmchKh",11) == 2491028541) strcat(s, "j");
if (crc32("ufgHqRZrTLXwpk",14) == 2069500428) strcat(s, "i");
if (crc32("BuQGwnoEwrl",11) == 395854097) strcat(s, "n");
if (crc32("udrSUVHulcN",11) == 941882442) strcat(s, "s");
if (crc32("nQMjAwUqASEx",12) == 3027711391) strcat(s, "E");
if (crc32("TMfKlgKAQlX",11) == 130040662) strcat(s, "u");
if (crc32("CIIknXNjWKRhRgh",15) == 1178195574) strcat(s, "r");
if (crc32("BOwweAtOHM",10) == 1699278615) strcat(s, "m");
if (crc32("TdWEfLAjByLlGF",14) == 1711185450) strcat(s, "Z");
if (crc32("xbvpGH",6) == 1759219026) strcat(s, "o");
if (crc32("wnliuQHNIHwoW",13) == 1638976554) strcat(s, "G");
if (crc32("ZsEwwCPkdqJ",11) == 1169981053) strcat(s, "u");
if (crc32("jldZUWnepYj",11) == 268206887) strcat(s, "e");
if (crc32("dSUAWlOQBy",10) == 2268428368) strcat(s, "n");
if (crc32("tGxqsepthwCZUw",14) == 249796440) strcat(s, "t");
if (crc32("kVcZJ",5) == 1516931350) strcat(s, "a");
if (crc32("YtjfzGrvUkArFsX",15) == 3550119036) strcat(s, "s");
if (crc32("mkTsypNYys",10) == 4024544139) strcat(s, "b");
if (crc32("VbRgrcBEsGSe",12) == 57745374) strcat(s, "l");
if (crc32("ZNCCdvjmks",10) == 3875121208) strcat(s, "Q");
if (crc32("fDNgL",5) == 3958696587) strcat(s, "e");
    return s;
}

char *originative_adjectives() {
    char *s = calloc(12);
    if (crc32("dUTWtVxZbdAr",12) == 2347877362) strcat(s, "o");
if (crc32("LaulJWQHVmH",11) == 1753388846) strcat(s, "w");
if (crc32("VLgAlh",6) == 2879265421) strcat(s, "r");
if (crc32("MrZhkWGMVXWQvv",14) == 3517507778) strcat(s, "i");
if (crc32("ABYEkWHk",8) == 2859223480) strcat(s, "o");
if (crc32("nSiiSnYIr",9) == 3225626961) strcat(s, "g");
if (crc32("RdKHXjgbzcHeKGt",15) == 2424222445) strcat(s, "i");
if (crc32("PFdJwHNbgbQ",11) == 1642955668) strcat(s, "E");
if (crc32("zSVElEMZbo",10) == 2717050489) strcat(s, "n");
if (crc32("hLrJtaAzibAvAL",14) == 2245935457) strcat(s, "a");
if (crc32("UnIKxrCzx",9) == 1847973189) strcat(s, "u");
if (crc32("MuqUmMcgSXzaMds",15) == 1901305153) strcat(s, "t");
if (crc32("bZcuIWQuFx",10) == 1778851488) strcat(s, "a");
if (crc32("jidlKfjVcep",11) == 3583925319) strcat(s, "i");
if (crc32("oLJCgxKDldmG",12) == 1481035715) strcat(s, "v");
if (crc32("icPTsnvgsw",10) == 1260494531) strcat(s, "e");
    return s;
}

char *pseudoMuslim_adjectives() {
    char *s = calloc(13);
    if (crc32("MAkvaZtlAbY",11) == 1947615114) strcat(s, "T");
if (crc32("dyxKIeRizwUmP",13) == 3207100239) strcat(s, "p");
if (crc32("howkumWKjg",10) == 3520655219) strcat(s, "s");
if (crc32("euuRKSIz",8) == 3921784152) strcat(s, "e");
if (crc32("SsJYjIVjrWfeVlT",15) == 1759328637) strcat(s, "T");
if (crc32("xaznoZT",7) == 2248231357) strcat(s, "u");
if (crc32("nCiRewrIqNNT",12) == 3302598944) strcat(s, "g");
if (crc32("GRVuvcFXhArVEaT",15) == 626944895) strcat(s, "d");
if (crc32("GMEqm",5) == 1339203293) strcat(s, "O");
if (crc32("acLmxlpgbrq",11) == 1032796566) strcat(s, "o");
if (crc32("VVcsKPLUvr",10) == 2382110584) strcat(s, "L");
if (crc32("fPDXilGwfq",10) == 3224199668) strcat(s, "M");
if (crc32("epBnAKIgx",9) == 2674415435) strcat(s, "u");
if (crc32("ZsVUlEAmXs",10) == 1373255007) strcat(s, "s");
if (crc32("LJRqCptZP",9) == 510507713) strcat(s, "l");
if (crc32("EqvZa",5) == 1702380770) strcat(s, "a");
if (crc32("mZPrqlUvirB",11) == 2340801515) strcat(s, "i");
if (crc32("jEHEVKGSMciKb",13) == 2278456253) strcat(s, "m");
    return s;
}

char *tachyphylactic_adjectives() {
    char *s = calloc(15);
    if (crc32("ABxotCBn",8) == 562006806) strcat(s, "x");
if (crc32("oQhbuDeRglFU",12) == 1015457422) strcat(s, "t");
if (crc32("TzumpD",6) == 3621775246) strcat(s, "a");
if (crc32("rnNwTecLxlQp",12) == 2731871465) strcat(s, "c");
if (crc32("ZZqgIWs",7) == 4147130231) strcat(s, "N");
if (crc32("nQIwRGxDFOgLT",13) == 3087787637) strcat(s, "h");
if (crc32("eIuqjSSMZMY",11) == 679789246) strcat(s, "s");
if (crc32("IbCwfSfEMrP",11) == 2231277815) strcat(s, "y");
if (crc32("muUyCxQ",7) == 1718871639) strcat(s, "v");
if (crc32("BEOAmADOCnMgdWE",15) == 627676545) strcat(s, "p");
if (crc32("CoBPk",5) == 982107731) strcat(s, "f");
if (crc32("JNWPQgOZjEP",11) == 3512942864) strcat(s, "h");
if (crc32("oFRXhl",6) == 2449247045) strcat(s, "T");
if (crc32("vtuYvM",6) == 779071420) strcat(s, "y");
if (crc32("DajsNZnbosMeH",13) == 2796443847) strcat(s, "e");
if (crc32("kdsHtl",6) == 3071790396) strcat(s, "l");
if (crc32("eHzgu",5) == 2598759079) strcat(s, "a");
if (crc32("TGCGYXqG",8) == 1556821661) strcat(s, "c");
if (crc32("gZWqOqbUo",9) == 3906769640) strcat(s, "l");
if (crc32("tVGmGHGX",8) == 3691030878) strcat(s, "t");
if (crc32("Ydmbrv",6) == 3498170108) strcat(s, "i");
if (crc32("XSZOEIC",7) == 4002762677) strcat(s, "E");
if (crc32("oASvuZcheMScm",13) == 2626978786) strcat(s, "c");
    return s;
}

char *unperfected_adjectives() {
    char *s = calloc(12);
    if (crc32("dqRSnfdElyrDO",13) == 344425582) strcat(s, "A");
if (crc32("GfAGLKFVE",9) == 4111025038) strcat(s, "u");
if (crc32("sPvFzHUJZY",10) == 396815713) strcat(s, "k");
if (crc32("ECyYPUNZjzzbSPQ",15) == 367981388) strcat(s, "n");
if (crc32("AUmNlpwiIqZONYe",15) == 3968593512) strcat(s, "p");
if (crc32("nFcBWcoIqcQah",13) == 3580374798) strcat(s, "e");
if (crc32("nsQDeoNiJsw",11) == 944441774) strcat(s, "p");
if (crc32("QPtOkjoFRpf",11) == 1464132547) strcat(s, "r");
if (crc32("GPYooREVMzLzwZo",15) == 2889877882) strcat(s, "v");
if (crc32("eNgJATZ",7) == 2319057769) strcat(s, "f");
if (crc32("fyPVLHTAdWgTJ",13) == 979101060) strcat(s, "e");
if (crc32("CPuPnWq",7) == 2391782499) strcat(s, "c");
if (crc32("YjtuDJLPJzeuxB",14) == 2762658947) strcat(s, "Z");
if (crc32("OKiGyLwYP",9) == 3943340326) strcat(s, "t");
if (crc32("tqJetWyIf",9) == 614960336) strcat(s, "i");
if (crc32("yDFeJJqZXoKHwzY",15) == 3270641686) strcat(s, "e");
if (crc32("sflLoatz",8) == 1814002411) strcat(s, "D");
if (crc32("QdOQyjOigNsjzE",14) == 1848510899) strcat(s, "d");
    return s;
}

char *nonlimitative_adjectives() {
    char *s = calloc(14);
    if (crc32("bCMEZgwVHcDemMP",15) == 3402587619) strcat(s, "n");
if (crc32("YKbUse",6) == 2012413429) strcat(s, "o");
if (crc32("cBBTiDXbyyhuFC",14) == 3778997083) strcat(s, "n");
if (crc32("RPSPzNfB",8) == 2224831117) strcat(s, "D");
if (crc32("KFWciLYDno",10) == 2566452741) strcat(s, "l");
if (crc32("LjTQcEqZz",9) == 1478738993) strcat(s, "i");
if (crc32("MkdLysbice",10) == 1689809027) strcat(s, "H");
if (crc32("fgcDcwGzCwlm",12) == 2285591115) strcat(s, "m");
if (crc32("lgqGevvnxpV",11) == 1055254020) strcat(s, "I");
if (crc32("JLKqe",5) == 1922101041) strcat(s, "i");
if (crc32("JaNtxeRV",8) == 598483361) strcat(s, "t");
if (crc32("pKpAsVGMYeaHA",13) == 1521745686) strcat(s, "a");
if (crc32("qESMZkREuIN",11) == 1889468664) strcat(s, "A");
if (crc32("bNlziMbwPkcBw",13) == 3656507145) strcat(s, "t");
if (crc32("ESZVbPWWGiz",11) == 1476045521) strcat(s, "i");
if (crc32("jKcQbLAsOjLoRA",14) == 3497615591) strcat(s, "v");
if (crc32("MSkaicXdVqu",11) == 3801075289) strcat(s, "B");
if (crc32("AhZdUad",7) == 18778182) strcat(s, "e");
    return s;
}

char *umbilicate_adjectives() {
    char *s = calloc(11);
    if (crc32("UKjByI",6) == 2009712785) strcat(s, "b");
if (crc32("PtWVyYT",7) == 369105556) strcat(s, "u");
if (crc32("JTjyFYRrbclmRNU",15) == 716717061) strcat(s, "F");
if (crc32("mQjmQwvLqxjTaP",14) == 1834621972) strcat(s, "m");
if (crc32("wrnUyRIXGk",10) == 315859026) strcat(s, "b");
if (crc32("miUXD",5) == 2282373862) strcat(s, "i");
if (crc32("HCWbbxnLOn",10) == 960387501) strcat(s, "l");
if (crc32("samLh",5) == 2968654627) strcat(s, "c");
if (crc32("vfRKMxfyKcBehn",14) == 3292580905) strcat(s, "i");
if (crc32("dtnzBfcuuy",10) == 1332411582) strcat(s, "c");
if (crc32("iBLNyvrjO",9) == 1595575356) strcat(s, "a");
if (crc32("BzafXaRQ",8) == 2398719228) strcat(s, "n");
if (crc32("RlJfanze",8) == 2942161987) strcat(s, "t");
if (crc32("wfqEfPWAiiFVsHu",15) == 2166137964) strcat(s, "U");
if (crc32("wruFi",5) == 2358327313) strcat(s, "e");
    return s;
}

char *luminous_adjectives() {
    char *s = calloc(9);
    if (crc32("TLArrDIMLvhY",12) == 3758051514) strcat(s, "l");
if (crc32("fxzaimG",7) == 3715002483) strcat(s, "u");
if (crc32("zulmjxDHlS",10) == 4034291020) strcat(s, "m");
if (crc32("OtpHQjqLMVFXV",13) == 494226327) strcat(s, "m");
if (crc32("fWssIPjm",8) == 3447933622) strcat(s, "I");
if (crc32("cyYXQQvxeXAhX",13) == 3730154068) strcat(s, "i");
if (crc32("oquhPNUe",8) == 1488553678) strcat(s, "Q");
if (crc32("fuOaYipmcnnMZr",14) == 3617897163) strcat(s, "n");
if (crc32("hfLuHWRMjUMpxN",14) == 1250015138) strcat(s, "Y");
if (crc32("qzsxCv",6) == 2206497276) strcat(s, "o");
if (crc32("JIjPU",5) == 3599177371) strcat(s, "u");
if (crc32("PLTKip",6) == 3192177588) strcat(s, "l");
if (crc32("lQdhzlwdq",9) == 3946008974) strcat(s, "s");
    return s;
}

char *nontyrannic_adjectives() {
    char *s = calloc(12);
    if (crc32("hWZjtnQcogS",11) == 201142911) strcat(s, "x");
if (crc32("olFrNIHdqbC",11) == 755295928) strcat(s, "n");
if (crc32("DdsSfluwVSUAFYW",15) == 3535808996) strcat(s, "o");
if (crc32("MYOyQ",5) == 1225999085) strcat(s, "n");
if (crc32("UsjQhOQT",8) == 1133170387) strcat(s, "t");
if (crc32("kNzlsxAmBGFXln",14) == 2399449681) strcat(s, "y");
if (crc32("NweqqW",6) == 142598373) strcat(s, "R");
if (crc32("BqrkGsNiWMCto",13) == 1177514974) strcat(s, "r");
if (crc32("KyvqWCSx",8) == 2594324626) strcat(s, "a");
if (crc32("wtStJFFIBOHGH",13) == 41012828) strcat(s, "n");
if (crc32("ZZTWZSpxGAIK",12) == 1271122887) strcat(s, "z");
if (crc32("uKLKJHv",7) == 1803462971) strcat(s, "n");
if (crc32("cOdZIixj",8) == 2203613991) strcat(s, "i");
if (crc32("pLZOQcVSnMy",11) == 1301021874) strcat(s, "c");
    return s;
}

char *ringent_adjectives() {
    char *s = calloc(8);
    if (crc32("ONmYPejiDXE",11) == 1164423675) strcat(s, "k");
if (crc32("sZokHvN",7) == 2352267352) strcat(s, "r");
if (crc32("GWRCCpQzNxEDIVm",15) == 1663446556) strcat(s, "f");
if (crc32("IVlAJt",6) == 1938849162) strcat(s, "i");
if (crc32("BvdItM",6) == 233916527) strcat(s, "n");
if (crc32("kvzwUMDnkPYRKsI",15) == 3777303764) strcat(s, "O");
if (crc32("GrVFndSB",8) == 2911526523) strcat(s, "g");
if (crc32("OzvMzuz",7) == 48131444) strcat(s, "V");
if (crc32("exsVFQKzCI",10) == 3769652275) strcat(s, "e");
if (crc32("MpSxnlYRNEcWp",13) == 2513707841) strcat(s, "n");
if (crc32("danuTS",6) == 3483734943) strcat(s, "P");
if (crc32("eXUNMKTstLP",11) == 1947238610) strcat(s, "t");
    return s;
}

char *psychoneurotic_adjectives() {
    char *s = calloc(15);
    if (crc32("YTXMQc",6) == 664941642) strcat(s, "a");
if (crc32("wuJxNKYGbpuHLKX",15) == 3913256277) strcat(s, "p");
if (crc32("xwIyjDF",7) == 3084286482) strcat(s, "T");
if (crc32("lUbAweHCnBbS",12) == 3448951855) strcat(s, "s");
if (crc32("HzQopJszq",9) == 1808611628) strcat(s, "y");
if (crc32("SVjgYaFw",8) == 3953237379) strcat(s, "c");
if (crc32("DfDMZMoSgXaRb",13) == 1568004622) strcat(s, "h");
if (crc32("DPYyYDqM",8) == 3418108390) strcat(s, "o");
if (crc32("arRVOykG",8) == 2400228989) strcat(s, "S");
if (crc32("ytSkpbavSixM",12) == 1957619125) strcat(s, "n");
if (crc32("DZZujoVIniCAP",13) == 374380326) strcat(s, "e");
if (crc32("yYjcGLODlez",11) == 3803474156) strcat(s, "u");
if (crc32("waPCqIC",7) == 2746441765) strcat(s, "e");
if (crc32("VlnLD",5) == 1874191975) strcat(s, "r");
if (crc32("iFOHzgE",7) == 2682424290) strcat(s, "g");
if (crc32("YQyCVPVtT",9) == 1651684149) strcat(s, "o");
if (crc32("dBSSmBHjxllH",12) == 832770087) strcat(s, "t");
if (crc32("dAoEfdqjJsLbc",13) == 3637903610) strcat(s, "i");
if (crc32("nwNQBcrSlpC",11) == 1947592737) strcat(s, "c");
    return s;
}

char *intense_adjectives() {
    char *s = calloc(8);
    if (crc32("ZDsxPUgMYag",11) == 604696904) strcat(s, "e");
if (crc32("mNCwNoOyDWuri",13) == 3318213625) strcat(s, "i");
if (crc32("hvEJDe",6) == 1543341620) strcat(s, "n");
if (crc32("xdNQvtXDAVVTp",13) == 1417228789) strcat(s, "t");
if (crc32("gAzlJIvUjNB",11) == 3642296220) strcat(s, "u");
if (crc32("APViUgJmpEmi",12) == 2307004346) strcat(s, "e");
if (crc32("KvJkw",5) == 188061408) strcat(s, "U");
if (crc32("PAOnL",5) == 575375073) strcat(s, "n");
if (crc32("hBqzre",6) == 3714220897) strcat(s, "s");
if (crc32("HGsMENpCD",9) == 4003494350) strcat(s, "X");
if (crc32("jgtthft",7) == 1834967407) strcat(s, "e");
    return s;
}

char *undewed_adjectives() {
    char *s = calloc(8);
    if (crc32("dCaeidB",7) == 3311275641) strcat(s, "d");
if (crc32("RiJvoI",6) == 756432772) strcat(s, "u");
if (crc32("FUHkeKbH",8) == 2838477273) strcat(s, "n");
if (crc32("ksUHPwsvkZGCT",13) == 1844903976) strcat(s, "d");
if (crc32("tQdqKNnWvtVxYm",14) == 2354186982) strcat(s, "e");
if (crc32("fofMJcbCe",9) == 219459744) strcat(s, "w");
if (crc32("KDtIUHUnE",9) == 512083451) strcat(s, "e");
if (crc32("vMfvjThdP",9) == 4160923634) strcat(s, "D");
if (crc32("UszfGRWAuYiF",12) == 2178497016) strcat(s, "d");
    return s;
}

char *proterogynous_adjectives() {
    char *s = calloc(14);
    if (crc32("HDTgzBgDU",9) == 187746361) strcat(s, "i");
if (crc32("AZkROvwlCpZHMtJ",15) == 841932662) strcat(s, "p");
if (crc32("epvnNIE",7) == 1148797558) strcat(s, "f");
if (crc32("vjHFbOBXxg",10) == 4096689914) strcat(s, "r");
if (crc32("jEWpK",5) == 514386213) strcat(s, "o");
if (crc32("QPeyT",5) == 514200080) strcat(s, "h");
if (crc32("gkinsYkQCEaAKib",15) == 649576462) strcat(s, "t");
if (crc32("sgaHNmBep",9) == 2231845606) strcat(s, "D");
if (crc32("YiksVmVIvW",10) == 2692227152) strcat(s, "e");
if (crc32("JSGLchndDxdf",12) == 1471694880) strcat(s, "r");
if (crc32("zhnLPSZFYhCZJn",14) == 2063706996) strcat(s, "o");
if (crc32("oJeln",5) == 2480314226) strcat(s, "K");
if (crc32("GZppBb",6) == 2399250722) strcat(s, "g");
if (crc32("QwasyoA",7) == 1806631994) strcat(s, "y");
if (crc32("qPHrtZZTvczN",12) == 1626629644) strcat(s, "n");
if (crc32("ZOqcrjyRNEnM",12) == 2954936186) strcat(s, "P");
if (crc32("xCLbuS",6) == 1935374752) strcat(s, "o");
if (crc32("csROQPqjkzOJ",12) == 35593057) strcat(s, "u");
if (crc32("dSXStQfJwOj",11) == 2107428561) strcat(s, "s");
    return s;
}

char *wellcoloured_adjectives() {
    char *s = calloc(13);
    if (crc32("oeyVhBxOwabm",12) == 1039739738) strcat(s, "w");
if (crc32("OPjnWDAzH",9) == 1709218334) strcat(s, "k");
if (crc32("efUswsJ",7) == 3499353052) strcat(s, "e");
if (crc32("HXjgioKsVnWYF",13) == 4188614359) strcat(s, "T");
if (crc32("kDapRrBTk",9) == 1195835586) strcat(s, "l");
if (crc32("OYgvHTuccPhikaz",15) == 1127421998) strcat(s, "I");
if (crc32("LUGfeWMqMUi",11) == 1956306504) strcat(s, "l");
if (crc32("APKrgHCpmIEFvJ",14) == 3971724727) strcat(s, "X");
if (crc32("AeXjx",5) == 204113150) strcat(s, "c");
if (crc32("KdmPWsLUQCR",11) == 2276693103) strcat(s, "o");
if (crc32("NRlgsVDICofWuB",14) == 687908063) strcat(s, "l");
if (crc32("wWGwuwzVYMWgL",13) == 2243986040) strcat(s, "o");
if (crc32("EyyLdPAFTGstQ",13) == 3000033987) strcat(s, "u");
if (crc32("imTzGlCjnGv",11) == 1931109634) strcat(s, "B");
if (crc32("GBlxSrtQ",8) == 4203271424) strcat(s, "r");
if (crc32("zDsXrjPeNpYzRb",14) == 3136639877) strcat(s, "e");
if (crc32("RhYENG",6) == 881856940) strcat(s, "s");
if (crc32("ZTqyVBF",7) == 1787993647) strcat(s, "d");
    return s;
}

char *pickled_adjectives() {
    char *s = calloc(8);
    if (crc32("hORfSxjHqnzhS",13) == 2146891866) strcat(s, "o");
if (crc32("UGznIVnL",8) == 2143977616) strcat(s, "p");
if (crc32("ztIZeeZ",7) == 3281522826) strcat(s, "x");
if (crc32("JXHBEwvDS",9) == 1324496012) strcat(s, "i");
if (crc32("kIlamcem",8) == 1241520722) strcat(s, "c");
if (crc32("fAwqIgiKivbG",12) == 2159632877) strcat(s, "j");
if (crc32("ZtkuYXvUpqiKvd",14) == 3656203688) strcat(s, "k");
if (crc32("uWGLa",5) == 217712518) strcat(s, "u");
if (crc32("dMXFlqKgq",9) == 1645600453) strcat(s, "l");
if (crc32("nhjQWW",6) == 3066292731) strcat(s, "J");
if (crc32("kazcRiEs",8) == 3544820655) strcat(s, "e");
if (crc32("xAbZYCsPNpHLJ",13) == 3494926577) strcat(s, "o");
if (crc32("tjfGozhdv",9) == 293943641) strcat(s, "d");
    return s;
}

char *hittable_adjectives() {
    char *s = calloc(9);
    if (crc32("jZUbqVdg",8) == 1978181417) strcat(s, "h");
if (crc32("YkHtVAT",7) == 681120107) strcat(s, "i");
if (crc32("MUPfimnYQKwiuBo",15) == 4256867158) strcat(s, "t");
if (crc32("iPjUTjrXHtwNq",13) == 906547630) strcat(s, "t");
if (crc32("rWwlOCqaSLm",11) == 4162155849) strcat(s, "a");
if (crc32("fijsC",5) == 955890064) strcat(s, "b");
if (crc32("jMcozRU",7) == 1985038468) strcat(s, "l");
if (crc32("pGPpc",5) == 4085801919) strcat(s, "r");
if (crc32("FpOZFDBthJd",11) == 353331341) strcat(s, "e");
    return s;
}

char *viceless_adjectives() {
    char *s = calloc(9);
    if (crc32("YiwcAMTQYDxfSQ",14) == 2882954685) strcat(s, "v");
if (crc32("gquOoUu",7) == 3835373421) strcat(s, "v");
if (crc32("WDlBuMos",8) == 3628771591) strcat(s, "i");
if (crc32("MTrcpfSzvv",10) == 3643667191) strcat(s, "F");
if (crc32("ZgyGeRv",7) == 2194560587) strcat(s, "c");
if (crc32("boCGHGfZjO",10) == 2168909755) strcat(s, "T");
if (crc32("KutByQDmvtBIC",13) == 3547348182) strcat(s, "e");
if (crc32("PvSxsjAhdO",10) == 27490793) strcat(s, "l");
if (crc32("npmgIWX",7) == 302930917) strcat(s, "F");
if (crc32("rRuKIIqP",8) == 2412379275) strcat(s, "e");
if (crc32("uHytZYrtPnVzqvz",15) == 979229376) strcat(s, "n");
if (crc32("PqmFdKYgPGYMslV",15) == 1243718382) strcat(s, "s");
if (crc32("TcpOw",5) == 3988191616) strcat(s, "A");
if (crc32("nQoTNKlE",8) == 3643443196) strcat(s, "s");
    return s;
}

char *prePauline_adjectives() {
    char *s = calloc(11);
    if (crc32("noOKl",5) == 279775292) strcat(s, "P");
if (crc32("SePdmqCS",8) == 2993725509) strcat(s, "p");
if (crc32("ajUzIJXyixXqs",13) == 2812526545) strcat(s, "r");
if (crc32("iXlKZ",5) == 1464741907) strcat(s, "S");
if (crc32("ebqOLEvxunLbcL",14) == 1053354067) strcat(s, "e");
if (crc32("YgRUnaGBalSJ",12) == 1937329930) strcat(s, "u");
if (crc32("APWFPzvkgFzzVNA",15) == 2557667090) strcat(s, "P");
if (crc32("qXkPgkpV",8) == 492878741) strcat(s, "K");
if (crc32("zIrsTuacgbASdr",14) == 3562405115) strcat(s, "a");
if (crc32("RqyQMZvZT",9) == 2495352488) strcat(s, "N");
if (crc32("OUjiiXuHN",9) == 2612812211) strcat(s, "u");
if (crc32("mIvcvFtNDJBXN",13) == 1339694244) strcat(s, "l");
if (crc32("NFvXBk",6) == 2936404114) strcat(s, "E");
if (crc32("jPrpjoWZA",9) == 2450281669) strcat(s, "i");
if (crc32("AyhJqnEGyN",10) == 2105371253) strcat(s, "n");
if (crc32("NnNkLyWHepbc",12) == 6641487) strcat(s, "R");
if (crc32("eYKoXaAGgQ",10) == 664690336) strcat(s, "e");
    return s;
}

char *undared_adjectives() {
    char *s = calloc(8);
    if (crc32("CGPqORfnBkLpYGD",15) == 1718780842) strcat(s, "u");
if (crc32("CLogkybOivMWMI",14) == 929939098) strcat(s, "A");
if (crc32("BUQMu",5) == 268760024) strcat(s, "n");
if (crc32("DNwrbhvzG",9) == 1177648761) strcat(s, "d");
if (crc32("FJMchMdGgYV",11) == 2057143013) strcat(s, "c");
if (crc32("uDnbEfj",7) == 3897136480) strcat(s, "a");
if (crc32("IgygepEOijNkO",13) == 3075518658) strcat(s, "B");
if (crc32("XCRZKf",6) == 4181669708) strcat(s, "r");
if (crc32("AUSplmPlVNz",11) == 625168181) strcat(s, "p");
if (crc32("CRGNtcYP",8) == 758827870) strcat(s, "e");
if (crc32("qFFWg",5) == 2643503641) strcat(s, "v");
if (crc32("KPilgXOTrbZq",12) == 3246721362) strcat(s, "d");
    return s;
}

char *diffusive_adjectives() {
    char *s = calloc(10);
    if (crc32("JxbJnIUh",8) == 1972373437) strcat(s, "d");
if (crc32("aQdUkyKbmprNP",13) == 3726293657) strcat(s, "O");
if (crc32("eUgVQamfRHt",11) == 2271707039) strcat(s, "i");
if (crc32("eNUlEWxDNnQwZr",14) == 4280466748) strcat(s, "t");
if (crc32("sTeQXMkEioth",12) == 3995145386) strcat(s, "f");
if (crc32("Vvhmyx",6) == 3087012959) strcat(s, "b");
if (crc32("nOOUxxYuRdjGEYX",15) == 1079943357) strcat(s, "f");
if (crc32("nQdCLBndbL",10) == 2397105737) strcat(s, "u");
if (crc32("ApaktlTmk",9) == 3496349520) strcat(s, "s");
if (crc32("qqPYbfsTqJDkvKt",15) == 2473842091) strcat(s, "V");
if (crc32("mIFzQe",6) == 690656442) strcat(s, "i");
if (crc32("RsviPl",6) == 3105615240) strcat(s, "v");
if (crc32("lTHUcfC",7) == 2489841890) strcat(s, "C");
if (crc32("PgZysgdexhGX",12) == 1355366225) strcat(s, "e");
    return s;
}

char *antipestilence_adjectives() {
    char *s = calloc(15);
    if (crc32("WVkQRTjNnA",10) == 3922121504) strcat(s, "a");
if (crc32("mQluLYkzsSudOd",14) == 1295240214) strcat(s, "t");
if (crc32("OssQZsNuC",9) == 320846500) strcat(s, "n");
if (crc32("vWjUBcotNjZnvn",14) == 2066289291) strcat(s, "D");
if (crc32("zMRpETCz",8) == 1761715516) strcat(s, "t");
if (crc32("cIjCT",5) == 213789418) strcat(s, "i");
if (crc32("RXuifXwuWPwbvO",14) == 3585396336) strcat(s, "p");
if (crc32("ndoeBRjoaS",10) == 2700557657) strcat(s, "r");
if (crc32("uCyrgGLTWqpBbq",14) == 1026302609) strcat(s, "e");
if (crc32("lBPRizVn",8) == 3227754198) strcat(s, "q");
if (crc32("fjnXqBDc",8) == 2261691242) strcat(s, "s");
if (crc32("TMEbHH",6) == 3293558311) strcat(s, "Y");
if (crc32("eVCbWpJLsNjUG",13) == 3629752394) strcat(s, "t");
if (crc32("lDmslYQRRi",10) == 2150123522) strcat(s, "x");
if (crc32("HJItdOPkfZsN",12) == 1478711512) strcat(s, "i");
if (crc32("BBcLqSbrMEWqLFR",15) == 460967610) strcat(s, "l");
if (crc32("AQkcuyBU",8) == 3308359402) strcat(s, "d");
if (crc32("zrZfhYs",7) == 465690471) strcat(s, "e");
if (crc32("bciewznfWWlzP",13) == 2913590865) strcat(s, "n");
if (crc32("iFluisuvuS",10) == 3604957241) strcat(s, "V");
if (crc32("cQelsXu",7) == 3296224820) strcat(s, "c");
if (crc32("BHgzKIrwIP",10) == 1308124035) strcat(s, "m");
if (crc32("NxvPgMCP",8) == 223751414) strcat(s, "e");
    return s;
}

char *undemonstrational_adjectives() {
    char *s = calloc(18);
    if (crc32("MhZTgeluUQApU",13) == 2199225288) strcat(s, "U");
if (crc32("SJYnXXIUJPTyvn",14) == 3505731695) strcat(s, "u");
if (crc32("WMKit",5) == 3136775116) strcat(s, "n");
if (crc32("TEtnvU",6) == 2454622975) strcat(s, "V");
if (crc32("dVXJtKSeKUgjmZg",15) == 79366944) strcat(s, "d");
if (crc32("QnzYJMLa",8) == 1376743321) strcat(s, "e");
if (crc32("rAfQhiLceP",10) == 3584719976) strcat(s, "y");
if (crc32("wHhgKAPiZs",10) == 3658842094) strcat(s, "m");
if (crc32("HzfwWFNcriFD",12) == 1428943194) strcat(s, "S");
if (crc32("TfYxnI",6) == 674672498) strcat(s, "o");
if (crc32("tbHAJdU",7) == 3972114953) strcat(s, "n");
if (crc32("WTkYPDGIle",10) == 2161468541) strcat(s, "s");
if (crc32("QYnMLF",6) == 601599300) strcat(s, "t");
if (crc32("HiHRRZFoqK",10) == 3375242462) strcat(s, "r");
if (crc32("nloRdUwFDLDC",12) == 167544793) strcat(s, "W");
if (crc32("aiWcgdxTzuEHjzj",15) == 4277090852) strcat(s, "a");
if (crc32("xXkcOYbWJcUq",12) == 2903590880) strcat(s, "u");
if (crc32("voWovkkvCcs",11) == 4198064358) strcat(s, "t");
if (crc32("lpAERViLidXdBe",14) == 3433163935) strcat(s, "i");
if (crc32("AECUqhhOwEZ",11) == 630133047) strcat(s, "y");
if (crc32("hXaXhZVM",8) == 3337103415) strcat(s, "o");
if (crc32("armXuuqFxTfufm",14) == 1348601955) strcat(s, "Q");
if (crc32("aPlCGsFWwYcwcZ",14) == 2310977377) strcat(s, "n");
if (crc32("UDaUyKO",7) == 3989706423) strcat(s, "A");
if (crc32("NsKUtoHLeqgbXM",14) == 439511477) strcat(s, "a");
if (crc32("NxpLudArkxlmfNF",15) == 2420409318) strcat(s, "l");
    return s;
}

char *supercarpal_adjectives() {
    char *s = calloc(12);
    if (crc32("sEarQR",6) == 1582135648) strcat(s, "s");
if (crc32("qVaByjfnzHuZ",12) == 1576750590) strcat(s, "u");
if (crc32("gTnXTRwpwpkp",12) == 387633618) strcat(s, "p");
if (crc32("fjwPhuoUooI",11) == 2116986697) strcat(s, "e");
if (crc32("NaInZuHyByeix",13) == 1363091272) strcat(s, "r");
if (crc32("vQZkjAZIRpdfcaW",15) == 167512065) strcat(s, "T");
if (crc32("tqELOGDV",8) == 1695422693) strcat(s, "c");
if (crc32("TVwZvU",6) == 2729381485) strcat(s, "T");
if (crc32("CIsDrVTVSLsYswy",15) == 76702267) strcat(s, "a");
if (crc32("WXBvdglfaSyOrhN",15) == 1140972148) strcat(s, "r");
if (crc32("DnhRYlrOuXrDix",14) == 2363458120) strcat(s, "s");
if (crc32("BthFajlQYIlSd",13) == 1144401851) strcat(s, "p");
if (crc32("MfXjIOZ",7) == 3119638914) strcat(s, "a");
if (crc32("KwmoH",5) == 3313819865) strcat(s, "l");
    return s;
}

char *conbrio_adjectives() {
    char *s = calloc(8);
    if (crc32("aDFPu",5) == 2563067679) strcat(s, "c");
if (crc32("wRpoNKhHVy",10) == 1111276716) strcat(s, "O");
if (crc32("YGrpzkGPmfqsXx",14) == 2584420049) strcat(s, "o");
if (crc32("nPiLdTmWWgjF",12) == 2349810893) strcat(s, "z");
if (crc32("TicmX",5) == 3001917386) strcat(s, "n");
if (crc32("JfJgxBrNSuWwYv",14) == 3463484700) strcat(s, "b");
if (crc32("dOxhmzjwutZl",12) == 4248221826) strcat(s, "r");
if (crc32("EVngDzli",8) == 3984643489) strcat(s, "i");
if (crc32("zMsVGBqZkmnBEJA",15) == 2237787035) strcat(s, "o");
    return s;
}

char *screwable_adjectives() {
    char *s = calloc(10);
    if (crc32("yGOGU",5) == 488926332) strcat(s, "q");
if (crc32("tVrHPku",7) == 1223957182) strcat(s, "s");
if (crc32("NdktXvCR",8) == 3524171640) strcat(s, "m");
if (crc32("XvooS",5) == 3550050156) strcat(s, "c");
if (crc32("dHZouiiIizXEJZ",14) == 924352462) strcat(s, "u");
if (crc32("hBjNmoIkcNBaA",13) == 166319227) strcat(s, "r");
if (crc32("iYXvIoMz",8) == 363238631) strcat(s, "f");
if (crc32("xkdAMuIhAGRNKs",14) == 1837661668) strcat(s, "e");
if (crc32("MllfXHoOoN",10) == 2869109586) strcat(s, "Y");
if (crc32("WfzCmq",6) == 926170144) strcat(s, "w");
if (crc32("inbQEC",6) == 649193080) strcat(s, "a");
if (crc32("OqZCRjvjWGCJXAX",15) == 2680521908) strcat(s, "b");
if (crc32("ZkxoW",5) == 2100439433) strcat(s, "u");
if (crc32("YJbWkcEAJLYzp",13) == 2132016998) strcat(s, "l");
if (crc32("HKZFMcgEdwckR",13) == 321188132) strcat(s, "e");
    return s;
}

char *extrafloral_adjectives() {
    char *s = calloc(12);
    if (crc32("AhaYD",5) == 251566987) strcat(s, "e");
if (crc32("xCBwvLVHawcdX",13) == 272650001) strcat(s, "x");
if (crc32("jktJaImnJFUKaC",14) == 158428473) strcat(s, "b");
if (crc32("RtlsmmkjY",9) == 853436756) strcat(s, "t");
if (crc32("fSxLjbI",7) == 4210765460) strcat(s, "r");
if (crc32("yOdRgTzAcxXUmnR",15) == 1895521029) strcat(s, "a");
if (crc32("AyRqPZtpnWtxmBv",15) == 2998470732) strcat(s, "f");
if (crc32("TbxcVq",6) == 3939928349) strcat(s, "l");
if (crc32("nvJeON",6) == 3947857308) strcat(s, "q");
if (crc32("wsYBAToYoeve",12) == 1850385982) strcat(s, "o");
if (crc32("MIfAGDXtH",9) == 732380693) strcat(s, "t");
if (crc32("KzGaOqdika",10) == 2609271632) strcat(s, "r");
if (crc32("bYNRFgc",7) == 3467208817) strcat(s, "U");
if (crc32("titpL",5) == 2415115610) strcat(s, "a");
if (crc32("UqEvTTrjb",9) == 2424149852) strcat(s, "k");
if (crc32("ZBRpl",5) == 2174688922) strcat(s, "l");
    return s;
}

char *unvinous_adjectives() {
    char *s = calloc(9);
    if (crc32("ZgjDPePrahi",11) == 4104234414) strcat(s, "u");
if (crc32("CPfnHP",6) == 265473190) strcat(s, "n");
if (crc32("CcYiTmNSwlDzo",13) == 1650256484) strcat(s, "m");
if (crc32("BjbVVvQKPT",10) == 398848832) strcat(s, "v");
if (crc32("uwLkQr",6) == 3518264799) strcat(s, "T");
if (crc32("FDCGD",5) == 3115514444) strcat(s, "i");
if (crc32("IcLBHnqZLOOKCH",14) == 3804145918) strcat(s, "G");
if (crc32("YRpEPTGtBVYviB",14) == 552036115) strcat(s, "n");
if (crc32("stpZcysBnj",10) == 1583449252) strcat(s, "o");
if (crc32("fAQUXoPvrkQH",12) == 2668746554) strcat(s, "x");
if (crc32("khszvJCHa",9) == 3204079268) strcat(s, "u");
if (crc32("odoovqFRb",9) == 1327065439) strcat(s, "s");
    return s;
}

char *superignorant_adjectives() {
    char *s = calloc(14);
    if (crc32("xxvWiAaniAXkat",14) == 2055666601) strcat(s, "s");
if (crc32("QvRhihgTj",9) == 2148128999) strcat(s, "D");
if (crc32("DYbywH",6) == 3263041191) strcat(s, "u");
if (crc32("nXUIRmaofQW",11) == 3786060118) strcat(s, "D");
if (crc32("LftmLxVbejAP",12) == 4151493418) strcat(s, "p");
if (crc32("oychioMlpwXe",12) == 2587652468) strcat(s, "Q");
if (crc32("xJkHLtLxL",9) == 3888591674) strcat(s, "e");
if (crc32("yiQFJUY",7) == 3625827801) strcat(s, "r");
if (crc32("hprZVl",6) == 621353076) strcat(s, "k");
if (crc32("eeixWWVncasZrj",14) == 3167059129) strcat(s, "i");
if (crc32("eYaUPcC",7) == 4200284816) strcat(s, "g");
if (crc32("JBAAvqJse",9) == 27499201) strcat(s, "n");
if (crc32("WqGvBK",6) == 285577578) strcat(s, "o");
if (crc32("RMKahhHUxnubxV",14) == 551922443) strcat(s, "r");
if (crc32("zUyjeOknIuhOgHJ",15) == 1484678032) strcat(s, "k");
if (crc32("aroux",5) == 3965401431) strcat(s, "a");
if (crc32("AnICxpFlkM",10) == 2196766580) strcat(s, "b");
if (crc32("PSDpkKzUfDvHoMT",15) == 142431800) strcat(s, "n");
if (crc32("MNfOTDSYpJiea",13) == 4232779717) strcat(s, "F");
if (crc32("WFlhKrZIochLQA",14) == 3866742513) strcat(s, "t");
    return s;
}

char *Frenchy_adjectives() {
    char *s = calloc(8);
    if (crc32("XoHOSX",6) == 2326525042) strcat(s, "C");
if (crc32("mqJYCuLDoAvHOA",14) == 2403397367) strcat(s, "F");
if (crc32("inoQlhZ",7) == 194048728) strcat(s, "S");
if (crc32("agUWcFjdU",9) == 677681638) strcat(s, "r");
if (crc32("UikfFV",6) == 1825469988) strcat(s, "M");
if (crc32("YTNuKHglz",9) == 3821859919) strcat(s, "e");
if (crc32("RpBbmbVJ",8) == 2095665876) strcat(s, "E");
if (crc32("bweoHVkhSM",10) == 552594366) strcat(s, "n");
if (crc32("JORHdK",6) == 580287997) strcat(s, "h");
if (crc32("QzBRmIqRSnP",11) == 1305773696) strcat(s, "c");
if (crc32("egiurVhwvKZOHq",14) == 2071130695) strcat(s, "h");
if (crc32("KbLbnRih",8) == 2142143700) strcat(s, "g");
if (crc32("XcPQSvGbFJEiz",13) == 2576170593) strcat(s, "y");
    return s;
}

char *unfaceted_adjectives() {
    char *s = calloc(10);
    if (crc32("oluRYwaNlrHXF",13) == 769676292) strcat(s, "S");
if (crc32("nPmTtJaYHzasL",13) == 2711334934) strcat(s, "u");
if (crc32("WkjYxxUBWokWB",13) == 3819331410) strcat(s, "G");
if (crc32("mTIToytcsmoU",12) == 3064322440) strcat(s, "n");
if (crc32("PaTkInHVQS",10) == 542982905) strcat(s, "f");
if (crc32("DiuibrVDN",9) == 1600307025) strcat(s, "X");
if (crc32("wkvXiuKDYa",10) == 665823991) strcat(s, "a");
if (crc32("sQZMJy",6) == 3334121461) strcat(s, "c");
if (crc32("eoobFZYVZ",9) == 2542652179) strcat(s, "z");
if (crc32("loIjg",5) == 3391769501) strcat(s, "e");
if (crc32("nXnVLOwxatO",11) == 1468384019) strcat(s, "P");
if (crc32("LFkcygSmVAY",11) == 3979935947) strcat(s, "t");
if (crc32("COVJxVPZmYl",11) == 67678784) strcat(s, "e");
if (crc32("zQXOzvBIeKvOkc",14) == 2331714944) strcat(s, "d");
    return s;
}

char *noncertified_adjectives() {
    char *s = calloc(13);
    if (crc32("sepuBc",6) == 1113010611) strcat(s, "n");
if (crc32("okkbjbhmLeb",11) == 2605020002) strcat(s, "W");
if (crc32("gtofGvq",7) == 1834200606) strcat(s, "o");
if (crc32("rWmQDh",6) == 240457344) strcat(s, "n");
if (crc32("fcBvZnrW",8) == 4077209834) strcat(s, "c");
if (crc32("oiSRXNXWfuMQkR",14) == 3715275519) strcat(s, "e");
if (crc32("cjbHtycSOH",10) == 3653492706) strcat(s, "r");
if (crc32("NxfqIfm",7) == 1112047320) strcat(s, "X");
if (crc32("izCnbcTiqiUY",12) == 1507632480) strcat(s, "t");
if (crc32("zNZTpeapS",9) == 3622861450) strcat(s, "G");
if (crc32("XygcTLxWpVKaD",13) == 1603094807) strcat(s, "i");
if (crc32("DOAgPwhJUcYah",13) == 1402273930) strcat(s, "f");
if (crc32("UvKMkrQilvCVRpe",15) == 3131785106) strcat(s, "i");
if (crc32("NGTcquMmmObC",12) == 1199660923) strcat(s, "N");
if (crc32("BjTbzZou",8) == 4061298395) strcat(s, "e");
if (crc32("SKjGyBeCvHKBP",13) == 3518192219) strcat(s, "E");
if (crc32("hzAcT",5) == 946651415) strcat(s, "d");
    return s;
}

char *shortorder_adjectives() {
    char *s = calloc(11);
    if (crc32("XdPJgeZdiC",10) == 636510709) strcat(s, "p");
if (crc32("GqjDtDolHPKgjv",14) == 4089028331) strcat(s, "s");
if (crc32("PhJWUMuiTuiwA",13) == 3073498555) strcat(s, "O");
if (crc32("IFvWVXIWRe",10) == 1223597020) strcat(s, "h");
if (crc32("LstOvEEDUnj",11) == 2675901038) strcat(s, "o");
if (crc32("SLohUiBx",8) == 1250193140) strcat(s, "r");
if (crc32("fWoNofPkPQWCi",13) == 668165732) strcat(s, "P");
if (crc32("VnWVk",5) == 4126816113) strcat(s, "t");
if (crc32("LdmrQuGs",8) == 70186030) strcat(s, "o");
if (crc32("uWEGuTnFRbsIAI",14) == 55461562) strcat(s, "r");
if (crc32("eQdIvehOiIJ",11) == 2966989558) strcat(s, "F");
if (crc32("AfOhzvIdWhIWa",13) == 2791383670) strcat(s, "d");
if (crc32("SvexgZsqsE",10) == 3302773036) strcat(s, "D");
if (crc32("TzVyUMnj",8) == 13363976) strcat(s, "e");
if (crc32("bMpHYi",6) == 4157511620) strcat(s, "T");
if (crc32("TtFCYZlB",8) == 3968856796) strcat(s, "r");
    return s;
}

char *quasiantique_adjectives() {
    char *s = calloc(13);
    if (crc32("kZSULWub",8) == 1546305000) strcat(s, "q");
if (crc32("rPcQIKnbjk",10) == 1779347329) strcat(s, "u");
if (crc32("syiEmhSPNMbojh",14) == 834672952) strcat(s, "F");
if (crc32("AoghMtfIWF",10) == 3347615654) strcat(s, "a");
if (crc32("SZaPSHWvhTaT",12) == 2831520155) strcat(s, "s");
if (crc32("DtrrYOnbzDXXM",13) == 246654299) strcat(s, "i");
if (crc32("XIBzEyBjb",9) == 2850588201) strcat(s, "a");
if (crc32("pcGLHn",6) == 838878645) strcat(s, "V");
if (crc32("lcHAQUF",7) == 557621752) strcat(s, "n");
if (crc32("NTaKWnQtfuGOHWr",15) == 778734197) strcat(s, "M");
if (crc32("pVdPdiZRiqowws",14) == 3924946370) strcat(s, "t");
if (crc32("KRxzGnK",7) == 2027391328) strcat(s, "Z");
if (crc32("pRYTEjxLOFAAG",13) == 2963345567) strcat(s, "i");
if (crc32("fnmil",5) == 3291818000) strcat(s, "R");
if (crc32("oquPTqSDeUvrZNY",15) == 894309462) strcat(s, "q");
if (crc32("JepZYJlYv",9) == 3302385946) strcat(s, "m");
if (crc32("rThdbpwGqMEopTw",15) == 1068063567) strcat(s, "u");
if (crc32("oaxKfPPT",8) == 758546957) strcat(s, "e");
    return s;
}

char *coolheaded_adjectives() {
    char *s = calloc(11);
    if (crc32("Uddhko",6) == 4034916507) strcat(s, "T");
if (crc32("fahPbaWEaiC",11) == 3034122647) strcat(s, "c");
if (crc32("ujNXDcVAeBAMw",13) == 3504073367) strcat(s, "H");
if (crc32("gyGBwMd",7) == 2049445679) strcat(s, "o");
if (crc32("cnkiGoN",7) == 3151272259) strcat(s, "o");
if (crc32("tptoJqrmKXcZkF",14) == 2163239383) strcat(s, "e");
if (crc32("udtNAKukPfX",11) == 3455781337) strcat(s, "l");
if (crc32("UctzZZANBxa",11) == 2074191898) strcat(s, "a");
if (crc32("JqnHkBvEOdHWQbv",15) == 1492059532) strcat(s, "h");
if (crc32("PWzSnLnma",9) == 1456854684) strcat(s, "e");
if (crc32("hoAcjNTmbEGfZKJ",15) == 1905700187) strcat(s, "p");
if (crc32("cJMvvL",6) == 317512566) strcat(s, "a");
if (crc32("EIMXNNI",7) == 372006596) strcat(s, "d");
if (crc32("ESbPRLpQ",8) == 1531297038) strcat(s, "s");
if (crc32("BkomltKl",8) == 1789542175) strcat(s, "e");
if (crc32("ilrZLtKzB",9) == 943048121) strcat(s, "M");
if (crc32("ZvLPxjM",7) == 1545714265) strcat(s, "d");
    return s;
}

char *unbeaded_adjectives() {
    char *s = calloc(9);
    if (crc32("dyCaSa",6) == 3186780108) strcat(s, "u");
if (crc32("bJNrAbMPyBbCWz",14) == 1282818721) strcat(s, "t");
if (crc32("uXXBsxtBlhNoG",13) == 4098826816) strcat(s, "n");
if (crc32("MotXuvNnYCjfz",13) == 3347029500) strcat(s, "b");
if (crc32("poXBsYBRDrZNAxp",15) == 389849205) strcat(s, "R");
if (crc32("ToGSwtUIjEcCVTO",15) == 3543006562) strcat(s, "e");
if (crc32("XAuwKyJfoKzRmP",14) == 2700240686) strcat(s, "Z");
if (crc32("sblCQr",6) == 3238133190) strcat(s, "a");
if (crc32("gocbXFtLABJkZl",14) == 3102353607) strcat(s, "d");
if (crc32("AHteItiBMu",10) == 1923158440) strcat(s, "e");
if (crc32("ueQNU",5) == 3815578852) strcat(s, "d");
    return s;
}

char *spleenish_adjectives() {
    char *s = calloc(10);
    if (crc32("HJdPOdpL",8) == 145486171) strcat(s, "s");
if (crc32("HOeHeVcePHsh",12) == 423715622) strcat(s, "W");
if (crc32("LnxRadCB",8) == 3942245268) strcat(s, "p");
if (crc32("yHugYW",6) == 2671544047) strcat(s, "K");
if (crc32("YTvxdKcjSPiitw",14) == 3711545253) strcat(s, "l");
if (crc32("FifaV",5) == 3842767816) strcat(s, "e");
if (crc32("IzPSaJfdESqCLUV",15) == 2668168711) strcat(s, "e");
if (crc32("uPqNhGAvWlqCqsq",15) == 2939083182) strcat(s, "x");
if (crc32("mRTvfHymeMG",11) == 3711370437) strcat(s, "n");
if (crc32("VvmIRrkShQUY",12) == 3754901438) strcat(s, "i");
if (crc32("PsNxQKA",7) == 91194546) strcat(s, "s");
if (crc32("XCJjeMT",7) == 630192781) strcat(s, "h");
    return s;
}

char *rechargeable_adjectives() {
    char *s = calloc(13);
    if (crc32("QTyWWQwj",8) == 2771815645) strcat(s, "D");
if (crc32("ZMmHAwJbhK",10) == 575483749) strcat(s, "r");
if (crc32("aNsJrdSkxdAqc",13) == 4290813813) strcat(s, "e");
if (crc32("VnSpPM",6) == 2620546926) strcat(s, "w");
if (crc32("viiYnB",6) == 3195310432) strcat(s, "c");
if (crc32("dLhlAdzoDRQI",12) == 139454511) strcat(s, "h");
if (crc32("JjWbCMiPWdOep",13) == 4019691345) strcat(s, "w");
if (crc32("RvfHsx",6) == 3156130476) strcat(s, "a");
if (crc32("xuAaCyFvjCQHD",13) == 3907622015) strcat(s, "Y");
if (crc32("aOvwFZpUG",9) == 3434470973) strcat(s, "r");
if (crc32("gDQntc",6) == 2807063093) strcat(s, "g");
if (crc32("vazusUEfhy",10) == 3795757491) strcat(s, "U");
if (crc32("yjJmltfRTnggBmE",15) == 2555515463) strcat(s, "e");
if (crc32("VYOIomsYlOPwe",13) == 2957828375) strcat(s, "a");
if (crc32("voZOLhQD",8) == 273922611) strcat(s, "H");
if (crc32("pYxjbhLJKV",10) == 1249221644) strcat(s, "b");
if (crc32("wikwNq",6) == 3349586960) strcat(s, "l");
if (crc32("FzYJpMafdMhz",12) == 991897186) strcat(s, "e");
    return s;
}

char *inviting_adjectives() {
    char *s = calloc(9);
    if (crc32("MCReodPBrDTK",12) == 746787224) strcat(s, "g");
if (crc32("RhehoHXSqSp",11) == 1192297455) strcat(s, "i");
if (crc32("NEbRDndaFpswl",13) == 3002848972) strcat(s, "Y");
if (crc32("eYcQhI",6) == 976328193) strcat(s, "n");
if (crc32("XcQEh",5) == 3747571315) strcat(s, "U");
if (crc32("KRZwgYUfaCWApZX",15) == 143817756) strcat(s, "v");
if (crc32("JtZQGexkhiryKG",14) == 179622743) strcat(s, "x");
if (crc32("sDTakaoQiWnrdj",14) == 4284633401) strcat(s, "i");
if (crc32("iLsNGRaBJDItJUo",15) == 2521692941) strcat(s, "t");
if (crc32("tTawrSICaL",10) == 1352912693) strcat(s, "H");
if (crc32("ZwidlMRO",8) == 2887672866) strcat(s, "i");
if (crc32("VGfOYHYmlHvVEav",15) == 3551309083) strcat(s, "S");
if (crc32("IAePsplHEzHG",12) == 2029243685) strcat(s, "n");
if (crc32("XlgqZ",5) == 319374375) strcat(s, "g");
if (crc32("UKDpyGwcAfiW",12) == 2572319756) strcat(s, "g");
    return s;
}

char *plantar_adjectives() {
    char *s = calloc(8);
    if (crc32("ZIWQaeHH",8) == 1653274714) strcat(s, "S");
if (crc32("XpNLP",5) == 3906806460) strcat(s, "p");
if (crc32("nYjEeXCFP",9) == 2825747359) strcat(s, "l");
if (crc32("OlewaWbUFHGMsif",15) == 140716557) strcat(s, "a");
if (crc32("ewovGvLRrdMKbrE",15) == 3031779777) strcat(s, "n");
if (crc32("zChhftQAsOqoa",13) == 1445372130) strcat(s, "t");
if (crc32("HrrKindMlMOV",12) == 2667546771) strcat(s, "a");
if (crc32("tBSwbmS",7) == 669165557) strcat(s, "r");
    return s;
}

char *unsoarable_adjectives() {
    char *s = calloc(11);
    if (crc32("PNwic",5) == 2366587827) strcat(s, "c");
if (crc32("RYQNJ",5) == 2809767196) strcat(s, "u");
if (crc32("tNzjAfbyBnggNz",14) == 4261106648) strcat(s, "n");
if (crc32("DfgTamNHN",9) == 337882976) strcat(s, "s");
if (crc32("WiPzUwOh",8) == 48687100) strcat(s, "o");
if (crc32("aNqEiDXJG",9) == 1763279084) strcat(s, "q");
if (crc32("rbXCAC",6) == 1846039550) strcat(s, "a");
if (crc32("ZQBxISdJNQwbvk",14) == 3675760111) strcat(s, "r");
if (crc32("uIzloMQJf",9) == 304906625) strcat(s, "v");
if (crc32("hhmdnUWEJg",10) == 3385906951) strcat(s, "a");
if (crc32("KfXQPj",6) == 3056889657) strcat(s, "b");
if (crc32("qQEvIWcQ",8) == 1949193296) strcat(s, "l");
if (crc32("NFDIdsg",7) == 2200726567) strcat(s, "e");
    return s;
}

char *edgiest_adjectives() {
    char *s = calloc(8);
    if (crc32("warUOUTzgan",11) == 4249743640) strcat(s, "e");
if (crc32("QUpJwqRmgHsXS",13) == 3069950928) strcat(s, "w");
if (crc32("GyOoUeKfTny",11) == 937491888) strcat(s, "d");
if (crc32("tFuXlEUYjszQN",13) == 496886804) strcat(s, "l");
if (crc32("VVPoNqOIFAGgVgC",15) == 1608307578) strcat(s, "g");
if (crc32("KJwrocv",7) == 1264247631) strcat(s, "i");
if (crc32("oRuyFboNNbCMcW",14) == 1005609476) strcat(s, "e");
if (crc32("MFuHJnSlVCmBRa",14) == 2912579749) strcat(s, "s");
if (crc32("kWuoRCnrBpOEnB",14) == 2428655729) strcat(s, "t");
    return s;
}

char *prototypic_adjectives() {
    char *s = calloc(11);
    if (crc32("IRHfAMkz",8) == 2292848913) strcat(s, "J");
if (crc32("sfMeqsQIJLs",11) == 2875442691) strcat(s, "p");
if (crc32("pRNMLQLbNx",10) == 2280656730) strcat(s, "r");
if (crc32("cAGUM",5) == 2171390625) strcat(s, "o");
if (crc32("VHvzU",5) == 2977733953) strcat(s, "t");
if (crc32("PLnnAPgg",8) == 288197847) strcat(s, "o");
if (crc32("UxJfGSwN",8) == 794416610) strcat(s, "u");
if (crc32("mqkarq",6) == 1579417491) strcat(s, "t");
if (crc32("qiCdHvxEyu",10) == 2000148763) strcat(s, "O");
if (crc32("omOskdcCafw",11) == 1450320067) strcat(s, "y");
if (crc32("nOXZdh",6) == 1962265587) strcat(s, "p");
if (crc32("rDFhNHawkpCfBU",14) == 3307511576) strcat(s, "i");
if (crc32("XSGaOrhloa",10) == 379363268) strcat(s, "c");
    return s;
}

char *metronymic_adjectives() {
    char *s = calloc(11);
    if (crc32("TLJuZaHqy",9) == 2623307624) strcat(s, "m");
if (crc32("zkXaari",7) == 3297817522) strcat(s, "T");
if (crc32("bpSBUQe",7) == 818331463) strcat(s, "e");
if (crc32("GfrvClSUBaKlaw",14) == 3107781651) strcat(s, "t");
if (crc32("rwxdckynMP",10) == 2683839284) strcat(s, "r");
if (crc32("BEtFnkbEMm",10) == 2948027122) strcat(s, "o");
if (crc32("HjdVfbCXztb",11) == 1580627020) strcat(s, "n");
if (crc32("FmfpdP",6) == 3321852023) strcat(s, "Z");
if (crc32("ArhXVumQcSuzKv",14) == 2773192932) strcat(s, "y");
if (crc32("HssgOnTGAVBMzWL",15) == 959676522) strcat(s, "m");
if (crc32("MCWPRHZDzBWE",12) == 3325086685) strcat(s, "z");
if (crc32("LUfgtuRFVbLk",12) == 2156414520) strcat(s, "i");
if (crc32("znTQppKEcjLQSJC",15) == 2718390858) strcat(s, "b");
if (crc32("swgRaWMdcsWrbC",14) == 2432630045) strcat(s, "c");
    return s;
}

char *Trinidadian_adjectives() {
    char *s = calloc(12);
    if (crc32("GlDxW",5) == 290517980) strcat(s, "u");
if (crc32("yKfPNkDwDzlllBL",15) == 2028266777) strcat(s, "T");
if (crc32("NzSGQYf",7) == 4165422229) strcat(s, "r");
if (crc32("EvsusLoGOffsRc",14) == 2199818857) strcat(s, "i");
if (crc32("umlSzw",6) == 1312143672) strcat(s, "K");
if (crc32("gDdSJgwins",10) == 320795757) strcat(s, "n");
if (crc32("FBNRjSwurZG",11) == 399178542) strcat(s, "w");
if (crc32("uheqmbOUn",9) == 2689480667) strcat(s, "i");
if (crc32("GLHZVdNouwI",11) == 3616517731) strcat(s, "N");
if (crc32("vtObd",5) == 843035424) strcat(s, "d");
if (crc32("HhUYHvPWISdpf",13) == 4279004853) strcat(s, "a");
if (crc32("kRIFmjkzhUH",11) == 3625860241) strcat(s, "f");
if (crc32("dirWSrdbMZg",11) == 1698989107) strcat(s, "d");
if (crc32("IqoGAiVqT",9) == 2328850444) strcat(s, "i");
if (crc32("NtIfORlkDuXfm",13) == 3040596929) strcat(s, "a");
if (crc32("RslJOSzcCoJsx",13) == 2702037161) strcat(s, "n");
    return s;
}

char *unmisinterpretable_adjectives() {
    char *s = calloc(19);
    if (crc32("EnDPxtiNuWKvau",14) == 2836536893) strcat(s, "u");
if (crc32("esKZwBSTtMFSaA",14) == 3873797097) strcat(s, "X");
if (crc32("ODzjpNTwnKk",11) == 4096101386) strcat(s, "n");
if (crc32("BQCtyyG",7) == 3326734584) strcat(s, "t");
if (crc32("cpuDkXhcmXnsObM",15) == 3959164944) strcat(s, "m");
if (crc32("OwUPxHa",7) == 1510016421) strcat(s, "i");
if (crc32("AxTcWIjsDBfOhU",14) == 138634118) strcat(s, "T");
if (crc32("QhtyPyzpX",9) == 2313764815) strcat(s, "s");
if (crc32("eGbJeVdKoLvz",12) == 499191594) strcat(s, "i");
if (crc32("BORWkvKTxEC",11) == 2965502952) strcat(s, "m");
if (crc32("bEmufflmrzlB",12) == 2939332023) strcat(s, "n");
if (crc32("bSJPWOddNHCyDZk",15) == 2773368201) strcat(s, "t");
if (crc32("UqLNxbIYHj",10) == 830784113) strcat(s, "p");
if (crc32("LLltVcczzi",10) == 1439114523) strcat(s, "e");
if (crc32("MIJGXVa",7) == 815555611) strcat(s, "r");
if (crc32("ajfTqWkACr",10) == 3408720819) strcat(s, "K");
if (crc32("nqTGKrVTpclwdXG",15) == 1222757937) strcat(s, "p");
if (crc32("UkrOoM",6) == 1409950427) strcat(s, "l");
if (crc32("ZGSJHSdAJ",9) == 526239840) strcat(s, "r");
if (crc32("SLaSkOKCDUyDoT",14) == 2142195274) strcat(s, "p");
if (crc32("NqaBLtL",7) == 2446328984) strcat(s, "e");
if (crc32("CJtlejgne",9) == 1345138513) strcat(s, "t");
if (crc32("BmnaMFnFtwX",11) == 2077008239) strcat(s, "a");
if (crc32("ENZunEfKMvMQfL",14) == 2362032776) strcat(s, "b");
if (crc32("rvaDBzUHV",9) == 486932103) strcat(s, "l");
if (crc32("Gvvtlprck",9) == 3723906795) strcat(s, "e");
    return s;
}

char *wellpeopled_adjectives() {
    char *s = calloc(12);
    if (crc32("iioFIvwuzT",10) == 1399454371) strcat(s, "w");
if (crc32("WcDwVMJStVcKXFn",15) == 1223838834) strcat(s, "r");
if (crc32("VgmOuEHgOEdyB",13) == 3907257404) strcat(s, "e");
if (crc32("bSNlYiXtJp",10) == 216869371) strcat(s, "c");
if (crc32("vanQDKeRcKhud",13) == 1366537009) strcat(s, "l");
if (crc32("eDWlCKXHPxTD",12) == 467865239) strcat(s, "l");
if (crc32("gPlTuQMG",8) == 2995570692) strcat(s, "p");
if (crc32("hvpLShqYAxHMTDF",15) == 761708190) strcat(s, "e");
if (crc32("eZYpclGRuIpKYX",14) == 3040894527) strcat(s, "o");
if (crc32("UOQAc",5) == 3837960086) strcat(s, "Q");
if (crc32("JbhpCxUYyMGUU",13) == 2800946884) strcat(s, "p");
if (crc32("NHuNKjhgLeFQtff",15) == 1226124887) strcat(s, "l");
if (crc32("VUEMLEIiQQ",10) == 3720066353) strcat(s, "e");
if (crc32("MvhcLyRTo",9) == 1912886150) strcat(s, "d");
    return s;
}

char *Recent_adjectives() {
    char *s = calloc(7);
    if (crc32("Rxjqjvh",7) == 4271984688) strcat(s, "q");
if (crc32("cScMidIacaf",11) == 4000322325) strcat(s, "R");
if (crc32("mCyhcfYK",8) == 3393548634) strcat(s, "g");
if (crc32("LIsIXRABlTEhKBQ",15) == 3614422597) strcat(s, "e");
if (crc32("ShTEo",5) == 436572050) strcat(s, "k");
if (crc32("Kbfmo",5) == 959086460) strcat(s, "c");
if (crc32("EUxnyqCGk",9) == 3640708761) strcat(s, "q");
if (crc32("eymobEgKsjvEi",13) == 628360737) strcat(s, "e");
if (crc32("VMtYo",5) == 4253226958) strcat(s, "n");
if (crc32("YbgMGykDSauvTlc",15) == 3250359673) strcat(s, "t");
    return s;
}

char *unhumanistic_adjectives() {
    char *s = calloc(13);
    if (crc32("zcWpdBj",7) == 2882662665) strcat(s, "w");
if (crc32("FzxjyHvSTYt",11) == 3694450465) strcat(s, "u");
if (crc32("IZesRcrAxAt",11) == 4226068704) strcat(s, "P");
if (crc32("jKzwdEjSIhIqBB",14) == 3150577216) strcat(s, "n");
if (crc32("iXcFTtY",7) == 1122805443) strcat(s, "z");
if (crc32("kTBJSjZbpgZ",11) == 1301899560) strcat(s, "h");
if (crc32("fmCytRqQCGKptH",14) == 555579182) strcat(s, "l");
if (crc32("LAaEd",5) == 4132291099) strcat(s, "u");
if (crc32("ntOUedKViMDGcu",14) == 630839971) strcat(s, "m");
if (crc32("bEvIgz",6) == 3483300998) strcat(s, "a");
if (crc32("NKHtkUkGyNU",11) == 3619385995) strcat(s, "n");
if (crc32("vFTyIWZJU",9) == 2856637794) strcat(s, "G");
if (crc32("bOMkPgFfJaEQXP",14) == 2942440696) strcat(s, "i");
if (crc32("abaYQUYcAmP",11) == 565148842) strcat(s, "s");
if (crc32("ooXDIVgIOj",10) == 3331425110) strcat(s, "I");
if (crc32("JiuOHcbX",8) == 1683459800) strcat(s, "t");
if (crc32("SegoqQe",7) == 1416889616) strcat(s, "i");
if (crc32("ysCmBpqbBawNGo",14) == 2326692347) strcat(s, "L");
if (crc32("nuZTQKwKYjjB",12) == 2789911174) strcat(s, "c");
    return s;
}

char *handtohand_adjectives() {
    char *s = calloc(11);
    if (crc32("jWDchMlMbUdHJ",13) == 2078245382) strcat(s, "h");
if (crc32("eHSqWBQRiqvNEC",14) == 1906967025) strcat(s, "a");
if (crc32("SQWHZBm",7) == 209129227) strcat(s, "n");
if (crc32("amirXwiFOAapoI",14) == 2680540088) strcat(s, "F");
if (crc32("IBqCW",5) == 3652487013) strcat(s, "d");
if (crc32("kmleYMV",7) == 3259126003) strcat(s, "o");
if (crc32("cBySXDekU",9) == 3568621122) strcat(s, "t");
if (crc32("OMxVHhByb",9) == 2712038982) strcat(s, "i");
if (crc32("AxkNQRdLTx",10) == 2297488827) strcat(s, "o");
if (crc32("YylTGblem",9) == 2680913380) strcat(s, "h");
if (crc32("Iozyqqk",7) == 2843719459) strcat(s, "h");
if (crc32("fXGniwBT",8) == 3994704971) strcat(s, "a");
if (crc32("AomKyZat",8) == 2733270789) strcat(s, "r");
if (crc32("YlmTvQir",8) == 867835811) strcat(s, "n");
if (crc32("VHMyUVkSBE",10) == 2087769722) strcat(s, "Z");
if (crc32("qrUOShImP",9) == 622179290) strcat(s, "d");
    return s;
}

char *acerb_adjectives() {
    char *s = calloc(6);
    if (crc32("loohZNLEJzAIY",13) == 2223621521) strcat(s, "s");
if (crc32("kFEEgpA",7) == 2457437299) strcat(s, "a");
if (crc32("pTZNHpZHQ",9) == 862604223) strcat(s, "c");
if (crc32("sfLKBqHpanqod",13) == 2843532708) strcat(s, "H");
if (crc32("pippIzHHnK",10) == 72829691) strcat(s, "e");
if (crc32("cEAhgJuHvT",10) == 2463676743) strcat(s, "R");
if (crc32("EIPcEGzaFkDcf",13) == 3667481044) strcat(s, "r");
if (crc32("xlDZTotwgJxji",13) == 1481398753) strcat(s, "M");
if (crc32("EPrMiRQlJjAlX",13) == 3632855655) strcat(s, "b");
    return s;
}

char *uncombed_adjectives() {
    char *s = calloc(9);
    if (crc32("NvPIexvhu",9) == 3012224655) strcat(s, "u");
if (crc32("ESKFjmCVRjDo",12) == 17995672) strcat(s, "n");
if (crc32("xGUindYPvHnt",12) == 3087574257) strcat(s, "G");
if (crc32("YjeWxAgFnz",10) == 169191870) strcat(s, "c");
if (crc32("SYnRDZBi",8) == 4221035998) strcat(s, "o");
if (crc32("wQSJrqjmy",9) == 2125863479) strcat(s, "B");
if (crc32("uEOqYXukpDHy",12) == 180425371) strcat(s, "m");
if (crc32("fpZDxsqUQT",10) == 2485364249) strcat(s, "b");
if (crc32("kDjpNsGcdbJ",11) == 3890466021) strcat(s, "T");
if (crc32("FBVoxL",6) == 2140234205) strcat(s, "e");
if (crc32("sheJIRzFWLKjnE",14) == 8256634) strcat(s, "D");
if (crc32("HqqIK",5) == 3903081823) strcat(s, "d");
    return s;
}

char *infarcted_adjectives() {
    char *s = calloc(10);
    if (crc32("fCmZonlk",8) == 4071116635) strcat(s, "i");
if (crc32("qnLzSCiujRYsK",13) == 2298164220) strcat(s, "K");
if (crc32("LZNcJhmyRmRC",12) == 936362487) strcat(s, "n");
if (crc32("PaQyQTy",7) == 4096128532) strcat(s, "f");
if (crc32("gzJFFdFxWrc",11) == 3917049856) strcat(s, "r");
if (crc32("krqSenbWyVvlPuQ",15) == 697894412) strcat(s, "a");
if (crc32("wzGYNHRIggE",11) == 2613979722) strcat(s, "R");
if (crc32("IOrWerTkVygBmS",14) == 1439746436) strcat(s, "r");
if (crc32("GUprTDVNnDaFJqV",15) == 2837561982) strcat(s, "c");
if (crc32("Jijzw",5) == 1010130398) strcat(s, "L");
if (crc32("uRTzDLLpHZmE",12) == 1959180692) strcat(s, "t");
if (crc32("wmdYkpWk",8) == 419225890) strcat(s, "e");
if (crc32("luXTRcgRlZJvln",14) == 2787156395) strcat(s, "m");
if (crc32("cGxkhHwIumBWdU",14) == 403006429) strcat(s, "d");
    return s;
}

char *unhypnotic_adjectives() {
    char *s = calloc(11);
    if (crc32("niGnZWv",7) == 1019598690) strcat(s, "V");
if (crc32("UmuSvFbonmGBs",13) == 1751289148) strcat(s, "u");
if (crc32("cvbBeqSEOf",10) == 4226515354) strcat(s, "n");
if (crc32("gPGjAcuOwrmLe",13) == 87373329) strcat(s, "h");
if (crc32("goMYPSDdc",9) == 3342842551) strcat(s, "m");
if (crc32("PxKLtAdyvSLM",12) == 2222808905) strcat(s, "y");
if (crc32("yVOwRxmCJolc",12) == 2523198945) strcat(s, "d");
if (crc32("nibXeylFLsFrJHH",15) == 1434837288) strcat(s, "p");
if (crc32("ElRBAorri",9) == 2069257457) strcat(s, "n");
if (crc32("jhLjLJnlShNwkXR",15) == 3123656418) strcat(s, "o");
if (crc32("OjUDdkXS",8) == 1001384137) strcat(s, "t");
if (crc32("ByEXtFwxH",9) == 804151479) strcat(s, "i");
if (crc32("QIUMBJY",7) == 4086981475) strcat(s, "s");
if (crc32("CkfINf",6) == 2109810507) strcat(s, "c");
    return s;
}

char *prefatory_adjectives() {
    char *s = calloc(10);
    if (crc32("QSVACvrZaKzZajo",15) == 3984098345) strcat(s, "I");
if (crc32("frbRcJUNjjXbO",13) == 291027209) strcat(s, "p");
if (crc32("LSjcbCavO",9) == 417369695) strcat(s, "r");
if (crc32("bxEsMwBE",8) == 901087630) strcat(s, "e");
if (crc32("JOMnwacEtkRu",12) == 2261679755) strcat(s, "f");
if (crc32("ewtxQvMKo",9) == 1423695607) strcat(s, "a");
if (crc32("pUIpN",5) == 36916076) strcat(s, "t");
if (crc32("kYmrpXkrTZfDuD",14) == 4290276290) strcat(s, "p");
if (crc32("zFLbul",6) == 1075149542) strcat(s, "o");
if (crc32("jbRpr",5) == 2055418945) strcat(s, "r");
if (crc32("TMbNSq",6) == 3674318789) strcat(s, "y");
    return s;
}

char *unblamed_adjectives() {
    char *s = calloc(9);
    if (crc32("VVxiXPBQXrDmMQZ",15) == 4223825110) strcat(s, "r");
if (crc32("rYyoCrGRMr",10) == 2581531686) strcat(s, "u");
if (crc32("CmHgDfWV",8) == 3482735540) strcat(s, "n");
if (crc32("YUVyebSM",8) == 3365513377) strcat(s, "C");
if (crc32("vnYGIjJWc",9) == 1509250288) strcat(s, "b");
if (crc32("TFoqDBDlvXY",11) == 4098827503) strcat(s, "H");
if (crc32("BWfpsM",6) == 1067634312) strcat(s, "l");
if (crc32("lSGhDfxUNZNsQw",14) == 4199224663) strcat(s, "W");
if (crc32("onKLkCIfSoK",11) == 1664229386) strcat(s, "a");
if (crc32("ylSOQhkqhBKzZ",13) == 79051170) strcat(s, "m");
if (crc32("fDyDsxZrdSeLXw",14) == 2084101829) strcat(s, "H");
if (crc32("Csdbfl",6) == 248044854) strcat(s, "e");
if (crc32("JfJCIc",6) == 2047231274) strcat(s, "d");
    return s;
}

char *wellforested_adjectives() {
    char *s = calloc(13);
    if (crc32("wSohErTN",8) == 3647421872) strcat(s, "h");
if (crc32("vBbbP",5) == 4133369179) strcat(s, "w");
if (crc32("UKETy",5) == 4221269625) strcat(s, "e");
if (crc32("AKkagoCAbeRr",12) == 3848227883) strcat(s, "l");
if (crc32("TsmfBbWoTXQNtVl",15) == 1034163277) strcat(s, "l");
if (crc32("clyOJtOcgkkb",12) == 2557297275) strcat(s, "V");
if (crc32("qKYaYt",6) == 2644419736) strcat(s, "f");
if (crc32("cZpIBxuqoRwpm",13) == 961985913) strcat(s, "n");
if (crc32("YCTIsSKazf",10) == 3345995502) strcat(s, "o");
if (crc32("QTHnm",5) == 835325479) strcat(s, "r");
if (crc32("hLZkuXnlIFWN",12) == 2516243402) strcat(s, "e");
if (crc32("HEIuejk",7) == 4076912539) strcat(s, "t");
if (crc32("mzkanUpvpGdvNHT",15) == 1040484260) strcat(s, "s");
if (crc32("oyABs",5) == 2976649825) strcat(s, "t");
if (crc32("epKWQXsuvoMpQz",14) == 2866302149) strcat(s, "g");
if (crc32("yyZuGVdGUUkzM",13) == 3498488289) strcat(s, "e");
if (crc32("MdcXEbcihaZDUnd",15) == 2503206538) strcat(s, "R");
if (crc32("YEdpXbGzJkbDzE",14) == 3957264520) strcat(s, "d");
    return s;
}

char *sporadic_adjectives() {
    char *s = calloc(9);
    if (crc32("JpQuGSA",7) == 3393170057) strcat(s, "s");
if (crc32("FhaNpFpx",8) == 2016148800) strcat(s, "p");
if (crc32("wvmbcXFqlZD",11) == 2347574487) strcat(s, "C");
if (crc32("kFKZqykPkrIG",12) == 2897556125) strcat(s, "o");
if (crc32("uJMbo",5) == 445172785) strcat(s, "u");
if (crc32("yusFUmTKJxH",11) == 2126117333) strcat(s, "r");
if (crc32("WTRIrylH",8) == 264508881) strcat(s, "S");
if (crc32("tQQbQlJahMs",11) == 622852578) strcat(s, "a");
if (crc32("VMFjFpwG",8) == 4058422630) strcat(s, "s");
if (crc32("AnBYswGif",9) == 1060438512) strcat(s, "d");
if (crc32("CmRPCNlxlsfS",12) == 2347471499) strcat(s, "i");
if (crc32("jRoOiHhrWUE",11) == 715277958) strcat(s, "c");
    return s;
}

char *hypaethral_adjectives() {
    char *s = calloc(11);
    if (crc32("SJEVchKgSiXr",12) == 2271975527) strcat(s, "h");
if (crc32("aKXnY",5) == 105705142) strcat(s, "K");
if (crc32("GRitZErQQIb",11) == 908395921) strcat(s, "y");
if (crc32("BIKmzmHYcxUKaa",14) == 272261092) strcat(s, "p");
if (crc32("acGSUUFmjowNzm",14) == 1823380478) strcat(s, "a");
if (crc32("DwOakaMagDmY",12) == 525495989) strcat(s, "e");
if (crc32("WYEyPy",6) == 4056046410) strcat(s, "t");
if (crc32("gNRuIHeadBrpw",13) == 3976161158) strcat(s, "h");
if (crc32("cmnuPVrx",8) == 838921051) strcat(s, "r");
if (crc32("FxSDgpGowAI",11) == 764801931) strcat(s, "a");
if (crc32("bDCnBSaWtNA",11) == 3671203747) strcat(s, "Y");
if (crc32("DuOmZBESl",9) == 1737747286) strcat(s, "l");
    return s;
}

char *slipover_adjectives() {
    char *s = calloc(9);
    if (crc32("AYSIUp",6) == 1912544254) strcat(s, "s");
if (crc32("EgbVWt",6) == 2196697319) strcat(s, "b");
if (crc32("HSFKkeDUsJnLwbV",15) == 254752790) strcat(s, "l");
if (crc32("NFEeVdQrW",9) == 67477605) strcat(s, "i");
if (crc32("xQlBAkPhHqie",12) == 2418156901) strcat(s, "i");
if (crc32("DAwcUAYdgMV",11) == 2239170926) strcat(s, "d");
if (crc32("cZUvE",5) == 2846134898) strcat(s, "p");
if (crc32("QgJpv",5) == 2398386997) strcat(s, "o");
if (crc32("zQblcI",6) == 2375958363) strcat(s, "E");
if (crc32("mGAaERVmJb",10) == 2945688792) strcat(s, "v");
if (crc32("ITfUjmCEVI",10) == 2717048846) strcat(s, "j");
if (crc32("sHiMuJKUd",9) == 1290836981) strcat(s, "e");
if (crc32("fQsJuV",6) == 3034212402) strcat(s, "g");
if (crc32("pRrTWCVggwnPs",13) == 2074120651) strcat(s, "r");
    return s;
}

char *tetrandrous_adjectives() {
    char *s = calloc(12);
    if (crc32("qClNZIanx",9) == 2811073878) strcat(s, "t");
if (crc32("QZMHkDYMhkqyJ",13) == 2276473462) strcat(s, "J");
if (crc32("ahcvAuCkpSgML",13) == 2917720913) strcat(s, "e");
if (crc32("ZRnxKjblYb",10) == 3788960613) strcat(s, "K");
if (crc32("oFCGLXqnTsVP",12) == 3451303479) strcat(s, "t");
if (crc32("PRBejc",6) == 1922228541) strcat(s, "g");
if (crc32("eVmudAG",7) == 3983703311) strcat(s, "r");
if (crc32("XzmTWtmqyWPUh",13) == 3902003544) strcat(s, "f");
if (crc32("qeTQMuA",7) == 448362978) strcat(s, "a");
if (crc32("KDToRMTttKyXzxD",15) == 217866080) strcat(s, "n");
if (crc32("uqGsEMDVrjLsHU",14) == 1880015249) strcat(s, "d");
if (crc32("WbHnzhxMba",10) == 937255496) strcat(s, "R");
if (crc32("wblMWPAgxjVSo",13) == 807093317) strcat(s, "r");
if (crc32("EylDMcXqGXJahEd",15) == 846948799) strcat(s, "o");
if (crc32("spIGyorxWRbvNi",14) == 3742617263) strcat(s, "u");
if (crc32("OSzlTlOZ",8) == 2284063096) strcat(s, "s");
    return s;
}

char *phlegmless_adjectives() {
    char *s = calloc(11);
    if (crc32("JNpMy",5) == 111778567) strcat(s, "P");
if (crc32("ppVpOe",6) == 3013391006) strcat(s, "p");
if (crc32("aenXDtJBn",9) == 1215855152) strcat(s, "Y");
if (crc32("mYnWnQoh",8) == 935846179) strcat(s, "h");
if (crc32("XAMHNOAhPbjtYf",14) == 2620672131) strcat(s, "l");
if (crc32("QOkRauCqf",9) == 1062566414) strcat(s, "n");
if (crc32("oJoiTUXEKVFu",12) == 3086981886) strcat(s, "e");
if (crc32("sdhqepjd",8) == 4062145849) strcat(s, "Z");
if (crc32("sZNvHWyrK",9) == 3153072232) strcat(s, "g");
if (crc32("iuUoTxosSpE",11) == 1946161221) strcat(s, "m");
if (crc32("zTOGvBuLguBuRZ",14) == 3051406391) strcat(s, "l");
if (crc32("fOPYXYqcj",9) == 964426286) strcat(s, "l");
if (crc32("YydUFDulphfe",12) == 3180166099) strcat(s, "z");
if (crc32("tQDqDnbPm",9) == 378657639) strcat(s, "e");
if (crc32("NBBdeTwbhPb",11) == 3586637610) strcat(s, "k");
if (crc32("mPVCQ",5) == 3280233701) strcat(s, "s");
if (crc32("izykUQGUPd",10) == 2845801962) strcat(s, "b");
if (crc32("CLAtqmdLrgiP",12) == 3947538055) strcat(s, "s");
    return s;
}

char *interverbal_adjectives() {
    char *s = calloc(12);
    if (crc32("tgTtttwIFiGHC",13) == 1752287435) strcat(s, "Q");
if (crc32("VQNmeaSTk",9) == 1721111960) strcat(s, "i");
if (crc32("DjpyZEa",7) == 4293604231) strcat(s, "Z");
if (crc32("flbuoQuKQfCWo",13) == 342782404) strcat(s, "n");
if (crc32("AoNgKlExiiftuXU",15) == 1218055191) strcat(s, "t");
if (crc32("OTqUupR",7) == 2016494965) strcat(s, "e");
if (crc32("TprqPUwHth",10) == 2073729386) strcat(s, "r");
if (crc32("qvXNgZQ",7) == 226968586) strcat(s, "f");
if (crc32("YPfTvhJcNzgo",12) == 651551416) strcat(s, "v");
if (crc32("EkqLBvNVDRYWMB",14) == 791355325) strcat(s, "e");
if (crc32("TphJbeWENnuj",12) == 1064558545) strcat(s, "r");
if (crc32("KVoeVdjLJpK",11) == 1395247538) strcat(s, "b");
if (crc32("YLnemNeHSMmzcY",14) == 50306315) strcat(s, "F");
if (crc32("RuFLcRYGShIGJ",13) == 1637250112) strcat(s, "a");
if (crc32("USiEHe",6) == 2805279364) strcat(s, "l");
    return s;
}

char *clerical_adjectives() {
    char *s = calloc(9);
    if (crc32("vmtTjLjZojbUwBB",15) == 2204651359) strcat(s, "h");
if (crc32("aDrhHVRNXXocFB",14) == 4021441799) strcat(s, "c");
if (crc32("kqURud",6) == 2621422329) strcat(s, "l");
if (crc32("PKOZkEs",7) == 1575139025) strcat(s, "v");
if (crc32("WoDuNlmcqW",10) == 24752062) strcat(s, "e");
if (crc32("sSHVEmJBpQWOyPb",15) == 747358220) strcat(s, "r");
if (crc32("MAwRZ",5) == 245006694) strcat(s, "x");
if (crc32("XpzAFKzDauLDW",13) == 4039447051) strcat(s, "i");
if (crc32("ySRQMTNAdFTClsB",15) == 2954827278) strcat(s, "G");
if (crc32("QGmVKVrFgrM",11) == 1778300600) strcat(s, "c");
if (crc32("vClljI",6) == 2083147390) strcat(s, "k");
if (crc32("sknqZRqRkeIXva",14) == 2195738309) strcat(s, "a");
if (crc32("JglkG",5) == 1575758932) strcat(s, "l");
    return s;
}

char *horizontal_adjectives() {
    char *s = calloc(11);
    if (crc32("kDkHXRKgR",9) == 961816516) strcat(s, "d");
if (crc32("vHoeqFBvugIB",12) == 822261625) strcat(s, "h");
if (crc32("LTQLsCwhdBHaZYR",15) == 2155611398) strcat(s, "b");
if (crc32("XtmrlDFLgp",10) == 3139208906) strcat(s, "o");
if (crc32("lsjHLuKUKlBrR",13) == 3973466783) strcat(s, "W");
if (crc32("CyXpsJSdrtQx",12) == 2828787808) strcat(s, "r");
if (crc32("TfJrD",5) == 48532700) strcat(s, "K");
if (crc32("pBlpLu",6) == 3245408794) strcat(s, "i");
if (crc32("VNjoyFnDPb",10) == 3828192565) strcat(s, "Q");
if (crc32("UrVSrJoGdvk",11) == 1853699258) strcat(s, "z");
if (crc32("IPPFkqOPMbSpwvt",15) == 2938764076) strcat(s, "o");
if (crc32("NhdejtLw",8) == 3054865208) strcat(s, "n");
if (crc32("eqNekQIcTY",10) == 3517499749) strcat(s, "t");
if (crc32("efZVlWH",7) == 3401246490) strcat(s, "a");
if (crc32("FBtgWqQgtTJBj",13) == 2052192280) strcat(s, "c");
if (crc32("SVFbGnlRdGrel",13) == 2429880764) strcat(s, "l");
    return s;
}

char *incapable_adjectives() {
    char *s = calloc(10);
    if (crc32("mLrnBCITQSFLVft",15) == 1721949218) strcat(s, "R");
if (crc32("WZbJPOBYeFcY",12) == 2214034020) strcat(s, "i");
if (crc32("ocKUcMIvAfZtAs",14) == 2641169616) strcat(s, "l");
if (crc32("WNHeyDWgPGRrqRM",15) == 2794158738) strcat(s, "n");
if (crc32("SpkNXix",7) == 2568232495) strcat(s, "c");
if (crc32("AdvXdkF",7) == 3258379240) strcat(s, "a");
if (crc32("ORRWpq",6) == 232080113) strcat(s, "p");
if (crc32("eImluF",6) == 2279911863) strcat(s, "w");
if (crc32("htpGETyrdHbI",12) == 3692344328) strcat(s, "a");
if (crc32("WtCJulWRrEcFfSI",15) == 944153790) strcat(s, "b");
if (crc32("HaVnbDwWMzb",11) == 1588356423) strcat(s, "s");
if (crc32("yGIYQh",6) == 310705668) strcat(s, "l");
if (crc32("eeuNS",5) == 3354442582) strcat(s, "G");
if (crc32("lWpMb",5) == 2124415782) strcat(s, "e");
    return s;
}

char *ungassed_adjectives() {
    char *s = calloc(9);
    if (crc32("xPoJtqhkO",9) == 3524683424) strcat(s, "u");
if (crc32("SIyOWCOTgakU",12) == 4247991886) strcat(s, "n");
if (crc32("NWnObRGtqSUFjv",14) == 2715900098) strcat(s, "G");
if (crc32("bqdvSkDO",8) == 3074992542) strcat(s, "g");
if (crc32("iaMjVKRnfuu",11) == 2449517335) strcat(s, "a");
if (crc32("KhnjVX",6) == 1274590255) strcat(s, "Z");
if (crc32("kAvWnVU",7) == 1161332063) strcat(s, "s");
if (crc32("MvOoxTPGrp",10) == 3747352356) strcat(s, "B");
if (crc32("MWQPHMW",7) == 2836673334) strcat(s, "s");
if (crc32("iHysJnpcXoQtM",13) == 2551410789) strcat(s, "o");
if (crc32("NIdqoSEut",9) == 3366425602) strcat(s, "e");
if (crc32("QrAztrvpC",9) == 2019742778) strcat(s, "d");
    return s;
}

char *transJovian_adjectives() {
    char *s = calloc(12);
    if (crc32("abtnSe",6) == 2613187536) strcat(s, "t");
if (crc32("nDSIDcuEIUGNW",13) == 809034397) strcat(s, "r");
if (crc32("tmslFakyKM",10) == 3848677575) strcat(s, "M");
if (crc32("mQMvnfxwcHHjP",13) == 1186555943) strcat(s, "a");
if (crc32("atZNcZB",7) == 3143749511) strcat(s, "n");
if (crc32("XPYQpDwcRqXwu",13) == 2090214414) strcat(s, "s");
if (crc32("iynvBmbYsR",10) == 3993230720) strcat(s, "q");
if (crc32("ODyjaZoXKUD",11) == 4226864970) strcat(s, "J");
if (crc32("pQgATYcAtuP",11) == 869195449) strcat(s, "L");
if (crc32("nHTgKZDKPnJ",11) == 443292142) strcat(s, "o");
if (crc32("dqCibLRT",8) == 4240662540) strcat(s, "R");
if (crc32("vVHKFX",6) == 974542498) strcat(s, "v");
if (crc32("rRXtmHYBz",9) == 2166784245) strcat(s, "i");
if (crc32("lTzNvQGWpMahn",13) == 1607916688) strcat(s, "c");
if (crc32("PpThuEXwtxB",11) == 4198640022) strcat(s, "a");
if (crc32("tTYjrgEXSaFLJFe",15) == 1819095551) strcat(s, "B");
if (crc32("lblXsSNiziZLXux",15) == 1429826338) strcat(s, "n");
    return s;
}

char *psychotic_adjectives() {
    char *s = calloc(10);
    if (crc32("DvnLG",5) == 3543712964) strcat(s, "p");
if (crc32("iARQhWLtNB",10) == 259448612) strcat(s, "S");
if (crc32("vfpiw",5) == 2152863372) strcat(s, "s");
if (crc32("oEVTmkH",7) == 4041521634) strcat(s, "A");
if (crc32("WiNDFYNe",8) == 855530647) strcat(s, "y");
if (crc32("uWBOpRmgreP",11) == 4283171690) strcat(s, "Y");
if (crc32("blqhpovnS",9) == 2123828175) strcat(s, "c");
if (crc32("dvitOVNbPvSLwSH",15) == 1052916169) strcat(s, "h");
if (crc32("RusEGtWm",8) == 312016931) strcat(s, "E");
if (crc32("WEiDRJzdNOT",11) == 1674207492) strcat(s, "o");
if (crc32("XgbrKPSaN",9) == 3359141638) strcat(s, "t");
if (crc32("gdCLFq",6) == 3803255861) strcat(s, "I");
if (crc32("KsFrEtFdgy",10) == 2046356588) strcat(s, "i");
if (crc32("LXWzmnG",7) == 593679267) strcat(s, "c");
    return s;
}

char *palaeontological_adjectives() {
    char *s = calloc(17);
    if (crc32("wvJdDf",6) == 3433323601) strcat(s, "D");
if (crc32("qHqwZ",5) == 3804437260) strcat(s, "p");
if (crc32("inSAKwghBoYjoLi",15) == 19417633) strcat(s, "a");
if (crc32("CxjOIXhwm",9) == 2756776142) strcat(s, "p");
if (crc32("ZtinYUP",7) == 174808710) strcat(s, "l");
if (crc32("oOZmVk",6) == 3739838750) strcat(s, "O");
if (crc32("ZbsITddqR",9) == 3810851678) strcat(s, "a");
if (crc32("TdQKhGDmGQy",11) == 913994229) strcat(s, "D");
if (crc32("iQoCPS",6) == 3255472284) strcat(s, "e");
if (crc32("vCquwNrYOLOLE",13) == 1828644879) strcat(s, "M");
if (crc32("MYdmir",6) == 3380145522) strcat(s, "o");
if (crc32("EdKRsIPpKoQ",11) == 3959292519) strcat(s, "o");
if (crc32("gtaVDBHzHVw",11) == 4148630363) strcat(s, "n");
if (crc32("TsigaXTqVekLOu",14) == 29791138) strcat(s, "t");
if (crc32("RSZEsomWguYM",12) == 2254303745) strcat(s, "o");
if (crc32("wMqTIAl",7) == 1435868315) strcat(s, "l");
if (crc32("jYzUfYHQXd",10) == 946345993) strcat(s, "n");
if (crc32("GgOwGU",6) == 3195894317) strcat(s, "o");
if (crc32("cwBKnRiclFOGfK",14) == 3847179049) strcat(s, "g");
if (crc32("EByajsDwpuKQkG",14) == 720504704) strcat(s, "l");
if (crc32("OjfMHOgwHkboyZ",14) == 4246786208) strcat(s, "i");
if (crc32("sXVkxxn",7) == 3437980063) strcat(s, "o");
if (crc32("yjZMPvR",7) == 3331518760) strcat(s, "c");
if (crc32("FCJKVdnXq",9) == 1940463629) strcat(s, "e");
if (crc32("kxCzkVhTQQxZqO",14) == 2286204614) strcat(s, "a");
if (crc32("zQLVvskIAfaSdlj",15) == 1899141812) strcat(s, "l");
    return s;
}

char *stanzaed_adjectives() {
    char *s = calloc(9);
    if (crc32("XWaMjkki",8) == 2351778062) strcat(s, "D");
if (crc32("SwShKqBG",8) == 2278402003) strcat(s, "s");
if (crc32("ayfleiD",7) == 1764047892) strcat(s, "C");
if (crc32("LyiQCgzoDdHHA",13) == 1050788440) strcat(s, "t");
if (crc32("KFUAkiBq",8) == 2898961855) strcat(s, "j");
if (crc32("RxPpyXjroTmkMx",14) == 1854731889) strcat(s, "a");
if (crc32("MRGuxFb",7) == 2485591610) strcat(s, "m");
if (crc32("gChmDVKSiGZRG",13) == 3134833042) strcat(s, "n");
if (crc32("OOQxM",5) == 3654091047) strcat(s, "R");
if (crc32("hbIwTfEWX",9) == 1628242349) strcat(s, "z");
if (crc32("JEqcw",5) == 2905194854) strcat(s, "a");
if (crc32("WwTqaxFCOFjLzpa",15) == 1619391255) strcat(s, "e");
if (crc32("etLnMWj",7) == 3667435020) strcat(s, "l");
if (crc32("KYZPFcCP",8) == 1984919110) strcat(s, "d");
    return s;
}

char *uncouth_adjectives() {
    char *s = calloc(8);
    if (crc32("CkmJgahGl",9) == 2321408502) strcat(s, "N");
if (crc32("WMRBxa",6) == 3479386531) strcat(s, "u");
if (crc32("rGWHomsRGaMoV",13) == 1750814609) strcat(s, "n");
if (crc32("QJqrlD",6) == 1482481916) strcat(s, "c");
if (crc32("vjuyTVLH",8) == 2271430981) strcat(s, "o");
if (crc32("MpHOKKAXagO",11) == 1488625631) strcat(s, "n");
if (crc32("FhCUv",5) == 3816147865) strcat(s, "u");
if (crc32("cFyTg",5) == 4042179093) strcat(s, "t");
if (crc32("mNHoxw",6) == 3603411105) strcat(s, "h");
    return s;
}

char *halfeaten_adjectives() {
    char *s = calloc(10);
    if (crc32("gJzyVOzjb",9) == 328198485) strcat(s, "h");
if (crc32("LmtwCXfGh",9) == 983571064) strcat(s, "a");
if (crc32("gZuqVNTywbAHfov",15) == 799323533) strcat(s, "l");
if (crc32("BOZDXYyqWc",10) == 3151494265) strcat(s, "f");
if (crc32("haBRbHnNhFbVm",13) == 1041004103) strcat(s, "e");
if (crc32("rZUzWDHwVY",10) == 1663998774) strcat(s, "e");
if (crc32("foIdhbz",7) == 3436202717) strcat(s, "a");
if (crc32("RqedEOsDP",9) == 1779519728) strcat(s, "t");
if (crc32("BDJAYCOjuZbp",12) == 2842678989) strcat(s, "e");
if (crc32("tukBf",5) == 3029150871) strcat(s, "n");
    return s;
}

char *unprecipitated_adjectives() {
    char *s = calloc(15);
    if (crc32("LqNllqhyloF",11) == 809513957) strcat(s, "u");
if (crc32("WHizCY",6) == 3572043757) strcat(s, "e");
if (crc32("IoJSBtzdkxONO",13) == 3109756418) strcat(s, "n");
if (crc32("GfhLrcWPERw",11) == 1435502916) strcat(s, "p");
if (crc32("GtprWEHRtFrIS",13) == 1430985894) strcat(s, "x");
if (crc32("eGucmXAiPxNUNJ",14) == 1443693807) strcat(s, "r");
if (crc32("SGmxrbYFM",9) == 1551912150) strcat(s, "e");
if (crc32("OPOprhAlehtYFIG",15) == 2880633244) strcat(s, "P");
if (crc32("VPbvkUa",7) == 3317304439) strcat(s, "c");
if (crc32("DPjPzMO",7) == 3288032866) strcat(s, "i");
if (crc32("jAbILNQWv",9) == 892777660) strcat(s, "g");
if (crc32("KMuUeEjuttIKgN",14) == 1908532406) strcat(s, "p");
if (crc32("GNeiODgKl",9) == 2080301351) strcat(s, "w");
if (crc32("ghrySqCjNMzZEhg",15) == 876816088) strcat(s, "i");
if (crc32("aASumzDOO",9) == 2194011569) strcat(s, "t");
if (crc32("SGSXAFIGKwcJt",13) == 324739975) strcat(s, "z");
if (crc32("GYVwSLpLPZE",11) == 516006001) strcat(s, "a");
if (crc32("HXvhX",5) == 2995910108) strcat(s, "b");
if (crc32("qnilr",5) == 3912006214) strcat(s, "t");
if (crc32("brYaOFs",7) == 1709117788) strcat(s, "e");
if (crc32("ixfrlja",7) == 1461539769) strcat(s, "d");
    return s;
}

char *puggish_adjectives() {
    char *s = calloc(8);
    if (crc32("WOkzAmDT",8) == 3261554454) strcat(s, "p");
if (crc32("zQXGiBoZ",8) == 638743805) strcat(s, "L");
if (crc32("inFDFKVzNImKnoj",15) == 4063556384) strcat(s, "u");
if (crc32("LlhWKXsWGtZs",12) == 3000204421) strcat(s, "d");
if (crc32("mMSGhaaEkZGXgdz",15) == 2908458113) strcat(s, "g");
if (crc32("fRrLGKoAELd",11) == 1420878719) strcat(s, "D");
if (crc32("MZSrLtDoUIg",11) == 955497777) strcat(s, "g");
if (crc32("bBhiAPwLxOb",11) == 722605714) strcat(s, "i");
if (crc32("ouMdkoZ",7) == 1184783241) strcat(s, "f");
if (crc32("zLuvgnQz",8) == 28055942) strcat(s, "s");
if (crc32("oIrMMmm",7) == 862460852) strcat(s, "z");
if (crc32("bATNA",5) == 49052041) strcat(s, "h");
    return s;
}

char *unrefitted_adjectives() {
    char *s = calloc(11);
    if (crc32("xeHgIPeRJwNC",12) == 1083023326) strcat(s, "S");
if (crc32("DSqqwVRlLg",10) == 457637379) strcat(s, "u");
if (crc32("MBDRaDQnssX",11) == 2397817247) strcat(s, "D");
if (crc32("SavtkVwcDnary",13) == 6945571) strcat(s, "n");
if (crc32("vRAHE",5) == 2673308202) strcat(s, "y");
if (crc32("LoEpO",5) == 2271858652) strcat(s, "r");
if (crc32("hRfRSXNvdaQaBF",14) == 2489238003) strcat(s, "K");
if (crc32("zDHQWOAuNLxho",13) == 3308289553) strcat(s, "e");
if (crc32("UkEIDydv",8) == 209878316) strcat(s, "f");
if (crc32("tTuNzpaBiVGjX",13) == 1393157807) strcat(s, "Y");
if (crc32("bOqVneGosT",10) == 1497167928) strcat(s, "i");
if (crc32("eGcTXYhkgPSu",12) == 1825616822) strcat(s, "V");
if (crc32("eMJIvBKK",8) == 3961314821) strcat(s, "t");
if (crc32("wJpZv",5) == 2295818287) strcat(s, "Z");
if (crc32("EjQGGvLWvzMDaXg",15) == 4202089155) strcat(s, "t");
if (crc32("jqrzKJpfNwD",11) == 2889585242) strcat(s, "z");
if (crc32("eFfPkvQrR",9) == 2923674672) strcat(s, "e");
if (crc32("QrVtIXQQghn",11) == 1517127423) strcat(s, "j");
if (crc32("QkJvKHqjcrfRgx",14) == 168801833) strcat(s, "d");
    return s;
}

char *discussional_adjectives() {
    char *s = calloc(13);
    if (crc32("qmqqXcUSXa",10) == 2574894174) strcat(s, "d");
if (crc32("DyjwGTRGQs",10) == 3784092628) strcat(s, "i");
if (crc32("qiyPkKWmMZOdQ",13) == 3359301643) strcat(s, "D");
if (crc32("EYTGPTbkSamNzi",14) == 2883287558) strcat(s, "s");
if (crc32("PnkcZkAnRL",10) == 739366991) strcat(s, "c");
if (crc32("WgkCB",5) == 2137360137) strcat(s, "g");
if (crc32("LfOTbCB",7) == 1450399853) strcat(s, "u");
if (crc32("uQXKsEM",7) == 1254740441) strcat(s, "L");
if (crc32("GCjLPYZDUxtFwk",14) == 1196276417) strcat(s, "s");
if (crc32("vWTlhmmhGSEat",13) == 803884159) strcat(s, "W");
if (crc32("lGcTOdLegnG",11) == 388914317) strcat(s, "s");
if (crc32("ydMqcj",6) == 782704258) strcat(s, "i");
if (crc32("qxcgoblRNH",10) == 3010114240) strcat(s, "o");
if (crc32("HHwAz",5) == 3413351351) strcat(s, "K");
if (crc32("wBZVZBk",7) == 334635929) strcat(s, "n");
if (crc32("MpgrFRYKcwLFer",14) == 1647043339) strcat(s, "a");
if (crc32("TzyBBEzHxW",10) == 3960618643) strcat(s, "l");
    return s;
}

char *subappressed_adjectives() {
    char *s = calloc(13);
    if (crc32("ajpUBUyXSY",10) == 2357577607) strcat(s, "s");
if (crc32("rixYRvUspaKzAR",14) == 2492808219) strcat(s, "x");
if (crc32("zvlVYrMbR",9) == 564390474) strcat(s, "u");
if (crc32("dadokmsLApVu",12) == 1469184781) strcat(s, "g");
if (crc32("RQkoBJ",6) == 236820274) strcat(s, "b");
if (crc32("NIfplcboZCLyU",13) == 3443231081) strcat(s, "a");
if (crc32("LbaZr",5) == 2101639428) strcat(s, "p");
if (crc32("YanVTK",6) == 2962768243) strcat(s, "v");
if (crc32("WzTbjWELamUg",12) == 1603346601) strcat(s, "p");
if (crc32("eFeNYLLEvn",10) == 932031426) strcat(s, "r");
if (crc32("cDhtU",5) == 2859197479) strcat(s, "m");
if (crc32("pBajt",5) == 2407665787) strcat(s, "e");
if (crc32("rjsIWac",7) == 3203568584) strcat(s, "g");
if (crc32("QAOpYlL",7) == 3088693151) strcat(s, "s");
if (crc32("IjRbzSsVIvDmnRZ",15) == 3809810045) strcat(s, "A");
if (crc32("JJdQUWekNhtgUa",14) == 3348849889) strcat(s, "s");
if (crc32("VCNHqQcWEvktPt",14) == 522458764) strcat(s, "M");
if (crc32("TLMacvXmq",9) == 1422508709) strcat(s, "e");
if (crc32("kONIBpdDUTjBPMr",15) == 3317275489) strcat(s, "K");
if (crc32("dIfosjaEZ",9) == 1708979797) strcat(s, "d");
    return s;
}

char *neat_adjectives() {
    char *s = calloc(5);
    if (crc32("SGcaeX",6) == 2098163048) strcat(s, "u");
if (crc32("LQvACh",6) == 1796890836) strcat(s, "n");
if (crc32("DNVZrYIyur",10) == 1425113914) strcat(s, "e");
if (crc32("RZcTdO",6) == 1347756144) strcat(s, "E");
if (crc32("JIzUEIMOT",9) == 2593540842) strcat(s, "a");
if (crc32("uZrApAW",7) == 1712281047) strcat(s, "t");
    return s;
}

char *nonlevel_adjectives() {
    char *s = calloc(9);
    if (crc32("nTvPQw",6) == 25624568) strcat(s, "n");
if (crc32("aYMZRwUV",8) == 462112481) strcat(s, "w");
if (crc32("oNTwVDp",7) == 1117442175) strcat(s, "o");
if (crc32("ywyWLrLZkHJtF",13) == 1571724671) strcat(s, "n");
if (crc32("xCghr",5) == 2475419203) strcat(s, "T");
if (crc32("qDatZO",6) == 2862233723) strcat(s, "l");
if (crc32("kWZpu",5) == 274846073) strcat(s, "e");
if (crc32("zYPZLXBm",8) == 3539175719) strcat(s, "v");
if (crc32("QdAazLOeiV",10) == 2807717386) strcat(s, "M");
if (crc32("lthpV",5) == 2504936757) strcat(s, "e");
if (crc32("fpaKHkFxhZYN",12) == 1446696643) strcat(s, "z");
if (crc32("BpxqCBawbJRns",13) == 1456815865) strcat(s, "l");
    return s;
}

char *intermissive_adjectives() {
    char *s = calloc(13);
    if (crc32("OlhCwuZxzz",10) == 3478862481) strcat(s, "d");
if (crc32("WbbhbRQuUt",10) == 1451234707) strcat(s, "i");
if (crc32("vnQlbpjQ",8) == 153388111) strcat(s, "n");
if (crc32("hnbGqmPWmlZbxx",14) == 3854624825) strcat(s, "V");
if (crc32("PIauF",5) == 2630870880) strcat(s, "t");
if (crc32("ewePSX",6) == 913046853) strcat(s, "e");
if (crc32("LIYLIGT",7) == 3700673559) strcat(s, "c");
if (crc32("dUFdrQkgW",9) == 627896885) strcat(s, "r");
if (crc32("hAkGpKQEuwTcBRm",15) == 2355613471) strcat(s, "m");
if (crc32("JwtqgYmktGArWW",14) == 3163495348) strcat(s, "m");
if (crc32("aYgJg",5) == 1919990425) strcat(s, "E");
if (crc32("veelEYq",7) == 1357249692) strcat(s, "i");
if (crc32("oOYpQwAjtxDaEg",14) == 3085253647) strcat(s, "X");
if (crc32("wObzxVXiiVz",11) == 3422574001) strcat(s, "s");
if (crc32("GAPCpqNb",8) == 215745832) strcat(s, "x");
if (crc32("zsYPTsBoDXkORi",14) == 4019064305) strcat(s, "s");
if (crc32("WVoujrl",7) == 4194773870) strcat(s, "i");
if (crc32("woIkhRLcBEZBjO",14) == 2156737899) strcat(s, "F");
if (crc32("OxDcfSU",7) == 2322853720) strcat(s, "v");
if (crc32("pIJzksTik",9) == 4164463953) strcat(s, "e");
    return s;
}

char *ingenious_adjectives() {
    char *s = calloc(10);
    if (crc32("BoTjT",5) == 536185805) strcat(s, "i");
if (crc32("dYDaXRs",7) == 737610947) strcat(s, "e");
if (crc32("cIaMuT",6) == 2950131908) strcat(s, "n");
if (crc32("fcxJHMAeaF",10) == 148282651) strcat(s, "g");
if (crc32("mFLgk",5) == 409794667) strcat(s, "y");
if (crc32("dFkvnkq",7) == 2019619337) strcat(s, "e");
if (crc32("EtZcFuet",8) == 3224217999) strcat(s, "q");
if (crc32("TMpsEQdIIOsBtMN",15) == 762864832) strcat(s, "n");
if (crc32("NlVhdgnySZ",10) == 3073099904) strcat(s, "e");
if (crc32("KJqqf",5) == 3664685217) strcat(s, "i");
if (crc32("YhlOdQZS",8) == 1052990501) strcat(s, "D");
if (crc32("BJaBDtvKbuQQTS",14) == 2603926648) strcat(s, "o");
if (crc32("vxvxNKjLaXhl",12) == 34442821) strcat(s, "u");
if (crc32("rwdEU",5) == 1779016016) strcat(s, "s");
    return s;
}

char *Algoman_adjectives() {
    char *s = calloc(8);
    if (crc32("kdMJPuJcE",9) == 462593044) strcat(s, "h");
if (crc32("PsIjgrrKZLPSyI",14) == 3476330720) strcat(s, "A");
if (crc32("frfPHvHBm",9) == 1795099543) strcat(s, "l");
if (crc32("fENFMtzphw",10) == 1008253104) strcat(s, "g");
if (crc32("qeNxG",5) == 139325877) strcat(s, "v");
if (crc32("aWEERZBHYxjt",12) == 3944288614) strcat(s, "o");
if (crc32("VRaQmDcgPxOUeO",14) == 1219794311) strcat(s, "m");
if (crc32("yxkpqJQhJJhnRz",14) == 876547610) strcat(s, "o");
if (crc32("xgqthpiHLSo",11) == 2675784184) strcat(s, "a");
if (crc32("WREcwrXwJh",10) == 3154681837) strcat(s, "n");
    return s;
}

char *stintless_adjectives() {
    char *s = calloc(10);
    if (crc32("GdVRWWcNmzkKO",13) == 3684970778) strcat(s, "s");
if (crc32("HmgozSxlgdj",11) == 3918556797) strcat(s, "v");
if (crc32("GniQuy",6) == 3579636350) strcat(s, "t");
if (crc32("JxpuVm",6) == 3943602947) strcat(s, "h");
if (crc32("KfPEPorG",8) == 404351803) strcat(s, "i");
if (crc32("ClyQgSZzvKG",11) == 857302421) strcat(s, "n");
if (crc32("mpfQUhiXzEy",11) == 1109066293) strcat(s, "t");
if (crc32("SQYjMBU",7) == 2283264948) strcat(s, "l");
if (crc32("opTtYrID",8) == 2864069736) strcat(s, "e");
if (crc32("IPBhNCtIepolu",13) == 1416668356) strcat(s, "s");
if (crc32("privUHxvIhX",11) == 1596558635) strcat(s, "s");
    return s;
}

char *clubby_adjectives() {
    char *s = calloc(7);
    if (crc32("GybrGTKAPHmT",12) == 3107865203) strcat(s, "W");
if (crc32("XnNRWMQDqfDAa",13) == 1866089432) strcat(s, "c");
if (crc32("UGaLnpvXjLrfPH",14) == 3816618589) strcat(s, "l");
if (crc32("YkiXNDQtMmpOq",13) == 2795917132) strcat(s, "B");
if (crc32("SPcnexEyflL",11) == 3521366314) strcat(s, "u");
if (crc32("RBGCtYywmT",10) == 2799190587) strcat(s, "b");
if (crc32("mUcHxWJKnubgCcl",15) == 3524458768) strcat(s, "b");
if (crc32("bszkdOzSNXvgW",13) == 1375770118) strcat(s, "y");
    return s;
}

char *cauterant_adjectives() {
    char *s = calloc(10);
    if (crc32("ZpVvDkuu",8) == 3275423074) strcat(s, "c");
if (crc32("vbcsNSnR",8) == 1208759375) strcat(s, "a");
if (crc32("CctiRQe",7) == 3534437415) strcat(s, "T");
if (crc32("UlQOc",5) == 2298861746) strcat(s, "u");
if (crc32("QndGnbIOoWSt",12) == 256461441) strcat(s, "Q");
if (crc32("uYKqjjmDLQ",10) == 2539781338) strcat(s, "t");
if (crc32("AmtVEXyMdi",10) == 1539160307) strcat(s, "e");
if (crc32("MNHZDgPtpmeqJib",15) == 3862969457) strcat(s, "R");
if (crc32("clyEXZfaNaaE",12) == 3550026146) strcat(s, "r");
if (crc32("qMGiaGyehUdtNb",14) == 2217340424) strcat(s, "I");
if (crc32("upQfmxLkKoRO",12) == 600891579) strcat(s, "a");
if (crc32("uVisWGPwQ",9) == 3232943504) strcat(s, "n");
if (crc32("orEDoicBR",9) == 1504439969) strcat(s, "t");
    return s;
}

char *anaphrodisiac_adjectives() {
    char *s = calloc(14);
    if (crc32("BJJPgJoHij",10) == 2891628139) strcat(s, "y");
if (crc32("hfyEdnp",7) == 1194676195) strcat(s, "a");
if (crc32("qvFXfNSOhCZp",12) == 1184185731) strcat(s, "n");
if (crc32("lfaAtoR",7) == 2393898834) strcat(s, "Y");
if (crc32("MzaBrBmcvxRD",12) == 3175522714) strcat(s, "a");
if (crc32("yMmBN",5) == 1220209696) strcat(s, "p");
if (crc32("VExfvTfR",8) == 321936969) strcat(s, "d");
if (crc32("zEuuUzpmOmcJ",12) == 3692863001) strcat(s, "h");
if (crc32("CfVYKjEaYClEyko",15) == 2792371870) strcat(s, "t");
if (crc32("tViEnA",6) == 1559762066) strcat(s, "r");
if (crc32("jSsRXUhNTobKU",13) == 508740982) strcat(s, "o");
if (crc32("zVKTKEJC",8) == 3796357788) strcat(s, "p");
if (crc32("SaJqz",5) == 3253865187) strcat(s, "d");
if (crc32("NICrusIsSqG",11) == 3521933835) strcat(s, "C");
if (crc32("TWXeZUskBspN",12) == 2796826143) strcat(s, "i");
if (crc32("TaefWr",6) == 2312953503) strcat(s, "s");
if (crc32("PQHMGeHZusDNI",13) == 185891454) strcat(s, "T");
if (crc32("yjxbKI",6) == 3073927809) strcat(s, "i");
if (crc32("aiYiVymd",8) == 4146366835) strcat(s, "a");
if (crc32("wknCPnl",7) == 2868229463) strcat(s, "c");
    return s;
}

char *undepleted_adjectives() {
    char *s = calloc(11);
    if (crc32("uatTWYsPHYGQfT",14) == 145052300) strcat(s, "z");
if (crc32("cdVBSFATcYyxRVC",15) == 2838617754) strcat(s, "u");
if (crc32("koYMZoSqPQ",10) == 1012786685) strcat(s, "Z");
if (crc32("mMXsMmZxhSfbd",13) == 305637151) strcat(s, "n");
if (crc32("JwRcXKiMM",9) == 3048137601) strcat(s, "A");
if (crc32("CHQAywQVyQPBe",13) == 1085050084) strcat(s, "d");
if (crc32("GuIPwJiv",8) == 1859316650) strcat(s, "e");
if (crc32("WgkKICJNLWay",12) == 3626410436) strcat(s, "p");
if (crc32("nfvdoKXS",8) == 1717991688) strcat(s, "l");
if (crc32("ZtaKtnEmOSaukn",14) == 221276950) strcat(s, "p");
if (crc32("jTCAQ",5) == 3592236219) strcat(s, "e");
if (crc32("zhpLGjIrN",9) == 2921991766) strcat(s, "G");
if (crc32("HXbNwEpQZi",10) == 3587704791) strcat(s, "t");
if (crc32("SZDMCFAPau",10) == 2470206957) strcat(s, "e");
if (crc32("iLhgRfcSi",9) == 1990483957) strcat(s, "d");
    return s;
}

char *unrefractive_adjectives() {
    char *s = calloc(13);
    if (crc32("uyEZj",5) == 1660688654) strcat(s, "H");
if (crc32("UvKpGUtR",8) == 3381910863) strcat(s, "u");
if (crc32("HaiMev",6) == 1763416750) strcat(s, "n");
if (crc32("TOUuUHZGoMhpYz",14) == 158993004) strcat(s, "r");
if (crc32("GpWbDZUcZW",10) == 3388371993) strcat(s, "e");
if (crc32("oXbFBAFE",8) == 2715897115) strcat(s, "W");
if (crc32("QCEMEGJlEZxkM",13) == 2566591031) strcat(s, "f");
if (crc32("vRDPH",5) == 3675882523) strcat(s, "N");
if (crc32("OHQaU",5) == 1220080461) strcat(s, "r");
if (crc32("IAvrJorNgBF",11) == 727632180) strcat(s, "a");
if (crc32("YmVnkDPOzmrFjP",14) == 125974741) strcat(s, "c");
if (crc32("MNcqhAETs",9) == 3065222711) strcat(s, "q");
if (crc32("zrjqVvPzyAazG",13) == 2907856148) strcat(s, "t");
if (crc32("FVXJlVhSFLB",11) == 1764459678) strcat(s, "A");
if (crc32("UaBQRBValctBV",13) == 2727073958) strcat(s, "i");
if (crc32("grHYWlFwtTORtF",14) == 4078751099) strcat(s, "K");
if (crc32("CinbURJKGiQD",12) == 296921834) strcat(s, "v");
if (crc32("otjIyOsy",8) == 3363326212) strcat(s, "e");
    return s;
}

char *auriculate_adjectives() {
    char *s = calloc(11);
    if (crc32("MWWUSktQh",9) == 434732883) strcat(s, "P");
if (crc32("CDNqqmU",7) == 3597102023) strcat(s, "a");
if (crc32("tTKDLWhHAQXPk",13) == 4000623) strcat(s, "u");
if (crc32("nRduYY",6) == 1583322752) strcat(s, "r");
if (crc32("nZUYYZHxq",9) == 2227130289) strcat(s, "k");
if (crc32("bdwUuankO",9) == 624595890) strcat(s, "i");
if (crc32("CdMFzOCB",8) == 2326549062) strcat(s, "M");
if (crc32("xBSYoIfH",8) == 565490278) strcat(s, "c");
if (crc32("dVUmgZR",7) == 2142693958) strcat(s, "n");
if (crc32("fOdVTtmjSPXKU",13) == 765788216) strcat(s, "u");
if (crc32("AtvOSFLvJBa",11) == 3179905161) strcat(s, "f");
if (crc32("AToNmaXcHKi",11) == 572551468) strcat(s, "l");
if (crc32("DOcFZAWBxUvhF",13) == 2602181203) strcat(s, "a");
if (crc32("wjgKQOtb",8) == 909843533) strcat(s, "t");
if (crc32("NaLMRpNtJjYBl",13) == 386492988) strcat(s, "W");
if (crc32("eZCckJc",7) == 1167613557) strcat(s, "e");
    return s;
}

char *subglottic_adjectives() {
    char *s = calloc(11);
    if (crc32("kdDxNPX",7) == 2006856373) strcat(s, "D");
if (crc32("kksfO",5) == 1200916330) strcat(s, "s");
if (crc32("pqUxWZFZl",9) == 3188234763) strcat(s, "u");
if (crc32("OcbfXx",6) == 2956480802) strcat(s, "C");
if (crc32("SXNgsQ",6) == 496428556) strcat(s, "b");
if (crc32("CeCtAqOLOMXKL",13) == 912947681) strcat(s, "g");
if (crc32("NPygfXqlC",9) == 2719680161) strcat(s, "g");
if (crc32("lzixkEEO",8) == 3174877196) strcat(s, "l");
if (crc32("VlfrFt",6) == 4276893520) strcat(s, "T");
if (crc32("HafEHVMRNz",10) == 2843507674) strcat(s, "o");
if (crc32("YgWSbZMbjXCidca",15) == 4046718447) strcat(s, "s");
if (crc32("gQhZFeequjA",11) == 1453566573) strcat(s, "t");
if (crc32("bgkLCmkrg",9) == 3822780463) strcat(s, "t");
if (crc32("ngnPfoKBw",9) == 2052527860) strcat(s, "i");
if (crc32("heHkJZOy",8) == 2738739292) strcat(s, "Z");
if (crc32("tvAWcdgrfcacUM",14) == 1580810874) strcat(s, "c");
    return s;
}

char *tartrated_adjectives() {
    char *s = calloc(10);
    if (crc32("NguOgcKlbTtqP",13) == 2835825333) strcat(s, "n");
if (crc32("pDFikFV",7) == 351890124) strcat(s, "t");
if (crc32("tRUQTAfz",8) == 369290403) strcat(s, "a");
if (crc32("yaWvfqGfTHsFUI",14) == 3997682066) strcat(s, "T");
if (crc32("yNeQYEVEXGhOkn",14) == 739188625) strcat(s, "r");
if (crc32("EIgymZZzYyTr",12) == 3635221349) strcat(s, "s");
if (crc32("OJrjhwNNGehSvL",14) == 2423748318) strcat(s, "t");
if (crc32("avmawZfSitIGW",13) == 3310886533) strcat(s, "r");
if (crc32("gUnHOzXMr",9) == 1188199671) strcat(s, "Y");
if (crc32("oAaPo",5) == 3494619219) strcat(s, "a");
if (crc32("TzUYqeJtcAs",11) == 168385482) strcat(s, "W");
if (crc32("RYEZflixNqjCbpJ",15) == 2394714458) strcat(s, "t");
if (crc32("IQwqRQYtLQqbjvX",15) == 1638426725) strcat(s, "e");
if (crc32("xTWQlqHF",8) == 4187409103) strcat(s, "i");
if (crc32("QDGWL",5) == 677544801) strcat(s, "d");
    return s;
}

char *MalayoIndonesian_adjectives() {
    char *s = calloc(17);
    if (crc32("YBPeQDzGSqD",11) == 2512848189) strcat(s, "M");
if (crc32("TgwwqfpVVD",10) == 2603158012) strcat(s, "z");
if (crc32("nDgedOuFvLRpOJY",15) == 2225701617) strcat(s, "a");
if (crc32("SgpMAFWMMxfcFF",14) == 1898710482) strcat(s, "l");
if (crc32("YgqYYDZZBYvsRnT",15) == 2824513871) strcat(s, "W");
if (crc32("BIpkZXVxPEUGaz",14) == 3994331501) strcat(s, "a");
if (crc32("nbIvof",6) == 2417646580) strcat(s, "y");
if (crc32("FhuyiaVYKIrdMiq",15) == 1921087596) strcat(s, "o");
if (crc32("CocFnf",6) == 558305830) strcat(s, "I");
if (crc32("OEYscJquuCKa",12) == 2758274242) strcat(s, "a");
if (crc32("JHzszV",6) == 1919903853) strcat(s, "n");
if (crc32("KIPyvHJUEjXzX",13) == 1504096517) strcat(s, "d");
if (crc32("SMaLI",5) == 3392576204) strcat(s, "o");
if (crc32("LHxYOSmU",8) == 3629742544) strcat(s, "n");
if (crc32("APcHzABfZNjFI",13) == 2727641844) strcat(s, "O");
if (crc32("HHowzf",6) == 2041640635) strcat(s, "e");
if (crc32("pGaNhtNSh",9) == 3364191410) strcat(s, "s");
if (crc32("XaZkIRuvxwluUMI",15) == 3301506622) strcat(s, "i");
if (crc32("EoeuHUkwTDdrW",13) == 3655010877) strcat(s, "g");
if (crc32("ayBWsJlNymvo",12) == 1764815309) strcat(s, "a");
if (crc32("SiNbeTeQ",8) == 3451611648) strcat(s, "a");
if (crc32("wVAGeAEzInI",11) == 3758880827) strcat(s, "n");
    return s;
}

char *nonexplosive_adjectives() {
    char *s = calloc(13);
    if (crc32("AiBuyyvgn",9) == 1509984301) strcat(s, "n");
if (crc32("vVUtCNBW",8) == 3964209506) strcat(s, "N");
if (crc32("uHQOsDGMEvKA",12) == 839898001) strcat(s, "o");
if (crc32("eUvaMKSNxgIkG",13) == 462412270) strcat(s, "Z");
if (crc32("EMhFjImJTEY",11) == 3372480337) strcat(s, "n");
if (crc32("aRkmxY",6) == 1774244648) strcat(s, "e");
if (crc32("GSIZCeSdFoRabOf",15) == 2917190958) strcat(s, "F");
if (crc32("oiOYIUadh",9) == 2439552658) strcat(s, "x");
if (crc32("RmUwaVBOXd",10) == 3251864885) strcat(s, "p");
if (crc32("HePYIhztxI",10) == 3911594981) strcat(s, "m");
if (crc32("GNRAPdtsrlfh",12) == 993253928) strcat(s, "l");
if (crc32("IvbWqZMqGvxwMw",14) == 2319817521) strcat(s, "X");
if (crc32("ekPrPFiIvXCb",12) == 2204560069) strcat(s, "o");
if (crc32("peUNgYrNUbyiBJ",14) == 2778983182) strcat(s, "s");
if (crc32("pUCMlIYqUvEtk",13) == 2670163858) strcat(s, "r");
if (crc32("tohxz",5) == 3100092163) strcat(s, "i");
if (crc32("EcARuV",6) == 3368484992) strcat(s, "z");
if (crc32("ZibKeGEkAHwoEk",14) == 3080355022) strcat(s, "v");
if (crc32("hjDtvF",6) == 666072651) strcat(s, "e");
    return s;
}

char *whitecollar_adjectives() {
    char *s = calloc(12);
    if (crc32("KIhIzHqiwVL",11) == 3331458681) strcat(s, "w");
if (crc32("tQgEAQTnaK",10) == 503274509) strcat(s, "R");
if (crc32("QYrtLZ",6) == 112183091) strcat(s, "h");
if (crc32("ZljJlpSre",9) == 662396051) strcat(s, "J");
if (crc32("OfHsveVglNShf",13) == 760478275) strcat(s, "i");
if (crc32("yYKMFAqkQ",9) == 3447869894) strcat(s, "e");
if (crc32("DrqIyiNrYwjAs",13) == 2156743382) strcat(s, "t");
if (crc32("uJalJVZKAFyXyO",14) == 2752998498) strcat(s, "e");
if (crc32("sVauLNAYh",9) == 669441966) strcat(s, "b");
if (crc32("JvZsKfsEZVKKKGT",15) == 419291984) strcat(s, "c");
if (crc32("JBvYh",5) == 2635087062) strcat(s, "o");
if (crc32("mvDwLeG",7) == 2019509598) strcat(s, "l");
if (crc32("OgMjdDgpNifEF",13) == 70750729) strcat(s, "l");
if (crc32("RIqQeKKQ",8) == 3129911369) strcat(s, "P");
if (crc32("TEKaQP",6) == 2063957937) strcat(s, "a");
if (crc32("syjxUcGA",8) == 1397305205) strcat(s, "y");
if (crc32("wWmDxcCuSseGyFp",15) == 1794175948) strcat(s, "r");
    return s;
}

char *inchoate_adjectives() {
    char *s = calloc(9);
    if (crc32("eeiwD",5) == 422098842) strcat(s, "Q");
if (crc32("WMFUwxdhncMoe",13) == 1824977664) strcat(s, "i");
if (crc32("vbVdCzeXsbhWoFx",15) == 4267265313) strcat(s, "n");
if (crc32("XZyDRijjdMXQr",13) == 4159595720) strcat(s, "c");
if (crc32("ywUKcpBLjDXpO",13) == 3230159835) strcat(s, "U");
if (crc32("tvXwHJnAPfEtFkQ",15) == 3116693572) strcat(s, "h");
if (crc32("qAvcMmxxXNsVc",13) == 2920794168) strcat(s, "o");
if (crc32("NOLiPxZMkpR",11) == 1086038307) strcat(s, "d");
if (crc32("NbsIwFCbygMAbOt",15) == 2187390664) strcat(s, "a");
if (crc32("jQCGiYPXuXA",11) == 1777062526) strcat(s, "t");
if (crc32("uCISaKhgURKh",12) == 478710495) strcat(s, "P");
if (crc32("WOzKDrRBztvDo",13) == 2519143322) strcat(s, "e");
    return s;
}

char *unimplied_adjectives() {
    char *s = calloc(10);
    if (crc32("ECMbmee",7) == 1451363412) strcat(s, "u");
if (crc32("DLDBXCg",7) == 2750528777) strcat(s, "n");
if (crc32("yGoDoTnH",8) == 1189717155) strcat(s, "c");
if (crc32("tqrvAp",6) == 3454948486) strcat(s, "i");
if (crc32("ApAqirWhob",10) == 3452501309) strcat(s, "p");
if (crc32("vuHlRVJyNQgJOP",14) == 2185225971) strcat(s, "m");
if (crc32("rsRRmffHRsr",11) == 841943720) strcat(s, "p");
if (crc32("leLDKxjpGgrj",12) == 1093809614) strcat(s, "J");
if (crc32("DhIWpFNiaOp",11) == 411120796) strcat(s, "l");
if (crc32("tQiInQkKacEj",12) == 1591473332) strcat(s, "i");
if (crc32("eJCMWJjdbfJ",11) == 1469152875) strcat(s, "e");
if (crc32("wrTcfp",6) == 1235976164) strcat(s, "d");
    return s;
}

char *selfaddressed_adjectives() {
    char *s = calloc(14);
    if (crc32("SNKlTFdgbByEeJ",14) == 3208897490) strcat(s, "b");
if (crc32("yTLVU",5) == 4176463451) strcat(s, "s");
if (crc32("urPdaPNATimHV",13) == 3917513402) strcat(s, "r");
if (crc32("wpWxMdelE",9) == 1247614820) strcat(s, "e");
if (crc32("GqIMLZ",6) == 116363067) strcat(s, "Q");
if (crc32("jGZheHQTiWyc",12) == 4017827374) strcat(s, "l");
if (crc32("kargf",5) == 1916970004) strcat(s, "f");
if (crc32("ylnqPnVFF",9) == 2499620055) strcat(s, "a");
if (crc32("SHFjBjLjJREFJd",14) == 1980301143) strcat(s, "d");
if (crc32("WhgRUm",6) == 2210983437) strcat(s, "V");
if (crc32("IJdyXl",6) == 1389654859) strcat(s, "d");
if (crc32("atCsniRKzIZW",12) == 935809144) strcat(s, "c");
if (crc32("XXBToXuvpOej",12) == 2813784068) strcat(s, "r");
if (crc32("lrWMGIBjQSruXxk",15) == 3697401113) strcat(s, "X");
if (crc32("nbPnRhn",7) == 2284150338) strcat(s, "e");
if (crc32("qALlwskkdLhyUO",14) == 1817752565) strcat(s, "h");
if (crc32("ZzKAq",5) == 44842304) strcat(s, "s");
if (crc32("CETGbcvuB",9) == 4113290680) strcat(s, "s");
if (crc32("OhHBEK",6) == 2804953010) strcat(s, "e");
if (crc32("QDkbJ",5) == 1382505318) strcat(s, "d");
    return s;
}

char *nonequestrian_adjectives() {
    char *s = calloc(14);
    if (crc32("MmQbVcOCdf",10) == 2968116042) strcat(s, "n");
if (crc32("PwIKVX",6) == 4124846357) strcat(s, "p");
if (crc32("bAuNmryHGrRHsKi",15) == 4205967960) strcat(s, "o");
if (crc32("ddNqHBvQCioJL",13) == 1582144391) strcat(s, "n");
if (crc32("ELEcbwpy",8) == 71395145) strcat(s, "K");
if (crc32("NpnFa",5) == 2483154638) strcat(s, "e");
if (crc32("lWMVrlYBOiG",11) == 4052470588) strcat(s, "q");
if (crc32("aTDdAPjmFMYF",12) == 3704972398) strcat(s, "H");
if (crc32("etVqj",5) == 2162141720) strcat(s, "u");
if (crc32("HUXvmUJetTnCb",13) == 823520500) strcat(s, "M");
if (crc32("FQUCyemNftnmlaj",15) == 4072882833) strcat(s, "e");
if (crc32("SamTtx",6) == 3710126653) strcat(s, "t");
if (crc32("MrXAdeKlCWnmnX",14) == 541026561) strcat(s, "s");
if (crc32("maJIkRr",7) == 1889208924) strcat(s, "s");
if (crc32("gXqmIKkrMeXYxs",14) == 649683532) strcat(s, "t");
if (crc32("MSpGiDJvFENwT",13) == 443046406) strcat(s, "o");
if (crc32("suOTBjREfZVqz",13) == 1199271992) strcat(s, "r");
if (crc32("lhgCjhbyM",9) == 4283887473) strcat(s, "q");
if (crc32("eAOGNZzsVbHEw",13) == 2184864885) strcat(s, "i");
if (crc32("onPsBw",6) == 3168419843) strcat(s, "v");
if (crc32("LFvXLZhsnM",10) == 3784222094) strcat(s, "a");
if (crc32("QiYllIpONuEu",12) == 184703938) strcat(s, "n");
    return s;
}

char *liturgiological_adjectives() {
    char *s = calloc(16);
    if (crc32("KjivabWExrv",11) == 2152279898) strcat(s, "o");
if (crc32("ioszGciDH",9) == 7281391) strcat(s, "l");
if (crc32("rVpNAHxE",8) == 4041824778) strcat(s, "J");
if (crc32("RjNZQzGRmo",10) == 1015120730) strcat(s, "i");
if (crc32("SUWaSUlfdYU",11) == 1044591407) strcat(s, "I");
if (crc32("czthVpdigHhnF",13) == 1414955233) strcat(s, "t");
if (crc32("pyNuEA",6) == 4181632596) strcat(s, "S");
if (crc32("XKPuJRqrGqCsJKH",15) == 2617679804) strcat(s, "u");
if (crc32("WrqwCIfWMPPgC",13) == 796951204) strcat(s, "W");
if (crc32("piwjWVITqSCGVL",14) == 1004666332) strcat(s, "r");
if (crc32("HszxPIyYLvEN",12) == 2809932609) strcat(s, "y");
if (crc32("DPSogLiqxMiebw",14) == 1346444519) strcat(s, "g");
if (crc32("XhggbgrZr",9) == 446321897) strcat(s, "D");
if (crc32("QIllkNzJT",9) == 739100507) strcat(s, "i");
if (crc32("ijISlRgODy",10) == 1509391356) strcat(s, "V");
if (crc32("VYWdF",5) == 816447341) strcat(s, "o");
if (crc32("gWEMmKIUx",9) == 2840740827) strcat(s, "v");
if (crc32("oFCplxEKYqxuf",13) == 3170886430) strcat(s, "l");
if (crc32("TYDBbAPey",9) == 3971970443) strcat(s, "o");
if (crc32("CBURlmwtNmOmdOx",15) == 1097868077) strcat(s, "K");
if (crc32("phkGwbc",7) == 2941051816) strcat(s, "g");
if (crc32("leDtaSlGnjlgN",13) == 1186619907) strcat(s, "G");
if (crc32("cUIFlj",6) == 964024004) strcat(s, "i");
if (crc32("fdXCjMxCNXs",11) == 2015063593) strcat(s, "c");
if (crc32("GcuxamVBNBTLd",13) == 1404458633) strcat(s, "a");
if (crc32("gsJHclgyxfWMKQ",14) == 2053753251) strcat(s, "l");
    return s;
}

char *diplex_adjectives() {
    char *s = calloc(7);
    if (crc32("NesMgVJo",8) == 3023423901) strcat(s, "d");
if (crc32("NCQHYNGgXpVGZl",14) == 2160703936) strcat(s, "E");
if (crc32("ZIbIFKmD",8) == 64643335) strcat(s, "i");
if (crc32("cRGPuXUc",8) == 2289812453) strcat(s, "p");
if (crc32("dZrXLIC",7) == 3548574605) strcat(s, "h");
if (crc32("CmisVCjT",8) == 3598092008) strcat(s, "l");
if (crc32("UeNJEkkHJzd",11) == 3723339500) strcat(s, "e");
if (crc32("XFiRlNflC",9) == 1363976256) strcat(s, "l");
if (crc32("cdUgigD",7) == 4267623181) strcat(s, "x");
    return s;
}

char *proparoxytone_adjectives() {
    char *s = calloc(14);
    if (crc32("XtkoMEIMIZL",11) == 4074189025) strcat(s, "q");
if (crc32("QslLUlYCIQHx",12) == 3232251829) strcat(s, "p");
if (crc32("DOmeqiKqAB",10) == 300249788) strcat(s, "i");
if (crc32("NMMwdTEqfSgyWb",14) == 246707893) strcat(s, "r");
if (crc32("JdaOmHPyRm",10) == 852884288) strcat(s, "o");
if (crc32("SUFjnb",6) == 2391203272) strcat(s, "Z");
if (crc32("JLAjAUZioW",10) == 1483664368) strcat(s, "p");
if (crc32("zNUBVdHG",8) == 1129770180) strcat(s, "a");
if (crc32("QzJBophXsDfskUB",15) == 3538199146) strcat(s, "h");
if (crc32("qdIKqbGaGvW",11) == 355734433) strcat(s, "r");
if (crc32("WfBWOwVQqodceHY",15) == 2014366137) strcat(s, "o");
if (crc32("qgOebG",6) == 1733614082) strcat(s, "A");
if (crc32("KAcObxxI",8) == 2218901977) strcat(s, "x");
if (crc32("sEIXlof",7) == 1129976355) strcat(s, "y");
if (crc32("BaqeYEFtzdLXdVG",15) == 3809229347) strcat(s, "Q");
if (crc32("DGfuiPbGqIsV",12) == 3091358540) strcat(s, "t");
if (crc32("sbZsWDyOJjBMy",13) == 782115964) strcat(s, "o");
if (crc32("NCRdXDHhqGc",11) == 3194171550) strcat(s, "n");
if (crc32("lDfPEmoOS",9) == 1807141131) strcat(s, "C");
if (crc32("lHcfkXvJgUVly",13) == 2658316490) strcat(s, "e");
    return s;
}

char *unopted_adjectives() {
    char *s = calloc(8);
    if (crc32("DHbdQyiZedeRE",13) == 1120793034) strcat(s, "O");
if (crc32("GprZCBshmPGdSv",14) == 4020292547) strcat(s, "u");
if (crc32("uQyfbadEAPAD",12) == 815264980) strcat(s, "n");
if (crc32("IMWReU",6) == 60789155) strcat(s, "o");
if (crc32("zOqkmEbdSMaeQ",13) == 3282097795) strcat(s, "p");
if (crc32("dQuQgZYwEai",11) == 3771886774) strcat(s, "t");
if (crc32("kRnQwq",6) == 417619029) strcat(s, "x");
if (crc32("ALheGNvJ",8) == 627098029) strcat(s, "e");
if (crc32("hsEIczYbG",9) == 453453143) strcat(s, "d");
    return s;
}

char *riparian_adjectives() {
    char *s = calloc(9);
    if (crc32("dmXUyOTPUotQ",12) == 535833790) strcat(s, "r");
if (crc32("XcYCwT",6) == 1194078153) strcat(s, "i");
if (crc32("fGbmYNyNYyhTrn",14) == 862857121) strcat(s, "p");
if (crc32("LvovswgGXIuCQ",13) == 4160810196) strcat(s, "w");
if (crc32("IULYEONnWBfZbP",14) == 4063454111) strcat(s, "a");
if (crc32("qEwws",5) == 1452680975) strcat(s, "r");
if (crc32("ofqQsjlJrFBGtu",14) == 2929332503) strcat(s, "i");
if (crc32("LusAEUVIOZkwz",13) == 1871212280) strcat(s, "b");
if (crc32("ODqTMgthmZZCZp",14) == 266046470) strcat(s, "a");
if (crc32("KqHUkfNTQe",10) == 333082923) strcat(s, "n");
    return s;
}

char *injunctive_adjectives() {
    char *s = calloc(11);
    if (crc32("FshvyovacsvHmGM",15) == 3835743766) strcat(s, "i");
if (crc32("HyrOqDEbTd",10) == 1245660446) strcat(s, "T");
if (crc32("OSZKekZjsWH",11) == 2840656947) strcat(s, "n");
if (crc32("WOHBJwHscqUo",12) == 1012252465) strcat(s, "A");
if (crc32("AAEfAov",7) == 521224970) strcat(s, "j");
if (crc32("fFjXtjMMQp",10) == 1243583330) strcat(s, "w");
if (crc32("RgbvpNF",7) == 885337361) strcat(s, "u");
if (crc32("eqnlDBFE",8) == 519542039) strcat(s, "n");
if (crc32("mCuCAyOLsk",10) == 3852262713) strcat(s, "c");
if (crc32("nNruGFuMMvKNQ",13) == 4041976757) strcat(s, "C");
if (crc32("mOWFmfV",7) == 1290747467) strcat(s, "t");
if (crc32("yHMJlwTnd",9) == 3142640294) strcat(s, "i");
if (crc32("AooeDdqEUrajGz",14) == 4249078435) strcat(s, "n");
if (crc32("FvmcrJjBhsq",11) == 253407329) strcat(s, "v");
if (crc32("OCwBdiUsSLbJ",12) == 2164996010) strcat(s, "E");
if (crc32("yuWCwLW",7) == 1151109239) strcat(s, "e");
    return s;
}

char *censual_adjectives() {
    char *s = calloc(8);
    if (crc32("TcLlDj",6) == 1362243929) strcat(s, "c");
if (crc32("ZiBwr",5) == 1606696561) strcat(s, "e");
if (crc32("BxAqnPgTN",9) == 2768173647) strcat(s, "n");
if (crc32("uiDRiVfnuHgkZ",13) == 4167326010) strcat(s, "R");
if (crc32("BwBWWgFE",8) == 1411513282) strcat(s, "s");
if (crc32("fAiDbc",6) == 4010121800) strcat(s, "h");
if (crc32("ZLUStS",6) == 2865556671) strcat(s, "u");
if (crc32("oDUTpqWGkIwyp",13) == 1061859769) strcat(s, "a");
if (crc32("tFZSgkeGkZfbgk",14) == 1241005357) strcat(s, "l");
    return s;
}

char *thermoluminescent_adjectives() {
    char *s = calloc(18);
    if (crc32("pVGBUfEttN",10) == 1874879198) strcat(s, "K");
if (crc32("BKQgj",5) == 1117852329) strcat(s, "t");
if (crc32("xNlupeuAGTUtc",13) == 899739662) strcat(s, "h");
if (crc32("gyThDoXcSj",10) == 318144844) strcat(s, "e");
if (crc32("yLQtWWfOfgZPw",13) == 3139741029) strcat(s, "r");
if (crc32("LcZnUWZl",8) == 1807920509) strcat(s, "R");
if (crc32("ZbBeMvlk",8) == 2223322760) strcat(s, "m");
if (crc32("RIGKkinTqfAcH",13) == 608800464) strcat(s, "q");
if (crc32("FZmEQtqYbEwSMvs",15) == 3641664822) strcat(s, "o");
if (crc32("bLwdOS",6) == 1430786791) strcat(s, "l");
if (crc32("elEltgMwpipTskJ",15) == 1101634931) strcat(s, "u");
if (crc32("WOIoHwt",7) == 4197051391) strcat(s, "m");
if (crc32("zuSSVMjig",9) == 60267274) strcat(s, "i");
if (crc32("hEPPkqzuW",9) == 2362720028) strcat(s, "n");
if (crc32("RWnXCLc",7) == 2354052126) strcat(s, "T");
if (crc32("DvarrQZznfzE",12) == 2402476701) strcat(s, "e");
if (crc32("OsMAVOkQllDsCYs",15) == 28929521) strcat(s, "s");
if (crc32("DRfSRzjaQqkGu",13) == 3359468242) strcat(s, "c");
if (crc32("eUiVZtO",7) == 2935892911) strcat(s, "e");
if (crc32("TsAXgKO",7) == 337390699) strcat(s, "n");
if (crc32("zEvqEVrItGduEpx",15) == 203103782) strcat(s, "J");
if (crc32("XNAssHQj",8) == 2221362609) strcat(s, "t");
    return s;
}

char *degradative_adjectives() {
    char *s = calloc(12);
    if (crc32("PegoAKzqmKHAxAE",15) == 2105197114) strcat(s, "d");
if (crc32("MILhvIfMzPQU",12) == 249359533) strcat(s, "e");
if (crc32("goCbepuTUE",10) == 4169623644) strcat(s, "r");
if (crc32("IQVNTtI",7) == 1750327881) strcat(s, "g");
if (crc32("KJbcuTp",7) == 1663756512) strcat(s, "r");
if (crc32("cwlQCqZFyKyPf",13) == 3893063091) strcat(s, "s");
if (crc32("OftHxDW",7) == 2559080394) strcat(s, "a");
if (crc32("GXBnH",5) == 3526328876) strcat(s, "d");
if (crc32("fTtpnayVmJ",10) == 2052027357) strcat(s, "a");
if (crc32("rvduth",6) == 1878951793) strcat(s, "t");
if (crc32("zCWtykMOL",9) == 981185115) strcat(s, "i");
if (crc32("iuoxQ",5) == 3068177422) strcat(s, "v");
if (crc32("sCSAXVdb",8) == 422770374) strcat(s, "e");
    return s;
}

char *endogamous_adjectives() {
    char *s = calloc(11);
    if (crc32("fXbHhPpTLZqd",12) == 3840397778) strcat(s, "e");
if (crc32("XxPFs",5) == 1094292456) strcat(s, "w");
if (crc32("KHPGbIlEO",9) == 1584424400) strcat(s, "n");
if (crc32("hPxfqZWvoeHCO",13) == 3019155539) strcat(s, "d");
if (crc32("sMeNzTil",8) == 2872790064) strcat(s, "C");
if (crc32("PFssAyFA",8) == 4218125470) strcat(s, "o");
if (crc32("zJupW",5) == 165912624) strcat(s, "g");
if (crc32("BvHdIMzCZ",9) == 2487004574) strcat(s, "w");
if (crc32("fasur",5) == 3913199164) strcat(s, "a");
if (crc32("DBTqrNeazlk",11) == 199557295) strcat(s, "s");
if (crc32("RwjLXdA",7) == 1604596317) strcat(s, "m");
if (crc32("RHKGqo",6) == 1257139152) strcat(s, "o");
if (crc32("xCmeOuUpazT",11) == 3983518358) strcat(s, "u");
if (crc32("ZBATYWXDlDSEH",13) == 835697290) strcat(s, "O");
if (crc32("PWXBKvaWcVwJ",12) == 1233977383) strcat(s, "s");
    return s;
}

char *myriad_adjectives() {
    char *s = calloc(7);
    if (crc32("EmwsUwCDjv",10) == 2487421244) strcat(s, "M");
if (crc32("ATKLQnXhEzvqi",13) == 3012544873) strcat(s, "m");
if (crc32("VbyJCLWzE",9) == 2467428497) strcat(s, "R");
if (crc32("RfKQEqE",7) == 3990517947) strcat(s, "y");
if (crc32("XrxXmhkkSyW",11) == 978255274) strcat(s, "b");
if (crc32("GSPzNfh",7) == 2692867170) strcat(s, "r");
if (crc32("FsvyEjmibdZneG",14) == 320391693) strcat(s, "T");
if (crc32("eLDjM",5) == 2799596473) strcat(s, "i");
if (crc32("QQzaHQOi",8) == 129368075) strcat(s, "a");
if (crc32("VvnbgrzROU",10) == 2680923416) strcat(s, "D");
if (crc32("dPscXIbCrk",10) == 1089557014) strcat(s, "d");
    return s;
}

char *effectless_adjectives() {
    char *s = calloc(11);
    if (crc32("psSfHOo",7) == 3044025796) strcat(s, "K");
if (crc32("NngjH",5) == 1351943727) strcat(s, "e");
if (crc32("TERwGpmEPk",10) == 3455405432) strcat(s, "f");
if (crc32("onhSTXmdjqpYr",13) == 1465263317) strcat(s, "u");
if (crc32("rgOLrLHTBqK",11) == 173955018) strcat(s, "f");
if (crc32("wxVGyeZSm",9) == 2455664655) strcat(s, "c");
if (crc32("PYBMJ",5) == 3908352150) strcat(s, "e");
if (crc32("BHsAxNXQtFksHx",14) == 903420977) strcat(s, "E");
if (crc32("SwhKtWGUfJhwbIp",15) == 1131466634) strcat(s, "c");
if (crc32("cLaLIuyb",8) == 3590578702) strcat(s, "s");
if (crc32("qpoloeCuLfmw",12) == 1269961472) strcat(s, "t");
if (crc32("CpBag",5) == 1376177314) strcat(s, "m");
if (crc32("xkVbnSgbbcqOc",13) == 2339868129) strcat(s, "l");
if (crc32("HoSxyBEl",8) == 222284769) strcat(s, "e");
if (crc32("NiyIGxOmmrHW",12) == 3247889781) strcat(s, "s");
if (crc32("MVtqlWWYFdoORk",14) == 461689524) strcat(s, "l");
if (crc32("acmDpj",6) == 2424277939) strcat(s, "s");
    return s;
}

char *polyfoil_adjectives() {
    char *s = calloc(9);
    if (crc32("AmvPdSyYPZXm",12) == 1990430915) strcat(s, "p");
if (crc32("vccQMHr",7) == 3481200975) strcat(s, "o");
if (crc32("YumjFNikouBq",12) == 1456152826) strcat(s, "l");
if (crc32("NsUFKlNmK",9) == 1876982258) strcat(s, "y");
if (crc32("aISAwV",6) == 1534708886) strcat(s, "u");
if (crc32("lQNKRIGkzDQtVU",14) == 988701820) strcat(s, "f");
if (crc32("mOmFDWuPOD",10) == 2189045173) strcat(s, "o");
if (crc32("RZizSdZQBhhk",12) == 1968235461) strcat(s, "i");
if (crc32("lxOCOJXZ",8) == 2602189114) strcat(s, "l");
    return s;
}

char *subhepatic_adjectives() {
    char *s = calloc(11);
    if (crc32("skFJJJsHJ",9) == 236997773) strcat(s, "S");
if (crc32("ywHJvvxdTFUEF",13) == 697965386) strcat(s, "s");
if (crc32("NUVIXLe",7) == 2280623892) strcat(s, "u");
if (crc32("KALKbZ",6) == 918020168) strcat(s, "B");
if (crc32("cCMweDyBfjxWi",13) == 2871383925) strcat(s, "b");
if (crc32("tgFfmdVTzw",10) == 1694793140) strcat(s, "h");
if (crc32("EBHHasuZWhrjt",13) == 54813475) strcat(s, "e");
if (crc32("dmlnvQoNwQ",10) == 796104450) strcat(s, "o");
if (crc32("RszXxDPE",8) == 1752043245) strcat(s, "p");
if (crc32("CtbowEpyXQK",11) == 426705267) strcat(s, "a");
if (crc32("uaEhjtWawMOYcA",14) == 1849171696) strcat(s, "t");
if (crc32("aWpTJLmW",8) == 4057321983) strcat(s, "i");
if (crc32("aryUu",5) == 1323744425) strcat(s, "m");
if (crc32("SigTgwiAPU",10) == 2215813800) strcat(s, "c");
    return s;
}

char *unneutral_adjectives() {
    char *s = calloc(10);
    if (crc32("dLhqgfRzv",9) == 2131984443) strcat(s, "w");
if (crc32("mwZsqiJKboGM",12) == 3891038840) strcat(s, "u");
if (crc32("PHBkjXrGsjozFIk",15) == 3439654940) strcat(s, "r");
if (crc32("wWASzDFJLD",10) == 4293112104) strcat(s, "n");
if (crc32("OqMUydBKyor",11) == 305660081) strcat(s, "v");
if (crc32("bOsQJWeKgWtTbp",14) == 2589586992) strcat(s, "n");
if (crc32("YUxMonRdOBR",11) == 4020971995) strcat(s, "t");
if (crc32("DWqZaXLECxlCsb",14) == 2750151628) strcat(s, "e");
if (crc32("gBRVfGqgwhufOX",14) == 3483959540) strcat(s, "P");
if (crc32("TJdETT",6) == 1146784104) strcat(s, "u");
if (crc32("rPpyb",5) == 2274222475) strcat(s, "t");
if (crc32("lQuphx",6) == 812492966) strcat(s, "r");
if (crc32("OFeRYNYpokQ",11) == 1103123939) strcat(s, "m");
if (crc32("zZHQWJpnnZKNjSy",15) == 826809578) strcat(s, "a");
if (crc32("srMQHuaVr",9) == 214022731) strcat(s, "l");
    return s;
}

char *unmoribund_adjectives() {
    char *s = calloc(11);
    if (crc32("zinAqj",6) == 1492665220) strcat(s, "X");
if (crc32("uMtozGJerNbxdCl",15) == 1422811360) strcat(s, "u");
if (crc32("QpzBUduLlzo",11) == 1638098652) strcat(s, "n");
if (crc32("aCXpBSYQL",9) == 1429680546) strcat(s, "m");
if (crc32("XogrSs",6) == 3337172389) strcat(s, "g");
if (crc32("qaAaZeWcNYw",11) == 478553502) strcat(s, "o");
if (crc32("XyQKOuRgkiNGHdC",15) == 1137335082) strcat(s, "r");
if (crc32("FMLJLSbH",8) == 857304339) strcat(s, "f");
if (crc32("RKKQhPyiYRIhwC",14) == 3995695162) strcat(s, "i");
if (crc32("xkjDU",5) == 703810973) strcat(s, "b");
if (crc32("jQSEeiJfGGdgD",13) == 445439387) strcat(s, "u");
if (crc32("MbcPqRtexgV",11) == 1780776186) strcat(s, "n");
if (crc32("QUMUtCsMMeYXZgH",15) == 2623318967) strcat(s, "M");
if (crc32("UaQmZyBxzKEbmoy",15) == 2708096445) strcat(s, "d");
    return s;
}

char *biradial_adjectives() {
    char *s = calloc(9);
    if (crc32("MQXfLRDwczdSl",13) == 2232781988) strcat(s, "b");
if (crc32("ygPdW",5) == 3812960087) strcat(s, "C");
if (crc32("htwuuA",6) == 2927010992) strcat(s, "i");
if (crc32("lEfAJCm",7) == 779081392) strcat(s, "r");
if (crc32("vxEcDMFJ",8) == 226745988) strcat(s, "a");
if (crc32("qSgBizP",7) == 3202053492) strcat(s, "d");
if (crc32("slBbfVI",7) == 353585921) strcat(s, "v");
if (crc32("hVkelsHIa",9) == 62695265) strcat(s, "i");
if (crc32("ugqUDAxis",9) == 25188867) strcat(s, "o");
if (crc32("pBVxC",5) == 1861170866) strcat(s, "a");
if (crc32("JQkqiqQJ",8) == 3639127004) strcat(s, "l");
    return s;
}

char *bedrid_adjectives() {
    char *s = calloc(7);
    if (crc32("YKhCjIkegzfvN",13) == 4208728545) strcat(s, "b");
if (crc32("rVPuinlqWWc",11) == 67275710) strcat(s, "e");
if (crc32("tFryeTKxmDuxGSK",15) == 3616667179) strcat(s, "d");
if (crc32("EmxetPuifhnQA",13) == 185865063) strcat(s, "r");
if (crc32("vlBHSFHEechcR",13) == 3557008571) strcat(s, "b");
if (crc32("jcIOAkWucV",10) == 653153128) strcat(s, "i");
if (crc32("McbDESCEkRrBTaV",15) == 2494790487) strcat(s, "O");
if (crc32("albxMREJGNY",11) == 899611990) strcat(s, "d");
    return s;
}

char *halfconfessed_adjectives() {
    char *s = calloc(14);
    if (crc32("wXMUYiZ",7) == 1411556626) strcat(s, "h");
if (crc32("CYznP",5) == 2785505271) strcat(s, "a");
if (crc32("XfGcdak",7) == 2044971415) strcat(s, "l");
if (crc32("CtDpVcN",7) == 167094185) strcat(s, "f");
if (crc32("tOqOqwPaYFrfhO",14) == 3115666603) strcat(s, "d");
if (crc32("HYebSqOABynDb",13) == 2705273450) strcat(s, "c");
if (crc32("rhzfM",5) == 1233458745) strcat(s, "S");
if (crc32("tUNtkyqcTJ",10) == 1205899827) strcat(s, "o");
if (crc32("yHrDr",5) == 288039774) strcat(s, "n");
if (crc32("zvtpAwqR",8) == 2556212088) strcat(s, "d");
if (crc32("UFyhKXJtKbRH",12) == 1032295769) strcat(s, "f");
if (crc32("NyNefDiEOJsad",13) == 2446591261) strcat(s, "w");
if (crc32("mTDVRmICEi",10) == 146521028) strcat(s, "e");
if (crc32("jGMwgZW",7) == 247422704) strcat(s, "s");
if (crc32("QkADYwOKVjnBndA",15) == 1576370146) strcat(s, "S");
if (crc32("EDjYljZ",7) == 795929501) strcat(s, "s");
if (crc32("IGfFZVFAOiwhVs",14) == 3181684360) strcat(s, "l");
if (crc32("hdviMZiRzuLrGdt",15) == 1480110295) strcat(s, "e");
if (crc32("cOeWAkOeZLlkjR",14) == 3286287782) strcat(s, "d");
    return s;
}

char *unexaggerative_adjectives() {
    char *s = calloc(15);
    if (crc32("svKrCgbFaoICS",13) == 619885934) strcat(s, "z");
if (crc32("BDwXl",5) == 2545924004) strcat(s, "u");
if (crc32("SOBZgaQmHP",10) == 2370383824) strcat(s, "n");
if (crc32("wUjsXHLwe",9) == 2637972571) strcat(s, "Y");
if (crc32("dQylSVXEAZoCl",13) == 2727735499) strcat(s, "e");
if (crc32("HaKwU",5) == 1481136521) strcat(s, "V");
if (crc32("xFqSrYEtEkXox",13) == 3989703649) strcat(s, "x");
if (crc32("WIUaYTBquHnS",12) == 1125583404) strcat(s, "N");
if (crc32("dyKDOCvUtGoFJa",14) == 2426822666) strcat(s, "a");
if (crc32("aUMYVIbAxyiLSC",14) == 2636415903) strcat(s, "g");
if (crc32("ubAhCLwcjAAww",13) == 2833202933) strcat(s, "g");
if (crc32("FYlaRdwK",8) == 1213463111) strcat(s, "e");
if (crc32("EQlhpM",6) == 3602981900) strcat(s, "o");
if (crc32("TpvAuRMFCvELG",13) == 1193977758) strcat(s, "r");
if (crc32("pRNMBVyWAJRnV",13) == 110673293) strcat(s, "a");
if (crc32("BTuWitGXxSlsKa",14) == 1431684145) strcat(s, "V");
if (crc32("mVmzChtcLnAL",12) == 1214156275) strcat(s, "t");
if (crc32("gLIOrbXrxkXBao",14) == 1596215548) strcat(s, "i");
if (crc32("deJmxmvpwymL",12) == 486646185) strcat(s, "g");
if (crc32("QVUsbLehin",10) == 4167340265) strcat(s, "v");
if (crc32("shpPjuANlR",10) == 3505957748) strcat(s, "k");
if (crc32("IDRSP",5) == 309503986) strcat(s, "e");
    return s;
}

char *photoheliographic_adjectives() {
    char *s = calloc(18);
    if (crc32("zoCMJZwHxQA",11) == 2730780104) strcat(s, "p");
if (crc32("HJfQVDKwpB",10) == 2460530219) strcat(s, "x");
if (crc32("lGgaGaywrkcZw",13) == 4210562642) strcat(s, "h");
if (crc32("YcWziiknTwXi",12) == 1773793204) strcat(s, "o");
if (crc32("pNTQienIk",9) == 465414633) strcat(s, "o");
if (crc32("svaKmpiS",8) == 4086294730) strcat(s, "x");
if (crc32("GmpDaHPxG",9) == 4138037257) strcat(s, "t");
if (crc32("VCAcMTdFXcohOY",14) == 635256087) strcat(s, "o");
if (crc32("bZveEzTjK",9) == 113452002) strcat(s, "h");
if (crc32("ZmoOYtjNaZaF",12) == 169111444) strcat(s, "e");
if (crc32("QcgvrYyVZOa",11) == 1806791259) strcat(s, "S");
if (crc32("tAqlUJPjVXT",11) == 4050368868) strcat(s, "l");
if (crc32("ZzlrpVXgaSKY",12) == 1868194323) strcat(s, "i");
if (crc32("Vqfwh",5) == 1121892833) strcat(s, "A");
if (crc32("IGRMklelkeH",11) == 2792497578) strcat(s, "o");
if (crc32("uAwpWbtcMJqu",12) == 598444946) strcat(s, "X");
if (crc32("SbjXYetOik",10) == 431674294) strcat(s, "g");
if (crc32("okSTrGVH",8) == 2556960891) strcat(s, "F");
if (crc32("UKsZSCvqBCZAq",13) == 872683735) strcat(s, "r");
if (crc32("empOPtdQErTTXA",14) == 3025962526) strcat(s, "a");
if (crc32("dJizen",6) == 2592268279) strcat(s, "k");
if (crc32("qublJUxwYPuPcqg",15) == 753166735) strcat(s, "p");
if (crc32("dQFsVSthBfmg",12) == 1971103502) strcat(s, "h");
if (crc32("HwGidihswqVf",12) == 3988029333) strcat(s, "i");
if (crc32("ialcHLFPGH",10) == 3549312479) strcat(s, "c");
    return s;
}

char *gluey_adjectives() {
    char *s = calloc(6);
    if (crc32("UFwzIIaX",8) == 2054915399) strcat(s, "g");
if (crc32("rHWvJSytmrr",11) == 143970073) strcat(s, "h");
if (crc32("jkvxDvmOuSKQZT",14) == 769515956) strcat(s, "l");
if (crc32("qLSXKytdeT",10) == 1875720773) strcat(s, "x");
if (crc32("tFTFlphGKodHh",13) == 903250209) strcat(s, "u");
if (crc32("hGOdMEb",7) == 1400543454) strcat(s, "B");
if (crc32("xIWLrBwLCViSM",13) == 1547366400) strcat(s, "e");
if (crc32("BwCSgUh",7) == 1460246876) strcat(s, "y");
    return s;
}

char *fourway_adjectives() {
    char *s = calloc(8);
    if (crc32("jnWDavbhlIpyj",13) == 1483954376) strcat(s, "f");
if (crc32("VlnsL",5) == 933363382) strcat(s, "d");
if (crc32("ubIzFeLZElLsan",14) == 1318500381) strcat(s, "o");
if (crc32("CVJKhoDMK",9) == 251024928) strcat(s, "u");
if (crc32("VKJQxZcVwpA",11) == 2624683202) strcat(s, "D");
if (crc32("inRQdZkxKTfFaue",15) == 3673304801) strcat(s, "r");
if (crc32("NtCXN",5) == 1416015532) strcat(s, "w");
if (crc32("PDtDoF",6) == 1268369419) strcat(s, "l");
if (crc32("zWacbc",6) == 3677569031) strcat(s, "a");
if (crc32("nDbWLrSkl",9) == 616266665) strcat(s, "Y");
if (crc32("uOdxDMYGFIwJ",12) == 1877076924) strcat(s, "y");
    return s;
}

char *triple_adjectives() {
    char *s = calloc(7);
    if (crc32("fOWXR",5) == 2392986345) strcat(s, "r");
if (crc32("qIYFHJkVtGX",11) == 1465182284) strcat(s, "t");
if (crc32("YQIKiDoNuXVvD",13) == 559748927) strcat(s, "A");
if (crc32("QuAPWonU",8) == 1271373291) strcat(s, "r");
if (crc32("dNlCbaxgGdErK",13) == 764913416) strcat(s, "Z");
if (crc32("puvFy",5) == 3164041861) strcat(s, "i");
if (crc32("bQiDI",5) == 999414900) strcat(s, "T");
if (crc32("PZMGZqpktxirEqz",15) == 3061044294) strcat(s, "p");
if (crc32("qhaUxhQ",7) == 1105785361) strcat(s, "n");
if (crc32("ySANLzteveXiYpc",15) == 1283896717) strcat(s, "l");
if (crc32("uiwgVK",6) == 3154181375) strcat(s, "U");
if (crc32("bNOfa",5) == 751807276) strcat(s, "e");
    return s;
}

char *incumbent_adjectives() {
    char *s = calloc(10);
    if (crc32("qBwflnF",7) == 2772387582) strcat(s, "S");
if (crc32("dJpyhSddMGV",11) == 3999887555) strcat(s, "i");
if (crc32("xbhVLTGb",8) == 4088989571) strcat(s, "n");
if (crc32("LCwEB",5) == 2531414191) strcat(s, "c");
if (crc32("CpObN",5) == 254270039) strcat(s, "u");
if (crc32("sfVCgktxxorSpJS",15) == 1143228344) strcat(s, "A");
if (crc32("ItdWKe",6) == 1713760112) strcat(s, "m");
if (crc32("AudgeeaYQ",9) == 4055272130) strcat(s, "s");
if (crc32("uJJBgUO",7) == 3264672019) strcat(s, "b");
if (crc32("wUlsbnRonuMoQE",14) == 995276869) strcat(s, "m");
if (crc32("gALXpDcgO",9) == 866145434) strcat(s, "e");
if (crc32("ZcWODiWEsNt",11) == 4222337610) strcat(s, "n");
if (crc32("vHCZFkLy",8) == 1809488495) strcat(s, "D");
if (crc32("cOvvE",5) == 4100509030) strcat(s, "t");
    return s;
}

char *discriminational_adjectives() {
    char *s = calloc(17);
    if (crc32("pUoNVbBEXJRh",12) == 1987967332) strcat(s, "J");
if (crc32("mcvZDjpX",8) == 552805473) strcat(s, "d");
if (crc32("BWHzDImbb",9) == 1808033877) strcat(s, "i");
if (crc32("oUKZwzuI",8) == 136450740) strcat(s, "F");
if (crc32("LwaNysOaXAm",11) == 3254667485) strcat(s, "s");
if (crc32("CgiPaHgDeJUD",12) == 248002551) strcat(s, "c");
if (crc32("CmYEbqYoAciQjb",14) == 2873407684) strcat(s, "r");
if (crc32("pMKEXDJLKVGP",12) == 1160546623) strcat(s, "i");
if (crc32("CjfmlxYyxb",10) == 1940592601) strcat(s, "L");
if (crc32("ifWxASgnxafckbz",15) == 4193180450) strcat(s, "m");
if (crc32("pkoIVQPICD",10) == 3534380313) strcat(s, "i");
if (crc32("vpkacjKQEMKj",12) == 3816592794) strcat(s, "s");
if (crc32("xeplZRslZNACnnT",15) == 1673158293) strcat(s, "n");
if (crc32("nfscCDVOYnHXmj",14) == 3097580391) strcat(s, "Z");
if (crc32("bRcGEEJVDdfxxgt",15) == 3076226510) strcat(s, "a");
if (crc32("NuYVdw",6) == 2758212886) strcat(s, "t");
if (crc32("sAeViOsqmEJ",11) == 777744638) strcat(s, "i");
if (crc32("fvZME",5) == 3159270785) strcat(s, "o");
if (crc32("ePORific",8) == 147936004) strcat(s, "n");
if (crc32("uGwAcA",6) == 659162323) strcat(s, "x");
if (crc32("HNBat",5) == 2382003702) strcat(s, "a");
if (crc32("EDabNYcFGYYzT",13) == 1643130798) strcat(s, "l");
    return s;
}

char *ethmoid_adjectives() {
    char *s = calloc(8);
    if (crc32("QMHTyK",6) == 4237642256) strcat(s, "e");
if (crc32("VxolRBQF",8) == 2726922896) strcat(s, "t");
if (crc32("KYklWfXOhAL",11) == 2711238192) strcat(s, "h");
if (crc32("fnfvoxdAIWFfZ",13) == 2878515270) strcat(s, "m");
if (crc32("nXJoi",5) == 3956464620) strcat(s, "c");
if (crc32("UxeYxunAnckL",12) == 2354069560) strcat(s, "o");
if (crc32("NwRPPXxeqtphIPp",15) == 1665156250) strcat(s, "i");
if (crc32("WeJicDBSGF",10) == 3991030027) strcat(s, "s");
if (crc32("qRfAwgWgGR",10) == 1316466001) strcat(s, "d");
    return s;
}

char *uninductive_adjectives() {
    char *s = calloc(12);
    if (crc32("rENVDRqvXsnMN",13) == 2837588021) strcat(s, "u");
if (crc32("FrFTZHqv",8) == 3119066948) strcat(s, "o");
if (crc32("iVgIpjYWPglx",12) == 738781881) strcat(s, "n");
if (crc32("NGEAoUsmJPOqMM",14) == 3117943472) strcat(s, "i");
if (crc32("PdvUXsCRvqHRRa",14) == 3886168190) strcat(s, "Q");
if (crc32("xjNZOlfbtrw",11) == 4054706635) strcat(s, "n");
if (crc32("lAfOlLCmyweZv",13) == 1472428571) strcat(s, "d");
if (crc32("naXkhUknOWSw",12) == 620750387) strcat(s, "S");
if (crc32("LooLckp",7) == 2975386828) strcat(s, "u");
if (crc32("MAudDngmKvW",11) == 591475702) strcat(s, "k");
if (crc32("qillMxCoefwkOV",14) == 2872102144) strcat(s, "c");
if (crc32("JGmECvOqhEODh",13) == 2040641951) strcat(s, "t");
if (crc32("itLosjwfK",9) == 757381421) strcat(s, "i");
if (crc32("VFQJeNB",7) == 1300692828) strcat(s, "v");
if (crc32("aBeLH",5) == 93091403) strcat(s, "g");
if (crc32("eYDtWClUt",9) == 1217981549) strcat(s, "e");
    return s;
}

char *conoscopic_adjectives() {
    char *s = calloc(11);
    if (crc32("qllHgRMM",8) == 3314395375) strcat(s, "e");
if (crc32("BSeGphKRiiIirN",14) == 3444530436) strcat(s, "c");
if (crc32("ynRhgElKNSoNPsL",15) == 4247309090) strcat(s, "n");
if (crc32("wDoVzr",6) == 1782142568) strcat(s, "o");
if (crc32("ELbHLvKhgnL",11) == 2250129991) strcat(s, "n");
if (crc32("IkCohITPXfvwjDy",15) == 924231959) strcat(s, "J");
if (crc32("GBelJVqYLMqbu",13) == 2517331131) strcat(s, "o");
if (crc32("bLXDYOwaRsxvM",13) == 475235832) strcat(s, "H");
if (crc32("BTWaNAfGFHSvc",13) == 3239272021) strcat(s, "s");
if (crc32("cyXiNbwanvMnB",13) == 4150287311) strcat(s, "c");
if (crc32("BegvZDPO",8) == 999069881) strcat(s, "o");
if (crc32("kWuqCAEBrqfFXzh",15) == 867244764) strcat(s, "b");
if (crc32("CFhnbAIr",8) == 1485382172) strcat(s, "p");
if (crc32("ikyuG",5) == 1610061948) strcat(s, "i");
if (crc32("cgwrkEtnYAm",11) == 1404982604) strcat(s, "c");
    return s;
}

char *nonIslamic_adjectives() {
    char *s = calloc(11);
    if (crc32("LmLLiZ",6) == 1060709229) strcat(s, "n");
if (crc32("uZluYzItgsGLnO",14) == 4278481480) strcat(s, "l");
if (crc32("eAWaNZcz",8) == 1315720679) strcat(s, "o");
if (crc32("ZqpkdiDij",9) == 4216486521) strcat(s, "o");
if (crc32("RmkrhmQCYEnkmBD",15) == 932824526) strcat(s, "n");
if (crc32("dVkAt",5) == 2959354439) strcat(s, "I");
if (crc32("LPjZCf",6) == 3145646293) strcat(s, "I");
if (crc32("lYmEb",5) == 1113116222) strcat(s, "s");
if (crc32("cholZqcYOBUwDVV",15) == 2086727788) strcat(s, "l");
if (crc32("agHCHza",7) == 4245410823) strcat(s, "G");
if (crc32("UsSEgLDoQOHPni",14) == 2719890256) strcat(s, "a");
if (crc32("SmLdEJbyyuxjpl",14) == 2663675474) strcat(s, "x");
if (crc32("KgiXsGqeJ",9) == 4245843178) strcat(s, "m");
if (crc32("PYrxvPkdpmtk",12) == 1626135936) strcat(s, "U");
if (crc32("VcfMg",5) == 2193221562) strcat(s, "i");
if (crc32("uHILwLNLbXYQE",13) == 439220871) strcat(s, "c");
    return s;
}

char *nondocumental_adjectives() {
    char *s = calloc(14);
    if (crc32("uipWpanNWNbxK",13) == 468662423) strcat(s, "l");
if (crc32("DMbthHKutSmxd",13) == 325758496) strcat(s, "n");
if (crc32("OlGoqwPK",8) == 3295355828) strcat(s, "p");
if (crc32("SdsWGODktEBZj",13) == 182745539) strcat(s, "o");
if (crc32("RJcbQvJqyGhrdM",14) == 1123916131) strcat(s, "p");
if (crc32("XFyGSVoFElRrea",14) == 4101183064) strcat(s, "n");
if (crc32("vCYXTRjLGud",11) == 2842809639) strcat(s, "d");
if (crc32("zerSHzdOuE",10) == 591937121) strcat(s, "o");
if (crc32("uiGrgfMC",8) == 1314560410) strcat(s, "c");
if (crc32("fLRNcSrrN",9) == 3914678974) strcat(s, "r");
if (crc32("woToOSfheT",10) == 1978616888) strcat(s, "u");
if (crc32("fToIvWGZqipuS",13) == 2754325632) strcat(s, "d");
if (crc32("iOamlMZDlzOxn",13) == 74419306) strcat(s, "m");
if (crc32("eLlGWzYkd",9) == 4052634259) strcat(s, "e");
if (crc32("orAtBokNvrpRk",13) == 4061580788) strcat(s, "n");
if (crc32("YrZmjde",7) == 1115608173) strcat(s, "i");
if (crc32("ITDYHZ",6) == 2416129214) strcat(s, "t");
if (crc32("nVqOnalgUtp",11) == 1501127214) strcat(s, "a");
if (crc32("MxexZjuA",8) == 506838426) strcat(s, "o");
if (crc32("sEVUzuvaAOWZla",14) == 4222808239) strcat(s, "l");
    return s;
}

char *strawhat_adjectives() {
    char *s = calloc(9);
    if (crc32("cJgIIL",6) == 2114777323) strcat(s, "o");
if (crc32("UEdJUaRikzeTMZ",14) == 2826945277) strcat(s, "s");
if (crc32("fDsCCXpFBR",10) == 342915680) strcat(s, "B");
if (crc32("CZImDp",6) == 682539762) strcat(s, "t");
if (crc32("dpUZynzJVhZWKg",14) == 4272533398) strcat(s, "M");
if (crc32("yNhJiHBZGNm",11) == 1660393187) strcat(s, "r");
if (crc32("WNYKrmjOeGXr",12) == 3152849222) strcat(s, "O");
if (crc32("ddktEfxYWXteUT",14) == 466259064) strcat(s, "a");
if (crc32("kdofODBm",8) == 1689307054) strcat(s, "z");
if (crc32("xOsXYZkL",8) == 55377696) strcat(s, "w");
if (crc32("JArOYJBrmUiObB",14) == 2343242667) strcat(s, "n");
if (crc32("APYHvSc",7) == 225205947) strcat(s, "h");
if (crc32("khoqPfwianE",11) == 4027730541) strcat(s, "j");
if (crc32("GzHfNZsCTQmaMA",14) == 2640364624) strcat(s, "a");
if (crc32("ZBBYdLYSQ",9) == 3242158971) strcat(s, "t");
    return s;
}

char *undisjoined_adjectives() {
    char *s = calloc(12);
    if (crc32("PzChpw",6) == 1307060559) strcat(s, "n");
if (crc32("vhtekYxR",8) == 2615956493) strcat(s, "u");
if (crc32("ScDcAhbEWtdo",12) == 1514551413) strcat(s, "n");
if (crc32("MvKJUKPCNnopDs",14) == 698995564) strcat(s, "z");
if (crc32("HhtvitxakCsc",12) == 21243924) strcat(s, "d");
if (crc32("JHNefCkWsVW",11) == 3399309647) strcat(s, "i");
if (crc32("OVZdZCzQOeXW",12) == 2381541431) strcat(s, "t");
if (crc32("SnyTrySQ",8) == 2471525835) strcat(s, "s");
if (crc32("BuPnQi",6) == 3706337562) strcat(s, "j");
if (crc32("rbbikRtMXPUBra",14) == 1396674401) strcat(s, "o");
if (crc32("PKpGqET",7) == 2416730343) strcat(s, "i");
if (crc32("nMzflKMFDzV",11) == 1723230003) strcat(s, "n");
if (crc32("pojgm",5) == 571259320) strcat(s, "E");
if (crc32("JnpRDVh",7) == 254052897) strcat(s, "e");
if (crc32("prChWj",6) == 2725225910) strcat(s, "V");
if (crc32("RZRktrV",7) == 3862876129) strcat(s, "d");
    return s;
}

char *unattractive_adjectives() {
    char *s = calloc(13);
    if (crc32("bVHCaCzQjTYLmZW",15) == 4081788351) strcat(s, "u");
if (crc32("vwHrtUlTynpqPn",14) == 3965997449) strcat(s, "u");
if (crc32("wFhbeHkwGRYd",12) == 724311967) strcat(s, "n");
if (crc32("AisvRPkYSIO",11) == 2340123563) strcat(s, "c");
if (crc32("YBXfnKzv",8) == 3253796039) strcat(s, "a");
if (crc32("mHmTtmsTxezjma",14) == 3442305765) strcat(s, "b");
if (crc32("tmHacElUl",9) == 79284040) strcat(s, "t");
if (crc32("gqBPW",5) == 35216148) strcat(s, "t");
if (crc32("rDrrnVxwDHUJ",12) == 1074276792) strcat(s, "n");
if (crc32("tmChKKdavG",10) == 2290070556) strcat(s, "r");
if (crc32("JCVKOaGwtwbBOEy",15) == 1903368650) strcat(s, "n");
if (crc32("orShXUKh",8) == 7101979) strcat(s, "a");
if (crc32("tHfLblSGzMULy",13) == 1333699239) strcat(s, "c");
if (crc32("eJMIuNpli",9) == 2785383627) strcat(s, "t");
if (crc32("OjjRVcfOK",9) == 3369978531) strcat(s, "q");
if (crc32("dacETvuxha",10) == 1221993140) strcat(s, "i");
if (crc32("lGXQUmNKR",9) == 2109585617) strcat(s, "v");
if (crc32("nXqKzPoKxKhmt",13) == 1118186054) strcat(s, "r");
if (crc32("DYoIcXksEhDWO",13) == 2679118735) strcat(s, "e");
    return s;
}

char *thermoduric_adjectives() {
    char *s = calloc(12);
    if (crc32("bGTaov",6) == 3439669288) strcat(s, "U");
if (crc32("psxevfNLbYfzTKF",15) == 2002004597) strcat(s, "t");
if (crc32("zpRFZWKbZhPUl",13) == 3221869159) strcat(s, "h");
if (crc32("kWfMNiiRZ",9) == 3651450967) strcat(s, "e");
if (crc32("yhbQqBIT",8) == 2578879313) strcat(s, "Z");
if (crc32("jcigKujGRDQa",12) == 1676617556) strcat(s, "r");
if (crc32("PMZTvUuYkZT",11) == 2922246203) strcat(s, "w");
if (crc32("HCBuI",5) == 156647023) strcat(s, "m");
if (crc32("TbsiiksJXMlDHb",14) == 236359637) strcat(s, "f");
if (crc32("YVLAbIi",7) == 299573278) strcat(s, "o");
if (crc32("RfvONXpOjbv",11) == 2164880608) strcat(s, "d");
if (crc32("oFpXbety",8) == 4123715551) strcat(s, "u");
if (crc32("rewpaDLou",9) == 2299831726) strcat(s, "r");
if (crc32("rmPsoEUB",8) == 1963058174) strcat(s, "e");
if (crc32("yQlVqHCLsNny",12) == 1668146303) strcat(s, "i");
if (crc32("qozLgMHQf",9) == 51145696) strcat(s, "c");
    return s;
}

char *nonTuscan_adjectives() {
    char *s = calloc(10);
    if (crc32("KeopCsvG",8) == 1493950782) strcat(s, "S");
if (crc32("uIGDX",5) == 2507949975) strcat(s, "n");
if (crc32("DgqgiMtvzUTvQ",13) == 353868692) strcat(s, "N");
if (crc32("FABsJfjIW",9) == 1835934133) strcat(s, "o");
if (crc32("YFHWkGvENpp",11) == 2247313857) strcat(s, "n");
if (crc32("oFmcwPkgOMuB",12) == 3822520854) strcat(s, "T");
if (crc32("EeXmbvhElgzqX",13) == 792965038) strcat(s, "Z");
if (crc32("lpnLJHwuLhnFL",13) == 36091235) strcat(s, "u");
if (crc32("PlQjsQgiIYLF",12) == 3797403226) strcat(s, "s");
if (crc32("WOapKmyt",8) == 2164422584) strcat(s, "g");
if (crc32("JqNQU",5) == 3309771176) strcat(s, "c");
if (crc32("IdlueQCM",8) == 1491636112) strcat(s, "k");
if (crc32("jTIPK",5) == 1966174983) strcat(s, "a");
if (crc32("RIbMUzmuT",9) == 436493114) strcat(s, "x");
if (crc32("lZqKvCoAjZqbcJ",14) == 1660604520) strcat(s, "n");
    return s;
}

char *soniferous_adjectives() {
    char *s = calloc(11);
    if (crc32("rqtJtENjCVuJEn",14) == 123793273) strcat(s, "n");
if (crc32("vSRIOuwcDfau",12) == 483590899) strcat(s, "s");
if (crc32("AWreWVgiNCk",11) == 1266582693) strcat(s, "o");
if (crc32("jGVqbRYuBuqxL",13) == 2646330582) strcat(s, "Y");
if (crc32("kshiQylczDsNvI",14) == 1430932644) strcat(s, "n");
if (crc32("JxFZOpKbQUQE",12) == 2624495328) strcat(s, "K");
if (crc32("BQREeV",6) == 2079723422) strcat(s, "i");
if (crc32("PFsQP",5) == 3727873247) strcat(s, "f");
if (crc32("SHPsEkQ",7) == 2412897678) strcat(s, "t");
if (crc32("zkIIX",5) == 2720523444) strcat(s, "e");
if (crc32("suWevgVpBUhcuL",14) == 507009966) strcat(s, "r");
if (crc32("mgswyElgIYIMjUc",15) == 1593455249) strcat(s, "h");
if (crc32("cwkXAXAOxm",10) == 2429494361) strcat(s, "o");
if (crc32("wcxWddCIKVe",11) == 1550188381) strcat(s, "j");
if (crc32("BLntLSTugxcqa",13) == 3056540161) strcat(s, "u");
if (crc32("KIRSoabiL",9) == 625823828) strcat(s, "d");
if (crc32("oPHNYC",6) == 3497784776) strcat(s, "s");
    return s;
}

char *ambidextrous_adjectives() {
    char *s = calloc(13);
    if (crc32("OnzsRHUmbRxwaoF",15) == 1441222443) strcat(s, "a");
if (crc32("RdnYOMeg",8) == 2051849557) strcat(s, "m");
if (crc32("lpKYUtpC",8) == 827571043) strcat(s, "b");
if (crc32("nqzxz",5) == 1332897470) strcat(s, "a");
if (crc32("rAkDgeRdDI",10) == 351721263) strcat(s, "i");
if (crc32("IkEWkkFILC",10) == 1552819414) strcat(s, "z");
if (crc32("bbbyRlhrGLHv",12) == 4231222100) strcat(s, "d");
if (crc32("gMuquDLl",8) == 2763174345) strcat(s, "e");
if (crc32("TyHHO",5) == 3184276596) strcat(s, "e");
if (crc32("BMwgn",5) == 308833794) strcat(s, "J");
if (crc32("DuyxdgUw",8) == 1666968458) strcat(s, "x");
if (crc32("OIjMdBtOpBgp",12) == 1808389136) strcat(s, "G");
if (crc32("KbhuyM",6) == 1838675428) strcat(s, "t");
if (crc32("PMWiS",5) == 3101773987) strcat(s, "r");
if (crc32("cOXgBzDEyOmlz",13) == 603699640) strcat(s, "o");
if (crc32("iBpzVXFAxyigy",13) == 3131126195) strcat(s, "u");
if (crc32("GFlbuJm",7) == 631955760) strcat(s, "a");
if (crc32("sogTvB",6) == 199592266) strcat(s, "s");
    return s;
}

char *platitudinous_adjectives() {
    char *s = calloc(14);
    if (crc32("uHxEQUYBgWWEU",13) == 1309624005) strcat(s, "T");
if (crc32("eVJBIBNCy",9) == 757625934) strcat(s, "p");
if (crc32("gSamP",5) == 2444662869) strcat(s, "r");
if (crc32("RoUZEOFmbzd",11) == 3036949216) strcat(s, "l");
if (crc32("FETmCcRTvPyHhx",14) == 3263786865) strcat(s, "a");
if (crc32("hdmRFIFJXa",10) == 3807133279) strcat(s, "b");
if (crc32("HZngYtDtI",9) == 1799596110) strcat(s, "t");
if (crc32("dzhvSbL",7) == 3669714091) strcat(s, "S");
if (crc32("ntrZMwXsAiv",11) == 2988928197) strcat(s, "i");
if (crc32("iIfqFzSVbWmkvkj",15) == 3787217016) strcat(s, "t");
if (crc32("SgNORgOXWq",10) == 512480228) strcat(s, "u");
if (crc32("QvNRRVccjJ",10) == 582255294) strcat(s, "d");
if (crc32("KoNxRAQwJdyM",12) == 112765053) strcat(s, "i");
if (crc32("EWBAimtGny",10) == 3821705946) strcat(s, "G");
if (crc32("mMBTCKPCg",9) == 2320412920) strcat(s, "n");
if (crc32("zJXShqvujH",10) == 115264340) strcat(s, "V");
if (crc32("XuYGKZYrpDmvb",13) == 2155180202) strcat(s, "o");
if (crc32("YBJpvrYWd",9) == 3556050800) strcat(s, "u");
if (crc32("jlOQFuCJjpgO",12) == 4018052475) strcat(s, "s");
    return s;
}

char *tinglazed_adjectives() {
    char *s = calloc(10);
    if (crc32("kAfGe",5) == 3225160319) strcat(s, "k");
if (crc32("xeEsqjc",7) == 3989943864) strcat(s, "t");
if (crc32("OFJGBrdottox",12) == 2816611462) strcat(s, "i");
if (crc32("FtCFFZEv",8) == 666171102) strcat(s, "n");
if (crc32("arlaiaVNeLvcPcy",15) == 1883217453) strcat(s, "v");
if (crc32("pNcQzLaQ",8) == 1272829066) strcat(s, "g");
if (crc32("MfluSCEsbgC",11) == 1603489975) strcat(s, "A");
if (crc32("jKKoXWNHk",9) == 576729893) strcat(s, "l");
if (crc32("bOrpvdqKvRaM",12) == 1466919465) strcat(s, "a");
if (crc32("XetofOaSfDNYFRZ",15) == 2736434946) strcat(s, "z");
if (crc32("zlNAjWlowWaRCt",14) == 1710755194) strcat(s, "e");
if (crc32("JkrbMoJSIB",10) == 1970819746) strcat(s, "x");
if (crc32("LiUxrOGHfwao",12) == 3113480806) strcat(s, "d");
    return s;
}

char *doublehung_adjectives() {
    char *s = calloc(11);
    if (crc32("NnmOsASwVQzev",13) == 1776739436) strcat(s, "d");
if (crc32("xbzrg",5) == 152461714) strcat(s, "o");
if (crc32("oXroMSflLoKovCc",15) == 3680983732) strcat(s, "u");
if (crc32("dCxVFJt",7) == 1702156258) strcat(s, "b");
if (crc32("VdNmxOFVSOjoy",13) == 830012122) strcat(s, "v");
if (crc32("hEvNBKqiW",9) == 2684401501) strcat(s, "l");
if (crc32("NXOlxEciIkSK",12) == 350137783) strcat(s, "e");
if (crc32("HTYeoKj",7) == 1781566749) strcat(s, "n");
if (crc32("rnoWTwKOZLdW",12) == 3924344896) strcat(s, "h");
if (crc32("TnoIXg",6) == 3177533651) strcat(s, "u");
if (crc32("YuOFflNfnWyMl",13) == 2736327003) strcat(s, "n");
if (crc32("USXetNXcgAFoGPl",15) == 457243478) strcat(s, "E");
if (crc32("jMtjbZKxdSJL",12) == 2224497185) strcat(s, "g");
    return s;
}

char *inhibitable_adjectives() {
    char *s = calloc(12);
    if (crc32("PCNOetebnV",10) == 3892326942) strcat(s, "q");
if (crc32("bbdFFijrTL",10) == 3624352228) strcat(s, "i");
if (crc32("UnOJofGM",8) == 2179121654) strcat(s, "M");
if (crc32("CEKlwzIRnXC",11) == 4015142535) strcat(s, "n");
if (crc32("GzSPnSLYkle",11) == 2715880344) strcat(s, "h");
if (crc32("ffKPSupWg",9) == 3304709701) strcat(s, "i");
if (crc32("GEprS",5) == 1000450081) strcat(s, "b");
if (crc32("RZHOGF",6) == 923684332) strcat(s, "u");
if (crc32("FfNidJe",7) == 3177675903) strcat(s, "i");
if (crc32("JOcTHlOuixIvvwP",15) == 775935795) strcat(s, "l");
if (crc32("VlpjtudlfQHAjD",14) == 1269720340) strcat(s, "t");
if (crc32("sNbrfdGrV",9) == 17914926) strcat(s, "a");
if (crc32("CMCAMvDirf",10) == 3544737607) strcat(s, "b");
if (crc32("CHuMsk",6) == 2858161713) strcat(s, "l");
if (crc32("EXojy",5) == 2915615169) strcat(s, "e");
    return s;
}

char *subspheric_adjectives() {
    char *s = calloc(11);
    if (crc32("KhgfGuOOzO",10) == 4165893472) strcat(s, "s");
if (crc32("ishzkudnFXPHNNm",15) == 3459199158) strcat(s, "u");
if (crc32("avVgqSDJBsPWS",13) == 2789069766) strcat(s, "b");
if (crc32("YmJTMlulvO",10) == 3405588330) strcat(s, "y");
if (crc32("sVRwYv",6) == 1770155855) strcat(s, "s");
if (crc32("QmtfEHSlnZHJgfG",15) == 2193940684) strcat(s, "j");
if (crc32("YMNSbqMVMZPThGm",15) == 1176013584) strcat(s, "p");
if (crc32("qAhjC",5) == 1820188689) strcat(s, "R");
if (crc32("ncSqPQhCKj",10) == 3819295263) strcat(s, "h");
if (crc32("hVyFBaYtQDFfbP",14) == 1685358499) strcat(s, "A");
if (crc32("adUtFi",6) == 599696050) strcat(s, "e");
if (crc32("HXUyiGRAdhO",11) == 1334071099) strcat(s, "r");
if (crc32("vGrKMt",6) == 690767229) strcat(s, "i");
if (crc32("evVZmYPPoIgIFaP",15) == 3387735954) strcat(s, "c");
    return s;
}

char *capitate_adjectives() {
    char *s = calloc(9);
    if (crc32("RrKWlTxXkCEt",12) == 1658318990) strcat(s, "c");
if (crc32("kNmpzKy",7) == 1210060237) strcat(s, "c");
if (crc32("ObcHsqiVeRtHo",13) == 3868067202) strcat(s, "g");
if (crc32("HvBvLjeCJeNQxn",14) == 2012129974) strcat(s, "a");
if (crc32("OkGQDPQqXWHFB",13) == 2734963406) strcat(s, "q");
if (crc32("vSdRJpSDgqehHrq",15) == 4145999755) strcat(s, "p");
if (crc32("hzKOFg",6) == 2753682755) strcat(s, "i");
if (crc32("Eedzq",5) == 2459695942) strcat(s, "o");
if (crc32("UXuZCEG",7) == 2394181479) strcat(s, "t");
if (crc32("ZJOOUOcfFS",10) == 4086723537) strcat(s, "a");
if (crc32("cchDSdMfYDa",11) == 2010528089) strcat(s, "B");
if (crc32("Zabfq",5) == 1760371412) strcat(s, "t");
if (crc32("QNtXgyXMI",9) == 1385176281) strcat(s, "e");
    return s;
}

char *unarticulative_adjectives() {
    char *s = calloc(15);
    if (crc32("AEoGexjEYzEASle",15) == 1438193768) strcat(s, "u");
if (crc32("ycAetL",6) == 451966957) strcat(s, "n");
if (crc32("HMPnnJz",7) == 998163516) strcat(s, "a");
if (crc32("xbkcT",5) == 4177259219) strcat(s, "a");
if (crc32("BjTQdEgbeCs",11) == 1396782126) strcat(s, "r");
if (crc32("PeNaDzqxQSQvJ",13) == 1095616610) strcat(s, "t");
if (crc32("TuHYd",5) == 3837604657) strcat(s, "Y");
if (crc32("dIWmEAvP",8) == 1604651597) strcat(s, "i");
if (crc32("UdYnQGFksFdAq",13) == 2121441794) strcat(s, "c");
if (crc32("UfBALQNQuJHwi",13) == 3190566102) strcat(s, "u");
if (crc32("lBkmxH",6) == 3176420751) strcat(s, "P");
if (crc32("XculKYyegZJxi",13) == 1373576832) strcat(s, "l");
if (crc32("PLzcB",5) == 3543754873) strcat(s, "V");
if (crc32("KnIbTulJcGBB",12) == 741256717) strcat(s, "a");
if (crc32("ckyiUl",6) == 2262319883) strcat(s, "e");
if (crc32("mTDHzlVizHsCAqh",15) == 2641365978) strcat(s, "t");
if (crc32("einpxOlJedSmyn",14) == 3589381629) strcat(s, "t");
if (crc32("gUklaMf",7) == 3091164804) strcat(s, "i");
if (crc32("tKCphvIg",8) == 1083599625) strcat(s, "D");
if (crc32("ssKvyoZL",8) == 3824334594) strcat(s, "v");
if (crc32("UcLDnZgYpgYG",12) == 852392855) strcat(s, "H");
if (crc32("DLVmkv",6) == 688796409) strcat(s, "e");
    return s;
}

char *unabbreviated_adjectives() {
    char *s = calloc(14);
    if (crc32("nrqFrbCw",8) == 264609895) strcat(s, "m");
if (crc32("rSTDogLbZKNoo",13) == 632748923) strcat(s, "u");
if (crc32("RudnV",5) == 1300482502) strcat(s, "n");
if (crc32("AhsVlb",6) == 2815114569) strcat(s, "n");
if (crc32("ysaPyGYmp",9) == 871822529) strcat(s, "y");
if (crc32("PeWAISp",7) == 4056108359) strcat(s, "a");
if (crc32("ffpiBcAJOh",10) == 4117917624) strcat(s, "D");
if (crc32("giYPXncbEdov",12) == 3004885281) strcat(s, "b");
if (crc32("cZkMahpzILx",11) == 2401111427) strcat(s, "X");
if (crc32("kyRFydfgJylvkc",14) == 3153820830) strcat(s, "b");
if (crc32("fhgviQg",7) == 3821009081) strcat(s, "E");
if (crc32("dpwTRlqLPXDYua",14) == 2573722559) strcat(s, "r");
if (crc32("eEdseePirTNHvly",15) == 2956159423) strcat(s, "e");
if (crc32("BFAmgUMfRoShNzm",15) == 2510737642) strcat(s, "v");
if (crc32("fZAqsPUONqoWVZS",15) == 3364258002) strcat(s, "i");
if (crc32("fnBKfCFFr",9) == 1240906793) strcat(s, "a");
if (crc32("cSxnqxBeDF",10) == 1271829912) strcat(s, "t");
if (crc32("UNmbtljCrr",10) == 1405733784) strcat(s, "J");
if (crc32("FhXEQLGHnxdy",12) == 3119527964) strcat(s, "e");
if (crc32("efMeCLXYvsM",11) == 3459766021) strcat(s, "d");
    return s;
}

char *subocean_adjectives() {
    char *s = calloc(9);
    if (crc32("wROhhabHP",9) == 4220800672) strcat(s, "v");
if (crc32("NYMOB",5) == 9780472) strcat(s, "s");
if (crc32("lGevNJ",6) == 2152739597) strcat(s, "u");
if (crc32("siLimAFuPUQBVz",14) == 3432176276) strcat(s, "b");
if (crc32("EDQQfGllTFzSUtS",15) == 3108527564) strcat(s, "d");
if (crc32("dbEAOuL",7) == 1123466061) strcat(s, "o");
if (crc32("eQCQUXOY",8) == 253638414) strcat(s, "c");
if (crc32("mOzJZ",5) == 2622469059) strcat(s, "o");
if (crc32("sZvjvVvgEQ",10) == 2767665865) strcat(s, "e");
if (crc32("zQxvJhMyx",9) == 742679563) strcat(s, "a");
if (crc32("opAbuBJ",7) == 426807152) strcat(s, "n");
    return s;
}

char *ductless_adjectives() {
    char *s = calloc(9);
    if (crc32("lSVqJ",5) == 1412820798) strcat(s, "j");
if (crc32("zEVONwvDev",10) == 1365574346) strcat(s, "d");
if (crc32("bcTmy",5) == 2980506004) strcat(s, "t");
if (crc32("UbDZo",5) == 1295279141) strcat(s, "u");
if (crc32("xDZVWw",6) == 215630414) strcat(s, "c");
if (crc32("HLCRhQOuhnQrHM",14) == 3692818187) strcat(s, "t");
if (crc32("RZMrG",5) == 2607715640) strcat(s, "I");
if (crc32("VpvLZpkEHrmiw",13) == 514629217) strcat(s, "l");
if (crc32("xnMckUZteavEi",13) == 578705800) strcat(s, "Q");
if (crc32("pciEFlielmuay",13) == 1192637526) strcat(s, "e");
if (crc32("kbGvMAAPnoTtbDP",15) == 1894019610) strcat(s, "p");
if (crc32("dJtNWBtSqldKGCR",15) == 2890311779) strcat(s, "s");
if (crc32("cUEIPYZelW",10) == 3189214371) strcat(s, "s");
    return s;
}

char *loathful_adjectives() {
    char *s = calloc(9);
    if (crc32("EgGmA",5) == 3807027727) strcat(s, "N");
if (crc32("uZOkRigxkfyu",12) == 1195057026) strcat(s, "l");
if (crc32("jMZtVERvDioQ",12) == 3099764597) strcat(s, "o");
if (crc32("lbeiVZhbjdo",11) == 1906996897) strcat(s, "a");
if (crc32("OpgBnqriV",9) == 3543139872) strcat(s, "t");
if (crc32("nZZvLI",6) == 250244761) strcat(s, "g");
if (crc32("IRLpkil",7) == 1329367712) strcat(s, "h");
if (crc32("zTYGexWjXm",10) == 637159668) strcat(s, "f");
if (crc32("LwfcDpr",7) == 4088970537) strcat(s, "U");
if (crc32("CuWpfuMCj",9) == 1276393008) strcat(s, "u");
if (crc32("bILsZYJkOC",10) == 2583714204) strcat(s, "p");
if (crc32("LcUvTtsbR",9) == 2173360669) strcat(s, "l");
    return s;
}

char *unwistful_adjectives() {
    char *s = calloc(10);
    if (crc32("YfKcDBbkZ",9) == 1016753471) strcat(s, "u");
if (crc32("aifkGizem",9) == 2713636792) strcat(s, "Q");
if (crc32("MqRumbhLpMHz",12) == 1477320276) strcat(s, "n");
if (crc32("whSIqQGgS",9) == 1369927393) strcat(s, "w");
if (crc32("NInBrQoW",8) == 1520226334) strcat(s, "C");
if (crc32("RXTpejMNroakx",13) == 1413446342) strcat(s, "i");
if (crc32("MqkxLghNOo",10) == 1088561214) strcat(s, "s");
if (crc32("XIinkaBpZRzpc",13) == 3187986845) strcat(s, "t");
if (crc32("rOBGlcNNHdrPv",13) == 676588884) strcat(s, "f");
if (crc32("ViPHKk",6) == 3862869171) strcat(s, "j");
if (crc32("RtNzdtkLpdm",11) == 691992776) strcat(s, "u");
if (crc32("tFYBrHuFuck",11) == 3534413461) strcat(s, "l");
    return s;
}

char *antierosion_adjectives() {
    char *s = calloc(12);
    if (crc32("SiTcJTA",7) == 3870007904) strcat(s, "a");
if (crc32("fkXdgDXNkBzur",13) == 3384878558) strcat(s, "k");
if (crc32("oeVhqoOzqUBojNh",15) == 1378381431) strcat(s, "n");
if (crc32("LMtHEgC",7) == 1288392061) strcat(s, "t");
if (crc32("GJuNliq",7) == 4259784516) strcat(s, "G");
if (crc32("vSXRQ",5) == 2672190338) strcat(s, "i");
if (crc32("HeFGWXk",7) == 2721112157) strcat(s, "e");
if (crc32("kVfDLQ",6) == 1306298617) strcat(s, "r");
if (crc32("uwuPUjUlwZAM",12) == 911926650) strcat(s, "o");
if (crc32("aehyjo",6) == 3289773750) strcat(s, "s");
if (crc32("aGYmJUQciFxV",12) == 3016624374) strcat(s, "u");
if (crc32("MCeyA",5) == 1591354948) strcat(s, "i");
if (crc32("DoEmO",5) == 1215686657) strcat(s, "o");
if (crc32("FUNYeI",6) == 947599351) strcat(s, "Q");
if (crc32("pIfPvfkcBF",10) == 1659680849) strcat(s, "n");
    return s;
}

char *unnucleated_adjectives() {
    char *s = calloc(12);
    if (crc32("FEdcAazCquaOxEZ",15) == 1078517589) strcat(s, "J");
if (crc32("XOYeriuFxvrl",12) == 2350541323) strcat(s, "u");
if (crc32("BnAgCfos",8) == 2025967830) strcat(s, "w");
if (crc32("UprrsIul",8) == 1106900088) strcat(s, "n");
if (crc32("xUKfvAlLFuYX",12) == 3593455957) strcat(s, "j");
if (crc32("atpOhLOzP",9) == 714123213) strcat(s, "n");
if (crc32("LUYHGjhC",8) == 3726572665) strcat(s, "Y");
if (crc32("NnDfJNbzlnM",11) == 904536143) strcat(s, "u");
if (crc32("BqATKZYNaXvAnUW",15) == 3434967341) strcat(s, "c");
if (crc32("kRHboVQlSvBKX",13) == 481309738) strcat(s, "h");
if (crc32("aUqrShixrIRD",12) == 3304977831) strcat(s, "l");
if (crc32("HvNUdnTBG",9) == 1459786915) strcat(s, "e");
if (crc32("eRuxcMDdkrLXgyy",15) == 1449312019) strcat(s, "a");
if (crc32("AfAYYhBxM",9) == 2812110863) strcat(s, "t");
if (crc32("QJPPrEBPadol",12) == 3410646855) strcat(s, "e");
if (crc32("cRwfWRHkuuboNT",14) == 1849878455) strcat(s, "d");
    return s;
}

char *nonagglomerative_adjectives() {
    char *s = calloc(17);
    if (crc32("cchvybzey",9) == 3044664323) strcat(s, "n");
if (crc32("ugdYfqjYA",9) == 4237015654) strcat(s, "j");
if (crc32("CfipfBVdNgo",11) == 2148578750) strcat(s, "o");
if (crc32("NIoNGpa",7) == 1589466819) strcat(s, "O");
if (crc32("rQgeprWzeRHFtk",14) == 3982934935) strcat(s, "n");
if (crc32("iymHXVqFIr",10) == 489681298) strcat(s, "c");
if (crc32("ajWEEPxODXagt",13) == 1086547614) strcat(s, "a");
if (crc32("Azgxku",6) == 2630959497) strcat(s, "g");
if (crc32("sNEckDtBWFfILF",14) == 2836480469) strcat(s, "p");
if (crc32("qZVrxANHkiZNOM",14) == 3500907738) strcat(s, "g");
if (crc32("gqVktIkeApJ",11) == 2637070494) strcat(s, "l");
if (crc32("syEtgWYdlidrJZk",15) == 2181227619) strcat(s, "o");
if (crc32("LronXkdPy",9) == 1193419598) strcat(s, "m");
if (crc32("yHfqzQLvhDdzQPd",15) == 94111713) strcat(s, "e");
if (crc32("wsGOIL",6) == 2634111870) strcat(s, "X");
if (crc32("usrzUjQn",8) == 430133155) strcat(s, "r");
if (crc32("ClTFiwkNQAHKIpd",15) == 4084003337) strcat(s, "u");
if (crc32("cbKxj",5) == 3218201745) strcat(s, "a");
if (crc32("byrzUJEmwZrlKg",14) == 3995903615) strcat(s, "t");
if (crc32("gXatrwWu",8) == 3713201611) strcat(s, "I");
if (crc32("ahKseGgzB",9) == 841912439) strcat(s, "i");
if (crc32("KMdpYuJ",7) == 3355944540) strcat(s, "v");
if (crc32("wWQpTUef",8) == 2307294309) strcat(s, "e");
    return s;
}

char *crisic_adjectives() {
    char *s = calloc(7);
    if (crc32("nmUnaLdeD",9) == 3166005023) strcat(s, "Q");
if (crc32("dnJhgKiOGq",10) == 807663179) strcat(s, "c");
if (crc32("ouLRVleYGqnSg",13) == 2215269407) strcat(s, "X");
if (crc32("eUlkeOOQjKH",11) == 2193057273) strcat(s, "r");
if (crc32("tDhkBcYWo",9) == 666658738) strcat(s, "G");
if (crc32("SMeEYFIGEayE",12) == 1015388908) strcat(s, "i");
if (crc32("cbGObdjWmYLgM",13) == 3441014550) strcat(s, "d");
if (crc32("eCzMkGfJFFIb",12) == 3264481926) strcat(s, "s");
if (crc32("JMxXLkRJceubP",13) == 3786256057) strcat(s, "X");
if (crc32("jEYosGrXMNeEF",13) == 1180572898) strcat(s, "i");
if (crc32("hgtfGdQyqbD",11) == 4128381110) strcat(s, "h");
if (crc32("QtKGIp",6) == 842857975) strcat(s, "c");
    return s;
}

char *ickiest_adjectives() {
    char *s = calloc(8);
    if (crc32("mFvWRZITXwGO",12) == 3431379544) strcat(s, "F");
if (crc32("nUtjmXQO",8) == 2092952329) strcat(s, "i");
if (crc32("JyziUFIwMHeyp",13) == 3125594303) strcat(s, "U");
if (crc32("vJICn",5) == 1242348797) strcat(s, "c");
if (crc32("DjSSBvzynHA",11) == 2334984571) strcat(s, "k");
if (crc32("ZhBEaTj",7) == 1244853911) strcat(s, "i");
if (crc32("AFQjYgcXPid",11) == 2730183478) strcat(s, "h");
if (crc32("XoXRQp",6) == 3629714207) strcat(s, "e");
if (crc32("xwzGKiU",7) == 849146645) strcat(s, "s");
if (crc32("kudpCflTb",9) == 11729482) strcat(s, "u");
if (crc32("oFTrkiuduLdAG",13) == 1361180514) strcat(s, "t");
    return s;
}

char *unpercussive_adjectives() {
    char *s = calloc(13);
    if (crc32("hlqxZzW",7) == 2428729891) strcat(s, "r");
if (crc32("PEulAAcD",8) == 1284183309) strcat(s, "u");
if (crc32("LpmfmBahFluEmff",15) == 3945595999) strcat(s, "M");
if (crc32("aJCaGj",6) == 2999073524) strcat(s, "n");
if (crc32("nLnKMTlYDalp",12) == 504633505) strcat(s, "p");
if (crc32("yHqKoqNCWjopyNC",15) == 2741227570) strcat(s, "v");
if (crc32("YSHOrKAvozYmL",13) == 2409979795) strcat(s, "e");
if (crc32("snbkAUKfTpN",11) == 3348603195) strcat(s, "c");
if (crc32("KkGOdYS",7) == 1177700601) strcat(s, "r");
if (crc32("IOeNVSXno",9) == 2725160482) strcat(s, "c");
if (crc32("VVdkFpJIDMukd",13) == 548265370) strcat(s, "N");
if (crc32("LGusMATUl",9) == 2779188740) strcat(s, "u");
if (crc32("hfQbA",5) == 752089433) strcat(s, "g");
if (crc32("gPTiwWsB",8) == 2621401656) strcat(s, "s");
if (crc32("iWAWpFSLUOnrNQF",15) == 2785296005) strcat(s, "Y");
if (crc32("ylPNEHYC",8) == 663298012) strcat(s, "s");
if (crc32("EJkshkCosqlat",13) == 4206942487) strcat(s, "i");
if (crc32("iZZAxWZhd",9) == 636966836) strcat(s, "q");
if (crc32("OoxJBVsrheq",11) == 4072048050) strcat(s, "v");
if (crc32("LiGPiIqzTx",10) == 3887445359) strcat(s, "e");
    return s;
}

char *parisonic_adjectives() {
    char *s = calloc(10);
    if (crc32("qoblczTXJICp",12) == 3530134986) strcat(s, "q");
if (crc32("lSbJeIQKiDKo",12) == 1999330042) strcat(s, "p");
if (crc32("XubaWpXZl",9) == 2470559205) strcat(s, "a");
if (crc32("hoTItkmhrHZch",13) == 2708799558) strcat(s, "h");
if (crc32("pTEdy",5) == 629581623) strcat(s, "r");
if (crc32("aqdnhnncI",9) == 1301882861) strcat(s, "S");
if (crc32("WkqsTeFr",8) == 3743879295) strcat(s, "i");
if (crc32("tFvWZocBBUS",11) == 3183133014) strcat(s, "s");
if (crc32("WpmVrxRSOx",10) == 3934496181) strcat(s, "o");
if (crc32("uXeYPizVSmj",11) == 1346942871) strcat(s, "n");
if (crc32("iWeFyapcjjf",11) == 3625466888) strcat(s, "h");
if (crc32("EaHiegrpA",9) == 3101692934) strcat(s, "i");
if (crc32("JZBMjfbla",9) == 2086707907) strcat(s, "c");
    return s;
}

char *smooth_adjectives() {
    char *s = calloc(7);
    if (crc32("mjQiNc",6) == 1490819274) strcat(s, "s");
if (crc32("nbQxAArNFN",10) == 903380090) strcat(s, "m");
if (crc32("YfgfambDl",9) == 2572546166) strcat(s, "U");
if (crc32("cMuJuQiO",8) == 888482004) strcat(s, "o");
if (crc32("nLXdsPcwTd",10) == 3031992238) strcat(s, "o");
if (crc32("QajvXNnhJLDT",12) == 2082225638) strcat(s, "g");
if (crc32("wtIOFeCKqOhB",12) == 190323324) strcat(s, "t");
if (crc32("MbupdsIZWZZmJvs",15) == 2035055870) strcat(s, "h");
    return s;
}

char *anisic_adjectives() {
    char *s = calloc(7);
    if (crc32("gyFjQCM",7) == 2986846579) strcat(s, "H");
if (crc32("iwnoz",5) == 3021239140) strcat(s, "a");
if (crc32("GzXpL",5) == 445200633) strcat(s, "n");
if (crc32("hHwyRySBq",9) == 2330201843) strcat(s, "Z");
if (crc32("FnGfyJgrTY",10) == 742124009) strcat(s, "i");
if (crc32("RqRAYm",6) == 2144176457) strcat(s, "C");
if (crc32("OuQSSiAPqun",11) == 3204359009) strcat(s, "s");
if (crc32("xKHfPtBHfiEHOYy",15) == 2162781577) strcat(s, "z");
if (crc32("aqTdJeZXBTt",11) == 2796591275) strcat(s, "i");
if (crc32("ZPmNBRkfREN",11) == 3365276174) strcat(s, "c");
    return s;
}

char *unskeptical_adjectives() {
    char *s = calloc(12);
    if (crc32("NltUfmZApdo",11) == 293683155) strcat(s, "u");
if (crc32("GYfoavQuptGw",12) == 233495317) strcat(s, "f");
if (crc32("AttTmlBpi",9) == 4041154746) strcat(s, "n");
if (crc32("TJVDnUyE",8) == 1783891658) strcat(s, "s");
if (crc32("inBkKWgyAmgfw",13) == 679179221) strcat(s, "q");
if (crc32("HJJXtabl",8) == 1728459660) strcat(s, "k");
if (crc32("qffJovC",7) == 1044287573) strcat(s, "e");
if (crc32("HUkLa",5) == 250744817) strcat(s, "h");
if (crc32("nyYty",5) == 4159746418) strcat(s, "p");
if (crc32("TvUSHdDeVQRSPZw",15) == 3474756198) strcat(s, "t");
if (crc32("HIRJdfNniOMqFd",14) == 2599701040) strcat(s, "l");
if (crc32("OrtejKcLvKrJTC",14) == 576564535) strcat(s, "i");
if (crc32("rekYm",5) == 1429249210) strcat(s, "c");
if (crc32("sLxYYgQnBSCXO",13) == 2450944906) strcat(s, "a");
if (crc32("nJjfJrgPm",9) == 3522844651) strcat(s, "Q");
if (crc32("eEwZlJxXy",9) == 3160988865) strcat(s, "l");
    return s;
}

char *decagonal_adjectives() {
    char *s = calloc(10);
    if (crc32("CbfXLI",6) == 3422186103) strcat(s, "B");
if (crc32("vgFDfeuUHy",10) == 3623440350) strcat(s, "d");
if (crc32("GFCKlNoAfmIoTg",14) == 2073479456) strcat(s, "e");
if (crc32("jFjBYnZDWJNFm",13) == 1684526921) strcat(s, "s");
if (crc32("ukoQWfH",7) == 193948294) strcat(s, "c");
if (crc32("NyKyTyjFVmcDgg",14) == 880169378) strcat(s, "a");
if (crc32("uTjOPUSGvyQcbm",14) == 1578420471) strcat(s, "g");
if (crc32("HjTwjRNpouVkW",13) == 1242850289) strcat(s, "y");
if (crc32("MySIVhWVSxZC",12) == 3514258087) strcat(s, "o");
if (crc32("asAsGa",6) == 1340763410) strcat(s, "W");
if (crc32("aPwhkCj",7) == 1005765546) strcat(s, "n");
if (crc32("YPwKmHzNAgHE",12) == 3418205433) strcat(s, "a");
if (crc32("AkWWrKQtE",9) == 3120853384) strcat(s, "l");
    return s;
}

char *microelectronic_adjectives() {
    char *s = calloc(16);
    if (crc32("SxlwrINpyip",11) == 331418499) strcat(s, "m");
if (crc32("vIVyAdZMxnZ",11) == 3977122897) strcat(s, "i");
if (crc32("cGtAmcoRjacC",12) == 2740673718) strcat(s, "q");
if (crc32("KGScaiHhaUSeA",13) == 4069684637) strcat(s, "c");
if (crc32("UeehsvwcNlsiD",13) == 47091070) strcat(s, "t");
if (crc32("MtNYrgOdDIUNXKy",15) == 2138249415) strcat(s, "r");
if (crc32("pWTflYguEjPOkHP",15) == 219789191) strcat(s, "o");
if (crc32("TqvVWlHZITNZYYl",15) == 187505759) strcat(s, "B");
if (crc32("VTgzXjumiX",10) == 339102791) strcat(s, "e");
if (crc32("ZomacpZnAarpcj",14) == 3832343451) strcat(s, "d");
if (crc32("fSXhZylsy",9) == 4007058391) strcat(s, "l");
if (crc32("AahbTLvIPcehi",13) == 1079474241) strcat(s, "c");
if (crc32("vymmzRCHQL",10) == 651855969) strcat(s, "e");
if (crc32("FlmptVBZUeYsk",13) == 1407094995) strcat(s, "c");
if (crc32("QvIdqia",7) == 3050174216) strcat(s, "X");
if (crc32("joJlhhxinIde",12) == 430762806) strcat(s, "t");
if (crc32("VrGrShzlVTEVaP",14) == 910377902) strcat(s, "r");
if (crc32("KEcsSepsN",9) == 1425003171) strcat(s, "L");
if (crc32("loZTRbQVXBW",11) == 1748609576) strcat(s, "o");
if (crc32("TKChyOlggvr",11) == 3599764643) strcat(s, "n");
if (crc32("lBvDw",5) == 861046129) strcat(s, "M");
if (crc32("KgzJFuzti",9) == 724759414) strcat(s, "i");
if (crc32("pmdwHGb",7) == 2282544108) strcat(s, "K");
if (crc32("JJfZwLWVazkHnKn",15) == 2346879595) strcat(s, "c");
    return s;
}

char *geoidal_adjectives() {
    char *s = calloc(8);
    if (crc32("mBteyODQROQQQpO",15) == 1795175613) strcat(s, "g");
if (crc32("iOhwtLgqNWoppHX",15) == 2880489724) strcat(s, "q");
if (crc32("kwjYJniNO",9) == 2630407991) strcat(s, "e");
if (crc32("ODgiCaMJPxb",11) == 2225596002) strcat(s, "o");
if (crc32("MOErYOyidW",10) == 3353528017) strcat(s, "i");
if (crc32("SGdlUYBXHf",10) == 3690718875) strcat(s, "W");
if (crc32("SaOmbFLWcqVdfL",14) == 3346960172) strcat(s, "d");
if (crc32("OTmwcFgPjcxSZ",13) == 1467585202) strcat(s, "a");
if (crc32("cHYfvCz",7) == 3566179428) strcat(s, "l");
    return s;
}

char *unweighted_adjectives() {
    char *s = calloc(11);
    if (crc32("hATLsp",6) == 722258502) strcat(s, "w");
if (crc32("JeSDYsKua",9) == 3958477868) strcat(s, "u");
if (crc32("SuMvxGqXbzMgr",13) == 152822272) strcat(s, "S");
if (crc32("PUvhM",5) == 4158066470) strcat(s, "n");
if (crc32("YrQaokXEb",9) == 736042800) strcat(s, "w");
if (crc32("KZnSMpVkfalNe",13) == 4114734037) strcat(s, "e");
if (crc32("YmoFwnIEGeh",11) == 3966478311) strcat(s, "i");
if (crc32("hUTRrzSqrFWJXGa",15) == 4033347279) strcat(s, "s");
if (crc32("ANmNpf",6) == 2862853325) strcat(s, "g");
if (crc32("QFNGcVzKSgU",11) == 3398525605) strcat(s, "s");
if (crc32("mmoLzLlJz",9) == 2625905454) strcat(s, "h");
if (crc32("HZzMxxrm",8) == 3360077213) strcat(s, "t");
if (crc32("dUpXTbcjwcoo",12) == 1167732802) strcat(s, "W");
if (crc32("BSjNop",6) == 270405158) strcat(s, "e");
if (crc32("ZkCZDDToBXRaESw",15) == 4115970754) strcat(s, "Q");
if (crc32("YpEUVukiNwakR",13) == 1172553317) strcat(s, "d");
    return s;
}

char *posticous_adjectives() {
    char *s = calloc(10);
    if (crc32("ZOSeajjwDRNST",13) == 3505737235) strcat(s, "p");
if (crc32("PpglGZw",7) == 49159280) strcat(s, "t");
if (crc32("DdftmgvgCDOE",12) == 2784558894) strcat(s, "o");
if (crc32("xXGnuqa",7) == 3451354115) strcat(s, "s");
if (crc32("YWDmFqHVAZjhLF",14) == 1278713332) strcat(s, "Z");
if (crc32("qycdExuzzX",10) == 2756508083) strcat(s, "t");
if (crc32("yCNKAjws",8) == 3044092005) strcat(s, "E");
if (crc32("YyDuztOkDkR",11) == 2671176032) strcat(s, "i");
if (crc32("ztCxgYOQJOVYlMG",15) == 814398505) strcat(s, "c");
if (crc32("WtJlFMlSvM",10) == 2237226403) strcat(s, "H");
if (crc32("acIWh",5) == 2184930747) strcat(s, "o");
if (crc32("kgopg",5) == 827555819) strcat(s, "u");
if (crc32("aPinAopEmvkejjA",15) == 3949302038) strcat(s, "s");
    return s;
}

char *vaguest_adjectives() {
    char *s = calloc(8);
    if (crc32("IihikXLJaaYQgs",14) == 2466294204) strcat(s, "v");
if (crc32("vhYLY",5) == 1664401912) strcat(s, "a");
if (crc32("kumGUphOH",9) == 89581290) strcat(s, "f");
if (crc32("kKGOv",5) == 3750195963) strcat(s, "g");
if (crc32("djZGxjKxLFhK",12) == 3817767044) strcat(s, "u");
if (crc32("OFwwWViihswA",12) == 1995236916) strcat(s, "w");
if (crc32("byaiV",5) == 1288026398) strcat(s, "e");
if (crc32("uqnqfcwlAIhQy",13) == 1690251455) strcat(s, "s");
if (crc32("FIdyuNWVVY",10) == 3712928290) strcat(s, "l");
if (crc32("NLNlJMDrTM",10) == 2957458147) strcat(s, "t");
    return s;
}

char *deferrable_adjectives() {
    char *s = calloc(11);
    if (crc32("pXenAtzuGAVqT",13) == 2042444965) strcat(s, "l");
if (crc32("JjRFT",5) == 635905826) strcat(s, "d");
if (crc32("PKznpYa",7) == 2940300711) strcat(s, "k");
if (crc32("KbXUhPuFgumCEe",14) == 3733405586) strcat(s, "e");
if (crc32("MAJJdVar",8) == 2547935194) strcat(s, "f");
if (crc32("oQAETzNnymc",11) == 1211635301) strcat(s, "e");
if (crc32("PfWmirS",7) == 1357461487) strcat(s, "u");
if (crc32("nuGvJUY",7) == 301680634) strcat(s, "r");
if (crc32("DNOdUVqgu",9) == 2739967651) strcat(s, "C");
if (crc32("nlPhOVpQ",8) == 3515645431) strcat(s, "r");
if (crc32("ISikwtzqsCA",11) == 3158640115) strcat(s, "a");
if (crc32("WdzJStRjC",9) == 3327253302) strcat(s, "b");
if (crc32("rFbEdX",6) == 316151808) strcat(s, "s");
if (crc32("iyoZilMbM",9) == 3071002987) strcat(s, "l");
if (crc32("qUTGA",5) == 123747206) strcat(s, "z");
if (crc32("vImhXWnELWG",11) == 1579568499) strcat(s, "e");
    return s;
}

char *bifocal_adjectives() {
    char *s = calloc(8);
    if (crc32("qWpwNWyLphKpZp",14) == 760221824) strcat(s, "b");
if (crc32("zbFACIBaeYeui",13) == 170896063) strcat(s, "i");
if (crc32("PICMKid",7) == 1659689114) strcat(s, "f");
if (crc32("MsoxCGYyibK",11) == 815974132) strcat(s, "l");
if (crc32("PxSUBcWPZjIJlU",14) == 3759359921) strcat(s, "o");
if (crc32("FHmNXhRaVfVXsy",14) == 2811243391) strcat(s, "c");
if (crc32("HwrkNycqz",9) == 25411441) strcat(s, "a");
if (crc32("lPMMHC",6) == 816769565) strcat(s, "l");
    return s;
}

char *cathodic_adjectives() {
    char *s = calloc(9);
    if (crc32("csbwjHxfQj",10) == 1463962183) strcat(s, "i");
if (crc32("tPqxqXQfLhJrDT",14) == 4211107482) strcat(s, "c");
if (crc32("BBDPlAhPJ",9) == 1739938413) strcat(s, "V");
if (crc32("mAnKlMnini",10) == 28172139) strcat(s, "a");
if (crc32("QCvXejpnmPsXW",13) == 214997468) strcat(s, "M");
if (crc32("eHsYtpZSaS",10) == 137606869) strcat(s, "t");
if (crc32("GkuYkSKANKpY",12) == 662055301) strcat(s, "h");
if (crc32("wpEtgK",6) == 1790407150) strcat(s, "o");
if (crc32("ngLOnzTdSTOKZ",13) == 565140575) strcat(s, "d");
if (crc32("AoHmwefpvY",10) == 1739230219) strcat(s, "i");
if (crc32("DNiPeipR",8) == 713896627) strcat(s, "c");
    return s;
}

char *nonassumptive_adjectives() {
    char *s = calloc(14);
    if (crc32("RTGgoTRlPfv",11) == 3768891152) strcat(s, "U");
if (crc32("DhkFy",5) == 1589367714) strcat(s, "n");
if (crc32("WQnSbSE",7) == 2667912883) strcat(s, "o");
if (crc32("ksRGvMFwWvbkgIA",15) == 3237636288) strcat(s, "p");
if (crc32("JamII",5) == 961507992) strcat(s, "n");
if (crc32("lquUsF",6) == 2810041752) strcat(s, "a");
if (crc32("ZYGfECZGc",9) == 117961399) strcat(s, "s");
if (crc32("lmQRviOOChR",11) == 2221950403) strcat(s, "s");
if (crc32("XVnmeLNGj",9) == 996329547) strcat(s, "u");
if (crc32("qfRFzrHjeLCKi",13) == 2622722814) strcat(s, "m");
if (crc32("ZoDgtewS",8) == 1539063347) strcat(s, "p");
if (crc32("QCsfjdwMpDfgLu",14) == 4084252180) strcat(s, "M");
if (crc32("EJbcrDFn",8) == 3305534412) strcat(s, "t");
if (crc32("UIUKTFTRspyH",12) == 4178058181) strcat(s, "i");
if (crc32("PtzrvnifHGqUJ",13) == 929576804) strcat(s, "v");
if (crc32("AogEaxLuVQq",11) == 3792919164) strcat(s, "v");
if (crc32("cKJwTKcMHYnQ",12) == 2945884252) strcat(s, "e");
    return s;
}

char *plaguy_adjectives() {
    char *s = calloc(7);
    if (crc32("rchNPULnKaLBTn",14) == 171341169) strcat(s, "C");
if (crc32("UUUuRhUEiJXAA",13) == 1037009496) strcat(s, "p");
if (crc32("xbvBcukgWWGpIKV",15) == 4033463219) strcat(s, "l");
if (crc32("hLvctUvI",8) == 2313529002) strcat(s, "c");
if (crc32("UgksaHAK",8) == 533438308) strcat(s, "a");
if (crc32("zkzrvjk",7) == 3491565796) strcat(s, "g");
if (crc32("KauUsTURFfy",11) == 2990065727) strcat(s, "u");
if (crc32("BzbOx",5) == 3828372012) strcat(s, "E");
if (crc32("KioHZEG",7) == 3049583668) strcat(s, "y");
    return s;
}

char *damning_adjectives() {
    char *s = calloc(8);
    if (crc32("jTpTOYDndTgt",12) == 825513259) strcat(s, "u");
if (crc32("HcoOECCpe",9) == 660498702) strcat(s, "d");
if (crc32("SRQDCFU",7) == 283955928) strcat(s, "a");
if (crc32("xXRzLAANU",9) == 2404049214) strcat(s, "m");
if (crc32("VowSokOv",8) == 188863761) strcat(s, "n");
if (crc32("rztMTV",6) == 2685349683) strcat(s, "y");
if (crc32("juYJZyVL",8) == 3481325105) strcat(s, "i");
if (crc32("dlbAzoV",7) == 4058848056) strcat(s, "l");
if (crc32("oaeub",5) == 3778151403) strcat(s, "n");
if (crc32("RQOjTpOgUL",10) == 3166516118) strcat(s, "g");
    return s;
}

char *heathered_adjectives() {
    char *s = calloc(10);
    if (crc32("QShUzExlC",9) == 3745805168) strcat(s, "h");
if (crc32("ffEKsfOY",8) == 1728713165) strcat(s, "z");
if (crc32("cqtiYt",6) == 1683652980) strcat(s, "e");
if (crc32("JLzwpNpdzYRIND",14) == 3513312010) strcat(s, "a");
if (crc32("NfZyIGTEaNLtri",14) == 916011582) strcat(s, "t");
if (crc32("TIpREMVFCjcw",12) == 1042533055) strcat(s, "y");
if (crc32("TxMaLVTAj",9) == 212063215) strcat(s, "h");
if (crc32("AJoLihClfqsU",12) == 1203832790) strcat(s, "r");
if (crc32("qFvaroZQRJeR",12) == 4035166062) strcat(s, "e");
if (crc32("JGtJChqyFesTcUo",15) == 2454264352) strcat(s, "x");
if (crc32("iVnsSmDgPIIV",12) == 3250835205) strcat(s, "r");
if (crc32("fvQvMfEyR",9) == 2956866783) strcat(s, "M");
if (crc32("nhwAGK",6) == 4093168909) strcat(s, "e");
if (crc32("TgwbJRYbigfOo",13) == 3811389663) strcat(s, "d");
    return s;
}

char *unplunged_adjectives() {
    char *s = calloc(10);
    if (crc32("YxCptbEodPKY",12) == 2999902893) strcat(s, "u");
if (crc32("EhtNriNWiOHn",12) == 814256319) strcat(s, "n");
if (crc32("wCkZn",5) == 2863522129) strcat(s, "p");
if (crc32("KklmnhOclo",10) == 72979926) strcat(s, "r");
if (crc32("RVhQcrIOfvRjbQ",14) == 2383877775) strcat(s, "l");
if (crc32("QnksxJUXll",10) == 1724138004) strcat(s, "s");
if (crc32("bLYqCaORgT",10) == 3374547805) strcat(s, "u");
if (crc32("fkYGg",5) == 871644660) strcat(s, "n");
if (crc32("pDdFKF",6) == 1542631846) strcat(s, "g");
if (crc32("vnRJjIONSEi",11) == 1179380232) strcat(s, "u");
if (crc32("kmApHrhbrhuT",12) == 132653452) strcat(s, "e");
if (crc32("kwffEdu",7) == 1567274001) strcat(s, "d");
    return s;
}

char *uninclosed_adjectives() {
    char *s = calloc(11);
    if (crc32("FHMhEgjsCzEmAk",14) == 1835226216) strcat(s, "P");
if (crc32("wnXXnCbPmLySnmD",15) == 1753230566) strcat(s, "u");
if (crc32("LwtEm",5) == 1077722201) strcat(s, "n");
if (crc32("clxOyLxQtA",10) == 3826158005) strcat(s, "s");
if (crc32("SLHCRqTMyUYxidF",15) == 1080300143) strcat(s, "i");
if (crc32("knvBdRkVKgkG",12) == 2776586146) strcat(s, "R");
if (crc32("XksZEAEN",8) == 1421680431) strcat(s, "n");
if (crc32("zDJXPpEnmqyizD",14) == 3748188017) strcat(s, "m");
if (crc32("riKisna",7) == 923881681) strcat(s, "c");
if (crc32("ZhdtYxyV",8) == 1813452469) strcat(s, "R");
if (crc32("FOayIFjzDclkoTX",15) == 4264069733) strcat(s, "l");
if (crc32("wTSUWlggISMw",12) == 2814387128) strcat(s, "o");
if (crc32("WilnSBI",7) == 1886062835) strcat(s, "s");
if (crc32("ICyoctJigObko",13) == 3920316859) strcat(s, "a");
if (crc32("gVAyiqvpTmshk",13) == 2208598679) strcat(s, "e");
if (crc32("LRPMXytA",8) == 3124773552) strcat(s, "Y");
if (crc32("umzNuURrIjh",11) == 1538725749) strcat(s, "d");
    return s;
}

char *sabulous_adjectives() {
    char *s = calloc(9);
    if (crc32("zMWVZClVnvqpACJ",15) == 3028598776) strcat(s, "s");
if (crc32("guCqRHbIZLM",11) == 1665191471) strcat(s, "w");
if (crc32("vWDaTuFEcNxwSAk",15) == 2252126706) strcat(s, "a");
if (crc32("MnCOqR",6) == 1538060918) strcat(s, "S");
if (crc32("hLADjBLQhqLHoGD",15) == 3721329598) strcat(s, "b");
if (crc32("evWZfRyP",8) == 1951624915) strcat(s, "B");
if (crc32("mcuHknez",8) == 2714378857) strcat(s, "u");
if (crc32("MvqhBkJabRZ",11) == 29667190) strcat(s, "l");
if (crc32("TcyECgZ",7) == 116250668) strcat(s, "n");
if (crc32("pWuol",5) == 2641481833) strcat(s, "o");
if (crc32("eQCPAFQUulhKy",13) == 1368475326) strcat(s, "W");
if (crc32("pirilSTORK",10) == 1140312630) strcat(s, "u");
if (crc32("SWILhwLjjMnIQ",13) == 1960606454) strcat(s, "s");
    return s;
}

char *unacuminous_adjectives() {
    char *s = calloc(12);
    if (crc32("ygxtQgkST",9) == 3324002437) strcat(s, "s");
if (crc32("qyRJVb",6) == 3593128160) strcat(s, "u");
if (crc32("WEOycASSVTWTGGw",15) == 4244641342) strcat(s, "q");
if (crc32("JVvLYAtSNceXFyj",15) == 1816732263) strcat(s, "n");
if (crc32("mrGbjY",6) == 1183783743) strcat(s, "a");
if (crc32("CXcdzUiOlcWB",12) == 711392378) strcat(s, "c");
if (crc32("hAgxhHamhuQlQP",14) == 1752660918) strcat(s, "u");
if (crc32("azEbK",5) == 2791716622) strcat(s, "m");
if (crc32("HQkBbhme",8) == 1620587951) strcat(s, "i");
if (crc32("pdVlK",5) == 3418593591) strcat(s, "n");
if (crc32("LfxJxlGfvsNici",14) == 1123671832) strcat(s, "L");
if (crc32("WPKYAkk",7) == 3280454795) strcat(s, "o");
if (crc32("fOFitDEAIhwI",12) == 4153417146) strcat(s, "u");
if (crc32("wOOjAhoF",8) == 1154392872) strcat(s, "s");
    return s;
}

char *justiceless_adjectives() {
    char *s = calloc(12);
    if (crc32("DmgnfiNSDHoCmn",14) == 192951554) strcat(s, "j");
if (crc32("DyVXgryfCAh",11) == 3127047467) strcat(s, "u");
if (crc32("MalLRAQhDRxRm",13) == 1337831924) strcat(s, "t");
if (crc32("bPzWFveq",8) == 624451887) strcat(s, "s");
if (crc32("qCqduLkFZisMKT",14) == 663924128) strcat(s, "P");
if (crc32("uSgKCiQRAFGxOv",14) == 2333003369) strcat(s, "t");
if (crc32("tKJEfizqorQYb",13) == 1877538363) strcat(s, "i");
if (crc32("VHhoTy",6) == 1233214456) strcat(s, "c");
if (crc32("MvCUI",5) == 706329569) strcat(s, "W");
if (crc32("oTfFMkKOodvzLtS",15) == 1242684599) strcat(s, "e");
if (crc32("IghqOmwQP",9) == 1454391514) strcat(s, "L");
if (crc32("olYeqxGp",8) == 1022409730) strcat(s, "l");
if (crc32("HAouD",5) == 3984285674) strcat(s, "e");
if (crc32("tqHwUHXPMWK",11) == 2892910099) strcat(s, "g");
if (crc32("PoEpEQLi",8) == 1118527182) strcat(s, "s");
if (crc32("uuNzqvjbFzYvr",13) == 1676319716) strcat(s, "p");
if (crc32("QtIDXqX",7) == 4174604673) strcat(s, "s");
    return s;
}

char *overglad_adjectives() {
    char *s = calloc(9);
    if (crc32("WKpXlzEvjdtEKyO",15) == 1908209452) strcat(s, "o");
if (crc32("yZGBqtRz",8) == 936869471) strcat(s, "V");
if (crc32("cqbqKaKbQie",11) == 1986280781) strcat(s, "v");
if (crc32("iOkaHPRgRbZvOUF",15) == 324931818) strcat(s, "e");
if (crc32("JiAdvgECBLWRBDL",15) == 4041113766) strcat(s, "Z");
if (crc32("yocwFHMlm",9) == 346112720) strcat(s, "r");
if (crc32("WMnqVRtvEGr",11) == 2436527268) strcat(s, "g");
if (crc32("VXutsagx",8) == 2529181550) strcat(s, "y");
if (crc32("SbpPQOW",7) == 388152946) strcat(s, "l");
if (crc32("crhiVf",6) == 2455392979) strcat(s, "A");
if (crc32("VRDHDtWuoueN",12) == 1468173031) strcat(s, "a");
if (crc32("BBKlhrmPqaZ",11) == 1377311756) strcat(s, "d");
    return s;
}

char *unimporting_adjectives() {
    char *s = calloc(12);
    if (crc32("nuHVuIwEEBr",11) == 1131671008) strcat(s, "J");
if (crc32("kGzUpjyozv",10) == 3718903332) strcat(s, "u");
if (crc32("rvRJxlY",7) == 210182209) strcat(s, "n");
if (crc32("EXcPVt",6) == 412256220) strcat(s, "i");
if (crc32("pinqqkeiBcC",11) == 2192096083) strcat(s, "H");
if (crc32("BVExuT",6) == 2355607830) strcat(s, "m");
if (crc32("FGltrwIyIlUShx",14) == 4152841020) strcat(s, "p");
if (crc32("ODhUf",5) == 1440437733) strcat(s, "s");
if (crc32("iFLIc",5) == 1627346378) strcat(s, "o");
if (crc32("NfyZuDmy",8) == 1025856714) strcat(s, "r");
if (crc32("sbBNX",5) == 2265542684) strcat(s, "y");
if (crc32("zsdpsrLh",8) == 3739184939) strcat(s, "t");
if (crc32("mogvRAjbHqmpPNP",15) == 2355301221) strcat(s, "j");
if (crc32("jtzLHQ",6) == 1295080355) strcat(s, "i");
if (crc32("yDRAhmq",7) == 2696638423) strcat(s, "n");
if (crc32("rRYYZosEMetrbEF",15) == 1802254281) strcat(s, "g");
    return s;
}

char *reflexional_adjectives() {
    char *s = calloc(12);
    if (crc32("DrnAQKOu",8) == 3892800346) strcat(s, "o");
if (crc32("CAekzPUJeJxB",12) == 2626868267) strcat(s, "r");
if (crc32("AvpTlQuxUfxZuz",14) == 167607829) strcat(s, "e");
if (crc32("TFaaBdjNzxq",11) == 1519611222) strcat(s, "V");
if (crc32("llFKDJF",7) == 3612353069) strcat(s, "f");
if (crc32("HmKNuNDyZ",9) == 4091172284) strcat(s, "l");
if (crc32("vrxvhfWdSzwpMB",14) == 3195142099) strcat(s, "D");
if (crc32("PVhBubFPJcxVXrL",15) == 3857785185) strcat(s, "e");
if (crc32("awRSjGHiJyN",11) == 1760026464) strcat(s, "x");
if (crc32("UlVXcVYuWkZR",12) == 737681764) strcat(s, "i");
if (crc32("njhZyKZ",7) == 2508736395) strcat(s, "C");
if (crc32("CSkWnh",6) == 2055113486) strcat(s, "o");
if (crc32("MWBzHadgS",9) == 2838525156) strcat(s, "B");
if (crc32("uJXUKhCzV",9) == 1554813461) strcat(s, "n");
if (crc32("XDlNlIDKxDkZDxl",15) == 2571662571) strcat(s, "a");
if (crc32("lsLNZMs",7) == 1475651182) strcat(s, "l");
    return s;
}

char *hunchbacked_adjectives() {
    char *s = calloc(12);
    if (crc32("LRhrvmXY",8) == 2791397362) strcat(s, "h");
if (crc32("xwEnBVeX",8) == 2458007910) strcat(s, "e");
if (crc32("IYjSeh",6) == 3440682683) strcat(s, "u");
if (crc32("fwciCW",6) == 1683161576) strcat(s, "n");
if (crc32("xwINko",6) == 3602098643) strcat(s, "g");
if (crc32("YrFYIudT",8) == 1628386319) strcat(s, "c");
if (crc32("kdjNNFbFEqE",11) == 3814697317) strcat(s, "h");
if (crc32("sELoWUD",7) == 1051838631) strcat(s, "b");
if (crc32("VqNYCeOOnxQAMsa",15) == 1063072896) strcat(s, "a");
if (crc32("scNRtiyJRgasTUt",15) == 2806245763) strcat(s, "c");
if (crc32("aXkuqntsky",10) == 478883923) strcat(s, "F");
if (crc32("CVjQVCwoHetnRfC",15) == 1935526401) strcat(s, "k");
if (crc32("wbhSU",5) == 1413105494) strcat(s, "N");
if (crc32("pRvqiaPhTU",10) == 2867949544) strcat(s, "e");
if (crc32("hyeSAWtSXMJd",12) == 1979897598) strcat(s, "d");
    return s;
}

char *unplagiarized_adjectives() {
    char *s = calloc(14);
    if (crc32("FKiFGCUgFgb",11) == 2348585525) strcat(s, "H");
if (crc32("umLNwZSH",8) == 2331555313) strcat(s, "u");
if (crc32("BbxDSMPaH",9) == 2977810128) strcat(s, "n");
if (crc32("jmjHxcl",7) == 4111557890) strcat(s, "a");
if (crc32("suYeNqoKOJp",11) == 4172636574) strcat(s, "p");
if (crc32("QQaKh",5) == 2836506386) strcat(s, "l");
if (crc32("MABXBzBT",8) == 3104283823) strcat(s, "a");
if (crc32("vmEEBO",6) == 1370036715) strcat(s, "W");
if (crc32("LAGxUOcZTEwSbye",15) == 867195626) strcat(s, "g");
if (crc32("GSvtjuarpKJrZ",13) == 3587350307) strcat(s, "K");
if (crc32("eXbXskeKloVIz",13) == 3133633309) strcat(s, "i");
if (crc32("jcRntP",6) == 3310572943) strcat(s, "T");
if (crc32("qBXhOD",6) == 497164152) strcat(s, "a");
if (crc32("ddFDPCCcEPz",11) == 3251813324) strcat(s, "B");
if (crc32("dDwZwJjZMtYB",12) == 2448843097) strcat(s, "r");
if (crc32("PMRkL",5) == 18152767) strcat(s, "i");
if (crc32("qsJMXSjnzeTegBn",15) == 3212947196) strcat(s, "z");
if (crc32("JcuxhdK",7) == 3398812498) strcat(s, "e");
if (crc32("steCe",5) == 882760211) strcat(s, "d");
    return s;
}

char *undetailed_adjectives() {
    char *s = calloc(11);
    if (crc32("DyXGm",5) == 1539666175) strcat(s, "l");
if (crc32("gHpIX",5) == 2741659976) strcat(s, "u");
if (crc32("HvrZaLnaLS",10) == 3238982191) strcat(s, "z");
if (crc32("WSMWNtc",7) == 3797021991) strcat(s, "n");
if (crc32("InNcW",5) == 2313359852) strcat(s, "d");
if (crc32("zViqpYp",7) == 663721541) strcat(s, "e");
if (crc32("iVYlqSfXxzFfmD",14) == 4068298571) strcat(s, "t");
if (crc32("OYOinQxOkOPbo",13) == 464630773) strcat(s, "C");
if (crc32("OtELMmLy",8) == 323667077) strcat(s, "a");
if (crc32("zfXjihUn",8) == 4003924423) strcat(s, "i");
if (crc32("YaRKbSMsCAIfGn",14) == 797447302) strcat(s, "B");
if (crc32("XlHiW",5) == 2148070253) strcat(s, "l");
if (crc32("bsNDMq",6) == 604106525) strcat(s, "e");
if (crc32("McnvtotJhKRYbSl",15) == 3794565354) strcat(s, "d");
    return s;
}

char *wellphotographed_adjectives() {
    char *s = calloc(17);
    if (crc32("kuKGwW",6) == 1316118170) strcat(s, "w");
if (crc32("FYzAuYLznDjYzBV",15) == 3047426235) strcat(s, "a");
if (crc32("ECxnoHJ",7) == 4259985346) strcat(s, "e");
if (crc32("FGZvZqlNfvlhfI",14) == 4229380730) strcat(s, "G");
if (crc32("IgtGDWPU",8) == 3149836346) strcat(s, "l");
if (crc32("bkJmafzJm",9) == 2548078108) strcat(s, "l");
if (crc32("ufTDERdArsTiPbU",15) == 3482152501) strcat(s, "p");
if (crc32("jSxpaFozIJLyiK",14) == 3154983691) strcat(s, "L");
if (crc32("WFzdXOPkDea",11) == 4146504246) strcat(s, "h");
if (crc32("jnnbCkVxut",10) == 3190564386) strcat(s, "o");
if (crc32("RCkhhFeItxUAf",13) == 1527915170) strcat(s, "O");
if (crc32("TZOmzhZyWUX",11) == 1152844475) strcat(s, "t");
if (crc32("ppkXTKIUau",10) == 268775942) strcat(s, "o");
if (crc32("fnaQDGWUxnALI",13) == 2848537687) strcat(s, "p");
if (crc32("msfElLzGANMhOd",14) == 4090555370) strcat(s, "g");
if (crc32("enrnJ",5) == 1980489097) strcat(s, "r");
if (crc32("NBULDqZDBpkKQ",13) == 3954123232) strcat(s, "a");
if (crc32("GmwEE",5) == 2627013313) strcat(s, "d");
if (crc32("fBLBjhwwZodSl",13) == 1160127764) strcat(s, "p");
if (crc32("HbACxmaRPY",10) == 1323026811) strcat(s, "h");
if (crc32("YSokCYtRPIWQXO",14) == 2070492783) strcat(s, "R");
if (crc32("bfvdDdT",7) == 2268726684) strcat(s, "e");
if (crc32("aelrEiMcByhk",12) == 4082210905) strcat(s, "d");
    return s;
}

char *interfilamentous_adjectives() {
    char *s = calloc(17);
    if (crc32("WuaGtWBl",8) == 2786037142) strcat(s, "i");
if (crc32("CvWXuPqmbUtZexa",15) == 2865320822) strcat(s, "Y");
if (crc32("EYPEDL",6) == 2373406965) strcat(s, "n");
if (crc32("RpxSqfRmTumFsf",14) == 2292833512) strcat(s, "p");
if (crc32("DPYkmeBOIUbL",12) == 94398618) strcat(s, "t");
if (crc32("dobdy",5) == 2838048380) strcat(s, "R");
if (crc32("vignoG",6) == 385798280) strcat(s, "e");
if (crc32("ifHrAq",6) == 3597411682) strcat(s, "U");
if (crc32("jHsBmWelT",9) == 2517015415) strcat(s, "r");
if (crc32("wHhByJeetT",10) == 420525010) strcat(s, "f");
if (crc32("KMggt",5) == 2956168005) strcat(s, "i");
if (crc32("uqkXlEetZaUJy",13) == 932766470) strcat(s, "q");
if (crc32("JSOsSDw",7) == 1621799309) strcat(s, "l");
if (crc32("TGura",5) == 2029264531) strcat(s, "a");
if (crc32("YrecuFFYHpoR",12) == 2545137422) strcat(s, "Q");
if (crc32("hllRhrvjO",9) == 3403649758) strcat(s, "m");
if (crc32("sRkZfPSnYO",10) == 3130515181) strcat(s, "p");
if (crc32("CYnwpPkE",8) == 2320330153) strcat(s, "e");
if (crc32("RIbMjPAaE",9) == 806848678) strcat(s, "n");
if (crc32("eZHQmD",6) == 157568022) strcat(s, "t");
if (crc32("oJXojvZ",7) == 2464973131) strcat(s, "o");
if (crc32("jBATIMTuLI",10) == 707515574) strcat(s, "u");
if (crc32("xqCUkjRKtkWhJG",14) == 484414434) strcat(s, "s");
    return s;
}

char *refillable_adjectives() {
    char *s = calloc(11);
    if (crc32("MICLPbRb",8) == 3112819259) strcat(s, "r");
if (crc32("xwLLGbs",7) == 2368696994) strcat(s, "M");
if (crc32("hFvRFrLLKUR",11) == 2501425726) strcat(s, "e");
if (crc32("GfUbWFyOSpf",11) == 3703518553) strcat(s, "k");
if (crc32("SanxfsYuCYmZbbz",15) == 667954310) strcat(s, "f");
if (crc32("NuWiMzkf",8) == 893205563) strcat(s, "X");
if (crc32("JNWUj",5) == 2901574041) strcat(s, "i");
if (crc32("OzlNFbt",7) == 3593145465) strcat(s, "l");
if (crc32("eDaQpuJKVL",10) == 4012177408) strcat(s, "l");
if (crc32("vQKjTuV",7) == 2969836989) strcat(s, "E");
if (crc32("CrqOsuIhsGJIOd",14) == 887890558) strcat(s, "a");
if (crc32("lhdeAer",7) == 3209911998) strcat(s, "z");
if (crc32("YEyBiolgVe",10) == 2345478466) strcat(s, "b");
if (crc32("evqfdEI",7) == 596744756) strcat(s, "q");
if (crc32("ZmiUzXwhGARtFBQ",15) == 1078773003) strcat(s, "l");
if (crc32("bCsEpPAWA",9) == 2953650390) strcat(s, "P");
if (crc32("jYUFjq",6) == 494595136) strcat(s, "e");
    return s;
}

char *phenetic_adjectives() {
    char *s = calloc(9);
    if (crc32("hOsaHJsGP",9) == 4058580212) strcat(s, "p");
if (crc32("pICvusnuvtxrAHx",15) == 401850184) strcat(s, "h");
if (crc32("cBryYst",7) == 2058828601) strcat(s, "e");
if (crc32("xAqKpczM",8) == 3953517833) strcat(s, "e");
if (crc32("aRTzVfikfbjz",12) == 852402151) strcat(s, "b");
if (crc32("QjhQkrjFov",10) == 1611914869) strcat(s, "n");
if (crc32("AmxyyUo",7) == 1547727070) strcat(s, "r");
if (crc32("nypFDQuCabN",11) == 1016560846) strcat(s, "e");
if (crc32("VJuMVMm",7) == 2848620048) strcat(s, "P");
if (crc32("HWDGthUPnbZwk",13) == 97791072) strcat(s, "t");
if (crc32("USadVp",6) == 808035997) strcat(s, "c");
if (crc32("AFNJVbHopdpiA",13) == 215280052) strcat(s, "i");
if (crc32("UbuzbEJRhqKIwM",14) == 838102330) strcat(s, "q");
if (crc32("kWHjUL",6) == 4203009903) strcat(s, "c");
    return s;
}

char *welltaxed_adjectives() {
    char *s = calloc(10);
    if (crc32("LNTYwLShRvy",11) == 3179370035) strcat(s, "w");
if (crc32("HgKjIxAvbjlZBX",14) == 1296628521) strcat(s, "W");
if (crc32("yxYGukJPNgw",11) == 1831588421) strcat(s, "e");
if (crc32("WKZesk",6) == 3149169756) strcat(s, "l");
if (crc32("zlGBLVQMIyiqcAG",15) == 2505582524) strcat(s, "c");
if (crc32("TLNAoHIcrgbcvXM",15) == 3101149683) strcat(s, "l");
if (crc32("mGsrpDPN",8) == 3550615105) strcat(s, "f");
if (crc32("oztzrBH",7) == 2949026617) strcat(s, "t");
if (crc32("IyMbhiqCIFd",11) == 952885875) strcat(s, "a");
if (crc32("AruBJAQgEJCMiN",14) == 3958013781) strcat(s, "x");
if (crc32("akxoo",5) == 1521024167) strcat(s, "p");
if (crc32("HkmilwTDfgU",11) == 2997893538) strcat(s, "e");
if (crc32("nVWwFn",6) == 1059199216) strcat(s, "d");
    return s;
}

char *nongenerical_adjectives() {
    char *s = calloc(13);
    if (crc32("pEmGVjTzPeZml",13) == 112263561) strcat(s, "n");
if (crc32("ZzytLnZUbHKh",12) == 8775947) strcat(s, "q");
if (crc32("ZOnkrqQqrWwvMaV",15) == 3621620965) strcat(s, "o");
if (crc32("evZRgi",6) == 1244863393) strcat(s, "n");
if (crc32("OdbdDDfco",9) == 373842378) strcat(s, "Z");
if (crc32("gmwlLADO",8) == 3445893801) strcat(s, "g");
if (crc32("IZMuuNoHTMQA",12) == 1653432454) strcat(s, "e");
if (crc32("TyMjbW",6) == 3418931930) strcat(s, "F");
if (crc32("namAREPjNPCImQ",14) == 2150853359) strcat(s, "n");
if (crc32("GuriYK",6) == 2666140277) strcat(s, "e");
if (crc32("gAhFlkYrK",9) == 1371091251) strcat(s, "T");
if (crc32("CkZBiBtjZpZoqPH",15) == 2002883075) strcat(s, "r");
if (crc32("xVHXjVT",7) == 1000456148) strcat(s, "i");
if (crc32("NMOzSx",6) == 194189242) strcat(s, "g");
if (crc32("eSDMLNJxVtELD",13) == 1359020818) strcat(s, "c");
if (crc32("tRsmOICmesgcC",13) == 3558165477) strcat(s, "a");
if (crc32("RFsQEI",6) == 2983046199) strcat(s, "l");
    return s;
}

char *infectious_adjectives() {
    char *s = calloc(11);
    if (crc32("RfOJFy",6) == 3112554097) strcat(s, "f");
if (crc32("NWAbAhQ",7) == 2894053470) strcat(s, "i");
if (crc32("DafFgFhAWCD",11) == 760528447) strcat(s, "n");
if (crc32("ORqpaJVeM",9) == 2096685212) strcat(s, "J");
if (crc32("ONoKfc",6) == 1352238725) strcat(s, "f");
if (crc32("tAuskpicXxnEJ",13) == 1116541150) strcat(s, "L");
if (crc32("rBRhCKGUeP",10) == 4155683640) strcat(s, "e");
if (crc32("GrXTPDTbSBMnfZo",15) == 639895471) strcat(s, "g");
if (crc32("SHGXP",5) == 2347577145) strcat(s, "c");
if (crc32("jVxvZkjSJ",9) == 1655364290) strcat(s, "t");
if (crc32("SKtSekcZdAqTrtv",15) == 1089633468) strcat(s, "i");
if (crc32("JMBeI",5) == 2487140983) strcat(s, "n");
if (crc32("OBCfTgxhhnUVGA",14) == 1131291886) strcat(s, "o");
if (crc32("kosUETqEtp",10) == 4165951859) strcat(s, "L");
if (crc32("bLMtKCfZ",8) == 1292083313) strcat(s, "u");
if (crc32("ANBWPMTwtotL",12) == 3886641125) strcat(s, "s");
    return s;
}

char *nonaddicting_adjectives() {
    char *s = calloc(13);
    if (crc32("FQaodY",6) == 3196581153) strcat(s, "n");
if (crc32("hMREeKCinUQ",11) == 825207226) strcat(s, "A");
if (crc32("QwRAXR",6) == 3669590388) strcat(s, "o");
if (crc32("XLtLWuAW",8) == 1970795835) strcat(s, "n");
if (crc32("xoTlQUVUf",9) == 4271498084) strcat(s, "a");
if (crc32("ruAsfmjVsw",10) == 3663947768) strcat(s, "d");
if (crc32("IYfQkPWLT",9) == 2368933821) strcat(s, "d");
if (crc32("yqFzwzCTsxgYMn",14) == 3818997824) strcat(s, "s");
if (crc32("NkWWK",5) == 2965441161) strcat(s, "i");
if (crc32("KnfJrluJowWN",12) == 308922211) strcat(s, "c");
if (crc32("hzjPcqYoWalWSd",14) == 3359877849) strcat(s, "t");
if (crc32("VWmQVTMbC",9) == 3048135707) strcat(s, "Q");
if (crc32("eohTM",5) == 1691080592) strcat(s, "i");
if (crc32("mTLcmXlsxOa",11) == 1779044631) strcat(s, "V");
if (crc32("VsZJkzdHKfXE",12) == 1614673352) strcat(s, "n");
if (crc32("RvaOgdHku",9) == 4260398944) strcat(s, "a");
if (crc32("rZlbt",5) == 2699961648) strcat(s, "g");
    return s;
}

char *supersulphureted_adjectives() {
    char *s = calloc(17);
    if (crc32("SXsUIZK",7) == 4080818376) strcat(s, "s");
if (crc32("ryOrAx",6) == 3328903964) strcat(s, "g");
if (crc32("ezzdLUTCzIE",11) == 2146618761) strcat(s, "u");
if (crc32("diggtCtc",8) == 1365047492) strcat(s, "A");
if (crc32("XtPtBp",6) == 1475542691) strcat(s, "p");
if (crc32("ZFpWzaFmbxlmmHh",15) == 398135796) strcat(s, "Z");
if (crc32("IMveDz",6) == 494633559) strcat(s, "e");
if (crc32("yxWky",5) == 4248651415) strcat(s, "G");
if (crc32("MLLpsViCb",9) == 1351947244) strcat(s, "r");
if (crc32("QmWwt",5) == 1425562777) strcat(s, "s");
if (crc32("ZrLdvqYYvIrtUN",14) == 2959652323) strcat(s, "F");
if (crc32("XpkKGzcyrQMdny",14) == 1515571051) strcat(s, "u");
if (crc32("DtzTKcTlwmYpLPf",15) == 410111162) strcat(s, "l");
if (crc32("USLjjytBnbZ",11) == 3914891103) strcat(s, "p");
if (crc32("LigRS",5) == 712513761) strcat(s, "h");
if (crc32("zCCgBNqrzziLcNo",15) == 2382946451) strcat(s, "u");
if (crc32("QIUSFsmGZoPMKmk",15) == 111884461) strcat(s, "E");
if (crc32("MdREPrM",7) == 3155475142) strcat(s, "r");
if (crc32("nSYqdkO",7) == 97219917) strcat(s, "e");
if (crc32("kHMMXdDH",8) == 899299581) strcat(s, "M");
if (crc32("TDIEUoRLTD",10) == 2705627) strcat(s, "t");
if (crc32("vLmEXSTH",8) == 1851553176) strcat(s, "e");
if (crc32("pDojymDzbMwju",13) == 470692791) strcat(s, "L");
if (crc32("aNPDUYMrfA",10) == 1269483526) strcat(s, "d");
    return s;
}

char *imperishable_adjectives() {
    char *s = calloc(13);
    if (crc32("ndLtiObEOG",10) == 3326200279) strcat(s, "i");
if (crc32("yjVNi",5) == 2519851412) strcat(s, "q");
if (crc32("BZtYkqGMtiT",11) == 3977263674) strcat(s, "m");
if (crc32("VWoPzDljoK",10) == 3374621775) strcat(s, "t");
if (crc32("FESzKXNAn",9) == 2324603875) strcat(s, "p");
if (crc32("iYdtLpdPYCY",11) == 1793011681) strcat(s, "k");
if (crc32("yTFWovB",7) == 1356261444) strcat(s, "e");
if (crc32("UUlAhpcI",8) == 3985480400) strcat(s, "z");
if (crc32("BNNZXoEwbiD",11) == 3067612704) strcat(s, "r");
if (crc32("HEGAM",5) == 1497109261) strcat(s, "b");
if (crc32("haiFoEAAnYg",11) == 1043417332) strcat(s, "i");
if (crc32("dSPnBXLYjfR",11) == 2237084487) strcat(s, "s");
if (crc32("FErcCVvNiG",10) == 4204657704) strcat(s, "R");
if (crc32("eJkCVmcao",9) == 3719833694) strcat(s, "h");
if (crc32("cbzDIIWzQoH",11) == 1066455716) strcat(s, "a");
if (crc32("URNjiFtEGyHpLBR",15) == 2443439264) strcat(s, "o");
if (crc32("ZDvAfPy",7) == 67250324) strcat(s, "b");
if (crc32("cOKwgS",6) == 3847973225) strcat(s, "e");
if (crc32("oBLLCZqpbMEeZs",14) == 2947164154) strcat(s, "l");
if (crc32("lpNOxsTTAWya",12) == 1599977909) strcat(s, "e");
    return s;
}

char *nonintoxicant_adjectives() {
    char *s = calloc(14);
    if (crc32("HmJkztzSXl",10) == 148032893) strcat(s, "n");
if (crc32("eCQBAELj",8) == 2600315064) strcat(s, "M");
if (crc32("TQKwDok",7) == 460968529) strcat(s, "o");
if (crc32("wjNdvcOs",8) == 263788463) strcat(s, "n");
if (crc32("NIJLwwpZRLPDd",13) == 133777228) strcat(s, "i");
if (crc32("qTRwspyRoPNrnLc",15) == 686223422) strcat(s, "n");
if (crc32("SjvRayqzG",9) == 4164775744) strcat(s, "t");
if (crc32("KCVHJJNfMPjQigS",15) == 3390477475) strcat(s, "o");
if (crc32("vvKPncbL",8) == 1692427996) strcat(s, "x");
if (crc32("GaRnaBXlzTWiBQ",14) == 1476991056) strcat(s, "i");
if (crc32("EheqYaK",7) == 2666977313) strcat(s, "f");
if (crc32("tknAVGjz",8) == 664115195) strcat(s, "c");
if (crc32("BztYEeiSEGGOI",13) == 4110856830) strcat(s, "R");
if (crc32("jRirJKrCCeRoKlq",15) == 3231966541) strcat(s, "a");
if (crc32("CPTyngKB",8) == 51678272) strcat(s, "X");
if (crc32("kAASGI",6) == 1258856580) strcat(s, "n");
if (crc32("RLCCwCZ",7) == 3323650628) strcat(s, "t");
    return s;
}

char *postsphenoid_adjectives() {
    char *s = calloc(13);
    if (crc32("UhdMTkv",7) == 2969547492) strcat(s, "G");
if (crc32("MmBduWavYs",10) == 2448220741) strcat(s, "p");
if (crc32("RweMTQJ",7) == 93144230) strcat(s, "L");
if (crc32("sCwQKPjUhmpQ",12) == 2506614225) strcat(s, "o");
if (crc32("cdIAZmsXpHPLIsA",15) == 3991587976) strcat(s, "s");
if (crc32("PpLOsaf",7) == 1536109569) strcat(s, "G");
if (crc32("CtwZfyLsxsI",11) == 4204388343) strcat(s, "t");
if (crc32("RVypNljCDOaz",12) == 2765768612) strcat(s, "s");
if (crc32("SLKjsubGvowT",12) == 1907521696) strcat(s, "p");
if (crc32("klfbLyiogDyqfvh",15) == 2648905625) strcat(s, "T");
if (crc32("AKLdCsXexk",10) == 2237899027) strcat(s, "h");
if (crc32("FIxxPHIEwJRZnAa",15) == 81945341) strcat(s, "e");
if (crc32("FsWwKuRCyx",10) == 679128810) strcat(s, "n");
if (crc32("MXUDfurRioIlEx",14) == 3394377837) strcat(s, "o");
if (crc32("XrUBUzg",7) == 1713606069) strcat(s, "i");
if (crc32("cTQKb",5) == 2208937986) strcat(s, "g");
if (crc32("jxxTbBaz",8) == 4285251347) strcat(s, "d");
    return s;
}

char *unabducted_adjectives() {
    char *s = calloc(11);
    if (crc32("DyUgngi",7) == 194813866) strcat(s, "u");
if (crc32("BxJxqntR",8) == 2534283338) strcat(s, "H");
if (crc32("iZiVXrdQY",9) == 558507047) strcat(s, "n");
if (crc32("BGuxvS",6) == 1658686886) strcat(s, "M");
if (crc32("amVOgInNGtqQlXU",15) == 3253559920) strcat(s, "a");
if (crc32("RQLyRcJKTcs",11) == 4278169401) strcat(s, "B");
if (crc32("fwQwY",5) == 957329203) strcat(s, "b");
if (crc32("WqvFCrKEb",9) == 1247885028) strcat(s, "d");
if (crc32("usTVpeRHEWE",11) == 3159079171) strcat(s, "P");
if (crc32("yAhnj",5) == 26549772) strcat(s, "u");
if (crc32("oIahrdPy",8) == 1256849911) strcat(s, "U");
if (crc32("qHQzcvKJPqTO",12) == 2606786297) strcat(s, "c");
if (crc32("sNSqH",5) == 591549424) strcat(s, "t");
if (crc32("dzWryjQM",8) == 3294016280) strcat(s, "E");
if (crc32("XemyKCpHym",10) == 3475452219) strcat(s, "e");
if (crc32("eakLnVRGpetfjyR",15) == 975830250) strcat(s, "d");
    return s;
}

char *perforative_adjectives() {
    char *s = calloc(12);
    if (crc32("qOWGdfiVDczlwv",14) == 1350005425) strcat(s, "P");
if (crc32("UOrEQwPx",8) == 3660902112) strcat(s, "p");
if (crc32("QwFTeXvC",8) == 2935051549) strcat(s, "Z");
if (crc32("CQDRQAq",7) == 1077160193) strcat(s, "e");
if (crc32("pSyqmyOAXEBxnM",14) == 2334227536) strcat(s, "r");
if (crc32("rpphf",5) == 1894013271) strcat(s, "Y");
if (crc32("ZjNmMIrUePRi",12) == 990392082) strcat(s, "f");
if (crc32("KVUgJENBukcfetD",15) == 228874951) strcat(s, "o");
if (crc32("drqiYNOdhKEXJsJ",15) == 2376621412) strcat(s, "L");
if (crc32("YucxeKn",7) == 4149000668) strcat(s, "r");
if (crc32("EPjclnjfsTzMf",13) == 2270955716) strcat(s, "a");
if (crc32("fMaymRu",7) == 2621762798) strcat(s, "a");
if (crc32("IXExqbjXCi",10) == 215458475) strcat(s, "t");
if (crc32("KgbsZYerdWr",11) == 2110838070) strcat(s, "F");
if (crc32("XvdiBpJi",8) == 805965038) strcat(s, "i");
if (crc32("LHDskIfvntBZQlJ",15) == 3516604469) strcat(s, "I");
if (crc32("DqyZIOzvs",9) == 2935163105) strcat(s, "v");
if (crc32("jXzQneSNgn",10) == 349263700) strcat(s, "e");
    return s;
}

char *imposable_adjectives() {
    char *s = calloc(10);
    if (crc32("BTnqiaPDKuUfeQ",14) == 3967630134) strcat(s, "T");
if (crc32("GnvcKtYZ",8) == 1630568739) strcat(s, "i");
if (crc32("dbPKS",5) == 895423421) strcat(s, "I");
if (crc32("sJPzL",5) == 1258252076) strcat(s, "m");
if (crc32("qXDIEpBp",8) == 3199797009) strcat(s, "p");
if (crc32("OgXeVJFdtU",10) == 2182317457) strcat(s, "o");
if (crc32("aISNjtqElpYvZ",13) == 1113774443) strcat(s, "s");
if (crc32("RTMASLMBtnrx",12) == 3754002928) strcat(s, "I");
if (crc32("EEPvtBWwRKVNAM",14) == 4228737343) strcat(s, "a");
if (crc32("EWqdUjNwwjOHxhe",15) == 582347599) strcat(s, "w");
if (crc32("abRYW",5) == 34688764) strcat(s, "b");
if (crc32("HAVSyg",6) == 2599267976) strcat(s, "l");
if (crc32("blEiGgKAPvhqj",13) == 2407253965) strcat(s, "e");
    return s;
}

char *supramolecular_adjectives() {
    char *s = calloc(15);
    if (crc32("EZeRlNqst",9) == 484319484) strcat(s, "U");
if (crc32("wXmXAhCrZgwn",12) == 1879401546) strcat(s, "s");
if (crc32("BWvXZPCJ",8) == 3097612840) strcat(s, "u");
if (crc32("QmsxiTD",7) == 451072919) strcat(s, "D");
if (crc32("enQiQqcHWLIQgx",14) == 1251052620) strcat(s, "p");
if (crc32("QLXeBn",6) == 1428084630) strcat(s, "e");
if (crc32("NQdXW",5) == 2598570245) strcat(s, "r");
if (crc32("ILWHkFEZGz",10) == 1227316461) strcat(s, "V");
if (crc32("PVhIbL",6) == 2741501442) strcat(s, "a");
if (crc32("mktkkkoT",8) == 4293578193) strcat(s, "m");
if (crc32("yXRbwLzBDZRKPc",14) == 114168270) strcat(s, "J");
if (crc32("nmwCguscN",9) == 1739920540) strcat(s, "o");
if (crc32("BWtyRYoefPA",11) == 3746580829) strcat(s, "l");
if (crc32("zNVVI",5) == 2237362585) strcat(s, "e");
if (crc32("ZRFlmI",6) == 2128990178) strcat(s, "c");
if (crc32("DQZJVJKJiWP",11) == 4161519501) strcat(s, "B");
if (crc32("QnvLTIWJM",9) == 4058251327) strcat(s, "u");
if (crc32("LfdXfMoJFbiPwR",14) == 304545093) strcat(s, "l");
if (crc32("IcwWO",5) == 1352901000) strcat(s, "k");
if (crc32("ZvNUGSSQCDVJ",12) == 963574775) strcat(s, "a");
if (crc32("LyyspyditP",10) == 4072942666) strcat(s, "M");
if (crc32("dCaoqOjuEHMbGd",14) == 860998908) strcat(s, "r");
    return s;
}

char *monogenetic_adjectives() {
    char *s = calloc(12);
    if (crc32("taiqXzzRrHK",11) == 1834815033) strcat(s, "m");
if (crc32("qtaUthaeBLRHEHY",15) == 354819546) strcat(s, "n");
if (crc32("dzKBcSNsb",9) == 67822816) strcat(s, "o");
if (crc32("RBPXyNcLp",9) == 3679220255) strcat(s, "n");
if (crc32("PbjsFOqVTq",10) == 4249433959) strcat(s, "S");
if (crc32("usSURCx",7) == 3344435712) strcat(s, "o");
if (crc32("pYjzAjQbhWMF",12) == 1560044891) strcat(s, "g");
if (crc32("WgUWRvJiOnne",12) == 1261273555) strcat(s, "U");
if (crc32("kapHEMfvOkzN",12) == 261346127) strcat(s, "e");
if (crc32("zMgtQC",6) == 2987952325) strcat(s, "S");
if (crc32("fNNLGJdPqKyhha",14) == 2405330912) strcat(s, "n");
if (crc32("MRPoZzy",7) == 1065531687) strcat(s, "e");
if (crc32("pdfejyZKHdfEYhN",15) == 1889629928) strcat(s, "t");
if (crc32("myrudhxlDxIWxt",14) == 4276596780) strcat(s, "i");
if (crc32("cwBwjyIdpGCnhf",14) == 499329618) strcat(s, "c");
    return s;
}

char *anabolic_adjectives() {
    char *s = calloc(9);
    if (crc32("HYdkIC",6) == 664962939) strcat(s, "S");
if (crc32("cNwsaKV",7) == 4169667247) strcat(s, "a");
if (crc32("uHpCuGDmPrzw",12) == 2908724097) strcat(s, "n");
if (crc32("xXYdKvUpbD",10) == 1734032067) strcat(s, "a");
if (crc32("IuFnPBiNjE",10) == 4274622441) strcat(s, "l");
if (crc32("NkBePbUYGvBKL",13) == 2847653080) strcat(s, "b");
if (crc32("axukShRv",8) == 1043273475) strcat(s, "w");
if (crc32("JGBaskoGsaCuQUT",15) == 1159597771) strcat(s, "o");
if (crc32("RqLkbqkVT",9) == 3766367713) strcat(s, "u");
if (crc32("nAJsNPCRAL",10) == 4248864071) strcat(s, "l");
if (crc32("ycqixPTOiPY",11) == 3466853791) strcat(s, "i");
if (crc32("dqbhgtw",7) == 4146141157) strcat(s, "c");
    return s;
}

char *unrated_adjectives() {
    char *s = calloc(8);
    if (crc32("AfADROENbtimWTv",15) == 3145027974) strcat(s, "u");
if (crc32("axSokEI",7) == 2376475512) strcat(s, "n");
if (crc32("RzKHuLnUutx",11) == 3546754669) strcat(s, "U");
if (crc32("YxNNqTb",7) == 2013310931) strcat(s, "r");
if (crc32("WsWXxaojDPd",11) == 1672342365) strcat(s, "a");
if (crc32("npoEIWKmjFm",11) == 2346516037) strcat(s, "t");
if (crc32("HvPbUkdVXyE",11) == 388623099) strcat(s, "e");
if (crc32("eqChqAuE",8) == 1637742277) strcat(s, "d");
    return s;
}

char *nonstaining_adjectives() {
    char *s = calloc(12);
    if (crc32("avqGf",5) == 1660832104) strcat(s, "n");
if (crc32("TevantGcsNiu",12) == 1395881539) strcat(s, "o");
if (crc32("NdwiIU",6) == 4010847084) strcat(s, "n");
if (crc32("jMuWkmZFiO",10) == 2302316140) strcat(s, "n");
if (crc32("GWddERauWzEwaU",14) == 4097029321) strcat(s, "s");
if (crc32("MYfhmSth",8) == 1237922254) strcat(s, "M");
if (crc32("dNshlWTRBEMIO",13) == 4288092957) strcat(s, "t");
if (crc32("iwyvic",6) == 4077180950) strcat(s, "a");
if (crc32("RLCHJCbGDz",10) == 3348401533) strcat(s, "i");
if (crc32("pVTjYqLwBuEaMo",14) == 3829288627) strcat(s, "n");
if (crc32("CKuVFrmVclIW",12) == 4089396689) strcat(s, "i");
if (crc32("ZfPIGZdk",8) == 2899748582) strcat(s, "n");
if (crc32("kXjWyC",6) == 3582614966) strcat(s, "x");
if (crc32("TNqlSXZHAbfKvZ",14) == 3528602251) strcat(s, "g");
    return s;
}

char *antiItalian_adjectives() {
    char *s = calloc(12);
    if (crc32("HHuyLn",6) == 3410851085) strcat(s, "a");
if (crc32("UOdzUtToeke",11) == 2340808894) strcat(s, "n");
if (crc32("MiTPbfzEplJjL",13) == 1469510512) strcat(s, "t");
if (crc32("vfegLnoYSPyB",12) == 3174957449) strcat(s, "i");
if (crc32("bIVXxVfP",8) == 594314846) strcat(s, "V");
if (crc32("UApzEc",6) == 3825110950) strcat(s, "I");
if (crc32("IeZLUMbBfAS",11) == 798811993) strcat(s, "t");
if (crc32("JsJpujC",7) == 2871022574) strcat(s, "a");
if (crc32("IUNalSvKe",9) == 2407265310) strcat(s, "w");
if (crc32("pKWUReweSI",10) == 1375501175) strcat(s, "l");
if (crc32("bydgtjuuPArAuo",14) == 3584404134) strcat(s, "i");
if (crc32("dffhOsuwONPcG",13) == 2621414780) strcat(s, "i");
if (crc32("XolIciBrBVp",11) == 3167338642) strcat(s, "a");
if (crc32("SqdPbAhdB",9) == 2709952480) strcat(s, "n");
    return s;
}

char *telolecithal_adjectives() {
    char *s = calloc(13);
    if (crc32("xcibJhfYZWWM",12) == 3683059960) strcat(s, "P");
if (crc32("lhzWTlZZYkV",11) == 3502517176) strcat(s, "t");
if (crc32("HRMhS",5) == 1130391610) strcat(s, "F");
if (crc32("xEaCkJMCZFvyb",13) == 2819520341) strcat(s, "e");
if (crc32("vatRl",5) == 2224508513) strcat(s, "V");
if (crc32("duWbpsOxRQpl",12) == 3616850944) strcat(s, "l");
if (crc32("AgUNhwP",7) == 2886260153) strcat(s, "o");
if (crc32("zsuoqtMWXH",10) == 2135344132) strcat(s, "a");
if (crc32("XMnTPsQ",7) == 675239202) strcat(s, "l");
if (crc32("mGLrEKlcbQSTBG",14) == 248088010) strcat(s, "p");
if (crc32("FZgjbffFJnCZE",13) == 3548958379) strcat(s, "e");
if (crc32("jOVBr",5) == 182291225) strcat(s, "h");
if (crc32("QNfRPTPLUQHyFF",14) == 3999418839) strcat(s, "c");
if (crc32("cZHRwnaRizi",11) == 267561576) strcat(s, "O");
if (crc32("nvsSAhfMVHs",11) == 1623176262) strcat(s, "i");
if (crc32("ncNllHQnFJXvsA",14) == 4201493099) strcat(s, "y");
if (crc32("fMzQeIyiIUZk",12) == 3270261417) strcat(s, "t");
if (crc32("huHUlPcIuwgYEMH",15) == 3108850134) strcat(s, "U");
if (crc32("XcvfkySywKYQ",12) == 723631068) strcat(s, "h");
if (crc32("LBTznWdR",8) == 4075547999) strcat(s, "P");
if (crc32("yDqGxkjWuhVvSY",14) == 4216176114) strcat(s, "a");
if (crc32("tGzGltmlXFRmLN",14) == 1764329208) strcat(s, "l");
    return s;
}

char *nonspottable_adjectives() {
    char *s = calloc(13);
    if (crc32("JNFBjYhcV",9) == 3540243435) strcat(s, "c");
if (crc32("tPQSkZWgYNGJUM",14) == 3402899660) strcat(s, "n");
if (crc32("ZpRMT",5) == 2572672656) strcat(s, "o");
if (crc32("YpHVMIMWflBn",12) == 3309018389) strcat(s, "n");
if (crc32("ZgJDlg",6) == 2814609369) strcat(s, "T");
if (crc32("etFYeBPnJcslrz",14) == 3555706140) strcat(s, "s");
if (crc32("UEOcXJyXheFueHE",15) == 2678538475) strcat(s, "U");
if (crc32("uStPFFSWgainz",13) == 4048144845) strcat(s, "p");
if (crc32("RDlNPKaOgQ",10) == 3679063354) strcat(s, "G");
if (crc32("TUlZLeARoyrfdH",14) == 1986364311) strcat(s, "o");
if (crc32("yosPQkhUpRk",11) == 4127208157) strcat(s, "a");
if (crc32("mRarEqj",7) == 3191726743) strcat(s, "t");
if (crc32("YClXHGTpDW",10) == 124210860) strcat(s, "x");
if (crc32("ePyXMYxrN",9) == 4229934650) strcat(s, "t");
if (crc32("YtFsvH",6) == 2142992553) strcat(s, "a");
if (crc32("yiEJXd",6) == 3770104466) strcat(s, "b");
if (crc32("JsYLygXZXB",10) == 1253278291) strcat(s, "l");
if (crc32("kjNfrzJ",7) == 1351622758) strcat(s, "l");
if (crc32("WVtWDJaAEFYS",12) == 3774717918) strcat(s, "e");
    return s;
}

char *unattachable_adjectives() {
    char *s = calloc(13);
    if (crc32("CorqvE",6) == 153066543) strcat(s, "h");
if (crc32("PQsWMlgy",8) == 2582979652) strcat(s, "u");
if (crc32("qPQkLKXtWUlgmc",14) == 3827807687) strcat(s, "n");
if (crc32("NrUYCac",7) == 1405428894) strcat(s, "a");
if (crc32("StpiXEX",7) == 705635915) strcat(s, "t");
if (crc32("pHRtgLEcuezz",12) == 3192195541) strcat(s, "E");
if (crc32("BRSHSyepCuUCmL",14) == 3697036771) strcat(s, "t");
if (crc32("jBmbyGZwJ",9) == 2398902163) strcat(s, "a");
if (crc32("FZppAgv",7) == 3958465520) strcat(s, "d");
if (crc32("wEueDFlwRe",10) == 2286237077) strcat(s, "c");
if (crc32("wvHfdBGPvbwVoMS",15) == 4139794236) strcat(s, "t");
if (crc32("iGxWU",5) == 3772437925) strcat(s, "h");
if (crc32("kBiWxSg",7) == 2350353829) strcat(s, "a");
if (crc32("eVvctGlgXvYwo",13) == 17745501) strcat(s, "O");
if (crc32("citLVcisOngOuFv",15) == 3025971026) strcat(s, "b");
if (crc32("Yuzkt",5) == 478254997) strcat(s, "e");
if (crc32("MtITwt",6) == 3035182545) strcat(s, "l");
if (crc32("zzEzVIFRSUAa",12) == 220986510) strcat(s, "e");
    return s;
}

char *halfoval_adjectives() {
    char *s = calloc(9);
    if (crc32("tdNUkq",6) == 593715901) strcat(s, "u");
if (crc32("yWtxc",5) == 77545768) strcat(s, "h");
if (crc32("KSMYyOiadq",10) == 3316242255) strcat(s, "r");
if (crc32("FGlsFhX",7) == 824310220) strcat(s, "a");
if (crc32("SZHsZjDuX",9) == 4113658630) strcat(s, "l");
if (crc32("eveVx",5) == 1426896491) strcat(s, "w");
if (crc32("lXFoOD",6) == 1026799415) strcat(s, "f");
if (crc32("kbZpqxnYB",9) == 4256003758) strcat(s, "o");
if (crc32("whGRXqEaDIw",11) == 2295997257) strcat(s, "v");
if (crc32("anisDgPSZWxBfhZ",15) == 3074356465) strcat(s, "i");
if (crc32("GoSJJgAZBHfVl",13) == 3143590123) strcat(s, "a");
if (crc32("pnLkI",5) == 3069319375) strcat(s, "x");
if (crc32("icjSLyNlRZ",10) == 1307404075) strcat(s, "l");
    return s;
}

char *molal_adjectives() {
    char *s = calloc(6);
    if (crc32("fjXDUsoxIWHJID",14) == 1551014022) strcat(s, "m");
if (crc32("SiBiMYWUWhw",11) == 3940690346) strcat(s, "o");
if (crc32("NGFOaGJjOQDtT",13) == 2632685185) strcat(s, "K");
if (crc32("BwytBPVLOPYCU",13) == 3622953448) strcat(s, "l");
if (crc32("aqwiG",5) == 2328988355) strcat(s, "N");
if (crc32("ZIOhQQViWLy",11) == 1056384489) strcat(s, "a");
if (crc32("cevdwRmlnrGG",12) == 3728322746) strcat(s, "l");
    return s;
}

char *flamy_adjectives() {
    char *s = calloc(6);
    if (crc32("UmMROoVgfz",10) == 3534548438) strcat(s, "f");
if (crc32("jkQVnNRVJCdJm",13) == 1151349031) strcat(s, "l");
if (crc32("JkJCpNIRPRxbOs",14) == 2796415317) strcat(s, "J");
if (crc32("SQwquPmyPMnGGoS",15) == 1997091199) strcat(s, "a");
if (crc32("iYFImhojlscbA",13) == 954752198) strcat(s, "m");
if (crc32("iRLWr",5) == 24480303) strcat(s, "y");
    return s;
}

char *diagrammatic_adjectives() {
    char *s = calloc(13);
    if (crc32("PCNqlHkU",8) == 645292796) strcat(s, "d");
if (crc32("RmmaRqLW",8) == 2428212148) strcat(s, "z");
if (crc32("nMRahH",6) == 3731692866) strcat(s, "i");
if (crc32("ZboaNZVwzP",10) == 1160685052) strcat(s, "y");
if (crc32("CbVYyWLMteyqn",13) == 3933891698) strcat(s, "a");
if (crc32("hIBIwzVVB",9) == 2014234725) strcat(s, "P");
if (crc32("NOwIFmrBmj",10) == 1651232008) strcat(s, "g");
if (crc32("irrkzUbgBiQFLbA",15) == 785168) strcat(s, "d");
if (crc32("ujjbmmrnphA",11) == 2270858719) strcat(s, "r");
if (crc32("lPAAy",5) == 3759026904) strcat(s, "a");
if (crc32("lqArVrfovXZrzav",15) == 3737396846) strcat(s, "Y");
if (crc32("aGosDKsbMgB",11) == 387248598) strcat(s, "m");
if (crc32("vEQvPSwezM",10) == 2358791675) strcat(s, "m");
if (crc32("lBSKrfOfCg",10) == 3633985802) strcat(s, "x");
if (crc32("UWxShrj",7) == 465183689) strcat(s, "a");
if (crc32("wrNLYgmo",8) == 3182184939) strcat(s, "n");
if (crc32("OsiVlUkMmLARRe",14) == 1874322860) strcat(s, "t");
if (crc32("LLweTeE",7) == 3426441455) strcat(s, "G");
if (crc32("SLIKPhh",7) == 1825318194) strcat(s, "i");
if (crc32("YuiQsn",6) == 4251134157) strcat(s, "x");
if (crc32("qTmGmtdTJl",10) == 916872824) strcat(s, "c");
    return s;
}

char *logy_adjectives() {
    char *s = calloc(5);
    if (crc32("vpqUl",5) == 225756395) strcat(s, "l");
if (crc32("wbbymRtyJC",10) == 3258138133) strcat(s, "o");
if (crc32("aksDyCVQIPB",11) == 2777415221) strcat(s, "a");
if (crc32("DwdjHRFc",8) == 3806170390) strcat(s, "g");
if (crc32("RalrZvEtbY",10) == 48970530) strcat(s, "P");
if (crc32("gKhohjoYn",9) == 2485556417) strcat(s, "y");
    return s;
}

char *consecutive_adjectives() {
    char *s = calloc(12);
    if (crc32("npWpoOdHAQnbRsC",15) == 2203384112) strcat(s, "c");
if (crc32("rmPwpYpYFTOE",12) == 79318649) strcat(s, "O");
if (crc32("KQvcnI",6) == 563447891) strcat(s, "o");
if (crc32("SwxVITCkx",9) == 1908099073) strcat(s, "c");
if (crc32("MLgrB",5) == 2143316493) strcat(s, "n");
if (crc32("aqFGt",5) == 766833548) strcat(s, "s");
if (crc32("GdFZAaqc",8) == 436446314) strcat(s, "e");
if (crc32("ROYsfYp",7) == 167797042) strcat(s, "b");
if (crc32("ozxOQDqafIqt",12) == 2491807602) strcat(s, "c");
if (crc32("cJjjFMZKvIJW",12) == 3617927719) strcat(s, "B");
if (crc32("kAxBn",5) == 969922089) strcat(s, "u");
if (crc32("ULLsaasuM",9) == 333662) strcat(s, "N");
if (crc32("GsHTxjuTUUmu",12) == 1521095849) strcat(s, "t");
if (crc32("WEltJotSsMez",12) == 1905047714) strcat(s, "i");
if (crc32("BcksfdBzM",9) == 2876140649) strcat(s, "I");
if (crc32("sUXIVuwqX",9) == 3809767177) strcat(s, "v");
if (crc32("rnNvA",5) == 2624834366) strcat(s, "e");
    return s;
}

char *antisymmetric_adjectives() {
    char *s = calloc(14);
    if (crc32("RsOcJnfnOVMw",12) == 860024360) strcat(s, "r");
if (crc32("MeRYMSo",7) == 545711456) strcat(s, "a");
if (crc32("YnlbykHQDygrG",13) == 3425306081) strcat(s, "I");
if (crc32("EaxVYWpFK",9) == 454558991) strcat(s, "n");
if (crc32("tJcfLINJhBVaU",13) == 2577957969) strcat(s, "t");
if (crc32("fGgrB",5) == 1112573929) strcat(s, "I");
if (crc32("YJittH",6) == 2927801633) strcat(s, "i");
if (crc32("XZKBjhHURVFwy",13) == 3487960611) strcat(s, "v");
if (crc32("ncrOgaETaXNOcek",15) == 1930261391) strcat(s, "s");
if (crc32("MIhdxLs",7) == 1120130524) strcat(s, "y");
if (crc32("UTvEZgms",8) == 308400517) strcat(s, "m");
if (crc32("YNDcuOx",7) == 3784752669) strcat(s, "m");
if (crc32("CuUmIPLDBpf",11) == 3959330759) strcat(s, "e");
if (crc32("icGbZCZmbmeYCCO",15) == 1422218111) strcat(s, "t");
if (crc32("XiItYPBQd",9) == 4271643546) strcat(s, "R");
if (crc32("WYoFspEHK",9) == 1679699260) strcat(s, "r");
if (crc32("nwSRPGUNpQ",10) == 1689407139) strcat(s, "e");
if (crc32("alJEqFjPAf",10) == 2882470144) strcat(s, "i");
if (crc32("OGCBu",5) == 4032823922) strcat(s, "O");
if (crc32("VUPcaKM",7) == 3261007717) strcat(s, "c");
    return s;
}

char *unfired_adjectives() {
    char *s = calloc(8);
    if (crc32("mwTAJcgb",8) == 1421422451) strcat(s, "Q");
if (crc32("nEvjfJMk",8) == 1149149023) strcat(s, "u");
if (crc32("hRxZENGJRNLx",12) == 3536256050) strcat(s, "L");
if (crc32("WmqiWrMArtAan",13) == 105626316) strcat(s, "n");
if (crc32("MelBOXXyMSmgsh",14) == 1940074655) strcat(s, "U");
if (crc32("BFyOTMlcPJtM",12) == 841872250) strcat(s, "f");
if (crc32("lkZSznuYpzWkz",13) == 2912585602) strcat(s, "S");
if (crc32("mVlwh",5) == 725360768) strcat(s, "i");
if (crc32("KjXzFAgexRFIqmT",15) == 2224297895) strcat(s, "v");
if (crc32("maFdQcmvyhdIRLM",15) == 647895338) strcat(s, "r");
if (crc32("ngSjancgka",10) == 3721667695) strcat(s, "e");
if (crc32("ElCiwq",6) == 144945329) strcat(s, "B");
if (crc32("oxSoMIrr",8) == 2535543868) strcat(s, "d");
    return s;
}

char *coffered_adjectives() {
    char *s = calloc(9);
    if (crc32("YRVLDicAkzz",11) == 3924360132) strcat(s, "c");
if (crc32("tdrypX",6) == 2639963137) strcat(s, "o");
if (crc32("PlVlPmAQzryk",12) == 442989531) strcat(s, "f");
if (crc32("gyWJtQJSo",9) == 1808849099) strcat(s, "f");
if (crc32("bdbnlF",6) == 2810846387) strcat(s, "Z");
if (crc32("GUJeB",5) == 762788764) strcat(s, "e");
if (crc32("rxazNWsBuWYU",12) == 2844856932) strcat(s, "F");
if (crc32("wDwwmyrf",8) == 93500468) strcat(s, "r");
if (crc32("KscqBNJsHJth",12) == 1469279256) strcat(s, "a");
if (crc32("QBohCe",6) == 2536408324) strcat(s, "e");
if (crc32("HgEMmcWUwbHqvV",14) == 253073200) strcat(s, "d");
    return s;
}

char *doited_adjectives() {
    char *s = calloc(7);
    if (crc32("PnkioPNtWZx",11) == 1198219559) strcat(s, "C");
if (crc32("cggeG",5) == 65774414) strcat(s, "d");
if (crc32("qyOzGnpnyZopkTX",15) == 638562656) strcat(s, "o");
if (crc32("wBgJUJesySVd",12) == 594450820) strcat(s, "D");
if (crc32("MrUULuSmuued",12) == 1677456203) strcat(s, "i");
if (crc32("sFCvyw",6) == 3473747895) strcat(s, "Q");
if (crc32("cXKdIWdOd",9) == 2710877479) strcat(s, "t");
if (crc32("buLlFTfJI",9) == 578324515) strcat(s, "T");
if (crc32("YFOkU",5) == 2878374060) strcat(s, "e");
if (crc32("btURXI",6) == 371548891) strcat(s, "d");
    return s;
}

char *nonfloriferous_adjectives() {
    char *s = calloc(15);
    if (crc32("vBlLhlujP",9) == 1148554162) strcat(s, "n");
if (crc32("UYTcSpVQeFGLA",13) == 2994488467) strcat(s, "h");
if (crc32("nAMuBVNpvXMpU",13) == 360141790) strcat(s, "o");
if (crc32("WpHpmEoZTGxWVR",14) == 210144881) strcat(s, "n");
if (crc32("zndPMWa",7) == 4147668176) strcat(s, "f");
if (crc32("hJRofVCNASiUZ",13) == 3392150862) strcat(s, "l");
if (crc32("ICyEPqhkGtPb",12) == 1588380384) strcat(s, "o");
if (crc32("ddOYBjuMYgS",11) == 179638948) strcat(s, "l");
if (crc32("AIJGRhrn",8) == 2236975737) strcat(s, "r");
if (crc32("gHDznHJRRJcQ",12) == 2842230748) strcat(s, "i");
if (crc32("UDomBLysyXrDYy",14) == 2920230027) strcat(s, "R");
if (crc32("THLNm",5) == 1902699790) strcat(s, "f");
if (crc32("hkPTcdVs",8) == 1830878401) strcat(s, "e");
if (crc32("gUBKGI",6) == 3887202984) strcat(s, "k");
if (crc32("ZMSHokRa",8) == 4085178499) strcat(s, "r");
if (crc32("VsRjbWNm",8) == 470438237) strcat(s, "o");
if (crc32("PhDWnYChDlSkCGe",15) == 3698429658) strcat(s, "u");
if (crc32("yFYeYuLEuV",10) == 3134836826) strcat(s, "s");
    return s;
}

char *crossbanded_adjectives() {
    char *s = calloc(12);
    if (crc32("ANMlwrbMuP",10) == 3411495952) strcat(s, "k");
if (crc32("jTiMrngf",8) == 1897520100) strcat(s, "c");
if (crc32("vrvfDzAqZOmwwp",14) == 3898862822) strcat(s, "r");
if (crc32("poepOXnSIxUd",12) == 1108692117) strcat(s, "J");
if (crc32("JxjziODikoao",12) == 895733452) strcat(s, "o");
if (crc32("BBfXoNhwqLzPZlk",15) == 3552689116) strcat(s, "R");
if (crc32("BmIWhBMOgMf",11) == 3643507831) strcat(s, "s");
if (crc32("LtVdqSK",7) == 2831696243) strcat(s, "s");
if (crc32("GbXdr",5) == 1626049911) strcat(s, "b");
if (crc32("ZZUGDPL",7) == 4088272858) strcat(s, "a");
if (crc32("LdUbNuoEN",9) == 611516176) strcat(s, "p");
if (crc32("DyDpFUpe",8) == 452012456) strcat(s, "n");
if (crc32("iynWpNN",7) == 1960317498) strcat(s, "d");
if (crc32("cXFuWjZXtoRk",12) == 4020031412) strcat(s, "e");
if (crc32("YmhpHMxcgpt",11) == 656916417) strcat(s, "T");
if (crc32("SmNqi",5) == 143875161) strcat(s, "d");
    return s;
}

char *predetrimental_adjectives() {
    char *s = calloc(15);
    if (crc32("vgzgr",5) == 2965227919) strcat(s, "F");
if (crc32("MCXaLVqY",8) == 2075568054) strcat(s, "p");
if (crc32("ZqualPgCfItuUE",14) == 2218870291) strcat(s, "r");
if (crc32("oZYNy",5) == 1572750955) strcat(s, "e");
if (crc32("lPQaiRjcEH",10) == 1751493426) strcat(s, "d");
if (crc32("zTRIOTbUmgiVYc",14) == 4028368939) strcat(s, "e");
if (crc32("YguSe",5) == 2879694054) strcat(s, "t");
if (crc32("hqzWprWhWNkurRq",15) == 3640778356) strcat(s, "p");
if (crc32("esyspbi",7) == 1934161430) strcat(s, "r");
if (crc32("ulmsNVMch",9) == 3236957249) strcat(s, "i");
if (crc32("NkVNOWXouyCTYl",14) == 2300195783) strcat(s, "g");
if (crc32("djTMbnvHsHvGqA",14) == 3890539575) strcat(s, "m");
if (crc32("aizeSBWCFo",10) == 1047543653) strcat(s, "e");
if (crc32("BPdqW",5) == 2749963402) strcat(s, "n");
if (crc32("jqrKfT",6) == 1044846362) strcat(s, "t");
if (crc32("KVwVSHOyLsFAz",13) == 3637795682) strcat(s, "g");
if (crc32("cQxPe",5) == 3061867308) strcat(s, "a");
if (crc32("ZkvHHKEdgMv",11) == 3661220764) strcat(s, "G");
if (crc32("pcbAcNqAYaITf",13) == 4156194783) strcat(s, "l");
    return s;
}

char *semirhythmic_adjectives() {
    char *s = calloc(13);
    if (crc32("GVXFpppB",8) == 3827702655) strcat(s, "m");
if (crc32("TKvvLtgOcQLs",12) == 2974128434) strcat(s, "s");
if (crc32("yHdFZ",5) == 2741283008) strcat(s, "I");
if (crc32("yGROTDpOKE",10) == 3385566233) strcat(s, "e");
if (crc32("ASnWWgNUD",9) == 2620327547) strcat(s, "L");
if (crc32("aKMGUQ",6) == 2588067794) strcat(s, "m");
if (crc32("oTYDPhIW",8) == 1694278221) strcat(s, "i");
if (crc32("LheCuBsnEtyW",12) == 472553497) strcat(s, "r");
if (crc32("oFiDrSfl",8) == 299209866) strcat(s, "h");
if (crc32("gtoEkCaBgY",10) == 3071518009) strcat(s, "w");
if (crc32("YmZnTso",7) == 2226907220) strcat(s, "y");
if (crc32("FsfBy",5) == 3486975499) strcat(s, "t");
if (crc32("ajqBnR",6) == 3262410736) strcat(s, "V");
if (crc32("xteNq",5) == 3963175218) strcat(s, "h");
if (crc32("skPPNRp",7) == 964176554) strcat(s, "h");
if (crc32("THfoyh",6) == 2920085469) strcat(s, "m");
if (crc32("ebtoEcbc",8) == 268068736) strcat(s, "i");
if (crc32("cLBzIvNARd",10) == 1415082310) strcat(s, "c");
    return s;
}

char *cushionlike_adjectives() {
    char *s = calloc(12);
    if (crc32("TOXQRAix",8) == 421413402) strcat(s, "c");
if (crc32("xCicIaoH",8) == 2876662221) strcat(s, "u");
if (crc32("lxwQvlAwCfh",11) == 2824926667) strcat(s, "o");
if (crc32("HMtLcXV",7) == 1042614972) strcat(s, "s");
if (crc32("hvlwXRgYWI",10) == 2447389679) strcat(s, "h");
if (crc32("OlocJgTgYAYkeDo",15) == 980262079) strcat(s, "F");
if (crc32("QSoARTwCvLyCq",13) == 255119384) strcat(s, "i");
if (crc32("VHGXEtlZqzkMdS",14) == 2932695666) strcat(s, "o");
if (crc32("xFLnWgrguoQUIz",14) == 698408011) strcat(s, "n");
if (crc32("JuDljCZZSZaVtjT",15) == 4141291739) strcat(s, "A");
if (crc32("PcDzKmBHeuYy",12) == 3567471541) strcat(s, "l");
if (crc32("IvKfhnWJMKg",11) == 1001581619) strcat(s, "i");
if (crc32("LZWUjVvIDhEt",12) == 3066220347) strcat(s, "k");
if (crc32("wImVmEJWZOlyl",13) == 1026713220) strcat(s, "e");
    return s;
}

char *illconditioned_adjectives() {
    char *s = calloc(15);
    if (crc32("KuvMG",5) == 1223901042) strcat(s, "i");
if (crc32("FsrbQNVqN",9) == 3864799316) strcat(s, "l");
if (crc32("DHlir",5) == 4036154826) strcat(s, "w");
if (crc32("VYNDCin",7) == 1773460646) strcat(s, "l");
if (crc32("STxzW",5) == 2277750320) strcat(s, "c");
if (crc32("MmJdrTzuYgDDa",13) == 4190938747) strcat(s, "o");
if (crc32("TkNVAIiKQWLLBQ",14) == 1883098244) strcat(s, "h");
if (crc32("AVEkZEcimMdXer",14) == 1632483333) strcat(s, "n");
if (crc32("CssNiucvdN",10) == 2651917444) strcat(s, "d");
if (crc32("JiufYuNK",8) == 3464946826) strcat(s, "m");
if (crc32("XLNAkPQpIV",10) == 1901576323) strcat(s, "i");
if (crc32("oHjrC",5) == 880550651) strcat(s, "t");
if (crc32("TvQKm",5) == 135638778) strcat(s, "i");
if (crc32("XehEqnXzKXIPnq",14) == 665188829) strcat(s, "o");
if (crc32("ekcGBIVggF",10) == 3560198613) strcat(s, "n");
if (crc32("vipBwylt",8) == 197792468) strcat(s, "e");
if (crc32("SmytmTZmfpVWJo",14) == 2650358236) strcat(s, "l");
if (crc32("geHULZFYr",9) == 4117866935) strcat(s, "d");
    return s;
}

char *ungiven_adjectives() {
    char *s = calloc(8);
    if (crc32("CFWCkiiHgChXj",13) == 290612202) strcat(s, "f");
if (crc32("omOMHVOv",8) == 552845577) strcat(s, "u");
if (crc32("tSNlJwoZPJpZmj",14) == 2848911802) strcat(s, "T");
if (crc32("fXcJWQfJcssbkPy",15) == 2500497675) strcat(s, "n");
if (crc32("RzzwinIwmhgmEnY",15) == 1526609963) strcat(s, "g");
if (crc32("VyLbLKNhetWvkn",14) == 2408204152) strcat(s, "D");
if (crc32("thieMgPPbZpNOqB",15) == 845546658) strcat(s, "i");
if (crc32("HWYRVwKjXLFbXR",14) == 702466679) strcat(s, "c");
if (crc32("amMgzMRPMmxbkAH",15) == 3553428737) strcat(s, "v");
if (crc32("QjFOjVJxSvOlg",13) == 2636778228) strcat(s, "b");
if (crc32("ifjJKOY",7) == 1667052801) strcat(s, "e");
if (crc32("URtuRiJLc",9) == 2072023225) strcat(s, "n");
    return s;
}

char *unprolific_adjectives() {
    char *s = calloc(11);
    if (crc32("UOxSZpqxgydPtoo",15) == 2345950119) strcat(s, "u");
if (crc32("ZygwDdcCudMMC",13) == 1531138816) strcat(s, "n");
if (crc32("pXdHrKbEEwRVSJ",14) == 3627442964) strcat(s, "V");
if (crc32("qPnuYhfwDxDGRGz",15) == 3556365635) strcat(s, "p");
if (crc32("qazAzeKaLgO",11) == 3816023518) strcat(s, "r");
if (crc32("dIqgJlXYaoins",13) == 1539103759) strcat(s, "P");
if (crc32("UXiRGLKWLT",10) == 2493610091) strcat(s, "o");
if (crc32("WvoBtZ",6) == 107820640) strcat(s, "l");
if (crc32("YhtkNfqvqwn",11) == 1437748648) strcat(s, "i");
if (crc32("AMjGqHWdIo",10) == 2541983223) strcat(s, "D");
if (crc32("IRlJcwSWWQidyIb",15) == 4066143137) strcat(s, "f");
if (crc32("RmhBaV",6) == 3796145094) strcat(s, "i");
if (crc32("bICJKOi",7) == 3695989451) strcat(s, "D");
if (crc32("yKFSjSMPPL",10) == 1578173478) strcat(s, "c");
    return s;
}

char *unbillable_adjectives() {
    char *s = calloc(11);
    if (crc32("jupznWCAKUUm",12) == 3101727612) strcat(s, "u");
if (crc32("LfDgeiSyeKVQnJ",14) == 895285605) strcat(s, "T");
if (crc32("lsvjcyWkyqcocxx",15) == 826953386) strcat(s, "n");
if (crc32("nnPcjcsasqY",11) == 3195679610) strcat(s, "i");
if (crc32("xodoKKsghdP",11) == 283169886) strcat(s, "b");
if (crc32("eEsFfAofgULMawE",15) == 782602587) strcat(s, "i");
if (crc32("vKXZuMLNw",9) == 1808139093) strcat(s, "i");
if (crc32("hWHMsy",6) == 3565138595) strcat(s, "l");
if (crc32("DCpoeStGDhLe",12) == 3191407957) strcat(s, "z");
if (crc32("jrIiDUiJSOdwL",13) == 2969902802) strcat(s, "l");
if (crc32("KCGossmGfmy",11) == 3671868028) strcat(s, "a");
if (crc32("IDpfZQlPEHt",11) == 2044042483) strcat(s, "b");
if (crc32("gbpjfNUiQhyuXf",14) == 2081372260) strcat(s, "K");
if (crc32("QPiNwXuzdZwHKn",14) == 4066863577) strcat(s, "l");
if (crc32("tuGse",5) == 3666789659) strcat(s, "e");
    return s;
}

char *bountyless_adjectives() {
    char *s = calloc(11);
    if (crc32("UAIxrKB",7) == 1685095992) strcat(s, "r");
if (crc32("cZMeSApjRnC",11) == 3149032525) strcat(s, "b");
if (crc32("gZNJzzrhuWIg",12) == 731808405) strcat(s, "o");
if (crc32("XHhGR",5) == 3967316039) strcat(s, "u");
if (crc32("aarUlMXoEBBzL",13) == 258539061) strcat(s, "n");
if (crc32("uVAFVjesDnRrbmo",15) == 2805190914) strcat(s, "t");
if (crc32("gMLkRxgAqAuo",12) == 4111145679) strcat(s, "y");
if (crc32("HjNqqnrSMRtTWK",14) == 1784837063) strcat(s, "l");
if (crc32("PqIJMHawUPpGYIr",15) == 761538916) strcat(s, "l");
if (crc32("bogIelmNoo",10) == 908389206) strcat(s, "e");
if (crc32("SSDerodnRnOHD",13) == 2431318498) strcat(s, "s");
if (crc32("zizEZ",5) == 1824020950) strcat(s, "s");
    return s;
}

char *asclepiadaceous_adjectives() {
    char *s = calloc(16);
    if (crc32("JYqLpDTBxKvmAJ",14) == 1631254133) strcat(s, "a");
if (crc32("CtXtCfjZGwV",11) == 2141035989) strcat(s, "D");
if (crc32("RUIAZLSNUDuuc",13) == 2422914583) strcat(s, "s");
if (crc32("ddsGLhf",7) == 3107213625) strcat(s, "c");
if (crc32("MTsOHwHgDO",10) == 424674360) strcat(s, "Z");
if (crc32("rjahBpAtW",9) == 907656463) strcat(s, "l");
if (crc32("QkNOWa",6) == 1471169283) strcat(s, "e");
if (crc32("BFIbILXRHHvaDu",14) == 2571477133) strcat(s, "p");
if (crc32("NkdqHZhcywOcBs",14) == 443651692) strcat(s, "O");
if (crc32("cbSAbjNRBT",10) == 3189659848) strcat(s, "i");
if (crc32("CkOjfoaniQdn",12) == 781267878) strcat(s, "b");
if (crc32("uQABfgGXO",9) == 873130377) strcat(s, "a");
if (crc32("YQmIJh",6) == 1623771539) strcat(s, "d");
if (crc32("QHVaGwPi",8) == 744962241) strcat(s, "a");
if (crc32("umtDsl",6) == 2379930304) strcat(s, "Z");
if (crc32("IAhlgLTAv",9) == 1996607195) strcat(s, "c");
if (crc32("lWpVMMo",7) == 937239043) strcat(s, "e");
if (crc32("gQJNlpH",7) == 2978842737) strcat(s, "J");
if (crc32("bMLoiHapLVkfS",13) == 3922780915) strcat(s, "o");
if (crc32("cwmeYC",6) == 2007773354) strcat(s, "u");
if (crc32("kERkGUUQhTTMHQ",14) == 4233886496) strcat(s, "s");
    return s;
}

char *nightmarish_adjectives() {
    char *s = calloc(12);
    if (crc32("kXKPLv",6) == 27300071) strcat(s, "C");
if (crc32("ZCkng",5) == 1359626679) strcat(s, "n");
if (crc32("JQgel",5) == 4052383917) strcat(s, "d");
if (crc32("WipLWQxWPJpcaa",14) == 1008058682) strcat(s, "i");
if (crc32("AdjXQpzAJvtfsj",14) == 882101294) strcat(s, "C");
if (crc32("hOmDuiNxNV",10) == 3643608518) strcat(s, "g");
if (crc32("yZdtZnD",7) == 684688484) strcat(s, "G");
if (crc32("KSUDlxDlFIK",11) == 2593740811) strcat(s, "h");
if (crc32("rCPjCLd",7) == 3485094296) strcat(s, "D");
if (crc32("riYuKWzuV",9) == 3934633676) strcat(s, "t");
if (crc32("xFGhfXhzeqC",11) == 933854746) strcat(s, "m");
if (crc32("nrNixBqWI",9) == 4033119163) strcat(s, "a");
if (crc32("iEqCqpoGPNBt",12) == 2541727574) strcat(s, "Y");
if (crc32("jZldhJIKd",9) == 1327733330) strcat(s, "r");
if (crc32("hDIqIoTgFKUjpOT",15) == 1455761081) strcat(s, "i");
if (crc32("TlJsCB",6) == 372578055) strcat(s, "h");
if (crc32("FCkBlXjTE",9) == 3907569389) strcat(s, "s");
if (crc32("jUHesHtURurNNC",14) == 3887262114) strcat(s, "h");
    return s;
}

char *gutterlike_adjectives() {
    char *s = calloc(11);
    if (crc32("otDcvWxNH",9) == 3410655821) strcat(s, "i");
if (crc32("BqWaCuhdVfR",11) == 463696459) strcat(s, "g");
if (crc32("SgwrnrWhDqdA",12) == 3293568378) strcat(s, "u");
if (crc32("zeAinASSYrh",11) == 3254961276) strcat(s, "t");
if (crc32("xdZGmnLaXouMg",13) == 3354804118) strcat(s, "n");
if (crc32("DpJUj",5) == 399016009) strcat(s, "t");
if (crc32("sDXgrNdVTIJTSS",14) == 2632374029) strcat(s, "a");
if (crc32("RHOWi",5) == 1610859510) strcat(s, "e");
if (crc32("DjACum",6) == 4268477273) strcat(s, "n");
if (crc32("CtFGfTTvxOdZjJ",14) == 4197875526) strcat(s, "r");
if (crc32("avpSnjLiDXouI",13) == 210772266) strcat(s, "n");
if (crc32("PYwssRA",7) == 2023867522) strcat(s, "l");
if (crc32("tWlNpeTas",9) == 1184115415) strcat(s, "i");
if (crc32("qmPkvMvQsyoDzam",15) == 2361740493) strcat(s, "k");
if (crc32("UMPmrP",6) == 2961357134) strcat(s, "e");
    return s;
}

char *pretyphoid_adjectives() {
    char *s = calloc(11);
    if (crc32("fEVgPET",7) == 394531028) strcat(s, "s");
if (crc32("lsyWZSfDjAUuzuy",15) == 472859545) strcat(s, "p");
if (crc32("BvyeujK",7) == 1986094028) strcat(s, "y");
if (crc32("TEREgOzzWL",10) == 3731242309) strcat(s, "r");
if (crc32("QPPOdbcbRk",10) == 3868535209) strcat(s, "B");
if (crc32("ylycDhhccshuj",13) == 138987923) strcat(s, "e");
if (crc32("DXkkYTEfTsu",11) == 1124557685) strcat(s, "U");
if (crc32("hIqWkLQYeSZE",12) == 791510011) strcat(s, "t");
if (crc32("cxdaJjXeffPycg",14) == 773098815) strcat(s, "D");
if (crc32("SYwqJwiCIikNyT",14) == 1946184531) strcat(s, "y");
if (crc32("SDXRFPCrfQPPra",14) == 1955464500) strcat(s, "V");
if (crc32("BtBtBL",6) == 549469389) strcat(s, "p");
if (crc32("rEvmfwnxEbISkK",14) == 729036682) strcat(s, "h");
if (crc32("RRWPffPHby",10) == 2108701014) strcat(s, "o");
if (crc32("OmFvAjYwuH",10) == 2603593754) strcat(s, "i");
if (crc32("iSaUhOkyF",9) == 4078403421) strcat(s, "d");
    return s;
}

char *intercalative_adjectives() {
    char *s = calloc(14);
    if (crc32("BoFXXg",6) == 2505355542) strcat(s, "i");
if (crc32("ALnBnAtWFUeCFJS",15) == 127839332) strcat(s, "O");
if (crc32("xGRyTmUtvQhRXJx",15) == 2687315960) strcat(s, "n");
if (crc32("ZVOKAPkpx",9) == 4044889992) strcat(s, "s");
if (crc32("jicsFZtSkk",10) == 721892699) strcat(s, "t");
if (crc32("VpQKZYuxx",9) == 3420578045) strcat(s, "A");
if (crc32("XxxqpKTZEJDi",12) == 2035914157) strcat(s, "e");
if (crc32("zfSxbxyaFt",10) == 273641684) strcat(s, "w");
if (crc32("rCZKEdy",7) == 267929336) strcat(s, "r");
if (crc32("WLqbIAnEjG",10) == 1810987982) strcat(s, "c");
if (crc32("pBebcUeoJoOkwd",14) == 3971215119) strcat(s, "M");
if (crc32("xBbcTuwSNt",10) == 3645738265) strcat(s, "a");
if (crc32("YOuzT",5) == 3686448358) strcat(s, "l");
if (crc32("RkVLORkgYbHm",12) == 2951736841) strcat(s, "a");
if (crc32("tJLMavlVIfYZExU",15) == 1319373332) strcat(s, "E");
if (crc32("yYSYReexSeqxCL",14) == 1233497091) strcat(s, "t");
if (crc32("eZThTiePGx",10) == 3633497476) strcat(s, "i");
if (crc32("XcdoRf",6) == 3280985457) strcat(s, "a");
if (crc32("jURDjR",6) == 3837697252) strcat(s, "v");
if (crc32("pDtZYgnEVxjVDa",14) == 3566434658) strcat(s, "e");
    return s;
}

char *nonexhaustible_adjectives() {
    char *s = calloc(15);
    if (crc32("ssClApSN",8) == 5058173) strcat(s, "f");
if (crc32("BHjbo",5) == 1966585852) strcat(s, "n");
if (crc32("qSFHpkHZpjuaLFl",15) == 43528802) strcat(s, "o");
if (crc32("VpxILe",6) == 3537381222) strcat(s, "j");
if (crc32("zHFqOcktuGhdebn",15) == 3984443663) strcat(s, "n");
if (crc32("tPGwNFGm",8) == 3030758884) strcat(s, "e");
if (crc32("rBGKWKmCqmedX",13) == 1393709762) strcat(s, "b");
if (crc32("TdcUGvCPBhMID",13) == 642833278) strcat(s, "x");
if (crc32("zOkQEiD",7) == 2544406024) strcat(s, "h");
if (crc32("aXqsc",5) == 3914569245) strcat(s, "h");
if (crc32("IuNPZtNdXKpcIrW",15) == 1802317677) strcat(s, "a");
if (crc32("BbAEsiehCUkKIlu",15) == 1316149113) strcat(s, "y");
if (crc32("cwwXK",5) == 747262772) strcat(s, "u");
if (crc32("AcDCTuX",7) == 1706100708) strcat(s, "Q");
if (crc32("WlAgIKMCqvwAH",13) == 2462283668) strcat(s, "s");
if (crc32("rbZIl",5) == 3498772835) strcat(s, "t");
if (crc32("FMpionBJcNvl",12) == 825408078) strcat(s, "b");
if (crc32("NhKWiCXkEht",11) == 3507896025) strcat(s, "i");
if (crc32("QZGOceMKJp",10) == 1403728183) strcat(s, "b");
if (crc32("PAWutQDkiYSt",12) == 2243568812) strcat(s, "l");
if (crc32("yxsIuWaRvVtVqOg",15) == 1706482882) strcat(s, "H");
if (crc32("NSvfIiZS",8) == 2469249573) strcat(s, "e");
    return s;
}

char *umbonal_adjectives() {
    char *s = calloc(8);
    if (crc32("zPUMBeYJyp",10) == 1693373917) strcat(s, "N");
if (crc32("vZFTHEiJfE",10) == 3135489558) strcat(s, "u");
if (crc32("AZZRqeTdvZxWrWM",15) == 897456521) strcat(s, "p");
if (crc32("OceInXDB",8) == 2542446596) strcat(s, "m");
if (crc32("YbMBluoahEepAV",14) == 223960355) strcat(s, "P");
if (crc32("uZaoLEevZL",10) == 4263167987) strcat(s, "b");
if (crc32("DFeRYUd",7) == 713113886) strcat(s, "o");
if (crc32("gBUIy",5) == 3191348601) strcat(s, "n");
if (crc32("KAHMDKQ",7) == 694469243) strcat(s, "G");
if (crc32("ZKPUrOwQgE",10) == 509944180) strcat(s, "a");
if (crc32("swTDIWhKICL",11) == 1686211573) strcat(s, "l");
    return s;
}

char *educated_adjectives() {
    char *s = calloc(9);
    if (crc32("hDhEagJPiSTDUeR",15) == 3322175293) strcat(s, "r");
if (crc32("bOtmXZGftw",10) == 2820476969) strcat(s, "e");
if (crc32("EZEuHRcFAo",10) == 4060043826) strcat(s, "e");
if (crc32("QZUXILtkfOy",11) == 2576984243) strcat(s, "d");
if (crc32("zpmsrqSe",8) == 2257188273) strcat(s, "u");
if (crc32("CHczmDGeImoFMz",14) == 973524929) strcat(s, "v");
if (crc32("pIzWlYny",8) == 4166095130) strcat(s, "c");
if (crc32("XBihjLbmA",9) == 640239002) strcat(s, "a");
if (crc32("tCUWQTChlS",10) == 4270695226) strcat(s, "t");
if (crc32("VCdUkiVPYq",10) == 25512134) strcat(s, "K");
if (crc32("vEJkj",5) == 1243183169) strcat(s, "e");
if (crc32("xLwnjrigvI",10) == 335556547) strcat(s, "d");
    return s;
}

char *wellbraced_adjectives() {
    char *s = calloc(11);
    if (crc32("JTcnteGbeFDvNI",14) == 3048386733) strcat(s, "c");
if (crc32("pOKsWbyL",8) == 1019399304) strcat(s, "w");
if (crc32("yjqqj",5) == 3954244326) strcat(s, "v");
if (crc32("uAtJpxRkXzIFti",14) == 1372516079) strcat(s, "e");
if (crc32("PwcFgdEujd",10) == 2935183932) strcat(s, "u");
if (crc32("OhqNtMi",7) == 1454414224) strcat(s, "l");
if (crc32("qrmoRtqp",8) == 2247773523) strcat(s, "l");
if (crc32("xyzIuJCLrhsd",12) == 2526935212) strcat(s, "b");
if (crc32("PAOlvUpJILlQNZ",14) == 1303749882) strcat(s, "r");
if (crc32("USXbm",5) == 2004226490) strcat(s, "H");
if (crc32("wFIMFAfENFLpgd",14) == 2922149373) strcat(s, "a");
if (crc32("EltdBZMp",8) == 4054634639) strcat(s, "c");
if (crc32("tXARKGr",7) == 486391039) strcat(s, "e");
if (crc32("pBjmThzZxvcZC",13) == 971708678) strcat(s, "Z");
if (crc32("dXakvimtgEkJH",13) == 3289400900) strcat(s, "d");
    return s;
}

char *quasitypical_adjectives() {
    char *s = calloc(13);
    if (crc32("lSKcSMrccLpm",12) == 3827059264) strcat(s, "Y");
if (crc32("acRpzuKE",8) == 942320021) strcat(s, "q");
if (crc32("rtWNqHvoVUydQIM",15) == 129690025) strcat(s, "u");
if (crc32("TiwAEGBxrTiTE",13) == 86877252) strcat(s, "A");
if (crc32("bKSyBc",6) == 1337034844) strcat(s, "a");
if (crc32("vbOpVcd",7) == 3610731522) strcat(s, "R");
if (crc32("vUqwYBoGvasvyOo",15) == 329905379) strcat(s, "s");
if (crc32("zXLXYemSD",9) == 4293024231) strcat(s, "i");
if (crc32("EyEExWvfSc",10) == 2587274651) strcat(s, "t");
if (crc32("MwaXuhliLNeQ",12) == 3983689093) strcat(s, "y");
if (crc32("ImPvwfL",7) == 2019802833) strcat(s, "x");
if (crc32("oGTfeqrWfTbMI",13) == 964275333) strcat(s, "p");
if (crc32("UVVgbEYUmeKDWqh",15) == 1712247258) strcat(s, "i");
if (crc32("FEbqzHxZLNb",11) == 1296155519) strcat(s, "c");
if (crc32("hKpbyLwQOuluDS",14) == 2210788191) strcat(s, "a");
if (crc32("doBNTctgyNVSBGd",15) == 524798746) strcat(s, "H");
if (crc32("qRiBDHRYEA",10) == 3361960770) strcat(s, "l");
    return s;
}

char *undiscernible_adjectives() {
    char *s = calloc(14);
    if (crc32("cvqfZDZaJQ",10) == 1031972405) strcat(s, "N");
if (crc32("kKMSrfTk",8) == 3942715819) strcat(s, "u");
if (crc32("CRPkkcmzaPPr",12) == 2694423382) strcat(s, "n");
if (crc32("SFrud",5) == 2938796699) strcat(s, "A");
if (crc32("QwFuViaYQzHgy",13) == 295079548) strcat(s, "d");
if (crc32("okhOkHXaMuJAS",13) == 2546118139) strcat(s, "i");
if (crc32("zLjqdmIURNJE",12) == 967019253) strcat(s, "s");
if (crc32("fIWUeQbBMqhk",12) == 748777459) strcat(s, "p");
if (crc32("nofchfVtMLQ",11) == 902598852) strcat(s, "c");
if (crc32("RcHwzjhB",8) == 1789909976) strcat(s, "J");
if (crc32("sHuAZ",5) == 370569669) strcat(s, "e");
if (crc32("IfgugCTebcv",11) == 2090469016) strcat(s, "r");
if (crc32("VnJrjk",6) == 2881076479) strcat(s, "n");
if (crc32("SShFuaSdBIZR",12) == 443161393) strcat(s, "i");
if (crc32("kgeXGHywzSZ",11) == 15567754) strcat(s, "I");
if (crc32("xfpfx",5) == 675654067) strcat(s, "b");
if (crc32("PrTJBezxziF",11) == 3698725324) strcat(s, "f");
if (crc32("AbhcxZXBG",9) == 2925336878) strcat(s, "l");
if (crc32("BvkhleAQciUdff",14) == 1529457204) strcat(s, "e");
    return s;
}

char *overfunctioning_adjectives() {
    char *s = calloc(16);
    if (crc32("yIgHuKwPcr",10) == 678332943) strcat(s, "o");
if (crc32("uMPcFt",6) == 983139924) strcat(s, "v");
if (crc32("MZMDMNBRd",9) == 943623364) strcat(s, "z");
if (crc32("wUcWjWBorHp",11) == 2571449273) strcat(s, "e");
if (crc32("zwnBMlNgNLL",11) == 3741115822) strcat(s, "r");
if (crc32("zrosgquXBHrDK",13) == 906523233) strcat(s, "C");
if (crc32("XAIKnGZEFAZZkw",14) == 1798869646) strcat(s, "f");
if (crc32("AmcnIiL",7) == 4215938719) strcat(s, "p");
if (crc32("mBSoawaTzAnSsn",14) == 176803177) strcat(s, "u");
if (crc32("tNwmaWindF",10) == 3588999497) strcat(s, "u");
if (crc32("FYuwdUuUYcgkv",13) == 3088256364) strcat(s, "n");
if (crc32("bFjaYTsOnJvnp",13) == 929345769) strcat(s, "c");
if (crc32("cskxpHTQSeLm",12) == 4190146450) strcat(s, "I");
if (crc32("eaxahdcnIYq",11) == 1048377003) strcat(s, "t");
if (crc32("HGrkUoWqLmooxm",14) == 1345659220) strcat(s, "U");
if (crc32("IAUYpBhnmiu",11) == 3444235282) strcat(s, "i");
if (crc32("NByjTa",6) == 297183720) strcat(s, "o");
if (crc32("mBqKytCTCXEfv",13) == 4114469365) strcat(s, "d");
if (crc32("fWUthQ",6) == 4215267822) strcat(s, "n");
if (crc32("euniegmppaFwcwE",15) == 3092144527) strcat(s, "i");
if (crc32("klmmfb",6) == 991260916) strcat(s, "y");
if (crc32("QqFFzgewZDbj",12) == 2488157929) strcat(s, "n");
if (crc32("PTzpOFM",7) == 611531657) strcat(s, "g");
    return s;
}

char *inquirable_adjectives() {
    char *s = calloc(11);
    if (crc32("ZeSoesARyflBve",14) == 1812161809) strcat(s, "i");
if (crc32("CQvmnGj",7) == 1166329048) strcat(s, "J");
if (crc32("fEmhvIzIhEWJ",12) == 2009160110) strcat(s, "n");
if (crc32("BMJRyynvMLQFU",13) == 3179255601) strcat(s, "q");
if (crc32("ZXZvOBVDkgCxB",13) == 597925172) strcat(s, "w");
if (crc32("LGowtineiJlI",12) == 2912070872) strcat(s, "u");
if (crc32("GONKxA",6) == 2550504248) strcat(s, "i");
if (crc32("gtVDIaI",7) == 3054420694) strcat(s, "t");
if (crc32("CRCRhKgVQI",10) == 1881107523) strcat(s, "r");
if (crc32("rhWtFaPWV",9) == 49606768) strcat(s, "a");
if (crc32("yqvQGagPtbIGc",13) == 652620081) strcat(s, "L");
if (crc32("YLNSmYOij",9) == 1843208669) strcat(s, "b");
if (crc32("vcllSHBTKx",10) == 1124311910) strcat(s, "l");
if (crc32("dnRwhsuf",8) == 3187839880) strcat(s, "e");
    return s;
}

char *vitascopic_adjectives() {
    char *s = calloc(11);
    if (crc32("WMUFT",5) == 2401361077) strcat(s, "U");
if (crc32("OBHisKqQ",8) == 506442435) strcat(s, "v");
if (crc32("SBexjpxePl",10) == 1902195990) strcat(s, "f");
if (crc32("DaLcpckPncjZknc",15) == 4160978013) strcat(s, "i");
if (crc32("QwzJeZGjM",9) == 3393743683) strcat(s, "N");
if (crc32("aqpvOwgU",8) == 3988312792) strcat(s, "t");
if (crc32("cZGFEnNMarz",11) == 389710477) strcat(s, "a");
if (crc32("UbZtu",5) == 2917734921) strcat(s, "s");
if (crc32("QbREaJ",6) == 1750607030) strcat(s, "c");
if (crc32("xkfgAh",6) == 1099200849) strcat(s, "A");
if (crc32("fedApHpzfBycsL",14) == 652289456) strcat(s, "o");
if (crc32("prAbAMlGuC",10) == 1412272082) strcat(s, "Y");
if (crc32("TSQcI",5) == 4272405389) strcat(s, "p");
if (crc32("rbjsXpwJ",8) == 744270537) strcat(s, "i");
if (crc32("jdEdCAGbrWG",11) == 3489038976) strcat(s, "b");
if (crc32("tTjalhH",7) == 3600974948) strcat(s, "c");
    return s;
}

char *single_adjectives() {
    char *s = calloc(7);
    if (crc32("nwDvbgPr",8) == 1029108201) strcat(s, "H");
if (crc32("xvldOCKEEst",11) == 2810857290) strcat(s, "s");
if (crc32("UayfSVtnHr",10) == 2971666231) strcat(s, "i");
if (crc32("tcbEgEMq",8) == 3030418605) strcat(s, "e");
if (crc32("IlJZxLWoMmFfpLe",15) == 786304676) strcat(s, "n");
if (crc32("YeDLmrpp",8) == 504115934) strcat(s, "g");
if (crc32("XKWiknnPTgWJ",12) == 690147841) strcat(s, "l");
if (crc32("YYmJnP",6) == 2614711310) strcat(s, "P");
if (crc32("deVbfNehHYD",11) == 972525222) strcat(s, "e");
    return s;
}

char *unrecuperative_adjectives() {
    char *s = calloc(15);
    if (crc32("sGUZPpz",7) == 75683193) strcat(s, "J");
if (crc32("EQJZmoFbmJDpGCg",15) == 3194411473) strcat(s, "u");
if (crc32("MIKUpQ",6) == 1121364442) strcat(s, "n");
if (crc32("aJNzgJ",6) == 3987172609) strcat(s, "F");
if (crc32("ffPqsZ",6) == 1754222611) strcat(s, "r");
if (crc32("xVOlZsXkEW",10) == 1205997709) strcat(s, "o");
if (crc32("ZuEJJbGvywRzFP",14) == 3663971709) strcat(s, "e");
if (crc32("pfnLCX",6) == 2953781019) strcat(s, "c");
if (crc32("YNnHJy",6) == 3205417735) strcat(s, "V");
if (crc32("LIdhQAsUPXZek",13) == 855827179) strcat(s, "u");
if (crc32("yanBrOEZnZPIJ",13) == 623072205) strcat(s, "v");
if (crc32("BqGWS",5) == 1172269909) strcat(s, "p");
if (crc32("ARTBBmlCh",9) == 279520010) strcat(s, "F");
if (crc32("WLdQUfDpfY",10) == 2051133684) strcat(s, "e");
if (crc32("zjqMc",5) == 3741254979) strcat(s, "D");
if (crc32("TDjMRBMMZDm",11) == 3063814133) strcat(s, "r");
if (crc32("SLuLsfgefVAlrHy",15) == 3391604541) strcat(s, "a");
if (crc32("urIWwPZxb",9) == 3621676973) strcat(s, "t");
if (crc32("BCIGaVsxyX",10) == 3850033519) strcat(s, "i");
if (crc32("pGLlesIlo",9) == 3107553947) strcat(s, "W");
if (crc32("fcbgHQbTbpIi",12) == 3219276279) strcat(s, "v");
if (crc32("jEtxvJnNI",9) == 283605034) strcat(s, "e");
    return s;
}

char *jeopardous_adjectives() {
    char *s = calloc(11);
    if (crc32("sDHEaI",6) == 3390094446) strcat(s, "j");
if (crc32("xtqDOouBdpG",11) == 1410513397) strcat(s, "I");
if (crc32("VHIuviKNn",9) == 533117121) strcat(s, "e");
if (crc32("uyIoKwumoja",11) == 3677217825) strcat(s, "o");
if (crc32("YTgyfhIcsT",10) == 2577261577) strcat(s, "p");
if (crc32("OcPtY",5) == 4856698) strcat(s, "a");
if (crc32("MaKLkFa",7) == 2550102277) strcat(s, "W");
if (crc32("JjGtHSatOVVuZg",14) == 3637428243) strcat(s, "r");
if (crc32("htYSzqg",7) == 1277693158) strcat(s, "l");
if (crc32("zHOaXL",6) == 4103253783) strcat(s, "d");
if (crc32("uNZBbx",6) == 3545603514) strcat(s, "o");
if (crc32("WtLpHWilSyQDK",13) == 1552569044) strcat(s, "u");
if (crc32("okBsBu",6) == 587773179) strcat(s, "s");
    return s;
}

char *turbosupercharged_adjectives() {
    char *s = calloc(18);
    if (crc32("ATIoKEdo",8) == 601488873) strcat(s, "Y");
if (crc32("OnoljsVSM",9) == 2068420858) strcat(s, "t");
if (crc32("dSrFLgGyFYxFS",13) == 4255860995) strcat(s, "W");
if (crc32("oEpAzTZjiFs",11) == 347743091) strcat(s, "u");
if (crc32("cnFWXXPpFjgBV",13) == 4048703647) strcat(s, "r");
if (crc32("dYuxZNZbIMC",11) == 2402834241) strcat(s, "b");
if (crc32("CAMWgViSZ",9) == 171510519) strcat(s, "M");
if (crc32("VFQcgIIqIpOjOY",14) == 1926364832) strcat(s, "o");
if (crc32("ibHOuARmJjt",11) == 1145509740) strcat(s, "s");
if (crc32("GlbKHYotnSHY",12) == 91795797) strcat(s, "U");
if (crc32("EqGxX",5) == 1915836064) strcat(s, "u");
if (crc32("zBvCzRxhlLqVGcC",15) == 1747587349) strcat(s, "p");
if (crc32("vMpOnuQbG",9) == 1839206732) strcat(s, "e");
if (crc32("TEqMgLqVKd",10) == 3945399714) strcat(s, "J");
if (crc32("uusXdUmHNJBeJB",14) == 2677153760) strcat(s, "r");
if (crc32("aKqdmvqnHJ",10) == 858152364) strcat(s, "W");
if (crc32("OyoDQlRjcZT",11) == 2155447121) strcat(s, "c");
if (crc32("LUBXzSuMbAufZQ",14) == 3686785121) strcat(s, "J");
if (crc32("VHIVqMt",7) == 3261818814) strcat(s, "h");
if (crc32("AhnoqsV",7) == 1073628551) strcat(s, "i");
if (crc32("EPKJwkJFieAB",12) == 2845525418) strcat(s, "a");
if (crc32("XduSojJybgJ",11) == 2480506131) strcat(s, "k");
if (crc32("asDirMmm",8) == 4264334903) strcat(s, "r");
if (crc32("PneCR",5) == 904240435) strcat(s, "g");
if (crc32("KSmqIuHoUz",10) == 3165421184) strcat(s, "e");
if (crc32("FYKDg",5) == 1678507441) strcat(s, "E");
if (crc32("JghVVX",6) == 736201998) strcat(s, "d");
    return s;
}

char *antiJesuitical_adjectives() {
    char *s = calloc(15);
    if (crc32("cUeXagvq",8) == 2324985563) strcat(s, "a");
if (crc32("JqOzePOMtdyQIN",14) == 3695654128) strcat(s, "n");
if (crc32("UWgeWCbfMcWG",12) == 3970214792) strcat(s, "t");
if (crc32("uJscaSrropyU",12) == 2100980828) strcat(s, "l");
if (crc32("RKKXFh",6) == 341295322) strcat(s, "i");
if (crc32("AZLNnCRlkIU",11) == 318227635) strcat(s, "s");
if (crc32("GRwhjLORNzU",11) == 3874994983) strcat(s, "J");
if (crc32("BzIjOGbeJo",10) == 422178088) strcat(s, "e");
if (crc32("OjlCW",5) == 663536951) strcat(s, "s");
if (crc32("ELjiEL",6) == 2460868103) strcat(s, "u");
if (crc32("elukmNPxU",9) == 816473290) strcat(s, "M");
if (crc32("aLSgsoGU",8) == 3321384595) strcat(s, "i");
if (crc32("OoMlkC",6) == 365029732) strcat(s, "t");
if (crc32("FaxknHcmo",9) == 3575188087) strcat(s, "i");
if (crc32("oYsqtn",6) == 2971099863) strcat(s, "q");
if (crc32("OlFXKcyyDlRH",12) == 2327126966) strcat(s, "c");
if (crc32("rvMgf",5) == 4249590892) strcat(s, "a");
if (crc32("xXgwirCGhCIe",12) == 341367963) strcat(s, "n");
if (crc32("BWSrDUAP",8) == 501745847) strcat(s, "l");
    return s;
}

char *autobiographical_adjectives() {
    char *s = calloc(17);
    if (crc32("uvlLERcFk",9) == 3310080927) strcat(s, "a");
if (crc32("zRctbg",6) == 226262487) strcat(s, "T");
if (crc32("ighbfSBpWT",10) == 3025384103) strcat(s, "u");
if (crc32("GkDOkkZJnusHatN",15) == 3747864127) strcat(s, "Q");
if (crc32("HZUeG",5) == 2421468377) strcat(s, "t");
if (crc32("OumKAcRZep",10) == 2354494848) strcat(s, "j");
if (crc32("eyQFcmre",8) == 3723828424) strcat(s, "o");
if (crc32("wpAXvrBewdFLL",13) == 2952757471) strcat(s, "Y");
if (crc32("nZiKwBYjvgh",11) == 1883901152) strcat(s, "b");
if (crc32("eYaoTg",6) == 1372607487) strcat(s, "K");
if (crc32("hkConSxTdEJqa",13) == 3681990135) strcat(s, "i");
if (crc32("YJzKOLnKd",9) == 3176707540) strcat(s, "o");
if (crc32("teJSukMWs",9) == 854159295) strcat(s, "x");
if (crc32("eAjcf",5) == 454656647) strcat(s, "g");
if (crc32("bdhUE",5) == 1476178709) strcat(s, "j");
if (crc32("BgtvL",5) == 387391689) strcat(s, "r");
if (crc32("HlmljRNmiYQr",12) == 272872272) strcat(s, "a");
if (crc32("jWqWsaFBVNW",11) == 827134176) strcat(s, "p");
if (crc32("jnNHA",5) == 2816108490) strcat(s, "q");
if (crc32("EMzKDfqnHvZPMou",15) == 673108704) strcat(s, "h");
if (crc32("RTRkdmajyWQxK",13) == 1464576706) strcat(s, "i");
if (crc32("MegApLSB",8) == 1705893663) strcat(s, "c");
if (crc32("MqTJerQDUfWPOE",14) == 2320701942) strcat(s, "a");
if (crc32("uFcBCMhaf",9) == 2749301291) strcat(s, "l");
    return s;
}

char *nonglutenous_adjectives() {
    char *s = calloc(13);
    if (crc32("ZwfafdV",7) == 1455795077) strcat(s, "n");
if (crc32("jomHVcRA",8) == 2831104973) strcat(s, "o");
if (crc32("sJLrHkZlTCobIR",14) == 2356137170) strcat(s, "n");
if (crc32("uZaWqYFVzyUua",13) == 1125342269) strcat(s, "g");
if (crc32("TGPcwLLuCas",11) == 2754702608) strcat(s, "l");
if (crc32("GNEkcVNZy",9) == 2202549985) strcat(s, "T");
if (crc32("zVkUTjYICfYS",12) == 3897125025) strcat(s, "u");
if (crc32("uQqhFL",6) == 2739954675) strcat(s, "t");
if (crc32("vaoCIKvvjB",10) == 1011727186) strcat(s, "m");
if (crc32("oPXxRauCLXqM",12) == 1263513429) strcat(s, "e");
if (crc32("grhQst",6) == 3887540629) strcat(s, "n");
if (crc32("DUPKu",5) == 4040511820) strcat(s, "U");
if (crc32("UKpHpoIrlI",10) == 1554352485) strcat(s, "o");
if (crc32("vwJQSf",6) == 2346403204) strcat(s, "u");
if (crc32("CGTKNBO",7) == 628944181) strcat(s, "s");
    return s;
}

char *semihysterical_adjectives() {
    char *s = calloc(15);
    if (crc32("HtyDqSSqKrsmj",13) == 278681933) strcat(s, "F");
if (crc32("VIuZLBbVKNBbR",13) == 1244294879) strcat(s, "s");
if (crc32("csfaxzN",7) == 557457633) strcat(s, "e");
if (crc32("KRgPPcU",7) == 1129594961) strcat(s, "m");
if (crc32("YpTHfdIgPw",10) == 2648804880) strcat(s, "i");
if (crc32("bjYSYsjelRSb",12) == 2017069321) strcat(s, "V");
if (crc32("JROpYrufb",9) == 902021790) strcat(s, "h");
if (crc32("hgZHQhGVkolEVd",14) == 4210483499) strcat(s, "d");
if (crc32("eoFlVWwszWd",11) == 3314634537) strcat(s, "y");
if (crc32("lTUBpHktewbi",12) == 3129316840) strcat(s, "s");
if (crc32("VbbKUssWHB",10) == 2750242995) strcat(s, "t");
if (crc32("BNSfSHJpJyyT",12) == 3677533757) strcat(s, "t");
if (crc32("qUloSXQ",7) == 3024340587) strcat(s, "e");
if (crc32("guYdvygwf",9) == 4127296159) strcat(s, "r");
if (crc32("ecEalLbo",8) == 3893547079) strcat(s, "s");
if (crc32("rlFZWqUIGP",10) == 1103364649) strcat(s, "i");
if (crc32("eANzoL",6) == 868939496) strcat(s, "c");
if (crc32("vlTiKLQMZYW",11) == 1334309532) strcat(s, "s");
if (crc32("yFVSFajmPeol",12) == 714107539) strcat(s, "a");
if (crc32("PJrzsJXfUfjT",12) == 3780671323) strcat(s, "Q");
if (crc32("BMVsFiUJo",9) == 1161259404) strcat(s, "l");
    return s;
}

char *pentahydroxy_adjectives() {
    char *s = calloc(13);
    if (crc32("KIuyzRsjgoHUQVc",15) == 1839534093) strcat(s, "p");
if (crc32("zgZYcISuiEJ",11) == 75402399) strcat(s, "e");
if (crc32("eGnACmA",7) == 2547249908) strcat(s, "X");
if (crc32("QpENAiP",7) == 1446555238) strcat(s, "n");
if (crc32("eloTGAVX",8) == 2076452804) strcat(s, "t");
if (crc32("fmuwCL",6) == 2813116702) strcat(s, "a");
if (crc32("XuiDqaxsoa",10) == 3361553135) strcat(s, "h");
if (crc32("kMGxAyVPD",9) == 873131200) strcat(s, "M");
if (crc32("kDyqFcLso",9) == 1926847232) strcat(s, "y");
if (crc32("nbuWkknyjvk",11) == 1678921008) strcat(s, "d");
if (crc32("AJMBsGtluAPEPDr",15) == 2284235908) strcat(s, "r");
if (crc32("VJxzrw",6) == 1574146239) strcat(s, "o");
if (crc32("qoKYnznSuAXjc",13) == 1099310460) strcat(s, "x");
if (crc32("GtaSuUN",7) == 2021532378) strcat(s, "g");
if (crc32("VTIEAbSmcF",10) == 938595329) strcat(s, "y");
    return s;
}

char *casuistic_adjectives() {
    char *s = calloc(10);
    if (crc32("jwUkaDA",7) == 3462718662) strcat(s, "m");
if (crc32("oLfKVBpwWhq",11) == 2581169561) strcat(s, "c");
if (crc32("VoRLCagNEC",10) == 3544373663) strcat(s, "a");
if (crc32("fqafAOaf",8) == 3051391) strcat(s, "A");
if (crc32("fQlAhPlb",8) == 343670541) strcat(s, "s");
if (crc32("qagmqOWsJYF",11) == 500989515) strcat(s, "b");
if (crc32("cEtYOXUHglm",11) == 1981459597) strcat(s, "u");
if (crc32("cbZhUsmkNgFwj",13) == 1248935104) strcat(s, "i");
if (crc32("ZLsWgLIGwCNa",12) == 1904073700) strcat(s, "O");
if (crc32("ONCsWzeEeOafkmi",15) == 1784063885) strcat(s, "s");
if (crc32("yJWUofjwPTNf",12) == 4236202346) strcat(s, "t");
if (crc32("aDJUkbaVIkSiO",13) == 3122825097) strcat(s, "i");
if (crc32("eqjKUh",6) == 2176369416) strcat(s, "c");
    return s;
}

char *wrynecked_adjectives() {
    char *s = calloc(10);
    if (crc32("gKyivbnyBDGUoMn",15) == 716950210) strcat(s, "a");
if (crc32("szslY",5) == 4053415432) strcat(s, "w");
if (crc32("cApxMowkuL",10) == 1418201695) strcat(s, "r");
if (crc32("WCxxmGgjBcQUUw",14) == 4130907628) strcat(s, "m");
if (crc32("ZbuVHXWcqto",11) == 4195198004) strcat(s, "y");
if (crc32("jSpuXvZCyGF",11) == 3525843255) strcat(s, "n");
if (crc32("gGckZCdXsxCjBov",15) == 4053131594) strcat(s, "e");
if (crc32("EIeBDemACoCUWB",14) == 2973125642) strcat(s, "f");
if (crc32("OVKVuxdMB",9) == 3855777172) strcat(s, "c");
if (crc32("HchfrkmOPBxQq",13) == 288174334) strcat(s, "k");
if (crc32("BwAFFpZrEEXE",12) == 800503931) strcat(s, "e");
if (crc32("boosJcceeVK",11) == 459220135) strcat(s, "t");
if (crc32("fRWcchQBPWCmN",13) == 3867610489) strcat(s, "d");
    return s;
}

char *spectrochemical_adjectives() {
    char *s = calloc(16);
    if (crc32("SSBLkZPOMoix",12) == 1686054833) strcat(s, "X");
if (crc32("jJxeYwqgMXzTKv",14) == 2316824472) strcat(s, "s");
if (crc32("dPFbNtTXYAU",11) == 18486241) strcat(s, "f");
if (crc32("DKvNydoWXoFAMU",14) == 310852655) strcat(s, "p");
if (crc32("NISoJolr",8) == 299933937) strcat(s, "V");
if (crc32("EODMhbbNgBgoN",13) == 2557273565) strcat(s, "e");
if (crc32("WZQexGOxAy",10) == 3779635726) strcat(s, "N");
if (crc32("MbhtuqXT",8) == 886083289) strcat(s, "c");
if (crc32("ehmwxbigS",9) == 1206650640) strcat(s, "B");
if (crc32("LTDYmXRQyovCDrp",15) == 197725420) strcat(s, "t");
if (crc32("QNrQdsvNzMTWkgZ",15) == 3492764109) strcat(s, "r");
if (crc32("dyrqWuzsbIE",11) == 609378835) strcat(s, "o");
if (crc32("cYnCHAzqraGkZ",13) == 2707582719) strcat(s, "g");
if (crc32("DfCLBlt",7) == 3492441967) strcat(s, "c");
if (crc32("mfAfHXiz",8) == 742133742) strcat(s, "h");
if (crc32("EuRIchT",7) == 745207871) strcat(s, "G");
if (crc32("mqQylLuqBwndq",13) == 1080197978) strcat(s, "e");
if (crc32("CVwTk",5) == 1646189487) strcat(s, "m");
if (crc32("irAWt",5) == 1090261879) strcat(s, "i");
if (crc32("VIdsAtQoMzx",11) == 1573292783) strcat(s, "c");
if (crc32("iFmBCnL",7) == 4231292024) strcat(s, "a");
if (crc32("DGXbCiCpOwNcKap",15) == 60508200) strcat(s, "n");
if (crc32("RNyLda",6) == 1138002600) strcat(s, "l");
    return s;
}

char *eyefilling_adjectives() {
    char *s = calloc(11);
    if (crc32("bZjGAmoVvR",10) == 1135718813) strcat(s, "e");
if (crc32("BttHF",5) == 1352512676) strcat(s, "q");
if (crc32("flIJouNUkIfDFG",14) == 1870113165) strcat(s, "y");
if (crc32("QBRtbNJnLMniA",13) == 1201115028) strcat(s, "e");
if (crc32("adHSbuyVojLY",12) == 822298503) strcat(s, "f");
if (crc32("htUiBhPVrH",10) == 2734510626) strcat(s, "i");
if (crc32("GivSnMJNLIOoTqk",15) == 1370484925) strcat(s, "z");
if (crc32("sgHjoYMpAdzR",12) == 3701424304) strcat(s, "l");
if (crc32("eIoagYOtUkDD",12) == 3458146222) strcat(s, "l");
if (crc32("jTguRadZdIv",11) == 1763548411) strcat(s, "P");
if (crc32("xIJWH",5) == 426525059) strcat(s, "i");
if (crc32("BGBYjA",6) == 3577280831) strcat(s, "n");
if (crc32("soLGo",5) == 1448981743) strcat(s, "P");
if (crc32("OSvUfgmVpOJFN",13) == 583593145) strcat(s, "g");
    return s;
}

char *rotiferous_adjectives() {
    char *s = calloc(11);
    if (crc32("FDsnVPOmOXkUFS",14) == 227149804) strcat(s, "l");
if (crc32("apTbRpzdrhBgkQ",14) == 1262181315) strcat(s, "r");
if (crc32("ONBWF",5) == 2066499674) strcat(s, "g");
if (crc32("ZRmaqd",6) == 2728818086) strcat(s, "o");
if (crc32("orojblsfHqklN",13) == 3124568686) strcat(s, "t");
if (crc32("oMWRMEyUZv",10) == 2713025931) strcat(s, "i");
if (crc32("YjWKFmDOYJWGQc",14) == 1203640265) strcat(s, "l");
if (crc32("KQwLBtpbJeEF",12) == 2624343988) strcat(s, "f");
if (crc32("hFjsHompLEiTJj",14) == 342345822) strcat(s, "A");
if (crc32("YPfvVBb",7) == 1984657841) strcat(s, "e");
if (crc32("SwgrW",5) == 3941062821) strcat(s, "r");
if (crc32("PaabvOzklXFu",12) == 2837521791) strcat(s, "Q");
if (crc32("cjUNHPHuXcCgOI",14) == 214783937) strcat(s, "o");
if (crc32("uwoSCrOTerzQBIR",15) == 3941212264) strcat(s, "u");
if (crc32("KMIiVITWOBVOOS",14) == 3894881222) strcat(s, "S");
if (crc32("cHypWNb",7) == 4285626863) strcat(s, "s");
    return s;
}

char *cleansable_adjectives() {
    char *s = calloc(11);
    if (crc32("QGEiYSajdgAOA",13) == 1504305015) strcat(s, "c");
if (crc32("KPRxjBy",7) == 2506115131) strcat(s, "l");
if (crc32("EurAGbqUyr",10) == 629747164) strcat(s, "e");
if (crc32("FkPUIOy",7) == 53243726) strcat(s, "r");
if (crc32("sisanwe",7) == 1292951023) strcat(s, "a");
if (crc32("TYGZsmpRv",9) == 3175332369) strcat(s, "n");
if (crc32("tJYJDZ",6) == 3885093961) strcat(s, "s");
if (crc32("PGlbI",5) == 2509334156) strcat(s, "u");
if (crc32("NEeph",5) == 2942378093) strcat(s, "a");
if (crc32("vnBgiBKuIQdSrvE",15) == 3076802065) strcat(s, "b");
if (crc32("akMtSXCdoHyE",12) == 2827367068) strcat(s, "s");
if (crc32("tJGpCjnsiYRzWoF",15) == 1947174901) strcat(s, "l");
if (crc32("qyJAxgHS",8) == 2661880825) strcat(s, "e");
    return s;
}

char *Spinozistic_adjectives() {
    char *s = calloc(12);
    if (crc32("WxXOTQiGS",9) == 3586491826) strcat(s, "S");
if (crc32("lnDhn",5) == 832857485) strcat(s, "p");
if (crc32("lVYQnaIaDqji",12) == 1748135787) strcat(s, "i");
if (crc32("qNeRmszMKzFtNI",14) == 2198450912) strcat(s, "O");
if (crc32("eypwdfVVqbNOM",13) == 2452631185) strcat(s, "n");
if (crc32("SzSdxfCATd",10) == 3969846440) strcat(s, "N");
if (crc32("etpgfGZpQs",10) == 903443835) strcat(s, "o");
if (crc32("ehmcRsQO",8) == 1850508041) strcat(s, "S");
if (crc32("NuNBtHqim",9) == 3266318141) strcat(s, "z");
if (crc32("XoKXD",5) == 3580752535) strcat(s, "C");
if (crc32("CWpgAHP",7) == 2226443438) strcat(s, "i");
if (crc32("KbafNETyFWs",11) == 599507026) strcat(s, "W");
if (crc32("xsVjUNK",7) == 3373663641) strcat(s, "s");
if (crc32("RaAWEfq",7) == 4254472440) strcat(s, "p");
if (crc32("IhramO",6) == 2395227744) strcat(s, "t");
if (crc32("WgtpwpzkIrNcR",13) == 2821252076) strcat(s, "i");
if (crc32("xyYnbVdmerjpx",13) == 347602009) strcat(s, "c");
    return s;
}

char *hurricanedecked_adjectives() {
    char *s = calloc(16);
    if (crc32("cPwNT",5) == 2164227217) strcat(s, "h");
if (crc32("QnYfYl",6) == 1115377709) strcat(s, "N");
if (crc32("RiKyk",5) == 2592983921) strcat(s, "u");
if (crc32("YuiTlF",6) == 3491588552) strcat(s, "r");
if (crc32("rZopdgEgLIC",11) == 2809220335) strcat(s, "r");
if (crc32("jLrSfW",6) == 3972712543) strcat(s, "i");
if (crc32("TrglUqLD",8) == 35077774) strcat(s, "c");
if (crc32("cHBVQkwFdccouwu",15) == 1647119047) strcat(s, "y");
if (crc32("VUaABXoKmByz",12) == 264940181) strcat(s, "a");
if (crc32("RpDye",5) == 1534638430) strcat(s, "n");
if (crc32("htsSfUUhVr",10) == 1426718191) strcat(s, "i");
if (crc32("FbczRC",6) == 2627532392) strcat(s, "e");
if (crc32("sKHWmg",6) == 679798364) strcat(s, "m");
if (crc32("agRjnHRfuuYa",12) == 2143803324) strcat(s, "d");
if (crc32("PeHHMc",6) == 1993559989) strcat(s, "Q");
if (crc32("FwxGCJusjHvMzP",14) == 1009924781) strcat(s, "e");
if (crc32("GOWuXGMkAgK",11) == 4245660055) strcat(s, "c");
if (crc32("MKlBTpDvBvs",11) == 1276318078) strcat(s, "Z");
if (crc32("lPvAlsnLkpWp",12) == 4103986820) strcat(s, "k");
if (crc32("tcJDFXes",8) == 1785290421) strcat(s, "W");
if (crc32("mHaYJfieZ",9) == 1864469243) strcat(s, "e");
if (crc32("cinEAiEtYFJ",11) == 2417061199) strcat(s, "d");
    return s;
}

char *overtolerant_adjectives() {
    char *s = calloc(13);
    if (crc32("GRqWaQGuD",9) == 1295515496) strcat(s, "S");
if (crc32("atAFeDOSzZqe",12) == 2643334531) strcat(s, "o");
if (crc32("aNgfE",5) == 1357404126) strcat(s, "J");
if (crc32("amyHWA",6) == 2404861787) strcat(s, "v");
if (crc32("qcYULPMX",8) == 4193067040) strcat(s, "e");
if (crc32("wCkRiwPOU",9) == 2142804807) strcat(s, "r");
if (crc32("GxqNeNMeU",9) == 3366837898) strcat(s, "d");
if (crc32("oDswIrrjfR",10) == 3539545925) strcat(s, "t");
if (crc32("SxgoyLS",7) == 3589913704) strcat(s, "o");
if (crc32("XXhXfJL",7) == 4090950739) strcat(s, "l");
if (crc32("oaRGjTdmY",9) == 895101687) strcat(s, "y");
if (crc32("sglctfxFFiVmJdC",15) == 832178588) strcat(s, "e");
if (crc32("AXPpH",5) == 3180182667) strcat(s, "T");
if (crc32("tuYfAwprkuW",11) == 3524470297) strcat(s, "r");
if (crc32("AfKlb",5) == 1558383516) strcat(s, "U");
if (crc32("jSrCHv",6) == 1429369358) strcat(s, "a");
if (crc32("wnHSnvd",7) == 1318986307) strcat(s, "n");
if (crc32("TBgptZUblFbeP",13) == 315518282) strcat(s, "n");
if (crc32("LXjFHrDyWffC",12) == 3237634135) strcat(s, "t");
    return s;
}

char *unroused_adjectives() {
    char *s = calloc(9);
    if (crc32("lDgcfpU",7) == 3363813817) strcat(s, "i");
if (crc32("AKdRcF",6) == 1358321529) strcat(s, "u");
if (crc32("NXbkMMBwgac",11) == 1209848900) strcat(s, "F");
if (crc32("CCLEQKBqyLiFiBF",15) == 3226409210) strcat(s, "n");
if (crc32("guTxOJJRPP",10) == 1611596370) strcat(s, "F");
if (crc32("tlQIKpLTxfz",11) == 4035679364) strcat(s, "r");
if (crc32("cEknzwQXn",9) == 3142934007) strcat(s, "n");
if (crc32("mGijOrtJ",8) == 440529059) strcat(s, "o");
if (crc32("LlfWFSICzc",10) == 515136055) strcat(s, "u");
if (crc32("ORHnDpi",7) == 2983290300) strcat(s, "s");
if (crc32("qwgASGmDcRHR",12) == 352315084) strcat(s, "u");
if (crc32("TAkaxpSLWlSY",12) == 562265300) strcat(s, "e");
if (crc32("wokzdiOvQFkn",12) == 2143874987) strcat(s, "n");
if (crc32("nhLmvw",6) == 213349916) strcat(s, "d");
    return s;
}

char *uninquisitorial_adjectives() {
    char *s = calloc(16);
    if (crc32("GhaEnOaxVgsG",12) == 1298494814) strcat(s, "u");
if (crc32("ltSgIolKqQtFVR",14) == 590002258) strcat(s, "n");
if (crc32("lsytUMNqHevZ",12) == 2593845652) strcat(s, "O");
if (crc32("tlQwGnOIKgmo",12) == 2611752454) strcat(s, "i");
if (crc32("RTMmzyNy",8) == 1868493836) strcat(s, "n");
if (crc32("SgYqu",5) == 1782994311) strcat(s, "q");
if (crc32("XVjKumPVRYnht",13) == 1474513539) strcat(s, "c");
if (crc32("tzazgqmiKGvrkg",14) == 1329101559) strcat(s, "u");
if (crc32("wXaKLaXAgS",10) == 1393430554) strcat(s, "V");
if (crc32("lsohaFp",7) == 101679448) strcat(s, "i");
if (crc32("UiZMfPPgGTCtTRb",15) == 3513733395) strcat(s, "s");
if (crc32("snqcxFTYXUtq",12) == 3823210824) strcat(s, "z");
if (crc32("VNNOrUCXPxQzvAd",15) == 1513445948) strcat(s, "i");
if (crc32("zWKcOIGZqsJ",11) == 2201542130) strcat(s, "q");
if (crc32("lPDAzOabt",9) == 1151053929) strcat(s, "t");
if (crc32("QXmWXWca",8) == 3252875884) strcat(s, "o");
if (crc32("uOPrZyCWkEqeYw",14) == 1087299404) strcat(s, "n");
if (crc32("OzkzZXTnhfWncxh",15) == 1435643293) strcat(s, "r");
if (crc32("TgVsTdD",7) == 2320217447) strcat(s, "i");
if (crc32("csFXjrAUs",9) == 185769214) strcat(s, "a");
if (crc32("kzLUJb",6) == 1913391729) strcat(s, "l");
    return s;
}

char *subpubescent_adjectives() {
    char *s = calloc(13);
    if (crc32("sjnKhSxDegd",11) == 2558892265) strcat(s, "D");
if (crc32("LxvgycC",7) == 3555782299) strcat(s, "s");
if (crc32("nasIlZ",6) == 1666823176) strcat(s, "u");
if (crc32("HnXjYqavQHa",11) == 3017613665) strcat(s, "b");
if (crc32("btokJnOd",8) == 3191027671) strcat(s, "e");
if (crc32("kQCSmgz",7) == 3481773015) strcat(s, "p");
if (crc32("gnitCpd",7) == 2260733670) strcat(s, "u");
if (crc32("stQPh",5) == 815976248) strcat(s, "P");
if (crc32("XySFFkTLNNAtUl",14) == 3016555901) strcat(s, "b");
if (crc32("zjnWDWyDaw",10) == 150534619) strcat(s, "d");
if (crc32("obKhvWJV",8) == 321151658) strcat(s, "e");
if (crc32("yJLnKFdL",8) == 774369672) strcat(s, "s");
if (crc32("lJqpPxmPFyKp",12) == 726501111) strcat(s, "c");
if (crc32("MdVEnRmQr",9) == 273756886) strcat(s, "B");
if (crc32("bANAVaJZdlZD",12) == 1197798327) strcat(s, "e");
if (crc32("juZVOqNqOGFf",12) == 4130730348) strcat(s, "x");
if (crc32("mCGUMOcSw",9) == 1202335234) strcat(s, "n");
if (crc32("OnIZvDNI",8) == 1289745853) strcat(s, "t");
    return s;
}

char *preEnglish_adjectives() {
    char *s = calloc(11);
    if (crc32("aARHgzIVtscd",12) == 3232682290) strcat(s, "F");
if (crc32("nMlPbpfzVmNwYqg",15) == 2838243346) strcat(s, "p");
if (crc32("YElmJvIiRRq",11) == 4288889625) strcat(s, "T");
if (crc32("FppVkvSsOeajnc",14) == 2351021059) strcat(s, "r");
if (crc32("foryNVdCrSVvQ",13) == 1973867285) strcat(s, "z");
if (crc32("ozJkuF",6) == 2262700492) strcat(s, "e");
if (crc32("GkJiBPVyyBenj",13) == 1738904847) strcat(s, "A");
if (crc32("DDirUhPIPNBnDe",14) == 3939003890) strcat(s, "E");
if (crc32("FiAoWizLXQPl",12) == 2529109442) strcat(s, "n");
if (crc32("XwPGu",5) == 3846486651) strcat(s, "F");
if (crc32("eTRRkgEIz",9) == 2075449016) strcat(s, "g");
if (crc32("IKOdZBZsNgX",11) == 239487404) strcat(s, "l");
if (crc32("nPQGbhasAz",10) == 118732718) strcat(s, "O");
if (crc32("OIvXpCvLNpMcQg",14) == 2455724562) strcat(s, "i");
if (crc32("MrJPJT",6) == 2140385077) strcat(s, "s");
if (crc32("AouAdajDH",9) == 1728228745) strcat(s, "V");
if (crc32("EUBlVtjUKEdEeo",14) == 1561310942) strcat(s, "h");
    return s;
}

char *thionic_adjectives() {
    char *s = calloc(8);
    if (crc32("UFalnD",6) == 3864489298) strcat(s, "g");
if (crc32("WVxijFjJEbec",12) == 1075255485) strcat(s, "t");
if (crc32("hwEciYJztiuWu",13) == 859597508) strcat(s, "P");
if (crc32("HeoUK",5) == 3339738800) strcat(s, "h");
if (crc32("AMuig",5) == 4280060074) strcat(s, "i");
if (crc32("oshHkVsPYNBJB",13) == 565858708) strcat(s, "o");
if (crc32("zBIkIhSrqh",10) == 1524017093) strcat(s, "e");
if (crc32("tmIfq",5) == 1758635272) strcat(s, "n");
if (crc32("XTUkj",5) == 1836071132) strcat(s, "R");
if (crc32("wzsVGexsEj",10) == 1804753591) strcat(s, "i");
if (crc32("ieBAvRrDIEd",11) == 2206443505) strcat(s, "c");
    return s;
}

char *coterminous_adjectives() {
    char *s = calloc(12);
    if (crc32("dkouGA",6) == 27882128) strcat(s, "G");
if (crc32("UMzYPXwvdl",10) == 4284179452) strcat(s, "c");
if (crc32("LWFmGQSdRg",10) == 522679662) strcat(s, "b");
if (crc32("nHaVaGezNukCaGa",15) == 671440337) strcat(s, "o");
if (crc32("opkIreMacWfQ",12) == 3485327632) strcat(s, "D");
if (crc32("FNuQqFyZkttRT",13) == 1945028200) strcat(s, "t");
if (crc32("gVeFjKYTar",10) == 4147669193) strcat(s, "e");
if (crc32("bUVzUsBPHDOwX",13) == 1939790008) strcat(s, "r");
if (crc32("niVMe",5) == 3951431957) strcat(s, "K");
if (crc32("IoEEISDRACFd",12) == 3067616354) strcat(s, "m");
if (crc32("IZGoux",6) == 1485403985) strcat(s, "a");
if (crc32("WUaAjsylBlFHd",13) == 2273864429) strcat(s, "i");
if (crc32("IlneHvQMgjj",11) == 84030541) strcat(s, "a");
if (crc32("GQhHjlYtdmKdi",13) == 2333557099) strcat(s, "n");
if (crc32("mDRJYvZxmeFJTCy",15) == 3932369844) strcat(s, "o");
if (crc32("RCdEifhKdyReN",13) == 354050099) strcat(s, "E");
if (crc32("HhKGWe",6) == 174657299) strcat(s, "u");
if (crc32("gXeNHmztuM",10) == 452083709) strcat(s, "s");
    return s;
}

char *unchanneled_adjectives() {
    char *s = calloc(12);
    if (crc32("uNNCV",5) == 2944663393) strcat(s, "u");
if (crc32("yVtutdIaHk",10) == 543493947) strcat(s, "F");
if (crc32("DGtMQwmPgE",10) == 3325330477) strcat(s, "n");
if (crc32("dqkbFtjapwybI",13) == 4182184566) strcat(s, "b");
if (crc32("jPjTGKsoHbPFY",13) == 3464858711) strcat(s, "c");
if (crc32("HDpXxYZc",8) == 2246382081) strcat(s, "W");
if (crc32("itsHkRup",8) == 3603335797) strcat(s, "h");
if (crc32("JtLYLg",6) == 2860135270) strcat(s, "X");
if (crc32("BJhfkXCwrzZU",12) == 3802388693) strcat(s, "a");
if (crc32("RUytMoEBAC",10) == 3159433816) strcat(s, "n");
if (crc32("alXvHblkdcE",11) == 2544516495) strcat(s, "p");
if (crc32("pWgHMDmBZJZ",11) == 230588561) strcat(s, "n");
if (crc32("AXbQxUUjnFj",11) == 3447594438) strcat(s, "x");
if (crc32("WZdGwJVbbxQgkgu",15) == 1716191214) strcat(s, "e");
if (crc32("qTvcXYGloTy",11) == 722037084) strcat(s, "x");
if (crc32("jQDCikOJAgMZiR",14) == 312033905) strcat(s, "l");
if (crc32("gDptRLa",7) == 1400543602) strcat(s, "e");
if (crc32("NZToyLkAtWKxX",13) == 2076979511) strcat(s, "K");
if (crc32("MhmmUwEmn",9) == 2663560273) strcat(s, "d");
    return s;
}

char *sallowish_adjectives() {
    char *s = calloc(10);
    if (crc32("UjBepkGPR",9) == 3067734339) strcat(s, "x");
if (crc32("yoGLXVaEoU",10) == 2447302919) strcat(s, "s");
if (crc32("TNjGivxVsvdInz",14) == 1683434033) strcat(s, "X");
if (crc32("iiiPeFcVla",10) == 4011617950) strcat(s, "a");
if (crc32("IJAelWhwLT",10) == 2811233385) strcat(s, "U");
if (crc32("uCFWfak",7) == 3242563430) strcat(s, "l");
if (crc32("yzOzOsTv",8) == 2884440438) strcat(s, "h");
if (crc32("BBLcFg",6) == 1070042985) strcat(s, "l");
if (crc32("bgIlUCHob",9) == 2786457513) strcat(s, "o");
if (crc32("MDTuwNV",7) == 3675950221) strcat(s, "v");
if (crc32("zQRjAPDX",8) == 4049941517) strcat(s, "w");
if (crc32("WSYkHCTEPf",10) == 3562338349) strcat(s, "F");
if (crc32("OsUNWWIuZGiR",12) == 1464124109) strcat(s, "i");
if (crc32("fFROjxPmsVs",11) == 2347523236) strcat(s, "K");
if (crc32("UaNRjAjzKJa",11) == 758575868) strcat(s, "s");
if (crc32("whyqmaHo",8) == 4135970585) strcat(s, "h");
    return s;
}

char *proAustrian_adjectives() {
    char *s = calloc(12);
    if (crc32("xcIgrfxpujmld",13) == 2018218393) strcat(s, "u");
if (crc32("BOyXlW",6) == 1630451134) strcat(s, "p");
if (crc32("jBeInSDSwtzKCTP",15) == 1696511524) strcat(s, "r");
if (crc32("BvoWyLIaCUSI",12) == 3143596034) strcat(s, "n");
if (crc32("xIeyKubfhEhGh",13) == 2893577524) strcat(s, "o");
if (crc32("CvzZcnWo",8) == 3602845478) strcat(s, "A");
if (crc32("vaRqyETVX",9) == 3072960487) strcat(s, "u");
if (crc32("JNWxPV",6) == 3427387879) strcat(s, "s");
if (crc32("LngxooQfewsIjX",14) == 1807557931) strcat(s, "t");
if (crc32("rUPvcFtYCEfkx",13) == 875608070) strcat(s, "g");
if (crc32("ZyORQGODQDJVIFK",15) == 2353214476) strcat(s, "r");
if (crc32("UAtfuEXjLllpPS",14) == 1166432212) strcat(s, "j");
if (crc32("nhpidejLCZi",11) == 3077837278) strcat(s, "i");
if (crc32("DmgCa",5) == 1783020013) strcat(s, "t");
if (crc32("UzzkOPamWWk",11) == 4273149775) strcat(s, "a");
if (crc32("wMvUQTIDLI",10) == 692733876) strcat(s, "x");
if (crc32("XHmXhqmC",8) == 3156954305) strcat(s, "n");
    return s;
}

char *nonextinct_adjectives() {
    char *s = calloc(11);
    if (crc32("fNybVwdY",8) == 513597418) strcat(s, "o");
if (crc32("FHyjflnkK",9) == 598345911) strcat(s, "n");
if (crc32("WTksWsqrOxpZ",12) == 347411925) strcat(s, "r");
if (crc32("wLLkBaR",7) == 931138838) strcat(s, "o");
if (crc32("AyGrRRTlr",9) == 1687717689) strcat(s, "n");
if (crc32("TzzKXjaOHwc",11) == 1204618042) strcat(s, "e");
if (crc32("SOtvusfvOPpdW",13) == 1347986534) strcat(s, "x");
if (crc32("LfxjXmqmpn",10) == 2411756989) strcat(s, "t");
if (crc32("hdruBgiViSh",11) == 1252073374) strcat(s, "i");
if (crc32("bXKhIQ",6) == 3058901544) strcat(s, "D");
if (crc32("QkQZTlmNayOPqIt",15) == 2149691512) strcat(s, "n");
if (crc32("USFFZErfES",10) == 4031204291) strcat(s, "c");
if (crc32("RFdnL",5) == 4047782969) strcat(s, "t");
    return s;
}

char *noisiest_adjectives() {
    char *s = calloc(9);
    if (crc32("oepeStnfPmN",11) == 3316227952) strcat(s, "b");
if (crc32("rFQcCXkkrpO",11) == 1827837373) strcat(s, "n");
if (crc32("gwFcFsLpwyKh",12) == 1213878596) strcat(s, "o");
if (crc32("dJjqALxfUQ",10) == 4217406400) strcat(s, "u");
if (crc32("NcBoAAtgFHpnrL",14) == 3554220780) strcat(s, "i");
if (crc32("NZPOqwNlnXuvM",13) == 2828714336) strcat(s, "s");
if (crc32("ZIrOjQmhls",10) == 1080763386) strcat(s, "i");
if (crc32("CfhcsAyMbecRTX",14) == 3300102978) strcat(s, "e");
if (crc32("FdMDrHdQURD",11) == 466110528) strcat(s, "e");
if (crc32("XKjpr",5) == 2027698024) strcat(s, "i");
if (crc32("rmAwRF",6) == 4088276075) strcat(s, "s");
if (crc32("vKeYYEp",7) == 155565384) strcat(s, "a");
if (crc32("DiPJQ",5) == 1463376192) strcat(s, "t");
    return s;
}

char *military_adjectives() {
    char *s = calloc(9);
    if (crc32("BfPJiAjB",8) == 3364345814) strcat(s, "m");
if (crc32("cqUFRSsIbgleSa",14) == 601038526) strcat(s, "i");
if (crc32("IVLAj",5) == 1075978237) strcat(s, "l");
if (crc32("EGdYwsZPRIBOATO",15) == 701221230) strcat(s, "i");
if (crc32("OQavUZuA",8) == 2726087738) strcat(s, "F");
if (crc32("bGAezV",6) == 608295045) strcat(s, "t");
if (crc32("XeSLmnwrpRzf",12) == 1867243343) strcat(s, "d");
if (crc32("IoiFCxVRcZabKo",14) == 2142169896) strcat(s, "a");
if (crc32("nKidCIrndB",10) == 3022246263) strcat(s, "i");
if (crc32("VdiOmVjFqQOYqp",14) == 1894049112) strcat(s, "r");
if (crc32("EbXGAJFhEAvS",12) == 1898684894) strcat(s, "y");
if (crc32("UCUcfYAA",8) == 441412436) strcat(s, "y");
    return s;
}

char *phialine_adjectives() {
    char *s = calloc(9);
    if (crc32("XjcEgQJ",7) == 3824032596) strcat(s, "K");
if (crc32("dOjLmHEsCbTmEF",14) == 1094834502) strcat(s, "p");
if (crc32("XLIjqvRy",8) == 3256703052) strcat(s, "U");
if (crc32("KuWNdVU",7) == 3377029647) strcat(s, "h");
if (crc32("JepTvcYFf",9) == 1483072692) strcat(s, "g");
if (crc32("rjUDdGlRRxfPuUh",15) == 1774672464) strcat(s, "i");
if (crc32("esukqUZEArV",11) == 1185135238) strcat(s, "a");
if (crc32("NyKsKPyOmeDF",12) == 2781487516) strcat(s, "l");
if (crc32("xILieszKnlc",11) == 1312730287) strcat(s, "i");
if (crc32("uwBZTFLHYFbvx",13) == 2848513440) strcat(s, "W");
if (crc32("BUjRP",5) == 3194233712) strcat(s, "n");
if (crc32("VJGGXaQx",8) == 1414308563) strcat(s, "e");
    return s;
}

char *nonremediable_adjectives() {
    char *s = calloc(14);
    if (crc32("ujvveRWn",8) == 965595814) strcat(s, "n");
if (crc32("Lbvtz",5) == 883345209) strcat(s, "U");
if (crc32("LilKrXhQu",9) == 1881302223) strcat(s, "o");
if (crc32("uQnnZDsgKB",10) == 922765075) strcat(s, "n");
if (crc32("okQzugqBnQKvt",13) == 2623642536) strcat(s, "S");
if (crc32("ItzaEEb",7) == 3025615892) strcat(s, "r");
if (crc32("ChmTIxkXFmgkPDI",15) == 1982896062) strcat(s, "e");
if (crc32("FjxUZbLiJuZAIAS",15) == 2333082094) strcat(s, "B");
if (crc32("klCqbNm",7) == 2979106048) strcat(s, "m");
if (crc32("pmZXLL",6) == 1056670434) strcat(s, "e");
if (crc32("EyLVBagXntd",11) == 460942183) strcat(s, "d");
if (crc32("cKzxCrE",7) == 908566086) strcat(s, "i");
if (crc32("zoFMKKTbuhqhSy",14) == 3417421575) strcat(s, "C");
if (crc32("fzkQDbewcwBAo",13) == 4214141939) strcat(s, "a");
if (crc32("rAodUXBrSfZTO",13) == 4085367531) strcat(s, "Q");
if (crc32("raobFuCRRs",10) == 15192956) strcat(s, "b");
if (crc32("sqRnJuxtiWvQmi",14) == 3302254211) strcat(s, "l");
if (crc32("jXVpSRcxYRxSK",13) == 3859902262) strcat(s, "o");
if (crc32("nWKioZpt",8) == 3451245994) strcat(s, "e");
    return s;
}

char *nonretentive_adjectives() {
    char *s = calloc(13);
    if (crc32("cTcAJneqodH",11) == 2364456458) strcat(s, "Y");
if (crc32("lZRURrvDalA",11) == 3487517995) strcat(s, "n");
if (crc32("lTkOxjkMNdjXC",13) == 55827178) strcat(s, "o");
if (crc32("HYqYT",5) == 2178603197) strcat(s, "e");
if (crc32("VPnXTInvQmRAzT",14) == 2198586877) strcat(s, "n");
if (crc32("aGPflEfRxWyMn",13) == 1696755442) strcat(s, "r");
if (crc32("dAZmMZDqhRKH",12) == 2703438531) strcat(s, "a");
if (crc32("uTnRyq",6) == 1249946913) strcat(s, "e");
if (crc32("rmgdEVfA",8) == 3592838044) strcat(s, "i");
if (crc32("XEdFphq",7) == 3738828104) strcat(s, "t");
if (crc32("CgvxGrLYepDsH",13) == 1832338311) strcat(s, "e");
if (crc32("dYlUAifAWcIq",12) == 4206441217) strcat(s, "n");
if (crc32("jkpjdyFaaXaf",12) == 2621513736) strcat(s, "t");
if (crc32("wnNhQgPEG",9) == 3477062478) strcat(s, "a");
if (crc32("dtWwiKGav",9) == 1470852742) strcat(s, "i");
if (crc32("tWSjpYizBmeyGgw",15) == 2825955888) strcat(s, "v");
if (crc32("VFSkDltFeOGQ",12) == 1758508489) strcat(s, "e");
    return s;
}

char *ridiculous_adjectives() {
    char *s = calloc(11);
    if (crc32("PflRLdp",7) == 1738098938) strcat(s, "s");
if (crc32("uEQYDYNsIy",10) == 3438943949) strcat(s, "r");
if (crc32("SdxdRZYr",8) == 1992361396) strcat(s, "f");
if (crc32("mLZLfXdtoMV",11) == 3910126880) strcat(s, "i");
if (crc32("jjPTT",5) == 2673257627) strcat(s, "d");
if (crc32("XvmCZNLLm",9) == 959884060) strcat(s, "i");
if (crc32("XowKratMmWVuH",13) == 2141088342) strcat(s, "j");
if (crc32("VJrRNzsZy",9) == 3117848086) strcat(s, "c");
if (crc32("GXuzD",5) == 1085814560) strcat(s, "Y");
if (crc32("cbriwfqjuvIVvTo",15) == 2691378016) strcat(s, "u");
if (crc32("pIctWsOCEe",10) == 2296525936) strcat(s, "f");
if (crc32("EhjmEyMgU",9) == 628463712) strcat(s, "l");
if (crc32("IkTGhV",6) == 1033426344) strcat(s, "v");
if (crc32("JjaDQdJcj",9) == 2048594036) strcat(s, "o");
if (crc32("tQpCXJLKYW",10) == 144603615) strcat(s, "o");
if (crc32("pguWbQldgiEHjY",14) == 864764009) strcat(s, "u");
if (crc32("tguJQsuFtBMXXa",14) == 1961090629) strcat(s, "s");
    return s;
}

char *anaclinal_adjectives() {
    char *s = calloc(10);
    if (crc32("vMJDTu",6) == 2975355681) strcat(s, "a");
if (crc32("meJWABspzyter",13) == 1091762808) strcat(s, "G");
if (crc32("XbFEbD",6) == 1555680114) strcat(s, "n");
if (crc32("tIDGIjaoGMxIVE",14) == 2541892253) strcat(s, "a");
if (crc32("WVlgrJh",7) == 1164985472) strcat(s, "c");
if (crc32("PpVIbPVgQZXbwD",14) == 2884979449) strcat(s, "A");
if (crc32("ZZiOO",5) == 3333763285) strcat(s, "l");
if (crc32("dnXqevYiL",9) == 2023872728) strcat(s, "P");
if (crc32("umEJx",5) == 474326742) strcat(s, "i");
if (crc32("zXMQbdZoxBXZHMR",15) == 370581257) strcat(s, "Y");
if (crc32("DwpTKhbuABKwMhl",15) == 3561358314) strcat(s, "n");
if (crc32("kVneGINgmxCqLd",14) == 706014777) strcat(s, "m");
if (crc32("DArYRSawqxH",11) == 1315620997) strcat(s, "a");
if (crc32("LtsaM",5) == 2638267484) strcat(s, "l");
    return s;
}

char *mispackaged_adjectives() {
    char *s = calloc(12);
    if (crc32("jkDytGcEMFi",11) == 1387732213) strcat(s, "m");
if (crc32("gIYKmRavSRaHFy",14) == 172336369) strcat(s, "r");
if (crc32("RXLZMvorIDxH",12) == 1139549857) strcat(s, "i");
if (crc32("mGVfAWIr",8) == 3056511938) strcat(s, "s");
if (crc32("KjerOK",6) == 1880813308) strcat(s, "y");
if (crc32("FsTyrLtmGPJOMai",15) == 1907958225) strcat(s, "p");
if (crc32("vMfGE",5) == 739949021) strcat(s, "a");
if (crc32("tYlWeFubz",9) == 1805644086) strcat(s, "r");
if (crc32("qZEQAvdVEsLiFBK",15) == 4087173882) strcat(s, "c");
if (crc32("ibQeX",5) == 2053820770) strcat(s, "n");
if (crc32("iuzAUTYlK",9) == 2178063307) strcat(s, "k");
if (crc32("euExTw",6) == 3641229816) strcat(s, "l");
if (crc32("PwBVXb",6) == 2118942743) strcat(s, "a");
if (crc32("OXgQLKBxW",9) == 2290490790) strcat(s, "t");
if (crc32("RlCFfV",6) == 3764366418) strcat(s, "g");
if (crc32("LCdWNDyGBhZ",11) == 3142322335) strcat(s, "e");
if (crc32("QoXVij",6) == 3273628555) strcat(s, "M");
if (crc32("wZErgKw",7) == 3639020176) strcat(s, "d");
    return s;
}

char *cladanthous_adjectives() {
    char *s = calloc(12);
    if (crc32("UlGzkwvvPTw",11) == 4001917648) strcat(s, "u");
if (crc32("bRJNGlTgQAYAQt",14) == 1127016571) strcat(s, "c");
if (crc32("wuEUbZ",6) == 3586797803) strcat(s, "F");
if (crc32("UFpGn",5) == 3379383690) strcat(s, "l");
if (crc32("lIhxFdiyrC",10) == 3899775246) strcat(s, "F");
if (crc32("evOtTGAPDMLRIf",14) == 202156266) strcat(s, "a");
if (crc32("yJRtOfYTGF",10) == 3549029011) strcat(s, "V");
if (crc32("PMnqetq",7) == 3669218621) strcat(s, "d");
if (crc32("dsWrji",6) == 906405636) strcat(s, "a");
if (crc32("NkDXJ",5) == 821720810) strcat(s, "t");
if (crc32("EhtMNem",7) == 1532619957) strcat(s, "n");
if (crc32("YARZGsEEVczZR",13) == 3606029191) strcat(s, "p");
if (crc32("qdPyIlFTqnLqbZj",15) == 3344379762) strcat(s, "t");
if (crc32("BgmIL",5) == 650439985) strcat(s, "i");
if (crc32("AVonpQftKj",10) == 3170247898) strcat(s, "h");
if (crc32("BxPoTIYXHV",10) == 3063443417) strcat(s, "o");
if (crc32("DRmwGEI",7) == 4243944808) strcat(s, "V");
if (crc32("SwEUSNRFx",9) == 3532538696) strcat(s, "u");
if (crc32("hlUkaVXtNQftyaV",15) == 4058941112) strcat(s, "s");
    return s;
}

char *unapologetic_adjectives() {
    char *s = calloc(13);
    if (crc32("oHozdgcr",8) == 1489667588) strcat(s, "u");
if (crc32("JUwodJflEJwZAL",14) == 2922738651) strcat(s, "d");
if (crc32("jeYKNVYfGMbvPuJ",15) == 4194495587) strcat(s, "n");
if (crc32("RcuRwL",6) == 47926584) strcat(s, "a");
if (crc32("cEKbsWxGLwyzOys",15) == 2674787092) strcat(s, "p");
if (crc32("cVLWIYQeYOvd",12) == 3460367176) strcat(s, "p");
if (crc32("lgldCvJNzggw",12) == 4099163621) strcat(s, "G");
if (crc32("qCUzhMd",7) == 3808588529) strcat(s, "o");
if (crc32("shIQLSR",7) == 4252193979) strcat(s, "e");
if (crc32("PEJGFbkYZhYb",12) == 1568704475) strcat(s, "l");
if (crc32("fvTyEiVJUC",10) == 1687396714) strcat(s, "o");
if (crc32("MTpOJs",6) == 3419807963) strcat(s, "c");
if (crc32("OnIqEuMH",8) == 1641238549) strcat(s, "g");
if (crc32("TSMpFZHEAg",10) == 1928288717) strcat(s, "o");
if (crc32("nodlYixFWkTNhia",15) == 823846734) strcat(s, "e");
if (crc32("IgGvHunxazzdBO",14) == 767422631) strcat(s, "t");
if (crc32("PgmSJjnSc",9) == 4078724711) strcat(s, "l");
if (crc32("xZZhViJeDkJgHX",14) == 3155184501) strcat(s, "i");
if (crc32("WxyOubP",7) == 257300120) strcat(s, "R");
if (crc32("TNBzXHHCZaJ",11) == 2008030212) strcat(s, "c");
    return s;
}

char *subchoroidal_adjectives() {
    char *s = calloc(13);
    if (crc32("TnVqJXvem",9) == 3557741404) strcat(s, "t");
if (crc32("cQCuVSakUuO",11) == 2885597527) strcat(s, "s");
if (crc32("TyeHWtSLdV",10) == 3739377345) strcat(s, "u");
if (crc32("kfLKgFJWWPqSjRn",15) == 937759571) strcat(s, "b");
if (crc32("XVNegIcpZCW",11) == 2978671270) strcat(s, "N");
if (crc32("gSMCVGGotOoyNA",14) == 545687056) strcat(s, "c");
if (crc32("uzdJV",5) == 886237416) strcat(s, "h");
if (crc32("kzKMnSfTI",9) == 4187848210) strcat(s, "V");
if (crc32("VUTUCunIxhOc",12) == 470447549) strcat(s, "o");
if (crc32("jXiQYQwjG",9) == 523708891) strcat(s, "r");
if (crc32("hfluyrr",7) == 60400610) strcat(s, "r");
if (crc32("ySxgTMWfEKmR",12) == 2290897685) strcat(s, "o");
if (crc32("MUMBnMt",7) == 628833418) strcat(s, "i");
if (crc32("AEtqHQPpmLCCO",13) == 3143995533) strcat(s, "d");
if (crc32("UXVxDxSUNxk",11) == 1729471386) strcat(s, "C");
if (crc32("duLpiGPUnazpyXm",15) == 2423682440) strcat(s, "a");
if (crc32("iFlaaQCj",8) == 3471766791) strcat(s, "l");
    return s;
}

char *unfanciful_adjectives() {
    char *s = calloc(11);
    if (crc32("qaxkzxgB",8) == 3426243424) strcat(s, "y");
if (crc32("OtSCjNRPMffi",12) == 3426892761) strcat(s, "u");
if (crc32("kXFZCaoNrBicyIU",15) == 3210830364) strcat(s, "n");
if (crc32("BKOTeUX",7) == 1506504688) strcat(s, "f");
if (crc32("rbdnSnC",7) == 1800519345) strcat(s, "z");
if (crc32("TiAow",5) == 281236127) strcat(s, "a");
if (crc32("DRdqoS",6) == 2527617127) strcat(s, "n");
if (crc32("CvfHeLzM",8) == 1399054205) strcat(s, "c");
if (crc32("XhAKDFCJoQwa",12) == 1428158079) strcat(s, "y");
if (crc32("zsxknqmMjMDEPe",14) == 367156389) strcat(s, "i");
if (crc32("KSOyLChmPiHID",13) == 3317447592) strcat(s, "u");
if (crc32("sYWsCDfkrM",10) == 3379740069) strcat(s, "f");
if (crc32("IYXCgfYBuvkRe",13) == 425093890) strcat(s, "C");
if (crc32("uwdsPNwodah",11) == 2639666742) strcat(s, "u");
if (crc32("wUtNEErlch",10) == 2949927480) strcat(s, "R");
if (crc32("uEsFDlsazrj",11) == 2704235845) strcat(s, "l");
    return s;
}

char *murmurous_adjectives() {
    char *s = calloc(10);
    if (crc32("LllFBYhFwy",10) == 651076454) strcat(s, "t");
if (crc32("WrXleM",6) == 2093522309) strcat(s, "m");
if (crc32("OnHZSZ",6) == 1282260479) strcat(s, "u");
if (crc32("hBgnFzqUPBFgc",13) == 3756204207) strcat(s, "S");
if (crc32("fFfzo",5) == 715663414) strcat(s, "r");
if (crc32("WVBKTgbVo",9) == 3299173195) strcat(s, "m");
if (crc32("OjzpuVXFNQEkr",13) == 2270124120) strcat(s, "u");
if (crc32("kfQpVHxQWFzK",12) == 750590772) strcat(s, "r");
if (crc32("uIeJiGt",7) == 3685259377) strcat(s, "m");
if (crc32("ZNGCrGYKtNPlNxF",15) == 629259257) strcat(s, "o");
if (crc32("PLwOQeQLt",9) == 1672393396) strcat(s, "p");
if (crc32("BldgeRD",7) == 1286461868) strcat(s, "u");
if (crc32("vHXxTanSF",9) == 1793764000) strcat(s, "s");
    return s;
}

char *shapelier_adjectives() {
    char *s = calloc(10);
    if (crc32("HStKblozwmWxfq",14) == 1312544292) strcat(s, "P");
if (crc32("XqjAlIBbjTCf",12) == 3325863911) strcat(s, "s");
if (crc32("ecZCLFbsrU",10) == 1763097906) strcat(s, "S");
if (crc32("suzqcNDqZlj",11) == 3987214360) strcat(s, "h");
if (crc32("BQuCuSCAfIANSgf",15) == 235709012) strcat(s, "a");
if (crc32("SNiZbLiKDEjKyg",14) == 2280242095) strcat(s, "p");
if (crc32("gdZyPjoWir",10) == 3014043044) strcat(s, "e");
if (crc32("iVhsabpEuthHTOL",15) == 1484274156) strcat(s, "p");
if (crc32("vbaZvtvseBnnNd",14) == 2724678225) strcat(s, "l");
if (crc32("DVpKSpVkHWk",11) == 3524304970) strcat(s, "o");
if (crc32("icwIY",5) == 421648645) strcat(s, "i");
if (crc32("GfqPssPOtusqo",13) == 3643758480) strcat(s, "Z");
if (crc32("CQPFGUbWdmhV",12) == 3612983401) strcat(s, "e");
if (crc32("oPJmOIsMS",9) == 1288679129) strcat(s, "x");
if (crc32("gGOsnaO",7) == 3133519846) strcat(s, "r");
    return s;
}

char *Liberian_adjectives() {
    char *s = calloc(9);
    if (crc32("QAUWehB",7) == 17390540) strcat(s, "L");
if (crc32("fLVyLSmQHb",10) == 3580580551) strcat(s, "i");
if (crc32("RXppt",5) == 3021394965) strcat(s, "F");
if (crc32("mkQoh",5) == 2278944358) strcat(s, "b");
if (crc32("WoAhmVjQc",9) == 1176530628) strcat(s, "F");
if (crc32("sqlMsztvlWCANb",14) == 263756979) strcat(s, "e");
if (crc32("hkrubHC",7) == 80939789) strcat(s, "r");
if (crc32("tcDwxDciSPEQ",12) == 768254560) strcat(s, "Y");
if (crc32("ECONNXI",7) == 2761790294) strcat(s, "i");
if (crc32("AGUlIVriCwVij",13) == 3288376784) strcat(s, "a");
if (crc32("hbqaIqQa",8) == 13664397) strcat(s, "a");
if (crc32("lIDBJMuaRJu",11) == 536091228) strcat(s, "n");
    return s;
}

char *revivalistic_adjectives() {
    char *s = calloc(13);
    if (crc32("fVLSp",5) == 2607503839) strcat(s, "J");
if (crc32("SGPDjnryJgfl",12) == 322025389) strcat(s, "r");
if (crc32("orxsjKaB",8) == 1996562532) strcat(s, "a");
if (crc32("OlRxYNfoyU",10) == 2324746253) strcat(s, "e");
if (crc32("RfWfugjTKLSHq",13) == 1453666160) strcat(s, "B");
if (crc32("TzldeliKvlQd",12) == 2689737449) strcat(s, "v");
if (crc32("edqatIITSI",10) == 1319088674) strcat(s, "i");
if (crc32("pGGwnhMoLKhLJY",14) == 247751158) strcat(s, "C");
if (crc32("yLlXnTd",7) == 406644395) strcat(s, "v");
if (crc32("haMZiyPVbzKy",12) == 3078439733) strcat(s, "a");
if (crc32("oNflPOOOlcH",11) == 871414948) strcat(s, "l");
if (crc32("HaBfXpqJfT",10) == 1308752636) strcat(s, "i");
if (crc32("bIqefCEwV",9) == 281808927) strcat(s, "M");
if (crc32("azeAFPANit",10) == 2579251842) strcat(s, "s");
if (crc32("KfEHc",5) == 2041266695) strcat(s, "w");
if (crc32("JGpwJDTaQsQs",12) == 1216861976) strcat(s, "t");
if (crc32("ZexcLitvTrb",11) == 4110156725) strcat(s, "p");
if (crc32("tMzYE",5) == 2544340854) strcat(s, "i");
if (crc32("PlwSzrpTPEcGNIg",15) == 2424755654) strcat(s, "c");
    return s;
}

char *machinable_adjectives() {
    char *s = calloc(11);
    if (crc32("zQgTglVBcLoNmAO",15) == 1977516065) strcat(s, "m");
if (crc32("btvMXG",6) == 1963744881) strcat(s, "i");
if (crc32("nYwBSFmNxPTbjMa",15) == 3158879673) strcat(s, "a");
if (crc32("ldEcveN",7) == 2945740742) strcat(s, "m");
if (crc32("HCBLUSjE",8) == 1051143857) strcat(s, "c");
if (crc32("eFMNx",5) == 1642696151) strcat(s, "h");
if (crc32("hGuidOnHgUkj",12) == 1609680938) strcat(s, "j");
if (crc32("vwzhwWkMgomf",12) == 1914973463) strcat(s, "i");
if (crc32("bnbuiWLJHgkvaSG",15) == 2857986340) strcat(s, "n");
if (crc32("ePLgzYEtfpwAGP",14) == 2929063833) strcat(s, "a");
if (crc32("tSxGGKnysbCCElW",15) == 1582996788) strcat(s, "b");
if (crc32("oRtmXPRBYGV",11) == 3268164050) strcat(s, "l");
if (crc32("ypkDwyElLGew",12) == 2228290375) strcat(s, "x");
if (crc32("FKckQrHQbsy",11) == 1705858814) strcat(s, "e");
    return s;
}

char *deviative_adjectives() {
    char *s = calloc(10);
    if (crc32("aCqdkAX",7) == 4098113186) strcat(s, "O");
if (crc32("cNJRyplVA",9) == 768041321) strcat(s, "d");
if (crc32("xNqVyba",7) == 1798551579) strcat(s, "e");
if (crc32("SwnjIcUbiBdg",12) == 889241522) strcat(s, "v");
if (crc32("QpQnDafHW",9) == 925926405) strcat(s, "i");
if (crc32("AeiDnUcBRHr",11) == 2538495755) strcat(s, "a");
if (crc32("pHNXQJ",6) == 4272827255) strcat(s, "t");
if (crc32("BfUyT",5) == 47247330) strcat(s, "i");
if (crc32("vVLOLdl",7) == 2924942942) strcat(s, "T");
if (crc32("zUzUFujFoYKqT",13) == 1556231723) strcat(s, "v");
if (crc32("tMcvZhEMVo",10) == 52087831) strcat(s, "e");
    return s;
}

char *spermatozoan_adjectives() {
    char *s = calloc(13);
    if (crc32("SLddHZmpecIpCI",14) == 1262153088) strcat(s, "s");
if (crc32("aLqDNGyjZxb",11) == 3071671678) strcat(s, "p");
if (crc32("kcrvmDaNZNK",11) == 3643156990) strcat(s, "e");
if (crc32("VKqmW",5) == 3958193505) strcat(s, "U");
if (crc32("KCIzONrMcQ",10) == 3993013331) strcat(s, "r");
if (crc32("riMQkACstUMuSxV",15) == 1916935594) strcat(s, "m");
if (crc32("OXyeyUngfJp",11) == 4084607523) strcat(s, "a");
if (crc32("QCfoPOEwnXm",11) == 964720403) strcat(s, "t");
if (crc32("hcRNW",5) == 121066409) strcat(s, "W");
if (crc32("ZhWreBbAliYJG",13) == 2399686937) strcat(s, "o");
if (crc32("aAbxpzgcfKrD",12) == 1982538572) strcat(s, "t");
if (crc32("sOPAwETHqNreFTd",15) == 526890515) strcat(s, "z");
if (crc32("iBxiTYfcJX",10) == 3328289770) strcat(s, "o");
if (crc32("QoBThHVMiQAmos",14) == 3602473286) strcat(s, "z");
if (crc32("vqnhYwiOLVyATX",14) == 820373707) strcat(s, "a");
if (crc32("whaJt",5) == 1739171731) strcat(s, "n");
    return s;
}

char *halfreasonable_adjectives() {
    char *s = calloc(15);
    if (crc32("UPQIOipheqmx",12) == 417427445) strcat(s, "h");
if (crc32("xziCFbSm",8) == 2015337587) strcat(s, "l");
if (crc32("egTbi",5) == 957453871) strcat(s, "a");
if (crc32("IQkIFPxB",8) == 1282792222) strcat(s, "l");
if (crc32("FtEJFTuekS",10) == 1139172369) strcat(s, "Y");
if (crc32("hhJbKwOBO",9) == 567951996) strcat(s, "f");
if (crc32("RnUYcX",6) == 1649986174) strcat(s, "r");
if (crc32("GtOYJsR",7) == 481248789) strcat(s, "e");
if (crc32("adIlLTvouCIZlB",14) == 3735048917) strcat(s, "S");
if (crc32("zXYOZLqdplqK",12) == 631656274) strcat(s, "a");
if (crc32("HaGZfFyt",8) == 296387305) strcat(s, "s");
if (crc32("qrpYkPyPIfMzKqj",15) == 4157069843) strcat(s, "o");
if (crc32("VHmZAh",6) == 33180247) strcat(s, "n");
if (crc32("LMuBUQrCZqd",11) == 3357947450) strcat(s, "F");
if (crc32("ZgAFPMHhX",9) == 123095650) strcat(s, "a");
if (crc32("okXbuuBaaAjYX",13) == 3935557770) strcat(s, "b");
if (crc32("RDOBYJXLUwV",11) == 3622687489) strcat(s, "e");
if (crc32("SUvmUkwAxLfUJJ",14) == 2574657944) strcat(s, "l");
if (crc32("MGjCET",6) == 4044579874) strcat(s, "p");
if (crc32("xRbvuAMUAX",10) == 4133593231) strcat(s, "e");
    return s;
}

char *nonrequisite_adjectives() {
    char *s = calloc(13);
    if (crc32("lSKytpQXjpdOmvz",15) == 1165258198) strcat(s, "N");
if (crc32("BmvaRLuNsiIC",12) == 1424285264) strcat(s, "n");
if (crc32("ulnOgKIYKYEVB",13) == 2300607056) strcat(s, "E");
if (crc32("hesXyliNSsJA",12) == 328175434) strcat(s, "o");
if (crc32("tcLYZXypfkXAX",13) == 3034798341) strcat(s, "n");
if (crc32("uQNStponqkjb",12) == 98378572) strcat(s, "r");
if (crc32("reqNkI",6) == 2876502057) strcat(s, "w");
if (crc32("ZuVNhBAKkvxRlE",14) == 1604841289) strcat(s, "e");
if (crc32("PdTEEuZAzaVJJ",13) == 2777339679) strcat(s, "L");
if (crc32("GKmXZuoiMid",11) == 3739604725) strcat(s, "q");
if (crc32("YVTxAShV",8) == 3007738582) strcat(s, "Y");
if (crc32("pjLgrVMQDwrg",12) == 3266472445) strcat(s, "u");
if (crc32("QBvcl",5) == 2833547301) strcat(s, "i");
if (crc32("VvYoPzdUwEnGnKP",15) == 3810412410) strcat(s, "r");
if (crc32("PcEYxKcLU",9) == 2137412952) strcat(s, "s");
if (crc32("gKkqiUK",7) == 3930527673) strcat(s, "i");
if (crc32("JTGJZiJHeR",10) == 2826435344) strcat(s, "t");
if (crc32("pJEJZsj",7) == 2352007841) strcat(s, "V");
if (crc32("UgQfQzBcuZv",11) == 2907404166) strcat(s, "e");
    return s;
}

char *probeable_adjectives() {
    char *s = calloc(10);
    if (crc32("dRInKyaDneoFS",13) == 414553079) strcat(s, "p");
if (crc32("QCkDLyXcryq",11) == 2448077070) strcat(s, "N");
if (crc32("JtsSmSbrkEgxxqd",15) == 3843558447) strcat(s, "r");
if (crc32("hrgzykbWxk",10) == 3551901408) strcat(s, "g");
if (crc32("MxNApx",6) == 2966706974) strcat(s, "o");
if (crc32("dnNPl",5) == 4124210765) strcat(s, "b");
if (crc32("CapAfUpC",8) == 358736783) strcat(s, "C");
if (crc32("ktuMXseaqVu",11) == 956635446) strcat(s, "e");
if (crc32("qWHzpulWzqOUQh",14) == 3143898502) strcat(s, "x");
if (crc32("chuBJYIn",8) == 3870750877) strcat(s, "a");
if (crc32("rvflUzkqBxoL",12) == 3325218975) strcat(s, "b");
if (crc32("ZmtXW",5) == 1679708388) strcat(s, "n");
if (crc32("upXqDLeZwxe",11) == 234302687) strcat(s, "l");
if (crc32("scOOAxXaFOsxa",13) == 2271817409) strcat(s, "e");
    return s;
}

char *unrepudiated_adjectives() {
    char *s = calloc(13);
    if (crc32("fAbmFIrzTagZMb",14) == 1073826516) strcat(s, "R");
if (crc32("lclbYhsxRGplOR",14) == 3444278605) strcat(s, "u");
if (crc32("CnJJuulP",8) == 163695479) strcat(s, "n");
if (crc32("ZoIHyPDDyblmN",13) == 246672837) strcat(s, "r");
if (crc32("tHAoYIC",7) == 3449144498) strcat(s, "e");
if (crc32("WNCCRzFddX",10) == 457688530) strcat(s, "p");
if (crc32("nvTsUhtpjkRwc",13) == 3015855414) strcat(s, "g");
if (crc32("RMYAuZchIXDkd",13) == 2060541958) strcat(s, "u");
if (crc32("sDvKE",5) == 279805433) strcat(s, "R");
if (crc32("RDnQKd",6) == 2988573166) strcat(s, "d");
if (crc32("WLiMtVszVrtbs",13) == 3632661804) strcat(s, "E");
if (crc32("vkvvVVGpoTq",11) == 485602006) strcat(s, "i");
if (crc32("YBdwYEPisFY",11) == 552032978) strcat(s, "a");
if (crc32("wazubBGeSYglksd",15) == 670906474) strcat(s, "E");
if (crc32("rPumZWIZSI",10) == 1395834188) strcat(s, "t");
if (crc32("vwMsLawRqQvl",12) == 2614752535) strcat(s, "m");
if (crc32("ySizyTYnMHj",11) == 2618030909) strcat(s, "e");
if (crc32("iVHUzBkaD",9) == 532650301) strcat(s, "r");
if (crc32("axrVeuWpUSKw",12) == 4277185564) strcat(s, "d");
    return s;
}

char *unbroached_adjectives() {
    char *s = calloc(11);
    if (crc32("CZrAjHjfwfBx",12) == 768161953) strcat(s, "S");
if (crc32("cCNggDwLFW",10) == 679824205) strcat(s, "u");
if (crc32("KYuRprmdPnaMrH",14) == 3021743795) strcat(s, "R");
if (crc32("ejsnWyid",8) == 2319566133) strcat(s, "n");
if (crc32("dCEWqHwtp",9) == 2547411247) strcat(s, "b");
if (crc32("wRzpmWAaLAwGB",13) == 90619446) strcat(s, "Z");
if (crc32("zdSAkkOCK",9) == 1111859514) strcat(s, "r");
if (crc32("kzDgmANdhaK",11) == 1364332253) strcat(s, "W");
if (crc32("BqRZTqiU",8) == 3372372215) strcat(s, "o");
if (crc32("RpSIJrwS",8) == 261367405) strcat(s, "d");
if (crc32("jtkaHevlMkCRkG",14) == 1429910044) strcat(s, "a");
if (crc32("LbzUJSgCiy",10) == 1612891101) strcat(s, "Q");
if (crc32("YfINaQUzXD",10) == 3416887423) strcat(s, "c");
if (crc32("ZjEKJDzkkTrzEPk",15) == 1173546534) strcat(s, "h");
if (crc32("zWBklle",7) == 3216412743) strcat(s, "e");
if (crc32("TDoHYQxJCKE",11) == 1809880224) strcat(s, "X");
if (crc32("kYbWCfytbWtkcI",14) == 3596722036) strcat(s, "d");
    return s;
}

char *monotheistical_adjectives() {
    char *s = calloc(15);
    if (crc32("BRVSyn",6) == 3804474191) strcat(s, "U");
if (crc32("PRPPMpEVDHczEL",14) == 535277803) strcat(s, "m");
if (crc32("GoEvasTPmqLGvG",14) == 737404343) strcat(s, "W");
if (crc32("AqXvHJTMGRsSam",14) == 2096441260) strcat(s, "o");
if (crc32("kTYqiL",6) == 2136639347) strcat(s, "R");
if (crc32("CxEILwJClQhbRug",15) == 2708288582) strcat(s, "n");
if (crc32("VMjQyOJOC",9) == 1866576564) strcat(s, "o");
if (crc32("SnYpwVtADIHIj",13) == 498049568) strcat(s, "X");
if (crc32("IJLwPVcvNfo",11) == 742623703) strcat(s, "t");
if (crc32("gFpdaTBua",9) == 708631767) strcat(s, "Y");
if (crc32("enuaSZekIDTc",12) == 3821714178) strcat(s, "h");
if (crc32("mZOpYANk",8) == 3955108480) strcat(s, "g");
if (crc32("WNtHk",5) == 2262988441) strcat(s, "e");
if (crc32("RRTWVXtA",8) == 486959348) strcat(s, "i");
if (crc32("zvDPIs",6) == 3303785229) strcat(s, "e");
if (crc32("MNudDm",6) == 1374616207) strcat(s, "s");
if (crc32("TLLxgTZGALqtpDJ",15) == 1666068224) strcat(s, "p");
if (crc32("cefWxUZnBeD",11) == 3579748231) strcat(s, "t");
if (crc32("cWTzkjhXj",9) == 1986979555) strcat(s, "i");
if (crc32("rNgXUSgBYGWzeW",14) == 1029016529) strcat(s, "i");
if (crc32("rqrgXHUqkcYly",13) == 2596831469) strcat(s, "C");
if (crc32("NPKbDv",6) == 2528549646) strcat(s, "c");
if (crc32("wvBbxejnFgYINu",14) == 2364021938) strcat(s, "a");
if (crc32("xvVzNxpyQavc",12) == 1275409438) strcat(s, "k");
if (crc32("CPeppxAR",8) == 500455966) strcat(s, "l");
    return s;
}

char *innovatory_adjectives() {
    char *s = calloc(11);
    if (crc32("fDCsJoeO",8) == 4155663009) strcat(s, "k");
if (crc32("gOwnkH",6) == 876565528) strcat(s, "i");
if (crc32("DCylnlbxnbgAp",13) == 3496364524) strcat(s, "n");
if (crc32("rvIkqYxo",8) == 4284579312) strcat(s, "F");
if (crc32("KKthOaPlqqpIBm",14) == 2487778066) strcat(s, "n");
if (crc32("BZNZjb",6) == 2814368415) strcat(s, "o");
if (crc32("tIezMMJHVH",10) == 2313366559) strcat(s, "r");
if (crc32("cWKVkFTzvusD",12) == 4117020925) strcat(s, "v");
if (crc32("nojNYEqNeRuKz",13) == 967738495) strcat(s, "J");
if (crc32("qQFQAbuNUEBds",13) == 2424098839) strcat(s, "a");
if (crc32("cvlse",5) == 391678069) strcat(s, "U");
if (crc32("oZDVd",5) == 2824700616) strcat(s, "t");
if (crc32("UpXJGFsjcpO",11) == 3564701481) strcat(s, "o");
if (crc32("mHuaQbddvnAOIcX",15) == 1314144603) strcat(s, "L");
if (crc32("gjFunY",6) == 1916662670) strcat(s, "r");
if (crc32("gktRYcJ",7) == 1739347583) strcat(s, "y");
    return s;
}

char *antiSerb_adjectives() {
    char *s = calloc(9);
    if (crc32("cbOdrnvH",8) == 3861086590) strcat(s, "l");
if (crc32("kyuAWF",6) == 1624196331) strcat(s, "a");
if (crc32("ERvygvYTbeObbV",14) == 1801555138) strcat(s, "c");
if (crc32("cVZBMTk",7) == 3266190115) strcat(s, "n");
if (crc32("lMKNBtvEXR",10) == 3801074935) strcat(s, "J");
if (crc32("frRsilLEZGZWuQ",14) == 4085891178) strcat(s, "t");
if (crc32("lkmgW",5) == 3917184023) strcat(s, "i");
if (crc32("zpoeBf",6) == 2842585279) strcat(s, "S");
if (crc32("OOilaK",6) == 258252465) strcat(s, "e");
if (crc32("vBLrzMVV",8) == 3255483623) strcat(s, "N");
if (crc32("XXlgnY",6) == 2363331924) strcat(s, "r");
if (crc32("zebthXeGPKhjN",13) == 929007748) strcat(s, "j");
if (crc32("zWwhK",5) == 1041121034) strcat(s, "b");
    return s;
}

char *Italianate_adjectives() {
    char *s = calloc(11);
    if (crc32("yLxqGtCtBKI",11) == 3295538513) strcat(s, "I");
if (crc32("ysrBzpItQDmvOqh",15) == 1974893840) strcat(s, "E");
if (crc32("JuHGIvSMRk",10) == 102800440) strcat(s, "t");
if (crc32("CNfzvxUEZcjaIH",14) == 4236667797) strcat(s, "a");
if (crc32("YSkfHWqkfk",10) == 2672652646) strcat(s, "l");
if (crc32("iwNxgDQPHBH",11) == 3916119910) strcat(s, "y");
if (crc32("hyssaPjpmaZSlu",14) == 3039504236) strcat(s, "i");
if (crc32("KLqIYkj",7) == 3377972535) strcat(s, "a");
if (crc32("DYHywFsstHzzq",13) == 3409911513) strcat(s, "C");
if (crc32("RQFFyH",6) == 3110409130) strcat(s, "n");
if (crc32("ovBKPeJ",7) == 668882343) strcat(s, "C");
if (crc32("iMivDOCGrjkAu",13) == 3060519372) strcat(s, "a");
if (crc32("vRNSw",5) == 2237260586) strcat(s, "C");
if (crc32("jwbtisGNYMdLts",14) == 3582844278) strcat(s, "t");
if (crc32("VCyVl",5) == 185974491) strcat(s, "e");
    return s;
}

char *valvar_adjectives() {
    char *s = calloc(7);
    if (crc32("ZXcSzC",6) == 450157171) strcat(s, "E");
if (crc32("zLnULyYD",8) == 2302588003) strcat(s, "v");
if (crc32("LJJIYOibiJmlM",13) == 2869032157) strcat(s, "O");
if (crc32("RBzCA",5) == 906328902) strcat(s, "a");
if (crc32("XwlBCTCQNCBxdeR",15) == 331863073) strcat(s, "l");
if (crc32("OHNGZYmcYvFyxX",14) == 3730274556) strcat(s, "R");
if (crc32("XHBaYQCDO",9) == 2212476627) strcat(s, "v");
if (crc32("VcmsuWlJUWXq",12) == 3006969078) strcat(s, "m");
if (crc32("AGwfVhl",7) == 3118698937) strcat(s, "a");
if (crc32("PuAdTn",6) == 422541919) strcat(s, "W");
if (crc32("FRZngJKsmMQ",11) == 1699313734) strcat(s, "r");
    return s;
}

char *inflammatory_adjectives() {
    char *s = calloc(13);
    if (crc32("IowkM",5) == 794745828) strcat(s, "i");
if (crc32("NQbSfAzrT",9) == 3060639630) strcat(s, "P");
if (crc32("abMeMSTZwM",10) == 1158567746) strcat(s, "n");
if (crc32("FxcOtsxgIhy",11) == 4273879778) strcat(s, "S");
if (crc32("sMnty",5) == 837648034) strcat(s, "f");
if (crc32("QwNom",5) == 2665169668) strcat(s, "l");
if (crc32("FSDAdVdcOxORQ",13) == 3057674930) strcat(s, "a");
if (crc32("ktrzDRyDLItPa",13) == 1468691020) strcat(s, "m");
if (crc32("sWclFLthPB",10) == 1044870937) strcat(s, "m");
if (crc32("aVkEuX",6) == 1756834923) strcat(s, "a");
if (crc32("EBDyFtuLpdO",11) == 1635687339) strcat(s, "G");
if (crc32("kgukumpiosF",11) == 1897692205) strcat(s, "t");
if (crc32("bQNtXt",6) == 640040744) strcat(s, "E");
if (crc32("VBeBMSkmzMOJJ",13) == 895861562) strcat(s, "o");
if (crc32("RYYvMvCJgprx",12) == 2040969495) strcat(s, "r");
if (crc32("ygQKcjfZSUMTC",13) == 992050562) strcat(s, "P");
if (crc32("urEJFJlpzUUT",12) == 504348712) strcat(s, "y");
    return s;
}

char *revolting_adjectives() {
    char *s = calloc(10);
    if (crc32("OUMKv",5) == 4138579749) strcat(s, "d");
if (crc32("GAEGLncIiuTV",12) == 3699058016) strcat(s, "r");
if (crc32("JZQOXhfg",8) == 3556207566) strcat(s, "r");
if (crc32("MfyMztuCpuxRfj",14) == 2512729935) strcat(s, "e");
if (crc32("qIQYt",5) == 2540002604) strcat(s, "A");
if (crc32("WGroJKtJ",8) == 3017403411) strcat(s, "v");
if (crc32("AgDBcPSvQdl",11) == 3217155694) strcat(s, "C");
if (crc32("gNNQgedDZBP",11) == 3139701753) strcat(s, "o");
if (crc32("iawVLHaxmhlVVQ",14) == 920824880) strcat(s, "l");
if (crc32("wleTdHVnacv",11) == 4035732548) strcat(s, "T");
if (crc32("jPTSSGNUjfaEi",13) == 2158827172) strcat(s, "t");
if (crc32("SAatwPCcYBcph",13) == 1723080091) strcat(s, "i");
if (crc32("SvVWuDOx",8) == 2286970775) strcat(s, "B");
if (crc32("XYQlKNG",7) == 685333448) strcat(s, "n");
if (crc32("vnhdYgSAfQchdeU",15) == 3685696507) strcat(s, "g");
if (crc32("XRCyaVBUEV",10) == 3952624180) strcat(s, "g");
    return s;
}

char *copasetic_adjectives() {
    char *s = calloc(10);
    if (crc32("hTEJX",5) == 4053947111) strcat(s, "y");
if (crc32("JLAzkaSjyf",10) == 4281207574) strcat(s, "c");
if (crc32("QkwYoadRtrY",11) == 3401436801) strcat(s, "o");
if (crc32("iADSuCmHd",9) == 3662187444) strcat(s, "v");
if (crc32("ZwAdSsuRwiw",11) == 2618719711) strcat(s, "p");
if (crc32("SFPSWgAejZw",11) == 1504345539) strcat(s, "R");
if (crc32("lZFDsFJ",7) == 3644270329) strcat(s, "a");
if (crc32("mKDZVYGS",8) == 1325090909) strcat(s, "s");
if (crc32("UXfDBKimGz",10) == 2183851604) strcat(s, "C");
if (crc32("fBtxEq",6) == 1508880900) strcat(s, "e");
if (crc32("rNojdviNAdmbzB",14) == 2002627693) strcat(s, "f");
if (crc32("GBexiLvc",8) == 2516936597) strcat(s, "t");
if (crc32("zBaAyKLW",8) == 3500732111) strcat(s, "E");
if (crc32("OaxoGhfqBL",10) == 2284624713) strcat(s, "i");
if (crc32("urHmYjBpmWEK",12) == 2896503459) strcat(s, "T");
if (crc32("bkRBkp",6) == 3725202553) strcat(s, "c");
    return s;
}

char *unevidenced_adjectives() {
    char *s = calloc(12);
    if (crc32("jZjYonxdzaOpP",13) == 534613666) strcat(s, "u");
if (crc32("XoIJPqzaVQyNKd",14) == 3451167242) strcat(s, "K");
if (crc32("ATkGjzKE",8) == 3349770830) strcat(s, "n");
if (crc32("UmsCRkDH",8) == 706998030) strcat(s, "j");
if (crc32("aOTPUpueiUUyf",13) == 3317936607) strcat(s, "e");
if (crc32("UhoHecUzdP",10) == 1825042938) strcat(s, "v");
if (crc32("vmqAvIDloKKYMC",14) == 1142961137) strcat(s, "b");
if (crc32("JeISoDsKVREE",12) == 3096355816) strcat(s, "i");
if (crc32("DtmMUntV",8) == 2276852977) strcat(s, "p");
if (crc32("jnOuslQ",7) == 2240130569) strcat(s, "d");
if (crc32("UukqZvnmn",9) == 3740712710) strcat(s, "w");
if (crc32("PxwoE",5) == 3856075783) strcat(s, "e");
if (crc32("EZbGEjbk",8) == 1211422749) strcat(s, "n");
if (crc32("GPVyMZKUG",9) == 4099920555) strcat(s, "h");
if (crc32("WuFqJhisbV",10) == 1698751946) strcat(s, "c");
if (crc32("RtgXU",5) == 1146614783) strcat(s, "e");
if (crc32("gDnIFmxsZv",10) == 1953363517) strcat(s, "U");
if (crc32("UVDVtJRVt",9) == 190585641) strcat(s, "d");
    return s;
}

char *denominative_adjectives() {
    char *s = calloc(13);
    if (crc32("GtxFoKBw",8) == 2101055116) strcat(s, "d");
if (crc32("emZUoKtgBFtWJq",14) == 116986094) strcat(s, "H");
if (crc32("ucyHdRRtvka",11) == 212582866) strcat(s, "e");
if (crc32("hTZsPUUqDKo",11) == 2309867491) strcat(s, "P");
if (crc32("NQtLitLubTC",11) == 1597775675) strcat(s, "n");
if (crc32("rHTDqn",6) == 1514580684) strcat(s, "Q");
if (crc32("wmFJHIeOKZF",11) == 3814735426) strcat(s, "o");
if (crc32("STbqHeCtODLWvJr",15) == 975343702) strcat(s, "m");
if (crc32("fraje",5) == 1048017823) strcat(s, "N");
if (crc32("MriuTYzKxg",10) == 3373173166) strcat(s, "i");
if (crc32("UdZsnDmq",8) == 3974383785) strcat(s, "x");
if (crc32("FNUQkhE",7) == 3820465196) strcat(s, "n");
if (crc32("GeodG",5) == 2204907640) strcat(s, "z");
if (crc32("LpDztsttnoPdf",13) == 4998488) strcat(s, "a");
if (crc32("akABbsr",7) == 2002428818) strcat(s, "t");
if (crc32("XMvCWzpYr",9) == 2489151569) strcat(s, "i");
if (crc32("JhEqtERmMtMF",12) == 721338308) strcat(s, "v");
if (crc32("YySDBwGWgNLfVS",14) == 4068331498) strcat(s, "e");
    return s;
}

char *selfpleased_adjectives() {
    char *s = calloc(12);
    if (crc32("GEEjvhvVgpL",11) == 1711691159) strcat(s, "J");
if (crc32("zPKQrIXkTsK",11) == 840436158) strcat(s, "s");
if (crc32("DtdAGPM",7) == 897766442) strcat(s, "e");
if (crc32("RxhDPeMwtaMDXjs",15) == 3521802775) strcat(s, "P");
if (crc32("FvfifUSs",8) == 1665622780) strcat(s, "l");
if (crc32("UfqzfP",6) == 702156192) strcat(s, "f");
if (crc32("jyFcynUkJG",10) == 2092116379) strcat(s, "p");
if (crc32("fDRjgutnBwZySO",14) == 190917227) strcat(s, "G");
if (crc32("ZAdoEG",6) == 3946674417) strcat(s, "l");
if (crc32("oNEFFeR",7) == 307496702) strcat(s, "e");
if (crc32("JpDIRdyPJ",9) == 761829533) strcat(s, "P");
if (crc32("kiqsqx",6) == 2854087503) strcat(s, "a");
if (crc32("mkmQrpPk",8) == 3816320288) strcat(s, "s");
if (crc32("ELjtHtmhjuiWaZh",15) == 2549216982) strcat(s, "e");
if (crc32("qrNfJFaYOhMy",12) == 989250381) strcat(s, "n");
if (crc32("cFWuGTVB",8) == 627135236) strcat(s, "d");
    return s;
}

char *diriment_adjectives() {
    char *s = calloc(9);
    if (crc32("CAlzYBTpDGAzih",14) == 3327018064) strcat(s, "d");
if (crc32("eLFpOkTITlSoA",13) == 2738213510) strcat(s, "i");
if (crc32("AIKoIJyoLUEer",13) == 3961424788) strcat(s, "r");
if (crc32("LBMRzbYRhDRHJo",14) == 86505129) strcat(s, "i");
if (crc32("Rywksp",6) == 3880316886) strcat(s, "P");
if (crc32("bNvgWNCXpcRH",12) == 3817550849) strcat(s, "m");
if (crc32("GhluBNG",7) == 2732483685) strcat(s, "q");
if (crc32("nPWrqYWlQYGb",12) == 3493062936) strcat(s, "e");
if (crc32("rpTEiQrCe",9) == 1248424130) strcat(s, "n");
if (crc32("awopXoVfTB",10) == 2199159040) strcat(s, "f");
if (crc32("lrFPvmBHEJ",10) == 3530114854) strcat(s, "t");
    return s;
}

char *noncommunicating_adjectives() {
    char *s = calloc(17);
    if (crc32("JYtuTTpYUKNBwY",14) == 3523044488) strcat(s, "s");
if (crc32("VYeMtmNBV",9) == 943566354) strcat(s, "n");
if (crc32("GckEo",5) == 300140769) strcat(s, "o");
if (crc32("fTChWUtYCdTdS",13) == 411504462) strcat(s, "n");
if (crc32("pegtUvMIJ",9) == 559200690) strcat(s, "c");
if (crc32("uRkUn",5) == 3209731588) strcat(s, "o");
if (crc32("cjAQYuupSdXjR",13) == 52747268) strcat(s, "m");
if (crc32("ssMudxqRLqm",11) == 2613905627) strcat(s, "m");
if (crc32("VHJEFFSyQ",9) == 1198579166) strcat(s, "u");
if (crc32("edCOE",5) == 541047352) strcat(s, "n");
if (crc32("lqOGegSamexqxa",14) == 2541927071) strcat(s, "i");
if (crc32("SxjJzjIonURB",12) == 150213654) strcat(s, "c");
if (crc32("CryEgobbHduCyg",14) == 2594098019) strcat(s, "c");
if (crc32("XEPmrWQM",8) == 2642883911) strcat(s, "n");
if (crc32("buXmrbFfE",9) == 2269617479) strcat(s, "a");
if (crc32("RjcfoTo",7) == 3725784407) strcat(s, "w");
if (crc32("xcUka",5) == 4040690439) strcat(s, "t");
if (crc32("FbNdDpVVBhTjD",13) == 1712114801) strcat(s, "i");
if (crc32("pSJiBvwhxmSEbhg",15) == 1233559538) strcat(s, "r");
if (crc32("mOAXHWfa",8) == 1856628568) strcat(s, "n");
if (crc32("gyNSgJZhA",9) == 3638843009) strcat(s, "V");
if (crc32("qXQPCLBtosNpG",13) == 1462004443) strcat(s, "g");
    return s;
}

char *wellgoverned_adjectives() {
    char *s = calloc(13);
    if (crc32("diCav",5) == 1541546863) strcat(s, "w");
if (crc32("qaipZoRtaZyj",12) == 4079450104) strcat(s, "d");
if (crc32("UTJpfPbRjR",10) == 3319950881) strcat(s, "e");
if (crc32("CElgT",5) == 2570715189) strcat(s, "I");
if (crc32("kibJCdkXMToVfQQ",15) == 2792085670) strcat(s, "l");
if (crc32("dqBlocTKlo",10) == 4029016655) strcat(s, "l");
if (crc32("oluPEIhjcCggSJ",14) == 4403211) strcat(s, "g");
if (crc32("IqkklHggrQsbkVR",15) == 421594946) strcat(s, "Y");
if (crc32("SVUhJTmJb",9) == 350027758) strcat(s, "o");
if (crc32("myXXKDm",7) == 4222637459) strcat(s, "K");
if (crc32("RpWDUWVebcVzzcC",15) == 1319550384) strcat(s, "v");
if (crc32("cWnJduSYkt",10) == 596702157) strcat(s, "e");
if (crc32("MStbIqIfWulJ",12) == 2688257281) strcat(s, "r");
if (crc32("URBPglBEkjGt",12) == 2933118346) strcat(s, "R");
if (crc32("Rnloy",5) == 3581503282) strcat(s, "n");
if (crc32("LXswctzuKbdFTu",14) == 3245007434) strcat(s, "e");
if (crc32("YcqOSzMCJYT",11) == 3967265478) strcat(s, "I");
if (crc32("rABNDLNxt",9) == 2375470559) strcat(s, "d");
    return s;
}

char *pseudoGreek_adjectives() {
    char *s = calloc(12);
    if (crc32("mzBhveVkBafUN",13) == 68642021) strcat(s, "R");
if (crc32("nZDOLJowRtJN",12) == 868886445) strcat(s, "p");
if (crc32("gjPgLhHMKlJ",11) == 249806182) strcat(s, "x");
if (crc32("gWvQI",5) == 1194781336) strcat(s, "s");
if (crc32("BlhhizhYNJ",10) == 2169557757) strcat(s, "e");
if (crc32("pAZzLQu",7) == 963566604) strcat(s, "u");
if (crc32("tLVWFKAhkycFME",14) == 2643796129) strcat(s, "d");
if (crc32("PsJYcMEosHifS",13) == 1658641409) strcat(s, "e");
if (crc32("VgkFBdqaA",9) == 3550885476) strcat(s, "o");
if (crc32("VYTlvNcrpeKf",12) == 1087253820) strcat(s, "G");
if (crc32("tuDnP",5) == 4294489995) strcat(s, "T");
if (crc32("vlmLyA",6) == 2140225008) strcat(s, "r");
if (crc32("MhbUkQrTgFMs",12) == 2523512394) strcat(s, "T");
if (crc32("xNXaaJYzV",9) == 649676981) strcat(s, "e");
if (crc32("XnCWk",5) == 1224651773) strcat(s, "e");
if (crc32("jKPxoIrpw",9) == 3561124168) strcat(s, "k");
    return s;
}

char *unvomited_adjectives() {
    char *s = calloc(10);
    if (crc32("NoCOdPuZYOz",11) == 566316559) strcat(s, "W");
if (crc32("JumciXQIzkMxN",13) == 531385370) strcat(s, "u");
if (crc32("FyMMlQSzeKmK",12) == 3154141470) strcat(s, "F");
if (crc32("xMsELR",6) == 547537535) strcat(s, "n");
if (crc32("LCSrQZ",6) == 1893237152) strcat(s, "v");
if (crc32("ULvzVeCtnDOXhH",14) == 1952667163) strcat(s, "o");
if (crc32("RLnGs",5) == 1632539485) strcat(s, "m");
if (crc32("VmmBVzewPXwe",12) == 3677395875) strcat(s, "i");
if (crc32("cKkgRha",7) == 4061638896) strcat(s, "t");
if (crc32("OYGvovyHKIjWjFm",15) == 2103181018) strcat(s, "U");
if (crc32("wpydzaGqbCSyOZh",15) == 3404675004) strcat(s, "e");
if (crc32("oGLKwIeakNI",11) == 176721940) strcat(s, "r");
if (crc32("VxyWSj",6) == 3783438517) strcat(s, "d");
    return s;
}

char *quasifoolish_adjectives() {
    char *s = calloc(13);
    if (crc32("gbIOgl",6) == 3030628149) strcat(s, "q");
if (crc32("MrgFIbRzO",9) == 3838368137) strcat(s, "l");
if (crc32("DjWnXMglluLt",12) == 4158672147) strcat(s, "u");
if (crc32("KIeNcGhYGgep",12) == 3137829511) strcat(s, "a");
if (crc32("BDqjOSgSViSkgiO",15) == 1596608239) strcat(s, "s");
if (crc32("kbgDapnhow",10) == 3416625044) strcat(s, "K");
if (crc32("KkiEmxPz",8) == 3192472358) strcat(s, "i");
if (crc32("cEJGRJCQxK",10) == 3315348793) strcat(s, "f");
if (crc32("bhdOYf",6) == 1378207514) strcat(s, "u");
if (crc32("hUkhnI",6) == 4211816872) strcat(s, "o");
if (crc32("PiSYOD",6) == 2515263320) strcat(s, "o");
if (crc32("nVBTICjHd",9) == 3700313489) strcat(s, "B");
if (crc32("CXktfXhdazD",11) == 2148242130) strcat(s, "l");
if (crc32("jfjNNv",6) == 1566507614) strcat(s, "O");
if (crc32("gEGgs",5) == 3617567468) strcat(s, "i");
if (crc32("zDHvTYh",7) == 2526269051) strcat(s, "d");
if (crc32("xqbJmMdgEe",10) == 3464160359) strcat(s, "s");
if (crc32("tMUHz",5) == 3059095160) strcat(s, "t");
if (crc32("EwgrtFBVE",9) == 4144382787) strcat(s, "h");
    return s;
}

char *undershot_adjectives() {
    char *s = calloc(10);
    if (crc32("bbkDBybekE",10) == 808486716) strcat(s, "K");
if (crc32("iTTqy",5) == 1646755223) strcat(s, "u");
if (crc32("WrHfED",6) == 3783170191) strcat(s, "q");
if (crc32("VLhaVgQIRHE",11) == 1665489491) strcat(s, "n");
if (crc32("nYNpNRKfIKp",11) == 3472613303) strcat(s, "d");
if (crc32("vEZOwrmfubJTeKM",15) == 1241813581) strcat(s, "u");
if (crc32("nFEHnBzaVj",10) == 2338924503) strcat(s, "e");
if (crc32("QNYwMZgZsXyYNG",14) == 1060015281) strcat(s, "g");
if (crc32("LFMioaZOu",9) == 2502387737) strcat(s, "r");
if (crc32("tkSYmmrdRiL",11) == 3828839265) strcat(s, "T");
if (crc32("hlyPzeaae",9) == 1144622736) strcat(s, "s");
if (crc32("CGmGzlsiNx",10) == 111723439) strcat(s, "E");
if (crc32("BZopTyUe",8) == 1813251756) strcat(s, "h");
if (crc32("JBVIuyHPNalB",12) == 2618205222) strcat(s, "W");
if (crc32("JInfSmCs",8) == 2744064350) strcat(s, "o");
if (crc32("OoSSbRZ",7) == 954657348) strcat(s, "t");
    return s;
}

char *unbeguiling_adjectives() {
    char *s = calloc(12);
    if (crc32("iiqfzpWbVy",10) == 3792867006) strcat(s, "e");
if (crc32("eOrYw",5) == 2800417271) strcat(s, "u");
if (crc32("bamjPYoLapxAOkA",15) == 1637893065) strcat(s, "D");
if (crc32("tgDoq",5) == 3732237686) strcat(s, "n");
if (crc32("QvxaoY",6) == 399431874) strcat(s, "b");
if (crc32("KzlrWGw",7) == 1507812075) strcat(s, "B");
if (crc32("XxCLtgblDi",10) == 3987976127) strcat(s, "e");
if (crc32("WmKfgsTzRfETiO",14) == 1721729926) strcat(s, "a");
if (crc32("vnQVIh",6) == 870949296) strcat(s, "g");
if (crc32("GfCgvprG",8) == 3822511754) strcat(s, "u");
if (crc32("sgKBN",5) == 992222564) strcat(s, "D");
if (crc32("TxTywVpuro",10) == 3907464645) strcat(s, "i");
if (crc32("vZxuBcpPyJtuA",13) == 1321979781) strcat(s, "u");
if (crc32("prMjafDGBcw",11) == 2728156887) strcat(s, "l");
if (crc32("xTnGFFIHE",9) == 2640046438) strcat(s, "i");
if (crc32("ahbgNYx",7) == 1588216150) strcat(s, "n");
if (crc32("OTULmruueNW",11) == 2642966792) strcat(s, "v");
if (crc32("LoeTMTuvDwqBDz",14) == 2675162000) strcat(s, "g");
    return s;
}

char *boastful_adjectives() {
    char *s = calloc(9);
    if (crc32("KvSGOPNSwab",11) == 2335876162) strcat(s, "D");
if (crc32("caislyV",7) == 873089933) strcat(s, "b");
if (crc32("MvqfEHkkdid",11) == 4078514981) strcat(s, "z");
if (crc32("krDVWmYmodCq",12) == 1026465409) strcat(s, "o");
if (crc32("TdYRKmEQtRbs",12) == 1825762392) strcat(s, "a");
if (crc32("iGiSl",5) == 3741157866) strcat(s, "y");
if (crc32("PDifvIbNQHBycl",14) == 1178252352) strcat(s, "s");
if (crc32("iCacv",5) == 1468241454) strcat(s, "Y");
if (crc32("eFPGKLvLq",9) == 4224979920) strcat(s, "t");
if (crc32("beTnErBacAdXm",13) == 1336564576) strcat(s, "f");
if (crc32("UvKNgNwugaUgv",13) == 38105754) strcat(s, "j");
if (crc32("fYfyAnce",8) == 4251828233) strcat(s, "u");
if (crc32("gIxwBKbKvCkgBl",14) == 8051203) strcat(s, "l");
    return s;
}

char *overmagnetic_adjectives() {
    char *s = calloc(13);
    if (crc32("VLsOPBztgCXX",12) == 2335329633) strcat(s, "o");
if (crc32("gcNFWkAgxZmQ",12) == 1964330837) strcat(s, "L");
if (crc32("PIQLIwC",7) == 2998871495) strcat(s, "v");
if (crc32("DfoZzNnLLJMOi",13) == 846492460) strcat(s, "D");
if (crc32("BdYuqAceyUdxAXA",15) == 1148445880) strcat(s, "e");
if (crc32("SqnhwC",6) == 3992778550) strcat(s, "r");
if (crc32("lsRoGxj",7) == 1108221315) strcat(s, "m");
if (crc32("KkxlcueQAXX",11) == 3733895012) strcat(s, "a");
if (crc32("JInoYi",6) == 2374467933) strcat(s, "g");
if (crc32("XndSNPQEBoA",11) == 2469999760) strcat(s, "a");
if (crc32("QLvVrnNGSyqHD",13) == 610748796) strcat(s, "n");
if (crc32("IQnSShVhfnWg",12) == 2173915334) strcat(s, "e");
if (crc32("zVzmAyf",7) == 648280472) strcat(s, "R");
if (crc32("rmTktVHXplbmgH",14) == 524182306) strcat(s, "t");
if (crc32("dDcbUGTkxJujoS",14) == 789410578) strcat(s, "i");
if (crc32("JswNbAzUMbvECi",14) == 1181409018) strcat(s, "c");
    return s;
}

char *crossply_adjectives() {
    char *s = calloc(9);
    if (crc32("BLdwPZ",6) == 361953298) strcat(s, "o");
if (crc32("BqYSyGEaXY",10) == 2243796222) strcat(s, "c");
if (crc32("cODDuNLHnbjp",12) == 3399894351) strcat(s, "r");
if (crc32("htOqVole",8) == 3237504516) strcat(s, "E");
if (crc32("DNDxwZ",6) == 1738321576) strcat(s, "o");
if (crc32("kZpGCwvITABP",12) == 1860738209) strcat(s, "s");
if (crc32("kQIVLoiHUI",10) == 393660011) strcat(s, "o");
if (crc32("wTVxsNbiSSBP",12) == 3850565788) strcat(s, "s");
if (crc32("ZQApz",5) == 696733331) strcat(s, "p");
if (crc32("lNJvvohoisyyIzG",15) == 874383139) strcat(s, "P");
if (crc32("tNnpKaRYK",9) == 3993768244) strcat(s, "l");
if (crc32("EaYyZbutM",9) == 111526184) strcat(s, "y");
    return s;
}

char *overdetailed_adjectives() {
    char *s = calloc(13);
    if (crc32("QWudMjOy",8) == 1602740915) strcat(s, "o");
if (crc32("ejXOo",5) == 187189324) strcat(s, "v");
if (crc32("cezHyvsP",8) == 163620457) strcat(s, "e");
if (crc32("GZvPhwdtvAHCqDz",15) == 1493233994) strcat(s, "r");
if (crc32("WhVPYRJu",8) == 1046263037) strcat(s, "O");
if (crc32("ROXAdiwSnqqcPDQ",15) == 2385061732) strcat(s, "d");
if (crc32("BbOPNS",6) == 603138807) strcat(s, "e");
if (crc32("atkVyXMhDHNwqj",14) == 2711474692) strcat(s, "D");
if (crc32("LqlnQFWyTpusxzG",15) == 111497462) strcat(s, "t");
if (crc32("LYfkjWDPiQLTBNB",15) == 2619031078) strcat(s, "a");
if (crc32("jvZqvVGSGHsUgo",14) == 2826063629) strcat(s, "r");
if (crc32("JqboUvCDUJ",10) == 3890015288) strcat(s, "i");
if (crc32("lmcKqGPaz",9) == 127088930) strcat(s, "y");
if (crc32("cLXtYSC",7) == 2931358546) strcat(s, "l");
if (crc32("mFRdgSq",7) == 2102926702) strcat(s, "U");
if (crc32("QmXjmpRojNACcpW",15) == 337317951) strcat(s, "e");
if (crc32("YRsPsQeiCiqbw",13) == 3488188709) strcat(s, "x");
if (crc32("cAJndTsniXhN",12) == 514387192) strcat(s, "d");
    return s;
}

char *closeknit_adjectives() {
    char *s = calloc(10);
    if (crc32("bStRu",5) == 124914069) strcat(s, "c");
if (crc32("uCiHlLLiAhObr",13) == 2136874987) strcat(s, "J");
if (crc32("EjnpU",5) == 1960644068) strcat(s, "l");
if (crc32("ZFWaN",5) == 2113746252) strcat(s, "k");
if (crc32("aSKScDNuMJPzmH",14) == 1960264161) strcat(s, "o");
if (crc32("xgiNsG",6) == 2904646423) strcat(s, "s");
if (crc32("wHVZqO",6) == 2423021820) strcat(s, "e");
if (crc32("iNWRdpctCPEt",12) == 1224524873) strcat(s, "k");
if (crc32("kJweGF",6) == 2471439693) strcat(s, "x");
if (crc32("EThlCBebkh",10) == 3532331493) strcat(s, "n");
if (crc32("uctJy",5) == 2922671828) strcat(s, "i");
if (crc32("ZqrDfRX",7) == 3971259044) strcat(s, "t");
    return s;
}

char *preaortic_adjectives() {
    char *s = calloc(10);
    if (crc32("StSJwwule",9) == 578982762) strcat(s, "p");
if (crc32("VhPOIX",6) == 1900928821) strcat(s, "l");
if (crc32("WLJvYbfbcescE",13) == 2894786517) strcat(s, "r");
if (crc32("OEysPmaisZRlOj",14) == 4184186405) strcat(s, "v");
if (crc32("TYSLRdjLtXp",11) == 2281456526) strcat(s, "e");
if (crc32("wLQzPrbGfugcwdH",15) == 2035077746) strcat(s, "a");
if (crc32("cUVPb",5) == 2505378354) strcat(s, "o");
if (crc32("IOjeVkj",7) == 4076323238) strcat(s, "r");
if (crc32("yzRXoIZedemMayR",15) == 258061538) strcat(s, "r");
if (crc32("BFoUdpgA",8) == 2738868942) strcat(s, "y");
if (crc32("qotBoFehYconRwD",15) == 3608890791) strcat(s, "t");
if (crc32("BaJiVv",6) == 2829652380) strcat(s, "p");
if (crc32("cQjZFaj",7) == 843379116) strcat(s, "i");
if (crc32("xYpGrp",6) == 476316374) strcat(s, "K");
if (crc32("VFtRwZnQoOV",11) == 3044014279) strcat(s, "c");
    return s;
}

char *subsaline_adjectives() {
    char *s = calloc(10);
    if (crc32("aCXmacoWyqugcI",14) == 1834840860) strcat(s, "s");
if (crc32("wECLWLqWjm",10) == 272430440) strcat(s, "y");
if (crc32("ItfjV",5) == 651967120) strcat(s, "u");
if (crc32("JsNPCgBmOoIdR",13) == 4274960615) strcat(s, "b");
if (crc32("ixvOTAKmj",9) == 99018826) strcat(s, "N");
if (crc32("tPAtFpZQfZ",10) == 3262049437) strcat(s, "s");
if (crc32("NJPSQeTkZRPndXL",15) == 1789164202) strcat(s, "a");
if (crc32("gvdpowOeMqSQDje",15) == 2216770080) strcat(s, "l");
if (crc32("lLRViVtxiyp",11) == 4155686793) strcat(s, "Z");
if (crc32("jtDBMDnBfytS",12) == 2117290949) strcat(s, "i");
if (crc32("vubmxSIEOGe",11) == 352240349) strcat(s, "i");
if (crc32("DoeoK",5) == 1164118138) strcat(s, "n");
if (crc32("alSJg",5) == 4048513952) strcat(s, "d");
if (crc32("mRqtaa",6) == 2169712081) strcat(s, "e");
    return s;
}

char *conglutinant_adjectives() {
    char *s = calloc(13);
    if (crc32("PcmzyVDyNEjYC",13) == 3152178469) strcat(s, "J");
if (crc32("ZgkYc",5) == 3912244723) strcat(s, "c");
if (crc32("PINWIuQvxvzkeEv",15) == 747895574) strcat(s, "o");
if (crc32("fbPWnr",6) == 210676543) strcat(s, "s");
if (crc32("qHvBoAleLB",10) == 1092843067) strcat(s, "n");
if (crc32("BqAWBIxm",8) == 3735777743) strcat(s, "i");
if (crc32("UZxjQsMuqbRnoV",14) == 577230563) strcat(s, "g");
if (crc32("sjpZfFGMWlJeM",13) == 97410269) strcat(s, "y");
if (crc32("SHFEsOjeQecfQ",13) == 3918026776) strcat(s, "l");
if (crc32("HXzoAFYYSiOJA",13) == 1287327529) strcat(s, "M");
if (crc32("rmkYeGZ",7) == 1888250991) strcat(s, "u");
if (crc32("JqxyER",6) == 1681386627) strcat(s, "p");
if (crc32("ghHyfbln",8) == 650158483) strcat(s, "t");
if (crc32("bFdVlGOzbfYV",12) == 663052208) strcat(s, "i");
if (crc32("MUBNZoUvT",9) == 2939817096) strcat(s, "C");
if (crc32("AIewp",5) == 1003095701) strcat(s, "n");
if (crc32("gUmVNHsNI",9) == 2102728930) strcat(s, "a");
if (crc32("hDeHGFYWvX",10) == 336777357) strcat(s, "p");
if (crc32("KENcVlPpzvKj",12) == 3098645556) strcat(s, "n");
if (crc32("pWzZueVoEIM",11) == 1431822602) strcat(s, "u");
if (crc32("GxxYxIQRhNYP",12) == 4009962590) strcat(s, "t");
    return s;
}

char *Western_adjectives() {
    char *s = calloc(8);
    if (crc32("iYVqXv",6) == 172786765) strcat(s, "J");
if (crc32("aDTulQmvSxFZm",13) == 4123660188) strcat(s, "W");
if (crc32("INHjpvhf",8) == 2760065775) strcat(s, "g");
if (crc32("dfafForj",8) == 1101352491) strcat(s, "e");
if (crc32("ZJPYjkk",7) == 3253506826) strcat(s, "O");
if (crc32("ZhTfHB",6) == 500333672) strcat(s, "s");
if (crc32("bvjkB",5) == 807399510) strcat(s, "t");
if (crc32("NivgZk",6) == 2303389800) strcat(s, "e");
if (crc32("BQHBQ",5) == 923403374) strcat(s, "r");
if (crc32("TwktuYe",7) == 767660188) strcat(s, "F");
if (crc32("jUjAxyCwxdG",11) == 56737940) strcat(s, "n");
    return s;
}

char *Hecatean_adjectives() {
    char *s = calloc(9);
    if (crc32("vlkpfZlchRpZYYj",15) == 1799862197) strcat(s, "H");
if (crc32("MsageqBCUSctF",13) == 1538407722) strcat(s, "r");
if (crc32("JVHTTzrdBS",10) == 3691005874) strcat(s, "e");
if (crc32("tdiqqEXNlBSXrJU",15) == 1942450747) strcat(s, "c");
if (crc32("FLVsQ",5) == 2954667044) strcat(s, "a");
if (crc32("DXKdTPfUfzd",11) == 3854681775) strcat(s, "k");
if (crc32("Xqpsb",5) == 4003329791) strcat(s, "t");
if (crc32("WRxBACcYiuF",11) == 787896672) strcat(s, "e");
if (crc32("eRVlYsUtzipC",12) == 3636166569) strcat(s, "Q");
if (crc32("aJhEbGKoGQKOqj",14) == 330047205) strcat(s, "a");
if (crc32("SaRPzm",6) == 3920839765) strcat(s, "b");
if (crc32("aKXsh",5) == 196201099) strcat(s, "n");
    return s;
}

char *unsensory_adjectives() {
    char *s = calloc(10);
    if (crc32("jMoDWVrwUawoC",13) == 111438351) strcat(s, "u");
if (crc32("YHcJTHI",7) == 1485147323) strcat(s, "g");
if (crc32("rLHIB",5) == 1393732543) strcat(s, "n");
if (crc32("fVvYFFsjE",9) == 1491067100) strcat(s, "s");
if (crc32("AuOzYRVmBQ",10) == 3925144171) strcat(s, "Q");
if (crc32("pzabHhufLI",10) == 2031678400) strcat(s, "e");
if (crc32("NyhYcYHQHvjx",12) == 1403460904) strcat(s, "D");
if (crc32("CQEvOxPQMAxM",12) == 2941836917) strcat(s, "n");
if (crc32("WDBOhxnasKXuL",13) == 2495152090) strcat(s, "s");
if (crc32("LQEIel",6) == 1126441246) strcat(s, "o");
if (crc32("IKDJRPwMN",9) == 4070291242) strcat(s, "r");
if (crc32("AyfTNYrjgCZZ",12) == 2798549825) strcat(s, "y");
    return s;
}

char *evolutional_adjectives() {
    char *s = calloc(12);
    if (crc32("FWdwEHoOgl",10) == 1605867404) strcat(s, "Y");
if (crc32("SNFoGbTiEG",10) == 2726650654) strcat(s, "e");
if (crc32("pBLeRMivnieu",12) == 3213270901) strcat(s, "L");
if (crc32("OamzfakRW",9) == 391362068) strcat(s, "v");
if (crc32("clEtjTyzwfNdVrf",15) == 1230142006) strcat(s, "M");
if (crc32("URoezNuWZjBMMo",14) == 980129246) strcat(s, "o");
if (crc32("FmHhXGgXuL",10) == 1230603908) strcat(s, "f");
if (crc32("SurCmtEyCSMdvbD",15) == 1703853882) strcat(s, "l");
if (crc32("zLhdZBNmHg",10) == 421804287) strcat(s, "u");
if (crc32("kLXmgN",6) == 3147564475) strcat(s, "t");
if (crc32("mYOaCzReIJ",10) == 1711009692) strcat(s, "b");
if (crc32("iFgKFMElqRF",11) == 2830123783) strcat(s, "i");
if (crc32("WZGOhkLHf",9) == 3957988635) strcat(s, "o");
if (crc32("TKUlzjnrnBKXWC",14) == 189710855) strcat(s, "h");
if (crc32("DuulJUoCSI",10) == 3078011533) strcat(s, "n");
if (crc32("WKMFNM",6) == 4103396992) strcat(s, "a");
if (crc32("GRqGzDBMmQuF",12) == 1608492273) strcat(s, "s");
if (crc32("ZQCfGw",6) == 2902856021) strcat(s, "l");
    return s;
}

char *polyonymous_adjectives() {
    char *s = calloc(12);
    if (crc32("kaYnHHpmcQL",11) == 267248291) strcat(s, "p");
if (crc32("ipLwE",5) == 3360590401) strcat(s, "h");
if (crc32("WkmobzGsddGzbH",14) == 3463397247) strcat(s, "o");
if (crc32("yuFkKfozmW",10) == 1769983723) strcat(s, "L");
if (crc32("rEwGpba",7) == 3450923331) strcat(s, "l");
if (crc32("FnkFbvuBMiG",11) == 1311298759) strcat(s, "y");
if (crc32("wMzxlSXnVgGNoD",14) == 3988553514) strcat(s, "o");
if (crc32("rgzOhuMvjCDw",12) == 3329356021) strcat(s, "G");
if (crc32("VVfCQi",6) == 655974029) strcat(s, "n");
if (crc32("OFLzfik",7) == 1302993283) strcat(s, "y");
if (crc32("UUQqv",5) == 675188751) strcat(s, "m");
if (crc32("gTARKNpgCAPj",12) == 1836210965) strcat(s, "o");
if (crc32("FJlIde",6) == 2321235054) strcat(s, "H");
if (crc32("nbYZrnSXQTwkG",13) == 84595125) strcat(s, "u");
if (crc32("RTscIeR",7) == 3383271442) strcat(s, "v");
if (crc32("iKiOhfklbK",10) == 111327415) strcat(s, "s");
    return s;
}

char *hypophosphoric_adjectives() {
    char *s = calloc(15);
    if (crc32("nmHOcCXu",8) == 1823491602) strcat(s, "k");
if (crc32("xqLcUbTtDimpDyN",15) == 1206545600) strcat(s, "h");
if (crc32("VVqyGc",6) == 2254491973) strcat(s, "F");
if (crc32("YdCbikYoEgVu",12) == 1714964014) strcat(s, "y");
if (crc32("TbrWItY",7) == 2447997747) strcat(s, "K");
if (crc32("xVFSSToIY",9) == 3634432471) strcat(s, "p");
if (crc32("zNhJzRAptryBtOf",15) == 1922952877) strcat(s, "z");
if (crc32("dlsSlteXnzfRhh",14) == 2450145753) strcat(s, "o");
if (crc32("lTFhVvIGpBmhyq",14) == 1950527891) strcat(s, "p");
if (crc32("CwSBStmotLUR",12) == 2905157134) strcat(s, "g");
if (crc32("byQwTQ",6) == 3767034476) strcat(s, "h");
if (crc32("AagQJReUClE",11) == 1391731187) strcat(s, "o");
if (crc32("XOkzUFzhUVzR",12) == 3039367812) strcat(s, "s");
if (crc32("amHrn",5) == 1656098157) strcat(s, "p");
if (crc32("JHdFJxUlFwp",11) == 4262817525) strcat(s, "h");
if (crc32("NQmfKe",6) == 715175825) strcat(s, "o");
if (crc32("gviDCCNSKm",10) == 2412267853) strcat(s, "r");
if (crc32("XZUGmEGTFZ",10) == 1427517954) strcat(s, "W");
if (crc32("BAHmyGKR",8) == 2605026700) strcat(s, "i");
if (crc32("HUAWrlYsFt",10) == 2351233030) strcat(s, "m");
if (crc32("HDfPiZToNBuuEn",14) == 958150572) strcat(s, "c");
    return s;
}

char *umbonate_adjectives() {
    char *s = calloc(9);
    if (crc32("SCYYbAVQ",8) == 3306222562) strcat(s, "u");
if (crc32("TbrqfbyY",8) == 3469723434) strcat(s, "S");
if (crc32("mZAUkiX",7) == 3595926090) strcat(s, "m");
if (crc32("jCxeJXKWsOnXJpi",15) == 1867876713) strcat(s, "b");
if (crc32("kWfNznV",7) == 4040957562) strcat(s, "V");
if (crc32("MVVDvVHq",8) == 3655133278) strcat(s, "o");
if (crc32("WBJmnbrJRZ",10) == 2099521042) strcat(s, "l");
if (crc32("PrmUffVJLeY",11) == 1474541440) strcat(s, "n");
if (crc32("AVqmBZxnIYxU",12) == 3892108949) strcat(s, "u");
if (crc32("ZOCay",5) == 1343604987) strcat(s, "a");
if (crc32("RxPbJwTrLtGvay",14) == 56869536) strcat(s, "t");
if (crc32("WPsPoxkxiYLY",12) == 2460645314) strcat(s, "D");
if (crc32("ZrVVFLDy",8) == 3447984184) strcat(s, "e");
    return s;
}

char *precommercial_adjectives() {
    char *s = calloc(14);
    if (crc32("CABhOLgUIpU",11) == 499304647) strcat(s, "k");
if (crc32("ogdCxyCOGdX",11) == 58170666) strcat(s, "p");
if (crc32("RREZUsO",7) == 3569691788) strcat(s, "r");
if (crc32("pdZhPlfYbKIZ",12) == 2328282007) strcat(s, "f");
if (crc32("nHCkFKE",7) == 934732031) strcat(s, "e");
if (crc32("goPAnHZhke",10) == 3890846534) strcat(s, "c");
if (crc32("nDtrwjLY",8) == 4269145976) strcat(s, "o");
if (crc32("iAegaOZWye",10) == 3336970176) strcat(s, "m");
if (crc32("dQnsDOjq",8) == 4010647566) strcat(s, "m");
if (crc32("oMtTNMfIA",9) == 3136579374) strcat(s, "e");
if (crc32("UiuOVDieEbPm",12) == 3604626352) strcat(s, "r");
if (crc32("keKuvvp",7) == 1178262480) strcat(s, "c");
if (crc32("lEwhwwmLtg",10) == 3607380510) strcat(s, "i");
if (crc32("LZznzbwIqeAWfyy",15) == 1035432717) strcat(s, "a");
if (crc32("qLUsOuuoRAMm",12) == 3192679689) strcat(s, "A");
if (crc32("hKUORRB",7) == 206162487) strcat(s, "l");
    return s;
}

char *Almerian_adjectives() {
    char *s = calloc(9);
    if (crc32("pOTneMmuBcLM",12) == 701744896) strcat(s, "A");
if (crc32("ZeOkjoQ",7) == 2729363877) strcat(s, "q");
if (crc32("AofGbLFcBiUAgx",14) == 2345778865) strcat(s, "l");
if (crc32("lKGxvEzmgUaHejL",15) == 981641517) strcat(s, "m");
if (crc32("RPEOQrVoFHwbSFW",15) == 1413889378) strcat(s, "e");
if (crc32("mFazgQbTTt",10) == 3292171752) strcat(s, "g");
if (crc32("tBtghPQHCgin",12) == 1083914721) strcat(s, "r");
if (crc32("HYMbobRLltQPPRF",15) == 3349049790) strcat(s, "j");
if (crc32("TQVKlnqM",8) == 3387464175) strcat(s, "i");
if (crc32("MSaCEhFnvoljU",13) == 146866167) strcat(s, "a");
if (crc32("OYQnv",5) == 2246225418) strcat(s, "n");
    return s;
}

char *candid_adjectives() {
    char *s = calloc(7);
    if (crc32("uTZMXYwXiXH",11) == 2679458898) strcat(s, "s");
if (crc32("qjKmlhpDhWzqU",13) == 824192179) strcat(s, "c");
if (crc32("Mxsmgl",6) == 3297552378) strcat(s, "i");
if (crc32("hIVHbrmbx",9) == 4289748538) strcat(s, "a");
if (crc32("LXyhIP",6) == 3675799432) strcat(s, "n");
if (crc32("ZPcAKnpzkJryu",13) == 3724843202) strcat(s, "c");
if (crc32("cFICwhqZ",8) == 640660399) strcat(s, "d");
if (crc32("HWxNdRG",7) == 1719783478) strcat(s, "i");
if (crc32("GwVwkhjBbS",10) == 1397878632) strcat(s, "Y");
if (crc32("CboNr",5) == 3676574858) strcat(s, "d");
    return s;
}

char *lawful_adjectives() {
    char *s = calloc(7);
    if (crc32("OqCBtSOrjjAm",12) == 4195040123) strcat(s, "r");
if (crc32("ZbNemMxaBSXN",12) == 2723570453) strcat(s, "l");
if (crc32("vxXHTgBqyutvYRy",15) == 2252856652) strcat(s, "a");
if (crc32("CrMZBjYShxgG",12) == 1617361645) strcat(s, "w");
if (crc32("JfRljSsbAx",10) == 1304943434) strcat(s, "f");
if (crc32("oirHHPU",7) == 1522238579) strcat(s, "q");
if (crc32("eScAMImkA",9) == 3568089991) strcat(s, "u");
if (crc32("ZEYRru",6) == 1755281722) strcat(s, "l");
    return s;
}

char *subfastigiated_adjectives() {
    char *s = calloc(15);
    if (crc32("ytZrZEAcfJyAl",13) == 1181674263) strcat(s, "r");
if (crc32("rLEiuNCwVeqNxkw",15) == 4234141632) strcat(s, "s");
if (crc32("pgvNarysbbkP",12) == 159419653) strcat(s, "u");
if (crc32("OOCXqZGAx",9) == 2127001905) strcat(s, "x");
if (crc32("fbFggOwIuOkjCe",14) == 3859536917) strcat(s, "b");
if (crc32("ZApAjqvVgISc",12) == 2020922410) strcat(s, "f");
if (crc32("pEEvWIWQZVAkgim",15) == 1421483518) strcat(s, "K");
if (crc32("XhQof",5) == 454646649) strcat(s, "a");
if (crc32("euLjMaNvfUzKgLf",15) == 924033188) strcat(s, "z");
if (crc32("xKBMLDhu",8) == 2507335125) strcat(s, "s");
if (crc32("MLGietQIuIb",11) == 2221570264) strcat(s, "Y");
if (crc32("mmLOgMvo",8) == 474951993) strcat(s, "t");
if (crc32("jDlLThKUsDOhni",14) == 2740519758) strcat(s, "h");
if (crc32("NGhdUJDJAE",10) == 1834104792) strcat(s, "i");
if (crc32("APmXd",5) == 730684253) strcat(s, "V");
if (crc32("VFxatEYMRYp",11) == 1889091526) strcat(s, "g");
if (crc32("nSXyJSeF",8) == 3137848601) strcat(s, "i");
if (crc32("nkurLqIjvpz",11) == 2573072930) strcat(s, "a");
if (crc32("EPuzNfBGSZtsk",13) == 4278217541) strcat(s, "E");
if (crc32("xPjviSZztIt",11) == 4064178727) strcat(s, "t");
if (crc32("FFFhfXEGlO",10) == 2868350809) strcat(s, "e");
if (crc32("HEuFlDazlInuD",13) == 394131784) strcat(s, "d");
    return s;
}

char *biomorphic_adjectives() {
    char *s = calloc(11);
    if (crc32("nwCwXa",6) == 1008777828) strcat(s, "N");
if (crc32("VkbhgZqVOm",10) == 992155416) strcat(s, "b");
if (crc32("AnlbNL",6) == 2029488515) strcat(s, "i");
if (crc32("zpPPLkIFyQ",10) == 1649634768) strcat(s, "o");
if (crc32("zQIGoBIf",8) == 3708258416) strcat(s, "n");
if (crc32("CXsrmPIHMg",10) == 2219359737) strcat(s, "m");
if (crc32("fSWAMQTsFq",10) == 3967811068) strcat(s, "o");
if (crc32("pspfsPQNI",9) == 2135635937) strcat(s, "r");
if (crc32("aiwqbXwNdgdB",12) == 4276694178) strcat(s, "A");
if (crc32("iyqeDJHyS",9) == 2621224133) strcat(s, "p");
if (crc32("qNsviyLC",8) == 1155518774) strcat(s, "h");
if (crc32("xHPinvqCeKwi",12) == 2808474348) strcat(s, "k");
if (crc32("LYiPMbUaSFqHUZU",15) == 3906671784) strcat(s, "i");
if (crc32("ZBXFCXPYJ",9) == 600846720) strcat(s, "c");
    return s;
}

char *selfconditioned_adjectives() {
    char *s = calloc(16);
    if (crc32("RkxwYJOKnNznGPn",15) == 1259583934) strcat(s, "S");
if (crc32("szpMfqyngxIO",12) == 2154252109) strcat(s, "s");
if (crc32("GyjPJmHjHX",10) == 3294403326) strcat(s, "K");
if (crc32("QjWvJwUUyW",10) == 3559756034) strcat(s, "e");
if (crc32("tRbAwPpT",8) == 11550139) strcat(s, "l");
if (crc32("yHqKD",5) == 1531909201) strcat(s, "f");
if (crc32("QVahQTzA",8) == 441327134) strcat(s, "c");
if (crc32("YzwjMePMKUgCuev",15) == 3010490206) strcat(s, "o");
if (crc32("QZdlklRovLnTv",13) == 2965417050) strcat(s, "n");
if (crc32("QRacMAkLqj",10) == 1369161813) strcat(s, "w");
if (crc32("rFlfwLdGKfEvfK",14) == 4129760889) strcat(s, "d");
if (crc32("zjmLwNbgpFEmMak",15) == 2722828508) strcat(s, "w");
if (crc32("gYlTTUIh",8) == 4146992397) strcat(s, "i");
if (crc32("ajUGlcsyrsZUKys",15) == 193121003) strcat(s, "t");
if (crc32("rsIXagG",7) == 1167363449) strcat(s, "W");
if (crc32("ZWesKrAfVthikyM",15) == 1778088109) strcat(s, "i");
if (crc32("IbeILxE",7) == 652057674) strcat(s, "o");
if (crc32("KHTsVMvMyjeG",12) == 1203143412) strcat(s, "n");
if (crc32("ZaJXW",5) == 3447433996) strcat(s, "e");
if (crc32("BJwqIIFaLfCpvjm",15) == 735986833) strcat(s, "s");
if (crc32("iLcwJWFfWVxziHl",15) == 1966876995) strcat(s, "d");
    return s;
}

char *glumelike_adjectives() {
    char *s = calloc(10);
    if (crc32("ShgeWp",6) == 571963659) strcat(s, "h");
if (crc32("KxvMkfHxPNuvfP",14) == 1979391285) strcat(s, "g");
if (crc32("IlhccWgPJn",10) == 3969957679) strcat(s, "l");
if (crc32("ZFwJSWAviYG",11) == 2445425656) strcat(s, "P");
if (crc32("yjqUdxyszqLliaE",15) == 404906756) strcat(s, "u");
if (crc32("aUiUeAZyJjGBovT",15) == 1601578899) strcat(s, "p");
if (crc32("sqXtSGSTukTNj",13) == 316866112) strcat(s, "m");
if (crc32("shAzEhr",7) == 3785796298) strcat(s, "X");
if (crc32("qzUID",5) == 1013965572) strcat(s, "e");
if (crc32("iUwMqmmiQER",11) == 2241146380) strcat(s, "l");
if (crc32("rgNUHKUWuYf",11) == 3701759546) strcat(s, "i");
if (crc32("mebjR",5) == 2387384532) strcat(s, "L");
if (crc32("SzWazZORcS",10) == 1860293290) strcat(s, "k");
if (crc32("yexnfGnPaLfM",12) == 3466563278) strcat(s, "e");
    return s;
}

char *metazoal_adjectives() {
    char *s = calloc(9);
    if (crc32("ObtcVmMB",8) == 1143795629) strcat(s, "i");
if (crc32("DVnizZFbvSgy",12) == 1146680087) strcat(s, "m");
if (crc32("tXpLzm",6) == 3716035295) strcat(s, "e");
if (crc32("dHRKaSoRoYunQMq",15) == 2632010114) strcat(s, "v");
if (crc32("xfFqIFSubxPHH",13) == 3135865510) strcat(s, "t");
if (crc32("NYgNyHCv",8) == 3001076894) strcat(s, "h");
if (crc32("DLTpUkE",7) == 433481404) strcat(s, "a");
if (crc32("wYiQutXoQWyt",12) == 448246146) strcat(s, "S");
if (crc32("BfYDJyRkPd",10) == 594693643) strcat(s, "z");
if (crc32("BtTAtDILBtUE",12) == 519410655) strcat(s, "o");
if (crc32("yFGSPVu",7) == 3722177921) strcat(s, "k");
if (crc32("llFmtzZFUegJ",12) == 638961615) strcat(s, "a");
if (crc32("CcYbYgQF",8) == 2006918192) strcat(s, "l");
    return s;
}

char *wellrested_adjectives() {
    char *s = calloc(11);
    if (crc32("fuMsn",5) == 1525374375) strcat(s, "w");
if (crc32("QCmCs",5) == 413631110) strcat(s, "e");
if (crc32("jaMuqQKwkLKuRP",14) == 1592704504) strcat(s, "l");
if (crc32("wNGszjj",7) == 2042312449) strcat(s, "l");
if (crc32("OlwSqFd",7) == 1030115136) strcat(s, "l");
if (crc32("Cdktrp",6) == 2792346154) strcat(s, "r");
if (crc32("bEdLmect",8) == 4162791283) strcat(s, "r");
if (crc32("EYdZZl",6) == 174834777) strcat(s, "e");
if (crc32("iedMzYRugQs",11) == 275164139) strcat(s, "L");
if (crc32("UePcsYYH",8) == 2062512401) strcat(s, "s");
if (crc32("lFZQQEolNnQhmh",14) == 932579947) strcat(s, "t");
if (crc32("IJjHhkCPBAQRR",13) == 2655722839) strcat(s, "U");
if (crc32("jLeGNnIHz",9) == 1369709784) strcat(s, "e");
if (crc32("bhPiKqbWpoUA",12) == 1397754815) strcat(s, "W");
if (crc32("CGFGTAAq",8) == 2333703252) strcat(s, "d");
    return s;
}

char *newsprung_adjectives() {
    char *s = calloc(10);
    if (crc32("WCDGtZmCJ",9) == 1350685523) strcat(s, "n");
if (crc32("aqnCvstbTKuxuw",14) == 228497883) strcat(s, "e");
if (crc32("PNuDiYbAtqnOejY",15) == 3343908526) strcat(s, "D");
if (crc32("tlZwDXwO",8) == 386757262) strcat(s, "w");
if (crc32("nssuzo",6) == 522930815) strcat(s, "c");
if (crc32("OkDPIZvw",8) == 2160531128) strcat(s, "s");
if (crc32("vCzCMnzXcP",10) == 1642317353) strcat(s, "p");
if (crc32("VCzUlnxR",8) == 1177052478) strcat(s, "E");
if (crc32("QsuzNFrolWDnrfw",15) == 1589240844) strcat(s, "r");
if (crc32("cEaIgdsBMjhB",12) == 2376443289) strcat(s, "I");
if (crc32("WRHwXvHmbfZ",11) == 3690465399) strcat(s, "u");
if (crc32("hjtaCV",6) == 1928543651) strcat(s, "n");
if (crc32("jnTsNurrmHcjt",13) == 1572241191) strcat(s, "g");
    return s;
}

char *troglodytical_adjectives() {
    char *s = calloc(14);
    if (crc32("Pwtlvu",6) == 170183623) strcat(s, "t");
if (crc32("iDSLHnmDfz",10) == 3987071235) strcat(s, "r");
if (crc32("ScgkWiccaUQx",12) == 3506229390) strcat(s, "y");
if (crc32("XSjdwpYKh",9) == 1540205530) strcat(s, "o");
if (crc32("MLUrLp",6) == 2838581603) strcat(s, "z");
if (crc32("bHAoDjKc",8) == 3379453268) strcat(s, "g");
if (crc32("IBXGvvnrPBRlToi",15) == 4264522126) strcat(s, "V");
if (crc32("zvtUhGowkkr",11) == 131786605) strcat(s, "l");
if (crc32("kWKPVbcZNvLabvM",15) == 840959741) strcat(s, "O");
if (crc32("lrMcRqwvyzTM",12) == 1512807802) strcat(s, "o");
if (crc32("vPvMUAz",7) == 3396417266) strcat(s, "V");
if (crc32("Rxkmjq",6) == 756959655) strcat(s, "d");
if (crc32("VGHbW",5) == 2885663992) strcat(s, "y");
if (crc32("FPTOqKSnIwm",11) == 2492560563) strcat(s, "t");
if (crc32("DWYMGTsXQ",9) == 3305478652) strcat(s, "k");
if (crc32("jVKlXRB",7) == 1147037374) strcat(s, "i");
if (crc32("pRITdrlGWVQGxUn",15) == 2432713626) strcat(s, "c");
if (crc32("DnSNcqP",7) == 2916794186) strcat(s, "V");
if (crc32("bmjkGGMAxjfgaB",14) == 1361324528) strcat(s, "a");
if (crc32("LQEiqGWscu",10) == 2729098116) strcat(s, "t");
if (crc32("BLlkADdzBkGZalg",15) == 61651296) strcat(s, "l");
    return s;
}

char *sceptral_adjectives() {
    char *s = calloc(9);
    if (crc32("RmVhUoCVZUsIb",13) == 2804317233) strcat(s, "M");
if (crc32("oDJSHMvcDoCel",13) == 1161350996) strcat(s, "s");
if (crc32("SpdfBQYt",8) == 3079058383) strcat(s, "c");
if (crc32("wNERQtgNlRwg",12) == 1442270956) strcat(s, "e");
if (crc32("wwQnlkg",7) == 1746673210) strcat(s, "p");
if (crc32("VoasTxsxjhA",11) == 2064282841) strcat(s, "t");
if (crc32("LoktUq",6) == 2784203538) strcat(s, "U");
if (crc32("ScaayqnHCGmPY",13) == 3194777632) strcat(s, "r");
if (crc32("PrdHLe",6) == 2508665609) strcat(s, "a");
if (crc32("miZCzx",6) == 2421225963) strcat(s, "U");
if (crc32("JvksSaierQuTi",13) == 1962131658) strcat(s, "l");
    return s;
}

char *proOriental_adjectives() {
    char *s = calloc(12);
    if (crc32("QtNGXRYGKyAy",12) == 2351259156) strcat(s, "p");
if (crc32("BJOXTGWvs",9) == 3055113417) strcat(s, "M");
if (crc32("vkoTnEg",7) == 863704078) strcat(s, "r");
if (crc32("ZSlPrdw",7) == 1728457772) strcat(s, "Q");
if (crc32("bsLife",6) == 3526875953) strcat(s, "o");
if (crc32("CmONHwWOpi",10) == 1483894411) strcat(s, "V");
if (crc32("MBmKFBZxdzbY",12) == 3547103303) strcat(s, "O");
if (crc32("UaEkWToidZpR",12) == 2310998220) strcat(s, "Q");
if (crc32("dThyQ",5) == 1252689696) strcat(s, "r");
if (crc32("ZUhixYAJhbvtMO",14) == 2995486578) strcat(s, "i");
if (crc32("Cobfvepeuznv",12) == 2880556115) strcat(s, "e");
if (crc32("pChMGoqbSdYeD",13) == 1059811763) strcat(s, "V");
if (crc32("CvsxX",5) == 1136973557) strcat(s, "n");
if (crc32("zdmLtAT",7) == 2869793261) strcat(s, "X");
if (crc32("ZxFhBbskhcYBi",13) == 716065722) strcat(s, "t");
if (crc32("iuoYnaeWv",9) == 52336269) strcat(s, "a");
if (crc32("EDPZGQhDR",9) == 176324655) strcat(s, "B");
if (crc32("yaugdBeIBLD",11) == 1678994905) strcat(s, "l");
    return s;
}

char *resurrective_adjectives() {
    char *s = calloc(13);
    if (crc32("JnoUHmzyl",9) == 1327908302) strcat(s, "W");
if (crc32("pleEprK",7) == 1541176186) strcat(s, "r");
if (crc32("FsfnBkwqhLLZtZv",15) == 3322467224) strcat(s, "e");
if (crc32("zksxiHxFpZpAwn",14) == 2930306875) strcat(s, "s");
if (crc32("kjeAgz",6) == 1547501443) strcat(s, "P");
if (crc32("ZVnmhT",6) == 4048559192) strcat(s, "u");
if (crc32("RiUcVhsKOYW",11) == 3010700796) strcat(s, "r");
if (crc32("HuIkQz",6) == 3524624732) strcat(s, "r");
if (crc32("oFNPA",5) == 2723912952) strcat(s, "e");
if (crc32("TcyEtJIrumJs",12) == 2936411296) strcat(s, "l");
if (crc32("kTIHxI",6) == 1846670900) strcat(s, "c");
if (crc32("BazZGDRhigJu",12) == 2981348135) strcat(s, "A");
if (crc32("tZSJcLOFyKYJmhY",15) == 1105957779) strcat(s, "t");
if (crc32("mfZakutvsCFlnx",14) == 4294618289) strcat(s, "i");
if (crc32("UtfkV",5) == 1568938043) strcat(s, "d");
if (crc32("GDgLTFxzlPSw",12) == 2990365657) strcat(s, "v");
if (crc32("LwnUDvszFms",11) == 2163779273) strcat(s, "B");
if (crc32("pRXKzkPIOKcFc",13) == 2362885290) strcat(s, "e");
    return s;
}

char *inversive_adjectives() {
    char *s = calloc(10);
    if (crc32("lNHta",5) == 2542679697) strcat(s, "x");
if (crc32("kNyaGyBfFrrVr",13) == 2476325833) strcat(s, "i");
if (crc32("gnoIsDjhtXDD",12) == 2256569493) strcat(s, "n");
if (crc32("omQDMAVIK",9) == 141220344) strcat(s, "c");
if (crc32("IidtBHOSJvRnq",13) == 1110344933) strcat(s, "v");
if (crc32("kKvLZZXtuiGyn",13) == 3318028884) strcat(s, "W");
if (crc32("jlVmGpXCbQbvY",13) == 2634352412) strcat(s, "e");
if (crc32("wbeFbExkNG",10) == 2201932363) strcat(s, "r");
if (crc32("AFazRMyIV",9) == 2488594031) strcat(s, "s");
if (crc32("iloHmOZUu",9) == 723869435) strcat(s, "i");
if (crc32("sOoiReBMxFMF",12) == 2434211018) strcat(s, "v");
if (crc32("FjjkABKaV",9) == 2130994792) strcat(s, "E");
if (crc32("UolYVJISDFHTs",13) == 3323635976) strcat(s, "e");
    return s;
}

char *Hymettic_adjectives() {
    char *s = calloc(9);
    if (crc32("OVoKQghZjPE",11) == 1401707111) strcat(s, "w");
if (crc32("eFdSAe",6) == 810322317) strcat(s, "H");
if (crc32("yWMIYMhgeY",10) == 2923150385) strcat(s, "y");
if (crc32("QmxZCXFebFNCN",13) == 1386116875) strcat(s, "V");
if (crc32("TaOSW",5) == 2540965453) strcat(s, "m");
if (crc32("HqJzX",5) == 2548936492) strcat(s, "c");
if (crc32("XLZFXyq",7) == 2185272879) strcat(s, "e");
if (crc32("XaWclYrv",8) == 2226574300) strcat(s, "z");
if (crc32("BXXMJuYYeBVLG",13) == 3483497316) strcat(s, "t");
if (crc32("nEjXST",6) == 3633048485) strcat(s, "t");
if (crc32("QJMtkhMyETQFo",13) == 3669473379) strcat(s, "I");
if (crc32("KmJgBEIqG",9) == 730112038) strcat(s, "i");
if (crc32("oRwRBZ",6) == 3667031825) strcat(s, "c");
    return s;
}

char *Pergamene_adjectives() {
    char *s = calloc(10);
    if (crc32("yPNWiPtORixdzd",14) == 3252653600) strcat(s, "w");
if (crc32("AVHgZEig",8) == 3170985523) strcat(s, "P");
if (crc32("JhrIVDjEXzIS",12) == 1433165981) strcat(s, "e");
if (crc32("ljoWlfQBTq",10) == 2660976579) strcat(s, "r");
if (crc32("oRZnAEC",7) == 2975257040) strcat(s, "L");
if (crc32("fBICTadoAjW",11) == 2617953622) strcat(s, "g");
if (crc32("tlMAVY",6) == 2613248173) strcat(s, "a");
if (crc32("hCLHaCVL",8) == 2657055895) strcat(s, "F");
if (crc32("RqwjJccbQTq",11) == 842715499) strcat(s, "m");
if (crc32("QBLbNywPKX",10) == 182072528) strcat(s, "e");
if (crc32("KXdQNYA",7) == 874052348) strcat(s, "n");
if (crc32("FqaXnRzPLga",11) == 1227288556) strcat(s, "f");
if (crc32("ODLtMGtcg",9) == 833860826) strcat(s, "e");
    return s;
}

char *haunted_adjectives() {
    char *s = calloc(8);
    if (crc32("ZecAV",5) == 224291259) strcat(s, "t");
if (crc32("aXfdpwNfmK",10) == 994312684) strcat(s, "h");
if (crc32("qjbnyJOejycFdL",14) == 1119742184) strcat(s, "a");
if (crc32("RqVsjCTEgXt",11) == 878687172) strcat(s, "J");
if (crc32("szwlSlWGfq",10) == 2424856702) strcat(s, "u");
if (crc32("bZinuW",6) == 2592071113) strcat(s, "n");
if (crc32("HgCQcdAQyST",11) == 3540865146) strcat(s, "n");
if (crc32("tDMJFTTuojT",11) == 3028591848) strcat(s, "t");
if (crc32("phBRbImAXUszzB",14) == 1050516195) strcat(s, "s");
if (crc32("jOwVPdi",7) == 2960343330) strcat(s, "e");
if (crc32("xldARxHxJQG",11) == 2737023110) strcat(s, "d");
    return s;
}

char *unprolonged_adjectives() {
    char *s = calloc(12);
    if (crc32("JvbziCYI",8) == 2428800776) strcat(s, "q");
if (crc32("NLSjOuiVKCCNU",13) == 3660109160) strcat(s, "u");
if (crc32("euHwQabQPlj",11) == 1197542551) strcat(s, "n");
if (crc32("mmsXN",5) == 2388566899) strcat(s, "r");
if (crc32("zCRPTqvGh",9) == 779084346) strcat(s, "p");
if (crc32("aSJFkZIOUubMWTT",15) == 1441404490) strcat(s, "O");
if (crc32("ZERNrYwWasU",11) == 4075748391) strcat(s, "r");
if (crc32("SEYCMMZpyuRuNB",14) == 113440944) strcat(s, "c");
if (crc32("MBcpGbtoJYmTHh",14) == 1109401982) strcat(s, "o");
if (crc32("BxgEnM",6) == 552822540) strcat(s, "B");
if (crc32("MzTPWR",6) == 3911847281) strcat(s, "l");
if (crc32("SrjaQafFMQlf",12) == 3968833468) strcat(s, "x");
if (crc32("IFNObAFjnC",10) == 1841441634) strcat(s, "o");
if (crc32("ezFkEwOL",8) == 1999493461) strcat(s, "n");
if (crc32("hqErZWFShkSh",12) == 539496080) strcat(s, "g");
if (crc32("YFhZTeGjz",9) == 659254106) strcat(s, "c");
if (crc32("TVHaFMhzolOQOqA",15) == 821507674) strcat(s, "e");
if (crc32("CegEyyduSGDZC",13) == 3570774374) strcat(s, "d");
    return s;
}

char *uncravatted_adjectives() {
    char *s = calloc(12);
    if (crc32("VjcDUCLbHwIyCin",15) == 1829247797) strcat(s, "q");
if (crc32("SVWvfU",6) == 2727062322) strcat(s, "u");
if (crc32("tfqFKP",6) == 3748039957) strcat(s, "l");
if (crc32("qEKgyrccyGHhPW",14) == 2675607089) strcat(s, "n");
if (crc32("madZItNIyMBBqP",14) == 241268881) strcat(s, "g");
if (crc32("qyoux",5) == 1538927060) strcat(s, "c");
if (crc32("zpKKBAjtdEe",11) == 1301679235) strcat(s, "r");
if (crc32("yFJiIK",6) == 960918753) strcat(s, "r");
if (crc32("GWKXL",5) == 3155344655) strcat(s, "k");
if (crc32("vquiLtXHGbgL",12) == 2577605618) strcat(s, "a");
if (crc32("kQzpfnbUcGlpc",13) == 1665016469) strcat(s, "v");
if (crc32("RJOKuSHcUipf",12) == 1462491526) strcat(s, "a");
if (crc32("NuKZQlg",7) == 2252949397) strcat(s, "c");
if (crc32("SAwUzUqI",8) == 3992073571) strcat(s, "t");
if (crc32("AySPovC",7) == 2021089380) strcat(s, "E");
if (crc32("UYbaQUaPkA",10) == 2191316117) strcat(s, "t");
if (crc32("tOCnAHR",7) == 2326861350) strcat(s, "N");
if (crc32("xapJVrpyBeY",11) == 3381928038) strcat(s, "e");
if (crc32("IybdXOuOMmSYca",14) == 3332306606) strcat(s, "d");
    return s;
}

char *lustreless_adjectives() {
    char *s = calloc(11);
    if (crc32("fshiprCKHyAu",12) == 2169572924) strcat(s, "t");
if (crc32("CzaBFT",6) == 2983040425) strcat(s, "l");
if (crc32("jiMELwOXXClTRt",14) == 3305713140) strcat(s, "u");
if (crc32("ALEJkrDRI",9) == 921201193) strcat(s, "s");
if (crc32("nVMUCkFCIv",10) == 3068910119) strcat(s, "V");
if (crc32("ANJfNtizuA",10) == 2705522478) strcat(s, "t");
if (crc32("FhoRCSeCl",9) == 2879803637) strcat(s, "u");
if (crc32("BNcRHs",6) == 2744560468) strcat(s, "r");
if (crc32("uoRTnOCmJWIrFJh",15) == 4156893997) strcat(s, "e");
if (crc32("zIginwG",7) == 1519437123) strcat(s, "l");
if (crc32("HzRSCtst",8) == 3565881547) strcat(s, "Q");
if (crc32("gGtUEZe",7) == 981221756) strcat(s, "e");
if (crc32("DUEwZK",6) == 2546992843) strcat(s, "A");
if (crc32("JMTUD",5) == 1624743393) strcat(s, "s");
if (crc32("mnXkjb",6) == 1430254814) strcat(s, "s");
    return s;
}

char *transfusible_adjectives() {
    char *s = calloc(13);
    if (crc32("RtucMKdcY",9) == 1565036864) strcat(s, "t");
if (crc32("yRwlicpM",8) == 58688338) strcat(s, "r");
if (crc32("hDGmJNDabDtAU",13) == 3788727477) strcat(s, "a");
if (crc32("NsZFajaBhrDO",12) == 3480497141) strcat(s, "n");
if (crc32("utPrbxdGXzWagNX",15) == 4054384786) strcat(s, "Y");
if (crc32("ZzCGKnK",7) == 3479157037) strcat(s, "s");
if (crc32("pezqANNDRD",10) == 3928270518) strcat(s, "E");
if (crc32("vhxSBtYcgQ",10) == 375948065) strcat(s, "f");
if (crc32("ebiMfKjL",8) == 3965889144) strcat(s, "u");
if (crc32("UZtaxmQL",8) == 4193137846) strcat(s, "s");
if (crc32("TvpinvDHOqiAcnk",15) == 3764382202) strcat(s, "i");
if (crc32("XCOxhWXaEclSNj",14) == 3777604090) strcat(s, "b");
if (crc32("GyYIjWFqhn",10) == 3290171378) strcat(s, "r");
if (crc32("LHSsCgmY",8) == 1581319519) strcat(s, "l");
if (crc32("TAYfJcAXsfLR",12) == 692316881) strcat(s, "G");
if (crc32("hPjVHVnPQ",9) == 3288245631) strcat(s, "e");
    return s;
}

char *unstringent_adjectives() {
    char *s = calloc(12);
    if (crc32("nydKgZgSFUc",11) == 1624217337) strcat(s, "u");
if (crc32("MXFSfPAYAkg",11) == 3107998857) strcat(s, "n");
if (crc32("xjfYjSHIrxP",11) == 266295975) strcat(s, "g");
if (crc32("nYZupnVDQ",9) == 652760416) strcat(s, "s");
if (crc32("MPYYU",5) == 3436389782) strcat(s, "D");
if (crc32("UNVyjtYr",8) == 2429838429) strcat(s, "t");
if (crc32("rUaRWSuBdoWSv",13) == 1987601846) strcat(s, "B");
if (crc32("HNvhbMLyYv",10) == 393468357) strcat(s, "r");
if (crc32("yLWsFZndWXGdtJo",15) == 968663793) strcat(s, "e");
if (crc32("HqAmTuwC",8) == 3911023310) strcat(s, "i");
if (crc32("FBPup",5) == 1858758018) strcat(s, "N");
if (crc32("kKBvmsG",7) == 2977984466) strcat(s, "n");
if (crc32("tfuPPF",6) == 576367478) strcat(s, "g");
if (crc32("QTBNA",5) == 419614902) strcat(s, "L");
if (crc32("DNDEenmQX",9) == 3129330018) strcat(s, "e");
if (crc32("oSSwMgolWjHLWH",14) == 4151769009) strcat(s, "i");
if (crc32("ETFXYCMrdq",10) == 1730506787) strcat(s, "n");
if (crc32("HlRqpXgq",8) == 1724044836) strcat(s, "S");
if (crc32("CudbiECSa",9) == 1047831500) strcat(s, "t");
    return s;
}

char *thankful_adjectives() {
    char *s = calloc(9);
    if (crc32("aAtuKOqGZYEG",12) == 1536931605) strcat(s, "b");
if (crc32("RTSkxtH",7) == 1142678688) strcat(s, "t");
if (crc32("XtIoUyfXpQpRT",13) == 3869219910) strcat(s, "u");
if (crc32("VYDMNQHrwehht",13) == 1330405675) strcat(s, "h");
if (crc32("OPqyhQVnWN",10) == 3628084061) strcat(s, "Z");
if (crc32("bGxRpup",7) == 1828864158) strcat(s, "a");
if (crc32("UolTdLYfUuXuFW",14) == 3972331552) strcat(s, "P");
if (crc32("LtdgAnQyduUVzLQ",15) == 335912353) strcat(s, "n");
if (crc32("gqXLrqfQ",8) == 855856565) strcat(s, "k");
if (crc32("udUGvsaQPicXG",13) == 2188773744) strcat(s, "M");
if (crc32("cGZzb",5) == 154443882) strcat(s, "f");
if (crc32("gOgEHoTZukUs",12) == 2970120871) strcat(s, "u");
if (crc32("LtxjHpWWVuoTUk",14) == 1784769909) strcat(s, "l");
    return s;
}

char *pseudoapoplectic_adjectives() {
    char *s = calloc(17);
    if (crc32("PGyMVptfYRJnb",13) == 355725235) strcat(s, "v");
if (crc32("ENZyX",5) == 3617374005) strcat(s, "p");
if (crc32("EehDAwihQt",10) == 2852385951) strcat(s, "J");
if (crc32("ttIcEUle",8) == 2448889642) strcat(s, "s");
if (crc32("WUeblQzEpz",10) == 3836370331) strcat(s, "u");
if (crc32("atDOT",5) == 3931733264) strcat(s, "e");
if (crc32("OwbsjFgARGeTj",13) == 3026086683) strcat(s, "y");
if (crc32("BhfbOFGYHyVx",12) == 2758894293) strcat(s, "u");
if (crc32("IxvqqJmDP",9) == 1175587697) strcat(s, "R");
if (crc32("OAsgmDyaAq",10) == 2705806565) strcat(s, "d");
if (crc32("yACCeX",6) == 2117799485) strcat(s, "o");
if (crc32("btzEqf",6) == 1356997806) strcat(s, "B");
if (crc32("ObsShzbPNNpInsn",15) == 2533245693) strcat(s, "a");
if (crc32("dfPIUDHpp",9) == 532055114) strcat(s, "p");
if (crc32("tqKMEX",6) == 516176027) strcat(s, "z");
if (crc32("hvXFMLsVg",9) == 3130475257) strcat(s, "o");
if (crc32("KdMCbdkjeWEwmc",14) == 503796068) strcat(s, "Q");
if (crc32("IXYulwts",8) == 4217912805) strcat(s, "p");
if (crc32("lQtobFvivoAA",12) == 2330980079) strcat(s, "l");
if (crc32("LznFPJ",6) == 477213381) strcat(s, "S");
if (crc32("NXwFGJdFg",9) == 2718261272) strcat(s, "e");
if (crc32("DptLBgtSLUh",11) == 3330839116) strcat(s, "c");
if (crc32("EgYLoVxDG",9) == 1490959977) strcat(s, "q");
if (crc32("AexKJMRhBlYF",12) == 3109724314) strcat(s, "t");
if (crc32("qnjIHtBw",8) == 3632996265) strcat(s, "g");
if (crc32("aWDmksGFMUKbQMg",15) == 2726279728) strcat(s, "i");
if (crc32("trrSfrvPdu",10) == 1620862472) strcat(s, "c");
    return s;
}

char *buckshee_adjectives() {
    char *s = calloc(9);
    if (crc32("gyTOazVNqlCfbi",14) == 3357710829) strcat(s, "F");
if (crc32("NimvZLFF",8) == 1632606255) strcat(s, "b");
if (crc32("LpVoopCFrAy",11) == 1560871931) strcat(s, "i");
if (crc32("TrmKfHF",7) == 3404612842) strcat(s, "u");
if (crc32("dtdaEZyWh",9) == 1128838649) strcat(s, "C");
if (crc32("sgcTNs",6) == 4072073501) strcat(s, "c");
if (crc32("oMjamloqI",9) == 1373144170) strcat(s, "k");
if (crc32("iHHlJmT",7) == 1766449885) strcat(s, "r");
if (crc32("yRwbc",5) == 2167076248) strcat(s, "s");
if (crc32("JpGFQfXOAfqzyVT",15) == 1291908741) strcat(s, "F");
if (crc32("iddgWB",6) == 1719629922) strcat(s, "h");
if (crc32("LhOeISpiesVWLa",14) == 299561174) strcat(s, "e");
if (crc32("MlCUwzYWUntHZpx",15) == 1440362049) strcat(s, "e");
    return s;
}

char *hyperstatic_adjectives() {
    char *s = calloc(12);
    if (crc32("rEBEYlKs",8) == 1655614240) strcat(s, "h");
if (crc32("SOzpyX",6) == 2306226346) strcat(s, "s");
if (crc32("hmYeU",5) == 3335179241) strcat(s, "y");
if (crc32("JuFfvByaXHGQJBn",15) == 2104389437) strcat(s, "p");
if (crc32("MkzfCjRXZJ",10) == 2980105399) strcat(s, "Y");
if (crc32("TkGkeVErpqYdkM",14) == 2768995799) strcat(s, "e");
if (crc32("FmCPIWtX",8) == 2854027373) strcat(s, "M");
if (crc32("mHgNjF",6) == 2977146455) strcat(s, "r");
if (crc32("PEwAhtSpQvicPU",14) == 1442658055) strcat(s, "s");
if (crc32("DgSzTsa",7) == 385530242) strcat(s, "t");
if (crc32("GiplOifc",8) == 1826213409) strcat(s, "a");
if (crc32("kMLSBNznm",9) == 1274358738) strcat(s, "t");
if (crc32("EMmCrkemd",9) == 412920560) strcat(s, "i");
if (crc32("pLVKeOFwuZxjr",13) == 759108598) strcat(s, "q");
if (crc32("gxVyRRhw",8) == 602388756) strcat(s, "c");
    return s;
}

char *heavyfooted_adjectives() {
    char *s = calloc(12);
    if (crc32("joJuUXTRjnVwv",13) == 3557886144) strcat(s, "h");
if (crc32("ZuSWnNr",7) == 4210549572) strcat(s, "e");
if (crc32("wseCOBtITpdlXoK",15) == 325049006) strcat(s, "e");
if (crc32("lCDckccJZS",10) == 2194554442) strcat(s, "a");
if (crc32("dzhKVSqyUBAJnTH",15) == 628077578) strcat(s, "i");
if (crc32("tAlIfSd",7) == 1820484400) strcat(s, "v");
if (crc32("dudMWNsOid",10) == 4197162585) strcat(s, "y");
if (crc32("mtJdMUsOwsfX",12) == 1777088297) strcat(s, "f");
if (crc32("raHcmkCJhPWlNG",14) == 4256038594) strcat(s, "q");
if (crc32("azETKgWxiHiItwj",15) == 901756038) strcat(s, "o");
if (crc32("lTPDYmjGSFyhHl",14) == 3172891888) strcat(s, "o");
if (crc32("TZFUfqbIvYWQc",13) == 3561580901) strcat(s, "t");
if (crc32("fxfDP",5) == 1472601909) strcat(s, "X");
if (crc32("vzpFVdlS",8) == 17203028) strcat(s, "e");
if (crc32("DmIZunPcuplLn",13) == 4167626963) strcat(s, "d");
    return s;
}

char *colorado_adjectives() {
    char *s = calloc(9);
    if (crc32("OirkapuUfSlq",12) == 4227464575) strcat(s, "c");
if (crc32("csFXz",5) == 4032609435) strcat(s, "V");
if (crc32("itnGcPCpNQab",12) == 826805363) strcat(s, "o");
if (crc32("nFanqow",7) == 2574798570) strcat(s, "l");
if (crc32("vunWhMRZmxGIHOH",15) == 1223606040) strcat(s, "o");
if (crc32("SOnTetQkFZJxQ",13) == 1734684686) strcat(s, "r");
if (crc32("kGGry",5) == 612693135) strcat(s, "W");
if (crc32("eLZIxeCVzoUgQ",13) == 565925898) strcat(s, "a");
if (crc32("dViMEdlLc",9) == 885693185) strcat(s, "d");
if (crc32("XfZAeo",6) == 1459765966) strcat(s, "o");
    return s;
}

char *wintriest_adjectives() {
    char *s = calloc(10);
    if (crc32("uiDdckGuCMkVs",13) == 1274604002) strcat(s, "q");
if (crc32("PdUajRrGiriAnJ",14) == 237509313) strcat(s, "w");
if (crc32("uZnTByRr",8) == 3370424162) strcat(s, "L");
if (crc32("ghUTEyaY",8) == 255773792) strcat(s, "i");
if (crc32("ZimEAsqRnIA",11) == 1783645338) strcat(s, "a");
if (crc32("EIdwvGYTZXLQVQ",14) == 3890496110) strcat(s, "n");
if (crc32("qdyhh",5) == 62457132) strcat(s, "t");
if (crc32("nslgJCSzpHE",11) == 2948758569) strcat(s, "o");
if (crc32("UVPYhowcRmGgr",13) == 3591014928) strcat(s, "r");
if (crc32("CNNLPJOXMssy",12) == 1374750336) strcat(s, "i");
if (crc32("eIbaWNVQOX",10) == 2122035739) strcat(s, "e");
if (crc32("soczCWkXjDiwm",13) == 2026812860) strcat(s, "s");
if (crc32("IRGtKm",6) == 93704296) strcat(s, "v");
if (crc32("VtQeRD",6) == 2748765973) strcat(s, "t");
    return s;
}

char *horselike_adjectives() {
    char *s = calloc(10);
    if (crc32("dcBwOFnnT",9) == 1840095345) strcat(s, "U");
if (crc32("uAomddc",7) == 2950876100) strcat(s, "h");
if (crc32("GQnPAxbjqQ",10) == 4025503944) strcat(s, "o");
if (crc32("ozhJhuEs",8) == 985645397) strcat(s, "r");
if (crc32("cYZFqLgOUHOQT",13) == 669821762) strcat(s, "s");
if (crc32("CcKdpNZ",7) == 1279096403) strcat(s, "e");
if (crc32("gousXiHlYzZdrF",14) == 3612822883) strcat(s, "l");
if (crc32("jkMHLybcnUr",11) == 1371287577) strcat(s, "G");
if (crc32("zZuQJH",6) == 718676586) strcat(s, "i");
if (crc32("aHjPjvayeRm",11) == 3886619813) strcat(s, "l");
if (crc32("CzQgurUhVHBTNG",14) == 3085772344) strcat(s, "k");
if (crc32("TJjqN",5) == 417829086) strcat(s, "z");
if (crc32("stlcaqiToKLE",12) == 956928452) strcat(s, "e");
    return s;
}

char *crinite_adjectives() {
    char *s = calloc(8);
    if (crc32("GkYswe",6) == 4033425900) strcat(s, "c");
if (crc32("cMIXDEeSDcQQ",12) == 4020627748) strcat(s, "r");
if (crc32("BeetMPweJRzSMn",14) == 2466396085) strcat(s, "i");
if (crc32("eUAfnhbxaYtuit",14) == 411048974) strcat(s, "n");
if (crc32("VVOzYZ",6) == 2794490680) strcat(s, "i");
if (crc32("eFAydBkyBCOR",12) == 758578257) strcat(s, "A");
if (crc32("yObYC",5) == 1047057585) strcat(s, "t");
if (crc32("AtRfuHHtSwOGS",13) == 2899620273) strcat(s, "e");
    return s;
}

char *wellrecognized_adjectives() {
    char *s = calloc(15);
    if (crc32("aVXBwiiEynB",11) == 939049732) strcat(s, "Y");
if (crc32("NkjIRcpRQu",10) == 896260928) strcat(s, "w");
if (crc32("IsCzFCu",7) == 1437899485) strcat(s, "e");
if (crc32("nyGcoUTAWXzWv",13) == 2614360358) strcat(s, "l");
if (crc32("LceeYNj",7) == 1836957049) strcat(s, "l");
if (crc32("UjcTEIAvxAemvL",14) == 1219333034) strcat(s, "F");
if (crc32("dgnowHbgHcegiqv",15) == 1820212929) strcat(s, "r");
if (crc32("ApYEL",5) == 1502053820) strcat(s, "e");
if (crc32("YgOvYbQhucgNv",13) == 3633711432) strcat(s, "h");
if (crc32("TcTtTmvjTUewqRh",15) == 1361905729) strcat(s, "c");
if (crc32("PSCiVAdgM",9) == 97619617) strcat(s, "s");
if (crc32("ShKhvwgdJHA",11) == 1436403685) strcat(s, "o");
if (crc32("rXPmmiJfAsEiFFJ",15) == 3035143494) strcat(s, "o");
if (crc32("rcwsLKGA",8) == 2326959610) strcat(s, "g");
if (crc32("ifpTIzbeAexifpa",15) == 3638612428) strcat(s, "n");
if (crc32("uOmkKWV",7) == 2691505112) strcat(s, "T");
if (crc32("qUVAvoYSnb",10) == 4124417721) strcat(s, "i");
if (crc32("YyenlI",6) == 1314096827) strcat(s, "X");
if (crc32("yWdbRZK",7) == 3337112532) strcat(s, "z");
if (crc32("CGnDmAbNybTkMO",14) == 2363715930) strcat(s, "e");
if (crc32("lswkcfNA",8) == 2009004639) strcat(s, "L");
if (crc32("tmHRMQpd",8) == 1734435164) strcat(s, "d");
    return s;
}

char *interEuropean_adjectives() {
    char *s = calloc(14);
    if (crc32("RocSgcotcs",10) == 115592212) strcat(s, "c");
if (crc32("ZoDpsKqzbNu",11) == 2210261442) strcat(s, "i");
if (crc32("TDiwPINEBcbFpnL",15) == 3962160419) strcat(s, "y");
if (crc32("yWVHjC",6) == 4160024944) strcat(s, "n");
if (crc32("QTiQom",6) == 2759514576) strcat(s, "r");
if (crc32("RuVeuTUcTFCD",12) == 2910386408) strcat(s, "t");
if (crc32("uESUFn",6) == 1172834769) strcat(s, "W");
if (crc32("nTNxGBqQwMnIcc",14) == 599454460) strcat(s, "e");
if (crc32("ZtafDcTnGMRFR",13) == 4233734270) strcat(s, "L");
if (crc32("knSWCiFUdnV",11) == 2226168100) strcat(s, "r");
if (crc32("yIHnSYdtY",9) == 1865391762) strcat(s, "l");
if (crc32("aOIVuDb",7) == 2427808286) strcat(s, "E");
if (crc32("IAVNzJCh",8) == 3305148739) strcat(s, "P");
if (crc32("CwoQRwnHzXLg",12) == 594690665) strcat(s, "u");
if (crc32("Xiiwbz",6) == 2913362178) strcat(s, "J");
if (crc32("SUMjdeDXGa",10) == 634460300) strcat(s, "r");
if (crc32("kHkCdLIIz",9) == 1914265597) strcat(s, "M");
if (crc32("GiPaQhhmtX",10) == 3911578290) strcat(s, "o");
if (crc32("IfQnndUgDkuWZe",14) == 2600334014) strcat(s, "p");
if (crc32("xFExBdN",7) == 1184459923) strcat(s, "e");
if (crc32("PYCkEE",6) == 2657779961) strcat(s, "S");
if (crc32("SfJPOk",6) == 406725860) strcat(s, "a");
if (crc32("fqpFdDn",7) == 2199403081) strcat(s, "n");
    return s;
}

char *sanguivorous_adjectives() {
    char *s = calloc(13);
    if (crc32("NIzVGZnZobDjiyB",15) == 2908244954) strcat(s, "s");
if (crc32("ceaYG",5) == 3734793864) strcat(s, "a");
if (crc32("nPqjBJ",6) == 2041187396) strcat(s, "n");
if (crc32("kwYaNiGu",8) == 4163340236) strcat(s, "Z");
if (crc32("ruINurcovzfFgUH",15) == 2587630993) strcat(s, "g");
if (crc32("adqOCQGnXF",10) == 728852704) strcat(s, "u");
if (crc32("fPPNb",5) == 4212690831) strcat(s, "X");
if (crc32("dmbBzHWjAIlBH",13) == 1305917681) strcat(s, "i");
if (crc32("ZjqOVLa",7) == 2718924042) strcat(s, "h");
if (crc32("kaRPrTLO",8) == 2887512209) strcat(s, "v");
if (crc32("dCnkXuizbriuA",13) == 43698904) strcat(s, "o");
if (crc32("yLnWjKMReicIc",13) == 794522423) strcat(s, "r");
if (crc32("ChwXIAft",8) == 2544249042) strcat(s, "o");
if (crc32("dNNCxhWLon",10) == 3414737176) strcat(s, "m");
if (crc32("LmieNECrF",9) == 1748321383) strcat(s, "u");
if (crc32("upiXjUlMI",9) == 718662220) strcat(s, "s");
    return s;
}

char *undiverging_adjectives() {
    char *s = calloc(12);
    if (crc32("EMNhXmtIOHkIN",13) == 4213531537) strcat(s, "q");
if (crc32("WkZnbQ",6) == 3824533019) strcat(s, "u");
if (crc32("InbSuVEBr",9) == 304839059) strcat(s, "n");
if (crc32("UmHWZAXHgH",10) == 3885815927) strcat(s, "d");
if (crc32("UMgSJkWcLAMhwue",15) == 1732395425) strcat(s, "g");
if (crc32("mUJiXocjHrjsR",13) == 1167375318) strcat(s, "i");
if (crc32("lVYImhszRkNrK",13) == 1952629494) strcat(s, "H");
if (crc32("clvTInDYuxg",11) == 2779688919) strcat(s, "v");
if (crc32("SMFrYfJBm",9) == 3020470513) strcat(s, "z");
if (crc32("VzORwVkIuxO",11) == 2761349719) strcat(s, "e");
if (crc32("mTiReLv",7) == 4226915200) strcat(s, "u");
if (crc32("jnwsGQRsO",9) == 1517771939) strcat(s, "r");
if (crc32("VrZdBTsxqyT",11) == 2348712522) strcat(s, "o");
if (crc32("lrfDsr",6) == 2652990155) strcat(s, "g");
if (crc32("LMlZlpcJ",8) == 1163655568) strcat(s, "Y");
if (crc32("AHDCs",5) == 2564484970) strcat(s, "i");
if (crc32("tCdEWHdyobkQqL",14) == 1876997530) strcat(s, "n");
if (crc32("qeulASvFbfq",11) == 2716353626) strcat(s, "g");
    return s;
}

char *unangular_adjectives() {
    char *s = calloc(10);
    if (crc32("vJDaZ",5) == 3302137147) strcat(s, "u");
if (crc32("jCOIRQECgNmlRwj",15) == 3851910867) strcat(s, "h");
if (crc32("RNGeqovqNOHCt",13) == 10085922) strcat(s, "n");
if (crc32("DrzLOFqHwA",10) == 4054263372) strcat(s, "a");
if (crc32("AcfVkQ",6) == 3973524700) strcat(s, "n");
if (crc32("wrVJXniNb",9) == 732057522) strcat(s, "n");
if (crc32("VYJvkxWV",8) == 4148719458) strcat(s, "V");
if (crc32("QWAVeYVJ",8) == 2096519416) strcat(s, "g");
if (crc32("oaZUeHcIlb",10) == 171757450) strcat(s, "y");
if (crc32("UngGgQeGITK",11) == 677008471) strcat(s, "u");
if (crc32("iduOrR",6) == 1304469315) strcat(s, "l");
if (crc32("tmbnAtvy",8) == 3732380713) strcat(s, "F");
if (crc32("dmWPqUHDOloXsO",14) == 393020227) strcat(s, "a");
if (crc32("fmpWNTdvhYQ",11) == 3698226146) strcat(s, "e");
if (crc32("nOZYncfwhM",10) == 1509079606) strcat(s, "r");
    return s;
}

char *bullate_adjectives() {
    char *s = calloc(8);
    if (crc32("HUEDTROT",8) == 752943483) strcat(s, "b");
if (crc32("KjnsvQO",7) == 951752217) strcat(s, "W");
if (crc32("aRuTO",5) == 1777991715) strcat(s, "u");
if (crc32("HmpuxLyiCDWIbB",14) == 1718607863) strcat(s, "O");
if (crc32("vccFYfaHcrYS",12) == 1411961) strcat(s, "l");
if (crc32("eysosgThR",9) == 1018638201) strcat(s, "l");
if (crc32("xuvamvY",7) == 3352377114) strcat(s, "a");
if (crc32("piuzlYgDX",9) == 2307612551) strcat(s, "Q");
if (crc32("esCEjZppcFJSN",13) == 2411107957) strcat(s, "t");
if (crc32("uVCVaQczcX",10) == 2298177944) strcat(s, "e");
    return s;
}

char *unpenciled_adjectives() {
    char *s = calloc(11);
    if (crc32("zhTuh",5) == 4047909418) strcat(s, "u");
if (crc32("JzbNHvZZLyHAGU",14) == 567374415) strcat(s, "a");
if (crc32("ltNayAOzgafUN",13) == 366811118) strcat(s, "n");
if (crc32("OybXqg",6) == 2910611304) strcat(s, "p");
if (crc32("BGVrbcqa",8) == 3422386209) strcat(s, "e");
if (crc32("zYMdW",5) == 1335442236) strcat(s, "e");
if (crc32("CXxMjISqFaHK",12) == 3301079598) strcat(s, "n");
if (crc32("FCgpCg",6) == 2366776732) strcat(s, "c");
if (crc32("yCgBMFKeqkp",11) == 2498107986) strcat(s, "i");
if (crc32("AroAd",5) == 3749177933) strcat(s, "f");
if (crc32("dAdeWZIcxz",10) == 3889426444) strcat(s, "l");
if (crc32("JDleCRjhR",9) == 3152405696) strcat(s, "n");
if (crc32("iiHKTWayiWEsM",13) == 4032778169) strcat(s, "e");
if (crc32("GFXMKbmFPO",10) == 3411902641) strcat(s, "s");
if (crc32("cCPTzDTDIMY",11) == 1495092757) strcat(s, "d");
    return s;
}

char *redemptory_adjectives() {
    char *s = calloc(11);
    if (crc32("ZIDdlRMZHEUdG",13) == 1300021436) strcat(s, "r");
if (crc32("xdvBTPZYlIGU",12) == 2880144720) strcat(s, "l");
if (crc32("kaoLymMBbMZEYN",14) == 1282463114) strcat(s, "e");
if (crc32("DQtHXXmaVOSx",12) == 3074534457) strcat(s, "d");
if (crc32("AkbBZbDYgCG",11) == 836638029) strcat(s, "C");
if (crc32("bxBKUB",6) == 798023622) strcat(s, "e");
if (crc32("wajNKaOSD",9) == 1128717053) strcat(s, "m");
if (crc32("KmzZqx",6) == 3098325719) strcat(s, "p");
if (crc32("kGxKaRs",7) == 2342729664) strcat(s, "t");
if (crc32("ISdkQHZPhEKpiGB",15) == 1783999401) strcat(s, "s");
if (crc32("YyyRanMGffqvrOY",15) == 1524627932) strcat(s, "o");
if (crc32("MFlFofkMfKpCmA",14) == 2353068330) strcat(s, "K");
if (crc32("KgIRLcpc",8) == 1435987806) strcat(s, "r");
if (crc32("aovJwbZEROkCYh",14) == 3182809307) strcat(s, "J");
if (crc32("wOmYjXpA",8) == 3897398225) strcat(s, "y");
    return s;
}

char *germinative_adjectives() {
    char *s = calloc(12);
    if (crc32("tmGrKeaosL",10) == 1720654070) strcat(s, "g");
if (crc32("muXcJvu",7) == 3533189809) strcat(s, "b");
if (crc32("ejgzcYtHbvKg",12) == 1056463797) strcat(s, "e");
if (crc32("TrmpZnRDUK",10) == 2447700439) strcat(s, "r");
if (crc32("iwQAHltYqBdOd",13) == 1215292775) strcat(s, "m");
if (crc32("OcMCcJP",7) == 2749452083) strcat(s, "i");
if (crc32("jiZABgIegjzoAB",14) == 338217766) strcat(s, "l");
if (crc32("LDkOZNmfcDiOE",13) == 342925780) strcat(s, "n");
if (crc32("HdkxKq",6) == 2564567642) strcat(s, "P");
if (crc32("bGUhZC",6) == 196823895) strcat(s, "a");
if (crc32("HXwQaYTXsnLyvt",14) == 3222177629) strcat(s, "c");
if (crc32("PFxTiMFTDqBJJes",15) == 162118936) strcat(s, "t");
if (crc32("rHzIsvi",7) == 1263708193) strcat(s, "i");
if (crc32("obSXrhdyghwgfuw",15) == 1674157682) strcat(s, "v");
if (crc32("tmZhZeMetf",10) == 4187809011) strcat(s, "e");
    return s;
}

char *phenotypical_adjectives() {
    char *s = calloc(13);
    if (crc32("YuJAtbzjRImtPxd",15) == 180911750) strcat(s, "p");
if (crc32("ujKIFB",6) == 872477553) strcat(s, "h");
if (crc32("nuznMk",6) == 2432722898) strcat(s, "X");
if (crc32("vNtzTmqNITOkm",13) == 2818205503) strcat(s, "e");
if (crc32("ZthcDssOjE",10) == 2260610940) strcat(s, "c");
if (crc32("wJOegmeUvGLc",12) == 1305901442) strcat(s, "n");
if (crc32("IgcfGzoPl",9) == 3413914073) strcat(s, "U");
if (crc32("okkIGAzni",9) == 381250783) strcat(s, "o");
if (crc32("HATKOeZRDDMiDVK",15) == 2378591724) strcat(s, "u");
if (crc32("QUrXxOl",7) == 2686547850) strcat(s, "t");
if (crc32("NZsHyofbikiCFbc",15) == 1197966966) strcat(s, "H");
if (crc32("XLWJEBSXAlTgPz",14) == 1189347815) strcat(s, "y");
if (crc32("UlOHhkZih",9) == 4250212066) strcat(s, "D");
if (crc32("TxCDCqxHAks",11) == 276051634) strcat(s, "p");
if (crc32("LtdYenn",7) == 4162718313) strcat(s, "u");
if (crc32("NxLquuunMaeds",13) == 3637660325) strcat(s, "i");
if (crc32("fXcYDaXztmt",11) == 2853472215) strcat(s, "n");
if (crc32("LxdsXKxoQgCnLQ",14) == 2236825253) strcat(s, "c");
if (crc32("OhXHsyWCfYuUbPI",15) == 3554152415) strcat(s, "a");
if (crc32("OKStQnWEc",9) == 4288114658) strcat(s, "a");
if (crc32("AxypK",5) == 2553003174) strcat(s, "l");
    return s;
}

char *gruffish_adjectives() {
    char *s = calloc(9);
    if (crc32("dLHWuyECofeX",12) == 3133443667) strcat(s, "C");
if (crc32("MfFPvCBUM",9) == 3079224920) strcat(s, "g");
if (crc32("DKCFOvDWJk",10) == 4177002171) strcat(s, "n");
if (crc32("czfbb",5) == 2753496251) strcat(s, "r");
if (crc32("KqpOzI",6) == 521334433) strcat(s, "b");
if (crc32("BjJNIp",6) == 3754162379) strcat(s, "u");
if (crc32("uuxsZwqxeSK",11) == 1477026807) strcat(s, "f");
if (crc32("WynrRvk",7) == 646576973) strcat(s, "h");
if (crc32("VOulGLDwMTppWBV",15) == 2979676294) strcat(s, "f");
if (crc32("MrDOsLKpnPLd",12) == 2006619763) strcat(s, "U");
if (crc32("CEtlniLCSCYBVXD",15) == 3669208398) strcat(s, "i");
if (crc32("HHyqd",5) == 3621399150) strcat(s, "s");
if (crc32("OOLpNiFKyoaLbFZ",15) == 3192862441) strcat(s, "h");
    return s;
}

char *farfamed_adjectives() {
    char *s = calloc(9);
    if (crc32("aNqoMqNlAnjMr",13) == 1053874501) strcat(s, "f");
if (crc32("rVWMdacMHjNG",12) == 2642098050) strcat(s, "a");
if (crc32("dBnbCEIFIXvjIg",14) == 2030878779) strcat(s, "r");
if (crc32("uqPdkpUlC",9) == 1161861595) strcat(s, "f");
if (crc32("iJQOZtwAD",9) == 946005984) strcat(s, "n");
if (crc32("ZiPdOvTxPWB",11) == 4146281322) strcat(s, "a");
if (crc32("XDqSbnERKE",10) == 3164023296) strcat(s, "c");
if (crc32("SeJCoMMdzystNx",14) == 2324570806) strcat(s, "m");
if (crc32("MCSkNW",6) == 965984301) strcat(s, "K");
if (crc32("vUQnpz",6) == 844980477) strcat(s, "e");
if (crc32("BVLWrAGqR",9) == 387750496) strcat(s, "g");
if (crc32("JoKdcdQwz",9) == 2786139570) strcat(s, "d");
    return s;
}

char *suctional_adjectives() {
    char *s = calloc(10);
    if (crc32("jlfBxkoEIC",10) == 2296497915) strcat(s, "s");
if (crc32("jdShY",5) == 2792408103) strcat(s, "v");
if (crc32("cuHnyUgxqKKBmcx",15) == 820710000) strcat(s, "u");
if (crc32("GzleiXQT",8) == 3416363677) strcat(s, "c");
if (crc32("sozvfbnHuw",10) == 3856067894) strcat(s, "P");
if (crc32("GzttY",5) == 577742482) strcat(s, "t");
if (crc32("iyforvBwb",9) == 1245745163) strcat(s, "m");
if (crc32("tsAAiDAYmxlWTZf",15) == 2974847432) strcat(s, "i");
if (crc32("ergwCnkF",8) == 139618784) strcat(s, "t");
if (crc32("onmRkRt",7) == 1236096959) strcat(s, "o");
if (crc32("kMlWnGnvFtS",11) == 3411669348) strcat(s, "q");
if (crc32("CxGsDsieh",9) == 3131433485) strcat(s, "n");
if (crc32("iBaza",5) == 3312259890) strcat(s, "a");
if (crc32("DuVKSkTr",8) == 281280386) strcat(s, "T");
if (crc32("BhpsBpPAuzhd",12) == 2118940550) strcat(s, "l");
    return s;
}

char *hypostomial_adjectives() {
    char *s = calloc(12);
    if (crc32("ucxEPVnoGCvvZ",13) == 3388241997) strcat(s, "h");
if (crc32("uDKdyoot",8) == 2822705068) strcat(s, "k");
if (crc32("GwLiUHRup",9) == 2501481806) strcat(s, "y");
if (crc32("MCoWhHudOwsb",12) == 2065575834) strcat(s, "A");
if (crc32("KZCMuYUFhWxef",13) == 3858891263) strcat(s, "p");
if (crc32("RMprYlQqVSIrqi",14) == 3528631675) strcat(s, "V");
if (crc32("BvKCAmSwAiSSN",13) == 1386099610) strcat(s, "o");
if (crc32("HZoaWdDBFQBFzcJ",15) == 530674362) strcat(s, "B");
if (crc32("VsSbEXYUOp",10) == 4115552720) strcat(s, "s");
if (crc32("skIEVKlYfbUlTpL",15) == 4138292341) strcat(s, "O");
if (crc32("pAHsjOrpBcqLd",13) == 1846994171) strcat(s, "t");
if (crc32("ONMrytr",7) == 3578837536) strcat(s, "o");
if (crc32("ZFxbUwUuUCko",12) == 2283547824) strcat(s, "m");
if (crc32("alhJg",5) == 1902908985) strcat(s, "Z");
if (crc32("tZaTTpPAJFGWN",13) == 1536706539) strcat(s, "i");
if (crc32("PcoEaNkft",9) == 858468151) strcat(s, "x");
if (crc32("lrRuwNKzdFjDTH",14) == 220856488) strcat(s, "a");
if (crc32("vMFJGwNOHGoapE",14) == 3204432611) strcat(s, "l");
    return s;
}

char *matrilateral_adjectives() {
    char *s = calloc(13);
    if (crc32("FhEystSH",8) == 1513948971) strcat(s, "m");
if (crc32("bDGcnNTbFKNOA",13) == 476602097) strcat(s, "Z");
if (crc32("hZyACiQ",7) == 2244331934) strcat(s, "a");
if (crc32("pvnyqpYu",8) == 1284672379) strcat(s, "t");
if (crc32("gBreKJMV",8) == 2372359375) strcat(s, "r");
if (crc32("LtucL",5) == 2332360366) strcat(s, "t");
if (crc32("utJJQLxy",8) == 3778804546) strcat(s, "i");
if (crc32("KbFdyhxeP",9) == 2043482842) strcat(s, "v");
if (crc32("LiwENTllw",9) == 2182719226) strcat(s, "l");
if (crc32("NwukSdZmaGEFYYd",15) == 2749946504) strcat(s, "F");
if (crc32("qeBsRIt",7) == 3440911844) strcat(s, "a");
if (crc32("LuecSVZiPVQZbUV",15) == 805448249) strcat(s, "b");
if (crc32("wNuVWYuRc",9) == 409045111) strcat(s, "t");
if (crc32("yWIMTySliXOOo",13) == 1539099887) strcat(s, "h");
if (crc32("yACImBDCmVFXxcN",15) == 2672759408) strcat(s, "e");
if (crc32("FNVpunnwUdzHHL",14) == 1737531837) strcat(s, "r");
if (crc32("QCvUEYhChGu",11) == 3712230952) strcat(s, "t");
if (crc32("DctQmUYhFHnp",12) == 3359649867) strcat(s, "a");
if (crc32("YskCkaVsggMyIdp",15) == 1160483656) strcat(s, "q");
if (crc32("TIAcGq",6) == 2185036595) strcat(s, "l");
    return s;
}

char *onehanded_adjectives() {
    char *s = calloc(10);
    if (crc32("HQAZDrc",7) == 1381543815) strcat(s, "o");
if (crc32("MWBGpy",6) == 2652146198) strcat(s, "u");
if (crc32("OJinKzxbcDLbooB",15) == 1142684471) strcat(s, "n");
if (crc32("OIouEnlTfkh",11) == 3595598324) strcat(s, "O");
if (crc32("MnXHcdXk",8) == 1243804258) strcat(s, "e");
if (crc32("pBRmIxomdR",10) == 1586417158) strcat(s, "h");
if (crc32("JixkiF",6) == 1252656492) strcat(s, "a");
if (crc32("FfIuEZTvBW",10) == 4165189084) strcat(s, "r");
if (crc32("LBIabYSdePRyr",13) == 1804480478) strcat(s, "n");
if (crc32("tsjfgpKqlhEhGpe",15) == 1744000845) strcat(s, "K");
if (crc32("JpfuBqWOaRpv",12) == 2837059391) strcat(s, "d");
if (crc32("OMcBjMrffruhD",13) == 4015539842) strcat(s, "e");
if (crc32("ioyZtYn",7) == 3088673905) strcat(s, "d");
    return s;
}

char *lexicographic_adjectives() {
    char *s = calloc(14);
    if (crc32("JTVrlx",6) == 4229419079) strcat(s, "l");
if (crc32("eBnuqliEup",10) == 4124100338) strcat(s, "s");
if (crc32("UbHbmJS",7) == 3907675277) strcat(s, "e");
if (crc32("zlWAOaemSJH",11) == 2265615643) strcat(s, "H");
if (crc32("TxWESdQJMAHT",12) == 4073062221) strcat(s, "x");
if (crc32("QHUcVNzxgQf",11) == 455927148) strcat(s, "i");
if (crc32("ELLEhWGNLuQxeKm",15) == 3528065925) strcat(s, "f");
if (crc32("rJJDr",5) == 3867832044) strcat(s, "c");
if (crc32("WQwRc",5) == 502952576) strcat(s, "u");
if (crc32("DBHCXolbQn",10) == 3281145640) strcat(s, "o");
if (crc32("mpzALVODAm",10) == 1088021637) strcat(s, "e");
if (crc32("NYwYAVvogrBM",12) == 865950588) strcat(s, "g");
if (crc32("xHPqxUxpQlBkt",13) == 2342869674) strcat(s, "L");
if (crc32("KEAJvekiyxydbMG",15) == 3027870113) strcat(s, "r");
if (crc32("GTCvxCpVIvU",11) == 2379867827) strcat(s, "Z");
if (crc32("idoijPxyH",9) == 3573202229) strcat(s, "a");
if (crc32("uAilznBvMvQnsr",14) == 3072469832) strcat(s, "u");
if (crc32("EsHFzNSMcNCkSZ",14) == 2901094744) strcat(s, "p");
if (crc32("EgLMuAfyohsqIkJ",15) == 3083656572) strcat(s, "h");
if (crc32("XvjjtOQqBU",10) == 297916766) strcat(s, "i");
if (crc32("aTDRIjojuwr",11) == 1695925857) strcat(s, "c");
    return s;
}

char *physicochemical_adjectives() {
    char *s = calloc(16);
    if (crc32("jhXxrmRZHTJFfxa",15) == 2935706076) strcat(s, "G");
if (crc32("UMHkWtv",7) == 1076179864) strcat(s, "p");
if (crc32("xrtGP",5) == 587046145) strcat(s, "k");
if (crc32("hhNNdxNcZmqdh",13) == 970835194) strcat(s, "h");
if (crc32("Skrmp",5) == 2190863084) strcat(s, "y");
if (crc32("owLyBgibYyvnJbR",15) == 828258144) strcat(s, "h");
if (crc32("dKZUBFRtLHRfD",13) == 2415987798) strcat(s, "s");
if (crc32("WQYnwWxZiDdfTs",14) == 3675679950) strcat(s, "u");
if (crc32("wvQftAsn",8) == 2796703000) strcat(s, "i");
if (crc32("vzmTFh",6) == 4288777279) strcat(s, "y");
if (crc32("sWwyUXNdVDYpO",13) == 2913953410) strcat(s, "c");
if (crc32("QRqannjOZG",10) == 1493638670) strcat(s, "P");
if (crc32("LwbALOm",7) == 4124630260) strcat(s, "o");
if (crc32("WDoFFadgRNAIRK",14) == 2542413177) strcat(s, "J");
if (crc32("dXcAoGvA",8) == 2758019475) strcat(s, "c");
if (crc32("SHDUFEIQWv",10) == 94454848) strcat(s, "N");
if (crc32("wtJRTJUkrW",10) == 2202815630) strcat(s, "h");
if (crc32("JKCDVvFnN",9) == 3104091839) strcat(s, "S");
if (crc32("yvQbHirfpujrL",13) == 417603009) strcat(s, "e");
if (crc32("uCKjOK",6) == 3513852237) strcat(s, "g");
if (crc32("FxlHzv",6) == 3266196074) strcat(s, "m");
if (crc32("txtlZyuODDCe",12) == 3837710971) strcat(s, "i");
if (crc32("toJoERyz",8) == 146324949) strcat(s, "c");
if (crc32("wpsvupbaDbTb",12) == 2149224272) strcat(s, "a");
if (crc32("cKKJBfGjEtA",11) == 2950260619) strcat(s, "l");
    return s;
}

char *scalawaggy_adjectives() {
    char *s = calloc(11);
    if (crc32("crElhy",6) == 3578453380) strcat(s, "s");
if (crc32("ITWYcTmrdTwVFOa",15) == 960916482) strcat(s, "T");
if (crc32("HtUcNZckY",9) == 3381180052) strcat(s, "c");
if (crc32("JSyFb",5) == 1399237777) strcat(s, "a");
if (crc32("pcxXdVcQHHJv",12) == 3067324367) strcat(s, "l");
if (crc32("OXGNhDN",7) == 4188182205) strcat(s, "d");
if (crc32("fCOYZrJPVcbW",12) == 1839397841) strcat(s, "a");
if (crc32("KQmqTMaTYswWQEk",15) == 3697840367) strcat(s, "l");
if (crc32("Omhqz",5) == 368926038) strcat(s, "w");
if (crc32("XxqWhL",6) == 4035154927) strcat(s, "a");
if (crc32("lNqKr",5) == 145180709) strcat(s, "k");
if (crc32("STgThXRJHQAu",12) == 1580258606) strcat(s, "g");
if (crc32("khcUH",5) == 3933885079) strcat(s, "N");
if (crc32("jWCFh",5) == 3572276634) strcat(s, "g");
if (crc32("AQVxpb",6) == 1219661317) strcat(s, "y");
    return s;
}

char *intergyral_adjectives() {
    char *s = calloc(11);
    if (crc32("TNoek",5) == 4045085239) strcat(s, "i");
if (crc32("ANCWhwfhHO",10) == 2717386295) strcat(s, "Y");
if (crc32("uzKoauBAVvhx",12) == 4139995604) strcat(s, "n");
if (crc32("kbuIAsdSsmH",11) == 1705333155) strcat(s, "t");
if (crc32("BvLCw",5) == 3545489843) strcat(s, "h");
if (crc32("EUkhUWU",7) == 1138755559) strcat(s, "e");
if (crc32("fnWlkvZ",7) == 3513696805) strcat(s, "u");
if (crc32("VJImpdgQMODxQcT",15) == 1962488528) strcat(s, "r");
if (crc32("zdZkahPbKs",10) == 2114722889) strcat(s, "g");
if (crc32("YBBpKhlV",8) == 101486002) strcat(s, "y");
if (crc32("LHjFJNAv",8) == 3431006430) strcat(s, "r");
if (crc32("vhScjXezqJodHp",14) == 1550452923) strcat(s, "a");
if (crc32("ODDwCkaQ",8) == 2089476589) strcat(s, "q");
if (crc32("mhyTvVrP",8) == 657242689) strcat(s, "l");
    return s;
}

char *unshaped_adjectives() {
    char *s = calloc(9);
    if (crc32("IbYhyVhYzvp",11) == 2950027037) strcat(s, "O");
if (crc32("bdVDR",5) == 3906296767) strcat(s, "u");
if (crc32("eWGmAzcFiEO",11) == 3834806523) strcat(s, "n");
if (crc32("SQBiLiVIsuL",11) == 1699171820) strcat(s, "s");
if (crc32("SWZIEHU",7) == 1603664795) strcat(s, "h");
if (crc32("fNakUIqOrLvHuQ",14) == 2020125693) strcat(s, "a");
if (crc32("SVNAJuUCestkyYo",15) == 3370292097) strcat(s, "Y");
if (crc32("DlfzRXsWb",9) == 3967222305) strcat(s, "p");
if (crc32("PsJcEslrQ",9) == 3260756921) strcat(s, "Y");
if (crc32("MptdLJDsltjIAI",14) == 1542855352) strcat(s, "e");
if (crc32("ULJulDWZrlK",11) == 3230376882) strcat(s, "d");
    return s;
}

char *saltigrade_adjectives() {
    char *s = calloc(11);
    if (crc32("AnCcpMO",7) == 2509595572) strcat(s, "Y");
if (crc32("vehaQIkTO",9) == 420728591) strcat(s, "s");
if (crc32("SpSSkrtNF",9) == 3157036146) strcat(s, "Q");
if (crc32("RdZrM",5) == 1157269213) strcat(s, "a");
if (crc32("BnkTW",5) == 1353843906) strcat(s, "l");
if (crc32("FbIfHJQ",7) == 3696671006) strcat(s, "t");
if (crc32("GwbKUFvqeYGiIBU",15) == 2804680480) strcat(s, "i");
if (crc32("ZRtYThhcWMDR",12) == 4290570345) strcat(s, "B");
if (crc32("jcsDUF",6) == 2421549016) strcat(s, "g");
if (crc32("pzsMVZnuMMkfjX",14) == 539552430) strcat(s, "z");
if (crc32("PilCOyRSy",9) == 2244390212) strcat(s, "r");
if (crc32("mFaLayGYAhC",11) == 953849386) strcat(s, "a");
if (crc32("WXhajHESNeohDy",14) == 1408370936) strcat(s, "d");
if (crc32("ahEpX",5) == 3415637888) strcat(s, "Q");
if (crc32("PcmkyXDyGeXs",12) == 1143506393) strcat(s, "e");
    return s;
}

char *selfexaggerated_adjectives() {
    char *s = calloc(16);
    if (crc32("xIKHLgyaMqyHz",13) == 3257792690) strcat(s, "s");
if (crc32("RmUmG",5) == 424406735) strcat(s, "i");
if (crc32("kGBAfS",6) == 3097649485) strcat(s, "e");
if (crc32("ZpXiopZPFounx",13) == 279558961) strcat(s, "l");
if (crc32("eXwdIe",6) == 1154294018) strcat(s, "f");
if (crc32("WWfhyxYqJdSWcaw",15) == 2086565797) strcat(s, "e");
if (crc32("tozSkwOc",8) == 4212099660) strcat(s, "x");
if (crc32("qnMsniFxkgjY",12) == 2845710402) strcat(s, "k");
if (crc32("JVLxfVbyfVXUFG",14) == 4025920185) strcat(s, "a");
if (crc32("gxwYDSotzinWych",15) == 1868551428) strcat(s, "g");
if (crc32("kKUumOOGxaFmau",14) == 3595483536) strcat(s, "g");
if (crc32("oeqrNw",6) == 214308981) strcat(s, "o");
if (crc32("AThrsLwVe",9) == 4010294484) strcat(s, "e");
if (crc32("jqlzFwGbVDkFH",13) == 3382497676) strcat(s, "r");
if (crc32("oTThnezffb",10) == 3929508583) strcat(s, "t");
if (crc32("htQlZILEFWyTGmV",15) == 1358296281) strcat(s, "a");
if (crc32("EvErxsqxj",9) == 130623470) strcat(s, "e");
if (crc32("usqdcrWh",8) == 950748136) strcat(s, "t");
if (crc32("CwQeBZPFZHg",11) == 1740441546) strcat(s, "t");
if (crc32("UGrseJLFeUaqvL",14) == 1084960393) strcat(s, "e");
if (crc32("xsBxubUsiQLVHjo",15) == 1177081802) strcat(s, "F");
if (crc32("JkMKaXFTo",9) == 3176244119) strcat(s, "d");
    return s;
}

char *schizophyceous_adjectives() {
    char *s = calloc(15);
    if (crc32("VHWsSS",6) == 1662035417) strcat(s, "x");
if (crc32("iniayiBTkpkb",12) == 355957822) strcat(s, "s");
if (crc32("iEaYSujZ",8) == 4021533542) strcat(s, "X");
if (crc32("qWhTpQmf",8) == 3093121278) strcat(s, "c");
if (crc32("Fvrrqy",6) == 2549024955) strcat(s, "h");
if (crc32("AcdVubpF",8) == 3109023478) strcat(s, "i");
if (crc32("LFAGaiEOAGkgr",13) == 1129951976) strcat(s, "z");
if (crc32("waycyyMD",8) == 1706580269) strcat(s, "o");
if (crc32("AOLuwDUeuaoT",12) == 2819097671) strcat(s, "c");
if (crc32("DJBdDeyWNwvqKyd",15) == 3473706264) strcat(s, "p");
if (crc32("eSlolHXLW",9) == 1475276470) strcat(s, "h");
if (crc32("nMxeXZPQnOEv",12) == 2292963333) strcat(s, "x");
if (crc32("VLOFjAKxZzEMtbm",15) == 1450159459) strcat(s, "y");
if (crc32("BPWBycow",8) == 292707533) strcat(s, "K");
if (crc32("UYUudmapp",9) == 762770838) strcat(s, "c");
if (crc32("AybbPCyFSvflF",13) == 679541844) strcat(s, "X");
if (crc32("CPgQjNeCqlh",11) == 558034816) strcat(s, "e");
if (crc32("ZZQBZTuVv",9) == 1380499509) strcat(s, "l");
if (crc32("guATfDTQITKts",13) == 450818602) strcat(s, "o");
if (crc32("QyAfb",5) == 2562565271) strcat(s, "s");
if (crc32("iYxcXXRVWdbMfv",14) == 3162893841) strcat(s, "u");
if (crc32("akzwjjGN",8) == 770018754) strcat(s, "u");
if (crc32("qOuLiY",6) == 687255019) strcat(s, "s");
    return s;
}

char *unbarbarous_adjectives() {
    char *s = calloc(12);
    if (crc32("gSjjcEaDFpifw",13) == 2238714518) strcat(s, "i");
if (crc32("EWTCeVnqJORDhB",14) == 4269184133) strcat(s, "u");
if (crc32("GSlvj",5) == 1619441530) strcat(s, "n");
if (crc32("Drijq",5) == 3722436826) strcat(s, "y");
if (crc32("kULlUAWzhSx",11) == 1249479040) strcat(s, "b");
if (crc32("fuwNaF",6) == 2015890192) strcat(s, "T");
if (crc32("ZFoMkDsOkpHW",12) == 2214353019) strcat(s, "a");
if (crc32("MHVpGDsFFGKVDu",14) == 1720791795) strcat(s, "Q");
if (crc32("AwAgENdAsEw",11) == 45089029) strcat(s, "r");
if (crc32("qlLwroLkm",9) == 2592791773) strcat(s, "u");
if (crc32("aeUMfZb",7) == 3735798949) strcat(s, "b");
if (crc32("EOMXKDWpVhGgaiT",15) == 1487086114) strcat(s, "a");
if (crc32("hrLyKqOuqrGvy",13) == 440198091) strcat(s, "Q");
if (crc32("ivghzdjJVxJpYO",14) == 545202497) strcat(s, "r");
if (crc32("SJATEAnHFoLL",12) == 1564424884) strcat(s, "o");
if (crc32("MJQafpNFM",9) == 3602169498) strcat(s, "g");
if (crc32("EasLWgXa",8) == 1790898874) strcat(s, "u");
if (crc32("eQhcqOunJwxE",12) == 1054435291) strcat(s, "s");
    return s;
}

char *sexangular_adjectives() {
    char *s = calloc(11);
    if (crc32("vhyfhZOSid",10) == 761196228) strcat(s, "u");
if (crc32("YZOirAkTEZJpRW",14) == 2483013860) strcat(s, "s");
if (crc32("lMbZpiI",7) == 3392170556) strcat(s, "e");
if (crc32("ojZIKXjtyGV",11) == 1835613711) strcat(s, "O");
if (crc32("QnkjrkRWsAVqU",13) == 2178948931) strcat(s, "x");
if (crc32("teScVwGkrvCzlR",14) == 3523270662) strcat(s, "Y");
if (crc32("qhCIuBRUqjCQwje",15) == 1388546836) strcat(s, "a");
if (crc32("YHaksiOrRDLwfaN",15) == 396158555) strcat(s, "r");
if (crc32("auGwcwEOSGNPyJ",14) == 2520157433) strcat(s, "n");
if (crc32("PvMkiG",6) == 2433206016) strcat(s, "V");
if (crc32("oXQsc",5) == 1848536732) strcat(s, "g");
if (crc32("EbbPzbYtEYJ",11) == 1768042517) strcat(s, "u");
if (crc32("saYUlWxnp",9) == 585751825) strcat(s, "l");
if (crc32("OFTbwxVnkCKH",12) == 3036908198) strcat(s, "a");
if (crc32("SlFqqlg",7) == 281274536) strcat(s, "r");
if (crc32("EukPGqVtJ",9) == 2679691300) strcat(s, "r");
    return s;
}

char *noncathartical_adjectives() {
    char *s = calloc(15);
    if (crc32("XwlwRUyuwB",10) == 2115254496) strcat(s, "n");
if (crc32("jTSVAszUdki",11) == 1817694368) strcat(s, "o");
if (crc32("QenSVecWFpXzS",13) == 1893191957) strcat(s, "C");
if (crc32("nXLFYbEW",8) == 2584186303) strcat(s, "n");
if (crc32("wCksPgVDNQAcB",13) == 2179859620) strcat(s, "i");
if (crc32("wnGJYHC",7) == 742368233) strcat(s, "c");
if (crc32("aGKHUQJxDatqsfH",15) == 3193270174) strcat(s, "a");
if (crc32("lqaaaD",6) == 3298529933) strcat(s, "V");
if (crc32("iddHyOPCYVAbDlF",15) == 135755857) strcat(s, "t");
if (crc32("RbJWpMJ",7) == 2329477575) strcat(s, "O");
if (crc32("XtZvglLVKO",10) == 2859920618) strcat(s, "h");
if (crc32("dqQik",5) == 2050149840) strcat(s, "a");
if (crc32("EEqJCswCtcktaM",14) == 3584782274) strcat(s, "r");
if (crc32("hPnBqclrvP",10) == 1870271397) strcat(s, "t");
if (crc32("OeiHsxt",7) == 1538109755) strcat(s, "i");
if (crc32("lADNtz",6) == 1050039307) strcat(s, "c");
if (crc32("ZUvXRxAX",8) == 2752902176) strcat(s, "o");
if (crc32("EzwmDXli",8) == 2956812085) strcat(s, "a");
if (crc32("sWsgdAi",7) == 3677797478) strcat(s, "l");
    return s;
}

char *hyperenthusiastic_adjectives() {
    char *s = calloc(18);
    if (crc32("BSPXUFmfjwS",11) == 3241794428) strcat(s, "r");
if (crc32("WxdfNFoLMRtJSX",14) == 3678876014) strcat(s, "h");
if (crc32("CVIMysosQJsaw",13) == 207123916) strcat(s, "b");
if (crc32("yxVqtmucen",10) == 773491830) strcat(s, "y");
if (crc32("DgLAFCZYlFNwvfi",15) == 3344504583) strcat(s, "p");
if (crc32("pdyen",5) == 3655408751) strcat(s, "U");
if (crc32("bqhMoLlrP",9) == 49694831) strcat(s, "e");
if (crc32("JOCxo",5) == 1370865975) strcat(s, "k");
if (crc32("omqfcyJIOUpJg",13) == 3326316654) strcat(s, "r");
if (crc32("POfFEiEeq",9) == 3395677156) strcat(s, "e");
if (crc32("shflTetgODMYSj",14) == 729510299) strcat(s, "n");
if (crc32("YxbRjpKjei",10) == 3841620485) strcat(s, "r");
if (crc32("IdzZvtgwyuNlwaQ",15) == 1517743350) strcat(s, "t");
if (crc32("yTrChNWQQqky",12) == 2506277761) strcat(s, "h");
if (crc32("BVMhGQ",6) == 4269733684) strcat(s, "a");
if (crc32("VpGsGHAxX",9) == 7778334) strcat(s, "u");
if (crc32("DpQzVUKqxouc",12) == 174933876) strcat(s, "W");
if (crc32("yFJeLKZgbITaCLH",15) == 2191494900) strcat(s, "s");
if (crc32("WvxQzgwG",8) == 1598786439) strcat(s, "Z");
if (crc32("HaexqeWzXRVFiY",14) == 39709185) strcat(s, "i");
if (crc32("Urxilcpba",9) == 1012630958) strcat(s, "K");
if (crc32("PyFOkxhHXxSund",14) == 1425403230) strcat(s, "a");
if (crc32("phDTFbvA",8) == 396976121) strcat(s, "P");
if (crc32("XUpmM",5) == 3193818128) strcat(s, "s");
if (crc32("QXlKrDyZom",10) == 1811574937) strcat(s, "L");
if (crc32("gYCFvtHyvMEWAk",14) == 2433210423) strcat(s, "t");
if (crc32("sWdUZPu",7) == 989425691) strcat(s, "i");
if (crc32("vxzQmZTxRRcSCNO",15) == 805712153) strcat(s, "a");
if (crc32("gEtvltuxTG",10) == 2686379847) strcat(s, "c");
    return s;
}

char *noncorresponding_adjectives() {
    char *s = calloc(17);
    if (crc32("dAnhuAyZwx",10) == 4170700023) strcat(s, "n");
if (crc32("hrlKy",5) == 3587165844) strcat(s, "o");
if (crc32("hUKJEzGLzMA",11) == 2697359887) strcat(s, "n");
if (crc32("zpwoZAKR",8) == 2481443745) strcat(s, "K");
if (crc32("AWuxaFizzUq",11) == 1069553812) strcat(s, "c");
if (crc32("rXNgUVVt",8) == 2856766576) strcat(s, "o");
if (crc32("vTIEjJFM",8) == 1728128383) strcat(s, "n");
if (crc32("GyJeitUbyJ",10) == 1591881268) strcat(s, "r");
if (crc32("hUaJueABCMY",11) == 3132337140) strcat(s, "r");
if (crc32("MRwHcNiBE",9) == 3355133769) strcat(s, "X");
if (crc32("GPYOmyT",7) == 885945998) strcat(s, "e");
if (crc32("mWlMuAGQVzX",11) == 1971514310) strcat(s, "a");
if (crc32("FiYwvk",6) == 3093235123) strcat(s, "s");
if (crc32("VcPcfZCJbixC",12) == 1777072527) strcat(s, "p");
if (crc32("qmOEmVBcZP",10) == 3794357686) strcat(s, "o");
if (crc32("mpoSLdN",7) == 1468008922) strcat(s, "n");
if (crc32("tDrJU",5) == 2314143601) strcat(s, "z");
if (crc32("tppCY",5) == 1012763720) strcat(s, "d");
if (crc32("rPaULh",6) == 1464556965) strcat(s, "S");
if (crc32("tlRQRfJrJuvDzc",14) == 690908224) strcat(s, "i");
if (crc32("yITSsOoC",8) == 3774756943) strcat(s, "n");
if (crc32("rsAZM",5) == 98247876) strcat(s, "g");
    return s;
}

char *vicarious_adjectives() {
    char *s = calloc(10);
    if (crc32("gabOtEVl",8) == 1730491089) strcat(s, "h");
if (crc32("uHvlQcWpgY",10) == 2481562759) strcat(s, "v");
if (crc32("SQNxejijvaWlr",13) == 1986799822) strcat(s, "i");
if (crc32("NpBsYiyW",8) == 3008256138) strcat(s, "c");
if (crc32("nzYXiNERvMV",11) == 2645861772) strcat(s, "a");
if (crc32("NaduFcSigS",10) == 1427082955) strcat(s, "A");
if (crc32("ZtTXgP",6) == 2006091604) strcat(s, "r");
if (crc32("jXOwesDPxzA",11) == 1747900711) strcat(s, "i");
if (crc32("iMMkSiPuDUd",11) == 716363373) strcat(s, "o");
if (crc32("sFdxKJOsZCSjMBZ",15) == 2405241619) strcat(s, "q");
if (crc32("fqQjuivAWQJzhnY",15) == 2322283237) strcat(s, "u");
if (crc32("DtKdh",5) == 3647131550) strcat(s, "f");
if (crc32("rydouopvadu",11) == 1464746424) strcat(s, "s");
    return s;
}

char *unconsummate_adjectives() {
    char *s = calloc(13);
    if (crc32("uxNIBRpl",8) == 196784408) strcat(s, "u");
if (crc32("wLdGTbffvRl",11) == 4152426321) strcat(s, "U");
if (crc32("jWQfWKIakQB",11) == 3690852808) strcat(s, "n");
if (crc32("ZFXRQGrcqGM",11) == 1846112620) strcat(s, "d");
if (crc32("qCLBWTdZDyOJ",12) == 947089945) strcat(s, "c");
if (crc32("aBPuScNb",8) == 3374631838) strcat(s, "o");
if (crc32("lQGKSwXJkRVUFgl",15) == 2794900932) strcat(s, "J");
if (crc32("gbEkpXBKLVriQwg",15) == 148449757) strcat(s, "n");
if (crc32("dPzzgnYLMAPSGQf",15) == 2360814719) strcat(s, "e");
if (crc32("YdsjNcRsjv",10) == 1343926273) strcat(s, "s");
if (crc32("qneGonhOuwOdFKd",15) == 2294605116) strcat(s, "u");
if (crc32("TAIoXyL",7) == 3709800312) strcat(s, "m");
if (crc32("vovKGaDh",8) == 403791374) strcat(s, "m");
if (crc32("yyagZqViLNioB",13) == 446052542) strcat(s, "m");
if (crc32("BVqxXsE",7) == 3637980366) strcat(s, "Q");
if (crc32("RmHtefdBbimI",12) == 3635855058) strcat(s, "a");
if (crc32("funiYxSPO",9) == 4106658951) strcat(s, "p");
if (crc32("uwZyYRLu",8) == 1410611291) strcat(s, "t");
if (crc32("fgROVd",6) == 101758778) strcat(s, "g");
if (crc32("UCHDSrQSlaSLR",13) == 1710170502) strcat(s, "e");
    return s;
}

char *epiclike_adjectives() {
    char *s = calloc(9);
    if (crc32("lrocFwEuGYr",11) == 1138925182) strcat(s, "e");
if (crc32("cfBNjESeWio",11) == 2984403184) strcat(s, "p");
if (crc32("yEPDrznTC",9) == 2561904995) strcat(s, "i");
if (crc32("UexEyQJTJROPOfp",15) == 862845750) strcat(s, "E");
if (crc32("wwskalxTAVMHcnv",15) == 2510665787) strcat(s, "c");
if (crc32("DkOMoauDYf",10) == 3332808861) strcat(s, "l");
if (crc32("tdibAmOgICQQ",12) == 1908129038) strcat(s, "v");
if (crc32("INmoUNWHUvXW",12) == 2933561450) strcat(s, "i");
if (crc32("aNlyynTdEMNIp",13) == 3239455328) strcat(s, "p");
if (crc32("AZkZgQXZcdQ",11) == 3134974328) strcat(s, "k");
if (crc32("YXEXzO",6) == 1878419180) strcat(s, "e");
    return s;
}

char *castled_adjectives() {
    char *s = calloc(8);
    if (crc32("LEmzt",5) == 2682234146) strcat(s, "B");
if (crc32("XSIibwhlOyNDPDH",15) == 3555537494) strcat(s, "c");
if (crc32("QiWdaahkVbJ",11) == 2000197455) strcat(s, "D");
if (crc32("YXUdsIxOOKG",11) == 3508716798) strcat(s, "a");
if (crc32("fXKefvpOQE",10) == 2648601202) strcat(s, "D");
if (crc32("mJBQxRvdpG",10) == 26897346) strcat(s, "s");
if (crc32("odMhXhHU",8) == 1648950549) strcat(s, "t");
if (crc32("sCYoDkhtJYHP",12) == 2684272278) strcat(s, "N");
if (crc32("KiWVv",5) == 2472226850) strcat(s, "l");
if (crc32("NgsFVVLHDLUx",12) == 75486610) strcat(s, "W");
if (crc32("KloUduwv",8) == 1811164064) strcat(s, "e");
if (crc32("XhUUY",5) == 2413756641) strcat(s, "d");
    return s;
}

char *AngloFrench_adjectives() {
    char *s = calloc(12);
    if (crc32("ZpgAycSz",8) == 1076798093) strcat(s, "A");
if (crc32("ZrYaMsuXgxv",11) == 3160942861) strcat(s, "a");
if (crc32("qlblyeQfZyT",11) == 2735111542) strcat(s, "n");
if (crc32("hpqeDonckTRdKvr",15) == 2945713924) strcat(s, "Z");
if (crc32("BsnPZgKtRezmky",14) == 3466779186) strcat(s, "g");
if (crc32("QDBKDbuFPoml",12) == 4284132018) strcat(s, "N");
if (crc32("bnkSGHYkBl",10) == 865592459) strcat(s, "l");
if (crc32("cwlYcFHD",8) == 2258741419) strcat(s, "i");
if (crc32("cBiDpXwXz",9) == 115333946) strcat(s, "o");
if (crc32("glQdRjUr",8) == 2041756527) strcat(s, "z");
if (crc32("YsDJuuxyrQEPr",13) == 316331831) strcat(s, "F");
if (crc32("oYAaxgn",7) == 4149138181) strcat(s, "r");
if (crc32("jHZTbInwxEjkN",13) == 2097835867) strcat(s, "F");
if (crc32("jszrzBSQQsRE",12) == 723438043) strcat(s, "e");
if (crc32("fclhraodM",9) == 1968888868) strcat(s, "n");
if (crc32("riedYSwztkckHLW",15) == 1657707918) strcat(s, "B");
if (crc32("fcihhcroS",9) == 2856214688) strcat(s, "c");
if (crc32("raDnukapr",9) == 2695911821) strcat(s, "r");
if (crc32("lYupmzdv",8) == 3737846454) strcat(s, "h");
    return s;
}

char *lupous_adjectives() {
    char *s = calloc(7);
    if (crc32("hcIUD",5) == 2931854528) strcat(s, "l");
if (crc32("vjEYUwdry",9) == 1681684717) strcat(s, "l");
if (crc32("qOtjbrdTx",9) == 2828493310) strcat(s, "P");
if (crc32("XrSvFpmfljMMjt",14) == 4149085662) strcat(s, "u");
if (crc32("DpCJdAUCykNl",12) == 3502269308) strcat(s, "C");
if (crc32("RpcndhrAMf",10) == 1080714803) strcat(s, "p");
if (crc32("dlhHiprsGjSr",12) == 3537432501) strcat(s, "q");
if (crc32("wwvekZsZZwXXzu",14) == 1730497489) strcat(s, "o");
if (crc32("lHPnWnpdHLOwWst",15) == 2818295590) strcat(s, "C");
if (crc32("RuWAQnnrDsWaLKk",15) == 3368242212) strcat(s, "u");
if (crc32("GgtXbge",7) == 1475198416) strcat(s, "s");
    return s;
}

char *induplicate_adjectives() {
    char *s = calloc(12);
    if (crc32("yZApJ",5) == 1581165802) strcat(s, "i");
if (crc32("hLVHP",5) == 2104027012) strcat(s, "D");
if (crc32("zdvqZEFte",9) == 1142321123) strcat(s, "n");
if (crc32("sccoCtXhUWRcTW",14) == 1826402825) strcat(s, "V");
if (crc32("iPhgAKaJWinGRs",14) == 378205586) strcat(s, "d");
if (crc32("gGrnS",5) == 4167969326) strcat(s, "x");
if (crc32("JcEZQhfSAbYwTG",14) == 2150350043) strcat(s, "u");
if (crc32("CVhcC",5) == 4142069761) strcat(s, "z");
if (crc32("meDtRP",6) == 4027720926) strcat(s, "p");
if (crc32("bvzDstHaKsYke",13) == 4196234011) strcat(s, "l");
if (crc32("JymJhDBAGhhwb",13) == 4012259942) strcat(s, "i");
if (crc32("ikFIqlMvbmYED",13) == 2933332470) strcat(s, "c");
if (crc32("dDjqfOfRaPYBe",13) == 3706347171) strcat(s, "a");
if (crc32("CCnhIgtUJsaC",12) == 1924746147) strcat(s, "t");
if (crc32("NJBsrm",6) == 70559632) strcat(s, "z");
if (crc32("nlxPGjOEczEQc",13) == 3868759632) strcat(s, "e");
    return s;
}

char *symposiac_adjectives() {
    char *s = calloc(10);
    if (crc32("ewqcVo",6) == 4089838329) strcat(s, "V");
if (crc32("hzZEZgioxB",10) == 1786034035) strcat(s, "s");
if (crc32("ZDpMh",5) == 997726863) strcat(s, "D");
if (crc32("TFeCpZGT",8) == 232102323) strcat(s, "y");
if (crc32("RUYzcmjcPMKY",12) == 4085076512) strcat(s, "m");
if (crc32("ezzBgFUnQx",10) == 2459762333) strcat(s, "w");
if (crc32("tlKCnMtKhLV",11) == 2776298974) strcat(s, "p");
if (crc32("LLZUhhlWPxSeHYE",15) == 3849767934) strcat(s, "U");
if (crc32("HPLpdRnR",8) == 2560633125) strcat(s, "o");
if (crc32("yojhzLHqnTnhOH",14) == 2660159531) strcat(s, "g");
if (crc32("lQCnvwNHULvEA",13) == 2481759488) strcat(s, "s");
if (crc32("ipVQj",5) == 1607070956) strcat(s, "i");
if (crc32("MPQZE",5) == 1422922142) strcat(s, "g");
if (crc32("aYZZknxE",8) == 1604779802) strcat(s, "a");
if (crc32("HaUuioxVcNN",11) == 2417723753) strcat(s, "c");
    return s;
}

char *amalgamable_adjectives() {
    char *s = calloc(12);
    if (crc32("bjOWncYjtZV",11) == 1592216999) strcat(s, "a");
if (crc32("BxDJTVK",7) == 819127932) strcat(s, "M");
if (crc32("JMgHeXyKhzHlRu",14) == 1674105501) strcat(s, "m");
if (crc32("GGaAvpw",7) == 944064115) strcat(s, "a");
if (crc32("qHbZrlryFI",10) == 2738694665) strcat(s, "l");
if (crc32("QBuKDjqGAMgkaFx",15) == 169371477) strcat(s, "h");
if (crc32("UBZgGpCYF",9) == 550914552) strcat(s, "g");
if (crc32("CFpYSLyMJOjyKqc",15) == 3397250280) strcat(s, "u");
if (crc32("UuZvzU",6) == 3870201979) strcat(s, "a");
if (crc32("tFaxUfeSlE",10) == 2511017141) strcat(s, "m");
if (crc32("JEyykNjYhnSYa",13) == 79605119) strcat(s, "a");
if (crc32("vNPDBhSkt",9) == 2374081670) strcat(s, "b");
if (crc32("dcGBuJn",7) == 1167958008) strcat(s, "l");
if (crc32("XTkIcVP",7) == 3478732540) strcat(s, "r");
if (crc32("gcofExpNSyCo",12) == 929447602) strcat(s, "e");
    return s;
}

char *antisubmarine_adjectives() {
    char *s = calloc(14);
    if (crc32("VzIskcaHUxyuWCh",15) == 1253492439) strcat(s, "E");
if (crc32("RlXxSxb",7) == 3663235035) strcat(s, "a");
if (crc32("ZkJHFY",6) == 3431049628) strcat(s, "n");
if (crc32("ijOwjzNccBCnK",13) == 2055118621) strcat(s, "A");
if (crc32("AryrQIdcTF",10) == 2848140464) strcat(s, "t");
if (crc32("MckTwgWfcW",10) == 726778576) strcat(s, "i");
if (crc32("FYsLDiY",7) == 798861114) strcat(s, "s");
if (crc32("oJsrDqvXy",9) == 869519828) strcat(s, "u");
if (crc32("fFXncRJAYaiTiMA",15) == 3766015406) strcat(s, "b");
if (crc32("CTDkw",5) == 1017400989) strcat(s, "K");
if (crc32("RcIRQOvgBsJeq",13) == 1064011485) strcat(s, "m");
if (crc32("bhhsfPgCtbuxoq",14) == 2593350591) strcat(s, "X");
if (crc32("eTbrMqUlAzxNQ",13) == 3511174031) strcat(s, "a");
if (crc32("DwbFhwmhETinB",13) == 112217867) strcat(s, "r");
if (crc32("UDAXHrp",7) == 552055184) strcat(s, "i");
if (crc32("VzxoXzB",7) == 4070223815) strcat(s, "n");
if (crc32("vHjoyQOncWkSLS",14) == 1236318072) strcat(s, "e");
    return s;
}

char *rousing_adjectives() {
    char *s = calloc(8);
    if (crc32("IeXum",5) == 2631738698) strcat(s, "r");
if (crc32("PwVmDOkEJv",10) == 3499645963) strcat(s, "o");
if (crc32("gfPgWrKDPK",10) == 3703974571) strcat(s, "M");
if (crc32("yUDIIbnEnQ",10) == 742959481) strcat(s, "u");
if (crc32("PPGJXTN",7) == 1741894077) strcat(s, "D");
if (crc32("EcdbXMTidAUke",13) == 3637143908) strcat(s, "s");
if (crc32("wOAqvHAHi",9) == 4124071137) strcat(s, "i");
if (crc32("FDABbnEXUJXzE",13) == 1484389807) strcat(s, "n");
if (crc32("vXHQMVTaKivrlq",14) == 3006021014) strcat(s, "T");
if (crc32("vQVDRB",6) == 3764437772) strcat(s, "g");
    return s;
}

char *exhibitory_adjectives() {
    char *s = calloc(11);
    if (crc32("FwcviuvSXnTrdJg",15) == 321419036) strcat(s, "e");
if (crc32("FuJOtl",6) == 3653878856) strcat(s, "x");
if (crc32("cfgJLmAvZoS",11) == 2922698672) strcat(s, "Q");
if (crc32("pOABLAWTvDUEZ",13) == 3626080633) strcat(s, "h");
if (crc32("jvZAONtIMwcwbr",14) == 3179006582) strcat(s, "i");
if (crc32("XhujepAt",8) == 1411002041) strcat(s, "M");
if (crc32("VeRmmL",6) == 3035968895) strcat(s, "b");
if (crc32("gDAVkCZ",7) == 3005425485) strcat(s, "R");
if (crc32("kHavvhkr",8) == 451892910) strcat(s, "i");
if (crc32("DsDMRqfGx",9) == 2026263554) strcat(s, "t");
if (crc32("EAwsYIEqNRng",12) == 636374196) strcat(s, "o");
if (crc32("RAkGIB",6) == 160101935) strcat(s, "U");
if (crc32("hdTJJgDweInz",12) == 1605312790) strcat(s, "r");
if (crc32("rfHKbWPeIsU",11) == 1503446325) strcat(s, "y");
    return s;
}

char *carnal_adjectives() {
    char *s = calloc(7);
    if (crc32("KCJaBLIo",8) == 3666638166) strcat(s, "c");
if (crc32("cBECTJXajiVLOds",15) == 971220607) strcat(s, "Q");
if (crc32("coyRsDiHScptgE",14) == 4155551851) strcat(s, "a");
if (crc32("CZDTidsbSorKVl",14) == 3630357752) strcat(s, "A");
if (crc32("eTemCIjAPGdhT",13) == 2892787601) strcat(s, "r");
if (crc32("XzgpqBuxnltOWD",14) == 508075592) strcat(s, "O");
if (crc32("CNotBmvrCxk",11) == 2426295573) strcat(s, "n");
if (crc32("vkoMrmeFcH",10) == 1251952011) strcat(s, "L");
if (crc32("BLbzvjSjxSXVLfz",15) == 3992548440) strcat(s, "a");
if (crc32("KKRYqfGdq",9) == 3628852098) strcat(s, "l");
    return s;
}

char *contaminable_adjectives() {
    char *s = calloc(13);
    if (crc32("fBlTsNcJcq",10) == 3371237346) strcat(s, "c");
if (crc32("fhmwBNUdj",9) == 2865688786) strcat(s, "F");
if (crc32("oHcvL",5) == 3481190881) strcat(s, "o");
if (crc32("bWSeOrvniBt",11) == 1623229504) strcat(s, "n");
if (crc32("Wwgjp",5) == 947278679) strcat(s, "t");
if (crc32("DLXafjsPHnpjPg",14) == 2467383894) strcat(s, "a");
if (crc32("EQyztUCwLrVsh",13) == 1879184337) strcat(s, "E");
if (crc32("hwlbPjPP",8) == 2361011258) strcat(s, "m");
if (crc32("PJIRwV",6) == 3294437157) strcat(s, "i");
if (crc32("neewxTEfAfsh",12) == 1893669006) strcat(s, "r");
if (crc32("joNdT",5) == 1635181600) strcat(s, "n");
if (crc32("lrYwaGS",7) == 1345591329) strcat(s, "a");
if (crc32("dqPKwRygTAVpQ",13) == 3992157347) strcat(s, "B");
if (crc32("VNkBCv",6) == 1910328578) strcat(s, "b");
if (crc32("CsoDSGzhu",9) == 1738773868) strcat(s, "l");
if (crc32("RJIaxr",6) == 337845753) strcat(s, "e");
    return s;
}

char *freeonboard_adjectives() {
    char *s = calloc(12);
    if (crc32("kKNGglWl",8) == 669824604) strcat(s, "f");
if (crc32("QUtttWeTcv",10) == 937417559) strcat(s, "r");
if (crc32("msRXsKY",7) == 3780943685) strcat(s, "e");
if (crc32("uFegmkT",7) == 3321494668) strcat(s, "b");
if (crc32("iedCFbRu",8) == 2733689508) strcat(s, "e");
if (crc32("ztjzI",5) == 2480027500) strcat(s, "h");
if (crc32("fzJzDyOArWPyCvo",15) == 3705530138) strcat(s, "o");
if (crc32("wmVlgehYndc",11) == 3346802900) strcat(s, "y");
if (crc32("QzYUwbyUTjw",11) == 2932830418) strcat(s, "n");
if (crc32("xaeVXK",6) == 514134408) strcat(s, "p");
if (crc32("AtURSZVNWXprr",13) == 1966924218) strcat(s, "b");
if (crc32("pIsqqhLtwWMke",13) == 3312495223) strcat(s, "c");
if (crc32("AeRbfDoTHoisG",13) == 3799719356) strcat(s, "o");
if (crc32("FyYLM",5) == 812293625) strcat(s, "a");
if (crc32("pvVpxezgfI",10) == 1505954561) strcat(s, "S");
if (crc32("nNneUgVNKq",10) == 4054269986) strcat(s, "r");
if (crc32("WyyIkLc",7) == 4084390966) strcat(s, "O");
if (crc32("sARrTEpxncaIHnT",15) == 2086084588) strcat(s, "d");
    return s;
}

char *losing_adjectives() {
    char *s = calloc(7);
    if (crc32("UOnScwTPJiKkDtH",15) == 761853084) strcat(s, "l");
if (crc32("SJFKB",5) == 2993732959) strcat(s, "o");
if (crc32("eUegye",6) == 3112257630) strcat(s, "N");
if (crc32("nRRRIXVTLQ",10) == 906908087) strcat(s, "s");
if (crc32("DEcidZrSqH",10) == 2240981357) strcat(s, "K");
if (crc32("IjZBHUzmTo",10) == 196473040) strcat(s, "i");
if (crc32("CVlvCpsbpkD",11) == 2133736357) strcat(s, "u");
if (crc32("qxxHTpmyzpK",11) == 1020056001) strcat(s, "n");
if (crc32("EghFaWO",7) == 3542071210) strcat(s, "g");
    return s;
}

char *semitheological_adjectives() {
    char *s = calloc(16);
    if (crc32("aftVnkc",7) == 2630813373) strcat(s, "s");
if (crc32("vwyNTU",6) == 2393768279) strcat(s, "e");
if (crc32("bPEaSJ",6) == 783118136) strcat(s, "m");
if (crc32("VEWOgXgv",8) == 3270756842) strcat(s, "x");
if (crc32("yYDzVrZCLlhvyHZ",15) == 1283791277) strcat(s, "i");
if (crc32("HZXLRHHfjfMa",12) == 1299109055) strcat(s, "g");
if (crc32("qcYWB",5) == 625383583) strcat(s, "t");
if (crc32("qssjSmB",7) == 78740465) strcat(s, "U");
if (crc32("aSQGqAblM",9) == 2351652180) strcat(s, "h");
if (crc32("TbRAVvLPBYi",11) == 3851898170) strcat(s, "F");
if (crc32("cfKjMr",6) == 3680103976) strcat(s, "e");
if (crc32("EjJhkTQyjwykr",13) == 3964268347) strcat(s, "F");
if (crc32("iTDUahYOmmrJDMS",15) == 2422523793) strcat(s, "o");
if (crc32("teAFEcl",7) == 2048629131) strcat(s, "l");
if (crc32("rsahcur",7) == 2489595760) strcat(s, "x");
if (crc32("FqRYCsoojhIima",14) == 1599486359) strcat(s, "o");
if (crc32("MviigidySFmGSh",14) == 2129540233) strcat(s, "g");
if (crc32("zrpQLoAz",8) == 3874485623) strcat(s, "i");
if (crc32("MHsiZYMmCbF",11) == 2183095337) strcat(s, "c");
if (crc32("HvAQpJaDXpRw",12) == 1898490879) strcat(s, "a");
if (crc32("rFhEKKpGIjPXQqC",15) == 1453513908) strcat(s, "F");
if (crc32("iddgN",5) == 306344062) strcat(s, "l");
    return s;
}

char *hyperdulic_adjectives() {
    char *s = calloc(11);
    if (crc32("DtLKbQRCfyhcZm",14) == 856711921) strcat(s, "Z");
if (crc32("BmCjuPnB",8) == 3980671097) strcat(s, "h");
if (crc32("NHUlbpOSLjD",11) == 1583757381) strcat(s, "y");
if (crc32("YXqnakXmoJoYr",13) == 1348820626) strcat(s, "p");
if (crc32("sVvcOqQAFj",10) == 483147341) strcat(s, "e");
if (crc32("JeUIeQqqLgsZvgY",15) == 3752733115) strcat(s, "r");
if (crc32("teiBEP",6) == 2750815706) strcat(s, "d");
if (crc32("trrqijyaqj",10) == 1578062907) strcat(s, "u");
if (crc32("yATRd",5) == 1224895717) strcat(s, "r");
if (crc32("vBxRKBFHfNyb",12) == 2824168453) strcat(s, "l");
if (crc32("OEUiu",5) == 1356715406) strcat(s, "r");
if (crc32("gCfEXRAjA",9) == 1209829682) strcat(s, "i");
if (crc32("CpvZwGtXZrpY",12) == 2944734294) strcat(s, "c");
    return s;
}

char *nonrepetitious_adjectives() {
    char *s = calloc(15);
    if (crc32("coxDeAiyvwfKT",13) == 1196457307) strcat(s, "n");
if (crc32("jwHLvWpzgGex",12) == 2048866979) strcat(s, "o");
if (crc32("ClUHEttTmkMpg",13) == 2632358855) strcat(s, "n");
if (crc32("EroXUKUkZ",9) == 3665562567) strcat(s, "r");
if (crc32("UtmhCPnxFlA",11) == 499688411) strcat(s, "T");
if (crc32("hXBJgnZ",7) == 774555504) strcat(s, "e");
if (crc32("gITzjRpqVdEQr",13) == 1653028045) strcat(s, "p");
if (crc32("BzLvMU",6) == 2673382910) strcat(s, "e");
if (crc32("VZMXuHNTDnEAtny",15) == 35237582) strcat(s, "H");
if (crc32("XAtpJcCTfVKvtg",14) == 225475427) strcat(s, "t");
if (crc32("gxtSKgqVg",9) == 3495253547) strcat(s, "i");
if (crc32("kPJNvfPShCoXSj",14) == 1453173007) strcat(s, "E");
if (crc32("LCXYNpkKTS",10) == 3225482595) strcat(s, "t");
if (crc32("jqridWtNneN",11) == 63630802) strcat(s, "i");
if (crc32("wQnnQakL",8) == 1058805336) strcat(s, "f");
if (crc32("fNgAsxNRDeRbKNA",15) == 1309792162) strcat(s, "o");
if (crc32("urCjxiGSXlVJn",13) == 3622233017) strcat(s, "u");
if (crc32("uSOGCFostXOMf",13) == 3470862481) strcat(s, "S");
if (crc32("ivfckhDUYcUTBny",15) == 43857779) strcat(s, "s");
    return s;
}

char *unrehearsable_adjectives() {
    char *s = calloc(14);
    if (crc32("CAgwwl",6) == 2393430965) strcat(s, "u");
if (crc32("pDLuQglEGguaUvI",15) == 3293177509) strcat(s, "S");
if (crc32("AHcMhxeTQNEhW",13) == 2100269079) strcat(s, "n");
if (crc32("mfBSdxKyOVcv",12) == 3443084427) strcat(s, "l");
if (crc32("tiCsP",5) == 2449162691) strcat(s, "r");
if (crc32("QQyrEQMGWVRHKH",14) == 1549774476) strcat(s, "e");
if (crc32("WcqkoWPZbXNnF",13) == 2476592205) strcat(s, "h");
if (crc32("kfLnJT",6) == 779886694) strcat(s, "i");
if (crc32("YKJhfeHZko",10) == 297305570) strcat(s, "e");
if (crc32("kyURBXhgwF",10) == 1688878006) strcat(s, "U");
if (crc32("gGFZRSTbLxpcUZ",14) == 1518695004) strcat(s, "a");
if (crc32("HrdNAkMHGCBoX",13) == 3819704745) strcat(s, "i");
if (crc32("QpWDiRsluZ",10) == 650192694) strcat(s, "r");
if (crc32("FRdWX",5) == 3410123408) strcat(s, "b");
if (crc32("pliaNvOA",8) == 1396732199) strcat(s, "s");
if (crc32("fdxWuZR",7) == 3994835013) strcat(s, "a");
if (crc32("zUJMft",6) == 3811078808) strcat(s, "J");
if (crc32("iwKJuJWxvIU",11) == 4009544884) strcat(s, "b");
if (crc32("AwGjlUiHq",9) == 2260846786) strcat(s, "A");
if (crc32("kigAihXF",8) == 1809331521) strcat(s, "l");
if (crc32("GVnFeNUSfCkcKt",14) == 3978237507) strcat(s, "Q");
if (crc32("NfNezEAXT",9) == 3661889773) strcat(s, "e");
    return s;
}

char *possible_adjectives() {
    char *s = calloc(9);
    if (crc32("SyhwKpMSpup",11) == 2749406087) strcat(s, "p");
if (crc32("XQaVuQPNjviDBub",15) == 2183125865) strcat(s, "O");
if (crc32("avCtCgdvS",9) == 1594190220) strcat(s, "o");
if (crc32("HwzMT",5) == 687748499) strcat(s, "s");
if (crc32("YeaCh",5) == 787548461) strcat(s, "s");
if (crc32("CPgDGVTGNEQgvDO",15) == 3859666626) strcat(s, "i");
if (crc32("iGPeFXfDjDvLnYo",15) == 3132562607) strcat(s, "L");
if (crc32("UFokHqz",7) == 985164908) strcat(s, "b");
if (crc32("JrXUG",5) == 1485626824) strcat(s, "l");
if (crc32("vakAyKEkjeYo",12) == 3356223710) strcat(s, "z");
if (crc32("pgXILWdlWkDlroJ",15) == 3159759824) strcat(s, "e");
    return s;
}

char *prenegligent_adjectives() {
    char *s = calloc(13);
    if (crc32("MQqEprnr",8) == 2068490640) strcat(s, "p");
if (crc32("GpIqLEukRBSO",12) == 4237863516) strcat(s, "r");
if (crc32("rcHPSqhHteJAFJW",15) == 4160561019) strcat(s, "j");
if (crc32("WVevjqvkss",10) == 78426628) strcat(s, "e");
if (crc32("AePOXSYCF",9) == 3131749986) strcat(s, "S");
if (crc32("jnHJbxfU",8) == 3986944881) strcat(s, "n");
if (crc32("USVliDRbGyFI",12) == 429429038) strcat(s, "e");
if (crc32("DfmMv",5) == 3382844537) strcat(s, "g");
if (crc32("ONGoAurSE",9) == 1511839806) strcat(s, "l");
if (crc32("wtwzpWW",7) == 1063544255) strcat(s, "i");
if (crc32("vpjwvUufqY",10) == 2051141920) strcat(s, "U");
if (crc32("hjeAdVkZpdLar",13) == 2307078802) strcat(s, "g");
if (crc32("LNgYpgZ",7) == 3501656330) strcat(s, "T");
if (crc32("ZodkupU",7) == 100271025) strcat(s, "e");
if (crc32("BXJBx",5) == 1434719993) strcat(s, "u");
if (crc32("fwzdRMtt",8) == 2568992695) strcat(s, "n");
if (crc32("QIdpcgRJ",8) == 1842223174) strcat(s, "U");
if (crc32("CQznvLTFwwlyZVT",15) == 823483373) strcat(s, "t");
    return s;
}

char *kneadable_adjectives() {
    char *s = calloc(10);
    if (crc32("IfPoeuFJeonv",12) == 3032628878) strcat(s, "k");
if (crc32("PiAuUasTaHnpbmL",15) == 4011889805) strcat(s, "n");
if (crc32("pnLwGdr",7) == 1938925082) strcat(s, "m");
if (crc32("jadTTXKxQexBClk",15) == 385946531) strcat(s, "e");
if (crc32("FoWmZgxyE",9) == 1722368273) strcat(s, "a");
if (crc32("xkDEBewycCiDMQ",14) == 3743810750) strcat(s, "d");
if (crc32("qwZwxtu",7) == 1958835838) strcat(s, "a");
if (crc32("QhSnePkaJSgtJ",13) == 2310465494) strcat(s, "b");
if (crc32("bzFXXgpFOay",11) == 1201182654) strcat(s, "E");
if (crc32("fBZkQeuH",8) == 4096219861) strcat(s, "l");
if (crc32("kdPjeygXgm",10) == 2364677004) strcat(s, "y");
if (crc32("LrKofTcGHcqnXW",14) == 3845363826) strcat(s, "e");
    return s;
}

char *sexlimited_adjectives() {
    char *s = calloc(11);
    if (crc32("hxwDatqcWaiVjpk",15) == 1333070883) strcat(s, "s");
if (crc32("kPszgSU",7) == 1705796408) strcat(s, "e");
if (crc32("IbyZFaDhHF",10) == 1053330044) strcat(s, "g");
if (crc32("KlZLNTHtM",9) == 1554932500) strcat(s, "x");
if (crc32("zMXAGWafQNaTl",13) == 2410664430) strcat(s, "y");
if (crc32("najsqYWhFW",10) == 1297632542) strcat(s, "l");
if (crc32("nafGiePxjptW",12) == 550917825) strcat(s, "i");
if (crc32("quSVhJiDMBq",11) == 380002733) strcat(s, "C");
if (crc32("btlPIS",6) == 909761524) strcat(s, "m");
if (crc32("PjiQVQ",6) == 1390568416) strcat(s, "O");
if (crc32("uPGpuK",6) == 860548965) strcat(s, "i");
if (crc32("nJTtlP",6) == 617325127) strcat(s, "t");
if (crc32("nRFqghVOtHycrR",14) == 3601436815) strcat(s, "e");
if (crc32("ltRBzQMlx",9) == 2912549138) strcat(s, "d");
    return s;
}

char *sidewhiskered_adjectives() {
    char *s = calloc(14);
    if (crc32("ZNBeTkV",7) == 1860488770) strcat(s, "s");
if (crc32("rlHbvTlTIQqT",12) == 3369225854) strcat(s, "i");
if (crc32("SFSkfvOmNMjl",12) == 3121658734) strcat(s, "W");
if (crc32("cKlSPHc",7) == 1198559990) strcat(s, "d");
if (crc32("LindsWx",7) == 507002009) strcat(s, "G");
if (crc32("coZYleRdf",9) == 3159030131) strcat(s, "e");
if (crc32("sYQpdpIQ",8) == 4212105288) strcat(s, "a");
if (crc32("ZFJgVkzJozqGT",13) == 400332789) strcat(s, "w");
if (crc32("lyzPmMHKaqNEm",13) == 3185530715) strcat(s, "N");
if (crc32("QvkTcgyefMW",11) == 2376927754) strcat(s, "h");
if (crc32("SKOvTvEAr",9) == 350677982) strcat(s, "i");
if (crc32("QsCCxT",6) == 617292330) strcat(s, "w");
if (crc32("KjmhmRLo",8) == 76454833) strcat(s, "s");
if (crc32("mVtfws",6) == 3012479138) strcat(s, "k");
if (crc32("LNvkQsyMQXJJk",13) == 1730510517) strcat(s, "F");
if (crc32("tNRwWauyqdzL",12) == 443297252) strcat(s, "e");
if (crc32("iTMeGabuLpoHbzR",15) == 3693838849) strcat(s, "g");
if (crc32("NxGZDHAxP",9) == 2907958750) strcat(s, "r");
if (crc32("UFWdCl",6) == 3160862812) strcat(s, "e");
if (crc32("tcbIidqHPM",10) == 1712231294) strcat(s, "d");
    return s;
}

char *limber_adjectives() {
    char *s = calloc(7);
    if (crc32("stWxpBN",7) == 987178296) strcat(s, "u");
if (crc32("rGNlHIXVo",9) == 2916747296) strcat(s, "l");
if (crc32("pLZTqmmHtYEE",12) == 1488934340) strcat(s, "i");
if (crc32("YgOsPDQ",7) == 797830556) strcat(s, "M");
if (crc32("yTcdOoxag",9) == 241842192) strcat(s, "m");
if (crc32("PruJJFfENal",11) == 583556905) strcat(s, "b");
if (crc32("GqakFZg",7) == 3050466053) strcat(s, "X");
if (crc32("YpqxUQZGQLEnnlt",15) == 1909687617) strcat(s, "e");
if (crc32("qKvSTPmMROM",11) == 2837310596) strcat(s, "r");
    return s;
}

char *supplemental_adjectives() {
    char *s = calloc(13);
    if (crc32("OldWKsGphyuxJ",13) == 211098025) strcat(s, "H");
if (crc32("tEqgHJOWC",9) == 2283148310) strcat(s, "s");
if (crc32("qCfqruXikXk",11) == 1037882236) strcat(s, "S");
if (crc32("SgfdrrepXr",10) == 2974732242) strcat(s, "u");
if (crc32("IdKtBSmDctYtXqY",15) == 4019480802) strcat(s, "C");
if (crc32("IctYqghmAQqR",12) == 1745074150) strcat(s, "p");
if (crc32("SANJF",5) == 1964285630) strcat(s, "p");
if (crc32("AffuKZemB",9) == 3502774006) strcat(s, "o");
if (crc32("tLtrNbpkxg",10) == 3125686150) strcat(s, "l");
if (crc32("UvJSrbOwYeVeaN",14) == 1039832959) strcat(s, "e");
if (crc32("rmmFUVCItQYTtO",14) == 3604022538) strcat(s, "m");
if (crc32("cxnjVvEYieFU",12) == 2783715671) strcat(s, "e");
if (crc32("GVPMPGErB",9) == 2047449252) strcat(s, "V");
if (crc32("WXzxQbMGKngKHUQ",15) == 2727282178) strcat(s, "n");
if (crc32("cWivOjdzYpjWOXt",15) == 48479249) strcat(s, "e");
if (crc32("WVEcC",5) == 1965282269) strcat(s, "t");
if (crc32("CmziU",5) == 3865403977) strcat(s, "a");
if (crc32("CgzZORZQxz",10) == 3999883414) strcat(s, "l");
if (crc32("rYcjjCV",7) == 1527774024) strcat(s, "l");
    return s;
}

char *parabolic_adjectives() {
    char *s = calloc(10);
    if (crc32("oOlBsIyOYYTa",12) == 2320506428) strcat(s, "Z");
if (crc32("iIOenNQRIq",10) == 1517809262) strcat(s, "p");
if (crc32("GnsopO",6) == 1992357059) strcat(s, "a");
if (crc32("MtyiPrDSSJNuvVS",15) == 25803338) strcat(s, "r");
if (crc32("kTjPKaQFGBsa",12) == 1556666496) strcat(s, "a");
if (crc32("KgiLhnTWTyFtF",13) == 963766648) strcat(s, "b");
if (crc32("FUKnio",6) == 4284390744) strcat(s, "o");
if (crc32("TnbfmufaGnTbsMZ",15) == 2683391435) strcat(s, "X");
if (crc32("dHNjyuikURwzq",13) == 1134339152) strcat(s, "l");
if (crc32("VoReSkMxNbX",11) == 693524040) strcat(s, "i");
if (crc32("VWKgHBKh",8) == 178628890) strcat(s, "I");
if (crc32("vJdTjgER",8) == 2700609620) strcat(s, "c");
    return s;
}

char *unlanded_adjectives() {
    char *s = calloc(9);
    if (crc32("XRXuirRXH",9) == 182550463) strcat(s, "u");
if (crc32("LrPBYriqf",9) == 1884916056) strcat(s, "u");
if (crc32("qZtiX",5) == 609687552) strcat(s, "n");
if (crc32("JTanzp",6) == 3496065154) strcat(s, "f");
if (crc32("DEwhj",5) == 2523313831) strcat(s, "l");
if (crc32("jnRYuh",6) == 1275283856) strcat(s, "g");
if (crc32("SHwEFqhmeHRdhNQ",15) == 653523782) strcat(s, "a");
if (crc32("tcetf",5) == 1115527339) strcat(s, "n");
if (crc32("ILzWaicwecTA",12) == 449493777) strcat(s, "m");
if (crc32("HZXMS",5) == 3742057821) strcat(s, "d");
if (crc32("KzMTkkcRTe",10) == 4182698660) strcat(s, "R");
if (crc32("yZEhAZNSVEqGF",13) == 2088391417) strcat(s, "e");
if (crc32("ODbEAPSpffYwU",13) == 1127875232) strcat(s, "d");
    return s;
}

char *tough_adjectives() {
    char *s = calloc(6);
    if (crc32("lKGiAoLe",8) == 361157489) strcat(s, "y");
if (crc32("pdKre",5) == 3618282244) strcat(s, "t");
if (crc32("TflefQoyXCv",11) == 1014570336) strcat(s, "c");
if (crc32("SmuXJcK",7) == 3596865608) strcat(s, "o");
if (crc32("URTnVJoF",8) == 3955704004) strcat(s, "d");
if (crc32("ddhcdCTZqGKFRLw",15) == 3415188297) strcat(s, "u");
if (crc32("qVpAJuxyQyGcu",13) == 1619188181) strcat(s, "g");
if (crc32("jlHiwMchxsAiqOd",15) == 55006129) strcat(s, "K");
if (crc32("WEUpREiU",8) == 822672244) strcat(s, "h");
    return s;
}

char *overloyal_adjectives() {
    char *s = calloc(10);
    if (crc32("aagfx",5) == 395996661) strcat(s, "L");
if (crc32("yVxHayCymLxd",12) == 3617836154) strcat(s, "o");
if (crc32("aGDSAZuHcG",10) == 3926997225) strcat(s, "v");
if (crc32("JgIFGLWwblcy",12) == 1512595707) strcat(s, "e");
if (crc32("jHHvrKnDvRNvjy",14) == 1585668343) strcat(s, "Y");
if (crc32("UxeIZDb",7) == 3938211931) strcat(s, "r");
if (crc32("GoQiGMaZ",8) == 3984879411) strcat(s, "d");
if (crc32("CDxUHJk",7) == 3880283993) strcat(s, "l");
if (crc32("xpQoHg",6) == 1949113324) strcat(s, "o");
if (crc32("dwqXSB",6) == 3346573953) strcat(s, "T");
if (crc32("GMblPsc",7) == 2165429706) strcat(s, "y");
if (crc32("pNzqtgDcuEuTqFn",15) == 162615946) strcat(s, "a");
if (crc32("aFblaj",6) == 2763657177) strcat(s, "l");
    return s;
}

char *nondoubtable_adjectives() {
    char *s = calloc(13);
    if (crc32("RzvoAM",6) == 1022715820) strcat(s, "c");
if (crc32("WSIKdhAlqquV",12) == 3469487315) strcat(s, "n");
if (crc32("FerMZRWKg",9) == 2712949263) strcat(s, "o");
if (crc32("VpbdzujpfTbJA",13) == 4062480385) strcat(s, "p");
if (crc32("RRKmupcXRWX",11) == 2075565018) strcat(s, "n");
if (crc32("amtKWktntGvfTRE",15) == 2130389828) strcat(s, "H");
if (crc32("ZZbVMOtWwNahWep",15) == 2440079804) strcat(s, "d");
if (crc32("GlXcwjJhfpOaml",14) == 1985023881) strcat(s, "o");
if (crc32("mPNNhK",6) == 868776058) strcat(s, "Y");
if (crc32("GfoHCfloUcFhy",13) == 721547712) strcat(s, "u");
if (crc32("nEpYxklgmbnneny",15) == 3835553507) strcat(s, "J");
if (crc32("pvOpKz",6) == 4171864026) strcat(s, "b");
if (crc32("RVvuOQkMYZ",10) == 76746688) strcat(s, "t");
if (crc32("qppnJLdGYDBylW",14) == 711355929) strcat(s, "d");
if (crc32("mJpDbcqaAVxP",12) == 122716934) strcat(s, "a");
if (crc32("HhTEiyQgDyAr",12) == 3375218017) strcat(s, "I");
if (crc32("xtTaistzOf",10) == 2826177737) strcat(s, "b");
if (crc32("qTjzNTmYVFeY",12) == 1438450523) strcat(s, "l");
if (crc32("RxSxQkz",7) == 1154022381) strcat(s, "e");
    return s;
}

char *ceroplastic_adjectives() {
    char *s = calloc(12);
    if (crc32("KtgfrwtgvchPl",13) == 1158036144) strcat(s, "c");
if (crc32("ezuFfgGcFSbkgM",14) == 258439028) strcat(s, "z");
if (crc32("nVzITIFYLrN",11) == 3857060566) strcat(s, "e");
if (crc32("yKPbDdiebFTybM",14) == 1883970455) strcat(s, "a");
if (crc32("tWhYIWYxYPSr",12) == 3598355259) strcat(s, "r");
if (crc32("XxhAbfps",8) == 89936358) strcat(s, "w");
if (crc32("inXOWUOSe",9) == 2633249607) strcat(s, "o");
if (crc32("JgQKVNxjzENWkq",14) == 2322321203) strcat(s, "Q");
if (crc32("RhUdLdrBi",9) == 3543715925) strcat(s, "p");
if (crc32("VeJRqAw",7) == 2217181799) strcat(s, "l");
if (crc32("LRsMxgxY",8) == 2496486586) strcat(s, "a");
if (crc32("yyPXvJOzziU",11) == 421986725) strcat(s, "s");
if (crc32("xyMEUohKC",9) == 1292815148) strcat(s, "t");
if (crc32("LYoFmxIao",9) == 2691535733) strcat(s, "E");
if (crc32("HxzgMkaDgFj",11) == 3961957140) strcat(s, "i");
if (crc32("ERfQFsjCdVHnK",13) == 1582372233) strcat(s, "c");
    return s;
}

char *welltold_adjectives() {
    char *s = calloc(9);
    if (crc32("XkDkByhIORicQrP",15) == 1902884625) strcat(s, "w");
if (crc32("nrBXsbg",7) == 4264510399) strcat(s, "e");
if (crc32("pKbNnsCQMST",11) == 41083349) strcat(s, "l");
if (crc32("uTNcW",5) == 1923374254) strcat(s, "l");
if (crc32("jnQQK",5) == 1580789788) strcat(s, "q");
if (crc32("NtUNHogG",8) == 633164158) strcat(s, "t");
if (crc32("xgeOLWJa",8) == 1578000295) strcat(s, "o");
if (crc32("dUJxRTMSG",9) == 4204420182) strcat(s, "l");
if (crc32("WbfjvDdxPIfdPQ",14) == 3588235992) strcat(s, "d");
    return s;
}

char *nongilled_adjectives() {
    char *s = calloc(10);
    if (crc32("KmWjrRyUbMzhk",13) == 1019632146) strcat(s, "n");
if (crc32("erMqo",5) == 3316469210) strcat(s, "o");
if (crc32("YeoRLbpdeYcMfa",14) == 560852067) strcat(s, "n");
if (crc32("MhUDKclFBet",11) == 928307997) strcat(s, "g");
if (crc32("ugWBra",6) == 2028803524) strcat(s, "w");
if (crc32("wgFkleUl",8) == 107044788) strcat(s, "i");
if (crc32("BgqODaw",7) == 3463880387) strcat(s, "e");
if (crc32("dDjzFPhd",8) == 2935134639) strcat(s, "l");
if (crc32("QqszcfTx",8) == 3099647936) strcat(s, "h");
if (crc32("NzhBa",5) == 2606610204) strcat(s, "l");
if (crc32("rWPEmKkITx",10) == 566527110) strcat(s, "I");
if (crc32("GImEMs",6) == 3317354612) strcat(s, "e");
if (crc32("UQYruPXpHBMnyn",14) == 401794460) strcat(s, "d");
    return s;
}

char *intertergal_adjectives() {
    char *s = calloc(12);
    if (crc32("WoCZwikmy",9) == 2446570134) strcat(s, "i");
if (crc32("foscYUqNqDJjKG",14) == 2005537728) strcat(s, "y");
if (crc32("WlMOknPrg",9) == 1003759286) strcat(s, "n");
if (crc32("hnftLCcpVCn",11) == 3715728571) strcat(s, "j");
if (crc32("nULYTrYCVQKU",12) == 4243945672) strcat(s, "t");
if (crc32("BeiVDXIdhICf",12) == 2917176026) strcat(s, "e");
if (crc32("baquBPD",7) == 2603072546) strcat(s, "J");
if (crc32("YLtDrYOND",9) == 2612942363) strcat(s, "r");
if (crc32("ndLAcy",6) == 3672370757) strcat(s, "o");
if (crc32("RlRPJ",5) == 3062574089) strcat(s, "t");
if (crc32("UzgagzZnSbMAoA",14) == 4230266029) strcat(s, "s");
if (crc32("ipDHsCjJFLyog",13) == 3397361766) strcat(s, "e");
if (crc32("uGFbBO",6) == 3523137697) strcat(s, "r");
if (crc32("sSXYziJkgwHowV",14) == 396223658) strcat(s, "Q");
if (crc32("sGgzKumr",8) == 280343836) strcat(s, "g");
if (crc32("vQUJrIPH",8) == 3095279231) strcat(s, "a");
if (crc32("zjPrslyHDYC",11) == 2621671309) strcat(s, "C");
if (crc32("hhOluUHOO",9) == 3978495281) strcat(s, "l");
    return s;
}

char *choking_adjectives() {
    char *s = calloc(8);
    if (crc32("huZXNhQYa",9) == 3384900457) strcat(s, "h");
if (crc32("yTCOsrJzQAgx",12) == 1291169426) strcat(s, "c");
if (crc32("KByLD",5) == 3633884286) strcat(s, "y");
if (crc32("xFiTLq",6) == 3612736672) strcat(s, "h");
if (crc32("XQRAfcqQeyxsPZ",14) == 2897312990) strcat(s, "o");
if (crc32("gOqCQYOHfl",10) == 4228859626) strcat(s, "o");
if (crc32("DwCYIhchc",9) == 3217668083) strcat(s, "K");
if (crc32("kenjhGsn",8) == 4111344579) strcat(s, "k");
if (crc32("MnyqGb",6) == 3091750863) strcat(s, "R");
if (crc32("UwoimtsRCSBjUQ",14) == 2190103857) strcat(s, "i");
if (crc32("dSnpT",5) == 1918405869) strcat(s, "n");
if (crc32("GaAOaWlPOQdO",12) == 717944856) strcat(s, "g");
    return s;
}

char *beholden_adjectives() {
    char *s = calloc(9);
    if (crc32("QRtjKLjsPfSe",12) == 1554164201) strcat(s, "k");
if (crc32("nSYgHIDJsBxaXq",14) == 1426834443) strcat(s, "b");
if (crc32("JyDrmNOiz",9) == 2370106607) strcat(s, "e");
if (crc32("tlVODetY",8) == 47501795) strcat(s, "h");
if (crc32("livxDMt",7) == 4236669811) strcat(s, "w");
if (crc32("rbsNLCc",7) == 275865020) strcat(s, "o");
if (crc32("SdBZM",5) == 921891599) strcat(s, "l");
if (crc32("qJBsQ",5) == 1575633341) strcat(s, "K");
if (crc32("NYEXplEMKT",10) == 816636195) strcat(s, "d");
if (crc32("iogAD",5) == 2700508254) strcat(s, "w");
if (crc32("QkvRfiYB",8) == 1079498888) strcat(s, "e");
if (crc32("PSayPLZ",7) == 1709140078) strcat(s, "H");
if (crc32("KWMGFvuSyTRDh",13) == 2273146761) strcat(s, "n");
    return s;
}

char *coaliest_adjectives() {
    char *s = calloc(9);
    if (crc32("QmapINyPrmlpFo",14) == 4075268092) strcat(s, "c");
if (crc32("obeDQiw",7) == 3404163344) strcat(s, "Z");
if (crc32("PVetKfYXyhzZtx",14) == 1206838588) strcat(s, "o");
if (crc32("blLLTuoHg",9) == 3513145644) strcat(s, "a");
if (crc32("itoibKBvDfylEy",14) == 2566385596) strcat(s, "I");
if (crc32("xvkGLhZx",8) == 2487482960) strcat(s, "l");
if (crc32("tolwHPzSaCm",11) == 1315786431) strcat(s, "d");
if (crc32("KHIinmCq",8) == 3185897851) strcat(s, "i");
if (crc32("lQpvA",5) == 3307127472) strcat(s, "e");
if (crc32("TNwdDK",6) == 2333690762) strcat(s, "n");
if (crc32("AMhOpV",6) == 4257643700) strcat(s, "s");
if (crc32("ZABDwXKyDbeAqi",14) == 1950556476) strcat(s, "r");
if (crc32("AKfzJAEcaiLVYmA",15) == 2256356027) strcat(s, "t");
    return s;
}

char *undetained_adjectives() {
    char *s = calloc(11);
    if (crc32("HnhYUai",7) == 3855522223) strcat(s, "u");
if (crc32("cycUCm",6) == 1624501116) strcat(s, "n");
if (crc32("jdHggyFtOflW",12) == 691372196) strcat(s, "d");
if (crc32("VcFVfLpFFRAMsV",14) == 3779047528) strcat(s, "I");
if (crc32("XHTqsadaqfjHN",13) == 3829091936) strcat(s, "e");
if (crc32("mLMYslLIsIofY",13) == 2280599172) strcat(s, "Z");
if (crc32("FAQUlkaTqYPhB",13) == 4179761562) strcat(s, "t");
if (crc32("oDdrHY",6) == 741675666) strcat(s, "a");
if (crc32("SExslV",6) == 414679763) strcat(s, "i");
if (crc32("zDFHHSThIf",10) == 3411083832) strcat(s, "w");
if (crc32("uBnBVUHjNI",10) == 1162204472) strcat(s, "n");
if (crc32("SSIJJE",6) == 3545916368) strcat(s, "e");
if (crc32("oWeoRf",6) == 2709290848) strcat(s, "d");
    return s;
}

char *postlabial_adjectives() {
    char *s = calloc(11);
    if (crc32("TRGgGp",6) == 1642749555) strcat(s, "w");
if (crc32("ZhKyxIcBzTE",11) == 1160183715) strcat(s, "p");
if (crc32("xIaQzunZJg",10) == 3020470141) strcat(s, "H");
if (crc32("NUEFu",5) == 758107326) strcat(s, "o");
if (crc32("jqcnfyMpQI",10) == 4231702737) strcat(s, "s");
if (crc32("woYIwYwY",8) == 661099408) strcat(s, "t");
if (crc32("lFOQmoBiPTjLAne",15) == 4041479600) strcat(s, "L");
if (crc32("Wwsob",5) == 2912411126) strcat(s, "l");
if (crc32("aDkGjPDcRcy",11) == 3955331712) strcat(s, "K");
if (crc32("xBnMLBl",7) == 2966214601) strcat(s, "a");
if (crc32("rdidvyAfSm",10) == 1144703431) strcat(s, "b");
if (crc32("cphNPfkqGmm",11) == 1499705367) strcat(s, "G");
if (crc32("sKRNPLEEir",10) == 3760630733) strcat(s, "i");
if (crc32("iNIWTdu",7) == 1775755254) strcat(s, "w");
if (crc32("yTKhHCdGOY",10) == 1381622132) strcat(s, "a");
if (crc32("dYRhj",5) == 2154213181) strcat(s, "o");
if (crc32("vAgBOfWZrpWi",12) == 1268466767) strcat(s, "l");
    return s;
}

char *proctologic_adjectives() {
    char *s = calloc(12);
    if (crc32("QBUgtRZ",7) == 1553424043) strcat(s, "p");
if (crc32("EbIjiwUHY",9) == 3130303657) strcat(s, "r");
if (crc32("wupyCMfE",8) == 1169821130) strcat(s, "z");
if (crc32("DrcEoEqlJH",10) == 1807165535) strcat(s, "o");
if (crc32("sxnVPaqD",8) == 1760384357) strcat(s, "g");
if (crc32("nmPmQwdanPE",11) == 4134135806) strcat(s, "c");
if (crc32("WDmFCkZqDYkQ",12) == 1984748648) strcat(s, "t");
if (crc32("RRXmWWIpi",9) == 1265906626) strcat(s, "g");
if (crc32("xBJFxBDAkiChBaH",15) == 1859012172) strcat(s, "o");
if (crc32("EtAvOstZUCGRaF",14) == 321880076) strcat(s, "l");
if (crc32("UIpbvJDO",8) == 257616559) strcat(s, "q");
if (crc32("ptSwjPaeTvOXAtZ",15) == 1911328095) strcat(s, "o");
if (crc32("HtZyxDG",7) == 615844951) strcat(s, "q");
if (crc32("ZaktO",5) == 3735647267) strcat(s, "g");
if (crc32("yjNzXW",6) == 971213915) strcat(s, "y");
if (crc32("QQKBU",5) == 358716284) strcat(s, "i");
if (crc32("dePgJA",6) == 1803048061) strcat(s, "h");
if (crc32("oAmjKiDEABUXgm",14) == 602228464) strcat(s, "c");
    return s;
}

char *fivegaited_adjectives() {
    char *s = calloc(11);
    if (crc32("HIUbIywaalCVt",13) == 2926922651) strcat(s, "f");
if (crc32("bqhhxBlIzGhoruY",15) == 3846623115) strcat(s, "i");
if (crc32("JvpIelF",7) == 2806588712) strcat(s, "v");
if (crc32("kykICjXWCVTt",12) == 1129447728) strcat(s, "i");
if (crc32("zEkeZebyI",9) == 4152681220) strcat(s, "e");
if (crc32("eyunRIEhU",9) == 2581236135) strcat(s, "G");
if (crc32("SxcTOeMp",8) == 3125190699) strcat(s, "g");
if (crc32("pwttY",5) == 1370337449) strcat(s, "s");
if (crc32("DCdGG",5) == 4205744202) strcat(s, "a");
if (crc32("AcPXYKPq",8) == 3117238861) strcat(s, "L");
if (crc32("cLceVxw",7) == 3430157534) strcat(s, "i");
if (crc32("prxueZNtSW",10) == 234594531) strcat(s, "P");
if (crc32("xlUKyAo",7) == 4000596166) strcat(s, "t");
if (crc32("YCEOfC",6) == 2389599484) strcat(s, "e");
if (crc32("ZwHAhL",6) == 2861813212) strcat(s, "d");
    return s;
}

char *dresscoated_adjectives() {
    char *s = calloc(12);
    if (crc32("FizHFagXEIvNvl",14) == 1388274965) strcat(s, "d");
if (crc32("tSuKEtxjh",9) == 3120022572) strcat(s, "r");
if (crc32("VcltVFuTCgwVScf",15) == 3650774492) strcat(s, "j");
if (crc32("OHWgqM",6) == 38049206) strcat(s, "e");
if (crc32("qMqrgGtm",8) == 3357328125) strcat(s, "s");
if (crc32("dDlmI",5) == 3475298458) strcat(s, "v");
if (crc32("fPpuvibpMHYc",12) == 3904078969) strcat(s, "s");
if (crc32("shQacBqsI",9) == 3683459585) strcat(s, "c");
if (crc32("WkHdsLxhbECIif",14) == 208617479) strcat(s, "O");
if (crc32("irtfyE",6) == 1298643815) strcat(s, "o");
if (crc32("nSOnRHcgRoge",12) == 171397485) strcat(s, "h");
if (crc32("rwbLQJqmCDkoKe",14) == 934390981) strcat(s, "a");
if (crc32("vqGvWUiDzSc",11) == 2457433851) strcat(s, "t");
if (crc32("JZeYcZrIdcutw",13) == 1525229541) strcat(s, "e");
if (crc32("vIPMfDAppUikxdo",15) == 3204792001) strcat(s, "d");
    return s;
}

char *zeroth_adjectives() {
    char *s = calloc(7);
    if (crc32("mUQWuGzVo",9) == 3699389769) strcat(s, "t");
if (crc32("VVpcwSbgjzUPo",13) == 769484423) strcat(s, "z");
if (crc32("kipfMQptvjxrLxi",15) == 1225984237) strcat(s, "L");
if (crc32("lwzMFROOevyzf",13) == 2135423383) strcat(s, "e");
if (crc32("bgrqkiXXxmYgr",13) == 2257157453) strcat(s, "o");
if (crc32("rrpCT",5) == 1738919390) strcat(s, "r");
if (crc32("zlIffsTrcutkWKY",15) == 3758536489) strcat(s, "o");
if (crc32("uBBlBaCMOfQK",12) == 3865814071) strcat(s, "s");
if (crc32("DGGnNFhk",8) == 94252146) strcat(s, "t");
if (crc32("dQufCo",6) == 825658791) strcat(s, "h");
    return s;
}

char *housebound_adjectives() {
    char *s = calloc(11);
    if (crc32("joZhFk",6) == 2650294286) strcat(s, "h");
if (crc32("dHVYj",5) == 1512008219) strcat(s, "o");
if (crc32("puoeKUzysXgMp",13) == 3652476273) strcat(s, "Z");
if (crc32("NFiMoiUFrE",10) == 3673326331) strcat(s, "u");
if (crc32("RRtTLjkw",8) == 1847425203) strcat(s, "G");
if (crc32("pBqafLoEFrLCoN",14) == 3105592273) strcat(s, "s");
if (crc32("DXvxTanZM",9) == 3232320146) strcat(s, "w");
if (crc32("dDSflwXuvMcqa",13) == 3238370755) strcat(s, "e");
if (crc32("Vaahx",5) == 1208280230) strcat(s, "b");
if (crc32("WPOOFkktTu",10) == 4268385184) strcat(s, "o");
if (crc32("IFkKXokQOGiigeB",15) == 1611913734) strcat(s, "u");
if (crc32("NVRmMC",6) == 2273483042) strcat(s, "R");
if (crc32("zGDGShYliBf",11) == 951827684) strcat(s, "n");
if (crc32("hjbRlzb",7) == 959106021) strcat(s, "i");
if (crc32("uQZEMTsFvXzTmd",14) == 2070223720) strcat(s, "d");
    return s;
}

char *autoerotic_adjectives() {
    char *s = calloc(11);
    if (crc32("MSvzmFiXBxtXDK",14) == 1788229647) strcat(s, "a");
if (crc32("CAxzg",5) == 3333641895) strcat(s, "O");
if (crc32("EhIvWzesbJYRo",13) == 2314722279) strcat(s, "u");
if (crc32("SQjYtGAocXrr",12) == 3586197623) strcat(s, "Q");
if (crc32("SsPgeW",6) == 4005218391) strcat(s, "t");
if (crc32("NCJEBFQso",9) == 652362004) strcat(s, "w");
if (crc32("tEPjdqLw",8) == 4158520163) strcat(s, "o");
if (crc32("ambDtvzoFRAHVkg",15) == 4097095969) strcat(s, "E");
if (crc32("zCTsYkohqGzOeo",14) == 198347136) strcat(s, "e");
if (crc32("yLMlfZsQQnZyl",13) == 4173779616) strcat(s, "v");
if (crc32("rDNqzHirr",9) == 1208455389) strcat(s, "r");
if (crc32("bqGBRZJmjlLPxXO",15) == 268861816) strcat(s, "o");
if (crc32("NPDzASg",7) == 524253767) strcat(s, "t");
if (crc32("QdeKuEaeiC",10) == 927254742) strcat(s, "i");
if (crc32("zxAsVEiPSC",10) == 2916698049) strcat(s, "E");
if (crc32("WXZgVsPS",8) == 1559550407) strcat(s, "c");
    return s;
}

char *comparative_adjectives() {
    char *s = calloc(12);
    if (crc32("QMWttSd",7) == 1305963397) strcat(s, "c");
if (crc32("MOxqfKs",7) == 3963619828) strcat(s, "I");
if (crc32("ABetCLtIdoxfjQ",14) == 1943855815) strcat(s, "o");
if (crc32("uXFRspKAy",9) == 4127633113) strcat(s, "e");
if (crc32("wRLlXLtjosRxa",13) == 3645492435) strcat(s, "m");
if (crc32("IKQELkAKxHlxkxB",15) == 2485202083) strcat(s, "i");
if (crc32("KkrwogSMEkxC",12) == 2725738131) strcat(s, "p");
if (crc32("ryyYElmRBniPlBT",15) == 1648910529) strcat(s, "o");
if (crc32("cvvSaeRyj",9) == 2020755323) strcat(s, "a");
if (crc32("kuvKYFDkKDw",11) == 4160703881) strcat(s, "r");
if (crc32("kQpWbAJj",8) == 1766682166) strcat(s, "q");
if (crc32("IyXgejupRQwQ",12) == 2754199965) strcat(s, "a");
if (crc32("nrmJuQD",7) == 4236824549) strcat(s, "k");
if (crc32("USxYwzY",7) == 2414186216) strcat(s, "t");
if (crc32("jjZfFDxBQW",10) == 1070206787) strcat(s, "i");
if (crc32("YXcxVnv",7) == 2446113868) strcat(s, "v");
if (crc32("zKGIPxDbGyPAb",13) == 1525155286) strcat(s, "n");
if (crc32("CQLalAkLs",9) == 1991359132) strcat(s, "e");
    return s;
}

char *unbeset_adjectives() {
    char *s = calloc(8);
    if (crc32("SlVXRSEYM",9) == 73671170) strcat(s, "u");
if (crc32("GzOBfen",7) == 461207541) strcat(s, "t");
if (crc32("VqTfjcjiY",9) == 2538986742) strcat(s, "n");
if (crc32("csfREfSGrb",10) == 4071545796) strcat(s, "E");
if (crc32("bclpK",5) == 2210355319) strcat(s, "b");
if (crc32("BniDVniFX",9) == 1269743548) strcat(s, "l");
if (crc32("XHEMIUxbm",9) == 3876881780) strcat(s, "e");
if (crc32("AfUfBo",6) == 2728959514) strcat(s, "n");
if (crc32("vqghYeKAyWO",11) == 4124127321) strcat(s, "s");
if (crc32("DnBHsGMxVdPY",12) == 1706322402) strcat(s, "e");
if (crc32("oXGCFb",6) == 1088214357) strcat(s, "q");
if (crc32("EozYEFIYH",9) == 1510440835) strcat(s, "t");
    return s;
}

char *stirrable_adjectives() {
    char *s = calloc(10);
    if (crc32("sqSvfXpvLss",11) == 1066343617) strcat(s, "s");
if (crc32("SPFis",5) == 744985132) strcat(s, "u");
if (crc32("FLzzjJ",6) == 2705292103) strcat(s, "t");
if (crc32("ktslvaoTcrSGlP",14) == 204149612) strcat(s, "i");
if (crc32("ggceiLVpdgKDWwn",15) == 192234490) strcat(s, "j");
if (crc32("AIDgwFv",7) == 306088315) strcat(s, "r");
if (crc32("rQnfjZczSfvzXLC",15) == 3681718498) strcat(s, "r");
if (crc32("ICNkaruY",8) == 1773341872) strcat(s, "a");
if (crc32("WBtUFd",6) == 3769369751) strcat(s, "b");
if (crc32("vXhatfq",7) == 963021808) strcat(s, "F");
if (crc32("PQdlxNhJbwSkCj",14) == 2789867877) strcat(s, "l");
if (crc32("KvEAV",5) == 3127813291) strcat(s, "e");
    return s;
}

char *undisclaimed_adjectives() {
    char *s = calloc(13);
    if (crc32("dULcExRZf",9) == 2930917916) strcat(s, "s");
if (crc32("gEoooHynfCSdu",13) == 3582969183) strcat(s, "u");
if (crc32("IRWfuURw",8) == 2419663663) strcat(s, "n");
if (crc32("qEMTHefnFzJVvQ",14) == 2780055705) strcat(s, "d");
if (crc32("ZSSitHdaW",9) == 2564678276) strcat(s, "U");
if (crc32("ECxAYwEFqqI",11) == 4115196285) strcat(s, "i");
if (crc32("lWvzydWHnR",10) == 3385821865) strcat(s, "G");
if (crc32("tnjRNzmKKkCI",12) == 4158589178) strcat(s, "s");
if (crc32("ECEjloLLLAmRQR",14) == 920365107) strcat(s, "D");
if (crc32("nYGNZcJMclUueC",14) == 90877510) strcat(s, "c");
if (crc32("fbclexedfDu",11) == 4226551350) strcat(s, "Y");
if (crc32("cVZpciyq",8) == 2565751989) strcat(s, "l");
if (crc32("eeSXToB",7) == 2094227771) strcat(s, "a");
if (crc32("mfapLnxeUAyolD",14) == 455651607) strcat(s, "s");
if (crc32("ceZnZepV",8) == 776246004) strcat(s, "i");
if (crc32("SWNCiBV",7) == 4160302089) strcat(s, "m");
if (crc32("pPVolxNXwTEKHA",14) == 3161700490) strcat(s, "e");
if (crc32("qSOHtOSpdGfX",12) == 3217998372) strcat(s, "i");
if (crc32("XgKvprQURgvNbR",14) == 2916664433) strcat(s, "d");
    return s;
}

char *unedible_adjectives() {
    char *s = calloc(9);
    if (crc32("ATojx",5) == 1704585263) strcat(s, "u");
if (crc32("KpyxJUor",8) == 2059529955) strcat(s, "Z");
if (crc32("tjiBaW",6) == 1311440398) strcat(s, "n");
if (crc32("uhMBVwkmf",9) == 1198839359) strcat(s, "e");
if (crc32("mIHNtIOhroZ",11) == 3789224749) strcat(s, "e");
if (crc32("LxHvtxTonZUO",12) == 3826517950) strcat(s, "d");
if (crc32("qHONVfSCTn",10) == 1759434615) strcat(s, "i");
if (crc32("maELaEzzLGC",11) == 3356249379) strcat(s, "b");
if (crc32("yLviVRCpVxojN",13) == 826715555) strcat(s, "U");
if (crc32("yrCsagd",7) == 3990434449) strcat(s, "l");
if (crc32("FalTknA",7) == 3751105173) strcat(s, "e");
    return s;
}

char *agnate_adjectives() {
    char *s = calloc(7);
    if (crc32("UzfXLHDunGqERC",14) == 2567186022) strcat(s, "M");
if (crc32("MjSlLgaaAeLrn",13) == 3057580989) strcat(s, "a");
if (crc32("AmZzyk",6) == 3442455481) strcat(s, "g");
if (crc32("UwvWbXylhfNr",12) == 606343661) strcat(s, "l");
if (crc32("gtYoniIUeWKnyoA",15) == 3977283086) strcat(s, "n");
if (crc32("iwpJdhiJC",9) == 3264351122) strcat(s, "a");
if (crc32("YFeJQ",5) == 87652140) strcat(s, "x");
if (crc32("jFogty",6) == 2202628076) strcat(s, "t");
if (crc32("gCcoEE",6) == 2718700308) strcat(s, "z");
if (crc32("bLOMO",5) == 744526593) strcat(s, "e");
    return s;
}

char *astral_adjectives() {
    char *s = calloc(7);
    if (crc32("zjUmMZs",7) == 3032389769) strcat(s, "a");
if (crc32("fgZCexiKtJ",10) == 3226766325) strcat(s, "s");
if (crc32("kbHDkyURIT",10) == 1807155307) strcat(s, "n");
if (crc32("QphIsueQIdnrw",13) == 887024076) strcat(s, "t");
if (crc32("lqUQmPLGUMyPw",13) == 3621992960) strcat(s, "U");
if (crc32("BOhaCHvjLPVCmQO",15) == 4056559595) strcat(s, "r");
if (crc32("xPJBfeOZEup",11) == 3520261538) strcat(s, "e");
if (crc32("ivLXON",6) == 3175304590) strcat(s, "a");
if (crc32("XZAuGsWS",8) == 1153291897) strcat(s, "P");
if (crc32("obtzmHA",7) == 3557468076) strcat(s, "l");
    return s;
}

char *crowded_adjectives() {
    char *s = calloc(8);
    if (crc32("mapEOlygIQvs",12) == 2600068042) strcat(s, "K");
if (crc32("DUeiWsRZvLzRJc",14) == 4056703062) strcat(s, "c");
if (crc32("yYjGskUrA",9) == 64238692) strcat(s, "C");
if (crc32("hEJIdcVcVp",10) == 2308270605) strcat(s, "r");
if (crc32("EGifvHM",7) == 1943858773) strcat(s, "o");
if (crc32("EjoGeAGaom",10) == 2032734790) strcat(s, "w");
if (crc32("ytveBR",6) == 3604959345) strcat(s, "d");
if (crc32("UqttoOFD",8) == 1008814351) strcat(s, "q");
if (crc32("ANHgXaJtVNba",12) == 298699864) strcat(s, "e");
if (crc32("IdRNKJGroAF",11) == 792907896) strcat(s, "o");
if (crc32("ZOtWXWeSiy",10) == 401993117) strcat(s, "d");
    return s;
}

char *unanswering_adjectives() {
    char *s = calloc(12);
    if (crc32("RFqlTxgghv",10) == 3604323806) strcat(s, "q");
if (crc32("yAOFYErxKhoZPJN",15) == 241141336) strcat(s, "u");
if (crc32("LuhEJogdnvlQI",13) == 471250447) strcat(s, "n");
if (crc32("QaWjttPhMDb",11) == 3990122255) strcat(s, "G");
if (crc32("UaoWVSPZyMa",11) == 4069306094) strcat(s, "a");
if (crc32("uFNmxgWqKekgzKY",15) == 3634008801) strcat(s, "W");
if (crc32("bBxkWY",6) == 3683224234) strcat(s, "n");
if (crc32("oNqbWCyDJEhR",12) == 3492389170) strcat(s, "s");
if (crc32("NMBQUeXCCZR",11) == 4075702899) strcat(s, "s");
if (crc32("EpLBan",6) == 1672835617) strcat(s, "w");
if (crc32("qSarigmh",8) == 3486731185) strcat(s, "e");
if (crc32("KRpdJVd",7) == 3188371117) strcat(s, "V");
if (crc32("JLrVbHVlUszfS",13) == 160390069) strcat(s, "r");
if (crc32("GXhTrnseErX",11) == 102041545) strcat(s, "J");
if (crc32("NDewtfqZcLvh",12) == 2141478188) strcat(s, "i");
if (crc32("NVcTaWP",7) == 519476392) strcat(s, "n");
if (crc32("seBAcNebgeTiH",13) == 1847018583) strcat(s, "y");
if (crc32("HrnPBx",6) == 4195344388) strcat(s, "g");
    return s;
}

char *supercivil_adjectives() {
    char *s = calloc(11);
    if (crc32("TmkOQgLKKPrTYH",14) == 2705238844) strcat(s, "N");
if (crc32("sGEcKo",6) == 4269567460) strcat(s, "s");
if (crc32("JlogydDQVQH",11) == 1250839265) strcat(s, "u");
if (crc32("CzIZSIcWOKpO",12) == 4166178130) strcat(s, "r");
if (crc32("txzDS",5) == 1542086312) strcat(s, "p");
if (crc32("iwHmfcanVjdjB",13) == 1537610313) strcat(s, "e");
if (crc32("qAJDUaIqdxaFNRA",15) == 1671968640) strcat(s, "D");
if (crc32("EkHzKZEnXNyt",12) == 535679808) strcat(s, "r");
if (crc32("DoWEnjTruCJwDZs",15) == 2972814825) strcat(s, "X");
if (crc32("HJjcKTWElqBo",12) == 3271723049) strcat(s, "c");
if (crc32("OdJKCvllZr",10) == 931535700) strcat(s, "I");
if (crc32("grUXHjjUo",9) == 3268918629) strcat(s, "i");
if (crc32("pcEvMMgAkSCvRvs",15) == 1823881284) strcat(s, "v");
if (crc32("MBrMjEJFjEy",11) == 2068783288) strcat(s, "F");
if (crc32("pCZyZDinbTkNFF",14) == 1992637162) strcat(s, "i");
if (crc32("AScYVrPUfhSTGVj",15) == 3812578808) strcat(s, "l");
    return s;
}

char *wellwired_adjectives() {
    char *s = calloc(10);
    if (crc32("hgiPHqDiRzF",11) == 3524159750) strcat(s, "Q");
if (crc32("XRRPihqNO",9) == 928908591) strcat(s, "w");
if (crc32("TpDdDXdWw",9) == 1738699653) strcat(s, "X");
if (crc32("OuAbk",5) == 3163766313) strcat(s, "e");
if (crc32("IkNuCjz",7) == 1757280874) strcat(s, "x");
if (crc32("gyuFEvjpWWGD",12) == 1346416065) strcat(s, "l");
if (crc32("hvkRO",5) == 190346183) strcat(s, "l");
if (crc32("lbhtceTXjQWfpgK",15) == 2059120141) strcat(s, "w");
if (crc32("WfoCOqML",8) == 125374368) strcat(s, "x");
if (crc32("CZrIBXMTez",10) == 2935986011) strcat(s, "i");
if (crc32("syCppXVVph",10) == 13512045) strcat(s, "r");
if (crc32("tTUduZkrwoyJsEY",15) == 3921357614) strcat(s, "q");
if (crc32("hqYxMYBBfvnUt",13) == 2088624350) strcat(s, "e");
if (crc32("hUTDsdfb",8) == 2346890948) strcat(s, "d");
    return s;
}

char *revolute_adjectives() {
    char *s = calloc(9);
    if (crc32("wvCxEePAAnJ",11) == 2533198672) strcat(s, "r");
if (crc32("okPCvcQl",8) == 367301712) strcat(s, "e");
if (crc32("DucoZsKqQYDsvNP",15) == 1754860445) strcat(s, "Y");
if (crc32("zzNbUFTmY",9) == 146885956) strcat(s, "v");
if (crc32("xjVoSw",6) == 435574872) strcat(s, "L");
if (crc32("AhYDAwg",7) == 2016588393) strcat(s, "o");
if (crc32("HFzWTTyG",8) == 2710860571) strcat(s, "l");
if (crc32("qVAfvaX",7) == 3053987488) strcat(s, "R");
if (crc32("GmTpDtfivjJuK",13) == 3353502256) strcat(s, "u");
if (crc32("cQvKwdrdEuhQPml",15) == 2404488343) strcat(s, "t");
if (crc32("yFfxohDqJ",9) == 501996576) strcat(s, "v");
if (crc32("LgsrinCHFO",10) == 3099016403) strcat(s, "e");
    return s;
}

char *unlibidinous_adjectives() {
    char *s = calloc(13);
    if (crc32("GefVuWWdf",9) == 1562070229) strcat(s, "u");
if (crc32("TSOCrzeoVt",10) == 2626034733) strcat(s, "n");
if (crc32("QEzBqFyij",9) == 2833196342) strcat(s, "b");
if (crc32("YuLQDGLF",8) == 1310872807) strcat(s, "l");
if (crc32("PBxLI",5) == 3259493658) strcat(s, "R");
if (crc32("UpzBQoouOjhKkup",15) == 2589148956) strcat(s, "i");
if (crc32("itpGtVvZ",8) == 4286415943) strcat(s, "Q");
if (crc32("FHXONqYzytQMgKN",15) == 1755821120) strcat(s, "b");
if (crc32("RuTBCX",6) == 2388445938) strcat(s, "j");
if (crc32("ZFkJRdEyAMJic",13) == 988634037) strcat(s, "i");
if (crc32("nusQQslNzZ",10) == 500641525) strcat(s, "d");
if (crc32("CsHgRMdrZIcI",12) == 1532333674) strcat(s, "c");
if (crc32("HKYihznYskRc",12) == 549966027) strcat(s, "i");
if (crc32("klnNtvBQ",8) == 2451105962) strcat(s, "f");
if (crc32("pgTHZlcKVf",10) == 1743942159) strcat(s, "n");
if (crc32("VveiFzgWkG",10) == 2580284160) strcat(s, "o");
if (crc32("JMPwa",5) == 3826975665) strcat(s, "k");
if (crc32("vhBlwKMwG",9) == 1031764220) strcat(s, "u");
if (crc32("kvPXNMGWtNxvN",13) == 1605112002) strcat(s, "X");
if (crc32("BesHaSvEAkAFoI",14) == 3290793903) strcat(s, "s");
    return s;
}

char *unconciliating_adjectives() {
    char *s = calloc(15);
    if (crc32("ECsDXnz",7) == 2806868338) strcat(s, "m");
if (crc32("OSxvfQKQNQX",11) == 2455907935) strcat(s, "u");
if (crc32("QqPiicNtSuIHKj",14) == 3930354177) strcat(s, "n");
if (crc32("LrRxGAFeNhnF",12) == 2406686725) strcat(s, "P");
if (crc32("JgQxkvxoy",9) == 614491966) strcat(s, "c");
if (crc32("MgrokPYfWDZPCY",14) == 121811536) strcat(s, "z");
if (crc32("YFgNGfgHf",9) == 2302591453) strcat(s, "o");
if (crc32("dGSSKDcKRHbz",12) == 3561707258) strcat(s, "N");
if (crc32("foIMSYYbdAlN",12) == 172183439) strcat(s, "n");
if (crc32("MAjkC",5) == 4011722227) strcat(s, "D");
if (crc32("spqCxZbDzH",10) == 3321327966) strcat(s, "c");
if (crc32("CXqNgyVmzM",10) == 2236854303) strcat(s, "M");
if (crc32("QddjKzvl",8) == 3953305566) strcat(s, "i");
if (crc32("roLDaPMxymKL",12) == 2991958115) strcat(s, "D");
if (crc32("rLByKgmYkREZaqv",15) == 1835215498) strcat(s, "l");
if (crc32("jtuulcB",7) == 4223560173) strcat(s, "Y");
if (crc32("vPoSNAbRqLqf",12) == 1113439870) strcat(s, "i");
if (crc32("maAkgylv",8) == 361813370) strcat(s, "a");
if (crc32("pLiyhTCZeNCP",12) == 453485900) strcat(s, "a");
if (crc32("mQJwtOebppazTiK",15) == 834502333) strcat(s, "e");
if (crc32("xTYIiWQV",8) == 3172656007) strcat(s, "t");
if (crc32("zdKZUrMKraWQXl",14) == 761681499) strcat(s, "X");
if (crc32("BlAIxVfSxBacL",13) == 2966068948) strcat(s, "i");
if (crc32("GARhY",5) == 3757227581) strcat(s, "n");
if (crc32("oneAdowjMZ",10) == 1862194832) strcat(s, "j");
if (crc32("ybfuTwHfwIzjsN",14) == 308546250) strcat(s, "g");
    return s;
}

char *halfnylon_adjectives() {
    char *s = calloc(10);
    if (crc32("chCelT",6) == 769969623) strcat(s, "B");
if (crc32("rBZPwKqZGLtXH",13) == 1328715981) strcat(s, "h");
if (crc32("vWOMs",5) == 1277332757) strcat(s, "E");
if (crc32("GjJmxq",6) == 73377509) strcat(s, "a");
if (crc32("QQYOKYRA",8) == 746048262) strcat(s, "X");
if (crc32("GnMPuNbs",8) == 2919509147) strcat(s, "l");
if (crc32("pVByfGaljq",10) == 1127096375) strcat(s, "M");
if (crc32("sByKpiGAoM",10) == 4178576287) strcat(s, "f");
if (crc32("VNvkEFJnc",9) == 1249462272) strcat(s, "n");
if (crc32("teDzx",5) == 974519117) strcat(s, "y");
if (crc32("pbUSOeMlrHhk",12) == 1292469552) strcat(s, "l");
if (crc32("srLYuB",6) == 1433026634) strcat(s, "U");
if (crc32("cWkJZqbLE",9) == 1266669774) strcat(s, "o");
if (crc32("gWDGXYciWDlA",12) == 3155031089) strcat(s, "H");
if (crc32("MBSOKnLyDi",10) == 2017782390) strcat(s, "n");
    return s;
}

char *formulable_adjectives() {
    char *s = calloc(11);
    if (crc32("AeuqVrfILgBdjPJ",15) == 2790970286) strcat(s, "f");
if (crc32("vggKBGKnX",9) == 3320718860) strcat(s, "t");
if (crc32("fsEfNAHVMTvfGeS",15) == 11537680) strcat(s, "o");
if (crc32("rMihrNga",8) == 747175285) strcat(s, "J");
if (crc32("ngVLXIMOsdMga",13) == 4124130172) strcat(s, "r");
if (crc32("cRJyZDJcPdkYYvX",15) == 4088648472) strcat(s, "m");
if (crc32("lIppGKRwN",9) == 3038920751) strcat(s, "u");
if (crc32("JTsSfi",6) == 3257625572) strcat(s, "l");
if (crc32("UjOIaeYGhbQLtO",14) == 2045104645) strcat(s, "Z");
if (crc32("rSczwBDPigZH",12) == 3885757985) strcat(s, "a");
if (crc32("hJVuSTGwSHq",11) == 1675069632) strcat(s, "j");
if (crc32("jlQDwtH",7) == 3195216224) strcat(s, "b");
if (crc32("CpRDfhWYdAsO",12) == 1370307134) strcat(s, "l");
if (crc32("JyLtnLaKvVYyKz",14) == 3975074046) strcat(s, "H");
if (crc32("xgegZvGXL",9) == 4278839785) strcat(s, "e");
    return s;
}

char *autoecious_adjectives() {
    char *s = calloc(11);
    if (crc32("mStMebctrmg",11) == 1337899031) strcat(s, "a");
if (crc32("vckCdSq",7) == 45996757) strcat(s, "u");
if (crc32("HQcMmqYb",8) == 2754726949) strcat(s, "R");
if (crc32("PgXoLOWtyfrM",12) == 2314814910) strcat(s, "t");
if (crc32("SSntnWZb",8) == 2495338293) strcat(s, "C");
if (crc32("QGeflWXo",8) == 2217058521) strcat(s, "o");
if (crc32("imzXZQuHNxf",11) == 2443170358) strcat(s, "e");
if (crc32("ZScuuwfUML",10) == 3100476234) strcat(s, "c");
if (crc32("zuZEQhR",7) == 365766396) strcat(s, "i");
if (crc32("llyXc",5) == 1413954057) strcat(s, "T");
if (crc32("yUVwbfkHBISUg",13) == 2721568233) strcat(s, "o");
if (crc32("yxrUrmxjtYjS",12) == 1951330743) strcat(s, "a");
if (crc32("BhZgBi",6) == 1159327824) strcat(s, "u");
if (crc32("SJKezvPm",8) == 3691244392) strcat(s, "W");
if (crc32("StuillFVVPtutGV",15) == 1961912165) strcat(s, "s");
    return s;
}

char *quasiprophetic_adjectives() {
    char *s = calloc(15);
    if (crc32("DttboMNik",9) == 1982933806) strcat(s, "q");
if (crc32("NLoQOhEaNmHg",12) == 3152161924) strcat(s, "v");
if (crc32("gIACWaFtCJIuy",13) == 3780085443) strcat(s, "u");
if (crc32("dUMoeYB",7) == 1789765754) strcat(s, "o");
if (crc32("GvPNJaelWgNQizL",15) == 1432586634) strcat(s, "a");
if (crc32("gQJYQdjI",8) == 219373914) strcat(s, "s");
if (crc32("KDBLnCLDlPS",11) == 2242368752) strcat(s, "d");
if (crc32("SoPStoRLLtKbyf",14) == 3204952922) strcat(s, "i");
if (crc32("BlGEoq",6) == 442862053) strcat(s, "p");
if (crc32("vopdPuyI",8) == 3298204879) strcat(s, "P");
if (crc32("UZbGz",5) == 3604612814) strcat(s, "r");
if (crc32("SiZtTdKZyhREL",13) == 1819692728) strcat(s, "o");
if (crc32("GaztQTCGQMcIAz",14) == 268437845) strcat(s, "y");
if (crc32("ENMilegwd",9) == 1933558458) strcat(s, "p");
if (crc32("xTASpwjsaqDLr",13) == 2212030693) strcat(s, "h");
if (crc32("MymmJeVfRglsLLm",15) == 3697587648) strcat(s, "e");
if (crc32("YfWAFNeVYFMj",12) == 2820602737) strcat(s, "l");
if (crc32("qpRzFaZHZkBP",12) == 2898740591) strcat(s, "t");
if (crc32("HWQwYHADLMXIEn",14) == 1548902220) strcat(s, "i");
if (crc32("wzRaX",5) == 2343543159) strcat(s, "K");
if (crc32("UICaYZJvmNlC",12) == 3436526777) strcat(s, "c");
    return s;
}

char *nonterminable_adjectives() {
    char *s = calloc(14);
    if (crc32("lAnZWGQKmp",10) == 3607907738) strcat(s, "n");
if (crc32("jmZXaRNVFnBz",12) == 3790549364) strcat(s, "o");
if (crc32("tsPYLE",6) == 1830411232) strcat(s, "n");
if (crc32("EepDK",5) == 650459721) strcat(s, "g");
if (crc32("ksOIHx",6) == 3082880514) strcat(s, "t");
if (crc32("pAkoUVPGPp",10) == 2468569579) strcat(s, "e");
if (crc32("pFDJkkXdebcFE",13) == 3438762779) strcat(s, "D");
if (crc32("vzvoF",5) == 2576623013) strcat(s, "r");
if (crc32("UfrIyIPglbBbJ",13) == 2974330769) strcat(s, "h");
if (crc32("GtkjdAkz",8) == 472505661) strcat(s, "m");
if (crc32("sssnFnAdUKFUIl",14) == 4101780769) strcat(s, "d");
if (crc32("QzSTwnpO",8) == 2395139070) strcat(s, "i");
if (crc32("lAxEWaauQPxaBo",14) == 655185542) strcat(s, "n");
if (crc32("SqWoygUKAyK",11) == 853864970) strcat(s, "a");
if (crc32("BldSZKI",7) == 4183998802) strcat(s, "b");
if (crc32("SfhGvIVERxaCd",13) == 3094690762) strcat(s, "g");
if (crc32("tjXEvSllPLnL",12) == 3175824488) strcat(s, "l");
if (crc32("cMiVsJgu",8) == 3844335691) strcat(s, "H");
if (crc32("iHjrTRjHScAkJjR",15) == 1501693384) strcat(s, "e");
    return s;
}

char *simulative_adjectives() {
    char *s = calloc(11);
    if (crc32("EXrRqP",6) == 360003068) strcat(s, "s");
if (crc32("UbXDiWYa",8) == 1467104379) strcat(s, "i");
if (crc32("bSCTqU",6) == 1148987034) strcat(s, "m");
if (crc32("WZwRsKpFKuiht",13) == 3780785126) strcat(s, "r");
if (crc32("tXiHek",6) == 3546229181) strcat(s, "u");
if (crc32("fdCtmnGd",8) == 961293659) strcat(s, "E");
if (crc32("EbEPShMHlOGqLk",14) == 2858269404) strcat(s, "l");
if (crc32("YzFixoildmusk",13) == 1443315032) strcat(s, "a");
if (crc32("cmQeunsO",8) == 3154032331) strcat(s, "t");
if (crc32("zhYrtGETPlI",11) == 4048350416) strcat(s, "i");
if (crc32("IhGQGM",6) == 3963553383) strcat(s, "v");
if (crc32("UfVcpRZ",7) == 4214126787) strcat(s, "e");
    return s;
}

char *unoppressive_adjectives() {
    char *s = calloc(13);
    if (crc32("cvWsKzZuK",9) == 2077232867) strcat(s, "u");
if (crc32("zkAIiQ",6) == 2195935744) strcat(s, "P");
if (crc32("WyxWxCqiYGCa",12) == 969885877) strcat(s, "n");
if (crc32("ypwPUx",6) == 1736178671) strcat(s, "o");
if (crc32("cUjVJ",5) == 3687520698) strcat(s, "p");
if (crc32("rPzCbqNVvmhs",12) == 4258096519) strcat(s, "p");
if (crc32("MJvRIngDT",9) == 2612748589) strcat(s, "h");
if (crc32("QzEZzpepQTWS",12) == 820435796) strcat(s, "r");
if (crc32("exZdFkXUaqKBU",13) == 1309005121) strcat(s, "J");
if (crc32("Dhppj",5) == 1131040664) strcat(s, "e");
if (crc32("LFQcbuVsypTb",12) == 888113528) strcat(s, "s");
if (crc32("RbSzQhuR",8) == 686006938) strcat(s, "f");
if (crc32("DEtTyBSHIVrA",12) == 794714664) strcat(s, "s");
if (crc32("OgBPOiLMUY",10) == 3691320454) strcat(s, "M");
if (crc32("rmGdyk",6) == 4211787650) strcat(s, "i");
if (crc32("qShElgRBUoEys",13) == 2207149275) strcat(s, "v");
if (crc32("ahhCtSslFQ",10) == 569491061) strcat(s, "v");
if (crc32("zwaGwvSdCkb",11) == 1677012958) strcat(s, "e");
    return s;
}

char *nonregressive_adjectives() {
    char *s = calloc(14);
    if (crc32("CyCJnBCIG",9) == 2139306134) strcat(s, "q");
if (crc32("nZOdT",5) == 1388388420) strcat(s, "n");
if (crc32("LfqtpPOoufSBMs",14) == 2269980770) strcat(s, "o");
if (crc32("hMLxMAxg",8) == 2829183720) strcat(s, "B");
if (crc32("QzuxklyJ",8) == 3823483999) strcat(s, "n");
if (crc32("LxkMxyAiNk",10) == 1202544255) strcat(s, "r");
if (crc32("JOnZLpckVOdpb",13) == 2636616237) strcat(s, "e");
if (crc32("LKuAdtIoFWYk",12) == 4265694849) strcat(s, "K");
if (crc32("LtVKUiFIPWU",11) == 3493239781) strcat(s, "g");
if (crc32("txqxQCy",7) == 2549118015) strcat(s, "r");
if (crc32("cYlaIufgg",9) == 3398810643) strcat(s, "s");
if (crc32("nEcUXifvSwRIXaE",15) == 3095853629) strcat(s, "e");
if (crc32("KrjSt",5) == 2352154908) strcat(s, "p");
if (crc32("LboJmlDLGFNk",12) == 3844661479) strcat(s, "s");
if (crc32("llhYvKhEaDXBC",13) == 3842971282) strcat(s, "T");
if (crc32("kgNwlpKWeOtXA",13) == 3645580956) strcat(s, "s");
if (crc32("XRQFVeO",7) == 3787759913) strcat(s, "i");
if (crc32("XvVIgmXDKWJiSSd",15) == 255414268) strcat(s, "v");
if (crc32("fnqfYPpvAHKV",12) == 1346518250) strcat(s, "e");
    return s;
}

char *preKoranic_adjectives() {
    char *s = calloc(11);
    if (crc32("ngnViq",6) == 2296063906) strcat(s, "p");
if (crc32("zbJPKukqzqc",11) == 2795404176) strcat(s, "z");
if (crc32("TTrwzlQTm",9) == 926119028) strcat(s, "r");
if (crc32("hyndTjznDgbHQvu",15) == 3134347724) strcat(s, "a");
if (crc32("FFWfcSLfJSWn",12) == 165007672) strcat(s, "e");
if (crc32("EXJvhumjg",9) == 1742157852) strcat(s, "v");
if (crc32("MUxbMEe",7) == 1961555457) strcat(s, "K");
if (crc32("eXXrLYftsydqQ",13) == 3520559919) strcat(s, "o");
if (crc32("RXnZKNEzX",9) == 3205587897) strcat(s, "m");
if (crc32("btgKKpgcMKc",11) == 548662892) strcat(s, "r");
if (crc32("gfMVsCuLIcuXV",13) == 1687885309) strcat(s, "a");
if (crc32("kaSsuXsKyVWwW",13) == 3411352005) strcat(s, "n");
if (crc32("lKLVklQGBsZq",12) == 1238300029) strcat(s, "s");
if (crc32("jcHkCFE",7) == 1780989102) strcat(s, "i");
if (crc32("HjwPZTTwapv",11) == 4214026275) strcat(s, "g");
if (crc32("pylLtubhgxBu",12) == 1300927325) strcat(s, "c");
    return s;
}

char *glassyeyed_adjectives() {
    char *s = calloc(11);
    if (crc32("xExuCoFjG",9) == 936171636) strcat(s, "g");
if (crc32("cOTEDpIxKDnuZO",14) == 782472895) strcat(s, "K");
if (crc32("lHscPpOodMX",11) == 3586584006) strcat(s, "l");
if (crc32("OHSHQQDBMGZ",11) == 2535894005) strcat(s, "w");
if (crc32("zuQKiK",6) == 1879483051) strcat(s, "a");
if (crc32("MPXlFJT",7) == 3744124049) strcat(s, "s");
if (crc32("RhrTIxMyjRVvVY",14) == 175384291) strcat(s, "s");
if (crc32("PGlXNzcAHKY",11) == 1439230726) strcat(s, "p");
if (crc32("aaUDEl",6) == 2490527518) strcat(s, "y");
if (crc32("wCdtGEst",8) == 176919544) strcat(s, "e");
if (crc32("XahiDFP",7) == 3522584175) strcat(s, "L");
if (crc32("BJyraQoLzDMsENX",15) == 2440499404) strcat(s, "y");
if (crc32("ADJaP",5) == 1639463122) strcat(s, "J");
if (crc32("NhhTDeA",7) == 3994039276) strcat(s, "e");
if (crc32("ILskzeYF",8) == 3719532899) strcat(s, "o");
if (crc32("AyIXcAES",8) == 4269167448) strcat(s, "d");
    return s;
}

char *unnibbed_adjectives() {
    char *s = calloc(9);
    if (crc32("vFtfr",5) == 3499882798) strcat(s, "u");
if (crc32("tjLCP",5) == 1465163747) strcat(s, "n");
if (crc32("esXvluaPg",9) == 1060687200) strcat(s, "n");
if (crc32("PQJFNehVVrSlM",13) == 4201368590) strcat(s, "u");
if (crc32("ESYEFCRzj",9) == 165685414) strcat(s, "i");
if (crc32("sIUtCgSzYoIs",12) == 3199120263) strcat(s, "m");
if (crc32("AmeqZo",6) == 3505784791) strcat(s, "b");
if (crc32("mEzHAENAVct",11) == 3171639648) strcat(s, "A");
if (crc32("tnDlr",5) == 291053701) strcat(s, "b");
if (crc32("mvVvDCdZqKLN",12) == 3071971322) strcat(s, "e");
if (crc32("riuMQIKZ",8) == 388775429) strcat(s, "x");
if (crc32("xexrbRzKEWaObGR",15) == 2337155109) strcat(s, "d");
    return s;
}

char *comfy_adjectives() {
    char *s = calloc(6);
    if (crc32("jyFUtyljTjiYe",13) == 2424123641) strcat(s, "c");
if (crc32("APAOakGqbV",10) == 481134553) strcat(s, "o");
if (crc32("yHmqnIULVfXInE",14) == 2561736658) strcat(s, "m");
if (crc32("cWeRFB",6) == 3902863964) strcat(s, "f");
if (crc32("QRGieMzTaqX",11) == 996961291) strcat(s, "r");
if (crc32("JrEZN",5) == 2989902208) strcat(s, "y");
    return s;
}

char *unmossed_adjectives() {
    char *s = calloc(9);
    if (crc32("lmtJzCrIfG",10) == 1335039849) strcat(s, "Q");
if (crc32("pFeIiZHkwfMHOze",15) == 568918640) strcat(s, "u");
if (crc32("gOWhsG",6) == 2183397980) strcat(s, "n");
if (crc32("MzHBoYGgD",9) == 1491881163) strcat(s, "m");
if (crc32("DKnLZS",6) == 443007365) strcat(s, "m");
if (crc32("TxEPrTtw",8) == 1816331923) strcat(s, "G");
if (crc32("rkdvFcsFsm",10) == 688276678) strcat(s, "o");
if (crc32("zXeXodQX",8) == 2275473606) strcat(s, "D");
if (crc32("kHneLaZMgO",10) == 2144150523) strcat(s, "s");
if (crc32("iIpkBl",6) == 693756051) strcat(s, "J");
if (crc32("zWTecmqYj",9) == 3610753544) strcat(s, "s");
if (crc32("JnrzRvmFBKJ",11) == 872245246) strcat(s, "e");
if (crc32("FXKeHBWZRUa",11) == 2432072885) strcat(s, "P");
if (crc32("PKaWTqT",7) == 406453942) strcat(s, "d");
    return s;
}

char *subadjacent_adjectives() {
    char *s = calloc(12);
    if (crc32("FfYRtDYMa",9) == 939213877) strcat(s, "S");
if (crc32("yyucFZPuaMDy",12) == 556283254) strcat(s, "s");
if (crc32("TniiSMj",7) == 695268067) strcat(s, "R");
if (crc32("yAUGNFamcg",10) == 2598218) strcat(s, "u");
if (crc32("FilQAognsMJwqI",14) == 2715189037) strcat(s, "S");
if (crc32("ReOApJDsgYhlKB",14) == 2288202294) strcat(s, "b");
if (crc32("sbYnrOPdQsZ",11) == 699995275) strcat(s, "a");
if (crc32("PwOwuqhQPQmbMs",14) == 3539249378) strcat(s, "d");
if (crc32("pJHYxoxVDJ",10) == 721389189) strcat(s, "j");
if (crc32("xpFAMyJEew",10) == 4196013766) strcat(s, "I");
if (crc32("uoPhYzPfAQcVK",13) == 128094916) strcat(s, "a");
if (crc32("rkABHxM",7) == 1092882945) strcat(s, "c");
if (crc32("oOdreoChBYTe",12) == 2469125703) strcat(s, "X");
if (crc32("gKiNLenRChBbHM",14) == 3665710098) strcat(s, "e");
if (crc32("oJQqhb",6) == 194202097) strcat(s, "T");
if (crc32("IxptPw",6) == 472549586) strcat(s, "n");
if (crc32("LWCTiIvZRmjrOE",14) == 2294244826) strcat(s, "s");
if (crc32("uhvHFEK",7) == 4156430930) strcat(s, "t");
    return s;
}

char *optometrical_adjectives() {
    char *s = calloc(13);
    if (crc32("BSNqYEXr",8) == 1058606414) strcat(s, "m");
if (crc32("oaMSZdT",7) == 1448973073) strcat(s, "o");
if (crc32("jnIPGPkOZio",11) == 2573944703) strcat(s, "p");
if (crc32("avLecCBFlfkg",12) == 2781649087) strcat(s, "S");
if (crc32("hnBaBfk",7) == 750454214) strcat(s, "t");
if (crc32("vnVnxHLkE",9) == 775094050) strcat(s, "M");
if (crc32("CyJkpWRdkRDrqO",14) == 1132962518) strcat(s, "o");
if (crc32("tlYGCwV",7) == 261339705) strcat(s, "i");
if (crc32("wRBwHKEtlSJ",11) == 2011801343) strcat(s, "m");
if (crc32("XfNRuxzSRxeDGIQ",15) == 4289036024) strcat(s, "e");
if (crc32("SdoSjCilwQE",11) == 3184821666) strcat(s, "t");
if (crc32("IALddOskrYy",11) == 362502955) strcat(s, "Z");
if (crc32("GbCwIZSbFsARII",14) == 1284480104) strcat(s, "r");
if (crc32("qhHVUsLc",8) == 3773133743) strcat(s, "o");
if (crc32("jLeVLRKPFj",10) == 3561208187) strcat(s, "i");
if (crc32("KtpWyaoTYaEkFB",14) == 382201263) strcat(s, "c");
if (crc32("LuNvTJR",7) == 943227091) strcat(s, "Z");
if (crc32("dgMCLtM",7) == 3826783802) strcat(s, "a");
if (crc32("xlaqEvtLyAvlGR",14) == 1014949239) strcat(s, "l");
    return s;
}

char *inscrutable_adjectives() {
    char *s = calloc(12);
    if (crc32("KQXGu",5) == 437644329) strcat(s, "A");
if (crc32("JaewrKcHSOU",11) == 1298457361) strcat(s, "i");
if (crc32("JxdUMhNG",8) == 3365289527) strcat(s, "n");
if (crc32("kXFOVUXYnViHPw",14) == 2930305404) strcat(s, "s");
if (crc32("GQlSWNEF",8) == 2948548877) strcat(s, "T");
if (crc32("yjlOhsCOUoNwgb",14) == 870181639) strcat(s, "c");
if (crc32("PTmijtiExTporf",14) == 2876561655) strcat(s, "r");
if (crc32("DDroQrPWUSAz",12) == 1479734556) strcat(s, "H");
if (crc32("xrEJzkszHSX",11) == 3958795936) strcat(s, "u");
if (crc32("JtAPn",5) == 4066320044) strcat(s, "L");
if (crc32("dOMnFRHDwklriR",14) == 411029496) strcat(s, "t");
if (crc32("AvVLToMtQzqUjq",14) == 2319065829) strcat(s, "s");
if (crc32("ZQDZTKyqhlvPFh",14) == 856728244) strcat(s, "a");
if (crc32("FxurjSAh",8) == 4021980520) strcat(s, "G");
if (crc32("ZkhpFoc",7) == 4165909750) strcat(s, "b");
if (crc32("AjMbUMcCjaMVL",13) == 4039939419) strcat(s, "j");
if (crc32("ZaPrSpTdXr",10) == 2623897351) strcat(s, "l");
if (crc32("RphLNaByYWejfv",14) == 3838734906) strcat(s, "e");
    return s;
}

char *wellarmored_adjectives() {
    char *s = calloc(12);
    if (crc32("NMNnElNLPObIFHP",15) == 443647840) strcat(s, "M");
if (crc32("GPnmIhdKmxca",12) == 4036270024) strcat(s, "w");
if (crc32("stMQtP",6) == 4143107212) strcat(s, "a");
if (crc32("iSSUuu",6) == 543297085) strcat(s, "e");
if (crc32("HADXyuwAczFVL",13) == 1831594912) strcat(s, "Y");
if (crc32("PEeOnbJbTTDoEWJ",15) == 1487456774) strcat(s, "l");
if (crc32("KknGw",5) == 3536516022) strcat(s, "a");
if (crc32("PUlVjdCKza",10) == 2060200847) strcat(s, "l");
if (crc32("TYKvmqtZS",9) == 2570510645) strcat(s, "y");
if (crc32("wkFfcKVF",8) == 2742489304) strcat(s, "a");
if (crc32("YVqlgmGIO",9) == 3469458167) strcat(s, "r");
if (crc32("wIPUFwOvUtmK",12) == 1348734636) strcat(s, "v");
if (crc32("pQnFC",5) == 1207853462) strcat(s, "m");
if (crc32("PyoqFixco",9) == 2729007067) strcat(s, "p");
if (crc32("RYodjjeREEToX",13) == 474433746) strcat(s, "o");
if (crc32("IPOFVvHouuVFoX",14) == 2692052461) strcat(s, "J");
if (crc32("zVSlrZZgjYoznv",14) == 717713131) strcat(s, "r");
if (crc32("iWWZmStfKOrIH",13) == 891843877) strcat(s, "F");
if (crc32("SzaGtxFs",8) == 242760361) strcat(s, "e");
if (crc32("ntoMd",5) == 2112897520) strcat(s, "U");
if (crc32("JMqdzJh",7) == 2931746483) strcat(s, "d");
    return s;
}

char *thyroarytenoid_adjectives() {
    char *s = calloc(15);
    if (crc32("ptjTHHB",7) == 2026152618) strcat(s, "M");
if (crc32("dSGwZgJWFyXosfI",15) == 1667385167) strcat(s, "t");
if (crc32("vBwHORCIkkwM",12) == 1795261454) strcat(s, "f");
if (crc32("tMbHDYprypYcw",13) == 1100260290) strcat(s, "h");
if (crc32("ZgeSKGzhwlgVUiE",15) == 731086241) strcat(s, "y");
if (crc32("JqlshYTYuqrTTi",14) == 3410558204) strcat(s, "r");
if (crc32("HTqsOKmAOnFEGxG",15) == 839803316) strcat(s, "o");
if (crc32("lvsGIhYPA",9) == 2327892690) strcat(s, "a");
if (crc32("LgaupQ",6) == 12182176) strcat(s, "r");
if (crc32("aVKpJDPHSVBVD",13) == 1431914030) strcat(s, "y");
if (crc32("kTxRJnRVYEY",11) == 1980881971) strcat(s, "t");
if (crc32("UocGisjBUsJ",11) == 2371816961) strcat(s, "e");
if (crc32("eySIwUWbBphCxEC",15) == 929878813) strcat(s, "n");
if (crc32("uCHfySpTUBcLTE",14) == 4252358721) strcat(s, "o");
if (crc32("lljZqGb",7) == 2429119797) strcat(s, "i");
if (crc32("vfSUyQwvSoms",12) == 372265262) strcat(s, "j");
if (crc32("yWpDVGYSBN",10) == 1478611971) strcat(s, "d");
    return s;
}

char *Greekish_adjectives() {
    char *s = calloc(9);
    if (crc32("IWDfbeWVsP",10) == 2547750367) strcat(s, "G");
if (crc32("saWUXOc",7) == 877738332) strcat(s, "r");
if (crc32("lxdlZQaKh",9) == 1002908402) strcat(s, "e");
if (crc32("VspdylQxjTQo",12) == 2288977376) strcat(s, "e");
if (crc32("OMBHNBUVRsS",11) == 2895020317) strcat(s, "r");
if (crc32("hobdv",5) == 4286662944) strcat(s, "k");
if (crc32("FqbbFOInkdtmCDJ",15) == 3340246571) strcat(s, "j");
if (crc32("kFCWuKtbjSUDvsi",15) == 1295066282) strcat(s, "i");
if (crc32("STpanOUlwv",10) == 466085639) strcat(s, "X");
if (crc32("RXdsPkV",7) == 3028163480) strcat(s, "s");
if (crc32("TpqSBJMX",8) == 2342316335) strcat(s, "h");
    return s;
}

char *unjoinable_adjectives() {
    char *s = calloc(11);
    if (crc32("jgdAl",5) == 1374250880) strcat(s, "u");
if (crc32("CyarmqRVFKC",11) == 604096855) strcat(s, "G");
if (crc32("wAcSzvZLVyCWth",14) == 1668317590) strcat(s, "n");
if (crc32("khOFXyjzkz",10) == 583398406) strcat(s, "J");
if (crc32("nyYIYwnUiqvzpa",14) == 737495265) strcat(s, "j");
if (crc32("XXKlZOrryBzSdc",14) == 2141702296) strcat(s, "W");
if (crc32("EESUxJVJGhf",11) == 2894906183) strcat(s, "o");
if (crc32("KtmGnbwkB",9) == 1584706603) strcat(s, "A");
if (crc32("ucpjrZiFfnYMuuU",15) == 3774450725) strcat(s, "i");
if (crc32("Snpqsz",6) == 1279953222) strcat(s, "z");
if (crc32("YhMolBr",7) == 824805971) strcat(s, "n");
if (crc32("rzWuwwYC",8) == 1872626527) strcat(s, "m");
if (crc32("xiWnBfMQ",8) == 399301143) strcat(s, "a");
if (crc32("ToDpymWYSzuqT",13) == 561155768) strcat(s, "P");
if (crc32("cgYqohI",7) == 904677409) strcat(s, "b");
if (crc32("sZgAESydH",9) == 181005497) strcat(s, "l");
if (crc32("tkSabBE",7) == 586254141) strcat(s, "o");
if (crc32("ANsrTcOwKbEmO",13) == 143840462) strcat(s, "e");
    return s;
}

char *quasitolerant_adjectives() {
    char *s = calloc(14);
    if (crc32("kueoXOwtvbx",11) == 1692665991) strcat(s, "q");
if (crc32("bLDCud",6) == 398487227) strcat(s, "q");
if (crc32("VZeii",5) == 432336840) strcat(s, "M");
if (crc32("BgsEIIfsikehnJx",15) == 4094701760) strcat(s, "u");
if (crc32("HsFzraqA",8) == 2539990313) strcat(s, "a");
if (crc32("xccUYKrOZaHZHc",14) == 1924552104) strcat(s, "s");
if (crc32("DQYSCtgCxJege",13) == 2765161803) strcat(s, "O");
if (crc32("kviyHAStpInbDnp",15) == 3103615509) strcat(s, "i");
if (crc32("IgQOKdYGKLNlV",13) == 2790462962) strcat(s, "G");
if (crc32("aueqBIgT",8) == 1398053154) strcat(s, "t");
if (crc32("frStIcI",7) == 2526412708) strcat(s, "o");
if (crc32("fFDchrNp",8) == 2302542740) strcat(s, "l");
if (crc32("phvpBWwDfRdPm",13) == 475675815) strcat(s, "r");
if (crc32("TlXuOsMkRCqBKMr",15) == 802594729) strcat(s, "e");
if (crc32("UuHdBF",6) == 2419952980) strcat(s, "r");
if (crc32("QvzLbktuyznVL",13) == 1417091683) strcat(s, "J");
if (crc32("jmmrgUkZcZjHhW",14) == 1495090652) strcat(s, "a");
if (crc32("PSeWtcJ",7) == 3096105936) strcat(s, "n");
if (crc32("ilPDa",5) == 3526952113) strcat(s, "j");
if (crc32("NPMtvCak",8) == 1601869651) strcat(s, "t");
    return s;
}

char *adventurous_adjectives() {
    char *s = calloc(12);
    if (crc32("IWgTwknRYN",10) == 516257535) strcat(s, "A");
if (crc32("beWmoG",6) == 3106159612) strcat(s, "a");
if (crc32("DMJRqJop",8) == 500661213) strcat(s, "d");
if (crc32("IsqamGgz",8) == 1927585982) strcat(s, "X");
if (crc32("HCxUatS",7) == 2786186647) strcat(s, "v");
if (crc32("kCspBDZECdzkZGN",15) == 1040330685) strcat(s, "H");
if (crc32("XJzpLHrup",9) == 1115631210) strcat(s, "e");
if (crc32("AAnuGtIHH",9) == 2077451041) strcat(s, "n");
if (crc32("zWZrrd",6) == 895185170) strcat(s, "t");
if (crc32("UfeIZgYqU",9) == 3103798518) strcat(s, "p");
if (crc32("KBsTwNKzcQfrW",13) == 323497769) strcat(s, "u");
if (crc32("HqblSSVPqURRbn",14) == 814642741) strcat(s, "r");
if (crc32("gAUGUFJRXKh",11) == 2439854344) strcat(s, "o");
if (crc32("uzXSDBaaDCrS",12) == 898587961) strcat(s, "m");
if (crc32("EkXZM",5) == 2424350685) strcat(s, "u");
if (crc32("wSzYPIwlr",9) == 839453407) strcat(s, "s");
    return s;
}

char *bimanous_adjectives() {
    char *s = calloc(9);
    if (crc32("SlupE",5) == 4026312) strcat(s, "f");
if (crc32("XdXHknPshNYV",12) == 3879017667) strcat(s, "b");
if (crc32("dknElfAllmNm",12) == 3820819175) strcat(s, "i");
if (crc32("jqqhDhrqmNf",11) == 1336152094) strcat(s, "d");
if (crc32("kfguQcGjHm",10) == 3505002916) strcat(s, "m");
if (crc32("rhIGOaihueOXX",13) == 2631723539) strcat(s, "a");
if (crc32("WxHFl",5) == 2117367101) strcat(s, "n");
if (crc32("mXTzRA",6) == 3872394183) strcat(s, "j");
if (crc32("dJtUqhA",7) == 1159443923) strcat(s, "o");
if (crc32("CVQkyBUmvFK",11) == 4001059196) strcat(s, "Q");
if (crc32("rLDHDbhvqemBep",14) == 2824911946) strcat(s, "u");
if (crc32("ZBjWxeuBzmK",11) == 316509676) strcat(s, "s");
    return s;
}

char *aweigh_adjectives() {
    char *s = calloc(7);
    if (crc32("bCGouGYI",8) == 3238691224) strcat(s, "z");
if (crc32("tNEAI",5) == 562583111) strcat(s, "a");
if (crc32("mNsIkH",6) == 3894156582) strcat(s, "u");
if (crc32("fElat",5) == 383320184) strcat(s, "w");
if (crc32("ngsnjhLYj",9) == 3581339993) strcat(s, "e");
if (crc32("JWoGitvZma",10) == 1825638489) strcat(s, "H");
if (crc32("WEEEsDaAiub",11) == 3483935087) strcat(s, "i");
if (crc32("CISJqHuizbd",11) == 796558516) strcat(s, "g");
if (crc32("mNptrzJNh",9) == 3706146270) strcat(s, "h");
    return s;
}

char *unsculptural_adjectives() {
    char *s = calloc(13);
    if (crc32("MDtLSqYTQdsXuQM",15) == 1587947539) strcat(s, "u");
if (crc32("BYXBHxxIAzucsI",14) == 1226092729) strcat(s, "n");
if (crc32("tIVPBrvTobbp",12) == 414969776) strcat(s, "s");
if (crc32("TimfzMeW",8) == 3500100545) strcat(s, "J");
if (crc32("BijBs",5) == 3963357002) strcat(s, "c");
if (crc32("icBtCN",6) == 1753141959) strcat(s, "u");
if (crc32("pfteuYEABiCJHTB",15) == 4218618688) strcat(s, "l");
if (crc32("htUJKYJiqX",10) == 2476244709) strcat(s, "R");
if (crc32("tqCkGioqJKw",11) == 2420028755) strcat(s, "p");
if (crc32("zdbFAGWTW",9) == 1639154889) strcat(s, "M");
if (crc32("QoNWOq",6) == 799645494) strcat(s, "t");
if (crc32("cFJOU",5) == 281714434) strcat(s, "R");
if (crc32("QIbJnuAhHygsrFt",15) == 3438246144) strcat(s, "u");
if (crc32("kYHhspDbl",9) == 1501360974) strcat(s, "e");
if (crc32("BBefcHJ",7) == 2815383633) strcat(s, "r");
if (crc32("dhBVygzGwFBIfQ",14) == 1021863663) strcat(s, "k");
if (crc32("YJxzjX",6) == 2236581738) strcat(s, "a");
if (crc32("fbTHfAxLvqIy",12) == 2304982077) strcat(s, "R");
if (crc32("CxufTMcfuaRU",12) == 2903169955) strcat(s, "l");
    return s;
}

char *poisonous_adjectives() {
    char *s = calloc(10);
    if (crc32("JyWrY",5) == 2753270514) strcat(s, "p");
if (crc32("GmPuVqxAEsIGoAY",15) == 1815572624) strcat(s, "n");
if (crc32("jusZdHkwLi",10) == 350016313) strcat(s, "o");
if (crc32("nhmXSbYwCcbLJFh",15) == 2842460471) strcat(s, "i");
if (crc32("dzFEuIDINjOnZo",14) == 2680441284) strcat(s, "e");
if (crc32("plbQsl",6) == 1516587623) strcat(s, "s");
if (crc32("NaXQtZQwwuAuVsK",15) == 3417651814) strcat(s, "b");
if (crc32("ldtvPe",6) == 2432980133) strcat(s, "o");
if (crc32("YpTwj",5) == 1051859744) strcat(s, "n");
if (crc32("yOQwhduNCq",10) == 169404093) strcat(s, "o");
if (crc32("jxhJz",5) == 1202304439) strcat(s, "u");
if (crc32("MiNVokHIK",9) == 2179632658) strcat(s, "s");
    return s;
}

char *isochasmic_adjectives() {
    char *s = calloc(11);
    if (crc32("CuwPgxF",7) == 106878315) strcat(s, "i");
if (crc32("oqAUqp",6) == 2540992498) strcat(s, "h");
if (crc32("YDYikaZ",7) == 2132797598) strcat(s, "s");
if (crc32("uZOIPPdI",8) == 3702189396) strcat(s, "A");
if (crc32("xVIjskViALQEO",13) == 3457569036) strcat(s, "o");
if (crc32("WhGYxBhCjQ",10) == 10370004) strcat(s, "c");
if (crc32("SRaNttGPDBuj",12) == 3131281617) strcat(s, "h");
if (crc32("ypHCmR",6) == 620671855) strcat(s, "c");
if (crc32("zHauQItxFXDZoT",14) == 3418963703) strcat(s, "a");
if (crc32("QJbCeIXMNDKPhs",14) == 1575881290) strcat(s, "s");
if (crc32("WgGrg",5) == 1374314422) strcat(s, "m");
if (crc32("fDnutoSUCzbtMZJ",15) == 3910821357) strcat(s, "i");
if (crc32("Eczar",5) == 3827949497) strcat(s, "c");
    return s;
}

char *gastrodermal_adjectives() {
    char *s = calloc(13);
    if (crc32("moiti",5) == 4244518421) strcat(s, "g");
if (crc32("nRaMHOSxOBKlt",13) == 2893202820) strcat(s, "e");
if (crc32("xRSLyXJ",7) == 311924317) strcat(s, "a");
if (crc32("KqZfyqh",7) == 2411674048) strcat(s, "v");
if (crc32("HtxGEVcVnbiF",12) == 4283265308) strcat(s, "s");
if (crc32("yhvVB",5) == 3471212006) strcat(s, "z");
if (crc32("tGsFw",5) == 4064676739) strcat(s, "t");
if (crc32("GWIedS",6) == 577965776) strcat(s, "h");
if (crc32("MtuPYx",6) == 195862291) strcat(s, "r");
if (crc32("SxkooAtXFPYBvO",14) == 3789045466) strcat(s, "K");
if (crc32("HlnGu",5) == 38737525) strcat(s, "o");
if (crc32("CRfvWRk",7) == 3385892252) strcat(s, "R");
if (crc32("vbdPF",5) == 1262815223) strcat(s, "d");
if (crc32("wlSHel",6) == 10012723) strcat(s, "e");
if (crc32("qlxLVmgs",8) == 2120583161) strcat(s, "r");
if (crc32("KKyuHGLRhmGEkk",14) == 593769489) strcat(s, "K");
if (crc32("KOknaVhmd",9) == 1732250544) strcat(s, "m");
if (crc32("foHeO",5) == 863341886) strcat(s, "a");
if (crc32("ABNIyV",6) == 2285113645) strcat(s, "Z");
if (crc32("VhmYz",5) == 340079830) strcat(s, "l");
    return s;
}

char *untunable_adjectives() {
    char *s = calloc(10);
    if (crc32("PiGoMl",6) == 803950962) strcat(s, "J");
if (crc32("LFmOqPXRdezMV",13) == 513617695) strcat(s, "u");
if (crc32("sXDWm",5) == 350742860) strcat(s, "f");
if (crc32("IHbwmDnCLX",10) == 3593348107) strcat(s, "n");
if (crc32("jYBOewclvCuo",12) == 4052492429) strcat(s, "t");
if (crc32("IkQXfrznbIDLD",13) == 433205249) strcat(s, "u");
if (crc32("SjWDUKusTwYTAHN",15) == 3461641119) strcat(s, "u");
if (crc32("hpaonYElo",9) == 3003820942) strcat(s, "g");
if (crc32("thmiaCtC",8) == 2162770974) strcat(s, "n");
if (crc32("LsltEOojo",9) == 1066926550) strcat(s, "r");
if (crc32("fHDjDcCzUcErfrv",15) == 3136626628) strcat(s, "a");
if (crc32("kXATwQCn",8) == 1063002913) strcat(s, "K");
if (crc32("OMfpB",5) == 2387105469) strcat(s, "b");
if (crc32("UDtZqqXapGcPDv",14) == 1854287870) strcat(s, "l");
if (crc32("gFjtOXNyiwxKD",13) == 3981255266) strcat(s, "H");
if (crc32("aNBglgQmNfZc",12) == 571104640) strcat(s, "e");
    return s;
}

char *nucleolated_adjectives() {
    char *s = calloc(12);
    if (crc32("GxIAWPRYcFg",11) == 3340920207) strcat(s, "n");
if (crc32("vyejBMINoJE",11) == 557976015) strcat(s, "u");
if (crc32("WTdOIiF",7) == 3666826930) strcat(s, "T");
if (crc32("AhCrORGWUlsdL",13) == 3546745045) strcat(s, "c");
if (crc32("KWZgVfcLv",9) == 1901906301) strcat(s, "l");
if (crc32("OoKPfFGUXxjMUVe",15) == 2413758466) strcat(s, "e");
if (crc32("HRSRnz",6) == 3979620752) strcat(s, "o");
if (crc32("mxlgSig",7) == 1667013885) strcat(s, "l");
if (crc32("vmuCw",5) == 1056153422) strcat(s, "a");
if (crc32("fiPsDFv",7) == 1941840156) strcat(s, "t");
if (crc32("iiegFDgWbRvWw",13) == 74551850) strcat(s, "U");
if (crc32("LEYVjpJkb",9) == 860691140) strcat(s, "e");
if (crc32("XyKhLrMWo",9) == 850896217) strcat(s, "d");
    return s;
}

char *unjudgable_adjectives() {
    char *s = calloc(11);
    if (crc32("PIfwDVzwlMs",11) == 443930948) strcat(s, "u");
if (crc32("EomiOZfPsL",10) == 3358038153) strcat(s, "n");
if (crc32("FzzyDZYBe",9) == 366905511) strcat(s, "m");
if (crc32("YUEWffvwgjzpX",13) == 359007853) strcat(s, "j");
if (crc32("OqcCciqUzjrBDgP",15) == 2274638070) strcat(s, "j");
if (crc32("JxyrhdelM",9) == 2133156533) strcat(s, "u");
if (crc32("kBxBuZBEh",9) == 3865800849) strcat(s, "d");
if (crc32("feGeM",5) == 193797014) strcat(s, "W");
if (crc32("nSPYatvkl",9) == 1932257534) strcat(s, "g");
if (crc32("irhHMUbjCX",10) == 1299825144) strcat(s, "a");
if (crc32("bqUpYklNRwwtLZv",15) == 3901777089) strcat(s, "t");
if (crc32("sBnqnkLciCpp",12) == 801323222) strcat(s, "b");
if (crc32("WfEkIJBP",8) == 1374020152) strcat(s, "l");
if (crc32("kmbEqYlDYt",10) == 1065644204) strcat(s, "c");
if (crc32("ZniDqrVdkpkCP",13) == 3936876589) strcat(s, "e");
    return s;
}

char *cymbocephalous_adjectives() {
    char *s = calloc(15);
    if (crc32("oKtdZ",5) == 983651134) strcat(s, "t");
if (crc32("IfuwxefQDUu",11) == 1956061075) strcat(s, "c");
if (crc32("iwMpjsiGNTwAh",13) == 3548734917) strcat(s, "k");
if (crc32("KQdhVhtQeZ",10) == 1703145205) strcat(s, "y");
if (crc32("jdzMiyHfzBpt",12) == 3689785276) strcat(s, "m");
if (crc32("ddrwuIw",7) == 3527025316) strcat(s, "v");
if (crc32("FMCYPgYxHicP",12) == 3609350504) strcat(s, "b");
if (crc32("BoPJrYxs",8) == 142140985) strcat(s, "u");
if (crc32("FBErODPi",8) == 3220353532) strcat(s, "o");
if (crc32("WUxUROAWzh",10) == 3386418260) strcat(s, "c");
if (crc32("HJiDYptEhUGcD",13) == 3202800315) strcat(s, "I");
if (crc32("MbYeWp",6) == 3155193712) strcat(s, "e");
if (crc32("wGDqyPGIz",9) == 4208493695) strcat(s, "p");
if (crc32("QkGyTcafyuJqXb",14) == 259791057) strcat(s, "h");
if (crc32("tidVQTavrjoCK",13) == 4044731835) strcat(s, "A");
if (crc32("kfzDicH",7) == 481631563) strcat(s, "a");
if (crc32("QRQHZEWfgGfv",12) == 1731634342) strcat(s, "B");
if (crc32("RxmXyU",6) == 2000262211) strcat(s, "l");
if (crc32("UtuQAgOCnoBNJ",13) == 403355670) strcat(s, "D");
if (crc32("UVsEaEfq",8) == 3291088086) strcat(s, "o");
if (crc32("WTktmuC",7) == 455931611) strcat(s, "u");
if (crc32("iCloqk",6) == 3510889116) strcat(s, "S");
if (crc32("nLqlxMndJVstvL",14) == 299742797) strcat(s, "s");
    return s;
}

char *cramped_adjectives() {
    char *s = calloc(8);
    if (crc32("zqcXrGXtyyARU",13) == 1800398061) strcat(s, "j");
if (crc32("AaedQRQgciio",12) == 2980647992) strcat(s, "c");
if (crc32("ghnWlVD",7) == 2610926346) strcat(s, "r");
if (crc32("yUcJNdAjsqyOY",13) == 2349263396) strcat(s, "a");
if (crc32("PVqnvictrm",10) == 4254930276) strcat(s, "m");
if (crc32("zzfeYGn",7) == 905524580) strcat(s, "f");
if (crc32("brbtQYs",7) == 252428162) strcat(s, "p");
if (crc32("eabFMVRaOCpgtBb",15) == 2807419405) strcat(s, "a");
if (crc32("DAHBoAZXGq",10) == 1456120112) strcat(s, "e");
if (crc32("YKIZTYstFUM",11) == 2776344649) strcat(s, "d");
    return s;
}

char *ungenial_adjectives() {
    char *s = calloc(9);
    if (crc32("wVdNeuVqhKcSS",13) == 2602622861) strcat(s, "L");
if (crc32("xpdZrBPmACO",11) == 2551289124) strcat(s, "u");
if (crc32("gfVZNxWNGbi",11) == 3989214869) strcat(s, "o");
if (crc32("QohQmMdnmfB",11) == 2314923477) strcat(s, "n");
if (crc32("qWCiBoKjlZsW",12) == 1366239599) strcat(s, "g");
if (crc32("oVDqlHJvKro",11) == 1924245665) strcat(s, "o");
if (crc32("IpEArpLCDU",10) == 1639285486) strcat(s, "e");
if (crc32("QDyOTWd",7) == 1864521580) strcat(s, "n");
if (crc32("RwlTbe",6) == 3407898277) strcat(s, "i");
if (crc32("FHjcasak",8) == 3653729844) strcat(s, "c");
if (crc32("KqvPKlGxugsQFUY",15) == 2922145849) strcat(s, "a");
if (crc32("wpmYUBJWfedV",12) == 3341531765) strcat(s, "K");
if (crc32("IVmegpYomlrRiw",14) == 3367167499) strcat(s, "l");
    return s;
}

char *peremptory_adjectives() {
    char *s = calloc(11);
    if (crc32("PltQUYfwvdCbJ",13) == 3467563782) strcat(s, "p");
if (crc32("wWsdUWHGS",9) == 2416136371) strcat(s, "S");
if (crc32("EMwewiUUvqySa",13) == 3256340136) strcat(s, "e");
if (crc32("wooANbUMJhuP",12) == 1390736516) strcat(s, "x");
if (crc32("oKxoIEc",7) == 152332395) strcat(s, "r");
if (crc32("PcYhBNonVx",10) == 1359317087) strcat(s, "n");
if (crc32("eHlHVXvoB",9) == 918157725) strcat(s, "e");
if (crc32("mLIUbExCIqxJJf",14) == 4158973217) strcat(s, "R");
if (crc32("XLUyjylhhciuf",13) == 2307682540) strcat(s, "m");
if (crc32("kONXtiFqqzN",11) == 3665642809) strcat(s, "x");
if (crc32("FBdBcToaiPdMr",13) == 1442835240) strcat(s, "p");
if (crc32("JJOncJH",7) == 3935209663) strcat(s, "t");
if (crc32("rdTFXZMKkL",10) == 2560774370) strcat(s, "o");
if (crc32("MOqytkdlSlxaxRm",15) == 4115426234) strcat(s, "J");
if (crc32("JBnqwhTnOoMVrxR",15) == 1592690467) strcat(s, "r");
if (crc32("MpiNYrNll",9) == 1300590587) strcat(s, "y");
    return s;
}

char *unmedalled_adjectives() {
    char *s = calloc(11);
    if (crc32("eFBcPoUllq",10) == 3968994969) strcat(s, "u");
if (crc32("EHPAkIhupCk",11) == 541639491) strcat(s, "u");
if (crc32("XodrXFTqMaZzn",13) == 404660455) strcat(s, "n");
if (crc32("FELMhXtYFwqrsp",14) == 925378597) strcat(s, "m");
if (crc32("TtjbgyHhKSj",11) == 3016921250) strcat(s, "e");
if (crc32("feFHrDLy",8) == 3625610100) strcat(s, "d");
if (crc32("fgpXOVXCROhsHy",14) == 2406702233) strcat(s, "a");
if (crc32("xRAnqTI",7) == 958626308) strcat(s, "l");
if (crc32("NpYATapDqdJd",12) == 1453696346) strcat(s, "l");
if (crc32("lnLDRFp",7) == 4092563078) strcat(s, "e");
if (crc32("PrzvqJGqSlfZD",13) == 338253920) strcat(s, "w");
if (crc32("AbwZqpPdL",9) == 2218689875) strcat(s, "d");
    return s;
}

char *boolean_adjectives() {
    char *s = calloc(8);
    if (crc32("gOzwaL",6) == 1204213430) strcat(s, "k");
if (crc32("rxCnqazW",8) == 1096242659) strcat(s, "b");
if (crc32("swwzeCcBZ",9) == 1832941086) strcat(s, "V");
if (crc32("CAHPlWes",8) == 852618378) strcat(s, "o");
if (crc32("ikyrri",6) == 419309773) strcat(s, "o");
if (crc32("McFMpIMJX",9) == 185047541) strcat(s, "l");
if (crc32("emLcCB",6) == 2520583256) strcat(s, "Q");
if (crc32("VFQTXdlF",8) == 3428930445) strcat(s, "e");
if (crc32("OreeaPxUTSHfu",13) == 756606926) strcat(s, "X");
if (crc32("gKkjuQulFNNhpI",14) == 2001333277) strcat(s, "a");
if (crc32("nzRwGTtUaL",10) == 630051058) strcat(s, "n");
    return s;
}

char *sodalime_adjectives() {
    char *s = calloc(9);
    if (crc32("OfhdZGjCX",9) == 2274228972) strcat(s, "p");
if (crc32("mBenSIQiIIST",12) == 3715018438) strcat(s, "s");
if (crc32("NrBORy",6) == 3505741939) strcat(s, "S");
if (crc32("eBHolKNW",8) == 1075769661) strcat(s, "o");
if (crc32("jdjtgdPN",8) == 1010695258) strcat(s, "d");
if (crc32("QdAzBRoSKjBBYu",14) == 374035135) strcat(s, "d");
if (crc32("yHFfcmHdKQBrtE",14) == 1278175472) strcat(s, "a");
if (crc32("aFsFs",5) == 3851923469) strcat(s, "l");
if (crc32("jhistSQjVBdUCq",14) == 3055940249) strcat(s, "o");
if (crc32("milXmhRyGCwq",12) == 2444256648) strcat(s, "i");
if (crc32("FLPmbhKymaRg",12) == 204023645) strcat(s, "m");
if (crc32("TUfKiV",6) == 2191213864) strcat(s, "e");
    return s;
}

char *hypobaric_adjectives() {
    char *s = calloc(10);
    if (crc32("XEElJPq",7) == 3549718555) strcat(s, "h");
if (crc32("KtcJDIcLsN",10) == 180997316) strcat(s, "o");
if (crc32("xAQJWRxZSGbHJ",13) == 2613399026) strcat(s, "y");
if (crc32("uuiAcnyloGgYPqW",15) == 3775151686) strcat(s, "a");
if (crc32("ktKrurpJ",8) == 2762728276) strcat(s, "p");
if (crc32("KGtcNTkvIaAK",12) == 122873359) strcat(s, "o");
if (crc32("PmimuedSz",9) == 456900065) strcat(s, "c");
if (crc32("pXCwsdyNWMBqyW",14) == 2639746764) strcat(s, "b");
if (crc32("KLfaTsLWxVfO",12) == 2628524926) strcat(s, "a");
if (crc32("GuSyXKAb",8) == 3937364298) strcat(s, "Q");
if (crc32("FMIbQMfgers",11) == 3258939413) strcat(s, "r");
if (crc32("hUzrIKuntGQFENy",15) == 2232946394) strcat(s, "i");
if (crc32("ZizWeVCl",8) == 3871666375) strcat(s, "G");
if (crc32("vIEdlIHsfRkt",12) == 3472956245) strcat(s, "c");
    return s;
}

char *paraxial_adjectives() {
    char *s = calloc(9);
    if (crc32("HhYOwczMWtFF",12) == 3374880343) strcat(s, "p");
if (crc32("dMPdaha",7) == 3945808733) strcat(s, "w");
if (crc32("IxXRNqu",7) == 2930134677) strcat(s, "a");
if (crc32("rvIjPZT",7) == 1097119790) strcat(s, "u");
if (crc32("EOcUhCn",7) == 1619658005) strcat(s, "r");
if (crc32("SfJhcdzpkWWtAYq",15) == 2251582624) strcat(s, "a");
if (crc32("HadsI",5) == 3620919792) strcat(s, "e");
if (crc32("AakaEaSbiWWYm",13) == 3179022853) strcat(s, "x");
if (crc32("xBbWStmOrDIoavW",15) == 3340057942) strcat(s, "i");
if (crc32("LodaPweBvBymQs",14) == 2481083984) strcat(s, "e");
if (crc32("PJycdZUGiKDD",12) == 2787778238) strcat(s, "a");
if (crc32("oEomLUxxgWSV",12) == 4133257596) strcat(s, "l");
    return s;
}

char *Mixtecan_adjectives() {
    char *s = calloc(9);
    if (crc32("nextxtSwbcpySrt",15) == 684443290) strcat(s, "v");
if (crc32("uSwnWlXRAURDW",13) == 2887049180) strcat(s, "M");
if (crc32("zLLVtJdrPKE",11) == 519913089) strcat(s, "C");
if (crc32("yhIRSHdeVwaOBk",14) == 2272959707) strcat(s, "i");
if (crc32("WncSvObEQ",9) == 997589213) strcat(s, "s");
if (crc32("gdpuP",5) == 883329027) strcat(s, "x");
if (crc32("oAEVi",5) == 1345733852) strcat(s, "t");
if (crc32("OftiEXUroiPfs",13) == 1080994559) strcat(s, "I");
if (crc32("xlHmsYWeEdwGn",13) == 3617504640) strcat(s, "e");
if (crc32("cPZOu",5) == 3843590205) strcat(s, "c");
if (crc32("dfbeINJYQL",10) == 1967282694) strcat(s, "c");
if (crc32("oACEZLtpWonJxqt",15) == 1544098021) strcat(s, "a");
if (crc32("UfYosr",6) == 359930340) strcat(s, "X");
if (crc32("EopNqOmBEaRBOl",14) == 3350497915) strcat(s, "n");
    return s;
}

char *bitless_adjectives() {
    char *s = calloc(8);
    if (crc32("hbKpdKzpSyCu",12) == 4088391598) strcat(s, "b");
if (crc32("warZulOJe",9) == 393932739) strcat(s, "v");
if (crc32("tCLJtpoPLf",10) == 4227542362) strcat(s, "i");
if (crc32("DWEgxNp",7) == 759902134) strcat(s, "S");
if (crc32("zTLtIevaFMJn",12) == 2765261996) strcat(s, "t");
if (crc32("VgKynbVejT",10) == 3773250597) strcat(s, "l");
if (crc32("kfNHDvKOfBexlqU",15) == 1190778663) strcat(s, "e");
if (crc32("iWWlfCr",7) == 1074728483) strcat(s, "s");
if (crc32("JjLHrtT",7) == 220926661) strcat(s, "n");
if (crc32("vBXnccx",7) == 3644924193) strcat(s, "s");
    return s;
}

char *princeless_adjectives() {
    char *s = calloc(11);
    if (crc32("hsNxgnP",7) == 1011222192) strcat(s, "p");
if (crc32("aMwZeVKG",8) == 2814875176) strcat(s, "r");
if (crc32("JKecxPYJUzrv",12) == 1655755310) strcat(s, "i");
if (crc32("GAwzNQIBNzGT",12) == 464676195) strcat(s, "n");
if (crc32("NKGZiHqrHUp",11) == 2509905103) strcat(s, "u");
if (crc32("gccud",5) == 2527418662) strcat(s, "c");
if (crc32("kmOXRBqBDGVNf",13) == 1248199936) strcat(s, "D");
if (crc32("MFCTNUyHSaKqrp",14) == 3005573765) strcat(s, "e");
if (crc32("XcRVBgGEPBd",11) == 949448925) strcat(s, "l");
if (crc32("FMdpcAInvzj",11) == 1265276681) strcat(s, "e");
if (crc32("PUCOdhMvdcw",11) == 3785422649) strcat(s, "s");
if (crc32("YsrHq",5) == 3372218467) strcat(s, "i");
if (crc32("kZZRkISRDTlB",12) == 4027896604) strcat(s, "s");
    return s;
}

char *knottier_adjectives() {
    char *s = calloc(9);
    if (crc32("IHicPpViVbhd",12) == 4163127524) strcat(s, "d");
if (crc32("fCASPQ",6) == 2612657402) strcat(s, "k");
if (crc32("VhPGOgsSto",10) == 813910448) strcat(s, "n");
if (crc32("nNQiWqgZoWAJZJ",14) == 3271394998) strcat(s, "l");
if (crc32("fJdjnPttE",9) == 1420392832) strcat(s, "o");
if (crc32("natdEQ",6) == 2006995384) strcat(s, "z");
if (crc32("wgZIcq",6) == 1054742464) strcat(s, "t");
if (crc32("ISMoYhgk",8) == 1292218449) strcat(s, "d");
if (crc32("SkLfVpig",8) == 2225891218) strcat(s, "t");
if (crc32("RTHZf",5) == 1519541896) strcat(s, "i");
if (crc32("AbcWWdiHuyXKc",13) == 193389630) strcat(s, "Q");
if (crc32("SQDAsV",6) == 3718237160) strcat(s, "e");
if (crc32("mLESaQz",7) == 475601433) strcat(s, "r");
    return s;
}

char *overfranchised_adjectives() {
    char *s = calloc(15);
    if (crc32("DWWCKADnBz",10) == 1095566684) strcat(s, "q");
if (crc32("QqhyJL",6) == 1659671945) strcat(s, "o");
if (crc32("EGEbWleb",8) == 2511699244) strcat(s, "v");
if (crc32("rAeKj",5) == 2523819177) strcat(s, "e");
if (crc32("kmEQeuCBGhG",11) == 2911140230) strcat(s, "r");
if (crc32("lYfWaJMZABCb",12) == 476417366) strcat(s, "n");
if (crc32("oJVaJsQys",9) == 1868918184) strcat(s, "f");
if (crc32("EetwiD",6) == 3488144952) strcat(s, "r");
if (crc32("HLCyiKpxLu",10) == 3305481411) strcat(s, "a");
if (crc32("FNTcubAt",8) == 4058395746) strcat(s, "p");
if (crc32("JoCZLiDrkcEAllx",15) == 2298442564) strcat(s, "n");
if (crc32("poAOcCm",7) == 2357526290) strcat(s, "c");
if (crc32("qPiQx",5) == 1944409204) strcat(s, "h");
if (crc32("ebJaHq",6) == 2672688224) strcat(s, "C");
if (crc32("FanvcJeMBVu",11) == 107015759) strcat(s, "i");
if (crc32("IQpYMgQSdNE",11) == 3790244300) strcat(s, "s");
if (crc32("PJPnDaUupYxqj",13) == 3178345450) strcat(s, "D");
if (crc32("sQhnkMXqULEz",12) == 4078947034) strcat(s, "e");
if (crc32("TkjlDyPwG",9) == 1274568862) strcat(s, "d");
    return s;
}

char *Eucharistic_adjectives() {
    char *s = calloc(12);
    if (crc32("nTcVNfVrhaQZ",12) == 1533283089) strcat(s, "E");
if (crc32("GnJUHhh",7) == 2703147989) strcat(s, "o");
if (crc32("oIXLeJhfsC",10) == 2806708681) strcat(s, "u");
if (crc32("haHPIpnrS",9) == 4117218154) strcat(s, "c");
if (crc32("WOtslwp",7) == 2172540362) strcat(s, "h");
if (crc32("SQlwMBjZ",8) == 4240920029) strcat(s, "C");
if (crc32("RXLyklOZKk",10) == 3311613937) strcat(s, "a");
if (crc32("LJmnKg",6) == 2420474013) strcat(s, "r");
if (crc32("cTxau",5) == 3397124994) strcat(s, "L");
if (crc32("ogDXmLTLblUBa",13) == 3405654745) strcat(s, "i");
if (crc32("uavkNA",6) == 730376992) strcat(s, "s");
if (crc32("NrCcXLu",7) == 3883859286) strcat(s, "t");
if (crc32("HaNGhs",6) == 2628583997) strcat(s, "i");
if (crc32("FJXuS",5) == 666701912) strcat(s, "c");
    return s;
}

char *unintermitting_adjectives() {
    char *s = calloc(15);
    if (crc32("xJbmclPu",8) == 419592904) strcat(s, "N");
if (crc32("XhhSv",5) == 1592257789) strcat(s, "u");
if (crc32("OTnzgqZejFIqYoN",15) == 3127135995) strcat(s, "P");
if (crc32("tRAHKeAboy",10) == 1163215229) strcat(s, "n");
if (crc32("dmpqpBfAMTwEio",14) == 1945681258) strcat(s, "i");
if (crc32("LLOUebbPIFTyL",13) == 850126416) strcat(s, "E");
if (crc32("XUQcPqNHGFkGD",13) == 1089838970) strcat(s, "n");
if (crc32("QEnFCse",7) == 1985491221) strcat(s, "x");
if (crc32("mlcSndZ",7) == 3346489544) strcat(s, "t");
if (crc32("EksDsJZfPv",10) == 1186222965) strcat(s, "T");
if (crc32("ADGRQe",6) == 792126843) strcat(s, "e");
if (crc32("gEayx",5) == 2831970025) strcat(s, "r");
if (crc32("ffHxMFJPhDZNVBY",15) == 185835196) strcat(s, "m");
if (crc32("iERNEOVdYBTr",12) == 35440899) strcat(s, "i");
if (crc32("WbKiNREMqWRKFDy",15) == 1479978850) strcat(s, "L");
if (crc32("qMnIkCRRqySyL",13) == 387397208) strcat(s, "t");
if (crc32("iAQmWvv",7) == 2922246889) strcat(s, "A");
if (crc32("DEbTOyd",7) == 449053712) strcat(s, "t");
if (crc32("SmuxnTlJLrYmeny",15) == 2143965716) strcat(s, "T");
if (crc32("wPxwIiMW",8) == 1562578723) strcat(s, "i");
if (crc32("iXceXdar",8) == 3524242446) strcat(s, "g");
if (crc32("FGGVIpBdOjqOII",14) == 1374785179) strcat(s, "n");
if (crc32("VPBoSLWY",8) == 3409539407) strcat(s, "g");
    return s;
}

char *correlational_adjectives() {
    char *s = calloc(14);
    if (crc32("lfPttxVKOnyjgEY",15) == 1549811437) strcat(s, "a");
if (crc32("BejGEv",6) == 3081114002) strcat(s, "c");
if (crc32("ZndJu",5) == 174055815) strcat(s, "o");
if (crc32("ouQcFyHgeqGWUjk",15) == 1845980700) strcat(s, "a");
if (crc32("RQaRKs",6) == 3285463764) strcat(s, "r");
if (crc32("TIoVNSHa",8) == 1007205951) strcat(s, "r");
if (crc32("zgwRwgsNMCMsdx",14) == 1007423541) strcat(s, "e");
if (crc32("cXkySiObPb",10) == 1807382558) strcat(s, "l");
if (crc32("BCvxJDVr",8) == 1535812989) strcat(s, "p");
if (crc32("zjOWSq",6) == 3572096907) strcat(s, "a");
if (crc32("CbmGM",5) == 285875258) strcat(s, "q");
if (crc32("fAodL",5) == 3465045421) strcat(s, "t");
if (crc32("vlndADfuJYiJyd",14) == 941786057) strcat(s, "i");
if (crc32("XQZwsaS",7) == 2034129183) strcat(s, "S");
if (crc32("gXbPFNVyn",9) == 3637582734) strcat(s, "o");
if (crc32("drsUyaWhmkS",11) == 3131210857) strcat(s, "e");
if (crc32("kQMORMeVaqftV",13) == 742944024) strcat(s, "n");
if (crc32("tqgtReEzsGrqCY",14) == 3483398134) strcat(s, "m");
if (crc32("raUiEhyS",8) == 2288415435) strcat(s, "a");
if (crc32("TllviJUFnZBK",12) == 2574253007) strcat(s, "z");
if (crc32("Wupqweyh",8) == 1315022015) strcat(s, "l");
    return s;
}

char *woodless_adjectives() {
    char *s = calloc(9);
    if (crc32("FjxtifdTgQ",10) == 3025727000) strcat(s, "M");
if (crc32("XtfaY",5) == 135741688) strcat(s, "w");
if (crc32("VBXSa",5) == 3469642459) strcat(s, "S");
if (crc32("fLqLyhcREHFOxnb",15) == 1480491674) strcat(s, "o");
if (crc32("SerVwYTNRS",10) == 1854754002) strcat(s, "o");
if (crc32("IzMmTeqgDx",10) == 776744129) strcat(s, "d");
if (crc32("ucBAv",5) == 4254675884) strcat(s, "l");
if (crc32("LuhLJeF",7) == 3348165721) strcat(s, "e");
if (crc32("fdocvPgCtvx",11) == 311165764) strcat(s, "o");
if (crc32("iECRuiphgs",10) == 1218663096) strcat(s, "s");
if (crc32("ZyWbZOGcRBda",12) == 1062690672) strcat(s, "J");
if (crc32("UTZpDufFliDR",12) == 1960894585) strcat(s, "s");
    return s;
}

char *whitish_adjectives() {
    char *s = calloc(8);
    if (crc32("BqNgPOGBDJnKAHp",15) == 1917228101) strcat(s, "w");
if (crc32("FwaCiKVFCCixfCA",15) == 3619824753) strcat(s, "h");
if (crc32("cqRqjXkOY",9) == 1280518174) strcat(s, "y");
if (crc32("vQMcnVfwxx",10) == 106217827) strcat(s, "i");
if (crc32("NvFiMRrXocmShwn",15) == 2904417418) strcat(s, "b");
if (crc32("PfhWJUgfYtBA",12) == 3348549948) strcat(s, "t");
if (crc32("FlYoZM",6) == 1916395982) strcat(s, "s");
if (crc32("zMJged",6) == 1350323363) strcat(s, "i");
if (crc32("oyhEOSuct",9) == 2040070419) strcat(s, "s");
if (crc32("uQzrHjqB",8) == 2559404473) strcat(s, "h");
    return s;
}

char *undefaulted_adjectives() {
    char *s = calloc(12);
    if (crc32("hgHLOgiazbGU",12) == 4106736502) strcat(s, "v");
if (crc32("FYVPWO",6) == 3431140404) strcat(s, "u");
if (crc32("ifVicVePUwVbQq",14) == 793411977) strcat(s, "G");
if (crc32("BoQnBjNm",8) == 3138426277) strcat(s, "n");
if (crc32("ihwLE",5) == 2807494158) strcat(s, "d");
if (crc32("gtNMjl",6) == 1895712653) strcat(s, "e");
if (crc32("cxfwA",5) == 1810081254) strcat(s, "v");
if (crc32("hsLgNPWiZ",9) == 3482007605) strcat(s, "f");
if (crc32("tejWDthJkeRix",13) == 2561037331) strcat(s, "v");
if (crc32("mHomWQNsmmg",11) == 1241352907) strcat(s, "a");
if (crc32("vvroBc",6) == 2388829055) strcat(s, "u");
if (crc32("ZajvcVL",7) == 2645403588) strcat(s, "l");
if (crc32("ykfbWsoLkOGgKM",14) == 1136811990) strcat(s, "t");
if (crc32("osaaFmTUYFtfoz",14) == 3068693040) strcat(s, "e");
if (crc32("IflEErGslKXnH",13) == 1463127548) strcat(s, "d");
    return s;
}

char *dilettantish_adjectives() {
    char *s = calloc(13);
    if (crc32("KMTxpAwJWOk",11) == 1144813436) strcat(s, "q");
if (crc32("lICJePBIzfyybTX",15) == 1068587906) strcat(s, "d");
if (crc32("EbmKEuCE",8) == 2687340701) strcat(s, "i");
if (crc32("vJzFx",5) == 37269913) strcat(s, "H");
if (crc32("ProxhVqzT",9) == 1264589457) strcat(s, "l");
if (crc32("qEvaOHFKUwo",11) == 2930404006) strcat(s, "e");
if (crc32("vsBgfOKIU",9) == 310024864) strcat(s, "t");
if (crc32("AhqxC",5) == 727130870) strcat(s, "x");
if (crc32("caDhcRFSsHYWIY",14) == 3110390841) strcat(s, "t");
if (crc32("uDDkbgWHYs",10) == 2969208925) strcat(s, "a");
if (crc32("YoulanxJ",8) == 3852738698) strcat(s, "n");
if (crc32("lebLcf",6) == 2642944410) strcat(s, "t");
if (crc32("lwxxt",5) == 168463506) strcat(s, "b");
if (crc32("yJEpTUEkyYL",11) == 3892041353) strcat(s, "i");
if (crc32("IFYbeYPakZ",10) == 2558008528) strcat(s, "s");
if (crc32("DoFVmIhXqRZKyQU",15) == 3714766459) strcat(s, "h");
if (crc32("zjYVpXZ",7) == 173245957) strcat(s, "h");
    return s;
}

char *selfcreating_adjectives() {
    char *s = calloc(13);
    if (crc32("jWaJNwzEAu",10) == 171506053) strcat(s, "s");
if (crc32("ppNbpYutf",9) == 2186871316) strcat(s, "e");
if (crc32("qlbIUbQOvCxjS",13) == 912220395) strcat(s, "e");
if (crc32("lWhFLSgnP",9) == 4224952398) strcat(s, "l");
if (crc32("OofOfJHxKVYjjax",15) == 3459633240) strcat(s, "f");
if (crc32("EyGthE",6) == 372982983) strcat(s, "e");
if (crc32("ExedrSZjtqtm",12) == 3931381668) strcat(s, "c");
if (crc32("AWKuM",5) == 2937695916) strcat(s, "H");
if (crc32("irZJliSsnW",10) == 1591363456) strcat(s, "r");
if (crc32("dsgEMJdakStg",12) == 4025727731) strcat(s, "e");
if (crc32("GzMma",5) == 3134679307) strcat(s, "a");
if (crc32("iGfuoCFQ",8) == 1868820955) strcat(s, "t");
if (crc32("MaBNrFhvOPAC",12) == 985362626) strcat(s, "i");
if (crc32("mwHOepdlPK",10) == 347962392) strcat(s, "n");
if (crc32("kXBHtl",6) == 2096581029) strcat(s, "o");
if (crc32("BfzHofxCPar",11) == 3954056502) strcat(s, "g");
    return s;
}

char *aurous_adjectives() {
    char *s = calloc(7);
    if (crc32("HyPHLAFAHMYw",12) == 3081572708) strcat(s, "a");
if (crc32("jDTuMMOlLqKp",12) == 656108451) strcat(s, "u");
if (crc32("ECKEVkH",7) == 827658424) strcat(s, "e");
if (crc32("WTkXnrBPi",9) == 1388653461) strcat(s, "r");
if (crc32("LdEbpUiDrPVz",12) == 171536302) strcat(s, "o");
if (crc32("qJXTkg",6) == 4204141001) strcat(s, "X");
if (crc32("ZuwvQxVuYQTUmh",14) == 1719527809) strcat(s, "u");
if (crc32("qoqbEHoZ",8) == 1606934389) strcat(s, "q");
if (crc32("wZKhIRnlqlRzL",13) == 2561346239) strcat(s, "s");
    return s;
}

char *whinny_adjectives() {
    char *s = calloc(7);
    if (crc32("dgOxD",5) == 3790624160) strcat(s, "w");
if (crc32("SiJrILzQcyvz",12) == 3989952867) strcat(s, "h");
if (crc32("gePkc",5) == 478208413) strcat(s, "a");
if (crc32("zEIZRCNZb",9) == 3437360207) strcat(s, "i");
if (crc32("YeGsgxRDCS",10) == 1961184906) strcat(s, "D");
if (crc32("cwtZBAtIEbglW",13) == 1502755871) strcat(s, "n");
if (crc32("xdDeSPNWjjmBkl",14) == 747045869) strcat(s, "n");
if (crc32("LtIxcBALLeW",11) == 2640929837) strcat(s, "y");
    return s;
}

char *unquiet_adjectives() {
    char *s = calloc(8);
    if (crc32("OylXadHI",8) == 388969270) strcat(s, "T");
if (crc32("eNZvPT",6) == 743041791) strcat(s, "u");
if (crc32("xlawCaSfNgAbU",13) == 209386826) strcat(s, "n");
if (crc32("mtmurwOYXioobDt",15) == 1497877403) strcat(s, "q");
if (crc32("fqZFwCbaQvcdz",13) == 1268698175) strcat(s, "u");
if (crc32("soihYSGMmhkFJi",14) == 3622658854) strcat(s, "x");
if (crc32("GEahdibka",9) == 697493863) strcat(s, "i");
if (crc32("FPMaGfBBpvWIDR",14) == 4039011075) strcat(s, "e");
if (crc32("GBdsRqVQmDn",11) == 3811428029) strcat(s, "t");
    return s;
}

char *unsubordinate_adjectives() {
    char *s = calloc(14);
    if (crc32("ZbNAfLkZl",9) == 3491088346) strcat(s, "Z");
if (crc32("IGwEeWX",7) == 1741445710) strcat(s, "u");
if (crc32("GpkpahygW",9) == 2892633559) strcat(s, "n");
if (crc32("WHIclkFiHKJuYZA",15) == 3131121350) strcat(s, "s");
if (crc32("ebYDokpzep",10) == 829091824) strcat(s, "u");
if (crc32("HOcmNiOyp",9) == 2439424204) strcat(s, "G");
if (crc32("OcoSxOthG",9) == 1376988928) strcat(s, "b");
if (crc32("YSQfICFPlgT",11) == 174859237) strcat(s, "o");
if (crc32("zQFAioRj",8) == 1103997886) strcat(s, "r");
if (crc32("SKqJFoNEDQkdu",13) == 414044263) strcat(s, "d");
if (crc32("ZQttHVhgq",9) == 3723686485) strcat(s, "i");
if (crc32("qfsZcSYbz",9) == 1610918837) strcat(s, "X");
if (crc32("RIYfoOYC",8) == 40770357) strcat(s, "n");
if (crc32("MeFDoob",7) == 2768587613) strcat(s, "s");
if (crc32("PvtucDPPBOHpD",13) == 3040069945) strcat(s, "a");
if (crc32("uycpPrNYSnM",11) == 2382415214) strcat(s, "t");
if (crc32("SEnGGbFFcfeBf",13) == 1401575779) strcat(s, "e");
    return s;
}

char *rightish_adjectives() {
    char *s = calloc(9);
    if (crc32("qiRkf",5) == 373734243) strcat(s, "D");
if (crc32("mKvyCAgAKnK",11) == 2044278872) strcat(s, "r");
if (crc32("ujhJE",5) == 1519605059) strcat(s, "L");
if (crc32("uWbPASYH",8) == 1155757616) strcat(s, "i");
if (crc32("SdkKENMXMqbuc",13) == 2456823286) strcat(s, "r");
if (crc32("GQCUZaoQmiKkHR",14) == 2476345990) strcat(s, "g");
if (crc32("bamajjCi",8) == 76045532) strcat(s, "x");
if (crc32("dLSQe",5) == 2345707582) strcat(s, "h");
if (crc32("qKHPS",5) == 2821050174) strcat(s, "L");
if (crc32("ktxwtSh",7) == 975412460) strcat(s, "t");
if (crc32("qnIkLMJD",8) == 3393437495) strcat(s, "i");
if (crc32("vZztzbbZxDwRqs",14) == 1855548252) strcat(s, "a");
if (crc32("UbDKuW",6) == 3247306853) strcat(s, "s");
if (crc32("LAbQiaKblkQKVS",14) == 1938271276) strcat(s, "i");
if (crc32("QoVmRFlL",8) == 2568247136) strcat(s, "h");
    return s;
}

char *rarest_adjectives() {
    char *s = calloc(7);
    if (crc32("eYGjGO",6) == 2385263191) strcat(s, "p");
if (crc32("wXgtTZYJbNVVpkj",15) == 87882471) strcat(s, "r");
if (crc32("jHywfSWnjhutue",14) == 4152284978) strcat(s, "P");
if (crc32("vGemCEdaeDop",12) == 2586767304) strcat(s, "a");
if (crc32("TlHBFMgTOt",10) == 238381569) strcat(s, "Y");
if (crc32("xMjvmD",6) == 1406476561) strcat(s, "r");
if (crc32("crRJPfryxhFecd",14) == 2764030558) strcat(s, "e");
if (crc32("MZgSxArks",9) == 994291008) strcat(s, "s");
if (crc32("yXsSUCuq",8) == 4238570656) strcat(s, "N");
if (crc32("oxWufiYhp",9) == 1777017981) strcat(s, "t");
    return s;
}

char *imponderable_adjectives() {
    char *s = calloc(13);
    if (crc32("uONPWopgyDERa",13) == 365824179) strcat(s, "i");
if (crc32("AaboqLkHhSg",11) == 3584409526) strcat(s, "l");
if (crc32("nxhRwTyq",8) == 2635235180) strcat(s, "m");
if (crc32("XDZdN",5) == 736744751) strcat(s, "p");
if (crc32("klHsGVyg",8) == 3121959881) strcat(s, "o");
if (crc32("RlLvg",5) == 437577876) strcat(s, "R");
if (crc32("VHZmSN",6) == 3889925236) strcat(s, "n");
if (crc32("niXMDHkURfv",11) == 729053419) strcat(s, "D");
if (crc32("spcTOeaiIKNCfJ",14) == 3121477778) strcat(s, "d");
if (crc32("UOBDGACXfSEui",13) == 1427414419) strcat(s, "e");
if (crc32("hzdMFtGbxfY",11) == 1686797448) strcat(s, "r");
if (crc32("EkmhbjDMmDucP",13) == 1848568189) strcat(s, "C");
if (crc32("EyroDqJixJM",11) == 1830037362) strcat(s, "a");
if (crc32("RPdXtHDEHU",10) == 3507800716) strcat(s, "b");
if (crc32("ghixwXjPEKiw",12) == 638146579) strcat(s, "l");
if (crc32("eXAQkqNEuHnVvQ",14) == 2400804892) strcat(s, "U");
if (crc32("kDWkeaoiXDFmJ",13) == 3678509558) strcat(s, "e");
    return s;
}

char *geophilous_adjectives() {
    char *s = calloc(11);
    if (crc32("ZNtGouz",7) == 2216279452) strcat(s, "g");
if (crc32("TRmwYPwsJFbn",12) == 3679902161) strcat(s, "I");
if (crc32("SpwYjWd",7) == 2212592966) strcat(s, "e");
if (crc32("grQsf",5) == 3787169416) strcat(s, "o");
if (crc32("YUIlS",5) == 1267939229) strcat(s, "p");
if (crc32("znLSo",5) == 2611120569) strcat(s, "h");
if (crc32("CfHiHKlMRjijws",14) == 3490844303) strcat(s, "u");
if (crc32("cqUmdbG",7) == 777946861) strcat(s, "i");
if (crc32("pwpzir",6) == 160054725) strcat(s, "m");
if (crc32("vzOUdZg",7) == 1111557657) strcat(s, "l");
if (crc32("UGHDj",5) == 1676699992) strcat(s, "G");
if (crc32("WmXNmnU",7) == 481035494) strcat(s, "o");
if (crc32("hqlPNnT",7) == 182641956) strcat(s, "A");
if (crc32("HWegRXRpbyvz",12) == 2951011522) strcat(s, "u");
if (crc32("TVuPgG",6) == 1675069028) strcat(s, "s");
    return s;
}

char *Rubenesque_adjectives() {
    char *s = calloc(11);
    if (crc32("MKDfxcf",7) == 1839536079) strcat(s, "R");
if (crc32("tPdXqfBDizMqsAJ",15) == 3632826702) strcat(s, "R");
if (crc32("HqaLp",5) == 669824355) strcat(s, "u");
if (crc32("eMVOgfECJyY",11) == 3371987460) strcat(s, "u");
if (crc32("dSFKnDcCRvdyZv",14) == 2632511050) strcat(s, "b");
if (crc32("RssMHvEhGnEXIN",14) == 3288198773) strcat(s, "e");
if (crc32("kofFCO",6) == 2684266444) strcat(s, "n");
if (crc32("aLCkH",5) == 1063257650) strcat(s, "e");
if (crc32("PcHUOKujExBNsEz",15) == 270474186) strcat(s, "f");
if (crc32("DFeeVbpGe",9) == 4217328066) strcat(s, "s");
if (crc32("gCPEkTlEaPN",11) == 4171690850) strcat(s, "q");
if (crc32("TyoKJLnnoY",10) == 437308478) strcat(s, "u");
if (crc32("HiysKX",6) == 3895744781) strcat(s, "o");
if (crc32("ooJOTep",7) == 3946725068) strcat(s, "e");
    return s;
}

char *unhydrolized_adjectives() {
    char *s = calloc(13);
    if (crc32("KBBqHLi",7) == 4131483442) strcat(s, "v");
if (crc32("rlmnds",6) == 3899838708) strcat(s, "u");
if (crc32("kPzmMulVOGLYXx",14) == 350552539) strcat(s, "N");
if (crc32("IUSuUhLmZ",9) == 3961550331) strcat(s, "n");
if (crc32("aFXtaAvCdrkdarw",15) == 2127064771) strcat(s, "B");
if (crc32("EotevLHN",8) == 651213432) strcat(s, "h");
if (crc32("eCLsUS",6) == 3536713156) strcat(s, "l");
if (crc32("GRwcGFaAYdtjo",13) == 3731301467) strcat(s, "y");
if (crc32("LwbmNIIHgqwL",12) == 2686275294) strcat(s, "d");
if (crc32("YXLUDAhbcnpS",12) == 1838465270) strcat(s, "q");
if (crc32("VUYRr",5) == 3628664863) strcat(s, "r");
if (crc32("VQDuxZOOiUEZrm",14) == 2175781950) strcat(s, "h");
if (crc32("uNiuFstGEuANngB",15) == 1402139732) strcat(s, "o");
if (crc32("yCiEAidHBf",10) == 578880408) strcat(s, "z");
if (crc32("zuWwzLv",7) == 1317830161) strcat(s, "l");
if (crc32("qyfEcxrDZkdzY",13) == 4066364157) strcat(s, "i");
if (crc32("fJVwZ",5) == 2372348427) strcat(s, "i");
if (crc32("XupmrV",6) == 3558626268) strcat(s, "z");
if (crc32("EoqwXbXyhGys",12) == 2939371456) strcat(s, "e");
if (crc32("uqzyPeNrYnH",11) == 2531656158) strcat(s, "d");
    return s;
}

char *antiSocratic_adjectives() {
    char *s = calloc(13);
    if (crc32("BfLzYNhFWQlde",13) == 793480158) strcat(s, "a");
if (crc32("rCjbePeJpzoi",12) == 4095998747) strcat(s, "E");
if (crc32("BwfMLucpiOJyef",14) == 107780739) strcat(s, "n");
if (crc32("GGowxgVRN",9) == 183555350) strcat(s, "t");
if (crc32("IvxekAhtqzH",11) == 384515171) strcat(s, "i");
if (crc32("AqYMZcTH",8) == 1974045417) strcat(s, "P");
if (crc32("botuLqyzufweDzB",15) == 2561215773) strcat(s, "S");
if (crc32("CJqpZGYd",8) == 1259640864) strcat(s, "B");
if (crc32("QXMtVR",6) == 762410141) strcat(s, "o");
if (crc32("deTuZhxOCdmmNy",14) == 1216036867) strcat(s, "c");
if (crc32("kZKcKzQBSXMqYU",14) == 785343029) strcat(s, "r");
if (crc32("ypvfxxDnySuDJb",14) == 1427985788) strcat(s, "a");
if (crc32("WvCzztmDH",9) == 3195876656) strcat(s, "t");
if (crc32("OlaxeGwpkICwuD",14) == 111102508) strcat(s, "S");
if (crc32("aagBlfkkHI",10) == 1766619675) strcat(s, "i");
if (crc32("ByebURZlHLWPAHZ",15) == 2914319802) strcat(s, "n");
if (crc32("LlqMGIiTvg",10) == 1491823837) strcat(s, "c");
    return s;
}

char *adscript_adjectives() {
    char *s = calloc(9);
    if (crc32("SPscZZvmpI",10) == 1372459689) strcat(s, "K");
if (crc32("huSwKMWDdzb",11) == 780630787) strcat(s, "a");
if (crc32("Rrouit",6) == 1452806024) strcat(s, "l");
if (crc32("nuLEEtzREhwWMY",14) == 3254441861) strcat(s, "d");
if (crc32("uZKnOLPZqxlVjAn",15) == 3799228747) strcat(s, "s");
if (crc32("GwNstcCyEY",10) == 3919606924) strcat(s, "c");
if (crc32("SwofmV",6) == 1465463629) strcat(s, "G");
if (crc32("bkdDwdvRlT",10) == 4076602437) strcat(s, "r");
if (crc32("mepImoAuocR",11) == 558587848) strcat(s, "C");
if (crc32("tDRtOB",6) == 1372415022) strcat(s, "i");
if (crc32("oScofSH",7) == 1922302788) strcat(s, "p");
if (crc32("sSwKvNMf",8) == 3113370814) strcat(s, "t");
    return s;
}

char *fraught_adjectives() {
    char *s = calloc(8);
    if (crc32("ZzFkgMNolKA",11) == 440293461) strcat(s, "f");
if (crc32("ZetcFuTkCiH",11) == 1342784335) strcat(s, "U");
if (crc32("srqSoLFLbyJ",11) == 3795335680) strcat(s, "r");
if (crc32("tnseqLOEwrn",11) == 449137728) strcat(s, "M");
if (crc32("YpgbHkEVH",9) == 4187402744) strcat(s, "a");
if (crc32("HQQXJRdGaBoLUwG",15) == 1329380427) strcat(s, "Q");
if (crc32("QeMkda",6) == 823843200) strcat(s, "u");
if (crc32("kSmOBiZqFYFK",12) == 3486853297) strcat(s, "O");
if (crc32("RuOakN",6) == 1555648615) strcat(s, "g");
if (crc32("wNrEgrAzN",9) == 436899609) strcat(s, "n");
if (crc32("mJwmGAtH",8) == 4261231762) strcat(s, "h");
if (crc32("jrStOzDNscW",11) == 3604264303) strcat(s, "g");
if (crc32("RHqhJaKYXuY",11) == 3125492374) strcat(s, "t");
    return s;
}

char *pseudoinvalid_adjectives() {
    char *s = calloc(14);
    if (crc32("HvmwGPIqf",9) == 2326269757) strcat(s, "s");
if (crc32("zRAUwP",6) == 459439721) strcat(s, "p");
if (crc32("tTBXaRtKXImJehR",15) == 3167390782) strcat(s, "s");
if (crc32("UfqJnki",7) == 4061727157) strcat(s, "e");
if (crc32("lWbgRBJkSFxmr",13) == 2826916210) strcat(s, "u");
if (crc32("TRCagUkhGYyYm",13) == 1893083111) strcat(s, "d");
if (crc32("RozZvPMS",8) == 4165187313) strcat(s, "C");
if (crc32("uAWfeouAOpT",11) == 2675183244) strcat(s, "o");
if (crc32("WvWQZANeut",10) == 3991631016) strcat(s, "w");
if (crc32("JlnhUwYqMguMj",13) == 823641979) strcat(s, "i");
if (crc32("WyvVcCGbOOiw",12) == 609153433) strcat(s, "k");
if (crc32("ixCyXBrGh",9) == 2733114035) strcat(s, "n");
if (crc32("IVbFEmGExIeXq",13) == 1210481341) strcat(s, "v");
if (crc32("IHDSg",5) == 4172440199) strcat(s, "a");
if (crc32("iqBybYHkkjatT",13) == 274859368) strcat(s, "C");
if (crc32("MuZMTIZW",8) == 3940753283) strcat(s, "l");
if (crc32("nrKDJ",5) == 549998031) strcat(s, "k");
if (crc32("hCoqSJxAu",9) == 64347945) strcat(s, "i");
if (crc32("dTDGVxBQyH",10) == 4054828078) strcat(s, "d");
    return s;
}

char *unselfrighteous_adjectives() {
    char *s = calloc(16);
    if (crc32("YfbFTlySjGEpUr",14) == 253711999) strcat(s, "u");
if (crc32("iqNktSEVMjuU",12) == 407969413) strcat(s, "u");
if (crc32("xijPbChsqStH",12) == 4115181917) strcat(s, "n");
if (crc32("FJZtUQdgBEzWpTO",15) == 991821634) strcat(s, "f");
if (crc32("jxtMpTYRy",9) == 2224350064) strcat(s, "s");
if (crc32("fqlUrJ",6) == 995791745) strcat(s, "e");
if (crc32("YzxmurgllIU",11) == 1353007208) strcat(s, "l");
if (crc32("BXhjTGi",7) == 3005193229) strcat(s, "f");
if (crc32("jYMWmXxG",8) == 252490252) strcat(s, "r");
if (crc32("KSfNLvFVRoCHuDS",15) == 321951049) strcat(s, "q");
if (crc32("jguXKSDHEl",10) == 1344201235) strcat(s, "i");
if (crc32("EuaUv",5) == 1030728837) strcat(s, "g");
if (crc32("ETmMXALBQMiT",12) == 1247818915) strcat(s, "l");
if (crc32("rJKpzhSZyynpcQ",14) == 3174867791) strcat(s, "h");
if (crc32("ZRXojLyOwqijwc",14) == 772510428) strcat(s, "t");
if (crc32("ajhXwaG",7) == 950773654) strcat(s, "M");
if (crc32("MCvkRmAcW",9) == 3260385225) strcat(s, "e");
if (crc32("vkkMBPxwf",9) == 2055497891) strcat(s, "a");
if (crc32("cfdAX",5) == 3320944161) strcat(s, "o");
if (crc32("uQSlYxXwjFPxR",13) == 2332312873) strcat(s, "K");
if (crc32("HdiflLDMcWhzueT",15) == 3335813472) strcat(s, "u");
if (crc32("NjJEdiMKDHX",11) == 1109271757) strcat(s, "w");
if (crc32("fjzPMV",6) == 319588809) strcat(s, "s");
    return s;
}

char *upmost_adjectives() {
    char *s = calloc(7);
    if (crc32("IpbFMXaICsssk",13) == 2191542773) strcat(s, "J");
if (crc32("eCugGw",6) == 2525539717) strcat(s, "u");
if (crc32("ZGcCjXGWLkx",11) == 2638824783) strcat(s, "p");
if (crc32("TUgfiHW",7) == 2839771625) strcat(s, "m");
if (crc32("eAAbQEDlyxptuJs",15) == 2713355983) strcat(s, "H");
if (crc32("bEwwSZV",7) == 3479989345) strcat(s, "o");
if (crc32("EaEwUUEw",8) == 3895639973) strcat(s, "s");
if (crc32("ONHKRayGcvtcn",13) == 3196073830) strcat(s, "I");
if (crc32("oyObObomSHvfgT",14) == 612307135) strcat(s, "t");
    return s;
}

char *hemocytoblastic_adjectives() {
    char *s = calloc(16);
    if (crc32("jhnNcUemdKF",11) == 3053423454) strcat(s, "m");
if (crc32("tuxMvSQuRBm",11) == 247171985) strcat(s, "h");
if (crc32("UuvMCKUTBZwGIS",14) == 2158164300) strcat(s, "e");
if (crc32("MdmVnO",6) == 3537243752) strcat(s, "m");
if (crc32("RinWTXjhy",9) == 2856220239) strcat(s, "j");
if (crc32("TizmjvW",7) == 3590967081) strcat(s, "o");
if (crc32("eyUuiCiIwTQx",12) == 1608839338) strcat(s, "B");
if (crc32("nnrgf",5) == 3804314418) strcat(s, "c");
if (crc32("CxiczmGliLamrm",14) == 204937533) strcat(s, "y");
if (crc32("ynjWTJCeCzoPBA",14) == 1280660903) strcat(s, "z");
if (crc32("HQgmsJPWqVv",11) == 1057540839) strcat(s, "t");
if (crc32("GaVMmvrAjN",10) == 802663946) strcat(s, "O");
if (crc32("yxORit",6) == 458588634) strcat(s, "o");
if (crc32("qXixUSIU",8) == 1529356901) strcat(s, "b");
if (crc32("iSVDgZGJHp",10) == 3532891519) strcat(s, "l");
if (crc32("DsYVFdszgw",10) == 3323709227) strcat(s, "a");
if (crc32("uQnGUaDVyFQKb",13) == 1181755474) strcat(s, "n");
if (crc32("PTSxEy",6) == 1465002787) strcat(s, "s");
if (crc32("PgwxqSwcwb",10) == 2517393410) strcat(s, "V");
if (crc32("CeDUHV",6) == 2910139297) strcat(s, "t");
if (crc32("qxpwVDQdGmdi",12) == 420380058) strcat(s, "i");
if (crc32("ANOtFxeeHvde",12) == 2557437522) strcat(s, "e");
if (crc32("nsRmz",5) == 2517714517) strcat(s, "c");
    return s;
}

char *celestial_adjectives() {
    char *s = calloc(10);
    if (crc32("YhCVgwHkUTG",11) == 1587044330) strcat(s, "c");
if (crc32("FEDBZTVJ",8) == 1795375655) strcat(s, "S");
if (crc32("eQreVIEEYUKyGA",14) == 670743489) strcat(s, "e");
if (crc32("eBCJhdH",7) == 3537530882) strcat(s, "l");
if (crc32("LIWIJIheEQh",11) == 3494601517) strcat(s, "v");
if (crc32("kMURDFgoja",10) == 1333461578) strcat(s, "e");
if (crc32("QKerKpwZgnC",11) == 3073599908) strcat(s, "s");
if (crc32("kcFlDTxhXxXPzVT",15) == 4163539462) strcat(s, "t");
if (crc32("zKHBcSHPXIMv",12) == 667564671) strcat(s, "i");
if (crc32("OtzvG",5) == 3365119136) strcat(s, "O");
if (crc32("WBJCeVTIwxXPSH",14) == 3107618532) strcat(s, "a");
if (crc32("rGhZxEYxFZdxowp",15) == 2045816019) strcat(s, "l");
    return s;
}

char *equal_adjectives() {
    char *s = calloc(6);
    if (crc32("RywvJ",5) == 739544203) strcat(s, "e");
if (crc32("SSscWhZgD",9) == 1796748738) strcat(s, "q");
if (crc32("WaHyTLbEVyKN",12) == 1999814787) strcat(s, "C");
if (crc32("lhnqunKoXnsd",12) == 3616903074) strcat(s, "u");
if (crc32("bwbuCI",6) == 529416212) strcat(s, "h");
if (crc32("uoIqtSKXySMEWnQ",15) == 180922236) strcat(s, "a");
if (crc32("oJQDizqVTDYA",12) == 3939493969) strcat(s, "W");
if (crc32("JiDwPKGXKiGWtic",15) == 2971446718) strcat(s, "l");
    return s;
}

char *nonpacifistic_adjectives() {
    char *s = calloc(14);
    if (crc32("EDmjxIAzyp",10) == 451642513) strcat(s, "n");
if (crc32("gHEYoIXdvpViOH",14) == 1574855463) strcat(s, "o");
if (crc32("cxFODVdZYOryGj",14) == 1587200337) strcat(s, "o");
if (crc32("KBWpSH",6) == 500484187) strcat(s, "n");
if (crc32("gPtGZmDAbnMVPW",14) == 2288661388) strcat(s, "p");
if (crc32("ZKilfJlJ",8) == 2834364886) strcat(s, "a");
if (crc32("GHfXzzcdzqXZhT",14) == 1922244540) strcat(s, "c");
if (crc32("ybmFHbQuwQvMxD",14) == 3691514165) strcat(s, "A");
if (crc32("dQBuBqSLntpTwI",14) == 3073815340) strcat(s, "i");
if (crc32("AQvFlRreqpXLqaU",15) == 3500238845) strcat(s, "f");
if (crc32("KUWFnnmD",8) == 921419680) strcat(s, "J");
if (crc32("nQLsLEt",7) == 3327718255) strcat(s, "i");
if (crc32("NjLIsriI",8) == 10011299) strcat(s, "F");
if (crc32("fJCddz",6) == 168996770) strcat(s, "s");
if (crc32("qhozumjBnJpLMRp",15) == 1001990143) strcat(s, "d");
if (crc32("iQwVWDLHX",9) == 3330826648) strcat(s, "t");
if (crc32("nenwfIeKgSosztt",15) == 712113310) strcat(s, "w");
if (crc32("CmYNPDAXtwiHYh",14) == 2227301079) strcat(s, "i");
if (crc32("MzNmy",5) == 3779942309) strcat(s, "c");
    return s;
}

char *wellcontrolled_adjectives() {
    char *s = calloc(15);
    if (crc32("GvAhkGVJQ",9) == 2801050554) strcat(s, "w");
if (crc32("CegxUSeKDx",10) == 475405712) strcat(s, "e");
if (crc32("aiitntocU",9) == 942511069) strcat(s, "l");
if (crc32("YHABtMVpAbIwvc",14) == 140428705) strcat(s, "l");
if (crc32("eXroBkCXsVlDKf",14) == 3816314439) strcat(s, "E");
if (crc32("YQAQWtA",7) == 3651814583) strcat(s, "c");
if (crc32("EQQTNPDL",8) == 2008335806) strcat(s, "o");
if (crc32("mzFyJFj",7) == 532743583) strcat(s, "S");
if (crc32("HjVSMuxLwXkYx",13) == 2963908030) strcat(s, "n");
if (crc32("HbdpBgvxtPQc",12) == 2737305826) strcat(s, "t");
if (crc32("eulEaGUZpHYw",12) == 405560042) strcat(s, "r");
if (crc32("LiIFvVtumnAjHW",14) == 4124875257) strcat(s, "o");
if (crc32("LGOct",5) == 387090968) strcat(s, "B");
if (crc32("DqSYeqSPA",9) == 1811611329) strcat(s, "l");
if (crc32("WpoqGpWQxAKUydk",15) == 1886346120) strcat(s, "l");
if (crc32("jgRzKBIXBdQsu",13) == 2146331855) strcat(s, "e");
if (crc32("UyoljerX",8) == 160542992) strcat(s, "W");
if (crc32("fFLuK",5) == 2766738206) strcat(s, "d");
    return s;
}

char *untrailing_adjectives() {
    char *s = calloc(11);
    if (crc32("SjPOhHzG",8) == 3147230260) strcat(s, "z");
if (crc32("WTUKAoPmpUjl",12) == 3608194161) strcat(s, "u");
if (crc32("negnsqCTW",9) == 2730086014) strcat(s, "n");
if (crc32("idYMARwhwQvsC",13) == 3389978162) strcat(s, "A");
if (crc32("FLYCdPJFwfHqEZH",15) == 1649104616) strcat(s, "t");
if (crc32("RmjkNQANya",10) == 2518187288) strcat(s, "r");
if (crc32("QTIFxC",6) == 1001495056) strcat(s, "Z");
if (crc32("McxdJqM",7) == 141689061) strcat(s, "a");
if (crc32("fkdGm",5) == 232208415) strcat(s, "G");
if (crc32("gfBJbInLeYcYe",13) == 2694076358) strcat(s, "i");
if (crc32("GZXkZMQwHU",10) == 3972567900) strcat(s, "o");
if (crc32("jYeVClZm",8) == 3323266640) strcat(s, "l");
if (crc32("SlMca",5) == 3292953988) strcat(s, "i");
if (crc32("aWlLTCFRTfmQ",12) == 2441971375) strcat(s, "n");
if (crc32("mQxQYhDf",8) == 2671451802) strcat(s, "x");
if (crc32("WnWDKHPPbAp",11) == 3940930813) strcat(s, "g");
    return s;
}

char *transTiber_adjectives() {
    char *s = calloc(11);
    if (crc32("ZzSqWzcU",8) == 4246293414) strcat(s, "t");
if (crc32("tfbVJJj",7) == 2358154381) strcat(s, "r");
if (crc32("XemKoCdJE",9) == 3914066102) strcat(s, "a");
if (crc32("FBkdxByyo",9) == 4114326503) strcat(s, "I");
if (crc32("oFMOQcgIfV",10) == 526387312) strcat(s, "n");
if (crc32("qFZDZowmkAbT",12) == 3214985832) strcat(s, "s");
if (crc32("CsErGigSYVCw",12) == 1856282539) strcat(s, "p");
if (crc32("sSZcr",5) == 806899292) strcat(s, "T");
if (crc32("ZmZcXOhhy",9) == 1249107951) strcat(s, "i");
if (crc32("MhXfH",5) == 2611540289) strcat(s, "q");
if (crc32("reGrvY",6) == 2627608270) strcat(s, "b");
if (crc32("iQeEPNUot",9) == 2516379207) strcat(s, "e");
if (crc32("LQXDoZwzvMG",11) == 1904818586) strcat(s, "Z");
if (crc32("sSutEBz",7) == 458739051) strcat(s, "r");
    return s;
}

char *noninductive_adjectives() {
    char *s = calloc(13);
    if (crc32("wqPkaIaCfFyK",12) == 1886983908) strcat(s, "U");
if (crc32("tWXJlybxm",9) == 2132768381) strcat(s, "n");
if (crc32("HGFvUeKL",8) == 1867373814) strcat(s, "o");
if (crc32("eOdXBWiEhGXHnuf",15) == 1764526955) strcat(s, "j");
if (crc32("KOwQaExXmRKrjaT",15) == 2152462613) strcat(s, "n");
if (crc32("qXZlqfDjYjCf",12) == 1362184854) strcat(s, "i");
if (crc32("iQzDNHRks",9) == 3402295768) strcat(s, "n");
if (crc32("fGEYBsrwvJdy",12) == 2196463432) strcat(s, "Y");
if (crc32("dYSamFw",7) == 493920165) strcat(s, "d");
if (crc32("xiCRcMzqTglwlFh",15) == 2204005273) strcat(s, "c");
if (crc32("GQXOm",5) == 2030906020) strcat(s, "u");
if (crc32("eLmqeISuFQi",11) == 3989051614) strcat(s, "r");
if (crc32("wxHjwF",6) == 2321941092) strcat(s, "c");
if (crc32("ystAtWAiH",9) == 2736608525) strcat(s, "t");
if (crc32("wRnvjx",6) == 2944396928) strcat(s, "i");
if (crc32("gTITAiRYAMhG",12) == 860031498) strcat(s, "v");
if (crc32("uzwERuYgIiyujzz",15) == 4151393044) strcat(s, "e");
    return s;
}

char *inbuilt_adjectives() {
    char *s = calloc(8);
    if (crc32("yOlmgtUSxBC",11) == 4033978211) strcat(s, "i");
if (crc32("qTsbwVWdT",9) == 3924899129) strcat(s, "n");
if (crc32("bJXAUereC",9) == 2766039500) strcat(s, "b");
if (crc32("KsjdnAaAqhVG",12) == 734314445) strcat(s, "N");
if (crc32("iwOUHCAAbguaqjG",15) == 4264130780) strcat(s, "u");
if (crc32("CQPtBnf",7) == 3354445101) strcat(s, "T");
if (crc32("YyWxII",6) == 1275230633) strcat(s, "i");
if (crc32("YpWNiEx",7) == 1160638703) strcat(s, "l");
if (crc32("zbpEznaTMaot",12) == 2719526781) strcat(s, "t");
    return s;
}

char *changeless_adjectives() {
    char *s = calloc(11);
    if (crc32("LtciLKflH",9) == 1326662610) strcat(s, "c");
if (crc32("SHupNALxKiMxvD",14) == 223221131) strcat(s, "h");
if (crc32("eYktilRhJyRSJ",13) == 2056748887) strcat(s, "a");
if (crc32("aUaNw",5) == 3906570322) strcat(s, "l");
if (crc32("FWiMHLlDKFJrPwa",15) == 3745282812) strcat(s, "n");
if (crc32("iPFqcCRhEj",10) == 2258511717) strcat(s, "W");
if (crc32("ZmiYIimhPZKsC",13) == 1547479521) strcat(s, "g");
if (crc32("YhbxPrr",7) == 1296136103) strcat(s, "e");
if (crc32("lOYdZkW",7) == 1344685) strcat(s, "u");
if (crc32("fMsIolYlNw",10) == 298945907) strcat(s, "l");
if (crc32("ykCsQIozOJHn",12) == 594501881) strcat(s, "e");
if (crc32("ifRMXkK",7) == 1944744760) strcat(s, "s");
if (crc32("whoPm",5) == 3111245954) strcat(s, "s");
    return s;
}

char *involuntary_adjectives() {
    char *s = calloc(12);
    if (crc32("kuUrZBOsxKqCqgT",15) == 3881466788) strcat(s, "O");
if (crc32("XuYlNNGLgPYzkNW",15) == 934101823) strcat(s, "i");
if (crc32("lYjJYF",6) == 648535793) strcat(s, "n");
if (crc32("nQqJkFbTOYdmli",14) == 3394436721) strcat(s, "v");
if (crc32("XTMsQbQOr",9) == 572643353) strcat(s, "i");
if (crc32("IEFQl",5) == 2897794366) strcat(s, "o");
if (crc32("THCff",5) == 2965099793) strcat(s, "l");
if (crc32("DXRGrmTa",8) == 369189105) strcat(s, "u");
if (crc32("yjhDQ",5) == 2823630129) strcat(s, "l");
if (crc32("cuXBDBRzu",9) == 856996514) strcat(s, "n");
if (crc32("QxJEHzmuJUMfME",14) == 1458726244) strcat(s, "j");
if (crc32("EQkQkRyy",8) == 2995153402) strcat(s, "t");
if (crc32("njHXyLRvggEks",13) == 16263003) strcat(s, "a");
if (crc32("KGvjlhKTjiHLW",13) == 3946141539) strcat(s, "r");
if (crc32("YNKYxmcz",8) == 2070355699) strcat(s, "y");
    return s;
}

char *discommodious_adjectives() {
    char *s = calloc(14);
    if (crc32("LstCCIwiLUHPQq",14) == 3644635586) strcat(s, "M");
if (crc32("zzkpUhMkekcY",12) == 2619853781) strcat(s, "d");
if (crc32("qAJASqDcHV",10) == 3274574213) strcat(s, "i");
if (crc32("kDIJDcktXnS",11) == 2865459155) strcat(s, "g");
if (crc32("TuNOgemxasYXq",13) == 3622678840) strcat(s, "s");
if (crc32("BVPFEPibEBisR",13) == 397903977) strcat(s, "c");
if (crc32("AxEPXCjIdxxdNBW",15) == 3995159078) strcat(s, "R");
if (crc32("xLgBAoWE",8) == 1032958787) strcat(s, "o");
if (crc32("YVaMu",5) == 837426997) strcat(s, "m");
if (crc32("AsyugZNx",8) == 3077839683) strcat(s, "m");
if (crc32("vZGRLq",6) == 204424172) strcat(s, "o");
if (crc32("KdIAC",5) == 616113712) strcat(s, "d");
if (crc32("exkrO",5) == 2257839335) strcat(s, "i");
if (crc32("GjJIOPK",7) == 24934051) strcat(s, "q");
if (crc32("kkaFnkA",7) == 2841134244) strcat(s, "o");
if (crc32("yENuYelUKyEwvPp",15) == 3167851996) strcat(s, "u");
if (crc32("TGJKVaBHKRawp",13) == 200381389) strcat(s, "Q");
if (crc32("pTDZWDYOOyi",11) == 1465438980) strcat(s, "s");
    return s;
}

char *untemptable_adjectives() {
    char *s = calloc(12);
    if (crc32("hhkvRvQjC",9) == 1195953844) strcat(s, "u");
if (crc32("yDCBWEdRPI",10) == 3813899461) strcat(s, "F");
if (crc32("ZgKXwFmaCE",10) == 2371640433) strcat(s, "n");
if (crc32("lyiRaB",6) == 3094595001) strcat(s, "n");
if (crc32("pLWHx",5) == 3787453537) strcat(s, "t");
if (crc32("ABuLcsSao",9) == 311974823) strcat(s, "O");
if (crc32("MWSWBcFBUxSv",12) == 1687798900) strcat(s, "e");
if (crc32("gbuZADpwvs",10) == 581890223) strcat(s, "m");
if (crc32("vINlDNRW",8) == 2767065765) strcat(s, "p");
if (crc32("shpdixLSb",9) == 587948621) strcat(s, "B");
if (crc32("XAzScIeAeHx",11) == 2931270412) strcat(s, "t");
if (crc32("IXsplsPD",8) == 448301470) strcat(s, "E");
if (crc32("gvhhiVc",7) == 646617654) strcat(s, "a");
if (crc32("bJDJmeI",7) == 3284847346) strcat(s, "L");
if (crc32("XnLCFxDXqVQ",11) == 1069417391) strcat(s, "b");
if (crc32("RnyxhZLYAGcxwTy",15) == 2838325318) strcat(s, "x");
if (crc32("AleYGxOnilZlP",13) == 1167373362) strcat(s, "l");
if (crc32("kLwKtTJKukYBPM",14) == 1418629611) strcat(s, "T");
if (crc32("kVXFaoBQeMXzBnT",15) == 1117154409) strcat(s, "e");
    return s;
}

char *wartlike_adjectives() {
    char *s = calloc(9);
    if (crc32("IiAPgnfFjDFDN",13) == 407993395) strcat(s, "E");
if (crc32("wOWEJ",5) == 1012115538) strcat(s, "w");
if (crc32("NBMMwxKmbP",10) == 3851439780) strcat(s, "R");
if (crc32("FJqoeSqPX",9) == 1110640786) strcat(s, "a");
if (crc32("eGueEoKZAQ",10) == 3347088491) strcat(s, "q");
if (crc32("EjAKupRGnP",10) == 3616963412) strcat(s, "r");
if (crc32("lzcXBVNAjrD",11) == 3273201468) strcat(s, "l");
if (crc32("yisPWrtZz",9) == 1289391693) strcat(s, "t");
if (crc32("pUZRQBb",7) == 846065446) strcat(s, "l");
if (crc32("gEmQSGDybeumt",13) == 4109210360) strcat(s, "Z");
if (crc32("nBBmOwURUF",10) == 595415837) strcat(s, "i");
if (crc32("wBqgEfAKGxYW",12) == 1865929396) strcat(s, "l");
if (crc32("TWaXDaE",7) == 4233468352) strcat(s, "k");
if (crc32("vePYa",5) == 2167962656) strcat(s, "e");
    return s;
}

char *ramiform_adjectives() {
    char *s = calloc(9);
    if (crc32("rWwpudNlNggA",12) == 1010577204) strcat(s, "H");
if (crc32("wgawFqQvFQdJSO",14) == 1240553653) strcat(s, "r");
if (crc32("lwsqFQxRDkStSf",14) == 2209806881) strcat(s, "a");
if (crc32("DmMfaMF",7) == 3021066829) strcat(s, "a");
if (crc32("wMoOFDEkp",9) == 3423256788) strcat(s, "U");
if (crc32("CetGPmvjRxqKskx",15) == 4048818968) strcat(s, "m");
if (crc32("msUpqBprJJAJ",12) == 377684586) strcat(s, "L");
if (crc32("ssfgqhavqmNd",12) == 1896496031) strcat(s, "i");
if (crc32("AfjpPNRC",8) == 4003408034) strcat(s, "f");
if (crc32("rNoGOdHu",8) == 410260831) strcat(s, "o");
if (crc32("sLBTCXcqNIq",11) == 2143408745) strcat(s, "N");
if (crc32("NuIXEjZyB",9) == 3861602500) strcat(s, "r");
if (crc32("DlZnTkq",7) == 838493125) strcat(s, "m");
    return s;
}

char *nonpunctual_adjectives() {
    char *s = calloc(12);
    if (crc32("ncgCGdMjWzOtn",13) == 824348373) strcat(s, "C");
if (crc32("TTGLUWSQvR",10) == 1116604987) strcat(s, "n");
if (crc32("MwtwXTqW",8) == 2199107641) strcat(s, "o");
if (crc32("bKJHGgWjOrWWL",13) == 983579617) strcat(s, "O");
if (crc32("alzFc",5) == 947836092) strcat(s, "n");
if (crc32("BefGAgxnKvSfd",13) == 2413371337) strcat(s, "P");
if (crc32("mJEvnmgIVCOMEv",14) == 4034859666) strcat(s, "p");
if (crc32("ucrNWLSoLeWqx",13) == 2697091704) strcat(s, "Z");
if (crc32("hbrNTwoWqKaZoYB",15) == 2879664764) strcat(s, "u");
if (crc32("dePfDdsmUz",10) == 651197771) strcat(s, "n");
if (crc32("KrWiPBxtFc",10) == 3139313627) strcat(s, "c");
if (crc32("fAoYPmqyeodgKn",14) == 2432535428) strcat(s, "X");
if (crc32("GrVvdpsHrXAukDM",15) == 2961208216) strcat(s, "t");
if (crc32("fKtUl",5) == 1067926970) strcat(s, "f");
if (crc32("QeksOZKgQ",9) == 723539529) strcat(s, "u");
if (crc32("qxJBXk",6) == 277893098) strcat(s, "a");
if (crc32("YWZiCE",6) == 774135287) strcat(s, "a");
if (crc32("VbubjMAVgcb",11) == 2340245500) strcat(s, "S");
if (crc32("GvsrQXuSzWBJaD",14) == 307767276) strcat(s, "l");
    return s;
}

char *electroneutral_adjectives() {
    char *s = calloc(15);
    if (crc32("VOZPQeH",7) == 2609220443) strcat(s, "X");
if (crc32("NVItbPWG",8) == 3722756104) strcat(s, "e");
if (crc32("LxDzaxxZFIxgnFv",15) == 4096280833) strcat(s, "l");
if (crc32("uWLWTZRmU",9) == 360467790) strcat(s, "e");
if (crc32("VjkqgkbuzzB",11) == 80746866) strcat(s, "e");
if (crc32("tKzCrzrmQoa",11) == 2936533370) strcat(s, "c");
if (crc32("jaTQGFibpGrZ",12) == 1192765679) strcat(s, "L");
if (crc32("BpAaIjjdSr",10) == 2392696648) strcat(s, "t");
if (crc32("byYwFyqNS",9) == 2412151927) strcat(s, "r");
if (crc32("yqdoSeSBbu",10) == 2391810272) strcat(s, "t");
if (crc32("sRmkUgctapxk",12) == 3388237341) strcat(s, "o");
if (crc32("xTplPenJJ",9) == 92124804) strcat(s, "n");
if (crc32("IDWQcCFAfLhpsrP",15) == 1714976608) strcat(s, "e");
if (crc32("MCRPX",5) == 2720731756) strcat(s, "z");
if (crc32("OFnoViTTRQy",11) == 599453617) strcat(s, "u");
if (crc32("IoCJLk",6) == 3285401426) strcat(s, "B");
if (crc32("QvJOdBCGCIv",11) == 1545178463) strcat(s, "t");
if (crc32("eDBTBApdvZLO",12) == 1673535426) strcat(s, "r");
if (crc32("QtrsBWEQb",9) == 1608482788) strcat(s, "a");
if (crc32("QhhyvOTBmeQgwj",14) == 2375827598) strcat(s, "n");
if (crc32("cwbJPrOoJZpKWSd",15) == 2000182922) strcat(s, "l");
    return s;
}

char *honorific_adjectives() {
    char *s = calloc(10);
    if (crc32("WxtGuPXgNohkI",13) == 993187497) strcat(s, "m");
if (crc32("KolFfGJrBw",10) == 1025084034) strcat(s, "h");
if (crc32("UOynYWJfQMHs",12) == 3937793490) strcat(s, "o");
if (crc32("YjTFfWjSrBy",11) == 566873077) strcat(s, "n");
if (crc32("iWrEmmMVdGeiWEL",15) == 825487279) strcat(s, "o");
if (crc32("dWCmZHwXfljwH",13) == 3193348711) strcat(s, "A");
if (crc32("uzIOBhVoDuPy",12) == 2135942969) strcat(s, "r");
if (crc32("NFFJHBLZXRPTPEo",15) == 1653349508) strcat(s, "f");
if (crc32("lcbmBh",6) == 1080082441) strcat(s, "i");
if (crc32("NDPEB",5) == 1302070102) strcat(s, "R");
if (crc32("FSkbDdQUsZ",10) == 3293056183) strcat(s, "f");
if (crc32("OmANeaRTj",9) == 3232805935) strcat(s, "k");
if (crc32("NuvhseIck",9) == 646418492) strcat(s, "i");
if (crc32("tZYdM",5) == 72472677) strcat(s, "c");
    return s;
}

char *compensatory_adjectives() {
    char *s = calloc(13);
    if (crc32("WRxOO",5) == 4057692571) strcat(s, "A");
if (crc32("YkYDAF",6) == 3286909205) strcat(s, "c");
if (crc32("cwgCSOsEtS",10) == 67565179) strcat(s, "o");
if (crc32("tJhCRHZl",8) == 1298810470) strcat(s, "m");
if (crc32("xzLugDwRUNM",11) == 4006939382) strcat(s, "p");
if (crc32("ZzqqOOEmcWTNDw",14) == 3242592637) strcat(s, "T");
if (crc32("OPnwRRkSzhKj",12) == 1477782362) strcat(s, "e");
if (crc32("MJihGluLxqg",11) == 2910287828) strcat(s, "n");
if (crc32("jJCoyjts",8) == 2612360938) strcat(s, "Y");
if (crc32("NbsKRE",6) == 3961260296) strcat(s, "s");
if (crc32("BthqXRzULZb",11) == 1689556350) strcat(s, "q");
if (crc32("bcikUnqemCv",11) == 2378849468) strcat(s, "a");
if (crc32("AahfApGpxLnWiD",14) == 3639570051) strcat(s, "W");
if (crc32("rfIpMaoWpFb",11) == 905155907) strcat(s, "t");
if (crc32("ZQUwnvzQsBCtEIe",15) == 3421435120) strcat(s, "o");
if (crc32("FZgAQFxXCmhH",12) == 1458620040) strcat(s, "h");
if (crc32("CfOsOxd",7) == 1140064373) strcat(s, "r");
if (crc32("OLgvxYL",7) == 2770082678) strcat(s, "s");
if (crc32("WINFLVz",7) == 793027710) strcat(s, "y");
    return s;
}

char *pretypographical_adjectives() {
    char *s = calloc(17);
    if (crc32("WuEZirGZMPPw",12) == 548187831) strcat(s, "L");
if (crc32("TREkKVx",7) == 3111419360) strcat(s, "p");
if (crc32("CtXjUYaVrlwmr",13) == 1685678560) strcat(s, "r");
if (crc32("jaHmqXS",7) == 100595977) strcat(s, "e");
if (crc32("VcbHqWG",7) == 2787784511) strcat(s, "t");
if (crc32("tSdPSRlurrkSEj",14) == 3644971699) strcat(s, "x");
if (crc32("bpKWZghF",8) == 798717593) strcat(s, "y");
if (crc32("SMeThbjlhs",10) == 3366653026) strcat(s, "y");
if (crc32("FqjdubXcIVVZFLc",15) == 2114237674) strcat(s, "p");
if (crc32("nCmpldnZKaZD",12) == 2913165500) strcat(s, "o");
if (crc32("caaOFSvO",8) == 2546452722) strcat(s, "o");
if (crc32("iqadwaZCKATxeDp",15) == 2927663848) strcat(s, "g");
if (crc32("upclftpZ",8) == 1079088782) strcat(s, "X");
if (crc32("ZyuQZ",5) == 3633492261) strcat(s, "r");
if (crc32("QlcEOTaUV",9) == 1941082722) strcat(s, "a");
if (crc32("MFHNzKE",7) == 1050988647) strcat(s, "p");
if (crc32("FqKthwrgOssueHg",15) == 3075426758) strcat(s, "h");
if (crc32("fJcLz",5) == 2188648699) strcat(s, "i");
if (crc32("gJMgTSn",7) == 2803609139) strcat(s, "T");
if (crc32("UyPeJPbmvWUvD",13) == 426820948) strcat(s, "c");
if (crc32("NbDJxxBW",8) == 12518051) strcat(s, "a");
if (crc32("btHVjJli",8) == 1864621275) strcat(s, "l");
    return s;
}

char *inclinatory_adjectives() {
    char *s = calloc(12);
    if (crc32("iICFyBituEZo",12) == 1340428630) strcat(s, "i");
if (crc32("CROMwuLHxLYQ",12) == 4099193541) strcat(s, "n");
if (crc32("sOWmT",5) == 1491569738) strcat(s, "w");
if (crc32("VTMLrdDC",8) == 4196193718) strcat(s, "c");
if (crc32("iGErgvTGsijox",13) == 18303311) strcat(s, "l");
if (crc32("uSnyQEFyGCncgMr",15) == 3141569515) strcat(s, "h");
if (crc32("nhKux",5) == 1860958017) strcat(s, "i");
if (crc32("nhKnNOKK",8) == 2835986372) strcat(s, "n");
if (crc32("SKDSMXfa",8) == 2885942678) strcat(s, "d");
if (crc32("gEpGzO",6) == 427409372) strcat(s, "a");
if (crc32("OpAkXEJIYySq",12) == 1708724212) strcat(s, "u");
if (crc32("TbsxQpPbXPMto",13) == 43175471) strcat(s, "t");
if (crc32("NmjLJB",6) == 1517133235) strcat(s, "o");
if (crc32("KmPKkCRnkgBKdn",14) == 2911741413) strcat(s, "S");
if (crc32("uFgUBrKRznUNXn",14) == 2711562049) strcat(s, "r");
if (crc32("acXJeFDzKxoc",12) == 850364042) strcat(s, "i");
if (crc32("dyOSxKJCZ",9) == 3297831292) strcat(s, "y");
    return s;
}

char *unexisting_adjectives() {
    char *s = calloc(11);
    if (crc32("bybXL",5) == 1975318927) strcat(s, "u");
if (crc32("jiXXkpu",7) == 3533901147) strcat(s, "Q");
if (crc32("dAsLGnwtdEomv",13) == 2778109760) strcat(s, "n");
if (crc32("qRzRvVrjJ",9) == 3642147734) strcat(s, "e");
if (crc32("FrsXPU",6) == 851558114) strcat(s, "c");
if (crc32("VwMfSUUezwcAfz",14) == 1258370982) strcat(s, "x");
if (crc32("LdvpjYyjK",9) == 953880561) strcat(s, "L");
if (crc32("vagWDClEvanL",12) == 2964600347) strcat(s, "i");
if (crc32("ZJdlksocKnET",12) == 1665151521) strcat(s, "s");
if (crc32("npFGdUV",7) == 1535844061) strcat(s, "u");
if (crc32("OpAkmxctfxUqtHV",15) == 1812542531) strcat(s, "t");
if (crc32("bmEOlmG",7) == 3652162766) strcat(s, "T");
if (crc32("DNDBte",6) == 3542855696) strcat(s, "i");
if (crc32("jHKED",5) == 2816290800) strcat(s, "z");
if (crc32("OLzZzgAZE",9) == 1580497868) strcat(s, "n");
if (crc32("sSDQFiMTQ",9) == 571238964) strcat(s, "N");
if (crc32("appezGRBWErAr",13) == 2807947666) strcat(s, "g");
    return s;
}

char *quasiangelic_adjectives() {
    char *s = calloc(13);
    if (crc32("vfZUjZz",7) == 555106395) strcat(s, "l");
if (crc32("DNtVytLzgOK",11) == 416726498) strcat(s, "q");
if (crc32("IvwHUGS",7) == 2751166674) strcat(s, "u");
if (crc32("DNofXsoV",8) == 4091579798) strcat(s, "n");
if (crc32("YcTTl",5) == 735326469) strcat(s, "a");
if (crc32("eojAFun",7) == 3242156441) strcat(s, "s");
if (crc32("zpZeoUHjBP",10) == 2134213818) strcat(s, "K");
if (crc32("hxPnlp",6) == 2362325893) strcat(s, "i");
if (crc32("iodCs",5) == 2792051216) strcat(s, "T");
if (crc32("mQfMiLYgsVQcqV",14) == 1123439778) strcat(s, "a");
if (crc32("MtJQHxbmXMlSQ",13) == 42665152) strcat(s, "Z");
if (crc32("jVrSVlaTrORtp",13) == 338337539) strcat(s, "n");
if (crc32("udHOiHfbMHfuAa",14) == 68314497) strcat(s, "g");
if (crc32("EqlkxCTkduEWdJ",14) == 1352249902) strcat(s, "K");
if (crc32("kigwThbcduTMCzR",15) == 3472117732) strcat(s, "e");
if (crc32("MpmSnZgwWWCC",12) == 1402131582) strcat(s, "l");
if (crc32("mPwTVyYncF",10) == 3489194106) strcat(s, "i");
if (crc32("ijRxHWOw",8) == 2908844650) strcat(s, "U");
if (crc32("lotIIPNegKCs",12) == 2714969901) strcat(s, "c");
    return s;
}

char *quasidifficult_adjectives() {
    char *s = calloc(15);
    if (crc32("XmwiijGlrUEqYD",14) == 698628834) strcat(s, "q");
if (crc32("vZOJNqeyUZo",11) == 248631049) strcat(s, "u");
if (crc32("PcpEYUYb",8) == 1240242825) strcat(s, "r");
if (crc32("EPUFf",5) == 4122603315) strcat(s, "a");
if (crc32("KZSnU",5) == 3274965560) strcat(s, "s");
if (crc32("kzBzYoVwY",9) == 809292532) strcat(s, "i");
if (crc32("zNwkUFuyFjX",11) == 4016478760) strcat(s, "d");
if (crc32("vjtIq",5) == 3740312514) strcat(s, "Q");
if (crc32("HzjhtsxQPNPWpgr",15) == 3379628393) strcat(s, "i");
if (crc32("LfNcm",5) == 1286808163) strcat(s, "l");
if (crc32("KFOBTeiVG",9) == 668687517) strcat(s, "f");
if (crc32("TcHHbNNzOYM",11) == 3572128179) strcat(s, "f");
if (crc32("qiFrerRO",8) == 1954989399) strcat(s, "i");
if (crc32("rTKYRdjDarXT",12) == 1694850249) strcat(s, "c");
if (crc32("pBdTm",5) == 2900844845) strcat(s, "u");
if (crc32("jcYwJifYmntl",12) == 1758101306) strcat(s, "l");
if (crc32("wJdvBC",6) == 2080675113) strcat(s, "t");
    return s;
}

char *compassable_adjectives() {
    char *s = calloc(12);
    if (crc32("MawXFy",6) == 4096943387) strcat(s, "S");
if (crc32("ZKMBmpZNWbPotn",14) == 3253047990) strcat(s, "c");
if (crc32("vZciOHKbivgy",12) == 4104143385) strcat(s, "o");
if (crc32("AtHYtO",6) == 390677915) strcat(s, "b");
if (crc32("VUDeSdsUdGLt",12) == 872400622) strcat(s, "m");
if (crc32("qBZQDlyTMrGG",12) == 1524560765) strcat(s, "y");
if (crc32("lxmAezatjnc",11) == 3312568337) strcat(s, "p");
if (crc32("tcNPPzKwQDT",11) == 2567989691) strcat(s, "a");
if (crc32("PDUGuflBBUG",11) == 3468507490) strcat(s, "s");
if (crc32("LgxpqACBoeVr",12) == 1044020898) strcat(s, "s");
if (crc32("qRfOCtnGvwseO",13) == 1098060322) strcat(s, "s");
if (crc32("wnCFrMjeBsHZ",12) == 4015820880) strcat(s, "d");
if (crc32("HIMkDAIvLcgWR",13) == 2463999759) strcat(s, "a");
if (crc32("DjNnF",5) == 554638517) strcat(s, "b");
if (crc32("SUFIa",5) == 2515040835) strcat(s, "L");
if (crc32("OByDNLXgmplByG",14) == 3978389986) strcat(s, "l");
if (crc32("nHvSJxXokeVm",12) == 2399016759) strcat(s, "x");
if (crc32("ypWrXf",6) == 3005318513) strcat(s, "e");
    return s;
}

char *uncounseled_adjectives() {
    char *s = calloc(12);
    if (crc32("LkEickjkiWpiG",13) == 2491064279) strcat(s, "u");
if (crc32("vEJiqhL",7) == 2656155554) strcat(s, "n");
if (crc32("qEaDgayhMorWiR",14) == 2436958379) strcat(s, "c");
if (crc32("IJkmFHiqf",9) == 1298061826) strcat(s, "o");
if (crc32("hOBaGsE",7) == 233044581) strcat(s, "u");
if (crc32("vEsEziKmuCnDq",13) == 1571594011) strcat(s, "t");
if (crc32("RMSuLrssgD",10) == 2616658384) strcat(s, "n");
if (crc32("xomffR",6) == 3731658141) strcat(s, "w");
if (crc32("myEaol",6) == 3000265882) strcat(s, "s");
if (crc32("vjEgRvvLAOOD",12) == 2704304812) strcat(s, "H");
if (crc32("RGnSH",5) == 703212077) strcat(s, "e");
if (crc32("sUPWTnV",7) == 1621442776) strcat(s, "l");
if (crc32("avDPbnmWaGiXR",13) == 2523769595) strcat(s, "e");
if (crc32("CgtCO",5) == 1534806074) strcat(s, "U");
if (crc32("XxOKoVkgjk",10) == 515846011) strcat(s, "d");
    return s;
}

char *hastiest_adjectives() {
    char *s = calloc(9);
    if (crc32("bKjfV",5) == 2636806682) strcat(s, "h");
if (crc32("kKRIZwTlYwV",11) == 666964342) strcat(s, "i");
if (crc32("IJYAccJVKg",10) == 1857921954) strcat(s, "a");
if (crc32("ZgcNePGJTO",10) == 2392610665) strcat(s, "Q");
if (crc32("EZGHwc",6) == 1350274617) strcat(s, "s");
if (crc32("quuUqYlAz",9) == 2493608907) strcat(s, "x");
if (crc32("fxnAZfC",7) == 713598996) strcat(s, "t");
if (crc32("JgtniMfGpxGifyN",15) == 3770868987) strcat(s, "i");
if (crc32("CiPAMfRs",8) == 1450079474) strcat(s, "g");
if (crc32("JybpzcYpTGv",11) == 2119570039) strcat(s, "e");
if (crc32("GdbvowQhzIH",11) == 3299917877) strcat(s, "s");
if (crc32("JCgRvQeMNKUuSfa",15) == 1447002739) strcat(s, "b");
if (crc32("bZHEvXAirKMXKE",14) == 2689258472) strcat(s, "t");
    return s;
}

char *ruthful_adjectives() {
    char *s = calloc(8);
    if (crc32("ATQZB",5) == 702808258) strcat(s, "S");
if (crc32("zYdatUYNggQwWZ",14) == 643827145) strcat(s, "r");
if (crc32("UBhPtpYu",8) == 1799145591) strcat(s, "l");
if (crc32("AzCOPDutLlwDqe",14) == 3888738886) strcat(s, "u");
if (crc32("uwbSkVf",7) == 65242004) strcat(s, "t");
if (crc32("GfLwzpHcz",9) == 817947175) strcat(s, "Y");
if (crc32("HXTno",5) == 3990781780) strcat(s, "h");
if (crc32("DCzbkl",6) == 3078884329) strcat(s, "f");
if (crc32("oFfDc",5) == 1875582225) strcat(s, "u");
if (crc32("TtblDeAW",8) == 2401501621) strcat(s, "q");
if (crc32("EOIBGt",6) == 1235670810) strcat(s, "l");
    return s;
}

char *pitiful_adjectives() {
    char *s = calloc(8);
    if (crc32("IHyqt",5) == 4144829370) strcat(s, "p");
if (crc32("rEolC",5) == 4190656643) strcat(s, "G");
if (crc32("LkyCXYeDceaDcdn",15) == 1857167690) strcat(s, "i");
if (crc32("hqNmEik",7) == 3553291643) strcat(s, "t");
if (crc32("oZyJZmscpDNo",12) == 4045404324) strcat(s, "D");
if (crc32("sYyqQPTv",8) == 1637055014) strcat(s, "i");
if (crc32("ogMfyGXvLeSwJ",13) == 1662473123) strcat(s, "I");
if (crc32("FcqUe",5) == 2535799992) strcat(s, "f");
if (crc32("jLnFCA",6) == 4040107093) strcat(s, "u");
if (crc32("LJsSfbOJBfFvn",13) == 4257581859) strcat(s, "l");
    return s;
}

char *nobleminded_adjectives() {
    char *s = calloc(12);
    if (crc32("mTTMOpqSc",9) == 1603733601) strcat(s, "n");
if (crc32("aLuycryLUTnxg",13) == 608543433) strcat(s, "o");
if (crc32("DMCVbDtBV",9) == 158218530) strcat(s, "C");
if (crc32("NuZNHqrYFbPfk",13) == 2025193410) strcat(s, "b");
if (crc32("njBjLpuMOMshx",13) == 4262799103) strcat(s, "l");
if (crc32("MOiIAfWBoZpW",12) == 702381798) strcat(s, "e");
if (crc32("lDgnNjzKwiwjiWm",15) == 4056774892) strcat(s, "m");
if (crc32("Zszekj",6) == 3277153076) strcat(s, "i");
if (crc32("yxnvDrzB",8) == 3244612024) strcat(s, "y");
if (crc32("ZYSMGPcbNceqCM",14) == 3521801291) strcat(s, "n");
if (crc32("lOLbMpjpdtXMEBQ",15) == 1954730660) strcat(s, "g");
if (crc32("JsXQdso",7) == 498226155) strcat(s, "d");
if (crc32("sfksjIj",7) == 3233120861) strcat(s, "e");
if (crc32("IiUnKKrbIpcgt",13) == 2838298354) strcat(s, "w");
if (crc32("WjHbAcP",7) == 2134803996) strcat(s, "d");
    return s;
}

char *hematuric_adjectives() {
    char *s = calloc(10);
    if (crc32("wtWYrtwit",9) == 2154705753) strcat(s, "c");
if (crc32("SOOCvPomRsst",12) == 1208824246) strcat(s, "h");
if (crc32("nGwFrHIilwSxKpU",15) == 4014705542) strcat(s, "Z");
if (crc32("sKgFhvRiCVjPq",13) == 2617871394) strcat(s, "e");
if (crc32("VPDHRygjjvr",11) == 299943503) strcat(s, "U");
if (crc32("HSiKuqmGuEpVfCI",15) == 933864065) strcat(s, "m");
if (crc32("lhsYSGmtGnR",11) == 2833468519) strcat(s, "o");
if (crc32("WJYndc",6) == 2473386311) strcat(s, "a");
if (crc32("xobaXSQsexfsO",13) == 3144986275) strcat(s, "U");
if (crc32("PhteGjDh",8) == 3720598750) strcat(s, "t");
if (crc32("VrHMiAbzIfKioow",15) == 631980696) strcat(s, "u");
if (crc32("aFCezDLwpt",10) == 4049231444) strcat(s, "r");
if (crc32("CTTGwQdGaN",10) == 3594413062) strcat(s, "i");
if (crc32("USkJPh",6) == 4207559126) strcat(s, "c");
    return s;
}

char *delicate_adjectives() {
    char *s = calloc(9);
    if (crc32("bhaLfiVxdxPzh",13) == 636612119) strcat(s, "T");
if (crc32("hHdWYNNanQ",10) == 4021150416) strcat(s, "d");
if (crc32("oyQfBYrQqDb",11) == 3145133916) strcat(s, "e");
if (crc32("ZVJRn",5) == 3415741566) strcat(s, "E");
if (crc32("kDHCSs",6) == 174378473) strcat(s, "l");
if (crc32("XRsJSgG",7) == 2248967913) strcat(s, "T");
if (crc32("SSsLLWe",7) == 3680043383) strcat(s, "i");
if (crc32("VMqLJMZtirYKG",13) == 2424569679) strcat(s, "c");
if (crc32("fraeROTkTe",10) == 1559159714) strcat(s, "a");
if (crc32("LiRQa",5) == 2081317155) strcat(s, "x");
if (crc32("RwYqn",5) == 2371543620) strcat(s, "t");
if (crc32("BpUjLqTNG",9) == 3251111670) strcat(s, "e");
    return s;
}

char *learned_adjectives() {
    char *s = calloc(8);
    if (crc32("VRObR",5) == 3105749343) strcat(s, "l");
if (crc32("vTvVXhUZCJaNUV",14) == 2519972028) strcat(s, "u");
if (crc32("puyioCVtd",9) == 1601167131) strcat(s, "e");
if (crc32("dRPDFcFuQ",9) == 2206890455) strcat(s, "a");
if (crc32("sThyLu",6) == 687259214) strcat(s, "r");
if (crc32("nZjCMGmDOlIsKQ",14) == 611548029) strcat(s, "N");
if (crc32("gbvkZOJOAi",10) == 1686073152) strcat(s, "n");
if (crc32("EeyFOyWs",8) == 3831038676) strcat(s, "m");
if (crc32("gZRiziOZpTuJXRK",15) == 1720655684) strcat(s, "e");
if (crc32("SUctEBYxegtXt",13) == 2170523093) strcat(s, "a");
if (crc32("Dakegc",6) == 3714384751) strcat(s, "d");
    return s;
}

char *blueblooded_adjectives() {
    char *s = calloc(12);
    if (crc32("qeIrRM",6) == 300363400) strcat(s, "b");
if (crc32("MkfvE",5) == 3119499034) strcat(s, "l");
if (crc32("ipLFLFi",7) == 168331048) strcat(s, "t");
if (crc32("zZdhFg",6) == 4004363994) strcat(s, "u");
if (crc32("ckdahF",6) == 1853808513) strcat(s, "u");
if (crc32("cDVPxa",6) == 3445161504) strcat(s, "e");
if (crc32("EXuNNXI",7) == 639484201) strcat(s, "b");
if (crc32("UiqUdHey",8) == 2916704116) strcat(s, "l");
if (crc32("HWBxOE",6) == 3260184050) strcat(s, "o");
if (crc32("kyRNje",6) == 2667163037) strcat(s, "o");
if (crc32("AwXSG",5) == 1322826605) strcat(s, "d");
if (crc32("zIEySUlcTx",10) == 3083577596) strcat(s, "e");
if (crc32("WBvKVzanre",10) == 3970075705) strcat(s, "e");
if (crc32("UdCWS",5) == 2084547636) strcat(s, "b");
if (crc32("xSahGuMk",8) == 2836268466) strcat(s, "d");
    return s;
}

char *preconcurrent_adjectives() {
    char *s = calloc(14);
    if (crc32("GzCxrcgIo",9) == 2523236273) strcat(s, "Y");
if (crc32("qCVcHXNjqVwfbaV",15) == 1123469617) strcat(s, "p");
if (crc32("GFefppoWHbq",11) == 3560117926) strcat(s, "v");
if (crc32("MvqjmaulTfLRRl",14) == 79968931) strcat(s, "r");
if (crc32("iJNATmwxDjeN",12) == 2748618990) strcat(s, "E");
if (crc32("BVyxMDhmMSwYL",13) == 3546131218) strcat(s, "e");
if (crc32("qssmwpyy",8) == 2181565909) strcat(s, "m");
if (crc32("wpHRPNsSNyri",12) == 3195493260) strcat(s, "c");
if (crc32("JCBHg",5) == 3316131966) strcat(s, "o");
if (crc32("SbkDAcxVSS",10) == 1500723969) strcat(s, "n");
if (crc32("cECogipUgJlqm",13) == 2803333729) strcat(s, "n");
if (crc32("vLdsNgJaRKihRk",14) == 3107646808) strcat(s, "c");
if (crc32("PetCiTGsFFlQD",13) == 3518438386) strcat(s, "a");
if (crc32("CdVWNqWtBCB",11) == 674642351) strcat(s, "u");
if (crc32("IfxLRumICswD",12) == 1517550996) strcat(s, "N");
if (crc32("vMGWCrBOo",9) == 1083717206) strcat(s, "r");
if (crc32("paARNW",6) == 3386347973) strcat(s, "r");
if (crc32("VKtrjfKgQ",9) == 1252758283) strcat(s, "e");
if (crc32("QiNqB",5) == 1368219950) strcat(s, "n");
if (crc32("fncvOXuDYQvLaz",14) == 3245351455) strcat(s, "c");
if (crc32("wGHhhVUMOgYnOd",14) == 2777913292) strcat(s, "t");
    return s;
}

char *nonindividual_adjectives() {
    char *s = calloc(14);
    if (crc32("mzPNdtNUxNql",12) == 1365885824) strcat(s, "n");
if (crc32("hqYvm",5) == 1879514980) strcat(s, "O");
if (crc32("OopBVqs",7) == 2304453931) strcat(s, "o");
if (crc32("bJRShIlFES",10) == 1603385016) strcat(s, "w");
if (crc32("EXrDDQbctju",11) == 1152111955) strcat(s, "n");
if (crc32("pGcrSmovYUm",11) == 110855667) strcat(s, "i");
if (crc32("fuIeDNfivHv",11) == 760003900) strcat(s, "n");
if (crc32("CmPuYnuTmoQLk",13) == 184163783) strcat(s, "d");
if (crc32("QcMFLWg",7) == 3589239042) strcat(s, "k");
if (crc32("goFMEbJr",8) == 3902029712) strcat(s, "i");
if (crc32("BIPrYDMARgc",11) == 2393969764) strcat(s, "W");
if (crc32("oyaLqdTcm",9) == 3842463712) strcat(s, "v");
if (crc32("LmSequezxcu",11) == 820321663) strcat(s, "i");
if (crc32("zCSxKiS",7) == 3071452976) strcat(s, "d");
if (crc32("mozvJbK",7) == 3996403152) strcat(s, "o");
if (crc32("EQLfwOMZMzMvVWm",15) == 3908747411) strcat(s, "u");
if (crc32("mvppy",5) == 677902448) strcat(s, "f");
if (crc32("bhGLS",5) == 3774430) strcat(s, "a");
if (crc32("vqLTV",5) == 2730360154) strcat(s, "z");
if (crc32("BGdAGhQ",7) == 3609359527) strcat(s, "l");
    return s;
}

char *quasizealous_adjectives() {
    char *s = calloc(13);
    if (crc32("oWyIdkgUC",9) == 4087329698) strcat(s, "a");
if (crc32("aeuQMctAklhrRJS",15) == 1109835991) strcat(s, "q");
if (crc32("jhESaKi",7) == 315256664) strcat(s, "G");
if (crc32("wcFQLsqwTWfktqg",15) == 179021278) strcat(s, "u");
if (crc32("oWcTFlUfLE",10) == 3639596179) strcat(s, "G");
if (crc32("WqETfvzTdQucit",14) == 1120122466) strcat(s, "a");
if (crc32("TPUlyCqI",8) == 1633192942) strcat(s, "H");
if (crc32("JbHaigkxfmHz",12) == 2472170587) strcat(s, "s");
if (crc32("cyRjGZhNTGpYmb",14) == 1594753949) strcat(s, "Q");
if (crc32("nMsKEDTUZnL",11) == 3913139618) strcat(s, "i");
if (crc32("yciUVbuyP",9) == 1204840985) strcat(s, "z");
if (crc32("gRPidfTpfVbegV",14) == 2459415640) strcat(s, "e");
if (crc32("JbejVWITnqftk",13) == 2605115478) strcat(s, "a");
if (crc32("MhMncikOqCpO",12) == 1247899714) strcat(s, "p");
if (crc32("sXzfbGlXIODPwbW",15) == 1639437999) strcat(s, "l");
if (crc32("txatUArjU",9) == 3683032012) strcat(s, "U");
if (crc32("ZvUxwQKMHz",10) == 2738348228) strcat(s, "o");
if (crc32("fFAOZGxp",8) == 653098286) strcat(s, "Z");
if (crc32("jWlWmPQkgHVE",12) == 1190780732) strcat(s, "u");
if (crc32("UVcLvEZE",8) == 2288102261) strcat(s, "l");
if (crc32("tTzPLqRkE",9) == 2142991301) strcat(s, "s");
    return s;
}

char *unsubmerging_adjectives() {
    char *s = calloc(13);
    if (crc32("AWLBdFwC",8) == 1932944672) strcat(s, "u");
if (crc32("LYldzfxTgmipYG",14) == 2060264102) strcat(s, "n");
if (crc32("erAQqqRpLl",10) == 4213713092) strcat(s, "X");
if (crc32("ZnabkH",6) == 202553336) strcat(s, "s");
if (crc32("hpAvlZfQx",9) == 3850330301) strcat(s, "q");
if (crc32("XWzKEJ",6) == 3093694965) strcat(s, "u");
if (crc32("oyoIYbqX",8) == 1529792754) strcat(s, "P");
if (crc32("yvLGTRrAiXxbUj",14) == 221293462) strcat(s, "b");
if (crc32("cSVwkdOs",8) == 3913969079) strcat(s, "M");
if (crc32("ZpnpSIwGFWBH",12) == 4147935161) strcat(s, "m");
if (crc32("GprMwuV",7) == 3942434223) strcat(s, "t");
if (crc32("kDwRFfgiWbYT",12) == 2416201947) strcat(s, "e");
if (crc32("TdDYWrQnzBStd",13) == 3121623730) strcat(s, "H");
if (crc32("eFHxCqwdI",9) == 476406719) strcat(s, "r");
if (crc32("YmGysIBEDaczN",13) == 2441645031) strcat(s, "g");
if (crc32("ibyej",5) == 769825234) strcat(s, "i");
if (crc32("UwlKUS",6) == 3969592825) strcat(s, "r");
if (crc32("fNtfoqcuEOMv",12) == 1063525586) strcat(s, "n");
if (crc32("gVHNeCCJYVmjXKf",15) == 3704193160) strcat(s, "Q");
if (crc32("VDsPXKyg",8) == 2899818446) strcat(s, "g");
    return s;
}

char *unsurcharged_adjectives() {
    char *s = calloc(13);
    if (crc32("oCHontrcpVcpG",13) == 2511862871) strcat(s, "s");
if (crc32("MjTlMZ",6) == 441316590) strcat(s, "u");
if (crc32("ijyYCyEyyoiQWo",14) == 2019854991) strcat(s, "n");
if (crc32("kYnORKTlgRKMtzS",15) == 2811524325) strcat(s, "s");
if (crc32("IbIjqDQ",7) == 3589375454) strcat(s, "u");
if (crc32("ZKceCMPNScM",11) == 3719991092) strcat(s, "q");
if (crc32("mybdUbz",7) == 2180683639) strcat(s, "r");
if (crc32("ocvtSSgeeYhe",12) == 3437429903) strcat(s, "c");
if (crc32("NHcVQquoWoBBed",14) == 1093632671) strcat(s, "h");
if (crc32("GCuIGBY",7) == 3876572113) strcat(s, "a");
if (crc32("ZWEIUb",6) == 555036364) strcat(s, "r");
if (crc32("MmaVKgHTxmCv",12) == 3925649897) strcat(s, "g");
if (crc32("FgbHLYgLUBmNlBq",15) == 3707082003) strcat(s, "e");
if (crc32("AqQegYSFQ",9) == 23055182) strcat(s, "X");
if (crc32("OHapl",5) == 1611644357) strcat(s, "d");
    return s;
}

char *overrestraint_adjectives() {
    char *s = calloc(14);
    if (crc32("cizyRfoGj",9) == 3167150045) strcat(s, "k");
if (crc32("IoIdNaRzvwKfiaH",15) == 2422627093) strcat(s, "o");
if (crc32("YciGksjj",8) == 3320097282) strcat(s, "p");
if (crc32("YTahOYBwesE",11) == 2436629460) strcat(s, "v");
if (crc32("MtluUrJqAApSM",13) == 3853726771) strcat(s, "e");
if (crc32("jceShJopsStXWCQ",15) == 3990412188) strcat(s, "r");
if (crc32("FXIXb",5) == 3254881565) strcat(s, "v");
if (crc32("fPOaftcmkGnIhK",14) == 3662197707) strcat(s, "r");
if (crc32("DWZPDhuAJDbYWpK",15) == 2023358020) strcat(s, "s");
if (crc32("EVRgBqHxhjy",11) == 3690316798) strcat(s, "e");
if (crc32("HwSrPjmOMtO",11) == 1261370501) strcat(s, "s");
if (crc32("iASKzjlXo",9) == 2726565775) strcat(s, "f");
if (crc32("GtlLYAEalwX",11) == 2330987313) strcat(s, "t");
if (crc32("TdmizHgiX",9) == 693732627) strcat(s, "r");
if (crc32("GoXmx",5) == 2744518653) strcat(s, "a");
if (crc32("AARpItCJPvx",11) == 4144421019) strcat(s, "O");
if (crc32("LAdHGD",6) == 2828007978) strcat(s, "i");
if (crc32("oGpQcQJejyh",11) == 2734345440) strcat(s, "K");
if (crc32("qWHCzelGrSmefQ",14) == 3411155203) strcat(s, "n");
if (crc32("irboQmyF",8) == 4220497466) strcat(s, "l");
if (crc32("btixb",5) == 3268536286) strcat(s, "t");
    return s;
}

char *unshouted_adjectives() {
    char *s = calloc(10);
    if (crc32("ctCPQ",5) == 1946452332) strcat(s, "v");
if (crc32("OMYoXsBaYRcnx",13) == 1476748577) strcat(s, "u");
if (crc32("CwSjbsmEemhktb",14) == 4177475878) strcat(s, "n");
if (crc32("UDyBHZSLQ",9) == 2853367763) strcat(s, "s");
if (crc32("NOuxcvYpXyBcFo",14) == 2448388747) strcat(s, "A");
if (crc32("ogUwJrYIbroFBFu",15) == 1224103081) strcat(s, "h");
if (crc32("NCPPThfIFWWqzW",14) == 654729510) strcat(s, "s");
if (crc32("ofRvLFSzYGAh",12) == 2925583570) strcat(s, "o");
if (crc32("ZVLNmuQNTKpsFZA",15) == 3392318275) strcat(s, "u");
if (crc32("HLEprtWixWXIJsR",15) == 1635192631) strcat(s, "t");
if (crc32("GOsKtXroOXApfp",14) == 1381087953) strcat(s, "v");
if (crc32("GxAaVKf",7) == 3268803099) strcat(s, "e");
if (crc32("vhFfpPDPrcYYqq",14) == 2801195647) strcat(s, "d");
    return s;
}

char *unindurate_adjectives() {
    char *s = calloc(11);
    if (crc32("FyztvdXG",8) == 3472462771) strcat(s, "O");
if (crc32("sjstiGENUTzvYyU",15) == 3704788886) strcat(s, "u");
if (crc32("WNifkqcHe",9) == 2116463033) strcat(s, "n");
if (crc32("xlUZFKML",8) == 2154587328) strcat(s, "i");
if (crc32("cLYuYVFDK",9) == 2472675909) strcat(s, "n");
if (crc32("yoYhxEGKwyNXT",13) == 1585465628) strcat(s, "n");
if (crc32("SquWTnIXUmRXJT",14) == 1030725857) strcat(s, "Z");
if (crc32("sDDqkkqjeYtkV",13) == 1155282063) strcat(s, "d");
if (crc32("DHZVzwfLeAzBYwW",15) == 899485077) strcat(s, "u");
if (crc32("vWDcc",5) == 1784794175) strcat(s, "D");
if (crc32("UirWwEGveRG",11) == 853414641) strcat(s, "r");
if (crc32("FgNPFgmyjYJc",12) == 3243342017) strcat(s, "Z");
if (crc32("UAwtXKWTd",9) == 990522756) strcat(s, "a");
if (crc32("rYKOcYFV",8) == 3514186614) strcat(s, "v");
if (crc32("EWODy",5) == 3336674907) strcat(s, "t");
if (crc32("YuIdDxzOznVNSp",14) == 634925206) strcat(s, "U");
if (crc32("LYCzeYUkzkZtzL",14) == 192498471) strcat(s, "e");
    return s;
}

char *pseudoassociational_adjectives() {
    char *s = calloc(20);
    if (crc32("dTAYJx",6) == 4223267074) strcat(s, "p");
if (crc32("vADipupOrwjDqt",14) == 2565903624) strcat(s, "o");
if (crc32("xWmAFkBjXsy",11) == 1083245786) strcat(s, "s");
if (crc32("DgejxoEFjUB",11) == 89281850) strcat(s, "Q");
if (crc32("bdjKJWBqIgHms",13) == 232757743) strcat(s, "e");
if (crc32("gKWlQaTwB",9) == 308196920) strcat(s, "P");
if (crc32("OjMzPdDF",8) == 897908645) strcat(s, "u");
if (crc32("pJPdFTBRfM",10) == 1699560423) strcat(s, "S");
if (crc32("ZSggFCKoTP",10) == 3995896288) strcat(s, "d");
if (crc32("WoCLWOCLRGkm",12) == 3747509614) strcat(s, "I");
if (crc32("mLCxr",5) == 1567847187) strcat(s, "o");
if (crc32("UhRBqU",6) == 2080143136) strcat(s, "a");
if (crc32("OOzMpDz",7) == 2064212138) strcat(s, "s");
if (crc32("DbvQD",5) == 3286846649) strcat(s, "W");
if (crc32("zRQTandJgY",10) == 79381386) strcat(s, "s");
if (crc32("tLQtl",5) == 272495247) strcat(s, "q");
if (crc32("FDMnEEnUPiiiHCw",15) == 3211819565) strcat(s, "o");
if (crc32("CKdodUEKWsvSaw",14) == 2755104469) strcat(s, "c");
if (crc32("SCAMvCAiRlwrjWK",15) == 3462616955) strcat(s, "i");
if (crc32("GLyfxhddfdQ",11) == 3629203752) strcat(s, "s");
if (crc32("UPyxaSkFR",9) == 256244526) strcat(s, "a");
if (crc32("sgUMdgpWNQPJhd",14) == 1187482200) strcat(s, "t");
if (crc32("FVvOfukakVlETr",14) == 330442305) strcat(s, "i");
if (crc32("zQhYokucaK",10) == 1314071426) strcat(s, "i");
if (crc32("kSkgAmHzxVIjMT",14) == 850053490) strcat(s, "o");
if (crc32("wDkiKtot",8) == 788668882) strcat(s, "n");
if (crc32("yGtDadjMTHNcmy",14) == 2024848023) strcat(s, "a");
if (crc32("iHAWWTmqzgi",11) == 3749811033) strcat(s, "l");
    return s;
}

char *antiparasitic_adjectives() {
    char *s = calloc(14);
    if (crc32("LzbQpLMcxHU",11) == 895520594) strcat(s, "T");
if (crc32("wnPfJAG",7) == 3704920708) strcat(s, "a");
if (crc32("MvbewIqdtSR",11) == 1375204815) strcat(s, "n");
if (crc32("EyzYgbTBOqrP",12) == 4209851823) strcat(s, "t");
if (crc32("lVtUDcnWMmkJ",12) == 747706662) strcat(s, "f");
if (crc32("ZsuClzVlwq",10) == 826444313) strcat(s, "i");
if (crc32("qikTtVWvIJF",11) == 2591487756) strcat(s, "p");
if (crc32("RIHZCdt",7) == 1795189037) strcat(s, "k");
if (crc32("EkfJsN",6) == 4135819851) strcat(s, "a");
if (crc32("FYNGYZBIZnWhBq",14) == 36473997) strcat(s, "o");
if (crc32("PfBpIRpNtLhuQGY",15) == 1567736403) strcat(s, "r");
if (crc32("QYyeePcZkxc",11) == 2336271336) strcat(s, "a");
if (crc32("NLbIRFiUqhhF",12) == 3485079815) strcat(s, "k");
if (crc32("dsxAMJ",6) == 2430107826) strcat(s, "s");
if (crc32("APQyMyM",7) == 3993518376) strcat(s, "i");
if (crc32("zxGZwFawTCAudGa",15) == 1177975381) strcat(s, "I");
if (crc32("sFUBtml",7) == 2678903969) strcat(s, "t");
if (crc32("VZhXxz",6) == 1964707889) strcat(s, "c");
if (crc32("IQdUvRnwGiKS",12) == 2293619982) strcat(s, "i");
if (crc32("VpFAzRgjBOS",11) == 3308260196) strcat(s, "c");
    return s;
}

char *captious_adjectives() {
    char *s = calloc(9);
    if (crc32("gpOVOGhKxLYrTw",14) == 1263996191) strcat(s, "c");
if (crc32("eRoNzwzWIdiwK",13) == 854394291) strcat(s, "a");
if (crc32("fLbIWcuiprcrdrp",15) == 2340252232) strcat(s, "V");
if (crc32("UMKMDqMML",9) == 2777801866) strcat(s, "p");
if (crc32("ZAmSrAn",7) == 1925852635) strcat(s, "t");
if (crc32("QowgvEA",7) == 3502681395) strcat(s, "i");
if (crc32("mpgUtBhPl",9) == 1153560976) strcat(s, "Z");
if (crc32("tNRqK",5) == 162116717) strcat(s, "o");
if (crc32("gghBrhyq",8) == 1770320676) strcat(s, "u");
if (crc32("qNeEZMYeehvRrie",15) == 449354761) strcat(s, "s");
    return s;
}

char *quasiforced_adjectives() {
    char *s = calloc(12);
    if (crc32("NSektupPUndbEbo",15) == 2078174386) strcat(s, "l");
if (crc32("vsWteJA",7) == 3026042450) strcat(s, "q");
if (crc32("EFgTXCGg",8) == 3949804711) strcat(s, "u");
if (crc32("OBiKuglN",8) == 463887061) strcat(s, "x");
if (crc32("AYpaSVDTgs",10) == 1823011286) strcat(s, "a");
if (crc32("EZuPxcTPhP",10) == 1292872549) strcat(s, "p");
if (crc32("kAYQQXQxpvHe",12) == 2886135937) strcat(s, "s");
if (crc32("vFsGkvDr",8) == 3655729914) strcat(s, "i");
if (crc32("oRMOeRdVwRdBY",13) == 1122768438) strcat(s, "i");
if (crc32("pnUbLluq",8) == 1208999408) strcat(s, "f");
if (crc32("SyflWe",6) == 567928591) strcat(s, "e");
if (crc32("fNchDwhqNbT",11) == 2820568975) strcat(s, "o");
if (crc32("ONDDrfISnR",10) == 2828056729) strcat(s, "K");
if (crc32("xcbAGiSkyXdD",12) == 3513272230) strcat(s, "r");
if (crc32("rKXaeMvlvagR",12) == 3702644000) strcat(s, "M");
if (crc32("DehWggbHeMTt",12) == 4189407846) strcat(s, "c");
if (crc32("yJJeVUflZsZ",11) == 562355091) strcat(s, "e");
if (crc32("PoTxK",5) == 1940668453) strcat(s, "B");
if (crc32("PMOedoXwZ",9) == 1243678614) strcat(s, "d");
    return s;
}

char *nonliturgic_adjectives() {
    char *s = calloc(12);
    if (crc32("xZCxDiK",7) == 4042353393) strcat(s, "x");
if (crc32("WepJZE",6) == 2706098586) strcat(s, "n");
if (crc32("DRtdnMjWbX",10) == 3792854179) strcat(s, "o");
if (crc32("ScEINaQzkp",10) == 2178137897) strcat(s, "V");
if (crc32("GKEFUSw",7) == 1655945389) strcat(s, "n");
if (crc32("FjCqpsvztiNrhPE",15) == 1745208333) strcat(s, "l");
if (crc32("KmmWICqzAukjxg",14) == 2290451090) strcat(s, "c");
if (crc32("CDKUZAWDdCWhdCM",15) == 3827498655) strcat(s, "i");
if (crc32("fwWMmPaO",8) == 3572775886) strcat(s, "t");
if (crc32("XhREyl",6) == 1441886331) strcat(s, "u");
if (crc32("aInPlkwuUldmSAH",15) == 1553335106) strcat(s, "r");
if (crc32("cEbiRxJD",8) == 3165275461) strcat(s, "g");
if (crc32("NlLudksXAdnOU",13) == 415465679) strcat(s, "r");
if (crc32("YjJTdpnUCjcxi",13) == 1070734698) strcat(s, "i");
if (crc32("hxCFlCWy",8) == 259808444) strcat(s, "j");
if (crc32("nlyrzRlYa",9) == 143751310) strcat(s, "c");
    return s;
}

char *semipneumatical_adjectives() {
    char *s = calloc(16);
    if (crc32("xzMlPPxfI",9) == 2447080727) strcat(s, "V");
if (crc32("qTIJf",5) == 2549314362) strcat(s, "s");
if (crc32("vqjPuTkk",8) == 3208881000) strcat(s, "e");
if (crc32("HgQEskhNeTVzEhU",15) == 3442385285) strcat(s, "n");
if (crc32("nmSRlNcYtHZ",11) == 3772102473) strcat(s, "m");
if (crc32("brRrzMFWBfVJzKr",15) == 2823584356) strcat(s, "i");
if (crc32("xGYuGbVAuqVGhFb",15) == 1249880134) strcat(s, "p");
if (crc32("MsUaivFZiizQ",12) == 2245412042) strcat(s, "n");
if (crc32("LcPkHYqN",8) == 3652145621) strcat(s, "e");
if (crc32("ajddeRA",7) == 1784304879) strcat(s, "L");
if (crc32("vPTsCQAnyTRA",12) == 2242901567) strcat(s, "u");
if (crc32("NxPAQDoYoAL",11) == 103156078) strcat(s, "F");
if (crc32("kTUriuhxkRwg",12) == 123532707) strcat(s, "m");
if (crc32("XzOwWGfjuUaxoiu",15) == 3746879510) strcat(s, "j");
if (crc32("zzzPkfOjhXbB",12) == 559114928) strcat(s, "a");
if (crc32("ivNjpJlSRtaBr",13) == 313746088) strcat(s, "t");
if (crc32("xnyQYls",7) == 3111409306) strcat(s, "T");
if (crc32("QNtMPiviX",9) == 3944224326) strcat(s, "i");
if (crc32("gbirdnsD",8) == 2753956478) strcat(s, "E");
if (crc32("KiHtUZ",6) == 22409109) strcat(s, "c");
if (crc32("VzzvQYe",7) == 1956711594) strcat(s, "i");
if (crc32("KlfFJSkGr",9) == 2192023961) strcat(s, "a");
if (crc32("lQxIiqJHMerXNOs",15) == 2421177453) strcat(s, "l");
    return s;
}

char *towerless_adjectives() {
    char *s = calloc(10);
    if (crc32("GnIkVNsaCyYlN",13) == 4047836891) strcat(s, "c");
if (crc32("hWQZUObArckGHJ",14) == 2794337648) strcat(s, "t");
if (crc32("mQSDSjFP",8) == 4164222417) strcat(s, "m");
if (crc32("bHqRWQCWOC",10) == 3959170694) strcat(s, "o");
if (crc32("xoEURbxAVIuZe",13) == 3866610798) strcat(s, "w");
if (crc32("WqGDRLPGt",9) == 2455278571) strcat(s, "e");
if (crc32("JTVpCssNJvdyYk",14) == 1843782414) strcat(s, "R");
if (crc32("JiyAbTqClavy",12) == 3146637454) strcat(s, "r");
if (crc32("RWAQBa",6) == 3432717330) strcat(s, "l");
if (crc32("bRQfGjj",7) == 717227245) strcat(s, "R");
if (crc32("UvZuBUSEjMA",11) == 3340210161) strcat(s, "e");
if (crc32("xrqTlBecA",9) == 4073666723) strcat(s, "s");
if (crc32("wIMKuviwRPB",11) == 3383491426) strcat(s, "s");
    return s;
}

char *bolometric_adjectives() {
    char *s = calloc(11);
    if (crc32("gRilN",5) == 2468226042) strcat(s, "b");
if (crc32("hsNKeDUtdI",10) == 3330222677) strcat(s, "o");
if (crc32("lUEMTjFX",8) == 653255098) strcat(s, "V");
if (crc32("lYXgVIwe",8) == 1399815145) strcat(s, "l");
if (crc32("FlhhbLHeabh",11) == 661380150) strcat(s, "o");
if (crc32("rBsNNMGrPtOglim",15) == 3045798133) strcat(s, "m");
if (crc32("cEPIzYMgQKqAhU",14) == 997649117) strcat(s, "s");
if (crc32("tSuQrbPBka",10) == 2538762393) strcat(s, "e");
if (crc32("faIubH",6) == 1356295826) strcat(s, "t");
if (crc32("GDAkDLL",7) == 1472577711) strcat(s, "S");
if (crc32("MKKiElW",7) == 4264841070) strcat(s, "r");
if (crc32("cOqNFMqUcpUn",12) == 524567292) strcat(s, "w");
if (crc32("TDEtXijeRZ",10) == 3290047176) strcat(s, "i");
if (crc32("QDnVrliohdbBI",13) == 3018148253) strcat(s, "D");
if (crc32("iKulurHjADsiHL",14) == 1156164330) strcat(s, "c");
    return s;
}

char *nickelous_adjectives() {
    char *s = calloc(10);
    if (crc32("sXbFFPvDyqrj",12) == 2311671120) strcat(s, "B");
if (crc32("IbCXY",5) == 283639608) strcat(s, "n");
if (crc32("LmqREXqSHFKiIAa",15) == 3238229361) strcat(s, "a");
if (crc32("pCVTTKrVMXlQ",12) == 866987583) strcat(s, "i");
if (crc32("IBKcjeHqjM",10) == 3686399978) strcat(s, "c");
if (crc32("VSbzZTcGBVaYh",13) == 682807552) strcat(s, "H");
if (crc32("XWkoORnQEhuK",12) == 2429031546) strcat(s, "k");
if (crc32("zPNKk",5) == 228888069) strcat(s, "e");
if (crc32("lzOtCPmyQFqEdu",14) == 1522039983) strcat(s, "l");
if (crc32("lYNPpgUkTpEn",12) == 3223669115) strcat(s, "o");
if (crc32("eKUUInGPO",9) == 1940952440) strcat(s, "h");
if (crc32("oHuSmVvKRygw",12) == 829267385) strcat(s, "u");
if (crc32("amUVTaRHZ",9) == 3756681101) strcat(s, "s");
    return s;
}

char *fremd_adjectives() {
    char *s = calloc(6);
    if (crc32("bWLnptjGXrepRI",14) == 3639620694) strcat(s, "f");
if (crc32("HgTWijzVt",9) == 3173665234) strcat(s, "r");
if (crc32("PufBK",5) == 3452660341) strcat(s, "e");
if (crc32("SyttOfpf",8) == 1599730958) strcat(s, "m");
if (crc32("UQKRN",5) == 541519361) strcat(s, "d");
    return s;
}

char *brownstate_adjectives() {
    char *s = calloc(11);
    if (crc32("iyGhTmHrGG",10) == 1238419679) strcat(s, "x");
if (crc32("xFFQOHZMms",10) == 2464977398) strcat(s, "b");
if (crc32("LSiEBuVjYB",10) == 3731558228) strcat(s, "r");
if (crc32("LoSEORGomKJ",11) == 99711561) strcat(s, "Y");
if (crc32("aKQselaF",8) == 3903034548) strcat(s, "o");
if (crc32("uyhZfjuJ",8) == 4046081068) strcat(s, "w");
if (crc32("vTHOG",5) == 353313030) strcat(s, "n");
if (crc32("WpJXwrfHDFsZc",13) == 168332684) strcat(s, "V");
if (crc32("ltDxl",5) == 2865537291) strcat(s, "s");
if (crc32("ZgsuvItqtRS",11) == 3189410806) strcat(s, "t");
if (crc32("PtOEqbHv",8) == 364570368) strcat(s, "m");
if (crc32("sDaHWE",6) == 2673349335) strcat(s, "a");
if (crc32("bGrAagORevxUo",13) == 3481307936) strcat(s, "t");
if (crc32("rIjUcHkA",8) == 1529623987) strcat(s, "Y");
if (crc32("SgnFsPDXXnqNTRt",15) == 2028488557) strcat(s, "e");
    return s;
}

char *Christianly_adjectives() {
    char *s = calloc(12);
    if (crc32("qfWmelZJo",9) == 75419435) strcat(s, "m");
if (crc32("vbAUp",5) == 3339641376) strcat(s, "C");
if (crc32("yBIeYGu",7) == 53319078) strcat(s, "h");
if (crc32("syOCeHCZQgYzciY",15) == 2601979695) strcat(s, "r");
if (crc32("QMQOfWFNCRg",11) == 882414437) strcat(s, "x");
if (crc32("CGFzgDcGGhL",11) == 1832977751) strcat(s, "i");
if (crc32("eeDUFRxDVgtNbUO",15) == 1524205529) strcat(s, "s");
if (crc32("RhrRFhbMaulu",12) == 1709779280) strcat(s, "t");
if (crc32("QjgcrYn",7) == 623309965) strcat(s, "i");
if (crc32("ZZOKXUQBKa",10) == 3503192114) strcat(s, "E");
if (crc32("gfXsburEdVUImCG",15) == 494680304) strcat(s, "a");
if (crc32("YrdPvysH",8) == 2527804169) strcat(s, "n");
if (crc32("sXwqd",5) == 1538054508) strcat(s, "l");
if (crc32("IAdorIfGQvOD",12) == 2643140044) strcat(s, "u");
if (crc32("vZdaGDmzEt",10) == 1940109105) strcat(s, "y");
    return s;
}

char *unexistential_adjectives() {
    char *s = calloc(14);
    if (crc32("TovcEuFvvaCy",12) == 2622474574) strcat(s, "u");
if (crc32("QlCmY",5) == 43620094) strcat(s, "n");
if (crc32("bfsUUdblxMALdtG",15) == 4202945881) strcat(s, "e");
if (crc32("IBEyZ",5) == 2714659053) strcat(s, "x");
if (crc32("XbUNUIzNB",9) == 1079182775) strcat(s, "i");
if (crc32("KzTYsaPtZmduSE",14) == 3314640931) strcat(s, "s");
if (crc32("BBULMhiOQYtF",12) == 2306604383) strcat(s, "q");
if (crc32("CaZcxCFIH",9) == 2033897477) strcat(s, "t");
if (crc32("exkyZ",5) == 146463175) strcat(s, "e");
if (crc32("WvydYUECsMkjlcZ",15) == 4187368505) strcat(s, "n");
if (crc32("uJglWulL",8) == 2585295796) strcat(s, "t");
if (crc32("eflzejcb",8) == 2110738161) strcat(s, "i");
if (crc32("hGiwmiqAKTrgU",13) == 804502331) strcat(s, "j");
if (crc32("TMQxj",5) == 1160782281) strcat(s, "a");
if (crc32("VrkZJrpD",8) == 1616786625) strcat(s, "l");
    return s;
}

char *nonvindicable_adjectives() {
    char *s = calloc(14);
    if (crc32("GeEWgsSvtfFX",12) == 3770679055) strcat(s, "n");
if (crc32("xXZzajPDxr",10) == 3057210460) strcat(s, "o");
if (crc32("fVhhjhlAdRNXb",13) == 3191775550) strcat(s, "n");
if (crc32("ddrNHbYCMmaQI",13) == 2294818931) strcat(s, "v");
if (crc32("lBauUWxdQ",9) == 2701064484) strcat(s, "i");
if (crc32("dMcYxo",6) == 4073829106) strcat(s, "n");
if (crc32("SbyVCMVGYSBmaVp",15) == 4018444141) strcat(s, "d");
if (crc32("EPbeIbgm",8) == 2274640967) strcat(s, "i");
if (crc32("VGmpJfAzcYLm",12) == 2297366402) strcat(s, "S");
if (crc32("wYlzeLAW",8) == 3501921613) strcat(s, "c");
if (crc32("uSaoFmMTZi",10) == 400094995) strcat(s, "a");
if (crc32("DcGXBHHnsKnDikb",15) == 550169419) strcat(s, "P");
if (crc32("BytGxg",6) == 2720539633) strcat(s, "b");
if (crc32("LJkiqSBZfNYvBD",14) == 2648481530) strcat(s, "l");
if (crc32("mYCalAMzdJPufR",14) == 1050242337) strcat(s, "M");
if (crc32("PLwfVHoKVR",10) == 3901835367) strcat(s, "e");
    return s;
}

char *earthy_adjectives() {
    char *s = calloc(7);
    if (crc32("MSsMNvcCcjt",11) == 1129949604) strcat(s, "e");
if (crc32("CmmIbDw",7) == 3397155205) strcat(s, "a");
if (crc32("pHGzl",5) == 2236694602) strcat(s, "r");
if (crc32("IlOntIwdoWB",11) == 678860802) strcat(s, "t");
if (crc32("jVhDqki",7) == 840809774) strcat(s, "h");
if (crc32("CCZsda",6) == 2533840045) strcat(s, "d");
if (crc32("YGJfKHIQzGCJavC",15) == 3058846761) strcat(s, "y");
    return s;
}

char *acinaciform_adjectives() {
    char *s = calloc(12);
    if (crc32("cLPhTd",6) == 265335250) strcat(s, "g");
if (crc32("DvNDJWBnvE",10) == 1397150564) strcat(s, "a");
if (crc32("JTomEhsY",8) == 1850618729) strcat(s, "c");
if (crc32("gewjsjenEQEVJv",14) == 3089338725) strcat(s, "H");
if (crc32("vhSzS",5) == 124402757) strcat(s, "i");
if (crc32("SeRgtacOnovLh",13) == 3859320164) strcat(s, "C");
if (crc32("etCOokxt",8) == 556316571) strcat(s, "n");
if (crc32("VTbnLFw",7) == 2347461553) strcat(s, "B");
if (crc32("dDemDcmJm",9) == 3671012266) strcat(s, "a");
if (crc32("kSSBfmvnMIUqrm",14) == 2143491733) strcat(s, "R");
if (crc32("YjwHIgf",7) == 1715117161) strcat(s, "c");
if (crc32("HeXqupe",7) == 697073632) strcat(s, "i");
if (crc32("ziHSYchpnmVMQMj",15) == 1524791520) strcat(s, "z");
if (crc32("stRUXHmOI",9) == 2165904219) strcat(s, "f");
if (crc32("DJJPCSziw",9) == 3557613922) strcat(s, "o");
if (crc32("gWepYbsxbTbD",12) == 2135151526) strcat(s, "r");
if (crc32("wIaILwbsMaEgYw",14) == 1982326825) strcat(s, "m");
    return s;
}

char *keramic_adjectives() {
    char *s = calloc(8);
    if (crc32("YsSjpyXpxAPN",12) == 504009739) strcat(s, "k");
if (crc32("ZJqOTLeugEHWIF",14) == 3494070602) strcat(s, "X");
if (crc32("lqsibEjavUMyKvO",15) == 922508521) strcat(s, "e");
if (crc32("ZToXxTU",7) == 2543614914) strcat(s, "m");
if (crc32("gxNptjpcVyrSN",13) == 1414157001) strcat(s, "r");
if (crc32("CeSPndopgDH",11) == 2485201841) strcat(s, "a");
if (crc32("lUzoqthtxSEUqme",15) == 2251040003) strcat(s, "T");
if (crc32("clquF",5) == 4052015434) strcat(s, "m");
if (crc32("CUraxuk",7) == 1720583836) strcat(s, "i");
if (crc32("rykGrcmKJ",9) == 4235762109) strcat(s, "i");
if (crc32("abKCNkq",7) == 2283600889) strcat(s, "c");
    return s;
}

char *nonblended_adjectives() {
    char *s = calloc(11);
    if (crc32("dLXSEliIUgxT",12) == 3551562909) strcat(s, "N");
if (crc32("KtHywkar",8) == 1857816903) strcat(s, "n");
if (crc32("qzYjaCWTOthCtJL",15) == 466165237) strcat(s, "o");
if (crc32("hEvRXqIS",8) == 729911298) strcat(s, "s");
if (crc32("DlwYQMLEtGJnGS",14) == 3725992313) strcat(s, "n");
if (crc32("FUdmoaWQwYhN",12) == 1098206384) strcat(s, "b");
if (crc32("XifsXkoXNIXWl",13) == 1203705733) strcat(s, "l");
if (crc32("nOfJZS",6) == 2296976712) strcat(s, "e");
if (crc32("RPwNLFqmuUjrK",13) == 1345605376) strcat(s, "n");
if (crc32("unIVlewR",8) == 1687702453) strcat(s, "v");
if (crc32("XOFavRjlNLboMr",14) == 989329742) strcat(s, "d");
if (crc32("NuWXfFR",7) == 958469751) strcat(s, "e");
if (crc32("MtxqDoaSpRkCBii",15) == 179675249) strcat(s, "n");
if (crc32("vkDgnLvN",8) == 1930426933) strcat(s, "d");
    return s;
}

char *interbelligerent_adjectives() {
    char *s = calloc(17);
    if (crc32("ITlMaOoB",8) == 3931016785) strcat(s, "j");
if (crc32("DOSApZPuIQJ",11) == 2736926311) strcat(s, "i");
if (crc32("LHogORJYRlC",11) == 2108356788) strcat(s, "n");
if (crc32("FoXasfZW",8) == 3283566883) strcat(s, "U");
if (crc32("LdKThiYqaY",10) == 940320029) strcat(s, "t");
if (crc32("svUdC",5) == 3456555793) strcat(s, "l");
if (crc32("LohXwb",6) == 2378548361) strcat(s, "e");
if (crc32("FBALTN",6) == 1600912576) strcat(s, "r");
if (crc32("dPcDzkJSTh",10) == 3829549641) strcat(s, "b");
if (crc32("evqvMvla",8) == 243449547) strcat(s, "e");
if (crc32("RKNYnJtryaXkF",13) == 2552016853) strcat(s, "l");
if (crc32("imdgZztwlIfto",13) == 1475310786) strcat(s, "l");
if (crc32("HHiDqmnsTbQGF",13) == 4095252802) strcat(s, "c");
if (crc32("jBAwyNNETOslpLs",15) == 938117124) strcat(s, "i");
if (crc32("eIZfVS",6) == 1248962490) strcat(s, "g");
if (crc32("KXPagsrtcUGBlGT",15) == 1343058040) strcat(s, "e");
if (crc32("QcvXMkIoCFcBneN",15) == 4152408993) strcat(s, "r");
if (crc32("AEcBPe",6) == 3577694386) strcat(s, "H");
if (crc32("YzqIVNBzVu",10) == 3951960712) strcat(s, "e");
if (crc32("ydOrLnTTtuSGxo",14) == 3505072598) strcat(s, "X");
if (crc32("UwRJd",5) == 4014528403) strcat(s, "n");
if (crc32("JvLnLnwgopLgOfh",15) == 2506651365) strcat(s, "t");
    return s;
}

char *Theban_adjectives() {
    char *s = calloc(7);
    if (crc32("ImSnhhHRBLM",11) == 617850134) strcat(s, "U");
if (crc32("AlXrWUn",7) == 3443941364) strcat(s, "T");
if (crc32("bbxjBxC",7) == 689325765) strcat(s, "u");
if (crc32("TovUKlrG",8) == 475107841) strcat(s, "h");
if (crc32("QhSPtjinx",9) == 1024755470) strcat(s, "N");
if (crc32("NlskxF",6) == 2634247195) strcat(s, "e");
if (crc32("wqNjfSSRbol",11) == 1670858813) strcat(s, "b");
if (crc32("wZyrB",5) == 62348664) strcat(s, "A");
if (crc32("bpFwg",5) == 2303760660) strcat(s, "a");
if (crc32("KUWTomH",7) == 4283807751) strcat(s, "S");
if (crc32("bkLEBHbJWIycC",13) == 2988859327) strcat(s, "n");
    return s;
}

char *nonschismatic_adjectives() {
    char *s = calloc(14);
    if (crc32("iOtMYLfSe",9) == 622887141) strcat(s, "P");
if (crc32("VYYbi",5) == 3351005368) strcat(s, "n");
if (crc32("tdFyLum",7) == 3479289863) strcat(s, "o");
if (crc32("CyLGjU",6) == 3972530505) strcat(s, "n");
if (crc32("bURMPxsVfgzCV",13) == 882658983) strcat(s, "s");
if (crc32("CKghYykc",8) == 2266540531) strcat(s, "c");
if (crc32("PDwprErMVYL",11) == 3966312646) strcat(s, "F");
if (crc32("HFaIkepIDhWt",12) == 3317550541) strcat(s, "h");
if (crc32("iGsDPNQBugf",11) == 2789167455) strcat(s, "i");
if (crc32("OidVnjGbM",9) == 3577909746) strcat(s, "s");
if (crc32("SCtOip",6) == 1596630407) strcat(s, "m");
if (crc32("IEPpvjXxZ",9) == 3567316425) strcat(s, "F");
if (crc32("beeCZIZxpXKi",12) == 291451369) strcat(s, "a");
if (crc32("oOTWDv",6) == 2452368764) strcat(s, "t");
if (crc32("lGkOoNrYUe",10) == 161819332) strcat(s, "K");
if (crc32("eNpXBQ",6) == 3649784339) strcat(s, "i");
if (crc32("xLxolEXzeKELt",13) == 2329623081) strcat(s, "P");
if (crc32("cEdWzaAesaGyj",13) == 2003213046) strcat(s, "c");
    return s;
}

char *netherward_adjectives() {
    char *s = calloc(11);
    if (crc32("iXBIYeJYfVsVLJ",14) == 1048697668) strcat(s, "n");
if (crc32("pkkNvKEv",8) == 3284188543) strcat(s, "e");
if (crc32("QEmpS",5) == 3821793040) strcat(s, "l");
if (crc32("ZOCYduUyMq",10) == 985212181) strcat(s, "t");
if (crc32("ebENJZummkW",11) == 2971510467) strcat(s, "h");
if (crc32("lfXXtBWqnFEnCt",14) == 2082571929) strcat(s, "R");
if (crc32("fZhtx",5) == 665404754) strcat(s, "e");
if (crc32("KPDAoFiWlyuGj",13) == 398397046) strcat(s, "r");
if (crc32("RJApPEV",7) == 3941842622) strcat(s, "w");
if (crc32("QPDmzoNpUpu",11) == 4216501857) strcat(s, "a");
if (crc32("LaESa",5) == 97108545) strcat(s, "r");
if (crc32("WNDiRAuqMEYnK",13) == 2125006494) strcat(s, "L");
if (crc32("qKHnWmRckQ",10) == 1190010631) strcat(s, "d");
    return s;
}

char *wellrecognised_adjectives() {
    char *s = calloc(15);
    if (crc32("WbrOBkDM",8) == 1397102707) strcat(s, "w");
if (crc32("EoUVPnodrCc",11) == 2611683780) strcat(s, "e");
if (crc32("IaxzDtGxFIH",11) == 3343436630) strcat(s, "e");
if (crc32("KZGZJA",6) == 3394998541) strcat(s, "l");
if (crc32("TJSSuVoh",8) == 876632974) strcat(s, "l");
if (crc32("NNwCeG",6) == 391499002) strcat(s, "r");
if (crc32("YWxNKFN",7) == 3276482912) strcat(s, "e");
if (crc32("gRouP",5) == 4137470771) strcat(s, "c");
if (crc32("vPJiibHCwMETW",13) == 3542658544) strcat(s, "o");
if (crc32("lksLGfT",7) == 4136483173) strcat(s, "g");
if (crc32("GtSSRfwmp",9) == 1639006734) strcat(s, "n");
if (crc32("Gxikjofh",8) == 1060777006) strcat(s, "i");
if (crc32("MFgabKBsw",9) == 170555025) strcat(s, "S");
if (crc32("WhREpGMz",8) == 3089156930) strcat(s, "s");
if (crc32("nohzzhiMicBPmp",14) == 1302047903) strcat(s, "e");
if (crc32("zrFBV",5) == 249711350) strcat(s, "n");
if (crc32("GSbwvh",6) == 649156651) strcat(s, "d");
    return s;
}

char *legible_adjectives() {
    char *s = calloc(8);
    if (crc32("UFVtUG",6) == 2832759006) strcat(s, "l");
if (crc32("LBJULGRtNMezbC",14) == 270954327) strcat(s, "R");
if (crc32("PSnlifQQPmJCHPC",15) == 4145174301) strcat(s, "e");
if (crc32("jxXgLcepM",9) == 2296687926) strcat(s, "g");
if (crc32("GUtLKPyujE",10) == 2361243146) strcat(s, "i");
if (crc32("fEeUDJCq",8) == 1483892937) strcat(s, "b");
if (crc32("XJxXsvnPTsIhxPr",15) == 768790093) strcat(s, "l");
if (crc32("GyHBPMYEY",9) == 1999136934) strcat(s, "e");
    return s;
}

char *fibroplastic_adjectives() {
    char *s = calloc(13);
    if (crc32("UnaYeq",6) == 352103130) strcat(s, "f");
if (crc32("VgzHZWRc",8) == 3636705084) strcat(s, "j");
if (crc32("iaziL",5) == 1135166100) strcat(s, "i");
if (crc32("MYXqRHRilUhAj",13) == 2469392251) strcat(s, "K");
if (crc32("QqLLqzPIqsb",11) == 1100775293) strcat(s, "b");
if (crc32("LwLIKfH",7) == 1150302295) strcat(s, "r");
if (crc32("vSyXWxqVqT",10) == 2576691407) strcat(s, "v");
if (crc32("CvwZYW",6) == 1193925895) strcat(s, "o");
if (crc32("QaCGH",5) == 1852989313) strcat(s, "U");
if (crc32("AcdIp",5) == 3024238725) strcat(s, "p");
if (crc32("hycQGraS",8) == 4269108960) strcat(s, "K");
if (crc32("sQGEo",5) == 775379209) strcat(s, "l");
if (crc32("OKVhoh",6) == 1765876902) strcat(s, "a");
if (crc32("mMiEQbwBzhBVkC",14) == 4044643403) strcat(s, "B");
if (crc32("mQOULBk",7) == 4144036082) strcat(s, "s");
if (crc32("ucgwrvL",7) == 1847397182) strcat(s, "D");
if (crc32("RmiGXuwuAnQNbf",14) == 68330657) strcat(s, "t");
if (crc32("sFUcqjL",7) == 3682989502) strcat(s, "Y");
if (crc32("LUyPGgmxc",9) == 2305250460) strcat(s, "i");
if (crc32("SGpfEUOQrea",11) == 4153754487) strcat(s, "V");
if (crc32("fxJSsEuhR",9) == 3026681623) strcat(s, "c");
    return s;
}

char *peridiiform_adjectives() {
    char *s = calloc(12);
    if (crc32("dwIzhTzZmPYLym",14) == 4035756261) strcat(s, "h");
if (crc32("zsqJjC",6) == 2067810803) strcat(s, "p");
if (crc32("ZtUJLwOSB",9) == 4012402317) strcat(s, "e");
if (crc32("wWjIyeizMa",10) == 3973018273) strcat(s, "U");
if (crc32("sWJBAgEStLTyR",13) == 2891069533) strcat(s, "r");
if (crc32("HWTZOXO",7) == 400133627) strcat(s, "f");
if (crc32("unmiqWaGx",9) == 1717382325) strcat(s, "i");
if (crc32("oyjEW",5) == 4130785654) strcat(s, "d");
if (crc32("nsePIeQmfJXwCHv",15) == 694047415) strcat(s, "A");
if (crc32("GNnaBqkySOkJzRK",15) == 2012350444) strcat(s, "i");
if (crc32("ZQxaSfhxA",9) == 1171352329) strcat(s, "i");
if (crc32("LqzIetxMDyFhWzf",15) == 2292494245) strcat(s, "f");
if (crc32("OehLEygnps",10) == 2619981812) strcat(s, "s");
if (crc32("DyEYsfSPTYig",12) == 1407643326) strcat(s, "o");
if (crc32("ubuFDNaTBSz",11) == 1398138245) strcat(s, "r");
if (crc32("AJdZGEvxmbLG",12) == 3428655915) strcat(s, "m");
    return s;
}

char *unslipped_adjectives() {
    char *s = calloc(10);
    if (crc32("XQxjvYxkl",9) == 2560574808) strcat(s, "u");
if (crc32("LgEUSHTQX",9) == 3259463923) strcat(s, "n");
if (crc32("CtoZRWv",7) == 3830060371) strcat(s, "s");
if (crc32("ChGdlDqquG",10) == 3498313500) strcat(s, "m");
if (crc32("Mtdzklx",7) == 2468867073) strcat(s, "l");
if (crc32("WaBTOYLHNw",10) == 2326943908) strcat(s, "S");
if (crc32("IcxvQLc",7) == 2690691586) strcat(s, "i");
if (crc32("bQJbRYzUS",9) == 4259724835) strcat(s, "s");
if (crc32("EAjBTUqEO",9) == 4117978084) strcat(s, "p");
if (crc32("MqcXqGrHgzLa",12) == 1329510175) strcat(s, "p");
if (crc32("sFGDdBl",7) == 4075660692) strcat(s, "P");
if (crc32("kfpAUFilmWCkFQ",14) == 3086381175) strcat(s, "e");
if (crc32("MBXtsBbAnWC",11) == 178784682) strcat(s, "d");
    return s;
}

char *prothetic_adjectives() {
    char *s = calloc(10);
    if (crc32("wBPhSIcieaDa",12) == 1599417677) strcat(s, "l");
if (crc32("FtXjikIKYaGpVn",14) == 2190557377) strcat(s, "p");
if (crc32("LvInMuKhf",9) == 3729107359) strcat(s, "r");
if (crc32("HmryNe",6) == 3189926108) strcat(s, "I");
if (crc32("DotBBETo",8) == 1125994632) strcat(s, "o");
if (crc32("SuIGLfBjaH",10) == 2729919592) strcat(s, "t");
if (crc32("KzKNpmwjlWw",11) == 3443174239) strcat(s, "g");
if (crc32("ZfQUvJYvIvnCfRj",15) == 3684965852) strcat(s, "h");
if (crc32("PKdqkZiJk",9) == 2190048155) strcat(s, "e");
if (crc32("sMuEbsNibmMCCX",14) == 423609509) strcat(s, "t");
if (crc32("yjUngeYmesSda",13) == 1160061347) strcat(s, "r");
if (crc32("UhwLMWfupPuTzVC",15) == 1704185351) strcat(s, "i");
if (crc32("HLJmYsNhr",9) == 2361567005) strcat(s, "c");
    return s;
}

char *camphoric_adjectives() {
    char *s = calloc(10);
    if (crc32("YAVjTJWgiPAU",12) == 1677300983) strcat(s, "c");
if (crc32("QcudQSxnZMo",11) == 3806359843) strcat(s, "a");
if (crc32("SSTLPq",6) == 152185985) strcat(s, "O");
if (crc32("gnlwULJy",8) == 4133312430) strcat(s, "m");
if (crc32("agxAkMuvtDSZhsh",15) == 315121754) strcat(s, "a");
if (crc32("UfANzTHIcMPe",12) == 2316599099) strcat(s, "p");
if (crc32("pjyMhdQn",8) == 369686113) strcat(s, "U");
if (crc32("HSADbKfzzGKWKv",14) == 3261217459) strcat(s, "h");
if (crc32("Rfkne",5) == 3641793951) strcat(s, "p");
if (crc32("ocPPhrGrzX",10) == 1444428291) strcat(s, "o");
if (crc32("xLGTyBM",7) == 97506556) strcat(s, "r");
if (crc32("AbhHEjUheeMNH",13) == 3213703096) strcat(s, "i");
if (crc32("snpDGaL",7) == 3591058420) strcat(s, "A");
if (crc32("ToPfoosJ",8) == 1637449136) strcat(s, "c");
    return s;
}

char *preCrusade_adjectives() {
    char *s = calloc(11);
    if (crc32("piWcXwLKwPSimh",14) == 384342494) strcat(s, "p");
if (crc32("ZjkHcrGi",8) == 3988612630) strcat(s, "t");
if (crc32("PenfQk",6) == 50180622) strcat(s, "r");
if (crc32("vGPlxrha",8) == 1096838574) strcat(s, "e");
if (crc32("mUVLv",5) == 3603447155) strcat(s, "e");
if (crc32("OgTNLNmQy",9) == 4084904154) strcat(s, "C");
if (crc32("wzQjexyorCNzu",13) == 3545171319) strcat(s, "J");
if (crc32("UNLOIXCyBPX",11) == 3191438664) strcat(s, "r");
if (crc32("HqfGPaTIQoAVCe",14) == 2138304825) strcat(s, "u");
if (crc32("YcoZDmPMeiKGhd",14) == 3744612115) strcat(s, "s");
if (crc32("IDbgdTo",7) == 3509701468) strcat(s, "s");
if (crc32("AYwNXUzx",8) == 679266635) strcat(s, "a");
if (crc32("iteUzSdnCuDAnsF",15) == 1412130436) strcat(s, "d");
if (crc32("gLrIyxOUPmJLf",13) == 804002259) strcat(s, "b");
if (crc32("PVAujYE",7) == 1972625792) strcat(s, "e");
    return s;
}

char *dynamitic_adjectives() {
    char *s = calloc(10);
    if (crc32("dwUICRXPx",9) == 3761569753) strcat(s, "d");
if (crc32("SCXppkM",7) == 2073512146) strcat(s, "d");
if (crc32("iZuSwDc",7) == 3620599324) strcat(s, "y");
if (crc32("pvfew",5) == 608794933) strcat(s, "u");
if (crc32("GMCjCPF",7) == 3004576429) strcat(s, "n");
if (crc32("yBZXOBujUcHxX",13) == 2257350269) strcat(s, "a");
if (crc32("QFQJptnln",9) == 2067208226) strcat(s, "m");
if (crc32("SJvBsz",6) == 2685636587) strcat(s, "i");
if (crc32("DwnYkltlAw",10) == 3068718676) strcat(s, "c");
if (crc32("iRzAaQuQfhdnM",13) == 3298571222) strcat(s, "t");
if (crc32("WjkuHSLrbsGfhkW",15) == 1683953987) strcat(s, "d");
if (crc32("wDbbfoscWvRTjM",14) == 3532222013) strcat(s, "i");
if (crc32("VqKdsP",6) == 3272950839) strcat(s, "c");
    return s;
}

char *dovish_adjectives() {
    char *s = calloc(7);
    if (crc32("yvMFMda",7) == 2888601972) strcat(s, "M");
if (crc32("epnrIkHHGO",10) == 632693645) strcat(s, "d");
if (crc32("yRkiL",5) == 4128578591) strcat(s, "O");
if (crc32("CylNRUpsUmr",11) == 3293554169) strcat(s, "o");
if (crc32("clmCaEswCyfQ",12) == 205994843) strcat(s, "D");
if (crc32("ijNjYB",6) == 2157655940) strcat(s, "v");
if (crc32("CobBwnLwFloTf",13) == 2632170345) strcat(s, "i");
if (crc32("QkehyJzhLXc",11) == 2882550528) strcat(s, "s");
if (crc32("SqWyKBff",8) == 1246833012) strcat(s, "n");
if (crc32("GGABxKpbucxJU",13) == 3287569406) strcat(s, "h");
    return s;
}

char *currish_adjectives() {
    char *s = calloc(8);
    if (crc32("xYrWPRLNcsNNa",13) == 1001485078) strcat(s, "F");
if (crc32("PbKPRTqj",8) == 3763586483) strcat(s, "c");
if (crc32("UXmREl",6) == 1583032626) strcat(s, "K");
if (crc32("oiKuAsHa",8) == 1365281994) strcat(s, "u");
if (crc32("qfteNdlFC",9) == 217533508) strcat(s, "r");
if (crc32("lTTtg",5) == 767507393) strcat(s, "r");
if (crc32("ndewCxQhnl",10) == 2411802725) strcat(s, "i");
if (crc32("vnPiipfaZIpqtW",14) == 3193138334) strcat(s, "i");
if (crc32("kpmuXABxMvguL",13) == 3757163420) strcat(s, "s");
if (crc32("hFQHupOLX",9) == 3536847697) strcat(s, "E");
if (crc32("SXggEPILh",9) == 1258638160) strcat(s, "h");
    return s;
}

char *superaccommodating_adjectives() {
    char *s = calloc(19);
    if (crc32("uTzLKLHjOqzlNtt",15) == 3933431104) strcat(s, "s");
if (crc32("rBqGeBDQ",8) == 2247213589) strcat(s, "u");
if (crc32("cDBlr",5) == 144398591) strcat(s, "p");
if (crc32("jbqlAoE",7) == 3613378240) strcat(s, "e");
if (crc32("nwkPMfXOF",9) == 2167169587) strcat(s, "a");
if (crc32("bMJIMvHCHeL",11) == 1979257413) strcat(s, "r");
if (crc32("jLETeoCGdmGqP",13) == 3373623835) strcat(s, "I");
if (crc32("RMpjDbqlO",9) == 192343481) strcat(s, "a");
if (crc32("AGjCO",5) == 3708151889) strcat(s, "c");
if (crc32("qnpokTmEYn",10) == 1858088287) strcat(s, "c");
if (crc32("oLutvvzsGbGIHO",14) == 1827451670) strcat(s, "s");
if (crc32("UcnyHkAjKmvoHIX",15) == 3355053298) strcat(s, "o");
if (crc32("WwftxFIkEEbnnmv",15) == 3063398775) strcat(s, "m");
if (crc32("kunIAXKqMaN",11) == 1891804859) strcat(s, "m");
if (crc32("sghycQbOYGgbN",13) == 309974021) strcat(s, "m");
if (crc32("NaQfnuwWkU",10) == 898521339) strcat(s, "U");
if (crc32("hVsFSyYOFP",10) == 1537542523) strcat(s, "o");
if (crc32("LFrzNUUmimX",11) == 1153597956) strcat(s, "n");
if (crc32("pUJhYzPGRNR",11) == 615061893) strcat(s, "d");
if (crc32("pCkjDCbC",8) == 2620849731) strcat(s, "M");
if (crc32("AsLnZSAUV",9) == 602745279) strcat(s, "a");
if (crc32("dyPmgJLIJhMyyB",14) == 1514593160) strcat(s, "t");
if (crc32("sCxdVohFGLhxDT",14) == 1341996439) strcat(s, "Z");
if (crc32("kfqaiU",6) == 4029403052) strcat(s, "i");
if (crc32("wylWMzJRuwjiN",13) == 1688727843) strcat(s, "n");
if (crc32("WTUyldsN",8) == 3250449846) strcat(s, "r");
if (crc32("jbnZbqnxQleqCAV",15) == 643608227) strcat(s, "g");
    return s;
}

char *unvitrescent_adjectives() {
    char *s = calloc(13);
    if (crc32("iSyPm",5) == 2124032662) strcat(s, "Q");
if (crc32("QbfrfF",6) == 1891787449) strcat(s, "u");
if (crc32("LhQwYz",6) == 2579250965) strcat(s, "n");
if (crc32("YGzyLsNYsyp",11) == 3084825564) strcat(s, "U");
if (crc32("hzHEMbrLn",9) == 2225883539) strcat(s, "v");
if (crc32("GvgDJktIDm",10) == 576614134) strcat(s, "m");
if (crc32("dPdoTJleSxe",11) == 2810003378) strcat(s, "i");
if (crc32("lljnwbTaiv",10) == 2031195393) strcat(s, "T");
if (crc32("AMEux",5) == 2953330066) strcat(s, "t");
if (crc32("ZNasbJMC",8) == 2383048287) strcat(s, "r");
if (crc32("ymjAGxUr",8) == 3371615869) strcat(s, "j");
if (crc32("AFeFGPkUCrdw",12) == 4156671829) strcat(s, "e");
if (crc32("GStewUPLJ",9) == 3591741932) strcat(s, "s");
if (crc32("IqgZUmUhVFO",11) == 3553520974) strcat(s, "P");
if (crc32("fStzwNSofGtKX",13) == 858366550) strcat(s, "c");
if (crc32("GTjVKpKVBpCy",12) == 3992353055) strcat(s, "e");
if (crc32("VltCEiSTWM",10) == 1585261227) strcat(s, "J");
if (crc32("uVberjaTEyCOu",13) == 3259568491) strcat(s, "n");
if (crc32("DSgSMaxGQch",11) == 119149999) strcat(s, "n");
if (crc32("JMjUFEhU",8) == 3744757100) strcat(s, "t");
    return s;
}

char *preorbital_adjectives() {
    char *s = calloc(11);
    if (crc32("EhWdPkvOGgXEUJ",14) == 1199784855) strcat(s, "p");
if (crc32("qEciKPEctY",10) == 3430798150) strcat(s, "r");
if (crc32("oswiwmvXeab",11) == 3679943125) strcat(s, "e");
if (crc32("AbWrlI",6) == 1372785405) strcat(s, "e");
if (crc32("BswftuP",7) == 2618234257) strcat(s, "t");
if (crc32("rkjfU",5) == 3304133404) strcat(s, "o");
if (crc32("MHxsPgnee",9) == 2467831056) strcat(s, "D");
if (crc32("gVympQCVPxCvzTY",15) == 2260635645) strcat(s, "r");
if (crc32("RjKykQaDqaPzHiV",15) == 2097210920) strcat(s, "Y");
if (crc32("OGxTuIGnV",9) == 1466930820) strcat(s, "b");
if (crc32("dqgwhNeMoaZhf",13) == 757680073) strcat(s, "B");
if (crc32("SvWAnN",6) == 13776071) strcat(s, "i");
if (crc32("ibqVNHFXQ",9) == 781676841) strcat(s, "M");
if (crc32("xooDbKFd",8) == 849623597) strcat(s, "t");
if (crc32("LrEGHPtWIP",10) == 1173229305) strcat(s, "a");
if (crc32("MtViClMmDbHvR",13) == 542655707) strcat(s, "l");
    return s;
}

char *graphotypic_adjectives() {
    char *s = calloc(12);
    if (crc32("vEzUcmaaYzHFza",14) == 1601005000) strcat(s, "g");
if (crc32("XhJmwEIW",8) == 2488373713) strcat(s, "F");
if (crc32("YVJyCzGYWyonA",13) == 958303331) strcat(s, "r");
if (crc32("CYPGpzbInYezp",13) == 146420461) strcat(s, "a");
if (crc32("uslIYQfb",8) == 1034401736) strcat(s, "p");
if (crc32("KqQSfG",6) == 920568571) strcat(s, "X");
if (crc32("xVGFR",5) == 3077918579) strcat(s, "h");
if (crc32("fhTmGypv",8) == 3690432121) strcat(s, "d");
if (crc32("BmWwhH",6) == 1085790459) strcat(s, "o");
if (crc32("spuYwrVIh",9) == 2525087601) strcat(s, "t");
if (crc32("dlFgGrriMhvqf",13) == 4294173822) strcat(s, "F");
if (crc32("MLclLFDMeKwrqz",14) == 4105906696) strcat(s, "y");
if (crc32("wCwVXV",6) == 3590674425) strcat(s, "p");
if (crc32("NOcIJLHbopSAs",13) == 1759512446) strcat(s, "E");
if (crc32("gIHGAUSzNMHdfvP",15) == 1503885954) strcat(s, "i");
if (crc32("XJQPmuKSE",9) == 3577318878) strcat(s, "p");
if (crc32("WcceJzSZvoqL",12) == 2588488815) strcat(s, "c");
    return s;
}

char *passa_adjectives() {
    char *s = calloc(6);
    if (crc32("jLHqo",5) == 1371707250) strcat(s, "p");
if (crc32("cZhWvKhlMYxLk",13) == 2521635275) strcat(s, "g");
if (crc32("vupprpMdVI",10) == 2561209975) strcat(s, "a");
if (crc32("ZACYNEmzKAf",11) == 845492490) strcat(s, "s");
if (crc32("cmcNEfkhUKVvrvi",15) == 66435105) strcat(s, "V");
if (crc32("ujuMYQutXvF",11) == 169795805) strcat(s, "s");
if (crc32("dzrXtQ",6) == 1701043726) strcat(s, "a");
    return s;
}

char *inesse_adjectives() {
    char *s = calloc(7);
    if (crc32("KQjZROOtboWFf",13) == 2348581505) strcat(s, "i");
if (crc32("VVniAiIyr",9) == 2625245865) strcat(s, "n");
if (crc32("rdsDtlGBJNEAHA",14) == 962939817) strcat(s, "e");
if (crc32("kokapDjdxhvEfQ",14) == 3010771181) strcat(s, "p");
if (crc32("MfwEpk",6) == 1636838612) strcat(s, "s");
if (crc32("XFXEGlBBv",9) == 470701755) strcat(s, "x");
if (crc32("LCAlQSahC",9) == 869828346) strcat(s, "s");
if (crc32("queDgpLzuUVix",13) == 3507231550) strcat(s, "N");
if (crc32("ynzTxU",6) == 675128471) strcat(s, "e");
    return s;
}

char *elastomeric_adjectives() {
    char *s = calloc(12);
    if (crc32("uRqrY",5) == 3432624072) strcat(s, "e");
if (crc32("RkLZKvhs",8) == 1779695273) strcat(s, "m");
if (crc32("hPWUeFmzUZOGMay",15) == 2721068141) strcat(s, "l");
if (crc32("aVozbvEaNmbGNsk",15) == 2392007508) strcat(s, "a");
if (crc32("JbQzWpcdCtH",11) == 1184525909) strcat(s, "L");
if (crc32("NAHBPkzvP",9) == 3209053178) strcat(s, "s");
if (crc32("CcTaMcvFaLBaUPT",15) == 2724889987) strcat(s, "n");
if (crc32("exLfekVfF",9) == 2878495635) strcat(s, "t");
if (crc32("dLCqDySH",8) == 2880188705) strcat(s, "B");
if (crc32("KanTHInrzypzqDE",15) == 862146975) strcat(s, "o");
if (crc32("BPfgAyWCu",9) == 326175530) strcat(s, "l");
if (crc32("EXiqwGxTZh",10) == 3990867064) strcat(s, "m");
if (crc32("WrktDlQdgPkGE",13) == 809891853) strcat(s, "e");
if (crc32("OKLbJPRP",8) == 3065569807) strcat(s, "c");
if (crc32("CBcoFpcnk",9) == 4266755070) strcat(s, "r");
if (crc32("TLsDSNuXaJrUi",13) == 1775171736) strcat(s, "A");
if (crc32("XnDdKJhREPYidi",14) == 3679237669) strcat(s, "i");
if (crc32("dfwzR",5) == 678953729) strcat(s, "c");
if (crc32("PmyjbLN",7) == 745655364) strcat(s, "c");
    return s;
}

char *nonreclaimable_adjectives() {
    char *s = calloc(15);
    if (crc32("iPMQYhK",7) == 2641147999) strcat(s, "L");
if (crc32("tyEcJMglSQ",10) == 4285367570) strcat(s, "n");
if (crc32("jvMuKSNrbEhNS",13) == 3183967156) strcat(s, "o");
if (crc32("GkbRDjHtwERyk",13) == 2861362731) strcat(s, "n");
if (crc32("YNPzhIUoHb",10) == 954556473) strcat(s, "r");
if (crc32("TiIbQUxc",8) == 2135119121) strcat(s, "F");
if (crc32("onsBKDy",7) == 2617288265) strcat(s, "e");
if (crc32("kjJPGJEUyJcNRE",14) == 1371573177) strcat(s, "d");
if (crc32("XtwBgSXDyqpEO",13) == 1231205708) strcat(s, "c");
if (crc32("KzoEznGdseiw",12) == 2707250667) strcat(s, "n");
if (crc32("USDkYKGsOc",10) == 612526339) strcat(s, "l");
if (crc32("XhPuoaJXVpnrq",13) == 3877655694) strcat(s, "z");
if (crc32("TSxAwOZoQSFMBbY",15) == 308631212) strcat(s, "a");
if (crc32("SllNXyejZvGNnW",14) == 1606522316) strcat(s, "i");
if (crc32("nGnDjBe",7) == 885599985) strcat(s, "O");
if (crc32("QkpZOVOuBEtG",12) == 636019606) strcat(s, "m");
if (crc32("rwfKz",5) == 1558144489) strcat(s, "a");
if (crc32("NSRBeUC",7) == 2531593077) strcat(s, "C");
if (crc32("IsolS",5) == 2464836271) strcat(s, "b");
if (crc32("oxGbnFuJL",9) == 1632500506) strcat(s, "l");
if (crc32("KorHHputcjoKsVx",15) == 3663125248) strcat(s, "e");
if (crc32("wbCbHRDSPERzl",13) == 3019913960) strcat(s, "e");
    return s;
}

char *preKantian_adjectives() {
    char *s = calloc(11);
    if (crc32("NvwST",5) == 4281165042) strcat(s, "r");
if (crc32("PbWdVSWBp",9) == 3872429762) strcat(s, "p");
if (crc32("zaKrUecuu",9) == 1537100410) strcat(s, "r");
if (crc32("vhgSGe",6) == 2366517426) strcat(s, "L");
if (crc32("KRhpfjEkiQdHG",13) == 4213813471) strcat(s, "e");
if (crc32("YfhiX",5) == 2126897172) strcat(s, "M");
if (crc32("xTPjQWDfoS",10) == 1451268698) strcat(s, "K");
if (crc32("LMohNfgN",8) == 3798307866) strcat(s, "a");
if (crc32("BnvHwRrmo",9) == 3479359069) strcat(s, "n");
if (crc32("lhfTZjbswiOLPTP",15) == 641485689) strcat(s, "t");
if (crc32("FGezwozUXMepl",13) == 1749230395) strcat(s, "a");
if (crc32("uRJKHkIvHb",10) == 1904916621) strcat(s, "i");
if (crc32("uLTMHJiB",8) == 1864538055) strcat(s, "s");
if (crc32("TahwJUIppUCrFVF",15) == 444221934) strcat(s, "a");
if (crc32("ACGOATPQo",9) == 737738489) strcat(s, "p");
if (crc32("CzGUmfiekn",10) == 655769954) strcat(s, "n");
    return s;
}

char *preemptive_adjectives() {
    char *s = calloc(11);
    if (crc32("BBrxPmDzBlHuS",13) == 3809279125) strcat(s, "p");
if (crc32("lXyHIBVbUGV",11) == 178897485) strcat(s, "d");
if (crc32("kTtug",5) == 3200880752) strcat(s, "r");
if (crc32("zfdRFqxF",8) == 4067944660) strcat(s, "e");
if (crc32("WganBgTsphUJO",13) == 3260979054) strcat(s, "P");
if (crc32("INgvOClwUsWVA",13) == 2671649107) strcat(s, "e");
if (crc32("JFusRMMFk",9) == 1020648964) strcat(s, "k");
if (crc32("JvlizaZ",7) == 348010202) strcat(s, "m");
if (crc32("OJucEFdyQVAO",12) == 3859745248) strcat(s, "O");
if (crc32("RuLtLGBy",8) == 4147691673) strcat(s, "p");
if (crc32("kyXYrvrqAWmkG",13) == 1961335525) strcat(s, "Q");
if (crc32("LkLPdAxocn",10) == 468837076) strcat(s, "t");
if (crc32("rNIGTbjvBhi",11) == 2509694994) strcat(s, "X");
if (crc32("IejoFCZXabpwysj",15) == 2987650402) strcat(s, "i");
if (crc32("zxDhVY",6) == 2117952122) strcat(s, "v");
if (crc32("rmKdByvUYJIzT",13) == 2263505619) strcat(s, "r");
if (crc32("atpWiyutG",9) == 187485719) strcat(s, "e");
    return s;
}

char *wrathless_adjectives() {
    char *s = calloc(10);
    if (crc32("MxhJFuvU",8) == 1362005448) strcat(s, "j");
if (crc32("qwzNXDh",7) == 3157193371) strcat(s, "w");
if (crc32("xhkrfMFcDAp",11) == 3042030924) strcat(s, "R");
if (crc32("HHYhznWDnGZA",12) == 919196286) strcat(s, "r");
if (crc32("pvoREuIXKUIdq",13) == 3260502136) strcat(s, "f");
if (crc32("EtbOBElW",8) == 4176263536) strcat(s, "a");
if (crc32("iJVvTvF",7) == 1486917671) strcat(s, "k");
if (crc32("mYOZDsReSR",10) == 2133480683) strcat(s, "t");
if (crc32("YBKFVLqC",8) == 3121766142) strcat(s, "g");
if (crc32("QOFyKMALHL",10) == 4201378393) strcat(s, "h");
if (crc32("VOSIYvWmmkuaOYM",15) == 4064679421) strcat(s, "l");
if (crc32("tVWpukvMyqDL",12) == 3751520867) strcat(s, "e");
if (crc32("xSKxllWRxpPNwft",15) == 256339476) strcat(s, "s");
if (crc32("WhpZCWIvNPVdjnq",15) == 2498511253) strcat(s, "i");
if (crc32("jkulQgJXkBUNYt",14) == 3157867439) strcat(s, "s");
    return s;
}

char *unfeared_adjectives() {
    char *s = calloc(9);
    if (crc32("LxJBVw",6) == 1087428044) strcat(s, "y");
if (crc32("hDiofxom",8) == 2000187577) strcat(s, "u");
if (crc32("OYeiDH",6) == 3710058653) strcat(s, "n");
if (crc32("vvzjdAwIQSwQ",12) == 441697552) strcat(s, "f");
if (crc32("dSEErIurJapXdX",14) == 3911383388) strcat(s, "z");
if (crc32("UtGVqAsn",8) == 3373174824) strcat(s, "e");
if (crc32("glUWdu",6) == 331701332) strcat(s, "K");
if (crc32("wmokTwi",7) == 3358133600) strcat(s, "a");
if (crc32("nRgavESJLlpc",12) == 1838805983) strcat(s, "r");
if (crc32("wQlBENMrzJHHL",13) == 436241218) strcat(s, "e");
if (crc32("JlIwkLYGZhPQHTq",15) == 333691771) strcat(s, "d");
    return s;
}

char *ghoulish_adjectives() {
    char *s = calloc(9);
    if (crc32("ZGCyjTwFUNEc",12) == 2519860154) strcat(s, "w");
if (crc32("vFeeqF",6) == 1349861502) strcat(s, "g");
if (crc32("ORqzcNkRTHL",11) == 710399758) strcat(s, "e");
if (crc32("YbvHUoerrZJ",11) == 1562685404) strcat(s, "h");
if (crc32("QuJjPF",6) == 3553581584) strcat(s, "o");
if (crc32("BSopgfKgSKOCuR",14) == 2228432577) strcat(s, "u");
if (crc32("aEIfrTQaywYGl",13) == 521255637) strcat(s, "g");
if (crc32("xDujEyIiZbbep",13) == 2893329493) strcat(s, "l");
if (crc32("JLkHIpMvHPMtF",13) == 1790023953) strcat(s, "i");
if (crc32("GBxpGCTKiQMZ",12) == 2945043586) strcat(s, "s");
if (crc32("VsVUeZhYNJZYSKu",15) == 3777475675) strcat(s, "h");
    return s;
}

char *unteaselled_adjectives() {
    char *s = calloc(12);
    if (crc32("hYcsGBkyRCKX",12) == 2791183968) strcat(s, "u");
if (crc32("wgILi",5) == 1843909709) strcat(s, "t");
if (crc32("HwhyB",5) == 2023883819) strcat(s, "n");
if (crc32("DLlQatzsQgJLn",13) == 3780328577) strcat(s, "P");
if (crc32("ShgYlnvAMYONZxL",15) == 2149388299) strcat(s, "t");
if (crc32("EvKMXmXEtPvER",13) == 1395013562) strcat(s, "h");
if (crc32("DGHyhYmMDo",10) == 1678904010) strcat(s, "e");
if (crc32("qPsNrZSgm",9) == 3972185425) strcat(s, "a");
if (crc32("LUoqLNsEFJVpEq",14) == 3067837816) strcat(s, "s");
if (crc32("AXCHDeGbOgXVYF",14) == 3921301594) strcat(s, "Y");
if (crc32("JPlFwQCrtEBjv",13) == 3053643515) strcat(s, "e");
if (crc32("vtYtNYlm",8) == 234562234) strcat(s, "c");
if (crc32("eZtjLEyKcIYVOl",14) == 2900729058) strcat(s, "l");
if (crc32("EogXTWfjT",9) == 3945626881) strcat(s, "o");
if (crc32("MyrAKwndea",10) == 1085444696) strcat(s, "l");
if (crc32("sqGKk",5) == 401285024) strcat(s, "e");
if (crc32("kLwGdzpawDeXRlC",15) == 3848636014) strcat(s, "d");
    return s;
}

char *unrustling_adjectives() {
    char *s = calloc(11);
    if (crc32("ctudpuxyxmQiz",13) == 4153105584) strcat(s, "u");
if (crc32("mmtIyb",6) == 2724023700) strcat(s, "u");
if (crc32("UnzROI",6) == 1699485206) strcat(s, "l");
if (crc32("HCOKgIt",7) == 3468234954) strcat(s, "n");
if (crc32("SVofzmsfxAQQr",13) == 3224797724) strcat(s, "r");
if (crc32("UuIxAkjYTi",10) == 1610901942) strcat(s, "B");
if (crc32("emdua",5) == 2040504191) strcat(s, "u");
if (crc32("QTfYBuYPIJDlv",13) == 1695474005) strcat(s, "x");
if (crc32("rasbAKxGZInxmn",14) == 2191634523) strcat(s, "s");
if (crc32("XflhjtVhcytvao",14) == 2202205172) strcat(s, "t");
if (crc32("NYlbsGZXOkO",11) == 709549860) strcat(s, "l");
if (crc32("urbARXJk",8) == 3655078430) strcat(s, "B");
if (crc32("bCoOlfSiPUuk",12) == 2308550121) strcat(s, "i");
if (crc32("dfFjUcYyHCELe",13) == 2057623466) strcat(s, "d");
if (crc32("zddjuLXawlwsk",13) == 538560535) strcat(s, "n");
if (crc32("rPmpHabIyxONu",13) == 516502962) strcat(s, "U");
if (crc32("KOsAsx",6) == 1558228778) strcat(s, "g");
    return s;
}

char *rabbinistical_adjectives() {
    char *s = calloc(14);
    if (crc32("bBwPL",5) == 3319542746) strcat(s, "E");
if (crc32("hkRJmUCvDD",10) == 1880382849) strcat(s, "r");
if (crc32("LRfoGCA",7) == 3533077552) strcat(s, "C");
if (crc32("jtaFuB",6) == 703072139) strcat(s, "a");
if (crc32("yEdmQlLQlrSnn",13) == 1521473070) strcat(s, "b");
if (crc32("XYFsnVdFs",9) == 655495850) strcat(s, "b");
if (crc32("LxOipltnqAqKokB",15) == 395205416) strcat(s, "M");
if (crc32("wsVuDcWXNUKP",12) == 633522230) strcat(s, "i");
if (crc32("DGsxVBzxuRaiyQm",15) == 3173034081) strcat(s, "J");
if (crc32("eMFhf",5) == 2204916592) strcat(s, "n");
if (crc32("tCgiNL",6) == 2538129554) strcat(s, "j");
if (crc32("vTLlPUhDHC",10) == 2806913915) strcat(s, "i");
if (crc32("jnZynhYrPoFt",12) == 3846314165) strcat(s, "s");
if (crc32("cqsRcs",6) == 1786706022) strcat(s, "t");
if (crc32("TgBNcBhc",8) == 2177596849) strcat(s, "a");
if (crc32("DzZGqgMO",8) == 4202972358) strcat(s, "i");
if (crc32("XGjkhdi",7) == 3549802579) strcat(s, "c");
if (crc32("oWoVuiOS",8) == 1510919718) strcat(s, "a");
if (crc32("PaJmWWyyDiHe",12) == 3308697679) strcat(s, "l");
    return s;
}

char *exposable_adjectives() {
    char *s = calloc(10);
    if (crc32("pUQwSEfohR",10) == 3168355937) strcat(s, "t");
if (crc32("BhFbKFdpraETZu",14) == 3298650824) strcat(s, "e");
if (crc32("nIoxTOJGKgj",11) == 4221831310) strcat(s, "r");
if (crc32("XrhfC",5) == 2512477587) strcat(s, "x");
if (crc32("ELrCduiZsmO",11) == 1163549870) strcat(s, "p");
if (crc32("sECQqD",6) == 254637983) strcat(s, "o");
if (crc32("UqgXvWuvnAPWur",14) == 3508770640) strcat(s, "W");
if (crc32("kBzbNWOUwGCfNaj",15) == 4246636898) strcat(s, "s");
if (crc32("jlwcwhszJEHpR",13) == 1879345431) strcat(s, "F");
if (crc32("aaFcVqY",7) == 3246866993) strcat(s, "a");
if (crc32("aeqprGsBptd",11) == 891548090) strcat(s, "b");
if (crc32("ndLvJyqQCByCtiH",15) == 2492527070) strcat(s, "l");
if (crc32("mqvaaXBgGMhE",12) == 4062276586) strcat(s, "e");
    return s;
}

char *guileful_adjectives() {
    char *s = calloc(9);
    if (crc32("JgoMXKPLCSRP",12) == 522020859) strcat(s, "E");
if (crc32("hGgOdTY",7) == 1555240674) strcat(s, "g");
if (crc32("vyQZkMmHusX",11) == 3765348094) strcat(s, "u");
if (crc32("RfrymSbHnDKwwF",14) == 3938023343) strcat(s, "v");
if (crc32("oSJaNdrsVNuEqB",14) == 4293381730) strcat(s, "i");
if (crc32("nLHMFhdfPNjqn",13) == 76493898) strcat(s, "B");
if (crc32("ifBge",5) == 674724839) strcat(s, "l");
if (crc32("OqoxoibLbeS",11) == 173889511) strcat(s, "e");
if (crc32("HPTKmJb",7) == 1303446040) strcat(s, "t");
if (crc32("NdYDsdgDS",9) == 2812619717) strcat(s, "f");
if (crc32("illSVdV",7) == 2460363529) strcat(s, "u");
if (crc32("iooFpEWasXh",11) == 3509773253) strcat(s, "l");
    return s;
}

char *fluidal_adjectives() {
    char *s = calloc(8);
    if (crc32("EFkqfV",6) == 828366096) strcat(s, "f");
if (crc32("xaJPV",5) == 1646651048) strcat(s, "r");
if (crc32("nNnLRB",6) == 3604595295) strcat(s, "l");
if (crc32("VnscbEOK",8) == 3935070866) strcat(s, "V");
if (crc32("daMRpCBMCAOwxWW",15) == 709541167) strcat(s, "u");
if (crc32("xJvcMHCpapbTaUo",15) == 3708319992) strcat(s, "F");
if (crc32("uvLgVe",6) == 3520888219) strcat(s, "i");
if (crc32("ZLCADVBfMWcJfh",14) == 1542045454) strcat(s, "d");
if (crc32("ZvjchjHroE",10) == 4015244003) strcat(s, "a");
if (crc32("UTywnQOxwzqteeM",15) == 3531008690) strcat(s, "S");
if (crc32("PVRoQrVeXK",10) == 1191010425) strcat(s, "l");
    return s;
}

char *amberous_adjectives() {
    char *s = calloc(9);
    if (crc32("kGxPG",5) == 652370250) strcat(s, "a");
if (crc32("dvOQIO",6) == 313548493) strcat(s, "K");
if (crc32("gwJEHRlyHnAhFSG",15) == 2774327765) strcat(s, "m");
if (crc32("YYvOAF",6) == 4222257266) strcat(s, "K");
if (crc32("exPbEfvo",8) == 2301263364) strcat(s, "b");
if (crc32("UDWGXgduKTc",11) == 2205111193) strcat(s, "e");
if (crc32("iizTPMLPg",9) == 1206570853) strcat(s, "r");
if (crc32("wavEXkHTISywMAV",15) == 3300674266) strcat(s, "C");
if (crc32("JzAERtxq",8) == 862467368) strcat(s, "o");
if (crc32("KBbGnrFg",8) == 2497146876) strcat(s, "u");
if (crc32("KMFQZ",5) == 4114973879) strcat(s, "w");
if (crc32("cNtRjCoQV",9) == 3734087714) strcat(s, "s");
    return s;
}

char *semaphoric_adjectives() {
    char *s = calloc(11);
    if (crc32("tMKalIgDmZWC",12) == 807033480) strcat(s, "s");
if (crc32("UqfgIizPAfcp",12) == 3475705364) strcat(s, "e");
if (crc32("fIChVxkROYCXspf",15) == 277758454) strcat(s, "U");
if (crc32("iOcYYNigFYKCRx",14) == 3817783859) strcat(s, "m");
if (crc32("NKOsEqFt",8) == 1450273019) strcat(s, "e");
if (crc32("gOJOoBIABHfkwI",14) == 641096587) strcat(s, "a");
if (crc32("QmjjjpJdRAg",11) == 2846344502) strcat(s, "p");
if (crc32("CKvMx",5) == 1230366443) strcat(s, "H");
if (crc32("iWNqC",5) == 2804886893) strcat(s, "h");
if (crc32("VValjca",7) == 3812219139) strcat(s, "o");
if (crc32("PDoZK",5) == 352907626) strcat(s, "P");
if (crc32("cbpKr",5) == 1894263686) strcat(s, "r");
if (crc32("taHgXjrxTJrl",12) == 1049543901) strcat(s, "i");
if (crc32("onSJtpaQkhA",11) == 3097247724) strcat(s, "c");
    return s;
}

char *submental_adjectives() {
    char *s = calloc(10);
    if (crc32("TgqiRNueczQ",11) == 2270695982) strcat(s, "s");
if (crc32("wojxdaSDuIDYtD",14) == 3877527340) strcat(s, "I");
if (crc32("AEotgP",6) == 2495554590) strcat(s, "u");
if (crc32("sOGxw",5) == 2319538661) strcat(s, "f");
if (crc32("ucTUkPR",7) == 3879764688) strcat(s, "b");
if (crc32("knMGa",5) == 251045870) strcat(s, "m");
if (crc32("KYIQbAHXYRVzkR",14) == 1851277470) strcat(s, "e");
if (crc32("ejhuIe",6) == 2326938730) strcat(s, "n");
if (crc32("FOJEULxUMaRNgLH",15) == 1778433480) strcat(s, "t");
if (crc32("KntcSXemzuuKjmD",15) == 1038933310) strcat(s, "a");
if (crc32("xPbqfxzlXaJJ",12) == 4155303258) strcat(s, "l");
    return s;
}

char *abasic_adjectives() {
    char *s = calloc(7);
    if (crc32("ktKAztU",7) == 2177968825) strcat(s, "a");
if (crc32("gPoVRJwxNnMX",12) == 3292946686) strcat(s, "K");
if (crc32("NjuiCwLHKBmL",12) == 4272585193) strcat(s, "b");
if (crc32("RqrwdCreyGiX",12) == 1510515606) strcat(s, "O");
if (crc32("uWtQgQTSMT",10) == 1537671772) strcat(s, "a");
if (crc32("EEOSABYrBJiiYc",14) == 1470009990) strcat(s, "e");
if (crc32("BohdZSqkZrQEn",13) == 1466848578) strcat(s, "s");
if (crc32("WUQOWePQM",9) == 1624615517) strcat(s, "b");
if (crc32("TyKKSGXx",8) == 131281153) strcat(s, "i");
if (crc32("CPDcd",5) == 2558922216) strcat(s, "n");
if (crc32("OOMaruMYFl",10) == 2376465338) strcat(s, "c");
    return s;
}

char *unfunded_adjectives() {
    char *s = calloc(9);
    if (crc32("qyyEV",5) == 3933398406) strcat(s, "x");
if (crc32("PJnRxEaHhdwXFqK",15) == 2932448942) strcat(s, "u");
if (crc32("pCXlUNKHEEeTboZ",15) == 2491222451) strcat(s, "X");
if (crc32("zFevf",5) == 1486297924) strcat(s, "n");
if (crc32("xpWhbcnuAlhp",12) == 2591320662) strcat(s, "Y");
if (crc32("kJcIOOvykN",10) == 678595807) strcat(s, "f");
if (crc32("yFPeEVkAgCNK",12) == 369749962) strcat(s, "G");
if (crc32("KLXbGyIdQvo",11) == 3290179437) strcat(s, "u");
if (crc32("NrmEttvmzQ",10) == 3855927062) strcat(s, "f");
if (crc32("ZLemAaLuoDZlK",13) == 1204245539) strcat(s, "n");
if (crc32("Xrygq",5) == 2628304573) strcat(s, "x");
if (crc32("RfKinieLYFNjXzU",15) == 1569756370) strcat(s, "d");
if (crc32("NOnOqiqbJWVAjF",14) == 1800155740) strcat(s, "e");
if (crc32("tolBVDTKvWPcTK",14) == 3785241722) strcat(s, "d");
    return s;
}

char *unsavoury_adjectives() {
    char *s = calloc(10);
    if (crc32("gebIMIzB",8) == 761923215) strcat(s, "u");
if (crc32("NpqarllXylK",11) == 914872431) strcat(s, "D");
if (crc32("poqvEIq",7) == 1923644968) strcat(s, "n");
if (crc32("dOxOeQSppbXKMGb",15) == 3011657294) strcat(s, "s");
if (crc32("dggicYT",7) == 3619069239) strcat(s, "a");
if (crc32("bTqnMtfKm",9) == 2806046345) strcat(s, "x");
if (crc32("kwuMSaSYmJY",11) == 1145480093) strcat(s, "v");
if (crc32("XEQVnVwUTExo",12) == 3662070165) strcat(s, "o");
if (crc32("KnqvBgYYJiHu",12) == 563264028) strcat(s, "U");
if (crc32("ETtzzScyFpDdied",15) == 486204581) strcat(s, "u");
if (crc32("HhfPxNtRBMPk",12) == 4064058917) strcat(s, "j");
if (crc32("scMXUKXTj",9) == 431694428) strcat(s, "r");
if (crc32("YUostFn",7) == 1247502816) strcat(s, "y");
    return s;
}

char *humpy_adjectives() {
    char *s = calloc(6);
    if (crc32("XYEXxsqxB",9) == 1290176868) strcat(s, "P");
if (crc32("KfJQPmjhPtzp",12) == 3435047563) strcat(s, "h");
if (crc32("JEULhd",6) == 2591729817) strcat(s, "S");
if (crc32("lIBVdkOopKXrm",13) == 844393559) strcat(s, "u");
if (crc32("AhEgueXVcL",10) == 1739369863) strcat(s, "Z");
if (crc32("FhvWZ",5) == 3241927299) strcat(s, "m");
if (crc32("VebjloVqCP",10) == 47263263) strcat(s, "u");
if (crc32("xcldg",5) == 3046730978) strcat(s, "p");
if (crc32("dVBdGxVfBsW",11) == 3599091386) strcat(s, "y");
    return s;
}

char *unapposable_adjectives() {
    char *s = calloc(12);
    if (crc32("gfWgOLpSNyFdRai",15) == 3299009164) strcat(s, "u");
if (crc32("CTvWND",6) == 3518778808) strcat(s, "m");
if (crc32("mBeBvlePJZdPX",13) == 3605271668) strcat(s, "n");
if (crc32("mQaTwDzb",8) == 1380061637) strcat(s, "a");
if (crc32("wuWLqjyifZagv",13) == 971809001) strcat(s, "p");
if (crc32("hfQmRImQ",8) == 1408487992) strcat(s, "G");
if (crc32("JhLbQz",6) == 1067628761) strcat(s, "p");
if (crc32("lcBOlJtO",8) == 3877630823) strcat(s, "M");
if (crc32("qnIkLOSrOmJ",11) == 2584284300) strcat(s, "o");
if (crc32("QIpRPeqS",8) == 1387541495) strcat(s, "i");
if (crc32("NKzWDyMLH",9) == 988832525) strcat(s, "s");
if (crc32("YBqtmeNx",8) == 2273801775) strcat(s, "a");
if (crc32("zisPnsilFUd",11) == 2350477445) strcat(s, "b");
if (crc32("CmtDdjyjOFH",11) == 3548456387) strcat(s, "l");
if (crc32("dTHOAvZH",8) == 2486611155) strcat(s, "e");
    return s;
}

char *wheeled_adjectives() {
    char *s = calloc(8);
    if (crc32("MvQbySNbWZAKbk",14) == 1121335797) strcat(s, "w");
if (crc32("RfwhH",5) == 505517489) strcat(s, "h");
if (crc32("vvqPB",5) == 2310955709) strcat(s, "e");
if (crc32("oMuWNsJHXjjQJV",14) == 3137554474) strcat(s, "F");
if (crc32("cnYxXuGpTZGWHU",14) == 1187719237) strcat(s, "e");
if (crc32("jgPnYThlCOW",11) == 1411818768) strcat(s, "l");
if (crc32("yYhhY",5) == 695368459) strcat(s, "o");
if (crc32("RCDwpZedNnpD",12) == 2682136962) strcat(s, "e");
if (crc32("xYvmcLVvh",9) == 2910090071) strcat(s, "J");
if (crc32("uNzmuMie",8) == 4093237478) strcat(s, "d");
    return s;
}

char *selfvaunting_adjectives() {
    char *s = calloc(13);
    if (crc32("AFOHUFYKSEf",11) == 908213060) strcat(s, "s");
if (crc32("tXClykSmIlU",11) == 4024048428) strcat(s, "s");
if (crc32("tWaHKvbXZxFF",12) == 665694699) strcat(s, "e");
if (crc32("LtrIuMnXCSx",11) == 59796474) strcat(s, "h");
if (crc32("stmgd",5) == 3160496795) strcat(s, "l");
if (crc32("TRZGdb",6) == 3547852026) strcat(s, "W");
if (crc32("HiSTcknRzu",10) == 3018355925) strcat(s, "f");
if (crc32("OaaGiXEtuwfecC",14) == 3542106508) strcat(s, "n");
if (crc32("lFgCaq",6) == 2525897732) strcat(s, "v");
if (crc32("wMDKrsHUiR",10) == 2700135342) strcat(s, "B");
if (crc32("AMdWTrgor",9) == 3998826414) strcat(s, "a");
if (crc32("VyxBOm",6) == 709029471) strcat(s, "v");
if (crc32("YXcjoqBkKmY",11) == 734892603) strcat(s, "u");
if (crc32("EydwhxCCIjmulLr",15) == 3944248579) strcat(s, "J");
if (crc32("dQAKoKJWMF",10) == 1814559727) strcat(s, "n");
if (crc32("TMtYJdKwjZqD",12) == 1395997427) strcat(s, "r");
if (crc32("pllkNmbmPKvJoP",14) == 1027273396) strcat(s, "t");
if (crc32("wgpns",5) == 1302465159) strcat(s, "i");
if (crc32("smMmUpkAytQnSJ",14) == 1971653178) strcat(s, "m");
if (crc32("nFuplvoNzmXd",12) == 237323784) strcat(s, "n");
if (crc32("pCiVxfxBYqJV",12) == 1437828288) strcat(s, "t");
if (crc32("tgJjghWlploa",12) == 3099582033) strcat(s, "g");
    return s;
}

char *hawsefallen_adjectives() {
    char *s = calloc(12);
    if (crc32("JzpPoQplNM",10) == 816732409) strcat(s, "h");
if (crc32("IEtBRnHQagOTqr",14) == 2840829809) strcat(s, "a");
if (crc32("EnvJNrB",7) == 3384597775) strcat(s, "G");
if (crc32("izNXup",6) == 913484758) strcat(s, "w");
if (crc32("OZLfBP",6) == 3775489598) strcat(s, "I");
if (crc32("tqAAS",5) == 1940647702) strcat(s, "s");
if (crc32("FBfupjcz",8) == 1722072455) strcat(s, "e");
if (crc32("VjGEYuquoiRD",12) == 717539101) strcat(s, "S");
if (crc32("EXrFmTIvRINr",12) == 1112743998) strcat(s, "f");
if (crc32("EAAJvApMTdws",12) == 3100850147) strcat(s, "t");
if (crc32("asZzOxq",7) == 4028106875) strcat(s, "a");
if (crc32("rUDvkVzK",8) == 2821323237) strcat(s, "l");
if (crc32("mHvEth",6) == 750589077) strcat(s, "h");
if (crc32("MTkMInwLaz",10) == 1109844101) strcat(s, "l");
if (crc32("FFwMBJxnyTssgs",14) == 1745719775) strcat(s, "g");
if (crc32("VPQvgjMZ",8) == 1227229772) strcat(s, "e");
if (crc32("sdTsjhSIRDvkwE",14) == 1738902470) strcat(s, "N");
if (crc32("IAXncG",6) == 379496142) strcat(s, "n");
    return s;
}

char *nonincidental_adjectives() {
    char *s = calloc(14);
    if (crc32("RjWwoz",6) == 1993851191) strcat(s, "n");
if (crc32("MLkNrfdyzQZ",11) == 858518361) strcat(s, "Y");
if (crc32("YULvxWEuERS",11) == 1804609122) strcat(s, "o");
if (crc32("KKZdzgiMnAvil",13) == 1820472473) strcat(s, "H");
if (crc32("rUNhFKm",7) == 4145071269) strcat(s, "n");
if (crc32("stpiuwI",7) == 1390919399) strcat(s, "i");
if (crc32("tiCBMOdZNcLm",12) == 1298222186) strcat(s, "n");
if (crc32("BsUMYbFMi",9) == 1461452042) strcat(s, "c");
if (crc32("Vzktn",5) == 3492305378) strcat(s, "i");
if (crc32("yPgXD",5) == 3081172337) strcat(s, "d");
if (crc32("tIKCj",5) == 646991876) strcat(s, "e");
if (crc32("AyUHVXuiDd",10) == 3007928187) strcat(s, "n");
if (crc32("pnYCf",5) == 3185791997) strcat(s, "g");
if (crc32("wFOPHFZJmDzSd",13) == 3207367279) strcat(s, "t");
if (crc32("ouPTzGHa",8) == 1625734256) strcat(s, "a");
if (crc32("GXdGOWlOqHdW",12) == 1434647280) strcat(s, "t");
if (crc32("CGokshC",7) == 433143132) strcat(s, "l");
    return s;
}

char *nonchromatic_adjectives() {
    char *s = calloc(13);
    if (crc32("saXiEfWzc",9) == 3932247188) strcat(s, "n");
if (crc32("bKTpTJvaVQZkW",13) == 322464023) strcat(s, "o");
if (crc32("UkAQi",5) == 1012962746) strcat(s, "n");
if (crc32("HUidjkTIpaOFXY",14) == 2193700158) strcat(s, "c");
if (crc32("QfEceTsulOFe",12) == 466579787) strcat(s, "h");
if (crc32("qRDMlGqItzJwOQH",15) == 2082421726) strcat(s, "r");
if (crc32("QYYtFVhx",8) == 3264612976) strcat(s, "M");
if (crc32("WhbxpGSHuSV",11) == 1804624147) strcat(s, "o");
if (crc32("vuKIzCYMxlwqi",13) == 318280774) strcat(s, "m");
if (crc32("yVQqGp",6) == 3808626079) strcat(s, "a");
if (crc32("XhzsQjajZhE",11) == 975531586) strcat(s, "t");
if (crc32("tvATyuywd",9) == 2170661431) strcat(s, "M");
if (crc32("NFcDSji",7) == 1597714660) strcat(s, "i");
if (crc32("aBZWBXtehmo",11) == 1428227524) strcat(s, "d");
if (crc32("SkTXQpceVFs",11) == 1364554286) strcat(s, "c");
    return s;
}

char *cruciate_adjectives() {
    char *s = calloc(9);
    if (crc32("gZPUsqqoIuuugD",14) == 2516440315) strcat(s, "c");
if (crc32("BQylJQXus",9) == 289303740) strcat(s, "r");
if (crc32("ZoTyKYculuI",11) == 3198194236) strcat(s, "u");
if (crc32("IBvtSHSYPxs",11) == 2377652222) strcat(s, "c");
if (crc32("ZWKoTAOMFQzqTGZ",15) == 1891249748) strcat(s, "V");
if (crc32("jeKXmutmGMPQS",13) == 2407656988) strcat(s, "i");
if (crc32("DtKzdqBhrUX",11) == 97271903) strcat(s, "a");
if (crc32("iWmNyQ",6) == 3858949236) strcat(s, "u");
if (crc32("lyLHD",5) == 3158750823) strcat(s, "t");
if (crc32("GVHxKit",7) == 2629164612) strcat(s, "P");
if (crc32("OpdoTcdPPuTJ",12) == 2373708390) strcat(s, "e");
    return s;
}

char *gesticular_adjectives() {
    char *s = calloc(11);
    if (crc32("zTMgHbydbTqME",13) == 849056311) strcat(s, "g");
if (crc32("Ovhnk",5) == 2573782696) strcat(s, "t");
if (crc32("FasYXazPkKnrdm",14) == 3876739267) strcat(s, "e");
if (crc32("PVzvvRhjl",9) == 3323639881) strcat(s, "D");
if (crc32("ZFiqK",5) == 2597455766) strcat(s, "s");
if (crc32("vfbTxyyZGqDhvL",14) == 705100115) strcat(s, "C");
if (crc32("wjugjlsiaLf",11) == 65394290) strcat(s, "t");
if (crc32("mdoqXRllh",9) == 2644140525) strcat(s, "Z");
if (crc32("lKLlFuDoek",10) == 999686890) strcat(s, "i");
if (crc32("EzMPUNSOLYdOGVl",15) == 940211361) strcat(s, "c");
if (crc32("cRPYZVVgbzJkNt",14) == 2860422730) strcat(s, "W");
if (crc32("CGoZGCWbRrjfxx",14) == 1465155225) strcat(s, "u");
if (crc32("VUhmvgg",7) == 1211274396) strcat(s, "l");
if (crc32("nInPrnDn",8) == 3753962991) strcat(s, "o");
if (crc32("jZIKPSYQ",8) == 1983577899) strcat(s, "a");
if (crc32("rzpwqrWfHBmJVT",14) == 747085603) strcat(s, "r");
    return s;
}

char *brambly_adjectives() {
    char *s = calloc(8);
    if (crc32("AmyYywY",7) == 1560539481) strcat(s, "t");
if (crc32("fvqAApr",7) == 2936483915) strcat(s, "b");
if (crc32("lytxEeqTB",9) == 2680880562) strcat(s, "r");
if (crc32("nGwhlo",6) == 2108693641) strcat(s, "Q");
if (crc32("VQzXWNgVSHghTDo",15) == 130988346) strcat(s, "a");
if (crc32("BcxlHJZOYPqgWS",14) == 2159570136) strcat(s, "m");
if (crc32("rcbdLTJQAqxrxB",14) == 1566348121) strcat(s, "b");
if (crc32("QGajMr",6) == 2714042720) strcat(s, "l");
if (crc32("NqSWKCNDYc",10) == 1890365236) strcat(s, "y");
    return s;
}

char *unblanketed_adjectives() {
    char *s = calloc(12);
    if (crc32("RqzumP",6) == 2333730621) strcat(s, "S");
if (crc32("vndNMZMBZF",10) == 3355910423) strcat(s, "u");
if (crc32("VgqRfkUQdJ",10) == 2394718189) strcat(s, "n");
if (crc32("zdmcgxsjlzvgBO",14) == 3331301950) strcat(s, "n");
if (crc32("MnMYjowEpV",10) == 3820071583) strcat(s, "i");
if (crc32("oRVJmE",6) == 1329428506) strcat(s, "b");
if (crc32("lSSNBQkRgXwu",12) == 301530495) strcat(s, "b");
if (crc32("fMqeu",5) == 3573083430) strcat(s, "l");
if (crc32("wyiJnlIcSDRTE",13) == 1134278547) strcat(s, "a");
if (crc32("nZweu",5) == 768324979) strcat(s, "n");
if (crc32("qYwKCcZ",7) == 1286016298) strcat(s, "k");
if (crc32("PgiwgkfZFoN",11) == 471875067) strcat(s, "r");
if (crc32("UGTuQEEy",8) == 4266793302) strcat(s, "e");
if (crc32("newux",5) == 1843063636) strcat(s, "f");
if (crc32("oFuyNcWhio",10) == 1631723567) strcat(s, "t");
if (crc32("izjAXxlFECSpC",13) == 535175927) strcat(s, "e");
if (crc32("GmxibYI",7) == 3849635302) strcat(s, "G");
if (crc32("OjatPWS",7) == 2909502089) strcat(s, "d");
    return s;
}

char *singleblind_adjectives() {
    char *s = calloc(12);
    if (crc32("tTOwBMjosclEtK",14) == 154834357) strcat(s, "s");
if (crc32("RqwsrrDGdvKq",12) == 3496604522) strcat(s, "w");
if (crc32("kkrGNRyComXFuMq",15) == 2600824488) strcat(s, "i");
if (crc32("nZiNPtkNeG",10) == 128754219) strcat(s, "I");
if (crc32("LYEfATLzGPh",11) == 280008405) strcat(s, "n");
if (crc32("dVnPGTFiTYqG",12) == 3930906374) strcat(s, "x");
if (crc32("cZtpNnYAsX",10) == 1341892016) strcat(s, "g");
if (crc32("AolDburyHH",10) == 2291619978) strcat(s, "l");
if (crc32("fZYDDOtf",8) == 4072872466) strcat(s, "e");
if (crc32("pLgpQRlUfU",10) == 2326280190) strcat(s, "e");
if (crc32("VIURczPqsnOEa",13) == 2918857194) strcat(s, "b");
if (crc32("liRsgMaojMPmqr",14) == 1632101885) strcat(s, "U");
if (crc32("wGfKljYFURA",11) == 374525613) strcat(s, "l");
if (crc32("RhEEOXSzPSLnerG",15) == 2592002062) strcat(s, "O");
if (crc32("ZLKzPEj",7) == 86480774) strcat(s, "i");
if (crc32("EGGOhInv",8) == 2355587828) strcat(s, "F");
if (crc32("AfGKh",5) == 2563623642) strcat(s, "n");
if (crc32("zfnVvGq",7) == 1688753708) strcat(s, "p");
if (crc32("tXFIIZk",7) == 2974195907) strcat(s, "d");
    return s;
}

char *multicapitate_adjectives() {
    char *s = calloc(14);
    if (crc32("tmMutCWgD",9) == 3382069974) strcat(s, "m");
if (crc32("SBfwXEGIo",9) == 2299110174) strcat(s, "w");
if (crc32("HyrEX",5) == 123589947) strcat(s, "u");
if (crc32("dzzjpUiZBMic",12) == 3440653653) strcat(s, "l");
if (crc32("ZgAIU",5) == 598606353) strcat(s, "K");
if (crc32("RcgjUmQF",8) == 2395931383) strcat(s, "t");
if (crc32("OFgQwD",6) == 1111446902) strcat(s, "i");
if (crc32("IeLfHEETZyHGe",13) == 1156337471) strcat(s, "z");
if (crc32("esRFsjmrzUojrAd",15) == 3420072079) strcat(s, "c");
if (crc32("NYTaCT",6) == 196859852) strcat(s, "a");
if (crc32("cMyWeuhN",8) == 3657827304) strcat(s, "p");
if (crc32("SIGjmKQ",7) == 1453345553) strcat(s, "i");
if (crc32("WcNFdXy",7) == 3098011970) strcat(s, "t");
if (crc32("BEBJuOCdcFZkKD",14) == 722216840) strcat(s, "a");
if (crc32("yTfDwazTT",9) == 2554181236) strcat(s, "W");
if (crc32("nMgMuU",6) == 3030755984) strcat(s, "t");
if (crc32("IdtZiWmLNpTpbM",14) == 1031739529) strcat(s, "e");
    return s;
}

char *uncombated_adjectives() {
    char *s = calloc(11);
    if (crc32("WxaVYNfQ",8) == 1920405711) strcat(s, "u");
if (crc32("bYRLZrZQQJoyt",13) == 921133002) strcat(s, "n");
if (crc32("LKeBcjgdHKHbHRT",15) == 3081888762) strcat(s, "y");
if (crc32("ufzWBu",6) == 1930325957) strcat(s, "c");
if (crc32("QDAchVtjyXue",12) == 956924427) strcat(s, "S");
if (crc32("bfgNhoVjrDQm",12) == 1930793184) strcat(s, "o");
if (crc32("gCxYMzpCtkVAkb",14) == 184124117) strcat(s, "m");
if (crc32("eMDSgCVAvJAMPx",14) == 620482846) strcat(s, "b");
if (crc32("nFbER",5) == 493333766) strcat(s, "a");
if (crc32("DGTRVQLwfHaU",12) == 1529051299) strcat(s, "w");
if (crc32("pLvdVxzV",8) == 407659150) strcat(s, "t");
if (crc32("TneoQg",6) == 1438778351) strcat(s, "A");
if (crc32("nOYYH",5) == 1396985050) strcat(s, "e");
if (crc32("MSIUvje",7) == 1764521518) strcat(s, "d");
    return s;
}

char *warm_adjectives() {
    char *s = calloc(5);
    if (crc32("OfKaDvJnLiggN",13) == 4061279573) strcat(s, "v");
if (crc32("fZbhTtyTc",9) == 2375710424) strcat(s, "w");
if (crc32("kmZvMNqVNAu",11) == 947634486) strcat(s, "a");
if (crc32("RxpHs",5) == 318776128) strcat(s, "j");
if (crc32("anyXkN",6) == 933100181) strcat(s, "r");
if (crc32("ZjiTgMvmZWoL",12) == 3845242452) strcat(s, "q");
if (crc32("oGKTMYSpgaaJAN",14) == 4158446652) strcat(s, "m");
    return s;
}

char *nonmature_adjectives() {
    char *s = calloc(10);
    if (crc32("cjKDGcgJ",8) == 1928709814) strcat(s, "N");
if (crc32("MeoAOfbxr",9) == 1047863299) strcat(s, "n");
if (crc32("AiJdXqMqfVxIy",13) == 540799767) strcat(s, "p");
if (crc32("MWQNZFzmqlDNvj",14) == 2187483649) strcat(s, "o");
if (crc32("CyOUPwRwIbcMmr",14) == 2675005907) strcat(s, "Q");
if (crc32("sxQuf",5) == 1295837224) strcat(s, "n");
if (crc32("IcLiu",5) == 3948290614) strcat(s, "y");
if (crc32("ZZanGzdVXbaLX",13) == 2146532179) strcat(s, "m");
if (crc32("QGGwMftheVm",11) == 720950903) strcat(s, "a");
if (crc32("qXooYc",6) == 3872605818) strcat(s, "t");
if (crc32("QrebOwJIiHX",11) == 4057784102) strcat(s, "B");
if (crc32("RKZrZGBCpNrG",12) == 3533472659) strcat(s, "u");
if (crc32("momzIdaB",8) == 134189486) strcat(s, "f");
if (crc32("YZoPYsxEuXwCP",13) == 2401841688) strcat(s, "r");
if (crc32("vIolHEt",7) == 4110294001) strcat(s, "e");
    return s;
}

char *imaginational_adjectives() {
    char *s = calloc(14);
    if (crc32("aiiyufaO",8) == 910838669) strcat(s, "i");
if (crc32("XOAOLOvAtJ",10) == 546804715) strcat(s, "f");
if (crc32("fQjuPg",6) == 97566700) strcat(s, "m");
if (crc32("LHpvGMPS",8) == 656148598) strcat(s, "a");
if (crc32("MJSCYmPCkM",10) == 2981192140) strcat(s, "I");
if (crc32("JbeniTleZcX",11) == 3399993030) strcat(s, "g");
if (crc32("htoGLvXIjjbm",12) == 2397706602) strcat(s, "a");
if (crc32("LKDapswoU",9) == 4046910696) strcat(s, "i");
if (crc32("cCNUNrqjWjnZB",13) == 2139170008) strcat(s, "n");
if (crc32("frVEbI",6) == 3178959934) strcat(s, "t");
if (crc32("KvLruslohgp",11) == 2205570904) strcat(s, "a");
if (crc32("DIeSJvNv",8) == 3215593212) strcat(s, "D");
if (crc32("sTfgYPDwwPevxup",15) == 4058905747) strcat(s, "t");
if (crc32("UvuuDizX",8) == 1988422297) strcat(s, "n");
if (crc32("IqdBoTyPthRHcy",14) == 581670483) strcat(s, "i");
if (crc32("jURkQMp",7) == 1106910636) strcat(s, "a");
if (crc32("qXGKtV",6) == 3397955931) strcat(s, "o");
if (crc32("OtzvkzyVJst",11) == 3388791557) strcat(s, "n");
if (crc32("uEubgSwkGxSD",12) == 1746447947) strcat(s, "x");
if (crc32("nxWNIND",7) == 812387058) strcat(s, "a");
if (crc32("jLckoZ",6) == 3361406524) strcat(s, "j");
if (crc32("PbmHyDDnasQLZlq",15) == 3838774262) strcat(s, "l");
    return s;
}

char *laevogyrate_adjectives() {
    char *s = calloc(12);
    if (crc32("qCaKy",5) == 4168103920) strcat(s, "l");
if (crc32("TeZCTuK",7) == 826163021) strcat(s, "a");
if (crc32("ZCBLgGdbbno",11) == 3334272984) strcat(s, "e");
if (crc32("GtPsdDN",7) == 2269486733) strcat(s, "v");
if (crc32("MusGeFkkGJ",10) == 2677516791) strcat(s, "o");
if (crc32("WQzQpiMnLoQX",12) == 4187430286) strcat(s, "E");
if (crc32("RTFhkRAE",8) == 3107156492) strcat(s, "g");
if (crc32("DQAvPnCq",8) == 2329119039) strcat(s, "y");
if (crc32("kWsqzoKRnnEj",12) == 1473097103) strcat(s, "r");
if (crc32("qajDSqO",7) == 765580093) strcat(s, "W");
if (crc32("zlRyZC",6) == 3525059658) strcat(s, "a");
if (crc32("vILFJrfCnoH",11) == 696423788) strcat(s, "t");
if (crc32("aCverqf",7) == 2257306199) strcat(s, "e");
    return s;
}

char *magnipotent_adjectives() {
    char *s = calloc(12);
    if (crc32("EnyPkUapTEeEnLu",15) == 3901623558) strcat(s, "m");
if (crc32("ssouPvVYef",10) == 2505301006) strcat(s, "z");
if (crc32("UPjur",5) == 1423928145) strcat(s, "a");
if (crc32("mUnhvAlHuHy",11) == 3355602911) strcat(s, "K");
if (crc32("SsPJWexoqOxs",12) == 1502174561) strcat(s, "g");
if (crc32("OjnWYSF",7) == 1939569009) strcat(s, "e");
if (crc32("kONuQ",5) == 3751261489) strcat(s, "n");
if (crc32("RflnbbRCIRQdhU",14) == 3013312787) strcat(s, "i");
if (crc32("gsJIQQzU",8) == 2830492346) strcat(s, "t");
if (crc32("kZsDLv",6) == 1256290110) strcat(s, "p");
if (crc32("cdydlMMpsEA",11) == 3048574602) strcat(s, "V");
if (crc32("MBhakNQEHxSK",12) == 1757110315) strcat(s, "o");
if (crc32("TBrHcL",6) == 2330681819) strcat(s, "t");
if (crc32("nhIyqNkJB",9) == 2898169127) strcat(s, "K");
if (crc32("csQUKlONlYl",11) == 834805959) strcat(s, "e");
if (crc32("XPbOMJeXYU",10) == 2755407855) strcat(s, "n");
if (crc32("RAhIVmsGFEIlcuN",15) == 3378542208) strcat(s, "r");
if (crc32("pPBtRGV",7) == 3924618397) strcat(s, "t");
    return s;
}

char *digitigrade_adjectives() {
    char *s = calloc(12);
    if (crc32("XvrjyJ",6) == 1634964584) strcat(s, "u");
if (crc32("FkldDYN",7) == 3180082474) strcat(s, "d");
if (crc32("QhrfJgsYPDp",11) == 2366091148) strcat(s, "i");
if (crc32("zCGASrGtQpffpV",14) == 1203197064) strcat(s, "h");
if (crc32("Dicgmq",6) == 577973741) strcat(s, "g");
if (crc32("wTQMPttUTdV",11) == 4255378351) strcat(s, "H");
if (crc32("qqfROoweQtDE",12) == 60237148) strcat(s, "i");
if (crc32("jNfyVJIf",8) == 767932766) strcat(s, "d");
if (crc32("ipcOkrd",7) == 2261845131) strcat(s, "t");
if (crc32("isfbvP",6) == 1734040891) strcat(s, "i");
if (crc32("KnbDKDTa",8) == 3971395098) strcat(s, "Z");
if (crc32("LLTCVrC",7) == 3095580128) strcat(s, "g");
if (crc32("zUjPYY",6) == 2858547493) strcat(s, "r");
if (crc32("xIGMqmkpP",9) == 2766279810) strcat(s, "a");
if (crc32("iNKUPvgNFFfdPM",14) == 841428559) strcat(s, "s");
if (crc32("oZFUrKsgNYLO",12) == 3166160397) strcat(s, "d");
if (crc32("AgqfCVOevHffAJ",14) == 2635650983) strcat(s, "p");
if (crc32("EPqmT",5) == 1952099814) strcat(s, "e");
    return s;
}

char *sacrarial_adjectives() {
    char *s = calloc(10);
    if (crc32("jCsEoLf",7) == 2454244990) strcat(s, "s");
if (crc32("ZHEeWt",6) == 2659226208) strcat(s, "W");
if (crc32("OdozE",5) == 942207151) strcat(s, "a");
if (crc32("ZbdbVZfmZN",10) == 1969379006) strcat(s, "N");
if (crc32("BPOckjmpXZiU",12) == 4198463963) strcat(s, "c");
if (crc32("dKqQpeNIdysMcMD",15) == 2314000249) strcat(s, "H");
if (crc32("WMrjaA",6) == 4183885845) strcat(s, "r");
if (crc32("eoQQDZEChXARs",13) == 1287859303) strcat(s, "Y");
if (crc32("LvqJcJOCvpGr",12) == 1321765404) strcat(s, "a");
if (crc32("qjFcQoKAESiVszz",15) == 2177638333) strcat(s, "r");
if (crc32("oylNdnAmUJTqZf",14) == 1742144755) strcat(s, "i");
if (crc32("qeBEh",5) == 3876721329) strcat(s, "m");
if (crc32("dMVayBROUnKHfbf",15) == 3450053942) strcat(s, "a");
if (crc32("EeZDnNmo",8) == 1897196643) strcat(s, "l");
    return s;
}

char *awestricken_adjectives() {
    char *s = calloc(12);
    if (crc32("usjecclRPPdEMY",14) == 3097644449) strcat(s, "Y");
if (crc32("CADSWrWN",8) == 2919740906) strcat(s, "a");
if (crc32("kCOmVDn",7) == 3637562297) strcat(s, "w");
if (crc32("PlmmBLtB",8) == 851893530) strcat(s, "e");
if (crc32("cTHFzzNCaeeUAY",14) == 580134893) strcat(s, "s");
if (crc32("FbYcKcth",8) == 3007446886) strcat(s, "G");
if (crc32("PNfjp",5) == 112677467) strcat(s, "t");
if (crc32("XxQwFjggWdW",11) == 2732668746) strcat(s, "M");
if (crc32("RVfSwOdM",8) == 401108821) strcat(s, "r");
if (crc32("IVVkUIJE",8) == 2826448091) strcat(s, "i");
if (crc32("nsPAetmyobE",11) == 3479236884) strcat(s, "c");
if (crc32("KaJSAyUu",8) == 1917819575) strcat(s, "k");
if (crc32("pdCLeQjkQl",10) == 472700571) strcat(s, "c");
if (crc32("xjFEWItyeWLfI",13) == 1028432277) strcat(s, "e");
if (crc32("skXzNWeSQ",9) == 2667213215) strcat(s, "q");
if (crc32("WQlVMpzGr",9) == 1820204546) strcat(s, "n");
    return s;
}

char *teleplasmic_adjectives() {
    char *s = calloc(12);
    if (crc32("RwSFlSS",7) == 163808036) strcat(s, "x");
if (crc32("OkYQnKna",8) == 1411472773) strcat(s, "t");
if (crc32("kkScdllY",8) == 2298303058) strcat(s, "B");
if (crc32("PBxdqvwuMvvfRw",14) == 3932891312) strcat(s, "e");
if (crc32("rkxbNf",6) == 909736686) strcat(s, "l");
if (crc32("vyQIwXGOIthJYhP",15) == 1683644267) strcat(s, "z");
if (crc32("tiLoXTlFI",9) == 1510580329) strcat(s, "e");
if (crc32("TtvhJpdRFsFFL",13) == 331853653) strcat(s, "F");
if (crc32("AGZSlyV",7) == 4218349691) strcat(s, "p");
if (crc32("UvWoEOb",7) == 3618357558) strcat(s, "b");
if (crc32("pkeEZivFX",9) == 3125991759) strcat(s, "l");
if (crc32("mRhQrHlbpFEHfr",14) == 1036701878) strcat(s, "x");
if (crc32("OXjiSqPjazXDR",13) == 1122450698) strcat(s, "a");
if (crc32("pQidkONBwS",10) == 3261094884) strcat(s, "z");
if (crc32("yGpLYtR",7) == 1938484749) strcat(s, "s");
if (crc32("GTNDR",5) == 3461217771) strcat(s, "m");
if (crc32("ghSXiXcIMWKhk",13) == 900870) strcat(s, "m");
if (crc32("wSSdyfzx",8) == 3863031784) strcat(s, "i");
if (crc32("NRaXOnL",7) == 4052832998) strcat(s, "p");
if (crc32("BCBlNPEe",8) == 3263851295) strcat(s, "c");
    return s;
}

char *uneradicated_adjectives() {
    char *s = calloc(13);
    if (crc32("kmMKeIcQgBii",12) == 434331232) strcat(s, "u");
if (crc32("XbPXOiCeAdT",11) == 2612089523) strcat(s, "V");
if (crc32("GbpkeL",6) == 137406814) strcat(s, "n");
if (crc32("qrYpMctPK",9) == 3547739557) strcat(s, "e");
if (crc32("MnjNyaGeqtOHfeV",15) == 1515928627) strcat(s, "r");
if (crc32("ihYlFyCSNsDz",12) == 2565269117) strcat(s, "d");
if (crc32("TeTUv",5) == 307651155) strcat(s, "a");
if (crc32("ZpnPQpsRw",9) == 4014562230) strcat(s, "h");
if (crc32("ewQKZHBFCm",10) == 4157440891) strcat(s, "d");
if (crc32("eCjwPdmtyWPIts",14) == 1467913096) strcat(s, "a");
if (crc32("OhAwvI",6) == 3808248671) strcat(s, "i");
if (crc32("iWoxqSKwje",10) == 246127428) strcat(s, "c");
if (crc32("upAwkzKgPDBdwz",14) == 2533202743) strcat(s, "t");
if (crc32("WuMLVLdtPhO",11) == 3959842727) strcat(s, "a");
if (crc32("TZDcrujbzwxRkoH",15) == 3240532823) strcat(s, "t");
if (crc32("jUZDGSRmMhykpBB",15) == 2421032162) strcat(s, "c");
if (crc32("RYtIlJXyqL",10) == 145873081) strcat(s, "e");
if (crc32("drmxRCUKK",9) == 1466268055) strcat(s, "d");
    return s;
}

char *subpredicative_adjectives() {
    char *s = calloc(15);
    if (crc32("TsnQVMQNuHP",11) == 1060747959) strcat(s, "s");
if (crc32("UqwgoMaE",8) == 3649315222) strcat(s, "I");
if (crc32("RvUTMtLFTfjp",12) == 255155894) strcat(s, "u");
if (crc32("zPfpvzjggzfwBWc",15) == 729294212) strcat(s, "X");
if (crc32("cfZdeNzsl",9) == 2999633589) strcat(s, "b");
if (crc32("pfpCyNM",7) == 3798857847) strcat(s, "p");
if (crc32("LwTpqvHHrYu",11) == 681387476) strcat(s, "N");
if (crc32("uDbfQRXHQKqsJsB",15) == 2553678670) strcat(s, "r");
if (crc32("ftvtghLHq",9) == 1293252772) strcat(s, "r");
if (crc32("BVUzXIg",7) == 4036767544) strcat(s, "e");
if (crc32("InzqDBKwk",9) == 2206210437) strcat(s, "d");
if (crc32("cNbwFgSUWewWH",13) == 442692779) strcat(s, "i");
if (crc32("hIcJBveBKNzjN",13) == 3026033241) strcat(s, "c");
if (crc32("kygoyjEY",8) == 1393482482) strcat(s, "a");
if (crc32("bKgKvhTWJa",10) == 1423861859) strcat(s, "K");
if (crc32("URgzMhLFSAM",11) == 3085897581) strcat(s, "t");
if (crc32("KrMxGoSccWuDNSL",15) == 527413326) strcat(s, "U");
if (crc32("FaAXAIiGyIivfb",14) == 1624780303) strcat(s, "i");
if (crc32("ADCsdmCuTjEKuSb",15) == 2883735667) strcat(s, "n");
if (crc32("NUScrxhqlC",10) == 952047567) strcat(s, "v");
if (crc32("GwnZAeTtKfMsor",14) == 54644243) strcat(s, "L");
if (crc32("StFjNirSKCwr",12) == 3758014595) strcat(s, "e");
    return s;
}

char *postseason_adjectives() {
    char *s = calloc(11);
    if (crc32("hnwpzkwWItTm",12) == 3273315832) strcat(s, "p");
if (crc32("wYCzmrzYR",9) == 139373136) strcat(s, "Y");
if (crc32("cSNkQliWVocgO",13) == 3842075934) strcat(s, "o");
if (crc32("wwjxpskJCxVUjxV",15) == 2941076968) strcat(s, "s");
if (crc32("KafIGRfOoLvS",12) == 124256376) strcat(s, "t");
if (crc32("NObeaUVd",8) == 2011327339) strcat(s, "l");
if (crc32("vlNjM",5) == 742110211) strcat(s, "s");
if (crc32("bkhfTT",6) == 436546669) strcat(s, "e");
if (crc32("ZBrMGmlCgrH",11) == 3475499553) strcat(s, "a");
if (crc32("lzZgoaoiB",9) == 692980442) strcat(s, "Q");
if (crc32("igsOiWEtm",9) == 596653287) strcat(s, "s");
if (crc32("SolbFUhpaHVgONx",15) == 2097111092) strcat(s, "o");
if (crc32("kwlLyVA",7) == 1487220293) strcat(s, "F");
if (crc32("wUwSywsMhJu",11) == 2016340851) strcat(s, "n");
    return s;
}

char *nonlarcenous_adjectives() {
    char *s = calloc(13);
    if (crc32("QOguRjKyaulrWy",14) == 1399471942) strcat(s, "n");
if (crc32("saoMuQgsh",9) == 3040769959) strcat(s, "o");
if (crc32("PMDblTlYE",9) == 3876855328) strcat(s, "n");
if (crc32("rooqOHKQknzAIbm",15) == 2679872615) strcat(s, "s");
if (crc32("VfeAkOOFQVqni",13) == 91240780) strcat(s, "l");
if (crc32("RaSwUbmfh",9) == 4092268835) strcat(s, "a");
if (crc32("bIaUDWCoIOSAJn",14) == 2084338416) strcat(s, "D");
if (crc32("SOKAASXgjykgwv",14) == 2439296486) strcat(s, "r");
if (crc32("JgeWKl",6) == 110208845) strcat(s, "c");
if (crc32("rQUKN",5) == 3726588535) strcat(s, "e");
if (crc32("MZYXhcjDZuEfT",13) == 2412473905) strcat(s, "n");
if (crc32("WcRQuzsqiVcOC",13) == 1627270155) strcat(s, "o");
if (crc32("HkjmqWHGXRieKnX",15) == 1824148745) strcat(s, "B");
if (crc32("GRwaMGMmr",9) == 287595412) strcat(s, "u");
if (crc32("qjkXbbYWMmKiiC",14) == 3890924584) strcat(s, "P");
if (crc32("NOlfuDPMT",9) == 4067884140) strcat(s, "s");
    return s;
}

char *unpacifiable_adjectives() {
    char *s = calloc(13);
    if (crc32("ALwVTIBye",9) == 2081094221) strcat(s, "y");
if (crc32("IGpRllDwpIzqI",13) == 3601368850) strcat(s, "u");
if (crc32("cCEdPSToeEUOdH",14) == 2118170895) strcat(s, "g");
if (crc32("BSkLVINbHALlj",13) == 1579526426) strcat(s, "n");
if (crc32("rSQAhGYFnVF",11) == 261855875) strcat(s, "p");
if (crc32("TvbwEZsG",8) == 343124133) strcat(s, "a");
if (crc32("dLrwGmtD",8) == 2253509702) strcat(s, "j");
if (crc32("HGiGsYoqygePf",13) == 3346843196) strcat(s, "c");
if (crc32("dvmeuuXNLMj",11) == 3606196701) strcat(s, "N");
if (crc32("rRXxqveQrdxV",12) == 734010057) strcat(s, "i");
if (crc32("qbbpnUYnjPP",11) == 487665942) strcat(s, "K");
if (crc32("wzanbpBAq",9) == 1708653664) strcat(s, "f");
if (crc32("GIDGhbDO",8) == 776273590) strcat(s, "i");
if (crc32("jkbqHdqnieAGoty",15) == 1916758834) strcat(s, "a");
if (crc32("jfMDTZR",7) == 2275533475) strcat(s, "g");
if (crc32("PGasaXY",7) == 1492959881) strcat(s, "b");
if (crc32("MomOYJrNxU",10) == 2360253798) strcat(s, "l");
if (crc32("SDRyqRmqP",9) == 546328315) strcat(s, "e");
    return s;
}

char *Helvetic_adjectives() {
    char *s = calloc(9);
    if (crc32("KHUqQZsFzh",10) == 3351168327) strcat(s, "S");
if (crc32("MtzGFISg",8) == 209919313) strcat(s, "H");
if (crc32("OHkUCguwwUxeak",14) == 1359281845) strcat(s, "e");
if (crc32("aCfTwgR",7) == 2501593496) strcat(s, "l");
if (crc32("evAaCyjQUdYPcH",14) == 66307284) strcat(s, "Z");
if (crc32("WGiencaDW",9) == 3001752250) strcat(s, "v");
if (crc32("zIXkEZvGfTpjQs",14) == 3878507213) strcat(s, "J");
if (crc32("HipbQzWnMPRW",12) == 2091015145) strcat(s, "e");
if (crc32("rkfir",5) == 4017701852) strcat(s, "t");
if (crc32("MDKiuBAbVYBUCKI",15) == 3282353707) strcat(s, "i");
if (crc32("PtUafYwAvRXot",13) == 1058650741) strcat(s, "J");
if (crc32("pUMLtEHX",8) == 1497776184) strcat(s, "c");
    return s;
}

char *nontrailing_adjectives() {
    char *s = calloc(12);
    if (crc32("zssGfjLZTCqzPk",14) == 2882455932) strcat(s, "w");
if (crc32("CzMwlayXMZ",10) == 155724903) strcat(s, "n");
if (crc32("xfkrsHhV",8) == 3563507246) strcat(s, "N");
if (crc32("DcJfTC",6) == 1919443957) strcat(s, "o");
if (crc32("XRMYPZXcX",9) == 3820089434) strcat(s, "n");
if (crc32("sdjhuTomMLq",11) == 3873813567) strcat(s, "t");
if (crc32("LvzjTytXbdvuCfk",15) == 1161793846) strcat(s, "t");
if (crc32("gImhbDjlw",9) == 1408427154) strcat(s, "r");
if (crc32("YyxWDkYVGHyprwU",15) == 275460083) strcat(s, "a");
if (crc32("dgbMDsvbHiVVMNH",15) == 871312585) strcat(s, "i");
if (crc32("LcHJRXTcWQvLTd",14) == 1834377525) strcat(s, "o");
if (crc32("mmeTrMMo",8) == 1890159553) strcat(s, "l");
if (crc32("TfSjLlO",7) == 371202488) strcat(s, "n");
if (crc32("SQZVSWRl",8) == 1571639913) strcat(s, "i");
if (crc32("WTpvrUigm",9) == 826124239) strcat(s, "n");
if (crc32("QRUAdlNU",8) == 4047940082) strcat(s, "g");
    return s;
}

char *hoodlike_adjectives() {
    char *s = calloc(9);
    if (crc32("vYaJuEti",8) == 1026952582) strcat(s, "h");
if (crc32("lNhiSmloT",9) == 1004030814) strcat(s, "i");
if (crc32("DCjlRn",6) == 227122666) strcat(s, "o");
if (crc32("plDAFnsflXCdlGL",15) == 2834405935) strcat(s, "m");
if (crc32("seBCCNNRr",9) == 3312376680) strcat(s, "o");
if (crc32("DJbOOGTM",8) == 2046912576) strcat(s, "o");
if (crc32("mVCGPguJqSfexg",14) == 2769032701) strcat(s, "d");
if (crc32("ujakRlG",7) == 2047265520) strcat(s, "N");
if (crc32("lHwmkGWCe",9) == 1558043291) strcat(s, "l");
if (crc32("yYaGjvjM",8) == 1045286398) strcat(s, "K");
if (crc32("geaaofxym",9) == 979002179) strcat(s, "i");
if (crc32("azGYpY",6) == 3501938808) strcat(s, "Q");
if (crc32("IbrWvjGNha",10) == 504913397) strcat(s, "k");
if (crc32("FemYSAdC",8) == 2492677965) strcat(s, "e");
    return s;
}

char *liege_adjectives() {
    char *s = calloc(6);
    if (crc32("CaMjSiXEW",9) == 4074289550) strcat(s, "U");
if (crc32("lbcKlDwAwM",10) == 2135572247) strcat(s, "l");
if (crc32("JvQQCUnXD",9) == 4206640654) strcat(s, "U");
if (crc32("xOUhFWFKW",9) == 3682195228) strcat(s, "i");
if (crc32("aJYoHcUQc",9) == 3053274505) strcat(s, "v");
if (crc32("rYgshBkDbzMGFp",14) == 2095961188) strcat(s, "e");
if (crc32("HiiSnJWnZH",10) == 4174926299) strcat(s, "U");
if (crc32("VcEDlCnsDauU",12) == 4031332293) strcat(s, "g");
if (crc32("aLgQBbrqnGs",11) == 764518710) strcat(s, "e");
    return s;
}

char *hyperprognathous_adjectives() {
    char *s = calloc(17);
    if (crc32("MUNYL",5) == 4102414105) strcat(s, "h");
if (crc32("jSiybbVJP",9) == 3187605842) strcat(s, "y");
if (crc32("JRDcRtAgL",9) == 110295390) strcat(s, "p");
if (crc32("MXzryVHI",8) == 2811081632) strcat(s, "e");
if (crc32("uHrZzbEaeBYvABD",15) == 2790349614) strcat(s, "T");
if (crc32("LvAqLqpZDJlzH",13) == 1100534946) strcat(s, "r");
if (crc32("YDugJeNzqiUpC",13) == 1266410904) strcat(s, "p");
if (crc32("UohDfbinSp",10) == 934298232) strcat(s, "T");
if (crc32("avEGxKceIgHO",12) == 2409210339) strcat(s, "r");
if (crc32("dzfpe",5) == 2302105110) strcat(s, "C");
if (crc32("zilrCu",6) == 1390933960) strcat(s, "o");
if (crc32("hMTHEVe",7) == 2100446274) strcat(s, "D");
if (crc32("YNLodhfg",8) == 1249300797) strcat(s, "g");
if (crc32("CMyDhzSNXUYlV",13) == 2451066440) strcat(s, "n");
if (crc32("kbDujn",6) == 486195744) strcat(s, "z");
if (crc32("NKuVAxCq",8) == 1989792752) strcat(s, "a");
if (crc32("LOEEMaoOjOgUb",13) == 1068647472) strcat(s, "U");
if (crc32("mbbCe",5) == 2607869238) strcat(s, "t");
if (crc32("kUBwcxXysCl",11) == 544434829) strcat(s, "V");
if (crc32("ElTYvoo",7) == 3773529313) strcat(s, "h");
if (crc32("iXXWU",5) == 3505247372) strcat(s, "o");
if (crc32("sFktizsKcTxyNx",14) == 3879128463) strcat(s, "u");
if (crc32("NwDczHCbfoVUr",13) == 2405939681) strcat(s, "s");
    return s;
}

char *hyperstoical_adjectives() {
    char *s = calloc(13);
    if (crc32("qHxlQwo",7) == 1971115404) strcat(s, "G");
if (crc32("dCvsBrhqcR",10) == 3400559840) strcat(s, "h");
if (crc32("HQPRQTiAQMHQQEr",15) == 2435453108) strcat(s, "w");
if (crc32("YeqrWvKRvGNd",12) == 3572056952) strcat(s, "y");
if (crc32("ZaYYraeQNDYMc",13) == 341358368) strcat(s, "p");
if (crc32("NMnwpgai",8) == 1808447449) strcat(s, "e");
if (crc32("vOzMuuaSSIdESu",14) == 2188871588) strcat(s, "r");
if (crc32("fGmLUFmCTUG",11) == 3668600415) strcat(s, "b");
if (crc32("adSLEtMni",9) == 1342928769) strcat(s, "s");
if (crc32("jANeNhE",7) == 1275265151) strcat(s, "t");
if (crc32("HulXylSkL",9) == 3671814586) strcat(s, "p");
if (crc32("IfkhnDJJPX",10) == 1386653219) strcat(s, "o");
if (crc32("vrLrpOPjvdCPq",13) == 3742868653) strcat(s, "b");
if (crc32("VldVJdAPYE",10) == 433661032) strcat(s, "i");
if (crc32("PMBnOqWujLjEZ",13) == 817584005) strcat(s, "a");
if (crc32("BmKRxE",6) == 1351473723) strcat(s, "c");
if (crc32("bIFRbdGNiJHsdo",14) == 696110007) strcat(s, "E");
if (crc32("BJZGtczXAYlqHYb",15) == 916165669) strcat(s, "a");
if (crc32("xdKGIhv",7) == 2473035339) strcat(s, "l");
    return s;
}

char *nonharmonious_adjectives() {
    char *s = calloc(14);
    if (crc32("vkvFgbfKhiMGjR",14) == 3110777423) strcat(s, "j");
if (crc32("ZDxHklfhcVwLZa",14) == 3863606747) strcat(s, "n");
if (crc32("oBtxfD",6) == 1615344429) strcat(s, "U");
if (crc32("PVRoMwmLzuL",11) == 92492055) strcat(s, "o");
if (crc32("tiBbSet",7) == 3948124243) strcat(s, "s");
if (crc32("tPJEGnQGQ",9) == 1586379799) strcat(s, "n");
if (crc32("iedrWS",6) == 725749947) strcat(s, "h");
if (crc32("FIPbGGmWNzFqD",13) == 2700650032) strcat(s, "a");
if (crc32("onUoIGrR",8) == 4226057280) strcat(s, "r");
if (crc32("PBtOU",5) == 2105401186) strcat(s, "I");
if (crc32("lCUoq",5) == 3159441435) strcat(s, "m");
if (crc32("JzTxRwT",7) == 3623271060) strcat(s, "o");
if (crc32("huKBrNnNwr",10) == 3796665786) strcat(s, "n");
if (crc32("RmLHsroBkaaZ",12) == 497949438) strcat(s, "U");
if (crc32("xlrvveFWjQyq",12) == 1925253994) strcat(s, "i");
if (crc32("fGqGGQ",6) == 3057806575) strcat(s, "d");
if (crc32("AXrZgeMLCuz",11) == 1006372053) strcat(s, "o");
if (crc32("VnPnRrn",7) == 2858335364) strcat(s, "I");
if (crc32("DnmJIQmnI",9) == 1989625234) strcat(s, "u");
if (crc32("nwrajQti",8) == 770459548) strcat(s, "s");
    return s;
}

char *fibriform_adjectives() {
    char *s = calloc(10);
    if (crc32("iwLxDmse",8) == 1606599614) strcat(s, "f");
if (crc32("LoBoPtcFdGJ",11) == 1074623604) strcat(s, "t");
if (crc32("sxVgJikvUwMHn",13) == 3038585401) strcat(s, "i");
if (crc32("rVlOLanGmzpbZ",13) == 863133618) strcat(s, "b");
if (crc32("TYTBMcLrRBug",12) == 1728730685) strcat(s, "r");
if (crc32("iOJBRYeVTN",10) == 27807370) strcat(s, "o");
if (crc32("xjFWBGpSZUGTZSa",15) == 1937633698) strcat(s, "i");
if (crc32("GwozudeU",8) == 901887506) strcat(s, "f");
if (crc32("wuasKmHHFkJVsZG",15) == 2275749320) strcat(s, "M");
if (crc32("xGKGGDBjB",9) == 1342182604) strcat(s, "o");
if (crc32("VhfBAEqlER",10) == 3138977916) strcat(s, "r");
if (crc32("OuRkrhlcC",9) == 1218655938) strcat(s, "m");
    return s;
}

char *spined_adjectives() {
    char *s = calloc(7);
    if (crc32("IHKAWnMhS",9) == 3866087011) strcat(s, "f");
if (crc32("wNtMmagYg",9) == 4063390526) strcat(s, "s");
if (crc32("IRJDuWlbM",9) == 2383047148) strcat(s, "p");
if (crc32("KOiNYPDuSDu",11) == 2891514277) strcat(s, "i");
if (crc32("oxSQYmrU",8) == 4154739407) strcat(s, "W");
if (crc32("uBhChiVGVzPDsm",14) == 3246205232) strcat(s, "n");
if (crc32("bOeJL",5) == 3712432292) strcat(s, "e");
if (crc32("JekzHIgLpG",10) == 392277150) strcat(s, "d");
    return s;
}

char *sparsest_adjectives() {
    char *s = calloc(9);
    if (crc32("iVWpyjBjcWvU",12) == 4264133887) strcat(s, "Z");
if (crc32("RXaRj",5) == 3870775932) strcat(s, "s");
if (crc32("wVpMBcJA",8) == 1479686418) strcat(s, "p");
if (crc32("vUfWaovdm",9) == 610405583) strcat(s, "a");
if (crc32("XegViHqzp",9) == 959072087) strcat(s, "r");
if (crc32("HNqKkmUWQrCOZm",14) == 349769772) strcat(s, "s");
if (crc32("sFcrUB",6) == 3661239483) strcat(s, "w");
if (crc32("IIJBveeUxl",10) == 3508103219) strcat(s, "e");
if (crc32("tqkgW",5) == 2193779485) strcat(s, "s");
if (crc32("uaZeinhYgWF",11) == 2984946703) strcat(s, "t");
    return s;
}

char *musteline_adjectives() {
    char *s = calloc(10);
    if (crc32("DsiQNRMUhA",10) == 3553058336) strcat(s, "a");
if (crc32("CUvdwSobC",9) == 1775400722) strcat(s, "m");
if (crc32("JNSAXdujcEkJPpN",15) == 596290860) strcat(s, "u");
if (crc32("EGuLqutDW",9) == 1708676980) strcat(s, "e");
if (crc32("cWrtl",5) == 373874724) strcat(s, "s");
if (crc32("ygxvvDEZU",9) == 758857113) strcat(s, "t");
if (crc32("ENaEtkPlIzV",11) == 2215194009) strcat(s, "H");
if (crc32("zNarHMniaKOZft",14) == 3906367810) strcat(s, "e");
if (crc32("aCtAtwgdI",9) == 1551127381) strcat(s, "i");
if (crc32("HCtySkaNd",9) == 4009720650) strcat(s, "l");
if (crc32("JnZeDwppEt",10) == 2974210007) strcat(s, "m");
if (crc32("fDdiYawqahHUHH",14) == 609530505) strcat(s, "i");
if (crc32("hQuGoPEJWQoa",12) == 3264490434) strcat(s, "n");
if (crc32("XfQCGVBRzfG",11) == 755888136) strcat(s, "e");
    return s;
}

char *undandled_adjectives() {
    char *s = calloc(10);
    if (crc32("xyHlTwNFO",9) == 394325633) strcat(s, "u");
if (crc32("SfxBLPU",7) == 1903785760) strcat(s, "n");
if (crc32("vKkmk",5) == 64192749) strcat(s, "X");
if (crc32("kGsrP",5) == 248925516) strcat(s, "d");
if (crc32("gVmMcl",6) == 2830794864) strcat(s, "a");
if (crc32("ZkHCnrouLy",10) == 3175882302) strcat(s, "z");
if (crc32("QAOniWMGQAunn",13) == 1191645344) strcat(s, "n");
if (crc32("EcjjVckeoVWYL",13) == 1549737976) strcat(s, "k");
if (crc32("dLMSSRPDGz",10) == 3627718101) strcat(s, "d");
if (crc32("fupWPHnvQTm",11) == 1155796137) strcat(s, "l");
if (crc32("LkAIKQjeURvEPUb",15) == 2176240295) strcat(s, "g");
if (crc32("tnkJMHsAjKr",11) == 1072862421) strcat(s, "e");
if (crc32("qGbtFohBuM",10) == 150025402) strcat(s, "r");
if (crc32("JbGotweq",8) == 1107431838) strcat(s, "d");
    return s;
}

char *quasioriental_adjectives() {
    char *s = calloc(14);
    if (crc32("ijrWWQwhHRcmpHL",15) == 2380684817) strcat(s, "q");
if (crc32("bnwRgsAlSOBbGBj",15) == 33869141) strcat(s, "u");
if (crc32("dxjrDWJwnGqc",12) == 4007080095) strcat(s, "a");
if (crc32("PTLfei",6) == 2868158710) strcat(s, "V");
if (crc32("xpfWlIoj",8) == 3822615329) strcat(s, "s");
if (crc32("tdDgmRaRlpQ",11) == 3100637411) strcat(s, "i");
if (crc32("rUsPcLUuxkZAMnu",15) == 1299784526) strcat(s, "p");
if (crc32("GNHkWSrcxJC",11) == 2231656206) strcat(s, "o");
if (crc32("mVVjoWEmQIt",11) == 3899963903) strcat(s, "n");
if (crc32("ubsGeBvxnE",10) == 2977493586) strcat(s, "r");
if (crc32("xemARe",6) == 1686287504) strcat(s, "f");
if (crc32("RhzXGInA",8) == 3952042521) strcat(s, "i");
if (crc32("PPNiCMm",7) == 399671211) strcat(s, "e");
if (crc32("VeEeLwCi",8) == 1323596258) strcat(s, "n");
if (crc32("OmseJxJaDVblF",13) == 1474368324) strcat(s, "X");
if (crc32("SEMeaQ",6) == 3961765484) strcat(s, "t");
if (crc32("WUPJa",5) == 3965567911) strcat(s, "a");
if (crc32("enpUOpztrjk",11) == 2913075404) strcat(s, "f");
if (crc32("zAqQWGuHnfXr",12) == 1747262586) strcat(s, "l");
    return s;
}

char *diaphragmatic_adjectives() {
    char *s = calloc(14);
    if (crc32("IgoDmExo",8) == 3435583488) strcat(s, "d");
if (crc32("OGSwXQfgYYZKdD",14) == 3140909097) strcat(s, "i");
if (crc32("lshYdudVFDVA",12) == 4261901631) strcat(s, "k");
if (crc32("aCESQovAvVH",11) == 761046259) strcat(s, "a");
if (crc32("lgGivDoGQobPK",13) == 577448138) strcat(s, "p");
if (crc32("oAaZUQw",7) == 1195149962) strcat(s, "Q");
if (crc32("IlfOYzvpg",9) == 2550178253) strcat(s, "h");
if (crc32("dcoETxHgBH",10) == 2318394679) strcat(s, "B");
if (crc32("zFaimmKFUgL",11) == 2430902675) strcat(s, "r");
if (crc32("nfhDzMDGlS",10) == 1168192933) strcat(s, "Z");
if (crc32("SeaLcfPNhBo",11) == 4136769172) strcat(s, "a");
if (crc32("MUKHq",5) == 4194267891) strcat(s, "g");
if (crc32("KZoNghc",7) == 45280041) strcat(s, "U");
if (crc32("OnrsZwnySoPku",13) == 2411404114) strcat(s, "m");
if (crc32("VOPixUjqYSVIshS",15) == 107919695) strcat(s, "a");
if (crc32("xTldyOfPo",9) == 3207905112) strcat(s, "t");
if (crc32("OJihPsWQ",8) == 2273220099) strcat(s, "Y");
if (crc32("VEoIQNRI",8) == 3257005742) strcat(s, "i");
if (crc32("lqDPhMG",7) == 300527140) strcat(s, "s");
if (crc32("XDJRdCESAbukLG",14) == 2246678015) strcat(s, "c");
    return s;
}

char *legit_adjectives() {
    char *s = calloc(6);
    if (crc32("VNHaMuXhyjFCjE",14) == 2876128725) strcat(s, "l");
if (crc32("aqQVcUFnCaM",11) == 304781803) strcat(s, "l");
if (crc32("cgcfkV",6) == 1970855640) strcat(s, "e");
if (crc32("emqImidOym",10) == 3032440193) strcat(s, "w");
if (crc32("FmkUrCKvZxGU",12) == 4244195488) strcat(s, "g");
if (crc32("TYkUBgTLdCuW",12) == 418639224) strcat(s, "i");
if (crc32("qtsGTewDFdC",11) == 2760937423) strcat(s, "l");
if (crc32("HOQMNsYAO",9) == 3082764385) strcat(s, "t");
    return s;
}

char *circumnavigable_adjectives() {
    char *s = calloc(16);
    if (crc32("uQNvtNA",7) == 1906323913) strcat(s, "c");
if (crc32("pJokEEXUY",9) == 976718516) strcat(s, "i");
if (crc32("AhxoPfGVhQ",10) == 2990844204) strcat(s, "r");
if (crc32("yIXjRjSBxpz",11) == 2455799774) strcat(s, "c");
if (crc32("KJWvwLv",7) == 97554873) strcat(s, "u");
if (crc32("lJihxpGIsG",10) == 2677144493) strcat(s, "m");
if (crc32("hTweRYku",8) == 19399884) strcat(s, "T");
if (crc32("PaNOySkQaE",10) == 927309048) strcat(s, "n");
if (crc32("iOdqrFd",7) == 2046069113) strcat(s, "a");
if (crc32("iaQadTB",7) == 3274764487) strcat(s, "x");
if (crc32("KAFsNySNLF",10) == 3742666545) strcat(s, "v");
if (crc32("fiIRtGf",7) == 2436771391) strcat(s, "o");
if (crc32("qatLdIJculNWolL",15) == 607003421) strcat(s, "i");
if (crc32("ABifKW",6) == 3137547969) strcat(s, "g");
if (crc32("LddjntKaG",9) == 1985354789) strcat(s, "a");
if (crc32("xGZAs",5) == 1208404275) strcat(s, "b");
if (crc32("PnvfDm",6) == 1045872462) strcat(s, "l");
if (crc32("AqxqKM",6) == 1361875170) strcat(s, "e");
    return s;
}

char *exclusive_adjectives() {
    char *s = calloc(10);
    if (crc32("dQBKdHo",7) == 3251738963) strcat(s, "l");
if (crc32("qYblUPmZCpp",11) == 1366041605) strcat(s, "e");
if (crc32("hKqwyIACJRC",11) == 1714437020) strcat(s, "Z");
if (crc32("LEepfOzzwIhv",12) == 238281979) strcat(s, "x");
if (crc32("RxLyRdSQpAt",11) == 712380549) strcat(s, "o");
if (crc32("GFxAMNxkbnyG",12) == 1203258962) strcat(s, "c");
if (crc32("UcMbIekcAUReQL",14) == 1818748248) strcat(s, "W");
if (crc32("mynOzJymFuRC",12) == 2637952470) strcat(s, "l");
if (crc32("XSnZMI",6) == 3440611610) strcat(s, "F");
if (crc32("eMXkjrfABNVGzT",14) == 28868134) strcat(s, "u");
if (crc32("otJtEwRn",8) == 162288400) strcat(s, "s");
if (crc32("yINKGQ",6) == 1817981469) strcat(s, "i");
if (crc32("DqEIZuUxNPkeF",13) == 1916158543) strcat(s, "v");
if (crc32("whYsJv",6) == 593739854) strcat(s, "J");
if (crc32("RhefctHMwUt",11) == 1662981244) strcat(s, "e");
    return s;
}

char *irregular_adjectives() {
    char *s = calloc(10);
    if (crc32("wWpBWVzNOdyCC",13) == 487311563) strcat(s, "i");
if (crc32("eCphSM",6) == 1118311533) strcat(s, "r");
if (crc32("zRjcPjAmkEX",11) == 3617299559) strcat(s, "r");
if (crc32("HGdzKOePsmXGaXK",15) == 2463832373) strcat(s, "e");
if (crc32("AbaMNH",6) == 2064742811) strcat(s, "g");
if (crc32("TfsviOoSXlj",11) == 1323443228) strcat(s, "t");
if (crc32("ymBmXoUpKj",10) == 676637484) strcat(s, "u");
if (crc32("AieCAwvLSZLP",12) == 686770222) strcat(s, "l");
if (crc32("CZhbUgqutQ",10) == 3693744829) strcat(s, "D");
if (crc32("ODxeeNGjbSj",11) == 1327511282) strcat(s, "a");
if (crc32("ahyLOXcgW",9) == 3234525499) strcat(s, "P");
if (crc32("JOTbQeKPJVPbLOp",15) == 716910075) strcat(s, "r");
    return s;
}

char *unrecollected_adjectives() {
    char *s = calloc(14);
    if (crc32("EQzaGEfZj",9) == 1258182352) strcat(s, "D");
if (crc32("dbfGoGTq",8) == 4136755472) strcat(s, "u");
if (crc32("ZERtpzSEtINjK",13) == 3159358208) strcat(s, "l");
if (crc32("MwoSq",5) == 1706438880) strcat(s, "n");
if (crc32("qaIYPtgctGFUs",13) == 3026607926) strcat(s, "N");
if (crc32("wILVpdX",7) == 3745615996) strcat(s, "r");
if (crc32("ZxbgOKDiffSe",12) == 2471439171) strcat(s, "g");
if (crc32("seQenrJBTFqtr",13) == 1039994340) strcat(s, "e");
if (crc32("qToqL",5) == 1278898054) strcat(s, "c");
if (crc32("wfECH",5) == 2705792143) strcat(s, "T");
if (crc32("pKvyvtAEv",9) == 372710082) strcat(s, "o");
if (crc32("CoJzDioZaPwy",12) == 2372413448) strcat(s, "l");
if (crc32("PDxiudRO",8) == 2395125712) strcat(s, "l");
if (crc32("rzrTzADuW",9) == 2562572681) strcat(s, "O");
if (crc32("UeZuodsm",8) == 650622686) strcat(s, "e");
if (crc32("bHLBPoPA",8) == 3913756002) strcat(s, "c");
if (crc32("xXTPeoEOIMo",11) == 1926115779) strcat(s, "w");
if (crc32("wBdEVImABneF",12) == 2389198389) strcat(s, "t");
if (crc32("xtzRUoTTRg",10) == 1494686778) strcat(s, "Z");
if (crc32("yJUsIKav",8) == 2334427079) strcat(s, "e");
if (crc32("pRiqkO",6) == 2336515146) strcat(s, "d");
    return s;
}

char *histographic_adjectives() {
    char *s = calloc(13);
    if (crc32("NQKqibwxzgA",11) == 1228411020) strcat(s, "h");
if (crc32("eRuezxJAwqsJGzG",15) == 3483519183) strcat(s, "b");
if (crc32("oYDvMvl",7) == 1830245908) strcat(s, "i");
if (crc32("gFaBcbVVakDt",12) == 4228871197) strcat(s, "s");
if (crc32("hKXjPgKxD",9) == 3093984866) strcat(s, "t");
if (crc32("suOiUIpGAVL",11) == 3929728972) strcat(s, "u");
if (crc32("wQRARsd",7) == 872365264) strcat(s, "o");
if (crc32("ytXzhLpcsGblIc",14) == 1730823294) strcat(s, "g");
if (crc32("zDVuduwmZUcop",13) == 852127678) strcat(s, "r");
if (crc32("VwShcjh",7) == 810873901) strcat(s, "f");
if (crc32("lpBbzvBEqUXVlv",14) == 552941219) strcat(s, "a");
if (crc32("oZKsByjkUHpB",12) == 3691744828) strcat(s, "J");
if (crc32("HbZhqiyYtFSYzjc",15) == 3169926625) strcat(s, "p");
if (crc32("ZIwOme",6) == 717137958) strcat(s, "y");
if (crc32("fvOkwD",6) == 2412207769) strcat(s, "h");
if (crc32("TmsjCchkVXgi",12) == 3670322843) strcat(s, "W");
if (crc32("BhWvBOAsB",9) == 582358008) strcat(s, "i");
if (crc32("pvPBJQdCxmiRQj",14) == 4285205076) strcat(s, "c");
    return s;
}

char *undetractory_adjectives() {
    char *s = calloc(13);
    if (crc32("EWuAKdpT",8) == 2627959177) strcat(s, "u");
if (crc32("VfGGvcOzUeP",11) == 3706357727) strcat(s, "I");
if (crc32("ijWyCJcOhmMPYI",14) == 1018720867) strcat(s, "n");
if (crc32("ixWjjESdVY",10) == 2109298104) strcat(s, "m");
if (crc32("ohHcoNfjEK",10) == 1301743041) strcat(s, "d");
if (crc32("OebjtuNeECOcD",13) == 3017959518) strcat(s, "e");
if (crc32("QYyFcrl",7) == 1785635427) strcat(s, "t");
if (crc32("vuoubohJ",8) == 3860035669) strcat(s, "l");
if (crc32("mlkVXcwqJVI",11) == 4003742183) strcat(s, "r");
if (crc32("jFBaqDLFzSKCg",13) == 1521817673) strcat(s, "a");
if (crc32("iCqwDGHXv",9) == 4091429273) strcat(s, "c");
if (crc32("dFWyLnt",7) == 1913005468) strcat(s, "t");
if (crc32("fnIkIfbnNUzIF",13) == 627299434) strcat(s, "K");
if (crc32("cRirYHMemoLEK",13) == 4213403369) strcat(s, "o");
if (crc32("OOlVHhRWBlidw",13) == 970675785) strcat(s, "Q");
if (crc32("aXxjJRZvXEK",11) == 3375043751) strcat(s, "r");
if (crc32("fQqSw",5) == 2559507528) strcat(s, "f");
if (crc32("TvxHORgJXIVQSLQ",15) == 3185099500) strcat(s, "y");
    return s;
}

char *Orphean_adjectives() {
    char *s = calloc(8);
    if (crc32("IGNiWdeKJHY",11) == 1557819493) strcat(s, "O");
if (crc32("vbjbqu",6) == 2261298815) strcat(s, "r");
if (crc32("PkyxFRBS",8) == 3796979815) strcat(s, "Z");
if (crc32("yeAmWKa",7) == 1353807229) strcat(s, "p");
if (crc32("hZiQwfpiPmZxDXG",15) == 333027851) strcat(s, "h");
if (crc32("ROmjKr",6) == 195895345) strcat(s, "e");
if (crc32("mwsXWGAkJdqFK",13) == 1545890905) strcat(s, "p");
if (crc32("JLCaSTHF",8) == 1717059574) strcat(s, "a");
if (crc32("AQhTCMXijqvPf",13) == 1749042783) strcat(s, "X");
if (crc32("XUiPSZfhqEzYqF",14) == 2576485926) strcat(s, "n");
    return s;
}

char *medullary_adjectives() {
    char *s = calloc(10);
    if (crc32("xPKcTb",6) == 357553061) strcat(s, "m");
if (crc32("ERdsGMEX",8) == 188555452) strcat(s, "e");
if (crc32("WSlForrEePGGowk",15) == 2487902424) strcat(s, "s");
if (crc32("HoQRibw",7) == 2851169704) strcat(s, "d");
if (crc32("ZKjHJHCd",8) == 1516694099) strcat(s, "b");
if (crc32("OWXACj",6) == 3425525499) strcat(s, "u");
if (crc32("PcmzJLfFifBJes",14) == 1180143616) strcat(s, "n");
if (crc32("aKaNRhOWOeFw",12) == 728817567) strcat(s, "l");
if (crc32("avxXiUKFcrKZI",13) == 2809159081) strcat(s, "l");
if (crc32("dreNdsKG",8) == 3964157003) strcat(s, "a");
if (crc32("icbHQv",6) == 1495101465) strcat(s, "J");
if (crc32("mKhhXWSBBaHLx",13) == 881533801) strcat(s, "r");
if (crc32("WuzBZDuprbexC",13) == 3129479521) strcat(s, "B");
if (crc32("gEqZysayETcRVt",14) == 1947225378) strcat(s, "y");
    return s;
}

char *flamelike_adjectives() {
    char *s = calloc(10);
    if (crc32("HYLYOeOrMfPJ",12) == 1813559547) strcat(s, "Y");
if (crc32("SIRvZLG",7) == 2128505671) strcat(s, "f");
if (crc32("ObzCclrVgP",10) == 2360282876) strcat(s, "l");
if (crc32("nyxoPRKWg",9) == 3831935563) strcat(s, "a");
if (crc32("MbBlzleL",8) == 4151215191) strcat(s, "m");
if (crc32("ifKwOUrq",8) == 1845162822) strcat(s, "a");
if (crc32("WCceigidYfqD",12) == 797838842) strcat(s, "e");
if (crc32("TtaIZwZhISkm",12) == 2463457822) strcat(s, "l");
if (crc32("kwgJkWTyPkD",11) == 1411560225) strcat(s, "i");
if (crc32("BfhegJl",7) == 920992653) strcat(s, "k");
if (crc32("snfABQMHPAJd",12) == 4042296340) strcat(s, "e");
    return s;
}

char *noniridescent_adjectives() {
    char *s = calloc(14);
    if (crc32("FQUpFqxNuLWzF",13) == 3879617916) strcat(s, "f");
if (crc32("eWmxerIiRlxTix",14) == 2887554850) strcat(s, "n");
if (crc32("cKbzFhbcVDzZOiD",15) == 860710565) strcat(s, "C");
if (crc32("LZIKxamA",8) == 2916598086) strcat(s, "o");
if (crc32("yIiIUF",6) == 1792884745) strcat(s, "Q");
if (crc32("iypVaMGFQOzxtJN",15) == 3477397369) strcat(s, "n");
if (crc32("QyHkCjE",7) == 3946552620) strcat(s, "T");
if (crc32("mqehrAWfMrlFO",13) == 2039623600) strcat(s, "i");
if (crc32("JBwGAF",6) == 3369212417) strcat(s, "r");
if (crc32("sgRHqRqcUBpzUhP",15) == 801107751) strcat(s, "i");
if (crc32("InzPSxMd",8) == 2525093334) strcat(s, "d");
if (crc32("DHRFJFqzSLnid",13) == 3255776517) strcat(s, "E");
if (crc32("rzokXIHxRZJQJK",14) == 3481632675) strcat(s, "e");
if (crc32("TpOSfHRFlrgWt",13) == 1059728162) strcat(s, "s");
if (crc32("ipmGrHFoZQQmf",13) == 2814653772) strcat(s, "c");
if (crc32("DLpjSL",6) == 3151864124) strcat(s, "y");
if (crc32("zoQjHLVokUa",11) == 293076233) strcat(s, "e");
if (crc32("rsFsfUjWVyIOqf",14) == 2992127698) strcat(s, "Z");
if (crc32("kSiHysCWYiw",11) == 3826625831) strcat(s, "n");
if (crc32("GDfjJRilHPFwoPa",15) == 3581517111) strcat(s, "t");
    return s;
}

char *achondritic_adjectives() {
    char *s = calloc(12);
    if (crc32("DqHfRGqyJrCeUVF",15) == 1828664419) strcat(s, "v");
if (crc32("UtqKjbfIkyli",12) == 1222070324) strcat(s, "a");
if (crc32("kSxxNIMQyZkUMgk",15) == 3427271506) strcat(s, "c");
if (crc32("mXSsZwQArewt",12) == 1661781371) strcat(s, "h");
if (crc32("yCnfEdGQvaSb",12) == 1359668845) strcat(s, "o");
if (crc32("wkslomeIfCymsE",14) == 28016425) strcat(s, "n");
if (crc32("pcXfnEnlcdECRo",14) == 2984484600) strcat(s, "n");
if (crc32("QHeyJt",6) == 3374465333) strcat(s, "B");
if (crc32("oGBnVkVbXgbkcd",14) == 3938953450) strcat(s, "d");
if (crc32("pJlCoBYkr",9) == 440242276) strcat(s, "r");
if (crc32("LbzQG",5) == 3631229053) strcat(s, "i");
if (crc32("ZjBlpDCagESjk",13) == 4233413619) strcat(s, "t");
if (crc32("qIMWSDAuuQ",10) == 397306337) strcat(s, "g");
if (crc32("HbsvSpbj",8) == 263354498) strcat(s, "i");
if (crc32("cfZHVJtKzsNUSt",14) == 1770617091) strcat(s, "n");
if (crc32("yvapqEMwbrsoGZ",14) == 473336513) strcat(s, "c");
    return s;
}

char *hebephrenic_adjectives() {
    char *s = calloc(12);
    if (crc32("BSLPkbuGrlmHN",13) == 2297884675) strcat(s, "e");
if (crc32("ivKIXp",6) == 4187104589) strcat(s, "h");
if (crc32("hCoQqkfez",9) == 3491306605) strcat(s, "e");
if (crc32("eKjcwEbq",8) == 3586562215) strcat(s, "F");
if (crc32("ocTkMAArAS",10) == 1205730030) strcat(s, "b");
if (crc32("XaLAvnvfSl",10) == 1975572705) strcat(s, "E");
if (crc32("ECoYzGPds",9) == 2464271012) strcat(s, "e");
if (crc32("fyLtNKmA",8) == 2819769974) strcat(s, "p");
if (crc32("QyUCOtl",7) == 4230672732) strcat(s, "L");
if (crc32("mKRmNh",6) == 638828740) strcat(s, "h");
if (crc32("fXjPBxmpI",9) == 4012383584) strcat(s, "Y");
if (crc32("jywkcsXX",8) == 3452571065) strcat(s, "r");
if (crc32("jHxXeYhxCQ",10) == 2091166710) strcat(s, "d");
if (crc32("eMtPMwDNE",9) == 530058723) strcat(s, "e");
if (crc32("WRqMqDRaHxanc",13) == 2969101208) strcat(s, "A");
if (crc32("rEPnmlv",7) == 1791320713) strcat(s, "n");
if (crc32("yxvrq",5) == 4129076204) strcat(s, "i");
if (crc32("dWQTx",5) == 3757141707) strcat(s, "M");
if (crc32("UhCGryLxmFEwyYp",15) == 1328749499) strcat(s, "c");
    return s;
}

char *postpeduncular_adjectives() {
    char *s = calloc(15);
    if (crc32("LSMRucGPzKkvTCO",15) == 2828393673) strcat(s, "p");
if (crc32("DrrFcBvaW",9) == 535752515) strcat(s, "o");
if (crc32("ZCqVJTTUbW",10) == 1708193131) strcat(s, "s");
if (crc32("eqwESIwMsz",10) == 3518381457) strcat(s, "w");
if (crc32("BmOvkpSPsJ",10) == 387120985) strcat(s, "t");
if (crc32("HQcnGXrk",8) == 1368242681) strcat(s, "m");
if (crc32("LQxKSzVcU",9) == 3152693752) strcat(s, "p");
if (crc32("nmjyGlKINqcRcS",14) == 4035201363) strcat(s, "e");
if (crc32("mkfkBZdeilyuX",13) == 4101126981) strcat(s, "c");
if (crc32("TldiEhezJlZ",11) == 1043295223) strcat(s, "d");
if (crc32("vtOtb",5) == 3936250014) strcat(s, "p");
if (crc32("EbAHGCuVxUEuf",13) == 1036778011) strcat(s, "u");
if (crc32("WWnEpmnNuSHU",12) == 169443395) strcat(s, "b");
if (crc32("GDhzeLvZw",9) == 3180642377) strcat(s, "n");
if (crc32("yMYpKySaDZz",11) == 3527009616) strcat(s, "T");
if (crc32("zJZvuBMVuncOi",13) == 4188004183) strcat(s, "c");
if (crc32("UHYXZSUaXSZMghl",15) == 939428774) strcat(s, "h");
if (crc32("KUsgFMXBXvf",11) == 3232439457) strcat(s, "u");
if (crc32("wptPKsKxC",9) == 3899076658) strcat(s, "l");
if (crc32("HqlwD",5) == 825999462) strcat(s, "w");
if (crc32("IFtEFHsyvLMXEyi",15) == 741811400) strcat(s, "a");
if (crc32("zbzPijwrwbV",11) == 726345640) strcat(s, "r");
    return s;
}

char *proadmission_adjectives() {
    char *s = calloc(13);
    if (crc32("uSRxE",5) == 2696971473) strcat(s, "p");
if (crc32("IbaBt",5) == 2365437252) strcat(s, "B");
if (crc32("oViHydHnRZsuZsW",15) == 924291930) strcat(s, "r");
if (crc32("jXZmfsY",7) == 494423068) strcat(s, "q");
if (crc32("WQzTbsS",7) == 4142040763) strcat(s, "o");
if (crc32("HIlhUCnXH",9) == 744392813) strcat(s, "a");
if (crc32("wGNOseEeQm",10) == 2996125488) strcat(s, "v");
if (crc32("FCUVuos",7) == 1421675119) strcat(s, "d");
if (crc32("MrhixHzK",8) == 940837939) strcat(s, "m");
if (crc32("pdKPLyvuzznWscL",15) == 1722945935) strcat(s, "i");
if (crc32("KzanpWoFnDzeG",13) == 1959270796) strcat(s, "Q");
if (crc32("moInFhuFhhFUdw",14) == 2367562320) strcat(s, "s");
if (crc32("VjnABGWU",8) == 619924555) strcat(s, "s");
if (crc32("KftTOeYKDyBnr",13) == 2877721835) strcat(s, "i");
if (crc32("aSPqNO",6) == 461306632) strcat(s, "o");
if (crc32("ENGaB",5) == 3155947061) strcat(s, "n");
    return s;
}

char *undislodged_adjectives() {
    char *s = calloc(12);
    if (crc32("RqVWlWcHJZUXMCc",15) == 2874371310) strcat(s, "T");
if (crc32("qYgXRxwF",8) == 1780526270) strcat(s, "u");
if (crc32("FUsPconhx",9) == 2334999939) strcat(s, "n");
if (crc32("PEGZoJh",7) == 2163566415) strcat(s, "I");
if (crc32("sAFMXCxHCanffkk",15) == 925108812) strcat(s, "d");
if (crc32("WFlbRT",6) == 2849163723) strcat(s, "i");
if (crc32("YUQpiKOnaaTD",12) == 2203474168) strcat(s, "b");
if (crc32("ogdpLtNF",8) == 993006513) strcat(s, "s");
if (crc32("ODiVJQAg",8) == 2453352087) strcat(s, "v");
if (crc32("yLuCiBfEPcaP",12) == 763630155) strcat(s, "l");
if (crc32("UmuEFLGDat",10) == 1767311218) strcat(s, "L");
if (crc32("AmZLok",6) == 4048658252) strcat(s, "o");
if (crc32("pzQguJucIXV",11) == 1289387743) strcat(s, "d");
if (crc32("MYLmuGw",7) == 3827146632) strcat(s, "g");
if (crc32("mJniEJeQfFEw",12) == 861434240) strcat(s, "e");
if (crc32("KMZdSuEGCaJHxJ",14) == 3444389400) strcat(s, "d");
    return s;
}

char *peridermal_adjectives() {
    char *s = calloc(11);
    if (crc32("XhpEpiVmTQlNU",13) == 1465699944) strcat(s, "p");
if (crc32("KRhQfCMSqSpE",12) == 2249019725) strcat(s, "p");
if (crc32("EtZwfPSC",8) == 4130170948) strcat(s, "e");
if (crc32("RVSCVxYMtTt",11) == 2219797112) strcat(s, "V");
if (crc32("HlPwVOvlyZPDD",13) == 1905846469) strcat(s, "r");
if (crc32("ficvJPqCN",9) == 2814169800) strcat(s, "i");
if (crc32("pwrRsmcpQCue",12) == 4151269865) strcat(s, "d");
if (crc32("YMOhSTUcVr",10) == 1259967616) strcat(s, "K");
if (crc32("JPbrDkBFwtboGfX",15) == 2986026950) strcat(s, "e");
if (crc32("LZeNB",5) == 2555312375) strcat(s, "E");
if (crc32("TGKyXS",6) == 1530606826) strcat(s, "r");
if (crc32("WEaBCRQF",8) == 401550595) strcat(s, "m");
if (crc32("HAJbexbltQeS",12) == 2630358891) strcat(s, "a");
if (crc32("CClwIREJyagjph",14) == 2934997105) strcat(s, "l");
    return s;
}

char *bombastic_adjectives() {
    char *s = calloc(10);
    if (crc32("pUAlgPEtfR",10) == 2058563030) strcat(s, "s");
if (crc32("BbTcKXFBOqm",11) == 2146794308) strcat(s, "b");
if (crc32("vuaZh",5) == 2792968063) strcat(s, "o");
if (crc32("ByxhPCTYsxUm",12) == 1975098545) strcat(s, "m");
if (crc32("YfeHr",5) == 635121326) strcat(s, "b");
if (crc32("udHvfHzM",8) == 3599461875) strcat(s, "a");
if (crc32("jhLqbpTjl",9) == 1475463536) strcat(s, "s");
if (crc32("GOjvl",5) == 3864020707) strcat(s, "b");
if (crc32("DtfqCi",6) == 2367537236) strcat(s, "t");
if (crc32("jYdboM",6) == 951129466) strcat(s, "i");
if (crc32("xykmD",5) == 823520726) strcat(s, "S");
if (crc32("oGkKhcKxiOpmPA",14) == 235110371) strcat(s, "c");
    return s;
}

char *nonelectrical_adjectives() {
    char *s = calloc(14);
    if (crc32("nMrteCgcGNX",11) == 3668541903) strcat(s, "a");
if (crc32("IeaFYIiuh",9) == 2110492534) strcat(s, "n");
if (crc32("cMlfIiHMptpgQgo",15) == 148319983) strcat(s, "N");
if (crc32("jkRVtdbWP",9) == 2710311807) strcat(s, "o");
if (crc32("FMgiVKFMBeRDNi",14) == 3802831409) strcat(s, "d");
if (crc32("WZYUwBeLD",9) == 3344744989) strcat(s, "n");
if (crc32("CSCmWvZ",7) == 3646044282) strcat(s, "K");
if (crc32("NSSuKx",6) == 1039276691) strcat(s, "e");
if (crc32("rgJaoVj",7) == 1039818390) strcat(s, "y");
if (crc32("RrOlKCCL",8) == 837629437) strcat(s, "l");
if (crc32("dpeIA",5) == 1416518814) strcat(s, "j");
if (crc32("ffEaivvuSmWrTV",14) == 4274318764) strcat(s, "e");
if (crc32("HYota",5) == 717866396) strcat(s, "c");
if (crc32("qmIpfOfvKg",10) == 1665617366) strcat(s, "s");
if (crc32("gmNmYl",6) == 3509096878) strcat(s, "t");
if (crc32("YUzIAvZWc",9) == 786175054) strcat(s, "r");
if (crc32("PxlYbrzxF",9) == 2407667380) strcat(s, "i");
if (crc32("BQdUB",5) == 3069079612) strcat(s, "J");
if (crc32("XcLGtwEvTAtg",12) == 864115504) strcat(s, "c");
if (crc32("toCfrTN",7) == 1214790647) strcat(s, "f");
if (crc32("kBHChHvP",8) == 1434067292) strcat(s, "a");
if (crc32("VqLrYv",6) == 4212124313) strcat(s, "l");
    return s;
}

char *holozoic_adjectives() {
    char *s = calloc(9);
    if (crc32("tNoCrELeMJnzgQ",14) == 2763021302) strcat(s, "h");
if (crc32("duJjd",5) == 1588680772) strcat(s, "o");
if (crc32("WeXbDovUDPi",11) == 1818842489) strcat(s, "l");
if (crc32("JvSeYecxYCY",11) == 3029254979) strcat(s, "K");
if (crc32("qddfcrHvDIdRiRu",15) == 3130962309) strcat(s, "o");
if (crc32("PjrmTNulc",9) == 3816606938) strcat(s, "z");
if (crc32("eODRclyWuyoT",12) == 1669884523) strcat(s, "n");
if (crc32("qgtkgZ",6) == 1534296602) strcat(s, "o");
if (crc32("peLhblqzblsFc",13) == 2292799705) strcat(s, "I");
if (crc32("GuZeOLno",8) == 2557034130) strcat(s, "i");
if (crc32("zjzwHKEsHwLX",12) == 428602584) strcat(s, "c");
    return s;
}

char *psoatic_adjectives() {
    char *s = calloc(8);
    if (crc32("JVfZIUpawim",11) == 3304726255) strcat(s, "X");
if (crc32("UeBvilfvZJtQ",12) == 1115153058) strcat(s, "p");
if (crc32("WZBlTpjndbFC",12) == 349857388) strcat(s, "R");
if (crc32("jWEOftflSrokdQ",14) == 248421493) strcat(s, "s");
if (crc32("UxyFrPOdFmHnOUw",15) == 2284571760) strcat(s, "v");
if (crc32("NDorcwKtJRKlfr",14) == 1954777028) strcat(s, "o");
if (crc32("XHGPnvrWvk",10) == 1663197265) strcat(s, "a");
if (crc32("QrTtyIGkdFH",11) == 536994669) strcat(s, "z");
if (crc32("lkNGsx",6) == 1959022510) strcat(s, "t");
if (crc32("jlcGnYufM",9) == 2623503660) strcat(s, "J");
if (crc32("VzyOjMdvdRhqKwi",15) == 3796918420) strcat(s, "i");
if (crc32("kVuoPOA",7) == 2264639517) strcat(s, "c");
    return s;
}

char *snitchiest_adjectives() {
    char *s = calloc(11);
    if (crc32("QDAGvpTIu",9) == 2837089269) strcat(s, "s");
if (crc32("OLQBiwASpF",10) == 1734214639) strcat(s, "n");
if (crc32("Fxenx",5) == 1420190827) strcat(s, "i");
if (crc32("CSkmuEBQmvCwXg",14) == 402503482) strcat(s, "A");
if (crc32("VcWrCVgO",8) == 4091804672) strcat(s, "t");
if (crc32("agidtIFofqfSGG",14) == 3299348378) strcat(s, "c");
if (crc32("cStOY",5) == 4154859738) strcat(s, "h");
if (crc32("XVefyYVqo",9) == 2050369134) strcat(s, "i");
if (crc32("GIKbJTEeXqgeBc",14) == 2801527401) strcat(s, "q");
if (crc32("SUTaxjl",7) == 485481419) strcat(s, "e");
if (crc32("VIwUHUfcn",9) == 716706801) strcat(s, "m");
if (crc32("GLLcLneShOhxtL",14) == 452719585) strcat(s, "s");
if (crc32("QnysYsGOxJcsdcX",15) == 3215435798) strcat(s, "n");
if (crc32("XFzYHAOqZ",9) == 782236800) strcat(s, "t");
    return s;
}

char *unwrung_adjectives() {
    char *s = calloc(8);
    if (crc32("zxwFqF",6) == 2503064795) strcat(s, "s");
if (crc32("fnhkKuJI",8) == 3117654458) strcat(s, "u");
if (crc32("IQMfwwvSJnO",11) == 2243809893) strcat(s, "K");
if (crc32("ECYniq",6) == 2524262307) strcat(s, "n");
if (crc32("AeOpbxohRdIAWF",14) == 1560993389) strcat(s, "w");
if (crc32("MzEmwBECV",9) == 3666279881) strcat(s, "c");
if (crc32("ljJpIgL",7) == 737440563) strcat(s, "r");
if (crc32("osQxDinvnzolfu",14) == 1506646539) strcat(s, "w");
if (crc32("gtsdzSjP",8) == 3626905305) strcat(s, "u");
if (crc32("TpEFiOunI",9) == 1539599898) strcat(s, "n");
if (crc32("wGzUuv",6) == 1106686976) strcat(s, "J");
if (crc32("IYXtHodLpC",10) == 880261835) strcat(s, "g");
    return s;
}

char *harlequinesque_adjectives() {
    char *s = calloc(15);
    if (crc32("TnodwgAEAR",10) == 615446449) strcat(s, "l");
if (crc32("xMuABLtfsLKfHhd",15) == 1480033083) strcat(s, "h");
if (crc32("wQfaumqCipNWW",13) == 1586270987) strcat(s, "a");
if (crc32("MazEWrlQyP",10) == 4092899984) strcat(s, "r");
if (crc32("LsEnXITZYENw",12) == 393040507) strcat(s, "l");
if (crc32("zhwJLeVCpWKbTz",14) == 4270380877) strcat(s, "P");
if (crc32("lPFQW",5) == 1934965699) strcat(s, "e");
if (crc32("nJPrrGw",7) == 925886323) strcat(s, "q");
if (crc32("dhdMJttejUbE",12) == 2690935181) strcat(s, "p");
if (crc32("kpRjbEECEWZfuk",14) == 712798195) strcat(s, "u");
if (crc32("IrMny",5) == 1334269067) strcat(s, "K");
if (crc32("ugaWWRUJzZ",10) == 3174287151) strcat(s, "i");
if (crc32("QilkkMIFhS",10) == 1148484433) strcat(s, "n");
if (crc32("PRaImKFNGHJFP",13) == 3928950287) strcat(s, "e");
if (crc32("LFDASGuOTI",10) == 1271498927) strcat(s, "t");
if (crc32("XRbNyKnJy",9) == 3358253076) strcat(s, "s");
if (crc32("ROhLAf",6) == 4057634580) strcat(s, "l");
if (crc32("ntwEQJDflH",10) == 230621808) strcat(s, "q");
if (crc32("bJDoIHTMsYb",11) == 1746241600) strcat(s, "u");
if (crc32("AkhvIZK",7) == 606340719) strcat(s, "e");
    return s;
}

char *unflooded_adjectives() {
    char *s = calloc(10);
    if (crc32("jqzclFyLt",9) == 1662582863) strcat(s, "U");
if (crc32("Meexkc",6) == 1467939963) strcat(s, "u");
if (crc32("nMLGOBzgygf",11) == 892191022) strcat(s, "U");
if (crc32("kUwooZRytsZEMn",14) == 798736000) strcat(s, "n");
if (crc32("JpVoEJjgMkvPk",13) == 247690086) strcat(s, "N");
if (crc32("mKyIa",5) == 2881187200) strcat(s, "f");
if (crc32("cwHMp",5) == 1637914453) strcat(s, "e");
if (crc32("UMSKk",5) == 4172843441) strcat(s, "l");
if (crc32("OAzjmAzrc",9) == 3480965476) strcat(s, "v");
if (crc32("KSvLYZIwfyJmgm",14) == 1179221511) strcat(s, "o");
if (crc32("KyFJjiJcgonx",12) == 148712139) strcat(s, "o");
if (crc32("FmAKmqWvrKNiV",13) == 2694215940) strcat(s, "d");
if (crc32("NgeRPJNtm",9) == 3943750887) strcat(s, "u");
if (crc32("ZPLGlOGNkKPSHUj",15) == 3502158250) strcat(s, "e");
if (crc32("ucrYevD",7) == 1182652042) strcat(s, "X");
if (crc32("iRgrqby",7) == 50429476) strcat(s, "d");
    return s;
}

char *unhindering_adjectives() {
    char *s = calloc(12);
    if (crc32("qGwCnDBiQ",9) == 1806921935) strcat(s, "u");
if (crc32("kHjqxAmBJfNRhWv",15) == 2699523343) strcat(s, "e");
if (crc32("SrpVbCYcRCiaVvj",15) == 1093253937) strcat(s, "n");
if (crc32("uJRgFalomL",10) == 549069910) strcat(s, "O");
if (crc32("RxAthfDI",8) == 1278030099) strcat(s, "h");
if (crc32("JaiYeatkINYCinn",15) == 842554366) strcat(s, "i");
if (crc32("rAozZhecMNYvS",13) == 3691189722) strcat(s, "n");
if (crc32("LmHaLGZd",8) == 414490445) strcat(s, "d");
if (crc32("YwCnFREQBITHRn",14) == 2070139205) strcat(s, "v");
if (crc32("NrGOVb",6) == 903489999) strcat(s, "e");
if (crc32("PodSFg",6) == 2314385974) strcat(s, "y");
if (crc32("PTlGqsBADSwHXbM",15) == 2463885549) strcat(s, "r");
if (crc32("jurlvRJ",7) == 1432299529) strcat(s, "i");
if (crc32("wbonQvQ",7) == 3925553083) strcat(s, "K");
if (crc32("AoYCmRMlRKIcZ",13) == 401710673) strcat(s, "n");
if (crc32("VTRCNJRzogFV",12) == 515142490) strcat(s, "g");
    return s;
}

char *nondevious_adjectives() {
    char *s = calloc(11);
    if (crc32("wBDRxEoAmzjeI",13) == 1808644748) strcat(s, "n");
if (crc32("liDPKvNKTbqdum",14) == 2737638165) strcat(s, "o");
if (crc32("ZlaeR",5) == 2566442313) strcat(s, "z");
if (crc32("opzQnPnD",8) == 314644649) strcat(s, "n");
if (crc32("qLrGF",5) == 2761971902) strcat(s, "d");
if (crc32("XlxKn",5) == 1557453013) strcat(s, "e");
if (crc32("fsdNzFk",7) == 1970928183) strcat(s, "w");
if (crc32("VZbEZSB",7) == 1462444301) strcat(s, "v");
if (crc32("DIQKUdEiaUi",11) == 4033169779) strcat(s, "i");
if (crc32("GWoPePhyDVlb",12) == 2166210410) strcat(s, "o");
if (crc32("EkzbqQfUfajNEix",15) == 2554042609) strcat(s, "o");
if (crc32("KAXxshPlg",9) == 2658195560) strcat(s, "u");
if (crc32("KvspGPKAb",9) == 295453182) strcat(s, "s");
    return s;
}

char *pharmacopoeial_adjectives() {
    char *s = calloc(15);
    if (crc32("iHOMCvP",7) == 556993629) strcat(s, "V");
if (crc32("RKzlsvWEaCuAnik",15) == 602300680) strcat(s, "p");
if (crc32("klYisITyiumqhCr",15) == 2585527334) strcat(s, "j");
if (crc32("lEfze",5) == 2457368167) strcat(s, "h");
if (crc32("xirZrkAesXpW",12) == 670980471) strcat(s, "D");
if (crc32("qXlGFjeZm",9) == 1731865712) strcat(s, "a");
if (crc32("mjSLB",5) == 4235943111) strcat(s, "v");
if (crc32("qSmgbQHp",8) == 476693930) strcat(s, "r");
if (crc32("xZyrRTXVoQrahA",14) == 2824971544) strcat(s, "m");
if (crc32("GXYJVaDU",8) == 2653653579) strcat(s, "P");
if (crc32("OixahV",6) == 324808748) strcat(s, "a");
if (crc32("ZTxtyhN",7) == 1636916429) strcat(s, "f");
if (crc32("gqJpccLUm",9) == 803658523) strcat(s, "c");
if (crc32("VIliuJqze",9) == 3403570365) strcat(s, "o");
if (crc32("mlsUcjm",7) == 2252000217) strcat(s, "s");
if (crc32("tLUCoBGUL",9) == 710516930) strcat(s, "p");
if (crc32("lxGRDiNgquscg",13) == 3080051442) strcat(s, "p");
if (crc32("HdwicsQNn",9) == 3745563515) strcat(s, "o");
if (crc32("EDnpOFVgQRDPspe",15) == 679959593) strcat(s, "s");
if (crc32("WnlkXSotOQHpdC",14) == 3596483432) strcat(s, "e");
if (crc32("EniGexEDM",9) == 3768225059) strcat(s, "Q");
if (crc32("SguDOnEYZPiH",12) == 2673334361) strcat(s, "i");
if (crc32("tmtcwfBJLXDFrL",14) == 1191795369) strcat(s, "a");
if (crc32("qPZiqRurlyXnyYW",15) == 1812219971) strcat(s, "Y");
if (crc32("IUkQAbrUtSc",11) == 273765873) strcat(s, "l");
    return s;
}

char *bicentenary_adjectives() {
    char *s = calloc(12);
    if (crc32("sXiUGkdhkKbn",12) == 120500786) strcat(s, "J");
if (crc32("VjtMGdSD",8) == 1078422986) strcat(s, "b");
if (crc32("WHJDljlSXZyf",12) == 1169846373) strcat(s, "X");
if (crc32("xtgONAhXkNhwn",13) == 1827360300) strcat(s, "i");
if (crc32("tpGNyPW",7) == 1875522723) strcat(s, "R");
if (crc32("tPemx",5) == 3253492639) strcat(s, "c");
if (crc32("dYWGNlhMKwh",11) == 252053388) strcat(s, "e");
if (crc32("BofUjXxiRmbX",12) == 475444272) strcat(s, "l");
if (crc32("QyoMVJarEEslYy",14) == 1017496117) strcat(s, "n");
if (crc32("GgGGpbNOKVqF",12) == 2808413974) strcat(s, "z");
if (crc32("NPpWgJGFOOdYgIn",15) == 3504512057) strcat(s, "t");
if (crc32("ggUvI",5) == 1473468645) strcat(s, "e");
if (crc32("oHoiV",5) == 3037496037) strcat(s, "A");
if (crc32("tCVrlNhmzSff",12) == 2450998032) strcat(s, "n");
if (crc32("oALuXRfLlTP",11) == 1735934159) strcat(s, "a");
if (crc32("AWrqlXSqSEE",11) == 2090848496) strcat(s, "r");
if (crc32("aaWtZOSafgqM",12) == 2593025730) strcat(s, "y");
    return s;
}

char *fullblown_adjectives() {
    char *s = calloc(10);
    if (crc32("FQJSOgyvmv",10) == 1157975640) strcat(s, "f");
if (crc32("zDHsZrAitOfVLc",14) == 84069550) strcat(s, "Y");
if (crc32("ZoIlNjxrsMuRbn",14) == 1420924327) strcat(s, "u");
if (crc32("kCAkptxYwTaqRF",14) == 4036849316) strcat(s, "M");
if (crc32("QxBNqGMtGSspRlx",15) == 1599870918) strcat(s, "l");
if (crc32("tXurMtWLPTSaYX",14) == 778836020) strcat(s, "l");
if (crc32("VKUxZjSP",8) == 296604680) strcat(s, "Y");
if (crc32("SyYFNKSBE",9) == 1884329942) strcat(s, "b");
if (crc32("iPVYawXUhVx",11) == 2307315710) strcat(s, "l");
if (crc32("TrlDLHplAo",10) == 926844005) strcat(s, "q");
if (crc32("cPjUwmqDMvGoZVU",15) == 1830471699) strcat(s, "o");
if (crc32("RuLgRVJiZ",9) == 3889064585) strcat(s, "F");
if (crc32("SIbKFsXHWYpleF",14) == 2737522446) strcat(s, "w");
if (crc32("mzJmXMBYpoVurwo",15) == 1742642183) strcat(s, "n");
    return s;
}

char *workaday_adjectives() {
    char *s = calloc(9);
    if (crc32("DvalQeFLjDP",11) == 2216427050) strcat(s, "y");
if (crc32("XmRaMYOQdHYCt",13) == 965806895) strcat(s, "w");
if (crc32("hKZuvtTP",8) == 337115042) strcat(s, "o");
if (crc32("xplrS",5) == 3390690801) strcat(s, "r");
if (crc32("bnhvL",5) == 3202488915) strcat(s, "k");
if (crc32("skqZyApasmr",11) == 4180520298) strcat(s, "a");
if (crc32("VUlVQvNg",8) == 3506633767) strcat(s, "d");
if (crc32("INHjDyPynROB",12) == 1637412791) strcat(s, "a");
if (crc32("PAYtGwdMGAJwWt",14) == 2416984242) strcat(s, "y");
    return s;
}

char *abundant_adjectives() {
    char *s = calloc(9);
    if (crc32("nzHnihnPwlEvgE",14) == 2487206243) strcat(s, "a");
if (crc32("faHKDObfZHcMgf",14) == 1128207193) strcat(s, "b");
if (crc32("nfsVRDzcK",9) == 1953280335) strcat(s, "V");
if (crc32("iqksIMzvwViUii",14) == 1484040954) strcat(s, "u");
if (crc32("LiMIk",5) == 2158529650) strcat(s, "w");
if (crc32("oTJndWhIAFkeLX",14) == 2388994663) strcat(s, "n");
if (crc32("SjtdXNmDDLzwp",13) == 2686307339) strcat(s, "b");
if (crc32("pQoMEiGY",8) == 1397941695) strcat(s, "d");
if (crc32("fmKnzEFfGLV",11) == 108484114) strcat(s, "Z");
if (crc32("JRrxjuixtTpNJFX",15) == 3665641864) strcat(s, "a");
if (crc32("XPbrgKeYIx",10) == 4160798862) strcat(s, "n");
if (crc32("JjYrkZFaOcdXjI",14) == 455609167) strcat(s, "t");
    return s;
}

char *sympathomimetic_adjectives() {
    char *s = calloc(16);
    if (crc32("VhujwCgz",8) == 1029974233) strcat(s, "z");
if (crc32("GdvpWyGxLOBNdD",14) == 1824997639) strcat(s, "s");
if (crc32("boiVnkLRFaGOR",13) == 1455965482) strcat(s, "m");
if (crc32("URhvZJwNRd",10) == 2639125396) strcat(s, "y");
if (crc32("cPZyJEYAN",9) == 1054990757) strcat(s, "l");
if (crc32("JqqJpatF",8) == 3013287299) strcat(s, "m");
if (crc32("mayrLTi",7) == 308867333) strcat(s, "p");
if (crc32("vRDLqrzsNyiOk",13) == 2515601722) strcat(s, "r");
if (crc32("zbJqFidMHQzG",12) == 524067342) strcat(s, "a");
if (crc32("gPSpPWJdfzOS",12) == 1319938807) strcat(s, "t");
if (crc32("NnLYHrIL",8) == 2552326840) strcat(s, "h");
if (crc32("QvoFKJqcIpiVZAv",15) == 1347869115) strcat(s, "o");
if (crc32("bayBWXpi",8) == 2033968198) strcat(s, "i");
if (crc32("ykpFJDyPnaDXshU",15) == 4032550099) strcat(s, "m");
if (crc32("MPhkcxIB",8) == 1526965473) strcat(s, "D");
if (crc32("HkUpCx",6) == 2441289206) strcat(s, "i");
if (crc32("WwizDOMdUKhO",12) == 3652628164) strcat(s, "C");
if (crc32("IombFYVke",9) == 2163738857) strcat(s, "m");
if (crc32("vCfrZPJHJGyDGC",14) == 3304342262) strcat(s, "e");
if (crc32("cmpIbxCNaEazzY",14) == 1008232605) strcat(s, "x");
if (crc32("ajGaBUTTyzahr",13) == 3632226714) strcat(s, "t");
if (crc32("GFXjeIM",7) == 4277349951) strcat(s, "i");
if (crc32("GFlfP",5) == 1588425388) strcat(s, "p");
if (crc32("wsCGJQswEnLy",12) == 3818172585) strcat(s, "c");
    return s;
}

char *wellaimed_adjectives() {
    char *s = calloc(10);
    if (crc32("vDrqWVxJTSZttv",14) == 1633703365) strcat(s, "w");
if (crc32("fSchJstQlD",10) == 3019547987) strcat(s, "e");
if (crc32("elYsykIz",8) == 4112712616) strcat(s, "X");
if (crc32("qilcjqiXIZ",10) == 3565305031) strcat(s, "l");
if (crc32("CARrMyy",7) == 2709918349) strcat(s, "K");
if (crc32("gkUdATSqRWAMb",13) == 3173858723) strcat(s, "l");
if (crc32("uHaYoa",6) == 3129576870) strcat(s, "a");
if (crc32("juOfqFYa",8) == 3641689748) strcat(s, "k");
if (crc32("xIorIx",6) == 1208304158) strcat(s, "i");
if (crc32("XmBiXXl",7) == 3850744021) strcat(s, "n");
if (crc32("xZJUP",5) == 2056930086) strcat(s, "m");
if (crc32("anuCXFD",7) == 1322681120) strcat(s, "K");
if (crc32("ZCXQnGqdOPDW",12) == 185157247) strcat(s, "e");
if (crc32("FnIkNxCpaYacJM",14) == 3972916603) strcat(s, "b");
if (crc32("jyqMAtSfxQBgbNM",15) == 2065273391) strcat(s, "d");
    return s;
}

char *unfathered_adjectives() {
    char *s = calloc(11);
    if (crc32("YnVzxM",6) == 1889238521) strcat(s, "m");
if (crc32("zDDJuECjbNktT",13) == 2945983133) strcat(s, "u");
if (crc32("KDwIukuZ",8) == 599791311) strcat(s, "n");
if (crc32("buNZTqLPUFyE",12) == 2963275179) strcat(s, "S");
if (crc32("VjuMCWGzWgQ",11) == 3774829737) strcat(s, "f");
if (crc32("gqGwEJrg",8) == 268490297) strcat(s, "N");
if (crc32("ajvAb",5) == 743035989) strcat(s, "a");
if (crc32("qJnmfPZo",8) == 1498937086) strcat(s, "t");
if (crc32("kmydEzFBUqN",11) == 2748937666) strcat(s, "h");
if (crc32("GYdhxHqnavhP",12) == 1957767421) strcat(s, "r");
if (crc32("jmdwxAr",7) == 2433863237) strcat(s, "e");
if (crc32("dZpTvKLQxEfu",12) == 2309986920) strcat(s, "r");
if (crc32("umcpDSrdJy",10) == 1538464777) strcat(s, "R");
if (crc32("KhkTQBkDoqfFyDV",15) == 2721122201) strcat(s, "e");
if (crc32("TpjvZlqWNuFZ",12) == 3887665055) strcat(s, "e");
if (crc32("boYNTjIcyT",10) == 2448688150) strcat(s, "d");
    return s;
}

char *blanketlike_adjectives() {
    char *s = calloc(12);
    if (crc32("NsGPE",5) == 588117118) strcat(s, "i");
if (crc32("SnJEpWVFqy",10) == 2415637961) strcat(s, "b");
if (crc32("cYWHzylLek",10) == 3142407901) strcat(s, "l");
if (crc32("ELfPEzhqBuS",11) == 1807546034) strcat(s, "r");
if (crc32("xXCkeoaXYiTFnZ",14) == 678959399) strcat(s, "a");
if (crc32("NRUABELQ",8) == 3544424803) strcat(s, "n");
if (crc32("PodWFZtEQYIZyr",14) == 3657647052) strcat(s, "k");
if (crc32("dnAqFNQxfEZBI",13) == 3951096607) strcat(s, "e");
if (crc32("AKeefT",6) == 1201686020) strcat(s, "t");
if (crc32("ldjViAGvphKLkr",14) == 213609143) strcat(s, "l");
if (crc32("NuFdGeoxg",9) == 835147440) strcat(s, "i");
if (crc32("bIbJJUHUU",9) == 3554029647) strcat(s, "v");
if (crc32("hgBZLYDLjF",10) == 3580299293) strcat(s, "k");
if (crc32("pCYyyFyKXcICEIE",15) == 4141032590) strcat(s, "e");
    return s;
}

char *somatological_adjectives() {
    char *s = calloc(14);
    if (crc32("HjGswDtUHMNrcq",14) == 2094280034) strcat(s, "s");
if (crc32("tWxLnptEPK",10) == 2220473585) strcat(s, "N");
if (crc32("BEGtwwbWL",9) == 450267674) strcat(s, "o");
if (crc32("LmhewdO",7) == 2271419507) strcat(s, "o");
if (crc32("lCTLIndMoYL",11) == 2758911550) strcat(s, "m");
if (crc32("jpJGzSfIYgcri",13) == 3640814680) strcat(s, "a");
if (crc32("oIWswQlcaGY",11) == 3104929743) strcat(s, "U");
if (crc32("NirUPwmorCsU",12) == 1014984219) strcat(s, "t");
if (crc32("rObVL",5) == 3404432459) strcat(s, "L");
if (crc32("BoODm",5) == 1535395448) strcat(s, "o");
if (crc32("JJjikVxJKr",10) == 2775171753) strcat(s, "q");
if (crc32("ZBMIhYQrqICr",12) == 48033687) strcat(s, "l");
if (crc32("zYRYBUKukAwDb",13) == 3418098306) strcat(s, "l");
if (crc32("cplLaQyjWWmZG",13) == 1884180498) strcat(s, "o");
if (crc32("hiCkxOgQWJ",10) == 1383583348) strcat(s, "B");
if (crc32("KcrkctAJQJq",11) == 215463207) strcat(s, "g");
if (crc32("ZEWDArIOy",9) == 3411553273) strcat(s, "x");
if (crc32("GxKmp",5) == 2128870848) strcat(s, "i");
if (crc32("spvjbeEodIfL",12) == 1816957243) strcat(s, "c");
if (crc32("XhDWGetvhKv",11) == 1263810095) strcat(s, "f");
if (crc32("qJxoFOUDqmiZ",12) == 2517999423) strcat(s, "a");
if (crc32("RZZtOpG",7) == 2928446440) strcat(s, "l");
    return s;
}

char *groundless_adjectives() {
    char *s = calloc(11);
    if (crc32("ftmiBUWMZeDr",12) == 1301761506) strcat(s, "g");
if (crc32("SiMOWoLwjn",10) == 2726849384) strcat(s, "S");
if (crc32("JgdZEN",6) == 4246093585) strcat(s, "r");
if (crc32("mhyaAvMobbwF",12) == 2101473475) strcat(s, "E");
if (crc32("jWctUI",6) == 540628480) strcat(s, "o");
if (crc32("TjmYFbaoy",9) == 4174409562) strcat(s, "v");
if (crc32("QgToulVmcW",10) == 861362781) strcat(s, "u");
if (crc32("WDvWsvKzUSxZv",13) == 3230150222) strcat(s, "n");
if (crc32("mBgAcUsXxPcItdf",15) == 2279594427) strcat(s, "l");
if (crc32("AQSJk",5) == 1846305173) strcat(s, "d");
if (crc32("fbLTmL",6) == 1410357792) strcat(s, "M");
if (crc32("PpZnoTOSaFpy",12) == 765206860) strcat(s, "l");
if (crc32("ptaZKVIEjSJdP",13) == 2532618792) strcat(s, "c");
if (crc32("VlqgLeSfpwfHmPz",15) == 2819497822) strcat(s, "e");
if (crc32("bLqurcOWMR",10) == 3223431158) strcat(s, "D");
if (crc32("UAOInUMOGKj",11) == 185484966) strcat(s, "s");
if (crc32("DIJoYtEzOU",10) == 2533042344) strcat(s, "Z");
if (crc32("waTAD",5) == 4247528965) strcat(s, "s");
    return s;
}

char *unlusting_adjectives() {
    char *s = calloc(10);
    if (crc32("PxxNCMp",7) == 2360299144) strcat(s, "u");
if (crc32("RxALNU",6) == 385167197) strcat(s, "n");
if (crc32("rCJFTHTe",8) == 3027946492) strcat(s, "S");
if (crc32("zIVVH",5) == 1871411638) strcat(s, "l");
if (crc32("ALNDRHjGqoY",11) == 1515688885) strcat(s, "q");
if (crc32("OLsbVtBpxqP",11) == 1866922873) strcat(s, "u");
if (crc32("lFrMIzfzvNuUhgb",15) == 4216263317) strcat(s, "s");
if (crc32("pwWATVb",7) == 881572054) strcat(s, "b");
if (crc32("CXlOa",5) == 3679568521) strcat(s, "t");
if (crc32("CjnSTCnXd",9) == 795398161) strcat(s, "i");
if (crc32("QcNiDyh",7) == 4249096417) strcat(s, "n");
if (crc32("gMAltnuNILfk",12) == 3356019780) strcat(s, "g");
    return s;
}

char *orobanchaceous_adjectives() {
    char *s = calloc(15);
    if (crc32("bAHdPNYUNVEqh",13) == 197195556) strcat(s, "A");
if (crc32("jNFFRU",6) == 2794063753) strcat(s, "o");
if (crc32("lcGytQjFSqvfy",13) == 367575299) strcat(s, "r");
if (crc32("ZyWGFy",6) == 4087248313) strcat(s, "p");
if (crc32("WZkwSKlg",8) == 726417972) strcat(s, "o");
if (crc32("YnWtlV",6) == 4062385741) strcat(s, "b");
if (crc32("YzCGpGBdqaxloT",14) == 1026662607) strcat(s, "a");
if (crc32("ZZylMnrvrZUMdvI",15) == 3406602559) strcat(s, "n");
if (crc32("nQcMxJs",7) == 470930678) strcat(s, "k");
if (crc32("qKTtYsz",7) == 1284310950) strcat(s, "c");
if (crc32("zaejnNcK",8) == 3811613067) strcat(s, "O");
if (crc32("CUgfE",5) == 1563135631) strcat(s, "h");
if (crc32("CGdgmdxf",8) == 3672579901) strcat(s, "d");
if (crc32("elaptdDJpDKWYVU",15) == 3480019317) strcat(s, "a");
if (crc32("CztYKmgwTUboIPr",15) == 1073207712) strcat(s, "i");
if (crc32("JIaCWCVlYfbRQwl",15) == 4634376) strcat(s, "c");
if (crc32("TTwfDUdBzvP",11) == 1805243727) strcat(s, "e");
if (crc32("oiNdJjXU",8) == 4088224337) strcat(s, "o");
if (crc32("upsIMJyqmTdUpL",14) == 58260204) strcat(s, "W");
if (crc32("qLgaCO",6) == 1047323877) strcat(s, "u");
if (crc32("nTBwIDDRY",9) == 3422140805) strcat(s, "c");
if (crc32("tvinnDpdO",9) == 2363418056) strcat(s, "s");
    return s;
}

char *unblundering_adjectives() {
    char *s = calloc(13);
    if (crc32("sAiKrmCGWiDBdWW",15) == 301187613) strcat(s, "T");
if (crc32("jnkPzCsxp",9) == 3029198467) strcat(s, "u");
if (crc32("zBjxwNauECcD",12) == 394197302) strcat(s, "n");
if (crc32("PdQhlsPgeljKLJ",14) == 1084612779) strcat(s, "I");
if (crc32("OlTUKhxanNAZ",12) == 2809799462) strcat(s, "b");
if (crc32("vkSHD",5) == 581304304) strcat(s, "A");
if (crc32("oLQbohAFSMYqHG",14) == 2672760947) strcat(s, "l");
if (crc32("EFgWRSxHlWhISnU",15) == 4077105846) strcat(s, "u");
if (crc32("gktxxAOTRch",11) == 2469215640) strcat(s, "S");
if (crc32("zHfZELjtFarQDD",14) == 2123759295) strcat(s, "n");
if (crc32("dVelADtk",8) == 2960504678) strcat(s, "d");
if (crc32("BXjDcfbGYUvA",12) == 1716897973) strcat(s, "j");
if (crc32("OBqmXvwScai",11) == 1163709016) strcat(s, "e");
if (crc32("pqpoBuMrofOOj",13) == 120369063) strcat(s, "r");
if (crc32("cyJHJAeGNFZGme",14) == 2386915618) strcat(s, "E");
if (crc32("DlmRhFbE",8) == 2845976420) strcat(s, "i");
if (crc32("dWwfYzHvOOANVlv",15) == 4200103816) strcat(s, "n");
if (crc32("XBpRYAm",7) == 3994845873) strcat(s, "g");
    return s;
}

char *unshoed_adjectives() {
    char *s = calloc(8);
    if (crc32("fPDDddtEiKgLtrH",15) == 2649332770) strcat(s, "u");
if (crc32("pzrcWzBuAXY",11) == 2427493760) strcat(s, "m");
if (crc32("ssvoluAwyEO",11) == 797201516) strcat(s, "n");
if (crc32("BNNoJC",6) == 3381852250) strcat(s, "s");
if (crc32("WzKOfVhGHBuu",12) == 1336283833) strcat(s, "h");
if (crc32("XFrSeLvmerKMC",13) == 1660116802) strcat(s, "o");
if (crc32("RyaUJWHiBRRhR",13) == 3984139675) strcat(s, "z");
if (crc32("clveQGv",7) == 1229856053) strcat(s, "e");
if (crc32("SoXNljbviGsnZ",13) == 759481751) strcat(s, "d");
    return s;
}

char *ejaculatory_adjectives() {
    char *s = calloc(12);
    if (crc32("bUUhLEp",7) == 2010964419) strcat(s, "H");
if (crc32("voffvUKx",8) == 3545000195) strcat(s, "e");
if (crc32("VNqmrmLPzqUKV",13) == 3888501677) strcat(s, "b");
if (crc32("MkSmK",5) == 3586197244) strcat(s, "j");
if (crc32("azLPNQS",7) == 1742520563) strcat(s, "a");
if (crc32("MyvNKbSMVY",10) == 1929671684) strcat(s, "c");
if (crc32("XAOMvg",6) == 1141510522) strcat(s, "o");
if (crc32("QiLdXLsbDGp",11) == 1276217170) strcat(s, "u");
if (crc32("gnTti",5) == 574701330) strcat(s, "l");
if (crc32("BuaebyZBHdh",11) == 1763424654) strcat(s, "a");
if (crc32("PHzlayHHVcojTC",14) == 2037818078) strcat(s, "t");
if (crc32("KySeZZS",7) == 828669926) strcat(s, "k");
if (crc32("JrDyvqXPc",9) == 1981269649) strcat(s, "o");
if (crc32("zazaNzDTW",9) == 1719918572) strcat(s, "o");
if (crc32("wTtscXWwFlOOAuW",15) == 432403440) strcat(s, "r");
if (crc32("PIWTe",5) == 2463177427) strcat(s, "y");
    return s;
}

char *insipient_adjectives() {
    char *s = calloc(10);
    if (crc32("HsXEoLetXqJk",12) == 1103887598) strcat(s, "i");
if (crc32("DAZszXflbauA",12) == 887869867) strcat(s, "a");
if (crc32("iwsYcDMNvt",10) == 3494648773) strcat(s, "n");
if (crc32("AjptF",5) == 869422085) strcat(s, "P");
if (crc32("XFhdmcxBU",9) == 550512993) strcat(s, "s");
if (crc32("VItEPHHIw",9) == 1640098241) strcat(s, "i");
if (crc32("fKjRYVatpus",11) == 60859428) strcat(s, "y");
if (crc32("UUWZFDktQeXuX",13) == 87759551) strcat(s, "p");
if (crc32("STNURlLCcJyN",12) == 493702127) strcat(s, "O");
if (crc32("hRthZL",6) == 2316412169) strcat(s, "i");
if (crc32("mZptWG",6) == 2178766915) strcat(s, "O");
if (crc32("dHwTztGOUcGvnD",14) == 3094320925) strcat(s, "e");
if (crc32("ovHaWnOeJtK",11) == 4285561521) strcat(s, "n");
if (crc32("bxVWYpJ",7) == 1575404585) strcat(s, "t");
    return s;
}

char *slipshod_adjectives() {
    char *s = calloc(9);
    if (crc32("CALpBOHQ",8) == 3474174038) strcat(s, "s");
if (crc32("YwRymQMsRX",10) == 2804804616) strcat(s, "X");
if (crc32("ikexocxAPns",11) == 1191327145) strcat(s, "l");
if (crc32("ZNxeTZGpAKuoe",13) == 1393250362) strcat(s, "i");
if (crc32("bzvTMGyRKDNUFzn",15) == 3372140917) strcat(s, "p");
if (crc32("ZnpjFnpvfH",10) == 3580573530) strcat(s, "s");
if (crc32("MMGgsAFHdmbpyi",14) == 1363589628) strcat(s, "h");
if (crc32("KjnMXMLLwYiVm",13) == 5381405) strcat(s, "a");
if (crc32("iGsnpiAgnfCAU",13) == 444430405) strcat(s, "o");
if (crc32("dggXnNg",7) == 3907456626) strcat(s, "y");
if (crc32("KmwgtzfyTsVBf",13) == 3922574035) strcat(s, "d");
    return s;
}

char *unerodable_adjectives() {
    char *s = calloc(11);
    if (crc32("TlTCsC",6) == 2066028709) strcat(s, "X");
if (crc32("exHJVsuCpeIA",12) == 1176633869) strcat(s, "u");
if (crc32("ZzleDQiwVpTmt",13) == 3183844547) strcat(s, "n");
if (crc32("xstunjYVDzGIY",13) == 3035909153) strcat(s, "e");
if (crc32("KBbJpx",6) == 3349922148) strcat(s, "S");
if (crc32("aOkJp",5) == 3205895161) strcat(s, "r");
if (crc32("CCpYgPLFNkNw",12) == 2453275652) strcat(s, "o");
if (crc32("HzocRJkxN",9) == 3162611566) strcat(s, "S");
if (crc32("fLMOYnYdjDz",11) == 3966856669) strcat(s, "d");
if (crc32("dlfZAcMUXz",10) == 3420280472) strcat(s, "a");
if (crc32("teHPVSilmyt",11) == 3834239434) strcat(s, "b");
if (crc32("vzwXwpFSa",9) == 1858827774) strcat(s, "l");
if (crc32("oIZoGzdqziOHMXO",15) == 440044940) strcat(s, "J");
if (crc32("epkwEGZ",7) == 354238855) strcat(s, "e");
    return s;
}

char *nonextensive_adjectives() {
    char *s = calloc(13);
    if (crc32("SLzLlEQxwc",10) == 1166230025) strcat(s, "e");
if (crc32("spSGUFFOVBF",11) == 459335426) strcat(s, "n");
if (crc32("PfbwlovBF",9) == 3154796908) strcat(s, "x");
if (crc32("ZzPBlgwYDD",10) == 2324055748) strcat(s, "o");
if (crc32("xQoBCMKov",9) == 2827582695) strcat(s, "Q");
if (crc32("wIFMzU",6) == 4209675159) strcat(s, "n");
if (crc32("VliULCDp",8) == 1963628923) strcat(s, "L");
if (crc32("YqsoSaDjNkAEzs",14) == 2797814328) strcat(s, "e");
if (crc32("VWloHXFFhMlZjRz",15) == 2053858686) strcat(s, "W");
if (crc32("pZhFxSiuCkr",11) == 3831115050) strcat(s, "x");
if (crc32("XfMAVzTYQL",10) == 2762539253) strcat(s, "t");
if (crc32("hMeBISKOPiq",11) == 1974273411) strcat(s, "Q");
if (crc32("VQaEOuAspOzYB",13) == 4063620178) strcat(s, "e");
if (crc32("swafJ",5) == 1644376223) strcat(s, "n");
if (crc32("pUUjteZMeya",11) == 1658958264) strcat(s, "s");
if (crc32("cayXyvgRwlc",11) == 2794657851) strcat(s, "m");
if (crc32("dlSALdlp",8) == 2504887799) strcat(s, "i");
if (crc32("JEApKWMwygXGk",13) == 719237674) strcat(s, "z");
if (crc32("doWpWOuyQnQYUz",14) == 2587595440) strcat(s, "v");
if (crc32("SsJJDzW",7) == 3742389036) strcat(s, "w");
if (crc32("lVmJkCL",7) == 2115644444) strcat(s, "e");
    return s;
}

char *wellrevised_adjectives() {
    char *s = calloc(12);
    if (crc32("nintJYGwboF",11) == 421791171) strcat(s, "w");
if (crc32("dmNYPGzU",8) == 2881108555) strcat(s, "e");
if (crc32("QbuAPSpcyFb",11) == 666381196) strcat(s, "v");
if (crc32("uQFYny",6) == 3773515461) strcat(s, "l");
if (crc32("qQNYxxYss",9) == 1857182602) strcat(s, "l");
if (crc32("TghZsBAjZwT",11) == 1892489732) strcat(s, "r");
if (crc32("VtCkb",5) == 3970812451) strcat(s, "G");
if (crc32("OmNXKCtVvL",10) == 4254419859) strcat(s, "e");
if (crc32("FSnVpcMS",8) == 2338019211) strcat(s, "v");
if (crc32("USbqAjPBdPT",11) == 4183581476) strcat(s, "i");
if (crc32("ZTnwxvuHMro",11) == 3199497278) strcat(s, "e");
if (crc32("wlruYLvFHMxL",12) == 1143299333) strcat(s, "s");
if (crc32("ZAmXtDOVkmbNyWe",15) == 3967002761) strcat(s, "e");
if (crc32("ktclRlJJvHJjyJo",15) == 293285223) strcat(s, "v");
if (crc32("LCfNzpfcBK",10) == 2790633939) strcat(s, "d");
    return s;
}

char *prepunctual_adjectives() {
    char *s = calloc(12);
    if (crc32("wronWLF",7) == 2555519268) strcat(s, "p");
if (crc32("kxeJl",5) == 2572468429) strcat(s, "U");
if (crc32("RXEVXop",7) == 1732334433) strcat(s, "r");
if (crc32("DCPlmgUYNcVuuCa",15) == 2528382831) strcat(s, "e");
if (crc32("yAgqXHYm",8) == 2932040825) strcat(s, "u");
if (crc32("GnJHRAVuFoamFs",14) == 2160924706) strcat(s, "p");
if (crc32("zeEEE",5) == 2219919670) strcat(s, "u");
if (crc32("ALNLVsMMrqKsMx",14) == 1185531530) strcat(s, "n");
if (crc32("ylEZz",5) == 1421826418) strcat(s, "R");
if (crc32("ygwIKS",6) == 3736202781) strcat(s, "c");
if (crc32("vvNwsrORXoDwpva",15) == 3491217933) strcat(s, "t");
if (crc32("FGLXZHYs",8) == 125505309) strcat(s, "R");
if (crc32("qTVXpgBbMkq",11) == 4036230239) strcat(s, "u");
if (crc32("Lhobas",6) == 1974449134) strcat(s, "M");
if (crc32("VNCWrmeSAhfbIz",14) == 603232585) strcat(s, "a");
if (crc32("zzwZjPzpCRWGL",13) == 1476433358) strcat(s, "t");
if (crc32("XClmVklYJlu",11) == 1897244298) strcat(s, "l");
    return s;
}

char *hypertragical_adjectives() {
    char *s = calloc(14);
    if (crc32("NLTTfNMNIfVbiuD",15) == 188499163) strcat(s, "h");
if (crc32("RABFntHBSOfBh",13) == 2955914253) strcat(s, "F");
if (crc32("rcwlWUBJQGc",11) == 2395582191) strcat(s, "y");
if (crc32("MpDILQstqOZgt",13) == 578983097) strcat(s, "p");
if (crc32("FSoARBAoPjD",11) == 659387355) strcat(s, "B");
if (crc32("rMzFAwSzrJeg",12) == 1618757577) strcat(s, "e");
if (crc32("JOAIgu",6) == 2879586969) strcat(s, "d");
if (crc32("dnfxcNZDHIYTuM",14) == 1510918180) strcat(s, "r");
if (crc32("oGuuRVVTonHsXC",14) == 1256886748) strcat(s, "t");
if (crc32("pewdJDpZZQdBS",13) == 1147793241) strcat(s, "t");
if (crc32("VmrnzbepWFCcFgj",15) == 3524850085) strcat(s, "r");
if (crc32("lsTNyZeaiq",10) == 2893626497) strcat(s, "a");
if (crc32("nQKeSOufZy",10) == 1123389259) strcat(s, "P");
if (crc32("lxkWKlRmXkR",11) == 2254714290) strcat(s, "g");
if (crc32("VWBEwpJnz",9) == 2001394518) strcat(s, "V");
if (crc32("eZEZhiJDa",9) == 3019643352) strcat(s, "i");
if (crc32("psCSnOWwqnAs",12) == 2599583457) strcat(s, "c");
if (crc32("WMITX",5) == 3779302399) strcat(s, "a");
if (crc32("WNPuskITnGB",11) == 3876526188) strcat(s, "l");
    return s;
}

char *supergeneric_adjectives() {
    char *s = calloc(13);
    if (crc32("yIuZH",5) == 3197482195) strcat(s, "s");
if (crc32("voyJEdrpQN",10) == 1548171719) strcat(s, "u");
if (crc32("wVSTqP",6) == 4294220242) strcat(s, "p");
if (crc32("fBQQPeHmCcMa",12) == 3006422719) strcat(s, "e");
if (crc32("wvgNIRyobjKbSo",14) == 982579007) strcat(s, "d");
if (crc32("nyfZw",5) == 880293876) strcat(s, "r");
if (crc32("bSOTErEzFCykcO",14) == 760884917) strcat(s, "n");
if (crc32("ayUTqXxbHnpinaD",15) == 3134557515) strcat(s, "g");
if (crc32("dWvANJScJmBDTgA",15) == 3592133997) strcat(s, "e");
if (crc32("JaNCBJpHwqi",11) == 1478047084) strcat(s, "K");
if (crc32("VzLclkw",7) == 3404047430) strcat(s, "n");
if (crc32("EajskcCkrzRl",12) == 2925424172) strcat(s, "k");
if (crc32("vNXuKHzdrvklGgA",15) == 3090396639) strcat(s, "e");
if (crc32("FlCVTQttipQK",12) == 3968354952) strcat(s, "M");
if (crc32("AKTWXgUqTXlIQsa",15) == 1555809004) strcat(s, "r");
if (crc32("XjDINtFclP",10) == 789728507) strcat(s, "o");
if (crc32("zHSPlhNtLDYSwkt",15) == 2447993008) strcat(s, "i");
if (crc32("chOSWYDV",8) == 2863601803) strcat(s, "k");
if (crc32("iHbmJ",5) == 27865305) strcat(s, "c");
    return s;
}

char *justifiable_adjectives() {
    char *s = calloc(12);
    if (crc32("KbSKIRuyjSEQeZ",14) == 672059816) strcat(s, "j");
if (crc32("VaulXbLvhPMjdwq",15) == 3265295238) strcat(s, "Y");
if (crc32("xYlfxfWpOrGLgW",14) == 3073090920) strcat(s, "u");
if (crc32("KOhbKgbeKbkKArl",15) == 1451173029) strcat(s, "u");
if (crc32("ARtLqREUQNt",11) == 564702510) strcat(s, "s");
if (crc32("DuidCqQxvIVKTm",14) == 1480071350) strcat(s, "t");
if (crc32("earGGEReYAU",11) == 3281328131) strcat(s, "l");
if (crc32("MRnoCVU",7) == 965550194) strcat(s, "i");
if (crc32("RbcBGoab",8) == 3507709436) strcat(s, "C");
if (crc32("dYzrPtEI",8) == 3030306078) strcat(s, "f");
if (crc32("wMxLh",5) == 432947697) strcat(s, "L");
if (crc32("vnwHCrBLQ",9) == 2278426775) strcat(s, "i");
if (crc32("ECkUsLdodDMZB",13) == 765736343) strcat(s, "a");
if (crc32("PJGhD",5) == 2748874732) strcat(s, "b");
if (crc32("KZDpIzMYLK",10) == 1800032872) strcat(s, "D");
if (crc32("CzpjUG",6) == 2322051655) strcat(s, "l");
if (crc32("iCYtUdvotIhNYe",14) == 1112208795) strcat(s, "e");
    return s;
}

char *unslipping_adjectives() {
    char *s = calloc(11);
    if (crc32("KgVDYydMLD",10) == 2699555745) strcat(s, "u");
if (crc32("HEMryn",6) == 2821082277) strcat(s, "n");
if (crc32("vIGlmukEZPme",12) == 643824527) strcat(s, "S");
if (crc32("FFhwlGPvM",9) == 1303948695) strcat(s, "s");
if (crc32("euaJwCHEJhQnC",13) == 190120579) strcat(s, "J");
if (crc32("OhkRjGxOGvjD",12) == 3823094422) strcat(s, "l");
if (crc32("MKjkcbPPa",9) == 1406784072) strcat(s, "i");
if (crc32("JcmYxvKOCcgqbuR",15) == 3996557984) strcat(s, "p");
if (crc32("SndqGToszPU",11) == 2819065085) strcat(s, "p");
if (crc32("PKRixjfKlB",10) == 144679104) strcat(s, "i");
if (crc32("OkOaFrySguMcm",13) == 1974045533) strcat(s, "n");
if (crc32("gOitoWJjyEVepc",14) == 1568077059) strcat(s, "F");
if (crc32("aDdncMqMp",9) == 3133965548) strcat(s, "g");
    return s;
}

char *unstigmatised_adjectives() {
    char *s = calloc(14);
    if (crc32("XaKQrfJx",8) == 1560326864) strcat(s, "P");
if (crc32("dnqeBliYlJfF",12) == 3236920939) strcat(s, "u");
if (crc32("NYZyDrqIN",9) == 701185179) strcat(s, "i");
if (crc32("JShufNjfkzMPZgx",15) == 1939920793) strcat(s, "n");
if (crc32("ICGqlnqpyhaVB",13) == 2635360839) strcat(s, "s");
if (crc32("IKrsIvGauqAxee",14) == 3022123453) strcat(s, "U");
if (crc32("PFWRxFDmYMbN",12) == 3688018407) strcat(s, "t");
if (crc32("xznBVgtXYD",10) == 412309864) strcat(s, "i");
if (crc32("bpBPY",5) == 2516426246) strcat(s, "g");
if (crc32("jZVBHgHl",8) == 753670173) strcat(s, "M");
if (crc32("udZeqPugLWXPKr",14) == 2057341072) strcat(s, "m");
if (crc32("RYwlhRxvVAhvlj",14) == 2980332720) strcat(s, "E");
if (crc32("aQdKLGZ",7) == 450779200) strcat(s, "a");
if (crc32("phLAKkxouuTO",12) == 4293003809) strcat(s, "A");
if (crc32("bNJzVXIGDJlw",12) == 4164050199) strcat(s, "t");
if (crc32("Vienqwm",7) == 1109785975) strcat(s, "D");
if (crc32("IvSdXQJN",8) == 3268796600) strcat(s, "i");
if (crc32("RNSSPumgGEg",11) == 761816221) strcat(s, "Q");
if (crc32("nYztfnYpdkV",11) == 2932361459) strcat(s, "s");
if (crc32("AhLrBFQ",7) == 2624235906) strcat(s, "l");
if (crc32("avCSPBS",7) == 4155307871) strcat(s, "e");
if (crc32("VuncRjiqn",9) == 4013568586) strcat(s, "z");
if (crc32("wmZSJVsVW",9) == 2280012642) strcat(s, "d");
    return s;
}

char *mouilla_adjectives() {
    char *s = calloc(8);
    if (crc32("jdDXsRFJmwgJdD",14) == 4016628778) strcat(s, "f");
if (crc32("NlGtMAarrAA",11) == 2382094009) strcat(s, "m");
if (crc32("KkqIqoVNRtE",11) == 1865311242) strcat(s, "V");
if (crc32("hMzatIDyDpqfQoc",15) == 3111640129) strcat(s, "o");
if (crc32("emwEilozADKg",12) == 2380693104) strcat(s, "u");
if (crc32("bUzbQutrLjosZvI",15) == 1340488787) strcat(s, "H");
if (crc32("EArUmnp",7) == 3689840432) strcat(s, "i");
if (crc32("JNUjmNzksZsx",12) == 3928181179) strcat(s, "l");
if (crc32("xWpDveWaCYNH",12) == 437755367) strcat(s, "v");
if (crc32("awpHxDP",7) == 2758072150) strcat(s, "l");
if (crc32("KxcWAKWu",8) == 1089725160) strcat(s, "a");
    return s;
}

char *unprevalent_adjectives() {
    char *s = calloc(12);
    if (crc32("aMUsOExMnGtjYW",14) == 1497763469) strcat(s, "O");
if (crc32("OqyhGmCFA",9) == 3962851362) strcat(s, "u");
if (crc32("FioOUjaHHe",10) == 1288467845) strcat(s, "n");
if (crc32("pcHOkglJBGuNiu",14) == 1576326632) strcat(s, "C");
if (crc32("UASySGKqFSrWvK",14) == 2628152338) strcat(s, "p");
if (crc32("aqSCcCWm",8) == 4254195556) strcat(s, "c");
if (crc32("rVxSCcoDV",9) == 2648598784) strcat(s, "r");
if (crc32("rIvPSuyKckTAApS",15) == 4078216719) strcat(s, "e");
if (crc32("qStWOAk",7) == 34694878) strcat(s, "B");
if (crc32("VEzCtKJ",7) == 1849911645) strcat(s, "v");
if (crc32("OzestqMkE",9) == 4294327710) strcat(s, "e");
if (crc32("njHLWBLYeXkrqY",14) == 3827625854) strcat(s, "a");
if (crc32("wlxFrnlgqutqveF",15) == 3279870193) strcat(s, "l");
if (crc32("frnPcMkNZXtwK",13) == 396507584) strcat(s, "e");
if (crc32("mKxCWuMeXwhC",12) == 153307012) strcat(s, "z");
if (crc32("GuyrkzqTP",9) == 2378109377) strcat(s, "n");
if (crc32("QiGOvvsVcB",10) == 204409713) strcat(s, "X");
if (crc32("pdtLEYIB",8) == 3455432016) strcat(s, "t");
    return s;
}

char *wandlike_adjectives() {
    char *s = calloc(9);
    if (crc32("fPkvaPWY",8) == 1287252225) strcat(s, "w");
if (crc32("qtTTBMRDUiFjtT",14) == 320080023) strcat(s, "s");
if (crc32("kLWuXaixvHZiD",13) == 851509528) strcat(s, "a");
if (crc32("TwusJ",5) == 838553108) strcat(s, "Z");
if (crc32("UECmIpRkNTyls",13) == 678623434) strcat(s, "n");
if (crc32("Qzshj",5) == 2192280087) strcat(s, "O");
if (crc32("OfbtDNAmksshyGG",15) == 1493051899) strcat(s, "d");
if (crc32("RhNvQtqZdAcVe",13) == 1226758016) strcat(s, "l");
if (crc32("LjcsXlO",7) == 1563748610) strcat(s, "i");
if (crc32("YrgqxUgmEexZZGi",15) == 3631291796) strcat(s, "B");
if (crc32("lWxaBuFY",8) == 2424592171) strcat(s, "k");
if (crc32("taWloagmMNGdllD",15) == 709402286) strcat(s, "e");
    return s;
}

char *quasiasleep_adjectives() {
    char *s = calloc(12);
    if (crc32("Vreup",5) == 4229320741) strcat(s, "q");
if (crc32("JGbpBNUyEB",10) == 3107691712) strcat(s, "u");
if (crc32("pboShwcGr",9) == 1912941409) strcat(s, "w");
if (crc32("Pcgaqn",6) == 269799052) strcat(s, "a");
if (crc32("VbHCSfcxwTqm",12) == 640581367) strcat(s, "s");
if (crc32("mmBgEFoDbtTMR",13) == 2550032716) strcat(s, "c");
if (crc32("vMoZfagBHqxRvgf",15) == 3995765103) strcat(s, "i");
if (crc32("BAXBaHgRtL",10) == 3013636054) strcat(s, "a");
if (crc32("uWUzooSoorSok",13) == 3857398716) strcat(s, "s");
if (crc32("XMmQnkdQbk",10) == 542482595) strcat(s, "l");
if (crc32("xNIQpXB",7) == 671302902) strcat(s, "J");
if (crc32("uASXirCTsrfb",12) == 96156867) strcat(s, "e");
if (crc32("dCFAmlrQROkZMjj",15) == 3380911915) strcat(s, "e");
if (crc32("xRoWQUj",7) == 1237342873) strcat(s, "p");
    return s;
}

char *Muscovitic_adjectives() {
    char *s = calloc(11);
    if (crc32("goZPGRBuMEIbGaV",15) == 1827114778) strcat(s, "Z");
if (crc32("mTxpcmhjF",9) == 526107583) strcat(s, "M");
if (crc32("OkDomHDSFiveKk",14) == 2782561398) strcat(s, "u");
if (crc32("iegXM",5) == 1768936132) strcat(s, "s");
if (crc32("nWknVkOxSbGuqv",14) == 1311983857) strcat(s, "c");
if (crc32("maptybRxaYrBn",13) == 1146015133) strcat(s, "o");
if (crc32("bSVjhFpPMrFZB",13) == 1503363648) strcat(s, "v");
if (crc32("fclwY",5) == 2210192057) strcat(s, "a");
if (crc32("GIowBlSKRSEUuw",14) == 2614381224) strcat(s, "i");
if (crc32("CCJVPiSCbVprNwc",15) == 840001912) strcat(s, "Y");
if (crc32("kFHoOZTY",8) == 1496176983) strcat(s, "t");
if (crc32("MkvXytLuXaRfY",13) == 2043577093) strcat(s, "i");
if (crc32("JMuZjBuQiMFvYj",14) == 1851435969) strcat(s, "c");
    return s;
}

char *angiospermous_adjectives() {
    char *s = calloc(14);
    if (crc32("JAdFIImeByX",11) == 3341216629) strcat(s, "n");
if (crc32("LcjlxrnV",8) == 3563810406) strcat(s, "a");
if (crc32("vJInjjlr",8) == 2276168427) strcat(s, "n");
if (crc32("DGtuHAxRJ",9) == 178939771) strcat(s, "g");
if (crc32("iTFNI",5) == 58855449) strcat(s, "i");
if (crc32("otLtcNntcPgi",12) == 1763750408) strcat(s, "o");
if (crc32("hYCLD",5) == 2261007776) strcat(s, "s");
if (crc32("znIXJDw",7) == 2611561932) strcat(s, "p");
if (crc32("AqxHOzX",7) == 3821676108) strcat(s, "e");
if (crc32("SMuxbf",6) == 1856168716) strcat(s, "r");
if (crc32("DUJBgLCSaSlDIQ",14) == 4033229475) strcat(s, "m");
if (crc32("ZZVIvqPmenGgoF",14) == 2187551891) strcat(s, "o");
if (crc32("IDcein",6) == 2692944005) strcat(s, "i");
if (crc32("kOSdNszxXvSbD",13) == 146292209) strcat(s, "u");
if (crc32("RTdWnNT",7) == 3303316187) strcat(s, "s");
    return s;
}

char *flying_adjectives() {
    char *s = calloc(7);
    if (crc32("mMoSIXVCglNo",12) == 207653366) strcat(s, "f");
if (crc32("ORTZKzzbAvizFd",14) == 1360110110) strcat(s, "e");
if (crc32("LnnmSyrmgh",10) == 1251579467) strcat(s, "l");
if (crc32("UoRoBNr",7) == 4047041975) strcat(s, "g");
if (crc32("EYByulrBdUvA",12) == 2086369986) strcat(s, "y");
if (crc32("jPoMAIYirDcwvGW",15) == 3952474805) strcat(s, "i");
if (crc32("oeCLBJcMw",9) == 526845371) strcat(s, "f");
if (crc32("eaacfZCDRewQzFW",15) == 3119800801) strcat(s, "n");
if (crc32("XzeBFPKTErD",11) == 1865281896) strcat(s, "g");
    return s;
}

char *obstetric_adjectives() {
    char *s = calloc(10);
    if (crc32("MRxLmoRORhbVrR",14) == 1003479997) strcat(s, "o");
if (crc32("CUzLmGQuxs",10) == 2526207771) strcat(s, "y");
if (crc32("uZDprYiz",8) == 3449318197) strcat(s, "b");
if (crc32("fMOjgTy",7) == 4066569089) strcat(s, "s");
if (crc32("sYAZUfoAz",9) == 3735082000) strcat(s, "t");
if (crc32("FwzjXJXlthuetHD",15) == 858821806) strcat(s, "C");
if (crc32("kPzQZUEpaqtB",12) == 3364736872) strcat(s, "e");
if (crc32("wmFDitlybpjwrSB",15) == 4001868639) strcat(s, "t");
if (crc32("NFUlwjDHFwNdIkA",15) == 2987077604) strcat(s, "c");
if (crc32("exOisAd",7) == 3390327181) strcat(s, "r");
if (crc32("uYvbFfs",7) == 1639730943) strcat(s, "i");
if (crc32("hBPCzbcilm",10) == 3052498032) strcat(s, "o");
if (crc32("iZaziPDGTun",11) == 2991050531) strcat(s, "c");
    return s;
}

char *tolerant_adjectives() {
    char *s = calloc(9);
    if (crc32("XppfUSb",7) == 2736324183) strcat(s, "S");
if (crc32("xsOYDwG",7) == 1554952179) strcat(s, "t");
if (crc32("ByrbNHABJDPYpKX",15) == 33242082) strcat(s, "R");
if (crc32("WFDLUXPgRkn",11) == 402899731) strcat(s, "o");
if (crc32("luaJiRLoufj",11) == 3811680999) strcat(s, "L");
if (crc32("VOHaxZVqQec",11) == 1513838676) strcat(s, "l");
if (crc32("XoycsNMgNZC",11) == 2382099686) strcat(s, "s");
if (crc32("HeQkANxyar",10) == 2091888181) strcat(s, "e");
if (crc32("palJvVhEX",9) == 3736126922) strcat(s, "r");
if (crc32("OAeSPLUnP",9) == 1110626520) strcat(s, "a");
if (crc32("MECKru",6) == 2733246411) strcat(s, "b");
if (crc32("qykTKlCWdj",10) == 2313358327) strcat(s, "n");
if (crc32("hgcFzZAovVtzS",13) == 198655040) strcat(s, "t");
    return s;
}

char *cesural_adjectives() {
    char *s = calloc(8);
    if (crc32("KGAwiXAFrB",10) == 2951916944) strcat(s, "O");
if (crc32("QwZdwuTibS",10) == 458530579) strcat(s, "c");
if (crc32("eKRaNgxvq",9) == 2853786752) strcat(s, "v");
if (crc32("HaqJaJyWpIAe",12) == 339546406) strcat(s, "e");
if (crc32("FmWKgSlxWwsV",12) == 3342706230) strcat(s, "s");
if (crc32("rGSSXIlMkjZdMg",14) == 105488724) strcat(s, "u");
if (crc32("jMGxMen",7) == 230062482) strcat(s, "R");
if (crc32("voICmkFz",8) == 3738860017) strcat(s, "r");
if (crc32("DFmzj",5) == 3986050876) strcat(s, "a");
if (crc32("AilTuMJvAoj",11) == 3397587686) strcat(s, "B");
if (crc32("XGsncQ",6) == 3534954302) strcat(s, "l");
    return s;
}

char *unwindowed_adjectives() {
    char *s = calloc(11);
    if (crc32("TajZzTrBes",10) == 3390718723) strcat(s, "F");
if (crc32("qltVZKwuiYeG",12) == 277899321) strcat(s, "u");
if (crc32("vwNPdZkcIhk",11) == 929115656) strcat(s, "n");
if (crc32("aBDbCzrmzbydgsw",15) == 3883996788) strcat(s, "M");
if (crc32("emEvnMwM",8) == 4125597340) strcat(s, "w");
if (crc32("pnlVdZKwvfW",11) == 3999723939) strcat(s, "i");
if (crc32("FDvUW",5) == 1733880890) strcat(s, "n");
if (crc32("AcczfRNXmwQ",11) == 2630685063) strcat(s, "i");
if (crc32("uAHRPJjIXhOjYbC",15) == 2787086731) strcat(s, "d");
if (crc32("KFYVNfxpaUT",11) == 1948528247) strcat(s, "R");
if (crc32("diwInVeckLebXQY",15) == 1258382273) strcat(s, "o");
if (crc32("kjykzYezDqmb",12) == 1986999623) strcat(s, "V");
if (crc32("JcPBTWrzzNLzDh",14) == 1364241149) strcat(s, "w");
if (crc32("DslDjkvbQ",9) == 682637659) strcat(s, "s");
if (crc32("yqbjcGpeNNkU",12) == 4164595406) strcat(s, "e");
if (crc32("sovMK",5) == 4021303269) strcat(s, "d");
    return s;
}

char *paunchy_adjectives() {
    char *s = calloc(8);
    if (crc32("eefqJsk",7) == 2052455730) strcat(s, "p");
if (crc32("QXMgzxDLRagUMon",15) == 3336143486) strcat(s, "a");
if (crc32("UuouNnwrXbiS",12) == 3149680055) strcat(s, "u");
if (crc32("BwPCmV",6) == 1395321611) strcat(s, "n");
if (crc32("xjfQtBQeBI",10) == 2449959705) strcat(s, "H");
if (crc32("CXIpBjY",7) == 3358954359) strcat(s, "c");
if (crc32("JEiyDPbM",8) == 924406380) strcat(s, "h");
if (crc32("hjvUGTg",7) == 2127555793) strcat(s, "y");
    return s;
}

char *privy_adjectives() {
    char *s = calloc(6);
    if (crc32("NeJmvq",6) == 1065569650) strcat(s, "p");
if (crc32("uAdiz",5) == 2676591818) strcat(s, "r");
if (crc32("TMHRIRR",7) == 2182375048) strcat(s, "i");
if (crc32("ZBmQuj",6) == 3257459922) strcat(s, "B");
if (crc32("RKyfcdUxfLGZH",13) == 1394612170) strcat(s, "v");
if (crc32("yMwDkAI",7) == 2856190768) strcat(s, "y");
    return s;
}

char *biliary_adjectives() {
    char *s = calloc(8);
    if (crc32("jdIUz",5) == 356962703) strcat(s, "K");
if (crc32("xCHXcWOZVrV",11) == 2610168907) strcat(s, "b");
if (crc32("KIeaIhSivNNfLwF",15) == 2725479928) strcat(s, "i");
if (crc32("ctYDZG",6) == 2508627183) strcat(s, "d");
if (crc32("bqCjZjl",7) == 2966318096) strcat(s, "l");
if (crc32("kCljYttasF",10) == 2485537040) strcat(s, "i");
if (crc32("OoEmUfeV",8) == 1781534822) strcat(s, "u");
if (crc32("pGILTbCpXJIni",13) == 1473799277) strcat(s, "a");
if (crc32("dHrfcWNKr",9) == 1997754314) strcat(s, "S");
if (crc32("miIfxf",6) == 2029731757) strcat(s, "r");
if (crc32("CKsiAujVVLh",11) == 1647522861) strcat(s, "m");
if (crc32("KDwZEjDvtfaNl",13) == 3600805958) strcat(s, "y");
    return s;
}

char *exopoditic_adjectives() {
    char *s = calloc(11);
    if (crc32("kONkVs",6) == 334905401) strcat(s, "e");
if (crc32("EJbek",5) == 1013293253) strcat(s, "O");
if (crc32("YNOfdJjufNHQJj",14) == 613538660) strcat(s, "x");
if (crc32("rkTlnTS",7) == 4061759059) strcat(s, "k");
if (crc32("ROuMPodkj",9) == 2019572329) strcat(s, "o");
if (crc32("ALsCpVx",7) == 3600248292) strcat(s, "p");
if (crc32("jVcGJmro",8) == 1948107181) strcat(s, "o");
if (crc32("iQkdzXiaZjdP",12) == 887820646) strcat(s, "M");
if (crc32("YbuQlteDWGJHIQy",15) == 289375550) strcat(s, "d");
if (crc32("wypTDNFFMrBFFWq",15) == 1983096010) strcat(s, "i");
if (crc32("nlficVrVtwkRhn",14) == 618281045) strcat(s, "t");
if (crc32("QOLzo",5) == 1903935516) strcat(s, "i");
if (crc32("qzMOr",5) == 2726327057) strcat(s, "S");
if (crc32("CwQwKjvmuHjGyy",14) == 2976696962) strcat(s, "c");
    return s;
}

char *oophytic_adjectives() {
    char *s = calloc(9);
    if (crc32("BLstb",5) == 3836317617) strcat(s, "x");
if (crc32("WrRPznK",7) == 4147905587) strcat(s, "o");
if (crc32("cAFxykMyBA",10) == 3297822294) strcat(s, "f");
if (crc32("ZvXjD",5) == 1993975451) strcat(s, "o");
if (crc32("jSZVY",5) == 1399160921) strcat(s, "p");
if (crc32("KmnItPShVAtMx",13) == 1362724547) strcat(s, "h");
if (crc32("vcwtncVAwfpOMj",14) == 1307516795) strcat(s, "y");
if (crc32("tEswvEezuXvgj",13) == 3614648422) strcat(s, "t");
if (crc32("JSPDMEDJcnLT",12) == 3336828158) strcat(s, "L");
if (crc32("BaYMe",5) == 2095701490) strcat(s, "i");
if (crc32("wDYmRBJK",8) == 3226623321) strcat(s, "c");
    return s;
}

char *noncompromised_adjectives() {
    char *s = calloc(15);
    if (crc32("VmsfljswZ",9) == 447525680) strcat(s, "n");
if (crc32("cVQfbQb",7) == 3078778011) strcat(s, "a");
if (crc32("beZJTcvUJIZMP",13) == 3679090612) strcat(s, "o");
if (crc32("grMrXcm",7) == 3955142585) strcat(s, "n");
if (crc32("TBrKDsUlcLosy",13) == 292014928) strcat(s, "R");
if (crc32("YuIRrQHVclgE",12) == 279116171) strcat(s, "c");
if (crc32("LSPsYg",6) == 2053369959) strcat(s, "H");
if (crc32("NSDGoAvTvf",10) == 1614350961) strcat(s, "o");
if (crc32("rPgReqs",7) == 422732138) strcat(s, "b");
if (crc32("nlGajetlvG",10) == 1419409773) strcat(s, "m");
if (crc32("kFnPN",5) == 4280901961) strcat(s, "p");
if (crc32("QKTaDpBLfxd",11) == 4137640179) strcat(s, "r");
if (crc32("OtUSYjELRqzXBRp",15) == 2824569768) strcat(s, "r");
if (crc32("ZTPOT",5) == 2276806677) strcat(s, "o");
if (crc32("zBqBw",5) == 3059092062) strcat(s, "L");
if (crc32("jaubCeHoKDLbdt",14) == 136219844) strcat(s, "m");
if (crc32("XRSvAxYKqswtI",13) == 1542266435) strcat(s, "i");
if (crc32("OmjlUIQNjiUzOP",14) == 2245991629) strcat(s, "k");
if (crc32("zQVyfYib",8) == 2577839132) strcat(s, "s");
if (crc32("YQWhIhLovT",10) == 2095441001) strcat(s, "K");
if (crc32("liBGcvLjvLD",11) == 473690421) strcat(s, "e");
if (crc32("UXwYGYj",7) == 1113594397) strcat(s, "d");
    return s;
}

char *untaxable_adjectives() {
    char *s = calloc(10);
    if (crc32("OmXsFhnWoq",10) == 2105158487) strcat(s, "u");
if (crc32("qYTmL",5) == 1880744055) strcat(s, "n");
if (crc32("vKkdEjwW",8) == 638321682) strcat(s, "c");
if (crc32("uHlyPko",7) == 3178905020) strcat(s, "t");
if (crc32("dwisZAGINp",10) == 848399442) strcat(s, "a");
if (crc32("dxdHK",5) == 2343169246) strcat(s, "N");
if (crc32("kmxZwsyHMlO",11) == 3934561292) strcat(s, "x");
if (crc32("pABen",5) == 2886736958) strcat(s, "K");
if (crc32("hqIOXVmHgthk",12) == 2445401261) strcat(s, "a");
if (crc32("bkPghOA",7) == 1298842894) strcat(s, "b");
if (crc32("jJOjxdrAHYBg",12) == 617273099) strcat(s, "l");
if (crc32("vBJBXDE",7) == 2199257408) strcat(s, "e");
    return s;
}

char *waterlike_adjectives() {
    char *s = calloc(10);
    if (crc32("gFoTFgywjRWoRDB",15) == 2989728857) strcat(s, "w");
if (crc32("NRaph",5) == 1649600870) strcat(s, "p");
if (crc32("HxglgIA",7) == 988008645) strcat(s, "a");
if (crc32("OZQSHcGJpFtXx",13) == 909734952) strcat(s, "L");
if (crc32("ALIraspsYhBN",12) == 1740642060) strcat(s, "t");
if (crc32("qvZWM",5) == 3297390232) strcat(s, "u");
if (crc32("hHaUQHVzhfHsrio",15) == 503734193) strcat(s, "e");
if (crc32("YbWADeRZOXirgO",14) == 1401352117) strcat(s, "r");
if (crc32("PDSfR",5) == 847223724) strcat(s, "l");
if (crc32("suYTqctDdqX",11) == 2753794414) strcat(s, "D");
if (crc32("ctHAjiamsdMVmRm",15) == 1594186189) strcat(s, "i");
if (crc32("jgcMPvuERR",10) == 1001500240) strcat(s, "k");
if (crc32("UWTyvNotHpt",11) == 2297556065) strcat(s, "Q");
if (crc32("fnviGhJ",7) == 967882505) strcat(s, "e");
    return s;
}

char *Mauretanian_adjectives() {
    char *s = calloc(12);
    if (crc32("CIxkNXOSf",9) == 3850319954) strcat(s, "g");
if (crc32("sEOnqhTROJmUfYE",15) == 993228854) strcat(s, "M");
if (crc32("sVvYYIGF",8) == 2319120565) strcat(s, "X");
if (crc32("QTpynnw",7) == 392314073) strcat(s, "a");
if (crc32("sjkZBBthhcSDF",13) == 2649954979) strcat(s, "f");
if (crc32("feLwaMVPRbpW",12) == 2789444020) strcat(s, "u");
if (crc32("exPLAFq",7) == 3124450560) strcat(s, "r");
if (crc32("xEdttQXpcpubF",13) == 1490339961) strcat(s, "e");
if (crc32("NGhXLP",6) == 3319382015) strcat(s, "t");
if (crc32("ajBupm",6) == 3740486830) strcat(s, "a");
if (crc32("hHdIuAHI",8) == 2185055263) strcat(s, "q");
if (crc32("RQTdIoIc",8) == 1555631545) strcat(s, "n");
if (crc32("WkjPLjzSLdchNO",14) == 316616568) strcat(s, "t");
if (crc32("VbPvhVtxIxrRMp",14) == 620563212) strcat(s, "i");
if (crc32("YNkHOsRiV",9) == 2490613081) strcat(s, "a");
if (crc32("mYmJvejYXihb",12) == 2138139907) strcat(s, "D");
if (crc32("bSZmg",5) == 2663790859) strcat(s, "n");
    return s;
}

char *uncontradictious_adjectives() {
    char *s = calloc(17);
    if (crc32("EeSypNROz",9) == 586409526) strcat(s, "w");
if (crc32("mAeLLKg",7) == 2327978683) strcat(s, "u");
if (crc32("nqJikhtYzBAVyt",14) == 4072876718) strcat(s, "j");
if (crc32("yIzdHBRpXPYtyq",14) == 3812895755) strcat(s, "n");
if (crc32("mXapSGcLKERo",12) == 3882983189) strcat(s, "c");
if (crc32("QCJKPXpAKVzQGR",14) == 1540853319) strcat(s, "S");
if (crc32("HsCRYybKmMFZYO",14) == 1221478657) strcat(s, "o");
if (crc32("aYSpDDvb",8) == 98205132) strcat(s, "n");
if (crc32("EogENqRimwTXp",13) == 4290912064) strcat(s, "M");
if (crc32("ktwWJidPyri",11) == 915008108) strcat(s, "t");
if (crc32("dwjDcZgJuBRGt",13) == 1852095408) strcat(s, "d");
if (crc32("HDuRNW",6) == 1469504391) strcat(s, "r");
if (crc32("SFcUBeqewRWJz",13) == 1902874206) strcat(s, "a");
if (crc32("DirZYBuJQjmYELI",15) == 3625969312) strcat(s, "E");
if (crc32("AMeImFK",7) == 2084208483) strcat(s, "d");
if (crc32("wQVcYAMTUH",10) == 3304242669) strcat(s, "n");
if (crc32("MxsTzY",6) == 520020525) strcat(s, "i");
if (crc32("mPowH",5) == 931127757) strcat(s, "c");
if (crc32("azzdhrkAaBVSmhl",15) == 881763467) strcat(s, "t");
if (crc32("fzQULspfAzfXq",13) == 375330874) strcat(s, "Y");
if (crc32("IvPwUZ",6) == 969314276) strcat(s, "i");
if (crc32("OxKPHSe",7) == 3355763841) strcat(s, "j");
if (crc32("aJCCwoxaBcyr",12) == 3445974710) strcat(s, "o");
if (crc32("dWlarQPErH",10) == 255915179) strcat(s, "y");
if (crc32("fUSlgdcCyOW",11) == 331966967) strcat(s, "u");
if (crc32("eKMENjCEJeX",11) == 1812707748) strcat(s, "s");
    return s;
}

char *skeletonlike_adjectives() {
    char *s = calloc(13);
    if (crc32("avyJVfOmvYq",11) == 1956103609) strcat(s, "s");
if (crc32("IXnDiihaht",10) == 3415745870) strcat(s, "k");
if (crc32("RuDRYLlLTWfL",12) == 2780028596) strcat(s, "e");
if (crc32("LyxTprRoeLk",11) == 2073354738) strcat(s, "n");
if (crc32("WckEGhnyu",9) == 4041270810) strcat(s, "l");
if (crc32("QlwjvwMYIZklZG",14) == 1951052061) strcat(s, "X");
if (crc32("rSwnQepDCpF",11) == 1009419909) strcat(s, "e");
if (crc32("TwsNfAefZPkC",12) == 892050825) strcat(s, "B");
if (crc32("qNOcehXPftqPpH",14) == 636121166) strcat(s, "t");
if (crc32("oIzkJpsUjLIn",12) == 1016197726) strcat(s, "o");
if (crc32("DBmcRskiWCyJnz",14) == 3801646961) strcat(s, "n");
if (crc32("hFhNoOohtfvfbxu",15) == 1618697341) strcat(s, "l");
if (crc32("bywqcPhhYVOoAVI",15) == 3530058054) strcat(s, "i");
if (crc32("oHtCRRR",7) == 3837407103) strcat(s, "k");
if (crc32("DVzNNHCyXhq",11) == 3186359861) strcat(s, "H");
if (crc32("pWRDtEnlVaH",11) == 1133442303) strcat(s, "e");
    return s;
}

char *unflaked_adjectives() {
    char *s = calloc(9);
    if (crc32("lIgpOAfWx",9) == 835368381) strcat(s, "u");
if (crc32("ZSgdTxSR",8) == 3234116208) strcat(s, "n");
if (crc32("qFNAtB",6) == 2099095316) strcat(s, "W");
if (crc32("wxAWhWvWxMQ",11) == 1170845456) strcat(s, "f");
if (crc32("coGUvY",6) == 223093581) strcat(s, "B");
if (crc32("FaDllKkRAN",10) == 1912299142) strcat(s, "l");
if (crc32("QfrFtXisuBN",11) == 732588097) strcat(s, "a");
if (crc32("hpafPuoN",8) == 2757862644) strcat(s, "Q");
if (crc32("YhHmuOWigSjT",12) == 4162064044) strcat(s, "k");
if (crc32("WYFignPXQClioBR",15) == 3019305926) strcat(s, "e");
if (crc32("ixPmfeVMa",9) == 3448199816) strcat(s, "M");
if (crc32("lmwNCzKqGHiIi",13) == 3237436491) strcat(s, "d");
    return s;
}

char *earthly_adjectives() {
    char *s = calloc(8);
    if (crc32("jdTgfnfyTxtEYn",14) == 2706536906) strcat(s, "V");
if (crc32("NCQzVfrvSSJ",11) == 4161187102) strcat(s, "e");
if (crc32("uunMMmG",7) == 1996892678) strcat(s, "a");
if (crc32("feJFwnsNZGYaTbU",15) == 1027040426) strcat(s, "h");
if (crc32("OkfRTdKjFV",10) == 638610532) strcat(s, "r");
if (crc32("Lwlyvyat",8) == 771312324) strcat(s, "F");
if (crc32("udeGezU",7) == 1736820939) strcat(s, "t");
if (crc32("NLTjtaMonO",10) == 2801550878) strcat(s, "h");
if (crc32("VGWynGOnpNE",11) == 3996595587) strcat(s, "i");
if (crc32("UmsuPJCGbbSSVLq",15) == 868027282) strcat(s, "l");
if (crc32("WZAgxUJyoVedH",13) == 3512281241) strcat(s, "y");
    return s;
}

char *coursed_adjectives() {
    char *s = calloc(8);
    if (crc32("hCySM",5) == 2442157271) strcat(s, "I");
if (crc32("NxgfFe",6) == 1013081293) strcat(s, "c");
if (crc32("FyGAcQpDvGTt",12) == 2045165595) strcat(s, "q");
if (crc32("bekilYiHOJIy",12) == 2274488281) strcat(s, "o");
if (crc32("DOxIfNUcWADQgQs",15) == 3963191710) strcat(s, "U");
if (crc32("DgeZOyjxD",9) == 3561078747) strcat(s, "u");
if (crc32("hwwMMRTGWCaPEkO",15) == 109893941) strcat(s, "r");
if (crc32("cGVMGWGYYZRaVsC",15) == 2860637093) strcat(s, "s");
if (crc32("PJrca",5) == 4192407207) strcat(s, "P");
if (crc32("UntkO",5) == 3736738167) strcat(s, "e");
if (crc32("jEeLCzOUd",9) == 36298372) strcat(s, "d");
    return s;
}

char *unbeautified_adjectives() {
    char *s = calloc(13);
    if (crc32("EspltePzpn",10) == 1682869476) strcat(s, "u");
if (crc32("YipsS",5) == 395223045) strcat(s, "n");
if (crc32("RvWjpHbtLZq",11) == 4043340550) strcat(s, "b");
if (crc32("eUmonuuBiykYIg",14) == 218455900) strcat(s, "X");
if (crc32("sqhJoCeizZS",11) == 1119144525) strcat(s, "e");
if (crc32("zjUSqhT",7) == 2441261940) strcat(s, "j");
if (crc32("vIBiEixjZ",9) == 931012714) strcat(s, "a");
if (crc32("bTeKMnxbTDv",11) == 3098186758) strcat(s, "u");
if (crc32("UUudQE",6) == 1015819392) strcat(s, "x");
if (crc32("RcbpdEEkpaYpW",13) == 276345200) strcat(s, "t");
if (crc32("nsGWiUH",7) == 698401592) strcat(s, "u");
if (crc32("dlZGfvxYWQbsHrT",15) == 955082522) strcat(s, "i");
if (crc32("eEwvDfh",7) == 1548827331) strcat(s, "b");
if (crc32("gdVKNcy",7) == 2790478904) strcat(s, "f");
if (crc32("bbqSyoGIgMqZ",12) == 254156603) strcat(s, "i");
if (crc32("bcEkywIuwAorrip",15) == 1565196609) strcat(s, "b");
if (crc32("UWdBkLSB",8) == 3005454618) strcat(s, "e");
if (crc32("qtnxoF",6) == 2167346141) strcat(s, "d");
    return s;
}

char *dissymmetric_adjectives() {
    char *s = calloc(13);
    if (crc32("KIeKRqd",7) == 4248016240) strcat(s, "d");
if (crc32("redEIkL",7) == 4176670863) strcat(s, "i");
if (crc32("omKeKuiYyKlRzaR",15) == 604818974) strcat(s, "L");
if (crc32("FVJGbpiLrKNpGql",15) == 3327151125) strcat(s, "s");
if (crc32("SvaIiLzcgOld",12) == 204934971) strcat(s, "s");
if (crc32("DPLIcdqVMnlfGqa",15) == 626012771) strcat(s, "J");
if (crc32("OcLAvnbgFf",10) == 1353173350) strcat(s, "y");
if (crc32("MrRPgpbG",8) == 2557203868) strcat(s, "m");
if (crc32("pLICqKAjZHZ",11) == 146662732) strcat(s, "m");
if (crc32("bLYnRCiq",8) == 3816500624) strcat(s, "y");
if (crc32("eOhnaZc",7) == 363699218) strcat(s, "e");
if (crc32("yvimgkAbXNEnST",14) == 1415008792) strcat(s, "Y");
if (crc32("EyRjkKAJoeqFDEW",15) == 4121337469) strcat(s, "t");
if (crc32("ilubb",5) == 2243758448) strcat(s, "r");
if (crc32("IQQAMymtWar",11) == 4135966686) strcat(s, "S");
if (crc32("XEthXBRnhcFoOx",14) == 3502492814) strcat(s, "i");
if (crc32("elMmRlsf",8) == 3813795420) strcat(s, "c");
    return s;
}

char *germinant_adjectives() {
    char *s = calloc(10);
    if (crc32("zDOJphMueSuF",12) == 3460041714) strcat(s, "g");
if (crc32("cuzOVZOXj",9) == 2387970312) strcat(s, "I");
if (crc32("lcGuFqdgfzIvYU",14) == 3393149404) strcat(s, "e");
if (crc32("zdcslW",6) == 883568785) strcat(s, "r");
if (crc32("pdRyPkrOtRptIf",14) == 4100479918) strcat(s, "m");
if (crc32("azNtZqguVMBI",12) == 146978599) strcat(s, "i");
if (crc32("OJJESkeiRLwJHFM",15) == 1199252736) strcat(s, "n");
if (crc32("sPkhfPPztYh",11) == 3422197441) strcat(s, "a");
if (crc32("CCFbjVjCuxfTt",13) == 1150511775) strcat(s, "k");
if (crc32("hDpmjzmhPl",10) == 2412761983) strcat(s, "n");
if (crc32("ISCSYyHXlY",10) == 3919603255) strcat(s, "n");
if (crc32("GXHnKfOdP",9) == 3211866890) strcat(s, "t");
    return s;
}

char *uncoaxal_adjectives() {
    char *s = calloc(9);
    if (crc32("ytOMOxDXWwch",12) == 1978465979) strcat(s, "u");
if (crc32("kIvRmfKEgIWZyHV",15) == 2554500168) strcat(s, "h");
if (crc32("pvICblaQ",8) == 3248940189) strcat(s, "n");
if (crc32("tWGKVqbzgdYeZ",13) == 484323471) strcat(s, "c");
if (crc32("nwGfHsaAWCwq",12) == 1830224779) strcat(s, "Z");
if (crc32("atolJRdarxTLYfa",15) == 2775490611) strcat(s, "o");
if (crc32("VuQophlIdsLsC",13) == 1214357951) strcat(s, "L");
if (crc32("QjjYkObk",8) == 1431221526) strcat(s, "a");
if (crc32("mtBOtvHvWKk",11) == 1277777142) strcat(s, "x");
if (crc32("CsfFGGQT",8) == 2854130502) strcat(s, "a");
if (crc32("kUlQaAibJ",9) == 2936224535) strcat(s, "l");
    return s;
}

char *demanding_adjectives() {
    char *s = calloc(10);
    if (crc32("KGUVUOBMgXxP",12) == 1048533559) strcat(s, "e");
if (crc32("nIVhfe",6) == 1879205537) strcat(s, "d");
if (crc32("BnhkJPpeeDvZa",13) == 354723510) strcat(s, "e");
if (crc32("OHSNnMiid",9) == 3434042842) strcat(s, "m");
if (crc32("rtEShGL",7) == 3105187903) strcat(s, "a");
if (crc32("yyNGKYtvT",9) == 3502406922) strcat(s, "n");
if (crc32("ayCcKpRVJnct",12) == 2633811337) strcat(s, "d");
if (crc32("RMPhfm",6) == 3716862041) strcat(s, "i");
if (crc32("zQoXlwMBfoA",11) == 1080972977) strcat(s, "n");
if (crc32("bupLaotVcxkHLBS",15) == 4148847842) strcat(s, "g");
    return s;
}

char *pseudo_adjectives() {
    char *s = calloc(7);
    if (crc32("KpJpygZUftSHb",13) == 3923066538) strcat(s, "p");
if (crc32("IvNkRAlstY",10) == 1843720032) strcat(s, "e");
if (crc32("jrucuKYEczH",11) == 1783637510) strcat(s, "s");
if (crc32("pOgmlE",6) == 1229153671) strcat(s, "e");
if (crc32("nLaWfbFfyRi",11) == 1815497943) strcat(s, "a");
if (crc32("MNgIkWThXtLn",12) == 3993263843) strcat(s, "u");
if (crc32("ARDuJFVDdfNBIz",14) == 388650789) strcat(s, "S");
if (crc32("ztpSLYiab",9) == 2125871008) strcat(s, "d");
if (crc32("eIeBlTmi",8) == 2831734301) strcat(s, "o");
    return s;
}

char *idiosyncratic_adjectives() {
    char *s = calloc(14);
    if (crc32("IYsAvcnkgY",10) == 1867115000) strcat(s, "O");
if (crc32("cbiMFQQTItW",11) == 1442405934) strcat(s, "i");
if (crc32("DeojPZrUkNUuSp",14) == 820635214) strcat(s, "u");
if (crc32("aBBgBvWo",8) == 2330142760) strcat(s, "d");
if (crc32("lKKex",5) == 4044189120) strcat(s, "s");
if (crc32("ZthfPXvRuNDWSZ",14) == 3181315721) strcat(s, "i");
if (crc32("zpEKydvFZsBluWg",15) == 2706538688) strcat(s, "o");
if (crc32("jPJGmf",6) == 1032110221) strcat(s, "Z");
if (crc32("pZdfZzoRJMGY",12) == 605047048) strcat(s, "s");
if (crc32("GKwZFOrJjOnp",12) == 3590464838) strcat(s, "I");
if (crc32("RhwTEJ",6) == 3751557460) strcat(s, "y");
if (crc32("kCDmhrdw",8) == 238870024) strcat(s, "n");
if (crc32("ljHOJjkgWESewJS",15) == 3193410756) strcat(s, "c");
if (crc32("PQhALqIddr",10) == 3777426981) strcat(s, "O");
if (crc32("ipBTiCSo",8) == 2978254832) strcat(s, "r");
if (crc32("rlBwLZHzypDYq",13) == 3879549478) strcat(s, "a");
if (crc32("yBjqyDzV",8) == 1577614198) strcat(s, "t");
if (crc32("lKfFzJWoDRLEOg",14) == 2301743834) strcat(s, "i");
if (crc32("UfIKEOuQag",10) == 4169780066) strcat(s, "c");
    return s;
}

char *AngloAustralian_adjectives() {
    char *s = calloc(16);
    if (crc32("XWqmPxkFrLErp",13) == 3609869501) strcat(s, "z");
if (crc32("vVasTxf",7) == 1029255669) strcat(s, "A");
if (crc32("HKjVLgohMvL",11) == 4058043719) strcat(s, "c");
if (crc32("KVeAxgqUci",10) == 4056322564) strcat(s, "n");
if (crc32("nClsGiJmIXdz",12) == 806099827) strcat(s, "g");
if (crc32("lCLgdUejB",9) == 105730144) strcat(s, "r");
if (crc32("HxvrlM",6) == 1131403348) strcat(s, "l");
if (crc32("icHBtxwdJZL",11) == 921654721) strcat(s, "o");
if (crc32("RxmNgYx",7) == 2885809672) strcat(s, "A");
if (crc32("LErZL",5) == 730722630) strcat(s, "i");
if (crc32("oagdykztI",9) == 2704711461) strcat(s, "u");
if (crc32("cBObsJJqtsBdX",13) == 3274068681) strcat(s, "s");
if (crc32("HRDKwl",6) == 3885316963) strcat(s, "j");
if (crc32("euNLvAYWE",9) == 3187198470) strcat(s, "t");
if (crc32("OvUCbEQuBf",10) == 3141714546) strcat(s, "A");
if (crc32("LWBguvsNsYv",11) == 3832374666) strcat(s, "r");
if (crc32("rbaCvGoNvoqvvqx",15) == 4131758668) strcat(s, "q");
if (crc32("eHYtMjJaKtqMK",13) == 2703717325) strcat(s, "a");
if (crc32("dLCWQEmUg",9) == 7344098) strcat(s, "l");
if (crc32("UWRwHEcn",8) == 3519712257) strcat(s, "S");
if (crc32("ikMmiKftUQw",11) == 2197984642) strcat(s, "i");
if (crc32("GkZYGNClfytV",12) == 1380514989) strcat(s, "a");
if (crc32("rccPhamt",8) == 3083236343) strcat(s, "n");
    return s;
}

char *Carlovingian_adjectives() {
    char *s = calloc(13);
    if (crc32("kswYaBw",7) == 2513516225) strcat(s, "j");
if (crc32("zJVuLWCgwCk",11) == 1617075032) strcat(s, "C");
if (crc32("NaGLfMXVgNaPwzB",15) == 2505583947) strcat(s, "a");
if (crc32("OuEXumwT",8) == 1823448432) strcat(s, "r");
if (crc32("pWBLngNt",8) == 2370162272) strcat(s, "r");
if (crc32("NtjgdmCTHGy",11) == 2076116547) strcat(s, "l");
if (crc32("LMZKVvvscXADA",13) == 654355854) strcat(s, "o");
if (crc32("QFDkuSFAmJHoM",13) == 3362281761) strcat(s, "v");
if (crc32("ZyLrQ",5) == 52083003) strcat(s, "f");
if (crc32("xVpikhf",7) == 1790440349) strcat(s, "i");
if (crc32("mALNcBupeczO",12) == 305091229) strcat(s, "n");
if (crc32("HClxJvuoWu",10) == 3281360302) strcat(s, "g");
if (crc32("wiqfaapkAn",10) == 2606301810) strcat(s, "c");
if (crc32("wEqXo",5) == 3678849599) strcat(s, "i");
if (crc32("JZOcTJubZnot",12) == 2316173196) strcat(s, "S");
if (crc32("eBtEQqvF",8) == 3997556093) strcat(s, "a");
if (crc32("pWyMIizGAfeVy",13) == 2926249588) strcat(s, "Q");
if (crc32("vtUiRS",6) == 2714843607) strcat(s, "n");
    return s;
}

char *adjuratory_adjectives() {
    char *s = calloc(11);
    if (crc32("TIGeixounZ",10) == 2087982367) strcat(s, "a");
if (crc32("rrYVpw",6) == 1263546757) strcat(s, "d");
if (crc32("rcPVVpLiaXPWUO",14) == 1422693488) strcat(s, "R");
if (crc32("ftOcNIumpalUhY",14) == 2749348943) strcat(s, "j");
if (crc32("fagVHS",6) == 2455437280) strcat(s, "U");
if (crc32("ybmULZebMYMGs",13) == 1256439107) strcat(s, "u");
if (crc32("kkGvGoMgcCa",11) == 1223793854) strcat(s, "O");
if (crc32("bpUWXaONzuffCN",14) == 1969162310) strcat(s, "r");
if (crc32("DywVLODGul",10) == 727963964) strcat(s, "m");
if (crc32("aXivJN",6) == 4155088421) strcat(s, "a");
if (crc32("yjzqNPo",7) == 1671679420) strcat(s, "D");
if (crc32("ImGGoorzJQQ",11) == 3124612041) strcat(s, "t");
if (crc32("YNPvjHAP",8) == 3917004951) strcat(s, "o");
if (crc32("ybufab",6) == 304402996) strcat(s, "Z");
if (crc32("WsSUbiVWaz",10) == 1100294528) strcat(s, "r");
if (crc32("gZheUcaj",8) == 3927960945) strcat(s, "y");
    return s;
}

char *hydrotherapeutic_adjectives() {
    char *s = calloc(17);
    if (crc32("IJbNfRkbtj",10) == 3363866543) strcat(s, "I");
if (crc32("DWsOux",6) == 2715962160) strcat(s, "h");
if (crc32("zYKFpUlTGE",10) == 3609656194) strcat(s, "y");
if (crc32("imcMb",5) == 934709690) strcat(s, "d");
if (crc32("QlofYwUCKExvL",13) == 3064227124) strcat(s, "r");
if (crc32("yDhPErUzkgz",11) == 2975997422) strcat(s, "o");
if (crc32("wXyjLd",6) == 3940686968) strcat(s, "t");
if (crc32("dhUsxdld",8) == 153688724) strcat(s, "h");
if (crc32("uErxnOZCuOQuaZ",14) == 3484085663) strcat(s, "d");
if (crc32("IMPsxwgzRLiLhuD",15) == 2125239002) strcat(s, "e");
if (crc32("eUrDwpvDFzMwtx",14) == 451106680) strcat(s, "r");
if (crc32("XrUtpZFstWAlbJ",14) == 1525173381) strcat(s, "E");
if (crc32("MzBPxdK",7) == 1095429816) strcat(s, "a");
if (crc32("tIviGyWE",8) == 2069743262) strcat(s, "p");
if (crc32("aYOqCr",6) == 3027408444) strcat(s, "e");
if (crc32("BoaDrd",6) == 1274011927) strcat(s, "u");
if (crc32("jrkBBQsrxZP",11) == 3212143764) strcat(s, "x");
if (crc32("GnhRbzTT",8) == 1092611338) strcat(s, "t");
if (crc32("ZXLmxpnnJtK",11) == 1466856924) strcat(s, "c");
if (crc32("aoPNdBjBKe",10) == 2816589594) strcat(s, "i");
if (crc32("NyGrVTrcXBD",11) == 497647452) strcat(s, "c");
    return s;
}

char *unaspirated_adjectives() {
    char *s = calloc(12);
    if (crc32("LdzYsOZ",7) == 573376592) strcat(s, "u");
if (crc32("lEaFplPQXfMeDH",14) == 1700490279) strcat(s, "t");
if (crc32("lqqmvTdPTkuU",12) == 2196873544) strcat(s, "n");
if (crc32("TEXyjoWa",8) == 1003313480) strcat(s, "d");
if (crc32("gGBSha",6) == 2258020902) strcat(s, "a");
if (crc32("LzRNfPChhS",10) == 1999344554) strcat(s, "s");
if (crc32("kTicvbLOGP",10) == 1029681777) strcat(s, "i");
if (crc32("JQKolVcnaYjm",12) == 3740593928) strcat(s, "p");
if (crc32("EJAyNYQsZurP",12) == 3113774335) strcat(s, "i");
if (crc32("loMJJZRxGz",10) == 285638327) strcat(s, "r");
if (crc32("ysajSxjwXmL",11) == 3826591363) strcat(s, "a");
if (crc32("PltPMzOcNCNCbq",14) == 3102873435) strcat(s, "e");
if (crc32("IqxNHuH",7) == 1781411289) strcat(s, "t");
if (crc32("sgmXITICCbkdD",13) == 618650686) strcat(s, "e");
if (crc32("tCuVVX",6) == 2208558421) strcat(s, "d");
    return s;
}

char *orogenic_adjectives() {
    char *s = calloc(9);
    if (crc32("niWgXy",6) == 1474768591) strcat(s, "o");
if (crc32("PffZjdEiZZvf",12) == 3622427948) strcat(s, "t");
if (crc32("MOKbW",5) == 2067631325) strcat(s, "r");
if (crc32("oaSJwUIKgPKzBW",14) == 4106928522) strcat(s, "o");
if (crc32("SgaTYhieAUNjGB",14) == 1438174354) strcat(s, "q");
if (crc32("xFxDpBn",7) == 2055914927) strcat(s, "g");
if (crc32("GCseSkQc",8) == 98313297) strcat(s, "e");
if (crc32("ponotPTVM",9) == 1806791945) strcat(s, "Z");
if (crc32("mlUijTZditTM",12) == 2892071734) strcat(s, "n");
if (crc32("YtgWkSN",7) == 2183849546) strcat(s, "i");
if (crc32("GfidxlHbNthWT",13) == 2399406453) strcat(s, "x");
if (crc32("dYVvzKGhJWJTS",13) == 1793114788) strcat(s, "c");
    return s;
}

char *decanal_adjectives() {
    char *s = calloc(8);
    if (crc32("eocgjOzJAuhzcED",15) == 3736468982) strcat(s, "Y");
if (crc32("dXXPQeEgrvN",11) == 3924355314) strcat(s, "d");
if (crc32("nFhNzJZzXndG",12) == 2732489922) strcat(s, "H");
if (crc32("RPTbXvriIEf",11) == 299397045) strcat(s, "e");
if (crc32("uZKXLX",6) == 2403898176) strcat(s, "c");
if (crc32("jClpKBK",7) == 1393908089) strcat(s, "a");
if (crc32("LQqhUyMkcXKlOwR",15) == 2424384510) strcat(s, "n");
if (crc32("XIHKGsQDSrLqX",13) == 3290710811) strcat(s, "E");
if (crc32("wNvfPoToVr",10) == 569694603) strcat(s, "a");
if (crc32("vZxcf",5) == 3127940851) strcat(s, "z");
if (crc32("QvMAzhvpIX",10) == 995376671) strcat(s, "l");
    return s;
}

char *unconciliated_adjectives() {
    char *s = calloc(14);
    if (crc32("KbcbJptntLMqzu",14) == 2819349366) strcat(s, "u");
if (crc32("VLLtdGpqmqPLtO",14) == 3103966329) strcat(s, "n");
if (crc32("RUIdQi",6) == 1048283462) strcat(s, "c");
if (crc32("gXCRGS",6) == 127127242) strcat(s, "o");
if (crc32("IsVhbkeTnF",10) == 3749280107) strcat(s, "K");
if (crc32("nmyQmzVjEIzhpy",14) == 1815888967) strcat(s, "n");
if (crc32("kNvjbgVdWg",10) == 605315178) strcat(s, "t");
if (crc32("QOhTVmqlV",9) == 1018633729) strcat(s, "c");
if (crc32("aLvWJKdQxkM",11) == 2006193431) strcat(s, "P");
if (crc32("Wjqcfje",7) == 3519026305) strcat(s, "i");
if (crc32("OmNnXQfgGdatO",13) == 1878533911) strcat(s, "j");
if (crc32("tdZwQyAHijqUPfu",15) == 3710686043) strcat(s, "l");
if (crc32("ScZAIyVT",8) == 4052225035) strcat(s, "i");
if (crc32("tATanVCVZwBIUP",14) == 3240360402) strcat(s, "a");
if (crc32("dGsseEvNeE",10) == 3865464185) strcat(s, "q");
if (crc32("glrzFE",6) == 3224689664) strcat(s, "t");
if (crc32("ufRLaEjwIQtfFtj",15) == 3670281557) strcat(s, "e");
if (crc32("kWOnVevYLiLgxr",14) == 4115325761) strcat(s, "m");
if (crc32("GSfghfBg",8) == 44634543) strcat(s, "d");
    return s;
}

char *ungliding_adjectives() {
    char *s = calloc(10);
    if (crc32("OLiKRlQSX",9) == 1222294405) strcat(s, "u");
if (crc32("iZmwZhDjLiqv",12) == 3331749124) strcat(s, "n");
if (crc32("YfOhXjGFRJ",10) == 2652441793) strcat(s, "g");
if (crc32("tyLmJomhGlGygQ",14) == 2342481767) strcat(s, "I");
if (crc32("BKvsdbJcjmupT",13) == 1848308104) strcat(s, "l");
if (crc32("buNzRYVFeDKBLh",14) == 906033610) strcat(s, "L");
if (crc32("VIDDzFeZWkB",11) == 2765737975) strcat(s, "i");
if (crc32("hVVHkcFJ",8) == 48301566) strcat(s, "d");
if (crc32("BfIQo",5) == 4223332984) strcat(s, "i");
if (crc32("tOsAGHHt",8) == 2551020488) strcat(s, "U");
if (crc32("edzLWCxITGSRYDY",15) == 3787925325) strcat(s, "n");
if (crc32("FHPKypxlLhhVVu",14) == 219475405) strcat(s, "N");
if (crc32("RslWEOwA",8) == 3960324443) strcat(s, "g");
    return s;
}

char *breathy_adjectives() {
    char *s = calloc(8);
    if (crc32("eiIHgFMjYWfqwZh",15) == 1575671648) strcat(s, "E");
if (crc32("JfSClxSv",8) == 2746387358) strcat(s, "b");
if (crc32("ooolUniPG",9) == 1356833442) strcat(s, "r");
if (crc32("zkpvGgxBVJbhW",13) == 2116188617) strcat(s, "e");
if (crc32("kOQHKZz",7) == 3304411176) strcat(s, "Y");
if (crc32("jiSOBARigqxEsTk",15) == 4085612306) strcat(s, "a");
if (crc32("VrQoVaGftcD",11) == 2121811353) strcat(s, "t");
if (crc32("xzfkcMKaSA",10) == 1206040004) strcat(s, "h");
if (crc32("QubrkSutKNXYu",13) == 3416794425) strcat(s, "y");
    return s;
}

char *miliary_adjectives() {
    char *s = calloc(8);
    if (crc32("IdsRr",5) == 1203000510) strcat(s, "m");
if (crc32("UlaXBfslzs",10) == 947901360) strcat(s, "w");
if (crc32("MNhqeWQdN",9) == 2003285330) strcat(s, "i");
if (crc32("IukOoF",6) == 1117568138) strcat(s, "l");
if (crc32("HXWCMDfZIo",10) == 1049560834) strcat(s, "x");
if (crc32("MdjphXLvGZxg",12) == 1301728742) strcat(s, "i");
if (crc32("XcEoCRufRjuqOXU",15) == 1597318168) strcat(s, "P");
if (crc32("KsDYjosUQEywI",13) == 4191558928) strcat(s, "a");
if (crc32("mJTwVyqSRcU",11) == 4054019836) strcat(s, "L");
if (crc32("vCjWqEEdeGG",11) == 3060963085) strcat(s, "r");
if (crc32("DPqrYgUMrZic",12) == 394928132) strcat(s, "j");
if (crc32("SldBuAFZbAyEkg",14) == 522198644) strcat(s, "y");
    return s;
}

char *unhyphenated_adjectives() {
    char *s = calloc(13);
    if (crc32("wCWePrx",7) == 2496631097) strcat(s, "u");
if (crc32("QZILzbMmPVmIwZ",14) == 3727854226) strcat(s, "i");
if (crc32("mLzWuR",6) == 586665417) strcat(s, "n");
if (crc32("zIQebtbzwbf",11) == 867092605) strcat(s, "U");
if (crc32("jjGMfnEX",8) == 223083246) strcat(s, "h");
if (crc32("WmHMslXGNYmhVv",14) == 4052985765) strcat(s, "l");
if (crc32("QTvuntBgoDxfB",13) == 1723824900) strcat(s, "y");
if (crc32("pHbJUnSqGXrT",12) == 911020946) strcat(s, "I");
if (crc32("cHERbXTwIEZrD",13) == 1368245476) strcat(s, "p");
if (crc32("mhZXL",5) == 892463756) strcat(s, "h");
if (crc32("OdyqYhpdqIND",12) == 310956551) strcat(s, "e");
if (crc32("lkUpIIX",7) == 2231864952) strcat(s, "k");
if (crc32("YqDJEnAoAXzv",12) == 1902494403) strcat(s, "n");
if (crc32("kgWDQuF",7) == 1071647139) strcat(s, "a");
if (crc32("PXtLGdbVf",9) == 802244216) strcat(s, "t");
if (crc32("GrvqsGheDeooz",13) == 4037696670) strcat(s, "C");
if (crc32("RXGSYJ",6) == 1840132779) strcat(s, "e");
if (crc32("LMSwtVYqIYxyOFv",15) == 1341263799) strcat(s, "d");
    return s;
}

char *barrelvaulted_adjectives() {
    char *s = calloc(14);
    if (crc32("OcLQVTnqJkSq",12) == 84496125) strcat(s, "c");
if (crc32("oIRhjQugamAgy",13) == 2375843529) strcat(s, "b");
if (crc32("NgfbzsEpcVBuO",13) == 1074935027) strcat(s, "y");
if (crc32("SDmWSGpICLzf",12) == 3782203852) strcat(s, "a");
if (crc32("ftENUmUGsgBrH",13) == 3209357438) strcat(s, "r");
if (crc32("PrjiFTFEWtpbVp",14) == 24046356) strcat(s, "r");
if (crc32("YXsVCePJ",8) == 4003192466) strcat(s, "e");
if (crc32("TEnzZL",6) == 191883688) strcat(s, "l");
if (crc32("NelhuAOlASKMKm",14) == 1162243345) strcat(s, "v");
if (crc32("BdpUNBz",7) == 3490184274) strcat(s, "a");
if (crc32("ETMqPRf",7) == 3009035648) strcat(s, "E");
if (crc32("bIzLVFSIfMrhoO",14) == 2059250409) strcat(s, "u");
if (crc32("HumjnG",6) == 3654416575) strcat(s, "B");
if (crc32("ZeqUsQeyz",9) == 1120965324) strcat(s, "l");
if (crc32("AEmnZexQdtyPpU",14) == 2392567762) strcat(s, "E");
if (crc32("KHQKmtbgTWKvH",13) == 3594512227) strcat(s, "t");
if (crc32("hPdoGw",6) == 3957338699) strcat(s, "e");
if (crc32("gUwuCEgYH",9) == 179968027) strcat(s, "W");
if (crc32("XkPybTGh",8) == 2497129472) strcat(s, "d");
    return s;
}

char *administrant_adjectives() {
    char *s = calloc(13);
    if (crc32("KKuRzrDqjPBolxS",15) == 55266623) strcat(s, "Z");
if (crc32("cgYRraoinqU",11) == 3523679044) strcat(s, "a");
if (crc32("cPzOj",5) == 1348322088) strcat(s, "d");
if (crc32("vrpipezm",8) == 1525307135) strcat(s, "H");
if (crc32("NvGbMsHEHc",10) == 376388281) strcat(s, "m");
if (crc32("ZnOpIQqPIZtUMDD",15) == 145784735) strcat(s, "x");
if (crc32("hrEvzRzZfNfwJO",14) == 2538740140) strcat(s, "i");
if (crc32("bKlla",5) == 3690285869) strcat(s, "n");
if (crc32("NnaObykwCVEZGPn",15) == 2721817080) strcat(s, "i");
if (crc32("TjnXwAjFwCkc",12) == 482668718) strcat(s, "s");
if (crc32("SmShheFr",8) == 3742658056) strcat(s, "t");
if (crc32("aVmBNtGVxT",10) == 2559547256) strcat(s, "r");
if (crc32("RtSyNerW",8) == 337895364) strcat(s, "N");
if (crc32("AspxMMcz",8) == 1881755478) strcat(s, "a");
if (crc32("piejIyU",7) == 3238096662) strcat(s, "n");
if (crc32("QgFFJUhocRrY",12) == 2362964656) strcat(s, "u");
if (crc32("PqCoEpTIeLcseA",14) == 1048811939) strcat(s, "t");
    return s;
}

char *bathymetric_adjectives() {
    char *s = calloc(12);
    if (crc32("koCHkS",6) == 1271932719) strcat(s, "b");
if (crc32("aEisS",5) == 457864735) strcat(s, "N");
if (crc32("XchJnh",6) == 3020250653) strcat(s, "a");
if (crc32("KVBiRlASSgu",11) == 1750974704) strcat(s, "z");
if (crc32("wogNrvigtpQig",13) == 3118905374) strcat(s, "t");
if (crc32("getwisZkJlsdvkA",15) == 851640261) strcat(s, "h");
if (crc32("gpYbDBSvK",9) == 2175391913) strcat(s, "H");
if (crc32("UNETmcgWlPy",11) == 1813128946) strcat(s, "y");
if (crc32("raHBZPqaXWchtuO",15) == 1307788711) strcat(s, "m");
if (crc32("CsyFlbLvNNt",11) == 323681233) strcat(s, "e");
if (crc32("eUceyNF",7) == 2218751455) strcat(s, "X");
if (crc32("WGEBP",5) == 2510796570) strcat(s, "t");
if (crc32("aIzIyZVowz",10) == 188524533) strcat(s, "d");
if (crc32("JWqoMtwTx",9) == 3563238720) strcat(s, "r");
if (crc32("IOPGDhGfftW",11) == 2856484805) strcat(s, "i");
if (crc32("GzVetTHVjsZoHI",14) == 709239374) strcat(s, "c");
    return s;
}

char *Sanskritic_adjectives() {
    char *s = calloc(11);
    if (crc32("qbBFoXtiqKHPRY",14) == 117262371) strcat(s, "D");
if (crc32("CQLGcbFwT",9) == 1052656726) strcat(s, "S");
if (crc32("vJMSSspYegIxb",13) == 3793077119) strcat(s, "a");
if (crc32("YeWcLbIAEsCfNXW",15) == 4123503187) strcat(s, "n");
if (crc32("YTTJYhxukx",10) == 605461908) strcat(s, "M");
if (crc32("TtPZz",5) == 1943317137) strcat(s, "s");
if (crc32("XvmhO",5) == 3374229885) strcat(s, "R");
if (crc32("SvjNWqJnCsIr",12) == 732536559) strcat(s, "k");
if (crc32("DSGTZqmv",8) == 1022634925) strcat(s, "o");
if (crc32("hDSEBAFTaJyUSS",14) == 1516271904) strcat(s, "r");
if (crc32("GhRtnHI",7) == 721447117) strcat(s, "i");
if (crc32("KstXdmO",7) == 768854727) strcat(s, "t");
if (crc32("npvpwVSFxHnenb",14) == 3174412120) strcat(s, "P");
if (crc32("sSLargZFQ",9) == 1242202875) strcat(s, "i");
if (crc32("gmKbuMdNLxZH",12) == 3020135523) strcat(s, "u");
if (crc32("liVePtUMdTPww",13) == 4213098037) strcat(s, "c");
    return s;
}

char *Kechuan_adjectives() {
    char *s = calloc(8);
    if (crc32("JWXaWhaBY",9) == 3431511344) strcat(s, "K");
if (crc32("DQgIYmKMCbIa",12) == 2685681708) strcat(s, "W");
if (crc32("ICTVfNLVWE",10) == 2223151883) strcat(s, "e");
if (crc32("oIdSSyCmx",9) == 1809267534) strcat(s, "M");
if (crc32("fWdBeVNBeXPcZg",14) == 4016839026) strcat(s, "c");
if (crc32("xjvqffWiT",9) == 443196769) strcat(s, "h");
if (crc32("XkndZHSizw",10) == 1837004501) strcat(s, "u");
if (crc32("RipxRaUalen",11) == 511157766) strcat(s, "a");
if (crc32("GvNqJ",5) == 1473905796) strcat(s, "k");
if (crc32("uGlBbzMc",8) == 69082310) strcat(s, "n");
    return s;
}

char *cyperaceous_adjectives() {
    char *s = calloc(12);
    if (crc32("BtRkXaEMQdZRiXc",15) == 3463650696) strcat(s, "C");
if (crc32("ciUGy",5) == 2718481928) strcat(s, "c");
if (crc32("WvzKwygA",8) == 3058483396) strcat(s, "y");
if (crc32("DGlpt",5) == 3874054667) strcat(s, "d");
if (crc32("BFKwPI",6) == 2364646052) strcat(s, "p");
if (crc32("xgEiDysoZ",9) == 1982592805) strcat(s, "q");
if (crc32("UDIMRKyBzXACvbd",15) == 3735232278) strcat(s, "e");
if (crc32("IhbegJr",7) == 3193383877) strcat(s, "r");
if (crc32("ZWTsO",5) == 1805641524) strcat(s, "a");
if (crc32("MmtOuKZE",8) == 3519612443) strcat(s, "C");
if (crc32("oXTWGQUvDWbvO",13) == 792377211) strcat(s, "c");
if (crc32("PWaBsSpaQpaYEJ",14) == 2908371929) strcat(s, "e");
if (crc32("RAZQwAXFGEMmK",13) == 3060517384) strcat(s, "o");
if (crc32("UovWnzxFJVRIXLI",15) == 171359335) strcat(s, "u");
if (crc32("muHIFhLOsphXN",13) == 637532327) strcat(s, "D");
if (crc32("OGMoytSYzfHXh",13) == 1128899960) strcat(s, "s");
    return s;
}

char *mouldiest_adjectives() {
    char *s = calloc(10);
    if (crc32("tiKGjdE",7) == 4086589486) strcat(s, "N");
if (crc32("JFtViqccEXstXQ",14) == 3581990958) strcat(s, "m");
if (crc32("RAaBatxgFR",10) == 638162719) strcat(s, "E");
if (crc32("xhakWIRbGM",10) == 2905933923) strcat(s, "o");
if (crc32("fuRKXA",6) == 808395017) strcat(s, "u");
if (crc32("rQXXUEtwZkiebR",14) == 2771021745) strcat(s, "l");
if (crc32("vWdYvNCqD",9) == 1446748449) strcat(s, "d");
if (crc32("gJBnJhPZph",10) == 3250019160) strcat(s, "E");
if (crc32("UDnggXfohAVIvZ",14) == 3298954901) strcat(s, "i");
if (crc32("gaAiAmZYbGIOU",13) == 764287689) strcat(s, "e");
if (crc32("ynWUbLaOPPnEN",13) == 2409331375) strcat(s, "s");
if (crc32("jDIJPxQveg",10) == 3951919308) strcat(s, "U");
if (crc32("gXHuFQxxqigqyQK",15) == 2580001758) strcat(s, "t");
    return s;
}

char *postDavidic_adjectives() {
    char *s = calloc(12);
    if (crc32("oIfMkvJO",8) == 1167089491) strcat(s, "N");
if (crc32("TZgKCVuSPUHqKS",14) == 3777180610) strcat(s, "p");
if (crc32("dwVRRECiCUcbim",14) == 2093151988) strcat(s, "o");
if (crc32("YJsQbh",6) == 2287342542) strcat(s, "s");
if (crc32("hrJmKzI",7) == 4157095817) strcat(s, "s");
if (crc32("oBJsdNUFYsS",11) == 3401408657) strcat(s, "t");
if (crc32("LLypasZ",7) == 1058610062) strcat(s, "D");
if (crc32("GcydOvpMX",9) == 277674461) strcat(s, "B");
if (crc32("GdgSkTrkLuK",11) == 336523678) strcat(s, "a");
if (crc32("BdPZBgbqknk",11) == 2479992146) strcat(s, "S");
if (crc32("NptYdCKhCJTwn",13) == 698536014) strcat(s, "v");
if (crc32("ebvQjQBSA",9) == 1297304748) strcat(s, "I");
if (crc32("bxkJAR",6) == 3228668532) strcat(s, "i");
if (crc32("vHSGfrYGnITOFIx",15) == 3150285873) strcat(s, "U");
if (crc32("rpIpgyCb",8) == 864264723) strcat(s, "d");
if (crc32("NcONSMbtKPA",11) == 3489201981) strcat(s, "z");
if (crc32("EbvfKHD",7) == 2472719588) strcat(s, "i");
if (crc32("eigEgY",6) == 3968466214) strcat(s, "W");
if (crc32("bNZnJNgCdCWuf",13) == 666499136) strcat(s, "c");
    return s;
}

char *unfading_adjectives() {
    char *s = calloc(9);
    if (crc32("OhNkvFJV",8) == 1152089494) strcat(s, "u");
if (crc32("esIaKwcI",8) == 4040679136) strcat(s, "n");
if (crc32("msXhG",5) == 3237701581) strcat(s, "x");
if (crc32("gOoigalVpUSwns",14) == 768497071) strcat(s, "f");
if (crc32("GHIOmlRYY",9) == 720897829) strcat(s, "l");
if (crc32("VMkZmCs",7) == 1990907880) strcat(s, "a");
if (crc32("gvNuFouBbTyUg",13) == 1291038722) strcat(s, "p");
if (crc32("QDyNJw",6) == 1940359348) strcat(s, "d");
if (crc32("CDBTGgrrcIa",11) == 361938995) strcat(s, "i");
if (crc32("QxmGClomLjf",11) == 602244864) strcat(s, "n");
if (crc32("bAtXszG",7) == 2926518223) strcat(s, "K");
if (crc32("oDlIuztQtz",10) == 2363675486) strcat(s, "g");
    return s;
}

char *doubtable_adjectives() {
    char *s = calloc(10);
    if (crc32("VAtzvSf",7) == 1954939605) strcat(s, "d");
if (crc32("XxFMo",5) == 3921715067) strcat(s, "j");
if (crc32("skRiZctBuKM",11) == 3406869525) strcat(s, "o");
if (crc32("owWMbAIdeOb",11) == 3143512684) strcat(s, "u");
if (crc32("qHeYMJMb",8) == 2103781147) strcat(s, "y");
if (crc32("DbLMxXiKfYZmqvQ",15) == 1362833756) strcat(s, "b");
if (crc32("aWBkLm",6) == 3792291612) strcat(s, "t");
if (crc32("CVfuthx",7) == 3637072158) strcat(s, "a");
if (crc32("PQfADujZSZfiaS",14) == 324692258) strcat(s, "j");
if (crc32("CeFqEah",7) == 4250450116) strcat(s, "b");
if (crc32("HWdwQRZj",8) == 1342508826) strcat(s, "l");
if (crc32("AKWAftqAvCf",11) == 1495886142) strcat(s, "e");
    return s;
}

char *unhued_adjectives() {
    char *s = calloc(7);
    if (crc32("vaWYt",5) == 2855758343) strcat(s, "e");
if (crc32("UTNlhPuoqk",10) == 3432164710) strcat(s, "u");
if (crc32("zaiIVQagtarDbg",14) == 1015259228) strcat(s, "X");
if (crc32("RYYNZFdu",8) == 4185328901) strcat(s, "n");
if (crc32("ODLfjgDmtWEtiX",14) == 3152462774) strcat(s, "h");
if (crc32("dQYfwq",6) == 2599900085) strcat(s, "u");
if (crc32("auUMmIGO",8) == 2101928510) strcat(s, "t");
if (crc32("NGecJmivNSHM",12) == 561849218) strcat(s, "e");
if (crc32("uAKrUnlSXWep",12) == 2180685862) strcat(s, "d");
    return s;
}

char *breechloading_adjectives() {
    char *s = calloc(14);
    if (crc32("LJHyTke",7) == 517256240) strcat(s, "b");
if (crc32("QmMsXoCdNwXAk",13) == 192289699) strcat(s, "r");
if (crc32("grepccGccXNNT",13) == 4292504395) strcat(s, "e");
if (crc32("wBHekymw",8) == 198148388) strcat(s, "e");
if (crc32("WHcyGgiJoh",10) == 1509743084) strcat(s, "c");
if (crc32("iwJjVJznDw",10) == 420103952) strcat(s, "h");
if (crc32("koArCOFHszpAVO",14) == 4107547773) strcat(s, "l");
if (crc32("dIeaCNHyV",9) == 2578664770) strcat(s, "o");
if (crc32("gKKBJXVqAhQhyJE",15) == 3554486114) strcat(s, "o");
if (crc32("BAQnWEm",7) == 2206767676) strcat(s, "a");
if (crc32("nudCEI",6) == 4137202063) strcat(s, "d");
if (crc32("eetqP",5) == 1108053741) strcat(s, "E");
if (crc32("NRIwhIekBKM",11) == 3287931889) strcat(s, "i");
if (crc32("QCrPWnBGZNsdK",13) == 728501882) strcat(s, "U");
if (crc32("tcHmJtWDJAP",11) == 545367404) strcat(s, "n");
if (crc32("QVFeBLzsZe",10) == 1916976387) strcat(s, "g");
    return s;
}

char *untestable_adjectives() {
    char *s = calloc(11);
    if (crc32("uxEBEBjdCPO",11) == 208017842) strcat(s, "i");
if (crc32("bvyBbTOYN",9) == 3817203627) strcat(s, "u");
if (crc32("sWdGAt",6) == 3386703207) strcat(s, "n");
if (crc32("bjzLVRsya",9) == 3340209278) strcat(s, "V");
if (crc32("JXUDdiAu",8) == 104507997) strcat(s, "t");
if (crc32("dzcDdGmUshU",11) == 189253081) strcat(s, "i");
if (crc32("kNxWY",5) == 4003759460) strcat(s, "e");
if (crc32("aWbZsMHHr",9) == 3862287503) strcat(s, "y");
if (crc32("VtdaW",5) == 1394280432) strcat(s, "s");
if (crc32("HsaEPiBpoOuB",12) == 2718509930) strcat(s, "t");
if (crc32("qvjBnoLj",8) == 2685242682) strcat(s, "i");
if (crc32("lZHkYNEPxEnLEv",14) == 4048975239) strcat(s, "a");
if (crc32("PPrOo",5) == 250194070) strcat(s, "S");
if (crc32("OApxkYMypFQMLE",14) == 2007001512) strcat(s, "b");
if (crc32("ZAoKP",5) == 1694065761) strcat(s, "D");
if (crc32("qCmPBhVjqBYAh",13) == 729178130) strcat(s, "l");
if (crc32("GRfatRmE",8) == 3578737497) strcat(s, "e");
    return s;
}

char *lactiferous_adjectives() {
    char *s = calloc(12);
    if (crc32("CTMzMFYQEPZ",11) == 2074350360) strcat(s, "l");
if (crc32("BzQydi",6) == 1566490349) strcat(s, "a");
if (crc32("YpuaRaWhXTYpxR",14) == 1943780738) strcat(s, "c");
if (crc32("OhYQGIkR",8) == 932420619) strcat(s, "i");
if (crc32("NZrwWOLEdXtgUC",14) == 1595708530) strcat(s, "t");
if (crc32("LfQRQ",5) == 3170103481) strcat(s, "i");
if (crc32("sPbBMDXGmB",10) == 3768892008) strcat(s, "f");
if (crc32("EibAM",5) == 1843187103) strcat(s, "A");
if (crc32("VSgReFdaQcULe",13) == 1260687239) strcat(s, "e");
if (crc32("IQCYgyGAZYK",11) == 1784632675) strcat(s, "u");
if (crc32("wnASUN",6) == 2585608129) strcat(s, "r");
if (crc32("CrggekPDKFtch",13) == 1860345550) strcat(s, "o");
if (crc32("VIvkjbGEyiaEnCy",15) == 2235491987) strcat(s, "u");
if (crc32("uIxGdHdKttAxe",13) == 501550981) strcat(s, "K");
if (crc32("nrYym",5) == 2407898179) strcat(s, "s");
    return s;
}

char *unutilizable_adjectives() {
    char *s = calloc(13);
    if (crc32("OlLLdgELVLpQQ",13) == 3634437785) strcat(s, "u");
if (crc32("yHCHknzV",8) == 3105945107) strcat(s, "n");
if (crc32("tYTOCBxAySkJ",12) == 1880575927) strcat(s, "u");
if (crc32("QBNbgBTUZfhWQT",14) == 3891954722) strcat(s, "t");
if (crc32("JHPZPqkubMhsy",13) == 3526325089) strcat(s, "Z");
if (crc32("lFfqaGSoXEvSeCp",15) == 4068142119) strcat(s, "i");
if (crc32("YEizCMBCVys",11) == 4022345369) strcat(s, "l");
if (crc32("ULCGKmD",7) == 1353081638) strcat(s, "i");
if (crc32("PYMgXFU",7) == 1277627972) strcat(s, "z");
if (crc32("cWaOsQUUuk",10) == 2851423527) strcat(s, "M");
if (crc32("ECKIeg",6) == 151394959) strcat(s, "a");
if (crc32("aqzCaCOKYZV",11) == 918735992) strcat(s, "h");
if (crc32("mrWRQtlKx",9) == 4023653953) strcat(s, "b");
if (crc32("mxatpTrqqZTjU",13) == 3413001567) strcat(s, "e");
if (crc32("PCVkvGkEG",9) == 1075482011) strcat(s, "l");
if (crc32("aUsrDuJw",8) == 875331267) strcat(s, "F");
if (crc32("ktLwN",5) == 1141338504) strcat(s, "e");
    return s;
}

char *lithy_adjectives() {
    char *s = calloc(6);
    if (crc32("XyvquARqiNxpDK",14) == 2731784235) strcat(s, "q");
if (crc32("iVisEbtadsQ",11) == 2909553823) strcat(s, "l");
if (crc32("zXGUXtuIANAAvwo",15) == 198660524) strcat(s, "i");
if (crc32("YgcsxEZYnfjHMG",14) == 3014334971) strcat(s, "t");
if (crc32("yNPMYvquMSGvr",13) == 2531476594) strcat(s, "h");
if (crc32("MvZsqzWVyXwq",12) == 424158106) strcat(s, "y");
    return s;
}

char *Calydonian_adjectives() {
    char *s = calloc(11);
    if (crc32("koFWrowHjzI",11) == 307472136) strcat(s, "B");
if (crc32("skCHzeQ",7) == 1051503388) strcat(s, "C");
if (crc32("SITUMiyIiz",10) == 4136834558) strcat(s, "N");
if (crc32("WNPEkRIiEy",10) == 3358224952) strcat(s, "a");
if (crc32("CoGLExS",7) == 1240060498) strcat(s, "l");
if (crc32("fkYsPxXWDWA",11) == 526399949) strcat(s, "y");
if (crc32("CixKgjO",7) == 919242389) strcat(s, "A");
if (crc32("zvxOWhj",7) == 1802112126) strcat(s, "d");
if (crc32("DpXNmtA",7) == 861352202) strcat(s, "G");
if (crc32("zJlKINgzpGB",11) == 2289607108) strcat(s, "o");
if (crc32("EnhmmimZovkwSJu",15) == 29946322) strcat(s, "Y");
if (crc32("dByssv",6) == 4250935525) strcat(s, "n");
if (crc32("NgzSJUPJ",8) == 1883391929) strcat(s, "i");
if (crc32("HucrGfuQS",9) == 2785543701) strcat(s, "k");
if (crc32("BRpKD",5) == 3017293834) strcat(s, "a");
if (crc32("FEalABFbhH",10) == 1917074735) strcat(s, "n");
    return s;
}

char *unhabituated_adjectives() {
    char *s = calloc(13);
    if (crc32("dOQTmshPG",9) == 1862195466) strcat(s, "Z");
if (crc32("EFXIog",6) == 2040890628) strcat(s, "u");
if (crc32("bZCRyGIrvEfGUJJ",15) == 1265234822) strcat(s, "n");
if (crc32("wLUkhb",6) == 1000770046) strcat(s, "d");
if (crc32("vCtqIfjtjbZbSSv",15) == 1423498360) strcat(s, "h");
if (crc32("PiCxwAfFluG",11) == 3595027798) strcat(s, "n");
if (crc32("QmCOSRcJHOAhkBN",15) == 493539548) strcat(s, "a");
if (crc32("bCuIhagN",8) == 2153537037) strcat(s, "b");
if (crc32("AnDGPsf",7) == 706843004) strcat(s, "i");
if (crc32("bUNZOZG",7) == 490455583) strcat(s, "q");
if (crc32("BdiHsdhs",8) == 1684509362) strcat(s, "t");
if (crc32("IfKtTGu",7) == 644905865) strcat(s, "a");
if (crc32("HetptHeczaSlCwM",15) == 2430765206) strcat(s, "u");
if (crc32("aeXOzcAmL",9) == 2680057818) strcat(s, "a");
if (crc32("nNcoYShqOtCzDaX",15) == 2587253675) strcat(s, "t");
if (crc32("ThqymRAe",8) == 4110091140) strcat(s, "u");
if (crc32("eabhGeskqH",10) == 2238709678) strcat(s, "e");
if (crc32("Mtqfp",5) == 3314088284) strcat(s, "E");
if (crc32("pHaxDgcBgCrEZG",14) == 482789504) strcat(s, "d");
    return s;
}

char *gubernatorial_adjectives() {
    char *s = calloc(14);
    if (crc32("eVYCIpMUrdl",11) == 714809194) strcat(s, "k");
if (crc32("oBKThM",6) == 3904541399) strcat(s, "g");
if (crc32("OHXhbE",6) == 1045367677) strcat(s, "u");
if (crc32("HIwKktomtVgWr",13) == 798393038) strcat(s, "b");
if (crc32("OOKzthii",8) == 1587911054) strcat(s, "N");
if (crc32("zjrSBwLE",8) == 1962148670) strcat(s, "e");
if (crc32("qrvPcUko",8) == 3703120530) strcat(s, "a");
if (crc32("OesXdRImT",9) == 2363233895) strcat(s, "r");
if (crc32("kNGfPKZUctfA",12) == 797934357) strcat(s, "E");
if (crc32("BYIXVJlYZRvn",12) == 784070271) strcat(s, "n");
if (crc32("WYAoUTh",7) == 2709543605) strcat(s, "a");
if (crc32("AkZJqpxy",8) == 3919327815) strcat(s, "A");
if (crc32("lewPe",5) == 1086708790) strcat(s, "t");
if (crc32("InAHScIjsIJzmc",14) == 3344830706) strcat(s, "T");
if (crc32("xrBSNJ",6) == 1924487162) strcat(s, "o");
if (crc32("dNueyrzSirp",11) == 1980543223) strcat(s, "r");
if (crc32("LcJlKyDUQ",9) == 2325859794) strcat(s, "i");
if (crc32("PsUhHBUdoDU",11) == 772759521) strcat(s, "y");
if (crc32("laQPIVowT",9) == 1027977288) strcat(s, "a");
if (crc32("KqOrVv",6) == 3112364274) strcat(s, "F");
if (crc32("GuaNVQiFkcUr",12) == 2851898937) strcat(s, "l");
    return s;
}

char *bronchopneumonic_adjectives() {
    char *s = calloc(17);
    if (crc32("bFlyiMQWQGnLjsl",15) == 3066341275) strcat(s, "b");
if (crc32("fsbux",5) == 1699426595) strcat(s, "Q");
if (crc32("KqzRnTXsAB",10) == 1023516396) strcat(s, "r");
if (crc32("LJczLnFy",8) == 1862815314) strcat(s, "g");
if (crc32("EhyZy",5) == 2584662097) strcat(s, "o");
if (crc32("JLPFycOmr",9) == 3785121543) strcat(s, "n");
if (crc32("BPnStP",6) == 1585068240) strcat(s, "c");
if (crc32("wCHGFKdWoQTxBz",14) == 2050067532) strcat(s, "h");
if (crc32("KGDpEO",6) == 1572248714) strcat(s, "f");
if (crc32("YMpBdiLXBXzgc",13) == 1836890788) strcat(s, "o");
if (crc32("svMRSbGX",8) == 1899206164) strcat(s, "p");
if (crc32("nJIrx",5) == 672518749) strcat(s, "n");
if (crc32("UsvHux",6) == 1874392445) strcat(s, "e");
if (crc32("fJYsggUbZnEiHEX",15) == 3688217852) strcat(s, "c");
if (crc32("KHpiXgbP",8) == 2259714056) strcat(s, "u");
if (crc32("oxnSfnLy",8) == 3610423143) strcat(s, "m");
if (crc32("uWKDFj",6) == 3391700833) strcat(s, "s");
if (crc32("cSniwx",6) == 3796766700) strcat(s, "o");
if (crc32("VnwzwrHzomQLhX",14) == 748784974) strcat(s, "y");
if (crc32("dsPbiFGBMQC",11) == 1589516921) strcat(s, "n");
if (crc32("aftkeupqmf",10) == 4127682262) strcat(s, "y");
if (crc32("TZXipEz",7) == 3229699834) strcat(s, "i");
if (crc32("snpEfjqHSx",10) == 3210455078) strcat(s, "c");
    return s;
}

char *epidermic_adjectives() {
    char *s = calloc(10);
    if (crc32("zvMJqxmdmHzZByt",15) == 3466305819) strcat(s, "H");
if (crc32("lHRnlpJgKn",10) == 130252311) strcat(s, "e");
if (crc32("PErQcAjUYrv",11) == 3128589736) strcat(s, "p");
if (crc32("qWnSGELj",8) == 803136911) strcat(s, "i");
if (crc32("bNtWVBNFatqr",12) == 677535717) strcat(s, "d");
if (crc32("KuOaNzwHPU",10) == 1299425963) strcat(s, "e");
if (crc32("WJdtu",5) == 2623145506) strcat(s, "r");
if (crc32("gRKOXKjb",8) == 2431185481) strcat(s, "z");
if (crc32("xoRxgSzSeHzetkU",15) == 1373150010) strcat(s, "m");
if (crc32("LKjHRZxQQP",10) == 1511128904) strcat(s, "C");
if (crc32("qbGIq",5) == 3771936585) strcat(s, "i");
if (crc32("FOTlJHNTHDtHcqz",15) == 1313104327) strcat(s, "B");
if (crc32("LIOwVVWx",8) == 1376554214) strcat(s, "c");
    return s;
}

char *untransmutable_adjectives() {
    char *s = calloc(15);
    if (crc32("IIgSRogjeRrD",12) == 3688249824) strcat(s, "m");
if (crc32("ScEAFN",6) == 262086027) strcat(s, "u");
if (crc32("ngJElvpLtGgx",12) == 4097876930) strcat(s, "c");
if (crc32("RaAmsJmT",8) == 1117028821) strcat(s, "n");
if (crc32("LKQpafoFEGVS",12) == 691292) strcat(s, "t");
if (crc32("vziTjZ",6) == 645267670) strcat(s, "d");
if (crc32("IAnyaXisaE",10) == 1432333733) strcat(s, "r");
if (crc32("HoISBUi",7) == 533588696) strcat(s, "a");
if (crc32("NwseUJ",6) == 1394801467) strcat(s, "o");
if (crc32("OlgmX",5) == 2500485559) strcat(s, "n");
if (crc32("ONLxaFQxT",9) == 1130161038) strcat(s, "s");
if (crc32("aYeYB",5) == 1774331554) strcat(s, "m");
if (crc32("xmgXrjP",7) == 2411141193) strcat(s, "Q");
if (crc32("DfOKa",5) == 669166774) strcat(s, "u");
if (crc32("lueMOfAwdeUU",12) == 742845035) strcat(s, "q");
if (crc32("SQGIQPJaxaAon",13) == 3789921483) strcat(s, "t");
if (crc32("ZFlHPs",6) == 3081424586) strcat(s, "a");
if (crc32("kdBMelepPJpPHXK",15) == 1866698442) strcat(s, "d");
if (crc32("vTICiNYv",8) == 28760496) strcat(s, "b");
if (crc32("lWDXufwTYV",10) == 3124681210) strcat(s, "l");
if (crc32("AWlTDIaIvbKzhfd",15) == 2170174251) strcat(s, "o");
if (crc32("WcqGwBHIGPX",11) == 2337047664) strcat(s, "e");
    return s;
}

char *nonenergetic_adjectives() {
    char *s = calloc(13);
    if (crc32("AZRnbmSFAL",10) == 2789028719) strcat(s, "n");
if (crc32("XfwLVtMVQIo",11) == 3246767629) strcat(s, "d");
if (crc32("MwBsedIWlrw",11) == 1795303573) strcat(s, "o");
if (crc32("SeiKmNAefWBQJc",14) == 29326426) strcat(s, "n");
if (crc32("SNhFbs",6) == 2433993771) strcat(s, "o");
if (crc32("xmnQIrnskSiK",12) == 2123484992) strcat(s, "e");
if (crc32("VwKkyztixLN",11) == 3494463888) strcat(s, "V");
if (crc32("YptuCKMzkBeY",12) == 353176886) strcat(s, "n");
if (crc32("iwVbIKxICbpW",12) == 86413382) strcat(s, "e");
if (crc32("nNmCMMFKztOSOX",14) == 1300195115) strcat(s, "H");
if (crc32("jQsrgWux",8) == 1822150379) strcat(s, "r");
if (crc32("izeql",5) == 1790889686) strcat(s, "g");
if (crc32("qmdSTkJoCMaFh",13) == 2307217636) strcat(s, "d");
if (crc32("RgIXgpzDadG",11) == 3464954886) strcat(s, "e");
if (crc32("SmKbnUZy",8) == 2629657755) strcat(s, "c");
if (crc32("ckLKbnLFB",9) == 2536040454) strcat(s, "t");
if (crc32("SOOthwnxrHsay",13) == 2020324341) strcat(s, "I");
if (crc32("hrXuLWMzoDoy",12) == 2763844211) strcat(s, "i");
if (crc32("MBCBIZi",7) == 3743353058) strcat(s, "c");
    return s;
}

char *undiapered_adjectives() {
    char *s = calloc(11);
    if (crc32("OcIBflYU",8) == 2870525461) strcat(s, "T");
if (crc32("OlKDzpgYlIXc",12) == 3751842348) strcat(s, "u");
if (crc32("SrnDoDn",7) == 2254163099) strcat(s, "n");
if (crc32("qfPJLatlrJ",10) == 2272952325) strcat(s, "M");
if (crc32("xBHvXE",6) == 243802965) strcat(s, "d");
if (crc32("CzvJCYUBx",9) == 1112354892) strcat(s, "i");
if (crc32("ZLJuGLqeTAs",11) == 1241144857) strcat(s, "j");
if (crc32("vqhdCGMxsiyxvzu",15) == 2514784840) strcat(s, "a");
if (crc32("YzkBdNaMen",10) == 2699928110) strcat(s, "p");
if (crc32("PtKCIlfVEl",10) == 2874211513) strcat(s, "G");
if (crc32("kZGeUMoREHeCD",13) == 1678779344) strcat(s, "e");
if (crc32("uDxezkjdzvyZt",13) == 2876967016) strcat(s, "y");
if (crc32("smbzPxfUqpyxpkI",15) == 840214687) strcat(s, "r");
if (crc32("ECoSTbzcGflz",12) == 2112074618) strcat(s, "e");
if (crc32("zQynaip",7) == 1279155563) strcat(s, "m");
if (crc32("FBqnnuzdLWsA",12) == 2806511213) strcat(s, "d");
    return s;
}

char *nicenelly_adjectives() {
    char *s = calloc(10);
    if (crc32("bnqwcicuCwSV",12) == 80610825) strcat(s, "n");
if (crc32("GXNXhHO",7) == 2371935458) strcat(s, "i");
if (crc32("dlngEhKE",8) == 1109982843) strcat(s, "Z");
if (crc32("RrxAZUIwd",9) == 2495707379) strcat(s, "c");
if (crc32("OaHHaDLKEMfcr",13) == 2190469608) strcat(s, "e");
if (crc32("JFAoUwGqKHUJC",13) == 1105686938) strcat(s, "n");
if (crc32("MoYlSSug",8) == 3957046983) strcat(s, "e");
if (crc32("DuUvFpsbFHNZ",12) == 1286409404) strcat(s, "V");
if (crc32("LAcVm",5) == 3992645443) strcat(s, "l");
if (crc32("rBjUCmBQ",8) == 382902806) strcat(s, "l");
if (crc32("rhNFPxDuwBKtODQ",15) == 4157118902) strcat(s, "y");
    return s;
}

char *selfproclaiming_adjectives() {
    char *s = calloc(16);
    if (crc32("aVshOkjmiaf",11) == 2331527036) strcat(s, "M");
if (crc32("yGGWCRMqrqlZb",13) == 895421904) strcat(s, "s");
if (crc32("hwGgzjxK",8) == 830897827) strcat(s, "e");
if (crc32("ovgGx",5) == 3628317407) strcat(s, "p");
if (crc32("KzYwHrdTHbESam",14) == 1953862847) strcat(s, "l");
if (crc32("PhjCZgzWkOiDpq",14) == 3813242283) strcat(s, "f");
if (crc32("svzJVLqdUeDGb",13) == 1731472751) strcat(s, "p");
if (crc32("vOKbCYcIvmjIX",13) == 2080482036) strcat(s, "J");
if (crc32("WpbIiyMzbm",10) == 2220164212) strcat(s, "r");
if (crc32("CfevsDvn",8) == 3649785983) strcat(s, "o");
if (crc32("JHtNtdKZmmyIox",14) == 196705094) strcat(s, "c");
if (crc32("qgCtQjMDgYJToW",14) == 1568992387) strcat(s, "Y");
if (crc32("bYCWF",5) == 2337050551) strcat(s, "l");
if (crc32("oWtPsJoTyA",10) == 3065610478) strcat(s, "a");
if (crc32("pguWKeSjaVSHCRf",15) == 2540810681) strcat(s, "i");
if (crc32("WqoKhAP",7) == 324345915) strcat(s, "M");
if (crc32("RdxsesBbHkBb",12) == 4161818617) strcat(s, "m");
if (crc32("dKWcyNjAE",9) == 4239042830) strcat(s, "a");
if (crc32("xJZjEUkp",8) == 2496314370) strcat(s, "i");
if (crc32("hJCqaMNy",8) == 2010307083) strcat(s, "n");
if (crc32("NQTzv",5) == 2149057156) strcat(s, "b");
if (crc32("yvExPymBZEqzEk",14) == 4266726006) strcat(s, "g");
    return s;
}

char *superhistorical_adjectives() {
    char *s = calloc(16);
    if (crc32("tSjYUAv",7) == 2751473663) strcat(s, "O");
if (crc32("myxvg",5) == 1105639572) strcat(s, "s");
if (crc32("hJEGYMTiptbjLbn",15) == 16195210) strcat(s, "P");
if (crc32("ngNIgkSslpNHZ",13) == 2513776720) strcat(s, "u");
if (crc32("LPnqKxgcCotq",12) == 3634165361) strcat(s, "p");
if (crc32("rMJCFnCAUv",10) == 1551100294) strcat(s, "c");
if (crc32("JWGLCTojBm",10) == 1338281809) strcat(s, "e");
if (crc32("neZkwBWfHO",10) == 2270183578) strcat(s, "r");
if (crc32("rpPKSKjLG",9) == 282365342) strcat(s, "h");
if (crc32("syCYJXbt",8) == 2940072782) strcat(s, "y");
if (crc32("fJDwfdGQVFA",11) == 1379771382) strcat(s, "i");
if (crc32("jxGtbI",6) == 3848417555) strcat(s, "D");
if (crc32("JdpNmTYxONlVH",13) == 2224871997) strcat(s, "s");
if (crc32("ZxrNCSDf",8) == 150326687) strcat(s, "t");
if (crc32("zpyEZGq",7) == 2135901285) strcat(s, "o");
if (crc32("avIzmWjppIJC",12) == 3460582732) strcat(s, "p");
if (crc32("DtBBpXtrxPrU",12) == 127157625) strcat(s, "r");
if (crc32("dRVZtttqphslxnc",15) == 1750184265) strcat(s, "i");
if (crc32("UmZbDYb",7) == 70332029) strcat(s, "c");
if (crc32("MUtOZEQw",8) == 2417842275) strcat(s, "e");
if (crc32("vUzcFDwDObjjn",13) == 292363282) strcat(s, "a");
if (crc32("NrAvy",5) == 3241380157) strcat(s, "l");
    return s;
}

char *halfmatured_adjectives() {
    char *s = calloc(12);
    if (crc32("amsYsvefK",9) == 2087558919) strcat(s, "h");
if (crc32("NYuGTvah",8) == 1977123938) strcat(s, "a");
if (crc32("zxSCYaamtDEMNX",14) == 3983379640) strcat(s, "c");
if (crc32("rLodOKiGarmyXy",14) == 3008695481) strcat(s, "l");
if (crc32("jqXIjhiSJCoS",12) == 1638274379) strcat(s, "f");
if (crc32("JtktNjdAirGlSK",14) == 1272933919) strcat(s, "m");
if (crc32("ydiWMHnl",8) == 2759935919) strcat(s, "a");
if (crc32("PFKdjKKgL",9) == 407818327) strcat(s, "t");
if (crc32("ZwZUrfhQ",8) == 3922324128) strcat(s, "u");
if (crc32("qaJKa",5) == 3746958660) strcat(s, "o");
if (crc32("bSbiF",5) == 2629523577) strcat(s, "r");
if (crc32("podUXmdULxHwE",13) == 3663822098) strcat(s, "e");
if (crc32("YhDDspPOLoZ",11) == 3111154468) strcat(s, "d");
    return s;
}

char *selfscourging_adjectives() {
    char *s = calloc(14);
    if (crc32("svYiE",5) == 3890274956) strcat(s, "s");
if (crc32("jjgQzGnYpiLMVmb",15) == 3930455101) strcat(s, "e");
if (crc32("ksOstnIDcvCPr",13) == 646608713) strcat(s, "l");
if (crc32("sxrNBzWyDeLm",12) == 2067824804) strcat(s, "f");
if (crc32("HiPuslMyni",10) == 1500233054) strcat(s, "s");
if (crc32("AgudgXqJqpScbo",14) == 3151975907) strcat(s, "N");
if (crc32("gMkIZOpdqRl",11) == 1011869409) strcat(s, "c");
if (crc32("QjUhdNTeVQ",10) == 1473695984) strcat(s, "o");
if (crc32("xXrsBdiPl",9) == 3661576842) strcat(s, "a");
if (crc32("svxasrFQzv",10) == 2653612821) strcat(s, "u");
if (crc32("YiTZaKnAjbF",11) == 1847487103) strcat(s, "r");
if (crc32("ZGSGo",5) == 3196941585) strcat(s, "g");
if (crc32("zIyJRGI",7) == 1087518393) strcat(s, "L");
if (crc32("zJgGtUW",7) == 928849666) strcat(s, "i");
if (crc32("CgqFo",5) == 3514623741) strcat(s, "c");
if (crc32("gnQCUfZyTx",10) == 2648143643) strcat(s, "n");
if (crc32("wBWNCxyPIUrDofx",15) == 1983085609) strcat(s, "Y");
if (crc32("PNXdnGHxCjQcbfW",15) == 2988021348) strcat(s, "g");
    return s;
}

char *stenothermal_adjectives() {
    char *s = calloc(13);
    if (crc32("suqyXGTPPOxrwGy",15) == 523151051) strcat(s, "X");
if (crc32("FRPLVEmgxJS",11) == 2653816796) strcat(s, "s");
if (crc32("QbBfXNibF",9) == 3923016145) strcat(s, "A");
if (crc32("pdqdorBZPKFZ",12) == 2143727325) strcat(s, "t");
if (crc32("GrIRNsBPQEZ",11) == 403217199) strcat(s, "e");
if (crc32("oxfxVfDAhVfc",12) == 163207274) strcat(s, "n");
if (crc32("prrCk",5) == 2827446253) strcat(s, "o");
if (crc32("IDuBEfrMfxPWVoG",15) == 1557525480) strcat(s, "t");
if (crc32("jisaRgQQ",8) == 413624552) strcat(s, "U");
if (crc32("ZZBAQVFPeyBX",12) == 2895288507) strcat(s, "h");
if (crc32("nVceveqmj",9) == 1374417373) strcat(s, "e");
if (crc32("RfFiXCXyWmgJNBs",15) == 2850683302) strcat(s, "x");
if (crc32("LVzzygqPI",9) == 503075901) strcat(s, "r");
if (crc32("oHuHwuSv",8) == 2046331327) strcat(s, "d");
if (crc32("zXzHvOB",7) == 1730426281) strcat(s, "m");
if (crc32("wVQAEgbAWXQo",12) == 1929710096) strcat(s, "F");
if (crc32("yiznJNpZAMjBM",13) == 3776206202) strcat(s, "a");
if (crc32("XibTOzlUvKSo",12) == 3656890774) strcat(s, "l");
    return s;
}

char *undivinable_adjectives() {
    char *s = calloc(12);
    if (crc32("qYCCxOlxFW",10) == 3018704548) strcat(s, "u");
if (crc32("zgQWXIONcye",11) == 1850357131) strcat(s, "n");
if (crc32("JBkaeRmhUFYUgN",14) == 603580854) strcat(s, "d");
if (crc32("YmowjkrQYsk",11) == 1768668145) strcat(s, "i");
if (crc32("ZATrgbpCBK",10) == 3798952152) strcat(s, "v");
if (crc32("VzYChXwvvGnPl",13) == 705018579) strcat(s, "D");
if (crc32("GZgnrZbFV",9) == 2888422986) strcat(s, "i");
if (crc32("GLvpMI",6) == 3955212150) strcat(s, "o");
if (crc32("gzqtzyaBXTcXWZ",14) == 597473729) strcat(s, "n");
if (crc32("gCTfonFwmc",10) == 726683451) strcat(s, "t");
if (crc32("oFPHPgZwpZVnBr",14) == 2210370606) strcat(s, "a");
if (crc32("eHdcJSBpC",9) == 2199112905) strcat(s, "b");
if (crc32("QPLOmwWVB",9) == 556391531) strcat(s, "l");
if (crc32("gEEeRllcmXtNsdy",15) == 3777518076) strcat(s, "m");
if (crc32("InGhJFbUDkKQf",13) == 394455190) strcat(s, "e");
    return s;
}

char *maladroit_adjectives() {
    char *s = calloc(10);
    if (crc32("YjRSkZHtvRqTCS",14) == 1548654197) strcat(s, "H");
if (crc32("mNQMxIEErfoc",12) == 3926916640) strcat(s, "m");
if (crc32("FXaHJyWLt",9) == 1705733095) strcat(s, "a");
if (crc32("tmBqAwBpVYjUh",13) == 588439916) strcat(s, "l");
if (crc32("AKOAIjKobGhoCn",14) == 3275440993) strcat(s, "a");
if (crc32("rXgpVjXh",8) == 3982692807) strcat(s, "d");
if (crc32("jlBAWDOnFZ",10) == 1075544799) strcat(s, "E");
if (crc32("YDwZP",5) == 2648051506) strcat(s, "r");
if (crc32("aKZYEWESpS",10) == 3208501305) strcat(s, "O");
if (crc32("YDAzO",5) == 2780610375) strcat(s, "o");
if (crc32("JcZsyVarHdWM",12) == 1357274272) strcat(s, "i");
if (crc32("OpYHqZ",6) == 266183905) strcat(s, "z");
if (crc32("yrLQYAn",7) == 1824595175) strcat(s, "t");
    return s;
}

char *melodyless_adjectives() {
    char *s = calloc(11);
    if (crc32("hPNgK",5) == 2146721491) strcat(s, "c");
if (crc32("mPRhOHgxtRwl",12) == 467235712) strcat(s, "m");
if (crc32("mBpeXB",6) == 3892897977) strcat(s, "e");
if (crc32("DfiGd",5) == 950185214) strcat(s, "i");
if (crc32("xJTKbQG",7) == 1843755367) strcat(s, "l");
if (crc32("tbupP",5) == 2583796524) strcat(s, "Z");
if (crc32("KRBDHjCfYoxhkC",14) == 3053555026) strcat(s, "o");
if (crc32("UiFolsPkiWTZPh",14) == 1077626556) strcat(s, "d");
if (crc32("eRXNFZlrJOXc",12) == 2747162273) strcat(s, "N");
if (crc32("SicMNmXEbRYi",12) == 152889315) strcat(s, "y");
if (crc32("auigEnnisPPJC",13) == 4050311647) strcat(s, "x");
if (crc32("JFtGRf",6) == 1969648245) strcat(s, "l");
if (crc32("qzJPnpCi",8) == 999642993) strcat(s, "a");
if (crc32("AzThgClf",8) == 1340406007) strcat(s, "e");
if (crc32("teUyFKrA",8) == 3797235465) strcat(s, "s");
if (crc32("Vnejykh",7) == 1956547162) strcat(s, "s");
    return s;
}

char *Chavin_adjectives() {
    char *s = calloc(7);
    if (crc32("OPVSHsgeS",9) == 999120384) strcat(s, "e");
if (crc32("ueQJpvYaOtjD",12) == 700617502) strcat(s, "C");
if (crc32("QaOzZLfVClxkONp",15) == 2313173036) strcat(s, "L");
if (crc32("YPfQtqqsBmBgT",13) == 2271224553) strcat(s, "h");
if (crc32("DfthcjHBnFup",12) == 4126255827) strcat(s, "a");
if (crc32("gzfiAYfCFi",10) == 1145440178) strcat(s, "c");
if (crc32("iFZRmRAsIXApUXJ",15) == 3306720329) strcat(s, "v");
if (crc32("hFPlRxQadxNngXI",15) == 4020307498) strcat(s, "i");
if (crc32("XLnlPxDOFHiRa",13) == 3568791885) strcat(s, "M");
if (crc32("WzHJrhdpTQm",11) == 1706416536) strcat(s, "n");
    return s;
}

char *concentrative_adjectives() {
    char *s = calloc(14);
    if (crc32("FZyMAoWSxoBV",12) == 916768981) strcat(s, "E");
if (crc32("QpjmopU",7) == 2123833374) strcat(s, "c");
if (crc32("SKsNoHQBcEbjB",13) == 2637023782) strcat(s, "o");
if (crc32("gmOaCOykOYgTtg",14) == 1914532218) strcat(s, "n");
if (crc32("oVcqyBfTO",9) == 1032538445) strcat(s, "c");
if (crc32("lcBlzhQIPEx",11) == 2349140853) strcat(s, "e");
if (crc32("dlDigMytiJISw",13) == 2379769845) strcat(s, "e");
if (crc32("GOQvrZ",6) == 3427175252) strcat(s, "n");
if (crc32("snyDurGUE",9) == 1330484943) strcat(s, "b");
if (crc32("xZTHaHLKBuzt",12) == 3417576904) strcat(s, "t");
if (crc32("RFnzEQ",6) == 885658146) strcat(s, "r");
if (crc32("wGtnzFpAcaQGNiv",15) == 1114830343) strcat(s, "a");
if (crc32("qFOcEBEae",9) == 1147254691) strcat(s, "t");
if (crc32("AHDmCaUOdRtLF",13) == 928874973) strcat(s, "M");
if (crc32("spGfLoVvzeP",11) == 4293952333) strcat(s, "i");
if (crc32("DFmajJOEFNyP",12) == 1540940908) strcat(s, "e");
if (crc32("wcghHIuOOg",10) == 3313397645) strcat(s, "v");
if (crc32("nqxcqN",6) == 81059804) strcat(s, "e");
    return s;
}

char *unvoyaging_adjectives() {
    char *s = calloc(11);
    if (crc32("NBoEqsBbMkMiC",13) == 331081125) strcat(s, "u");
if (crc32("TMZQHRzJvPJEL",13) == 36213318) strcat(s, "n");
if (crc32("pQgWRzWZUZliS",13) == 1241081718) strcat(s, "v");
if (crc32("kTWnMdKLzxGVc",13) == 1377058437) strcat(s, "o");
if (crc32("XqkeyteofW",10) == 529728702) strcat(s, "c");
if (crc32("lKUsFKpXR",9) == 3970104539) strcat(s, "y");
if (crc32("sVyRhTWqvh",10) == 3896048238) strcat(s, "a");
if (crc32("RDWmTAQqjYpBB",13) == 3303386001) strcat(s, "g");
if (crc32("LZQpIsMHAQssIKu",15) == 2526420545) strcat(s, "i");
if (crc32("HaUozeV",7) == 2037520852) strcat(s, "n");
if (crc32("BCynUYsAKcgs",12) == 3736307494) strcat(s, "X");
if (crc32("EsgBav",6) == 1078638744) strcat(s, "g");
    return s;
}

char *palaeoecologic_adjectives() {
    char *s = calloc(15);
    if (crc32("sqxvmKFUwcfrb",13) == 987657429) strcat(s, "p");
if (crc32("vtCbej",6) == 401929801) strcat(s, "a");
if (crc32("ahvRqDWGgkpeDj",14) == 3703865713) strcat(s, "l");
if (crc32("gxTszbM",7) == 3521169658) strcat(s, "w");
if (crc32("XNYCzZwcVLv",11) == 1520291449) strcat(s, "a");
if (crc32("secSuavo",8) == 3728519607) strcat(s, "e");
if (crc32("qpBIDwzqDxeytHp",15) == 2018067918) strcat(s, "F");
if (crc32("RNwZppgCt",9) == 1361665184) strcat(s, "o");
if (crc32("PdquEI",6) == 3528021999) strcat(s, "e");
if (crc32("UEQSIGLeLtiUrQc",15) == 442997002) strcat(s, "c");
if (crc32("XHpuFusX",8) == 1039371052) strcat(s, "x");
if (crc32("yvWMnIfSJJQzuR",14) == 577829809) strcat(s, "o");
if (crc32("wSHibhr",7) == 1214778994) strcat(s, "l");
if (crc32("vOBOFzsnwtNre",13) == 1008420717) strcat(s, "o");
if (crc32("IwhYfgTwnHjxB",13) == 3163875934) strcat(s, "g");
if (crc32("dwMdNOhmvR",10) == 3477671961) strcat(s, "i");
if (crc32("VGifuPSg",8) == 1486318643) strcat(s, "j");
if (crc32("yznYjMdzQosOoH",14) == 1720083089) strcat(s, "c");
    return s;
}

char *intimate_adjectives() {
    char *s = calloc(9);
    if (crc32("WYTToL",6) == 664752156) strcat(s, "i");
if (crc32("fWXOvquQiopmI",13) == 2162890995) strcat(s, "j");
if (crc32("yEfXw",5) == 1853053437) strcat(s, "n");
if (crc32("KqzdPduOdDK",11) == 3464090657) strcat(s, "t");
if (crc32("iOrXXSMn",8) == 2978067440) strcat(s, "Q");
if (crc32("ewfIafK",7) == 957866289) strcat(s, "i");
if (crc32("TiPvdYiOql",10) == 2424674346) strcat(s, "m");
if (crc32("rCqZzB",6) == 399635119) strcat(s, "a");
if (crc32("OpURgHsGRCoD",12) == 2386229050) strcat(s, "t");
if (crc32("NIRqtkPTXKJwOH",14) == 1212854922) strcat(s, "e");
    return s;
}

char *selfevolving_adjectives() {
    char *s = calloc(13);
    if (crc32("yTlniwnNvUmT",12) == 4262142799) strcat(s, "s");
if (crc32("JWoOvDYnvpmXGs",14) == 957195476) strcat(s, "e");
if (crc32("LxthSMpqLlnJzl",14) == 529697378) strcat(s, "l");
if (crc32("DWAgeA",6) == 3629774363) strcat(s, "f");
if (crc32("NEowhK",6) == 1783823793) strcat(s, "e");
if (crc32("sWGCOZd",7) == 1576391844) strcat(s, "D");
if (crc32("PqihLf",6) == 2164885086) strcat(s, "v");
if (crc32("yozomdFhysMk",12) == 4173921334) strcat(s, "o");
if (crc32("lZjwqmYqBNwW",12) == 2636663176) strcat(s, "e");
if (crc32("uPDjtsostQtJnx",14) == 2081708712) strcat(s, "l");
if (crc32("YnNFDW",6) == 3494743394) strcat(s, "c");
if (crc32("jnPFqlPQIilWK",13) == 3553516758) strcat(s, "v");
if (crc32("wYiSUjQWRnskFr",14) == 1455083567) strcat(s, "K");
if (crc32("ILAQedsldqDja",13) == 3438510687) strcat(s, "i");
if (crc32("aFUimBZJZHddwoC",15) == 2320202889) strcat(s, "n");
if (crc32("sTKDOwYpyx",10) == 3805437673) strcat(s, "g");
    return s;
}

char *lorn_adjectives() {
    char *s = calloc(5);
    if (crc32("FSIvNe",6) == 3190202579) strcat(s, "C");
if (crc32("KmeSoPRzaNQT",12) == 863469391) strcat(s, "l");
if (crc32("PbeaxnwQkjGs",12) == 1543194726) strcat(s, "o");
if (crc32("qbwjsF",6) == 3580106409) strcat(s, "d");
if (crc32("EjPwp",5) == 1584236542) strcat(s, "r");
if (crc32("NXYcmp",6) == 4029751090) strcat(s, "n");
    return s;
}

char *wellelevated_adjectives() {
    char *s = calloc(13);
    if (crc32("ZRiMDSCXnM",10) == 2873811056) strcat(s, "F");
if (crc32("AfjBBxRNMddAgRs",15) == 3331021634) strcat(s, "w");
if (crc32("uLLUbg",6) == 1216773785) strcat(s, "e");
if (crc32("NRvDs",5) == 1755620155) strcat(s, "L");
if (crc32("WxeRCtl",7) == 3509721831) strcat(s, "l");
if (crc32("yOzIQgIuHfo",11) == 1648151961) strcat(s, "O");
if (crc32("UPtznbnemjFXZ",13) == 3038233138) strcat(s, "l");
if (crc32("oztmxcG",7) == 1941926331) strcat(s, "e");
if (crc32("XtuKpQZZGcx",11) == 1501985298) strcat(s, "q");
if (crc32("qxXoAchsoh",10) == 1509454033) strcat(s, "l");
if (crc32("KvDVzsvmlhWp",12) == 2514328824) strcat(s, "c");
if (crc32("YNecXeGW",8) == 3074857415) strcat(s, "e");
if (crc32("lUwxojhAJigiLUW",15) == 3630652339) strcat(s, "t");
if (crc32("OyhLtitcpX",10) == 2957794751) strcat(s, "v");
if (crc32("VodOAfjv",8) == 2346009630) strcat(s, "a");
if (crc32("bacuCSeUVUUiq",13) == 1248224844) strcat(s, "i");
if (crc32("pSVPvGhee",9) == 2454655586) strcat(s, "t");
if (crc32("FqnFJwJkrKljtMf",15) == 561599348) strcat(s, "e");
if (crc32("amgFS",5) == 1463849596) strcat(s, "v");
if (crc32("FRxLOdqDH",9) == 744038603) strcat(s, "d");
    return s;
}

char *ecological_adjectives() {
    char *s = calloc(11);
    if (crc32("RNceH",5) == 2816679496) strcat(s, "t");
if (crc32("LkTYgK",6) == 3406480730) strcat(s, "e");
if (crc32("xfqtCfImZCZRW",13) == 2859222771) strcat(s, "l");
if (crc32("zxTnfSTlba",10) == 2327674216) strcat(s, "c");
if (crc32("jKBUkvsxN",9) == 1424477255) strcat(s, "o");
if (crc32("awYFZyTRg",9) == 816982504) strcat(s, "l");
if (crc32("VBGFwuJeBlee",12) == 3248446107) strcat(s, "L");
if (crc32("WUFAmwvVLdKE",12) == 3820768505) strcat(s, "o");
if (crc32("PPKlTdfnWy",10) == 642220195) strcat(s, "D");
if (crc32("GuvttNGjrfoxpfy",15) == 3201589222) strcat(s, "g");
if (crc32("nGAAZTrDO",9) == 1682376649) strcat(s, "i");
if (crc32("gdlwRefGdwHyb",13) == 919548511) strcat(s, "r");
if (crc32("uOBHhQ",6) == 3461496394) strcat(s, "c");
if (crc32("KMOXPYMK",8) == 4234581701) strcat(s, "h");
if (crc32("rGjTKCzBqomQc",13) == 4062015428) strcat(s, "a");
if (crc32("tadLCrlE",8) == 3172051331) strcat(s, "B");
if (crc32("WgtPLZFxb",9) == 927151370) strcat(s, "l");
    return s;
}

char *unclotted_adjectives() {
    char *s = calloc(10);
    if (crc32("nklcCfAvlnsurX",14) == 1160322684) strcat(s, "E");
if (crc32("qNaqpktyWncj",12) == 793617456) strcat(s, "u");
if (crc32("bGjCioVoOS",10) == 487407826) strcat(s, "U");
if (crc32("ROIDyM",6) == 1295518462) strcat(s, "n");
if (crc32("DefVvku",7) == 1828221835) strcat(s, "s");
if (crc32("zNuISsvFlZaD",12) == 1118447495) strcat(s, "c");
if (crc32("poNxyGhzE",9) == 625868174) strcat(s, "p");
if (crc32("FtTIYDwM",8) == 4186843082) strcat(s, "l");
if (crc32("TNlsZsW",7) == 1038171023) strcat(s, "j");
if (crc32("qSRWSXqCpS",10) == 3201608554) strcat(s, "o");
if (crc32("CuNzA",5) == 579607506) strcat(s, "Y");
if (crc32("YuluOkhHWEZD",12) == 3235587233) strcat(s, "t");
if (crc32("DYefVYJJ",8) == 560458078) strcat(s, "t");
if (crc32("eRlDllBAhqGrLK",14) == 2537233568) strcat(s, "B");
if (crc32("OHjwMTyexSotJf",14) == 473411584) strcat(s, "e");
if (crc32("dGsxHZcHEUMW",12) == 346845876) strcat(s, "d");
    return s;
}

char *subconnivent_adjectives() {
    char *s = calloc(13);
    if (crc32("LNqgpDH",7) == 3536487672) strcat(s, "O");
if (crc32("syMsjvCCnkODTp",14) == 3263116216) strcat(s, "s");
if (crc32("QNoFBympLzOJmc",14) == 1481408188) strcat(s, "u");
if (crc32("gUYqyOOareJ",11) == 3542607620) strcat(s, "U");
if (crc32("jCqiocEPZZIPco",14) == 3657560773) strcat(s, "b");
if (crc32("oaNxtR",6) == 2035148153) strcat(s, "m");
if (crc32("MyOObRlupKbAf",13) == 2810167512) strcat(s, "c");
if (crc32("dpwOYtXugfBX",12) == 1978197061) strcat(s, "o");
if (crc32("nwvMyTpBfdQ",11) == 3214358847) strcat(s, "G");
if (crc32("ZzegHUEfmKjMLl",14) == 4275654057) strcat(s, "n");
if (crc32("ajiJSOxR",8) == 2883640074) strcat(s, "n");
if (crc32("yYBzwTHCkQUeSGC",15) == 349007641) strcat(s, "i");
if (crc32("yVfVOgo",7) == 1244149931) strcat(s, "v");
if (crc32("YzaYVjzjlAAM",12) == 38629474) strcat(s, "e");
if (crc32("WwUOt",5) == 467482510) strcat(s, "j");
if (crc32("novBLCFqC",9) == 252664205) strcat(s, "n");
if (crc32("pKvwfXAXgPlZo",13) == 3614629268) strcat(s, "q");
if (crc32("CdFAxavOFnQzN",13) == 1760451415) strcat(s, "t");
    return s;
}

char *unhampering_adjectives() {
    char *s = calloc(12);
    if (crc32("ZFVRAo",6) == 40275048) strcat(s, "Y");
if (crc32("JzsmuAVC",8) == 1476271899) strcat(s, "u");
if (crc32("RfvsrIIxCfH",11) == 2053205991) strcat(s, "t");
if (crc32("UQBKGASpa",9) == 1128300256) strcat(s, "n");
if (crc32("iSKIMZ",6) == 2565930710) strcat(s, "G");
if (crc32("CpPfDt",6) == 2247540410) strcat(s, "h");
if (crc32("GJkelIFfUf",10) == 1001523855) strcat(s, "a");
if (crc32("nSaiebCyMfrjl",13) == 430194072) strcat(s, "M");
if (crc32("dqrGDwEbROQwux",14) == 3742454715) strcat(s, "m");
if (crc32("AUwNDbik",8) == 828815425) strcat(s, "p");
if (crc32("gkaXdVpDqHZApu",14) == 2068404623) strcat(s, "s");
if (crc32("ceTbOxXoj",9) == 3503268648) strcat(s, "e");
if (crc32("eTOTT",5) == 445141141) strcat(s, "r");
if (crc32("ZQyqQROXPsQGDC",14) == 2953730066) strcat(s, "L");
if (crc32("paOJRqBjgGJrqYA",15) == 3091874966) strcat(s, "i");
if (crc32("EFhuAxeHdOJ",11) == 4169019096) strcat(s, "n");
if (crc32("pLQgtheIbQU",11) == 379107331) strcat(s, "g");
    return s;
}

char *Lamaistic_adjectives() {
    char *s = calloc(10);
    if (crc32("XRFCdgCPEDQVoP",14) == 3891953004) strcat(s, "o");
if (crc32("aIGrUcv",7) == 786313203) strcat(s, "L");
if (crc32("zofeYErEt",9) == 785039146) strcat(s, "a");
if (crc32("RGIRyXHg",8) == 510912755) strcat(s, "q");
if (crc32("WPgqk",5) == 650167974) strcat(s, "m");
if (crc32("kLNKzqJeLnFVal",14) == 540416875) strcat(s, "o");
if (crc32("cytyAxK",7) == 1724575751) strcat(s, "a");
if (crc32("ILSlE",5) == 1588824925) strcat(s, "p");
if (crc32("QvULstvjRGbQGw",14) == 3664845384) strcat(s, "i");
if (crc32("SCiRbYR",7) == 2172297877) strcat(s, "x");
if (crc32("msZtp",5) == 2759273787) strcat(s, "s");
if (crc32("OSqChqTCsrOj",12) == 238912296) strcat(s, "C");
if (crc32("mGRNmYGxfNPnOvP",15) == 2969699834) strcat(s, "t");
if (crc32("YhxjoJjND",9) == 1704167730) strcat(s, "o");
if (crc32("xJPdAJuN",8) == 123301995) strcat(s, "i");
if (crc32("kQBShBWiIo",10) == 3892848603) strcat(s, "o");
if (crc32("xsOqhZhpw",9) == 1475931231) strcat(s, "c");
    return s;
}

char *stealthless_adjectives() {
    char *s = calloc(12);
    if (crc32("CPMZJ",5) == 3160660453) strcat(s, "s");
if (crc32("gvYbuxI",7) == 4091551904) strcat(s, "I");
if (crc32("rfOXFWTHFeO",11) == 3108329736) strcat(s, "t");
if (crc32("nxJebEhUwuzZI",13) == 752736841) strcat(s, "e");
if (crc32("xoUrFRjnAdFLR",13) == 2513050984) strcat(s, "a");
if (crc32("HWkiy",5) == 555740729) strcat(s, "l");
if (crc32("drkzUUa",7) == 1437092792) strcat(s, "z");
if (crc32("nysZeMPuba",10) == 3654153810) strcat(s, "t");
if (crc32("Xtjbai",6) == 168683013) strcat(s, "h");
if (crc32("MatfYMluDhCPlJF",15) == 3634200758) strcat(s, "T");
if (crc32("shcIfFzxJtBnAm",14) == 2035161198) strcat(s, "l");
if (crc32("iDQrbpAhVQitU",13) == 4178832328) strcat(s, "Q");
if (crc32("wQgran",6) == 2248023964) strcat(s, "e");
if (crc32("DkOnR",5) == 2192295322) strcat(s, "s");
if (crc32("nsUsDYEjPR",10) == 1128707386) strcat(s, "H");
if (crc32("aPpklTYa",8) == 4110394466) strcat(s, "s");
    return s;
}

char *hardwearing_adjectives() {
    char *s = calloc(12);
    if (crc32("ttMSALQEowvcRj",14) == 4055287456) strcat(s, "T");
if (crc32("zazWJLgfgvRscA",14) == 1037268792) strcat(s, "h");
if (crc32("SIyccEFHxQWHY",13) == 100944009) strcat(s, "k");
if (crc32("PddtckCBuxGHtY",14) == 2127997922) strcat(s, "a");
if (crc32("QNuSAnXW",8) == 709542149) strcat(s, "r");
if (crc32("RlPwuRIXKLhJ",12) == 2734388266) strcat(s, "d");
if (crc32("geHOCEBbzHQ",11) == 3767825360) strcat(s, "h");
if (crc32("WiTJwb",6) == 3469472630) strcat(s, "w");
if (crc32("PceMutzSdUw",11) == 3681114708) strcat(s, "j");
if (crc32("hqlmfVr",7) == 1853221722) strcat(s, "e");
if (crc32("GIywZjPf",8) == 2179841757) strcat(s, "L");
if (crc32("GLfDpOlkKxUF",12) == 2109244185) strcat(s, "a");
if (crc32("sBdEygCX",8) == 2239107010) strcat(s, "M");
if (crc32("nUaTkyT",7) == 753058841) strcat(s, "r");
if (crc32("fcQQYVaxUDYERj",14) == 2607966982) strcat(s, "i");
if (crc32("ElCzFvvP",8) == 2206639343) strcat(s, "l");
if (crc32("AwZihQAC",8) == 95827991) strcat(s, "n");
if (crc32("OCYXAPSxPfQnt",13) == 3761050652) strcat(s, "b");
if (crc32("rMQtnBrUJih",11) == 2268986851) strcat(s, "g");
    return s;
}

char *prestidigitatory_adjectives() {
    char *s = calloc(17);
    if (crc32("UVwjwJwrBqSkr",13) == 3782242573) strcat(s, "b");
if (crc32("wGToGKzwPPJXuLd",15) == 3501624593) strcat(s, "p");
if (crc32("iOIVLjWKtV",10) == 1504293820) strcat(s, "X");
if (crc32("mBoPrpFYC",9) == 1232836416) strcat(s, "r");
if (crc32("MQomX",5) == 3818406675) strcat(s, "e");
if (crc32("JDCscBw",7) == 957453143) strcat(s, "o");
if (crc32("OMJtejBs",8) == 1344876626) strcat(s, "s");
if (crc32("XxHaVNXnQP",10) == 3416451091) strcat(s, "O");
if (crc32("XnUckHujFZ",10) == 1157430534) strcat(s, "t");
if (crc32("FIRtzAZtkCg",11) == 1658540997) strcat(s, "w");
if (crc32("HxvMHvQtO",9) == 638684043) strcat(s, "i");
if (crc32("SuFVMeJDZI",10) == 2316366944) strcat(s, "d");
if (crc32("fLhAYyJY",8) == 2977789924) strcat(s, "M");
if (crc32("ywNJCDqmKUTF",12) == 257962654) strcat(s, "i");
if (crc32("ngVdfN",6) == 4278272159) strcat(s, "H");
if (crc32("btpremHuxTF",11) == 3225917234) strcat(s, "g");
if (crc32("ObvkAbfgqjD",11) == 431664417) strcat(s, "E");
if (crc32("eRGdLCDlq",9) == 2018255043) strcat(s, "i");
if (crc32("qlYsICFFdSeoho",14) == 720637192) strcat(s, "i");
if (crc32("FQNnTP",6) == 3784224297) strcat(s, "t");
if (crc32("pfnPrrrbeuwO",12) == 1822595828) strcat(s, "r");
if (crc32("oTPZMOoASqw",11) == 3678868573) strcat(s, "a");
if (crc32("PLtHCHM",7) == 3602907578) strcat(s, "t");
if (crc32("eMdYpZIA",8) == 1424427849) strcat(s, "o");
if (crc32("jzoKnqXahaHHb",13) == 3092711482) strcat(s, "r");
if (crc32("rCAiyFvh",8) == 4139697131) strcat(s, "y");
    return s;
}

char *unrefreshed_adjectives() {
    char *s = calloc(12);
    if (crc32("ZdhYh",5) == 1846662604) strcat(s, "u");
if (crc32("XxlViyQZboPX",12) == 3461308061) strcat(s, "W");
if (crc32("mKLObPPa",8) == 3076805549) strcat(s, "n");
if (crc32("BCMzbWNSgosaBA",14) == 3451334645) strcat(s, "O");
if (crc32("GoYjljOAHZS",11) == 4212079270) strcat(s, "r");
if (crc32("sISaTmYxtydJSr",14) == 1548199551) strcat(s, "u");
if (crc32("YJjNoMxXdlfkZc",14) == 4166403181) strcat(s, "e");
if (crc32("MXojeJOAgUD",11) == 640943015) strcat(s, "l");
if (crc32("HOuSxpNduRP",11) == 1071560380) strcat(s, "f");
if (crc32("LweaXJPbUeqNyK",14) == 2877120115) strcat(s, "D");
if (crc32("HiUima",6) == 2547545989) strcat(s, "r");
if (crc32("teQFysuuWki",11) == 3047636340) strcat(s, "v");
if (crc32("pEkWKvUtBLEgMRS",15) == 887943489) strcat(s, "e");
if (crc32("mteoUEj",7) == 2417017619) strcat(s, "s");
if (crc32("EphIUETM",8) == 88826114) strcat(s, "s");
if (crc32("qtjABa",6) == 2698491153) strcat(s, "h");
if (crc32("LKcWfPlZV",9) == 480124238) strcat(s, "D");
if (crc32("qcKKsf",6) == 1060577567) strcat(s, "e");
if (crc32("fyBFVj",6) == 2540332916) strcat(s, "z");
if (crc32("UEJgfFzNHeH",11) == 1822810531) strcat(s, "d");
    return s;
}

char *spongiest_adjectives() {
    char *s = calloc(10);
    if (crc32("lLqidSqXuagxj",13) == 1906916608) strcat(s, "t");
if (crc32("mxfFCwMxpqf",11) == 2130329191) strcat(s, "s");
if (crc32("jCcIGPmIZ",9) == 3515566184) strcat(s, "p");
if (crc32("imuFXlVZTqk",11) == 1377595400) strcat(s, "D");
if (crc32("GroYsNlIOw",10) == 594628969) strcat(s, "o");
if (crc32("kmJEulBAG",9) == 4265204616) strcat(s, "n");
if (crc32("iQCsmKIGsIUI",12) == 3403051949) strcat(s, "g");
if (crc32("tEDGijDMD",9) == 3963830577) strcat(s, "M");
if (crc32("ULuSRRODGtix",12) == 386830537) strcat(s, "i");
if (crc32("GGnjzSMxWha",11) == 2184012184) strcat(s, "o");
if (crc32("aonyqxMbaK",10) == 1425884678) strcat(s, "e");
if (crc32("tTjjnZoAF",9) == 2875684042) strcat(s, "s");
if (crc32("iJeMnNoFqIRLT",13) == 1737789865) strcat(s, "t");
    return s;
}

char *wellrespected_adjectives() {
    char *s = calloc(14);
    if (crc32("kLqhAmwI",8) == 55822981) strcat(s, "k");
if (crc32("lUikMWUAsFC",11) == 3950513848) strcat(s, "w");
if (crc32("BolcciN",7) == 667868444) strcat(s, "l");
if (crc32("URlaSBvbX",9) == 1792606190) strcat(s, "e");
if (crc32("GaoDOnyuJfNm",12) == 3737614580) strcat(s, "l");
if (crc32("GSFlHmGNS",9) == 4247155601) strcat(s, "g");
if (crc32("YcJxdXWSmXg",11) == 1270465709) strcat(s, "l");
if (crc32("SqwpS",5) == 3874587282) strcat(s, "r");
if (crc32("TNmUWH",6) == 1377803211) strcat(s, "y");
if (crc32("QnmHNsFxJF",10) == 3882081634) strcat(s, "e");
if (crc32("UsecZeIL",8) == 800815932) strcat(s, "X");
if (crc32("UNNiZTik",8) == 1828344667) strcat(s, "s");
if (crc32("UeozKwWT",8) == 1878916095) strcat(s, "p");
if (crc32("CJfHBfi",7) == 2051614684) strcat(s, "e");
if (crc32("OKjYhYa",7) == 943661774) strcat(s, "c");
if (crc32("HgjrnHmz",8) == 3368605507) strcat(s, "f");
if (crc32("ouwgENwhosrOXn",14) == 3495163468) strcat(s, "t");
if (crc32("rBuAXajMy",9) == 2332540514) strcat(s, "e");
if (crc32("vIFTHIeJ",8) == 1702102623) strcat(s, "d");
    return s;
}

char *presuccessful_adjectives() {
    char *s = calloc(14);
    if (crc32("tMLBmTEXykkG",12) == 3256954416) strcat(s, "p");
if (crc32("Ubawg",5) == 1564685043) strcat(s, "r");
if (crc32("rYFBFrlnwJsqqD",14) == 457773575) strcat(s, "p");
if (crc32("XahHuAFF",8) == 1445025163) strcat(s, "e");
if (crc32("rfVdDpFSjvTxx",13) == 2533363833) strcat(s, "s");
if (crc32("kWqddB",6) == 1046062691) strcat(s, "e");
if (crc32("mHsKPArBbcga",12) == 4163779797) strcat(s, "u");
if (crc32("IgKrZjp",7) == 422021134) strcat(s, "c");
if (crc32("YumyGFxjLU",10) == 1196005174) strcat(s, "c");
if (crc32("UJkMsPMLzJqVb",13) == 1172269715) strcat(s, "e");
if (crc32("qefUoPvf",8) == 1989054940) strcat(s, "R");
if (crc32("ypTdYkZgKOUoCZ",14) == 2974285959) strcat(s, "s");
if (crc32("osTyZAMCyf",10) == 452675416) strcat(s, "E");
if (crc32("JyJiPE",6) == 3831605930) strcat(s, "s");
if (crc32("GMRwWDDSCndmGo",14) == 2976966785) strcat(s, "w");
if (crc32("pfOLKxlbPmHxh",13) == 3000516655) strcat(s, "f");
if (crc32("ZpUTL",5) == 343210331) strcat(s, "u");
if (crc32("iOPSACwzDHcKv",13) == 3676709062) strcat(s, "R");
if (crc32("ghNoeJrcZUMMn",13) == 3030974496) strcat(s, "l");
    return s;
}

char *unmisgiving_adjectives() {
    char *s = calloc(12);
    if (crc32("xCLwbtTMo",9) == 1798064658) strcat(s, "u");
if (crc32("ENUtOaQXR",9) == 1812330243) strcat(s, "n");
if (crc32("hkOZcKhMmbhJp",13) == 530498730) strcat(s, "m");
if (crc32("LlMLrZvj",8) == 3294015332) strcat(s, "X");
if (crc32("SZkypZkIARbiqd",14) == 76138274) strcat(s, "i");
if (crc32("iRwvZUvgPk",10) == 2231435247) strcat(s, "s");
if (crc32("eTgVJ",5) == 2395191140) strcat(s, "A");
if (crc32("zeUHgUb",7) == 183929435) strcat(s, "g");
if (crc32("IIYem",5) == 3859507025) strcat(s, "N");
if (crc32("qkaShrUh",8) == 489692213) strcat(s, "i");
if (crc32("ZHJOxLrECOijwBR",15) == 3483454267) strcat(s, "u");
if (crc32("BtrocHdehyjiZoA",15) == 2559648287) strcat(s, "v");
if (crc32("tdrRAPBCRg",10) == 2736098639) strcat(s, "i");
if (crc32("PXRzhPf",7) == 1083925409) strcat(s, "n");
if (crc32("wNSJGMs",7) == 4091927822) strcat(s, "g");
    return s;
}

char *Jezebelian_adjectives() {
    char *s = calloc(11);
    if (crc32("UauaZajo",8) == 86119968) strcat(s, "J");
if (crc32("MYyYiYIy",8) == 2609987671) strcat(s, "L");
if (crc32("ZfTyFRZizstDVb",14) == 3977495713) strcat(s, "e");
if (crc32("vewirGTRN",9) == 201504287) strcat(s, "z");
if (crc32("QoJJgzz",7) == 790539448) strcat(s, "e");
if (crc32("yBIKWthpz",9) == 233138134) strcat(s, "a");
if (crc32("ouVLPACYyKWunf",14) == 2598251416) strcat(s, "b");
if (crc32("VQwoGBzrKmVdde",14) == 439953210) strcat(s, "e");
if (crc32("qaSYgCQjrNg",11) == 399775540) strcat(s, "l");
if (crc32("AXLwcLuvhDglwvU",15) == 527930280) strcat(s, "i");
if (crc32("lbKgDb",6) == 4215989567) strcat(s, "t");
if (crc32("zgGAv",5) == 4133548481) strcat(s, "a");
if (crc32("ZNqavdyO",8) == 3368598744) strcat(s, "n");
    return s;
}

char *hierarchical_adjectives() {
    char *s = calloc(13);
    if (crc32("NGQHEzDMUEKcghQ",15) == 565518773) strcat(s, "G");
if (crc32("ajqOmyFpfaNv",12) == 4042300578) strcat(s, "h");
if (crc32("TAfOLJvrRJNswdR",15) == 2330808736) strcat(s, "i");
if (crc32("HJHFcARwhIW",11) == 2350326633) strcat(s, "E");
if (crc32("olOqrZ",6) == 340881394) strcat(s, "e");
if (crc32("uWCvNWwbskJX",12) == 487830936) strcat(s, "r");
if (crc32("muhKVlVovyIFk",13) == 705261827) strcat(s, "a");
if (crc32("WreamdxhGTerlpo",15) == 1475401148) strcat(s, "r");
if (crc32("XreHDlQOJmj",11) == 3196412026) strcat(s, "c");
if (crc32("IkFyywahvM",10) == 446205058) strcat(s, "h");
if (crc32("cQOgDQTMS",9) == 4000833759) strcat(s, "o");
if (crc32("VUNlXyQRGSDXr",13) == 2076619082) strcat(s, "i");
if (crc32("lkKgzVOHgKOt",12) == 1787778864) strcat(s, "c");
if (crc32("TapdiCtIgngB",12) == 1667582529) strcat(s, "B");
if (crc32("rKnHbolh",8) == 3483593713) strcat(s, "a");
if (crc32("VTNDmuTdnVKaIQ",14) == 4114647388) strcat(s, "l");
    return s;
}

char *nonmagnetized_adjectives() {
    char *s = calloc(14);
    if (crc32("DFlfNglRHjjf",12) == 3907945328) strcat(s, "m");
if (crc32("TgExJnGBiakv",12) == 1832988181) strcat(s, "n");
if (crc32("hiTnQgqKHPsbCmm",15) == 2473895921) strcat(s, "R");
if (crc32("IgRVSwsKaJjmmf",14) == 508582055) strcat(s, "o");
if (crc32("hyskinGvWRjCZdx",15) == 3637962239) strcat(s, "d");
if (crc32("YTCalKg",7) == 2707544949) strcat(s, "n");
if (crc32("eRyFrnBj",8) == 1588220724) strcat(s, "m");
if (crc32("qpsMLLidKNPb",12) == 2575165098) strcat(s, "a");
if (crc32("wNXcmqyITnlG",12) == 2985026236) strcat(s, "R");
if (crc32("YUrjoQogt",9) == 2703933212) strcat(s, "g");
if (crc32("stYLqadOVNQA",12) == 2210421103) strcat(s, "p");
if (crc32("FTAqtWAU",8) == 573644240) strcat(s, "n");
if (crc32("XrpVzEUgjp",10) == 4194545693) strcat(s, "c");
if (crc32("YQsxzWvKgqv",11) == 704116332) strcat(s, "e");
if (crc32("ejBog",5) == 568183469) strcat(s, "f");
if (crc32("xVZOOW",6) == 3162023618) strcat(s, "t");
if (crc32("BFgHQoNDPTqN",12) == 3031070101) strcat(s, "i");
if (crc32("XhhctzFe",8) == 1196233259) strcat(s, "z");
if (crc32("zkfbWIzsZ",9) == 431639987) strcat(s, "e");
if (crc32("AEwQV",5) == 2428917808) strcat(s, "A");
if (crc32("BCSUpRFmyGLfG",13) == 263591022) strcat(s, "d");
    return s;
}

char *nonrotational_adjectives() {
    char *s = calloc(14);
    if (crc32("AKtJu",5) == 3927310852) strcat(s, "n");
if (crc32("kXiej",5) == 3566366983) strcat(s, "n");
if (crc32("vkRqotZo",8) == 3979692649) strcat(s, "F");
if (crc32("ictWIZmZWNRvAf",14) == 4124810886) strcat(s, "o");
if (crc32("DINfvJKOTUZ",11) == 3956226476) strcat(s, "i");
if (crc32("yOjdZb",6) == 3219256067) strcat(s, "n");
if (crc32("kDuUxteaGVOi",12) == 3668256856) strcat(s, "r");
if (crc32("fMrAjgOjB",9) == 3446598221) strcat(s, "o");
if (crc32("LolCZdczfTqFgO",14) == 2083183371) strcat(s, "s");
if (crc32("ktHwpGuc",8) == 3227821546) strcat(s, "t");
if (crc32("zIukSmzFcGmS",12) == 3127027828) strcat(s, "J");
if (crc32("tPyqfBtprGpozvR",15) == 2333916047) strcat(s, "a");
if (crc32("SCcaZzI",7) == 3765307971) strcat(s, "t");
if (crc32("UsYBmXoTr",9) == 1149374731) strcat(s, "i");
if (crc32("xLHgLwR",7) == 1548633381) strcat(s, "k");
if (crc32("MNEdEcCuW",9) == 479117850) strcat(s, "o");
if (crc32("sYHLOwPp",8) == 4157588193) strcat(s, "n");
if (crc32("JvQYcddLtZgyuTM",15) == 3141476381) strcat(s, "z");
if (crc32("EyZKFuwESfj",11) == 1048126255) strcat(s, "a");
if (crc32("etnVbcFziwXucy",14) == 1487015486) strcat(s, "o");
if (crc32("uYzQoR",6) == 3520254884) strcat(s, "l");
    return s;
}

char *croupous_adjectives() {
    char *s = calloc(9);
    if (crc32("jzvXRjSUdRTWQuK",15) == 555508508) strcat(s, "c");
if (crc32("oHYnKABRMI",10) == 590504067) strcat(s, "r");
if (crc32("rRzoXVXxYz",10) == 3581949212) strcat(s, "o");
if (crc32("wtVqfCe",7) == 3927358749) strcat(s, "u");
if (crc32("skayWnTHDF",10) == 1136043779) strcat(s, "p");
if (crc32("eTIBM",5) == 3253940679) strcat(s, "D");
if (crc32("vzBsMk",6) == 667318326) strcat(s, "o");
if (crc32("oopQpUQMpqnn",12) == 2754297826) strcat(s, "u");
if (crc32("QHcxLcpHsAAot",13) == 3616624589) strcat(s, "P");
if (crc32("ksPatazUb",9) == 1212365414) strcat(s, "s");
    return s;
}

char *gray_adjectives() {
    char *s = calloc(5);
    if (crc32("lLdtTZYkHCWZfm",14) == 3288788574) strcat(s, "s");
if (crc32("rMAudVcaRh",10) == 3940072477) strcat(s, "g");
if (crc32("zXVjlbtfZluY",12) == 2501045442) strcat(s, "c");
if (crc32("uilHhi",6) == 3896280189) strcat(s, "r");
if (crc32("nszdc",5) == 367411844) strcat(s, "a");
if (crc32("yUVkeBCdYe",10) == 557797990) strcat(s, "y");
    return s;
}

char *gorillian_adjectives() {
    char *s = calloc(10);
    if (crc32("WsFRiP",6) == 271089622) strcat(s, "g");
if (crc32("FPzNwSZoFUh",11) == 3766011197) strcat(s, "g");
if (crc32("xsJtTofN",8) == 3231794337) strcat(s, "o");
if (crc32("FWXjSNXq",8) == 2227098117) strcat(s, "r");
if (crc32("BVQUVnJPhCIZ",12) == 2714671811) strcat(s, "r");
if (crc32("gTpyT",5) == 2913532284) strcat(s, "Y");
if (crc32("myyjR",5) == 4041231325) strcat(s, "i");
if (crc32("CiXEfyOcRN",10) == 3858425577) strcat(s, "B");
if (crc32("AlKNjS",6) == 1919229619) strcat(s, "l");
if (crc32("HmPqy",5) == 1135866531) strcat(s, "y");
if (crc32("HaCdjegkECPhQuu",15) == 2658230244) strcat(s, "l");
if (crc32("gqUrqdr",7) == 3362776841) strcat(s, "i");
if (crc32("WZJox",5) == 1107956851) strcat(s, "Y");
if (crc32("LSRAQeAEj",9) == 770835572) strcat(s, "a");
if (crc32("MSqNE",5) == 1587236515) strcat(s, "k");
if (crc32("VUJiVvRh",8) == 3365489966) strcat(s, "n");
    return s;
}

char *last_adjectives() {
    char *s = calloc(5);
    if (crc32("YFGhYDhQtnmPGh",14) == 1151417303) strcat(s, "l");
if (crc32("EYyZVBleADJ",11) == 815013036) strcat(s, "a");
if (crc32("litHzDf",7) == 3318821450) strcat(s, "s");
if (crc32("onrbkgvTKjlgmWG",15) == 580297605) strcat(s, "X");
if (crc32("PaYDW",5) == 2145186777) strcat(s, "t");
    return s;
}

char *noncuspidate_adjectives() {
    char *s = calloc(13);
    if (crc32("KwtZEiXgTlsnq",13) == 4150871225) strcat(s, "G");
if (crc32("UqxptPvwDRdOw",13) == 1296657707) strcat(s, "n");
if (crc32("ORFwacktOYHgEI",14) == 860982624) strcat(s, "o");
if (crc32("rGRowAlGPVxIj",13) == 3203154007) strcat(s, "n");
if (crc32("gFySLSvCmdm",11) == 2189076678) strcat(s, "c");
if (crc32("ZKKmdh",6) == 2098602988) strcat(s, "u");
if (crc32("vPfxlKDUNlEcD",13) == 2303008432) strcat(s, "s");
if (crc32("TkcQvYpNX",9) == 2794894153) strcat(s, "p");
if (crc32("fbniLApztMgmTzT",15) == 1619991498) strcat(s, "i");
if (crc32("qpGSesz",7) == 1041032034) strcat(s, "i");
if (crc32("zcrAcMG",7) == 475017498) strcat(s, "d");
if (crc32("ZPNjZAXQ",8) == 547338147) strcat(s, "c");
if (crc32("xcgHmMRxR",9) == 1533747893) strcat(s, "a");
if (crc32("TltDytdPqURT",12) == 1066117527) strcat(s, "t");
if (crc32("sLiRYNmq",8) == 457878927) strcat(s, "o");
if (crc32("KEQUWjFeAgK",11) == 2955843686) strcat(s, "e");
    return s;
}

char *unfenestrated_adjectives() {
    char *s = calloc(14);
    if (crc32("ZDILwmoVMPV",11) == 1116996781) strcat(s, "u");
if (crc32("eGqjSpjlWTJzZSf",15) == 1304819953) strcat(s, "n");
if (crc32("wTSrpFNdtCVoyA",14) == 3213171651) strcat(s, "f");
if (crc32("EEKPnxBVU",9) == 1434775619) strcat(s, "e");
if (crc32("kGcGNcucNKkqQVG",15) == 3892110900) strcat(s, "n");
if (crc32("ioTdtNqJN",9) == 2742770248) strcat(s, "N");
if (crc32("pKUTcRrvzkxdxX",14) == 768502531) strcat(s, "e");
if (crc32("iGPRPzvzPvR",11) == 854188762) strcat(s, "s");
if (crc32("NsLLpKmz",8) == 2251256969) strcat(s, "J");
if (crc32("lojaZMeN",8) == 3350799984) strcat(s, "t");
if (crc32("VnzzqY",6) == 3090434678) strcat(s, "W");
if (crc32("CHSPvhLcqk",10) == 136304787) strcat(s, "r");
if (crc32("BHSOigklnebqek",14) == 814704231) strcat(s, "k");
if (crc32("MAZwUxLwywIlyp",14) == 1811652670) strcat(s, "a");
if (crc32("BkNHvqNWrn",10) == 1298250156) strcat(s, "x");
if (crc32("jRwfdVjuk",9) == 2157515691) strcat(s, "t");
if (crc32("NSokKRewi",9) == 3915039196) strcat(s, "l");
if (crc32("ZoXOLrowxC",10) == 1000791693) strcat(s, "e");
if (crc32("mPaHh",5) == 1085179481) strcat(s, "f");
if (crc32("JbTFvawPFuudN",13) == 3827888953) strcat(s, "d");
    return s;
}

char *Ushaped_adjectives() {
    char *s = calloc(8);
    if (crc32("njwzCRhDLJzTO",13) == 3682788195) strcat(s, "U");
if (crc32("dATMVEX",7) == 1411608544) strcat(s, "G");
if (crc32("CSAQV",5) == 1345915627) strcat(s, "s");
if (crc32("xBdEDXEnrkOVfr",14) == 869958085) strcat(s, "h");
if (crc32("wsVNkhzGmXQ",11) == 1779024811) strcat(s, "a");
if (crc32("dkxjKCZPmcJ",11) == 1181040511) strcat(s, "p");
if (crc32("RAnsog",6) == 703245324) strcat(s, "e");
if (crc32("cJhroQyyoHA",11) == 13553933) strcat(s, "d");
    return s;
}

char *crannied_adjectives() {
    char *s = calloc(9);
    if (crc32("JCHGZGsDl",9) == 4123036596) strcat(s, "x");
if (crc32("gsayQCAx",8) == 3812048424) strcat(s, "c");
if (crc32("rrroU",5) == 706167432) strcat(s, "r");
if (crc32("nYbEgiLbj",9) == 2506983029) strcat(s, "a");
if (crc32("WYDBXmSqJ",9) == 48381732) strcat(s, "B");
if (crc32("ncdLZIAbUklpkc",14) == 852068542) strcat(s, "n");
if (crc32("nNKlFCGXvIlMFkH",15) == 3937023126) strcat(s, "n");
if (crc32("CyTpvIVeWHL",11) == 2884805036) strcat(s, "S");
if (crc32("dyDQWDq",7) == 3399388753) strcat(s, "i");
if (crc32("lzKmciK",7) == 2181868609) strcat(s, "e");
if (crc32("owAGQWdUBBAOEyl",15) == 1876848336) strcat(s, "d");
    return s;
}

char *preaggressive_adjectives() {
    char *s = calloc(14);
    if (crc32("SGwnzdc",7) == 2169231784) strcat(s, "p");
if (crc32("NVolerwIGrkSUA",14) == 3118922079) strcat(s, "r");
if (crc32("pscBB",5) == 1450598626) strcat(s, "e");
if (crc32("AVztcvnNLucTYP",14) == 1195686473) strcat(s, "a");
if (crc32("aDYVWrFvmPtsunN",15) == 3242925032) strcat(s, "V");
if (crc32("CPDvp",5) == 1284460662) strcat(s, "g");
if (crc32("vejNmVL",7) == 3866998660) strcat(s, "v");
if (crc32("vEoauuZcyxXx",12) == 893854484) strcat(s, "g");
if (crc32("ckwoUwMqu",9) == 2438036819) strcat(s, "X");
if (crc32("azaJAtMs",8) == 471564836) strcat(s, "r");
if (crc32("FkZPxitHeT",10) == 2254907731) strcat(s, "Y");
if (crc32("beYrLZfh",8) == 1188468949) strcat(s, "e");
if (crc32("CWuHVEOjDd",10) == 787232800) strcat(s, "d");
if (crc32("qLzXWlPG",8) == 1639806975) strcat(s, "s");
if (crc32("fSmuTooGphOd",12) == 450796662) strcat(s, "H");
if (crc32("evcARa",6) == 1973091111) strcat(s, "s");
if (crc32("czQzRhJTsw",10) == 3492317084) strcat(s, "i");
if (crc32("QIobyUMNQLaWT",13) == 898407098) strcat(s, "v");
if (crc32("mbeDLAUeTZjEx",13) == 1565193197) strcat(s, "b");
if (crc32("iOHqho",6) == 1059118970) strcat(s, "e");
    return s;
}

char *upstate_adjectives() {
    char *s = calloc(8);
    if (crc32("MqofVjsVdIyf",12) == 1570992794) strcat(s, "A");
if (crc32("DmgyIbBkUt",10) == 1421296335) strcat(s, "u");
if (crc32("TsnLYfDhXOCW",12) == 2223655472) strcat(s, "J");
if (crc32("oaTVvRdNocUGdx",14) == 1644071159) strcat(s, "p");
if (crc32("BZvGdACXpOPc",12) == 3570942529) strcat(s, "Z");
if (crc32("ycusFWtYKmkb",12) == 1473378198) strcat(s, "s");
if (crc32("vMfrgHJBw",9) == 2100672089) strcat(s, "t");
if (crc32("wafVCalErWZ",11) == 3550780710) strcat(s, "G");
if (crc32("lYiJyjXzqVGjQu",14) == 3258690573) strcat(s, "a");
if (crc32("QCYMLpl",7) == 3754182852) strcat(s, "t");
if (crc32("gWwtZYrAikxZ",12) == 2704310086) strcat(s, "q");
if (crc32("pGwRPPzBEr",10) == 3454768653) strcat(s, "e");
    return s;
}

char *fuzzy_adjectives() {
    char *s = calloc(6);
    if (crc32("OMyyKLMHeh",10) == 3716262591) strcat(s, "f");
if (crc32("KQNtCdkzxL",10) == 209334141) strcat(s, "u");
if (crc32("kaBYLNJZNROko",13) == 719006506) strcat(s, "U");
if (crc32("HIBfxOeChr",10) == 3486622482) strcat(s, "z");
if (crc32("eqpzDBtAbVlbSu",14) == 365246538) strcat(s, "e");
if (crc32("jDffJLWehxJd",12) == 3006743010) strcat(s, "z");
if (crc32("CZZXO",5) == 956488061) strcat(s, "l");
if (crc32("sNTUrNfjA",9) == 2997073561) strcat(s, "y");
    return s;
}

char *disciplinal_adjectives() {
    char *s = calloc(12);
    if (crc32("HtonAoMTWcG",11) == 283268108) strcat(s, "d");
if (crc32("wqPAabAXvPwg",12) == 957995067) strcat(s, "d");
if (crc32("qntMclEeycjU",12) == 1930736757) strcat(s, "J");
if (crc32("zMLQuPpoqXUGvfP",15) == 1533144306) strcat(s, "i");
if (crc32("tldzzFwyplh",11) == 1691582143) strcat(s, "N");
if (crc32("KCqVAQNLPdcbfYJ",15) == 762649890) strcat(s, "s");
if (crc32("BVJjw",5) == 638174190) strcat(s, "c");
if (crc32("HeBAzwqls",9) == 3474236351) strcat(s, "r");
if (crc32("whxcmihltmYAfPa",15) == 3939431876) strcat(s, "i");
if (crc32("lxcaFm",6) == 4075866384) strcat(s, "p");
if (crc32("jmuYcOBKWvA",11) == 2018715016) strcat(s, "B");
if (crc32("kwSfMhqYjHiqxP",14) == 577361614) strcat(s, "l");
if (crc32("sPNskuVl",8) == 4193279158) strcat(s, "i");
if (crc32("tOKEfXyrouuoXi",14) == 302414743) strcat(s, "n");
if (crc32("ZdxNMjGgutIk",12) == 1497427803) strcat(s, "X");
if (crc32("iYaaT",5) == 3186674709) strcat(s, "a");
if (crc32("SflCZWPNVSyhbf",14) == 1631265416) strcat(s, "H");
if (crc32("lOnSGlagGOhJ",12) == 1443904032) strcat(s, "l");
    return s;
}

char *bimensal_adjectives() {
    char *s = calloc(9);
    if (crc32("gOATxryoeveDmJ",14) == 3466736607) strcat(s, "W");
if (crc32("OLZberwVGE",10) == 2418998582) strcat(s, "b");
if (crc32("mqNzE",5) == 3714123697) strcat(s, "i");
if (crc32("BEWhsClra",9) == 4082531159) strcat(s, "p");
if (crc32("ScgGIniWM",9) == 2608151267) strcat(s, "m");
if (crc32("wdLmJkqyCSjKAfY",15) == 4232484863) strcat(s, "G");
if (crc32("ykFSaLME",8) == 1078292786) strcat(s, "e");
if (crc32("JweidekwsTmZWr",14) == 1286035093) strcat(s, "r");
if (crc32("rpgaVLr",7) == 3485952669) strcat(s, "n");
if (crc32("eEYsoKDYPSTtNiL",15) == 3817511792) strcat(s, "s");
if (crc32("PTqtFbfQRtwd",12) == 1791512387) strcat(s, "f");
if (crc32("MNHWdzoUyU",10) == 1314777978) strcat(s, "a");
if (crc32("XzmbQjODEm",10) == 1411799447) strcat(s, "N");
if (crc32("kshqJLG",7) == 718511959) strcat(s, "l");
    return s;
}

char *fleshly_adjectives() {
    char *s = calloc(8);
    if (crc32("ayyKsfPjlRWCZUH",15) == 1289595147) strcat(s, "f");
if (crc32("JEbxSYpWlz",10) == 1997763358) strcat(s, "l");
if (crc32("FXzVsibNhVI",11) == 239609696) strcat(s, "A");
if (crc32("zXDaNZu",7) == 25109705) strcat(s, "e");
if (crc32("eHGcARaQJ",9) == 2103635010) strcat(s, "s");
if (crc32("nmXTO",5) == 2233877521) strcat(s, "A");
if (crc32("HOLUcRQzLoDlG",13) == 3702646790) strcat(s, "h");
if (crc32("HTdLcpdEgCARI",13) == 1276360322) strcat(s, "r");
if (crc32("vwDXfHlrtDfJLdr",15) == 4069879904) strcat(s, "l");
if (crc32("LwsAsB",6) == 1886741097) strcat(s, "V");
if (crc32("zoebPdgbPbAWQp",14) == 1345830787) strcat(s, "y");
    return s;
}

char *dative_adjectives() {
    char *s = calloc(7);
    if (crc32("iRwDbmnHBtQNEcT",15) == 56673659) strcat(s, "n");
if (crc32("qakaDl",6) == 2697811805) strcat(s, "d");
if (crc32("dGbrWO",6) == 498564242) strcat(s, "a");
if (crc32("eqfEeCmVfXJNZkW",15) == 3467195466) strcat(s, "t");
if (crc32("sfBHXJPGc",9) == 4073280784) strcat(s, "i");
if (crc32("woYQCeuli",9) == 3056078295) strcat(s, "v");
if (crc32("wzBTCg",6) == 1185782355) strcat(s, "e");
    return s;
}

char *uncreatable_adjectives() {
    char *s = calloc(12);
    if (crc32("VIjGFbG",7) == 1235060232) strcat(s, "f");
if (crc32("aeAufZKAUxazz",13) == 1891391833) strcat(s, "u");
if (crc32("mmIkeJAd",8) == 1403123398) strcat(s, "c");
if (crc32("GJaIH",5) == 3371259876) strcat(s, "n");
if (crc32("qWHSzgWN",8) == 3145941312) strcat(s, "A");
if (crc32("JQRLfnIpLw",10) == 1132265350) strcat(s, "c");
if (crc32("ViGBGkP",7) == 76758467) strcat(s, "c");
if (crc32("ayFeTXem",8) == 2232000002) strcat(s, "r");
if (crc32("uhcZn",5) == 1839749676) strcat(s, "R");
if (crc32("HfzXb",5) == 945059556) strcat(s, "e");
if (crc32("bSrlXM",6) == 1907952331) strcat(s, "a");
if (crc32("QWwzQOgrHMI",11) == 1093820018) strcat(s, "L");
if (crc32("gaGANDucx",9) == 912492619) strcat(s, "t");
if (crc32("PJdFjkxuetNInR",14) == 2469201971) strcat(s, "a");
if (crc32("wiZmpsUjBT",10) == 2562261287) strcat(s, "j");
if (crc32("edtruwNPTgy",11) == 1029419587) strcat(s, "b");
if (crc32("pLwNSXparZwz",12) == 204755968) strcat(s, "e");
if (crc32("mGEWcDyZO",9) == 1479975887) strcat(s, "l");
if (crc32("OaJdhDL",7) == 1227454416) strcat(s, "R");
if (crc32("IvzUaUJRufPjh",13) == 3589330615) strcat(s, "e");
    return s;
}

char *unretributive_adjectives() {
    char *s = calloc(14);
    if (crc32("nlvWzJfXviLa",12) == 1596609762) strcat(s, "b");
if (crc32("VeVKxXUeSSLW",12) == 490917979) strcat(s, "u");
if (crc32("WAVWweGhG",9) == 2088504868) strcat(s, "Y");
if (crc32("dMIOPZG",7) == 60265268) strcat(s, "n");
if (crc32("qdiVGhotqIka",12) == 1610126172) strcat(s, "N");
if (crc32("iKMqiownzYIGyd",14) == 1399962212) strcat(s, "r");
if (crc32("sXnURXZeFxQL",12) == 78558763) strcat(s, "y");
if (crc32("NqVKiMoswdIFEF",14) == 916453743) strcat(s, "e");
if (crc32("VDlnRlbgBQPHLTv",15) == 1509502723) strcat(s, "t");
if (crc32("LnfzrcKty",9) == 1238911136) strcat(s, "Y");
if (crc32("FjuLzIatNznB",12) == 1557014291) strcat(s, "r");
if (crc32("fsAQCk",6) == 695393094) strcat(s, "F");
if (crc32("QosXXNCVJZxNVA",14) == 1841588613) strcat(s, "i");
if (crc32("ZjhxAL",6) == 4247613477) strcat(s, "b");
if (crc32("YjniLsjEW",9) == 3684568573) strcat(s, "x");
if (crc32("GBXRISi",7) == 3984858601) strcat(s, "u");
if (crc32("sHEVTZ",6) == 350376407) strcat(s, "U");
if (crc32("IYRcThBFPS",10) == 3238484801) strcat(s, "t");
if (crc32("ZiryK",5) == 1621328004) strcat(s, "y");
if (crc32("juTLc",5) == 2860744408) strcat(s, "i");
if (crc32("JLRZyWxQYs",10) == 1678483806) strcat(s, "e");
if (crc32("HPVBdHnAu",9) == 1839631647) strcat(s, "v");
if (crc32("jzCPqVRvRBgajGO",15) == 467456163) strcat(s, "I");
if (crc32("kCNvCmr",7) == 671256744) strcat(s, "e");
    return s;
}

char *adhoc_adjectives() {
    char *s = calloc(6);
    if (crc32("ijEKIRx",7) == 1597211366) strcat(s, "a");
if (crc32("bjKrCP",6) == 2351124014) strcat(s, "d");
if (crc32("qQBkBodtgyWfAj",14) == 936375637) strcat(s, "h");
if (crc32("UYifgH",6) == 3605476193) strcat(s, "t");
if (crc32("WtXxzzRxHI",10) == 1507067280) strcat(s, "o");
if (crc32("ptcaZUSJQjXNA",13) == 2200517795) strcat(s, "Z");
if (crc32("wIrVq",5) == 4149926707) strcat(s, "c");
    return s;
}

char *ordinal_adjectives() {
    char *s = calloc(8);
    if (crc32("YXaOAbQPnPXB",12) == 2086595405) strcat(s, "o");
if (crc32("lDbULwTwNSIG",12) == 1155572012) strcat(s, "F");
if (crc32("fftdw",5) == 1377130399) strcat(s, "r");
if (crc32("oRTHrXwSAGD",11) == 1983717618) strcat(s, "d");
if (crc32("MUTuaIL",7) == 1648702406) strcat(s, "i");
if (crc32("XLWEGUTOWvDPU",13) == 3352930003) strcat(s, "I");
if (crc32("PsWWicyUAGmP",12) == 703858758) strcat(s, "n");
if (crc32("TJCVmRLBbfh",11) == 1653266050) strcat(s, "a");
if (crc32("ByYaRrYSrtMToqD",15) == 2664728279) strcat(s, "g");
if (crc32("brlHc",5) == 1227914380) strcat(s, "l");
    return s;
}

char *outgoing_adjectives() {
    char *s = calloc(9);
    if (crc32("bfJqVRFbQq",10) == 36242430) strcat(s, "o");
if (crc32("ritEcvXPTwdT",12) == 2194589797) strcat(s, "u");
if (crc32("KHHmfpmDnLB",11) == 166120874) strcat(s, "J");
if (crc32("SLBwmQHnqP",10) == 1002961759) strcat(s, "t");
if (crc32("VeOTTvQWbPt",11) == 960482800) strcat(s, "N");
if (crc32("aigYPMnMbxPEop",14) == 3823117986) strcat(s, "g");
if (crc32("ggnEZgLkLKBcGV",14) == 2384665061) strcat(s, "F");
if (crc32("yXmMCPdxyLerEWn",15) == 1679274936) strcat(s, "o");
if (crc32("yEVhsw",6) == 1865232095) strcat(s, "i");
if (crc32("fmijeZHwgBA",11) == 585673601) strcat(s, "n");
if (crc32("bJmUQKdPAH",10) == 3863678416) strcat(s, "g");
    return s;
}

char *nonsensate_adjectives() {
    char *s = calloc(11);
    if (crc32("bhurrkYEcgogAI",14) == 4014126432) strcat(s, "n");
if (crc32("sWNoF",5) == 693397790) strcat(s, "o");
if (crc32("deaqHvTo",8) == 3792799555) strcat(s, "n");
if (crc32("VzgiHEatFo",10) == 777645118) strcat(s, "s");
if (crc32("CFfzzs",6) == 4192824224) strcat(s, "y");
if (crc32("skESbEKkhnqzf",13) == 3320333907) strcat(s, "e");
if (crc32("iZGGd",5) == 1988291105) strcat(s, "n");
if (crc32("UZzFpYrTofrdWVO",15) == 1129434858) strcat(s, "P");
if (crc32("KpJLlCPMZv",10) == 1688013698) strcat(s, "s");
if (crc32("DpiKP",5) == 1066311325) strcat(s, "a");
if (crc32("iCxObIs",7) == 3469262505) strcat(s, "l");
if (crc32("KePNIYhPgGPag",13) == 2145289493) strcat(s, "t");
if (crc32("MKHwBpvPlbHwbb",14) == 3630292905) strcat(s, "e");
    return s;
}

char *verbal_adjectives() {
    char *s = calloc(7);
    if (crc32("SFxyaYxuWlGIp",13) == 1450640599) strcat(s, "i");
if (crc32("ucBEhlYh",8) == 2113964132) strcat(s, "v");
if (crc32("jZiULlLCL",9) == 2558720194) strcat(s, "e");
if (crc32("orPNWAV",7) == 3879280077) strcat(s, "r");
if (crc32("rbVqLGiQwQf",11) == 2589029697) strcat(s, "K");
if (crc32("KZEnkeCYxESo",12) == 814119218) strcat(s, "b");
if (crc32("poldPwoB",8) == 1191987962) strcat(s, "a");
if (crc32("lDwqqlnzXI",10) == 618961507) strcat(s, "l");
    return s;
}

char *Ascanian_adjectives() {
    char *s = calloc(9);
    if (crc32("XKFhQqDUgwJDfB",14) == 2979833099) strcat(s, "A");
if (crc32("tMEAitcfJPt",11) == 3784743794) strcat(s, "s");
if (crc32("OQImcUiKNBCEiUB",15) == 1298309739) strcat(s, "w");
if (crc32("SbZOMnWelTy",11) == 1864550616) strcat(s, "c");
if (crc32("snzkxUpxNkk",11) == 3650453945) strcat(s, "a");
if (crc32("JvbpPeNOPG",10) == 2556407539) strcat(s, "n");
if (crc32("UlNXDgOcOQzP",12) == 533920973) strcat(s, "i");
if (crc32("nvAgD",5) == 1959672033) strcat(s, "w");
if (crc32("JjcMLH",6) == 3113838736) strcat(s, "a");
if (crc32("McdJUh",6) == 1147785711) strcat(s, "l");
if (crc32("XOIkGYKHqY",10) == 3327170056) strcat(s, "n");
    return s;
}

char *underproportioned_adjectives() {
    char *s = calloc(18);
    if (crc32("tyOaDcMir",9) == 2133110186) strcat(s, "u");
if (crc32("HOwRzfweKYv",11) == 2484291381) strcat(s, "n");
if (crc32("RMVuOELEBH",10) == 1379251727) strcat(s, "z");
if (crc32("mzzMhGC",7) == 293730050) strcat(s, "d");
if (crc32("UzUfUVaDKSSAB",13) == 4226373746) strcat(s, "e");
if (crc32("xkozpSGnNb",10) == 3822630552) strcat(s, "X");
if (crc32("JBnKqGuSjIRrim",14) == 3017416030) strcat(s, "r");
if (crc32("dASKbfoPQIBvXx",14) == 2512657187) strcat(s, "p");
if (crc32("AjpjMPzIkW",10) == 123064180) strcat(s, "p");
if (crc32("VLLlsPDBDwwNhY",14) == 3150560301) strcat(s, "r");
if (crc32("WYLmOkP",7) == 2457133707) strcat(s, "o");
if (crc32("HxIslnQeMiziOxb",15) == 969851090) strcat(s, "q");
if (crc32("KdSzMl",6) == 971168624) strcat(s, "p");
if (crc32("HSeTWPqxqnX",11) == 3650047632) strcat(s, "o");
if (crc32("IKHBUTU",7) == 3747563317) strcat(s, "r");
if (crc32("QsjPZyJmO",9) == 4113371549) strcat(s, "n");
if (crc32("QtyTZfdHvVgXTj",14) == 532307742) strcat(s, "t");
if (crc32("iVqBfFiSJGAEcr",14) == 642662371) strcat(s, "i");
if (crc32("lvJNhr",6) == 1043281527) strcat(s, "x");
if (crc32("CyKHDIRmeCIUlqJ",15) == 799090472) strcat(s, "o");
if (crc32("ORckIZpGd",9) == 178322282) strcat(s, "Z");
if (crc32("yaLyJYDEwARsTg",14) == 1399482264) strcat(s, "n");
if (crc32("mwoXBI",6) == 2197802262) strcat(s, "e");
if (crc32("JUudcesDTYKLw",13) == 3886348326) strcat(s, "f");
if (crc32("gHIDej",6) == 3906119878) strcat(s, "d");
    return s;
}

char *predorsal_adjectives() {
    char *s = calloc(10);
    if (crc32("MGPtpnqx",8) == 651623435) strcat(s, "F");
if (crc32("xwbhjyZmwheo",12) == 1038406036) strcat(s, "p");
if (crc32("bOUcbzVQW",9) == 853352193) strcat(s, "s");
if (crc32("DJKBNXTGbUFmBCQ",15) == 1248754330) strcat(s, "r");
if (crc32("tFZrjGjKcYubW",13) == 872361893) strcat(s, "h");
if (crc32("hGvSus",6) == 73165393) strcat(s, "e");
if (crc32("bOCeS",5) == 2123577198) strcat(s, "d");
if (crc32("RbsmYtMlbUtHOgN",15) == 2884787924) strcat(s, "o");
if (crc32("UlUsZVvZZFDfi",13) == 2912693661) strcat(s, "t");
if (crc32("xgpwuGrGvS",10) == 894503685) strcat(s, "r");
if (crc32("bEdyCKqfOPRK",12) == 1844783552) strcat(s, "s");
if (crc32("LkwXGSNL",8) == 3972876518) strcat(s, "h");
if (crc32("fPGNuwDiP",9) == 1203072049) strcat(s, "a");
if (crc32("QUKijrMnspp",11) == 1832983186) strcat(s, "U");
if (crc32("FsOqHFeCxyqjBVD",15) == 1338640371) strcat(s, "l");
    return s;
}

char *needy_adjectives() {
    char *s = calloc(6);
    if (crc32("HfYxnNQm",8) == 1307138350) strcat(s, "o");
if (crc32("VZACTBmKe",9) == 3670239108) strcat(s, "n");
if (crc32("QDJztyTtbV",10) == 3161989088) strcat(s, "U");
if (crc32("lGJDFMWw",8) == 2648490135) strcat(s, "e");
if (crc32("HazJvgMrinYBME",14) == 3218930464) strcat(s, "l");
if (crc32("bMnkKMUgo",9) == 1143285467) strcat(s, "e");
if (crc32("ztbzv",5) == 3877927913) strcat(s, "c");
if (crc32("ovYpptMZB",9) == 264781724) strcat(s, "d");
if (crc32("NlkkDRzmWk",10) == 1320995731) strcat(s, "a");
if (crc32("OUotxy",6) == 1102922782) strcat(s, "y");
    return s;
}

char *overluscious_adjectives() {
    char *s = calloc(13);
    if (crc32("BSUxHXLHdLWIrob",15) == 2706452183) strcat(s, "o");
if (crc32("mcIBDlMWjEqo",12) == 3761625760) strcat(s, "o");
if (crc32("IIgZKcDKrSt",11) == 3762865089) strcat(s, "v");
if (crc32("fCfCHVH",7) == 3207151662) strcat(s, "s");
if (crc32("gKMrSVRlEorznJA",15) == 2634997303) strcat(s, "e");
if (crc32("QKrVgKIrylzxW",13) == 3131429426) strcat(s, "y");
if (crc32("wciwoJheid",10) == 3507830828) strcat(s, "r");
if (crc32("SYhevaGuwj",10) == 457078960) strcat(s, "D");
if (crc32("McFADD",6) == 4128594450) strcat(s, "l");
if (crc32("kJfLCylGsmX",11) == 3884826811) strcat(s, "V");
if (crc32("BUThL",5) == 2704894428) strcat(s, "u");
if (crc32("LZYoGyV",7) == 3971222582) strcat(s, "s");
if (crc32("WaZrpe",6) == 1235310254) strcat(s, "N");
if (crc32("ijAnIxtzq",9) == 3710004692) strcat(s, "c");
if (crc32("diRPsqkLvWsDatE",15) == 2252323174) strcat(s, "i");
if (crc32("XYfTyfZyNgPM",12) == 926787048) strcat(s, "o");
if (crc32("JShdcLYfOY",10) == 3511735496) strcat(s, "u");
if (crc32("FhVFJYqqJlsIv",13) == 3767958983) strcat(s, "q");
if (crc32("TFOylohDbDSm",12) == 3198398131) strcat(s, "s");
    return s;
}

char *pilgrimatical_adjectives() {
    char *s = calloc(14);
    if (crc32("akMlBi",6) == 1109032415) strcat(s, "p");
if (crc32("cJOKb",5) == 1931788656) strcat(s, "c");
if (crc32("BrfpCLWpiakw",12) == 2787835454) strcat(s, "i");
if (crc32("ZjSgDCFyQiRq",12) == 453789104) strcat(s, "l");
if (crc32("fRJfe",5) == 3257328441) strcat(s, "g");
if (crc32("oZMYbVPyuvpP",12) == 1246922449) strcat(s, "z");
if (crc32("avebDAr",7) == 2379348494) strcat(s, "r");
if (crc32("NpxdXxk",7) == 2696225767) strcat(s, "i");
if (crc32("eHUvTTicBZHPcET",15) == 2884804914) strcat(s, "m");
if (crc32("YpIAqWpOVcDzEOK",15) == 313757688) strcat(s, "C");
if (crc32("hoQnf",5) == 1056238087) strcat(s, "a");
if (crc32("qchvl",5) == 1353060116) strcat(s, "t");
if (crc32("LcGgu",5) == 229964078) strcat(s, "i");
if (crc32("CdeKzVKBynYe",12) == 1338818502) strcat(s, "p");
if (crc32("ngYyESuVoCHyg",13) == 1145963360) strcat(s, "c");
if (crc32("CaVtorvyfgOVy",13) == 321551461) strcat(s, "a");
if (crc32("lNdNmOnQkYElOBk",15) == 3948719032) strcat(s, "o");
if (crc32("yTWCeSarquMgx",13) == 459636192) strcat(s, "l");
    return s;
}

char *zany_adjectives() {
    char *s = calloc(5);
    if (crc32("MPpDPYCJympHbq",14) == 1691707207) strcat(s, "z");
if (crc32("xoAYIDbCzkFSb",13) == 3763009718) strcat(s, "L");
if (crc32("AfRjXTDklhi",11) == 2747383770) strcat(s, "a");
if (crc32("AOHZYAD",7) == 3063090102) strcat(s, "n");
if (crc32("XWbshRd",7) == 2184407985) strcat(s, "y");
    return s;
}

char *Cretaceous_adjectives() {
    char *s = calloc(11);
    if (crc32("EpKKxd",6) == 359670439) strcat(s, "R");
if (crc32("weQlM",5) == 762548722) strcat(s, "C");
if (crc32("GXpbxmKrKhZF",12) == 2925754848) strcat(s, "t");
if (crc32("CMQkyEfCqGkrO",13) == 277250767) strcat(s, "r");
if (crc32("yhSGTF",6) == 1015102323) strcat(s, "Q");
if (crc32("icBgU",5) == 959495033) strcat(s, "e");
if (crc32("MDfmSvCDxGtNvMI",15) == 1374926385) strcat(s, "t");
if (crc32("jDueWH",6) == 719202370) strcat(s, "a");
if (crc32("WtZgtA",6) == 263921780) strcat(s, "c");
if (crc32("njUYgz",6) == 1433153416) strcat(s, "e");
if (crc32("KGTqavaQMmFo",12) == 2483110720) strcat(s, "H");
if (crc32("qxjLd",5) == 4282932655) strcat(s, "o");
if (crc32("kBBcaAdBBjXXY",13) == 1769397250) strcat(s, "u");
if (crc32("FbicvbbxSntfPl",14) == 1149839945) strcat(s, "s");
    return s;
}

char *ithyphallic_adjectives() {
    char *s = calloc(12);
    if (crc32("MmwoyzzOp",9) == 3785224249) strcat(s, "f");
if (crc32("BvmuPPU",7) == 1673945151) strcat(s, "i");
if (crc32("TsUZKfcZLHUpk",13) == 869240430) strcat(s, "t");
if (crc32("lrcWc",5) == 805735246) strcat(s, "h");
if (crc32("RmyMNPEVIoPme",13) == 108503231) strcat(s, "y");
if (crc32("vRGHkQIg",8) == 2998772366) strcat(s, "p");
if (crc32("qITUuiofUr",10) == 2980341800) strcat(s, "h");
if (crc32("ZwZpfcY",7) == 3979255624) strcat(s, "P");
if (crc32("THPDLBWsnl",10) == 920848001) strcat(s, "a");
if (crc32("jZvcHWiHFh",10) == 2793867146) strcat(s, "l");
if (crc32("xBtLakaEueEpQxj",15) == 328410730) strcat(s, "N");
if (crc32("mLVPPpVPdkxG",12) == 1932587852) strcat(s, "l");
if (crc32("Kltaqs",6) == 2863311467) strcat(s, "s");
if (crc32("eylyuDNVVSWd",12) == 819728861) strcat(s, "i");
if (crc32("aYhybIpuDpwq",12) == 152892293) strcat(s, "Q");
if (crc32("pIhnvQJSX",9) == 651673850) strcat(s, "c");
    return s;
}

char *halfcrumbled_adjectives() {
    char *s = calloc(13);
    if (crc32("rrvrDWC",7) == 2852912866) strcat(s, "E");
if (crc32("dEJkaTlSbdFrE",13) == 276342581) strcat(s, "h");
if (crc32("ZvveUhZrnLOp",12) == 1041534114) strcat(s, "g");
if (crc32("VOGTGbLXQMSJYf",14) == 1950631330) strcat(s, "a");
if (crc32("iPjhrhOEQDIRhV",14) == 324785228) strcat(s, "h");
if (crc32("DYcVLw",6) == 3272059418) strcat(s, "l");
if (crc32("mTRxuynYSOMny",13) == 1281678605) strcat(s, "J");
if (crc32("GZQpYA",6) == 2631850897) strcat(s, "f");
if (crc32("sBnYiUHTc",9) == 2827214543) strcat(s, "c");
if (crc32("AAsVX",5) == 357815213) strcat(s, "w");
if (crc32("pogRKzS",7) == 2580360637) strcat(s, "r");
if (crc32("pmCqyQmVoTceIE",14) == 3170708898) strcat(s, "Y");
if (crc32("RFhNzOqhNbZjfua",15) == 23639691) strcat(s, "u");
if (crc32("PsnfMsAgh",9) == 2830680020) strcat(s, "m");
if (crc32("HeleBhWYdWrgqd",14) == 3238348535) strcat(s, "m");
if (crc32("XGTAspTEEspBHRY",15) == 1474080074) strcat(s, "C");
if (crc32("dAjVaWd",7) == 3980762646) strcat(s, "b");
if (crc32("rRasWhCoWzlF",12) == 1210210095) strcat(s, "l");
if (crc32("lhZtvr",6) == 3707697759) strcat(s, "t");
if (crc32("zWNZpJRQm",9) == 2544259383) strcat(s, "e");
if (crc32("NuuJV",5) == 4160599680) strcat(s, "N");
if (crc32("FcjtFmLWxXMnOHJ",15) == 813758889) strcat(s, "d");
    return s;
}

char *nondeaf_adjectives() {
    char *s = calloc(8);
    if (crc32("LaUstxxyOACop",13) == 2546212604) strcat(s, "n");
if (crc32("Ondqp",5) == 3220419173) strcat(s, "h");
if (crc32("fhLNS",5) == 3420109949) strcat(s, "o");
if (crc32("ORmjwZdpAE",10) == 3746746918) strcat(s, "n");
if (crc32("FrXJlhEVKyb",11) == 2302265861) strcat(s, "c");
if (crc32("vWDsJlXq",8) == 600858313) strcat(s, "d");
if (crc32("HYAKteybLT",10) == 3879991788) strcat(s, "l");
if (crc32("MCaXDZyFus",10) == 2091184144) strcat(s, "e");
if (crc32("OqleYV",6) == 1575191497) strcat(s, "a");
if (crc32("IPZLqmCTGNDEI",13) == 3804203579) strcat(s, "a");
if (crc32("qcMOxU",6) == 1097952962) strcat(s, "f");
    return s;
}

char *prebronze_adjectives() {
    char *s = calloc(10);
    if (crc32("moepaCdTOlsWw",13) == 154451169) strcat(s, "p");
if (crc32("GbBmMc",6) == 2564617705) strcat(s, "C");
if (crc32("cviKqAVUqlpSo",13) == 2306362122) strcat(s, "r");
if (crc32("qNtFbsOs",8) == 798570672) strcat(s, "e");
if (crc32("lysTbtsmpyKse",13) == 4196639579) strcat(s, "b");
if (crc32("PlfeFMZDZgkb",12) == 3518538480) strcat(s, "b");
if (crc32("KYYAiqXM",8) == 2157499887) strcat(s, "r");
if (crc32("uPlkLtMDiDB",11) == 2264686098) strcat(s, "o");
if (crc32("GwxgnzckIsWsy",13) == 4275713778) strcat(s, "K");
if (crc32("kAIACp",6) == 2859971193) strcat(s, "n");
if (crc32("ZqFhwIWhXPcugs",14) == 1730718728) strcat(s, "w");
if (crc32("vUaZvB",6) == 2672609800) strcat(s, "z");
if (crc32("AxCsORSAwJWX",12) == 2041160872) strcat(s, "d");
if (crc32("QKbChnPD",8) == 2535219297) strcat(s, "e");
    return s;
}

char *insuperable_adjectives() {
    char *s = calloc(12);
    if (crc32("glUnOPhaDO",10) == 2940538972) strcat(s, "i");
if (crc32("NIBwhPha",8) == 896287702) strcat(s, "j");
if (crc32("elYXQIjlvXEcg",13) == 146262708) strcat(s, "n");
if (crc32("vMKkMh",6) == 3270766680) strcat(s, "s");
if (crc32("dHqaMcmZv",9) == 137065263) strcat(s, "W");
if (crc32("MBHxnsIsjgYJ",12) == 4154247955) strcat(s, "u");
if (crc32("zwOMge",6) == 4247539373) strcat(s, "d");
if (crc32("UMiweUSoAtjoyG",14) == 2316250399) strcat(s, "p");
if (crc32("WVTicGemFjPsjGc",15) == 213986432) strcat(s, "o");
if (crc32("OVhHwDWsn",9) == 3075867984) strcat(s, "e");
if (crc32("xlBIty",6) == 1845635528) strcat(s, "Y");
if (crc32("seqvFAXDlYSpbyP",15) == 3802113284) strcat(s, "r");
if (crc32("DWuVJGpEkMHXKy",14) == 3986774857) strcat(s, "S");
if (crc32("ZAkquFHlegzbHiy",15) == 1201989591) strcat(s, "a");
if (crc32("PSzFU",5) == 877864417) strcat(s, "p");
if (crc32("BTXhFhELS",9) == 3259159965) strcat(s, "b");
if (crc32("ztsrdR",6) == 3937986965) strcat(s, "h");
if (crc32("LYqAQodYteyx",12) == 3579513934) strcat(s, "l");
if (crc32("WWphgPpPkdwMy",13) == 1443260353) strcat(s, "H");
if (crc32("mxkYoAW",7) == 2541571469) strcat(s, "e");
    return s;
}

char *quasihealthful_adjectives() {
    char *s = calloc(15);
    if (crc32("KScOJVVEXU",10) == 3404477769) strcat(s, "q");
if (crc32("UMDFOomfRLQQHr",14) == 2397587909) strcat(s, "u");
if (crc32("wZEupDnYWdh",11) == 2712688392) strcat(s, "a");
if (crc32("cEkPkAkphnZ",11) == 3222870316) strcat(s, "n");
if (crc32("KUoNzqKG",8) == 3571293191) strcat(s, "s");
if (crc32("odeNrQK",7) == 1278554430) strcat(s, "i");
if (crc32("CuxJmLIaWkO",11) == 888231947) strcat(s, "b");
if (crc32("MMSJNobvmLMEa",13) == 2458735859) strcat(s, "h");
if (crc32("dQUnD",5) == 3704427178) strcat(s, "U");
if (crc32("mehLTuudByAV",12) == 1326130119) strcat(s, "e");
if (crc32("UTsJP",5) == 1173622561) strcat(s, "a");
if (crc32("VqGBuYfSwZnH",12) == 3841012807) strcat(s, "U");
if (crc32("fJntPDN",7) == 1885059434) strcat(s, "l");
if (crc32("AMDyVPyCWA",10) == 453442412) strcat(s, "t");
if (crc32("dWuBrlYOJnx",11) == 3352389496) strcat(s, "a");
if (crc32("JeoZLU",6) == 191928789) strcat(s, "h");
if (crc32("JIENdsEfaplSU",13) == 2319537994) strcat(s, "i");
if (crc32("efJQur",6) == 2317212890) strcat(s, "f");
if (crc32("BxgRq",5) == 2125388232) strcat(s, "U");
if (crc32("unBdnSgZraH",11) == 45930590) strcat(s, "u");
if (crc32("nKqcakCAjpM",11) == 2687283853) strcat(s, "W");
if (crc32("gwVfICUcLlu",11) == 11122932) strcat(s, "l");
    return s;
}

char *decem_adjectives() {
    char *s = calloc(6);
    if (crc32("HXXVWiTkiFYuE",13) == 3574233220) strcat(s, "d");
if (crc32("aGSLXtqPUMf",11) == 2916130070) strcat(s, "f");
if (crc32("XZwPJnbh",8) == 3895643501) strcat(s, "e");
if (crc32("DrmHpgkfXzv",11) == 1729584954) strcat(s, "Q");
if (crc32("HnxFRxMvJwOsr",13) == 1986214) strcat(s, "c");
if (crc32("iOwLI",5) == 2466590114) strcat(s, "e");
if (crc32("XSwHFuZWFILbp",13) == 3717986154) strcat(s, "m");
    return s;
}

char *typhous_adjectives() {
    char *s = calloc(8);
    if (crc32("OWsujmgHkPi",11) == 2083050969) strcat(s, "t");
if (crc32("CGeWd",5) == 3104560790) strcat(s, "l");
if (crc32("wNkjVxnlsn",10) == 1683035582) strcat(s, "y");
if (crc32("XseGdhk",7) == 1869325819) strcat(s, "p");
if (crc32("NVCkVaKc",8) == 509328096) strcat(s, "h");
if (crc32("MmgDWLfDhnRzj",13) == 3691801392) strcat(s, "o");
if (crc32("zbmhiPDkbPMr",12) == 4003938334) strcat(s, "u");
if (crc32("NLCPzvtrP",9) == 2647566870) strcat(s, "M");
if (crc32("ypcFcLFb",8) == 906662234) strcat(s, "s");
    return s;
}

char *achronychous_adjectives() {
    char *s = calloc(13);
    if (crc32("WeQYnrhJVCdNi",13) == 2665777252) strcat(s, "H");
if (crc32("PdyVE",5) == 4211229840) strcat(s, "a");
if (crc32("EEiJCrYdFuRH",12) == 2505949841) strcat(s, "c");
if (crc32("AWIXMFCcrUQDF",13) == 2844659343) strcat(s, "b");
if (crc32("XSSaKdQvUV",10) == 2614782682) strcat(s, "h");
if (crc32("JhWtvG",6) == 1156371695) strcat(s, "k");
if (crc32("izqyGu",6) == 984600328) strcat(s, "r");
if (crc32("LeaPmJlkbyd",11) == 3088096914) strcat(s, "A");
if (crc32("mbZYbDmrafB",11) == 1121197644) strcat(s, "o");
if (crc32("rjCDMJ",6) == 155593100) strcat(s, "n");
if (crc32("dIbCZmeuz",9) == 4213171435) strcat(s, "W");
if (crc32("RfzYdtuTdEitS",13) == 3335808411) strcat(s, "y");
if (crc32("VCJSOko",7) == 2783962121) strcat(s, "k");
if (crc32("dswIaiGGgJ",10) == 495451299) strcat(s, "c");
if (crc32("NvDuhEci",8) == 194551423) strcat(s, "T");
if (crc32("MtKLzGl",7) == 1958220794) strcat(s, "h");
if (crc32("MVSwdUvpkKVOjKA",15) == 2243429262) strcat(s, "o");
if (crc32("zEexpTgfKEMB",12) == 4044018806) strcat(s, "u");
if (crc32("pObzWY",6) == 1388826897) strcat(s, "z");
if (crc32("WfnPVWfp",8) == 1014835422) strcat(s, "s");
    return s;
}

char *unfallen_adjectives() {
    char *s = calloc(9);
    if (crc32("QUdlXOChJTqwI",13) == 1682655748) strcat(s, "Z");
if (crc32("nljihsmU",8) == 2993670917) strcat(s, "u");
if (crc32("XNgqQHWONoh",11) == 878442028) strcat(s, "Z");
if (crc32("AdiVE",5) == 3131333074) strcat(s, "n");
if (crc32("neJXJmXuRAKlC",13) == 1810548386) strcat(s, "a");
if (crc32("hYgnZVUWLtFnZ",13) == 625859216) strcat(s, "f");
if (crc32("AnthEe",6) == 1099641474) strcat(s, "a");
if (crc32("TRJvqb",6) == 1430492049) strcat(s, "l");
if (crc32("pWXXfnNZA",9) == 87099266) strcat(s, "Y");
if (crc32("ccCYHRZmctfwf",13) == 446088647) strcat(s, "l");
if (crc32("SqGEDZjyEalV",12) == 1052742703) strcat(s, "e");
if (crc32("ClraMgpsmMJBleO",15) == 1827903021) strcat(s, "B");
if (crc32("innMmMzeNodJ",12) == 385756972) strcat(s, "n");
    return s;
}

char *Mosaic_adjectives() {
    char *s = calloc(7);
    if (crc32("JEIoWPsZQJWNLg",14) == 1992596958) strcat(s, "M");
if (crc32("mFuZyyi",7) == 2694752281) strcat(s, "Q");
if (crc32("IZxSctuZkIJnkeR",15) == 3422809393) strcat(s, "o");
if (crc32("fzDHqiE",7) == 3205756489) strcat(s, "L");
if (crc32("tpRYcfr",7) == 3179434828) strcat(s, "s");
if (crc32("DiMCpWSOrVLJ",12) == 2519412853) strcat(s, "a");
if (crc32("CFzsCnDiubPG",12) == 3119603539) strcat(s, "V");
if (crc32("HQrmauhhLNDjA",13) == 834125314) strcat(s, "i");
if (crc32("UhFZjLDO",8) == 3372701691) strcat(s, "Q");
if (crc32("DwiYhAkFfc",10) == 1743320889) strcat(s, "c");
    return s;
}

char *strident_adjectives() {
    char *s = calloc(9);
    if (crc32("WffAWPFmBEEKCW",14) == 3977659959) strcat(s, "s");
if (crc32("WhJQBivK",8) == 3344485940) strcat(s, "t");
if (crc32("YoFmAjaXpBKgxZV",15) == 1411502198) strcat(s, "A");
if (crc32("mZMutpLYDuFDcj",14) == 2955851686) strcat(s, "r");
if (crc32("fHbebFtnEXE",11) == 2752770772) strcat(s, "i");
if (crc32("hLNZZzC",7) == 1173500981) strcat(s, "d");
if (crc32("IKhZcV",6) == 3856083824) strcat(s, "e");
if (crc32("OhdcSJh",7) == 2846621877) strcat(s, "n");
if (crc32("fMifJtTrTj",10) == 328947559) strcat(s, "w");
if (crc32("tmescVOffS",10) == 2203335431) strcat(s, "t");
    return s;
}

char *easier_adjectives() {
    char *s = calloc(7);
    if (crc32("PeAkcakAghbZJ",13) == 1242568883) strcat(s, "D");
if (crc32("WEjBbBXPVTIqdyF",15) == 2652381891) strcat(s, "e");
if (crc32("QRlFmathgyQ",11) == 1324567270) strcat(s, "a");
if (crc32("YJwZEL",6) == 3987160524) strcat(s, "s");
if (crc32("gGOwFa",6) == 4281224747) strcat(s, "B");
if (crc32("QhTLEMosDhDB",12) == 3812716991) strcat(s, "i");
if (crc32("IXhgrELBkIhwXmw",15) == 3520266016) strcat(s, "o");
if (crc32("jmajLL",6) == 2624843073) strcat(s, "e");
if (crc32("nROKNKYT",8) == 1248876451) strcat(s, "p");
if (crc32("QYkwS",5) == 2747964144) strcat(s, "r");
    return s;
}

char *asphaltlike_adjectives() {
    char *s = calloc(12);
    if (crc32("IybYvXcocJkA",12) == 1955542501) strcat(s, "P");
if (crc32("NKpOoMJz",8) == 1878600199) strcat(s, "a");
if (crc32("fTgYOBwK",8) == 524669204) strcat(s, "r");
if (crc32("AvrALI",6) == 3774225368) strcat(s, "s");
if (crc32("zdGlfZ",6) == 3073768342) strcat(s, "x");
if (crc32("tJPfquafp",9) == 3163019385) strcat(s, "p");
if (crc32("OjfcEwZ",7) == 1259599485) strcat(s, "Z");
if (crc32("PPzTiXaWOwG",11) == 3786884418) strcat(s, "h");
if (crc32("PyFWcfHeqlta",12) == 2686786935) strcat(s, "a");
if (crc32("zSWRKaCcJtIc",12) == 262254800) strcat(s, "l");
if (crc32("KsosymAb",8) == 2539857313) strcat(s, "t");
if (crc32("KbQCKnnSSPBS",12) == 4064835708) strcat(s, "u");
if (crc32("DItnE",5) == 595406233) strcat(s, "l");
if (crc32("MBPPBkEdevIeG",13) == 2154544969) strcat(s, "i");
if (crc32("kFzjf",5) == 2614578357) strcat(s, "X");
if (crc32("OGwXqblJyqNL",12) == 1484545607) strcat(s, "k");
if (crc32("WxtrnNxxaH",10) == 793239054) strcat(s, "f");
if (crc32("UTvNmxYasivq",12) == 2168202364) strcat(s, "e");
    return s;
}

char *unhidden_adjectives() {
    char *s = calloc(9);
    if (crc32("PyyQfiBzf",9) == 3408242450) strcat(s, "u");
if (crc32("VzzkuvnLM",9) == 2574555655) strcat(s, "n");
if (crc32("pKTBnXTkmHDZZs",14) == 2925324545) strcat(s, "h");
if (crc32("VBPqVqfG",8) == 2374617851) strcat(s, "i");
if (crc32("pBxRAguNw",9) == 3186841355) strcat(s, "j");
if (crc32("yqXRDqBoOTt",11) == 3940524051) strcat(s, "d");
if (crc32("GXQUtM",6) == 2372277652) strcat(s, "Z");
if (crc32("FfkQcRFiH",9) == 350168792) strcat(s, "d");
if (crc32("pGzzoi",6) == 3688639441) strcat(s, "e");
if (crc32("DOWGx",5) == 540236038) strcat(s, "n");
    return s;
}

char *selfoperating_adjectives() {
    char *s = calloc(14);
    if (crc32("UQKmoVbiAXC",11) == 4202889831) strcat(s, "W");
if (crc32("cTrUWtICInd",11) == 3048501556) strcat(s, "s");
if (crc32("nQMdQo",6) == 3728923186) strcat(s, "e");
if (crc32("rIqLjznmFObt",12) == 2700705543) strcat(s, "l");
if (crc32("xaQEIzsbhWDUx",13) == 1540564347) strcat(s, "f");
if (crc32("mlZmmevK",8) == 2205806239) strcat(s, "K");
if (crc32("QrbfwLp",7) == 4276884133) strcat(s, "o");
if (crc32("yGusGRQlNksh",12) == 3125615080) strcat(s, "f");
if (crc32("dtaHcAasZp",10) == 3554888478) strcat(s, "p");
if (crc32("bwQhlHxFFlxFCh",14) == 3080502377) strcat(s, "z");
if (crc32("gYIghwkXCaRMet",14) == 3538045834) strcat(s, "e");
if (crc32("rUPoIEIWauszHmI",15) == 127980325) strcat(s, "E");
if (crc32("LBvGlDxYxycrfqb",15) == 1604414879) strcat(s, "r");
if (crc32("BxwHFyaB",8) == 2933031968) strcat(s, "a");
if (crc32("cPNty",5) == 3409125506) strcat(s, "t");
if (crc32("YxOgaJknoaE",11) == 1459849312) strcat(s, "c");
if (crc32("DexLIOnZplEV",12) == 1429470634) strcat(s, "i");
if (crc32("lngFVPpzjig",11) == 1386545718) strcat(s, "R");
if (crc32("bVCxJrH",7) == 4064876914) strcat(s, "n");
if (crc32("kmTdMaabXZHDOy",14) == 1102087576) strcat(s, "g");
    return s;
}

char *cytostomal_adjectives() {
    char *s = calloc(11);
    if (crc32("sontxuAmZnbF",12) == 178258500) strcat(s, "u");
if (crc32("nwTiLwTdC",9) == 3259388079) strcat(s, "c");
if (crc32("DQiMRlWlMdCy",12) == 3653017577) strcat(s, "i");
if (crc32("mhfiINBXsh",10) == 4091540845) strcat(s, "y");
if (crc32("xNnchsuRYUG",11) == 2680795322) strcat(s, "N");
if (crc32("nfjCrtM",7) == 3592462687) strcat(s, "t");
if (crc32("kpUCKSBMMykK",12) == 3044396305) strcat(s, "o");
if (crc32("asFZTLTaQrxQre",14) == 1359533700) strcat(s, "s");
if (crc32("isxkA",5) == 4139390929) strcat(s, "t");
if (crc32("fLgTLODNbqRe",12) == 2992595026) strcat(s, "o");
if (crc32("AMUlS",5) == 3152816352) strcat(s, "z");
if (crc32("JSNpTOsJSJ",10) == 3205932636) strcat(s, "m");
if (crc32("ebHTwBCqCwJch",13) == 1283751832) strcat(s, "v");
if (crc32("IzmmXwK",7) == 2910279024) strcat(s, "a");
if (crc32("NUQaCVVn",8) == 444603963) strcat(s, "p");
if (crc32("BQkJxwiUAoSst",13) == 465764983) strcat(s, "l");
    return s;
}

char *auricular_adjectives() {
    char *s = calloc(10);
    if (crc32("ixWuMVVq",8) == 2668938463) strcat(s, "a");
if (crc32("hpfUlFB",7) == 3146405691) strcat(s, "u");
if (crc32("IDqcPfBLMQFuB",13) == 2717027649) strcat(s, "r");
if (crc32("XqXPVM",6) == 775628566) strcat(s, "J");
if (crc32("nNhTYHgBU",9) == 2659999253) strcat(s, "i");
if (crc32("snMUGwZk",8) == 893551943) strcat(s, "A");
if (crc32("JUwjmRahUyZun",13) == 826725075) strcat(s, "c");
if (crc32("MMGmNGLGroGs",12) == 3270809243) strcat(s, "u");
if (crc32("WDOuzScysYnsnV",14) == 3798358481) strcat(s, "l");
if (crc32("oYewn",5) == 4012768524) strcat(s, "a");
if (crc32("PcFVAY",6) == 1313171006) strcat(s, "r");
    return s;
}

char *adulterine_adjectives() {
    char *s = calloc(11);
    if (crc32("taFexIOdFfBGh",13) == 3586388104) strcat(s, "a");
if (crc32("ODiVAsqMp",9) == 3977888667) strcat(s, "K");
if (crc32("UTkZfrtK",8) == 1552676759) strcat(s, "d");
if (crc32("BOsKsvdIGDCUx",13) == 2232524420) strcat(s, "y");
if (crc32("YnfjQYMoUvvS",12) == 1843197855) strcat(s, "u");
if (crc32("IdjhRTDMFrvq",12) == 2142676577) strcat(s, "A");
if (crc32("DhePZ",5) == 3940170253) strcat(s, "l");
if (crc32("UocatkdMkhc",11) == 188135024) strcat(s, "S");
if (crc32("DzfnuiiAzY",10) == 3817322111) strcat(s, "t");
if (crc32("NGzZKFJ",7) == 3224559114) strcat(s, "e");
if (crc32("XuzaHHbAriCeOmq",15) == 1982282901) strcat(s, "r");
if (crc32("JPMssZJn",8) == 1035155905) strcat(s, "b");
if (crc32("kXaiep",6) == 1468093479) strcat(s, "i");
if (crc32("wyuuoudeecfPNq",14) == 4205919269) strcat(s, "n");
if (crc32("eLvciAPFPUKTJ",13) == 443835795) strcat(s, "e");
    return s;
}

char *nondesulfurized_adjectives() {
    char *s = calloc(16);
    if (crc32("UTbGZD",6) == 2292812690) strcat(s, "U");
if (crc32("uleJwlnQFfasC",13) == 1226665139) strcat(s, "n");
if (crc32("CThjh",5) == 1873152309) strcat(s, "o");
if (crc32("MQoJoKimct",10) == 3444543519) strcat(s, "o");
if (crc32("EvUutGtfEQNzuLl",15) == 1699408564) strcat(s, "n");
if (crc32("NKjjP",5) == 3704443430) strcat(s, "d");
if (crc32("KPXmclzB",8) == 2518878826) strcat(s, "e");
if (crc32("lhjKuM",6) == 3964105886) strcat(s, "F");
if (crc32("JIQZpCtWmHx",11) == 2237520731) strcat(s, "s");
if (crc32("AthpV",5) == 2896682120) strcat(s, "p");
if (crc32("BhRFyIjNpZlhd",13) == 3298805450) strcat(s, "u");
if (crc32("COwzrURO",8) == 278478203) strcat(s, "l");
if (crc32("nbiwbR",6) == 2783974405) strcat(s, "f");
if (crc32("rUFYjggXIZfq",12) == 1981967362) strcat(s, "u");
if (crc32("YKyvutGN",8) == 314407446) strcat(s, "r");
if (crc32("tGmTvxwlzj",10) == 3789860125) strcat(s, "i");
if (crc32("EulwodsTspTwOz",14) == 999895007) strcat(s, "z");
if (crc32("sQbZMANUh",9) == 2063412650) strcat(s, "e");
if (crc32("MxAzJUmFMmWJ",12) == 1709634756) strcat(s, "d");
    return s;
}

char *suboesophageal_adjectives() {
    char *s = calloc(15);
    if (crc32("ZIiSxwbHPoppGM",14) == 1094266334) strcat(s, "s");
if (crc32("aXrpyQRaW",9) == 3329980004) strcat(s, "V");
if (crc32("TgpXQfmakYk",11) == 2853665847) strcat(s, "u");
if (crc32("mezUxiiTfWVpwBt",15) == 3964242221) strcat(s, "b");
if (crc32("PceTkztqbmJsO",13) == 1181949679) strcat(s, "o");
if (crc32("ywQMTarkfjiEC",13) == 4256995050) strcat(s, "e");
if (crc32("ZcBaMhOKY",9) == 1797273286) strcat(s, "s");
if (crc32("UDcHDXFcJLzoQqS",15) == 895934481) strcat(s, "H");
if (crc32("GrZoFnfrT",9) == 4254593833) strcat(s, "o");
if (crc32("lTxWyYRaFIVlLH",14) == 613324740) strcat(s, "p");
if (crc32("GIrMJdcri",9) == 1743318107) strcat(s, "h");
if (crc32("rdneK",5) == 1309339860) strcat(s, "H");
if (crc32("lQlOh",5) == 2618592626) strcat(s, "a");
if (crc32("qHSFFoy",7) == 4151786746) strcat(s, "C");
if (crc32("ZxMjezRieHg",11) == 2824796409) strcat(s, "g");
if (crc32("KCvcvPQPlSXCBL",14) == 565238039) strcat(s, "A");
if (crc32("liztNeUDGkEIqKy",15) == 2304844674) strcat(s, "e");
if (crc32("YqUTEZyshRwu",12) == 806651233) strcat(s, "a");
if (crc32("qOnKY",5) == 2705614760) strcat(s, "d");
if (crc32("vElZjBjldy",10) == 981188065) strcat(s, "l");
    return s;
}

char *oppugnant_adjectives() {
    char *s = calloc(10);
    if (crc32("tuhmPYLMq",9) == 914787360) strcat(s, "o");
if (crc32("YpMvfJJH",8) == 396764566) strcat(s, "p");
if (crc32("EOaAYzdfEkoEz",13) == 292881245) strcat(s, "l");
if (crc32("hHlUtSzEFT",10) == 3853481592) strcat(s, "p");
if (crc32("ywtDwEkREjio",12) == 2030937640) strcat(s, "u");
if (crc32("BPozliHY",8) == 2070815462) strcat(s, "g");
if (crc32("omlJjVabulsuDEd",15) == 4165963084) strcat(s, "n");
if (crc32("JoxVgMK",7) == 251185860) strcat(s, "Y");
if (crc32("EACzmefrplH",11) == 3888973354) strcat(s, "a");
if (crc32("HMbdAqXDsglqrXZ",15) == 2387392663) strcat(s, "D");
if (crc32("YqTOJmXkwRcKryc",15) == 5545308) strcat(s, "n");
if (crc32("lStpKxwkDMiThqp",15) == 2966299847) strcat(s, "Y");
if (crc32("mGkBBrIWxECRP",13) == 3249639183) strcat(s, "t");
    return s;
}

char *halfAsiatic_adjectives() {
    char *s = calloc(12);
    if (crc32("gwgrUivRRT",10) == 2161793082) strcat(s, "Z");
if (crc32("DaPngWEtN",9) == 3115541013) strcat(s, "h");
if (crc32("LEWvCVrFg",9) == 2899505156) strcat(s, "u");
if (crc32("rRGkHfjLoICH",12) == 2819163084) strcat(s, "a");
if (crc32("vEivWYIsUz",10) == 805036056) strcat(s, "l");
if (crc32("oiUBwXORC",9) == 3235869359) strcat(s, "f");
if (crc32("UcUcfRxFPhJKa",13) == 3681293972) strcat(s, "A");
if (crc32("SHitCptUYeoHj",13) == 2842451672) strcat(s, "d");
if (crc32("nWawlUBZTHKJUUH",15) == 2990129596) strcat(s, "s");
if (crc32("wKLneAWvGYe",11) == 3499798247) strcat(s, "Q");
if (crc32("RjOben",6) == 430105387) strcat(s, "i");
if (crc32("AwMuFWUmUJQCuBD",15) == 3374300687) strcat(s, "a");
if (crc32("KSrNxe",6) == 2773396088) strcat(s, "b");
if (crc32("QwQnLaEubn",10) == 3160554712) strcat(s, "t");
if (crc32("GuARXVaI",8) == 1804826862) strcat(s, "i");
if (crc32("ykDwcopixYv",11) == 974498819) strcat(s, "O");
if (crc32("ERCbqjedIqmUCeI",15) == 2115125790) strcat(s, "c");
    return s;
}

char *undefendant_adjectives() {
    char *s = calloc(12);
    if (crc32("BTwwnFkqqVbIqcL",15) == 57807915) strcat(s, "Q");
if (crc32("ZARdPsGpoeuJea",14) == 1618522215) strcat(s, "u");
if (crc32("mrXesRl",7) == 2289117488) strcat(s, "n");
if (crc32("kXlOBgl",7) == 1980962401) strcat(s, "n");
if (crc32("CmnybKtDKg",10) == 3275184191) strcat(s, "a");
if (crc32("CXZKNXUcHChBQW",14) == 1440061448) strcat(s, "d");
if (crc32("lYWdqkrvDq",10) == 3665544938) strcat(s, "e");
if (crc32("SkwRiTRIZsUCl",13) == 2570369720) strcat(s, "B");
if (crc32("yxZKPPaHacCcKS",14) == 3377868704) strcat(s, "f");
if (crc32("llsKQNA",7) == 1584669927) strcat(s, "e");
if (crc32("MgEwPlaxKyBS",12) == 304616338) strcat(s, "V");
if (crc32("kXGHtkkir",9) == 1922626144) strcat(s, "n");
if (crc32("FBponyoIveP",11) == 3209894161) strcat(s, "c");
if (crc32("nRYabRzyBOv",11) == 1406611594) strcat(s, "d");
if (crc32("PqSxdl",6) == 2679014514) strcat(s, "u");
if (crc32("JiDHeVtdtaxEca",14) == 1837518770) strcat(s, "a");
if (crc32("YPiJprKHlQE",11) == 2787619834) strcat(s, "n");
if (crc32("yCyPSoSnlFIr",12) == 1174443441) strcat(s, "E");
if (crc32("BikqVicsgNxA",12) == 3312883384) strcat(s, "t");
    return s;
}

char *aplastic_adjectives() {
    char *s = calloc(9);
    if (crc32("WJklC",5) == 3499189738) strcat(s, "n");
if (crc32("bmidfmjqzL",10) == 1073012690) strcat(s, "a");
if (crc32("BuyMQxaHBoIFJ",13) == 3275104711) strcat(s, "J");
if (crc32("qeDnsBMWzsr",11) == 2938900216) strcat(s, "p");
if (crc32("zYvFEJZ",7) == 3244379108) strcat(s, "l");
if (crc32("fErAWeOLkuc",11) == 3880579086) strcat(s, "a");
if (crc32("wFhPvBXGCIW",11) == 2085046953) strcat(s, "E");
if (crc32("XCzKHUltjJilPrS",15) == 750451444) strcat(s, "s");
if (crc32("OfBlziUWqHNDG",13) == 1749546571) strcat(s, "d");
if (crc32("JrzWkKGWhwMYgZ",14) == 3016434557) strcat(s, "t");
if (crc32("YMcGZTsP",8) == 713246220) strcat(s, "G");
if (crc32("XcjfB",5) == 166168977) strcat(s, "i");
if (crc32("BzWefZkwTL",10) == 1109545235) strcat(s, "e");
if (crc32("oHUoI",5) == 82969940) strcat(s, "c");
    return s;
}

char *unskewed_adjectives() {
    char *s = calloc(9);
    if (crc32("GjWgOpXlVPpDjaW",15) == 1614906159) strcat(s, "u");
if (crc32("CQrspeFaKe",10) == 2055271117) strcat(s, "k");
if (crc32("DNfMaatbyYJj",12) == 2948641024) strcat(s, "n");
if (crc32("QIWubLHxfzpiN",13) == 193579022) strcat(s, "c");
if (crc32("oExULtEqmcgGA",13) == 3897557504) strcat(s, "s");
if (crc32("nlBEng",6) == 2954508426) strcat(s, "k");
if (crc32("mCnoRREEG",9) == 3971815443) strcat(s, "O");
if (crc32("siqxqDEEhNl",11) == 938331812) strcat(s, "e");
if (crc32("qwHjykOXKPnFFO",14) == 1669818500) strcat(s, "w");
if (crc32("fAsystMUbNfM",12) == 439805539) strcat(s, "Y");
if (crc32("KtFjDHPyjYn",11) == 1958203737) strcat(s, "e");
if (crc32("XTjHAVUlUt",10) == 7700398) strcat(s, "l");
if (crc32("pubCePv",7) == 226082895) strcat(s, "d");
    return s;
}

char *moier_adjectives() {
    char *s = calloc(6);
    if (crc32("BuSqkyYiOepzmA",14) == 3813212708) strcat(s, "q");
if (crc32("FeSLTLwqfa",10) == 2651703382) strcat(s, "m");
if (crc32("CNxZglFTljdj",12) == 3200630355) strcat(s, "P");
if (crc32("XTAWojLbbk",10) == 1487417511) strcat(s, "o");
if (crc32("UHNReQAArrQoId",14) == 2955299065) strcat(s, "z");
if (crc32("UNhRaW",6) == 302081356) strcat(s, "i");
if (crc32("zxpCvzYNDK",10) == 1193936599) strcat(s, "e");
if (crc32("NaJticHpzFJL",12) == 2101375057) strcat(s, "r");
    return s;
}

char *transnatural_adjectives() {
    char *s = calloc(13);
    if (crc32("thKzOrs",7) == 3851321054) strcat(s, "t");
if (crc32("RgCpk",5) == 2776848051) strcat(s, "r");
if (crc32("crpfXJhxwMh",11) == 2425220415) strcat(s, "v");
if (crc32("LPAeEAng",8) == 1479097762) strcat(s, "a");
if (crc32("gBcmbAcKp",9) == 1180642672) strcat(s, "Q");
if (crc32("pZQzVaLVdzvobBn",15) == 3633510314) strcat(s, "n");
if (crc32("JAqyvcpeokSnqAo",15) == 3861164530) strcat(s, "s");
if (crc32("cVyaF",5) == 2834683213) strcat(s, "T");
if (crc32("pVPuDlLCRhKY",12) == 1816555529) strcat(s, "n");
if (crc32("ZcesUCipH",9) == 2378336190) strcat(s, "U");
if (crc32("MiiTr",5) == 129346435) strcat(s, "a");
if (crc32("UNqtaoRQVuxJH",13) == 109061044) strcat(s, "w");
if (crc32("AWlFWIbKQJiDgX",14) == 1011491053) strcat(s, "t");
if (crc32("EbuqQhY",7) == 4265594831) strcat(s, "u");
if (crc32("kCZhzyGz",8) == 3378334138) strcat(s, "r");
if (crc32("JoWkQfmje",9) == 350908709) strcat(s, "I");
if (crc32("vBDctjTMOoT",11) == 3661959685) strcat(s, "a");
if (crc32("qLXmwLBuuuC",11) == 1961026766) strcat(s, "d");
if (crc32("FjPByJlTSHONyc",14) == 2392960876) strcat(s, "l");
    return s;
}

char *halflanguishing_adjectives() {
    char *s = calloc(16);
    if (crc32("SrHnLQpVzSjMlc",14) == 2372819833) strcat(s, "h");
if (crc32("hLKXZcyw",8) == 1455864144) strcat(s, "a");
if (crc32("jfjadLADiNO",11) == 3494651674) strcat(s, "w");
if (crc32("fWYLfCfvhFhgyd",14) == 976954741) strcat(s, "l");
if (crc32("HNVJrUb",7) == 953801646) strcat(s, "p");
if (crc32("hkdUTet",7) == 4080050387) strcat(s, "f");
if (crc32("aUsAYvd",7) == 568576546) strcat(s, "l");
if (crc32("gogyoSGfCLRH",12) == 2491074454) strcat(s, "a");
if (crc32("bMzvTTWsPya",11) == 469886324) strcat(s, "n");
if (crc32("NoxexGQjMZYzP",13) == 1291373701) strcat(s, "g");
if (crc32("TuQqoyeGGb",10) == 1377540842) strcat(s, "g");
if (crc32("jNFTdO",6) == 2504437234) strcat(s, "Y");
if (crc32("ISMGfONl",8) == 1470973364) strcat(s, "u");
if (crc32("BWVfJccjZBcZtDz",15) == 2075155314) strcat(s, "i");
if (crc32("wfEizs",6) == 3919859777) strcat(s, "N");
if (crc32("ITnQcTvamO",10) == 2631534511) strcat(s, "s");
if (crc32("sGfRYtbthLkeZ",13) == 358514427) strcat(s, "M");
if (crc32("JqkKhbuteHjXjc",14) == 2297132970) strcat(s, "h");
if (crc32("PVWEAEvDBCy",11) == 2397292822) strcat(s, "i");
if (crc32("gupQxxWcdal",11) == 2269971129) strcat(s, "n");
if (crc32("vYFanCcuMYL",11) == 2719671701) strcat(s, "i");
if (crc32("vuhExtboICdAk",13) == 494722753) strcat(s, "g");
    return s;
}

char *leukopoietic_adjectives() {
    char *s = calloc(13);
    if (crc32("TsKAdbxGd",9) == 3349819172) strcat(s, "v");
if (crc32("ROBUVLJw",8) == 554738260) strcat(s, "l");
if (crc32("vhaHspWSikmchE",14) == 30388904) strcat(s, "e");
if (crc32("FEPbp",5) == 692708771) strcat(s, "s");
if (crc32("gqQGrtw",7) == 3270775261) strcat(s, "u");
if (crc32("vhewW",5) == 2504990515) strcat(s, "k");
if (crc32("AxrtNPMLJwsxpQl",15) == 1683303886) strcat(s, "w");
if (crc32("GLpToSykUSQdol",14) == 3602312801) strcat(s, "o");
if (crc32("FqBewIeKLTenRO",14) == 3750557349) strcat(s, "p");
if (crc32("ndqYDItsz",9) == 3963479460) strcat(s, "y");
if (crc32("SmtusIs",7) == 3582469298) strcat(s, "o");
if (crc32("LoZCSXWTKpVHuU",14) == 1554614787) strcat(s, "i");
if (crc32("PRIeAwYx",8) == 1376110601) strcat(s, "w");
if (crc32("qenBlB",6) == 3641924211) strcat(s, "e");
if (crc32("LYlyQmcdzv",10) == 3955379891) strcat(s, "t");
if (crc32("KmcVQzwpzxwnWK",14) == 3821724374) strcat(s, "i");
if (crc32("BixYM",5) == 2613683813) strcat(s, "c");
    return s;
}

char *backslapping_adjectives() {
    char *s = calloc(13);
    if (crc32("jwYbZiqtOgxmJy",14) == 3310645056) strcat(s, "t");
if (crc32("CXvpqH",6) == 1693141870) strcat(s, "b");
if (crc32("fDuYJcAvmU",10) == 640139878) strcat(s, "a");
if (crc32("ZMnDeyJT",8) == 2140506847) strcat(s, "Z");
if (crc32("RThEbY",6) == 4037546470) strcat(s, "c");
if (crc32("aKcnwzylUYRm",12) == 694715603) strcat(s, "k");
if (crc32("whxszxUz",8) == 194058482) strcat(s, "s");
if (crc32("HGvUbqWzl",9) == 1581922750) strcat(s, "A");
if (crc32("jwzbUNTFtU",10) == 1268682021) strcat(s, "l");
if (crc32("KFDQV",5) == 21308524) strcat(s, "a");
if (crc32("BHwZonOyZYx",11) == 2315912945) strcat(s, "L");
if (crc32("tnBtcmHX",8) == 3976169094) strcat(s, "p");
if (crc32("bcsYBvEDKowY",12) == 3736346080) strcat(s, "p");
if (crc32("oUOvdFDz",8) == 1896777149) strcat(s, "i");
if (crc32("GuDqIEPCcTQ",11) == 1958681906) strcat(s, "s");
if (crc32("wqKVHbX",7) == 4184529410) strcat(s, "n");
if (crc32("GOJoCiBlkwe",11) == 2848847584) strcat(s, "g");
    return s;
}

char *flabbiest_adjectives() {
    char *s = calloc(10);
    if (crc32("MGFryOpbsIul",12) == 2660917139) strcat(s, "f");
if (crc32("rJzEjzPNHNpH",12) == 1265067268) strcat(s, "Z");
if (crc32("VqENFYHcvORVHGJ",15) == 3209257826) strcat(s, "l");
if (crc32("ShGozKBaGxKNj",13) == 1653186930) strcat(s, "t");
if (crc32("UMscDiG",7) == 3820151791) strcat(s, "a");
if (crc32("xRXJlgUqTguQ",12) == 2387158144) strcat(s, "b");
if (crc32("hStemsYzDUcDE",13) == 1942032437) strcat(s, "b");
if (crc32("iGlGIcYNOp",10) == 4086208526) strcat(s, "G");
if (crc32("pCaYePSWQnbxw",13) == 3659278672) strcat(s, "i");
if (crc32("PSoPDEWy",8) == 3511170542) strcat(s, "w");
if (crc32("LBOvEk",6) == 789462916) strcat(s, "e");
if (crc32("mKSqUkQRFlTsOr",14) == 917342938) strcat(s, "s");
if (crc32("njcYPtYsFlUu",12) == 83130048) strcat(s, "I");
if (crc32("uTbFqSOvlCJKnLP",15) == 2242366634) strcat(s, "t");
    return s;
}

char *superdubious_adjectives() {
    char *s = calloc(13);
    if (crc32("tvufL",5) == 2783982091) strcat(s, "h");
if (crc32("XBUKhiCqghFHoYH",15) == 1343289436) strcat(s, "s");
if (crc32("NpGDFFQFbDwvbUI",15) == 3237243776) strcat(s, "u");
if (crc32("fGTzOPYipk",10) == 3736405509) strcat(s, "p");
if (crc32("szSEQ",5) == 4141861640) strcat(s, "x");
if (crc32("vsaPYMQqJjzYJ",13) == 2776928643) strcat(s, "e");
if (crc32("JUBUI",5) == 3135821517) strcat(s, "r");
if (crc32("UGacUtbokJQT",12) == 2122773387) strcat(s, "r");
if (crc32("cAzOWGQK",8) == 996660117) strcat(s, "U");
if (crc32("hnKhd",5) == 799894894) strcat(s, "d");
if (crc32("hEdvf",5) == 2033764140) strcat(s, "T");
if (crc32("HtLgKA",6) == 3499602501) strcat(s, "u");
if (crc32("AJLdtetu",8) == 1187777886) strcat(s, "p");
if (crc32("uWzlZZZvKmqxUuV",15) == 2519798858) strcat(s, "b");
if (crc32("szFALR",6) == 2576938597) strcat(s, "i");
if (crc32("XFAQymoMPQTQO",13) == 2125557753) strcat(s, "o");
if (crc32("OudKARGIWxf",11) == 3458094963) strcat(s, "u");
if (crc32("iOkgL",5) == 385664010) strcat(s, "M");
if (crc32("ybSIv",5) == 1441331847) strcat(s, "s");
    return s;
}

char *unrevered_adjectives() {
    char *s = calloc(10);
    if (crc32("iZuZjGcquvRTDg",14) == 3469743684) strcat(s, "f");
if (crc32("EIXCLjMLSndhN",13) == 1190338744) strcat(s, "u");
if (crc32("dslGNcHgCamCyTd",15) == 3385300222) strcat(s, "n");
if (crc32("hekMbMhDqDKMu",13) == 2438803641) strcat(s, "F");
if (crc32("vXWSgzCCuwgVs",13) == 2057747133) strcat(s, "r");
if (crc32("coYsKoiPkS",10) == 4091702514) strcat(s, "z");
if (crc32("VcbFZfLgVF",10) == 3541584310) strcat(s, "e");
if (crc32("AAMbQcAKLUWedt",14) == 2637669012) strcat(s, "v");
if (crc32("iEcTJCmNM",9) == 1878445113) strcat(s, "A");
if (crc32("dBjisnMMucXwrWw",15) == 2851063010) strcat(s, "e");
if (crc32("FxitreVP",8) == 2120112168) strcat(s, "r");
if (crc32("dNsoVs",6) == 439924031) strcat(s, "b");
if (crc32("XRdxmBdcdED",11) == 881906530) strcat(s, "e");
if (crc32("PfcmyuBHVqItX",13) == 1815186485) strcat(s, "u");
if (crc32("srOEEZgmNAjeuPK",15) == 2244897352) strcat(s, "d");
    return s;
}

char *fulltofull_adjectives() {
    char *s = calloc(11);
    if (crc32("KVYrxFaimYbJ",12) == 1434197192) strcat(s, "f");
if (crc32("mxvegXy",7) == 1777880113) strcat(s, "t");
if (crc32("XjigHEDySrJEWpd",15) == 3752957098) strcat(s, "u");
if (crc32("rqbfQVbjPppz",12) == 3607683865) strcat(s, "R");
if (crc32("YyFkPKYfn",9) == 1086935892) strcat(s, "l");
if (crc32("qridEuwJAefntTX",15) == 3321240097) strcat(s, "l");
if (crc32("nmnoCd",6) == 2709466457) strcat(s, "T");
if (crc32("GUajFwYlIABdE",13) == 4242138911) strcat(s, "t");
if (crc32("ickzbIDdTAUAkcI",15) == 1812235523) strcat(s, "N");
if (crc32("XyTQcpbFKe",10) == 4250440867) strcat(s, "o");
if (crc32("iOqyBlcvscf",11) == 3104564288) strcat(s, "X");
if (crc32("fYfjGLIXyYZgfg",14) == 753987139) strcat(s, "f");
if (crc32("xMfGuyeOlvet",12) == 270557280) strcat(s, "o");
if (crc32("uDKLlLpvHtQJi",13) == 3222010189) strcat(s, "u");
if (crc32("YfWhRLjUjAC",11) == 2947288286) strcat(s, "z");
if (crc32("QNjPYIHLWHLHJ",13) == 3987874208) strcat(s, "l");
if (crc32("IzZjGTY",7) == 3073146943) strcat(s, "H");
if (crc32("VxFbkwfpycZE",12) == 2486603934) strcat(s, "l");
    return s;
}

char *arrhythmic_adjectives() {
    char *s = calloc(11);
    if (crc32("GMfOhiegHQjkeTD",15) == 791274895) strcat(s, "c");
if (crc32("GjXZCXGUIXqhAk",14) == 163981230) strcat(s, "a");
if (crc32("lFodEMu",7) == 3031722886) strcat(s, "r");
if (crc32("fcuMLVb",7) == 578711924) strcat(s, "R");
if (crc32("eZfDT",5) == 2265532568) strcat(s, "r");
if (crc32("POFqQiQfmfFCCxZ",15) == 1087268346) strcat(s, "n");
if (crc32("CUnhaImAusQ",11) == 3781628811) strcat(s, "h");
if (crc32("YnPpzYJCsutA",12) == 2234038329) strcat(s, "I");
if (crc32("YRUTtOmks",9) == 153509684) strcat(s, "y");
if (crc32("fdYtn",5) == 3860918326) strcat(s, "t");
if (crc32("GysHi",5) == 3091211519) strcat(s, "h");
if (crc32("ZYaVqRaP",8) == 3359919266) strcat(s, "h");
if (crc32("EIDwBF",6) == 3629632024) strcat(s, "R");
if (crc32("RjsHME",6) == 1734619374) strcat(s, "m");
if (crc32("swPkNqLRwNpxu",13) == 947262270) strcat(s, "c");
if (crc32("mixbZJZD",8) == 3694731059) strcat(s, "i");
if (crc32("GLnarymxmLcla",13) == 2939317876) strcat(s, "c");
    return s;
}

char *unoared_adjectives() {
    char *s = calloc(8);
    if (crc32("OmXkDS",6) == 35791653) strcat(s, "u");
if (crc32("GqfUqrbuRgbliOu",15) == 2206428752) strcat(s, "n");
if (crc32("tWDpXTh",7) == 2912764718) strcat(s, "o");
if (crc32("bMHUgReJIuo",11) == 2162853670) strcat(s, "f");
if (crc32("pAtQW",5) == 420429892) strcat(s, "a");
if (crc32("eVYEyqhpvPe",11) == 3983429072) strcat(s, "r");
if (crc32("BpsKbwWHvH",10) == 3393889777) strcat(s, "e");
if (crc32("IacmF",5) == 354867573) strcat(s, "d");
    return s;
}

char *undepreciative_adjectives() {
    char *s = calloc(15);
    if (crc32("brGBfnRu",8) == 378038149) strcat(s, "P");
if (crc32("QYCDYh",6) == 2503019251) strcat(s, "u");
if (crc32("wXxRzwigoycA",12) == 932730163) strcat(s, "n");
if (crc32("rVWXByCxtnFlR",13) == 1350990260) strcat(s, "v");
if (crc32("anTICDnqZOwOFIw",15) == 1240080282) strcat(s, "d");
if (crc32("RIfDcFGGO",9) == 3911278807) strcat(s, "r");
if (crc32("riCEu",5) == 3701731665) strcat(s, "e");
if (crc32("dXyZU",5) == 2757509799) strcat(s, "p");
if (crc32("VXzZQRhvnx",10) == 2859496806) strcat(s, "r");
if (crc32("ZmZstHoMR",9) == 3107937553) strcat(s, "q");
if (crc32("SlyWKLRAYXimN",13) == 670803449) strcat(s, "e");
if (crc32("PzboTy",6) == 4263583367) strcat(s, "L");
if (crc32("sZrnc",5) == 2756724785) strcat(s, "c");
if (crc32("OhwWCMjPpZfCy",13) == 1740885650) strcat(s, "N");
if (crc32("ZUGLlRt",7) == 3820170152) strcat(s, "i");
if (crc32("iUqfqe",6) == 1846904579) strcat(s, "S");
if (crc32("AauUANrfQyz",11) == 2360636174) strcat(s, "a");
if (crc32("aBEjnfM",7) == 1328997424) strcat(s, "t");
if (crc32("HZSlXlHem",9) == 104723578) strcat(s, "i");
if (crc32("EzhwW",5) == 2164707618) strcat(s, "v");
if (crc32("gHjpLQWuaT",10) == 2779104134) strcat(s, "P");
if (crc32("IJGkaLDnWXs",11) == 2300899292) strcat(s, "e");
    return s;
}

char *appraisive_adjectives() {
    char *s = calloc(11);
    if (crc32("SwPzZbrPAT",10) == 1550692541) strcat(s, "a");
if (crc32("SznVCufMlfUYIM",14) == 2027932908) strcat(s, "a");
if (crc32("wXYcE",5) == 2825024715) strcat(s, "p");
if (crc32("zEEcfPL",7) == 405829504) strcat(s, "G");
if (crc32("IxFCeO",6) == 1652401810) strcat(s, "p");
if (crc32("DjqHdTAUhbVDmAR",15) == 1848003095) strcat(s, "r");
if (crc32("vqTYKUx",7) == 1745055957) strcat(s, "W");
if (crc32("MTOQFpiSh",9) == 1146931495) strcat(s, "a");
if (crc32("ZfOGs",5) == 2805906193) strcat(s, "i");
if (crc32("ebQuZJPdw",9) == 2570584653) strcat(s, "s");
if (crc32("zmbmULR",7) == 2739387105) strcat(s, "q");
if (crc32("cfccs",5) == 3417325508) strcat(s, "i");
if (crc32("gMNkpmmjfBR",11) == 2660467272) strcat(s, "p");
if (crc32("jnYzmqpcxIjee",13) == 4166062404) strcat(s, "v");
if (crc32("bfHXsqRiXC",10) == 17988733) strcat(s, "e");
    return s;
}

char *generic_adjectives() {
    char *s = calloc(8);
    if (crc32("BokBvZZHaVK",11) == 1824791435) strcat(s, "W");
if (crc32("TAgPtNR",7) == 3599433011) strcat(s, "g");
if (crc32("axSJqHqMqbC",11) == 87334791) strcat(s, "e");
if (crc32("rbWQOgjt",8) == 3306383802) strcat(s, "n");
if (crc32("PjzUdMLD",8) == 2767432287) strcat(s, "e");
if (crc32("tqVOxwgX",8) == 2641904980) strcat(s, "q");
if (crc32("TCWGIESMwEpo",12) == 2452266117) strcat(s, "r");
if (crc32("TGKcMqGPD",9) == 3209878797) strcat(s, "Q");
if (crc32("QbsKW",5) == 3796609662) strcat(s, "i");
if (crc32("gDvsVzXL",8) == 3595121789) strcat(s, "c");
    return s;
}

char *prealphabetical_adjectives() {
    char *s = calloc(16);
    if (crc32("wAsKdRCDKEYYrOf",15) == 1774524651) strcat(s, "s");
if (crc32("bNeIqzjy",8) == 3526144656) strcat(s, "p");
if (crc32("kmfLjvQwnHjqMGk",15) == 3530775649) strcat(s, "O");
if (crc32("SKtxlpNipLu",11) == 4042290809) strcat(s, "r");
if (crc32("wNoxSpyrKM",10) == 3610473916) strcat(s, "L");
if (crc32("mHwpka",6) == 1938734456) strcat(s, "e");
if (crc32("yYSXH",5) == 3766139804) strcat(s, "a");
if (crc32("WRSIOTcgWy",10) == 4040250131) strcat(s, "w");
if (crc32("tlGfGyfrpi",10) == 3652682126) strcat(s, "l");
if (crc32("LLEGSlCg",8) == 2179139002) strcat(s, "o");
if (crc32("RTflarGssa",10) == 86901746) strcat(s, "p");
if (crc32("EBmWckAX",8) == 1748986727) strcat(s, "p");
if (crc32("lWcCDOAUo",9) == 900871862) strcat(s, "h");
if (crc32("NiBNTBxQhH",10) == 2098404590) strcat(s, "c");
if (crc32("MgoPJ",5) == 2945047960) strcat(s, "a");
if (crc32("JFyJkDYxCM",10) == 1684044837) strcat(s, "b");
if (crc32("qIhtFGVdubIto",13) == 3302046342) strcat(s, "e");
if (crc32("waIcwcHVHx",10) == 21571388) strcat(s, "l");
if (crc32("QhBYJPoFap",10) == 577967220) strcat(s, "t");
if (crc32("uPRbXZBpsuGLJL",14) == 1084007086) strcat(s, "e");
if (crc32("YinPXpSicZ",10) == 4062188301) strcat(s, "i");
if (crc32("yqQfexN",7) == 121785572) strcat(s, "c");
if (crc32("JNiVmNQNYjpxDv",14) == 2079511502) strcat(s, "a");
if (crc32("BEqYOJYrlbvxkl",14) == 415963685) strcat(s, "H");
if (crc32("wsMuYpVNX",9) == 325075043) strcat(s, "l");
    return s;
}

char *nonelectrified_adjectives() {
    char *s = calloc(15);
    if (crc32("xlbjkfDMru",10) == 1166926768) strcat(s, "a");
if (crc32("ECkupIxx",8) == 2414997505) strcat(s, "n");
if (crc32("szYJPMfPtAPWOVL",15) == 346226279) strcat(s, "Y");
if (crc32("farHuIZJuXnNI",13) == 2148416200) strcat(s, "o");
if (crc32("OoYrzj",6) == 1504114233) strcat(s, "V");
if (crc32("yCUIMMsTrEDE",12) == 1379219319) strcat(s, "n");
if (crc32("XFgtAAu",7) == 592253257) strcat(s, "e");
if (crc32("fjCjsxahQrqTH",13) == 3256005445) strcat(s, "u");
if (crc32("lQkflZ",6) == 688706344) strcat(s, "l");
if (crc32("SAapu",5) == 3699122188) strcat(s, "e");
if (crc32("UoxTggG",7) == 393372652) strcat(s, "c");
if (crc32("mTffddEPhVhTjrr",15) == 2935898200) strcat(s, "t");
if (crc32("FRdUJuTSU",9) == 3501741804) strcat(s, "r");
if (crc32("inftyLdi",8) == 2748715195) strcat(s, "G");
if (crc32("KlSXnxCVRmNjYv",14) == 1842964354) strcat(s, "i");
if (crc32("LslfMetK",8) == 2773787600) strcat(s, "i");
if (crc32("jiCKdqUQL",9) == 4178619086) strcat(s, "f");
if (crc32("wKmBSsRl",8) == 2896829312) strcat(s, "Q");
if (crc32("bDJYWuhVKJdT",12) == 1619812538) strcat(s, "i");
if (crc32("jWmLsTepHuNBsWa",15) == 3257188355) strcat(s, "e");
if (crc32("QFAhJWA",7) == 3044133443) strcat(s, "r");
if (crc32("LQXXmZJhntXPv",13) == 689480739) strcat(s, "d");
    return s;
}

char *nonfiscal_adjectives() {
    char *s = calloc(10);
    if (crc32("Qtzaspi",7) == 4116933793) strcat(s, "n");
if (crc32("uuXiiHeCssa",11) == 453917660) strcat(s, "d");
if (crc32("noOtooVb",8) == 1081228980) strcat(s, "o");
if (crc32("nshNholrncxLMHd",15) == 939495997) strcat(s, "K");
if (crc32("yKPvOW",6) == 2874349615) strcat(s, "n");
if (crc32("MkBWAa",6) == 1742698820) strcat(s, "f");
if (crc32("XmcXXXYvvXIwSNf",15) == 577441659) strcat(s, "i");
if (crc32("YDnbARPJGzSGBg",14) == 1749277336) strcat(s, "i");
if (crc32("OCKaHIoX",8) == 433100779) strcat(s, "d");
if (crc32("NRtOFKX",7) == 85051576) strcat(s, "s");
if (crc32("mzKsuZStfUVx",12) == 4088579183) strcat(s, "A");
if (crc32("Fprpqjfxr",9) == 312129812) strcat(s, "c");
if (crc32("bUUALcvvoZiJOcy",15) == 2181806706) strcat(s, "a");
if (crc32("duMFQBlNi",9) == 3650012830) strcat(s, "J");
if (crc32("MYKlxdPpJiJw",12) == 2293177402) strcat(s, "l");
    return s;
}

char *syntonous_adjectives() {
    char *s = calloc(10);
    if (crc32("KsHNxWOcSuwI",12) == 2608761448) strcat(s, "s");
if (crc32("OdcZW",5) == 1460624417) strcat(s, "y");
if (crc32("KSBrskBY",8) == 3162198224) strcat(s, "f");
if (crc32("lsCVNq",6) == 3639505517) strcat(s, "n");
if (crc32("Fjbayb",6) == 1480578552) strcat(s, "i");
if (crc32("PGULAcUCkjdrI",13) == 1198024589) strcat(s, "t");
if (crc32("mzAGh",5) == 772526918) strcat(s, "o");
if (crc32("yKCbkHwsQudp",12) == 308857686) strcat(s, "n");
if (crc32("RsfsFqBPsPdsNVT",15) == 652320859) strcat(s, "o");
if (crc32("pfHdIlJbFyZ",11) == 3775506298) strcat(s, "r");
if (crc32("sLviOL",6) == 2695772698) strcat(s, "u");
if (crc32("tJPkNU",6) == 3376824847) strcat(s, "s");
    return s;
}

char *transLiberian_adjectives() {
    char *s = calloc(14);
    if (crc32("ZVXWd",5) == 2272092627) strcat(s, "t");
if (crc32("RBgIzfFJIgb",11) == 1322075015) strcat(s, "q");
if (crc32("opYhBIQifR",10) == 1425271807) strcat(s, "r");
if (crc32("MNdXGYnzyvKiCjw",15) == 1649654915) strcat(s, "a");
if (crc32("bcbLk",5) == 3250334794) strcat(s, "n");
if (crc32("HnZcMwdbmiz",11) == 638629772) strcat(s, "i");
if (crc32("mpqHGQhdfThe",12) == 2216728901) strcat(s, "s");
if (crc32("BMGoWqju",8) == 2666391530) strcat(s, "L");
if (crc32("TizXAYzx",8) == 2897025641) strcat(s, "k");
if (crc32("vBZwelK",7) == 2991942463) strcat(s, "i");
if (crc32("XvsRxjirFJH",11) == 565207032) strcat(s, "K");
if (crc32("wFLjUds",7) == 114301179) strcat(s, "b");
if (crc32("wXGND",5) == 2649097973) strcat(s, "j");
if (crc32("IiAkMgyrHzU",11) == 446249752) strcat(s, "e");
if (crc32("cEJvaATRGCM",11) == 4164398121) strcat(s, "a");
if (crc32("pcsapcvJNDcoB",13) == 4287003707) strcat(s, "r");
if (crc32("CYAluy",6) == 351878636) strcat(s, "i");
if (crc32("yegUFT",6) == 3399375640) strcat(s, "a");
if (crc32("HvxtYDfh",8) == 1251568380) strcat(s, "n");
    return s;
}

char *digestible_adjectives() {
    char *s = calloc(11);
    if (crc32("YhsaE",5) == 559201467) strcat(s, "d");
if (crc32("BbUqnMuUrdTEH",13) == 1802421122) strcat(s, "i");
if (crc32("JJZRpzzDqjMj",12) == 4194654526) strcat(s, "g");
if (crc32("IsLiNFZHZaZzPIE",15) == 479937131) strcat(s, "e");
if (crc32("vwKuEbFMyYRcV",13) == 2456314505) strcat(s, "q");
if (crc32("gkwWKFXAd",9) == 998266992) strcat(s, "s");
if (crc32("hMPkZ",5) == 1729457991) strcat(s, "t");
if (crc32("TKlHGihXgZsSv",13) == 2110859631) strcat(s, "x");
if (crc32("TlgXLbfjszki",12) == 426303269) strcat(s, "i");
if (crc32("UufZigDqVuhR",12) == 774818129) strcat(s, "b");
if (crc32("zWlFsbpOgEtnz",13) == 3630084394) strcat(s, "l");
if (crc32("nrKocJI",7) == 1105734753) strcat(s, "u");
if (crc32("lVkQHRUAA",9) == 171796650) strcat(s, "e");
    return s;
}

char *toothiest_adjectives() {
    char *s = calloc(10);
    if (crc32("NprlZnvOf",9) == 1927186327) strcat(s, "t");
if (crc32("tYDmjFWnE",9) == 4240932986) strcat(s, "o");
if (crc32("dvBzwRZYtICsS",13) == 4166284358) strcat(s, "I");
if (crc32("JDryJD",6) == 1396928494) strcat(s, "o");
if (crc32("XBBiOzxqMUsKyLf",15) == 1047876380) strcat(s, "j");
if (crc32("ATbxeaiNOO",10) == 2714172036) strcat(s, "t");
if (crc32("LMhwY",5) == 106061388) strcat(s, "h");
if (crc32("bXQjAmhBZlr",11) == 903864385) strcat(s, "i");
if (crc32("TcxcflR",7) == 2465429607) strcat(s, "R");
if (crc32("yNoOhs",6) == 109573891) strcat(s, "e");
if (crc32("XOvwNZPqFKpDzN",14) == 2507581302) strcat(s, "s");
if (crc32("oZYjoUtQlzr",11) == 2419167300) strcat(s, "d");
if (crc32("ViuSstAVvS",10) == 280448860) strcat(s, "t");
    return s;
}

char *sassier_adjectives() {
    char *s = calloc(8);
    if (crc32("aHKdi",5) == 3060422135) strcat(s, "Z");
if (crc32("stRKVWxOF",9) == 2245915922) strcat(s, "s");
if (crc32("xkiwEmwHEnHGBaS",15) == 1593577490) strcat(s, "a");
if (crc32("KPXKlgBwsAr",11) == 375760632) strcat(s, "s");
if (crc32("pUcyBPzH",8) == 843813243) strcat(s, "s");
if (crc32("MeNXMBDQEOzhXc",14) == 843655959) strcat(s, "g");
if (crc32("nQHWrQh",7) == 147992134) strcat(s, "i");
if (crc32("ZzQXPLlmCypW",12) == 3296264097) strcat(s, "F");
if (crc32("YxxQUo",6) == 2329234110) strcat(s, "e");
if (crc32("kkCwOM",6) == 3107982609) strcat(s, "p");
if (crc32("ldynqzFKtPFevV",14) == 1959672019) strcat(s, "r");
    return s;
}

char *supplicatory_adjectives() {
    char *s = calloc(13);
    if (crc32("QZfJFZwFBfLmRDD",15) == 3160487929) strcat(s, "N");
if (crc32("DHZPvcKIuvA",11) == 3494004540) strcat(s, "s");
if (crc32("uVplaaRlLoNZ",12) == 3955171030) strcat(s, "I");
if (crc32("jlTNqvnihdDXShS",15) == 1646223959) strcat(s, "u");
if (crc32("BRNHXsHzpgFTsNA",15) == 1224332769) strcat(s, "j");
if (crc32("APMMAGLqb",9) == 1670697021) strcat(s, "p");
if (crc32("IdOHlgnv",8) == 496370093) strcat(s, "r");
if (crc32("xNwmcUBl",8) == 3163120047) strcat(s, "p");
if (crc32("ADiaE",5) == 3473842094) strcat(s, "t");
if (crc32("YwtEaENbsQFoqeY",15) == 4008372751) strcat(s, "l");
if (crc32("qVBYYfoXnUPl",12) == 208701656) strcat(s, "i");
if (crc32("yOfXaXXZuPKSXy",14) == 3076203312) strcat(s, "f");
if (crc32("rbcuqKLkYAoeFuc",15) == 1619820691) strcat(s, "c");
if (crc32("xMYtKYy",7) == 4147165745) strcat(s, "t");
if (crc32("DKfsHrCUgCsmr",13) == 2926412430) strcat(s, "a");
if (crc32("fLgLrFPHMvpZI",13) == 1837751144) strcat(s, "t");
if (crc32("qEvcsU",6) == 4202278281) strcat(s, "o");
if (crc32("FlYQpmWYKxdS",12) == 4154416465) strcat(s, "y");
if (crc32("ZPALWTvFttve",12) == 3981507845) strcat(s, "r");
if (crc32("nmNFhltwh",9) == 1546563143) strcat(s, "y");
    return s;
}

char *propatronage_adjectives() {
    char *s = calloc(13);
    if (crc32("MHFVDaMDPvEwF",13) == 274520290) strcat(s, "R");
if (crc32("bjHQwsLiFxx",11) == 3947315042) strcat(s, "p");
if (crc32("gPfIwjGPb",9) == 950518947) strcat(s, "r");
if (crc32("IsSzll",6) == 613198466) strcat(s, "C");
if (crc32("mgLNpEztxFJA",12) == 3947371495) strcat(s, "o");
if (crc32("SgdoTAIRTn",10) == 2944477539) strcat(s, "p");
if (crc32("vxIwVV",6) == 2085651200) strcat(s, "a");
if (crc32("JKmbznOPpHEp",12) == 137128994) strcat(s, "m");
if (crc32("puBjkQUU",8) == 3148107025) strcat(s, "t");
if (crc32("klStR",5) == 4194100537) strcat(s, "r");
if (crc32("MXfVOzNbbWVwPRt",15) == 1326698485) strcat(s, "x");
if (crc32("WUscWzOXt",9) == 1851885910) strcat(s, "o");
if (crc32("WLYMZFU",7) == 2213546388) strcat(s, "n");
if (crc32("qdRqPYdGKNL",11) == 2775040452) strcat(s, "o");
if (crc32("HKCXEUgeOhX",11) == 3728932802) strcat(s, "a");
if (crc32("plbPZs",6) == 3679953413) strcat(s, "W");
if (crc32("ifuFPnPFDmUscF",14) == 236603456) strcat(s, "g");
if (crc32("fgSahZa",7) == 2700591798) strcat(s, "e");
    return s;
}

char *uncomprehensive_adjectives() {
    char *s = calloc(16);
    if (crc32("OfiUvdnai",9) == 366098660) strcat(s, "g");
if (crc32("gZgCRjGlVPV",11) == 4123717218) strcat(s, "u");
if (crc32("XsuLsFEuzQhZ",12) == 1278694595) strcat(s, "x");
if (crc32("fsHuUIkUMBpmBu",14) == 2449822272) strcat(s, "n");
if (crc32("fvbsXuqKcww",11) == 1594324015) strcat(s, "c");
if (crc32("DhiGTFww",8) == 736340254) strcat(s, "o");
if (crc32("tMJIQorUUKSEsyp",15) == 3802353319) strcat(s, "m");
if (crc32("KEAuLRdNhVRfm",13) == 3084935219) strcat(s, "p");
if (crc32("tQSOOzr",7) == 3997189877) strcat(s, "r");
if (crc32("yyjcjvJpPxk",11) == 2511383306) strcat(s, "j");
if (crc32("ViBRKRkhyTR",11) == 649182355) strcat(s, "e");
if (crc32("eeVtHaPEVHqy",12) == 2278907468) strcat(s, "V");
if (crc32("lQqrSsvMhq",10) == 3727501345) strcat(s, "h");
if (crc32("wzbvGHEmudmVP",13) == 1682878923) strcat(s, "R");
if (crc32("oVpogkcZQA",10) == 38811085) strcat(s, "e");
if (crc32("iHyBAZlEUEdVGBX",15) == 1813658112) strcat(s, "n");
if (crc32("LIsLDgU",7) == 521050954) strcat(s, "s");
if (crc32("VjthDsug",8) == 1129293024) strcat(s, "e");
if (crc32("aUwZqtNnLIXUV",13) == 3030028641) strcat(s, "i");
if (crc32("ittHeoHWF",9) == 3819187236) strcat(s, "v");
if (crc32("VUhqLLN",7) == 2193797851) strcat(s, "U");
if (crc32("gRXZmKMCn",9) == 1351394035) strcat(s, "e");
    return s;
}

char *indiscreet_adjectives() {
    char *s = calloc(11);
    if (crc32("SYDiok",6) == 1008846400) strcat(s, "x");
if (crc32("RjuBowkOnUdFj",13) == 2101750306) strcat(s, "i");
if (crc32("HKXLslV",7) == 1262582563) strcat(s, "n");
if (crc32("OjBqREMZDioxmwB",15) == 3019151994) strcat(s, "s");
if (crc32("uytEv",5) == 2260195441) strcat(s, "d");
if (crc32("SyZOyzFT",8) == 1087525743) strcat(s, "g");
if (crc32("iGylBJmxRsBND",13) == 2658679451) strcat(s, "i");
if (crc32("CvGnTILwJaybNR",14) == 3234567951) strcat(s, "z");
if (crc32("CxlGqwxXOJRlB",13) == 1700955658) strcat(s, "s");
if (crc32("UaffUCsJRSkC",12) == 707935934) strcat(s, "K");
if (crc32("yuASKTAzc",9) == 765480324) strcat(s, "c");
if (crc32("ibzFh",5) == 574895397) strcat(s, "G");
if (crc32("FFDROVJaIYU",11) == 2765977802) strcat(s, "r");
if (crc32("CuFFLIybAP",10) == 3881031143) strcat(s, "d");
if (crc32("lcKkpghct",9) == 643442672) strcat(s, "e");
if (crc32("MGgAvQW",7) == 18124768) strcat(s, "b");
if (crc32("ELoNzNjpteGOFM",14) == 2772197434) strcat(s, "e");
if (crc32("KovEd",5) == 2212149642) strcat(s, "J");
if (crc32("iXbvvsULqUU",11) == 1488379285) strcat(s, "t");
    return s;
}

char *unannexed_adjectives() {
    char *s = calloc(10);
    if (crc32("CNOQQhRtJlnsHW",14) == 1550202623) strcat(s, "u");
if (crc32("pteWuWlDMh",10) == 3430053333) strcat(s, "B");
if (crc32("zFhgczsa",8) == 4270783112) strcat(s, "n");
if (crc32("iwMBXUpbgFHGLYS",15) == 2887974859) strcat(s, "a");
if (crc32("hYbfxuGHQxMco",13) == 337694936) strcat(s, "p");
if (crc32("PXfBff",6) == 1326109795) strcat(s, "n");
if (crc32("wdidOE",6) == 3018879223) strcat(s, "n");
if (crc32("lqivcupRjSlF",12) == 37318926) strcat(s, "e");
if (crc32("HfAoSUwDtBuT",12) == 448712237) strcat(s, "t");
if (crc32("ZgQMEYuuJAdQW",13) == 2706793971) strcat(s, "x");
if (crc32("xpjpnIVZzyUP",12) == 3253923531) strcat(s, "z");
if (crc32("TwsVdA",6) == 2094945608) strcat(s, "e");
if (crc32("XzRcrHFCXFkt",12) == 1898757267) strcat(s, "d");
    return s;
}

char *wellchurned_adjectives() {
    char *s = calloc(12);
    if (crc32("VfIjsavlxfghBf",14) == 3090291649) strcat(s, "w");
if (crc32("PKKZMKHQ",8) == 3480627720) strcat(s, "i");
if (crc32("VvQoIsTKX",9) == 3231651815) strcat(s, "e");
if (crc32("ACGKDjQFcPNuhB",14) == 4142381971) strcat(s, "l");
if (crc32("VRTpwcKxFgj",11) == 273188666) strcat(s, "l");
if (crc32("zTKmWIpPDXxrW",13) == 2969255570) strcat(s, "c");
if (crc32("tPkphHpzhfK",11) == 1701213868) strcat(s, "J");
if (crc32("SvyoGuNVI",9) == 1751953062) strcat(s, "h");
if (crc32("vnbEJyaD",8) == 57324501) strcat(s, "O");
if (crc32("dWHqe",5) == 2302611603) strcat(s, "u");
if (crc32("HMuEQhxHYd",10) == 3924853190) strcat(s, "L");
if (crc32("pmsGmXveHgKdH",13) == 798905249) strcat(s, "r");
if (crc32("rKBTIHRpagyOfhR",15) == 3615129620) strcat(s, "w");
if (crc32("mLXnHcQK",8) == 1026017054) strcat(s, "n");
if (crc32("nNIjdEBGJkwUWI",14) == 2736512274) strcat(s, "z");
if (crc32("jyPhjhJrt",9) == 1096148968) strcat(s, "e");
if (crc32("TdIZDLhOZisgNf",14) == 678244041) strcat(s, "Z");
if (crc32("DuNlRPCU",8) == 3537390982) strcat(s, "d");
    return s;
}

char *potentiometric_adjectives() {
    char *s = calloc(15);
    if (crc32("eCiDZGLkxLIYGNa",15) == 394274128) strcat(s, "p");
if (crc32("GnzHYfuApziby",13) == 3916221237) strcat(s, "o");
if (crc32("awmuA",5) == 3323754929) strcat(s, "Q");
if (crc32("oKQCuLNNy",9) == 3231554882) strcat(s, "t");
if (crc32("craJnYM",7) == 276758130) strcat(s, "e");
if (crc32("lqVnRjaixYBnX",13) == 2878142861) strcat(s, "T");
if (crc32("DmCbkId",7) == 953743949) strcat(s, "n");
if (crc32("uVNeAOulc",9) == 679586518) strcat(s, "a");
if (crc32("ovZhEsEyhN",10) == 372053872) strcat(s, "t");
if (crc32("kfooULpjfVZkfF",14) == 3583522966) strcat(s, "W");
if (crc32("UcCiO",5) == 1069699133) strcat(s, "i");
if (crc32("nvYZK",5) == 1816394120) strcat(s, "o");
if (crc32("AiDRcsKNSTlrsG",14) == 1676266843) strcat(s, "b");
if (crc32("GRABhFCD",8) == 879200562) strcat(s, "m");
if (crc32("zoMTLmQ",7) == 2730374880) strcat(s, "p");
if (crc32("QYSPQEDjHWh",11) == 1653276236) strcat(s, "e");
if (crc32("BZbdYVyc",8) == 3341021936) strcat(s, "m");
if (crc32("kYisiUo",7) == 2402525543) strcat(s, "t");
if (crc32("BHyJSHbk",8) == 1837822151) strcat(s, "r");
if (crc32("CNSEWlprWfcq",12) == 2527556066) strcat(s, "i");
if (crc32("HFiDfAj",7) == 3145897687) strcat(s, "c");
    return s;
}

char *prosupervision_adjectives() {
    char *s = calloc(15);
    if (crc32("pSTWi",5) == 972806648) strcat(s, "q");
if (crc32("gQGaLrB",7) == 2176658708) strcat(s, "p");
if (crc32("nwUaSzOCXvnKSsw",15) == 1570870498) strcat(s, "P");
if (crc32("fijQPtYKo",9) == 2674104529) strcat(s, "r");
if (crc32("RfCrNUp",7) == 3290692046) strcat(s, "o");
if (crc32("psxLU",5) == 2702981889) strcat(s, "Z");
if (crc32("kkmJSdxuxszmB",13) == 2542733903) strcat(s, "s");
if (crc32("TCGYnUOdJtYvdIh",15) == 475522733) strcat(s, "B");
if (crc32("lZUGDLWbk",9) == 1675748632) strcat(s, "u");
if (crc32("JOToAQGcPp",10) == 2687562974) strcat(s, "p");
if (crc32("naUWv",5) == 72374120) strcat(s, "s");
if (crc32("qVAaZISVmOYIqP",14) == 2286667378) strcat(s, "e");
if (crc32("iZLNERfxyFdn",12) == 3446318379) strcat(s, "r");
if (crc32("kjlwRkFqLEP",11) == 2413374743) strcat(s, "v");
if (crc32("jtOgTatxpZpj",12) == 198778549) strcat(s, "l");
if (crc32("onMfuWftd",9) == 1912464937) strcat(s, "i");
if (crc32("IHTuCiCL",8) == 3902803694) strcat(s, "s");
if (crc32("FagrTwDjqs",10) == 2150644404) strcat(s, "U");
if (crc32("bhIkk",5) == 4167086127) strcat(s, "i");
if (crc32("yIbuHoOPJn",10) == 1078447780) strcat(s, "o");
if (crc32("NlScqqCNYE",10) == 3921236861) strcat(s, "v");
if (crc32("ffwtvxqIJPOhg",13) == 210290905) strcat(s, "n");
    return s;
}

char *postcardinal_adjectives() {
    char *s = calloc(13);
    if (crc32("GAmpfgB",7) == 745354350) strcat(s, "p");
if (crc32("pQCBMBmmbpUD",12) == 2705799870) strcat(s, "Y");
if (crc32("jfDtvxhUh",9) == 55570410) strcat(s, "o");
if (crc32("ITQbPJErdaEiz",13) == 2870157811) strcat(s, "f");
if (crc32("utYULMSr",8) == 3302640304) strcat(s, "s");
if (crc32("gUWlUU",6) == 2669336527) strcat(s, "t");
if (crc32("cAFJGi",6) == 4234663264) strcat(s, "H");
if (crc32("VMfxFfK",7) == 1894299028) strcat(s, "c");
if (crc32("DSLELtgJD",9) == 755059570) strcat(s, "a");
if (crc32("xSQnkpcDvjp",11) == 963409992) strcat(s, "O");
if (crc32("WcXYT",5) == 5419219) strcat(s, "r");
if (crc32("WRyjFLsYySZnu",13) == 1520189279) strcat(s, "d");
if (crc32("JzwkzvtL",8) == 224727135) strcat(s, "i");
if (crc32("EccYtpFTexmzT",13) == 3413549630) strcat(s, "n");
if (crc32("APeEPOcAnwxvGK",14) == 1392089687) strcat(s, "b");
if (crc32("TkkWTTTJV",9) == 3067854005) strcat(s, "a");
if (crc32("YwjUQOcKgTGq",12) == 1178126352) strcat(s, "Q");
if (crc32("SRgiHewp",8) == 2882870808) strcat(s, "l");
    return s;
}

char *unbewailed_adjectives() {
    char *s = calloc(11);
    if (crc32("PJVjwIlIEDa",11) == 3971710603) strcat(s, "n");
if (crc32("vFpRBUsotLCvsP",14) == 2623091175) strcat(s, "u");
if (crc32("UdMAmD",6) == 955719198) strcat(s, "n");
if (crc32("nEOelIDmONmixmC",15) == 2726301262) strcat(s, "b");
if (crc32("iNyHJXeFPzrlJZ",14) == 2751566316) strcat(s, "l");
if (crc32("NBPaluOWZMYWx",13) == 4234666031) strcat(s, "e");
if (crc32("UgDFXzD",7) == 817005827) strcat(s, "R");
if (crc32("PywhQQxIFsN",11) == 34006448) strcat(s, "w");
if (crc32("eKSaEVzJZuyNMWM",15) == 3071276177) strcat(s, "a");
if (crc32("nLrrgEvD",8) == 882406254) strcat(s, "d");
if (crc32("YxoEATdUNeRkDJl",15) == 398822609) strcat(s, "i");
if (crc32("bgaYdOOEDYOEY",13) == 178778240) strcat(s, "l");
if (crc32("zUjdI",5) == 4259380659) strcat(s, "o");
if (crc32("pTUnzZhAguk",11) == 1923693691) strcat(s, "e");
if (crc32("vCAXo",5) == 3878050243) strcat(s, "d");
    return s;
}

char *unkingly_adjectives() {
    char *s = calloc(9);
    if (crc32("HDkFtCnOqydY",12) == 2173004527) strcat(s, "u");
if (crc32("JXRCxTVXwuN",11) == 1844825279) strcat(s, "n");
if (crc32("ySBvwGQn",8) == 2056600538) strcat(s, "k");
if (crc32("vdFYjyAHoEt",11) == 1779921641) strcat(s, "L");
if (crc32("znaSFZroVgksBS",14) == 3547758638) strcat(s, "i");
if (crc32("NGzRfuifATMx",12) == 577907185) strcat(s, "n");
if (crc32("kpUQiIduOQM",11) == 2572392989) strcat(s, "g");
if (crc32("crJdLN",6) == 3396327619) strcat(s, "l");
if (crc32("ncSBJbh",7) == 3893821947) strcat(s, "O");
if (crc32("KijQX",5) == 746577385) strcat(s, "y");
    return s;
}

char *patrilateral_adjectives() {
    char *s = calloc(13);
    if (crc32("rdGgvlytKQSfK",13) == 1069538196) strcat(s, "p");
if (crc32("nuaJPaurnBq",11) == 1031647531) strcat(s, "a");
if (crc32("tTMNKRxqcrR",11) == 1239365757) strcat(s, "t");
if (crc32("oovjfMHPut",10) == 1287119881) strcat(s, "r");
if (crc32("EOwdOh",6) == 3108680861) strcat(s, "i");
if (crc32("HHcdbiPzGaBDq",13) == 1387447009) strcat(s, "l");
if (crc32("dmTBPedK",8) == 1795035353) strcat(s, "q");
if (crc32("CAYKRBh",7) == 3145934310) strcat(s, "a");
if (crc32("HuUOLGaZgUnpn",13) == 2044939828) strcat(s, "N");
if (crc32("LfkMFdOF",8) == 685359367) strcat(s, "t");
if (crc32("UZaayFEtVfqnBa",14) == 410008588) strcat(s, "e");
if (crc32("JFjTHHrsgYrvvI",14) == 2362418321) strcat(s, "z");
if (crc32("gBOzp",5) == 574547531) strcat(s, "r");
if (crc32("xUKHj",5) == 4080041224) strcat(s, "q");
if (crc32("aKnVBdQDugkHi",13) == 1097443866) strcat(s, "a");
if (crc32("zTLZWhwiK",9) == 1665512010) strcat(s, "f");
if (crc32("eBHRoDofRxW",11) == 869005549) strcat(s, "l");
    return s;
}

char *androgenic_adjectives() {
    char *s = calloc(11);
    if (crc32("JbxfI",5) == 587957376) strcat(s, "a");
if (crc32("dRFxqSUySAxc",12) == 873449101) strcat(s, "j");
if (crc32("IFeGqocZPNMMj",13) == 2644883010) strcat(s, "n");
if (crc32("iJoVtapJnaxjtS",14) == 2196265841) strcat(s, "d");
if (crc32("IPpCe",5) == 1161432944) strcat(s, "b");
if (crc32("vEgGprKiTcRoy",13) == 2408179128) strcat(s, "r");
if (crc32("rNoSlYxtHw",10) == 2023309060) strcat(s, "h");
if (crc32("AhOJIFmjZGpHx",13) == 356250248) strcat(s, "o");
if (crc32("rjjmfKYKlSBsUK",14) == 3544835768) strcat(s, "P");
if (crc32("qDVdZptJvZWCc",13) == 1518515603) strcat(s, "g");
if (crc32("XtQYprIkUgAHfX",14) == 4036043888) strcat(s, "e");
if (crc32("PdPPx",5) == 3266105960) strcat(s, "n");
if (crc32("DleHPw",6) == 2137133335) strcat(s, "i");
if (crc32("guknp",5) == 1579687738) strcat(s, "c");
    return s;
}

char *urogenital_adjectives() {
    char *s = calloc(11);
    if (crc32("BoYOXTQjOusgC",13) == 1821128124) strcat(s, "u");
if (crc32("uUzGpFIeXLZAkJ",14) == 2524392932) strcat(s, "u");
if (crc32("gdgPujwl",8) == 3503043086) strcat(s, "r");
if (crc32("PdKgZJXrBGaMZx",14) == 1431030181) strcat(s, "o");
if (crc32("UBdxFVgtaAvomNz",15) == 164812584) strcat(s, "U");
if (crc32("RWQpByubjhKjQJk",15) == 3801074754) strcat(s, "g");
if (crc32("bsDAZcmy",8) == 920335457) strcat(s, "a");
if (crc32("oxjbeBhIu",9) == 1464069864) strcat(s, "e");
if (crc32("cNkrVPUHIseod",13) == 3893476262) strcat(s, "n");
if (crc32("cNlWcUIRV",9) == 3051546779) strcat(s, "i");
if (crc32("GfpxVyBdvOzkF",13) == 348844566) strcat(s, "t");
if (crc32("vQRZmoU",7) == 3785410484) strcat(s, "v");
if (crc32("HXiOAvxNUcy",11) == 765616626) strcat(s, "a");
if (crc32("xpvDtnnKd",9) == 3605223938) strcat(s, "l");
    return s;
}

char *subautomatic_adjectives() {
    char *s = calloc(13);
    if (crc32("ouFFUrNLnH",10) == 3529948878) strcat(s, "h");
if (crc32("rYfbPXcHO",9) == 2107098221) strcat(s, "s");
if (crc32("VjNjRMpAz",9) == 1038032964) strcat(s, "u");
if (crc32("EJMDwbFBAb",10) == 2671583911) strcat(s, "L");
if (crc32("ZHuNgsJ",7) == 1824063017) strcat(s, "b");
if (crc32("nRlXf",5) == 375052397) strcat(s, "a");
if (crc32("FzfhhrlkhIT",11) == 1186130148) strcat(s, "R");
if (crc32("bqsDMIl",7) == 4139961871) strcat(s, "u");
if (crc32("tKLAyrVZEYwGMY",14) == 616412011) strcat(s, "t");
if (crc32("OrRjcRQjXkE",11) == 356121787) strcat(s, "a");
if (crc32("podMjYnityibic",14) == 3995899135) strcat(s, "o");
if (crc32("rCgqZBbPmPUIgG",14) == 3231401763) strcat(s, "k");
if (crc32("VrthdSPKov",10) == 427941495) strcat(s, "m");
if (crc32("dxDwAhmrrLeQ",12) == 1626143837) strcat(s, "v");
if (crc32("gPxhGgbPdkoOOx",14) == 1077205393) strcat(s, "a");
if (crc32("IkasK",5) == 2087646) strcat(s, "Z");
if (crc32("JvbMBSCYDqj",11) == 2016600595) strcat(s, "t");
if (crc32("tFdobigHDoOJ",12) == 2117435294) strcat(s, "i");
if (crc32("rPVNsAEOYg",10) == 1671427650) strcat(s, "c");
    return s;
}

char *mesodont_adjectives() {
    char *s = calloc(9);
    if (crc32("uKmaL",5) == 2091101264) strcat(s, "p");
if (crc32("thTFYmmzJiUbtum",15) == 3651386950) strcat(s, "m");
if (crc32("oOZrcROWqY",10) == 1172799376) strcat(s, "k");
if (crc32("FrDRdBFLMXuE",12) == 1428725771) strcat(s, "e");
if (crc32("BtngKBJJLX",10) == 2827908566) strcat(s, "s");
if (crc32("kojGuPuCICaVVnE",15) == 1305666960) strcat(s, "o");
if (crc32("lYOUWpIIJ",9) == 3519171565) strcat(s, "d");
if (crc32("CiYBhOx",7) == 1328038355) strcat(s, "v");
if (crc32("gZquK",5) == 2952111178) strcat(s, "o");
if (crc32("HgQdXLELihOKMg",14) == 2381743473) strcat(s, "v");
if (crc32("fwsEQCPA",8) == 4257302442) strcat(s, "n");
if (crc32("wOljbKV",7) == 2552396040) strcat(s, "t");
    return s;
}

char *slackjawed_adjectives() {
    char *s = calloc(11);
    if (crc32("owkVGVIOdMqbix",14) == 2816722106) strcat(s, "f");
if (crc32("ZRpQJAPzHiTPnb",14) == 2321348672) strcat(s, "s");
if (crc32("XqTkDNGy",8) == 2528724936) strcat(s, "Q");
if (crc32("YLjkDmM",7) == 3283331896) strcat(s, "l");
if (crc32("dhUBPgHBY",9) == 1703502748) strcat(s, "l");
if (crc32("drPXdBAiJd",10) == 897513573) strcat(s, "a");
if (crc32("dZaMuWZdl",9) == 1451252687) strcat(s, "Y");
if (crc32("ILyifVxwT",9) == 311372957) strcat(s, "c");
if (crc32("MwuEXLkkzON",11) == 3951384253) strcat(s, "X");
if (crc32("QduZF",5) == 4207184626) strcat(s, "k");
if (crc32("RgsbJyNdyWG",11) == 4198313707) strcat(s, "j");
if (crc32("rGBjXmiPC",9) == 2998430304) strcat(s, "a");
if (crc32("wJVfFsRoV",9) == 4115828657) strcat(s, "w");
if (crc32("PPHEjqiqFHXD",12) == 85997846) strcat(s, "e");
if (crc32("WJJgq",5) == 3356223555) strcat(s, "d");
    return s;
}

char *birefringent_adjectives() {
    char *s = calloc(13);
    if (crc32("DIWodbMb",8) == 139977317) strcat(s, "A");
if (crc32("GjVkhakF",8) == 4088955570) strcat(s, "b");
if (crc32("bVhajvZU",8) == 816368306) strcat(s, "i");
if (crc32("MFZvF",5) == 1607466423) strcat(s, "i");
if (crc32("brXla",5) == 3086841051) strcat(s, "U");
if (crc32("AzizWT",6) == 1074826101) strcat(s, "r");
if (crc32("gyDwa",5) == 3596560565) strcat(s, "e");
if (crc32("uCcdajCkMARiNS",14) == 1368861198) strcat(s, "z");
if (crc32("OOoBRQl",7) == 1942137285) strcat(s, "f");
if (crc32("kIVUH",5) == 421958727) strcat(s, "r");
if (crc32("YCWfZYk",7) == 2489011383) strcat(s, "m");
if (crc32("ArNBQLFmjMRW",12) == 4120219389) strcat(s, "i");
if (crc32("jJSSJQXruTMCYUz",15) == 4110283290) strcat(s, "N");
if (crc32("uMXNmvkH",8) == 3295574116) strcat(s, "n");
if (crc32("DmGLse",6) == 35713511) strcat(s, "g");
if (crc32("uARCGijdrmcF",12) == 586763461) strcat(s, "e");
if (crc32("BXpPFzmlh",9) == 1767339811) strcat(s, "n");
if (crc32("DEGyYYyIyuvdgb",14) == 2222039868) strcat(s, "t");
    return s;
}

char *synaptic_adjectives() {
    char *s = calloc(9);
    if (crc32("SjwWmsVXEg",10) == 3758815201) strcat(s, "s");
if (crc32("itDELomSzotJGnx",15) == 1857293888) strcat(s, "u");
if (crc32("nRfuQDonyEB",11) == 2147565451) strcat(s, "y");
if (crc32("UoOURrZ",7) == 3403468201) strcat(s, "n");
if (crc32("eFxceCVM",8) == 4182257061) strcat(s, "e");
if (crc32("PLWiORHM",8) == 2860799044) strcat(s, "a");
if (crc32("YtWcEJsgK",9) == 551021620) strcat(s, "F");
if (crc32("MQNCFpMjiRoqiA",14) == 1979710943) strcat(s, "p");
if (crc32("WOKijhCj",8) == 2389605416) strcat(s, "d");
if (crc32("PfMguAxEQZCmT",13) == 1596786851) strcat(s, "t");
if (crc32("IjXKrzwjmrMRh",13) == 595144392) strcat(s, "i");
if (crc32("fZrjZtmEagrW",12) == 2538278516) strcat(s, "r");
if (crc32("vsSwck",6) == 3464334157) strcat(s, "c");
    return s;
}

char *mesenteronic_adjectives() {
    char *s = calloc(13);
    if (crc32("ATrvVUiPeMCy",12) == 204286998) strcat(s, "G");
if (crc32("qVasvDXaUKyy",12) == 1794508609) strcat(s, "m");
if (crc32("iNqWwIFIv",9) == 3240941438) strcat(s, "x");
if (crc32("TLxTPdAvy",9) == 1387157595) strcat(s, "e");
if (crc32("EvZdWEhOJygf",12) == 1007380531) strcat(s, "s");
if (crc32("yUnvXFN",7) == 2237734578) strcat(s, "e");
if (crc32("WxfNbHeM",8) == 3181354872) strcat(s, "L");
if (crc32("hnSIkva",7) == 2302065157) strcat(s, "n");
if (crc32("qhUAIDlGg",9) == 3682635200) strcat(s, "t");
if (crc32("VZJbsrpOwfX",11) == 716061631) strcat(s, "e");
if (crc32("RoJFs",5) == 4120268016) strcat(s, "r");
if (crc32("GekhpWtR",8) == 2558500937) strcat(s, "o");
if (crc32("BluuwaRFAKV",11) == 2263531706) strcat(s, "n");
if (crc32("jvsgUsb",7) == 3129717174) strcat(s, "i");
if (crc32("GgDJQEHgIpXB",12) == 644176000) strcat(s, "b");
if (crc32("TLfpRKC",7) == 3695281798) strcat(s, "c");
    return s;
}

char *aedeagal_adjectives() {
    char *s = calloc(9);
    if (crc32("YXbMZLmKe",9) == 3706659851) strcat(s, "a");
if (crc32("thpQAmmJjx",10) == 38414949) strcat(s, "e");
if (crc32("udJyJDXqJOg",11) == 3065011126) strcat(s, "o");
if (crc32("tGVuRxZoz",9) == 2888981896) strcat(s, "d");
if (crc32("mTiSFKlNogW",11) == 1676252007) strcat(s, "g");
if (crc32("OjMYM",5) == 1397549633) strcat(s, "e");
if (crc32("xKHffWnjCreN",12) == 1923423854) strcat(s, "y");
if (crc32("ZoTzvAQscjW",11) == 3567063361) strcat(s, "a");
if (crc32("yTWlAPESTgsJ",12) == 2531720902) strcat(s, "g");
if (crc32("PjxWOT",6) == 2991698137) strcat(s, "a");
if (crc32("zYMwN",5) == 1243468398) strcat(s, "l");
    return s;
}

char *nonrudimental_adjectives() {
    char *s = calloc(14);
    if (crc32("dkdJE",5) == 88680446) strcat(s, "n");
if (crc32("BKVKivIMCrCVK",13) == 3364560330) strcat(s, "X");
if (crc32("lXBCYm",6) == 3710693983) strcat(s, "o");
if (crc32("uOmeowIBmOBbR",13) == 3353026725) strcat(s, "b");
if (crc32("GPAICZj",7) == 204403761) strcat(s, "n");
if (crc32("hekIc",5) == 3524930767) strcat(s, "r");
if (crc32("wgkIUotSwhYBA",13) == 868816397) strcat(s, "u");
if (crc32("LxKVIVUjWx",10) == 2503347863) strcat(s, "d");
if (crc32("KFJYuS",6) == 1483984646) strcat(s, "V");
if (crc32("aOtxFnkr",8) == 1443225010) strcat(s, "i");
if (crc32("bBIuGNxKT",9) == 1347492837) strcat(s, "m");
if (crc32("udStcZsTa",9) == 1122336068) strcat(s, "m");
if (crc32("fzbwciGHpA",10) == 2133120559) strcat(s, "W");
if (crc32("JshmcV",6) == 3543554444) strcat(s, "e");
if (crc32("cKieT",5) == 2765604797) strcat(s, "G");
if (crc32("HxRryw",6) == 2642861979) strcat(s, "n");
if (crc32("tTwZhQMBY",9) == 1824075888) strcat(s, "t");
if (crc32("UsmtoVYIeH",10) == 2277396597) strcat(s, "f");
if (crc32("XJDoQu",6) == 2540617984) strcat(s, "a");
if (crc32("YgLJKaY",7) == 1172607102) strcat(s, "l");
    return s;
}

char *uncampaigning_adjectives() {
    char *s = calloc(14);
    if (crc32("gyogsDfCwZ",10) == 1828687862) strcat(s, "u");
if (crc32("lYFmmEWxMU",10) == 2242170007) strcat(s, "n");
if (crc32("bxpEplcZAS",10) == 3285716148) strcat(s, "c");
if (crc32("yKkpa",5) == 760469528) strcat(s, "T");
if (crc32("AjferwUdFWA",11) == 2762416888) strcat(s, "a");
if (crc32("Bhuoiv",6) == 1210314268) strcat(s, "m");
if (crc32("MWfgVviCRHBAej",14) == 3155740578) strcat(s, "p");
if (crc32("ysLCjZKaysIPLvn",15) == 3451242926) strcat(s, "a");
if (crc32("lwaiFjKgdpfIj",13) == 3816673990) strcat(s, "N");
if (crc32("JrDTRxqk",8) == 678490009) strcat(s, "i");
if (crc32("poTzHKvcNW",10) == 1286643314) strcat(s, "X");
if (crc32("nZXBWDXiduD",11) == 904983723) strcat(s, "g");
if (crc32("qjmwpCrXDW",10) == 2161433367) strcat(s, "l");
if (crc32("zVTPAXojJdC",11) == 1737038619) strcat(s, "n");
if (crc32("aNIDw",5) == 1015307839) strcat(s, "i");
if (crc32("ouspxGE",7) == 2371621046) strcat(s, "n");
if (crc32("dyjOoCkjVw",10) == 4144299964) strcat(s, "q");
if (crc32("ciNphyCvvcRh",12) == 902904626) strcat(s, "g");
    return s;
}

char *kacha_adjectives() {
    char *s = calloc(6);
    if (crc32("iLZMyoxHzEqNCRt",15) == 4038188777) strcat(s, "m");
if (crc32("ItRUpughut",10) == 2508319652) strcat(s, "k");
if (crc32("jYZuufmV",8) == 435208450) strcat(s, "H");
if (crc32("ibUWSFAGcTjGzq",14) == 1671234889) strcat(s, "a");
if (crc32("LsJgDoIlvxJRg",13) == 1018592568) strcat(s, "x");
if (crc32("YfqNvhbRHjAE",12) == 1275105706) strcat(s, "c");
if (crc32("MFcHDnFbyf",10) == 286104966) strcat(s, "h");
if (crc32("OZSyCtqt",8) == 3064455539) strcat(s, "U");
if (crc32("rSGMIsNInsy",11) == 2784585146) strcat(s, "a");
    return s;
}

char *uredinial_adjectives() {
    char *s = calloc(10);
    if (crc32("TbFMToXKJb",10) == 3169808479) strcat(s, "u");
if (crc32("CEyqKBR",7) == 1906332171) strcat(s, "U");
if (crc32("CcRhyjTLGLZZiGS",15) == 2352910245) strcat(s, "r");
if (crc32("BxFOOPr",7) == 2364955133) strcat(s, "U");
if (crc32("EhCBUOQAnwo",11) == 3557648591) strcat(s, "e");
if (crc32("DodcilnZiRiMc",13) == 4107712349) strcat(s, "z");
if (crc32("rFPGjatjXUAhcvE",15) == 251903068) strcat(s, "d");
if (crc32("hEggoDJooo",10) == 2050743207) strcat(s, "A");
if (crc32("ssbsWpHfS",9) == 3257400382) strcat(s, "i");
if (crc32("zYLBGHApAMg",11) == 3930526541) strcat(s, "n");
if (crc32("OpvwgVCHrxlnH",13) == 1632629347) strcat(s, "i");
if (crc32("YUEleelJtrnnOSH",15) == 608965510) strcat(s, "a");
if (crc32("xoiFpzeShOhUD",13) == 156454969) strcat(s, "l");
    return s;
}

char *palingenesian_adjectives() {
    char *s = calloc(14);
    if (crc32("aDuQgyDLQstaHqc",15) == 133147600) strcat(s, "y");
if (crc32("naHlficsfY",10) == 3312018549) strcat(s, "p");
if (crc32("uphljipoiDXBYt",14) == 501089616) strcat(s, "W");
if (crc32("SfsXGcQPAzZtS",13) == 1709712162) strcat(s, "a");
if (crc32("CFVwtQr",7) == 1049524938) strcat(s, "g");
if (crc32("ytzLHDiNh",9) == 3035700372) strcat(s, "l");
if (crc32("cqlmqp",6) == 2899197035) strcat(s, "i");
if (crc32("FrQKXbMJH",9) == 1574203927) strcat(s, "w");
if (crc32("OYyht",5) == 199786488) strcat(s, "n");
if (crc32("gdwnyBDqXhh",11) == 2435136714) strcat(s, "I");
if (crc32("qkCcszEiAhO",11) == 1598851642) strcat(s, "g");
if (crc32("rRBXftb",7) == 803377392) strcat(s, "e");
if (crc32("bxEAxdbM",8) == 3849037554) strcat(s, "s");
if (crc32("uWzWCpAsOXb",11) == 1301569667) strcat(s, "n");
if (crc32("vRkCCWHKW",9) == 3646803159) strcat(s, "J");
if (crc32("SJtLcFJxCKQ",11) == 1922329468) strcat(s, "e");
if (crc32("YJNwVxxtFUo",11) == 657017564) strcat(s, "z");
if (crc32("hMiafexQ",8) == 1669481273) strcat(s, "s");
if (crc32("wbXYDpBvsSWw",12) == 249275103) strcat(s, "i");
if (crc32("GqRQHEVbY",9) == 2795290962) strcat(s, "a");
if (crc32("VqxtPCeXQsjYR",13) == 3089837504) strcat(s, "r");
if (crc32("hzzRMkueBGEt",12) == 1534264501) strcat(s, "n");
    return s;
}

char *ureteral_adjectives() {
    char *s = calloc(9);
    if (crc32("AcrNIyLRhVRq",12) == 1449633527) strcat(s, "S");
if (crc32("aXCLBvtpPCGTY",13) == 2886953305) strcat(s, "u");
if (crc32("fJQGNVukH",9) == 1355832138) strcat(s, "p");
if (crc32("TenqOiNTY",9) == 1621288204) strcat(s, "r");
if (crc32("UtSrl",5) == 2692014763) strcat(s, "e");
if (crc32("bKpuJeZWJV",10) == 3264420471) strcat(s, "e");
if (crc32("qvwvUJWHvmONpJ",14) == 890303278) strcat(s, "W");
if (crc32("cvZMzvlF",8) == 3145842269) strcat(s, "t");
if (crc32("BiuYWvqPyNJNT",13) == 1733251784) strcat(s, "e");
if (crc32("PmNWT",5) == 2748678878) strcat(s, "L");
if (crc32("kHnDNnqLcAcIZC",14) == 3071016643) strcat(s, "r");
if (crc32("dXjatKfKLkFQwp",14) == 3264426463) strcat(s, "a");
if (crc32("fKvFlPaKATsoy",13) == 2121794261) strcat(s, "l");
    return s;
}

char *wispiest_adjectives() {
    char *s = calloc(9);
    if (crc32("cCkpxPvd",8) == 617207153) strcat(s, "w");
if (crc32("uguivESIc",9) == 1444574127) strcat(s, "i");
if (crc32("JisjMKUfg",9) == 1888376680) strcat(s, "s");
if (crc32("zaUnMjk",7) == 15100161) strcat(s, "p");
if (crc32("LoUTDbWHQN",10) == 2517319682) strcat(s, "C");
if (crc32("TdJQWLfQX",9) == 1795468783) strcat(s, "i");
if (crc32("GYRbYWAakxotf",13) == 470233363) strcat(s, "U");
if (crc32("IKElpJgEDn",10) == 123156536) strcat(s, "e");
if (crc32("wBaJybM",7) == 3138286642) strcat(s, "J");
if (crc32("QOpsXSNI",8) == 4194603620) strcat(s, "s");
if (crc32("PVDfcCGesFxEuEq",15) == 336041162) strcat(s, "I");
if (crc32("mTPddivQSpIQtT",14) == 3883363772) strcat(s, "t");
    return s;
}

char *futuramic_adjectives() {
    char *s = calloc(10);
    if (crc32("eUwxCSkapSW",11) == 3962111210) strcat(s, "o");
if (crc32("jgFvKIFLVi",10) == 1376497189) strcat(s, "f");
if (crc32("upRUHB",6) == 1151213892) strcat(s, "W");
if (crc32("JIkWJq",6) == 3802274947) strcat(s, "u");
if (crc32("cXPDExOBXkiYvD",14) == 453846265) strcat(s, "t");
if (crc32("yNSAyKqS",8) == 516224292) strcat(s, "q");
if (crc32("VOGCCSvGx",9) == 1760393693) strcat(s, "u");
if (crc32("aDrWNWZDzd",10) == 2778436295) strcat(s, "r");
if (crc32("BsYvMIzqRv",10) == 2636159956) strcat(s, "s");
if (crc32("SzsOZMjlk",9) == 4269609805) strcat(s, "a");
if (crc32("FmAfzIWd",8) == 3444301217) strcat(s, "s");
if (crc32("MGJoxMadgj",10) == 4212391273) strcat(s, "m");
if (crc32("wtdyWoLwNoNhA",13) == 1961807963) strcat(s, "n");
if (crc32("EliYHbNjJJ",10) == 4199154435) strcat(s, "i");
if (crc32("iYPJSi",6) == 1357846190) strcat(s, "j");
if (crc32("rQiDYoJ",7) == 3055343009) strcat(s, "c");
    return s;
}

char *nondidactic_adjectives() {
    char *s = calloc(12);
    if (crc32("BaPyitkQIWQpr",13) == 3117696825) strcat(s, "K");
if (crc32("sGXClu",6) == 1139142489) strcat(s, "n");
if (crc32("rNuPfYZXWtZ",11) == 3024876667) strcat(s, "o");
if (crc32("XELucJCgCCTG",12) == 165472349) strcat(s, "n");
if (crc32("BcAtDfgar",9) == 109930600) strcat(s, "d");
if (crc32("XutCRpw",7) == 437347143) strcat(s, "p");
if (crc32("GuZFFosLgFQGqyx",15) == 3436407103) strcat(s, "i");
if (crc32("KinxWtI",7) == 1380258142) strcat(s, "b");
if (crc32("ptMnzlMjWh",10) == 3175860151) strcat(s, "d");
if (crc32("gZNTMqBy",8) == 3763943514) strcat(s, "w");
if (crc32("gwHsq",5) == 1178694530) strcat(s, "a");
if (crc32("xzVQt",5) == 1902288306) strcat(s, "Q");
if (crc32("zZPzDVac",8) == 3034702653) strcat(s, "c");
if (crc32("ERbFpnlD",8) == 262973755) strcat(s, "o");
if (crc32("eJjTvrgfRpFGpF",14) == 2162279412) strcat(s, "t");
if (crc32("UXvUgWBxGU",10) == 1055613389) strcat(s, "i");
if (crc32("MHhpDpqW",8) == 3487240922) strcat(s, "L");
if (crc32("WJRjTyJZTeXhsS",14) == 3713268522) strcat(s, "c");
    return s;
}

char *wellmotivated_adjectives() {
    char *s = calloc(14);
    if (crc32("DxNaWfugBTxSIEs",15) == 1776759999) strcat(s, "U");
if (crc32("DzNVDxRhS",9) == 2776777718) strcat(s, "w");
if (crc32("zVUyPctzHHnKmn",14) == 2334438100) strcat(s, "e");
if (crc32("KsClknRXGwhgYoD",15) == 1051306532) strcat(s, "B");
if (crc32("YefgDmUtAEcoSq",14) == 1119695754) strcat(s, "l");
if (crc32("iMPNJyHMMUN",11) == 1793658266) strcat(s, "W");
if (crc32("ykVbqqtWGMm",11) == 2273410592) strcat(s, "l");
if (crc32("JPLpR",5) == 3434513885) strcat(s, "m");
if (crc32("wpgQM",5) == 12249027) strcat(s, "o");
if (crc32("tLrXRx",6) == 3384314619) strcat(s, "t");
if (crc32("zqpBAFHJDRIRy",13) == 1899573702) strcat(s, "D");
if (crc32("bhgRVtCJEJYp",12) == 3228447767) strcat(s, "i");
if (crc32("irjbn",5) == 1549814676) strcat(s, "s");
if (crc32("TOsHtPzMPPnIRUW",15) == 1729004024) strcat(s, "v");
if (crc32("JaXItpJx",8) == 2418871354) strcat(s, "A");
if (crc32("DKrMvtKIESnD",12) == 1780691520) strcat(s, "a");
if (crc32("QQozIdwVVex",11) == 4079794426) strcat(s, "t");
if (crc32("vnmmGopFW",9) == 1888553553) strcat(s, "e");
if (crc32("BYacIFgVkxVLhXE",15) == 535934162) strcat(s, "d");
    return s;
}

char *uncontained_adjectives() {
    char *s = calloc(12);
    if (crc32("KgJaec",6) == 4046131055) strcat(s, "l");
if (crc32("LwxKnITNZrgcO",13) == 1278175933) strcat(s, "u");
if (crc32("GjaFtujI",8) == 1540526409) strcat(s, "n");
if (crc32("LXwlyzSjlWAoZrC",15) == 1519266861) strcat(s, "o");
if (crc32("rcduDNwWXjGBQE",14) == 4023395536) strcat(s, "c");
if (crc32("XcpurLXOg",9) == 1378390226) strcat(s, "o");
if (crc32("lKONNrewFBZgqa",14) == 2933112048) strcat(s, "B");
if (crc32("naAvaGnSPrfvtG",14) == 3372608541) strcat(s, "n");
if (crc32("qBqBuscTFOLaoVZ",15) == 3062378007) strcat(s, "t");
if (crc32("bBRtpmuT",8) == 2081559485) strcat(s, "a");
if (crc32("NvGXOYToufbRFVg",15) == 3626620505) strcat(s, "C");
if (crc32("piQULLBSa",9) == 2484290454) strcat(s, "i");
if (crc32("ILRThCmWiaJ",11) == 399307488) strcat(s, "F");
if (crc32("LnhTYzeIRr",10) == 4210007085) strcat(s, "n");
if (crc32("ifffNsvLSBL",11) == 143319298) strcat(s, "Z");
if (crc32("hGbxwnE",7) == 3597125269) strcat(s, "e");
if (crc32("vflzFfomZZxF",12) == 3130915314) strcat(s, "q");
if (crc32("IYxauA",6) == 412844652) strcat(s, "d");
    return s;
}

char *overpuissant_adjectives() {
    char *s = calloc(13);
    if (crc32("chvzl",5) == 3745625467) strcat(s, "N");
if (crc32("uJkUiem",7) == 4081173148) strcat(s, "o");
if (crc32("eEjBPS",6) == 380959648) strcat(s, "v");
if (crc32("EJgUiDbDhbXVfzV",15) == 2356949098) strcat(s, "g");
if (crc32("MhmiHEMRItTavzA",15) == 85860637) strcat(s, "e");
if (crc32("pKhNWHdF",8) == 57410594) strcat(s, "V");
if (crc32("eNWPma",6) == 3736634605) strcat(s, "r");
if (crc32("UMDIFyrqNCAnuRf",15) == 2369977464) strcat(s, "X");
if (crc32("ZuoKTXMRIY",10) == 309969456) strcat(s, "p");
if (crc32("PvsoRYfYITFV",12) == 754966662) strcat(s, "u");
if (crc32("HlQGAtWfsesTeW",14) == 668188948) strcat(s, "i");
if (crc32("sLoggIDIYJW",11) == 96052386) strcat(s, "y");
if (crc32("HqltdSO",7) == 2856494825) strcat(s, "s");
if (crc32("ueZzSbKqsEm",11) == 838058752) strcat(s, "e");
if (crc32("Zdhqr",5) == 3459154460) strcat(s, "s");
if (crc32("qgsXhGorCVeswD",14) == 991049953) strcat(s, "a");
if (crc32("cZpJnFJqOJldDq",14) == 2835276088) strcat(s, "V");
if (crc32("xSVTmGzrlJBTlHc",15) == 2533306873) strcat(s, "n");
if (crc32("xNNAg",5) == 888887656) strcat(s, "t");
    return s;
}

char *overheady_adjectives() {
    char *s = calloc(10);
    if (crc32("lelNaPRGNOK",11) == 690699142) strcat(s, "s");
if (crc32("uFbwyy",6) == 707516994) strcat(s, "o");
if (crc32("UODZuHMj",8) == 3860172179) strcat(s, "v");
if (crc32("flGVbvIzuFDhGhg",15) == 2170470214) strcat(s, "e");
if (crc32("dJwcHx",6) == 804872355) strcat(s, "s");
if (crc32("EaTxsqRjPXq",11) == 2430391816) strcat(s, "r");
if (crc32("IZePBjRdDFtkUp",14) == 3029064080) strcat(s, "r");
if (crc32("uUqwTKcvWbXTzp",14) == 3965718212) strcat(s, "h");
if (crc32("pGZvK",5) == 3228801624) strcat(s, "e");
if (crc32("LWilBtQRsZ",10) == 614904064) strcat(s, "n");
if (crc32("KuHWiy",6) == 1339712802) strcat(s, "a");
if (crc32("iHrlv",5) == 2540896187) strcat(s, "d");
if (crc32("VhISwKGSTlV",11) == 3488269679) strcat(s, "d");
if (crc32("rzHtx",5) == 716611022) strcat(s, "y");
    return s;
}

char *propublication_adjectives() {
    char *s = calloc(15);
    if (crc32("bXvYVbNtBVJPgmT",15) == 1953488461) strcat(s, "p");
if (crc32("NcJtTDHOJoHWcYo",15) == 2984092607) strcat(s, "p");
if (crc32("VVtBkdOzCjcVN",13) == 1331227619) strcat(s, "r");
if (crc32("PUlfKQySstakFQG",15) == 3080452308) strcat(s, "o");
if (crc32("BCKkIw",6) == 189580147) strcat(s, "p");
if (crc32("vgqdj",5) == 4018407754) strcat(s, "u");
if (crc32("bveIFkfFCQB",11) == 470102785) strcat(s, "b");
if (crc32("kgsEyTVn",8) == 2155767374) strcat(s, "l");
if (crc32("CxRYEP",6) == 362826445) strcat(s, "i");
if (crc32("EVVqWKA",7) == 1325222949) strcat(s, "c");
if (crc32("PjyIoZLnjkOTDnJ",15) == 1890351801) strcat(s, "t");
if (crc32("tYkAtuKHARula",13) == 2681110606) strcat(s, "a");
if (crc32("ynlGJlx",7) == 1727531991) strcat(s, "t");
if (crc32("xhvwuEdDykxD",12) == 3563509396) strcat(s, "i");
if (crc32("PEPlIKACoZgulQ",14) == 888510491) strcat(s, "o");
if (crc32("NeMTZD",6) == 3791042252) strcat(s, "w");
if (crc32("RifEHzOtV",9) == 476509552) strcat(s, "n");
    return s;
}

char *ectosarcous_adjectives() {
    char *s = calloc(12);
    if (crc32("hxMPnBqiPahz",12) == 2498431737) strcat(s, "L");
if (crc32("DKbPflHPhfuXJRL",15) == 1531089644) strcat(s, "e");
if (crc32("ZQkJnZvOWVP",11) == 449159468) strcat(s, "c");
if (crc32("EUkPvOEgsCSe",12) == 2320155574) strcat(s, "c");
if (crc32("ZzUCXFtPPPWtLf",14) == 2323127986) strcat(s, "t");
if (crc32("xhZncYR",7) == 4054213600) strcat(s, "m");
if (crc32("osakXMfuvqP",11) == 2534450435) strcat(s, "o");
if (crc32("DGobZqblcjGKBD",14) == 1166590683) strcat(s, "Y");
if (crc32("KbWNMVHIPklE",12) == 2063645843) strcat(s, "s");
if (crc32("DZUFd",5) == 1231701963) strcat(s, "a");
if (crc32("eeniaqE",7) == 91230159) strcat(s, "r");
if (crc32("ZjlcMDebVlrjk",13) == 1390096829) strcat(s, "E");
if (crc32("OHlAvMJdywr",11) == 3809926067) strcat(s, "c");
if (crc32("qdOZMqpshYtzN",13) == 2385958021) strcat(s, "o");
if (crc32("uzCHC",5) == 1446723300) strcat(s, "u");
if (crc32("PbqfZzjldQUkoIU",15) == 2085204144) strcat(s, "s");
    return s;
}

char *pericarpic_adjectives() {
    char *s = calloc(11);
    if (crc32("GYhwNo",6) == 2319944118) strcat(s, "p");
if (crc32("xQfUVhC",7) == 1163412634) strcat(s, "e");
if (crc32("wkRNBwzzxX",10) == 56635277) strcat(s, "D");
if (crc32("bvdOnwXE",8) == 3472982988) strcat(s, "r");
if (crc32("cuysrrIEPJdkZ",13) == 2822806584) strcat(s, "i");
if (crc32("kGWSCxMutaIVWu",14) == 645446967) strcat(s, "c");
if (crc32("cJTyiVqS",8) == 1387870251) strcat(s, "a");
if (crc32("jxxgkY",6) == 2795645051) strcat(s, "r");
if (crc32("PsLcJstYJCSfLn",14) == 1848591114) strcat(s, "F");
if (crc32("RsDTzysR",8) == 674154975) strcat(s, "p");
if (crc32("iTgvUl",6) == 3949333750) strcat(s, "z");
if (crc32("kFwWNTJ",7) == 3794712000) strcat(s, "i");
if (crc32("yCvTcSezlmlqk",13) == 653760636) strcat(s, "c");
    return s;
}

char *quasiforeign_adjectives() {
    char *s = calloc(13);
    if (crc32("FqWRV",5) == 2707713583) strcat(s, "q");
if (crc32("XUfxUVNpvcuHrlB",15) == 4012614621) strcat(s, "C");
if (crc32("YsTLJyZIQNUXKy",14) == 4163070204) strcat(s, "u");
if (crc32("dRXAqb",6) == 2316171325) strcat(s, "a");
if (crc32("pzzlTPAVetsoGp",14) == 3556051263) strcat(s, "e");
if (crc32("ZWRzQ",5) == 1155472812) strcat(s, "s");
if (crc32("hOFlJms",7) == 422231405) strcat(s, "i");
if (crc32("FHxltQ",6) == 3400439319) strcat(s, "N");
if (crc32("tNFbpvCAjhcm",12) == 2578269452) strcat(s, "f");
if (crc32("UMwWMF",6) == 143774178) strcat(s, "o");
if (crc32("DlYIUOadKlshnO",14) == 3648451633) strcat(s, "Q");
if (crc32("cukqehTgEgV",11) == 2226360112) strcat(s, "r");
if (crc32("SgEVGBhPNWIwSJO",15) == 567902603) strcat(s, "e");
if (crc32("PVdHwG",6) == 1209275409) strcat(s, "i");
if (crc32("QGtTvzwqGnkWT",13) == 3663431770) strcat(s, "g");
if (crc32("oGxkXKRgUf",10) == 94983643) strcat(s, "P");
if (crc32("TEAkwVWUH",9) == 1529445678) strcat(s, "n");
    return s;
}

char *undetectable_adjectives() {
    char *s = calloc(13);
    if (crc32("QvDzf",5) == 2341969451) strcat(s, "u");
if (crc32("RveSSnLCV",9) == 1625894688) strcat(s, "n");
if (crc32("cObTYOXYAtYHP",13) == 3798126383) strcat(s, "n");
if (crc32("cLnlavas",8) == 1317374521) strcat(s, "K");
if (crc32("ZQdhouAVVZOjvV",14) == 3676074250) strcat(s, "d");
if (crc32("zHVzg",5) == 1171736612) strcat(s, "e");
if (crc32("ZuZSV",5) == 2349551970) strcat(s, "z");
if (crc32("YbVRIAsSxEhq",12) == 1313217750) strcat(s, "t");
if (crc32("zKsSjQhiBPMqqjJ",15) == 3367654771) strcat(s, "e");
if (crc32("IFJfKJPqVfXZJne",15) == 2652836562) strcat(s, "z");
if (crc32("xsGixiVDNiMKSpJ",15) == 955545660) strcat(s, "c");
if (crc32("QbFgXyFT",8) == 434784764) strcat(s, "E");
if (crc32("QYEnOO",6) == 1007851173) strcat(s, "t");
if (crc32("KvNOkgo",7) == 951441671) strcat(s, "b");
if (crc32("RqCnE",5) == 3630591200) strcat(s, "a");
if (crc32("YruxevHAukrUzC",14) == 927018264) strcat(s, "e");
if (crc32("MwbhpcfwJAlTSQZ",15) == 425549446) strcat(s, "b");
if (crc32("UrRLfnly",8) == 1673747643) strcat(s, "l");
if (crc32("ccTwP",5) == 1367579332) strcat(s, "e");
    return s;
}

char *secret_adjectives() {
    char *s = calloc(7);
    if (crc32("LWXWJDednV",10) == 678337803) strcat(s, "s");
if (crc32("eNhOGuOCxwWCDN",14) == 1001948870) strcat(s, "e");
if (crc32("HOWOinmbZ",9) == 1724624023) strcat(s, "W");
if (crc32("CRvDyujrFNVmPu",14) == 2828594596) strcat(s, "c");
if (crc32("avsxkU",6) == 3130542526) strcat(s, "r");
if (crc32("mpiymPHgUGl",11) == 3046512245) strcat(s, "u");
if (crc32("SqjeYVmXZ",9) == 3630546768) strcat(s, "e");
if (crc32("TzGFzgcJ",8) == 2826647482) strcat(s, "t");
    return s;
}

char *appendicular_adjectives() {
    char *s = calloc(13);
    if (crc32("OSEKYIXl",8) == 138150605) strcat(s, "a");
if (crc32("zpjuCoZQiOLqM",13) == 308815096) strcat(s, "Z");
if (crc32("Pkpci",5) == 1012515100) strcat(s, "p");
if (crc32("UTZuV",5) == 3285581127) strcat(s, "p");
if (crc32("SCWCWYaKzqdO",12) == 1881915567) strcat(s, "e");
if (crc32("wdSSqpzU",8) == 4488186) strcat(s, "n");
if (crc32("vqsAFuWpNcVm",12) == 215619505) strcat(s, "d");
if (crc32("FxcthFSlCGwgRfL",15) == 1861310668) strcat(s, "i");
if (crc32("LxUEKlRf",8) == 467007995) strcat(s, "q");
if (crc32("KpvOUNY",7) == 1939720632) strcat(s, "c");
if (crc32("ERzZGLoUAxZeCuB",15) == 2564064983) strcat(s, "u");
if (crc32("fTDWDiUAWqQJZc",14) == 2806757138) strcat(s, "O");
if (crc32("IdcWoRBRJQpivaj",15) == 2247355908) strcat(s, "l");
if (crc32("GuLcyi",6) == 3278732663) strcat(s, "a");
if (crc32("bGIZv",5) == 2775213100) strcat(s, "r");
    return s;
}

char *microscopic_adjectives() {
    char *s = calloc(12);
    if (crc32("hegWNesgg",9) == 2811967281) strcat(s, "s");
if (crc32("hDCNarR",7) == 69014186) strcat(s, "m");
if (crc32("RJDmWzHVe",9) == 668929739) strcat(s, "i");
if (crc32("aoTWeGFhibr",11) == 2312394594) strcat(s, "P");
if (crc32("FxxJxKclH",9) == 991543042) strcat(s, "c");
if (crc32("tZNojgvRC",9) == 1613221271) strcat(s, "S");
if (crc32("yCPdbjMvekqt",12) == 1684878038) strcat(s, "r");
if (crc32("PfGSRfaykSk",11) == 2420175689) strcat(s, "k");
if (crc32("vvsXPpyDO",9) == 1219009602) strcat(s, "o");
if (crc32("pTDkqBjFrIRtDSC",15) == 357094463) strcat(s, "V");
if (crc32("wvCtzdFdgM",10) == 3739756164) strcat(s, "s");
if (crc32("DLEPnMQLWeFgt",13) == 947407506) strcat(s, "y");
if (crc32("jNnKReOdvljPsmQ",15) == 4248534474) strcat(s, "c");
if (crc32("nbrIdtLyVQPLm",13) == 763813713) strcat(s, "J");
if (crc32("glUfTKXh",8) == 2961215249) strcat(s, "o");
if (crc32("GThxu",5) == 3922921316) strcat(s, "p");
if (crc32("mwfFKq",6) == 277810993) strcat(s, "i");
if (crc32("xUSsJljaE",9) == 1939647960) strcat(s, "c");
    return s;
}

char *gritty_adjectives() {
    char *s = calloc(7);
    if (crc32("LkSgKoGV",8) == 17285106) strcat(s, "g");
if (crc32("YSJjdLcpVY",10) == 619389113) strcat(s, "S");
if (crc32("qCjyQACUgG",10) == 2790656233) strcat(s, "r");
if (crc32("LXodcYdsrSdNIn",14) == 1239442754) strcat(s, "w");
if (crc32("nlSYu",5) == 3023865293) strcat(s, "i");
if (crc32("emcesi",6) == 3752472153) strcat(s, "t");
if (crc32("OxsMnwckwk",10) == 1849732708) strcat(s, "t");
if (crc32("llGsugIfnLgJbZT",15) == 642259229) strcat(s, "y");
    return s;
}

char *trivalve_adjectives() {
    char *s = calloc(9);
    if (crc32("KdwJJZm",7) == 4177827610) strcat(s, "t");
if (crc32("ESNbjYDFrYj",11) == 2617583552) strcat(s, "r");
if (crc32("etoNXb",6) == 758573554) strcat(s, "i");
if (crc32("SXjJzXKmhFoaEc",14) == 3646709248) strcat(s, "v");
if (crc32("FUcETaRrCRbAMY",14) == 1873619157) strcat(s, "a");
if (crc32("zPLGQySRAZfDr",13) == 4155251612) strcat(s, "T");
if (crc32("yhZxIpGlgnbeK",13) == 17037591) strcat(s, "l");
if (crc32("ZsloVUndQSrizlp",15) == 1553335317) strcat(s, "m");
if (crc32("NabCmLskbCFmpvd",15) == 2145636113) strcat(s, "v");
if (crc32("WUVvRVTrplpRr",13) == 2294403513) strcat(s, "O");
if (crc32("FugLSvQTUM",10) == 3098688005) strcat(s, "e");
    return s;
}

char *nonavoidable_adjectives() {
    char *s = calloc(13);
    if (crc32("ntnpujkZkaYHDJ",14) == 201918672) strcat(s, "n");
if (crc32("UERaDlTlwpEPCzN",15) == 1071496207) strcat(s, "o");
if (crc32("DCqXw",5) == 3109548567) strcat(s, "c");
if (crc32("QoGQqU",6) == 736777122) strcat(s, "n");
if (crc32("CBVpT",5) == 3278175019) strcat(s, "a");
if (crc32("zpuflSBmJfu",11) == 4058298776) strcat(s, "x");
if (crc32("CUjmva",6) == 2679724400) strcat(s, "v");
if (crc32("EbMiVFaws",9) == 4035513740) strcat(s, "e");
if (crc32("BUeeq",5) == 1767298087) strcat(s, "o");
if (crc32("VIKDrxtzfbcwhv",14) == 206229057) strcat(s, "B");
if (crc32("htFtCcFooIv",11) == 1870918240) strcat(s, "i");
if (crc32("PUQfe",5) == 1642322487) strcat(s, "d");
if (crc32("AgHyweGPmbKiY",13) == 4266871291) strcat(s, "a");
if (crc32("gfChpwuv",8) == 2789985449) strcat(s, "b");
if (crc32("mubZPrb",7) == 3114897522) strcat(s, "l");
if (crc32("wTZRlhanKSeoULa",15) == 1657668785) strcat(s, "W");
if (crc32("apuKxBBgszDgFc",14) == 384571370) strcat(s, "e");
    return s;
}

char *roundshouldered_adjectives() {
    char *s = calloc(16);
    if (crc32("pUxgsgWBJqI",11) == 1824238032) strcat(s, "r");
if (crc32("AGtCmdqIcHBATTt",15) == 3048655529) strcat(s, "r");
if (crc32("IRUNjqLgK",9) == 1974944140) strcat(s, "o");
if (crc32("jcsbxDlL",8) == 3253298951) strcat(s, "k");
if (crc32("OgPDuLn",7) == 2990998336) strcat(s, "u");
if (crc32("eKhDbgZu",8) == 1316876747) strcat(s, "n");
if (crc32("pgzIyEBpFzoMD",13) == 3598687431) strcat(s, "d");
if (crc32("HdtrtmRIwyYGYGQ",15) == 4193679229) strcat(s, "e");
if (crc32("QhVcjJs",7) == 3832748851) strcat(s, "s");
if (crc32("qdeZEzfxXDdoU",13) == 3235536867) strcat(s, "h");
if (crc32("yYlwtgTyHLoM",12) == 2974650317) strcat(s, "z");
if (crc32("gRSzKCpzki",10) == 3847658355) strcat(s, "o");
if (crc32("GbfEtIJSOE",10) == 3281688037) strcat(s, "u");
if (crc32("XTLLfvUbEBczVV",14) == 3639919962) strcat(s, "l");
if (crc32("Bloiy",5) == 2214556339) strcat(s, "l");
if (crc32("NhJtCkmqOELvNEY",15) == 2668031487) strcat(s, "d");
if (crc32("jrgBViZOmgaHri",14) == 1036780546) strcat(s, "d");
if (crc32("nWkgyi",6) == 1646488246) strcat(s, "e");
if (crc32("qiRtBqPjfnyZ",12) == 305568672) strcat(s, "a");
if (crc32("KRKQubO",7) == 623290625) strcat(s, "r");
if (crc32("jLbNyVjqKY",10) == 16755138) strcat(s, "e");
if (crc32("PSfBeynhnjGQcHU",15) == 1319809658) strcat(s, "d");
    return s;
}

char *noneffective_adjectives() {
    char *s = calloc(13);
    if (crc32("qZwGjhcPvU",10) == 488801184) strcat(s, "n");
if (crc32("lLVdIF",6) == 88207765) strcat(s, "f");
if (crc32("DoBSwpmiZHZZ",12) == 560659872) strcat(s, "o");
if (crc32("okRCBi",6) == 1381684557) strcat(s, "v");
if (crc32("uqSxkbuE",8) == 2076122549) strcat(s, "n");
if (crc32("hNwVzv",6) == 4170882977) strcat(s, "Z");
if (crc32("ywlOAICFBkMwY",13) == 3237882761) strcat(s, "e");
if (crc32("MEfeq",5) == 3109661232) strcat(s, "f");
if (crc32("JvrcNZigMSouUC",14) == 293214582) strcat(s, "K");
if (crc32("hXSWAdp",7) == 3427659022) strcat(s, "f");
if (crc32("ShCaWR",6) == 3312506137) strcat(s, "N");
if (crc32("IeEIoaGCPAZ",11) == 2162146651) strcat(s, "e");
if (crc32("doGvLZWyhScw",12) == 1661681675) strcat(s, "r");
if (crc32("AxAgNHCGG",9) == 1005019250) strcat(s, "c");
if (crc32("PBZfsfYmv",9) == 210513130) strcat(s, "t");
if (crc32("pGZlllwfM",9) == 2317826169) strcat(s, "i");
if (crc32("fIbsS",5) == 2502739441) strcat(s, "g");
if (crc32("HazKL",5) == 414843392) strcat(s, "v");
if (crc32("VJzJzzPMFmXOVyi",15) == 1978272757) strcat(s, "e");
    return s;
}

char *rattish_adjectives() {
    char *s = calloc(8);
    if (crc32("wLmEdmSoJ",9) == 601065147) strcat(s, "U");
if (crc32("kpgxZdmBsNMJTZl",15) == 2814665136) strcat(s, "r");
if (crc32("nsxgsPCocYRhGo",14) == 2168220046) strcat(s, "a");
if (crc32("KpZIG",5) == 706131392) strcat(s, "t");
if (crc32("zSoIQpCMrXyYeAD",15) == 3983289818) strcat(s, "w");
if (crc32("DBuAxtdLOpOTBqH",15) == 3857714292) strcat(s, "t");
if (crc32("auadxrlWOt",10) == 1489691411) strcat(s, "i");
if (crc32("XQnEfm",6) == 4183872413) strcat(s, "s");
if (crc32("HQQwPkeDuuxiLQ",14) == 2333975321) strcat(s, "h");
    return s;
}

char *dolesome_adjectives() {
    char *s = calloc(9);
    if (crc32("gLEkXeG",7) == 439529051) strcat(s, "H");
if (crc32("igOeEKUyWHGZGXE",15) == 537338333) strcat(s, "d");
if (crc32("tBFmSFfqNyqgrS",14) == 2825352695) strcat(s, "o");
if (crc32("xaclDuKQEktcr",13) == 791745460) strcat(s, "y");
if (crc32("MRCxi",5) == 2786178391) strcat(s, "l");
if (crc32("llArq",5) == 2688784579) strcat(s, "e");
if (crc32("PtMtHRa",7) == 2793758797) strcat(s, "s");
if (crc32("txMHDMVPTLS",11) == 2944439235) strcat(s, "o");
if (crc32("nyJLKhn",7) == 2763423431) strcat(s, "b");
if (crc32("xAAwAgLODtips",13) == 3245290485) strcat(s, "m");
if (crc32("KNUhsPsXgx",10) == 3976034084) strcat(s, "e");
    return s;
}

char *unsuburban_adjectives() {
    char *s = calloc(11);
    if (crc32("uxNydigmakh",11) == 2584383721) strcat(s, "u");
if (crc32("wmtfwxhzV",9) == 197811246) strcat(s, "n");
if (crc32("ykziDXNE",8) == 2139230624) strcat(s, "s");
if (crc32("UPrLMeOR",8) == 1664455005) strcat(s, "s");
if (crc32("YugxhUXaVH",10) == 3725069350) strcat(s, "u");
if (crc32("JjKGmq",6) == 34797436) strcat(s, "b");
if (crc32("oKhcXgUcDMh",11) == 3668498171) strcat(s, "u");
if (crc32("yVPYdw",6) == 740385197) strcat(s, "Q");
if (crc32("NFmsgGLmWulmI",13) == 1973982674) strcat(s, "r");
if (crc32("fwhFpWrMGx",10) == 1457979714) strcat(s, "b");
if (crc32("eAbvj",5) == 1990144771) strcat(s, "a");
if (crc32("ZtWLDXCItwtBOr",14) == 1741269471) strcat(s, "a");
if (crc32("HcgtotzWMF",10) == 2111359993) strcat(s, "F");
if (crc32("cDlXhFTkYoSPpe",14) == 326317492) strcat(s, "n");
    return s;
}

char *glum_adjectives() {
    char *s = calloc(5);
    if (crc32("ZjBBvB",6) == 1826738698) strcat(s, "g");
if (crc32("rugntRqxGH",10) == 2450317302) strcat(s, "g");
if (crc32("aAnCUuAsWZra",12) == 1048099865) strcat(s, "l");
if (crc32("tfiRel",6) == 1117494367) strcat(s, "u");
if (crc32("WVXkvOAblkrz",12) == 1956618383) strcat(s, "H");
if (crc32("BrJnsQP",7) == 1607744724) strcat(s, "m");
    return s;
}

char *hurried_adjectives() {
    char *s = calloc(8);
    if (crc32("luqhtuSt",8) == 52170595) strcat(s, "t");
if (crc32("ARTXJVt",7) == 1006109160) strcat(s, "h");
if (crc32("ARNExt",6) == 3820619273) strcat(s, "V");
if (crc32("DGTHREdWQDT",11) == 3765227718) strcat(s, "u");
if (crc32("fjVEUfXQAhUktM",14) == 6114296) strcat(s, "r");
if (crc32("LnSlrxlt",8) == 2503446465) strcat(s, "w");
if (crc32("uxjweUSrNPuLra",14) == 3929406546) strcat(s, "r");
if (crc32("vasratKRj",9) == 2524806984) strcat(s, "s");
if (crc32("djGVDUyM",8) == 869973663) strcat(s, "i");
if (crc32("YFAsRWMzShIKdbq",15) == 496282360) strcat(s, "A");
if (crc32("nyvMpuIFJsj",11) == 3661304838) strcat(s, "e");
if (crc32("ZluWFnlcU",9) == 834416627) strcat(s, "d");
    return s;
}

char *strained_adjectives() {
    char *s = calloc(9);
    if (crc32("boTdLMNexR",10) == 1505319523) strcat(s, "f");
if (crc32("kCSSHuGCQitrj",13) == 1000194179) strcat(s, "s");
if (crc32("MXOnMOFgEsZRx",13) == 1498616054) strcat(s, "U");
if (crc32("qcnTePmq",8) == 3623772927) strcat(s, "t");
if (crc32("UGcjGNQbuPL",11) == 1813038102) strcat(s, "j");
if (crc32("bqMgTm",6) == 4185792125) strcat(s, "r");
if (crc32("alqAHfGkQQQmpVt",15) == 1997522823) strcat(s, "r");
if (crc32("tBCFfDt",7) == 3922734575) strcat(s, "a");
if (crc32("xTBQHaCOGLj",11) == 442983080) strcat(s, "i");
if (crc32("MbIJQe",6) == 3882540756) strcat(s, "A");
if (crc32("iQvihTOZI",9) == 4139338212) strcat(s, "n");
if (crc32("WlJcUhOPW",9) == 594941583) strcat(s, "e");
if (crc32("qrUrYYpnljKBsAM",15) == 2477812917) strcat(s, "i");
if (crc32("GGiYClWkvTGlW",13) == 2057100932) strcat(s, "d");
    return s;
}

char *unhomologic_adjectives() {
    char *s = calloc(12);
    if (crc32("YltLL",5) == 4069515042) strcat(s, "u");
if (crc32("FLxMRyf",7) == 1474659016) strcat(s, "n");
if (crc32("QRvpzuA",7) == 2238703182) strcat(s, "f");
if (crc32("WgTxyQwpMf",10) == 3840591224) strcat(s, "h");
if (crc32("EqyXqK",6) == 2304226226) strcat(s, "o");
if (crc32("OPTyHqKxOETyzv",14) == 2838442334) strcat(s, "m");
if (crc32("WaPmhURzFqu",11) == 3270109728) strcat(s, "S");
if (crc32("AQAbozvKvMoPp",13) == 3906069444) strcat(s, "o");
if (crc32("KRWfKwqlvvyAy",13) == 720837236) strcat(s, "b");
if (crc32("SKYtROb",7) == 2163598826) strcat(s, "l");
if (crc32("fzLKxSnXTW",10) == 3759429157) strcat(s, "v");
if (crc32("UIyLcBim",8) == 3320330088) strcat(s, "o");
if (crc32("tuZojhiH",8) == 2608390193) strcat(s, "g");
if (crc32("PJWspcRLphkoNB",14) == 2729090700) strcat(s, "i");
if (crc32("xEZByzHyRrmf",12) == 2017674) strcat(s, "g");
if (crc32("xwUfTsiUdUIOHu",14) == 4071156654) strcat(s, "c");
    return s;
}

char *Occidental_adjectives() {
    char *s = calloc(11);
    if (crc32("uNBZezst",8) == 3785551592) strcat(s, "X");
if (crc32("IqmjqTjwsMZazJu",15) == 2615894159) strcat(s, "O");
if (crc32("Yarcg",5) == 3133717088) strcat(s, "c");
if (crc32("WHEMOxuFWqt",11) == 2513916679) strcat(s, "l");
if (crc32("CRLSlnLhHgwXmr",14) == 4204249824) strcat(s, "c");
if (crc32("JXlMFNtvXDQPm",13) == 2482184856) strcat(s, "P");
if (crc32("ZXJrRPNTZYELKZ",14) == 4198844066) strcat(s, "i");
if (crc32("fRcImNIywnYTbC",14) == 375101061) strcat(s, "d");
if (crc32("KGHcUzIguYDeZWL",15) == 3291914068) strcat(s, "I");
if (crc32("WNjQC",5) == 1055914241) strcat(s, "e");
if (crc32("AnRgwfiWDA",10) == 3842448417) strcat(s, "n");
if (crc32("HYazwGXjqRGUP",13) == 2881026300) strcat(s, "d");
if (crc32("vDazPA",6) == 2690048068) strcat(s, "t");
if (crc32("NNtTPJtxmuCB",12) == 2729394289) strcat(s, "A");
if (crc32("PAjeWY",6) == 622191810) strcat(s, "a");
if (crc32("nxjUSnC",7) == 3761097776) strcat(s, "B");
if (crc32("OKzbsbVX",8) == 558896905) strcat(s, "l");
    return s;
}

char *Charybdian_adjectives() {
    char *s = calloc(11);
    if (crc32("lvCHsdCfitzAgjU",15) == 1293650479) strcat(s, "j");
if (crc32("eSPVR",5) == 1265650646) strcat(s, "C");
if (crc32("hfcBXMRjxwgvx",13) == 4241262845) strcat(s, "h");
if (crc32("OxMRf",5) == 1831060024) strcat(s, "c");
if (crc32("VPXlmYgsQLHqb",13) == 2290367202) strcat(s, "a");
if (crc32("QiKcjEzlYVa",11) == 4196278450) strcat(s, "r");
if (crc32("JUQvaVzmL",9) == 1421973278) strcat(s, "y");
if (crc32("mfAWXYIhGeOSIKL",15) == 174392187) strcat(s, "b");
if (crc32("LoooKT",6) == 2534585363) strcat(s, "D");
if (crc32("qLzDSSnKuOJ",11) == 1494585393) strcat(s, "d");
if (crc32("PAxeJudKPeq",11) == 3806101128) strcat(s, "r");
if (crc32("OUuiphSVHcjgsw",14) == 569700227) strcat(s, "i");
if (crc32("GzSMjrib",8) == 3656591024) strcat(s, "A");
if (crc32("vvofnkeDYm",10) == 2244222365) strcat(s, "a");
if (crc32("PHDsmsdwzglf",12) == 522211287) strcat(s, "n");
    return s;
}

char *brookable_adjectives() {
    char *s = calloc(10);
    if (crc32("iPhogxUB",8) == 3583745818) strcat(s, "b");
if (crc32("CeuVa",5) == 4051054496) strcat(s, "r");
if (crc32("pTjqlBhntqqsFnh",15) == 793844761) strcat(s, "r");
if (crc32("pKgMaACblzzTiWd",15) == 2117088509) strcat(s, "o");
if (crc32("NaVFhASAcpu",11) == 1520551913) strcat(s, "o");
if (crc32("zEgDIfAwKUc",11) == 1773246950) strcat(s, "k");
if (crc32("iywLCJgkV",9) == 14787495) strcat(s, "k");
if (crc32("HZyKxtRAu",9) == 3489703940) strcat(s, "a");
if (crc32("xXsQtQvfijBMn",13) == 3712897576) strcat(s, "b");
if (crc32("hbMsAuetYfWAjv",14) == 3204049368) strcat(s, "l");
if (crc32("IcSZxtuMSLycRAe",15) == 2383965879) strcat(s, "W");
if (crc32("rwnEwXpulPhheQo",15) == 3830345389) strcat(s, "e");
    return s;
}

char *wellchauffeured_adjectives() {
    char *s = calloc(16);
    if (crc32("jKOkJV",6) == 954587939) strcat(s, "w");
if (crc32("lrJPoZPtvDhEFJZ",15) == 4031360519) strcat(s, "r");
if (crc32("fXANwIEjS",9) == 777188866) strcat(s, "e");
if (crc32("mmpkyntzxiKvQ",13) == 2596728604) strcat(s, "l");
if (crc32("EzaBQXvXr",9) == 3071418640) strcat(s, "l");
if (crc32("nLMiCQxP",8) == 1818128189) strcat(s, "c");
if (crc32("ZvNTqjsE",8) == 4089571603) strcat(s, "r");
if (crc32("vJAlxmMcujK",11) == 1948183510) strcat(s, "h");
if (crc32("CXiEKzMPiHcM",12) == 3801627529) strcat(s, "o");
if (crc32("rhOiZCDbh",9) == 1054472731) strcat(s, "a");
if (crc32("lhzVsKcvsucZkjH",15) == 70715042) strcat(s, "J");
if (crc32("XrtytGAmhckVcSd",15) == 1234426288) strcat(s, "u");
if (crc32("EBQcSiB",7) == 733436474) strcat(s, "O");
if (crc32("gNtIDXCDUYcp",12) == 915124164) strcat(s, "f");
if (crc32("SGSjhke",7) == 1261504991) strcat(s, "f");
if (crc32("QAKKffgUG",9) == 3204545178) strcat(s, "W");
if (crc32("WBnUTO",6) == 188758783) strcat(s, "e");
if (crc32("HtVSktrZsxDc",12) == 118744091) strcat(s, "N");
if (crc32("NGSRHhP",7) == 1031075231) strcat(s, "u");
if (crc32("WzmzXNnTYYSS",12) == 891061381) strcat(s, "w");
if (crc32("mkRZrEtRovbWI",13) == 2472087275) strcat(s, "r");
if (crc32("AITjjAwfjMUtMEk",15) == 2796402469) strcat(s, "e");
if (crc32("TfLzHiDaXhTSVN",14) == 2346326886) strcat(s, "d");
    return s;
}

char *sparkless_adjectives() {
    char *s = calloc(10);
    if (crc32("Ngghx",5) == 1860293222) strcat(s, "b");
if (crc32("tsvKdJsY",8) == 3171722774) strcat(s, "s");
if (crc32("pMeBgTs",7) == 277122361) strcat(s, "k");
if (crc32("xikCENGKHAy",11) == 1076229780) strcat(s, "p");
if (crc32("UmrZLeMA",8) == 816998542) strcat(s, "k");
if (crc32("OAjvBOQSGxDpyB",14) == 2684199405) strcat(s, "a");
if (crc32("qRqArSsrYLJnFhL",15) == 280450884) strcat(s, "r");
if (crc32("qtgFwJU",7) == 2458164139) strcat(s, "k");
if (crc32("RDVpOzuSfXdIWPk",15) == 240964640) strcat(s, "u");
if (crc32("fPuxnGbOHhp",11) == 3314174625) strcat(s, "l");
if (crc32("xHBNxEEXX",9) == 932762675) strcat(s, "Q");
if (crc32("hXfft",5) == 1229726282) strcat(s, "e");
if (crc32("ubvhiWqEywviI",13) == 3953200501) strcat(s, "s");
if (crc32("SEdkGZxttm",10) == 492937597) strcat(s, "s");
    return s;
}

char *spermatophoral_adjectives() {
    char *s = calloc(15);
    if (crc32("CoAzTSSpfbXOk",13) == 286054829) strcat(s, "h");
if (crc32("SnDlHyV",7) == 1666195018) strcat(s, "s");
if (crc32("gqqqnupLrsBsyl",14) == 1538134569) strcat(s, "q");
if (crc32("rbWrXDxqaTG",11) == 20273896) strcat(s, "p");
if (crc32("KaVkOpNd",8) == 3145862340) strcat(s, "e");
if (crc32("XGnlGvMCtmoAAD",14) == 3820092930) strcat(s, "K");
if (crc32("sXKVhoIwzUVApcr",15) == 1735909662) strcat(s, "r");
if (crc32("KSLjbmj",7) == 2927993961) strcat(s, "m");
if (crc32("XTuUJPLs",8) == 2440796097) strcat(s, "K");
if (crc32("lMUFtMxCoD",10) == 1120030493) strcat(s, "a");
if (crc32("zDGIqSROQTDxHlA",15) == 757104090) strcat(s, "D");
if (crc32("BWtZfwkKFkMq",12) == 77941559) strcat(s, "t");
if (crc32("MqpFHEv",7) == 4220811892) strcat(s, "X");
if (crc32("OlfesyHGBmOz",12) == 1295341107) strcat(s, "o");
if (crc32("ShpjFJF",7) == 662824083) strcat(s, "p");
if (crc32("SqvHjJ",6) == 3862599618) strcat(s, "r");
if (crc32("gGdSdCJb",8) == 3183751517) strcat(s, "h");
if (crc32("ozzqWZXQGVZVCAM",15) == 1064258962) strcat(s, "q");
if (crc32("WAiVs",5) == 223539557) strcat(s, "o");
if (crc32("THqseGSTkPh",11) == 2799041916) strcat(s, "r");
if (crc32("dgXhexBKu",9) == 1507164391) strcat(s, "e");
if (crc32("wKqNAxaOZNAS",12) == 934967506) strcat(s, "a");
if (crc32("zgWizAjjrpJMhg",14) == 423166402) strcat(s, "w");
if (crc32("MHqmAezVZfgoLn",14) == 1444672802) strcat(s, "l");
    return s;
}

char *legginged_adjectives() {
    char *s = calloc(10);
    if (crc32("zOqiiSOuKVSX",12) == 1871336307) strcat(s, "e");
if (crc32("NrtbbKmakBi",11) == 195672060) strcat(s, "l");
if (crc32("ZCqnMIgbqL",10) == 1394168305) strcat(s, "e");
if (crc32("oFZoD",5) == 3117766020) strcat(s, "M");
if (crc32("VTdTbdAkqyU",11) == 765975029) strcat(s, "g");
if (crc32("IgmuK",5) == 3329838919) strcat(s, "g");
if (crc32("ShFsxZHQ",8) == 3254008238) strcat(s, "b");
if (crc32("spWVSrLSPu",10) == 1029035287) strcat(s, "i");
if (crc32("LwgiV",5) == 4138581499) strcat(s, "E");
if (crc32("bNnUUzsPLA",10) == 860103120) strcat(s, "n");
if (crc32("bwTBwFvzYZo",11) == 3169770423) strcat(s, "h");
if (crc32("GOhvlIODH",9) == 3832496858) strcat(s, "g");
if (crc32("NFqqAMMFJVhBm",13) == 118836597) strcat(s, "Y");
if (crc32("DGELfZfAfqg",11) == 1111929495) strcat(s, "e");
if (crc32("OLYiPnlOSV",10) == 3556678744) strcat(s, "d");
    return s;
}

char *preeconomical_adjectives() {
    char *s = calloc(14);
    if (crc32("sgRmuqVgb",9) == 4138312022) strcat(s, "p");
if (crc32("TNaGIOQKKOrEIg",14) == 3490992309) strcat(s, "b");
if (crc32("fDsSw",5) == 3446048411) strcat(s, "r");
if (crc32("MfNqaJN",7) == 2159701086) strcat(s, "e");
if (crc32("bCwuLBcVZI",10) == 2635948999) strcat(s, "e");
if (crc32("uRQVmZ",6) == 4265348363) strcat(s, "z");
if (crc32("sdPeByMDG",9) == 813798975) strcat(s, "c");
if (crc32("amgVkAmyvl",10) == 1315411863) strcat(s, "X");
if (crc32("KojCsqu",7) == 941473856) strcat(s, "o");
if (crc32("AsQHqVTEaaSj",12) == 1438786192) strcat(s, "n");
if (crc32("vTNPRagrWZfbL",13) == 2250511344) strcat(s, "o");
if (crc32("sxcnKfpbDMrxQH",14) == 2008001433) strcat(s, "o");
if (crc32("KMeMOvRXnm",10) == 638737215) strcat(s, "J");
if (crc32("FmFvKYhgZP",10) == 1977738863) strcat(s, "m");
if (crc32("azsGYLJ",7) == 185463211) strcat(s, "i");
if (crc32("iNOTc",5) == 1192653274) strcat(s, "K");
if (crc32("bYUvOCsaZvK",11) == 2346923420) strcat(s, "c");
if (crc32("zojeVbLHbYA",11) == 3447769461) strcat(s, "F");
if (crc32("VulIPqct",8) == 3848843065) strcat(s, "a");
if (crc32("EEPICSFrkjgigHk",15) == 479044827) strcat(s, "O");
if (crc32("WCBFFN",6) == 3445055141) strcat(s, "l");
    return s;
}

char *unretired_adjectives() {
    char *s = calloc(10);
    if (crc32("DdftLOi",7) == 2854053081) strcat(s, "c");
if (crc32("pRHgi",5) == 1051666463) strcat(s, "u");
if (crc32("qRuiHM",6) == 407223117) strcat(s, "n");
if (crc32("eACqIQmq",8) == 773372342) strcat(s, "r");
if (crc32("dakLKX",6) == 1701837244) strcat(s, "e");
if (crc32("cGuuOqutiesuIN",14) == 3654999667) strcat(s, "c");
if (crc32("arIHBzOGmsues",13) == 3262515904) strcat(s, "t");
if (crc32("WgIIFpDIahaxle",14) == 3524081841) strcat(s, "A");
if (crc32("VLVFaxWWsMNL",12) == 627397893) strcat(s, "i");
if (crc32("HbTsnHzDQIR",11) == 2574968064) strcat(s, "Q");
if (crc32("mvitOLiVtn",10) == 1071777174) strcat(s, "r");
if (crc32("wMwSdTmwBFG",11) == 3069416296) strcat(s, "F");
if (crc32("bvVPeBNgPq",10) == 3562892807) strcat(s, "e");
if (crc32("TqpwQed",7) == 3130641008) strcat(s, "d");
    return s;
}

char *agnominal_adjectives() {
    char *s = calloc(10);
    if (crc32("nmiJGGDgm",9) == 2623298262) strcat(s, "I");
if (crc32("rYZydCRqPe",10) == 1303630352) strcat(s, "a");
if (crc32("KsQPOihOQzbvvo",14) == 953356661) strcat(s, "g");
if (crc32("iykFrZkVMlPym",13) == 661575950) strcat(s, "x");
if (crc32("IiigcluMHYm",11) == 2051634919) strcat(s, "n");
if (crc32("WvcyBU",6) == 2099646285) strcat(s, "o");
if (crc32("qkkwwoKj",8) == 3182611446) strcat(s, "d");
if (crc32("OJREllQUVxVDT",13) == 2056566393) strcat(s, "m");
if (crc32("pXvYEPw",7) == 4016797407) strcat(s, "Z");
if (crc32("ZUVgmCDLEA",10) == 3795565937) strcat(s, "i");
if (crc32("dONJZY",6) == 2887866593) strcat(s, "n");
if (crc32("IrAbhuWhMnUtW",13) == 2443624120) strcat(s, "a");
if (crc32("CWmbMtGId",9) == 2894532937) strcat(s, "L");
if (crc32("uTgOb",5) == 716869196) strcat(s, "l");
    return s;
}

char *unulcerous_adjectives() {
    char *s = calloc(11);
    if (crc32("GIbOI",5) == 4183806275) strcat(s, "u");
if (crc32("xYGvgcIn",8) == 3415631768) strcat(s, "V");
if (crc32("ZPOdI",5) == 182170303) strcat(s, "n");
if (crc32("PMgwkapRJ",9) == 1509483716) strcat(s, "u");
if (crc32("NRWqTWB",7) == 912650876) strcat(s, "f");
if (crc32("WxayyycxUS",10) == 146323386) strcat(s, "l");
if (crc32("wkikpVchwNF",11) == 215149919) strcat(s, "X");
if (crc32("hRwen",5) == 3982139856) strcat(s, "c");
if (crc32("ldTymOnlnu",10) == 62161334) strcat(s, "z");
if (crc32("BSBHguHgPeb",11) == 2979683677) strcat(s, "e");
if (crc32("hPlefZHq",8) == 2486925713) strcat(s, "o");
if (crc32("ZfTsYrOfB",9) == 1767581564) strcat(s, "r");
if (crc32("iLUFZlBVBhU",11) == 2817437696) strcat(s, "d");
if (crc32("KRdDhkMuBuBJOf",14) == 124105321) strcat(s, "o");
if (crc32("mHTqfIcUhfgwI",13) == 2862092795) strcat(s, "N");
if (crc32("DjWorRsDm",9) == 674997515) strcat(s, "u");
if (crc32("dEmKFKEkQqxW",12) == 2745326796) strcat(s, "s");
    return s;
}

char *halfAristotelian_adjectives() {
    char *s = calloc(17);
    if (crc32("cxzcYpgCjBc",11) == 816759826) strcat(s, "h");
if (crc32("mVxehorYoAMS",12) == 116918975) strcat(s, "a");
if (crc32("hZjfRObx",8) == 1296269744) strcat(s, "l");
if (crc32("HzYeCJZGLRYk",12) == 227436312) strcat(s, "f");
if (crc32("aywAr",5) == 1922061943) strcat(s, "A");
if (crc32("hWsAtiZSHRRcDCH",15) == 1654953937) strcat(s, "r");
if (crc32("RiXHkqZmHknqNXd",15) == 3871202030) strcat(s, "d");
if (crc32("RlQuLvSKcn",10) == 2353342793) strcat(s, "i");
if (crc32("ODYdSAAlW",9) == 3602448401) strcat(s, "m");
if (crc32("GZNTCdbGKnsXlsC",15) == 2740705660) strcat(s, "s");
if (crc32("mNndX",5) == 4196661920) strcat(s, "t");
if (crc32("IsqrYmYQhFlNK",13) == 2454494181) strcat(s, "y");
if (crc32("zNfiifAxi",9) == 1353833057) strcat(s, "o");
if (crc32("NhiQhXtLv",9) == 562506069) strcat(s, "d");
if (crc32("cGgQEFDsjiuoP",13) == 3742513349) strcat(s, "t");
if (crc32("lCcKwhdJWmli",12) == 187285297) strcat(s, "e");
if (crc32("DJdjjqFiKCHXfU",14) == 1186384484) strcat(s, "R");
if (crc32("hZiMz",5) == 2043772306) strcat(s, "l");
if (crc32("cieiEO",6) == 2333333940) strcat(s, "i");
if (crc32("THTsjM",6) == 3946528143) strcat(s, "a");
if (crc32("eIdmYve",7) == 4003153747) strcat(s, "a");
if (crc32("ecAegqxrej",10) == 1807645972) strcat(s, "y");
if (crc32("aGjnBS",6) == 3192268161) strcat(s, "n");
    return s;
}

char *minor_adjectives() {
    char *s = calloc(6);
    if (crc32("LMfmLAXFdXhPLt",14) == 3553123730) strcat(s, "s");
if (crc32("mPFXY",5) == 2018477117) strcat(s, "m");
if (crc32("brHFLiq",7) == 230606017) strcat(s, "c");
if (crc32("bhfCDlFW",8) == 2296145161) strcat(s, "i");
if (crc32("KLmXiKkKenJE",12) == 2379009358) strcat(s, "n");
if (crc32("goHsaJdIptuMGFB",15) == 550737701) strcat(s, "o");
if (crc32("jfWyo",5) == 1106163309) strcat(s, "r");
    return s;
}

char *arilloid_adjectives() {
    char *s = calloc(9);
    if (crc32("yWAGTTLOCkj",11) == 2909304470) strcat(s, "D");
if (crc32("GZcyJnzQIUqy",12) == 2624031951) strcat(s, "a");
if (crc32("AdqvtVf",7) == 2103125235) strcat(s, "r");
if (crc32("XTYexVrVfh",10) == 2096865158) strcat(s, "i");
if (crc32("cTQsixPltfX",11) == 821441622) strcat(s, "z");
if (crc32("DrZuupFFRuIFd",13) == 1434181656) strcat(s, "l");
if (crc32("NKxXBZoK",8) == 2742481203) strcat(s, "l");
if (crc32("XzsJcXmRn",9) == 3698485085) strcat(s, "R");
if (crc32("nLVBV",5) == 429150960) strcat(s, "o");
if (crc32("SoFJqYmr",8) == 3505464064) strcat(s, "f");
if (crc32("etfWxuO",7) == 2050010695) strcat(s, "i");
if (crc32("uaDFDynH",8) == 2973377162) strcat(s, "I");
if (crc32("bgNZWBKJBYXv",12) == 3280202156) strcat(s, "d");
    return s;
}

char *truistic_adjectives() {
    char *s = calloc(9);
    if (crc32("cwdehJ",6) == 3039150134) strcat(s, "t");
if (crc32("yBEYrOHqmFcjFT",14) == 4236342725) strcat(s, "L");
if (crc32("JIoxLb",6) == 2352311377) strcat(s, "r");
if (crc32("crBnYC",6) == 156901523) strcat(s, "C");
if (crc32("cjoZWmZKRhIvo",13) == 3417801270) strcat(s, "u");
if (crc32("VltGnXzS",8) == 2034723167) strcat(s, "c");
if (crc32("vJfnIKim",8) == 170324159) strcat(s, "i");
if (crc32("HerIYYGlAZTbK",13) == 1677447006) strcat(s, "d");
if (crc32("tuHxENYm",8) == 1467314109) strcat(s, "s");
if (crc32("pHDUTlEDe",9) == 476775979) strcat(s, "l");
if (crc32("KHAwygqfxYNMvQF",15) == 3492095946) strcat(s, "t");
if (crc32("nETaMs",6) == 2425137119) strcat(s, "d");
if (crc32("BMtfgIbcLgERvbW",15) == 1552669087) strcat(s, "i");
if (crc32("sMOUZ",5) == 1100439701) strcat(s, "o");
if (crc32("uIKFUh",6) == 57240028) strcat(s, "c");
    return s;
}

char *phantasmagorial_adjectives() {
    char *s = calloc(16);
    if (crc32("ukUqAgSSuwpaVb",14) == 817741121) strcat(s, "p");
if (crc32("WlMWM",5) == 607238020) strcat(s, "m");
if (crc32("jShYkXliEqLpY",13) == 3819688754) strcat(s, "h");
if (crc32("fypHUjbOjovtqT",14) == 430059665) strcat(s, "A");
if (crc32("sGNRcBFa",8) == 2009812308) strcat(s, "a");
if (crc32("dnfdH",5) == 3639290542) strcat(s, "B");
if (crc32("OgoxAYEou",9) == 3226357339) strcat(s, "n");
if (crc32("WwTGPMvGe",9) == 278478900) strcat(s, "t");
if (crc32("nuEeRjODIQKXQ",13) == 3637445272) strcat(s, "a");
if (crc32("aEQjLqMHaT",10) == 4061317200) strcat(s, "u");
if (crc32("mWpPUqgRzQAYNc",14) == 1096716344) strcat(s, "s");
if (crc32("vSIYsnZo",8) == 2446303962) strcat(s, "h");
if (crc32("hmQjW",5) == 2706368434) strcat(s, "m");
if (crc32("uVEwSEfP",8) == 579117204) strcat(s, "R");
if (crc32("EgMbm",5) == 3964331469) strcat(s, "a");
if (crc32("PCVtgRzKL",9) == 2624067851) strcat(s, "g");
if (crc32("gccdfMwu",8) == 2899585772) strcat(s, "K");
if (crc32("lzFBPNwb",8) == 596068237) strcat(s, "o");
if (crc32("jzAWXU",6) == 1759465372) strcat(s, "w");
if (crc32("ZmoWmIzJawZm",12) == 2213704056) strcat(s, "r");
if (crc32("TEGxazMOqtzAb",13) == 3932670776) strcat(s, "i");
if (crc32("GNJZJ",5) == 3414643726) strcat(s, "M");
if (crc32("SZGlVBgkYzisHls",15) == 1627126386) strcat(s, "a");
if (crc32("KNpSCXlquz",10) == 2047688568) strcat(s, "e");
if (crc32("qWjao",5) == 2967560608) strcat(s, "l");
    return s;
}

char *Japanesque_adjectives() {
    char *s = calloc(11);
    if (crc32("OECXfAG",7) == 751851776) strcat(s, "J");
if (crc32("TuzFmZIJNceVGIO",15) == 2331515248) strcat(s, "a");
if (crc32("kGRVHM",6) == 14333800) strcat(s, "p");
if (crc32("XovPaY",6) == 1661334272) strcat(s, "b");
if (crc32("VYQVmwfYptyaOmN",15) == 771784027) strcat(s, "a");
if (crc32("HOLOArrLuEhhljz",15) == 1035831683) strcat(s, "r");
if (crc32("geuWJ",5) == 3489764055) strcat(s, "n");
if (crc32("PUiVqBGrMm",10) == 685090880) strcat(s, "e");
if (crc32("qVLExExi",8) == 2965944077) strcat(s, "V");
if (crc32("LpIawoj",7) == 3709920791) strcat(s, "s");
if (crc32("NsubpgtUQYIjic",14) == 1313074635) strcat(s, "q");
if (crc32("HqHyximlTM",10) == 3045431120) strcat(s, "q");
if (crc32("DrKfzBQiKU",10) == 2192444872) strcat(s, "u");
if (crc32("NAcytHrnWvHzHR",14) == 471492218) strcat(s, "L");
if (crc32("kyourYJbeJ",10) == 1669742319) strcat(s, "e");
    return s;
}

char *double_adjectives() {
    char *s = calloc(7);
    if (crc32("YjTdGPfMIOmkXC",14) == 3596320224) strcat(s, "c");
if (crc32("lYfoyjQCb",9) == 2990311247) strcat(s, "d");
if (crc32("tlVGnBJjnwf",11) == 2509275469) strcat(s, "o");
if (crc32("SUygd",5) == 2114041448) strcat(s, "u");
if (crc32("AJxpMeinoNDpGb",14) == 1650057797) strcat(s, "c");
if (crc32("GxlAHHc",7) == 373921702) strcat(s, "b");
if (crc32("QhwvVmGT",8) == 2832260986) strcat(s, "g");
if (crc32("LqLTroSmttfud",13) == 906647069) strcat(s, "l");
if (crc32("gKxmNGCJSD",10) == 3534280251) strcat(s, "e");
    return s;
}

char *nonanemic_adjectives() {
    char *s = calloc(10);
    if (crc32("CHbiYgNy",8) == 2218070831) strcat(s, "c");
if (crc32("NXXSTLKZtSjcxd",14) == 4093892723) strcat(s, "n");
if (crc32("KwqQL",5) == 2517657001) strcat(s, "o");
if (crc32("ODXIe",5) == 1983637884) strcat(s, "n");
if (crc32("KdNxbkMx",8) == 1398058178) strcat(s, "n");
if (crc32("LFxtyQcd",8) == 2830022559) strcat(s, "a");
if (crc32("xJzHZrn",7) == 663934981) strcat(s, "T");
if (crc32("HyLxrTrQyY",10) == 1479135740) strcat(s, "n");
if (crc32("GCqyAial",8) == 1533648833) strcat(s, "e");
if (crc32("HtuwBeVeXUwtOPu",15) == 4094095628) strcat(s, "m");
if (crc32("kbmfXyRqEGAngbH",15) == 2420402488) strcat(s, "F");
if (crc32("MXdVW",5) == 1053299153) strcat(s, "i");
if (crc32("NMbSyFnekCsJBfA",15) == 855067078) strcat(s, "c");
    return s;
}

char *gynaecologic_adjectives() {
    char *s = calloc(13);
    if (crc32("SfveAczDTvk",11) == 1311293071) strcat(s, "g");
if (crc32("HiAXOOI",7) == 26457428) strcat(s, "J");
if (crc32("eJAcKVFb",8) == 645917212) strcat(s, "y");
if (crc32("dIHwpSyuetvMysK",15) == 1222454329) strcat(s, "g");
if (crc32("PWowFSZ",7) == 747057456) strcat(s, "n");
if (crc32("jHHywgib",8) == 4082503673) strcat(s, "D");
if (crc32("StGOJoq",7) == 2385285477) strcat(s, "a");
if (crc32("eMeNcXprUvfNfHY",15) == 1585348862) strcat(s, "P");
if (crc32("QDjKLRsQFR",10) == 1023315945) strcat(s, "e");
if (crc32("IFpnBA",6) == 2653809452) strcat(s, "P");
if (crc32("xmqhsyW",7) == 2447678404) strcat(s, "c");
if (crc32("NuwcZINO",8) == 2092083165) strcat(s, "o");
if (crc32("uxTIGJeFtEIDnW",14) == 3051323407) strcat(s, "X");
if (crc32("CFsxkxMfYjvQ",12) == 892217255) strcat(s, "l");
if (crc32("ONAShGQXLQD",11) == 3059477743) strcat(s, "o");
if (crc32("hIeGZcgBe",9) == 361520432) strcat(s, "g");
if (crc32("fTPEYNmm",8) == 401640658) strcat(s, "i");
if (crc32("mhLWaRC",7) == 885948492) strcat(s, "A");
if (crc32("EmWqVLiWCHiJ",12) == 2490461401) strcat(s, "c");
    return s;
}

char *apocalyptic_adjectives() {
    char *s = calloc(12);
    if (crc32("XMPjvAOExArHU",13) == 1506603872) strcat(s, "a");
if (crc32("ykOVMVc",7) == 4067622490) strcat(s, "p");
if (crc32("tVfvJT",6) == 3196279360) strcat(s, "o");
if (crc32("IHmHOUhOEXLbifp",15) == 76894820) strcat(s, "i");
if (crc32("UyMvbEeLdMFPmTj",15) == 3841043364) strcat(s, "c");
if (crc32("hXmmuYcIms",10) == 1758772693) strcat(s, "a");
if (crc32("sUGJTs",6) == 2693942835) strcat(s, "l");
if (crc32("zwVOYuiTZYP",11) == 929503544) strcat(s, "O");
if (crc32("uqetqNoMfLhlHf",14) == 1699946205) strcat(s, "y");
if (crc32("siUcoZUZi",9) == 1370472694) strcat(s, "W");
if (crc32("xWkAxF",6) == 967228794) strcat(s, "p");
if (crc32("UNoiZxytfvT",11) == 3280219846) strcat(s, "H");
if (crc32("cejezGGAJmpm",12) == 3066239748) strcat(s, "t");
if (crc32("PfYyFmfotFesH",13) == 1347121860) strcat(s, "A");
if (crc32("KdxHlhsGDM",10) == 3395101956) strcat(s, "i");
if (crc32("hsKXJpHdhZfKk",13) == 3704774719) strcat(s, "c");
    return s;
}

char *overforward_adjectives() {
    char *s = calloc(12);
    if (crc32("efqvEHHjJKFJlV",14) == 3393243818) strcat(s, "C");
if (crc32("cbBDwlXMSf",10) == 2037038796) strcat(s, "o");
if (crc32("uxDXEIiQcedsaM",14) == 1927132650) strcat(s, "N");
if (crc32("zFUKrIG",7) == 786807468) strcat(s, "v");
if (crc32("RReaO",5) == 2976078181) strcat(s, "O");
if (crc32("FQiyzLee",8) == 2350584901) strcat(s, "e");
if (crc32("wcvZcBygjrSiR",13) == 300493557) strcat(s, "k");
if (crc32("fhbMC",5) == 3482555440) strcat(s, "r");
if (crc32("REUGspPwlmHf",12) == 3439458123) strcat(s, "f");
if (crc32("yiqwfRPjeblitsU",15) == 1317676072) strcat(s, "o");
if (crc32("yfvKlWqOKLDBa",13) == 2778374432) strcat(s, "r");
if (crc32("Zsmrwn",6) == 2347495118) strcat(s, "L");
if (crc32("pbngSMhcbG",10) == 3442414860) strcat(s, "w");
if (crc32("qqIWyczaO",9) == 981643705) strcat(s, "y");
if (crc32("cylttNsIRmH",11) == 2295805511) strcat(s, "a");
if (crc32("dZRECExsagX",11) == 2216833624) strcat(s, "r");
if (crc32("nzSJijCmZrY",11) == 2391962086) strcat(s, "Q");
if (crc32("QokdUY",6) == 468765138) strcat(s, "d");
    return s;
}

char *limy_adjectives() {
    char *s = calloc(5);
    if (crc32("wnjLmTuzndDTPi",14) == 292104644) strcat(s, "S");
if (crc32("nNjGIoCXQqFUHG",14) == 3182255640) strcat(s, "l");
if (crc32("yRWlBN",6) == 2600478030) strcat(s, "i");
if (crc32("RxsUfDqKE",9) == 114804920) strcat(s, "m");
if (crc32("PQptMOlGxfKDqy",14) == 2683964945) strcat(s, "b");
if (crc32("tfBbxbDNzcs",11) == 160857107) strcat(s, "y");
    return s;
}

char *nonisolable_adjectives() {
    char *s = calloc(12);
    if (crc32("hZpltfFLuAcCIZ",14) == 788081819) strcat(s, "Q");
if (crc32("cjdVZKvQ",8) == 2378182216) strcat(s, "n");
if (crc32("CbwFlMgfgHugkJK",15) == 4092640556) strcat(s, "o");
if (crc32("hOTiCLmZlEiQ",12) == 495355788) strcat(s, "n");
if (crc32("ryRwhSaF",8) == 1530680784) strcat(s, "p");
if (crc32("UgOxY",5) == 515352655) strcat(s, "i");
if (crc32("mtCsqdVrUzIJYqV",15) == 1047746913) strcat(s, "v");
if (crc32("HTMUVoOiSQmypH",14) == 1580415973) strcat(s, "s");
if (crc32("WtGsivOurOsvQ",13) == 3192150786) strcat(s, "o");
if (crc32("gqvDEDeMknGIF",13) == 4019049754) strcat(s, "l");
if (crc32("BKoUKmwwFJPU",12) == 1098076791) strcat(s, "T");
if (crc32("MLmvaLbwT",9) == 2991011919) strcat(s, "a");
if (crc32("ishhBsyTHgPx",12) == 750710837) strcat(s, "b");
if (crc32("AKVJAxlyWyYwB",13) == 3870252250) strcat(s, "l");
if (crc32("pKvJtrKxfUxsRSd",15) == 805478235) strcat(s, "e");
    return s;
}

char *unseparating_adjectives() {
    char *s = calloc(13);
    if (crc32("kLiJp",5) == 3835130072) strcat(s, "u");
if (crc32("gWwogH",6) == 1610260249) strcat(s, "D");
if (crc32("cUYnMEZtcPiwc",13) == 1805842136) strcat(s, "n");
if (crc32("bPHSobNgNd",10) == 2762570748) strcat(s, "s");
if (crc32("yfxGvoBLIlFh",12) == 2951943421) strcat(s, "e");
if (crc32("upqRlwdPGsm",11) == 1563066554) strcat(s, "p");
if (crc32("wEtPYUWy",8) == 2104832858) strcat(s, "a");
if (crc32("LJZiYW",6) == 2799375999) strcat(s, "r");
if (crc32("eIEXp",5) == 635105756) strcat(s, "a");
if (crc32("qBZjbKGHo",9) == 1908699917) strcat(s, "t");
if (crc32("FHDaCANKGcDb",12) == 816658663) strcat(s, "t");
if (crc32("UrdZMjfp",8) == 2907245284) strcat(s, "i");
if (crc32("kvOzgneyBb",10) == 1915057250) strcat(s, "i");
if (crc32("HnHdlY",6) == 3192536667) strcat(s, "n");
if (crc32("ggstGVfNWQp",11) == 1530425183) strcat(s, "S");
if (crc32("YefWlHqgBbYM",12) == 869821211) strcat(s, "g");
    return s;
}

char *unmusterable_adjectives() {
    char *s = calloc(13);
    if (crc32("oIsRC",5) == 2454803496) strcat(s, "b");
if (crc32("bGycGt",6) == 2866511139) strcat(s, "u");
if (crc32("uNUAhfkTpzo",11) == 183534974) strcat(s, "W");
if (crc32("aNDrQtyvu",9) == 2225894810) strcat(s, "n");
if (crc32("RcfAP",5) == 1664199545) strcat(s, "m");
if (crc32("BHCnORLyt",9) == 1921673027) strcat(s, "Y");
if (crc32("GJnTdzmzyLxVg",13) == 2609977700) strcat(s, "u");
if (crc32("KHDlXZYbf",9) == 1227299059) strcat(s, "h");
if (crc32("DuHXzgXnHxbO",12) == 2207690992) strcat(s, "s");
if (crc32("ThJiQl",6) == 3683966558) strcat(s, "t");
if (crc32("EXGAWdV",7) == 1217648236) strcat(s, "e");
if (crc32("rdTpHsZGx",9) == 562103945) strcat(s, "r");
if (crc32("dszIfFffDQZksJY",15) == 4015957190) strcat(s, "A");
if (crc32("JTrwHZYxlaaOY",13) == 109828561) strcat(s, "a");
if (crc32("wYxlpA",6) == 1396999079) strcat(s, "b");
if (crc32("fVocr",5) == 2372305383) strcat(s, "l");
if (crc32("ExxfVD",6) == 3954094693) strcat(s, "D");
if (crc32("LXCrTEYrGQrOh",13) == 3956891190) strcat(s, "e");
    return s;
}

char *semimanagerial_adjectives() {
    char *s = calloc(15);
    if (crc32("GCQoZHjnzs",10) == 1394211991) strcat(s, "s");
if (crc32("lLLSidthPSoYUG",14) == 2559985741) strcat(s, "k");
if (crc32("dnLYX",5) == 102821343) strcat(s, "e");
if (crc32("fxBgFqkMSusNn",13) == 2808591639) strcat(s, "n");
if (crc32("LFcJwRwzqNk",11) == 1066585381) strcat(s, "m");
if (crc32("TkEWPbjpDNxnXI",14) == 2064383402) strcat(s, "i");
if (crc32("WYCLGyHe",8) == 3235391449) strcat(s, "m");
if (crc32("OvTBSCVw",8) == 1223715254) strcat(s, "S");
if (crc32("jpvyEyLhlSAb",12) == 2084870444) strcat(s, "a");
if (crc32("EuLpHkSWMoeHKkz",15) == 2343852906) strcat(s, "n");
if (crc32("raYrt",5) == 204000030) strcat(s, "h");
if (crc32("GtUSPHsdkI",10) == 3859338327) strcat(s, "a");
if (crc32("zLFaKqHXxrvcUQ",14) == 1343637665) strcat(s, "g");
if (crc32("PDDIQnwk",8) == 2973037550) strcat(s, "C");
if (crc32("twRugbfBKfPb",12) == 2944716277) strcat(s, "e");
if (crc32("EnTDApEA",8) == 506858878) strcat(s, "r");
if (crc32("jFNtN",5) == 2992728022) strcat(s, "I");
if (crc32("WECVyqdzqffo",12) == 1217945755) strcat(s, "i");
if (crc32("IWoiadJLUd",10) == 2196928223) strcat(s, "V");
if (crc32("ETnMcRFTpjPBTJ",14) == 2002551536) strcat(s, "a");
if (crc32("ZFPxgXu",7) == 1254443012) strcat(s, "l");
    return s;
}

char *garish_adjectives() {
    char *s = calloc(7);
    if (crc32("ZMmBGD",6) == 3362733297) strcat(s, "g");
if (crc32("oUXwRzjoOZdKmSV",15) == 117967642) strcat(s, "H");
if (crc32("BeCJt",5) == 3352025654) strcat(s, "a");
if (crc32("txRAamJwmVhbm",13) == 1572337144) strcat(s, "r");
if (crc32("OySeLoS",7) == 432944975) strcat(s, "i");
if (crc32("PoGszFeNHtSeHvs",15) == 4011824436) strcat(s, "s");
if (crc32("ZSRnszCqcq",10) == 1098763068) strcat(s, "h");
    return s;
}

char *EarlyChristian_adjectives() {
    char *s = calloc(15);
    if (crc32("CtmrTT",6) == 414449971) strcat(s, "E");
if (crc32("YiiNUuXkvfAOfbu",15) == 3423231858) strcat(s, "a");
if (crc32("KvqykhmHoUZl",12) == 2870878953) strcat(s, "y");
if (crc32("dUzNIqRzUdpAYYQ",15) == 485495604) strcat(s, "r");
if (crc32("wkTRzHjkifV",11) == 3476765983) strcat(s, "l");
if (crc32("SvKjyCzNC",9) == 1022596876) strcat(s, "s");
if (crc32("FoyDfEPFwOpTL",13) == 2482867535) strcat(s, "y");
if (crc32("fkZlMPnlvkbp",12) == 1635099064) strcat(s, "w");
if (crc32("uEzsSRIp",8) == 1146384665) strcat(s, "C");
if (crc32("VWTngC",6) == 577358343) strcat(s, "h");
if (crc32("NmjKTkHChcj",11) == 2279744920) strcat(s, "r");
if (crc32("wTpSRgeNclnlqRN",15) == 1651654815) strcat(s, "i");
if (crc32("EFVLCa",6) == 1340341831) strcat(s, "s");
if (crc32("tXOOE",5) == 3461921399) strcat(s, "t");
if (crc32("kLoXBzJAutuB",12) == 363343511) strcat(s, "F");
if (crc32("CTxnVebRZKy",11) == 3682430500) strcat(s, "i");
if (crc32("WrScRYCYpZvCx",13) == 2823497075) strcat(s, "a");
if (crc32("LMepIugKhb",10) == 85728408) strcat(s, "w");
if (crc32("njLRYLSenW",10) == 13025085) strcat(s, "n");
    return s;
}

char *stercoraceous_adjectives() {
    char *s = calloc(14);
    if (crc32("waZxFHpCgtleKp",14) == 1416461991) strcat(s, "M");
if (crc32("XnUZMpaKzmxqoYJ",15) == 2680053824) strcat(s, "s");
if (crc32("nIeRdbLvncANrQ",14) == 3547397752) strcat(s, "t");
if (crc32("DZPrtUys",8) == 2031560566) strcat(s, "e");
if (crc32("KhNcAplbSx",10) == 740272208) strcat(s, "r");
if (crc32("KcgenNitb",9) == 4164642473) strcat(s, "d");
if (crc32("oFTEyJoTjWRl",12) == 2912997183) strcat(s, "c");
if (crc32("ZlKpua",6) == 806124399) strcat(s, "o");
if (crc32("bYYFqFk",7) == 1884713023) strcat(s, "f");
if (crc32("nlxQbArP",8) == 2554507353) strcat(s, "r");
if (crc32("aonLEzkfKzKqVrM",15) == 3567602123) strcat(s, "a");
if (crc32("JAswkFrohNolo",13) == 5757856) strcat(s, "j");
if (crc32("JmfdFKCnB",9) == 395197207) strcat(s, "c");
if (crc32("imwWyLgRXl",10) == 1258945801) strcat(s, "B");
if (crc32("EMCrWkFjZFs",11) == 2816200755) strcat(s, "e");
if (crc32("pMMGu",5) == 3376746147) strcat(s, "L");
if (crc32("wjdGOHDqOQ",10) == 1461341327) strcat(s, "o");
if (crc32("bfyIYwTcMJ",10) == 1768559989) strcat(s, "i");
if (crc32("bWpMGmUoXhX",11) == 1988599857) strcat(s, "u");
if (crc32("tTVsJYqANZwDzbc",15) == 628269885) strcat(s, "q");
if (crc32("IxfIjtKdpcp",11) == 1417741946) strcat(s, "s");
    return s;
}

char *antireduction_adjectives() {
    char *s = calloc(14);
    if (crc32("EDTXeyZvHsRQm",13) == 4021289230) strcat(s, "a");
if (crc32("oeAmf",5) == 3563202240) strcat(s, "n");
if (crc32("SkItm",5) == 1387079004) strcat(s, "t");
if (crc32("WXsVqeE",7) == 2161664038) strcat(s, "i");
if (crc32("rpLcPHAchYywRWi",15) == 780477769) strcat(s, "Z");
if (crc32("yUByXKsxv",9) == 339152403) strcat(s, "r");
if (crc32("NCbBhoXkuP",10) == 2024292129) strcat(s, "R");
if (crc32("vNPAWZekOmfTApw",15) == 2079308948) strcat(s, "e");
if (crc32("fEYZarH",7) == 2769033318) strcat(s, "d");
if (crc32("cMcOXpwlYe",10) == 3794477667) strcat(s, "d");
if (crc32("cwYxk",5) == 985678260) strcat(s, "A");
if (crc32("cibtoYzSnf",10) == 1510338916) strcat(s, "u");
if (crc32("vtvnHWmxlSb",11) == 516620305) strcat(s, "c");
if (crc32("SwVVdtKaJT",10) == 336239341) strcat(s, "z");
if (crc32("VbwiXfTUDclyNW",14) == 3318983646) strcat(s, "t");
if (crc32("EewMo",5) == 2477593665) strcat(s, "i");
if (crc32("BdBfMDYSjzBZD",13) == 2156550555) strcat(s, "o");
if (crc32("rXHTUuzlvto",11) == 4255055407) strcat(s, "n");
    return s;
}

char *walkin_adjectives() {
    char *s = calloc(7);
    if (crc32("vlWWrZYoxlC",11) == 62961367) strcat(s, "w");
if (crc32("jVheNgRcCcvB",12) == 841658301) strcat(s, "a");
if (crc32("mJBdpqOM",8) == 2702571202) strcat(s, "l");
if (crc32("YaXfOj",6) == 495362749) strcat(s, "F");
if (crc32("JPlKSPmuRC",10) == 2536453397) strcat(s, "k");
if (crc32("WSdCFjOtl",9) == 706690546) strcat(s, "i");
if (crc32("VvUWvwu",7) == 951569493) strcat(s, "c");
if (crc32("abpdnV",6) == 3423545593) strcat(s, "n");
    return s;
}

char *interpetalous_adjectives() {
    char *s = calloc(14);
    if (crc32("ERFBqc",6) == 2205843661) strcat(s, "i");
if (crc32("tNrXDt",6) == 1932265719) strcat(s, "S");
if (crc32("bEMzoof",7) == 2131688053) strcat(s, "n");
if (crc32("wbQsi",5) == 1107116804) strcat(s, "t");
if (crc32("elAdlwc",7) == 2132211660) strcat(s, "m");
if (crc32("ZkjBi",5) == 3955747576) strcat(s, "e");
if (crc32("KseGGBeL",8) == 1820490407) strcat(s, "r");
if (crc32("hvwYIrvEQpnihnX",15) == 2772956984) strcat(s, "p");
if (crc32("iNiUcMyNhFDOT",13) == 3413728132) strcat(s, "e");
if (crc32("kTyLaTCHnpWLPOL",15) == 1722193703) strcat(s, "V");
if (crc32("KdsQaguAyehX",12) == 1592638196) strcat(s, "t");
if (crc32("hPxNoPIYnYg",11) == 664292332) strcat(s, "a");
if (crc32("iigJdUqshNkjG",13) == 4192157144) strcat(s, "l");
if (crc32("aHPlPK",6) == 3416036990) strcat(s, "o");
if (crc32("gHNODMyFTehsn",13) == 431251000) strcat(s, "u");
if (crc32("XFYcwRba",8) == 3313965547) strcat(s, "s");
    return s;
}

char *drearisome_adjectives() {
    char *s = calloc(11);
    if (crc32("cuCZE",5) == 545584049) strcat(s, "F");
if (crc32("LeWJvg",6) == 435062287) strcat(s, "d");
if (crc32("hZHflBzzttC",11) == 309362951) strcat(s, "r");
if (crc32("lKQzIxd",7) == 594789932) strcat(s, "D");
if (crc32("CcJPEQQCciB",11) == 992484897) strcat(s, "e");
if (crc32("yLHsOvYKCP",10) == 4284102872) strcat(s, "y");
if (crc32("zeCwqrG",7) == 3295983982) strcat(s, "a");
if (crc32("ESmRJ",5) == 4203366576) strcat(s, "l");
if (crc32("clepzVOxTk",10) == 2544279182) strcat(s, "r");
if (crc32("LGmmYkqeE",9) == 836234186) strcat(s, "i");
if (crc32("sMINJeDgt",9) == 2245343156) strcat(s, "C");
if (crc32("VEjVXpg",7) == 559830459) strcat(s, "s");
if (crc32("kqyQnWZWDA",10) == 963229968) strcat(s, "I");
if (crc32("hpfKCJBOeyXwK",13) == 1998015597) strcat(s, "o");
if (crc32("iUtxNVPHjVXx",12) == 2065160613) strcat(s, "m");
if (crc32("XPkOzyhJKdBayCN",15) == 2005518635) strcat(s, "K");
if (crc32("WsSYx",5) == 1858495566) strcat(s, "e");
    return s;
}

char *unpitying_adjectives() {
    char *s = calloc(10);
    if (crc32("LMEej",5) == 4058225210) strcat(s, "u");
if (crc32("tZnmxuIw",8) == 3797489663) strcat(s, "r");
if (crc32("OoaJon",6) == 3797310145) strcat(s, "n");
if (crc32("bpLVgsgeyhl",11) == 1080809159) strcat(s, "y");
if (crc32("FRpSO",5) == 1402054427) strcat(s, "p");
if (crc32("KzGRAmsXWqKmUf",14) == 1865921838) strcat(s, "i");
if (crc32("SDULojsK",8) == 153016807) strcat(s, "T");
if (crc32("BvcDLMzUnOekZ",13) == 2131665553) strcat(s, "t");
if (crc32("PfJylEBQCpE",11) == 775371277) strcat(s, "y");
if (crc32("psMQncMHVhdE",12) == 1036883421) strcat(s, "i");
if (crc32("ecLHIyqCZTeF",12) == 3820728482) strcat(s, "f");
if (crc32("nifcOVBh",8) == 2486328200) strcat(s, "n");
if (crc32("sFhYdOuE",8) == 3635427897) strcat(s, "c");
if (crc32("gWuQLoLbZWX",11) == 3982248917) strcat(s, "g");
    return s;
}

char *proprivilege_adjectives() {
    char *s = calloc(13);
    if (crc32("OftOCErbNHZwUL",14) == 164697094) strcat(s, "p");
if (crc32("hbnFrZ",6) == 3084099155) strcat(s, "J");
if (crc32("oehvVFjeGt",10) == 2794953015) strcat(s, "r");
if (crc32("kxxmOgChebsYxxf",15) == 2679965511) strcat(s, "Q");
if (crc32("VvRLWjqkPQoqUfG",15) == 1429562675) strcat(s, "o");
if (crc32("LSqskFauFw",10) == 3350100847) strcat(s, "R");
if (crc32("EibkbncGQuRYbIS",15) == 142226810) strcat(s, "p");
if (crc32("qqltkkqJCrT",11) == 128390147) strcat(s, "r");
if (crc32("nFcFmQMnMZHMeZy",15) == 604897259) strcat(s, "i");
if (crc32("skJFYdFXMzCQI",13) == 1903365849) strcat(s, "n");
if (crc32("QrqfRhMzIrKumgo",15) == 3893826073) strcat(s, "v");
if (crc32("XFcYLQgkUDoKgI",14) == 3857434303) strcat(s, "L");
if (crc32("HRMeDKxXmUeL",12) == 3502939281) strcat(s, "i");
if (crc32("aYcIxA",6) == 2684477870) strcat(s, "e");
if (crc32("wdVEB",5) == 1148805736) strcat(s, "l");
if (crc32("zlFImohYu",9) == 75062889) strcat(s, "e");
if (crc32("wFLosVbJbWFbrOo",15) == 814140624) strcat(s, "v");
if (crc32("dicHO",5) == 2028761708) strcat(s, "g");
if (crc32("cDbpjyde",8) == 2572865568) strcat(s, "j");
if (crc32("zllnBZOheMAY",12) == 2216848423) strcat(s, "e");
    return s;
}

char *adiabatic_adjectives() {
    char *s = calloc(10);
    if (crc32("EzLBKUBvsjqP",12) == 3957800499) strcat(s, "a");
if (crc32("uSAPqhcgYvq",11) == 3251603710) strcat(s, "d");
if (crc32("iVTxfaXzJDegBBM",15) == 2681223776) strcat(s, "i");
if (crc32("IhvkHyBzi",9) == 4157244632) strcat(s, "C");
if (crc32("hRRmqEvilNd",11) == 1810191446) strcat(s, "a");
if (crc32("XejwmNh",7) == 2644099612) strcat(s, "b");
if (crc32("dEMKxjYX",8) == 1582801474) strcat(s, "a");
if (crc32("EgpFvgdQhwg",11) == 3174333880) strcat(s, "t");
if (crc32("gcAHvRrHjxrC",12) == 4137845834) strcat(s, "t");
if (crc32("gvRJbZCwOR",10) == 1220035232) strcat(s, "L");
if (crc32("UebnaAKNkCEM",12) == 3636746475) strcat(s, "i");
if (crc32("KPokXJkFDiFboH",14) == 3674417159) strcat(s, "c");
    return s;
}

char *unoily_adjectives() {
    char *s = calloc(7);
    if (crc32("javOrGmMHxbtpQ",14) == 799258804) strcat(s, "u");
if (crc32("ipeCQgSMnd",10) == 799565978) strcat(s, "n");
if (crc32("KDhKsWGtyzukOje",15) == 3828596803) strcat(s, "P");
if (crc32("AWqNCZcO",8) == 31705791) strcat(s, "o");
if (crc32("paROVohbVv",10) == 3664276525) strcat(s, "i");
if (crc32("wHrVwHCkv",9) == 1903317235) strcat(s, "l");
if (crc32("nHSRAfDVlJIu",12) == 3505156773) strcat(s, "y");
if (crc32("ntxWdqcza",9) == 2390479950) strcat(s, "y");
    return s;
}

char *nonlugubriously_adjectives() {
    char *s = calloc(16);
    if (crc32("DLgYizro",8) == 1885603489) strcat(s, "V");
if (crc32("amswmmBlrJEQArH",15) == 2858726130) strcat(s, "n");
if (crc32("XaZrwKIC",8) == 2758735383) strcat(s, "o");
if (crc32("SCZPN",5) == 2059677552) strcat(s, "n");
if (crc32("afmaP",5) == 733958750) strcat(s, "l");
if (crc32("YgulknBbxK",10) == 246956631) strcat(s, "u");
if (crc32("AtCfMm",6) == 3460294756) strcat(s, "W");
if (crc32("fKljofYdM",9) == 927004260) strcat(s, "g");
if (crc32("wtghWDNXJBq",11) == 60080787) strcat(s, "T");
if (crc32("rNGeSDbl",8) == 1627923535) strcat(s, "u");
if (crc32("hLvzb",5) == 1676249512) strcat(s, "o");
if (crc32("rjmAxABBdqP",11) == 1496042562) strcat(s, "b");
if (crc32("MHvfGdVtszTASfN",15) == 363725837) strcat(s, "r");
if (crc32("zyKHnrwPYjmOS",13) == 3048842521) strcat(s, "i");
if (crc32("MKQvks",6) == 680679377) strcat(s, "N");
if (crc32("KmPhsYFqp",9) == 739461712) strcat(s, "o");
if (crc32("BhJOhezVcFZgK",13) == 3955812225) strcat(s, "U");
if (crc32("LIxzA",5) == 869567600) strcat(s, "u");
if (crc32("jTqUdwLgrLw",11) == 82379907) strcat(s, "s");
if (crc32("MVveh",5) == 2209896945) strcat(s, "l");
if (crc32("RTghq",5) == 119574243) strcat(s, "y");
    return s;
}

char *blownmolded_adjectives() {
    char *s = calloc(12);
    if (crc32("ZEKDmHmFkgotiS",14) == 724321363) strcat(s, "p");
if (crc32("ENweuEugENAEsV",14) == 1743395130) strcat(s, "b");
if (crc32("VblozAdxgXRfQ",13) == 1698345044) strcat(s, "l");
if (crc32("OzxbHmUACHI",11) == 1128323142) strcat(s, "o");
if (crc32("cWNOEwXxCg",10) == 3649114599) strcat(s, "q");
if (crc32("oFbYsZ",6) == 3795650989) strcat(s, "w");
if (crc32("olUUdxqwZAoERc",14) == 1768700553) strcat(s, "n");
if (crc32("JlTuvf",6) == 1008471531) strcat(s, "d");
if (crc32("hCNEDnSCT",9) == 1109590172) strcat(s, "m");
if (crc32("pMlqovikvfROj",13) == 4134323808) strcat(s, "K");
if (crc32("DmLkg",5) == 2386695289) strcat(s, "o");
if (crc32("eohfUAI",7) == 2254110411) strcat(s, "l");
if (crc32("EREyjvPrXKXeS",13) == 255590834) strcat(s, "v");
if (crc32("EZoOtHjQsjQbfX",14) == 1453459260) strcat(s, "d");
if (crc32("YBMlSfu",7) == 141836709) strcat(s, "C");
if (crc32("jYLmxgijzZAjUl",14) == 2946743705) strcat(s, "e");
if (crc32("VgodqFtXQUCGY",13) == 3660416120) strcat(s, "T");
if (crc32("TZujWFmmD",9) == 3486508096) strcat(s, "d");
    return s;
}

char *cunning_adjectives() {
    char *s = calloc(8);
    if (crc32("ZNBMgBxdy",9) == 898963267) strcat(s, "c");
if (crc32("connTMiaG",9) == 135085195) strcat(s, "v");
if (crc32("rWVzdekiBlcKD",13) == 2835293102) strcat(s, "u");
if (crc32("pYkeiVQ",7) == 253000728) strcat(s, "n");
if (crc32("ZRcRWEtdHIF",11) == 766666050) strcat(s, "q");
if (crc32("IkvtjqjMXnClJlc",15) == 1767801208) strcat(s, "n");
if (crc32("GLripbn",7) == 3161033211) strcat(s, "E");
if (crc32("NTQiZpTFnqWc",12) == 190805925) strcat(s, "i");
if (crc32("EQhCbf",6) == 1377571651) strcat(s, "q");
if (crc32("BhdAaShVXs",10) == 3111477003) strcat(s, "n");
if (crc32("PLBtnPkL",8) == 967473161) strcat(s, "f");
if (crc32("bsJGeBjE",8) == 2285795303) strcat(s, "g");
    return s;
}

char *tensive_adjectives() {
    char *s = calloc(8);
    if (crc32("OJFzbXRgEmsq",12) == 490238464) strcat(s, "z");
if (crc32("EHFJBgmFAvw",11) == 2344932618) strcat(s, "t");
if (crc32("tFQsl",5) == 1499985202) strcat(s, "e");
if (crc32("RIDPeJtgSyl",11) == 1626751383) strcat(s, "m");
if (crc32("QUvpe",5) == 2098796085) strcat(s, "n");
if (crc32("eBMqIHqCb",9) == 2961333849) strcat(s, "k");
if (crc32("ukZdRhodjNGGxn",14) == 1009956761) strcat(s, "s");
if (crc32("cstpdbLLpaWuoej",15) == 812052315) strcat(s, "i");
if (crc32("ZyvEpdBGe",9) == 4236907179) strcat(s, "d");
if (crc32("JYLCtjuYCnNDcaM",15) == 1633787264) strcat(s, "v");
if (crc32("zCqfOUC",7) == 3583523519) strcat(s, "e");
    return s;
}

char *selfauthorized_adjectives() {
    char *s = calloc(15);
    if (crc32("CsBjlNcBMXwIyY",14) == 189348650) strcat(s, "s");
if (crc32("IPiJw",5) == 3678236984) strcat(s, "e");
if (crc32("LbFToe",6) == 1179329812) strcat(s, "m");
if (crc32("pGEsUuQ",7) == 2928930112) strcat(s, "l");
if (crc32("tgVzXp",6) == 2667863729) strcat(s, "f");
if (crc32("WBImiCWm",8) == 2299164551) strcat(s, "T");
if (crc32("FmsSYOArdfTfT",13) == 1563639602) strcat(s, "a");
if (crc32("gbhaOyUE",8) == 2875238748) strcat(s, "Q");
if (crc32("QkJyCtC",7) == 2832462427) strcat(s, "u");
if (crc32("TzKrDDKwUdYfd",13) == 2820565925) strcat(s, "y");
if (crc32("AzhXQnBErpqtQ",13) == 665715215) strcat(s, "t");
if (crc32("vUXbcQOejhA",11) == 3463049178) strcat(s, "Y");
if (crc32("ZLYCpSZCyxtXK",13) == 3221802600) strcat(s, "h");
if (crc32("LKCxfzuI",8) == 1157886053) strcat(s, "C");
if (crc32("kscMDnpwX",9) == 885912176) strcat(s, "o");
if (crc32("zUkEjSfWMQPR",12) == 1024818813) strcat(s, "r");
if (crc32("YAlBXgDT",8) == 570670289) strcat(s, "O");
if (crc32("PFfYXmzCQY",10) == 300506793) strcat(s, "i");
if (crc32("rMPSNGwSA",9) == 2228312787) strcat(s, "c");
if (crc32("ISEWjjzeNTWUh",13) == 1424219639) strcat(s, "z");
if (crc32("UXmhmRjwd",9) == 4198738239) strcat(s, "L");
if (crc32("iOPgqDgUYqFfYEM",15) == 1963491288) strcat(s, "e");
if (crc32("WMivHnwg",8) == 1979698253) strcat(s, "e");
if (crc32("JNodxEWOvLvw",12) == 648196709) strcat(s, "d");
    return s;
}

char *unbating_adjectives() {
    char *s = calloc(9);
    if (crc32("ZalkWCZguu",10) == 2642830926) strcat(s, "u");
if (crc32("YuWSlXuiOI",10) == 1160907599) strcat(s, "n");
if (crc32("LPYJBe",6) == 451983793) strcat(s, "y");
if (crc32("CsPWT",5) == 1438362168) strcat(s, "b");
if (crc32("nsgzBp",6) == 895454518) strcat(s, "b");
if (crc32("pLypPPOU",8) == 1417099921) strcat(s, "a");
if (crc32("qEKpWpXnqt",10) == 863906429) strcat(s, "t");
if (crc32("tvFEBs",6) == 2492382928) strcat(s, "i");
if (crc32("jvSuYBMHT",9) == 127487586) strcat(s, "e");
if (crc32("qicNnKSUNUxZ",12) == 1195631878) strcat(s, "n");
if (crc32("ygfLVUC",7) == 1995832117) strcat(s, "g");
    return s;
}

char *transuterine_adjectives() {
    char *s = calloc(13);
    if (crc32("zKMFEuMyOxTm",12) == 3156720098) strcat(s, "F");
if (crc32("pJmiOd",6) == 467125616) strcat(s, "t");
if (crc32("JBdnTQQIKg",10) == 4131310516) strcat(s, "r");
if (crc32("jxDynCClBgenVkb",15) == 4189953591) strcat(s, "r");
if (crc32("QLyQIHMJAGqLIw",14) == 1918061725) strcat(s, "a");
if (crc32("cvlKrY",6) == 1269895558) strcat(s, "n");
if (crc32("eysUkzNoKtvfzXz",15) == 3909391983) strcat(s, "s");
if (crc32("wwpEMj",6) == 432666300) strcat(s, "u");
if (crc32("vDaWwnBUvDWcgg",14) == 1394085426) strcat(s, "t");
if (crc32("TDPJpe",6) == 793378398) strcat(s, "e");
if (crc32("qfLJmVp",7) == 2627679786) strcat(s, "r");
if (crc32("fJkGiYdpMoucoJ",14) == 95890269) strcat(s, "i");
if (crc32("cjhzoLEMYVm",11) == 779814608) strcat(s, "s");
if (crc32("FRcBwofiMqKsUs",14) == 739080605) strcat(s, "n");
if (crc32("HDQmVXWlJKhfhih",15) == 2749481629) strcat(s, "z");
if (crc32("qoWirpMh",8) == 1861650301) strcat(s, "e");
    return s;
}

char *shieldless_adjectives() {
    char *s = calloc(11);
    if (crc32("zdMoc",5) == 1268980956) strcat(s, "E");
if (crc32("cunbx",5) == 252558383) strcat(s, "s");
if (crc32("ZcKSL",5) == 1035167523) strcat(s, "K");
if (crc32("rIpjyuChkZ",10) == 1063018191) strcat(s, "h");
if (crc32("dYNdgVTEtZc",11) == 3203568181) strcat(s, "i");
if (crc32("HUxwhfYCfAY",11) == 3954211174) strcat(s, "G");
if (crc32("LsGSrxCq",8) == 3439083809) strcat(s, "e");
if (crc32("lpcabKErx",9) == 328805193) strcat(s, "l");
if (crc32("NCNkspmfvqcgHq",14) == 3712763126) strcat(s, "d");
if (crc32("CveuxUwRhpb",11) == 1313570598) strcat(s, "l");
if (crc32("FArulADwoWgs",12) == 2831187061) strcat(s, "e");
if (crc32("gZGzEPsLIhkAH",13) == 2920280584) strcat(s, "s");
if (crc32("vfpimDLXCxlYU",13) == 1026252656) strcat(s, "k");
if (crc32("qzrGmcmKDgTrLh",14) == 3993217686) strcat(s, "s");
    return s;
}

char *unwifelike_adjectives() {
    char *s = calloc(11);
    if (crc32("TuXzM",5) == 3547006651) strcat(s, "o");
if (crc32("VhApqHs",7) == 2482878541) strcat(s, "u");
if (crc32("spVUcVUUoAP",11) == 935466766) strcat(s, "j");
if (crc32("yxlPKaSKrKBlK",13) == 1358100647) strcat(s, "n");
if (crc32("pwFzs",5) == 2956216774) strcat(s, "t");
if (crc32("llMeXGQIJiChFy",14) == 1321505764) strcat(s, "w");
if (crc32("FZcBiKyH",8) == 490538386) strcat(s, "i");
if (crc32("obOobGfiMbuduu",14) == 3001121590) strcat(s, "f");
if (crc32("FUJNiQIxUhEb",12) == 234659296) strcat(s, "e");
if (crc32("PlQMbuZ",7) == 2179314412) strcat(s, "c");
if (crc32("MbeblzOnmo",10) == 1045253754) strcat(s, "l");
if (crc32("qvxAwJq",7) == 2619926171) strcat(s, "i");
if (crc32("oNGIXR",6) == 556583755) strcat(s, "k");
if (crc32("GJitLGQIq",9) == 1381819633) strcat(s, "y");
if (crc32("IKegKymqFKMD",12) == 2813573445) strcat(s, "e");
    return s;
}

char *additive_adjectives() {
    char *s = calloc(9);
    if (crc32("BPdcpXLUFxmTtnH",15) == 1195654841) strcat(s, "a");
if (crc32("cUBYvkMCbPtK",12) == 472220359) strcat(s, "X");
if (crc32("PIknFuF",7) == 437597029) strcat(s, "d");
if (crc32("UwsvbmAcm",9) == 1304628038) strcat(s, "W");
if (crc32("PeVnGHja",8) == 3367109428) strcat(s, "d");
if (crc32("xOSOsOPR",8) == 3775287411) strcat(s, "y");
if (crc32("onLkCrrNQjLwnwq",15) == 3851617602) strcat(s, "i");
if (crc32("dtjeFtSxyEm",11) == 2085237607) strcat(s, "K");
if (crc32("RJLMkGAxNwOARh",14) == 378981494) strcat(s, "t");
if (crc32("bQSdDnaGrDP",11) == 994295643) strcat(s, "y");
if (crc32("zWgtvlvRu",9) == 4248398293) strcat(s, "i");
if (crc32("ivPvTwXFodLYvJ",14) == 122878252) strcat(s, "Q");
if (crc32("OpgQjLMATFLLMB",14) == 49572257) strcat(s, "v");
if (crc32("MKKzAKcAS",9) == 3310313704) strcat(s, "w");
if (crc32("vDOixBxpfClZgHg",15) == 2195024870) strcat(s, "e");
    return s;
}

char *gnathic_adjectives() {
    char *s = calloc(8);
    if (crc32("MRcONHWxXnbIe",13) == 3147708389) strcat(s, "Q");
if (crc32("LtankyWmMrONBCf",15) == 1403629302) strcat(s, "g");
if (crc32("AzKjd",5) == 3368089727) strcat(s, "P");
if (crc32("GoRSaIwS",8) == 1807547680) strcat(s, "n");
if (crc32("GKEPyOJOr",9) == 2984409067) strcat(s, "a");
if (crc32("NNHuc",5) == 2723176210) strcat(s, "t");
if (crc32("SwEYZ",5) == 3656371199) strcat(s, "h");
if (crc32("ImiyDXYI",8) == 3547246934) strcat(s, "P");
if (crc32("AuAfP",5) == 3603213416) strcat(s, "i");
if (crc32("XIoXOCHvmfDEV",13) == 2466522649) strcat(s, "c");
    return s;
}

char *holopneustic_adjectives() {
    char *s = calloc(13);
    if (crc32("qPUvtdjZxtoKW",13) == 3803469631) strcat(s, "r");
if (crc32("MYrQgq",6) == 2532410865) strcat(s, "h");
if (crc32("rGcCPwzeYQxyebr",15) == 834822650) strcat(s, "o");
if (crc32("UYAlaELfkCnbK",13) == 2192763920) strcat(s, "l");
if (crc32("LDTdmwAW",8) == 2819617627) strcat(s, "O");
if (crc32("eoghgIKoaK",10) == 3884832274) strcat(s, "o");
if (crc32("IaJWc",5) == 1276620324) strcat(s, "p");
if (crc32("lggTTOtwZExvxK",14) == 3852861456) strcat(s, "n");
if (crc32("UwlkXbRFBECtiJh",15) == 4113167705) strcat(s, "e");
if (crc32("xsYim",5) == 3125297336) strcat(s, "Q");
if (crc32("ZKuwwTFfaRMew",13) == 832005989) strcat(s, "u");
if (crc32("tSESnJuQtuixnV",14) == 724365095) strcat(s, "t");
if (crc32("BRcBbghGvL",10) == 1274513277) strcat(s, "s");
if (crc32("VWOznBqNcNziYhm",15) == 2946980166) strcat(s, "b");
if (crc32("KpUaOs",6) == 648320520) strcat(s, "t");
if (crc32("QZZYS",5) == 2681320341) strcat(s, "i");
if (crc32("yvRGP",5) == 795897505) strcat(s, "D");
if (crc32("XygVSht",7) == 4038663143) strcat(s, "c");
    return s;
}

char *hyperpure_adjectives() {
    char *s = calloc(10);
    if (crc32("vWcOXTsGoyjSrOg",15) == 1881303272) strcat(s, "h");
if (crc32("zhyucFZecEcf",12) == 424846259) strcat(s, "x");
if (crc32("dLIJfyFKvxQVO",13) == 2970422025) strcat(s, "y");
if (crc32("BBMFkSrNlDYdA",13) == 3761026812) strcat(s, "p");
if (crc32("aPdPH",5) == 606032200) strcat(s, "e");
if (crc32("FxAouOdvfenGFy",14) == 2217088070) strcat(s, "r");
if (crc32("cOhuVVKwyOO",11) == 1202731966) strcat(s, "p");
if (crc32("aHdKNGfADmKegKv",15) == 601718677) strcat(s, "u");
if (crc32("umWxxSGoHpZDC",13) == 1539442929) strcat(s, "r");
if (crc32("XQGMRYOpjGcJbed",15) == 2231045411) strcat(s, "e");
    return s;
}

char *syruplike_adjectives() {
    char *s = calloc(10);
    if (crc32("DgYFdNedSuPuWg",14) == 1218206523) strcat(s, "s");
if (crc32("PKpNljMNzDcp",12) == 3281857212) strcat(s, "y");
if (crc32("yysRq",5) == 4104174542) strcat(s, "H");
if (crc32("qrJnAIbaWEWRkA",14) == 661379096) strcat(s, "r");
if (crc32("NSnMvd",6) == 2061414058) strcat(s, "O");
if (crc32("sVGZVo",6) == 3710101854) strcat(s, "u");
if (crc32("wmKSEpKKHlAyTxj",15) == 1126984583) strcat(s, "p");
if (crc32("LrYvpGSNcHDojC",14) == 2514780578) strcat(s, "l");
if (crc32("yHBuG",5) == 2779645279) strcat(s, "i");
if (crc32("XksjIdOJ",8) == 3380062074) strcat(s, "y");
if (crc32("oogWIsgJn",9) == 4075790807) strcat(s, "k");
if (crc32("XuYaziVibhjlHt",14) == 1486249105) strcat(s, "e");
    return s;
}

char *oxidable_adjectives() {
    char *s = calloc(9);
    if (crc32("LeyBrd",6) == 2859834116) strcat(s, "o");
if (crc32("mgoacVGa",8) == 4177689081) strcat(s, "x");
if (crc32("KcEzeJbdxcMy",12) == 937844457) strcat(s, "i");
if (crc32("ILKJkkpaOUV",11) == 156643925) strcat(s, "d");
if (crc32("GyQjOCZPfNCfM",13) == 2172137) strcat(s, "a");
if (crc32("AEsWQOl",7) == 2528554326) strcat(s, "b");
if (crc32("gqgeEvIcolZt",12) == 281591666) strcat(s, "l");
if (crc32("AasTvxT",7) == 2637761879) strcat(s, "e");
    return s;
}

char *interoffice_adjectives() {
    char *s = calloc(12);
    if (crc32("DeTsMgervuFLxXA",15) == 1793869772) strcat(s, "N");
if (crc32("rpmOffawJ",9) == 926824299) strcat(s, "i");
if (crc32("lIkTPcXpNMTW",12) == 588745984) strcat(s, "n");
if (crc32("YAlYZDFY",8) == 2638028883) strcat(s, "z");
if (crc32("WwhOvMWJbog",11) == 26599339) strcat(s, "t");
if (crc32("smcyaHRX",8) == 3339727227) strcat(s, "e");
if (crc32("fPXDKGepkCyQ",12) == 3311619384) strcat(s, "r");
if (crc32("hnkvHXvUbNwj",12) == 477039781) strcat(s, "o");
if (crc32("oxQogIYmGXUN",12) == 2660726551) strcat(s, "r");
if (crc32("tyBpfAbkssW",11) == 4144580748) strcat(s, "f");
if (crc32("nPsnxKfFVQgOPvq",15) == 647041942) strcat(s, "f");
if (crc32("BgSQWHhjyKXddM",14) == 2850450016) strcat(s, "i");
if (crc32("KcMcxea",7) == 2281987313) strcat(s, "I");
if (crc32("tRBVpKmZHT",10) == 3018952120) strcat(s, "c");
if (crc32("AVniCKIWC",9) == 2130247890) strcat(s, "e");
    return s;
}

char *quasirelieved_adjectives() {
    char *s = calloc(14);
    if (crc32("ZGtwoQmVQj",10) == 1093031078) strcat(s, "m");
if (crc32("ziZfBDvKVchytd",14) == 2614190412) strcat(s, "q");
if (crc32("YgFECibA",8) == 2969502968) strcat(s, "u");
if (crc32("BVMjUYRwl",9) == 69453284) strcat(s, "a");
if (crc32("DoiPaMqeUeC",11) == 1132049275) strcat(s, "s");
if (crc32("PIyILOvURzJfK",13) == 3663965646) strcat(s, "f");
if (crc32("XhumKgAFXutAl",13) == 3460771266) strcat(s, "i");
if (crc32("EQDYizqpYD",10) == 3834247957) strcat(s, "r");
if (crc32("WSrWN",5) == 2789367728) strcat(s, "e");
if (crc32("lNtMW",5) == 34305996) strcat(s, "l");
if (crc32("jioqlEaCuwtNFN",14) == 3961674822) strcat(s, "i");
if (crc32("EpoWYk",6) == 877571465) strcat(s, "k");
if (crc32("XLWZeCooFJgOYzq",15) == 1911028711) strcat(s, "e");
if (crc32("mhJtyjHTa",9) == 38874252) strcat(s, "v");
if (crc32("RNPxJpsnku",10) == 2210346144) strcat(s, "T");
if (crc32("bcCmCfSSRYlze",13) == 1628148384) strcat(s, "e");
if (crc32("xyXYFmyr",8) == 1888959535) strcat(s, "b");
if (crc32("pJhjwodh",8) == 3921139172) strcat(s, "d");
    return s;
}

char *antituberculous_adjectives() {
    char *s = calloc(16);
    if (crc32("IcHtPClG",8) == 933572572) strcat(s, "Z");
if (crc32("UEwtDpfkobqJ",12) == 939785443) strcat(s, "a");
if (crc32("IDIWeaIJQPXr",12) == 2561167951) strcat(s, "n");
if (crc32("yhmnkrxnUVsyXqr",15) == 1986638540) strcat(s, "t");
if (crc32("RBBQhwvmLabiyp",14) == 3378363762) strcat(s, "h");
if (crc32("CWufO",5) == 139843588) strcat(s, "i");
if (crc32("cLVndCQvnp",10) == 173882998) strcat(s, "c");
if (crc32("CeSOUok",7) == 1577119968) strcat(s, "t");
if (crc32("cJhQIzJc",8) == 3692609410) strcat(s, "L");
if (crc32("fbkRRmfGCgrQU",13) == 270070141) strcat(s, "u");
if (crc32("mtqsw",5) == 1134015826) strcat(s, "K");
if (crc32("WRTRaDawt",9) == 3217212006) strcat(s, "b");
if (crc32("cHmpJkI",7) == 983585065) strcat(s, "e");
if (crc32("CeqOCJcAnZy",11) == 156821670) strcat(s, "r");
if (crc32("NOWxYBQnKB",10) == 4036415446) strcat(s, "d");
if (crc32("ZRhWMWXhbYFPSd",14) == 148042648) strcat(s, "c");
if (crc32("edsnYwFgRtwi",12) == 1437542764) strcat(s, "u");
if (crc32("UAtimfoSlrcRVG",14) == 2963095712) strcat(s, "l");
if (crc32("DnEwStujv",9) == 3617442007) strcat(s, "L");
if (crc32("ESogmqXIrSwu",12) == 1907704337) strcat(s, "o");
if (crc32("xxquzfDGGUsA",12) == 1157312868) strcat(s, "p");
if (crc32("itSbMjLPHB",10) == 3657377318) strcat(s, "u");
if (crc32("yTwUNO",6) == 1148902997) strcat(s, "s");
    return s;
}

char *nonmunicipal_adjectives() {
    char *s = calloc(13);
    if (crc32("RsEqFDhhWagBDje",15) == 3743072502) strcat(s, "n");
if (crc32("dLzQorpHzPi",11) == 3743762496) strcat(s, "j");
if (crc32("ZYZajqhfjSr",11) == 2109799406) strcat(s, "o");
if (crc32("HpPjeAey",8) == 2546802972) strcat(s, "x");
if (crc32("PKUFpl",6) == 1905302123) strcat(s, "n");
if (crc32("JsoGqqjy",8) == 2223291716) strcat(s, "w");
if (crc32("AuVtoNBnFJOJ",12) == 500469084) strcat(s, "m");
if (crc32("OAkRi",5) == 3343435062) strcat(s, "u");
if (crc32("nkQALijmHB",10) == 402297679) strcat(s, "r");
if (crc32("ogxZiKbtQoGIRf",14) == 2996640660) strcat(s, "n");
if (crc32("zgDvqEHoTL",10) == 3557047878) strcat(s, "f");
if (crc32("gmsgXwhH",8) == 2045640265) strcat(s, "i");
if (crc32("nwxJeOUGSX",10) == 4113110128) strcat(s, "e");
if (crc32("oTlmBx",6) == 681423206) strcat(s, "c");
if (crc32("PlpLM",5) == 2408654105) strcat(s, "i");
if (crc32("clZekZIYnKGIVbW",15) == 1009509363) strcat(s, "p");
if (crc32("tEuZZOOuJDLhLHm",15) == 2576675016) strcat(s, "n");
if (crc32("qOoekNaJBHFlp",13) == 787028011) strcat(s, "a");
if (crc32("IxybwZRmhZsYhL",14) == 2480252626) strcat(s, "b");
if (crc32("typsDMzmIRAm",12) == 4140081447) strcat(s, "l");
    return s;
}

char *putupon_adjectives() {
    char *s = calloc(8);
    if (crc32("JanEKhYIJbrEkJ",14) == 2235107933) strcat(s, "d");
if (crc32("mYZjsQaxtSfAD",13) == 551347087) strcat(s, "p");
if (crc32("ijYQmKzFTPmTIxB",15) == 2468412449) strcat(s, "w");
if (crc32("OUZkvviE",8) == 186919590) strcat(s, "u");
if (crc32("LzCQoGr",7) == 3726923827) strcat(s, "q");
if (crc32("ofkvAqiZYPYel",13) == 3003106809) strcat(s, "t");
if (crc32("FzOrC",5) == 2143655729) strcat(s, "b");
if (crc32("YdZgOU",6) == 1933176259) strcat(s, "u");
if (crc32("ySjrtPukK",9) == 4209959686) strcat(s, "p");
if (crc32("slCdXtgQpts",11) == 3119688207) strcat(s, "p");
if (crc32("xEPGN",5) == 3786043385) strcat(s, "o");
if (crc32("GzgLaZiid",9) == 4008016767) strcat(s, "n");
    return s;
}

char *processional_adjectives() {
    char *s = calloc(13);
    if (crc32("tCJWy",5) == 3808382172) strcat(s, "p");
if (crc32("FSkpF",5) == 908684058) strcat(s, "A");
if (crc32("ckdZKKOcjAZq",12) == 946751729) strcat(s, "r");
if (crc32("wTYNRhGWunjJ",12) == 2427860916) strcat(s, "o");
if (crc32("kPnbZCCTqKe",11) == 2302324225) strcat(s, "c");
if (crc32("yOKnZKwbXMjZxQ",14) == 2330306941) strcat(s, "e");
if (crc32("IxtNK",5) == 3779493705) strcat(s, "s");
if (crc32("mvObyjI",7) == 717800785) strcat(s, "s");
if (crc32("xFAJmTJg",8) == 2427614952) strcat(s, "i");
if (crc32("XumSVhXBn",9) == 3898852383) strcat(s, "o");
if (crc32("bacmUjkQJyypE",13) == 4018197265) strcat(s, "Q");
if (crc32("XovUopWSDMwwPf",14) == 1056164067) strcat(s, "n");
if (crc32("aFBaiSzdF",9) == 3558856843) strcat(s, "o");
if (crc32("ahPhHa",6) == 1425293353) strcat(s, "a");
if (crc32("zzYomm",6) == 1143565362) strcat(s, "F");
if (crc32("XawrMlIl",8) == 370775302) strcat(s, "l");
    return s;
}

char *superattainable_adjectives() {
    char *s = calloc(16);
    if (crc32("IzRcZPjz",8) == 1676867538) strcat(s, "s");
if (crc32("hIzBPBZO",8) == 554815120) strcat(s, "u");
if (crc32("LlUJsbXeGUVb",12) == 2900570901) strcat(s, "p");
if (crc32("jjoOe",5) == 1216988566) strcat(s, "e");
if (crc32("rpQEcNTQZhADS",13) == 1344658536) strcat(s, "x");
if (crc32("TKhHvmSqAOsJIqk",15) == 1663426368) strcat(s, "r");
if (crc32("eBUcmUtzpLm",11) == 3248488007) strcat(s, "F");
if (crc32("JTVfh",5) == 2297518153) strcat(s, "a");
if (crc32("qvwKDVA",7) == 609559576) strcat(s, "U");
if (crc32("FUxhpuNIQCSeR",13) == 1738732800) strcat(s, "t");
if (crc32("nJNvPbvTUoG",11) == 2825674309) strcat(s, "t");
if (crc32("DdNimki",7) == 3989351962) strcat(s, "a");
if (crc32("NTJJucntbJf",11) == 3151819448) strcat(s, "i");
if (crc32("PApscwvJbjEi",12) == 3130250447) strcat(s, "n");
if (crc32("hpKxZWvqplxdz",13) == 4225841373) strcat(s, "a");
if (crc32("mbZxhimbfZrcP",13) == 3120819492) strcat(s, "b");
if (crc32("FrZxO",5) == 935944964) strcat(s, "L");
if (crc32("zJznQibb",8) == 4105309876) strcat(s, "l");
if (crc32("tEbjTiwYMXkKw",13) == 3328498277) strcat(s, "e");
    return s;
}

char *halfformed_adjectives() {
    char *s = calloc(11);
    if (crc32("lhvfGbgkLQlN",12) == 972933196) strcat(s, "Y");
if (crc32("sXXdfUXiZbJ",11) == 1630459992) strcat(s, "h");
if (crc32("GOeRNkbToxo",11) == 1380491186) strcat(s, "a");
if (crc32("JGHFhZwzvX",10) == 672997506) strcat(s, "l");
if (crc32("hYPzGSkchfLED",13) == 926467687) strcat(s, "f");
if (crc32("gqmkpTT",7) == 899805458) strcat(s, "d");
if (crc32("vcDTSazQTR",10) == 460892456) strcat(s, "f");
if (crc32("qsxnTyoDowgc",12) == 3799310236) strcat(s, "o");
if (crc32("VlDjvnBiu",9) == 856391004) strcat(s, "r");
if (crc32("WbXtiDddMifJlvj",15) == 97889877) strcat(s, "J");
if (crc32("lzhbxoGec",9) == 2410168203) strcat(s, "m");
if (crc32("mvCNrodj",8) == 953024724) strcat(s, "y");
if (crc32("wxtME",5) == 868353898) strcat(s, "e");
if (crc32("DaiuupfKFQ",10) == 1999523773) strcat(s, "h");
if (crc32("glxrkDpvJkr",11) == 2471281673) strcat(s, "d");
    return s;
}

char *clannish_adjectives() {
    char *s = calloc(9);
    if (crc32("xbEHsmwvNg",10) == 3780640997) strcat(s, "l");
if (crc32("oTAyKd",6) == 2754161199) strcat(s, "c");
if (crc32("byYjkYUCREB",11) == 1463807091) strcat(s, "l");
if (crc32("yxuSscY",7) == 3786870244) strcat(s, "a");
if (crc32("dPBatutPMH",10) == 3114014820) strcat(s, "L");
if (crc32("WiPWjvNtC",9) == 1318375111) strcat(s, "n");
if (crc32("fDtHjSHqwI",10) == 1983026636) strcat(s, "B");
if (crc32("Qvioh",5) == 1796178059) strcat(s, "n");
if (crc32("KjrRMmwxmQcS",12) == 3904324315) strcat(s, "D");
if (crc32("qLKfcArZE",9) == 200234852) strcat(s, "i");
if (crc32("yVMFZhlRqM",10) == 411586512) strcat(s, "b");
if (crc32("zpejCmacU",9) == 2515448388) strcat(s, "s");
if (crc32("WfKjPKCujfqN",12) == 806723351) strcat(s, "h");
    return s;
}

char *nonsoporific_adjectives() {
    char *s = calloc(13);
    if (crc32("Zknuj",5) == 3854611370) strcat(s, "n");
if (crc32("BuFkKeu",7) == 1789493959) strcat(s, "o");
if (crc32("dbjLpEHfcCG",11) == 1437143468) strcat(s, "n");
if (crc32("xzlvSTcQbr",10) == 2176950969) strcat(s, "s");
if (crc32("KjWhWIr",7) == 4042113695) strcat(s, "o");
if (crc32("WkGgXKEPxGJDuh",14) == 1816538258) strcat(s, "p");
if (crc32("LZMlqyG",7) == 3972237259) strcat(s, "F");
if (crc32("zKRwQGUInlHodgL",15) == 4281720481) strcat(s, "o");
if (crc32("CtGRZNO",7) == 442051025) strcat(s, "r");
if (crc32("rMdLnvwCFL",10) == 4042284302) strcat(s, "i");
if (crc32("gNYWRHuohBFjhJE",15) == 821887522) strcat(s, "L");
if (crc32("clhNFp",6) == 298885250) strcat(s, "f");
if (crc32("hmsWljxOvW",10) == 2128435495) strcat(s, "j");
if (crc32("CljIWptKxflUOmc",15) == 2474296449) strcat(s, "i");
if (crc32("VHoqi",5) == 1913418382) strcat(s, "x");
if (crc32("jFqummMOXbWDHA",14) == 810574349) strcat(s, "c");
    return s;
}

char *nonintroversive_adjectives() {
    char *s = calloc(16);
    if (crc32("ufkgUhA",7) == 1930049953) strcat(s, "n");
if (crc32("RgtrkL",6) == 563259308) strcat(s, "R");
if (crc32("PLTPUAdke",9) == 371817613) strcat(s, "o");
if (crc32("lTXOuYUDiMxdL",13) == 399232154) strcat(s, "q");
if (crc32("vlSfxCGha",9) == 2351133585) strcat(s, "n");
if (crc32("ppFcoeL",7) == 3231456194) strcat(s, "Z");
if (crc32("BOfdczuCNb",10) == 3488233125) strcat(s, "i");
if (crc32("LLmzBcgEl",9) == 1870080207) strcat(s, "n");
if (crc32("SUZDXBWGrnPNK",13) == 4047611246) strcat(s, "w");
if (crc32("vzptE",5) == 2904998711) strcat(s, "t");
if (crc32("TiMASCwIIzkATeG",15) == 77151665) strcat(s, "E");
if (crc32("WEzxIoTVB",9) == 386823486) strcat(s, "r");
if (crc32("nsXgO",5) == 1728127512) strcat(s, "X");
if (crc32("kgyQsLyPPTvj",12) == 4118787057) strcat(s, "o");
if (crc32("XwKqiBtDWMLL",12) == 1549939327) strcat(s, "h");
if (crc32("NwombTdXSNYwGW",14) == 603650963) strcat(s, "v");
if (crc32("lkTeaSgbLZytE",13) == 566981805) strcat(s, "T");
if (crc32("cNZGNnoNDftHbct",15) == 3820027995) strcat(s, "e");
if (crc32("hUkoLNld",8) == 722845722) strcat(s, "W");
if (crc32("lSdtWphWQAak",12) == 3152196366) strcat(s, "r");
if (crc32("eDuSl",5) == 3543198035) strcat(s, "U");
if (crc32("ktqnZuLl",8) == 4172998899) strcat(s, "s");
if (crc32("yclxTUqvUD",10) == 2257954084) strcat(s, "i");
if (crc32("JuykNPzGwNOkp",13) == 484921476) strcat(s, "v");
if (crc32("LJBCWOBGU",9) == 3961507528) strcat(s, "A");
if (crc32("gpwoJKFkzzOQVb",14) == 1513280362) strcat(s, "e");
    return s;
}

char *kenspeckle_adjectives() {
    char *s = calloc(11);
    if (crc32("dTLVHOY",7) == 755250586) strcat(s, "J");
if (crc32("CVHgFeqC",8) == 1673442049) strcat(s, "k");
if (crc32("YcqKDdDAFPa",11) == 2557002764) strcat(s, "e");
if (crc32("SJhwnJSOGeS",11) == 350142910) strcat(s, "n");
if (crc32("cTwmPqEs",8) == 4130557189) strcat(s, "O");
if (crc32("SkBNYSNkkUbQsf",14) == 1319623550) strcat(s, "s");
if (crc32("YZsEqlLTfx",10) == 1051316831) strcat(s, "p");
if (crc32("eoMolBGjkQMkqM",14) == 3732053105) strcat(s, "e");
if (crc32("owTUYg",6) == 2502248123) strcat(s, "c");
if (crc32("peQFGJfwI",9) == 4015845185) strcat(s, "k");
if (crc32("olvLQjWYzYrzigm",15) == 4152365139) strcat(s, "c");
if (crc32("dSrmFaGyKkClndA",15) == 688241704) strcat(s, "l");
if (crc32("grtyGjIMQmV",11) == 2786861529) strcat(s, "W");
if (crc32("iQRTKpSZg",9) == 359955070) strcat(s, "e");
    return s;
}

char *stagey_adjectives() {
    char *s = calloc(7);
    if (crc32("xqdPdjtXKLWMTay",15) == 2819392135) strcat(s, "g");
if (crc32("bnTmUpweKeDlSo",14) == 298362385) strcat(s, "s");
if (crc32("KtMqNwGOnalw",12) == 2963309891) strcat(s, "t");
if (crc32("jDlWCojC",8) == 3685025347) strcat(s, "a");
if (crc32("kFIXUMQjFCs",11) == 4258385211) strcat(s, "S");
if (crc32("leXRafZc",8) == 3268001062) strcat(s, "g");
if (crc32("XjTGzmGRpvNeKFO",15) == 1799282614) strcat(s, "m");
if (crc32("LGFYACBdiyLtoa",14) == 2773572320) strcat(s, "e");
if (crc32("dbnqfrMlFN",10) == 2217108752) strcat(s, "y");
    return s;
}

char *unilluminant_adjectives() {
    char *s = calloc(13);
    if (crc32("uMqbgVNE",8) == 558818369) strcat(s, "u");
if (crc32("ftVuovlFmBwXbX",14) == 241172316) strcat(s, "v");
if (crc32("HgDlkcqGYcA",11) == 3653968381) strcat(s, "n");
if (crc32("mEWlDsjyX",9) == 3118990008) strcat(s, "i");
if (crc32("xlIRI",5) == 3688177020) strcat(s, "K");
if (crc32("ggwCBmxcf",9) == 4290389520) strcat(s, "l");
if (crc32("sirBgeh",7) == 3412312942) strcat(s, "l");
if (crc32("ZJQaofoie",9) == 1309575041) strcat(s, "C");
if (crc32("EMEoSWWrGF",10) == 2303094663) strcat(s, "u");
if (crc32("wJzLZc",6) == 1548447058) strcat(s, "m");
if (crc32("GZNxzh",6) == 1722557165) strcat(s, "i");
if (crc32("CSrpkQELhjLtf",13) == 1444480649) strcat(s, "n");
if (crc32("COvRIM",6) == 2595955969) strcat(s, "j");
if (crc32("iUyHpji",7) == 2330890209) strcat(s, "a");
if (crc32("GYZFibSYvawUh",13) == 2705515570) strcat(s, "g");
if (crc32("BayMJRHWFHc",11) == 846626811) strcat(s, "n");
if (crc32("fnpumlahCCXj",12) == 3130686107) strcat(s, "M");
if (crc32("VrPMIxxy",8) == 1404068892) strcat(s, "t");
    return s;
}

char *jacketlike_adjectives() {
    char *s = calloc(11);
    if (crc32("xHEkXYda",8) == 1337263457) strcat(s, "n");
if (crc32("NYXBBHsWHGnvW",13) == 3616268249) strcat(s, "j");
if (crc32("KoPNFcUaLAsyrV",14) == 672377558) strcat(s, "a");
if (crc32("YAxteHuIkQysdox",15) == 611545654) strcat(s, "c");
if (crc32("akxDzZ",6) == 469680121) strcat(s, "k");
if (crc32("HSyAncPtHL",10) == 1055658195) strcat(s, "B");
if (crc32("pRzwEkpELoLICFP",15) == 1725393735) strcat(s, "e");
if (crc32("OhHYeFPVgUr",11) == 562110609) strcat(s, "t");
if (crc32("UjGMEtyBVCYQLyV",15) == 3206426296) strcat(s, "l");
if (crc32("MGDZEAx",7) == 1656956989) strcat(s, "i");
if (crc32("DsyAgYp",7) == 4153483442) strcat(s, "f");
if (crc32("ofdiQBpGumhZH",13) == 1512740574) strcat(s, "k");
if (crc32("lumdKORsOLB",11) == 3827815382) strcat(s, "e");
    return s;
}

char *unvibrating_adjectives() {
    char *s = calloc(12);
    if (crc32("xxSjhLY",7) == 3098879697) strcat(s, "a");
if (crc32("FTDBiLFOuPkzVOC",15) == 4203233246) strcat(s, "u");
if (crc32("tSKwzSRvzAFKs",13) == 912913158) strcat(s, "n");
if (crc32("KTRHATGvWbhgJe",14) == 786016887) strcat(s, "v");
if (crc32("eANqhUBNdsfpVQ",14) == 1300184597) strcat(s, "i");
if (crc32("cMSvvAFQp",9) == 749839721) strcat(s, "b");
if (crc32("kVPhjXwYss",10) == 2249643571) strcat(s, "j");
if (crc32("OJHAggUZM",9) == 1127408837) strcat(s, "r");
if (crc32("LiArRSkLLLYMQQ",14) == 1377794997) strcat(s, "a");
if (crc32("VKTxxWSHPFMO",12) == 495301927) strcat(s, "i");
if (crc32("tqLbx",5) == 1768354404) strcat(s, "t");
if (crc32("vZJao",5) == 3370525581) strcat(s, "i");
if (crc32("zhHIA",5) == 3577448877) strcat(s, "n");
if (crc32("AtFyuwwpqFAd",12) == 2012176257) strcat(s, "g");
    return s;
}

char *interparliament_adjectives() {
    char *s = calloc(16);
    if (crc32("PPbBgwUwIJ",10) == 759870052) strcat(s, "i");
if (crc32("UFvtkCiDI",9) == 3997546545) strcat(s, "J");
if (crc32("MllFQtn",7) == 2837196129) strcat(s, "n");
if (crc32("loxMuFqYGR",10) == 4218887940) strcat(s, "B");
if (crc32("jvALanHOGh",10) == 4244047034) strcat(s, "t");
if (crc32("MbxmeNWCih",10) == 52801411) strcat(s, "e");
if (crc32("pgWfcRVFvCCz",12) == 1347361482) strcat(s, "I");
if (crc32("lSaLltYgJTcu",12) == 3741447122) strcat(s, "r");
if (crc32("RzuAGSXG",8) == 293322519) strcat(s, "x");
if (crc32("wesERHTwIRym",12) == 2066704149) strcat(s, "p");
if (crc32("mFkgTtJG",8) == 3046069569) strcat(s, "a");
if (crc32("EIVCMzWG",8) == 3519441325) strcat(s, "I");
if (crc32("irYWNMqqnrrb",12) == 342625930) strcat(s, "r");
if (crc32("yjtkDpCpOCFn",12) == 2882132239) strcat(s, "a");
if (crc32("HlsLWaIhl",9) == 1054865866) strcat(s, "l");
if (crc32("qYKRvxtbvKVJUv",14) == 3529610550) strcat(s, "i");
if (crc32("Cdscr",5) == 3411626925) strcat(s, "a");
if (crc32("XbcoRAddgs",10) == 616143607) strcat(s, "m");
if (crc32("mXORGNxE",8) == 2915631694) strcat(s, "u");
if (crc32("JcpPwlVZswpkoNF",15) == 3118764219) strcat(s, "e");
if (crc32("QoyLRmcLzsU",11) == 2574000659) strcat(s, "n");
if (crc32("HNqabw",6) == 2843736962) strcat(s, "I");
if (crc32("PWTMK",5) == 1736909041) strcat(s, "t");
    return s;
}

char *esquamate_adjectives() {
    char *s = calloc(10);
    if (crc32("StgzPavXM",9) == 2747024812) strcat(s, "N");
if (crc32("DfMNDtJBl",9) == 3507835292) strcat(s, "e");
if (crc32("GetCwRQ",7) == 1008432916) strcat(s, "n");
if (crc32("xQfexC",6) == 195201716) strcat(s, "s");
if (crc32("nwqKOggyibdHP",13) == 2776688267) strcat(s, "M");
if (crc32("Uwxrmgfbz",9) == 2368135243) strcat(s, "q");
if (crc32("urssHZLyaQ",10) == 2180030880) strcat(s, "x");
if (crc32("RKVOitVTr",9) == 147013476) strcat(s, "u");
if (crc32("zxEaqP",6) == 3521964504) strcat(s, "F");
if (crc32("IxEHAWlxjzyHrtM",15) == 2518380602) strcat(s, "a");
if (crc32("ZGuBviFzIjqB",12) == 2704714823) strcat(s, "m");
if (crc32("ZEIOWdWQcsD",11) == 1904065577) strcat(s, "b");
if (crc32("wDJWlQ",6) == 1122543606) strcat(s, "a");
if (crc32("PfJUfiVWVClF",12) == 3186405913) strcat(s, "Y");
if (crc32("GRkPFMLibnBaR",13) == 3573414261) strcat(s, "t");
if (crc32("PmRgpdWhy",9) == 1520346417) strcat(s, "x");
if (crc32("WIqsaNHdHhekL",13) == 1182072944) strcat(s, "e");
    return s;
}

char *recessive_adjectives() {
    char *s = calloc(10);
    if (crc32("QWmHZIDxgj",10) == 2578181549) strcat(s, "x");
if (crc32("JEByZQTFa",9) == 3309365611) strcat(s, "r");
if (crc32("KnlfwvbmzzanrJk",15) == 1116744264) strcat(s, "w");
if (crc32("lPBSHycmTiVV",12) == 4268323853) strcat(s, "e");
if (crc32("MxmeHnYenKqzO",13) == 970304583) strcat(s, "c");
if (crc32("SoKVCLIceYEN",12) == 898474277) strcat(s, "e");
if (crc32("XfPkkARBXe",10) == 741698197) strcat(s, "r");
if (crc32("sOZJDN",6) == 974852114) strcat(s, "s");
if (crc32("udzZhuHEyCC",11) == 2222689445) strcat(s, "K");
if (crc32("EpUIEufb",8) == 2407312982) strcat(s, "s");
if (crc32("sAlUMbjpF",9) == 516548301) strcat(s, "i");
if (crc32("IoXlmmXkL",9) == 3838227498) strcat(s, "g");
if (crc32("LqDBtoYFnDVfW",13) == 1012344656) strcat(s, "v");
if (crc32("GkIZODA",7) == 360439370) strcat(s, "b");
if (crc32("WLCQpJLbBmE",11) == 728488005) strcat(s, "e");
    return s;
}

char *gutless_adjectives() {
    char *s = calloc(8);
    if (crc32("GfrLOovKdez",11) == 4149734801) strcat(s, "G");
if (crc32("oTZSClQ",7) == 2070849765) strcat(s, "g");
if (crc32("DTflHHxTapZ",11) == 3781316742) strcat(s, "u");
if (crc32("SbqJFjADqlKVOXF",15) == 3412824293) strcat(s, "k");
if (crc32("mOnRRISzzbVcz",13) == 3717293937) strcat(s, "t");
if (crc32("pvOUFdmet",9) == 4270812337) strcat(s, "l");
if (crc32("HmntvLGTDTu",11) == 4219974211) strcat(s, "e");
if (crc32("ijwhJqFnQZUQgd",14) == 1675491827) strcat(s, "e");
if (crc32("ceNLOmZOdIQPkYD",15) == 1327386317) strcat(s, "s");
if (crc32("lTAOdRg",7) == 2453273563) strcat(s, "B");
if (crc32("SejnrdmMFudYrNM",15) == 1125203837) strcat(s, "s");
    return s;
}

char *phymatic_adjectives() {
    char *s = calloc(9);
    if (crc32("nJCrixDksmKOa",13) == 2273583995) strcat(s, "p");
if (crc32("UxllayXXNW",10) == 1109893645) strcat(s, "q");
if (crc32("uYrJOdvyV",9) == 2165186433) strcat(s, "h");
if (crc32("XtYcDBpkngQDqM",14) == 2293556506) strcat(s, "T");
if (crc32("yeKHoczDy",9) == 1365143571) strcat(s, "y");
if (crc32("akopyCFTX",9) == 3831482848) strcat(s, "m");
if (crc32("GIhtAXwmDqCRsT",14) == 2239925694) strcat(s, "a");
if (crc32("uIgOdohytM",10) == 2268962808) strcat(s, "t");
if (crc32("PQssdjGHXfVI",12) == 1034327475) strcat(s, "J");
if (crc32("ycBjn",5) == 1567996818) strcat(s, "i");
if (crc32("VsjbnEMYCeregUv",15) == 2482795295) strcat(s, "c");
    return s;
}

char *Darwinistic_adjectives() {
    char *s = calloc(12);
    if (crc32("PoOvmRo",7) == 4006628070) strcat(s, "E");
if (crc32("MWwNSUzqmbPB",12) == 3797968439) strcat(s, "D");
if (crc32("PPVKxFXtg",9) == 1762663378) strcat(s, "a");
if (crc32("QbYXLDuTsjBsOJq",15) == 1614151567) strcat(s, "r");
if (crc32("vUsqHuGmniRNVU",14) == 988095911) strcat(s, "m");
if (crc32("ilDoFpLby",9) == 1668662060) strcat(s, "w");
if (crc32("tYkBVlHnPhrlabD",15) == 1187550791) strcat(s, "i");
if (crc32("NIWBHnwH",8) == 669898485) strcat(s, "X");
if (crc32("agCoK",5) == 3040262835) strcat(s, "n");
if (crc32("qvVVJyLvXT",10) == 1865351201) strcat(s, "i");
if (crc32("iQriiC",6) == 3358768016) strcat(s, "t");
if (crc32("tUrFZSFBcwwTp",13) == 1250113457) strcat(s, "s");
if (crc32("lQCJLXntLLbbpm",14) == 1822532552) strcat(s, "H");
if (crc32("tQDJGn",6) == 1481333486) strcat(s, "t");
if (crc32("KYFFKbA",7) == 2921190804) strcat(s, "P");
if (crc32("eRgYvcV",7) == 68626162) strcat(s, "i");
if (crc32("QkuMc",5) == 3961571957) strcat(s, "c");
    return s;
}

char *multiarticulate_adjectives() {
    char *s = calloc(16);
    if (crc32("kjkFRjTXZpldHO",14) == 1045643691) strcat(s, "u");
if (crc32("DqjwTLVmLyspBow",15) == 2816273417) strcat(s, "m");
if (crc32("gtLntR",6) == 4124857803) strcat(s, "u");
if (crc32("nntvqRUtQy",10) == 3092817062) strcat(s, "l");
if (crc32("qoYirL",6) == 1651856005) strcat(s, "c");
if (crc32("xttvYXvLJq",10) == 895219020) strcat(s, "t");
if (crc32("afYzusq",7) == 2911734983) strcat(s, "g");
if (crc32("MwsQyViWkCsUbED",15) == 2769446582) strcat(s, "i");
if (crc32("hrQoFAvTTdS",11) == 1454000263) strcat(s, "a");
if (crc32("znEMZwpR",8) == 597277331) strcat(s, "r");
if (crc32("HaRzI",5) == 2564023909) strcat(s, "t");
if (crc32("mzuqZSpowiX",11) == 3699102929) strcat(s, "i");
if (crc32("GaIPHkhrS",9) == 2964127792) strcat(s, "c");
if (crc32("ZcylUu",6) == 166588185) strcat(s, "f");
if (crc32("NofTkMlFyKn",11) == 187550884) strcat(s, "u");
if (crc32("zmEPgb",6) == 3611084116) strcat(s, "q");
if (crc32("nxhIEbaa",8) == 1867184330) strcat(s, "l");
if (crc32("cwcoDyaqKMbDxM",14) == 3127889879) strcat(s, "Z");
if (crc32("VzCjws",6) == 3185886389) strcat(s, "a");
if (crc32("RAGoWggTBZo",11) == 2379455690) strcat(s, "u");
if (crc32("fQmVIHs",7) == 3019623861) strcat(s, "t");
if (crc32("QZpmpt",6) == 2577836439) strcat(s, "B");
if (crc32("VqDBPCyz",8) == 4252162882) strcat(s, "e");
    return s;
}

char *extortionary_adjectives() {
    char *s = calloc(13);
    if (crc32("hRutiKytPjIe",12) == 4086285475) strcat(s, "e");
if (crc32("DMpJcxL",7) == 1099449356) strcat(s, "x");
if (crc32("KwRJze",6) == 386806502) strcat(s, "Y");
if (crc32("PIaDSFgoE",9) == 1929784861) strcat(s, "t");
if (crc32("ubOwxvOFiQAWcH",14) == 895461609) strcat(s, "D");
if (crc32("GAtexBAd",8) == 458217314) strcat(s, "o");
if (crc32("IXUlkRbEVxc",11) == 1076157732) strcat(s, "V");
if (crc32("HbOyNgSTczsin",13) == 3098638985) strcat(s, "r");
if (crc32("cORUHQYNoxFvjNy",15) == 2265183902) strcat(s, "t");
if (crc32("AVazKPGkUOh",11) == 3334511057) strcat(s, "p");
if (crc32("bfGZRSoBlkpnnvP",15) == 2568754310) strcat(s, "i");
if (crc32("DgLtyQPhtUzeDBJ",15) == 82961285) strcat(s, "o");
if (crc32("tJNHzrZL",8) == 1829063415) strcat(s, "n");
if (crc32("EyWzf",5) == 1492427286) strcat(s, "n");
if (crc32("kuMHuZf",7) == 122580017) strcat(s, "a");
if (crc32("ohyPGE",6) == 2418082969) strcat(s, "Y");
if (crc32("aZANbkYMNKjniJ",14) == 2520789936) strcat(s, "r");
if (crc32("CDgAPzABRzndi",13) == 1617387182) strcat(s, "B");
if (crc32("CnqhQjCMYFw",11) == 1578820412) strcat(s, "y");
    return s;
}

char *nonallegorical_adjectives() {
    char *s = calloc(15);
    if (crc32("uhNwpUgaOui",11) == 2470749987) strcat(s, "n");
if (crc32("TxFJqbnpzXQedN",14) == 2848451936) strcat(s, "o");
if (crc32("ULwUqmziZh",10) == 2987133579) strcat(s, "n");
if (crc32("mvvjShWyssrh",12) == 507620079) strcat(s, "a");
if (crc32("XumdtD",6) == 556301105) strcat(s, "G");
if (crc32("gqscDUIg",8) == 710671392) strcat(s, "l");
if (crc32("jnDDANF",7) == 1530834976) strcat(s, "z");
if (crc32("TlAMRvlWfYRgP",13) == 1912802149) strcat(s, "l");
if (crc32("hFyNLLO",7) == 1300321800) strcat(s, "y");
if (crc32("QXBBexTpocCw",12) == 1644028089) strcat(s, "e");
if (crc32("QwtFTaICJKsQW",13) == 1486748474) strcat(s, "e");
if (crc32("PIRGupBdUMm",11) == 835500896) strcat(s, "g");
if (crc32("zTJBVtk",7) == 137856524) strcat(s, "C");
if (crc32("plLiW",5) == 1991262068) strcat(s, "o");
if (crc32("vrwPbhtmeMDI",12) == 1141040422) strcat(s, "r");
if (crc32("fdZyOdQOlLZMrFI",15) == 2427185560) strcat(s, "C");
if (crc32("ytZNAKRV",8) == 3509516861) strcat(s, "i");
if (crc32("SjxACf",6) == 2513446019) strcat(s, "o");
if (crc32("GBHaOHbPV",9) == 1961709952) strcat(s, "c");
if (crc32("HaMKqABHZIqq",12) == 2301319403) strcat(s, "a");
if (crc32("vFGiOXMMDKRX",12) == 1952424817) strcat(s, "l");
    return s;
}

char *typical_adjectives() {
    char *s = calloc(8);
    if (crc32("FuKhOHgLCLTJabn",15) == 3878836333) strcat(s, "S");
if (crc32("lVYFmjkJeiGx",12) == 2421156204) strcat(s, "t");
if (crc32("NuBrcFldvWA",11) == 3148654664) strcat(s, "D");
if (crc32("mZbmalEfNf",10) == 3985725813) strcat(s, "y");
if (crc32("bWBgkWgWhkMKj",13) == 1605221093) strcat(s, "m");
if (crc32("UyxVBdoikxvWBN",14) == 2919703760) strcat(s, "p");
if (crc32("AFbtZnHI",8) == 6578069) strcat(s, "w");
if (crc32("dyDUQCJXDmuc",12) == 3795797369) strcat(s, "i");
if (crc32("xPRAHaAdqDXmBa",14) == 3946609146) strcat(s, "W");
if (crc32("BXNGDmtL",8) == 2707518524) strcat(s, "c");
if (crc32("yvtIOsbu",8) == 2125584344) strcat(s, "a");
if (crc32("JvWwoGmJhOZRfqg",15) == 963228691) strcat(s, "Q");
if (crc32("iNtnVcXXgMizfKV",15) == 2276004503) strcat(s, "l");
    return s;
}

char *unassayed_adjectives() {
    char *s = calloc(10);
    if (crc32("LPnccXhwaLe",11) == 1485206359) strcat(s, "R");
if (crc32("XGLVqRMXR",9) == 2136227730) strcat(s, "u");
if (crc32("fniaLoJgrtPCn",13) == 3422000760) strcat(s, "n");
if (crc32("jCMzFnRwfMMEjwr",15) == 912810207) strcat(s, "q");
if (crc32("CEewgKTm",8) == 4028811937) strcat(s, "a");
if (crc32("ASNicwSEQo",10) == 4022476322) strcat(s, "s");
if (crc32("NDUOZhLTaD",10) == 4235549895) strcat(s, "s");
if (crc32("ZEJaN",5) == 2294593055) strcat(s, "a");
if (crc32("WFqIXuvTRKI",11) == 4083732758) strcat(s, "j");
if (crc32("RrSaaCcfjzwyPDW",15) == 3218814289) strcat(s, "y");
if (crc32("IHEGL",5) == 2070029989) strcat(s, "e");
if (crc32("CJXQemEMsRQyEoe",15) == 63448468) strcat(s, "p");
if (crc32("NogiRQFgRD",10) == 1791860248) strcat(s, "d");
    return s;
}

char *larine_adjectives() {
    char *s = calloc(7);
    if (crc32("zvFeXXRLAMN",11) == 2143516250) strcat(s, "l");
if (crc32("BWeCGHjjX",9) == 1430535088) strcat(s, "I");
if (crc32("BQaCQ",5) == 428689472) strcat(s, "a");
if (crc32("abzFPaVyp",9) == 327661208) strcat(s, "N");
if (crc32("pkWJOXYqEL",10) == 2471684728) strcat(s, "r");
if (crc32("VxsGGTLMlDFHrX",14) == 3473230163) strcat(s, "A");
if (crc32("htpzNp",6) == 1435579446) strcat(s, "i");
if (crc32("GVFbmLpLFkYVDPU",15) == 715529066) strcat(s, "n");
if (crc32("kJsKoeXIWYguibW",15) == 3391099246) strcat(s, "n");
if (crc32("TCaIUPXtLNDCt",13) == 2185368246) strcat(s, "e");
    return s;
}

char *unconglutinated_adjectives() {
    char *s = calloc(16);
    if (crc32("dxVxumwxjKaDT",13) == 2266533785) strcat(s, "u");
if (crc32("QTxqhwOWuDBzM",13) == 387879791) strcat(s, "E");
if (crc32("MtfTKcUZ",8) == 2522202783) strcat(s, "n");
if (crc32("MixDAx",6) == 397061875) strcat(s, "R");
if (crc32("rMiDQr",6) == 2069721089) strcat(s, "c");
if (crc32("HuJNCqXzNlk",11) == 2962691871) strcat(s, "o");
if (crc32("bUXwOpCoQtZ",11) == 1006183932) strcat(s, "n");
if (crc32("HriBVzIPFFOziR",14) == 2094843382) strcat(s, "h");
if (crc32("JcBiRVxGsK",10) == 2990390356) strcat(s, "g");
if (crc32("iKwuyUaSqYUd",12) == 3920778522) strcat(s, "C");
if (crc32("KyvzG",5) == 2451710206) strcat(s, "l");
if (crc32("NXJRiNBjTQW",11) == 2452372748) strcat(s, "U");
if (crc32("wVcgiwEUqLEkR",13) == 2647696139) strcat(s, "u");
if (crc32("sdNYZZX",7) == 2445728111) strcat(s, "o");
if (crc32("hhznVvXhC",9) == 2701338357) strcat(s, "t");
if (crc32("KppoiHiOyh",10) == 1675226835) strcat(s, "i");
if (crc32("NZDgmbUujvZuIIh",15) == 2036429318) strcat(s, "o");
if (crc32("nNCHQdzVQUtrzXX",15) == 157115340) strcat(s, "n");
if (crc32("rSERr",5) == 3697247251) strcat(s, "a");
if (crc32("rvLJUCJ",7) == 526766020) strcat(s, "Z");
if (crc32("QpjVCmjmJWRjGm",14) == 2084667529) strcat(s, "t");
if (crc32("MxQRtUCf",8) == 2629432362) strcat(s, "x");
if (crc32("iAvuboqk",8) == 2589186213) strcat(s, "e");
if (crc32("hhfCFGsRxdgEKF",14) == 660087084) strcat(s, "U");
if (crc32("qfZNMdYHrKDKm",13) == 54211592) strcat(s, "d");
    return s;
}

char *monkish_adjectives() {
    char *s = calloc(8);
    if (crc32("mKuNEQdRS",9) == 1648614380) strcat(s, "m");
if (crc32("IzQlKD",6) == 2058832813) strcat(s, "o");
if (crc32("rKWaNOrEA",9) == 2523263675) strcat(s, "n");
if (crc32("HZNSMUbeeDeiYyk",15) == 2653399609) strcat(s, "k");
if (crc32("fLrwpVxYiyzZi",13) == 511003082) strcat(s, "i");
if (crc32("KtzqnSj",7) == 1435168326) strcat(s, "s");
if (crc32("suriANd",7) == 2336400033) strcat(s, "h");
    return s;
}

char *alkaloidal_adjectives() {
    char *s = calloc(11);
    if (crc32("ropqjxVrf",9) == 2975934753) strcat(s, "a");
if (crc32("aFwvOYr",7) == 3267268145) strcat(s, "l");
if (crc32("XQFpbZrPDgnh",12) == 301896697) strcat(s, "k");
if (crc32("ekqMELLNLpt",11) == 3336939083) strcat(s, "w");
if (crc32("fqjzrtl",7) == 978745966) strcat(s, "a");
if (crc32("giaiUilKp",9) == 2802677524) strcat(s, "l");
if (crc32("ugNqUjx",7) == 1702125964) strcat(s, "b");
if (crc32("vHoyTJN",7) == 214823056) strcat(s, "o");
if (crc32("BpDxRvNKuP",10) == 276385120) strcat(s, "b");
if (crc32("jaYPDKFoyUZs",12) == 3273233766) strcat(s, "i");
if (crc32("OdgtBeVKZCw",11) == 1804642036) strcat(s, "G");
if (crc32("bdUBTWzSc",9) == 1950544729) strcat(s, "d");
if (crc32("iwKBTElZMvJ",11) == 2225575014) strcat(s, "a");
if (crc32("kstvEMMxMdOvvN",14) == 3130308839) strcat(s, "l");
    return s;
}

char *frigid_adjectives() {
    char *s = calloc(7);
    if (crc32("aRMSPh",6) == 3471787456) strcat(s, "f");
if (crc32("IKrCD",5) == 1285001551) strcat(s, "I");
if (crc32("hEbWkfG",7) == 1343580614) strcat(s, "r");
if (crc32("ZbAGwgu",7) == 1336879584) strcat(s, "m");
if (crc32("ogqGjURHynT",11) == 4240324340) strcat(s, "i");
if (crc32("DvAQDUjOvA",10) == 3956883949) strcat(s, "y");
if (crc32("GhfeiUgNptUuaXW",15) == 1229593842) strcat(s, "g");
if (crc32("ySjxDTrYguObO",13) == 2448220386) strcat(s, "i");
if (crc32("EtAVdgXdbeP",11) == 2265427636) strcat(s, "d");
    return s;
}

char *unpugnacious_adjectives() {
    char *s = calloc(13);
    if (crc32("vSTAskgFW",9) == 3134933894) strcat(s, "I");
if (crc32("rPyXqclbLb",10) == 461297087) strcat(s, "u");
if (crc32("ynKphuL",7) == 4138839451) strcat(s, "H");
if (crc32("kkRTyFcNIOEgbZw",15) == 1299980231) strcat(s, "n");
if (crc32("aAEMkmWGsNokB",13) == 393574325) strcat(s, "w");
if (crc32("wKYUn",5) == 3480151183) strcat(s, "p");
if (crc32("WzYhNwA",7) == 26700363) strcat(s, "u");
if (crc32("YXvEQ",5) == 448062267) strcat(s, "W");
if (crc32("EUgTiybBtDqvdT",14) == 2007601073) strcat(s, "g");
if (crc32("JODgNoXLNHvunGO",15) == 2579546596) strcat(s, "n");
if (crc32("FNvzpnJuZosnZN",14) == 1481652598) strcat(s, "f");
if (crc32("IGFWWJ",6) == 3342410391) strcat(s, "a");
if (crc32("FkOGihKbiNUSQe",14) == 1518347744) strcat(s, "c");
if (crc32("wMNpHOGdusge",12) == 1844303803) strcat(s, "i");
if (crc32("ekABQTQEXAiU",12) == 137014055) strcat(s, "j");
if (crc32("kGkYOMSeWWjYo",13) == 1110132533) strcat(s, "o");
if (crc32("PeQsqSDqozHsKH",14) == 3115565389) strcat(s, "u");
if (crc32("jeWyaJF",7) == 1008324999) strcat(s, "Z");
if (crc32("JDUTiDJ",7) == 408467293) strcat(s, "s");
    return s;
}

char *quasimalicious_adjectives() {
    char *s = calloc(15);
    if (crc32("vzWjpuaOjHorHV",14) == 338564365) strcat(s, "q");
if (crc32("vZHgskdKlq",10) == 241017653) strcat(s, "u");
if (crc32("OoKqDEl",7) == 2494855919) strcat(s, "a");
if (crc32("qpVEzuGMuxsgFRr",15) == 3857912508) strcat(s, "Q");
if (crc32("XbeGGFp",7) == 478694588) strcat(s, "s");
if (crc32("feOCgWY",7) == 1230872450) strcat(s, "Z");
if (crc32("gqbBDMK",7) == 312888230) strcat(s, "i");
if (crc32("VunDADBYy",9) == 216663260) strcat(s, "m");
if (crc32("EyYijStrqb",10) == 1664248534) strcat(s, "a");
if (crc32("jWdkysoKxAJBah",14) == 359019951) strcat(s, "l");
if (crc32("WJCMenTivYVyM",13) == 4042638919) strcat(s, "i");
if (crc32("qZffGUZzmn",10) == 2260646977) strcat(s, "c");
if (crc32("OdcRyVzpdCrlHa",14) == 690609807) strcat(s, "G");
if (crc32("JfREzSPfKstqTsY",15) == 2351810220) strcat(s, "i");
if (crc32("QNNmc",5) == 3009322374) strcat(s, "T");
if (crc32("LSzcoheaVkDF",12) == 3352446353) strcat(s, "o");
if (crc32("WRiplFInBIr",11) == 751845707) strcat(s, "u");
if (crc32("vvoeje",6) == 2511905396) strcat(s, "s");
    return s;
}

char *attent_adjectives() {
    char *s = calloc(7);
    if (crc32("PotSvhhZc",9) == 33312222) strcat(s, "v");
if (crc32("PQStnzArqfQd",12) == 3174817696) strcat(s, "a");
if (crc32("plqlihuJ",8) == 3715312492) strcat(s, "t");
if (crc32("IpMnmKvrFCESrG",14) == 2619915893) strcat(s, "r");
if (crc32("gNDLaTJrElaEfbo",15) == 4026416110) strcat(s, "t");
if (crc32("auhje",5) == 2935745018) strcat(s, "L");
if (crc32("ilisLTBbC",9) == 276401632) strcat(s, "e");
if (crc32("WRZzi",5) == 4009167557) strcat(s, "z");
if (crc32("owCQmWM",7) == 667892376) strcat(s, "n");
if (crc32("SVOPrUR",7) == 1374954099) strcat(s, "t");
    return s;
}

char *nondoubting_adjectives() {
    char *s = calloc(12);
    if (crc32("YiOnESSdb",9) == 4070406882) strcat(s, "n");
if (crc32("MZdwrrtV",8) == 3616559909) strcat(s, "o");
if (crc32("zACBnlW",7) == 1093680427) strcat(s, "n");
if (crc32("zaEywvasbGWdyT",14) == 4048635979) strcat(s, "x");
if (crc32("iVsxyJtlSON",11) == 1617004441) strcat(s, "d");
if (crc32("GDZGtfPr",8) == 491726626) strcat(s, "o");
if (crc32("lbSKuhyEdsywFhg",15) == 3596859612) strcat(s, "Y");
if (crc32("kxFCpkGwVuxA",12) == 878707267) strcat(s, "u");
if (crc32("bfOWdevdJmZFvI",14) == 400381052) strcat(s, "j");
if (crc32("fslJubNpUwqpm",13) == 1494753216) strcat(s, "b");
if (crc32("oqLcXEJngBkvwyn",15) == 1512520866) strcat(s, "M");
if (crc32("tOgDvVqvod",10) == 906275855) strcat(s, "t");
if (crc32("sDaZaDIhTvf",11) == 2017128072) strcat(s, "e");
if (crc32("UDcPiKAJsp",10) == 1209164307) strcat(s, "i");
if (crc32("kICXDA",6) == 2302557495) strcat(s, "H");
if (crc32("pnTzTN",6) == 3461932282) strcat(s, "n");
if (crc32("jDvCNUNE",8) == 798354164) strcat(s, "g");
    return s;
}

char *keratinous_adjectives() {
    char *s = calloc(11);
    if (crc32("VXtMdWMT",8) == 585608467) strcat(s, "k");
if (crc32("pjMdtJSGlLbflzx",15) == 4068741190) strcat(s, "e");
if (crc32("sYapKHjJ",8) == 4031639977) strcat(s, "r");
if (crc32("fXSMAWdTisUOVl",14) == 4196237525) strcat(s, "a");
if (crc32("WJimTg",6) == 3106559317) strcat(s, "t");
if (crc32("tvESxbOfGGqfN",13) == 3855193522) strcat(s, "i");
if (crc32("YsLEKnXrp",9) == 1981006278) strcat(s, "k");
if (crc32("EEPzBLgrUkiq",12) == 4245643492) strcat(s, "n");
if (crc32("GUoZNurgsL",10) == 3310161863) strcat(s, "O");
if (crc32("rehOneQPEDHLRKa",15) == 531146658) strcat(s, "o");
if (crc32("xnEFgE",6) == 1495613665) strcat(s, "a");
if (crc32("RjMCGuuzwpufV",13) == 1164215955) strcat(s, "u");
if (crc32("gxFKXCsNK",9) == 540404522) strcat(s, "x");
if (crc32("CPMawPjmYUYJiO",14) == 1440018670) strcat(s, "s");
    return s;
}

char *renunciative_adjectives() {
    char *s = calloc(13);
    if (crc32("tysFkyCOOOGUiV",14) == 1816667675) strcat(s, "r");
if (crc32("aLyPydpHruT",11) == 68034170) strcat(s, "A");
if (crc32("evcRW",5) == 4005002904) strcat(s, "e");
if (crc32("QswqiOgV",8) == 1726441812) strcat(s, "n");
if (crc32("dbYQsmoVNfUsry",14) == 1989103855) strcat(s, "u");
if (crc32("zvhWd",5) == 3664847589) strcat(s, "F");
if (crc32("wTPSZAUCIIa",11) == 4214009448) strcat(s, "n");
if (crc32("duSTTChSyiKZFYm",15) == 1858101696) strcat(s, "j");
if (crc32("aBeJceuUEsRoDr",14) == 3382811538) strcat(s, "c");
if (crc32("cmVrKuEMWE",10) == 4020361141) strcat(s, "i");
if (crc32("YaSypKGXwfJiGSd",15) == 2593299510) strcat(s, "a");
if (crc32("DqHROhjcymd",11) == 193805393) strcat(s, "t");
if (crc32("guTLTYdLQoi",11) == 85006887) strcat(s, "D");
if (crc32("pjUtMsv",7) == 166966454) strcat(s, "i");
if (crc32("fEtbyqS",7) == 3894432775) strcat(s, "c");
if (crc32("pQyKVNSNbT",10) == 547127919) strcat(s, "v");
if (crc32("JigGRBrr",8) == 2372609570) strcat(s, "e");
    return s;
}

char *postGalilean_adjectives() {
    char *s = calloc(13);
    if (crc32("wwhkzncUNS",10) == 3131427426) strcat(s, "p");
if (crc32("AQasiQoLumHFGRg",15) == 3970384359) strcat(s, "j");
if (crc32("ijXPeCXOjXyb",12) == 405272349) strcat(s, "o");
if (crc32("ZBTwntmd",8) == 3157316126) strcat(s, "s");
if (crc32("NHnAWdk",7) == 404443762) strcat(s, "Q");
if (crc32("MKAFkhUCfAKm",12) == 3318954360) strcat(s, "t");
if (crc32("FKGmViUUc",9) == 2194477217) strcat(s, "G");
if (crc32("GfdAASUHcJ",10) == 4265633999) strcat(s, "G");
if (crc32("GagWkSKVPxP",11) == 4025422758) strcat(s, "a");
if (crc32("paOmhwyMVEwbEF",14) == 351906336) strcat(s, "l");
if (crc32("IipBums",7) == 3769523944) strcat(s, "i");
if (crc32("oImQJzIIeazl",12) == 2498683516) strcat(s, "l");
if (crc32("XChRCDqKAUkTwJf",15) == 2402599382) strcat(s, "e");
if (crc32("zKrzEoh",7) == 1373952041) strcat(s, "x");
if (crc32("GZuIJks",7) == 1425235436) strcat(s, "a");
if (crc32("oslGhUSsNbzbwi",14) == 4015663059) strcat(s, "n");
    return s;
}

char *uppish_adjectives() {
    char *s = calloc(7);
    if (crc32("pbMPfiXjirqklSP",15) == 2439433362) strcat(s, "Q");
if (crc32("RXXviEe",7) == 2015102984) strcat(s, "u");
if (crc32("lfSFWLa",7) == 3247558304) strcat(s, "p");
if (crc32("aydIfqGuCbtqwEJ",15) == 1318758317) strcat(s, "j");
if (crc32("VYEjIy",6) == 3221109982) strcat(s, "p");
if (crc32("tZHQVBaKQi",10) == 351345226) strcat(s, "i");
if (crc32("qpMYOuUEFr",10) == 1407295859) strcat(s, "s");
if (crc32("ILHBUUDGFOx",11) == 3242472327) strcat(s, "w");
if (crc32("sAmkzMVIXRP",11) == 1984600511) strcat(s, "h");
    return s;
}

char *unwarpable_adjectives() {
    char *s = calloc(11);
    if (crc32("zwXlQdkh",8) == 3413226976) strcat(s, "P");
if (crc32("sFNsWwnn",8) == 3172383714) strcat(s, "u");
if (crc32("YTBAPNxEJjcM",12) == 2162335260) strcat(s, "n");
if (crc32("LhHpabJHN",9) == 1087613333) strcat(s, "w");
if (crc32("LcMoIV",6) == 4090688222) strcat(s, "P");
if (crc32("qLOdYyFvCxjD",12) == 3619440077) strcat(s, "a");
if (crc32("ALVeK",5) == 1020617685) strcat(s, "f");
if (crc32("ESZsTfZ",7) == 3653293382) strcat(s, "r");
if (crc32("uneuWXcNENzOA",13) == 2392400121) strcat(s, "i");
if (crc32("ZlqkiBOIFSeHqT",14) == 244148522) strcat(s, "p");
if (crc32("MDMWOGqGyWV",11) == 3750340195) strcat(s, "a");
if (crc32("ZiztDPx",7) == 4059789814) strcat(s, "b");
if (crc32("VHAee",5) == 2077970534) strcat(s, "l");
if (crc32("oOrNDmrjgqj",11) == 1308047237) strcat(s, "j");
if (crc32("MReeWigorUopj",13) == 3824086995) strcat(s, "e");
    return s;
}

char *bridal_adjectives() {
    char *s = calloc(7);
    if (crc32("nyacB",5) == 2263624731) strcat(s, "n");
if (crc32("fPkhguDdnAJXKB",14) == 250373840) strcat(s, "b");
if (crc32("FbmMGafX",8) == 2047174938) strcat(s, "A");
if (crc32("umnRGIFRhxAHano",15) == 3511694093) strcat(s, "r");
if (crc32("gjABLSFdsA",10) == 3692993092) strcat(s, "i");
if (crc32("rmUQU",5) == 1588219481) strcat(s, "d");
if (crc32("onMVMLSyPbvnt",13) == 1961615204) strcat(s, "a");
if (crc32("TRWObDzDewLtZvT",15) == 2278063914) strcat(s, "V");
if (crc32("OZpRsyKWJqOar",13) == 1432084362) strcat(s, "l");
    return s;
}

char *selfteaching_adjectives() {
    char *s = calloc(13);
    if (crc32("mIsmIdje",8) == 3397145148) strcat(s, "D");
if (crc32("QdRwLBBDgP",10) == 3622803382) strcat(s, "s");
if (crc32("kumtZtUkmchoMzj",15) == 893561166) strcat(s, "e");
if (crc32("mGsFb",5) == 150447037) strcat(s, "S");
if (crc32("VopKkNQEerctn",13) == 1738494071) strcat(s, "l");
if (crc32("PbacvaONHZXDd",13) == 27438367) strcat(s, "f");
if (crc32("qiuyHRSIfTPEet",14) == 3687035064) strcat(s, "t");
if (crc32("EsqmxxErQyuiVlw",15) == 62571805) strcat(s, "t");
if (crc32("ljaGUe",6) == 288175755) strcat(s, "e");
if (crc32("oYaOSXmCH",9) == 2384102872) strcat(s, "k");
if (crc32("AiLbQBUTqjFO",12) == 13795723) strcat(s, "a");
if (crc32("twNHXOMWKMOkjmI",15) == 570073848) strcat(s, "c");
if (crc32("tUPofhZZ",8) == 1336983765) strcat(s, "p");
if (crc32("EJidkObdvXkl",12) == 859136256) strcat(s, "h");
if (crc32("kiGxLWRRrjQP",12) == 3033140880) strcat(s, "O");
if (crc32("QrmMHENaKdsbsI",14) == 577690976) strcat(s, "i");
if (crc32("iGKgYaQTU",9) == 3126936211) strcat(s, "p");
if (crc32("UsmQYFSZIhvSsoL",15) == 1544208668) strcat(s, "n");
if (crc32("OPsmTPtOTVHeeXC",15) == 1232378634) strcat(s, "g");
    return s;
}

char *thermosetting_adjectives() {
    char *s = calloc(14);
    if (crc32("iWWrlCvAaL",10) == 2696606460) strcat(s, "t");
if (crc32("JjqIkYPeNh",10) == 3984886314) strcat(s, "h");
if (crc32("fGSXhx",6) == 160800283) strcat(s, "h");
if (crc32("qSuyyXleWKcYbYS",15) == 434403212) strcat(s, "e");
if (crc32("kfcQAgiE",8) == 1466894040) strcat(s, "r");
if (crc32("ylhkokbUm",9) == 984119489) strcat(s, "b");
if (crc32("BgDFoD",6) == 737504608) strcat(s, "m");
if (crc32("ESkUwFpXfbs",11) == 2289272246) strcat(s, "o");
if (crc32("scOseXXYiyYmLgx",15) == 1044154866) strcat(s, "I");
if (crc32("lRdotuDXYve",11) == 1128165071) strcat(s, "s");
if (crc32("lBwaHJcYsLZHwk",14) == 1185402432) strcat(s, "j");
if (crc32("EssuOGtoVyvhN",13) == 2232176418) strcat(s, "e");
if (crc32("fGUvyh",6) == 1667005141) strcat(s, "R");
if (crc32("NUgpriEVbXCTO",13) == 425190905) strcat(s, "t");
if (crc32("vQuGirgte",9) == 1663303182) strcat(s, "K");
if (crc32("YrQCebJvuFFPbUp",15) == 3317661898) strcat(s, "t");
if (crc32("jMqjcRyl",8) == 4144194659) strcat(s, "u");
if (crc32("RihlBgJwdcBlVbw",15) == 2836941192) strcat(s, "i");
if (crc32("vrXMdzryDf",10) == 4014099126) strcat(s, "n");
if (crc32("UCkWjFlOcMj",11) == 1566932229) strcat(s, "g");
    return s;
}

char *valuable_adjectives() {
    char *s = calloc(9);
    if (crc32("oDKKtpjqwS",10) == 2285293535) strcat(s, "v");
if (crc32("kXzmsAtLvPc",11) == 1723486636) strcat(s, "a");
if (crc32("bPqfNqoy",8) == 209820176) strcat(s, "B");
if (crc32("cAfAEJKcogKIPK",14) == 3597198223) strcat(s, "l");
if (crc32("cTEqJBEL",8) == 36220985) strcat(s, "u");
if (crc32("RbwBmFw",7) == 126871919) strcat(s, "h");
if (crc32("HnSctUZnGDX",11) == 3034011082) strcat(s, "a");
if (crc32("fOpAcSpR",8) == 1114083031) strcat(s, "b");
if (crc32("RwiYyMSglJLX",12) == 2378517375) strcat(s, "l");
if (crc32("CRXMpUHSCsoF",12) == 2049785323) strcat(s, "e");
    return s;
}

char *nonadhering_adjectives() {
    char *s = calloc(12);
    if (crc32("jjgIGlRwwd",10) == 2905545966) strcat(s, "C");
if (crc32("cvslfjtZIGhz",12) == 3234364249) strcat(s, "n");
if (crc32("waMrVXcYT",9) == 2236137676) strcat(s, "n");
if (crc32("EeSPGBlY",8) == 3254399457) strcat(s, "o");
if (crc32("UCbFLznAqro",11) == 856407141) strcat(s, "n");
if (crc32("TyYpffG",7) == 2946690165) strcat(s, "a");
if (crc32("oCDrzVQUC",9) == 738998233) strcat(s, "d");
if (crc32("FYzIWa",6) == 266356327) strcat(s, "M");
if (crc32("LNRwe",5) == 309652835) strcat(s, "h");
if (crc32("hGXThrmaDc",10) == 169794448) strcat(s, "p");
if (crc32("ydUWyTGmFAltWgk",15) == 1747460511) strcat(s, "e");
if (crc32("JEzqCmQ",7) == 1582547513) strcat(s, "K");
if (crc32("uXScHPIRoolRF",13) == 3342173376) strcat(s, "r");
if (crc32("FHALTzTkaE",10) == 3764836744) strcat(s, "z");
if (crc32("NbkIVmyrgfO",11) == 2341009106) strcat(s, "i");
if (crc32("GfeUMhEKvBn",11) == 1719342159) strcat(s, "n");
if (crc32("WhKdbOk",7) == 3792468008) strcat(s, "g");
    return s;
}

char *uncoked_adjectives() {
    char *s = calloc(8);
    if (crc32("cqmaPOGNRmSkRfR",15) == 1631330649) strcat(s, "X");
if (crc32("spDeXcBTWsT",11) == 412758599) strcat(s, "u");
if (crc32("DYeAnBaVuVxMLy",14) == 3040775997) strcat(s, "z");
if (crc32("dvkSOUu",7) == 2496747803) strcat(s, "n");
if (crc32("JQstSIanBpOm",12) == 1568939064) strcat(s, "e");
if (crc32("gmdhe",5) == 4217267226) strcat(s, "c");
if (crc32("QfQIxEStaU",10) == 1087452384) strcat(s, "k");
if (crc32("CAXxJvuGVuFoT",13) == 526259345) strcat(s, "o");
if (crc32("dlxiTsYV",8) == 2149662458) strcat(s, "H");
if (crc32("souYHpv",7) == 3601462871) strcat(s, "k");
if (crc32("SuIeIxMfC",9) == 2677287033) strcat(s, "e");
if (crc32("FReUwxY",7) == 4062139671) strcat(s, "d");
    return s;
}

char *divertive_adjectives() {
    char *s = calloc(10);
    if (crc32("wcCLyouABQgTE",13) == 3086444734) strcat(s, "d");
if (crc32("fcGlTE",6) == 1292919205) strcat(s, "i");
if (crc32("bBxAvg",6) == 2746040788) strcat(s, "i");
if (crc32("osOxQF",6) == 4219197830) strcat(s, "M");
if (crc32("emGuczKN",8) == 3325773514) strcat(s, "v");
if (crc32("OhqAdq",6) == 1657203345) strcat(s, "e");
if (crc32("uwiAyzWDJ",9) == 1892026222) strcat(s, "c");
if (crc32("xKXWGU",6) == 3135448214) strcat(s, "r");
if (crc32("CJgemmew",8) == 968948575) strcat(s, "t");
if (crc32("uTLXsZHXGqAPH",13) == 488165669) strcat(s, "I");
if (crc32("MOkgVisC",8) == 1853866959) strcat(s, "i");
if (crc32("Qamnzqnd",8) == 2736201535) strcat(s, "v");
if (crc32("gFXan",5) == 3876336144) strcat(s, "e");
    return s;
}

char *Swiss_adjectives() {
    char *s = calloc(6);
    if (crc32("UCbSpack",8) == 2165495642) strcat(s, "S");
if (crc32("LQNKQEUsCfkmBgV",15) == 1756402452) strcat(s, "w");
if (crc32("ENwlYAhomHkS",12) == 1838637624) strcat(s, "i");
if (crc32("ExMhSPjXTJqlsyb",15) == 4081921997) strcat(s, "s");
if (crc32("vioWe",5) == 43863151) strcat(s, "H");
if (crc32("TqGysXCIzxvai",13) == 2613293062) strcat(s, "s");
    return s;
}

char *tres_adjectives() {
    char *s = calloc(5);
    if (crc32("WGeZHPQ",7) == 1149224230) strcat(s, "t");
if (crc32("WfGdZO",6) == 3534921350) strcat(s, "G");
if (crc32("aTUUFEl",7) == 2525956772) strcat(s, "r");
if (crc32("ifNnTjrhkGS",11) == 1574760677) strcat(s, "U");
if (crc32("iaTDnapYzBMyHKm",15) == 1821185963) strcat(s, "e");
if (crc32("jOlOiR",6) == 4183957623) strcat(s, "s");
    return s;
}

char *isocheimenal_adjectives() {
    char *s = calloc(13);
    if (crc32("SsRLPq",6) == 9957014) strcat(s, "i");
if (crc32("tyVbXuJhRWgqV",13) == 1301821734) strcat(s, "s");
if (crc32("IgdVU",5) == 2105945481) strcat(s, "I");
if (crc32("PfVpVAYNLyKV",12) == 494278668) strcat(s, "o");
if (crc32("OoSxKUVcF",9) == 294028057) strcat(s, "X");
if (crc32("RDAmMhgiRRm",11) == 653427274) strcat(s, "c");
if (crc32("xDaQcTwfVWDU",12) == 1424593727) strcat(s, "M");
if (crc32("SIjACutucac",11) == 1484592544) strcat(s, "h");
if (crc32("BslJrbMdLLJqNU",14) == 2428282037) strcat(s, "q");
if (crc32("mMKhtU",6) == 4282940914) strcat(s, "e");
if (crc32("VSufWvHMsIge",12) == 1153699220) strcat(s, "X");
if (crc32("sgwyAGbYofJ",11) == 1532130846) strcat(s, "i");
if (crc32("DkObaXesbxJtQA",14) == 3963600605) strcat(s, "d");
if (crc32("zgJUCozODwOKZ",13) == 1482943932) strcat(s, "m");
if (crc32("QNLIidwTbN",10) == 337006201) strcat(s, "e");
if (crc32("EUmiK",5) == 1239542596) strcat(s, "s");
if (crc32("WJOUYHxQ",8) == 3879860559) strcat(s, "n");
if (crc32("asCTRc",6) == 3853104795) strcat(s, "v");
if (crc32("KKNYluWcxVV",11) == 618603846) strcat(s, "a");
if (crc32("erglocjSm",9) == 2115998729) strcat(s, "K");
if (crc32("CWpEoHuV",8) == 1929336313) strcat(s, "l");
    return s;
}

char *revengeful_adjectives() {
    char *s = calloc(11);
    if (crc32("uHrqLDKMTNwcr",13) == 3420203364) strcat(s, "X");
if (crc32("hpjlZFKWRp",10) == 1542216286) strcat(s, "r");
if (crc32("mlzbYrA",7) == 2950088701) strcat(s, "u");
if (crc32("MxjCOCFpT",9) == 1950823568) strcat(s, "e");
if (crc32("nOnUGX",6) == 3256114677) strcat(s, "u");
if (crc32("EtWUG",5) == 4109062904) strcat(s, "v");
if (crc32("qRvIkhMLn",9) == 801718851) strcat(s, "e");
if (crc32("EhFfBaeoJcVwr",13) == 1681793035) strcat(s, "A");
if (crc32("DcrHXFxuwZ",10) == 2830863710) strcat(s, "n");
if (crc32("FLOgQTGVZVL",11) == 569368474) strcat(s, "u");
if (crc32("WDPjwInzejY",11) == 2123070711) strcat(s, "g");
if (crc32("vMTdUKs",7) == 2446743895) strcat(s, "G");
if (crc32("NejxYWVdqA",10) == 3696556390) strcat(s, "e");
if (crc32("XnuwslwnHhtkFQe",15) == 3094356926) strcat(s, "g");
if (crc32("GBWidzxCE",9) == 301676319) strcat(s, "f");
if (crc32("ODMUeKEhQee",11) == 297876839) strcat(s, "u");
if (crc32("WlWOEV",6) == 3734090183) strcat(s, "l");
    return s;
}

char *subreptitious_adjectives() {
    char *s = calloc(14);
    if (crc32("qFzArmCAHLG",11) == 3235467738) strcat(s, "T");
if (crc32("GWlOwSNioCckL",13) == 3884182862) strcat(s, "s");
if (crc32("ivIZLDeBEGOvwd",14) == 2658260195) strcat(s, "u");
if (crc32("JZIcIinvnAjqiJz",15) == 1986687654) strcat(s, "b");
if (crc32("gmpBgESpCbcdxzI",15) == 1697746662) strcat(s, "q");
if (crc32("qxvbWBxLywRp",12) == 1612554237) strcat(s, "r");
if (crc32("DVCaGPIvQCzw",12) == 3038891139) strcat(s, "f");
if (crc32("pHwgNMOhP",9) == 3822633738) strcat(s, "e");
if (crc32("NgsYmuSRsJ",10) == 3012616369) strcat(s, "D");
if (crc32("zqyqmM",6) == 1156809677) strcat(s, "p");
if (crc32("dLUOVhGBFaKEg",13) == 625693191) strcat(s, "t");
if (crc32("OTeBLXr",7) == 1830177644) strcat(s, "i");
if (crc32("heUSKzqBAAMqJob",15) == 1036315155) strcat(s, "W");
if (crc32("vnUacsPNA",9) == 3054582085) strcat(s, "t");
if (crc32("ZIBnRUGyCzPPnvP",15) == 3340250268) strcat(s, "i");
if (crc32("nTzszLAAUWJhhU",14) == 1596936039) strcat(s, "W");
if (crc32("ESbnKJLELjJJGd",14) == 4103497160) strcat(s, "o");
if (crc32("FLVLNJoWJMmQ",12) == 2854811208) strcat(s, "Y");
if (crc32("VcRmBfPHajUuNJa",15) == 3964344269) strcat(s, "u");
if (crc32("WInWkSZlAdSKN",13) == 3537450912) strcat(s, "w");
if (crc32("ZYNCoatmkiwun",13) == 1579597314) strcat(s, "s");
    return s;
}

char *exorcistical_adjectives() {
    char *s = calloc(13);
    if (crc32("ZmDXrLH",7) == 2128075090) strcat(s, "e");
if (crc32("DbfTMI",6) == 4191562555) strcat(s, "x");
if (crc32("oYQMoNKzDNI",11) == 1333738634) strcat(s, "o");
if (crc32("zQBvfZp",7) == 583666768) strcat(s, "r");
if (crc32("lNsgvYtVKzQK",12) == 3825712052) strcat(s, "M");
if (crc32("uPGEpUFFFUgWSHy",15) == 931892331) strcat(s, "c");
if (crc32("bEdPciyTPUL",11) == 619348676) strcat(s, "w");
if (crc32("szwLyOWvz",9) == 3557947110) strcat(s, "i");
if (crc32("CARlSTfeYuapy",13) == 1124158391) strcat(s, "s");
if (crc32("IecvUs",6) == 3211315106) strcat(s, "t");
if (crc32("LNqTWmF",7) == 2371302303) strcat(s, "i");
if (crc32("RQUuHNIQXA",10) == 1690825307) strcat(s, "c");
if (crc32("wdBGPnMrxWTq",12) == 1801516322) strcat(s, "a");
if (crc32("VShiegWxUbzWyy",14) == 3931597128) strcat(s, "P");
if (crc32("BuRlKfubeMYpWXS",15) == 1124197537) strcat(s, "l");
    return s;
}

char *untippled_adjectives() {
    char *s = calloc(10);
    if (crc32("FGnTW",5) == 2126741597) strcat(s, "u");
if (crc32("RBqldVpHAdc",11) == 1759579808) strcat(s, "v");
if (crc32("LuclrE",6) == 2341191881) strcat(s, "n");
if (crc32("SrifNHFVw",9) == 1825858372) strcat(s, "t");
if (crc32("ztjsUEd",7) == 1114213640) strcat(s, "i");
if (crc32("wrIegngm",8) == 1661678773) strcat(s, "U");
if (crc32("TApTdryu",8) == 2904597300) strcat(s, "p");
if (crc32("cEEtYUxiYPdf",12) == 1643389756) strcat(s, "p");
if (crc32("TCXNvFGKPoEU",12) == 2890587890) strcat(s, "S");
if (crc32("cGKPxu",6) == 844226511) strcat(s, "l");
if (crc32("DfVvy",5) == 1301406881) strcat(s, "e");
if (crc32("zTGUqxpqDSXxo",13) == 2283307317) strcat(s, "d");
    return s;
}

char *undryable_adjectives() {
    char *s = calloc(10);
    if (crc32("pJoyCaZjNsUql",13) == 4113485020) strcat(s, "u");
if (crc32("utceFakFPuv",11) == 3586773770) strcat(s, "n");
if (crc32("mxMNIdOXwlmXAL",14) == 3559957220) strcat(s, "d");
if (crc32("JWFnynhEsIVdXc",14) == 3217313397) strcat(s, "r");
if (crc32("jdBrUPzoBBDVOGG",15) == 1356835349) strcat(s, "y");
if (crc32("GzbQLVXuwGjK",12) == 3962216547) strcat(s, "z");
if (crc32("oLiiMA",6) == 2420613388) strcat(s, "a");
if (crc32("ooDKntfWZM",10) == 2857149526) strcat(s, "b");
if (crc32("fTASCzqWGj",10) == 333549210) strcat(s, "H");
if (crc32("TkclRXwcx",9) == 2357470521) strcat(s, "l");
if (crc32("gvmmjwSBaxyp",12) == 2466113558) strcat(s, "p");
if (crc32("IODma",5) == 3452167286) strcat(s, "e");
    return s;
}

char *welldeserved_adjectives() {
    char *s = calloc(13);
    if (crc32("qAfjedqXV",9) == 3636136976) strcat(s, "W");
if (crc32("XjwEfklJ",8) == 1335742154) strcat(s, "w");
if (crc32("nhFnZRfYZA",10) == 739069401) strcat(s, "e");
if (crc32("ncSKaHYKyaJk",12) == 1882839953) strcat(s, "B");
if (crc32("ylQqXebkjdHFr",13) == 2433366418) strcat(s, "l");
if (crc32("STCdEW",6) == 1211455945) strcat(s, "l");
if (crc32("AGYxYDbVG",9) == 2096447942) strcat(s, "H");
if (crc32("eGnESij",7) == 2882875274) strcat(s, "d");
if (crc32("eYugwwDNQEwGU",13) == 2547540954) strcat(s, "t");
if (crc32("kPVqmsiMKoJhIZc",15) == 103758668) strcat(s, "e");
if (crc32("vsCbMNPv",8) == 669328416) strcat(s, "w");
if (crc32("jnyjUZwZmFsGA",13) == 4133575152) strcat(s, "s");
if (crc32("mOUwYcEyxGNJq",13) == 995811427) strcat(s, "e");
if (crc32("fgpgCMFFS",9) == 3166441773) strcat(s, "r");
if (crc32("TkjSvsRwH",9) == 3673088685) strcat(s, "E");
if (crc32("DRDHNcsrE",9) == 2724441554) strcat(s, "v");
if (crc32("MfrcLIx",7) == 4133328727) strcat(s, "i");
if (crc32("hvOhMciUzLa",11) == 2226158390) strcat(s, "e");
if (crc32("fSWgKc",6) == 3025120896) strcat(s, "D");
if (crc32("MSGavyAd",8) == 3309430988) strcat(s, "d");
    return s;
}

char *potassic_adjectives() {
    char *s = calloc(9);
    if (crc32("wJszwUqrTSRpx",13) == 2626998567) strcat(s, "Q");
if (crc32("AeLwwZyY",8) == 293244988) strcat(s, "p");
if (crc32("EIpaNEIN",8) == 3355019400) strcat(s, "o");
if (crc32("RtBONXpkLkdmbz",14) == 835558728) strcat(s, "X");
if (crc32("gKvZhoqlQj",10) == 44087310) strcat(s, "t");
if (crc32("TAmlGuMHE",9) == 1236377301) strcat(s, "a");
if (crc32("buLaiVWat",9) == 135689022) strcat(s, "s");
if (crc32("KIcSWDkORUZ",11) == 1046622264) strcat(s, "s");
if (crc32("whHInB",6) == 1289748574) strcat(s, "i");
if (crc32("HcwdhXzeDieNDRG",15) == 318143456) strcat(s, "d");
if (crc32("mMIPUvFMGEJZc",13) == 2506788669) strcat(s, "c");
    return s;
}

char *boneless_adjectives() {
    char *s = calloc(9);
    if (crc32("kpXcQeeYZIOdItn",15) == 542633214) strcat(s, "b");
if (crc32("ngUDfwwvmedr",12) == 651415788) strcat(s, "l");
if (crc32("kRdDrQVXATfhmj",14) == 243347467) strcat(s, "o");
if (crc32("guceBvZIznp",11) == 2543910903) strcat(s, "n");
if (crc32("YMHCmiHq",8) == 1730663027) strcat(s, "e");
if (crc32("VxnZKOXUL",9) == 817109165) strcat(s, "l");
if (crc32("ctaCheinrLpgGlx",15) == 3049138503) strcat(s, "l");
if (crc32("GXIzhufkbpKKS",13) == 2231542006) strcat(s, "i");
if (crc32("MYMexROWGrEULj",14) == 788832532) strcat(s, "e");
if (crc32("PEutSlyWpF",10) == 4211079862) strcat(s, "t");
if (crc32("AOnWUb",6) == 2032117394) strcat(s, "s");
if (crc32("YiCLQHLIRwVZ",12) == 3480097212) strcat(s, "Z");
if (crc32("wKEYIJzwwW",10) == 2259748263) strcat(s, "s");
    return s;
}

char *paralexic_adjectives() {
    char *s = calloc(10);
    if (crc32("oOqTbMiATqsjrD",14) == 3607329746) strcat(s, "z");
if (crc32("oSnNhukojRWq",12) == 879058530) strcat(s, "p");
if (crc32("MiTySF",6) == 2269154357) strcat(s, "a");
if (crc32("FDyGZmx",7) == 234698549) strcat(s, "b");
if (crc32("duHxZX",6) == 842245746) strcat(s, "r");
if (crc32("audkGjytIqFEThv",15) == 4072794299) strcat(s, "U");
if (crc32("CLNDQQKm",8) == 3892000660) strcat(s, "a");
if (crc32("WztoeUOhId",10) == 600390745) strcat(s, "I");
if (crc32("fIxvoyh",7) == 615779971) strcat(s, "l");
if (crc32("cNhcwZCkSKcq",12) == 2369919190) strcat(s, "e");
if (crc32("IyUxXkgCrVgVZNg",15) == 3585693376) strcat(s, "x");
if (crc32("SUmgviBiW",9) == 1293051529) strcat(s, "i");
if (crc32("goYCrkblKs",10) == 3708689492) strcat(s, "c");
if (crc32("AfMXBXDIULjpZUy",15) == 3215286029) strcat(s, "c");
    return s;
}

char *fainaant_adjectives() {
    char *s = calloc(9);
    if (crc32("LwwPscnm",8) == 3884791067) strcat(s, "f");
if (crc32("HiufQkYU",8) == 1229345333) strcat(s, "q");
if (crc32("GOyKiJBboXvUpru",15) == 1405765752) strcat(s, "a");
if (crc32("prVPqoAiSwT",11) == 3254073557) strcat(s, "i");
if (crc32("RRqSRVVNAgrQ",12) == 3696510995) strcat(s, "n");
if (crc32("XYqnQlpOWG",10) == 3126905742) strcat(s, "a");
if (crc32("SUqCOqev",8) == 324259437) strcat(s, "B");
if (crc32("LJlQbLsl",8) == 697780172) strcat(s, "a");
if (crc32("ivAuX",5) == 1514622741) strcat(s, "p");
if (crc32("hiWaCSWcKK",10) == 3153012718) strcat(s, "n");
if (crc32("vIPZfxRBNsq",11) == 2361825909) strcat(s, "t");
    return s;
}

char *nonosmotic_adjectives() {
    char *s = calloc(11);
    if (crc32("ymQBolWPpb",10) == 493318197) strcat(s, "n");
if (crc32("gCDPhmEgSkRM",12) == 1527551199) strcat(s, "f");
if (crc32("ztysVtf",7) == 1329379485) strcat(s, "o");
if (crc32("oJkrMcKhfFyZ",12) == 967050294) strcat(s, "n");
if (crc32("TTloDDSK",8) == 1020468604) strcat(s, "b");
if (crc32("Qeuxl",5) == 1047618145) strcat(s, "o");
if (crc32("evXBJncDuijaYM",14) == 2514668155) strcat(s, "Q");
if (crc32("WPinRZ",6) == 2668531640) strcat(s, "s");
if (crc32("orvItgSo",8) == 2061033640) strcat(s, "m");
if (crc32("eNjGy",5) == 538584805) strcat(s, "P");
if (crc32("LfMWgLsNnKYcqc",14) == 3574094106) strcat(s, "o");
if (crc32("tdhvviWas",9) == 2522885083) strcat(s, "t");
if (crc32("qcjWdpanSMNY",12) == 1563303286) strcat(s, "i");
if (crc32("OhnmRg",6) == 639842040) strcat(s, "c");
    return s;
}

char *antireactive_adjectives() {
    char *s = calloc(13);
    if (crc32("HYEspPZGkmTyU",13) == 1792269307) strcat(s, "a");
if (crc32("OjgdAplIxV",10) == 3055697656) strcat(s, "n");
if (crc32("VgsaldRRZFYUx",13) == 2389534765) strcat(s, "t");
if (crc32("xFAQSJDPCsfo",12) == 3582661619) strcat(s, "i");
if (crc32("KEvxxKoXQPByxB",14) == 539362642) strcat(s, "q");
if (crc32("sHCYR",5) == 3123771532) strcat(s, "r");
if (crc32("tsaZwkOxAMfQc",13) == 549944964) strcat(s, "W");
if (crc32("PeupcJ",6) == 1012398461) strcat(s, "e");
if (crc32("hjYMDWRY",8) == 632787922) strcat(s, "a");
if (crc32("NosqJ",5) == 3024011344) strcat(s, "c");
if (crc32("EZZwBchp",8) == 2692692767) strcat(s, "k");
if (crc32("QWAbd",5) == 4190596590) strcat(s, "t");
if (crc32("BuKuC",5) == 1759139349) strcat(s, "G");
if (crc32("JUnbCwiHPOJM",12) == 1850100789) strcat(s, "i");
if (crc32("uJpeqzsrbbv",11) == 1071542380) strcat(s, "v");
if (crc32("CWsKiXUEqvvigWi",15) == 4218061268) strcat(s, "e");
    return s;
}

char *intersonant_adjectives() {
    char *s = calloc(12);
    if (crc32("ClFukJ",6) == 2559177877) strcat(s, "i");
if (crc32("MPcxJyBdmUnKxsZ",15) == 3294094126) strcat(s, "n");
if (crc32("tayroo",6) == 4211730432) strcat(s, "t");
if (crc32("LqFSfdiXTDxr",12) == 2376072748) strcat(s, "e");
if (crc32("aHGKj",5) == 426091509) strcat(s, "r");
if (crc32("rLLRXnbdGg",10) == 2536034311) strcat(s, "r");
if (crc32("qJqlsZXLXgp",11) == 1791704210) strcat(s, "T");
if (crc32("JlFFklUEU",9) == 3074522486) strcat(s, "s");
if (crc32("ngnuDsyfXwTC",12) == 2454602044) strcat(s, "o");
if (crc32("qpXOyePl",8) == 1968852404) strcat(s, "n");
if (crc32("zgIxJXfcOhzBjco",15) == 3172827193) strcat(s, "H");
if (crc32("UlQLOjyfSb",10) == 1493973677) strcat(s, "a");
if (crc32("onCJEHKDvYvEI",13) == 2415651648) strcat(s, "n");
if (crc32("zPbQomxi",8) == 1097112770) strcat(s, "P");
if (crc32("ZSeebkWSQKcRF",13) == 3870311813) strcat(s, "t");
    return s;
}

char *apologal_adjectives() {
    char *s = calloc(9);
    if (crc32("WhLmjFHICcuSkDW",15) == 1605226769) strcat(s, "x");
if (crc32("xCeFBYRi",8) == 242051595) strcat(s, "a");
if (crc32("qaGzSuTVwAuey",13) == 3489022902) strcat(s, "f");
if (crc32("YELbEROinSNz",12) == 1597583025) strcat(s, "p");
if (crc32("bvwmCDBDEMbwFV",14) == 1539834420) strcat(s, "o");
if (crc32("XowiOCgBF",9) == 3845991296) strcat(s, "Z");
if (crc32("Lsgsau",6) == 3689232205) strcat(s, "l");
if (crc32("UsuoIDTwdGB",11) == 2905735810) strcat(s, "P");
if (crc32("Yvoon",5) == 3062960845) strcat(s, "o");
if (crc32("sgyQWxcaYePQy",13) == 3781180004) strcat(s, "I");
if (crc32("TNxHCwYHFlFTRg",14) == 824858411) strcat(s, "g");
if (crc32("TnMtYi",6) == 2986328818) strcat(s, "j");
if (crc32("qzUJxxaz",8) == 1000303601) strcat(s, "a");
if (crc32("mueuhEvWtYB",11) == 3627770297) strcat(s, "W");
if (crc32("anRFK",5) == 2442961813) strcat(s, "l");
    return s;
}

char *nonlepidopteran_adjectives() {
    char *s = calloc(16);
    if (crc32("eQYsLPpnXbLy",12) == 2262571423) strcat(s, "N");
if (crc32("eEqUcZfVx",9) == 60491778) strcat(s, "n");
if (crc32("YeRXMRIxEmbo",12) == 248214283) strcat(s, "o");
if (crc32("TfulOwRDEOfXy",13) == 2945127369) strcat(s, "k");
if (crc32("lRWjnriCCg",10) == 2303505060) strcat(s, "n");
if (crc32("sXDulotqFVaskSs",15) == 3412818515) strcat(s, "K");
if (crc32("spymefNQPa",10) == 2413382065) strcat(s, "l");
if (crc32("ZhvpUn",6) == 445085549) strcat(s, "v");
if (crc32("iXCmYtnEsW",10) == 837251776) strcat(s, "e");
if (crc32("NMfhfyct",8) == 1473494405) strcat(s, "p");
if (crc32("LGcIMexeCqUg",12) == 3960689132) strcat(s, "i");
if (crc32("uxXkVWXFfNAyb",13) == 3080960420) strcat(s, "d");
if (crc32("uIFyEIppPneXeAx",15) == 28635028) strcat(s, "y");
if (crc32("TwGbxyZ",7) == 143448015) strcat(s, "o");
if (crc32("VCMid",5) == 2121421209) strcat(s, "p");
if (crc32("qUhKzmauof",10) == 1769443722) strcat(s, "P");
if (crc32("xeepEONgXbJih",13) == 4275200078) strcat(s, "t");
if (crc32("wxbjQlCQ",8) == 3020843518) strcat(s, "W");
if (crc32("duCxlPJSJN",10) == 3215192806) strcat(s, "e");
if (crc32("USTNBYhsJRnULKH",15) == 1180805325) strcat(s, "r");
if (crc32("VRjAa",5) == 3051054275) strcat(s, "Q");
if (crc32("mWQwxmX",7) == 2048672142) strcat(s, "a");
if (crc32("AMzrWiahA",9) == 3128782229) strcat(s, "n");
    return s;
}

char *subcranial_adjectives() {
    char *s = calloc(11);
    if (crc32("eXkfN",5) == 2131274778) strcat(s, "s");
if (crc32("ItbLAkW",7) == 3961713255) strcat(s, "u");
if (crc32("EyFPdM",6) == 3249144349) strcat(s, "b");
if (crc32("OxtSjye",7) == 1151278492) strcat(s, "t");
if (crc32("rJHfQ",5) == 3772485072) strcat(s, "c");
if (crc32("tCsiABnpG",9) == 3480190461) strcat(s, "r");
if (crc32("GUdWDmqL",8) == 1089943770) strcat(s, "p");
if (crc32("lZYbHksX",8) == 3593471638) strcat(s, "a");
if (crc32("BqneEP",6) == 1147183348) strcat(s, "n");
if (crc32("SbKFTJr",7) == 2954107282) strcat(s, "T");
if (crc32("DjyQrxwaCaE",11) == 1379792793) strcat(s, "i");
if (crc32("UHqGD",5) == 3432786874) strcat(s, "q");
if (crc32("mnNJFw",6) == 1294884623) strcat(s, "a");
if (crc32("fxNfaESNU",9) == 2342003934) strcat(s, "h");
if (crc32("ZtLtP",5) == 157584926) strcat(s, "l");
    return s;
}

char *halfshouted_adjectives() {
    char *s = calloc(12);
    if (crc32("PDShixE",7) == 218604042) strcat(s, "h");
if (crc32("DOSfMkwzjNc",11) == 12462904) strcat(s, "Z");
if (crc32("nylbQBJjwrOBe",13) == 2219723632) strcat(s, "a");
if (crc32("BnIGjwUAJF",10) == 2377342150) strcat(s, "k");
if (crc32("rkqWptxp",8) == 3348070134) strcat(s, "l");
if (crc32("myVoW",5) == 1154994266) strcat(s, "A");
if (crc32("FgFugcR",7) == 2721679489) strcat(s, "f");
if (crc32("shsafgCnGIqKew",14) == 2008172595) strcat(s, "s");
if (crc32("YplHSnUdaK",10) == 611673388) strcat(s, "h");
if (crc32("CIlkSUiwr",9) == 3974197640) strcat(s, "f");
if (crc32("lOIQKOemy",9) == 3781208365) strcat(s, "o");
if (crc32("WwfsrBWBRdlWxG",14) == 1079201989) strcat(s, "u");
if (crc32("qnXVbwlVCiCKwvZ",15) == 821374607) strcat(s, "t");
if (crc32("wfjKkjbH",8) == 3858526378) strcat(s, "W");
if (crc32("LKrQPqDjYNOFk",13) == 3689205340) strcat(s, "e");
if (crc32("NsvoEa",6) == 2156317043) strcat(s, "d");
    return s;
}

char *Czech_adjectives() {
    char *s = calloc(6);
    if (crc32("UtHEQiPBOfI",11) == 2110625018) strcat(s, "C");
if (crc32("mjUWjGN",7) == 2477049679) strcat(s, "y");
if (crc32("mAtibHIaWgEU",12) == 837685951) strcat(s, "z");
if (crc32("AFHGCHwsstn",11) == 3114563947) strcat(s, "w");
if (crc32("hDuaWuGvZEC",11) == 2858317738) strcat(s, "e");
if (crc32("pHWKPaSIPNtDTx",14) == 1634529050) strcat(s, "c");
if (crc32("BiYtVSA",7) == 1210143326) strcat(s, "h");
    return s;
}

char *oversolemn_adjectives() {
    char *s = calloc(11);
    if (crc32("yRyOaHx",7) == 354777184) strcat(s, "a");
if (crc32("GUIraGBvo",9) == 2745360076) strcat(s, "o");
if (crc32("PCCqnJSx",8) == 1629850953) strcat(s, "v");
if (crc32("aGyYiWjcGoMuDVx",15) == 847860524) strcat(s, "e");
if (crc32("kZdGPPHczFPO",12) == 2001468138) strcat(s, "a");
if (crc32("qxmXpHft",8) == 388975941) strcat(s, "r");
if (crc32("oCkDiLQ",7) == 2490139458) strcat(s, "s");
if (crc32("zdRpnmtylswwRL",14) == 2556827596) strcat(s, "O");
if (crc32("RAIZNzUzZS",10) == 3074847372) strcat(s, "o");
if (crc32("dUJQnJZPKHSlrnD",15) == 3551223484) strcat(s, "l");
if (crc32("VusgCWTSBX",10) == 2966456292) strcat(s, "B");
if (crc32("fwOMqPNsnzG",11) == 3543790027) strcat(s, "e");
if (crc32("jcCzA",5) == 2598638591) strcat(s, "m");
if (crc32("DANqp",5) == 2374126512) strcat(s, "p");
if (crc32("kDFojug",7) == 4030525977) strcat(s, "n");
    return s;
}

char *subpial_adjectives() {
    char *s = calloc(8);
    if (crc32("HNGfGhuM",8) == 2506357422) strcat(s, "s");
if (crc32("pUrORuBaNYC",11) == 173730447) strcat(s, "J");
if (crc32("zxnSirCAQqnK",12) == 289837572) strcat(s, "u");
if (crc32("wczJvhuMrdCeB",13) == 911731884) strcat(s, "o");
if (crc32("eiCcgTwtAXZv",12) == 1596607231) strcat(s, "b");
if (crc32("ZDwCo",5) == 782225383) strcat(s, "H");
if (crc32("JTGpkV",6) == 2225188827) strcat(s, "p");
if (crc32("KmCKXWGJJxbhdeX",15) == 573926831) strcat(s, "L");
if (crc32("YpxLjQFtKnNZ",12) == 65000199) strcat(s, "i");
if (crc32("aAvkMeQRwdbfc",13) == 1439135970) strcat(s, "F");
if (crc32("RjaVJUP",7) == 467137964) strcat(s, "a");
if (crc32("gVruk",5) == 3691742563) strcat(s, "l");
    return s;
}

char *partridgelike_adjectives() {
    char *s = calloc(14);
    if (crc32("xLcZRRrpnFC",11) == 994322708) strcat(s, "Y");
if (crc32("sDjSTy",6) == 1550382595) strcat(s, "p");
if (crc32("baYlwphdDotLgb",14) == 2546388395) strcat(s, "a");
if (crc32("SpJhlOmnzL",10) == 3092561715) strcat(s, "j");
if (crc32("BTIfnUC",7) == 4162403385) strcat(s, "r");
if (crc32("ftCOuT",6) == 1646051199) strcat(s, "h");
if (crc32("nxCejMoDkKz",11) == 2271500129) strcat(s, "t");
if (crc32("GduyGlmFpyN",11) == 2602123831) strcat(s, "n");
if (crc32("ybvspOxipOpbFwW",15) == 221957311) strcat(s, "r");
if (crc32("AlDcPaiwuuxc",12) == 4294420450) strcat(s, "m");
if (crc32("kchGIsHmkwdTl",13) == 1905588784) strcat(s, "i");
if (crc32("xSqcLsegGJu",11) == 1489713351) strcat(s, "J");
if (crc32("NEwyecraz",9) == 2009361460) strcat(s, "d");
if (crc32("njtAGBZBWXYGsGl",15) == 128770141) strcat(s, "w");
if (crc32("YeccrAZfSxKc",12) == 1471733838) strcat(s, "g");
if (crc32("GyEiQqRzhJK",11) == 1809361713) strcat(s, "e");
if (crc32("qpQue",5) == 3290168138) strcat(s, "G");
if (crc32("mzYZaEVbc",9) == 2385831367) strcat(s, "l");
if (crc32("nooAgSVkrmDCXp",14) == 4092025874) strcat(s, "i");
if (crc32("BoIJqktXPSzrhYx",15) == 3977488033) strcat(s, "l");
if (crc32("yqKyDbQz",8) == 1093325391) strcat(s, "k");
if (crc32("hdqzaxrBW",9) == 3747213067) strcat(s, "e");
    return s;
}

char *interpretative_adjectives() {
    char *s = calloc(15);
    if (crc32("ErzghEoO",8) == 1925639350) strcat(s, "i");
if (crc32("fgLfoCWXckUxWjj",15) == 1167924801) strcat(s, "n");
if (crc32("fKlUciHDPmYiTHl",15) == 1457335498) strcat(s, "t");
if (crc32("GSEyrkM",7) == 3387942272) strcat(s, "e");
if (crc32("FeQrWRR",7) == 1120974979) strcat(s, "r");
if (crc32("lxfIIocRlsysU",13) == 2183926620) strcat(s, "p");
if (crc32("twaQNkcv",8) == 1792242560) strcat(s, "r");
if (crc32("rJyarbWTG",9) == 2012778670) strcat(s, "e");
if (crc32("GSbXYNJbXeapiC",14) == 528696625) strcat(s, "b");
if (crc32("EQnUnzsATKi",11) == 3012901797) strcat(s, "t");
if (crc32("eMJrwax",7) == 446197073) strcat(s, "i");
if (crc32("IlCqzNQtwqI",11) == 2118264363) strcat(s, "a");
if (crc32("EdwAgByXBUQHba",14) == 799072428) strcat(s, "t");
if (crc32("MEMIshfmHI",10) == 3152792731) strcat(s, "A");
if (crc32("oBrdmg",6) == 3879665151) strcat(s, "i");
if (crc32("wnKvLyQz",8) == 397579509) strcat(s, "L");
if (crc32("eqgYzYopcdF",11) == 3869231253) strcat(s, "v");
if (crc32("XuEmy",5) == 494645472) strcat(s, "e");
    return s;
}

char *solvolytic_adjectives() {
    char *s = calloc(11);
    if (crc32("TeZGekUdU",9) == 156649882) strcat(s, "s");
if (crc32("vSPjOW",6) == 531180717) strcat(s, "o");
if (crc32("mXmrwqJAYcJ",11) == 1330652205) strcat(s, "N");
if (crc32("HIcZa",5) == 2026725963) strcat(s, "l");
if (crc32("iYBZCcGmA",9) == 2965111200) strcat(s, "v");
if (crc32("aifTtvBMEkItmG",14) == 1207969173) strcat(s, "o");
if (crc32("fgrRtwUUfz",10) == 1870398124) strcat(s, "x");
if (crc32("zNaVAeEOH",9) == 1482261002) strcat(s, "l");
if (crc32("OkLjhAsNdaH",11) == 4204845149) strcat(s, "o");
if (crc32("czNgFFCjeqc",11) == 2520107233) strcat(s, "y");
if (crc32("NmDARNTVR",9) == 4108193329) strcat(s, "t");
if (crc32("QjEhelvZVJzPb",13) == 2666230947) strcat(s, "G");
if (crc32("LpKhG",5) == 156087668) strcat(s, "i");
if (crc32("NDqpAhUpDujK",12) == 3985711617) strcat(s, "c");
    return s;
}

char *trusting_adjectives() {
    char *s = calloc(9);
    if (crc32("oorZxXKaNJMd",12) == 1349776147) strcat(s, "t");
if (crc32("HLtSYILw",8) == 286621513) strcat(s, "R");
if (crc32("oVEAWzL",7) == 1253524491) strcat(s, "r");
if (crc32("LfKFdDfXK",9) == 418933402) strcat(s, "Y");
if (crc32("DqgVCsWGQSeMs",13) == 799612926) strcat(s, "u");
if (crc32("esfXbuFhMfviqr",14) == 3639332374) strcat(s, "c");
if (crc32("QxFEDYzSvuJi",12) == 1934459474) strcat(s, "s");
if (crc32("RWwUQEr",7) == 3522638647) strcat(s, "t");
if (crc32("kDRYXcKRM",9) == 3623672412) strcat(s, "i");
if (crc32("AfdnjzDiW",9) == 3283883108) strcat(s, "q");
if (crc32("YMLqfhzQJBLQykQ",15) == 1257237561) strcat(s, "n");
if (crc32("EKmoklhnpGen",12) == 1755474765) strcat(s, "e");
if (crc32("wuPaHCeAuqvLLrX",15) == 2898082794) strcat(s, "g");
    return s;
}

char *unautistic_adjectives() {
    char *s = calloc(11);
    if (crc32("RCAeUZVqNln",11) == 3461613596) strcat(s, "u");
if (crc32("QQyjUnsBDTtWU",13) == 1196877459) strcat(s, "v");
if (crc32("qOHITPPZsKXMUnb",15) == 426612320) strcat(s, "n");
if (crc32("tLPolqL",7) == 1795951475) strcat(s, "a");
if (crc32("rdYXeI",6) == 1488618770) strcat(s, "a");
if (crc32("mSwHlbd",7) == 2566622092) strcat(s, "K");
if (crc32("nSJmFSqzac",10) == 2974666263) strcat(s, "u");
if (crc32("xMJxQIGY",8) == 494378587) strcat(s, "y");
if (crc32("xWlZr",5) == 3871931522) strcat(s, "t");
if (crc32("gNjVSG",6) == 182437060) strcat(s, "L");
if (crc32("dPVpoOI",7) == 152896363) strcat(s, "i");
if (crc32("uaIheMzbT",9) == 3431759987) strcat(s, "O");
if (crc32("tXVDjvsyWyYYk",13) == 1421573746) strcat(s, "s");
if (crc32("oNpTmRXGzApyy",13) == 439349963) strcat(s, "t");
if (crc32("yRQvOQTvfPknRDK",15) == 1270352799) strcat(s, "P");
if (crc32("dNzKU",5) == 2159138733) strcat(s, "i");
if (crc32("FnxOhjjjz",9) == 942834765) strcat(s, "c");
    return s;
}

char *prediscontented_adjectives() {
    char *s = calloc(16);
    if (crc32("pgkpNJpPHGTXDH",14) == 1761010394) strcat(s, "p");
if (crc32("sSHupNgwrgGNcF",14) == 2571602507) strcat(s, "r");
if (crc32("dDYWkXMURah",11) == 114935663) strcat(s, "P");
if (crc32("CSntHG",6) == 530857464) strcat(s, "e");
if (crc32("HTFajTDAmykQVM",14) == 2814496086) strcat(s, "d");
if (crc32("GALiVKD",7) == 165937604) strcat(s, "i");
if (crc32("zDSfNC",6) == 1741111010) strcat(s, "g");
if (crc32("NfJYTuEYiEKywN",14) == 2819892398) strcat(s, "s");
if (crc32("eaBxOR",6) == 930513603) strcat(s, "I");
if (crc32("xBZFYFtBYheszo",14) == 4273726622) strcat(s, "c");
if (crc32("JYntQzdnkrFs",12) == 1355184848) strcat(s, "l");
if (crc32("maknxnq",7) == 119592611) strcat(s, "o");
if (crc32("abOjXvHsdeGkSab",15) == 4145422450) strcat(s, "n");
if (crc32("yXfugfRP",8) == 1101209722) strcat(s, "k");
if (crc32("bCWKCI",6) == 367828387) strcat(s, "t");
if (crc32("SMqUfsgGWArvftc",15) == 4278828799) strcat(s, "e");
if (crc32("OJjbHLh",7) == 2725090971) strcat(s, "n");
if (crc32("FtjDD",5) == 2635685225) strcat(s, "H");
if (crc32("uKpyjO",6) == 2355132646) strcat(s, "t");
if (crc32("XngxkpAHhc",10) == 1730080297) strcat(s, "e");
if (crc32("CmqRjwUp",8) == 3010214854) strcat(s, "s");
if (crc32("YysyvFyRKGv",11) == 2717364137) strcat(s, "d");
    return s;
}

char *tetrasporic_adjectives() {
    char *s = calloc(12);
    if (crc32("hSDYWDGrrakEm",13) == 3042223770) strcat(s, "t");
if (crc32("qfPbctNZSjEqIRY",15) == 672747141) strcat(s, "e");
if (crc32("iVDiQCVT",8) == 1810026835) strcat(s, "t");
if (crc32("NZNEpMhSSxliLa",14) == 3448851146) strcat(s, "r");
if (crc32("AUAbpTJyhBvK",12) == 2417079991) strcat(s, "L");
if (crc32("gwBowMHIuJwpLWJ",15) == 3283184071) strcat(s, "a");
if (crc32("vucfuiNbwNmn",12) == 4042646334) strcat(s, "s");
if (crc32("sBKrvv",6) == 318411252) strcat(s, "E");
if (crc32("GwgoK",5) == 2498419124) strcat(s, "p");
if (crc32("xApysmOJRwqt",12) == 4121833672) strcat(s, "N");
if (crc32("RUpfQuYrA",9) == 3011736840) strcat(s, "o");
if (crc32("ysiyFvEK",8) == 1384608531) strcat(s, "r");
if (crc32("Ducwypyv",8) == 3060415529) strcat(s, "i");
if (crc32("hLmYW",5) == 4274013445) strcat(s, "D");
if (crc32("vgAThtrQPj",10) == 1091783849) strcat(s, "c");
    return s;
}

char *antinational_adjectives() {
    char *s = calloc(13);
    if (crc32("kRpfpsr",7) == 1559000312) strcat(s, "a");
if (crc32("roHAffhdc",9) == 430342614) strcat(s, "n");
if (crc32("tSmidIk",7) == 505108389) strcat(s, "N");
if (crc32("ZeXGh",5) == 646408422) strcat(s, "t");
if (crc32("jzSkCJRCQprvSu",14) == 2890493634) strcat(s, "T");
if (crc32("pbyyzREAxuHR",12) == 4090755907) strcat(s, "i");
if (crc32("vCmGbxXdJ",9) == 2607689484) strcat(s, "y");
if (crc32("HeYRdn",6) == 1908246933) strcat(s, "n");
if (crc32("EYzJREgxiPidp",13) == 1175844009) strcat(s, "a");
if (crc32("PhLdCOuglyrKMR",14) == 1604091761) strcat(s, "t");
if (crc32("lHSqqY",6) == 242187974) strcat(s, "i");
if (crc32("TqRsLNy",7) == 352204224) strcat(s, "h");
if (crc32("bVXCXlyWOXv",11) == 3296418438) strcat(s, "o");
if (crc32("MsMfoVwysIT",11) == 527365138) strcat(s, "p");
if (crc32("hNzXs",5) == 4137942723) strcat(s, "n");
if (crc32("GNJmgUWEGqM",11) == 2068413626) strcat(s, "n");
if (crc32("MZurKiSNz",9) == 743831335) strcat(s, "a");
if (crc32("srMYdGciWakdB",13) == 4227631644) strcat(s, "l");
    return s;
}

char *unworldly_adjectives() {
    char *s = calloc(10);
    if (crc32("WCJuAgIpDwmT",12) == 952099316) strcat(s, "t");
if (crc32("aNDlhkpLRelTa",13) == 3175434761) strcat(s, "u");
if (crc32("rIYRYVqksDfFlv",14) == 4128351634) strcat(s, "n");
if (crc32("yFXDllaQnX",10) == 4109490575) strcat(s, "V");
if (crc32("euAabKpKmcTiDp",14) == 2324340361) strcat(s, "w");
if (crc32("leKDxdPoAEoxT",13) == 159045194) strcat(s, "M");
if (crc32("eDuIgzMPWBVAPZO",15) == 3968073197) strcat(s, "o");
if (crc32("XvRgHxHhzG",10) == 2621906511) strcat(s, "r");
if (crc32("XAajJzcDRx",10) == 302434494) strcat(s, "C");
if (crc32("FeikclR",7) == 2620851680) strcat(s, "l");
if (crc32("gRNewSL",7) == 3326253065) strcat(s, "d");
if (crc32("atfEsVBYyWYlvo",14) == 2680510508) strcat(s, "c");
if (crc32("easWbjTwMGXkQxq",15) == 3245091356) strcat(s, "l");
if (crc32("LkrfPEawtSxKl",13) == 4219251216) strcat(s, "y");
    return s;
}

char *unhistrionic_adjectives() {
    char *s = calloc(13);
    if (crc32("CDAtGJnCBkNMzZr",15) == 1738176373) strcat(s, "C");
if (crc32("neFlSxpiCNgUVJP",15) == 3853066890) strcat(s, "u");
if (crc32("qGiNvwqkRCWosTe",15) == 354888124) strcat(s, "n");
if (crc32("KMrSMpz",7) == 3584101355) strcat(s, "h");
if (crc32("iLnWTVGv",8) == 3152068921) strcat(s, "i");
if (crc32("lMnaLhvjQ",9) == 1182058092) strcat(s, "s");
if (crc32("RpsLzIoSFU",10) == 1081825907) strcat(s, "t");
if (crc32("YenMTwsxxsdAS",13) == 3732092925) strcat(s, "W");
if (crc32("uzGBdY",6) == 1068809062) strcat(s, "r");
if (crc32("cvUMLciq",8) == 1437201043) strcat(s, "B");
if (crc32("TGABKDK",7) == 99727737) strcat(s, "i");
if (crc32("Bpgrs",5) == 2752654095) strcat(s, "Y");
if (crc32("vefAxTkpNoTh",12) == 302068108) strcat(s, "o");
if (crc32("qsQwAsXZcbRkNDm",15) == 2857084274) strcat(s, "T");
if (crc32("oRxoOhJdH",9) == 1952445120) strcat(s, "n");
if (crc32("ZRWyzzErIhKQSk",14) == 1566239978) strcat(s, "X");
if (crc32("SRYWsUykxOSmPL",14) == 1844575587) strcat(s, "i");
if (crc32("xPgCAcShgu",10) == 565975374) strcat(s, "u");
if (crc32("oPOwrvXDsliSvGJ",15) == 2204403260) strcat(s, "c");
    return s;
}

char *albinistic_adjectives() {
    char *s = calloc(11);
    if (crc32("pviaBrlUik",10) == 3225780070) strcat(s, "a");
if (crc32("AIGjC",5) == 1086298385) strcat(s, "l");
if (crc32("DOCMBTii",8) == 2327068123) strcat(s, "T");
if (crc32("BgwDoxiP",8) == 489485509) strcat(s, "b");
if (crc32("OhMXbCrjqay",11) == 298507686) strcat(s, "V");
if (crc32("VLPdNmblHUHdZV",14) == 3329106998) strcat(s, "i");
if (crc32("VhVVwloO",8) == 2722570777) strcat(s, "h");
if (crc32("CTwqZsTWydsz",12) == 3999467201) strcat(s, "n");
if (crc32("UaHRB",5) == 3684558034) strcat(s, "i");
if (crc32("hKDlKjuegTiUXbw",15) == 1608580840) strcat(s, "s");
if (crc32("mUYUl",5) == 4260121222) strcat(s, "Q");
if (crc32("jFnvRVAu",8) == 2273720000) strcat(s, "t");
if (crc32("oysarRJuPzQ",11) == 2794161251) strcat(s, "i");
if (crc32("NfnGH",5) == 3134869408) strcat(s, "c");
    return s;
}

char *coed_adjectives() {
    char *s = calloc(5);
    if (crc32("iBhpfLvVgLZ",11) == 56160127) strcat(s, "c");
if (crc32("VxTjpABAhdtgsx",14) == 1343750617) strcat(s, "X");
if (crc32("tGkqQ",5) == 2725895298) strcat(s, "o");
if (crc32("ZWHyxNlft",9) == 2452917710) strcat(s, "e");
if (crc32("DtlUoanjS",9) == 3942216617) strcat(s, "d");
    return s;
}

char *African_adjectives() {
    char *s = calloc(8);
    if (crc32("pglKeaohfr",10) == 3381171978) strcat(s, "T");
if (crc32("kTFUxQTlOfwb",12) == 1010203430) strcat(s, "A");
if (crc32("ojgemGFiA",9) == 80432236) strcat(s, "O");
if (crc32("lZkpkZOUVGRrB",13) == 1735324916) strcat(s, "f");
if (crc32("GXMfgWBHCp",10) == 226158988) strcat(s, "X");
if (crc32("ibaKkQU",7) == 3524924535) strcat(s, "r");
if (crc32("kGijxRrQorQaOEs",15) == 1259288845) strcat(s, "A");
if (crc32("rgVSirKPjv",10) == 41194304) strcat(s, "i");
if (crc32("yBhvh",5) == 2659336143) strcat(s, "K");
if (crc32("GMDzWzJOgL",10) == 766415315) strcat(s, "c");
if (crc32("PWkdPSIVezXLUnD",15) == 1479088865) strcat(s, "a");
if (crc32("aAEzGoNY",8) == 1324156274) strcat(s, "n");
    return s;
}

char *concordal_adjectives() {
    char *s = calloc(10);
    if (crc32("JXOoP",5) == 672169177) strcat(s, "c");
if (crc32("NDRcvHAix",9) == 2888246045) strcat(s, "n");
if (crc32("sxWIRGJAdfpHAuf",15) == 3006212954) strcat(s, "o");
if (crc32("wgykzNgRTPLGN",13) == 1071566707) strcat(s, "n");
if (crc32("mwIfPiIZiqvc",12) == 3441250572) strcat(s, "e");
if (crc32("FfBQrlQap",9) == 4198296660) strcat(s, "c");
if (crc32("jcqiqCsjxS",10) == 270887019) strcat(s, "a");
if (crc32("CGXZnEamdgPTsR",14) == 3091734517) strcat(s, "o");
if (crc32("bVSZzFMi",8) == 827550866) strcat(s, "H");
if (crc32("UNNkiHCegYgmoF",14) == 304974347) strcat(s, "r");
if (crc32("ZmsJYRIhcOXSk",13) == 2893998874) strcat(s, "d");
if (crc32("twhzlUlo",8) == 3300343543) strcat(s, "E");
if (crc32("eRRwd",5) == 3010295975) strcat(s, "a");
if (crc32("iowKynLUtMXTJQ",14) == 233213526) strcat(s, "h");
if (crc32("OZLKReFjYrab",12) == 2169939546) strcat(s, "l");
    return s;
}

char *calorescent_adjectives() {
    char *s = calloc(12);
    if (crc32("pOmOGbvcLrMNeE",14) == 2050491944) strcat(s, "c");
if (crc32("oNApHSALK",9) == 988893356) strcat(s, "H");
if (crc32("wXqJKB",6) == 2320982349) strcat(s, "a");
if (crc32("MxsbsqJRi",9) == 2193796582) strcat(s, "l");
if (crc32("YbcxYbXLclwF",12) == 521518203) strcat(s, "o");
if (crc32("sVZNWvYbioZch",13) == 3588629771) strcat(s, "r");
if (crc32("TwPJzdlDKpqrfvB",15) == 2143486524) strcat(s, "U");
if (crc32("vknmuCXjAKYpC",13) == 1147929981) strcat(s, "e");
if (crc32("atwoRpvlHQnU",12) == 3102052586) strcat(s, "s");
if (crc32("jydZBhQAjQt",11) == 3064547622) strcat(s, "c");
if (crc32("wjDYIP",6) == 1236045019) strcat(s, "e");
if (crc32("XlNvKtj",7) == 1231351212) strcat(s, "Y");
if (crc32("DPnom",5) == 863210129) strcat(s, "n");
if (crc32("KjMhjYdlx",9) == 1532712611) strcat(s, "M");
if (crc32("xhKwXF",6) == 260538515) strcat(s, "t");
    return s;
}

char *conjunct_adjectives() {
    char *s = calloc(9);
    if (crc32("kQufgthbu",9) == 1063346652) strcat(s, "c");
if (crc32("hlYonAAMl",9) == 3157827253) strcat(s, "o");
if (crc32("pUqJWpQEiXuKB",13) == 2227627787) strcat(s, "n");
if (crc32("kcLSSJ",6) == 3361473959) strcat(s, "q");
if (crc32("EpvxPrh",7) == 1790495187) strcat(s, "j");
if (crc32("rpzIhKRBAgoS",12) == 2258404985) strcat(s, "u");
if (crc32("jakBeXdqCAl",11) == 839144833) strcat(s, "a");
if (crc32("zYksodkwCUjioN",14) == 3312633895) strcat(s, "n");
if (crc32("ItfjHvgA",8) == 2783807942) strcat(s, "a");
if (crc32("LTdioDCYzlj",11) == 3022594146) strcat(s, "c");
if (crc32("bFEeUU",6) == 2884957840) strcat(s, "w");
if (crc32("CjyirTQEdUYRrdL",15) == 2532554527) strcat(s, "t");
    return s;
}

char *pisolitic_adjectives() {
    char *s = calloc(10);
    if (crc32("gkFobcKnIieTAV",14) == 2131189145) strcat(s, "k");
if (crc32("fherchR",7) == 1670979506) strcat(s, "p");
if (crc32("ktHhZgdZ",8) == 3653895963) strcat(s, "i");
if (crc32("gTvrWqI",7) == 2735805242) strcat(s, "s");
if (crc32("cBHihSRpjqrd",12) == 4070113836) strcat(s, "r");
if (crc32("ehOtaoClsqljNh",14) == 2279956824) strcat(s, "o");
if (crc32("WczdbhPd",8) == 1629213153) strcat(s, "l");
if (crc32("ywHBfTHd",8) == 2306634644) strcat(s, "c");
if (crc32("qzgvKpmoXO",10) == 1217507798) strcat(s, "i");
if (crc32("tWfpuGMFe",9) == 3945302685) strcat(s, "z");
if (crc32("nXSdq",5) == 2800772764) strcat(s, "t");
if (crc32("aYuwAsgkjzvvo",13) == 35901470) strcat(s, "i");
if (crc32("aVKzZBS",7) == 100254145) strcat(s, "B");
if (crc32("FbhQm",5) == 1457098260) strcat(s, "c");
    return s;
}

char *nonscaling_adjectives() {
    char *s = calloc(11);
    if (crc32("fHbjbYOZSPLQ",12) == 2415264180) strcat(s, "N");
if (crc32("fWFEVOP",7) == 1799605044) strcat(s, "n");
if (crc32("gdljvdBi",8) == 2615858743) strcat(s, "o");
if (crc32("oCSGXrIHz",9) == 1392166435) strcat(s, "m");
if (crc32("dpqYzIWtsFIWvHK",15) == 4247758693) strcat(s, "n");
if (crc32("zhQfzPWuTwTynQ",14) == 3523180728) strcat(s, "v");
if (crc32("ydyqwhWZM",9) == 3280787208) strcat(s, "s");
if (crc32("nUVwLwOstLZ",11) == 602569562) strcat(s, "c");
if (crc32("nfMStzhu",8) == 1819789720) strcat(s, "g");
if (crc32("zHXfNjQ",7) == 3643520586) strcat(s, "a");
if (crc32("cERGqUGUW",9) == 2417682762) strcat(s, "R");
if (crc32("qHurHbBn",8) == 3614921952) strcat(s, "l");
if (crc32("uMaxYCxLDZIfnqm",15) == 3083773618) strcat(s, "i");
if (crc32("FTpxyww",7) == 2412700945) strcat(s, "n");
if (crc32("OMuwV",5) == 1041503508) strcat(s, "J");
if (crc32("UKkeYuVD",8) == 1952878884) strcat(s, "g");
    return s;
}

char *coseys_adjectives() {
    char *s = calloc(7);
    if (crc32("JufaQQjXgQaZ",12) == 2547240540) strcat(s, "L");
if (crc32("hIEriDyvNIXJH",13) == 1267745454) strcat(s, "c");
if (crc32("QuLtZtkpI",9) == 2660539163) strcat(s, "L");
if (crc32("ERRxBeBXYB",10) == 3160595920) strcat(s, "o");
if (crc32("MpIiii",6) == 3667769044) strcat(s, "s");
if (crc32("dIGqS",5) == 4246725275) strcat(s, "e");
if (crc32("BGumi",5) == 3016347943) strcat(s, "L");
if (crc32("FGFeAeJbOqNSSkP",15) == 2157669778) strcat(s, "y");
if (crc32("AlqXQAx",7) == 1051322999) strcat(s, "d");
if (crc32("pOsnUjFoDeHe",12) == 1015136128) strcat(s, "s");
    return s;
}

char *unprofaned_adjectives() {
    char *s = calloc(11);
    if (crc32("pZBuj",5) == 393323599) strcat(s, "u");
if (crc32("wYlNAuDQVGEJHE",14) == 3373819095) strcat(s, "x");
if (crc32("qojriktWtNDPO",13) == 1512604110) strcat(s, "n");
if (crc32("fxUVhpptm",9) == 3751078026) strcat(s, "N");
if (crc32("UetLp",5) == 1696071982) strcat(s, "p");
if (crc32("oVKIsoVzdnyY",12) == 288543032) strcat(s, "H");
if (crc32("wwUgxzNHlI",10) == 2803076713) strcat(s, "r");
if (crc32("WNeALHd",7) == 685747674) strcat(s, "Y");
if (crc32("pRsJxHw",7) == 3602554005) strcat(s, "o");
if (crc32("ivlpATDV",8) == 4258949618) strcat(s, "f");
if (crc32("rRtxzinfbUOhQN",14) == 402629495) strcat(s, "H");
if (crc32("Wmobff",6) == 2123094599) strcat(s, "a");
if (crc32("GtFOwRoSusfgf",13) == 1193285339) strcat(s, "n");
if (crc32("QzuGxGquCuuax",13) == 2892346683) strcat(s, "e");
if (crc32("dtkrCHHWSzSaoCt",15) == 3559685438) strcat(s, "a");
if (crc32("CRlef",5) == 1172536166) strcat(s, "d");
    return s;
}

char *laboursaving_adjectives() {
    char *s = calloc(13);
    if (crc32("cdDsz",5) == 1873087967) strcat(s, "l");
if (crc32("sXXlG",5) == 861817179) strcat(s, "w");
if (crc32("WhzZKwDovshv",12) == 17061951) strcat(s, "a");
if (crc32("JhDOZ",5) == 2705303077) strcat(s, "b");
if (crc32("gjrMdTSNqoH",11) == 3761357651) strcat(s, "J");
if (crc32("eMbedHJxZKg",11) == 1251270980) strcat(s, "o");
if (crc32("zuGUbG",6) == 4186878322) strcat(s, "u");
if (crc32("aSTdtmctiKvjaRl",15) == 368036124) strcat(s, "e");
if (crc32("ZIMOBhzuhl",10) == 1797040243) strcat(s, "r");
if (crc32("KnKOfUZBEJeD",12) == 2396435911) strcat(s, "x");
if (crc32("MKIdZ",5) == 3744470239) strcat(s, "s");
if (crc32("OzwwMPOzPmtD",12) == 3233259806) strcat(s, "Z");
if (crc32("sKxyFNOMqyWAa",13) == 4290633588) strcat(s, "a");
if (crc32("lIjjXVzI",8) == 532537090) strcat(s, "m");
if (crc32("iwCWfKnUFo",10) == 552896217) strcat(s, "v");
if (crc32("tSAdwQsaNKRKF",13) == 3859140899) strcat(s, "D");
if (crc32("SxKknKytnOv",11) == 2621765401) strcat(s, "i");
if (crc32("FeqbG",5) == 741310036) strcat(s, "B");
if (crc32("kpqjOgKDVV",10) == 4116787542) strcat(s, "n");
if (crc32("vHYuoQwjM",9) == 3698855729) strcat(s, "g");
    return s;
}

char *wellevidence_adjectives() {
    char *s = calloc(13);
    if (crc32("jXGBR",5) == 702953894) strcat(s, "w");
if (crc32("upQZNFZLqr",10) == 2862523886) strcat(s, "e");
if (crc32("pjFhghABDsEHOb",14) == 4105665709) strcat(s, "l");
if (crc32("YdtXooMUt",9) == 73545230) strcat(s, "l");
if (crc32("UbnPD",5) == 784185049) strcat(s, "e");
if (crc32("JohlzYrDfwmsLB",14) == 3290541677) strcat(s, "p");
if (crc32("UeTBhiXPesW",11) == 4201376325) strcat(s, "v");
if (crc32("JCtpWQf",7) == 2660456444) strcat(s, "Z");
if (crc32("AHKOAFxOMpviY",13) == 4192396999) strcat(s, "i");
if (crc32("oImiONtyX",9) == 65577950) strcat(s, "I");
if (crc32("QEsAwxgdZ",9) == 3642220845) strcat(s, "d");
if (crc32("ecfAYS",6) == 3124338502) strcat(s, "n");
if (crc32("BPNBEv",6) == 4160543974) strcat(s, "e");
if (crc32("KnQvESnvUmad",12) == 1344283428) strcat(s, "n");
if (crc32("BDfuLnvq",8) == 2628605470) strcat(s, "c");
if (crc32("cwVGFyUzPtB",11) == 3566109387) strcat(s, "e");
    return s;
}

char *circumpolar_adjectives() {
    char *s = calloc(12);
    if (crc32("wemrmkAGbSAulUi",15) == 2365456801) strcat(s, "a");
if (crc32("YpNEJupv",8) == 1453909143) strcat(s, "c");
if (crc32("Spmua",5) == 637176157) strcat(s, "Y");
if (crc32("bvDjlFbiuLIedll",15) == 3113186094) strcat(s, "i");
if (crc32("aoRjwtXlEriG",12) == 959610368) strcat(s, "P");
if (crc32("ExpAJGFvhKmCTL",14) == 1163047542) strcat(s, "r");
if (crc32("cvRBSyACnr",10) == 4105002926) strcat(s, "c");
if (crc32("FIbQWX",6) == 686207246) strcat(s, "e");
if (crc32("MqKKbxgXo",9) == 624124082) strcat(s, "u");
if (crc32("xoLLGnavekN",11) == 3476364638) strcat(s, "R");
if (crc32("GTSwg",5) == 3050070162) strcat(s, "m");
if (crc32("epLxczQApobpsr",14) == 1502828237) strcat(s, "p");
if (crc32("tLwNrxzt",8) == 639365625) strcat(s, "o");
if (crc32("ZxgjWHBRSfb",11) == 3582881466) strcat(s, "l");
if (crc32("JhkOyAn",7) == 2892830605) strcat(s, "a");
if (crc32("RglkgxJDP",9) == 598188118) strcat(s, "s");
if (crc32("nLbiCza",7) == 102387038) strcat(s, "r");
    return s;
}

char *fleeceless_adjectives() {
    char *s = calloc(11);
    if (crc32("OPQsTfAZbOFA",12) == 483968796) strcat(s, "f");
if (crc32("ndAmVEpRItsZgEQ",15) == 3668611117) strcat(s, "H");
if (crc32("LMmfVbv",7) == 1416777164) strcat(s, "l");
if (crc32("HDqeRjoMdrqvLR",14) == 1385789972) strcat(s, "e");
if (crc32("mpTPBpExioV",11) == 2332673728) strcat(s, "b");
if (crc32("bwRZer",6) == 430100624) strcat(s, "e");
if (crc32("LUZWy",5) == 1182628520) strcat(s, "u");
if (crc32("dfIkCdn",7) == 1555808400) strcat(s, "c");
if (crc32("JdVrnSJknvmT",12) == 2340313912) strcat(s, "e");
if (crc32("cWMYL",5) == 574306478) strcat(s, "l");
if (crc32("QJyfgtiu",8) == 449613078) strcat(s, "z");
if (crc32("sKJhdMfxFq",10) == 1421868602) strcat(s, "e");
if (crc32("GXWsJl",6) == 3842208915) strcat(s, "s");
if (crc32("LcYOQkoRBNS",11) == 3510150047) strcat(s, "s");
    return s;
}

char *unadjudicated_adjectives() {
    char *s = calloc(14);
    if (crc32("JJJTyTG",7) == 2903499850) strcat(s, "K");
if (crc32("Kjcng",5) == 3752021641) strcat(s, "u");
if (crc32("cwEgLspeudAW",12) == 1301467613) strcat(s, "s");
if (crc32("eTikH",5) == 1788288180) strcat(s, "n");
if (crc32("cORFukNZjB",10) == 1082413820) strcat(s, "a");
if (crc32("rHqRoRcMPxNZt",13) == 2956667729) strcat(s, "c");
if (crc32("wSXmkRDgcBikY",13) == 902149361) strcat(s, "d");
if (crc32("BeOSENGIVnVTp",13) == 988871015) strcat(s, "Z");
if (crc32("ZIyEcOFO",8) == 3732712815) strcat(s, "j");
if (crc32("vlJTXQuJzHE",11) == 1494781943) strcat(s, "u");
if (crc32("NHhRnBaqDKvYFPA",15) == 1329805933) strcat(s, "R");
if (crc32("LImqQBYyTIKpaF",14) == 2782176921) strcat(s, "d");
if (crc32("bvzWWWbWvj",10) == 1416911931) strcat(s, "y");
if (crc32("WEflyRBwEVSBab",14) == 667621734) strcat(s, "i");
if (crc32("vgwXPDrbMurbsRo",15) == 735631855) strcat(s, "c");
if (crc32("cBoSsj",6) == 3109749425) strcat(s, "a");
if (crc32("hjXVav",6) == 3223291033) strcat(s, "p");
if (crc32("iKoRoPYz",8) == 2209076100) strcat(s, "t");
if (crc32("YLNERUWSUEskZct",15) == 3564811775) strcat(s, "a");
if (crc32("xIGCYbKQzubggE",14) == 2486418740) strcat(s, "e");
if (crc32("taOZtbPoGlPbK",13) == 4104211619) strcat(s, "U");
if (crc32("ZdmCbp",6) == 3426435041) strcat(s, "d");
    return s;
}

char *unrumored_adjectives() {
    char *s = calloc(10);
    if (crc32("vaquErnAK",9) == 3343088612) strcat(s, "n");
if (crc32("fEAUL",5) == 3043270306) strcat(s, "u");
if (crc32("tpLOYNmvzCZQl",13) == 1918996859) strcat(s, "l");
if (crc32("gpdQhDWWUTEBF",13) == 3436006694) strcat(s, "n");
if (crc32("kKknbAxoHGiaUq",14) == 73210719) strcat(s, "m");
if (crc32("RMNtz",5) == 1812492108) strcat(s, "r");
if (crc32("ySNtUyOuXmGuFX",14) == 3958201021) strcat(s, "h");
if (crc32("OFhmBTMtGLqvg",13) == 3559861842) strcat(s, "u");
if (crc32("FRTiPVlP",8) == 893269942) strcat(s, "f");
if (crc32("IsMPt",5) == 2145006773) strcat(s, "m");
if (crc32("rcYMaqSw",8) == 1605826031) strcat(s, "D");
if (crc32("qBmeaUfuticAeGr",15) == 2984946591) strcat(s, "o");
if (crc32("LazeEVEbFaIEZW",14) == 2430146065) strcat(s, "u");
if (crc32("UilztfVXJ",9) == 1770151985) strcat(s, "r");
if (crc32("RwZbC",5) == 3689377425) strcat(s, "O");
if (crc32("zjrFSwyJh",9) == 4225628641) strcat(s, "e");
if (crc32("negSOc",6) == 3116305359) strcat(s, "d");
    return s;
}

char *tonguelike_adjectives() {
    char *s = calloc(11);
    if (crc32("JbnUBrgPChT",11) == 3314198752) strcat(s, "t");
if (crc32("tqRcKIkbRFcGiKx",15) == 2130197310) strcat(s, "o");
if (crc32("IeQfGnq",7) == 2790368095) strcat(s, "n");
if (crc32("mLdyA",5) == 1828951854) strcat(s, "p");
if (crc32("EYLzmjcqACNZDP",14) == 1958506804) strcat(s, "g");
if (crc32("eBPQadKWoPrcn",13) == 2049962442) strcat(s, "d");
if (crc32("ePjaPLhxCh",10) == 1732031233) strcat(s, "u");
if (crc32("xwvbGzgrActOtuQ",15) == 961945402) strcat(s, "e");
if (crc32("XVdwP",5) == 249467016) strcat(s, "y");
if (crc32("kChLrnLejqKN",12) == 148683062) strcat(s, "l");
if (crc32("eepyfG",6) == 1395207206) strcat(s, "i");
if (crc32("iDhCw",5) == 737124874) strcat(s, "M");
if (crc32("ZtThIMzGxGkVj",13) == 1093864818) strcat(s, "k");
if (crc32("JVCfZOvcgHgJpch",15) == 2108418609) strcat(s, "t");
if (crc32("cyJsduLKdf",10) == 1251834753) strcat(s, "e");
    return s;
}

char *unvenial_adjectives() {
    char *s = calloc(9);
    if (crc32("tbAZIDEIrGSGaWm",15) == 2211988493) strcat(s, "n");
if (crc32("BhhHrCAPRUY",11) == 3702968998) strcat(s, "u");
if (crc32("qqsEsuSirm",10) == 3712719006) strcat(s, "G");
if (crc32("GAwTS",5) == 1918020311) strcat(s, "n");
if (crc32("KZIetRtxcuVzDNh",15) == 4190033213) strcat(s, "q");
if (crc32("SEAOvLL",7) == 100308809) strcat(s, "v");
if (crc32("WDwPUYJIBGww",12) == 656850318) strcat(s, "D");
if (crc32("Qkmwg",5) == 3704693469) strcat(s, "e");
if (crc32("oxZAg",5) == 2578707072) strcat(s, "H");
if (crc32("metCYfhjxH",10) == 2506007367) strcat(s, "n");
if (crc32("diFPymIObP",10) == 334765588) strcat(s, "V");
if (crc32("neYbdKPQKXAI",12) == 2133393833) strcat(s, "i");
if (crc32("oieFgxysgnP",11) == 2247772506) strcat(s, "a");
if (crc32("LyCiKnSQvLr",11) == 2281356859) strcat(s, "F");
if (crc32("Wwtons",6) == 2115991626) strcat(s, "l");
    return s;
}

char *razorless_adjectives() {
    char *s = calloc(10);
    if (crc32("bdUWsbctoTHLKSx",15) == 653603306) strcat(s, "x");
if (crc32("RgDPKOOUigWmwS",14) == 1233430610) strcat(s, "r");
if (crc32("HYvjQ",5) == 3256399320) strcat(s, "d");
if (crc32("MTXpnTq",7) == 4151286368) strcat(s, "a");
if (crc32("TKagAQK",7) == 2538281633) strcat(s, "m");
if (crc32("rOKAsiCyfQLcel",14) == 959442083) strcat(s, "z");
if (crc32("vUKThNKFtI",10) == 4232088088) strcat(s, "o");
if (crc32("EpYMYiPFIpKtgE",14) == 923102710) strcat(s, "r");
if (crc32("KKwaBu",6) == 2795742034) strcat(s, "l");
if (crc32("dmGyaVFcm",9) == 3535075701) strcat(s, "m");
if (crc32("bpBKPsrZCWNBBP",14) == 2485764485) strcat(s, "e");
if (crc32("CeEBfrqbeI",10) == 3774830958) strcat(s, "s");
if (crc32("XEYZG",5) == 2836049866) strcat(s, "s");
    return s;
}

char *adaptive_adjectives() {
    char *s = calloc(9);
    if (crc32("nRxMc",5) == 1281468474) strcat(s, "v");
if (crc32("LiYVPGLj",8) == 3600776705) strcat(s, "a");
if (crc32("ZvIDcDrwe",9) == 2783876908) strcat(s, "N");
if (crc32("KSlWCHfmyYv",11) == 3918573950) strcat(s, "d");
if (crc32("ekUSnhORATC",11) == 1153194430) strcat(s, "a");
if (crc32("dOpmoMnopUHr",12) == 1266234056) strcat(s, "b");
if (crc32("nlCis",5) == 2654975355) strcat(s, "p");
if (crc32("BGCdwDs",7) == 4147667326) strcat(s, "J");
if (crc32("BIYCBurI",8) == 2599782840) strcat(s, "t");
if (crc32("fcjDTpCZXsfmN",13) == 50114555) strcat(s, "M");
if (crc32("HWGRRUirqNet",12) == 278866061) strcat(s, "i");
if (crc32("cVdtfEiXwfK",11) == 4116885089) strcat(s, "Y");
if (crc32("RyJoQtnJR",9) == 1023393936) strcat(s, "v");
if (crc32("tOcSygtTog",10) == 3896381520) strcat(s, "e");
    return s;
}

char *unreconcilable_adjectives() {
    char *s = calloc(15);
    if (crc32("FGLTiByba",9) == 4010573445) strcat(s, "u");
if (crc32("GfXOVyEXwYAd",12) == 2815486066) strcat(s, "n");
if (crc32("CfOVk",5) == 2323379620) strcat(s, "r");
if (crc32("KkMKDNjjKqBkw",13) == 1130957365) strcat(s, "L");
if (crc32("ATflQCsnPZYz",12) == 1217291733) strcat(s, "e");
if (crc32("ajMSCcU",7) == 2811429756) strcat(s, "p");
if (crc32("ARZPYyVEMUoqaeC",15) == 196516568) strcat(s, "c");
if (crc32("xlsshkKmPJ",10) == 1777416849) strcat(s, "o");
if (crc32("BRyUyh",6) == 335614234) strcat(s, "m");
if (crc32("DueHYyJpBk",10) == 1177829928) strcat(s, "n");
if (crc32("wWlyYRGHslGfcg",14) == 3374700198) strcat(s, "c");
if (crc32("vvLckm",6) == 879912805) strcat(s, "i");
if (crc32("qtraFmfRfyC",11) == 1655141015) strcat(s, "x");
if (crc32("rFJkLzjXqgJaC",13) == 1362265044) strcat(s, "l");
if (crc32("yxFOkaqZe",9) == 597343772) strcat(s, "F");
if (crc32("FSiUwcPtiXsHfAc",15) == 2435123662) strcat(s, "a");
if (crc32("IXakEjUMnDHsL",13) == 2546376549) strcat(s, "b");
if (crc32("IqRMn",5) == 3226770095) strcat(s, "N");
if (crc32("GArcOgiFRNCsfCq",15) == 3784264722) strcat(s, "l");
if (crc32("CQTdWoOAJh",10) == 2007602538) strcat(s, "N");
if (crc32("yltCrVTtvIfAHS",14) == 2128456144) strcat(s, "e");
    return s;
}

char *unsandaled_adjectives() {
    char *s = calloc(11);
    if (crc32("VGLtaxv",7) == 1826546437) strcat(s, "E");
if (crc32("XMDlKaRw",8) == 1306154231) strcat(s, "u");
if (crc32("SrJjTbdTaCNiOPT",15) == 1670167977) strcat(s, "n");
if (crc32("LucTfHqxrqw",11) == 3713242241) strcat(s, "s");
if (crc32("dNLtsIaUdIbPK",13) == 799725717) strcat(s, "a");
if (crc32("DVpyouKWyZJA",12) == 1452579719) strcat(s, "n");
if (crc32("DRbpKfqvygPp",12) == 1814886581) strcat(s, "E");
if (crc32("vMziyzq",7) == 4255965235) strcat(s, "d");
if (crc32("UQdoWQxvghbnK",13) == 1963881597) strcat(s, "a");
if (crc32("wUbFeYCBOKkEBE",14) == 2721262092) strcat(s, "l");
if (crc32("rByvpIawSUM",11) == 2552267780) strcat(s, "U");
if (crc32("gmjTuGOP",8) == 70244108) strcat(s, "e");
if (crc32("qtCbRL",6) == 1224467256) strcat(s, "d");
    return s;
}

char *freckliest_adjectives() {
    char *s = calloc(11);
    if (crc32("UroqLcgAvDCf",12) == 1278952732) strcat(s, "f");
if (crc32("RndaYcvrNC",10) == 3565069838) strcat(s, "J");
if (crc32("WBCiSFfWtRAZE",13) == 3265372105) strcat(s, "r");
if (crc32("eRrjkOxYEw",10) == 3485409272) strcat(s, "J");
if (crc32("fgXgUFXBKynVNtj",15) == 1464763997) strcat(s, "e");
if (crc32("UZdiPSNDpStrXhW",15) == 3838346366) strcat(s, "c");
if (crc32("lITfJsyRLPyFBCN",15) == 2356251202) strcat(s, "K");
if (crc32("kqguJstdY",9) == 1714207781) strcat(s, "k");
if (crc32("XGivi",5) == 3264210096) strcat(s, "l");
if (crc32("FEcaP",5) == 1720147999) strcat(s, "O");
if (crc32("WctuhM",6) == 1844827523) strcat(s, "i");
if (crc32("ggjKWFhi",8) == 610959375) strcat(s, "t");
if (crc32("szihTfKbOw",10) == 3543079327) strcat(s, "e");
if (crc32("UNIzVtGOJWQyU",13) == 3146118407) strcat(s, "a");
if (crc32("heEmsmqZjxhUeQm",15) == 1731952659) strcat(s, "s");
if (crc32("CCvzeyhLZxpXfsA",15) == 4156379801) strcat(s, "A");
if (crc32("kEaWbnAPKJ",10) == 219541104) strcat(s, "t");
    return s;
}

char *overeasy_adjectives() {
    char *s = calloc(9);
    if (crc32("gezxQ",5) == 1126442091) strcat(s, "o");
if (crc32("fkFwvBVSV",9) == 1227686106) strcat(s, "v");
if (crc32("geZmmECWrg",10) == 2123654258) strcat(s, "s");
if (crc32("FwgfvCPfNmezx",13) == 3583395309) strcat(s, "e");
if (crc32("VzxEIThcdSnms",13) == 795618680) strcat(s, "r");
if (crc32("OfWIlPHeKjpK",12) == 543909692) strcat(s, "V");
if (crc32("EaiwP",5) == 2579037736) strcat(s, "e");
if (crc32("gZShMLzRhzlbdb",14) == 3221190470) strcat(s, "a");
if (crc32("qMwbBtii",8) == 929372834) strcat(s, "s");
if (crc32("wNNpowa",7) == 555810412) strcat(s, "N");
if (crc32("EMixomRAdNQ",11) == 3171866341) strcat(s, "y");
    return s;
}

char *nondispersive_adjectives() {
    char *s = calloc(14);
    if (crc32("XlETX",5) == 1921463569) strcat(s, "n");
if (crc32("UoTLBhHDCQkvYKe",15) == 2548586297) strcat(s, "o");
if (crc32("uUlUaNPpaDbV",12) == 3777539981) strcat(s, "n");
if (crc32("FCkMFSZZNgiG",12) == 2773910155) strcat(s, "d");
if (crc32("FcfWrBOwAfBYJUj",15) == 224733344) strcat(s, "i");
if (crc32("uSUgnaoUdXHr",12) == 2260482127) strcat(s, "a");
if (crc32("TSJankpPNLMsVD",14) == 2215105772) strcat(s, "s");
if (crc32("MAHefSqlB",9) == 3361584043) strcat(s, "p");
if (crc32("MpOpQyWwaRznL",13) == 1545688092) strcat(s, "e");
if (crc32("SiYBMadiX",9) == 721925060) strcat(s, "r");
if (crc32("OlWDyHtpu",9) == 3826728042) strcat(s, "s");
if (crc32("KmZdGvxSITLxJt",14) == 1906792308) strcat(s, "Z");
if (crc32("WIVamOALgoCE",12) == 4178773867) strcat(s, "i");
if (crc32("TYSwem",6) == 2958105190) strcat(s, "v");
if (crc32("quJFMlsnbQSUas",14) == 2340833640) strcat(s, "e");
    return s;
}

char *epilimnial_adjectives() {
    char *s = calloc(11);
    if (crc32("GXPFnlTL",8) == 1291657837) strcat(s, "u");
if (crc32("juNjr",5) == 308083624) strcat(s, "e");
if (crc32("NjBTvkArDNue",12) == 7812720) strcat(s, "p");
if (crc32("cEOilEvc",8) == 1876810288) strcat(s, "W");
if (crc32("ghejRcMD",8) == 2468185053) strcat(s, "i");
if (crc32("ucIeo",5) == 3735883236) strcat(s, "m");
if (crc32("KwLgNNARZYQGwu",14) == 1292270733) strcat(s, "l");
if (crc32("coxzdaIrhlWhM",13) == 3720272353) strcat(s, "i");
if (crc32("KhPxemie",8) == 3217611709) strcat(s, "T");
if (crc32("UfZFa",5) == 3575713106) strcat(s, "m");
if (crc32("MKbzsr",6) == 10479138) strcat(s, "T");
if (crc32("QdnDMKVe",8) == 3629275552) strcat(s, "n");
if (crc32("ArNEVqBj",8) == 2568387427) strcat(s, "T");
if (crc32("QHannGJLAVZbaFW",15) == 167995117) strcat(s, "i");
if (crc32("TiuFamMwBFRrr",13) == 3216611067) strcat(s, "i");
if (crc32("dRGds",5) == 1994192089) strcat(s, "a");
if (crc32("XekKXZBA",8) == 3640282145) strcat(s, "o");
if (crc32("MTiDD",5) == 2156661815) strcat(s, "l");
    return s;
}

char *lushiest_adjectives() {
    char *s = calloc(9);
    if (crc32("AGKAxJhVYycZ",12) == 1688362680) strcat(s, "l");
if (crc32("OCtqNPVynKkwH",13) == 2629179230) strcat(s, "u");
if (crc32("tEYYs",5) == 2489689564) strcat(s, "K");
if (crc32("KhHfcqYvFAJBNA",14) == 1226387062) strcat(s, "s");
if (crc32("SJVWljfIvkqgFex",15) == 35570068) strcat(s, "h");
if (crc32("cIgnBHVVnuCGA",13) == 1656918029) strcat(s, "t");
if (crc32("zxUsm",5) == 2259508363) strcat(s, "i");
if (crc32("YeMJthiIGgmhHSH",15) == 3508483902) strcat(s, "e");
if (crc32("BXAErZgxEq",10) == 555594544) strcat(s, "s");
if (crc32("giKUDgMHGI",10) == 1031784290) strcat(s, "t");
    return s;
}

char *cosmographic_adjectives() {
    char *s = calloc(13);
    if (crc32("YmVeYUEDYyppzmP",15) == 2186199336) strcat(s, "c");
if (crc32("vdqBbDrfMnFoL",13) == 1934112539) strcat(s, "o");
if (crc32("BFviqSKVehp",11) == 2288477778) strcat(s, "s");
if (crc32("DteQFaAd",8) == 3645891111) strcat(s, "m");
if (crc32("krliynJlkLjopZz",15) == 962791039) strcat(s, "C");
if (crc32("hhDDt",5) == 622595653) strcat(s, "o");
if (crc32("buQcceVrn",9) == 3481983962) strcat(s, "c");
if (crc32("KDUbauYwNMHw",12) == 1178038676) strcat(s, "g");
if (crc32("jwLogSuzdLL",11) == 1640491662) strcat(s, "r");
if (crc32("THDsHMiEj",9) == 416599847) strcat(s, "h");
if (crc32("hQTlqiFIbYzH",12) == 1269871591) strcat(s, "a");
if (crc32("jBzSAqvy",8) == 186518698) strcat(s, "O");
if (crc32("yPOdsv",6) == 2485249994) strcat(s, "p");
if (crc32("OljwQYeYXwIfJek",15) == 2137294668) strcat(s, "p");
if (crc32("wwZNBerq",8) == 3852773215) strcat(s, "h");
if (crc32("UThuXbXpOBzgPqS",15) == 2697783705) strcat(s, "s");
if (crc32("uwWQTWwe",8) == 3433015850) strcat(s, "i");
if (crc32("nmZaACeRp",9) == 4014653009) strcat(s, "K");
if (crc32("WyQBQzYAoER",11) == 1285496447) strcat(s, "c");
    return s;
}

char *unconverged_adjectives() {
    char *s = calloc(12);
    if (crc32("tPesvbGcfJ",10) == 4236563240) strcat(s, "u");
if (crc32("MhRaRCwTVQiVBz",14) == 2596738064) strcat(s, "n");
if (crc32("QzBjTdBLVCysY",13) == 1465947361) strcat(s, "J");
if (crc32("rhRZEMXSNlO",11) == 3065653230) strcat(s, "c");
if (crc32("xlGdIe",6) == 1594873504) strcat(s, "o");
if (crc32("QxyvwILXro",10) == 4063064854) strcat(s, "n");
if (crc32("vHHQHiWzjbr",11) == 1989500195) strcat(s, "v");
if (crc32("XplmzIZBzbQFnhj",15) == 3985827019) strcat(s, "U");
if (crc32("DkMQRdgcOujIzhd",15) == 4124675456) strcat(s, "e");
if (crc32("nQhdIjqR",8) == 3186225783) strcat(s, "r");
if (crc32("tJrLFuu",7) == 2137566996) strcat(s, "g");
if (crc32("ajDhRHnB",8) == 386885077) strcat(s, "e");
if (crc32("sHbYapC",7) == 2176858556) strcat(s, "A");
if (crc32("EqnnBBXF",8) == 4116878744) strcat(s, "d");
    return s;
}

char *multiflagellate_adjectives() {
    char *s = calloc(16);
    if (crc32("UMaig",5) == 1901310532) strcat(s, "m");
if (crc32("oaNRAPuEYmIg",12) == 4134657924) strcat(s, "J");
if (crc32("tulimYvmnbrBp",13) == 275377307) strcat(s, "u");
if (crc32("cWOTLG",6) == 2837960113) strcat(s, "l");
if (crc32("tawJpEq",7) == 122020229) strcat(s, "t");
if (crc32("wYEHIeOBBWOJj",13) == 2278762400) strcat(s, "S");
if (crc32("mbjittfu",8) == 2881859610) strcat(s, "i");
if (crc32("vmqqx",5) == 28192936) strcat(s, "H");
if (crc32("lVacBhYBGrC",11) == 605763027) strcat(s, "f");
if (crc32("MsgVjb",6) == 1310211311) strcat(s, "l");
if (crc32("DmslWbhl",8) == 3113656710) strcat(s, "J");
if (crc32("okHUlgm",7) == 1317216818) strcat(s, "a");
if (crc32("TtXWrmWwmiLQJBh",15) == 3731708784) strcat(s, "g");
if (crc32("UYFFd",5) == 1106196400) strcat(s, "b");
if (crc32("CFDaWKACMECWqo",14) == 3963730051) strcat(s, "e");
if (crc32("feTpSdLnV",9) == 1187156281) strcat(s, "l");
if (crc32("QFvwJCEmkFJIy",13) == 1183120456) strcat(s, "U");
if (crc32("rbWDYNrGdeTT",12) == 3645346751) strcat(s, "l");
if (crc32("haxgUfLpwUa",11) == 2938058019) strcat(s, "N");
if (crc32("FowWhXJqBu",10) == 476906851) strcat(s, "a");
if (crc32("gWLZZtmsO",9) == 2614556774) strcat(s, "t");
if (crc32("eCZUtP",6) == 941890038) strcat(s, "e");
if (crc32("EdzgXrJaHymCYx",14) == 361564109) strcat(s, "e");
    return s;
}

char *unpartisan_adjectives() {
    char *s = calloc(11);
    if (crc32("UqBHOSzgIEUkQ",13) == 690474263) strcat(s, "u");
if (crc32("FnVNd",5) == 108187024) strcat(s, "T");
if (crc32("GwUJTGzfrLaPW",13) == 3507194775) strcat(s, "n");
if (crc32("ZNydahlYhP",10) == 691161475) strcat(s, "p");
if (crc32("sdTELRab",8) == 4180971338) strcat(s, "t");
if (crc32("UboDnq",6) == 3336165632) strcat(s, "a");
if (crc32("WKhbcuvuxhloM",13) == 3431305328) strcat(s, "r");
if (crc32("hicslMbuLfbf",12) == 849560097) strcat(s, "D");
if (crc32("QaDKoiYGMWsSl",13) == 4121305968) strcat(s, "t");
if (crc32("YPFVxqij",8) == 2150424469) strcat(s, "i");
if (crc32("hLEHtpDwDDsQ",12) == 668382051) strcat(s, "f");
if (crc32("rJHFGNYkZbkBigq",15) == 2851727358) strcat(s, "s");
if (crc32("zmTHdwFpUkuy",12) == 3859376195) strcat(s, "v");
if (crc32("jKUkVDvdiVBG",12) == 1543375261) strcat(s, "a");
if (crc32("lAHBNPlKjNCGvxB",15) == 3904796526) strcat(s, "n");
    return s;
}

char *proFreud_adjectives() {
    char *s = calloc(9);
    if (crc32("CXHyU",5) == 3579583105) strcat(s, "e");
if (crc32("VmRuhCGSwzyB",12) == 3869572822) strcat(s, "p");
if (crc32("gbSgM",5) == 1157268881) strcat(s, "B");
if (crc32("VrtCawmujj",10) == 4118145930) strcat(s, "r");
if (crc32("pauIscmCekZUMU",14) == 160184999) strcat(s, "e");
if (crc32("uAERBr",6) == 805839726) strcat(s, "o");
if (crc32("qLwdiBkSu",9) == 2033471823) strcat(s, "m");
if (crc32("FgFtFvirzsIvaj",14) == 1568798848) strcat(s, "F");
if (crc32("bKbpmdrXwBoSxT",14) == 2230646235) strcat(s, "a");
if (crc32("SoDSEGvYoUO",11) == 1413332826) strcat(s, "r");
if (crc32("zhJeJZNbeOJ",11) == 3497439734) strcat(s, "a");
if (crc32("PgVbRUaMjwLiZ",13) == 2736985734) strcat(s, "e");
if (crc32("VnBGc",5) == 2987785672) strcat(s, "u");
if (crc32("KPpQbkXgBN",10) == 1705309489) strcat(s, "d");
    return s;
}

char *haematoid_adjectives() {
    char *s = calloc(10);
    if (crc32("EiQmhIhLO",9) == 1652095400) strcat(s, "Y");
if (crc32("VVFOKOhz",8) == 2683024128) strcat(s, "h");
if (crc32("soTMxCQR",8) == 4159521832) strcat(s, "a");
if (crc32("fnsmpoAc",8) == 1364651865) strcat(s, "e");
if (crc32("dqhOEa",6) == 2399744795) strcat(s, "x");
if (crc32("cVfzHDAI",8) == 3655164459) strcat(s, "m");
if (crc32("bodYZk",6) == 3987331249) strcat(s, "j");
if (crc32("WkBAzSATJ",9) == 964146798) strcat(s, "a");
if (crc32("tcanRyJmRg",10) == 577574723) strcat(s, "M");
if (crc32("BZgdneieRLg",11) == 3699306527) strcat(s, "t");
if (crc32("japYG",5) == 1117005408) strcat(s, "Y");
if (crc32("oeFkdUcjiICnQc",14) == 3808761181) strcat(s, "o");
if (crc32("NeJUFIGunspIeuj",15) == 570222167) strcat(s, "i");
if (crc32("NhoBwmeXihoA",12) == 3251711598) strcat(s, "Q");
if (crc32("tSsXkOYlYdpkzq",14) == 3013496919) strcat(s, "d");
    return s;
}

char *compellable_adjectives() {
    char *s = calloc(12);
    if (crc32("sqTWQxXfX",9) == 378309564) strcat(s, "c");
if (crc32("QJYCp",5) == 3299620327) strcat(s, "k");
if (crc32("zmFkpELswDItT",13) == 3061915190) strcat(s, "o");
if (crc32("KblNLvQSdIC",11) == 3457640729) strcat(s, "m");
if (crc32("tspgGpKz",8) == 1105668625) strcat(s, "p");
if (crc32("tPalAaTvTxaiwxH",15) == 1248015433) strcat(s, "C");
if (crc32("vTrPstNlp",9) == 2059649713) strcat(s, "e");
if (crc32("ydMsKVG",7) == 1818441064) strcat(s, "x");
if (crc32("HITjpqMkxHCrMd",14) == 1624472161) strcat(s, "l");
if (crc32("TneFJbO",7) == 3149221714) strcat(s, "x");
if (crc32("lnPEBQj",7) == 176442876) strcat(s, "l");
if (crc32("GtZRVimNl",9) == 3909961226) strcat(s, "u");
if (crc32("AiBSRRAGTftjxIZ",15) == 3338114274) strcat(s, "a");
if (crc32("owVEUtSJfMBCweg",15) == 544507891) strcat(s, "t");
if (crc32("SouCVciZPuTTTw",14) == 3408155385) strcat(s, "b");
if (crc32("MxKOuvULn",9) == 1305874458) strcat(s, "X");
if (crc32("yRVBlYLWeo",10) == 3257692101) strcat(s, "l");
if (crc32("SOsHsdhNsdMgT",13) == 2253289105) strcat(s, "U");
if (crc32("acBmNNNFOzZQjk",14) == 2021129257) strcat(s, "e");
    return s;
}


char *(*adjectives_list[4096])() = {
unexpandable_adjectives,
carcinomatoid_adjectives,
proemial_adjectives,
explosive_adjectives,
gobony_adjectives,
slidable_adjectives,
halfburied_adjectives,
monarchistic_adjectives,
nonparabolical_adjectives,
unspasmodic_adjectives,
halfveiled_adjectives,
selfdestroyed_adjectives,
brambliest_adjectives,
halfpleased_adjectives,
groveless_adjectives,
irradiative_adjectives,
lobar_adjectives,
antiliturgy_adjectives,
convocative_adjectives,
caritive_adjectives,
catkinate_adjectives,
tricuspidate_adjectives,
multifocal_adjectives,
unparental_adjectives,
nonreservable_adjectives,
unmilted_adjectives,
unproportioned_adjectives,
supersingular_adjectives,
suppressive_adjectives,
pokier_adjectives,
nonelicited_adjectives,
auntlike_adjectives,
semisavage_adjectives,
halfcontented_adjectives,
masked_adjectives,
spirant_adjectives,
generative_adjectives,
manubrial_adjectives,
unarbitrary_adjectives,
untameable_adjectives,
dignitarial_adjectives,
spiritualistic_adjectives,
complementfixing_adjectives,
cryogenic_adjectives,
active_adjectives,
pseudoreformed_adjectives,
yeararound_adjectives,
unneedy_adjectives,
glandulous_adjectives,
serflike_adjectives,
ternate_adjectives,
wirespun_adjectives,
unrelishing_adjectives,
overdiverse_adjectives,
unmerry_adjectives,
untransformed_adjectives,
superlaborious_adjectives,
exostotic_adjectives,
ketogenetic_adjectives,
illusionistic_adjectives,
impressional_adjectives,
nonconsultative_adjectives,
postmeiotic_adjectives,
indecipherable_adjectives,
radical_adjectives,
neuroglic_adjectives,
goddamned_adjectives,
oceanographic_adjectives,
amphitropous_adjectives,
freer_adjectives,
redundant_adjectives,
promotional_adjectives,
jerseyed_adjectives,
Navarrian_adjectives,
kinematographic_adjectives,
sharpedged_adjectives,
capitular_adjectives,
masturbatory_adjectives,
palaverous_adjectives,
unpendant_adjectives,
germinable_adjectives,
ceremonial_adjectives,
factitive_adjectives,
euphonic_adjectives,
antirevolution_adjectives,
vortical_adjectives,
unendorsable_adjectives,
wellpaved_adjectives,
undisclosed_adjectives,
phlegmy_adjectives,
wellverified_adjectives,
columbous_adjectives,
subbranchial_adjectives,
unacrimonious_adjectives,
postsuppurative_adjectives,
preAryan_adjectives,
presbyterian_adjectives,
Levitical_adjectives,
nonpassionate_adjectives,
nuggety_adjectives,
granulocytic_adjectives,
pyic_adjectives,
subtransversal_adjectives,
nonapologetical_adjectives,
overhearty_adjectives,
isobathic_adjectives,
better_adjectives,
overage_adjectives,
aroundtheclock_adjectives,
monogrammatic_adjectives,
nonabstemious_adjectives,
nonlicentious_adjectives,
unterminational_adjectives,
espiagle_adjectives,
assumed_adjectives,
quasireported_adjectives,
noncotyledonous_adjectives,
flexuous_adjectives,
subpetiolated_adjectives,
pluriliteral_adjectives,
flocculent_adjectives,
Nepalese_adjectives,
Plutonian_adjectives,
trafficless_adjectives,
gentler_adjectives,
subcostal_adjectives,
whiterobed_adjectives,
quasieducated_adjectives,
unenumerative_adjectives,
pentarchical_adjectives,
haemic_adjectives,
hypoblastic_adjectives,
selfidolized_adjectives,
guiltless_adjectives,
pettier_adjectives,
laddish_adjectives,
impartial_adjectives,
vizarded_adjectives,
unrinsed_adjectives,
tubbier_adjectives,
quasilegitimate_adjectives,
superformal_adjectives,
unlaved_adjectives,
chloric_adjectives,
gnarliest_adjectives,
fattier_adjectives,
vengeful_adjectives,
unridden_adjectives,
sonic_adjectives,
alleviative_adjectives,
hyposulfurous_adjectives,
prespecific_adjectives,
uncounselled_adjectives,
selfaggrandizing_adjectives,
noniodized_adjectives,
laboristic_adjectives,
magnetohydrodynamic_adjectives,
thoric_adjectives,
overobedient_adjectives,
lauraceous_adjectives,
quasibiographical_adjectives,
unisometrical_adjectives,
prototypal_adjectives,
superelastic_adjectives,
inequable_adjectives,
Ugrian_adjectives,
impetiginous_adjectives,
cytophagic_adjectives,
pseudoprophetical_adjectives,
uncracked_adjectives,
smilacaceous_adjectives,
pterocarpous_adjectives,
palmiest_adjectives,
correctible_adjectives,
nonHibernian_adjectives,
unentombed_adjectives,
gimcrack_adjectives,
Samoyedic_adjectives,
kilted_adjectives,
nonreciprocal_adjectives,
welldebated_adjectives,
quasidefinite_adjectives,
postnodal_adjectives,
Jeffersonian_adjectives,
amphitokous_adjectives,
unfutile_adjectives,
offertorial_adjectives,
crotchety_adjectives,
antinomical_adjectives,
Cesarean_adjectives,
unevaporated_adjectives,
friable_adjectives,
chewy_adjectives,
propertied_adjectives,
unbureaucratic_adjectives,
consistorian_adjectives,
dacolleta_adjectives,
unacknowledged_adjectives,
selfbetraying_adjectives,
scoldable_adjectives,
halfcivilized_adjectives,
unpurified_adjectives,
factional_adjectives,
sweatier_adjectives,
nonanimate_adjectives,
unapposite_adjectives,
brakeless_adjectives,
windier_adjectives,
undeepened_adjectives,
secular_adjectives,
womanish_adjectives,
nonincriminating_adjectives,
antimoralistic_adjectives,
undistrained_adjectives,
tardier_adjectives,
dolllike_adjectives,
immovable_adjectives,
unrhapsodical_adjectives,
nonintrospective_adjectives,
uncamped_adjectives,
hydrolyzable_adjectives,
inborn_adjectives,
hatchetlike_adjectives,
intermuscular_adjectives,
popelike_adjectives,
unbangled_adjectives,
plural_adjectives,
verier_adjectives,
Herzegovinian_adjectives,
inclement_adjectives,
PostImpressionistic_adjectives,
unpaternal_adjectives,
overkeen_adjectives,
knowledgeable_adjectives,
cranky_adjectives,
anacusic_adjectives,
flakiest_adjectives,
unruffed_adjectives,
unrepined_adjectives,
shady_adjectives,
berserk_adjectives,
Tai_adjectives,
resentful_adjectives,
searoving_adjectives,
cavate_adjectives,
nonpeaked_adjectives,
uncomprehended_adjectives,
oarless_adjectives,
Neustrian_adjectives,
overangry_adjectives,
metonymical_adjectives,
overburdensome_adjectives,
occupative_adjectives,
overkind_adjectives,
wellreputed_adjectives,
durative_adjectives,
subunequal_adjectives,
wellattained_adjectives,
loosefooted_adjectives,
unbending_adjectives,
preTertiary_adjectives,
robust_adjectives,
halfprofessed_adjectives,
instructorial_adjectives,
easy_adjectives,
uncasketed_adjectives,
nonirrigated_adjectives,
epidural_adjectives,
undistant_adjectives,
indusial_adjectives,
unsubjugated_adjectives,
viniferous_adjectives,
multivalent_adjectives,
teetotal_adjectives,
Carolinian_adjectives,
proBrazilian_adjectives,
nonconductible_adjectives,
unmossy_adjectives,
zoophobous_adjectives,
transCarpathian_adjectives,
interstrial_adjectives,
unrestful_adjectives,
malarian_adjectives,
fragmentary_adjectives,
crackbrained_adjectives,
quasihappy_adjectives,
alexipharmic_adjectives,
analytic_adjectives,
nonrepayable_adjectives,
pulverisable_adjectives,
scotomatous_adjectives,
unsocializable_adjectives,
proFlorentine_adjectives,
unessayed_adjectives,
eudaemonistic_adjectives,
headless_adjectives,
sporting_adjectives,
feudalistic_adjectives,
annihilationistical_adjectives,
cognizant_adjectives,
pensionary_adjectives,
sylvatic_adjectives,
Voltairean_adjectives,
organisational_adjectives,
unsurmised_adjectives,
unporcelainized_adjectives,
amphiarthrodial_adjectives,
welltreated_adjectives,
fissureless_adjectives,
nongalvanized_adjectives,
photoperiodic_adjectives,
antiskidding_adjectives,
photospectroscopical_adjectives,
unstretchable_adjectives,
biotypic_adjectives,
habitable_adjectives,
superinclusive_adjectives,
unparted_adjectives,
caudate_adjectives,
wellcontrived_adjectives,
unspecked_adjectives,
overmettled_adjectives,
unsoggy_adjectives,
unspewed_adjectives,
animalcular_adjectives,
eximious_adjectives,
promilitarist_adjectives,
immodest_adjectives,
singleacting_adjectives,
pyromagnetic_adjectives,
Livonian_adjectives,
telautographic_adjectives,
skewbald_adjectives,
epitaphic_adjectives,
unabsolved_adjectives,
halfimportant_adjectives,
aptitudinal_adjectives,
deceased_adjectives,
semiepic_adjectives,
fortyfifth_adjectives,
noncrucial_adjectives,
quasithorough_adjectives,
tressiest_adjectives,
brassbound_adjectives,
omnipresent_adjectives,
unbenevolent_adjectives,
impenetrable_adjectives,
Ertebolle_adjectives,
monic_adjectives,
unacclaimed_adjectives,
unawed_adjectives,
subpharyngeal_adjectives,
unambulant_adjectives,
chivalric_adjectives,
interpretational_adjectives,
floppiest_adjectives,
ichthyosaurian_adjectives,
tortious_adjectives,
semielliptical_adjectives,
nonrepentant_adjectives,
gushy_adjectives,
gemmuliferous_adjectives,
unregularised_adjectives,
preexclusive_adjectives,
catatonic_adjectives,
incongruent_adjectives,
unpretermitted_adjectives,
uncomplaisant_adjectives,
amphichroic_adjectives,
despisable_adjectives,
rebuttable_adjectives,
clairvoyant_adjectives,
unascended_adjectives,
feathery_adjectives,
gynaecoid_adjectives,
unmicaceous_adjectives,
nonCalvinistical_adjectives,
wasteless_adjectives,
nonpastoral_adjectives,
surefooted_adjectives,
insurgent_adjectives,
unsinning_adjectives,
openmouthed_adjectives,
unhistoric_adjectives,
nonperiodical_adjectives,
fortyish_adjectives,
selfcleaning_adjectives,
matronal_adjectives,
estrildine_adjectives,
flitting_adjectives,
wellcontented_adjectives,
denunciable_adjectives,
antarthritic_adjectives,
sepaled_adjectives,
dewlapped_adjectives,
bomba_adjectives,
precondylar_adjectives,
sartorial_adjectives,
halfmumbled_adjectives,
rachidian_adjectives,
unbeneficent_adjectives,
chevronny_adjectives,
antifrictional_adjectives,
Scotistic_adjectives,
anacoluthic_adjectives,
leechlike_adjectives,
communicable_adjectives,
nerveless_adjectives,
pseudoMongolian_adjectives,
defeasible_adjectives,
glostfired_adjectives,
subpericranial_adjectives,
chiliastic_adjectives,
proEmersonian_adjectives,
subnotochordal_adjectives,
arsenical_adjectives,
prefashioned_adjectives,
desinent_adjectives,
prepueblo_adjectives,
unanachronous_adjectives,
heterophil_adjectives,
trendy_adjectives,
unremittable_adjectives,
psychobiologic_adjectives,
moldy_adjectives,
harangueful_adjectives,
selftrained_adjectives,
tenantlike_adjectives,
suety_adjectives,
hyperhidrotic_adjectives,
holeandcorner_adjectives,
subdialectal_adjectives,
wellgraded_adjectives,
cryptonymous_adjectives,
alicyclic_adjectives,
commorant_adjectives,
loudish_adjectives,
unribbed_adjectives,
undefective_adjectives,
wellasserted_adjectives,
isocyano_adjectives,
gyrose_adjectives,
tergiversatory_adjectives,
unintended_adjectives,
subcultrate_adjectives,
apertured_adjectives,
auspicious_adjectives,
selfpointed_adjectives,
overboastful_adjectives,
nondistillable_adjectives,
diphthongal_adjectives,
proAlabaman_adjectives,
subdistinctive_adjectives,
Rubensian_adjectives,
uncivilisable_adjectives,
telling_adjectives,
quasicomplex_adjectives,
unpreventive_adjectives,
unliveable_adjectives,
dormient_adjectives,
fattenable_adjectives,
nonproportionable_adjectives,
iniquitous_adjectives,
unimplorable_adjectives,
Monophysitic_adjectives,
onstream_adjectives,
shadowless_adjectives,
Carnacian_adjectives,
uninterpolative_adjectives,
postSocratic_adjectives,
tiptop_adjectives,
unmotioning_adjectives,
fireresistant_adjectives,
prebuccal_adjectives,
antiimperialistic_adjectives,
doiled_adjectives,
mechanistic_adjectives,
unendurability_adjectives,
tragicomical_adjectives,
biauricular_adjectives,
waitressless_adjectives,
unfacaded_adjectives,
shroudless_adjectives,
insentient_adjectives,
perceptual_adjectives,
tuberculous_adjectives,
closelipped_adjectives,
unimmolated_adjectives,
goahead_adjectives,
unlumbering_adjectives,
unleased_adjectives,
crotched_adjectives,
nondomineering_adjectives,
subimpressed_adjectives,
unstaggering_adjectives,
brevirostrate_adjectives,
plethoric_adjectives,
intercosmic_adjectives,
chasmogamic_adjectives,
unwearisome_adjectives,
proArian_adjectives,
muckerish_adjectives,
quasialternative_adjectives,
scrawnier_adjectives,
nonelective_adjectives,
splinterless_adjectives,
elmy_adjectives,
unnormalizing_adjectives,
unarching_adjectives,
Fliptop_adjectives,
subtruncated_adjectives,
unexamining_adjectives,
subtegumentary_adjectives,
nonconsequent_adjectives,
spriggy_adjectives,
shadowed_adjectives,
unsentient_adjectives,
sigmate_adjectives,
semielliptic_adjectives,
nonspeculatory_adjectives,
mongolian_adjectives,
contactual_adjectives,
obcuneate_adjectives,
unmeddling_adjectives,
nonaccenting_adjectives,
Pegasian_adjectives,
underivable_adjectives,
contained_adjectives,
pseudocultural_adjectives,
cantharidean_adjectives,
sisterly_adjectives,
unshowy_adjectives,
happygolucky_adjectives,
nonapplicable_adjectives,
unadvertised_adjectives,
cornmeal_adjectives,
structureless_adjectives,
saxophonic_adjectives,
halffinished_adjectives,
nongranulated_adjectives,
unlaurelled_adjectives,
xenogenic_adjectives,
busied_adjectives,
proCeylon_adjectives,
prouniversity_adjectives,
stipitiform_adjectives,
unsanctionable_adjectives,
neuroplasmatic_adjectives,
groomish_adjectives,
discreditable_adjectives,
odontophorous_adjectives,
subvitalized_adjectives,
excrescent_adjectives,
semipractical_adjectives,
unrequisitioned_adjectives,
unsunken_adjectives,
sublanceolate_adjectives,
torchless_adjectives,
ostracizable_adjectives,
vectorial_adjectives,
unsuspicious_adjectives,
hardhanded_adjectives,
nephelinitic_adjectives,
afterdinner_adjectives,
unborrowed_adjectives,
hempy_adjectives,
unheady_adjectives,
stromatic_adjectives,
raving_adjectives,
auriform_adjectives,
unhallucinatory_adjectives,
unmodest_adjectives,
ruthenic_adjectives,
horrent_adjectives,
preAugustan_adjectives,
comelier_adjectives,
subendothelial_adjectives,
tressured_adjectives,
scarlatinoid_adjectives,
bathypelagic_adjectives,
unrefunding_adjectives,
heartrending_adjectives,
nonstratified_adjectives,
nondisciplining_adjectives,
aphakial_adjectives,
nonsolvable_adjectives,
weaponed_adjectives,
shivery_adjectives,
pseudomilitary_adjectives,
incognita_adjectives,
archetypic_adjectives,
nonformal_adjectives,
touristy_adjectives,
escapeless_adjectives,
preaseptic_adjectives,
uttermost_adjectives,
princelier_adjectives,
vaccinial_adjectives,
phrenoward_adjectives,
noncomic_adjectives,
stationary_adjectives,
Keatsian_adjectives,
parcelgilt_adjectives,
endocranial_adjectives,
unhosed_adjectives,
hormonic_adjectives,
tabarded_adjectives,
undecadent_adjectives,
quasitraditional_adjectives,
nonmobile_adjectives,
unacceding_adjectives,
cisela_adjectives,
preepochal_adjectives,
undragoned_adjectives,
wellwrought_adjectives,
grimiest_adjectives,
occasional_adjectives,
noncultivable_adjectives,
unpestered_adjectives,
nonmethodic_adjectives,
pericemental_adjectives,
unantagonizable_adjectives,
nonanaemic_adjectives,
pusillanimous_adjectives,
unimpairable_adjectives,
resupinate_adjectives,
trabeculate_adjectives,
cytochemical_adjectives,
unmopped_adjectives,
nondefining_adjectives,
unmotorised_adjectives,
lounging_adjectives,
hypolimnial_adjectives,
paroxytonic_adjectives,
kingliest_adjectives,
semidefensive_adjectives,
fullcut_adjectives,
untottering_adjectives,
untributary_adjectives,
ulnar_adjectives,
unapplauding_adjectives,
proSouth_adjectives,
undefendable_adjectives,
gastrocnemial_adjectives,
bellowslike_adjectives,
Pyrrhic_adjectives,
barbellate_adjectives,
spreathed_adjectives,
quasicalm_adjectives,
overmerciful_adjectives,
unlevigated_adjectives,
unfervent_adjectives,
metempsychosic_adjectives,
unadornable_adjectives,
octupled_adjectives,
unpoeticised_adjectives,
leftlaid_adjectives,
taenidial_adjectives,
subbronchial_adjectives,
parallelepipedous_adjectives,
sacramental_adjectives,
lexicologic_adjectives,
wellread_adjectives,
graphomotor_adjectives,
cutrate_adjectives,
semifictionalized_adjectives,
porous_adjectives,
overlong_adjectives,
local_adjectives,
unstrengthened_adjectives,
genomic_adjectives,
nonadapting_adjectives,
trichogynic_adjectives,
suspectless_adjectives,
clypeal_adjectives,
religiose_adjectives,
propretorian_adjectives,
multisacculate_adjectives,
polyparian_adjectives,
undifferentiated_adjectives,
scorpionic_adjectives,
gainable_adjectives,
unsignalised_adjectives,
preJustinian_adjectives,
discovert_adjectives,
furuncular_adjectives,
chirurgical_adjectives,
unfreckled_adjectives,
nonsimulate_adjectives,
primaeval_adjectives,
unecstatic_adjectives,
unstrange_adjectives,
jimcrow_adjectives,
importable_adjectives,
pruinose_adjectives,
nonresidual_adjectives,
boskiest_adjectives,
Pennsylvanian_adjectives,
auriculoventricular_adjectives,
reparable_adjectives,
deutoplasmic_adjectives,
ancient_adjectives,
unthroaty_adjectives,
porrect_adjectives,
ellipsoidal_adjectives,
interAmerican_adjectives,
undelaying_adjectives,
shrieky_adjectives,
unanatomized_adjectives,
backhanded_adjectives,
whackiest_adjectives,
flyblown_adjectives,
unworkmanly_adjectives,
domestic_adjectives,
paleontographic_adjectives,
subaqueous_adjectives,
blastodermatic_adjectives,
premaxillary_adjectives,
squally_adjectives,
semiconditioned_adjectives,
sodless_adjectives,
tricksiest_adjectives,
postdiphtherial_adjectives,
Pannonian_adjectives,
highclass_adjectives,
unbigoted_adjectives,
unmatriculated_adjectives,
nonvirginal_adjectives,
unbesprinkled_adjectives,
ovine_adjectives,
undisparaged_adjectives,
perishless_adjectives,
prepolice_adjectives,
impactive_adjectives,
flakeless_adjectives,
Ottomanlike_adjectives,
proresearch_adjectives,
sheathier_adjectives,
supermilitary_adjectives,
holomorphic_adjectives,
Peruginesque_adjectives,
Casanovanic_adjectives,
circumstantial_adjectives,
quasisuperficial_adjectives,
disintegratory_adjectives,
nonpermissible_adjectives,
noncorruptible_adjectives,
SpanishAmerican_adjectives,
farseeing_adjectives,
neurogliac_adjectives,
unhawked_adjectives,
twaddly_adjectives,
unmanful_adjectives,
wellinvented_adjectives,
tinfoil_adjectives,
nonclarified_adjectives,
isographic_adjectives,
nonphobic_adjectives,
pseudofaithful_adjectives,
wellbeaten_adjectives,
allelic_adjectives,
overreserved_adjectives,
subcontiguous_adjectives,
prechoroid_adjectives,
exsufflicate_adjectives,
gasiform_adjectives,
groggier_adjectives,
quasiathletic_adjectives,
nonobligated_adjectives,
unadvised_adjectives,
wellremembered_adjectives,
unquizzical_adjectives,
hypersentimental_adjectives,
unincriminating_adjectives,
everyday_adjectives,
gauntleted_adjectives,
embowed_adjectives,
microstomatous_adjectives,
selfworn_adjectives,
fidgety_adjectives,
halfflattered_adjectives,
peachiest_adjectives,
unsighing_adjectives,
unacclimatized_adjectives,
phlebotomical_adjectives,
unretardable_adjectives,
cerographic_adjectives,
susurrous_adjectives,
unaccused_adjectives,
serpentine_adjectives,
porcine_adjectives,
inadequate_adjectives,
lefthanded_adjectives,
unimpressive_adjectives,
earthborn_adjectives,
hyperanabolic_adjectives,
manganic_adjectives,
warty_adjectives,
capitalisable_adjectives,
cloggy_adjectives,
onlimits_adjectives,
unlittered_adjectives,
cablelaid_adjectives,
undestitute_adjectives,
postuterine_adjectives,
unorganic_adjectives,
yarer_adjectives,
wellaccustomed_adjectives,
centrolecithal_adjectives,
nonvitriolic_adjectives,
Gabar_adjectives,
oilfired_adjectives,
anthocarpous_adjectives,
Argonautic_adjectives,
bluffable_adjectives,
illustratable_adjectives,
wellbrewed_adjectives,
dermographic_adjectives,
unloafing_adjectives,
cindery_adjectives,
rebellike_adjectives,
unqueried_adjectives,
swart_adjectives,
nonefficient_adjectives,
nondefiant_adjectives,
assentient_adjectives,
unwrangling_adjectives,
tubate_adjectives,
quasiexpectant_adjectives,
electrotropic_adjectives,
unretrogressive_adjectives,
exhaustible_adjectives,
postneural_adjectives,
unthralled_adjectives,
slavelabor_adjectives,
thorniest_adjectives,
pseudopyriform_adjectives,
unfrightening_adjectives,
quasicongenial_adjectives,
antiFreud_adjectives,
lymphoblastic_adjectives,
nonpathologic_adjectives,
ornithoid_adjectives,
jutelike_adjectives,
choppy_adjectives,
premundane_adjectives,
deuteranomalous_adjectives,
unmastered_adjectives,
subcortical_adjectives,
noninternational_adjectives,
quadricipital_adjectives,
blastemal_adjectives,
nonpassible_adjectives,
terebinic_adjectives,
calefacient_adjectives,
bulimiac_adjectives,
MickeyMouse_adjectives,
welltinted_adjectives,
pentagonal_adjectives,
reclosable_adjectives,
radiometric_adjectives,
thickskinned_adjectives,
guttersnipish_adjectives,
caespitose_adjectives,
geocentric_adjectives,
unhaggling_adjectives,
noninducible_adjectives,
nonrepressible_adjectives,
nonaspirated_adjectives,
digitipinnate_adjectives,
assiduous_adjectives,
parotid_adjectives,
wellhatched_adjectives,
balmier_adjectives,
spoutlike_adjectives,
prerenal_adjectives,
juvenescent_adjectives,
unmatted_adjectives,
quasiroyal_adjectives,
noninferential_adjectives,
accentless_adjectives,
uncircumscribed_adjectives,
dure_adjectives,
eupotamic_adjectives,
salpingian_adjectives,
tactile_adjectives,
scalariform_adjectives,
semipendent_adjectives,
nematocystic_adjectives,
unbodied_adjectives,
reparative_adjectives,
leucocythaemic_adjectives,
unprudential_adjectives,
megalithic_adjectives,
progambling_adjectives,
unpropounded_adjectives,
wellfarmed_adjectives,
vacciniaceous_adjectives,
Aragonese_adjectives,
unbaked_adjectives,
fiducial_adjectives,
collective_adjectives,
unpilloried_adjectives,
draggy_adjectives,
glottidean_adjectives,
undefrayed_adjectives,
unprompt_adjectives,
ecesic_adjectives,
subintroductive_adjectives,
unexperienced_adjectives,
nonrecalcitrant_adjectives,
vertical_adjectives,
unnervous_adjectives,
spirituel_adjectives,
unterrific_adjectives,
laterigrade_adjectives,
squashier_adjectives,
uncommenced_adjectives,
wellclad_adjectives,
postJurassic_adjectives,
selfmaintained_adjectives,
hoidenish_adjectives,
unassiduous_adjectives,
willcall_adjectives,
palmitic_adjectives,
nonejaculatory_adjectives,
nonextractable_adjectives,
medallic_adjectives,
polyploid_adjectives,
unsupplanted_adjectives,
surmisable_adjectives,
mackinawed_adjectives,
hungerly_adjectives,
antipolar_adjectives,
selfundoing_adjectives,
unjocund_adjectives,
nonflowering_adjectives,
nonconcluding_adjectives,
antiRoman_adjectives,
chymic_adjectives,
unoccasional_adjectives,
proanarchy_adjectives,
ophthalmoscopical_adjectives,
pettish_adjectives,
preponderant_adjectives,
halfSemitic_adjectives,
silvicultural_adjectives,
crinklier_adjectives,
somnambulant_adjectives,
superindustrious_adjectives,
nonvascular_adjectives,
blithering_adjectives,
antalkaline_adjectives,
interfacial_adjectives,
grallatorial_adjectives,
cavitied_adjectives,
respectful_adjectives,
Aegean_adjectives,
ethnologic_adjectives,
gullwing_adjectives,
glace_adjectives,
overstiff_adjectives,
unsteeped_adjectives,
permutable_adjectives,
unchafed_adjectives,
superwise_adjectives,
fiftyeighth_adjectives,
lubricatory_adjectives,
preparatory_adjectives,
overslight_adjectives,
breezelike_adjectives,
foveolar_adjectives,
unmitigated_adjectives,
sunniest_adjectives,
glassier_adjectives,
nonreturnable_adjectives,
semimedicinal_adjectives,
cleptobiotic_adjectives,
hematopoietic_adjectives,
nondimensioned_adjectives,
hydrogenous_adjectives,
whopping_adjectives,
unhollowed_adjectives,
phyletic_adjectives,
heimish_adjectives,
alarmable_adjectives,
unflitched_adjectives,
inventionless_adjectives,
uncelestial_adjectives,
heartaching_adjectives,
preSyrian_adjectives,
wellintentioned_adjectives,
pestiferous_adjectives,
quasiconsiderate_adjectives,
knightless_adjectives,
benthonic_adjectives,
anabatic_adjectives,
cordilleran_adjectives,
aesthetical_adjectives,
tracheoscopic_adjectives,
unwishful_adjectives,
nonalkaloidal_adjectives,
prostomiate_adjectives,
antherless_adjectives,
redfigure_adjectives,
untaxied_adjectives,
involucral_adjectives,
agrostographic_adjectives,
outdated_adjectives,
turbaned_adjectives,
syzygial_adjectives,
lacerated_adjectives,
nondormant_adjectives,
Chaucerian_adjectives,
unthreaded_adjectives,
unmasking_adjectives,
agrostographical_adjectives,
nonassimilable_adjectives,
drearies_adjectives,
curdiest_adjectives,
ferny_adjectives,
ionizable_adjectives,
chuckfull_adjectives,
irrefragable_adjectives,
nonoptimistic_adjectives,
overpartial_adjectives,
nonastronomical_adjectives,
furthermost_adjectives,
dink_adjectives,
anticentralization_adjectives,
fishable_adjectives,
unstoneable_adjectives,
unpledged_adjectives,
unrecusant_adjectives,
prefeudal_adjectives,
bacchantic_adjectives,
deeplaid_adjectives,
preachier_adjectives,
winglike_adjectives,
closewinded_adjectives,
remillable_adjectives,
gynaecocratic_adjectives,
dawnlike_adjectives,
methodical_adjectives,
saporous_adjectives,
unalphabetical_adjectives,
Chattertonian_adjectives,
transAustralian_adjectives,
subrictal_adjectives,
wadable_adjectives,
radiotoxic_adjectives,
expendable_adjectives,
unseeded_adjectives,
Polish_adjectives,
jowlier_adjectives,
antihuman_adjectives,
intraspinal_adjectives,
bibliographical_adjectives,
ardeid_adjectives,
unkidnaped_adjectives,
overstrung_adjectives,
unnimble_adjectives,
unaware_adjectives,
chinchier_adjectives,
unsettleable_adjectives,
xenodiagnostic_adjectives,
monogamistic_adjectives,
nonscientific_adjectives,
Circean_adjectives,
illsorted_adjectives,
whiniest_adjectives,
phlegmatized_adjectives,
hamular_adjectives,
distressed_adjectives,
Indienne_adjectives,
metempsychosical_adjectives,
anatomizable_adjectives,
hypersuggestible_adjectives,
knotty_adjectives,
enharmonic_adjectives,
chemoreceptive_adjectives,
nonrepetitive_adjectives,
streaklike_adjectives,
beholdable_adjectives,
nonsuspended_adjectives,
unthrifty_adjectives,
dragonlike_adjectives,
nonamenable_adjectives,
deltoidal_adjectives,
wellcleansed_adjectives,
wellfabricated_adjectives,
peridotic_adjectives,
behenic_adjectives,
cirsoid_adjectives,
nonwestern_adjectives,
unmaterialistic_adjectives,
primitive_adjectives,
olivary_adjectives,
proindustrial_adjectives,
spriggiest_adjectives,
untapered_adjectives,
cibarian_adjectives,
harborous_adjectives,
interdisciplinary_adjectives,
sedimentologic_adjectives,
hippiest_adjectives,
chemosmotic_adjectives,
symbolic_adjectives,
shaglike_adjectives,
Carinthian_adjectives,
exuberant_adjectives,
hypnoanalytic_adjectives,
extractable_adjectives,
unevasive_adjectives,
megathermic_adjectives,
voluble_adjectives,
NeoScholastic_adjectives,
pseudoVergilian_adjectives,
Averrhoistic_adjectives,
ditheistic_adjectives,
flybynight_adjectives,
lithological_adjectives,
cultic_adjectives,
preabundant_adjectives,
unincarcerated_adjectives,
ultra_adjectives,
nonconsumptive_adjectives,
postMiocene_adjectives,
pretribal_adjectives,
newrich_adjectives,
nonderivable_adjectives,
unradiant_adjectives,
untested_adjectives,
untransfigured_adjectives,
reptilelike_adjectives,
nonportrayable_adjectives,
teeniest_adjectives,
depopulative_adjectives,
immitigable_adjectives,
ineluctable_adjectives,
postnephritic_adjectives,
unideational_adjectives,
ameboid_adjectives,
selfsequestered_adjectives,
multilaciniate_adjectives,
rockbottom_adjectives,
nonprescribed_adjectives,
hemiopic_adjectives,
unrisible_adjectives,
unheardof_adjectives,
unparked_adjectives,
antifoaming_adjectives,
unfarcical_adjectives,
laconical_adjectives,
prenatal_adjectives,
precedentless_adjectives,
barrable_adjectives,
kosher_adjectives,
uninterrupted_adjectives,
uneloping_adjectives,
successless_adjectives,
ungraved_adjectives,
unrelieved_adjectives,
papistical_adjectives,
lithic_adjectives,
uncharmed_adjectives,
informable_adjectives,
welllighted_adjectives,
goodtime_adjectives,
indologenous_adjectives,
amblyopic_adjectives,
unflavourous_adjectives,
pseudorhombohedral_adjectives,
synecological_adjectives,
hypertorrid_adjectives,
anisodont_adjectives,
umbral_adjectives,
hiplike_adjectives,
postDiocletian_adjectives,
dangerless_adjectives,
quasiinvisible_adjectives,
wellgreeted_adjectives,
preumbonal_adjectives,
gumptious_adjectives,
unreconsidered_adjectives,
rarefactional_adjectives,
confabulatory_adjectives,
perioecid_adjectives,
subaxillary_adjectives,
perlucidus_adjectives,
Asianic_adjectives,
ungarnished_adjectives,
superfeminine_adjectives,
fairhaired_adjectives,
acroterial_adjectives,
wellanchored_adjectives,
Virginian_adjectives,
easeful_adjectives,
transAmerican_adjectives,
anfractuous_adjectives,
inferable_adjectives,
vibrational_adjectives,
intercerebral_adjectives,
micronucleate_adjectives,
subpeltated_adjectives,
teratoid_adjectives,
ragtimey_adjectives,
subtribal_adjectives,
unebullient_adjectives,
affiliable_adjectives,
unsectarian_adjectives,
plantable_adjectives,
deciduate_adjectives,
nondiligent_adjectives,
intervascular_adjectives,
graptolitic_adjectives,
dogseared_adjectives,
bracteolate_adjectives,
trimolecular_adjectives,
cottony_adjectives,
unenvironed_adjectives,
postnuptial_adjectives,
undivergent_adjectives,
Cappadocian_adjectives,
interventionist_adjectives,
selfstarved_adjectives,
hasty_adjectives,
unharboured_adjectives,
unindustrious_adjectives,
abiotrophic_adjectives,
untopping_adjectives,
unburstable_adjectives,
wellconcocted_adjectives,
halfarmed_adjectives,
pinaceous_adjectives,
anatomical_adjectives,
treacherous_adjectives,
uninert_adjectives,
unalcoholized_adjectives,
ribless_adjectives,
unpopularised_adjectives,
investable_adjectives,
tugless_adjectives,
photoelectric_adjectives,
agglutinant_adjectives,
seatless_adjectives,
nondiplomatic_adjectives,
unblistered_adjectives,
pronationalist_adjectives,
corynebacterial_adjectives,
backfilleted_adjectives,
unshapable_adjectives,
halfdeserved_adjectives,
fissipalmate_adjectives,
unpilfered_adjectives,
unfeasted_adjectives,
circuitous_adjectives,
examinable_adjectives,
unmoderating_adjectives,
shrill_adjectives,
petit_adjectives,
pulsatile_adjectives,
grottolike_adjectives,
Aymaran_adjectives,
trimorphic_adjectives,
comminatory_adjectives,
unprevailing_adjectives,
armorplated_adjectives,
ideaful_adjectives,
overinsolent_adjectives,
heterotrichous_adjectives,
seafaring_adjectives,
nonpenal_adjectives,
specific_adjectives,
gradely_adjectives,
quasiconverted_adjectives,
intoxicated_adjectives,
unconciliable_adjectives,
equitable_adjectives,
proevolutionist_adjectives,
unavoiding_adjectives,
saprogenic_adjectives,
roughdry_adjectives,
snide_adjectives,
wellcommanded_adjectives,
primeministerial_adjectives,
halfHessian_adjectives,
fourth_adjectives,
cryptovolcanic_adjectives,
insomnious_adjectives,
sphenoid_adjectives,
unresinous_adjectives,
detectible_adjectives,
aw_adjectives,
undualistic_adjectives,
iffy_adjectives,
resigned_adjectives,
wavelike_adjectives,
superstrenuous_adjectives,
wheezy_adjectives,
nondynamical_adjectives,
nonpalatal_adjectives,
featureless_adjectives,
visional_adjectives,
officious_adjectives,
rhombohedral_adjectives,
choleraic_adjectives,
Karaitic_adjectives,
worse_adjectives,
paidin_adjectives,
houndstooth_adjectives,
untitular_adjectives,
enneasyllabic_adjectives,
crystalloid_adjectives,
superorganic_adjectives,
stainless_adjectives,
grammatical_adjectives,
silklike_adjectives,
monovalent_adjectives,
kickable_adjectives,
unbranching_adjectives,
fiftyfifth_adjectives,
tensional_adjectives,
crescentoid_adjectives,
unjeopardized_adjectives,
unrazed_adjectives,
firstborn_adjectives,
crabby_adjectives,
Paduan_adjectives,
consolable_adjectives,
battological_adjectives,
unvaccinated_adjectives,
subconvolute_adjectives,
rugged_adjectives,
enabling_adjectives,
wellaffected_adjectives,
hypostyle_adjectives,
preSilurian_adjectives,
guardable_adjectives,
biting_adjectives,
unaddible_adjectives,
bordandpillar_adjectives,
hypocritical_adjectives,
undethroned_adjectives,
uninfracted_adjectives,
wieldier_adjectives,
undefaming_adjectives,
postulnar_adjectives,
morphonemic_adjectives,
antilottery_adjectives,
nondiscriminating_adjectives,
lukewarm_adjectives,
unserviceable_adjectives,
untwirled_adjectives,
aphoristic_adjectives,
nonuniversal_adjectives,
unraving_adjectives,
jannock_adjectives,
unexpiring_adjectives,
selfpowered_adjectives,
extirpative_adjectives,
republican_adjectives,
gemmological_adjectives,
halfItalian_adjectives,
precisive_adjectives,
fibroid_adjectives,
unhackled_adjectives,
misleading_adjectives,
noncereal_adjectives,
acuminate_adjectives,
excitant_adjectives,
chirpy_adjectives,
presentperfect_adjectives,
nonrefractive_adjectives,
intermastoid_adjectives,
energetic_adjectives,
crinal_adjectives,
eriophyllous_adjectives,
unupset_adjectives,
faint_adjectives,
gypsylike_adjectives,
supersignificant_adjectives,
synoicous_adjectives,
nee_adjectives,
unoperatable_adjectives,
languid_adjectives,
crossfertilizable_adjectives,
myologic_adjectives,
halfjoking_adjectives,
compatible_adjectives,
reachable_adjectives,
instinctive_adjectives,
interAndean_adjectives,
unwhining_adjectives,
wellscattered_adjectives,
androgynous_adjectives,
opaline_adjectives,
eradicative_adjectives,
unsmothering_adjectives,
armored_adjectives,
superchivalrous_adjectives,
nonsubstantival_adjectives,
stoical_adjectives,
pseudoparasitic_adjectives,
nonaffiliated_adjectives,
pseudolaminated_adjectives,
hypogastric_adjectives,
unexposed_adjectives,
otiose_adjectives,
drying_adjectives,
unsurpliced_adjectives,
Ninevitish_adjectives,
nonmanual_adjectives,
noneducational_adjectives,
hotter_adjectives,
theurgical_adjectives,
odontographic_adjectives,
uncanny_adjectives,
runtish_adjectives,
mistyped_adjectives,
synodic_adjectives,
cashedup_adjectives,
untenebrous_adjectives,
chasubled_adjectives,
tungstenic_adjectives,
paragogical_adjectives,
doubleminded_adjectives,
unfuturistic_adjectives,
spotted_adjectives,
bewhiskered_adjectives,
microbial_adjectives,
vizorless_adjectives,
fireeating_adjectives,
platinocyanic_adjectives,
chalybeate_adjectives,
unblasted_adjectives,
unentwined_adjectives,
unmuscular_adjectives,
unrebukable_adjectives,
shellless_adjectives,
quasiprovocative_adjectives,
actinographic_adjectives,
bridgelike_adjectives,
ungrazed_adjectives,
slavocratic_adjectives,
unparliamented_adjectives,
Bosporan_adjectives,
endarterial_adjectives,
nonTurkish_adjectives,
subhexagonal_adjectives,
unexpiated_adjectives,
agile_adjectives,
nonlicensable_adjectives,
overcerebral_adjectives,
transpulmonary_adjectives,
heliotypic_adjectives,
unprognosticated_adjectives,
nuciform_adjectives,
fireless_adjectives,
nonsyllogistical_adjectives,
unbroadcast_adjectives,
unextravagant_adjectives,
climant_adjectives,
nonbulbiferous_adjectives,
uncomportable_adjectives,
Memphite_adjectives,
bridlewise_adjectives,
effectible_adjectives,
unprofound_adjectives,
palaeobiological_adjectives,
diploic_adjectives,
methylidyne_adjectives,
lecithoid_adjectives,
apophyseal_adjectives,
preboding_adjectives,
prediplomatic_adjectives,
submetallic_adjectives,
nondesigned_adjectives,
gablelike_adjectives,
hemoglobic_adjectives,
charterless_adjectives,
honest_adjectives,
epexegetic_adjectives,
wellcarved_adjectives,
foraminal_adjectives,
nonvisual_adjectives,
transAndean_adjectives,
horseandbuggy_adjectives,
flyaway_adjectives,
Alleghanian_adjectives,
unclosable_adjectives,
epencephalic_adjectives,
interplacental_adjectives,
unprepared_adjectives,
transMississippian_adjectives,
stonier_adjectives,
stylistic_adjectives,
stenchful_adjectives,
magisterial_adjectives,
unnatural_adjectives,
haustellate_adjectives,
synaptical_adjectives,
sacrilegious_adjectives,
astrolabical_adjectives,
unmasticated_adjectives,
unharming_adjectives,
unstultifying_adjectives,
pseudoscientific_adjectives,
undocketed_adjectives,
Yoruban_adjectives,
superexplicit_adjectives,
compoundwound_adjectives,
causative_adjectives,
neocolonial_adjectives,
huffish_adjectives,
hypermoral_adjectives,
nonegocentric_adjectives,
unenlightening_adjectives,
grooveless_adjectives,
noncodified_adjectives,
unfictitious_adjectives,
ablepharous_adjectives,
unhusked_adjectives,
vinegarlike_adjectives,
septivalent_adjectives,
apian_adjectives,
promonopolistic_adjectives,
postmesenteric_adjectives,
labial_adjectives,
nonearning_adjectives,
apparent_adjectives,
proFrench_adjectives,
unadulterous_adjectives,
unpaving_adjectives,
nonlugubrious_adjectives,
hundredfold_adjectives,
eudaemonistical_adjectives,
subcreative_adjectives,
twofisted_adjectives,
sheer_adjectives,
limitable_adjectives,
subserrate_adjectives,
imminent_adjectives,
unnefarious_adjectives,
unaccumulable_adjectives,
galactoid_adjectives,
unmailed_adjectives,
nonreprehensible_adjectives,
unincreased_adjectives,
ruinable_adjectives,
unregistered_adjectives,
paracusic_adjectives,
guidebookish_adjectives,
matrilineal_adjectives,
uncoaxial_adjectives,
unacoustic_adjectives,
viewiest_adjectives,
luckier_adjectives,
unblended_adjectives,
excrementitious_adjectives,
seducible_adjectives,
nonfugitive_adjectives,
filamentary_adjectives,
unrepudiative_adjectives,
vaticinal_adjectives,
halfbound_adjectives,
pisiform_adjectives,
templed_adjectives,
measurable_adjectives,
Louisianian_adjectives,
Aesculapian_adjectives,
unlying_adjectives,
nongratuitous_adjectives,
anticipant_adjectives,
parasynthetic_adjectives,
osteoid_adjectives,
pliable_adjectives,
jiglike_adjectives,
nonslip_adjectives,
compoundable_adjectives,
uninaugurated_adjectives,
simian_adjectives,
weatherbeaten_adjectives,
nonparallel_adjectives,
preachiest_adjectives,
ungrilled_adjectives,
madding_adjectives,
overspeculative_adjectives,
unpriced_adjectives,
interim_adjectives,
frizzier_adjectives,
aphaeretic_adjectives,
wellrehearsed_adjectives,
verificative_adjectives,
marketwise_adjectives,
unsplendourous_adjectives,
premillennial_adjectives,
overidolatrous_adjectives,
hazier_adjectives,
unsieved_adjectives,
civetlike_adjectives,
leprose_adjectives,
idiomatic_adjectives,
balloonlike_adjectives,
unpornographic_adjectives,
postthalamic_adjectives,
rehearsable_adjectives,
articulable_adjectives,
hygrophytic_adjectives,
unnymphal_adjectives,
embryonic_adjectives,
noncarbolic_adjectives,
annulate_adjectives,
instructorless_adjectives,
decided_adjectives,
degraded_adjectives,
unbedabbled_adjectives,
previctorious_adjectives,
interteam_adjectives,
sarcolemmous_adjectives,
shipless_adjectives,
lived_adjectives,
overbookish_adjectives,
preseminary_adjectives,
bitchiest_adjectives,
untilling_adjectives,
intermundane_adjectives,
halfprotested_adjectives,
unpresentable_adjectives,
barbate_adjectives,
wrier_adjectives,
edgegrained_adjectives,
actionless_adjectives,
medicinable_adjectives,
preSumerian_adjectives,
fiftyfifty_adjectives,
uninvoiced_adjectives,
sudorific_adjectives,
bosomy_adjectives,
lamprophyric_adjectives,
secondary_adjectives,
seminervous_adjectives,
riotous_adjectives,
retarded_adjectives,
noncivilizable_adjectives,
maddest_adjectives,
nonSanskritic_adjectives,
abortional_adjectives,
wellstyled_adjectives,
gonopodial_adjectives,
unconvulsed_adjectives,
ammono_adjectives,
hyperadipose_adjectives,
unexecutable_adjectives,
blamable_adjectives,
buccolingual_adjectives,
congestus_adjectives,
annectent_adjectives,
lexicological_adjectives,
undetached_adjectives,
agonic_adjectives,
excellent_adjectives,
peristaltic_adjectives,
breezy_adjectives,
goldleaf_adjectives,
unsere_adjectives,
unparched_adjectives,
marshier_adjectives,
pseudoCanadian_adjectives,
uncaptained_adjectives,
impetrative_adjectives,
addible_adjectives,
clawless_adjectives,
quasiprecedent_adjectives,
stealable_adjectives,
drys_adjectives,
halfforgotten_adjectives,
revocable_adjectives,
evacuant_adjectives,
halfdiscriminating_adjectives,
contradictious_adjectives,
recompensable_adjectives,
vapourific_adjectives,
galvanometric_adjectives,
classified_adjectives,
carunculous_adjectives,
unprospered_adjectives,
loonier_adjectives,
intercessory_adjectives,
ungrinned_adjectives,
selfexploiting_adjectives,
predietary_adjectives,
reddish_adjectives,
evens_adjectives,
superfluous_adjectives,
anticapitalistic_adjectives,
traitorous_adjectives,
nonproscriptive_adjectives,
nondenunciating_adjectives,
nontraceable_adjectives,
pseudoidentical_adjectives,
wordless_adjectives,
authorial_adjectives,
uncinctured_adjectives,
micrometric_adjectives,
bacteriostatic_adjectives,
exsertile_adjectives,
unfiltrated_adjectives,
nigh_adjectives,
brainlike_adjectives,
unstriving_adjectives,
psittacistic_adjectives,
moneyed_adjectives,
costlier_adjectives,
unintensified_adjectives,
unnibbled_adjectives,
antienergistic_adjectives,
nonreplicated_adjectives,
quasilegislative_adjectives,
pottiest_adjectives,
nonreductive_adjectives,
raptureless_adjectives,
nonconversational_adjectives,
unatrophied_adjectives,
detainable_adjectives,
conducible_adjectives,
intransigent_adjectives,
usurious_adjectives,
groved_adjectives,
uninfringed_adjectives,
coequal_adjectives,
untagged_adjectives,
overcompliant_adjectives,
compromissary_adjectives,
unpanelled_adjectives,
unreiterative_adjectives,
subconcessionary_adjectives,
nonpneumatic_adjectives,
pterylographic_adjectives,
unwakened_adjectives,
unacidic_adjectives,
migrainoid_adjectives,
unmowed_adjectives,
vitriolic_adjectives,
unlocalizable_adjectives,
flowerless_adjectives,
mansized_adjectives,
Papuan_adjectives,
karyotypic_adjectives,
unrepetitious_adjectives,
shaggier_adjectives,
paleopsychic_adjectives,
anaerobiotic_adjectives,
aphidious_adjectives,
unhieratical_adjectives,
ferniest_adjectives,
untrenched_adjectives,
macerative_adjectives,
superaccurate_adjectives,
monotrichous_adjectives,
unwormeaten_adjectives,
quasimad_adjectives,
unacknowledging_adjectives,
postAugustan_adjectives,
unstratified_adjectives,
superabominable_adjectives,
antisupernatural_adjectives,
sextan_adjectives,
swingwing_adjectives,
otological_adjectives,
unsacked_adjectives,
fortheperson_adjectives,
unmedicinal_adjectives,
late_adjectives,
undealt_adjectives,
unstudied_adjectives,
illative_adjectives,
dipyramidal_adjectives,
anthracitic_adjectives,
immemorial_adjectives,
nonpleading_adjectives,
unrevokable_adjectives,
nonobsessional_adjectives,
unupsettable_adjectives,
soluble_adjectives,
uncommuted_adjectives,
aufait_adjectives,
unsinged_adjectives,
illiberal_adjectives,
brigandish_adjectives,
tensed_adjectives,
lumpen_adjectives,
mealless_adjectives,
noninformative_adjectives,
nonmutative_adjectives,
algetic_adjectives,
uncheaply_adjectives,
Peruvian_adjectives,
unpredicable_adjectives,
reverend_adjectives,
holier_adjectives,
invected_adjectives,
cutglass_adjectives,
gustoish_adjectives,
unfair_adjectives,
cinnamoyl_adjectives,
nonrepellent_adjectives,
unbedaubed_adjectives,
Bernese_adjectives,
uncontinuous_adjectives,
dashier_adjectives,
unticketed_adjectives,
supravaginal_adjectives,
nonBrahminic_adjectives,
fiercer_adjectives,
freerange_adjectives,
frowzier_adjectives,
crateral_adjectives,
noncomprehensible_adjectives,
nightly_adjectives,
semitailored_adjectives,
mustier_adjectives,
autopolyploid_adjectives,
heraldic_adjectives,
Gravettian_adjectives,
horny_adjectives,
syngamic_adjectives,
cornaceous_adjectives,
noncontemptible_adjectives,
unchanted_adjectives,
pseudodramatic_adjectives,
unelectable_adjectives,
unreminded_adjectives,
subolive_adjectives,
nontautomerizable_adjectives,
stockcar_adjectives,
tinkly_adjectives,
submanic_adjectives,
noneducatory_adjectives,
transpalmar_adjectives,
parsonish_adjectives,
nondistinctive_adjectives,
nonsyntactic_adjectives,
microparasitic_adjectives,
unallayable_adjectives,
postcubital_adjectives,
untricked_adjectives,
anadromous_adjectives,
unrioting_adjectives,
undipped_adjectives,
unresistive_adjectives,
leaden_adjectives,
resistive_adjectives,
tumular_adjectives,
quinquepartite_adjectives,
quasideaf_adjectives,
unirritable_adjectives,
mattery_adjectives,
unoffered_adjectives,
unexported_adjectives,
eurytopic_adjectives,
pseudomonastic_adjectives,
proautomation_adjectives,
outeyed_adjectives,
exploitive_adjectives,
vicarly_adjectives,
necessitative_adjectives,
foolhardier_adjectives,
rless_adjectives,
Barcan_adjectives,
nonvariable_adjectives,
nonperceivable_adjectives,
mannerly_adjectives,
unrecuperated_adjectives,
dire_adjectives,
antiaphrodisiac_adjectives,
unthrilled_adjectives,
nondeciduous_adjectives,
unrent_adjectives,
precontemporaneous_adjectives,
unlawful_adjectives,
nontutorial_adjectives,
uncontributed_adjectives,
nongerminative_adjectives,
nonmoveable_adjectives,
undebatable_adjectives,
nonconsecutive_adjectives,
nonforming_adjectives,
selfneglect_adjectives,
untransmissive_adjectives,
proBolshevik_adjectives,
duodecimal_adjectives,
slummiest_adjectives,
antireligion_adjectives,
unrented_adjectives,
pixilated_adjectives,
noncorrespondent_adjectives,
hyperacute_adjectives,
cymoid_adjectives,
adrenocorticotropic_adjectives,
potenty_adjectives,
hyaline_adjectives,
plesiosauroid_adjectives,
justiciary_adjectives,
chummiest_adjectives,
unclean_adjectives,
undissolved_adjectives,
unpollened_adjectives,
nerval_adjectives,
anticritical_adjectives,
ancra_adjectives,
suburethral_adjectives,
unlaudatory_adjectives,
quinonoid_adjectives,
scurrile_adjectives,
unforetellable_adjectives,
shoeless_adjectives,
uninjectable_adjectives,
ungelded_adjectives,
unclassified_adjectives,
retral_adjectives,
Sicanian_adjectives,
cellular_adjectives,
Augean_adjectives,
unfinanced_adjectives,
nonsyntonical_adjectives,
consecratory_adjectives,
magnetographic_adjectives,
uncoagulated_adjectives,
brannew_adjectives,
nonblocking_adjectives,
unnosed_adjectives,
exequial_adjectives,
quasiunified_adjectives,
nondelicate_adjectives,
histiocytic_adjectives,
unsymptomatical_adjectives,
stealthier_adjectives,
barruly_adjectives,
unemitted_adjectives,
synecdochic_adjectives,
unrespired_adjectives,
preflood_adjectives,
unhashed_adjectives,
adynamic_adjectives,
pizzicato_adjectives,
unassuageable_adjectives,
halfrotten_adjectives,
evidential_adjectives,
unassignable_adjectives,
gentlemanlike_adjectives,
preservable_adjectives,
quasiLatin_adjectives,
nonincorporated_adjectives,
nonabstaining_adjectives,
unJesuitical_adjectives,
pericarditic_adjectives,
queanish_adjectives,
weathertight_adjectives,
roughvoiced_adjectives,
pneumatological_adjectives,
slatiest_adjectives,
unexpunged_adjectives,
unumpired_adjectives,
paradelike_adjectives,
forgiving_adjectives,
tactless_adjectives,
wellaired_adjectives,
iconic_adjectives,
unevaded_adjectives,
affecting_adjectives,
nonvenomous_adjectives,
okeydoke_adjectives,
patrimonial_adjectives,
unsown_adjectives,
overmellow_adjectives,
wellblacked_adjectives,
snippy_adjectives,
exoteric_adjectives,
renversa_adjectives,
proFrance_adjectives,
halftrue_adjectives,
unsharing_adjectives,
hexahemeric_adjectives,
nonacceptant_adjectives,
fiendliest_adjectives,
wellinsured_adjectives,
hypernutritive_adjectives,
scrawly_adjectives,
prognosticable_adjectives,
nonadmissive_adjectives,
synergistic_adjectives,
unretrenched_adjectives,
rhinologic_adjectives,
nonreflective_adjectives,
pennoned_adjectives,
perissodactylous_adjectives,
quasiGrecian_adjectives,
untimbered_adjectives,
openairish_adjectives,
unslackened_adjectives,
squabbier_adjectives,
dubitable_adjectives,
epitheliomuscular_adjectives,
posttubercular_adjectives,
quasirenewed_adjectives,
stepdown_adjectives,
uncompassionate_adjectives,
transitive_adjectives,
dysphoric_adjectives,
resistible_adjectives,
hyperpietic_adjectives,
nomographical_adjectives,
unauthorized_adjectives,
periostitic_adjectives,
unreplaceable_adjectives,
snootiest_adjectives,
salvageable_adjectives,
Israelitish_adjectives,
unrived_adjectives,
native_adjectives,
synergetic_adjectives,
ophthalmometric_adjectives,
unattired_adjectives,
innerdirected_adjectives,
selfhardened_adjectives,
Kashmiri_adjectives,
lophodont_adjectives,
cloisterlike_adjectives,
violaceous_adjectives,
anserine_adjectives,
dank_adjectives,
nonenforcing_adjectives,
pentup_adjectives,
impolitic_adjectives,
untraditional_adjectives,
undatable_adjectives,
ahorse_adjectives,
nonparadoxical_adjectives,
wellconcorded_adjectives,
antiidealistic_adjectives,
sacrificial_adjectives,
unbrowsing_adjectives,
punctual_adjectives,
nonrheumatic_adjectives,
halfsensed_adjectives,
unhateful_adjectives,
polymorphistic_adjectives,
carboxylic_adjectives,
chinless_adjectives,
plankless_adjectives,
transmontane_adjectives,
veryhighfrequency_adjectives,
undistressed_adjectives,
nonrepresentational_adjectives,
nonAlexandrian_adjectives,
sublaryngeal_adjectives,
carsick_adjectives,
nondeprecative_adjectives,
unappointable_adjectives,
unsupported_adjectives,
caliginous_adjectives,
fossillike_adjectives,
convictional_adjectives,
unsecretarial_adjectives,
Balkan_adjectives,
terraqueous_adjectives,
concyclic_adjectives,
heliastic_adjectives,
erectable_adjectives,
proud_adjectives,
onetime_adjectives,
unaccoutered_adjectives,
postphrenic_adjectives,
mellifluous_adjectives,
fulgurant_adjectives,
unregressive_adjectives,
unseeing_adjectives,
interreligious_adjectives,
conflagrative_adjectives,
coadunate_adjectives,
chondromatous_adjectives,
unsobering_adjectives,
cuddlesome_adjectives,
kookiest_adjectives,
baronial_adjectives,
presanguine_adjectives,
precharted_adjectives,
workingclass_adjectives,
unemaciated_adjectives,
stelliform_adjectives,
unamortized_adjectives,
plausible_adjectives,
bifoliate_adjectives,
husklike_adjectives,
colourless_adjectives,
karmic_adjectives,
combless_adjectives,
unsloped_adjectives,
mesometeorological_adjectives,
selfemptying_adjectives,
aplitic_adjectives,
hallucinative_adjectives,
noneradicable_adjectives,
sufferable_adjectives,
selfdisserving_adjectives,
unalimentary_adjectives,
halfMuslim_adjectives,
peristomal_adjectives,
subjective_adjectives,
openandshut_adjectives,
nonimitating_adjectives,
interstreet_adjectives,
secernent_adjectives,
screwpropelled_adjectives,
erumpent_adjectives,
noncruciform_adjectives,
selfsoothed_adjectives,
florid_adjectives,
unskilled_adjectives,
internalcombustion_adjectives,
unscattered_adjectives,
billowy_adjectives,
unrefutable_adjectives,
noncultural_adjectives,
precartilaginous_adjectives,
noncelestial_adjectives,
quadrangled_adjectives,
extortive_adjectives,
peppy_adjectives,
electrotechnical_adjectives,
selfafflicting_adjectives,
pinkish_adjectives,
subacid_adjectives,
nonpublic_adjectives,
unriveted_adjectives,
Haligonian_adjectives,
pupilless_adjectives,
cibarial_adjectives,
apical_adjectives,
original_adjectives,
unsatirical_adjectives,
gentlemanly_adjectives,
rodded_adjectives,
adorable_adjectives,
allogamous_adjectives,
unassisting_adjectives,
multifistulous_adjectives,
unfemale_adjectives,
underbeaten_adjectives,
nonfictitious_adjectives,
nonerratic_adjectives,
nonclose_adjectives,
submaxillary_adjectives,
semielevated_adjectives,
sublaryngal_adjectives,
hypercivilized_adjectives,
darkish_adjectives,
nonemotive_adjectives,
peglike_adjectives,
dainty_adjectives,
grizzly_adjectives,
stickable_adjectives,
unchapped_adjectives,
outermost_adjectives,
basifixed_adjectives,
shortwinded_adjectives,
calorimetric_adjectives,
hypanthial_adjectives,
ultrared_adjectives,
unsweltering_adjectives,
opinionative_adjectives,
armourpiercing_adjectives,
particular_adjectives,
coleopterous_adjectives,
excretive_adjectives,
OKd_adjectives,
transArabian_adjectives,
renegotiable_adjectives,
explanate_adjectives,
armipotent_adjectives,
spherulate_adjectives,
selfrecollective_adjectives,
alliaceous_adjectives,
gangliar_adjectives,
sprayful_adjectives,
pneumatophorous_adjectives,
spoony_adjectives,
postmedieval_adjectives,
charlatanistic_adjectives,
transAustrian_adjectives,
libationary_adjectives,
unpursued_adjectives,
apodictic_adjectives,
unacquiescent_adjectives,
lianoid_adjectives,
hyperspeculative_adjectives,
prescout_adjectives,
unessential_adjectives,
unstarched_adjectives,
heterochromous_adjectives,
tabulable_adjectives,
lordliest_adjectives,
unapproached_adjectives,
calcinatory_adjectives,
semicolloidal_adjectives,
undeprecative_adjectives,
unimplanted_adjectives,
unforeseeing_adjectives,
unattributive_adjectives,
unpacific_adjectives,
narcoleptic_adjectives,
persevering_adjectives,
sibyllic_adjectives,
toylike_adjectives,
shoddy_adjectives,
doublebreasted_adjectives,
overambitioned_adjectives,
unfervid_adjectives,
preseminal_adjectives,
tarsal_adjectives,
stratospheric_adjectives,
sugarcane_adjectives,
histaminic_adjectives,
superpure_adjectives,
wellirrigated_adjectives,
transNiger_adjectives,
leaky_adjectives,
triable_adjectives,
untorn_adjectives,
quasiexceptional_adjectives,
quinquefoliate_adjectives,
icicled_adjectives,
ungraphable_adjectives,
triploid_adjectives,
nonalternating_adjectives,
multifibrous_adjectives,
selfdisparaging_adjectives,
strenuous_adjectives,
nonstainable_adjectives,
selfdiscrepant_adjectives,
unstarting_adjectives,
chemurgical_adjectives,
unworshipped_adjectives,
unpedantic_adjectives,
farmable_adjectives,
tegular_adjectives,
judgemental_adjectives,
rhonchial_adjectives,
hyaloid_adjectives,
matterless_adjectives,
untransferable_adjectives,
sclerotomic_adjectives,
ungrasped_adjectives,
thermotactic_adjectives,
diametral_adjectives,
predependent_adjectives,
stroboscopic_adjectives,
wellallied_adjectives,
unexplicit_adjectives,
unmunicipalized_adjectives,
auricled_adjectives,
chondrosarcomatous_adjectives,
winy_adjectives,
qualityless_adjectives,
southeastward_adjectives,
ringstreaked_adjectives,
Handelian_adjectives,
antiphrastic_adjectives,
unchevroned_adjectives,
quarterwitted_adjectives,
unfriendly_adjectives,
halfexposed_adjectives,
lipotropic_adjectives,
ungeodetic_adjectives,
unpublic_adjectives,
swaybacked_adjectives,
quasiextraterritorial_adjectives,
ooziest_adjectives,
contumacious_adjectives,
preSemitic_adjectives,
noctilucan_adjectives,
lawlike_adjectives,
unwinnable_adjectives,
tertiary_adjectives,
nobbier_adjectives,
geosynclinal_adjectives,
keratosic_adjectives,
untrigonometrical_adjectives,
lubberly_adjectives,
preallied_adjectives,
Ruskinian_adjectives,
subcrystalline_adjectives,
palpitant_adjectives,
unnarrowminded_adjectives,
strutting_adjectives,
arboricultural_adjectives,
psychopathological_adjectives,
lichenous_adjectives,
pustulant_adjectives,
fleshiest_adjectives,
nonduplicating_adjectives,
concavoconvex_adjectives,
Ceylonese_adjectives,
daintiest_adjectives,
nonexaggerative_adjectives,
semialuminous_adjectives,
unrocked_adjectives,
nonIndian_adjectives,
nonalienating_adjectives,
unclamped_adjectives,
midway_adjectives,
lepidopterological_adjectives,
halfsunk_adjectives,
unsecure_adjectives,
monohydroxy_adjectives,
pendanted_adjectives,
grandmotherly_adjectives,
overassertive_adjectives,
antipoetic_adjectives,
nonnatty_adjectives,
superevangelical_adjectives,
nonadjudicated_adjectives,
punier_adjectives,
sequestered_adjectives,
chimneyless_adjectives,
nonparticipating_adjectives,
sphenographic_adjectives,
fracturable_adjectives,
astute_adjectives,
upcountry_adjectives,
pseudogenerical_adjectives,
substructional_adjectives,
palpebral_adjectives,
vigintillionth_adjectives,
paleoecologic_adjectives,
unipersonal_adjectives,
ceorlish_adjectives,
slack_adjectives,
unhallucinated_adjectives,
noncataclysmic_adjectives,
ennuya_adjectives,
amortisable_adjectives,
underlaid_adjectives,
lated_adjectives,
maritime_adjectives,
nonpyogenic_adjectives,
breakfastless_adjectives,
homocentric_adjectives,
chopping_adjectives,
unvested_adjectives,
reanalyzable_adjectives,
inferoanterior_adjectives,
freesoil_adjectives,
unenriching_adjectives,
unslimmed_adjectives,
unexpanding_adjectives,
compressed_adjectives,
ontogenetic_adjectives,
unaccessible_adjectives,
unperceivable_adjectives,
accusatorial_adjectives,
nonnutritious_adjectives,
aerobiotic_adjectives,
unartistic_adjectives,
nonappellate_adjectives,
unantagonizing_adjectives,
unquellable_adjectives,
uncomely_adjectives,
crunchier_adjectives,
nonremovable_adjectives,
undisinherited_adjectives,
parturifacient_adjectives,
semidecayed_adjectives,
xyloid_adjectives,
unsubrogated_adjectives,
motionless_adjectives,
squireless_adjectives,
exertive_adjectives,
pseudoSemitic_adjectives,
neurotrophic_adjectives,
superfervent_adjectives,
goutish_adjectives,
middleaged_adjectives,
unserried_adjectives,
nonVenetian_adjectives,
nondegenerative_adjectives,
dropleaf_adjectives,
nonlixiviated_adjectives,
approximal_adjectives,
superdiabolical_adjectives,
unmasterful_adjectives,
unsacred_adjectives,
unstacked_adjectives,
reservable_adjectives,
ringed_adjectives,
ahistoric_adjectives,
sinistrogyric_adjectives,
godless_adjectives,
unfurrowed_adjectives,
reductional_adjectives,
globoid_adjectives,
vociferant_adjectives,
undivertible_adjectives,
lenitic_adjectives,
proUnitarian_adjectives,
synaesthetic_adjectives,
tabu_adjectives,
unconducing_adjectives,
burthensome_adjectives,
preNorse_adjectives,
semireactionary_adjectives,
unparliamentary_adjectives,
selfstabilizing_adjectives,
nonreconcilable_adjectives,
overable_adjectives,
pencillike_adjectives,
misrhymed_adjectives,
unbrandied_adjectives,
untriturated_adjectives,
loutish_adjectives,
singletrack_adjectives,
socialistic_adjectives,
pronunciative_adjectives,
cronk_adjectives,
natatory_adjectives,
herbless_adjectives,
unromanticised_adjectives,
winterier_adjectives,
nonLatin_adjectives,
succubous_adjectives,
sweatless_adjectives,
nonideational_adjectives,
identic_adjectives,
unhasty_adjectives,
unmedical_adjectives,
nonMalay_adjectives,
quasiexpedient_adjectives,
benmost_adjectives,
singlehanded_adjectives,
quasifederal_adjectives,
multisulcate_adjectives,
rockered_adjectives,
spannew_adjectives,
unlarded_adjectives,
tasteless_adjectives,
unfunctioning_adjectives,
wellfinished_adjectives,
unreaped_adjectives,
wellattached_adjectives,
nonindividualistic_adjectives,
limiting_adjectives,
lattermost_adjectives,
welltraveled_adjectives,
naggy_adjectives,
masterly_adjectives,
perspicuous_adjectives,
unburly_adjectives,
metallic_adjectives,
Americanistic_adjectives,
unsymbolical_adjectives,
undergraduette_adjectives,
bronchitic_adjectives,
dormie_adjectives,
noncongenital_adjectives,
unethereal_adjectives,
classical_adjectives,
curial_adjectives,
disorderly_adjectives,
incontrovertible_adjectives,
uratic_adjectives,
noncultured_adjectives,
boonless_adjectives,
patchless_adjectives,
proabstinence_adjectives,
slowwitted_adjectives,
unmodificative_adjectives,
earthbound_adjectives,
disintegrable_adjectives,
airier_adjectives,
beady_adjectives,
semimonarchic_adjectives,
proacting_adjectives,
intervalvular_adjectives,
cotyledonal_adjectives,
stereognostic_adjectives,
forenamed_adjectives,
wearier_adjectives,
fluty_adjectives,
autotelic_adjectives,
premonumental_adjectives,
pokiest_adjectives,
supersubtilized_adjectives,
opportune_adjectives,
Hogarthian_adjectives,
sympodial_adjectives,
phonematic_adjectives,
sympathetic_adjectives,
redissoluble_adjectives,
nonmarriageable_adjectives,
hemizygous_adjectives,
quasiextreme_adjectives,
unpractical_adjectives,
halfdeaf_adjectives,
electrodiagnostic_adjectives,
unleisurely_adjectives,
unsnagged_adjectives,
supersquamosal_adjectives,
nonrecurent_adjectives,
unfined_adjectives,
mellow_adjectives,
diploid_adjectives,
preeminent_adjectives,
uncharmable_adjectives,
aerodynamic_adjectives,
compassionate_adjectives,
unmelted_adjectives,
phrenogrady_adjectives,
ahungered_adjectives,
imperialistic_adjectives,
unmetrified_adjectives,
unattaining_adjectives,
Confederate_adjectives,
unbeholden_adjectives,
prospectless_adjectives,
unsputtering_adjectives,
selfsubordained_adjectives,
pluckier_adjectives,
stretchier_adjectives,
Tibetan_adjectives,
wellcorked_adjectives,
venatic_adjectives,
pseudoancestral_adjectives,
equanimous_adjectives,
vociferous_adjectives,
unconsulting_adjectives,
brunet_adjectives,
caped_adjectives,
unreproaching_adjectives,
semiintellectual_adjectives,
commenceable_adjectives,
euphonious_adjectives,
unhelping_adjectives,
gorilline_adjectives,
nonallegoric_adjectives,
pseudoItalian_adjectives,
lowdown_adjectives,
postpubescent_adjectives,
uncongealable_adjectives,
nonelectrized_adjectives,
luetic_adjectives,
suppositive_adjectives,
oneideaed_adjectives,
mydriatic_adjectives,
condensable_adjectives,
asteriated_adjectives,
omissive_adjectives,
confessionalian_adjectives,
unkindhearted_adjectives,
hotfoot_adjectives,
uncomplemented_adjectives,
pneumographic_adjectives,
icebound_adjectives,
overflat_adjectives,
misprincipled_adjectives,
aciculate_adjectives,
unpecked_adjectives,
untransfixed_adjectives,
unlogistic_adjectives,
ninefold_adjectives,
uncorroded_adjectives,
pseudoDutch_adjectives,
connected_adjectives,
specificgravity_adjectives,
aimful_adjectives,
overassumptive_adjectives,
siliceous_adjectives,
caseless_adjectives,
unrejoicing_adjectives,
unincisive_adjectives,
nice_adjectives,
flamb_adjectives,
subarytenoid_adjectives,
diocesan_adjectives,
aerobiologic_adjectives,
sedimentological_adjectives,
nonaccredited_adjectives,
unrelative_adjectives,
dextrosinistral_adjectives,
handsoff_adjectives,
incubative_adjectives,
unsplittable_adjectives,
halfAmericanized_adjectives,
Genevan_adjectives,
selfinjurious_adjectives,
semiexternal_adjectives,
subestuarine_adjectives,
unpenetrable_adjectives,
spleeny_adjectives,
holehigh_adjectives,
queenly_adjectives,
lothsome_adjectives,
beadiest_adjectives,
respirable_adjectives,
autolytic_adjectives,
quilleted_adjectives,
weatherly_adjectives,
aggravative_adjectives,
mutilative_adjectives,
bibliotic_adjectives,
nonaccordant_adjectives,
heaviest_adjectives,
acuate_adjectives,
skillful_adjectives,
unendemic_adjectives,
preaexistent_adjectives,
nosogeographic_adjectives,
rollable_adjectives,
Voltairian_adjectives,
halfminded_adjectives,
antimonyyellow_adjectives,
unscorned_adjectives,
bibliolatrous_adjectives,
nonirritable_adjectives,
convulsionary_adjectives,
nonBrahmanic_adjectives,
heathery_adjectives,
semipunitory_adjectives,
triadelphous_adjectives,
unscintillant_adjectives,
ontogenetical_adjectives,
plumy_adjectives,
asthmatoid_adjectives,
expatriate_adjectives,
crapulous_adjectives,
pseudocritical_adjectives,
vomerine_adjectives,
unartificial_adjectives,
underweight_adjectives,
homozygous_adjectives,
andante_adjectives,
insertional_adjectives,
newmodel_adjectives,
multiviewing_adjectives,
unmenacing_adjectives,
diadelphous_adjectives,
unwearied_adjectives,
aerobic_adjectives,
superceremonious_adjectives,
numberless_adjectives,
telford_adjectives,
rhotacistic_adjectives,
filate_adjectives,
frangible_adjectives,
pseudomedical_adjectives,
undefensive_adjectives,
nonscandalous_adjectives,
overthick_adjectives,
nonevanescent_adjectives,
runtgenoscopic_adjectives,
paleogeologic_adjectives,
unascertained_adjectives,
crummier_adjectives,
unpropelled_adjectives,
manlike_adjectives,
binucleate_adjectives,
unannealed_adjectives,
unflowing_adjectives,
semiformal_adjectives,
sequestral_adjectives,
untalkative_adjectives,
pudgy_adjectives,
membranophonic_adjectives,
undeputed_adjectives,
antinaturalistic_adjectives,
breathable_adjectives,
nonresistible_adjectives,
sicker_adjectives,
duplicatus_adjectives,
uncastrated_adjectives,
breakable_adjectives,
semiallegorical_adjectives,
selfwriting_adjectives,
unchalky_adjectives,
meliorative_adjectives,
interresponsible_adjectives,
overwilling_adjectives,
electrophonic_adjectives,
wideangle_adjectives,
driedup_adjectives,
inessive_adjectives,
untuberculous_adjectives,
planoblastic_adjectives,
unstatic_adjectives,
unluckier_adjectives,
Mantuan_adjectives,
eely_adjectives,
mouthier_adjectives,
negational_adjectives,
unpresiding_adjectives,
mullocky_adjectives,
coronagraphic_adjectives,
homogamous_adjectives,
transCongo_adjectives,
oscitant_adjectives,
wellappearing_adjectives,
nonextraditable_adjectives,
antimethodic_adjectives,
unmartyred_adjectives,
trypanosomal_adjectives,
alimentative_adjectives,
brainless_adjectives,
reconstructional_adjectives,
Panic_adjectives,
styleless_adjectives,
lexical_adjectives,
preChristmas_adjectives,
assistive_adjectives,
purpuric_adjectives,
flawless_adjectives,
Tehuelchean_adjectives,
simplicidentate_adjectives,
matterindeed_adjectives,
shearless_adjectives,
overhasty_adjectives,
microchemical_adjectives,
monopetalous_adjectives,
pucka_adjectives,
agrypnotic_adjectives,
unfluid_adjectives,
homeotypic_adjectives,
euthermic_adjectives,
subauriculate_adjectives,
villagey_adjectives,
unrabbeted_adjectives,
halfagreed_adjectives,
variational_adjectives,
furibund_adjectives,
indescribable_adjectives,
undamaging_adjectives,
paranasal_adjectives,
unhoisted_adjectives,
Levalloisian_adjectives,
isomerous_adjectives,
hypercorrect_adjectives,
unobservable_adjectives,
miotic_adjectives,
trapdoor_adjectives,
intimidatory_adjectives,
spiffy_adjectives,
chapleted_adjectives,
valleculate_adjectives,
unscandalized_adjectives,
manneristic_adjectives,
unmercantile_adjectives,
tripodal_adjectives,
hollowbacked_adjectives,
downless_adjectives,
spiral_adjectives,
epibolic_adjectives,
ridgier_adjectives,
bearish_adjectives,
baseless_adjectives,
adipopexic_adjectives,
lemony_adjectives,
selfconstituted_adjectives,
talebearing_adjectives,
apheretic_adjectives,
subartesian_adjectives,
liguloid_adjectives,
unathletic_adjectives,
monotonal_adjectives,
emmetropic_adjectives,
roundfaced_adjectives,
nitid_adjectives,
undiscernable_adjectives,
thunderstruck_adjectives,
quasifiscal_adjectives,
flightiest_adjectives,
lubric_adjectives,
unlowered_adjectives,
guestless_adjectives,
enterpriseless_adjectives,
untraversed_adjectives,
unwellintentioned_adjectives,
ichthyoid_adjectives,
proAlsatian_adjectives,
predacious_adjectives,
Cainitic_adjectives,
subpeduncled_adjectives,
flavorous_adjectives,
monomorphic_adjectives,
barefoot_adjectives,
savoriest_adjectives,
unfasciated_adjectives,
ambulant_adjectives,
karstic_adjectives,
unfructuous_adjectives,
uncontestable_adjectives,
nonruinable_adjectives,
lone_adjectives,
pseudoascetical_adjectives,
batholitic_adjectives,
sugarcandy_adjectives,
wellconstricted_adjectives,
unconciliative_adjectives,
polarographic_adjectives,
uxorious_adjectives,
untissued_adjectives,
dyostyle_adjectives,
nondeflective_adjectives,
odourful_adjectives,
forethoughtful_adjectives,
sustentational_adjectives,
hazardable_adjectives,
wellattributed_adjectives,
propagative_adjectives,
ambiguous_adjectives,
nondamageable_adjectives,
unwinsome_adjectives,
forceripe_adjectives,
downy_adjectives,
epsilondelta_adjectives,
pseudolateral_adjectives,
branniest_adjectives,
calfless_adjectives,
dutiable_adjectives,
unsilent_adjectives,
antiSweden_adjectives,
unswaggering_adjectives,
simoniacal_adjectives,
softcentred_adjectives,
quasinegligible_adjectives,
platinic_adjectives,
anginal_adjectives,
lofty_adjectives,
jetpropulsion_adjectives,
composable_adjectives,
sublunate_adjectives,
tailheavy_adjectives,
phenotypic_adjectives,
prorestoration_adjectives,
pseudoanachronistic_adjectives,
unerodent_adjectives,
juicy_adjectives,
journalish_adjectives,
paleethnologic_adjectives,
muscicolous_adjectives,
Chamian_adjectives,
genealogical_adjectives,
boarish_adjectives,
gentled_adjectives,
terministic_adjectives,
pretenceless_adjectives,
unbounded_adjectives,
bolographic_adjectives,
preCopernican_adjectives,
venturesome_adjectives,
groundtoground_adjectives,
prophylactic_adjectives,
wellapproved_adjectives,
grudging_adjectives,
Neogene_adjectives,
Eolic_adjectives,
sulfitic_adjectives,
unbetrayed_adjectives,
unlegislated_adjectives,
exedral_adjectives,
Stygian_adjectives,
glycaemic_adjectives,
ideologic_adjectives,
appraisable_adjectives,
nondepraved_adjectives,
nonhedonistic_adjectives,
permeable_adjectives,
microclimatic_adjectives,
malvasian_adjectives,
unempirical_adjectives,
cresyl_adjectives,
freesilver_adjectives,
protistic_adjectives,
superattractive_adjectives,
hetero_adjectives,
noncancerous_adjectives,
nonsegregable_adjectives,
gorsy_adjectives,
seriate_adjectives,
uncaviling_adjectives,
unbereaved_adjectives,
antirealistic_adjectives,
retrooperative_adjectives,
selftroubled_adjectives,
inhuman_adjectives,
astonied_adjectives,
nonrevokable_adjectives,
noncomplacent_adjectives,
nifty_adjectives,
antiphonal_adjectives,
postDevonian_adjectives,
Aesopian_adjectives,
untraversable_adjectives,
gametogenic_adjectives,
untremolant_adjectives,
hostly_adjectives,
soundless_adjectives,
geminiflorous_adjectives,
unjogged_adjectives,
rhotic_adjectives,
proequality_adjectives,
nonebullient_adjectives,
frenzied_adjectives,
unkindling_adjectives,
spinescent_adjectives,
infertile_adjectives,
unclassifiable_adjectives,
nonembellished_adjectives,
preCeltic_adjectives,
lethargic_adjectives,
wiglike_adjectives,
early_adjectives,
lathiest_adjectives,
helminthoid_adjectives,
fleshier_adjectives,
hemispheric_adjectives,
unpluralised_adjectives,
unpolishable_adjectives,
unwhelped_adjectives,
sidelong_adjectives,
visible_adjectives,
anhydrotic_adjectives,
selfapplauding_adjectives,
sapindaceous_adjectives,
unicameral_adjectives,
pearly_adjectives,
crabbier_adjectives,
stirruplike_adjectives,
fierier_adjectives,
unwebbing_adjectives,
Pandean_adjectives,
nonprovided_adjectives,
promoderationist_adjectives,
unnotable_adjectives,
pennywise_adjectives,
octan_adjectives,
episepalous_adjectives,
arsenous_adjectives,
ingoing_adjectives,
untufted_adjectives,
preceptive_adjectives,
roentgenological_adjectives,
wailful_adjectives,
risible_adjectives,
radiotelegraphic_adjectives,
unappeased_adjectives,
unvoluble_adjectives,
emptied_adjectives,
nonentomological_adjectives,
reduplicative_adjectives,
nonvisiting_adjectives,
petrographic_adjectives,
uninitialed_adjectives,
spermacetilike_adjectives,
unhuntable_adjectives,
brownish_adjectives,
unrelaxing_adjectives,
quasirewarding_adjectives,
unlaid_adjectives,
coachbuilt_adjectives,
psychotomimetic_adjectives,
xeromorphic_adjectives,
gyrational_adjectives,
rogatory_adjectives,
nonformidable_adjectives,
unmanual_adjectives,
thirteenth_adjectives,
antimonous_adjectives,
subacute_adjectives,
ethnographical_adjectives,
nonphilologic_adjectives,
insurmountable_adjectives,
originative_adjectives,
pseudoMuslim_adjectives,
tachyphylactic_adjectives,
unperfected_adjectives,
nonlimitative_adjectives,
umbilicate_adjectives,
luminous_adjectives,
nontyrannic_adjectives,
ringent_adjectives,
psychoneurotic_adjectives,
intense_adjectives,
undewed_adjectives,
proterogynous_adjectives,
wellcoloured_adjectives,
pickled_adjectives,
hittable_adjectives,
viceless_adjectives,
prePauline_adjectives,
undared_adjectives,
diffusive_adjectives,
antipestilence_adjectives,
undemonstrational_adjectives,
supercarpal_adjectives,
conbrio_adjectives,
screwable_adjectives,
extrafloral_adjectives,
unvinous_adjectives,
superignorant_adjectives,
Frenchy_adjectives,
unfaceted_adjectives,
noncertified_adjectives,
shortorder_adjectives,
quasiantique_adjectives,
coolheaded_adjectives,
unbeaded_adjectives,
spleenish_adjectives,
rechargeable_adjectives,
inviting_adjectives,
plantar_adjectives,
unsoarable_adjectives,
edgiest_adjectives,
prototypic_adjectives,
metronymic_adjectives,
Trinidadian_adjectives,
unmisinterpretable_adjectives,
wellpeopled_adjectives,
Recent_adjectives,
unhumanistic_adjectives,
handtohand_adjectives,
acerb_adjectives,
uncombed_adjectives,
infarcted_adjectives,
unhypnotic_adjectives,
prefatory_adjectives,
unblamed_adjectives,
wellforested_adjectives,
sporadic_adjectives,
hypaethral_adjectives,
slipover_adjectives,
tetrandrous_adjectives,
phlegmless_adjectives,
interverbal_adjectives,
clerical_adjectives,
horizontal_adjectives,
incapable_adjectives,
ungassed_adjectives,
transJovian_adjectives,
psychotic_adjectives,
palaeontological_adjectives,
stanzaed_adjectives,
uncouth_adjectives,
halfeaten_adjectives,
unprecipitated_adjectives,
puggish_adjectives,
unrefitted_adjectives,
discussional_adjectives,
subappressed_adjectives,
neat_adjectives,
nonlevel_adjectives,
intermissive_adjectives,
ingenious_adjectives,
Algoman_adjectives,
stintless_adjectives,
clubby_adjectives,
cauterant_adjectives,
anaphrodisiac_adjectives,
undepleted_adjectives,
unrefractive_adjectives,
auriculate_adjectives,
subglottic_adjectives,
tartrated_adjectives,
MalayoIndonesian_adjectives,
nonexplosive_adjectives,
whitecollar_adjectives,
inchoate_adjectives,
unimplied_adjectives,
selfaddressed_adjectives,
nonequestrian_adjectives,
liturgiological_adjectives,
diplex_adjectives,
proparoxytone_adjectives,
unopted_adjectives,
riparian_adjectives,
injunctive_adjectives,
censual_adjectives,
thermoluminescent_adjectives,
degradative_adjectives,
endogamous_adjectives,
myriad_adjectives,
effectless_adjectives,
polyfoil_adjectives,
subhepatic_adjectives,
unneutral_adjectives,
unmoribund_adjectives,
biradial_adjectives,
bedrid_adjectives,
halfconfessed_adjectives,
unexaggerative_adjectives,
photoheliographic_adjectives,
gluey_adjectives,
fourway_adjectives,
triple_adjectives,
incumbent_adjectives,
discriminational_adjectives,
ethmoid_adjectives,
uninductive_adjectives,
conoscopic_adjectives,
nonIslamic_adjectives,
nondocumental_adjectives,
strawhat_adjectives,
undisjoined_adjectives,
unattractive_adjectives,
thermoduric_adjectives,
nonTuscan_adjectives,
soniferous_adjectives,
ambidextrous_adjectives,
platitudinous_adjectives,
tinglazed_adjectives,
doublehung_adjectives,
inhibitable_adjectives,
subspheric_adjectives,
capitate_adjectives,
unarticulative_adjectives,
unabbreviated_adjectives,
subocean_adjectives,
ductless_adjectives,
loathful_adjectives,
unwistful_adjectives,
antierosion_adjectives,
unnucleated_adjectives,
nonagglomerative_adjectives,
crisic_adjectives,
ickiest_adjectives,
unpercussive_adjectives,
parisonic_adjectives,
smooth_adjectives,
anisic_adjectives,
unskeptical_adjectives,
decagonal_adjectives,
microelectronic_adjectives,
geoidal_adjectives,
unweighted_adjectives,
posticous_adjectives,
vaguest_adjectives,
deferrable_adjectives,
bifocal_adjectives,
cathodic_adjectives,
nonassumptive_adjectives,
plaguy_adjectives,
damning_adjectives,
heathered_adjectives,
unplunged_adjectives,
uninclosed_adjectives,
sabulous_adjectives,
unacuminous_adjectives,
justiceless_adjectives,
overglad_adjectives,
unimporting_adjectives,
reflexional_adjectives,
hunchbacked_adjectives,
unplagiarized_adjectives,
undetailed_adjectives,
wellphotographed_adjectives,
interfilamentous_adjectives,
refillable_adjectives,
phenetic_adjectives,
welltaxed_adjectives,
nongenerical_adjectives,
infectious_adjectives,
nonaddicting_adjectives,
supersulphureted_adjectives,
imperishable_adjectives,
nonintoxicant_adjectives,
postsphenoid_adjectives,
unabducted_adjectives,
perforative_adjectives,
imposable_adjectives,
supramolecular_adjectives,
monogenetic_adjectives,
anabolic_adjectives,
unrated_adjectives,
nonstaining_adjectives,
antiItalian_adjectives,
telolecithal_adjectives,
nonspottable_adjectives,
unattachable_adjectives,
halfoval_adjectives,
molal_adjectives,
flamy_adjectives,
diagrammatic_adjectives,
logy_adjectives,
consecutive_adjectives,
antisymmetric_adjectives,
unfired_adjectives,
coffered_adjectives,
doited_adjectives,
nonfloriferous_adjectives,
crossbanded_adjectives,
predetrimental_adjectives,
semirhythmic_adjectives,
cushionlike_adjectives,
illconditioned_adjectives,
ungiven_adjectives,
unprolific_adjectives,
unbillable_adjectives,
bountyless_adjectives,
asclepiadaceous_adjectives,
nightmarish_adjectives,
gutterlike_adjectives,
pretyphoid_adjectives,
intercalative_adjectives,
nonexhaustible_adjectives,
umbonal_adjectives,
educated_adjectives,
wellbraced_adjectives,
quasitypical_adjectives,
undiscernible_adjectives,
overfunctioning_adjectives,
inquirable_adjectives,
vitascopic_adjectives,
single_adjectives,
unrecuperative_adjectives,
jeopardous_adjectives,
turbosupercharged_adjectives,
antiJesuitical_adjectives,
autobiographical_adjectives,
nonglutenous_adjectives,
semihysterical_adjectives,
pentahydroxy_adjectives,
casuistic_adjectives,
wrynecked_adjectives,
spectrochemical_adjectives,
eyefilling_adjectives,
rotiferous_adjectives,
cleansable_adjectives,
Spinozistic_adjectives,
hurricanedecked_adjectives,
overtolerant_adjectives,
unroused_adjectives,
uninquisitorial_adjectives,
subpubescent_adjectives,
preEnglish_adjectives,
thionic_adjectives,
coterminous_adjectives,
unchanneled_adjectives,
sallowish_adjectives,
proAustrian_adjectives,
nonextinct_adjectives,
noisiest_adjectives,
military_adjectives,
phialine_adjectives,
nonremediable_adjectives,
nonretentive_adjectives,
ridiculous_adjectives,
anaclinal_adjectives,
mispackaged_adjectives,
cladanthous_adjectives,
unapologetic_adjectives,
subchoroidal_adjectives,
unfanciful_adjectives,
murmurous_adjectives,
shapelier_adjectives,
Liberian_adjectives,
revivalistic_adjectives,
machinable_adjectives,
deviative_adjectives,
spermatozoan_adjectives,
halfreasonable_adjectives,
nonrequisite_adjectives,
probeable_adjectives,
unrepudiated_adjectives,
unbroached_adjectives,
monotheistical_adjectives,
innovatory_adjectives,
antiSerb_adjectives,
Italianate_adjectives,
valvar_adjectives,
inflammatory_adjectives,
revolting_adjectives,
copasetic_adjectives,
unevidenced_adjectives,
denominative_adjectives,
selfpleased_adjectives,
diriment_adjectives,
noncommunicating_adjectives,
wellgoverned_adjectives,
pseudoGreek_adjectives,
unvomited_adjectives,
quasifoolish_adjectives,
undershot_adjectives,
unbeguiling_adjectives,
boastful_adjectives,
overmagnetic_adjectives,
crossply_adjectives,
overdetailed_adjectives,
closeknit_adjectives,
preaortic_adjectives,
subsaline_adjectives,
conglutinant_adjectives,
Western_adjectives,
Hecatean_adjectives,
unsensory_adjectives,
evolutional_adjectives,
polyonymous_adjectives,
hypophosphoric_adjectives,
umbonate_adjectives,
precommercial_adjectives,
Almerian_adjectives,
candid_adjectives,
lawful_adjectives,
subfastigiated_adjectives,
biomorphic_adjectives,
selfconditioned_adjectives,
glumelike_adjectives,
metazoal_adjectives,
wellrested_adjectives,
newsprung_adjectives,
troglodytical_adjectives,
sceptral_adjectives,
proOriental_adjectives,
resurrective_adjectives,
inversive_adjectives,
Hymettic_adjectives,
Pergamene_adjectives,
haunted_adjectives,
unprolonged_adjectives,
uncravatted_adjectives,
lustreless_adjectives,
transfusible_adjectives,
unstringent_adjectives,
thankful_adjectives,
pseudoapoplectic_adjectives,
buckshee_adjectives,
hyperstatic_adjectives,
heavyfooted_adjectives,
colorado_adjectives,
wintriest_adjectives,
horselike_adjectives,
crinite_adjectives,
wellrecognized_adjectives,
interEuropean_adjectives,
sanguivorous_adjectives,
undiverging_adjectives,
unangular_adjectives,
bullate_adjectives,
unpenciled_adjectives,
redemptory_adjectives,
germinative_adjectives,
phenotypical_adjectives,
gruffish_adjectives,
farfamed_adjectives,
suctional_adjectives,
hypostomial_adjectives,
matrilateral_adjectives,
onehanded_adjectives,
lexicographic_adjectives,
physicochemical_adjectives,
scalawaggy_adjectives,
intergyral_adjectives,
unshaped_adjectives,
saltigrade_adjectives,
selfexaggerated_adjectives,
schizophyceous_adjectives,
unbarbarous_adjectives,
sexangular_adjectives,
noncathartical_adjectives,
hyperenthusiastic_adjectives,
noncorresponding_adjectives,
vicarious_adjectives,
unconsummate_adjectives,
epiclike_adjectives,
castled_adjectives,
AngloFrench_adjectives,
lupous_adjectives,
induplicate_adjectives,
symposiac_adjectives,
amalgamable_adjectives,
antisubmarine_adjectives,
rousing_adjectives,
exhibitory_adjectives,
carnal_adjectives,
contaminable_adjectives,
freeonboard_adjectives,
losing_adjectives,
semitheological_adjectives,
hyperdulic_adjectives,
nonrepetitious_adjectives,
unrehearsable_adjectives,
possible_adjectives,
prenegligent_adjectives,
kneadable_adjectives,
sexlimited_adjectives,
sidewhiskered_adjectives,
limber_adjectives,
supplemental_adjectives,
parabolic_adjectives,
unlanded_adjectives,
tough_adjectives,
overloyal_adjectives,
nondoubtable_adjectives,
ceroplastic_adjectives,
welltold_adjectives,
nongilled_adjectives,
intertergal_adjectives,
choking_adjectives,
beholden_adjectives,
coaliest_adjectives,
undetained_adjectives,
postlabial_adjectives,
proctologic_adjectives,
fivegaited_adjectives,
dresscoated_adjectives,
zeroth_adjectives,
housebound_adjectives,
autoerotic_adjectives,
comparative_adjectives,
unbeset_adjectives,
stirrable_adjectives,
undisclaimed_adjectives,
unedible_adjectives,
agnate_adjectives,
astral_adjectives,
crowded_adjectives,
unanswering_adjectives,
supercivil_adjectives,
wellwired_adjectives,
revolute_adjectives,
unlibidinous_adjectives,
unconciliating_adjectives,
halfnylon_adjectives,
formulable_adjectives,
autoecious_adjectives,
quasiprophetic_adjectives,
nonterminable_adjectives,
simulative_adjectives,
unoppressive_adjectives,
nonregressive_adjectives,
preKoranic_adjectives,
glassyeyed_adjectives,
unnibbed_adjectives,
comfy_adjectives,
unmossed_adjectives,
subadjacent_adjectives,
optometrical_adjectives,
inscrutable_adjectives,
wellarmored_adjectives,
thyroarytenoid_adjectives,
Greekish_adjectives,
unjoinable_adjectives,
quasitolerant_adjectives,
adventurous_adjectives,
bimanous_adjectives,
aweigh_adjectives,
unsculptural_adjectives,
poisonous_adjectives,
isochasmic_adjectives,
gastrodermal_adjectives,
untunable_adjectives,
nucleolated_adjectives,
unjudgable_adjectives,
cymbocephalous_adjectives,
cramped_adjectives,
ungenial_adjectives,
peremptory_adjectives,
unmedalled_adjectives,
boolean_adjectives,
sodalime_adjectives,
hypobaric_adjectives,
paraxial_adjectives,
Mixtecan_adjectives,
bitless_adjectives,
princeless_adjectives,
knottier_adjectives,
overfranchised_adjectives,
Eucharistic_adjectives,
unintermitting_adjectives,
correlational_adjectives,
woodless_adjectives,
whitish_adjectives,
undefaulted_adjectives,
dilettantish_adjectives,
selfcreating_adjectives,
aurous_adjectives,
whinny_adjectives,
unquiet_adjectives,
unsubordinate_adjectives,
rightish_adjectives,
rarest_adjectives,
imponderable_adjectives,
geophilous_adjectives,
Rubenesque_adjectives,
unhydrolized_adjectives,
antiSocratic_adjectives,
adscript_adjectives,
fraught_adjectives,
pseudoinvalid_adjectives,
unselfrighteous_adjectives,
upmost_adjectives,
hemocytoblastic_adjectives,
celestial_adjectives,
equal_adjectives,
nonpacifistic_adjectives,
wellcontrolled_adjectives,
untrailing_adjectives,
transTiber_adjectives,
noninductive_adjectives,
inbuilt_adjectives,
changeless_adjectives,
involuntary_adjectives,
discommodious_adjectives,
untemptable_adjectives,
wartlike_adjectives,
ramiform_adjectives,
nonpunctual_adjectives,
electroneutral_adjectives,
honorific_adjectives,
compensatory_adjectives,
pretypographical_adjectives,
inclinatory_adjectives,
unexisting_adjectives,
quasiangelic_adjectives,
quasidifficult_adjectives,
compassable_adjectives,
uncounseled_adjectives,
hastiest_adjectives,
ruthful_adjectives,
pitiful_adjectives,
nobleminded_adjectives,
hematuric_adjectives,
delicate_adjectives,
learned_adjectives,
blueblooded_adjectives,
preconcurrent_adjectives,
nonindividual_adjectives,
quasizealous_adjectives,
unsubmerging_adjectives,
unsurcharged_adjectives,
overrestraint_adjectives,
unshouted_adjectives,
unindurate_adjectives,
pseudoassociational_adjectives,
antiparasitic_adjectives,
captious_adjectives,
quasiforced_adjectives,
nonliturgic_adjectives,
semipneumatical_adjectives,
towerless_adjectives,
bolometric_adjectives,
nickelous_adjectives,
fremd_adjectives,
brownstate_adjectives,
Christianly_adjectives,
unexistential_adjectives,
nonvindicable_adjectives,
earthy_adjectives,
acinaciform_adjectives,
keramic_adjectives,
nonblended_adjectives,
interbelligerent_adjectives,
Theban_adjectives,
nonschismatic_adjectives,
netherward_adjectives,
wellrecognised_adjectives,
legible_adjectives,
fibroplastic_adjectives,
peridiiform_adjectives,
unslipped_adjectives,
prothetic_adjectives,
camphoric_adjectives,
preCrusade_adjectives,
dynamitic_adjectives,
dovish_adjectives,
currish_adjectives,
superaccommodating_adjectives,
unvitrescent_adjectives,
preorbital_adjectives,
graphotypic_adjectives,
passa_adjectives,
inesse_adjectives,
elastomeric_adjectives,
nonreclaimable_adjectives,
preKantian_adjectives,
preemptive_adjectives,
wrathless_adjectives,
unfeared_adjectives,
ghoulish_adjectives,
unteaselled_adjectives,
unrustling_adjectives,
rabbinistical_adjectives,
exposable_adjectives,
guileful_adjectives,
fluidal_adjectives,
amberous_adjectives,
semaphoric_adjectives,
submental_adjectives,
abasic_adjectives,
unfunded_adjectives,
unsavoury_adjectives,
humpy_adjectives,
unapposable_adjectives,
wheeled_adjectives,
selfvaunting_adjectives,
hawsefallen_adjectives,
nonincidental_adjectives,
nonchromatic_adjectives,
cruciate_adjectives,
gesticular_adjectives,
brambly_adjectives,
unblanketed_adjectives,
singleblind_adjectives,
multicapitate_adjectives,
uncombated_adjectives,
warm_adjectives,
nonmature_adjectives,
imaginational_adjectives,
laevogyrate_adjectives,
magnipotent_adjectives,
digitigrade_adjectives,
sacrarial_adjectives,
awestricken_adjectives,
teleplasmic_adjectives,
uneradicated_adjectives,
subpredicative_adjectives,
postseason_adjectives,
nonlarcenous_adjectives,
unpacifiable_adjectives,
Helvetic_adjectives,
nontrailing_adjectives,
hoodlike_adjectives,
liege_adjectives,
hyperprognathous_adjectives,
hyperstoical_adjectives,
nonharmonious_adjectives,
fibriform_adjectives,
spined_adjectives,
sparsest_adjectives,
musteline_adjectives,
undandled_adjectives,
quasioriental_adjectives,
diaphragmatic_adjectives,
legit_adjectives,
circumnavigable_adjectives,
exclusive_adjectives,
irregular_adjectives,
unrecollected_adjectives,
histographic_adjectives,
undetractory_adjectives,
Orphean_adjectives,
medullary_adjectives,
flamelike_adjectives,
noniridescent_adjectives,
achondritic_adjectives,
hebephrenic_adjectives,
postpeduncular_adjectives,
proadmission_adjectives,
undislodged_adjectives,
peridermal_adjectives,
bombastic_adjectives,
nonelectrical_adjectives,
holozoic_adjectives,
psoatic_adjectives,
snitchiest_adjectives,
unwrung_adjectives,
harlequinesque_adjectives,
unflooded_adjectives,
unhindering_adjectives,
nondevious_adjectives,
pharmacopoeial_adjectives,
bicentenary_adjectives,
fullblown_adjectives,
workaday_adjectives,
abundant_adjectives,
sympathomimetic_adjectives,
wellaimed_adjectives,
unfathered_adjectives,
blanketlike_adjectives,
somatological_adjectives,
groundless_adjectives,
unlusting_adjectives,
orobanchaceous_adjectives,
unblundering_adjectives,
unshoed_adjectives,
ejaculatory_adjectives,
insipient_adjectives,
slipshod_adjectives,
unerodable_adjectives,
nonextensive_adjectives,
wellrevised_adjectives,
prepunctual_adjectives,
hypertragical_adjectives,
supergeneric_adjectives,
justifiable_adjectives,
unslipping_adjectives,
unstigmatised_adjectives,
mouilla_adjectives,
unprevalent_adjectives,
wandlike_adjectives,
quasiasleep_adjectives,
Muscovitic_adjectives,
angiospermous_adjectives,
flying_adjectives,
obstetric_adjectives,
tolerant_adjectives,
cesural_adjectives,
unwindowed_adjectives,
paunchy_adjectives,
privy_adjectives,
biliary_adjectives,
exopoditic_adjectives,
oophytic_adjectives,
noncompromised_adjectives,
untaxable_adjectives,
waterlike_adjectives,
Mauretanian_adjectives,
uncontradictious_adjectives,
skeletonlike_adjectives,
unflaked_adjectives,
earthly_adjectives,
coursed_adjectives,
unbeautified_adjectives,
dissymmetric_adjectives,
germinant_adjectives,
uncoaxal_adjectives,
demanding_adjectives,
pseudo_adjectives,
idiosyncratic_adjectives,
AngloAustralian_adjectives,
Carlovingian_adjectives,
adjuratory_adjectives,
hydrotherapeutic_adjectives,
unaspirated_adjectives,
orogenic_adjectives,
decanal_adjectives,
unconciliated_adjectives,
ungliding_adjectives,
breathy_adjectives,
miliary_adjectives,
unhyphenated_adjectives,
barrelvaulted_adjectives,
administrant_adjectives,
bathymetric_adjectives,
Sanskritic_adjectives,
Kechuan_adjectives,
cyperaceous_adjectives,
mouldiest_adjectives,
postDavidic_adjectives,
unfading_adjectives,
doubtable_adjectives,
unhued_adjectives,
breechloading_adjectives,
untestable_adjectives,
lactiferous_adjectives,
unutilizable_adjectives,
lithy_adjectives,
Calydonian_adjectives,
unhabituated_adjectives,
gubernatorial_adjectives,
bronchopneumonic_adjectives,
epidermic_adjectives,
untransmutable_adjectives,
nonenergetic_adjectives,
undiapered_adjectives,
nicenelly_adjectives,
selfproclaiming_adjectives,
superhistorical_adjectives,
halfmatured_adjectives,
selfscourging_adjectives,
stenothermal_adjectives,
undivinable_adjectives,
maladroit_adjectives,
melodyless_adjectives,
Chavin_adjectives,
concentrative_adjectives,
unvoyaging_adjectives,
palaeoecologic_adjectives,
intimate_adjectives,
selfevolving_adjectives,
lorn_adjectives,
wellelevated_adjectives,
ecological_adjectives,
unclotted_adjectives,
subconnivent_adjectives,
unhampering_adjectives,
Lamaistic_adjectives,
stealthless_adjectives,
hardwearing_adjectives,
prestidigitatory_adjectives,
unrefreshed_adjectives,
spongiest_adjectives,
wellrespected_adjectives,
presuccessful_adjectives,
unmisgiving_adjectives,
Jezebelian_adjectives,
hierarchical_adjectives,
nonmagnetized_adjectives,
nonrotational_adjectives,
croupous_adjectives,
gray_adjectives,
gorillian_adjectives,
last_adjectives,
noncuspidate_adjectives,
unfenestrated_adjectives,
Ushaped_adjectives,
crannied_adjectives,
preaggressive_adjectives,
upstate_adjectives,
fuzzy_adjectives,
disciplinal_adjectives,
bimensal_adjectives,
fleshly_adjectives,
dative_adjectives,
uncreatable_adjectives,
unretributive_adjectives,
adhoc_adjectives,
ordinal_adjectives,
outgoing_adjectives,
nonsensate_adjectives,
verbal_adjectives,
Ascanian_adjectives,
underproportioned_adjectives,
predorsal_adjectives,
needy_adjectives,
overluscious_adjectives,
pilgrimatical_adjectives,
zany_adjectives,
Cretaceous_adjectives,
ithyphallic_adjectives,
halfcrumbled_adjectives,
nondeaf_adjectives,
prebronze_adjectives,
insuperable_adjectives,
quasihealthful_adjectives,
decem_adjectives,
typhous_adjectives,
achronychous_adjectives,
unfallen_adjectives,
Mosaic_adjectives,
strident_adjectives,
easier_adjectives,
asphaltlike_adjectives,
unhidden_adjectives,
selfoperating_adjectives,
cytostomal_adjectives,
auricular_adjectives,
adulterine_adjectives,
nondesulfurized_adjectives,
suboesophageal_adjectives,
oppugnant_adjectives,
halfAsiatic_adjectives,
undefendant_adjectives,
aplastic_adjectives,
unskewed_adjectives,
moier_adjectives,
transnatural_adjectives,
halflanguishing_adjectives,
leukopoietic_adjectives,
backslapping_adjectives,
flabbiest_adjectives,
superdubious_adjectives,
unrevered_adjectives,
fulltofull_adjectives,
arrhythmic_adjectives,
unoared_adjectives,
undepreciative_adjectives,
appraisive_adjectives,
generic_adjectives,
prealphabetical_adjectives,
nonelectrified_adjectives,
nonfiscal_adjectives,
syntonous_adjectives,
transLiberian_adjectives,
digestible_adjectives,
toothiest_adjectives,
sassier_adjectives,
supplicatory_adjectives,
propatronage_adjectives,
uncomprehensive_adjectives,
indiscreet_adjectives,
unannexed_adjectives,
wellchurned_adjectives,
potentiometric_adjectives,
prosupervision_adjectives,
postcardinal_adjectives,
unbewailed_adjectives,
unkingly_adjectives,
patrilateral_adjectives,
androgenic_adjectives,
urogenital_adjectives,
subautomatic_adjectives,
mesodont_adjectives,
slackjawed_adjectives,
birefringent_adjectives,
synaptic_adjectives,
mesenteronic_adjectives,
aedeagal_adjectives,
nonrudimental_adjectives,
uncampaigning_adjectives,
kacha_adjectives,
uredinial_adjectives,
palingenesian_adjectives,
ureteral_adjectives,
wispiest_adjectives,
futuramic_adjectives,
nondidactic_adjectives,
wellmotivated_adjectives,
uncontained_adjectives,
overpuissant_adjectives,
overheady_adjectives,
propublication_adjectives,
ectosarcous_adjectives,
pericarpic_adjectives,
quasiforeign_adjectives,
undetectable_adjectives,
secret_adjectives,
appendicular_adjectives,
microscopic_adjectives,
gritty_adjectives,
trivalve_adjectives,
nonavoidable_adjectives,
roundshouldered_adjectives,
noneffective_adjectives,
rattish_adjectives,
dolesome_adjectives,
unsuburban_adjectives,
glum_adjectives,
hurried_adjectives,
strained_adjectives,
unhomologic_adjectives,
Occidental_adjectives,
Charybdian_adjectives,
brookable_adjectives,
wellchauffeured_adjectives,
sparkless_adjectives,
spermatophoral_adjectives,
legginged_adjectives,
preeconomical_adjectives,
unretired_adjectives,
agnominal_adjectives,
unulcerous_adjectives,
halfAristotelian_adjectives,
minor_adjectives,
arilloid_adjectives,
truistic_adjectives,
phantasmagorial_adjectives,
Japanesque_adjectives,
double_adjectives,
nonanemic_adjectives,
gynaecologic_adjectives,
apocalyptic_adjectives,
overforward_adjectives,
limy_adjectives,
nonisolable_adjectives,
unseparating_adjectives,
unmusterable_adjectives,
semimanagerial_adjectives,
garish_adjectives,
EarlyChristian_adjectives,
stercoraceous_adjectives,
antireduction_adjectives,
walkin_adjectives,
interpetalous_adjectives,
drearisome_adjectives,
unpitying_adjectives,
proprivilege_adjectives,
adiabatic_adjectives,
unoily_adjectives,
nonlugubriously_adjectives,
blownmolded_adjectives,
cunning_adjectives,
tensive_adjectives,
selfauthorized_adjectives,
unbating_adjectives,
transuterine_adjectives,
shieldless_adjectives,
unwifelike_adjectives,
additive_adjectives,
gnathic_adjectives,
holopneustic_adjectives,
hyperpure_adjectives,
syruplike_adjectives,
oxidable_adjectives,
interoffice_adjectives,
quasirelieved_adjectives,
antituberculous_adjectives,
nonmunicipal_adjectives,
putupon_adjectives,
processional_adjectives,
superattainable_adjectives,
halfformed_adjectives,
clannish_adjectives,
nonsoporific_adjectives,
nonintroversive_adjectives,
kenspeckle_adjectives,
stagey_adjectives,
unilluminant_adjectives,
jacketlike_adjectives,
unvibrating_adjectives,
interparliament_adjectives,
esquamate_adjectives,
recessive_adjectives,
gutless_adjectives,
phymatic_adjectives,
Darwinistic_adjectives,
multiarticulate_adjectives,
extortionary_adjectives,
nonallegorical_adjectives,
typical_adjectives,
unassayed_adjectives,
larine_adjectives,
unconglutinated_adjectives,
monkish_adjectives,
alkaloidal_adjectives,
frigid_adjectives,
unpugnacious_adjectives,
quasimalicious_adjectives,
attent_adjectives,
nondoubting_adjectives,
keratinous_adjectives,
renunciative_adjectives,
postGalilean_adjectives,
uppish_adjectives,
unwarpable_adjectives,
bridal_adjectives,
selfteaching_adjectives,
thermosetting_adjectives,
valuable_adjectives,
nonadhering_adjectives,
uncoked_adjectives,
divertive_adjectives,
Swiss_adjectives,
tres_adjectives,
isocheimenal_adjectives,
revengeful_adjectives,
subreptitious_adjectives,
exorcistical_adjectives,
untippled_adjectives,
undryable_adjectives,
welldeserved_adjectives,
potassic_adjectives,
boneless_adjectives,
paralexic_adjectives,
fainaant_adjectives,
nonosmotic_adjectives,
antireactive_adjectives,
intersonant_adjectives,
apologal_adjectives,
nonlepidopteran_adjectives,
subcranial_adjectives,
halfshouted_adjectives,
Czech_adjectives,
oversolemn_adjectives,
subpial_adjectives,
partridgelike_adjectives,
interpretative_adjectives,
solvolytic_adjectives,
trusting_adjectives,
unautistic_adjectives,
prediscontented_adjectives,
tetrasporic_adjectives,
antinational_adjectives,
unworldly_adjectives,
unhistrionic_adjectives,
albinistic_adjectives,
coed_adjectives,
African_adjectives,
concordal_adjectives,
calorescent_adjectives,
conjunct_adjectives,
pisolitic_adjectives,
nonscaling_adjectives,
coseys_adjectives,
unprofaned_adjectives,
laboursaving_adjectives,
wellevidence_adjectives,
circumpolar_adjectives,
fleeceless_adjectives,
unadjudicated_adjectives,
unrumored_adjectives,
tonguelike_adjectives,
unvenial_adjectives,
razorless_adjectives,
adaptive_adjectives,
unreconcilable_adjectives,
unsandaled_adjectives,
freckliest_adjectives,
overeasy_adjectives,
nondispersive_adjectives,
epilimnial_adjectives,
lushiest_adjectives,
cosmographic_adjectives,
unconverged_adjectives,
multiflagellate_adjectives,
unpartisan_adjectives,
proFreud_adjectives,
haematoid_adjectives,
compellable_adjectives,
};
