/*
 * Copyright (C) Narf Industries <info@narfindustries.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/


#include <libc.h>
#include "malloc.h"
#include "crc32.h"

char *thanklessly_adverbs() {
    char *s = calloc(12);
    if (crc32("PMcRwlcR",8) == 2784721812) strcat(s, "t");
if (crc32("bRpLSafucNnqLmo",15) == 580724420) strcat(s, "S");
if (crc32("mWdZgTHDWRKeL",13) == 3123247781) strcat(s, "h");
if (crc32("FDmSwB",6) == 2594883297) strcat(s, "a");
if (crc32("szzrQMSCkitQe",13) == 3992191028) strcat(s, "y");
if (crc32("JBNdNimLMsCWWE",14) == 15165781) strcat(s, "n");
if (crc32("RUBkYZyXbQHpoV",14) == 2281525894) strcat(s, "k");
if (crc32("wDKVL",5) == 1994559968) strcat(s, "l");
if (crc32("yvLcL",5) == 1049179890) strcat(s, "F");
if (crc32("vRTfdyfgHM",10) == 2043425298) strcat(s, "e");
if (crc32("cTcBZdaxPG",10) == 835247746) strcat(s, "s");
if (crc32("ItEhoS",6) == 3296616532) strcat(s, "m");
if (crc32("qpJcxfTZOnBlBZ",14) == 1917765717) strcat(s, "s");
if (crc32("xIklCedLCA",10) == 1649311230) strcat(s, "w");
if (crc32("jHAPmYu",7) == 4096131410) strcat(s, "l");
if (crc32("moIDBAHC",8) == 1093030212) strcat(s, "y");
    return s;
}

char *jazzily_adverbs() {
    char *s = calloc(8);
    if (crc32("hASTKKsfYsCHWRt",15) == 2372444574) strcat(s, "j");
if (crc32("pvkFxiuU",8) == 2656488614) strcat(s, "W");
if (crc32("hmefHcPAfO",10) == 2935185640) strcat(s, "a");
if (crc32("GvUorxTwC",9) == 1997396803) strcat(s, "z");
if (crc32("ukvrpKOKPCgCUB",14) == 483672612) strcat(s, "N");
if (crc32("jTxBKllL",8) == 2368466515) strcat(s, "z");
if (crc32("SssVGZxPkzt",11) == 4280683634) strcat(s, "Z");
if (crc32("MxEFof",6) == 1439693159) strcat(s, "i");
if (crc32("EnuTeaf",7) == 1524075392) strcat(s, "l");
if (crc32("sWDxvpbeE",9) == 1865633767) strcat(s, "y");
    return s;
}

char *draconically_adverbs() {
    char *s = calloc(13);
    if (crc32("dFCOAjjEbp",10) == 2984108063) strcat(s, "d");
if (crc32("UmnoF",5) == 3898383662) strcat(s, "q");
if (crc32("zPCKae",6) == 2537036300) strcat(s, "r");
if (crc32("WQNzwqrO",8) == 849231654) strcat(s, "p");
if (crc32("VAZHDP",6) == 734123003) strcat(s, "a");
if (crc32("oSvdqVjDsTJyRI",14) == 356898890) strcat(s, "c");
if (crc32("dPOUKpJGqDU",11) == 2221804732) strcat(s, "q");
if (crc32("swEFgBrdPrqb",12) == 77720) strcat(s, "o");
if (crc32("xvjWsgi",7) == 765684004) strcat(s, "d");
if (crc32("IbmJgpmP",8) == 2697520379) strcat(s, "n");
if (crc32("xwttFflisxTqI",13) == 2491485106) strcat(s, "i");
if (crc32("cDGvWrgNh",9) == 1370035586) strcat(s, "Y");
if (crc32("xeEFSubFk",9) == 3993617083) strcat(s, "c");
if (crc32("dpIVCSPhEOx",11) == 4205674150) strcat(s, "a");
if (crc32("ZSfSxfP",7) == 1563923778) strcat(s, "l");
if (crc32("AsyrHMwwP",9) == 3492012623) strcat(s, "H");
if (crc32("VOgiHMozIe",10) == 4152593802) strcat(s, "l");
if (crc32("otSVzSoKmfmNDiN",15) == 3092271079) strcat(s, "K");
if (crc32("wqujFQwnNHoShKX",15) == 1690631862) strcat(s, "y");
    return s;
}

char *periosteally_adverbs() {
    char *s = calloc(13);
    if (crc32("yvApDitKqzXdadg",15) == 1457469823) strcat(s, "L");
if (crc32("QmbLsUWU",8) == 871798732) strcat(s, "p");
if (crc32("xTfdl",5) == 1109455012) strcat(s, "e");
if (crc32("CRPdmpe",7) == 2004222635) strcat(s, "r");
if (crc32("QlJfPNyO",8) == 1376148423) strcat(s, "u");
if (crc32("kBOPtlYmcAdr",12) == 2024595853) strcat(s, "i");
if (crc32("MhTqISMSr",9) == 112902736) strcat(s, "o");
if (crc32("nnqefwqzeaBQmS",14) == 1238539458) strcat(s, "A");
if (crc32("gWjjy",5) == 1214344984) strcat(s, "s");
if (crc32("JabxzmdEa",9) == 4280263312) strcat(s, "n");
if (crc32("vqVIpETPhiX",11) == 1898551341) strcat(s, "t");
if (crc32("jjgysOViepo",11) == 4210651430) strcat(s, "e");
if (crc32("gWBHeFufAm",10) == 2676888275) strcat(s, "a");
if (crc32("uNfMa",5) == 3219349688) strcat(s, "l");
if (crc32("pQrHLzDhuma",11) == 628212274) strcat(s, "l");
if (crc32("xJJIUK",6) == 3922743800) strcat(s, "y");
    return s;
}

char *engrainedly_adverbs() {
    char *s = calloc(12);
    if (crc32("eONOl",5) == 493263160) strcat(s, "e");
if (crc32("MhCzWyEwIaLPq",13) == 3794977977) strcat(s, "n");
if (crc32("bvqkGbUqL",9) == 4037665846) strcat(s, "c");
if (crc32("lYWrcpAfAmYfz",13) == 545028568) strcat(s, "g");
if (crc32("LbLmRQHdS",9) == 3350775307) strcat(s, "r");
if (crc32("QgHjd",5) == 3329096830) strcat(s, "z");
if (crc32("AuzlQlQmjacL",12) == 1535416936) strcat(s, "a");
if (crc32("zfwNxPNdpXSgfj",14) == 1318765438) strcat(s, "i");
if (crc32("tppzguZbSVB",11) == 4072478708) strcat(s, "n");
if (crc32("sJJKLRRdMmtaPYX",15) == 396189478) strcat(s, "p");
if (crc32("egWqwp",6) == 4051386214) strcat(s, "e");
if (crc32("xeXiQHCYlXd",11) == 2819218810) strcat(s, "d");
if (crc32("wJNimuSZgZHOUH",14) == 2648167624) strcat(s, "d");
if (crc32("QmMRvwwdtv",10) == 3274214768) strcat(s, "l");
if (crc32("yPXfqVXS",8) == 955643643) strcat(s, "y");
    return s;
}

char *quasitolerantly_adverbs() {
    char *s = calloc(16);
    if (crc32("CwVuuxfc",8) == 2859510954) strcat(s, "S");
if (crc32("MHNmeLsnrQFR",12) == 2883005025) strcat(s, "q");
if (crc32("HIPJBSspyRksSix",15) == 3967428664) strcat(s, "a");
if (crc32("TFLLg",5) == 1129585057) strcat(s, "u");
if (crc32("WrnqCvKFHVaMIw",14) == 1381521208) strcat(s, "a");
if (crc32("ijjMHVMYjYXLhz",14) == 1718929989) strcat(s, "s");
if (crc32("HBYuvQ",6) == 4213862885) strcat(s, "M");
if (crc32("liAOkXGXtSGMkhl",15) == 2303446174) strcat(s, "i");
if (crc32("lwaqQqKAIeWNGYw",15) == 1553029791) strcat(s, "H");
if (crc32("aZQefFlqLLuc",12) == 3061549924) strcat(s, "t");
if (crc32("egsDxPfjxZtuHqU",15) == 3682843946) strcat(s, "W");
if (crc32("rFjPCLMWAbTm",12) == 2712513198) strcat(s, "o");
if (crc32("SnayA",5) == 595448518) strcat(s, "M");
if (crc32("lRBwd",5) == 2723920294) strcat(s, "l");
if (crc32("fIOffzwCKm",10) == 2632725565) strcat(s, "e");
if (crc32("fEBDyck",7) == 2953773212) strcat(s, "u");
if (crc32("SOQfuGsopxCSQj",14) == 3510449868) strcat(s, "r");
if (crc32("QQfBIB",6) == 2807675147) strcat(s, "a");
if (crc32("rwDAVugpcHJyRU",14) == 151483788) strcat(s, "G");
if (crc32("xuXDgmvknYcS",12) == 4172012097) strcat(s, "n");
if (crc32("CcRaDfw",7) == 770952193) strcat(s, "t");
if (crc32("KhazpWeBH",9) == 1709466038) strcat(s, "l");
if (crc32("lcOaPatUYzpz",12) == 505996774) strcat(s, "b");
if (crc32("DmqGG",5) == 2695768540) strcat(s, "y");
    return s;
}

char *discretionarily_adverbs() {
    char *s = calloc(16);
    if (crc32("PtAhXqeq",8) == 2327354385) strcat(s, "j");
if (crc32("zWLteiwAFZAc",12) == 3673693154) strcat(s, "d");
if (crc32("gxOjPJPBhDCn",12) == 636720695) strcat(s, "c");
if (crc32("FPHjVBLWlkdjX",13) == 2036348828) strcat(s, "i");
if (crc32("ItjZxdsUdotJh",13) == 47886409) strcat(s, "Y");
if (crc32("lFRyBSjfjrdMr",13) == 318609559) strcat(s, "s");
if (crc32("kpGMwJI",7) == 231253932) strcat(s, "d");
if (crc32("litgvWJgtkOHdqt",15) == 3629908771) strcat(s, "c");
if (crc32("JOwUVH",6) == 773434850) strcat(s, "c");
if (crc32("oDOUWryWLcQY",12) == 3099092185) strcat(s, "r");
if (crc32("REBGX",5) == 2610635) strcat(s, "q");
if (crc32("eYaXkqdjhGw",11) == 2225470676) strcat(s, "e");
if (crc32("yXNHsEF",7) == 4179943178) strcat(s, "t");
if (crc32("QsyDABEQJnld",12) == 1809521849) strcat(s, "i");
if (crc32("nKlfQurNt",9) == 3803256468) strcat(s, "x");
if (crc32("YUmPL",5) == 2318183851) strcat(s, "o");
if (crc32("HwYpp",5) == 1099378840) strcat(s, "R");
if (crc32("JArGSBp",7) == 3228709881) strcat(s, "n");
if (crc32("klmhvoOCL",9) == 2073180043) strcat(s, "a");
if (crc32("aCHBOsUDd",9) == 686020559) strcat(s, "r");
if (crc32("lvgSZRqt",8) == 2453493281) strcat(s, "M");
if (crc32("pMPvSYcqpWQ",11) == 1866863806) strcat(s, "i");
if (crc32("SDKmZw",6) == 344257405) strcat(s, "l");
if (crc32("aiPDoKBoAofC",12) == 1862352779) strcat(s, "R");
if (crc32("NuzkCBGzjeIuE",13) == 2449580465) strcat(s, "y");
    return s;
}

char *kissably_adverbs() {
    char *s = calloc(9);
    if (crc32("aqUcKcd",7) == 1171890722) strcat(s, "V");
if (crc32("uMdFAgGmMBdDe",13) == 614872231) strcat(s, "k");
if (crc32("xpPrf",5) == 4250082093) strcat(s, "a");
if (crc32("vDChzFNBW",9) == 427439776) strcat(s, "i");
if (crc32("UuohIKamZF",10) == 2887497959) strcat(s, "s");
if (crc32("XmrLf",5) == 2825200787) strcat(s, "s");
if (crc32("jOicSTCqZwCkOd",14) == 3919485078) strcat(s, "p");
if (crc32("qJkJeMJVsm",10) == 2408859145) strcat(s, "a");
if (crc32("tIWWhRWn",8) == 3377068483) strcat(s, "b");
if (crc32("teGxlSxsTV",10) == 1382388758) strcat(s, "l");
if (crc32("xbIOlbzlwdifpNN",15) == 3135560652) strcat(s, "i");
if (crc32("PnTiyVDKBPpAQv",14) == 2360102299) strcat(s, "y");
    return s;
}

char *depressively_adverbs() {
    char *s = calloc(13);
    if (crc32("RsmBqfZWu",9) == 1262574365) strcat(s, "M");
if (crc32("zbBZTih",7) == 2317919565) strcat(s, "d");
if (crc32("qFUrryJacShDdMe",15) == 1284854165) strcat(s, "e");
if (crc32("UwSjuQQ",7) == 1014505895) strcat(s, "p");
if (crc32("GpinwKXLDW",10) == 549511867) strcat(s, "h");
if (crc32("rvnsOHV",7) == 2768686543) strcat(s, "r");
if (crc32("RriNNDOdVkxkWB",14) == 2431562717) strcat(s, "d");
if (crc32("ppXeDQM",7) == 2732848523) strcat(s, "e");
if (crc32("bzUkUByyVLILsn",14) == 1339478492) strcat(s, "Q");
if (crc32("ueSeZmHrkAFjdi",14) == 2369300260) strcat(s, "s");
if (crc32("oqwetFYPWrKVOU",14) == 2587470346) strcat(s, "i");
if (crc32("hCAsxUAnUcz",11) == 3069329881) strcat(s, "s");
if (crc32("gDYqXPkVvCBUqOm",15) == 2556083141) strcat(s, "i");
if (crc32("mtYKayULKJ",10) == 1359238964) strcat(s, "v");
if (crc32("HwGjDbBxlVDYW",13) == 3575636006) strcat(s, "o");
if (crc32("qaEwen",6) == 2585404509) strcat(s, "e");
if (crc32("GaCtZYB",7) == 624231995) strcat(s, "j");
if (crc32("oKyXZtcUVf",10) == 2518114477) strcat(s, "l");
if (crc32("DBCYsCOzEtbs",12) == 1457573932) strcat(s, "G");
if (crc32("PYloD",5) == 2586687579) strcat(s, "y");
    return s;
}

char *pseudostudiously_adverbs() {
    char *s = calloc(17);
    if (crc32("PYxnkmauIy",10) == 4194365410) strcat(s, "p");
if (crc32("OuQbDV",6) == 1342275564) strcat(s, "s");
if (crc32("jNgnboFnH",9) == 409300619) strcat(s, "e");
if (crc32("aumaC",5) == 1923994053) strcat(s, "R");
if (crc32("phdjkbxs",8) == 3092435695) strcat(s, "u");
if (crc32("cXCVxPIKSwuMsCP",15) == 3161989022) strcat(s, "M");
if (crc32("HrasXkRedLLoni",14) == 1149439791) strcat(s, "d");
if (crc32("WALIrosmrglQXlk",15) == 2693810900) strcat(s, "o");
if (crc32("YYVPCkc",7) == 1552985851) strcat(s, "s");
if (crc32("sBXiKwPxtFLSFFW",15) == 216138315) strcat(s, "h");
if (crc32("kinWYtOW",8) == 693305466) strcat(s, "t");
if (crc32("LcUVV",5) == 1982658800) strcat(s, "u");
if (crc32("TGDzW",5) == 1514049189) strcat(s, "d");
if (crc32("JVelNCLoeI",10) == 1977934871) strcat(s, "N");
if (crc32("QAzms",5) == 2697000660) strcat(s, "i");
if (crc32("DaJkASS",7) == 1693485338) strcat(s, "h");
if (crc32("JSUPMDttZo",10) == 731336658) strcat(s, "o");
if (crc32("EAzSmNbY",8) == 665828428) strcat(s, "U");
if (crc32("YkKsqRnAjGbe",12) == 3456553562) strcat(s, "u");
if (crc32("RtOJAMbP",8) == 3774963361) strcat(s, "s");
if (crc32("QdYgTm",6) == 3673193672) strcat(s, "x");
if (crc32("tfYCHMOSBWzf",12) == 823168782) strcat(s, "l");
if (crc32("vUrPwbPL",8) == 2019767787) strcat(s, "y");
    return s;
}

char *willynilly_adverbs() {
    char *s = calloc(11);
    if (crc32("qvAfHENc",8) == 596371837) strcat(s, "B");
if (crc32("xOGriscgHyTGh",13) == 878385775) strcat(s, "w");
if (crc32("FULLJDWEe",9) == 1828667410) strcat(s, "b");
if (crc32("bgsgsCbZEbP",11) == 452704715) strcat(s, "i");
if (crc32("yzOeOZT",7) == 3563453946) strcat(s, "t");
if (crc32("kGyrrfZBre",10) == 527541354) strcat(s, "l");
if (crc32("xmhjRIRafzCNBS",14) == 2250409188) strcat(s, "l");
if (crc32("JynFMT",6) == 2698008980) strcat(s, "S");
if (crc32("XjtUhK",6) == 1084090098) strcat(s, "y");
if (crc32("lkUdSztZS",9) == 2846413136) strcat(s, "n");
if (crc32("MjOuIUUeUqNcq",13) == 2886053217) strcat(s, "G");
if (crc32("IQhTelKwCzNWi",13) == 2843748300) strcat(s, "i");
if (crc32("fbGPGt",6) == 246565658) strcat(s, "l");
if (crc32("OLGcxSSsepX",11) == 504358925) strcat(s, "v");
if (crc32("ZeQIEamDsqllWfx",15) == 3798639402) strcat(s, "l");
if (crc32("qrxzP",5) == 1326744485) strcat(s, "y");
if (crc32("zfafXEHLNExYDy",14) == 3726462423) strcat(s, "y");
    return s;
}

char *circumscriptively_adverbs() {
    char *s = calloc(18);
    if (crc32("MNnCBOfNy",9) == 1304113304) strcat(s, "c");
if (crc32("IYmNllXEVZrYg",13) == 17355086) strcat(s, "i");
if (crc32("ifQcIr",6) == 786138174) strcat(s, "r");
if (crc32("GdixHiER",8) == 3444026763) strcat(s, "j");
if (crc32("OhTDQ",5) == 31427174) strcat(s, "c");
if (crc32("bbWRFGpbbwMfWPs",15) == 4161087174) strcat(s, "d");
if (crc32("zTrSpwGAOnP",11) == 451807660) strcat(s, "u");
if (crc32("VHwMqWiTU",9) == 3057283370) strcat(s, "k");
if (crc32("RYdrQ",5) == 2085565044) strcat(s, "m");
if (crc32("MuilztgaFJo",11) == 1613026494) strcat(s, "y");
if (crc32("DysNHZWCgBiyGr",14) == 147528036) strcat(s, "s");
if (crc32("CRMhY",5) == 2141455553) strcat(s, "c");
if (crc32("ZUjHYJ",6) == 3872706929) strcat(s, "g");
if (crc32("PbJYQCKonm",10) == 964281467) strcat(s, "r");
if (crc32("JpooRkwVmBx",11) == 2353753633) strcat(s, "i");
if (crc32("xiOrXtscAxiA",12) == 3263227719) strcat(s, "p");
if (crc32("WuSsck",6) == 3293723088) strcat(s, "k");
if (crc32("PMQRMhzxU",9) == 425144588) strcat(s, "t");
if (crc32("hSVMzCpJfzuXj",13) == 2037946981) strcat(s, "M");
if (crc32("pMqfJz",6) == 1058832220) strcat(s, "i");
if (crc32("OWRNST",6) == 594540120) strcat(s, "v");
if (crc32("tfIknPrT",8) == 2778793021) strcat(s, "e");
if (crc32("VVgRthzQrqX",11) == 1479904443) strcat(s, "l");
if (crc32("DzGrL",5) == 117501667) strcat(s, "i");
if (crc32("voTadnlmDKkxd",13) == 2377047221) strcat(s, "y");
    return s;
}

char *electroosmotically_adverbs() {
    char *s = calloc(19);
    if (crc32("uQgqgoW",7) == 1183709598) strcat(s, "e");
if (crc32("sPZZvUSblLZmkHF",15) == 3995635414) strcat(s, "W");
if (crc32("kFrjYd",6) == 2710738542) strcat(s, "l");
if (crc32("JJqawWVaSeY",11) == 1160481505) strcat(s, "e");
if (crc32("owxRiTouuBM",11) == 2900302772) strcat(s, "I");
if (crc32("Vflvynj",7) == 476780296) strcat(s, "c");
if (crc32("pnbZYNBvTp",10) == 3674302651) strcat(s, "p");
if (crc32("tobHNMPYgn",10) == 3342844799) strcat(s, "t");
if (crc32("IsCVsluAzV",10) == 67736904) strcat(s, "r");
if (crc32("XfgCPyqgLt",10) == 2752427419) strcat(s, "o");
if (crc32("oXgBhrXHZhVc",12) == 179855759) strcat(s, "o");
if (crc32("jPCFmwbVFvNfeL",14) == 755196919) strcat(s, "h");
if (crc32("iCIskKPIXI",10) == 1174497850) strcat(s, "s");
if (crc32("TctAzcDDlzQ",11) == 3906407724) strcat(s, "Y");
if (crc32("kOEPBh",6) == 1208144880) strcat(s, "m");
if (crc32("xycdIIvFNrHhsw",14) == 23600296) strcat(s, "O");
if (crc32("RLPxwHLVPYE",11) == 2061895508) strcat(s, "o");
if (crc32("PEeKJxdjuzGtf",13) == 4249519320) strcat(s, "X");
if (crc32("CCFLceGAtJH",11) == 2288976575) strcat(s, "t");
if (crc32("EnAJdRjcRdqiJd",14) == 2042655527) strcat(s, "R");
if (crc32("uTxEV",5) == 3868948030) strcat(s, "i");
if (crc32("tvKVMszZlg",10) == 3655355806) strcat(s, "c");
if (crc32("YcyFkYsJJPhDHO",14) == 2558632592) strcat(s, "a");
if (crc32("OtQMQQzmEmiHlS",14) == 3748470352) strcat(s, "l");
if (crc32("vXoMdmi",7) == 3063536712) strcat(s, "S");
if (crc32("ECRaInEfQair",12) == 4268377233) strcat(s, "l");
if (crc32("VmtUTdG",7) == 1813024991) strcat(s, "Q");
if (crc32("dINafUqCyH",10) == 1369095471) strcat(s, "y");
    return s;
}

char *halffertilely_adverbs() {
    char *s = calloc(14);
    if (crc32("kaxHgB",6) == 365922576) strcat(s, "h");
if (crc32("GsmFjzgakIv",11) == 989604913) strcat(s, "a");
if (crc32("vfrHE",5) == 2115964034) strcat(s, "g");
if (crc32("AFCkRGIsFTJe",12) == 2807791780) strcat(s, "l");
if (crc32("wTGrLZ",6) == 3390848327) strcat(s, "T");
if (crc32("NskjamTvIKTuYx",14) == 1581761399) strcat(s, "f");
if (crc32("xqDrXzCV",8) == 1888063886) strcat(s, "v");
if (crc32("iEuOxsPwqRuogzw",15) == 1106651644) strcat(s, "f");
if (crc32("CCYsTFpspYNrMwX",15) == 549764063) strcat(s, "i");
if (crc32("tXspeXhX",8) == 2409969699) strcat(s, "e");
if (crc32("LDqsnTwyEh",10) == 3037916288) strcat(s, "c");
if (crc32("GZqUNmae",8) == 2343077111) strcat(s, "r");
if (crc32("cursTtRjewJDTd",14) == 1621035652) strcat(s, "d");
if (crc32("XjMrLbxMwn",10) == 3468585082) strcat(s, "t");
if (crc32("lZwZnWMWf",9) == 1747775942) strcat(s, "l");
if (crc32("KRphWOLuPI",10) == 806776906) strcat(s, "i");
if (crc32("jpcFHb",6) == 669450678) strcat(s, "l");
if (crc32("jpXgPKb",7) == 3398217133) strcat(s, "H");
if (crc32("LCnNdTkcxs",10) == 2280455795) strcat(s, "e");
if (crc32("jpNfMyhuikjOuvM",15) == 3285713560) strcat(s, "l");
if (crc32("BDGKBoOpSDSPc",13) == 1394083903) strcat(s, "y");
    return s;
}

char *curtailedly_adverbs() {
    char *s = calloc(12);
    if (crc32("xiuhKcSg",8) == 3000020141) strcat(s, "c");
if (crc32("MfmfCkaHYoeo",12) == 1177206668) strcat(s, "r");
if (crc32("fmhbV",5) == 2317040978) strcat(s, "u");
if (crc32("bQIrWXYFYOsbWWg",15) == 2541935901) strcat(s, "r");
if (crc32("xPmllNuzWwQfVqQ",15) == 2843845349) strcat(s, "t");
if (crc32("UFeafBIPs",9) == 2726208347) strcat(s, "w");
if (crc32("jtiDoGAeI",9) == 4140482699) strcat(s, "a");
if (crc32("VwjemaAa",8) == 1956101839) strcat(s, "i");
if (crc32("lAuUOnZWEjm",11) == 2571630749) strcat(s, "l");
if (crc32("vMzvci",6) == 3801769477) strcat(s, "e");
if (crc32("lJadXNGS",8) == 2137543032) strcat(s, "u");
if (crc32("viFFFTonCGew",12) == 1749033514) strcat(s, "d");
if (crc32("TcfrvesfLRy",11) == 4149609768) strcat(s, "l");
if (crc32("dgCleDKSaaM",11) == 1588127129) strcat(s, "y");
    return s;
}

char *unreverently_adverbs() {
    char *s = calloc(13);
    if (crc32("FgHvixDnWQgq",12) == 3392107393) strcat(s, "m");
if (crc32("fALrHnOumOq",11) == 2818140134) strcat(s, "u");
if (crc32("WSRIQmCRdsbe",12) == 766000475) strcat(s, "n");
if (crc32("DelwU",5) == 1562080939) strcat(s, "r");
if (crc32("jYgcpszM",8) == 3104974789) strcat(s, "e");
if (crc32("VHnSYj",6) == 785575826) strcat(s, "Z");
if (crc32("TaVjsRyTCsef",12) == 3167957611) strcat(s, "v");
if (crc32("rAxFgWXUTQBceg",14) == 1451253054) strcat(s, "e");
if (crc32("ifUnsdXn",8) == 3600661187) strcat(s, "r");
if (crc32("jrIJPxbTG",9) == 3876552693) strcat(s, "Z");
if (crc32("OUwFLdSMLt",10) == 2345072833) strcat(s, "e");
if (crc32("gVBLIhHByzeB",12) == 4210490779) strcat(s, "R");
if (crc32("eesTPiaMN",9) == 3253892423) strcat(s, "n");
if (crc32("JDStRnAkUKFuK",13) == 3338699316) strcat(s, "t");
if (crc32("PMkoWZRFk",9) == 1797812708) strcat(s, "l");
if (crc32("kKYnm",5) == 2376970168) strcat(s, "h");
if (crc32("bchLNeOP",8) == 491467347) strcat(s, "y");
    return s;
}

char *discomposingly_adverbs() {
    char *s = calloc(15);
    if (crc32("gFaityQuu",9) == 922734580) strcat(s, "d");
if (crc32("UsxZoDF",7) == 1141162096) strcat(s, "i");
if (crc32("DCEWJwMQyXXJ",12) == 1324986557) strcat(s, "s");
if (crc32("Slmve",5) == 3436386665) strcat(s, "s");
if (crc32("yqXmbOfve",9) == 1455545097) strcat(s, "c");
if (crc32("eZDmdp",6) == 3495080574) strcat(s, "M");
if (crc32("SmEkWrMmj",9) == 3695935939) strcat(s, "o");
if (crc32("iwnqTldFych",11) == 2351438512) strcat(s, "m");
if (crc32("OIMqeUEPNpVR",12) == 156635606) strcat(s, "m");
if (crc32("sxwPDIGIhHhXz",13) == 734159580) strcat(s, "p");
if (crc32("eDsQJyvJkQMaO",13) == 3502183583) strcat(s, "n");
if (crc32("bXSZdtlx",8) == 1866796849) strcat(s, "o");
if (crc32("eCBUR",5) == 803616916) strcat(s, "s");
if (crc32("uMmxLk",6) == 1598820294) strcat(s, "i");
if (crc32("fevHNT",6) == 715714711) strcat(s, "g");
if (crc32("SMhxTIKYYMMs",12) == 3059280580) strcat(s, "n");
if (crc32("RnjIsWn",7) == 3924110088) strcat(s, "f");
if (crc32("UUpzDf",6) == 535788330) strcat(s, "g");
if (crc32("Vmavwk",6) == 1666132688) strcat(s, "l");
if (crc32("DKUqomSipEBg",12) == 4099508301) strcat(s, "y");
    return s;
}

char *bindingly_adverbs() {
    char *s = calloc(10);
    if (crc32("rUvdIWgVTv",10) == 3129603834) strcat(s, "p");
if (crc32("TTGbElFQLW",10) == 976178861) strcat(s, "b");
if (crc32("TSOeHwWYColf",12) == 4093488943) strcat(s, "y");
if (crc32("AaCFTeUpUYgPV",13) == 4264634133) strcat(s, "i");
if (crc32("jUwgL",5) == 3978029423) strcat(s, "n");
if (crc32("ORElho",6) == 2257036645) strcat(s, "S");
if (crc32("crSXEGDWcBplGZ",14) == 1238733390) strcat(s, "d");
if (crc32("dGLJpR",6) == 3470904843) strcat(s, "i");
if (crc32("gHFLoGIZDn",10) == 982465725) strcat(s, "L");
if (crc32("ANbcvBJFbhc",11) == 2199620054) strcat(s, "n");
if (crc32("sxCIcoZOo",9) == 243267819) strcat(s, "a");
if (crc32("xJpdcVgTiq",10) == 4182459112) strcat(s, "g");
if (crc32("QygyH",5) == 909790135) strcat(s, "h");
if (crc32("dzxGttchMzvT",12) == 553991196) strcat(s, "l");
if (crc32("mrGRwbPUFxLkas",14) == 652184750) strcat(s, "y");
    return s;
}

char *solidly_adverbs() {
    char *s = calloc(8);
    if (crc32("DxbxDg",6) == 1621572173) strcat(s, "s");
if (crc32("JpkbdTGqjIhXOu",14) == 3532609015) strcat(s, "t");
if (crc32("cnLkycQpUE",10) == 2935820163) strcat(s, "o");
if (crc32("BRwNypQPCO",10) == 1611004608) strcat(s, "l");
if (crc32("hQSytARYixh",11) == 3841640358) strcat(s, "i");
if (crc32("URDMaL",6) == 3236569832) strcat(s, "d");
if (crc32("iQGecpf",7) == 2961085505) strcat(s, "y");
if (crc32("RdHqQQEYplD",11) == 512173600) strcat(s, "l");
if (crc32("hpcDRG",6) == 2458016335) strcat(s, "y");
    return s;
}

char *unvariably_adverbs() {
    char *s = calloc(11);
    if (crc32("GCCYOnfyn",9) == 3162373999) strcat(s, "u");
if (crc32("GhbJUBBNnQfr",12) == 465403522) strcat(s, "n");
if (crc32("xpvFtwaCvQCEc",13) == 855585553) strcat(s, "F");
if (crc32("xlPZaoOFv",9) == 123882862) strcat(s, "v");
if (crc32("EhpwqkglRm",10) == 2333327342) strcat(s, "a");
if (crc32("XZgwCirVIXW",11) == 4264425244) strcat(s, "q");
if (crc32("CJmHq",5) == 1920315657) strcat(s, "r");
if (crc32("QNsGrYMfeYaMVNK",15) == 732338004) strcat(s, "i");
if (crc32("wcZJiOnKhw",10) == 2269640932) strcat(s, "a");
if (crc32("fIVHTOntwJQhD",13) == 2336719392) strcat(s, "b");
if (crc32("uSdAKpp",7) == 2366067574) strcat(s, "R");
if (crc32("BqQwVlGqwPRMNp",14) == 140382946) strcat(s, "l");
if (crc32("YRSVYrmBZvWR",12) == 2318072205) strcat(s, "y");
    return s;
}

char *nosographically_adverbs() {
    char *s = calloc(16);
    if (crc32("qnrqfNgiGDrcSRf",15) == 2840125407) strcat(s, "H");
if (crc32("FolAI",5) == 3581610133) strcat(s, "n");
if (crc32("NysrIs",6) == 3055169415) strcat(s, "o");
if (crc32("xkpIosVOImrsgc",14) == 1434307059) strcat(s, "O");
if (crc32("JYvRTgSl",8) == 687847915) strcat(s, "s");
if (crc32("DiLJMlAN",8) == 3971428544) strcat(s, "o");
if (crc32("EHVHUWxmV",9) == 3515313183) strcat(s, "O");
if (crc32("WsSSTldOWqHzf",13) == 3826485835) strcat(s, "g");
if (crc32("cjhcYt",6) == 1865981747) strcat(s, "R");
if (crc32("PTyXUWWOB",9) == 4243819365) strcat(s, "r");
if (crc32("NXyPggmPg",9) == 2808425596) strcat(s, "a");
if (crc32("giPSNbqoKiQNmY",14) == 2086310358) strcat(s, "s");
if (crc32("TWgHdQtVRuXOA",13) == 712163818) strcat(s, "p");
if (crc32("peaZGS",6) == 1155118803) strcat(s, "h");
if (crc32("PuKbtQhbR",9) == 2555562067) strcat(s, "i");
if (crc32("azSVK",5) == 99031867) strcat(s, "c");
if (crc32("YNEawbNguWMSGe",14) == 1722359771) strcat(s, "a");
if (crc32("iBGfMAZAd",9) == 1493576409) strcat(s, "D");
if (crc32("AkQRngUc",8) == 162760346) strcat(s, "l");
if (crc32("SELyGaokrcmqxvY",15) == 4123335088) strcat(s, "O");
if (crc32("QthSYRuHa",9) == 2639393473) strcat(s, "l");
if (crc32("jzpcjgVfmc",10) == 1919236073) strcat(s, "y");
    return s;
}

char *nondivisively_adverbs() {
    char *s = calloc(14);
    if (crc32("PXawFqmwmWY",11) == 2212128852) strcat(s, "n");
if (crc32("hUqapzmAT",9) == 2918768189) strcat(s, "o");
if (crc32("WrNXKpHUZqo",11) == 189875018) strcat(s, "n");
if (crc32("ZVRunSvi",8) == 1027724062) strcat(s, "M");
if (crc32("yHVijmLyuoFB",12) == 3976104227) strcat(s, "d");
if (crc32("yKZWdPCqnYYBNq",14) == 2931230804) strcat(s, "c");
if (crc32("dkKXO",5) == 2927214574) strcat(s, "i");
if (crc32("smLanYKVr",9) == 2598935745) strcat(s, "v");
if (crc32("gUDRTKtbHTgHf",13) == 4161489040) strcat(s, "i");
if (crc32("jtSqNJnFdUEMhmt",15) == 1733507464) strcat(s, "s");
if (crc32("RLdtnCEhKuLws",13) == 4021554399) strcat(s, "p");
if (crc32("pZWvHqzmfcJ",11) == 514348164) strcat(s, "i");
if (crc32("LasVYNuP",8) == 3612653518) strcat(s, "V");
if (crc32("gLEKG",5) == 2979444243) strcat(s, "v");
if (crc32("oefSoD",6) == 2678329759) strcat(s, "c");
if (crc32("FKqFsnBGKidT",12) == 3530573015) strcat(s, "e");
if (crc32("NmlhKzmQBroRie",14) == 1552586093) strcat(s, "l");
if (crc32("JjyiA",5) == 1920961794) strcat(s, "o");
if (crc32("RkKkLFl",7) == 330723447) strcat(s, "y");
    return s;
}

char *noncompetitively_adverbs() {
    char *s = calloc(17);
    if (crc32("iHCBpsBVaC",10) == 2700826667) strcat(s, "n");
if (crc32("yJogUORGRPU",11) == 3151813604) strcat(s, "I");
if (crc32("gzVBgvvumHC",11) == 3079704136) strcat(s, "o");
if (crc32("IbZCvoXkYsijlYR",15) == 3238042903) strcat(s, "l");
if (crc32("OpcOWBIBCRy",11) == 1589225338) strcat(s, "n");
if (crc32("wkqRorjiuOeMY",13) == 323179860) strcat(s, "M");
if (crc32("BOJSgfhO",8) == 3427092222) strcat(s, "c");
if (crc32("xxSqXxrSfwI",11) == 1863889283) strcat(s, "o");
if (crc32("xQOZUEgHl",9) == 1185772885) strcat(s, "m");
if (crc32("geKARKXrgNAXocD",15) == 1594222771) strcat(s, "a");
if (crc32("vToBisIocND",11) == 3580476868) strcat(s, "p");
if (crc32("tvvgczBBWbFbWg",14) == 105839044) strcat(s, "a");
if (crc32("QAJnIT",6) == 3906876634) strcat(s, "e");
if (crc32("qtKQmueGHTbFetA",15) == 1631783526) strcat(s, "t");
if (crc32("MoQEI",5) == 3933506115) strcat(s, "i");
if (crc32("jyAwuFTfLS",10) == 3728467772) strcat(s, "f");
if (crc32("LTTSsf",6) == 2392712443) strcat(s, "t");
if (crc32("jsYeKFEseULI",12) == 168661746) strcat(s, "i");
if (crc32("lYsIux",6) == 3468278326) strcat(s, "U");
if (crc32("hcZwHAM",7) == 2962780246) strcat(s, "v");
if (crc32("NupTqYsvDAXRNzO",15) == 1240461067) strcat(s, "r");
if (crc32("QiJHvNW",7) == 2959073771) strcat(s, "e");
if (crc32("fmCkhaJFyb",10) == 2876825745) strcat(s, "u");
if (crc32("BpCmDo",6) == 2318840675) strcat(s, "l");
if (crc32("QrmcW",5) == 4139837417) strcat(s, "p");
if (crc32("yOiQM",5) == 492608607) strcat(s, "y");
    return s;
}

char *salutarily_adverbs() {
    char *s = calloc(11);
    if (crc32("zbmwCBVFqLoyUq",14) == 220620195) strcat(s, "S");
if (crc32("OIIBJMuBsN",10) == 2942682817) strcat(s, "s");
if (crc32("jNfKyiXVRyVdu",13) == 2027140787) strcat(s, "a");
if (crc32("JzhpTWQiy",9) == 1217338573) strcat(s, "l");
if (crc32("hBDxVupASB",10) == 864338839) strcat(s, "h");
if (crc32("XYURJVdcSPl",11) == 754284798) strcat(s, "u");
if (crc32("WsbDbrLa",8) == 2938989993) strcat(s, "t");
if (crc32("IvEpPFYvDQ",10) == 984938582) strcat(s, "a");
if (crc32("oQZYDXCsWMk",11) == 1830101042) strcat(s, "p");
if (crc32("NoRPdtLovlV",11) == 3437754234) strcat(s, "r");
if (crc32("GZXivXtXzw",10) == 2821065204) strcat(s, "i");
if (crc32("UtLxTYeDdke",11) == 2560296417) strcat(s, "f");
if (crc32("PqqaPk",6) == 2209604417) strcat(s, "l");
if (crc32("sLDqw",5) == 370089919) strcat(s, "H");
if (crc32("NfSHmRGMugloxYt",15) == 3665092062) strcat(s, "y");
    return s;
}

char *uncurrently_adverbs() {
    char *s = calloc(12);
    if (crc32("Sdkput",6) == 3865102062) strcat(s, "i");
if (crc32("xcLDDbc",7) == 2971490879) strcat(s, "u");
if (crc32("CDSkue",6) == 3724750297) strcat(s, "f");
if (crc32("zKLwLHsOhos",11) == 4285245272) strcat(s, "n");
if (crc32("IgrMocrQTVc",11) == 2828403487) strcat(s, "o");
if (crc32("UVoFvqhYHQRZ",12) == 51054856) strcat(s, "c");
if (crc32("ykcnghdgAfFFkDJ",15) == 3560214860) strcat(s, "D");
if (crc32("cvUdYyMgQoDCkw",14) == 1748587615) strcat(s, "u");
if (crc32("cECzCmUrq",9) == 2837848525) strcat(s, "Q");
if (crc32("NnJmlKskev",10) == 1771384946) strcat(s, "r");
if (crc32("kOhRgElsNmn",11) == 3018501711) strcat(s, "r");
if (crc32("xNDIMsCnjwVVmDs",15) == 3817414012) strcat(s, "S");
if (crc32("vangqueBIdUssqr",15) == 233787034) strcat(s, "e");
if (crc32("ZqqxRq",6) == 753420111) strcat(s, "M");
if (crc32("pCROMDmZX",9) == 704787883) strcat(s, "n");
if (crc32("mYlCBhOzvzeNcF",14) == 3973014109) strcat(s, "I");
if (crc32("qYTCeCeNxQlJBs",14) == 3779165318) strcat(s, "t");
if (crc32("UERFRFhMK",9) == 3427493235) strcat(s, "l");
if (crc32("LVRnu",5) == 2598771406) strcat(s, "L");
if (crc32("ZDsFfeAhCqhD",12) == 3652576464) strcat(s, "y");
    return s;
}

char *broadly_adverbs() {
    char *s = calloc(8);
    if (crc32("lHbGvVXB",8) == 4139262249) strcat(s, "b");
if (crc32("dIMuqrRNe",9) == 3642096311) strcat(s, "V");
if (crc32("YbkCWLKPjhIn",12) == 76393492) strcat(s, "r");
if (crc32("MqUstqYeI",9) == 4265814672) strcat(s, "o");
if (crc32("ieBtXKMoJTzWe",13) == 1842509098) strcat(s, "Q");
if (crc32("aXpaDQzUkxfGSd",14) == 2209697524) strcat(s, "a");
if (crc32("DlFjAnoEO",9) == 1159896614) strcat(s, "y");
if (crc32("lIgjvUdpBUxB",12) == 1422231700) strcat(s, "d");
if (crc32("XWgrEnIdYVtU",12) == 2369694939) strcat(s, "l");
if (crc32("nlAzwcgrVnkYxni",15) == 4102091171) strcat(s, "y");
    return s;
}

char *garishly_adverbs() {
    char *s = calloc(9);
    if (crc32("wXImqKivVpm",11) == 2927217995) strcat(s, "g");
if (crc32("OkLBRssqiokAU",13) == 2824302697) strcat(s, "a");
if (crc32("xqqIjrYZko",10) == 4143079760) strcat(s, "r");
if (crc32("YUnQnNWvjuEPBD",14) == 3525224898) strcat(s, "A");
if (crc32("UgpyBELFSaoyNv",14) == 916770091) strcat(s, "i");
if (crc32("vXcahuBFaJtgzHn",15) == 3764720789) strcat(s, "s");
if (crc32("aLJafXdjcwTmXMS",15) == 3322437969) strcat(s, "P");
if (crc32("PohDK",5) == 2930464514) strcat(s, "h");
if (crc32("cDNnxVtAzrnC",12) == 3684089244) strcat(s, "l");
if (crc32("SnTsFYzB",8) == 865409419) strcat(s, "H");
if (crc32("HhDPCj",6) == 4117913716) strcat(s, "y");
    return s;
}

char *interpenetratively_adverbs() {
    char *s = calloc(19);
    if (crc32("YyazWkDIcrPmg",13) == 1527448540) strcat(s, "r");
if (crc32("YczfUQovW",9) == 3163199935) strcat(s, "i");
if (crc32("RijLlH",6) == 4176647081) strcat(s, "n");
if (crc32("jwIzVC",6) == 1395187977) strcat(s, "E");
if (crc32("WTacs",5) == 3333932486) strcat(s, "t");
if (crc32("LdEZzoSm",8) == 2890134303) strcat(s, "e");
if (crc32("vdXvJGAwo",9) == 620436959) strcat(s, "r");
if (crc32("lBvKQoNduOONNia",15) == 3854221727) strcat(s, "p");
if (crc32("JxDSrzGkb",9) == 1068426795) strcat(s, "e");
if (crc32("ifGKjoVeBUBeMr",14) == 3587366095) strcat(s, "n");
if (crc32("lxawpCcUJddmlcr",15) == 518522040) strcat(s, "e");
if (crc32("vyPDC",5) == 2986064383) strcat(s, "t");
if (crc32("yTchNnLLWcFlD",13) == 1092632896) strcat(s, "r");
if (crc32("FzNwS",5) == 4245378489) strcat(s, "a");
if (crc32("fTnyXfXuUcu",11) == 824423780) strcat(s, "t");
if (crc32("NaTaygkX",8) == 4289660386) strcat(s, "t");
if (crc32("RAPyEjkfvcYhS",13) == 934535291) strcat(s, "w");
if (crc32("JcLCW",5) == 2854830893) strcat(s, "i");
if (crc32("QdXSiZVixypNabN",15) == 1493448669) strcat(s, "s");
if (crc32("WIeeVZUTIxKD",12) == 3841448118) strcat(s, "v");
if (crc32("NDVXCQOI",8) == 2818254998) strcat(s, "e");
if (crc32("zGHsLXeEV",9) == 575861115) strcat(s, "I");
if (crc32("MmaYwqteXwU",11) == 2750960499) strcat(s, "l");
if (crc32("vQtsj",5) == 965535818) strcat(s, "y");
    return s;
}

char *quasicomplexly_adverbs() {
    char *s = calloc(15);
    if (crc32("cphAppzHucw",11) == 1983339948) strcat(s, "T");
if (crc32("qFkFGiOjhV",10) == 3535224040) strcat(s, "q");
if (crc32("qscuNXTPKh",10) == 2518484963) strcat(s, "u");
if (crc32("NoHHnKETZfi",11) == 2502732322) strcat(s, "Y");
if (crc32("hwRiXALhJtNH",12) == 3413658042) strcat(s, "a");
if (crc32("MHyoSGUsTyTWC",13) == 1490784546) strcat(s, "s");
if (crc32("hNGlP",5) == 3540804624) strcat(s, "f");
if (crc32("QykngsJRR",9) == 2836209186) strcat(s, "i");
if (crc32("GXUDcOnAmzh",11) == 1828959432) strcat(s, "L");
if (crc32("tSoaESLDvYBToX",14) == 2509989930) strcat(s, "c");
if (crc32("xXBIXQAyrkm",11) == 86034299) strcat(s, "o");
if (crc32("IhgBxgIBIlRUh",13) == 894044309) strcat(s, "m");
if (crc32("WCCJqvH",7) == 2819594249) strcat(s, "j");
if (crc32("cmdhJBIH",8) == 889977037) strcat(s, "p");
if (crc32("bNhHONIxRcKOh",13) == 4146774680) strcat(s, "l");
if (crc32("JpRtnd",6) == 1610220695) strcat(s, "i");
if (crc32("eifENG",6) == 2475129658) strcat(s, "e");
if (crc32("EUjuUOzYhySVf",13) == 2605430440) strcat(s, "x");
if (crc32("heAdpXruJz",10) == 2274047574) strcat(s, "l");
if (crc32("npffCWOtEpAyu",13) == 2002881255) strcat(s, "L");
if (crc32("iYUPMXXSCfILH",13) == 4271711631) strcat(s, "y");
    return s;
}

char *oversuperstitiously_adverbs() {
    char *s = calloc(20);
    if (crc32("UPtYQHyMRZdJn",13) == 4273105737) strcat(s, "j");
if (crc32("sdMAWVAfnJbZ",12) == 3719343898) strcat(s, "o");
if (crc32("SJNbJK",6) == 2070100545) strcat(s, "d");
if (crc32("vqnzgCt",7) == 831396249) strcat(s, "v");
if (crc32("FeRLrSdP",8) == 986303335) strcat(s, "n");
if (crc32("zKFrbU",6) == 2442719709) strcat(s, "e");
if (crc32("ICMvubExO",9) == 474230394) strcat(s, "r");
if (crc32("mqimTYja",8) == 2821653467) strcat(s, "s");
if (crc32("eFYeymQqTVaRUJV",15) == 2706965732) strcat(s, "h");
if (crc32("YzTwIZlD",8) == 2221986604) strcat(s, "u");
if (crc32("VbyFYI",6) == 2394844969) strcat(s, "p");
if (crc32("hatewrfFMfLKVg",14) == 2297698046) strcat(s, "W");
if (crc32("mnYxOyd",7) == 295638203) strcat(s, "e");
if (crc32("mBdmppR",7) == 1858635281) strcat(s, "r");
if (crc32("TxHjv",5) == 4257717561) strcat(s, "s");
if (crc32("AHSnypuo",8) == 677851965) strcat(s, "O");
if (crc32("NIwMbGIygeppa",13) == 2473230313) strcat(s, "t");
if (crc32("dULXQadwRySoa",13) == 1797054033) strcat(s, "F");
if (crc32("rPiGoIUlWle",11) == 4002203260) strcat(s, "i");
if (crc32("CfTOPlBQ",8) == 856266690) strcat(s, "t");
if (crc32("UZKVZfZoTHPWTuV",15) == 1593922495) strcat(s, "i");
if (crc32("ZvSBWmQs",8) == 4197222397) strcat(s, "o");
if (crc32("FptlPAHzzgHb",12) == 1860255144) strcat(s, "G");
if (crc32("PGVyGR",6) == 3632580534) strcat(s, "u");
if (crc32("BjUpbjfDkIu",11) == 1172797851) strcat(s, "s");
if (crc32("bBZMm",5) == 53658701) strcat(s, "l");
if (crc32("LVGDTYJwFTLJ",12) == 1582974697) strcat(s, "h");
if (crc32("IfyiAtQVQa",10) == 1236182887) strcat(s, "y");
    return s;
}

char *softly_adverbs() {
    char *s = calloc(7);
    if (crc32("EbWGa",5) == 3635903104) strcat(s, "H");
if (crc32("BwtqoS",6) == 432632977) strcat(s, "s");
if (crc32("HJYPPVNli",9) == 1279779202) strcat(s, "J");
if (crc32("uDlpFVMcish",11) == 287660011) strcat(s, "o");
if (crc32("WoqnoOTf",8) == 3284565863) strcat(s, "f");
if (crc32("KxiWiZRzvJH",11) == 1384659714) strcat(s, "m");
if (crc32("PQPJobOan",9) == 2812700013) strcat(s, "t");
if (crc32("ZPAPrkTxIsCVIgr",15) == 1360460561) strcat(s, "p");
if (crc32("uWQSfuYszGRYHl",14) == 1116698848) strcat(s, "l");
if (crc32("ZZAVlghDuwIGwxI",15) == 1404192389) strcat(s, "d");
if (crc32("FXDoSVBy",8) == 1331563876) strcat(s, "y");
    return s;
}

char *impolitely_adverbs() {
    char *s = calloc(11);
    if (crc32("JUDEPpxgsKqc",12) == 969612048) strcat(s, "i");
if (crc32("mzKYpTPWTuzTnkn",15) == 4060956493) strcat(s, "v");
if (crc32("pyaluSCqTntsnX",14) == 3288811624) strcat(s, "m");
if (crc32("ISGnqhYcSaFV",12) == 1186098419) strcat(s, "p");
if (crc32("GwTUHCr",7) == 2678600105) strcat(s, "H");
if (crc32("xnOLQp",6) == 971228869) strcat(s, "o");
if (crc32("zqcNtrQTw",9) == 3705595871) strcat(s, "l");
if (crc32("EwBqb",5) == 3642679123) strcat(s, "c");
if (crc32("oBponBbYlns",11) == 1960696188) strcat(s, "i");
if (crc32("RIPJRTX",7) == 429174942) strcat(s, "t");
if (crc32("NqbZIpSgp",9) == 3244719638) strcat(s, "D");
if (crc32("ACBISZcDXEm",11) == 1712650950) strcat(s, "e");
if (crc32("agXSxgxAS",9) == 2252986260) strcat(s, "y");
if (crc32("tLjFczkEmGa",11) == 269021456) strcat(s, "l");
if (crc32("iWmMJYwkEAmBa",13) == 799272956) strcat(s, "d");
if (crc32("TETAHbodCEPRVTX",15) == 3121389260) strcat(s, "y");
    return s;
}

char *insultingly_adverbs() {
    char *s = calloc(12);
    if (crc32("fIzVXkdfH",9) == 2697576115) strcat(s, "r");
if (crc32("jHNdyCHKFCYp",12) == 2848782920) strcat(s, "i");
if (crc32("LXXpcBxDXaBzk",13) == 1943530207) strcat(s, "Q");
if (crc32("swqXgO",6) == 175504259) strcat(s, "n");
if (crc32("kqLIWesBaB",10) == 2809032672) strcat(s, "F");
if (crc32("hRmvtFOdutlrJ",13) == 2548723047) strcat(s, "s");
if (crc32("fJFTyoSGU",9) == 2628628924) strcat(s, "u");
if (crc32("OcpziiXh",8) == 747612962) strcat(s, "q");
if (crc32("seyyGQteIxnU",12) == 1690576861) strcat(s, "l");
if (crc32("KlcgBCN",7) == 166116184) strcat(s, "G");
if (crc32("uEBtkPzR",8) == 156043325) strcat(s, "t");
if (crc32("CcpfzBolPp",10) == 4150484236) strcat(s, "i");
if (crc32("SswsvLwdphSI",12) == 873181628) strcat(s, "L");
if (crc32("gCMzqihlucQj",12) == 3095050138) strcat(s, "n");
if (crc32("QNFszHyOC",9) == 999044843) strcat(s, "g");
if (crc32("QJlvAyGZhyYwN",13) == 776008489) strcat(s, "Y");
if (crc32("QsYHKjgCUMPUsx",14) == 2794774276) strcat(s, "l");
if (crc32("bsqCcqFUZW",10) == 3241055097) strcat(s, "y");
    return s;
}

char *thirdly_adverbs() {
    char *s = calloc(8);
    if (crc32("JsuWyAePOI",10) == 1386980735) strcat(s, "L");
if (crc32("dtPRESPKPryUk",13) == 2506261287) strcat(s, "t");
if (crc32("kEghMtheqq",10) == 583268894) strcat(s, "h");
if (crc32("szDiOZHtWTl",11) == 3244228224) strcat(s, "i");
if (crc32("adHDUs",6) == 2711098735) strcat(s, "I");
if (crc32("CYsSy",5) == 2173469866) strcat(s, "r");
if (crc32("eiCAhbLmVwe",11) == 4184033084) strcat(s, "d");
if (crc32("YFRpfWnJVxcvrx",14) == 2909911979) strcat(s, "l");
if (crc32("LtTPiAxVJxfIxtf",15) == 2659304658) strcat(s, "y");
    return s;
}

char *unmutually_adverbs() {
    char *s = calloc(11);
    if (crc32("mXOEBNBmMIu",11) == 2086278305) strcat(s, "z");
if (crc32("CWhjFFAJvsX",11) == 2269858687) strcat(s, "u");
if (crc32("DAhRQUYdDLmk",12) == 158665397) strcat(s, "n");
if (crc32("TaKGc",5) == 4018756070) strcat(s, "J");
if (crc32("RARrZJLD",8) == 2798202140) strcat(s, "m");
if (crc32("BaFpLUDJnuLZE",13) == 3860802709) strcat(s, "y");
if (crc32("KytCmQ",6) == 2049026408) strcat(s, "u");
if (crc32("zzOAvFLFyhE",11) == 2041634570) strcat(s, "O");
if (crc32("DGknlVpZXlbjx",13) == 286203112) strcat(s, "t");
if (crc32("YyNOaoGFZEanik",14) == 2210625310) strcat(s, "A");
if (crc32("qJWGLuMXkJBIarZ",15) == 2452334154) strcat(s, "u");
if (crc32("yurHxZwFWY",10) == 974388767) strcat(s, "a");
if (crc32("teFFxXo",7) == 1093897690) strcat(s, "l");
if (crc32("UNYtsREz",8) == 947571756) strcat(s, "I");
if (crc32("oBBayBSlesxtM",13) == 563702923) strcat(s, "l");
if (crc32("VcsSrWtbeFzblCT",15) == 3857876284) strcat(s, "J");
if (crc32("UhkTdOjRbeXYaRL",15) == 376970916) strcat(s, "y");
    return s;
}

char *intradermically_adverbs() {
    char *s = calloc(16);
    if (crc32("zAQJNjvybvc",11) == 2829939580) strcat(s, "T");
if (crc32("dnmOHm",6) == 3180075016) strcat(s, "i");
if (crc32("BObWh",5) == 3668347368) strcat(s, "n");
if (crc32("yyQxZxnGtb",10) == 3671307020) strcat(s, "v");
if (crc32("MrfrvEOD",8) == 3483889815) strcat(s, "t");
if (crc32("fHRskRMb",8) == 107785364) strcat(s, "H");
if (crc32("vlpHsDbdl",9) == 1230342852) strcat(s, "r");
if (crc32("DYWdfMHPSVJBWpX",15) == 130607934) strcat(s, "K");
if (crc32("GQGipHjuPTSrHvc",15) == 3464647128) strcat(s, "a");
if (crc32("RrNRGYWruIOpO",13) == 640109402) strcat(s, "C");
if (crc32("QIiCUspdb",9) == 1572167911) strcat(s, "d");
if (crc32("NJwJTbX",7) == 3238931033) strcat(s, "e");
if (crc32("wPdWgSEnAX",10) == 47210069) strcat(s, "q");
if (crc32("dXoNKSxYjLBoGVn",15) == 2019471233) strcat(s, "r");
if (crc32("DXREIHFuXY",10) == 1454821924) strcat(s, "g");
if (crc32("RXdMBOCoDHoyRoG",15) == 2980477835) strcat(s, "m");
if (crc32("THUArQKXnBCoW",13) == 454602173) strcat(s, "i");
if (crc32("VCqXCyQrRRyCcE",14) == 2538171047) strcat(s, "c");
if (crc32("ROqmoCbqsmUA",12) == 1488343627) strcat(s, "a");
if (crc32("OjjoGcSGpM",10) == 2884755863) strcat(s, "R");
if (crc32("Grhssirut",9) == 761870174) strcat(s, "l");
if (crc32("WTIHCCRtzJeRh",13) == 2245106811) strcat(s, "n");
if (crc32("bqGkBzRTDjcBFoZ",15) == 3671721325) strcat(s, "l");
if (crc32("TqYimUOosI",10) == 798831425) strcat(s, "y");
    return s;
}

char *hastefully_adverbs() {
    char *s = calloc(11);
    if (crc32("CygBXMuAYUSpPul",15) == 2827586571) strcat(s, "h");
if (crc32("UFnqsEEwdVmS",12) == 399087573) strcat(s, "h");
if (crc32("bpiHK",5) == 3494370838) strcat(s, "a");
if (crc32("iuAsKBWhErskxsU",15) == 2214257473) strcat(s, "s");
if (crc32("nPWaccOouUCDwY",14) == 3909330813) strcat(s, "R");
if (crc32("lLWWElKRBXgA",12) == 3050713732) strcat(s, "t");
if (crc32("wyaJtrwpkyecL",13) == 1928486059) strcat(s, "T");
if (crc32("pFQEXTBxLqmIYJ",14) == 3764420170) strcat(s, "e");
if (crc32("HyYIfIQWfVT",11) == 3740594039) strcat(s, "Q");
if (crc32("NKorQH",6) == 1143233851) strcat(s, "f");
if (crc32("gavVdAzPSOs",11) == 391177469) strcat(s, "A");
if (crc32("YRNWoPBvj",9) == 1563935221) strcat(s, "u");
if (crc32("ZMdqxOoERc",10) == 137299975) strcat(s, "l");
if (crc32("ymTvMkTmVAh",11) == 169104251) strcat(s, "k");
if (crc32("ZCgHHiJZhYjG",12) == 1713440313) strcat(s, "l");
if (crc32("RnPiZi",6) == 783766108) strcat(s, "y");
    return s;
}

char *hungrily_adverbs() {
    char *s = calloc(9);
    if (crc32("ZrQWkHPBGe",10) == 3696510925) strcat(s, "h");
if (crc32("jHsCgmIOp",9) == 998335618) strcat(s, "u");
if (crc32("lxGlWfPjwqhzRQi",15) == 3656163805) strcat(s, "N");
if (crc32("ImwGV",5) == 906211629) strcat(s, "n");
if (crc32("tCFpns",6) == 1703865289) strcat(s, "V");
if (crc32("NqpvMxvFbkbVWT",14) == 2831255939) strcat(s, "g");
if (crc32("sEijCeIAJw",10) == 3999196019) strcat(s, "N");
if (crc32("gqyQfwTsGqoD",12) == 2713989849) strcat(s, "r");
if (crc32("ItBFavQ",7) == 1813820110) strcat(s, "i");
if (crc32("sImiR",5) == 4011442928) strcat(s, "l");
if (crc32("rlhXkGMWGsME",12) == 3290281400) strcat(s, "y");
    return s;
}

char *unweariedly_adverbs() {
    char *s = calloc(12);
    if (crc32("SOQknflXh",9) == 285083923) strcat(s, "h");
if (crc32("bycjHZDm",8) == 1264825119) strcat(s, "u");
if (crc32("ELkbDbcmNXdKLu",14) == 1129623820) strcat(s, "m");
if (crc32("CrveLCfkrEu",11) == 3339032778) strcat(s, "n");
if (crc32("RNezDwQP",8) == 2224195147) strcat(s, "u");
if (crc32("tVqVUWIeG",9) == 1637336701) strcat(s, "w");
if (crc32("vxxjmEMxTnaTt",13) == 1832608232) strcat(s, "e");
if (crc32("leSLIayZO",9) == 2241651106) strcat(s, "a");
if (crc32("DSCpNuDcg",9) == 2443743136) strcat(s, "r");
if (crc32("mUeJFr",6) == 1008183189) strcat(s, "o");
if (crc32("KCCxsrQhk",9) == 3929031618) strcat(s, "i");
if (crc32("lfTYGaBcGYF",11) == 2421430394) strcat(s, "K");
if (crc32("XYlZbyJuE",9) == 1491069356) strcat(s, "e");
if (crc32("BZsnlJaF",8) == 238659252) strcat(s, "g");
if (crc32("kykhDdUACygFK",13) == 2408533696) strcat(s, "d");
if (crc32("ZSSDpkr",7) == 555451017) strcat(s, "A");
if (crc32("hXrWVhllPW",10) == 3962288850) strcat(s, "l");
if (crc32("eAAPogRKDSs",11) == 4000532734) strcat(s, "y");
    return s;
}

char *overpessimistically_adverbs() {
    char *s = calloc(20);
    if (crc32("yvsADQ",6) == 4126805665) strcat(s, "u");
if (crc32("MfJIJFTMFDPTD",13) == 2768229553) strcat(s, "o");
if (crc32("RoEpzfNg",8) == 1550585300) strcat(s, "v");
if (crc32("JLrzmrtPqfmzkCo",15) == 3981655964) strcat(s, "D");
if (crc32("cUaWMiizGUGLHaR",15) == 540344073) strcat(s, "e");
if (crc32("jYMCNTxKka",10) == 2868689117) strcat(s, "r");
if (crc32("FLaQXacQQ",9) == 1159440343) strcat(s, "t");
if (crc32("fSphdvQ",7) == 3532078901) strcat(s, "p");
if (crc32("jVwbCdOae",9) == 1091691040) strcat(s, "e");
if (crc32("UUOfHngbDFHPi",13) == 1846941942) strcat(s, "s");
if (crc32("kPqMLDco",8) == 1302194436) strcat(s, "o");
if (crc32("UAmcSmooVNEjR",13) == 894762450) strcat(s, "s");
if (crc32("zHENZPfhdgPj",12) == 3376217520) strcat(s, "i");
if (crc32("XbtcfSSSnEwFEGg",15) == 2522350996) strcat(s, "A");
if (crc32("OwnLgrhdDoJJ",12) == 4212987170) strcat(s, "m");
if (crc32("WzNNUucHJc",10) == 296388596) strcat(s, "i");
if (crc32("lRlqsknd",8) == 1627479174) strcat(s, "s");
if (crc32("fTNKwnlXIxHvOQr",15) == 3207803472) strcat(s, "c");
if (crc32("mLfsYgJgAEJPNuD",15) == 1668143720) strcat(s, "t");
if (crc32("bswGgYwvwHGF",12) == 3526010063) strcat(s, "i");
if (crc32("wOAFVTUxgUwRC",13) == 2851679375) strcat(s, "c");
if (crc32("ZbNoMjIlvoNUGaP",15) == 1358545437) strcat(s, "m");
if (crc32("pdKMk",5) == 1758239807) strcat(s, "a");
if (crc32("tKFIQSvU",8) == 4177080812) strcat(s, "l");
if (crc32("rYOjVeHnjZdu",12) == 4288449539) strcat(s, "u");
if (crc32("gDDDE",5) == 477530408) strcat(s, "l");
if (crc32("aBCWlCMIrA",10) == 103387115) strcat(s, "y");
    return s;
}

char *connectedly_adverbs() {
    char *s = calloc(12);
    if (crc32("tpJXfjFqM",9) == 4010255912) strcat(s, "c");
if (crc32("dAELckMujXZ",11) == 2293689813) strcat(s, "o");
if (crc32("ETdYVxB",7) == 3865438473) strcat(s, "N");
if (crc32("QUqKRjD",7) == 1303465472) strcat(s, "n");
if (crc32("XIbHeRFU",8) == 3241085566) strcat(s, "n");
if (crc32("cspZRkG",7) == 1203985154) strcat(s, "x");
if (crc32("RmnxiwRLCHCN",12) == 867606198) strcat(s, "e");
if (crc32("vmCMXWkXICqILu",14) == 382498547) strcat(s, "c");
if (crc32("deTBgfiQMrxUUA",14) == 2184477043) strcat(s, "t");
if (crc32("dwPcLsdEUBrPPfV",15) == 3252346323) strcat(s, "e");
if (crc32("VQoesIz",7) == 3987864109) strcat(s, "Q");
if (crc32("mMOsPBCd",8) == 1660203927) strcat(s, "d");
if (crc32("PzTfkrWqDF",10) == 1874059063) strcat(s, "x");
if (crc32("JQscy",5) == 2523855047) strcat(s, "l");
if (crc32("yFrJUqWtWbVvRXD",15) == 110353504) strcat(s, "y");
    return s;
}

char *illiberally_adverbs() {
    char *s = calloc(12);
    if (crc32("qHPMmRqvYGS",11) == 1422905158) strcat(s, "p");
if (crc32("KSvSDSoJDn",10) == 2099271379) strcat(s, "i");
if (crc32("yLheboFjPx",10) == 1257524731) strcat(s, "l");
if (crc32("WsgNYXBkvQNqJP",14) == 3040411496) strcat(s, "l");
if (crc32("SSSniWlCH",9) == 1994048831) strcat(s, "i");
if (crc32("DTIXFmvTkuQfyPG",15) == 718329984) strcat(s, "O");
if (crc32("fxZufkjfOZG",11) == 2701432450) strcat(s, "b");
if (crc32("tcqQu",5) == 891224638) strcat(s, "e");
if (crc32("GiSqiFDlFzVaUJk",15) == 742633833) strcat(s, "b");
if (crc32("jbvvzW",6) == 3316127547) strcat(s, "r");
if (crc32("sjipmbPXws",10) == 1128116696) strcat(s, "a");
if (crc32("TDeAw",5) == 2922082913) strcat(s, "c");
if (crc32("gCHIAzVhqxZH",12) == 4167161363) strcat(s, "l");
if (crc32("apgXUybhU",9) == 3024034847) strcat(s, "l");
if (crc32("MrNmWE",6) == 1191272819) strcat(s, "H");
if (crc32("BZPPInEQvsrV",12) == 3330668728) strcat(s, "y");
    return s;
}

char *lithologically_adverbs() {
    char *s = calloc(15);
    if (crc32("QWqTq",5) == 963509728) strcat(s, "l");
if (crc32("jehgzi",6) == 466304875) strcat(s, "i");
if (crc32("ZWOblkkQ",8) == 4116563134) strcat(s, "t");
if (crc32("PgfCTjitNzVc",12) == 185347951) strcat(s, "D");
if (crc32("OHrnknIUwk",10) == 2932453033) strcat(s, "h");
if (crc32("kXMgvUdBv",9) == 1877238536) strcat(s, "O");
if (crc32("bivZIsY",7) == 359814051) strcat(s, "o");
if (crc32("OQwlMAtfIkAq",12) == 2483775496) strcat(s, "l");
if (crc32("yPpnivCmQUIZd",13) == 3899944801) strcat(s, "o");
if (crc32("PrEeGTgMQZXQAN",14) == 117944131) strcat(s, "U");
if (crc32("NWbEnVH",7) == 21278829) strcat(s, "g");
if (crc32("oVMwDOje",8) == 839240839) strcat(s, "S");
if (crc32("MALGrXvKsNFMITO",15) == 3028278761) strcat(s, "i");
if (crc32("wPtSzXEZzG",10) == 1006514915) strcat(s, "I");
if (crc32("qydbBku",7) == 3552303260) strcat(s, "c");
if (crc32("QjwCW",5) == 3000570913) strcat(s, "f");
if (crc32("plqMVeYOjbZ",11) == 2084790215) strcat(s, "a");
if (crc32("jHBIQrEJkKMs",12) == 27479791) strcat(s, "q");
if (crc32("aeaPWD",6) == 1221948845) strcat(s, "l");
if (crc32("BJJBZgHygIEV",12) == 2702488365) strcat(s, "l");
if (crc32("uDWVlIf",7) == 1136653318) strcat(s, "L");
if (crc32("lpZltg",6) == 1256070086) strcat(s, "y");
    return s;
}

char *nondeterminatively_adverbs() {
    char *s = calloc(19);
    if (crc32("RoiVqNIpJ",9) == 2176115063) strcat(s, "P");
if (crc32("CXThEhMFrUE",11) == 3638120202) strcat(s, "n");
if (crc32("emEiimewUfHjbkF",15) == 4131942396) strcat(s, "o");
if (crc32("XSEdk",5) == 3126430211) strcat(s, "n");
if (crc32("MPmUsbQDO",9) == 444956745) strcat(s, "d");
if (crc32("UxlFzpuKgbCHxFN",15) == 4220543451) strcat(s, "e");
if (crc32("BNGFDjAjkpYZc",13) == 1111901360) strcat(s, "r");
if (crc32("nMROZUlgLPRjnL",14) == 1188260279) strcat(s, "t");
if (crc32("ycAjzF",6) == 1041939854) strcat(s, "X");
if (crc32("TEFbNPEypcsV",12) == 296216428) strcat(s, "e");
if (crc32("LeNwT",5) == 448210658) strcat(s, "c");
if (crc32("xpKJrYiIznxlBt",14) == 63903241) strcat(s, "r");
if (crc32("MMkFLCVRIuotRu",14) == 2143577990) strcat(s, "m");
if (crc32("YRsrWV",6) == 2174609449) strcat(s, "i");
if (crc32("HvTApIu",7) == 24321628) strcat(s, "i");
if (crc32("zJmNcfqim",9) == 4131041239) strcat(s, "n");
if (crc32("UZlHVvBlFAE",11) == 210659642) strcat(s, "U");
if (crc32("NzVjr",5) == 1816891634) strcat(s, "a");
if (crc32("CWcYoQnyylkBr",13) == 3220407334) strcat(s, "d");
if (crc32("pYdWQIwk",8) == 3498915171) strcat(s, "t");
if (crc32("nVfDkrebAzWHKr",14) == 531579802) strcat(s, "i");
if (crc32("NnWrnhzYl",9) == 992687465) strcat(s, "v");
if (crc32("hDGUJwbLmwXa",12) == 2279628404) strcat(s, "a");
if (crc32("BFlSnr",6) == 2124294470) strcat(s, "e");
if (crc32("mebkphOZTUXPWm",14) == 999417668) strcat(s, "s");
if (crc32("SXtmUUccJrCIJSQ",15) == 1386402192) strcat(s, "l");
if (crc32("npHTJM",6) == 3345129867) strcat(s, "O");
if (crc32("wopvR",5) == 1181002351) strcat(s, "y");
    return s;
}

char *sippingly_adverbs() {
    char *s = calloc(10);
    if (crc32("kVKnteHKACpkSyZ",15) == 42146896) strcat(s, "s");
if (crc32("npgjieKDj",9) == 3645876679) strcat(s, "e");
if (crc32("CcfOD",5) == 3135827128) strcat(s, "i");
if (crc32("VdoKCVzoVQPbmY",14) == 3678446824) strcat(s, "B");
if (crc32("EIKgrvUNnx",10) == 3233932486) strcat(s, "p");
if (crc32("MVKIBVwOQCJTbSp",15) == 1202856849) strcat(s, "p");
if (crc32("IiOyxTLdqEXbmFV",15) == 439653442) strcat(s, "i");
if (crc32("eONtEKdCSPXsxG",14) == 886991362) strcat(s, "n");
if (crc32("oZeLRHa",7) == 2696591686) strcat(s, "g");
if (crc32("xJOJzvw",7) == 3080311239) strcat(s, "i");
if (crc32("gLvkBKb",7) == 4068330875) strcat(s, "l");
if (crc32("bxKfaUhNW",9) == 4130891588) strcat(s, "y");
    return s;
}

char *destructively_adverbs() {
    char *s = calloc(14);
    if (crc32("KiQhvSuEuwOZBxI",15) == 3379823656) strcat(s, "d");
if (crc32("YkbwolqUUYFbFxJ",15) == 960579688) strcat(s, "e");
if (crc32("ohUlYKNk",8) == 442345893) strcat(s, "v");
if (crc32("iVjAXanleCrKTTP",15) == 231543441) strcat(s, "s");
if (crc32("AFWED",5) == 2290255865) strcat(s, "t");
if (crc32("MvViZbeKyyXi",12) == 596303403) strcat(s, "r");
if (crc32("iQRnB",5) == 787944160) strcat(s, "V");
if (crc32("ChiLqjQEcjTf",12) == 3443773267) strcat(s, "u");
if (crc32("hcPyKSDq",8) == 3049667624) strcat(s, "c");
if (crc32("cFziqQGTEfxy",12) == 527862972) strcat(s, "t");
if (crc32("apXZLQoOUej",11) == 1108272827) strcat(s, "i");
if (crc32("MULEIB",6) == 480466108) strcat(s, "O");
if (crc32("zFlaZZpNh",9) == 1287239676) strcat(s, "v");
if (crc32("MpeWqRQDXSvzT",13) == 2108156292) strcat(s, "Y");
if (crc32("PaCWYUbEMF",10) == 3062027556) strcat(s, "e");
if (crc32("qXZNOdop",8) == 1643973069) strcat(s, "l");
if (crc32("xqWZfogfMMS",11) == 3212658888) strcat(s, "U");
if (crc32("ApxNw",5) == 855087492) strcat(s, "y");
    return s;
}

char *untopographically_adverbs() {
    char *s = calloc(18);
    if (crc32("cUnBSdPszazDGe",14) == 3126908363) strcat(s, "F");
if (crc32("rTHnHqHjs",9) == 1069415511) strcat(s, "u");
if (crc32("gkuhxghdDkVRL",13) == 253779913) strcat(s, "w");
if (crc32("wxsolMD",7) == 4216210872) strcat(s, "n");
if (crc32("Waapg",5) == 4110820940) strcat(s, "Y");
if (crc32("JxKDNnoTvF",10) == 413198559) strcat(s, "t");
if (crc32("mMoHfJCv",8) == 2604906683) strcat(s, "o");
if (crc32("hlfXBUiBgoXGc",13) == 2484689581) strcat(s, "p");
if (crc32("KGOlKUwiFxz",11) == 1095594194) strcat(s, "F");
if (crc32("IChXlYNvVZvgFyx",15) == 3001194219) strcat(s, "o");
if (crc32("vQTiSMVPKpIn",12) == 3326687888) strcat(s, "g");
if (crc32("QRBswSJPTTCpjhc",15) == 2429719196) strcat(s, "h");
if (crc32("UQVmuVxYrYo",11) == 2218752448) strcat(s, "r");
if (crc32("IYOkhHf",7) == 2440918025) strcat(s, "c");
if (crc32("PIQfOV",6) == 581823282) strcat(s, "a");
if (crc32("OchKHosavIH",11) == 3247975590) strcat(s, "F");
if (crc32("JGJJXhj",7) == 3947635149) strcat(s, "p");
if (crc32("BDsqhgKm",8) == 1683911905) strcat(s, "h");
if (crc32("JvjPXRGHLK",10) == 3717428714) strcat(s, "L");
if (crc32("vRbDBwaFwsQL",12) == 3974460793) strcat(s, "i");
if (crc32("XSdMrekE",8) == 3444536107) strcat(s, "c");
if (crc32("CiGTzQtxRX",10) == 3551319031) strcat(s, "h");
if (crc32("KBUomYpqrt",10) == 3767059354) strcat(s, "a");
if (crc32("FaCXFVwQabPsEQb",15) == 3433062836) strcat(s, "l");
if (crc32("OOQzj",5) == 3393138003) strcat(s, "l");
if (crc32("ytXTCGSbIkNSnfV",15) == 2888473034) strcat(s, "y");
    return s;
}

char *electrodiagnostically_adverbs() {
    char *s = calloc(22);
    if (crc32("BnvKr",5) == 182204932) strcat(s, "G");
if (crc32("ZALMo",5) == 1987257866) strcat(s, "e");
if (crc32("JWXTX",5) == 1534312048) strcat(s, "l");
if (crc32("JbfiVbx",7) == 2010767074) strcat(s, "I");
if (crc32("ikqwvGaPFdSL",12) == 1072129749) strcat(s, "e");
if (crc32("EendEVnIxlImqkn",15) == 232316481) strcat(s, "c");
if (crc32("yZWQshhHX",9) == 75186661) strcat(s, "t");
if (crc32("wtmiiQpzyrqKY",13) == 1727036605) strcat(s, "K");
if (crc32("mvGzSFkdtiNKfLq",15) == 641477352) strcat(s, "r");
if (crc32("eRPeDIZRhCuS",12) == 240676055) strcat(s, "u");
if (crc32("pltFLyLxz",9) == 4115282656) strcat(s, "o");
if (crc32("zEiGasqDvGDcjt",14) == 2295520631) strcat(s, "C");
if (crc32("jZsvPsNFeWiBz",13) == 3727307718) strcat(s, "d");
if (crc32("WChmpiUDdZoCiJm",15) == 1709241786) strcat(s, "i");
if (crc32("RhggwhJPSSUpglu",15) == 1403174563) strcat(s, "b");
if (crc32("wMRLJnlBw",9) == 2296013955) strcat(s, "a");
if (crc32("nmiJGHhDoiXed",13) == 3253284546) strcat(s, "Q");
if (crc32("MiOlDCeI",8) == 444119475) strcat(s, "g");
if (crc32("cfEhGHAaEHYpk",13) == 1469174446) strcat(s, "a");
if (crc32("aSbHCRpALHjab",13) == 2481501805) strcat(s, "n");
if (crc32("TqhBvpqXCppLjq",14) == 2283779545) strcat(s, "w");
if (crc32("xmQtgCTxfObHLjG",15) == 789097893) strcat(s, "o");
if (crc32("RKCIt",5) == 3438003834) strcat(s, "s");
if (crc32("aQoemgWVkcImv",13) == 925716366) strcat(s, "q");
if (crc32("EIrxSYaBDsaHaPN",15) == 412689995) strcat(s, "t");
if (crc32("SdouEMb",7) == 3415060285) strcat(s, "i");
if (crc32("PyyPcWGgz",9) == 2868747952) strcat(s, "g");
if (crc32("gYjsnXnLSM",10) == 2482297753) strcat(s, "c");
if (crc32("uythnvj",7) == 1805276420) strcat(s, "a");
if (crc32("KFLHMQxTJc",10) == 129371604) strcat(s, "b");
if (crc32("VFAsFFEOUA",10) == 3709211212) strcat(s, "l");
if (crc32("zGcEObaeFaIHqwn",15) == 3133930015) strcat(s, "l");
if (crc32("dbTUIZoJmWrWge",14) == 1142483505) strcat(s, "F");
if (crc32("NMILbz",6) == 1551148115) strcat(s, "y");
    return s;
}

char *composedly_adverbs() {
    char *s = calloc(11);
    if (crc32("BbCaEELj",8) == 2807987755) strcat(s, "T");
if (crc32("LlxDQBCABx",10) == 2468557425) strcat(s, "c");
if (crc32("PLbgtNmPmhiGnL",14) == 1192166106) strcat(s, "o");
if (crc32("kpRlMBZ",7) == 3286418682) strcat(s, "s");
if (crc32("mUJCaUJm",8) == 1053385175) strcat(s, "m");
if (crc32("YnBPX",5) == 3495227880) strcat(s, "O");
if (crc32("OLWEliQuXKhkrqd",15) == 322866607) strcat(s, "p");
if (crc32("XqirKSarXDwqC",13) == 1109949777) strcat(s, "o");
if (crc32("vgxHyzHZvpw",11) == 3095360382) strcat(s, "M");
if (crc32("HnGaFxeiwQZgrRr",15) == 3210808900) strcat(s, "s");
if (crc32("EfbZmJmu",8) == 2561446698) strcat(s, "f");
if (crc32("pTJHMb",6) == 456691828) strcat(s, "e");
if (crc32("sMPPijdG",8) == 1493973559) strcat(s, "Q");
if (crc32("nRBVHALUhtKUYC",14) == 2987937942) strcat(s, "d");
if (crc32("zvPssdwwDDmQ",12) == 2826355629) strcat(s, "h");
if (crc32("biRbB",5) == 3286219006) strcat(s, "l");
if (crc32("yNhJLgbrQMR",11) == 674184914) strcat(s, "y");
    return s;
}

char *inharmoniously_adverbs() {
    char *s = calloc(15);
    if (crc32("DfNylmdfoO",10) == 676796831) strcat(s, "v");
if (crc32("yAAkapWuYDKyd",13) == 341826282) strcat(s, "i");
if (crc32("nQjPyhEUzth",11) == 55808288) strcat(s, "n");
if (crc32("eUkHq",5) == 805523670) strcat(s, "h");
if (crc32("qIsOZCnftR",10) == 2003296400) strcat(s, "Q");
if (crc32("GQrFPdDeEise",12) == 3840440809) strcat(s, "a");
if (crc32("ZYMJtNtC",8) == 2473064851) strcat(s, "e");
if (crc32("hMjXA",5) == 820487133) strcat(s, "r");
if (crc32("ApszhGx",7) == 1776340161) strcat(s, "m");
if (crc32("FjymquxlzfiFc",13) == 1248267867) strcat(s, "o");
if (crc32("tzHnwoUKGCZLzuq",15) == 2041366636) strcat(s, "n");
if (crc32("FprJhLbYb",9) == 1124520138) strcat(s, "N");
if (crc32("PHmKKkXIKWHDrJU",15) == 1830979500) strcat(s, "i");
if (crc32("nkcPJoIdRiyhnf",14) == 2389902076) strcat(s, "e");
if (crc32("YdGFprWpFGiz",12) == 459241830) strcat(s, "o");
if (crc32("zNkTtslcyHa",11) == 2615663211) strcat(s, "y");
if (crc32("yDShPNgCyAPGW",13) == 1516590595) strcat(s, "u");
if (crc32("xZpoqOHbrKCagos",15) == 1220632553) strcat(s, "s");
if (crc32("cTeEe",5) == 3939613689) strcat(s, "Z");
if (crc32("UwhbYuHBjo",10) == 1111526844) strcat(s, "l");
if (crc32("YlPyIvWpRRZZG",13) == 3248443230) strcat(s, "y");
    return s;
}

char *alliteratively_adverbs() {
    char *s = calloc(15);
    if (crc32("KMIcbAkK",8) == 3980932684) strcat(s, "x");
if (crc32("ktVTnPlTipAvCZ",14) == 1804056181) strcat(s, "a");
if (crc32("RiHagaFTkw",10) == 1744740967) strcat(s, "H");
if (crc32("Pqucs",5) == 4166274422) strcat(s, "l");
if (crc32("mRSKsjG",7) == 619753623) strcat(s, "l");
if (crc32("YbNKXcJrU",9) == 2171132464) strcat(s, "i");
if (crc32("GCgYte",6) == 2491573062) strcat(s, "G");
if (crc32("ULYXFvwM",8) == 1589453292) strcat(s, "t");
if (crc32("NZGbhyjTArxCOtm",15) == 3969595280) strcat(s, "l");
if (crc32("bfYmy",5) == 2709172898) strcat(s, "e");
if (crc32("NCyBNgDUqq",10) == 2500486177) strcat(s, "r");
if (crc32("TOPBg",5) == 3051561393) strcat(s, "a");
if (crc32("EmdcuSDl",8) == 1103304993) strcat(s, "t");
if (crc32("uaQWFuxRNbvjUM",14) == 1051254341) strcat(s, "C");
if (crc32("cYyVzY",6) == 3015750869) strcat(s, "i");
if (crc32("yKPfUESLHig",11) == 2646297065) strcat(s, "M");
if (crc32("ZqhMhZhlFpjnYbW",15) == 1928133242) strcat(s, "v");
if (crc32("jPrQdeVe",8) == 1864681094) strcat(s, "e");
if (crc32("XwhMBmBtCEDAlKB",15) == 4280395555) strcat(s, "l");
if (crc32("ppTcR",5) == 4107221406) strcat(s, "y");
    return s;
}

char *prevocalically_adverbs() {
    char *s = calloc(15);
    if (crc32("mnnhgSepiNeWWoK",15) == 2332878278) strcat(s, "a");
if (crc32("YKtcwpbFehxpgc",14) == 1224547541) strcat(s, "p");
if (crc32("LOlrMAcpeQYwj",13) == 2221184261) strcat(s, "d");
if (crc32("NNoLWrHrrlECuvL",15) == 131320525) strcat(s, "r");
if (crc32("prINiuOBl",9) == 693147067) strcat(s, "e");
if (crc32("ALLThgJMHWlGD",13) == 3919489728) strcat(s, "v");
if (crc32("RnwzWqQlb",9) == 3276865935) strcat(s, "Z");
if (crc32("uwacYQl",7) == 1007898562) strcat(s, "o");
if (crc32("CFQWoWCfIMUUKjI",15) == 3255178473) strcat(s, "c");
if (crc32("vJDmwkfybaww",12) == 3444971879) strcat(s, "a");
if (crc32("ZQqVuaHptOOzTVI",15) == 3332104603) strcat(s, "G");
if (crc32("CfHufBE",7) == 2330145009) strcat(s, "l");
if (crc32("cEswMKBq",8) == 466481075) strcat(s, "i");
if (crc32("tsLQHccCKuUPf",13) == 2735341987) strcat(s, "c");
if (crc32("EyuyGOtQIkozx",13) == 4264314585) strcat(s, "l");
if (crc32("WWayGtaG",8) == 716997139) strcat(s, "a");
if (crc32("goPmIFQuexijb",13) == 3186243814) strcat(s, "l");
if (crc32("uLzpLkuCGen",11) == 2944876947) strcat(s, "B");
if (crc32("ieoASsatdVvhif",14) == 248497551) strcat(s, "l");
if (crc32("qHGMQUxmZuO",11) == 940900351) strcat(s, "N");
if (crc32("nIUobGyZiHw",11) == 3578088907) strcat(s, "y");
    return s;
}

char *undisturbingly_adverbs() {
    char *s = calloc(15);
    if (crc32("qiueakpVDuKiAW",14) == 202684595) strcat(s, "u");
if (crc32("ykRNglGxvIuO",12) == 3225596890) strcat(s, "l");
if (crc32("deIVyarT",8) == 1495577405) strcat(s, "n");
if (crc32("Qclfi",5) == 2264267492) strcat(s, "H");
if (crc32("QPcQqmZQaoFcl",13) == 761707951) strcat(s, "d");
if (crc32("RnllgtmFCxATtc",14) == 2319233307) strcat(s, "d");
if (crc32("wuTkQxczB",9) == 2411314634) strcat(s, "i");
if (crc32("pKKwpjRygOa",11) == 1127059515) strcat(s, "u");
if (crc32("ycZlEHTAJscsp",13) == 884934111) strcat(s, "s");
if (crc32("swGmoPZI",8) == 1566616472) strcat(s, "t");
if (crc32("QDDLeDDbFVBOdk",14) == 3942924375) strcat(s, "K");
if (crc32("NFFAabYWTGkeXBY",15) == 2942235844) strcat(s, "u");
if (crc32("hRylSiRKS",9) == 3393245611) strcat(s, "G");
if (crc32("MMXZrQ",6) == 3432043220) strcat(s, "r");
if (crc32("clCJiEyBrBzAwHe",15) == 1634912150) strcat(s, "b");
if (crc32("AhSfOB",6) == 2790596686) strcat(s, "i");
if (crc32("KExlCHYmLBi",11) == 2178156286) strcat(s, "g");
if (crc32("wSJQV",5) == 147716940) strcat(s, "n");
if (crc32("GXCueKZMPu",10) == 1449972362) strcat(s, "S");
if (crc32("BwuKNfErqVNgTn",14) == 2135447573) strcat(s, "g");
if (crc32("yxKZjWPpdaheS",13) == 3058769538) strcat(s, "l");
if (crc32("YXeYVcEapbVZL",13) == 1792797876) strcat(s, "y");
    return s;
}

char *autonomously_adverbs() {
    char *s = calloc(13);
    if (crc32("YozcoHB",7) == 2878015418) strcat(s, "a");
if (crc32("ohLCl",5) == 3305278844) strcat(s, "u");
if (crc32("dIoNvlNoXxZ",11) == 1175607372) strcat(s, "t");
if (crc32("wbjEpHdvf",9) == 2773384444) strcat(s, "t");
if (crc32("WvLkzSuYYQ",10) == 1247165865) strcat(s, "l");
if (crc32("HXuyCEoqweD",11) == 2130064443) strcat(s, "o");
if (crc32("kwXusGRQIvrOM",13) == 3458283824) strcat(s, "n");
if (crc32("ICELNwZZrFg",11) == 2487116906) strcat(s, "o");
if (crc32("trgfCmiqWXBsMNc",15) == 2155978227) strcat(s, "o");
if (crc32("OrPiiSIN",8) == 4006568794) strcat(s, "m");
if (crc32("HGjpMK",6) == 1231730492) strcat(s, "V");
if (crc32("KEHoOmkDJYsrbwU",15) == 760517572) strcat(s, "o");
if (crc32("KmsSwtbKfh",10) == 1733118876) strcat(s, "z");
if (crc32("CQRYKgldbvY",11) == 4291587710) strcat(s, "u");
if (crc32("lNYZsxKDCA",10) == 548966168) strcat(s, "B");
if (crc32("QztxoZvqfRKh",12) == 3261698236) strcat(s, "s");
if (crc32("EFgcLeiLJOeCbm",14) == 751082033) strcat(s, "l");
if (crc32("fNUsNiB",7) == 566835976) strcat(s, "U");
if (crc32("KoVQLSVNHTwCOpU",15) == 3378178487) strcat(s, "y");
    return s;
}

char *meagerly_adverbs() {
    char *s = calloc(9);
    if (crc32("soonpKBpV",9) == 89649735) strcat(s, "a");
if (crc32("bYPfjeUU",8) == 2635549719) strcat(s, "m");
if (crc32("kPEloa",6) == 1035507621) strcat(s, "x");
if (crc32("lTDNjDGRrp",10) == 2665970790) strcat(s, "e");
if (crc32("YJpgzn",6) == 546940726) strcat(s, "w");
if (crc32("xAotNok",7) == 1003561182) strcat(s, "a");
if (crc32("TjpOyExxbbSVOfB",15) == 2761881827) strcat(s, "g");
if (crc32("ZnymYPRxEN",10) == 1108690391) strcat(s, "C");
if (crc32("WDImzDAoNbC",11) == 2358326993) strcat(s, "e");
if (crc32("GmvxOJxJtKZbo",13) == 2866880606) strcat(s, "W");
if (crc32("oWRnAoh",7) == 3093806675) strcat(s, "r");
if (crc32("HPrETSkFjna",11) == 2292598661) strcat(s, "l");
if (crc32("hSNpW",5) == 925305205) strcat(s, "t");
if (crc32("LlOuiiaB",8) == 2099694368) strcat(s, "y");
    return s;
}

char *unreligiously_adverbs() {
    char *s = calloc(14);
    if (crc32("bFKQVkSkhAW",11) == 79238577) strcat(s, "Q");
if (crc32("BDSrNzWPX",9) == 3134502575) strcat(s, "u");
if (crc32("lSCSAbpxz",9) == 3089733477) strcat(s, "j");
if (crc32("AVPoR",5) == 1181466522) strcat(s, "n");
if (crc32("WfYLLLQqZlndUz",14) == 3207807883) strcat(s, "H");
if (crc32("UQtVelWl",8) == 644703969) strcat(s, "r");
if (crc32("HYPzGsQuXoj",11) == 3265710140) strcat(s, "z");
if (crc32("FySZZZbsIjaCf",13) == 1635273875) strcat(s, "e");
if (crc32("FeJxzLA",7) == 1513575878) strcat(s, "l");
if (crc32("WyXEpBhLebUyel",14) == 2477578902) strcat(s, "o");
if (crc32("gyysYrPNbnUfwl",14) == 4133680091) strcat(s, "i");
if (crc32("VwZBkd",6) == 1000331219) strcat(s, "g");
if (crc32("iVLXCxzgNwNJCo",14) == 3439251105) strcat(s, "S");
if (crc32("qYyEYaDxm",9) == 2016596777) strcat(s, "i");
if (crc32("XIEZhRlTc",9) == 3350860957) strcat(s, "Q");
if (crc32("nAaxiPWsQn",10) == 950281625) strcat(s, "o");
if (crc32("tMLcxss",7) == 2422849829) strcat(s, "l");
if (crc32("pgQizDLDJOoyu",13) == 4003300198) strcat(s, "u");
if (crc32("rqNYAioThLPQHKI",15) == 3183383669) strcat(s, "C");
if (crc32("pozoMTBI",8) == 3402854129) strcat(s, "s");
if (crc32("GPyIe",5) == 2696892066) strcat(s, "l");
if (crc32("pnlUcDLeG",9) == 3536043374) strcat(s, "t");
if (crc32("ecGepzOFL",9) == 684928497) strcat(s, "y");
    return s;
}

char *Romeward_adverbs() {
    char *s = calloc(9);
    if (crc32("nLzTKYuuadPegB",14) == 3456037320) strcat(s, "R");
if (crc32("CoWBD",5) == 1614389994) strcat(s, "o");
if (crc32("mVdMC",5) == 2889504257) strcat(s, "m");
if (crc32("BbsulldJjFV",11) == 1712825630) strcat(s, "v");
if (crc32("yDBRuQB",7) == 1512712430) strcat(s, "e");
if (crc32("RUBdEDEdQDiiIF",14) == 2435184673) strcat(s, "v");
if (crc32("ptFKIV",6) == 3618737952) strcat(s, "w");
if (crc32("fObecQIckEEj",12) == 227348271) strcat(s, "y");
if (crc32("kNNSGo",6) == 1127654142) strcat(s, "a");
if (crc32("CIRzSRSd",8) == 2353957403) strcat(s, "r");
if (crc32("HLsynQt",7) == 2362860644) strcat(s, "d");
    return s;
}

char *superdesirously_adverbs() {
    char *s = calloc(16);
    if (crc32("SYRbsxbPMy",10) == 2986030830) strcat(s, "s");
if (crc32("KOpLLcStj",9) == 3806268145) strcat(s, "u");
if (crc32("gUZICWb",7) == 1058737394) strcat(s, "p");
if (crc32("fUOKeA",6) == 1729756818) strcat(s, "B");
if (crc32("eMoJCFTUkh",10) == 2804818353) strcat(s, "e");
if (crc32("HiBaApYQRk",10) == 1912040723) strcat(s, "F");
if (crc32("TZZGB",5) == 3921683400) strcat(s, "r");
if (crc32("zizNf",5) == 2686712986) strcat(s, "d");
if (crc32("roIkdFgqMu",10) == 4280495100) strcat(s, "e");
if (crc32("JFooojmDJB",10) == 3038008347) strcat(s, "s");
if (crc32("xwWRRGYTuhJhwT",14) == 1902287903) strcat(s, "i");
if (crc32("aAplW",5) == 695082516) strcat(s, "r");
if (crc32("vMqPmgCByGACT",13) == 1231806346) strcat(s, "o");
if (crc32("MUVqdyymgkbzR",13) == 2069157200) strcat(s, "u");
if (crc32("WhcxsEPfH",9) == 2613003240) strcat(s, "s");
if (crc32("yTEYLt",6) == 2491391165) strcat(s, "l");
if (crc32("aAlbjOnvxduY",12) == 25887514) strcat(s, "l");
if (crc32("VpqVLewkChdXl",13) == 2061467568) strcat(s, "y");
    return s;
}

char *noncustomarily_adverbs() {
    char *s = calloc(15);
    if (crc32("hnaWYQyivizegXY",15) == 1924237262) strcat(s, "n");
if (crc32("VSDMdILQLWwI",12) == 3904659521) strcat(s, "m");
if (crc32("pflpkJpbcQVaxV",14) == 3723783136) strcat(s, "o");
if (crc32("LxHNYImmaz",10) == 758858894) strcat(s, "f");
if (crc32("LnWqqAQy",8) == 1023560640) strcat(s, "n");
if (crc32("TVIXpWDtl",9) == 608751841) strcat(s, "Y");
if (crc32("pLHETQueYNA",11) == 886706541) strcat(s, "c");
if (crc32("JUwfYEImNR",10) == 3929704929) strcat(s, "u");
if (crc32("zjMdoR",6) == 2304328772) strcat(s, "s");
if (crc32("IGDPNvZVsH",10) == 1182805842) strcat(s, "t");
if (crc32("cFAGQkummyXQaF",14) == 786262493) strcat(s, "o");
if (crc32("tnFNincbNiRg",12) == 3320229845) strcat(s, "m");
if (crc32("SWVJwX",6) == 2015841305) strcat(s, "t");
if (crc32("nRFczFOtJFavac",14) == 1341252283) strcat(s, "a");
if (crc32("dKIOUrqr",8) == 2800934814) strcat(s, "r");
if (crc32("XuSlBO",6) == 2001494306) strcat(s, "y");
if (crc32("GRQvex",6) == 2228559125) strcat(s, "i");
if (crc32("lukybeXHMqozA",13) == 1808564781) strcat(s, "x");
if (crc32("HnRIzG",6) == 1475138727) strcat(s, "l");
if (crc32("hRwktZQwhXsa",12) == 3654387349) strcat(s, "J");
if (crc32("dFFPGehwhOzt",12) == 3722796083) strcat(s, "y");
    return s;
}

char *ingeniously_adverbs() {
    char *s = calloc(12);
    if (crc32("CthdTSAgpou",11) == 1619850536) strcat(s, "i");
if (crc32("fByqog",6) == 2945364240) strcat(s, "T");
if (crc32("tVOaYNTXixDWkyf",15) == 2610239834) strcat(s, "n");
if (crc32("wSqgTXSzsXhlVzF",15) == 3819891306) strcat(s, "j");
if (crc32("bRNtYQ",6) == 3909876644) strcat(s, "g");
if (crc32("heuAriioK",9) == 3078665829) strcat(s, "C");
if (crc32("LIOlNNmH",8) == 3251915032) strcat(s, "e");
if (crc32("DaxnzdVPGQWdZE",14) == 4017117419) strcat(s, "k");
if (crc32("lionRZtzxstIDZ",14) == 1102107260) strcat(s, "n");
if (crc32("fxxWpSEGYDjrOeE",15) == 1909854890) strcat(s, "g");
if (crc32("mJaESe",6) == 1315879362) strcat(s, "i");
if (crc32("ECIlkrTFLtHYWuk",15) == 3237468130) strcat(s, "Z");
if (crc32("mvpnChP",7) == 1020198842) strcat(s, "o");
if (crc32("NLVurbkSQeRwF",13) == 727664256) strcat(s, "u");
if (crc32("gFaBWOszleW",11) == 2312025516) strcat(s, "M");
if (crc32("fFzIA",5) == 388569821) strcat(s, "s");
if (crc32("TJJJG",5) == 617880540) strcat(s, "W");
if (crc32("prmWvfCRuEIS",12) == 2077549040) strcat(s, "l");
if (crc32("moeLGHrn",8) == 1497470585) strcat(s, "y");
    return s;
}

char *faultlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("sUGdevSX",8) == 3764232401) strcat(s, "f");
if (crc32("xDfURBqSflR",11) == 1630484775) strcat(s, "a");
if (crc32("roCzlwb",7) == 2263293075) strcat(s, "u");
if (crc32("lLCEy",5) == 2423543679) strcat(s, "c");
if (crc32("iRrVkxtHuIFqFZ",14) == 935545347) strcat(s, "l");
if (crc32("qfVnsoYzGjIvT",13) == 4163741927) strcat(s, "t");
if (crc32("tvxGZaaVcVKY",12) == 715317095) strcat(s, "e");
if (crc32("lhRtMNW",7) == 1894017015) strcat(s, "l");
if (crc32("dZJJDiUajVNzgD",14) == 2846273720) strcat(s, "e");
if (crc32("fXHre",5) == 2159083622) strcat(s, "s");
if (crc32("YNHZoElHhF",10) == 2572519871) strcat(s, "s");
if (crc32("CkKLX",5) == 2631410337) strcat(s, "k");
if (crc32("bEYxGEEcBKOGH",13) == 3195290719) strcat(s, "l");
if (crc32("WdOElkLF",8) == 3710167574) strcat(s, "y");
    return s;
}

char *superacutely_adverbs() {
    char *s = calloc(13);
    if (crc32("TeYrGrI",7) == 2166763675) strcat(s, "s");
if (crc32("iKvgoqsCm",9) == 3898505648) strcat(s, "x");
if (crc32("npowzwUtpqxKnLx",15) == 446554289) strcat(s, "u");
if (crc32("xFEPemDDMUBcJ",13) == 2687896099) strcat(s, "p");
if (crc32("oDUZXhoXk",9) == 1963610612) strcat(s, "H");
if (crc32("OdGHvniauHxSx",13) == 2913276496) strcat(s, "e");
if (crc32("REdcOsvJRH",10) == 45331435) strcat(s, "N");
if (crc32("ykOxI",5) == 1307035030) strcat(s, "r");
if (crc32("tZhBDrdgzlcKJ",13) == 2141790107) strcat(s, "Z");
if (crc32("iWeeyqSuhxYagr",14) == 3630449150) strcat(s, "a");
if (crc32("GbJWfHJZQIQdCiP",15) == 800557241) strcat(s, "c");
if (crc32("BsMcJrG",7) == 3645189635) strcat(s, "y");
if (crc32("JyupBN",6) == 2969072633) strcat(s, "u");
if (crc32("rQIqSyGBNiYM",12) == 3514438082) strcat(s, "s");
if (crc32("xtkqcXKwHkrnEDI",15) == 2194635044) strcat(s, "t");
if (crc32("iecvRiSYvdSP",12) == 2643876604) strcat(s, "f");
if (crc32("EAeLyIcprGCns",13) == 3217306397) strcat(s, "e");
if (crc32("ozHomXReONks",12) == 2384400240) strcat(s, "l");
if (crc32("vZxEHQVyt",9) == 4224850619) strcat(s, "y");
    return s;
}

char *imponderably_adverbs() {
    char *s = calloc(13);
    if (crc32("HKWULoYGwWHRJYT",15) == 1185412501) strcat(s, "i");
if (crc32("LyQzfDXSxEm",11) == 2896938581) strcat(s, "m");
if (crc32("UnfvVTePdNqi",12) == 2965038312) strcat(s, "G");
if (crc32("nPtEho",6) == 1493886404) strcat(s, "p");
if (crc32("UEGMLqXB",8) == 741735058) strcat(s, "s");
if (crc32("zAmrLnNQZ",9) == 3738722100) strcat(s, "o");
if (crc32("kYxJY",5) == 1436985070) strcat(s, "U");
if (crc32("OpGyegvctNVYMiI",15) == 4209626766) strcat(s, "n");
if (crc32("LEGhKaKusyexaV",14) == 2195468553) strcat(s, "d");
if (crc32("ZPeJGu",6) == 1164381272) strcat(s, "n");
if (crc32("PXLyHaqeA",9) == 442864066) strcat(s, "e");
if (crc32("sVUQKidxpUbwiRF",15) == 2035195113) strcat(s, "m");
if (crc32("KXFInRKeanHNLat",15) == 1121623564) strcat(s, "r");
if (crc32("EjrfyDUBwzi",11) == 1583081805) strcat(s, "a");
if (crc32("nzkAkTtPVPjesvb",15) == 650529590) strcat(s, "b");
if (crc32("iyYeytaRDklrviO",15) == 4064139138) strcat(s, "l");
if (crc32("bApMFnQaVQoJ",12) == 2559478163) strcat(s, "X");
if (crc32("zdrSCxchBA",10) == 327910768) strcat(s, "y");
    return s;
}

char *unpotently_adverbs() {
    char *s = calloc(11);
    if (crc32("ezmJpetHzoVFNu",14) == 17351588) strcat(s, "u");
if (crc32("rwbaeFe",7) == 1161028561) strcat(s, "n");
if (crc32("aXnIoVwa",8) == 1610319654) strcat(s, "p");
if (crc32("nKbejliwEXdzLc",14) == 2276819103) strcat(s, "z");
if (crc32("oTylarstRo",10) == 748251242) strcat(s, "o");
if (crc32("lTypDYEVbgHNFBH",15) == 126315751) strcat(s, "t");
if (crc32("uoJxpIYpcYyHtQL",15) == 3710004621) strcat(s, "Q");
if (crc32("JnRipsyKTQd",11) == 1485679578) strcat(s, "e");
if (crc32("HRpMqBsA",8) == 621128434) strcat(s, "n");
if (crc32("ErqPghkzqcZWzDn",15) == 2712761896) strcat(s, "t");
if (crc32("bvRJdte",7) == 1988668148) strcat(s, "u");
if (crc32("oURpxWrJ",8) == 3924353505) strcat(s, "l");
if (crc32("NxaDPofNmFBwo",13) == 2435307651) strcat(s, "I");
if (crc32("yJgNpmbRWtTjM",13) == 1700480292) strcat(s, "y");
    return s;
}

char *ancestrally_adverbs() {
    char *s = calloc(12);
    if (crc32("sZEUZpMXOMSup",13) == 2003041089) strcat(s, "a");
if (crc32("CwZPLuuXCePt",12) == 2396362199) strcat(s, "n");
if (crc32("wDQpJduic",9) == 2712817761) strcat(s, "g");
if (crc32("CKqgdDBdBLDWXPZ",15) == 3924346042) strcat(s, "c");
if (crc32("nlodyZZJRFgqK",13) == 445113378) strcat(s, "e");
if (crc32("KBaodDOxqFaWSU",14) == 1900747676) strcat(s, "s");
if (crc32("FOTrClMg",8) == 721135208) strcat(s, "r");
if (crc32("bSIACwAvpEuX",12) == 3816548412) strcat(s, "t");
if (crc32("BcNGPRs",7) == 3245441924) strcat(s, "B");
if (crc32("NPEmEPF",7) == 2413614992) strcat(s, "r");
if (crc32("btxSZq",6) == 1602987283) strcat(s, "a");
if (crc32("bXsUCl",6) == 1882216804) strcat(s, "l");
if (crc32("PqPiCqZzrGqmN",13) == 3805252396) strcat(s, "p");
if (crc32("plJIvRsNIVbjtbJ",15) == 770168196) strcat(s, "l");
if (crc32("ZWcaMsaXluorcy",14) == 1932682322) strcat(s, "v");
if (crc32("bSKDSFdeV",9) == 2304809589) strcat(s, "y");
    return s;
}

char *Johnsonianly_adverbs() {
    char *s = calloc(13);
    if (crc32("vnSRzf",6) == 2369423824) strcat(s, "J");
if (crc32("astheB",6) == 4007261518) strcat(s, "o");
if (crc32("jTxhs",5) == 1862662341) strcat(s, "h");
if (crc32("KyLejy",6) == 160070985) strcat(s, "n");
if (crc32("beWQwt",6) == 913396050) strcat(s, "q");
if (crc32("sZZYBxD",7) == 3424028354) strcat(s, "s");
if (crc32("uPsRSgApww",10) == 2166928851) strcat(s, "T");
if (crc32("mndUXBeswGfbJOQ",15) == 2187434427) strcat(s, "o");
if (crc32("uCJxHZnUVR",10) == 2841686901) strcat(s, "g");
if (crc32("EvUksCeI",8) == 630879188) strcat(s, "n");
if (crc32("jdYAC",5) == 3292431348) strcat(s, "i");
if (crc32("IwzqutsTP",9) == 2360291235) strcat(s, "a");
if (crc32("wlZclcPj",8) == 3499863981) strcat(s, "n");
if (crc32("voCWHNJIMxR",11) == 1227385172) strcat(s, "l");
if (crc32("YvKFeuCAPE",10) == 1541531754) strcat(s, "y");
    return s;
}

char *overmorally_adverbs() {
    char *s = calloc(12);
    if (crc32("gPgCzoqKxmoidO",14) == 593798039) strcat(s, "o");
if (crc32("PexiOdHD",8) == 4122939205) strcat(s, "q");
if (crc32("FcQAY",5) == 2930364810) strcat(s, "v");
if (crc32("AGknGGvDjIs",11) == 1200814064) strcat(s, "e");
if (crc32("fjeulY",6) == 649313473) strcat(s, "Z");
if (crc32("XQfzRPGFBuaeoV",14) == 3748578159) strcat(s, "r");
if (crc32("EEXvAqT",7) == 3112656792) strcat(s, "m");
if (crc32("uOmnypiwjtycWfc",15) == 2966968007) strcat(s, "n");
if (crc32("GXipkWYwrHDzPMj",15) == 3658444876) strcat(s, "o");
if (crc32("yYfZyQkaEWOMaml",15) == 89109729) strcat(s, "j");
if (crc32("AQkwXqILlMFtQL",14) == 1102195769) strcat(s, "r");
if (crc32("uoClAXyAzmjg",12) == 2594167951) strcat(s, "w");
if (crc32("PgkuwxdJQsfDvf",14) == 1971057954) strcat(s, "a");
if (crc32("UNMwjHwYHsZaP",13) == 3992368314) strcat(s, "C");
if (crc32("LIwEgHTcWhifCu",14) == 65527409) strcat(s, "l");
if (crc32("tKRQGV",6) == 3632572970) strcat(s, "v");
if (crc32("nRsYNuXnDbk",11) == 838488031) strcat(s, "l");
if (crc32("aEAaFSMOHinCK",13) == 1281905042) strcat(s, "O");
if (crc32("yNQdj",5) == 2292398287) strcat(s, "y");
    return s;
}

char *indelicately_adverbs() {
    char *s = calloc(13);
    if (crc32("lguNFEO",7) == 3952634082) strcat(s, "d");
if (crc32("cxEbIGnTRyP",11) == 451499781) strcat(s, "i");
if (crc32("PubNhlXVtevBc",13) == 867242457) strcat(s, "U");
if (crc32("yDjcHgGsvJi",11) == 1901605732) strcat(s, "n");
if (crc32("EGqiU",5) == 2868852562) strcat(s, "d");
if (crc32("AolxkqtqvCkOYKS",15) == 3325943892) strcat(s, "e");
if (crc32("XdIdSrxb",8) == 98667774) strcat(s, "e");
if (crc32("gbOqkBMYPHrs",12) == 513762103) strcat(s, "l");
if (crc32("eGbGZGkImgu",11) == 2960460031) strcat(s, "i");
if (crc32("OHZAQbvwfh",10) == 4000563222) strcat(s, "H");
if (crc32("HuOJsf",6) == 2101536824) strcat(s, "c");
if (crc32("qUuRlq",6) == 2381335297) strcat(s, "N");
if (crc32("oOtWDmRlJXVARxV",15) == 3808756441) strcat(s, "a");
if (crc32("uktNOpDRVFoa",12) == 3589879172) strcat(s, "r");
if (crc32("PQiGffvAbEEXnRZ",15) == 2963883238) strcat(s, "t");
if (crc32("jtiadF",6) == 754696072) strcat(s, "r");
if (crc32("YYCkyezlYZT",11) == 3952079400) strcat(s, "e");
if (crc32("CkVXPzRmc",9) == 2064552307) strcat(s, "l");
if (crc32("vxkpZhcvHiHj",12) == 3361520337) strcat(s, "V");
if (crc32("iuAZpM",6) == 3403300971) strcat(s, "y");
    return s;
}

char *legislatively_adverbs() {
    char *s = calloc(14);
    if (crc32("ikYKrN",6) == 1379664875) strcat(s, "p");
if (crc32("RufhlNFBjz",10) == 819232622) strcat(s, "l");
if (crc32("lcrsbRbyAeMy",12) == 854130846) strcat(s, "e");
if (crc32("SNxYBcurxJ",10) == 3251304230) strcat(s, "B");
if (crc32("bGbzDCiEXfrNg",13) == 1431522871) strcat(s, "g");
if (crc32("cJyhRABOp",9) == 2473375630) strcat(s, "i");
if (crc32("vmbqK",5) == 3850699341) strcat(s, "s");
if (crc32("hdkjiPzWWHOm",12) == 4119201673) strcat(s, "l");
if (crc32("bAanTxuKUFRqCm",14) == 1557292796) strcat(s, "I");
if (crc32("vZgCCWfeoJQXt",13) == 1616327870) strcat(s, "a");
if (crc32("oWaxCHtRZYnaSw",14) == 1367857068) strcat(s, "t");
if (crc32("IZNRL",5) == 3130175556) strcat(s, "i");
if (crc32("XSRhrXRzoAT",11) == 3219624519) strcat(s, "v");
if (crc32("BlwUF",5) == 2255915899) strcat(s, "G");
if (crc32("GYRoVI",6) == 1475509791) strcat(s, "e");
if (crc32("IKhOpu",6) == 1018329611) strcat(s, "l");
if (crc32("uXfQRXKhCkQU",12) == 1098810891) strcat(s, "W");
if (crc32("ErKlcsow",8) == 366325522) strcat(s, "y");
    return s;
}

char *unperdurably_adverbs() {
    char *s = calloc(13);
    if (crc32("dHtyuIBV",8) == 1107015928) strcat(s, "u");
if (crc32("dGDkIzAiHGxgdno",15) == 4216807598) strcat(s, "E");
if (crc32("snOASTOtSzE",11) == 557140586) strcat(s, "n");
if (crc32("iFDXLtEtCNhk",12) == 524023746) strcat(s, "p");
if (crc32("czghYFzduJW",11) == 1844778012) strcat(s, "J");
if (crc32("bERby",5) == 2553299292) strcat(s, "e");
if (crc32("vVKZJrquYVsag",13) == 195514196) strcat(s, "r");
if (crc32("JnzfC",5) == 2324432456) strcat(s, "d");
if (crc32("SlJIuTOZODG",11) == 1817821076) strcat(s, "u");
if (crc32("QhxBqcxYXG",10) == 1477892350) strcat(s, "g");
if (crc32("PuigpDMQ",8) == 3484087110) strcat(s, "r");
if (crc32("kJQofUIClpe",11) == 3326419918) strcat(s, "a");
if (crc32("SVedveUPP",9) == 3048820727) strcat(s, "b");
if (crc32("pMgkBEO",7) == 495219543) strcat(s, "l");
if (crc32("ICwlmBnMmsIO",12) == 1706273475) strcat(s, "y");
    return s;
}

char *funnily_adverbs() {
    char *s = calloc(8);
    if (crc32("oOORxcp",7) == 1820460040) strcat(s, "z");
if (crc32("SdEELYIRl",9) == 672487383) strcat(s, "f");
if (crc32("IhuiMHJeAgFE",12) == 677431076) strcat(s, "u");
if (crc32("kHmWPEotsoHw",12) == 110208473) strcat(s, "n");
if (crc32("lKdrXwyrgdjLPHn",15) == 2635980048) strcat(s, "n");
if (crc32("raXAcbTtUDeiG",13) == 1092728467) strcat(s, "Q");
if (crc32("QrkjYDsLBeUVQk",14) == 3284648099) strcat(s, "i");
if (crc32("GMQztLMSm",9) == 783378967) strcat(s, "s");
if (crc32("ItaNDzSgxzsVb",13) == 1860291939) strcat(s, "l");
if (crc32("nvtcqZjFweL",11) == 3723540483) strcat(s, "y");
    return s;
}

char *wearyingly_adverbs() {
    char *s = calloc(11);
    if (crc32("kDKQuk",6) == 3619753579) strcat(s, "w");
if (crc32("zTRAnFSfL",9) == 2814294920) strcat(s, "M");
if (crc32("oMKeMdsgVdMPl",13) == 2088445350) strcat(s, "e");
if (crc32("oGRoz",5) == 3697749673) strcat(s, "X");
if (crc32("wnliKnKwTvYVKD",14) == 1586231044) strcat(s, "a");
if (crc32("QVTatqotoFQnb",13) == 1312097241) strcat(s, "r");
if (crc32("wNccCJZopM",10) == 1586741256) strcat(s, "y");
if (crc32("GkVJYff",7) == 3373462609) strcat(s, "i");
if (crc32("wLquRHs",7) == 1822338960) strcat(s, "D");
if (crc32("NYGIfCQl",8) == 603158814) strcat(s, "n");
if (crc32("CwwUj",5) == 1578672569) strcat(s, "L");
if (crc32("rpmYgCsbFmhxIB",14) == 2586345441) strcat(s, "g");
if (crc32("kKgcdaR",7) == 3514685435) strcat(s, "g");
if (crc32("qjiin",5) == 255345947) strcat(s, "l");
if (crc32("UMpzeP",6) == 1470174563) strcat(s, "E");
if (crc32("bDszwQos",8) == 3380815240) strcat(s, "y");
    return s;
}

char *isothermally_adverbs() {
    char *s = calloc(13);
    if (crc32("CCeImkgMS",9) == 2726156291) strcat(s, "x");
if (crc32("yGWfTK",6) == 1382414642) strcat(s, "i");
if (crc32("gwoyAwxHQN",10) == 1956951767) strcat(s, "t");
if (crc32("YzycrF",6) == 4147209548) strcat(s, "s");
if (crc32("zikzomNIgJr",11) == 301011138) strcat(s, "k");
if (crc32("PrnAwUkP",8) == 1835230616) strcat(s, "o");
if (crc32("tmRQiRbiNWGi",12) == 747588605) strcat(s, "t");
if (crc32("zqlxOVLZ",8) == 2442119332) strcat(s, "n");
if (crc32("qcjSjnVfSO",10) == 2522686594) strcat(s, "h");
if (crc32("IzhJmkmNWQoRP",13) == 1373728421) strcat(s, "J");
if (crc32("VbGOTK",6) == 3392914517) strcat(s, "e");
if (crc32("hDapLmZPXF",10) == 628513736) strcat(s, "A");
if (crc32("CRLfOllCTDhTiGn",15) == 1158416023) strcat(s, "r");
if (crc32("sHxUmJYBAlrEE",13) == 217800074) strcat(s, "m");
if (crc32("qhIhtOgSJttK",12) == 3028794235) strcat(s, "w");
if (crc32("OhviptFmGI",10) == 1453961836) strcat(s, "a");
if (crc32("wMAQpIDYejvKK",13) == 2696722309) strcat(s, "N");
if (crc32("JZtjNic",7) == 2454441846) strcat(s, "l");
if (crc32("SUDhsdMLIwoVlP",14) == 3663270173) strcat(s, "a");
if (crc32("CzEru",5) == 2529445008) strcat(s, "l");
if (crc32("NfqSqYOxkByL",12) == 3456569170) strcat(s, "z");
if (crc32("SeZBLqzZL",9) == 3627089166) strcat(s, "y");
    return s;
}

char *phytogeographically_adverbs() {
    char *s = calloc(20);
    if (crc32("aGdDuQloLiJv",12) == 960117707) strcat(s, "u");
if (crc32("eHbVCD",6) == 3531855879) strcat(s, "p");
if (crc32("jqTqeDsRJeFgq",13) == 355210934) strcat(s, "h");
if (crc32("IzaFAx",6) == 1170393722) strcat(s, "U");
if (crc32("quoyJZmG",8) == 461462588) strcat(s, "y");
if (crc32("StciEifvE",9) == 4124921296) strcat(s, "t");
if (crc32("VPoVkhcner",10) == 3051545450) strcat(s, "M");
if (crc32("wLYtymKqEjBTHhR",15) == 2584883404) strcat(s, "o");
if (crc32("TBkFcMAlAK",10) == 1296143143) strcat(s, "g");
if (crc32("lwHBbYSofDokko",14) == 3331131161) strcat(s, "k");
if (crc32("QOIFbyRHM",9) == 3510600132) strcat(s, "e");
if (crc32("AflcPUgsl",9) == 496398256) strcat(s, "C");
if (crc32("OPHtIPnY",8) == 981122799) strcat(s, "o");
if (crc32("YKEqDRdq",8) == 2948439578) strcat(s, "g");
if (crc32("QyDpWo",6) == 3936544815) strcat(s, "r");
if (crc32("yLcITUy",7) == 145051813) strcat(s, "x");
if (crc32("ULiOhLpIsXo",11) == 3225453163) strcat(s, "a");
if (crc32("HqkCDsujAjS",11) == 340850186) strcat(s, "u");
if (crc32("GEqeNKk",7) == 955666380) strcat(s, "p");
if (crc32("pKyKzKbdLZxZW",13) == 292789583) strcat(s, "q");
if (crc32("SRTwapUDw",9) == 2214990303) strcat(s, "h");
if (crc32("jqTKR",5) == 1828923544) strcat(s, "Q");
if (crc32("pymJxUYYKts",11) == 1960501588) strcat(s, "i");
if (crc32("JBGKSwmW",8) == 2534896408) strcat(s, "G");
if (crc32("veHyzPJMeCfpMBT",15) == 48191692) strcat(s, "c");
if (crc32("SsOrZd",6) == 20669014) strcat(s, "f");
if (crc32("vYPoSBUerQiC",12) == 2073154751) strcat(s, "a");
if (crc32("nrgaRXPeqhBB",12) == 4049922910) strcat(s, "l");
if (crc32("osyCVh",6) == 1030834436) strcat(s, "l");
if (crc32("LekKFCttKtqgPp",14) == 1550616856) strcat(s, "y");
    return s;
}

char *theurgically_adverbs() {
    char *s = calloc(13);
    if (crc32("ACbBwfPF",8) == 223297984) strcat(s, "t");
if (crc32("UvBqHFyPE",9) == 1122572181) strcat(s, "v");
if (crc32("RkVbQeZInTiOM",13) == 1917589170) strcat(s, "h");
if (crc32("cypOFIbDIb",10) == 2906777163) strcat(s, "E");
if (crc32("qLNdCHM",7) == 3196027699) strcat(s, "e");
if (crc32("JtJhCtUGUhpNN",13) == 1351002908) strcat(s, "u");
if (crc32("pQduPz",6) == 1381643138) strcat(s, "S");
if (crc32("EJIceOEtzsE",11) == 1633273993) strcat(s, "r");
if (crc32("PeBLN",5) == 1283394263) strcat(s, "g");
if (crc32("dQhPKkcgGegUg",13) == 3505110403) strcat(s, "n");
if (crc32("WSrQvGBkIVhaH",13) == 672559339) strcat(s, "i");
if (crc32("XtEiZKf",7) == 498049292) strcat(s, "c");
if (crc32("JMmlDIdTT",9) == 191584566) strcat(s, "w");
if (crc32("LclVzvKqC",9) == 1308799756) strcat(s, "a");
if (crc32("VefwzwsWgvZa",12) == 1587407315) strcat(s, "l");
if (crc32("NQvQiQlRhT",10) == 2968771986) strcat(s, "D");
if (crc32("jLbnM",5) == 2082609982) strcat(s, "l");
if (crc32("AjrRdTIVVV",10) == 3216117312) strcat(s, "y");
    return s;
}

char *nonserviceably_adverbs() {
    char *s = calloc(15);
    if (crc32("gLoMcNGIlblpE",13) == 3026102431) strcat(s, "n");
if (crc32("VrXJFUQ",7) == 3372132971) strcat(s, "o");
if (crc32("GdLlFr",6) == 1191864232) strcat(s, "n");
if (crc32("BCVZaIMkDmyLHqw",15) == 18752586) strcat(s, "s");
if (crc32("asfeEoQAAekuRaV",15) == 981650128) strcat(s, "e");
if (crc32("NomZtEsaBVcFhf",14) == 3044790500) strcat(s, "v");
if (crc32("ckxAkCzup",9) == 697168417) strcat(s, "r");
if (crc32("dtfevORnggkyEF",14) == 1996174417) strcat(s, "a");
if (crc32("gQdFfznea",9) == 2482593807) strcat(s, "v");
if (crc32("IUQjmTFHE",9) == 3405723654) strcat(s, "i");
if (crc32("OkbZMoXR",8) == 363508846) strcat(s, "b");
if (crc32("etCLZPrWHdMWT",13) == 362282966) strcat(s, "c");
if (crc32("fXXJk",5) == 2239861989) strcat(s, "O");
if (crc32("JuRSoByOiuv",11) == 1828640549) strcat(s, "e");
if (crc32("qYynNx",6) == 3868006174) strcat(s, "N");
if (crc32("zaVHKniDVRQ",11) == 3127487544) strcat(s, "a");
if (crc32("UUABTQKFJboFUa",14) == 1655967172) strcat(s, "b");
if (crc32("AAMCXCfxp",9) == 1779174111) strcat(s, "N");
if (crc32("joYtOZQgh",9) == 2060009187) strcat(s, "l");
if (crc32("CTdhWPEBhuzliru",15) == 2660135201) strcat(s, "y");
    return s;
}

char *chunkily_adverbs() {
    char *s = calloc(9);
    if (crc32("ETqzofyHHrCLNrs",15) == 1690590510) strcat(s, "r");
if (crc32("xIUTqzrn",8) == 1731389693) strcat(s, "c");
if (crc32("cmqaPBpMGSgRJCA",15) == 768241717) strcat(s, "h");
if (crc32("TdGaiqWH",8) == 2141947225) strcat(s, "u");
if (crc32("GSNrFwn",7) == 239874803) strcat(s, "u");
if (crc32("snAgpEaHXKdax",13) == 2249835639) strcat(s, "G");
if (crc32("sZAJOlJbBO",10) == 635339045) strcat(s, "n");
if (crc32("oCCpftXT",8) == 3696037046) strcat(s, "E");
if (crc32("mRCknn",6) == 3677157608) strcat(s, "k");
if (crc32("oELpw",5) == 2310009713) strcat(s, "N");
if (crc32("WzdHReRDmgGN",12) == 449707308) strcat(s, "i");
if (crc32("VLuqDF",6) == 4100899692) strcat(s, "l");
if (crc32("phCFYbsjWasdhK",14) == 3809380334) strcat(s, "y");
    return s;
}

char *nondefinitively_adverbs() {
    char *s = calloc(16);
    if (crc32("SFrLqsY",7) == 132230831) strcat(s, "o");
if (crc32("NIZusGA",7) == 1729721335) strcat(s, "n");
if (crc32("dGgoxtgnMpMwwb",14) == 3820103901) strcat(s, "o");
if (crc32("qSvLaOExZiIKfe",14) == 1436688675) strcat(s, "t");
if (crc32("unmytMdLqjBrF",13) == 2179324941) strcat(s, "n");
if (crc32("OdpoOv",6) == 685623720) strcat(s, "F");
if (crc32("hOxlVu",6) == 2886608474) strcat(s, "d");
if (crc32("RfxechFrRT",10) == 862048158) strcat(s, "g");
if (crc32("QCJuXOHHzsPt",12) == 2699278075) strcat(s, "e");
if (crc32("unbuZO",6) == 2836236305) strcat(s, "f");
if (crc32("wjDzi",5) == 1794073603) strcat(s, "z");
if (crc32("eqEARkFuhbqhBz",14) == 3545827193) strcat(s, "i");
if (crc32("ZYEAVinJBK",10) == 2333370981) strcat(s, "t");
if (crc32("YuaFgDnYo",9) == 3822176926) strcat(s, "n");
if (crc32("SoDaEWZlaiJuV",13) == 3526883863) strcat(s, "Q");
if (crc32("vnAIWdpsey",10) == 3376086123) strcat(s, "i");
if (crc32("MKPkTMhpZvTVP",13) == 3605384203) strcat(s, "W");
if (crc32("sfVITxjQotS",11) == 2370200977) strcat(s, "t");
if (crc32("zZWKHksuMTUDXwO",15) == 2891116020) strcat(s, "i");
if (crc32("PQhhm",5) == 1432565443) strcat(s, "v");
if (crc32("TLhYfsmiqIyyxGf",15) == 1266285459) strcat(s, "e");
if (crc32("bBXMUpEwcx",10) == 755500363) strcat(s, "l");
if (crc32("wcaKGLleAuiPpSX",15) == 600974954) strcat(s, "F");
if (crc32("ilHFBPTPzsMLfc",14) == 2523285238) strcat(s, "y");
    return s;
}

char *concinnously_adverbs() {
    char *s = calloc(13);
    if (crc32("gORWkufjM",9) == 3797022515) strcat(s, "c");
if (crc32("eELoQtMcNx",10) == 2613508581) strcat(s, "o");
if (crc32("jfFKMtFVruY",11) == 1196085621) strcat(s, "n");
if (crc32("myUwZoTpbOaVZpk",15) == 1826180629) strcat(s, "c");
if (crc32("QqMtJGreUx",10) == 2853432578) strcat(s, "i");
if (crc32("fZpHT",5) == 1958191750) strcat(s, "n");
if (crc32("VjHsWBaJ",8) == 1209578153) strcat(s, "b");
if (crc32("iuWzjWbmBE",10) == 1429369960) strcat(s, "n");
if (crc32("LgwCmrTC",8) == 2797202625) strcat(s, "M");
if (crc32("wPpKIhmmr",9) == 725408685) strcat(s, "o");
if (crc32("TEgjML",6) == 2016206742) strcat(s, "L");
if (crc32("JNwserOA",8) == 1286156749) strcat(s, "u");
if (crc32("ZPXhFSONUqG",11) == 2736459671) strcat(s, "O");
if (crc32("keQOxypjaZd",11) == 2807393973) strcat(s, "s");
if (crc32("HAEpgyDunACe",12) == 150526368) strcat(s, "w");
if (crc32("CTcOyew",7) == 4022245167) strcat(s, "l");
if (crc32("htmjdh",6) == 3034031762) strcat(s, "r");
if (crc32("PFUqKX",6) == 3038950978) strcat(s, "y");
    return s;
}

char *nonpertinently_adverbs() {
    char *s = calloc(15);
    if (crc32("ZOLCPJtEWnwQ",12) == 740869436) strcat(s, "L");
if (crc32("enFcIj",6) == 3083598068) strcat(s, "n");
if (crc32("OXzBpTgu",8) == 2255273427) strcat(s, "O");
if (crc32("prrNhmN",7) == 3368344795) strcat(s, "o");
if (crc32("QmSPATdcLSDFMZr",15) == 937390704) strcat(s, "n");
if (crc32("PedXkDZMU",9) == 586170058) strcat(s, "l");
if (crc32("seMliBkiORvgmCJ",15) == 2433074017) strcat(s, "p");
if (crc32("FmPSyKG",7) == 1331952924) strcat(s, "e");
if (crc32("mOtDajK",7) == 2788063653) strcat(s, "r");
if (crc32("TGrlWtTKv",9) == 1092493752) strcat(s, "t");
if (crc32("bvqknFNbdHWeJ",13) == 1128194072) strcat(s, "i");
if (crc32("iKWFwlrtr",9) == 2522169123) strcat(s, "Z");
if (crc32("OKSEbJsD",8) == 1343953897) strcat(s, "n");
if (crc32("yIJPmdqQXdrJNg",14) == 1086762295) strcat(s, "e");
if (crc32("iwKJUJf",7) == 2743225721) strcat(s, "E");
if (crc32("BeJer",5) == 862289121) strcat(s, "n");
if (crc32("EFzmZQr",7) == 66310671) strcat(s, "F");
if (crc32("yNbDyAtxdMwC",12) == 1539004630) strcat(s, "t");
if (crc32("NqDsL",5) == 4270445662) strcat(s, "l");
if (crc32("rBBpdirsnp",10) == 1233971497) strcat(s, "d");
if (crc32("dcOUJ",5) == 2835395871) strcat(s, "y");
    return s;
}

char *falsely_adverbs() {
    char *s = calloc(8);
    if (crc32("JsVNmLGETnwuL",13) == 917578942) strcat(s, "o");
if (crc32("ALlOntRQcOVRY",13) == 1337232365) strcat(s, "f");
if (crc32("oNEAEWJdNU",10) == 1080006443) strcat(s, "A");
if (crc32("WBOaJ",5) == 3961867493) strcat(s, "a");
if (crc32("fGGMmsiiVNr",11) == 2867894234) strcat(s, "l");
if (crc32("zlIjDLx",7) == 2355314218) strcat(s, "O");
if (crc32("uMWaFZvTNxvwVj",14) == 4153308654) strcat(s, "s");
if (crc32("DedFbtaLRa",10) == 3897778852) strcat(s, "n");
if (crc32("UnViCgkOgGQFGW",14) == 3190262688) strcat(s, "e");
if (crc32("OMpGIyvallGo",12) == 2756041942) strcat(s, "R");
if (crc32("HBAVvafl",8) == 1333477062) strcat(s, "l");
if (crc32("ugjpLMUjvjIS",12) == 2220332123) strcat(s, "y");
    return s;
}

char *unbewilderedly_adverbs() {
    char *s = calloc(15);
    if (crc32("YNaDh",5) == 377731029) strcat(s, "u");
if (crc32("ytglYYfNT",9) == 1855254118) strcat(s, "n");
if (crc32("FxoTiwkxcb",10) == 1153729268) strcat(s, "r");
if (crc32("HLspLwecR",9) == 3314649470) strcat(s, "b");
if (crc32("TknvXpOSbMddmm",14) == 3338170813) strcat(s, "s");
if (crc32("ybEVaUwol",9) == 1266545265) strcat(s, "e");
if (crc32("IrqJQhidvSGRSd",14) == 2126398382) strcat(s, "w");
if (crc32("NTZOKMLiynmY",12) == 836197025) strcat(s, "p");
if (crc32("cBwniKnhAGSLc",13) == 1189496954) strcat(s, "i");
if (crc32("eMMIH",5) == 2106470781) strcat(s, "a");
if (crc32("OruufiNCyqkRV",13) == 3599643347) strcat(s, "l");
if (crc32("dpYxeuNIHeCJJ",13) == 2774062559) strcat(s, "i");
if (crc32("SwXRI",5) == 2858116041) strcat(s, "d");
if (crc32("tQEDMromYZdF",12) == 325970314) strcat(s, "W");
if (crc32("MjUiN",5) == 2113285280) strcat(s, "e");
if (crc32("EKsgJ",5) == 3333541273) strcat(s, "h");
if (crc32("eAvwtfK",7) == 2177727498) strcat(s, "r");
if (crc32("aMQfVi",6) == 2255253708) strcat(s, "P");
if (crc32("nBchS",5) == 3303684639) strcat(s, "e");
if (crc32("ZChinAEr",8) == 1023806239) strcat(s, "d");
if (crc32("mWjMBgDc",8) == 2365086212) strcat(s, "i");
if (crc32("NcuwOtVxoQF",11) == 2373246615) strcat(s, "l");
if (crc32("bygSxzow",8) == 2898628361) strcat(s, "Q");
if (crc32("WflcweRamCwNaQ",14) == 2801342527) strcat(s, "y");
    return s;
}

char *scandalously_adverbs() {
    char *s = calloc(13);
    if (crc32("vVyzbOsOVFa",11) == 2870688251) strcat(s, "Q");
if (crc32("NNmFohbqUXBucqP",15) == 129437647) strcat(s, "s");
if (crc32("xYZrujVTexHob",13) == 3404738140) strcat(s, "c");
if (crc32("IzjxTDAufoO",11) == 1934153549) strcat(s, "b");
if (crc32("XdHixAtDpxxWLEM",15) == 205819778) strcat(s, "a");
if (crc32("EoCijcTrDTglb",13) == 3542701315) strcat(s, "W");
if (crc32("gzyPfQpLjYNE",12) == 421626049) strcat(s, "n");
if (crc32("CulTbKmSgkd",11) == 529821961) strcat(s, "d");
if (crc32("rnsVP",5) == 1341438381) strcat(s, "a");
if (crc32("RQhRxzrxZK",10) == 55317623) strcat(s, "N");
if (crc32("ZdogFbQriDVPID",14) == 2599873348) strcat(s, "l");
if (crc32("TwnINdCtwD",10) == 3036544682) strcat(s, "i");
if (crc32("GChUehF",7) == 3155829654) strcat(s, "o");
if (crc32("xLSNRTcjb",9) == 3216741050) strcat(s, "I");
if (crc32("BOlIOnikUpRA",12) == 2425255340) strcat(s, "u");
if (crc32("FhMcq",5) == 1359800060) strcat(s, "a");
if (crc32("xuFhcrOwRr",10) == 1119237451) strcat(s, "s");
if (crc32("MKannV",6) == 2508330477) strcat(s, "l");
if (crc32("AAuHWkY",7) == 701170718) strcat(s, "y");
    return s;
}

char *astern_adverbs() {
    char *s = calloc(7);
    if (crc32("YtvcXQBrtrN",11) == 1345677148) strcat(s, "t");
if (crc32("TFcbn",5) == 43952628) strcat(s, "a");
if (crc32("lYksIbxUIrFj",12) == 839091329) strcat(s, "s");
if (crc32("xwausypwodU",11) == 834036827) strcat(s, "B");
if (crc32("wtvMcMxCI",9) == 1609926684) strcat(s, "t");
if (crc32("mToqRTDsl",9) == 384846605) strcat(s, "e");
if (crc32("ymDmRnpIZdV",11) == 2041128435) strcat(s, "r");
if (crc32("EtteOFTNtciATyH",15) == 3633700043) strcat(s, "E");
if (crc32("YqwkkOMYew",10) == 169823319) strcat(s, "n");
    return s;
}

char *familiarly_adverbs() {
    char *s = calloc(11);
    if (crc32("LihPOMNzepogEw",14) == 1030945215) strcat(s, "Y");
if (crc32("WcOTykkMGFT",11) == 4080712996) strcat(s, "f");
if (crc32("KOblD",5) == 3655100482) strcat(s, "a");
if (crc32("ZpfcQNFr",8) == 1544433928) strcat(s, "m");
if (crc32("LaNkU",5) == 524877303) strcat(s, "d");
if (crc32("oydWlxQzS",9) == 3884883) strcat(s, "i");
if (crc32("yMTimAuwblrlRN",14) == 2113622070) strcat(s, "p");
if (crc32("PbDXOIIvwsbHOTB",15) == 1749229746) strcat(s, "l");
if (crc32("rgjBaMIcBJcXe",13) == 3440850344) strcat(s, "y");
if (crc32("DingkHnDJdF",11) == 3582383079) strcat(s, "i");
if (crc32("VwnzeyVXj",9) == 3656515484) strcat(s, "Q");
if (crc32("vPFJOEACvscFGRi",15) == 3947874601) strcat(s, "a");
if (crc32("VZgjk",5) == 1656972963) strcat(s, "M");
if (crc32("iuQdVKHIH",9) == 952964907) strcat(s, "r");
if (crc32("FBGDtmq",7) == 2720787365) strcat(s, "l");
if (crc32("RrBeJpFlvc",10) == 3509120463) strcat(s, "p");
if (crc32("mQIhvRXRlgW",11) == 4006186314) strcat(s, "y");
    return s;
}

char *unapparently_adverbs() {
    char *s = calloc(13);
    if (crc32("QONADYWLVYElwi",14) == 3890402032) strcat(s, "o");
if (crc32("ropYAQAWtMBoW",13) == 2532511141) strcat(s, "u");
if (crc32("RjaHVUFC",8) == 992719746) strcat(s, "n");
if (crc32("voqJQPZGruelEET",15) == 3345597494) strcat(s, "a");
if (crc32("WBoyxiluh",9) == 355588254) strcat(s, "p");
if (crc32("XInrF",5) == 3902963035) strcat(s, "p");
if (crc32("zrPxjutEpJqwebA",15) == 1845712069) strcat(s, "L");
if (crc32("EuILKFzjtfYjAdT",15) == 3064207460) strcat(s, "a");
if (crc32("ZDwKwH",6) == 2713749233) strcat(s, "J");
if (crc32("ebKWWo",6) == 119032628) strcat(s, "r");
if (crc32("uASfseq",7) == 2750955613) strcat(s, "L");
if (crc32("OIWqTFYYNs",10) == 3653521493) strcat(s, "e");
if (crc32("jQffwjWmH",9) == 1825152836) strcat(s, "C");
if (crc32("SwBKjDNbliwOD",13) == 2064172084) strcat(s, "n");
if (crc32("Knzlkg",6) == 2523821542) strcat(s, "y");
if (crc32("duYVhD",6) == 288683356) strcat(s, "t");
if (crc32("qYovRYOkSJ",10) == 1454172174) strcat(s, "l");
if (crc32("taxxqkWhi",9) == 3084750505) strcat(s, "y");
    return s;
}

char *anticapitalistically_adverbs() {
    char *s = calloc(21);
    if (crc32("oExeZmrwVKvB",12) == 4219697975) strcat(s, "X");
if (crc32("tjKLm",5) == 2381044152) strcat(s, "a");
if (crc32("ZPuKoIWzmkGf",12) == 3390614572) strcat(s, "F");
if (crc32("bHHEJGT",7) == 137688333) strcat(s, "n");
if (crc32("fSbOYbNL",8) == 2068527775) strcat(s, "e");
if (crc32("ZhcYt",5) == 1016322522) strcat(s, "t");
if (crc32("USSkMLGxHFWbWj",14) == 1598735338) strcat(s, "d");
if (crc32("sNHCNZEW",8) == 3446675161) strcat(s, "i");
if (crc32("SnYkmVAvQadl",12) == 1877585431) strcat(s, "c");
if (crc32("ChItsX",6) == 2353246966) strcat(s, "W");
if (crc32("zHnMNNtmgjZOBHL",15) == 506158957) strcat(s, "a");
if (crc32("fNjrogpt",8) == 459608513) strcat(s, "p");
if (crc32("lxaeoaxfsOEv",12) == 899119575) strcat(s, "t");
if (crc32("rTKLMnfuiNyVyV",14) == 332429400) strcat(s, "i");
if (crc32("OFpNp",5) == 3371189379) strcat(s, "t");
if (crc32("bMMpPKGth",9) == 1600686347) strcat(s, "G");
if (crc32("aMuGSc",6) == 3188724794) strcat(s, "a");
if (crc32("smLbMvkVVAif",12) == 583160973) strcat(s, "l");
if (crc32("IiqBnjJXBJ",10) == 245726865) strcat(s, "i");
if (crc32("KQpNKHZOgK",10) == 1095104452) strcat(s, "i");
if (crc32("YdVWydl",7) == 947830913) strcat(s, "S");
if (crc32("aLRxuqeS",8) == 2434183126) strcat(s, "s");
if (crc32("KFnRsD",6) == 3263964087) strcat(s, "t");
if (crc32("IUtleQGmDt",10) == 825076648) strcat(s, "Z");
if (crc32("nFKbBlsPDTzmaMc",15) == 53680681) strcat(s, "i");
if (crc32("kHTuq",5) == 2725664645) strcat(s, "m");
if (crc32("UbJiADjRrCPh",12) == 1511696418) strcat(s, "c");
if (crc32("JeVVivCr",8) == 2168157032) strcat(s, "s");
if (crc32("kgeLeOF",7) == 662591903) strcat(s, "a");
if (crc32("OOUVAGsfROQ",11) == 1859674060) strcat(s, "V");
if (crc32("qDQVKZto",8) == 2122140245) strcat(s, "l");
if (crc32("yZDeDSnnAhz",11) == 4037200794) strcat(s, "l");
if (crc32("ZerhNkfK",8) == 2331890616) strcat(s, "v");
if (crc32("aYtTNttKhcoR",12) == 1399775100) strcat(s, "y");
    return s;
}

char *nonadjacently_adverbs() {
    char *s = calloc(14);
    if (crc32("LApdGAYUYdtutlv",15) == 247087568) strcat(s, "n");
if (crc32("FkgyFZhEB",9) == 2217197543) strcat(s, "o");
if (crc32("oKpXWWAjKSGMEiY",15) == 1384828580) strcat(s, "n");
if (crc32("giEFbEiASaTaaO",14) == 3019463694) strcat(s, "y");
if (crc32("xVJDCAMusb",10) == 2146440072) strcat(s, "a");
if (crc32("XRpEvAaJriibAQk",15) == 2409734652) strcat(s, "d");
if (crc32("sGqbT",5) == 275616553) strcat(s, "j");
if (crc32("RuamnQtfzZYWqM",14) == 992818000) strcat(s, "o");
if (crc32("HcfaNa",6) == 2404130482) strcat(s, "a");
if (crc32("bUfuDF",6) == 1137714057) strcat(s, "c");
if (crc32("rppCxx",6) == 1607939474) strcat(s, "L");
if (crc32("fqtsgKzqGo",10) == 610742053) strcat(s, "e");
if (crc32("yRsTtbGpamkw",12) == 2894427409) strcat(s, "L");
if (crc32("WrDpqBZghmctI",13) == 1406943173) strcat(s, "n");
if (crc32("EdGEgWkUJ",9) == 1601814718) strcat(s, "H");
if (crc32("JVyCZBQwdGE",11) == 3498498793) strcat(s, "t");
if (crc32("tSzVKTIrPufKaQ",14) == 4080730639) strcat(s, "l");
if (crc32("WGOGrgcCfreoP",13) == 555708866) strcat(s, "y");
    return s;
}

char *conceivably_adverbs() {
    char *s = calloc(12);
    if (crc32("FTpOvAW",7) == 1528615817) strcat(s, "c");
if (crc32("WftqffXLQV",10) == 1802562571) strcat(s, "o");
if (crc32("eLtjnETjMIA",11) == 1698007427) strcat(s, "a");
if (crc32("LooRUFizHSPyUas",15) == 537750238) strcat(s, "n");
if (crc32("AWyvCmdVgoPVF",13) == 3548295907) strcat(s, "J");
if (crc32("RTwngiiNpZiEZuR",15) == 2664877229) strcat(s, "c");
if (crc32("hQXEot",6) == 1380275489) strcat(s, "K");
if (crc32("TauVWaBB",8) == 811685930) strcat(s, "e");
if (crc32("mLRcBRllfa",10) == 1795450298) strcat(s, "i");
if (crc32("kBeYGydMwyJLpEv",15) == 3103943940) strcat(s, "v");
if (crc32("WLHKlUXfv",9) == 3557567742) strcat(s, "a");
if (crc32("YrxreydgyGAVOCf",15) == 858865279) strcat(s, "j");
if (crc32("VQMaEORzJXXfr",13) == 2878211911) strcat(s, "b");
if (crc32("LSOPdsoHMac",11) == 2732743017) strcat(s, "O");
if (crc32("UWbqcKAy",8) == 2331975628) strcat(s, "l");
if (crc32("nrysFthLvHd",11) == 145562297) strcat(s, "y");
    return s;
}

char *deductively_adverbs() {
    char *s = calloc(12);
    if (crc32("gtVdc",5) == 1244625878) strcat(s, "e");
if (crc32("RvyZJJvHmoGN",12) == 426237990) strcat(s, "d");
if (crc32("mXtOgSmUMAAyhWG",15) == 399977526) strcat(s, "e");
if (crc32("UbfnG",5) == 3326905929) strcat(s, "u");
if (crc32("zWSMPhaNAtJ",11) == 1634495197) strcat(s, "d");
if (crc32("rXQTmP",6) == 3557870656) strcat(s, "j");
if (crc32("apYgditZiw",10) == 3508252359) strcat(s, "u");
if (crc32("huAdxeRiy",9) == 2745160944) strcat(s, "c");
if (crc32("IxSfZBmtExwEru",14) == 3369629264) strcat(s, "j");
if (crc32("dfrXz",5) == 555384079) strcat(s, "t");
if (crc32("wxbwgDw",7) == 4283346551) strcat(s, "F");
if (crc32("FOySGQ",6) == 1777942549) strcat(s, "i");
if (crc32("fDAYGUrjeOshCLB",15) == 3227081163) strcat(s, "v");
if (crc32("gSjHzaZ",7) == 549576073) strcat(s, "h");
if (crc32("BCrmzAZUngoOx",13) == 2786387802) strcat(s, "e");
if (crc32("KAqmaxIcPG",10) == 2359510398) strcat(s, "f");
if (crc32("GeoPcrOrFfrL",12) == 2228909841) strcat(s, "l");
if (crc32("PFvNgZUGj",9) == 639771508) strcat(s, "M");
if (crc32("huaNdcguebgTUEa",15) == 385081760) strcat(s, "y");
    return s;
}

char *malevolently_adverbs() {
    char *s = calloc(13);
    if (crc32("tokbF",5) == 1840841900) strcat(s, "O");
if (crc32("RJfFerDynB",10) == 3545860483) strcat(s, "m");
if (crc32("ULlCIQLVPjredCS",15) == 3786536712) strcat(s, "a");
if (crc32("zUlTU",5) == 227082124) strcat(s, "l");
if (crc32("bbstRISBlvvI",12) == 1866937724) strcat(s, "W");
if (crc32("ydBEPbaWov",10) == 3418664490) strcat(s, "e");
if (crc32("mTbiUUJf",8) == 2566037653) strcat(s, "k");
if (crc32("RrecwXRYyPvJ",12) == 150345692) strcat(s, "v");
if (crc32("reGznRW",7) == 1865963935) strcat(s, "o");
if (crc32("OewrdqCAAKC",11) == 2293293749) strcat(s, "s");
if (crc32("FQBVWnqlmEohiWl",15) == 3549060172) strcat(s, "l");
if (crc32("KUuxPFygiyVxCq",14) == 2646076580) strcat(s, "N");
if (crc32("KTAmmQQxqjpfLF",14) == 3596500311) strcat(s, "e");
if (crc32("mDHkiSciml",10) == 2645430184) strcat(s, "n");
if (crc32("FVWsxNCKmxVJpNQ",15) == 4173422768) strcat(s, "t");
if (crc32("LOWcmsg",7) == 3718868543) strcat(s, "L");
if (crc32("kJSwP",5) == 3112576820) strcat(s, "l");
if (crc32("pZcxldmrAcDz",12) == 225762361) strcat(s, "h");
if (crc32("uIOiRHJb",8) == 2357879064) strcat(s, "y");
    return s;
}

char *vibratingly_adverbs() {
    char *s = calloc(12);
    if (crc32("hkAeDhbMRam",11) == 2198484129) strcat(s, "T");
if (crc32("bUvZeipXKeD",11) == 1874265168) strcat(s, "v");
if (crc32("CLtyapGZ",8) == 3805330226) strcat(s, "X");
if (crc32("WhsOBmDIuVY",11) == 1096563277) strcat(s, "i");
if (crc32("nzryNnUucMdrSR",14) == 902670067) strcat(s, "b");
if (crc32("VocmqODEYKPN",12) == 2523830180) strcat(s, "h");
if (crc32("nxjIioD",7) == 1087905151) strcat(s, "r");
if (crc32("xJAgBNpr",8) == 3902488296) strcat(s, "g");
if (crc32("TczaY",5) == 353736907) strcat(s, "a");
if (crc32("JiMTIoaKfPXr",12) == 3621633127) strcat(s, "t");
if (crc32("JmNAW",5) == 2068087538) strcat(s, "i");
if (crc32("buibsW",6) == 967584232) strcat(s, "n");
if (crc32("cEKsfHlmSxXrRCB",15) == 2617786919) strcat(s, "g");
if (crc32("xeziJd",6) == 78406827) strcat(s, "l");
if (crc32("TbFKVDdPCfcH",12) == 4163173107) strcat(s, "y");
    return s;
}

char *nontolerably_adverbs() {
    char *s = calloc(13);
    if (crc32("vePqEEQQcbzc",12) == 3978712866) strcat(s, "K");
if (crc32("aicRGyaZfs",10) == 969146572) strcat(s, "n");
if (crc32("XVcDuiiFH",9) == 2086868283) strcat(s, "o");
if (crc32("JRNpppmBl",9) == 1428427898) strcat(s, "e");
if (crc32("tmqyPumnGmGNqJ",14) == 1836414219) strcat(s, "n");
if (crc32("WFsdQwLFrGVvDK",14) == 3238611663) strcat(s, "t");
if (crc32("fQVmMeUsnbTZ",12) == 1391466679) strcat(s, "b");
if (crc32("ToUnBYAIkSuoOGf",15) == 3646192845) strcat(s, "o");
if (crc32("yIaQEEZvSRPfM",13) == 3317750371) strcat(s, "p");
if (crc32("xFgWcHt",7) == 3279630676) strcat(s, "l");
if (crc32("CmUTmbuCzPZeXYz",15) == 3423933080) strcat(s, "e");
if (crc32("DpCEWCZ",7) == 677356586) strcat(s, "v");
if (crc32("ESwClJBvUBeZ",12) == 2382871668) strcat(s, "r");
if (crc32("KIvrVWVyCrH",11) == 1991638895) strcat(s, "a");
if (crc32("RiRBrejrUmfh",12) == 2941753365) strcat(s, "r");
if (crc32("ouPdDvjGlyx",11) == 3349728210) strcat(s, "b");
if (crc32("foVxIKKyW",9) == 151293051) strcat(s, "l");
if (crc32("cDbYywiGGzfznKa",15) == 51303404) strcat(s, "y");
    return s;
}

char *unartfully_adverbs() {
    char *s = calloc(11);
    if (crc32("tHQxVbVfmRz",11) == 1727534902) strcat(s, "u");
if (crc32("gIdMBV",6) == 2106655736) strcat(s, "n");
if (crc32("lGdAnb",6) == 3120114469) strcat(s, "a");
if (crc32("PrNIZgYb",8) == 2172073142) strcat(s, "E");
if (crc32("siuKylHTTQCip",13) == 1206198453) strcat(s, "r");
if (crc32("UojrMaB",7) == 2327014502) strcat(s, "M");
if (crc32("lntifpnBm",9) == 1621854724) strcat(s, "t");
if (crc32("uosZI",5) == 2377573652) strcat(s, "f");
if (crc32("rUbWDN",6) == 990073359) strcat(s, "s");
if (crc32("znJFMk",6) == 577799835) strcat(s, "u");
if (crc32("yoSKEZYTSOWOm",13) == 3093908222) strcat(s, "F");
if (crc32("jRjxXAHwdw",10) == 2733049944) strcat(s, "l");
if (crc32("JLhOKJZIyfMFbhn",15) == 1594820886) strcat(s, "l");
if (crc32("PtXherEd",8) == 4259367823) strcat(s, "y");
    return s;
}

char *dubiously_adverbs() {
    char *s = calloc(10);
    if (crc32("ZbNyiKiedzeQK",13) == 174674668) strcat(s, "J");
if (crc32("iKyrEt",6) == 708758308) strcat(s, "d");
if (crc32("XKNhbfDhvTrPuK",14) == 103575235) strcat(s, "E");
if (crc32("yZaXIrSRvDOZa",13) == 1933344840) strcat(s, "u");
if (crc32("bPvJkCkbZNT",11) == 422469620) strcat(s, "E");
if (crc32("olRYwUOqpDEQlTd",15) == 142214756) strcat(s, "b");
if (crc32("epmtcVdofinwznh",15) == 1312371395) strcat(s, "H");
if (crc32("jOibiI",6) == 1951190042) strcat(s, "i");
if (crc32("KzhUNgqlRecyee",14) == 2882468046) strcat(s, "o");
if (crc32("TiSAIl",6) == 3972917601) strcat(s, "P");
if (crc32("fPgwvrWgdRD",11) == 2803323682) strcat(s, "u");
if (crc32("kcKrz",5) == 3494185179) strcat(s, "s");
if (crc32("htnFtzVaCgjBGCx",15) == 1118244619) strcat(s, "l");
if (crc32("nVVVXnVrL",9) == 2734408521) strcat(s, "y");
    return s;
}

char *sensitometrically_adverbs() {
    char *s = calloc(18);
    if (crc32("EGBiGYSmUNtAemT",15) == 1103027705) strcat(s, "s");
if (crc32("VqKSoY",6) == 2107265755) strcat(s, "e");
if (crc32("mDEloKhR",8) == 3742062912) strcat(s, "v");
if (crc32("WRIVdqQpHHGgg",13) == 3886759357) strcat(s, "n");
if (crc32("wsJreCWt",8) == 4015021549) strcat(s, "s");
if (crc32("tOtzyaP",7) == 1060687301) strcat(s, "i");
if (crc32("Egzhs",5) == 3590296463) strcat(s, "H");
if (crc32("irxiDAJfKide",12) == 3179185293) strcat(s, "t");
if (crc32("IrqDjBmvxWscxtc",15) == 1201407839) strcat(s, "o");
if (crc32("ZwNITjIaqZqUs",13) == 3451751480) strcat(s, "m");
if (crc32("lMSqmidOVO",10) == 1936868000) strcat(s, "e");
if (crc32("HojyYArrUZ",10) == 1103472072) strcat(s, "t");
if (crc32("tkdgiNmel",9) == 1604828510) strcat(s, "r");
if (crc32("VsslincMgWp",11) == 910784374) strcat(s, "h");
if (crc32("JIFFRfvXYBiJVvf",15) == 2407330268) strcat(s, "i");
if (crc32("myeHqJhoWE",10) == 1956445013) strcat(s, "E");
if (crc32("wHQVboeK",8) == 4025625000) strcat(s, "c");
if (crc32("JtmBSePVHtrfs",13) == 2937342609) strcat(s, "D");
if (crc32("FMLWBSuNEsDZ",12) == 194857739) strcat(s, "a");
if (crc32("TTUvnktNowcWdW",14) == 68878059) strcat(s, "V");
if (crc32("NVYcpXDuR",9) == 216578079) strcat(s, "l");
if (crc32("LXcspN",6) == 4131881874) strcat(s, "d");
if (crc32("NYJfV",5) == 1531339243) strcat(s, "l");
if (crc32("nMQxtjztnELI",12) == 3851711333) strcat(s, "y");
    return s;
}

char *inefficaciously_adverbs() {
    char *s = calloc(16);
    if (crc32("QAGBUJALfera",12) == 2493018561) strcat(s, "i");
if (crc32("qzAWANQqPvqhsbh",15) == 2727552643) strcat(s, "J");
if (crc32("RgHkRoS",7) == 3343709808) strcat(s, "n");
if (crc32("uEcMNwaZ",8) == 1687111832) strcat(s, "e");
if (crc32("UMfiZbhGXtc",11) == 2828578956) strcat(s, "Q");
if (crc32("SAVcpgPQYyRO",12) == 2657468037) strcat(s, "f");
if (crc32("pfBMLmrVgXo",11) == 3017997821) strcat(s, "f");
if (crc32("RUsAdIw",7) == 1220241612) strcat(s, "i");
if (crc32("rxwMaCGPky",10) == 921066776) strcat(s, "i");
if (crc32("gyubpdW",7) == 4280460175) strcat(s, "c");
if (crc32("OdlcvAPzcNcXYfe",15) == 606452978) strcat(s, "w");
if (crc32("HLiwDFGKFNwFjz",14) == 721216408) strcat(s, "a");
if (crc32("rlvRevm",7) == 2319567173) strcat(s, "c");
if (crc32("LxqwZ",5) == 1264164762) strcat(s, "i");
if (crc32("gSCfCEhIEC",10) == 784849711) strcat(s, "o");
if (crc32("osuDtacpGWyY",12) == 4121227548) strcat(s, "h");
if (crc32("gnoGHCwCI",9) == 268514286) strcat(s, "u");
if (crc32("miRBj",5) == 1774714880) strcat(s, "P");
if (crc32("kqKGnHyPN",9) == 80304748) strcat(s, "s");
if (crc32("xdSMQJRxM",9) == 1457059991) strcat(s, "l");
if (crc32("zdibkCzeDmicN",13) == 3481848151) strcat(s, "l");
if (crc32("iLZAacD",7) == 3701991575) strcat(s, "y");
    return s;
}

char *unbiliously_adverbs() {
    char *s = calloc(12);
    if (crc32("kYdCnMuDMZppWXz",15) == 972051366) strcat(s, "b");
if (crc32("WoeZtYl",7) == 190556625) strcat(s, "u");
if (crc32("PRcJrf",6) == 2622555994) strcat(s, "D");
if (crc32("fuIzpu",6) == 4000785455) strcat(s, "n");
if (crc32("kEdzkRppdnZsD",13) == 3650880346) strcat(s, "u");
if (crc32("gUlhTrPiSJwXaiT",15) == 4175933950) strcat(s, "b");
if (crc32("klEYQ",5) == 3225936721) strcat(s, "q");
if (crc32("iOEHDAQE",8) == 4025161897) strcat(s, "i");
if (crc32("VrCCQqakablNdW",14) == 753804665) strcat(s, "o");
if (crc32("nnjZkBxFXV",10) == 343777829) strcat(s, "l");
if (crc32("dtfamUxT",8) == 4160395735) strcat(s, "f");
if (crc32("LshknTjekqHuo",13) == 1175991235) strcat(s, "i");
if (crc32("EYJyfy",6) == 1856207353) strcat(s, "o");
if (crc32("PvQzhLGemTgjdD",14) == 1597752837) strcat(s, "v");
if (crc32("kMJeHYCnlqOGTI",14) == 3772690406) strcat(s, "u");
if (crc32("dbQvIdMRXgC",11) == 1977219404) strcat(s, "s");
if (crc32("tWseAbfnOR",10) == 3291618107) strcat(s, "K");
if (crc32("ZCYLzTzA",8) == 3650721050) strcat(s, "l");
if (crc32("iJanCCfGqhJKXN",14) == 3260121483) strcat(s, "y");
    return s;
}

char *rabidly_adverbs() {
    char *s = calloc(8);
    if (crc32("NubBqNvkMIJZ",12) == 3637427612) strcat(s, "r");
if (crc32("AsJyvslESLJ",11) == 3483753001) strcat(s, "a");
if (crc32("TVApTaIkesBAKj",14) == 2181945492) strcat(s, "m");
if (crc32("SvFfYfob",8) == 1170613607) strcat(s, "b");
if (crc32("RCHPC",5) == 649530723) strcat(s, "i");
if (crc32("QDQITX",6) == 1828592486) strcat(s, "d");
if (crc32("ShHjqKESGEZgJww",15) == 494654037) strcat(s, "l");
if (crc32("XIkCPVa",7) == 2024412969) strcat(s, "y");
    return s;
}

char *nonpassionately_adverbs() {
    char *s = calloc(16);
    if (crc32("XLkIqEQvf",9) == 686119987) strcat(s, "n");
if (crc32("WDVjJvm",7) == 997500594) strcat(s, "o");
if (crc32("xNlozkINCo",10) == 887374846) strcat(s, "n");
if (crc32("VwqUPBRSyjd",11) == 2365065738) strcat(s, "L");
if (crc32("sklxmVEQodaDZ",13) == 4173746519) strcat(s, "p");
if (crc32("VnkHbEPaJzDT",12) == 3115981170) strcat(s, "s");
if (crc32("HbVTbTwwTdwXbe",14) == 2799369463) strcat(s, "a");
if (crc32("bNInpVnOJH",10) == 2739706266) strcat(s, "s");
if (crc32("DKZIN",5) == 4138788117) strcat(s, "s");
if (crc32("SRytoW",6) == 732879860) strcat(s, "i");
if (crc32("LxGMGhHiwQrUDZ",14) == 2512496911) strcat(s, "f");
if (crc32("ggRfY",5) == 99175509) strcat(s, "o");
if (crc32("MjSTjCWLSzfiyVm",15) == 3297909011) strcat(s, "Q");
if (crc32("DhbodCzcSnY",11) == 1603210007) strcat(s, "n");
if (crc32("Fvluu",5) == 201052680) strcat(s, "W");
if (crc32("PWDLmS",6) == 2025329893) strcat(s, "a");
if (crc32("hgxlvMMt",8) == 3072812626) strcat(s, "t");
if (crc32("JtODkAlhN",9) == 3787146230) strcat(s, "F");
if (crc32("kUYgBn",6) == 2967134932) strcat(s, "e");
if (crc32("vXJQBKKJfpXZr",13) == 2946773668) strcat(s, "X");
if (crc32("SqvCLPsBFV",10) == 664484378) strcat(s, "l");
if (crc32("LOrfeKuZzaUMBci",15) == 1889605136) strcat(s, "y");
    return s;
}

char *fiendishly_adverbs() {
    char *s = calloc(11);
    if (crc32("XeYQYZeQQLHd",12) == 2831250169) strcat(s, "f");
if (crc32("XFcWtdddRVhEAu",14) == 2910381994) strcat(s, "i");
if (crc32("OMhvcxcGzh",10) == 2725110608) strcat(s, "i");
if (crc32("NLHsFJbVrwfg",12) == 3079260818) strcat(s, "e");
if (crc32("qBPfgUYrg",9) == 3982667045) strcat(s, "n");
if (crc32("IsmxZShTwaLi",12) == 4128082222) strcat(s, "d");
if (crc32("rfGpSRbDZua",11) == 1930097768) strcat(s, "l");
if (crc32("cHwnv",5) == 1438017191) strcat(s, "i");
if (crc32("MDhyDbtwjdlsCkg",15) == 1385286285) strcat(s, "s");
if (crc32("JnLELFYC",8) == 2473530603) strcat(s, "W");
if (crc32("jmcJGadCCQmbDe",14) == 485789858) strcat(s, "h");
if (crc32("jvONfn",6) == 1323429935) strcat(s, "l");
if (crc32("OaZifiCRGRYZs",13) == 2278270381) strcat(s, "p");
if (crc32("SxCqKUaCYEl",11) == 1971057548) strcat(s, "y");
    return s;
}

char *acquiescently_adverbs() {
    char *s = calloc(14);
    if (crc32("qsCpx",5) == 3490034367) strcat(s, "V");
if (crc32("eqWuPhgyIYhWK",13) == 1075053366) strcat(s, "a");
if (crc32("bYgsDgUMkY",10) == 1586834580) strcat(s, "c");
if (crc32("sqDBr",5) == 2684662384) strcat(s, "c");
if (crc32("aKKyz",5) == 478629472) strcat(s, "q");
if (crc32("vJmFTPQ",7) == 2640088444) strcat(s, "t");
if (crc32("ZGmvyXcX",8) == 3177710535) strcat(s, "u");
if (crc32("qNcZcWbYE",9) == 2975552968) strcat(s, "n");
if (crc32("SIusDMrLIUUHLem",15) == 2414849062) strcat(s, "i");
if (crc32("SYkIL",5) == 276830543) strcat(s, "T");
if (crc32("Shekt",5) == 3632173928) strcat(s, "e");
if (crc32("XsWLGAV",7) == 1680697349) strcat(s, "Z");
if (crc32("xGfyKI",6) == 3850387116) strcat(s, "s");
if (crc32("xeRIBE",6) == 3780613122) strcat(s, "J");
if (crc32("czgZCOQQse",10) == 2503386605) strcat(s, "c");
if (crc32("HqQlCAl",7) == 457177137) strcat(s, "n");
if (crc32("osykgIMqCJ",10) == 31746346) strcat(s, "e");
if (crc32("YRxyMdsMtR",10) == 3974161965) strcat(s, "n");
if (crc32("WLPLtdMCdr",10) == 240155151) strcat(s, "t");
if (crc32("PifuCYIJnHDgPi",14) == 3344893455) strcat(s, "l");
if (crc32("xlGbIHVbGtgDjkw",15) == 738519482) strcat(s, "y");
    return s;
}

char *semiorthodoxly_adverbs() {
    char *s = calloc(15);
    if (crc32("yjawHJ",6) == 853545334) strcat(s, "s");
if (crc32("kEbgWruIPqxH",12) == 1138567658) strcat(s, "e");
if (crc32("mryoombAmmdgsB",14) == 3542398834) strcat(s, "g");
if (crc32("mTcLgYIf",8) == 2864940479) strcat(s, "m");
if (crc32("OKCDOLhATETYHQK",15) == 2013772308) strcat(s, "i");
if (crc32("XMqaJVPBhx",10) == 2475219767) strcat(s, "C");
if (crc32("hVnxqeHLtk",10) == 497753798) strcat(s, "o");
if (crc32("cwcmbulfe",9) == 2664319773) strcat(s, "Y");
if (crc32("NwTUlsDTjGpG",12) == 418625582) strcat(s, "r");
if (crc32("gcPxZivlbW",10) == 3859361795) strcat(s, "v");
if (crc32("NeMIphwJMIFmp",13) == 1090656668) strcat(s, "t");
if (crc32("JRYvyfdBAHF",11) == 2063218451) strcat(s, "h");
if (crc32("qepct",5) == 1126292546) strcat(s, "o");
if (crc32("nzNVXd",6) == 454637814) strcat(s, "d");
if (crc32("tWVNSycX",8) == 1067878601) strcat(s, "o");
if (crc32("idLIuWBRX",9) == 274673315) strcat(s, "x");
if (crc32("sUTgcJQk",8) == 2453317193) strcat(s, "X");
if (crc32("moDseEfirjhoQlc",15) == 1284863207) strcat(s, "l");
if (crc32("JYHSyR",6) == 1639987023) strcat(s, "y");
    return s;
}

char *stylographically_adverbs() {
    char *s = calloc(17);
    if (crc32("vAHrIrtPokzK",12) == 46193275) strcat(s, "s");
if (crc32("UFXMDPs",7) == 1354345531) strcat(s, "t");
if (crc32("rifZy",5) == 650721263) strcat(s, "y");
if (crc32("EVluGtNDHQ",10) == 3301707302) strcat(s, "T");
if (crc32("NGYagO",6) == 1569459896) strcat(s, "l");
if (crc32("alYHRe",6) == 642020188) strcat(s, "T");
if (crc32("nBrpScuXEwWX",12) == 1774727565) strcat(s, "o");
if (crc32("MCBvXfW",7) == 2128640305) strcat(s, "R");
if (crc32("fRTGhbJbWG",10) == 2533020375) strcat(s, "g");
if (crc32("psGuNLz",7) == 2319311827) strcat(s, "h");
if (crc32("UNKzEeMcyyXr",12) == 205368551) strcat(s, "r");
if (crc32("xFTpLvKIy",9) == 1088751185) strcat(s, "i");
if (crc32("cPAhxKYBV",9) == 1988563384) strcat(s, "a");
if (crc32("HaMUhGriPbCGRc",14) == 3892183046) strcat(s, "M");
if (crc32("BnRPHCUHWl",10) == 374249281) strcat(s, "p");
if (crc32("HkVteJVqkCY",11) == 1817269705) strcat(s, "F");
if (crc32("wjEWCGcHJEoSWH",14) == 3416003048) strcat(s, "h");
if (crc32("ubwfUyXsO",9) == 3665311297) strcat(s, "k");
if (crc32("XakhTyhcY",9) == 2681409404) strcat(s, "i");
if (crc32("oHdWilrWbx",10) == 2180563510) strcat(s, "W");
if (crc32("ffVYuoBkgs",10) == 3819743029) strcat(s, "c");
if (crc32("IEKGpF",6) == 1903285497) strcat(s, "O");
if (crc32("AAOhIxA",7) == 106126521) strcat(s, "a");
if (crc32("UvVPHIjAA",9) == 4041057168) strcat(s, "I");
if (crc32("ZjrLBsIhrYRQ",12) == 3564065946) strcat(s, "l");
if (crc32("WmafpaQpDeGXG",13) == 2889206306) strcat(s, "l");
if (crc32("xkxVOQPtrCix",12) == 3799569245) strcat(s, "y");
    return s;
}

char *pronto_adverbs() {
    char *s = calloc(7);
    if (crc32("pmSYAo",6) == 1442359392) strcat(s, "p");
if (crc32("AhJAxwqSrU",10) == 3932160710) strcat(s, "A");
if (crc32("gGaPQi",6) == 906498343) strcat(s, "r");
if (crc32("mTBkDYqzRC",10) == 1179896320) strcat(s, "o");
if (crc32("kpHudguwNvDEmD",14) == 3167017311) strcat(s, "n");
if (crc32("ocjnSRT",7) == 3975695240) strcat(s, "t");
if (crc32("yLbWRWuwWvuAnYq",15) == 2566688608) strcat(s, "H");
if (crc32("eNcejiIbVUN",11) == 3455742006) strcat(s, "o");
    return s;
}

char *amorphously_adverbs() {
    char *s = calloc(12);
    if (crc32("HiXjcppH",8) == 2557569688) strcat(s, "a");
if (crc32("iMXDZ",5) == 1182412578) strcat(s, "m");
if (crc32("OFTuJDTqtCTXwna",15) == 377414428) strcat(s, "I");
if (crc32("zYrOmwjuzWAKzb",14) == 2887535852) strcat(s, "o");
if (crc32("OUSrgrBOnuipH",13) == 3011624592) strcat(s, "r");
if (crc32("PZtmQgfqtsOK",12) == 4242674770) strcat(s, "M");
if (crc32("rJDPAZhbKdCYxp",14) == 3415384753) strcat(s, "p");
if (crc32("uVusbRmK",8) == 3508647825) strcat(s, "W");
if (crc32("TtPlZ",5) == 3248888620) strcat(s, "h");
if (crc32("qcXUZmW",7) == 4081331389) strcat(s, "V");
if (crc32("zKpYHI",6) == 195719110) strcat(s, "o");
if (crc32("xKbFTy",6) == 1852293418) strcat(s, "a");
if (crc32("BemCuEMayMPH",12) == 215384686) strcat(s, "u");
if (crc32("vbXzAZ",6) == 3125307191) strcat(s, "s");
if (crc32("keodnqEoIIejX",13) == 1360309333) strcat(s, "l");
if (crc32("CaZReqlNrC",10) == 1068946846) strcat(s, "V");
if (crc32("KYloE",5) == 4196019806) strcat(s, "y");
    return s;
}

char *nonsubtly_adverbs() {
    char *s = calloc(10);
    if (crc32("eNNoaluSnRPSEI",14) == 2717605142) strcat(s, "n");
if (crc32("SZXaqi",6) == 991109046) strcat(s, "e");
if (crc32("ZAfeVyY",7) == 1077693567) strcat(s, "o");
if (crc32("AFMKVHqZ",8) == 1704036894) strcat(s, "C");
if (crc32("RcDghsIhZtpZMyT",15) == 102070878) strcat(s, "n");
if (crc32("VtSxMpFdpuvZ",12) == 1354475007) strcat(s, "W");
if (crc32("fODIlFHRNFVFYlU",15) == 3202010913) strcat(s, "s");
if (crc32("QvxuroYtrurd",12) == 3853828610) strcat(s, "u");
if (crc32("VmtbdzXKbMyDp",13) == 3607706196) strcat(s, "b");
if (crc32("ruzGFf",6) == 3049231749) strcat(s, "t");
if (crc32("aeNbwiLjpETL",12) == 3023506523) strcat(s, "l");
if (crc32("mOgLZaom",8) == 3988984437) strcat(s, "L");
if (crc32("ToUwUcn",7) == 1004728235) strcat(s, "y");
    return s;
}

char *glacially_adverbs() {
    char *s = calloc(10);
    if (crc32("xALStmhZNTe",11) == 2242247753) strcat(s, "g");
if (crc32("rpUHgVC",7) == 1618911427) strcat(s, "R");
if (crc32("pYJZxnIaAZv",11) == 3969184786) strcat(s, "l");
if (crc32("pMEQk",5) == 1495207132) strcat(s, "a");
if (crc32("RxLJn",5) == 4083580081) strcat(s, "c");
if (crc32("HgDnW",5) == 2386101770) strcat(s, "r");
if (crc32("KHIVVANRLQ",10) == 2103058141) strcat(s, "i");
if (crc32("OfZyzZlcdZdw",12) == 1491484739) strcat(s, "Z");
if (crc32("WMQgCGU",7) == 3183441684) strcat(s, "a");
if (crc32("NAdbHpqYbvJSM",13) == 773915207) strcat(s, "l");
if (crc32("nIBOgn",6) == 481435333) strcat(s, "l");
if (crc32("zNnJP",5) == 470194188) strcat(s, "p");
if (crc32("TNbxgJa",7) == 1332149884) strcat(s, "l");
if (crc32("iKopLMDthfrphJ",14) == 1325726657) strcat(s, "y");
    return s;
}

char *zoologically_adverbs() {
    char *s = calloc(13);
    if (crc32("DdVtlxI",7) == 134015311) strcat(s, "z");
if (crc32("jPjxP",5) == 392199087) strcat(s, "z");
if (crc32("ApYehnd",7) == 330862423) strcat(s, "u");
if (crc32("uqzVERp",7) == 278878023) strcat(s, "o");
if (crc32("pIGVXM",6) == 3986986747) strcat(s, "V");
if (crc32("kyJGhlbcMC",10) == 1722092357) strcat(s, "o");
if (crc32("HGDaWtRftNem",12) == 3926333341) strcat(s, "B");
if (crc32("ZBGYmGwCN",9) == 3155154402) strcat(s, "l");
if (crc32("wvivDdgg",8) == 3080997889) strcat(s, "o");
if (crc32("vvCSPwQBpgFF",12) == 508823516) strcat(s, "g");
if (crc32("RVDFKMwoKMyFIn",14) == 229162458) strcat(s, "i");
if (crc32("lVnVmzgJsUL",11) == 4091117902) strcat(s, "c");
if (crc32("QkvOEJl",7) == 3838457291) strcat(s, "d");
if (crc32("RPgEwSfjc",9) == 1807155170) strcat(s, "a");
if (crc32("ftSEs",5) == 1047517493) strcat(s, "B");
if (crc32("LlkcHN",6) == 2598919449) strcat(s, "l");
if (crc32("CQnQJmwma",9) == 3835060505) strcat(s, "l");
if (crc32("CnAHgEVRbXqsq",13) == 2544876167) strcat(s, "y");
    return s;
}

char *foamily_adverbs() {
    char *s = calloc(8);
    if (crc32("stJfBTHsAzl",11) == 466872810) strcat(s, "f");
if (crc32("QiIANLYtPVlNe",13) == 954729266) strcat(s, "o");
if (crc32("YeamjfB",7) == 4029890235) strcat(s, "a");
if (crc32("CRAPwthiqHALwE",14) == 1714056530) strcat(s, "m");
if (crc32("HcAPlDG",7) == 1928910611) strcat(s, "k");
if (crc32("uUeeXEfRdbpzPHr",15) == 1302057288) strcat(s, "i");
if (crc32("eVhLalukfdTJ",12) == 1571740128) strcat(s, "l");
if (crc32("ylqpUqQmu",9) == 3259126038) strcat(s, "y");
    return s;
}

char *offishly_adverbs() {
    char *s = calloc(9);
    if (crc32("BSvuB",5) == 2137743062) strcat(s, "l");
if (crc32("vwOwblJZc",9) == 480374573) strcat(s, "o");
if (crc32("znHHZUzEmMiCl",13) == 2464648254) strcat(s, "f");
if (crc32("YeBeXijjqygGfb",14) == 2543441682) strcat(s, "F");
if (crc32("FqzqMbWIEvz",11) == 4205699934) strcat(s, "f");
if (crc32("cNMvabiOFI",10) == 1186703020) strcat(s, "i");
if (crc32("TkaUBM",6) == 2696708201) strcat(s, "b");
if (crc32("unYLhjGdLvJ",11) == 1381143544) strcat(s, "s");
if (crc32("WTnRmJYrwJkLvOH",15) == 3808371340) strcat(s, "b");
if (crc32("LInBzskXrxuS",12) == 1833821257) strcat(s, "h");
if (crc32("DtyVsVy",7) == 884012608) strcat(s, "l");
if (crc32("QhurZVu",7) == 3148226700) strcat(s, "R");
if (crc32("WuJXHOZv",8) == 4268076226) strcat(s, "y");
    return s;
}

char *coeternally_adverbs() {
    char *s = calloc(12);
    if (crc32("VGgGjUhxYj",10) == 2365847098) strcat(s, "c");
if (crc32("BAglKMaXqXdBy",13) == 2253852740) strcat(s, "o");
if (crc32("fEAyH",5) == 2335715605) strcat(s, "e");
if (crc32("KPEDYFjuqcefVr",14) == 62338383) strcat(s, "t");
if (crc32("OgpprAbIiM",10) == 834495464) strcat(s, "A");
if (crc32("etJcICXiziBq",12) == 4172162032) strcat(s, "e");
if (crc32("blGjlATii",9) == 2324178061) strcat(s, "F");
if (crc32("fedCYHiBrloI",12) == 4294048882) strcat(s, "r");
if (crc32("zGjpQrh",7) == 1284117286) strcat(s, "n");
if (crc32("VaTKBIXdcdUcB",13) == 681270569) strcat(s, "a");
if (crc32("FfKAYXIIsWjRtMP",15) == 1414860523) strcat(s, "l");
if (crc32("sQUrnvJwP",9) == 2682450563) strcat(s, "l");
if (crc32("fpEPs",5) == 2390065199) strcat(s, "e");
if (crc32("uylACtMoQCSaZd",14) == 3985315936) strcat(s, "y");
    return s;
}

char *nonanalogously_adverbs() {
    char *s = calloc(15);
    if (crc32("IgLPBhKrUto",11) == 3174452754) strcat(s, "n");
if (crc32("PjShnzqCN",9) == 510225492) strcat(s, "o");
if (crc32("ZnvPM",5) == 785874530) strcat(s, "Q");
if (crc32("skaYWNKPamD",11) == 4224248888) strcat(s, "n");
if (crc32("LxzLTCrgZ",9) == 601705606) strcat(s, "a");
if (crc32("ACFHFwmzjg",10) == 2549163278) strcat(s, "p");
if (crc32("QOmDmALtql",10) == 1849590374) strcat(s, "n");
if (crc32("EjrBMNCnjmDP",12) == 2168343040) strcat(s, "a");
if (crc32("IYodw",5) == 2847886124) strcat(s, "l");
if (crc32("ZtyaM",5) == 2138514344) strcat(s, "o");
if (crc32("HMsMDieM",8) == 4172577018) strcat(s, "z");
if (crc32("VeSGIajWEFAp",12) == 943040265) strcat(s, "g");
if (crc32("zoxeYeFaYy",10) == 226914004) strcat(s, "Y");
if (crc32("DMLjPZdwwYdIFI",14) == 2517868062) strcat(s, "o");
if (crc32("kUIliwPWhwWa",12) == 3131585812) strcat(s, "E");
if (crc32("wGmxcganxc",10) == 2390347910) strcat(s, "u");
if (crc32("AtCOO",5) == 2763165053) strcat(s, "s");
if (crc32("IXBLFoieUaCia",13) == 1758628626) strcat(s, "l");
if (crc32("AWDOlelvOKU",11) == 565791876) strcat(s, "y");
    return s;
}

char *hypothetically_adverbs() {
    char *s = calloc(15);
    if (crc32("RvwOztmzFaiolMx",15) == 1548921859) strcat(s, "h");
if (crc32("HQKUcmPpCh",10) == 1413514551) strcat(s, "P");
if (crc32("jQyZiJyZxgWVwo",14) == 1706079285) strcat(s, "y");
if (crc32("IknBADSDURZo",12) == 2451456759) strcat(s, "c");
if (crc32("kqxIZjt",7) == 1380726994) strcat(s, "p");
if (crc32("HaLbBBBuAEWSxby",15) == 2501729459) strcat(s, "M");
if (crc32("vxRKM",5) == 1793276732) strcat(s, "o");
if (crc32("ioMqmdIf",8) == 2750739515) strcat(s, "t");
if (crc32("qteoxxWrlTmk",12) == 1711059890) strcat(s, "Q");
if (crc32("WZLVZa",6) == 301473553) strcat(s, "h");
if (crc32("EjwoYicpb",9) == 3682574616) strcat(s, "a");
if (crc32("aFYUIi",6) == 1820217718) strcat(s, "e");
if (crc32("cccRR",5) == 834043569) strcat(s, "y");
if (crc32("hmBxkXKfyVf",11) == 1632294551) strcat(s, "t");
if (crc32("bmzEwnaKdkbahxE",15) == 2268381944) strcat(s, "a");
if (crc32("pXzAIbwXlgbK",12) == 192037045) strcat(s, "i");
if (crc32("jaOjIkMCcGt",11) == 2675629373) strcat(s, "c");
if (crc32("jEiVwQRGPPKqar",14) == 38169402) strcat(s, "a");
if (crc32("AnOyQjYfVkQ",11) == 4102836027) strcat(s, "l");
if (crc32("DMsMfgODuFprM",13) == 3440216434) strcat(s, "l");
if (crc32("rtZtFTaZwBrbds",14) == 231187596) strcat(s, "H");
if (crc32("tFXZUzqZBWMZiuu",15) == 1595727167) strcat(s, "y");
    return s;
}

char *blithefully_adverbs() {
    char *s = calloc(12);
    if (crc32("rIgGGmpRfap",11) == 2039856624) strcat(s, "b");
if (crc32("UhyUHTmLuaI",11) == 2430542029) strcat(s, "l");
if (crc32("dkNaZNfKviZ",11) == 867816282) strcat(s, "O");
if (crc32("AeATq",5) == 667205592) strcat(s, "i");
if (crc32("cszNKlBJyCHU",12) == 2610573053) strcat(s, "t");
if (crc32("tAWAaBNItj",10) == 3611599689) strcat(s, "m");
if (crc32("dIRvAk",6) == 1967047560) strcat(s, "h");
if (crc32("zaSDCItYe",9) == 3844587768) strcat(s, "e");
if (crc32("gqdFoVeBHQfbE",13) == 1026214324) strcat(s, "f");
if (crc32("dHFiysjFEGul",12) == 451718192) strcat(s, "o");
if (crc32("kwIYKoPXpRVV",12) == 777562181) strcat(s, "u");
if (crc32("BKglKXYXQPnDHus",15) == 3144951562) strcat(s, "A");
if (crc32("CaSEUiNpZhwJi",13) == 772495405) strcat(s, "l");
if (crc32("ENVJPOStTYrKrZ",14) == 1183369143) strcat(s, "l");
if (crc32("FsIRoTAZabsuhH",14) == 703049315) strcat(s, "Q");
if (crc32("EpVRQt",6) == 1645455651) strcat(s, "y");
    return s;
}

char *unpreparedly_adverbs() {
    char *s = calloc(13);
    if (crc32("hUWCF",5) == 1082365518) strcat(s, "a");
if (crc32("fLprW",5) == 3177522438) strcat(s, "u");
if (crc32("dZHjfsMO",8) == 968323690) strcat(s, "F");
if (crc32("nADpqYEhbZEWiGX",15) == 4203448604) strcat(s, "n");
if (crc32("lktdyt",6) == 570428275) strcat(s, "p");
if (crc32("PXwqXNd",7) == 2157969335) strcat(s, "r");
if (crc32("lUabrLrfZLEvkZ",14) == 2613594) strcat(s, "g");
if (crc32("SChqo",5) == 2648513331) strcat(s, "e");
if (crc32("usSWGcD",7) == 3445095221) strcat(s, "p");
if (crc32("VLhljrdcl",9) == 2488598695) strcat(s, "Z");
if (crc32("PQbIuHUxCm",10) == 31483078) strcat(s, "a");
if (crc32("oBNulNknuTeSMJ",14) == 740798718) strcat(s, "r");
if (crc32("GeUYakpTI",9) == 1406037083) strcat(s, "e");
if (crc32("EYwvseNubY",10) == 168454045) strcat(s, "l");
if (crc32("uqisOtyNh",9) == 3876738318) strcat(s, "d");
if (crc32("ZmgqnktFvSu",11) == 1734725862) strcat(s, "l");
if (crc32("YfhLoCuj",8) == 1346348829) strcat(s, "y");
    return s;
}

char *overexertedly_adverbs() {
    char *s = calloc(14);
    if (crc32("EMfUJTUFoLx",11) == 2731811001) strcat(s, "C");
if (crc32("MgRoOvebmTuDOi",14) == 1043995500) strcat(s, "o");
if (crc32("ttDnezFgfs",10) == 623801478) strcat(s, "v");
if (crc32("TtOtzxeMoWE",11) == 1383195537) strcat(s, "e");
if (crc32("DQaAcJ",6) == 1729292954) strcat(s, "t");
if (crc32("gNBIjSlGvBz",11) == 2308162942) strcat(s, "r");
if (crc32("PBCBLH",6) == 4238961174) strcat(s, "k");
if (crc32("diqpndL",7) == 1582417355) strcat(s, "e");
if (crc32("uTCOlcBvwPcx",12) == 4173317155) strcat(s, "x");
if (crc32("PnImORuiHmfC",12) == 3278388991) strcat(s, "e");
if (crc32("NKxkwlV",7) == 2705281613) strcat(s, "g");
if (crc32("ruJUFLiF",8) == 2269681847) strcat(s, "r");
if (crc32("vvqRYxmaT",9) == 3135853600) strcat(s, "O");
if (crc32("zhIzCZHNpHw",11) == 2467690026) strcat(s, "t");
if (crc32("FjBKfVZxtNzba",13) == 506830531) strcat(s, "x");
if (crc32("XlrSclcKfBnndB",14) == 470757364) strcat(s, "e");
if (crc32("OMotgnMEU",9) == 2731547114) strcat(s, "M");
if (crc32("wHhIxXvrjK",10) == 3370618817) strcat(s, "d");
if (crc32("cFfjOJ",6) == 516221235) strcat(s, "W");
if (crc32("diNcezoiV",9) == 2459573425) strcat(s, "l");
if (crc32("vhjordjywFSfjW",14) == 1770562890) strcat(s, "x");
if (crc32("HgDYKDcAmFZZnUN",15) == 4096037731) strcat(s, "y");
    return s;
}

char *superimprobably_adverbs() {
    char *s = calloc(16);
    if (crc32("MCwEdCaACIST",12) == 3744233132) strcat(s, "X");
if (crc32("mNiLOStMpgkNqiN",15) == 1263669692) strcat(s, "s");
if (crc32("iCiRIvVi",8) == 3701664095) strcat(s, "u");
if (crc32("wFCKXdjZcLQCAZ",14) == 3975519309) strcat(s, "p");
if (crc32("rQbyZwkOE",9) == 541753403) strcat(s, "e");
if (crc32("BVRJUTvlb",9) == 794874257) strcat(s, "n");
if (crc32("mHtbpul",7) == 1271319373) strcat(s, "r");
if (crc32("cjgsTjkjo",9) == 2667494897) strcat(s, "i");
if (crc32("JLANolGRAF",10) == 435282979) strcat(s, "m");
if (crc32("DfOIgPpaMOVQ",12) == 1508851054) strcat(s, "p");
if (crc32("HYNsgYxA",8) == 2174092075) strcat(s, "r");
if (crc32("fjOlAhirRsC",11) == 1599489630) strcat(s, "t");
if (crc32("TmslfEcRXMIzsh",14) == 3048509999) strcat(s, "o");
if (crc32("vLGniCHHoOGYnWa",15) == 178393962) strcat(s, "b");
if (crc32("CComV",5) == 3652026544) strcat(s, "z");
if (crc32("MJdJwduYqg",10) == 3611557024) strcat(s, "a");
if (crc32("dTsWjyVZkuAHBi",14) == 1766508509) strcat(s, "s");
if (crc32("YioatopelORNk",13) == 2640034972) strcat(s, "b");
if (crc32("DMZkIMLT",8) == 4912842) strcat(s, "l");
if (crc32("pHVjusHfe",9) == 1039539153) strcat(s, "y");
    return s;
}

char *overblindly_adverbs() {
    char *s = calloc(12);
    if (crc32("gvRirGNC",8) == 1067521243) strcat(s, "R");
if (crc32("WCUhbu",6) == 1923699435) strcat(s, "o");
if (crc32("iEJAwUWCAcVJJJT",15) == 133143639) strcat(s, "v");
if (crc32("xRzjdZnhLeJ",11) == 4181813235) strcat(s, "n");
if (crc32("UZeOylgwdHuPL",13) == 2770649785) strcat(s, "e");
if (crc32("opeHH",5) == 3099898489) strcat(s, "r");
if (crc32("aYxvul",6) == 2949835959) strcat(s, "b");
if (crc32("ILKWjnHi",8) == 636165482) strcat(s, "l");
if (crc32("srUWvnzXc",9) == 2342435189) strcat(s, "z");
if (crc32("UsqxdPO",7) == 403195300) strcat(s, "i");
if (crc32("zZZKnV",6) == 3369166689) strcat(s, "n");
if (crc32("dmlzbz",6) == 2357750569) strcat(s, "d");
if (crc32("PBgGyCHMqNjlH",13) == 2559512270) strcat(s, "L");
if (crc32("GDLZCKXbv",9) == 14146922) strcat(s, "l");
if (crc32("IDmehFbeL",9) == 2956552275) strcat(s, "y");
    return s;
}

char *issuably_adverbs() {
    char *s = calloc(9);
    if (crc32("xdPIDkamvNh",11) == 1902935603) strcat(s, "i");
if (crc32("UbJaKbU",7) == 2905090813) strcat(s, "a");
if (crc32("QcCUsxKG",8) == 3885119063) strcat(s, "s");
if (crc32("cOuFrJQdF",9) == 3280348328) strcat(s, "g");
if (crc32("FntJX",5) == 4139148289) strcat(s, "s");
if (crc32("kpwugjYxq",9) == 978318273) strcat(s, "u");
if (crc32("kiunqnLgPA",10) == 1862054688) strcat(s, "r");
if (crc32("uzaoPUmpyQZhjpS",15) == 3741509781) strcat(s, "a");
if (crc32("tQDdzEJBQEYQG",13) == 1269657451) strcat(s, "b");
if (crc32("dxlMlOgdq",9) == 1846658479) strcat(s, "w");
if (crc32("QpxWDbxFwyLv",12) == 416991048) strcat(s, "l");
if (crc32("awFYMhKhcoERvkI",15) == 465322434) strcat(s, "N");
if (crc32("npwKrJJzBQSOTVl",15) == 649064243) strcat(s, "y");
    return s;
}

char *wintrily_adverbs() {
    char *s = calloc(9);
    if (crc32("vQpdxXDpdIrqS",13) == 903575597) strcat(s, "U");
if (crc32("HHUfn",5) == 64747618) strcat(s, "w");
if (crc32("DFqOUi",6) == 1173590643) strcat(s, "m");
if (crc32("cymBM",5) == 2225757519) strcat(s, "i");
if (crc32("ekljriFbPfa",11) == 3913716455) strcat(s, "n");
if (crc32("WITIw",5) == 778200526) strcat(s, "n");
if (crc32("EJfveqjyVfzcEu",14) == 2240878034) strcat(s, "t");
if (crc32("VAeOdm",6) == 1261061434) strcat(s, "r");
if (crc32("ixydmgWs",8) == 385433238) strcat(s, "n");
if (crc32("wtcCVjAzOoO",11) == 1987808053) strcat(s, "i");
if (crc32("liwELcaQVfdi",12) == 1760607263) strcat(s, "l");
if (crc32("hpBrEZwjedsh",12) == 547157634) strcat(s, "O");
if (crc32("IdgAYz",6) == 4180114936) strcat(s, "y");
    return s;
}

char *troublesomely_adverbs() {
    char *s = calloc(14);
    if (crc32("znnSI",5) == 1919327946) strcat(s, "t");
if (crc32("yerWDVNAbSq",11) == 3889982246) strcat(s, "r");
if (crc32("DkOVOXPHqEtoC",13) == 2872896818) strcat(s, "r");
if (crc32("RXnxtMbgXm",10) == 1902261987) strcat(s, "y");
if (crc32("XfnluBkJkX",10) == 3825747481) strcat(s, "o");
if (crc32("qWMFbk",6) == 1800252539) strcat(s, "u");
if (crc32("lqKsgMEqAjz",11) == 2806552154) strcat(s, "u");
if (crc32("qNvZyMEqmVXtKmb",15) == 3883369591) strcat(s, "b");
if (crc32("UOxDjHtqBAvSe",13) == 1810016727) strcat(s, "w");
if (crc32("mHoroIvuj",9) == 3630489087) strcat(s, "l");
if (crc32("QZbZallMsmzQs",13) == 3704760455) strcat(s, "e");
if (crc32("QrCYtxlPSbdt",12) == 2777929208) strcat(s, "s");
if (crc32("tYvbIZqIJGwzhV",14) == 4129985176) strcat(s, "O");
if (crc32("rkcXRN",6) == 1260339089) strcat(s, "o");
if (crc32("DtvGoFbPLlsHVQd",15) == 2957614853) strcat(s, "N");
if (crc32("YBhtYvUi",8) == 32619723) strcat(s, "m");
if (crc32("prfPWsMhuGZXA",13) == 2893078043) strcat(s, "e");
if (crc32("gcDKURutwJHwng",14) == 2437052142) strcat(s, "l");
if (crc32("AVUcA",5) == 1756066723) strcat(s, "y");
    return s;
}

char *prayerlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("QsZal",5) == 3809657575) strcat(s, "p");
if (crc32("tjNqkSZYW",9) == 371230072) strcat(s, "r");
if (crc32("MeIjFcZn",8) == 3487297373) strcat(s, "D");
if (crc32("ZeyyAUdCiqBHz",13) == 2646008447) strcat(s, "a");
if (crc32("mLwRfZe",7) == 1307152272) strcat(s, "n");
if (crc32("BSzrTOIhsLj",11) == 427900320) strcat(s, "y");
if (crc32("qPlsCmTWF",9) == 2700555193) strcat(s, "q");
if (crc32("aHvbe",5) == 113201442) strcat(s, "e");
if (crc32("hFlla",5) == 1664060241) strcat(s, "r");
if (crc32("WFphBUFFYrgM",12) == 828598785) strcat(s, "M");
if (crc32("jXhMzzECPxNvBl",14) == 401793505) strcat(s, "l");
if (crc32("UXImCJpVS",9) == 2242569404) strcat(s, "T");
if (crc32("GJonIDCtaAhOcB",14) == 2180018852) strcat(s, "e");
if (crc32("sJPChzFiRslMcW",14) == 2827905885) strcat(s, "s");
if (crc32("pfUaYihHWmUwK",13) == 3354497641) strcat(s, "r");
if (crc32("sBSKbQzbWfLC",12) == 1602177585) strcat(s, "s");
if (crc32("yoKWlXot",8) == 3795678548) strcat(s, "l");
if (crc32("tTIgIg",6) == 1842287924) strcat(s, "E");
if (crc32("XwvWVQipgdMVl",13) == 2202599948) strcat(s, "y");
    return s;
}

char *nonequilaterally_adverbs() {
    char *s = calloc(17);
    if (crc32("ZOTsKtKWSEY",11) == 3443727494) strcat(s, "n");
if (crc32("DyIkPZvaRkg",11) == 3117778692) strcat(s, "o");
if (crc32("igqvsEDXUFOD",12) == 186752968) strcat(s, "n");
if (crc32("DwweOzT",7) == 3189065455) strcat(s, "e");
if (crc32("mRDoBQHutAsk",12) == 3164627548) strcat(s, "Y");
if (crc32("qvHIcpi",7) == 3579263857) strcat(s, "q");
if (crc32("qDTUKAmBLwgBiB",14) == 282618491) strcat(s, "u");
if (crc32("HLoZkJvsSWysIBr",15) == 1047398940) strcat(s, "O");
if (crc32("iWrmRIM",7) == 2658746825) strcat(s, "i");
if (crc32("nzpfcMBGGBJKzEb",15) == 2796369769) strcat(s, "l");
if (crc32("PpugVLFw",8) == 600134871) strcat(s, "Q");
if (crc32("PZuoaOUTtjZ",11) == 787976745) strcat(s, "a");
if (crc32("UmnbbDKzCVsiIHv",15) == 919411495) strcat(s, "t");
if (crc32("ihsAsiVUGRYYJg",14) == 1130679348) strcat(s, "Z");
if (crc32("mQOVEZw",7) == 2088675461) strcat(s, "e");
if (crc32("IdzHMUMyNROilht",15) == 615928734) strcat(s, "c");
if (crc32("TLpdzBdO",8) == 3222997728) strcat(s, "r");
if (crc32("TfXzAif",7) == 2040790693) strcat(s, "U");
if (crc32("OQjVOgo",7) == 1500411258) strcat(s, "a");
if (crc32("qstRaLCV",8) == 2185579918) strcat(s, "r");
if (crc32("lyKqNTYKvbAgI",13) == 1770738793) strcat(s, "l");
if (crc32("pvKJLjP",7) == 821491874) strcat(s, "k");
if (crc32("jxZiFGpagYmZ",12) == 4244141290) strcat(s, "l");
if (crc32("hJUHsabYKL",10) == 3045712916) strcat(s, "z");
if (crc32("Apakg",5) == 3561275896) strcat(s, "y");
    return s;
}

char *nonruinously_adverbs() {
    char *s = calloc(13);
    if (crc32("jZYgofzkqlBH",12) == 3538930373) strcat(s, "Y");
if (crc32("bCYUHmRN",8) == 1580954927) strcat(s, "n");
if (crc32("SEwIgYoDk",9) == 1574585644) strcat(s, "o");
if (crc32("IdhQTp",6) == 602479084) strcat(s, "m");
if (crc32("iLGrbZRxqE",10) == 2459617147) strcat(s, "n");
if (crc32("MIrMrqKSjS",10) == 2855099801) strcat(s, "n");
if (crc32("WtFgIjzHkWG",11) == 2130190541) strcat(s, "r");
if (crc32("ITQmnLVo",8) == 3644688023) strcat(s, "m");
if (crc32("QbOwGIcJsrqxvph",15) == 3392912144) strcat(s, "u");
if (crc32("faBzmhJ",7) == 3945865437) strcat(s, "i");
if (crc32("KfMiEYPYXzZSQA",14) == 2331957848) strcat(s, "n");
if (crc32("VyAOHpPILOfeo",13) == 3425537547) strcat(s, "v");
if (crc32("XWZZmYftnrwfjU",14) == 2253085445) strcat(s, "o");
if (crc32("HDazJoIYCbk",11) == 459883508) strcat(s, "T");
if (crc32("VdCKDKgxbczVl",13) == 3249818992) strcat(s, "u");
if (crc32("vxaXPlZgoata",12) == 3345818376) strcat(s, "s");
if (crc32("MkKcfckOQ",9) == 2631392269) strcat(s, "l");
if (crc32("rTLkfewznlEbuSZ",15) == 4063588591) strcat(s, "y");
    return s;
}

char *pregnantly_adverbs() {
    char *s = calloc(11);
    if (crc32("ZgoXd",5) == 1766199757) strcat(s, "p");
if (crc32("jtTpiAnbjR",10) == 1974550753) strcat(s, "r");
if (crc32("WPjjhz",6) == 2490725947) strcat(s, "e");
if (crc32("aODGwhe",7) == 609334326) strcat(s, "g");
if (crc32("vUPqouJaHGVEIur",15) == 3602558750) strcat(s, "b");
if (crc32("mBgVMPp",7) == 1645580516) strcat(s, "n");
if (crc32("SiUggPDNusZ",11) == 2690568405) strcat(s, "B");
if (crc32("JQOjuwxLfiBbA",13) == 1659080541) strcat(s, "a");
if (crc32("NQoerKoHxPu",11) == 958579765) strcat(s, "n");
if (crc32("KGDte",5) == 4007326456) strcat(s, "t");
if (crc32("dcHRiee",7) == 2559950705) strcat(s, "w");
if (crc32("xErLywDnV",9) == 3282911120) strcat(s, "l");
if (crc32("vUieXbU",7) == 353199972) strcat(s, "y");
if (crc32("dEkzOZMYg",9) == 453841436) strcat(s, "y");
    return s;
}

char *nontheistically_adverbs() {
    char *s = calloc(16);
    if (crc32("KtKMFZ",6) == 2631613370) strcat(s, "l");
if (crc32("ZnfICjKG",8) == 3335989880) strcat(s, "n");
if (crc32("dJJVJSurXsTOS",13) == 354251737) strcat(s, "W");
if (crc32("bWuhO",5) == 1786245950) strcat(s, "o");
if (crc32("jAiMH",5) == 1556099687) strcat(s, "o");
if (crc32("HCTUeUGkZVUpgzU",15) == 2393499407) strcat(s, "n");
if (crc32("jzTCI",5) == 2932063127) strcat(s, "t");
if (crc32("PaxXtyYDD",9) == 736907909) strcat(s, "h");
if (crc32("EmKiyJ",6) == 3960654882) strcat(s, "e");
if (crc32("tCXBKXfsmmqB",12) == 1781792418) strcat(s, "i");
if (crc32("zSMaIx",6) == 3999264916) strcat(s, "a");
if (crc32("NGetCq",6) == 3440759863) strcat(s, "s");
if (crc32("DbwvtBbsByMCfdF",15) == 163670301) strcat(s, "a");
if (crc32("cePWeKxZWNShM",13) == 84964396) strcat(s, "t");
if (crc32("CUfmF",5) == 638872777) strcat(s, "i");
if (crc32("EBfCKkBkfdUb",12) == 33596557) strcat(s, "c");
if (crc32("ZqPEo",5) == 1539116727) strcat(s, "a");
if (crc32("yXREHJeFzaFMAK",14) == 149884869) strcat(s, "l");
if (crc32("GtYXNfmMM",9) == 3177184048) strcat(s, "U");
if (crc32("kcPjHn",6) == 293903265) strcat(s, "l");
if (crc32("lYjKKTmYC",9) == 3126029223) strcat(s, "M");
if (crc32("yzQwHVFQvqqEky",14) == 2421226551) strcat(s, "y");
    return s;
}

char *scoutingly_adverbs() {
    char *s = calloc(11);
    if (crc32("MsyLmqD",7) == 396117214) strcat(s, "s");
if (crc32("eisRTL",6) == 3403041329) strcat(s, "c");
if (crc32("ZcJZRE",6) == 2287652094) strcat(s, "P");
if (crc32("iLKrpsFdZEUoCG",14) == 761677814) strcat(s, "o");
if (crc32("OIQjjlhi",8) == 3695220300) strcat(s, "u");
if (crc32("kXBqzwRpyz",10) == 91740775) strcat(s, "M");
if (crc32("fHRDh",5) == 917806231) strcat(s, "t");
if (crc32("lWRdTWciutCpFfC",15) == 4274080305) strcat(s, "R");
if (crc32("TrZkDx",6) == 2402738405) strcat(s, "i");
if (crc32("EFpLpFuWK",9) == 1183226864) strcat(s, "y");
if (crc32("jlLamQeZYuO",11) == 962064025) strcat(s, "n");
if (crc32("yKOzRHzCJbCiKl",14) == 3581648140) strcat(s, "g");
if (crc32("AkglrkZ",7) == 2009768610) strcat(s, "j");
if (crc32("cdBWdfakd",9) == 3798308089) strcat(s, "l");
if (crc32("jVEkwz",6) == 2534951977) strcat(s, "y");
    return s;
}

char *nonatomically_adverbs() {
    char *s = calloc(14);
    if (crc32("dBDBUjtF",8) == 542502298) strcat(s, "i");
if (crc32("JvaLhpPf",8) == 3093668719) strcat(s, "n");
if (crc32("nTTtoVdABofp",12) == 3714235760) strcat(s, "V");
if (crc32("LPwjBP",6) == 3955691231) strcat(s, "o");
if (crc32("DwfVkHxQ",8) == 3789559057) strcat(s, "n");
if (crc32("ZhjJz",5) == 2501468591) strcat(s, "O");
if (crc32("ZEyWay",6) == 2789153110) strcat(s, "a");
if (crc32("qCdfmKnBKbI",11) == 59381886) strcat(s, "l");
if (crc32("pufBQvMxPNhs",12) == 1158032424) strcat(s, "t");
if (crc32("bFmwHycmXpBs",12) == 1998305877) strcat(s, "X");
if (crc32("jrgRfCQMVeE",11) == 2146119002) strcat(s, "o");
if (crc32("ZsAuxTVuxV",10) == 1486825291) strcat(s, "s");
if (crc32("fYAnzu",6) == 3459395043) strcat(s, "m");
if (crc32("KzIIdNkWafMhhL",14) == 3537877575) strcat(s, "i");
if (crc32("AymlRQ",6) == 2640624122) strcat(s, "c");
if (crc32("xrXLVtkJjKpCV",13) == 1594222144) strcat(s, "g");
if (crc32("BGcxjCsdfUAyNUl",15) == 1687268402) strcat(s, "a");
if (crc32("KBKzsljYCotHp",13) == 2416737054) strcat(s, "l");
if (crc32("dsVbEYKxnYkxJ",13) == 227053659) strcat(s, "l");
if (crc32("GrsTvcLrvs",10) == 2177597991) strcat(s, "y");
    return s;
}

char *inconveniently_adverbs() {
    char *s = calloc(15);
    if (crc32("uQMBDeZt",8) == 3633542751) strcat(s, "i");
if (crc32("FMxcAcoIRpgI",12) == 3662037003) strcat(s, "n");
if (crc32("QbIZpjVGxF",10) == 3237932677) strcat(s, "N");
if (crc32("TOZrRT",6) == 3945848089) strcat(s, "c");
if (crc32("eaEjyZJO",8) == 3340139818) strcat(s, "o");
if (crc32("glQJgrlbNi",10) == 3854941295) strcat(s, "n");
if (crc32("gbyUX",5) == 1881665887) strcat(s, "X");
if (crc32("AcebEi",6) == 1436487476) strcat(s, "v");
if (crc32("SazfLZuTox",10) == 3562587058) strcat(s, "y");
if (crc32("ZCilhKRI",8) == 2731466866) strcat(s, "e");
if (crc32("YHDjcdrVUzj",11) == 1908668133) strcat(s, "n");
if (crc32("kuhxCnDa",8) == 2476891875) strcat(s, "M");
if (crc32("CvZNN",5) == 160468926) strcat(s, "i");
if (crc32("DUEspgDjozQTMh",14) == 1244378236) strcat(s, "e");
if (crc32("ooPlYKiUyCAYmb",14) == 3810467633) strcat(s, "n");
if (crc32("yPZzpZw",7) == 1157098738) strcat(s, "t");
if (crc32("nytla",5) == 1444046030) strcat(s, "l");
if (crc32("PVhiVKweqjSN",12) == 3215700723) strcat(s, "q");
if (crc32("StEDmPUCOH",10) == 3226459945) strcat(s, "y");
    return s;
}

char *inflexionally_adverbs() {
    char *s = calloc(14);
    if (crc32("vXamBUDWdFqUB",13) == 249359793) strcat(s, "i");
if (crc32("FUvdAByOFwYzSVA",15) == 1561238654) strcat(s, "a");
if (crc32("nqadf",5) == 3757453841) strcat(s, "n");
if (crc32("QDfyiTkQUu",10) == 3720660081) strcat(s, "f");
if (crc32("ReBsuGVuQPpop",13) == 4016098137) strcat(s, "l");
if (crc32("fRLeUQcIs",9) == 612700176) strcat(s, "e");
if (crc32("AkxybCt",7) == 2933556218) strcat(s, "B");
if (crc32("kCntD",5) == 3653933507) strcat(s, "x");
if (crc32("XRGwP",5) == 1783228966) strcat(s, "z");
if (crc32("zmAerGIvQuXbDE",14) == 4210417552) strcat(s, "i");
if (crc32("vOnbtqIKl",9) == 4239092573) strcat(s, "o");
if (crc32("ZBEiJinEs",9) == 19110679) strcat(s, "n");
if (crc32("JIhthIkJGZgfKRJ",15) == 2934356103) strcat(s, "B");
if (crc32("rjpiG",5) == 433930072) strcat(s, "a");
if (crc32("JJhuwST",7) == 2321110478) strcat(s, "l");
if (crc32("xpqqzt",6) == 2575373483) strcat(s, "o");
if (crc32("aSKulRSVLXuEYPu",15) == 2841633217) strcat(s, "l");
if (crc32("uMfQjxSTYBqM",12) == 2888044728) strcat(s, "A");
if (crc32("VqoDydQnNVzGLn",14) == 419543423) strcat(s, "y");
    return s;
}

char *unnumerously_adverbs() {
    char *s = calloc(13);
    if (crc32("BjZeNQx",7) == 515273368) strcat(s, "u");
if (crc32("XFuoQzXzs",9) == 4160820952) strcat(s, "n");
if (crc32("DQcZHO",6) == 3053675813) strcat(s, "n");
if (crc32("yaZyjXbPDPj",11) == 50704695) strcat(s, "u");
if (crc32("FpdmiVzeL",9) == 1210602385) strcat(s, "G");
if (crc32("tUsxATnAU",9) == 4255640278) strcat(s, "m");
if (crc32("YeGxovC",7) == 1089098621) strcat(s, "B");
if (crc32("bGYGcX",6) == 4137529700) strcat(s, "e");
if (crc32("HdVhHWnwyJlinZ",14) == 3692221574) strcat(s, "Y");
if (crc32("XdrprHUlsu",10) == 4258391476) strcat(s, "r");
if (crc32("WomJc",5) == 323135069) strcat(s, "R");
if (crc32("MmuERHcsDLrt",12) == 3177094667) strcat(s, "o");
if (crc32("czROdIBRxqVbwKT",15) == 3852255695) strcat(s, "u");
if (crc32("GUXuwsXLZ",9) == 2370586662) strcat(s, "s");
if (crc32("EoTfJqchplWs",12) == 1289455458) strcat(s, "l");
if (crc32("mHvHSSgMz",9) == 3279595405) strcat(s, "y");
    return s;
}

char *semimythically_adverbs() {
    char *s = calloc(15);
    if (crc32("ihYiz",5) == 3406848062) strcat(s, "s");
if (crc32("eVJYUtODXnzJB",13) == 2361380186) strcat(s, "Q");
if (crc32("EEnRiCnM",8) == 2778745771) strcat(s, "e");
if (crc32("dxkRWZQqCHR",11) == 342355170) strcat(s, "X");
if (crc32("LuHtPqAdIpRUNXJ",15) == 4033937364) strcat(s, "m");
if (crc32("FIhFl",5) == 1399722539) strcat(s, "i");
if (crc32("ptPgtSZX",8) == 1480876224) strcat(s, "N");
if (crc32("pTRHPyQ",7) == 1950688416) strcat(s, "m");
if (crc32("WrQrYQtdwtwlm",13) == 3343590021) strcat(s, "B");
if (crc32("dBjgHBSbLGV",11) == 2650694174) strcat(s, "y");
if (crc32("ZPXFOyuXlE",10) == 4134926399) strcat(s, "u");
if (crc32("cWfevTSiOCR",11) == 1254542996) strcat(s, "t");
if (crc32("RSQFqKDU",8) == 1344611553) strcat(s, "h");
if (crc32("nlvifrQzlzNqXXu",15) == 1001130989) strcat(s, "G");
if (crc32("mhRyvUzOPOl",11) == 570118469) strcat(s, "i");
if (crc32("rxeObVvPZWwoASg",15) == 381181101) strcat(s, "c");
if (crc32("EgiFrxwl",8) == 2288909133) strcat(s, "V");
if (crc32("TmtSEYXEOcoVuE",14) == 693581684) strcat(s, "a");
if (crc32("NZEgWCGKIRBqRr",14) == 1489828646) strcat(s, "l");
if (crc32("pKilScCTeGR",11) == 928729376) strcat(s, "l");
if (crc32("KcGdMmFfAsCq",12) == 261721397) strcat(s, "U");
if (crc32("NZysiSJh",8) == 769923548) strcat(s, "y");
    return s;
}

char *vegetably_adverbs() {
    char *s = calloc(10);
    if (crc32("jugIBeLf",8) == 4074659271) strcat(s, "C");
if (crc32("LDvsHOOjFIdF",12) == 553233545) strcat(s, "v");
if (crc32("syfQnhyEMqD",11) == 1743029906) strcat(s, "D");
if (crc32("rwpEXLBZ",8) == 123845469) strcat(s, "e");
if (crc32("AVcYwPb",7) == 2246648857) strcat(s, "g");
if (crc32("QDSvzANk",8) == 880122267) strcat(s, "x");
if (crc32("rNbjxB",6) == 3148892541) strcat(s, "e");
if (crc32("Wesvzvbs",8) == 3267634806) strcat(s, "a");
if (crc32("OUZBbpPk",8) == 3461438428) strcat(s, "t");
if (crc32("mpyTOqxPrGCWS",13) == 356308766) strcat(s, "a");
if (crc32("jtiOiFHqKhrye",13) == 545829543) strcat(s, "M");
if (crc32("kfmFphMNA",9) == 234378370) strcat(s, "b");
if (crc32("oqPCZfAmtw",10) == 1502210565) strcat(s, "l");
if (crc32("oUKALtCkoPsLVKy",15) == 1350512214) strcat(s, "v");
if (crc32("YdNcVbWndOA",11) == 2505779597) strcat(s, "y");
    return s;
}

char *lurkingly_adverbs() {
    char *s = calloc(10);
    if (crc32("oVgNUxOofhmDiGy",15) == 4162527002) strcat(s, "l");
if (crc32("aJlaWENuFPQgo",13) == 3695862908) strcat(s, "u");
if (crc32("VvrWKOCt",8) == 2840734698) strcat(s, "U");
if (crc32("BQLNRXY",7) == 1611611880) strcat(s, "r");
if (crc32("FUUmKaKZB",9) == 2603632488) strcat(s, "k");
if (crc32("MMFXkqMRlfWwkaa",15) == 2389405256) strcat(s, "i");
if (crc32("uqoCoGz",7) == 1038230564) strcat(s, "n");
if (crc32("alGgpOg",7) == 1937757068) strcat(s, "g");
if (crc32("CuOqaI",6) == 3969801984) strcat(s, "l");
if (crc32("bCEoLmC",7) == 3185163128) strcat(s, "y");
    return s;
}

char *studiedly_adverbs() {
    char *s = calloc(10);
    if (crc32("zNuSceyPWf",10) == 372146941) strcat(s, "s");
if (crc32("NvTecd",6) == 4218853677) strcat(s, "q");
if (crc32("TmEvCDmEha",10) == 481253360) strcat(s, "t");
if (crc32("oJPHfVYvvmi",11) == 1421788270) strcat(s, "u");
if (crc32("CvHXyyCrDyW",11) == 398086754) strcat(s, "r");
if (crc32("QRQAwvDEzhG",11) == 113245406) strcat(s, "d");
if (crc32("ncyoS",5) == 2190754341) strcat(s, "i");
if (crc32("OuJmQNHkMn",10) == 2984072639) strcat(s, "e");
if (crc32("wMcMQu",6) == 1979881160) strcat(s, "L");
if (crc32("VcqFw",5) == 1704172512) strcat(s, "d");
if (crc32("DcmCWzDXrx",10) == 3101637242) strcat(s, "l");
if (crc32("LrqbVoIJsJxqwC",14) == 1597703153) strcat(s, "d");
if (crc32("ZKaEqLMdqWFop",13) == 4023767476) strcat(s, "y");
    return s;
}

char *fetchingly_adverbs() {
    char *s = calloc(11);
    if (crc32("GeVRhVcJEIouT",13) == 959740217) strcat(s, "f");
if (crc32("xIoKttQYAGGl",12) == 2663506580) strcat(s, "k");
if (crc32("vKLEckvmy",9) == 1446658455) strcat(s, "e");
if (crc32("NnQHyzUjidCty",13) == 576837138) strcat(s, "F");
if (crc32("LmJzTuCXuv",10) == 2624081108) strcat(s, "t");
if (crc32("DDzRGzZqIV",10) == 2372978679) strcat(s, "c");
if (crc32("pkFpatvLtS",10) == 2305836158) strcat(s, "h");
if (crc32("tZfTjtQjwZeX",12) == 2943853925) strcat(s, "U");
if (crc32("PmbAOOhrUjnCLcJ",15) == 1387509989) strcat(s, "i");
if (crc32("dDFuqK",6) == 2746301511) strcat(s, "R");
if (crc32("yJODWDoTdl",10) == 319744697) strcat(s, "n");
if (crc32("gHfnXWYvKOj",11) == 4223453948) strcat(s, "D");
if (crc32("WsKeyqXUtCCnK",13) == 1998779216) strcat(s, "g");
if (crc32("CHmfOSajdeTj",12) == 1443702169) strcat(s, "y");
if (crc32("WMMrpsjRZiTszXz",15) == 3159965400) strcat(s, "l");
if (crc32("qTOhHySvJaeBwQ",14) == 1335696373) strcat(s, "g");
if (crc32("gLkNY",5) == 71111903) strcat(s, "y");
    return s;
}

char *rebelliously_adverbs() {
    char *s = calloc(13);
    if (crc32("plTQKuIB",8) == 2957927813) strcat(s, "r");
if (crc32("RsjiErRp",8) == 1372693497) strcat(s, "l");
if (crc32("kDpvTqlDfQApJ",13) == 3932699622) strcat(s, "e");
if (crc32("dwhJJvYcieV",11) == 1046168864) strcat(s, "V");
if (crc32("tJsbzdYhu",9) == 2192037292) strcat(s, "b");
if (crc32("gzUIit",6) == 2006862395) strcat(s, "e");
if (crc32("JxsiLIE",7) == 4171822719) strcat(s, "G");
if (crc32("vQZJMNaBvI",10) == 2341280947) strcat(s, "l");
if (crc32("yghFMpOSBbqvtqp",15) == 2764873208) strcat(s, "O");
if (crc32("opZlLNT",7) == 2476733088) strcat(s, "l");
if (crc32("klxcjzEaOtrSCFc",15) == 3832851215) strcat(s, "g");
if (crc32("LYJFtOnVCqiStLm",15) == 1805517957) strcat(s, "i");
if (crc32("ixJQgNJY",8) == 1840775797) strcat(s, "t");
if (crc32("wyAPGT",6) == 3473752995) strcat(s, "o");
if (crc32("ByNgpcOyPs",10) == 619630086) strcat(s, "f");
if (crc32("LJQsI",5) == 3387190666) strcat(s, "u");
if (crc32("OBZNqMFxIWFh",12) == 809527671) strcat(s, "s");
if (crc32("emjnc",5) == 3104142018) strcat(s, "C");
if (crc32("OPdhAG",6) == 2223343210) strcat(s, "l");
if (crc32("BeIwoAEQqG",10) == 4080398361) strcat(s, "y");
    return s;
}

char *overoffensively_adverbs() {
    char *s = calloc(16);
    if (crc32("XKgRahnljPj",11) == 3830945238) strcat(s, "N");
if (crc32("VHUOdCUQCmTRaI",14) == 524088753) strcat(s, "o");
if (crc32("CLbKNnUOeRr",11) == 3407679590) strcat(s, "v");
if (crc32("wVSAfathgi",10) == 1421939794) strcat(s, "a");
if (crc32("qkjUnvZC",8) == 4059106265) strcat(s, "e");
if (crc32("HpbWvjg",7) == 2223767896) strcat(s, "H");
if (crc32("bMJxL",5) == 2838472067) strcat(s, "r");
if (crc32("YtjUbYr",7) == 182601202) strcat(s, "o");
if (crc32("LayhwloSt",9) == 1481300869) strcat(s, "s");
if (crc32("enySIoA",7) == 3348316357) strcat(s, "f");
if (crc32("ZTTkjdt",7) == 3218829087) strcat(s, "f");
if (crc32("JBmUSuq",7) == 3108392626) strcat(s, "e");
if (crc32("VSJoeoPoGR",10) == 679220531) strcat(s, "n");
if (crc32("rvUVBVqPPxPkNQ",14) == 342199206) strcat(s, "s");
if (crc32("ltEiHNfEvqbQLXz",15) == 4039708868) strcat(s, "i");
if (crc32("wsdUUeYYDVL",11) == 2323336335) strcat(s, "h");
if (crc32("BIHRTCjHcU",10) == 2991133961) strcat(s, "v");
if (crc32("BLyyJdRVSmuCIk",14) == 2342009889) strcat(s, "e");
if (crc32("JQRTMocBtbXB",12) == 2892341149) strcat(s, "l");
if (crc32("QLZCEZcitXKqB",13) == 3937154804) strcat(s, "S");
if (crc32("OFSxhhW",7) == 972665239) strcat(s, "y");
    return s;
}

char *unriotously_adverbs() {
    char *s = calloc(12);
    if (crc32("EhaBsBoqU",9) == 4287786662) strcat(s, "u");
if (crc32("RoivQbH",7) == 424114604) strcat(s, "d");
if (crc32("JNbXJqnE",8) == 3628493883) strcat(s, "n");
if (crc32("ZuhjgRKKV",9) == 1403978326) strcat(s, "r");
if (crc32("bZCEzeEaSsaESi",14) == 2957443515) strcat(s, "i");
if (crc32("lChaXqaxUQb",11) == 3625133556) strcat(s, "l");
if (crc32("yFfxUYfwWCfoztp",15) == 258725538) strcat(s, "o");
if (crc32("tqNHQmNeeIiShi",14) == 4146799511) strcat(s, "k");
if (crc32("sUEuYPAptkeN",12) == 2652141136) strcat(s, "t");
if (crc32("fmaVRH",6) == 367839752) strcat(s, "o");
if (crc32("KUPdNTyQh",9) == 3952797672) strcat(s, "X");
if (crc32("JxsiRwyqmWYBf",13) == 2447810458) strcat(s, "u");
if (crc32("igPiGBNdrc",10) == 1891305416) strcat(s, "s");
if (crc32("oOEhFllC",8) == 64200691) strcat(s, "r");
if (crc32("niUnAXV",7) == 3274093237) strcat(s, "l");
if (crc32("MqAqlIoomR",10) == 2668859775) strcat(s, "y");
    return s;
}

char *reproachingly_adverbs() {
    char *s = calloc(14);
    if (crc32("oKrqCqX",7) == 4107587427) strcat(s, "r");
if (crc32("qEivKqA",7) == 4244167164) strcat(s, "c");
if (crc32("WMyVTVioWn",10) == 513574131) strcat(s, "e");
if (crc32("PqsraqVul",9) == 3489804949) strcat(s, "F");
if (crc32("WBlZBRDROTVfc",13) == 1420399290) strcat(s, "p");
if (crc32("yygfU",5) == 1105800778) strcat(s, "r");
if (crc32("dxGAMoLEsg",10) == 2810803040) strcat(s, "R");
if (crc32("VJXUn",5) == 2326916969) strcat(s, "o");
if (crc32("GyrMobypZTpnRHn",15) == 1169891395) strcat(s, "P");
if (crc32("TFINXQdrudGC",12) == 1584303718) strcat(s, "a");
if (crc32("JaLyqOSxisOlR",13) == 2487830384) strcat(s, "d");
if (crc32("NFlYFYB",7) == 1025693084) strcat(s, "c");
if (crc32("giwuOTCRkDRmk",13) == 2194139432) strcat(s, "M");
if (crc32("lRSDczCrgSH",11) == 2849283) strcat(s, "h");
if (crc32("jfIXvVxxx",9) == 254757361) strcat(s, "D");
if (crc32("yKudtTN",7) == 406752137) strcat(s, "i");
if (crc32("kbPIz",5) == 3793905923) strcat(s, "C");
if (crc32("uWKsctTONwJAFkC",15) == 1861906856) strcat(s, "n");
if (crc32("LsWwNKXtgCGgWKd",15) == 1381164792) strcat(s, "g");
if (crc32("yOmtHKTVfnbBeSR",15) == 740842078) strcat(s, "t");
if (crc32("GQdIJIzVt",9) == 2221428548) strcat(s, "l");
if (crc32("sttBngzC",8) == 461304641) strcat(s, "f");
if (crc32("odJVsdwUzsMiYWE",15) == 2240475460) strcat(s, "y");
    return s;
}

char *subtransversally_adverbs() {
    char *s = calloc(17);
    if (crc32("APfjEssvhwNDsxF",15) == 997082343) strcat(s, "P");
if (crc32("NYMreTTjj",9) == 2507895146) strcat(s, "s");
if (crc32("VBshIqbBi",9) == 2395781303) strcat(s, "u");
if (crc32("CtezKNnEb",9) == 2830483456) strcat(s, "V");
if (crc32("wHLApObEVFrp",12) == 379748600) strcat(s, "b");
if (crc32("pzPPO",5) == 186022095) strcat(s, "t");
if (crc32("oWvnwpikeUKu",12) == 2836508387) strcat(s, "f");
if (crc32("XdIiSVCMpcxmH",13) == 3407499551) strcat(s, "r");
if (crc32("DiQsiWKjSD",10) == 4243327337) strcat(s, "Z");
if (crc32("tITFLaoKJfzkpPZ",15) == 3008121908) strcat(s, "a");
if (crc32("cmNSsDPwf",9) == 1412446273) strcat(s, "n");
if (crc32("BoeWnrVaPGi",11) == 90031138) strcat(s, "G");
if (crc32("AtNEbyqc",8) == 367214853) strcat(s, "s");
if (crc32("yNOpQNDQ",8) == 3262806249) strcat(s, "a");
if (crc32("vSPQkhBbjoxkQ",13) == 1261982044) strcat(s, "v");
if (crc32("oXsznBNHMy",10) == 3029318182) strcat(s, "A");
if (crc32("SRQAdxgEPCU",11) == 77445375) strcat(s, "e");
if (crc32("aowDIKP",7) == 3359727386) strcat(s, "F");
if (crc32("SvmTME",6) == 2899501936) strcat(s, "r");
if (crc32("CccicQqQ",8) == 1115979403) strcat(s, "u");
if (crc32("yYhjAygYNREQaM",14) == 69057587) strcat(s, "s");
if (crc32("ykSuIxAXI",9) == 2299054401) strcat(s, "a");
if (crc32("owjhZHStuTtFVt",14) == 1363804260) strcat(s, "l");
if (crc32("MWSBFMGZBcad",12) == 3250488857) strcat(s, "l");
if (crc32("gtlKO",5) == 3895236007) strcat(s, "A");
if (crc32("iDEFzfXaJZdHs",13) == 701917936) strcat(s, "y");
    return s;
}

char *graciously_adverbs() {
    char *s = calloc(11);
    if (crc32("NAllrxZAwRz",11) == 129783650) strcat(s, "g");
if (crc32("pLviW",5) == 4286509068) strcat(s, "r");
if (crc32("QikTZtm",7) == 2227418935) strcat(s, "a");
if (crc32("qxpMBfKrjTilj",13) == 3041129034) strcat(s, "Y");
if (crc32("LHqHvd",6) == 1063983244) strcat(s, "c");
if (crc32("ahqDZtizKxw",11) == 2686222011) strcat(s, "i");
if (crc32("EdWtHYSdroAjEp",14) == 3444840783) strcat(s, "o");
if (crc32("vnggvvciHGv",11) == 3803854650) strcat(s, "u");
if (crc32("phvPxtoWJ",9) == 2601906774) strcat(s, "s");
if (crc32("QPbnrbKWJHXs",12) == 464030179) strcat(s, "c");
if (crc32("stXZgSkc",8) == 1461533967) strcat(s, "l");
if (crc32("sOeoXaUKjKHsFNs",15) == 1769506211) strcat(s, "p");
if (crc32("VetdyZ",6) == 3825703958) strcat(s, "y");
    return s;
}

char *uncomprehensibly_adverbs() {
    char *s = calloc(17);
    if (crc32("XOqfeHTQi",9) == 3095767859) strcat(s, "u");
if (crc32("haqdHVoMblUMDG",14) == 2739441928) strcat(s, "n");
if (crc32("PBpxvoKkpEZFP",13) == 910506169) strcat(s, "k");
if (crc32("egMpogvbcQSQ",12) == 2573756443) strcat(s, "c");
if (crc32("bgkWgT",6) == 2756754320) strcat(s, "J");
if (crc32("kTSRVdbjrSBF",12) == 1825019554) strcat(s, "o");
if (crc32("dYURHAfTgUBwEp",14) == 2078534919) strcat(s, "X");
if (crc32("quPGBNLjnT",10) == 840339331) strcat(s, "m");
if (crc32("sEiEPLnyxm",10) == 796882705) strcat(s, "X");
if (crc32("NELkKDSIShXRANQ",15) == 3367001345) strcat(s, "p");
if (crc32("jYkDRSgKwp",10) == 2003975328) strcat(s, "W");
if (crc32("himiIqZKxuUUzN",14) == 2046019191) strcat(s, "r");
if (crc32("GJsePTeJQPDz",12) == 154207299) strcat(s, "O");
if (crc32("BKccShfvXc",10) == 176737863) strcat(s, "e");
if (crc32("aFlthM",6) == 375445205) strcat(s, "e");
if (crc32("jFElsE",6) == 549266711) strcat(s, "h");
if (crc32("OHAfXkUz",8) == 220880301) strcat(s, "e");
if (crc32("CjxheMnTx",9) == 2804606971) strcat(s, "g");
if (crc32("RfzhGdAkmyVMuu",14) == 677815126) strcat(s, "n");
if (crc32("MOqzfQgKzROzJf",14) == 1180968692) strcat(s, "O");
if (crc32("SjspbyO",7) == 2696854299) strcat(s, "s");
if (crc32("WxJNL",5) == 2382826387) strcat(s, "i");
if (crc32("VPVHaJDrufLBAOP",15) == 390273171) strcat(s, "b");
if (crc32("hefZaKAwPqs",11) == 810926537) strcat(s, "w");
if (crc32("YSOqPKWhyOCHWZX",15) == 3498248732) strcat(s, "l");
if (crc32("NBxywKDco",9) == 2645419320) strcat(s, "d");
if (crc32("bcrzPHQs",8) == 1729291578) strcat(s, "y");
    return s;
}

char *overinsistently_adverbs() {
    char *s = calloc(16);
    if (crc32("FoQxzoWr",8) == 4121317173) strcat(s, "o");
if (crc32("qGAbKZhQsYyJbig",15) == 399126480) strcat(s, "v");
if (crc32("scJHwshAhbuTOh",14) == 2111562982) strcat(s, "i");
if (crc32("GhXFACzQiJagkr",14) == 1079517017) strcat(s, "e");
if (crc32("wymaVvzVDnj",11) == 3865046826) strcat(s, "r");
if (crc32("kcyVdUErJwdnnma",15) == 2038062950) strcat(s, "i");
if (crc32("aYKtIQYhZO",10) == 341595174) strcat(s, "n");
if (crc32("uhkUDwmydun",11) == 2203614187) strcat(s, "s");
if (crc32("nInOeIH",7) == 2623997440) strcat(s, "i");
if (crc32("AayWUcOj",8) == 2833691693) strcat(s, "B");
if (crc32("gUNwFlWzFClZ",12) == 3038719586) strcat(s, "s");
if (crc32("TCxLpw",6) == 3068870851) strcat(s, "j");
if (crc32("uxWHqQOC",8) == 30684552) strcat(s, "t");
if (crc32("cscUZnDZAQW",11) == 1552464292) strcat(s, "e");
if (crc32("XBieLzzTvWUQwyE",15) == 1821430892) strcat(s, "N");
if (crc32("CafgG",5) == 3568687907) strcat(s, "n");
if (crc32("fYYkCrbVtSfa",12) == 263362685) strcat(s, "P");
if (crc32("rDDHzvSckTac",12) == 3997251147) strcat(s, "t");
if (crc32("pQHWJRl",7) == 957082151) strcat(s, "l");
if (crc32("ixOTt",5) == 250777050) strcat(s, "y");
    return s;
}

char *hypervigilantly_adverbs() {
    char *s = calloc(16);
    if (crc32("hgCuwczYGnYL",12) == 808797695) strcat(s, "h");
if (crc32("OYuSMrK",7) == 1537323430) strcat(s, "N");
if (crc32("XEbcnAtAzB",10) == 2058774291) strcat(s, "y");
if (crc32("PSPxeOzDqbDD",12) == 2105845230) strcat(s, "b");
if (crc32("WnmkcU",6) == 1582614208) strcat(s, "p");
if (crc32("YRyobUbPXfHdWbc",15) == 3675203723) strcat(s, "c");
if (crc32("KgJYlfo",7) == 3316663155) strcat(s, "e");
if (crc32("OafZvzNqr",9) == 1176442515) strcat(s, "Y");
if (crc32("CBlfqlqToYATg",13) == 972962484) strcat(s, "r");
if (crc32("HkgMnhhHHSkP",12) == 680883245) strcat(s, "R");
if (crc32("CxBJElwVcJA",11) == 80192612) strcat(s, "v");
if (crc32("oNlCkrbb",8) == 1469926287) strcat(s, "i");
if (crc32("rmefzThRNNh",11) == 2843127235) strcat(s, "g");
if (crc32("HqaxImgP",8) == 948652303) strcat(s, "i");
if (crc32("VUaSruSKJZI",11) == 1773876580) strcat(s, "s");
if (crc32("AOtCzJKv",8) == 1859289069) strcat(s, "l");
if (crc32("lRjHLmlK",8) == 2823223113) strcat(s, "V");
if (crc32("hvpWSISDnsZDi",13) == 1345881479) strcat(s, "a");
if (crc32("wNNduqRwUEWK",12) == 346573118) strcat(s, "n");
if (crc32("itXysV",6) == 1225216280) strcat(s, "W");
if (crc32("TtdAfHdDTR",10) == 1722555934) strcat(s, "t");
if (crc32("kKmZCCeYUMZl",12) == 1307042063) strcat(s, "z");
if (crc32("hNyiDdEG",8) == 4094288019) strcat(s, "l");
if (crc32("fIyigoVk",8) == 3384872559) strcat(s, "y");
    return s;
}

char *incoherently_adverbs() {
    char *s = calloc(13);
    if (crc32("SrqCr",5) == 4287342083) strcat(s, "O");
if (crc32("XcERZncNwyxbqyi",15) == 3633611864) strcat(s, "i");
if (crc32("KZSjHhazSLUuRG",14) == 2859547143) strcat(s, "B");
if (crc32("dJoRiZESMWnGb",13) == 1708978521) strcat(s, "n");
if (crc32("zXpvmHQOYxm",11) == 1068750581) strcat(s, "c");
if (crc32("TgCdkhAKDCLW",12) == 3940861910) strcat(s, "T");
if (crc32("DcKKAFtqAQQ",11) == 902749017) strcat(s, "o");
if (crc32("jJlbOnxwgQK",11) == 3359394934) strcat(s, "h");
if (crc32("yCZJfme",7) == 2950121052) strcat(s, "s");
if (crc32("eBzrixfbAh",10) == 2064324026) strcat(s, "e");
if (crc32("psdASI",6) == 1595426429) strcat(s, "r");
if (crc32("KcgfiNOwwdFOnE",14) == 681361826) strcat(s, "e");
if (crc32("LkCKbaAzkRqP",12) == 2948409607) strcat(s, "Q");
if (crc32("tKOOrngITSOCZD",14) == 2050591997) strcat(s, "n");
if (crc32("VwOlENigsH",10) == 2954640889) strcat(s, "t");
if (crc32("lqlpYAh",7) == 456708429) strcat(s, "l");
if (crc32("eTMJQmBAj",9) == 1370126019) strcat(s, "l");
if (crc32("RwIMmAswQ",9) == 3512800211) strcat(s, "b");
if (crc32("lKtutiG",7) == 3945386416) strcat(s, "y");
    return s;
}

char *remonstratingly_adverbs() {
    char *s = calloc(16);
    if (crc32("eUzLjxPS",8) == 4259209180) strcat(s, "r");
if (crc32("EaQzNM",6) == 105234022) strcat(s, "e");
if (crc32("nUAhZGQTE",9) == 2206675523) strcat(s, "X");
if (crc32("aREdtwWDrPMip",13) == 3728999986) strcat(s, "m");
if (crc32("EwaLkfwCBcqP",12) == 4026437777) strcat(s, "M");
if (crc32("LJFmrRYfsseeV",13) == 1512293729) strcat(s, "o");
if (crc32("liJIlLPuBWNFi",13) == 1483826159) strcat(s, "n");
if (crc32("fPIVwRiVaPBK",12) == 3790850450) strcat(s, "s");
if (crc32("fuJVMbrvkuH",11) == 3625469508) strcat(s, "t");
if (crc32("lGuESgsXCTMS",12) == 1750589068) strcat(s, "r");
if (crc32("jEgUZt",6) == 1392802236) strcat(s, "a");
if (crc32("DzQpguvvKBzN",12) == 3078877430) strcat(s, "E");
if (crc32("RfWvJvn",7) == 2643377413) strcat(s, "t");
if (crc32("zWVoV",5) == 734456259) strcat(s, "i");
if (crc32("BttjDvyRqHXcBB",14) == 1004787197) strcat(s, "n");
if (crc32("LcxgQvvKyZfnIGE",15) == 2128520219) strcat(s, "g");
if (crc32("ToOGy",5) == 2245239780) strcat(s, "l");
if (crc32("uIBWIhNgJhu",11) == 2912569964) strcat(s, "y");
    return s;
}

char *grossly_adverbs() {
    char *s = calloc(8);
    if (crc32("HZqoq",5) == 1999046757) strcat(s, "a");
if (crc32("XnYxH",5) == 3912555588) strcat(s, "g");
if (crc32("hMVibGMSx",9) == 1581943242) strcat(s, "e");
if (crc32("cqhTMFsmPMZ",11) == 2765856488) strcat(s, "r");
if (crc32("dntZGvBpv",9) == 4038244831) strcat(s, "p");
if (crc32("BgPwbcA",7) == 2443871502) strcat(s, "o");
if (crc32("jnYauSZPG",9) == 2531552131) strcat(s, "B");
if (crc32("WMITdHOa",8) == 2101394824) strcat(s, "s");
if (crc32("XXbjzEzvXMK",11) == 474651564) strcat(s, "s");
if (crc32("UPEXrONp",8) == 2294834676) strcat(s, "l");
if (crc32("WQFjLrtDQoVXq",13) == 1061634029) strcat(s, "w");
if (crc32("ufPoa",5) == 1563506795) strcat(s, "y");
    return s;
}

char *resentfully_adverbs() {
    char *s = calloc(12);
    if (crc32("MWvWKCMAZVizAg",14) == 3230228632) strcat(s, "F");
if (crc32("yHxreHxIuRE",11) == 263264870) strcat(s, "r");
if (crc32("EIFehULSfh",10) == 1906521114) strcat(s, "c");
if (crc32("xcBFshu",7) == 2335932955) strcat(s, "e");
if (crc32("RJQhhFvocsoCEk",14) == 3545844417) strcat(s, "s");
if (crc32("ugamQkNdaSewD",13) == 1276192103) strcat(s, "m");
if (crc32("HDXBCeEpFz",10) == 2383986955) strcat(s, "e");
if (crc32("aDCIkh",6) == 1152857820) strcat(s, "u");
if (crc32("fpoxWSChHgEhz",13) == 1519629754) strcat(s, "n");
if (crc32("NFFmA",5) == 973177674) strcat(s, "t");
if (crc32("VQZtZSQgiI",10) == 2975800290) strcat(s, "r");
if (crc32("DypWHqAjaQjTXdH",15) == 3128905939) strcat(s, "f");
if (crc32("ijZMifdNnfD",11) == 77210956) strcat(s, "u");
if (crc32("dpFkR",5) == 3067409866) strcat(s, "l");
if (crc32("vYmAryfBtWCzoZ",14) == 604140536) strcat(s, "l");
if (crc32("PPkzKvGSLLM",11) == 3434535531) strcat(s, "y");
    return s;
}

char *undynamically_adverbs() {
    char *s = calloc(14);
    if (crc32("tQNsxqyhr",9) == 195593936) strcat(s, "J");
if (crc32("bAtotvcMKNZNu",13) == 297067400) strcat(s, "u");
if (crc32("eXollcP",7) == 2866529621) strcat(s, "n");
if (crc32("hABOBpnurbsZPx",14) == 4022830039) strcat(s, "a");
if (crc32("uXXKFtY",7) == 2858702222) strcat(s, "d");
if (crc32("DUcDnv",6) == 2516349388) strcat(s, "M");
if (crc32("HuUhXuingbf",11) == 2519402222) strcat(s, "y");
if (crc32("iPuJPvB",7) == 681131761) strcat(s, "D");
if (crc32("BIzYUmTCKuJm",12) == 1833131268) strcat(s, "n");
if (crc32("nXZNgPI",7) == 1467212797) strcat(s, "a");
if (crc32("WvVlj",5) == 3455966580) strcat(s, "L");
if (crc32("CQwoIwl",7) == 1557906511) strcat(s, "m");
if (crc32("PbbOOPJNkRTTDq",14) == 2655416334) strcat(s, "F");
if (crc32("toyDGhSl",8) == 604833655) strcat(s, "i");
if (crc32("gBOZKvCbGkTOa",13) == 99272056) strcat(s, "P");
if (crc32("xFWXWPX",7) == 2845319282) strcat(s, "c");
if (crc32("ZumAjMloUNNJvoX",15) == 3931017579) strcat(s, "i");
if (crc32("EZMAZqKvKST",11) == 263664445) strcat(s, "a");
if (crc32("zyZFQPUvFEFJV",13) == 1245515785) strcat(s, "M");
if (crc32("JZyQyVPezUB",11) == 2775495187) strcat(s, "l");
if (crc32("CgySuI",6) == 916027716) strcat(s, "l");
if (crc32("DOpzrciJ",8) == 1801946703) strcat(s, "y");
    return s;
}

char *zeugmatically_adverbs() {
    char *s = calloc(14);
    if (crc32("KwgQmaXfcwc",11) == 3930511670) strcat(s, "z");
if (crc32("RthpOrACjODuTv",14) == 3471767589) strcat(s, "e");
if (crc32("YyKVoEhNuV",10) == 2036237809) strcat(s, "p");
if (crc32("kJKEkxltaNyUI",13) == 2159255730) strcat(s, "u");
if (crc32("WkjgbyZXVtN",11) == 4269692881) strcat(s, "g");
if (crc32("vtdzOHDLRSpfdr",14) == 202330452) strcat(s, "m");
if (crc32("VpaPtuyGnv",10) == 2599882206) strcat(s, "b");
if (crc32("iecVDrwxEnc",11) == 3409240489) strcat(s, "a");
if (crc32("ydpCuzMooMS",11) == 3060564808) strcat(s, "a");
if (crc32("RPdYILCL",8) == 3425718525) strcat(s, "t");
if (crc32("jrpZvzALG",9) == 930092185) strcat(s, "i");
if (crc32("wDSPWCtEuJU",11) == 1031436335) strcat(s, "T");
if (crc32("zoIMgOO",7) == 3427894562) strcat(s, "c");
if (crc32("RNtjFSQ",7) == 3705246995) strcat(s, "t");
if (crc32("uTFKbnQbrQPBEHg",15) == 2555096311) strcat(s, "a");
if (crc32("Korat",5) == 4139723501) strcat(s, "l");
if (crc32("bxNdcDzo",8) == 964411909) strcat(s, "q");
if (crc32("OFqdVuoDVcFLMrE",15) == 3110237442) strcat(s, "l");
if (crc32("XNLQdFCZdYbUzP",14) == 3427212373) strcat(s, "Z");
if (crc32("ncgMuXDQSUUq",12) == 1498890384) strcat(s, "y");
    return s;
}

char *goodhumoredly_adverbs() {
    char *s = calloc(14);
    if (crc32("fckOUWqFvZ",10) == 1377347276) strcat(s, "h");
if (crc32("zwtzSZOdNJikVvE",15) == 1122137617) strcat(s, "g");
if (crc32("XEzqSM",6) == 155618597) strcat(s, "o");
if (crc32("tjbZjXTOpl",10) == 225301485) strcat(s, "U");
if (crc32("nBfFwOUFXZOjFgN",15) == 977705611) strcat(s, "o");
if (crc32("Lkmkl",5) == 889517371) strcat(s, "d");
if (crc32("nYpNn",5) == 2829334167) strcat(s, "x");
if (crc32("oLhbssmZSwSkT",13) == 2377180457) strcat(s, "h");
if (crc32("BEHcCm",6) == 2548079512) strcat(s, "J");
if (crc32("CYWxGKhyNVZ",11) == 1320633642) strcat(s, "u");
if (crc32("ZUKXcfIiySxY",12) == 2353786643) strcat(s, "m");
if (crc32("rFMafCcpT",9) == 2812350605) strcat(s, "o");
if (crc32("UUsRdfsXPkIRYn",14) == 2048592819) strcat(s, "r");
if (crc32("QbHRGxpKeTgKwmO",15) == 1785548670) strcat(s, "e");
if (crc32("FYKcVK",6) == 2585522429) strcat(s, "H");
if (crc32("CfJLBwFMPbxGtzp",15) == 821421150) strcat(s, "d");
if (crc32("QiVzn",5) == 2459182798) strcat(s, "l");
if (crc32("dDJJuYgsstHKo",13) == 3441478866) strcat(s, "p");
if (crc32("BjgaH",5) == 4193494450) strcat(s, "y");
    return s;
}

char *yes_adverbs() {
    char *s = calloc(4);
    if (crc32("eKJbJWrBNTbQb",13) == 2114077788) strcat(s, "Q");
if (crc32("cTEfaqtotKQNZK",14) == 1676921523) strcat(s, "y");
if (crc32("LGMOVx",6) == 2198644268) strcat(s, "e");
if (crc32("yRSDAIHqqQZSofI",15) == 3483239059) strcat(s, "s");
    return s;
}

char *overloudly_adverbs() {
    char *s = calloc(11);
    if (crc32("WqVlaX",6) == 3523654025) strcat(s, "o");
if (crc32("yoCPSbiTyjeUFp",14) == 3570147808) strcat(s, "v");
if (crc32("jCpZEnJKo",9) == 827102264) strcat(s, "e");
if (crc32("GgZcz",5) == 355186654) strcat(s, "r");
if (crc32("CAEZMPDgt",9) == 1995289895) strcat(s, "G");
if (crc32("hMubImuGOrkTCOI",15) == 2348563321) strcat(s, "l");
if (crc32("FPcnGYyqxek",11) == 1501930165) strcat(s, "o");
if (crc32("EgmwXtXIddu",11) == 4107064932) strcat(s, "u");
if (crc32("MSkgohwajgm",11) == 1569209258) strcat(s, "r");
if (crc32("XyYxx",5) == 35881934) strcat(s, "d");
if (crc32("jhEkNvKuF",9) == 1088754562) strcat(s, "l");
if (crc32("kyHWlbcfSpA",11) == 2708267161) strcat(s, "y");
    return s;
}

char *aoristically_adverbs() {
    char *s = calloc(13);
    if (crc32("AYliqBZo",8) == 762673988) strcat(s, "g");
if (crc32("UhPCuwbFvnxnvW",14) == 4283737133) strcat(s, "a");
if (crc32("bieBaGaxTSbp",12) == 749795905) strcat(s, "w");
if (crc32("FAlPGqYU",8) == 201411489) strcat(s, "o");
if (crc32("MycgsBoMSeNLnU",14) == 2001571806) strcat(s, "i");
if (crc32("YOOzybsl",8) == 3440805341) strcat(s, "r");
if (crc32("pvjPYILWUm",10) == 3771226201) strcat(s, "g");
if (crc32("QeXgAGEUgKOjWq",14) == 2398963711) strcat(s, "i");
if (crc32("PQlAqJvuZ",9) == 374787862) strcat(s, "F");
if (crc32("CNGQyJbd",8) == 3070526344) strcat(s, "s");
if (crc32("hbDtknfeuHSiMG",14) == 1903347060) strcat(s, "I");
if (crc32("OHjqRPD",7) == 1746393337) strcat(s, "t");
if (crc32("QLVWlNUCMt",10) == 4236523782) strcat(s, "i");
if (crc32("xDFvhNjrBJmuo",13) == 2988185068) strcat(s, "c");
if (crc32("lHYZwiTuoF",10) == 66689785) strcat(s, "M");
if (crc32("OtmguWUZk",9) == 2802052132) strcat(s, "a");
if (crc32("CEKsoasOYpTdRe",14) == 807711820) strcat(s, "o");
if (crc32("Oegkxksiu",9) == 3026821901) strcat(s, "l");
if (crc32("ksnpXIitTqLKxLq",15) == 1723301259) strcat(s, "D");
if (crc32("mvTPiWTdC",9) == 3171366363) strcat(s, "l");
if (crc32("PNoffpiBWdibvTn",15) == 1606948002) strcat(s, "E");
if (crc32("suvJmyuJBsoFJJH",15) == 162342265) strcat(s, "y");
    return s;
}

char *cosily_adverbs() {
    char *s = calloc(7);
    if (crc32("jqNYTZARLlc",11) == 2250609030) strcat(s, "c");
if (crc32("egJxm",5) == 2565416599) strcat(s, "o");
if (crc32("YaLKDUpmMw",10) == 286360523) strcat(s, "s");
if (crc32("uCzwg",5) == 2491390269) strcat(s, "i");
if (crc32("WiDAmHPfZUaNssC",15) == 2816386472) strcat(s, "h");
if (crc32("bsWhfDAP",8) == 2037519529) strcat(s, "l");
if (crc32("YxHxwGE",7) == 3283368040) strcat(s, "C");
if (crc32("HHXYVQeZei",10) == 2779786738) strcat(s, "y");
    return s;
}

char *alarmedly_adverbs() {
    char *s = calloc(10);
    if (crc32("JVjIJWMqFTgYOe",14) == 1729293535) strcat(s, "y");
if (crc32("JlbWqwjXgVClbua",15) == 1195312917) strcat(s, "a");
if (crc32("GSNLrRhWQ",9) == 2797145753) strcat(s, "l");
if (crc32("eZlzSHp",7) == 3085461953) strcat(s, "a");
if (crc32("MpTEjnEASez",11) == 3483952491) strcat(s, "r");
if (crc32("WqmGGRuxx",9) == 136928725) strcat(s, "r");
if (crc32("OeLoHReK",8) == 3907871676) strcat(s, "I");
if (crc32("bMFHqUCPoN",10) == 667087964) strcat(s, "m");
if (crc32("njQPW",5) == 3884569677) strcat(s, "B");
if (crc32("WSjKC",5) == 749833368) strcat(s, "e");
if (crc32("EBqKDwbmKATDL",13) == 730980397) strcat(s, "d");
if (crc32("nkSHR",5) == 3456490093) strcat(s, "D");
if (crc32("cihOkNdRLyxig",13) == 3870409940) strcat(s, "l");
if (crc32("tsAyCiXmkzQyLL",14) == 1075859826) strcat(s, "V");
if (crc32("OUgSIdHpFf",10) == 816567471) strcat(s, "y");
    return s;
}

char *nondepressingly_adverbs() {
    char *s = calloc(16);
    if (crc32("wpamATaYkpaM",12) == 2254744501) strcat(s, "z");
if (crc32("bJwvnCZLIVNZP",13) == 2985495001) strcat(s, "n");
if (crc32("wqolesic",8) == 369330824) strcat(s, "o");
if (crc32("BGAvP",5) == 2172974275) strcat(s, "n");
if (crc32("dhqdMVxykO",10) == 1382678560) strcat(s, "d");
if (crc32("fxReT",5) == 1943663933) strcat(s, "U");
if (crc32("BLaYvqjS",8) == 227347189) strcat(s, "e");
if (crc32("ogbhjXD",7) == 3583211502) strcat(s, "c");
if (crc32("nEAmIaqeq",9) == 4177630761) strcat(s, "p");
if (crc32("LclpeEnjiKeEhbI",15) == 3854700950) strcat(s, "Z");
if (crc32("BIKqNquDFRjfd",13) == 1160850485) strcat(s, "r");
if (crc32("ZepRokzljK",10) == 3337354820) strcat(s, "j");
if (crc32("WFYoo",5) == 2926312889) strcat(s, "e");
if (crc32("DsGTVYv",7) == 2338779473) strcat(s, "V");
if (crc32("sJlSc",5) == 2283395434) strcat(s, "s");
if (crc32("fSsCCr",6) == 2127939778) strcat(s, "s");
if (crc32("fuocyzcE",8) == 3992040992) strcat(s, "i");
if (crc32("aAomq",5) == 2300402602) strcat(s, "i");
if (crc32("XLTkcrsDHIXbd",13) == 3137501149) strcat(s, "n");
if (crc32("KEfUiPx",7) == 3720121937) strcat(s, "E");
if (crc32("zFnagVRDvCBqB",13) == 3306547601) strcat(s, "g");
if (crc32("XyANGBcFScBkoDP",15) == 1781482608) strcat(s, "l");
if (crc32("hsYSpTh",7) == 2373432847) strcat(s, "y");
    return s;
}

char *quasiuniversally_adverbs() {
    char *s = calloc(17);
    if (crc32("BixSqFAm",8) == 4281714245) strcat(s, "t");
if (crc32("bpEYPnTngwb",11) == 3254905198) strcat(s, "q");
if (crc32("vXXuA",5) == 86017989) strcat(s, "z");
if (crc32("eYloKNFqYN",10) == 1661094428) strcat(s, "u");
if (crc32("IBShr",5) == 3398233561) strcat(s, "W");
if (crc32("ypJsAvB",7) == 345510374) strcat(s, "a");
if (crc32("eGtuVOADHo",10) == 1226780312) strcat(s, "s");
if (crc32("TwweLlF",7) == 883728615) strcat(s, "i");
if (crc32("bYrVlL",6) == 3738743117) strcat(s, "u");
if (crc32("wzpMVxObBwVifiP",15) == 660480333) strcat(s, "n");
if (crc32("HpsuuVfHVkxNP",13) == 2634494565) strcat(s, "i");
if (crc32("ZAHROuuHXptzZ",13) == 1660536906) strcat(s, "W");
if (crc32("FEzmhf",6) == 3047727778) strcat(s, "v");
if (crc32("KVnmspsAufSAU",13) == 1875989713) strcat(s, "e");
if (crc32("XOTGrvtaGN",10) == 1757307303) strcat(s, "M");
if (crc32("ZnLmg",5) == 360527346) strcat(s, "r");
if (crc32("kbIyDAKdQFzaZ",13) == 2173509967) strcat(s, "C");
if (crc32("UoKGo",5) == 1265539033) strcat(s, "s");
if (crc32("qzFvZZtakkSJbB",14) == 1146455714) strcat(s, "a");
if (crc32("XMUuBQvHSNVN",12) == 1017919975) strcat(s, "l");
if (crc32("WdeDQyBBwiJgo",13) == 1397901273) strcat(s, "y");
if (crc32("QDSLhRPbIPUpOSz",15) == 2461443731) strcat(s, "l");
if (crc32("MkpcfyfvG",9) == 1250134083) strcat(s, "K");
if (crc32("SuwfpU",6) == 2221295487) strcat(s, "y");
    return s;
}

char *loosest_adverbs() {
    char *s = calloc(8);
    if (crc32("FedxXvab",8) == 2282158142) strcat(s, "l");
if (crc32("gUjYKMJStkTkw",13) == 3896096509) strcat(s, "P");
if (crc32("ZmhVtCpFMxbh",12) == 1408752292) strcat(s, "o");
if (crc32("WMfQEVZgSv",10) == 3827284966) strcat(s, "o");
if (crc32("tmQWlkEYpPOr",12) == 758526058) strcat(s, "o");
if (crc32("vkvyBkgqpA",10) == 1842950640) strcat(s, "N");
if (crc32("tAwSSaRulP",10) == 3728477466) strcat(s, "s");
if (crc32("MdPIZACPxeexS",13) == 561260962) strcat(s, "e");
if (crc32("RnKjQSCZoKmRvqM",15) == 1705341218) strcat(s, "F");
if (crc32("gTlzwZQRJE",10) == 1149122318) strcat(s, "s");
if (crc32("BlBfjEmV",8) == 1053165525) strcat(s, "S");
if (crc32("qPCCvebdPI",10) == 3175187385) strcat(s, "t");
    return s;
}

char *creakingly_adverbs() {
    char *s = calloc(11);
    if (crc32("sJcsvaXBUBbT",12) == 3725127776) strcat(s, "c");
if (crc32("UkXABJU",7) == 3372069351) strcat(s, "D");
if (crc32("UZIHzjeCpEWg",12) == 747049466) strcat(s, "r");
if (crc32("ZkEBlPS",7) == 2824049231) strcat(s, "P");
if (crc32("DKyTWAr",7) == 3330291857) strcat(s, "e");
if (crc32("eEjACEyiIs",10) == 1129269052) strcat(s, "a");
if (crc32("nfCAeVzhavElgM",14) == 2708729414) strcat(s, "k");
if (crc32("yoIOwgptXWuc",12) == 1825832013) strcat(s, "i");
if (crc32("ouIUdyooIYerh",13) == 698279830) strcat(s, "y");
if (crc32("axspkKhZDK",10) == 4291940607) strcat(s, "n");
if (crc32("ySzQkqvwHjYy",12) == 2591956521) strcat(s, "O");
if (crc32("OryXVTyywMWYKe",14) == 2606566785) strcat(s, "g");
if (crc32("VIbcjmlCEWlxH",13) == 3112539039) strcat(s, "z");
if (crc32("aEZkzkRQrbjq",12) == 3713807683) strcat(s, "l");
if (crc32("kzXYTu",6) == 3415123414) strcat(s, "T");
if (crc32("tcspax",6) == 4037027619) strcat(s, "y");
    return s;
}

char *nonpalpably_adverbs() {
    char *s = calloc(12);
    if (crc32("ifwjfaNhALl",11) == 4288659475) strcat(s, "q");
if (crc32("lHGizdEIWrs",11) == 3656853113) strcat(s, "n");
if (crc32("eDdBSBXxBMIwv",13) == 1874659206) strcat(s, "o");
if (crc32("GPTUNgQOKMoBus",14) == 395074493) strcat(s, "n");
if (crc32("TwMtZ",5) == 1704286319) strcat(s, "D");
if (crc32("knXGABEZX",9) == 4160939558) strcat(s, "p");
if (crc32("ZGqPwxSiCWPl",12) == 1089733087) strcat(s, "a");
if (crc32("zdRgrkNAllA",11) == 2105368513) strcat(s, "l");
if (crc32("uoxvoOJgJUiysOe",15) == 208506951) strcat(s, "p");
if (crc32("givlOqEFCyc",11) == 1068292270) strcat(s, "a");
if (crc32("btPZCXOchR",10) == 839552540) strcat(s, "x");
if (crc32("qGFqSNIzbmcTyz",14) == 2499480040) strcat(s, "b");
if (crc32("PWHOlXxNTmeKT",13) == 2922267993) strcat(s, "l");
if (crc32("NZolR",5) == 2331469469) strcat(s, "y");
    return s;
}

char *benignantly_adverbs() {
    char *s = calloc(12);
    if (crc32("kDFeoBxyKvimqdS",15) == 348339058) strcat(s, "x");
if (crc32("dKwULkaFqlP",11) == 1752249615) strcat(s, "b");
if (crc32("NlxjtfThJd",10) == 1308522946) strcat(s, "e");
if (crc32("VlbiJYDyvok",11) == 3708941695) strcat(s, "b");
if (crc32("smMdvgwbPAuBZQS",15) == 3734465739) strcat(s, "n");
if (crc32("RuXFtQcuKktzZZj",15) == 1944455068) strcat(s, "U");
if (crc32("nMIKMLsmzxTu",12) == 3841850480) strcat(s, "i");
if (crc32("mqlbxDWvGlzZx",13) == 2063263752) strcat(s, "N");
if (crc32("ICgRvRaxFcCdSlS",15) == 1038466875) strcat(s, "g");
if (crc32("TdEQNrcAE",9) == 155295758) strcat(s, "i");
if (crc32("CXhmMBYeLc",10) == 1467599363) strcat(s, "n");
if (crc32("kGIrJxjkCXiNX",13) == 757878508) strcat(s, "n");
if (crc32("jbMFKV",6) == 2008267311) strcat(s, "a");
if (crc32("NtcACWnvcacV",12) == 1398875403) strcat(s, "l");
if (crc32("ehlAYiQTZHKVsda",15) == 1952299778) strcat(s, "n");
if (crc32("Naxpz",5) == 1735809391) strcat(s, "t");
if (crc32("oBSMkgNgFQod",12) == 1956828075) strcat(s, "l");
if (crc32("TSRJUXyU",8) == 503309740) strcat(s, "a");
if (crc32("BrIFeQAD",8) == 1943836109) strcat(s, "y");
    return s;
}

char *unscornfully_adverbs() {
    char *s = calloc(13);
    if (crc32("iMvrMxHpM",9) == 3815190950) strcat(s, "W");
if (crc32("ouNIkUh",7) == 2055596581) strcat(s, "u");
if (crc32("tJOOsmNhluMf",12) == 2424723095) strcat(s, "n");
if (crc32("pFCtkdfjCLNNiT",14) == 4081668720) strcat(s, "s");
if (crc32("hTLyj",5) == 18181433) strcat(s, "c");
if (crc32("pFcfpbOacIzG",12) == 29432091) strcat(s, "E");
if (crc32("nesUGk",6) == 2756425103) strcat(s, "o");
if (crc32("UbEuleSxFF",10) == 2234326467) strcat(s, "r");
if (crc32("SNsBZ",5) == 34006974) strcat(s, "k");
if (crc32("jtElLCp",7) == 824903134) strcat(s, "n");
if (crc32("RCJKIQT",7) == 3523734787) strcat(s, "H");
if (crc32("jeNmBMk",7) == 682970108) strcat(s, "f");
if (crc32("bDzDkjdZtteVzbB",15) == 129397890) strcat(s, "u");
if (crc32("zIJsvCdzBBok",12) == 499557528) strcat(s, "l");
if (crc32("KqzOkhEGzr",10) == 2490284620) strcat(s, "l");
if (crc32("WnCAOhJKwB",10) == 2727970269) strcat(s, "i");
if (crc32("FmsDcB",6) == 3514485144) strcat(s, "y");
    return s;
}

char *inconvertibly_adverbs() {
    char *s = calloc(14);
    if (crc32("VyNCbwrzKY",10) == 3587193933) strcat(s, "i");
if (crc32("PCkuGFcjFXoM",12) == 2149352329) strcat(s, "V");
if (crc32("Sybcj",5) == 121766524) strcat(s, "n");
if (crc32("RUSsGN",6) == 3338018341) strcat(s, "o");
if (crc32("UShZKBu",7) == 4119231080) strcat(s, "c");
if (crc32("WKeQo",5) == 2342059903) strcat(s, "B");
if (crc32("IMIogXuBf",9) == 530461866) strcat(s, "o");
if (crc32("AKDasWkeeBiw",12) == 197639526) strcat(s, "n");
if (crc32("OVaKkdPMRvpFFps",15) == 3547746651) strcat(s, "v");
if (crc32("ZRNcekPkmI",10) == 1978660299) strcat(s, "x");
if (crc32("KUaTttcJ",8) == 25105819) strcat(s, "e");
if (crc32("MEQxriscGiV",11) == 2488997112) strcat(s, "r");
if (crc32("kvDLi",5) == 1689225193) strcat(s, "L");
if (crc32("xZPzlZRhsaIE",12) == 3765174925) strcat(s, "t");
if (crc32("kCkocBgiAW",10) == 3217872894) strcat(s, "W");
if (crc32("mveAYtniSWt",11) == 1927931357) strcat(s, "i");
if (crc32("mICEORneJW",10) == 4073741940) strcat(s, "Y");
if (crc32("nAayu",5) == 1410328434) strcat(s, "b");
if (crc32("xNBoQKCMVmX",11) == 712082240) strcat(s, "m");
if (crc32("dQvDcfbM",8) == 4266022921) strcat(s, "l");
if (crc32("ykcSmLFkVMibIE",14) == 4233701867) strcat(s, "j");
if (crc32("umUzUJZzj",9) == 3510732119) strcat(s, "y");
    return s;
}

char *equivocatingly_adverbs() {
    char *s = calloc(15);
    if (crc32("VmtmiZPiXvyk",12) == 3687945199) strcat(s, "D");
if (crc32("tjzvcSY",7) == 413307626) strcat(s, "e");
if (crc32("QOqbm",5) == 836587434) strcat(s, "q");
if (crc32("prULevytnoCplN",14) == 710539160) strcat(s, "u");
if (crc32("RcgUgYmYZ",9) == 3914903592) strcat(s, "j");
if (crc32("HlMqJ",5) == 121524868) strcat(s, "i");
if (crc32("vSvUIxs",7) == 1647759204) strcat(s, "P");
if (crc32("dPYaguOqF",9) == 1659624007) strcat(s, "v");
if (crc32("PnccbHBMWvHF",12) == 3159525977) strcat(s, "o");
if (crc32("KOzptA",6) == 335901128) strcat(s, "c");
if (crc32("nZZdANUVRxm",11) == 700087669) strcat(s, "D");
if (crc32("UsqkI",5) == 2472669675) strcat(s, "a");
if (crc32("ccqSxG",6) == 1394057495) strcat(s, "t");
if (crc32("nZYTZSo",7) == 3073126176) strcat(s, "i");
if (crc32("OFmoPJCtxfXQZ",13) == 1132102536) strcat(s, "n");
if (crc32("kwoABTRFFjk",11) == 3813199107) strcat(s, "g");
if (crc32("WXxrdQz",7) == 3489256975) strcat(s, "l");
if (crc32("iKiNHzr",7) == 10904300) strcat(s, "Y");
if (crc32("xhEuWHGOgqHS",12) == 2832871541) strcat(s, "y");
    return s;
}

char *regionally_adverbs() {
    char *s = calloc(11);
    if (crc32("QxbKfwnICIunq",13) == 2599884927) strcat(s, "r");
if (crc32("wozHpxpXlAdG",12) == 1105211174) strcat(s, "Y");
if (crc32("PselR",5) == 2240424476) strcat(s, "e");
if (crc32("cRZMXyOYpeU",11) == 3449920630) strcat(s, "d");
if (crc32("sWbZeWFMusM",11) == 3379664292) strcat(s, "g");
if (crc32("PpNCWBgW",8) == 1763695343) strcat(s, "b");
if (crc32("VDePivxndLq",11) == 3390167287) strcat(s, "i");
if (crc32("QqjeF",5) == 3161263424) strcat(s, "t");
if (crc32("KdVAzbatpIxqTl",14) == 2109922416) strcat(s, "o");
if (crc32("xitWBBRpXcdNY",13) == 2040278076) strcat(s, "n");
if (crc32("XqQwjFeyFBEAmp",14) == 4262216731) strcat(s, "a");
if (crc32("AwUgdGTqLZYGB",13) == 1298708203) strcat(s, "l");
if (crc32("CNGtDn",6) == 988429216) strcat(s, "j");
if (crc32("lNbBfVmhC",9) == 3290053391) strcat(s, "l");
if (crc32("QJOvpzGnRMhVpqk",15) == 4133762464) strcat(s, "O");
if (crc32("SffeTz",6) == 335345777) strcat(s, "y");
    return s;
}

char *resourcefully_adverbs() {
    char *s = calloc(14);
    if (crc32("oAMezBfoFyzv",12) == 2108591140) strcat(s, "r");
if (crc32("KkdUqnD",7) == 4140756670) strcat(s, "r");
if (crc32("AJPdITuWD",9) == 2898585868) strcat(s, "j");
if (crc32("TMioNAkXcNYfrnV",15) == 3509041529) strcat(s, "e");
if (crc32("Nnnevje",7) == 1676309365) strcat(s, "s");
if (crc32("MDvnEMgLS",9) == 3273539049) strcat(s, "o");
if (crc32("JRMWQytEtAS",11) == 3545257713) strcat(s, "u");
if (crc32("ZkDJXBquqbslUrx",15) == 4082554545) strcat(s, "w");
if (crc32("iwiGnQeEvf",10) == 2216870881) strcat(s, "r");
if (crc32("gUoSBCRkEogd",12) == 2065180967) strcat(s, "c");
if (crc32("eKpAmqYB",8) == 1897681575) strcat(s, "D");
if (crc32("rDpiEOJfgo",10) == 3930205531) strcat(s, "e");
if (crc32("fcpRvstoESA",11) == 2241031700) strcat(s, "f");
if (crc32("IbGOeScNFSxxlc",14) == 685330294) strcat(s, "u");
if (crc32("TrpoQ",5) == 2258173081) strcat(s, "G");
if (crc32("TrRyExfvpGIThD",14) == 2055389450) strcat(s, "l");
if (crc32("irXkqcmVj",9) == 2688093112) strcat(s, "H");
if (crc32("GarNMtGYQJZew",13) == 2981153532) strcat(s, "l");
if (crc32("tdFjcPisEO",10) == 269778435) strcat(s, "y");
    return s;
}

char *transrationally_adverbs() {
    char *s = calloc(16);
    if (crc32("PqEQwAwf",8) == 2355720636) strcat(s, "F");
if (crc32("MkmpyIT",7) == 3330479424) strcat(s, "t");
if (crc32("zUUejjJjYyipVY",14) == 2318469516) strcat(s, "A");
if (crc32("NIiftkHmrYsFGeX",15) == 1081172769) strcat(s, "r");
if (crc32("gwIqkhJIe",9) == 409829049) strcat(s, "a");
if (crc32("qHQIdnbZTl",10) == 1117856430) strcat(s, "d");
if (crc32("wcfLr",5) == 182334628) strcat(s, "n");
if (crc32("xteXzTySM",9) == 4223107113) strcat(s, "v");
if (crc32("LZYwMporVfyP",12) == 377800624) strcat(s, "s");
if (crc32("wGafHSGfORSRkoR",15) == 2307932025) strcat(s, "T");
if (crc32("vixPOWk",7) == 1809611247) strcat(s, "r");
if (crc32("SwcuLeBwenJo",12) == 1345923343) strcat(s, "a");
if (crc32("VNjRyQv",7) == 458959849) strcat(s, "t");
if (crc32("stSar",5) == 736691482) strcat(s, "R");
if (crc32("WMBfdo",6) == 2716987482) strcat(s, "i");
if (crc32("DpLKQVGdTAL",11) == 1263626438) strcat(s, "o");
if (crc32("EeklQh",6) == 4070966648) strcat(s, "n");
if (crc32("IQemhQ",6) == 1633272819) strcat(s, "a");
if (crc32("nfOKhNuIR",9) == 2378648699) strcat(s, "M");
if (crc32("joQyKWPJ",8) == 1672680489) strcat(s, "l");
if (crc32("ukfRLO",6) == 3364849538) strcat(s, "u");
if (crc32("uBLFhVKFBdU",11) == 867530270) strcat(s, "l");
if (crc32("mzhMZQqQBwbcuQk",15) == 1027405172) strcat(s, "y");
    return s;
}

char *nonobviously_adverbs() {
    char *s = calloc(13);
    if (crc32("eIQfhxtob",9) == 2294809768) strcat(s, "n");
if (crc32("hYbdYXHFOqAb",12) == 815031604) strcat(s, "o");
if (crc32("wNNzswe",7) == 1772179704) strcat(s, "n");
if (crc32("EscrYDSVEhS",11) == 3225140967) strcat(s, "o");
if (crc32("AxnNyi",6) == 4002571617) strcat(s, "e");
if (crc32("qLzvamAfiRk",11) == 679608311) strcat(s, "b");
if (crc32("DZQqBkEYzQMS",12) == 1408779007) strcat(s, "d");
if (crc32("AoFyBpyIrQoDEM",14) == 2767437441) strcat(s, "v");
if (crc32("jZPmnESG",8) == 2601847756) strcat(s, "c");
if (crc32("ALgUkZokpESwE",13) == 618892175) strcat(s, "i");
if (crc32("fmTMxd",6) == 2681810625) strcat(s, "o");
if (crc32("scWnMGQMuwNPv",13) == 3644028425) strcat(s, "r");
if (crc32("wePNHcBUm",9) == 981872889) strcat(s, "u");
if (crc32("EfVbq",5) == 2091888896) strcat(s, "E");
if (crc32("pZmUwfJSqEQKzw",14) == 1648081613) strcat(s, "s");
if (crc32("DlydYaBLrFRq",12) == 2319873585) strcat(s, "O");
if (crc32("rcfvuUMEmZnTg",13) == 2663889652) strcat(s, "l");
if (crc32("vTrqBB",6) == 1873953087) strcat(s, "y");
    return s;
}

char *nonperversely_adverbs() {
    char *s = calloc(14);
    if (crc32("MqNQHucVCeAXQ",13) == 345303012) strcat(s, "r");
if (crc32("CllRd",5) == 723400172) strcat(s, "n");
if (crc32("dDcOefHHZAuROQ",14) == 3309224674) strcat(s, "N");
if (crc32("RFpYTyxIf",9) == 2526720244) strcat(s, "o");
if (crc32("vxSzDZWV",8) == 3947692123) strcat(s, "n");
if (crc32("ZrRmuzQifXqZ",12) == 669680550) strcat(s, "O");
if (crc32("rojsJGIGL",9) == 947807092) strcat(s, "p");
if (crc32("vZImuRCBnvm",11) == 143283901) strcat(s, "w");
if (crc32("BIDrOfoFslz",11) == 215719268) strcat(s, "e");
if (crc32("eCYQQttWWGC",11) == 2240339694) strcat(s, "P");
if (crc32("NmpYuT",6) == 3543061694) strcat(s, "r");
if (crc32("jtumFIRju",9) == 3968738792) strcat(s, "v");
if (crc32("SwnLBkeuRAKm",12) == 2876328479) strcat(s, "e");
if (crc32("JmKUWocqO",9) == 2410939867) strcat(s, "r");
if (crc32("sMQcRe",6) == 2449924807) strcat(s, "A");
if (crc32("iIyvrSLwypqMM",13) == 1122276318) strcat(s, "s");
if (crc32("XhjDFPBuWhfzG",13) == 584031885) strcat(s, "e");
if (crc32("KFbzYR",6) == 447952167) strcat(s, "e");
if (crc32("ggDfxEbJnJSk",12) == 891527044) strcat(s, "l");
if (crc32("qjgoAnQ",7) == 2684462185) strcat(s, "y");
    return s;
}

char *unpaternally_adverbs() {
    char *s = calloc(13);
    if (crc32("idCPTIYReuJd",12) == 2902633309) strcat(s, "Z");
if (crc32("WIfnqoZxc",9) == 3924930674) strcat(s, "u");
if (crc32("hVSfopmmA",9) == 3216092833) strcat(s, "n");
if (crc32("ktVHu",5) == 3125340908) strcat(s, "m");
if (crc32("TjSoyv",6) == 687324745) strcat(s, "p");
if (crc32("mGzHBiffkVKnuIA",15) == 3030276479) strcat(s, "a");
if (crc32("tuzKFpcACAFbZOK",15) == 3166111106) strcat(s, "t");
if (crc32("opImY",5) == 2904312532) strcat(s, "C");
if (crc32("llcMZhu",7) == 4123030729) strcat(s, "e");
if (crc32("kwsQsfvpErYE",12) == 4114318395) strcat(s, "r");
if (crc32("efBUcPkxowC",11) == 3910561880) strcat(s, "Y");
if (crc32("SOZeba",6) == 1722395268) strcat(s, "n");
if (crc32("wGwWFqcKwlK",11) == 255639038) strcat(s, "y");
if (crc32("yMMLekmX",8) == 549257805) strcat(s, "a");
if (crc32("eJUdbktv",8) == 920078620) strcat(s, "P");
if (crc32("fZIBnEHHdYofS",13) == 2041509356) strcat(s, "l");
if (crc32("UVAAdwIgsa",10) == 4143997250) strcat(s, "l");
if (crc32("emtCucyjCjxK",12) == 461281098) strcat(s, "j");
if (crc32("dwBSxiFT",8) == 113738819) strcat(s, "y");
    return s;
}

char *labouredly_adverbs() {
    char *s = calloc(11);
    if (crc32("rndBsTWetz",10) == 624008261) strcat(s, "g");
if (crc32("zzzOveD",7) == 916439088) strcat(s, "l");
if (crc32("SdofLhjWbue",11) == 618859908) strcat(s, "E");
if (crc32("oeDMZQi",7) == 2319654269) strcat(s, "a");
if (crc32("jIGCIP",6) == 3988332875) strcat(s, "q");
if (crc32("qYGAuA",6) == 1622649275) strcat(s, "b");
if (crc32("iSxEYOGUvqlIORz",15) == 3993892960) strcat(s, "N");
if (crc32("MPaMDgWlSnW",11) == 137496296) strcat(s, "o");
if (crc32("yVcfDbOPDHFKBJ",14) == 2270213080) strcat(s, "u");
if (crc32("OoEDsdNk",8) == 2554978471) strcat(s, "r");
if (crc32("rpMeXthZtjEl",12) == 1354852884) strcat(s, "e");
if (crc32("XwxCxgfMgxTdaL",14) == 1428746856) strcat(s, "d");
if (crc32("qjljLWGxgwl",11) == 4232039768) strcat(s, "J");
if (crc32("UiYPuZE",7) == 699158430) strcat(s, "l");
if (crc32("IyaIVpSM",8) == 2670165508) strcat(s, "y");
    return s;
}

char *beneficently_adverbs() {
    char *s = calloc(13);
    if (crc32("ZkmCBjz",7) == 3425013904) strcat(s, "b");
if (crc32("iLkgopcnmNQM",12) == 1446838524) strcat(s, "e");
if (crc32("lCVXkYv",7) == 2009172702) strcat(s, "n");
if (crc32("WElycYDT",8) == 1235681368) strcat(s, "t");
if (crc32("swlZHH",6) == 670698849) strcat(s, "e");
if (crc32("DbocZnMTU",9) == 3205356129) strcat(s, "H");
if (crc32("XeJoyakcRowY",12) == 408582976) strcat(s, "f");
if (crc32("CRVJvu",6) == 2965128801) strcat(s, "i");
if (crc32("ljOYBqDKx",9) == 1338441934) strcat(s, "c");
if (crc32("mWFnbSxUoQT",11) == 3968416008) strcat(s, "e");
if (crc32("iOrEhrsw",8) == 2635261760) strcat(s, "P");
if (crc32("nuhEa",5) == 1304305289) strcat(s, "n");
if (crc32("GzvCYpooskdPf",13) == 2549181201) strcat(s, "t");
if (crc32("lxEUkEE",7) == 2515629172) strcat(s, "l");
if (crc32("NLJqetIDk",9) == 719299746) strcat(s, "y");
    return s;
}

char *olericulturally_adverbs() {
    char *s = calloc(16);
    if (crc32("qvnCFXAHdw",10) == 3579853088) strcat(s, "s");
if (crc32("kGryQOEytINjxF",14) == 1397510768) strcat(s, "o");
if (crc32("BUGJJxo",7) == 971022365) strcat(s, "P");
if (crc32("eJdlknVlsFr",11) == 1982092252) strcat(s, "l");
if (crc32("COnlKF",6) == 319236500) strcat(s, "C");
if (crc32("csWxi",5) == 3678529477) strcat(s, "e");
if (crc32("crEHGizMlNGipla",15) == 1853712874) strcat(s, "r");
if (crc32("RvMlPneOEmDTlrF",15) == 3984551445) strcat(s, "i");
if (crc32("myJuNDxAUpj",11) == 2971079498) strcat(s, "T");
if (crc32("vLtESLf",7) == 1546734325) strcat(s, "c");
if (crc32("oZwkQCTO",8) == 709902253) strcat(s, "u");
if (crc32("slgyLhzMFcAPF",13) == 1268084091) strcat(s, "H");
if (crc32("kOSYPf",6) == 2918039016) strcat(s, "l");
if (crc32("koXKPbUcreIt",12) == 622472599) strcat(s, "t");
if (crc32("VjQggD",6) == 1576436416) strcat(s, "u");
if (crc32("NlqjvrjWyKKaw",13) == 3106956566) strcat(s, "u");
if (crc32("YSJGMia",7) == 1131656860) strcat(s, "r");
if (crc32("hAiYKCJU",8) == 2981807317) strcat(s, "c");
if (crc32("pfszOAikEnaQPI",14) == 404643046) strcat(s, "a");
if (crc32("gZxRuAWkqqGUuJB",15) == 54183050) strcat(s, "p");
if (crc32("fftudlXFkMh",11) == 2987347026) strcat(s, "l");
if (crc32("LYEmDFRx",8) == 2258885563) strcat(s, "z");
if (crc32("ARmFTY",6) == 1177439085) strcat(s, "l");
if (crc32("cTBfjPLHlRZCJCY",15) == 2077091857) strcat(s, "V");
if (crc32("hSRwkbE",7) == 250297296) strcat(s, "y");
    return s;
}

char *yappingly_adverbs() {
    char *s = calloc(10);
    if (crc32("zeeYqsbfKqH",11) == 346264479) strcat(s, "y");
if (crc32("kOBSlr",6) == 2932208628) strcat(s, "B");
if (crc32("zaLeAFFEDRKI",12) == 1522344945) strcat(s, "a");
if (crc32("ZNYciLOhV",9) == 3511247192) strcat(s, "C");
if (crc32("SicwOfQJcPKzVs",14) == 883988738) strcat(s, "p");
if (crc32("lzdcqMhdlhERrxI",15) == 2013333906) strcat(s, "p");
if (crc32("TBrNBwKZdUrzi",13) == 2808122770) strcat(s, "i");
if (crc32("wOPlatPWt",9) == 1354003797) strcat(s, "n");
if (crc32("XYjozU",6) == 1680818288) strcat(s, "n");
if (crc32("rRcqsTVzxqI",11) == 4021572203) strcat(s, "g");
if (crc32("kzKNYdtcQsW",11) == 88321515) strcat(s, "l");
if (crc32("zSMeNqUGBtapJ",13) == 3447699154) strcat(s, "y");
    return s;
}

char *frolicly_adverbs() {
    char *s = calloc(9);
    if (crc32("khrQpyx",7) == 1868194086) strcat(s, "k");
if (crc32("DSeHetCtOG",10) == 3246411678) strcat(s, "f");
if (crc32("NEHggY",6) == 1068541121) strcat(s, "r");
if (crc32("MTOUYPNy",8) == 2481280207) strcat(s, "W");
if (crc32("SwGHkZFCdHlF",12) == 2924022267) strcat(s, "o");
if (crc32("uVuGvrkhTZJSkcq",15) == 2077639935) strcat(s, "l");
if (crc32("kQNgfyavci",10) == 1895198701) strcat(s, "h");
if (crc32("cpbDRRrMBMfNl",13) == 2844905373) strcat(s, "i");
if (crc32("tdLGheb",7) == 289967060) strcat(s, "K");
if (crc32("HymBRnLhSNYbQ",13) == 2188189101) strcat(s, "c");
if (crc32("mjexfdhIXTwI",12) == 3517778477) strcat(s, "l");
if (crc32("UVLekSiYMfHRL",13) == 1132846388) strcat(s, "h");
if (crc32("CsWTIfxC",8) == 1641923172) strcat(s, "y");
    return s;
}

char *doughtily_adverbs() {
    char *s = calloc(10);
    if (crc32("hqgeLtbzUP",10) == 3571379027) strcat(s, "J");
if (crc32("xDNAcAsFJytZ",12) == 4292976594) strcat(s, "d");
if (crc32("jpYYMiJkbDU",11) == 2334765053) strcat(s, "o");
if (crc32("mgYznFWDBhLr",12) == 1595400896) strcat(s, "u");
if (crc32("lwNWFusUisNcmk",14) == 3900777352) strcat(s, "g");
if (crc32("FeLHg",5) == 2409568407) strcat(s, "h");
if (crc32("HuBbsZIk",8) == 1662164607) strcat(s, "t");
if (crc32("MDMfDfW",7) == 594320112) strcat(s, "i");
if (crc32("NWOqHd",6) == 3314011211) strcat(s, "s");
if (crc32("tzKvbExWzoOc",12) == 2820406841) strcat(s, "l");
if (crc32("tFaeF",5) == 3267700160) strcat(s, "z");
if (crc32("SOLpjrX",7) == 3130658173) strcat(s, "y");
    return s;
}

char *noxiously_adverbs() {
    char *s = calloc(10);
    if (crc32("PExDhKzVBEPI",12) == 743328533) strcat(s, "n");
if (crc32("NvbSKHkQf",9) == 1042671242) strcat(s, "o");
if (crc32("dnqBO",5) == 7787841) strcat(s, "x");
if (crc32("rSUBPMR",7) == 126769769) strcat(s, "r");
if (crc32("mLpvwQwqbHlrPK",14) == 852472691) strcat(s, "i");
if (crc32("TTLdkpNuKVHeE",13) == 2246883570) strcat(s, "z");
if (crc32("XipQmDCY",8) == 2225220290) strcat(s, "o");
if (crc32("FMzOSnpCDR",10) == 2710218035) strcat(s, "i");
if (crc32("SrTwbjeFmtrsSa",14) == 2668163690) strcat(s, "u");
if (crc32("WbXuXaKG",8) == 100874559) strcat(s, "z");
if (crc32("BjICUuUABFm",11) == 3911351392) strcat(s, "s");
if (crc32("VGmAvbGHBsDlCGK",15) == 679326474) strcat(s, "D");
if (crc32("bouvvKWPjoV",11) == 502010365) strcat(s, "l");
if (crc32("FewTn",5) == 443394081) strcat(s, "r");
if (crc32("tgGzMjTejt",10) == 3978769408) strcat(s, "y");
    return s;
}

char *rustily_adverbs() {
    char *s = calloc(8);
    if (crc32("QcPbeZ",6) == 1980623059) strcat(s, "y");
if (crc32("XlfGCXkdQwW",11) == 1503131198) strcat(s, "r");
if (crc32("gfOWqUssV",9) == 3300423362) strcat(s, "I");
if (crc32("BCGJAjF",7) == 2830860179) strcat(s, "u");
if (crc32("vJjmImOiL",9) == 1287261387) strcat(s, "v");
if (crc32("iwYFtSJZeVpt",12) == 191302473) strcat(s, "s");
if (crc32("LfzMU",5) == 759862507) strcat(s, "E");
if (crc32("yOWblsP",7) == 792369129) strcat(s, "t");
if (crc32("TnBGIzQSfxxS",12) == 4046911772) strcat(s, "i");
if (crc32("azWYcKNHO",9) == 3158103372) strcat(s, "X");
if (crc32("dMhyMsWqO",9) == 2704798392) strcat(s, "l");
if (crc32("kFhwxmepVDsB",12) == 2064683408) strcat(s, "y");
    return s;
}

char *hyperintellectually_adverbs() {
    char *s = calloc(20);
    if (crc32("xslRyQhujsUf",12) == 724938427) strcat(s, "h");
if (crc32("KkDaFddVNUMMJU",14) == 3727151699) strcat(s, "z");
if (crc32("smaNLtjRDAqEfAC",15) == 1518946833) strcat(s, "y");
if (crc32("IBEghnBQaJV",11) == 3948623878) strcat(s, "p");
if (crc32("ZcpqBNeiash",11) == 2756441172) strcat(s, "p");
if (crc32("EsWStdIlUHaSfLX",15) == 2115351156) strcat(s, "e");
if (crc32("oUGtiV",6) == 4143873774) strcat(s, "Q");
if (crc32("XdksBcOynliE",12) == 2987487706) strcat(s, "r");
if (crc32("nTYEzXXIQkeElv",14) == 84222185) strcat(s, "i");
if (crc32("wQHNWIGG",8) == 32765977) strcat(s, "n");
if (crc32("XJBkLWLLZCS",11) == 3413856233) strcat(s, "n");
if (crc32("zQnniQhFq",9) == 3319488485) strcat(s, "U");
if (crc32("TPXrwyTzUYgi",12) == 854861338) strcat(s, "t");
if (crc32("guzoQTng",8) == 2151661559) strcat(s, "x");
if (crc32("TSlHGU",6) == 4063147555) strcat(s, "e");
if (crc32("uKdWKTDGFVRNvXL",15) == 384851960) strcat(s, "l");
if (crc32("BRnUdGD",7) == 1412963289) strcat(s, "l");
if (crc32("TQGcGdjZcGPM",12) == 4273903613) strcat(s, "n");
if (crc32("pIiJGLzDtjcCo",13) == 3059397342) strcat(s, "e");
if (crc32("wsuEASPZoFQFHk",14) == 3965563985) strcat(s, "J");
if (crc32("udUNuXP",7) == 1884433944) strcat(s, "c");
if (crc32("WUQNEUEmPeWrXKF",15) == 4218176170) strcat(s, "D");
if (crc32("GDiGcnyoIhV",11) == 2675775689) strcat(s, "t");
if (crc32("vAEJriSlP",9) == 2465797090) strcat(s, "p");
if (crc32("KNdfZTMC",8) == 3857811615) strcat(s, "u");
if (crc32("soNJyEYeXVOabtt",15) == 4164859482) strcat(s, "a");
if (crc32("RYCzBQQcxI",10) == 1565645000) strcat(s, "s");
if (crc32("OsGgGxnCAM",10) == 3146322894) strcat(s, "l");
if (crc32("LgjilWKGsrMiFKR",15) == 3520840959) strcat(s, "l");
if (crc32("jAtcvVqkss",10) == 1322590117) strcat(s, "y");
    return s;
}

char *creamily_adverbs() {
    char *s = calloc(9);
    if (crc32("LmTpJRHSFFknic",14) == 3478548716) strcat(s, "c");
if (crc32("gAhBrnoTVWJnkU",14) == 998928301) strcat(s, "r");
if (crc32("oOZRloN",7) == 1073177139) strcat(s, "e");
if (crc32("LDUvwdtc",8) == 2807800387) strcat(s, "a");
if (crc32("UjJrkO",6) == 1695679613) strcat(s, "a");
if (crc32("TPWmULuVJBsrQa",14) == 3439407198) strcat(s, "m");
if (crc32("pwrKMMKOB",9) == 4105599248) strcat(s, "i");
if (crc32("PfDPoR",6) == 1957909619) strcat(s, "s");
if (crc32("hbPHcSp",7) == 2377696870) strcat(s, "l");
if (crc32("vhznpfkypULBXm",14) == 3142937149) strcat(s, "U");
if (crc32("QFvqETchvN",10) == 765738563) strcat(s, "y");
    return s;
}

char *quasianciently_adverbs() {
    char *s = calloc(15);
    if (crc32("oUAHak",6) == 3434113128) strcat(s, "k");
if (crc32("XEVnnrASGRIs",12) == 1115398848) strcat(s, "q");
if (crc32("txHlUnT",7) == 2252783686) strcat(s, "u");
if (crc32("MtgNbX",6) == 624821128) strcat(s, "q");
if (crc32("AaTBJ",5) == 534255079) strcat(s, "a");
if (crc32("oBYpns",6) == 3134544338) strcat(s, "s");
if (crc32("suaMOPlFNrWyqgY",15) == 3648274704) strcat(s, "i");
if (crc32("ACHwFkljvhqanc",14) == 3811564980) strcat(s, "L");
if (crc32("DMkJYVUYxWzgWMW",15) == 2509768120) strcat(s, "a");
if (crc32("FIyAiQsEi",9) == 167856556) strcat(s, "Z");
if (crc32("wAnLxBVsrsgIY",13) == 2356012554) strcat(s, "n");
if (crc32("acQQViANisK",11) == 1992157167) strcat(s, "u");
if (crc32("IRrbLBOWbbEUbKi",15) == 4065245801) strcat(s, "c");
if (crc32("bWUVvISFmBjlVbH",15) == 623238357) strcat(s, "i");
if (crc32("nxMQqEarAUIP",12) == 3283580996) strcat(s, "G");
if (crc32("RAODCMmkjRp",11) == 1085869282) strcat(s, "e");
if (crc32("jxAGLn",6) == 1907674842) strcat(s, "n");
if (crc32("KNrltSrZufTNGoM",15) == 1879525656) strcat(s, "e");
if (crc32("dZZNMXtpSM",10) == 2665092903) strcat(s, "t");
if (crc32("DJRhMQQyaZUBkg",14) == 4014312541) strcat(s, "k");
if (crc32("YzLAoEdjh",9) == 1724574007) strcat(s, "l");
if (crc32("bgGSLhhHZgeUx",13) == 431170757) strcat(s, "X");
if (crc32("KTHoGZEOW",9) == 1597522416) strcat(s, "y");
    return s;
}

char *democratically_adverbs() {
    char *s = calloc(15);
    if (crc32("VZsGvlixyle",11) == 3663450418) strcat(s, "d");
if (crc32("icWBGcvqCPOCDh",14) == 3255023003) strcat(s, "K");
if (crc32("hpbuKTAjV",9) == 3978954378) strcat(s, "e");
if (crc32("NaYErceYvbBCaFv",15) == 806592937) strcat(s, "m");
if (crc32("rGqsILsPsqGYci",14) == 3481067835) strcat(s, "o");
if (crc32("HsifxzpqzmUF",12) == 3425857734) strcat(s, "c");
if (crc32("ETCnnsIYKD",10) == 2751308708) strcat(s, "r");
if (crc32("uOwNvvBGcIUR",12) == 3657219717) strcat(s, "a");
if (crc32("WCQaGBIuGVd",11) == 841277237) strcat(s, "M");
if (crc32("jMckwGgIurOMmn",14) == 3850582931) strcat(s, "t");
if (crc32("NSwTyphLElWLv",13) == 959802651) strcat(s, "i");
if (crc32("EhBwS",5) == 505433537) strcat(s, "d");
if (crc32("KwJSejBker",10) == 3822575026) strcat(s, "c");
if (crc32("DJXCfRU",7) == 3724540408) strcat(s, "a");
if (crc32("ACKGUoVob",9) == 1727881027) strcat(s, "l");
if (crc32("cuFzsAIgZLZfLq",14) == 363187805) strcat(s, "r");
if (crc32("FlnZYRYLlf",10) == 1140029583) strcat(s, "l");
if (crc32("vVaEvZU",7) == 3921448913) strcat(s, "T");
if (crc32("OHRoRVBjsxa",11) == 1709489013) strcat(s, "y");
    return s;
}

char *peaceably_adverbs() {
    char *s = calloc(10);
    if (crc32("vdrgaGQIbrgS",12) == 3069707831) strcat(s, "s");
if (crc32("QVMktFgGGUzF",12) == 793430422) strcat(s, "p");
if (crc32("muzetQqrgTvT",12) == 2201065067) strcat(s, "e");
if (crc32("oDcfa",5) == 1554356062) strcat(s, "d");
if (crc32("zXJuEHqb",8) == 2426572768) strcat(s, "a");
if (crc32("qaqSCCSPDNVsG",13) == 3136491278) strcat(s, "c");
if (crc32("etgyUiZS",8) == 232686205) strcat(s, "e");
if (crc32("lbPCVsDpkDgAG",13) == 2800537608) strcat(s, "H");
if (crc32("sIDeZk",6) == 2848534363) strcat(s, "a");
if (crc32("ellol",5) == 28061636) strcat(s, "b");
if (crc32("kzaAoBC",7) == 701191832) strcat(s, "K");
if (crc32("WoSAFpOBAWWk",12) == 3518423522) strcat(s, "l");
if (crc32("gaDjKMwh",8) == 3812533449) strcat(s, "K");
if (crc32("GIENUayBrftN",12) == 2510965048) strcat(s, "y");
    return s;
}

char *unadmiringly_adverbs() {
    char *s = calloc(13);
    if (crc32("AjyZFGbEp",9) == 4245035439) strcat(s, "u");
if (crc32("lATQxSkoUDmOH",13) == 3857178842) strcat(s, "n");
if (crc32("sYDyCX",6) == 394315931) strcat(s, "b");
if (crc32("BdKPSKTMb",9) == 3057018221) strcat(s, "a");
if (crc32("yngbJGuCLjqpN",13) == 3098263386) strcat(s, "t");
if (crc32("AQNOyiYx",8) == 2396019511) strcat(s, "d");
if (crc32("yxkuAehZlNyuu",13) == 1731929313) strcat(s, "f");
if (crc32("dzqoAGfb",8) == 1692510461) strcat(s, "m");
if (crc32("iFRPZxPoSDdGOKU",15) == 2492495270) strcat(s, "i");
if (crc32("kxXOI",5) == 3034417354) strcat(s, "a");
if (crc32("npLAz",5) == 2871856239) strcat(s, "r");
if (crc32("boQHaYO",7) == 2809080634) strcat(s, "u");
if (crc32("OFJrvAFeUnCltfi",15) == 2492848275) strcat(s, "i");
if (crc32("tcNeY",5) == 1622656472) strcat(s, "T");
if (crc32("fNuYOWUDxWkVuF",14) == 2910207549) strcat(s, "n");
if (crc32("utCiJBAcsQYLTW",14) == 3813910076) strcat(s, "g");
if (crc32("vEcZRZmP",8) == 1593483119) strcat(s, "l");
if (crc32("vgmdXpsfFxy",11) == 3978724564) strcat(s, "G");
if (crc32("qaJCkpXdU",9) == 2311431160) strcat(s, "y");
    return s;
}

char *exhortingly_adverbs() {
    char *s = calloc(12);
    if (crc32("LbMaT",5) == 2729225285) strcat(s, "e");
if (crc32("DQArpLQLJ",9) == 2327868081) strcat(s, "a");
if (crc32("vpVVDwZRVWFWb",13) == 905864997) strcat(s, "x");
if (crc32("tgvGcNRVMnF",11) == 2308748177) strcat(s, "h");
if (crc32("dAkBGjCBinNHd",13) == 1670211037) strcat(s, "l");
if (crc32("phletFUJ",8) == 2655042625) strcat(s, "o");
if (crc32("NjJyrKDu",8) == 628208173) strcat(s, "r");
if (crc32("YkZseCWZxifCqCC",15) == 3432110464) strcat(s, "x");
if (crc32("MZBQhTnWqCH",11) == 410733067) strcat(s, "t");
if (crc32("MkjdLYaHTUZF",12) == 3317563768) strcat(s, "Q");
if (crc32("LXVnGW",6) == 656622719) strcat(s, "i");
if (crc32("rrloBeanBxAJXmv",15) == 626088749) strcat(s, "n");
if (crc32("ADomdIbVWzEA",12) == 4063424297) strcat(s, "t");
if (crc32("LDNHmlnTyz",10) == 3108564123) strcat(s, "g");
if (crc32("jeukXTvx",8) == 171793449) strcat(s, "l");
if (crc32("NjidWOmUwplqOk",14) == 1016367616) strcat(s, "y");
    return s;
}

char *mezzo_adverbs() {
    char *s = calloc(6);
    if (crc32("RMPHoSAYngKcuAh",15) == 438076407) strcat(s, "m");
if (crc32("kmLDdbeeGVyhxb",14) == 1388486961) strcat(s, "e");
if (crc32("PlgqTqax",8) == 2654324185) strcat(s, "z");
if (crc32("jNqjrhn",7) == 1200252959) strcat(s, "z");
if (crc32("OupmBFLeeDeGyp",14) == 1822685691) strcat(s, "o");
    return s;
}

char *overaggressively_adverbs() {
    char *s = calloc(17);
    if (crc32("CSMpYAzHcXans",13) == 1253008616) strcat(s, "N");
if (crc32("ZFGyXhSEzeiF",12) == 4136629264) strcat(s, "o");
if (crc32("fWiIFqEtuELCR",13) == 1359746517) strcat(s, "v");
if (crc32("XNGMvSa",7) == 3237371056) strcat(s, "e");
if (crc32("UFbnaQpEUSSbEF",14) == 3950370917) strcat(s, "r");
if (crc32("nXknequkGbI",11) == 1565164187) strcat(s, "d");
if (crc32("dAtkye",6) == 617535860) strcat(s, "a");
if (crc32("bOkwcjDUeachR",13) == 1008110562) strcat(s, "g");
if (crc32("oBcZSPfp",8) == 2501414993) strcat(s, "g");
if (crc32("oFmAkaTVnnCt",12) == 1738423025) strcat(s, "r");
if (crc32("oDARYzXcfL",10) == 2170776978) strcat(s, "e");
if (crc32("LzqiJeOpw",9) == 1974270339) strcat(s, "j");
if (crc32("jPkkFM",6) == 643154745) strcat(s, "s");
if (crc32("tTTkKMYJOwir",12) == 170118812) strcat(s, "s");
if (crc32("HLiPZkuUcRfb",12) == 4273186619) strcat(s, "i");
if (crc32("aaqulLkxY",9) == 3425982547) strcat(s, "s");
if (crc32("ErnQyYeuGxl",11) == 3128744214) strcat(s, "v");
if (crc32("AUpByoez",8) == 1557743985) strcat(s, "J");
if (crc32("FGsuVmLyW",9) == 3806041322) strcat(s, "e");
if (crc32("WlrPn",5) == 21805030) strcat(s, "D");
if (crc32("aldypeCKkfnB",12) == 100692286) strcat(s, "l");
if (crc32("Jeeyouty",8) == 4227811037) strcat(s, "y");
    return s;
}

char *unfaintly_adverbs() {
    char *s = calloc(10);
    if (crc32("OvbgjDEzCr",10) == 1202896963) strcat(s, "u");
if (crc32("oqacmiH",7) == 555383353) strcat(s, "n");
if (crc32("RAWxXAuD",8) == 1067254766) strcat(s, "v");
if (crc32("MXAgBkWPNtP",11) == 1710905122) strcat(s, "f");
if (crc32("beLICYykksml",12) == 2514465117) strcat(s, "a");
if (crc32("tZZLKnX",7) == 2966654795) strcat(s, "f");
if (crc32("jpNleUAV",8) == 2887000974) strcat(s, "i");
if (crc32("yPStYqIFqVwgrT",14) == 2322797145) strcat(s, "N");
if (crc32("UXKtpBfRzUnL",12) == 3745438593) strcat(s, "n");
if (crc32("kLCtPWRGWnO",11) == 1364322524) strcat(s, "t");
if (crc32("SLjGrdYNeT",10) == 2709312436) strcat(s, "x");
if (crc32("WjVwPEbc",8) == 3121518694) strcat(s, "l");
if (crc32("dHreDPyl",8) == 2274067447) strcat(s, "n");
if (crc32("POReJozaoJICXdi",15) == 2728925874) strcat(s, "y");
    return s;
}

char *unenterprisingly_adverbs() {
    char *s = calloc(17);
    if (crc32("wjtRXNjzkQVj",12) == 3014610735) strcat(s, "A");
if (crc32("ifouS",5) == 2951498526) strcat(s, "u");
if (crc32("knUAWhlyCFfpX",13) == 4221144140) strcat(s, "L");
if (crc32("sdZrpybSNQ",10) == 852069310) strcat(s, "n");
if (crc32("YDwvhwsLeGIuN",13) == 2432840061) strcat(s, "e");
if (crc32("lFOqvW",6) == 57250624) strcat(s, "n");
if (crc32("UQenebGytR",10) == 2986536093) strcat(s, "t");
if (crc32("oqELZALSnb",10) == 3725284222) strcat(s, "B");
if (crc32("jAxCw",5) == 2044683800) strcat(s, "e");
if (crc32("zLAuSmXPD",9) == 1535071720) strcat(s, "r");
if (crc32("yMMmepnYHLmZwvM",15) == 2221431991) strcat(s, "Z");
if (crc32("urkzHW",6) == 298914464) strcat(s, "p");
if (crc32("TpIRVUmjJHe",11) == 3626961097) strcat(s, "n");
if (crc32("RYqDm",5) == 3234971165) strcat(s, "r");
if (crc32("GIdKWxJXxBp",11) == 1450362266) strcat(s, "i");
if (crc32("hevJCuJFtgYpRvE",15) == 3831149156) strcat(s, "V");
if (crc32("veJALsV",7) == 2224845158) strcat(s, "s");
if (crc32("ZAIGy",5) == 1071393544) strcat(s, "m");
if (crc32("fskOnVvbLMOg",12) == 1158476534) strcat(s, "i");
if (crc32("UIWGR",5) == 2204332350) strcat(s, "n");
if (crc32("zIphsnFaio",10) == 1362487291) strcat(s, "g");
if (crc32("AZeHlrQnveo",11) == 2138466088) strcat(s, "l");
if (crc32("hKEyPgwOfMOK",12) == 2736977290) strcat(s, "y");
    return s;
}

char *Gothically_adverbs() {
    char *s = calloc(11);
    if (crc32("rhugN",5) == 1379966994) strcat(s, "G");
if (crc32("PYmlthziH",9) == 754659864) strcat(s, "o");
if (crc32("KNZvvRsPPvoxiz",14) == 1019837649) strcat(s, "P");
if (crc32("oSzVAtus",8) == 2284509305) strcat(s, "t");
if (crc32("DsvxdJaydzC",11) == 4209035229) strcat(s, "h");
if (crc32("taBHaoUsSBmOl",13) == 1179322981) strcat(s, "i");
if (crc32("daHtR",5) == 2578835108) strcat(s, "c");
if (crc32("ZhFmTFyLf",9) == 1092338142) strcat(s, "a");
if (crc32("uqdpzXlxFSLXAeV",15) == 2049485980) strcat(s, "O");
if (crc32("pOpojXgHbIshH",13) == 1297599284) strcat(s, "l");
if (crc32("zwJYotx",7) == 823370819) strcat(s, "l");
if (crc32("EMJzEfkDQJ",10) == 2742786357) strcat(s, "y");
    return s;
}

char *well_adverbs() {
    char *s = calloc(5);
    if (crc32("sZKujTk",7) == 3309512670) strcat(s, "U");
if (crc32("OCcdqLNRcm",10) == 2128895818) strcat(s, "w");
if (crc32("fasljuTeQW",10) == 3726853051) strcat(s, "e");
if (crc32("PAIeTOL",7) == 1083705876) strcat(s, "l");
if (crc32("dyNajz",6) == 3413769031) strcat(s, "l");
    return s;
}

char *nonruminatingly_adverbs() {
    char *s = calloc(16);
    if (crc32("OyIuvcEE",8) == 3003625808) strcat(s, "G");
if (crc32("OGdujVV",7) == 646455804) strcat(s, "n");
if (crc32("xCQjBlO",7) == 1781848504) strcat(s, "t");
if (crc32("TrLbdQLRh",9) == 1278359607) strcat(s, "o");
if (crc32("uxZRJKWYAJS",11) == 2374095503) strcat(s, "F");
if (crc32("CXuOHmfP",8) == 354769705) strcat(s, "n");
if (crc32("MiHUh",5) == 237330626) strcat(s, "o");
if (crc32("BosliYGeQxveTg",14) == 1528399958) strcat(s, "r");
if (crc32("LnlggzyoRMWYi",13) == 2834453774) strcat(s, "B");
if (crc32("nMakImgOmhZk",12) == 1092936055) strcat(s, "u");
if (crc32("TpgrrtQWbo",10) == 3414139245) strcat(s, "Y");
if (crc32("KjlhrDUQnXr",11) == 53408290) strcat(s, "m");
if (crc32("rNhxTIrlu",9) == 3312066473) strcat(s, "N");
if (crc32("Csayxa",6) == 2207589111) strcat(s, "i");
if (crc32("fMUrTuJnlTYFy",13) == 1305802215) strcat(s, "P");
if (crc32("HCshaLuP",8) == 225710771) strcat(s, "n");
if (crc32("BNGikyxAHLSd",12) == 636456495) strcat(s, "a");
if (crc32("LzvRKrkwLaL",11) == 2867535787) strcat(s, "C");
if (crc32("bieYzaVGtjyPUeY",15) == 1134286828) strcat(s, "t");
if (crc32("xCdgTetracVg",12) == 2337742515) strcat(s, "i");
if (crc32("kEDnVQAvERMWQjW",15) == 4059042611) strcat(s, "i");
if (crc32("znwcsHopog",10) == 1773767057) strcat(s, "n");
if (crc32("EwyQrLGUooR",11) == 1793264634) strcat(s, "H");
if (crc32("LJAKiKifAKp",11) == 1079847469) strcat(s, "g");
if (crc32("CwlYFX",6) == 2733803903) strcat(s, "l");
if (crc32("xdcyrw",6) == 1811360004) strcat(s, "o");
if (crc32("oRffC",5) == 745323313) strcat(s, "y");
    return s;
}

char *besottedly_adverbs() {
    char *s = calloc(11);
    if (crc32("iqvPGNEMuiAqH",13) == 1235451964) strcat(s, "C");
if (crc32("eOeyUbCLZb",10) == 2565659399) strcat(s, "b");
if (crc32("CalRVde",7) == 2817145978) strcat(s, "V");
if (crc32("dyrqrcuXzqmrez",14) == 3049668313) strcat(s, "e");
if (crc32("SvnvlU",6) == 2588431206) strcat(s, "v");
if (crc32("nhpfcDXZXX",10) == 3564803722) strcat(s, "s");
if (crc32("qGvjAWtk",8) == 3929812196) strcat(s, "h");
if (crc32("POuhLIOT",8) == 3313770028) strcat(s, "o");
if (crc32("XDwNmz",6) == 268656791) strcat(s, "t");
if (crc32("VPWaTvmpwXRkK",13) == 477507706) strcat(s, "t");
if (crc32("gRrcYsqHkAtFV",13) == 3699740508) strcat(s, "E");
if (crc32("GWaRDeWVobUz",12) == 2174825040) strcat(s, "e");
if (crc32("xxuedrWLKonlgi",14) == 1427804563) strcat(s, "d");
if (crc32("LOeBtufRFd",10) == 296793770) strcat(s, "l");
if (crc32("mBUfIfz",7) == 1857207162) strcat(s, "A");
if (crc32("zAbcvl",6) == 2553759503) strcat(s, "y");
    return s;
}

char *antigrammatically_adverbs() {
    char *s = calloc(18);
    if (crc32("xOWPc",5) == 3406053883) strcat(s, "a");
if (crc32("fHqBlLc",7) == 2853467590) strcat(s, "n");
if (crc32("mSwOVaEDQbcKo",13) == 978887667) strcat(s, "t");
if (crc32("mtaBuWzEG",9) == 3710678023) strcat(s, "B");
if (crc32("OPRqKPAkzv",10) == 4117049729) strcat(s, "i");
if (crc32("hPGRXcQljaiXm",13) == 1313938823) strcat(s, "b");
if (crc32("ERTEMhAwrKo",11) == 4098861228) strcat(s, "g");
if (crc32("paCnswzmMDACAGQ",15) == 1010895393) strcat(s, "b");
if (crc32("VGJGz",5) == 89646084) strcat(s, "r");
if (crc32("zxiLtmlhUnaU",12) == 695165984) strcat(s, "a");
if (crc32("lYIOrXq",7) == 3381495882) strcat(s, "Z");
if (crc32("QdfoGqDPWKTycVh",15) == 216024248) strcat(s, "m");
if (crc32("ylHqvSXQqbWB",12) == 3927017760) strcat(s, "N");
if (crc32("NOlZGy",6) == 3624531616) strcat(s, "m");
if (crc32("nJErOmpMUBYBHk",14) == 3059879625) strcat(s, "E");
if (crc32("arfGeKSrxCmkj",13) == 3453051300) strcat(s, "a");
if (crc32("ojzjlPgWgxy",11) == 4097828720) strcat(s, "t");
if (crc32("oBvOY",5) == 3648465231) strcat(s, "i");
if (crc32("tufFHTel",8) == 521336635) strcat(s, "r");
if (crc32("sgEZHkhDLlQIUJX",15) == 1246715258) strcat(s, "c");
if (crc32("eRMNVxA",7) == 476469737) strcat(s, "W");
if (crc32("kAIPCvgGvLcWG",13) == 2021002907) strcat(s, "a");
if (crc32("OLLWqAAnZvHGQz",14) == 2282949937) strcat(s, "l");
if (crc32("TYZsuDwVzxrv",12) == 801952461) strcat(s, "l");
if (crc32("TuLLYMK",7) == 4236574606) strcat(s, "N");
if (crc32("WZjSsKoupHS",11) == 3883908589) strcat(s, "y");
    return s;
}

char *blusterously_adverbs() {
    char *s = calloc(13);
    if (crc32("eSYnqzP",7) == 988843290) strcat(s, "W");
if (crc32("pcqPZtoYZYHkAPv",15) == 2351917192) strcat(s, "b");
if (crc32("HSeyGPxp",8) == 4227868090) strcat(s, "l");
if (crc32("WNTkDTNjZFk",11) == 2435183422) strcat(s, "u");
if (crc32("pPLhD",5) == 1374161138) strcat(s, "s");
if (crc32("Omeffqo",7) == 1940460900) strcat(s, "t");
if (crc32("tBiMwsIH",8) == 4207538614) strcat(s, "z");
if (crc32("ajQiyVNPPhBHTGt",15) == 1493972201) strcat(s, "e");
if (crc32("FXMSOygxeUZjQj",14) == 87861723) strcat(s, "r");
if (crc32("HKHNX",5) == 2541182108) strcat(s, "o");
if (crc32("kwpcMNwCYQZ",11) == 2915248130) strcat(s, "g");
if (crc32("KeAPDGowoBOfcWz",15) == 1547787182) strcat(s, "u");
if (crc32("MKvZDpxGRavIAr",14) == 911410262) strcat(s, "s");
if (crc32("nVNej",5) == 3249527073) strcat(s, "l");
if (crc32("iHaJpfK",7) == 3034184128) strcat(s, "a");
if (crc32("sGiecmGDF",9) == 600399927) strcat(s, "y");
    return s;
}

char *nonnormally_adverbs() {
    char *s = calloc(12);
    if (crc32("GaqQTOTes",9) == 2901987203) strcat(s, "T");
if (crc32("kPGLk",5) == 280272255) strcat(s, "n");
if (crc32("hSMdzzN",7) == 2799324004) strcat(s, "o");
if (crc32("gBEYpya",7) == 658664002) strcat(s, "n");
if (crc32("srRiUu",6) == 727551218) strcat(s, "X");
if (crc32("PUufzJqeBWUSBG",14) == 2235817042) strcat(s, "n");
if (crc32("eYuxZzziK",9) == 2579724906) strcat(s, "o");
if (crc32("cXDUI",5) == 1395376446) strcat(s, "K");
if (crc32("wmostyZ",7) == 1150974056) strcat(s, "r");
if (crc32("caVjJjc",7) == 838255404) strcat(s, "m");
if (crc32("rABITqfAjh",10) == 2184673628) strcat(s, "a");
if (crc32("YFQHZotLh",9) == 656746489) strcat(s, "s");
if (crc32("bkpXruUyEldFVj",14) == 490320751) strcat(s, "l");
if (crc32("GMbxWIb",7) == 160165224) strcat(s, "l");
if (crc32("GlfregEXcrDcOHt",15) == 3238551460) strcat(s, "m");
if (crc32("GtVUsISPj",9) == 1240361104) strcat(s, "y");
    return s;
}

char *ennoblingly_adverbs() {
    char *s = calloc(12);
    if (crc32("qfnvqtOyQzxz",12) == 1060923583) strcat(s, "e");
if (crc32("KyGdILQGmqR",11) == 588717508) strcat(s, "n");
if (crc32("ohpRgbnj",8) == 4094903426) strcat(s, "r");
if (crc32("qlwajjiZdjieeQB",15) == 3247888205) strcat(s, "n");
if (crc32("PUWekdYfO",9) == 3531698521) strcat(s, "G");
if (crc32("dMZgCGd",7) == 37419504) strcat(s, "o");
if (crc32("RyOExAWCBi",10) == 3022049214) strcat(s, "b");
if (crc32("EVgkc",5) == 270753083) strcat(s, "U");
if (crc32("ERZIMfvJG",9) == 3330349177) strcat(s, "l");
if (crc32("umLhqBWyNo",10) == 3303881394) strcat(s, "i");
if (crc32("AwsFRDaeNziQ",12) == 1198201005) strcat(s, "e");
if (crc32("Fdxll",5) == 1920666256) strcat(s, "n");
if (crc32("yKBTyEgKz",9) == 3295447194) strcat(s, "u");
if (crc32("PVbuVLkpGyb",11) == 2764047813) strcat(s, "g");
if (crc32("UOaowCmRVi",10) == 1584956611) strcat(s, "x");
if (crc32("yfvczkOyDQx",11) == 2208191711) strcat(s, "l");
if (crc32("eLvruskm",8) == 2679577318) strcat(s, "y");
    return s;
}

char *unmethodically_adverbs() {
    char *s = calloc(15);
    if (crc32("yoXcs",5) == 1185178612) strcat(s, "i");
if (crc32("znCMlGkLE",9) == 3292131877) strcat(s, "u");
if (crc32("BAZyoFMXFgU",11) == 2402810798) strcat(s, "n");
if (crc32("IzGtLMsPG",9) == 1216234060) strcat(s, "m");
if (crc32("REcbPysG",8) == 1566822260) strcat(s, "B");
if (crc32("EkcWktRuzS",10) == 2278854332) strcat(s, "e");
if (crc32("njjNP",5) == 1037555019) strcat(s, "a");
if (crc32("ZVwuCWMyWCcWl",13) == 1634605993) strcat(s, "t");
if (crc32("cIsyRNCiig",10) == 4287565167) strcat(s, "h");
if (crc32("fHEJHKJeSXhH",12) == 2634328317) strcat(s, "O");
if (crc32("ntTlHPk",7) == 1952956253) strcat(s, "o");
if (crc32("qGZtVxEsatxH",12) == 3575517865) strcat(s, "x");
if (crc32("TVmnBq",6) == 4291196144) strcat(s, "d");
if (crc32("GzCcpTmHwSn",11) == 3803403698) strcat(s, "i");
if (crc32("zBvHROqi",8) == 2365543754) strcat(s, "P");
if (crc32("MczJdM",6) == 2900717292) strcat(s, "c");
if (crc32("rCaZZAnlvid",11) == 1393321094) strcat(s, "i");
if (crc32("HCwybqByzEGjjgq",15) == 577679955) strcat(s, "a");
if (crc32("DJFgvgjlhyA",11) == 1928416066) strcat(s, "l");
if (crc32("yfYZFEp",7) == 43966387) strcat(s, "l");
if (crc32("imNBoOQdVAOOL",13) == 2667309022) strcat(s, "Y");
if (crc32("kAlcpo",6) == 2133923646) strcat(s, "y");
    return s;
}

char *unmisgivingly_adverbs() {
    char *s = calloc(14);
    if (crc32("AWchkHq",7) == 364637163) strcat(s, "u");
if (crc32("fiJsrIA",7) == 3222816446) strcat(s, "V");
if (crc32("EKgWvJhEDpUkS",13) == 3363345413) strcat(s, "n");
if (crc32("jPgfQzJHspW",11) == 2702257023) strcat(s, "m");
if (crc32("HoFFeuVmGoR",11) == 2335281452) strcat(s, "i");
if (crc32("kNxntMgMJTW",11) == 2839795425) strcat(s, "s");
if (crc32("wmMVJwsGB",9) == 431794620) strcat(s, "a");
if (crc32("PnkHfZgHHtFzu",13) == 1928770681) strcat(s, "g");
if (crc32("CaByT",5) == 1416733040) strcat(s, "Q");
if (crc32("KhvCy",5) == 3043131413) strcat(s, "i");
if (crc32("RaXmbmHicLQR",12) == 1875602021) strcat(s, "d");
if (crc32("cfkTXIu",7) == 812234015) strcat(s, "v");
if (crc32("stiaHXSd",8) == 859117889) strcat(s, "i");
if (crc32("pncJRnx",7) == 164173577) strcat(s, "B");
if (crc32("PlWGwIVPWT",10) == 1717832279) strcat(s, "n");
if (crc32("vgWlSC",6) == 788529088) strcat(s, "g");
if (crc32("UlqYYoG",7) == 3873028732) strcat(s, "G");
if (crc32("rzFWiikiZWjz",12) == 4020509908) strcat(s, "l");
if (crc32("IygmvHKkHw",10) == 3896371536) strcat(s, "J");
if (crc32("mpFsgQ",6) == 576851970) strcat(s, "y");
    return s;
}

char *sulfurously_adverbs() {
    char *s = calloc(12);
    if (crc32("HBGypkd",7) == 1487486407) strcat(s, "T");
if (crc32("OhWHdakDolFBTNz",15) == 1216491794) strcat(s, "s");
if (crc32("fOXtP",5) == 3769323955) strcat(s, "h");
if (crc32("nSaQLOiOASCVism",15) == 227877944) strcat(s, "u");
if (crc32("sVxqQlzRk",9) == 2462176361) strcat(s, "d");
if (crc32("uJvFKk",6) == 197156117) strcat(s, "l");
if (crc32("hFkslrydK",9) == 3423341623) strcat(s, "f");
if (crc32("AvptYdcsCVJWv",13) == 3632548025) strcat(s, "u");
if (crc32("YDDcHLtSrkGZ",12) == 1774765891) strcat(s, "r");
if (crc32("LpgLVwLId",9) == 1679263908) strcat(s, "j");
if (crc32("EdzJDtkoQFzl",12) == 3273424237) strcat(s, "o");
if (crc32("lcPtbvHYWz",10) == 1274526581) strcat(s, "u");
if (crc32("siwfqhcuKXppQo",14) == 1488194008) strcat(s, "W");
if (crc32("PxLydf",6) == 1531763918) strcat(s, "s");
if (crc32("fzOuWJS",7) == 3371600068) strcat(s, "l");
if (crc32("qeCAVRYujYdVp",13) == 2338443372) strcat(s, "y");
    return s;
}

char *entrenous_adverbs() {
    char *s = calloc(10);
    if (crc32("hkmvrUSsrsI",11) == 309218018) strcat(s, "e");
if (crc32("gNGWLnbkQMDyCx",14) == 3431689211) strcat(s, "n");
if (crc32("oWqwVdffAvzMp",13) == 1098697174) strcat(s, "t");
if (crc32("ZluLPB",6) == 96845512) strcat(s, "L");
if (crc32("ZnUGkQwdkbxL",12) == 129747437) strcat(s, "r");
if (crc32("AQMWkFDZx",9) == 3149919285) strcat(s, "e");
if (crc32("hcIoEROAEJ",10) == 934421343) strcat(s, "d");
if (crc32("pTLTFpKCz",9) == 2025165851) strcat(s, "n");
if (crc32("IPLZLYNXAi",10) == 2341058225) strcat(s, "V");
if (crc32("fNYLgqe",7) == 3808266055) strcat(s, "o");
if (crc32("LhTqKmhiitWX",12) == 2176136120) strcat(s, "h");
if (crc32("cTRfx",5) == 1587457412) strcat(s, "u");
if (crc32("ofqFNmhcNTbnPC",14) == 3371299225) strcat(s, "I");
if (crc32("KWNdYj",6) == 2892327550) strcat(s, "s");
    return s;
}

char *quasipolitically_adverbs() {
    char *s = calloc(17);
    if (crc32("VnjduouNimJ",11) == 3391041077) strcat(s, "Y");
if (crc32("ZviQFi",6) == 3545780780) strcat(s, "q");
if (crc32("nKvZIJbAuOIluN",14) == 567265047) strcat(s, "u");
if (crc32("fZpjZEkJ",8) == 1930203845) strcat(s, "F");
if (crc32("JKDnQri",7) == 706475856) strcat(s, "a");
if (crc32("ONsQxxYJlZ",10) == 1711914224) strcat(s, "Z");
if (crc32("GjUTl",5) == 2295217499) strcat(s, "s");
if (crc32("ZKGdtuHgTIev",12) == 3783393331) strcat(s, "i");
if (crc32("qhiuCysbuKEsGNs",15) == 471611556) strcat(s, "p");
if (crc32("NkHAYeLJgDh",11) == 1543085756) strcat(s, "o");
if (crc32("NdQEHfDun",9) == 4086738431) strcat(s, "b");
if (crc32("vZjwIkCoaSkOIe",14) == 3025365995) strcat(s, "l");
if (crc32("ZGvVPQUZ",8) == 2688677369) strcat(s, "i");
if (crc32("aFPyN",5) == 3464991778) strcat(s, "U");
if (crc32("PJIrAASRyp",10) == 3857202754) strcat(s, "t");
if (crc32("qVDRugZCoUWWf",13) == 3510299059) strcat(s, "i");
if (crc32("THZheRRxYO",10) == 2114027507) strcat(s, "w");
if (crc32("PKeEaheYNp",10) == 3017893423) strcat(s, "c");
if (crc32("tFmSamIAxMC",11) == 1431210904) strcat(s, "g");
if (crc32("aTJdNWbQSFl",11) == 1277089382) strcat(s, "a");
if (crc32("igCaPXYonxSyEk",14) == 1068793264) strcat(s, "l");
if (crc32("NmFAYpvfFulwWGG",15) == 4114134194) strcat(s, "l");
if (crc32("oYGaIpdEdwyVBUR",15) == 1111686955) strcat(s, "y");
    return s;
}

char *opposingly_adverbs() {
    char *s = calloc(11);
    if (crc32("Ukdhb",5) == 3968387941) strcat(s, "u");
if (crc32("LqVBk",5) == 4173087481) strcat(s, "o");
if (crc32("dzDLVIZ",7) == 2344701363) strcat(s, "R");
if (crc32("CnRSZxJeEjpbOO",14) == 2416807092) strcat(s, "p");
if (crc32("yxJzTzD",7) == 3025857720) strcat(s, "b");
if (crc32("oANVbuvqiUKdk",13) == 2871649741) strcat(s, "p");
if (crc32("emqeytxMZC",10) == 2569738991) strcat(s, "o");
if (crc32("nXsLe",5) == 1470289499) strcat(s, "x");
if (crc32("nwfzwtoYEGolnc",14) == 886027322) strcat(s, "s");
if (crc32("uHrNI",5) == 2671759345) strcat(s, "i");
if (crc32("bTNKkVBIdNklyx",14) == 2478394854) strcat(s, "N");
if (crc32("xWGgyl",6) == 757231417) strcat(s, "n");
if (crc32("eMZEowl",7) == 1320981684) strcat(s, "g");
if (crc32("KuThJ",5) == 3849847206) strcat(s, "l");
if (crc32("uFMlyCwldpkqi",13) == 1297645196) strcat(s, "y");
    return s;
}

char *forsakenly_adverbs() {
    char *s = calloc(11);
    if (crc32("xKEmk",5) == 1073176894) strcat(s, "f");
if (crc32("TIUnRfsesjHYbW",14) == 3683308886) strcat(s, "o");
if (crc32("mlSaWVSQ",8) == 2047234705) strcat(s, "n");
if (crc32("tCywnbIZyzbKrZz",15) == 2980090552) strcat(s, "r");
if (crc32("kaZOIuxGimKtiNp",15) == 3469471669) strcat(s, "O");
if (crc32("zKprENLMatngB",13) == 3941042784) strcat(s, "s");
if (crc32("oZZEmoVyYX",10) == 1947832933) strcat(s, "c");
if (crc32("kgQtsUpNvhtQqL",14) == 2708498193) strcat(s, "a");
if (crc32("dhISmhyFxjMjgU",14) == 582637131) strcat(s, "k");
if (crc32("gTpObuzMeAGy",12) == 3374979607) strcat(s, "O");
if (crc32("StNveowyWaI",11) == 1860893002) strcat(s, "e");
if (crc32("wKIUV",5) == 4215996257) strcat(s, "n");
if (crc32("nLmINNyY",8) == 803532922) strcat(s, "l");
if (crc32("VeiRiwGvGtjGQ",13) == 1653212263) strcat(s, "y");
    return s;
}

char *agnostically_adverbs() {
    char *s = calloc(13);
    if (crc32("vSpngHFUZfir",12) == 494003278) strcat(s, "g");
if (crc32("qxDjMKTsxXlN",12) == 2536934820) strcat(s, "a");
if (crc32("vIwIS",5) == 2978203842) strcat(s, "m");
if (crc32("NpPMJDbJcFDFkf",14) == 2750642497) strcat(s, "g");
if (crc32("ozWNuE",6) == 2200062783) strcat(s, "n");
if (crc32("RCOkVDP",7) == 18966863) strcat(s, "o");
if (crc32("rykqlxDd",8) == 3121480691) strcat(s, "S");
if (crc32("DYBLwm",6) == 199774885) strcat(s, "s");
if (crc32("upIILFiSebU",11) == 1136541894) strcat(s, "t");
if (crc32("xaBJnNfeQSF",11) == 2493832505) strcat(s, "k");
if (crc32("toZmmFXoYcgO",12) == 997090679) strcat(s, "i");
if (crc32("waklPgWSPvT",11) == 2082600491) strcat(s, "x");
if (crc32("QsVVlnYmdwRYDQb",15) == 3874361321) strcat(s, "c");
if (crc32("mKlxjZwWDvde",12) == 2587391173) strcat(s, "a");
if (crc32("IuXyBzuxvulKbJJ",15) == 1727717703) strcat(s, "z");
if (crc32("QXrDatWlWEjPf",13) == 1469429474) strcat(s, "l");
if (crc32("TiFQjW",6) == 1161403875) strcat(s, "X");
if (crc32("QorpFAr",7) == 708775143) strcat(s, "l");
if (crc32("YXNZbFbBpcfUDRx",15) == 2495438635) strcat(s, "M");
if (crc32("EIbIlrZxnb",10) == 4039207519) strcat(s, "y");
    return s;
}

char *nondefinably_adverbs() {
    char *s = calloc(13);
    if (crc32("qrGqKcUIclBHls",14) == 1438061074) strcat(s, "n");
if (crc32("YAbgcB",6) == 4117066640) strcat(s, "o");
if (crc32("WbCKPSSM",8) == 162968132) strcat(s, "o");
if (crc32("HVfUzhTFDzjHQi",14) == 2929886546) strcat(s, "n");
if (crc32("kVUthI",6) == 3431201315) strcat(s, "l");
if (crc32("sjMrDJbvfmiafB",14) == 2705442849) strcat(s, "d");
if (crc32("fiAEdKf",7) == 1797918874) strcat(s, "e");
if (crc32("jeTXdhCn",8) == 3866556650) strcat(s, "d");
if (crc32("ubpUU",5) == 3993223952) strcat(s, "f");
if (crc32("qxQTlUNuDPhATM",14) == 1224819407) strcat(s, "J");
if (crc32("ZcBLJwxp",8) == 3606920318) strcat(s, "i");
if (crc32("MeRbF",5) == 3455417226) strcat(s, "n");
if (crc32("cupWiNovH",9) == 2929408870) strcat(s, "b");
if (crc32("DCKgmIqMdhtmK",13) == 1632462618) strcat(s, "a");
if (crc32("rkovRaaqLMdEyk",14) == 4946175) strcat(s, "g");
if (crc32("sCvGnzDqs",9) == 3219862924) strcat(s, "b");
if (crc32("nIXEoKa",7) == 2695419002) strcat(s, "l");
if (crc32("hXXbcXnQrGqxF",13) == 3322889044) strcat(s, "f");
if (crc32("pmHhkb",6) == 3868411852) strcat(s, "y");
    return s;
}

char *undiaphanously_adverbs() {
    char *s = calloc(15);
    if (crc32("CCJIoA",6) == 1325527936) strcat(s, "u");
if (crc32("UnmrUzGghr",10) == 2941920912) strcat(s, "n");
if (crc32("VMmaIw",6) == 2767538347) strcat(s, "d");
if (crc32("AtcQMTpjtrEhuxN",15) == 2789199562) strcat(s, "M");
if (crc32("OaddR",5) == 1412519268) strcat(s, "i");
if (crc32("HeiSxfrZaqgXQi",14) == 329062780) strcat(s, "a");
if (crc32("BGlEhSTZkZqMSh",14) == 2371694042) strcat(s, "p");
if (crc32("fnTQqJRaoX",10) == 2196049748) strcat(s, "h");
if (crc32("wMsTwtH",7) == 2924715736) strcat(s, "C");
if (crc32("cXfNKLIfIX",10) == 78729531) strcat(s, "a");
if (crc32("eFBPfCU",7) == 235553462) strcat(s, "m");
if (crc32("PJrtaNYYe",9) == 756486702) strcat(s, "n");
if (crc32("kpevMb",6) == 3620008886) strcat(s, "v");
if (crc32("LYtMVvNA",8) == 1287004305) strcat(s, "o");
if (crc32("cmxGe",5) == 1037061266) strcat(s, "x");
if (crc32("qCOaPacrSTQ",11) == 1867830678) strcat(s, "u");
if (crc32("ckUXM",5) == 3840904360) strcat(s, "s");
if (crc32("cgyszJTSwzi",11) == 4097534831) strcat(s, "E");
if (crc32("UPkPlwu",7) == 3292266657) strcat(s, "l");
if (crc32("MiSud",5) == 2264600052) strcat(s, "i");
if (crc32("KWrvaGtLBYl",11) == 3475214333) strcat(s, "y");
    return s;
}

char *steadfastly_adverbs() {
    char *s = calloc(12);
    if (crc32("OPghIOy",7) == 1867912038) strcat(s, "L");
if (crc32("AyOLT",5) == 4270470891) strcat(s, "s");
if (crc32("DeWiHhV",7) == 2811389189) strcat(s, "b");
if (crc32("hSZsWbHLaojTD",13) == 834464897) strcat(s, "t");
if (crc32("nQdpJB",6) == 4106135237) strcat(s, "e");
if (crc32("irBMGcOznxndSZJ",15) == 1954732601) strcat(s, "a");
if (crc32("aZJiAAGxoj",10) == 3157409309) strcat(s, "t");
if (crc32("qmMUFXaMmnOMZO",14) == 2767723574) strcat(s, "d");
if (crc32("FuQWgjzy",8) == 1725561518) strcat(s, "f");
if (crc32("yxLIvXkxYLBqX",13) == 23013337) strcat(s, "a");
if (crc32("uMkGGWjKWIuaDNW",15) == 811626416) strcat(s, "s");
if (crc32("ScQry",5) == 3383528576) strcat(s, "t");
if (crc32("MMrTCogBXwK",11) == 1740087002) strcat(s, "l");
if (crc32("MVbqvz",6) == 3103717831) strcat(s, "y");
    return s;
}

char *nonpreciously_adverbs() {
    char *s = calloc(14);
    if (crc32("kLzGQaW",7) == 3322849827) strcat(s, "R");
if (crc32("XZWeFvcD",8) == 4118802303) strcat(s, "n");
if (crc32("zRiUlBADXWnC",12) == 2524364564) strcat(s, "A");
if (crc32("zKMldbFmYogY",12) == 2893856500) strcat(s, "o");
if (crc32("yZkaV",5) == 742133891) strcat(s, "n");
if (crc32("HCFQxZTEYXJpmuU",15) == 1096048143) strcat(s, "T");
if (crc32("yQspWEDNxUGiqL",14) == 2236602811) strcat(s, "p");
if (crc32("qTpapCTVnAv",11) == 1546298598) strcat(s, "r");
if (crc32("rsxgcj",6) == 1241412226) strcat(s, "e");
if (crc32("aLMesqCeKtoUJIx",15) == 3889058394) strcat(s, "M");
if (crc32("OrqlskeLfcjtzI",14) == 4235981858) strcat(s, "c");
if (crc32("AACquIOxjpAtN",13) == 2652459655) strcat(s, "t");
if (crc32("FdRjSSVGukZoSLK",15) == 2395137981) strcat(s, "i");
if (crc32("QZaCFcXlXGKuTR",14) == 1524391210) strcat(s, "U");
if (crc32("peeoMScmbSmLwFR",15) == 2780763889) strcat(s, "o");
if (crc32("qvoYZjePeJzf",12) == 2806959141) strcat(s, "u");
if (crc32("ZRvwCtmAp",9) == 2375004620) strcat(s, "s");
if (crc32("AKeXI",5) == 3100746687) strcat(s, "P");
if (crc32("UPuHVU",6) == 1713235) strcat(s, "l");
if (crc32("JlwVNCPOAQ",10) == 1494309463) strcat(s, "y");
    return s;
}

char *unsurely_adverbs() {
    char *s = calloc(9);
    if (crc32("IIeYFVbhjewwfmp",15) == 2377379620) strcat(s, "K");
if (crc32("VoXogfPG",8) == 3363996269) strcat(s, "u");
if (crc32("POaRTmsnonvhBAP",15) == 2607079902) strcat(s, "n");
if (crc32("THLpW",5) == 4137756609) strcat(s, "s");
if (crc32("SiPsbXPKrOPHn",13) == 1734387316) strcat(s, "u");
if (crc32("jrMQAWDpBKYR",12) == 3691243964) strcat(s, "r");
if (crc32("FUdIn",5) == 690847371) strcat(s, "e");
if (crc32("BfFUORXKwol",11) == 3384291662) strcat(s, "l");
if (crc32("emoRG",5) == 2097301254) strcat(s, "y");
    return s;
}

char *girdlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("WHflviCIGSxfUPr",15) == 1809049452) strcat(s, "g");
if (crc32("nOGcqrwgSlEVp",13) == 932502102) strcat(s, "L");
if (crc32("vQRnGVNjBpWe",12) == 143743479) strcat(s, "i");
if (crc32("ZAlivp",6) == 4121516339) strcat(s, "o");
if (crc32("KYMtK",5) == 2367415316) strcat(s, "r");
if (crc32("CPckzChm",8) == 779904515) strcat(s, "V");
if (crc32("zNQgJSkL",8) == 3279338365) strcat(s, "d");
if (crc32("VpfSi",5) == 4092333331) strcat(s, "l");
if (crc32("hEEhK",5) == 2729343898) strcat(s, "P");
if (crc32("SlFHWdiJ",8) == 2016271267) strcat(s, "i");
if (crc32("XXNttKhY",8) == 3346401244) strcat(s, "e");
if (crc32("HNyHAZxoTS",10) == 3411989697) strcat(s, "n");
if (crc32("hUfSP",5) == 3350366671) strcat(s, "X");
if (crc32("qCxNjxPrQsbfe",13) == 23816693) strcat(s, "g");
if (crc32("iKQwRXqqwzy",11) == 1039590280) strcat(s, "E");
if (crc32("uhtyXC",6) == 1638244927) strcat(s, "l");
if (crc32("ZTAxxYVW",8) == 2951752909) strcat(s, "y");
    return s;
}

char *quasirespectfully_adverbs() {
    char *s = calloc(18);
    if (crc32("qYKpMGdWXhGQb",13) == 2057994386) strcat(s, "c");
if (crc32("PoKOuIFL",8) == 136652365) strcat(s, "q");
if (crc32("jcCsbqSYexK",11) == 2079948068) strcat(s, "u");
if (crc32("VAQDLakLgWIzU",13) == 2717726865) strcat(s, "v");
if (crc32("PvNsYToY",8) == 436101313) strcat(s, "a");
if (crc32("qgjRDURP",8) == 791160978) strcat(s, "L");
if (crc32("fazIun",6) == 1219896386) strcat(s, "s");
if (crc32("mynXmTTXuHieBwU",15) == 2895835505) strcat(s, "i");
if (crc32("oAPMWOjbASoGvj",14) == 881521278) strcat(s, "r");
if (crc32("ZndmnPqpJOyn",12) == 3734737428) strcat(s, "e");
if (crc32("VHfYMyf",7) == 1428320010) strcat(s, "a");
if (crc32("JxHFkGpa",8) == 3124263319) strcat(s, "s");
if (crc32("BJdkDAaBdAAv",12) == 1178450429) strcat(s, "W");
if (crc32("AFYHs",5) == 2400154033) strcat(s, "p");
if (crc32("Wcrqh",5) == 140290922) strcat(s, "l");
if (crc32("muUgfMTDUjT",11) == 426423555) strcat(s, "e");
if (crc32("CsaFNZYjD",9) == 431229258) strcat(s, "c");
if (crc32("ediMfMnYegbac",13) == 249913165) strcat(s, "t");
if (crc32("AEhXGnU",7) == 654467479) strcat(s, "n");
if (crc32("RnYwoeBnUBjo",12) == 32593560) strcat(s, "f");
if (crc32("VhQrdkVCzfbxVt",14) == 1997391493) strcat(s, "u");
if (crc32("gQfgMhdIB",9) == 25484039) strcat(s, "Z");
if (crc32("XJEdGyGYTk",10) == 2616684157) strcat(s, "l");
if (crc32("QVmCHLX",7) == 3301204667) strcat(s, "n");
if (crc32("baCSY",5) == 1471649544) strcat(s, "l");
if (crc32("GhfodkxJI",9) == 2446443490) strcat(s, "y");
    return s;
}

char *fugato_adverbs() {
    char *s = calloc(7);
    if (crc32("lRNcwlIAhamYSr",14) == 557298031) strcat(s, "K");
if (crc32("YVJgRchUGS",10) == 400826140) strcat(s, "f");
if (crc32("FjGFDDxfDrECtK",14) == 2069061251) strcat(s, "H");
if (crc32("HSxezB",6) == 2163190977) strcat(s, "u");
if (crc32("yVfSoUSNmf",10) == 843614459) strcat(s, "g");
if (crc32("YWQloDl",7) == 3719548666) strcat(s, "a");
if (crc32("hdoSdjTqZvFn",12) == 3522320066) strcat(s, "l");
if (crc32("MTqDYPY",7) == 873080328) strcat(s, "t");
if (crc32("NajVOEJhCZoCJtX",15) == 1781096550) strcat(s, "o");
    return s;
}

char *inscriptively_adverbs() {
    char *s = calloc(14);
    if (crc32("zNjmRhy",7) == 288205276) strcat(s, "i");
if (crc32("qUlCWfZmjGN",11) == 4269800964) strcat(s, "n");
if (crc32("xVUStNBnjj",10) == 4214397995) strcat(s, "l");
if (crc32("WYJSluPOcinQFD",14) == 3417806064) strcat(s, "s");
if (crc32("uwXhRaLJPGqVB",13) == 2322403615) strcat(s, "c");
if (crc32("FRjoLzOrITjb",12) == 997665541) strcat(s, "r");
if (crc32("eAuWVaMD",8) == 1570555258) strcat(s, "i");
if (crc32("esNGWRLF",8) == 96042284) strcat(s, "p");
if (crc32("kVzlddlXDyJ",11) == 502960467) strcat(s, "U");
if (crc32("awMTMXFtx",9) == 1980188835) strcat(s, "t");
if (crc32("ssAkEtzJ",8) == 208686408) strcat(s, "i");
if (crc32("FzRtr",5) == 2406698032) strcat(s, "v");
if (crc32("PIeZqoShUnr",11) == 3189431746) strcat(s, "e");
if (crc32("afIVxonafMH",11) == 1064141325) strcat(s, "h");
if (crc32("hSWwjdpuVshKVXx",15) == 925382402) strcat(s, "l");
if (crc32("pifKZPbcxxzFoD",14) == 4018012400) strcat(s, "s");
if (crc32("iLNLRP",6) == 3801579505) strcat(s, "y");
    return s;
}

char *leally_adverbs() {
    char *s = calloc(7);
    if (crc32("JmGqMZwJC",9) == 396822400) strcat(s, "l");
if (crc32("qDDOrYAEqead",12) == 4107902133) strcat(s, "r");
if (crc32("XWIBlJxUSJ",10) == 338326043) strcat(s, "e");
if (crc32("xuBcgdANmVZnWKh",15) == 103900370) strcat(s, "a");
if (crc32("bdKFYiXovghW",12) == 1618795352) strcat(s, "l");
if (crc32("MyZNdhaQO",9) == 1456093378) strcat(s, "l");
if (crc32("stHUGIUCnKCBpn",14) == 735408922) strcat(s, "w");
if (crc32("DRZbEKMkhc",10) == 3563426677) strcat(s, "y");
    return s;
}

char *cosmonautically_adverbs() {
    char *s = calloc(16);
    if (crc32("LPcYvQDKCE",10) == 2418329895) strcat(s, "c");
if (crc32("IckUyxummHrQX",13) == 3246450985) strcat(s, "o");
if (crc32("WjHIkavcyRRfdgE",15) == 1091842588) strcat(s, "s");
if (crc32("uZzvdpJy",8) == 434547647) strcat(s, "m");
if (crc32("YFXvNWEfGVyucD",14) == 2824331563) strcat(s, "o");
if (crc32("UcdEt",5) == 2331673298) strcat(s, "n");
if (crc32("wjpGgRtHaNZncq",14) == 2010629600) strcat(s, "Q");
if (crc32("MkneE",5) == 3591624496) strcat(s, "a");
if (crc32("AMxKVbaBgDjBwyd",15) == 1274337266) strcat(s, "u");
if (crc32("wdfkYEILlKLv",12) == 3361637029) strcat(s, "t");
if (crc32("GxLaTPGwuxFIHqO",15) == 1435898973) strcat(s, "P");
if (crc32("GqEjuJjZEFuv",12) == 1571331247) strcat(s, "i");
if (crc32("nezLINm",7) == 1590599909) strcat(s, "c");
if (crc32("wIDvr",5) == 110178999) strcat(s, "J");
if (crc32("zyVuDg",6) == 338069893) strcat(s, "a");
if (crc32("WZWLiUgdSxw",11) == 3320341369) strcat(s, "Q");
if (crc32("hwpZmXXhKeuMTwz",15) == 3206265158) strcat(s, "l");
if (crc32("zXatwePnQw",10) == 1820159506) strcat(s, "l");
if (crc32("QavihxQovlEG",12) == 751888175) strcat(s, "y");
    return s;
}

char *undiatonically_adverbs() {
    char *s = calloc(15);
    if (crc32("CTPdl",5) == 3023560721) strcat(s, "u");
if (crc32("KnCSZGJdNPfN",12) == 878400713) strcat(s, "n");
if (crc32("YYmADfdP",8) == 2049536306) strcat(s, "d");
if (crc32("IuWnjecNwQTA",12) == 2494262737) strcat(s, "y");
if (crc32("HolMtRxNrJTB",12) == 206353324) strcat(s, "i");
if (crc32("oALzdbFBueeXITQ",15) == 54832473) strcat(s, "a");
if (crc32("ZKWsTveEIHNL",12) == 3773164369) strcat(s, "f");
if (crc32("GBfTOnRUWDTYJk",14) == 4058253243) strcat(s, "t");
if (crc32("KcVaSREn",8) == 3073478992) strcat(s, "i");
if (crc32("qLpABmpmmPZsZgp",15) == 4113457349) strcat(s, "o");
if (crc32("wdAPJzSwOJEqJn",14) == 1966168770) strcat(s, "R");
if (crc32("rSgVlTqlhmqLTq",14) == 3160526855) strcat(s, "n");
if (crc32("DqUKJy",6) == 1122685696) strcat(s, "i");
if (crc32("oAmnMOncIihKN",13) == 3709151358) strcat(s, "O");
if (crc32("menbmbKzQGCRORZ",15) == 4021919331) strcat(s, "c");
if (crc32("EgmckgScSSV",11) == 2244626343) strcat(s, "X");
if (crc32("LpnFWwoAWPITvKG",15) == 3929888665) strcat(s, "a");
if (crc32("dwrJVC",6) == 849684759) strcat(s, "t");
if (crc32("bwaLWEfY",8) == 2165547772) strcat(s, "l");
if (crc32("HpwAKsRLn",9) == 1786259524) strcat(s, "G");
if (crc32("zztSOnwZbOmWHo",14) == 2952129688) strcat(s, "l");
if (crc32("bIMuJMhViqSK",12) == 1849247929) strcat(s, "y");
    return s;
}

char *nauseatingly_adverbs() {
    char *s = calloc(13);
    if (crc32("TvThXys",7) == 4235095844) strcat(s, "v");
if (crc32("KNlLelhcCiRLD",13) == 4003136658) strcat(s, "n");
if (crc32("RbugIPDcaOtb",12) == 4218497828) strcat(s, "I");
if (crc32("MFQoLSEzhwqswmS",15) == 2443855016) strcat(s, "a");
if (crc32("tzQlEZEpMYcy",12) == 2165345302) strcat(s, "u");
if (crc32("QQYhwdAKZtDkiBD",15) == 3930403896) strcat(s, "s");
if (crc32("BpLJT",5) == 2419989102) strcat(s, "e");
if (crc32("FsKZPHDhLzGCO",13) == 389921179) strcat(s, "a");
if (crc32("iUgLwYkaWtphgYt",15) == 1455009298) strcat(s, "t");
if (crc32("iqeUnVrnvEBWXI",14) == 2976599867) strcat(s, "y");
if (crc32("WRFbi",5) == 984023620) strcat(s, "i");
if (crc32("mBNtWKzvdts",11) == 3885510529) strcat(s, "n");
if (crc32("EDORSMef",8) == 359105480) strcat(s, "g");
if (crc32("lZrpjvIZpQM",11) == 296274096) strcat(s, "l");
if (crc32("CrWDjyBNKyjDC",13) == 2593527727) strcat(s, "y");
    return s;
}

char *hyperlustrously_adverbs() {
    char *s = calloc(16);
    if (crc32("KAmPaBzWJBReP",13) == 3034449040) strcat(s, "J");
if (crc32("DyAaN",5) == 3787208452) strcat(s, "h");
if (crc32("ZQgRYNsQpUYq",12) == 772975201) strcat(s, "j");
if (crc32("HJrwIhnRvcsNcAf",15) == 3833665284) strcat(s, "y");
if (crc32("lLFfNgmVDURtsLT",15) == 814672414) strcat(s, "R");
if (crc32("PVqfMGtHk",9) == 2218318188) strcat(s, "p");
if (crc32("NgJDSuiAOndtHrR",15) == 2810201177) strcat(s, "e");
if (crc32("KiiJtMZdupSTnRE",15) == 1725651618) strcat(s, "r");
if (crc32("jTqgRxKNbZ",10) == 1184547611) strcat(s, "l");
if (crc32("pMHLg",5) == 2803744696) strcat(s, "u");
if (crc32("vnksdNv",7) == 2793391559) strcat(s, "F");
if (crc32("dIjGOKfpDrOD",12) == 1429148760) strcat(s, "s");
if (crc32("VBXZIyrO",8) == 4057407381) strcat(s, "t");
if (crc32("AfktxuMPsnGYPRH",15) == 526314062) strcat(s, "r");
if (crc32("tXjVoFv",7) == 79441625) strcat(s, "o");
if (crc32("Rpsmc",5) == 3180410923) strcat(s, "u");
if (crc32("aEgpnxblJQ",10) == 1118320380) strcat(s, "s");
if (crc32("CoDbZouroijq",12) == 3883329227) strcat(s, "l");
if (crc32("dqbES",5) == 1294746921) strcat(s, "y");
    return s;
}

char *numerically_adverbs() {
    char *s = calloc(12);
    if (crc32("VCduuAgkMwoZS",13) == 4136459989) strcat(s, "b");
if (crc32("sqrWZLoSgfJFvqs",15) == 4041860709) strcat(s, "n");
if (crc32("JAlXobn",7) == 991508775) strcat(s, "U");
if (crc32("NmcWfmHDvZgGu",13) == 3947601450) strcat(s, "u");
if (crc32("zRtjkEoBlQnARMN",15) == 3795249930) strcat(s, "Z");
if (crc32("kvqTx",5) == 3014536504) strcat(s, "m");
if (crc32("ZAsNmkoCJMNZrjk",15) == 2689167570) strcat(s, "G");
if (crc32("jNEJl",5) == 1453879848) strcat(s, "e");
if (crc32("MMMjTJzSH",9) == 2117264550) strcat(s, "r");
if (crc32("vfCkJXECx",9) == 2344966902) strcat(s, "i");
if (crc32("kjEUzLPzdfs",11) == 2470462514) strcat(s, "p");
if (crc32("fwTgtrURCedji",13) == 2390027656) strcat(s, "c");
if (crc32("sKNNUtybB",9) == 1809811758) strcat(s, "P");
if (crc32("jDZNChwTrftR",12) == 3772917294) strcat(s, "a");
if (crc32("WUxfabcS",8) == 2717083412) strcat(s, "N");
if (crc32("MRHBBLUaRzZpH",13) == 2667609438) strcat(s, "l");
if (crc32("QJXWmmwYyy",10) == 2140959922) strcat(s, "p");
if (crc32("hXECnzdkQoDZ",12) == 3608539923) strcat(s, "l");
if (crc32("yupaE",5) == 1084269220) strcat(s, "y");
    return s;
}

char *figuredly_adverbs() {
    char *s = calloc(10);
    if (crc32("pjhHmGvCJgZcVfS",15) == 3216341979) strcat(s, "M");
if (crc32("qGFMKL",6) == 833976729) strcat(s, "f");
if (crc32("jXInlmSrA",9) == 2907498094) strcat(s, "i");
if (crc32("CNdohgfdN",9) == 2191350191) strcat(s, "y");
if (crc32("yRNdjiebAhl",11) == 1228954780) strcat(s, "g");
if (crc32("qopuoTUst",9) == 3650958932) strcat(s, "u");
if (crc32("FVfsnu",6) == 3029826358) strcat(s, "W");
if (crc32("Bezkc",5) == 3812463629) strcat(s, "r");
if (crc32("XNoAKdQobWj",11) == 4025812962) strcat(s, "e");
if (crc32("YbMFUMookMYXJF",14) == 1275630831) strcat(s, "r");
if (crc32("YqeKqgnGZTjMVA",14) == 3191690919) strcat(s, "d");
if (crc32("vYoAKhTic",9) == 4137504053) strcat(s, "f");
if (crc32("wkuoAtqPHz",10) == 1333682614) strcat(s, "l");
if (crc32("ARZYvZmMnmtxZi",14) == 1520737413) strcat(s, "y");
    return s;
}

char *stentoriously_adverbs() {
    char *s = calloc(14);
    if (crc32("lxxbIEcJp",9) == 2281162371) strcat(s, "A");
if (crc32("FXihRuxuqYnNzwF",15) == 2301748499) strcat(s, "s");
if (crc32("NRziNmsmOjgw",12) == 3413560001) strcat(s, "t");
if (crc32("IrvsZ",5) == 2368152335) strcat(s, "e");
if (crc32("VLFxUuhhV",9) == 2378662697) strcat(s, "c");
if (crc32("UJXKnVgfLr",10) == 3120912739) strcat(s, "n");
if (crc32("kjYRyupb",8) == 1723435412) strcat(s, "t");
if (crc32("iDIymCKlIHO",11) == 345090238) strcat(s, "Q");
if (crc32("JSJMqOJPT",9) == 2312379180) strcat(s, "o");
if (crc32("CAWuWxnfK",9) == 3991178223) strcat(s, "r");
if (crc32("fsFzASdSF",9) == 3037854491) strcat(s, "Y");
if (crc32("fLXcPaCWvl",10) == 1319581878) strcat(s, "i");
if (crc32("rFIptnPmNXT",11) == 2470058324) strcat(s, "U");
if (crc32("ZqqJQqbQB",9) == 595775160) strcat(s, "o");
if (crc32("IszRHgyVPddBHuW",15) == 160907114) strcat(s, "u");
if (crc32("HHMpV",5) == 1883157888) strcat(s, "X");
if (crc32("nnmqRT",6) == 3721036071) strcat(s, "s");
if (crc32("kruxNAbKSRFa",12) == 1092763790) strcat(s, "l");
if (crc32("oSTsWkGtLcW",11) == 2847649375) strcat(s, "Q");
if (crc32("JpppKUjEOba",11) == 2254817896) strcat(s, "y");
    return s;
}

char *inquiringly_adverbs() {
    char *s = calloc(12);
    if (crc32("vqLxkmyTS",9) == 833293597) strcat(s, "i");
if (crc32("OjUEFcECWRczUZ",14) == 2096527254) strcat(s, "n");
if (crc32("tDGOBH",6) == 2520290276) strcat(s, "D");
if (crc32("uoAWUeHOR",9) == 3590823489) strcat(s, "q");
if (crc32("NRfJmU",6) == 108675920) strcat(s, "X");
if (crc32("HdLdunq",7) == 3740061960) strcat(s, "u");
if (crc32("xsWuwqjmtZ",10) == 769081849) strcat(s, "u");
if (crc32("qjOLVFbpnw",10) == 3187667403) strcat(s, "i");
if (crc32("RfDlAGrEtE",10) == 2660495468) strcat(s, "H");
if (crc32("CLLqnHRqHI",10) == 3278285870) strcat(s, "r");
if (crc32("kYTrtVyfWyvP",12) == 3700948085) strcat(s, "f");
if (crc32("LYwmudGqx",9) == 2436553574) strcat(s, "i");
if (crc32("RWYKXWBmb",9) == 1758735979) strcat(s, "n");
if (crc32("gXlSnlSFVFbAva",14) == 3536026681) strcat(s, "S");
if (crc32("WogVd",5) == 3304227237) strcat(s, "g");
if (crc32("GXZdXyQaMJ",10) == 3255423727) strcat(s, "U");
if (crc32("XzFZgiovEDo",11) == 711624601) strcat(s, "l");
if (crc32("bYEizNUNRbPLN",13) == 623445640) strcat(s, "y");
    return s;
}

char *boobily_adverbs() {
    char *s = calloc(8);
    if (crc32("qMFLZsPEcs",10) == 2422365954) strcat(s, "b");
if (crc32("PZSYbTTeQN",10) == 1022903335) strcat(s, "s");
if (crc32("nMVSdpsyJ",9) == 870445657) strcat(s, "o");
if (crc32("VjzDeSlZcjpUWj",14) == 3941985004) strcat(s, "o");
if (crc32("SkKFapT",7) == 3654579349) strcat(s, "b");
if (crc32("HdejMiDwWMPPH",13) == 801105758) strcat(s, "b");
if (crc32("xnnMPjyDNm",10) == 4275985125) strcat(s, "o");
if (crc32("zVBTGLFRsllaGL",14) == 1644722356) strcat(s, "i");
if (crc32("wSNgPxlGfYhx",12) == 3820244476) strcat(s, "l");
if (crc32("YSKfFsSIGkBmG",13) == 3099913961) strcat(s, "h");
if (crc32("wkYMmOARAJbPj",13) == 3399154070) strcat(s, "y");
    return s;
}

char *uncondemningly_adverbs() {
    char *s = calloc(15);
    if (crc32("KjEgqmRUW",9) == 3230563548) strcat(s, "I");
if (crc32("fFXvdVOBZxjWiTc",15) == 14732789) strcat(s, "u");
if (crc32("MxQAk",5) == 1018729897) strcat(s, "k");
if (crc32("UBchaOC",7) == 1597014671) strcat(s, "n");
if (crc32("alzTAXGFkOnq",12) == 73795187) strcat(s, "z");
if (crc32("wKOzGBAcPSOF",12) == 1939961357) strcat(s, "c");
if (crc32("AsXhhZOPK",9) == 3559089029) strcat(s, "o");
if (crc32("UtHMVgOGdLOPZ",13) == 2625743684) strcat(s, "f");
if (crc32("jylUvlO",7) == 1103206728) strcat(s, "n");
if (crc32("dtKlYv",6) == 4046615948) strcat(s, "d");
if (crc32("MxAcxd",6) == 4287844136) strcat(s, "u");
if (crc32("jEKbGbVWDIus",12) == 2508986567) strcat(s, "e");
if (crc32("cTdvGMonfS",10) == 2185747908) strcat(s, "H");
if (crc32("RQKJxCSdk",9) == 1055284424) strcat(s, "m");
if (crc32("CifOBXPcSeW",11) == 3911334728) strcat(s, "D");
if (crc32("fZDiPIqilhVDIK",14) == 3024652682) strcat(s, "n");
if (crc32("IRDpEYnL",8) == 3239223334) strcat(s, "i");
if (crc32("RVkFyTLWSaBIG",13) == 214806163) strcat(s, "n");
if (crc32("qLXYN",5) == 805261806) strcat(s, "F");
if (crc32("zJXKFyKOxWU",11) == 273972062) strcat(s, "g");
if (crc32("WNKMCKnMx",9) == 2294030463) strcat(s, "M");
if (crc32("xBHHBZCSGWgP",12) == 185941397) strcat(s, "l");
if (crc32("PdjwhSHSH",9) == 2551752674) strcat(s, "i");
if (crc32("HOHagPfkGAOpx",13) == 3700347848) strcat(s, "y");
    return s;
}

char *antiscientifically_adverbs() {
    char *s = calloc(19);
    if (crc32("OpjggmcN",8) == 1362910136) strcat(s, "r");
if (crc32("ArwnmfwJYfDbte",14) == 3691418697) strcat(s, "a");
if (crc32("TrALK",5) == 2757415469) strcat(s, "a");
if (crc32("jBeYvdNv",8) == 1286676007) strcat(s, "n");
if (crc32("hkUduOKOwKMBcgF",15) == 3736398732) strcat(s, "v");
if (crc32("ebUiRXkMPlQ",11) == 48512947) strcat(s, "t");
if (crc32("qTNLj",5) == 3444608530) strcat(s, "i");
if (crc32("kyZlhOnYkx",10) == 2681559048) strcat(s, "M");
if (crc32("tXLBLcWflBqabNf",15) == 2586686499) strcat(s, "s");
if (crc32("vXqIhyOSKUN",11) == 3151066952) strcat(s, "c");
if (crc32("lKbqvHLjZdiy",12) == 343254955) strcat(s, "h");
if (crc32("zgJHEIp",7) == 2341049752) strcat(s, "i");
if (crc32("XzLwaQGnqjXgO",13) == 98082257) strcat(s, "e");
if (crc32("NCocKpdoazxy",12) == 2893339445) strcat(s, "n");
if (crc32("kscdgVLkNG",10) == 2476660538) strcat(s, "t");
if (crc32("AOSjXZ",6) == 3229725036) strcat(s, "K");
if (crc32("mbZqUJSlTKkHBUx",15) == 751551804) strcat(s, "i");
if (crc32("oJcfQeCNbpc",11) == 4280186629) strcat(s, "m");
if (crc32("JJNywd",6) == 118030048) strcat(s, "f");
if (crc32("XahODoXDMtUQcV",14) == 3180273873) strcat(s, "i");
if (crc32("jOiHKcvw",8) == 691506528) strcat(s, "g");
if (crc32("mCwwDxMCIk",10) == 314880713) strcat(s, "c");
if (crc32("zNqcrUBZDdNiwh",14) == 429183576) strcat(s, "a");
if (crc32("hRwtNvQ",7) == 3570491596) strcat(s, "l");
if (crc32("UVJLthVacCnc",12) == 391614651) strcat(s, "r");
if (crc32("qGCkcTgbN",9) == 613660110) strcat(s, "l");
if (crc32("BLvrImy",7) == 117925500) strcat(s, "y");
    return s;
}

char *unspectacularly_adverbs() {
    char *s = calloc(16);
    if (crc32("uGmckTtPXSGnQ",13) == 4278160384) strcat(s, "J");
if (crc32("ISyonYol",8) == 1752663556) strcat(s, "u");
if (crc32("hqyuvjEbPrLgY",13) == 1430947277) strcat(s, "N");
if (crc32("wucxgqjxRtZ",11) == 3927325266) strcat(s, "n");
if (crc32("EhCKeIoBePFi",12) == 1883791526) strcat(s, "s");
if (crc32("SqJKSWCHID",10) == 3946467714) strcat(s, "t");
if (crc32("WoAFDlC",7) == 140431949) strcat(s, "p");
if (crc32("cyiAYTNn",8) == 295578162) strcat(s, "e");
if (crc32("evMysyLZzV",10) == 300428210) strcat(s, "x");
if (crc32("uPRYotqlkCUFbs",14) == 2942448726) strcat(s, "c");
if (crc32("QLNRrmyu",8) == 1462744035) strcat(s, "t");
if (crc32("MZJZJGo",7) == 3161383525) strcat(s, "a");
if (crc32("KYqdTDuxxpz",11) == 1903247676) strcat(s, "c");
if (crc32("uIABsGfzDx",10) == 1615817784) strcat(s, "M");
if (crc32("QMyuLcVgisWEk",13) == 11053325) strcat(s, "u");
if (crc32("BBMav",5) == 1758395646) strcat(s, "l");
if (crc32("ivuQyCgYHzJ",11) == 1383830695) strcat(s, "t");
if (crc32("hgGguiDV",8) == 478697796) strcat(s, "a");
if (crc32("ouokyv",6) == 289908240) strcat(s, "q");
if (crc32("aHCiIoJ",7) == 33350551) strcat(s, "r");
if (crc32("fFZNXtAgHTPrO",13) == 1258338761) strcat(s, "D");
if (crc32("eLBRGDJZc",9) == 190450770) strcat(s, "l");
if (crc32("srJQUWs",7) == 3323161850) strcat(s, "W");
if (crc32("DvtmATYVlzBKi",13) == 2876724932) strcat(s, "y");
    return s;
}

char *elaboratively_adverbs() {
    char *s = calloc(14);
    if (crc32("JBJQRsQ",7) == 691259272) strcat(s, "e");
if (crc32("gSphVfrn",8) == 2324368922) strcat(s, "A");
if (crc32("bGYQsj",6) == 1814244727) strcat(s, "l");
if (crc32("dcHNdg",6) == 2277069517) strcat(s, "u");
if (crc32("NRdwFTgfuXUFdH",14) == 3800993776) strcat(s, "a");
if (crc32("fVZAPgqkY",9) == 2898672075) strcat(s, "z");
if (crc32("gnZSUjWuyq",10) == 3222657392) strcat(s, "b");
if (crc32("mtbmDzjZA",9) == 1715640352) strcat(s, "o");
if (crc32("SttVofSysSCSM",13) == 2991180717) strcat(s, "D");
if (crc32("dSdZBd",6) == 15407616) strcat(s, "r");
if (crc32("aPYgUukLXxAPC",13) == 4122568286) strcat(s, "G");
if (crc32("gqMuEo",6) == 197573356) strcat(s, "a");
if (crc32("TRzmwZCA",8) == 2253592851) strcat(s, "t");
if (crc32("WjgCNTLjySaaU",13) == 722143396) strcat(s, "X");
if (crc32("WbAPZHRkV",9) == 3409768998) strcat(s, "i");
if (crc32("HUFetIqkwLLvd",13) == 648711702) strcat(s, "v");
if (crc32("jMkNhxtL",8) == 1854269182) strcat(s, "g");
if (crc32("svbkw",5) == 893377535) strcat(s, "e");
if (crc32("hTGkJ",5) == 1322963651) strcat(s, "l");
if (crc32("jCrQtHcIsOFivw",14) == 2214319965) strcat(s, "i");
if (crc32("GpqtLcO",7) == 3862853437) strcat(s, "y");
    return s;
}

char *gleefully_adverbs() {
    char *s = calloc(10);
    if (crc32("ZOocWIuRHUBJeF",14) == 2354334533) strcat(s, "g");
if (crc32("LkpHRl",6) == 3935127171) strcat(s, "I");
if (crc32("NRIRHQvVW",9) == 623898878) strcat(s, "l");
if (crc32("CgFWyCr",7) == 1566242158) strcat(s, "L");
if (crc32("dzLvOe",6) == 1514283515) strcat(s, "e");
if (crc32("oXQrwproKKC",11) == 3407447341) strcat(s, "e");
if (crc32("oSbulBvisanI",12) == 1654795063) strcat(s, "Y");
if (crc32("mxeYkmq",7) == 3296245091) strcat(s, "f");
if (crc32("MwvRIJOnXKUuBMA",15) == 3759011646) strcat(s, "e");
if (crc32("lDOydm",6) == 3376560377) strcat(s, "u");
if (crc32("gDRUWvod",8) == 2269397522) strcat(s, "k");
if (crc32("BqtpniG",7) == 4146422062) strcat(s, "l");
if (crc32("rBWphBMFWWipsFD",15) == 4255133557) strcat(s, "m");
if (crc32("zHluNQIrrML",11) == 2390431263) strcat(s, "l");
if (crc32("oRPYHFaGmAnke",13) == 1351136053) strcat(s, "v");
if (crc32("JEJcAGGXUFVmqpU",15) == 2269998352) strcat(s, "y");
    return s;
}

char *unbumptiously_adverbs() {
    char *s = calloc(14);
    if (crc32("WIiOmwRLRgbNNIj",15) == 2217538394) strcat(s, "u");
if (crc32("etmTFrWJsBYGh",13) == 1695654359) strcat(s, "T");
if (crc32("OMImeUegXJKvRKY",15) == 820923829) strcat(s, "n");
if (crc32("koxUgFSboRABOnm",15) == 3554165394) strcat(s, "m");
if (crc32("XQamjyxbgrXC",12) == 1005639484) strcat(s, "b");
if (crc32("yqAUrPuSlfu",11) == 4005209098) strcat(s, "u");
if (crc32("RUFfDXhvum",10) == 842342311) strcat(s, "m");
if (crc32("knXMo",5) == 3583062932) strcat(s, "U");
if (crc32("doshtkrxzrItYaR",15) == 252116185) strcat(s, "p");
if (crc32("JKFedYjgvaC",11) == 3885990544) strcat(s, "u");
if (crc32("BaZotkDkRWI",11) == 2612218400) strcat(s, "t");
if (crc32("JqSlWyDHYiHLysl",15) == 2687726874) strcat(s, "U");
if (crc32("DsAeZnCBbbVA",12) == 3408582184) strcat(s, "i");
if (crc32("cOoCdgYbYbIfnS",14) == 1853911199) strcat(s, "H");
if (crc32("Sbhka",5) == 3536192692) strcat(s, "o");
if (crc32("KHCwOBKQIz",10) == 173688053) strcat(s, "C");
if (crc32("VUNTDINGc",9) == 591672801) strcat(s, "u");
if (crc32("RldyEUHrhLJeuR",14) == 272371452) strcat(s, "R");
if (crc32("JWIKdpaQzUnt",12) == 1922956200) strcat(s, "s");
if (crc32("ITIYLwnHdWWyWY",14) == 142514788) strcat(s, "l");
if (crc32("JJIKqEvuhKCOd",13) == 1642754429) strcat(s, "y");
    return s;
}

char *stereochromatically_adverbs() {
    char *s = calloc(20);
    if (crc32("OaqOQoAgZGLX",12) == 246620031) strcat(s, "K");
if (crc32("IHIcMDZr",8) == 845376442) strcat(s, "s");
if (crc32("ycXJIE",6) == 398761535) strcat(s, "t");
if (crc32("KlULY",5) == 2602706477) strcat(s, "J");
if (crc32("HlWWlKSJKtJzQmn",15) == 1356595451) strcat(s, "e");
if (crc32("heDYstbKAAe",11) == 3753043429) strcat(s, "a");
if (crc32("vZoGZLZ",7) == 339313251) strcat(s, "r");
if (crc32("gxhXPp",6) == 454212035) strcat(s, "e");
if (crc32("DmtUoDBzX",9) == 2461334880) strcat(s, "o");
if (crc32("uVbvacjyGSFP",12) == 1600084027) strcat(s, "o");
if (crc32("pFEofHPGSFGFy",13) == 3484260902) strcat(s, "E");
if (crc32("NMHYWhntFbyz",12) == 2396050522) strcat(s, "c");
if (crc32("KgpMtrnMh",9) == 3024776006) strcat(s, "j");
if (crc32("NORZiI",6) == 3844292786) strcat(s, "h");
if (crc32("oDwveA",6) == 475575820) strcat(s, "v");
if (crc32("hhQbfDIetYxdvLh",15) == 822508545) strcat(s, "r");
if (crc32("GHMlvjmTO",9) == 3160762561) strcat(s, "k");
if (crc32("qbEBzCvEnyfDpQ",14) == 140096950) strcat(s, "o");
if (crc32("qRJcaHHBjl",10) == 4179963688) strcat(s, "m");
if (crc32("boTcvZRlARCO",12) == 221105085) strcat(s, "r");
if (crc32("FPjeU",5) == 2622955833) strcat(s, "a");
if (crc32("DHAHWKgCh",9) == 2382073311) strcat(s, "t");
if (crc32("wNtTvxovpG",10) == 2025562025) strcat(s, "b");
if (crc32("FmckxgmZeEqI",12) == 1875731827) strcat(s, "i");
if (crc32("rglfLueHAmwR",12) == 1485659106) strcat(s, "c");
if (crc32("QDEKBZCpcj",10) == 528968109) strcat(s, "a");
if (crc32("ykfTbGsaVx",10) == 4177068855) strcat(s, "w");
if (crc32("ZkanXsAICvtnFv",14) == 1840176086) strcat(s, "l");
if (crc32("emrzCMsq",8) == 808684264) strcat(s, "l");
if (crc32("vZxwvCgrsRtL",12) == 4032508912) strcat(s, "y");
    return s;
}

char *electrometrically_adverbs() {
    char *s = calloc(18);
    if (crc32("UgIxsScTmwiX",12) == 3626603581) strcat(s, "A");
if (crc32("RYJmdfe",7) == 2550737891) strcat(s, "e");
if (crc32("VIKaiGzJ",8) == 2146289787) strcat(s, "f");
if (crc32("MvbWvL",6) == 2319808776) strcat(s, "l");
if (crc32("CzWnzmqr",8) == 1896031309) strcat(s, "e");
if (crc32("NONEsYyN",8) == 994640486) strcat(s, "c");
if (crc32("SpNTqjf",7) == 1227823727) strcat(s, "t");
if (crc32("XlbQlCWLOwBebF",14) == 3741118927) strcat(s, "r");
if (crc32("KtROqbfVDzKujV",14) == 696650297) strcat(s, "o");
if (crc32("mEQAYIvc",8) == 4264460931) strcat(s, "m");
if (crc32("voGlpjbPxjjD",12) == 3954982726) strcat(s, "b");
if (crc32("MWmbrFmgaPY",11) == 2530080806) strcat(s, "e");
if (crc32("DlnCSDntUe",10) == 728930523) strcat(s, "t");
if (crc32("YZaEyrF",7) == 3527586605) strcat(s, "b");
if (crc32("NgzMDrPuXIOklL",14) == 3710095126) strcat(s, "r");
if (crc32("PazbOnZWpevDRG",14) == 966135172) strcat(s, "i");
if (crc32("VadVMw",6) == 2558849845) strcat(s, "c");
if (crc32("XONocbun",8) == 1156944520) strcat(s, "x");
if (crc32("XQZgGHqHtW",10) == 3474926818) strcat(s, "a");
if (crc32("KbXvcFBVlQkjrD",14) == 424189378) strcat(s, "v");
if (crc32("fSiBPhl",7) == 3753098014) strcat(s, "l");
if (crc32("qvXGE",5) == 2548421367) strcat(s, "l");
if (crc32("dfxsRAoRd",9) == 1133590880) strcat(s, "y");
    return s;
}

char *rightaway_adverbs() {
    char *s = calloc(10);
    if (crc32("eUEznqxukH",10) == 823598788) strcat(s, "r");
if (crc32("nOhcNddNGJTpLI",14) == 1766668613) strcat(s, "i");
if (crc32("yrlvnDfb",8) == 2552178663) strcat(s, "g");
if (crc32("PqRaiqoaDwigmk",14) == 3763743721) strcat(s, "h");
if (crc32("yYbPdXD",7) == 2445569531) strcat(s, "c");
if (crc32("ZoFJUWVhMG",10) == 307393757) strcat(s, "t");
if (crc32("YFmmVJtamzcpv",13) == 1331665189) strcat(s, "A");
if (crc32("RogakwDE",8) == 2437302024) strcat(s, "a");
if (crc32("XwAtHJovB",9) == 3787303402) strcat(s, "Y");
if (crc32("uekpOQCXzaQp",12) == 1972962543) strcat(s, "w");
if (crc32("TBxScTXWJrI",11) == 3045136609) strcat(s, "a");
if (crc32("pzxRDRQfIteqsep",15) == 2776137901) strcat(s, "t");
if (crc32("rmhjJKoSStYHP",13) == 739513102) strcat(s, "y");
    return s;
}

char *drearily_adverbs() {
    char *s = calloc(9);
    if (crc32("WwdsrIuGozeysHS",15) == 3778639831) strcat(s, "C");
if (crc32("jaPVpUj",7) == 2569914008) strcat(s, "d");
if (crc32("jedsXj",6) == 1955175653) strcat(s, "r");
if (crc32("CnrevENek",9) == 2232417430) strcat(s, "e");
if (crc32("VkJjbH",6) == 1552779852) strcat(s, "U");
if (crc32("dNnnIHovmMSRSRu",15) == 3896521371) strcat(s, "a");
if (crc32("WmNufiIbhHTN",12) == 1129132516) strcat(s, "E");
if (crc32("maZgkYedylRwun",14) == 1045021806) strcat(s, "r");
if (crc32("NNsMT",5) == 3623708379) strcat(s, "y");
if (crc32("xFQhXeo",7) == 3340963319) strcat(s, "i");
if (crc32("QjIHjLfB",8) == 366147816) strcat(s, "l");
if (crc32("OKaaQhsERLWUlBD",15) == 2058488878) strcat(s, "w");
if (crc32("rhHUkgtJtscYax",14) == 783231537) strcat(s, "y");
    return s;
}

char *haply_adverbs() {
    char *s = calloc(6);
    if (crc32("nJLqyFDSY",9) == 2203376680) strcat(s, "q");
if (crc32("DhmUTIcrs",9) == 1698724349) strcat(s, "h");
if (crc32("FbtvvRBVyG",10) == 1977117319) strcat(s, "a");
if (crc32("hBXtLFEmwu",10) == 1288169016) strcat(s, "p");
if (crc32("ZKHdkTLslAVh",12) == 4071436150) strcat(s, "t");
if (crc32("hNUUEL",6) == 3597037452) strcat(s, "l");
if (crc32("WCbqfa",6) == 2536697579) strcat(s, "A");
if (crc32("snopVhuZrPhBqGt",15) == 4107392572) strcat(s, "y");
    return s;
}

char *unprecisely_adverbs() {
    char *s = calloc(12);
    if (crc32("Iabby",5) == 622494384) strcat(s, "u");
if (crc32("FVCytSIRE",9) == 1634847835) strcat(s, "x");
if (crc32("buwvrY",6) == 1827020462) strcat(s, "n");
if (crc32("oHBWHI",6) == 788327252) strcat(s, "c");
if (crc32("NaZDoRNhQxHsB",13) == 3679672480) strcat(s, "p");
if (crc32("hKGLPD",6) == 707367721) strcat(s, "R");
if (crc32("XsBMGYIFi",9) == 3705560848) strcat(s, "r");
if (crc32("XzIKnPxnrZNa",12) == 567107724) strcat(s, "P");
if (crc32("kjtZneYlcleA",12) == 2450765866) strcat(s, "e");
if (crc32("oqkaxWxjtenju",13) == 1260810920) strcat(s, "c");
if (crc32("wBjNHJWdZWmLy",13) == 889456532) strcat(s, "r");
if (crc32("AiPScEjc",8) == 4184673737) strcat(s, "i");
if (crc32("gGurdLuQre",10) == 2288977609) strcat(s, "g");
if (crc32("kboluLl",7) == 1904297686) strcat(s, "s");
if (crc32("vaDWJkrQSQ",10) == 2610956078) strcat(s, "p");
if (crc32("FTTtOyRLvN",10) == 1821523330) strcat(s, "e");
if (crc32("cwatJuEPsXOThC",14) == 91117781) strcat(s, "l");
if (crc32("fLxBnn",6) == 2123178759) strcat(s, "y");
    return s;
}

char *overprosperously_adverbs() {
    char *s = calloc(17);
    if (crc32("qYTpVPUK",8) == 3241187826) strcat(s, "D");
if (crc32("hpVlXDpl",8) == 507548478) strcat(s, "o");
if (crc32("WmwbdzokoSBFM",13) == 4079213509) strcat(s, "v");
if (crc32("OZPODZoAPAnaUxk",15) == 1276349274) strcat(s, "e");
if (crc32("DijWyMswujr",11) == 1204138536) strcat(s, "r");
if (crc32("NspSrs",6) == 3944897319) strcat(s, "p");
if (crc32("uoNOHhIGSNh",11) == 2717511657) strcat(s, "r");
if (crc32("NxpczBDvyvZElEE",15) == 936712286) strcat(s, "B");
if (crc32("pWbbH",5) == 230031104) strcat(s, "o");
if (crc32("YiiaqtllMkAKP",13) == 2553579274) strcat(s, "s");
if (crc32("smBIlJU",7) == 1676973838) strcat(s, "h");
if (crc32("LExTxAvKcouVcO",14) == 4182897682) strcat(s, "p");
if (crc32("wpndt",5) == 973007507) strcat(s, "I");
if (crc32("BcCmLh",6) == 4224401818) strcat(s, "e");
if (crc32("CUViukEm",8) == 4255654686) strcat(s, "k");
if (crc32("dsjeDQs",7) == 2909194677) strcat(s, "r");
if (crc32("cvAhun",6) == 2335593503) strcat(s, "U");
if (crc32("NxWTMdZGMwcXi",13) == 1068596030) strcat(s, "o");
if (crc32("uoqgqsNedT",10) == 2023215690) strcat(s, "u");
if (crc32("HQXFOowZwcHi",12) == 2863746631) strcat(s, "s");
if (crc32("oWEjBXlBpEOb",12) == 416899549) strcat(s, "w");
if (crc32("fuCJxrRyDXo",11) == 2310114590) strcat(s, "l");
if (crc32("COQyTUnk",8) == 3299868054) strcat(s, "J");
if (crc32("MsyfgmcTQkNF",12) == 573982895) strcat(s, "y");
    return s;
}

char *contingently_adverbs() {
    char *s = calloc(13);
    if (crc32("tjAAerrnSnHmLhq",15) == 1952782809) strcat(s, "c");
if (crc32("YcMKahduLoMaau",14) == 1730171663) strcat(s, "V");
if (crc32("DambAqx",7) == 128944337) strcat(s, "o");
if (crc32("mWrSaif",7) == 1708616803) strcat(s, "n");
if (crc32("lPjRvaXqit",10) == 1855355347) strcat(s, "t");
if (crc32("mmBUdwlQ",8) == 1175517106) strcat(s, "i");
if (crc32("VEdUjJNjg",9) == 3027046848) strcat(s, "n");
if (crc32("wSLqpnl",7) == 1925621444) strcat(s, "y");
if (crc32("rsFjyWzKPFcoN",13) == 4020815723) strcat(s, "g");
if (crc32("YyELP",5) == 379337980) strcat(s, "Z");
if (crc32("BaNwcEPf",8) == 475235476) strcat(s, "e");
if (crc32("HnpzVLSsLw",10) == 173967351) strcat(s, "g");
if (crc32("eHnjIKwYiOqBmTm",15) == 1331358595) strcat(s, "n");
if (crc32("mvSUpnOMi",9) == 4028203578) strcat(s, "q");
if (crc32("JKyhXdgVEdNgwBH",15) == 4180774845) strcat(s, "t");
if (crc32("MrKTzkDJMOYqlq",14) == 1647220630) strcat(s, "l");
if (crc32("CfmwnHAteCiCGi",14) == 2351632433) strcat(s, "y");
    return s;
}

char *unthroatily_adverbs() {
    char *s = calloc(12);
    if (crc32("yRhOAYL",7) == 1552719281) strcat(s, "g");
if (crc32("wOfLePgLgtBSkaL",15) == 2052851740) strcat(s, "u");
if (crc32("VJDLjHFvF",9) == 4007587912) strcat(s, "H");
if (crc32("FahrjbOaMKaBq",13) == 3540447526) strcat(s, "n");
if (crc32("mpsXI",5) == 3882490908) strcat(s, "t");
if (crc32("zoHEQ",5) == 4193185404) strcat(s, "h");
if (crc32("phgUaIEPwPvJOEO",15) == 4088302591) strcat(s, "t");
if (crc32("pJHekEAZb",9) == 1370624167) strcat(s, "r");
if (crc32("hGobk",5) == 2810418941) strcat(s, "o");
if (crc32("vhiRVHqGiDx",11) == 549065498) strcat(s, "H");
if (crc32("MmjllCF",7) == 2878224947) strcat(s, "a");
if (crc32("XAqBlHIylIyL",12) == 479367061) strcat(s, "t");
if (crc32("RInaSiApcD",10) == 2465921799) strcat(s, "i");
if (crc32("spjrsqX",7) == 1549359242) strcat(s, "l");
if (crc32("CQtFhGOtut",10) == 202057056) strcat(s, "o");
if (crc32("yOuyuQdVshNUlx",14) == 4123713528) strcat(s, "y");
    return s;
}

char *overlushly_adverbs() {
    char *s = calloc(11);
    if (crc32("bHhReMZnk",9) == 4016235240) strcat(s, "o");
if (crc32("MfcGFwQQiamWC",13) == 3287810629) strcat(s, "H");
if (crc32("mXsCzTsbHxdPX",13) == 336720900) strcat(s, "v");
if (crc32("RYgavWGDXgtNE",13) == 3701692277) strcat(s, "e");
if (crc32("HiyWxuIi",8) == 3699981959) strcat(s, "o");
if (crc32("uWRITTzalFtYP",13) == 1711547917) strcat(s, "r");
if (crc32("aQErCJ",6) == 3438362185) strcat(s, "R");
if (crc32("jHuUbryMXE",10) == 165120524) strcat(s, "l");
if (crc32("nFKCUwgSCDq",11) == 592884646) strcat(s, "i");
if (crc32("aUnyiLO",7) == 561155062) strcat(s, "u");
if (crc32("EOVsMcogjCyas",13) == 3440088097) strcat(s, "s");
if (crc32("ZOJmWFh",7) == 1563368879) strcat(s, "U");
if (crc32("xdYVeOdHGrZ",11) == 1277356355) strcat(s, "h");
if (crc32("GcjGE",5) == 4188801410) strcat(s, "l");
if (crc32("eKaMzPuyHF",10) == 2172992915) strcat(s, "o");
if (crc32("RYRxXrHvlR",10) == 1763764911) strcat(s, "y");
    return s;
}

char *antimilitaristically_adverbs() {
    char *s = calloc(21);
    if (crc32("GzXUJnAw",8) == 4255001365) strcat(s, "D");
if (crc32("ijlNgRp",7) == 2553601145) strcat(s, "a");
if (crc32("eLZbCKbYlO",10) == 1526321760) strcat(s, "D");
if (crc32("yLvnxa",6) == 3517117368) strcat(s, "n");
if (crc32("XPEAirfqtPX",11) == 1880763144) strcat(s, "t");
if (crc32("USNPdZ",6) == 641890730) strcat(s, "Y");
if (crc32("FzzXKZLnw",9) == 433632776) strcat(s, "i");
if (crc32("XdNBubxBeEPst",13) == 518776184) strcat(s, "m");
if (crc32("IbxvmQD",7) == 1973567121) strcat(s, "e");
if (crc32("bzsXuX",6) == 1799476115) strcat(s, "i");
if (crc32("YhUjczkXOLJQ",12) == 977756675) strcat(s, "y");
if (crc32("cOrVx",5) == 1049431305) strcat(s, "l");
if (crc32("DJZump",6) == 1100253338) strcat(s, "i");
if (crc32("WtyfyuIcLym",11) == 1697988794) strcat(s, "t");
if (crc32("ynYKbym",7) == 3811155533) strcat(s, "D");
if (crc32("tVjRwkr",7) == 2225517760) strcat(s, "a");
if (crc32("tQOrJwfVR",9) == 3877009696) strcat(s, "r");
if (crc32("qmBIzmdiTLJ",11) == 3239744854) strcat(s, "i");
if (crc32("AbPyWcJSExiOt",13) == 3304366799) strcat(s, "e");
if (crc32("nHhredzEUzXwr",13) == 3369504192) strcat(s, "s");
if (crc32("dwiwotozZOObYbZ",15) == 1094438088) strcat(s, "A");
if (crc32("kOhQdPiYeoKU",12) == 3939499702) strcat(s, "t");
if (crc32("LhNSHxvmpSjdj",13) == 955351481) strcat(s, "i");
if (crc32("UZVFNVBNEHOgRR",14) == 3873142764) strcat(s, "c");
if (crc32("AkvmNvMdgEkbUo",14) == 1408877345) strcat(s, "h");
if (crc32("EJRrRdm",7) == 4224913806) strcat(s, "a");
if (crc32("kNVVJcJBXofTDem",15) == 227600018) strcat(s, "z");
if (crc32("jVNQbNxtlcv",11) == 1356191406) strcat(s, "l");
if (crc32("gbSjuV",6) == 192490916) strcat(s, "l");
if (crc32("egfGXEYRIAQ",11) == 3199393256) strcat(s, "N");
if (crc32("KEKkjB",6) == 1259983961) strcat(s, "y");
    return s;
}

char *imperatorially_adverbs() {
    char *s = calloc(15);
    if (crc32("UCfeAGdIPgOsmDA",15) == 1438905276) strcat(s, "i");
if (crc32("fNKgMGY",7) == 4015892247) strcat(s, "A");
if (crc32("zdSGcKqWTQattU",14) == 1643947302) strcat(s, "m");
if (crc32("CzVTebBv",8) == 2716792338) strcat(s, "p");
if (crc32("pbxmiJ",6) == 3224715646) strcat(s, "D");
if (crc32("awoUjgFw",8) == 683452931) strcat(s, "e");
if (crc32("ZqFuXmV",7) == 3274248939) strcat(s, "q");
if (crc32("XKRxN",5) == 2616117660) strcat(s, "r");
if (crc32("zzrHnnCP",8) == 390875454) strcat(s, "a");
if (crc32("QyhfWqgMpyYX",12) == 3452400792) strcat(s, "v");
if (crc32("FSgnGBsxUiHInH",14) == 2571197583) strcat(s, "t");
if (crc32("slNJoStkWa",10) == 2161249497) strcat(s, "i");
if (crc32("XNLCB",5) == 2408322247) strcat(s, "o");
if (crc32("TqvyeWr",7) == 2183706713) strcat(s, "l");
if (crc32("jJvPAzKZVwZ",11) == 3327947405) strcat(s, "r");
if (crc32("mODnfjCEijvbflQ",15) == 2256531331) strcat(s, "A");
if (crc32("yftOACxVbD",10) == 1734412669) strcat(s, "i");
if (crc32("AgZdmzWf",8) == 3466746059) strcat(s, "a");
if (crc32("efOVmvKWmPozMZi",15) == 227162496) strcat(s, "l");
if (crc32("vcMJS",5) == 4138089797) strcat(s, "Y");
if (crc32("RrWoutwTdpuacyx",15) == 3444228009) strcat(s, "l");
if (crc32("DRSQfasyKyxsBGk",15) == 1922431169) strcat(s, "y");
    return s;
}

char *unanswerably_adverbs() {
    char *s = calloc(13);
    if (crc32("qAIwdPyg",8) == 1909600113) strcat(s, "u");
if (crc32("EOoMgtZX",8) == 1113800389) strcat(s, "L");
if (crc32("NDSAVKHWotF",11) == 1520717284) strcat(s, "n");
if (crc32("fUCykHELTIBE",12) == 1542498442) strcat(s, "a");
if (crc32("OyXkgYjQau",10) == 1847805092) strcat(s, "T");
if (crc32("yBIPEFOyhhS",11) == 1234478277) strcat(s, "n");
if (crc32("TOoSkFMZrcnKRMk",15) == 3256414787) strcat(s, "s");
if (crc32("UkoSRpCSjNOoZCi",15) == 3149444129) strcat(s, "Z");
if (crc32("PkpQSdHpFawLxkM",15) == 3708479257) strcat(s, "w");
if (crc32("wjOboNpAjfMnK",13) == 3224800430) strcat(s, "a");
if (crc32("pVKPdjdptKvsV",13) == 2296743872) strcat(s, "e");
if (crc32("xpxgMfWjRzDHRCs",15) == 2612394284) strcat(s, "f");
if (crc32("gMUgYsUApm",10) == 2835325874) strcat(s, "r");
if (crc32("fxQbVmPJYNU",11) == 2653176689) strcat(s, "V");
if (crc32("GCuQgPPDTEmTjNJ",15) == 3036351821) strcat(s, "a");
if (crc32("FDFixBXXy",9) == 2701415447) strcat(s, "B");
if (crc32("GRQFyHs",7) == 1275488955) strcat(s, "b");
if (crc32("sjKGDEMiPsprtNI",15) == 2027166551) strcat(s, "w");
if (crc32("apTUMRPP",8) == 628216739) strcat(s, "l");
if (crc32("ScDzqQUBFOexJI",14) == 2523674933) strcat(s, "J");
if (crc32("rzXesHXHB",9) == 1874869224) strcat(s, "y");
    return s;
}

char *unfictitiously_adverbs() {
    char *s = calloc(15);
    if (crc32("hrWNrhiAB",9) == 3663007078) strcat(s, "C");
if (crc32("GKxUijwjZaEpc",13) == 3623891987) strcat(s, "u");
if (crc32("LIiuYo",6) == 1054595434) strcat(s, "n");
if (crc32("fKoZbF",6) == 2655057304) strcat(s, "H");
if (crc32("EvjMshAwKH",10) == 1094707973) strcat(s, "f");
if (crc32("juOTFgJpfxLXnI",14) == 2959092669) strcat(s, "a");
if (crc32("IAPSMW",6) == 3911836074) strcat(s, "i");
if (crc32("fOznZgEBYmK",11) == 2110856225) strcat(s, "c");
if (crc32("dEVEfhwCQBgdL",13) == 4101301797) strcat(s, "L");
if (crc32("LKMnakv",7) == 1991827814) strcat(s, "t");
if (crc32("ZSIXLaxwgKmI",12) == 2908291742) strcat(s, "l");
if (crc32("GxdJttzD",8) == 186606791) strcat(s, "i");
if (crc32("UTuVJqM",7) == 705040046) strcat(s, "e");
if (crc32("BpargaIcHDXN",12) == 1925213985) strcat(s, "t");
if (crc32("krHmjUFtMMegzPd",15) == 3772130796) strcat(s, "D");
if (crc32("bYzJBtYLyTuH",12) == 2219359013) strcat(s, "i");
if (crc32("vfRHepLgybnMnR",14) == 888832464) strcat(s, "o");
if (crc32("UrEHV",5) == 991863126) strcat(s, "u");
if (crc32("oEGdDLtlnyfnB",13) == 2690049009) strcat(s, "u");
if (crc32("CCkeqZEQbnV",11) == 554705233) strcat(s, "s");
if (crc32("OXjMmAhXmMRcq",13) == 1751707862) strcat(s, "l");
if (crc32("ndauBokexxH",11) == 330185165) strcat(s, "y");
    return s;
}

char *accusatorially_adverbs() {
    char *s = calloc(15);
    if (crc32("zKTLdrKr",8) == 2625244724) strcat(s, "e");
if (crc32("XWdDksJAa",9) == 2732737313) strcat(s, "a");
if (crc32("piiAmhjk",8) == 4279792865) strcat(s, "F");
if (crc32("ZJACeuWfcuPvC",13) == 911929200) strcat(s, "c");
if (crc32("WZyoETqMzoxCzE",14) == 1064877663) strcat(s, "W");
if (crc32("fexVdK",6) == 412637459) strcat(s, "c");
if (crc32("zjjKxneKEQ",10) == 4224646705) strcat(s, "K");
if (crc32("TbcyrFN",7) == 2807916074) strcat(s, "u");
if (crc32("DFqumeyiKgzdQit",15) == 3831758318) strcat(s, "G");
if (crc32("OngoIzTiXJbCa",13) == 3964773483) strcat(s, "s");
if (crc32("hmaxKBiJvjxM",12) == 3318862545) strcat(s, "a");
if (crc32("lvgxsIzEZNMFCIe",15) == 1354282427) strcat(s, "t");
if (crc32("VTbHMcwJCfwdFqO",15) == 3874257140) strcat(s, "o");
if (crc32("pBzjB",5) == 143995009) strcat(s, "h");
if (crc32("HXveGynwEpwS",12) == 736569837) strcat(s, "r");
if (crc32("uUiGrgD",7) == 3789949145) strcat(s, "i");
if (crc32("iRtOOEvavqOtt",13) == 2578581494) strcat(s, "a");
if (crc32("ToMwCyS",7) == 2610715360) strcat(s, "l");
if (crc32("JgyyMvazYRN",11) == 2713170597) strcat(s, "l");
if (crc32("OsDnMrFnRavdG",13) == 1792551835) strcat(s, "l");
if (crc32("NaEnLBMoybSIIy",14) == 4166308319) strcat(s, "y");
    return s;
}

char *comprehensively_adverbs() {
    char *s = calloc(16);
    if (crc32("RBebaIFTcypaiPW",15) == 3284146698) strcat(s, "A");
if (crc32("nBIDI",5) == 895708157) strcat(s, "c");
if (crc32("ibkDFgWAALoBi",13) == 4076134848) strcat(s, "o");
if (crc32("LlCTcP",6) == 1379264983) strcat(s, "m");
if (crc32("qllGKeLgknTFJW",14) == 736412715) strcat(s, "p");
if (crc32("XcVqwdSvhyYPg",13) == 820090630) strcat(s, "r");
if (crc32("EoPWELIJZe",10) == 1308102186) strcat(s, "N");
if (crc32("PbCzNCMxXHwycdH",15) == 3337303806) strcat(s, "e");
if (crc32("JSmapvG",7) == 3491352217) strcat(s, "h");
if (crc32("oOPjb",5) == 1311109635) strcat(s, "e");
if (crc32("GHjWhQRO",8) == 4022397144) strcat(s, "n");
if (crc32("JaUaDqtndrnfhO",14) == 721386680) strcat(s, "X");
if (crc32("uPtvokmNzQGt",12) == 2447788590) strcat(s, "s");
if (crc32("HXIKdNba",8) == 3180743310) strcat(s, "W");
if (crc32("NRDbIh",6) == 4222917398) strcat(s, "i");
if (crc32("iffviQE",7) == 802587030) strcat(s, "S");
if (crc32("WtQnOer",7) == 3898631380) strcat(s, "v");
if (crc32("VopwB",5) == 3194588670) strcat(s, "e");
if (crc32("GTWfJqI",7) == 1535696121) strcat(s, "l");
if (crc32("ADopzRdWs",9) == 1436895646) strcat(s, "y");
    return s;
}

char *acromial_adverbs() {
    char *s = calloc(9);
    if (crc32("AyShMF",6) == 993581780) strcat(s, "v");
if (crc32("LBOATXwajxqK",12) == 3434090513) strcat(s, "a");
if (crc32("vnUlxQUrBFXHjxb",15) == 1411752328) strcat(s, "T");
if (crc32("tUCYTskIbru",11) == 4090521623) strcat(s, "c");
if (crc32("YusduYIsTSFtw",13) == 2707742808) strcat(s, "m");
if (crc32("ngCbjNC",7) == 419952226) strcat(s, "r");
if (crc32("cFLLAKGGBgB",11) == 3707958606) strcat(s, "o");
if (crc32("XWIVWh",6) == 3818020782) strcat(s, "m");
if (crc32("jySKFwlALVOlJ",13) == 3520116831) strcat(s, "i");
if (crc32("MacJsvP",7) == 362478449) strcat(s, "a");
if (crc32("NniOogw",7) == 1269135301) strcat(s, "l");
    return s;
}

char *nonzonally_adverbs() {
    char *s = calloc(11);
    if (crc32("mlvQFOumiLGzSRj",15) == 547400614) strcat(s, "L");
if (crc32("EzThi",5) == 2689392355) strcat(s, "n");
if (crc32("sbQGwfvb",8) == 4016682436) strcat(s, "b");
if (crc32("IJsciElsiWbqJ",13) == 3417536009) strcat(s, "o");
if (crc32("NGgqDYHVofRFou",14) == 3705205710) strcat(s, "M");
if (crc32("ZqqHwgnBeSdRrwP",15) == 22111844) strcat(s, "n");
if (crc32("CLqeQDS",7) == 774700167) strcat(s, "K");
if (crc32("RdnmDWEkn",9) == 538214569) strcat(s, "z");
if (crc32("GAxaZjrjnY",10) == 391734138) strcat(s, "o");
if (crc32("zGKkwF",6) == 117373748) strcat(s, "n");
if (crc32("SuZcYegfO",9) == 1369858967) strcat(s, "c");
if (crc32("jSaerWRAGnGXcNv",15) == 1144804645) strcat(s, "a");
if (crc32("uvyhrVmNhpekQmV",15) == 1364097640) strcat(s, "l");
if (crc32("icGvVraVkoiv",12) == 3065134056) strcat(s, "i");
if (crc32("MlKInSM",7) == 3574312857) strcat(s, "l");
if (crc32("tyCip",5) == 1252117583) strcat(s, "y");
    return s;
}

char *pantheistically_adverbs() {
    char *s = calloc(16);
    if (crc32("UDNzDPSXynBI",12) == 3374905658) strcat(s, "p");
if (crc32("TSaNarnIbNd",11) == 1116703421) strcat(s, "a");
if (crc32("tUbbDz",6) == 2348806676) strcat(s, "U");
if (crc32("JGqQWWAqRQuLV",13) == 1936282595) strcat(s, "n");
if (crc32("ySAaZz",6) == 2019949314) strcat(s, "t");
if (crc32("jfFxZ",5) == 329419336) strcat(s, "h");
if (crc32("osBPxEldZL",10) == 3874899063) strcat(s, "L");
if (crc32("xiGNFzv",7) == 3836281072) strcat(s, "e");
if (crc32("mZOdFOLitwnLVyA",15) == 2591469479) strcat(s, "I");
if (crc32("vZrNTDohQUZpicB",15) == 2334697823) strcat(s, "i");
if (crc32("bKTlzagzW",9) == 360218932) strcat(s, "s");
if (crc32("MeMaVHiWpQggs",13) == 3053703039) strcat(s, "t");
if (crc32("DxlIbhQJiygFr",13) == 3845678105) strcat(s, "i");
if (crc32("UyZOP",5) == 1564996072) strcat(s, "c");
if (crc32("zszSxmybh",9) == 2387138744) strcat(s, "b");
if (crc32("aWMYTTNoTndH",12) == 2070214484) strcat(s, "a");
if (crc32("EZobZs",6) == 2357035190) strcat(s, "F");
if (crc32("bAPgC",5) == 2947362706) strcat(s, "l");
if (crc32("uHpnYmxpuZTLU",13) == 1468816518) strcat(s, "l");
if (crc32("tjeddtQ",7) == 3511886207) strcat(s, "y");
    return s;
}

char *fructuously_adverbs() {
    char *s = calloc(12);
    if (crc32("GZNInxGItsM",11) == 1926399647) strcat(s, "A");
if (crc32("ATjvtwHcANhdJ",13) == 610589252) strcat(s, "f");
if (crc32("sRfAbXXqiALLqc",14) == 2399898010) strcat(s, "n");
if (crc32("xffbBlIeROUlaT",14) == 2417183796) strcat(s, "r");
if (crc32("xwNVMeI",7) == 2684377482) strcat(s, "G");
if (crc32("WOIILa",6) == 2244257355) strcat(s, "u");
if (crc32("kHTImGFk",8) == 2640432267) strcat(s, "c");
if (crc32("aXJnVqTTnjre",12) == 1179928456) strcat(s, "G");
if (crc32("uYqyIGHaR",9) == 2756448693) strcat(s, "t");
if (crc32("OPHlcbxZ",8) == 119273573) strcat(s, "u");
if (crc32("TcnlASynzbCjM",13) == 3461525137) strcat(s, "o");
if (crc32("ogDJCnhtBiYMpo",14) == 3458544825) strcat(s, "K");
if (crc32("IKqBaGIchJZBMI",14) == 907808574) strcat(s, "u");
if (crc32("xOzhLzWw",8) == 403728376) strcat(s, "s");
if (crc32("NzHueCx",7) == 3692384472) strcat(s, "l");
if (crc32("IoMLGEedwkKX",12) == 3845408986) strcat(s, "P");
if (crc32("lwbFeAJRQLr",11) == 1506746478) strcat(s, "y");
    return s;
}

char *imploringly_adverbs() {
    char *s = calloc(12);
    if (crc32("BoUoT",5) == 3118163993) strcat(s, "d");
if (crc32("BCqnhCnS",8) == 408406087) strcat(s, "i");
if (crc32("YBgyqMfan",9) == 101114053) strcat(s, "m");
if (crc32("GTyGJMCCS",9) == 3337406313) strcat(s, "p");
if (crc32("pWUbiukNndTl",12) == 663841754) strcat(s, "m");
if (crc32("IlKJixWwnZ",10) == 1040416945) strcat(s, "l");
if (crc32("rvbZEmCXZ",9) == 417472495) strcat(s, "L");
if (crc32("hdjNxttMDuEI",12) == 4128505752) strcat(s, "o");
if (crc32("mHGYHgJlIQgOn",13) == 2907280281) strcat(s, "l");
if (crc32("FZKjmzCPEYZ",11) == 3836766733) strcat(s, "r");
if (crc32("OGNvccoq",8) == 1149092685) strcat(s, "U");
if (crc32("gpfvSTAelyh",11) == 2977366372) strcat(s, "i");
if (crc32("sZKTzyDiOPblmAN",15) == 507153312) strcat(s, "n");
if (crc32("pkFgPamxzSK",11) == 1782645841) strcat(s, "I");
if (crc32("ECDtsHUtyWDG",12) == 2699212629) strcat(s, "g");
if (crc32("QqihAZdOF",9) == 3306960414) strcat(s, "D");
if (crc32("AleAXzOyXprgY",13) == 1956299510) strcat(s, "l");
if (crc32("lfNYfrvFRKFyW",13) == 3760167902) strcat(s, "P");
if (crc32("MuGWKAyl",8) == 1982859729) strcat(s, "y");
    return s;
}

char *architecturally_adverbs() {
    char *s = calloc(16);
    if (crc32("WxiHPxjv",8) == 363173774) strcat(s, "a");
if (crc32("xkxGkdrQWUP",11) == 1096882447) strcat(s, "r");
if (crc32("kaeXFjV",7) == 2717812657) strcat(s, "d");
if (crc32("juCoNg",6) == 1587089310) strcat(s, "c");
if (crc32("hhZxddGhPNeTOz",14) == 1907789500) strcat(s, "m");
if (crc32("EhDmhamjl",9) == 3303931585) strcat(s, "h");
if (crc32("ciPUZcHXXChbljU",15) == 2132985282) strcat(s, "a");
if (crc32("UTvgUrbocAbjNu",14) == 384401825) strcat(s, "i");
if (crc32("ZDwBZ",5) == 2028356326) strcat(s, "O");
if (crc32("KRIPa",5) == 2000741305) strcat(s, "t");
if (crc32("MwGgW",5) == 1267840748) strcat(s, "x");
if (crc32("ZMSCTis",7) == 1234912505) strcat(s, "e");
if (crc32("PNEVJQxHf",9) == 3284739220) strcat(s, "c");
if (crc32("DltGd",5) == 3166633248) strcat(s, "t");
if (crc32("jPLqWG",6) == 3104684054) strcat(s, "u");
if (crc32("URfZltNh",8) == 2968936361) strcat(s, "p");
if (crc32("YisRg",5) == 3101949706) strcat(s, "r");
if (crc32("EXHZDPCDdwsZUz",14) == 3187767953) strcat(s, "u");
if (crc32("jeTbEHOfvep",11) == 2053589116) strcat(s, "a");
if (crc32("PgsCHy",6) == 2356228727) strcat(s, "l");
if (crc32("ZbjzPUxQaJ",10) == 3648106489) strcat(s, "x");
if (crc32("BgjlNd",6) == 3912450928) strcat(s, "l");
if (crc32("jCElbs",6) == 1950227694) strcat(s, "y");
    return s;
}

char *swaggeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("CGdLQQvGKmV",11) == 59048586) strcat(s, "E");
if (crc32("trNOpX",6) == 3907065880) strcat(s, "s");
if (crc32("hweWwacx",8) == 840630184) strcat(s, "w");
if (crc32("NNvAdlLMjuM",11) == 3801325613) strcat(s, "a");
if (crc32("dCEYIBGKvvEKSnb",15) == 1653221014) strcat(s, "g");
if (crc32("LAAMlAtlVFuwkWp",15) == 3230211403) strcat(s, "Z");
if (crc32("wJlpzgklyzJy",12) == 100023861) strcat(s, "g");
if (crc32("CIsflukQWDp",11) == 3407867429) strcat(s, "R");
if (crc32("lWtHXpC",7) == 809951657) strcat(s, "e");
if (crc32("njIJIQMedP",10) == 1112210404) strcat(s, "v");
if (crc32("PhyWeo",6) == 2924323280) strcat(s, "r");
if (crc32("rrKMnLSkYM",10) == 3483080797) strcat(s, "i");
if (crc32("SMdZbkXz",8) == 1838084580) strcat(s, "n");
if (crc32("bFOwyTmKHTiFOD",14) == 109004727) strcat(s, "g");
if (crc32("JWQFyvxK",8) == 943725802) strcat(s, "x");
if (crc32("BAfhHJW",7) == 3809247302) strcat(s, "l");
if (crc32("WDmuyfFmKfwH",12) == 1572520377) strcat(s, "w");
if (crc32("otaIExIIAPgpJyd",15) == 765147445) strcat(s, "y");
    return s;
}

char *pronouncedly_adverbs() {
    char *s = calloc(13);
    if (crc32("nabOjJbpiIofW",13) == 1075053752) strcat(s, "Q");
if (crc32("PrqHWTBmqSdMIK",14) == 3115143862) strcat(s, "p");
if (crc32("awxpRLXsXvL",11) == 2387198681) strcat(s, "T");
if (crc32("qvuMWvLjoIArB",13) == 409278907) strcat(s, "r");
if (crc32("KcXKBN",6) == 2454764764) strcat(s, "U");
if (crc32("vMWhLDJrnKmHVa",14) == 593314261) strcat(s, "o");
if (crc32("arpFErnd",8) == 2484857151) strcat(s, "n");
if (crc32("GnVReje",7) == 348068048) strcat(s, "o");
if (crc32("rSLvaBoWVdv",11) == 1063001224) strcat(s, "u");
if (crc32("aLwTOVnww",9) == 3043000525) strcat(s, "n");
if (crc32("qXUpzfYIlfelzKr",15) == 4133821415) strcat(s, "D");
if (crc32("qUYUQN",6) == 1878627213) strcat(s, "c");
if (crc32("XAQhB",5) == 3811780835) strcat(s, "Q");
if (crc32("aIiuecJdLbzy",12) == 1952303181) strcat(s, "e");
if (crc32("eLVfYs",6) == 1957800821) strcat(s, "d");
if (crc32("svBQtMS",7) == 676882800) strcat(s, "l");
if (crc32("UKsfoglYonXC",12) == 179200602) strcat(s, "Q");
if (crc32("YMnQvzpaKdt",11) == 2070066571) strcat(s, "y");
    return s;
}

char *autonomically_adverbs() {
    char *s = calloc(14);
    if (crc32("YhlokCgeXle",11) == 2825966763) strcat(s, "a");
if (crc32("uANYBBDUQz",10) == 1396818612) strcat(s, "R");
if (crc32("xjaQadwboC",10) == 1235945821) strcat(s, "u");
if (crc32("JlsDSHcPY",9) == 2687938235) strcat(s, "t");
if (crc32("iMghxWX",7) == 1609460442) strcat(s, "w");
if (crc32("hAHCTBeKCMuXNo",14) == 1298876711) strcat(s, "o");
if (crc32("pxQEMOJVUul",11) == 799231938) strcat(s, "n");
if (crc32("GUdWqhGkubYawbY",15) == 821114894) strcat(s, "o");
if (crc32("zNZIQ",5) == 1383538229) strcat(s, "m");
if (crc32("CPlmyLPda",9) == 5789853) strcat(s, "E");
if (crc32("PoHELNVSA",9) == 2874536155) strcat(s, "i");
if (crc32("aCzUtXiVdvN",11) == 4114868952) strcat(s, "Q");
if (crc32("GXLAbEnHA",9) == 2845608660) strcat(s, "c");
if (crc32("CUUwKNFgm",9) == 4235939326) strcat(s, "c");
if (crc32("FSAaJIS",7) == 2020669679) strcat(s, "a");
if (crc32("mPVTxZNQu",9) == 1572870739) strcat(s, "l");
if (crc32("OsQpIUxW",8) == 3902616134) strcat(s, "l");
if (crc32("TZUCAAyFRPGbkRb",15) == 211105372) strcat(s, "y");
    return s;
}

char *tenurially_adverbs() {
    char *s = calloc(11);
    if (crc32("PlRnY",5) == 2203544200) strcat(s, "U");
if (crc32("HhOHARaT",8) == 3992888591) strcat(s, "t");
if (crc32("ZjFIwgmkTl",10) == 4078629885) strcat(s, "o");
if (crc32("jJuMDQgdus",10) == 1280201065) strcat(s, "e");
if (crc32("pxKLgrcuQgvFC",13) == 3232778044) strcat(s, "o");
if (crc32("IjJujmVwi",9) == 1214811961) strcat(s, "n");
if (crc32("iSVlVk",6) == 918769354) strcat(s, "m");
if (crc32("vjeVBjDDIESScKu",15) == 1513339911) strcat(s, "u");
if (crc32("LQbDOdfguDDZq",13) == 2380834181) strcat(s, "r");
if (crc32("msbRczGcNvo",11) == 2246356937) strcat(s, "i");
if (crc32("MllceiiERPtUIVe",15) == 4151359429) strcat(s, "a");
if (crc32("ZmGtEMRmr",9) == 2743715569) strcat(s, "l");
if (crc32("PerhmTagvXzsP",13) == 4153295353) strcat(s, "p");
if (crc32("MHYabHwlGhpR",12) == 4061739105) strcat(s, "l");
if (crc32("GoaBYNbUVJKxS",13) == 375671988) strcat(s, "y");
    return s;
}

char *hyperprophetically_adverbs() {
    char *s = calloc(19);
    if (crc32("QauVJd",6) == 3611512785) strcat(s, "B");
if (crc32("AszbvFLwUuZiryB",15) == 1120547240) strcat(s, "h");
if (crc32("UsOkZUmtfji",11) == 1250281699) strcat(s, "y");
if (crc32("YAWvNSDkXz",10) == 1738454956) strcat(s, "p");
if (crc32("bbnUaRrMxZU",11) == 3088456035) strcat(s, "e");
if (crc32("vaPIZkPUD",9) == 1232797371) strcat(s, "K");
if (crc32("JQBhVmTq",8) == 3836978515) strcat(s, "r");
if (crc32("AhMQVZqjXcuY",12) == 934172751) strcat(s, "p");
if (crc32("hnhlJwxiUldHzl",14) == 2964522523) strcat(s, "S");
if (crc32("LDlCbpFiLm",10) == 1015915391) strcat(s, "r");
if (crc32("lvvTRDT",7) == 2849472411) strcat(s, "o");
if (crc32("EjLxIkbTfvkEaRi",15) == 3490512487) strcat(s, "p");
if (crc32("NiVaDbxRA",9) == 1404617184) strcat(s, "h");
if (crc32("xvVVdAuXS",9) == 493154333) strcat(s, "Z");
if (crc32("MtCMphh",7) == 3834791676) strcat(s, "e");
if (crc32("bYXnZuKO",8) == 2216302799) strcat(s, "t");
if (crc32("KMVDtHpsT",9) == 2995596266) strcat(s, "i");
if (crc32("rczvEhGOD",9) == 2518902326) strcat(s, "i");
if (crc32("gRloMWfLObRm",12) == 1797431706) strcat(s, "c");
if (crc32("psWcCiUtMzcqq",13) == 1768407117) strcat(s, "Z");
if (crc32("bjAwxjaSToKJkyQ",15) == 310174345) strcat(s, "a");
if (crc32("KCSkIxlCyqInGb",14) == 1445403618) strcat(s, "x");
if (crc32("SxfuKMwya",9) == 2990604937) strcat(s, "l");
if (crc32("zQxVkpri",8) == 4011635688) strcat(s, "O");
if (crc32("RbIulBgnVnrdUWg",15) == 781864846) strcat(s, "l");
if (crc32("HgppJYiZD",9) == 1820459457) strcat(s, "y");
    return s;
}

char *harpwise_adverbs() {
    char *s = calloc(9);
    if (crc32("zhJQrSyuCMClom",14) == 91625022) strcat(s, "X");
if (crc32("EZlUFixqDuqpmQT",15) == 402886667) strcat(s, "h");
if (crc32("LzPmhlQoGhZqJtA",15) == 3453919082) strcat(s, "O");
if (crc32("gVTEfVsgPdytnBF",15) == 271292018) strcat(s, "a");
if (crc32("QQnaZya",7) == 499562361) strcat(s, "I");
if (crc32("poEoD",5) == 3106950477) strcat(s, "r");
if (crc32("OzsVMdoOwvBApI",14) == 3321767267) strcat(s, "a");
if (crc32("owdeAZghJTMbM",13) == 2006449804) strcat(s, "p");
if (crc32("oehSmyZCky",10) == 4256531157) strcat(s, "w");
if (crc32("UewAuTQEtMr",11) == 3074374573) strcat(s, "h");
if (crc32("rPCSm",5) == 1584688123) strcat(s, "i");
if (crc32("ilVecrTuMfpIYYu",15) == 1617555422) strcat(s, "s");
if (crc32("dGoWuuuP",8) == 3443135857) strcat(s, "I");
if (crc32("lhCPVnKsJy",10) == 2383791721) strcat(s, "e");
    return s;
}

char *unhostilely_adverbs() {
    char *s = calloc(12);
    if (crc32("TdekutWVG",9) == 3087286628) strcat(s, "y");
if (crc32("jgFZtd",6) == 3982988278) strcat(s, "u");
if (crc32("rbVxzAMn",8) == 2804150908) strcat(s, "z");
if (crc32("tpnOQvg",7) == 2899429836) strcat(s, "n");
if (crc32("hAMUui",6) == 1961249956) strcat(s, "r");
if (crc32("bTPLE",5) == 1467600995) strcat(s, "h");
if (crc32("GZAjk",5) == 2306496201) strcat(s, "E");
if (crc32("CHcwFIbHAMpGCf",14) == 2190469251) strcat(s, "o");
if (crc32("iloUxYD",7) == 1542413337) strcat(s, "s");
if (crc32("aXchlkLKGCn",11) == 2638963015) strcat(s, "g");
if (crc32("ovNGJogJNa",10) == 3346410371) strcat(s, "t");
if (crc32("UITEYvFgO",9) == 2744032707) strcat(s, "i");
if (crc32("AVDacV",6) == 1419290870) strcat(s, "c");
if (crc32("XWECShGtkIE",11) == 1522416615) strcat(s, "l");
if (crc32("dXfxBYPC",8) == 2994335722) strcat(s, "l");
if (crc32("kJAYVVvWKxNvZqq",15) == 2581746167) strcat(s, "e");
if (crc32("Mziqwq",6) == 1989702996) strcat(s, "u");
if (crc32("RGixoKDYDHQDu",13) == 2858527459) strcat(s, "l");
if (crc32("CJuVIRphATNqxFn",15) == 3281532015) strcat(s, "A");
if (crc32("yHukuvTPQi",10) == 1945987681) strcat(s, "y");
    return s;
}

char *aforetime_adverbs() {
    char *s = calloc(10);
    if (crc32("qJFGTQ",6) == 1794005689) strcat(s, "a");
if (crc32("jVJDyxz",7) == 1650364606) strcat(s, "f");
if (crc32("WeUHBalNdBi",11) == 149360127) strcat(s, "I");
if (crc32("ZDWuVQnrUmVNC",13) == 2603024945) strcat(s, "o");
if (crc32("SvjqFIPZwpAN",12) == 3202171995) strcat(s, "s");
if (crc32("zgOgGfRfqVFl",12) == 1584092464) strcat(s, "r");
if (crc32("tQJNzFEkqQmVy",13) == 2855853420) strcat(s, "e");
if (crc32("iRQrvKqfy",9) == 3074970798) strcat(s, "t");
if (crc32("LJcJvpxlF",9) == 139161858) strcat(s, "u");
if (crc32("jWCNOwE",7) == 3669453278) strcat(s, "i");
if (crc32("pSKxbV",6) == 107414089) strcat(s, "m");
if (crc32("ZUUfaSNcsRprM",13) == 3647946421) strcat(s, "e");
    return s;
}

char *omnipotently_adverbs() {
    char *s = calloc(13);
    if (crc32("oeaCNWFjod",10) == 1356128088) strcat(s, "o");
if (crc32("VJOBowuqaZ",10) == 3943685242) strcat(s, "v");
if (crc32("YuoriPejuJRKY",13) == 1921803077) strcat(s, "m");
if (crc32("jMcMUW",6) == 3688643167) strcat(s, "n");
if (crc32("qhulcVGcihpAN",13) == 3184140874) strcat(s, "i");
if (crc32("QQuyaE",6) == 250769410) strcat(s, "p");
if (crc32("NVYIPQIwQVQforY",15) == 4277499087) strcat(s, "o");
if (crc32("wkqroGpYJFyQ",12) == 511322792) strcat(s, "S");
if (crc32("StCNDebz",8) == 1976702520) strcat(s, "t");
if (crc32("xltnfCZgjJXvmS",14) == 3487771883) strcat(s, "e");
if (crc32("ylprBOIseBFj",12) == 2342004959) strcat(s, "n");
if (crc32("wzPdXZoIuUAI",12) == 2599432426) strcat(s, "j");
if (crc32("NtiWqgqOfGPWm",13) == 739332899) strcat(s, "t");
if (crc32("damUYCx",7) == 1423490876) strcat(s, "D");
if (crc32("FxLErdclG",9) == 3023910606) strcat(s, "l");
if (crc32("vMTFwALAzMRH",12) == 1705189273) strcat(s, "y");
    return s;
}

char *nonconjugally_adverbs() {
    char *s = calloc(14);
    if (crc32("tMFfeuwpJ",9) == 3843291761) strcat(s, "n");
if (crc32("eWmmKLDJdxT",11) == 1417440661) strcat(s, "o");
if (crc32("FslwN",5) == 1494053464) strcat(s, "E");
if (crc32("gbrNPXZJbAcHRUW",15) == 3894267708) strcat(s, "n");
if (crc32("CErfSAOtpWNQdk",14) == 64268243) strcat(s, "c");
if (crc32("zOeEOMqnHZm",11) == 2082655994) strcat(s, "o");
if (crc32("uByXrjqtTLh",11) == 1654629460) strcat(s, "q");
if (crc32("phGDIczpjTPqyih",15) == 1017587913) strcat(s, "n");
if (crc32("rABwZHuzkn",10) == 1991932576) strcat(s, "j");
if (crc32("zcSLtVRKTblYVlT",15) == 2695468417) strcat(s, "u");
if (crc32("FmvBpVnQqvUALkl",15) == 2047571365) strcat(s, "g");
if (crc32("hKvhaqplt",9) == 1986730272) strcat(s, "E");
if (crc32("iZdors",6) == 3478192096) strcat(s, "a");
if (crc32("OcoRombe",8) == 3723058080) strcat(s, "l");
if (crc32("NWMUhG",6) == 2651821382) strcat(s, "O");
if (crc32("UxGFjmzlgqSR",12) == 4026722494) strcat(s, "l");
if (crc32("YPPIfSXugttCg",13) == 2352042967) strcat(s, "y");
    return s;
}

char *corymbosely_adverbs() {
    char *s = calloc(12);
    if (crc32("rDEQJy",6) == 3097522559) strcat(s, "c");
if (crc32("gHhJxh",6) == 3684679882) strcat(s, "h");
if (crc32("KfxLFdDuuj",10) == 1516741119) strcat(s, "o");
if (crc32("lLGXaCWbKao",11) == 3955917646) strcat(s, "r");
if (crc32("HfIVyPCaQVqh",12) == 1168478631) strcat(s, "y");
if (crc32("lKpkXjT",7) == 816577093) strcat(s, "m");
if (crc32("fdyRGp",6) == 2515476831) strcat(s, "b");
if (crc32("LIreFLwATe",10) == 2467712706) strcat(s, "s");
if (crc32("PRBzOWFKSjUJm",13) == 3719788727) strcat(s, "o");
if (crc32("xiwOOWqXLeYdc",13) == 2950764279) strcat(s, "U");
if (crc32("CMmYo",5) == 1182046147) strcat(s, "s");
if (crc32("JMoMOAIPtmiW",12) == 1418409817) strcat(s, "e");
if (crc32("WdsUFKScUeZ",11) == 2496160358) strcat(s, "Q");
if (crc32("acwyLw",6) == 2476564397) strcat(s, "l");
if (crc32("tXjjAupYUlcSDVd",15) == 3784033142) strcat(s, "K");
if (crc32("GIXWQy",6) == 458169274) strcat(s, "y");
    return s;
}

char *quasicolloquially_adverbs() {
    char *s = calloc(18);
    if (crc32("PaXkpmIrrBH",11) == 1224579742) strcat(s, "q");
if (crc32("YOibTBJhmqUpqe",14) == 3112168759) strcat(s, "y");
if (crc32("ORiDsG",6) == 3490244130) strcat(s, "u");
if (crc32("AQhsRnWrMtu",11) == 826074576) strcat(s, "a");
if (crc32("GCkXjTp",7) == 3761213476) strcat(s, "W");
if (crc32("XUvULtPZS",9) == 1181380500) strcat(s, "s");
if (crc32("mYAWUcHttPpiDoL",15) == 3444153597) strcat(s, "r");
if (crc32("dOgLAJB",7) == 89596717) strcat(s, "i");
if (crc32("qlkWVVBeq",9) == 116343822) strcat(s, "y");
if (crc32("BltAAbn",7) == 2460856277) strcat(s, "c");
if (crc32("nxnLVc",6) == 3718719049) strcat(s, "w");
if (crc32("cUSGkcLMwHf",11) == 2875757928) strcat(s, "o");
if (crc32("hVZtza",6) == 4196137223) strcat(s, "l");
if (crc32("whuGWyziIZz",11) == 2190875903) strcat(s, "D");
if (crc32("AHQgdC",6) == 3441975305) strcat(s, "l");
if (crc32("ZaZhhAcf",8) == 2767723440) strcat(s, "K");
if (crc32("FYcUvT",6) == 189209155) strcat(s, "o");
if (crc32("KaIbJWaM",8) == 509664941) strcat(s, "q");
if (crc32("HMELWh",6) == 1431204672) strcat(s, "t");
if (crc32("KpnwKACNT",9) == 2811986138) strcat(s, "u");
if (crc32("YEuUh",5) == 2306087016) strcat(s, "i");
if (crc32("IFhqZCFk",8) == 4262563496) strcat(s, "a");
if (crc32("zfojqaTiLLee",12) == 662616016) strcat(s, "l");
if (crc32("YRISqfSBcEyGQoZ",15) == 2883666407) strcat(s, "r");
if (crc32("xVDyAsAbuC",10) == 2087400016) strcat(s, "l");
if (crc32("vZkgfoamcqXJW",13) == 2899943067) strcat(s, "y");
    return s;
}

char *blessingly_adverbs() {
    char *s = calloc(11);
    if (crc32("hZcbqT",6) == 522477831) strcat(s, "b");
if (crc32("kCvzxhigP",9) == 271188142) strcat(s, "N");
if (crc32("ympsYGYrQl",10) == 4071398375) strcat(s, "l");
if (crc32("atQwtujwqXs",11) == 2004903052) strcat(s, "r");
if (crc32("slXeRCru",8) == 2488956763) strcat(s, "e");
if (crc32("tmqTbGiYTqtyVYA",15) == 4188935386) strcat(s, "s");
if (crc32("XlafR",5) == 3220754333) strcat(s, "q");
if (crc32("FOviMgUC",8) == 2100629005) strcat(s, "s");
if (crc32("DYheAAiZiMOLc",13) == 2425985557) strcat(s, "R");
if (crc32("mLwMuUzoi",9) == 3985801685) strcat(s, "i");
if (crc32("zovceLS",7) == 2472913306) strcat(s, "n");
if (crc32("uuypS",5) == 764207723) strcat(s, "g");
if (crc32("NVdlrDJjz",9) == 1527292306) strcat(s, "n");
if (crc32("bvsxkSlfwycjlxF",15) == 834966228) strcat(s, "l");
if (crc32("GMdXOVZg",8) == 681146841) strcat(s, "R");
if (crc32("QOUfhqTfytVCkuY",15) == 1027360152) strcat(s, "y");
    return s;
}

char *perpetually_adverbs() {
    char *s = calloc(12);
    if (crc32("dOpRSqsmM",9) == 4186219468) strcat(s, "T");
if (crc32("hkfDJ",5) == 3439406734) strcat(s, "p");
if (crc32("uMDkDqHPs",9) == 894470627) strcat(s, "K");
if (crc32("jKZKcgb",7) == 705869377) strcat(s, "e");
if (crc32("GdPFwDpOOY",10) == 2878626198) strcat(s, "r");
if (crc32("GZOuPk",6) == 548031305) strcat(s, "r");
if (crc32("TPtNxbD",7) == 1299826280) strcat(s, "p");
if (crc32("frTeEXmSqNtNLA",14) == 2036931485) strcat(s, "v");
if (crc32("tkYNpj",6) == 2177546618) strcat(s, "e");
if (crc32("voSdXWvOabZijN",14) == 3899366556) strcat(s, "t");
if (crc32("UMQtg",5) == 3628617585) strcat(s, "q");
if (crc32("ZmhcghXceYo",11) == 528388044) strcat(s, "u");
if (crc32("SstAfskj",8) == 4122975016) strcat(s, "a");
if (crc32("CtORn",5) == 1684888379) strcat(s, "l");
if (crc32("WFwzaambyeSVm",13) == 596079485) strcat(s, "l");
if (crc32("HCJWZNtJBPyIw",13) == 4033035420) strcat(s, "y");
    return s;
}

char *unplacidly_adverbs() {
    char *s = calloc(11);
    if (crc32("BlJsSe",6) == 2713740696) strcat(s, "u");
if (crc32("aZPNwv",6) == 2299448286) strcat(s, "P");
if (crc32("XNNUkENyETnJ",12) == 2365596683) strcat(s, "n");
if (crc32("oQAEtvOJs",9) == 2899704433) strcat(s, "O");
if (crc32("mQhxkxoNWPZHH",13) == 1734418732) strcat(s, "p");
if (crc32("xnTeS",5) == 567647457) strcat(s, "Z");
if (crc32("ToTBt",5) == 2523293581) strcat(s, "l");
if (crc32("KMLgMFDaWxYl",12) == 4244208064) strcat(s, "U");
if (crc32("MgjQyATdYvK",11) == 713299030) strcat(s, "a");
if (crc32("kMUoX",5) == 2887545684) strcat(s, "c");
if (crc32("gkBKB",5) == 3963952021) strcat(s, "w");
if (crc32("YxuxDkXCLJSTyGi",15) == 2489294550) strcat(s, "i");
if (crc32("xswUoDfnoeE",11) == 3256336180) strcat(s, "d");
if (crc32("uklyVu",6) == 3801161608) strcat(s, "l");
if (crc32("bGlzGrHjq",9) == 3155660031) strcat(s, "y");
    return s;
}

char *quasifascinatingly_adverbs() {
    char *s = calloc(19);
    if (crc32("EIVCjNPqczLBluP",15) == 3412449785) strcat(s, "q");
if (crc32("jIjVMRRxoo",10) == 2748012820) strcat(s, "u");
if (crc32("VdphBZcJ",8) == 155641803) strcat(s, "h");
if (crc32("RYmvDwiadyhRJjH",15) == 1698042424) strcat(s, "a");
if (crc32("fsgixdQ",7) == 3533650995) strcat(s, "s");
if (crc32("CeFHhnsBt",9) == 3974545382) strcat(s, "i");
if (crc32("DGUVQlJAm",9) == 595938520) strcat(s, "N");
if (crc32("XushZyIPdi",10) == 2406702038) strcat(s, "f");
if (crc32("SxLvaOi",7) == 2985149137) strcat(s, "a");
if (crc32("QqqdjrTHzjgUeFd",15) == 3668999646) strcat(s, "s");
if (crc32("FYDTVGPn",8) == 404738881) strcat(s, "g");
if (crc32("Bfxqc",5) == 1109464406) strcat(s, "c");
if (crc32("epAkKuRZK",9) == 1631727215) strcat(s, "i");
if (crc32("Shoqf",5) == 4051116079) strcat(s, "J");
if (crc32("oYmYUsKDmTRk",12) == 548844508) strcat(s, "n");
if (crc32("ELPrNHthYT",10) == 2266929760) strcat(s, "C");
if (crc32("ATqNrWDi",8) == 2022501165) strcat(s, "a");
if (crc32("KxcnOiwKLQ",10) == 898535701) strcat(s, "a");
if (crc32("VCbWsgfsp",9) == 1295988193) strcat(s, "t");
if (crc32("nwPNiX",6) == 2823312662) strcat(s, "i");
if (crc32("xDBZCNSFxN",10) == 3696614597) strcat(s, "n");
if (crc32("UXTwCOnNz",9) == 3209326400) strcat(s, "E");
if (crc32("QMdPo",5) == 2185745383) strcat(s, "g");
if (crc32("CzRZaltXWiOSOI",14) == 3138752166) strcat(s, "b");
if (crc32("Duxfelkvxu",10) == 638954692) strcat(s, "l");
if (crc32("MnrBt",5) == 2146094921) strcat(s, "y");
    return s;
}

char *superelaborately_adverbs() {
    char *s = calloc(17);
    if (crc32("qQUnTervWqe",11) == 858407772) strcat(s, "h");
if (crc32("nFUXnNNA",8) == 493093786) strcat(s, "s");
if (crc32("oPwYSMrFZDvz",12) == 3866356937) strcat(s, "u");
if (crc32("WCigzBs",7) == 2149703783) strcat(s, "X");
if (crc32("aZQIIUQkfoLngv",14) == 1991151823) strcat(s, "p");
if (crc32("GFmcnAyOmbwP",12) == 415082653) strcat(s, "e");
if (crc32("pmHRjOiveHY",11) == 2889899395) strcat(s, "r");
if (crc32("nnilZnaBZYxrVhC",15) == 976639474) strcat(s, "p");
if (crc32("mzmwC",5) == 1822860145) strcat(s, "e");
if (crc32("KgbDVd",6) == 2937623159) strcat(s, "J");
if (crc32("GIvYLlhRYLJM",12) == 4003721993) strcat(s, "l");
if (crc32("ymzccvtxBDBuUb",14) == 3973541050) strcat(s, "x");
if (crc32("wMSAGPXbYXvc",12) == 3620179381) strcat(s, "a");
if (crc32("zUwFcqh",7) == 3220167495) strcat(s, "G");
if (crc32("VhIgG",5) == 850169222) strcat(s, "b");
if (crc32("XRKJQbg",7) == 2970425138) strcat(s, "L");
if (crc32("cqfpbxNYhhDP",12) == 1038033899) strcat(s, "o");
if (crc32("nolxND",6) == 2886187332) strcat(s, "r");
if (crc32("bsrxIwy",7) == 394680039) strcat(s, "a");
if (crc32("QGPmeZH",7) == 2374210059) strcat(s, "t");
if (crc32("VraUKcvo",8) == 472608914) strcat(s, "e");
if (crc32("aTEoUWR",7) == 662444075) strcat(s, "x");
if (crc32("dTCLaBG",7) == 3640221910) strcat(s, "l");
if (crc32("bGBDgQYZR",9) == 2353767029) strcat(s, "M");
if (crc32("xkkYfbGRSHNAx",13) == 289522233) strcat(s, "y");
    return s;
}

char *transcendentally_adverbs() {
    char *s = calloc(17);
    if (crc32("wMFmGzPPUvU",11) == 1764572884) strcat(s, "t");
if (crc32("dAHbutR",7) == 1127310544) strcat(s, "t");
if (crc32("zZNIHmcaBiY",11) == 2997777976) strcat(s, "r");
if (crc32("BlgEysznjeRTMxZ",15) == 2506276445) strcat(s, "a");
if (crc32("HzgLXwjcEmwgvYv",15) == 1117450808) strcat(s, "d");
if (crc32("jblicIdbBObuXl",14) == 2316711957) strcat(s, "n");
if (crc32("MyFsgK",6) == 2074563240) strcat(s, "g");
if (crc32("OIyLuiBwEVdnhJ",14) == 504278323) strcat(s, "s");
if (crc32("thVzVham",8) == 1982963479) strcat(s, "I");
if (crc32("HoRsAxyfZgBQni",14) == 1230395925) strcat(s, "c");
if (crc32("SGKfxzobknk",11) == 517897606) strcat(s, "u");
if (crc32("OnAnlWWIxjiQDx",14) == 488097786) strcat(s, "e");
if (crc32("dQtSipY",7) == 2503176634) strcat(s, "x");
if (crc32("JcsnCpWIvnB",11) == 1220613715) strcat(s, "n");
if (crc32("QMZKCKOeIx",10) == 1284174501) strcat(s, "d");
if (crc32("hbhPdKSLocEtPu",14) == 3362755217) strcat(s, "e");
if (crc32("asJQWIx",7) == 254791000) strcat(s, "n");
if (crc32("IAqoZduhPWv",11) == 2729043285) strcat(s, "n");
if (crc32("bgbrFB",6) == 659025702) strcat(s, "t");
if (crc32("hcZPfgsicG",10) == 3960057353) strcat(s, "P");
if (crc32("cQJSIHdK",8) == 396294999) strcat(s, "a");
if (crc32("kqHjvA",6) == 146102901) strcat(s, "X");
if (crc32("HKbLQVvVupEbq",13) == 3668948581) strcat(s, "l");
if (crc32("OZlNJiCN",8) == 1934665855) strcat(s, "l");
if (crc32("wbaUP",5) == 3245608906) strcat(s, "B");
if (crc32("bQpzazmCtDdp",12) == 2826053338) strcat(s, "y");
    return s;
}

char *prodigiously_adverbs() {
    char *s = calloc(13);
    if (crc32("XLMshLYdVmVxp",13) == 3682757911) strcat(s, "x");
if (crc32("pKYtvFYPrCsi",12) == 2673344652) strcat(s, "p");
if (crc32("ptvjUYbuN",9) == 4242176123) strcat(s, "k");
if (crc32("CRlaWJsyFqGIKM",14) == 221711267) strcat(s, "r");
if (crc32("XWUYIaBdu",9) == 2929019600) strcat(s, "o");
if (crc32("IOlqUBjkXGn",11) == 148615449) strcat(s, "d");
if (crc32("JGdgXvqxCftZ",12) == 676221696) strcat(s, "C");
if (crc32("VDPcjGIXkDtb",12) == 2165352821) strcat(s, "i");
if (crc32("vMQWGlX",7) == 3134790048) strcat(s, "B");
if (crc32("HfjhKV",6) == 3345040575) strcat(s, "g");
if (crc32("cVcDraRujnaWqa",14) == 2366924017) strcat(s, "s");
if (crc32("gnfkoZpSfnu",11) == 410280257) strcat(s, "i");
if (crc32("bXZeZiwjzgNklp",14) == 1647615448) strcat(s, "a");
if (crc32("mWHCKEeYexkm",12) == 439434718) strcat(s, "o");
if (crc32("DSJgaTQaB",9) == 572743552) strcat(s, "u");
if (crc32("OFiyoczA",8) == 456223961) strcat(s, "A");
if (crc32("CnKeKLzmZ",9) == 640215252) strcat(s, "s");
if (crc32("gbhYxHVnKbn",11) == 222085980) strcat(s, "F");
if (crc32("vanSFLpdNI",10) == 2239778059) strcat(s, "l");
if (crc32("LDXAJwrgXtleF",13) == 30058384) strcat(s, "y");
    return s;
}

char *innerly_adverbs() {
    char *s = calloc(8);
    if (crc32("bUxpHBn",7) == 1767353796) strcat(s, "i");
if (crc32("LNpmvSkgu",9) == 1038136515) strcat(s, "A");
if (crc32("zCkcSmfo",8) == 3874326278) strcat(s, "n");
if (crc32("rDchjiYPXrhoaFc",15) == 2553335364) strcat(s, "w");
if (crc32("syFmfQheHQp",11) == 3881811146) strcat(s, "n");
if (crc32("EStOLl",6) == 1966218568) strcat(s, "Y");
if (crc32("vyUsd",5) == 2185064011) strcat(s, "e");
if (crc32("rekUJyDCHptv",12) == 18531132) strcat(s, "m");
if (crc32("iytTvTGRcumsr",13) == 732934175) strcat(s, "r");
if (crc32("FijAGuyF",8) == 626732777) strcat(s, "H");
if (crc32("FFYuKlrm",8) == 2490009897) strcat(s, "l");
if (crc32("vDBqzJh",7) == 3647121577) strcat(s, "O");
if (crc32("OflmICs",7) == 153028916) strcat(s, "y");
    return s;
}

char *twohandedly_adverbs() {
    char *s = calloc(12);
    if (crc32("sLZNqbPxm",9) == 237426597) strcat(s, "t");
if (crc32("TZBptTcxOGHB",12) == 449283167) strcat(s, "w");
if (crc32("cKkQwRypJjE",11) == 2425096956) strcat(s, "o");
if (crc32("FyPDjiYc",8) == 4269950642) strcat(s, "h");
if (crc32("ZfDIQ",5) == 1937540363) strcat(s, "g");
if (crc32("nvcyyryqpZrs",12) == 882361843) strcat(s, "a");
if (crc32("xsOhGkqWKJqtPd",14) == 132715895) strcat(s, "Z");
if (crc32("RSDAzPmoG",9) == 670633276) strcat(s, "n");
if (crc32("NBoAG",5) == 547449658) strcat(s, "Z");
if (crc32("xQDtAkbt",8) == 1613176483) strcat(s, "d");
if (crc32("fRLArVfjGT",10) == 3291140467) strcat(s, "I");
if (crc32("GSupigDiacNjw",13) == 4004803177) strcat(s, "e");
if (crc32("KSbTWXmmwhohqz",14) == 1219098856) strcat(s, "d");
if (crc32("PpnPbHDvwre",11) == 1451870837) strcat(s, "v");
if (crc32("nWPLMwQN",8) == 3719887313) strcat(s, "l");
if (crc32("RFiCQMSjuJCb",12) == 3813242742) strcat(s, "y");
    return s;
}

char *unrectangularly_adverbs() {
    char *s = calloc(16);
    if (crc32("wCIpJHBAjvWxh",13) == 1466121003) strcat(s, "U");
if (crc32("PRKPHKBFVIWwN",13) == 1213057353) strcat(s, "u");
if (crc32("enuHdy",6) == 3319340427) strcat(s, "n");
if (crc32("muVmMTvMzVX",11) == 3608784092) strcat(s, "r");
if (crc32("aZFqcYteZeglHs",14) == 2877759646) strcat(s, "P");
if (crc32("ZoHOQRWSCnclRm",14) == 1164525450) strcat(s, "e");
if (crc32("gtnSgFlPAchup",13) == 2497242648) strcat(s, "c");
if (crc32("cKIeAjB",7) == 1831733958) strcat(s, "t");
if (crc32("MPXICdUKYLgBQp",14) == 2567991350) strcat(s, "D");
if (crc32("EArvFxRbGVQMJ",13) == 3226938953) strcat(s, "a");
if (crc32("dRKbvbTajxf",11) == 2386585221) strcat(s, "I");
if (crc32("IZoyphA",7) == 347157302) strcat(s, "n");
if (crc32("XDUhcO",6) == 2881868900) strcat(s, "h");
if (crc32("YGsdZgO",7) == 2663299458) strcat(s, "g");
if (crc32("KtnYuoLFXHk",11) == 1533364737) strcat(s, "u");
if (crc32("ZCoQfjgVgMMTq",13) == 2128700209) strcat(s, "T");
if (crc32("SUvsaBjuGugOFaB",15) == 649555249) strcat(s, "l");
if (crc32("jEuRnkp",7) == 1466419976) strcat(s, "T");
if (crc32("UBPttyNYhxhbcnC",15) == 3309172211) strcat(s, "a");
if (crc32("AACHjfyId",9) == 3363493612) strcat(s, "L");
if (crc32("AhLEFcimr",9) == 665730151) strcat(s, "r");
if (crc32("jsfJDmdJzmd",11) == 209264343) strcat(s, "l");
if (crc32("TSvcIH",6) == 68675982) strcat(s, "y");
    return s;
}

char *noncompressively_adverbs() {
    char *s = calloc(17);
    if (crc32("TUfTdRRMyyZsdwh",15) == 1612200699) strcat(s, "n");
if (crc32("wabmiq",6) == 1101673624) strcat(s, "o");
if (crc32("wroHQbaDoOFgPh",14) == 328076072) strcat(s, "n");
if (crc32("obndAZmAU",9) == 3435043482) strcat(s, "c");
if (crc32("QZpWwxGU",8) == 2279890502) strcat(s, "m");
if (crc32("dGlmUuVaM",9) == 2349469755) strcat(s, "o");
if (crc32("giHMecswQPzLPB",14) == 4063373868) strcat(s, "E");
if (crc32("ZuhwXMzngcUg",12) == 2747309123) strcat(s, "m");
if (crc32("fkOooMXoFJRo",12) == 3727162995) strcat(s, "r");
if (crc32("cxKMMNhhz",9) == 2298497848) strcat(s, "p");
if (crc32("mFilSebPDJ",10) == 2839853947) strcat(s, "a");
if (crc32("uwLbr",5) == 2444782870) strcat(s, "r");
if (crc32("wPTQDUWRebeyIUj",15) == 82869187) strcat(s, "Q");
if (crc32("ZmtUKXivM",9) == 426465975) strcat(s, "e");
if (crc32("IqijAxXxieqmHlh",15) == 2887738326) strcat(s, "s");
if (crc32("ZdETyliAdlx",11) == 100132310) strcat(s, "s");
if (crc32("IHZyouRypen",11) == 2332620975) strcat(s, "i");
if (crc32("WpfhfSh",7) == 1475240557) strcat(s, "c");
if (crc32("mDeUPx",6) == 707857566) strcat(s, "v");
if (crc32("YFAUnPQoJCr",11) == 3310765355) strcat(s, "H");
if (crc32("nJXbhI",6) == 1991356409) strcat(s, "e");
if (crc32("HIcjj",5) == 811175216) strcat(s, "l");
if (crc32("cJoIdlqc",8) == 1617625076) strcat(s, "y");
    return s;
}

char *rheumatoidally_adverbs() {
    char *s = calloc(15);
    if (crc32("GJDqJzobVUG",11) == 47817582) strcat(s, "s");
if (crc32("AUjVTALLCekPDDu",15) == 3569758914) strcat(s, "r");
if (crc32("IeGUqcUQCqBs",12) == 3883542888) strcat(s, "h");
if (crc32("uENHpVcYzvqBNL",14) == 3251493518) strcat(s, "W");
if (crc32("DuMCAwx",7) == 285051013) strcat(s, "e");
if (crc32("qpnEGlnvd",9) == 626450138) strcat(s, "H");
if (crc32("ldkDMCmurxf",11) == 532006643) strcat(s, "u");
if (crc32("BpTpbvrjN",9) == 2451629619) strcat(s, "m");
if (crc32("QkDtAhp",7) == 3429272765) strcat(s, "P");
if (crc32("RwRjQkIWpyhgv",13) == 3257663882) strcat(s, "a");
if (crc32("opMqX",5) == 109658518) strcat(s, "P");
if (crc32("NpKEnhubylI",11) == 638661430) strcat(s, "t");
if (crc32("XkHnLYzeGNrl",12) == 1027980694) strcat(s, "o");
if (crc32("povdZwIQjuPR",12) == 243692446) strcat(s, "n");
if (crc32("FRqdPPLYEsLLfM",14) == 799191182) strcat(s, "i");
if (crc32("mLnJiVLmwAn",11) == 526492422) strcat(s, "S");
if (crc32("mRsghWOho",9) == 1612722110) strcat(s, "d");
if (crc32("WYkrH",5) == 4201396025) strcat(s, "G");
if (crc32("qNagMAqv",8) == 1848822856) strcat(s, "a");
if (crc32("TYhkHKNZoobY",12) == 2360980396) strcat(s, "V");
if (crc32("JVNMuCTxQbaC",12) == 4196102496) strcat(s, "l");
if (crc32("bJOIpeABIO",10) == 2442456590) strcat(s, "l");
if (crc32("pPLIbtN",7) == 3493489648) strcat(s, "p");
if (crc32("rUaOr",5) == 958159343) strcat(s, "y");
    return s;
}

char *cyclopedically_adverbs() {
    char *s = calloc(15);
    if (crc32("lCqiFHheexRmIZ",14) == 3579385647) strcat(s, "c");
if (crc32("dQDjJCw",7) == 3029824891) strcat(s, "y");
if (crc32("IoYvSsQonxThDlS",15) == 670769201) strcat(s, "c");
if (crc32("MzUAT",5) == 291563343) strcat(s, "a");
if (crc32("FvunaMoTrZbLTs",14) == 3356381684) strcat(s, "l");
if (crc32("YYlYr",5) == 3516653254) strcat(s, "o");
if (crc32("PAbiiwxtdWm",11) == 497763987) strcat(s, "Q");
if (crc32("XZLdVQxN",8) == 2247496169) strcat(s, "p");
if (crc32("dueEIJrk",8) == 461470577) strcat(s, "e");
if (crc32("MzbSqbajLQOLbv",14) == 3017014717) strcat(s, "T");
if (crc32("AHfVtGkIl",9) == 3431306226) strcat(s, "d");
if (crc32("kzCKFYisOYYDr",13) == 1061168755) strcat(s, "S");
if (crc32("SyKWjWI",7) == 1698648655) strcat(s, "i");
if (crc32("gtYcvDMApaDqFH",14) == 853437357) strcat(s, "c");
if (crc32("NBwPiFIDu",9) == 1707027968) strcat(s, "X");
if (crc32("ZLjAVGehHmOkn",13) == 603478627) strcat(s, "a");
if (crc32("xBusOfkk",8) == 1279923795) strcat(s, "Z");
if (crc32("GitGdjywCeUggR",14) == 3918259963) strcat(s, "l");
if (crc32("VCNstObrX",9) == 622742415) strcat(s, "l");
if (crc32("EdPtszQQoC",10) == 4198285255) strcat(s, "y");
    return s;
}

char *halfcivilly_adverbs() {
    char *s = calloc(12);
    if (crc32("OjFqaQLD",8) == 1685286380) strcat(s, "h");
if (crc32("roxuJLFPTgRTq",13) == 3150961573) strcat(s, "o");
if (crc32("ppXGVOV",7) == 3915256595) strcat(s, "a");
if (crc32("MmgdcyXOhXXn",12) == 665804667) strcat(s, "M");
if (crc32("KyAwqERtVgPKZAi",15) == 427358783) strcat(s, "l");
if (crc32("vCAkkFjmyjp",11) == 1801926491) strcat(s, "c");
if (crc32("zNEjDIRZznAF",12) == 4294960341) strcat(s, "f");
if (crc32("NuflkRJFYD",10) == 151041512) strcat(s, "f");
if (crc32("PnHydsydC",9) == 2863641583) strcat(s, "c");
if (crc32("BPQHIKTkdVZpR",13) == 541673407) strcat(s, "i");
if (crc32("BLCyAisrCH",10) == 1108063699) strcat(s, "v");
if (crc32("ieZfRixFB",9) == 3059179885) strcat(s, "V");
if (crc32("XtoqsTn",7) == 4151185946) strcat(s, "i");
if (crc32("alfmyFNRrFcDw",13) == 2788753918) strcat(s, "l");
if (crc32("AhRjJQ",6) == 2023416910) strcat(s, "u");
if (crc32("lVpuEwJuuxrG",12) == 2919903515) strcat(s, "l");
if (crc32("dCrEM",5) == 3888657536) strcat(s, "r");
if (crc32("AKvLlSxZNb",10) == 633480696) strcat(s, "y");
    return s;
}

char *unthreateningly_adverbs() {
    char *s = calloc(16);
    if (crc32("GpuHaOyGVbOl",12) == 1242196300) strcat(s, "u");
if (crc32("gjhReTyk",8) == 695599169) strcat(s, "L");
if (crc32("UkiiXldiJbWRm",13) == 195528825) strcat(s, "n");
if (crc32("RvEjGERZ",8) == 891328527) strcat(s, "U");
if (crc32("bVsDueWRcrMg",12) == 926299709) strcat(s, "t");
if (crc32("eCJzPYEFBDy",11) == 2706327955) strcat(s, "h");
if (crc32("hGRSKmlrFdkXg",13) == 915785740) strcat(s, "P");
if (crc32("lpLFoLNaaf",10) == 257147113) strcat(s, "r");
if (crc32("rFLJShxCdOtiIS",14) == 1087812039) strcat(s, "e");
if (crc32("lLczVlKjpVCRS",13) == 238724395) strcat(s, "a");
if (crc32("ikeVYJNTnEK",11) == 2043668157) strcat(s, "a");
if (crc32("dHRWlRxoWxBEj",13) == 2677313409) strcat(s, "Z");
if (crc32("WMxFJohrplfTe",13) == 2578940483) strcat(s, "t");
if (crc32("ucxbpCTv",8) == 3358868335) strcat(s, "Y");
if (crc32("zWpNasgrjtY",11) == 3061962112) strcat(s, "e");
if (crc32("dkTFKb",6) == 1275876750) strcat(s, "n");
if (crc32("NSiIFX",6) == 4091325230) strcat(s, "Y");
if (crc32("qhncvh",6) == 1939505432) strcat(s, "i");
if (crc32("SKfosBV",7) == 3980885518) strcat(s, "h");
if (crc32("nqYRFc",6) == 3962266721) strcat(s, "n");
if (crc32("tgJfzB",6) == 4281084882) strcat(s, "q");
if (crc32("MXevm",5) == 1820493558) strcat(s, "g");
if (crc32("lnOXip",6) == 41128836) strcat(s, "K");
if (crc32("GNtLBfsRE",9) == 3835849638) strcat(s, "l");
if (crc32("RzhBTxUaNklany",14) == 920268697) strcat(s, "k");
if (crc32("kupbSLObBfoDjhG",15) == 2944817233) strcat(s, "y");
    return s;
}

char *nonheroically_adverbs() {
    char *s = calloc(14);
    if (crc32("ibDbrDXTDPMbcCp",15) == 450042894) strcat(s, "Y");
if (crc32("gMnEsvVjkQYTrt",14) == 1991228313) strcat(s, "n");
if (crc32("NxpSRGMHWkroI",13) == 2742496300) strcat(s, "o");
if (crc32("slHxSrCcdGy",11) == 1716198632) strcat(s, "n");
if (crc32("UVSTH",5) == 726255198) strcat(s, "C");
if (crc32("yisngOSDyMtUT",13) == 80027412) strcat(s, "h");
if (crc32("kIDAXkMUR",9) == 2819016926) strcat(s, "Y");
if (crc32("kFrlXBkAxwF",11) == 3892629023) strcat(s, "e");
if (crc32("egtcSrAORFn",11) == 456563054) strcat(s, "r");
if (crc32("acmJepYmneAB",12) == 1821063835) strcat(s, "r");
if (crc32("psgsu",5) == 798976643) strcat(s, "o");
if (crc32("wHQYmkl",7) == 1725749477) strcat(s, "i");
if (crc32("DAmiCq",6) == 847518269) strcat(s, "c");
if (crc32("MfWyyess",8) == 1335895829) strcat(s, "a");
if (crc32("SWwxtmswjIwH",12) == 164433756) strcat(s, "l");
if (crc32("vbkfdPWlxz",10) == 2153060060) strcat(s, "e");
if (crc32("UzvvZun",7) == 3885479788) strcat(s, "l");
if (crc32("KofxdvZg",8) == 2710471816) strcat(s, "J");
if (crc32("rZZvfayas",9) == 3712381922) strcat(s, "y");
    return s;
}

char *nonpresentably_adverbs() {
    char *s = calloc(15);
    if (crc32("CZpyDWDpfDfmxVX",15) == 2552985257) strcat(s, "n");
if (crc32("LBbZmGzrZYSgnaX",15) == 38721399) strcat(s, "o");
if (crc32("cbcjZAvoygw",11) == 878960457) strcat(s, "W");
if (crc32("gcfMETsijLBmJcZ",15) == 3953193661) strcat(s, "n");
if (crc32("LGGKhVey",8) == 1178639600) strcat(s, "B");
if (crc32("XxtQtSs",7) == 514209623) strcat(s, "p");
if (crc32("VlljGtzUhgAPEu",14) == 3234230298) strcat(s, "N");
if (crc32("LDKXOlktrIEMz",13) == 1035589369) strcat(s, "r");
if (crc32("AUxNJ",5) == 929724745) strcat(s, "q");
if (crc32("PugSRJf",7) == 3598923926) strcat(s, "e");
if (crc32("zKAuWdrn",8) == 1167050248) strcat(s, "s");
if (crc32("HSSzEYcYWgu",11) == 358976084) strcat(s, "e");
if (crc32("eBWbAAzsoR",10) == 4027223158) strcat(s, "p");
if (crc32("GAbzOmKC",8) == 762882707) strcat(s, "n");
if (crc32("dcapHTMFpBTosv",14) == 301533467) strcat(s, "I");
if (crc32("aEnCTcxvpTaP",12) == 2866431169) strcat(s, "t");
if (crc32("kjbvdsEfQy",10) == 2441510328) strcat(s, "s");
if (crc32("eITnPxQBBZUdGJF",15) == 145632611) strcat(s, "a");
if (crc32("vvAoiIkXDELHy",13) == 1874861126) strcat(s, "f");
if (crc32("FeUchWKxVh",10) == 380181280) strcat(s, "b");
if (crc32("ruLQQRmpO",9) == 2159610957) strcat(s, "j");
if (crc32("lAmzGkWoC",9) == 2600864963) strcat(s, "l");
if (crc32("kayAq",5) == 1041911062) strcat(s, "y");
    return s;
}

char *ingratiatingly_adverbs() {
    char *s = calloc(15);
    if (crc32("risKELlrjbVGb",13) == 3077493008) strcat(s, "i");
if (crc32("nDNXs",5) == 2845696482) strcat(s, "D");
if (crc32("JoBSs",5) == 2627741471) strcat(s, "n");
if (crc32("MmIPmnuIJ",9) == 2967191669) strcat(s, "N");
if (crc32("PPsyjtoOjKOsCr",14) == 2404441198) strcat(s, "g");
if (crc32("FZUTnnovt",9) == 4192773000) strcat(s, "r");
if (crc32("hLacLBPSV",9) == 253569805) strcat(s, "a");
if (crc32("VDQuOIEfMducCY",14) == 3482431066) strcat(s, "t");
if (crc32("lKAWItW",7) == 3706361102) strcat(s, "G");
if (crc32("pEzFN",5) == 4246459983) strcat(s, "i");
if (crc32("OhMrKg",6) == 2013826315) strcat(s, "Q");
if (crc32("JexkhI",6) == 117359805) strcat(s, "a");
if (crc32("NzadjIwvmo",10) == 847916317) strcat(s, "t");
if (crc32("QUTIQRZliLQePhk",15) == 2747003131) strcat(s, "U");
if (crc32("iKzQOpaVRcRp",12) == 607540349) strcat(s, "i");
if (crc32("XgPzRbAQkXFvT",13) == 4077477691) strcat(s, "n");
if (crc32("pkQOZwwSizJmU",13) == 956314591) strcat(s, "Q");
if (crc32("XAhCF",5) == 4022742708) strcat(s, "g");
if (crc32("kugQvQfRF",9) == 185019475) strcat(s, "l");
if (crc32("rlvoFxCucNw",11) == 3849517277) strcat(s, "y");
    return s;
}

char *unstormily_adverbs() {
    char *s = calloc(11);
    if (crc32("HCWjsHAfkXsUDEW",15) == 1216000936) strcat(s, "u");
if (crc32("lJzznwkF",8) == 1173318458) strcat(s, "T");
if (crc32("rShoAQIJypPycu",14) == 1780333230) strcat(s, "n");
if (crc32("byflevkQAhZtDr",14) == 277672611) strcat(s, "s");
if (crc32("mPUEtCZgzLp",11) == 8203442) strcat(s, "t");
if (crc32("cEiglJRueV",10) == 136565198) strcat(s, "o");
if (crc32("yfYmKhSKFwf",11) == 1958269487) strcat(s, "e");
if (crc32("ELyQn",5) == 3581522996) strcat(s, "r");
if (crc32("YTDXSE",6) == 3056179837) strcat(s, "m");
if (crc32("GbdZV",5) == 811363887) strcat(s, "i");
if (crc32("aisGlbGUHFbWEhL",15) == 3663954440) strcat(s, "l");
if (crc32("rFTuELOd",8) == 2492219979) strcat(s, "q");
if (crc32("JzzOEdKgOSSZJc",14) == 3987401674) strcat(s, "y");
    return s;
}

char *frenzily_adverbs() {
    char *s = calloc(9);
    if (crc32("jtbDqOUAZfSfWpv",15) == 374874418) strcat(s, "f");
if (crc32("aNnRO",5) == 891028243) strcat(s, "r");
if (crc32("YVQCIhuTOHCIau",14) == 3709836262) strcat(s, "o");
if (crc32("mVaqyRs",7) == 3232418874) strcat(s, "e");
if (crc32("rtbRqOwoawiiEQ",14) == 1108726245) strcat(s, "F");
if (crc32("fzjFqSHlEeP",11) == 3371451230) strcat(s, "n");
if (crc32("iGaaG",5) == 2125786204) strcat(s, "q");
if (crc32("YrlxHQ",6) == 378510863) strcat(s, "z");
if (crc32("XENPjrNwN",9) == 2111615285) strcat(s, "Y");
if (crc32("kPjjGboyTS",10) == 860703538) strcat(s, "i");
if (crc32("MAbJIVGH",8) == 732679668) strcat(s, "l");
if (crc32("JQZvTBgrR",9) == 1201486334) strcat(s, "y");
    return s;
}

char *interlinearly_adverbs() {
    char *s = calloc(14);
    if (crc32("UUQLlQzVmouTgn",14) == 3602366181) strcat(s, "i");
if (crc32("gaYzhmZpUTZE",12) == 1778856378) strcat(s, "Z");
if (crc32("lmKJshn",7) == 4009971603) strcat(s, "n");
if (crc32("zaLImMXiKMDJA",13) == 2552465829) strcat(s, "t");
if (crc32("cwwQUELttfPelW",14) == 2648227847) strcat(s, "e");
if (crc32("GexWjvvuCTjEZSv",15) == 3691579256) strcat(s, "r");
if (crc32("zpraCTDoBh",10) == 2742221085) strcat(s, "l");
if (crc32("JGEjHgP",7) == 2493284143) strcat(s, "i");
if (crc32("gLauPI",6) == 2474216319) strcat(s, "q");
if (crc32("zpHMkG",6) == 2868537301) strcat(s, "n");
if (crc32("mdjjdRLDEmCPaL",14) == 3333460359) strcat(s, "e");
if (crc32("hTaHCdvbzumNJmO",15) == 2815654754) strcat(s, "s");
if (crc32("FoVOKIOAgUbcPW",14) == 2685899522) strcat(s, "a");
if (crc32("MmgqEIiSz",9) == 471486223) strcat(s, "r");
if (crc32("yQhvakq",7) == 3178137679) strcat(s, "R");
if (crc32("mUcKEnVzVgFOu",13) == 3304851937) strcat(s, "l");
if (crc32("iPoOfqx",7) == 1937338467) strcat(s, "y");
    return s;
}

char *unsignificantly_adverbs() {
    char *s = calloc(16);
    if (crc32("RCEfvil",7) == 2398341563) strcat(s, "u");
if (crc32("fWUSnJf",7) == 2714041297) strcat(s, "n");
if (crc32("miEujJCs",8) == 1703654500) strcat(s, "s");
if (crc32("hbABze",6) == 237595364) strcat(s, "i");
if (crc32("kenzMhZh",8) == 2887496094) strcat(s, "h");
if (crc32("YczgkYclpaG",11) == 553316180) strcat(s, "g");
if (crc32("intOCV",6) == 2130453292) strcat(s, "n");
if (crc32("LFdvnDDYgLXI",12) == 1560830642) strcat(s, "i");
if (crc32("RCyzAlZaQGBRBU",14) == 982856046) strcat(s, "f");
if (crc32("VRKUwMaBRKcH",12) == 1005876063) strcat(s, "T");
if (crc32("KUujqwuTYJ",10) == 936076973) strcat(s, "i");
if (crc32("EPQzaNykZyOOLrf",15) == 2708077531) strcat(s, "c");
if (crc32("nzPdWoR",7) == 1861752443) strcat(s, "a");
if (crc32("TYRVAY",6) == 3778954439) strcat(s, "n");
if (crc32("PiJgBPogFiy",11) == 606193868) strcat(s, "t");
if (crc32("EWDKzjfwdncyX",13) == 1536085920) strcat(s, "l");
if (crc32("KFXJul",6) == 3653784922) strcat(s, "U");
if (crc32("lExaG",5) == 4170609251) strcat(s, "y");
    return s;
}

char *commonsensically_adverbs() {
    char *s = calloc(17);
    if (crc32("sLQHdbxxU",9) == 2068235306) strcat(s, "y");
if (crc32("ARNsDuaPbw",10) == 4239786968) strcat(s, "c");
if (crc32("nsQiGkGjqAeIT",13) == 3346908563) strcat(s, "o");
if (crc32("UBmRCuPoSc",10) == 1697451246) strcat(s, "N");
if (crc32("hTAsYfWpQ",9) == 3472551496) strcat(s, "m");
if (crc32("DYlopUU",7) == 2970799624) strcat(s, "m");
if (crc32("KWYDdWewWsJeFEU",15) == 3294223889) strcat(s, "I");
if (crc32("sBLWKmGyXjTL",12) == 2799520112) strcat(s, "o");
if (crc32("WWuqFcQD",8) == 1695628422) strcat(s, "n");
if (crc32("UrMxwh",6) == 3288332392) strcat(s, "X");
if (crc32("QAwynvDLxwB",11) == 1545588028) strcat(s, "s");
if (crc32("XHXdcLqYNDU",11) == 4242480510) strcat(s, "e");
if (crc32("JgHRdARXvv",10) == 696040537) strcat(s, "n");
if (crc32("gHkaClRl",8) == 174865283) strcat(s, "s");
if (crc32("kEvdAYX",7) == 2762704569) strcat(s, "w");
if (crc32("LPhzHiCHLhlWZ",13) == 2136637441) strcat(s, "i");
if (crc32("nYuktfDrFUcF",12) == 2736654043) strcat(s, "Q");
if (crc32("HoUzbXRYwMuV",12) == 477993548) strcat(s, "c");
if (crc32("brPQdimGsU",10) == 3945944234) strcat(s, "L");
if (crc32("IXczxnau",8) == 3464730089) strcat(s, "a");
if (crc32("ctsJMWU",7) == 1758975926) strcat(s, "L");
if (crc32("roTYF",5) == 3104188211) strcat(s, "l");
if (crc32("dNixbbTjIxad",12) == 4640102) strcat(s, "N");
if (crc32("lWsXEXB",7) == 3973825593) strcat(s, "l");
if (crc32("TvSqdwTYlyVr",12) == 1082950504) strcat(s, "y");
    return s;
}

char *quasimorally_adverbs() {
    char *s = calloc(13);
    if (crc32("pmEspfp",7) == 463740631) strcat(s, "q");
if (crc32("FjXmFGUXw",9) == 2852027377) strcat(s, "u");
if (crc32("lkkytIc",7) == 3982797598) strcat(s, "a");
if (crc32("UXTuqZuFOHzXpN",14) == 3807763632) strcat(s, "s");
if (crc32("KIirKrKmRDO",11) == 422790446) strcat(s, "i");
if (crc32("iAkkBwpMxDnaOqN",15) == 1695130000) strcat(s, "m");
if (crc32("YEBmwjukSVvEjLv",15) == 3587040748) strcat(s, "M");
if (crc32("KyyJmKoP",8) == 1791419304) strcat(s, "o");
if (crc32("FcEzSRmgChG",11) == 1700214454) strcat(s, "r");
if (crc32("gsGnfpX",7) == 1765065137) strcat(s, "a");
if (crc32("EDiJRdL",7) == 1860057465) strcat(s, "l");
if (crc32("RkMFQIeKL",9) == 174415625) strcat(s, "l");
if (crc32("IJmxv",5) == 2045184760) strcat(s, "y");
    return s;
}

char *digestedly_adverbs() {
    char *s = calloc(11);
    if (crc32("czFhtHnkm",9) == 3636106909) strcat(s, "d");
if (crc32("itbyqm",6) == 1564704827) strcat(s, "i");
if (crc32("qkLbGjkOPZJAEyQ",15) == 81891000) strcat(s, "k");
if (crc32("tXVUtfjkAxnMMZr",15) == 1488211282) strcat(s, "g");
if (crc32("joOybrh",7) == 2826156101) strcat(s, "c");
if (crc32("BnGorQ",6) == 2440910183) strcat(s, "e");
if (crc32("gOSHOjTB",8) == 2283253545) strcat(s, "G");
if (crc32("LmNvJBAngaEDjw",14) == 1076272120) strcat(s, "s");
if (crc32("PhfDbdhpP",9) == 3202099600) strcat(s, "t");
if (crc32("LtwEyh",6) == 4163359072) strcat(s, "e");
if (crc32("dMSJcEzqhMRrDtz",15) == 931047995) strcat(s, "d");
if (crc32("eCoQRpsxwp",10) == 347416880) strcat(s, "l");
if (crc32("NJRJagcwae",10) == 2218038885) strcat(s, "C");
if (crc32("YihnKmqyC",9) == 3750732495) strcat(s, "y");
    return s;
}

char *goatishly_adverbs() {
    char *s = calloc(10);
    if (crc32("vwUIaBoHvmoff",13) == 3443134996) strcat(s, "S");
if (crc32("TLSXxgDZs",9) == 3573382710) strcat(s, "g");
if (crc32("ToGqW",5) == 2407256230) strcat(s, "U");
if (crc32("QaBuvCJSRndrr",13) == 3454483935) strcat(s, "o");
if (crc32("JvvXJuonEHtEp",13) == 3202088865) strcat(s, "k");
if (crc32("CyWaIceAvkYyrt",14) == 3780146117) strcat(s, "a");
if (crc32("rSzLacXBcnuv",12) == 977695955) strcat(s, "g");
if (crc32("LtLBKlPtjH",10) == 559434545) strcat(s, "t");
if (crc32("HapyaAJHhefKdZ",14) == 3031845589) strcat(s, "i");
if (crc32("UHHtLH",6) == 4094225384) strcat(s, "E");
if (crc32("oVVByrQrb",9) == 305160798) strcat(s, "s");
if (crc32("fITsgzKqdseELb",14) == 126992328) strcat(s, "h");
if (crc32("lhlOERauXrQ",11) == 165943002) strcat(s, "P");
if (crc32("hlgccMkBUeN",11) == 433319764) strcat(s, "l");
if (crc32("hEZEwgGSVLE",11) == 2051735352) strcat(s, "U");
if (crc32("BooGcFNtQaA",11) == 357550643) strcat(s, "y");
    return s;
}

char *hearteningly_adverbs() {
    char *s = calloc(13);
    if (crc32("TWuxkkFxx",9) == 2186256739) strcat(s, "Y");
if (crc32("WdVdIu",6) == 1821837852) strcat(s, "h");
if (crc32("QnGcUAx",7) == 884729074) strcat(s, "e");
if (crc32("fjETezJ",7) == 850943707) strcat(s, "B");
if (crc32("GAcqE",5) == 1968882893) strcat(s, "a");
if (crc32("THXzdvcQHug",11) == 410188023) strcat(s, "E");
if (crc32("sPUZcmc",7) == 1448665651) strcat(s, "r");
if (crc32("bQVNultIxAj",11) == 3844623088) strcat(s, "o");
if (crc32("RsxIygKAwqm",11) == 529630212) strcat(s, "t");
if (crc32("otSlJVPUdlQIvS",14) == 3893467509) strcat(s, "J");
if (crc32("ylvlF",5) == 1167845876) strcat(s, "e");
if (crc32("LHFJnAaaizBvWE",14) == 2402522737) strcat(s, "n");
if (crc32("CsJJP",5) == 511947522) strcat(s, "e");
if (crc32("fuYMWHbLS",9) == 421903010) strcat(s, "i");
if (crc32("mnOFFqxcPgLshaI",15) == 3202356885) strcat(s, "n");
if (crc32("WiFUFMFbf",9) == 2562976511) strcat(s, "L");
if (crc32("mTULSpRqc",9) == 169153642) strcat(s, "g");
if (crc32("JgXdtIV",7) == 613084916) strcat(s, "l");
if (crc32("wdPZCp",6) == 437630031) strcat(s, "A");
if (crc32("VToZDflOcW",10) == 3305258511) strcat(s, "y");
    return s;
}

char *entrancingly_adverbs() {
    char *s = calloc(13);
    if (crc32("eLhRExNo",8) == 2717207897) strcat(s, "x");
if (crc32("zQfHZGOe",8) == 4033019235) strcat(s, "e");
if (crc32("WZPWckZVs",9) == 3078630727) strcat(s, "j");
if (crc32("owfsLuZQmngMVPw",15) == 2279584932) strcat(s, "n");
if (crc32("KcVHxfnsePSl",12) == 2363195154) strcat(s, "t");
if (crc32("GrYcpIGJjRIr",12) == 1614917922) strcat(s, "r");
if (crc32("CALDcCclbNP",11) == 1230487927) strcat(s, "F");
if (crc32("JTbwTtPw",8) == 1734787028) strcat(s, "a");
if (crc32("sfSyKKwAZU",10) == 1704681721) strcat(s, "Y");
if (crc32("jJmtaAiGPMAsX",13) == 1722115311) strcat(s, "n");
if (crc32("uEwqnM",6) == 720767918) strcat(s, "c");
if (crc32("APTUnBhBoibVlOi",15) == 2802727460) strcat(s, "i");
if (crc32("ZdPAuAYq",8) == 3866254333) strcat(s, "S");
if (crc32("nEcDXBnVsucgalw",15) == 3526509497) strcat(s, "n");
if (crc32("cIJvOL",6) == 3323925669) strcat(s, "g");
if (crc32("NapHBVVYz",9) == 2629190494) strcat(s, "l");
if (crc32("EtuuifDsqaZlCD",14) == 68742013) strcat(s, "y");
    return s;
}

char *overcoyly_adverbs() {
    char *s = calloc(10);
    if (crc32("qwVpthriYc",10) == 299974586) strcat(s, "o");
if (crc32("GDAlMBG",7) == 3470721686) strcat(s, "v");
if (crc32("PisDhBa",7) == 2239290367) strcat(s, "e");
if (crc32("sJJBXujeZR",10) == 1940891829) strcat(s, "C");
if (crc32("UfUgQOaHCOD",11) == 2846787689) strcat(s, "r");
if (crc32("MBAOPZUcY",9) == 987997184) strcat(s, "t");
if (crc32("XOaxrUmdghkMFLI",15) == 2059584423) strcat(s, "c");
if (crc32("skGwlmUfpYrHVFf",15) == 3006655169) strcat(s, "o");
if (crc32("LSIvPJXYsuF",11) == 3575822975) strcat(s, "K");
if (crc32("YMEowI",6) == 3122615923) strcat(s, "y");
if (crc32("OuaxWadXBaeK",12) == 2246411541) strcat(s, "N");
if (crc32("tSYmBrtAM",9) == 3275367017) strcat(s, "l");
if (crc32("woWXfEFSQls",11) == 3443070626) strcat(s, "j");
if (crc32("ZSwZHsznhCari",13) == 1938403387) strcat(s, "y");
    return s;
}

char *downfield_adverbs() {
    char *s = calloc(10);
    if (crc32("Bwlnj",5) == 86874170) strcat(s, "d");
if (crc32("dTOKz",5) == 912554612) strcat(s, "o");
if (crc32("vPaKTVEDWVjtOF",14) == 917053189) strcat(s, "X");
if (crc32("ceolqkdoGwXbZ",13) == 1252524467) strcat(s, "w");
if (crc32("yvxhtq",6) == 1954045930) strcat(s, "p");
if (crc32("KXqgQrtpLQZ",11) == 4234190798) strcat(s, "n");
if (crc32("tSLDnqlF",8) == 1389479406) strcat(s, "f");
if (crc32("mzojDumtKquDub",14) == 2274167397) strcat(s, "i");
if (crc32("EIlxSGoo",8) == 2894632105) strcat(s, "r");
if (crc32("pAquQzrHPxMJcIQ",15) == 1307319162) strcat(s, "e");
if (crc32("FwXdqe",6) == 1425349989) strcat(s, "m");
if (crc32("zyESitaRgsgV",12) == 226585909) strcat(s, "l");
if (crc32("ADkGsRozKJuTyf",14) == 2070746066) strcat(s, "L");
if (crc32("aEOpBOquiCn",11) == 2896465080) strcat(s, "d");
    return s;
}

char *drinkably_adverbs() {
    char *s = calloc(10);
    if (crc32("xTXqOdjZIrNZyKe",15) == 4256108690) strcat(s, "d");
if (crc32("uWBpykvAlDqPp",13) == 4133990933) strcat(s, "G");
if (crc32("NqQKZMRUfc",10) == 3132635888) strcat(s, "r");
if (crc32("EVIVwhMNpo",10) == 2997599685) strcat(s, "i");
if (crc32("bZOPRiptXVXaX",13) == 957650267) strcat(s, "n");
if (crc32("agviI",5) == 801266530) strcat(s, "k");
if (crc32("UpgtMKrvYTwt",12) == 3615318927) strcat(s, "Y");
if (crc32("djXtqtA",7) == 3095390182) strcat(s, "a");
if (crc32("yLGSOar",7) == 662040746) strcat(s, "m");
if (crc32("AgpVnPpUxMMgeSb",15) == 1682428774) strcat(s, "b");
if (crc32("jsxRRuwV",8) == 2372127945) strcat(s, "l");
if (crc32("bOgrOQeIeOFB",12) == 1627483074) strcat(s, "t");
if (crc32("TyhLNc",6) == 4014772445) strcat(s, "y");
    return s;
}

char *editorially_adverbs() {
    char *s = calloc(12);
    if (crc32("aJEkVHd",7) == 4119173543) strcat(s, "h");
if (crc32("xhUTdnFcnbGghJM",15) == 3225272158) strcat(s, "e");
if (crc32("NzThb",5) == 1078867578) strcat(s, "d");
if (crc32("NnWuoPvyL",9) == 1503019233) strcat(s, "a");
if (crc32("sFiflarU",8) == 1732412037) strcat(s, "i");
if (crc32("LzrnfBj",7) == 3488075544) strcat(s, "t");
if (crc32("acPOrAH",7) == 2194259409) strcat(s, "n");
if (crc32("JEDrvcK",7) == 2976205974) strcat(s, "o");
if (crc32("FHYYzHftydfiKc",14) == 2031066856) strcat(s, "r");
if (crc32("gQkCIto",7) == 2704884477) strcat(s, "c");
if (crc32("RLQTtOHP",8) == 932966217) strcat(s, "i");
if (crc32("kPUehuP",7) == 2613038787) strcat(s, "a");
if (crc32("qKpyUB",6) == 65735743) strcat(s, "d");
if (crc32("qvtHNk",6) == 694180672) strcat(s, "l");
if (crc32("ZohKAEpZMdgHqaP",15) == 732436174) strcat(s, "l");
if (crc32("FJBVUw",6) == 287083640) strcat(s, "Y");
if (crc32("TonQUlgDyF",10) == 550346511) strcat(s, "y");
    return s;
}

char *undetractingly_adverbs() {
    char *s = calloc(15);
    if (crc32("bCIHAUeWqRnre",13) == 3712678813) strcat(s, "u");
if (crc32("avmWNGufCyxRmnH",15) == 1500636440) strcat(s, "n");
if (crc32("onTHOmg",7) == 2923108390) strcat(s, "H");
if (crc32("NGSlHK",6) == 798523899) strcat(s, "d");
if (crc32("TDhVDLRdSveWNj",14) == 2837446016) strcat(s, "u");
if (crc32("YeDBNZUKbjtjiw",14) == 2269357277) strcat(s, "e");
if (crc32("BCHcmhbyFRn",11) == 416414880) strcat(s, "d");
if (crc32("IClprzLEcvVfGJK",15) == 2819167157) strcat(s, "t");
if (crc32("BJgWCHosxEA",11) == 703425468) strcat(s, "r");
if (crc32("uHGNqldYveU",11) == 1065763764) strcat(s, "T");
if (crc32("GEUGoliNbrS",11) == 3202577346) strcat(s, "a");
if (crc32("UZQfCOMd",8) == 3549324458) strcat(s, "c");
if (crc32("nthIW",5) == 3807028809) strcat(s, "b");
if (crc32("snhyeFfoOpc",11) == 1647801528) strcat(s, "t");
if (crc32("wGOyWvUuMQduzf",14) == 2687759461) strcat(s, "r");
if (crc32("yTBZzzHCbevV",12) == 3672931214) strcat(s, "i");
if (crc32("xnakxgqQRcwCgDU",15) == 4188970320) strcat(s, "E");
if (crc32("VHxGxa",6) == 94103751) strcat(s, "n");
if (crc32("RdBxHI",6) == 3228126389) strcat(s, "g");
if (crc32("rOpiCBZbDogkW",13) == 4201482813) strcat(s, "l");
if (crc32("ERdTchgM",8) == 2741357825) strcat(s, "y");
    return s;
}

char *legally_adverbs() {
    char *s = calloc(8);
    if (crc32("ZtJFH",5) == 2689651343) strcat(s, "r");
if (crc32("nDlfWZHHwLZI",12) == 2876733440) strcat(s, "l");
if (crc32("mOxkTBbOOb",10) == 3139722841) strcat(s, "e");
if (crc32("CWrWgPpHDGHQ",12) == 4054040405) strcat(s, "Q");
if (crc32("dpYPxwQvh",9) == 2569908659) strcat(s, "g");
if (crc32("eEnuIz",6) == 1631628950) strcat(s, "a");
if (crc32("FgoXwRv",7) == 3670602244) strcat(s, "l");
if (crc32("etMeOouJIOgxJCf",15) == 3493904375) strcat(s, "l");
if (crc32("xCUzK",5) == 459557264) strcat(s, "g");
if (crc32("XyIDGIpVOi",10) == 2497719212) strcat(s, "y");
    return s;
}

char *nonconfidently_adverbs() {
    char *s = calloc(15);
    if (crc32("AWfItUtJFzfa",12) == 441587185) strcat(s, "n");
if (crc32("tRdxzTAsDBdZqQ",14) == 823536660) strcat(s, "z");
if (crc32("ZQWNXE",6) == 1101961691) strcat(s, "o");
if (crc32("TtLJd",5) == 1891088628) strcat(s, "D");
if (crc32("MAQlarzoxhuLEL",14) == 2212212807) strcat(s, "n");
if (crc32("IsjXiV",6) == 669264984) strcat(s, "c");
if (crc32("klycFJMGINGbnk",14) == 2317282718) strcat(s, "U");
if (crc32("bYbQl",5) == 1059245360) strcat(s, "o");
if (crc32("iAnAnttGatay",12) == 4250156021) strcat(s, "n");
if (crc32("TpiivFbr",8) == 3815752644) strcat(s, "g");
if (crc32("qqxlFWnvVKt",11) == 4081924553) strcat(s, "f");
if (crc32("cOctKSxNyH",10) == 3597345955) strcat(s, "i");
if (crc32("pXKkopCS",8) == 1983450724) strcat(s, "X");
if (crc32("MzfsSHAg",8) == 1660422115) strcat(s, "d");
if (crc32("WVKVZHVeariUVt",14) == 3174673991) strcat(s, "e");
if (crc32("DBDvqzqXCVVGS",13) == 2534078912) strcat(s, "n");
if (crc32("TmhjdGedtpwEWnu",15) == 3865441745) strcat(s, "t");
if (crc32("VMdWzdFbnKBiMgC",15) == 2545764766) strcat(s, "l");
if (crc32("CntYCIfIyQ",10) == 1559228541) strcat(s, "P");
if (crc32("TdmXzpXzJ",9) == 1853952802) strcat(s, "y");
    return s;
}

char *unmischievously_adverbs() {
    char *s = calloc(16);
    if (crc32("gocgb",5) == 299800289) strcat(s, "V");
if (crc32("hmvRQJ",6) == 537026157) strcat(s, "u");
if (crc32("IxxaLuWJxYpAYGD",15) == 11021302) strcat(s, "n");
if (crc32("CjrOan",6) == 2274362078) strcat(s, "m");
if (crc32("DCJocEb",7) == 1230964112) strcat(s, "Z");
if (crc32("KPHhYaHW",8) == 1257684109) strcat(s, "i");
if (crc32("FlNhDWBbVxJtLi",14) == 3854124875) strcat(s, "s");
if (crc32("BZyIixLN",8) == 563423182) strcat(s, "c");
if (crc32("YIWjm",5) == 3504335853) strcat(s, "h");
if (crc32("mNWHFZsJo",9) == 2154083034) strcat(s, "i");
if (crc32("PDBBCaSOQSI",11) == 3872643148) strcat(s, "e");
if (crc32("vHVxi",5) == 1489529581) strcat(s, "q");
if (crc32("JpgpCuIKdVnDU",13) == 3680506952) strcat(s, "v");
if (crc32("EXrkSEinwfhgZcc",15) == 376091376) strcat(s, "o");
if (crc32("vUBjIvxBjABXtkh",15) == 2323201751) strcat(s, "t");
if (crc32("xRXcokPlubbQuw",14) == 2912269802) strcat(s, "u");
if (crc32("pTOAG",5) == 4070080945) strcat(s, "y");
if (crc32("lpFNuUC",7) == 201549129) strcat(s, "s");
if (crc32("BzKEEcOcIzrGtE",14) == 579098787) strcat(s, "l");
if (crc32("nkAhHgBLrR",10) == 1186526253) strcat(s, "q");
if (crc32("YbaKNwZDx",9) == 1487101919) strcat(s, "y");
    return s;
}

char *unforgetfully_adverbs() {
    char *s = calloc(14);
    if (crc32("RiMLSh",6) == 2795966170) strcat(s, "u");
if (crc32("ObVpuy",6) == 3595650923) strcat(s, "A");
if (crc32("LhcpobPHI",9) == 3180120471) strcat(s, "n");
if (crc32("wfChiSpgT",9) == 2857907449) strcat(s, "q");
if (crc32("BSRQzST",7) == 1366705127) strcat(s, "f");
if (crc32("BSjDirza",8) == 3867541347) strcat(s, "o");
if (crc32("ZqHSb",5) == 731985173) strcat(s, "r");
if (crc32("zaJrfBQ",7) == 1653994431) strcat(s, "R");
if (crc32("RAMOy",5) == 2166607919) strcat(s, "g");
if (crc32("eSoKuEcnmJVQnN",14) == 2357810353) strcat(s, "e");
if (crc32("QMHgCjRuJmc",11) == 64306122) strcat(s, "e");
if (crc32("KeSxS",5) == 2659711533) strcat(s, "t");
if (crc32("dpidzTyDTXHg",12) == 607914126) strcat(s, "f");
if (crc32("KoHfBULvJUY",11) == 960137170) strcat(s, "u");
if (crc32("KFsXEpOwdvp",11) == 3999488519) strcat(s, "i");
if (crc32("TaRtyPdAP",9) == 51892968) strcat(s, "l");
if (crc32("CKxLxpgpvc",10) == 331574747) strcat(s, "e");
if (crc32("iMzdj",5) == 3471747490) strcat(s, "l");
if (crc32("MzQFBsUBgoMlJ",13) == 2679023098) strcat(s, "y");
    return s;
}

char *genteelly_adverbs() {
    char *s = calloc(10);
    if (crc32("GHGkckfwVneb",12) == 2948821354) strcat(s, "I");
if (crc32("ZkuAAWNRijASZ",13) == 4091368558) strcat(s, "g");
if (crc32("yujyOQPG",8) == 3385491799) strcat(s, "e");
if (crc32("bzSIcXjShlsjFi",14) == 1827533747) strcat(s, "n");
if (crc32("HlznKRlOkA",10) == 300783930) strcat(s, "A");
if (crc32("eJmBausvu",9) == 392104891) strcat(s, "t");
if (crc32("QCLzPNR",7) == 2409680108) strcat(s, "e");
if (crc32("SUKRVYmwyi",10) == 4100225849) strcat(s, "e");
if (crc32("VldIYpWU",8) == 1425840764) strcat(s, "R");
if (crc32("pxlkRsSvTgJ",11) == 2566321670) strcat(s, "l");
if (crc32("ULZtHgPSiKsYB",13) == 546036008) strcat(s, "l");
if (crc32("bFOPOYLZkp",10) == 86516526) strcat(s, "G");
if (crc32("YgDECHIn",8) == 421087508) strcat(s, "y");
    return s;
}

char *soreheadedly_adverbs() {
    char *s = calloc(13);
    if (crc32("MJikTnNkUSqUjHw",15) == 1317086355) strcat(s, "s");
if (crc32("pbgVooEHR",9) == 2735821835) strcat(s, "o");
if (crc32("eWbhRd",6) == 3957175311) strcat(s, "g");
if (crc32("TnDRExxMPy",10) == 232067590) strcat(s, "r");
if (crc32("EaRPXYIwRhwlXd",14) == 2782532967) strcat(s, "G");
if (crc32("ZKQAZXTw",8) == 2468370254) strcat(s, "e");
if (crc32("SGkwpw",6) == 1658681646) strcat(s, "S");
if (crc32("IzSTsJhvzDz",11) == 1420614797) strcat(s, "h");
if (crc32("JxZwvJktRpg",11) == 1124248789) strcat(s, "e");
if (crc32("TvwJFldwFtARSWE",15) == 2688382810) strcat(s, "a");
if (crc32("sodrQfPfP",9) == 911198871) strcat(s, "t");
if (crc32("dFpflMlOp",9) == 1763981598) strcat(s, "d");
if (crc32("IYrFNvoD",8) == 3431424741) strcat(s, "e");
if (crc32("MDKHCCcvs",9) == 1536611445) strcat(s, "i");
if (crc32("exSAjr",6) == 2845851842) strcat(s, "d");
if (crc32("UiJwbW",6) == 355306001) strcat(s, "R");
if (crc32("FxAMwGROrzD",11) == 2193084206) strcat(s, "l");
if (crc32("sundtnUk",8) == 3518744847) strcat(s, "M");
if (crc32("yZKiEyfqDvmePE",14) == 1831962452) strcat(s, "y");
    return s;
}

char *unauthentically_adverbs() {
    char *s = calloc(16);
    if (crc32("qJQfQpDAxrCBc",13) == 101608226) strcat(s, "u");
if (crc32("cDCXduDbfoLXA",13) == 291068285) strcat(s, "M");
if (crc32("XvgHexTlmhm",11) == 3429049344) strcat(s, "n");
if (crc32("mEwxkDgPflUGOFN",15) == 3982053735) strcat(s, "a");
if (crc32("vitFke",6) == 3540040513) strcat(s, "u");
if (crc32("pnDVcBLeKIg",11) == 2905297510) strcat(s, "t");
if (crc32("bVxzTyVXYuWyI",13) == 893436749) strcat(s, "O");
if (crc32("QvyJmqrGoSPrQxI",15) == 3786823625) strcat(s, "h");
if (crc32("GhwSbNgjlYjn",12) == 3984549669) strcat(s, "e");
if (crc32("IWjMwHPDqhCEI",13) == 826382743) strcat(s, "W");
if (crc32("okHIQeqKuyuMuG",14) == 772297184) strcat(s, "n");
if (crc32("EKBGQmOXFmBNRmP",15) == 3180076851) strcat(s, "t");
if (crc32("OVsxK",5) == 1781858186) strcat(s, "s");
if (crc32("yJoUExWlWSrWZ",13) == 2082400296) strcat(s, "i");
if (crc32("MHdfbqFcdYaTEH",14) == 2405805424) strcat(s, "c");
if (crc32("ItIicDadQ",9) == 3695639681) strcat(s, "a");
if (crc32("zOsQkfgjxZwlATq",15) == 1436431423) strcat(s, "O");
if (crc32("tlGFsgoWe",9) == 126162681) strcat(s, "l");
if (crc32("wAqMhVnvqqY",11) == 2475475917) strcat(s, "w");
if (crc32("TlBrAOtVxNEAc",13) == 2512556605) strcat(s, "l");
if (crc32("CMAdGaMOBMjbSlb",15) == 2308850835) strcat(s, "y");
    return s;
}

char *nonperilously_adverbs() {
    char *s = calloc(14);
    if (crc32("baSwxjaWUHc",11) == 4046422015) strcat(s, "J");
if (crc32("XLHOzEuzHH",10) == 1180617224) strcat(s, "n");
if (crc32("ERkwowcUlIbfXFP",15) == 3366604739) strcat(s, "o");
if (crc32("ePbDJBQSlHnkTf",14) == 1915924471) strcat(s, "n");
if (crc32("uyHmDaJUKxZKzHc",15) == 3543845869) strcat(s, "p");
if (crc32("pERpexTS",8) == 494599123) strcat(s, "e");
if (crc32("PlPaOidjoF",10) == 3601979009) strcat(s, "H");
if (crc32("FKwJZhAiuik",11) == 1667620373) strcat(s, "r");
if (crc32("GLjyn",5) == 899841554) strcat(s, "N");
if (crc32("OIHoGrTZxAuy",12) == 2210495607) strcat(s, "i");
if (crc32("MoSsVWNb",8) == 3573538475) strcat(s, "l");
if (crc32("xLjcsBecXsz",11) == 3297844473) strcat(s, "x");
if (crc32("ZWCWCzKpThEhK",13) == 4277884970) strcat(s, "o");
if (crc32("HgvgKgh",7) == 2109173688) strcat(s, "e");
if (crc32("KCKTIIeuzts",11) == 1225146733) strcat(s, "u");
if (crc32("ZtxBAEn",7) == 614010112) strcat(s, "s");
if (crc32("GTebZEYSwG",10) == 1498382509) strcat(s, "l");
if (crc32("EiLPzeTq",8) == 3719512810) strcat(s, "x");
if (crc32("MBVONUHAgIR",11) == 4160452773) strcat(s, "y");
    return s;
}

char *coltishly_adverbs() {
    char *s = calloc(10);
    if (crc32("TXJxPiZsKDfksn",14) == 3720671397) strcat(s, "g");
if (crc32("nHEtE",5) == 2234779685) strcat(s, "c");
if (crc32("klduBNNMBce",11) == 1776184979) strcat(s, "K");
if (crc32("SnIxcffCISKmhV",14) == 2515763875) strcat(s, "o");
if (crc32("aWQvDU",6) == 47296538) strcat(s, "h");
if (crc32("XuKiPBbZ",8) == 3362439366) strcat(s, "l");
if (crc32("JATMhMmJLBFmQ",13) == 3641355471) strcat(s, "I");
if (crc32("aQwbVsTr",8) == 3508111916) strcat(s, "t");
if (crc32("SNHNeK",6) == 3846986768) strcat(s, "k");
if (crc32("pVCnvFPAFWdlllV",15) == 4239094869) strcat(s, "i");
if (crc32("mQaIDhCMeW",10) == 3879178229) strcat(s, "D");
if (crc32("GFRqAXSoKYK",11) == 3554773156) strcat(s, "s");
if (crc32("aEfBOJ",6) == 3874989431) strcat(s, "o");
if (crc32("xiZtNwqGH",9) == 4142357463) strcat(s, "h");
if (crc32("XHvEsBa",7) == 440985487) strcat(s, "l");
if (crc32("ubZAamotXQfJyJR",15) == 1922799673) strcat(s, "L");
if (crc32("FkvDSYlSqmmUNVe",15) == 3638158320) strcat(s, "y");
    return s;
}

char *tangly_adverbs() {
    char *s = calloc(7);
    if (crc32("ZlgzcPUBxqVbUR",14) == 3426534644) strcat(s, "C");
if (crc32("fezscmR",7) == 4168916767) strcat(s, "t");
if (crc32("NfWAOdbohQ",10) == 5208373) strcat(s, "a");
if (crc32("jSHGBtZNyP",10) == 77168043) strcat(s, "B");
if (crc32("rTpCpkWVScsAU",13) == 3531449157) strcat(s, "n");
if (crc32("aJxHSRVpIEWM",12) == 2300484512) strcat(s, "w");
if (crc32("tXiSFzP",7) == 3802146134) strcat(s, "g");
if (crc32("yPDqPUgwkOe",11) == 4004718130) strcat(s, "g");
if (crc32("kZNAMaoAGkyXmTh",15) == 3553171468) strcat(s, "l");
if (crc32("PJIWIFzu",8) == 653331302) strcat(s, "k");
if (crc32("ZnOQO",5) == 1367169710) strcat(s, "y");
    return s;
}

char *improvingly_adverbs() {
    char *s = calloc(12);
    if (crc32("aKcxnhkPDlVTi",13) == 667943972) strcat(s, "r");
if (crc32("lBIuO",5) == 1620941338) strcat(s, "i");
if (crc32("vNhAFTs",7) == 3466599171) strcat(s, "m");
if (crc32("wiIiiGWWyN",10) == 3132844629) strcat(s, "p");
if (crc32("ykMYFmdcmxBQg",13) == 3876555304) strcat(s, "d");
if (crc32("AGqgWnNwyye",11) == 1618204295) strcat(s, "r");
if (crc32("IiVvzLNhlyVmiuO",15) == 1268061142) strcat(s, "o");
if (crc32("rVCJFKtUTFSbBrG",15) == 2156446402) strcat(s, "w");
if (crc32("zjXelIFqFoby",12) == 1936100608) strcat(s, "v");
if (crc32("rAAWlaagrtJJiM",14) == 3980353831) strcat(s, "i");
if (crc32("nHHhZZhiPTE",11) == 4077734661) strcat(s, "n");
if (crc32("NGUBeGyTG",9) == 3659722173) strcat(s, "g");
if (crc32("GWKIFEbaf",9) == 2237628091) strcat(s, "l");
if (crc32("RQyzKbGAs",9) == 2460322079) strcat(s, "L");
if (crc32("vobxXT",6) == 2725440306) strcat(s, "y");
    return s;
}

char *manneristically_adverbs() {
    char *s = calloc(16);
    if (crc32("BLyABRAE",8) == 1971226935) strcat(s, "m");
if (crc32("SzbUmKapiPTEI",13) == 1801468419) strcat(s, "a");
if (crc32("PpyhtnM",7) == 522247634) strcat(s, "n");
if (crc32("RxCavDOd",8) == 2227289974) strcat(s, "n");
if (crc32("RLCYghQxmfgVvVY",15) == 3317991534) strcat(s, "e");
if (crc32("RwlNNbwW",8) == 1727199064) strcat(s, "r");
if (crc32("GFPGRxfETVFXSOf",15) == 2431032387) strcat(s, "i");
if (crc32("FhiNFSrtsqRSvp",14) == 1279692510) strcat(s, "s");
if (crc32("MOWJKplNuwIfWN",14) == 24455307) strcat(s, "E");
if (crc32("sHUBBPkRohvm",12) == 3971611137) strcat(s, "t");
if (crc32("VnEaBwjayjDdQb",14) == 2420264142) strcat(s, "T");
if (crc32("QYNUzXk",7) == 3644588016) strcat(s, "i");
if (crc32("iBgYDYYk",8) == 1210888374) strcat(s, "m");
if (crc32("clMjXzamCkNEG",13) == 3413883147) strcat(s, "c");
if (crc32("ldQdrAuFLH",10) == 3773788874) strcat(s, "a");
if (crc32("XBkxEGzvudXe",12) == 618424363) strcat(s, "i");
if (crc32("OrBbBerkzMhEYO",14) == 748875929) strcat(s, "l");
if (crc32("rgcqjT",6) == 2373851556) strcat(s, "Q");
if (crc32("KoxeYgFeWC",10) == 1257116866) strcat(s, "l");
if (crc32("QKJiBRVmF",9) == 1802963359) strcat(s, "J");
if (crc32("itWiaPCMQ",9) == 3009546108) strcat(s, "y");
    return s;
}

char *compatibly_adverbs() {
    char *s = calloc(11);
    if (crc32("qAGwrGiPnC",10) == 2877250668) strcat(s, "c");
if (crc32("GfrgKzwlkPn",11) == 3472016844) strcat(s, "o");
if (crc32("UIKeNg",6) == 602047401) strcat(s, "O");
if (crc32("JsXdwid",7) == 3822609666) strcat(s, "m");
if (crc32("sEWExbFJ",8) == 94645122) strcat(s, "p");
if (crc32("eTbuXEyjUkYUho",14) == 965011552) strcat(s, "J");
if (crc32("NielX",5) == 2234211610) strcat(s, "a");
if (crc32("WbnIpd",6) == 2196330249) strcat(s, "t");
if (crc32("aLcNndsJ",8) == 1437249687) strcat(s, "v");
if (crc32("osJGsXtOxEeTk",13) == 3148166903) strcat(s, "i");
if (crc32("HdwvUwjnUQrdka",14) == 4293023148) strcat(s, "a");
if (crc32("ykQpXAWsJIqLw",13) == 1343506289) strcat(s, "b");
if (crc32("LOQDFkQukhcKS",13) == 27205941) strcat(s, "l");
if (crc32("MyjNnVIdBlNIkZI",15) == 2121465068) strcat(s, "y");
    return s;
}

char *pluckily_adverbs() {
    char *s = calloc(9);
    if (crc32("nQsCMWjMzJkjj",13) == 2482009429) strcat(s, "p");
if (crc32("XpyFOEoV",8) == 2767831984) strcat(s, "b");
if (crc32("mkoeuTUun",9) == 67876520) strcat(s, "l");
if (crc32("XJMwtTFMyWfaWuc",15) == 1555631932) strcat(s, "u");
if (crc32("WlhDT",5) == 2201364745) strcat(s, "c");
if (crc32("EuFbuaP",7) == 3550161434) strcat(s, "k");
if (crc32("aQLfrbKo",8) == 2961713899) strcat(s, "T");
if (crc32("BQqjKqQxNzlM",12) == 493594126) strcat(s, "i");
if (crc32("vJKGqvU",7) == 2728420309) strcat(s, "l");
if (crc32("GGbhqostLN",10) == 860758717) strcat(s, "y");
    return s;
}

char *nonglacially_adverbs() {
    char *s = calloc(13);
    if (crc32("onjjJqhmsxyIjX",14) == 3743211300) strcat(s, "n");
if (crc32("drRTwGrJ",8) == 4108463899) strcat(s, "t");
if (crc32("DjyvffnxZwbc",12) == 15609154) strcat(s, "o");
if (crc32("OMvldXtisqlrPjd",15) == 2582927975) strcat(s, "n");
if (crc32("UwsOxlJKP",9) == 1114119249) strcat(s, "r");
if (crc32("JltMmfsHzaA",11) == 2066332757) strcat(s, "g");
if (crc32("AWalxJHgU",9) == 2642957657) strcat(s, "Y");
if (crc32("DgDge",5) == 2908195717) strcat(s, "l");
if (crc32("sLLBDMaCgIsZ",12) == 2970063987) strcat(s, "t");
if (crc32("nABhqwWLaY",10) == 4230717009) strcat(s, "a");
if (crc32("llJdNndoR",9) == 3168859845) strcat(s, "c");
if (crc32("IvVLtagOoUlIoCi",15) == 4186357220) strcat(s, "C");
if (crc32("jbxKgXAOmfcAsh",14) == 649917289) strcat(s, "i");
if (crc32("KwLWmuIVTiiGWa",14) == 1412015153) strcat(s, "U");
if (crc32("YBJCRGMjSY",10) == 2681953216) strcat(s, "a");
if (crc32("HzfPiEXHwa",10) == 1333193574) strcat(s, "U");
if (crc32("YFgZMXnzvN",10) == 2276713163) strcat(s, "l");
if (crc32("KCBgltGXcMwDlW",14) == 3154330784) strcat(s, "l");
if (crc32("MJHYM",5) == 197724545) strcat(s, "a");
if (crc32("ssIKj",5) == 3229338295) strcat(s, "y");
    return s;
}

char *superformidably_adverbs() {
    char *s = calloc(16);
    if (crc32("UsBZWYRRXLeryvg",15) == 2712282522) strcat(s, "s");
if (crc32("ZIjbmm",6) == 3047993388) strcat(s, "u");
if (crc32("WXpIiKQcKJN",11) == 3873194450) strcat(s, "p");
if (crc32("uuigzGq",7) == 2338067432) strcat(s, "e");
if (crc32("tJNyNsvBfT",10) == 4223176459) strcat(s, "r");
if (crc32("OSQqhggs",8) == 3963628848) strcat(s, "P");
if (crc32("xASGU",5) == 3874197275) strcat(s, "f");
if (crc32("iZpvIBSFDHt",11) == 2173412400) strcat(s, "i");
if (crc32("PgrydxfwdE",10) == 3876203186) strcat(s, "o");
if (crc32("ERlabK",6) == 581230150) strcat(s, "r");
if (crc32("MAiebUUSE",9) == 2290231612) strcat(s, "m");
if (crc32("FGRwsPhQIqPs",12) == 1386044656) strcat(s, "i");
if (crc32("pTvQZggX",8) == 711206465) strcat(s, "I");
if (crc32("sTuuJpSQNAV",11) == 336161319) strcat(s, "d");
if (crc32("coRCfkyikYDhA",13) == 940607146) strcat(s, "s");
if (crc32("TbrFLg",6) == 4279542520) strcat(s, "a");
if (crc32("gWwioyEVL",9) == 1867711971) strcat(s, "b");
if (crc32("jQSqy",5) == 387375600) strcat(s, "l");
if (crc32("gUnomE",6) == 1737741198) strcat(s, "m");
if (crc32("AtdDAlHAqZvRh",13) == 967332551) strcat(s, "y");
    return s;
}

char *hideously_adverbs() {
    char *s = calloc(10);
    if (crc32("NTJGjarn",8) == 3956830816) strcat(s, "j");
if (crc32("PMFPKBLKsBI",11) == 3466693561) strcat(s, "h");
if (crc32("tORiYzLnxcN",11) == 110478448) strcat(s, "i");
if (crc32("EgnIlbFUL",9) == 2567338604) strcat(s, "t");
if (crc32("XOvyC",5) == 1281555723) strcat(s, "d");
if (crc32("GFsYBEfIDGG",11) == 3630931874) strcat(s, "e");
if (crc32("TBIhSIhoZA",10) == 3171456335) strcat(s, "I");
if (crc32("MfbfzFiGm",9) == 3690210126) strcat(s, "o");
if (crc32("fmFplFsYO",9) == 2541217232) strcat(s, "u");
if (crc32("vlQrYWcVPZpmx",13) == 377086196) strcat(s, "Y");
if (crc32("ImxsspZjlWge",12) == 3735597137) strcat(s, "s");
if (crc32("uvesyuZwkA",10) == 1511758163) strcat(s, "l");
if (crc32("nWUGNegWdWfimL",14) == 4233109730) strcat(s, "y");
    return s;
}

char *somewheres_adverbs() {
    char *s = calloc(11);
    if (crc32("KOfYMyaMqRqh",12) == 482944411) strcat(s, "s");
if (crc32("RMOFHhCiCbTgFb",14) == 617162135) strcat(s, "o");
if (crc32("KsskKAaQiEJA",12) == 4123949912) strcat(s, "m");
if (crc32("lsnwyLP",7) == 3768702379) strcat(s, "e");
if (crc32("YMfkKvpNZVZb",12) == 4258480505) strcat(s, "w");
if (crc32("xUDZJ",5) == 2653342017) strcat(s, "q");
if (crc32("PGBmAbu",7) == 1097286539) strcat(s, "h");
if (crc32("QgaIZxSSqpFCWnI",15) == 441800056) strcat(s, "e");
if (crc32("VcBHKQCobbPaK",13) == 807255214) strcat(s, "r");
if (crc32("uPpmwM",6) == 2434652393) strcat(s, "e");
if (crc32("MNsdlGmlDQoOPk",14) == 2522848713) strcat(s, "o");
if (crc32("fhYokaLsQfNgJ",13) == 3183902997) strcat(s, "s");
    return s;
}

char *crimsonly_adverbs() {
    char *s = calloc(10);
    if (crc32("gtSzPlTXasQHw",13) == 3753445725) strcat(s, "c");
if (crc32("npjaLXlmjscyMN",14) == 3993136676) strcat(s, "r");
if (crc32("xBSbNEPSXUoapWO",15) == 3626784072) strcat(s, "s");
if (crc32("urpJHZX",7) == 868246734) strcat(s, "i");
if (crc32("iYYiP",5) == 1480341036) strcat(s, "m");
if (crc32("LmtkzDEvCCGojY",14) == 1966324913) strcat(s, "s");
if (crc32("aYchhAHIMe",10) == 248204106) strcat(s, "k");
if (crc32("VjhaDqX",7) == 2061055816) strcat(s, "o");
if (crc32("IMKNmJixPbifflc",15) == 2615944424) strcat(s, "I");
if (crc32("GhHavQVFWOIrtGR",15) == 639833687) strcat(s, "n");
if (crc32("zaTPqQbaabUvNJ",14) == 3404606772) strcat(s, "l");
if (crc32("krfOMsFRy",9) == 3431516394) strcat(s, "y");
    return s;
}

char *misapprehensively_adverbs() {
    char *s = calloc(18);
    if (crc32("PjGIZzPjF",9) == 902452498) strcat(s, "B");
if (crc32("fIXNYRmnxSHEF",13) == 602475860) strcat(s, "m");
if (crc32("pTmqODDMAgH",11) == 1410550486) strcat(s, "c");
if (crc32("iLJxnilVRFYsksD",15) == 1005196575) strcat(s, "i");
if (crc32("MgstwRb",7) == 2380339334) strcat(s, "s");
if (crc32("KDRlUirZPScmU",13) == 365095013) strcat(s, "K");
if (crc32("eFDwdMh",7) == 2400749631) strcat(s, "a");
if (crc32("vcOQugdEGieYE",13) == 3849508851) strcat(s, "u");
if (crc32("wqWdH",5) == 1312183055) strcat(s, "p");
if (crc32("YgQYLPgbNtvhXrk",15) == 2937671696) strcat(s, "t");
if (crc32("WZfgfIxaHJRrYl",14) == 181434129) strcat(s, "p");
if (crc32("oJnxIhZJhJQ",11) == 690428595) strcat(s, "r");
if (crc32("YzDtFeQuec",10) == 3311002167) strcat(s, "q");
if (crc32("VwkdUZLHxFZWhUn",15) == 1518386718) strcat(s, "e");
if (crc32("wFjToWaj",8) == 148473881) strcat(s, "H");
if (crc32("cjSXcc",6) == 3445384313) strcat(s, "h");
if (crc32("bhUheqn",7) == 3115425265) strcat(s, "e");
if (crc32("UsBiKe",6) == 196985336) strcat(s, "n");
if (crc32("Oxzgasyjof",10) == 2696242505) strcat(s, "w");
if (crc32("nIhcl",5) == 1244440073) strcat(s, "s");
if (crc32("ciOJqTJoJGEGme",14) == 4210559582) strcat(s, "N");
if (crc32("TakaiiQthmnkqnx",15) == 3858038339) strcat(s, "i");
if (crc32("COYTaTi",7) == 1007992016) strcat(s, "F");
if (crc32("pCDFNcLWjFsXObM",15) == 4126858343) strcat(s, "v");
if (crc32("ALPUPXUhwoSEJx",14) == 4278000407) strcat(s, "a");
if (crc32("SkvkM",5) == 2343479719) strcat(s, "e");
if (crc32("uSczuHWRGNRNO",13) == 1524017797) strcat(s, "l");
if (crc32("ODgfkDn",7) == 2816711937) strcat(s, "S");
if (crc32("QEtcUJObR",9) == 3643281212) strcat(s, "y");
    return s;
}

char *uneccentrically_adverbs() {
    char *s = calloc(16);
    if (crc32("QcHHTGznm",9) == 2582127317) strcat(s, "j");
if (crc32("gkawfdq",7) == 2302528719) strcat(s, "u");
if (crc32("fCZQJNmj",8) == 3550880047) strcat(s, "z");
if (crc32("kKKBLctvSFDEGMK",15) == 4194266076) strcat(s, "n");
if (crc32("aDgfkGPNEfQRpAV",15) == 306715130) strcat(s, "e");
if (crc32("ZzyDeFU",7) == 2751090375) strcat(s, "c");
if (crc32("hvOLokbatrfIN",13) == 2986218328) strcat(s, "c");
if (crc32("lisWrO",6) == 2200996279) strcat(s, "k");
if (crc32("hHWSMlkFtMvM",12) == 2400103785) strcat(s, "e");
if (crc32("YjqNh",5) == 3743073350) strcat(s, "n");
if (crc32("UnEUn",5) == 3512313841) strcat(s, "Z");
if (crc32("DlRrJOXvnsoQsPX",15) == 3748162180) strcat(s, "t");
if (crc32("tdARSObVTZQnkva",15) == 2998906829) strcat(s, "r");
if (crc32("gbBQJbW",7) == 1336967365) strcat(s, "p");
if (crc32("mMwURwYtXrj",11) == 3010791121) strcat(s, "i");
if (crc32("uoFfYgSFTt",10) == 1395086403) strcat(s, "c");
if (crc32("oWIaSaSpKE",10) == 2021411530) strcat(s, "a");
if (crc32("pNvdSDsEcB",10) == 1319358070) strcat(s, "S");
if (crc32("IXBpqprz",8) == 3525559848) strcat(s, "l");
if (crc32("mhyoxCmCy",9) == 45808254) strcat(s, "v");
if (crc32("LzOMXWl",7) == 3572643908) strcat(s, "l");
if (crc32("jrpcRkjoIKx",11) == 3508607049) strcat(s, "y");
    return s;
}

char *confoundedly_adverbs() {
    char *s = calloc(13);
    if (crc32("yytGbd",6) == 637274759) strcat(s, "b");
if (crc32("EMlFszPhbWI",11) == 4066961492) strcat(s, "c");
if (crc32("BvTQIAm",7) == 2436638329) strcat(s, "o");
if (crc32("IzLgS",5) == 907871319) strcat(s, "o");
if (crc32("WEshYgBjQMl",11) == 822617797) strcat(s, "n");
if (crc32("vkVLTNri",8) == 3253409948) strcat(s, "j");
if (crc32("mSbtKTIZ",8) == 4164576385) strcat(s, "f");
if (crc32("bKFGAnqsfybn",12) == 2610740400) strcat(s, "o");
if (crc32("lSMiKWk",7) == 1124444171) strcat(s, "Q");
if (crc32("ZTfedABWObZaaD",14) == 1786342009) strcat(s, "u");
if (crc32("vrCxNUy",7) == 1912077324) strcat(s, "n");
if (crc32("dGEzcb",6) == 3501462831) strcat(s, "d");
if (crc32("XEgktBJ",7) == 306740651) strcat(s, "e");
if (crc32("AAQrBPWPGW",10) == 3014803812) strcat(s, "d");
if (crc32("NDIyl",5) == 4028991452) strcat(s, "l");
if (crc32("weJBE",5) == 953965693) strcat(s, "y");
    return s;
}

char *speakably_adverbs() {
    char *s = calloc(10);
    if (crc32("ZWbDlRGKnxC",11) == 2498764222) strcat(s, "s");
if (crc32("KNspOcKzxpamvfw",15) == 2956565387) strcat(s, "j");
if (crc32("XzTCUfqFgyFzSQh",15) == 3260134691) strcat(s, "p");
if (crc32("TKufq",5) == 2648921092) strcat(s, "W");
if (crc32("zjPzy",5) == 2976804416) strcat(s, "e");
if (crc32("hPuROODyaFhYJ",13) == 2673720353) strcat(s, "c");
if (crc32("XNfScMB",7) == 3764016542) strcat(s, "a");
if (crc32("piAHdSQwLNwZI",13) == 2077221767) strcat(s, "i");
if (crc32("HwSzOlltL",9) == 1140192411) strcat(s, "k");
if (crc32("DUjdzTW",7) == 621109781) strcat(s, "u");
if (crc32("UcwFTeKd",8) == 1343178386) strcat(s, "a");
if (crc32("rJcgRbitkQRdYD",14) == 820947645) strcat(s, "b");
if (crc32("MmsqreRhsQeohHt",15) == 4036268690) strcat(s, "C");
if (crc32("vqrxUFFHCxotLxZ",15) == 3375615156) strcat(s, "l");
if (crc32("etcCo",5) == 3489551388) strcat(s, "X");
if (crc32("RtYtoEcVntTCm",13) == 2116878006) strcat(s, "y");
    return s;
}

char *unfoolishly_adverbs() {
    char *s = calloc(12);
    if (crc32("ViZEmYOEFse",11) == 3050530339) strcat(s, "x");
if (crc32("HInUOagVx",9) == 2495955724) strcat(s, "u");
if (crc32("MHgoTWDTKpI",11) == 2960523217) strcat(s, "F");
if (crc32("mpGmCIAKJV",10) == 4125068927) strcat(s, "n");
if (crc32("ZDyRT",5) == 2941265714) strcat(s, "F");
if (crc32("UmWuhdiKdr",10) == 4249255547) strcat(s, "f");
if (crc32("BOTlmkvDCabBDqG",15) == 3746943624) strcat(s, "i");
if (crc32("zEvrxCekcXFoAS",14) == 1471462881) strcat(s, "o");
if (crc32("PjpqiHmDQNe",11) == 2443857166) strcat(s, "J");
if (crc32("DMCxH",5) == 4010967217) strcat(s, "o");
if (crc32("pFzcPEvR",8) == 3688792993) strcat(s, "l");
if (crc32("JakJRJFIJzbT",12) == 3220726474) strcat(s, "i");
if (crc32("ScSiUzCJhs",10) == 2447680230) strcat(s, "B");
if (crc32("ZCfrgHKAkFooeSG",15) == 925756559) strcat(s, "s");
if (crc32("wSbprFbbdVwUDm",14) == 511629830) strcat(s, "h");
if (crc32("OMFQcbL",7) == 1865111149) strcat(s, "X");
if (crc32("SSdXqCQwwkGBhFl",15) == 1512855879) strcat(s, "l");
if (crc32("CZVIfJasHtIXg",13) == 1319738649) strcat(s, "y");
    return s;
}

char *halfruefully_adverbs() {
    char *s = calloc(13);
    if (crc32("inXPgDH",7) == 209126622) strcat(s, "k");
if (crc32("GjsqViLzfC",10) == 608311975) strcat(s, "h");
if (crc32("GRwMr",5) == 886108671) strcat(s, "I");
if (crc32("EVRdOaqHJJWo",12) == 732089052) strcat(s, "a");
if (crc32("llEZFTPke",9) == 3984405174) strcat(s, "x");
if (crc32("NRZxG",5) == 781212343) strcat(s, "l");
if (crc32("afKGZqUCdUtm",12) == 4025815102) strcat(s, "f");
if (crc32("lRODr",5) == 2856123028) strcat(s, "f");
if (crc32("LwCuKtjvBWtCrF",14) == 580400826) strcat(s, "G");
if (crc32("iUXDSemEAlF",11) == 3686607597) strcat(s, "r");
if (crc32("lYEMAPflb",9) == 1005723785) strcat(s, "u");
if (crc32("RhAWtbvWjfKVSWt",15) == 3712328159) strcat(s, "e");
if (crc32("AvDmjBClgKGbkpj",15) == 13141124) strcat(s, "A");
if (crc32("RcQhAqYJhbG",11) == 230520453) strcat(s, "f");
if (crc32("AbHCysyJCQDLW",13) == 2841529377) strcat(s, "u");
if (crc32("TwYUDMNgvUQEWVZ",15) == 2535358259) strcat(s, "B");
if (crc32("fLMXpShWyovpw",13) == 2271857273) strcat(s, "l");
if (crc32("eiuJLvnojJZJWY",14) == 3805382025) strcat(s, "l");
if (crc32("oSPYuMLFhatcPbY",15) == 1992457137) strcat(s, "y");
    return s;
}

char *bottomlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("TInDWWrVbDP",11) == 3600379165) strcat(s, "b");
if (crc32("hGQABnotttZtOKw",15) == 2634508435) strcat(s, "O");
if (crc32("rvzditMq",8) == 3051838296) strcat(s, "o");
if (crc32("HPOTNvDmtbVC",12) == 2683673127) strcat(s, "t");
if (crc32("OodEIOWfCaIv",12) == 3242807529) strcat(s, "k");
if (crc32("IfsYsIwER",9) == 1963385762) strcat(s, "t");
if (crc32("URpEGn",6) == 2802769510) strcat(s, "o");
if (crc32("TAlszYgHjb",10) == 3140761028) strcat(s, "m");
if (crc32("KMVHIEcCliKiwBb",15) == 2270697849) strcat(s, "l");
if (crc32("OmkUov",6) == 4080899550) strcat(s, "e");
if (crc32("hBwPg",5) == 1722715229) strcat(s, "s");
if (crc32("kHpWAlnwz",9) == 3105919632) strcat(s, "s");
if (crc32("WAfbRmwoYMcAfP",14) == 3777603745) strcat(s, "I");
if (crc32("gOVCMyJpqVORMm",14) == 4034729269) strcat(s, "l");
if (crc32("bnHLKPHHADvxug",14) == 1599432973) strcat(s, "Y");
if (crc32("MWyplgUK",8) == 4271753149) strcat(s, "y");
    return s;
}

char *unfirmly_adverbs() {
    char *s = calloc(9);
    if (crc32("lLBaxDy",7) == 3805768632) strcat(s, "R");
if (crc32("hJdIJFWeFCdFbh",14) == 3747783088) strcat(s, "u");
if (crc32("ASpqmd",6) == 2935349025) strcat(s, "n");
if (crc32("xrOjwwzpUiJMIeK",15) == 3827976870) strcat(s, "f");
if (crc32("UAoXdNscnRwc",12) == 3987152186) strcat(s, "M");
if (crc32("QQBxYh",6) == 814496419) strcat(s, "i");
if (crc32("lyGJy",5) == 111870742) strcat(s, "j");
if (crc32("cezrAQlTv",9) == 624968604) strcat(s, "r");
if (crc32("kmcYKgPHg",9) == 3799515004) strcat(s, "A");
if (crc32("ObKBUyhdirwA",12) == 997832865) strcat(s, "m");
if (crc32("pDVqijX",7) == 1018761465) strcat(s, "l");
if (crc32("NYsewsWq",8) == 1102831765) strcat(s, "y");
    return s;
}

char *unmonarchically_adverbs() {
    char *s = calloc(16);
    if (crc32("TOBWhoZKzw",10) == 3818849684) strcat(s, "u");
if (crc32("wLeyFrdo",8) == 1903334891) strcat(s, "S");
if (crc32("NhHmkHhUhh",10) == 3829620679) strcat(s, "n");
if (crc32("CZdiRBxToPmZJ",13) == 4273712865) strcat(s, "i");
if (crc32("GhLTHbBt",8) == 3422437949) strcat(s, "m");
if (crc32("RZdIPQKoZNU",11) == 1854872216) strcat(s, "o");
if (crc32("fhOBUYzWKyUq",12) == 3045197748) strcat(s, "n");
if (crc32("vsykr",5) == 4005726074) strcat(s, "x");
if (crc32("VEbhPIjZ",8) == 2899078913) strcat(s, "a");
if (crc32("jtDNxChgBLS",11) == 2541832104) strcat(s, "b");
if (crc32("DGCThUZsjq",10) == 3773013772) strcat(s, "r");
if (crc32("bMbdlM",6) == 1263130360) strcat(s, "c");
if (crc32("USsoowLpouDoZi",14) == 2609429887) strcat(s, "h");
if (crc32("XIBxFBVur",9) == 2081156768) strcat(s, "n");
if (crc32("adEmLQSSe",9) == 2012200820) strcat(s, "i");
if (crc32("nPaKTKKnaeiTsxk",15) == 1580988539) strcat(s, "X");
if (crc32("VxTmqcFa",8) == 3671411124) strcat(s, "c");
if (crc32("TcwHqeXin",9) == 3922192607) strcat(s, "a");
if (crc32("czKTUanrIUlX",12) == 3490250554) strcat(s, "l");
if (crc32("LjVMTWGQ",8) == 3483397517) strcat(s, "D");
if (crc32("mSCTRUzQRHyf",12) == 4207041409) strcat(s, "l");
if (crc32("jDbdTEyEc",9) == 1846794874) strcat(s, "y");
    return s;
}

char *slackingly_adverbs() {
    char *s = calloc(11);
    if (crc32("XnmKPqLKak",10) == 331204111) strcat(s, "s");
if (crc32("kmDcNUKQZQTaXp",14) == 1867142767) strcat(s, "l");
if (crc32("oOrqRqHg",8) == 2209610211) strcat(s, "a");
if (crc32("PwxAzeEVKi",10) == 1273419631) strcat(s, "c");
if (crc32("ByKOMHdGCClHDd",14) == 3563318081) strcat(s, "k");
if (crc32("CPjreeIQR",9) == 968389189) strcat(s, "i");
if (crc32("VmkDkcPu",8) == 2502550013) strcat(s, "U");
if (crc32("AwUiDG",6) == 4182513080) strcat(s, "n");
if (crc32("gQqmQAaqwRvMHy",14) == 1927440738) strcat(s, "g");
if (crc32("lHFBtP",6) == 1261358659) strcat(s, "l");
if (crc32("eJBsUyFSqmBQ",12) == 596202446) strcat(s, "y");
    return s;
}

char *heliotropically_adverbs() {
    char *s = calloc(16);
    if (crc32("jHASt",5) == 1232930287) strcat(s, "Y");
if (crc32("DeSIVKWvpwoKpS",14) == 3322117695) strcat(s, "h");
if (crc32("rlvpMHM",7) == 522409660) strcat(s, "z");
if (crc32("sjKpMVPqCZBO",12) == 4202988383) strcat(s, "e");
if (crc32("lSEaCCKlLm",10) == 2963038076) strcat(s, "x");
if (crc32("xOiJv",5) == 939628369) strcat(s, "l");
if (crc32("BuYSRIG",7) == 715469114) strcat(s, "t");
if (crc32("mTmsG",5) == 1330281057) strcat(s, "i");
if (crc32("SkEdudZ",7) == 2618814945) strcat(s, "z");
if (crc32("TfsHCjCdhuQ",11) == 859060841) strcat(s, "o");
if (crc32("oMbtUxtZARnN",12) == 2401637347) strcat(s, "Z");
if (crc32("vJWXArxMOP",10) == 2448275335) strcat(s, "t");
if (crc32("UlJMTEpPf",9) == 569878155) strcat(s, "r");
if (crc32("oBJSLqL",7) == 1496815897) strcat(s, "o");
if (crc32("rRBGEJQ",7) == 299210801) strcat(s, "b");
if (crc32("SZHwfnmTx",9) == 92191620) strcat(s, "p");
if (crc32("WoFAxibMdaNPy",13) == 1135661102) strcat(s, "i");
if (crc32("FjCqD",5) == 2366626631) strcat(s, "c");
if (crc32("wZEKMfcmjNa",11) == 268099552) strcat(s, "c");
if (crc32("cTGTattajNhY",12) == 4222763861) strcat(s, "n");
if (crc32("wossjH",6) == 1957687218) strcat(s, "a");
if (crc32("iVvGjsl",7) == 747766265) strcat(s, "l");
if (crc32("heuPHuqMu",9) == 797874956) strcat(s, "l");
if (crc32("bJzrdWmBcHnuW",13) == 3323942752) strcat(s, "y");
    return s;
}

char *unlitigiously_adverbs() {
    char *s = calloc(14);
    if (crc32("lBkMJd",6) == 3446230177) strcat(s, "y");
if (crc32("qwBGF",5) == 2816590478) strcat(s, "u");
if (crc32("ACgLtqgv",8) == 3834361265) strcat(s, "q");
if (crc32("ECOZOkKhjU",10) == 2502975743) strcat(s, "n");
if (crc32("UpKZVqciThSGXD",14) == 1840865825) strcat(s, "Q");
if (crc32("tVHvFIxfURv",11) == 503070760) strcat(s, "l");
if (crc32("xUbKtEGpTpxN",12) == 1779792375) strcat(s, "i");
if (crc32("odHzFnCHJ",9) == 1007719136) strcat(s, "t");
if (crc32("lQaMcGDW",8) == 994977252) strcat(s, "V");
if (crc32("hVzmRsZXr",9) == 4170359105) strcat(s, "i");
if (crc32("QRKuFv",6) == 900312919) strcat(s, "g");
if (crc32("kbzYIRJNKCFwNTu",15) == 2955773860) strcat(s, "t");
if (crc32("XXysfxtOMoho",12) == 2573377818) strcat(s, "i");
if (crc32("jHptiSLBBueRAVD",15) == 2420518750) strcat(s, "R");
if (crc32("oVHmCKzKGSDi",12) == 1033831220) strcat(s, "o");
if (crc32("qaVYmWFhSAp",11) == 892506519) strcat(s, "T");
if (crc32("HgezlEcRDfkY",12) == 4148178708) strcat(s, "u");
if (crc32("DmBVBrWArwFDYc",14) == 2910683624) strcat(s, "p");
if (crc32("roBiIEMCYPop",12) == 4272589671) strcat(s, "s");
if (crc32("fkEMstjIvV",10) == 4106054129) strcat(s, "l");
if (crc32("ibnmOmhnmFuDZ",13) == 921595652) strcat(s, "y");
    return s;
}

char *nonabsolutistically_adverbs() {
    char *s = calloc(20);
    if (crc32("pBogyyLEiAqJxhb",15) == 1823664047) strcat(s, "n");
if (crc32("TgrokAKL",8) == 1448022248) strcat(s, "o");
if (crc32("HxDFa",5) == 3945787575) strcat(s, "n");
if (crc32("IVcDVAKP",8) == 631511597) strcat(s, "d");
if (crc32("mWMHO",5) == 1474032741) strcat(s, "a");
if (crc32("LvlmkCWGfvQfWJ",14) == 1029929141) strcat(s, "v");
if (crc32("mKxteMJUEdIkoEx",15) == 279821532) strcat(s, "b");
if (crc32("EbqSfQmPW",9) == 1254064060) strcat(s, "s");
if (crc32("kLWJb",5) == 970705162) strcat(s, "o");
if (crc32("yWEpthDl",8) == 826115643) strcat(s, "H");
if (crc32("IFORyDgpWjGi",12) == 2890125392) strcat(s, "l");
if (crc32("kdTVWNIDigYZLWQ",15) == 906239056) strcat(s, "h");
if (crc32("QzUYpveP",8) == 2505371074) strcat(s, "u");
if (crc32("uqPyCkqLCunx",12) == 3750999911) strcat(s, "F");
if (crc32("XowlVzscFqqrfdu",15) == 3489313387) strcat(s, "t");
if (crc32("nDoVZAHkE",9) == 3614139984) strcat(s, "i");
if (crc32("hSiKQuNkXWSpe",13) == 2291689218) strcat(s, "s");
if (crc32("QOwOn",5) == 2356361293) strcat(s, "t");
if (crc32("WNvMrYLCcJhf",12) == 18411956) strcat(s, "i");
if (crc32("cqaNbzAbTiW",11) == 3754732571) strcat(s, "Z");
if (crc32("NqwyXRCB",8) == 3553135111) strcat(s, "c");
if (crc32("fGNQZxh",7) == 3050322243) strcat(s, "J");
if (crc32("lRHGXBSPvU",10) == 447677331) strcat(s, "a");
if (crc32("IioKYuwefk",10) == 424277821) strcat(s, "g");
if (crc32("DhExJwLojZTM",12) == 2150601667) strcat(s, "l");
if (crc32("jFAYpszd",8) == 1347556738) strcat(s, "l");
if (crc32("kczBV",5) == 410180972) strcat(s, "y");
    return s;
}

char *inversely_adverbs() {
    char *s = calloc(10);
    if (crc32("pABYs",5) == 1802768488) strcat(s, "f");
if (crc32("PsrTgGha",8) == 575194950) strcat(s, "i");
if (crc32("fvCQtekYtvBsSW",14) == 3860159683) strcat(s, "S");
if (crc32("iUqJGwYBwyWfN",13) == 3937409916) strcat(s, "n");
if (crc32("SjGxyQcntweDS",13) == 3316170517) strcat(s, "A");
if (crc32("rCLClFyo",8) == 3211446609) strcat(s, "v");
if (crc32("bYPbismaRLrA",12) == 1904480915) strcat(s, "e");
if (crc32("ZljuVoiPKQFwcx",14) == 4027207554) strcat(s, "b");
if (crc32("MHLewZy",7) == 4067685164) strcat(s, "r");
if (crc32("UaKwtVWNXnVkd",13) == 342878034) strcat(s, "C");
if (crc32("hdvJQ",5) == 2644670922) strcat(s, "s");
if (crc32("LkNybPjjCAw",11) == 4194046879) strcat(s, "e");
if (crc32("DDkLeMqaaeYe",12) == 1492730366) strcat(s, "c");
if (crc32("ttBkCX",6) == 3864582412) strcat(s, "l");
if (crc32("EShtCxgzyQw",11) == 3673773412) strcat(s, "y");
    return s;
}

char *noncreatively_adverbs() {
    char *s = calloc(14);
    if (crc32("TUhpAFkznQXiU",13) == 3824190844) strcat(s, "n");
if (crc32("feFtZVuvEuDa",12) == 1511830310) strcat(s, "o");
if (crc32("yfxwlVPC",8) == 3732392121) strcat(s, "n");
if (crc32("SOXGNgRaprl",11) == 2671743994) strcat(s, "h");
if (crc32("iMRDZNc",7) == 3175834932) strcat(s, "c");
if (crc32("PDFNhxmU",8) == 3516933129) strcat(s, "r");
if (crc32("IconHOf",7) == 4166784858) strcat(s, "z");
if (crc32("BBdfUvjKgz",10) == 2911887323) strcat(s, "e");
if (crc32("wQeXxLzfM",9) == 2314826539) strcat(s, "q");
if (crc32("iVmaPCp",7) == 1547722098) strcat(s, "a");
if (crc32("DnXMRr",6) == 1582674205) strcat(s, "h");
if (crc32("kggUqXjHqJycIcX",15) == 3199062735) strcat(s, "t");
if (crc32("RTBqhGi",7) == 2182822775) strcat(s, "i");
if (crc32("GctSHEdCtv",10) == 2274410880) strcat(s, "v");
if (crc32("QZPXACptyZChr",13) == 4244169579) strcat(s, "e");
if (crc32("EbpoQejeBPV",11) == 2846770626) strcat(s, "l");
if (crc32("GpoSNpYblTgPfD",14) == 2998935511) strcat(s, "W");
if (crc32("IDRoNKPr",8) == 3122929358) strcat(s, "y");
    return s;
}

char *infuriately_adverbs() {
    char *s = calloc(12);
    if (crc32("zfTFTqVGMFy",11) == 1475444702) strcat(s, "r");
if (crc32("VgPEtBt",7) == 2594046971) strcat(s, "i");
if (crc32("dHtysbAm",8) == 2370486518) strcat(s, "C");
if (crc32("XPdoUnddFvSZxmD",15) == 1812907515) strcat(s, "n");
if (crc32("VBjRqIgLfh",10) == 4195250014) strcat(s, "h");
if (crc32("xEIrfWAuT",9) == 1422421973) strcat(s, "f");
if (crc32("joCtKjRBEkRr",12) == 1154794063) strcat(s, "u");
if (crc32("aIHAYIuXBb",10) == 2521134243) strcat(s, "r");
if (crc32("fhbQqKUndksSlDA",15) == 157881761) strcat(s, "U");
if (crc32("owMPZeLJdUG",11) == 274293178) strcat(s, "i");
if (crc32("JBFltyKAPzaGg",13) == 4282732934) strcat(s, "h");
if (crc32("MrHQfAdJB",9) == 2144853797) strcat(s, "a");
if (crc32("iuXVOrTvz",9) == 38786981) strcat(s, "p");
if (crc32("hCKMAxT",7) == 270323042) strcat(s, "t");
if (crc32("HRrDHFmRZvyI",12) == 847363505) strcat(s, "e");
if (crc32("nqsuyBmMEcpyVQ",14) == 3249614713) strcat(s, "M");
if (crc32("pwVtVIyT",8) == 904838362) strcat(s, "l");
if (crc32("jZcmASRtG",9) == 2507078092) strcat(s, "y");
    return s;
}

char *subproportionally_adverbs() {
    char *s = calloc(18);
    if (crc32("TbmceW",6) == 3866480065) strcat(s, "N");
if (crc32("FpHphQTbn",9) == 3616562737) strcat(s, "s");
if (crc32("YOeYkNdYMbyJrS",14) == 2026313135) strcat(s, "u");
if (crc32("FBjldQt",7) == 1223176256) strcat(s, "m");
if (crc32("IgaBSsrY",8) == 2093688691) strcat(s, "b");
if (crc32("JqVQun",6) == 2699662531) strcat(s, "p");
if (crc32("gKIfIaYhZthTfa",14) == 2444319023) strcat(s, "r");
if (crc32("ltRzNSbIGKFwlgX",15) == 3716404513) strcat(s, "o");
if (crc32("wSCfFUmH",8) == 3481798497) strcat(s, "a");
if (crc32("LWedsQmngD",10) == 3456126407) strcat(s, "p");
if (crc32("ZjfBjfhMdYdx",12) == 1452282797) strcat(s, "o");
if (crc32("hXqYRFiIcFO",11) == 2470899145) strcat(s, "r");
if (crc32("dolLLvUEDNtVt",13) == 127438293) strcat(s, "t");
if (crc32("PDYdVxBFBw",10) == 2094235059) strcat(s, "M");
if (crc32("HYPeFTEaOw",10) == 1953724092) strcat(s, "i");
if (crc32("JmIRqDajnWftdtk",15) == 4015422300) strcat(s, "o");
if (crc32("cwuvolfdMIhh",12) == 3758603886) strcat(s, "e");
if (crc32("ftOhVAPhyA",10) == 393470155) strcat(s, "n");
if (crc32("cQiGSlVPicSo",12) == 1064792636) strcat(s, "a");
if (crc32("PGBUVCS",7) == 3013427645) strcat(s, "R");
if (crc32("slXJlz",6) == 1788532562) strcat(s, "l");
if (crc32("yDAvhNtfxpTd",12) == 1881740742) strcat(s, "I");
if (crc32("RzpaPjhMP",9) == 2886590042) strcat(s, "l");
if (crc32("zPVwsetTNsFHN",13) == 3157693926) strcat(s, "g");
if (crc32("rqorsq",6) == 616232162) strcat(s, "y");
    return s;
}

char *racemously_adverbs() {
    char *s = calloc(11);
    if (crc32("BpdlJIkILF",10) == 988726589) strcat(s, "r");
if (crc32("vAYxYbwTtmCh",12) == 411407196) strcat(s, "a");
if (crc32("AJWgbWEVmUMo",12) == 547705480) strcat(s, "c");
if (crc32("DfSblAaANRt",11) == 2734145799) strcat(s, "e");
if (crc32("ZpQltWjetjXU",12) == 1100033663) strcat(s, "m");
if (crc32("FfcqHgxM",8) == 2141769089) strcat(s, "j");
if (crc32("uMGzoZlBkI",10) == 3079780035) strcat(s, "o");
if (crc32("THnufJaMJPEI",12) == 2093904248) strcat(s, "g");
if (crc32("ncwam",5) == 3622330122) strcat(s, "u");
if (crc32("TRJRFwlnuqwF",12) == 3169267977) strcat(s, "Z");
if (crc32("wvLGCNozpgf",11) == 3657092453) strcat(s, "s");
if (crc32("YAAzefEQQ",9) == 544534656) strcat(s, "M");
if (crc32("OpacmUha",8) == 1348959621) strcat(s, "l");
if (crc32("rJNgADLHwa",10) == 3028006076) strcat(s, "y");
    return s;
}

char *prefiguratively_adverbs() {
    char *s = calloc(16);
    if (crc32("wgCmlvAK",8) == 944565764) strcat(s, "d");
if (crc32("gcJdCZaCVnXNBXk",15) == 2232374545) strcat(s, "p");
if (crc32("HFVIdNJEYMf",11) == 3581662348) strcat(s, "r");
if (crc32("UaJoZnCvBkVPb",13) == 2307551297) strcat(s, "e");
if (crc32("BVEFHzFKDmW",11) == 3366815875) strcat(s, "U");
if (crc32("tQdbjlieuLeQf",13) == 1182496668) strcat(s, "f");
if (crc32("HkdFvEssDpjAoS",14) == 4106940050) strcat(s, "M");
if (crc32("RdvES",5) == 530949134) strcat(s, "i");
if (crc32("NyqDG",5) == 508076662) strcat(s, "g");
if (crc32("nkSOeqlW",8) == 482813332) strcat(s, "u");
if (crc32("GmaAuJe",7) == 2541267423) strcat(s, "c");
if (crc32("SaaJrcTZ",8) == 2624572894) strcat(s, "r");
if (crc32("KzNZClEnlYVWKGj",15) == 2691676545) strcat(s, "R");
if (crc32("dIMPFnRGBK",10) == 275353093) strcat(s, "a");
if (crc32("iEqsUhUrnV",10) == 3235253938) strcat(s, "t");
if (crc32("OYKgKHHh",8) == 1409175437) strcat(s, "y");
if (crc32("jsUXDZsTiaUW",12) == 526958788) strcat(s, "i");
if (crc32("fAWmfCusMhZzJ",13) == 1927587781) strcat(s, "k");
if (crc32("zLgjkmRlGDriIA",14) == 3861242243) strcat(s, "v");
if (crc32("vZOHdVfH",8) == 2313186659) strcat(s, "e");
if (crc32("uCQXMcssmXbB",12) == 1211259910) strcat(s, "l");
if (crc32("tBfdVOJLLBckGhU",15) == 2217533077) strcat(s, "y");
    return s;
}

char *quasidevotedly_adverbs() {
    char *s = calloc(15);
    if (crc32("TXoPJy",6) == 34130106) strcat(s, "q");
if (crc32("TUUXIMww",8) == 2702819687) strcat(s, "H");
if (crc32("bafMN",5) == 1050913051) strcat(s, "u");
if (crc32("tfySmHOBF",9) == 2839479849) strcat(s, "v");
if (crc32("mgRcWUQQ",8) == 2087217726) strcat(s, "a");
if (crc32("eCRlGeew",8) == 192561104) strcat(s, "s");
if (crc32("BzoJWZPZn",9) == 1352764509) strcat(s, "i");
if (crc32("XZhyEJQ",7) == 4288481635) strcat(s, "d");
if (crc32("FYumctbmu",9) == 2322780295) strcat(s, "e");
if (crc32("sYrXVIeOSeUOgQ",14) == 1171796701) strcat(s, "v");
if (crc32("rSSYgLqJCDdGRF",14) == 1828905934) strcat(s, "L");
if (crc32("tHKconhrf",9) == 1188374133) strcat(s, "o");
if (crc32("fTlErjco",8) == 1450659764) strcat(s, "c");
if (crc32("wXEdDeEt",8) == 1621516966) strcat(s, "t");
if (crc32("vmgVEDtoGvWbVbb",15) == 668152243) strcat(s, "e");
if (crc32("IVhTiNhVSP",10) == 4036976765) strcat(s, "d");
if (crc32("gUMoXUpZMjKu",12) == 705514483) strcat(s, "V");
if (crc32("brJWJQexYpTNd",13) == 1004941321) strcat(s, "l");
if (crc32("NbEHWwJfqJC",11) == 3498763857) strcat(s, "h");
if (crc32("PeQoc",5) == 2842246378) strcat(s, "y");
    return s;
}

char *inceptively_adverbs() {
    char *s = calloc(12);
    if (crc32("VAnOlVS",7) == 207166345) strcat(s, "z");
if (crc32("ovjKexPOzQO",11) == 930629008) strcat(s, "i");
if (crc32("GFAsH",5) == 3130583374) strcat(s, "s");
if (crc32("HVVKlnh",7) == 851671002) strcat(s, "n");
if (crc32("wEJREGkTDUsdDT",14) == 909889870) strcat(s, "c");
if (crc32("NRbDQrT",7) == 2659518926) strcat(s, "n");
if (crc32("eaBKKqxFFdY",11) == 1714222187) strcat(s, "e");
if (crc32("JgvjYrNE",8) == 3745620154) strcat(s, "M");
if (crc32("eYQSMcCtE",9) == 65363603) strcat(s, "p");
if (crc32("GXPVw",5) == 3184283407) strcat(s, "T");
if (crc32("Zwwch",5) == 510531465) strcat(s, "t");
if (crc32("kKQiehEsFzldEzv",15) == 236299500) strcat(s, "i");
if (crc32("bTkObZFINFyhUx",14) == 562228327) strcat(s, "n");
if (crc32("oLQJmwUjjEQGB",13) == 3318827097) strcat(s, "v");
if (crc32("bKWSEGffH",9) == 489278459) strcat(s, "e");
if (crc32("kFoRNILux",9) == 2679940299) strcat(s, "l");
if (crc32("EYacCBFZ",8) == 4279003510) strcat(s, "M");
if (crc32("OIHTLgAarmiZPKr",15) == 2051554385) strcat(s, "y");
    return s;
}

char *overfiercely_adverbs() {
    char *s = calloc(13);
    if (crc32("gAboqFt",7) == 2132099527) strcat(s, "l");
if (crc32("PyTQlr",6) == 400343843) strcat(s, "o");
if (crc32("ATcjHOtsjxvy",12) == 3554023288) strcat(s, "v");
if (crc32("JkGnpH",6) == 2856426711) strcat(s, "a");
if (crc32("EmdGzGCb",8) == 2654417119) strcat(s, "e");
if (crc32("WctZh",5) == 3794294094) strcat(s, "I");
if (crc32("KqeTsUqC",8) == 74225179) strcat(s, "r");
if (crc32("SmSEOUJqGLBwlZb",15) == 3060154164) strcat(s, "b");
if (crc32("caQasGPVfw",10) == 529561795) strcat(s, "f");
if (crc32("djTbvAPhb",9) == 95557164) strcat(s, "l");
if (crc32("tSvpeRoBBJN",11) == 49131067) strcat(s, "i");
if (crc32("wMeiitNT",8) == 1029330927) strcat(s, "e");
if (crc32("qIKFBRBwJ",9) == 1850736669) strcat(s, "r");
if (crc32("FgSbNjDVe",9) == 3546030508) strcat(s, "c");
if (crc32("penWg",5) == 1466812833) strcat(s, "e");
if (crc32("IvoOcwrDLJDZ",12) == 1379595672) strcat(s, "B");
if (crc32("XJixMHzmNbZOg",13) == 3532254144) strcat(s, "l");
if (crc32("IzIrJohnUuGOM",13) == 3709619335) strcat(s, "l");
if (crc32("oxSHMj",6) == 3460526616) strcat(s, "y");
    return s;
}

char *immoderately_adverbs() {
    char *s = calloc(13);
    if (crc32("ipUYnSVAqeDtU",13) == 3392311976) strcat(s, "i");
if (crc32("lyTbePq",7) == 1917773392) strcat(s, "m");
if (crc32("RLNSsOFoxgejEA",14) == 2809891516) strcat(s, "A");
if (crc32("bQiakeS",7) == 4282738647) strcat(s, "m");
if (crc32("iPhxTQlxvD",10) == 3507070408) strcat(s, "o");
if (crc32("ubufH",5) == 2597472655) strcat(s, "a");
if (crc32("TBytMkxF",8) == 302051193) strcat(s, "d");
if (crc32("uiOetUJtsYqfP",13) == 3435643608) strcat(s, "O");
if (crc32("fNvMBPUoDyFRb",13) == 3431747544) strcat(s, "e");
if (crc32("hGxncgYSxqn",11) == 776246767) strcat(s, "n");
if (crc32("eqsmMpHay",9) == 419947547) strcat(s, "r");
if (crc32("gFZAJQcYHRe",11) == 1082762883) strcat(s, "Q");
if (crc32("mYaBXa",6) == 2297978823) strcat(s, "a");
if (crc32("ZjOZBrGMUfi",11) == 2314450568) strcat(s, "t");
if (crc32("ZlfzTXTmDQtq",12) == 1821481157) strcat(s, "e");
if (crc32("ZglbqpDhTA",10) == 3485535159) strcat(s, "E");
if (crc32("cTPhE",5) == 2616268917) strcat(s, "l");
if (crc32("fvpsLgSN",8) == 3794823779) strcat(s, "l");
if (crc32("LyCNIzmxZiQ",11) == 469386467) strcat(s, "y");
    return s;
}

char *nonconvivially_adverbs() {
    char *s = calloc(15);
    if (crc32("lRYmDYFpMgwEkE",14) == 1520553251) strcat(s, "E");
if (crc32("LyLdWFd",7) == 2661432465) strcat(s, "n");
if (crc32("IJvMDPygzKnqMMQ",15) == 3965538935) strcat(s, "o");
if (crc32("DxiRRvZIZnA",11) == 485638381) strcat(s, "U");
if (crc32("jRqGzusjGj",10) == 765664990) strcat(s, "n");
if (crc32("gVEheJvF",8) == 2666608871) strcat(s, "c");
if (crc32("HHTxxmubl",9) == 1315987677) strcat(s, "c");
if (crc32("TsBKn",5) == 3097629275) strcat(s, "o");
if (crc32("CmtBXmpNR",9) == 3564296588) strcat(s, "x");
if (crc32("CNFfAKG",7) == 2655943610) strcat(s, "n");
if (crc32("gzAIOdVmeqA",11) == 719488151) strcat(s, "v");
if (crc32("jxrJcvpnr",9) == 76001549) strcat(s, "i");
if (crc32("KyAwOXWVzybjuFj",15) == 1460102407) strcat(s, "v");
if (crc32("ktUWtrAsJSISaSY",15) == 3630924272) strcat(s, "t");
if (crc32("Aczbx",5) == 3662791588) strcat(s, "i");
if (crc32("soMpAjAPQVVskBI",15) == 499966943) strcat(s, "K");
if (crc32("xMchjXmPuHN",11) == 3163074155) strcat(s, "a");
if (crc32("TVFisEJvNMvwmJq",15) == 3501184864) strcat(s, "l");
if (crc32("pZPxjQDzheBqXB",14) == 3526169648) strcat(s, "v");
if (crc32("BEgmw",5) == 460421355) strcat(s, "l");
if (crc32("ilhnTkFS",8) == 2609910085) strcat(s, "Q");
if (crc32("GUtBYWLB",8) == 2667564763) strcat(s, "y");
    return s;
}

char *protectively_adverbs() {
    char *s = calloc(13);
    if (crc32("alhulc",6) == 2683536910) strcat(s, "p");
if (crc32("ryAFS",5) == 3166013373) strcat(s, "S");
if (crc32("DANnUBQEhPjq",12) == 4161357736) strcat(s, "r");
if (crc32("SvkJzG",6) == 50737698) strcat(s, "w");
if (crc32("uZWhTLoIoZZJM",13) == 896608693) strcat(s, "o");
if (crc32("YFXoPDwVW",9) == 850626337) strcat(s, "O");
if (crc32("BRzMNWLQeLsi",12) == 2875314482) strcat(s, "t");
if (crc32("jDCcKsC",7) == 2276173541) strcat(s, "e");
if (crc32("FXAqRPOPVWW",11) == 2533642019) strcat(s, "c");
if (crc32("UtBHeG",6) == 1584757239) strcat(s, "t");
if (crc32("hbCjPUhKIxtORhn",15) == 3505075048) strcat(s, "i");
if (crc32("TfLwFj",6) == 3147272250) strcat(s, "v");
if (crc32("mVLEByB",7) == 2300755803) strcat(s, "e");
if (crc32("yUZoPAjlVDRjC",13) == 3886232945) strcat(s, "n");
if (crc32("ZfuIFDpSSM",10) == 3215605168) strcat(s, "l");
if (crc32("wgqdI",5) == 1887654280) strcat(s, "y");
    return s;
}

char *nonsocially_adverbs() {
    char *s = calloc(12);
    if (crc32("ktofuD",6) == 2914474705) strcat(s, "X");
if (crc32("uEmhgqLgceJ",11) == 1137494700) strcat(s, "n");
if (crc32("kICvHJinxnaq",12) == 3724033595) strcat(s, "o");
if (crc32("steOqKWSEu",10) == 757665944) strcat(s, "L");
if (crc32("bJhrIAuqmXvdu",13) == 1419094362) strcat(s, "n");
if (crc32("pJoHmSgasrMiNDR",15) == 2741926453) strcat(s, "s");
if (crc32("itpLWmv",7) == 992438019) strcat(s, "s");
if (crc32("UEYPmS",6) == 3054969569) strcat(s, "o");
if (crc32("aqThVSruRUqt",12) == 1012494923) strcat(s, "o");
if (crc32("oYsqxnkhMsFenn",14) == 30476146) strcat(s, "c");
if (crc32("QYqXQDNv",8) == 210279610) strcat(s, "R");
if (crc32("BhmUjzFKPUMgY",13) == 177662161) strcat(s, "i");
if (crc32("aZuZPWdi",8) == 1082901093) strcat(s, "a");
if (crc32("rJfZxFLQHStP",12) == 2300824711) strcat(s, "l");
if (crc32("QObwpXZcoPyGUS",14) == 515785176) strcat(s, "f");
if (crc32("RksGZkAXfsF",11) == 3513743548) strcat(s, "l");
if (crc32("kwJKAM",6) == 4080966146) strcat(s, "Z");
if (crc32("woxSSuCtqqoC",12) == 755884941) strcat(s, "y");
    return s;
}

char *tattlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("XbbqkVaWoZeMt",13) == 1093569372) strcat(s, "U");
if (crc32("tWeuZuguAdUcH",13) == 2541494656) strcat(s, "t");
if (crc32("XRXMvAAMCfoxQL",14) == 51521313) strcat(s, "a");
if (crc32("mIUIRJ",6) == 2622114664) strcat(s, "c");
if (crc32("UufyNkDCQXV",11) == 564749118) strcat(s, "t");
if (crc32("kSPNgGSsE",9) == 3012935157) strcat(s, "B");
if (crc32("kTVjGDePzEXrRJ",14) == 2205441467) strcat(s, "t");
if (crc32("RWzhTRkUUul",11) == 2395482994) strcat(s, "l");
if (crc32("rNuYmXgeZAbXlC",14) == 527467803) strcat(s, "a");
if (crc32("Mtgxvxl",7) == 1577348433) strcat(s, "i");
if (crc32("kKmbvNYqadd",11) == 398053038) strcat(s, "J");
if (crc32("HPwgND",6) == 3470869739) strcat(s, "n");
if (crc32("IZJZyGSQj",9) == 3909678206) strcat(s, "U");
if (crc32("USccnxtoVVmixg",14) == 1457927892) strcat(s, "g");
if (crc32("httIYGohaQq",11) == 1777896708) strcat(s, "l");
if (crc32("IWyHuVBAvpWv",12) == 1023647113) strcat(s, "y");
    return s;
}

char *venously_adverbs() {
    char *s = calloc(9);
    if (crc32("chWpfy",6) == 3322110000) strcat(s, "m");
if (crc32("OhxTXksr",8) == 4144419492) strcat(s, "v");
if (crc32("bCTWVbbOXqlcM",13) == 414740913) strcat(s, "e");
if (crc32("cpVeNPS",7) == 2345874560) strcat(s, "S");
if (crc32("jgEpzV",6) == 2623308576) strcat(s, "n");
if (crc32("kHOAzEwJHf",10) == 2246193512) strcat(s, "h");
if (crc32("ZwaPwMwHK",9) == 741578646) strcat(s, "o");
if (crc32("JECbdClvjbgoT",13) == 209217763) strcat(s, "u");
if (crc32("RfSzpckWqc",10) == 1347980627) strcat(s, "s");
if (crc32("gVekAwimqxvU",12) == 1241534023) strcat(s, "W");
if (crc32("QwLKHFDeG",9) == 2463909396) strcat(s, "l");
if (crc32("rMufmJMHxbRn",12) == 2798642703) strcat(s, "S");
if (crc32("WFNvb",5) == 1387503081) strcat(s, "y");
    return s;
}

char *rateably_adverbs() {
    char *s = calloc(9);
    if (crc32("YZSfa",5) == 2141747684) strcat(s, "v");
if (crc32("zwaJUn",6) == 3285765861) strcat(s, "r");
if (crc32("MSQIEjCfBctyw",13) == 2135785584) strcat(s, "c");
if (crc32("rFOEaNuC",8) == 2257767282) strcat(s, "a");
if (crc32("xBCXMXHSsmHNN",13) == 2913544560) strcat(s, "y");
if (crc32("KNePvddwBkLcglt",15) == 3646357896) strcat(s, "t");
if (crc32("DMnBTPDtrCs",11) == 13116667) strcat(s, "q");
if (crc32("OPeHh",5) == 3797488267) strcat(s, "e");
if (crc32("kSKMJvAgVK",10) == 1811389458) strcat(s, "a");
if (crc32("NHBrADSXJSc",11) == 169292752) strcat(s, "c");
if (crc32("gWobkvVufBny",12) == 1925963513) strcat(s, "b");
if (crc32("ToyhaPJRkmOD",12) == 2961757665) strcat(s, "R");
if (crc32("IuJGDmgN",8) == 1175540382) strcat(s, "l");
if (crc32("QJVMzwrEcatG",12) == 1928333837) strcat(s, "y");
    return s;
}

char *intricately_adverbs() {
    char *s = calloc(12);
    if (crc32("IjjrKRuGot",10) == 520896058) strcat(s, "s");
if (crc32("ZKQYJWnhxz",10) == 3493984180) strcat(s, "i");
if (crc32("UbPtpGn",7) == 3440184381) strcat(s, "x");
if (crc32("PclTjKpcK",9) == 1972299276) strcat(s, "n");
if (crc32("oUzHAgg",7) == 3642825958) strcat(s, "t");
if (crc32("lwIPAb",6) == 1256766804) strcat(s, "R");
if (crc32("HleOndFX",8) == 107127640) strcat(s, "r");
if (crc32("aShzsuUtcYRQITi",15) == 4099017653) strcat(s, "v");
if (crc32("OTnQvrroPH",10) == 4247673124) strcat(s, "i");
if (crc32("ULJdbmfyX",9) == 776537942) strcat(s, "c");
if (crc32("nKiRJffdblgrgS",14) == 2796071712) strcat(s, "a");
if (crc32("ltPVmYajlrmP",12) == 1216030415) strcat(s, "Z");
if (crc32("XzZgNgGEPCArky",14) == 2938838960) strcat(s, "t");
if (crc32("mCqwWHGXN",9) == 341908217) strcat(s, "Q");
if (crc32("WUbKq",5) == 3474903932) strcat(s, "e");
if (crc32("LjqPHXphoFeT",12) == 3146876728) strcat(s, "C");
if (crc32("VyIoo",5) == 660971406) strcat(s, "l");
if (crc32("GVNrMGwfBDnIwXV",15) == 328308019) strcat(s, "y");
    return s;
}

char *quasispatially_adverbs() {
    char *s = calloc(15);
    if (crc32("LjLYYZMWVoH",11) == 476935773) strcat(s, "q");
if (crc32("RyIynUeslw",10) == 2097636836) strcat(s, "X");
if (crc32("vjnVnMMTNofPgvx",15) == 1196531060) strcat(s, "u");
if (crc32("WMdTmvCLMZJMVN",14) == 2371857511) strcat(s, "i");
if (crc32("CZCxyqjqweZk",12) == 785568550) strcat(s, "a");
if (crc32("TSjhJUsnpKLcDVR",15) == 2480466299) strcat(s, "w");
if (crc32("LeVxdcfhuyzX",12) == 3204444831) strcat(s, "s");
if (crc32("dAPXZK",6) == 1984443520) strcat(s, "w");
if (crc32("nuapkTtSCJvP",12) == 2835140759) strcat(s, "i");
if (crc32("AdHUf",5) == 3919090879) strcat(s, "g");
if (crc32("PJdwMQVV",8) == 1644281215) strcat(s, "s");
if (crc32("rBlZWKIyGa",10) == 3886712876) strcat(s, "p");
if (crc32("KRdCoAVSrmlM",12) == 724210037) strcat(s, "a");
if (crc32("GrsqjdyP",8) == 4200236127) strcat(s, "t");
if (crc32("unnmVa",6) == 2173536162) strcat(s, "i");
if (crc32("iJCNPSPU",8) == 549435200) strcat(s, "a");
if (crc32("dOinynp",7) == 671596489) strcat(s, "S");
if (crc32("QDsQbYSu",8) == 2274641372) strcat(s, "l");
if (crc32("jWKrrfuqdz",10) == 3564602790) strcat(s, "l");
if (crc32("xlOsfgTtUapQOs",14) == 2646255919) strcat(s, "s");
if (crc32("ygRLN",5) == 914435161) strcat(s, "y");
    return s;
}

char *cleverly_adverbs() {
    char *s = calloc(9);
    if (crc32("ZLpKDFRJCvsAg",13) == 2860701928) strcat(s, "A");
if (crc32("sCMVIMkFlMh",11) == 2967840111) strcat(s, "c");
if (crc32("ZYwmGXaFConOudw",15) == 3532344510) strcat(s, "e");
if (crc32("NXWtPoeeIfr",11) == 250165030) strcat(s, "l");
if (crc32("BqWyrhyf",8) == 516253371) strcat(s, "t");
if (crc32("yopwenntqSwqac",14) == 2234561703) strcat(s, "e");
if (crc32("QeQFYxqxqFRerJ",14) == 3818009142) strcat(s, "v");
if (crc32("JyYzPzBpUmpuiax",15) == 2502595028) strcat(s, "l");
if (crc32("HkhMtSdoy",9) == 1423255843) strcat(s, "e");
if (crc32("XscXnxGNgKC",11) == 1962153824) strcat(s, "X");
if (crc32("lGJbWgXIEw",10) == 1053965408) strcat(s, "r");
if (crc32("XZLVeoCG",8) == 3608293958) strcat(s, "l");
if (crc32("jJNaaqNJ",8) == 3693210603) strcat(s, "B");
if (crc32("JHnniShoz",9) == 3880901983) strcat(s, "y");
    return s;
}

char *permissibly_adverbs() {
    char *s = calloc(12);
    if (crc32("kXsjke",6) == 1552530447) strcat(s, "p");
if (crc32("klyNsrzPzKR",11) == 1626998606) strcat(s, "s");
if (crc32("onPTGSiVmt",10) == 296851028) strcat(s, "e");
if (crc32("ctoeVyD",7) == 2556770599) strcat(s, "o");
if (crc32("WbzILGTAzU",10) == 1333519580) strcat(s, "r");
if (crc32("sKUrGHd",7) == 3169363126) strcat(s, "t");
if (crc32("rgllGFUA",8) == 1383147363) strcat(s, "m");
if (crc32("FTlsRvVcq",9) == 3226900675) strcat(s, "Y");
if (crc32("LYmxFhMjulTPcRL",15) == 1387034258) strcat(s, "i");
if (crc32("qYrgGS",6) == 3538232158) strcat(s, "L");
if (crc32("hekJmdG",7) == 3462504435) strcat(s, "s");
if (crc32("hfrXwKWdCk",10) == 1838504731) strcat(s, "L");
if (crc32("dMEkgLBTHelfE",13) == 4093001923) strcat(s, "s");
if (crc32("jGpAavi",7) == 2123599629) strcat(s, "i");
if (crc32("voYYIUqlmyPw",12) == 3578479646) strcat(s, "b");
if (crc32("NwXFTdewlx",10) == 957600383) strcat(s, "R");
if (crc32("FogiKzbQgNc",11) == 153069122) strcat(s, "l");
if (crc32("zrztBhZZengJM",13) == 3991827188) strcat(s, "r");
if (crc32("dZYENEVlsTn",11) == 894999646) strcat(s, "y");
    return s;
}

char *unflirtatiously_adverbs() {
    char *s = calloc(16);
    if (crc32("VvSqmTZUzCSVZT",14) == 2219896559) strcat(s, "X");
if (crc32("BaJcG",5) == 3169749011) strcat(s, "u");
if (crc32("qGAMneOHFCra",12) == 581535431) strcat(s, "O");
if (crc32("UHJzPecLuEWBuc",14) == 1235265870) strcat(s, "n");
if (crc32("ckcQhXt",7) == 2347559716) strcat(s, "f");
if (crc32("CGGZJNerhpbbzd",14) == 603220792) strcat(s, "O");
if (crc32("EkEWINPCObge",12) == 1614493110) strcat(s, "l");
if (crc32("fwDpDkepyVBYd",13) == 2219644383) strcat(s, "I");
if (crc32("MzCzPDNh",8) == 872523459) strcat(s, "i");
if (crc32("gKxZqq",6) == 1435950353) strcat(s, "r");
if (crc32("zWiqkq",6) == 593417719) strcat(s, "t");
if (crc32("AeCknrJhdZz",11) == 1121814513) strcat(s, "F");
if (crc32("IXqos",5) == 3810705377) strcat(s, "a");
if (crc32("LdntHMCCSLUdgL",14) == 11084463) strcat(s, "u");
if (crc32("zoRtNEkZnCPpSMu",15) == 3456478582) strcat(s, "t");
if (crc32("QifiOHEqJBi",11) == 3856100175) strcat(s, "L");
if (crc32("jIBQQVQWeO",10) == 760093736) strcat(s, "i");
if (crc32("CGXgxcphHuZ",11) == 3124211117) strcat(s, "o");
if (crc32("NXNeSYyT",8) == 633354996) strcat(s, "g");
if (crc32("gMkhIDRBuSmELMJ",15) == 1644162603) strcat(s, "u");
if (crc32("oGgpmsjM",8) == 508157944) strcat(s, "u");
if (crc32("dWsUnCYCZgEEs",13) == 1528019860) strcat(s, "s");
if (crc32("ANwprQ",6) == 1962393833) strcat(s, "q");
if (crc32("reCMObvjCzCczm",14) == 3570902694) strcat(s, "l");
if (crc32("jiaJvd",6) == 170769106) strcat(s, "V");
if (crc32("OSKWjpUger",10) == 303440222) strcat(s, "y");
    return s;
}

char *startingly_adverbs() {
    char *s = calloc(11);
    if (crc32("klEugad",7) == 3703090645) strcat(s, "s");
if (crc32("fehTmnvT",8) == 494564162) strcat(s, "t");
if (crc32("iVoVfW",6) == 1852175587) strcat(s, "B");
if (crc32("TOsmMn",6) == 707137228) strcat(s, "a");
if (crc32("AoosZWBgJ",9) == 2027863355) strcat(s, "A");
if (crc32("yYTixU",6) == 1466068687) strcat(s, "r");
if (crc32("EEDuapEe",8) == 3492460634) strcat(s, "t");
if (crc32("JlxTSM",6) == 3644927424) strcat(s, "D");
if (crc32("MtKWckVWSamr",12) == 2454700607) strcat(s, "i");
if (crc32("hZCbuAUgqiFUe",13) == 3693678737) strcat(s, "t");
if (crc32("wrfwcpIAsww",11) == 4166074592) strcat(s, "n");
if (crc32("nUlVvJYA",8) == 4212283080) strcat(s, "Y");
if (crc32("MlmxNE",6) == 2770658303) strcat(s, "g");
if (crc32("egDNqI",6) == 2512341556) strcat(s, "l");
if (crc32("YUqemRUy",8) == 3252702284) strcat(s, "z");
if (crc32("NcsKzr",6) == 882649885) strcat(s, "y");
    return s;
}

char *noncognizantly_adverbs() {
    char *s = calloc(15);
    if (crc32("IxNeHOPsv",9) == 3720097909) strcat(s, "n");
if (crc32("iUKvTTZCtELec",13) == 1237460472) strcat(s, "K");
if (crc32("PvgGvmAYDTXGhxj",15) == 3895225251) strcat(s, "o");
if (crc32("vCItZoQqe",9) == 2904902083) strcat(s, "M");
if (crc32("cXLgwQZkUbxE",12) == 1827733197) strcat(s, "n");
if (crc32("KxQyteMsDdOwygi",15) == 3387401423) strcat(s, "H");
if (crc32("dGvfuVZKKXbcQu",14) == 1366160182) strcat(s, "c");
if (crc32("fcgcvebvfcjWb",13) == 1042700686) strcat(s, "r");
if (crc32("myLLNsEaOAgDaFl",15) == 3432094906) strcat(s, "o");
if (crc32("JJsbipLqnQT",11) == 1534809772) strcat(s, "g");
if (crc32("DzMWDs",6) == 1379392701) strcat(s, "K");
if (crc32("PAVXtYhAf",9) == 1620371242) strcat(s, "n");
if (crc32("njCtZVJrlzbpi",13) == 3207596455) strcat(s, "J");
if (crc32("LKUiQpMVWOVjJ",13) == 1404385815) strcat(s, "i");
if (crc32("ExsETm",6) == 3982835506) strcat(s, "o");
if (crc32("cdVqESac",8) == 817324208) strcat(s, "z");
if (crc32("obNjbTdxUj",10) == 2927682156) strcat(s, "a");
if (crc32("dtiykuktVwsj",12) == 613784690) strcat(s, "n");
if (crc32("JnVtjjBEH",9) == 1924261938) strcat(s, "r");
if (crc32("cHCATVtcrrFF",12) == 2220986414) strcat(s, "t");
if (crc32("aiSvnDaXx",9) == 3387757908) strcat(s, "x");
if (crc32("yfvaicNwXCT",11) == 4184952635) strcat(s, "l");
if (crc32("ytjUT",5) == 280563404) strcat(s, "f");
if (crc32("ciZKpm",6) == 1875058847) strcat(s, "y");
    return s;
}

char *nonprudentially_adverbs() {
    char *s = calloc(16);
    if (crc32("eFpvdPQjKoWrxWS",15) == 2492993767) strcat(s, "Z");
if (crc32("gPQaYlkfbLe",11) == 3246868057) strcat(s, "n");
if (crc32("uVIIiEuFnVvxz",13) == 2374071838) strcat(s, "o");
if (crc32("YOFyknZQC",9) == 3690348221) strcat(s, "n");
if (crc32("FhNWQiy",7) == 2151505159) strcat(s, "V");
if (crc32("HBfcW",5) == 1748582274) strcat(s, "p");
if (crc32("isIMaIBt",8) == 3688943832) strcat(s, "t");
if (crc32("vwyEXHwLzL",10) == 2227112580) strcat(s, "r");
if (crc32("psqfaNnB",8) == 1489800959) strcat(s, "u");
if (crc32("RkdQlL",6) == 1904100288) strcat(s, "d");
if (crc32("JfNEPVTYQcwkFCY",15) == 1494456474) strcat(s, "e");
if (crc32("OxwcMYQEAzzRgR",14) == 2560859758) strcat(s, "P");
if (crc32("DcjYl",5) == 687854817) strcat(s, "n");
if (crc32("mOyKdHY",7) == 3319076687) strcat(s, "z");
if (crc32("ihIJbQQTYsvSSCv",15) == 3462746158) strcat(s, "t");
if (crc32("dKZWZLWpJKmZeyg",15) == 2338960185) strcat(s, "W");
if (crc32("arHvsn",6) == 1371327657) strcat(s, "i");
if (crc32("hGYVdOrVN",9) == 3410299125) strcat(s, "a");
if (crc32("YgtwzMhZ",8) == 3762368969) strcat(s, "l");
if (crc32("bbFledLtGOPzF",13) == 3638211709) strcat(s, "h");
if (crc32("PffMFskvALIoTK",14) == 435096753) strcat(s, "l");
if (crc32("NsqfKrU",7) == 1019029183) strcat(s, "Z");
if (crc32("GItDyQdkEjw",11) == 4015392920) strcat(s, "y");
    return s;
}

char *mustily_adverbs() {
    char *s = calloc(8);
    if (crc32("WwdGaANVgpYDRw",14) == 1602527191) strcat(s, "d");
if (crc32("hhVMIYlGUBAAEA",14) == 4004966191) strcat(s, "m");
if (crc32("fqUfchKdReI",11) == 1493229695) strcat(s, "u");
if (crc32("MMSlzUsQFQ",10) == 846881703) strcat(s, "H");
if (crc32("jDoMxLmJhuWXhP",14) == 3833446459) strcat(s, "s");
if (crc32("oIKMTrHUlz",10) == 4172485046) strcat(s, "c");
if (crc32("JMGcXq",6) == 2790299482) strcat(s, "t");
if (crc32("DQhFnRQyw",9) == 2269590188) strcat(s, "i");
if (crc32("QtjnIUUb",8) == 2214555536) strcat(s, "l");
if (crc32("CyhcU",5) == 3696442645) strcat(s, "y");
    return s;
}

char *unruinously_adverbs() {
    char *s = calloc(12);
    if (crc32("rGkZhyzgfgOzsAZ",15) == 708706887) strcat(s, "u");
if (crc32("JoMVnBhjQ",9) == 2312171838) strcat(s, "n");
if (crc32("nEkXDKpCtuKLBKy",15) == 2928384520) strcat(s, "o");
if (crc32("dyBRvNUfCfpYUlQ",15) == 3042314081) strcat(s, "r");
if (crc32("BgfUoc",6) == 3666081790) strcat(s, "w");
if (crc32("sMmxo",5) == 1808415398) strcat(s, "u");
if (crc32("DUBewH",6) == 1073632410) strcat(s, "U");
if (crc32("xxYaOSyu",8) == 970740556) strcat(s, "i");
if (crc32("AfclndIh",8) == 880402443) strcat(s, "g");
if (crc32("oLMfUIUXMzNhsit",15) == 1634982438) strcat(s, "n");
if (crc32("mzXpKyBgSiyTSA",14) == 2920228987) strcat(s, "z");
if (crc32("euhqTWxufxmKQrh",15) == 241369227) strcat(s, "o");
if (crc32("FwuYgDubwGQd",12) == 87466077) strcat(s, "u");
if (crc32("Yrzogyxn",8) == 3443195796) strcat(s, "o");
if (crc32("vHSWFQZMAEcJHP",14) == 2047709246) strcat(s, "s");
if (crc32("mMVzJCt",7) == 737066236) strcat(s, "q");
if (crc32("rwOJzyAlGKwjq",13) == 1301678173) strcat(s, "l");
if (crc32("HuRAJWXfRRJ",11) == 949878578) strcat(s, "y");
    return s;
}

char *importantly_adverbs() {
    char *s = calloc(12);
    if (crc32("nsCXsq",6) == 3635944959) strcat(s, "j");
if (crc32("IIusfOgQZ",9) == 563034891) strcat(s, "i");
if (crc32("xykikCilDu",10) == 399947568) strcat(s, "U");
if (crc32("AEwYgNFvQRckWoL",15) == 991560219) strcat(s, "m");
if (crc32("RITkrcYFClBlcyw",15) == 5640988) strcat(s, "p");
if (crc32("LDRVUbjIzRHe",12) == 119891052) strcat(s, "o");
if (crc32("kyFSnh",6) == 2066346849) strcat(s, "p");
if (crc32("NNutkBMpQ",9) == 1984134226) strcat(s, "r");
if (crc32("UBufflOaTNPbWav",15) == 2783773631) strcat(s, "Y");
if (crc32("jSGWa",5) == 1988245925) strcat(s, "t");
if (crc32("rIUWrQQXd",9) == 3414701462) strcat(s, "a");
if (crc32("QDqoLGcj",8) == 3495333697) strcat(s, "n");
if (crc32("OJyRo",5) == 3980633291) strcat(s, "l");
if (crc32("VKaioWGEse",10) == 870421673) strcat(s, "t");
if (crc32("KQjTfq",6) == 4205158903) strcat(s, "l");
if (crc32("onUvGNfRyLwFF",13) == 2009861052) strcat(s, "y");
    return s;
}

char *laxly_adverbs() {
    char *s = calloc(6);
    if (crc32("OKrshcoYnqF",11) == 3295365192) strcat(s, "l");
if (crc32("klGTpeJiumR",11) == 1594289846) strcat(s, "a");
if (crc32("MPGzx",5) == 1162109399) strcat(s, "s");
if (crc32("JEfbYPXHgiGqu",13) == 995202934) strcat(s, "x");
if (crc32("KgolqDn",7) == 3093123681) strcat(s, "P");
if (crc32("xpCSK",5) == 1727748505) strcat(s, "l");
if (crc32("ZLJGr",5) == 427623990) strcat(s, "y");
    return s;
}

char *bardily_adverbs() {
    char *s = calloc(8);
    if (crc32("NfgffL",6) == 881127904) strcat(s, "b");
if (crc32("xleojccLCfuky",13) == 150789578) strcat(s, "y");
if (crc32("CYJVEWukgM",10) == 1606032758) strcat(s, "a");
if (crc32("DRIXZSIwcva",11) == 3824174241) strcat(s, "r");
if (crc32("CulNEbZcqnZwCt",14) == 154043410) strcat(s, "d");
if (crc32("DJZdiahmJdZI",12) == 1425754024) strcat(s, "v");
if (crc32("NVFbcbdlodGX",12) == 2823078426) strcat(s, "i");
if (crc32("mOAXr",5) == 3653643313) strcat(s, "l");
if (crc32("agaWZGI",7) == 2623430114) strcat(s, "x");
if (crc32("uqpEJLryni",10) == 3365339693) strcat(s, "y");
    return s;
}

char *supercolossally_adverbs() {
    char *s = calloc(16);
    if (crc32("ERDAFDM",7) == 4072528081) strcat(s, "Q");
if (crc32("aEgkwQ",6) == 2082000717) strcat(s, "s");
if (crc32("jYKGVVpTUuILhb",14) == 2368858250) strcat(s, "u");
if (crc32("gzbJdngyiU",10) == 536993365) strcat(s, "p");
if (crc32("nTatvpWLdI",10) == 2686031158) strcat(s, "H");
if (crc32("NdcSVdyZTCB",11) == 584263908) strcat(s, "e");
if (crc32("vytJqzqPmz",10) == 538714097) strcat(s, "r");
if (crc32("hpChf",5) == 1157593158) strcat(s, "O");
if (crc32("ZvjKtyBOJGm",11) == 2466460496) strcat(s, "c");
if (crc32("NHZhyyYfrLuNr",13) == 1907746991) strcat(s, "o");
if (crc32("CgNFgGXTIkaVQxo",15) == 1085119776) strcat(s, "c");
if (crc32("FHoastW",7) == 699386218) strcat(s, "l");
if (crc32("gLgDhcTLlNu",11) == 638308743) strcat(s, "o");
if (crc32("XzXfGTZZI",9) == 1459486767) strcat(s, "g");
if (crc32("cTgfJBsMBwe",11) == 1737988689) strcat(s, "s");
if (crc32("mkFvcCsI",8) == 1488139895) strcat(s, "s");
if (crc32("FddoTqbOOPGdP",13) == 1514874349) strcat(s, "a");
if (crc32("Besabc",6) == 292513115) strcat(s, "l");
if (crc32("zQnimDaJr",9) == 1713810825) strcat(s, "l");
if (crc32("JkWGiHqyUr",10) == 3673640232) strcat(s, "C");
if (crc32("umyTPDMBTJDgZ",13) == 2090872268) strcat(s, "y");
    return s;
}

char *passim_adverbs() {
    char *s = calloc(7);
    if (crc32("OdfEGaPgea",10) == 2269830952) strcat(s, "c");
if (crc32("bymOnEn",7) == 1794126873) strcat(s, "p");
if (crc32("mUUNy",5) == 4272399478) strcat(s, "w");
if (crc32("pzDtzYmESjP",11) == 3956847798) strcat(s, "a");
if (crc32("oCluXBoHRVSvm",13) == 2672454544) strcat(s, "s");
if (crc32("mzpttkghP",9) == 3728954432) strcat(s, "e");
if (crc32("LTeLmDTfT",9) == 4011267042) strcat(s, "s");
if (crc32("pgUznRpyGglzjmS",15) == 2961031596) strcat(s, "V");
if (crc32("deWcyTPy",8) == 3388267022) strcat(s, "i");
if (crc32("PojxKZNJQJZ",11) == 743217355) strcat(s, "V");
if (crc32("CAgoQjVQYcd",11) == 3956402287) strcat(s, "m");
    return s;
}

char *greatheartedly_adverbs() {
    char *s = calloc(15);
    if (crc32("KYtrlQUMMVMM",12) == 2853401677) strcat(s, "g");
if (crc32("vcqgjZWOWduHe",13) == 532357633) strcat(s, "u");
if (crc32("uACWegXngPZOIoT",15) == 1781201506) strcat(s, "r");
if (crc32("InhYQZlbgnfhiJ",14) == 2221354112) strcat(s, "e");
if (crc32("CvVaDHBgydjKzr",14) == 1624012336) strcat(s, "a");
if (crc32("iwucLBVrnBeuo",13) == 489681746) strcat(s, "r");
if (crc32("nKzYjMbVUdVEUvL",15) == 4209827637) strcat(s, "t");
if (crc32("xgKWUsvsrtADA",13) == 1973071819) strcat(s, "y");
if (crc32("URsYtxACOC",10) == 3838893413) strcat(s, "h");
if (crc32("sQffvhFhx",9) == 2408427054) strcat(s, "e");
if (crc32("KTelUaWo",8) == 567455520) strcat(s, "z");
if (crc32("YkJUzKdenspkiw",14) == 2341275521) strcat(s, "a");
if (crc32("dlsrENjDvBp",11) == 1101594696) strcat(s, "r");
if (crc32("xdVEtuFgujs",11) == 2716946732) strcat(s, "t");
if (crc32("OeFHMaRBFlatuA",14) == 1110245874) strcat(s, "M");
if (crc32("UUAMarE",7) == 4001726031) strcat(s, "e");
if (crc32("xNZhWhRh",8) == 3507369802) strcat(s, "d");
if (crc32("uVbdWV",6) == 2567611259) strcat(s, "z");
if (crc32("mYqvso",6) == 1783338362) strcat(s, "l");
if (crc32("vAobOiBMePJ",11) == 3147628256) strcat(s, "Y");
if (crc32("LNoMeRIWOFc",11) == 2487959967) strcat(s, "y");
    return s;
}

char *feudally_adverbs() {
    char *s = calloc(9);
    if (crc32("TUbeyogiT",9) == 2350739860) strcat(s, "M");
if (crc32("JAIMepnKBnFn",12) == 3992337453) strcat(s, "f");
if (crc32("VlGaAFN",7) == 1399036568) strcat(s, "W");
if (crc32("jdJfNIzb",8) == 2444077122) strcat(s, "e");
if (crc32("ezBhYzjeiwtrGLo",15) == 755610766) strcat(s, "n");
if (crc32("EkFAfUzn",8) == 983304912) strcat(s, "u");
if (crc32("uToSdvnPbkLK",12) == 3723744650) strcat(s, "d");
if (crc32("MBgCBzUIlhJ",11) == 1713798500) strcat(s, "a");
if (crc32("hYwmSwq",7) == 2777459120) strcat(s, "l");
if (crc32("lhkEqKrZOuJ",11) == 3186330599) strcat(s, "k");
if (crc32("HXvSwJQ",7) == 3795543009) strcat(s, "l");
if (crc32("DGegoG",6) == 734891615) strcat(s, "E");
if (crc32("nKXOIjt",7) == 1600085583) strcat(s, "y");
    return s;
}

char *felinely_adverbs() {
    char *s = calloc(9);
    if (crc32("LYYgkQYfvjFOvl",14) == 4107617547) strcat(s, "f");
if (crc32("BOjMzzfLv",9) == 2488288028) strcat(s, "A");
if (crc32("EEAetBocolEib",13) == 423070950) strcat(s, "e");
if (crc32("DeqWKBOOuR",10) == 3432481547) strcat(s, "l");
if (crc32("VuZDMJProayMsi",14) == 346306568) strcat(s, "i");
if (crc32("XGbyhL",6) == 2743938851) strcat(s, "n");
if (crc32("VQPLYaAl",8) == 2956118172) strcat(s, "e");
if (crc32("AYEWjIqvf",9) == 3536156348) strcat(s, "e");
if (crc32("dQaugEi",7) == 688709008) strcat(s, "l");
if (crc32("DVqpkr",6) == 757653095) strcat(s, "y");
    return s;
}

char *unvoluptuously_adverbs() {
    char *s = calloc(15);
    if (crc32("BBkRDtzHyrHplT",14) == 4124368771) strcat(s, "f");
if (crc32("vkctef",6) == 1147914957) strcat(s, "u");
if (crc32("ueemZvjH",8) == 1918812001) strcat(s, "n");
if (crc32("NEzPd",5) == 1017275431) strcat(s, "i");
if (crc32("rvjDXsUBMWKEKqp",15) == 1296291206) strcat(s, "v");
if (crc32("JWnJFAkYJV",10) == 1586111859) strcat(s, "r");
if (crc32("oFdfObKqKps",11) == 3173507920) strcat(s, "o");
if (crc32("OYZGiD",6) == 1485713828) strcat(s, "j");
if (crc32("QYNIyT",6) == 3580369240) strcat(s, "l");
if (crc32("kIanbJH",7) == 2136968737) strcat(s, "p");
if (crc32("OZrWUzg",7) == 998505495) strcat(s, "u");
if (crc32("tRwBw",5) == 1694497462) strcat(s, "d");
if (crc32("DXVaEVaSHz",10) == 2383375814) strcat(s, "p");
if (crc32("pqDSsEOncVRs",12) == 2840064342) strcat(s, "d");
if (crc32("HAjXdQCBXGjpiFJ",15) == 4148568664) strcat(s, "t");
if (crc32("rXPZJWG",7) == 4205486941) strcat(s, "u");
if (crc32("GSNlAFmssgnNDik",15) == 1909594222) strcat(s, "K");
if (crc32("CueyKWpXV",9) == 3446120029) strcat(s, "o");
if (crc32("QrBsj",5) == 596860129) strcat(s, "C");
if (crc32("yHtSXPUh",8) == 2826558854) strcat(s, "u");
if (crc32("bVGXhSmtQ",9) == 24027011) strcat(s, "s");
if (crc32("jlzgRYRu",8) == 1128245250) strcat(s, "l");
if (crc32("etqlTpdVqNyKNcg",15) == 2481176794) strcat(s, "y");
    return s;
}

char *demonstrably_adverbs() {
    char *s = calloc(13);
    if (crc32("PKGJYCGXWj",10) == 3445208536) strcat(s, "d");
if (crc32("amVVEuvdSSftWIr",15) == 3850292934) strcat(s, "B");
if (crc32("yYcXOdphdrI",11) == 863359817) strcat(s, "e");
if (crc32("NWFzHFaJpAaX",12) == 3355144601) strcat(s, "g");
if (crc32("oSlrxxeoRCnwK",13) == 3653852945) strcat(s, "m");
if (crc32("gNlFJrZdiiaHbZe",15) == 1202171249) strcat(s, "o");
if (crc32("uYbRqqskCWlVksq",15) == 3548103084) strcat(s, "j");
if (crc32("riMektMmyOGosXq",15) == 4094269800) strcat(s, "n");
if (crc32("oYWGuZnbDJ",10) == 2319629580) strcat(s, "L");
if (crc32("YxlGZ",5) == 685867448) strcat(s, "s");
if (crc32("UXuEfwZ",7) == 910078989) strcat(s, "t");
if (crc32("pefaMJjPJtiwjH",14) == 1848610884) strcat(s, "r");
if (crc32("gDYaI",5) == 3922535879) strcat(s, "a");
if (crc32("CBAMHrT",7) == 2842998789) strcat(s, "b");
if (crc32("hzMBAGbbIaIEIds",15) == 967806085) strcat(s, "Q");
if (crc32("TewwByJlNiZ",11) == 2146836015) strcat(s, "l");
if (crc32("wMcarF",6) == 456042849) strcat(s, "i");
if (crc32("BCLHeBfqqSbg",12) == 1628410790) strcat(s, "y");
    return s;
}

char *nonoriginally_adverbs() {
    char *s = calloc(14);
    if (crc32("FTTNvjqXuJ",10) == 2478274236) strcat(s, "q");
if (crc32("ZxZxz",5) == 739731646) strcat(s, "n");
if (crc32("OiyzfTxkPtNEkqH",15) == 2761768557) strcat(s, "o");
if (crc32("PtINn",5) == 3947001060) strcat(s, "h");
if (crc32("tpjfcaLUqxMm",12) == 1333721753) strcat(s, "n");
if (crc32("mnImtq",6) == 2723070061) strcat(s, "f");
if (crc32("wEuIIhj",7) == 1125125546) strcat(s, "o");
if (crc32("carfqKwHzooj",12) == 1859157465) strcat(s, "N");
if (crc32("FEeIvJpUvbkrCjP",15) == 1430348861) strcat(s, "r");
if (crc32("KsejX",5) == 3795530652) strcat(s, "b");
if (crc32("AHDnmhyWoYYyzrm",15) == 852546300) strcat(s, "i");
if (crc32("natIFYpWoWTNQox",15) == 1637835998) strcat(s, "g");
if (crc32("KRgFAMiC",8) == 1958823748) strcat(s, "O");
if (crc32("GujFlLwAvAbYTM",14) == 2231918306) strcat(s, "i");
if (crc32("QdNUudT",7) == 2937518204) strcat(s, "n");
if (crc32("XSaQYbvUHTBy",12) == 1589207588) strcat(s, "a");
if (crc32("frUOOdiL",8) == 3377272649) strcat(s, "l");
if (crc32("TTnfpA",6) == 1376369947) strcat(s, "l");
if (crc32("HjfhY",5) == 3669730983) strcat(s, "U");
if (crc32("kaoSeO",6) == 2230695064) strcat(s, "y");
    return s;
}

char *hermetically_adverbs() {
    char *s = calloc(13);
    if (crc32("AcegPnsRP",9) == 3946844098) strcat(s, "h");
if (crc32("csVBAIPOOHic",12) == 2726534658) strcat(s, "o");
if (crc32("SxCuvYwwjkIG",12) == 3822444816) strcat(s, "e");
if (crc32("xaDfuMh",7) == 4074516542) strcat(s, "j");
if (crc32("ekouNtmDdGTbA",13) == 2165483021) strcat(s, "r");
if (crc32("XfuuYkNFNZhsuI",14) == 1778664137) strcat(s, "m");
if (crc32("uhmPBHZIOwM",11) == 1765649025) strcat(s, "e");
if (crc32("UoEWNGlxzrXwWH",14) == 1002926047) strcat(s, "t");
if (crc32("IhcGe",5) == 2109902512) strcat(s, "a");
if (crc32("lucSk",5) == 3345415873) strcat(s, "i");
if (crc32("floKXKoiiMVmLGY",15) == 1703948467) strcat(s, "o");
if (crc32("bIBZH",5) == 2290213205) strcat(s, "c");
if (crc32("wLbOxlQ",7) == 418031423) strcat(s, "N");
if (crc32("SRPEutQtvmjwyI",14) == 216411750) strcat(s, "a");
if (crc32("oCDgmjXKkZI",11) == 2295899676) strcat(s, "l");
if (crc32("dMLhVc",6) == 3206775262) strcat(s, "X");
if (crc32("woPjWbHSk",9) == 3755576130) strcat(s, "l");
if (crc32("tMjCxXcNnviW",12) == 2754080489) strcat(s, "w");
if (crc32("HsGAVhM",7) == 1664986766) strcat(s, "y");
    return s;
}

char *inspiredly_adverbs() {
    char *s = calloc(11);
    if (crc32("rIRLkejJlv",10) == 3782136312) strcat(s, "y");
if (crc32("blBodo",6) == 104225663) strcat(s, "i");
if (crc32("zJahlLFwxfaKR",13) == 4218081845) strcat(s, "n");
if (crc32("YrTkFgVis",9) == 2901180754) strcat(s, "z");
if (crc32("gsReXbZzYB",10) == 3661657536) strcat(s, "s");
if (crc32("wmotdiPto",9) == 1244865350) strcat(s, "u");
if (crc32("ODpkH",5) == 2718491761) strcat(s, "p");
if (crc32("yvJxqsadpaO",11) == 3650161793) strcat(s, "r");
if (crc32("TlZNZwguqOeOy",13) == 2995464106) strcat(s, "i");
if (crc32("MnItvz",6) == 932370107) strcat(s, "g");
if (crc32("EODmIG",6) == 2844672642) strcat(s, "r");
if (crc32("VRIxMAuPMKWy",12) == 1528760899) strcat(s, "e");
if (crc32("yYVxMZVBMPxCA",13) == 3315160891) strcat(s, "f");
if (crc32("SKWsYdeS",8) == 1145902311) strcat(s, "d");
if (crc32("StowbnHHQXUk",12) == 762159750) strcat(s, "O");
if (crc32("osaVJdKQxrtZva",14) == 4105646395) strcat(s, "l");
if (crc32("vLUWVm",6) == 849770147) strcat(s, "j");
if (crc32("FvdQiRmtMScoNHs",15) == 3457954824) strcat(s, "y");
    return s;
}

char *unbreachably_adverbs() {
    char *s = calloc(13);
    if (crc32("ajzRWM",6) == 3937248936) strcat(s, "l");
if (crc32("OOWviwSTFAdNSIj",15) == 1379717124) strcat(s, "u");
if (crc32("uYqTKGro",8) == 3287709778) strcat(s, "n");
if (crc32("vPshSADrQZzSaE",14) == 2615969526) strcat(s, "b");
if (crc32("QEkLCTGk",8) == 3884812256) strcat(s, "f");
if (crc32("vLJSgwUREecBqfi",15) == 3855464298) strcat(s, "r");
if (crc32("HqmfNo",6) == 1756617189) strcat(s, "K");
if (crc32("bOZgNOnWMiDYU",13) == 1196416663) strcat(s, "e");
if (crc32("wGJMM",5) == 3148132149) strcat(s, "a");
if (crc32("VUZWoZ",6) == 1065226883) strcat(s, "c");
if (crc32("YFfXpwphDlaP",12) == 2487245379) strcat(s, "h");
if (crc32("MZNiNMOSR",9) == 1544623397) strcat(s, "m");
if (crc32("ANLedSbVnJrz",12) == 2038558461) strcat(s, "a");
if (crc32("uRQxCThSQb",10) == 1030623459) strcat(s, "b");
if (crc32("mPTEjEBLOuZBaaj",15) == 3275983433) strcat(s, "B");
if (crc32("rUWbh",5) == 3300025176) strcat(s, "l");
if (crc32("nfTxXgwq",8) == 314941859) strcat(s, "y");
    return s;
}

char *unhysterically_adverbs() {
    char *s = calloc(15);
    if (crc32("GVsLIpCUMWYDcy",14) == 1605459654) strcat(s, "L");
if (crc32("GRlAs",5) == 743889131) strcat(s, "u");
if (crc32("IdChzmZUUgVq",12) == 3375538077) strcat(s, "Z");
if (crc32("dPCLvO",6) == 1972576802) strcat(s, "n");
if (crc32("PzgyctYdMWbWQ",13) == 1381213635) strcat(s, "i");
if (crc32("VdKZzUOxz",9) == 1001926366) strcat(s, "h");
if (crc32("JMTAvhnjJMKaif",14) == 2099948095) strcat(s, "y");
if (crc32("HexTKtQJB",9) == 926880020) strcat(s, "o");
if (crc32("ChnwpQjTFXqw",12) == 3829968040) strcat(s, "s");
if (crc32("jERZP",5) == 17467653) strcat(s, "i");
if (crc32("AaMIi",5) == 1304176033) strcat(s, "t");
if (crc32("FApSVwnd",8) == 306454487) strcat(s, "e");
if (crc32("PNABOQEw",8) == 1561394822) strcat(s, "u");
if (crc32("ZdKbLEWq",8) == 758883460) strcat(s, "r");
if (crc32("sbrHVs",6) == 1171559642) strcat(s, "i");
if (crc32("dZnTLqkccr",10) == 608458462) strcat(s, "c");
if (crc32("SEUXdcFBcM",10) == 4061771709) strcat(s, "j");
if (crc32("HAzLWfMxsKni",12) == 2214979382) strcat(s, "a");
if (crc32("OIpGLNKkRph",11) == 1493987449) strcat(s, "u");
if (crc32("xCpFGAANQTr",11) == 334018120) strcat(s, "l");
if (crc32("uKZajZUdutyk",12) == 724669075) strcat(s, "m");
if (crc32("RDlIDFbvw",9) == 2623541429) strcat(s, "l");
if (crc32("iTjZnXQwJQp",11) == 2623467612) strcat(s, "K");
if (crc32("yLpyCLLSRRC",11) == 1752176143) strcat(s, "y");
    return s;
}

char *lobately_adverbs() {
    char *s = calloc(9);
    if (crc32("CtptvM",6) == 791575686) strcat(s, "q");
if (crc32("zzhhFc",6) == 1658317439) strcat(s, "l");
if (crc32("irokPQoVGVXQqOe",15) == 2073588604) strcat(s, "F");
if (crc32("mHStLphQmCDdcC",14) == 2870061773) strcat(s, "o");
if (crc32("oWlFDNxKCVBdN",13) == 3271222197) strcat(s, "Y");
if (crc32("DMdsXZlWoHZCQ",13) == 2464122034) strcat(s, "b");
if (crc32("HaafuXZmhyXRaK",14) == 1623822522) strcat(s, "a");
if (crc32("eEwOnsrZitfL",12) == 204898541) strcat(s, "t");
if (crc32("YWlceGwzjS",10) == 2856165979) strcat(s, "i");
if (crc32("omOaQHhFbxc",11) == 2554510620) strcat(s, "e");
if (crc32("dYVPdcpIsqKR",12) == 473796922) strcat(s, "O");
if (crc32("czyuvFhWMVEcG",13) == 3164249903) strcat(s, "l");
if (crc32("oTLlyTLeRI",10) == 3367283205) strcat(s, "t");
if (crc32("DwEtaZVeXyEiPkz",15) == 2306393474) strcat(s, "y");
    return s;
}

char *appreciatingly_adverbs() {
    char *s = calloc(15);
    if (crc32("KFrueawMAzS",11) == 205767367) strcat(s, "s");
if (crc32("wQhfKLoJprPJC",13) == 420505540) strcat(s, "a");
if (crc32("OORuNPfb",8) == 3984629093) strcat(s, "l");
if (crc32("kIYzYXqtrk",10) == 3728555201) strcat(s, "p");
if (crc32("CnrlrKAhSXyDzIQ",15) == 2026761651) strcat(s, "P");
if (crc32("BTutFcSJzJZj",12) == 2341228406) strcat(s, "p");
if (crc32("oRNJN",5) == 1571994490) strcat(s, "r");
if (crc32("qbqqO",5) == 382408507) strcat(s, "e");
if (crc32("UVRARYr",7) == 3982974372) strcat(s, "c");
if (crc32("RNGzIRgldkI",11) == 1647565471) strcat(s, "X");
if (crc32("HHaSotNBPEzHHs",14) == 1667536618) strcat(s, "i");
if (crc32("ymzdKzEvUFjPLs",14) == 958968508) strcat(s, "a");
if (crc32("rxPiuhpvsWoi",12) == 1505412878) strcat(s, "t");
if (crc32("GRjkTEcj",8) == 312766830) strcat(s, "J");
if (crc32("YiAUPJu",7) == 3688869741) strcat(s, "i");
if (crc32("MhobBImU",8) == 4038526237) strcat(s, "n");
if (crc32("giSFQGrRcmVyzlp",15) == 213291210) strcat(s, "E");
if (crc32("KGrEeBZRdF",10) == 3905551362) strcat(s, "g");
if (crc32("zTtjl",5) == 336962456) strcat(s, "E");
if (crc32("vMnpLLSl",8) == 2621271527) strcat(s, "l");
if (crc32("npTyJO",6) == 3984155141) strcat(s, "D");
if (crc32("zInTOy",6) == 2699831602) strcat(s, "y");
    return s;
}

char *quasigraciously_adverbs() {
    char *s = calloc(16);
    if (crc32("MQmDobvhZqCDrj",14) == 2221725771) strcat(s, "q");
if (crc32("LzZBHKRAJmZBCW",14) == 3781320303) strcat(s, "P");
if (crc32("jkbUdACn",8) == 2889171669) strcat(s, "u");
if (crc32("EejCQUW",7) == 1841605753) strcat(s, "W");
if (crc32("xjhBockNblxV",12) == 1523935217) strcat(s, "a");
if (crc32("nlOQt",5) == 3418345696) strcat(s, "M");
if (crc32("nzDrZwVL",8) == 2567274282) strcat(s, "s");
if (crc32("XPTEZJbFNKiDt",13) == 1708576063) strcat(s, "i");
if (crc32("hBTtNDNJi",9) == 2590672650) strcat(s, "g");
if (crc32("GBTFJwjYOBD",11) == 1573501605) strcat(s, "e");
if (crc32("bBESgCokLZjp",12) == 3316098790) strcat(s, "r");
if (crc32("THRWgwpnvEMjV",13) == 1949515077) strcat(s, "a");
if (crc32("yuZEGBN",7) == 172263891) strcat(s, "P");
if (crc32("yqbXH",5) == 2689971178) strcat(s, "c");
if (crc32("MSguKd",6) == 3233113866) strcat(s, "Z");
if (crc32("FeoqPUOjCFmUYmn",15) == 4007979298) strcat(s, "i");
if (crc32("XHYhRBUVipWns",13) == 2481696277) strcat(s, "o");
if (crc32("QCSrUMRKXRxTcU",14) == 2505913554) strcat(s, "u");
if (crc32("RSTrsQzWsRm",11) == 3265810912) strcat(s, "H");
if (crc32("iYuThr",6) == 2403431926) strcat(s, "s");
if (crc32("xdGZcuaJyJC",11) == 2253844292) strcat(s, "l");
if (crc32("doBJJaQmdcRkx",13) == 146791827) strcat(s, "y");
    return s;
}

char *descriptively_adverbs() {
    char *s = calloc(14);
    if (crc32("DjnmUZecLJPvf",13) == 3857827605) strcat(s, "d");
if (crc32("zCopogd",7) == 3228994330) strcat(s, "H");
if (crc32("LxSXtaDDNZ",10) == 1436851293) strcat(s, "e");
if (crc32("MCpVsgJWPuYwl",13) == 3053935379) strcat(s, "m");
if (crc32("AbLcYkA",7) == 1778594834) strcat(s, "s");
if (crc32("KfjlZoz",7) == 1965292932) strcat(s, "F");
if (crc32("lkfvo",5) == 2666858616) strcat(s, "c");
if (crc32("KITxXCE",7) == 759047774) strcat(s, "I");
if (crc32("zrEdhH",6) == 2925453141) strcat(s, "r");
if (crc32("LPmHJYBCrwKcZZa",15) == 1448927507) strcat(s, "i");
if (crc32("SzgCGaxNgLN",11) == 2231211208) strcat(s, "p");
if (crc32("HeXOxFrXsaUkXop",15) == 44607381) strcat(s, "a");
if (crc32("DlqJeRSKNLldWlz",15) == 3141766397) strcat(s, "t");
if (crc32("IePSBqGigu",10) == 503188219) strcat(s, "i");
if (crc32("dwAPoTmxON",10) == 683455563) strcat(s, "v");
if (crc32("XDkBXKSI",8) == 2165668950) strcat(s, "j");
if (crc32("LQyhgWzjfDnedT",14) == 2179805385) strcat(s, "e");
if (crc32("DOZrrMnXUoVHFc",14) == 1768005756) strcat(s, "J");
if (crc32("IgDhkKTdMBtk",12) == 1684641725) strcat(s, "l");
if (crc32("ZnrPid",6) == 862793390) strcat(s, "P");
if (crc32("DHJDFfTq",8) == 3075577450) strcat(s, "y");
    return s;
}

char *altogether_adverbs() {
    char *s = calloc(11);
    if (crc32("VExnth",6) == 536782513) strcat(s, "a");
if (crc32("toQZeBF",7) == 3019073944) strcat(s, "L");
if (crc32("HnSoLJPfka",10) == 220425296) strcat(s, "l");
if (crc32("xEVLHJNIG",9) == 3686630420) strcat(s, "t");
if (crc32("fmaTgpU",7) == 1492876549) strcat(s, "o");
if (crc32("RuKSOUC",7) == 3616342336) strcat(s, "g");
if (crc32("VfIPKFmBriJm",12) == 2190898683) strcat(s, "z");
if (crc32("aVIyjjF",7) == 1816366997) strcat(s, "e");
if (crc32("iOdncBdMI",9) == 1106625383) strcat(s, "t");
if (crc32("dFOhLWikHgtSZ",13) == 85597015) strcat(s, "h");
if (crc32("DaEJqmfYwlBD",12) == 1445934091) strcat(s, "R");
if (crc32("YjYHhNzeaGlfvZ",14) == 2003294795) strcat(s, "e");
if (crc32("SpBAYH",6) == 203971236) strcat(s, "b");
if (crc32("AaPegX",6) == 461964376) strcat(s, "r");
    return s;
}

char *insusceptibly_adverbs() {
    char *s = calloc(14);
    if (crc32("uNHreCJleL",10) == 4057678417) strcat(s, "i");
if (crc32("uPVKynHuHjN",11) == 667591780) strcat(s, "n");
if (crc32("GQzBLA",6) == 2355565909) strcat(s, "s");
if (crc32("xNwQCFXhfiAd",12) == 2859281959) strcat(s, "z");
if (crc32("WUqelcBDqoMfeFo",15) == 3011272842) strcat(s, "u");
if (crc32("NeIFGHnE",8) == 4208842099) strcat(s, "s");
if (crc32("fXeowIqZXWgpTPJ",15) == 3054974925) strcat(s, "H");
if (crc32("wdOVQZh",7) == 2101410626) strcat(s, "c");
if (crc32("iHKTbOtISb",10) == 1056709474) strcat(s, "e");
if (crc32("KWHQwCR",7) == 248569762) strcat(s, "R");
if (crc32("enEDs",5) == 1732340412) strcat(s, "p");
if (crc32("IpPbJzyXbTmGTx",14) == 1455965527) strcat(s, "m");
if (crc32("pJhQWkLJyD",10) == 70904780) strcat(s, "t");
if (crc32("QfkXzSHkwAL",11) == 3618352041) strcat(s, "i");
if (crc32("PUdJhGwsArt",11) == 1452502292) strcat(s, "b");
if (crc32("epfaBNwwJlB",11) == 3778912905) strcat(s, "D");
if (crc32("sVGwc",5) == 1462139370) strcat(s, "l");
if (crc32("uxGsvTYqBTDQZ",13) == 1976769460) strcat(s, "y");
    return s;
}

char *submaniacally_adverbs() {
    char *s = calloc(14);
    if (crc32("mNqgMS",6) == 3819197903) strcat(s, "R");
if (crc32("zgCXTuxyse",10) == 3884429956) strcat(s, "s");
if (crc32("yXXQuCnCwvhKNFT",15) == 1603227471) strcat(s, "Q");
if (crc32("EJWbuSWFMNq",11) == 4030837772) strcat(s, "u");
if (crc32("hMDQipsPXP",10) == 4228185985) strcat(s, "b");
if (crc32("BcosQIUHIdz",11) == 3017441207) strcat(s, "m");
if (crc32("MtPrspHURO",10) == 621618309) strcat(s, "a");
if (crc32("aimMkSiZm",9) == 1619489042) strcat(s, "U");
if (crc32("nOCEUPPTYTzX",12) == 2354091436) strcat(s, "n");
if (crc32("TJbRX",5) == 636409157) strcat(s, "Z");
if (crc32("usUcHgCPHw",10) == 1184475597) strcat(s, "i");
if (crc32("SVFnVRxsN",9) == 168698073) strcat(s, "r");
if (crc32("JIcfONSoXs",10) == 2528186846) strcat(s, "a");
if (crc32("wNeKNCKQ",8) == 1899649796) strcat(s, "b");
if (crc32("QiWOvOSNa",9) == 3685247779) strcat(s, "c");
if (crc32("fKllbHrUdjc",11) == 205233989) strcat(s, "a");
if (crc32("JgrnfxzrhJ",10) == 3979108938) strcat(s, "w");
if (crc32("dZbVcOL",7) == 967490) strcat(s, "l");
if (crc32("eTURW",5) == 3431525078) strcat(s, "I");
if (crc32("RTKoFpdzwPflL",13) == 574972974) strcat(s, "l");
if (crc32("jZBcwW",6) == 4284654931) strcat(s, "f");
if (crc32("nIHiiXIdtUxnx",13) == 753162023) strcat(s, "y");
    return s;
}

char *dialytically_adverbs() {
    char *s = calloc(13);
    if (crc32("wLARbKp",7) == 3228939680) strcat(s, "d");
if (crc32("LkyOhn",6) == 196904026) strcat(s, "Z");
if (crc32("JLkogK",6) == 3860636806) strcat(s, "i");
if (crc32("wVSsraEgwIGIfLY",15) == 2505513557) strcat(s, "E");
if (crc32("brpkYBMTHnijFp",14) == 3510229362) strcat(s, "a");
if (crc32("eCqSLqXtuEpQM",13) == 2362150261) strcat(s, "l");
if (crc32("HkxzJCnSGaLG",12) == 2767717479) strcat(s, "G");
if (crc32("efpcS",5) == 1644099461) strcat(s, "y");
if (crc32("bToxp",5) == 1716949487) strcat(s, "E");
if (crc32("ZkbIdzgHJeN",11) == 3368541586) strcat(s, "t");
if (crc32("hElby",5) == 1192259175) strcat(s, "e");
if (crc32("HKOmoHFaA",9) == 3178576066) strcat(s, "i");
if (crc32("tVhRielqX",9) == 2878563952) strcat(s, "c");
if (crc32("JoIssVuy",8) == 954063443) strcat(s, "G");
if (crc32("NEeRrEwWslGdGgD",15) == 836248974) strcat(s, "a");
if (crc32("LRZAqwB",7) == 2736082007) strcat(s, "l");
if (crc32("TPwbfOm",7) == 2484986055) strcat(s, "l");
if (crc32("iRaaKjpHONexex",14) == 3863231510) strcat(s, "N");
if (crc32("ECkxYg",6) == 4285416425) strcat(s, "y");
    return s;
}

char *boilingly_adverbs() {
    char *s = calloc(10);
    if (crc32("HjLSrBN",7) == 50471030) strcat(s, "b");
if (crc32("wllfigfwgSXxLaM",15) == 2719189703) strcat(s, "H");
if (crc32("zXMwpLb",7) == 3366172273) strcat(s, "o");
if (crc32("SfIaSEBHVgJyt",13) == 813452231) strcat(s, "i");
if (crc32("nuNtTS",6) == 3062421418) strcat(s, "l");
if (crc32("EryfoXcAGE",10) == 3303281914) strcat(s, "n");
if (crc32("ZKByXbKI",8) == 150826948) strcat(s, "i");
if (crc32("QgbzQQgviTctT",13) == 2203627502) strcat(s, "j");
if (crc32("TqVleUdPx",9) == 2428782205) strcat(s, "n");
if (crc32("pgVhsbsKoTI",11) == 1549775705) strcat(s, "g");
if (crc32("LSTYmO",6) == 2816023182) strcat(s, "l");
if (crc32("nIztZPOBEMSkzpH",15) == 553752230) strcat(s, "m");
if (crc32("BvuRxjWpqgAa",12) == 137897028) strcat(s, "y");
    return s;
}

char *anticatalytically_adverbs() {
    char *s = calloc(18);
    if (crc32("JRKqTw",6) == 1413658006) strcat(s, "a");
if (crc32("zWAEp",5) == 2412320227) strcat(s, "n");
if (crc32("FNtGMfKAEY",10) == 3364413981) strcat(s, "t");
if (crc32("SUlTLsKxYJJMocJ",15) == 1511313751) strcat(s, "i");
if (crc32("tvUsheKLQIaarC",14) == 661271189) strcat(s, "d");
if (crc32("nKseXMfcIxv",11) == 3817624720) strcat(s, "c");
if (crc32("kPdijnyaDUg",11) == 397337941) strcat(s, "t");
if (crc32("XHAdSZJN",8) == 533906546) strcat(s, "a");
if (crc32("akgRKsvmpbE",11) == 3843996178) strcat(s, "D");
if (crc32("TyluHvmVtCae",12) == 292452555) strcat(s, "t");
if (crc32("vZbnPoyMqhFNVr",14) == 1705535220) strcat(s, "a");
if (crc32("pklHbdHjdhoGYOk",15) == 1373400515) strcat(s, "o");
if (crc32("xDggmhyJqbMEH",13) == 938803935) strcat(s, "l");
if (crc32("xmMkrigXTKTNkbx",15) == 4210538015) strcat(s, "y");
if (crc32("jZWRQgSBHjG",11) == 1820275632) strcat(s, "z");
if (crc32("mvntGt",6) == 325813267) strcat(s, "t");
if (crc32("DpSKFjPAldDDO",13) == 4063072030) strcat(s, "q");
if (crc32("gvLkUXohzkyDSy",14) == 3736301427) strcat(s, "i");
if (crc32("JJiWmm",6) == 3251585266) strcat(s, "c");
if (crc32("dUJqpKnUHSmTs",13) == 2918945896) strcat(s, "a");
if (crc32("ffMLUGTrN",9) == 2472168098) strcat(s, "l");
if (crc32("jZZEfXCSCUbYB",13) == 36503765) strcat(s, "l");
if (crc32("zPgBRlWC",8) == 1510844813) strcat(s, "g");
if (crc32("SotKFSS",7) == 559413059) strcat(s, "y");
    return s;
}

char *nonactionably_adverbs() {
    char *s = calloc(14);
    if (crc32("vRXUuytYPDyGKP",14) == 603848471) strcat(s, "r");
if (crc32("qruAhMqAyYXJo",13) == 1923219145) strcat(s, "n");
if (crc32("VBmcMxMM",8) == 824304908) strcat(s, "o");
if (crc32("dLKlrUvA",8) == 1485448700) strcat(s, "n");
if (crc32("ctvUXOslSdtV",12) == 330902339) strcat(s, "a");
if (crc32("haUyu",5) == 1478488224) strcat(s, "c");
if (crc32("JLLDE",5) == 3671392927) strcat(s, "f");
if (crc32("BWzLLJwptvBETPx",15) == 3951554748) strcat(s, "t");
if (crc32("ZXEsaFxyoC",10) == 3570095710) strcat(s, "i");
if (crc32("lNznxqBPk",9) == 1787161119) strcat(s, "U");
if (crc32("UxpZDhPjQrI",11) == 4104751883) strcat(s, "o");
if (crc32("nIFEgSv",7) == 1889776063) strcat(s, "n");
if (crc32("nTyhTBzYUP",10) == 1983391772) strcat(s, "a");
if (crc32("OSCjZYFTxBGa",12) == 3196026738) strcat(s, "K");
if (crc32("tRFVWoFCyO",10) == 833569174) strcat(s, "b");
if (crc32("tCgwBJacLKwzJVG",15) == 1015503548) strcat(s, "M");
if (crc32("pRoHBwB",7) == 4264730820) strcat(s, "l");
if (crc32("jAnjFaKHqQ",10) == 1953333079) strcat(s, "P");
if (crc32("vvtnGzdc",8) == 3164288983) strcat(s, "y");
    return s;
}

char *inoffensively_adverbs() {
    char *s = calloc(14);
    if (crc32("ApGrMkcaKe",10) == 688482502) strcat(s, "i");
if (crc32("LzOXyYAWUIpx",12) == 2225581421) strcat(s, "I");
if (crc32("gcUVqYOUWNVMIqs",15) == 3533525367) strcat(s, "n");
if (crc32("RgNUBaCPab",10) == 395068932) strcat(s, "r");
if (crc32("iashR",5) == 2943120697) strcat(s, "o");
if (crc32("azoVmYv",7) == 2097179661) strcat(s, "f");
if (crc32("pQMwkspcxMPYZ",13) == 3316986602) strcat(s, "s");
if (crc32("keLObqmnWM",10) == 3876903244) strcat(s, "f");
if (crc32("vaLeBFkl",8) == 877745854) strcat(s, "a");
if (crc32("OOdvVnRuEGaDBwt",15) == 1287867227) strcat(s, "e");
if (crc32("EtVONpGxyfK",11) == 269009207) strcat(s, "n");
if (crc32("cIZVaHHOeFR",11) == 3511152176) strcat(s, "h");
if (crc32("AEPMKgvjyp",10) == 2641163800) strcat(s, "s");
if (crc32("kyUuPDhGE",9) == 2056875099) strcat(s, "l");
if (crc32("jHheEIkllWG",11) == 3604518686) strcat(s, "i");
if (crc32("SyYecMxsRhoRtc",14) == 2027125166) strcat(s, "l");
if (crc32("oLpyu",5) == 2262949720) strcat(s, "v");
if (crc32("pNAclSGgx",9) == 3573084350) strcat(s, "k");
if (crc32("zVBvkY",6) == 1509386759) strcat(s, "e");
if (crc32("fhEMICnWl",9) == 1082055107) strcat(s, "l");
if (crc32("rvHpiBnlbEGE",12) == 686477343) strcat(s, "S");
if (crc32("nnEOZoA",7) == 2783622326) strcat(s, "y");
    return s;
}

char *snatchingly_adverbs() {
    char *s = calloc(12);
    if (crc32("RdjGGzR",7) == 3422696691) strcat(s, "X");
if (crc32("hTEWmsHsL",9) == 3401576391) strcat(s, "s");
if (crc32("gxfqnCuPZlwCcdH",15) == 1342542652) strcat(s, "C");
if (crc32("ChNILvqEZ",9) == 3199176231) strcat(s, "n");
if (crc32("UGrKPngeaIPkUA",14) == 2319763166) strcat(s, "V");
if (crc32("TkXeMKEZxHb",11) == 1853392644) strcat(s, "a");
if (crc32("zcsQYh",6) == 2481923281) strcat(s, "a");
if (crc32("aVxvhPN",7) == 2157415632) strcat(s, "t");
if (crc32("PYewceiI",8) == 1228036609) strcat(s, "c");
if (crc32("SvwlmAkrT",9) == 3868718706) strcat(s, "h");
if (crc32("iQwPnYarqpaEku",14) == 585968681) strcat(s, "F");
if (crc32("qWLQQPIC",8) == 1327503139) strcat(s, "i");
if (crc32("gYdGbpjIebNG",12) == 2653399892) strcat(s, "G");
if (crc32("wWSlXuZJSXw",11) == 887837777) strcat(s, "n");
if (crc32("HQQNM",5) == 4140820859) strcat(s, "z");
if (crc32("MuczqwTyWZEdr",13) == 1020491756) strcat(s, "g");
if (crc32("bYEKOpQTND",10) == 3482056643) strcat(s, "l");
if (crc32("cgBkUiflIRsVJB",14) == 3778993970) strcat(s, "y");
    return s;
}

char *intently_adverbs() {
    char *s = calloc(9);
    if (crc32("twjnR",5) == 130224432) strcat(s, "i");
if (crc32("QWLKmfbnGrm",11) == 3263641758) strcat(s, "f");
if (crc32("WDHvaFQOmvh",11) == 3940649152) strcat(s, "n");
if (crc32("dGTLph",6) == 2580354171) strcat(s, "t");
if (crc32("VxleRQhMLeM",11) == 31173981) strcat(s, "h");
if (crc32("clrRxp",6) == 2056082960) strcat(s, "e");
if (crc32("bZcshUiIDa",10) == 681952246) strcat(s, "Z");
if (crc32("kQGBBdScZC",10) == 1306683211) strcat(s, "n");
if (crc32("FUwvESd",7) == 3132536339) strcat(s, "X");
if (crc32("thvGzgQXaHhOc",13) == 4096168416) strcat(s, "t");
if (crc32("tYZmisUUZDAFgg",14) == 3341805795) strcat(s, "l");
if (crc32("sheptuEei",9) == 4102234535) strcat(s, "y");
    return s;
}

char *quasiangelically_adverbs() {
    char *s = calloc(17);
    if (crc32("AwWpDRzkimpdfy",14) == 1935246390) strcat(s, "q");
if (crc32("rgqpK",5) == 2323268658) strcat(s, "L");
if (crc32("KdognRbhZyx",11) == 1504811464) strcat(s, "u");
if (crc32("lrFuYRyyTNzR",12) == 1105997713) strcat(s, "o");
if (crc32("zCsZzcTbqlW",11) == 4244591023) strcat(s, "a");
if (crc32("djyJjVjCQrAg",12) == 4223137740) strcat(s, "o");
if (crc32("trPYrCkBDszL",12) == 2933878446) strcat(s, "s");
if (crc32("OJANdE",6) == 1512014021) strcat(s, "r");
if (crc32("kHyXFHPPqU",10) == 938749346) strcat(s, "i");
if (crc32("NWOoqbJaogHvf",13) == 768324885) strcat(s, "a");
if (crc32("zYYquabqR",9) == 4116996080) strcat(s, "n");
if (crc32("LDfjEVGxeuWyLt",14) == 1485202028) strcat(s, "g");
if (crc32("WDlyatJVpaiT",12) == 240579222) strcat(s, "Z");
if (crc32("lEKoXSoYnrGhBJ",14) == 2933601175) strcat(s, "e");
if (crc32("GKYZVjUL",8) == 1255407977) strcat(s, "l");
if (crc32("nQpzt",5) == 1988531967) strcat(s, "a");
if (crc32("ahJEHlWt",8) == 1108721629) strcat(s, "i");
if (crc32("NvcGGWTXg",9) == 1148005897) strcat(s, "c");
if (crc32("sliyIRb",7) == 2373490982) strcat(s, "A");
if (crc32("thuoG",5) == 1812293406) strcat(s, "a");
if (crc32("uLGigPCZ",8) == 3606916306) strcat(s, "T");
if (crc32("IfkDi",5) == 1769280198) strcat(s, "l");
if (crc32("EbuCENiJ",8) == 2821881954) strcat(s, "l");
if (crc32("oaaIx",5) == 1755982770) strcat(s, "y");
    return s;
}

char *unstrictly_adverbs() {
    char *s = calloc(11);
    if (crc32("xUCrPWzzA",9) == 2794048265) strcat(s, "z");
if (crc32("TWpXxcXd",8) == 2379936688) strcat(s, "u");
if (crc32("ifMKAIvKiiF",11) == 2560984872) strcat(s, "J");
if (crc32("lRiLkMLxOqk",11) == 2619802935) strcat(s, "n");
if (crc32("KdjvqylDXlIUL",13) == 2961814867) strcat(s, "x");
if (crc32("uhQEXaIpckm",11) == 809740574) strcat(s, "s");
if (crc32("rwbLwzH",7) == 2676613633) strcat(s, "H");
if (crc32("hrbjbnBIitgHmCj",15) == 832351991) strcat(s, "t");
if (crc32("dLVVasthUFdpry",14) == 2228471585) strcat(s, "B");
if (crc32("njthDGRPdsWo",12) == 2415808843) strcat(s, "r");
if (crc32("wqwUgP",6) == 3361518311) strcat(s, "Y");
if (crc32("yiVkZSkWxN",10) == 572414545) strcat(s, "i");
if (crc32("KVfUxWFaKRaIS",13) == 1160411867) strcat(s, "c");
if (crc32("PvwiDiv",7) == 349470136) strcat(s, "t");
if (crc32("mVJdAYncYtjWr",13) == 634304091) strcat(s, "s");
if (crc32("pyCOsqk",7) == 1006510016) strcat(s, "l");
if (crc32("IdRofnUWmuMp",12) == 2531579348) strcat(s, "N");
if (crc32("nILNsYsSWbZhW",13) == 4232815849) strcat(s, "y");
    return s;
}

char *ribaldly_adverbs() {
    char *s = calloc(9);
    if (crc32("ZfPIWwtByVfNGAA",15) == 3791593890) strcat(s, "j");
if (crc32("QEKZKB",6) == 1080192992) strcat(s, "r");
if (crc32("StuMMiu",7) == 1330071694) strcat(s, "v");
if (crc32("IYYoiTD",7) == 3646427506) strcat(s, "i");
if (crc32("PpVSqcP",7) == 1203747990) strcat(s, "s");
if (crc32("ZRNayXjhl",9) == 2549210879) strcat(s, "b");
if (crc32("DkdoXaJSs",9) == 3234012506) strcat(s, "a");
if (crc32("JsXkVHtjVQE",11) == 821370739) strcat(s, "l");
if (crc32("xzonTVBnziNpKn",14) == 2044906211) strcat(s, "d");
if (crc32("tXRPCQFmxyQRl",13) == 1170742440) strcat(s, "l");
if (crc32("NllXVibJOqIkDh",14) == 1507117089) strcat(s, "y");
    return s;
}

char *dissonantly_adverbs() {
    char *s = calloc(12);
    if (crc32("NvMmLiuCEKEzCR",14) == 1245359647) strcat(s, "d");
if (crc32("ACpAxnApIJL",11) == 4114282430) strcat(s, "i");
if (crc32("CZglTWG",7) == 1771036961) strcat(s, "s");
if (crc32("dsnETdYf",8) == 901041878) strcat(s, "U");
if (crc32("bKrJJLyc",8) == 1109822382) strcat(s, "s");
if (crc32("yfbyzlrXSlvTb",13) == 3961586128) strcat(s, "x");
if (crc32("JxxQZelWBtMOR",13) == 3600097871) strcat(s, "o");
if (crc32("ckfkyWUbBRLxzt",14) == 3390942166) strcat(s, "c");
if (crc32("hYhbldWkLRvVAQQ",15) == 3462229053) strcat(s, "n");
if (crc32("MPAupYP",7) == 3652140510) strcat(s, "a");
if (crc32("RwElnTkGiO",10) == 1072095555) strcat(s, "D");
if (crc32("ugnhPjGCv",9) == 3260156479) strcat(s, "n");
if (crc32("DgSVnGpQeDqva",13) == 3035852850) strcat(s, "E");
if (crc32("qjdxhWw",7) == 3246048439) strcat(s, "t");
if (crc32("tlfDLnbOg",9) == 422809377) strcat(s, "l");
if (crc32("vacnosksPkmNYi",14) == 4209879489) strcat(s, "y");
    return s;
}

char *anodically_adverbs() {
    char *s = calloc(11);
    if (crc32("vMSGwpWYsJtJ",12) == 3026895655) strcat(s, "l");
if (crc32("iQJUlCESsVAy",12) == 3317833530) strcat(s, "a");
if (crc32("ZOgJqDK",7) == 3945783092) strcat(s, "g");
if (crc32("FfvoX",5) == 3631564903) strcat(s, "n");
if (crc32("vPQcsfqyz",9) == 2155194618) strcat(s, "o");
if (crc32("EKYuNr",6) == 2640493175) strcat(s, "W");
if (crc32("MLeaf",5) == 564665120) strcat(s, "d");
if (crc32("SKhmdxgoWr",10) == 1789171407) strcat(s, "b");
if (crc32("RAOrY",5) == 3542182967) strcat(s, "i");
if (crc32("cogxJ",5) == 4176103712) strcat(s, "D");
if (crc32("bagjHVC",7) == 1088017655) strcat(s, "c");
if (crc32("ePUonjhdVbS",11) == 3655603029) strcat(s, "d");
if (crc32("ZLPmwVeffqOxs",13) == 3306829961) strcat(s, "a");
if (crc32("cmvtU",5) == 3520256053) strcat(s, "l");
if (crc32("GYcGwM",6) == 835591792) strcat(s, "R");
if (crc32("gNCzmLsTSCkXSi",14) == 1936919271) strcat(s, "l");
if (crc32("boyDXSlFTYr",11) == 1952335924) strcat(s, "y");
    return s;
}

char *overassumptively_adverbs() {
    char *s = calloc(17);
    if (crc32("vtgTxNpIno",10) == 1183101902) strcat(s, "y");
if (crc32("vEnyayvfFJLrmb",14) == 4192103512) strcat(s, "o");
if (crc32("Tcuqp",5) == 2537970964) strcat(s, "Y");
if (crc32("AqLDbhaIyj",10) == 4167674811) strcat(s, "v");
if (crc32("TQReQGYSIpdqBZ",14) == 3831806969) strcat(s, "O");
if (crc32("aUYTicLBXvcxWQ",14) == 1416308969) strcat(s, "e");
if (crc32("NxkMEYlDealQPSe",15) == 1856127025) strcat(s, "r");
if (crc32("ebdjtfA",7) == 1483974956) strcat(s, "a");
if (crc32("AGWCHDUurH",10) == 151804230) strcat(s, "s");
if (crc32("FSdkRdIDFK",10) == 498593341) strcat(s, "s");
if (crc32("ZxbvCKsgaYEg",12) == 3280898282) strcat(s, "d");
if (crc32("nDGCrImAwUCe",12) == 3545368154) strcat(s, "s");
if (crc32("rlgGt",5) == 108337001) strcat(s, "k");
if (crc32("yjnLEMgCO",9) == 3522423367) strcat(s, "u");
if (crc32("wEoYVEoAcUL",11) == 3269416281) strcat(s, "s");
if (crc32("yhvQDfhYOB",10) == 294120638) strcat(s, "m");
if (crc32("KigRvDeREKHnKW",14) == 4284997995) strcat(s, "C");
if (crc32("JGnJSlkXu",9) == 3815490559) strcat(s, "p");
if (crc32("NFSTKAvYSDXk",12) == 2638804445) strcat(s, "r");
if (crc32("WAzmaYSz",8) == 3524777420) strcat(s, "t");
if (crc32("AWgDKlDFiTDZ",12) == 2021173730) strcat(s, "i");
if (crc32("LPJhcJn",7) == 345360681) strcat(s, "v");
if (crc32("vYNOV",5) == 3302477407) strcat(s, "y");
if (crc32("vhRvvaGxWvYQhaH",15) == 1010490585) strcat(s, "e");
if (crc32("KpUbBbmMHC",10) == 3011878074) strcat(s, "l");
if (crc32("AZJZYrmL",8) == 3585546592) strcat(s, "t");
if (crc32("mLuIBbq",7) == 3681440101) strcat(s, "y");
    return s;
}

char *emanatively_adverbs() {
    char *s = calloc(12);
    if (crc32("LsIwNba",7) == 654370080) strcat(s, "e");
if (crc32("SVYnxkMxHo",10) == 582498668) strcat(s, "j");
if (crc32("zDWRvbQANoFS",12) == 1812141560) strcat(s, "m");
if (crc32("ANEHN",5) == 591566296) strcat(s, "Z");
if (crc32("vKpMVDNBdxh",11) == 2956090083) strcat(s, "a");
if (crc32("MNVIkJPpI",9) == 3411670911) strcat(s, "n");
if (crc32("GZWkNLisOMvMebU",15) == 2419378138) strcat(s, "a");
if (crc32("REQpaMrSwVGktH",14) == 3545352193) strcat(s, "t");
if (crc32("tYubTHQRIIKJuiy",15) == 1806627915) strcat(s, "i");
if (crc32("pphjqnboKMW",11) == 4047313083) strcat(s, "v");
if (crc32("wxWgipZCLQlRt",13) == 2858946966) strcat(s, "e");
if (crc32("MFlnhzitDwuEKFP",15) == 1422774318) strcat(s, "l");
if (crc32("vmVODwQhYzzubO",14) == 3854919315) strcat(s, "I");
if (crc32("FJxMMsQu",8) == 2445251119) strcat(s, "y");
    return s;
}

char *noncontinuously_adverbs() {
    char *s = calloc(16);
    if (crc32("XpVwxCpDRmIxgp",14) == 2205477411) strcat(s, "n");
if (crc32("wGNHMNgGs",9) == 1185439860) strcat(s, "o");
if (crc32("lSVcDtGcW",9) == 3091157239) strcat(s, "i");
if (crc32("VzxGkUYsG",9) == 2331858791) strcat(s, "n");
if (crc32("yfbBOMpCCAzQkf",14) == 1333616564) strcat(s, "c");
if (crc32("rQmeKYAn",8) == 1060454235) strcat(s, "H");
if (crc32("wOTPPRdXrH",10) == 4181030684) strcat(s, "o");
if (crc32("FZXNExAdy",9) == 12100723) strcat(s, "d");
if (crc32("usSOsvPnq",9) == 3526820792) strcat(s, "n");
if (crc32("phUBFnJzAwakJh",14) == 3012111686) strcat(s, "t");
if (crc32("abnYd",5) == 2427466526) strcat(s, "i");
if (crc32("RGlPvTTnV",9) == 3961105806) strcat(s, "i");
if (crc32("sRxbhNlTU",9) == 4094505973) strcat(s, "n");
if (crc32("BkRrWx",6) == 2162492690) strcat(s, "u");
if (crc32("fZZsaD",6) == 1077978545) strcat(s, "n");
if (crc32("pkTliWB",7) == 2239417084) strcat(s, "o");
if (crc32("WalzAY",6) == 3612931384) strcat(s, "u");
if (crc32("HcebOJywOKfASV",14) == 3142633284) strcat(s, "s");
if (crc32("nZJnKtqRIN",10) == 947539975) strcat(s, "U");
if (crc32("SmghRlQHYUkfLf",14) == 522135976) strcat(s, "l");
if (crc32("tSEjCcy",7) == 1612719085) strcat(s, "Z");
if (crc32("VRcytzu",7) == 4073561287) strcat(s, "y");
    return s;
}

char *incontrollably_adverbs() {
    char *s = calloc(15);
    if (crc32("TPHqgTTRKmsJlBE",15) == 3192499418) strcat(s, "K");
if (crc32("qlBUUgc",7) == 3805617824) strcat(s, "i");
if (crc32("YksGHkCUyCk",11) == 2498755191) strcat(s, "z");
if (crc32("yhusddRK",8) == 434173275) strcat(s, "n");
if (crc32("LzOsdo",6) == 3269884111) strcat(s, "H");
if (crc32("fHOsDIcDGSSx",12) == 2391288868) strcat(s, "c");
if (crc32("ZlkITCodWjNwK",13) == 3097896118) strcat(s, "O");
if (crc32("BCDzqA",6) == 2532193024) strcat(s, "o");
if (crc32("psyhK",5) == 1366307528) strcat(s, "n");
if (crc32("fkqff",5) == 2117395183) strcat(s, "G");
if (crc32("hKGiZlXMjx",10) == 116097482) strcat(s, "t");
if (crc32("NMpcWkgsfNmm",12) == 2583389683) strcat(s, "z");
if (crc32("jsKusUCtSvcnOMk",15) == 1541766920) strcat(s, "r");
if (crc32("nPEwFqQqfHmGx",13) == 3253965138) strcat(s, "H");
if (crc32("RNYrDrtVOSnJWY",14) == 3057043562) strcat(s, "o");
if (crc32("YkQHDEzSdSNL",12) == 1068394783) strcat(s, "l");
if (crc32("JsESnDdR",8) == 2834892542) strcat(s, "f");
if (crc32("vyHjKlSaOlixBHv",15) == 4270800772) strcat(s, "l");
if (crc32("VUCMwxZEUz",10) == 2549304414) strcat(s, "a");
if (crc32("jAMtozoLeDdtJbB",15) == 1537893442) strcat(s, "b");
if (crc32("ceEFWSXwaz",10) == 3590496196) strcat(s, "I");
if (crc32("xADkQqy",7) == 3040400344) strcat(s, "l");
if (crc32("mBnuv",5) == 1728736134) strcat(s, "q");
if (crc32("GUFpbROVKIgGI",13) == 2591791622) strcat(s, "y");
    return s;
}

char *nongeographically_adverbs() {
    char *s = calloc(18);
    if (crc32("YIhoFDILdujqjtp",15) == 290442080) strcat(s, "n");
if (crc32("drfizUjyE",9) == 1020545806) strcat(s, "o");
if (crc32("RWpxyF",6) == 707306730) strcat(s, "n");
if (crc32("UPJdcnYNIFve",12) == 1669576160) strcat(s, "R");
if (crc32("nVhzRoshHbQe",12) == 1216511707) strcat(s, "g");
if (crc32("NtwXqAVPVfLmXD",14) == 2369714062) strcat(s, "e");
if (crc32("QaWwynMsIejR",12) == 1426995710) strcat(s, "o");
if (crc32("fAsVF",5) == 2115810591) strcat(s, "X");
if (crc32("ZczCWj",6) == 3968251675) strcat(s, "g");
if (crc32("BUhsnrlNpx",10) == 1417117542) strcat(s, "r");
if (crc32("CBgxnuKWjhLETY",14) == 2180337265) strcat(s, "N");
if (crc32("EAtDLoMdvA",10) == 4148697911) strcat(s, "a");
if (crc32("XpntWMtxrRMVEn",14) == 2794237228) strcat(s, "K");
if (crc32("GeRgEZFbHL",10) == 1339730488) strcat(s, "p");
if (crc32("qtlQJiVdLk",10) == 1214117011) strcat(s, "h");
if (crc32("kNMvAmfNZ",9) == 2248988645) strcat(s, "Q");
if (crc32("AtovoK",6) == 1237721762) strcat(s, "i");
if (crc32("wDTEinG",7) == 1506537123) strcat(s, "t");
if (crc32("loYAHeajVa",10) == 2714325357) strcat(s, "c");
if (crc32("UTPliXL",7) == 2020867767) strcat(s, "a");
if (crc32("HADjUCxXsycrP",13) == 1862567375) strcat(s, "a");
if (crc32("jmCRiKvri",9) == 4045631628) strcat(s, "l");
if (crc32("VxlibPAsGt",10) == 1710335834) strcat(s, "l");
if (crc32("omCqBoQCrKRRA",13) == 529286820) strcat(s, "o");
if (crc32("jCsOjvvSp",9) == 2816562032) strcat(s, "y");
    return s;
}

char *undeficiently_adverbs() {
    char *s = calloc(14);
    if (crc32("gNOkjfUWfsn",11) == 143779322) strcat(s, "A");
if (crc32("pdNfKxx",7) == 3726140479) strcat(s, "u");
if (crc32("vfljAUVhOy",10) == 3833524140) strcat(s, "E");
if (crc32("WTnLSyVN",8) == 3183171238) strcat(s, "n");
if (crc32("eBbRT",5) == 154479331) strcat(s, "d");
if (crc32("KILlZS",6) == 2866732667) strcat(s, "G");
if (crc32("hueShLOLGvANJuv",15) == 2847250253) strcat(s, "e");
if (crc32("KlnJFR",6) == 680101159) strcat(s, "z");
if (crc32("esMfEFXsykO",11) == 3954343172) strcat(s, "f");
if (crc32("IwwVybtClpm",11) == 2691913301) strcat(s, "r");
if (crc32("WOhFtvlbX",9) == 1349474379) strcat(s, "i");
if (crc32("CdEqURQ",7) == 3337379833) strcat(s, "c");
if (crc32("KBsNJCAAjEMjj",13) == 2440199052) strcat(s, "i");
if (crc32("KhhAiiDY",8) == 2248639714) strcat(s, "M");
if (crc32("BZMxLOyToU",10) == 3581510549) strcat(s, "e");
if (crc32("dhfSzZZyNLgK",12) == 3428710524) strcat(s, "S");
if (crc32("meQhkQKUaGkAF",13) == 1080128869) strcat(s, "n");
if (crc32("KidpX",5) == 1025478165) strcat(s, "h");
if (crc32("GgtnhlYMWouSeww",15) == 2397827039) strcat(s, "t");
if (crc32("atDYKAvwyZ",10) == 2213983999) strcat(s, "O");
if (crc32("uDxWMmOABzD",11) == 3640247859) strcat(s, "l");
if (crc32("klmUAUlGzub",11) == 61679513) strcat(s, "J");
if (crc32("hPaEuVZFXs",10) == 3740260360) strcat(s, "y");
    return s;
}

char *unsavagely_adverbs() {
    char *s = calloc(11);
    if (crc32("qulKhLP",7) == 934052458) strcat(s, "j");
if (crc32("RprMJdUfxJTak",13) == 3481753836) strcat(s, "u");
if (crc32("NLlFjlPljxfWT",13) == 3905578287) strcat(s, "Y");
if (crc32("KvFalVDGjh",10) == 2984733031) strcat(s, "n");
if (crc32("XNDdqMjBpx",10) == 1845912844) strcat(s, "b");
if (crc32("XByqRGEM",8) == 1230511165) strcat(s, "s");
if (crc32("RUShKE",6) == 2318422497) strcat(s, "a");
if (crc32("PCmQTmbPz",9) == 1528691276) strcat(s, "v");
if (crc32("zeSLFScTanHfOEw",15) == 3067301219) strcat(s, "a");
if (crc32("FIuYROjAJ",9) == 2464181270) strcat(s, "D");
if (crc32("aeXKTkFHzXt",11) == 817392140) strcat(s, "g");
if (crc32("MsuAvWPp",8) == 4183802997) strcat(s, "e");
if (crc32("kAgZXCxj",8) == 2427719779) strcat(s, "l");
if (crc32("ftIsTaiUWLWo",12) == 2110303533) strcat(s, "l");
if (crc32("FRYCJUBbHQFlrom",15) == 2839783500) strcat(s, "y");
    return s;
}

char *outofbounds_adverbs() {
    char *s = calloc(12);
    if (crc32("qVVNaoUlnntnj",13) == 523916581) strcat(s, "o");
if (crc32("xxVKBQ",6) == 3550215099) strcat(s, "u");
if (crc32("bcQgnrnUNbjXh",13) == 1269121477) strcat(s, "t");
if (crc32("pldHUzxsRPDkTkN",15) == 2347500405) strcat(s, "o");
if (crc32("oQQuFgv",7) == 2568967918) strcat(s, "f");
if (crc32("CPlPOKOF",8) == 381087145) strcat(s, "Y");
if (crc32("NdPiPnqvFBFIMsL",15) == 3035811636) strcat(s, "b");
if (crc32("yDFsxnb",7) == 1705539047) strcat(s, "M");
if (crc32("nwTskVaRNjG",11) == 3947858383) strcat(s, "o");
if (crc32("efJBptMhSilO",12) == 366957883) strcat(s, "u");
if (crc32("zdTcYaWSMryyS",13) == 3909134898) strcat(s, "K");
if (crc32("gnPCSSCuz",9) == 2268915808) strcat(s, "n");
if (crc32("ehJsoUbeQXvOMK",14) == 2169390853) strcat(s, "u");
if (crc32("kDbxl",5) == 3557277672) strcat(s, "d");
if (crc32("qAPXrQ",6) == 3169322114) strcat(s, "s");
    return s;
}

char *meteorologically_adverbs() {
    char *s = calloc(17);
    if (crc32("xLylKQBYcZk",11) == 3052006569) strcat(s, "m");
if (crc32("ClfJQk",6) == 2118924065) strcat(s, "e");
if (crc32("ibTosi",6) == 894397235) strcat(s, "V");
if (crc32("LbwTKtZrEUDmJL",14) == 3054112792) strcat(s, "t");
if (crc32("UNsMXHRtyd",10) == 2055085896) strcat(s, "p");
if (crc32("HCPiSDMMm",9) == 1294766037) strcat(s, "e");
if (crc32("uFKrjl",6) == 4259863908) strcat(s, "o");
if (crc32("reFEh",5) == 4088979675) strcat(s, "r");
if (crc32("FuJQI",5) == 4264973694) strcat(s, "U");
if (crc32("uQdIqHZYSTz",11) == 3895918338) strcat(s, "o");
if (crc32("mPoMgBw",7) == 1210682989) strcat(s, "l");
if (crc32("CJySUIqYdMpb",12) == 809180119) strcat(s, "R");
if (crc32("IBwXgepk",8) == 2207440091) strcat(s, "o");
if (crc32("tKaJxEFMy",9) == 3250732084) strcat(s, "g");
if (crc32("JiWjbigtHzCRK",13) == 1470248077) strcat(s, "F");
if (crc32("QLIypdHJaVgVDRS",15) == 3424763416) strcat(s, "i");
if (crc32("zaBHAx",6) == 3444678836) strcat(s, "x");
if (crc32("MLdRWGn",7) == 2975709916) strcat(s, "c");
if (crc32("kSapcxotFgX",11) == 873612027) strcat(s, "a");
if (crc32("vgOidqikI",9) == 1394143698) strcat(s, "l");
if (crc32("NLKSLMYm",8) == 826826209) strcat(s, "l");
if (crc32("NkRAoxGUhV",10) == 3355831353) strcat(s, "t");
if (crc32("mkyCFRvEfj",10) == 3796802630) strcat(s, "y");
    return s;
}

char *unconfoundedly_adverbs() {
    char *s = calloc(15);
    if (crc32("gUAafbwMniiCAq",14) == 1744434406) strcat(s, "u");
if (crc32("DTIapMocktpjq",13) == 2313558713) strcat(s, "n");
if (crc32("ipgCZLoHwsCOKB",14) == 1668730082) strcat(s, "c");
if (crc32("ehUyb",5) == 1582628444) strcat(s, "o");
if (crc32("VTBPUuvQKBkaRC",14) == 101149567) strcat(s, "w");
if (crc32("PEqcBdVr",8) == 351452160) strcat(s, "n");
if (crc32("gucfg",5) == 4205259940) strcat(s, "B");
if (crc32("lEZoXGWkEr",10) == 773828491) strcat(s, "f");
if (crc32("HtZVrCAcfKZONK",14) == 1956087747) strcat(s, "o");
if (crc32("eXCriqITVgn",11) == 3472257703) strcat(s, "u");
if (crc32("hCIcN",5) == 1178525438) strcat(s, "n");
if (crc32("JjxaUXk",7) == 3755725695) strcat(s, "y");
if (crc32("gPlrakgGiJpSw",13) == 430301018) strcat(s, "d");
if (crc32("QqZMufqlvXEvH",13) == 55786910) strcat(s, "e");
if (crc32("HrlrpCusyEPlOY",14) == 2351199666) strcat(s, "D");
if (crc32("qMKhEGAZbdBB",12) == 2317178981) strcat(s, "d");
if (crc32("AYzriztMrCsbam",14) == 3905691421) strcat(s, "M");
if (crc32("MJTLuR",6) == 4203063747) strcat(s, "l");
if (crc32("zEwQX",5) == 1311009914) strcat(s, "y");
    return s;
}

char *jokingly_adverbs() {
    char *s = calloc(9);
    if (crc32("elurJYeb",8) == 1160792586) strcat(s, "j");
if (crc32("bkUMMXzAmEY",11) == 1243144673) strcat(s, "o");
if (crc32("SsATdh",6) == 2906652058) strcat(s, "Q");
if (crc32("xMuhBFmn",8) == 4072003962) strcat(s, "k");
if (crc32("qDalHBkte",9) == 2506492293) strcat(s, "i");
if (crc32("CjtNScuMDUBEo",13) == 1766754823) strcat(s, "n");
if (crc32("sVdiJv",6) == 528319703) strcat(s, "g");
if (crc32("ZSwEWeFYGpjb",12) == 3366338901) strcat(s, "g");
if (crc32("HJLXCIHSy",9) == 1742852186) strcat(s, "l");
if (crc32("llwfXkUHuSA",11) == 1727654855) strcat(s, "y");
    return s;
}

char *quantitatively_adverbs() {
    char *s = calloc(15);
    if (crc32("ohqlWVTm",8) == 1804690826) strcat(s, "B");
if (crc32("jotVoIA",7) == 3403116156) strcat(s, "q");
if (crc32("ETexApmreZblx",13) == 3022202996) strcat(s, "u");
if (crc32("JyXMTgWTfW",10) == 2971000522) strcat(s, "U");
if (crc32("HONDXOmWw",9) == 1132697776) strcat(s, "a");
if (crc32("chEaJnaKZepKgSj",15) == 4149595614) strcat(s, "n");
if (crc32("NjZOUyBkFv",10) == 2733085574) strcat(s, "J");
if (crc32("QuWLxDgl",8) == 2044076998) strcat(s, "t");
if (crc32("qpSVSrpov",9) == 76752015) strcat(s, "S");
if (crc32("ubwDggkiQ",9) == 315056775) strcat(s, "i");
if (crc32("CfYvuJggmYfn",12) == 40312199) strcat(s, "J");
if (crc32("MlZClfqW",8) == 3614135301) strcat(s, "t");
if (crc32("BLteBblIV",9) == 2032370740) strcat(s, "a");
if (crc32("ZwBlLVLC",8) == 1985351033) strcat(s, "O");
if (crc32("hXbtfnRFWxYvFYG",15) == 1313769895) strcat(s, "t");
if (crc32("ExOFhSzUgZzaUfR",15) == 2097996387) strcat(s, "i");
if (crc32("QcnGtlo",7) == 4057100751) strcat(s, "v");
if (crc32("cBEjcnFttr",10) == 3610836209) strcat(s, "e");
if (crc32("gZiBC",5) == 2965777134) strcat(s, "t");
if (crc32("qiFGaMpLQNw",11) == 2365274406) strcat(s, "l");
if (crc32("atbtwpTMv",9) == 150398392) strcat(s, "X");
if (crc32("zsDxIE",6) == 3432030922) strcat(s, "y");
    return s;
}

char *pseudobiologically_adverbs() {
    char *s = calloc(19);
    if (crc32("hTZIExp",7) == 3581384032) strcat(s, "N");
if (crc32("EQdeoAnPDQCPBQ",14) == 1868516258) strcat(s, "p");
if (crc32("xbYipaVyz",9) == 1438871132) strcat(s, "E");
if (crc32("FWQDlnUPag",10) == 700377132) strcat(s, "s");
if (crc32("puZKvcQ",7) == 379442837) strcat(s, "e");
if (crc32("RlYRmGZE",8) == 2904456333) strcat(s, "u");
if (crc32("ZbJneRU",7) == 682032239) strcat(s, "h");
if (crc32("ZuFfIBYpuQrns",13) == 3777907242) strcat(s, "d");
if (crc32("FUGgSMrOr",9) == 1246244235) strcat(s, "o");
if (crc32("AsWObLAnuClWfl",14) == 2174245750) strcat(s, "j");
if (crc32("JgEhLXoXbkfyJEc",15) == 883212195) strcat(s, "b");
if (crc32("pDmpdbtF",8) == 527811733) strcat(s, "i");
if (crc32("xVjOyHYxP",9) == 1509773806) strcat(s, "u");
if (crc32("wfrUn",5) == 2838379117) strcat(s, "o");
if (crc32("NPrwyPjE",8) == 2497151360) strcat(s, "l");
if (crc32("OSaxpmaqvVi",11) == 4019788843) strcat(s, "o");
if (crc32("lVeFPwkuQu",10) == 3966197215) strcat(s, "g");
if (crc32("WifFXMuzNv",10) == 3110575694) strcat(s, "H");
if (crc32("AXUKQxnSNGCW",12) == 982977464) strcat(s, "i");
if (crc32("LXUXaDUV",8) == 4006042367) strcat(s, "c");
if (crc32("GJGeJEq",7) == 1476849857) strcat(s, "l");
if (crc32("TvoGEDR",7) == 3977087468) strcat(s, "a");
if (crc32("izdAxIzwYmCA",12) == 2695820451) strcat(s, "l");
if (crc32("HnpoQQMU",8) == 2264289416) strcat(s, "f");
if (crc32("PEDqXizUSAtKfHC",15) == 3290316472) strcat(s, "l");
if (crc32("CNEaIxHJkj",10) == 2716782075) strcat(s, "Z");
if (crc32("irpxfOzNnrES",12) == 3473898674) strcat(s, "y");
    return s;
}

char *immovably_adverbs() {
    char *s = calloc(10);
    if (crc32("qsaDYVszJkkKRJO",15) == 4266602769) strcat(s, "i");
if (crc32("GWLKp",5) == 1076090633) strcat(s, "m");
if (crc32("insUenbf",8) == 2984329414) strcat(s, "m");
if (crc32("eZmhhMZe",8) == 3246421061) strcat(s, "H");
if (crc32("UbIexCdTqNeFReC",15) == 1688177225) strcat(s, "o");
if (crc32("StScGMZbZvrk",12) == 851470265) strcat(s, "v");
if (crc32("WnKLTYuNmfpyNw",14) == 1853450143) strcat(s, "z");
if (crc32("ZCEeDRdYbL",10) == 1002589146) strcat(s, "a");
if (crc32("OyJVV",5) == 1780077439) strcat(s, "h");
if (crc32("sixeLFLebE",10) == 3380985343) strcat(s, "b");
if (crc32("LVtNY",5) == 2599573884) strcat(s, "l");
if (crc32("wDwOeBkOWtNQKv",14) == 1866861070) strcat(s, "N");
if (crc32("fpnwLFsiVDLl",12) == 3627311617) strcat(s, "y");
    return s;
}

char *withershins_adverbs() {
    char *s = calloc(12);
    if (crc32("ZlPuzKgv",8) == 3999299080) strcat(s, "Q");
if (crc32("BnOHRFynndxc",12) == 844738049) strcat(s, "w");
if (crc32("HjBSnYRxBdA",11) == 11155679) strcat(s, "k");
if (crc32("DGZNoL",6) == 2355320927) strcat(s, "i");
if (crc32("qskLdZGfn",9) == 4133462579) strcat(s, "t");
if (crc32("CyDQzmAtjXI",11) == 1897755726) strcat(s, "h");
if (crc32("IzWPlUQxN",9) == 4172893526) strcat(s, "e");
if (crc32("BmOAlaQE",8) == 3801468474) strcat(s, "r");
if (crc32("eHsDA",5) == 170480380) strcat(s, "s");
if (crc32("BBhOFqQohdfKWXa",15) == 412462453) strcat(s, "h");
if (crc32("FQTsosPBgy",10) == 3847043146) strcat(s, "i");
if (crc32("gbMcW",5) == 1913766047) strcat(s, "D");
if (crc32("toQwYuMEbV",10) == 4293794483) strcat(s, "n");
if (crc32("ucYJhyKm",8) == 3395700962) strcat(s, "p");
if (crc32("fHbxnIeNp",9) == 2024612703) strcat(s, "s");
    return s;
}

char *moonily_adverbs() {
    char *s = calloc(8);
    if (crc32("RVtjITqXO",9) == 1247941646) strcat(s, "T");
if (crc32("katBMoIMBHln",12) == 3607970212) strcat(s, "m");
if (crc32("kybDicTBselMxJr",15) == 2187622524) strcat(s, "j");
if (crc32("aDHCDmackH",10) == 321160920) strcat(s, "o");
if (crc32("LQLZXFh",7) == 1732460366) strcat(s, "o");
if (crc32("AEtmkOrRkMYbpVo",15) == 2200792695) strcat(s, "n");
if (crc32("efqQTBevFnuA",12) == 2349937931) strcat(s, "i");
if (crc32("QrMTY",5) == 3621011033) strcat(s, "x");
if (crc32("HZWophgCiIIX",12) == 1820130464) strcat(s, "l");
if (crc32("UHTJE",5) == 3468055808) strcat(s, "m");
if (crc32("Lfklh",5) == 2345599882) strcat(s, "y");
    return s;
}

char *undiffidently_adverbs() {
    char *s = calloc(14);
    if (crc32("dyNrxuVhD",9) == 664805847) strcat(s, "u");
if (crc32("OxupqY",6) == 2867669773) strcat(s, "n");
if (crc32("jJsRxpYlBRbnEpc",15) == 2047072728) strcat(s, "d");
if (crc32("iihBZwtAfza",11) == 4238890288) strcat(s, "i");
if (crc32("rEIjjnpuUfFmoc",14) == 1250902835) strcat(s, "c");
if (crc32("jDfHRcWCP",9) == 997364508) strcat(s, "f");
if (crc32("uCJqENjAOyLU",12) == 3912779588) strcat(s, "I");
if (crc32("WsNsOTIyTUMPBj",14) == 687495534) strcat(s, "f");
if (crc32("wlDaDAluAjYUGm",14) == 3912280290) strcat(s, "g");
if (crc32("UmRvSMMQXL",10) == 2857478658) strcat(s, "i");
if (crc32("qpgud",5) == 1017146281) strcat(s, "d");
if (crc32("GxvZVNlQqvUNXdb",15) == 3301386645) strcat(s, "m");
if (crc32("oZKLqhTAdaUvYF",14) == 133840649) strcat(s, "e");
if (crc32("QtWCOp",6) == 2040535690) strcat(s, "n");
if (crc32("XWdUHDZJWybA",12) == 1587563631) strcat(s, "C");
if (crc32("JdBQTC",6) == 517080431) strcat(s, "t");
if (crc32("NKQFcSd",7) == 1686765354) strcat(s, "g");
if (crc32("sJgowFnd",8) == 2588620396) strcat(s, "l");
if (crc32("LiaOienBWQ",10) == 3659699706) strcat(s, "v");
if (crc32("BexLrUjLUyZBz",13) == 3280753601) strcat(s, "y");
    return s;
}

char *adaptively_adverbs() {
    char *s = calloc(11);
    if (crc32("DPFhKCyZM",9) == 3692604337) strcat(s, "C");
if (crc32("sIzSRyHoMpIf",12) == 30346156) strcat(s, "a");
if (crc32("Iolkoq",6) == 1927430179) strcat(s, "d");
if (crc32("YxeOpjygu",9) == 2625072889) strcat(s, "a");
if (crc32("ZVpTpNWj",8) == 547871508) strcat(s, "L");
if (crc32("YIeAzDdpelkxObu",15) == 3028132459) strcat(s, "p");
if (crc32("Bvxtmonq",8) == 1018860043) strcat(s, "t");
if (crc32("OPVXmCGX",8) == 3869371303) strcat(s, "P");
if (crc32("bdDufEYgmMcGf",13) == 2288166586) strcat(s, "i");
if (crc32("uVlZyWZgaSZ",11) == 2871227392) strcat(s, "L");
if (crc32("pZoODGAdIBqqLUs",15) == 990529646) strcat(s, "v");
if (crc32("GjtgV",5) == 2200349966) strcat(s, "e");
if (crc32("ldjIeonjgaCT",12) == 1581995818) strcat(s, "l");
if (crc32("BwIaGtxCPcfQ",12) == 875123868) strcat(s, "y");
    return s;
}

char *formulaically_adverbs() {
    char *s = calloc(14);
    if (crc32("rRJhV",5) == 3503288854) strcat(s, "k");
if (crc32("UALPlCYXsJE",11) == 3663839228) strcat(s, "f");
if (crc32("jSNVnXTzQBHAf",13) == 303117817) strcat(s, "K");
if (crc32("PGXMnfQopzzXJp",14) == 2436776678) strcat(s, "o");
if (crc32("VGGFC",5) == 1267846686) strcat(s, "r");
if (crc32("VCPSJ",5) == 2482221580) strcat(s, "m");
if (crc32("GKiwzwWIzZkM",12) == 1096814666) strcat(s, "h");
if (crc32("PVipv",5) == 3238540792) strcat(s, "u");
if (crc32("QvNQLvCXxZMQe",13) == 3772715930) strcat(s, "S");
if (crc32("cFaRfDJAiaifBp",14) == 3111849178) strcat(s, "l");
if (crc32("iwScWz",6) == 63456618) strcat(s, "a");
if (crc32("xpaWnJXA",8) == 1781097535) strcat(s, "i");
if (crc32("xhvOGG",6) == 3858208171) strcat(s, "Q");
if (crc32("vdnRjnjjPdOYIrl",15) == 1295186371) strcat(s, "c");
if (crc32("scAsJSKC",8) == 3789484768) strcat(s, "a");
if (crc32("uEjrBdSRrmGvVI",14) == 499878452) strcat(s, "l");
if (crc32("GOlnHXeuFoRmL",13) == 3438597944) strcat(s, "W");
if (crc32("iWigdO",6) == 4165892964) strcat(s, "l");
if (crc32("wbGeqOlfVNxTV",13) == 2338095244) strcat(s, "y");
    return s;
}

char *endlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("KdMGxlQ",7) == 1559454041) strcat(s, "s");
if (crc32("raHIMHhA",8) == 2876666077) strcat(s, "e");
if (crc32("iIcJJG",6) == 2104157774) strcat(s, "n");
if (crc32("MRlIbPIC",8) == 703583128) strcat(s, "F");
if (crc32("oLbqudDovCen",12) == 1432485221) strcat(s, "d");
if (crc32("iwNKlmAzDOsTcT",14) == 810239218) strcat(s, "b");
if (crc32("gUEGC",5) == 928982291) strcat(s, "l");
if (crc32("oLQTufuCNTsv",12) == 1596379256) strcat(s, "S");
if (crc32("rOOnLOjd",8) == 2664511125) strcat(s, "e");
if (crc32("GoiUR",5) == 3419819907) strcat(s, "o");
if (crc32("RIfAJdY",7) == 1518374420) strcat(s, "s");
if (crc32("KAgurlndGuzqwZB",15) == 1309415967) strcat(s, "s");
if (crc32("YOxjEHGsCggpo",13) == 3341196206) strcat(s, "D");
if (crc32("hGjdbxz",7) == 1288412162) strcat(s, "l");
if (crc32("FwAYVMOo",8) == 3229762422) strcat(s, "F");
if (crc32("LiZrix",6) == 1147012240) strcat(s, "y");
    return s;
}

char *uncircularly_adverbs() {
    char *s = calloc(13);
    if (crc32("NnWjsuw",7) == 2945451241) strcat(s, "u");
if (crc32("jzvLYWUVG",9) == 3892438481) strcat(s, "n");
if (crc32("arvSVbBMVOZyp",13) == 418871284) strcat(s, "c");
if (crc32("zvnFozAaI",9) == 3406046775) strcat(s, "p");
if (crc32("PFmrgvkKA",9) == 3836774473) strcat(s, "i");
if (crc32("rxOlBHB",7) == 2629776526) strcat(s, "W");
if (crc32("yozTUBszlw",10) == 3652417536) strcat(s, "r");
if (crc32("rBgouxpZjJBPV",13) == 1195066991) strcat(s, "h");
if (crc32("UKHeGbbh",8) == 3573804273) strcat(s, "c");
if (crc32("WZGwvDclIG",10) == 756068755) strcat(s, "A");
if (crc32("KJLGOXiCGKCJGo",14) == 627693118) strcat(s, "u");
if (crc32("TrsdAMR",7) == 3082854972) strcat(s, "l");
if (crc32("OxFfDlq",7) == 236754802) strcat(s, "y");
if (crc32("wmOkl",5) == 4250382846) strcat(s, "a");
if (crc32("rsBurRVv",8) == 264196096) strcat(s, "G");
if (crc32("WUuUTm",6) == 2348343319) strcat(s, "r");
if (crc32("KQNGntluQkda",12) == 650238956) strcat(s, "l");
if (crc32("zKtrNMMxA",9) == 3111919887) strcat(s, "y");
    return s;
}

char *dialogically_adverbs() {
    char *s = calloc(13);
    if (crc32("noSwhw",6) == 1931343036) strcat(s, "d");
if (crc32("dXbLfBvo",8) == 817733161) strcat(s, "i");
if (crc32("KZHRjPfPtcgput",14) == 3264547093) strcat(s, "a");
if (crc32("vXteYsFdeYWP",12) == 842923034) strcat(s, "q");
if (crc32("pbIIEG",6) == 2784184004) strcat(s, "l");
if (crc32("VKciuvkIyk",10) == 3605923693) strcat(s, "y");
if (crc32("vcSzgrZrHxTh",12) == 1478012636) strcat(s, "o");
if (crc32("YhHKEUyc",8) == 3082904150) strcat(s, "g");
if (crc32("wkunwNdxbdsfkc",14) == 3462888878) strcat(s, "i");
if (crc32("yrjTShiRkbU",11) == 260135598) strcat(s, "c");
if (crc32("jcFLnVOgJJv",11) == 4128013678) strcat(s, "H");
if (crc32("ajNJTNq",7) == 686116655) strcat(s, "a");
if (crc32("SgXGCPkaXilfpXk",15) == 52533457) strcat(s, "l");
if (crc32("SbDNF",5) == 2926108348) strcat(s, "l");
if (crc32("mkoemkhacoDGI",13) == 3400102447) strcat(s, "y");
    return s;
}

char *roundedly_adverbs() {
    char *s = calloc(10);
    if (crc32("hKxGsPwpfAQyC",13) == 3583719221) strcat(s, "r");
if (crc32("RTeBtKAmZOR",11) == 3291376260) strcat(s, "o");
if (crc32("ROUlPc",6) == 2278548839) strcat(s, "R");
if (crc32("StJkqVMBTwFe",12) == 373629854) strcat(s, "u");
if (crc32("dDYUKW",6) == 2977067740) strcat(s, "f");
if (crc32("BbTDcRcVjT",10) == 343754735) strcat(s, "n");
if (crc32("LQSVpwjs",8) == 2797071189) strcat(s, "h");
if (crc32("SccYDvzvTpAu",12) == 988868456) strcat(s, "d");
if (crc32("cIWebXUbAtng",12) == 2711483998) strcat(s, "e");
if (crc32("WstFPk",6) == 4004126926) strcat(s, "d");
if (crc32("vtLZgOkgZXKUiv",14) == 126141842) strcat(s, "n");
if (crc32("YkRIrn",6) == 3723335821) strcat(s, "l");
if (crc32("JaaPimwoTSHjOys",15) == 1003328164) strcat(s, "y");
    return s;
}

char *surgically_adverbs() {
    char *s = calloc(11);
    if (crc32("ptUduNKU",8) == 3690842323) strcat(s, "F");
if (crc32("muwDIkkbJOwhEz",14) == 2946981451) strcat(s, "s");
if (crc32("GalaGKAFRSum",12) == 3661778649) strcat(s, "I");
if (crc32("YCjAqOEphG",10) == 1169808567) strcat(s, "u");
if (crc32("tPlitsk",7) == 2886530799) strcat(s, "H");
if (crc32("IqAszmKgWTzbC",13) == 3531699465) strcat(s, "r");
if (crc32("xzbRQKYopr",10) == 1130222986) strcat(s, "Q");
if (crc32("pIfuZZvVW",9) == 208730587) strcat(s, "g");
if (crc32("tKzaYAV",7) == 1984620941) strcat(s, "G");
if (crc32("fnmNoUnukq",10) == 3583105344) strcat(s, "i");
if (crc32("nycugtYgNCl",11) == 1243827926) strcat(s, "c");
if (crc32("oBqqBRAwWQJ",11) == 3895827145) strcat(s, "a");
if (crc32("RGuKbOgRRIr",11) == 2247759626) strcat(s, "L");
if (crc32("ZIhvvJP",7) == 3825800054) strcat(s, "l");
if (crc32("UcOqCZlIqLzCEPE",15) == 274727397) strcat(s, "l");
if (crc32("WQllH",5) == 2233297932) strcat(s, "K");
if (crc32("MNJuxhqoOR",10) == 3022816908) strcat(s, "y");
    return s;
}

char *unelastically_adverbs() {
    char *s = calloc(14);
    if (crc32("KRgUKlzzkTzjh",13) == 3239024772) strcat(s, "Q");
if (crc32("KzgXC",5) == 1034732654) strcat(s, "u");
if (crc32("lzUzsA",6) == 2702757488) strcat(s, "z");
if (crc32("wsTBtax",7) == 3025917037) strcat(s, "n");
if (crc32("jEEWBEuzH",9) == 1021183288) strcat(s, "p");
if (crc32("QNGsCkqr",8) == 28903787) strcat(s, "e");
if (crc32("nBbBAH",6) == 4003797433) strcat(s, "V");
if (crc32("fnyGbCfIqPEC",12) == 3207605851) strcat(s, "l");
if (crc32("dcOQvdzvkYOQWe",14) == 1977591989) strcat(s, "a");
if (crc32("EyBrTNptrr",10) == 1696583948) strcat(s, "M");
if (crc32("aaYltbZ",7) == 3095122066) strcat(s, "s");
if (crc32("pJmiiqxoXGX",11) == 2157359317) strcat(s, "v");
if (crc32("hmWcApYtBOVR",12) == 4248746719) strcat(s, "t");
if (crc32("VgWtshXyGQUmLjx",15) == 3657266568) strcat(s, "i");
if (crc32("rgGyFGVU",8) == 1673174074) strcat(s, "p");
if (crc32("YxvOJoSAHQd",11) == 752547304) strcat(s, "c");
if (crc32("ympYmwkBQFl",11) == 3705355939) strcat(s, "a");
if (crc32("WdhsBmAgA",9) == 3024412657) strcat(s, "P");
if (crc32("GbweDXNWZreCnjy",15) == 4105398809) strcat(s, "l");
if (crc32("ApIgpb",6) == 2870160181) strcat(s, "l");
if (crc32("DMFgrIO",7) == 487196290) strcat(s, "A");
if (crc32("fWlMXLZYWhU",11) == 4080096078) strcat(s, "y");
    return s;
}

char *collinearly_adverbs() {
    char *s = calloc(12);
    if (crc32("KEgSjdyCoTMLz",13) == 1891606538) strcat(s, "c");
if (crc32("dKzjHwyYKCxgtBE",15) == 3950536887) strcat(s, "B");
if (crc32("KRFsk",5) == 576731899) strcat(s, "o");
if (crc32("fCHcQZOhbCmtg",13) == 874660710) strcat(s, "l");
if (crc32("fcmvLtv",7) == 1596558262) strcat(s, "l");
if (crc32("WDmNWRDzQPvljvi",15) == 578049994) strcat(s, "s");
if (crc32("iGyMsIuhrY",10) == 797362757) strcat(s, "l");
if (crc32("JkTbEwKxeyRBx",13) == 3954330224) strcat(s, "i");
if (crc32("nbeghZwwG",9) == 4170392419) strcat(s, "n");
if (crc32("nuzMWQwoqqN",11) == 3138656377) strcat(s, "u");
if (crc32("GswZIbsG",8) == 3197878983) strcat(s, "e");
if (crc32("miEgbsNeuR",10) == 25936203) strcat(s, "a");
if (crc32("LuTLyItbuXhsv",13) == 2529268848) strcat(s, "I");
if (crc32("oHMgpB",6) == 3018329003) strcat(s, "r");
if (crc32("GxFyp",5) == 1486207430) strcat(s, "l");
if (crc32("hkLmzsUZVQh",11) == 3268080741) strcat(s, "y");
    return s;
}

char *uniniquitously_adverbs() {
    char *s = calloc(15);
    if (crc32("DizhMvbvslqegGF",15) == 3806910173) strcat(s, "u");
if (crc32("KnVOoHvqnLzV",12) == 534801909) strcat(s, "n");
if (crc32("naLkTYKxevVoMX",14) == 1700488507) strcat(s, "i");
if (crc32("jKvNnZjBSkEZPh",14) == 1887090906) strcat(s, "n");
if (crc32("MDEXUCNFrknaCF",14) == 3985647697) strcat(s, "i");
if (crc32("oYVvPZi",7) == 1878598504) strcat(s, "X");
if (crc32("WixCfijPNBhwce",14) == 4067768955) strcat(s, "q");
if (crc32("VwvpTwys",8) == 3643654535) strcat(s, "u");
if (crc32("OPHsrEgbpQuq",12) == 1843804908) strcat(s, "L");
if (crc32("eKPlidf",7) == 2329435010) strcat(s, "i");
if (crc32("amOrrSMwq",9) == 2009218706) strcat(s, "t");
if (crc32("goVySSkrrsXiTf",14) == 1672102082) strcat(s, "o");
if (crc32("cqNURWnc",8) == 2479489502) strcat(s, "u");
if (crc32("igECsRSmrnT",11) == 2852524907) strcat(s, "s");
if (crc32("NIxJUtO",7) == 1531155713) strcat(s, "l");
if (crc32("eYABOiPmJdd",11) == 4159720483) strcat(s, "y");
    return s;
}

char *unboastfully_adverbs() {
    char *s = calloc(13);
    if (crc32("JvHoxbmnReZX",12) == 1118415060) strcat(s, "u");
if (crc32("zkdbjmDtb",9) == 2632672315) strcat(s, "L");
if (crc32("WpSembkWRuiH",12) == 3372396165) strcat(s, "n");
if (crc32("fCyrHNLlCaTnG",13) == 3493206199) strcat(s, "b");
if (crc32("WAUBJflhdGOON",13) == 1096213861) strcat(s, "o");
if (crc32("GvmIXTRrgdI",11) == 3012846805) strcat(s, "a");
if (crc32("YLNBGKGYvUb",11) == 502489288) strcat(s, "s");
if (crc32("jJVtFDUhvCjJIG",14) == 4257505579) strcat(s, "X");
if (crc32("KPOZFaS",7) == 1399750030) strcat(s, "t");
if (crc32("YrKKON",6) == 220945306) strcat(s, "b");
if (crc32("eRQrrZNRZBmCR",13) == 2502241321) strcat(s, "f");
if (crc32("kaoWle",6) == 2307223259) strcat(s, "u");
if (crc32("sXhhDnyGGgVWuY",14) == 3846658595) strcat(s, "D");
if (crc32("oQgoABVC",8) == 3025853453) strcat(s, "l");
if (crc32("JKiicMTMv",9) == 758808359) strcat(s, "W");
if (crc32("MKfaKWheFiRqz",13) == 2843038681) strcat(s, "l");
if (crc32("NnHRxqmmy",9) == 2688418982) strcat(s, "y");
    return s;
}

char *nonfloatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("unLAXWWSzTjceD",14) == 1766015601) strcat(s, "m");
if (crc32("PQyFrXgD",8) == 3064746170) strcat(s, "n");
if (crc32("emTwug",6) == 3564875841) strcat(s, "g");
if (crc32("HCrFsIQdQcdDt",13) == 3549795910) strcat(s, "o");
if (crc32("cwafD",5) == 478060283) strcat(s, "H");
if (crc32("CscpWqIbC",9) == 206609860) strcat(s, "n");
if (crc32("PyeuUUOFpW",10) == 429884804) strcat(s, "S");
if (crc32("ZjivcpDRDeYPF",13) == 4048834511) strcat(s, "f");
if (crc32("Dueidy",6) == 2005866179) strcat(s, "l");
if (crc32("oPgbZAvYIOfBkDP",15) == 1485535904) strcat(s, "e");
if (crc32("JeIcuzyJVtS",11) == 2172201157) strcat(s, "o");
if (crc32("mQDjHA",6) == 361726337) strcat(s, "f");
if (crc32("hjAPyr",6) == 2298839103) strcat(s, "a");
if (crc32("RPoWYVdhJ",9) == 591337280) strcat(s, "y");
if (crc32("ZCCojbcIhsEUMdK",15) == 2897954255) strcat(s, "t");
if (crc32("ehJIiXvH",8) == 4276174487) strcat(s, "P");
if (crc32("QCwMPz",6) == 3984726952) strcat(s, "i");
if (crc32("PCTUXlqfDxYQ",12) == 2681519927) strcat(s, "T");
if (crc32("ZUwMjGmVsYak",12) == 3773257413) strcat(s, "n");
if (crc32("bNBPOg",6) == 3937136877) strcat(s, "g");
if (crc32("KLOnMcyw",8) == 365685629) strcat(s, "X");
if (crc32("byhJgb",6) == 178497442) strcat(s, "l");
if (crc32("ejbJuFqQykCNBuA",15) == 1898509004) strcat(s, "y");
    return s;
}

char *nondeferentially_adverbs() {
    char *s = calloc(17);
    if (crc32("lPsMU",5) == 1332250202) strcat(s, "U");
if (crc32("NbdWZb",6) == 1497170777) strcat(s, "n");
if (crc32("OLdIyTzoC",9) == 717597703) strcat(s, "o");
if (crc32("PYiUXeIdtjOkhNm",15) == 1651282294) strcat(s, "T");
if (crc32("ddDqFs",6) == 1618950250) strcat(s, "n");
if (crc32("RulGBNTM",8) == 1791433685) strcat(s, "S");
if (crc32("MFIYs",5) == 83893456) strcat(s, "d");
if (crc32("FVhGIcADrHwbZNn",15) == 509969931) strcat(s, "I");
if (crc32("fRciNZqjql",10) == 2156890978) strcat(s, "e");
if (crc32("oYryUDNXjfpYq",13) == 2676566096) strcat(s, "f");
if (crc32("NfodkDAWbaLKqv",14) == 626628998) strcat(s, "e");
if (crc32("PREhix",6) == 4285542024) strcat(s, "r");
if (crc32("WrQDk",5) == 3293665076) strcat(s, "x");
if (crc32("bDqnXawlv",9) == 3955449397) strcat(s, "e");
if (crc32("PkEETzYnjKI",11) == 107272492) strcat(s, "Z");
if (crc32("CpMfmdQZG",9) == 1178842304) strcat(s, "n");
if (crc32("xMVKrPzf",8) == 667329449) strcat(s, "l");
if (crc32("DNAcQ",5) == 863934571) strcat(s, "t");
if (crc32("JkRBlESJbiB",11) == 1909927038) strcat(s, "F");
if (crc32("rrLEktnOqJbjVy",14) == 2724499139) strcat(s, "i");
if (crc32("sJqEsJjVJSxOJC",14) == 929422803) strcat(s, "Z");
if (crc32("LRaMtmjzLyOVvsU",15) == 2835481622) strcat(s, "a");
if (crc32("GLmJPrw",7) == 1317373024) strcat(s, "l");
if (crc32("sSoCpO",6) == 2382257242) strcat(s, "P");
if (crc32("joknJRYmglvvm",13) == 3282425199) strcat(s, "l");
if (crc32("YNXYuumFv",9) == 3350493090) strcat(s, "o");
if (crc32("SpIbmW",6) == 1243210353) strcat(s, "y");
    return s;
}

char *teemingly_adverbs() {
    char *s = calloc(10);
    if (crc32("dzyGPGhqQ",9) == 2844887161) strcat(s, "K");
if (crc32("jmwccqNZwmQVD",13) == 2924039704) strcat(s, "t");
if (crc32("QUZHWeNEP",9) == 3772963925) strcat(s, "e");
if (crc32("RtyZPOCOAB",10) == 2456040481) strcat(s, "e");
if (crc32("ejYxaWetdUGJNZ",14) == 1568428482) strcat(s, "m");
if (crc32("TNzZWy",6) == 2023023871) strcat(s, "i");
if (crc32("tWHYn",5) == 592506931) strcat(s, "n");
if (crc32("CIOCHdapA",9) == 164508997) strcat(s, "Y");
if (crc32("LCZuGXIdfA",10) == 2066077610) strcat(s, "g");
if (crc32("EkZqt",5) == 3127969490) strcat(s, "l");
if (crc32("OZYHUSGDxqvTJB",14) == 2942254780) strcat(s, "i");
if (crc32("oXbyQm",6) == 447710593) strcat(s, "y");
    return s;
}

char *quasiseriously_adverbs() {
    char *s = calloc(15);
    if (crc32("FoDiWfsGmU",10) == 803246295) strcat(s, "y");
if (crc32("wtRoRVYsqEv",11) == 1427952651) strcat(s, "q");
if (crc32("nOsZgVDK",8) == 1914640323) strcat(s, "P");
if (crc32("gBIwdYy",7) == 1066985494) strcat(s, "u");
if (crc32("UIYPvKvfwksTz",13) == 2795441286) strcat(s, "u");
if (crc32("oxGwAjJSdy",10) == 655854265) strcat(s, "a");
if (crc32("TUhoULyfCdPy",12) == 4253343779) strcat(s, "s");
if (crc32("rnlNne",6) == 477691850) strcat(s, "i");
if (crc32("XxAngwdhlyqaU",13) == 4185730279) strcat(s, "A");
if (crc32("xCUpCajV",8) == 390816267) strcat(s, "s");
if (crc32("EcrTDCQuNku",11) == 3975573095) strcat(s, "P");
if (crc32("DyEJrEqDvFzNik",14) == 2231299706) strcat(s, "e");
if (crc32("wNEugVIdA",9) == 3111468552) strcat(s, "r");
if (crc32("jyRjTCYCZmCHz",13) == 679175694) strcat(s, "Y");
if (crc32("LWKpKwFpprpNuc",14) == 2670142812) strcat(s, "i");
if (crc32("ZEbeVaJ",7) == 680030510) strcat(s, "o");
if (crc32("sxKTJiF",7) == 2589742996) strcat(s, "u");
if (crc32("iodcgh",6) == 1279816224) strcat(s, "a");
if (crc32("tsocBYvXjmjW",12) == 138387910) strcat(s, "s");
if (crc32("MAeCdUXZRoaYlzL",15) == 1864712653) strcat(s, "l");
if (crc32("TsYNHfskD",9) == 1489710595) strcat(s, "O");
if (crc32("JdypaZRdXyRCnGT",15) == 2802208842) strcat(s, "y");
    return s;
}

char *equably_adverbs() {
    char *s = calloc(8);
    if (crc32("kexUiMDV",8) == 249435915) strcat(s, "e");
if (crc32("EJnBKEXzJt",10) == 1159522773) strcat(s, "q");
if (crc32("rLmYLA",6) == 2635985871) strcat(s, "q");
if (crc32("IfWcWwNLYyb",11) == 3848655956) strcat(s, "s");
if (crc32("SHikLSILuzng",12) == 1527464804) strcat(s, "u");
if (crc32("thpVk",5) == 1452426412) strcat(s, "a");
if (crc32("OvScBqwz",8) == 3883230867) strcat(s, "L");
if (crc32("ITtGALfgVCqWGLn",15) == 3589185195) strcat(s, "b");
if (crc32("XEwgpInTUjX",11) == 2572168274) strcat(s, "k");
if (crc32("SPCbWxzgMLj",11) == 3681021208) strcat(s, "l");
if (crc32("VXfIQC",6) == 1195096634) strcat(s, "p");
if (crc32("aYHJnaBJxU",10) == 1057422728) strcat(s, "y");
    return s;
}

char *balmily_adverbs() {
    char *s = calloc(8);
    if (crc32("ZSMQrbNDMDB",11) == 2685857047) strcat(s, "I");
if (crc32("BHfSGgYvkxA",11) == 3517700683) strcat(s, "b");
if (crc32("lFfNqbGOUQ",10) == 37800286) strcat(s, "a");
if (crc32("XXQYJElHMkp",11) == 1318732199) strcat(s, "D");
if (crc32("MDJmxgUrvh",10) == 71636264) strcat(s, "l");
if (crc32("qllEFuCfrSoIV",13) == 1073214392) strcat(s, "m");
if (crc32("TDkiI",5) == 3766115431) strcat(s, "i");
if (crc32("cXCLEjHP",8) == 3296832262) strcat(s, "l");
if (crc32("KWbeD",5) == 2645798011) strcat(s, "l");
if (crc32("tWgqrJRt",8) == 2510650780) strcat(s, "k");
if (crc32("ndNpsCHcrVrHlh",14) == 27739341) strcat(s, "y");
    return s;
}

char *unpitiably_adverbs() {
    char *s = calloc(11);
    if (crc32("nBBrvl",6) == 819473364) strcat(s, "M");
if (crc32("SJmFoCZHKu",10) == 2567607896) strcat(s, "u");
if (crc32("CGoAPcvMKhje",12) == 3992160427) strcat(s, "z");
if (crc32("rEqfHIIeZjU",11) == 2811639827) strcat(s, "n");
if (crc32("tZozqyEPHcx",11) == 1722484526) strcat(s, "p");
if (crc32("mvQIhxDVCrLcK",13) == 2321308524) strcat(s, "c");
if (crc32("YVSpZp",6) == 2953367049) strcat(s, "i");
if (crc32("BWbYp",5) == 3269739328) strcat(s, "t");
if (crc32("OywqAYTmCpxgN",13) == 3841007023) strcat(s, "B");
if (crc32("RBKhnkhXCPOj",12) == 1004526717) strcat(s, "i");
if (crc32("NoVYQsCuu",9) == 3994298638) strcat(s, "a");
if (crc32("QhPTb",5) == 3576812633) strcat(s, "T");
if (crc32("bXXCGWxGdtfU",12) == 932130653) strcat(s, "b");
if (crc32("xGUFofqwzOYFS",13) == 3211460045) strcat(s, "l");
if (crc32("skTvXLDGpDJTPAl",15) == 148439422) strcat(s, "y");
    return s;
}

char *episodically_adverbs() {
    char *s = calloc(13);
    if (crc32("AdsyHOIvrM",10) == 1392424286) strcat(s, "e");
if (crc32("epXvPBOa",8) == 3267363425) strcat(s, "a");
if (crc32("RJpgFpsWP",9) == 2411924905) strcat(s, "p");
if (crc32("daEssXwZEloyGDk",15) == 1071823929) strcat(s, "i");
if (crc32("GTsgfEyPGjoSjY",14) == 2402594852) strcat(s, "s");
if (crc32("gHRjJ",5) == 408101384) strcat(s, "W");
if (crc32("FsPbcFgsYjxa",12) == 4108329455) strcat(s, "o");
if (crc32("WmQziF",6) == 3233585946) strcat(s, "d");
if (crc32("DGYWihX",7) == 3544114855) strcat(s, "i");
if (crc32("NDUwtzE",7) == 2601821521) strcat(s, "c");
if (crc32("VAYUkmGv",8) == 1695770587) strcat(s, "a");
if (crc32("ALtvQ",5) == 370741584) strcat(s, "b");
if (crc32("cChHzNHOhJnp",12) == 4095854312) strcat(s, "l");
if (crc32("RlnWtyNQqldtXUZ",15) == 2749249384) strcat(s, "x");
if (crc32("wQWCvkCu",8) == 3105947073) strcat(s, "l");
if (crc32("pXutJ",5) == 3190394456) strcat(s, "y");
    return s;
}

char *nondiplomatically_adverbs() {
    char *s = calloc(18);
    if (crc32("dXmhonCEqvS",11) == 1065487381) strcat(s, "h");
if (crc32("vkUnkDUpASXT",12) == 3282672945) strcat(s, "n");
if (crc32("FdBNMeayDnr",11) == 3160634762) strcat(s, "o");
if (crc32("MBtmwJOGUUhEiE",14) == 2696384007) strcat(s, "q");
if (crc32("iLhRsRYX",8) == 2535628831) strcat(s, "n");
if (crc32("DsfhWSeQDanNC",13) == 1703701674) strcat(s, "d");
if (crc32("GIchg",5) == 4270720222) strcat(s, "i");
if (crc32("iIsFXb",6) == 395963425) strcat(s, "p");
if (crc32("juClt",5) == 956484680) strcat(s, "L");
if (crc32("zXobmBDJMcTlitN",15) == 4294599857) strcat(s, "l");
if (crc32("chAeUpLWWQm",11) == 2032516237) strcat(s, "o");
if (crc32("sXEaNgME",8) == 1813594918) strcat(s, "x");
if (crc32("TAnPXWdLltLD",12) == 2410733183) strcat(s, "m");
if (crc32("zPdQSuZhypLCvt",14) == 4118440722) strcat(s, "H");
if (crc32("pgJePTaDL",9) == 2865806228) strcat(s, "a");
if (crc32("YtydFbsfKmkOb",13) == 2980037551) strcat(s, "t");
if (crc32("uhUzKQ",6) == 4109821810) strcat(s, "F");
if (crc32("qgFmtlYcXbACTIw",15) == 304056372) strcat(s, "i");
if (crc32("cvtWCI",6) == 281682740) strcat(s, "c");
if (crc32("mDUHJ",5) == 1999112787) strcat(s, "a");
if (crc32("leAHrYJknLr",11) == 998959839) strcat(s, "l");
if (crc32("PmOGGURbFJYfIvH",15) == 238043297) strcat(s, "l");
if (crc32("FdHCRRrLmdRLwPs",15) == 2541783203) strcat(s, "K");
if (crc32("erNubOilKcmKo",13) == 730361892) strcat(s, "y");
    return s;
}

char *simplistically_adverbs() {
    char *s = calloc(15);
    if (crc32("EwBShsh",7) == 1739232174) strcat(s, "V");
if (crc32("IayYqcxeAcVSZ",13) == 1190035794) strcat(s, "s");
if (crc32("byTlAndOASQDpMp",15) == 2359504986) strcat(s, "i");
if (crc32("DYmIWQ",6) == 1335457539) strcat(s, "m");
if (crc32("SNtWVoqZjtAIC",13) == 1521050300) strcat(s, "i");
if (crc32("aDWUkBxlHiMezHI",15) == 468042769) strcat(s, "p");
if (crc32("TCEaHWBgpiISZhC",15) == 2359360469) strcat(s, "l");
if (crc32("ZYjhyryQeSdivRT",15) == 3528096083) strcat(s, "i");
if (crc32("LHoHDEShajSQa",13) == 850868799) strcat(s, "I");
if (crc32("NDhENreYipVJv",13) == 3339193518) strcat(s, "s");
if (crc32("EdCgshVEAOp",11) == 1571235535) strcat(s, "t");
if (crc32("zZNbMR",6) == 2582800830) strcat(s, "i");
if (crc32("rAHVf",5) == 2473043662) strcat(s, "A");
if (crc32("csAXsmTGmLTMVE",14) == 1342409285) strcat(s, "c");
if (crc32("BlvTodnffKZzSOU",15) == 1445810785) strcat(s, "a");
if (crc32("zeQSJxkcSWlk",12) == 4047156010) strcat(s, "l");
if (crc32("mREckGKwfW",10) == 3530395238) strcat(s, "u");
if (crc32("YJOUEzxkH",9) == 1591243925) strcat(s, "l");
if (crc32("ZPnTZrjzZQPSMp",14) == 1159369233) strcat(s, "y");
    return s;
}

char *nextdoor_adverbs() {
    char *s = calloc(9);
    if (crc32("oHUKHFGIDA",10) == 622346897) strcat(s, "n");
if (crc32("pKTGCkAYsKWTk",13) == 1037751018) strcat(s, "X");
if (crc32("qaYnBwdhNPKUDTs",15) == 99137227) strcat(s, "e");
if (crc32("RzdmXpf",7) == 2307732739) strcat(s, "m");
if (crc32("urtqWdLJm",9) == 343118788) strcat(s, "x");
if (crc32("YqUmfLjfmhkvty",14) == 2398580274) strcat(s, "t");
if (crc32("udXRe",5) == 2494443007) strcat(s, "d");
if (crc32("gupvnnoMzkh",11) == 1277381745) strcat(s, "n");
if (crc32("QMwjygylj",9) == 3693405704) strcat(s, "o");
if (crc32("cXlwUEoi",8) == 1127297584) strcat(s, "o");
if (crc32("QPrjsZwXAe",10) == 537423408) strcat(s, "w");
if (crc32("QeNRkqW",7) == 1100556980) strcat(s, "r");
    return s;
}

char *magisterially_adverbs() {
    char *s = calloc(14);
    if (crc32("tgPxzMCf",8) == 3309311825) strcat(s, "m");
if (crc32("GMhGqjNkMe",10) == 1713995486) strcat(s, "a");
if (crc32("bZhajlApcalW",12) == 4115931064) strcat(s, "b");
if (crc32("DNvvGIhezbEtH",13) == 1306223296) strcat(s, "g");
if (crc32("BqxjcnueMK",10) == 3492328734) strcat(s, "i");
if (crc32("SnOoeDVHOWRi",12) == 903285742) strcat(s, "P");
if (crc32("qKvmmW",6) == 1972920337) strcat(s, "s");
if (crc32("zKULzSYYmQQwMBB",15) == 3205276975) strcat(s, "t");
if (crc32("vYWGafWtNoQGO",13) == 44709172) strcat(s, "e");
if (crc32("iHLIIoelAQgK",12) == 2661402086) strcat(s, "r");
if (crc32("JbExZblwjJ",10) == 3251574409) strcat(s, "i");
if (crc32("lxscXuRR",8) == 3602101083) strcat(s, "u");
if (crc32("nnzDLomxOLr",11) == 1114701476) strcat(s, "a");
if (crc32("MVlcKwNXvH",10) == 2197274290) strcat(s, "l");
if (crc32("DlcEP",5) == 3059080930) strcat(s, "l");
if (crc32("gFyEcfnQ",8) == 582919629) strcat(s, "a");
if (crc32("KMcdFaWcH",9) == 710979840) strcat(s, "y");
    return s;
}

char *lubriciously_adverbs() {
    char *s = calloc(13);
    if (crc32("YQPKk",5) == 633418446) strcat(s, "l");
if (crc32("lprgXOD",7) == 1154491887) strcat(s, "N");
if (crc32("cwVJpgztx",9) == 3632022478) strcat(s, "u");
if (crc32("RsvWzeQepYM",11) == 1237382573) strcat(s, "F");
if (crc32("voNfyi",6) == 2329488444) strcat(s, "b");
if (crc32("UynJgUAp",8) == 1414051176) strcat(s, "r");
if (crc32("iqJwmAdpdAkgq",13) == 2171492252) strcat(s, "I");
if (crc32("huMHC",5) == 2629193867) strcat(s, "i");
if (crc32("scPJF",5) == 842728353) strcat(s, "T");
if (crc32("sJTUtv",6) == 4061823601) strcat(s, "c");
if (crc32("elctglCf",8) == 2880719241) strcat(s, "i");
if (crc32("gvbCqBNr",8) == 488258818) strcat(s, "i");
if (crc32("QvPrXfHNhiPH",12) == 3164103063) strcat(s, "o");
if (crc32("DiEBLMUjMS",10) == 3300112851) strcat(s, "E");
if (crc32("yPthGNQAvjqDXsg",15) == 1753467802) strcat(s, "u");
if (crc32("PWtoJBi",7) == 1258902449) strcat(s, "s");
if (crc32("kaWGfBCcrNOIDPu",15) == 1858174277) strcat(s, "l");
if (crc32("oHlzukDrFuag",12) == 3631168858) strcat(s, "F");
if (crc32("QbPCXFvhQIlj",12) == 927747706) strcat(s, "y");
    return s;
}

char *monomolecularly_adverbs() {
    char *s = calloc(16);
    if (crc32("WXgmIaaPOFIoa",13) == 2423543149) strcat(s, "m");
if (crc32("vodSNIGtOVaCKyC",15) == 4033549973) strcat(s, "o");
if (crc32("dOtlpBHdfUTW",12) == 2292338852) strcat(s, "O");
if (crc32("tyTOMdGmWs",10) == 2252987243) strcat(s, "n");
if (crc32("qIPgxYOw",8) == 433625220) strcat(s, "m");
if (crc32("SHOyVEFqhpyG",12) == 1273347643) strcat(s, "o");
if (crc32("pyfvPffmB",9) == 2989305619) strcat(s, "m");
if (crc32("XLitCNfTBJLUrun",15) == 3520663564) strcat(s, "o");
if (crc32("ghmZiUps",8) == 200716805) strcat(s, "l");
if (crc32("DdiXpqED",8) == 1378303266) strcat(s, "e");
if (crc32("ZRNiHFtPR",9) == 2016824134) strcat(s, "A");
if (crc32("kSjGeDyIqxTwZHf",15) == 3614167624) strcat(s, "c");
if (crc32("ggWPOM",6) == 2580841163) strcat(s, "k");
if (crc32("FtkeB",5) == 823588512) strcat(s, "u");
if (crc32("QWJaXcqGTVXU",12) == 469976771) strcat(s, "l");
if (crc32("RiMVSJPJ",8) == 1537779048) strcat(s, "S");
if (crc32("UpcAAZ",6) == 776249756) strcat(s, "a");
if (crc32("eLrLUuEYuI",10) == 2124603901) strcat(s, "r");
if (crc32("YESYufdBX",9) == 3242736761) strcat(s, "B");
if (crc32("eogOIS",6) == 4235669139) strcat(s, "l");
if (crc32("sjTkKcO",7) == 474687161) strcat(s, "y");
    return s;
}

char *courageously_adverbs() {
    char *s = calloc(13);
    if (crc32("qGRlSCE",7) == 1297489515) strcat(s, "m");
if (crc32("GzwNwqdrCuvEGA",14) == 1133202720) strcat(s, "c");
if (crc32("jYgINVevR",9) == 426453046) strcat(s, "C");
if (crc32("gjHzqCvsJw",10) == 2829434076) strcat(s, "o");
if (crc32("uGsTySUqP",9) == 385850567) strcat(s, "T");
if (crc32("wbFSvyhx",8) == 2678256248) strcat(s, "u");
if (crc32("bVJvkiEGYLiQz",13) == 3630622859) strcat(s, "r");
if (crc32("AiYoUX",6) == 3288076224) strcat(s, "I");
if (crc32("vJeZekIBH",9) == 3514884690) strcat(s, "a");
if (crc32("EiTZYuziLIQHkE",14) == 2334965040) strcat(s, "h");
if (crc32("bLIQdkRbFl",10) == 146366826) strcat(s, "g");
if (crc32("BlVYUYv",7) == 4047919132) strcat(s, "h");
if (crc32("AHMqGXgmNblWbO",14) == 2169177856) strcat(s, "e");
if (crc32("mBkhBQLj",8) == 2397471685) strcat(s, "D");
if (crc32("TbwrQ",5) == 3393561949) strcat(s, "o");
if (crc32("eppsjywsOThWKC",14) == 1536585864) strcat(s, "X");
if (crc32("uwLWlbUEHbNLd",13) == 3971831372) strcat(s, "u");
if (crc32("qsxbZRTzTrbd",12) == 1848540920) strcat(s, "s");
if (crc32("gabOfnZBbYhJL",13) == 257161648) strcat(s, "i");
if (crc32("SQxBuNU",7) == 2549981685) strcat(s, "l");
if (crc32("dUVYJMXhkyucM",13) == 1359418185) strcat(s, "y");
    return s;
}

char *uncircuitously_adverbs() {
    char *s = calloc(15);
    if (crc32("YZYjnISsIpgjHD",14) == 2525990531) strcat(s, "H");
if (crc32("VCMxdEIGxxuko",13) == 3566144406) strcat(s, "u");
if (crc32("kGwUHIdIwO",10) == 2545716405) strcat(s, "g");
if (crc32("JARbLim",7) == 2488481292) strcat(s, "n");
if (crc32("JYNUNYfhpP",10) == 3851797022) strcat(s, "c");
if (crc32("zcpcZeGXmbKScc",14) == 3150008434) strcat(s, "q");
if (crc32("meRtGQX",7) == 981461316) strcat(s, "i");
if (crc32("BYfERZUMjLi",11) == 2365885583) strcat(s, "Q");
if (crc32("gXVHdDFsxOqxRTZ",15) == 206874132) strcat(s, "r");
if (crc32("YFGZg",5) == 469023279) strcat(s, "q");
if (crc32("tNKjriNmj",9) == 1514040663) strcat(s, "c");
if (crc32("lJAWUzbIDWo",11) == 2936374922) strcat(s, "u");
if (crc32("weUvMpdXmZrv",12) == 725813901) strcat(s, "J");
if (crc32("VJSfM",5) == 3504870602) strcat(s, "i");
if (crc32("ewTTw",5) == 1994820954) strcat(s, "j");
if (crc32("YOXOZISdzi",10) == 470711896) strcat(s, "t");
if (crc32("ydUDkXGjtljyWUp",15) == 1799133309) strcat(s, "o");
if (crc32("rGUcHxHuODRYwP",14) == 2945805911) strcat(s, "u");
if (crc32("LSVSZjtiTCiFAym",15) == 397408302) strcat(s, "s");
if (crc32("vGOOiNdmge",10) == 3501339211) strcat(s, "L");
if (crc32("uvvcmp",6) == 405587537) strcat(s, "l");
if (crc32("GpSfcrrSv",9) == 76235349) strcat(s, "z");
if (crc32("lYjUFcEQxWz",11) == 4111599129) strcat(s, "y");
    return s;
}

char *unlevelly_adverbs() {
    char *s = calloc(10);
    if (crc32("PTdoyCdnS",9) == 3820923229) strcat(s, "G");
if (crc32("vKhjpzTDLNtvt",13) == 1830547245) strcat(s, "u");
if (crc32("NLoPvMRie",9) == 672707624) strcat(s, "E");
if (crc32("BDnQKSzpXm",10) == 2974159055) strcat(s, "n");
if (crc32("QcqEeErN",8) == 3763948781) strcat(s, "l");
if (crc32("WBgbYfgD",8) == 3187987834) strcat(s, "e");
if (crc32("szBNjoM",7) == 484776955) strcat(s, "v");
if (crc32("rRcCMoMdqLzLh",13) == 3029622845) strcat(s, "k");
if (crc32("Nnytm",5) == 3647497165) strcat(s, "e");
if (crc32("slhuM",5) == 1848985464) strcat(s, "l");
if (crc32("oUUWaZTxA",9) == 2501504137) strcat(s, "l");
if (crc32("lUMIwKQjfplkweW",15) == 3079827293) strcat(s, "m");
if (crc32("moVMQv",6) == 2452138826) strcat(s, "l");
if (crc32("UyQOOEQaFGdJS",13) == 3329426479) strcat(s, "X");
if (crc32("tfsCeFOu",8) == 416957456) strcat(s, "y");
    return s;
}

char *bumblingly_adverbs() {
    char *s = calloc(11);
    if (crc32("LErjOY",6) == 1998423308) strcat(s, "T");
if (crc32("qbYHKlgtvkL",11) == 4208599014) strcat(s, "b");
if (crc32("fjtFEdosFH",10) == 554603133) strcat(s, "u");
if (crc32("MwtvT",5) == 3820447211) strcat(s, "L");
if (crc32("QeBhFYqa",8) == 527553343) strcat(s, "m");
if (crc32("nOZUr",5) == 1002136637) strcat(s, "b");
if (crc32("ccRIv",5) == 1833030563) strcat(s, "p");
if (crc32("sGgFpmLZVUY",11) == 2066365090) strcat(s, "l");
if (crc32("GgNQbV",6) == 2575342542) strcat(s, "b");
if (crc32("hYeRcDmofLFyfV",14) == 3907255155) strcat(s, "i");
if (crc32("lUVrVirWoAzyQJp",15) == 94630927) strcat(s, "n");
if (crc32("iuzKIwNWhLREv",13) == 3001533392) strcat(s, "g");
if (crc32("VQfsNNifRcD",11) == 1902340640) strcat(s, "L");
if (crc32("XUiUAXZYPjUiW",13) == 675306124) strcat(s, "l");
if (crc32("JijPSDqu",8) == 1591472545) strcat(s, "Y");
if (crc32("xoPWvktde",9) == 1675855897) strcat(s, "y");
    return s;
}

char *orientally_adverbs() {
    char *s = calloc(11);
    if (crc32("mbbdqamvGMCtTg",14) == 681787442) strcat(s, "K");
if (crc32("ncfaFOrtNKo",11) == 1792269817) strcat(s, "o");
if (crc32("kyyrIgD",7) == 692240231) strcat(s, "r");
if (crc32("bYQiDpxFz",9) == 941142792) strcat(s, "W");
if (crc32("SLgYD",5) == 1057168306) strcat(s, "i");
if (crc32("OisHjzZ",7) == 4213705169) strcat(s, "e");
if (crc32("LDYGBxbcQPBxl",13) == 4175016555) strcat(s, "q");
if (crc32("rKksTzqSCUd",11) == 3365706362) strcat(s, "n");
if (crc32("PzmlrbQVxWkgyMC",15) == 4153727217) strcat(s, "t");
if (crc32("uMtVGsnNPBumxRH",15) == 3299376295) strcat(s, "a");
if (crc32("lAhhABxGVs",10) == 3535328867) strcat(s, "T");
if (crc32("LEIIMsj",7) == 597347011) strcat(s, "l");
if (crc32("qpuskREIDzUEOYX",15) == 689739693) strcat(s, "l");
if (crc32("IgUuJYhdBMwKPgK",15) == 3014735909) strcat(s, "h");
if (crc32("DQlZTvc",7) == 3571664946) strcat(s, "y");
    return s;
}

char *aport_adverbs() {
    char *s = calloc(6);
    if (crc32("cJpsWgvMtfLGk",13) == 1003092093) strcat(s, "y");
if (crc32("TRLkWk",6) == 3738486766) strcat(s, "a");
if (crc32("AGLNuWIxJsmVmH",14) == 2319058755) strcat(s, "p");
if (crc32("CNkDxUz",7) == 179788395) strcat(s, "o");
if (crc32("TlnEg",5) == 1724940092) strcat(s, "r");
if (crc32("DiqyRZxkZ",9) == 2111257248) strcat(s, "t");
    return s;
}

char *superconfidently_adverbs() {
    char *s = calloc(17);
    if (crc32("WtMAboUGr",9) == 2598699952) strcat(s, "R");
if (crc32("dddXuabytvStUy",14) == 1369117151) strcat(s, "s");
if (crc32("WGjbhcVjSc",10) == 1125502208) strcat(s, "e");
if (crc32("XpXNrUuMJFeT",12) == 2469770516) strcat(s, "u");
if (crc32("xFjQSfWnlsxbuuf",15) == 3883302057) strcat(s, "p");
if (crc32("dreJAJ",6) == 1829728054) strcat(s, "x");
if (crc32("EyEaoyuAH",9) == 3665972395) strcat(s, "e");
if (crc32("joeXYg",6) == 3577153500) strcat(s, "r");
if (crc32("eCoWYrCWJPCHQUY",15) == 1855689776) strcat(s, "f");
if (crc32("UlPJGeGwNoEiMa",14) == 878570032) strcat(s, "c");
if (crc32("FznLmwIuE",9) == 1778236398) strcat(s, "o");
if (crc32("YrQDJpG",7) == 927880171) strcat(s, "v");
if (crc32("WaiHBEwEpffQypJ",15) == 3666398614) strcat(s, "n");
if (crc32("ymBRTuoM",8) == 2890447412) strcat(s, "a");
if (crc32("BTogLoAYw",9) == 2231924373) strcat(s, "f");
if (crc32("fSZAVyiKOqp",11) == 3963905792) strcat(s, "O");
if (crc32("anlgGQY",7) == 3164782067) strcat(s, "i");
if (crc32("HMNCP",5) == 445346917) strcat(s, "I");
if (crc32("MIKlLLsFimv",11) == 444111080) strcat(s, "d");
if (crc32("UbDVxiXBPfPKwGZ",15) == 4034147362) strcat(s, "i");
if (crc32("rbZBFhs",7) == 4029073322) strcat(s, "e");
if (crc32("sRVMTLbGACAECIw",15) == 456362950) strcat(s, "g");
if (crc32("GFBFAgeAFXeP",12) == 262737755) strcat(s, "n");
if (crc32("azIJqmkETK",10) == 1794699131) strcat(s, "t");
if (crc32("tTuTys",6) == 3964121988) strcat(s, "l");
if (crc32("rdCBKxTJWCNzuR",14) == 3745678706) strcat(s, "h");
if (crc32("zZPnbs",6) == 2119931973) strcat(s, "y");
    return s;
}

char *quincuncially_adverbs() {
    char *s = calloc(14);
    if (crc32("wsfhtzW",7) == 2731705874) strcat(s, "q");
if (crc32("YcmNEdrjJ",9) == 3281396242) strcat(s, "u");
if (crc32("kwocuVhxHteMFz",14) == 306083396) strcat(s, "z");
if (crc32("HAMGxSCBp",9) == 2709077455) strcat(s, "i");
if (crc32("sRdbQgTBSz",10) == 3014787397) strcat(s, "n");
if (crc32("YClTdfKiD",9) == 2405237993) strcat(s, "n");
if (crc32("UCBuQBqwUSAqd",13) == 3022640551) strcat(s, "c");
if (crc32("dIqmqxyb",8) == 2515275968) strcat(s, "u");
if (crc32("eTfIbsorQ",9) == 4183872227) strcat(s, "W");
if (crc32("tPfxpbQJCVqLuD",14) == 3794928813) strcat(s, "n");
if (crc32("KjscO",5) == 1134443342) strcat(s, "c");
if (crc32("WMjJQUlyt",9) == 3529476537) strcat(s, "i");
if (crc32("twgvgWPMWWJi",12) == 2858550539) strcat(s, "a");
if (crc32("BOzFxnXAnwvA",12) == 2102753944) strcat(s, "l");
if (crc32("TpqUXxmjRYYP",12) == 2803072984) strcat(s, "l");
if (crc32("ktYLgmVKReFsC",13) == 3572579417) strcat(s, "t");
if (crc32("LSUbaUOrA",9) == 239237435) strcat(s, "y");
    return s;
}

char *expletively_adverbs() {
    char *s = calloc(12);
    if (crc32("IDhxbpsZTeP",11) == 1829050635) strcat(s, "Y");
if (crc32("xhXwBuTqmWN",11) == 817075358) strcat(s, "e");
if (crc32("cQuiUadgTcUSvb",14) == 3556939516) strcat(s, "f");
if (crc32("tzolWbFhrIUkJyn",15) == 737086100) strcat(s, "x");
if (crc32("okRzFTMskLHAHa",14) == 802871841) strcat(s, "p");
if (crc32("RgicBX",6) == 725862750) strcat(s, "C");
if (crc32("ccfCXbrkmkSIj",13) == 55507740) strcat(s, "l");
if (crc32("pLhxYrppCbxV",12) == 2578730409) strcat(s, "O");
if (crc32("AqTunHgbPxoQyJM",15) == 1992740030) strcat(s, "e");
if (crc32("EiVUAK",6) == 4127749433) strcat(s, "t");
if (crc32("qhPCFrcPYLo",11) == 3579411306) strcat(s, "i");
if (crc32("lHjXgD",6) == 3410914700) strcat(s, "v");
if (crc32("cXPjDniTy",9) == 1226595305) strcat(s, "e");
if (crc32("fgJICBG",7) == 3431924785) strcat(s, "l");
if (crc32("gXFCgwUdrZdcH",13) == 2979084721) strcat(s, "V");
if (crc32("bFMFAn",6) == 2102190482) strcat(s, "y");
    return s;
}

char *dreamlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("iLDdRKJdtWuZBqf",15) == 3299345925) strcat(s, "l");
if (crc32("hknlvk",6) == 2193014300) strcat(s, "d");
if (crc32("hkQmK",5) == 3747902182) strcat(s, "r");
if (crc32("XIGmC",5) == 1645148709) strcat(s, "e");
if (crc32("TQTKECE",7) == 2802948429) strcat(s, "a");
if (crc32("WScUzBWOLBAeUZ",14) == 186509868) strcat(s, "M");
if (crc32("RPqrrnozOoTTPm",14) == 1664439235) strcat(s, "m");
if (crc32("CkZyyPoWV",9) == 2041738943) strcat(s, "w");
if (crc32("eXeSpozonfwNN",13) == 2344769054) strcat(s, "l");
if (crc32("fXUXNxgXPMBrS",13) == 875177529) strcat(s, "z");
if (crc32("XiDMhxnkrhlC",12) == 1934477968) strcat(s, "e");
if (crc32("WCZQZ",5) == 1579464671) strcat(s, "v");
if (crc32("pFIPs",5) == 2373180334) strcat(s, "s");
if (crc32("qGeioteSfKSIso",14) == 2450907852) strcat(s, "K");
if (crc32("gAORTpnHnk",10) == 3071033467) strcat(s, "s");
if (crc32("PmNAcixJdK",10) == 8583369) strcat(s, "l");
if (crc32("YXHTREpmNgZI",12) == 2820563876) strcat(s, "y");
    return s;
}

char *regrettably_adverbs() {
    char *s = calloc(12);
    if (crc32("dwkWsbOYYPZfc",13) == 63628216) strcat(s, "r");
if (crc32("pRdgB",5) == 2533825002) strcat(s, "d");
if (crc32("CUDxFrpwE",9) == 1868169096) strcat(s, "e");
if (crc32("GjplbSThNW",10) == 1190997972) strcat(s, "N");
if (crc32("EGyYeLDPyRcK",12) == 2573258827) strcat(s, "g");
if (crc32("tCRCzy",6) == 183231085) strcat(s, "f");
if (crc32("mvtpRgHXGSd",11) == 1670537071) strcat(s, "r");
if (crc32("GQGymnAUi",9) == 1347828240) strcat(s, "e");
if (crc32("OecVb",5) == 364228715) strcat(s, "t");
if (crc32("TedMt",5) == 2577280504) strcat(s, "n");
if (crc32("PrOSLnPqTQh",11) == 3938352024) strcat(s, "t");
if (crc32("hchCqVkZNQFJcdn",15) == 1917425109) strcat(s, "j");
if (crc32("tuypaUlDAI",10) == 707913485) strcat(s, "a");
if (crc32("wwjpqBkYAGbOFs",14) == 3706419530) strcat(s, "b");
if (crc32("JaWIzRxuJWnieEt",15) == 3116831187) strcat(s, "l");
if (crc32("vnwXXTyfFQtgFJ",14) == 1043694347) strcat(s, "y");
    return s;
}

char *unapplicably_adverbs() {
    char *s = calloc(13);
    if (crc32("leAoohSuvCJGKW",14) == 199056839) strcat(s, "u");
if (crc32("JmRUF",5) == 711339841) strcat(s, "n");
if (crc32("qFHiG",5) == 2360195068) strcat(s, "d");
if (crc32("hXaxvQZrf",9) == 2417040971) strcat(s, "a");
if (crc32("GjQfLWfb",8) == 3429874448) strcat(s, "B");
if (crc32("oZgWzltEtlnNC",13) == 3374574697) strcat(s, "p");
if (crc32("whXFaZdWIvC",11) == 194078815) strcat(s, "p");
if (crc32("eZiIpxcvtKxr",12) == 3356295430) strcat(s, "W");
if (crc32("xgmLFvphPan",11) == 2297628087) strcat(s, "l");
if (crc32("zfGJlJWhazBg",12) == 114332184) strcat(s, "y");
if (crc32("BXfwUan",7) == 4062499230) strcat(s, "i");
if (crc32("xBTmkIsjENGWFfb",15) == 589616963) strcat(s, "c");
if (crc32("LUCAqNiYUiuFWAx",15) == 1519802597) strcat(s, "a");
if (crc32("zVoLxnvjRbMi",12) == 3435272973) strcat(s, "b");
if (crc32("wlISKWp",7) == 3684872944) strcat(s, "c");
if (crc32("jMymwnnkzLUs",12) == 3521045699) strcat(s, "l");
if (crc32("gQZaxIicccSArda",15) == 547749461) strcat(s, "H");
if (crc32("uhdmNfT",7) == 1203808912) strcat(s, "y");
    return s;
}

char *frontwards_adverbs() {
    char *s = calloc(11);
    if (crc32("iaDOlyUsVNNMr",13) == 2224444816) strcat(s, "f");
if (crc32("pbUTYKzho",9) == 660850723) strcat(s, "z");
if (crc32("ZLEKggVP",8) == 1044014292) strcat(s, "r");
if (crc32("DgDJOOONvf",10) == 1092567164) strcat(s, "o");
if (crc32("UcTUFlGFfxIc",12) == 1235490334) strcat(s, "n");
if (crc32("cIxXYbL",7) == 4005435789) strcat(s, "c");
if (crc32("dHwpghpL",8) == 435336943) strcat(s, "t");
if (crc32("NEZvaJxTLqRS",12) == 13700413) strcat(s, "w");
if (crc32("hpGPJKB",7) == 4187743650) strcat(s, "a");
if (crc32("IUXfPJbcpCGLixi",15) == 3952618219) strcat(s, "w");
if (crc32("grVVKtjXFm",10) == 393321289) strcat(s, "r");
if (crc32("eqmeF",5) == 2202659821) strcat(s, "d");
if (crc32("xUniKRNVocnmQnY",15) == 2847315637) strcat(s, "s");
    return s;
}

char *uninnately_adverbs() {
    char *s = calloc(11);
    if (crc32("UNJDdcTgoYEqQ",13) == 2675883222) strcat(s, "M");
if (crc32("WBKmNuJzl",9) == 1042268697) strcat(s, "u");
if (crc32("bMZvLkxTl",9) == 3452926740) strcat(s, "n");
if (crc32("TYSkpRFAXnHl",12) == 1603452432) strcat(s, "i");
if (crc32("CeBpwjDJncKxWbd",15) == 2011772514) strcat(s, "n");
if (crc32("qHqkAYSqPPpiCKt",15) == 4215973895) strcat(s, "n");
if (crc32("rxLgDaSXqxfK",12) == 308723404) strcat(s, "a");
if (crc32("LyEWZEOQWivG",12) == 3316724977) strcat(s, "e");
if (crc32("zEfxwBGx",8) == 1033809633) strcat(s, "t");
if (crc32("XDpNU",5) == 1426472333) strcat(s, "Q");
if (crc32("UQoneZoUBHgViD",14) == 2007137391) strcat(s, "e");
if (crc32("nUhTZyJEktQU",12) == 3664355780) strcat(s, "l");
if (crc32("gaKjRBhzU",9) == 3606247387) strcat(s, "y");
    return s;
}

char *gayly_adverbs() {
    char *s = calloc(6);
    if (crc32("EUzzdmkrAKpTh",13) == 2468032696) strcat(s, "g");
if (crc32("KIdDhPhG",8) == 702695037) strcat(s, "a");
if (crc32("QQEMJFGDaHyXkBu",15) == 1991241843) strcat(s, "y");
if (crc32("DsVbNjTFKRtXCqm",15) == 3108890086) strcat(s, "A");
if (crc32("rUOBtuMS",8) == 659918962) strcat(s, "l");
if (crc32("RMSEWyzKDSA",11) == 3628408524) strcat(s, "y");
    return s;
}

char *lankily_adverbs() {
    char *s = calloc(8);
    if (crc32("smgcaJKDgqrxz",13) == 618307227) strcat(s, "l");
if (crc32("enbljaMudLZWxI",14) == 568053045) strcat(s, "A");
if (crc32("UhAfKbDvwLAdt",13) == 3759655055) strcat(s, "a");
if (crc32("OrmQy",5) == 398568812) strcat(s, "n");
if (crc32("FUiPutZlUlxbcsK",15) == 3226696846) strcat(s, "k");
if (crc32("PgOHsQ",6) == 870243661) strcat(s, "i");
if (crc32("EwqEdV",6) == 2213467155) strcat(s, "l");
if (crc32("vAnizaXjUaX",11) == 3118413617) strcat(s, "H");
if (crc32("rAKvYuLws",9) == 4279022806) strcat(s, "y");
    return s;
}

char *tryingly_adverbs() {
    char *s = calloc(9);
    if (crc32("wqSRWPDTmPpPIdU",15) == 1211989339) strcat(s, "G");
if (crc32("bzRoqMzoDHOAPOh",15) == 4244482252) strcat(s, "t");
if (crc32("iVWeNqz",7) == 598628631) strcat(s, "r");
if (crc32("hVvtv",5) == 592439286) strcat(s, "y");
if (crc32("vVglyuYYlZDbog",14) == 1127403357) strcat(s, "i");
if (crc32("bsRYV",5) == 1824284985) strcat(s, "Y");
if (crc32("ScKRnCyg",8) == 2811731677) strcat(s, "n");
if (crc32("fehCQLoYIha",11) == 470043295) strcat(s, "g");
if (crc32("vlxqmLutDtbQGgI",15) == 3381573527) strcat(s, "A");
if (crc32("BtMybqqmiSJRo",13) == 1801724701) strcat(s, "l");
if (crc32("iLitDuwBEXUfzuq",15) == 3696143431) strcat(s, "p");
if (crc32("gAMRjyNpARWsrDz",15) == 3652134577) strcat(s, "y");
    return s;
}

char *diametrally_adverbs() {
    char *s = calloc(12);
    if (crc32("hYUNBlKOGv",10) == 332491095) strcat(s, "j");
if (crc32("eEDNWqHctFK",11) == 4265031561) strcat(s, "d");
if (crc32("aMnHTPjTMtHQfFu",15) == 4047349869) strcat(s, "R");
if (crc32("eresdxnVmH",10) == 247578688) strcat(s, "i");
if (crc32("cSuxikor",8) == 3857991511) strcat(s, "a");
if (crc32("fFPYjRWy",8) == 3303830151) strcat(s, "v");
if (crc32("PitQJADSfjsk",12) == 3264769356) strcat(s, "m");
if (crc32("sbiNf",5) == 1683096771) strcat(s, "e");
if (crc32("LazpNhnYCuH",11) == 2016080078) strcat(s, "t");
if (crc32("PvhcGvFiCxMzckz",15) == 974806863) strcat(s, "V");
if (crc32("XTiphDtIpyyw",12) == 571335356) strcat(s, "r");
if (crc32("raEEyFlRfew",11) == 17977938) strcat(s, "a");
if (crc32("YrAWyrNUgoUBV",13) == 816684259) strcat(s, "i");
if (crc32("CRLqsUD",7) == 126062918) strcat(s, "l");
if (crc32("IJHTbROvqEe",11) == 3611407828) strcat(s, "l");
if (crc32("UZoMhxV",7) == 279105316) strcat(s, "y");
    return s;
}

char *nonterminatively_adverbs() {
    char *s = calloc(17);
    if (crc32("zpHfpwgdWm",10) == 2405061979) strcat(s, "n");
if (crc32("wVriu",5) == 2694017759) strcat(s, "o");
if (crc32("XPIVZmnEwzzZrr",14) == 2499607939) strcat(s, "o");
if (crc32("syShZxpZ",8) == 1200000261) strcat(s, "n");
if (crc32("nMaPmbJc",8) == 571919760) strcat(s, "t");
if (crc32("qODbYrwIsxB",11) == 3304523510) strcat(s, "U");
if (crc32("tjvLJuBObVBtV",13) == 269091885) strcat(s, "e");
if (crc32("OkIldFCKeBygKB",14) == 1303768626) strcat(s, "L");
if (crc32("LXqvRK",6) == 726113131) strcat(s, "r");
if (crc32("XxXzPHrhsKTFrO",14) == 3759255293) strcat(s, "m");
if (crc32("eWOMmUrCMWOKDK",14) == 2857747717) strcat(s, "C");
if (crc32("ofumfFEnGJJ",11) == 374327094) strcat(s, "i");
if (crc32("GUzOsMFMYyb",11) == 2958966911) strcat(s, "n");
if (crc32("tqIwEjWmPQ",10) == 3450685642) strcat(s, "t");
if (crc32("KZBnHzubKc",10) == 1383085122) strcat(s, "a");
if (crc32("VkNez",5) == 1686492254) strcat(s, "V");
if (crc32("gHMALHzMuROCN",13) == 2130693722) strcat(s, "t");
if (crc32("MuXqrZPrZb",10) == 3053399174) strcat(s, "i");
if (crc32("lncMEsEjpmwbdy",14) == 3940044574) strcat(s, "U");
if (crc32("JKmJvzzKmgRT",12) == 4239329729) strcat(s, "v");
if (crc32("kjlGvbi",7) == 3332753806) strcat(s, "b");
if (crc32("zGZYRvmGsJj",11) == 1500494013) strcat(s, "e");
if (crc32("QMZtmZgXg",9) == 3556630439) strcat(s, "N");
if (crc32("nZwRnJHan",9) == 2752077179) strcat(s, "l");
if (crc32("YYSElcBqzCLSe",13) == 2711806914) strcat(s, "y");
    return s;
}

char *reputedly_adverbs() {
    char *s = calloc(10);
    if (crc32("TiWkyegKvOsK",12) == 1778562362) strcat(s, "r");
if (crc32("Ulwjq",5) == 3239015928) strcat(s, "F");
if (crc32("HZFIOaVrKO",10) == 2707152833) strcat(s, "e");
if (crc32("iTzBVXPpxuPxyeY",15) == 356840758) strcat(s, "j");
if (crc32("iBjbUZYmNV",10) == 1460030925) strcat(s, "p");
if (crc32("PVMlitgIwwnZxx",14) == 118662568) strcat(s, "J");
if (crc32("oozaAHlDABssX",13) == 3595353067) strcat(s, "u");
if (crc32("tSQUGuoYLJCcF",13) == 2321021143) strcat(s, "U");
if (crc32("gxTXZZPO",8) == 1723098009) strcat(s, "t");
if (crc32("FBatbXpDtlP",11) == 4045796441) strcat(s, "G");
if (crc32("hRUVrb",6) == 1038157485) strcat(s, "e");
if (crc32("ITibVQ",6) == 1450813986) strcat(s, "i");
if (crc32("WhKgHZnIit",10) == 3008526068) strcat(s, "d");
if (crc32("mqwFVdBqVM",10) == 3882406272) strcat(s, "c");
if (crc32("HlIerB",6) == 600872538) strcat(s, "l");
if (crc32("jrRxUrSrvODKP",13) == 1365525992) strcat(s, "H");
if (crc32("uDxjskDz",8) == 485017639) strcat(s, "y");
    return s;
}

char *undoubtfully_adverbs() {
    char *s = calloc(13);
    if (crc32("blMwyzunfcReSR",14) == 2285195702) strcat(s, "J");
if (crc32("JQCNmjIFsGGsIDQ",15) == 1925620025) strcat(s, "u");
if (crc32("vWbTSi",6) == 3119002155) strcat(s, "n");
if (crc32("klisqi",6) == 2648718269) strcat(s, "d");
if (crc32("LtCslrNYkrPtv",13) == 2632869462) strcat(s, "Z");
if (crc32("dlkZDDIkY",9) == 378969836) strcat(s, "o");
if (crc32("sJnmJ",5) == 2297073173) strcat(s, "u");
if (crc32("exAXsutAkcqCGTG",15) == 328243141) strcat(s, "b");
if (crc32("xAqVJIGEWDXoWz",14) == 1028705118) strcat(s, "t");
if (crc32("JzUlJzPUvoq",11) == 445858544) strcat(s, "f");
if (crc32("GTcdsDCFF",9) == 3481330642) strcat(s, "Y");
if (crc32("PTBfqwbljRCu",12) == 2863407628) strcat(s, "u");
if (crc32("EzuvHnASCZ",10) == 3509310242) strcat(s, "n");
if (crc32("yYkaFECHGSCWZnR",15) == 1919663882) strcat(s, "l");
if (crc32("nXBzDbsIlNYNBKc",15) == 2148098018) strcat(s, "D");
if (crc32("WcgUwRDB",8) == 4035626193) strcat(s, "l");
if (crc32("WLvDqokLjJivpm",14) == 1016453420) strcat(s, "y");
    return s;
}

char *unsuspectingly_adverbs() {
    char *s = calloc(15);
    if (crc32("frMfOpfLpfN",11) == 2430619777) strcat(s, "u");
if (crc32("pwlvcjhaGrZx",12) == 3197085977) strcat(s, "n");
if (crc32("CntKSBeHA",9) == 2147880735) strcat(s, "s");
if (crc32("nGOGCZBUbr",10) == 732338277) strcat(s, "o");
if (crc32("AuBUAsiDz",9) == 996015373) strcat(s, "u");
if (crc32("bGbwlXS",7) == 1204805944) strcat(s, "s");
if (crc32("QQNEnP",6) == 4107912026) strcat(s, "o");
if (crc32("tFziyOm",7) == 3066339104) strcat(s, "p");
if (crc32("bclzOobbSd",10) == 447081975) strcat(s, "R");
if (crc32("NUHXpEPzYgvL",12) == 395575884) strcat(s, "e");
if (crc32("YTgMRqePoC",10) == 2663859925) strcat(s, "c");
if (crc32("pkERzSbvDiZslb",14) == 103506624) strcat(s, "T");
if (crc32("wRfoSuE",7) == 3134608858) strcat(s, "t");
if (crc32("OouMR",5) == 3981210875) strcat(s, "i");
if (crc32("UVWyBdRBo",9) == 101223921) strcat(s, "D");
if (crc32("dBtOCQQzOWyoYOc",15) == 843139710) strcat(s, "n");
if (crc32("NKZtNqCut",9) == 3489972592) strcat(s, "g");
if (crc32("mmoKWbEgaosay",13) == 1717035783) strcat(s, "n");
if (crc32("WXbtetmGYIB",11) == 1041676189) strcat(s, "l");
if (crc32("jeZIgJvCCuZAuu",14) == 620257191) strcat(s, "p");
if (crc32("mGZcibrDejv",11) == 2443681783) strcat(s, "y");
    return s;
}

char *gruffly_adverbs() {
    char *s = calloc(8);
    if (crc32("zUcZDArUPax",11) == 3426413884) strcat(s, "g");
if (crc32("oqTEzUvjQIkqA",13) == 3881989960) strcat(s, "r");
if (crc32("yETKVutO",8) == 164661772) strcat(s, "d");
if (crc32("UwNAkDaAbOL",11) == 1556493426) strcat(s, "u");
if (crc32("qOqKwfptlFXA",12) == 4287024162) strcat(s, "k");
if (crc32("qBofjqQFrFNxb",13) == 1572645485) strcat(s, "f");
if (crc32("amjOootkDAsfX",13) == 1162929603) strcat(s, "Q");
if (crc32("hEvRcqLJtDV",11) == 1003913168) strcat(s, "f");
if (crc32("jwXSpKBs",8) == 773223180) strcat(s, "b");
if (crc32("djGsLUP",7) == 226794718) strcat(s, "l");
if (crc32("XALRlDvCGtj",11) == 1126876701) strcat(s, "y");
    return s;
}

char *mistrustfully_adverbs() {
    char *s = calloc(14);
    if (crc32("KGEmbH",6) == 4253544366) strcat(s, "m");
if (crc32("fEolbdX",7) == 1870658930) strcat(s, "i");
if (crc32("TBdkxSjH",8) == 1027153664) strcat(s, "s");
if (crc32("ZidOkex",7) == 2773373585) strcat(s, "A");
if (crc32("tQxryPXAKdHlnm",14) == 2967534775) strcat(s, "t");
if (crc32("kvHaBgAgsnGO",12) == 1523641758) strcat(s, "r");
if (crc32("RMxTeMN",7) == 2374130109) strcat(s, "u");
if (crc32("SGbjpM",6) == 856397532) strcat(s, "Q");
if (crc32("XGdjBMWSCE",10) == 2414625882) strcat(s, "s");
if (crc32("dCwnllmYmLBuItL",15) == 4121354539) strcat(s, "t");
if (crc32("YsdjnEMUnsf",11) == 260622192) strcat(s, "f");
if (crc32("ORCIBNNTr",9) == 356027045) strcat(s, "W");
if (crc32("iTjLQqpvakd",11) == 805795369) strcat(s, "u");
if (crc32("VGkrkKuUdtjRrH",14) == 268780222) strcat(s, "l");
if (crc32("rsEHVAylvlXDC",13) == 1659522508) strcat(s, "a");
if (crc32("tsYZQIQJvVyrE",13) == 735644139) strcat(s, "l");
if (crc32("mIcwToJufzJgrJe",15) == 3023459112) strcat(s, "y");
    return s;
}

char *uncheerfully_adverbs() {
    char *s = calloc(13);
    if (crc32("mBrDbYxnOouP",12) == 3907821911) strcat(s, "P");
if (crc32("iCporTujyUGLi",13) == 306250875) strcat(s, "u");
if (crc32("FFKBtjheSCxzD",13) == 2800848582) strcat(s, "n");
if (crc32("bsszeUAHtbwqINl",15) == 4059666851) strcat(s, "E");
if (crc32("yZgdzn",6) == 2042190757) strcat(s, "c");
if (crc32("CjanCgjvmISe",12) == 140563532) strcat(s, "h");
if (crc32("PdUQJHXrYT",10) == 1535570742) strcat(s, "e");
if (crc32("hUgFMUnjAzvZZ",13) == 2943204432) strcat(s, "e");
if (crc32("ILGFQLlNFr",10) == 1873673716) strcat(s, "R");
if (crc32("mDlZwXXHK",9) == 4189817541) strcat(s, "r");
if (crc32("sziDV",5) == 3094583525) strcat(s, "r");
if (crc32("PNKmbu",6) == 556876965) strcat(s, "f");
if (crc32("JKTjNjgRwCsbecF",15) == 36128866) strcat(s, "u");
if (crc32("zfenjaBzALHix",13) == 671887794) strcat(s, "J");
if (crc32("GUSXyVaYoo",10) == 677104633) strcat(s, "l");
if (crc32("vkecBklz",8) == 3809750890) strcat(s, "B");
if (crc32("uORKdbhNtIeeWv",14) == 1982359236) strcat(s, "l");
if (crc32("EnZwRC",6) == 1510165951) strcat(s, "y");
    return s;
}

char *auteciously_adverbs() {
    char *s = calloc(12);
    if (crc32("pZNbbJdpIeF",11) == 617651883) strcat(s, "N");
if (crc32("kCArmEpP",8) == 555691761) strcat(s, "a");
if (crc32("lRQZVCMNXQEzDZK",15) == 2010235035) strcat(s, "u");
if (crc32("hlnCfj",6) == 653886828) strcat(s, "c");
if (crc32("PBowGpuOG",9) == 3635779770) strcat(s, "t");
if (crc32("vtXuMTcDNcRtIsK",15) == 742521953) strcat(s, "e");
if (crc32("ULBXAAZibzUuYFz",15) == 3344821177) strcat(s, "c");
if (crc32("nOxwTfBTQmY",11) == 730571705) strcat(s, "i");
if (crc32("lJjGgqybnWj",11) == 2744276594) strcat(s, "o");
if (crc32("xXoBnVzH",8) == 3690354877) strcat(s, "q");
if (crc32("yVRWMAN",7) == 705037980) strcat(s, "u");
if (crc32("yCDCQsFnztod",12) == 3105739026) strcat(s, "s");
if (crc32("KvaIABFa",8) == 3288784319) strcat(s, "l");
if (crc32("CCIgfddoLpH",11) == 2750654692) strcat(s, "y");
    return s;
}

char *nonvocally_adverbs() {
    char *s = calloc(11);
    if (crc32("cbOAwWrQWE",10) == 3114530123) strcat(s, "c");
if (crc32("UweVnoAlYd",10) == 2586065346) strcat(s, "n");
if (crc32("lrcImYJhuoAYze",14) == 2477079980) strcat(s, "s");
if (crc32("bbxmRgZxqqKImIs",15) == 1712632722) strcat(s, "o");
if (crc32("wXUegcC",7) == 1156057376) strcat(s, "n");
if (crc32("UjpkR",5) == 903301669) strcat(s, "v");
if (crc32("FxsXPAiMQ",9) == 1375625270) strcat(s, "r");
if (crc32("MuusypokmcfqGaJ",15) == 944909491) strcat(s, "o");
if (crc32("PIjQqcTRiqnVWXx",15) == 2967421033) strcat(s, "n");
if (crc32("LGtbmhWdoHxvAt",14) == 1738136120) strcat(s, "c");
if (crc32("XkAykXxn",8) == 2582824153) strcat(s, "a");
if (crc32("pqcWmBc",7) == 1875488417) strcat(s, "l");
if (crc32("vabfPxRzD",9) == 3870561996) strcat(s, "l");
if (crc32("cxhgWJ",6) == 224677249) strcat(s, "J");
if (crc32("XNtvflSBlvvZov",14) == 2685577399) strcat(s, "y");
    return s;
}

char *helpingly_adverbs() {
    char *s = calloc(10);
    if (crc32("eSHTbvKvbh",10) == 2300337826) strcat(s, "h");
if (crc32("VXMaNK",6) == 2661878908) strcat(s, "y");
if (crc32("NjNFLazl",8) == 2635145333) strcat(s, "e");
if (crc32("FTFeDMcttCrORX",14) == 2043447635) strcat(s, "l");
if (crc32("rJUyuHRCic",10) == 3883062001) strcat(s, "I");
if (crc32("vAAwEGlUPYGC",12) == 3578215751) strcat(s, "p");
if (crc32("wfEQPwSaajO",11) == 2488383539) strcat(s, "i");
if (crc32("OLRjnnLRzwY",11) == 1017269496) strcat(s, "G");
if (crc32("VVaHirniicyVaxd",15) == 2912238797) strcat(s, "n");
if (crc32("yqyScAICLixrzdz",15) == 2445759997) strcat(s, "z");
if (crc32("pvhNlSKyHBP",11) == 2649464622) strcat(s, "g");
if (crc32("UMSAzwIVhwpqgvK",15) == 1001662047) strcat(s, "l");
if (crc32("qETTkVrTCDyaTv",14) == 4243578552) strcat(s, "y");
    return s;
}

char *Anglice_adverbs() {
    char *s = calloc(8);
    if (crc32("XSNqHnAqnVvh",12) == 2935840812) strcat(s, "T");
if (crc32("yofsIIRs",8) == 332046638) strcat(s, "A");
if (crc32("ZPBJTStQrscJAh",14) == 2502418524) strcat(s, "n");
if (crc32("TlXUEXKDeHiKWJZ",15) == 2755371621) strcat(s, "v");
if (crc32("fqQtFFsN",8) == 2905047206) strcat(s, "g");
if (crc32("KaMswkoZjZh",11) == 530202126) strcat(s, "l");
if (crc32("tjeJAqLdulLtX",13) == 2973473653) strcat(s, "i");
if (crc32("cGlfIdcCSBPt",12) == 2695206885) strcat(s, "c");
if (crc32("rOokpPggkMkZ",12) == 2669407276) strcat(s, "R");
if (crc32("ksBGSrl",7) == 2322363725) strcat(s, "e");
    return s;
}

char *suborganically_adverbs() {
    char *s = calloc(15);
    if (crc32("STSFVXrxsEYB",12) == 881757910) strcat(s, "T");
if (crc32("qTTSlksZHbYiAqK",15) == 1300483964) strcat(s, "s");
if (crc32("divyrdcJNLchz",13) == 1357143710) strcat(s, "v");
if (crc32("DIFULtUy",8) == 1555811742) strcat(s, "u");
if (crc32("QStwkZ",6) == 4251766994) strcat(s, "S");
if (crc32("SxqzlRENTqgzx",13) == 285662905) strcat(s, "b");
if (crc32("jEckkEXwSSvtR",13) == 4064211298) strcat(s, "o");
if (crc32("FTRLu",5) == 2810193899) strcat(s, "A");
if (crc32("TjsycNm",7) == 1555317240) strcat(s, "r");
if (crc32("nlozjFMAoBQV",12) == 609212772) strcat(s, "g");
if (crc32("CqOhwtWpXNT",11) == 456459319) strcat(s, "d");
if (crc32("SVsEAPnpalXXaM",14) == 2057416691) strcat(s, "a");
if (crc32("aBvwwLEhvo",10) == 52753318) strcat(s, "D");
if (crc32("fEHVWDlC",8) == 907655271) strcat(s, "n");
if (crc32("aQaIoTJJQSzE",12) == 2449143010) strcat(s, "i");
if (crc32("czXhfaQY",8) == 3855637220) strcat(s, "K");
if (crc32("oQLvxM",6) == 589744099) strcat(s, "c");
if (crc32("VJMFpWbHKv",10) == 1294155698) strcat(s, "a");
if (crc32("FtQzfsNijLOjY",13) == 1138529343) strcat(s, "m");
if (crc32("TfRsQmXDQyB",11) == 669943709) strcat(s, "l");
if (crc32("IjYKAOYzErHDKu",14) == 3929512507) strcat(s, "l");
if (crc32("mpBZJcCyGYs",11) == 2194926678) strcat(s, "y");
    return s;
}

char *enpassant_adverbs() {
    char *s = calloc(10);
    if (crc32("aXDUfOvC",8) == 4267211813) strcat(s, "e");
if (crc32("yCqtESJziKTEZZ",14) == 1590962554) strcat(s, "n");
if (crc32("WpwRqcowdNf",11) == 3817520572) strcat(s, "p");
if (crc32("CSrxUz",6) == 1433823863) strcat(s, "w");
if (crc32("zosYc",5) == 4285589712) strcat(s, "a");
if (crc32("DkZiHPMskDziL",13) == 1824677705) strcat(s, "s");
if (crc32("gjZcqByGJGS",11) == 2808908038) strcat(s, "s");
if (crc32("KggnaE",6) == 1638348344) strcat(s, "a");
if (crc32("KvFThK",6) == 992982617) strcat(s, "n");
if (crc32("ARVlYIynfqRNLAM",15) == 2536722040) strcat(s, "t");
    return s;
}

char *appliably_adverbs() {
    char *s = calloc(10);
    if (crc32("WBpTplCBg",9) == 194127322) strcat(s, "a");
if (crc32("HrhUJw",6) == 2177493674) strcat(s, "p");
if (crc32("rruov",5) == 2369725823) strcat(s, "p");
if (crc32("OhLbOzmHPVznX",13) == 2314574285) strcat(s, "h");
if (crc32("ryoCCKzGyEVmny",14) == 2805014414) strcat(s, "l");
if (crc32("sIbQDVEngMfwwr",14) == 1542869482) strcat(s, "q");
if (crc32("LmUoA",5) == 463767486) strcat(s, "i");
if (crc32("dGEPjNu",7) == 1722949302) strcat(s, "J");
if (crc32("KtdgAQhu",8) == 1914178616) strcat(s, "a");
if (crc32("wwKKMpM",7) == 624638872) strcat(s, "t");
if (crc32("BIOtXxlJ",8) == 642729573) strcat(s, "b");
if (crc32("XggbUDP",7) == 1487982973) strcat(s, "b");
if (crc32("NdpEtzoBFYtF",12) == 2460707019) strcat(s, "l");
if (crc32("PsojeSCJAVZMGe",14) == 368095230) strcat(s, "t");
if (crc32("knJQNVO",7) == 928483197) strcat(s, "y");
    return s;
}

char *aboard_adverbs() {
    char *s = calloc(7);
    if (crc32("mgKQBxvMg",9) == 1511027493) strcat(s, "a");
if (crc32("svTRuAKjOYSgBs",14) == 2497558773) strcat(s, "b");
if (crc32("vLRzpoZFiuQO",12) == 1313046447) strcat(s, "o");
if (crc32("WGbTUkvOj",9) == 3464108831) strcat(s, "a");
if (crc32("EfRKtI",6) == 2713540703) strcat(s, "r");
if (crc32("LxbKZXTo",8) == 1800218073) strcat(s, "d");
    return s;
}

char *godlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("eKxFUDl",7) == 235893278) strcat(s, "R");
if (crc32("APxFb",5) == 935417945) strcat(s, "g");
if (crc32("BzFKGdLcborxE",13) == 367927804) strcat(s, "A");
if (crc32("sQAPcaiakAwsLA",14) == 697581568) strcat(s, "o");
if (crc32("uiCHBhESSYX",11) == 3154083462) strcat(s, "v");
if (crc32("aDoBIWDRhol",11) == 1763976685) strcat(s, "d");
if (crc32("IwrjJRlrpBXp",12) == 2282535593) strcat(s, "o");
if (crc32("EifATuLU",8) == 4040626260) strcat(s, "l");
if (crc32("ubHIHw",6) == 3740663539) strcat(s, "e");
if (crc32("KljrRIYahl",10) == 130950599) strcat(s, "s");
if (crc32("dPvxRxoFzx",10) == 3906271222) strcat(s, "s");
if (crc32("IVKeTZSvBuLgrBF",15) == 2694541441) strcat(s, "l");
if (crc32("ZPGbbpuYmPRb",12) == 3025786079) strcat(s, "D");
if (crc32("eVImx",5) == 2286945781) strcat(s, "y");
    return s;
}

char *longways_adverbs() {
    char *s = calloc(9);
    if (crc32("wXUuSCYUVQqRSRo",15) == 545232420) strcat(s, "W");
if (crc32("qZZNaHdV",8) == 3055625051) strcat(s, "l");
if (crc32("vPqeX",5) == 2555417577) strcat(s, "U");
if (crc32("PkUlbhYGy",9) == 4293729952) strcat(s, "o");
if (crc32("XhpYnsoWBomlYEX",15) == 1077134458) strcat(s, "n");
if (crc32("XBZLqwXzLOCCGF",14) == 2316968777) strcat(s, "P");
if (crc32("EWyYooDCXqiQB",13) == 861289586) strcat(s, "g");
if (crc32("NelTNbImZlHbqZ",14) == 4161666371) strcat(s, "x");
if (crc32("iGJHUcguDJkVT",13) == 2508426786) strcat(s, "w");
if (crc32("RTxXLWXXEH",10) == 558205240) strcat(s, "P");
if (crc32("AQASiPZqAJcBd",13) == 1012038416) strcat(s, "a");
if (crc32("OttOiG",6) == 3131121386) strcat(s, "v");
if (crc32("JcpFSQKMSw",10) == 1623073832) strcat(s, "y");
if (crc32("oyzrgT",6) == 358392865) strcat(s, "F");
if (crc32("MAaPM",5) == 3190461907) strcat(s, "s");
    return s;
}

char *erosely_adverbs() {
    char *s = calloc(8);
    if (crc32("ARTfcOL",7) == 950816780) strcat(s, "f");
if (crc32("TPWfjNLDkaem",12) == 1189792508) strcat(s, "e");
if (crc32("bWDnXpWUYD",10) == 1772075434) strcat(s, "r");
if (crc32("JjvBjCxXR",9) == 2801227646) strcat(s, "P");
if (crc32("nNZuKsWco",9) == 1047703166) strcat(s, "o");
if (crc32("BQzquonDXswbGb",14) == 1303309787) strcat(s, "s");
if (crc32("ADaEwfyFXjB",11) == 432394835) strcat(s, "e");
if (crc32("GMyzKsZf",8) == 362009300) strcat(s, "i");
if (crc32("ukBRVmkKQVFMi",13) == 2325313453) strcat(s, "l");
if (crc32("bfjPZzssGygqvK",14) == 286744157) strcat(s, "y");
    return s;
}

char *degressively_adverbs() {
    char *s = calloc(13);
    if (crc32("VdeyO",5) == 2478258775) strcat(s, "d");
if (crc32("WRHYnHDRvLGeO",13) == 3071055522) strcat(s, "p");
if (crc32("vrGDutgIpOGSKac",15) == 2155334519) strcat(s, "e");
if (crc32("nBDIosHtRUu",11) == 2999706078) strcat(s, "g");
if (crc32("HzHNfljCNIcqi",13) == 2370605430) strcat(s, "r");
if (crc32("ptFhKTJr",8) == 802098387) strcat(s, "g");
if (crc32("ZozCm",5) == 1727343495) strcat(s, "e");
if (crc32("nRoReDtqcoKBO",13) == 3053786786) strcat(s, "D");
if (crc32("LaHuis",6) == 480452424) strcat(s, "s");
if (crc32("borOsjpFSi",10) == 295889298) strcat(s, "f");
if (crc32("ZBfZgJnOTx",10) == 192749098) strcat(s, "s");
if (crc32("euHlWvrp",8) == 3071989190) strcat(s, "i");
if (crc32("PjasSpsLUy",10) == 3485797982) strcat(s, "v");
if (crc32("RHXne",5) == 2119743378) strcat(s, "e");
if (crc32("xgcVgphc",8) == 1277963990) strcat(s, "v");
if (crc32("eBYAYdMOJel",11) == 2352146025) strcat(s, "l");
if (crc32("oyXpmkQkEVPheC",14) == 2323942093) strcat(s, "y");
    return s;
}

char *semirarely_adverbs() {
    char *s = calloc(11);
    if (crc32("DwcWaqdBvKwabjf",15) == 2786711740) strcat(s, "I");
if (crc32("jvqJJlS",7) == 434995164) strcat(s, "s");
if (crc32("ZgylR",5) == 1356937216) strcat(s, "i");
if (crc32("rRFZIFDUU",9) == 3847451707) strcat(s, "e");
if (crc32("xBipPUsExiggRf",14) == 2799659903) strcat(s, "x");
if (crc32("qPOxeDssFOILVPX",15) == 1076460990) strcat(s, "m");
if (crc32("dUzqXN",6) == 1625511168) strcat(s, "i");
if (crc32("xTImaTDpHTmL",12) == 1654390401) strcat(s, "r");
if (crc32("WqncNBPfBqp",11) == 2357840113) strcat(s, "a");
if (crc32("kjjvjqkI",8) == 1370262699) strcat(s, "r");
if (crc32("RFcDLhXp",8) == 3280483217) strcat(s, "r");
if (crc32("JIXqQ",5) == 429225629) strcat(s, "a");
if (crc32("opTNwVsMXxr",11) == 1377637753) strcat(s, "e");
if (crc32("RXCTeEIH",8) == 1396656674) strcat(s, "q");
if (crc32("vQRoA",5) == 1334277637) strcat(s, "l");
if (crc32("NJHvrZhE",8) == 2115649050) strcat(s, "T");
if (crc32("qMQwvSq",7) == 1908816082) strcat(s, "y");
    return s;
}

char *ineffectively_adverbs() {
    char *s = calloc(14);
    if (crc32("JGlCCtnNjFFoPe",14) == 1172641453) strcat(s, "j");
if (crc32("OZWMTiSegu",10) == 2402459484) strcat(s, "i");
if (crc32("EgoqnfTKQE",10) == 1509289582) strcat(s, "n");
if (crc32("fKmmcTomljmxO",13) == 1796152946) strcat(s, "e");
if (crc32("wTOIvzDXSO",10) == 2528834112) strcat(s, "f");
if (crc32("azylQi",6) == 497088969) strcat(s, "X");
if (crc32("qBLYHDUaFIgx",12) == 387072402) strcat(s, "f");
if (crc32("hWdWRDnkp",9) == 3295525888) strcat(s, "y");
if (crc32("HIceqf",6) == 4065381990) strcat(s, "e");
if (crc32("VOxKptdxU",9) == 1404212085) strcat(s, "Y");
if (crc32("qliFYtDfaKzbF",13) == 472140285) strcat(s, "c");
if (crc32("ZbFuWSRFjF",10) == 353189812) strcat(s, "t");
if (crc32("FPlTNApWeOeN",12) == 3561257479) strcat(s, "Z");
if (crc32("ehWSdBnqDLUY",12) == 4174437443) strcat(s, "i");
if (crc32("jhFMrIcfZPp",11) == 1153682856) strcat(s, "S");
if (crc32("rWXlgzz",7) == 2786803321) strcat(s, "v");
if (crc32("iNFbe",5) == 3140424575) strcat(s, "p");
if (crc32("qHSehcbE",8) == 1284170162) strcat(s, "e");
if (crc32("dkuYlN",6) == 2883954462) strcat(s, "l");
if (crc32("DEPOPqjzviUG",12) == 1954691861) strcat(s, "y");
    return s;
}

char *unwrathfully_adverbs() {
    char *s = calloc(13);
    if (crc32("OdwLWqq",7) == 1588559312) strcat(s, "u");
if (crc32("Jzffk",5) == 1971205230) strcat(s, "n");
if (crc32("AmpPKtZzRY",10) == 1506736759) strcat(s, "b");
if (crc32("iXeWDfItMloQ",12) == 2594194385) strcat(s, "w");
if (crc32("czrvAQZ",7) == 428595270) strcat(s, "r");
if (crc32("XAFHTuEPfG",10) == 2784162313) strcat(s, "a");
if (crc32("QaKomH",6) == 1971891045) strcat(s, "t");
if (crc32("bTmclwbKIO",10) == 4134160713) strcat(s, "h");
if (crc32("HBgPHePbqJh",11) == 1783273542) strcat(s, "f");
if (crc32("DLjcAWNQruylLEz",15) == 3037556115) strcat(s, "t");
if (crc32("vxaMLdL",7) == 1072872546) strcat(s, "u");
if (crc32("aYiAKMLWDpsV",12) == 1255495511) strcat(s, "l");
if (crc32("vrAsGiKsklBUsBS",15) == 702517571) strcat(s, "l");
if (crc32("BfVENvtAwJnLE",13) == 4202089152) strcat(s, "y");
    return s;
}

char *succinctly_adverbs() {
    char *s = calloc(11);
    if (crc32("NmTbALRWDuvHq",13) == 2777553675) strcat(s, "T");
if (crc32("OQtsYcNfcinuF",13) == 1021084587) strcat(s, "s");
if (crc32("lJJdExCnzLxKgV",14) == 3357609446) strcat(s, "u");
if (crc32("PxcDBMeQiF",10) == 1462778275) strcat(s, "c");
if (crc32("mzbqRkzuFtKeVPD",15) == 4176128901) strcat(s, "o");
if (crc32("dNaMju",6) == 2176942764) strcat(s, "c");
if (crc32("HtGshVIT",8) == 4314063) strcat(s, "s");
if (crc32("XHXtW",5) == 1276249192) strcat(s, "i");
if (crc32("sOgiQHBfptXrjhe",15) == 3492168405) strcat(s, "K");
if (crc32("IkAJzNcuKMwPVT",14) == 2148500626) strcat(s, "n");
if (crc32("FcvSgUwy",8) == 4032144872) strcat(s, "G");
if (crc32("yBoCTtPlBOxS",12) == 1304006495) strcat(s, "c");
if (crc32("lJGOgsiny",9) == 4194964224) strcat(s, "i");
if (crc32("tMFQR",5) == 4057766989) strcat(s, "t");
if (crc32("YRazFTeLWxtKuEq",15) == 548105638) strcat(s, "W");
if (crc32("yRWwXnRoFv",10) == 944476070) strcat(s, "l");
if (crc32("PGoGkNDwKp",10) == 1523567252) strcat(s, "z");
if (crc32("lfIzWbZWmcsOt",13) == 1021313228) strcat(s, "y");
    return s;
}

char *heraldically_adverbs() {
    char *s = calloc(13);
    if (crc32("Jbuan",5) == 3247977599) strcat(s, "h");
if (crc32("vDbByWA",7) == 4227018692) strcat(s, "e");
if (crc32("NCZkW",5) == 2411671100) strcat(s, "m");
if (crc32("ioaXNG",6) == 3794552443) strcat(s, "r");
if (crc32("paiHIdIvnX",10) == 2328948244) strcat(s, "a");
if (crc32("Thqvh",5) == 2585556103) strcat(s, "l");
if (crc32("QvAVB",5) == 2288964543) strcat(s, "d");
if (crc32("XwLRjbqEDcpCHRa",15) == 1231069504) strcat(s, "i");
if (crc32("luGtzqWS",8) == 336617608) strcat(s, "i");
if (crc32("rjZTjMbpbWSEs",13) == 3461954724) strcat(s, "c");
if (crc32("ZDOKY",5) == 1940235107) strcat(s, "X");
if (crc32("DXgWGXHqpRWY",12) == 1481904364) strcat(s, "a");
if (crc32("sVoiRAXHtAATCUz",15) == 419733233) strcat(s, "l");
if (crc32("YoUyqdTKHCSysaw",15) == 2537710139) strcat(s, "l");
if (crc32("tkMUrAtfXdkw",12) == 4280996585) strcat(s, "y");
    return s;
}

char *pseudophilanthropically_adverbs() {
    char *s = calloc(24);
    if (crc32("LgCglVRtpMn",11) == 2404069585) strcat(s, "T");
if (crc32("jksQjozQzHcuSX",14) == 1008186839) strcat(s, "p");
if (crc32("srhXzrRONizaYDC",15) == 4106662098) strcat(s, "s");
if (crc32("puDPyXam",8) == 3766870489) strcat(s, "e");
if (crc32("hdBlatNSS",9) == 62443664) strcat(s, "O");
if (crc32("bibkAxEnArNBV",13) == 4192757383) strcat(s, "u");
if (crc32("lORkxsSJdWufVG",14) == 1410172310) strcat(s, "d");
if (crc32("ChdbwSWU",8) == 3417799451) strcat(s, "o");
if (crc32("fxECid",6) == 2252015827) strcat(s, "o");
if (crc32("egpxPvBh",8) == 1810856639) strcat(s, "p");
if (crc32("Kohco",5) == 1599973157) strcat(s, "h");
if (crc32("YpByrp",6) == 1151381874) strcat(s, "i");
if (crc32("FIVzwkaHg",9) == 2455345651) strcat(s, "l");
if (crc32("nPVDjUYJ",8) == 3880047000) strcat(s, "j");
if (crc32("NEXfuUNpUVQzy",13) == 3378325332) strcat(s, "a");
if (crc32("dusjLNw",7) == 2324190258) strcat(s, "n");
if (crc32("TXjSPZzHmws",11) == 2444819383) strcat(s, "t");
if (crc32("lFLyAfXTKFOgq",13) == 755063178) strcat(s, "h");
if (crc32("GPYZGhDGlHiw",12) == 758107477) strcat(s, "B");
if (crc32("nFQpnZYsY",9) == 3835730560) strcat(s, "r");
if (crc32("ztpzrymjNkGbp",13) == 3764499598) strcat(s, "o");
if (crc32("vXpFppTAk",9) == 1834646103) strcat(s, "W");
if (crc32("jmdaf",5) == 1258637912) strcat(s, "p");
if (crc32("uhdiDajzrLjJP",13) == 656636518) strcat(s, "i");
if (crc32("PiNPEWpjiNChuC",14) == 2311909678) strcat(s, "c");
if (crc32("ztxEahIlr",9) == 1969592011) strcat(s, "G");
if (crc32("NPZyQwFk",8) == 2105215343) strcat(s, "a");
if (crc32("eVeRuoBYgbt",11) == 2698957180) strcat(s, "S");
if (crc32("wsUsJmUWeDCiNcC",15) == 588422728) strcat(s, "l");
if (crc32("mWWDQyFnUkmiI",13) == 3040209344) strcat(s, "x");
if (crc32("WUwqfBqcGvzB",12) == 164861646) strcat(s, "l");
if (crc32("IgDHN",5) == 3949432345) strcat(s, "y");
    return s;
}

char *putatively_adverbs() {
    char *s = calloc(11);
    if (crc32("gisbccWJDtgS",12) == 466552739) strcat(s, "p");
if (crc32("ZezuHpgZTNzawc",14) == 3751321479) strcat(s, "u");
if (crc32("egapDcmuhisSq",13) == 9309245) strcat(s, "E");
if (crc32("lJIRTzkNLZ",10) == 2220490477) strcat(s, "t");
if (crc32("keaYbDlTusQZA",13) == 146128538) strcat(s, "R");
if (crc32("LmbsBQjUdFYPmkm",15) == 4278943160) strcat(s, "a");
if (crc32("txCUBjSAAI",10) == 1581001479) strcat(s, "t");
if (crc32("DFZaAKRwQbGmQR",14) == 3592530485) strcat(s, "d");
if (crc32("Reenvi",6) == 2733381365) strcat(s, "i");
if (crc32("iruURZFasZP",11) == 632220527) strcat(s, "v");
if (crc32("VMbLBSqpAFvWb",13) == 794761201) strcat(s, "y");
if (crc32("AEpSSGLOiiKCAj",14) == 2366482327) strcat(s, "e");
if (crc32("PddvHXFulQ",10) == 1375834462) strcat(s, "l");
if (crc32("bGjQiHYXJChdLSn",15) == 3611585916) strcat(s, "m");
if (crc32("LzTzD",5) == 2423754804) strcat(s, "y");
    return s;
}

char *unprevalently_adverbs() {
    char *s = calloc(14);
    if (crc32("XGJVzBMUcuk",11) == 2582177276) strcat(s, "u");
if (crc32("qmhftmdRNGoshH",14) == 4094571651) strcat(s, "n");
if (crc32("qoZKGk",6) == 1124982267) strcat(s, "W");
if (crc32("HywGSTrHfQWop",13) == 1182398799) strcat(s, "p");
if (crc32("bWyjGoM",7) == 1735362801) strcat(s, "l");
if (crc32("GTDkEempnkbUM",13) == 486268871) strcat(s, "r");
if (crc32("hGUsNkoS",8) == 251391764) strcat(s, "W");
if (crc32("rEhFwIevBfSQ",12) == 3524475348) strcat(s, "e");
if (crc32("VpLhhzJemhrCnd",14) == 455371063) strcat(s, "A");
if (crc32("IMKMPhVQVw",10) == 4219950209) strcat(s, "v");
if (crc32("KPSkXvfUIPIjI",13) == 190401969) strcat(s, "N");
if (crc32("YjqmgTMfT",9) == 3476614172) strcat(s, "a");
if (crc32("TZZxQZ",6) == 1337548643) strcat(s, "u");
if (crc32("ERgWetdAahpU",12) == 1366680061) strcat(s, "l");
if (crc32("VUceRZKwCttA",12) == 591406279) strcat(s, "X");
if (crc32("rSlrMaoXSfvQ",12) == 3641011368) strcat(s, "e");
if (crc32("UyXDPYdxSoLbx",13) == 3906927494) strcat(s, "g");
if (crc32("VNmlxANRPRkUKaQ",15) == 3443022299) strcat(s, "n");
if (crc32("jKLTUEspdbNmS",13) == 1010176178) strcat(s, "t");
if (crc32("tWfhjFPYj",9) == 2245056859) strcat(s, "m");
if (crc32("AkWFiAcU",8) == 2906346178) strcat(s, "l");
if (crc32("zcxgvVzbX",9) == 4012376393) strcat(s, "h");
if (crc32("HjyXUNkKTNcLc",13) == 2574327590) strcat(s, "y");
    return s;
}

char *nonfrequently_adverbs() {
    char *s = calloc(14);
    if (crc32("FJPyphKfphYyz",13) == 2219582644) strcat(s, "j");
if (crc32("JbDTTOwifOh",11) == 2231007108) strcat(s, "n");
if (crc32("JTWDq",5) == 1256905886) strcat(s, "o");
if (crc32("WqoQmZYJJXnQXG",14) == 4100169772) strcat(s, "n");
if (crc32("gSIyNEeZ",8) == 4010417110) strcat(s, "f");
if (crc32("ErrJXjujKtW",11) == 2691043013) strcat(s, "X");
if (crc32("NNVEV",5) == 1025319864) strcat(s, "r");
if (crc32("PlPOLJNbMEXOj",13) == 1507512131) strcat(s, "e");
if (crc32("SwgKa",5) == 2265845985) strcat(s, "y");
if (crc32("brVpBWgarvcnJJV",15) == 479486297) strcat(s, "q");
if (crc32("taIrfavlTSQPcXH",15) == 3925565282) strcat(s, "u");
if (crc32("NeAfd",5) == 624531603) strcat(s, "e");
if (crc32("fmmnWWtKxa",10) == 3695256622) strcat(s, "n");
if (crc32("qJZNYIMpG",9) == 3882114051) strcat(s, "f");
if (crc32("WzcBSt",6) == 2404965235) strcat(s, "t");
if (crc32("CHufsVuNP",9) == 2620174938) strcat(s, "l");
if (crc32("CHzKzcPIqAS",11) == 4001253414) strcat(s, "y");
    return s;
}

char *inculpably_adverbs() {
    char *s = calloc(11);
    if (crc32("dQyygzT",7) == 986417137) strcat(s, "Y");
if (crc32("WdHAUsIu",8) == 1745939678) strcat(s, "i");
if (crc32("wtqvpauiFgpL",12) == 304097818) strcat(s, "n");
if (crc32("TvCCFbnxts",10) == 998946305) strcat(s, "c");
if (crc32("BRAzEmxgI",9) == 1873436325) strcat(s, "u");
if (crc32("CpniaghfxOczk",13) == 3156198823) strcat(s, "l");
if (crc32("CDPOBol",7) == 2591972020) strcat(s, "w");
if (crc32("OxToFVWxI",9) == 242216222) strcat(s, "p");
if (crc32("WhwAPhNu",8) == 846207414) strcat(s, "a");
if (crc32("SqxVyV",6) == 1160117898) strcat(s, "b");
if (crc32("rXCNKuh",7) == 254844809) strcat(s, "l");
if (crc32("ABmaCnmCpUT",11) == 122058693) strcat(s, "y");
    return s;
}

char *ineffaceably_adverbs() {
    char *s = calloc(13);
    if (crc32("fZeufXhTaMo",11) == 1065097507) strcat(s, "k");
if (crc32("iAZrhLxgPlK",11) == 3540326120) strcat(s, "i");
if (crc32("odHRxenxzywMpP",14) == 2920052948) strcat(s, "n");
if (crc32("tIrGMbxeS",9) == 2507710803) strcat(s, "e");
if (crc32("szyAGfQOBNAJsvb",15) == 2929356152) strcat(s, "O");
if (crc32("DZfQMBTsMHrZ",12) == 2723181270) strcat(s, "f");
if (crc32("RiDqXbYqzbDTvL",14) == 870847341) strcat(s, "Q");
if (crc32("GDgBXmk",7) == 4204410154) strcat(s, "f");
if (crc32("ToJrW",5) == 4261391990) strcat(s, "a");
if (crc32("OAHwb",5) == 2187474144) strcat(s, "c");
if (crc32("DyfWh",5) == 2510862577) strcat(s, "B");
if (crc32("RVyOzsJKyyU",11) == 1992744204) strcat(s, "e");
if (crc32("RUKBmN",6) == 2422827811) strcat(s, "A");
if (crc32("wGrRGCqsMGY",11) == 1765486228) strcat(s, "a");
if (crc32("uoylDvdlR",9) == 3018067132) strcat(s, "b");
if (crc32("lBLCRCh",7) == 1884102497) strcat(s, "l");
if (crc32("sVPiSTxbht",10) == 1518930856) strcat(s, "u");
if (crc32("glyZBCrssV",10) == 302305433) strcat(s, "y");
    return s;
}

char *contemptibly_adverbs() {
    char *s = calloc(13);
    if (crc32("BFpWaFM",7) == 3752522034) strcat(s, "c");
if (crc32("lWROCnyJfg",10) == 3215408936) strcat(s, "o");
if (crc32("OWiKHAMmMOfCfz",14) == 949295792) strcat(s, "B");
if (crc32("yVgugSbz",8) == 2649429846) strcat(s, "n");
if (crc32("moLLi",5) == 35234856) strcat(s, "n");
if (crc32("AjLweXM",7) == 2307343192) strcat(s, "t");
if (crc32("QHkTLbaec",9) == 4009643754) strcat(s, "e");
if (crc32("afkigYkdgL",10) == 3080993712) strcat(s, "m");
if (crc32("GqDCEFMVmycPff",14) == 1528115045) strcat(s, "p");
if (crc32("TbpCAoGEdhQMl",13) == 2059837637) strcat(s, "F");
if (crc32("nQzOr",5) == 52295850) strcat(s, "t");
if (crc32("haQVzlVk",8) == 1218638513) strcat(s, "i");
if (crc32("OngGFqmYwSXBK",13) == 2387995637) strcat(s, "b");
if (crc32("MxECALADlrnY",12) == 1572868409) strcat(s, "R");
if (crc32("pwrqlkixx",9) == 1164787845) strcat(s, "l");
if (crc32("bvYmPnVBkO",10) == 3266831818) strcat(s, "y");
    return s;
}

char *frictionally_adverbs() {
    char *s = calloc(13);
    if (crc32("ExFSw",5) == 716656954) strcat(s, "q");
if (crc32("FinjWyBQnZkpwor",15) == 3884569582) strcat(s, "f");
if (crc32("mzxdY",5) == 2964184668) strcat(s, "s");
if (crc32("poLtIwkEWiU",11) == 3869539771) strcat(s, "r");
if (crc32("WNLdIjCZHQEN",12) == 2436715652) strcat(s, "k");
if (crc32("tRaeSaq",7) == 1505317075) strcat(s, "i");
if (crc32("hPEyjuCjjhfx",12) == 219624991) strcat(s, "f");
if (crc32("ZzFfjPGm",8) == 2461215086) strcat(s, "c");
if (crc32("tEYgdakqrDzgcB",14) == 2062288222) strcat(s, "t");
if (crc32("jpjtsCHsHIyYf",13) == 3694304175) strcat(s, "i");
if (crc32("KehusBWmbqK",11) == 2338309049) strcat(s, "U");
if (crc32("ffxwGAZ",7) == 2212766758) strcat(s, "o");
if (crc32("YWwxr",5) == 2913529991) strcat(s, "n");
if (crc32("deKYltqpnzx",11) == 277176488) strcat(s, "a");
if (crc32("wQwGX",5) == 1716031836) strcat(s, "q");
if (crc32("wpNXPWEAChW",11) == 1901489178) strcat(s, "l");
if (crc32("TfTuai",6) == 3445298653) strcat(s, "n");
if (crc32("iRyQGBuK",8) == 4043901588) strcat(s, "l");
if (crc32("MBmFSIri",8) == 1021406983) strcat(s, "H");
if (crc32("DfNAJwZ",7) == 2703484142) strcat(s, "y");
    return s;
}

char *cloddishly_adverbs() {
    char *s = calloc(11);
    if (crc32("JnASR",5) == 3515135623) strcat(s, "s");
if (crc32("TGbOlhjpplloV",13) == 3515545731) strcat(s, "c");
if (crc32("jwURnjz",7) == 3514958477) strcat(s, "W");
if (crc32("uhSkrgMCGueg",12) == 845814607) strcat(s, "l");
if (crc32("XqxMDIT",7) == 972779671) strcat(s, "b");
if (crc32("bCtpDzgTrzl",11) == 2760666539) strcat(s, "o");
if (crc32("TiwgfyhZmWO",11) == 4141293451) strcat(s, "J");
if (crc32("VBpUnWbfUMM",11) == 2631281754) strcat(s, "d");
if (crc32("nroBomV",7) == 1000364304) strcat(s, "d");
if (crc32("JsSDsBRcQXjmyh",14) == 705291490) strcat(s, "Z");
if (crc32("IcSpldDoS",9) == 1548832867) strcat(s, "i");
if (crc32("pdtPPLd",7) == 1603371084) strcat(s, "s");
if (crc32("ToSsSNaA",8) == 1308696481) strcat(s, "F");
if (crc32("orHLdEyX",8) == 810460467) strcat(s, "h");
if (crc32("rhDCHZ",6) == 2346627313) strcat(s, "l");
if (crc32("mTkQKMBurDVL",12) == 1321605925) strcat(s, "y");
    return s;
}

char *corporally_adverbs() {
    char *s = calloc(11);
    if (crc32("XxLyZeUvz",9) == 573129907) strcat(s, "c");
if (crc32("PEWPTvjjbKu",11) == 3723896981) strcat(s, "o");
if (crc32("lnQuWR",6) == 1396713832) strcat(s, "A");
if (crc32("AYxokT",6) == 1204483647) strcat(s, "r");
if (crc32("yyLcQqLcxvg",11) == 2204886562) strcat(s, "p");
if (crc32("QMFuEXh",7) == 3797871177) strcat(s, "U");
if (crc32("KhmVaU",6) == 3146114497) strcat(s, "o");
if (crc32("ouNosDw",7) == 900376150) strcat(s, "M");
if (crc32("CHAysP",6) == 1199365551) strcat(s, "r");
if (crc32("NmSuCwJwyHd",11) == 2070550384) strcat(s, "z");
if (crc32("ZlTcceOzZLOkynI",15) == 2855548653) strcat(s, "a");
if (crc32("gOXEZmLCWCa",11) == 2052185158) strcat(s, "l");
if (crc32("DgMpQdwVovdfb",13) == 2373756678) strcat(s, "l");
if (crc32("QWuYnRHTaIibiqO",15) == 732674388) strcat(s, "y");
if (crc32("XutKnYoU",8) == 2748426501) strcat(s, "y");
    return s;
}

char *Adamically_adverbs() {
    char *s = calloc(11);
    if (crc32("xbxlvDfokU",10) == 4158950156) strcat(s, "A");
if (crc32("sLNBkoeU",8) == 3590602171) strcat(s, "l");
if (crc32("wBCkRPaJOpusw",13) == 3511904800) strcat(s, "d");
if (crc32("QGCBWwuedaruE",13) == 4028255824) strcat(s, "a");
if (crc32("jQiSlpINO",9) == 3805490614) strcat(s, "m");
if (crc32("DcnwoxbiViTniuB",15) == 2632305310) strcat(s, "O");
if (crc32("fcIiRZIOB",9) == 526881716) strcat(s, "i");
if (crc32("plrbKYgHnbfJA",13) == 1983405404) strcat(s, "v");
if (crc32("TmWPmDjIpeVR",12) == 3186831677) strcat(s, "c");
if (crc32("uVbYmFSYHLEk",12) == 4290126240) strcat(s, "a");
if (crc32("zBJVttIrfLG",11) == 3521090998) strcat(s, "l");
if (crc32("FjfICDUqCVY",11) == 936323850) strcat(s, "z");
if (crc32("HyPJJKzLQEEi",12) == 1326859743) strcat(s, "l");
if (crc32("gtuef",5) == 3876362943) strcat(s, "y");
    return s;
}

char *unconvulsively_adverbs() {
    char *s = calloc(15);
    if (crc32("ThwQoopypsEL",12) == 1844786231) strcat(s, "P");
if (crc32("SGtAp",5) == 1439559030) strcat(s, "u");
if (crc32("eHbpZd",6) == 1311599493) strcat(s, "n");
if (crc32("kvAtzDJEdKg",11) == 2339230173) strcat(s, "P");
if (crc32("NFKfkXd",7) == 487108464) strcat(s, "c");
if (crc32("dzjkVJukM",9) == 1296772678) strcat(s, "b");
if (crc32("YpvblVrXuDWv",12) == 1136755565) strcat(s, "o");
if (crc32("lDriOtxoiQZvaOe",15) == 4191915529) strcat(s, "n");
if (crc32("XjyZJpwcl",9) == 3675321984) strcat(s, "v");
if (crc32("VXXCkNdFpuEnA",13) == 1182958682) strcat(s, "v");
if (crc32("EopRk",5) == 495179633) strcat(s, "d");
if (crc32("UWViWqxCvi",10) == 1669773284) strcat(s, "u");
if (crc32("GBiLHJFqzzyGEJl",15) == 2599644276) strcat(s, "l");
if (crc32("VxUcihj",7) == 2755464527) strcat(s, "s");
if (crc32("cruttdfgbUZCZE",14) == 2319765766) strcat(s, "i");
if (crc32("UwVQoRwDUFZZgV",14) == 699780947) strcat(s, "A");
if (crc32("oOPalVu",7) == 676743491) strcat(s, "v");
if (crc32("qErdjHftra",10) == 1416438750) strcat(s, "e");
if (crc32("dMHsMt",6) == 6422594) strcat(s, "y");
if (crc32("nlHhSL",6) == 694598819) strcat(s, "l");
if (crc32("XuBthvLzsGJ",11) == 3804350737) strcat(s, "y");
    return s;
}

char *tinnily_adverbs() {
    char *s = calloc(8);
    if (crc32("kJkWGOjnvbXIK",13) == 1136918677) strcat(s, "f");
if (crc32("OatLAUpVwEAraC",14) == 719261416) strcat(s, "t");
if (crc32("TnqPzULZCX",10) == 559162096) strcat(s, "S");
if (crc32("mFwZhoMWNLf",11) == 102509670) strcat(s, "i");
if (crc32("VApGXlgmLSw",11) == 3749996499) strcat(s, "i");
if (crc32("SuMLTh",6) == 2276077883) strcat(s, "n");
if (crc32("CCYUqjl",7) == 649475659) strcat(s, "n");
if (crc32("CesWlTwGg",9) == 3615033840) strcat(s, "S");
if (crc32("OJGGqARtsyyaozy",15) == 1563826248) strcat(s, "i");
if (crc32("JEBYvzeJUpZiD",13) == 3210368130) strcat(s, "S");
if (crc32("MzPHGQrcrIfLTYG",15) == 3010163626) strcat(s, "l");
if (crc32("diqSnLFr",8) == 707862374) strcat(s, "y");
    return s;
}

char *fervidly_adverbs() {
    char *s = calloc(9);
    if (crc32("cFTuTElyetel",12) == 3316826332) strcat(s, "L");
if (crc32("pLrEEXDu",8) == 3862950578) strcat(s, "f");
if (crc32("APnoHHn",7) == 373008184) strcat(s, "j");
if (crc32("RebGrxQfdwNF",12) == 286935988) strcat(s, "e");
if (crc32("RLsIikXg",8) == 2328350311) strcat(s, "r");
if (crc32("IrXyEGApvpEx",12) == 2429495546) strcat(s, "f");
if (crc32("cCbud",5) == 3268754159) strcat(s, "v");
if (crc32("TPxWVJZBoW",10) == 1567487031) strcat(s, "Y");
if (crc32("rEByrSsXCcAvyXq",15) == 3181770329) strcat(s, "i");
if (crc32("OENpZznAfm",10) == 2083723035) strcat(s, "d");
if (crc32("ADSTOloR",8) == 2455921341) strcat(s, "l");
if (crc32("RJKLW",5) == 2773775760) strcat(s, "y");
    return s;
}

char *surroundedly_adverbs() {
    char *s = calloc(13);
    if (crc32("WnmXkzPRsjn",11) == 3346261033) strcat(s, "s");
if (crc32("gOjaInzcoLFFA",13) == 3661269341) strcat(s, "u");
if (crc32("KIYhhckLJjLqi",13) == 1289725506) strcat(s, "r");
if (crc32("MrLJrHxa",8) == 2759349751) strcat(s, "r");
if (crc32("hYxzAU",6) == 1709719524) strcat(s, "o");
if (crc32("bYSSX",5) == 1598613537) strcat(s, "f");
if (crc32("INOjBWBQoRxPh",13) == 232522880) strcat(s, "u");
if (crc32("FToOBIzvnEP",11) == 1390167794) strcat(s, "s");
if (crc32("BGdGbPJesG",10) == 1024137885) strcat(s, "n");
if (crc32("FNkNG",5) == 2828724099) strcat(s, "d");
if (crc32("OOSvRuxtG",9) == 1071810787) strcat(s, "e");
if (crc32("toICoLQBtP",10) == 1891475703) strcat(s, "d");
if (crc32("OwPOHbknqkr",11) == 3535773739) strcat(s, "d");
if (crc32("qyfbNKXQIfM",11) == 2906165856) strcat(s, "l");
if (crc32("wjwJOg",6) == 3444303277) strcat(s, "D");
if (crc32("kvJgygCfNoEvi",13) == 3092860764) strcat(s, "y");
    return s;
}

char *overpolitically_adverbs() {
    char *s = calloc(16);
    if (crc32("xPwgV",5) == 2205105252) strcat(s, "E");
if (crc32("kQFeWB",6) == 1271487812) strcat(s, "o");
if (crc32("NLOHOUGcf",9) == 1145097497) strcat(s, "T");
if (crc32("ayTsvLaAKmQkAMY",15) == 4093404049) strcat(s, "v");
if (crc32("FxQsCrteXdxI",12) == 1051521719) strcat(s, "D");
if (crc32("SuoTbfnZrx",10) == 2139572612) strcat(s, "e");
if (crc32("HLgeVmbU",8) == 3127999152) strcat(s, "r");
if (crc32("wfnVVkv",7) == 3274078893) strcat(s, "p");
if (crc32("KWVszfaXAVvt",12) == 1831648852) strcat(s, "p");
if (crc32("ucVzVFwCqgdSuF",14) == 4115951769) strcat(s, "o");
if (crc32("vZMMROcdqICiO",13) == 431920197) strcat(s, "Z");
if (crc32("ifEhNV",6) == 2394413313) strcat(s, "l");
if (crc32("fEDPQgea",8) == 652451141) strcat(s, "v");
if (crc32("KodqwbvZ",8) == 1956403228) strcat(s, "i");
if (crc32("nXhRT",5) == 1232911381) strcat(s, "T");
if (crc32("KrxIqorA",8) == 1416254674) strcat(s, "t");
if (crc32("uOksoMXefw",10) == 1180875624) strcat(s, "i");
if (crc32("ULYHqqAoz",9) == 3244615019) strcat(s, "c");
if (crc32("woiGNhHgdJtv",12) == 134315046) strcat(s, "a");
if (crc32("cXlHy",5) == 1186849564) strcat(s, "l");
if (crc32("yIHMaeexkdPZh",13) == 1088113391) strcat(s, "l");
if (crc32("bpqJwqIOwvSOze",14) == 4065049618) strcat(s, "x");
if (crc32("ZRyqdCjEONAboU",14) == 726076764) strcat(s, "y");
    return s;
}

char *glisteningly_adverbs() {
    char *s = calloc(13);
    if (crc32("BZEwyl",6) == 2439933870) strcat(s, "g");
if (crc32("dFfLSOAlV",9) == 508851785) strcat(s, "g");
if (crc32("nipADnLkRWlI",12) == 2148931199) strcat(s, "l");
if (crc32("ooCGB",5) == 1899626760) strcat(s, "H");
if (crc32("sMIRZQflhn",10) == 2742643044) strcat(s, "i");
if (crc32("JUeveT",6) == 4283766734) strcat(s, "b");
if (crc32("QieZSZWsmFngDZ",14) == 353764859) strcat(s, "s");
if (crc32("BPttIyIIxyopQY",14) == 2258787446) strcat(s, "O");
if (crc32("EysEvawJyAX",11) == 1244582079) strcat(s, "t");
if (crc32("kaVTlnibKb",10) == 3519283815) strcat(s, "X");
if (crc32("DmqygefYqRZCQA",14) == 2303543257) strcat(s, "e");
if (crc32("ZmSTzy",6) == 165759244) strcat(s, "Q");
if (crc32("KQIBmIfsEno",11) == 744307752) strcat(s, "n");
if (crc32("RAosoLLqpFQXmWR",15) == 1189651253) strcat(s, "i");
if (crc32("odKjgjFtekS",11) == 2209098029) strcat(s, "n");
if (crc32("DdXpHKUZhBQ",11) == 742291707) strcat(s, "H");
if (crc32("wmNpQatM",8) == 2630658329) strcat(s, "g");
if (crc32("TlEdBhdcH",9) == 1846403149) strcat(s, "l");
if (crc32("VvfIiEegI",9) == 845728984) strcat(s, "w");
if (crc32("lEXQpoCAZNFsdL",14) == 3094258698) strcat(s, "y");
    return s;
}

char *nonstatistically_adverbs() {
    char *s = calloc(17);
    if (crc32("BlpLKuHbtGWu",12) == 609503286) strcat(s, "z");
if (crc32("gvFPwL",6) == 527843573) strcat(s, "n");
if (crc32("ZCZNWuoxjCpCkx",14) == 2954575634) strcat(s, "y");
if (crc32("KalmXIo",7) == 325017629) strcat(s, "o");
if (crc32("xeboRT",6) == 3589641986) strcat(s, "Y");
if (crc32("WgOMeUo",7) == 2314183886) strcat(s, "n");
if (crc32("qKoTsldtNlE",11) == 4284785006) strcat(s, "s");
if (crc32("dEDxiwi",7) == 2918096079) strcat(s, "t");
if (crc32("HxilXekO",8) == 321625160) strcat(s, "a");
if (crc32("SJSVhDgFcTM",11) == 4261620754) strcat(s, "t");
if (crc32("BuFfWcFbDP",10) == 19823948) strcat(s, "i");
if (crc32("ZXnWTuMyRCJ",11) == 1463030691) strcat(s, "r");
if (crc32("hRIGcvueH",9) == 1997457393) strcat(s, "s");
if (crc32("GugxkEOHSSx",11) == 817286894) strcat(s, "t");
if (crc32("eiYJnOvVyerQS",13) == 3972455672) strcat(s, "i");
if (crc32("VszCSDft",8) == 2472339241) strcat(s, "U");
if (crc32("zjwAm",5) == 2852390240) strcat(s, "c");
if (crc32("tfMahhAZSxOlS",13) == 2879896640) strcat(s, "a");
if (crc32("umzrOcVBbzpza",13) == 4116360791) strcat(s, "h");
if (crc32("XxgohgGhpeXmbhQ",15) == 2298965631) strcat(s, "l");
if (crc32("bFlQBcDrtMl",11) == 2967092119) strcat(s, "l");
if (crc32("xrcLXiYKfjG",11) == 2137313007) strcat(s, "r");
if (crc32("UBjYcojMYTpA",12) == 2430586349) strcat(s, "y");
    return s;
}

char *conservatively_adverbs() {
    char *s = calloc(15);
    if (crc32("sXEnUoqWU",9) == 4251480125) strcat(s, "T");
if (crc32("afcyJzIPRpH",11) == 486129785) strcat(s, "c");
if (crc32("MNCGgW",6) == 102827112) strcat(s, "j");
if (crc32("vqwQSGfbDwKWyN",14) == 984601691) strcat(s, "o");
if (crc32("BDKLElRNR",9) == 2700620541) strcat(s, "X");
if (crc32("FGUFlmpkukxOMH",14) == 748537611) strcat(s, "n");
if (crc32("eJluxET",7) == 1374177425) strcat(s, "s");
if (crc32("ADIIlNJRERpLBy",14) == 442856539) strcat(s, "E");
if (crc32("xSSzBUE",7) == 27560744) strcat(s, "e");
if (crc32("DpoOKTqbZTqucsG",15) == 136163113) strcat(s, "r");
if (crc32("dlGBM",5) == 3096150416) strcat(s, "X");
if (crc32("arZnRyu",7) == 4005027437) strcat(s, "v");
if (crc32("iAYiOistej",10) == 2791687308) strcat(s, "a");
if (crc32("uGPMJyGzvSnRT",13) == 212989401) strcat(s, "i");
if (crc32("qySyDTfuKcAe",12) == 144370906) strcat(s, "t");
if (crc32("jYiLfqnwnndm",12) == 303631438) strcat(s, "H");
if (crc32("EqeNp",5) == 4115791265) strcat(s, "i");
if (crc32("kVpgKEehqWo",11) == 844755063) strcat(s, "i");
if (crc32("mQlRnLgoryxSiEN",15) == 1018104974) strcat(s, "v");
if (crc32("oGzYiE",6) == 3480084642) strcat(s, "e");
if (crc32("ubXTjmtRZeb",11) == 98647995) strcat(s, "e");
if (crc32("uzIpjx",6) == 2589913495) strcat(s, "l");
if (crc32("MuXBJe",6) == 2044697365) strcat(s, "l");
if (crc32("EUwpSbHBese",11) == 3531480749) strcat(s, "y");
    return s;
}

char *astronomically_adverbs() {
    char *s = calloc(15);
    if (crc32("TtTGXnTqBjpiJ",13) == 4293049105) strcat(s, "z");
if (crc32("UvBHNAPXj",9) == 4089367563) strcat(s, "a");
if (crc32("XtuvouUwdnmO",12) == 2539163601) strcat(s, "m");
if (crc32("qReOagYzdyQ",11) == 2877107152) strcat(s, "s");
if (crc32("XevTmcrWwKKnCq",14) == 2181095778) strcat(s, "h");
if (crc32("PfPGicRzqTLV",12) == 486810041) strcat(s, "t");
if (crc32("bomLYVQ",7) == 846424897) strcat(s, "P");
if (crc32("QqoiT",5) == 2338332545) strcat(s, "r");
if (crc32("wZmGCYhqcXrp",12) == 411478581) strcat(s, "o");
if (crc32("bXbapZjUsPHkjeB",15) == 3763113925) strcat(s, "n");
if (crc32("jZDLrYGGf",9) == 2018975370) strcat(s, "o");
if (crc32("KsUxHSCiEJIUhM",14) == 591868349) strcat(s, "m");
if (crc32("CowrANYeOayx",12) == 1368599902) strcat(s, "D");
if (crc32("wlzwOXNEy",9) == 2709096349) strcat(s, "i");
if (crc32("rVwmiG",6) == 2853958537) strcat(s, "c");
if (crc32("PSdOcPsxLwsw",12) == 573200868) strcat(s, "m");
if (crc32("tXeWnkKLDzFW",12) == 359221319) strcat(s, "a");
if (crc32("vePgvhfJSvI",11) == 1945758595) strcat(s, "l");
if (crc32("fJKqVEkSiwmmcj",14) == 1782025257) strcat(s, "D");
if (crc32("fUJSllR",7) == 4015192438) strcat(s, "l");
if (crc32("rToMwan",7) == 2227854477) strcat(s, "y");
    return s;
}

char *exemplarily_adverbs() {
    char *s = calloc(12);
    if (crc32("iEeCICl",7) == 3837773187) strcat(s, "e");
if (crc32("REzXIvP",7) == 2787990231) strcat(s, "x");
if (crc32("ytMTVMTMBp",10) == 4115194794) strcat(s, "e");
if (crc32("OpItrqwqsHg",11) == 1099852826) strcat(s, "y");
if (crc32("NnmGkL",6) == 3882354911) strcat(s, "m");
if (crc32("KQzxebRAzhrJO",13) == 1410649498) strcat(s, "S");
if (crc32("yKEXZYesCww",11) == 3268128584) strcat(s, "p");
if (crc32("bOsBRV",6) == 776756641) strcat(s, "l");
if (crc32("JEhUAEVRog",10) == 1745806218) strcat(s, "a");
if (crc32("dxtsImrUheHPW",13) == 1521981508) strcat(s, "W");
if (crc32("HpkKHQifNf",10) == 1945024030) strcat(s, "r");
if (crc32("wxqkUCpClIJuRp",14) == 2889439285) strcat(s, "k");
if (crc32("wHvWl",5) == 854739218) strcat(s, "i");
if (crc32("zOELXOKpx",9) == 3685364693) strcat(s, "l");
if (crc32("ZFvXYcvxrFJhh",13) == 433771932) strcat(s, "y");
    return s;
}

char *overbulkily_adverbs() {
    char *s = calloc(12);
    if (crc32("GqQibmtZSEmm",12) == 1888631452) strcat(s, "o");
if (crc32("MvVgVsPaqzR",11) == 396335277) strcat(s, "v");
if (crc32("GEbYcGPJsTmamdl",15) == 1580001865) strcat(s, "v");
if (crc32("cVXDbdqjCDS",11) == 2032725997) strcat(s, "e");
if (crc32("bWlrevyyLB",10) == 2075849608) strcat(s, "r");
if (crc32("biXDFmZfNFMJ",12) == 4011589346) strcat(s, "L");
if (crc32("laOFzADvW",9) == 1081004759) strcat(s, "b");
if (crc32("ZGZAtGIrMQUA",12) == 1990978916) strcat(s, "h");
if (crc32("PpbmFrjXYlThvN",14) == 2456032152) strcat(s, "u");
if (crc32("DOvSnpJnyW",10) == 2077015609) strcat(s, "l");
if (crc32("amYkacvUqnzjkzF",15) == 285702462) strcat(s, "F");
if (crc32("bmFgtJp",7) == 1292298842) strcat(s, "k");
if (crc32("mReEwKT",7) == 3848697443) strcat(s, "i");
if (crc32("sFkdXmrvXzugdGB",15) == 626547268) strcat(s, "T");
if (crc32("DxuyDzmtOje",11) == 2813146417) strcat(s, "l");
if (crc32("mtaDZlnDXjcgBu",14) == 1092764609) strcat(s, "z");
if (crc32("crpsaOTMPSCSuz",14) == 90516134) strcat(s, "y");
    return s;
}

char *quasiexpensively_adverbs() {
    char *s = calloc(17);
    if (crc32("DEZdRgjyg",9) == 2625854010) strcat(s, "q");
if (crc32("bljWYhTy",8) == 2674518689) strcat(s, "u");
if (crc32("SdWwaPVbO",9) == 980211858) strcat(s, "P");
if (crc32("GoOhjQ",6) == 3190836055) strcat(s, "a");
if (crc32("DgkBIARMoZIVEKs",15) == 3201893634) strcat(s, "s");
if (crc32("JAgHZRIieJKbrR",14) == 3745745571) strcat(s, "J");
if (crc32("ngBkdr",6) == 1647013392) strcat(s, "i");
if (crc32("gyadLPSmMMENw",13) == 1480717647) strcat(s, "e");
if (crc32("eekYq",5) == 2744403462) strcat(s, "d");
if (crc32("ATmPsAS",7) == 253230863) strcat(s, "x");
if (crc32("TbYWq",5) == 722157208) strcat(s, "p");
if (crc32("LVmDyx",6) == 1626824876) strcat(s, "e");
if (crc32("dEAGvCpxWS",10) == 1064672604) strcat(s, "n");
if (crc32("qtyKxpZBGgP",11) == 25921799) strcat(s, "z");
if (crc32("siwvOiPBKJJ",11) == 2880370160) strcat(s, "s");
if (crc32("IQwZBJ",6) == 1600367158) strcat(s, "i");
if (crc32("GNOjqBsNTb",10) == 3396308225) strcat(s, "v");
if (crc32("mLGqjyU",7) == 2524664542) strcat(s, "e");
if (crc32("nXwpL",5) == 4017230820) strcat(s, "l");
if (crc32("eRBVXbi",7) == 3371950406) strcat(s, "y");
    return s;
}

char *unreceptively_adverbs() {
    char *s = calloc(14);
    if (crc32("wqWoORNJyLTG",12) == 4136051865) strcat(s, "u");
if (crc32("OKdknkKhbrm",11) == 3375475613) strcat(s, "n");
if (crc32("xWlEjtOi",8) == 1462552496) strcat(s, "r");
if (crc32("lDerszZaskdUn",13) == 3809796958) strcat(s, "c");
if (crc32("jwvRyNjap",9) == 2709848940) strcat(s, "e");
if (crc32("QposLmEsmjW",11) == 4104483377) strcat(s, "U");
if (crc32("dIAFinixV",9) == 2266687712) strcat(s, "c");
if (crc32("BzEqVpIgMzKZdTD",15) == 3561802786) strcat(s, "I");
if (crc32("sKtiTqhpRgFoxQ",14) == 3310309927) strcat(s, "e");
if (crc32("FUNkNnUEME",10) == 3728467222) strcat(s, "w");
if (crc32("RHQyhesGHqzXpk",14) == 295545959) strcat(s, "p");
if (crc32("AHoqVmWqiyt",11) == 1363180786) strcat(s, "t");
if (crc32("MIBMp",5) == 3868288392) strcat(s, "i");
if (crc32("NvkkaArgt",9) == 4079234980) strcat(s, "M");
if (crc32("cOxYCLNHIboy",12) == 1163768673) strcat(s, "v");
if (crc32("kPoIsMez",8) == 4024573049) strcat(s, "X");
if (crc32("TDOXAvQop",9) == 3257371555) strcat(s, "e");
if (crc32("nftLl",5) == 870859318) strcat(s, "e");
if (crc32("HWsNlmsKzZuFub",14) == 57942255) strcat(s, "l");
if (crc32("ISCSVPoFwfH",11) == 2891867931) strcat(s, "i");
if (crc32("LZinWgQ",7) == 2737494745) strcat(s, "y");
    return s;
}

char *impulsively_adverbs() {
    char *s = calloc(12);
    if (crc32("QEOtELScqJ",10) == 2010623178) strcat(s, "Z");
if (crc32("xQHOOHsWuXO",11) == 2476515073) strcat(s, "i");
if (crc32("VkHrVhIegC",10) == 466005058) strcat(s, "T");
if (crc32("ddhbZAYUkRLeTRy",15) == 2714388728) strcat(s, "m");
if (crc32("ZITWmTvK",8) == 1474934317) strcat(s, "p");
if (crc32("CCGiiwDYhMpTS",13) == 105203251) strcat(s, "E");
if (crc32("PTBsxhgAGjgdl",13) == 3741069855) strcat(s, "u");
if (crc32("hAsyGBxNBB",10) == 218115138) strcat(s, "l");
if (crc32("RKEBMuX",7) == 2718814246) strcat(s, "s");
if (crc32("zgDiopV",7) == 3311675603) strcat(s, "i");
if (crc32("tKxcgXpkISvmr",13) == 3357339499) strcat(s, "v");
if (crc32("VWBUPmeHWYJpk",13) == 762809971) strcat(s, "i");
if (crc32("GUfHcdFVqkWbh",13) == 3352903372) strcat(s, "e");
if (crc32("xGihKDOGASuDE",13) == 1869443508) strcat(s, "l");
if (crc32("arHBHjaqoXIkN",13) == 3335822041) strcat(s, "Q");
if (crc32("adhSfkiwpMXI",12) == 887323020) strcat(s, "y");
    return s;
}

char *supersafely_adverbs() {
    char *s = calloc(12);
    if (crc32("SdWCdfQ",7) == 823690311) strcat(s, "K");
if (crc32("OCKeTzHrOk",10) == 1182016281) strcat(s, "s");
if (crc32("GxazpxeeejIwmB",14) == 2846807855) strcat(s, "y");
if (crc32("QFsRshOdPS",10) == 1858446350) strcat(s, "u");
if (crc32("SUYPSdmb",8) == 2334053428) strcat(s, "q");
if (crc32("pUZOKHIeM",9) == 1827154323) strcat(s, "p");
if (crc32("jFZDEgaSzJhFrgn",15) == 1771635176) strcat(s, "e");
if (crc32("ilcUZEZE",8) == 201383691) strcat(s, "r");
if (crc32("Aiuqb",5) == 2147148584) strcat(s, "G");
if (crc32("lVfIp",5) == 1231163341) strcat(s, "s");
if (crc32("ApAIZwV",7) == 1960868522) strcat(s, "a");
if (crc32("LbMfNgHx",8) == 4070572272) strcat(s, "f");
if (crc32("IPAvGpOuupWL",12) == 3740037860) strcat(s, "e");
if (crc32("MxUSDYZMdRQ",11) == 730772195) strcat(s, "l");
if (crc32("IAVSALfTA",9) == 2618756589) strcat(s, "y");
    return s;
}

char *halfintellectually_adverbs() {
    char *s = calloc(19);
    if (crc32("qpUCNiqYWxRlg",13) == 2283102008) strcat(s, "G");
if (crc32("JcMFQz",6) == 3481927825) strcat(s, "h");
if (crc32("boarcaHwMnhAGAh",15) == 2330723127) strcat(s, "a");
if (crc32("wUFhTQXIcWbbV",13) == 3902512407) strcat(s, "g");
if (crc32("yyrHOStkVpHnOm",14) == 4073902454) strcat(s, "l");
if (crc32("vkHESsm",7) == 2523020889) strcat(s, "R");
if (crc32("BrlQKwxlFwvBHbK",15) == 516205296) strcat(s, "f");
if (crc32("LhgKNQSd",8) == 1781235575) strcat(s, "Q");
if (crc32("ABjByqrsjoEDu",13) == 592751663) strcat(s, "i");
if (crc32("ouZAibGZeYErzU",14) == 3489215940) strcat(s, "B");
if (crc32("sDQAQ",5) == 4099340745) strcat(s, "n");
if (crc32("vtMHoEjPqR",10) == 348358905) strcat(s, "V");
if (crc32("MurjWRGUnbWLY",13) == 1707938631) strcat(s, "t");
if (crc32("BsbwrnIYFbH",11) == 3723098687) strcat(s, "e");
if (crc32("xgNlMawVM",9) == 2325063792) strcat(s, "l");
if (crc32("RYEZvIDoAyhpp",13) == 2022606024) strcat(s, "l");
if (crc32("gdAQevxDo",9) == 2742565696) strcat(s, "e");
if (crc32("NWlsmyULuR",10) == 3170425279) strcat(s, "W");
if (crc32("sjfZpe",6) == 2188861112) strcat(s, "c");
if (crc32("FnAKYSgXvIcv",12) == 1986837768) strcat(s, "w");
if (crc32("mMTvDRwibgWZsO",14) == 4046929523) strcat(s, "t");
if (crc32("aHOdGSWdvcNBK",13) == 1707840829) strcat(s, "u");
if (crc32("yOmee",5) == 885561556) strcat(s, "g");
if (crc32("duIMxk",6) == 2957885786) strcat(s, "a");
if (crc32("DiAQsOVIFVHyip",14) == 3277406595) strcat(s, "l");
if (crc32("XXEEnkVrTfxbZ",13) == 4085262410) strcat(s, "l");
if (crc32("qVuVqigkDouUc",13) == 1117214138) strcat(s, "A");
if (crc32("piAAiqiZzQCH",12) == 3738938384) strcat(s, "y");
    return s;
}

char *quasifully_adverbs() {
    char *s = calloc(11);
    if (crc32("fxyhLEPavwzPpH",14) == 3612133191) strcat(s, "q");
if (crc32("ktgXRKGctBtM",12) == 3756187316) strcat(s, "u");
if (crc32("vPxwtCE",7) == 2936695014) strcat(s, "a");
if (crc32("gzkjlJ",6) == 3782726910) strcat(s, "s");
if (crc32("EVUfmYmBLzki",12) == 1650707450) strcat(s, "i");
if (crc32("EqRDbVkK",8) == 1911094404) strcat(s, "v");
if (crc32("biJARYntIG",10) == 2839433129) strcat(s, "f");
if (crc32("WfdYyR",6) == 636801329) strcat(s, "N");
if (crc32("JJnuyHHtLRZXunJ",15) == 1706893169) strcat(s, "u");
if (crc32("hDQytYTaGM",10) == 2591830491) strcat(s, "s");
if (crc32("XuUuX",5) == 3476003735) strcat(s, "l");
if (crc32("eXZajWk",7) == 945890365) strcat(s, "u");
if (crc32("ucqlw",5) == 2358837788) strcat(s, "l");
if (crc32("aBWrs",5) == 1412092746) strcat(s, "v");
if (crc32("RoTKlWGKEPrxS",13) == 2318519058) strcat(s, "y");
    return s;
}

char *acquiescingly_adverbs() {
    char *s = calloc(14);
    if (crc32("fnkCuXYkL",9) == 2850675918) strcat(s, "a");
if (crc32("JiywHOfhdpt",11) == 3733210035) strcat(s, "c");
if (crc32("NXqniUbZcdcpXi",14) == 1223606525) strcat(s, "E");
if (crc32("elXoyLwfQnrjalo",15) == 3072830466) strcat(s, "q");
if (crc32("lobEDqwxdvBQ",12) == 1950061996) strcat(s, "c");
if (crc32("bUuQYuOjfp",10) == 2422819061) strcat(s, "u");
if (crc32("HIsoXtWFGbehII",14) == 3811007080) strcat(s, "i");
if (crc32("dRMMc",5) == 2728640078) strcat(s, "a");
if (crc32("dViOWlchztCGQ",13) == 527039406) strcat(s, "e");
if (crc32("lHPLvUsAQGaFhX",14) == 195167079) strcat(s, "Q");
if (crc32("OihwBHS",7) == 3869424696) strcat(s, "s");
if (crc32("PsmISpThYQKijYz",15) == 2525971949) strcat(s, "c");
if (crc32("GWZZJ",5) == 892104378) strcat(s, "E");
if (crc32("iUVhmdvdDAa",11) == 49530987) strcat(s, "i");
if (crc32("IjiILXA",7) == 2643923869) strcat(s, "n");
if (crc32("VWCykgYcWClhzW",14) == 81210134) strcat(s, "R");
if (crc32("PXJhJcZklgssdG",14) == 2792055844) strcat(s, "g");
if (crc32("DRBZtD",6) == 218920921) strcat(s, "l");
if (crc32("QLuyESaUAr",10) == 1199471885) strcat(s, "i");
if (crc32("rhIFvuMOVDlhYz",14) == 3355197767) strcat(s, "y");
    return s;
}

char *tenuously_adverbs() {
    char *s = calloc(10);
    if (crc32("aDoOVpWRs",9) == 230530841) strcat(s, "P");
if (crc32("mdsWaVhVgCdWYS",14) == 351223462) strcat(s, "t");
if (crc32("pkSbjAWgPKlo",12) == 822633577) strcat(s, "a");
if (crc32("PkTGssuo",8) == 1677840905) strcat(s, "e");
if (crc32("TOGkkKTdcOnJMO",14) == 2342213849) strcat(s, "e");
if (crc32("dAOONQ",6) == 2366839913) strcat(s, "n");
if (crc32("EmKKdyfMxBiXVRC",15) == 1902648011) strcat(s, "u");
if (crc32("tHstPHwE",8) == 1752484745) strcat(s, "o");
if (crc32("HjUyxnAahEgjt",13) == 1118645406) strcat(s, "n");
if (crc32("VFbqlfBqYofOL",13) == 3319316437) strcat(s, "u");
if (crc32("zIhwBmDPbOv",11) == 3504291254) strcat(s, "s");
if (crc32("wNEzjTW",7) == 2636695904) strcat(s, "c");
if (crc32("AmndqVrPTYzeC",13) == 3581662513) strcat(s, "l");
if (crc32("MYbacuEXmkadd",13) == 582607811) strcat(s, "F");
if (crc32("lyGIGbXmlpTz",12) == 683519442) strcat(s, "y");
    return s;
}

char *Frenchly_adverbs() {
    char *s = calloc(9);
    if (crc32("GEQHrmHSc",9) == 3037948796) strcat(s, "I");
if (crc32("ZZDnR",5) == 431594588) strcat(s, "F");
if (crc32("kSDVwMFDS",9) == 3119088240) strcat(s, "r");
if (crc32("XtHkUFnogFiEnD",14) == 3370546433) strcat(s, "e");
if (crc32("bsbymze",7) == 1362192958) strcat(s, "n");
if (crc32("ikOixdptwwDlC",13) == 948271542) strcat(s, "c");
if (crc32("KjbAg",5) == 3430751443) strcat(s, "h");
if (crc32("kxJWlmVWZ",9) == 897648483) strcat(s, "l");
if (crc32("HfASQJQcwhN",11) == 2747947106) strcat(s, "y");
    return s;
}

char *hyperpolysyllabically_adverbs() {
    char *s = calloc(22);
    if (crc32("AVvAhZSscBiiX",13) == 770132505) strcat(s, "J");
if (crc32("KTBcVTMCtmlpu",13) == 688789711) strcat(s, "h");
if (crc32("HDVlv",5) == 2525601080) strcat(s, "N");
if (crc32("HhtvsWjbRazEHq",14) == 408564966) strcat(s, "y");
if (crc32("WspIJQC",7) == 4167514115) strcat(s, "x");
if (crc32("LvaCpv",6) == 3637866715) strcat(s, "p");
if (crc32("ZNlTOOp",7) == 1796532265) strcat(s, "e");
if (crc32("RFslBndYBOtyGFj",15) == 3465415310) strcat(s, "p");
if (crc32("fFpinkhNsO",10) == 2592005902) strcat(s, "r");
if (crc32("DduxvfZxxCpM",12) == 3998031405) strcat(s, "p");
if (crc32("uwLEbeJBZyfHxCl",15) == 3992765720) strcat(s, "E");
if (crc32("HReKTOPBHFJePLA",15) == 2032172538) strcat(s, "o");
if (crc32("hMCGgoyUTOfmxZ",14) == 3975660794) strcat(s, "W");
if (crc32("XdVLG",5) == 2789250427) strcat(s, "l");
if (crc32("CvsdfHFJcRZBDsr",15) == 1861053922) strcat(s, "E");
if (crc32("opAaAEdpXSb",11) == 1638597635) strcat(s, "y");
if (crc32("aJAGbxZ",7) == 2138321533) strcat(s, "K");
if (crc32("MMppcDymhtrQ",12) == 3247382117) strcat(s, "s");
if (crc32("jCmFoAHl",8) == 1579937423) strcat(s, "F");
if (crc32("TsbyilODdAXHyM",14) == 237918169) strcat(s, "y");
if (crc32("tMyIyWFZNblYc",13) == 4287514714) strcat(s, "e");
if (crc32("XubvDPcozqsl",12) == 2463860527) strcat(s, "l");
if (crc32("nsbqKUDfu",9) == 1272162896) strcat(s, "f");
if (crc32("oGMNYWf",7) == 455176337) strcat(s, "l");
if (crc32("XvokHgyuxZp",11) == 56484152) strcat(s, "L");
if (crc32("KpktsKxLc",9) == 795738892) strcat(s, "a");
if (crc32("cNzmEzXie",9) == 1012614913) strcat(s, "b");
if (crc32("GCXGInYvLJIjdWJ",15) == 2052815075) strcat(s, "i");
if (crc32("yXqxSkdigLPU",12) == 2033138043) strcat(s, "c");
if (crc32("WICpDRKPOKCJlT",14) == 211997294) strcat(s, "a");
if (crc32("JXITQDXFfdzU",12) == 2936660970) strcat(s, "l");
if (crc32("VfKhQDr",7) == 1729965948) strcat(s, "r");
if (crc32("SetDxiT",7) == 1301759795) strcat(s, "l");
if (crc32("pSIDmiKsoLWpuEh",15) == 856121888) strcat(s, "y");
    return s;
}

char *convincingly_adverbs() {
    char *s = calloc(13);
    if (crc32("gRLcEBSbbKtTzh",14) == 570802564) strcat(s, "A");
if (crc32("lpYnE",5) == 1870277572) strcat(s, "c");
if (crc32("SbBRTpbjmBBvVVy",15) == 1276775255) strcat(s, "o");
if (crc32("ZZdLtLjELFul",12) == 4134955246) strcat(s, "n");
if (crc32("PYLSkVxQVYNRdQB",15) == 807570852) strcat(s, "v");
if (crc32("KvUzRPsuRunqe",13) == 2930709268) strcat(s, "i");
if (crc32("MiXDTXWSj",9) == 346772582) strcat(s, "n");
if (crc32("ZqdZUtQInQDwg",13) == 2467962242) strcat(s, "r");
if (crc32("oMhIEbrDgOhsmIK",15) == 805178830) strcat(s, "c");
if (crc32("vCyqMIcJtPvubgw",15) == 2142748701) strcat(s, "i");
if (crc32("SlGzWhDwoN",10) == 569715176) strcat(s, "h");
if (crc32("UJaJYRjepNbdHvR",15) == 321123793) strcat(s, "n");
if (crc32("idbeOwaiJW",10) == 172938391) strcat(s, "g");
if (crc32("SjHmHXFTPUtZ",12) == 1028503707) strcat(s, "l");
if (crc32("SWeDMFuNRV",10) == 2436416835) strcat(s, "N");
if (crc32("XEpFYhJdTlWgz",13) == 2024149237) strcat(s, "y");
    return s;
}

char *evermore_adverbs() {
    char *s = calloc(9);
    if (crc32("jRxeBlyTLENF",12) == 4207861735) strcat(s, "e");
if (crc32("IxvVswhujl",10) == 1369373170) strcat(s, "v");
if (crc32("cshZNnhMB",9) == 1908762627) strcat(s, "Q");
if (crc32("QoLMsRxI",8) == 2818423220) strcat(s, "e");
if (crc32("fwGKccDkWZR",11) == 3504331575) strcat(s, "r");
if (crc32("UPjEBCwVIdAY",12) == 407612063) strcat(s, "m");
if (crc32("zcqPgRPIWwx",11) == 3167499029) strcat(s, "i");
if (crc32("RTQmJaGwyp",10) == 4046203425) strcat(s, "o");
if (crc32("yhMSyMCsO",9) == 4084330606) strcat(s, "H");
if (crc32("auvGbH",6) == 1461040737) strcat(s, "r");
if (crc32("kIwBJew",7) == 1287438540) strcat(s, "n");
if (crc32("ECvcTEJNC",9) == 1237169342) strcat(s, "e");
    return s;
}

char *semineurotically_adverbs() {
    char *s = calloc(17);
    if (crc32("evaJYAJUjQE",11) == 2074553514) strcat(s, "U");
if (crc32("VcSNaH",6) == 316331030) strcat(s, "s");
if (crc32("eTUDXJG",7) == 3086579128) strcat(s, "e");
if (crc32("ebtGiAvaHgAF",12) == 3084516168) strcat(s, "m");
if (crc32("cWRDco",6) == 3195808346) strcat(s, "f");
if (crc32("QJtOREW",7) == 1846648794) strcat(s, "i");
if (crc32("sRFIQQ",6) == 2467226777) strcat(s, "s");
if (crc32("HeNmOcFDbjBI",12) == 1725389047) strcat(s, "n");
if (crc32("vseYWTONQ",9) == 1083971539) strcat(s, "T");
if (crc32("LVfoAArywbHX",12) == 3562805329) strcat(s, "e");
if (crc32("GUHvUBvcWpB",11) == 4055999449) strcat(s, "z");
if (crc32("OXHkpPcsaHmsXIz",15) == 3332209533) strcat(s, "u");
if (crc32("aSaKnytWtmUyv",13) == 3042928578) strcat(s, "E");
if (crc32("ZbzQu",5) == 4278655967) strcat(s, "r");
if (crc32("JrYGtnQ",7) == 3168236410) strcat(s, "o");
if (crc32("oNpgTuQQdtY",11) == 4007159618) strcat(s, "t");
if (crc32("cqbmXUjqseu",11) == 2691426786) strcat(s, "i");
if (crc32("eGVeVe",6) == 1864809405) strcat(s, "k");
if (crc32("GwxObQIyuejZMIX",15) == 2581186131) strcat(s, "c");
if (crc32("hjMTVAg",7) == 4056824208) strcat(s, "f");
if (crc32("pLGcJwPROEjb",12) == 3422703054) strcat(s, "a");
if (crc32("KLQORSwMBNy",11) == 2803728728) strcat(s, "l");
if (crc32("PBWwtfq",7) == 4134071740) strcat(s, "u");
if (crc32("iOmxrmJtpASqEjt",15) == 1152200548) strcat(s, "l");
if (crc32("jaCLi",5) == 2353324795) strcat(s, "y");
    return s;
}

char *nonsuppositively_adverbs() {
    char *s = calloc(17);
    if (crc32("gWmDJsrFhZYZxp",14) == 247467536) strcat(s, "q");
if (crc32("TkfvETzHlWBIcv",14) == 2254599506) strcat(s, "n");
if (crc32("TCEgsVqrO",9) == 4116979066) strcat(s, "J");
if (crc32("IPrxZAOlMHX",11) == 332831731) strcat(s, "o");
if (crc32("IPdWGxqXt",9) == 2601348793) strcat(s, "n");
if (crc32("hzlYtSdkuseg",12) == 504685580) strcat(s, "g");
if (crc32("IZSYFHaq",8) == 4032735072) strcat(s, "s");
if (crc32("ItJquNlIDKn",11) == 1884812267) strcat(s, "p");
if (crc32("LGsHNjasMsJar",13) == 386977465) strcat(s, "u");
if (crc32("rAIHEsmUKdiEh",13) == 3485734712) strcat(s, "h");
if (crc32("YnWgjXM",7) == 173172182) strcat(s, "p");
if (crc32("uIWuMl",6) == 3137177202) strcat(s, "p");
if (crc32("dUkgeUnwMu",10) == 2280034959) strcat(s, "o");
if (crc32("iGyqPczecNKTB",13) == 1658659124) strcat(s, "h");
if (crc32("aaZhnH",6) == 3073759604) strcat(s, "s");
if (crc32("ZRxlpFD",7) == 3559287278) strcat(s, "V");
if (crc32("BaPBuJfmleyN",12) == 2484473361) strcat(s, "i");
if (crc32("Msxdb",5) == 3445360954) strcat(s, "R");
if (crc32("bGhtZzq",7) == 1308543121) strcat(s, "t");
if (crc32("EuRZlGAfbjgav",13) == 125086580) strcat(s, "i");
if (crc32("UsvADrXaP",9) == 2932365496) strcat(s, "v");
if (crc32("oxQTuAODEMxljt",14) == 1105049827) strcat(s, "X");
if (crc32("KyQUt",5) == 49031648) strcat(s, "e");
if (crc32("JqXTrhzGldIC",12) == 4250284987) strcat(s, "l");
if (crc32("tmvDLkyly",9) == 2704047568) strcat(s, "Y");
if (crc32("BGQsFOxkddxaxc",14) == 1041473611) strcat(s, "y");
    return s;
}

char *tenderly_adverbs() {
    char *s = calloc(9);
    if (crc32("psTqoM",6) == 4291225258) strcat(s, "t");
if (crc32("JSYVr",5) == 1012852804) strcat(s, "e");
if (crc32("FVqUxfq",7) == 1375671979) strcat(s, "H");
if (crc32("XgLahlYUVS",10) == 1479316416) strcat(s, "n");
if (crc32("IOJVDKuXCKQv",12) == 3437413940) strcat(s, "w");
if (crc32("VYvraTTsR",9) == 1854265325) strcat(s, "d");
if (crc32("OZSYwDBsH",9) == 1257755887) strcat(s, "e");
if (crc32("tCmSkt",6) == 1224045715) strcat(s, "r");
if (crc32("cdCeoSFtVhY",11) == 721802935) strcat(s, "Q");
if (crc32("atmbOplZhrqaCel",15) == 149056083) strcat(s, "l");
if (crc32("fiqUbkreMC",10) == 1347605523) strcat(s, "y");
    return s;
}

char *costively_adverbs() {
    char *s = calloc(10);
    if (crc32("KCNcLslRm",9) == 4253348617) strcat(s, "G");
if (crc32("MjGVhezLWWbFOl",14) == 3762193120) strcat(s, "c");
if (crc32("FOnBxvH",7) == 136728612) strcat(s, "o");
if (crc32("XTpGPBZeysQ",11) == 1851306868) strcat(s, "v");
if (crc32("fCQWQ",5) == 3709430869) strcat(s, "s");
if (crc32("trCjrVWhK",9) == 823324945) strcat(s, "t");
if (crc32("arIcMvDOpZAkX",13) == 2292339610) strcat(s, "s");
if (crc32("VcVTOIMwGhR",11) == 2155072739) strcat(s, "i");
if (crc32("zFDVRTuKxYeoccX",15) == 2341428864) strcat(s, "u");
if (crc32("UHRkAFVSxwwtT",13) == 2177795735) strcat(s, "v");
if (crc32("qhXZfGimaqekmAu",15) == 3653490600) strcat(s, "r");
if (crc32("bqMhTEpJhmMQh",13) == 4113914124) strcat(s, "e");
if (crc32("zReieXMSOTymH",13) == 1337660359) strcat(s, "A");
if (crc32("lOCZHOFZHgDbpQ",14) == 1895620096) strcat(s, "l");
if (crc32("YVkjEN",6) == 2552048596) strcat(s, "y");
    return s;
}

char *dilatorily_adverbs() {
    char *s = calloc(11);
    if (crc32("ZmYfVpnFQZRyYV",14) == 1692792092) strcat(s, "Q");
if (crc32("gkCLZ",5) == 2763630392) strcat(s, "d");
if (crc32("pUlHU",5) == 2706356848) strcat(s, "i");
if (crc32("WUpdYpafTeTIE",13) == 2367831642) strcat(s, "s");
if (crc32("QUxsFzMfbduNqZq",15) == 3777317011) strcat(s, "l");
if (crc32("PFPOB",5) == 2182987606) strcat(s, "b");
if (crc32("EgNstesMqs",10) == 2098044076) strcat(s, "a");
if (crc32("WbWBzOkX",8) == 2309860019) strcat(s, "t");
if (crc32("XcurkFZPumdptV",14) == 476637984) strcat(s, "o");
if (crc32("lPvLXXgN",8) == 1443172620) strcat(s, "r");
if (crc32("ERrEXOsOhgR",11) == 1895542560) strcat(s, "y");
if (crc32("jqJjSoMkw",9) == 712413887) strcat(s, "i");
if (crc32("IqPsCRKnXr",10) == 3882987721) strcat(s, "l");
if (crc32("IOpGRKTQeNnefX",14) == 4072690836) strcat(s, "L");
if (crc32("inBrCpVjCzKGWSV",15) == 3291366476) strcat(s, "y");
    return s;
}

char *overliterarily_adverbs() {
    char *s = calloc(15);
    if (crc32("wSkmQlseWu",10) == 2721256299) strcat(s, "o");
if (crc32("GLwjBLnBmLlH",12) == 3550508720) strcat(s, "b");
if (crc32("JygQmIGOYNAgb",13) == 1286647947) strcat(s, "v");
if (crc32("phiwNJaHuvrMGft",15) == 4176188124) strcat(s, "C");
if (crc32("mxHvPv",6) == 3238787908) strcat(s, "e");
if (crc32("HUVHTGIQFoilu",13) == 1076960927) strcat(s, "D");
if (crc32("traLS",5) == 3976034389) strcat(s, "r");
if (crc32("MEvDiuGCUcBytF",14) == 3619786875) strcat(s, "l");
if (crc32("WOvTWrgoaP",10) == 3855657355) strcat(s, "O");
if (crc32("crbPxlBqf",9) == 613178584) strcat(s, "i");
if (crc32("tkyBjhUSfSN",11) == 2504094973) strcat(s, "t");
if (crc32("cXMfkrQtKXvaAi",14) == 2775271858) strcat(s, "e");
if (crc32("rrWdrqlujUArP",13) == 353960254) strcat(s, "r");
if (crc32("DFzNTamzRDwngA",14) == 1432828129) strcat(s, "a");
if (crc32("yRYDeYosgkFjA",13) == 2296367261) strcat(s, "x");
if (crc32("TazgeFQYoP",10) == 2108968180) strcat(s, "r");
if (crc32("nEcuSFebVGso",12) == 2555930200) strcat(s, "i");
if (crc32("sSzmSNcLxg",10) == 52194987) strcat(s, "V");
if (crc32("vJcUETvUzkAYGcm",15) == 255758548) strcat(s, "l");
if (crc32("evpgPJUuN",9) == 3967450758) strcat(s, "K");
if (crc32("DqapcCXm",8) == 2730382620) strcat(s, "y");
    return s;
}

char *retributively_adverbs() {
    char *s = calloc(14);
    if (crc32("idICDZIqSqVb",12) == 2102377317) strcat(s, "v");
if (crc32("zexLFCyrXgS",11) == 1411355342) strcat(s, "r");
if (crc32("kROTFgAIi",9) == 531568649) strcat(s, "e");
if (crc32("SRqcOIqD",8) == 4018418481) strcat(s, "t");
if (crc32("YSJehmG",7) == 3591662564) strcat(s, "z");
if (crc32("yYaVBlftWVfxU",13) == 1837819211) strcat(s, "r");
if (crc32("ZSpZPvibR",9) == 2018388224) strcat(s, "i");
if (crc32("CvEPFHVuRlG",11) == 160266868) strcat(s, "K");
if (crc32("zXaQuwEziKxSE",13) == 3355113046) strcat(s, "b");
if (crc32("zKbplm",6) == 3510180272) strcat(s, "T");
if (crc32("fVOmPcPRUu",10) == 3043820909) strcat(s, "u");
if (crc32("eOfTQsQjBpQtoG",14) == 4099148158) strcat(s, "t");
if (crc32("kpZyzxzghoKSi",13) == 2951576933) strcat(s, "D");
if (crc32("cLUHMGCuX",9) == 2360847340) strcat(s, "i");
if (crc32("pfcrDgsItSn",11) == 1467538880) strcat(s, "v");
if (crc32("uhOTShgNVAkkJ",13) == 961309525) strcat(s, "Z");
if (crc32("VamdLZ",6) == 2661802101) strcat(s, "e");
if (crc32("UOcosuyMvsI",11) == 1560347034) strcat(s, "l");
if (crc32("vIAvLpwo",8) == 1415096159) strcat(s, "l");
if (crc32("lwRDMQUV",8) == 3820643969) strcat(s, "z");
if (crc32("MJnhgLYBwItWgiS",15) == 2954261724) strcat(s, "y");
    return s;
}

char *freshly_adverbs() {
    char *s = calloc(8);
    if (crc32("homDjMyVHfJMLvQ",15) == 2542747514) strcat(s, "v");
if (crc32("zDAVFwYHJYbbZAl",15) == 641964209) strcat(s, "f");
if (crc32("tRoVci",6) == 2961111865) strcat(s, "W");
if (crc32("CAWmk",5) == 2568585171) strcat(s, "r");
if (crc32("CcKsEwE",7) == 551534145) strcat(s, "e");
if (crc32("GCFyPohzv",9) == 2168083543) strcat(s, "s");
if (crc32("eJPYIgobIS",10) == 2216267161) strcat(s, "h");
if (crc32("PZqOkGTlnQve",12) == 4040528660) strcat(s, "l");
if (crc32("Hicbyk",6) == 433574487) strcat(s, "A");
if (crc32("aTyKcdPvQKx",11) == 495220203) strcat(s, "y");
    return s;
}

char *anagrammatically_adverbs() {
    char *s = calloc(17);
    if (crc32("VSvdgavFWnMklau",15) == 3214019703) strcat(s, "a");
if (crc32("DZqkz",5) == 2886454907) strcat(s, "n");
if (crc32("vBIRDVDOHyHbhae",15) == 3174916515) strcat(s, "a");
if (crc32("jMlvXoug",8) == 3302850549) strcat(s, "g");
if (crc32("VAAnrmRMdaSAwLm",15) == 3022935509) strcat(s, "r");
if (crc32("DlkJdjFlNkzOJU",14) == 4130178964) strcat(s, "a");
if (crc32("KStwHT",6) == 1252784105) strcat(s, "a");
if (crc32("BTMBJp",6) == 3977583886) strcat(s, "k");
if (crc32("ABSUox",6) == 1484894514) strcat(s, "m");
if (crc32("lSNxphCK",8) == 3012682046) strcat(s, "q");
if (crc32("UFKtDvEV",8) == 2113817121) strcat(s, "m");
if (crc32("iuHDZmJeZqI",11) == 3986214340) strcat(s, "a");
if (crc32("xATXekBMoxHqoko",15) == 1116499575) strcat(s, "t");
if (crc32("oBRTHiUQxay",11) == 1806464805) strcat(s, "i");
if (crc32("sMIxDQdXgekkVe",14) == 3747817276) strcat(s, "c");
if (crc32("qtNYioO",7) == 13439145) strcat(s, "i");
if (crc32("xaBusun",7) == 1365561775) strcat(s, "a");
if (crc32("mxPcZTgbYzL",11) == 1514121380) strcat(s, "l");
if (crc32("HQdGMUFyGc",10) == 321551286) strcat(s, "l");
if (crc32("nyuOoVysMQvs",12) == 1097467160) strcat(s, "y");
    return s;
}

char *conspiratorially_adverbs() {
    char *s = calloc(17);
    if (crc32("wnJbuIAhl",9) == 471573982) strcat(s, "L");
if (crc32("xFfmRICZkiB",11) == 2546237967) strcat(s, "c");
if (crc32("gjkFQTVlUInz",12) == 2138483667) strcat(s, "H");
if (crc32("ciQkuDF",7) == 3087894002) strcat(s, "o");
if (crc32("jJYhWZLJhxXZS",13) == 144869791) strcat(s, "n");
if (crc32("anXupB",6) == 3204866252) strcat(s, "s");
if (crc32("siFFlkiio",9) == 2156416986) strcat(s, "p");
if (crc32("MiLQhKbbIGU",11) == 2397757579) strcat(s, "i");
if (crc32("fhUwZJ",6) == 3172855165) strcat(s, "r");
if (crc32("XEPosRuZqTFIpjD",15) == 4070258689) strcat(s, "a");
if (crc32("EFfVIhgkKVr",11) == 1059626984) strcat(s, "t");
if (crc32("wMNpXWZkXHY",11) == 2989017058) strcat(s, "x");
if (crc32("lBxqBtd",7) == 4216946274) strcat(s, "o");
if (crc32("urdVSWBNQSvsiS",14) == 63135952) strcat(s, "r");
if (crc32("zyrXTbXameYkptQ",15) == 3786331587) strcat(s, "D");
if (crc32("FcjsHNNIsBo",11) == 2393138848) strcat(s, "i");
if (crc32("QJgfeyZYGUlLC",13) == 99759121) strcat(s, "j");
if (crc32("XfOxFCnmIaLLBK",14) == 827639478) strcat(s, "a");
if (crc32("tuiiAZ",6) == 3590370162) strcat(s, "B");
if (crc32("lKdkgsVx",8) == 2610190945) strcat(s, "l");
if (crc32("xZYyP",5) == 1573598625) strcat(s, "l");
if (crc32("QoVpdjRlOg",10) == 2378076643) strcat(s, "y");
    return s;
}

char *nonconclusively_adverbs() {
    char *s = calloc(16);
    if (crc32("IsOiDR",6) == 3001442821) strcat(s, "n");
if (crc32("tIhhpTiaWO",10) == 257796994) strcat(s, "o");
if (crc32("RTgGNW",6) == 1975948151) strcat(s, "n");
if (crc32("qYlFAh",6) == 3948149914) strcat(s, "c");
if (crc32("aclkwBxEobg",11) == 1048231482) strcat(s, "o");
if (crc32("UGzPlE",6) == 2693940034) strcat(s, "n");
if (crc32("QUQkdCOjiIMTI",13) == 2308782463) strcat(s, "c");
if (crc32("lOenZ",5) == 3409475279) strcat(s, "j");
if (crc32("hhCdKrgPsgMk",12) == 1121547056) strcat(s, "l");
if (crc32("bdShPEVBttJV",12) == 1860379239) strcat(s, "u");
if (crc32("bgcIeCpQFBIf",12) == 620820867) strcat(s, "s");
if (crc32("LSTBw",5) == 3842157933) strcat(s, "i");
if (crc32("AwlOhvPwzuXhf",13) == 2868108068) strcat(s, "U");
if (crc32("xVrugA",6) == 1502304942) strcat(s, "v");
if (crc32("UDbEKhQbesf",11) == 1056935983) strcat(s, "e");
if (crc32("ijJNIFvcIfmFOl",14) == 908802426) strcat(s, "l");
if (crc32("EXsNNnZvZxi",11) == 898161399) strcat(s, "L");
if (crc32("TWQPIFqSxTk",11) == 2213186824) strcat(s, "y");
    return s;
}

char *auditorily_adverbs() {
    char *s = calloc(11);
    if (crc32("YzKSpEOJdBjZ",12) == 2243804443) strcat(s, "o");
if (crc32("oYufqgwT",8) == 89833221) strcat(s, "a");
if (crc32("juBDoykpH",9) == 2091070429) strcat(s, "r");
if (crc32("JppIcFk",7) == 1596533466) strcat(s, "u");
if (crc32("sUnsnxvcapGkiGG",15) == 222240809) strcat(s, "x");
if (crc32("ZUcUUxn",7) == 1129337140) strcat(s, "d");
if (crc32("XcQxUFMUSvar",12) == 2805501103) strcat(s, "i");
if (crc32("sLmVtgchlDcfTy",14) == 3036158343) strcat(s, "v");
if (crc32("OJUKHCSAAW",10) == 3566745299) strcat(s, "t");
if (crc32("JKFztOm",7) == 3701697620) strcat(s, "o");
if (crc32("ZwzquksvyonBMtr",15) == 3419650739) strcat(s, "v");
if (crc32("GkrrXLwKrwCW",12) == 3800914582) strcat(s, "r");
if (crc32("dDtNNjAE",8) == 669524766) strcat(s, "i");
if (crc32("lhzficfRHV",10) == 1869879590) strcat(s, "S");
if (crc32("KnawlLeQL",9) == 1537168505) strcat(s, "l");
if (crc32("ddqwQJi",7) == 271356266) strcat(s, "y");
    return s;
}

char *bleatingly_adverbs() {
    char *s = calloc(11);
    if (crc32("koOePGWesbOKn",13) == 3433792690) strcat(s, "b");
if (crc32("UNTuATheqtP",11) == 2361497831) strcat(s, "l");
if (crc32("eUepWhYkPocpVFf",15) == 4152948208) strcat(s, "e");
if (crc32("ZonjHQdNmFtYCY",14) == 4224172555) strcat(s, "a");
if (crc32("eZyzVPu",7) == 733653260) strcat(s, "H");
if (crc32("GiDsRFvNZr",10) == 1132575648) strcat(s, "t");
if (crc32("grKmN",5) == 301870859) strcat(s, "i");
if (crc32("VRsfmgHKsZT",11) == 244742319) strcat(s, "N");
if (crc32("UBhUbjJrGL",10) == 3405800006) strcat(s, "n");
if (crc32("CcHMJ",5) == 854087801) strcat(s, "k");
if (crc32("RfpHbQmSdseVL",13) == 2437887404) strcat(s, "g");
if (crc32("IgmWnmC",7) == 658974847) strcat(s, "T");
if (crc32("ePvEpXHOwuJ",11) == 594158002) strcat(s, "l");
if (crc32("wpfGniiBIIln",12) == 2493545558) strcat(s, "h");
if (crc32("VpxNXTjVNVr",11) == 3901098666) strcat(s, "y");
    return s;
}

char *chemotactically_adverbs() {
    char *s = calloc(16);
    if (crc32("mgMAXWmhZppsXY",14) == 45912998) strcat(s, "Q");
if (crc32("kULigLlJK",9) == 3643602657) strcat(s, "c");
if (crc32("bhMzPn",6) == 2098548499) strcat(s, "h");
if (crc32("TmJfBzpRZ",9) == 38966629) strcat(s, "I");
if (crc32("zPOYMMUpDFptqI",14) == 1455660417) strcat(s, "e");
if (crc32("uIEXiB",6) == 1564876988) strcat(s, "m");
if (crc32("vZRDwyGZDSWz",12) == 2041721068) strcat(s, "r");
if (crc32("ebbZjDKgihvCEg",14) == 1923484607) strcat(s, "o");
if (crc32("RPyCEMhSh",9) == 3636896325) strcat(s, "V");
if (crc32("XKqAowSUWAVRTH",14) == 2054748384) strcat(s, "t");
if (crc32("nXSxhl",6) == 293523472) strcat(s, "S");
if (crc32("LHsyLOL",7) == 612505518) strcat(s, "a");
if (crc32("GSHxlcEuoQVEVhn",15) == 3330983154) strcat(s, "c");
if (crc32("YgsfepgMhrgBa",13) == 4244469132) strcat(s, "t");
if (crc32("zqavCMVEPm",10) == 1011126480) strcat(s, "B");
if (crc32("yvSPpefsdYUZ",12) == 2055895453) strcat(s, "i");
if (crc32("fkNxA",5) == 2689476544) strcat(s, "c");
if (crc32("stiGD",5) == 2340930082) strcat(s, "C");
if (crc32("ebHqZqXSNcqN",12) == 782505739) strcat(s, "a");
if (crc32("vZfZwlOT",8) == 2289346284) strcat(s, "l");
if (crc32("BdKWKBelMsyfkrf",15) == 3230180445) strcat(s, "U");
if (crc32("AeLiyYQeiDVCUN",14) == 3692338142) strcat(s, "l");
if (crc32("mnAXfJ",6) == 3654061414) strcat(s, "O");
if (crc32("SSnMXAwwezQazxi",15) == 3085342988) strcat(s, "y");
    return s;
}

char *hammeringly_adverbs() {
    char *s = calloc(12);
    if (crc32("HNpgk",5) == 1900537467) strcat(s, "h");
if (crc32("tPxXIyJdPVyajxY",15) == 2299954500) strcat(s, "v");
if (crc32("KpCKDp",6) == 485610764) strcat(s, "a");
if (crc32("dltxEIaSMLxmE",13) == 3215553336) strcat(s, "m");
if (crc32("fYmiKSN",7) == 87749834) strcat(s, "m");
if (crc32("eAJTA",5) == 3907458175) strcat(s, "t");
if (crc32("jAkRSiADmoFhf",13) == 3552655073) strcat(s, "e");
if (crc32("HhNxlbNOLRqFaQU",15) == 682461027) strcat(s, "r");
if (crc32("xBRkrqM",7) == 2161874423) strcat(s, "E");
if (crc32("ZtKWVmbesM",10) == 441425121) strcat(s, "i");
if (crc32("kbkLGvSv",8) == 1979046497) strcat(s, "n");
if (crc32("rThIRICDiDyBY",13) == 3804852191) strcat(s, "g");
if (crc32("sJQdwXfRy",9) == 704168090) strcat(s, "l");
if (crc32("lUUBJ",5) == 1827735132) strcat(s, "w");
if (crc32("USLItS",6) == 2240438410) strcat(s, "y");
    return s;
}

char *shiftily_adverbs() {
    char *s = calloc(9);
    if (crc32("WtCKz",5) == 3405566846) strcat(s, "b");
if (crc32("lWMMrkVlu",9) == 2072289661) strcat(s, "s");
if (crc32("gpAYfr",6) == 2424867032) strcat(s, "h");
if (crc32("nfjvCzdjbkzYsVn",15) == 1099663549) strcat(s, "J");
if (crc32("JebaJCFbQhd",11) == 2748642889) strcat(s, "i");
if (crc32("SfQFF",5) == 4080968312) strcat(s, "f");
if (crc32("EoWGedBZRJko",12) == 1508761794) strcat(s, "M");
if (crc32("FqbZkukUKWo",11) == 1859461648) strcat(s, "t");
if (crc32("cmlZkxW",7) == 3369047331) strcat(s, "a");
if (crc32("AzwtuQfmf",9) == 3512159917) strcat(s, "i");
if (crc32("UnKOkEf",7) == 182238773) strcat(s, "L");
if (crc32("IgOrLrUgYcLVm",13) == 3600226562) strcat(s, "l");
if (crc32("BJCeTojPeyj",11) == 941507809) strcat(s, "y");
    return s;
}

char *unilaterally_adverbs() {
    char *s = calloc(13);
    if (crc32("nvJtkjUVcSehj",13) == 2248250354) strcat(s, "u");
if (crc32("pIwQEgHB",8) == 2284871372) strcat(s, "Q");
if (crc32("ViVSEElVerV",11) == 645965989) strcat(s, "n");
if (crc32("SGtqPwZdOCZ",11) == 3811645670) strcat(s, "i");
if (crc32("EFpQVcHgBGY",11) == 3902101340) strcat(s, "l");
if (crc32("xpEnQGXUA",9) == 2148807331) strcat(s, "x");
if (crc32("HBhxlmjP",8) == 2756544073) strcat(s, "a");
if (crc32("faDeHKaMaYCpB",13) == 1399125805) strcat(s, "y");
if (crc32("ECOOfVVTZWNyMV",14) == 1255219882) strcat(s, "t");
if (crc32("kQRHsvZ",7) == 1796227289) strcat(s, "e");
if (crc32("YFeproHYMCWIRfo",15) == 1862824391) strcat(s, "u");
if (crc32("RxfwKzOSXUGn",12) == 1809934742) strcat(s, "r");
if (crc32("wthqrEnI",8) == 3097259953) strcat(s, "a");
if (crc32("FmDwtUARVYEW",12) == 2435194778) strcat(s, "v");
if (crc32("zhGQsepl",8) == 2875776544) strcat(s, "l");
if (crc32("FpwDhYtDaPkRs",13) == 1031697527) strcat(s, "l");
if (crc32("tXkbPgfCnsmNd",13) == 1615052897) strcat(s, "k");
if (crc32("mNTnIUGIzqXCU",13) == 2628232102) strcat(s, "y");
    return s;
}

char *factually_adverbs() {
    char *s = calloc(10);
    if (crc32("PIxMnClvf",9) == 4245822790) strcat(s, "f");
if (crc32("GXVqilyjaEh",11) == 431387197) strcat(s, "a");
if (crc32("nbaFmdoraKexWq",14) == 1251676810) strcat(s, "c");
if (crc32("vFIWIRj",7) == 2454577122) strcat(s, "t");
if (crc32("fpOrNnwPgGvbSUz",15) == 2106983302) strcat(s, "d");
if (crc32("NXSkG",5) == 789823694) strcat(s, "u");
if (crc32("jGuiwwBbPnLHfHp",15) == 3222591406) strcat(s, "T");
if (crc32("VURkb",5) == 3341777440) strcat(s, "a");
if (crc32("pvISgiaYigX",11) == 3168645532) strcat(s, "l");
if (crc32("heERac",6) == 1603103228) strcat(s, "m");
if (crc32("xZwrv",5) == 1591804541) strcat(s, "l");
if (crc32("wbjuAgrvpLLUo",13) == 1251655844) strcat(s, "A");
if (crc32("KYwIOPHJGLD",11) == 61885804) strcat(s, "y");
    return s;
}

char *ashore_adverbs() {
    char *s = calloc(7);
    if (crc32("KksZrlgB",8) == 1075597801) strcat(s, "D");
if (crc32("smAEKfytpWczesh",15) == 1074834275) strcat(s, "a");
if (crc32("rFtbi",5) == 3406975750) strcat(s, "s");
if (crc32("yOEMWByzMiGhLc",14) == 89952323) strcat(s, "h");
if (crc32("CNfshnPvrwq",11) == 1158797770) strcat(s, "o");
if (crc32("nSSeUpuRsaCH",12) == 3620596768) strcat(s, "c");
if (crc32("xTpZOLLbuFXpx",13) == 2775052780) strcat(s, "r");
if (crc32("fzqtvXtOsqWQq",13) == 3439292891) strcat(s, "x");
if (crc32("eGHFvmhryHbQgG",14) == 1171319087) strcat(s, "e");
    return s;
}

char *nonnutritively_adverbs() {
    char *s = calloc(15);
    if (crc32("PwjcNubsh",9) == 488036074) strcat(s, "S");
if (crc32("BePdTt",6) == 2951525330) strcat(s, "n");
if (crc32("xaTUaIvG",8) == 2944434653) strcat(s, "z");
if (crc32("MRqCBji",7) == 1820811240) strcat(s, "o");
if (crc32("WpuzirLCgUG",11) == 3787547509) strcat(s, "U");
if (crc32("OpESdzte",8) == 3262666032) strcat(s, "n");
if (crc32("YgQfSzFn",8) == 1007547718) strcat(s, "n");
if (crc32("ZgrEeNYg",8) == 4152331490) strcat(s, "u");
if (crc32("sExEU",5) == 2161362388) strcat(s, "e");
if (crc32("QGuBa",5) == 1867687696) strcat(s, "t");
if (crc32("ndIIUgTTiouXOy",14) == 1834886062) strcat(s, "r");
if (crc32("ZusvKOQrti",10) == 3100809760) strcat(s, "F");
if (crc32("ljchrfPNvdi",11) == 309168632) strcat(s, "i");
if (crc32("JOJIO",5) == 1198666745) strcat(s, "A");
if (crc32("BpFhdaHYrp",10) == 2570824130) strcat(s, "t");
if (crc32("BrOGLmXNTWDJa",13) == 2849736705) strcat(s, "i");
if (crc32("YMDsS",5) == 465360160) strcat(s, "v");
if (crc32("YmsGba",6) == 1115394111) strcat(s, "C");
if (crc32("zEjed",5) == 3466580777) strcat(s, "e");
if (crc32("lwiqSQZSYHZSjse",15) == 1821841288) strcat(s, "w");
if (crc32("FOXonnLqsIITp",13) == 161003700) strcat(s, "l");
if (crc32("xOZWQe",6) == 3744190374) strcat(s, "y");
    return s;
}

char *unsuperficially_adverbs() {
    char *s = calloc(16);
    if (crc32("BYNJuoEwalKwN",13) == 2504852372) strcat(s, "u");
if (crc32("mpSGDHxrDrwbZG",14) == 4157868249) strcat(s, "D");
if (crc32("JEkbZLmo",8) == 2598597223) strcat(s, "n");
if (crc32("WNFXxDqBizfFT",13) == 3458024527) strcat(s, "s");
if (crc32("pIoyZnyDe",9) == 706508267) strcat(s, "u");
if (crc32("EevQlqncKwST",12) == 2917444432) strcat(s, "p");
if (crc32("OwdDjrBqqt",10) == 196202368) strcat(s, "i");
if (crc32("HRnXViTCTuer",12) == 3727921818) strcat(s, "e");
if (crc32("buCMWiTcjBVSI",13) == 622106468) strcat(s, "v");
if (crc32("UVvJqjYeyDxXW",13) == 572787850) strcat(s, "r");
if (crc32("EGLQJl",6) == 2864067736) strcat(s, "W");
if (crc32("UUCrySyFqV",10) == 3708120655) strcat(s, "f");
if (crc32("HdYXPfXD",8) == 540097880) strcat(s, "O");
if (crc32("oQXXAbxfVPPA",12) == 3402486338) strcat(s, "i");
if (crc32("JFNSy",5) == 556526710) strcat(s, "W");
if (crc32("AVBrdw",6) == 1796023477) strcat(s, "c");
if (crc32("Ypovcvb",7) == 3850226298) strcat(s, "i");
if (crc32("mfNEzMKDCV",10) == 3868976399) strcat(s, "m");
if (crc32("WsjBHLxYLf",10) == 2820716053) strcat(s, "a");
if (crc32("LkBAO",5) == 3407432124) strcat(s, "l");
if (crc32("szYnz",5) == 3617058473) strcat(s, "d");
if (crc32("QdoTh",5) == 2837482517) strcat(s, "l");
if (crc32("yffnzVkXaOLGAY",14) == 1164261988) strcat(s, "w");
if (crc32("aQjYacNymkVd",12) == 626641931) strcat(s, "y");
    return s;
}

char *undeferrably_adverbs() {
    char *s = calloc(13);
    if (crc32("DSujGNtfxvGN",12) == 606088455) strcat(s, "c");
if (crc32("FpeJmiwnHRUI",12) == 3127529985) strcat(s, "u");
if (crc32("WJNzwQVIjSZOeK",14) == 2889257997) strcat(s, "i");
if (crc32("JPZNjKbBOwot",12) == 649414325) strcat(s, "n");
if (crc32("owpszk",6) == 833257418) strcat(s, "d");
if (crc32("eJjsBfQvCJ",10) == 958511609) strcat(s, "e");
if (crc32("Ogiayr",6) == 722696566) strcat(s, "f");
if (crc32("QYnpRVbSYbWFeT",14) == 2515219882) strcat(s, "v");
if (crc32("QFcdjQt",7) == 445722115) strcat(s, "e");
if (crc32("TFwOzLr",7) == 2698211968) strcat(s, "r");
if (crc32("aUGLi",5) == 2211714240) strcat(s, "r");
if (crc32("zcAqttGKUgPkrZg",15) == 2454357212) strcat(s, "a");
if (crc32("VAhQoAdeUof",11) == 28341974) strcat(s, "b");
if (crc32("weCqnLgOqZ",10) == 3283485333) strcat(s, "l");
if (crc32("YdVsvYqhJ",9) == 1579139456) strcat(s, "V");
if (crc32("KpRxZfxYnKzP",12) == 3588433540) strcat(s, "y");
    return s;
}

char *antioptimistically_adverbs() {
    char *s = calloc(19);
    if (crc32("EREjNDs",7) == 1513601275) strcat(s, "Q");
if (crc32("MSPscpkq",8) == 2870127340) strcat(s, "a");
if (crc32("WLUwRkX",7) == 2300480442) strcat(s, "n");
if (crc32("CpMZUfHbuvFAw",13) == 2826484582) strcat(s, "t");
if (crc32("kVufMXtl",8) == 3787313151) strcat(s, "i");
if (crc32("KsmHKwl",7) == 828498655) strcat(s, "o");
if (crc32("OtMPqfuapt",10) == 3247882283) strcat(s, "u");
if (crc32("bBzHaHHrrelrtL",14) == 474693804) strcat(s, "p");
if (crc32("nAuOy",5) == 3481940352) strcat(s, "t");
if (crc32("CfoFhFykWksk",12) == 881902062) strcat(s, "b");
if (crc32("hOEpwvRTpU",10) == 4089334104) strcat(s, "i");
if (crc32("hrlnJfD",7) == 3690932980) strcat(s, "m");
if (crc32("zdfZCss",7) == 1259424086) strcat(s, "i");
if (crc32("IvfxHOml",8) == 2245757781) strcat(s, "l");
if (crc32("LusXBqUoEJo",11) == 3385780940) strcat(s, "s");
if (crc32("keazcPszV",9) == 867990901) strcat(s, "t");
if (crc32("necNyXrADVqGj",13) == 1216916024) strcat(s, "z");
if (crc32("ebcdNNEsTfxISg",14) == 815286577) strcat(s, "i");
if (crc32("meqvffUeF",9) == 2842113462) strcat(s, "A");
if (crc32("AUBQzPRGAHTHK",13) == 215075965) strcat(s, "c");
if (crc32("gTTgzYxN",8) == 3321270397) strcat(s, "a");
if (crc32("vZwjQfDUZi",10) == 2909391823) strcat(s, "l");
if (crc32("MAdRkWdJB",9) == 2013160975) strcat(s, "l");
if (crc32("VpGTIoMM",8) == 3971399981) strcat(s, "K");
if (crc32("hFmpSUNEGQn",11) == 1782634835) strcat(s, "y");
    return s;
}

char *nonvirginally_adverbs() {
    char *s = calloc(14);
    if (crc32("qgQrLBQToQ",10) == 1310124874) strcat(s, "D");
if (crc32("tSZBB",5) == 679393027) strcat(s, "n");
if (crc32("yDNYLYjvkoP",11) == 3723534075) strcat(s, "o");
if (crc32("CnXtFRWOdDMPG",13) == 2356375112) strcat(s, "V");
if (crc32("TTnAhWlo",8) == 3080540057) strcat(s, "n");
if (crc32("QXheVXutdsvA",12) == 3236359324) strcat(s, "U");
if (crc32("DIKouQbXyB",10) == 3301982413) strcat(s, "v");
if (crc32("GQBLH",5) == 144018310) strcat(s, "i");
if (crc32("RsHmWBjOrxQQRK",14) == 487587733) strcat(s, "r");
if (crc32("OoTXW",5) == 2982511048) strcat(s, "A");
if (crc32("MxCkpmivq",9) == 2286832322) strcat(s, "g");
if (crc32("HTopkySSrvmO",12) == 4080068262) strcat(s, "i");
if (crc32("aOmZdzYzW",9) == 28845998) strcat(s, "f");
if (crc32("zuxPCe",6) == 250793833) strcat(s, "n");
if (crc32("OZzjBwxdSNjca",13) == 3066295294) strcat(s, "a");
if (crc32("FCEUcO",6) == 429804154) strcat(s, "l");
if (crc32("ElZbdbPf",8) == 2094450485) strcat(s, "e");
if (crc32("izYuykGUUjhVYOo",15) == 3024834487) strcat(s, "l");
if (crc32("NqiSyiS",7) == 432093489) strcat(s, "y");
    return s;
}

char *streakily_adverbs() {
    char *s = calloc(10);
    if (crc32("ySQvHPclQSuqo",13) == 2587091348) strcat(s, "F");
if (crc32("PeSOddnTGrDU",12) == 1068656082) strcat(s, "s");
if (crc32("cxyCvJGeOnf",11) == 1594110963) strcat(s, "t");
if (crc32("KKdIDygDz",9) == 2386193180) strcat(s, "G");
if (crc32("OOgKfef",7) == 1177025067) strcat(s, "r");
if (crc32("zGEPpeldYJh",11) == 463048192) strcat(s, "K");
if (crc32("qNuFaxLaR",9) == 3494759694) strcat(s, "e");
if (crc32("tAGNWotxq",9) == 4012000651) strcat(s, "A");
if (crc32("hLbQzVB",7) == 3770248425) strcat(s, "a");
if (crc32("HMAnuVxYaM",10) == 592351184) strcat(s, "j");
if (crc32("Ybylf",5) == 1421334070) strcat(s, "k");
if (crc32("zSwOOCnSAVQLlpT",15) == 4181831001) strcat(s, "i");
if (crc32("HJZxz",5) == 1813355638) strcat(s, "l");
if (crc32("vUIpvJtLdat",11) == 1693950258) strcat(s, "y");
    return s;
}

char *noninterpretatively_adverbs() {
    char *s = calloc(20);
    if (crc32("YHTPJeEttCdhk",13) == 147651005) strcat(s, "q");
if (crc32("hJKUsHrTIB",10) == 2579753900) strcat(s, "n");
if (crc32("RNMIQWPUU",9) == 1760104742) strcat(s, "o");
if (crc32("dPuUOABEibL",11) == 3736249298) strcat(s, "A");
if (crc32("LeaFWCyt",8) == 1528195463) strcat(s, "n");
if (crc32("APIXG",5) == 2368552038) strcat(s, "i");
if (crc32("jnTOKxXRFuFYr",13) == 3963992613) strcat(s, "E");
if (crc32("ZKrGxa",6) == 1514451464) strcat(s, "n");
if (crc32("ZINauaxlCIt",11) == 1851720470) strcat(s, "S");
if (crc32("zFPrHbxTX",9) == 291538828) strcat(s, "t");
if (crc32("NfODriHY",8) == 459060003) strcat(s, "f");
if (crc32("SNYDUygjXr",10) == 3666700757) strcat(s, "e");
if (crc32("UWGEoYFAOeIam",13) == 407615260) strcat(s, "r");
if (crc32("jngxA",5) == 2625761842) strcat(s, "O");
if (crc32("wEZDMcbX",8) == 3296128348) strcat(s, "p");
if (crc32("rUZGliHrdFJc",12) == 945818940) strcat(s, "Q");
if (crc32("uePIHkVdKZfUdQm",15) == 2157365351) strcat(s, "r");
if (crc32("vtiFEaBaYG",10) == 525740545) strcat(s, "p");
if (crc32("ANFiyd",6) == 3747483378) strcat(s, "e");
if (crc32("gyOFSQzXVpvj",12) == 1912055487) strcat(s, "p");
if (crc32("ixvXVjJ",7) == 2100433511) strcat(s, "t");
if (crc32("AwAXcinvDxQ",11) == 1444192019) strcat(s, "a");
if (crc32("RajqOIjJ",8) == 1472967116) strcat(s, "O");
if (crc32("ygYPZnpWeJfYxpA",15) == 2781527460) strcat(s, "t");
if (crc32("dHKcBcug",8) == 1023321140) strcat(s, "y");
if (crc32("sslxcIa",7) == 1854711907) strcat(s, "i");
if (crc32("vRcHIar",7) == 1845891685) strcat(s, "v");
if (crc32("FfYCHpnryvGMj",13) == 3498535510) strcat(s, "e");
if (crc32("AFHgqBCdPLqAq",13) == 4159037046) strcat(s, "l");
if (crc32("AfsLDISeJySx",12) == 1758192088) strcat(s, "h");
if (crc32("pbsCNHNtZwSzj",13) == 2567816802) strcat(s, "y");
    return s;
}

char *nosily_adverbs() {
    char *s = calloc(7);
    if (crc32("MhhNJEEghwn",11) == 1786495614) strcat(s, "n");
if (crc32("pntNLoPGkpNA",12) == 2259249933) strcat(s, "o");
if (crc32("TBDzvRqzJDVnKeU",15) == 2297539082) strcat(s, "L");
if (crc32("MqBvlXF",7) == 3099189367) strcat(s, "s");
if (crc32("eQMxzAYdGL",10) == 718345204) strcat(s, "i");
if (crc32("ixVGifiuxe",10) == 1615151059) strcat(s, "l");
if (crc32("RjVMBxiGKnne",12) == 1003795936) strcat(s, "y");
    return s;
}

char *unamicably_adverbs() {
    char *s = calloc(11);
    if (crc32("qlsFeFMEysHFAV",14) == 3000253841) strcat(s, "u");
if (crc32("TgLobhmFOwpzeR",14) == 772742486) strcat(s, "n");
if (crc32("rpKTupZlifIni",13) == 3168073904) strcat(s, "j");
if (crc32("SQzrKZXFw",9) == 3151383648) strcat(s, "a");
if (crc32("hHrufMndhEZCPqR",15) == 506880482) strcat(s, "M");
if (crc32("hIIglqtagvdxu",13) == 2219012198) strcat(s, "m");
if (crc32("xskWcfROQiOHrr",14) == 623509382) strcat(s, "F");
if (crc32("EhslJhzZbMgCh",13) == 3741693031) strcat(s, "i");
if (crc32("tiBrVuUlKisnA",13) == 96986305) strcat(s, "i");
if (crc32("SwbzJXCAKxKrWL",14) == 2902666994) strcat(s, "c");
if (crc32("CVcgzdt",7) == 1168404311) strcat(s, "a");
if (crc32("xzzPqHwFR",9) == 588019290) strcat(s, "S");
if (crc32("WGavQgKqSqSlEh",14) == 3194306693) strcat(s, "b");
if (crc32("JTfHoW",6) == 2772182586) strcat(s, "l");
if (crc32("LTspark",7) == 3538530978) strcat(s, "y");
    return s;
}

char *singleheartedly_adverbs() {
    char *s = calloc(16);
    if (crc32("rmbaTRqmkA",10) == 3818846700) strcat(s, "r");
if (crc32("kfUXRw",6) == 487819014) strcat(s, "s");
if (crc32("uFJbDgQXgKa",11) == 1694213118) strcat(s, "i");
if (crc32("rXthFWJ",7) == 390810030) strcat(s, "C");
if (crc32("JobGj",5) == 3995606634) strcat(s, "n");
if (crc32("FufvcjkCbsDZR",13) == 3785473342) strcat(s, "g");
if (crc32("MolKTXOrNnnc",12) == 723813822) strcat(s, "l");
if (crc32("eTQTMxN",7) == 2619410857) strcat(s, "e");
if (crc32("EhYTqlwaCKIAFA",14) == 2537495746) strcat(s, "h");
if (crc32("FOXFJCZpUMr",11) == 4248043113) strcat(s, "e");
if (crc32("AEWxgxIpOP",10) == 4104638214) strcat(s, "a");
if (crc32("uUNnmhfbkMRrDC",14) == 919348108) strcat(s, "r");
if (crc32("cRgOyUGA",8) == 2197674844) strcat(s, "t");
if (crc32("IYOqcllqxvy",11) == 2720369712) strcat(s, "e");
if (crc32("yJfnrKVPW",9) == 2483004850) strcat(s, "H");
if (crc32("hPjFGLlvXipAtc",14) == 643915934) strcat(s, "d");
if (crc32("AywgAOL",7) == 3354244953) strcat(s, "l");
if (crc32("YLMOwkFPMGB",11) == 3666353053) strcat(s, "d");
if (crc32("pAaQpoZwTI",10) == 1901110694) strcat(s, "y");
    return s;
}

char *tasselly_adverbs() {
    char *s = calloc(9);
    if (crc32("lkTHTl",6) == 2698450839) strcat(s, "f");
if (crc32("CdWMVBmzQlQzJ",13) == 1856669052) strcat(s, "t");
if (crc32("hbxQZIDCwkMjBxu",15) == 1552921802) strcat(s, "H");
if (crc32("CcJwvVypy",9) == 1813790170) strcat(s, "a");
if (crc32("jirXyfvYgF",10) == 2309347155) strcat(s, "s");
if (crc32("knNDhnRxxQalW",13) == 575723759) strcat(s, "h");
if (crc32("cVbSLqOGjRB",11) == 1965937972) strcat(s, "s");
if (crc32("wXavevqJIZK",11) == 3716504289) strcat(s, "e");
if (crc32("tpiCYcJjC",9) == 1248597059) strcat(s, "a");
if (crc32("zeqrthp",7) == 638599045) strcat(s, "l");
if (crc32("yPHROMSbksrS",12) == 3564895763) strcat(s, "t");
if (crc32("SRYKLxTdXQx",11) == 534775495) strcat(s, "l");
if (crc32("PvotURHXE",9) == 2658312828) strcat(s, "i");
if (crc32("uOifjDZJ",8) == 4279088729) strcat(s, "y");
    return s;
}

char *headforemost_adverbs() {
    char *s = calloc(13);
    if (crc32("kOWTs",5) == 2510256585) strcat(s, "h");
if (crc32("OHzzdRStx",9) == 2302305107) strcat(s, "e");
if (crc32("oDVcT",5) == 41485695) strcat(s, "H");
if (crc32("ZiWCuezWvHHYLox",15) == 3658610912) strcat(s, "a");
if (crc32("RmImOfWz",8) == 464667367) strcat(s, "d");
if (crc32("EWTYke",6) == 4172776406) strcat(s, "f");
if (crc32("XQlPINdeSXWWzQe",15) == 3641712426) strcat(s, "o");
if (crc32("ZMQuBvCi",8) == 1019774252) strcat(s, "E");
if (crc32("rvdKHvPlAw",10) == 3094884893) strcat(s, "r");
if (crc32("uUwKVgap",8) == 3374903935) strcat(s, "u");
if (crc32("xGOAtCgjqkKt",12) == 1221989939) strcat(s, "e");
if (crc32("AysGd",5) == 171578425) strcat(s, "A");
if (crc32("xdTLQIR",7) == 75432675) strcat(s, "m");
if (crc32("NkMZTJql",8) == 550002294) strcat(s, "B");
if (crc32("fqtOuzbirOkwv",13) == 1447960423) strcat(s, "o");
if (crc32("BvgJPc",6) == 809285041) strcat(s, "s");
if (crc32("jotaZTiClnvXIKS",15) == 2617710047) strcat(s, "D");
if (crc32("lliCo",5) == 2857350474) strcat(s, "t");
    return s;
}

char *supremely_adverbs() {
    char *s = calloc(10);
    if (crc32("UNYgOaSQRXZwm",13) == 4293528635) strcat(s, "H");
if (crc32("XvlpH",5) == 2531266119) strcat(s, "s");
if (crc32("JlZjuDzl",8) == 1431874077) strcat(s, "u");
if (crc32("lbacSa",6) == 3361280606) strcat(s, "X");
if (crc32("SzgYdnFKCRNCSl",14) == 2810848458) strcat(s, "p");
if (crc32("SDvrrRWUJffFr",13) == 1197582852) strcat(s, "r");
if (crc32("HnzEPrNsbDjwL",13) == 3857882154) strcat(s, "e");
if (crc32("oQGPrI",6) == 4100114431) strcat(s, "Y");
if (crc32("iaqqRet",7) == 1996608552) strcat(s, "m");
if (crc32("uSJFK",5) == 1109004429) strcat(s, "D");
if (crc32("ZZlaWacjYTHvktT",15) == 3287312751) strcat(s, "e");
if (crc32("VBDegRX",7) == 2664917657) strcat(s, "l");
if (crc32("vWpKSHE",7) == 2211233683) strcat(s, "S");
if (crc32("dGyWYoMf",8) == 45698077) strcat(s, "y");
    return s;
}

char *afterward_adverbs() {
    char *s = calloc(10);
    if (crc32("mXFkxrmUWsACI",13) == 133118621) strcat(s, "y");
if (crc32("lIWVrOlX",8) == 2200242068) strcat(s, "a");
if (crc32("shtstaIF",8) == 3257473125) strcat(s, "f");
if (crc32("kDBATTq",7) == 334488828) strcat(s, "t");
if (crc32("zHmDpIQB",8) == 42359290) strcat(s, "U");
if (crc32("QoBHLFNbnkb",11) == 3019728322) strcat(s, "e");
if (crc32("iUbfoc",6) == 1324868261) strcat(s, "w");
if (crc32("nIjkRdxcoYgjFid",15) == 3034413328) strcat(s, "r");
if (crc32("yBweMldlHPz",11) == 1260671332) strcat(s, "w");
if (crc32("wMoGpMWQEO",10) == 2871914179) strcat(s, "a");
if (crc32("LdYrNk",6) == 133676960) strcat(s, "q");
if (crc32("YJcGKY",6) == 3581674562) strcat(s, "r");
if (crc32("lnxfDIb",7) == 3254732080) strcat(s, "d");
    return s;
}

char *unresolutely_adverbs() {
    char *s = calloc(13);
    if (crc32("oAYwHKSmOuSU",12) == 1346672797) strcat(s, "G");
if (crc32("YRUgTkaOHgrCjMD",15) == 3799470175) strcat(s, "u");
if (crc32("hpYfGhGnXTyac",13) == 17325968) strcat(s, "e");
if (crc32("QuopYcBGW",9) == 888495822) strcat(s, "n");
if (crc32("TrUMarPLyBq",11) == 3885393357) strcat(s, "r");
if (crc32("oQTcYgKPq",9) == 3609265420) strcat(s, "e");
if (crc32("QyvkEHnsSgYyAq",14) == 1275732361) strcat(s, "k");
if (crc32("qJpQdtL",7) == 2285139798) strcat(s, "s");
if (crc32("WgZeAR",6) == 233871904) strcat(s, "o");
if (crc32("lytmJfsShUlfT",13) == 157485101) strcat(s, "l");
if (crc32("pnopoZV",7) == 1180097921) strcat(s, "t");
if (crc32("bQFYD",5) == 951986449) strcat(s, "u");
if (crc32("UCAPOqxQJVAJW",13) == 4187909112) strcat(s, "t");
if (crc32("umBaU",5) == 715460943) strcat(s, "e");
if (crc32("yMETCPNHYrzwQn",14) == 2582296499) strcat(s, "F");
if (crc32("DkgFyz",6) == 1461898192) strcat(s, "l");
if (crc32("qNTUcLaPXuiUl",13) == 2361516491) strcat(s, "y");
    return s;
}

char *nonspecifically_adverbs() {
    char *s = calloc(16);
    if (crc32("iHFAISrSoROx",12) == 2714345497) strcat(s, "D");
if (crc32("KHLFTTonn",9) == 2166346181) strcat(s, "n");
if (crc32("xHyeSRLucrji",12) == 1191562967) strcat(s, "Q");
if (crc32("ABvXnoKrftiLBd",14) == 4293122169) strcat(s, "o");
if (crc32("XtOlS",5) == 1496763423) strcat(s, "D");
if (crc32("zoWfmXoOBzuegnL",15) == 282087610) strcat(s, "n");
if (crc32("tBYlOtAzZmUg",12) == 1209162956) strcat(s, "v");
if (crc32("VqxnOAMgyCbH",12) == 657599361) strcat(s, "s");
if (crc32("srSixvuZpcW",11) == 344368679) strcat(s, "x");
if (crc32("swNaVFnOQOzUXas",15) == 1059562768) strcat(s, "p");
if (crc32("VrXWkauUoBvsSLx",15) == 3714577090) strcat(s, "e");
if (crc32("gQNInC",6) == 2976626552) strcat(s, "c");
if (crc32("TBFuCttXpsv",11) == 2125068979) strcat(s, "i");
if (crc32("kwzqJM",6) == 3410606808) strcat(s, "f");
if (crc32("JjljsQI",7) == 641079158) strcat(s, "i");
if (crc32("iUVvGWgg",8) == 2851348076) strcat(s, "l");
if (crc32("CIRCyXjFPbzPTsj",15) == 415499207) strcat(s, "c");
if (crc32("yaGhLyfVM",9) == 2535916595) strcat(s, "G");
if (crc32("CYRdUeZ",7) == 3436895753) strcat(s, "a");
if (crc32("OSIDO",5) == 3355768966) strcat(s, "l");
if (crc32("GmsRKf",6) == 3791230226) strcat(s, "w");
if (crc32("xzTglclQAWs",11) == 2604010463) strcat(s, "l");
if (crc32("HtBoIGhZeF",10) == 407174921) strcat(s, "r");
if (crc32("RkzxOqmDjUd",11) == 3083865124) strcat(s, "y");
    return s;
}

char *nonequatorially_adverbs() {
    char *s = calloc(16);
    if (crc32("EfidsRQZcSZuS",13) == 2879252502) strcat(s, "n");
if (crc32("fCqob",5) == 1293678424) strcat(s, "o");
if (crc32("LCrvxhxOpXl",11) == 626038594) strcat(s, "n");
if (crc32("NXJBsgNJLC",10) == 3535922551) strcat(s, "e");
if (crc32("TtnXoYHdoyTktor",15) == 648043054) strcat(s, "q");
if (crc32("tGUKulgyVZXyae",14) == 101574344) strcat(s, "u");
if (crc32("ESpBqvapRJ",10) == 198662389) strcat(s, "X");
if (crc32("kFDzFFvX",8) == 1047421686) strcat(s, "a");
if (crc32("KfuLdfDGb",9) == 1936232491) strcat(s, "t");
if (crc32("RyHIiVuR",8) == 1141595123) strcat(s, "o");
if (crc32("BpPyvoMuHDtyf",13) == 91032287) strcat(s, "r");
if (crc32("XhCFKBWuqtxU",12) == 2723899962) strcat(s, "g");
if (crc32("NOjvDILRHSAc",12) == 3922027986) strcat(s, "i");
if (crc32("JFcqt",5) == 3125257356) strcat(s, "j");
if (crc32("vwBfzNGkEceofW",14) == 900105675) strcat(s, "a");
if (crc32("IGtYw",5) == 1675784111) strcat(s, "l");
if (crc32("kkHIzoYvquGGI",13) == 3949241407) strcat(s, "l");
if (crc32("hXSYKUy",7) == 2659492093) strcat(s, "y");
    return s;
}

char *anesthetically_adverbs() {
    char *s = calloc(15);
    if (crc32("NaFWsLrTqNDM",12) == 1594727234) strcat(s, "f");
if (crc32("eKzjMP",6) == 2846242976) strcat(s, "a");
if (crc32("rMidAQCGzWi",11) == 270096807) strcat(s, "y");
if (crc32("SdZSFKXTB",9) == 1271185101) strcat(s, "n");
if (crc32("FUXuYyBWcnaQT",13) == 587714723) strcat(s, "P");
if (crc32("VLiPgsPEisgH",12) == 4067441407) strcat(s, "e");
if (crc32("vKiXOcoNJKpNE",13) == 2697364650) strcat(s, "s");
if (crc32("qPxQTMNoc",9) == 672786650) strcat(s, "V");
if (crc32("fPNvC",5) == 4159247554) strcat(s, "t");
if (crc32("rVOuw",5) == 1076584801) strcat(s, "q");
if (crc32("uhtSvFTz",8) == 2190456467) strcat(s, "h");
if (crc32("pRJUG",5) == 210609615) strcat(s, "e");
if (crc32("rBPJsxioUrse",12) == 2491759750) strcat(s, "t");
if (crc32("ikOnFyBwipVGw",13) == 267099620) strcat(s, "h");
if (crc32("mGiZsaKNZAh",11) == 963101356) strcat(s, "i");
if (crc32("cQCwYZD",7) == 1540607360) strcat(s, "c");
if (crc32("dGBZKeOzpJtlsqs",15) == 1492300135) strcat(s, "a");
if (crc32("WkYDWh",6) == 967743613) strcat(s, "l");
if (crc32("DmPtXh",6) == 3981945661) strcat(s, "l");
if (crc32("FqIUhXDPsL",10) == 1069488312) strcat(s, "y");
    return s;
}

char *underminingly_adverbs() {
    char *s = calloc(14);
    if (crc32("YHFeihKQgyt",11) == 2458709738) strcat(s, "u");
if (crc32("lrxzLuOPG",9) == 791864932) strcat(s, "n");
if (crc32("kJexxzF",7) == 1227673023) strcat(s, "l");
if (crc32("otBrEYczLeg",11) == 476453541) strcat(s, "d");
if (crc32("WOyXDxgLMUL",11) == 3799093436) strcat(s, "e");
if (crc32("mNnBpWd",7) == 1589436505) strcat(s, "M");
if (crc32("fJzNTbDkj",9) == 203857769) strcat(s, "r");
if (crc32("YykCQyxW",8) == 295924685) strcat(s, "m");
if (crc32("hWlQB",5) == 646010915) strcat(s, "D");
if (crc32("SRWaVGW",7) == 3854059906) strcat(s, "i");
if (crc32("mQkxicrldadgtVA",15) == 2551391259) strcat(s, "n");
if (crc32("IqAGsPNklOb",11) == 2059571457) strcat(s, "i");
if (crc32("zfmJFlglHhRpaoa",15) == 807331351) strcat(s, "n");
if (crc32("oQpNxFRSgWKhYZS",15) == 402633379) strcat(s, "g");
if (crc32("hUVYVKyp",8) == 1464501417) strcat(s, "n");
if (crc32("PyDoMk",6) == 2177163525) strcat(s, "l");
if (crc32("eLFqnZePWKOxwec",15) == 3937221252) strcat(s, "y");
    return s;
}

char *mourningly_adverbs() {
    char *s = calloc(11);
    if (crc32("xUdosLwLCtJ",11) == 1982160384) strcat(s, "u");
if (crc32("OacufXQpw",9) == 2386152985) strcat(s, "m");
if (crc32("FlbdXPwLfC",10) == 2037474886) strcat(s, "p");
if (crc32("BUaJNluQq",9) == 3355608385) strcat(s, "o");
if (crc32("gcenNqcaLqayn",13) == 2443949215) strcat(s, "u");
if (crc32("KchPBtednIY",11) == 3070905691) strcat(s, "N");
if (crc32("ucEzx",5) == 601679638) strcat(s, "r");
if (crc32("MeRbPDpj",8) == 3550988962) strcat(s, "F");
if (crc32("sPXoYMS",7) == 4087110233) strcat(s, "n");
if (crc32("VqxlGEJFaQhNj",13) == 1528705552) strcat(s, "S");
if (crc32("QMZtnow",7) == 1404809651) strcat(s, "i");
if (crc32("StQYx",5) == 85274201) strcat(s, "n");
if (crc32("FYbAw",5) == 3418660681) strcat(s, "g");
if (crc32("oxSLeYMMoaJ",11) == 2050018934) strcat(s, "j");
if (crc32("VvwpwspEGtnWOe",14) == 997705793) strcat(s, "l");
if (crc32("vjrgxUOOE",9) == 1655581766) strcat(s, "M");
if (crc32("uuMjdi",6) == 3269389095) strcat(s, "y");
    return s;
}

char *unconservatively_adverbs() {
    char *s = calloc(17);
    if (crc32("OIHfKwLCbgffihu",15) == 860672352) strcat(s, "u");
if (crc32("EljqJHSec",9) == 1833938257) strcat(s, "j");
if (crc32("HbyIoSMLyC",10) == 4181267028) strcat(s, "n");
if (crc32("KICbwBZWy",9) == 2065994755) strcat(s, "c");
if (crc32("WcSoYZRPEJgnLB",14) == 1398205820) strcat(s, "o");
if (crc32("gVJuLbwC",8) == 1101100683) strcat(s, "W");
if (crc32("BqgZmXvTP",9) == 524860972) strcat(s, "n");
if (crc32("HJulZjbSaSdBz",13) == 114243964) strcat(s, "s");
if (crc32("BcDlyfVzTQkXBya",15) == 930458000) strcat(s, "e");
if (crc32("QkNDAArPpKcs",12) == 3831519197) strcat(s, "I");
if (crc32("PbAkAzdyQ",9) == 1250198122) strcat(s, "r");
if (crc32("ElmdEJR",7) == 3626844501) strcat(s, "v");
if (crc32("fyiVawk",7) == 1867742754) strcat(s, "o");
if (crc32("phWsHur",7) == 4107329296) strcat(s, "a");
if (crc32("eCpxRpiOrEHTYbZ",15) == 395960405) strcat(s, "O");
if (crc32("xGdXDXGPHbtzlz",14) == 3143009358) strcat(s, "t");
if (crc32("TIeJXCnPVMdZTN",14) == 437393110) strcat(s, "i");
if (crc32("fdaBgiQ",7) == 2532002191) strcat(s, "v");
if (crc32("SsFCJ",5) == 586363621) strcat(s, "J");
if (crc32("zjwfftT",7) == 1118533290) strcat(s, "e");
if (crc32("fobWpqgf",8) == 1899392037) strcat(s, "l");
if (crc32("ZzPXwBp",7) == 2913056266) strcat(s, "L");
if (crc32("JGOUldpsj",9) == 1978661420) strcat(s, "y");
    return s;
}

char *superornamentally_adverbs() {
    char *s = calloc(18);
    if (crc32("ooTkvuCAvNcwVD",14) == 467195740) strcat(s, "n");
if (crc32("dBbGhIJh",8) == 2245924918) strcat(s, "s");
if (crc32("hvPzwnd",7) == 616571310) strcat(s, "u");
if (crc32("PmUrxEvVZYMti",13) == 4159076278) strcat(s, "p");
if (crc32("OnRGB",5) == 2410330901) strcat(s, "e");
if (crc32("zUJQHzvl",8) == 727667166) strcat(s, "m");
if (crc32("qPiAexRH",8) == 3405070358) strcat(s, "r");
if (crc32("EvMKGvrzLWxId",13) == 305291100) strcat(s, "j");
if (crc32("VojoshGQCKALrrW",15) == 1380108851) strcat(s, "o");
if (crc32("PfrIANVFWgLpdz",14) == 3766725527) strcat(s, "r");
if (crc32("tDuZyM",6) == 1196954791) strcat(s, "n");
if (crc32("kEAvyisnMh",10) == 2977271444) strcat(s, "a");
if (crc32("hdxgil",6) == 4181373876) strcat(s, "B");
if (crc32("FtgGbQzPT",9) == 542101539) strcat(s, "m");
if (crc32("PGpJWpeSNP",10) == 596395888) strcat(s, "e");
if (crc32("MpwjGWKVoU",10) == 3021003443) strcat(s, "n");
if (crc32("isTZP",5) == 1795198741) strcat(s, "t");
if (crc32("EAXwyP",6) == 3275633886) strcat(s, "R");
if (crc32("JzAPDBHpLrHJr",13) == 3928526593) strcat(s, "a");
if (crc32("aDQcJxHWXx",10) == 3101653027) strcat(s, "b");
if (crc32("TYBkP",5) == 600335368) strcat(s, "l");
if (crc32("ujKyfGtKVVccC",13) == 2907450204) strcat(s, "U");
if (crc32("EZrViVUpofXj",12) == 1624964925) strcat(s, "l");
if (crc32("RQrfhjQrR",9) == 2393958275) strcat(s, "y");
    return s;
}

char *digressively_adverbs() {
    char *s = calloc(13);
    if (crc32("BznORvd",7) == 3497961924) strcat(s, "J");
if (crc32("nSVphJIkVYgb",12) == 1049150226) strcat(s, "d");
if (crc32("GLUJMlzmjEzbeyz",15) == 2313132636) strcat(s, "i");
if (crc32("jNzUujULdt",10) == 614796350) strcat(s, "g");
if (crc32("xggaHMIW",8) == 393418850) strcat(s, "r");
if (crc32("dvNJtvmf",8) == 4066725097) strcat(s, "n");
if (crc32("wdHHWlpfmtYIpns",15) == 3173631259) strcat(s, "e");
if (crc32("lNfTPhMGej",10) == 2329147942) strcat(s, "H");
if (crc32("kicNSyIzPP",10) == 1617889028) strcat(s, "s");
if (crc32("EdPlZKOE",8) == 2193785503) strcat(s, "s");
if (crc32("vrwCarbZtGX",11) == 2397207055) strcat(s, "Z");
if (crc32("NGNfB",5) == 4132650470) strcat(s, "i");
if (crc32("XgEkXLxyE",9) == 3380328247) strcat(s, "C");
if (crc32("HwGXURUOdexXhP",14) == 2258282077) strcat(s, "v");
if (crc32("AffKNqlasVI",11) == 1165109988) strcat(s, "e");
if (crc32("sDxMn",5) == 3642353303) strcat(s, "l");
if (crc32("nfoFcgEkE",9) == 1235010782) strcat(s, "P");
if (crc32("uXUZltdR",8) == 431275823) strcat(s, "y");
    return s;
}

char *fatly_adverbs() {
    char *s = calloc(6);
    if (crc32("sGvcNjr",7) == 1454199145) strcat(s, "f");
if (crc32("fMaLekRcC",9) == 3377008512) strcat(s, "I");
if (crc32("CxbhKlZAxTV",11) == 3726920363) strcat(s, "a");
if (crc32("GyKcb",5) == 3829054878) strcat(s, "V");
if (crc32("SgInXTqZbc",10) == 2020008423) strcat(s, "t");
if (crc32("lFnZcLVYsUOJ",12) == 2150378761) strcat(s, "l");
if (crc32("kxqlhChfbhF",11) == 2440297669) strcat(s, "u");
if (crc32("eemdCAuf",8) == 4062152199) strcat(s, "y");
    return s;
}

char *snatchily_adverbs() {
    char *s = calloc(10);
    if (crc32("FAftfnNx",8) == 3597866486) strcat(s, "s");
if (crc32("MyElbdRuKZRPy",13) == 714321181) strcat(s, "T");
if (crc32("LiYLZCPDEXRlj",13) == 2013410728) strcat(s, "n");
if (crc32("ueUVlrRHfquAQy",14) == 1355677757) strcat(s, "a");
if (crc32("otPJgn",6) == 3938418523) strcat(s, "L");
if (crc32("RLLSEwzWD",9) == 1995973416) strcat(s, "t");
if (crc32("kFjTJBPE",8) == 2420010828) strcat(s, "c");
if (crc32("SEwPRwZFxxHecM",14) == 2966622128) strcat(s, "h");
if (crc32("eYYGeKokXLo",11) == 1519784054) strcat(s, "i");
if (crc32("vnEGNmZ",7) == 2534665778) strcat(s, "l");
if (crc32("GzOnsQFFxYQeZzp",15) == 1068808818) strcat(s, "W");
if (crc32("zOCKUoB",7) == 1761390216) strcat(s, "y");
    return s;
}

char *eschatologically_adverbs() {
    char *s = calloc(17);
    if (crc32("QCabuaG",7) == 1645936804) strcat(s, "e");
if (crc32("mFbvRUiPtSWGyjg",15) == 2791372713) strcat(s, "s");
if (crc32("DbCGeZCCCKbGd",13) == 4107730549) strcat(s, "n");
if (crc32("wUshnlaVOq",10) == 2150122045) strcat(s, "c");
if (crc32("wfxvghRaj",9) == 2346755133) strcat(s, "k");
if (crc32("rJPJqmRdiljyZL",14) == 3390426846) strcat(s, "h");
if (crc32("shNZrRSEEgOkC",13) == 2887413619) strcat(s, "a");
if (crc32("CWPToHhugMkk",12) == 4003394951) strcat(s, "Q");
if (crc32("neUNQMjRWQn",11) == 3196214283) strcat(s, "t");
if (crc32("sZugMwuCL",9) == 2988560812) strcat(s, "v");
if (crc32("eOBvXmozzjEU",12) == 1724763422) strcat(s, "o");
if (crc32("Lgkyodk",7) == 1805241525) strcat(s, "l");
if (crc32("sjAop",5) == 4025719750) strcat(s, "o");
if (crc32("rkgfPqjduddrg",13) == 1945069658) strcat(s, "N");
if (crc32("fJaJdmkR",8) == 3037821670) strcat(s, "g");
if (crc32("LlmkvOKMko",10) == 3082801726) strcat(s, "t");
if (crc32("UgOZmQCEQTwf",12) == 622314088) strcat(s, "i");
if (crc32("VbhDryPDJBGUMKi",15) == 3914047014) strcat(s, "c");
if (crc32("LQAHwELNmEsxpU",14) == 1881133663) strcat(s, "a");
if (crc32("bRgTuhBwRXU",11) == 1234891836) strcat(s, "u");
if (crc32("yPadG",5) == 1506910598) strcat(s, "l");
if (crc32("oxICEsi",7) == 2426229518) strcat(s, "o");
if (crc32("HOWLeKQvn",9) == 1321240951) strcat(s, "l");
if (crc32("MlrIJkT",7) == 898273129) strcat(s, "y");
    return s;
}

char *nights_adverbs() {
    char *s = calloc(7);
    if (crc32("IUJqPaCxtt",10) == 780088386) strcat(s, "j");
if (crc32("xgfFLYz",7) == 1564406087) strcat(s, "n");
if (crc32("aVPPeEkLOtlr",12) == 700553962) strcat(s, "K");
if (crc32("yBfLqtLlc",9) == 97618209) strcat(s, "i");
if (crc32("VycdRSgfbKt",11) == 3290867225) strcat(s, "g");
if (crc32("HWQiFHfAFUso",12) == 1335545287) strcat(s, "j");
if (crc32("OrvrIjBZWyCuUWw",15) == 394411473) strcat(s, "h");
if (crc32("GVQtyYQRtndfL",13) == 478065686) strcat(s, "r");
if (crc32("NUeDJwSw",8) == 661816642) strcat(s, "t");
if (crc32("IEOymISy",8) == 755802190) strcat(s, "c");
if (crc32("TDOYOEPZrCzirDN",15) == 1860760165) strcat(s, "s");
    return s;
}

char *slambang_adverbs() {
    char *s = calloc(9);
    if (crc32("gXRihrbpgwIul",13) == 3785047426) strcat(s, "s");
if (crc32("VPLEkcPGudjULOR",15) == 2835602549) strcat(s, "O");
if (crc32("cQDnPFhNDeEmifU",15) == 1828173196) strcat(s, "l");
if (crc32("WQCWpFJURu",10) == 1990654986) strcat(s, "a");
if (crc32("CDWTnj",6) == 4262156528) strcat(s, "m");
if (crc32("yeJHLnSX",8) == 2602362924) strcat(s, "T");
if (crc32("wsVCdls",7) == 1216210141) strcat(s, "b");
if (crc32("FupKuQWNoVei",12) == 4171420797) strcat(s, "p");
if (crc32("wXlmnhhRNL",10) == 1211536780) strcat(s, "a");
if (crc32("moYgj",5) == 544457645) strcat(s, "n");
if (crc32("JduSvC",6) == 3608696633) strcat(s, "g");
    return s;
}

char *animally_adverbs() {
    char *s = calloc(9);
    if (crc32("WJBDsaAUTS",10) == 3809685649) strcat(s, "E");
if (crc32("eTWLJjBn",8) == 2140644962) strcat(s, "a");
if (crc32("OdGZE",5) == 3968291633) strcat(s, "P");
if (crc32("bzVcI",5) == 145948826) strcat(s, "n");
if (crc32("SOBFfGQDWjm",11) == 3558898408) strcat(s, "i");
if (crc32("KOmRVl",6) == 7312949) strcat(s, "m");
if (crc32("YqffOUnkML",10) == 344629889) strcat(s, "a");
if (crc32("rNTglKkxK",9) == 2493372211) strcat(s, "l");
if (crc32("UVQJtxqZQ",9) == 3771033648) strcat(s, "A");
if (crc32("peeoOcimQJ",10) == 4124453523) strcat(s, "l");
if (crc32("YbsblUgPGx",10) == 1317464373) strcat(s, "y");
    return s;
}

char *warmheartedly_adverbs() {
    char *s = calloc(14);
    if (crc32("FZaGrpHkhq",10) == 629376952) strcat(s, "w");
if (crc32("awIzIPOoUztHO",13) == 3574708319) strcat(s, "a");
if (crc32("jHiUBAs",7) == 1780525332) strcat(s, "r");
if (crc32("ctFxc",5) == 2416317714) strcat(s, "O");
if (crc32("YPAtbwUpr",9) == 4048034026) strcat(s, "m");
if (crc32("VCPTykpisClGd",13) == 3092010217) strcat(s, "h");
if (crc32("lfHOQjmMhEEViUE",15) == 2130351121) strcat(s, "e");
if (crc32("OSSvpiv",7) == 3447359067) strcat(s, "a");
if (crc32("TfHVad",6) == 1248768959) strcat(s, "h");
if (crc32("MENOg",5) == 347653137) strcat(s, "r");
if (crc32("eyPcLhKw",8) == 2796000003) strcat(s, "G");
if (crc32("xaNNiPMEm",9) == 154473174) strcat(s, "t");
if (crc32("lxsjEIdquuMcygv",15) == 3422933900) strcat(s, "e");
if (crc32("cupUzselpLww",12) == 1034656602) strcat(s, "d");
if (crc32("WfxcwqgpOcPije",14) == 491615751) strcat(s, "l");
if (crc32("jwGpeJ",6) == 2940655031) strcat(s, "W");
if (crc32("dEatlnmwR",9) == 430349807) strcat(s, "y");
    return s;
}

char *overvigorously_adverbs() {
    char *s = calloc(15);
    if (crc32("HUIbYgZl",8) == 2106117330) strcat(s, "I");
if (crc32("vjPEuRgvJfVj",12) == 3844398207) strcat(s, "o");
if (crc32("GEsXcFOb",8) == 2748174805) strcat(s, "S");
if (crc32("aMJNyUzevq",10) == 2520578354) strcat(s, "v");
if (crc32("ZUTRh",5) == 4107094956) strcat(s, "u");
if (crc32("OeOuzcaZvAGn",12) == 3521074108) strcat(s, "e");
if (crc32("dIgGUpvDnbB",11) == 1728348610) strcat(s, "r");
if (crc32("pkxreUdbEBriWfJ",15) == 2328984336) strcat(s, "v");
if (crc32("NZKHvTF",7) == 1487003561) strcat(s, "t");
if (crc32("igcYzWXCSWxdnrI",15) == 531175420) strcat(s, "i");
if (crc32("RpRKJxHHEzhNZe",14) == 3513095611) strcat(s, "B");
if (crc32("kPOqSDsVzVyl",12) == 1434469771) strcat(s, "g");
if (crc32("zijfBq",6) == 3421024053) strcat(s, "J");
if (crc32("MEIVYDlQqTFwG",13) == 3237280721) strcat(s, "o");
if (crc32("vqyTjEcw",8) == 1954417889) strcat(s, "b");
if (crc32("XlewxIitoEpdWh",14) == 2376541974) strcat(s, "r");
if (crc32("UovgENvZhU",10) == 978316406) strcat(s, "o");
if (crc32("DGtLAzv",7) == 4278958024) strcat(s, "u");
if (crc32("KCQYSdoCGPCG",12) == 2752240277) strcat(s, "Y");
if (crc32("ScWtuQTlzuLI",12) == 2688159590) strcat(s, "s");
if (crc32("fTTcjNqiQCw",11) == 4068526360) strcat(s, "l");
if (crc32("peooZIjJktrKu",13) == 3690918521) strcat(s, "i");
if (crc32("oHUfRRKAOCxzgxC",15) == 4152943672) strcat(s, "y");
    return s;
}

char *antinationally_adverbs() {
    char *s = calloc(15);
    if (crc32("cVNfoWfO",8) == 1982519774) strcat(s, "V");
if (crc32("MsviLZtczvDd",12) == 2228018920) strcat(s, "a");
if (crc32("oXPZRco",7) == 1611265942) strcat(s, "n");
if (crc32("hVMfVb",6) == 430933995) strcat(s, "J");
if (crc32("EEAnjBiIGlsJUtS",15) == 3287067098) strcat(s, "t");
if (crc32("OiKbSPrgSuo",11) == 3537903073) strcat(s, "Y");
if (crc32("iVQAWFm",7) == 2208115154) strcat(s, "i");
if (crc32("sdoPSKFCXI",10) == 3248346356) strcat(s, "n");
if (crc32("OsymPhT",7) == 847860243) strcat(s, "a");
if (crc32("qktsiURItdVN",12) == 4255771724) strcat(s, "t");
if (crc32("VdRiArxfOmFtmDz",15) == 1096211057) strcat(s, "y");
if (crc32("gLJolKntpROvyp",14) == 951847140) strcat(s, "i");
if (crc32("fOkTacRDmNjCNT",14) == 2427867906) strcat(s, "v");
if (crc32("AdKwhbPLYmC",11) == 373310200) strcat(s, "o");
if (crc32("GolVuTSGzaY",11) == 4195243086) strcat(s, "n");
if (crc32("HYMSdEwci",9) == 2375341427) strcat(s, "a");
if (crc32("RTfghqfvc",9) == 219374634) strcat(s, "l");
if (crc32("MTWmwtzGfiSW",12) == 680554986) strcat(s, "l");
if (crc32("WFOEGCpkgwe",11) == 1887540473) strcat(s, "r");
if (crc32("ThLtEYjQx",9) == 1200202748) strcat(s, "y");
    return s;
}

char *haggishly_adverbs() {
    char *s = calloc(10);
    if (crc32("fPpQVZ",6) == 912401420) strcat(s, "h");
if (crc32("mmKGNiSNSc",10) == 2278574503) strcat(s, "V");
if (crc32("sDYCLQmzwmh",11) == 19441129) strcat(s, "a");
if (crc32("jmTBuKNWevqK",12) == 3382155770) strcat(s, "a");
if (crc32("rOeScP",6) == 1781677241) strcat(s, "g");
if (crc32("UdBDdugYj",9) == 1994760225) strcat(s, "g");
if (crc32("cALlVt",6) == 1111901950) strcat(s, "X");
if (crc32("HbPQXIWWkOjeonA",15) == 3920587689) strcat(s, "i");
if (crc32("RXKzrsDCnL",10) == 2972192007) strcat(s, "s");
if (crc32("HIBPRpZrprrgIjO",15) == 713909301) strcat(s, "U");
if (crc32("bDDZrOWv",8) == 1471024037) strcat(s, "h");
if (crc32("YxKEXpY",7) == 278843983) strcat(s, "l");
if (crc32("yghzxOWgNgL",11) == 627164914) strcat(s, "y");
    return s;
}

char *nobbut_adverbs() {
    char *s = calloc(7);
    if (crc32("wrKKpvi",7) == 2290435241) strcat(s, "n");
if (crc32("vhIZRdgR",8) == 1823711327) strcat(s, "o");
if (crc32("rfLxni",6) == 2775240252) strcat(s, "b");
if (crc32("LMHdEcNL",8) == 1186920376) strcat(s, "b");
if (crc32("uFguUpbr",8) == 3755110088) strcat(s, "z");
if (crc32("QsBsCbhpYIS",11) == 1600425209) strcat(s, "u");
if (crc32("nbgEUraHN",9) == 553001163) strcat(s, "t");
    return s;
}

char *Hellenistically_adverbs() {
    char *s = calloc(16);
    if (crc32("sgORR",5) == 632692362) strcat(s, "P");
if (crc32("ahgDLvjXA",9) == 2439619314) strcat(s, "H");
if (crc32("YnaahPL",7) == 3171031516) strcat(s, "e");
if (crc32("rFCisvsUgkE",11) == 4188746328) strcat(s, "l");
if (crc32("MMRWmAFE",8) == 563229566) strcat(s, "l");
if (crc32("LthFJAP",7) == 973639125) strcat(s, "C");
if (crc32("FvFuVMdjVYYz",12) == 995904148) strcat(s, "e");
if (crc32("PPzVqDptsVlbN",13) == 1939918445) strcat(s, "n");
if (crc32("fnyVjZylfJdTL",13) == 1454445600) strcat(s, "i");
if (crc32("eIRPIJQfSu",10) == 648364079) strcat(s, "s");
if (crc32("ZqiYVv",6) == 1171756921) strcat(s, "d");
if (crc32("EmmIVcgrZpvj",12) == 2244613880) strcat(s, "t");
if (crc32("lBQvbjzFnf",10) == 2005222195) strcat(s, "i");
if (crc32("fdMZlvRl",8) == 541040263) strcat(s, "c");
if (crc32("awbxZTQwOTX",11) == 3236449503) strcat(s, "a");
if (crc32("cPJQyhYvGYW",11) == 3291893350) strcat(s, "l");
if (crc32("HVgdTKQI",8) == 840719142) strcat(s, "l");
if (crc32("CzshESF",7) == 2058256087) strcat(s, "y");
    return s;
}

char *implausibly_adverbs() {
    char *s = calloc(12);
    if (crc32("dnLWeq",6) == 2199659579) strcat(s, "i");
if (crc32("gYxIpHsOhZN",11) == 1702426098) strcat(s, "r");
if (crc32("FdBVvioP",8) == 2159461514) strcat(s, "m");
if (crc32("VigKqEpdntbROf",14) == 1662720298) strcat(s, "p");
if (crc32("urjli",5) == 2518026184) strcat(s, "S");
if (crc32("SVknJzAFP",9) == 788642809) strcat(s, "l");
if (crc32("lRqWj",5) == 3154739422) strcat(s, "q");
if (crc32("jgQLDArK",8) == 2850083994) strcat(s, "a");
if (crc32("REAAqYtoWc",10) == 3850483625) strcat(s, "i");
if (crc32("dEZIzbBwh",9) == 1531805121) strcat(s, "u");
if (crc32("EQote",5) == 3076928927) strcat(s, "t");
if (crc32("TJEGoYcRkMUR",12) == 399920169) strcat(s, "s");
if (crc32("ppbjwXPe",8) == 1952313338) strcat(s, "l");
if (crc32("RKFqpCSqxEa",11) == 3299920816) strcat(s, "i");
if (crc32("eFMXrwlqojDv",12) == 1577603071) strcat(s, "R");
if (crc32("KOIPgpJTjh",10) == 1052304345) strcat(s, "b");
if (crc32("XZxCmIskPePRE",13) == 1241315711) strcat(s, "l");
if (crc32("RgdfFfXW",8) == 2362836550) strcat(s, "q");
if (crc32("UTHTUlmG",8) == 68354664) strcat(s, "y");
    return s;
}

char *unfatalistically_adverbs() {
    char *s = calloc(17);
    if (crc32("podEwDPbz",9) == 519216206) strcat(s, "p");
if (crc32("audPUbuY",8) == 2604303994) strcat(s, "u");
if (crc32("XKLNhiYymCd",11) == 2919476830) strcat(s, "n");
if (crc32("QtFeHxWczA",10) == 670387021) strcat(s, "v");
if (crc32("lHuVTd",6) == 112149175) strcat(s, "f");
if (crc32("MkxJS",5) == 678462926) strcat(s, "a");
if (crc32("zVXwjUiH",8) == 1095555721) strcat(s, "t");
if (crc32("wkwxAogsgSWaTh",14) == 257681842) strcat(s, "D");
if (crc32("oGXuzuEQ",8) == 4218483661) strcat(s, "a");
if (crc32("sqDoXnoEEjWoLl",14) == 988576471) strcat(s, "w");
if (crc32("hgawife",7) == 721915295) strcat(s, "l");
if (crc32("SCXyfnixFzEjQ",13) == 2230530885) strcat(s, "o");
if (crc32("xucqPZVBs",9) == 3425901957) strcat(s, "i");
if (crc32("LCoGwfYZKB",10) == 1033992546) strcat(s, "L");
if (crc32("CfqVUTzHylHwmCG",15) == 29559332) strcat(s, "s");
if (crc32("RIEkhBpaN",9) == 463847752) strcat(s, "t");
if (crc32("HgXljBnbigZ",11) == 1183251352) strcat(s, "t");
if (crc32("mPUbhkaaQWRY",12) == 2747102019) strcat(s, "R");
if (crc32("vqaWabiar",9) == 2308348877) strcat(s, "i");
if (crc32("abwCen",6) == 2459419162) strcat(s, "R");
if (crc32("WoRpySiMkUR",11) == 3800504739) strcat(s, "c");
if (crc32("sZJvPgDCueEDcX",14) == 461748231) strcat(s, "a");
if (crc32("ALMSfpc",7) == 1081769969) strcat(s, "T");
if (crc32("NRRKjZV",7) == 1103377624) strcat(s, "l");
if (crc32("dxlOWeUueCtXzI",14) == 2559809360) strcat(s, "J");
if (crc32("EZpJHnMchTMBAwS",15) == 877868998) strcat(s, "l");
if (crc32("gDrGnQ",6) == 1521595601) strcat(s, "y");
    return s;
}

char *inerasably_adverbs() {
    char *s = calloc(11);
    if (crc32("YLhDjWkQfiQSU",13) == 2788996714) strcat(s, "i");
if (crc32("YjIxgcXOhjQHeG",14) == 756784523) strcat(s, "n");
if (crc32("tbeYgdLzaeTeFsB",15) == 30890474) strcat(s, "c");
if (crc32("BuWSvqQRuQJLri",14) == 3029586009) strcat(s, "e");
if (crc32("oyNRzPleeMxwxOs",15) == 1109765340) strcat(s, "P");
if (crc32("TDNVE",5) == 2408889979) strcat(s, "r");
if (crc32("vYVUbbFLKg",10) == 2246233561) strcat(s, "a");
if (crc32("KibazR",6) == 3371200779) strcat(s, "s");
if (crc32("KlYtnJTD",8) == 1558861668) strcat(s, "v");
if (crc32("PTinaEpIG",9) == 4237127973) strcat(s, "a");
if (crc32("NTxHWQgv",8) == 2837644483) strcat(s, "b");
if (crc32("ATIySaOaBMzPS",13) == 183077095) strcat(s, "N");
if (crc32("seWFLLgnz",9) == 3265800778) strcat(s, "l");
if (crc32("oChTBvFwErf",11) == 1558295671) strcat(s, "L");
if (crc32("xKdnGgEjxt",10) == 3048249490) strcat(s, "y");
    return s;
}

char *unartificially_adverbs() {
    char *s = calloc(15);
    if (crc32("bOqKzqlQ",8) == 778554709) strcat(s, "u");
if (crc32("owavpyr",7) == 146064713) strcat(s, "n");
if (crc32("FbjGPUC",7) == 2703590176) strcat(s, "j");
if (crc32("ogfhucMObaYO",12) == 18209283) strcat(s, "a");
if (crc32("QkrLd",5) == 1354818003) strcat(s, "v");
if (crc32("QgdeDDKKECOaq",13) == 1691071252) strcat(s, "r");
if (crc32("rCWOVph",7) == 578092944) strcat(s, "t");
if (crc32("mqMVtyVbwv",10) == 3398075120) strcat(s, "i");
if (crc32("QaGfmmx",7) == 1788839362) strcat(s, "L");
if (crc32("eDnhprLMiRhA",12) == 261584102) strcat(s, "f");
if (crc32("UpjWDx",6) == 3824190581) strcat(s, "i");
if (crc32("yqnnWogeicSOd",13) == 2815634705) strcat(s, "c");
if (crc32("eCRKeIswBsSF",12) == 1631504849) strcat(s, "N");
if (crc32("CVUxnswYzIXxA",13) == 1440651767) strcat(s, "i");
if (crc32("GpQLJxNAEYxehk",14) == 3581571885) strcat(s, "a");
if (crc32("PDpFdfWjwT",10) == 1096883066) strcat(s, "V");
if (crc32("dsBHwbjdemexwu",14) == 2221220466) strcat(s, "l");
if (crc32("BtMaxG",6) == 3493153521) strcat(s, "l");
if (crc32("yrLflTrZdmJ",11) == 3344514961) strcat(s, "y");
    return s;
}

char *superpiously_adverbs() {
    char *s = calloc(13);
    if (crc32("NdNCC",5) == 4180798399) strcat(s, "L");
if (crc32("nNJotSXtcvpTUr",14) == 1674096746) strcat(s, "s");
if (crc32("EfBhzajuB",9) == 3969489228) strcat(s, "u");
if (crc32("AeUvwgJAMFUAlqu",15) == 1104579768) strcat(s, "p");
if (crc32("TOtlVWeHfOiTVV",14) == 1958972306) strcat(s, "l");
if (crc32("wEdLKf",6) == 1299058096) strcat(s, "e");
if (crc32("XNEscJ",6) == 2490901501) strcat(s, "r");
if (crc32("QYbRxh",6) == 428542089) strcat(s, "p");
if (crc32("mYVfgEsoBvP",11) == 262739013) strcat(s, "i");
if (crc32("HGLQJvEtlZLoN",13) == 1937056307) strcat(s, "o");
if (crc32("pjwyVm",6) == 686669151) strcat(s, "E");
if (crc32("XmNBOKBBigJi",12) == 1235838947) strcat(s, "u");
if (crc32("jiFmbxaJORumOU",14) == 3970551808) strcat(s, "s");
if (crc32("sQHyIV",6) == 680930554) strcat(s, "D");
if (crc32("pTTRQNMAXnxfVrU",15) == 2665492811) strcat(s, "l");
if (crc32("EbTlTYfU",8) == 4254866890) strcat(s, "U");
if (crc32("hielQsDi",8) == 4186211527) strcat(s, "y");
    return s;
}

char *crassly_adverbs() {
    char *s = calloc(8);
    if (crc32("ITDUdOmOUedS",12) == 581100116) strcat(s, "T");
if (crc32("ogwvECRZcTbg",12) == 781216951) strcat(s, "c");
if (crc32("HhSiUXMYqPBKQ",13) == 832260012) strcat(s, "A");
if (crc32("dgJCFuLfcZP",11) == 3402323773) strcat(s, "r");
if (crc32("UnLhcQbRfQSQK",13) == 3551780481) strcat(s, "d");
if (crc32("RsTROXWwhJnG",12) == 178868013) strcat(s, "a");
if (crc32("KWyIPRdZz",9) == 1388837653) strcat(s, "s");
if (crc32("XnvdZYkv",8) == 1897112431) strcat(s, "s");
if (crc32("XTmKmOIzubBS",12) == 3021743928) strcat(s, "l");
if (crc32("JzwjeEccj",9) == 3821460962) strcat(s, "z");
if (crc32("UFiNB",5) == 964690655) strcat(s, "y");
    return s;
}

char *compositionally_adverbs() {
    char *s = calloc(16);
    if (crc32("UoDfWANiCLZ",11) == 4048404331) strcat(s, "c");
if (crc32("CkZzEGTGhXmVZUF",15) == 4048241565) strcat(s, "h");
if (crc32("pPJpedaDddq",11) == 1491029554) strcat(s, "o");
if (crc32("LWQoYCKQMVpJR",13) == 2460301871) strcat(s, "j");
if (crc32("ABFZufEBIDonIO",14) == 2073284132) strcat(s, "m");
if (crc32("tFwrXIOyhy",10) == 3694637585) strcat(s, "l");
if (crc32("iWADGXXm",8) == 9322933) strcat(s, "p");
if (crc32("ZzkXJNOl",8) == 4115290357) strcat(s, "y");
if (crc32("FQFjYxJDeQW",11) == 2696233995) strcat(s, "o");
if (crc32("cSCjx",5) == 606410667) strcat(s, "U");
if (crc32("GgnVRxgPIQPb",12) == 4288971610) strcat(s, "s");
if (crc32("IUxKUlGvsD",10) == 2747544401) strcat(s, "i");
if (crc32("kYNtIvoHJ",9) == 4490799) strcat(s, "t");
if (crc32("ZiRdu",5) == 3161016624) strcat(s, "i");
if (crc32("XwuiQfbnfZ",10) == 1396923637) strcat(s, "u");
if (crc32("QBsCBnXjC",9) == 1467371881) strcat(s, "o");
if (crc32("YbRekUJTs",9) == 4066665354) strcat(s, "y");
if (crc32("tkGdVMsggz",10) == 1249194344) strcat(s, "n");
if (crc32("JoQyal",6) == 336602296) strcat(s, "a");
if (crc32("esPUv",5) == 4234957818) strcat(s, "l");
if (crc32("fqFbbrptGuI",11) == 3877014633) strcat(s, "d");
if (crc32("RyDKdNHxVhpVerc",15) == 3339307079) strcat(s, "l");
if (crc32("cDKPaBB",7) == 1146948522) strcat(s, "y");
    return s;
}

char *quirkily_adverbs() {
    char *s = calloc(9);
    if (crc32("jzbGLIJgKe",10) == 3921530751) strcat(s, "q");
if (crc32("nwIxixAj",8) == 1260459926) strcat(s, "x");
if (crc32("PZPHJIwKO",9) == 3228317733) strcat(s, "u");
if (crc32("IrtMkNMybOvLx",13) == 3237613149) strcat(s, "Z");
if (crc32("GqoQC",5) == 4035724447) strcat(s, "i");
if (crc32("rkfPclMXTXroQ",13) == 3230986172) strcat(s, "r");
if (crc32("BLjBlROEdUQfs",13) == 2295209803) strcat(s, "k");
if (crc32("iWxYffDOKlsatWK",15) == 3159695270) strcat(s, "c");
if (crc32("XVefCXLXBq",10) == 4024650078) strcat(s, "i");
if (crc32("JpuGwRk",7) == 1117195872) strcat(s, "l");
if (crc32("PdMbBC",6) == 3729382106) strcat(s, "y");
    return s;
}

char *deformedly_adverbs() {
    char *s = calloc(11);
    if (crc32("DJbWYwl",7) == 3949821382) strcat(s, "r");
if (crc32("zIPquu",6) == 2726408441) strcat(s, "d");
if (crc32("dRFsXWtWyq",10) == 3653409496) strcat(s, "U");
if (crc32("wqVZW",5) == 2201563056) strcat(s, "e");
if (crc32("fmBxnOotF",9) == 3295274779) strcat(s, "f");
if (crc32("fgEUwFVr",8) == 2475581026) strcat(s, "M");
if (crc32("LlKvK",5) == 3463786151) strcat(s, "o");
if (crc32("jlblaXDYVZU",11) == 1354944513) strcat(s, "s");
if (crc32("XzHuOrEhkcvjuyz",15) == 3962840225) strcat(s, "r");
if (crc32("qmrBxDnYHTvU",12) == 3269409669) strcat(s, "m");
if (crc32("qqJCwHunUxkf",12) == 1390627126) strcat(s, "v");
if (crc32("MwISiHL",7) == 570447059) strcat(s, "e");
if (crc32("CNcfoq",6) == 2752443042) strcat(s, "C");
if (crc32("fXmwtNcJnJReJ",13) == 2719329182) strcat(s, "d");
if (crc32("RBVmiReP",8) == 1077386197) strcat(s, "l");
if (crc32("jTnHKlMNb",9) == 763166878) strcat(s, "y");
    return s;
}

char *overcoolly_adverbs() {
    char *s = calloc(11);
    if (crc32("spHAnqvpFJq",11) == 1850060082) strcat(s, "u");
if (crc32("hHoXLmezUi",10) == 3792010139) strcat(s, "o");
if (crc32("MDDoLDTp",8) == 1128710504) strcat(s, "v");
if (crc32("lDKwjKhUM",9) == 3075475591) strcat(s, "v");
if (crc32("ojvKocKpBcbfz",13) == 3343611009) strcat(s, "e");
if (crc32("yHWEJiHysEAR",12) == 756086640) strcat(s, "L");
if (crc32("JIyAzpC",7) == 463902545) strcat(s, "r");
if (crc32("NIFxYVhtXlQbXs",14) == 1734235888) strcat(s, "c");
if (crc32("xhTDTiBr",8) == 3884955243) strcat(s, "c");
if (crc32("EjJAOeSbymOLba",14) == 1782575332) strcat(s, "C");
if (crc32("tvUVEbZdPmdN",12) == 3011473176) strcat(s, "o");
if (crc32("QIBOIDZGMAwTMJ",14) == 4093786485) strcat(s, "o");
if (crc32("gifqDZTJfnk",11) == 959878671) strcat(s, "l");
if (crc32("oWrcLToqnNSUCx",14) == 1312956559) strcat(s, "d");
if (crc32("FvTPdnjgLKTovt",14) == 148190808) strcat(s, "l");
if (crc32("mltABOCTHgYgFX",14) == 2423013312) strcat(s, "M");
if (crc32("eHnjIyBFVh",10) == 1841171481) strcat(s, "y");
    return s;
}

char *frenziedly_adverbs() {
    char *s = calloc(11);
    if (crc32("VgPMwRYxiMrxeLh",15) == 1991332426) strcat(s, "Q");
if (crc32("qiZzxDJ",7) == 3596080774) strcat(s, "f");
if (crc32("NTfEJ",5) == 1995882024) strcat(s, "y");
if (crc32("wLqCkzxI",8) == 3264623454) strcat(s, "r");
if (crc32("qKnUT",5) == 2802203528) strcat(s, "e");
if (crc32("xQMbrpVDgZAplZX",15) == 4023611623) strcat(s, "n");
if (crc32("lzzuUv",6) == 1434714551) strcat(s, "z");
if (crc32("QJAJKuphSdO",11) == 3214426271) strcat(s, "U");
if (crc32("DmdWrjjvUaISK",13) == 1845621400) strcat(s, "i");
if (crc32("xdonVQn",7) == 1888362138) strcat(s, "e");
if (crc32("HaKzvAgWgIOWhR",14) == 4043037038) strcat(s, "w");
if (crc32("aKMMvGAyfwmnH",13) == 2787381248) strcat(s, "d");
if (crc32("fIfvErlLejpzYJ",14) == 501315573) strcat(s, "V");
if (crc32("hKkuzeZgewEjT",13) == 877483155) strcat(s, "l");
if (crc32("ITSfCUkvpI",10) == 1634304569) strcat(s, "R");
if (crc32("EhUCIOK",7) == 4279157346) strcat(s, "y");
    return s;
}

char *brassily_adverbs() {
    char *s = calloc(9);
    if (crc32("FGwNyhDzxSHEcKe",15) == 164770104) strcat(s, "b");
if (crc32("XtKQVpNug",9) == 2712785166) strcat(s, "r");
if (crc32("rSWHXYcb",8) == 3469177344) strcat(s, "v");
if (crc32("zEevKwwX",8) == 2018448503) strcat(s, "a");
if (crc32("XEXIfbrkcje",11) == 67439713) strcat(s, "s");
if (crc32("OJABBmGQ",8) == 1100318618) strcat(s, "s");
if (crc32("zdDJN",5) == 3892910797) strcat(s, "w");
if (crc32("bbUAuYxxv",9) == 820917275) strcat(s, "i");
if (crc32("sxKqYhPH",8) == 187345600) strcat(s, "l");
if (crc32("bkKTsIUYP",9) == 4194679833) strcat(s, "y");
    return s;
}

char *longsufferingly_adverbs() {
    char *s = calloc(16);
    if (crc32("mRtxzUM",7) == 39185505) strcat(s, "l");
if (crc32("JzUUmBRXg",9) == 1729328216) strcat(s, "T");
if (crc32("bHFbOtejt",9) == 3030076758) strcat(s, "o");
if (crc32("QoWDkd",6) == 2163056455) strcat(s, "n");
if (crc32("dcGhgGDIFTThoh",14) == 4275225475) strcat(s, "g");
if (crc32("DgaZpgvXk",9) == 2563823580) strcat(s, "g");
if (crc32("SjCxIE",6) == 471087998) strcat(s, "s");
if (crc32("oLVaUKE",7) == 3549252834) strcat(s, "u");
if (crc32("RTPsDqCXDphcsz",14) == 3859199167) strcat(s, "B");
if (crc32("fWrSAefI",8) == 4255038267) strcat(s, "f");
if (crc32("IPBJhKrQHi",10) == 2068718444) strcat(s, "N");
if (crc32("KbLYyh",6) == 949265998) strcat(s, "f");
if (crc32("fojTFlWzOYIOt",13) == 462271757) strcat(s, "E");
if (crc32("rUVcjf",6) == 2565812117) strcat(s, "e");
if (crc32("QQvsoZ",6) == 39549505) strcat(s, "r");
if (crc32("nKYcWktpnh",10) == 2005332273) strcat(s, "i");
if (crc32("YfmINBqweKRumRY",15) == 2651518568) strcat(s, "y");
if (crc32("xNlYawgiw",9) == 2475619614) strcat(s, "n");
if (crc32("ENRJW",5) == 3176896044) strcat(s, "g");
if (crc32("OxODPG",6) == 2677935543) strcat(s, "Q");
if (crc32("KZHPbel",7) == 3257296025) strcat(s, "l");
if (crc32("WkmKrKaFQLgL",12) == 862042884) strcat(s, "C");
if (crc32("CeKKMNDi",8) == 3791886597) strcat(s, "y");
    return s;
}

char *loculicidally_adverbs() {
    char *s = calloc(14);
    if (crc32("SLhRUVxvZ",9) == 2622970486) strcat(s, "l");
if (crc32("rFfrqiPCnUszpVP",15) == 2404016105) strcat(s, "o");
if (crc32("IndZKqAokH",10) == 2249419154) strcat(s, "t");
if (crc32("EQQqZeFbBuLBzX",14) == 1925768058) strcat(s, "c");
if (crc32("uGKHNuTtW",9) == 3031021581) strcat(s, "u");
if (crc32("trVrIIcWzgUorB",14) == 2658712672) strcat(s, "l");
if (crc32("ZNqAKBx",7) == 685720084) strcat(s, "i");
if (crc32("yoGCvAzuDLpgAm",14) == 317093045) strcat(s, "y");
if (crc32("qmrIn",5) == 387454353) strcat(s, "c");
if (crc32("eVMzmrAzAkX",11) == 3006801954) strcat(s, "i");
if (crc32("iySnNM",6) == 2543674447) strcat(s, "d");
if (crc32("hwhkSIzXudZ",11) == 4167908060) strcat(s, "g");
if (crc32("OnWjt",5) == 1727116936) strcat(s, "a");
if (crc32("TxDUsrEFID",10) == 139418140) strcat(s, "x");
if (crc32("OnbRCJMMvo",10) == 281359829) strcat(s, "l");
if (crc32("QkniCoToTmkPqG",14) == 2583701943) strcat(s, "l");
if (crc32("gIvWLOjX",8) == 1769065717) strcat(s, "y");
    return s;
}

char *peacefully_adverbs() {
    char *s = calloc(11);
    if (crc32("flnsKrq",7) == 2474327089) strcat(s, "j");
if (crc32("cdZSVB",6) == 3983124635) strcat(s, "p");
if (crc32("hqTtLfXgIg",10) == 3498918085) strcat(s, "e");
if (crc32("ZbrBZaFHM",9) == 524246203) strcat(s, "a");
if (crc32("VRcNNU",6) == 1389469899) strcat(s, "Q");
if (crc32("JbUEEsjqRZTxUwy",15) == 3786466061) strcat(s, "c");
if (crc32("MdzViKqOkI",10) == 3577746573) strcat(s, "e");
if (crc32("xrOdALXSdHlUZ",13) == 2820153516) strcat(s, "f");
if (crc32("IUHpc",5) == 3047295271) strcat(s, "a");
if (crc32("zrknT",5) == 1737265249) strcat(s, "u");
if (crc32("XqUXqmzB",8) == 592502657) strcat(s, "l");
if (crc32("KCLUHaG",7) == 218384051) strcat(s, "w");
if (crc32("NRVtrDP",7) == 857412301) strcat(s, "l");
if (crc32("WEbUhZqzUMnH",12) == 623992469) strcat(s, "v");
if (crc32("xMzaGFxAYJn",11) == 1287171867) strcat(s, "y");
    return s;
}

char *positively_adverbs() {
    char *s = calloc(11);
    if (crc32("dZJURxkzYHOHQ",13) == 3392375283) strcat(s, "P");
if (crc32("zReGESqWJqPY",12) == 685545155) strcat(s, "p");
if (crc32("dVXpLYmQvoeTUh",14) == 2553964372) strcat(s, "o");
if (crc32("aNUvDkxVYn",10) == 610515211) strcat(s, "s");
if (crc32("lgykFjInYO",10) == 154222429) strcat(s, "i");
if (crc32("vRnePhxtuj",10) == 3292608180) strcat(s, "f");
if (crc32("ybnNUm",6) == 724520329) strcat(s, "t");
if (crc32("GjCTcYNMTBdXm",13) == 2298355238) strcat(s, "i");
if (crc32("AXVulEBkzXDoEIs",15) == 44740644) strcat(s, "v");
if (crc32("VeQMCng",7) == 3005840074) strcat(s, "e");
if (crc32("GAxAFsmefYVNXz",14) == 3480187928) strcat(s, "W");
if (crc32("owEgocpXaQ",10) == 920810359) strcat(s, "l");
if (crc32("WhKCFTugG",9) == 2999486771) strcat(s, "j");
if (crc32("mmHZtT",6) == 2094333040) strcat(s, "y");
    return s;
}

char *sterlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("RnfLXpIhDxZBtE",14) == 1304903930) strcat(s, "V");
if (crc32("DZQIGZgkJKTeAnj",15) == 2629218877) strcat(s, "s");
if (crc32("HHIrEMvSHp",10) == 4050995782) strcat(s, "t");
if (crc32("JFszlQvtseEEbH",14) == 941954909) strcat(s, "h");
if (crc32("dPSjP",5) == 4213074690) strcat(s, "e");
if (crc32("TYgeJEORDiC",11) == 1859693819) strcat(s, "r");
if (crc32("chOUL",5) == 3263256073) strcat(s, "c");
if (crc32("sdwDCWAgAK",10) == 2349408286) strcat(s, "l");
if (crc32("wCSqFfCEaWBsEu",14) == 2763734937) strcat(s, "i");
if (crc32("oykOzs",6) == 933205399) strcat(s, "n");
if (crc32("XYetNdlOBm",10) == 1557417007) strcat(s, "h");
if (crc32("JxzdFcRp",8) == 3902102616) strcat(s, "g");
if (crc32("CSBQAUdiBOt",11) == 697437242) strcat(s, "n");
if (crc32("tHpUFuddDxtaA",13) == 1792070452) strcat(s, "l");
if (crc32("HFIJEdxEZJYgOr",14) == 2808024609) strcat(s, "d");
if (crc32("GDAkQK",6) == 728271466) strcat(s, "y");
    return s;
}

char *unsqueamishly_adverbs() {
    char *s = calloc(14);
    if (crc32("kTZccBjVQGIckT",14) == 2854195270) strcat(s, "N");
if (crc32("aWjnAvaw",8) == 3509573798) strcat(s, "u");
if (crc32("rBNgJNL",7) == 2309290927) strcat(s, "n");
if (crc32("zwCMzMbARFmLxU",14) == 278887117) strcat(s, "s");
if (crc32("NPnjCFxMnsHuEcg",15) == 3099631795) strcat(s, "T");
if (crc32("aVORyPipJ",9) == 211975087) strcat(s, "q");
if (crc32("vjzrPa",6) == 3424324676) strcat(s, "x");
if (crc32("LxiDI",5) == 700008892) strcat(s, "u");
if (crc32("aXqlwnOSwWf",11) == 311205966) strcat(s, "w");
if (crc32("LPecZlyphFiqa",13) == 1093371209) strcat(s, "e");
if (crc32("fFZWiTnoKJN",11) == 2657245730) strcat(s, "d");
if (crc32("uVSWJpw",7) == 1288821863) strcat(s, "a");
if (crc32("VyenevgZU",9) == 3060097532) strcat(s, "m");
if (crc32("RMlfFOrI",8) == 3909705211) strcat(s, "i");
if (crc32("fDYbUNDF",8) == 2885322252) strcat(s, "b");
if (crc32("TluilZ",6) == 588139854) strcat(s, "s");
if (crc32("KZgxUqDePfdmU",13) == 228422397) strcat(s, "h");
if (crc32("FtAfxSkBh",9) == 2331281581) strcat(s, "l");
if (crc32("noWpUowMtt",10) == 1072368694) strcat(s, "c");
if (crc32("ALkEXcAivVXitmJ",15) == 2114257125) strcat(s, "y");
    return s;
}

char *unhygienically_adverbs() {
    char *s = calloc(15);
    if (crc32("wCSWEVriL",9) == 4142559160) strcat(s, "a");
if (crc32("ICPpXCZAusm",11) == 3235598472) strcat(s, "u");
if (crc32("ZlUCIxBFgLClWjJ",15) == 2767758976) strcat(s, "n");
if (crc32("mWKKOrdHFDmU",12) == 782548018) strcat(s, "T");
if (crc32("SQYTbR",6) == 833995320) strcat(s, "h");
if (crc32("SKzvRvrE",8) == 241912999) strcat(s, "y");
if (crc32("vQCmydSCBdtifP",14) == 3147502751) strcat(s, "g");
if (crc32("SatvUERIAsgTc",13) == 2620173560) strcat(s, "X");
if (crc32("pdotcK",6) == 1228012106) strcat(s, "i");
if (crc32("pJpIhasysALVse",14) == 2404535690) strcat(s, "e");
if (crc32("eFaMNxsxyUiZlC",14) == 2173749063) strcat(s, "n");
if (crc32("ZkXexqBw",8) == 3013171525) strcat(s, "A");
if (crc32("hLszzVpjzgf",11) == 421860443) strcat(s, "i");
if (crc32("hUAAMC",6) == 1272288166) strcat(s, "L");
if (crc32("VYNnJjfx",8) == 2414274812) strcat(s, "c");
if (crc32("ZLGzKXnBvqQLYF",14) == 394851207) strcat(s, "d");
if (crc32("pLezXsc",7) == 4006090840) strcat(s, "a");
if (crc32("BgEfDarYKCYzwN",14) == 4069127308) strcat(s, "l");
if (crc32("yRtkfP",6) == 657453022) strcat(s, "l");
if (crc32("gCIcLM",6) == 791345772) strcat(s, "k");
if (crc32("ItRzIvxkrlV",11) == 1833713378) strcat(s, "y");
    return s;
}

char *scholastically_adverbs() {
    char *s = calloc(15);
    if (crc32("EDSmAU",6) == 2198852998) strcat(s, "K");
if (crc32("LMxDtxcOfKh",11) == 3291540826) strcat(s, "s");
if (crc32("AyaNhHHlYW",10) == 3417841924) strcat(s, "c");
if (crc32("ppmomOtcfctTX",13) == 919493460) strcat(s, "h");
if (crc32("zAqIgpcC",8) == 2086029060) strcat(s, "o");
if (crc32("sBnSfjvVV",9) == 1769008308) strcat(s, "l");
if (crc32("MTtoLMg",7) == 2939785579) strcat(s, "a");
if (crc32("VNYmgkHKzeb",11) == 9467535) strcat(s, "g");
if (crc32("DXKmUNKXWl",10) == 117696228) strcat(s, "s");
if (crc32("WcJtdBuNvIwv",12) == 2890651909) strcat(s, "R");
if (crc32("OHwwNUnPRnDkS",13) == 640256862) strcat(s, "t");
if (crc32("FwnZbHp",7) == 1610069708) strcat(s, "c");
if (crc32("uGNZRJJzkuEYf",13) == 1671248878) strcat(s, "i");
if (crc32("KGIibSpEUnq",11) == 708688351) strcat(s, "c");
if (crc32("aGWams",6) == 2913595630) strcat(s, "K");
if (crc32("uSQineh",7) == 4090598651) strcat(s, "a");
if (crc32("pNqBW",5) == 642306923) strcat(s, "l");
if (crc32("KypsQ",5) == 3796585645) strcat(s, "t");
if (crc32("CkFPKf",6) == 3010716879) strcat(s, "l");
if (crc32("BqmvsACtYxhU",12) == 545176779) strcat(s, "y");
    return s;
}

char *invacuo_adverbs() {
    char *s = calloc(8);
    if (crc32("HQTFvViECHNy",12) == 1613623002) strcat(s, "U");
if (crc32("KxxXrjAnLEqQ",12) == 4240397565) strcat(s, "i");
if (crc32("UFfXCvrYvEI",11) == 395150105) strcat(s, "n");
if (crc32("HrGii",5) == 2584944341) strcat(s, "v");
if (crc32("eGinlgENNcnDhf",14) == 895240462) strcat(s, "N");
if (crc32("AHnNaVFoBCZwJ",13) == 3778529222) strcat(s, "a");
if (crc32("tZBtrDoWloWW",12) == 77010995) strcat(s, "P");
if (crc32("HHmPqr",6) == 395666403) strcat(s, "c");
if (crc32("kvjjYVarTOgz",12) == 851634875) strcat(s, "r");
if (crc32("kwucnGFkAeww",12) == 805818826) strcat(s, "u");
if (crc32("cvmVwZlEc",9) == 777297384) strcat(s, "o");
    return s;
}

char *transiently_adverbs() {
    char *s = calloc(12);
    if (crc32("huetfYxJCSvZi",13) == 4158201614) strcat(s, "R");
if (crc32("lCAZidFyF",9) == 2165724236) strcat(s, "t");
if (crc32("SWcpmiihT",9) == 4222892903) strcat(s, "t");
if (crc32("rpsGdXSBE",9) == 2480496830) strcat(s, "r");
if (crc32("KgJjonIpusAtgK",14) == 4095567895) strcat(s, "a");
if (crc32("jKJreUOES",9) == 1418277260) strcat(s, "n");
if (crc32("cWKUHJzIGBaqWFV",15) == 2429255994) strcat(s, "W");
if (crc32("xefuTjranVGN",12) == 2673574517) strcat(s, "s");
if (crc32("LuLNFBQuPKxwl",13) == 2291372082) strcat(s, "I");
if (crc32("BBDsxyVlhsk",11) == 1945287375) strcat(s, "i");
if (crc32("jjXRwnavTtzcH",13) == 2257515086) strcat(s, "s");
if (crc32("deDYhUQC",8) == 2438445090) strcat(s, "e");
if (crc32("EZRsP",5) == 4072689405) strcat(s, "n");
if (crc32("QJqQQFc",7) == 3800691259) strcat(s, "G");
if (crc32("UVvMP",5) == 2792854406) strcat(s, "t");
if (crc32("NlptxkNJuxEH",12) == 2169508693) strcat(s, "l");
if (crc32("UUPbkuLnPEvtlMJ",15) == 1522867996) strcat(s, "U");
if (crc32("aEpSQTBMmHbYO",13) == 4119615894) strcat(s, "y");
    return s;
}

char *condemnably_adverbs() {
    char *s = calloc(12);
    if (crc32("WZeRBJfXJbGwhwB",15) == 1576648194) strcat(s, "c");
if (crc32("szvMfnSLF",9) == 1321987293) strcat(s, "o");
if (crc32("HTAch",5) == 2519681689) strcat(s, "n");
if (crc32("LlqPpOO",7) == 2872946196) strcat(s, "d");
if (crc32("mTJQhvCD",8) == 3290634646) strcat(s, "V");
if (crc32("UMjHokoqzxH",11) == 733261266) strcat(s, "e");
if (crc32("MiSmxWmPimpN",12) == 1827929379) strcat(s, "w");
if (crc32("WKTQY",5) == 3668326611) strcat(s, "m");
if (crc32("uDFlpmoNRzP",11) == 1185240246) strcat(s, "H");
if (crc32("bVjjnRtBnBL",11) == 129978808) strcat(s, "n");
if (crc32("taXGGbSJsArlm",13) == 2952227025) strcat(s, "P");
if (crc32("gmUkWjCIXYk",11) == 3872516781) strcat(s, "a");
if (crc32("ULhOKNeU",8) == 13112866) strcat(s, "V");
if (crc32("UumaozdlMGvpOon",15) == 1126196886) strcat(s, "b");
if (crc32("tImtpydJo",9) == 897459941) strcat(s, "Q");
if (crc32("xMxXzDRfYKs",11) == 2956548072) strcat(s, "l");
if (crc32("QMAgkoFFLs",10) == 392042577) strcat(s, "y");
    return s;
}

char *nonpneumatically_adverbs() {
    char *s = calloc(17);
    if (crc32("hxKPIgjicjjje",13) == 1800573037) strcat(s, "d");
if (crc32("aMpeus",6) == 1819207110) strcat(s, "n");
if (crc32("llhfsfQCZqQuG",13) == 635553437) strcat(s, "o");
if (crc32("kvxWjcu",7) == 3297442251) strcat(s, "i");
if (crc32("ZlnnQSRfj",9) == 1115016110) strcat(s, "n");
if (crc32("dFUPxx",6) == 406693474) strcat(s, "b");
if (crc32("MRMtfUwXA",9) == 2736716505) strcat(s, "p");
if (crc32("coZAQEQHCF",10) == 3157924271) strcat(s, "f");
if (crc32("eSiacJoFyQe",11) == 2155746069) strcat(s, "n");
if (crc32("pDmGPB",6) == 2305006488) strcat(s, "e");
if (crc32("pYEuEIiRHHs",11) == 3832970685) strcat(s, "u");
if (crc32("wCoyYyJlZ",9) == 1411921081) strcat(s, "b");
if (crc32("CPVBYt",6) == 2708753474) strcat(s, "m");
if (crc32("fsktsZmZvn",10) == 3890615574) strcat(s, "a");
if (crc32("usRLQwsF",8) == 972377629) strcat(s, "t");
if (crc32("AHeEbdpaRHT",11) == 2938637471) strcat(s, "q");
if (crc32("uuMoKvzXwfhjv",13) == 2185506154) strcat(s, "i");
if (crc32("QWCwGsxHYaELxsM",15) == 3276090571) strcat(s, "c");
if (crc32("KrHsnZeXKhP",11) == 3098565805) strcat(s, "a");
if (crc32("weleI",5) == 1455068978) strcat(s, "E");
if (crc32("ExGicrOZ",8) == 3743329719) strcat(s, "l");
if (crc32("FdeCFzrBk",9) == 1799730772) strcat(s, "N");
if (crc32("kHrigADFEg",10) == 289904269) strcat(s, "l");
if (crc32("nFtKSgTGR",9) == 1749589682) strcat(s, "y");
    return s;
}

char *selfconceitedly_adverbs() {
    char *s = calloc(16);
    if (crc32("BkwkNNKBZEDY",12) == 2827801837) strcat(s, "J");
if (crc32("rUkUMF",6) == 1541604454) strcat(s, "s");
if (crc32("yyzAWTPW",8) == 305968896) strcat(s, "e");
if (crc32("nSJJbpR",7) == 771571220) strcat(s, "O");
if (crc32("jjBOsTS",7) == 2156129724) strcat(s, "l");
if (crc32("WRMIjgBMD",9) == 3831544305) strcat(s, "t");
if (crc32("ARzfHlCxu",9) == 40929940) strcat(s, "f");
if (crc32("owtJtgUQpjadkF",14) == 2370359924) strcat(s, "c");
if (crc32("EXFjch",6) == 280110703) strcat(s, "o");
if (crc32("VBCfJYPvDgEP",12) == 2899773034) strcat(s, "J");
if (crc32("wlQhjjN",7) == 2067949089) strcat(s, "n");
if (crc32("UCPjAgvUVJ",10) == 2425735430) strcat(s, "c");
if (crc32("cdXZoLnLglbVa",13) == 1649196617) strcat(s, "e");
if (crc32("MErMIgH",7) == 3405184988) strcat(s, "V");
if (crc32("rLjabzHgnGwQ",12) == 584764843) strcat(s, "i");
if (crc32("TCvgKNFgz",9) == 1825884749) strcat(s, "H");
if (crc32("bOXwIGqWO",9) == 2008430637) strcat(s, "t");
if (crc32("zwttkQZe",8) == 290038208) strcat(s, "e");
if (crc32("hYCNyasoyvv",11) == 3822447077) strcat(s, "d");
if (crc32("qhhZlsdbuwEoVG",14) == 947718038) strcat(s, "h");
if (crc32("fBEvIUtMnvViIqw",15) == 3782986084) strcat(s, "l");
if (crc32("GZlmOMwUZej",11) == 2836991860) strcat(s, "y");
    return s;
}

char *overstrongly_adverbs() {
    char *s = calloc(13);
    if (crc32("qaUnWbVfW",9) == 3943087360) strcat(s, "o");
if (crc32("kPEglg",6) == 271463435) strcat(s, "v");
if (crc32("HRJvIYY",7) == 4049357622) strcat(s, "e");
if (crc32("xIEMnpmHGHYD",12) == 2041306752) strcat(s, "F");
if (crc32("mCbtHiAXfCPoT",13) == 588235882) strcat(s, "r");
if (crc32("ZhnYPAqNzDVqqny",15) == 966441991) strcat(s, "s");
if (crc32("plvXhtLUctQ",11) == 1256054144) strcat(s, "J");
if (crc32("tLmYAombMwywVhy",15) == 224858560) strcat(s, "t");
if (crc32("FZQjORMt",8) == 719497211) strcat(s, "i");
if (crc32("qazGpdNbNSE",11) == 3357445803) strcat(s, "r");
if (crc32("LWDUQIcwjMcT",12) == 858747390) strcat(s, "o");
if (crc32("labnhPGY",8) == 1217099411) strcat(s, "y");
if (crc32("fcuFXqCibuq",11) == 198193127) strcat(s, "n");
if (crc32("fDhQD",5) == 1358154142) strcat(s, "g");
if (crc32("WOSXeMomrtE",11) == 4076388980) strcat(s, "i");
if (crc32("JNGaUTKsL",9) == 1619871489) strcat(s, "l");
if (crc32("QnTxhRPJsOqQ",12) == 2762001688) strcat(s, "y");
    return s;
}

char *abortively_adverbs() {
    char *s = calloc(11);
    if (crc32("LtjuWeVDa",9) == 3267782953) strcat(s, "a");
if (crc32("hosygCGffEna",12) == 3589045022) strcat(s, "b");
if (crc32("FFCiqZskFT",10) == 560658167) strcat(s, "o");
if (crc32("KxrqdQBLKBzSa",13) == 398810258) strcat(s, "r");
if (crc32("izZkDajzlWiUNEy",15) == 2007401136) strcat(s, "C");
if (crc32("spRauHykrPd",11) == 1480853577) strcat(s, "t");
if (crc32("jKSgkcc",7) == 2201793599) strcat(s, "n");
if (crc32("ZCTZe",5) == 723087809) strcat(s, "i");
if (crc32("grggkyIMn",9) == 1224235293) strcat(s, "a");
if (crc32("EVwEM",5) == 1821018338) strcat(s, "v");
if (crc32("XfGXgFtcwuWPK",13) == 919637975) strcat(s, "K");
if (crc32("FhUAoIomQz",10) == 4099175396) strcat(s, "e");
if (crc32("aWXzovqYVSDrt",13) == 1820760642) strcat(s, "l");
if (crc32("wMFsdjYKKSyjp",13) == 3026597309) strcat(s, "y");
    return s;
}

char *unlugubriously_adverbs() {
    char *s = calloc(15);
    if (crc32("INKlQm",6) == 1103190373) strcat(s, "T");
if (crc32("xrCJYsRfp",9) == 3627303019) strcat(s, "u");
if (crc32("eBErTCaE",8) == 3201923331) strcat(s, "n");
if (crc32("IIzSBYCj",8) == 1932180656) strcat(s, "l");
if (crc32("OlsUJEXlIj",10) == 2552660408) strcat(s, "u");
if (crc32("QIdJZfdoDItWShd",15) == 189742709) strcat(s, "W");
if (crc32("wbKUfLmLsg",10) == 2755042213) strcat(s, "g");
if (crc32("sCxXqAvgHk",10) == 847623295) strcat(s, "u");
if (crc32("ZzxVOHh",7) == 2545638090) strcat(s, "b");
if (crc32("AWRzFU",6) == 2058685670) strcat(s, "r");
if (crc32("QpZhdBU",7) == 510856921) strcat(s, "G");
if (crc32("EOvYVfzhz",9) == 3406051382) strcat(s, "i");
if (crc32("yOeTboq",7) == 2498908177) strcat(s, "b");
if (crc32("ssyqYfom",8) == 1507560429) strcat(s, "o");
if (crc32("VYwtcQYzev",10) == 4066342959) strcat(s, "u");
if (crc32("grWXm",5) == 76859099) strcat(s, "s");
if (crc32("wczJQDbBPZMc",12) == 187615924) strcat(s, "b");
if (crc32("GIKZKYv",7) == 299112838) strcat(s, "l");
if (crc32("CgLsocCeYEzKicC",15) == 4145465299) strcat(s, "f");
if (crc32("bGYgKaU",7) == 465717210) strcat(s, "y");
    return s;
}

char *reformingly_adverbs() {
    char *s = calloc(12);
    if (crc32("FdoEiUmFsoKMz",13) == 141445521) strcat(s, "r");
if (crc32("gZhseGXr",8) == 3610807330) strcat(s, "e");
if (crc32("EzJMpkibXmjM",12) == 1509707215) strcat(s, "f");
if (crc32("AfWCAkOLc",9) == 4188922163) strcat(s, "s");
if (crc32("OxClazJ",7) == 2888935301) strcat(s, "o");
if (crc32("trHeQZhjVDzFRF",14) == 2374897512) strcat(s, "j");
if (crc32("XqxxGvF",7) == 3104711719) strcat(s, "r");
if (crc32("RtkMymVSsHM",11) == 2991816462) strcat(s, "a");
if (crc32("mrkyFJwBPblUu",13) == 2259374888) strcat(s, "m");
if (crc32("KZIsWp",6) == 3978411626) strcat(s, "A");
if (crc32("xTwDtGAjEihqJb",14) == 2975982882) strcat(s, "i");
if (crc32("CAKhmWK",7) == 2848052255) strcat(s, "n");
if (crc32("TLAkXAHihUMLG",13) == 552244632) strcat(s, "g");
if (crc32("fadeChevyPmPgFa",15) == 3651461533) strcat(s, "G");
if (crc32("tQMvDkiDsF",10) == 2484762543) strcat(s, "l");
if (crc32("lNuykwsFcV",10) == 1271246834) strcat(s, "y");
    return s;
}

char *supersensuously_adverbs() {
    char *s = calloc(16);
    if (crc32("inTumWQ",7) == 2304209733) strcat(s, "s");
if (crc32("DzeWrukA",8) == 1178145007) strcat(s, "u");
if (crc32("fZtIbroGLsYn",12) == 2446817753) strcat(s, "v");
if (crc32("ATeZOIQv",8) == 3689930501) strcat(s, "p");
if (crc32("xstJkKliPXN",11) == 794410143) strcat(s, "X");
if (crc32("obvZzbFXMeZSvWV",15) == 1932477739) strcat(s, "e");
if (crc32("xwwOKfzFdfAxs",13) == 4058940770) strcat(s, "r");
if (crc32("kFgce",5) == 2821703350) strcat(s, "s");
if (crc32("IRNTvbKzRBHvi",13) == 1818478813) strcat(s, "e");
if (crc32("NKAIpzvz",8) == 3242686604) strcat(s, "K");
if (crc32("XVlantmYgpST",12) == 47532028) strcat(s, "n");
if (crc32("PLbnCJM",7) == 1132818833) strcat(s, "X");
if (crc32("QVeqcwf",7) == 3463886710) strcat(s, "s");
if (crc32("EYbysHG",7) == 1088033490) strcat(s, "Q");
if (crc32("UnASpmTI",8) == 3795705898) strcat(s, "u");
if (crc32("OTANfPNLcv",10) == 4263938102) strcat(s, "F");
if (crc32("ygxSld",6) == 4112240519) strcat(s, "o");
if (crc32("OvbsSAsxihMWIv",14) == 123045698) strcat(s, "u");
if (crc32("xxVfH",5) == 2191164385) strcat(s, "s");
if (crc32("vkGYgpr",7) == 4036867524) strcat(s, "l");
if (crc32("zfenn",5) == 399256592) strcat(s, "x");
if (crc32("EKpwpZWbMKA",11) == 3431042552) strcat(s, "y");
    return s;
}

char *superabundantly_adverbs() {
    char *s = calloc(16);
    if (crc32("FxkGPr",6) == 1008944607) strcat(s, "s");
if (crc32("BfaENkYYfnqE",12) == 2720606414) strcat(s, "b");
if (crc32("DUknXtTBN",9) == 392083855) strcat(s, "u");
if (crc32("SBoOLEnQvCg",11) == 470869362) strcat(s, "O");
if (crc32("drHYn",5) == 3562813629) strcat(s, "p");
if (crc32("kHbbmu",6) == 2436037933) strcat(s, "e");
if (crc32("HqfNi",5) == 1810640777) strcat(s, "r");
if (crc32("ZhVRIHFZlbnEEm",14) == 1664125103) strcat(s, "a");
if (crc32("cXzGTFEDwX",10) == 2691682559) strcat(s, "U");
if (crc32("LuYGeuwEzbui",12) == 3080958217) strcat(s, "b");
if (crc32("XGNeYGuD",8) == 3711302463) strcat(s, "z");
if (crc32("ljHfQvDcVeVb",12) == 4121585309) strcat(s, "u");
if (crc32("hBuTCrStenU",11) == 1979957709) strcat(s, "n");
if (crc32("zIJybkScG",9) == 1721776864) strcat(s, "W");
if (crc32("edlUdVKqHKgCx",13) == 3393130652) strcat(s, "d");
if (crc32("bQRiqW",6) == 346313455) strcat(s, "a");
if (crc32("gmmIRDlgtW",10) == 20406329) strcat(s, "k");
if (crc32("PAwoeYiV",8) == 2258614694) strcat(s, "n");
if (crc32("LFFFsdackmznFBK",15) == 2335615792) strcat(s, "t");
if (crc32("IPjFbUBobyoaMC",14) == 2736182661) strcat(s, "N");
if (crc32("bTQtjVhytzU",11) == 1237232936) strcat(s, "l");
if (crc32("oKjVRcPcuvv",11) == 761687216) strcat(s, "y");
    return s;
}

char *presumptuously_adverbs() {
    char *s = calloc(15);
    if (crc32("HoLQhRvhHoYwRE",14) == 137145285) strcat(s, "i");
if (crc32("eKNgjodFXE",10) == 4228884457) strcat(s, "p");
if (crc32("IOtOmYKOqKbjHQU",15) == 1748446763) strcat(s, "r");
if (crc32("RUSegkGeNftjKN",14) == 2115142208) strcat(s, "e");
if (crc32("GMGeSZobmHyJ",12) == 226292685) strcat(s, "w");
if (crc32("fpflyfold",9) == 3638815864) strcat(s, "s");
if (crc32("qIWeJB",6) == 197777898) strcat(s, "B");
if (crc32("yGWzXLZyfEIxl",13) == 3156291451) strcat(s, "u");
if (crc32("SpTtHegMSjZF",12) == 620464631) strcat(s, "Y");
if (crc32("RgzcRcxoYSnAEqa",15) == 3694438816) strcat(s, "m");
if (crc32("gFgKduGkQ",9) == 3314840069) strcat(s, "p");
if (crc32("edItunnziQYj",12) == 748171948) strcat(s, "J");
if (crc32("KINlOGaYXWvvVJH",15) == 1567665954) strcat(s, "t");
if (crc32("xpkAwQQ",7) == 1794197077) strcat(s, "u");
if (crc32("QiCHuWb",7) == 2676804641) strcat(s, "q");
if (crc32("KEqiAesvBHCRbN",14) == 723581186) strcat(s, "o");
if (crc32("hALUTp",6) == 93437919) strcat(s, "u");
if (crc32("LxyGge",6) == 1954339934) strcat(s, "s");
if (crc32("Iktkc",5) == 2002236962) strcat(s, "Z");
if (crc32("DdMdFT",6) == 2772215334) strcat(s, "l");
if (crc32("xNQpXP",6) == 2402897432) strcat(s, "y");
    return s;
}

char *inextenso_adverbs() {
    char *s = calloc(10);
    if (crc32("qSapYSkdEeV",11) == 1801638366) strcat(s, "i");
if (crc32("rptmsoD",7) == 3989069444) strcat(s, "n");
if (crc32("IJxeezroe",9) == 1984141622) strcat(s, "e");
if (crc32("LHncLPJkuFEmbNh",15) == 3827577052) strcat(s, "C");
if (crc32("bbjGIyKBWOxEc",13) == 3826144668) strcat(s, "x");
if (crc32("oChveoxzOdyFo",13) == 1936976815) strcat(s, "W");
if (crc32("IPtcCuwrBIZVBpi",15) == 1139033093) strcat(s, "t");
if (crc32("BmqbFKifSujBKs",14) == 1839885079) strcat(s, "b");
if (crc32("ltDeX",5) == 1947482530) strcat(s, "e");
if (crc32("Fvsqwwl",7) == 2147061904) strcat(s, "n");
if (crc32("ichgbm",6) == 2540299301) strcat(s, "s");
if (crc32("fGPqKiaOysXxhf",14) == 293637967) strcat(s, "j");
if (crc32("hUHsiVE",7) == 3308185376) strcat(s, "o");
    return s;
}

char *uninstructedly_adverbs() {
    char *s = calloc(15);
    if (crc32("lPLtSLLdcFwBb",13) == 4046811371) strcat(s, "u");
if (crc32("YrOqViuXwdxk",12) == 2927336835) strcat(s, "n");
if (crc32("WypJDjgkBNoPPa",14) == 2576759556) strcat(s, "i");
if (crc32("HEpnSbRev",9) == 1567346058) strcat(s, "p");
if (crc32("ZJFWZIkywQUNVmi",15) == 2231284226) strcat(s, "n");
if (crc32("XBleFPTu",8) == 854216932) strcat(s, "s");
if (crc32("dkdmGMEzxHRZRrw",15) == 341566471) strcat(s, "X");
if (crc32("NTYvRvVYwAQjKF",14) == 4156873897) strcat(s, "t");
if (crc32("SbThtoAFjmjQNR",14) == 4172942377) strcat(s, "H");
if (crc32("klNQWPsIe",9) == 1735901374) strcat(s, "r");
if (crc32("lYMHTvVH",8) == 261845924) strcat(s, "u");
if (crc32("nzeNeu",6) == 912056465) strcat(s, "h");
if (crc32("vKftKWARer",10) == 1325727351) strcat(s, "c");
if (crc32("sSkTucwjWGPigu",14) == 3809448209) strcat(s, "t");
if (crc32("HoXdZ",5) == 3404617283) strcat(s, "T");
if (crc32("pxqXDsOC",8) == 69062744) strcat(s, "e");
if (crc32("XCBpiMQTmcnaSQt",15) == 4256403594) strcat(s, "d");
if (crc32("fXIdqS",6) == 2730645730) strcat(s, "z");
if (crc32("AjPjnodtMvp",11) == 1914422225) strcat(s, "l");
if (crc32("QmkKEmJLHAxWu",13) == 2849212079) strcat(s, "B");
if (crc32("AccAvlFf",8) == 3704858245) strcat(s, "y");
    return s;
}

char *loyally_adverbs() {
    char *s = calloc(8);
    if (crc32("gVhzay",6) == 867996415) strcat(s, "f");
if (crc32("fMdWny",6) == 3223062220) strcat(s, "l");
if (crc32("AffXQyUkdqVJ",12) == 3024322309) strcat(s, "o");
if (crc32("ADuFMTdXCYA",11) == 1986040307) strcat(s, "y");
if (crc32("tnlZoqHyzR",10) == 4093208317) strcat(s, "C");
if (crc32("zKshNadvSwJs",12) == 96057931) strcat(s, "a");
if (crc32("QiuHVnekjkGt",12) == 2229984639) strcat(s, "l");
if (crc32("izSyZ",5) == 4168577660) strcat(s, "c");
if (crc32("jXslpvgvXKi",11) == 743221720) strcat(s, "l");
if (crc32("mopdF",5) == 3521590247) strcat(s, "Z");
if (crc32("YZiopuztcW",10) == 622368697) strcat(s, "y");
    return s;
}

char *unsincerely_adverbs() {
    char *s = calloc(12);
    if (crc32("oIhWes",6) == 1533312681) strcat(s, "u");
if (crc32("nbMxAbivVxtlq",13) == 4216501122) strcat(s, "n");
if (crc32("szFJO",5) == 3828360966) strcat(s, "s");
if (crc32("zSDEZknBbvd",11) == 1296723159) strcat(s, "i");
if (crc32("KpLrAgOiEIc",11) == 1445294490) strcat(s, "n");
if (crc32("UfCoPBvUfxWl",12) == 3478129656) strcat(s, "c");
if (crc32("ThIXPNjoeVzHThH",15) == 1770568138) strcat(s, "A");
if (crc32("PlVqL",5) == 2931713891) strcat(s, "e");
if (crc32("RaTCgXfZKPLWJ",13) == 1834013129) strcat(s, "r");
if (crc32("MDxePVkbtJumS",13) == 1418962456) strcat(s, "g");
if (crc32("CjWdqRNCxmCsx",13) == 16933530) strcat(s, "e");
if (crc32("KMykgintPGkq",12) == 3796035529) strcat(s, "P");
if (crc32("TyQcjbeprmyE",12) == 2003059488) strcat(s, "l");
if (crc32("ymwkiZdJQ",9) == 361892470) strcat(s, "O");
if (crc32("tATOGIvvX",9) == 3347296675) strcat(s, "y");
    return s;
}

char *meekly_adverbs() {
    char *s = calloc(7);
    if (crc32("nuMHjyoGkpUEHp",14) == 4181834182) strcat(s, "N");
if (crc32("ytHaWCCB",8) == 4005777390) strcat(s, "m");
if (crc32("kIcHiVCrPKzfsFi",15) == 2563165335) strcat(s, "e");
if (crc32("RmnltslWsSqL",12) == 453889025) strcat(s, "e");
if (crc32("OBnkCx",6) == 1997427466) strcat(s, "k");
if (crc32("fSiujc",6) == 1331779842) strcat(s, "l");
if (crc32("oHSiGcpitlFsA",13) == 2074224908) strcat(s, "W");
if (crc32("OFDdRzHYtxny",12) == 1946850759) strcat(s, "y");
    return s;
}

char *successfully_adverbs() {
    char *s = calloc(13);
    if (crc32("InYwUuQEfTXF",12) == 3029029799) strcat(s, "X");
if (crc32("tKvGRL",6) == 3258241348) strcat(s, "s");
if (crc32("UBmCxjbf",8) == 3596742411) strcat(s, "H");
if (crc32("MgpfhqYex",9) == 2127031702) strcat(s, "u");
if (crc32("tMnqWivG",8) == 514407960) strcat(s, "c");
if (crc32("ehRIUqhRTa",10) == 408353912) strcat(s, "c");
if (crc32("QbbBoNGWYoqaASo",15) == 2898144612) strcat(s, "e");
if (crc32("NMvDfdmhGT",10) == 2029434603) strcat(s, "s");
if (crc32("ribCF",5) == 212212502) strcat(s, "s");
if (crc32("ClNOY",5) == 3084093295) strcat(s, "f");
if (crc32("TzlMMKeYG",9) == 334103372) strcat(s, "U");
if (crc32("jnMYTudvqBO",11) == 2901035988) strcat(s, "u");
if (crc32("vukokTXK",8) == 3932379449) strcat(s, "f");
if (crc32("iJdhPnqDCwv",11) == 2704043191) strcat(s, "l");
if (crc32("xehbHOfmZh",10) == 1796236466) strcat(s, "l");
if (crc32("RkhMSCJgq",9) == 2086997138) strcat(s, "N");
if (crc32("FsWTTfDqxlzcp",13) == 374588486) strcat(s, "y");
    return s;
}

char *subversively_adverbs() {
    char *s = calloc(13);
    if (crc32("QVOQjeWLVcF",11) == 2850962479) strcat(s, "n");
if (crc32("nhCeerjuAQsz",12) == 2993525722) strcat(s, "s");
if (crc32("omuIDxB",7) == 2189402335) strcat(s, "y");
if (crc32("yldFxeracHI",11) == 826886282) strcat(s, "u");
if (crc32("ZEhNFFvxCCRRFVL",15) == 4148876377) strcat(s, "K");
if (crc32("YAJSV",5) == 3189413823) strcat(s, "b");
if (crc32("fMZrgRCVyM",10) == 4020055831) strcat(s, "v");
if (crc32("HtntZF",6) == 158432874) strcat(s, "e");
if (crc32("kxCVHdYY",8) == 1628152578) strcat(s, "r");
if (crc32("BFgTluwP",8) == 3657191574) strcat(s, "s");
if (crc32("gIlsfBhZlhmN",12) == 2918728451) strcat(s, "i");
if (crc32("brhGNzZNKvkTg",13) == 3076905507) strcat(s, "z");
if (crc32("kiYfqnUT",8) == 4051610703) strcat(s, "v");
if (crc32("kCeNvRyF",8) == 1653888805) strcat(s, "e");
if (crc32("pNTqtQdJquLIl",13) == 3702196959) strcat(s, "l");
if (crc32("lUXfQSRf",8) == 2468508195) strcat(s, "u");
if (crc32("yfOUGTrbJO",10) == 4272027475) strcat(s, "y");
    return s;
}

char *Celtically_adverbs() {
    char *s = calloc(11);
    if (crc32("qDliopOEF",9) == 83039441) strcat(s, "s");
if (crc32("ynNjDxyX",8) == 1052609377) strcat(s, "C");
if (crc32("YFuiOMovSCYdmf",14) == 217127133) strcat(s, "e");
if (crc32("BJvhzlAGMcxzk",13) == 437963364) strcat(s, "y");
if (crc32("BnBoMHvNXtR",11) == 3023432044) strcat(s, "l");
if (crc32("kUOJSwWEof",10) == 1163518989) strcat(s, "t");
if (crc32("wpjqLDx",7) == 3175727482) strcat(s, "y");
if (crc32("UJvglChET",9) == 2390216171) strcat(s, "i");
if (crc32("eLKIjswxUQN",11) == 2556618795) strcat(s, "w");
if (crc32("ZqdLFZyYflP",11) == 2983245417) strcat(s, "c");
if (crc32("nXzLThqObWLde",13) == 828228979) strcat(s, "a");
if (crc32("xXPHGYbrQ",9) == 4254031247) strcat(s, "l");
if (crc32("MsDtR",5) == 2792279457) strcat(s, "l");
if (crc32("hrWnUZE",7) == 3911913679) strcat(s, "y");
if (crc32("YkQJkQTZxxj",11) == 2871271690) strcat(s, "y");
    return s;
}

char *quasiequivalently_adverbs() {
    char *s = calloc(18);
    if (crc32("fuqrVdIdTIxsli",14) == 546705413) strcat(s, "q");
if (crc32("rAWlhrJzgZi",11) == 3064214009) strcat(s, "w");
if (crc32("XDGasuxpbYZGx",13) == 2194625013) strcat(s, "u");
if (crc32("jdGVGf",6) == 570542784) strcat(s, "s");
if (crc32("zAQkGHxoFppE",12) == 1093052248) strcat(s, "a");
if (crc32("EOfwvEOWBk",10) == 2277219649) strcat(s, "W");
if (crc32("JyBZXYeY",8) == 4082478201) strcat(s, "s");
if (crc32("wijfG",5) == 1436624303) strcat(s, "i");
if (crc32("RTOunBo",7) == 1701856595) strcat(s, "e");
if (crc32("phdUvwGWc",9) == 3807408313) strcat(s, "q");
if (crc32("sMtERJvTfPsjUBv",15) == 3290975007) strcat(s, "Y");
if (crc32("ssgvnWq",7) == 950882985) strcat(s, "u");
if (crc32("QHVmUlhQiuk",11) == 867387844) strcat(s, "c");
if (crc32("KQDYrUL",7) == 3893855130) strcat(s, "i");
if (crc32("MFLzQAiqRZxzbSX",15) == 1113716507) strcat(s, "k");
if (crc32("opTkxaeWGbi",11) == 4052368404) strcat(s, "v");
if (crc32("jlLYdHnz",8) == 161018879) strcat(s, "V");
if (crc32("gJIILuqwPIY",11) == 1790781485) strcat(s, "a");
if (crc32("USmiheEM",8) == 2138867731) strcat(s, "l");
if (crc32("vfLOEOUbO",9) == 2988862570) strcat(s, "n");
if (crc32("AKHEYNdu",8) == 1493084243) strcat(s, "e");
if (crc32("UpgNGNlsiDXAlu",14) == 883912042) strcat(s, "n");
if (crc32("iBAIXfpuQ",9) == 3147918332) strcat(s, "t");
if (crc32("bwFcDZDKDe",10) == 3504906936) strcat(s, "l");
if (crc32("VCFVcHuWKqb",11) == 1730819803) strcat(s, "y");
    return s;
}

char *badgeringly_adverbs() {
    char *s = calloc(12);
    if (crc32("CFUyBPaO",8) == 3942360071) strcat(s, "Y");
if (crc32("CroViCKyboc",11) == 360284397) strcat(s, "b");
if (crc32("NljszFz",7) == 3456342277) strcat(s, "L");
if (crc32("wWbkgcuEOEAcd",13) == 624061824) strcat(s, "a");
if (crc32("djwlIwFNJFrVO",13) == 2082078130) strcat(s, "n");
if (crc32("LrymMZxrZbFIozb",15) == 141932470) strcat(s, "d");
if (crc32("sHRtNVhz",8) == 2385014558) strcat(s, "M");
if (crc32("OJEVmUA",7) == 2038559943) strcat(s, "g");
if (crc32("MKXVFYRAo",9) == 2307288717) strcat(s, "p");
if (crc32("FseIR",5) == 2195298521) strcat(s, "e");
if (crc32("befcxsEb",8) == 1851183890) strcat(s, "U");
if (crc32("LRTmoxfmTZQd",12) == 3603271965) strcat(s, "r");
if (crc32("zYMhSXWCXbgVEzt",15) == 1963423323) strcat(s, "i");
if (crc32("ObuDfzV",7) == 820801870) strcat(s, "Z");
if (crc32("JHWyWR",6) == 182912174) strcat(s, "n");
if (crc32("uGlGlHpJWASXP",13) == 3389149946) strcat(s, "z");
if (crc32("sxPlZkNqEJy",11) == 2550660477) strcat(s, "g");
if (crc32("XYpuhFt",7) == 299215904) strcat(s, "e");
if (crc32("XlxxMOMSk",9) == 3230740371) strcat(s, "l");
if (crc32("lhSYzvpLGvLsk",13) == 3386463148) strcat(s, "q");
if (crc32("yZuUTYKxge",10) == 947404048) strcat(s, "y");
    return s;
}

char *agly_adverbs() {
    char *s = calloc(5);
    if (crc32("IwhGeI",6) == 1319822503) strcat(s, "a");
if (crc32("EQXCxPHl",8) == 3235911517) strcat(s, "g");
if (crc32("gsqlI",5) == 3751836340) strcat(s, "X");
if (crc32("nOvJFgs",7) == 2910310877) strcat(s, "l");
if (crc32("jFKBwGhK",8) == 4148397329) strcat(s, "F");
if (crc32("zwWTyaaYCIm",11) == 1823176987) strcat(s, "y");
    return s;
}

char *unfervidly_adverbs() {
    char *s = calloc(11);
    if (crc32("IWhfaeGlD",9) == 3366573635) strcat(s, "u");
if (crc32("mGeKrSRbdfeGy",13) == 1849032607) strcat(s, "T");
if (crc32("EPrXhjckY",9) == 2683760406) strcat(s, "n");
if (crc32("OVlfKSRQd",9) == 1614230865) strcat(s, "x");
if (crc32("VYLwmxmFOSIh",12) == 2211171583) strcat(s, "f");
if (crc32("ZZMdAzitB",9) == 2260481117) strcat(s, "e");
if (crc32("texxZcoMPAaoyI",14) == 4072509868) strcat(s, "I");
if (crc32("TnaQWU",6) == 12621927) strcat(s, "r");
if (crc32("uwseCuXv",8) == 1688631127) strcat(s, "v");
if (crc32("LvylcpqdZw",10) == 2355173842) strcat(s, "Y");
if (crc32("qRXbHgNHhTDIzoS",15) == 2804008587) strcat(s, "i");
if (crc32("TFVgXoLXwrdTV",13) == 2161876560) strcat(s, "d");
if (crc32("votlkt",6) == 53128485) strcat(s, "l");
if (crc32("MKZHQmLMHZG",11) == 517307737) strcat(s, "y");
    return s;
}

char *continuingly_adverbs() {
    char *s = calloc(13);
    if (crc32("yIMam",5) == 3814407044) strcat(s, "c");
if (crc32("QIaxUwfOCQUH",12) == 1179706177) strcat(s, "y");
if (crc32("nisDnQZhl",9) == 704491925) strcat(s, "o");
if (crc32("VIUNunVBCwy",11) == 1306694797) strcat(s, "l");
if (crc32("OebBgeECEEAzCr",14) == 2118249301) strcat(s, "n");
if (crc32("iuMQwUZsFS",10) == 65296553) strcat(s, "t");
if (crc32("CzUSv",5) == 2675221433) strcat(s, "i");
if (crc32("camYTljbqsJpW",13) == 3409166959) strcat(s, "p");
if (crc32("WgPXoAIncnvdgF",14) == 105788823) strcat(s, "n");
if (crc32("MGKVHFyICusS",12) == 2353230346) strcat(s, "k");
if (crc32("piTcchEHVgNnDcN",15) == 3244922120) strcat(s, "u");
if (crc32("eKwhPLxJdosP",12) == 1986677382) strcat(s, "i");
if (crc32("dnVudwm",7) == 662315599) strcat(s, "n");
if (crc32("teeCmdkMQJMno",13) == 773510677) strcat(s, "p");
if (crc32("GUTPmlb",7) == 1827018696) strcat(s, "g");
if (crc32("SLFGWDvIGwoJB",13) == 490299766) strcat(s, "l");
if (crc32("XXlVVxX",7) == 2930752773) strcat(s, "a");
if (crc32("HQQfKecKwNJ",11) == 126386466) strcat(s, "y");
    return s;
}

char *overhonestly_adverbs() {
    char *s = calloc(13);
    if (crc32("PaXxFbc",7) == 748564218) strcat(s, "o");
if (crc32("KwZcZsRyiGH",11) == 2872475344) strcat(s, "F");
if (crc32("MrnQafUKP",9) == 2473875386) strcat(s, "v");
if (crc32("DhYLPHuWQlR",11) == 3917534828) strcat(s, "e");
if (crc32("gqxkwBygRy",10) == 863768434) strcat(s, "y");
if (crc32("mjaFifHcvvs",11) == 4084131047) strcat(s, "r");
if (crc32("mSmmkmz",7) == 2961852113) strcat(s, "f");
if (crc32("sQBGMYtU",8) == 811403377) strcat(s, "h");
if (crc32("mAOYorNKzVUaY",13) == 2312200265) strcat(s, "M");
if (crc32("afqqtUg",7) == 1054074760) strcat(s, "o");
if (crc32("nkKKekBnS",9) == 633686362) strcat(s, "m");
if (crc32("RkzLx",5) == 866258741) strcat(s, "n");
if (crc32("EqpQWBLInDIELi",14) == 2551146900) strcat(s, "K");
if (crc32("REArVfI",7) == 2256585414) strcat(s, "e");
if (crc32("KnbaUqnFaoCZ",12) == 1834651818) strcat(s, "P");
if (crc32("aHnRC",5) == 432083172) strcat(s, "s");
if (crc32("VAILgF",6) == 77503064) strcat(s, "u");
if (crc32("xFvpOq",6) == 3410364054) strcat(s, "t");
if (crc32("NUAzKaSsGytjUy",14) == 2616297736) strcat(s, "B");
if (crc32("pwqJURPzMoNKHu",14) == 3734212686) strcat(s, "l");
if (crc32("IDbkFXIRbLuy",12) == 3185069797) strcat(s, "y");
    return s;
}

char *entitatively_adverbs() {
    char *s = calloc(13);
    if (crc32("ENWReWCxY",9) == 1772755693) strcat(s, "e");
if (crc32("YNEBHHDBgRi",11) == 2345238105) strcat(s, "c");
if (crc32("LZXagA",6) == 3610293986) strcat(s, "n");
if (crc32("AHqDDKXnbXLpUVu",15) == 1734151620) strcat(s, "E");
if (crc32("GhCcpCtNsl",10) == 2938469242) strcat(s, "t");
if (crc32("oDpgwTal",8) == 3953334431) strcat(s, "g");
if (crc32("JJtGK",5) == 755404538) strcat(s, "i");
if (crc32("uDPDhk",6) == 333500805) strcat(s, "o");
if (crc32("gkjrwi",6) == 489637257) strcat(s, "t");
if (crc32("aOBjPZagXbrImyK",15) == 984690431) strcat(s, "f");
if (crc32("xoZaxHKQg",9) == 2064616545) strcat(s, "a");
if (crc32("puEKmsUl",8) == 2785102119) strcat(s, "X");
if (crc32("bkYbTc",6) == 3978739322) strcat(s, "t");
if (crc32("oqNNI",5) == 139560572) strcat(s, "F");
if (crc32("XtgEUGMRxoKDZ",13) == 3427350867) strcat(s, "i");
if (crc32("LluDz",5) == 1546564214) strcat(s, "v");
if (crc32("yTWoTN",6) == 4184314677) strcat(s, "d");
if (crc32("KFGjNxf",7) == 2233078763) strcat(s, "e");
if (crc32("SVZPOY",6) == 1826383919) strcat(s, "c");
if (crc32("IJLhHji",7) == 1415064275) strcat(s, "l");
if (crc32("bYllCrqvPR",10) == 2950352130) strcat(s, "R");
if (crc32("PiPKS",5) == 894187631) strcat(s, "y");
    return s;
}

char *subdistinctively_adverbs() {
    char *s = calloc(17);
    if (crc32("jNJmQhhQaF",10) == 2131105196) strcat(s, "s");
if (crc32("VoDbzz",6) == 893572142) strcat(s, "y");
if (crc32("lTshsqRj",8) == 408641119) strcat(s, "u");
if (crc32("ltRGIRmWDQ",10) == 1374919322) strcat(s, "b");
if (crc32("jOcNJhZfmyfngxH",15) == 1362450776) strcat(s, "d");
if (crc32("QbRpkGnpnv",10) == 3672559946) strcat(s, "S");
if (crc32("BeYaOFYAD",9) == 1692518368) strcat(s, "i");
if (crc32("yEjtnIYoexC",11) == 1605985981) strcat(s, "y");
if (crc32("QOxHzP",6) == 3255443946) strcat(s, "s");
if (crc32("tvtxSkFGCXJ",11) == 4089745077) strcat(s, "u");
if (crc32("vvFVBrsQQhaGp",13) == 225409178) strcat(s, "t");
if (crc32("TwPuZkwnHnzz",12) == 2483715164) strcat(s, "i");
if (crc32("DofpnXdSpsIQc",13) == 4114855175) strcat(s, "o");
if (crc32("DmPgPCYs",8) == 514615121) strcat(s, "n");
if (crc32("gPzKFDEFK",9) == 664258870) strcat(s, "W");
if (crc32("BigFllHZfE",10) == 1570674194) strcat(s, "c");
if (crc32("UioOFoOFmWiUn",13) == 3490586583) strcat(s, "t");
if (crc32("aMeirRqfzLUs",12) == 3976316186) strcat(s, "i");
if (crc32("FdOkjh",6) == 1610588082) strcat(s, "v");
if (crc32("avjyFMZ",7) == 1391383269) strcat(s, "o");
if (crc32("tgkkAAmvkk",10) == 1154784443) strcat(s, "e");
if (crc32("bDmMwAjFnxjC",12) == 419461195) strcat(s, "l");
if (crc32("CAmfcJ",6) == 5414974) strcat(s, "y");
    return s;
}

char *dadaistically_adverbs() {
    char *s = calloc(14);
    if (crc32("oVQcxjps",8) == 945092809) strcat(s, "d");
if (crc32("KsSegg",6) == 1753192432) strcat(s, "U");
if (crc32("ChScHrmTzk",10) == 3709595268) strcat(s, "a");
if (crc32("DoxKHRM",7) == 662417389) strcat(s, "g");
if (crc32("xdaHWYYJYdqW",12) == 141425366) strcat(s, "d");
if (crc32("RtnAmO",6) == 1615290492) strcat(s, "a");
if (crc32("fbLeYectYlhRI",13) == 3201374156) strcat(s, "U");
if (crc32("NmbjXQPsafo",11) == 3385898064) strcat(s, "i");
if (crc32("eMHalJcenqkS",12) == 1386312019) strcat(s, "s");
if (crc32("oBXiPDxrTnW",11) == 3245790486) strcat(s, "F");
if (crc32("HVSakDKunrH",11) == 2909093808) strcat(s, "t");
if (crc32("XbaFnLyqW",9) == 642125744) strcat(s, "i");
if (crc32("VgPniPCcFpEup",13) == 3686050486) strcat(s, "c");
if (crc32("YwZvLYTiTRgRM",13) == 1539217835) strcat(s, "a");
if (crc32("Feacr",5) == 2762462374) strcat(s, "l");
if (crc32("wqvsSIwHGWxGuF",14) == 9477873) strcat(s, "w");
if (crc32("flvyZh",6) == 635709315) strcat(s, "l");
if (crc32("XkEJEH",6) == 2603859870) strcat(s, "y");
    return s;
}

char *equivalently_adverbs() {
    char *s = calloc(13);
    if (crc32("HHOUALDSJvjoDp",14) == 4071519411) strcat(s, "e");
if (crc32("gNIvuBxtHJ",10) == 1435312410) strcat(s, "q");
if (crc32("iYOgMIbVnBoeR",13) == 1507411484) strcat(s, "P");
if (crc32("feuoJkKnGiSvIw",14) == 3507268233) strcat(s, "u");
if (crc32("UUkHDFeBLEwtlO",14) == 1362512147) strcat(s, "I");
if (crc32("MeUWGKBeZg",10) == 3027468738) strcat(s, "i");
if (crc32("sxqIoTWssKw",11) == 354993990) strcat(s, "p");
if (crc32("cdWvdPyKdFryKwh",15) == 3011791089) strcat(s, "v");
if (crc32("sHTSFq",6) == 381208680) strcat(s, "O");
if (crc32("zmWoreaKMJHmc",13) == 1759544127) strcat(s, "a");
if (crc32("bOkVV",5) == 2117426530) strcat(s, "E");
if (crc32("XbgMHDFGCOiAJS",14) == 384878641) strcat(s, "l");
if (crc32("ugfoJowZAzUM",12) == 4122527658) strcat(s, "e");
if (crc32("sIBdRr",6) == 394373045) strcat(s, "U");
if (crc32("kVuDZQItkJeR",12) == 1216660049) strcat(s, "n");
if (crc32("NQhsZKvvtEYQ",12) == 3702772048) strcat(s, "t");
if (crc32("luKNTxZJFYCB",12) == 2262506296) strcat(s, "l");
if (crc32("tpRDjtXYUxLvP",13) == 2058790416) strcat(s, "H");
if (crc32("WrUVlgImkk",10) == 2508856895) strcat(s, "y");
    return s;
}

char *impregnably_adverbs() {
    char *s = calloc(12);
    if (crc32("ycfgZU",6) == 1051912982) strcat(s, "M");
if (crc32("BJhPfBNDwJAQNSH",15) == 3585708372) strcat(s, "i");
if (crc32("BRNvQnuSePxUAp",14) == 4264875283) strcat(s, "m");
if (crc32("eUREktdg",8) == 2352597981) strcat(s, "x");
if (crc32("JFyXUVYFNoP",11) == 3310033770) strcat(s, "p");
if (crc32("VSXFFcSkPDjszIH",15) == 596709900) strcat(s, "C");
if (crc32("cPBprU",6) == 1683314037) strcat(s, "r");
if (crc32("KlMOlrsDAySQy",13) == 28933086) strcat(s, "W");
if (crc32("lCjEqMRlvL",10) == 3733795293) strcat(s, "e");
if (crc32("HGgQqctJq",9) == 3130351687) strcat(s, "g");
if (crc32("QdXyAeIA",8) == 3667722042) strcat(s, "n");
if (crc32("RsFYaVQylL",10) == 1305762792) strcat(s, "a");
if (crc32("TyPEwcPHP",9) == 1543381628) strcat(s, "a");
if (crc32("VsPvClIFeKyuJh",14) == 2275115125) strcat(s, "b");
if (crc32("rBfsBvOlVbBaq",13) == 4113824484) strcat(s, "l");
if (crc32("pvrKxuG",7) == 2204822898) strcat(s, "y");
    return s;
}

char *noninfallibly_adverbs() {
    char *s = calloc(14);
    if (crc32("tRjXIpgHje",10) == 2982697381) strcat(s, "Z");
if (crc32("NomTmjEOfMJalHz",15) == 1716094564) strcat(s, "n");
if (crc32("aTSldlGpao",10) == 4035644172) strcat(s, "j");
if (crc32("elqzVagl",8) == 199774295) strcat(s, "o");
if (crc32("yeCnQmwkLeFRRUk",15) == 4085752225) strcat(s, "d");
if (crc32("guWfmpoF",8) == 3871532966) strcat(s, "n");
if (crc32("fkpENcrfETNRF",13) == 708277229) strcat(s, "i");
if (crc32("hyyCWasDmFwJFr",14) == 4105930383) strcat(s, "h");
if (crc32("uLHbgNiwvsB",11) == 1120216239) strcat(s, "n");
if (crc32("iOYynfRN",8) == 993128345) strcat(s, "Q");
if (crc32("HuHMNMIk",8) == 2586873925) strcat(s, "f");
if (crc32("nzwvm",5) == 925751529) strcat(s, "m");
if (crc32("aQUFolBLgd",10) == 252015644) strcat(s, "a");
if (crc32("ORVTjA",6) == 369467784) strcat(s, "l");
if (crc32("ZIQGtkszqYIuTfl",15) == 2793734479) strcat(s, "l");
if (crc32("AnPMf",5) == 3095004544) strcat(s, "L");
if (crc32("VphhnRwRVFqAhZ",14) == 2025843343) strcat(s, "i");
if (crc32("KRlQPjTxhQbA",12) == 1436934773) strcat(s, "b");
if (crc32("kYwsMgySWq",10) == 1960965579) strcat(s, "u");
if (crc32("jciQIG",6) == 611081331) strcat(s, "l");
if (crc32("DOjLJUvQ",8) == 3037553802) strcat(s, "y");
    return s;
}

char *behindhand_adverbs() {
    char *s = calloc(11);
    if (crc32("MJlrSi",6) == 719872883) strcat(s, "Q");
if (crc32("EjiCMKcW",8) == 3042927282) strcat(s, "b");
if (crc32("QvCvSxvBViP",11) == 241455009) strcat(s, "u");
if (crc32("LBpSOjd",7) == 3526805254) strcat(s, "e");
if (crc32("KBCrHkHFQNuHg",13) == 3245567275) strcat(s, "E");
if (crc32("ZFZELgOXFMIZMW",14) == 1513251298) strcat(s, "h");
if (crc32("MgCvLhL",7) == 1468576076) strcat(s, "i");
if (crc32("eqhXPrPrtfT",11) == 2872901416) strcat(s, "x");
if (crc32("fvgECbSjxukyqE",14) == 3871466050) strcat(s, "n");
if (crc32("VdOcLK",6) == 864239303) strcat(s, "d");
if (crc32("UUGuSMijz",9) == 4203838930) strcat(s, "a");
if (crc32("TsYDX",5) == 3774076828) strcat(s, "h");
if (crc32("PNKvq",5) == 4290242874) strcat(s, "q");
if (crc32("XfvBLgWvIRfZ",12) == 2499246579) strcat(s, "a");
if (crc32("dPqGOlOFPUTJZnv",15) == 506365192) strcat(s, "n");
if (crc32("khuQeDZyBvZdqN",14) == 3190264603) strcat(s, "K");
if (crc32("iPlKhXQD",8) == 2540331599) strcat(s, "d");
    return s;
}

char *opinionatively_adverbs() {
    char *s = calloc(15);
    if (crc32("orBniMT",7) == 543895703) strcat(s, "C");
if (crc32("nhKNsanNx",9) == 1300089055) strcat(s, "o");
if (crc32("xdaYwHkgAFLAu",13) == 2300048276) strcat(s, "p");
if (crc32("EvHqd",5) == 437776106) strcat(s, "i");
if (crc32("ymiKnNiLj",9) == 1630714129) strcat(s, "n");
if (crc32("qyGFqYOwKR",10) == 1407097759) strcat(s, "i");
if (crc32("VlMDjvp",7) == 2053799674) strcat(s, "o");
if (crc32("WtnbaifZ",8) == 258833817) strcat(s, "l");
if (crc32("VWvXyrwnNRrbqUJ",15) == 2094649488) strcat(s, "n");
if (crc32("alaXamuYPCK",11) == 3030892370) strcat(s, "a");
if (crc32("tncKABeePfzelX",14) == 1943774413) strcat(s, "A");
if (crc32("RtnDF",5) == 693097715) strcat(s, "t");
if (crc32("jqBDBWAVuUk",11) == 534477887) strcat(s, "l");
if (crc32("PSEFCOi",7) == 731653607) strcat(s, "i");
if (crc32("FkVQbHPoJtFJcu",14) == 232021189) strcat(s, "T");
if (crc32("YPZAegVCxXpaFsz",15) == 2701487732) strcat(s, "v");
if (crc32("JOcFygoJxqj",11) == 4171682151) strcat(s, "e");
if (crc32("JpyeOHe",7) == 4038190880) strcat(s, "l");
if (crc32("TJdnLRRaftBed",13) == 3088278383) strcat(s, "y");
    return s;
}

char *ruggedly_adverbs() {
    char *s = calloc(9);
    if (crc32("mRgRCPPwZhOB",12) == 2244813936) strcat(s, "m");
if (crc32("AXozcNlmdgwGiiP",15) == 1357408813) strcat(s, "r");
if (crc32("VkzHrwbHVIugJF",14) == 3448665532) strcat(s, "u");
if (crc32("hwIWAIqqGzinQ",13) == 3330557357) strcat(s, "g");
if (crc32("XNDsJennRFWjXj",14) == 2541884591) strcat(s, "D");
if (crc32("bKTGIN",6) == 1522073025) strcat(s, "g");
if (crc32("UiARvsZgnhUyPUB",15) == 4144035938) strcat(s, "R");
if (crc32("erlawkeLvcT",11) == 2817047369) strcat(s, "e");
if (crc32("cZYPMb",6) == 1909675161) strcat(s, "d");
if (crc32("csJnf",5) == 1134067616) strcat(s, "l");
if (crc32("yYyqrSEer",9) == 771859894) strcat(s, "D");
if (crc32("RIbVXpBLd",9) == 1288751822) strcat(s, "y");
    return s;
}

char *unsententiously_adverbs() {
    char *s = calloc(16);
    if (crc32("NXYsX",5) == 764924084) strcat(s, "u");
if (crc32("FBuoE",5) == 2523243150) strcat(s, "n");
if (crc32("bxhhIHxVBpu",11) == 2705237737) strcat(s, "S");
if (crc32("hPJtXWHfl",9) == 1942957839) strcat(s, "s");
if (crc32("gYtMAMFaiStNmJD",15) == 1191062851) strcat(s, "e");
if (crc32("xDAWB",5) == 126263201) strcat(s, "n");
if (crc32("qBfaJBAF",8) == 1574560667) strcat(s, "t");
if (crc32("DaSatm",6) == 3540273302) strcat(s, "O");
if (crc32("gvnTMRJCF",9) == 2340393) strcat(s, "e");
if (crc32("nfsnWi",6) == 3870386159) strcat(s, "r");
if (crc32("xonJOkcmRAG",11) == 2319077719) strcat(s, "n");
if (crc32("gZqAanQhBhQlo",13) == 2928298302) strcat(s, "t");
if (crc32("gWteO",5) == 385574964) strcat(s, "i");
if (crc32("XjKTtWSxVQFRKWp",15) == 1679413212) strcat(s, "o");
if (crc32("ROowIMj",7) == 2719059545) strcat(s, "p");
if (crc32("zVRIMeSsgFZes",13) == 326735159) strcat(s, "u");
if (crc32("OvMNWYrTEcOErI",14) == 1821073273) strcat(s, "s");
if (crc32("yYUvmPDYWDTCI",13) == 1795735811) strcat(s, "I");
if (crc32("jKBqTxUHgbN",11) == 985134078) strcat(s, "l");
if (crc32("nYQxRy",6) == 1043907922) strcat(s, "y");
    return s;
}

char *galvanometrically_adverbs() {
    char *s = calloc(18);
    if (crc32("ebryr",5) == 2388856860) strcat(s, "f");
if (crc32("WzwyFfe",7) == 4127874477) strcat(s, "g");
if (crc32("wKCnatDsryAz",12) == 3942932776) strcat(s, "C");
if (crc32("mSLdfkxXkUsbEB",14) == 1396551832) strcat(s, "a");
if (crc32("JCQXDWFng",9) == 3105688789) strcat(s, "C");
if (crc32("IVxhHuYRU",9) == 4174546044) strcat(s, "l");
if (crc32("Qljbjw",6) == 3177763231) strcat(s, "O");
if (crc32("WZQYz",5) == 1584804280) strcat(s, "v");
if (crc32("vEWXgDQDWa",10) == 2968424451) strcat(s, "a");
if (crc32("rceExGQyQCjQht",14) == 3997721663) strcat(s, "Y");
if (crc32("WCmgzzDVsq",10) == 472788410) strcat(s, "n");
if (crc32("vfziqbtrvJl",11) == 1442479599) strcat(s, "h");
if (crc32("SvBBlgDozrUsDz",14) == 1179050915) strcat(s, "o");
if (crc32("xeDsNlyetHzSV",13) == 1957024757) strcat(s, "v");
if (crc32("wANPPIEEg",9) == 2042668798) strcat(s, "m");
if (crc32("FDClxucnuKRRuI",14) == 4114100238) strcat(s, "e");
if (crc32("kGlIlWq",7) == 795592755) strcat(s, "t");
if (crc32("PtCiHFtxRb",10) == 2546436354) strcat(s, "c");
if (crc32("IYGvqGSPxyLpm",13) == 4034983935) strcat(s, "r");
if (crc32("khlSY",5) == 2105735018) strcat(s, "U");
if (crc32("JMzPekiQE",9) == 73296899) strcat(s, "i");
if (crc32("aPhdnElz",8) == 179907548) strcat(s, "Y");
if (crc32("ouZcB",5) == 914945169) strcat(s, "c");
if (crc32("lmkWZwPoXJsYb",13) == 4242264038) strcat(s, "a");
if (crc32("BggKqJx",7) == 3013459092) strcat(s, "M");
if (crc32("kPQPMW",6) == 1144464025) strcat(s, "l");
if (crc32("QCVWXc",6) == 1208997789) strcat(s, "l");
if (crc32("PNSCWssxkodpTXx",15) == 3928130733) strcat(s, "y");
    return s;
}

char *nonspeciously_adverbs() {
    char *s = calloc(14);
    if (crc32("oasGNSNilqEdyf",14) == 1718700495) strcat(s, "v");
if (crc32("NMSvNCtUg",9) == 2751957612) strcat(s, "n");
if (crc32("purtFEJNl",9) == 903119954) strcat(s, "o");
if (crc32("ZCKTvkqTsP",10) == 3320003993) strcat(s, "I");
if (crc32("vGRmjjFzkRwBv",13) == 4112551682) strcat(s, "n");
if (crc32("JjfBboAtQXWFwsR",15) == 517905507) strcat(s, "s");
if (crc32("dNZYxU",6) == 4267615931) strcat(s, "p");
if (crc32("HUDcvOAEHyt",11) == 84040512) strcat(s, "U");
if (crc32("LgmrFcvnjt",10) == 2900614355) strcat(s, "e");
if (crc32("NeYuMCTnXJ",10) == 3929818122) strcat(s, "b");
if (crc32("qbpuctK",7) == 3618655042) strcat(s, "c");
if (crc32("HEhnfgSVuQjg",12) == 2763216100) strcat(s, "i");
if (crc32("DGymWAO",7) == 1678312400) strcat(s, "o");
if (crc32("KsekmJCgyEDIQ",13) == 1766820896) strcat(s, "u");
if (crc32("nXkuZaLxE",9) == 3184869737) strcat(s, "s");
if (crc32("uqaqnqGODlAMz",13) == 1286873865) strcat(s, "s");
if (crc32("yRbsuEIFRMYGpvw",15) == 3783249867) strcat(s, "l");
if (crc32("DTKxiNXaNb",10) == 1994441024) strcat(s, "h");
if (crc32("rJTmEfrwfUsd",12) == 610547229) strcat(s, "y");
    return s;
}

char *understandingly_adverbs() {
    char *s = calloc(16);
    if (crc32("aTAGZFMF",8) == 387835692) strcat(s, "u");
if (crc32("qLWVQ",5) == 1244428898) strcat(s, "u");
if (crc32("UcZdc",5) == 4290629684) strcat(s, "l");
if (crc32("eZPCyNxULOOcLZA",15) == 4162518095) strcat(s, "n");
if (crc32("dCNct",5) == 703547024) strcat(s, "Y");
if (crc32("TkLwA",5) == 4289922183) strcat(s, "d");
if (crc32("OeFMJzWxPOEjeH",14) == 613668882) strcat(s, "e");
if (crc32("eyUDEIjIwzHZPS",14) == 708804411) strcat(s, "R");
if (crc32("aGwCbGsSGm",10) == 2156850991) strcat(s, "r");
if (crc32("DxpmRSK",7) == 1663608287) strcat(s, "V");
if (crc32("ZJlEh",5) == 3481466944) strcat(s, "s");
if (crc32("lHKMDmOVrib",11) == 61304945) strcat(s, "h");
if (crc32("iDHesYEsHlDTsA",14) == 593085974) strcat(s, "t");
if (crc32("IfbfYnmFTJQ",11) == 3636348308) strcat(s, "h");
if (crc32("wKSFgWXHZ",9) == 1635377403) strcat(s, "a");
if (crc32("AwFECUlZMLu",11) == 1897023269) strcat(s, "n");
if (crc32("PmKJfQHOXU",10) == 4108697205) strcat(s, "d");
if (crc32("MIZhWEs",7) == 2803213762) strcat(s, "j");
if (crc32("YCfDiAtgZbreGHc",15) == 1991153240) strcat(s, "i");
if (crc32("MyZuzpsvuLJIPyh",15) == 66331957) strcat(s, "r");
if (crc32("abJzjRsY",8) == 1441652024) strcat(s, "n");
if (crc32("IVcRET",6) == 2305117426) strcat(s, "g");
if (crc32("HgTPAeh",7) == 2423438277) strcat(s, "Q");
if (crc32("qiiFHBEc",8) == 2545227508) strcat(s, "l");
if (crc32("YcusrwMKDnPsoD",14) == 2551587019) strcat(s, "P");
if (crc32("sRmnLH",6) == 3513336376) strcat(s, "y");
    return s;
}

char *psychophysiologically_adverbs() {
    char *s = calloc(22);
    if (crc32("zNxNwZJb",8) == 438244376) strcat(s, "B");
if (crc32("sqnuPvv",7) == 1456371431) strcat(s, "p");
if (crc32("uBLXTTiP",8) == 3530683731) strcat(s, "s");
if (crc32("OnRQovddReu",11) == 1099748192) strcat(s, "f");
if (crc32("oSVjVtHDJzuL",12) == 4176731680) strcat(s, "y");
if (crc32("YdangsL",7) == 4044298928) strcat(s, "c");
if (crc32("VtVTUs",6) == 3964949443) strcat(s, "h");
if (crc32("qDjrbcIFpr",10) == 1969282665) strcat(s, "d");
if (crc32("LotnOPjTaIMDQ",13) == 2918273785) strcat(s, "o");
if (crc32("OiUxCWS",7) == 2716766769) strcat(s, "y");
if (crc32("tckYVUOu",8) == 1942564356) strcat(s, "p");
if (crc32("HqbyIkkbdlRqTJk",15) == 2427140026) strcat(s, "h");
if (crc32("cGmCHbwdELQLwD",14) == 1224220832) strcat(s, "h");
if (crc32("GTrhg",5) == 1092174555) strcat(s, "y");
if (crc32("RMgudWCoueLqij",14) == 3179762854) strcat(s, "s");
if (crc32("pmRgWcbILue",11) == 1289378074) strcat(s, "i");
if (crc32("PKWqOa",6) == 3704813428) strcat(s, "o");
if (crc32("cOwyAcS",7) == 1225997739) strcat(s, "l");
if (crc32("YCkiCfvfwWOyD",13) == 3518839162) strcat(s, "o");
if (crc32("xTmWjtulzSil",12) == 3927985636) strcat(s, "X");
if (crc32("mGTQxmrQxJeMYqg",15) == 3408683048) strcat(s, "g");
if (crc32("EpsnKucN",8) == 2182632700) strcat(s, "i");
if (crc32("IkvetnUGq",9) == 3957249259) strcat(s, "c");
if (crc32("xrlls",5) == 2403271277) strcat(s, "a");
if (crc32("TzUyZQdcHaFTLE",14) == 2735292259) strcat(s, "l");
if (crc32("okPPAZfbHM",10) == 1197032950) strcat(s, "K");
if (crc32("ZcPOuYVAX",9) == 3776901895) strcat(s, "l");
if (crc32("ONsYAlAsMNz",11) == 171464566) strcat(s, "y");
    return s;
}

char *tetchily_adverbs() {
    char *s = calloc(9);
    if (crc32("ghDbW",5) == 3337972674) strcat(s, "t");
if (crc32("midySCoEwl",10) == 3408172283) strcat(s, "A");
if (crc32("xlMSDonaGRjzlp",14) == 3946950484) strcat(s, "e");
if (crc32("GNqGBLXQIjH",11) == 2558863547) strcat(s, "t");
if (crc32("JqrICtWZYmpL",12) == 2003544647) strcat(s, "o");
if (crc32("mzKmjqqaNtg",11) == 1284778791) strcat(s, "c");
if (crc32("fAdizap",7) == 3007223344) strcat(s, "B");
if (crc32("HvNpZCIoGUF",11) == 1395798075) strcat(s, "h");
if (crc32("uPCABZz",7) == 3438872854) strcat(s, "m");
if (crc32("ivUwzmPv",8) == 1977595301) strcat(s, "i");
if (crc32("kkdOsYFA",8) == 277241584) strcat(s, "p");
if (crc32("jxKToIDwfdsn",12) == 1281181388) strcat(s, "l");
if (crc32("HfqrFXWgcUt",11) == 3819504639) strcat(s, "y");
    return s;
}

char *demonologically_adverbs() {
    char *s = calloc(16);
    if (crc32("nGEuPytaokyIW",13) == 3474319147) strcat(s, "i");
if (crc32("vBclVUIRyhYgJ",13) == 2449709560) strcat(s, "d");
if (crc32("jdrNAeFmo",9) == 1808141726) strcat(s, "F");
if (crc32("wzFVawxGGmjds",13) == 40678090) strcat(s, "e");
if (crc32("DrKBv",5) == 2910976556) strcat(s, "m");
if (crc32("ABfJzOQB",8) == 3680047945) strcat(s, "o");
if (crc32("goUioW",6) == 2868584260) strcat(s, "e");
if (crc32("ZegTHQUJl",9) == 2141672699) strcat(s, "n");
if (crc32("gMfhMsWhehUquGY",15) == 965272560) strcat(s, "d");
if (crc32("trelEnKDkxrU",12) == 3046843040) strcat(s, "o");
if (crc32("uWsYTe",6) == 2583050688) strcat(s, "l");
if (crc32("tQVbhVF",7) == 1367306520) strcat(s, "o");
if (crc32("EosAByrg",8) == 2568318902) strcat(s, "i");
if (crc32("ESFaRxhUzzEFor",14) == 4159980134) strcat(s, "g");
if (crc32("XSPFgT",6) == 1701107307) strcat(s, "B");
if (crc32("XCNiWzXNElBbN",13) == 3897889912) strcat(s, "i");
if (crc32("NcPqtS",6) == 2626272064) strcat(s, "j");
if (crc32("ptxPdGxHrWxueM",14) == 1363194455) strcat(s, "c");
if (crc32("mkzPVRTpcAqo",12) == 2909010931) strcat(s, "F");
if (crc32("otxUkpqTsE",10) == 1090660494) strcat(s, "a");
if (crc32("IyUhFbfY",8) == 188549953) strcat(s, "l");
if (crc32("wmLNiGnCnupMDJ",14) == 2478773238) strcat(s, "l");
if (crc32("VGGsefzFT",9) == 350163764) strcat(s, "y");
    return s;
}

char *overanalytically_adverbs() {
    char *s = calloc(17);
    if (crc32("YIyUQwSI",8) == 3514709605) strcat(s, "Q");
if (crc32("moDzwDsBKbWjn",13) == 3749040810) strcat(s, "o");
if (crc32("KZUne",5) == 1704830213) strcat(s, "q");
if (crc32("XrHJyq",6) == 677339975) strcat(s, "v");
if (crc32("ZmWgHM",6) == 1459235664) strcat(s, "e");
if (crc32("Glxmeh",6) == 1245358003) strcat(s, "r");
if (crc32("axCdoIJflMXB",12) == 4221913871) strcat(s, "B");
if (crc32("lMcfDFevfzQ",11) == 3661813172) strcat(s, "a");
if (crc32("gMescmeUzwRVOme",15) == 324724462) strcat(s, "u");
if (crc32("RhOejnpOdYMAc",13) == 3152342242) strcat(s, "n");
if (crc32("lzxJRErUsmGyJ",13) == 3897283047) strcat(s, "a");
if (crc32("zeVaXK",6) == 2125908244) strcat(s, "l");
if (crc32("jwfPHwWU",8) == 3636750691) strcat(s, "f");
if (crc32("ZlBjAwzmrGX",11) == 2290773886) strcat(s, "y");
if (crc32("xxcrRPJM",8) == 1788383423) strcat(s, "r");
if (crc32("BeAAOcdnWyiYanu",15) == 3086948140) strcat(s, "t");
if (crc32("Dmwtfi",6) == 3083640345) strcat(s, "X");
if (crc32("ARqYN",5) == 1838926112) strcat(s, "i");
if (crc32("vKsTwZT",7) == 681635737) strcat(s, "v");
if (crc32("jhexRJ",6) == 4184938642) strcat(s, "c");
if (crc32("pCtDMUinLrKPlYW",15) == 1748255068) strcat(s, "L");
if (crc32("vYsmjzKFAAc",11) == 3799200832) strcat(s, "a");
if (crc32("teMiqieIueu",11) == 1245633028) strcat(s, "l");
if (crc32("lEkrXsGjNJmr",12) == 4106359680) strcat(s, "l");
if (crc32("ZsCsPcyT",8) == 3253522849) strcat(s, "E");
if (crc32("wOYXl",5) == 464284857) strcat(s, "y");
    return s;
}

char *nonhereditably_adverbs() {
    char *s = calloc(15);
    if (crc32("SqkGRWmJ",8) == 3549031339) strcat(s, "X");
if (crc32("hwgUdazUrjDIhQ",14) == 1827612302) strcat(s, "n");
if (crc32("GisuXRYgkFbcyjH",15) == 970974764) strcat(s, "B");
if (crc32("UZslGYaL",8) == 1209488375) strcat(s, "o");
if (crc32("dofktlmdjU",10) == 266846415) strcat(s, "x");
if (crc32("OLEzeCKGS",9) == 3430731744) strcat(s, "n");
if (crc32("TcZFrcPCFCzKV",13) == 96456237) strcat(s, "l");
if (crc32("bKOTXTo",7) == 459519201) strcat(s, "h");
if (crc32("DRsPZUbojJ",10) == 2938907268) strcat(s, "e");
if (crc32("PcNJnkinK",9) == 3421943122) strcat(s, "p");
if (crc32("giVUBBvxNjWCNo",14) == 3318802021) strcat(s, "r");
if (crc32("UMRSOqBZmIvAgWT",15) == 2506935391) strcat(s, "e");
if (crc32("KMYdCLKvTZM",11) == 1472236354) strcat(s, "b");
if (crc32("tLUkGPaUSNYWX",13) == 162986594) strcat(s, "d");
if (crc32("JIQNIfqtSHGKQr",14) == 3385455534) strcat(s, "p");
if (crc32("SHqrMumEUMAUi",13) == 631611066) strcat(s, "i");
if (crc32("gyAtXtz",7) == 1858621537) strcat(s, "S");
if (crc32("sGYeQOeu",8) == 2358254468) strcat(s, "t");
if (crc32("aYMrGJnp",8) == 3992146314) strcat(s, "I");
if (crc32("dYAshcTOk",9) == 2227184734) strcat(s, "a");
if (crc32("CTDcTLJz",8) == 3068079517) strcat(s, "m");
if (crc32("rjuSHsqTWhUfOa",14) == 93607357) strcat(s, "b");
if (crc32("mrowzmdCZs",10) == 3328727072) strcat(s, "V");
if (crc32("NxPyYL",6) == 3373061738) strcat(s, "l");
if (crc32("TRzAerYmnIZvQy",14) == 3813974765) strcat(s, "F");
if (crc32("ZbpgBxxSXJk",11) == 2561608351) strcat(s, "y");
    return s;
}

char *nonorthographically_adverbs() {
    char *s = calloc(20);
    if (crc32("EllCuBTkMrpR",12) == 2140625829) strcat(s, "n");
if (crc32("pPLilhXxW",9) == 456155634) strcat(s, "A");
if (crc32("sCbmTGRnbVOrm",13) == 2971428596) strcat(s, "o");
if (crc32("foJnwLGd",8) == 4229315197) strcat(s, "n");
if (crc32("LwubWjZkRjXm",12) == 1282941359) strcat(s, "S");
if (crc32("XPtoL",5) == 3418081002) strcat(s, "o");
if (crc32("uPukLucVpAE",11) == 640018048) strcat(s, "h");
if (crc32("rRXpUZvlWHI",11) == 2419837452) strcat(s, "r");
if (crc32("Ljtjqzzsq",9) == 2307272960) strcat(s, "V");
if (crc32("FOxMkWhO",8) == 2970810206) strcat(s, "t");
if (crc32("dwPExerkXGgE",12) == 2538815381) strcat(s, "U");
if (crc32("TIHOzR",6) == 116247281) strcat(s, "h");
if (crc32("wxEph",5) == 962370566) strcat(s, "o");
if (crc32("bwoypWmt",8) == 3845670470) strcat(s, "o");
if (crc32("yUhuLsXV",8) == 89809755) strcat(s, "g");
if (crc32("SpPfecHs",8) == 4292535998) strcat(s, "r");
if (crc32("TbvZhibE",8) == 4015445334) strcat(s, "a");
if (crc32("aVhxOKHh",8) == 3490874325) strcat(s, "p");
if (crc32("MVbgsUZjuzd",11) == 2367218) strcat(s, "h");
if (crc32("rvGgR",5) == 3705227925) strcat(s, "Y");
if (crc32("zrKAzHlJUfjmBsp",15) == 1299091286) strcat(s, "i");
if (crc32("DWTSNXevfL",10) == 2361512026) strcat(s, "c");
if (crc32("HKOhgoZcNMkA",12) == 209338478) strcat(s, "q");
if (crc32("PVjiPam",7) == 3533399029) strcat(s, "a");
if (crc32("LVDvf",5) == 526396714) strcat(s, "l");
if (crc32("xYGcxSCfuxlXVZD",15) == 2339222786) strcat(s, "S");
if (crc32("Ensiwe",6) == 2877257323) strcat(s, "l");
if (crc32("DNNDYgZWYxEL",12) == 3595850441) strcat(s, "a");
if (crc32("wGGvNulgMWudbU",14) == 1503253005) strcat(s, "y");
    return s;
}

char *unmercifully_adverbs() {
    char *s = calloc(13);
    if (crc32("UseTDHW",7) == 3468042895) strcat(s, "u");
if (crc32("UYVUbgKLWYJdKz",14) == 5101070) strcat(s, "n");
if (crc32("okjGauHCri",10) == 3648176235) strcat(s, "T");
if (crc32("QZsvqsSeN",9) == 487665518) strcat(s, "m");
if (crc32("NMNlj",5) == 1555391569) strcat(s, "v");
if (crc32("cCLdgFGLqi",10) == 2160410867) strcat(s, "e");
if (crc32("CHjmWeVXluJt",12) == 505556777) strcat(s, "p");
if (crc32("ZQeaBlgcThJmU",13) == 3067529992) strcat(s, "r");
if (crc32("Bqshmd",6) == 454529501) strcat(s, "Q");
if (crc32("SLzcHqPhRawY",12) == 664025960) strcat(s, "c");
if (crc32("iVxjtfD",7) == 711397995) strcat(s, "h");
if (crc32("trhvvNRXNaDaLzY",15) == 3294918779) strcat(s, "i");
if (crc32("PCwvmOoQaJhFdWW",15) == 1574004742) strcat(s, "f");
if (crc32("sBjtWd",6) == 2785111260) strcat(s, "u");
if (crc32("AiTyro",6) == 874754701) strcat(s, "f");
if (crc32("EKefJnI",7) == 674011366) strcat(s, "l");
if (crc32("ZGeETNmDql",10) == 3310626807) strcat(s, "l");
if (crc32("mwvaPhVbwmdroD",14) == 2711172082) strcat(s, "y");
    return s;
}

char *hereinto_adverbs() {
    char *s = calloc(9);
    if (crc32("wclhqYCWcmUiWl",14) == 2667875308) strcat(s, "D");
if (crc32("GySLZZzTR",9) == 1367716932) strcat(s, "h");
if (crc32("opALCTWnUrqSbY",14) == 1067430427) strcat(s, "e");
if (crc32("rGZoLiSfe",9) == 3258955428) strcat(s, "R");
if (crc32("tZYawalGLvqqjNv",15) == 942220937) strcat(s, "r");
if (crc32("VnamBbWvTS",10) == 3506747755) strcat(s, "M");
if (crc32("GRiVR",5) == 1668779720) strcat(s, "e");
if (crc32("DMAIhNC",7) == 2948410559) strcat(s, "f");
if (crc32("XSQKN",5) == 4167986565) strcat(s, "i");
if (crc32("JtekrOepxb",10) == 2496707139) strcat(s, "s");
if (crc32("JHhWq",5) == 519952262) strcat(s, "n");
if (crc32("fdlNJ",5) == 3710578149) strcat(s, "t");
if (crc32("ciaBmU",6) == 2421600306) strcat(s, "o");
    return s;
}

char *rumblingly_adverbs() {
    char *s = calloc(11);
    if (crc32("bpoUWAEPCMZbwY",14) == 836727104) strcat(s, "r");
if (crc32("VrmuhgWmBNnxQT",14) == 3884305790) strcat(s, "F");
if (crc32("bjPyombXifaShL",14) == 941863357) strcat(s, "u");
if (crc32("PWyCTNhNbiBo",12) == 4097819450) strcat(s, "m");
if (crc32("IVLKOydfBUOkY",13) == 584980390) strcat(s, "F");
if (crc32("fZdOFPv",7) == 1076473) strcat(s, "b");
if (crc32("gdTVBPjCj",9) == 1571466801) strcat(s, "l");
if (crc32("YPxZTdN",7) == 2986179453) strcat(s, "i");
if (crc32("wPELjsbKi",9) == 2415716703) strcat(s, "n");
if (crc32("gxIOFy",6) == 2482828730) strcat(s, "b");
if (crc32("qjfCLgAooZfG",12) == 2073249280) strcat(s, "g");
if (crc32("HTVhLQCYehZE",12) == 2649555397) strcat(s, "l");
if (crc32("pmIfGaZ",7) == 206436479) strcat(s, "y");
    return s;
}

char *nongeometrically_adverbs() {
    char *s = calloc(17);
    if (crc32("UuEra",5) == 1004397209) strcat(s, "n");
if (crc32("xephCV",6) == 2091556688) strcat(s, "b");
if (crc32("PzOwi",5) == 3580199966) strcat(s, "o");
if (crc32("UxwkgfPewVSIq",13) == 3472158449) strcat(s, "t");
if (crc32("rWAbdedHIsOh",12) == 321273030) strcat(s, "n");
if (crc32("ScSzJrglNnVj",12) == 1010158483) strcat(s, "g");
if (crc32("hcvIgMIdgjDq",12) == 2904292620) strcat(s, "H");
if (crc32("OzlVjvEJj",9) == 354325) strcat(s, "e");
if (crc32("DfKXNlWSBpTV",12) == 2014045903) strcat(s, "o");
if (crc32("AjcVKcbvi",9) == 246033276) strcat(s, "m");
if (crc32("LwBvnck",7) == 2994630653) strcat(s, "e");
if (crc32("JCeLsift",8) == 937804752) strcat(s, "t");
if (crc32("AseuiYAe",8) == 3311886559) strcat(s, "r");
if (crc32("yMdGVqnI",8) == 350190319) strcat(s, "w");
if (crc32("fRxXViJxbhIHzFY",15) == 1010652152) strcat(s, "i");
if (crc32("XGrpEojBGkWO",12) == 2060022982) strcat(s, "c");
if (crc32("MmwaikocrwnjR",13) == 151995952) strcat(s, "a");
if (crc32("wqYdKi",6) == 3178182979) strcat(s, "l");
if (crc32("OCFygkuRauEFBX",14) == 2897199269) strcat(s, "l");
if (crc32("cKoslyoymD",10) == 1134910216) strcat(s, "y");
    return s;
}

char *lamentedly_adverbs() {
    char *s = calloc(11);
    if (crc32("PATxQZHtSY",10) == 2794766763) strcat(s, "l");
if (crc32("WfmWtQ",6) == 1234907467) strcat(s, "O");
if (crc32("CoTtmgvGGU",10) == 3696639169) strcat(s, "a");
if (crc32("TXutucp",7) == 1458444248) strcat(s, "v");
if (crc32("sGxXUfnYpD",10) == 2275632911) strcat(s, "m");
if (crc32("iKgSfSUkEV",10) == 1290095890) strcat(s, "e");
if (crc32("ARpHFYKRa",9) == 2562805379) strcat(s, "n");
if (crc32("utnCtJZyxFON",12) == 2242547648) strcat(s, "K");
if (crc32("nYWmGIyoAEzSz",13) == 2451933740) strcat(s, "t");
if (crc32("vcaVyEnGhZZVII",14) == 4252629793) strcat(s, "e");
if (crc32("mzJNAqiq",8) == 3420515567) strcat(s, "u");
if (crc32("eQZBKdLCousFY",13) == 478763053) strcat(s, "d");
if (crc32("VjaxmxNOUPSg",12) == 3321978194) strcat(s, "l");
if (crc32("ZvwipqNtPCVDCr",14) == 2668310125) strcat(s, "y");
    return s;
}

char *undesirably_adverbs() {
    char *s = calloc(12);
    if (crc32("mgxoAenY",8) == 414445234) strcat(s, "u");
if (crc32("OrYGanhUUAErV",13) == 1912963546) strcat(s, "n");
if (crc32("FvoUdNja",8) == 1742610011) strcat(s, "d");
if (crc32("ebjTeASwvOCB",12) == 3882674462) strcat(s, "e");
if (crc32("emdyTIY",7) == 835612983) strcat(s, "g");
if (crc32("MqVGPmX",7) == 268545488) strcat(s, "s");
if (crc32("BMPUHQOfa",9) == 2995107005) strcat(s, "i");
if (crc32("ZJIDDtMiDHlmGf",14) == 687523292) strcat(s, "r");
if (crc32("pvKVzJR",7) == 3148849790) strcat(s, "a");
if (crc32("zSpWaICFW",9) == 4029357386) strcat(s, "L");
if (crc32("WHiFGoxeAM",10) == 1037088530) strcat(s, "b");
if (crc32("hLfOLFXnLXSzsUU",15) == 3341213744) strcat(s, "G");
if (crc32("ayJkqIpOMNbAReb",15) == 4026162487) strcat(s, "l");
if (crc32("lBeij",5) == 1132049753) strcat(s, "z");
if (crc32("uLBuOfoI",8) == 332655341) strcat(s, "y");
    return s;
}

char *nonmaternally_adverbs() {
    char *s = calloc(14);
    if (crc32("qeWTX",5) == 3282375982) strcat(s, "O");
if (crc32("CiUoPGAjSPwIohN",15) == 540126923) strcat(s, "n");
if (crc32("xbwafihoh",9) == 4051093453) strcat(s, "D");
if (crc32("OhlArZxEkuie",12) == 4165963048) strcat(s, "o");
if (crc32("mKPniINUMtpR",12) == 2029458399) strcat(s, "x");
if (crc32("abqZeiqTh",9) == 128247144) strcat(s, "n");
if (crc32("aNXqorgur",9) == 1137415734) strcat(s, "R");
if (crc32("UsWuduNOkpffM",13) == 4104670720) strcat(s, "m");
if (crc32("kzdMY",5) == 888949341) strcat(s, "a");
if (crc32("TSZgUWXXmu",10) == 3624397841) strcat(s, "t");
if (crc32("zcewC",5) == 2640617806) strcat(s, "e");
if (crc32("tQZIZPMFpVQsjt",14) == 407709356) strcat(s, "X");
if (crc32("iaDTevOAfjB",11) == 2588782709) strcat(s, "r");
if (crc32("OzalGa",6) == 3144993626) strcat(s, "n");
if (crc32("HGQFhKhQYGQCsUL",15) == 2152069451) strcat(s, "H");
if (crc32("rkKEx",5) == 101192927) strcat(s, "a");
if (crc32("HMScCDSrH",9) == 2908177311) strcat(s, "l");
if (crc32("bHQEDRpCCyKlNKp",15) == 2164744115) strcat(s, "l");
if (crc32("gITVYo",6) == 1811608666) strcat(s, "y");
    return s;
}

char *regretfully_adverbs() {
    char *s = calloc(12);
    if (crc32("KoTLLa",6) == 2494105094) strcat(s, "r");
if (crc32("sbsPoXELZ",9) == 3013349384) strcat(s, "e");
if (crc32("TkJxOyIE",8) == 3854885545) strcat(s, "e");
if (crc32("ClsNc",5) == 422517858) strcat(s, "q");
if (crc32("GqcXHamHDHpR",12) == 942506503) strcat(s, "g");
if (crc32("tuEJUueDi",9) == 1433608308) strcat(s, "r");
if (crc32("UxxeNEmvool",11) == 4045556721) strcat(s, "C");
if (crc32("JNNUDVhfIe",10) == 3163114161) strcat(s, "e");
if (crc32("IBgCw",5) == 3471931541) strcat(s, "A");
if (crc32("rpgYxbu",7) == 1575505334) strcat(s, "t");
if (crc32("HvprL",5) == 3597100362) strcat(s, "f");
if (crc32("tgGmfMGbCqKQOd",14) == 254589464) strcat(s, "H");
if (crc32("lrmONZvcV",9) == 2039723206) strcat(s, "u");
if (crc32("VovEBTSYVJOZ",12) == 1642618290) strcat(s, "b");
if (crc32("xDWCP",5) == 3258639998) strcat(s, "l");
if (crc32("nvXQmOe",7) == 1270092716) strcat(s, "V");
if (crc32("WZMrgiE",7) == 1213165421) strcat(s, "l");
if (crc32("uZPdFvXFm",9) == 761086181) strcat(s, "J");
if (crc32("PEYVgsD",7) == 41034443) strcat(s, "y");
    return s;
}

char *intramuscularly_adverbs() {
    char *s = calloc(16);
    if (crc32("UHxBzzUTPya",11) == 822732750) strcat(s, "i");
if (crc32("LnYQHltsqJdbyK",14) == 830491766) strcat(s, "u");
if (crc32("pAtUKATLa",9) == 3065969119) strcat(s, "n");
if (crc32("dQMXkL",6) == 3477438060) strcat(s, "F");
if (crc32("WJzOpwycXMSuwqW",15) == 1769029792) strcat(s, "t");
if (crc32("ZAFjzyYpiFAk",12) == 1976109585) strcat(s, "X");
if (crc32("uzjazNmkWFL",11) == 2430602137) strcat(s, "r");
if (crc32("OLURkuogglGHL",13) == 782035976) strcat(s, "a");
if (crc32("ZvCcgWqUULPqPzf",15) == 2883603013) strcat(s, "E");
if (crc32("wupQOAmNsdSMr",13) == 2026993241) strcat(s, "m");
if (crc32("hWNgIxUQ",8) == 3548404889) strcat(s, "K");
if (crc32("LnAVJZnpbYMoFO",14) == 675848378) strcat(s, "u");
if (crc32("EbWqSv",6) == 175997455) strcat(s, "H");
if (crc32("DZgjW",5) == 3898899597) strcat(s, "s");
if (crc32("GDarbcTHOs",10) == 1686229902) strcat(s, "c");
if (crc32("pbJmEnu",7) == 2251850021) strcat(s, "A");
if (crc32("tIlbVLnJnjJ",11) == 3459040231) strcat(s, "u");
if (crc32("BuNoxdoavCi",11) == 2164541374) strcat(s, "l");
if (crc32("FBULGWcyRzv",11) == 2089555422) strcat(s, "P");
if (crc32("mNeBcrsoJJrj",12) == 70362881) strcat(s, "a");
if (crc32("YXRrnEhJx",9) == 4179035226) strcat(s, "h");
if (crc32("UdCTMcYYVvcbB",13) == 1596646355) strcat(s, "r");
if (crc32("YeTJxIaXpGvC",12) == 1488686836) strcat(s, "o");
if (crc32("IWzbkyo",7) == 407603914) strcat(s, "l");
if (crc32("cVovPnguCuDrPV",14) == 3952029714) strcat(s, "Z");
if (crc32("WNZudXdTHUYn",12) == 1287900163) strcat(s, "y");
    return s;
}

char *cautiously_adverbs() {
    char *s = calloc(11);
    if (crc32("wkXaYXwUXd",10) == 3773274176) strcat(s, "U");
if (crc32("efYmMWCHFOsIMA",14) == 2712643463) strcat(s, "c");
if (crc32("vcIQLP",6) == 250495023) strcat(s, "a");
if (crc32("ChcoWMrFIyjV",12) == 4002305037) strcat(s, "Q");
if (crc32("uCsJnhZeAhLXTb",14) == 1321088314) strcat(s, "u");
if (crc32("NnsZprFpZlywJvO",15) == 1939545358) strcat(s, "t");
if (crc32("ncwaQeFNWJnt",12) == 2528771186) strcat(s, "N");
if (crc32("vhanjIbZKU",10) == 1017813207) strcat(s, "i");
if (crc32("ALOgiEJQHkCldkl",15) == 2117421161) strcat(s, "o");
if (crc32("TzQAKVGixmrFyk",14) == 2460233372) strcat(s, "u");
if (crc32("AjnmcwbfRgYRW",13) == 2060445364) strcat(s, "b");
if (crc32("zmOCAvNF",8) == 3508488352) strcat(s, "s");
if (crc32("OfdwTJNS",8) == 9762114) strcat(s, "l");
if (crc32("UzZWWCTQ",8) == 4050085972) strcat(s, "y");
    return s;
}

char *indissolubly_adverbs() {
    char *s = calloc(13);
    if (crc32("PynMxuu",7) == 4113371876) strcat(s, "i");
if (crc32("zygBfhTN",8) == 2038663583) strcat(s, "c");
if (crc32("XTNfTNUSeqAbLIV",15) == 3026703856) strcat(s, "n");
if (crc32("bEtcPcUcSXwEOm",14) == 3802993376) strcat(s, "k");
if (crc32("weUIkaPPo",9) == 3574091982) strcat(s, "d");
if (crc32("DTqIsV",6) == 3259641744) strcat(s, "i");
if (crc32("vnWWzwicouuQ",12) == 552178014) strcat(s, "E");
if (crc32("RXWcpGLuOfkAV",13) == 3610893763) strcat(s, "s");
if (crc32("nxbvGLhjjYQpiIx",15) == 2259820634) strcat(s, "u");
if (crc32("adqeWeWv",8) == 3278639273) strcat(s, "s");
if (crc32("HmLxwLAoFdKe",12) == 2824837882) strcat(s, "g");
if (crc32("fKhyQyfb",8) == 2638589714) strcat(s, "o");
if (crc32("vCVYVa",6) == 682984379) strcat(s, "l");
if (crc32("VFKNiZSkdx",10) == 98987699) strcat(s, "u");
if (crc32("QiajS",5) == 372718694) strcat(s, "p");
if (crc32("jPjoxJK",7) == 3214494436) strcat(s, "b");
if (crc32("mSMxump",7) == 563303140) strcat(s, "l");
if (crc32("QvWhbOOTAtZFtE",14) == 3615761888) strcat(s, "f");
if (crc32("OjZjmt",6) == 4203050761) strcat(s, "y");
    return s;
}

char *tegularly_adverbs() {
    char *s = calloc(10);
    if (crc32("iyGMe",5) == 1240281837) strcat(s, "t");
if (crc32("psxvj",5) == 3365566334) strcat(s, "e");
if (crc32("yIdKSQ",6) == 2373822994) strcat(s, "g");
if (crc32("XEqSDawhtWTUpA",14) == 1557766029) strcat(s, "m");
if (crc32("AguIrfzJuI",10) == 3951842709) strcat(s, "u");
if (crc32("blJGAGSHJAE",11) == 903369679) strcat(s, "r");
if (crc32("sjxNZNT",7) == 943579636) strcat(s, "l");
if (crc32("AztLakfpJyOZ",12) == 586673256) strcat(s, "x");
if (crc32("IFjKw",5) == 3037918819) strcat(s, "a");
if (crc32("nnEOVwRcE",9) == 2217606802) strcat(s, "R");
if (crc32("EMLgbfvW",8) == 588575790) strcat(s, "r");
if (crc32("GrIBtwcnql",10) == 1715767905) strcat(s, "l");
if (crc32("WZZrE",5) == 3165030761) strcat(s, "Y");
if (crc32("HMrzPfFHociYCK",14) == 3142869921) strcat(s, "y");
    return s;
}

char *adequately_adverbs() {
    char *s = calloc(11);
    if (crc32("DrnYzrS",7) == 413916726) strcat(s, "j");
if (crc32("GYPJPppo",8) == 2201260587) strcat(s, "a");
if (crc32("IsJgyoljc",9) == 3733898804) strcat(s, "d");
if (crc32("FYDNT",5) == 3539716262) strcat(s, "e");
if (crc32("FFVGh",5) == 999178175) strcat(s, "q");
if (crc32("NXdYwzKQFMKy",12) == 336560347) strcat(s, "u");
if (crc32("cwwKgQJtPbHhEhf",15) == 3971287410) strcat(s, "i");
if (crc32("GCAoiaIA",8) == 3282362104) strcat(s, "a");
if (crc32("KWxsVJL",7) == 1729010424) strcat(s, "t");
if (crc32("RhWkhN",6) == 2011081265) strcat(s, "e");
if (crc32("iInOZhHYR",9) == 2864266516) strcat(s, "d");
if (crc32("JknMoUTRnYZpx",13) == 814562610) strcat(s, "l");
if (crc32("zhgopt",6) == 789855484) strcat(s, "y");
    return s;
}

char *noncurrently_adverbs() {
    char *s = calloc(13);
    if (crc32("JvxfuOoGTO",10) == 3507510545) strcat(s, "n");
if (crc32("PTzHwfkMRefTPQ",14) == 1787675292) strcat(s, "h");
if (crc32("XnMCja",6) == 3373826959) strcat(s, "o");
if (crc32("hCFOktGyfLpJ",12) == 627893754) strcat(s, "n");
if (crc32("EkOBPuGaAb",10) == 185722795) strcat(s, "z");
if (crc32("MmtPFGRlHn",10) == 2946295135) strcat(s, "c");
if (crc32("eSGvlyH",7) == 1328101256) strcat(s, "J");
if (crc32("csYrCt",6) == 3969651645) strcat(s, "u");
if (crc32("HMVLwAyx",8) == 2827852177) strcat(s, "B");
if (crc32("KMVqQxvMGX",10) == 2444607524) strcat(s, "r");
if (crc32("HJixouoe",8) == 2008708811) strcat(s, "r");
if (crc32("yoLDCLolqNwsvSZ",15) == 2704610260) strcat(s, "e");
if (crc32("XWpulY",6) == 970391358) strcat(s, "n");
if (crc32("TAfaSXo",7) == 96971551) strcat(s, "R");
if (crc32("OGpilzsjk",9) == 1282189941) strcat(s, "t");
if (crc32("QtRgOBfGt",9) == 1586964727) strcat(s, "T");
if (crc32("CbeKmYMSdigLb",13) == 1551162239) strcat(s, "l");
if (crc32("zFMTJ",5) == 4221773535) strcat(s, "y");
    return s;
}

char *nondisputatiously_adverbs() {
    char *s = calloc(18);
    if (crc32("CSLLzLVUeRfeyEp",15) == 3314405442) strcat(s, "n");
if (crc32("gNzAPEiYDgB",11) == 2302366144) strcat(s, "o");
if (crc32("GYFMnrnPeaKEco",14) == 460312471) strcat(s, "n");
if (crc32("RLMdmd",6) == 231989236) strcat(s, "e");
if (crc32("WFUSUnNpX",9) == 4290678595) strcat(s, "d");
if (crc32("hTnlz",5) == 282986951) strcat(s, "i");
if (crc32("jngwkQNVHZmz",12) == 1663641558) strcat(s, "T");
if (crc32("CYIzHWNgnwOCr",13) == 395318373) strcat(s, "s");
if (crc32("anxdNBpOYSt",11) == 742651028) strcat(s, "Z");
if (crc32("FLdbUdQae",9) == 1736561791) strcat(s, "p");
if (crc32("QZgpmMKhZxmCWN",14) == 2253478266) strcat(s, "u");
if (crc32("lVizgwuAcgUqiD",14) == 530840980) strcat(s, "t");
if (crc32("nbzfYJkPmVVggA",14) == 2768744326) strcat(s, "a");
if (crc32("HGkydFtNPKbdJ",13) == 993628809) strcat(s, "C");
if (crc32("VxfKObARaRWV",12) == 2640314077) strcat(s, "t");
if (crc32("LgroaOoepaIQWo",14) == 672233503) strcat(s, "n");
if (crc32("KaSVuv",6) == 715697669) strcat(s, "i");
if (crc32("YZCghtVaokStOzM",15) == 4096409669) strcat(s, "s");
if (crc32("yXHkkuieVNBME",13) == 3449341183) strcat(s, "o");
if (crc32("bGMxwA",6) == 1276423316) strcat(s, "u");
if (crc32("VUtqEdzPOpNB",12) == 2028029612) strcat(s, "F");
if (crc32("jcMqbkfwCPS",11) == 143549283) strcat(s, "s");
if (crc32("ZwUJsfXJO",9) == 214748759) strcat(s, "J");
if (crc32("XetCJzxjtI",10) == 2961033352) strcat(s, "l");
if (crc32("GwJLpW",6) == 3212105460) strcat(s, "y");
    return s;
}

char *monotheistically_adverbs() {
    char *s = calloc(17);
    if (crc32("GnFeHluZN",9) == 2080390786) strcat(s, "m");
if (crc32("IYzFEFvNhalMWy",14) == 2126467429) strcat(s, "o");
if (crc32("iIwhBB",6) == 3079565715) strcat(s, "l");
if (crc32("mCiWMOYflsRxBIX",15) == 894167745) strcat(s, "n");
if (crc32("XAxUlq",6) == 1048432924) strcat(s, "O");
if (crc32("ROXKMQj",7) == 3856350895) strcat(s, "o");
if (crc32("aXJcikAQZ",9) == 1686792399) strcat(s, "t");
if (crc32("prqMkIA",7) == 4274015115) strcat(s, "h");
if (crc32("HRCFIxvWS",9) == 2486086379) strcat(s, "e");
if (crc32("zOwQCtY",7) == 939645569) strcat(s, "i");
if (crc32("XHZWVYsnlcp",11) == 3441368943) strcat(s, "s");
if (crc32("PBTiIGwFWqLiwkY",15) == 388472903) strcat(s, "t");
if (crc32("kuleDIHCZhooBbZ",15) == 2343079928) strcat(s, "g");
if (crc32("qcZHHfckgBAtMEL",15) == 3255206479) strcat(s, "i");
if (crc32("mYuzBREipViSW",13) == 4091454570) strcat(s, "x");
if (crc32("YEzfynp",7) == 700505278) strcat(s, "c");
if (crc32("qRqVaFlztpT",11) == 2014373746) strcat(s, "g");
if (crc32("BddCVRhYS",9) == 3178299603) strcat(s, "a");
if (crc32("fNKFY",5) == 475853111) strcat(s, "w");
if (crc32("omIVYKUovcB",11) == 2882596560) strcat(s, "l");
if (crc32("GhYLgAm",7) == 2338319749) strcat(s, "l");
if (crc32("zVeZFKhX",8) == 940153494) strcat(s, "y");
    return s;
}

char *unskilfully_adverbs() {
    char *s = calloc(12);
    if (crc32("UNpWBw",6) == 519571100) strcat(s, "O");
if (crc32("DEAHImy",7) == 3478093533) strcat(s, "u");
if (crc32("hfQmUcj",7) == 3716851194) strcat(s, "b");
if (crc32("OlcUkmSZb",9) == 751300209) strcat(s, "n");
if (crc32("yGlXxzzLUk",10) == 3663422280) strcat(s, "C");
if (crc32("pPnJDPYUMFhLRU",14) == 1773555297) strcat(s, "s");
if (crc32("oRseqdrgUKxn",12) == 2962887774) strcat(s, "A");
if (crc32("dOwdwXvByfBqQM",14) == 4292881519) strcat(s, "k");
if (crc32("pfXmOnWWZErR",12) == 437320835) strcat(s, "i");
if (crc32("kgtXBIEP",8) == 167955065) strcat(s, "Q");
if (crc32("pOUzZAu",7) == 3546146622) strcat(s, "l");
if (crc32("iIwAyzsPLAHpp",13) == 2094276995) strcat(s, "s");
if (crc32("MPaUaFZtfB",10) == 3742790116) strcat(s, "f");
if (crc32("BRrHUK",6) == 687608585) strcat(s, "u");
if (crc32("XjiWl",5) == 1814196799) strcat(s, "l");
if (crc32("uTLYgjy",7) == 1157305401) strcat(s, "I");
if (crc32("YNOidrlpEBLrl",13) == 423015775) strcat(s, "l");
if (crc32("lhBIIHl",7) == 4062000759) strcat(s, "y");
    return s;
}

char *nonreverently_adverbs() {
    char *s = calloc(14);
    if (crc32("gtrpekNFzaeSoNT",15) == 4125255124) strcat(s, "Y");
if (crc32("cnTEmm",6) == 3368995498) strcat(s, "n");
if (crc32("fRxhoEg",7) == 401536842) strcat(s, "i");
if (crc32("XZLJJ",5) == 2414798708) strcat(s, "o");
if (crc32("UtKwLYzxGDXZkoz",15) == 3211945341) strcat(s, "n");
if (crc32("DyxQRRTMGcOY",12) == 2019187175) strcat(s, "x");
if (crc32("wBJSEMVThyzVyN",14) == 3088190492) strcat(s, "r");
if (crc32("LIYIoUHXwAjUP",13) == 1817025471) strcat(s, "e");
if (crc32("Hrezb",5) == 1474761793) strcat(s, "v");
if (crc32("WmhnWF",6) == 393559264) strcat(s, "e");
if (crc32("KvdBV",5) == 2831997887) strcat(s, "r");
if (crc32("hciFdqQSb",9) == 3319618023) strcat(s, "e");
if (crc32("LYPMhaVeFY",10) == 2635863206) strcat(s, "e");
if (crc32("CfFURvHkBFPioZ",14) == 1873464797) strcat(s, "i");
if (crc32("WTnmecUUCfGWA",13) == 2275390295) strcat(s, "n");
if (crc32("gROLZ",5) == 545319287) strcat(s, "t");
if (crc32("PDGcdd",6) == 175874876) strcat(s, "w");
if (crc32("PCtWizTT",8) == 4076750837) strcat(s, "l");
if (crc32("mbdqd",5) == 387619757) strcat(s, "D");
if (crc32("aepFDMvpwhL",11) == 1335709813) strcat(s, "y");
    return s;
}

char *unillustriously_adverbs() {
    char *s = calloc(16);
    if (crc32("stKiiCxNbsjLN",13) == 1477071812) strcat(s, "u");
if (crc32("tYOfvPLm",8) == 1580079663) strcat(s, "n");
if (crc32("jRzQU",5) == 2506324784) strcat(s, "i");
if (crc32("NMyhndfkXuIWJ",13) == 3539382416) strcat(s, "e");
if (crc32("YKQnlwWKNy",10) == 3787165977) strcat(s, "l");
if (crc32("mEwciXBDM",9) == 1036748666) strcat(s, "c");
if (crc32("tvaKPeQaI",9) == 1129614385) strcat(s, "l");
if (crc32("yxUSwpfqv",9) == 637393610) strcat(s, "L");
if (crc32("FGSSzKdzaifX",12) == 2333406268) strcat(s, "u");
if (crc32("RUxwaPsrLeDvvxc",15) == 3066086840) strcat(s, "s");
if (crc32("AbIQGL",6) == 3307057313) strcat(s, "Q");
if (crc32("aZlRRvkNfjRV",12) == 2307902339) strcat(s, "t");
if (crc32("LPmDk",5) == 3600705514) strcat(s, "k");
if (crc32("qpRmkX",6) == 1255959544) strcat(s, "r");
if (crc32("qkSmjookYAnIOim",15) == 911357117) strcat(s, "y");
if (crc32("WvFMHaQN",8) == 3916063849) strcat(s, "i");
if (crc32("hxDxerWYYeG",11) == 557646147) strcat(s, "o");
if (crc32("iZPhyl",6) == 3685372589) strcat(s, "o");
if (crc32("ACNtLbH",7) == 625054333) strcat(s, "o");
if (crc32("WJMNUC",6) == 2305376277) strcat(s, "u");
if (crc32("TjNbzWPnIOAl",12) == 3320308310) strcat(s, "s");
if (crc32("YFOqozNVQDDO",12) == 3642034491) strcat(s, "l");
if (crc32("foQsiDHBAtKw",12) == 2103436676) strcat(s, "m");
if (crc32("RbOIBkDqXJAvw",13) == 2996637253) strcat(s, "y");
    return s;
}

char *undutifully_adverbs() {
    char *s = calloc(12);
    if (crc32("hbmLLNBvRBUo",12) == 391356514) strcat(s, "u");
if (crc32("gjLwgUvz",8) == 2794583579) strcat(s, "n");
if (crc32("naJvqnIZf",9) == 3614221541) strcat(s, "d");
if (crc32("cIKgw",5) == 429999583) strcat(s, "W");
if (crc32("vQXXPjMjhV",10) == 924007260) strcat(s, "u");
if (crc32("tJcfWd",6) == 2573154364) strcat(s, "c");
if (crc32("YctEtWLW",8) == 2983735986) strcat(s, "t");
if (crc32("fqdJuVr",7) == 767512936) strcat(s, "i");
if (crc32("AApSdws",7) == 1910093652) strcat(s, "j");
if (crc32("wGpAuMNSBrYKtC",14) == 322088714) strcat(s, "f");
if (crc32("fIzFEeugyCPAZyC",15) == 1816306446) strcat(s, "u");
if (crc32("pqymiTLxKaL",11) == 1580893901) strcat(s, "l");
if (crc32("FWCakDFE",8) == 2048781703) strcat(s, "l");
if (crc32("HJGVwrecgUaT",12) == 2212250682) strcat(s, "y");
    return s;
}

char *monopodially_adverbs() {
    char *s = calloc(13);
    if (crc32("FBmOntBDTLEfK",13) == 1074145168) strcat(s, "Z");
if (crc32("QjAXFb",6) == 3775577530) strcat(s, "m");
if (crc32("WtoWQcJCi",9) == 1165774538) strcat(s, "I");
if (crc32("uRZjtckF",8) == 4231391237) strcat(s, "o");
if (crc32("fRpxts",6) == 2654917711) strcat(s, "n");
if (crc32("qiPXSbntvGyzQ",13) == 2138495666) strcat(s, "o");
if (crc32("JIPCCHuaPU",10) == 996808222) strcat(s, "m");
if (crc32("MLHBjE",6) == 723325463) strcat(s, "p");
if (crc32("XZNvCNzjoAyw",12) == 820334226) strcat(s, "o");
if (crc32("ThSkbtEgLPplVS",14) == 2687842332) strcat(s, "d");
if (crc32("ZAvRS",5) == 3183096917) strcat(s, "i");
if (crc32("qwLwWdxMoNqB",12) == 3554192223) strcat(s, "a");
if (crc32("xHCuAkaJTmBJB",13) == 29469135) strcat(s, "H");
if (crc32("stWXWillHi",10) == 2771964486) strcat(s, "l");
if (crc32("ESRtPxWUdi",10) == 2660940063) strcat(s, "v");
if (crc32("DdCaNtGXugiAPB",14) == 3942596938) strcat(s, "l");
if (crc32("bNLQsEmsnqqyMlr",15) == 1634961116) strcat(s, "y");
    return s;
}

char *captivatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("nNhPbR",6) == 1627543876) strcat(s, "w");
if (crc32("KSlpZJuOmEXtK",13) == 2830595064) strcat(s, "c");
if (crc32("JjwgqGAnZ",9) == 323567820) strcat(s, "a");
if (crc32("ZpzoRrzYXLJBOU",14) == 1986038666) strcat(s, "N");
if (crc32("zDsumI",6) == 1122711706) strcat(s, "p");
if (crc32("SgRMv",5) == 2854147863) strcat(s, "H");
if (crc32("cypBoPVZiQfkT",13) == 468281694) strcat(s, "t");
if (crc32("nMAJTbiuYYD",11) == 124259095) strcat(s, "T");
if (crc32("pBSxHS",6) == 3511417772) strcat(s, "i");
if (crc32("cDfKIRjWScvmbo",14) == 661845120) strcat(s, "v");
if (crc32("ZxpUbdrbsOGmNm",14) == 2201095952) strcat(s, "a");
if (crc32("QQBTd",5) == 1475747102) strcat(s, "t");
if (crc32("LXXsDjXeOoKkWNi",15) == 109388463) strcat(s, "i");
if (crc32("saxwUrd",7) == 2439436056) strcat(s, "Z");
if (crc32("jomvjIkIOna",11) == 2338396855) strcat(s, "n");
if (crc32("xUXvqJfpz",9) == 446345961) strcat(s, "b");
if (crc32("zAjOhXi",7) == 21838445) strcat(s, "g");
if (crc32("yEQojoTNxw",10) == 2886653753) strcat(s, "N");
if (crc32("YblxEHDq",8) == 3835867579) strcat(s, "l");
if (crc32("ClGwFvY",7) == 2885738098) strcat(s, "m");
if (crc32("OVPUMw",6) == 3528660319) strcat(s, "y");
    return s;
}

char *dissemblingly_adverbs() {
    char *s = calloc(14);
    if (crc32("aCyqqcQMMMhzkGB",15) == 423618744) strcat(s, "d");
if (crc32("ZVkvujDeDSUfZTc",15) == 782437726) strcat(s, "i");
if (crc32("YTVyYZxFSmdqT",13) == 2614356000) strcat(s, "s");
if (crc32("fqrCSGa",7) == 1420829788) strcat(s, "s");
if (crc32("dgFumOnSKF",10) == 98477401) strcat(s, "e");
if (crc32("dAZqHB",6) == 382047494) strcat(s, "m");
if (crc32("OBGhwx",6) == 324599312) strcat(s, "b");
if (crc32("UtMXh",5) == 2613420232) strcat(s, "l");
if (crc32("AyLmyKlUeCfbRu",14) == 2264361908) strcat(s, "z");
if (crc32("CVubc",5) == 3864860294) strcat(s, "i");
if (crc32("lENKcEIITF",10) == 12262476) strcat(s, "j");
if (crc32("xTfcg",5) == 2595471339) strcat(s, "n");
if (crc32("FIqxlbJ",7) == 2027296378) strcat(s, "g");
if (crc32("jlEuzYWnAJU",11) == 806281888) strcat(s, "l");
if (crc32("QoWSXUWbz",9) == 2631633988) strcat(s, "y");
    return s;
}

char *nonappreciatively_adverbs() {
    char *s = calloc(18);
    if (crc32("JxPgVkFx",8) == 2004703640) strcat(s, "n");
if (crc32("VvSwybNTgnpf",12) == 1078227727) strcat(s, "o");
if (crc32("RDckmrVA",8) == 3072769519) strcat(s, "A");
if (crc32("cUwyemFHWTPDM",13) == 1652727645) strcat(s, "n");
if (crc32("JvaRHx",6) == 2304458705) strcat(s, "C");
if (crc32("PRUhLNeKPPuJEH",14) == 2097166208) strcat(s, "a");
if (crc32("hVfoKafkORsm",12) == 1753499432) strcat(s, "p");
if (crc32("LRotwpQ",7) == 3260274841) strcat(s, "p");
if (crc32("NRaJQrdRqrnsc",13) == 2719653596) strcat(s, "r");
if (crc32("eQIHsp",6) == 1967765557) strcat(s, "W");
if (crc32("yjGuJHrN",8) == 3705209040) strcat(s, "e");
if (crc32("SwPftBlFxvbsust",15) == 2056241308) strcat(s, "K");
if (crc32("OCnGT",5) == 72836435) strcat(s, "c");
if (crc32("iVYaqF",6) == 2145486967) strcat(s, "i");
if (crc32("fAPAQo",6) == 3456418964) strcat(s, "a");
if (crc32("GitQefIyh",9) == 2608501526) strcat(s, "P");
if (crc32("ogkjifOHz",9) == 3875204459) strcat(s, "t");
if (crc32("YkwziAZAoQ",10) == 4156161073) strcat(s, "i");
if (crc32("ytNem",5) == 901046248) strcat(s, "Z");
if (crc32("IRiRCIOt",8) == 1559337851) strcat(s, "v");
if (crc32("OedYtJhj",8) == 1935989416) strcat(s, "e");
if (crc32("OSwHzFOeFRCLFd",14) == 2890962462) strcat(s, "l");
if (crc32("DmlcIleSl",9) == 1400041478) strcat(s, "y");
    return s;
}

char *subrotundly_adverbs() {
    char *s = calloc(12);
    if (crc32("RbGGV",5) == 3701424446) strcat(s, "F");
if (crc32("GCapxg",6) == 1603749597) strcat(s, "s");
if (crc32("HBzGkmWM",8) == 1562056272) strcat(s, "u");
if (crc32("wODrk",5) == 4267509009) strcat(s, "b");
if (crc32("jQfntTvqBPPHqN",14) == 117134097) strcat(s, "r");
if (crc32("GKUnXqZWjutaA",13) == 1945323613) strcat(s, "L");
if (crc32("cPoJwvH",7) == 2494279731) strcat(s, "o");
if (crc32("dTxAesuekQocL",13) == 4143639733) strcat(s, "t");
if (crc32("hHZvsGRgNiokH",13) == 2132640793) strcat(s, "y");
if (crc32("nuWURU",6) == 489677275) strcat(s, "u");
if (crc32("YAdZAooJ",8) == 952025036) strcat(s, "n");
if (crc32("IMEeoIvIQ",9) == 4169122846) strcat(s, "d");
if (crc32("UWxSuRu",7) == 3554644683) strcat(s, "J");
if (crc32("qTEnnveH",8) == 1088230306) strcat(s, "l");
if (crc32("XUKikFEhrjMaqC",14) == 2323472896) strcat(s, "y");
    return s;
}

char *legibly_adverbs() {
    char *s = calloc(8);
    if (crc32("dJtDfbduMXHByEh",15) == 1350961414) strcat(s, "q");
if (crc32("sUygqfePuQbYhI",14) == 281692704) strcat(s, "l");
if (crc32("DoUbrkCJpWk",11) == 2633692389) strcat(s, "N");
if (crc32("gaYjW",5) == 1742380643) strcat(s, "e");
if (crc32("sOSNfnboMgEqD",13) == 4290815221) strcat(s, "p");
if (crc32("KvpaESqWT",9) == 2052404955) strcat(s, "g");
if (crc32("EwqKBMjjgl",10) == 10234729) strcat(s, "B");
if (crc32("ycoOJisZBhBIx",13) == 3843285954) strcat(s, "i");
if (crc32("EsESxNmgCT",10) == 306411253) strcat(s, "b");
if (crc32("nstSjXcQEcexTg",14) == 1497777206) strcat(s, "l");
if (crc32("ObiLRDXAUhNXHrd",15) == 257044232) strcat(s, "h");
if (crc32("MDfxTbmE",8) == 2837985592) strcat(s, "y");
    return s;
}

char *institutively_adverbs() {
    char *s = calloc(14);
    if (crc32("GUuVLiSNIoL",11) == 1104982199) strcat(s, "X");
if (crc32("aZubAJSNlIBYS",13) == 1446690457) strcat(s, "i");
if (crc32("NaRFIxI",7) == 569453162) strcat(s, "n");
if (crc32("iCzGgUkbwspS",12) == 2367428373) strcat(s, "s");
if (crc32("cffFBFaKi",9) == 926768648) strcat(s, "p");
if (crc32("PiebgWanP",9) == 1669663191) strcat(s, "t");
if (crc32("WLMvPiFJnrwLDh",14) == 2746490081) strcat(s, "i");
if (crc32("YzMJrHuNEzOLMD",14) == 3177630270) strcat(s, "U");
if (crc32("cnrPIj",6) == 955658198) strcat(s, "t");
if (crc32("mihCFjaetl",10) == 3336302811) strcat(s, "Z");
if (crc32("CUFKeOiCwq",10) == 4129836799) strcat(s, "u");
if (crc32("OnviGhgmHzU",11) == 2584331253) strcat(s, "t");
if (crc32("JiBbg",5) == 760658494) strcat(s, "X");
if (crc32("MbKuNfDnWfTfnL",14) == 3579811570) strcat(s, "i");
if (crc32("lkiYFiCKbmF",11) == 3908878023) strcat(s, "m");
if (crc32("ZUTZwoIlGtlPQ",13) == 605084814) strcat(s, "v");
if (crc32("cQkAxEOCbWkO",12) == 1839870395) strcat(s, "e");
if (crc32("QTcsLPeA",8) == 3205046703) strcat(s, "l");
if (crc32("nkieyMwIMVbJS",13) == 2891209817) strcat(s, "y");
    return s;
}

char *unfully_adverbs() {
    char *s = calloc(8);
    if (crc32("AODcxkUvv",9) == 959810935) strcat(s, "t");
if (crc32("hlSPjlnIU",9) == 1120201073) strcat(s, "u");
if (crc32("ckAGTcbOvKuzCGi",15) == 890758400) strcat(s, "n");
if (crc32("FLRyhn",6) == 3112021547) strcat(s, "G");
if (crc32("ZFztCgCbsIOIJma",15) == 1998224193) strcat(s, "f");
if (crc32("ATKPekm",7) == 4147588074) strcat(s, "u");
if (crc32("foAjyAH",7) == 2024243804) strcat(s, "P");
if (crc32("vSYWdeA",7) == 2912442255) strcat(s, "l");
if (crc32("QHAPhQeOctApXs",14) == 3708203811) strcat(s, "H");
if (crc32("AkcwkFKpyE",10) == 1849737424) strcat(s, "l");
if (crc32("jQPaykFXLSy",11) == 3795787803) strcat(s, "y");
    return s;
}

char *unentertainingly_adverbs() {
    char *s = calloc(17);
    if (crc32("EAcZcIaDpVDYE",13) == 2493601397) strcat(s, "l");
if (crc32("XwKTgHWdVr",10) == 1215988102) strcat(s, "u");
if (crc32("tttAIEOlEarE",12) == 1482975661) strcat(s, "n");
if (crc32("ZVowzy",6) == 1611428846) strcat(s, "h");
if (crc32("rqTXRi",6) == 2847524289) strcat(s, "e");
if (crc32("ncgMqBg",7) == 3460523412) strcat(s, "n");
if (crc32("VwYOuvCAzLA",11) == 2599718686) strcat(s, "t");
if (crc32("qbIzIbJYCFDty",13) == 2132883379) strcat(s, "e");
if (crc32("WJWlmc",6) == 1095012403) strcat(s, "d");
if (crc32("WRmqVBM",7) == 711628566) strcat(s, "r");
if (crc32("frGHb",5) == 4289676251) strcat(s, "t");
if (crc32("BfBhNPQyNmwU",12) == 2420203) strcat(s, "u");
if (crc32("mIPpGl",6) == 881529948) strcat(s, "a");
if (crc32("kHFvKXPK",8) == 1122556596) strcat(s, "T");
if (crc32("dxswGvvXMiwaJPx",15) == 3409057636) strcat(s, "i");
if (crc32("TTYNz",5) == 2934753301) strcat(s, "l");
if (crc32("YFwFqGsCR",9) == 3979574481) strcat(s, "n");
if (crc32("OMuErIzjATemK",13) == 2616097454) strcat(s, "i");
if (crc32("TOnMglblREVYKr",14) == 254985109) strcat(s, "n");
if (crc32("KiqiBj",6) == 3151158439) strcat(s, "g");
if (crc32("ftzMKawTmcg",11) == 2892078008) strcat(s, "l");
if (crc32("pXrYgUhnPZ",10) == 3970799400) strcat(s, "y");
    return s;
}

char *halfearnestly_adverbs() {
    char *s = calloc(14);
    if (crc32("zscqycgdNh",10) == 3921119427) strcat(s, "h");
if (crc32("wkxNYQHtdkhgg",13) == 3400544973) strcat(s, "a");
if (crc32("LHxioe",6) == 2548818527) strcat(s, "l");
if (crc32("VVhURmgyqmHU",12) == 3604008950) strcat(s, "B");
if (crc32("UOHAZW",6) == 2910917075) strcat(s, "f");
if (crc32("KoqktGKMQH",10) == 2060582099) strcat(s, "e");
if (crc32("eodgJusfOj",10) == 1032392900) strcat(s, "a");
if (crc32("KJDak",5) == 3434996022) strcat(s, "r");
if (crc32("juisNYX",7) == 1881200120) strcat(s, "n");
if (crc32("oEVxWpolP",9) == 2764702548) strcat(s, "e");
if (crc32("gCXfOcWcLpZQWB",14) == 1891038879) strcat(s, "e");
if (crc32("BXFdSyYQALfeq",13) == 1090471598) strcat(s, "s");
if (crc32("FmIEYfhOgCPcCJx",15) == 2806643663) strcat(s, "c");
if (crc32("gtVzQLOvld",10) == 3974243323) strcat(s, "t");
if (crc32("vXmVcrmGuLzpfzu",15) == 1139905958) strcat(s, "z");
if (crc32("sGVilwbrnQW",11) == 3537765137) strcat(s, "l");
if (crc32("ikmmmnBUNyyBj",13) == 1122884739) strcat(s, "y");
    return s;
}

char *reactively_adverbs() {
    char *s = calloc(11);
    if (crc32("frLsoZv",7) == 1842371995) strcat(s, "r");
if (crc32("wCTnzWvMKGulwEt",15) == 4096633646) strcat(s, "p");
if (crc32("VMDHdIrQjHF",11) == 2895914668) strcat(s, "e");
if (crc32("OwoXJr",6) == 2974353927) strcat(s, "a");
if (crc32("uvNgIbTYaKZmIaG",15) == 1248364540) strcat(s, "b");
if (crc32("QAhxwzlMt",9) == 624805064) strcat(s, "c");
if (crc32("jWcnfiaW",8) == 3132868154) strcat(s, "t");
if (crc32("jRhJbJ",6) == 404973413) strcat(s, "i");
if (crc32("BdAviwpKgD",10) == 4160834627) strcat(s, "s");
if (crc32("sKSecOGm",8) == 72858826) strcat(s, "v");
if (crc32("ByFUQiMOiBFD",12) == 2407949470) strcat(s, "j");
if (crc32("jfuLPvmYefmD",12) == 2476746651) strcat(s, "e");
if (crc32("IBjxt",5) == 2937914210) strcat(s, "x");
if (crc32("aoHnBBhTPftQ",12) == 1404221896) strcat(s, "l");
if (crc32("cddtpJzoDFDnOB",14) == 2366576395) strcat(s, "y");
    return s;
}

char *brawlis_adverbs() {
    char *s = calloc(8);
    if (crc32("TzIeGJGjgKPf",12) == 3939943859) strcat(s, "b");
if (crc32("RSfyo",5) == 991007111) strcat(s, "e");
if (crc32("eBHtJMNfm",9) == 2106576922) strcat(s, "r");
if (crc32("WoDTRlnAdsf",11) == 1765262830) strcat(s, "a");
if (crc32("CAnFOLiaEHQm",12) == 4078428586) strcat(s, "w");
if (crc32("rrDTfoOTGRl",11) == 3893752085) strcat(s, "d");
if (crc32("BRwxSzDD",8) == 3094098) strcat(s, "l");
if (crc32("dImghXzcjWVAIi",14) == 2483279359) strcat(s, "i");
if (crc32("ipqkUI",6) == 2114851355) strcat(s, "N");
if (crc32("noazcThjjDZ",11) == 3039953151) strcat(s, "s");
    return s;
}

char *contradictiously_adverbs() {
    char *s = calloc(17);
    if (crc32("nmIJhShYayOr",12) == 2636085259) strcat(s, "z");
if (crc32("qiqrZgsnp",9) == 3944674865) strcat(s, "c");
if (crc32("TplxQktJ",8) == 81514027) strcat(s, "o");
if (crc32("APMqOmzWdd",10) == 2712940887) strcat(s, "n");
if (crc32("RoTIoSq",7) == 236201971) strcat(s, "t");
if (crc32("IHDivnz",7) == 1601956668) strcat(s, "r");
if (crc32("pXjNcRuTnBt",11) == 2467792896) strcat(s, "a");
if (crc32("sieYS",5) == 402268274) strcat(s, "J");
if (crc32("lHSrDzSIJOFMpGD",15) == 519967270) strcat(s, "d");
if (crc32("FjIsvfyyCstUc",13) == 2259958634) strcat(s, "i");
if (crc32("fsVyWRkrXtosOSg",15) == 93991428) strcat(s, "h");
if (crc32("jXLsymNOFmN",11) == 3041423548) strcat(s, "c");
if (crc32("BgjinBlfCvEyiD",14) == 1984080442) strcat(s, "t");
if (crc32("NutPkCNNsVzwzIR",15) == 1274756169) strcat(s, "i");
if (crc32("umZrlKb",7) == 1199011224) strcat(s, "r");
if (crc32("GRtCF",5) == 1525058690) strcat(s, "o");
if (crc32("lvdEWhhcYWN",11) == 790352057) strcat(s, "u");
if (crc32("UziPYSnLcTZVw",13) == 943479652) strcat(s, "s");
if (crc32("JjtBD",5) == 2854402448) strcat(s, "w");
if (crc32("YBejalZtluqDB",13) == 954746802) strcat(s, "l");
if (crc32("kYBeQKwF",8) == 1584347405) strcat(s, "J");
if (crc32("HbZjn",5) == 1807597321) strcat(s, "y");
    return s;
}

char *unstatistically_adverbs() {
    char *s = calloc(16);
    if (crc32("bDLHIyQm",8) == 2049885634) strcat(s, "u");
if (crc32("hcPTfEIPVARdnAY",15) == 3961719733) strcat(s, "B");
if (crc32("ZgOVRkcrVqMk",12) == 229468694) strcat(s, "n");
if (crc32("naAySxM",7) == 2006512876) strcat(s, "s");
if (crc32("KNBrIAzB",8) == 505763518) strcat(s, "t");
if (crc32("lsCfCvteVRiL",12) == 3363403673) strcat(s, "a");
if (crc32("utyku",5) == 3092515011) strcat(s, "D");
if (crc32("ylQSqFDBvov",11) == 2679927590) strcat(s, "t");
if (crc32("dSZajhOywfQdd",13) == 3114009964) strcat(s, "G");
if (crc32("lhtVzpiKUkrFhe",14) == 2604187022) strcat(s, "i");
if (crc32("Npfzed",6) == 1748784522) strcat(s, "s");
if (crc32("RDkjYuhRDmINTj",14) == 3554918165) strcat(s, "t");
if (crc32("faTkg",5) == 3821013840) strcat(s, "F");
if (crc32("zNdQHyIlSxlZES",14) == 3142229144) strcat(s, "i");
if (crc32("EEScV",5) == 360162636) strcat(s, "B");
if (crc32("QAKMQofMHCYRYs",14) == 919442535) strcat(s, "c");
if (crc32("GoAjhb",6) == 4230806045) strcat(s, "f");
if (crc32("OPxRiJe",7) == 4216290505) strcat(s, "a");
if (crc32("cbDFMxBcvzm",11) == 1686985811) strcat(s, "l");
if (crc32("wulCmhaQTAOU",12) == 3826093894) strcat(s, "l");
if (crc32("OXQkuJkg",8) == 3557982066) strcat(s, "W");
if (crc32("vAnmppGnQlL",11) == 3726319242) strcat(s, "y");
    return s;
}

char *chartographically_adverbs() {
    char *s = calloc(18);
    if (crc32("uySeKTBHByPime",14) == 1780098127) strcat(s, "c");
if (crc32("iizznokgh",9) == 228058227) strcat(s, "G");
if (crc32("CifRyBsMJ",9) == 656678168) strcat(s, "h");
if (crc32("IkGOwaJxNWVYH",13) == 3115401898) strcat(s, "a");
if (crc32("JFitAPVbuHQVqIO",15) == 1955030793) strcat(s, "r");
if (crc32("YfhMJ",5) == 1680128165) strcat(s, "D");
if (crc32("fyYshIYvFKkp",12) == 784879623) strcat(s, "t");
if (crc32("EJBlIGRYyDuk",12) == 3657491504) strcat(s, "m");
if (crc32("AzZfhOJh",8) == 3217121527) strcat(s, "o");
if (crc32("xHegjTavb",9) == 2673113233) strcat(s, "g");
if (crc32("ocVkvpajD",9) == 2744831191) strcat(s, "r");
if (crc32("zabKOuDI",8) == 355746700) strcat(s, "a");
if (crc32("gRuNmQCtz",9) == 2857507826) strcat(s, "P");
if (crc32("mIocC",5) == 2735929093) strcat(s, "p");
if (crc32("fntvxfbdG",9) == 3168281314) strcat(s, "h");
if (crc32("TlFaYcqZv",9) == 437369723) strcat(s, "i");
if (crc32("CgGDzE",6) == 2972324807) strcat(s, "c");
if (crc32("aUPctb",6) == 2822866758) strcat(s, "q");
if (crc32("iyeBALuYp",9) == 3823094313) strcat(s, "a");
if (crc32("ADaMqnCRwOyW",12) == 4004236832) strcat(s, "j");
if (crc32("ibHzCwSolreXb",13) == 1740131342) strcat(s, "l");
if (crc32("jnPFjkayAggMsr",14) == 3755249075) strcat(s, "h");
if (crc32("RVZDdzDuSf",10) == 2022548114) strcat(s, "l");
if (crc32("fLCpQQEi",8) == 666681257) strcat(s, "y");
    return s;
}

char *quasiexplicitly_adverbs() {
    char *s = calloc(16);
    if (crc32("uKPULR",6) == 526989287) strcat(s, "x");
if (crc32("zNCNIr",6) == 2427312745) strcat(s, "q");
if (crc32("IHFHkFATowM",11) == 3080359389) strcat(s, "P");
if (crc32("kGbCFUbZwDhO",12) == 2362940764) strcat(s, "u");
if (crc32("HiLQCT",6) == 3439662775) strcat(s, "a");
if (crc32("gCyPlR",6) == 2378590477) strcat(s, "s");
if (crc32("APOlV",5) == 1480233937) strcat(s, "i");
if (crc32("rWeROqAAmbV",11) == 1277219930) strcat(s, "C");
if (crc32("EIqwT",5) == 3915796264) strcat(s, "e");
if (crc32("LtKDeSn",7) == 3231802005) strcat(s, "x");
if (crc32("TJSNuCWbRHXNTR",14) == 1634297525) strcat(s, "Z");
if (crc32("pqQVyGKhAGFD",12) == 1210896730) strcat(s, "p");
if (crc32("UPDlC",5) == 2899487129) strcat(s, "l");
if (crc32("iPHIjbqBpjeVa",13) == 1575687678) strcat(s, "w");
if (crc32("ABJDVD",6) == 1235194205) strcat(s, "i");
if (crc32("BbRwYTsHwsV",11) == 3701774495) strcat(s, "c");
if (crc32("IsxhvlOEjlCQF",13) == 2116659385) strcat(s, "p");
if (crc32("KSJvvzziazlHB",13) == 1237351362) strcat(s, "i");
if (crc32("doWwVPfpxbnJ",12) == 2455382000) strcat(s, "O");
if (crc32("EvcymYWcRnbzUWs",15) == 2542484322) strcat(s, "t");
if (crc32("JWvUZyRYuNnBe",13) == 262527459) strcat(s, "b");
if (crc32("KoppuziBNuTbm",13) == 1759035681) strcat(s, "l");
if (crc32("uFoDDyFmCQgWnht",15) == 3166882283) strcat(s, "y");
    return s;
}

char *heartbreakingly_adverbs() {
    char *s = calloc(16);
    if (crc32("yOOBZNm",7) == 3456006425) strcat(s, "h");
if (crc32("NgLhQVHO",8) == 2559700164) strcat(s, "A");
if (crc32("zSxWIgCibFtqLW",14) == 1205045886) strcat(s, "e");
if (crc32("OwZFqNB",7) == 1456437068) strcat(s, "a");
if (crc32("OvmzqbR",7) == 2767939309) strcat(s, "E");
if (crc32("YokjHDWlPhfQNt",14) == 1750434391) strcat(s, "r");
if (crc32("DHZdHXbSNWLe",12) == 2629720459) strcat(s, "c");
if (crc32("CqfKfPzMSjEP",12) == 3333173611) strcat(s, "t");
if (crc32("ZcZcJDnGVYxxnRl",15) == 885193389) strcat(s, "b");
if (crc32("XCrvOsEcTPppV",13) == 139249999) strcat(s, "w");
if (crc32("HIURx",5) == 4103723425) strcat(s, "r");
if (crc32("ZUphNMFvQ",9) == 2346669904) strcat(s, "e");
if (crc32("bfqycLfcxygYJDM",15) == 613479173) strcat(s, "a");
if (crc32("uGOiQFSMZ",9) == 3996373192) strcat(s, "N");
if (crc32("KAoud",5) == 2444559858) strcat(s, "k");
if (crc32("gvhNMCEO",8) == 1126149373) strcat(s, "i");
if (crc32("dfOuDj",6) == 3306711063) strcat(s, "t");
if (crc32("EapQewHMoMLM",12) == 1814368187) strcat(s, "n");
if (crc32("CTMPjBbeSfTvi",13) == 891525535) strcat(s, "g");
if (crc32("OQDGnzYy",8) == 1651788299) strcat(s, "v");
if (crc32("OuWdrh",6) == 966447196) strcat(s, "l");
if (crc32("iIFmggtLzNYuqLo",15) == 4043950878) strcat(s, "U");
if (crc32("FRGpbsle",8) == 3860688507) strcat(s, "y");
    return s;
}

char *unbanteringly_adverbs() {
    char *s = calloc(14);
    if (crc32("WabqxXsTPoMAgWe",15) == 3954751892) strcat(s, "V");
if (crc32("ERIzTsgbazo",11) == 2667643020) strcat(s, "u");
if (crc32("yUPzC",5) == 2559190485) strcat(s, "n");
if (crc32("ZbLbNiAElkC",11) == 1651476400) strcat(s, "x");
if (crc32("cjXCYDM",7) == 4035605744) strcat(s, "b");
if (crc32("vSPBLWMoRmi",11) == 319878875) strcat(s, "r");
if (crc32("ZXjaStbbNei",11) == 686430307) strcat(s, "a");
if (crc32("GBDCIrHkfDxgCVF",15) == 3372445136) strcat(s, "N");
if (crc32("rvaEzsLOP",9) == 2413116130) strcat(s, "n");
if (crc32("SHVWOTGQCAYJT",13) == 881433729) strcat(s, "p");
if (crc32("VxJBK",5) == 2176252044) strcat(s, "t");
if (crc32("jRhhmSJsmfFZJ",13) == 89275679) strcat(s, "e");
if (crc32("xitCrZOVRQQyT",13) == 3721277374) strcat(s, "r");
if (crc32("rbmEJbJYA",9) == 3728486625) strcat(s, "a");
if (crc32("blNQWzN",7) == 1195771554) strcat(s, "i");
if (crc32("ALUiY",5) == 3972383113) strcat(s, "n");
if (crc32("aUxywbF",7) == 2863781414) strcat(s, "n");
if (crc32("qZLUu",5) == 939755938) strcat(s, "g");
if (crc32("jJZEybtzWBiN",12) == 2085222998) strcat(s, "k");
if (crc32("gpNTMVrRHX",10) == 1007944714) strcat(s, "l");
if (crc32("BIvFEPrUw",9) == 1911204160) strcat(s, "F");
if (crc32("hOcSgOuYalnJ",12) == 3365216783) strcat(s, "y");
    return s;
}

char *continually_adverbs() {
    char *s = calloc(12);
    if (crc32("vKMLR",5) == 2415318456) strcat(s, "y");
if (crc32("TTzvpWsccNZvy",13) == 1989055979) strcat(s, "c");
if (crc32("xAmWkOLdPXGAe",13) == 2114541924) strcat(s, "U");
if (crc32("LtcyGktLSaJJ",12) == 3455905980) strcat(s, "o");
if (crc32("HEovl",5) == 2088842116) strcat(s, "n");
if (crc32("StPGPPl",7) == 2764550275) strcat(s, "I");
if (crc32("QGceqP",6) == 2785261261) strcat(s, "t");
if (crc32("XCkToCGUIWlUyg",14) == 1434943657) strcat(s, "i");
if (crc32("xlXIIypufNdY",12) == 3656525788) strcat(s, "n");
if (crc32("YIbzH",5) == 106684291) strcat(s, "X");
if (crc32("IFDuwQxjm",9) == 1590777016) strcat(s, "u");
if (crc32("OLACNaKKpyyIA",13) == 2139945009) strcat(s, "a");
if (crc32("rwgqQJVCEysFWb",14) == 1964482955) strcat(s, "l");
if (crc32("BeKjAnfIEX",10) == 3580402781) strcat(s, "T");
if (crc32("XPeIaGfxy",9) == 2877853549) strcat(s, "l");
if (crc32("nueBmCn",7) == 1441501229) strcat(s, "m");
if (crc32("fZhkxLOMUSszD",13) == 1534063056) strcat(s, "y");
    return s;
}

char *nondialectally_adverbs() {
    char *s = calloc(15);
    if (crc32("FcfwHVYVr",9) == 3513103323) strcat(s, "l");
if (crc32("eIMHmILJXAIr",12) == 2027617483) strcat(s, "n");
if (crc32("iVBmsuzixQxSuZn",15) == 987237845) strcat(s, "o");
if (crc32("FKPPlhjf",8) == 315935691) strcat(s, "b");
if (crc32("lIbIOhxUsT",10) == 3801739645) strcat(s, "n");
if (crc32("EdikaHiKBdqLDa",14) == 3835908428) strcat(s, "d");
if (crc32("yQPgmK",6) == 2911057314) strcat(s, "l");
if (crc32("nHiMMeSQ",8) == 4071060042) strcat(s, "i");
if (crc32("Khblk",5) == 1016650812) strcat(s, "i");
if (crc32("RqIwAeVPzEbllmN",15) == 494208635) strcat(s, "a");
if (crc32("hcmgqZLbgRzOfsp",15) == 2185730074) strcat(s, "K");
if (crc32("iqpkszDY",8) == 2736223582) strcat(s, "l");
if (crc32("BKQlEcVPZffOFJ",14) == 2501877551) strcat(s, "e");
if (crc32("odWPB",5) == 580792840) strcat(s, "c");
if (crc32("IMISn",5) == 3916370636) strcat(s, "s");
if (crc32("msMnhRwh",8) == 3560264514) strcat(s, "t");
if (crc32("AqOmjEfJrBXv",12) == 3489198835) strcat(s, "a");
if (crc32("EEqBmz",6) == 577137454) strcat(s, "c");
if (crc32("uDIrWmJYMu",10) == 3219455563) strcat(s, "l");
if (crc32("IUvtKocjoCW",11) == 102672634) strcat(s, "J");
if (crc32("VCiiKKQYj",9) == 3117425216) strcat(s, "l");
if (crc32("zTQdiadarNErv",13) == 3600050423) strcat(s, "d");
if (crc32("ezkMeBvmQrDEr",13) == 204022776) strcat(s, "y");
    return s;
}

char *soothingly_adverbs() {
    char *s = calloc(11);
    if (crc32("ntqbOc",6) == 3543367485) strcat(s, "J");
if (crc32("LsDNsdDartnMu",13) == 866675417) strcat(s, "s");
if (crc32("fkLvS",5) == 3471880040) strcat(s, "o");
if (crc32("erCzAQbtGXL",11) == 179125357) strcat(s, "d");
if (crc32("GmWfOIAZu",9) == 35126209) strcat(s, "o");
if (crc32("ZeGHyVWyzkz",11) == 3595504121) strcat(s, "t");
if (crc32("fJObE",5) == 239254382) strcat(s, "h");
if (crc32("WeRYCw",6) == 3871820702) strcat(s, "i");
if (crc32("hhzFIsm",7) == 2228563675) strcat(s, "n");
if (crc32("sBucf",5) == 3226103952) strcat(s, "L");
if (crc32("XgyaNDgwUE",10) == 1099020217) strcat(s, "g");
if (crc32("sIntMBoK",8) == 2982766507) strcat(s, "l");
if (crc32("jPRLtwJab",9) == 3999224437) strcat(s, "y");
    return s;
}

char *satisfactorily_adverbs() {
    char *s = calloc(15);
    if (crc32("OwQMThFQcOMXw",13) == 2683580072) strcat(s, "O");
if (crc32("BVYnNwHOEG",10) == 3609058013) strcat(s, "s");
if (crc32("SGdzHUrCIEkyGg",14) == 811951471) strcat(s, "a");
if (crc32("JKBGzsJUyhW",11) == 3258177008) strcat(s, "t");
if (crc32("cfcSbpPN",8) == 3438456602) strcat(s, "i");
if (crc32("YMWzUoEDeiRkEzk",15) == 3530799460) strcat(s, "t");
if (crc32("fksBiVbJnWhfLXD",15) == 4254174071) strcat(s, "s");
if (crc32("xawsTaqScUS",11) == 3512332597) strcat(s, "f");
if (crc32("wuaiPsPnvVVZi",13) == 1456044035) strcat(s, "m");
if (crc32("dtNhxFQVOAxZq",13) == 2671748286) strcat(s, "a");
if (crc32("WbGROLBqlWU",11) == 3602868360) strcat(s, "c");
if (crc32("dHryD",5) == 4195196231) strcat(s, "h");
if (crc32("UxJtgg",6) == 2048451239) strcat(s, "t");
if (crc32("PPYoZtbyaJJTmA",14) == 3942447072) strcat(s, "o");
if (crc32("BnNhPAPlRYv",11) == 2192530047) strcat(s, "u");
if (crc32("FEQBmFIjalqWCP",14) == 3828914712) strcat(s, "r");
if (crc32("mmsnkvL",7) == 3831563258) strcat(s, "i");
if (crc32("VtvWvVgoesKSl",13) == 2315813691) strcat(s, "H");
if (crc32("tOwYpx",6) == 532032526) strcat(s, "l");
if (crc32("LvdYzqtwuDvwvK",14) == 3621136495) strcat(s, "D");
if (crc32("numBQGzSc",9) == 554828322) strcat(s, "y");
    return s;
}

char *semiprofanely_adverbs() {
    char *s = calloc(14);
    if (crc32("usQIxlGYQF",10) == 2430202531) strcat(s, "s");
if (crc32("nWItpesDQi",10) == 3611637647) strcat(s, "e");
if (crc32("xbcMGxwKWW",10) == 1578423235) strcat(s, "m");
if (crc32("UeNRtzpdWPGIGVh",15) == 3261365499) strcat(s, "i");
if (crc32("dSYIiUlOLBJ",11) == 3247764494) strcat(s, "p");
if (crc32("CjoCFc",6) == 4150967375) strcat(s, "y");
if (crc32("bevslekjdH",10) == 1774601368) strcat(s, "r");
if (crc32("pHUFHkrMTPoVSd",14) == 2713466662) strcat(s, "o");
if (crc32("vRMEoGM",7) == 3202047688) strcat(s, "P");
if (crc32("MRTDzyusG",9) == 2252456542) strcat(s, "f");
if (crc32("bUVjxh",6) == 2058606345) strcat(s, "f");
if (crc32("dLodut",6) == 2518672792) strcat(s, "a");
if (crc32("OzFiV",5) == 3457544356) strcat(s, "s");
if (crc32("DXyzdaFVYnEmw",13) == 1248370842) strcat(s, "n");
if (crc32("hyLUREBPBnYBds",14) == 1732500561) strcat(s, "e");
if (crc32("BrupmjOCCvKoh",13) == 950304776) strcat(s, "l");
if (crc32("raUWzTohL",9) == 404771932) strcat(s, "U");
if (crc32("tlOhJkoYJr",10) == 437241668) strcat(s, "y");
    return s;
}

char *pseudoservilely_adverbs() {
    char *s = calloc(16);
    if (crc32("zMDUxeLntO",10) == 509598494) strcat(s, "a");
if (crc32("HierEeiXn",9) == 3490085389) strcat(s, "p");
if (crc32("GXByPakWxABlXL",14) == 1929722652) strcat(s, "n");
if (crc32("xJlITkEFR",9) == 97343498) strcat(s, "s");
if (crc32("eEIFL",5) == 2637755480) strcat(s, "e");
if (crc32("AVLAtRz",7) == 1892263729) strcat(s, "u");
if (crc32("nmHCOT",6) == 3573938457) strcat(s, "d");
if (crc32("TPEYulzL",8) == 1251673002) strcat(s, "o");
if (crc32("aKXCOmJSzEpr",12) == 1490847389) strcat(s, "s");
if (crc32("HcSEYcwa",8) == 2572318343) strcat(s, "e");
if (crc32("DsEwhNPifMXxOEb",15) == 2391041777) strcat(s, "r");
if (crc32("XBXuawp",7) == 3794417783) strcat(s, "v");
if (crc32("iSQHTf",6) == 1181066090) strcat(s, "C");
if (crc32("alTeGlT",7) == 3731559223) strcat(s, "i");
if (crc32("HcRMfUKC",8) == 3785311437) strcat(s, "z");
if (crc32("LgFdnEbtXSfQtKp",15) == 1222425305) strcat(s, "l");
if (crc32("apyGK",5) == 2663019857) strcat(s, "N");
if (crc32("XCxfUpjoQ",9) == 2839476254) strcat(s, "e");
if (crc32("XgIlClZVUfnYWud",15) == 228931354) strcat(s, "r");
if (crc32("slssde",6) == 1942136463) strcat(s, "l");
if (crc32("CfAOhd",6) == 2020205386) strcat(s, "N");
if (crc32("IhgYrl",6) == 2890279433) strcat(s, "y");
    return s;
}

char *advancingly_adverbs() {
    char *s = calloc(12);
    if (crc32("YvYhBIVysKVI",12) == 1565344321) strcat(s, "e");
if (crc32("gysww",5) == 61828849) strcat(s, "a");
if (crc32("hpZHfxGJRGnOrle",15) == 174575148) strcat(s, "d");
if (crc32("IPgydsJdNQclPOl",15) == 1199701931) strcat(s, "v");
if (crc32("yQVPpN",6) == 2651946289) strcat(s, "W");
if (crc32("ezjgOgI",7) == 3310550116) strcat(s, "a");
if (crc32("NEYApp",6) == 3423972053) strcat(s, "O");
if (crc32("OqoxksXZt",9) == 4289514507) strcat(s, "n");
if (crc32("tkvRbBbnYOJsF",13) == 2694916688) strcat(s, "c");
if (crc32("bBkDCi",6) == 1157397658) strcat(s, "K");
if (crc32("DfYDiAJe",8) == 2790891569) strcat(s, "i");
if (crc32("dPPBOqc",7) == 2118931114) strcat(s, "n");
if (crc32("PpOKr",5) == 1129239657) strcat(s, "g");
if (crc32("CtLdPZJQ",8) == 2581161962) strcat(s, "n");
if (crc32("kawYAmRts",9) == 1736975589) strcat(s, "l");
if (crc32("UiBmEhyMJoQDREB",15) == 606612478) strcat(s, "p");
if (crc32("BGuyub",6) == 4021551147) strcat(s, "y");
    return s;
}

char *effeminately_adverbs() {
    char *s = calloc(13);
    if (crc32("ZChxh",5) == 3748353960) strcat(s, "e");
if (crc32("fSDqfNUVCLRg",12) == 1874167939) strcat(s, "f");
if (crc32("DtLDDnpGcJ",10) == 1662710232) strcat(s, "f");
if (crc32("pKXVMKFJabQz",12) == 3843162953) strcat(s, "e");
if (crc32("JZctsaCFsfeHgqX",15) == 1479890255) strcat(s, "m");
if (crc32("hjiZuwuoxyU",11) == 3738658689) strcat(s, "g");
if (crc32("sKnJs",5) == 3046560541) strcat(s, "i");
if (crc32("CNNJy",5) == 1349538240) strcat(s, "U");
if (crc32("PlOBJs",6) == 2457707988) strcat(s, "n");
if (crc32("wBOimCFN",8) == 4141356646) strcat(s, "a");
if (crc32("JbDas",5) == 2268583681) strcat(s, "t");
if (crc32("wgukDtxajd",10) == 148151404) strcat(s, "e");
if (crc32("MiXXtTiRaCGeg",13) == 771118344) strcat(s, "L");
if (crc32("hNRWyPO",7) == 60182490) strcat(s, "l");
if (crc32("YcyIKmyZawhWRF",14) == 1860860530) strcat(s, "m");
if (crc32("QjuIbKKisCBn",12) == 1246613973) strcat(s, "y");
    return s;
}

char *dissolvingly_adverbs() {
    char *s = calloc(13);
    if (crc32("LsHyjDGM",8) == 1157897814) strcat(s, "d");
if (crc32("UwSGlsXH",8) == 1241107876) strcat(s, "P");
if (crc32("MmXlTBnBywFua",13) == 2303818895) strcat(s, "i");
if (crc32("aLKfioINrRpHXbN",15) == 1466249877) strcat(s, "e");
if (crc32("tTtQIdcHpiNc",12) == 935690115) strcat(s, "s");
if (crc32("iwhENaJkpK",10) == 1356839093) strcat(s, "O");
if (crc32("XGMAqgPEb",9) == 3444466181) strcat(s, "s");
if (crc32("DqoFHUJULZK",11) == 1700328568) strcat(s, "o");
if (crc32("MlmeZtWBecJq",12) == 968786840) strcat(s, "l");
if (crc32("pgYaTHnkoGyvkqW",15) == 197213554) strcat(s, "v");
if (crc32("LHErW",5) == 212299321) strcat(s, "O");
if (crc32("aayRmNNFFyKAo",13) == 2185374743) strcat(s, "i");
if (crc32("XZtDIpnrg",9) == 1324271839) strcat(s, "j");
if (crc32("uLmgWl",6) == 1107598338) strcat(s, "n");
if (crc32("gjbklDCiMgGZnNr",15) == 1857767613) strcat(s, "g");
if (crc32("XAZIOjqjzZQ",11) == 2519486696) strcat(s, "a");
if (crc32("GPzcURgcnFP",11) == 2871138010) strcat(s, "l");
if (crc32("pFfAoKklhKS",11) == 3960957689) strcat(s, "y");
    return s;
}

char *blankly_adverbs() {
    char *s = calloc(8);
    if (crc32("GWtweiwwE",9) == 764620209) strcat(s, "b");
if (crc32("byrxrpnZBYNhsS",14) == 4056867778) strcat(s, "l");
if (crc32("uQQBWSb",7) == 541868359) strcat(s, "A");
if (crc32("nYqlwHcQorlgSk",14) == 1525940303) strcat(s, "a");
if (crc32("kwlMjEqgs",9) == 2830218271) strcat(s, "n");
if (crc32("onkBsoFEZwx",11) == 3537629886) strcat(s, "k");
if (crc32("Kemcpo",6) == 4099996841) strcat(s, "l");
if (crc32("kXzwYHEXXAB",11) == 2801428482) strcat(s, "h");
if (crc32("yAScJEPqhjEb",12) == 286217298) strcat(s, "y");
    return s;
}

char *maturely_adverbs() {
    char *s = calloc(9);
    if (crc32("yBtCNsEMDvqDxNB",15) == 3612836698) strcat(s, "W");
if (crc32("ArNETBarZ",9) == 2836986824) strcat(s, "m");
if (crc32("FEVBjMVueJAxaPb",15) == 2496964701) strcat(s, "M");
if (crc32("pqyInnFjjQbsmx",14) == 920816282) strcat(s, "a");
if (crc32("cZnCYdJbuyBaOaR",15) == 2471457244) strcat(s, "c");
if (crc32("eRXcmc",6) == 3957904605) strcat(s, "t");
if (crc32("FxGsyOCGaq",10) == 1984007613) strcat(s, "u");
if (crc32("gVnbUzrrE",9) == 1800178045) strcat(s, "u");
if (crc32("lzwVjmVpJpXNeT",14) == 346938866) strcat(s, "e");
if (crc32("FMzaYXw",7) == 3873949819) strcat(s, "r");
if (crc32("fHXqN",5) == 1260346890) strcat(s, "e");
if (crc32("jluCkk",6) == 2649830878) strcat(s, "F");
if (crc32("TxjIzKXBSUbTJgC",15) == 436534760) strcat(s, "l");
if (crc32("KufxF",5) == 2111974051) strcat(s, "u");
if (crc32("nfTaUopTBOJ",11) == 556231157) strcat(s, "y");
    return s;
}

char *depreciatively_adverbs() {
    char *s = calloc(15);
    if (crc32("qGUPAQlia",9) == 2257546353) strcat(s, "d");
if (crc32("ZQkXBhvZ",8) == 3962239355) strcat(s, "r");
if (crc32("QTxySRKbzMYEdff",15) == 2936619945) strcat(s, "e");
if (crc32("MgXnhq",6) == 3720562915) strcat(s, "i");
if (crc32("AVHVrjGjhBYIBTz",15) == 3763239281) strcat(s, "p");
if (crc32("MwYFp",5) == 98729792) strcat(s, "r");
if (crc32("ZTLbpUazvBENTC",14) == 1379150597) strcat(s, "e");
if (crc32("oIWeAlVRj",9) == 3035764253) strcat(s, "c");
if (crc32("NZtfEpztFTwNYiz",15) == 1920578476) strcat(s, "h");
if (crc32("xEIgkQqR",8) == 1039774593) strcat(s, "i");
if (crc32("eIaCQNLeLlDD",12) == 1849737102) strcat(s, "a");
if (crc32("FQQOudxrTZ",10) == 2768430436) strcat(s, "t");
if (crc32("KxKIo",5) == 3354655890) strcat(s, "i");
if (crc32("qwaLfDso",8) == 2544606130) strcat(s, "M");
if (crc32("fwjTApphC",9) == 3482346995) strcat(s, "v");
if (crc32("xvGEXloUmw",10) == 467233986) strcat(s, "e");
if (crc32("YDrHlRVFfUFu",12) == 350064879) strcat(s, "i");
if (crc32("DoHsV",5) == 4035439693) strcat(s, "l");
if (crc32("iJxNdFfOL",9) == 3529324459) strcat(s, "y");
    return s;
}

char *predeficiently_adverbs() {
    char *s = calloc(15);
    if (crc32("XzEHWYZKbBgpoHr",15) == 199947151) strcat(s, "p");
if (crc32("fLPAQ",5) == 2552275939) strcat(s, "p");
if (crc32("jDdfbBEVj",9) == 3338657302) strcat(s, "r");
if (crc32("guAoPMgEw",9) == 2130667812) strcat(s, "e");
if (crc32("XtmCCYJx",8) == 2110365667) strcat(s, "O");
if (crc32("wwbFKwrpKsjiG",13) == 3335842218) strcat(s, "d");
if (crc32("bTVprjUlNOk",11) == 4207329189) strcat(s, "e");
if (crc32("bosFdqjIKIIvpA",14) == 3455194473) strcat(s, "L");
if (crc32("puMdDnYUILYVsZG",15) == 2282309245) strcat(s, "f");
if (crc32("jwVlcUUmQTVGTJG",15) == 961200183) strcat(s, "X");
if (crc32("LJugdfCHVjttrg",14) == 2945426227) strcat(s, "i");
if (crc32("dCDKMEvXKkr",11) == 3073902765) strcat(s, "z");
if (crc32("oXZDsSfR",8) == 3708255444) strcat(s, "c");
if (crc32("TprlmJ",6) == 430894266) strcat(s, "i");
if (crc32("lbRcRAvjMy",10) == 323296753) strcat(s, "M");
if (crc32("QBkzvrxBoCoZ",12) == 2993487920) strcat(s, "e");
if (crc32("JevVUifcDrlraSR",15) == 1975985523) strcat(s, "c");
if (crc32("jOZvgPLzW",9) == 1013387904) strcat(s, "n");
if (crc32("ChutMGxofcg",11) == 940149325) strcat(s, "t");
if (crc32("QBbtF",5) == 1535644779) strcat(s, "L");
if (crc32("RDlobPwrXhfzTgQ",15) == 390454702) strcat(s, "l");
if (crc32("TwFAIafhOkSHVG",14) == 3572313505) strcat(s, "y");
    return s;
}

char *unlegislatively_adverbs() {
    char *s = calloc(16);
    if (crc32("qoATEIVGPpnra",13) == 1405045495) strcat(s, "u");
if (crc32("shNUHOzOWXDwTp",14) == 312022078) strcat(s, "n");
if (crc32("cBmXwE",6) == 2188128884) strcat(s, "w");
if (crc32("xxrulSXfRlMj",12) == 4267004710) strcat(s, "l");
if (crc32("rgFEk",5) == 1465026444) strcat(s, "A");
if (crc32("lMbdyUM",7) == 2710266823) strcat(s, "e");
if (crc32("YSJPVj",6) == 1013164538) strcat(s, "g");
if (crc32("PkbSp",5) == 2564171825) strcat(s, "i");
if (crc32("XvaUYtanL",9) == 1314834995) strcat(s, "j");
if (crc32("vEdNgEhWGhf",11) == 2854730091) strcat(s, "s");
if (crc32("IAqcGyuMZnUqdQ",14) == 4137039467) strcat(s, "l");
if (crc32("KztLanCnge",10) == 1925853584) strcat(s, "a");
if (crc32("azQjc",5) == 1076174416) strcat(s, "t");
if (crc32("QtUsomcFNUXguMB",15) == 2064711016) strcat(s, "h");
if (crc32("mRqGu",5) == 216063454) strcat(s, "i");
if (crc32("NQkemeyfChGoBWS",15) == 2263084106) strcat(s, "k");
if (crc32("nPsmYOxJPFimfRY",15) == 15250196) strcat(s, "v");
if (crc32("CxlDf",5) == 116597215) strcat(s, "e");
if (crc32("iBwLLbDvro",10) == 71612870) strcat(s, "l");
if (crc32("rlTblr",6) == 3549766693) strcat(s, "y");
    return s;
}

char *unpreclusively_adverbs() {
    char *s = calloc(15);
    if (crc32("faQYpLpGOQT",11) == 111520711) strcat(s, "h");
if (crc32("zoGMvJBk",8) == 3154422288) strcat(s, "u");
if (crc32("qdaKTVzU",8) == 3299405478) strcat(s, "W");
if (crc32("cTzLfebxTGrg",12) == 2302808173) strcat(s, "n");
if (crc32("QfTgCXhz",8) == 1581204740) strcat(s, "p");
if (crc32("riqYbMaSUoABG",13) == 4022717362) strcat(s, "u");
if (crc32("jPuPsvCjVJP",11) == 3439671721) strcat(s, "r");
if (crc32("osZBn",5) == 3114013193) strcat(s, "M");
if (crc32("uGZzARRvJJQFQw",14) == 3603490591) strcat(s, "e");
if (crc32("XTspoWkN",8) == 1573151877) strcat(s, "c");
if (crc32("fZOGjfwJNVuXLcf",15) == 1183803044) strcat(s, "C");
if (crc32("bGpEivMdfM",10) == 1913339990) strcat(s, "l");
if (crc32("NXcXSTjNs",9) == 4118010303) strcat(s, "u");
if (crc32("ZiFplVRsA",9) == 1959494982) strcat(s, "u");
if (crc32("IHBkDSwUQW",10) == 657201617) strcat(s, "s");
if (crc32("QgqECUGbv",9) == 880554777) strcat(s, "i");
if (crc32("EsKdzmb",7) == 4128228796) strcat(s, "P");
if (crc32("njehvudTPkhzl",13) == 1451029529) strcat(s, "v");
if (crc32("TIxRHjhDnCaEQc",14) == 2408013038) strcat(s, "e");
if (crc32("uFxFnMR",7) == 253461206) strcat(s, "l");
if (crc32("XiODR",5) == 2288655463) strcat(s, "x");
if (crc32("jioWkvaHx",9) == 55084111) strcat(s, "y");
    return s;
}

char *unpresentably_adverbs() {
    char *s = calloc(14);
    if (crc32("VSpIYlXXd",9) == 3862346732) strcat(s, "u");
if (crc32("KOamO",5) == 2492804443) strcat(s, "e");
if (crc32("bbItekmyz",9) == 4104515558) strcat(s, "n");
if (crc32("GRUhOp",6) == 4039400960) strcat(s, "N");
if (crc32("xqkkmyX",7) == 1527966210) strcat(s, "p");
if (crc32("nNEiOCYiakxrTEj",15) == 3392625581) strcat(s, "r");
if (crc32("pnOow",5) == 977809673) strcat(s, "T");
if (crc32("mgcwE",5) == 757638156) strcat(s, "e");
if (crc32("wVvHDgdFDK",10) == 810222713) strcat(s, "b");
if (crc32("JyOWhYuKRImwzrj",15) == 1871366685) strcat(s, "s");
if (crc32("qxuGTGArzdn",11) == 3141948729) strcat(s, "e");
if (crc32("PUsnybkkUCtJW",13) == 782709294) strcat(s, "v");
if (crc32("OaUibbye",8) == 1768338351) strcat(s, "n");
if (crc32("JaXvRaCdCgzGt",13) == 2894913513) strcat(s, "t");
if (crc32("DcoGVIWSkz",10) == 3954583977) strcat(s, "K");
if (crc32("mopQSLXYdmO",11) == 338416299) strcat(s, "a");
if (crc32("AvAWCTegAG",10) == 384551639) strcat(s, "b");
if (crc32("MkFVGkjQiJf",11) == 3413162567) strcat(s, "l");
if (crc32("etwjiLchMGD",11) == 682810302) strcat(s, "A");
if (crc32("yXFAfIrXeJMcLd",14) == 563247975) strcat(s, "y");
    return s;
}

char *vivaciously_adverbs() {
    char *s = calloc(12);
    if (crc32("UmRUO",5) == 2970261430) strcat(s, "v");
if (crc32("WzQwiPWgFMCAIGe",15) == 3313822578) strcat(s, "u");
if (crc32("wiBVhguZ",8) == 1118234826) strcat(s, "i");
if (crc32("asKQAtKIDi",10) == 3198640600) strcat(s, "v");
if (crc32("pufgI",5) == 184022202) strcat(s, "a");
if (crc32("PhgHXFZzkukKmid",15) == 367864618) strcat(s, "X");
if (crc32("xidSVhkwhrvfZk",14) == 1133712623) strcat(s, "c");
if (crc32("WUvge",5) == 2589146467) strcat(s, "e");
if (crc32("omYkZzwnTB",10) == 1094825110) strcat(s, "i");
if (crc32("TZKYymKkGmI",11) == 2944620380) strcat(s, "Z");
if (crc32("OrFlyoEUPrDalVL",15) == 3342976462) strcat(s, "o");
if (crc32("kXKuf",5) == 2888809971) strcat(s, "u");
if (crc32("PKhPBRuSD",9) == 2773576883) strcat(s, "s");
if (crc32("cvDUxvkQPTfLOj",14) == 331926099) strcat(s, "l");
if (crc32("UEasKgEhUYcBBY",14) == 3354091750) strcat(s, "y");
if (crc32("KDbldt",6) == 4281709519) strcat(s, "y");
    return s;
}

char *nonpartially_adverbs() {
    char *s = calloc(13);
    if (crc32("RMAQbiJ",7) == 3852943426) strcat(s, "n");
if (crc32("lRKYC",5) == 3222224949) strcat(s, "S");
if (crc32("rbHxsPmPDBGB",12) == 2969244501) strcat(s, "o");
if (crc32("PiiNPM",6) == 2811413586) strcat(s, "n");
if (crc32("kttJCNZZlFzVnSL",15) == 2418441162) strcat(s, "p");
if (crc32("PADdlnDaQI",10) == 2462071736) strcat(s, "u");
if (crc32("oXHrn",5) == 443792287) strcat(s, "a");
if (crc32("sOKqOsUZRHzch",13) == 301951377) strcat(s, "r");
if (crc32("rLKPFoDmj",9) == 2998792999) strcat(s, "t");
if (crc32("WyDnmxwcf",9) == 4127529808) strcat(s, "D");
if (crc32("JJbhyoBE",8) == 1077887541) strcat(s, "i");
if (crc32("ArfzINBcyLm",11) == 2183962950) strcat(s, "D");
if (crc32("YVUIOBWotbun",12) == 428657774) strcat(s, "a");
if (crc32("OSoLlB",6) == 2065710055) strcat(s, "l");
if (crc32("jLdeUHxJtoDrYm",14) == 3009908544) strcat(s, "L");
if (crc32("mLamAfMY",8) == 939477727) strcat(s, "l");
if (crc32("fdKjYFvREnyodXM",15) == 942750357) strcat(s, "y");
    return s;
}

char *orthopedically_adverbs() {
    char *s = calloc(15);
    if (crc32("FghjyzHVf",9) == 1591040703) strcat(s, "Z");
if (crc32("XWoqvBfWcDKTWoB",15) == 3904128365) strcat(s, "o");
if (crc32("QByuqX",6) == 3386222428) strcat(s, "l");
if (crc32("PjZNcTdiySYy",12) == 4184342077) strcat(s, "r");
if (crc32("mnrlOU",6) == 3484539113) strcat(s, "t");
if (crc32("USIzsQ",6) == 2922512507) strcat(s, "t");
if (crc32("ponHaEQ",7) == 678653969) strcat(s, "h");
if (crc32("qIqMdl",6) == 3389726533) strcat(s, "o");
if (crc32("reQnXaCakSAiytq",15) == 3873860506) strcat(s, "S");
if (crc32("WkdriT",6) == 1973634777) strcat(s, "p");
if (crc32("AAXkW",5) == 2444275855) strcat(s, "e");
if (crc32("vVBogeymegehN",13) == 591781581) strcat(s, "A");
if (crc32("GWPfRJApaQm",11) == 1719212269) strcat(s, "d");
if (crc32("uezfs",5) == 1478860466) strcat(s, "i");
if (crc32("NqApfRKuR",9) == 1092170281) strcat(s, "Q");
if (crc32("KsamGMYqHVxL",12) == 2303163206) strcat(s, "c");
if (crc32("syHLXKo",7) == 3104358988) strcat(s, "O");
if (crc32("xknROthZnpK",11) == 649711001) strcat(s, "a");
if (crc32("FzhrUiAp",8) == 2535982610) strcat(s, "L");
if (crc32("qBdCWoKppxYmHdG",15) == 2686190636) strcat(s, "l");
if (crc32("rLUNJJJpvTo",11) == 3223504903) strcat(s, "j");
if (crc32("ckapumJjNHc",11) == 3053673351) strcat(s, "l");
if (crc32("DiTUCn",6) == 2033480380) strcat(s, "u");
if (crc32("ZqGwiwREMpluc",13) == 3644864389) strcat(s, "y");
    return s;
}

char *nonconcentrically_adverbs() {
    char *s = calloc(18);
    if (crc32("omXlEJOrjcPV",12) == 1885633542) strcat(s, "n");
if (crc32("VorluUPPlkodc",13) == 3489976097) strcat(s, "S");
if (crc32("EpNEInEhOHZB",12) == 1203072379) strcat(s, "o");
if (crc32("zuNRfANdspWN",12) == 4171941471) strcat(s, "k");
if (crc32("IAphENasxxsf",12) == 2350051467) strcat(s, "n");
if (crc32("JcviLUwXTMArU",13) == 1043084316) strcat(s, "h");
if (crc32("gTnIRuvDFWYoljk",15) == 333525308) strcat(s, "c");
if (crc32("GTixbfq",7) == 4001419746) strcat(s, "o");
if (crc32("uTzWsatTCam",11) == 1942769124) strcat(s, "J");
if (crc32("KqpiLeoNsKOCN",13) == 312421899) strcat(s, "n");
if (crc32("blthHRBUmRiZmf",14) == 2344153971) strcat(s, "c");
if (crc32("hSzfXl",6) == 421550168) strcat(s, "U");
if (crc32("wDOospcD",8) == 2223346784) strcat(s, "e");
if (crc32("MpfaAgVGx",9) == 83822787) strcat(s, "n");
if (crc32("DdXgFNXTdOnmcxX",15) == 225505089) strcat(s, "t");
if (crc32("SGGAFDsFQGfLQQ",14) == 95474473) strcat(s, "X");
if (crc32("LZWQXNs",7) == 2399776251) strcat(s, "r");
if (crc32("NgbkwZWb",8) == 2105503092) strcat(s, "i");
if (crc32("CaxLgPitKTyQRQ",14) == 274506562) strcat(s, "c");
if (crc32("TyjLaVWprVE",11) == 3053158799) strcat(s, "a");
if (crc32("UbXalqdqSY",10) == 1678097430) strcat(s, "d");
if (crc32("EIQejq",6) == 1040819151) strcat(s, "l");
if (crc32("DxtfCtJUsYpdoI",14) == 2520244626) strcat(s, "l");
if (crc32("chSbYamik",9) == 1327579691) strcat(s, "y");
    return s;
}

char *unpoignantly_adverbs() {
    char *s = calloc(13);
    if (crc32("WUsFIH",6) == 77273785) strcat(s, "u");
if (crc32("SsWtcmLr",8) == 4119433021) strcat(s, "n");
if (crc32("qRdjJcNcZepocan",15) == 4012085183) strcat(s, "G");
if (crc32("ruVIBEqlswUTFXt",15) == 2876072477) strcat(s, "p");
if (crc32("mTBTUtha",8) == 1324346038) strcat(s, "o");
if (crc32("DEyIpnaGvNSdKSE",15) == 22791584) strcat(s, "i");
if (crc32("aGrzfm",6) == 2912497626) strcat(s, "B");
if (crc32("KiBXZV",6) == 3515998353) strcat(s, "g");
if (crc32("dULjQP",6) == 2384279750) strcat(s, "n");
if (crc32("waVFdQQWSPUHVBt",15) == 1306433953) strcat(s, "i");
if (crc32("RIPdGaibB",9) == 3717844330) strcat(s, "a");
if (crc32("NFCcoRzy",8) == 3543317212) strcat(s, "e");
if (crc32("zJereEgHZcipOuy",15) == 2470890689) strcat(s, "n");
if (crc32("jKlxsrUgYQX",11) == 4191966255) strcat(s, "M");
if (crc32("fOSPxOY",7) == 927699) strcat(s, "t");
if (crc32("yLemmVfYbhtJU",13) == 4185158602) strcat(s, "x");
if (crc32("leUiWsQifXjU",12) == 4052855017) strcat(s, "l");
if (crc32("QcOExq",6) == 1353954439) strcat(s, "t");
if (crc32("OAMOCjoHD",9) == 2559922028) strcat(s, "y");
    return s;
}

char *quasiintellectually_adverbs() {
    char *s = calloc(20);
    if (crc32("jTEBPj",6) == 173086856) strcat(s, "p");
if (crc32("IYLlbtLucAGUk",13) == 2495602684) strcat(s, "q");
if (crc32("OsCOlGTOr",9) == 3058607656) strcat(s, "u");
if (crc32("pJIEwLVsTpPsKX",14) == 852640000) strcat(s, "m");
if (crc32("nwokNDuf",8) == 1678588762) strcat(s, "a");
if (crc32("zoQvOWYTrVK",11) == 2840711311) strcat(s, "u");
if (crc32("lMrNBBQyvNpmf",13) == 213228725) strcat(s, "s");
if (crc32("ahIbhAYmHinn",12) == 3515658550) strcat(s, "i");
if (crc32("zpdmcVLOzj",10) == 492903954) strcat(s, "n");
if (crc32("vXOeSjAiGBfE",12) == 4011797939) strcat(s, "i");
if (crc32("OiUforLhSpkVuFB",15) == 3347673327) strcat(s, "n");
if (crc32("VLHkJWMgoXYyJ",13) == 3972969392) strcat(s, "t");
if (crc32("sigyAnzdUKHPQ",13) == 1254048159) strcat(s, "i");
if (crc32("nPGUoNVKjCjVf",13) == 2857425918) strcat(s, "e");
if (crc32("EVQhQMAzfj",10) == 715140040) strcat(s, "g");
if (crc32("dqzEnLjs",8) == 3041985558) strcat(s, "l");
if (crc32("FDJliaLEFeQuB",13) == 2455073206) strcat(s, "l");
if (crc32("RpvzjqoMPkQZ",12) == 3489976198) strcat(s, "E");
if (crc32("vFgxnFREDahjemC",15) == 1220042535) strcat(s, "e");
if (crc32("HdqwSSeebKAdoe",14) == 2219466324) strcat(s, "c");
if (crc32("iQQSjnjzIVHytC",14) == 83581343) strcat(s, "t");
if (crc32("jkNrhQvMhzdX",12) == 2340709581) strcat(s, "o");
if (crc32("TjlfbPolDoZPGFn",15) == 3799786701) strcat(s, "u");
if (crc32("YFZZwCYTUSi",11) == 2941765949) strcat(s, "w");
if (crc32("OEgua",5) == 2502857042) strcat(s, "a");
if (crc32("IxgRzE",6) == 463399068) strcat(s, "n");
if (crc32("AHEzRPQzXcMcvS",14) == 3595444367) strcat(s, "l");
if (crc32("zTCUmXmpdSQon",13) == 4202868644) strcat(s, "l");
if (crc32("HZcYQDvBoGfZt",13) == 4064244407) strcat(s, "z");
if (crc32("gKIuXptVf",9) == 1477726213) strcat(s, "y");
    return s;
}

char *nonbureaucratically_adverbs() {
    char *s = calloc(20);
    if (crc32("jstuKVwO",8) == 4197562314) strcat(s, "n");
if (crc32("ycCVhfXm",8) == 4227646863) strcat(s, "Y");
if (crc32("QJHvQBg",7) == 3963446596) strcat(s, "o");
if (crc32("RBBOmAqXN",9) == 145772847) strcat(s, "n");
if (crc32("CowaSQVk",8) == 4230647231) strcat(s, "W");
if (crc32("rdGWgGPMaAWhzq",14) == 3159060180) strcat(s, "b");
if (crc32("sVfrOQf",7) == 2303308958) strcat(s, "s");
if (crc32("SiUrmLPCazh",11) == 2373759372) strcat(s, "u");
if (crc32("lKphKBfNJiVI",12) == 2343325179) strcat(s, "U");
if (crc32("wlqMlWjeUHGHhOb",15) == 3242497245) strcat(s, "r");
if (crc32("tbrlBKMzqtphxo",14) == 2100309812) strcat(s, "i");
if (crc32("eyIbZRQ",7) == 1506349143) strcat(s, "e");
if (crc32("VSYFYkuQXojma",13) == 2480649223) strcat(s, "a");
if (crc32("WegZzElrBoS",11) == 3802682822) strcat(s, "E");
if (crc32("sJoQyRguaMO",11) == 980264179) strcat(s, "u");
if (crc32("hhqNjkjq",8) == 303355709) strcat(s, "X");
if (crc32("NPOMRwRMpo",10) == 621450061) strcat(s, "c");
if (crc32("ygstQ",5) == 1802703306) strcat(s, "g");
if (crc32("feOgwpbtwi",10) == 3994644223) strcat(s, "r");
if (crc32("HksjijLc",8) == 1899069513) strcat(s, "s");
if (crc32("ctLPl",5) == 2077411784) strcat(s, "a");
if (crc32("KkjhOoZnqfGqR",13) == 3714780716) strcat(s, "t");
if (crc32("noWWCM",6) == 1951269328) strcat(s, "i");
if (crc32("kOwWI",5) == 1089713496) strcat(s, "c");
if (crc32("KwdtdON",7) == 3975379299) strcat(s, "a");
if (crc32("hbJiivrltX",10) == 36513369) strcat(s, "l");
if (crc32("BdnONYh",7) == 2993240154) strcat(s, "N");
if (crc32("qFJYnHmDuINk",12) == 2432888636) strcat(s, "l");
if (crc32("RYXdhYOfapJ",11) == 879393073) strcat(s, "y");
    return s;
}

char *aaerially_adverbs() {
    char *s = calloc(10);
    if (crc32("yjZYXOvh",8) == 3168629404) strcat(s, "T");
if (crc32("dKFYdzmh",8) == 3851773234) strcat(s, "a");
if (crc32("WKDCkMHFYV",10) == 1695912207) strcat(s, "E");
if (crc32("rVRDGemycLK",11) == 3521342890) strcat(s, "a");
if (crc32("mmdnapKhXTaHr",13) == 421822475) strcat(s, "e");
if (crc32("MJHGtlpKVvOc",12) == 880208633) strcat(s, "A");
if (crc32("IKHATWxPqrGHHb",14) == 523183374) strcat(s, "r");
if (crc32("ovyUVD",6) == 3756160341) strcat(s, "i");
if (crc32("LVrgjPszjcQsmc",14) == 709172697) strcat(s, "a");
if (crc32("QJKjNSAi",8) == 1660259098) strcat(s, "l");
if (crc32("rmXkhXNPDU",10) == 3352267957) strcat(s, "l");
if (crc32("fCTHlVk",7) == 1529938114) strcat(s, "R");
if (crc32("lrLfjCShYiNd",12) == 2576019931) strcat(s, "y");
    return s;
}

char *squeakingly_adverbs() {
    char *s = calloc(12);
    if (crc32("Wallpuc",7) == 1200018254) strcat(s, "s");
if (crc32("wglEU",5) == 4242745351) strcat(s, "q");
if (crc32("yfcJINNGMSo",11) == 2859293842) strcat(s, "i");
if (crc32("hpjPyeApRSY",11) == 684620952) strcat(s, "u");
if (crc32("CFoAGChhp",9) == 2889785134) strcat(s, "A");
if (crc32("gnciRQYR",8) == 2627828944) strcat(s, "e");
if (crc32("PcAagtwALs",10) == 278471696) strcat(s, "p");
if (crc32("HQjbr",5) == 1905318801) strcat(s, "a");
if (crc32("uQdzuBQIQHxUT",13) == 3633645197) strcat(s, "k");
if (crc32("WOPWIGw",7) == 3593614964) strcat(s, "X");
if (crc32("DctalZz",7) == 2647210545) strcat(s, "i");
if (crc32("sdhVm",5) == 3503920632) strcat(s, "w");
if (crc32("cvvFtmIHX",9) == 1478819565) strcat(s, "n");
if (crc32("ekKKSubxRoW",11) == 936033687) strcat(s, "g");
if (crc32("CCVMMFTLYZHF",12) == 121335022) strcat(s, "l");
if (crc32("cEewGITy",8) == 1287596034) strcat(s, "y");
if (crc32("XBtAt",5) == 313452620) strcat(s, "y");
    return s;
}

char *irrecoverably_adverbs() {
    char *s = calloc(14);
    if (crc32("pGTAuf",6) == 2768469963) strcat(s, "U");
if (crc32("wYuHDkVn",8) == 1351170392) strcat(s, "i");
if (crc32("APCPT",5) == 3437064806) strcat(s, "r");
if (crc32("dMRwlJvIEUOxFe",14) == 3380906769) strcat(s, "U");
if (crc32("tNtByjFT",8) == 1927206487) strcat(s, "r");
if (crc32("hKFKnzs",7) == 1945714079) strcat(s, "s");
if (crc32("LorVBEvMZVWPLN",14) == 1731158472) strcat(s, "e");
if (crc32("bIhlpnB",7) == 294917090) strcat(s, "V");
if (crc32("bONKeSNDiPvhZHb",15) == 2221706393) strcat(s, "c");
if (crc32("izjGgsMRvjcHMd",14) == 3835807006) strcat(s, "o");
if (crc32("vmyajoUOLcyPX",13) == 1728869993) strcat(s, "v");
if (crc32("cyTYspxgIks",11) == 3734386087) strcat(s, "n");
if (crc32("YjzxoubeNP",10) == 2682456790) strcat(s, "e");
if (crc32("ETXhybdkNRrM",12) == 2234278599) strcat(s, "r");
if (crc32("TKJqrukeA",9) == 526714648) strcat(s, "a");
if (crc32("MFjOTQeyPjwPukt",15) == 2621600940) strcat(s, "b");
if (crc32("nsfOORDNETfQIuv",15) == 902023557) strcat(s, "l");
if (crc32("xsIPBLCYVthE",12) == 1564569706) strcat(s, "h");
if (crc32("uDEXGysUrwdNbl",14) == 188608186) strcat(s, "y");
    return s;
}

char *harebrainedly_adverbs() {
    char *s = calloc(14);
    if (crc32("GIetFrtDhKlh",12) == 2836605357) strcat(s, "h");
if (crc32("mAYEE",5) == 1828544729) strcat(s, "a");
if (crc32("wpHCRWwfjfGld",13) == 742938791) strcat(s, "Z");
if (crc32("jcjYWg",6) == 3622157618) strcat(s, "r");
if (crc32("FpJeRvgZfgr",11) == 1325058213) strcat(s, "e");
if (crc32("HDnqqhzuscPvf",13) == 2302791772) strcat(s, "X");
if (crc32("ZPeJdfBThe",10) == 148706922) strcat(s, "b");
if (crc32("HlIOabKv",8) == 1134197107) strcat(s, "r");
if (crc32("mGhDEJXxVeiLBd",14) == 888997283) strcat(s, "a");
if (crc32("oGjridxwu",9) == 1961376385) strcat(s, "u");
if (crc32("EGwyddXjXyFHW",13) == 2113912150) strcat(s, "i");
if (crc32("jkxKupXRFYuFw",13) == 4077396558) strcat(s, "s");
if (crc32("PZDOBKKMhASPLf",14) == 3896423608) strcat(s, "n");
if (crc32("eLfxhYKYahgaTgf",15) == 1216580662) strcat(s, "J");
if (crc32("ztHvyvp",7) == 290459543) strcat(s, "e");
if (crc32("GlvQymI",7) == 3802568961) strcat(s, "d");
if (crc32("QcJUeNBmXhQ",11) == 1784261420) strcat(s, "l");
if (crc32("NBYXReMsHbe",11) == 214236849) strcat(s, "y");
    return s;
}

char *trippingly_adverbs() {
    char *s = calloc(11);
    if (crc32("YAtPRJIhnQEA",12) == 204447395) strcat(s, "G");
if (crc32("fXPuSr",6) == 3517346416) strcat(s, "t");
if (crc32("iwslzjIcqK",10) == 921676312) strcat(s, "r");
if (crc32("vIeafZqW",8) == 2661824665) strcat(s, "i");
if (crc32("cHUPgQJk",8) == 864780738) strcat(s, "p");
if (crc32("hxGIkWctICAfoY",14) == 3060126131) strcat(s, "p");
if (crc32("adwCgvP",7) == 3188542542) strcat(s, "i");
if (crc32("BOXukLSyPpjlLM",14) == 360190274) strcat(s, "c");
if (crc32("FkrRwl",6) == 206921221) strcat(s, "n");
if (crc32("cCiNsz",6) == 2820232346) strcat(s, "g");
if (crc32("EpqWzJeIN",9) == 318243861) strcat(s, "T");
if (crc32("oPaXcSfNiw",10) == 1384875395) strcat(s, "l");
if (crc32("KzJNQITjtoSWW",13) == 1951897495) strcat(s, "G");
if (crc32("ItGCbsuIjctFSkA",15) == 2082050900) strcat(s, "y");
    return s;
}

char *legendarily_adverbs() {
    char *s = calloc(12);
    if (crc32("PMXTCongBRD",11) == 3859532166) strcat(s, "l");
if (crc32("WisrsafnwooWVHA",15) == 1357767736) strcat(s, "e");
if (crc32("xtTNkmD",7) == 1622953826) strcat(s, "y");
if (crc32("DyenbQwtBPPmhS",14) == 2798841394) strcat(s, "g");
if (crc32("PhfhyZdXF",9) == 1776625475) strcat(s, "e");
if (crc32("qiPRGHwTvHYZMRq",15) == 3486709798) strcat(s, "e");
if (crc32("tUYaWy",6) == 4071706107) strcat(s, "n");
if (crc32("VCXshuEnMHTxWmZ",15) == 2303259201) strcat(s, "g");
if (crc32("AJtPiD",6) == 720008350) strcat(s, "d");
if (crc32("RasOGAnAoBaDhs",14) == 201182765) strcat(s, "a");
if (crc32("taSOK",5) == 2986310223) strcat(s, "r");
if (crc32("IonaHbiQYELyr",13) == 3746411172) strcat(s, "h");
if (crc32("knnGpXsBW",9) == 2719370345) strcat(s, "i");
if (crc32("bzFDCrWqNgxwQMI",15) == 2100614450) strcat(s, "F");
if (crc32("tupoRVpiTAQDR",13) == 2304056959) strcat(s, "l");
if (crc32("ZSmjXcAu",8) == 1496586726) strcat(s, "y");
    return s;
}

char *binately_adverbs() {
    char *s = calloc(9);
    if (crc32("dUjHNdNjpLmAFhP",15) == 3507740245) strcat(s, "b");
if (crc32("dxXDHSSCYB",10) == 949994360) strcat(s, "B");
if (crc32("incBj",5) == 2889921193) strcat(s, "i");
if (crc32("sLAlzjPtTYHh",12) == 1899852235) strcat(s, "n");
if (crc32("MvStbSldMBWw",12) == 2491125825) strcat(s, "h");
if (crc32("XdRpDz",6) == 748505070) strcat(s, "a");
if (crc32("lACUWFbMUccjWA",14) == 49108767) strcat(s, "t");
if (crc32("ytHbcUBCfyy",11) == 2009459509) strcat(s, "F");
if (crc32("ijWyFVUDC",9) == 3051331573) strcat(s, "e");
if (crc32("OQYid",5) == 1279834412) strcat(s, "D");
if (crc32("GQwpyYoQupqOIu",14) == 3695966631) strcat(s, "l");
if (crc32("aNVxpf",6) == 1340024512) strcat(s, "a");
if (crc32("raeIRcQ",7) == 2943979217) strcat(s, "y");
    return s;
}

char *reportedly_adverbs() {
    char *s = calloc(11);
    if (crc32("lIkdiXsZPjPv",12) == 2002499654) strcat(s, "V");
if (crc32("BWSWmHoKW",9) == 3493008191) strcat(s, "r");
if (crc32("MAyBJBVPkblaM",13) == 4059967266) strcat(s, "w");
if (crc32("vuYdgQIdsQGHX",13) == 1947026193) strcat(s, "e");
if (crc32("MUPTwPr",7) == 2109774337) strcat(s, "J");
if (crc32("PyBEtO",6) == 2750551172) strcat(s, "p");
if (crc32("DUGNhxMbf",9) == 1084051333) strcat(s, "b");
if (crc32("KywtP",5) == 2393956992) strcat(s, "o");
if (crc32("JJiocRwi",8) == 276598503) strcat(s, "j");
if (crc32("uDXwDROqLbZtuY",14) == 1923437623) strcat(s, "r");
if (crc32("HxrwHpDIhiSxdzU",15) == 1763080358) strcat(s, "t");
if (crc32("FnWalKqTTTLlVt",14) == 1575292937) strcat(s, "f");
if (crc32("ABaOoqnJsn",10) == 4184346720) strcat(s, "e");
if (crc32("lRDqZdQ",7) == 2451180996) strcat(s, "d");
if (crc32("fgJKevpVCjZPbw",14) == 2865996784) strcat(s, "l");
if (crc32("TItpIobzygt",11) == 702923267) strcat(s, "y");
    return s;
}

char *discomposedly_adverbs() {
    char *s = calloc(14);
    if (crc32("YSlnigLEiNoTT",13) == 3488720895) strcat(s, "L");
if (crc32("lkuzYOOrHXEb",12) == 3340673928) strcat(s, "d");
if (crc32("HcwxfJPfYSTptO",14) == 3351803544) strcat(s, "i");
if (crc32("iKMel",5) == 987336991) strcat(s, "s");
if (crc32("nwQpwgIcrVIZoWS",15) == 3682458207) strcat(s, "c");
if (crc32("hKIwUxHSOoMqq",13) == 3387495900) strcat(s, "o");
if (crc32("gbvsZidEDFC",11) == 3042525286) strcat(s, "Z");
if (crc32("kzvcc",5) == 3864391133) strcat(s, "m");
if (crc32("VHVwSbRoClvEb",13) == 2424224822) strcat(s, "p");
if (crc32("DyGBeJjhDEgRny",14) == 3835974874) strcat(s, "o");
if (crc32("jMxmTYjJ",8) == 1458093011) strcat(s, "h");
if (crc32("uZRsrYzwzuubtD",14) == 3052139311) strcat(s, "s");
if (crc32("zGbbmVnkCwqfqt",14) == 2967899850) strcat(s, "e");
if (crc32("tfCUU",5) == 3071769596) strcat(s, "f");
if (crc32("uWBGqckCWwyY",12) == 4209981736) strcat(s, "d");
if (crc32("sXwJcKbRMwP",11) == 218531459) strcat(s, "v");
if (crc32("UsQOjHkIPl",10) == 4067009916) strcat(s, "l");
if (crc32("kUExMnqNtik",11) == 807774151) strcat(s, "r");
if (crc32("EvihI",5) == 4249302864) strcat(s, "y");
    return s;
}

char *supersecretively_adverbs() {
    char *s = calloc(17);
    if (crc32("dAJkMDBb",8) == 4275132757) strcat(s, "T");
if (crc32("rXFdNTQoYLhxh",13) == 3035390991) strcat(s, "s");
if (crc32("cGxFCLzRmpUzW",13) == 4290055893) strcat(s, "u");
if (crc32("nNxjwIedQrniQ",13) == 2349743201) strcat(s, "V");
if (crc32("YHVVlE",6) == 3144251612) strcat(s, "p");
if (crc32("HzteLhVnEC",10) == 3855774180) strcat(s, "e");
if (crc32("hbEOaj",6) == 1695255583) strcat(s, "C");
if (crc32("DaSroCAgL",9) == 2611788035) strcat(s, "r");
if (crc32("fRwaKeHBQ",9) == 3572969649) strcat(s, "b");
if (crc32("TjhbIWRBr",9) == 1706876446) strcat(s, "s");
if (crc32("qGFCGfTv",8) == 4263881970) strcat(s, "X");
if (crc32("XqpKYpQvWvOa",12) == 2285086954) strcat(s, "e");
if (crc32("lfiJNIhLr",9) == 2755363985) strcat(s, "P");
if (crc32("SubucNfW",8) == 3790267775) strcat(s, "c");
if (crc32("jMvHngUsa",9) == 4262329775) strcat(s, "H");
if (crc32("iXHrwJheNilaGZ",14) == 404946462) strcat(s, "r");
if (crc32("XMrnxczO",8) == 1903982130) strcat(s, "e");
if (crc32("TmxpN",5) == 642030913) strcat(s, "t");
if (crc32("YRdIZhEWcxLDIXv",15) == 3887928013) strcat(s, "g");
if (crc32("jzTGHYqWO",9) == 1329570793) strcat(s, "i");
if (crc32("GkfIJTEdWnMFy",13) == 4117800498) strcat(s, "v");
if (crc32("ywDExROUNCrfwD",14) == 1219965001) strcat(s, "e");
if (crc32("HTapeFHWk",9) == 3396489978) strcat(s, "l");
if (crc32("hGVGamzlTDjGK",13) == 3663364532) strcat(s, "U");
if (crc32("qwJGWhKCTrTJb",13) == 1686255665) strcat(s, "y");
    return s;
}

char *halfrebelliously_adverbs() {
    char *s = calloc(17);
    if (crc32("fjDgOIoD",8) == 1620529432) strcat(s, "Z");
if (crc32("TDRsY",5) == 1717201095) strcat(s, "h");
if (crc32("dnXwyahxQy",10) == 2791166433) strcat(s, "a");
if (crc32("sksVv",5) == 1507057899) strcat(s, "m");
if (crc32("qrRNZip",7) == 764416314) strcat(s, "l");
if (crc32("FDEkyavpFBBTnE",14) == 1434491676) strcat(s, "f");
if (crc32("DGTMmcBuC",9) == 2764142177) strcat(s, "r");
if (crc32("PhjnIeEKVIMM",12) == 1608459299) strcat(s, "u");
if (crc32("vJFvXSAcNE",10) == 2905643135) strcat(s, "e");
if (crc32("QxQoeYRjYMDSy",13) == 3001759112) strcat(s, "b");
if (crc32("Eyubd",5) == 2039894640) strcat(s, "r");
if (crc32("wKoxPZczr",9) == 559547313) strcat(s, "e");
if (crc32("atXhepSCAiYX",12) == 854759520) strcat(s, "B");
if (crc32("DsRbjbsrBClGZD",14) == 3541301936) strcat(s, "l");
if (crc32("rbumQi",6) == 2683999344) strcat(s, "l");
if (crc32("fllLOzwXCtprUMf",15) == 1342184100) strcat(s, "i");
if (crc32("yPCdp",5) == 413056762) strcat(s, "A");
if (crc32("eNiZsuMuMFVl",12) == 778285581) strcat(s, "o");
if (crc32("laOYEdpNRa",10) == 3046981974) strcat(s, "u");
if (crc32("WPCBMImMIe",10) == 1021901606) strcat(s, "n");
if (crc32("qMTMPlHPP",9) == 833591226) strcat(s, "s");
if (crc32("NkAZOJvTIYIq",12) == 3894774628) strcat(s, "k");
if (crc32("sMSwEVAbuJYF",12) == 546891060) strcat(s, "l");
if (crc32("ePuYVDs",7) == 4201866201) strcat(s, "y");
    return s;
}

char *bountifully_adverbs() {
    char *s = calloc(12);
    if (crc32("qHoMvwnQMutg",12) == 1883034690) strcat(s, "b");
if (crc32("shfPOFlLdJJtPZ",14) == 798001426) strcat(s, "G");
if (crc32("mzJYPcFi",8) == 4005898866) strcat(s, "o");
if (crc32("bhFiGqLe",8) == 588074683) strcat(s, "a");
if (crc32("ZRdlquTAvrVe",12) == 187613116) strcat(s, "u");
if (crc32("iQOQQTg",7) == 2382201449) strcat(s, "n");
if (crc32("oCGVO",5) == 3351018468) strcat(s, "J");
if (crc32("vWoGoDbVa",9) == 3353594194) strcat(s, "t");
if (crc32("mVogcNPpsMWMAau",15) == 4110307742) strcat(s, "i");
if (crc32("PKKwwYdYmB",10) == 3891106564) strcat(s, "f");
if (crc32("thmJFHwiNbQ",11) == 177399894) strcat(s, "u");
if (crc32("jZiHrjb",7) == 510754261) strcat(s, "H");
if (crc32("NdLuJyG",7) == 2962712426) strcat(s, "l");
if (crc32("qicUjZAhM",9) == 2336951499) strcat(s, "l");
if (crc32("cVUSRyG",7) == 2916314697) strcat(s, "y");
    return s;
}

char *clearsightedly_adverbs() {
    char *s = calloc(15);
    if (crc32("UXeTon",6) == 3401582215) strcat(s, "c");
if (crc32("LzdfCvgLMOvpo",13) == 2878616600) strcat(s, "r");
if (crc32("rIrwdR",6) == 3065495528) strcat(s, "l");
if (crc32("tTOvJHVEXwL",11) == 2613399486) strcat(s, "e");
if (crc32("jcaSbgNKDFRDIsA",15) == 349451304) strcat(s, "H");
if (crc32("CaxztISegfFd",12) == 158826238) strcat(s, "a");
if (crc32("bkrUn",5) == 4081384002) strcat(s, "r");
if (crc32("BIwIa",5) == 943374885) strcat(s, "N");
if (crc32("XjpgeEXZhd",10) == 570869534) strcat(s, "s");
if (crc32("xOPfbkHpCWyBmRu",15) == 1714548502) strcat(s, "i");
if (crc32("HuEcOtuklSbKWD",14) == 2745651160) strcat(s, "g");
if (crc32("tjepmNdAY",9) == 1990409373) strcat(s, "h");
if (crc32("uIQGnNIktvvh",12) == 559388298) strcat(s, "n");
if (crc32("qTOqNHwvIffczj",14) == 3437831648) strcat(s, "t");
if (crc32("ArxuOlfdUqIZG",13) == 735607995) strcat(s, "h");
if (crc32("KDZMHEYDXjTR",12) == 2813110318) strcat(s, "e");
if (crc32("hPmzoteABCex",12) == 953628857) strcat(s, "W");
if (crc32("LXzKbVGjRjbUQsJ",15) == 937349089) strcat(s, "d");
if (crc32("DVerEZCw",8) == 3238449476) strcat(s, "e");
if (crc32("xamAHNtDshkwina",15) == 2790118891) strcat(s, "l");
if (crc32("rvBrW",5) == 2424061311) strcat(s, "y");
    return s;
}

char *glaringly_adverbs() {
    char *s = calloc(10);
    if (crc32("WEYLdMAWlxXyK",13) == 2613953858) strcat(s, "g");
if (crc32("dKKNcDIYkl",10) == 1676517331) strcat(s, "l");
if (crc32("yInTqYQLYLjjnh",14) == 1686982730) strcat(s, "a");
if (crc32("EjGhFpqr",8) == 4062654725) strcat(s, "r");
if (crc32("PZIDKYEQp",9) == 3110062108) strcat(s, "R");
if (crc32("iGZGruRuBkvz",12) == 3118709202) strcat(s, "i");
if (crc32("Yvjti",5) == 909037320) strcat(s, "x");
if (crc32("WzuVxxkxWJnwoO",14) == 1314834576) strcat(s, "n");
if (crc32("xbHEOc",6) == 1055545075) strcat(s, "g");
if (crc32("PxkRVppuT",9) == 384696835) strcat(s, "P");
if (crc32("RuwLIuat",8) == 3640463008) strcat(s, "l");
if (crc32("UxNsUyrzVeL",11) == 1727980053) strcat(s, "y");
    return s;
}

char *caudally_adverbs() {
    char *s = calloc(9);
    if (crc32("msdRXkA",7) == 309340146) strcat(s, "c");
if (crc32("GzykfnkRVmt",11) == 684000299) strcat(s, "B");
if (crc32("qciDzLMZaPJGrn",14) == 3887874580) strcat(s, "a");
if (crc32("rYClhzhY",8) == 4034084347) strcat(s, "u");
if (crc32("iPtaZ",5) == 1034800899) strcat(s, "d");
if (crc32("lOQUrHFlhpShEd",14) == 2577539994) strcat(s, "r");
if (crc32("wCwwVotwboZGpo",14) == 2459518184) strcat(s, "a");
if (crc32("KRFkYOynlmBGc",13) == 441378647) strcat(s, "Y");
if (crc32("QBnjjHbdR",9) == 3640328580) strcat(s, "l");
if (crc32("pyvlpVrx",8) == 3199003140) strcat(s, "p");
if (crc32("wrMXrxgTMG",10) == 1686881857) strcat(s, "l");
if (crc32("FcxRonYwfDz",11) == 3618015821) strcat(s, "y");
    return s;
}

char *trimly_adverbs() {
    char *s = calloc(7);
    if (crc32("rbUoiOZwdOmzx",13) == 4101552950) strcat(s, "A");
if (crc32("jCEgoTUIY",9) == 2380412552) strcat(s, "t");
if (crc32("WLZtqwIEU",9) == 643164208) strcat(s, "R");
if (crc32("oQjCd",5) == 2050656311) strcat(s, "r");
if (crc32("VzLCuOIp",8) == 2401459680) strcat(s, "i");
if (crc32("UolVXcNsCeVEO",13) == 2974312191) strcat(s, "m");
if (crc32("lvEhyeGYPl",10) == 2485279092) strcat(s, "l");
if (crc32("LCGIgGjnlhT",11) == 20803762) strcat(s, "f");
if (crc32("kRYEcZaWhpv",11) == 792849961) strcat(s, "y");
    return s;
}

char *unsadly_adverbs() {
    char *s = calloc(8);
    if (crc32("PEijBhRRK",9) == 2039413105) strcat(s, "v");
if (crc32("EmPuOVxkUSDEdr",14) == 2294291072) strcat(s, "u");
if (crc32("NmHoI",5) == 2067885263) strcat(s, "n");
if (crc32("ASUWpoHBJWcLd",13) == 2729192574) strcat(s, "s");
if (crc32("NSjWajEiQnsX",12) == 1228181751) strcat(s, "n");
if (crc32("CKLttBcAhboWvzQ",15) == 2145344114) strcat(s, "a");
if (crc32("noRSkxMVKQpurB",14) == 3266407283) strcat(s, "d");
if (crc32("KgWdxZSYkv",10) == 2376098229) strcat(s, "l");
if (crc32("agpnGhCARp",10) == 269929575) strcat(s, "Q");
if (crc32("zCRXXPsRUmFRBR",14) == 504444529) strcat(s, "y");
    return s;
}

char *frankly_adverbs() {
    char *s = calloc(8);
    if (crc32("rLxkSKPtEDsE",12) == 282722654) strcat(s, "f");
if (crc32("NNZvvCJexPq",11) == 2900312240) strcat(s, "c");
if (crc32("nRolnLNr",8) == 3286316210) strcat(s, "r");
if (crc32("fbypWT",6) == 1470607601) strcat(s, "a");
if (crc32("fwDqmDBYZXh",11) == 2134887826) strcat(s, "k");
if (crc32("MDikUfeZGlDd",12) == 112368289) strcat(s, "n");
if (crc32("UjxAFLQqMRk",11) == 2166310886) strcat(s, "X");
if (crc32("HmQuheCKUG",10) == 2339952863) strcat(s, "k");
if (crc32("JllWs",5) == 4087173237) strcat(s, "b");
if (crc32("gbKSkw",6) == 759604042) strcat(s, "l");
if (crc32("TmFPzGrZ",8) == 1490899433) strcat(s, "y");
    return s;
}

char *circularly_adverbs() {
    char *s = calloc(11);
    if (crc32("gqxZBoavrjudFPj",15) == 1595326520) strcat(s, "a");
if (crc32("tMZmZFEmYsFxa",13) == 719805372) strcat(s, "c");
if (crc32("PGRKSiRC",8) == 640407779) strcat(s, "i");
if (crc32("krcOuF",6) == 184947457) strcat(s, "W");
if (crc32("kIVCacOu",8) == 1647421755) strcat(s, "r");
if (crc32("ahLAUnrt",8) == 684224971) strcat(s, "c");
if (crc32("GmfDN",5) == 1618515428) strcat(s, "A");
if (crc32("eEqCG",5) == 1575316925) strcat(s, "u");
if (crc32("ouwfVyfZoPEpZnl",15) == 4244537745) strcat(s, "P");
if (crc32("vVcUMsBZCr",10) == 247558326) strcat(s, "l");
if (crc32("ToyZo",5) == 2928534411) strcat(s, "a");
if (crc32("zctbXvWvrWeWuc",14) == 2737728914) strcat(s, "r");
if (crc32("mjCtrXzRISrBFGN",15) == 1772037100) strcat(s, "v");
if (crc32("TyydcMUUW",9) == 2137348795) strcat(s, "l");
if (crc32("aFIUggoSlziU",12) == 1276954783) strcat(s, "D");
if (crc32("WVFAbECkFDw",11) == 1478245598) strcat(s, "y");
    return s;
}

char *unpromptly_adverbs() {
    char *s = calloc(11);
    if (crc32("coshPXEDQyyI",12) == 1936078493) strcat(s, "u");
if (crc32("OaqEbuObLhwg",12) == 809151985) strcat(s, "n");
if (crc32("cwbnJcVckDGH",12) == 3900611272) strcat(s, "p");
if (crc32("IeEeTgXuZC",10) == 1613620866) strcat(s, "r");
if (crc32("QsHLhyuFTh",10) == 2716160385) strcat(s, "o");
if (crc32("STDgEKDRg",9) == 700521629) strcat(s, "o");
if (crc32("zSVefASjPg",10) == 1297236796) strcat(s, "m");
if (crc32("JUWwt",5) == 1432187423) strcat(s, "Y");
if (crc32("IYzWpuEnqp",10) == 914685056) strcat(s, "p");
if (crc32("UIEMtQNEc",9) == 297373597) strcat(s, "t");
if (crc32("KrEOxHzVn",9) == 1703534054) strcat(s, "t");
if (crc32("YQMAeofbcXVHSXg",15) == 79548257) strcat(s, "l");
if (crc32("vXUztpVCyTRS",12) == 1324616333) strcat(s, "y");
    return s;
}

char *semiintellectually_adverbs() {
    char *s = calloc(19);
    if (crc32("oTZJg",5) == 198564456) strcat(s, "k");
if (crc32("LlWGsLbJqyD",11) == 559669493) strcat(s, "s");
if (crc32("cZVgJ",5) == 3269919374) strcat(s, "t");
if (crc32("LZyxY",5) == 1373693154) strcat(s, "e");
if (crc32("rcXzZHHtJNnZVE",14) == 1364830224) strcat(s, "y");
if (crc32("aaGNOA",6) == 3703947555) strcat(s, "m");
if (crc32("nVhegVjsi",9) == 2982768302) strcat(s, "i");
if (crc32("rzebmG",6) == 3397994860) strcat(s, "n");
if (crc32("StgOIhCP",8) == 2031742739) strcat(s, "i");
if (crc32("aHLipr",6) == 488181784) strcat(s, "n");
if (crc32("kBAVEhtYoEb",11) == 4251417839) strcat(s, "t");
if (crc32("tLGpTlOPm",9) == 4058496031) strcat(s, "e");
if (crc32("CqbrpaTtbZJlnRa",15) == 951481407) strcat(s, "l");
if (crc32("EjQqGIcNUJoQQPn",15) == 362926009) strcat(s, "l");
if (crc32("BNvIDmo",7) == 2448006869) strcat(s, "e");
if (crc32("RMpUTCAnVc",10) == 509677745) strcat(s, "q");
if (crc32("RGmss",5) == 253975026) strcat(s, "c");
if (crc32("ylzjPytUXyD",11) == 319813699) strcat(s, "t");
if (crc32("YLSQf",5) == 2999484502) strcat(s, "c");
if (crc32("sDnOWS",6) == 916496725) strcat(s, "u");
if (crc32("Wxrmsium",8) == 2866798384) strcat(s, "h");
if (crc32("JQTrJcMYKrk",11) == 195482096) strcat(s, "a");
if (crc32("ALvZRLHo",8) == 1409734721) strcat(s, "Z");
if (crc32("zhdwgHHSozaEXPi",15) == 3998770141) strcat(s, "l");
if (crc32("booOApoGkXwI",12) == 1376127460) strcat(s, "J");
if (crc32("MThMd",5) == 1810038145) strcat(s, "l");
if (crc32("EYWoLQ",6) == 2648328714) strcat(s, "B");
if (crc32("VeqhUoAHhDf",11) == 3991448423) strcat(s, "y");
    return s;
}

char *gymnastically_adverbs() {
    char *s = calloc(14);
    if (crc32("DDVwrIgWRIsob",13) == 2837197194) strcat(s, "R");
if (crc32("HebTpSNlTdpDpp",14) == 3911564607) strcat(s, "g");
if (crc32("TFYoKoK",7) == 1077529562) strcat(s, "R");
if (crc32("JpKfGveycfNfCIH",15) == 447814773) strcat(s, "y");
if (crc32("FsxkbdB",7) == 3230968335) strcat(s, "m");
if (crc32("ljvspL",6) == 1438669930) strcat(s, "n");
if (crc32("BDaoBRRPwPgS",12) == 2378706878) strcat(s, "a");
if (crc32("JnlZHpaSu",9) == 1921498009) strcat(s, "a");
if (crc32("GTjTeMmWz",9) == 147238153) strcat(s, "s");
if (crc32("kjMwWzPxMI",10) == 919480690) strcat(s, "v");
if (crc32("tWMlPYsSG",9) == 4022346878) strcat(s, "t");
if (crc32("KkJdgYiokxdWQNH",15) == 1179343756) strcat(s, "d");
if (crc32("CskqGcfCGCvkQhy",15) == 4195391692) strcat(s, "i");
if (crc32("PdGRjM",6) == 796548227) strcat(s, "c");
if (crc32("vgeLzgBKkXl",11) == 1635434965) strcat(s, "H");
if (crc32("yJtssQXySN",10) == 2321454567) strcat(s, "a");
if (crc32("FrZyNq",6) == 1572430917) strcat(s, "l");
if (crc32("TyIqTGRHuX",10) == 781390756) strcat(s, "N");
if (crc32("sprZNqWvyDPC",12) == 3862493377) strcat(s, "l");
if (crc32("BVPXFxHGPjF",11) == 1740880659) strcat(s, "y");
    return s;
}

char *overbounteously_adverbs() {
    char *s = calloc(16);
    if (crc32("zXmvFo",6) == 1600543534) strcat(s, "t");
if (crc32("okmBjl",6) == 3351675486) strcat(s, "o");
if (crc32("smiouvbr",8) == 2038797972) strcat(s, "h");
if (crc32("DRMIDsCnv",9) == 2613226817) strcat(s, "v");
if (crc32("pJgxpbv",7) == 3371502757) strcat(s, "i");
if (crc32("VLnKtWlKoTwvrN",14) == 727597707) strcat(s, "e");
if (crc32("cNSPRb",6) == 1080631245) strcat(s, "a");
if (crc32("YfsfSzdzlO",10) == 3090851129) strcat(s, "r");
if (crc32("xraQHDOV",8) == 2237869440) strcat(s, "c");
if (crc32("LZIwYIaoPkNA",12) == 2170480386) strcat(s, "b");
if (crc32("prIteMF",7) == 304378442) strcat(s, "o");
if (crc32("tzaKn",5) == 1046514284) strcat(s, "u");
if (crc32("TfokJuUUf",9) == 2268528412) strcat(s, "n");
if (crc32("PFkhQWx",7) == 2979147794) strcat(s, "t");
if (crc32("ZZrbpdvmmlan",12) == 264315363) strcat(s, "w");
if (crc32("wzRVSf",6) == 687160165) strcat(s, "e");
if (crc32("CvVjWRiDLkP",11) == 748391677) strcat(s, "o");
if (crc32("KODvYhVb",8) == 769243427) strcat(s, "N");
if (crc32("hjSZfhHZqH",10) == 2998726526) strcat(s, "u");
if (crc32("hlVLvuhAExoIuL",14) == 4020134609) strcat(s, "x");
if (crc32("yhkGzE",6) == 2117668354) strcat(s, "s");
if (crc32("ZwoyK",5) == 504458984) strcat(s, "l");
if (crc32("QJAakBvoNudMzz",14) == 3040155105) strcat(s, "y");
    return s;
}

char *syne_adverbs() {
    char *s = calloc(5);
    if (crc32("aAewBk",6) == 1979267763) strcat(s, "j");
if (crc32("MrfEzwJy",8) == 2491458067) strcat(s, "s");
if (crc32("jrJLPYP",7) == 1534025259) strcat(s, "y");
if (crc32("CfIAFOdt",8) == 3667256025) strcat(s, "u");
if (crc32("iLaovaPospYJi",13) == 3483002317) strcat(s, "n");
if (crc32("kttxWSRHQ",9) == 4144759311) strcat(s, "e");
    return s;
}

char *nonelastically_adverbs() {
    char *s = calloc(15);
    if (crc32("qPYtDLkOXwdCDpM",15) == 3471652084) strcat(s, "F");
if (crc32("IfxUgbVuNC",10) == 1802789804) strcat(s, "n");
if (crc32("rTVRxAEnDeeEo",13) == 4066250652) strcat(s, "o");
if (crc32("ajmiKlqHAKXP",12) == 2029158044) strcat(s, "n");
if (crc32("juCOBHS",7) == 1600970002) strcat(s, "Q");
if (crc32("BMZZNVtsSTdwgr",14) == 2247439891) strcat(s, "e");
if (crc32("wbXWPMYoCEI",11) == 3902033732) strcat(s, "G");
if (crc32("JOTKBPEjY",9) == 4257700768) strcat(s, "l");
if (crc32("cXMEBdmmxH",10) == 2617505095) strcat(s, "P");
if (crc32("ZTdwEIK",7) == 2707966385) strcat(s, "a");
if (crc32("wjbMkPEFGtyt",12) == 3111117899) strcat(s, "s");
if (crc32("LCaNIyUjNFd",11) == 3574859976) strcat(s, "D");
if (crc32("KypfbnSu",8) == 401230208) strcat(s, "t");
if (crc32("XzItsUClIbqgCkq",15) == 3461531885) strcat(s, "i");
if (crc32("HBrWjWmDagjESmO",15) == 382165558) strcat(s, "c");
if (crc32("HeQvqeo",7) == 1763869438) strcat(s, "a");
if (crc32("ziEXzByuGqbK",12) == 956694957) strcat(s, "l");
if (crc32("KqZBgERGhrQ",11) == 429144716) strcat(s, "l");
if (crc32("UeNUGeXfOyI",11) == 3892420007) strcat(s, "M");
if (crc32("RlRRxkX",7) == 3432833281) strcat(s, "y");
    return s;
}

char *unfulgently_adverbs() {
    char *s = calloc(12);
    if (crc32("iMJKP",5) == 2679007498) strcat(s, "C");
if (crc32("KTplpmPfQGvEw",13) == 153223545) strcat(s, "u");
if (crc32("dDIwsFqejUKSc",13) == 2926913904) strcat(s, "M");
if (crc32("gOiEYYxgvRxsZFl",15) == 303700484) strcat(s, "n");
if (crc32("wFiST",5) == 2302257142) strcat(s, "f");
if (crc32("mVMPuUTVFjlvbR",14) == 1447136532) strcat(s, "J");
if (crc32("yTBEiKL",7) == 3600533659) strcat(s, "u");
if (crc32("CbwITqot",8) == 3591968343) strcat(s, "a");
if (crc32("GdPqmq",6) == 2789348223) strcat(s, "l");
if (crc32("UsRmEp",6) == 2952001502) strcat(s, "g");
if (crc32("DoaSltdMSqcKGRL",15) == 17882447) strcat(s, "e");
if (crc32("dxEja",5) == 3622646571) strcat(s, "n");
if (crc32("OKxwoxnlXkzQIjR",15) == 4282532594) strcat(s, "b");
if (crc32("cLGKCauGSzeE",12) == 2112327679) strcat(s, "t");
if (crc32("yELnuLBYlsNj",12) == 2170324964) strcat(s, "l");
if (crc32("blaVvWuxF",9) == 4185685193) strcat(s, "C");
if (crc32("rmEeVI",6) == 2545753271) strcat(s, "y");
    return s;
}

char *quasiexpediently_adverbs() {
    char *s = calloc(17);
    if (crc32("KmIAstQHDXir",12) == 3815174029) strcat(s, "q");
if (crc32("xvoqrvM",7) == 1929108589) strcat(s, "A");
if (crc32("RdzFtWORoWQEdGe",15) == 815906615) strcat(s, "u");
if (crc32("KzclQjCZZm",10) == 2331344443) strcat(s, "Z");
if (crc32("nhreR",5) == 3559453401) strcat(s, "a");
if (crc32("kmKopcOVHo",10) == 1334724877) strcat(s, "R");
if (crc32("vNujeaJccwCYvw",14) == 1818259409) strcat(s, "s");
if (crc32("MDOWJ",5) == 1778519407) strcat(s, "i");
if (crc32("mGNrSHGVcZ",10) == 1938113404) strcat(s, "e");
if (crc32("CFUazsKAxm",10) == 947343943) strcat(s, "V");
if (crc32("uODFRkZEIOC",11) == 144705500) strcat(s, "x");
if (crc32("tUZtd",5) == 1443167319) strcat(s, "p");
if (crc32("IczzNyZCGDfaZkW",15) == 1061233629) strcat(s, "P");
if (crc32("LzsbTXrTvUQNvX",14) == 423790221) strcat(s, "e");
if (crc32("OhsQgr",6) == 2213696848) strcat(s, "m");
if (crc32("JCxZqK",6) == 416831882) strcat(s, "d");
if (crc32("GANQq",5) == 1148901736) strcat(s, "W");
if (crc32("WlmgAoCICHJmE",13) == 2300836271) strcat(s, "i");
if (crc32("WxkTXAD",7) == 3051740431) strcat(s, "C");
if (crc32("YjkazsmO",8) == 2733202001) strcat(s, "e");
if (crc32("xCkKdNnJJtiQ",12) == 2218451048) strcat(s, "Y");
if (crc32("ZYRKdld",7) == 4089942329) strcat(s, "n");
if (crc32("RYDWIuIvXVcmwkN",15) == 1942855821) strcat(s, "t");
if (crc32("vFxZEVGxB",9) == 2353274630) strcat(s, "l");
if (crc32("zTIcA",5) == 3390374620) strcat(s, "q");
if (crc32("likMLJCYcF",10) == 565618673) strcat(s, "y");
    return s;
}

char *personably_adverbs() {
    char *s = calloc(11);
    if (crc32("szUipEJrinVxt",13) == 1107782133) strcat(s, "p");
if (crc32("AlTajoTNTYLI",12) == 2303218096) strcat(s, "Y");
if (crc32("svpXVLaOY",9) == 58716027) strcat(s, "e");
if (crc32("TXdpkUl",7) == 1793870322) strcat(s, "r");
if (crc32("ZXRqpEZADeURbmN",15) == 3071118408) strcat(s, "r");
if (crc32("KlIOjMHqRZKuDBF",15) == 2171209688) strcat(s, "s");
if (crc32("KAsgcnxsQacHON",14) == 374635290) strcat(s, "r");
if (crc32("reRDL",5) == 3448717031) strcat(s, "o");
if (crc32("MeTEfSoClgGGkg",14) == 3713678136) strcat(s, "g");
if (crc32("jeGiPUgsNWYoIm",14) == 768020420) strcat(s, "n");
if (crc32("SZeaPmnqtu",10) == 1808103238) strcat(s, "a");
if (crc32("QknXoByGYp",10) == 669533712) strcat(s, "P");
if (crc32("BkBwG",5) == 4092522138) strcat(s, "b");
if (crc32("raZnexqxteCqCGc",15) == 1401692009) strcat(s, "l");
if (crc32("kNPJG",5) == 3717841731) strcat(s, "y");
    return s;
}

char *annoyingly_adverbs() {
    char *s = calloc(11);
    if (crc32("mOruk",5) == 4046770451) strcat(s, "C");
if (crc32("hksnwgN",7) == 3370899304) strcat(s, "a");
if (crc32("NOffks",6) == 1126271104) strcat(s, "n");
if (crc32("zqxJv",5) == 965383890) strcat(s, "e");
if (crc32("vbrhHeQcYYlvgg",14) == 4059038191) strcat(s, "n");
if (crc32("WmvvVkYrgZGZ",12) == 1183159323) strcat(s, "Z");
if (crc32("Gmbxx",5) == 399919396) strcat(s, "o");
if (crc32("DfGwTJ",6) == 1792130700) strcat(s, "w");
if (crc32("MzpqTIhUtknL",12) == 3898962058) strcat(s, "y");
if (crc32("FCCctZAUWxuv",12) == 3549206314) strcat(s, "x");
if (crc32("bhwOUVjg",8) == 1528255112) strcat(s, "i");
if (crc32("iGjpOcWO",8) == 3790096765) strcat(s, "n");
if (crc32("OcbEoGhKLpKvdw",14) == 2601896942) strcat(s, "g");
if (crc32("sVRYvfilj",9) == 1777444748) strcat(s, "L");
if (crc32("HMhpuIDNNnfH",12) == 1459493235) strcat(s, "l");
if (crc32("keIcK",5) == 4105019459) strcat(s, "y");
    return s;
}

char *conspiringly_adverbs() {
    char *s = calloc(13);
    if (crc32("KsHYAmReJS",10) == 3606589176) strcat(s, "F");
if (crc32("iZReaNQ",7) == 1543488701) strcat(s, "c");
if (crc32("SbkqCHBuw",9) == 3625151081) strcat(s, "o");
if (crc32("cWDffBDaN",9) == 3397804857) strcat(s, "P");
if (crc32("MSSVVpVK",8) == 1337385385) strcat(s, "n");
if (crc32("boSzybfndgYTEB",14) == 121413118) strcat(s, "s");
if (crc32("ZRdfAHMdlYlIyF",14) == 1246378866) strcat(s, "J");
if (crc32("usHydjVxoqL",11) == 3931268513) strcat(s, "p");
if (crc32("TMGyUZUuolESAH",14) == 3234112661) strcat(s, "P");
if (crc32("PIGhbrLCe",9) == 2051734353) strcat(s, "i");
if (crc32("KDhzn",5) == 3295221396) strcat(s, "r");
if (crc32("oXdsXhtHVnGOIr",14) == 403302422) strcat(s, "i");
if (crc32("LNVFK",5) == 267800514) strcat(s, "n");
if (crc32("zADFEyNeVb",10) == 1701250426) strcat(s, "Y");
if (crc32("ovsUaUKdIfD",11) == 1353452673) strcat(s, "g");
if (crc32("qEYqgJJBluENX",13) == 2782085491) strcat(s, "L");
if (crc32("SNRGTtIxQIJobsi",15) == 1923462456) strcat(s, "l");
if (crc32("ifKEAtNdHBGlEj",14) == 3455522595) strcat(s, "d");
if (crc32("TbyaqCsXMVrd",12) == 3405896200) strcat(s, "y");
    return s;
}

char *steamily_adverbs() {
    char *s = calloc(9);
    if (crc32("caojgjAVSeuIx",13) == 2047320481) strcat(s, "y");
if (crc32("PKqMNmsPaQrds",13) == 3613182129) strcat(s, "s");
if (crc32("quYTeLteiCoyHf",14) == 186122308) strcat(s, "C");
if (crc32("GqHLbfK",7) == 4228248983) strcat(s, "t");
if (crc32("JZtYllbCyyWbmd",14) == 2618574069) strcat(s, "e");
if (crc32("HRlLqtBMEgEVlJ",14) == 773477223) strcat(s, "a");
if (crc32("IBuBGyiEoJ",10) == 3840476183) strcat(s, "m");
if (crc32("LvpBb",5) == 544733366) strcat(s, "i");
if (crc32("SczKvrw",7) == 2102566395) strcat(s, "l");
if (crc32("axxuzuULRgEd",12) == 2579888386) strcat(s, "u");
if (crc32("zBjly",5) == 3784064000) strcat(s, "y");
    return s;
}

char *unannoyingly_adverbs() {
    char *s = calloc(13);
    if (crc32("dxHvrW",6) == 769193941) strcat(s, "Z");
if (crc32("yibtEWmLrEZCj",13) == 287904655) strcat(s, "u");
if (crc32("uwpWDbxrRcep",12) == 2670217580) strcat(s, "D");
if (crc32("ztolJMh",7) == 1424386015) strcat(s, "n");
if (crc32("gqiUHj",6) == 892667441) strcat(s, "G");
if (crc32("pKqxJUnSeOi",11) == 629349141) strcat(s, "a");
if (crc32("SZgYHZiFUmlejW",14) == 205781805) strcat(s, "n");
if (crc32("iPFAXGnN",8) == 3631222527) strcat(s, "y");
if (crc32("tfopKiJYlKM",11) == 1100209465) strcat(s, "n");
if (crc32("jjqTcoZypacEe",13) == 827071315) strcat(s, "o");
if (crc32("rkjzBgPO",8) == 2490433158) strcat(s, "B");
if (crc32("hZMCHAhVSK",10) == 1629404507) strcat(s, "y");
if (crc32("pXCiWKQQs",9) == 3958523052) strcat(s, "h");
if (crc32("HGjIpo",6) == 1643645420) strcat(s, "i");
if (crc32("KrHKGnkC",8) == 3255088172) strcat(s, "Y");
if (crc32("kDQaeaT",7) == 1476476870) strcat(s, "n");
if (crc32("hafprnLrJtI",11) == 285147078) strcat(s, "g");
if (crc32("bkpDCKNrmfxC",12) == 414237098) strcat(s, "e");
if (crc32("rWkKidPw",8) == 1562340034) strcat(s, "l");
if (crc32("FJvfuYVdXrgjfJU",15) == 104713437) strcat(s, "V");
if (crc32("bkYMU",5) == 4098630206) strcat(s, "y");
    return s;
}

char *zoogeographically_adverbs() {
    char *s = calloc(18);
    if (crc32("YDIyF",5) == 4183688600) strcat(s, "z");
if (crc32("yYmQtCzAbmD",11) == 1134952345) strcat(s, "n");
if (crc32("nIPxjxSazAJbzVM",15) == 240927560) strcat(s, "o");
if (crc32("xkZdWOLrgi",10) == 812694891) strcat(s, "o");
if (crc32("PCnbbNtZFII",11) == 3152957064) strcat(s, "g");
if (crc32("wyiFcANXlGzh",12) == 1034357310) strcat(s, "e");
if (crc32("JqvjRGjnrQQM",12) == 2993737180) strcat(s, "o");
if (crc32("URoBEbqH",8) == 3196410535) strcat(s, "g");
if (crc32("quYJfyX",7) == 2585862555) strcat(s, "r");
if (crc32("DxowANfc",8) == 462581555) strcat(s, "a");
if (crc32("XuXvBhEzUsIm",12) == 1617366108) strcat(s, "p");
if (crc32("JwvfknEqmyQU",12) == 1163182053) strcat(s, "h");
if (crc32("NxvKpS",6) == 2733933928) strcat(s, "i");
if (crc32("qaoGyOfum",9) == 1754761428) strcat(s, "c");
if (crc32("cKozmLCtsVVMDu",14) == 2251902605) strcat(s, "a");
if (crc32("xwqpxSulZ",9) == 1242301964) strcat(s, "l");
if (crc32("yFBNRXy",7) == 1302355806) strcat(s, "u");
if (crc32("UDyCkgInwAEdP",13) == 1272104218) strcat(s, "l");
if (crc32("zcjwfXZ",7) == 3422028290) strcat(s, "y");
    return s;
}

char *unbewilderingly_adverbs() {
    char *s = calloc(16);
    if (crc32("ghoeKgFrS",9) == 3932990850) strcat(s, "u");
if (crc32("WJUaYj",6) == 3251825112) strcat(s, "n");
if (crc32("FtOYRCUvjIvyz",13) == 1309215491) strcat(s, "R");
if (crc32("ipKHccwQeE",10) == 3901810570) strcat(s, "b");
if (crc32("xEBMIcFXPOQ",11) == 2495736289) strcat(s, "e");
if (crc32("flrzBoiPqbBRNv",14) == 3133154957) strcat(s, "w");
if (crc32("AeciAYANz",9) == 3406272002) strcat(s, "g");
if (crc32("zMIOnerIJlxC",12) == 2034316638) strcat(s, "i");
if (crc32("QqSiHqLDCOSmlt",14) == 2627346061) strcat(s, "l");
if (crc32("dtixMTV",7) == 1813124882) strcat(s, "d");
if (crc32("BEupXRJR",8) == 2537198518) strcat(s, "E");
if (crc32("DxXcDr",6) == 2191493874) strcat(s, "e");
if (crc32("reUzeD",6) == 1786051881) strcat(s, "r");
if (crc32("AYUphNE",7) == 952581903) strcat(s, "R");
if (crc32("XRXFhYMDiIBFri",14) == 2698846993) strcat(s, "i");
if (crc32("hcShT",5) == 3911940055) strcat(s, "n");
if (crc32("pbdxhVwl",8) == 1027979995) strcat(s, "g");
if (crc32("uHJrF",5) == 1443569591) strcat(s, "l");
if (crc32("kwAlhZukjIkJ",12) == 878000932) strcat(s, "y");
    return s;
}

char *concordantly_adverbs() {
    char *s = calloc(13);
    if (crc32("YiCFogFionNKJZ",14) == 1613575848) strcat(s, "y");
if (crc32("vELjD",5) == 2337880189) strcat(s, "c");
if (crc32("tetKkojVCYHMn",13) == 2167268863) strcat(s, "X");
if (crc32("oNSmQyD",7) == 2165117210) strcat(s, "o");
if (crc32("ftIeXFoAc",9) == 2090590965) strcat(s, "f");
if (crc32("vLJqpHj",7) == 1790464626) strcat(s, "n");
if (crc32("XHZhwpxVqhbr",12) == 50110011) strcat(s, "c");
if (crc32("FhgvmHMxa",9) == 2652642834) strcat(s, "P");
if (crc32("WPNylRddtBvU",12) == 2919575184) strcat(s, "o");
if (crc32("VpjBAiqFvkY",11) == 3703065766) strcat(s, "r");
if (crc32("ZMDdWX",6) == 2002167817) strcat(s, "d");
if (crc32("XKpiYveLTrgWxy",14) == 1482045829) strcat(s, "a");
if (crc32("HHvOOSm",7) == 1977122874) strcat(s, "S");
if (crc32("IikIbWUY",8) == 1470729668) strcat(s, "n");
if (crc32("GTLcfmDzRGjiv",13) == 1679163630) strcat(s, "t");
if (crc32("zhRXwTUaHzPMwTK",15) == 3224740587) strcat(s, "o");
if (crc32("ENViCqVWPuXoPs",14) == 1329782166) strcat(s, "l");
if (crc32("PzNIlpXb",8) == 3966895405) strcat(s, "y");
    return s;
}

char *nonquantitatively_adverbs() {
    char *s = calloc(18);
    if (crc32("MXsIKheg",8) == 3730359407) strcat(s, "n");
if (crc32("VKvEiht",7) == 3756318745) strcat(s, "o");
if (crc32("FousRHSwdy",10) == 1129252720) strcat(s, "n");
if (crc32("fqgXhauRoOy",11) == 1121478539) strcat(s, "q");
if (crc32("fOjqapUk",8) == 681322179) strcat(s, "e");
if (crc32("rtNpIjehHREbvJG",15) == 303929680) strcat(s, "u");
if (crc32("QwUXkqZwklBEm",13) == 1440711628) strcat(s, "a");
if (crc32("DsrVeKADnY",10) == 2068772537) strcat(s, "k");
if (crc32("AkGUYyokkGLBjAX",15) == 4203019379) strcat(s, "n");
if (crc32("eEEzTx",6) == 206425252) strcat(s, "t");
if (crc32("LEprMKfMoEtOd",13) == 2483986247) strcat(s, "S");
if (crc32("YqgpxhRraT",10) == 532114647) strcat(s, "i");
if (crc32("PKcYTS",6) == 3855471089) strcat(s, "Q");
if (crc32("brDTjdsEIEQW",12) == 1149822055) strcat(s, "t");
if (crc32("XYgoTjRjqbKx",12) == 1264437168) strcat(s, "a");
if (crc32("aaHOIzSqDA",10) == 1560065265) strcat(s, "t");
if (crc32("oIugkVF",7) == 2401227965) strcat(s, "v");
if (crc32("WRjuRTb",7) == 2808675331) strcat(s, "i");
if (crc32("rvdsqyWafBAMZE",14) == 374651060) strcat(s, "y");
if (crc32("edqlZvWNAv",10) == 1585103639) strcat(s, "v");
if (crc32("VoVMdvbjSV",10) == 1086975487) strcat(s, "e");
if (crc32("OaERO",5) == 16303428) strcat(s, "G");
if (crc32("QTDVk",5) == 3324833421) strcat(s, "l");
if (crc32("IaKMwtxGJufNAyn",15) == 3122003505) strcat(s, "d");
if (crc32("gshUZRjKLr",10) == 1311319828) strcat(s, "y");
    return s;
}

char *accountably_adverbs() {
    char *s = calloc(12);
    if (crc32("uMyox",5) == 2046150139) strcat(s, "a");
if (crc32("cFkHlOTkO",9) == 2462402717) strcat(s, "c");
if (crc32("PpCdNK",6) == 4100428970) strcat(s, "a");
if (crc32("LfQcivPkJ",9) == 1696795736) strcat(s, "c");
if (crc32("cOFJezJlJCH",11) == 187861791) strcat(s, "N");
if (crc32("bvsWNnMT",8) == 1870830731) strcat(s, "o");
if (crc32("ZYgaTC",6) == 4147298655) strcat(s, "u");
if (crc32("DXdudvsaCVe",11) == 1913145377) strcat(s, "h");
if (crc32("XEafrlaSvjtHjY",14) == 834831916) strcat(s, "n");
if (crc32("vaffyu",6) == 814104085) strcat(s, "J");
if (crc32("wSNcHTDUhpGd",12) == 966412353) strcat(s, "t");
if (crc32("kzLGlkDrESGdY",13) == 2950154162) strcat(s, "N");
if (crc32("gImCfpQx",8) == 1919167976) strcat(s, "a");
if (crc32("AqEts",5) == 2218562114) strcat(s, "b");
if (crc32("AcyFQVImtc",10) == 3167338102) strcat(s, "s");
if (crc32("xskroq",6) == 2532593390) strcat(s, "l");
if (crc32("SSmRoUdZkQDQl",13) == 3949018358) strcat(s, "W");
if (crc32("LpnooeFtBUgy",12) == 2708677221) strcat(s, "y");
    return s;
}

char *amphitheatrically_adverbs() {
    char *s = calloc(18);
    if (crc32("BNoAAqnM",8) == 51879568) strcat(s, "a");
if (crc32("OdCDmcWDBdFamz",14) == 1043025317) strcat(s, "m");
if (crc32("hICgpkEOBprBX",13) == 2789661858) strcat(s, "p");
if (crc32("UtMGC",5) == 438292390) strcat(s, "x");
if (crc32("sctZJ",5) == 3563513907) strcat(s, "h");
if (crc32("DXAKdYxCpjyAVyh",15) == 2889959263) strcat(s, "i");
if (crc32("jwUAuXdSLV",10) == 3714631218) strcat(s, "A");
if (crc32("Bstxx",5) == 2002467130) strcat(s, "t");
if (crc32("ZFjumBccETkcfcg",15) == 2734624512) strcat(s, "h");
if (crc32("axmSPypWyQ",10) == 1742933501) strcat(s, "y");
if (crc32("JbNroGHcfmL",11) == 3213330636) strcat(s, "e");
if (crc32("TlPqYiISDNyZBjh",15) == 1651553020) strcat(s, "i");
if (crc32("GGRgRr",6) == 1398155876) strcat(s, "a");
if (crc32("wpVrTAcrppubVUb",15) == 513310014) strcat(s, "q");
if (crc32("UPOcrwroxPFEB",13) == 3241872323) strcat(s, "t");
if (crc32("ipwziofBx",9) == 507765681) strcat(s, "r");
if (crc32("qEPgYvb",7) == 2947568756) strcat(s, "i");
if (crc32("AfQIiZamnFLTfP",14) == 1031735044) strcat(s, "i");
if (crc32("ZaHQDVapyHxvIl",14) == 3245034999) strcat(s, "c");
if (crc32("yhPvLrsIHj",10) == 3162340993) strcat(s, "a");
if (crc32("iWEAUgnju",9) == 808138028) strcat(s, "l");
if (crc32("jjbXOCHczrtvzPA",15) == 1563500990) strcat(s, "l");
if (crc32("ZoLDx",5) == 1687142537) strcat(s, "y");
    return s;
}

char *unsplendidly_adverbs() {
    char *s = calloc(13);
    if (crc32("YLiAOYaLHzfnN",13) == 3132826216) strcat(s, "u");
if (crc32("XGoISdZaav",10) == 3849267539) strcat(s, "n");
if (crc32("ERYceoL",7) == 94022163) strcat(s, "s");
if (crc32("plKKKHea",8) == 2953323241) strcat(s, "X");
if (crc32("wvNKHbTWgpfNe",13) == 2401267401) strcat(s, "p");
if (crc32("yrjpJzNb",8) == 2650697475) strcat(s, "l");
if (crc32("MZFdyOOLCxw",11) == 4135585517) strcat(s, "e");
if (crc32("JpDcLFStWIkv",12) == 2012570905) strcat(s, "h");
if (crc32("FsPHsHIyYFC",11) == 2548743930) strcat(s, "n");
if (crc32("ZKvrtrAUT",9) == 3901844811) strcat(s, "W");
if (crc32("YPBOpIHJIshDjCf",15) == 224074907) strcat(s, "d");
if (crc32("yjwUv",5) == 1232036105) strcat(s, "i");
if (crc32("sNyDUHAc",8) == 1153468162) strcat(s, "v");
if (crc32("qftqpwzzPrR",11) == 4229438439) strcat(s, "d");
if (crc32("TEqWjYuLKACP",12) == 406203859) strcat(s, "P");
if (crc32("LRnofhiYuHB",11) == 1274047078) strcat(s, "l");
if (crc32("SDxFnhOe",8) == 4069438486) strcat(s, "D");
if (crc32("wccfDq",6) == 2947134867) strcat(s, "y");
    return s;
}

char *Bristolfashion_adverbs() {
    char *s = calloc(15);
    if (crc32("TBtXYigI",8) == 2729257759) strcat(s, "r");
if (crc32("HwMKlMYeKKb",11) == 1114016895) strcat(s, "B");
if (crc32("FPCkcAW",7) == 330369595) strcat(s, "r");
if (crc32("XUbHDLWMYplXd",13) == 4064600434) strcat(s, "i");
if (crc32("HudBtkvQ",8) == 1435112384) strcat(s, "s");
if (crc32("bCbeBXnSzbwfWml",15) == 272444587) strcat(s, "t");
if (crc32("QssucniE",8) == 601924219) strcat(s, "q");
if (crc32("BqLrTWnR",8) == 3968495343) strcat(s, "o");
if (crc32("iwyhldqeoL",10) == 3474655670) strcat(s, "Q");
if (crc32("gbOhOd",6) == 4283211284) strcat(s, "l");
if (crc32("LrwHjKkMQJh",11) == 1915850967) strcat(s, "C");
if (crc32("grXrd",5) == 427816298) strcat(s, "f");
if (crc32("dFAezKJzYjJSVLr",15) == 617880592) strcat(s, "a");
if (crc32("vNTaSOOrz",9) == 433777750) strcat(s, "N");
if (crc32("cumXxARSfBjW",12) == 3800937612) strcat(s, "s");
if (crc32("ZVDwfmJXLnF",11) == 4253348470) strcat(s, "V");
if (crc32("OEaKie",6) == 2842523997) strcat(s, "h");
if (crc32("eXHWFejRmPaBr",13) == 2183606175) strcat(s, "F");
if (crc32("DILvgdWd",8) == 1097088568) strcat(s, "i");
if (crc32("OthMwayCzl",10) == 3728967289) strcat(s, "R");
if (crc32("OoSmLB",6) == 151462156) strcat(s, "o");
if (crc32("LVhsDuDTwR",10) == 2280224566) strcat(s, "n");
    return s;
}

char *quasinaturally_adverbs() {
    char *s = calloc(15);
    if (crc32("hAjnSoTN",8) == 1627126831) strcat(s, "i");
if (crc32("tWHvkLyZS",9) == 1745678076) strcat(s, "q");
if (crc32("VOywrzC",7) == 1279106233) strcat(s, "u");
if (crc32("wxLXxQy",7) == 284405783) strcat(s, "a");
if (crc32("BrdMOqZCFACoT",13) == 1149635287) strcat(s, "r");
if (crc32("MrOEpF",6) == 2226164141) strcat(s, "s");
if (crc32("fHlqcBvTqMoyfOM",15) == 716426314) strcat(s, "W");
if (crc32("DSezdIDSRd",10) == 2437882309) strcat(s, "i");
if (crc32("EoNjeiGyMi",10) == 4286480220) strcat(s, "g");
if (crc32("sxzLGiNGyjexB",13) == 1346953829) strcat(s, "n");
if (crc32("qBpGVL",6) == 3740186718) strcat(s, "a");
if (crc32("Yvfhd",5) == 383014555) strcat(s, "t");
if (crc32("ZQvVFFD",7) == 1592419576) strcat(s, "e");
if (crc32("FSbavTQOvvIBmT",14) == 4096459664) strcat(s, "u");
if (crc32("pRwsgiFs",8) == 1538647569) strcat(s, "r");
if (crc32("giPLmxwytAfTL",13) == 1883856202) strcat(s, "Z");
if (crc32("pHnTyMLEdMZl",12) == 1704525518) strcat(s, "a");
if (crc32("WUHcxoKnEgw",11) == 509783679) strcat(s, "l");
if (crc32("bOnQNhqCXZNv",12) == 3009850414) strcat(s, "l");
if (crc32("dZpNy",5) == 502401557) strcat(s, "y");
    return s;
}

char *untensely_adverbs() {
    char *s = calloc(10);
    if (crc32("iICKSAuPhsIjc",13) == 261161795) strcat(s, "L");
if (crc32("ajNcrsF",7) == 457865336) strcat(s, "u");
if (crc32("WwdihUC",7) == 1120910611) strcat(s, "n");
if (crc32("MOlVj",5) == 2776458078) strcat(s, "n");
if (crc32("nQekCeBFwGqMX",13) == 434104700) strcat(s, "t");
if (crc32("kJbTPm",6) == 2995840903) strcat(s, "e");
if (crc32("HNATCUxFXUVSBP",14) == 2871090203) strcat(s, "n");
if (crc32("XyplilJEbTqAmsC",15) == 965048780) strcat(s, "W");
if (crc32("YkrfyUyE",8) == 1919513937) strcat(s, "s");
if (crc32("wydGEfqlkXfqAjt",15) == 2438614493) strcat(s, "F");
if (crc32("gNBVIxrZ",8) == 1957848098) strcat(s, "e");
if (crc32("FiJaQ",5) == 617426274) strcat(s, "J");
if (crc32("EJVJyQDuXZ",10) == 895044968) strcat(s, "l");
if (crc32("AulyVPz",7) == 206626799) strcat(s, "y");
    return s;
}

char *macaronically_adverbs() {
    char *s = calloc(14);
    if (crc32("miUyadxr",8) == 750540774) strcat(s, "V");
if (crc32("hpVIkjvUBwyCH",13) == 3978575776) strcat(s, "m");
if (crc32("qyhMtva",7) == 726313910) strcat(s, "a");
if (crc32("KIWKp",5) == 1545460923) strcat(s, "l");
if (crc32("pDoPKaqZdXIKfo",14) == 1106927005) strcat(s, "c");
if (crc32("BFYCBbaRZMwXjh",14) == 2704178516) strcat(s, "t");
if (crc32("xemCky",6) == 320975233) strcat(s, "a");
if (crc32("nItrWdYxOkk",11) == 2172672881) strcat(s, "r");
if (crc32("hXjMDjVSB",9) == 2213298367) strcat(s, "o");
if (crc32("rYKuTHUmWjgMhrn",15) == 2196207442) strcat(s, "o");
if (crc32("VgYZQqtoMQHzMm",14) == 1702631265) strcat(s, "n");
if (crc32("VqhKRzdWFLsV",12) == 241231126) strcat(s, "i");
if (crc32("EiExdEMGoAOleyJ",15) == 2805684893) strcat(s, "Q");
if (crc32("eZEjnwIyhbSXY",13) == 1391902539) strcat(s, "c");
if (crc32("uyBVKFJEVjdrtG",14) == 2887276554) strcat(s, "X");
if (crc32("FvQabyW",7) == 2709790298) strcat(s, "a");
if (crc32("HcVwjptB",8) == 3480197654) strcat(s, "J");
if (crc32("XbZgfdlbea",10) == 464010910) strcat(s, "l");
if (crc32("ZyxNsEpKIOw",11) == 961221997) strcat(s, "D");
if (crc32("tixriJtEthLwQh",14) == 775259636) strcat(s, "l");
if (crc32("zMmbZOMWA",9) == 2750821034) strcat(s, "y");
    return s;
}

char *ardently_adverbs() {
    char *s = calloc(9);
    if (crc32("KaVonJe",7) == 3080835566) strcat(s, "A");
if (crc32("uTrHwcXKTnMcd",13) == 1775598262) strcat(s, "a");
if (crc32("ScntVbHswRZY",12) == 2186122070) strcat(s, "r");
if (crc32("tYvFEfckqome",12) == 2645513520) strcat(s, "d");
if (crc32("RHAgezinMVdXk",13) == 3663540937) strcat(s, "e");
if (crc32("mbCrYUHCeHoE",12) == 1060523739) strcat(s, "n");
if (crc32("phzqIgaDHZ",10) == 2209355462) strcat(s, "d");
if (crc32("uRRCc",5) == 4140009841) strcat(s, "t");
if (crc32("wjZovtDCzuLFU",13) == 443427185) strcat(s, "g");
if (crc32("rnfJlIIZMHq",11) == 1731295977) strcat(s, "l");
if (crc32("OYCzMId",7) == 207203886) strcat(s, "y");
    return s;
}

char *equinely_adverbs() {
    char *s = calloc(9);
    if (crc32("HbQClSNOzzd",11) == 888415744) strcat(s, "e");
if (crc32("DzZRZPiiM",9) == 3707638108) strcat(s, "q");
if (crc32("vMtKgVT",7) == 740952180) strcat(s, "u");
if (crc32("ySNyiYLNEZgKiYs",15) == 1365512437) strcat(s, "i");
if (crc32("AMjFirQtcPVnj",13) == 3228537725) strcat(s, "n");
if (crc32("FDXiI",5) == 3698836300) strcat(s, "e");
if (crc32("fWUnjY",6) == 532798887) strcat(s, "q");
if (crc32("IjfMT",5) == 2731657589) strcat(s, "l");
if (crc32("wKxYCRJqYbmm",12) == 2184087666) strcat(s, "y");
    return s;
}

char *navally_adverbs() {
    char *s = calloc(8);
    if (crc32("XEUztZsPEutDbAG",15) == 3151795907) strcat(s, "V");
if (crc32("nqBkKv",6) == 2566582342) strcat(s, "n");
if (crc32("KQjqsxbvlpKvK",13) == 4253976143) strcat(s, "a");
if (crc32("TMUpPvd",7) == 2807148366) strcat(s, "A");
if (crc32("pfkyDjqfKFSvY",13) == 3386203152) strcat(s, "v");
if (crc32("oSncxkWtPBpV",12) == 2490773712) strcat(s, "a");
if (crc32("PSaUXOIUtIG",11) == 3392865268) strcat(s, "l");
if (crc32("cuDXmRs",7) == 465702426) strcat(s, "o");
if (crc32("eCUUgRygJSn",11) == 25105123) strcat(s, "l");
if (crc32("csVlbHAsWUP",11) == 390976208) strcat(s, "c");
if (crc32("aBjbCVWifp",10) == 1009317126) strcat(s, "y");
    return s;
}

char *interpretably_adverbs() {
    char *s = calloc(14);
    if (crc32("OVnnL",5) == 884655427) strcat(s, "i");
if (crc32("xgFXtmzuCvuJ",12) == 1044255500) strcat(s, "n");
if (crc32("wgtKXxAMX",9) == 698452201) strcat(s, "C");
if (crc32("ChyqfzqCKeB",11) == 700242605) strcat(s, "t");
if (crc32("FBGDaIz",7) == 1072219846) strcat(s, "n");
if (crc32("ZkOpnq",6) == 3117411286) strcat(s, "e");
if (crc32("mwSfWl",6) == 275312069) strcat(s, "l");
if (crc32("HTVUXIwevJDNDQ",14) == 1042145713) strcat(s, "r");
if (crc32("MjArFXxSmnV",11) == 1126020902) strcat(s, "u");
if (crc32("BEubGaFCm",9) == 2037728789) strcat(s, "p");
if (crc32("DjSaezeKnAN",11) == 3371306163) strcat(s, "r");
if (crc32("YdtHLpPbrNwXZNw",15) == 4138881898) strcat(s, "e");
if (crc32("LpdsxYNddiNwg",13) == 2937298730) strcat(s, "q");
if (crc32("TqvXT",5) == 2519338940) strcat(s, "t");
if (crc32("JxEjYaqK",8) == 535890424) strcat(s, "d");
if (crc32("PAeozspsWSHh",12) == 4074078376) strcat(s, "a");
if (crc32("pMSIKV",6) == 102842865) strcat(s, "n");
if (crc32("IZAjVFcrSHNYdn",14) == 2039041734) strcat(s, "b");
if (crc32("ZLRIUPwaaxX",11) == 1630439973) strcat(s, "l");
if (crc32("dlyHVlKn",8) == 790077587) strcat(s, "y");
    return s;
}

char *injunctively_adverbs() {
    char *s = calloc(13);
    if (crc32("iOAwwLQfmcCgCoD",15) == 3638694628) strcat(s, "i");
if (crc32("PNqxUebJnJK",11) == 2625182552) strcat(s, "n");
if (crc32("VpQGztTK",8) == 1499138677) strcat(s, "X");
if (crc32("lxxdOHVF",8) == 2021793940) strcat(s, "j");
if (crc32("LvdyH",5) == 4043930868) strcat(s, "F");
if (crc32("xFofArSDRYug",12) == 1386572261) strcat(s, "u");
if (crc32("vzQUcOPUGkL",11) == 3904007826) strcat(s, "n");
if (crc32("LzGNSrrbE",9) == 4014773254) strcat(s, "c");
if (crc32("ZgrQhbfmsorWg",13) == 367299371) strcat(s, "t");
if (crc32("MbnUjhcEGVe",11) == 939219347) strcat(s, "i");
if (crc32("YknmolrIvzrzc",13) == 2145085128) strcat(s, "w");
if (crc32("dVpYU",5) == 1618959832) strcat(s, "v");
if (crc32("XJuzDpPcaT",10) == 781861427) strcat(s, "j");
if (crc32("xhxsIz",6) == 2527469719) strcat(s, "e");
if (crc32("ZWXtwawwq",9) == 2686158104) strcat(s, "l");
if (crc32("zQKKy",5) == 1080711875) strcat(s, "l");
if (crc32("EsDWcITM",8) == 1195886888) strcat(s, "y");
    return s;
}

char *crispily_adverbs() {
    char *s = calloc(9);
    if (crc32("MKQngR",6) == 3003552284) strcat(s, "c");
if (crc32("mnEUVtei",8) == 3411628083) strcat(s, "r");
if (crc32("TlZWm",5) == 3717442493) strcat(s, "i");
if (crc32("uTehGuSz",8) == 3536614358) strcat(s, "s");
if (crc32("LqkUuX",6) == 3158469351) strcat(s, "p");
if (crc32("ISqJpNjHotBi",12) == 3357213143) strcat(s, "w");
if (crc32("IUtDrnfB",8) == 936842049) strcat(s, "i");
if (crc32("lHLfOmtZboEv",12) == 2415507785) strcat(s, "l");
if (crc32("cgaxMKokQKWbJdj",15) == 3282353518) strcat(s, "y");
    return s;
}

char *underzealously_adverbs() {
    char *s = calloc(15);
    if (crc32("ghEoAp",6) == 1532463527) strcat(s, "u");
if (crc32("mTMpKwgqfAO",11) == 676650152) strcat(s, "n");
if (crc32("iObBWcW",7) == 2106531436) strcat(s, "d");
if (crc32("xnFwVlVtDvw",11) == 1207948642) strcat(s, "e");
if (crc32("MVvKd",5) == 1085156901) strcat(s, "V");
if (crc32("CZGSVgaYSdDCsM",14) == 3496495612) strcat(s, "r");
if (crc32("CFRjQoUR",8) == 2339468756) strcat(s, "p");
if (crc32("YNhXAtvDsFrmkQ",14) == 3032215616) strcat(s, "z");
if (crc32("wjAOgtmiTCLNrs",14) == 3103322053) strcat(s, "e");
if (crc32("wkqHCOM",7) == 4034589575) strcat(s, "d");
if (crc32("aWEuvvRX",8) == 44257703) strcat(s, "a");
if (crc32("xGQatUTUab",10) == 2501548) strcat(s, "c");
if (crc32("FDXHsRSLIUyKrt",14) == 2733469407) strcat(s, "l");
if (crc32("VYlvEOz",7) == 1428077315) strcat(s, "o");
if (crc32("YRxdb",5) == 2621011979) strcat(s, "t");
if (crc32("vXJGFbhzHYLq",12) == 2745819148) strcat(s, "u");
if (crc32("haBhrkjXx",9) == 738843993) strcat(s, "s");
if (crc32("FBuMpaTZUFfgST",14) == 3658072699) strcat(s, "l");
if (crc32("lzqJWEqWXoTEnI",14) == 143289882) strcat(s, "y");
    return s;
}

char *anamnestically_adverbs() {
    char *s = calloc(15);
    if (crc32("NcRLeq",6) == 2098113255) strcat(s, "a");
if (crc32("VYFDreDMeWBU",12) == 130648418) strcat(s, "q");
if (crc32("fFqFBW",6) == 671629142) strcat(s, "n");
if (crc32("zpfNUp",6) == 144949283) strcat(s, "F");
if (crc32("hqQImsd",7) == 149300563) strcat(s, "a");
if (crc32("wBvmX",5) == 1498579898) strcat(s, "m");
if (crc32("gmIbezKvX",9) == 1716420869) strcat(s, "s");
if (crc32("YWCnfBQx",8) == 4141495609) strcat(s, "n");
if (crc32("wjghyLh",7) == 2483406521) strcat(s, "T");
if (crc32("KxpTGOxIrLyRO",13) == 3811308548) strcat(s, "e");
if (crc32("gcIulYSV",8) == 1611194514) strcat(s, "F");
if (crc32("lGnjVHmq",8) == 3842570474) strcat(s, "s");
if (crc32("ITNyDVKmE",9) == 2490524352) strcat(s, "t");
if (crc32("KyIQXSpCyxT",11) == 421022683) strcat(s, "J");
if (crc32("lCJGiDMqAI",10) == 2920842100) strcat(s, "i");
if (crc32("rQmPXMHe",8) == 4044296652) strcat(s, "c");
if (crc32("OnNvY",5) == 3601739615) strcat(s, "a");
if (crc32("ELFKMynqxRrPyKM",15) == 2395598176) strcat(s, "h");
if (crc32("hKEWrSbVoLTuJS",14) == 748028034) strcat(s, "l");
if (crc32("TXmouFrEWjfEx",13) == 339109530) strcat(s, "y");
if (crc32("SDdup",5) == 3765703199) strcat(s, "l");
if (crc32("tfbmKVGXe",9) == 55339914) strcat(s, "Z");
if (crc32("jOSErjoqLht",11) == 89815090) strcat(s, "y");
    return s;
}

char *nonBiblically_adverbs() {
    char *s = calloc(14);
    if (crc32("gXRvwPdt",8) == 1414512795) strcat(s, "n");
if (crc32("kMacsejIvTUI",12) == 2398241426) strcat(s, "o");
if (crc32("ZwNhPKqCU",9) == 4286286412) strcat(s, "r");
if (crc32("BEdXXoGKU",9) == 4266383973) strcat(s, "n");
if (crc32("MqpazOfCNnUDIW",14) == 467823065) strcat(s, "m");
if (crc32("hxfaa",5) == 3420651352) strcat(s, "B");
if (crc32("FGnJI",5) == 1351451361) strcat(s, "i");
if (crc32("UdIRCVnIy",9) == 1170835500) strcat(s, "W");
if (crc32("XbwrmwTfZXJKr",13) == 321840042) strcat(s, "b");
if (crc32("yCOhkWp",7) == 2820455518) strcat(s, "l");
if (crc32("HjiuimpepOxfAR",14) == 120491247) strcat(s, "i");
if (crc32("ukotQsF",7) == 1222869547) strcat(s, "c");
if (crc32("VmLoylzN",8) == 1266899443) strcat(s, "E");
if (crc32("xgYIaNplkhczDkf",15) == 1346372423) strcat(s, "a");
if (crc32("sIIktSt",7) == 362547722) strcat(s, "J");
if (crc32("MoZOcTwYbQqOPMP",15) == 1930531299) strcat(s, "l");
if (crc32("RKHrjuXTDLrlv",13) == 1527219088) strcat(s, "u");
if (crc32("bSJpLEQEyfNZf",13) == 527621062) strcat(s, "l");
if (crc32("jUKqctYHBlaMA",13) == 1366938407) strcat(s, "x");
if (crc32("yTRSZXFQvjdYTre",15) == 146479850) strcat(s, "y");
    return s;
}

char *sedulously_adverbs() {
    char *s = calloc(11);
    if (crc32("hKneZT",6) == 3287411716) strcat(s, "s");
if (crc32("wTUmNNVWiJIDt",13) == 2097834765) strcat(s, "e");
if (crc32("mPvodmJ",7) == 1741739534) strcat(s, "d");
if (crc32("bWKNlXMvqJK",11) == 114203963) strcat(s, "L");
if (crc32("rrkZiWgL",8) == 2587611154) strcat(s, "u");
if (crc32("zNSATSQ",7) == 1250835244) strcat(s, "G");
if (crc32("YoFUAHYRnNIBtH",14) == 1051217854) strcat(s, "l");
if (crc32("xDcdSFXLT",9) == 3124230742) strcat(s, "o");
if (crc32("VFXNmpjDE",9) == 4158245623) strcat(s, "T");
if (crc32("SQtIN",5) == 688353942) strcat(s, "u");
if (crc32("YujQDhmIOxgXbti",15) == 665027716) strcat(s, "v");
if (crc32("XGLxrzcYEo",10) == 3178911509) strcat(s, "s");
if (crc32("DzAajWXE",8) == 2835830334) strcat(s, "l");
if (crc32("vzwUp",5) == 3520380793) strcat(s, "I");
if (crc32("YePfA",5) == 2702822913) strcat(s, "y");
    return s;
}

char *quasifavorably_adverbs() {
    char *s = calloc(15);
    if (crc32("CvIoqeQXrx",10) == 2650233004) strcat(s, "q");
if (crc32("euoIOgmXDO",10) == 3139327033) strcat(s, "t");
if (crc32("SBoYfyXlqEoulwO",15) == 161154227) strcat(s, "u");
if (crc32("KRCGtaTD",8) == 3299774162) strcat(s, "a");
if (crc32("yMYLI",5) == 1799297345) strcat(s, "s");
if (crc32("wHWOTYnAEnJ",11) == 4108526391) strcat(s, "K");
if (crc32("UWXQO",5) == 1197985697) strcat(s, "i");
if (crc32("aMNPA",5) == 2885269876) strcat(s, "e");
if (crc32("KWTPERDSkLJ",11) == 306671723) strcat(s, "f");
if (crc32("hsqyjKAriyhie",13) == 1773805017) strcat(s, "a");
if (crc32("BpFPYwzr",8) == 2407551993) strcat(s, "v");
if (crc32("eyLCLuRqO",9) == 414641403) strcat(s, "r");
if (crc32("lXoSSThwyTD",11) == 3979844251) strcat(s, "o");
if (crc32("DGOzvMJMHssmoK",14) == 2468676297) strcat(s, "F");
if (crc32("UubDEQRaQgftBFU",15) == 1151830643) strcat(s, "r");
if (crc32("AjhajjKJV",9) == 1718757376) strcat(s, "a");
if (crc32("YhhvxXQttfbY",12) == 1420874954) strcat(s, "A");
if (crc32("kwzimWBeQOf",11) == 3449882360) strcat(s, "b");
if (crc32("gVdASYJ",7) == 3577378384) strcat(s, "l");
if (crc32("gQNzbWPruLAlE",13) == 2824881062) strcat(s, "y");
    return s;
}

char *auricularly_adverbs() {
    char *s = calloc(12);
    if (crc32("PUKYPwWDrclG",12) == 2628440108) strcat(s, "a");
if (crc32("MTtYwX",6) == 1298777369) strcat(s, "u");
if (crc32("yZuFtSPIFNTrLj",14) == 501460993) strcat(s, "w");
if (crc32("FLDtRwmmtTCJAK",14) == 455417677) strcat(s, "r");
if (crc32("cMzsjoGzEVtAiZy",15) == 1443640045) strcat(s, "E");
if (crc32("CBroBeYFi",9) == 923843113) strcat(s, "i");
if (crc32("WyJVObQuDYm",11) == 1980552350) strcat(s, "R");
if (crc32("qAhBlpSQ",8) == 2311846314) strcat(s, "c");
if (crc32("UFUqrwGyXvxlC",13) == 1004821815) strcat(s, "u");
if (crc32("iVPKr",5) == 3617003271) strcat(s, "O");
if (crc32("isTKROGFszSyj",13) == 148868097) strcat(s, "l");
if (crc32("mSJtfAvAy",9) == 2870443604) strcat(s, "I");
if (crc32("AfkEZwd",7) == 2820620977) strcat(s, "a");
if (crc32("jkszvYQHvS",10) == 4294562631) strcat(s, "r");
if (crc32("vaAtTRlOn",9) == 999275581) strcat(s, "l");
if (crc32("lMSQGcaQ",8) == 3163590398) strcat(s, "g");
if (crc32("UOiIXIMVrAdxEZZ",15) == 2239449790) strcat(s, "y");
    return s;
}

char *unreproachably_adverbs() {
    char *s = calloc(15);
    if (crc32("BeRKRMQjRcoi",12) == 3933181121) strcat(s, "L");
if (crc32("MDdjDR",6) == 1325650659) strcat(s, "u");
if (crc32("gTGyIcA",7) == 199868530) strcat(s, "T");
if (crc32("npgbbabXdxDeT",13) == 550563538) strcat(s, "n");
if (crc32("OrIkralJBMEBAm",14) == 698786418) strcat(s, "E");
if (crc32("PMpDVYABxkiU",12) == 2839626490) strcat(s, "r");
if (crc32("jkSlWOSmEr",10) == 1666994428) strcat(s, "t");
if (crc32("DCViDGIkKxkhi",13) == 3349302039) strcat(s, "e");
if (crc32("cWRwjlB",7) == 2068879070) strcat(s, "e");
if (crc32("pWerMMZjzu",10) == 3890650681) strcat(s, "p");
if (crc32("UTXxXLElOB",10) == 3441885236) strcat(s, "B");
if (crc32("MoFFAhbOqRRb",12) == 2103622744) strcat(s, "r");
if (crc32("vNRuAFgrHKZ",11) == 1922322145) strcat(s, "o");
if (crc32("LsSenjomS",9) == 2194040892) strcat(s, "R");
if (crc32("DnLYbLWkmQqiR",13) == 3572255561) strcat(s, "a");
if (crc32("KstIAwLtimB",11) == 3316931432) strcat(s, "w");
if (crc32("qYMmHejKN",9) == 2044494846) strcat(s, "c");
if (crc32("zeoFgDWPDNTUrE",14) == 349860732) strcat(s, "h");
if (crc32("ddqbLoBSLr",10) == 2550328027) strcat(s, "a");
if (crc32("zyuvlj",6) == 2265703707) strcat(s, "b");
if (crc32("qDBLWNKq",8) == 1918779799) strcat(s, "l");
if (crc32("ihRTGLPDoeajx",13) == 3573541421) strcat(s, "y");
    return s;
}

char *electrodialitically_adverbs() {
    char *s = calloc(20);
    if (crc32("RTDrnlroTYQqq",13) == 3798460462) strcat(s, "X");
if (crc32("fyuIdZKPVnP",11) == 2612690139) strcat(s, "e");
if (crc32("DtYWk",5) == 3288029219) strcat(s, "l");
if (crc32("RopYnvXgCT",10) == 2008237316) strcat(s, "e");
if (crc32("dRKuHgwaJ",9) == 4058748685) strcat(s, "b");
if (crc32("NczjvPwkPe",10) == 3290442119) strcat(s, "c");
if (crc32("OIwzKp",6) == 704157347) strcat(s, "w");
if (crc32("IPPHFzbN",8) == 899578802) strcat(s, "t");
if (crc32("fZnIRrVa",8) == 1933264053) strcat(s, "r");
if (crc32("bjVsaElECQMjZgw",15) == 1759948570) strcat(s, "o");
if (crc32("YPkhdJTI",8) == 3748729856) strcat(s, "d");
if (crc32("nHWWxr",6) == 553237475) strcat(s, "F");
if (crc32("nKJDJkGD",8) == 2606586675) strcat(s, "i");
if (crc32("dJhkjLNKk",9) == 2242203089) strcat(s, "B");
if (crc32("YozBiZaBFVt",11) == 2940719874) strcat(s, "a");
if (crc32("cQkZggAhPhqq",12) == 918875319) strcat(s, "l");
if (crc32("udvSeaLkpBUDaPU",15) == 18007988) strcat(s, "A");
if (crc32("lqYbFz",6) == 3789785146) strcat(s, "i");
if (crc32("LJMRQSbg",8) == 962981637) strcat(s, "i");
if (crc32("ZuAoOhyFPyvzqI",14) == 555917906) strcat(s, "t");
if (crc32("oTubbvgyE",9) == 1470531410) strcat(s, "i");
if (crc32("FiWUWGCVQy",10) == 1045539051) strcat(s, "c");
if (crc32("GCEovsMa",8) == 284117493) strcat(s, "a");
if (crc32("wYCKFAhbLDzyb",13) == 2019139128) strcat(s, "l");
if (crc32("CvIbjPx",7) == 4112939486) strcat(s, "y");
if (crc32("EkAyuYidngWf",12) == 1533468679) strcat(s, "l");
if (crc32("qwOjvIXFGBb",11) == 4097232987) strcat(s, "D");
if (crc32("NmkNOnXvtkJJtyc",15) == 931134940) strcat(s, "y");
    return s;
}

char *suspiciously_adverbs() {
    char *s = calloc(13);
    if (crc32("WXLZKbKdZrAygs",14) == 788642761) strcat(s, "Q");
if (crc32("CSCGfwjMdymfPI",14) == 2607486977) strcat(s, "s");
if (crc32("EdcfmPuIiVjNH",13) == 3602458307) strcat(s, "u");
if (crc32("IknTltoaSo",10) == 1481087354) strcat(s, "s");
if (crc32("zXVmBxKGSYI",11) == 831742165) strcat(s, "T");
if (crc32("EqVwOpbrvK",10) == 2678782536) strcat(s, "p");
if (crc32("xaMOXFIfJrE",11) == 130942688) strcat(s, "j");
if (crc32("EUlVBVfSdfD",11) == 1912227571) strcat(s, "i");
if (crc32("OGQCltvP",8) == 4239702695) strcat(s, "c");
if (crc32("xXmFtZwzQ",9) == 3042863371) strcat(s, "L");
if (crc32("NxOktgTAfmD",11) == 2295893034) strcat(s, "i");
if (crc32("mXhEygAaFl",10) == 1081387107) strcat(s, "Y");
if (crc32("gNMMHVn",7) == 391164132) strcat(s, "o");
if (crc32("WRXbmEHy",8) == 2185148042) strcat(s, "S");
if (crc32("gYDkD",5) == 3676180113) strcat(s, "u");
if (crc32("sNPvzLAFp",9) == 2650526957) strcat(s, "O");
if (crc32("SUZvFFuyXj",10) == 340018152) strcat(s, "s");
if (crc32("rasLrqOyWKPQ",12) == 2990228578) strcat(s, "Q");
if (crc32("ZYsyiUQTy",9) == 1211129591) strcat(s, "l");
if (crc32("WMwNHCsCMsHDW",13) == 3527763479) strcat(s, "y");
    return s;
}

char *larkingly_adverbs() {
    char *s = calloc(10);
    if (crc32("pnCuAyDCCvFg",12) == 1882210038) strcat(s, "U");
if (crc32("mekIKkyvEBz",11) == 3045734962) strcat(s, "l");
if (crc32("XfaKfVPXO",9) == 3821966693) strcat(s, "Y");
if (crc32("NusVoEGCENg",11) == 802866570) strcat(s, "a");
if (crc32("vPKDWIK",7) == 3484350152) strcat(s, "J");
if (crc32("XEQHRmvzx",9) == 2025496238) strcat(s, "r");
if (crc32("pCnjrBSxUTXH",12) == 4111221604) strcat(s, "k");
if (crc32("Zcyues",6) == 1980527533) strcat(s, "r");
if (crc32("MFNHLjwAHi",10) == 1322497010) strcat(s, "i");
if (crc32("XueML",5) == 556396826) strcat(s, "b");
if (crc32("MJexVszq",8) == 3965272356) strcat(s, "n");
if (crc32("NIGowfudD",9) == 397740037) strcat(s, "r");
if (crc32("CVANYtr",7) == 3124083802) strcat(s, "g");
if (crc32("oFEcC",5) == 433923346) strcat(s, "S");
if (crc32("JHHjUcFLfjSUh",13) == 2245095487) strcat(s, "l");
if (crc32("cWckYwhAhfxnOI",14) == 796934328) strcat(s, "y");
    return s;
}

char *unverdantly_adverbs() {
    char *s = calloc(12);
    if (crc32("UOmwSy",6) == 2554600786) strcat(s, "k");
if (crc32("lYMuXQ",6) == 2931646301) strcat(s, "u");
if (crc32("GzUGKeBZ",8) == 1780051426) strcat(s, "L");
if (crc32("KGpXXpeFHnLENz",14) == 2700306274) strcat(s, "n");
if (crc32("pjiUfJAF",8) == 740391251) strcat(s, "v");
if (crc32("cwYATvvvRgnywU",14) == 1087415640) strcat(s, "q");
if (crc32("BeArAZiT",8) == 179880672) strcat(s, "e");
if (crc32("FVpUXLssg",9) == 808564293) strcat(s, "r");
if (crc32("bXRTWPeQ",8) == 1434712227) strcat(s, "d");
if (crc32("CHrlvE",6) == 2946890709) strcat(s, "a");
if (crc32("kNUKklsLTlIUI",13) == 2804131670) strcat(s, "n");
if (crc32("uuUycklKGEbpHm",14) == 4293064969) strcat(s, "A");
if (crc32("GSOqssIEW",9) == 903612804) strcat(s, "t");
if (crc32("TysfSMtox",9) == 2148258703) strcat(s, "l");
if (crc32("FHdNfaCubkELtPc",15) == 3693780052) strcat(s, "u");
if (crc32("sFOaUZBtGrRJBzP",15) == 2478563945) strcat(s, "y");
    return s;
}

char *jeeringly_adverbs() {
    char *s = calloc(10);
    if (crc32("bKMTNYRYniLoW",13) == 1077768020) strcat(s, "j");
if (crc32("ybWsnFpXpf",10) == 2115239587) strcat(s, "e");
if (crc32("YdhMZmYzJjTrU",13) == 2960082092) strcat(s, "e");
if (crc32("elplcsuMXUf",11) == 2553204085) strcat(s, "r");
if (crc32("DyRDiKdPXiV",11) == 2125440677) strcat(s, "i");
if (crc32("aZAHpFa",7) == 237928108) strcat(s, "o");
if (crc32("nXuzquL",7) == 3952725876) strcat(s, "n");
if (crc32("AaCbAiSNkfbTz",13) == 1966504590) strcat(s, "M");
if (crc32("WZCRyGRzNs",10) == 353153997) strcat(s, "g");
if (crc32("NilQd",5) == 3481096876) strcat(s, "l");
if (crc32("SqMyqkeZgInO",12) == 2411010131) strcat(s, "g");
if (crc32("KhwTTICRiesQf",13) == 4166873318) strcat(s, "y");
    return s;
}

char *superbenevolently_adverbs() {
    char *s = calloc(18);
    if (crc32("unsShYGqxyxFB",13) == 195679415) strcat(s, "s");
if (crc32("sdxspf",6) == 588573856) strcat(s, "u");
if (crc32("OMFLpf",6) == 2747157308) strcat(s, "p");
if (crc32("ougrBBcTXeWbV",13) == 528211313) strcat(s, "e");
if (crc32("DugyjwrO",8) == 1274291681) strcat(s, "u");
if (crc32("FhhvzUtlBjKpiRf",15) == 601356986) strcat(s, "r");
if (crc32("cuPoTTXG",8) == 715497633) strcat(s, "k");
if (crc32("BTcydhGJTVbfBUC",15) == 179690372) strcat(s, "b");
if (crc32("HzDflGhf",8) == 1479128575) strcat(s, "e");
if (crc32("UZUEGeFm",8) == 4008592998) strcat(s, "n");
if (crc32("cIZrFfZsTxIRVC",14) == 436952358) strcat(s, "e");
if (crc32("OVIwNq",6) == 113600818) strcat(s, "v");
if (crc32("rMXaqVMfBhaXfk",14) == 707522109) strcat(s, "o");
if (crc32("QoAXysnnUg",10) == 286506413) strcat(s, "l");
if (crc32("ZMvqKLidoxc",11) == 397886192) strcat(s, "l");
if (crc32("svRMcXmoJfnZbXb",15) == 2767238281) strcat(s, "v");
if (crc32("NmSFFnuSXga",11) == 3766781984) strcat(s, "e");
if (crc32("ssCFruUpRqbPi",13) == 2473357831) strcat(s, "n");
if (crc32("oKmZxqSfYslbBL",14) == 1587982271) strcat(s, "t");
if (crc32("LYfnDRUvUaaqMuo",15) == 2804445887) strcat(s, "B");
if (crc32("uBIlO",5) == 2523776753) strcat(s, "l");
if (crc32("wFfjQHFcF",9) == 3999695314) strcat(s, "A");
if (crc32("dhfWGYBBrFmd",12) == 2856800509) strcat(s, "y");
    return s;
}

char *tumidly_adverbs() {
    char *s = calloc(8);
    if (crc32("oZtSYfSiPP",10) == 3053556204) strcat(s, "x");
if (crc32("RmQyndnTiDJhWqO",15) == 3891638354) strcat(s, "t");
if (crc32("OFnOCXULNQed",12) == 4216511151) strcat(s, "u");
if (crc32("fmyLF",5) == 2169498973) strcat(s, "m");
if (crc32("vcTeSf",6) == 1833807239) strcat(s, "q");
if (crc32("weJbAVj",7) == 1596474673) strcat(s, "i");
if (crc32("rvxlXzhb",8) == 3860566629) strcat(s, "d");
if (crc32("zfPFhDU",7) == 1147519380) strcat(s, "l");
if (crc32("ZZtfalKQypHwO",13) == 1376020310) strcat(s, "y");
    return s;
}

char *preaccommodatingly_adverbs() {
    char *s = calloc(19);
    if (crc32("QtAfxb",6) == 4011473158) strcat(s, "L");
if (crc32("fJNxA",5) == 3099651995) strcat(s, "p");
if (crc32("OThIyvHpsDQxlC",14) == 4245193090) strcat(s, "R");
if (crc32("AoiYO",5) == 182987522) strcat(s, "r");
if (crc32("PUwLQ",5) == 1128686539) strcat(s, "E");
if (crc32("UtzPT",5) == 1566025042) strcat(s, "e");
if (crc32("JxvJslGa",8) == 4060303695) strcat(s, "Y");
if (crc32("tCsaGXpmYcII",12) == 3466084934) strcat(s, "a");
if (crc32("rdMMuOOYMN",10) == 1351093795) strcat(s, "U");
if (crc32("lwjgwxKyqtotV",13) == 1640431552) strcat(s, "c");
if (crc32("joKVqaqUMxcF",12) == 2194393370) strcat(s, "c");
if (crc32("uqLEbyRYEun",11) == 3999518432) strcat(s, "o");
if (crc32("ZOkTfHeymAOcYFY",15) == 2502506557) strcat(s, "J");
if (crc32("pMpYVDpWoyL",11) == 4260578317) strcat(s, "m");
if (crc32("wDfUtwsS",8) == 507435283) strcat(s, "m");
if (crc32("kxRZBIkUtloRm",13) == 3534491133) strcat(s, "n");
if (crc32("MnnLCPH",7) == 3454938155) strcat(s, "o");
if (crc32("wCshojdTZXaZFyP",15) == 844221404) strcat(s, "T");
if (crc32("SgKHN",5) == 3396027911) strcat(s, "d");
if (crc32("mCfvQeIyp",9) == 3500018941) strcat(s, "J");
if (crc32("HABXqMLApb",10) == 2424856906) strcat(s, "a");
if (crc32("ljFQbThAAnoYeoH",15) == 1125745151) strcat(s, "x");
if (crc32("YofldJxqME",10) == 1178339275) strcat(s, "t");
if (crc32("ZYYkAbHQFQWmTB",14) == 2284454608) strcat(s, "i");
if (crc32("CIRDQme",7) == 41374299) strcat(s, "t");
if (crc32("vYyWAjBBzypFhX",14) == 749849749) strcat(s, "n");
if (crc32("MEAka",5) == 124766143) strcat(s, "g");
if (crc32("oGMSWaHg",8) == 2203369786) strcat(s, "h");
if (crc32("dgphBs",6) == 789409975) strcat(s, "l");
if (crc32("iBcBPulJiTzSR",13) == 3772520422) strcat(s, "y");
    return s;
}

char *impressionably_adverbs() {
    char *s = calloc(15);
    if (crc32("MmhlOrFKIpwfA",13) == 2068993645) strcat(s, "A");
if (crc32("SWfAc",5) == 2663943209) strcat(s, "i");
if (crc32("esePRdhbfWWO",12) == 3261288305) strcat(s, "p");
if (crc32("JBeXm",5) == 3925992497) strcat(s, "m");
if (crc32("oszmPEMEAMf",11) == 1978996113) strcat(s, "h");
if (crc32("QhukzylObHgywvB",15) == 2400959992) strcat(s, "p");
if (crc32("rOYCO",5) == 3625802017) strcat(s, "r");
if (crc32("OAIiQUMNmZqHRGD",15) == 918144719) strcat(s, "q");
if (crc32("YxrVQWSiUmK",11) == 912797764) strcat(s, "e");
if (crc32("ObtySltHyyfQ",12) == 1773495144) strcat(s, "R");
if (crc32("fvPuzaJh",8) == 3318373126) strcat(s, "s");
if (crc32("AhDMQCYkbbI",11) == 1229266518) strcat(s, "s");
if (crc32("EOYQjsWzuK",10) == 4263386047) strcat(s, "i");
if (crc32("yqOPJVTdA",9) == 4091851798) strcat(s, "o");
if (crc32("uinZltaMU",9) == 2642469407) strcat(s, "k");
if (crc32("QPbRB",5) == 1397759712) strcat(s, "n");
if (crc32("qjMLe",5) == 1331536456) strcat(s, "a");
if (crc32("nfmdffxvnKoUWN",14) == 501704420) strcat(s, "b");
if (crc32("nNJrIBIfvmpIWBV",15) == 3813152751) strcat(s, "l");
if (crc32("sraoSuDeMYJz",12) == 4293622517) strcat(s, "w");
if (crc32("EYBLWmifq",9) == 2209830253) strcat(s, "y");
    return s;
}

char *unexplicitly_adverbs() {
    char *s = calloc(13);
    if (crc32("NWLunVuY",8) == 98094070) strcat(s, "u");
if (crc32("ulrabQWYHJ",10) == 1364754987) strcat(s, "n");
if (crc32("nQNBlv",6) == 4273254384) strcat(s, "e");
if (crc32("FkoGE",5) == 129223222) strcat(s, "x");
if (crc32("PIHIDfozfP",10) == 3601196617) strcat(s, "w");
if (crc32("ahZfzuyD",8) == 2745792967) strcat(s, "p");
if (crc32("EigBfinTsq",10) == 3148925479) strcat(s, "l");
if (crc32("qoBYwHJlte",10) == 426060952) strcat(s, "i");
if (crc32("bElFh",5) == 765282450) strcat(s, "c");
if (crc32("EVrIkjIB",8) == 1197323163) strcat(s, "i");
if (crc32("AiuTfz",6) == 104868908) strcat(s, "V");
if (crc32("oMEYoDaLfKsm",12) == 672804307) strcat(s, "t");
if (crc32("KeLzJvnBriOELq",14) == 1514956276) strcat(s, "h");
if (crc32("WZqVYpwoAfNziX",14) == 3234974055) strcat(s, "l");
if (crc32("mOJmWbT",7) == 3309865) strcat(s, "y");
    return s;
}

char *nondetractively_adverbs() {
    char *s = calloc(16);
    if (crc32("uwhHlCuDVUDU",12) == 3453345363) strcat(s, "U");
if (crc32("coUBrrPOpfdV",12) == 2940182792) strcat(s, "n");
if (crc32("HmltN",5) == 3345519151) strcat(s, "k");
if (crc32("AXmMWWHSNrXVe",13) == 2219932772) strcat(s, "o");
if (crc32("Hikkr",5) == 3404548121) strcat(s, "d");
if (crc32("aMdekb",6) == 233060899) strcat(s, "n");
if (crc32("lBZObxjOzGMkf",13) == 593475809) strcat(s, "Y");
if (crc32("VPxuOWILfvYBQnc",15) == 1634085650) strcat(s, "d");
if (crc32("QuDBwsA",7) == 2335763158) strcat(s, "e");
if (crc32("UKcfiNkSEI",10) == 2660858882) strcat(s, "t");
if (crc32("fimRAnETVEB",11) == 2379978957) strcat(s, "e");
if (crc32("VIYoxfViksZAhL",14) == 3404935002) strcat(s, "r");
if (crc32("UHofwLJBBJzdoxh",15) == 405789092) strcat(s, "a");
if (crc32("miHgrKApsFlbrkm",15) == 1122554895) strcat(s, "F");
if (crc32("GjkIH",5) == 1700035852) strcat(s, "c");
if (crc32("YaIkfOKhEMYen",13) == 3815872017) strcat(s, "t");
if (crc32("qEqjvBSzZXEaRZ",14) == 3505753802) strcat(s, "i");
if (crc32("oULRLXyler",10) == 2958622771) strcat(s, "v");
if (crc32("uXhEtbnPVsxqI",13) == 1170581852) strcat(s, "e");
if (crc32("jaAeccNlP",9) == 3910771058) strcat(s, "P");
if (crc32("iFvbxAlPulWfg",13) == 3177013994) strcat(s, "l");
if (crc32("UyxbowkRjnp",11) == 3145945392) strcat(s, "y");
    return s;
}

char *autogenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("mMGEDM",6) == 1983318098) strcat(s, "d");
if (crc32("DxCRftOicYdiP",13) == 3230396475) strcat(s, "a");
if (crc32("JMFxMbIVohpQXgB",15) == 436546379) strcat(s, "i");
if (crc32("NkfLtkgXXd",10) == 2857516297) strcat(s, "u");
if (crc32("kymZJxiMEmFgeRK",15) == 1224350725) strcat(s, "P");
if (crc32("FrKOrezHMJfiab",14) == 1065455144) strcat(s, "t");
if (crc32("TwyCyWzOJyFSh",13) == 1259254081) strcat(s, "a");
if (crc32("LeaSlBy",7) == 2437903984) strcat(s, "o");
if (crc32("aPRDrkZ",7) == 1499471631) strcat(s, "L");
if (crc32("ATrOPjJsoS",10) == 2356148610) strcat(s, "g");
if (crc32("EsROfhADL",9) == 550071267) strcat(s, "y");
if (crc32("uLZeMP",6) == 3007188520) strcat(s, "e");
if (crc32("TyfBtRn",7) == 334919844) strcat(s, "s");
if (crc32("koCWnPbUS",9) == 3329138420) strcat(s, "n");
if (crc32("etjkwIfcFVq",11) == 3653488433) strcat(s, "g");
if (crc32("LnsCeqmCUsOw",12) == 3702937064) strcat(s, "e");
if (crc32("ODpJzDRIhP",10) == 2656610761) strcat(s, "N");
if (crc32("mAzdLLZcLWEi",12) == 3041262576) strcat(s, "t");
if (crc32("IPDmIiTxN",9) == 3131434501) strcat(s, "d");
if (crc32("swcLQkgNMji",11) == 1735961783) strcat(s, "i");
if (crc32("ojOHwMmzmcUoA",13) == 2335513723) strcat(s, "c");
if (crc32("TUEcROVmVj",10) == 3519573427) strcat(s, "w");
if (crc32("rswgdmdBRj",10) == 552294651) strcat(s, "a");
if (crc32("pcmbXaQEQFXSSKv",15) == 2060841841) strcat(s, "f");
if (crc32("nNTYEhmq",8) == 188015176) strcat(s, "l");
if (crc32("uoVNbwsoMrfq",12) == 2704349994) strcat(s, "l");
if (crc32("XpaYyxL",7) == 1469040160) strcat(s, "y");
    return s;
}

char *woozily_adverbs() {
    char *s = calloc(8);
    if (crc32("tSubQngQQGlpH",13) == 1484110074) strcat(s, "w");
if (crc32("ZFgivLmjwLl",11) == 3416407518) strcat(s, "g");
if (crc32("vPhDxipAPIBoFF",14) == 3410426194) strcat(s, "o");
if (crc32("TMGmxISap",9) == 592347921) strcat(s, "o");
if (crc32("nVgzXUmB",8) == 2911804387) strcat(s, "i");
if (crc32("oYcHGEtLhD",10) == 4145124932) strcat(s, "z");
if (crc32("TBUQaii",7) == 2467898735) strcat(s, "S");
if (crc32("iXZjBAvtlQ",10) == 56227996) strcat(s, "i");
if (crc32("MnwUlpdz",8) == 2064317706) strcat(s, "d");
if (crc32("dRqZGpmcPJg",11) == 1645668952) strcat(s, "l");
if (crc32("UmTKlOOFwjK",11) == 3831018042) strcat(s, "y");
    return s;
}

char *overcautiously_adverbs() {
    char *s = calloc(15);
    if (crc32("RknPbgaMn",9) == 65063275) strcat(s, "o");
if (crc32("cWjxyHqdLi",10) == 3784633332) strcat(s, "v");
if (crc32("dCApamcVjKq",11) == 1127149957) strcat(s, "e");
if (crc32("xqTMptinJTk",11) == 4265635812) strcat(s, "e");
if (crc32("ArNcuQrmXbqKXI",14) == 1738389374) strcat(s, "r");
if (crc32("DQcPjVUAsmzB",12) == 3521588077) strcat(s, "f");
if (crc32("PqFBqGAGGm",10) == 1909173397) strcat(s, "c");
if (crc32("VcIJYBBbO",9) == 1853842556) strcat(s, "j");
if (crc32("wDdCaOxfit",10) == 1303260276) strcat(s, "a");
if (crc32("MsfCaDEEQhjhavZ",15) == 4040268768) strcat(s, "z");
if (crc32("ShgqUdE",7) == 4265032224) strcat(s, "u");
if (crc32("ehNlanYrUjeKcK",14) == 3255060139) strcat(s, "W");
if (crc32("zuWeJCovfZ",10) == 67694287) strcat(s, "t");
if (crc32("TtHzYWMaHmONJwE",15) == 122562677) strcat(s, "I");
if (crc32("iVkZCZmCQnkq",12) == 2334360383) strcat(s, "i");
if (crc32("nDFDn",5) == 2470235827) strcat(s, "E");
if (crc32("iYbaL",5) == 2900027930) strcat(s, "o");
if (crc32("SFnBAZZsoGb",11) == 4247337575) strcat(s, "u");
if (crc32("IsVmNLEUN",9) == 3619954678) strcat(s, "U");
if (crc32("RipTkEXIuOHO",12) == 2392025709) strcat(s, "s");
if (crc32("jNlGJZUgYiQ",11) == 2948948990) strcat(s, "t");
if (crc32("gGelZbRfvt",10) == 4092298669) strcat(s, "l");
if (crc32("evFaoCc",7) == 2178207574) strcat(s, "y");
    return s;
}

char *unpolitically_adverbs() {
    char *s = calloc(14);
    if (crc32("IoNWY",5) == 1842194553) strcat(s, "u");
if (crc32("NgRLuoSuQ",9) == 202518749) strcat(s, "N");
if (crc32("GTCsz",5) == 2927651391) strcat(s, "n");
if (crc32("TntaQcADr",9) == 2448552877) strcat(s, "t");
if (crc32("YDOFEBswFib",11) == 1850810432) strcat(s, "p");
if (crc32("huyPp",5) == 3346311012) strcat(s, "R");
if (crc32("MCKxiEGtSzhgD",13) == 1149591892) strcat(s, "o");
if (crc32("CAfDqAYeUgJaG",13) == 3624899955) strcat(s, "l");
if (crc32("GnSLkow",7) == 3905494795) strcat(s, "i");
if (crc32("bELJPzVLZs",10) == 4108239568) strcat(s, "H");
if (crc32("hpPCYlwugFiSN",13) == 2347868639) strcat(s, "t");
if (crc32("cChiVjVpi",9) == 3571810184) strcat(s, "k");
if (crc32("uEbVXewdIhKLeH",14) == 4209052543) strcat(s, "i");
if (crc32("fHyYVwImzQTeZC",14) == 242874300) strcat(s, "c");
if (crc32("GQNkIhRjzE",10) == 961815502) strcat(s, "a");
if (crc32("oJOIYgUzX",9) == 243211307) strcat(s, "l");
if (crc32("vQygXdzOWEC",11) == 156251915) strcat(s, "H");
if (crc32("VlRKdDSX",8) == 3823718660) strcat(s, "l");
if (crc32("rlnjbTtYQO",10) == 194657275) strcat(s, "y");
    return s;
}

char *betweentimes_adverbs() {
    char *s = calloc(13);
    if (crc32("yApyyERPXGXwaX",14) == 769157942) strcat(s, "X");
if (crc32("dKcIuXSF",8) == 2624312051) strcat(s, "b");
if (crc32("IYADztkBRMJj",12) == 1253181474) strcat(s, "Z");
if (crc32("pIFBrD",6) == 1322931944) strcat(s, "e");
if (crc32("mfwppOzWd",9) == 2745832437) strcat(s, "t");
if (crc32("BGVHqxJLBxkia",13) == 3796034587) strcat(s, "F");
if (crc32("wcLyUBEVCbWwRX",14) == 1398850925) strcat(s, "w");
if (crc32("WpzeEbt",7) == 3266884782) strcat(s, "x");
if (crc32("YNaQnZubPKHesTw",15) == 838820087) strcat(s, "e");
if (crc32("jxjowy",6) == 2411240258) strcat(s, "e");
if (crc32("MjqBlGGKxPwN",12) == 2251748096) strcat(s, "n");
if (crc32("PBdEPpOWENJCXd",14) == 4274827951) strcat(s, "t");
if (crc32("RyySXHkiwPvXhJ",14) == 398780792) strcat(s, "i");
if (crc32("NUzzRQ",6) == 1679533038) strcat(s, "r");
if (crc32("tIeFMDukeeq",11) == 2738956171) strcat(s, "m");
if (crc32("hNkeVXdP",8) == 2815081926) strcat(s, "e");
if (crc32("UBAcWakyERBusig",15) == 4022203462) strcat(s, "s");
    return s;
}

char *innately_adverbs() {
    char *s = calloc(9);
    if (crc32("HSDbusFYX",9) == 1561031596) strcat(s, "a");
if (crc32("wYbFWplRcI",10) == 733629834) strcat(s, "i");
if (crc32("ryIlQKAwLE",10) == 4151308699) strcat(s, "n");
if (crc32("HBIFHxSjDgIHCe",14) == 2095160405) strcat(s, "q");
if (crc32("mdAJZDIigD",10) == 958502323) strcat(s, "n");
if (crc32("USktCfhZdrypRAi",15) == 2362053378) strcat(s, "o");
if (crc32("YXPoItfGS",9) == 3572644901) strcat(s, "a");
if (crc32("SvNXfdCOxTPUIHZ",15) == 272956442) strcat(s, "t");
if (crc32("LEFduMQHMjQZuMr",15) == 1410143732) strcat(s, "e");
if (crc32("CFfQmf",6) == 3893119319) strcat(s, "l");
if (crc32("nqZtur",6) == 2191784722) strcat(s, "A");
if (crc32("sdXXPKuTAyNM",12) == 806109470) strcat(s, "y");
    return s;
}

char *adagissimo_adverbs() {
    char *s = calloc(11);
    if (crc32("mULyrqL",7) == 3191982195) strcat(s, "a");
if (crc32("EwMLEYv",7) == 1217904283) strcat(s, "d");
if (crc32("jUuGiUogImS",11) == 3173606285) strcat(s, "a");
if (crc32("LvxOjPxYfdvdRvs",15) == 2223581873) strcat(s, "g");
if (crc32("NOuRRoVZLsQ",11) == 315228742) strcat(s, "i");
if (crc32("OHdKopnqEzaKW",13) == 717916297) strcat(s, "s");
if (crc32("VkABbXh",7) == 2036276262) strcat(s, "z");
if (crc32("fIhIMpjfbuwk",12) == 962114081) strcat(s, "s");
if (crc32("kkkqkOBzJKFzDB",14) == 4240086247) strcat(s, "i");
if (crc32("gNnfGyrfaLzmFmR",15) == 2216598158) strcat(s, "m");
if (crc32("dENYvmumxiyw",12) == 320372530) strcat(s, "b");
if (crc32("RUfZxBzIvhzqes",14) == 1408418409) strcat(s, "o");
    return s;
}

char *overweakly_adverbs() {
    char *s = calloc(11);
    if (crc32("CEKsDRDkOSmdWm",14) == 2775850544) strcat(s, "V");
if (crc32("fUTUSprlNdX",11) == 1266392851) strcat(s, "o");
if (crc32("kRMzMtyrs",9) == 3242533312) strcat(s, "L");
if (crc32("DqFJvQXeuNzk",12) == 3636717782) strcat(s, "v");
if (crc32("YIvGMFILRtXEcHB",15) == 1995788120) strcat(s, "e");
if (crc32("WJtCUktHGueTF",13) == 1837224140) strcat(s, "r");
if (crc32("HQrcwdFXJ",9) == 2157062196) strcat(s, "w");
if (crc32("IGnZoaty",8) == 2064657617) strcat(s, "x");
if (crc32("kQsRoIimrHoL",12) == 1850669705) strcat(s, "e");
if (crc32("FVyOXBr",7) == 1228864669) strcat(s, "a");
if (crc32("AaIHAycOiahPuw",14) == 1540897431) strcat(s, "k");
if (crc32("amLlNz",6) == 1575870920) strcat(s, "l");
if (crc32("ypcbtXgDFyLWoO",14) == 3048503573) strcat(s, "y");
    return s;
}

char *freakily_adverbs() {
    char *s = calloc(9);
    if (crc32("onXPoStUaUJ",11) == 1333435628) strcat(s, "R");
if (crc32("FIYuKbNUoEQthxd",15) == 3785275953) strcat(s, "f");
if (crc32("KqMQsJdd",8) == 2729847042) strcat(s, "r");
if (crc32("EMwHhKUrM",9) == 3292398081) strcat(s, "d");
if (crc32("XsvXzKJZUpmlp",13) == 2917651459) strcat(s, "e");
if (crc32("WFqfQJMEC",9) == 3834942958) strcat(s, "i");
if (crc32("WghDW",5) == 3443457970) strcat(s, "a");
if (crc32("DYcZHUtRvFTroKM",15) == 4042380447) strcat(s, "k");
if (crc32("wEWFCdxktTw",11) == 811344149) strcat(s, "d");
if (crc32("iMCbx",5) == 1085776243) strcat(s, "i");
if (crc32("CHinYTAiTN",10) == 711979750) strcat(s, "l");
if (crc32("PsdFoxYm",8) == 3364824057) strcat(s, "y");
    return s;
}

char *nonprolifically_adverbs() {
    char *s = calloc(16);
    if (crc32("VXkJpXJKB",9) == 1204391122) strcat(s, "n");
if (crc32("FiqRuZLzFX",10) == 3331798081) strcat(s, "d");
if (crc32("ZcVhVDMuMmEW",12) == 3348572970) strcat(s, "o");
if (crc32("YazbfSsdwsYYg",13) == 2827762371) strcat(s, "n");
if (crc32("UQgpI",5) == 4223061628) strcat(s, "S");
if (crc32("mGrGEGpq",8) == 3531276913) strcat(s, "p");
if (crc32("MhaLZiOwtapGpiq",15) == 1268895230) strcat(s, "r");
if (crc32("ohQhXcm",7) == 3769109851) strcat(s, "o");
if (crc32("EZiVofxgova",11) == 3447482402) strcat(s, "l");
if (crc32("qVHsqZMyLg",10) == 2042469763) strcat(s, "z");
if (crc32("VafXXcIPAzNwbrI",15) == 554525416) strcat(s, "i");
if (crc32("hlnISro",7) == 887307026) strcat(s, "f");
if (crc32("KcPwXP",6) == 633748789) strcat(s, "a");
if (crc32("sSvkuLicETMA",12) == 4181555507) strcat(s, "i");
if (crc32("mXDJE",5) == 3532280864) strcat(s, "c");
if (crc32("SIWpMsAUWokXZn",14) == 1585951881) strcat(s, "a");
if (crc32("PGnRBAvARN",10) == 732270999) strcat(s, "X");
if (crc32("lKsCp",5) == 185797022) strcat(s, "l");
if (crc32("MuSISNm",7) == 1240668830) strcat(s, "l");
if (crc32("BMHNlT",6) == 2188183011) strcat(s, "Z");
if (crc32("aZpMmReJ",8) == 2104539872) strcat(s, "y");
    return s;
}

char *unresponsibly_adverbs() {
    char *s = calloc(14);
    if (crc32("VzuYlpmOEIUKPF",14) == 74117586) strcat(s, "i");
if (crc32("OMbwFwtwa",9) == 2010915918) strcat(s, "u");
if (crc32("mBGUQIZS",8) == 2704940836) strcat(s, "n");
if (crc32("oyUBxjyGBJUCbjD",15) == 287841852) strcat(s, "r");
if (crc32("ynPNoNmPPhcThkA",15) == 397357008) strcat(s, "e");
if (crc32("mEvghzAEZPDe",12) == 2885729133) strcat(s, "e");
if (crc32("FFXoHJrdmwIXFh",14) == 1171242017) strcat(s, "s");
if (crc32("WWzcmeBDNXCPs",13) == 2404915716) strcat(s, "p");
if (crc32("FQnEPzaBE",9) == 1768251329) strcat(s, "J");
if (crc32("odSPomFZtoCwh",13) == 701310886) strcat(s, "o");
if (crc32("jtazcBLhAqtMXWp",15) == 4103512666) strcat(s, "n");
if (crc32("uXeLS",5) == 421246563) strcat(s, "s");
if (crc32("kpmdOjAVjc",10) == 1833787343) strcat(s, "f");
if (crc32("QwLRbXBepxALWvw",15) == 869232193) strcat(s, "i");
if (crc32("ihVtIZkU",8) == 3731185752) strcat(s, "b");
if (crc32("gNNZogZWl",9) == 914059017) strcat(s, "l");
if (crc32("oVNygl",6) == 2808581287) strcat(s, "L");
if (crc32("NGmTwaiLFgL",11) == 1641661785) strcat(s, "y");
    return s;
}

char *contemnibly_adverbs() {
    char *s = calloc(12);
    if (crc32("VfaKjqh",7) == 4122092574) strcat(s, "K");
if (crc32("EOZUcETfn",9) == 3642166938) strcat(s, "c");
if (crc32("PMvGbU",6) == 247668785) strcat(s, "m");
if (crc32("fpygEH",6) == 941354362) strcat(s, "o");
if (crc32("AUNXEWApzg",10) == 1709603280) strcat(s, "Y");
if (crc32("pRcuKfkbStWKh",13) == 2560690073) strcat(s, "n");
if (crc32("HqBxXTF",7) == 273075475) strcat(s, "b");
if (crc32("VjPFQNDVj",9) == 336793114) strcat(s, "t");
if (crc32("PvKrGS",6) == 2648966837) strcat(s, "e");
if (crc32("vAmGepoglspQ",12) == 2336828250) strcat(s, "m");
if (crc32("ZLuDzTWZKTQIje",14) == 2976787639) strcat(s, "L");
if (crc32("TwrbhvpfUOZbneh",15) == 3237433033) strcat(s, "n");
if (crc32("hrJri",5) == 1748102954) strcat(s, "W");
if (crc32("zieeZpMSv",9) == 2226759717) strcat(s, "i");
if (crc32("vcOyGNfisVFzSe",14) == 2761499446) strcat(s, "b");
if (crc32("DnTKye",6) == 4169960777) strcat(s, "l");
if (crc32("QxXzSinRtQSak",13) == 1930654268) strcat(s, "y");
    return s;
}

char *prissily_adverbs() {
    char *s = calloc(9);
    if (crc32("mNwNgtjK",8) == 3180631903) strcat(s, "y");
if (crc32("fkFgFTmVGhSQhv",14) == 1178964033) strcat(s, "p");
if (crc32("cNpAvgZzVghTE",13) == 773200104) strcat(s, "j");
if (crc32("gaGpPaC",7) == 1857433939) strcat(s, "r");
if (crc32("AqOMamklen",10) == 237504570) strcat(s, "I");
if (crc32("MZQYVUptISWC",12) == 2956117234) strcat(s, "i");
if (crc32("KnADxxpWAgD",11) == 1730171361) strcat(s, "P");
if (crc32("lohumX",6) == 3437049701) strcat(s, "s");
if (crc32("pLdIZe",6) == 961192874) strcat(s, "c");
if (crc32("xxpAjIUBiYVv",12) == 3168701910) strcat(s, "s");
if (crc32("tvpHCygLvdtPc",13) == 3129073600) strcat(s, "K");
if (crc32("xAjxCnyx",8) == 4092430075) strcat(s, "i");
if (crc32("CnBdFqjFja",10) == 105980458) strcat(s, "l");
if (crc32("wgRvcwXfwUQCV",13) == 3243452755) strcat(s, "l");
if (crc32("QYbwTFKUajEjuD",14) == 2249497044) strcat(s, "S");
if (crc32("nzIhTR",6) == 3409187392) strcat(s, "y");
    return s;
}

char *toutcourt_adverbs() {
    char *s = calloc(10);
    if (crc32("MDormb",6) == 3903326317) strcat(s, "t");
if (crc32("YqXVhbZxFUUyTyY",15) == 1710784685) strcat(s, "o");
if (crc32("doRFm",5) == 869125757) strcat(s, "u");
if (crc32("eliRzDaHjD",10) == 25627752) strcat(s, "t");
if (crc32("yfwihhiZixj",11) == 144458361) strcat(s, "c");
if (crc32("XYdGYSMCSRyS",12) == 2604425271) strcat(s, "C");
if (crc32("eQcfzbyzEU",10) == 2541370065) strcat(s, "o");
if (crc32("JJEqPXNZwNf",11) == 971571800) strcat(s, "u");
if (crc32("LgwoizQjAoI",11) == 3510169239) strcat(s, "l");
if (crc32("yfesMFEMTXhOQ",13) == 1111390151) strcat(s, "r");
if (crc32("XzQgvFNqg",9) == 3579554161) strcat(s, "t");
    return s;
}

char *geometrically_adverbs() {
    char *s = calloc(14);
    if (crc32("BKiOwHWsynmOMj",14) == 3232080060) strcat(s, "A");
if (crc32("LGljN",5) == 307887919) strcat(s, "g");
if (crc32("MvEdzaIgzQkk",12) == 2618540222) strcat(s, "e");
if (crc32("yLLFDWDUCSxAfyl",15) == 1454162290) strcat(s, "Z");
if (crc32("HXmMqyvzLRpE",12) == 1684247398) strcat(s, "o");
if (crc32("Dywihmow",8) == 2711206571) strcat(s, "m");
if (crc32("skPguZO",7) == 1211148612) strcat(s, "e");
if (crc32("vvKOglKFuzd",11) == 1198775405) strcat(s, "t");
if (crc32("qYyWVA",6) == 3594620554) strcat(s, "r");
if (crc32("jxYIOAkrpa",10) == 3230361601) strcat(s, "i");
if (crc32("TCORKAxGudndRBg",15) == 814741610) strcat(s, "v");
if (crc32("wnIxCzMPYRgcjz",14) == 1754933056) strcat(s, "c");
if (crc32("QRFZFKBUDIYS",12) == 1639618213) strcat(s, "a");
if (crc32("eepAhENxbPMswj",14) == 3442279312) strcat(s, "w");
if (crc32("UoPuZxJdRmj",11) == 12533614) strcat(s, "l");
if (crc32("RSDHzoxbzZqw",12) == 1883082344) strcat(s, "R");
if (crc32("ptYUoH",6) == 4037212372) strcat(s, "l");
if (crc32("ePQUy",5) == 3751158924) strcat(s, "y");
    return s;
}

char *fantasmagorically_adverbs() {
    char *s = calloc(18);
    if (crc32("mtaLpeEvkLpcjVX",15) == 2936027584) strcat(s, "k");
if (crc32("ntkVtoceAjJz",12) == 2331703263) strcat(s, "f");
if (crc32("dGpVtw",6) == 1313391173) strcat(s, "a");
if (crc32("wNPhTApDURIW",12) == 596147429) strcat(s, "n");
if (crc32("NCJtgDpMMSEO",12) == 1681409638) strcat(s, "t");
if (crc32("kBCBN",5) == 942297982) strcat(s, "a");
if (crc32("xhUPtuFX",8) == 3010112884) strcat(s, "s");
if (crc32("HhBIKSfdEyNWU",13) == 554312704) strcat(s, "U");
if (crc32("NpVLyKwB",8) == 1625146245) strcat(s, "m");
if (crc32("CnoynMReVwYWK",13) == 4215850970) strcat(s, "a");
if (crc32("qZisXBEP",8) == 2734296758) strcat(s, "r");
if (crc32("fEbtAUVztt",10) == 3193119914) strcat(s, "g");
if (crc32("wMhQPsIxrCgMS",13) == 1276104855) strcat(s, "o");
if (crc32("AYrnRBczCzKyDQe",15) == 3674438116) strcat(s, "r");
if (crc32("MHXcqJUt",8) == 2688247703) strcat(s, "i");
if (crc32("SvAub",5) == 2003425142) strcat(s, "c");
if (crc32("cWJfe",5) == 1332430271) strcat(s, "Z");
if (crc32("ddKuTzefMhBGc",13) == 1543672055) strcat(s, "a");
if (crc32("XbTRVbI",7) == 2383939102) strcat(s, "K");
if (crc32("oXsuit",6) == 2296666148) strcat(s, "l");
if (crc32("YLirHFIgBdX",11) == 4185043260) strcat(s, "g");
if (crc32("PBlRCR",6) == 3750116358) strcat(s, "l");
if (crc32("wajslxolWKOA",12) == 339408840) strcat(s, "y");
    return s;
}

char *palaeogeographically_adverbs() {
    char *s = calloc(21);
    if (crc32("FIGPFy",6) == 3634699717) strcat(s, "p");
if (crc32("ikjEP",5) == 3668760775) strcat(s, "K");
if (crc32("rRRECsEXfkRrx",13) == 3091820641) strcat(s, "a");
if (crc32("WlDPOPnjUyaoJs",14) == 1034230192) strcat(s, "m");
if (crc32("koInRu",6) == 3290756446) strcat(s, "l");
if (crc32("ibSIHhevV",9) == 2634924807) strcat(s, "a");
if (crc32("qzZLIau",7) == 4251546547) strcat(s, "e");
if (crc32("FePRBpCBp",9) == 411255840) strcat(s, "o");
if (crc32("wfcAwJjO",8) == 3844809872) strcat(s, "T");
if (crc32("ALbHrbaI",8) == 3615648581) strcat(s, "g");
if (crc32("TvFvzKakYTvan",13) == 432577432) strcat(s, "j");
if (crc32("VpMksecheZPNna",14) == 3729820844) strcat(s, "e");
if (crc32("qDuUiqfNGBrFbG",14) == 696844629) strcat(s, "j");
if (crc32("AUUYaco",7) == 3211648478) strcat(s, "o");
if (crc32("vPRCImZrbOdImL",14) == 3729638958) strcat(s, "g");
if (crc32("CfbOCWkN",8) == 1812774077) strcat(s, "L");
if (crc32("WQpzQyfiJoGUfPx",15) == 4170303364) strcat(s, "r");
if (crc32("EcNtLnrEaN",10) == 3736743778) strcat(s, "a");
if (crc32("RSGXbZYEyl",10) == 1810151008) strcat(s, "p");
if (crc32("ZgzXwkm",7) == 473558962) strcat(s, "h");
if (crc32("WnJNMfrWHs",10) == 2086097286) strcat(s, "h");
if (crc32("XoIMaUa",7) == 4228195889) strcat(s, "i");
if (crc32("YPBQh",5) == 2885388756) strcat(s, "c");
if (crc32("RGWbQXSNLCbx",12) == 3404554445) strcat(s, "e");
if (crc32("URUAkkqoZUMmF",13) == 3939768617) strcat(s, "a");
if (crc32("ynCMGJNks",9) == 3797343529) strcat(s, "j");
if (crc32("qEXgecFA",8) == 968220339) strcat(s, "l");
if (crc32("vSJoi",5) == 3255755964) strcat(s, "l");
if (crc32("ONPZl",5) == 3815242472) strcat(s, "Y");
if (crc32("WRCBv",5) == 618719736) strcat(s, "y");
    return s;
}

char *halfcoaxingly_adverbs() {
    char *s = calloc(14);
    if (crc32("OWvdmcgJYdYYg",13) == 1477828695) strcat(s, "u");
if (crc32("QsLpRLBI",8) == 1974315873) strcat(s, "h");
if (crc32("UVlkZ",5) == 1288425189) strcat(s, "a");
if (crc32("xyeXYjzg",8) == 3330191630) strcat(s, "a");
if (crc32("uvsmXm",6) == 3831215366) strcat(s, "l");
if (crc32("pnvRlpGIMDftn",13) == 2038410251) strcat(s, "f");
if (crc32("kEKbNfmPL",9) == 639766247) strcat(s, "c");
if (crc32("kTkjtXgzpRp",11) == 681071116) strcat(s, "G");
if (crc32("YHgAxydXSxCj",12) == 611618218) strcat(s, "o");
if (crc32("wKuSTimT",8) == 517711703) strcat(s, "a");
if (crc32("altnjmemWoaPk",13) == 10313569) strcat(s, "Q");
if (crc32("Hrimib",6) == 3229198957) strcat(s, "x");
if (crc32("hqSTFms",7) == 1184658918) strcat(s, "y");
if (crc32("cVnTq",5) == 1296733486) strcat(s, "i");
if (crc32("SgKwmkdcuDJXG",13) == 1007375633) strcat(s, "M");
if (crc32("aUNhcQ",6) == 3979006327) strcat(s, "n");
if (crc32("YXMdmIzihoZ",11) == 2636895515) strcat(s, "x");
if (crc32("hTtBrLLiQ",9) == 157942899) strcat(s, "g");
if (crc32("HGwrjOMucmv",11) == 255049392) strcat(s, "l");
if (crc32("dtLsZNrq",8) == 891989768) strcat(s, "Q");
if (crc32("OJnCXRqbmS",10) == 1877654413) strcat(s, "y");
    return s;
}

char *caenogenetically_adverbs() {
    char *s = calloc(17);
    if (crc32("XfyZfSG",7) == 922588327) strcat(s, "c");
if (crc32("fxGAxWbLGTLmHw",14) == 1281627714) strcat(s, "a");
if (crc32("QufEmLFxWjp",11) == 2845478900) strcat(s, "S");
if (crc32("qShegGhEnZQp",12) == 2548285082) strcat(s, "e");
if (crc32("YGxTXUEWVCKHzb",14) == 3863216463) strcat(s, "n");
if (crc32("PuvwZgv",7) == 4143208677) strcat(s, "f");
if (crc32("PvRav",5) == 450737063) strcat(s, "o");
if (crc32("PyshWzTSosYFP",13) == 2684612444) strcat(s, "g");
if (crc32("BzDZZRHDN",9) == 1593041441) strcat(s, "e");
if (crc32("SMRRCvNryevgYlp",15) == 424694376) strcat(s, "D");
if (crc32("wRsFjIZLWu",10) == 1519815185) strcat(s, "n");
if (crc32("DBYWIqlozx",10) == 2100618742) strcat(s, "e");
if (crc32("WqZLNhvPpflozvG",15) == 3875506334) strcat(s, "t");
if (crc32("MbvLD",5) == 2333214036) strcat(s, "H");
if (crc32("sudkR",5) == 1745083620) strcat(s, "i");
if (crc32("WnJqAZATgPCaF",13) == 2019698464) strcat(s, "J");
if (crc32("rnlwiRJ",7) == 667751880) strcat(s, "c");
if (crc32("rsnvEJeAd",9) == 2506755396) strcat(s, "a");
if (crc32("QQNzroFgoXG",11) == 2246547999) strcat(s, "l");
if (crc32("dzNnxEsatEHS",12) == 682279150) strcat(s, "b");
if (crc32("ljskeMd",7) == 1800708620) strcat(s, "l");
if (crc32("APtwqmr",7) == 3514911386) strcat(s, "o");
if (crc32("mXXfu",5) == 3630060854) strcat(s, "y");
    return s;
}

char *someway_adverbs() {
    char *s = calloc(8);
    if (crc32("YlbzVy",6) == 3421537172) strcat(s, "s");
if (crc32("TFSKyDtPiTujH",13) == 503539372) strcat(s, "o");
if (crc32("tJrgNk",6) == 184992117) strcat(s, "m");
if (crc32("KuRcKuuWKmKjadA",15) == 4062893792) strcat(s, "V");
if (crc32("jOwfkJeKdmrQcHG",15) == 3706756153) strcat(s, "e");
if (crc32("kwkvRaNVLH",10) == 2387813303) strcat(s, "w");
if (crc32("TjojUhPqHXA",11) == 1478936398) strcat(s, "W");
if (crc32("RXdIrQOBJTOFcSb",15) == 1997955697) strcat(s, "a");
if (crc32("kJirzcKPv",9) == 1027947505) strcat(s, "y");
    return s;
}

char *ovally_adverbs() {
    char *s = calloc(7);
    if (crc32("gpZSX",5) == 318931179) strcat(s, "o");
if (crc32("btCcwChYETuebE",14) == 3753971882) strcat(s, "v");
if (crc32("rpbwqDtqdaoaue",14) == 4181291651) strcat(s, "a");
if (crc32("dMMFxt",6) == 790841182) strcat(s, "l");
if (crc32("jQCIbVSFhoYJF",13) == 2812312553) strcat(s, "l");
if (crc32("phDtdBfdqMDYDb",14) == 1929392818) strcat(s, "y");
    return s;
}

char *quasihumorously_adverbs() {
    char *s = calloc(16);
    if (crc32("JUoYkGqP",8) == 2760779117) strcat(s, "q");
if (crc32("DRWaYNvyCLuXas",14) == 750480362) strcat(s, "Z");
if (crc32("JbBfaBbXf",9) == 988639442) strcat(s, "u");
if (crc32("JpZgquR",7) == 799628198) strcat(s, "M");
if (crc32("PQWTJI",6) == 2160500963) strcat(s, "a");
if (crc32("OfvdMufD",8) == 3161247093) strcat(s, "y");
if (crc32("VzRmdv",6) == 1099651031) strcat(s, "s");
if (crc32("DzrdXkEI",8) == 1652596900) strcat(s, "i");
if (crc32("lYtzVXa",7) == 3536679607) strcat(s, "h");
if (crc32("GavgTBo",7) == 2080130433) strcat(s, "u");
if (crc32("mQoTSPlytyT",11) == 1642212789) strcat(s, "m");
if (crc32("wVBQjPxn",8) == 3062434029) strcat(s, "M");
if (crc32("qiMRIgxZvQtT",12) == 825042714) strcat(s, "o");
if (crc32("POyHZH",6) == 922888670) strcat(s, "r");
if (crc32("NzjmicfG",8) == 4222630957) strcat(s, "h");
if (crc32("bERjVqYrqLDJV",13) == 1415899359) strcat(s, "o");
if (crc32("ZUKIlaIDOLpUDC",14) == 2913079808) strcat(s, "P");
if (crc32("ALcgHAOXHcpdwT",14) == 3172622834) strcat(s, "u");
if (crc32("JYPOlHK",7) == 3387169068) strcat(s, "c");
if (crc32("XkkrMzTkhSrBHiz",15) == 3503277912) strcat(s, "s");
if (crc32("BgCIE",5) == 389103940) strcat(s, "l");
if (crc32("cPeMke",6) == 3369741701) strcat(s, "y");
    return s;
}

char *transitorily_adverbs() {
    char *s = calloc(13);
    if (crc32("ZriLt",5) == 1163280815) strcat(s, "q");
if (crc32("pPRsF",5) == 6827070) strcat(s, "t");
if (crc32("foduRbh",7) == 3592941397) strcat(s, "P");
if (crc32("sZPXzeS",7) == 1759356149) strcat(s, "r");
if (crc32("OkJAF",5) == 4218870384) strcat(s, "a");
if (crc32("LkunPRVtslg",11) == 2120881309) strcat(s, "H");
if (crc32("IqoQp",5) == 4033649640) strcat(s, "n");
if (crc32("jpKjNhMPiW",10) == 3014401707) strcat(s, "q");
if (crc32("EsCydIGK",8) == 837334251) strcat(s, "s");
if (crc32("MyGFj",5) == 806973978) strcat(s, "W");
if (crc32("WVQRBrDauARP",12) == 1204039011) strcat(s, "i");
if (crc32("GxUruBPY",8) == 3244236094) strcat(s, "t");
if (crc32("YNFhb",5) == 4066731264) strcat(s, "o");
if (crc32("HcdNNCGmLrfJMxJ",15) == 463229879) strcat(s, "r");
if (crc32("fHEPXUoRTbfSGYA",15) == 313296172) strcat(s, "i");
if (crc32("YpwEgybIMOt",11) == 2470046708) strcat(s, "P");
if (crc32("XRHRhAHZeFN",11) == 2942772358) strcat(s, "l");
if (crc32("ywbLblv",7) == 496143603) strcat(s, "L");
if (crc32("WiShuXBA",8) == 4201453938) strcat(s, "y");
    return s;
}

char *saltirewise_adverbs() {
    char *s = calloc(12);
    if (crc32("bkZfJM",6) == 4027419480) strcat(s, "s");
if (crc32("BHwPxGKWGug",11) == 3913421722) strcat(s, "a");
if (crc32("GMtOfiPRlY",10) == 523095033) strcat(s, "l");
if (crc32("EMDEhjnc",8) == 2974711755) strcat(s, "t");
if (crc32("jqBddqIJJWYWZ",13) == 2508880630) strcat(s, "i");
if (crc32("nPRBPjJvPNYs",12) == 781363466) strcat(s, "T");
if (crc32("ppkcX",5) == 992834093) strcat(s, "r");
if (crc32("HmtHKugugMLz",12) == 370058388) strcat(s, "L");
if (crc32("ZGmIu",5) == 4086917503) strcat(s, "e");
if (crc32("ECuimXbr",8) == 4236500977) strcat(s, "i");
if (crc32("sLsDGml",7) == 1945119094) strcat(s, "w");
if (crc32("dVNDrW",6) == 1906967477) strcat(s, "i");
if (crc32("lqtEMPQikahi",12) == 3494236072) strcat(s, "b");
if (crc32("VWorojSXlfV",11) == 2551344096) strcat(s, "s");
if (crc32("bXItunECvG",10) == 3821123104) strcat(s, "e");
    return s;
}

char *nakedly_adverbs() {
    char *s = calloc(8);
    if (crc32("wfujJDmrsT",10) == 3019632101) strcat(s, "Y");
if (crc32("OynLMFRKJS",10) == 398154435) strcat(s, "n");
if (crc32("ESkwyz",6) == 1649466157) strcat(s, "a");
if (crc32("FaJYSilUu",9) == 2382097571) strcat(s, "L");
if (crc32("NkgaDGD",7) == 4210650287) strcat(s, "k");
if (crc32("TzTDFAIFnTXIlr",14) == 1226153647) strcat(s, "l");
if (crc32("OZotfE",6) == 952340631) strcat(s, "e");
if (crc32("VHvQsRQsyxdeU",13) == 911075560) strcat(s, "n");
if (crc32("lLimn",5) == 1987912654) strcat(s, "d");
if (crc32("dnNiuH",6) == 304594547) strcat(s, "l");
if (crc32("bVFrPptMHPlf",12) == 3026055501) strcat(s, "y");
    return s;
}

char *parentally_adverbs() {
    char *s = calloc(11);
    if (crc32("QesfViqrgq",10) == 2930546588) strcat(s, "p");
if (crc32("zqKgVPKJJdoP",12) == 560293499) strcat(s, "a");
if (crc32("rIQIyYZwK",9) == 3994196189) strcat(s, "L");
if (crc32("ZqbhLcTvfGFm",12) == 2076513896) strcat(s, "r");
if (crc32("boWIXpBDRKniCEk",15) == 1845094185) strcat(s, "u");
if (crc32("GkZFMwUOxB",10) == 2733770713) strcat(s, "e");
if (crc32("emRKr",5) == 2617400574) strcat(s, "n");
if (crc32("qglesFvKJ",9) == 2655940210) strcat(s, "w");
if (crc32("xigirIrknBKrUA",14) == 3695941925) strcat(s, "t");
if (crc32("FKItJjBNrhlcraS",15) == 564528946) strcat(s, "a");
if (crc32("lChURrAvjbzJ",12) == 3060148450) strcat(s, "f");
if (crc32("uxgZUgOo",8) == 585120623) strcat(s, "l");
if (crc32("wlUou",5) == 2525057667) strcat(s, "o");
if (crc32("uUqxVw",6) == 2973736246) strcat(s, "l");
if (crc32("hxIPdwqusZ",10) == 928193176) strcat(s, "b");
if (crc32("tpGsDNKgbpao",12) == 2225614824) strcat(s, "y");
    return s;
}

char *insincerely_adverbs() {
    char *s = calloc(12);
    if (crc32("ptFuq",5) == 3484730497) strcat(s, "Y");
if (crc32("qpQGlJjrgEyiVL",14) == 3110165858) strcat(s, "i");
if (crc32("gmmbfu",6) == 1413895359) strcat(s, "n");
if (crc32("IRieOVbAWovpB",13) == 2750238094) strcat(s, "x");
if (crc32("UFtysTqM",8) == 389567333) strcat(s, "s");
if (crc32("CIGrCsKubeHy",12) == 3547059185) strcat(s, "i");
if (crc32("YMJrSGF",7) == 99610585) strcat(s, "n");
if (crc32("DaMuJEqvWi",10) == 1113043207) strcat(s, "B");
if (crc32("TziFLTgmvhzH",12) == 2699252546) strcat(s, "c");
if (crc32("AyKLq",5) == 583232360) strcat(s, "b");
if (crc32("LpjCJY",6) == 250405210) strcat(s, "e");
if (crc32("ovBpKdCxbmC",11) == 3006078954) strcat(s, "V");
if (crc32("PQEOEbfN",8) == 1976208668) strcat(s, "r");
if (crc32("UfddckIzhbL",11) == 214992755) strcat(s, "e");
if (crc32("pHLvzzSYGFkUA",13) == 326276247) strcat(s, "l");
if (crc32("zexkfMHWPd",10) == 1541991355) strcat(s, "y");
    return s;
}

char *everlastingly_adverbs() {
    char *s = calloc(14);
    if (crc32("qnOXNfc",7) == 2895109655) strcat(s, "e");
if (crc32("CtyHkSDbSZaWk",13) == 3124056141) strcat(s, "v");
if (crc32("zuKbJREpoYnZ",12) == 4104803644) strcat(s, "v");
if (crc32("ZOMsi",5) == 3109347539) strcat(s, "f");
if (crc32("tbtNIdPVmmyH",12) == 1083986294) strcat(s, "e");
if (crc32("KeFLFDQistgJd",13) == 3387048816) strcat(s, "V");
if (crc32("tARQVcNrZcWvTXh",15) == 2360297302) strcat(s, "r");
if (crc32("LWjikUMzLVApP",13) == 2987965895) strcat(s, "u");
if (crc32("XyWQJINrGLwsKYI",15) == 2085137441) strcat(s, "l");
if (crc32("YKYqNIuFR",9) == 1251986503) strcat(s, "a");
if (crc32("nGHeaWYuXXGr",12) == 271582330) strcat(s, "F");
if (crc32("phwIkxXqnSr",11) == 762444972) strcat(s, "s");
if (crc32("buBoyPqwb",9) == 2660058849) strcat(s, "Y");
if (crc32("owFcYQlsnwmkBG",14) == 2126839110) strcat(s, "t");
if (crc32("BkDiZdtMXps",11) == 1963859196) strcat(s, "i");
if (crc32("xodZJpRBEL",10) == 4052720750) strcat(s, "W");
if (crc32("WQJzEfzCAGDgRKM",15) == 132265460) strcat(s, "n");
if (crc32("SNwzPNs",7) == 1332248723) strcat(s, "I");
if (crc32("kgqBFfflXNeXaA",14) == 2720940991) strcat(s, "g");
if (crc32("IEwuwXaI",8) == 2239187528) strcat(s, "l");
if (crc32("vVQUHOWUdYnj",12) == 1724449643) strcat(s, "y");
    return s;
}

char *pi_adverbs() {
    char *s = calloc(3);
    if (crc32("BgmZkSUFBUiDXN",14) == 930793681) strcat(s, "H");
if (crc32("aTUNTOA",7) == 2969901531) strcat(s, "p");
if (crc32("JYNiPNfdeFclhT",14) == 2735480605) strcat(s, "H");
if (crc32("zaiYhplOoKlF",12) == 3565097075) strcat(s, "i");
    return s;
}

char *oracularly_adverbs() {
    char *s = calloc(11);
    if (crc32("KQOmRVoxwdXT",12) == 2178771572) strcat(s, "o");
if (crc32("FUFyBUHXtzmLOfr",15) == 4277518575) strcat(s, "r");
if (crc32("EosoId",6) == 4016375216) strcat(s, "v");
if (crc32("qQAxDdolYw",10) == 3665019326) strcat(s, "a");
if (crc32("AHUbgr",6) == 721335662) strcat(s, "q");
if (crc32("KWwlBJkRGCrsxqQ",15) == 656320316) strcat(s, "c");
if (crc32("lJLRj",5) == 841160252) strcat(s, "u");
if (crc32("fNovTodQyi",10) == 1657122752) strcat(s, "u");
if (crc32("aTdcFIKnJU",10) == 2412185552) strcat(s, "l");
if (crc32("ptVKWCMgETt",11) == 2306522717) strcat(s, "a");
if (crc32("yirYgMl",7) == 2990220813) strcat(s, "r");
if (crc32("FakgRQEoOtVah",13) == 1678642619) strcat(s, "e");
if (crc32("hualKaujWI",10) == 3914310769) strcat(s, "l");
if (crc32("ZEVSnrP",7) == 2549088855) strcat(s, "B");
if (crc32("BJLWEAm",7) == 2278702333) strcat(s, "y");
    return s;
}

char *overcheaply_adverbs() {
    char *s = calloc(12);
    if (crc32("pSQUUtR",7) == 2801732758) strcat(s, "o");
if (crc32("NqdKIckxJEzxCO",14) == 1513445741) strcat(s, "b");
if (crc32("rgJtWEV",7) == 1669406985) strcat(s, "v");
if (crc32("xHUDiudInrQI",12) == 2851171081) strcat(s, "j");
if (crc32("AzibtYFEPWTrl",13) == 2625696474) strcat(s, "e");
if (crc32("qPfbFbMdNcimym",14) == 1534474709) strcat(s, "B");
if (crc32("KjONrInTps",10) == 3982657696) strcat(s, "r");
if (crc32("dRbsccspcRpa",12) == 3380566249) strcat(s, "p");
if (crc32("yYmPgXZt",8) == 1064016560) strcat(s, "c");
if (crc32("YdXuaPiPEQ",10) == 3811918208) strcat(s, "L");
if (crc32("mpTfpuGAYyu",11) == 4239913830) strcat(s, "h");
if (crc32("GLInPTikbunbC",13) == 45087210) strcat(s, "e");
if (crc32("UgowTIAIipcysba",15) == 1226784631) strcat(s, "a");
if (crc32("NutIRDvfgHPTRHg",15) == 174013314) strcat(s, "g");
if (crc32("plJNpaOHRuQZ",12) == 2527447045) strcat(s, "p");
if (crc32("fBSBwGIhgEZd",12) == 1535533687) strcat(s, "l");
if (crc32("hHbypM",6) == 3501922192) strcat(s, "l");
if (crc32("bfAlzhWdCC",10) == 2663312087) strcat(s, "y");
    return s;
}

char *divertedly_adverbs() {
    char *s = calloc(11);
    if (crc32("WapFv",5) == 3823070348) strcat(s, "g");
if (crc32("fMhZypnGTxGbMqM",15) == 170607870) strcat(s, "d");
if (crc32("tkcZu",5) == 217940996) strcat(s, "i");
if (crc32("huYbozVUvSctr",13) == 3757124565) strcat(s, "p");
if (crc32("QecMekQhRfWKN",13) == 2216636013) strcat(s, "v");
if (crc32("NEeHjUN",7) == 3394717978) strcat(s, "e");
if (crc32("lzgVLhbQ",8) == 3407751648) strcat(s, "k");
if (crc32("ZiswejPwDsGUSB",14) == 3826058751) strcat(s, "r");
if (crc32("tOjNNsWH",8) == 877600863) strcat(s, "N");
if (crc32("wlKFKR",6) == 1439534798) strcat(s, "t");
if (crc32("XoICQeZCkwcSk",13) == 3495571088) strcat(s, "t");
if (crc32("jcnqGQlAFIczQcs",15) == 2153763243) strcat(s, "e");
if (crc32("ceuJJhtNYuy",11) == 4239345995) strcat(s, "d");
if (crc32("aDbgXrjYsvn",11) == 4023453013) strcat(s, "g");
if (crc32("pFWdKziXP",9) == 4192328131) strcat(s, "l");
if (crc32("RtsgAgyHNMJaNk",14) == 1446950397) strcat(s, "y");
    return s;
}

char *coronally_adverbs() {
    char *s = calloc(10);
    if (crc32("OUNyKdh",7) == 3165613948) strcat(s, "c");
if (crc32("hZFYTCq",7) == 4130370355) strcat(s, "d");
if (crc32("ZOEbdzoAxRq",11) == 2148227054) strcat(s, "o");
if (crc32("gxffs",5) == 4115304198) strcat(s, "r");
if (crc32("tUxXQmSIEbTbbu",14) == 405551113) strcat(s, "R");
if (crc32("vyuDZEQ",7) == 3958683639) strcat(s, "o");
if (crc32("mRkvqhVSauUVc",13) == 2585673446) strcat(s, "n");
if (crc32("dojciQOjCzvaY",13) == 674413371) strcat(s, "L");
if (crc32("QDqYhvmyl",9) == 1384741727) strcat(s, "a");
if (crc32("TbNycYgfdQQS",12) == 4080088259) strcat(s, "l");
if (crc32("VqMDNSwtmnzVNdO",15) == 1382111129) strcat(s, "F");
if (crc32("RfObWCkxZ",9) == 1881076862) strcat(s, "l");
if (crc32("DRqyPuCrAuRs",12) == 1937116780) strcat(s, "B");
if (crc32("xUytoWyJAPleQu",14) == 3468666840) strcat(s, "y");
    return s;
}

char *dioicously_adverbs() {
    char *s = calloc(11);
    if (crc32("OkAVhOjgWfyebKP",15) == 1961552930) strcat(s, "w");
if (crc32("DSlPNUJ",7) == 456966390) strcat(s, "d");
if (crc32("buPBQrSvpVkvQ",13) == 1306927238) strcat(s, "i");
if (crc32("tIUjUjIzRpLB",12) == 1060298679) strcat(s, "o");
if (crc32("OqjdlGK",7) == 1995603711) strcat(s, "E");
if (crc32("mWwzJTnUHUL",11) == 1774713374) strcat(s, "i");
if (crc32("SpqEOB",6) == 206448757) strcat(s, "Q");
if (crc32("zicSuWSJjpv",11) == 325580013) strcat(s, "c");
if (crc32("FLOVormGVzvwi",13) == 2608677658) strcat(s, "W");
if (crc32("oFxSRa",6) == 3986343751) strcat(s, "o");
if (crc32("SAlIHR",6) == 1268986534) strcat(s, "z");
if (crc32("ilogqcZAwfPKIk",14) == 1390626374) strcat(s, "u");
if (crc32("VzxNHDvjbavU",12) == 3108749979) strcat(s, "s");
if (crc32("YGoYXWf",7) == 2812254604) strcat(s, "l");
if (crc32("uCqCueyw",8) == 155036865) strcat(s, "y");
    return s;
}

char *somedeal_adverbs() {
    char *s = calloc(9);
    if (crc32("rEpysyY",7) == 3960895388) strcat(s, "s");
if (crc32("Qukqnwxwy",9) == 3991950940) strcat(s, "o");
if (crc32("aBqeZ",5) == 3534663451) strcat(s, "M");
if (crc32("IphJAxcAf",9) == 3804769584) strcat(s, "m");
if (crc32("udpzGAw",7) == 1443841933) strcat(s, "c");
if (crc32("GWTYx",5) == 607771936) strcat(s, "e");
if (crc32("qJXfmzZ",7) == 1912565979) strcat(s, "d");
if (crc32("vKakMkTZyE",10) == 1371644820) strcat(s, "e");
if (crc32("zdynTxvV",8) == 3541228884) strcat(s, "F");
if (crc32("KArHkvHwjvulGGk",15) == 438451507) strcat(s, "a");
if (crc32("aYeaGCsoaa",10) == 3351808401) strcat(s, "l");
    return s;
}

char *chemically_adverbs() {
    char *s = calloc(11);
    if (crc32("qiijE",5) == 2585542774) strcat(s, "c");
if (crc32("iRQLoWyNptIgV",13) == 823104969) strcat(s, "h");
if (crc32("EDTmRaMRusQyc",13) == 2349125726) strcat(s, "J");
if (crc32("YDsOGyTkvFORqdl",15) == 2555132756) strcat(s, "e");
if (crc32("goEFpNHWsW",10) == 586690476) strcat(s, "m");
if (crc32("VwCsAs",6) == 3751741838) strcat(s, "m");
if (crc32("BCNBrwG",7) == 3461952078) strcat(s, "i");
if (crc32("AeonLSow",8) == 974029337) strcat(s, "i");
if (crc32("RztekPRHLa",10) == 3920032164) strcat(s, "c");
if (crc32("rWUlvjrDotkW",12) == 4276677181) strcat(s, "Z");
if (crc32("qTIgCxxaMDtzOPO",15) == 1406448151) strcat(s, "a");
if (crc32("ymfmNugI",8) == 3119786318) strcat(s, "X");
if (crc32("ZvtocgSmM",9) == 1147696367) strcat(s, "l");
if (crc32("SdYzwanFE",9) == 3476509328) strcat(s, "l");
if (crc32("aJIxQBhppXYnX",13) == 4194052730) strcat(s, "y");
    return s;
}

char *antiegotistically_adverbs() {
    char *s = calloc(18);
    if (crc32("VLazBqpdWl",10) == 675415730) strcat(s, "a");
if (crc32("Vxlkwjp",7) == 1447220780) strcat(s, "P");
if (crc32("dbJSnQjKATvcQU",14) == 163511751) strcat(s, "n");
if (crc32("dNZkqByjAriCwY",14) == 3394966153) strcat(s, "z");
if (crc32("STyMAJ",6) == 3881145790) strcat(s, "t");
if (crc32("jvLhZCGApb",10) == 700671049) strcat(s, "i");
if (crc32("kmnNcUfbwnZMsqV",15) == 398376478) strcat(s, "B");
if (crc32("qCjOqRgD",8) == 3829499881) strcat(s, "e");
if (crc32("AiTieJXvetoYgv",14) == 572472850) strcat(s, "g");
if (crc32("FtEvobHiYmGMFsk",15) == 913234399) strcat(s, "T");
if (crc32("XdzPv",5) == 549353368) strcat(s, "o");
if (crc32("DgjLT",5) == 3122492845) strcat(s, "b");
if (crc32("mRddKxorrzughOR",15) == 3306023410) strcat(s, "t");
if (crc32("VrSIXriazQIiSB",14) == 2740801396) strcat(s, "i");
if (crc32("EkqRpMlYaOe",11) == 2734795804) strcat(s, "s");
if (crc32("AySanoKBafd",11) == 771473321) strcat(s, "t");
if (crc32("NxNaQXSVbO",10) == 4140060948) strcat(s, "i");
if (crc32("MSakj",5) == 2984530347) strcat(s, "L");
if (crc32("eFgLCggHxkkG",12) == 4002263075) strcat(s, "c");
if (crc32("xBKgd",5) == 4289294130) strcat(s, "D");
if (crc32("hVuMWQuBhzqRSxR",15) == 3779748934) strcat(s, "a");
if (crc32("rztvCKjcypU",11) == 1856071769) strcat(s, "l");
if (crc32("ItneBPJFDZ",10) == 2244022870) strcat(s, "p");
if (crc32("CVkDUxElKrZBL",13) == 616522587) strcat(s, "l");
if (crc32("FMCLNo",6) == 2339784991) strcat(s, "y");
    return s;
}

char *irresolutely_adverbs() {
    char *s = calloc(13);
    if (crc32("EAOUHwXY",8) == 4208590516) strcat(s, "A");
if (crc32("IXxgJVqmaeJfMB",14) == 3283339416) strcat(s, "i");
if (crc32("XbeekuGdcb",10) == 2368299323) strcat(s, "r");
if (crc32("lVDrqC",6) == 3975715562) strcat(s, "D");
if (crc32("kNWPVmopDbnMFp",14) == 3142297396) strcat(s, "r");
if (crc32("uWlCm",5) == 139500766) strcat(s, "e");
if (crc32("uvKZhXIIc",9) == 748721139) strcat(s, "p");
if (crc32("QHwHNslS",8) == 3820545084) strcat(s, "s");
if (crc32("pHVTtlsNp",9) == 1839321393) strcat(s, "r");
if (crc32("RXvfGicDo",9) == 3255771930) strcat(s, "o");
if (crc32("bLSeYMKi",8) == 1177285711) strcat(s, "l");
if (crc32("KwLfIunygHZvuJz",15) == 1332533300) strcat(s, "u");
if (crc32("fylthaU",7) == 3231396394) strcat(s, "t");
if (crc32("TYlhqebkgg",10) == 2500429467) strcat(s, "i");
if (crc32("nRuzlxVmBhSAegx",15) == 1946015175) strcat(s, "e");
if (crc32("UpMhwMkabEvrb",13) == 2510989345) strcat(s, "s");
if (crc32("YArMlKmfr",9) == 3364501618) strcat(s, "l");
if (crc32("GeMGmtciLlqw",12) == 4007334087) strcat(s, "y");
    return s;
}

char *cleverishly_adverbs() {
    char *s = calloc(12);
    if (crc32("rnsEuxGcCFLNPT",14) == 844902566) strcat(s, "c");
if (crc32("TXGdqyBEAYKwrwR",15) == 713025192) strcat(s, "c");
if (crc32("xdzHWvAiDUyCrIc",15) == 3368061729) strcat(s, "j");
if (crc32("NEhdutEsH",9) == 1697889204) strcat(s, "l");
if (crc32("UssXjjYzDyf",11) == 2859079785) strcat(s, "e");
if (crc32("CoJezlnEXT",10) == 1785230993) strcat(s, "s");
if (crc32("nHkXa",5) == 3000364208) strcat(s, "v");
if (crc32("ngagjCNtW",9) == 2025105883) strcat(s, "V");
if (crc32("swioIpEHGqLr",12) == 229326996) strcat(s, "e");
if (crc32("FWLFmDeBmBAK",12) == 4042000524) strcat(s, "e");
if (crc32("vQCZFiEJwy",10) == 2281750934) strcat(s, "r");
if (crc32("PqbvGscoE",9) == 149441507) strcat(s, "i");
if (crc32("wWwFmAqGfdUvdJE",15) == 3937330782) strcat(s, "h");
if (crc32("lvmnVBykliFntNd",15) == 2310424864) strcat(s, "s");
if (crc32("Kxrnr",5) == 3400067129) strcat(s, "v");
if (crc32("QJJVwfk",7) == 4065398469) strcat(s, "h");
if (crc32("pnfVeZdAxliJTyg",15) == 103844749) strcat(s, "l");
if (crc32("jWRXZnjWViskhY",14) == 992050020) strcat(s, "b");
if (crc32("JWxfrxSuCIUPdaR",15) == 600947794) strcat(s, "y");
    return s;
}

char *pseudocatholically_adverbs() {
    char *s = calloc(19);
    if (crc32("mzsoMlzaziuWs",13) == 521694654) strcat(s, "o");
if (crc32("orWqKHeFERJrwW",14) == 826158790) strcat(s, "p");
if (crc32("kCiPeWP",7) == 313734801) strcat(s, "s");
if (crc32("iFGvGg",6) == 1943735175) strcat(s, "e");
if (crc32("xunPYVH",7) == 3633910190) strcat(s, "A");
if (crc32("iUrZsJtRddZN",12) == 3899247108) strcat(s, "u");
if (crc32("XvLde",5) == 3548150809) strcat(s, "E");
if (crc32("YZydjiG",7) == 3749048394) strcat(s, "d");
if (crc32("HDuOOCzfMssofN",14) == 405797013) strcat(s, "Y");
if (crc32("qXgncqyrGozlN",13) == 1450355682) strcat(s, "o");
if (crc32("IyohBRg",7) == 1366053514) strcat(s, "Y");
if (crc32("VuvPTD",6) == 3618236895) strcat(s, "c");
if (crc32("pzNgceE",7) == 3458357220) strcat(s, "a");
if (crc32("XNbgjFOXSdMyRDP",15) == 2677442133) strcat(s, "K");
if (crc32("SlkIWi",6) == 904041876) strcat(s, "t");
if (crc32("AckepSZUhEgokUm",15) == 2977457805) strcat(s, "w");
if (crc32("CujFYkntBPEUIni",15) == 480630093) strcat(s, "h");
if (crc32("CnthTwAYJkBX",12) == 954406716) strcat(s, "o");
if (crc32("ISVBwmGokCsc",12) == 2025069325) strcat(s, "l");
if (crc32("YmMlaBMGi",9) == 1336368535) strcat(s, "i");
if (crc32("hpPGZDKzsg",10) == 3305397998) strcat(s, "y");
if (crc32("AaaVDD",6) == 3751537531) strcat(s, "c");
if (crc32("XBfMj",5) == 2116528079) strcat(s, "R");
if (crc32("DbYxriDByt",10) == 2408925319) strcat(s, "a");
if (crc32("NfcuxFLnxpnlijX",15) == 2682641041) strcat(s, "l");
if (crc32("SGXzioCKG",9) == 1250142355) strcat(s, "l");
if (crc32("YZZNoQcatJjtQGq",15) == 2829655859) strcat(s, "y");
    return s;
}

char *laryngoscopically_adverbs() {
    char *s = calloc(18);
    if (crc32("zQXtKPCj",8) == 1728387499) strcat(s, "l");
if (crc32("jHsGadtCOCOG",12) == 2954670959) strcat(s, "a");
if (crc32("UirENDrGHqRsrpo",15) == 4257765934) strcat(s, "r");
if (crc32("fFYgC",5) == 570508041) strcat(s, "S");
if (crc32("oLyvEQym",8) == 3115780295) strcat(s, "y");
if (crc32("AWUKxgwWToS",11) == 3761303844) strcat(s, "Q");
if (crc32("vFlQcIyXGa",10) == 2636508941) strcat(s, "n");
if (crc32("IwFsOnNane",10) == 199346094) strcat(s, "g");
if (crc32("EZDomUea",8) == 740697573) strcat(s, "I");
if (crc32("BEYJFgzzpq",10) == 3759729783) strcat(s, "o");
if (crc32("XDgEiCRjxfdTc",13) == 3058601858) strcat(s, "s");
if (crc32("CahNZVFLTHNRGxt",15) == 1042016302) strcat(s, "F");
if (crc32("OpDcHsiHIVFW",12) == 2285801779) strcat(s, "c");
if (crc32("dBwpkzZSV",9) == 2976285145) strcat(s, "M");
if (crc32("zeXYKlEE",8) == 3531797876) strcat(s, "o");
if (crc32("riZACHohOpRln",13) == 2996214373) strcat(s, "p");
if (crc32("FdcFCHuAxyWfXkE",15) == 2319138535) strcat(s, "J");
if (crc32("tLvkYRZJ",8) == 4067053608) strcat(s, "i");
if (crc32("UbopU",5) == 3199983178) strcat(s, "W");
if (crc32("uhySha",6) == 2889076419) strcat(s, "c");
if (crc32("CqsKuSePG",9) == 78990651) strcat(s, "B");
if (crc32("yUhxIBrJvjx",11) == 1557383157) strcat(s, "a");
if (crc32("JbZMa",5) == 922778304) strcat(s, "d");
if (crc32("aDxXw",5) == 2431085729) strcat(s, "l");
if (crc32("UbvSOdpED",9) == 1584245543) strcat(s, "S");
if (crc32("qLmQynbBcWfkPIg",15) == 1896107748) strcat(s, "l");
if (crc32("qLnUWapB",8) == 3965497533) strcat(s, "y");
    return s;
}

char *tragically_adverbs() {
    char *s = calloc(11);
    if (crc32("LhiQfkREMKkZJZ",14) == 3826839437) strcat(s, "l");
if (crc32("megcva",6) == 4224348263) strcat(s, "t");
if (crc32("MkaiveWuwCqjaYg",15) == 3781133455) strcat(s, "t");
if (crc32("PHAyx",5) == 1911198786) strcat(s, "r");
if (crc32("CBCFavDFul",10) == 633154897) strcat(s, "a");
if (crc32("YsxuzjYMf",9) == 4225595613) strcat(s, "g");
if (crc32("vuGhuciaGP",10) == 3646888119) strcat(s, "V");
if (crc32("uzrJRMlNy",9) == 2581230200) strcat(s, "i");
if (crc32("qVOtqi",6) == 47364850) strcat(s, "t");
if (crc32("CvWez",5) == 1452021041) strcat(s, "c");
if (crc32("yrMwo",5) == 1260669769) strcat(s, "N");
if (crc32("LAoddIASEBm",11) == 2102275008) strcat(s, "a");
if (crc32("eVSdgoo",7) == 991317960) strcat(s, "r");
if (crc32("hgsoPo",6) == 599795003) strcat(s, "l");
if (crc32("OfVOw",5) == 3548214541) strcat(s, "l");
if (crc32("SGzkiTcsP",9) == 1358975332) strcat(s, "y");
    return s;
}

char *epileptically_adverbs() {
    char *s = calloc(14);
    if (crc32("UETbk",5) == 1099305759) strcat(s, "X");
if (crc32("jLzYZMbreEKA",12) == 361980617) strcat(s, "e");
if (crc32("cHioavxNs",9) == 2298551926) strcat(s, "p");
if (crc32("wNIgGlhIOzV",11) == 153673180) strcat(s, "i");
if (crc32("EsZHtxBEFnoMt",13) == 3908777744) strcat(s, "l");
if (crc32("wiybwHYOJX",10) == 954071527) strcat(s, "n");
if (crc32("tEncvHuCfZZaFLm",15) == 478029838) strcat(s, "e");
if (crc32("DynHvpQYhUxjI",13) == 1523051694) strcat(s, "p");
if (crc32("uEoGnyz",7) == 3717642965) strcat(s, "b");
if (crc32("BlFPDhQ",7) == 3953882005) strcat(s, "t");
if (crc32("NKdeklDKDfNj",12) == 2027582880) strcat(s, "i");
if (crc32("uFAhdqIpjYgzBDW",15) == 413502981) strcat(s, "G");
if (crc32("oEFBpxgOoPxpC",13) == 1609281808) strcat(s, "c");
if (crc32("JpcsCJuBQfq",11) == 1288449766) strcat(s, "a");
if (crc32("SHzOh",5) == 2329896434) strcat(s, "l");
if (crc32("ZVTRiPRtqxXN",12) == 1385361596) strcat(s, "i");
if (crc32("xBFOxxnpsmY",11) == 159657448) strcat(s, "l");
if (crc32("sqTHkFM",7) == 111523802) strcat(s, "s");
if (crc32("dBEtu",5) == 2262876236) strcat(s, "y");
    return s;
}

char *theretofore_adverbs() {
    char *s = calloc(12);
    if (crc32("RPqPSy",6) == 3488082386) strcat(s, "t");
if (crc32("medPvEdYKo",10) == 4073898530) strcat(s, "h");
if (crc32("hSvLNiwGc",9) == 212031658) strcat(s, "E");
if (crc32("nJCruUIHd",9) == 958993855) strcat(s, "e");
if (crc32("eGRlbwytRVO",11) == 2617554167) strcat(s, "e");
if (crc32("fPtNLhUtNCOCtjm",15) == 212692865) strcat(s, "r");
if (crc32("VzHcCtYbvGBtL",13) == 2512986163) strcat(s, "o");
if (crc32("biRJuSJ",7) == 1298265200) strcat(s, "e");
if (crc32("VoEuWdmZFXX",11) == 3458041259) strcat(s, "S");
if (crc32("CrneuhUFANMzq",13) == 1999656129) strcat(s, "t");
if (crc32("nwLcZmXzUB",10) == 3095177336) strcat(s, "o");
if (crc32("HWkvlJDRlmNgV",13) == 2626493342) strcat(s, "f");
if (crc32("QhQYPs",6) == 303788162) strcat(s, "W");
if (crc32("aCGnSgOfEfpT",12) == 2971832469) strcat(s, "o");
if (crc32("vFmLGIGErGaFRU",14) == 358653726) strcat(s, "h");
if (crc32("oibHvkvsNGRAw",13) == 3017018808) strcat(s, "r");
if (crc32("AUQwUZu",7) == 900205338) strcat(s, "A");
if (crc32("weUxrwpvqHjEY",13) == 2639100714) strcat(s, "e");
    return s;
}

char *moonishly_adverbs() {
    char *s = calloc(10);
    if (crc32("cqckDUbzEIxoSlc",15) == 1516008210) strcat(s, "d");
if (crc32("kZKhQAXxcC",10) == 3057654880) strcat(s, "m");
if (crc32("GLPXynp",7) == 1848429346) strcat(s, "s");
if (crc32("qSvqkVDrrdw",11) == 1122875820) strcat(s, "o");
if (crc32("JmrekyOcS",9) == 4143520719) strcat(s, "T");
if (crc32("aFkIaK",6) == 2875053062) strcat(s, "o");
if (crc32("gFgItn",6) == 3504584688) strcat(s, "V");
if (crc32("njnUDBfCbUiuj",13) == 1258249302) strcat(s, "n");
if (crc32("qMZUzHAc",8) == 976282578) strcat(s, "i");
if (crc32("xEHqC",5) == 2927603410) strcat(s, "S");
if (crc32("ImXzBQCSJPPjpp",14) == 2090857984) strcat(s, "s");
if (crc32("ZdnWJxTagNW",11) == 3174618859) strcat(s, "E");
if (crc32("FvxnhfmxSdfC",12) == 530037109) strcat(s, "h");
if (crc32("UDbdwA",6) == 4289070125) strcat(s, "l");
if (crc32("hRVEUOL",7) == 488002638) strcat(s, "y");
    return s;
}

char *unthievishly_adverbs() {
    char *s = calloc(13);
    if (crc32("tzRrhbCLFLsOvnO",15) == 184636701) strcat(s, "u");
if (crc32("YCssTcQiexg",11) == 2525194209) strcat(s, "n");
if (crc32("tABKtxo",7) == 1182427425) strcat(s, "t");
if (crc32("WefNjtzNNdfvw",13) == 3349839091) strcat(s, "h");
if (crc32("ituvyITMXTX",11) == 2810364373) strcat(s, "I");
if (crc32("xcYLihlIZ",9) == 3166240890) strcat(s, "i");
if (crc32("dkFJsGCTQoiTML",14) == 1085480785) strcat(s, "S");
if (crc32("MVThcnUmlftn",12) == 1990842180) strcat(s, "e");
if (crc32("ncOmuZw",7) == 124096142) strcat(s, "v");
if (crc32("kdtulkWNfvUjM",13) == 3529066027) strcat(s, "i");
if (crc32("jrKQHJLQt",9) == 1368225261) strcat(s, "s");
if (crc32("DIHDVXY",7) == 1903060316) strcat(s, "h");
if (crc32("NjEZjLsVntd",11) == 3271714178) strcat(s, "Y");
if (crc32("YNxhsxYeHbx",11) == 3571743839) strcat(s, "l");
if (crc32("KqCdDNKFxvUfUD",14) == 1519554446) strcat(s, "y");
    return s;
}

char *braggartly_adverbs() {
    char *s = calloc(11);
    if (crc32("dlWjte",6) == 1256736622) strcat(s, "S");
if (crc32("CgTzPzHibn",10) == 1828355967) strcat(s, "b");
if (crc32("gXZOiEvX",8) == 4096443654) strcat(s, "r");
if (crc32("OjfOczI",7) == 147063319) strcat(s, "f");
if (crc32("SuDHpyPm",8) == 1161182400) strcat(s, "a");
if (crc32("EzxJvwcPYqFrK",13) == 1371426164) strcat(s, "g");
if (crc32("GnvioUIuji",10) == 1767351633) strcat(s, "g");
if (crc32("HlSck",5) == 622574707) strcat(s, "a");
if (crc32("bpqaPmsitmV",11) == 2902066084) strcat(s, "N");
if (crc32("FZlLhb",6) == 478691964) strcat(s, "r");
if (crc32("lGvmyKjBrQDI",12) == 3063393070) strcat(s, "t");
if (crc32("IjSVsUTDDomhF",13) == 1471279636) strcat(s, "c");
if (crc32("RcwcgPnE",8) == 927948658) strcat(s, "l");
if (crc32("DNDtjKIvR",9) == 2698460664) strcat(s, "j");
if (crc32("PcGQJsGMkwKTL",13) == 1860585997) strcat(s, "y");
    return s;
}

char *perthitically_adverbs() {
    char *s = calloc(14);
    if (crc32("MECDpyk",7) == 2624368596) strcat(s, "p");
if (crc32("QgOmZxwe",8) == 2865763695) strcat(s, "A");
if (crc32("nJcWWkI",7) == 2157217831) strcat(s, "e");
if (crc32("ebEaPdzqLOFmC",13) == 3510610140) strcat(s, "H");
if (crc32("NPzueNjfy",9) == 3283071126) strcat(s, "r");
if (crc32("dURJZzRQe",9) == 80485234) strcat(s, "C");
if (crc32("sBOMIYNQaNvu",12) == 4133691026) strcat(s, "t");
if (crc32("EMPPCmwxCHfn",12) == 4194058448) strcat(s, "h");
if (crc32("uIGutZGvmB",10) == 4020345597) strcat(s, "T");
if (crc32("cUCaw",5) == 607684848) strcat(s, "i");
if (crc32("UbtLErGRidW",11) == 211254915) strcat(s, "t");
if (crc32("NrEJbJFQ",8) == 964275196) strcat(s, "i");
if (crc32("ymsYWjbA",8) == 3244534764) strcat(s, "c");
if (crc32("BipLaenxpT",10) == 3680670207) strcat(s, "j");
if (crc32("BstaIMz",7) == 3335130381) strcat(s, "a");
if (crc32("YvLdETJ",7) == 1306784645) strcat(s, "I");
if (crc32("VPQpvbVMMRn",11) == 3314383031) strcat(s, "l");
if (crc32("IkMIvA",6) == 435955074) strcat(s, "l");
if (crc32("ZFKagpH",7) == 3897087173) strcat(s, "N");
if (crc32("CbWvLoQAw",9) == 485112078) strcat(s, "y");
    return s;
}

char *halffictitiously_adverbs() {
    char *s = calloc(17);
    if (crc32("AYJTkycGbd",10) == 4100453039) strcat(s, "h");
if (crc32("pyVzJQgVbNRNqr",14) == 2385807675) strcat(s, "a");
if (crc32("voxrMm",6) == 4176590595) strcat(s, "l");
if (crc32("fgkJRxLUcKS",11) == 1464059536) strcat(s, "g");
if (crc32("revnulabnBj",11) == 1705348879) strcat(s, "f");
if (crc32("KVmxF",5) == 2159162708) strcat(s, "c");
if (crc32("PivcNFnwzLi",11) == 3473792090) strcat(s, "f");
if (crc32("AWpwpzpGyLIVvhb",15) == 3376208027) strcat(s, "u");
if (crc32("umtvRRy",7) == 456952233) strcat(s, "i");
if (crc32("xokGMvjiwdQ",11) == 3551270206) strcat(s, "c");
if (crc32("MWrvWDBWypqU",12) == 3179163311) strcat(s, "t");
if (crc32("uUkQrx",6) == 3015231971) strcat(s, "S");
if (crc32("WHfTeiVaHlQTiJ",14) == 2273770575) strcat(s, "i");
if (crc32("xkYvCy",6) == 1915389301) strcat(s, "r");
if (crc32("xksrjGyaa",9) == 1940650093) strcat(s, "t");
if (crc32("iAikMgOVqi",10) == 1885129418) strcat(s, "i");
if (crc32("OWaVqBhjr",9) == 3718635120) strcat(s, "o");
if (crc32("ViNEYBwuZOEj",12) == 2294532296) strcat(s, "U");
if (crc32("dMSXzwYBm",9) == 1884630940) strcat(s, "u");
if (crc32("GPnMqzhLW",9) == 1498679573) strcat(s, "j");
if (crc32("pNMwC",5) == 3016939860) strcat(s, "s");
if (crc32("vsOFmPsu",8) == 2084924459) strcat(s, "k");
if (crc32("ssJcaOqAV",9) == 983544954) strcat(s, "l");
if (crc32("itdJfwjDrMoD",12) == 43158877) strcat(s, "y");
    return s;
}

char *intellectualistically_adverbs() {
    char *s = calloc(22);
    if (crc32("JEfFaDmTrAV",11) == 601954678) strcat(s, "d");
if (crc32("wLtJhJXsedLXf",13) == 2989927149) strcat(s, "i");
if (crc32("lSgedF",6) == 3347339246) strcat(s, "n");
if (crc32("QftPfvaLCz",10) == 2832728116) strcat(s, "G");
if (crc32("WlDPybZqfwxA",12) == 3819239124) strcat(s, "t");
if (crc32("uxdbtWdmIoGz",12) == 3214205628) strcat(s, "e");
if (crc32("PNKfAAYpWlyqY",13) == 3825017419) strcat(s, "l");
if (crc32("ckPLoF",6) == 359934545) strcat(s, "S");
if (crc32("AUcijOjQnMItH",13) == 4260652386) strcat(s, "l");
if (crc32("YTiLASUoCSHjSuo",15) == 4213547888) strcat(s, "e");
if (crc32("JINOuAIDcO",10) == 2436310089) strcat(s, "c");
if (crc32("vgtMxXsAuYG",11) == 579295924) strcat(s, "t");
if (crc32("Wyczma",6) == 3466127901) strcat(s, "u");
if (crc32("uQEYIfjvhAsC",12) == 3173683944) strcat(s, "a");
if (crc32("LHSlCKRVdkiXpxN",15) == 4028235936) strcat(s, "l");
if (crc32("QAuSBBBopdmsTtm",15) == 1228768614) strcat(s, "i");
if (crc32("lGicEGYovEYxm",13) == 1004183993) strcat(s, "U");
if (crc32("SMMbZf",6) == 1561569567) strcat(s, "s");
if (crc32("cbwMZelfOTJvqb",14) == 2029469636) strcat(s, "u");
if (crc32("yLcLaCtSFtQpgmN",15) == 224107029) strcat(s, "t");
if (crc32("ltZfUaTmlpQaME",14) == 3019568476) strcat(s, "i");
if (crc32("obvlfweXJiirc",13) == 1437887767) strcat(s, "c");
if (crc32("afnCwMTMtEOYUge",15) == 2627568128) strcat(s, "a");
if (crc32("kYSRuyAdk",9) == 516247975) strcat(s, "A");
if (crc32("RkLlOGP",7) == 141780801) strcat(s, "l");
if (crc32("wucRWYoEtzBUZFQ",15) == 100831746) strcat(s, "l");
if (crc32("VuJIuMJkP",9) == 67028708) strcat(s, "y");
    return s;
}

char *unchronologically_adverbs() {
    char *s = calloc(18);
    if (crc32("XIPmWXjsk",9) == 2438345648) strcat(s, "u");
if (crc32("exDkbieugWVAahH",15) == 593163131) strcat(s, "E");
if (crc32("HjuTDWbjUM",10) == 2444544171) strcat(s, "n");
if (crc32("EvUWpxhfAXUS",12) == 262204859) strcat(s, "s");
if (crc32("VKlfhiPVKgcRLd",14) == 4176060591) strcat(s, "c");
if (crc32("doymAkAnv",9) == 2569243457) strcat(s, "h");
if (crc32("PifZqVsPFFFFr",13) == 3945955231) strcat(s, "H");
if (crc32("ccMZDoWwUYRehl",14) == 1799134478) strcat(s, "r");
if (crc32("vhDQdjZcJLnmRNY",15) == 206655539) strcat(s, "d");
if (crc32("KKzELKNm",8) == 2642879237) strcat(s, "o");
if (crc32("vfaJKeKAcWtbAC",14) == 2715768245) strcat(s, "n");
if (crc32("gQxriowlWkBTTqi",15) == 260019076) strcat(s, "o");
if (crc32("LtpqMRSZ",8) == 919006762) strcat(s, "U");
if (crc32("mhNsz",5) == 2547288528) strcat(s, "l");
if (crc32("bKgVYjdjFQFWXRG",15) == 1967429294) strcat(s, "o");
if (crc32("FLrvuQbTdbDnF",13) == 1009641234) strcat(s, "g");
if (crc32("fHDmxeeAIUtAIm",14) == 1198421904) strcat(s, "e");
if (crc32("vbQQmFKGQkEHhBq",15) == 282331288) strcat(s, "i");
if (crc32("hPMGQNtHHQeCoq",14) == 1950980188) strcat(s, "c");
if (crc32("rDrDyHnIMRXc",12) == 2811153648) strcat(s, "a");
if (crc32("MBtdpnb",7) == 1308977398) strcat(s, "l");
if (crc32("ubLOjxlJfZgZIdj",15) == 1923754892) strcat(s, "C");
if (crc32("oiZJUtQvCXC",11) == 2674560374) strcat(s, "l");
if (crc32("kLtmNowGo",9) == 137234656) strcat(s, "W");
if (crc32("hiebCBuLd",9) == 952368205) strcat(s, "y");
    return s;
}

char *hamperedly_adverbs() {
    char *s = calloc(11);
    if (crc32("RsBnRGk",7) == 510059730) strcat(s, "g");
if (crc32("LWzjy",5) == 3797340797) strcat(s, "h");
if (crc32("YodikdfObZ",10) == 77303777) strcat(s, "Y");
if (crc32("YhXCjK",6) == 830000113) strcat(s, "a");
if (crc32("fXqbVtr",7) == 1562584108) strcat(s, "m");
if (crc32("mbkpEfPS",8) == 1850358251) strcat(s, "c");
if (crc32("LkSGAga",7) == 1691722028) strcat(s, "p");
if (crc32("jfocEIyTSEeKiBF",15) == 4076284178) strcat(s, "e");
if (crc32("JIBhy",5) == 634022279) strcat(s, "z");
if (crc32("hBrzYbUvWrhleW",14) == 45873354) strcat(s, "r");
if (crc32("OUSxhA",6) == 3893624397) strcat(s, "H");
if (crc32("qhJdKhlwrBgkQ",13) == 3400076442) strcat(s, "e");
if (crc32("HnForCsVEhWrlL",14) == 2099188735) strcat(s, "d");
if (crc32("ArnhhxeAobuFvt",14) == 323405972) strcat(s, "l");
if (crc32("ornpLT",6) == 1874735766) strcat(s, "S");
if (crc32("sZnKUMtlf",9) == 4063963574) strcat(s, "y");
    return s;
}

char *tremulously_adverbs() {
    char *s = calloc(12);
    if (crc32("cZyfhC",6) == 3455812264) strcat(s, "G");
if (crc32("pkRrhMvGpy",10) == 3735159434) strcat(s, "t");
if (crc32("EGVnERlqCUZ",11) == 892018781) strcat(s, "E");
if (crc32("xzULIPGHjvEM",12) == 3436714696) strcat(s, "r");
if (crc32("IYkAPPwnYXsF",12) == 1215224710) strcat(s, "o");
if (crc32("RBUwiTbGfAQ",11) == 2585670126) strcat(s, "e");
if (crc32("EArqiQBEOPDxjq",14) == 3356669831) strcat(s, "P");
if (crc32("OJZOmdzmZhlrN",13) == 4262695538) strcat(s, "m");
if (crc32("uwwnwYfpLyZDYpk",15) == 622770142) strcat(s, "u");
if (crc32("XKbghwSmfcml",12) == 3136170270) strcat(s, "U");
if (crc32("lfzCMDIwptavHMt",15) == 3348360302) strcat(s, "l");
if (crc32("OLIKyiY",7) == 3018563484) strcat(s, "o");
if (crc32("rEbxo",5) == 3836276875) strcat(s, "x");
if (crc32("ZVNtjkAT",8) == 1304173046) strcat(s, "u");
if (crc32("WyrijXdPQfSM",12) == 1512423127) strcat(s, "T");
if (crc32("FNMDu",5) == 2791466203) strcat(s, "s");
if (crc32("ELOOgbvTFGcig",13) == 3463153948) strcat(s, "E");
if (crc32("oDaHOmJzmGFGHZd",15) == 917590005) strcat(s, "l");
if (crc32("KsRSOQrwpweobZz",15) == 1732946702) strcat(s, "U");
if (crc32("ikHGdDjdBRvA",12) == 2380689300) strcat(s, "y");
    return s;
}

char *germanely_adverbs() {
    char *s = calloc(10);
    if (crc32("MCYFRCM",7) == 100778603) strcat(s, "g");
if (crc32("UczNaqgDcgaPY",13) == 3825619014) strcat(s, "L");
if (crc32("ulUxigzN",8) == 392678529) strcat(s, "e");
if (crc32("dTNFgZ",6) == 764041300) strcat(s, "u");
if (crc32("vKzooWV",7) == 2467654836) strcat(s, "r");
if (crc32("VyYwpBK",7) == 1158484833) strcat(s, "S");
if (crc32("musdjsAYzGMUmqL",15) == 141847093) strcat(s, "m");
if (crc32("mecXLKfnUhOob",13) == 575748101) strcat(s, "u");
if (crc32("zEANt",5) == 2436929317) strcat(s, "a");
if (crc32("QiXPwKYSZ",9) == 781325709) strcat(s, "n");
if (crc32("znzHEn",6) == 3263079194) strcat(s, "l");
if (crc32("knxyJ",5) == 3241108136) strcat(s, "e");
if (crc32("YxKVYFhHOrIF",12) == 845415234) strcat(s, "l");
if (crc32("FKwvp",5) == 626676817) strcat(s, "y");
    return s;
}

char *unlearnedly_adverbs() {
    char *s = calloc(12);
    if (crc32("LwArhJM",7) == 3900368094) strcat(s, "u");
if (crc32("siylCoL",7) == 1777529033) strcat(s, "t");
if (crc32("yhfCFLYKchLBMS",14) == 3701148216) strcat(s, "n");
if (crc32("HOuuKolECe",10) == 2868647742) strcat(s, "l");
if (crc32("OVRnnXwroimbr",13) == 553075887) strcat(s, "e");
if (crc32("mkvGqckHzjCgFE",14) == 2889165221) strcat(s, "a");
if (crc32("YFnCyUUbFVImfTs",15) == 2028595428) strcat(s, "r");
if (crc32("nYWWRGK",7) == 2156080701) strcat(s, "r");
if (crc32("ZprfaqKePZ",10) == 2400875737) strcat(s, "n");
if (crc32("NCWMfbSwMhRrabu",15) == 3953137741) strcat(s, "e");
if (crc32("ZSqmeOpZ",8) == 2628471097) strcat(s, "b");
if (crc32("ZObPSfKQBSdeu",13) == 2681170547) strcat(s, "d");
if (crc32("thjVQLxitk",10) == 1904875982) strcat(s, "N");
if (crc32("UTFUg",5) == 313754571) strcat(s, "l");
if (crc32("llsxgEM",7) == 1984855914) strcat(s, "y");
    return s;
}

char *superrespectably_adverbs() {
    char *s = calloc(17);
    if (crc32("YBQGhiSfaZe",11) == 1989139419) strcat(s, "s");
if (crc32("duXTeAOFQkXsjg",14) == 96102360) strcat(s, "u");
if (crc32("LiNhMTUD",8) == 764968057) strcat(s, "p");
if (crc32("wELWvdcsoWlPTAH",15) == 3302634658) strcat(s, "z");
if (crc32("kHYnmfj",7) == 3353575166) strcat(s, "e");
if (crc32("bahnLcbfesu",11) == 3855951912) strcat(s, "r");
if (crc32("chsERu",6) == 1299287509) strcat(s, "G");
if (crc32("VcSGleILpI",10) == 4180428807) strcat(s, "r");
if (crc32("sBfOyLa",7) == 1820876163) strcat(s, "Y");
if (crc32("VzcRQzt",7) == 662734654) strcat(s, "e");
if (crc32("pFqJmjUl",8) == 1605036562) strcat(s, "Q");
if (crc32("mkfvJBFHqdmOR",13) == 2062846721) strcat(s, "s");
if (crc32("vSWvvsAqyEOYZP",14) == 851635530) strcat(s, "F");
if (crc32("QJhcli",6) == 762736091) strcat(s, "p");
if (crc32("JoSsdibheXEYMLZ",15) == 3661668603) strcat(s, "A");
if (crc32("JDDcPnA",7) == 4213637832) strcat(s, "e");
if (crc32("eoaQDkpjbja",11) == 3972628690) strcat(s, "G");
if (crc32("kPLCNjUzua",10) == 2560009306) strcat(s, "c");
if (crc32("osErpkPWFE",10) == 898703726) strcat(s, "Q");
if (crc32("yQCyIqqK",8) == 1251248338) strcat(s, "t");
if (crc32("LWGMzTjCcbWf",12) == 593431092) strcat(s, "a");
if (crc32("fibKYXH",7) == 2619214051) strcat(s, "b");
if (crc32("gDODqDcis",9) == 2989554234) strcat(s, "l");
if (crc32("IAFpkzovd",9) == 2835251553) strcat(s, "Q");
if (crc32("PlTvIS",6) == 642009869) strcat(s, "y");
    return s;
}

char *overcensoriously_adverbs() {
    char *s = calloc(17);
    if (crc32("GNTLyxfRkIbi",12) == 1178879620) strcat(s, "N");
if (crc32("YvwYRCfYJCaRJYF",15) == 1319443202) strcat(s, "o");
if (crc32("jNtUpHllfPGLAvL",15) == 1084708422) strcat(s, "v");
if (crc32("kgWBDLF",7) == 249739870) strcat(s, "e");
if (crc32("ihqwhTVDlgoYq",13) == 2494409531) strcat(s, "r");
if (crc32("hqOEW",5) == 3206855042) strcat(s, "c");
if (crc32("uhtwk",5) == 4197566096) strcat(s, "g");
if (crc32("WgUHvefCPV",10) == 854195108) strcat(s, "e");
if (crc32("FdgfgyWwnCOnkHN",15) == 1978854529) strcat(s, "X");
if (crc32("znxjpF",6) == 1714560510) strcat(s, "n");
if (crc32("dejFefEMZd",10) == 3687468704) strcat(s, "s");
if (crc32("iToymmKjgNm",11) == 1501059826) strcat(s, "J");
if (crc32("QfOpFyxiyWtrR",13) == 681142082) strcat(s, "o");
if (crc32("gBTqDmCoRXzjvE",14) == 1913578546) strcat(s, "r");
if (crc32("BoBZOn",6) == 1710083613) strcat(s, "i");
if (crc32("reJxhJfDQi",10) == 1760316580) strcat(s, "o");
if (crc32("ohyrb",5) == 3165483671) strcat(s, "j");
if (crc32("UhiwhxhVGSD",11) == 2079709951) strcat(s, "u");
if (crc32("OKVhmAAUXErx",12) == 966819135) strcat(s, "s");
if (crc32("MyqvudZXNvadAYY",15) == 3993208909) strcat(s, "l");
if (crc32("TIScYdFWYgaR",12) == 4202616417) strcat(s, "W");
if (crc32("abmSY",5) == 812722652) strcat(s, "y");
    return s;
}

char *lightmindedly_adverbs() {
    char *s = calloc(14);
    if (crc32("gGStEXE",7) == 2358774500) strcat(s, "M");
if (crc32("MbHoDVHPP",9) == 957394822) strcat(s, "l");
if (crc32("zmfRp",5) == 685693397) strcat(s, "i");
if (crc32("oXvyKceifQHMKMC",15) == 4118443471) strcat(s, "C");
if (crc32("PJEOtFf",7) == 303328499) strcat(s, "g");
if (crc32("xDJxGnYkanCy",12) == 4077776273) strcat(s, "h");
if (crc32("XqFkruXPeXyHcXE",15) == 587024089) strcat(s, "t");
if (crc32("oqWTLBVlr",9) == 2359231738) strcat(s, "l");
if (crc32("Dcgnc",5) == 547355159) strcat(s, "m");
if (crc32("DTfagIywCcVlUvc",15) == 2156391841) strcat(s, "G");
if (crc32("FvVXWTMmEtqF",12) == 3274178570) strcat(s, "i");
if (crc32("zYkFFfbYzc",10) == 1242600977) strcat(s, "n");
if (crc32("mOJev",5) == 2490060592) strcat(s, "x");
if (crc32("gtnCQpsCq",9) == 1626989905) strcat(s, "d");
if (crc32("uSVaCvtFlsKLNRz",15) == 681722578) strcat(s, "e");
if (crc32("ZwfGKQL",7) == 1298198841) strcat(s, "V");
if (crc32("VyPLdDMsFT",10) == 385326974) strcat(s, "d");
if (crc32("knBStHocgmNLeDD",15) == 3816910918) strcat(s, "l");
if (crc32("LFRRA",5) == 523316204) strcat(s, "Z");
if (crc32("bxtUfRbQFD",10) == 2477384293) strcat(s, "y");
    return s;
}

char *Calvinistically_adverbs() {
    char *s = calloc(16);
    if (crc32("srGtUtVOWFSTWai",15) == 1447787352) strcat(s, "m");
if (crc32("znyJiHP",7) == 4079771776) strcat(s, "C");
if (crc32("iTwLFTVmLkPyv",13) == 758329601) strcat(s, "F");
if (crc32("RmoPiQRVvr",10) == 1032511730) strcat(s, "a");
if (crc32("PmDBWvTbRTLk",12) == 2053829585) strcat(s, "W");
if (crc32("MzowOWuajSgLp",13) == 2219463831) strcat(s, "l");
if (crc32("wzQcORMKSwz",11) == 3349092850) strcat(s, "v");
if (crc32("QOTWC",5) == 1908147416) strcat(s, "i");
if (crc32("deqVeEvQJMCoI",13) == 554622338) strcat(s, "n");
if (crc32("etRFx",5) == 3832075192) strcat(s, "i");
if (crc32("DIrUvIvjPiiYTaD",15) == 4169857119) strcat(s, "s");
if (crc32("PEJDJhhGgJgr",12) == 423514511) strcat(s, "C");
if (crc32("CywNTSIinB",10) == 1388071297) strcat(s, "t");
if (crc32("WJeSNiaM",8) == 3044449305) strcat(s, "i");
if (crc32("JWXGAgvXBDv",11) == 3938808708) strcat(s, "y");
if (crc32("lohfEFsTmKKrzAH",15) == 484399143) strcat(s, "c");
if (crc32("ZHIntNJEGtkZ",12) == 1835941639) strcat(s, "a");
if (crc32("eaxOjcyZ",8) == 2255711896) strcat(s, "l");
if (crc32("DPCbXRmLHVSn",12) == 275765999) strcat(s, "f");
if (crc32("KRuhpprfrFN",11) == 2148710934) strcat(s, "l");
if (crc32("CHzjZjg",7) == 3247573794) strcat(s, "y");
    return s;
}

char *unreasonably_adverbs() {
    char *s = calloc(13);
    if (crc32("acDPCADQoG",10) == 1712007968) strcat(s, "r");
if (crc32("LeCWI",5) == 3758048346) strcat(s, "u");
if (crc32("dKaQfwlqiJsXapm",15) == 1191019405) strcat(s, "n");
if (crc32("bQhCLUnwRNz",11) == 3214353845) strcat(s, "f");
if (crc32("YLleptQkHoZw",12) == 3575863527) strcat(s, "r");
if (crc32("idsIUFdqXK",10) == 3227428944) strcat(s, "W");
if (crc32("bpROMX",6) == 931727975) strcat(s, "e");
if (crc32("YPXyh",5) == 3877044696) strcat(s, "a");
if (crc32("ynLfJxwkVDK",11) == 3358632945) strcat(s, "B");
if (crc32("YLpaNybqVW",10) == 64883182) strcat(s, "s");
if (crc32("ZVEQyQAGptsEcx",14) == 3803546776) strcat(s, "J");
if (crc32("YCzFDEj",7) == 4161462861) strcat(s, "o");
if (crc32("GSsxgYC",7) == 36753244) strcat(s, "R");
if (crc32("WFUZffOhF",9) == 2186476351) strcat(s, "n");
if (crc32("FOWNWZb",7) == 1062901454) strcat(s, "a");
if (crc32("maPYIXtJG",9) == 3049049269) strcat(s, "b");
if (crc32("EvZeCwaKMlOJSOL",15) == 2709287554) strcat(s, "G");
if (crc32("TDvRUpvyAzkJU",13) == 1565549226) strcat(s, "l");
if (crc32("ewYBLhoeIG",10) == 4286221561) strcat(s, "y");
if (crc32("JUICcdoaYLxI",12) == 1993796010) strcat(s, "y");
    return s;
}

char *photoelectrically_adverbs() {
    char *s = calloc(18);
    if (crc32("NygMO",5) == 1204070189) strcat(s, "P");
if (crc32("subFeKK",7) == 4195462507) strcat(s, "p");
if (crc32("FudTFFxWImpQN",13) == 974104900) strcat(s, "T");
if (crc32("gjuOFdaYO",9) == 2022102323) strcat(s, "h");
if (crc32("erTzfgYXKMYbN",13) == 368684735) strcat(s, "M");
if (crc32("qiYCIkffile",11) == 137594260) strcat(s, "o");
if (crc32("tKtQNhSZQS",10) == 2551619014) strcat(s, "t");
if (crc32("bcPzGR",6) == 2770564582) strcat(s, "P");
if (crc32("quGFBqQnxscj",12) == 1096642872) strcat(s, "o");
if (crc32("aidtWcFeCYOcgct",15) == 1077916938) strcat(s, "e");
if (crc32("DeqPhERxQLsUCzq",15) == 2377469929) strcat(s, "T");
if (crc32("bJupTURAGpdHN",13) == 3883085571) strcat(s, "l");
if (crc32("ryHtqGB",7) == 3877468451) strcat(s, "X");
if (crc32("WZTgJODeVEutOeU",15) == 1344221049) strcat(s, "e");
if (crc32("IZsLYVHyBfLVbyH",15) == 3825321273) strcat(s, "S");
if (crc32("RoUwuBwmwgHUgI",14) == 3442658808) strcat(s, "c");
if (crc32("EDPgXPAVFYSnM",13) == 2632625293) strcat(s, "S");
if (crc32("dsXpRMNaXYCTfd",14) == 1257836010) strcat(s, "t");
if (crc32("GcRCzza",7) == 2901206479) strcat(s, "A");
if (crc32("zFaLSlDahZ",10) == 2644668335) strcat(s, "r");
if (crc32("bLbfULRXIoSK",12) == 2775499284) strcat(s, "V");
if (crc32("yQqYafzgKtGOy",13) == 260101604) strcat(s, "i");
if (crc32("wBtyaVbfjLy",11) == 3496290161) strcat(s, "i");
if (crc32("sYuVjcFFeiihWe",14) == 2325308978) strcat(s, "c");
if (crc32("VWjKSDOIY",9) == 3522466329) strcat(s, "a");
if (crc32("IAZvijQUqwYCED",14) == 564178318) strcat(s, "l");
if (crc32("kOSna",5) == 1149664804) strcat(s, "l");
if (crc32("EIgbLtFxqYk",11) == 4224930044) strcat(s, "U");
if (crc32("uIwmk",5) == 1249991930) strcat(s, "y");
    return s;
}

char *pseudoassertively_adverbs() {
    char *s = calloc(18);
    if (crc32("EnzFzUmBAxMkFb",14) == 1948611279) strcat(s, "p");
if (crc32("DZylHpBHoCT",11) == 2364032360) strcat(s, "s");
if (crc32("YKNllZrohJ",10) == 1044912896) strcat(s, "e");
if (crc32("HoTKLe",6) == 270509620) strcat(s, "u");
if (crc32("YstGFNMCELxLwJJ",15) == 2017834884) strcat(s, "s");
if (crc32("lPyoacAQVcvO",12) == 4214011004) strcat(s, "d");
if (crc32("xeMssihkQEeJi",13) == 1517099095) strcat(s, "o");
if (crc32("BjfdRAZyor",10) == 1591637631) strcat(s, "a");
if (crc32("WUakVgUEOs",10) == 4159382906) strcat(s, "K");
if (crc32("qBUMFzgh",8) == 2762002918) strcat(s, "s");
if (crc32("rxROqdlPlRVMHUy",15) == 3224260170) strcat(s, "s");
if (crc32("XdnAfazMk",9) == 4227480023) strcat(s, "A");
if (crc32("SroXazOzcZZu",12) == 1320072515) strcat(s, "e");
if (crc32("dOavbesAIa",10) == 3870883351) strcat(s, "j");
if (crc32("BYONTaUDt",9) == 1008112476) strcat(s, "r");
if (crc32("YxCsjIZUPYnQ",12) == 2691271890) strcat(s, "t");
if (crc32("TxEgcNbeHRZSrR",14) == 1257910968) strcat(s, "i");
if (crc32("edoLEFP",7) == 3988716576) strcat(s, "I");
if (crc32("nUnXWHcIvitgBsK",15) == 107099004) strcat(s, "v");
if (crc32("YBCOXxRGK",9) == 2715667064) strcat(s, "l");
if (crc32("ljvfIvWUpLMKi",13) == 1186494484) strcat(s, "e");
if (crc32("cUeLtkIurpAhsSd",15) == 2424763403) strcat(s, "R");
if (crc32("pEzbROHL",8) == 3405962191) strcat(s, "l");
if (crc32("ZnrTRG",6) == 4033037952) strcat(s, "y");
    return s;
}

char *uncumbrously_adverbs() {
    char *s = calloc(13);
    if (crc32("qAsTJJcgaTxMB",13) == 617849689) strcat(s, "W");
if (crc32("HwcftSVvwTjwGx",14) == 344609362) strcat(s, "u");
if (crc32("nHAVgGWXWvJHhP",14) == 2105411243) strcat(s, "M");
if (crc32("inMjM",5) == 1724170882) strcat(s, "n");
if (crc32("UiuenfKpe",9) == 2707826065) strcat(s, "c");
if (crc32("PCaTChiJESjjbIN",15) == 1022984533) strcat(s, "g");
if (crc32("ZxudbgnTT",9) == 3866027939) strcat(s, "u");
if (crc32("TaobxVyp",8) == 885518304) strcat(s, "N");
if (crc32("aBSdrV",6) == 1497258608) strcat(s, "m");
if (crc32("lMwaQncgF",9) == 632916367) strcat(s, "b");
if (crc32("OFEdfR",6) == 396557790) strcat(s, "M");
if (crc32("PqsJrkoW",8) == 1999648606) strcat(s, "r");
if (crc32("srgZxud",7) == 834395961) strcat(s, "q");
if (crc32("cWrMCUSeuYibCy",14) == 1579205939) strcat(s, "o");
if (crc32("NzlTpXwkZynh",12) == 1497825869) strcat(s, "u");
if (crc32("yKOolv",6) == 1109303334) strcat(s, "s");
if (crc32("WektdycC",8) == 3798482224) strcat(s, "d");
if (crc32("fwEzVmFr",8) == 14617567) strcat(s, "l");
if (crc32("uCvIwBFGz",9) == 1573975412) strcat(s, "y");
    return s;
}

char *nonpermissibly_adverbs() {
    char *s = calloc(15);
    if (crc32("vUwoACEtRJLbk",13) == 3075354763) strcat(s, "K");
if (crc32("LRVtgJuzK",9) == 2688889735) strcat(s, "n");
if (crc32("PdZklzWQ",8) == 3439994456) strcat(s, "o");
if (crc32("vEDOiMFafEEIwB",14) == 2968416072) strcat(s, "n");
if (crc32("YGbajlg",7) == 2935587290) strcat(s, "e");
if (crc32("MaEVYVimGEWX",12) == 2574592357) strcat(s, "p");
if (crc32("ycFIJVkU",8) == 3775999407) strcat(s, "e");
if (crc32("iDTISVKOjHKIs",13) == 3506977457) strcat(s, "T");
if (crc32("aJKcdOgdoF",10) == 2240396093) strcat(s, "r");
if (crc32("MjaZJIJo",8) == 353289531) strcat(s, "m");
if (crc32("fyJmZQCG",8) == 3581334475) strcat(s, "C");
if (crc32("MxSMdJPsUuHpG",13) == 1596362389) strcat(s, "i");
if (crc32("BJiuTZLxoJ",10) == 3763668396) strcat(s, "Q");
if (crc32("nFULtAqPIn",10) == 3740249059) strcat(s, "s");
if (crc32("xGPwnILuf",9) == 4108290488) strcat(s, "s");
if (crc32("ciiYuvBxCP",10) == 2798557823) strcat(s, "i");
if (crc32("bAVxVWCBdABYXwY",15) == 4253629590) strcat(s, "V");
if (crc32("xMQXVMWn",8) == 959371148) strcat(s, "b");
if (crc32("xcpPBsFObrknF",13) == 900088471) strcat(s, "j");
if (crc32("HNTCUHJjQOhJG",13) == 1694887665) strcat(s, "l");
if (crc32("MzreAVrzTfuCZ",13) == 4039653159) strcat(s, "y");
    return s;
}

char *semijuridically_adverbs() {
    char *s = calloc(16);
    if (crc32("lijPr",5) == 2363247631) strcat(s, "A");
if (crc32("pOnxmincClAlS",13) == 66802890) strcat(s, "s");
if (crc32("ntcYQvJG",8) == 1787994840) strcat(s, "R");
if (crc32("QntdikzssbCcsoG",15) == 1093944370) strcat(s, "e");
if (crc32("uxIUcSca",8) == 899614111) strcat(s, "S");
if (crc32("GcsfVyVfEhsM",12) == 74616237) strcat(s, "m");
if (crc32("fjRXxsuBFXy",11) == 3002468657) strcat(s, "i");
if (crc32("iHwEVOIfpBj",11) == 4195999947) strcat(s, "c");
if (crc32("LMTTlNJ",7) == 2646855806) strcat(s, "j");
if (crc32("HmoxkcKFpTM",11) == 3418145961) strcat(s, "u");
if (crc32("aMnqm",5) == 3722993113) strcat(s, "D");
if (crc32("xsLVmkQ",7) == 1716670486) strcat(s, "r");
if (crc32("tozocKRRckVB",12) == 4292563184) strcat(s, "i");
if (crc32("mjBXeMpT",8) == 1895850786) strcat(s, "J");
if (crc32("LJOFtzARXhym",12) == 3677645879) strcat(s, "d");
if (crc32("lKGYiTIfEcE",11) == 520723934) strcat(s, "H");
if (crc32("zwjbmk",6) == 1165104840) strcat(s, "i");
if (crc32("sWkwetKj",8) == 1772389456) strcat(s, "c");
if (crc32("RWiVxdAH",8) == 3280912175) strcat(s, "d");
if (crc32("iZassqXRWzAB",12) == 402021040) strcat(s, "a");
if (crc32("rcImfJ",6) == 705112991) strcat(s, "l");
if (crc32("KExeShjMCvQEMrC",15) == 2244348463) strcat(s, "l");
if (crc32("BxWczvQTQvPNAn",14) == 1132962266) strcat(s, "h");
if (crc32("RMwFEPNRG",9) == 3117694466) strcat(s, "y");
    return s;
}

char *prespecifically_adverbs() {
    char *s = calloc(16);
    if (crc32("UimKq",5) == 2488456241) strcat(s, "U");
if (crc32("UDAhiKrZgNR",11) == 3318541084) strcat(s, "p");
if (crc32("zAxwNGuOrbJJn",13) == 3466047837) strcat(s, "r");
if (crc32("yfpYYVZPlFSRL",13) == 3355550431) strcat(s, "j");
if (crc32("QrEPpKirrBuQc",13) == 1185737023) strcat(s, "e");
if (crc32("zuSvo",5) == 3811798413) strcat(s, "s");
if (crc32("IqqHsdBiIy",10) == 4003383989) strcat(s, "p");
if (crc32("BcMjTXuQl",9) == 1980424988) strcat(s, "z");
if (crc32("bTFmSIGzEqr",11) == 534973539) strcat(s, "e");
if (crc32("AxwTgT",6) == 4166913139) strcat(s, "y");
if (crc32("bakyPoBvtQvX",12) == 3536712241) strcat(s, "c");
if (crc32("jqUzNB",6) == 227128859) strcat(s, "w");
if (crc32("dYpzgHkHoH",10) == 1954618238) strcat(s, "i");
if (crc32("aoAFxeM",7) == 3639003295) strcat(s, "f");
if (crc32("xurtTLlN",8) == 3175101856) strcat(s, "f");
if (crc32("egreNwNrobFWI",13) == 928608381) strcat(s, "i");
if (crc32("DcbhcD",6) == 320076985) strcat(s, "c");
if (crc32("BdhCWd",6) == 2894813678) strcat(s, "a");
if (crc32("icjeucaaKASVa",13) == 2552848258) strcat(s, "s");
if (crc32("rvhrSFLIIjh",11) == 742620924) strcat(s, "l");
if (crc32("ngrROKdmT",9) == 4144659611) strcat(s, "l");
if (crc32("jGyRtZBXFzdfI",13) == 3171268195) strcat(s, "y");
    return s;
}

char *unproscriptively_adverbs() {
    char *s = calloc(17);
    if (crc32("cfyCh",5) == 1667895026) strcat(s, "O");
if (crc32("whqqxYhVQ",9) == 843771465) strcat(s, "u");
if (crc32("jrRFnA",6) == 571956528) strcat(s, "J");
if (crc32("hhPcrqajqLZ",11) == 2794948675) strcat(s, "n");
if (crc32("ssCZpQo",7) == 243817599) strcat(s, "a");
if (crc32("UaaPmykuoHkKNfK",15) == 2872328872) strcat(s, "p");
if (crc32("ddSPtVwPPhgjZ",13) == 919659743) strcat(s, "r");
if (crc32("oBuytYfB",8) == 499322850) strcat(s, "l");
if (crc32("aSWHgQSV",8) == 3393705674) strcat(s, "o");
if (crc32("XNpHcrWOFTX",11) == 1506980341) strcat(s, "s");
if (crc32("mdLQxxaTGmjIrrc",15) == 3656363144) strcat(s, "c");
if (crc32("zgqIXsFIOUBrI",13) == 766025186) strcat(s, "r");
if (crc32("DTiKkAOYKcjixr",14) == 1932562775) strcat(s, "X");
if (crc32("QYCauskcrgfi",12) == 4019920320) strcat(s, "i");
if (crc32("IeKwxdRYp",9) == 1975170418) strcat(s, "p");
if (crc32("dJbKKilKn",9) == 3765213897) strcat(s, "p");
if (crc32("IdxJzMfQleSF",12) == 1785191134) strcat(s, "t");
if (crc32("EHGjWrO",7) == 2451551335) strcat(s, "V");
if (crc32("kpttolEuGjUh",12) == 1653007694) strcat(s, "i");
if (crc32("kIpSrHZBu",9) == 908507212) strcat(s, "v");
if (crc32("eqUWX",5) == 3192796887) strcat(s, "e");
if (crc32("ycnssZY",7) == 824212395) strcat(s, "l");
if (crc32("cIOgxengYwPkubO",15) == 949580184) strcat(s, "P");
if (crc32("GcshWA",6) == 3059923349) strcat(s, "y");
    return s;
}

char *nonabusively_adverbs() {
    char *s = calloc(13);
    if (crc32("qZpHLKempQJy",12) == 3917741035) strcat(s, "n");
if (crc32("fGOMSFl",7) == 1482130964) strcat(s, "o");
if (crc32("mkoQWRcA",8) == 759541071) strcat(s, "n");
if (crc32("ZGUhjuChbHO",11) == 680471338) strcat(s, "Q");
if (crc32("zKWXnfMNyPZ",11) == 889806184) strcat(s, "a");
if (crc32("DjsunR",6) == 366002103) strcat(s, "t");
if (crc32("TUlhAsYBzSivj",13) == 475270797) strcat(s, "b");
if (crc32("tYJEVwnRgs",10) == 2867023487) strcat(s, "u");
if (crc32("RtPtzdga",8) == 427531242) strcat(s, "P");
if (crc32("ycCQghVJst",10) == 3526006878) strcat(s, "s");
if (crc32("LLCoexit",8) == 2175402459) strcat(s, "o");
if (crc32("lMrqLKrxhjWCHWg",15) == 318067633) strcat(s, "i");
if (crc32("ShDudWdYQUq",11) == 374402706) strcat(s, "v");
if (crc32("DIIriSyPtyVAr",13) == 47245621) strcat(s, "w");
if (crc32("OGELI",5) == 1071640087) strcat(s, "e");
if (crc32("HBMCDxhMDrRdOY",14) == 3392171223) strcat(s, "N");
if (crc32("VWFbps",6) == 4063828045) strcat(s, "l");
if (crc32("HPGFBYaQt",9) == 3312842920) strcat(s, "v");
if (crc32("BDYxYDvDcMr",11) == 580624682) strcat(s, "y");
    return s;
}

char *rushingly_adverbs() {
    char *s = calloc(10);
    if (crc32("UfNww",5) == 4236751901) strcat(s, "r");
if (crc32("EEXLZPgBtds",11) == 731766823) strcat(s, "b");
if (crc32("XLzhRNyBhPPkIPy",15) == 1219049741) strcat(s, "u");
if (crc32("IKPDVqtYHiBMhqd",15) == 419365577) strcat(s, "s");
if (crc32("UAGhAcKTvek",11) == 1660559475) strcat(s, "J");
if (crc32("nPZnaEMoIXKJb",13) == 3934344180) strcat(s, "h");
if (crc32("WfBLaNeYMvm",11) == 1677117392) strcat(s, "a");
if (crc32("zEDayslyGGVaWv",14) == 3319387878) strcat(s, "i");
if (crc32("AvVKCNDKtokXVHS",15) == 3315456889) strcat(s, "n");
if (crc32("YMsmKjLEuB",10) == 1976369819) strcat(s, "M");
if (crc32("pGuFJXNVmGGdXmH",15) == 4195593282) strcat(s, "g");
if (crc32("FPjfQTsguRlwHK",14) == 3996407893) strcat(s, "l");
if (crc32("JRwwQWSxYyhhW",13) == 1765245613) strcat(s, "y");
    return s;
}

char *uncreditably_adverbs() {
    char *s = calloc(13);
    if (crc32("DhCKNRNAa",9) == 1494337185) strcat(s, "u");
if (crc32("nNmBurOsi",9) == 620170640) strcat(s, "n");
if (crc32("rmQrvUESSHO",11) == 1222972419) strcat(s, "n");
if (crc32("rBBKVUJotNk",11) == 1496809690) strcat(s, "c");
if (crc32("aXVJOcTtKp",10) == 1380572278) strcat(s, "o");
if (crc32("ZCPsEwqsCQP",11) == 3551391800) strcat(s, "r");
if (crc32("pntALtzLiN",10) == 3122494570) strcat(s, "N");
if (crc32("VnyiXqDAuQTtd",13) == 980365456) strcat(s, "e");
if (crc32("CdfMhCjdmtp",11) == 3581720329) strcat(s, "J");
if (crc32("cHJRsaVT",8) == 281688020) strcat(s, "d");
if (crc32("CngFsWYH",8) == 3640436524) strcat(s, "i");
if (crc32("xkGequJMLtG",11) == 2055139542) strcat(s, "Y");
if (crc32("ybeuAFQvyku",11) == 1151514703) strcat(s, "t");
if (crc32("eVJfKRHi",8) == 1525039094) strcat(s, "Y");
if (crc32("XHTCY",5) == 850882623) strcat(s, "a");
if (crc32("ltxRCjY",7) == 3369200531) strcat(s, "m");
if (crc32("OuRjwkHenrODaN",14) == 44647033) strcat(s, "b");
if (crc32("GTPHBVVWpTr",11) == 1892049222) strcat(s, "l");
if (crc32("DlxTBkBysv",10) == 496511731) strcat(s, "y");
    return s;
}

char *superinquisitively_adverbs() {
    char *s = calloc(19);
    if (crc32("PRAtWsaTFpjUAF",14) == 1266978125) strcat(s, "s");
if (crc32("jBaWDmDT",8) == 2259308289) strcat(s, "u");
if (crc32("spVFdCU",7) == 3446276034) strcat(s, "u");
if (crc32("ToxUDT",6) == 22048794) strcat(s, "p");
if (crc32("IxYGaWjMZJuRJvt",15) == 2448538806) strcat(s, "K");
if (crc32("lsrWqOwmgq",10) == 1224498988) strcat(s, "e");
if (crc32("nrVzFEmt",8) == 2192997595) strcat(s, "v");
if (crc32("oNaGJvfLH",9) == 1390294544) strcat(s, "r");
if (crc32("tApfaNlO",8) == 1688336868) strcat(s, "i");
if (crc32("RobTsEo",7) == 1907177271) strcat(s, "n");
if (crc32("AfLZqPkS",8) == 1743875984) strcat(s, "I");
if (crc32("XhHEfBaZpVp",11) == 771499170) strcat(s, "q");
if (crc32("KggIfmR",7) == 2757025375) strcat(s, "o");
if (crc32("cmgBtvdE",8) == 1440962890) strcat(s, "u");
if (crc32("QfyxIgRiTOo",11) == 4169520180) strcat(s, "Z");
if (crc32("fJyGNoKNtnSQXS",14) == 2247876871) strcat(s, "i");
if (crc32("wXOIKdnJr",9) == 1135519861) strcat(s, "A");
if (crc32("WiGSmrCzshSMZVF",15) == 3845618882) strcat(s, "s");
if (crc32("hRGBxrNHFpUuEd",14) == 4108653529) strcat(s, "i");
if (crc32("GWWauJOHZwCAQI",14) == 917787125) strcat(s, "t");
if (crc32("EMPDmfDMLBtgjaY",15) == 3570733285) strcat(s, "i");
if (crc32("GBDJKB",6) == 3780918101) strcat(s, "d");
if (crc32("NSwXwnknjocYvzY",15) == 2085194139) strcat(s, "v");
if (crc32("zbTVYbCOLyMeMZ",14) == 2174514933) strcat(s, "n");
if (crc32("tXxuAoY",7) == 1902060467) strcat(s, "e");
if (crc32("zHmKJmDqaC",10) == 2002671078) strcat(s, "l");
if (crc32("yxZRtEYD",8) == 3398890895) strcat(s, "f");
if (crc32("nVdPDdNrLEtyD",13) == 423807019) strcat(s, "y");
    return s;
}

char *then_adverbs() {
    char *s = calloc(5);
    if (crc32("iMwzB",5) == 2280988014) strcat(s, "x");
if (crc32("zjlGnGfSZRN",11) == 1444692364) strcat(s, "t");
if (crc32("ewtbHB",6) == 1601949813) strcat(s, "q");
if (crc32("NZNlHvlFlqjYDOu",15) == 1692360064) strcat(s, "h");
if (crc32("XVRDk",5) == 23784294) strcat(s, "e");
if (crc32("YnqXSnMwBN",10) == 2233050444) strcat(s, "n");
    return s;
}

char *circuitously_adverbs() {
    char *s = calloc(13);
    if (crc32("aEbGTdEnO",9) == 3498276484) strcat(s, "c");
if (crc32("nczWZF",6) == 4013222818) strcat(s, "i");
if (crc32("mEeZZPwssSzhLjN",15) == 1292437275) strcat(s, "A");
if (crc32("LvmShUDOHoDkCY",14) == 1935185179) strcat(s, "r");
if (crc32("gyMoMD",6) == 1315087555) strcat(s, "c");
if (crc32("nNsZm",5) == 3352336590) strcat(s, "r");
if (crc32("XzqcctQDapf",11) == 138331168) strcat(s, "u");
if (crc32("brsPCwNCHVb",11) == 838443742) strcat(s, "i");
if (crc32("coWNSl",6) == 3716974846) strcat(s, "t");
if (crc32("rOFpzkLm",8) == 906509439) strcat(s, "o");
if (crc32("caTsKV",6) == 414035545) strcat(s, "u");
if (crc32("AtNGnSLEpzNah",13) == 2610299815) strcat(s, "s");
if (crc32("PeOUnFXErVKz",12) == 801645416) strcat(s, "f");
if (crc32("TAsxKXkqBlA",11) == 1144922206) strcat(s, "l");
if (crc32("IaDnU",5) == 3316567995) strcat(s, "n");
if (crc32("MUeYypAYOqtfw",13) == 2872847884) strcat(s, "y");
    return s;
}

char *draughtily_adverbs() {
    char *s = calloc(11);
    if (crc32("NeMGwkDfgYf",11) == 3640589495) strcat(s, "y");
if (crc32("zhPZoYhMTPp",11) == 348529212) strcat(s, "d");
if (crc32("XFCRpIC",7) == 486625361) strcat(s, "X");
if (crc32("ejImmRXqO",9) == 1717657459) strcat(s, "r");
if (crc32("InFnUw",6) == 3217172455) strcat(s, "J");
if (crc32("ZjfBSWIae",9) == 4256451315) strcat(s, "a");
if (crc32("hrLBWXmW",8) == 4107367890) strcat(s, "C");
if (crc32("HNQbQovaCvJrcOo",15) == 3577921233) strcat(s, "u");
if (crc32("FtngIabM",8) == 2075437028) strcat(s, "g");
if (crc32("LjOinKr",7) == 3303734186) strcat(s, "h");
if (crc32("lNgTGiV",7) == 153652302) strcat(s, "n");
if (crc32("EdpIvkZeCQth",12) == 1154246297) strcat(s, "t");
if (crc32("tMwqDYJEfJTu",12) == 2942518621) strcat(s, "L");
if (crc32("hxOTCTy",7) == 3646580588) strcat(s, "i");
if (crc32("chtuBmj",7) == 2634864274) strcat(s, "l");
if (crc32("xknhY",5) == 511558340) strcat(s, "y");
    return s;
}

char *humanly_adverbs() {
    char *s = calloc(8);
    if (crc32("govhYIKXoA",10) == 817529098) strcat(s, "F");
if (crc32("KuXPqQPKWrck",12) == 1042986457) strcat(s, "h");
if (crc32("NqhKXHsqOE",10) == 345202860) strcat(s, "u");
if (crc32("CSAKADCxJ",9) == 352691949) strcat(s, "c");
if (crc32("hubBilLw",8) == 708661448) strcat(s, "m");
if (crc32("mvzYFujib",9) == 2601672507) strcat(s, "a");
if (crc32("xkAHUk",6) == 4175207090) strcat(s, "n");
if (crc32("ggIAQNk",7) == 3459113420) strcat(s, "n");
if (crc32("hprFpNiF",8) == 564560242) strcat(s, "l");
if (crc32("sPSrVRIcqiOGTxS",15) == 1573007520) strcat(s, "y");
    return s;
}

char *projectingly_adverbs() {
    char *s = calloc(13);
    if (crc32("sdkFuDib",8) == 2480321262) strcat(s, "f");
if (crc32("sckFahNngh",10) == 201140863) strcat(s, "p");
if (crc32("EoFAByy",7) == 584906775) strcat(s, "r");
if (crc32("hFkAHRFeRcGlK",13) == 3253591567) strcat(s, "J");
if (crc32("UtKEQCkdAuozsKT",15) == 2733577062) strcat(s, "o");
if (crc32("ahCByNw",7) == 2922543597) strcat(s, "S");
if (crc32("NrpPRCSXo",9) == 4096643598) strcat(s, "j");
if (crc32("YtCkZhToykk",11) == 1675049232) strcat(s, "f");
if (crc32("Sjote",5) == 3624595545) strcat(s, "e");
if (crc32("hglxl",5) == 733931746) strcat(s, "c");
if (crc32("kOcLhHjvGU",10) == 982713073) strcat(s, "t");
if (crc32("dueDwZuKqH",10) == 1579959003) strcat(s, "a");
if (crc32("gdLEYmHlHTeteg",14) == 2148588076) strcat(s, "i");
if (crc32("SDqyLn",6) == 3905879299) strcat(s, "n");
if (crc32("QkIkNjQqxXqq",12) == 3738492252) strcat(s, "g");
if (crc32("toUqxSVAQaughd",14) == 1017184592) strcat(s, "I");
if (crc32("fVzLHjb",7) == 2405043585) strcat(s, "l");
if (crc32("qQheAl",6) == 321778260) strcat(s, "B");
if (crc32("KEMisxgAKxbUdyy",15) == 810623613) strcat(s, "y");
    return s;
}

char *nonreciprocally_adverbs() {
    char *s = calloc(16);
    if (crc32("CcdmtUkYbfliHh",14) == 227809448) strcat(s, "n");
if (crc32("xnvFtACYJfxr",12) == 2589580275) strcat(s, "o");
if (crc32("XDHwRwWTJXQBM",13) == 662443891) strcat(s, "n");
if (crc32("TABPDSgoVXHZ",12) == 903693578) strcat(s, "r");
if (crc32("oEGtsXqmF",9) == 3215318024) strcat(s, "e");
if (crc32("ZuViQvGkVrY",11) == 1652724230) strcat(s, "u");
if (crc32("cCYWYVIWZqjoAV",14) == 1344532218) strcat(s, "c");
if (crc32("OMRSDmHNWogWIms",15) == 3677500483) strcat(s, "y");
if (crc32("scCkKOdoyL",10) == 2094866663) strcat(s, "i");
if (crc32("FYkzfdVIv",9) == 1882857608) strcat(s, "p");
if (crc32("qvoTHewDCYK",11) == 2322356513) strcat(s, "J");
if (crc32("TdZjgMHMwOnFPda",15) == 1789552446) strcat(s, "r");
if (crc32("XAtrmJdiGXC",11) == 501535807) strcat(s, "o");
if (crc32("pprlpZUiOnIz",12) == 1013568403) strcat(s, "h");
if (crc32("XtIQqDyxoum",11) == 465201928) strcat(s, "c");
if (crc32("WkcayLuA",8) == 1026862853) strcat(s, "s");
if (crc32("tNgtRRC",7) == 2000030190) strcat(s, "a");
if (crc32("ZACYcQVJSArPeDa",15) == 453619392) strcat(s, "l");
if (crc32("rLDrs",5) == 929349081) strcat(s, "l");
if (crc32("vBGqHxFRO",9) == 2022327844) strcat(s, "q");
if (crc32("XUPpTwMpI",9) == 2041872747) strcat(s, "y");
    return s;
}

char *endermically_adverbs() {
    char *s = calloc(13);
    if (crc32("LSFBtq",6) == 3880685666) strcat(s, "R");
if (crc32("JZNnmxsb",8) == 2106206706) strcat(s, "e");
if (crc32("zuxHPWvuYjWBYL",14) == 2353448511) strcat(s, "E");
if (crc32("okdrXW",6) == 3269367057) strcat(s, "n");
if (crc32("wGyPcN",6) == 3892940246) strcat(s, "d");
if (crc32("pLwrcDTHZzvrgv",14) == 2287345325) strcat(s, "Z");
if (crc32("TEGhd",5) == 894822834) strcat(s, "e");
if (crc32("ZlcgQCLgbXYI",12) == 3429448752) strcat(s, "l");
if (crc32("wZGyiNwzowD",11) == 755825856) strcat(s, "r");
if (crc32("cLRsCMEpg",9) == 1317782142) strcat(s, "F");
if (crc32("OvDKUhsJg",9) == 3645960576) strcat(s, "m");
if (crc32("VgwGpRqjLzgUEP",14) == 3600405532) strcat(s, "i");
if (crc32("fccWVjwSGmgqWrE",15) == 449792377) strcat(s, "c");
if (crc32("wsQejCIUtOZHseJ",15) == 41059742) strcat(s, "a");
if (crc32("FTZOziJNmFhZITm",15) == 2593048919) strcat(s, "l");
if (crc32("HxTxY",5) == 1354493146) strcat(s, "J");
if (crc32("oaLNiOikUsOQP",13) == 2402647153) strcat(s, "l");
if (crc32("QGQIPQIfJcHF",12) == 1216098428) strcat(s, "w");
if (crc32("upPoznlV",8) == 2006781541) strcat(s, "y");
    return s;
}

char *trinomially_adverbs() {
    char *s = calloc(12);
    if (crc32("mzFFOwhbRJUz",12) == 1522255206) strcat(s, "t");
if (crc32("fbSVzB",6) == 3737485647) strcat(s, "n");
if (crc32("icNILIRI",8) == 1500378253) strcat(s, "r");
if (crc32("CPxgfcPQTuCxx",13) == 1723091942) strcat(s, "N");
if (crc32("PNuiPGBLpho",11) == 8105000) strcat(s, "i");
if (crc32("ncAolheiCEDAPV",14) == 1592856208) strcat(s, "o");
if (crc32("SGQNHQjECVZYw",13) == 2132768645) strcat(s, "n");
if (crc32("ArpTNZzDHqtANb",14) == 3260038838) strcat(s, "U");
if (crc32("nLHkACpI",8) == 1598697651) strcat(s, "o");
if (crc32("heaHCodGftwG",12) == 1229868020) strcat(s, "m");
if (crc32("BdGgnil",7) == 1298550019) strcat(s, "X");
if (crc32("WRHZfyipGm",10) == 766544145) strcat(s, "i");
if (crc32("aSbJMfHlJltKt",13) == 1700893351) strcat(s, "t");
if (crc32("PVjrqGwXw",9) == 1106441237) strcat(s, "a");
if (crc32("haESiRuvX",9) == 974375080) strcat(s, "l");
if (crc32("DilAY",5) == 3837938403) strcat(s, "v");
if (crc32("XQwndjk",7) == 3491972882) strcat(s, "l");
if (crc32("rOEnhNLF",8) == 124159341) strcat(s, "y");
    return s;
}

char *hitchily_adverbs() {
    char *s = calloc(9);
    if (crc32("zksplCGHbodp",12) == 4267453526) strcat(s, "E");
if (crc32("fPTIcfrL",8) == 2502235787) strcat(s, "h");
if (crc32("SPJvWTQO",8) == 1034125309) strcat(s, "i");
if (crc32("cfMKdTT",7) == 3907406020) strcat(s, "t");
if (crc32("MXDGXgCNcSs",11) == 266761354) strcat(s, "c");
if (crc32("IYIHr",5) == 1476828628) strcat(s, "g");
if (crc32("mrlSsxdKk",9) == 4120307702) strcat(s, "h");
if (crc32("mseTkoN",7) == 258372503) strcat(s, "S");
if (crc32("SJJNLf",6) == 1596671973) strcat(s, "i");
if (crc32("hKRSZRsNSQYE",12) == 2500612330) strcat(s, "l");
if (crc32("dWTEsSj",7) == 4160822811) strcat(s, "y");
    return s;
}

char *nonexactingly_adverbs() {
    char *s = calloc(14);
    if (crc32("kboEJiy",7) == 111292611) strcat(s, "n");
if (crc32("oltAAhOJil",10) == 2421226553) strcat(s, "o");
if (crc32("spxsaoUPlTzamf",14) == 2963010377) strcat(s, "n");
if (crc32("hyxJO",5) == 3477137121) strcat(s, "e");
if (crc32("BchvsYlDiRRI",12) == 3346951912) strcat(s, "x");
if (crc32("tehaG",5) == 1667294124) strcat(s, "B");
if (crc32("wyaVPFpyDIYLA",13) == 2091955196) strcat(s, "a");
if (crc32("liREKFibbwwUyd",14) == 1463726317) strcat(s, "z");
if (crc32("JbQpbS",6) == 2115675512) strcat(s, "c");
if (crc32("HrYtdu",6) == 366490041) strcat(s, "t");
if (crc32("uJGJoEjJUY",10) == 3995695990) strcat(s, "i");
if (crc32("RswBWJTX",8) == 184920495) strcat(s, "n");
if (crc32("ZGtigWhqJ",9) == 3989736309) strcat(s, "t");
if (crc32("VImrDwXqwQetLH",14) == 2198408005) strcat(s, "g");
if (crc32("jXziKAM",7) == 989538272) strcat(s, "l");
if (crc32("tsSGlZthHKcO",12) == 2956908689) strcat(s, "i");
if (crc32("BmwOY",5) == 431298469) strcat(s, "y");
    return s;
}

char *contrariwise_adverbs() {
    char *s = calloc(13);
    if (crc32("WQeSBmMSsSmRx",13) == 3031491185) strcat(s, "p");
if (crc32("dsfEkDdfP",9) == 2670511978) strcat(s, "c");
if (crc32("cnXsS",5) == 1501931510) strcat(s, "k");
if (crc32("wWUOyQdoCzzoit",14) == 324194806) strcat(s, "o");
if (crc32("EiCDbmSuIQGRt",13) == 1042143950) strcat(s, "n");
if (crc32("yFBFCUrlEHOdnx",14) == 2608567670) strcat(s, "t");
if (crc32("ifBZNHfxOkXUE",13) == 385991249) strcat(s, "r");
if (crc32("BQkMHohMylcUc",13) == 762595116) strcat(s, "Q");
if (crc32("rytQasWWdttk",12) == 2159419480) strcat(s, "a");
if (crc32("HjuwkykcKFiFfG",14) == 3856006111) strcat(s, "r");
if (crc32("mjKJhDkt",8) == 783695446) strcat(s, "i");
if (crc32("KPxmHUCBnwnJP",13) == 3760082088) strcat(s, "Q");
if (crc32("KsjfraH",7) == 3364710875) strcat(s, "w");
if (crc32("eDmKVMZLaHBAsv",14) == 1843737765) strcat(s, "i");
if (crc32("TkdGB",5) == 1208120547) strcat(s, "B");
if (crc32("ZXPKaYLu",8) == 235403003) strcat(s, "s");
if (crc32("DqoNyoxb",8) == 2958051669) strcat(s, "p");
if (crc32("jOtNnMkryT",10) == 2742995179) strcat(s, "e");
    return s;
}

char *overserenely_adverbs() {
    char *s = calloc(13);
    if (crc32("vtZWXmPZntGBc",13) == 1579854628) strcat(s, "o");
if (crc32("UGdjTYPdtGmsw",13) == 825806930) strcat(s, "d");
if (crc32("neWBbRbNgu",10) == 1345377210) strcat(s, "v");
if (crc32("svVrKGXxivJVDR",14) == 4043005304) strcat(s, "W");
if (crc32("vWXKaDgFTvLC",12) == 3731787466) strcat(s, "e");
if (crc32("MpVFS",5) == 1534218781) strcat(s, "u");
if (crc32("xUUwoXk",7) == 4080722809) strcat(s, "r");
if (crc32("UhcAqIjzQDtX",12) == 1199991072) strcat(s, "s");
if (crc32("JERucetoCx",10) == 2863294903) strcat(s, "e");
if (crc32("OuQnGovIYr",10) == 2572686187) strcat(s, "r");
if (crc32("RcboUplbwhi",11) == 1963809244) strcat(s, "e");
if (crc32("JNYKGactHLhSv",13) == 1870113112) strcat(s, "n");
if (crc32("MOBmGsvwaRaLJhX",15) == 3025884276) strcat(s, "i");
if (crc32("QyoFAhfY",8) == 4013107486) strcat(s, "e");
if (crc32("Qfyymcib",8) == 1484325220) strcat(s, "l");
if (crc32("RqgXWRbuomwe",12) == 2411951559) strcat(s, "y");
    return s;
}

char *cursorily_adverbs() {
    char *s = calloc(10);
    if (crc32("kBdJVfnnC",9) == 2101456166) strcat(s, "c");
if (crc32("koAOgUqdsQBcri",14) == 496795786) strcat(s, "z");
if (crc32("uttJGvFMgNHcCoq",15) == 655233366) strcat(s, "u");
if (crc32("LWSpGeISUjvY",12) == 3268069992) strcat(s, "r");
if (crc32("GcgaDYZFO",9) == 3040531177) strcat(s, "s");
if (crc32("bhCxwgniq",9) == 964125377) strcat(s, "o");
if (crc32("cMNlsPfFXeRPHq",14) == 1988952647) strcat(s, "O");
if (crc32("KOczJzwh",8) == 273470044) strcat(s, "r");
if (crc32("gNRYX",5) == 4144674379) strcat(s, "i");
if (crc32("BXqiLsxaqHRrE",13) == 1453716894) strcat(s, "v");
if (crc32("DstcoZhlCZ",10) == 1258674895) strcat(s, "l");
if (crc32("ImLqxcbrtao",11) == 2413532255) strcat(s, "J");
if (crc32("CXVuiCbz",8) == 3926270965) strcat(s, "y");
    return s;
}

char *biblically_adverbs() {
    char *s = calloc(11);
    if (crc32("cdqZfgwftro",11) == 2357464050) strcat(s, "p");
if (crc32("yVqUODLurKH",11) == 2070629119) strcat(s, "b");
if (crc32("UgxeHa",6) == 2838812317) strcat(s, "o");
if (crc32("YBCyFk",6) == 380766186) strcat(s, "i");
if (crc32("oVfXsA",6) == 2249763491) strcat(s, "b");
if (crc32("NtvPED",6) == 1223328696) strcat(s, "x");
if (crc32("SaMznvPsXCkE",12) == 2874938599) strcat(s, "l");
if (crc32("yJfwlEgB",8) == 383153457) strcat(s, "i");
if (crc32("JInxkk",6) == 924155754) strcat(s, "g");
if (crc32("PgLPGbxHwex",11) == 167401047) strcat(s, "c");
if (crc32("IuDAX",5) == 2375069629) strcat(s, "P");
if (crc32("soESltAdxjI",11) == 2760201108) strcat(s, "a");
if (crc32("sTWHGcLs",8) == 1124686267) strcat(s, "j");
if (crc32("GqRwdOCCox",10) == 1224241631) strcat(s, "l");
if (crc32("QPzgMzDxfcZUGem",15) == 2911749249) strcat(s, "l");
if (crc32("XCrRTcEGD",9) == 4009261238) strcat(s, "y");
    return s;
}

char *syndetically_adverbs() {
    char *s = calloc(13);
    if (crc32("lUhOTxUASbdGgpn",15) == 1493669657) strcat(s, "E");
if (crc32("RgEIndCYkJrxl",13) == 2405861090) strcat(s, "s");
if (crc32("OdBZCrcC",8) == 2776922224) strcat(s, "y");
if (crc32("QsjdYPTbMlTSa",13) == 2000941372) strcat(s, "z");
if (crc32("NsoRzlHXIkBvjN",14) == 1047474975) strcat(s, "n");
if (crc32("BOtdHxiDCa",10) == 3589830451) strcat(s, "d");
if (crc32("nHcQG",5) == 3205071804) strcat(s, "e");
if (crc32("EhiEpL",6) == 658474271) strcat(s, "t");
if (crc32("WGRYZqGFJCe",11) == 222028375) strcat(s, "h");
if (crc32("BnzYkG",6) == 3691966576) strcat(s, "i");
if (crc32("txoCfEiFQ",9) == 295392385) strcat(s, "Y");
if (crc32("KcbfbgRRK",9) == 1704339744) strcat(s, "c");
if (crc32("HmNyzOBolDvBpDi",15) == 2722708362) strcat(s, "i");
if (crc32("eWCdbaHKEB",10) == 3426836390) strcat(s, "a");
if (crc32("jsrDwAg",7) == 1859191238) strcat(s, "o");
if (crc32("lkkxBZaVLdZYF",13) == 732442055) strcat(s, "l");
if (crc32("yNpWDXLVBfQ",11) == 3095470821) strcat(s, "X");
if (crc32("MNrzrSOnAj",10) == 3297862889) strcat(s, "l");
if (crc32("ZhUTIDmGJTzB",12) == 1027391885) strcat(s, "y");
    return s;
}

char *heliacally_adverbs() {
    char *s = calloc(11);
    if (crc32("elpZO",5) == 348571156) strcat(s, "h");
if (crc32("NdLJkJFtxm",10) == 3039683679) strcat(s, "e");
if (crc32("aJtldzXAC",9) == 2240606585) strcat(s, "N");
if (crc32("xtqZvUkxrDwco",13) == 4243414689) strcat(s, "l");
if (crc32("aPqGJrCgcvjfQDT",15) == 3966307165) strcat(s, "i");
if (crc32("OyvtdVN",7) == 3066645951) strcat(s, "h");
if (crc32("KeDqJfMUgmiJfFf",15) == 119832030) strcat(s, "a");
if (crc32("dvQZBHkHrRdl",12) == 3707982306) strcat(s, "I");
if (crc32("xfSeeU",6) == 3572383740) strcat(s, "c");
if (crc32("xMjcDcTJbvPzz",13) == 3384656836) strcat(s, "a");
if (crc32("pODGtrlnYHtv",12) == 4269557001) strcat(s, "Z");
if (crc32("DKqAYOmXnM",10) == 55050432) strcat(s, "l");
if (crc32("ozbvVe",6) == 2697277100) strcat(s, "M");
if (crc32("ElHCvHvzl",9) == 3808061854) strcat(s, "l");
if (crc32("QbzSPebJYkBccVu",15) == 2587200209) strcat(s, "y");
    return s;
}

char *unludicrously_adverbs() {
    char *s = calloc(14);
    if (crc32("XBDmzKKetEOmer",14) == 1031213332) strcat(s, "b");
if (crc32("NqjmgMHG",8) == 3578563582) strcat(s, "u");
if (crc32("smqqlEklrgAMx",13) == 2293995377) strcat(s, "t");
if (crc32("GRYSVSQCRInb",12) == 240839519) strcat(s, "n");
if (crc32("hXMwJms",7) == 1030241472) strcat(s, "d");
if (crc32("GCcNsSjRaTam",12) == 546309343) strcat(s, "l");
if (crc32("BBaOtRDOCfLOVS",14) == 4279170474) strcat(s, "M");
if (crc32("CehabgUL",8) == 1062923368) strcat(s, "u");
if (crc32("nXmwmAYkq",9) == 2875590988) strcat(s, "X");
if (crc32("nlcDOUgjL",9) == 1357612629) strcat(s, "d");
if (crc32("EMnonrlFgo",10) == 1340156834) strcat(s, "i");
if (crc32("iNKkedOau",9) == 3426263125) strcat(s, "c");
if (crc32("JrkOvTQqzraKmK",14) == 1681168274) strcat(s, "r");
if (crc32("ULavioOvN",9) == 887416011) strcat(s, "o");
if (crc32("mrmoWbHFth",10) == 2063255004) strcat(s, "l");
if (crc32("OowoJQUkREWthm",14) == 1316842967) strcat(s, "u");
if (crc32("pRBNVcuVjRQCDh",14) == 3889273047) strcat(s, "w");
if (crc32("VrRKIxlVvds",11) == 1036299158) strcat(s, "s");
if (crc32("qTVWVTslhpiK",12) == 3861305412) strcat(s, "O");
if (crc32("GxbVoAeKPwse",12) == 2420191977) strcat(s, "l");
if (crc32("VoXTpIEmI",9) == 3747817465) strcat(s, "y");
    return s;
}

char *anxiously_adverbs() {
    char *s = calloc(10);
    if (crc32("KoErceRikK",10) == 1199014101) strcat(s, "c");
if (crc32("OcTiUGTgrYYKsXV",15) == 3396784579) strcat(s, "a");
if (crc32("KrxKqVYCrwXky",13) == 3857420095) strcat(s, "G");
if (crc32("RWqzK",5) == 3016120238) strcat(s, "n");
if (crc32("rLqGCIWXFw",10) == 1222513100) strcat(s, "x");
if (crc32("VkLtjhAC",8) == 2300829995) strcat(s, "I");
if (crc32("BbYkmqfDwCW",11) == 876582605) strcat(s, "i");
if (crc32("EOEOvU",6) == 2174544925) strcat(s, "o");
if (crc32("fxKafWcaayET",12) == 453283193) strcat(s, "Y");
if (crc32("LLluJTAEixLx",12) == 3322916933) strcat(s, "u");
if (crc32("ENpUf",5) == 3822858999) strcat(s, "l");
if (crc32("QdqwFEfqXCN",11) == 3738618316) strcat(s, "s");
if (crc32("qdQFdrKUZIIfi",13) == 1885232186) strcat(s, "l");
if (crc32("wKYazO",6) == 1147525568) strcat(s, "y");
    return s;
}

char *absorbingly_adverbs() {
    char *s = calloc(12);
    if (crc32("dkvZng",6) == 2989305354) strcat(s, "l");
if (crc32("sdqQOvcs",8) == 3923664280) strcat(s, "a");
if (crc32("BtGbr",5) == 2623097231) strcat(s, "b");
if (crc32("SeeKVfv",7) == 677371798) strcat(s, "s");
if (crc32("FfUCNILDIcYDi",13) == 563183338) strcat(s, "o");
if (crc32("lvlAQBTl",8) == 3976705310) strcat(s, "r");
if (crc32("WTUVg",5) == 2877698167) strcat(s, "i");
if (crc32("RDsoFlqp",8) == 3441617253) strcat(s, "b");
if (crc32("GaJufSTbTQ",10) == 3194021684) strcat(s, "i");
if (crc32("LTwboaH",7) == 3820459797) strcat(s, "f");
if (crc32("kujXnnUdPguyVc",14) == 2485791702) strcat(s, "n");
if (crc32("YWWtRces",8) == 2537562091) strcat(s, "A");
if (crc32("cVeWzmr",7) == 3453175222) strcat(s, "g");
if (crc32("engSgTxXnYVAWeL",15) == 2726868481) strcat(s, "j");
if (crc32("hEgwwS",6) == 2686821821) strcat(s, "l");
if (crc32("HPVto",5) == 2613278990) strcat(s, "y");
    return s;
}

char *seventhly_adverbs() {
    char *s = calloc(10);
    if (crc32("grJlzOb",7) == 1253473631) strcat(s, "w");
if (crc32("cSCktHxEjUZy",12) == 285416435) strcat(s, "s");
if (crc32("KoPgDgWsVTsYPCC",15) == 2864969442) strcat(s, "e");
if (crc32("AgPhHvj",7) == 1223393658) strcat(s, "t");
if (crc32("xKqEBUl",7) == 3218736929) strcat(s, "v");
if (crc32("YzphoRkwD",9) == 3249962444) strcat(s, "R");
if (crc32("vXpnurkSQxo",11) == 2053431386) strcat(s, "e");
if (crc32("UlwpOhsrOINr",12) == 1266163716) strcat(s, "n");
if (crc32("kPrRHyHFtyBx",12) == 1617901261) strcat(s, "t");
if (crc32("bMiXekOgXujpAO",14) == 3103744862) strcat(s, "h");
if (crc32("QhWkDQeEhcZjv",13) == 3604169805) strcat(s, "l");
if (crc32("irdqAh",6) == 2170329100) strcat(s, "p");
if (crc32("rQBtFpxL",8) == 842389275) strcat(s, "y");
    return s;
}

char *predelinquently_adverbs() {
    char *s = calloc(16);
    if (crc32("PzqELx",6) == 2850955503) strcat(s, "p");
if (crc32("REwdqxSlslVKCBT",15) == 1271466328) strcat(s, "r");
if (crc32("psGew",5) == 3846502552) strcat(s, "e");
if (crc32("IuvVfEBgaYlYvBZ",15) == 3547576657) strcat(s, "d");
if (crc32("oTuVXTnIka",10) == 2100122308) strcat(s, "e");
if (crc32("BJskqHVnphA",11) == 354735210) strcat(s, "l");
if (crc32("INAfgCoBhEzkrh",14) == 3399420836) strcat(s, "k");
if (crc32("oeYVnotWwMGQh",13) == 44679436) strcat(s, "i");
if (crc32("TVqLhXKrMpbSP",13) == 1431701190) strcat(s, "G");
if (crc32("igzpYwGZJ",9) == 4022254557) strcat(s, "n");
if (crc32("jHbXeC",6) == 1961972063) strcat(s, "q");
if (crc32("uisAWObZVFBza",13) == 3372853717) strcat(s, "u");
if (crc32("hwZsivotZyPzKBO",15) == 737312912) strcat(s, "W");
if (crc32("GaxzhHJztVqhf",13) == 805607505) strcat(s, "e");
if (crc32("vckVwDntUOYDfSz",15) == 114042354) strcat(s, "n");
if (crc32("wFcOgbabQXc",11) == 1335816749) strcat(s, "t");
if (crc32("WvLXEwhCzIdlC",13) == 4182966798) strcat(s, "l");
if (crc32("qAcaFVGhSbi",11) == 3102670121) strcat(s, "y");
    return s;
}

char *antiministerially_adverbs() {
    char *s = calloc(18);
    if (crc32("jaibyqBtBPxu",12) == 1516763489) strcat(s, "a");
if (crc32("dAdWCMqz",8) == 3183372455) strcat(s, "n");
if (crc32("jcybVBEdDUfn",12) == 1093229564) strcat(s, "P");
if (crc32("TLTzwuCgPLxr",12) == 485715775) strcat(s, "t");
if (crc32("GGIEbOgDjWrVba",14) == 1720858243) strcat(s, "i");
if (crc32("hWYiSpaiNgW",11) == 1352901090) strcat(s, "s");
if (crc32("VzYqdjVOEmKxL",13) == 833464016) strcat(s, "m");
if (crc32("ugxXAKHP",8) == 48045556) strcat(s, "A");
if (crc32("RbkvmGelLrA",11) == 2533506955) strcat(s, "i");
if (crc32("bdjNFLkmAwsHwBu",15) == 713419320) strcat(s, "Y");
if (crc32("mJmYHiijeIJP",12) == 155595802) strcat(s, "n");
if (crc32("QeVZdJsAFXTZvY",14) == 4258524360) strcat(s, "i");
if (crc32("POuyikjt",8) == 207050649) strcat(s, "o");
if (crc32("huJMIyjWZfKg",12) == 947132585) strcat(s, "s");
if (crc32("FePVogzttp",10) == 4258019035) strcat(s, "n");
if (crc32("qGHmXJyJaWc",11) == 3492796968) strcat(s, "t");
if (crc32("bwbSjEJjnXV",11) == 2034296457) strcat(s, "p");
if (crc32("rCKEPZ",6) == 3812252249) strcat(s, "e");
if (crc32("OhrOIGGyg",9) == 255947641) strcat(s, "I");
if (crc32("wNxWjOD",7) == 1570332263) strcat(s, "r");
if (crc32("tGrhtAVArGt",11) == 3225932362) strcat(s, "G");
if (crc32("poHPpegO",8) == 2254978313) strcat(s, "i");
if (crc32("exwwA",5) == 530940163) strcat(s, "G");
if (crc32("ErnjUOuXKdF",11) == 3106384349) strcat(s, "a");
if (crc32("dnUWjczZKaBI",12) == 4027446475) strcat(s, "l");
if (crc32("HQSfh",5) == 466498707) strcat(s, "E");
if (crc32("YXjCvneULxAjy",13) == 1273251679) strcat(s, "l");
if (crc32("qxBNTYuLqDxTFc",14) == 3455334638) strcat(s, "y");
    return s;
}

char *unanimously_adverbs() {
    char *s = calloc(12);
    if (crc32("nzaUrBObKBBIld",14) == 769250218) strcat(s, "D");
if (crc32("JStlj",5) == 974027736) strcat(s, "u");
if (crc32("LNBxjDLdMsriPPb",15) == 523133112) strcat(s, "b");
if (crc32("KCIKZRinDBtl",12) == 1519164580) strcat(s, "n");
if (crc32("foNeXors",8) == 4092545498) strcat(s, "a");
if (crc32("qZpSl",5) == 2832341485) strcat(s, "u");
if (crc32("maCQKXlVrx",10) == 2580665146) strcat(s, "n");
if (crc32("uYQOImNAafSc",12) == 1864942998) strcat(s, "D");
if (crc32("ojkhHCKgRVDG",12) == 3914992582) strcat(s, "i");
if (crc32("WmjHBd",6) == 763196416) strcat(s, "Q");
if (crc32("yndkBoaVrpAeg",13) == 1726758709) strcat(s, "m");
if (crc32("qBZQeZBmZC",10) == 3207103726) strcat(s, "o");
if (crc32("IwuHGIqEN",9) == 1481434104) strcat(s, "f");
if (crc32("afNlinUTKh",10) == 1286379710) strcat(s, "u");
if (crc32("YztIDFSLiB",10) == 4112573014) strcat(s, "s");
if (crc32("BxdARijSltv",11) == 2877300703) strcat(s, "k");
if (crc32("duRIXNVPysucBQ",14) == 3361208160) strcat(s, "l");
if (crc32("HfMCGrYbn",9) == 2359217405) strcat(s, "y");
    return s;
}

char *nonexperientially_adverbs() {
    char *s = calloc(18);
    if (crc32("IXjsXxBGlaqq",12) == 3276645750) strcat(s, "n");
if (crc32("cWjuwXfbc",9) == 1622919248) strcat(s, "X");
if (crc32("pNNJpyeUghLRt",13) == 3571499750) strcat(s, "o");
if (crc32("SUUgGXACnkxK",12) == 3170276496) strcat(s, "m");
if (crc32("SuzorSAsnq",10) == 3687421424) strcat(s, "n");
if (crc32("TiSNKapsXvur",12) == 991721145) strcat(s, "v");
if (crc32("dKEtTR",6) == 2835629500) strcat(s, "e");
if (crc32("bcHQhwimGKInBFQ",15) == 1800649172) strcat(s, "x");
if (crc32("xglOmDZJhkIISZM",15) == 1036966567) strcat(s, "p");
if (crc32("TNFdbxjTr",9) == 704361452) strcat(s, "e");
if (crc32("ffZWqf",6) == 2885803566) strcat(s, "G");
if (crc32("vxCUqPUPN",9) == 2108868913) strcat(s, "r");
if (crc32("TaGGD",5) == 3012586724) strcat(s, "i");
if (crc32("eGtuYAwmRHzQFl",14) == 3540008923) strcat(s, "i");
if (crc32("ZPbETvV",7) == 2717777601) strcat(s, "x");
if (crc32("YqNQWgEzS",9) == 4140148099) strcat(s, "e");
if (crc32("TAhmZZincdqnVF",14) == 1731753530) strcat(s, "n");
if (crc32("OjAdEuSik",9) == 2751589989) strcat(s, "D");
if (crc32("OJiYovRiWqb",11) == 1159041722) strcat(s, "t");
if (crc32("afAYgN",6) == 3522356900) strcat(s, "b");
if (crc32("jengaFLNW",9) == 2171548277) strcat(s, "i");
if (crc32("ZydgqfwGgnFIxpE",15) == 1239296441) strcat(s, "j");
if (crc32("wdnAawhBdCNXgdR",15) == 1606637736) strcat(s, "a");
if (crc32("pdyplGvF",8) == 3505084715) strcat(s, "I");
if (crc32("mpCrrXZnCU",10) == 2213591294) strcat(s, "l");
if (crc32("eUpEY",5) == 1889894199) strcat(s, "s");
if (crc32("jLHXyusE",8) == 174303899) strcat(s, "l");
if (crc32("JrdjX",5) == 1392835925) strcat(s, "R");
if (crc32("ntMJTNsppwNtL",13) == 3429205981) strcat(s, "y");
    return s;
}

char *prewillingly_adverbs() {
    char *s = calloc(13);
    if (crc32("fnSoOwEqJ",9) == 498722819) strcat(s, "p");
if (crc32("sCIqlMGDyXZTvj",14) == 2647093185) strcat(s, "r");
if (crc32("ZROlfB",6) == 3410710599) strcat(s, "h");
if (crc32("NNtRpv",6) == 2121223293) strcat(s, "e");
if (crc32("kdzFI",5) == 2552028710) strcat(s, "w");
if (crc32("RlvPvACrB",9) == 484575018) strcat(s, "w");
if (crc32("mXaNHXwlzyI",11) == 682359482) strcat(s, "i");
if (crc32("NUxGX",5) == 1566103369) strcat(s, "l");
if (crc32("wiLgSDfRLwBO",12) == 4023988383) strcat(s, "l");
if (crc32("KKxqAG",6) == 18616887) strcat(s, "i");
if (crc32("MkCyqVtIugMK",12) == 695396779) strcat(s, "O");
if (crc32("dUThy",5) == 3104536411) strcat(s, "n");
if (crc32("xZCnxQKqigC",11) == 3316936650) strcat(s, "g");
if (crc32("yvNwV",5) == 3838194137) strcat(s, "l");
if (crc32("SaoxymUtxFUn",12) == 280307028) strcat(s, "F");
if (crc32("kjfGnXIhVXTIX",13) == 1361993388) strcat(s, "y");
    return s;
}

char *failingly_adverbs() {
    char *s = calloc(10);
    if (crc32("TlWchkGn",8) == 2556649382) strcat(s, "f");
if (crc32("XFDETgVE",8) == 591454855) strcat(s, "a");
if (crc32("iHifkquxPwI",11) == 4270053828) strcat(s, "i");
if (crc32("CTmdFJZTvV",10) == 1401611738) strcat(s, "F");
if (crc32("BJvDjQSS",8) == 3304619426) strcat(s, "l");
if (crc32("igXDHmI",7) == 729584236) strcat(s, "i");
if (crc32("UBhOrutfYQ",10) == 2769204852) strcat(s, "y");
if (crc32("huooVcOrNZJGEfG",15) == 42404726) strcat(s, "n");
if (crc32("mBeLeTRGXIoy",12) == 305026476) strcat(s, "g");
if (crc32("QNvGTBhQozT",11) == 2953685059) strcat(s, "L");
if (crc32("kRTCkR",6) == 2768104265) strcat(s, "l");
if (crc32("HwmsMjVgII",10) == 2169112607) strcat(s, "y");
    return s;
}

char *amatively_adverbs() {
    char *s = calloc(10);
    if (crc32("JoPFDDplHeYtvn",14) == 498333980) strcat(s, "N");
if (crc32("edrdmDwYlgZfKZa",15) == 595246310) strcat(s, "a");
if (crc32("RUjJAFWYSioynqa",15) == 3278850280) strcat(s, "H");
if (crc32("efDTgMimqtxQTno",15) == 348176493) strcat(s, "m");
if (crc32("qnyOAaRxoqWOZz",14) == 3169950770) strcat(s, "a");
if (crc32("QvqqpSRWKuxhq",13) == 469088461) strcat(s, "t");
if (crc32("jRcgYrKYjEjGXr",14) == 1372889086) strcat(s, "r");
if (crc32("YIDbFoGPcLLi",12) == 305494181) strcat(s, "i");
if (crc32("wMemB",5) == 2482097851) strcat(s, "I");
if (crc32("QSwBQImqu",9) == 2264765639) strcat(s, "v");
if (crc32("HeKlwGqpjOA",11) == 1726996801) strcat(s, "o");
if (crc32("eeEwkVsyyCOo",12) == 2080500680) strcat(s, "e");
if (crc32("stwOTTeeKbbyHZ",14) == 1871229114) strcat(s, "B");
if (crc32("uIsazlgWLWYyUH",14) == 2160498338) strcat(s, "l");
if (crc32("rVZCwRnzeLLJIG",14) == 2408383920) strcat(s, "y");
    return s;
}

char *frugally_adverbs() {
    char *s = calloc(9);
    if (crc32("BlbHLUgyzWlYifV",15) == 113868007) strcat(s, "f");
if (crc32("ybdrEx",6) == 1325156259) strcat(s, "r");
if (crc32("ZQCKwtldnlJ",11) == 2019166502) strcat(s, "u");
if (crc32("vZwOhWjfpx",10) == 3137823782) strcat(s, "Q");
if (crc32("TLRRr",5) == 2211294347) strcat(s, "g");
if (crc32("ARKDXpAgQ",9) == 1591687984) strcat(s, "X");
if (crc32("pDupppZQtz",10) == 1591251621) strcat(s, "a");
if (crc32("KFEEAzDdneb",11) == 2215344955) strcat(s, "R");
if (crc32("whiuEzEShQY",11) == 1747715778) strcat(s, "l");
if (crc32("wDumCLOy",8) == 979458462) strcat(s, "h");
if (crc32("IWYXonsPtyl",11) == 369556530) strcat(s, "l");
if (crc32("bXNtHtrnThrUoD",14) == 1799284696) strcat(s, "y");
    return s;
}

char *closely_adverbs() {
    char *s = calloc(8);
    if (crc32("fIvCo",5) == 3799761685) strcat(s, "G");
if (crc32("YEfCWxjBnCJgg",13) == 3411245575) strcat(s, "c");
if (crc32("UPsqwww",7) == 1918843140) strcat(s, "l");
if (crc32("HoQkvufSKrUWnmv",15) == 4204834423) strcat(s, "o");
if (crc32("AYrSJgeoPQ",10) == 3169231784) strcat(s, "L");
if (crc32("ThlaZzFVPXprW",13) == 558880974) strcat(s, "s");
if (crc32("emZMUMafjdLNN",13) == 3286845066) strcat(s, "e");
if (crc32("DHfXHZ",6) == 2188660833) strcat(s, "l");
if (crc32("lpOwdmCxtvp",11) == 3176632886) strcat(s, "W");
if (crc32("qmiGPFBhmtI",11) == 2172880546) strcat(s, "y");
    return s;
}

char *unlibellously_adverbs() {
    char *s = calloc(14);
    if (crc32("sORgMNzTFkzxR",13) == 1409481679) strcat(s, "j");
if (crc32("DXfyPlaIKyBUTg",14) == 2441104527) strcat(s, "u");
if (crc32("UIKViKkaye",10) == 4260458596) strcat(s, "n");
if (crc32("vMUriYsaAvRs",12) == 1313739328) strcat(s, "n");
if (crc32("sLZyiaGOVfzfE",13) == 4213499347) strcat(s, "l");
if (crc32("aKoSvBan",8) == 1389946380) strcat(s, "i");
if (crc32("GZrPvG",6) == 4080733378) strcat(s, "N");
if (crc32("YMgAiWMk",8) == 3399443458) strcat(s, "b");
if (crc32("yeOxqPyAMvd",11) == 2728893909) strcat(s, "R");
if (crc32("hKeitcYsVXkp",12) == 983457005) strcat(s, "e");
if (crc32("lyMiXJhlwYu",11) == 2811208471) strcat(s, "l");
if (crc32("FeVCAzNdRwz",11) == 1614416733) strcat(s, "l");
if (crc32("DCMxmNAIGeeBPsS",15) == 1270936533) strcat(s, "C");
if (crc32("nYbrhQa",7) == 2423347840) strcat(s, "o");
if (crc32("KJzbklQvMjI",11) == 3049651244) strcat(s, "u");
if (crc32("ulrAdc",6) == 234420586) strcat(s, "X");
if (crc32("ukwhkfHP",8) == 1156581918) strcat(s, "s");
if (crc32("VCgOTUhJbg",10) == 3703065376) strcat(s, "G");
if (crc32("BJwajldlnnGvaS",14) == 2681502596) strcat(s, "l");
if (crc32("aseicVx",7) == 870627551) strcat(s, "X");
if (crc32("lPGhG",5) == 1638190122) strcat(s, "y");
    return s;
}

char *hastily_adverbs() {
    char *s = calloc(8);
    if (crc32("yqtGCiKRg",9) == 3154932877) strcat(s, "e");
if (crc32("RdZOQH",6) == 2565298526) strcat(s, "h");
if (crc32("ZNasySjP",8) == 1405054502) strcat(s, "d");
if (crc32("oNqpfubklD",10) == 3681523624) strcat(s, "a");
if (crc32("xTLgKkyxiyzTICh",15) == 2264863837) strcat(s, "s");
if (crc32("CXrvWbe",7) == 3337933352) strcat(s, "t");
if (crc32("nRXuPKLelamGY",13) == 1671071640) strcat(s, "y");
if (crc32("RvykKaWMxdA",11) == 1573020095) strcat(s, "i");
if (crc32("IHRQdFtsaCcUDS",14) == 3386686979) strcat(s, "l");
if (crc32("gTitwOZY",8) == 2752369469) strcat(s, "S");
if (crc32("KefIPvJPTwzQOeO",15) == 3511454732) strcat(s, "y");
    return s;
}

char *incorrectly_adverbs() {
    char *s = calloc(12);
    if (crc32("CYhlvqufrs",10) == 3667477770) strcat(s, "i");
if (crc32("LSyujYnbzhDdJpY",15) == 2250712385) strcat(s, "n");
if (crc32("tvJDFySTSY",10) == 2338837164) strcat(s, "c");
if (crc32("COLTJNlzDwUunX",14) == 874016936) strcat(s, "o");
if (crc32("FuqZXDxdRN",10) == 3099836832) strcat(s, "t");
if (crc32("XwmSSsxmo",9) == 3102266007) strcat(s, "r");
if (crc32("JulTy",5) == 3949476371) strcat(s, "c");
if (crc32("jGBEcjCWYzf",11) == 2086120297) strcat(s, "r");
if (crc32("yjvFBmrGbTY",11) == 561708455) strcat(s, "e");
if (crc32("fyqXXOz",7) == 4023661914) strcat(s, "Y");
if (crc32("bdZsMpqFruL",11) == 1358203988) strcat(s, "c");
if (crc32("gGPVjiJaABOxV",13) == 2603058495) strcat(s, "t");
if (crc32("JPHCvLpqRkvM",12) == 3251076957) strcat(s, "l");
if (crc32("PdugR",5) == 3080077185) strcat(s, "y");
    return s;
}

char *parsimoniously_adverbs() {
    char *s = calloc(15);
    if (crc32("TfLYQnuIu",9) == 4107135195) strcat(s, "N");
if (crc32("YQoUV",5) == 2262819757) strcat(s, "p");
if (crc32("PUZHqvStBVjYBf",14) == 2781172389) strcat(s, "a");
if (crc32("RfvDzGwbtAKwz",13) == 419113648) strcat(s, "F");
if (crc32("BBQWcky",7) == 3129003940) strcat(s, "r");
if (crc32("kvuxPfgdAx",10) == 996216493) strcat(s, "X");
if (crc32("LEEKrSyKffosXHQ",15) == 2991498745) strcat(s, "s");
if (crc32("gKtcbPdflUaO",12) == 4248069655) strcat(s, "i");
if (crc32("wYvIKyYwhLzjDE",14) == 2753893784) strcat(s, "D");
if (crc32("LSwQaHTwfL",10) == 4258488492) strcat(s, "m");
if (crc32("zPxMxT",6) == 2118234172) strcat(s, "o");
if (crc32("hLIAfGQAeS",10) == 298648424) strcat(s, "n");
if (crc32("DfOFZQsxrRNkCYm",15) == 3343361214) strcat(s, "i");
if (crc32("XpLLoaC",7) == 437117299) strcat(s, "o");
if (crc32("stBoX",5) == 1757851081) strcat(s, "u");
if (crc32("wbJnefhIyM",10) == 3747363869) strcat(s, "s");
if (crc32("JWSqlaZUtAwRZ",13) == 940911257) strcat(s, "l");
if (crc32("eUmmiWSVj",9) == 1588911132) strcat(s, "y");
    return s;
}

char *unselfconsciously_adverbs() {
    char *s = calloc(18);
    if (crc32("seDKcfspomQz",12) == 810065703) strcat(s, "u");
if (crc32("tkCCLwRKJFU",11) == 387166683) strcat(s, "n");
if (crc32("elNmsjTVtrEm",12) == 2349075337) strcat(s, "t");
if (crc32("zZlhE",5) == 1001358913) strcat(s, "s");
if (crc32("USbntDqK",8) == 1292072164) strcat(s, "e");
if (crc32("aoEGcNCqB",9) == 1785806098) strcat(s, "J");
if (crc32("gPoFrDq",7) == 2659988746) strcat(s, "l");
if (crc32("fCAyIyCCJKqOu",13) == 3711964036) strcat(s, "C");
if (crc32("cKYtlwKgx",9) == 1936322785) strcat(s, "f");
if (crc32("zvVtIIwBsKoPh",13) == 1283661545) strcat(s, "c");
if (crc32("APjmIwNETWrabk",14) == 2572103391) strcat(s, "o");
if (crc32("zUolrPkjRQmBmC",14) == 968402878) strcat(s, "a");
if (crc32("hmbLWudsIJIz",12) == 3852567095) strcat(s, "n");
if (crc32("sCeueYC",7) == 245578341) strcat(s, "s");
if (crc32("iVUtnfl",7) == 264390241) strcat(s, "M");
if (crc32("vuWEnBrXn",9) == 2699363140) strcat(s, "c");
if (crc32("WbwzDbnSuLoh",12) == 444986587) strcat(s, "u");
if (crc32("uxEFlKCJJEHEJu",14) == 621833633) strcat(s, "i");
if (crc32("ghivDndhAcZ",11) == 3993735011) strcat(s, "o");
if (crc32("gXhswqFIncRSZPF",15) == 2235183136) strcat(s, "R");
if (crc32("IuSiBMTierPD",12) == 643256877) strcat(s, "u");
if (crc32("gRYfGeZhi",9) == 3215088646) strcat(s, "s");
if (crc32("xmRquefdttI",11) == 1691710450) strcat(s, "l");
if (crc32("wcgiPawPBJoz",12) == 1773946644) strcat(s, "y");
    return s;
}

char *consumingly_adverbs() {
    char *s = calloc(12);
    if (crc32("YzGlDtl",7) == 3412959896) strcat(s, "j");
if (crc32("aNaLCMnYlK",10) == 3983060227) strcat(s, "c");
if (crc32("PhvXdXAAJgfzjU",14) == 4218337694) strcat(s, "o");
if (crc32("TQzNrNIPzeIuaI",14) == 3154378188) strcat(s, "n");
if (crc32("dyMWvF",6) == 808643665) strcat(s, "s");
if (crc32("zPltZnpFwHo",11) == 448145637) strcat(s, "u");
if (crc32("SLURrmexTeoA",12) == 1120966520) strcat(s, "b");
if (crc32("hmUMBXvynBphX",13) == 3516705896) strcat(s, "m");
if (crc32("FfdWug",6) == 3955396528) strcat(s, "X");
if (crc32("QRuKahTTivQK",12) == 437698244) strcat(s, "i");
if (crc32("YiWhykGpNnhXNMz",15) == 3824006604) strcat(s, "n");
if (crc32("JjugpflMcttSW",13) == 3805589774) strcat(s, "g");
if (crc32("vxesFRmQtrS",11) == 1689802650) strcat(s, "l");
if (crc32("InEgVLdslsHweIR",15) == 3985261271) strcat(s, "G");
if (crc32("BIuxeNlUihwMShu",15) == 3792287639) strcat(s, "y");
    return s;
}

char *contiguously_adverbs() {
    char *s = calloc(13);
    if (crc32("HyuMcf",6) == 744535303) strcat(s, "x");
if (crc32("HhEAl",5) == 2332305253) strcat(s, "c");
if (crc32("YMyUYjtw",8) == 2688444732) strcat(s, "o");
if (crc32("ZVKOoDZnZB",10) == 526723450) strcat(s, "w");
if (crc32("vFrzadCC",8) == 629910767) strcat(s, "n");
if (crc32("rDXtC",5) == 2540656648) strcat(s, "t");
if (crc32("gNogtOmNZAtP",12) == 2280605680) strcat(s, "i");
if (crc32("vUAzUOtiUDYxM",13) == 2689528406) strcat(s, "D");
if (crc32("QwsWDSpvUFCXu",13) == 2955663163) strcat(s, "g");
if (crc32("wbYfKdMMwOaP",12) == 2257148012) strcat(s, "M");
if (crc32("bgSjWsEl",8) == 688023632) strcat(s, "u");
if (crc32("ZDYZzPsnDhQrD",13) == 804490100) strcat(s, "o");
if (crc32("VUFiLEn",7) == 758022207) strcat(s, "q");
if (crc32("WTIHJI",6) == 4040779155) strcat(s, "u");
if (crc32("vtnRPub",7) == 1958403209) strcat(s, "D");
if (crc32("acLfknbYTVcw",12) == 540252035) strcat(s, "s");
if (crc32("GklcNfO",7) == 4057359288) strcat(s, "A");
if (crc32("yEnKCodG",8) == 4275046688) strcat(s, "l");
if (crc32("YITXnv",6) == 1070200844) strcat(s, "k");
if (crc32("hVRYPqHyBS",10) == 2083357597) strcat(s, "y");
    return s;
}

char *prediligently_adverbs() {
    char *s = calloc(14);
    if (crc32("ZCUtJVmHbRQXJN",14) == 4010598495) strcat(s, "i");
if (crc32("DibMQYqMGtQHEpm",15) == 4234978022) strcat(s, "p");
if (crc32("UUTzCBYTX",9) == 1215162544) strcat(s, "r");
if (crc32("KtyycUiwZhob",12) == 2473795173) strcat(s, "f");
if (crc32("lbiFIVPwec",10) == 2067620289) strcat(s, "e");
if (crc32("KRmxfzg",7) == 1244679732) strcat(s, "s");
if (crc32("VeVCIx",6) == 3642285265) strcat(s, "d");
if (crc32("eKAFfNFlCrQtMW",14) == 3742303105) strcat(s, "J");
if (crc32("RtNub",5) == 3948704112) strcat(s, "i");
if (crc32("CIfKMgtuLGu",11) == 1845622624) strcat(s, "w");
if (crc32("FdtxdrfzCV",10) == 2285673890) strcat(s, "l");
if (crc32("GJWuGHNdFVMa",12) == 1035903985) strcat(s, "i");
if (crc32("KixncXmex",9) == 1315165901) strcat(s, "i");
if (crc32("xXMRfhjszUklh",13) == 2061239838) strcat(s, "g");
if (crc32("AgvNwfkXjOeg",12) == 2220474183) strcat(s, "e");
if (crc32("FqQVtHlyRxOUx",13) == 2571734695) strcat(s, "n");
if (crc32("LGpdBoTeSoEeVu",14) == 3697611809) strcat(s, "I");
if (crc32("obwEPQiltLfUnYh",15) == 2050518135) strcat(s, "t");
if (crc32("UpnlbFSTtyxlaa",14) == 1227490325) strcat(s, "d");
if (crc32("jPSLv",5) == 1442698170) strcat(s, "l");
if (crc32("mLnpUtLpaNtFfHf",15) == 3403213720) strcat(s, "y");
    return s;
}

char *anemographically_adverbs() {
    char *s = calloc(17);
    if (crc32("XKhMkmXGlSqoyyd",15) == 2923680940) strcat(s, "D");
if (crc32("uUTlhIP",7) == 3473450790) strcat(s, "a");
if (crc32("cZFZXbXJBVFR",12) == 3637388314) strcat(s, "n");
if (crc32("vYRvyW",6) == 1707135322) strcat(s, "w");
if (crc32("zTvxFYaW",8) == 3473561128) strcat(s, "e");
if (crc32("exPWAkg",7) == 3923601952) strcat(s, "m");
if (crc32("exMBk",5) == 1494617239) strcat(s, "o");
if (crc32("HtHysql",7) == 538502372) strcat(s, "g");
if (crc32("ABImJZalSMlD",12) == 673572565) strcat(s, "r");
if (crc32("gUPSYkO",7) == 4114534114) strcat(s, "v");
if (crc32("vkAvnruayOS",11) == 111754616) strcat(s, "a");
if (crc32("TGctyFodF",9) == 1461360075) strcat(s, "p");
if (crc32("RdjyqZpsht",10) == 304540721) strcat(s, "h");
if (crc32("CzQbjwkGFFOf",12) == 2793862887) strcat(s, "s");
if (crc32("FUSDpnswu",9) == 3829331109) strcat(s, "i");
if (crc32("eSahEK",6) == 1610139732) strcat(s, "H");
if (crc32("otKhdqAJpDtu",12) == 1365285810) strcat(s, "c");
if (crc32("TvESApJQbbqsGYj",15) == 1317349881) strcat(s, "a");
if (crc32("JblyzVQpY",9) == 3134074190) strcat(s, "D");
if (crc32("UZQlPLeGard",11) == 1017680625) strcat(s, "l");
if (crc32("zknwBGMeX",9) == 2664888680) strcat(s, "E");
if (crc32("dgOHB",5) == 3621111398) strcat(s, "l");
if (crc32("OFaciODPoc",10) == 1021349841) strcat(s, "y");
    return s;
}

char *musingly_adverbs() {
    char *s = calloc(9);
    if (crc32("QXNrENBfqUpay",13) == 186200201) strcat(s, "m");
if (crc32("EUOcmRa",7) == 1546590153) strcat(s, "C");
if (crc32("DjupqjHSWZIvzVv",15) == 1368698901) strcat(s, "u");
if (crc32("iHZumyGOwLpH",12) == 246301863) strcat(s, "W");
if (crc32("EmMLLUizeAaKds",14) == 511517661) strcat(s, "s");
if (crc32("ADHcQzrnYtllJ",13) == 3560150703) strcat(s, "i");
if (crc32("bWvQKOc",7) == 134918983) strcat(s, "F");
if (crc32("aGVjMC",6) == 2577254127) strcat(s, "n");
if (crc32("yhokBRX",7) == 1767762065) strcat(s, "g");
if (crc32("mWqDWpuPedM",11) == 2978991299) strcat(s, "l");
if (crc32("oPBRmnWvPywl",12) == 3698288530) strcat(s, "y");
    return s;
}

char *edictally_adverbs() {
    char *s = calloc(10);
    if (crc32("cWCoFCcx",8) == 2469904964) strcat(s, "e");
if (crc32("EMKBoamfJY",10) == 3546337224) strcat(s, "d");
if (crc32("BAhhDI",6) == 3045215612) strcat(s, "i");
if (crc32("ivqaymekpuZk",12) == 3334343429) strcat(s, "c");
if (crc32("DGMeRTavgvR",11) == 1068017292) strcat(s, "k");
if (crc32("DxPjySzdEIQEZYW",15) == 191722375) strcat(s, "t");
if (crc32("snAykFvRuyF",11) == 1889235766) strcat(s, "t");
if (crc32("mihqnPKmMOUNx",13) == 174720090) strcat(s, "a");
if (crc32("BJBomvfZSLxACEJ",15) == 3284764420) strcat(s, "l");
if (crc32("sTSMVKhABAFQC",13) == 1288457180) strcat(s, "c");
if (crc32("mJHzkCloZ",9) == 1634792840) strcat(s, "l");
if (crc32("WzcSMcABo",9) == 4006491828) strcat(s, "G");
if (crc32("cUZlkcOUwHntkk",14) == 3730166147) strcat(s, "y");
    return s;
}

char *deftly_adverbs() {
    char *s = calloc(7);
    if (crc32("kvjwqTJWPCqaxYh",15) == 2042818754) strcat(s, "m");
if (crc32("UiFCm",5) == 3972005758) strcat(s, "d");
if (crc32("VHYuFvYeLIrc",12) == 3752708583) strcat(s, "G");
if (crc32("OEZzfslSkC",10) == 2194218548) strcat(s, "e");
if (crc32("SzWQGGEMqh",10) == 1462676838) strcat(s, "f");
if (crc32("yoImJbjlPftgD",13) == 1189496473) strcat(s, "t");
if (crc32("NXYuSZGvf",9) == 433235928) strcat(s, "A");
if (crc32("CXnHqFtccUoVDkz",15) == 3607981937) strcat(s, "l");
if (crc32("ptOfwXFr",8) == 3655450268) strcat(s, "Z");
if (crc32("GySBPcij",8) == 258462310) strcat(s, "y");
    return s;
}

char *inaptly_adverbs() {
    char *s = calloc(8);
    if (crc32("nGxGGPGAVQYtLua",15) == 2796675384) strcat(s, "i");
if (crc32("qPtRtuX",7) == 3534428617) strcat(s, "n");
if (crc32("NKlgiJZM",8) == 940012069) strcat(s, "a");
if (crc32("sCyVfz",6) == 3730183490) strcat(s, "p");
if (crc32("NLATQqlgJnIshSQ",15) == 828480516) strcat(s, "t");
if (crc32("HcsjFkPNugoDt",13) == 931679488) strcat(s, "l");
if (crc32("yJzzlGqcnqG",11) == 282229145) strcat(s, "y");
    return s;
}

char *vulgarly_adverbs() {
    char *s = calloc(9);
    if (crc32("RErteNybqnbpkla",15) == 3781100317) strcat(s, "v");
if (crc32("bUPnVqbMeapxMK",14) == 2516475513) strcat(s, "U");
if (crc32("IqjiBIbl",8) == 2033968799) strcat(s, "u");
if (crc32("XMYpHSxBFnyS",12) == 879910383) strcat(s, "l");
if (crc32("IlBHtPHULKd",11) == 2809059165) strcat(s, "g");
if (crc32("ecFkPxTJP",9) == 3977263404) strcat(s, "J");
if (crc32("HNCgowQOyYUuPWx",15) == 2144917274) strcat(s, "a");
if (crc32("hpHNZUMIeOHJFj",14) == 3157794102) strcat(s, "c");
if (crc32("efNFPEwpmz",10) == 3203820931) strcat(s, "r");
if (crc32("MuCzimwSsJw",11) == 385484154) strcat(s, "l");
if (crc32("OwtHRZhYxmOcGR",14) == 2422235282) strcat(s, "y");
    return s;
}

char *recently_adverbs() {
    char *s = calloc(9);
    if (crc32("OIsNh",5) == 2176414426) strcat(s, "r");
if (crc32("IjhtEZLMBGzaZ",13) == 3805326879) strcat(s, "O");
if (crc32("pPFCjGmLgRKvY",13) == 3882750348) strcat(s, "e");
if (crc32("lQkdGmkaoWoY",12) == 839503040) strcat(s, "c");
if (crc32("DAAppnoMh",9) == 1930903166) strcat(s, "W");
if (crc32("wduUWHOKIEsFJpv",15) == 278346260) strcat(s, "e");
if (crc32("PHxaoLuORXYot",13) == 1844043379) strcat(s, "n");
if (crc32("DHerwDp",7) == 56631585) strcat(s, "l");
if (crc32("bMHurdeMwCQbD",13) == 3658945850) strcat(s, "t");
if (crc32("vjvZVYufQp",10) == 2755582189) strcat(s, "p");
if (crc32("oKociaUyRLqmkl",14) == 1298047350) strcat(s, "l");
if (crc32("ZMbnTyouj",9) == 1530255590) strcat(s, "K");
if (crc32("DJVjP",5) == 61878550) strcat(s, "y");
    return s;
}

char *unlustfully_adverbs() {
    char *s = calloc(12);
    if (crc32("iSnPbV",6) == 4065951013) strcat(s, "j");
if (crc32("YeOjNjqGQi",10) == 3092000592) strcat(s, "u");
if (crc32("XfVvY",5) == 3555704554) strcat(s, "n");
if (crc32("yHTjZGgNGXDCOOc",15) == 3644897627) strcat(s, "F");
if (crc32("AYusy",5) == 1782943706) strcat(s, "l");
if (crc32("icCYNmV",7) == 2351663340) strcat(s, "u");
if (crc32("MXsHZO",6) == 2874345166) strcat(s, "s");
if (crc32("zeDuSBHv",8) == 4192853674) strcat(s, "f");
if (crc32("MQbFOCATOhbZO",13) == 3541574203) strcat(s, "t");
if (crc32("AGRuKBjaCCTyQAl",15) == 1492375003) strcat(s, "l");
if (crc32("rKbwJ",5) == 3020014463) strcat(s, "f");
if (crc32("PxLrTfwNNN",10) == 3316040630) strcat(s, "r");
if (crc32("LbeWOyel",8) == 300577040) strcat(s, "u");
if (crc32("dMbLWInwTcT",11) == 3790241001) strcat(s, "Y");
if (crc32("oKwwIrycJLtUpt",14) == 2793133024) strcat(s, "l");
if (crc32("nJravhRk",8) == 3471600074) strcat(s, "F");
if (crc32("pVqeNXZIqSg",11) == 693751857) strcat(s, "l");
if (crc32("qAsgMjZV",8) == 2942462865) strcat(s, "y");
    return s;
}

char *mannishly_adverbs() {
    char *s = calloc(10);
    if (crc32("DrUdZTVtFyBtp",13) == 2976504242) strcat(s, "j");
if (crc32("gmWxFDErry",10) == 1189389370) strcat(s, "m");
if (crc32("GSKIJ",5) == 853891586) strcat(s, "A");
if (crc32("TxUyBi",6) == 3199015032) strcat(s, "a");
if (crc32("PelobmMDCS",10) == 4111105810) strcat(s, "I");
if (crc32("PrRxoD",6) == 2523666139) strcat(s, "n");
if (crc32("ReGjyWksblOxGc",14) == 1426380657) strcat(s, "n");
if (crc32("ucvyTDD",7) == 1908747404) strcat(s, "F");
if (crc32("spUanTYINpKoD",13) == 2751221674) strcat(s, "i");
if (crc32("MSwriIJtHHQnW",13) == 3267338238) strcat(s, "g");
if (crc32("WlGYkcKcJxaEEH",14) == 2782864239) strcat(s, "s");
if (crc32("JaZJEXtCYJdDuCm",15) == 4202064732) strcat(s, "f");
if (crc32("OwABplCj",8) == 111555893) strcat(s, "h");
if (crc32("fUeNzBVdSqqYWq",14) == 1422874485) strcat(s, "l");
if (crc32("GtNarNcLkKgSSh",14) == 1052643248) strcat(s, "N");
if (crc32("WYrHJqa",7) == 4239491946) strcat(s, "y");
    return s;
}

char *amitotically_adverbs() {
    char *s = calloc(13);
    if (crc32("jugrJUtl",8) == 3174974798) strcat(s, "a");
if (crc32("alAkvm",6) == 65290012) strcat(s, "a");
if (crc32("egHAqxuU",8) == 4119342332) strcat(s, "m");
if (crc32("lwkTCIVNC",9) == 1474335172) strcat(s, "q");
if (crc32("OFzGUW",6) == 3689611784) strcat(s, "i");
if (crc32("IeUPHXLvuOVhQa",14) == 4101560925) strcat(s, "t");
if (crc32("WGUVOtjIFGRZng",14) == 583576512) strcat(s, "q");
if (crc32("QHtcTPiSR",9) == 3128211782) strcat(s, "o");
if (crc32("lMcWtuO",7) == 3315298820) strcat(s, "L");
if (crc32("HehnznZahtnuaR",14) == 2552443440) strcat(s, "t");
if (crc32("EBlyzHi",7) == 2766840189) strcat(s, "w");
if (crc32("beagag",6) == 3290305553) strcat(s, "i");
if (crc32("eXFZyliyO",9) == 1610333957) strcat(s, "z");
if (crc32("uVxXn",5) == 2617010743) strcat(s, "c");
if (crc32("gHvGReBa",8) == 2779786750) strcat(s, "R");
if (crc32("WlgWwZuX",8) == 1227769896) strcat(s, "a");
if (crc32("kCPGm",5) == 2766300154) strcat(s, "a");
if (crc32("mAKZbjriwoqzmia",15) == 940136087) strcat(s, "l");
if (crc32("kTfRFQUbq",9) == 907246640) strcat(s, "x");
if (crc32("NzkZg",5) == 4066587689) strcat(s, "l");
if (crc32("ZvNMERwDOdQ",11) == 3234057105) strcat(s, "y");
    return s;
}

char *supplely_adverbs() {
    char *s = calloc(9);
    if (crc32("sItSscbTfaAJzf",14) == 3542240457) strcat(s, "s");
if (crc32("vfTHBzQd",8) == 2581844908) strcat(s, "u");
if (crc32("BQUcbLsrwm",10) == 516496261) strcat(s, "p");
if (crc32("jPPVrzQBptje",12) == 2698223247) strcat(s, "p");
if (crc32("oxNTuWglUQs",11) == 2146154298) strcat(s, "l");
if (crc32("SJUvAmQDgH",10) == 2606028603) strcat(s, "e");
if (crc32("qCCmUjNuqpGt",12) == 954351906) strcat(s, "R");
if (crc32("BLmlhzBxjUy",11) == 2118165739) strcat(s, "l");
if (crc32("YVGWcjk",7) == 1109157174) strcat(s, "y");
    return s;
}

char *speechlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("kTvmYusyhYYmHJ",14) == 1458666460) strcat(s, "H");
if (crc32("lldWLVHxrpIt",12) == 905314978) strcat(s, "s");
if (crc32("eZtTcqmkB",9) == 1944267876) strcat(s, "j");
if (crc32("uakVsRpPn",9) == 2284643721) strcat(s, "p");
if (crc32("sDglThMFslXRzDE",15) == 951086484) strcat(s, "k");
if (crc32("WeXozllkwiKvISN",15) == 989908058) strcat(s, "e");
if (crc32("rkxfBXjfTQvy",12) == 3078943281) strcat(s, "e");
if (crc32("oRsStTqFuTNUrsu",15) == 4238522061) strcat(s, "c");
if (crc32("blhsbqxJ",8) == 1423716233) strcat(s, "h");
if (crc32("JpuWSzqoQH",10) == 3700270809) strcat(s, "K");
if (crc32("zzFyj",5) == 1448080384) strcat(s, "l");
if (crc32("whqqbzfiYJfG",12) == 3205325229) strcat(s, "e");
if (crc32("JJlVVVKA",8) == 1633696645) strcat(s, "s");
if (crc32("kDKrmnW",7) == 545215577) strcat(s, "s");
if (crc32("YZZPTOuFOo",10) == 1768030979) strcat(s, "l");
if (crc32("pYtsjgXwE",9) == 3091607985) strcat(s, "y");
    return s;
}

char *superincumbently_adverbs() {
    char *s = calloc(17);
    if (crc32("UTrsnRf",7) == 2927828895) strcat(s, "v");
if (crc32("exbEBVX",7) == 384091400) strcat(s, "s");
if (crc32("UwabyptsdC",10) == 3571235104) strcat(s, "u");
if (crc32("tkxtkl",6) == 4042096584) strcat(s, "u");
if (crc32("UCuSYyJhzmhOVaY",15) == 973442712) strcat(s, "u");
if (crc32("vKjtoC",6) == 1229559438) strcat(s, "p");
if (crc32("uqsmdSfGIkhC",12) == 3662615126) strcat(s, "e");
if (crc32("XjOYLHQRHWbmo",13) == 157181889) strcat(s, "K");
if (crc32("VAHzDhtyebUrUT",14) == 3727438297) strcat(s, "r");
if (crc32("lUqGHbvrazTla",13) == 3068879318) strcat(s, "y");
if (crc32("pMMZRLovcgCIPf",14) == 3144611717) strcat(s, "i");
if (crc32("rgquG",5) == 4279974558) strcat(s, "H");
if (crc32("kphHSMzFyo",10) == 936918377) strcat(s, "n");
if (crc32("fdtxi",5) == 4174250511) strcat(s, "h");
if (crc32("WDuRrAPRtAAT",12) == 1263959876) strcat(s, "c");
if (crc32("sCsBEIyJeIc",11) == 1582298565) strcat(s, "u");
if (crc32("OgeeHQLjd",9) == 250879908) strcat(s, "R");
if (crc32("tRDtSzSuXKaDswo",15) == 1190344580) strcat(s, "m");
if (crc32("KlPWcFkcZOPFuj",14) == 2577248283) strcat(s, "N");
if (crc32("Qpphe",5) == 1818471890) strcat(s, "b");
if (crc32("kNfNqNnI",8) == 2550185953) strcat(s, "e");
if (crc32("hubOVS",6) == 2419936450) strcat(s, "n");
if (crc32("cabRPTfhwLqG",12) == 919402785) strcat(s, "t");
if (crc32("DDiUHx",6) == 3261038465) strcat(s, "t");
if (crc32("WoYUAPNwZOOwPD",14) == 708976626) strcat(s, "l");
if (crc32("vxunv",5) == 3999245269) strcat(s, "m");
if (crc32("QHMDNn",6) == 3297698385) strcat(s, "y");
    return s;
}

char *unministerially_adverbs() {
    char *s = calloc(16);
    if (crc32("MazDBTMHLkToj",13) == 2088051449) strcat(s, "n");
if (crc32("zbmNZgfjW",9) == 1013732386) strcat(s, "u");
if (crc32("PSHUKzMZwBcr",12) == 2617053906) strcat(s, "n");
if (crc32("oBGee",5) == 3657317594) strcat(s, "E");
if (crc32("pyMFhrAbvtpVgA",14) == 2327789343) strcat(s, "m");
if (crc32("fZRROtzab",9) == 1079516587) strcat(s, "i");
if (crc32("XosTZRksz",9) == 670259065) strcat(s, "Z");
if (crc32("xAwZjThekve",11) == 325460551) strcat(s, "n");
if (crc32("AqPcvXhTOIgyqC",14) == 4138092054) strcat(s, "i");
if (crc32("pLlQALGwJFDCUP",14) == 2528337192) strcat(s, "m");
if (crc32("fsSdbJXgnMab",12) == 1296940689) strcat(s, "s");
if (crc32("UbLiH",5) == 306636230) strcat(s, "t");
if (crc32("ucRDoYnpgsxXWw",14) == 1765770400) strcat(s, "X");
if (crc32("HktyOjCFVKsPwKL",15) == 885946025) strcat(s, "e");
if (crc32("idHsHxYunIDKe",13) == 3498387679) strcat(s, "d");
if (crc32("cxMTumJhaYqsr",13) == 995346341) strcat(s, "r");
if (crc32("hGuTMPAzI",9) == 3207254397) strcat(s, "b");
if (crc32("PaMenTDjn",9) == 3575235610) strcat(s, "i");
if (crc32("PpLXgeQhue",10) == 1884854453) strcat(s, "h");
if (crc32("JxkyGSTb",8) == 2170260078) strcat(s, "a");
if (crc32("jKechDzmsetgBTi",15) == 1441515989) strcat(s, "l");
if (crc32("jWaQXoeVZvBMn",13) == 541651870) strcat(s, "D");
if (crc32("gAyxGzc",7) == 965625034) strcat(s, "l");
if (crc32("GMChE",5) == 2629932173) strcat(s, "y");
    return s;
}

char *rightmindedly_adverbs() {
    char *s = calloc(14);
    if (crc32("ruvHoVIzbd",10) == 4118102881) strcat(s, "U");
if (crc32("gxMxLJJrfxK",11) == 322001858) strcat(s, "r");
if (crc32("bYiQHYAV",8) == 2660279551) strcat(s, "D");
if (crc32("deukaRArI",9) == 99219119) strcat(s, "i");
if (crc32("PgnTldFoNrP",11) == 1088489020) strcat(s, "R");
if (crc32("AuGlrkQzrXkbuwD",15) == 1465644727) strcat(s, "g");
if (crc32("tbkNMbinZqTPml",14) == 1240864075) strcat(s, "h");
if (crc32("skGVjlhS",8) == 3671287740) strcat(s, "h");
if (crc32("LtdIeCEr",8) == 2291143807) strcat(s, "t");
if (crc32("rKrsHIzygDxoRNu",15) == 51764171) strcat(s, "x");
if (crc32("DxrsDVlPxVPF",12) == 2122981395) strcat(s, "m");
if (crc32("ZZYDr",5) == 105715721) strcat(s, "D");
if (crc32("tlPgpTo",7) == 867461343) strcat(s, "i");
if (crc32("DhXgWqTIHEQd",12) == 652783736) strcat(s, "n");
if (crc32("EqINxOoCixpREl",14) == 1873688917) strcat(s, "o");
if (crc32("JGqWIUPutUzW",12) == 2235343278) strcat(s, "d");
if (crc32("BDjzXJ",6) == 3082252670) strcat(s, "e");
if (crc32("nEEAOmIkpLxgHg",14) == 1793302711) strcat(s, "d");
if (crc32("POpBJxOmgfpjg",13) == 1779068386) strcat(s, "o");
if (crc32("joEdok",6) == 3638454600) strcat(s, "l");
if (crc32("GXxRadet",8) == 1020014885) strcat(s, "f");
if (crc32("zIkQyGDIErzCIsJ",15) == 3697600845) strcat(s, "y");
    return s;
}

char *quasiautomatically_adverbs() {
    char *s = calloc(19);
    if (crc32("ZnolLd",6) == 3514657260) strcat(s, "o");
if (crc32("xwqSUAdrL",9) == 889472764) strcat(s, "q");
if (crc32("eErXRuCbmeaaIg",14) == 316605539) strcat(s, "u");
if (crc32("mZxxy",5) == 1990311461) strcat(s, "Z");
if (crc32("HbxgeUAchNnkz",13) == 2591997946) strcat(s, "a");
if (crc32("EdTwL",5) == 2530485398) strcat(s, "s");
if (crc32("sonkBATu",8) == 1491220418) strcat(s, "i");
if (crc32("CrZziWls",8) == 3993002565) strcat(s, "x");
if (crc32("pjBzGQQIjXFF",12) == 692435749) strcat(s, "a");
if (crc32("mifkHoULU",9) == 516823725) strcat(s, "W");
if (crc32("UwWwfvqSpiukCx",14) == 83916558) strcat(s, "u");
if (crc32("hARaT",5) == 856736028) strcat(s, "t");
if (crc32("wnGVvYPnkTTroS",14) == 2034826311) strcat(s, "o");
if (crc32("rCFvnwX",7) == 4023918468) strcat(s, "N");
if (crc32("tpOxsM",6) == 1296656416) strcat(s, "m");
if (crc32("MrhWIxhGGDMSjh",14) == 1928978851) strcat(s, "m");
if (crc32("UKrSmQbpJ",9) == 3147849850) strcat(s, "a");
if (crc32("zBjcFy",6) == 2830681896) strcat(s, "t");
if (crc32("jYRodm",6) == 1035196503) strcat(s, "i");
if (crc32("wJHhWuaI",8) == 952245622) strcat(s, "b");
if (crc32("HMIwdmT",7) == 164543540) strcat(s, "c");
if (crc32("IRHdGyB",7) == 1244624660) strcat(s, "T");
if (crc32("TGhqTDwzo",9) == 307111623) strcat(s, "a");
if (crc32("JyIHsr",6) == 1997408291) strcat(s, "z");
if (crc32("KpurZqqyCJii",12) == 3297492081) strcat(s, "l");
if (crc32("uBOeh",5) == 3861427297) strcat(s, "l");
if (crc32("dytgAPdM",8) == 3429423249) strcat(s, "d");
if (crc32("qQnuVW",6) == 3840052658) strcat(s, "y");
    return s;
}

char *semiarticulately_adverbs() {
    char *s = calloc(17);
    if (crc32("FgxyBgUSrmnyBGg",15) == 838688029) strcat(s, "s");
if (crc32("WQkMPvUMAeoJ",12) == 1145663755) strcat(s, "u");
if (crc32("aCNuvvIJjudfySg",15) == 3528883479) strcat(s, "e");
if (crc32("LlZDWTVK",8) == 1742743807) strcat(s, "m");
if (crc32("pxjGohe",7) == 2299437075) strcat(s, "J");
if (crc32("DrtoTe",6) == 3804294183) strcat(s, "i");
if (crc32("DZrIEZXhfyuRA",13) == 3974044760) strcat(s, "H");
if (crc32("zkmnmvZCTCso",12) == 4015640467) strcat(s, "a");
if (crc32("eDldpLAU",8) == 650390438) strcat(s, "j");
if (crc32("LxmjvQFkuJ",10) == 2934654702) strcat(s, "r");
if (crc32("TECVPUuhNKOvwJ",14) == 1647131601) strcat(s, "r");
if (crc32("PFfOCvotWuLrvk",14) == 2345988821) strcat(s, "t");
if (crc32("dznNQdSQ",8) == 3571156923) strcat(s, "v");
if (crc32("XFhfslGRXFpc",12) == 763038765) strcat(s, "i");
if (crc32("kyFjFP",6) == 3893938656) strcat(s, "n");
if (crc32("QJwVjiVAUQ",10) == 1638076007) strcat(s, "c");
if (crc32("ukwXoXALNon",11) == 1368745340) strcat(s, "w");
if (crc32("QfTSzaUuzlfHyRd",15) == 237742206) strcat(s, "u");
if (crc32("SGovKq",6) == 3058944506) strcat(s, "Q");
if (crc32("Qrzgwkb",7) == 1069312686) strcat(s, "l");
if (crc32("LXRYyV",6) == 1669758913) strcat(s, "u");
if (crc32("fiPbtRaURqAohQE",15) == 1821101052) strcat(s, "a");
if (crc32("zYajha",6) == 2134068303) strcat(s, "t");
if (crc32("QDJdBE",6) == 631678293) strcat(s, "t");
if (crc32("imvhzMScUm",10) == 3691931700) strcat(s, "e");
if (crc32("azXXNVEhwP",10) == 1304550645) strcat(s, "l");
if (crc32("zUjnoAsQdXdGtRc",15) == 4169833526) strcat(s, "y");
    return s;
}

char *facetoface_adverbs() {
    char *s = calloc(11);
    if (crc32("sPqWVMXYwUIVUmV",15) == 1359459368) strcat(s, "n");
if (crc32("aYkzarCsIbRw",12) == 1022419759) strcat(s, "f");
if (crc32("bMXMDtPd",8) == 2953549640) strcat(s, "r");
if (crc32("lfpbvaveKfqryEM",15) == 2868707084) strcat(s, "a");
if (crc32("KlNRumhVXIsbCCq",15) == 2794316413) strcat(s, "e");
if (crc32("NtKuHfiqOEL",11) == 3475430739) strcat(s, "c");
if (crc32("jDvMSWCyxZcyD",13) == 2421399763) strcat(s, "e");
if (crc32("mEvODbYB",8) == 2477328156) strcat(s, "t");
if (crc32("vNdJUMY",7) == 1994965312) strcat(s, "q");
if (crc32("hRbvoaY",7) == 3826225350) strcat(s, "o");
if (crc32("RjIXJZiWigyWZj",14) == 1689194046) strcat(s, "v");
if (crc32("dYgwrMgioQUaf",13) == 3659686288) strcat(s, "f");
if (crc32("tIWHERdfs",9) == 1016045506) strcat(s, "a");
if (crc32("FyYUdsRcyHnBbw",14) == 1700183250) strcat(s, "e");
if (crc32("XysceERvkVXvp",13) == 3992799804) strcat(s, "c");
if (crc32("leQRKP",6) == 1611991675) strcat(s, "I");
if (crc32("FoipaEAPs",9) == 1563538452) strcat(s, "e");
    return s;
}

char *nonprimitively_adverbs() {
    char *s = calloc(15);
    if (crc32("PnJvwWtGJQKWlh",14) == 1627463919) strcat(s, "n");
if (crc32("UuTOfajjQFnVp",13) == 1957987190) strcat(s, "G");
if (crc32("TJKFZhKUyvwfSP",14) == 1101340346) strcat(s, "o");
if (crc32("bAMvaDhOrNiHF",13) == 928087953) strcat(s, "w");
if (crc32("ixtqlllNHEviozl",15) == 583817418) strcat(s, "n");
if (crc32("jUbbiZ",6) == 4267376033) strcat(s, "y");
if (crc32("rTPRcBXolLjOrE",14) == 3900580916) strcat(s, "p");
if (crc32("tMzQp",5) == 164479325) strcat(s, "r");
if (crc32("RvwaAzmfkfo",11) == 2776887695) strcat(s, "i");
if (crc32("OwPGE",5) == 1380188637) strcat(s, "v");
if (crc32("VrmQEDMLUdPBkL",14) == 1615374573) strcat(s, "m");
if (crc32("fARzaMMXwumOa",13) == 3990102996) strcat(s, "i");
if (crc32("DpscjqiEAX",10) == 2457202499) strcat(s, "R");
if (crc32("LLYwxlgMRJ",10) == 1200106130) strcat(s, "t");
if (crc32("XZxyVOtoPzGuAIl",15) == 1248618611) strcat(s, "i");
if (crc32("HFjyKmkZXKaZIJg",15) == 2901537208) strcat(s, "E");
if (crc32("eYGnLBcETzyDT",13) == 1372645913) strcat(s, "v");
if (crc32("NgVWLJSVk",9) == 173872765) strcat(s, "J");
if (crc32("lVSBqQ",6) == 4182344926) strcat(s, "e");
if (crc32("KzymoLdSray",11) == 3662631528) strcat(s, "l");
if (crc32("UjXSuwC",7) == 1235502260) strcat(s, "y");
    return s;
}

char *wholeheartedly_adverbs() {
    char *s = calloc(15);
    if (crc32("teizQM",6) == 2124223758) strcat(s, "T");
if (crc32("KPUmn",5) == 841098249) strcat(s, "w");
if (crc32("EDPnipSp",8) == 1306209315) strcat(s, "h");
if (crc32("UMTrAzx",7) == 599690986) strcat(s, "z");
if (crc32("cbPKSvKbuiJjDR",14) == 1353365980) strcat(s, "o");
if (crc32("ZdIMKfRjepR",11) == 2208101579) strcat(s, "l");
if (crc32("aWnaIWqh",8) == 4078900989) strcat(s, "e");
if (crc32("KrfCDv",6) == 1859753657) strcat(s, "N");
if (crc32("LBWfwnfdNgPimD",14) == 1296334385) strcat(s, "h");
if (crc32("VZxsvfNgMQiY",12) == 547576335) strcat(s, "e");
if (crc32("mbFWywHHO",9) == 1306260088) strcat(s, "a");
if (crc32("DkRwgQvsSox",11) == 2327476436) strcat(s, "r");
if (crc32("njgTWJnLEhmBSK",14) == 1440787510) strcat(s, "Z");
if (crc32("juvnJnTmtuLijys",15) == 848421769) strcat(s, "t");
if (crc32("rwZdYnYc",8) == 682700224) strcat(s, "e");
if (crc32("XuPGGAYCvIqzbq",14) == 1502285595) strcat(s, "d");
if (crc32("uzYpSQ",6) == 910262834) strcat(s, "l");
if (crc32("InwoYgyhnlkD",12) == 1974679798) strcat(s, "t");
if (crc32("JmroYkaaTEN",11) == 680454878) strcat(s, "y");
    return s;
}

char *anytime_adverbs() {
    char *s = calloc(8);
    if (crc32("WwSTTMCeylvIMPe",15) == 609908069) strcat(s, "J");
if (crc32("golTgl",6) == 3417071641) strcat(s, "a");
if (crc32("XnfZMTtf",8) == 2033141148) strcat(s, "n");
if (crc32("BhHBLcgn",8) == 3840698770) strcat(s, "T");
if (crc32("ugROylrYW",9) == 2154180544) strcat(s, "y");
if (crc32("AkRWKBJqMYgsycr",15) == 2417073078) strcat(s, "d");
if (crc32("tpEeoeZHCXYRda",14) == 4150474194) strcat(s, "t");
if (crc32("eEnyRvMNvymcqPt",15) == 3063357389) strcat(s, "W");
if (crc32("ITSClZRa",8) == 3015712270) strcat(s, "i");
if (crc32("oyjYoPwCSjRmU",13) == 346983434) strcat(s, "K");
if (crc32("GLgshMDBOhv",11) == 4074416868) strcat(s, "m");
if (crc32("eFWZXWVLTdz",11) == 3064057180) strcat(s, "e");
    return s;
}

char *overtenderly_adverbs() {
    char *s = calloc(13);
    if (crc32("CHNnWxdMzmDePhT",15) == 2684270161) strcat(s, "b");
if (crc32("JbKPTt",6) == 1441099901) strcat(s, "o");
if (crc32("MbyoTNhXoncA",12) == 331091351) strcat(s, "v");
if (crc32("NBgKeAyEm",9) == 1336892652) strcat(s, "p");
if (crc32("GVDxq",5) == 1977660530) strcat(s, "e");
if (crc32("qQOJzfxU",8) == 3624465882) strcat(s, "r");
if (crc32("xehaPdOKUZRO",12) == 4191987596) strcat(s, "t");
if (crc32("dbCZrNf",7) == 2165624414) strcat(s, "e");
if (crc32("LZxQYQ",6) == 715892405) strcat(s, "S");
if (crc32("udigieoAlicxq",13) == 3673288923) strcat(s, "n");
if (crc32("eGHBy",5) == 70014915) strcat(s, "d");
if (crc32("ecMTaNQzzo",10) == 3074301122) strcat(s, "B");
if (crc32("JsmHkQbSfHK",11) == 4103592988) strcat(s, "e");
if (crc32("lpaHVCTIVnDxJj",14) == 1413561436) strcat(s, "r");
if (crc32("DtOXuLzM",8) == 3342852642) strcat(s, "p");
if (crc32("ifChjm",6) == 3946810975) strcat(s, "l");
if (crc32("qtnWx",5) == 3742438421) strcat(s, "y");
if (crc32("rzjsEn",6) == 1633862518) strcat(s, "y");
    return s;
}

char *epochally_adverbs() {
    char *s = calloc(10);
    if (crc32("ujvvRFmXeQUuGCX",15) == 2355289853) strcat(s, "e");
if (crc32("IquFDsUfT",9) == 1924948589) strcat(s, "p");
if (crc32("XBHCZ",5) == 1624045068) strcat(s, "U");
if (crc32("PuXIQApoZza",11) == 2843627320) strcat(s, "o");
if (crc32("bjSkwWcNMleCqAR",15) == 3766755052) strcat(s, "c");
if (crc32("GLFKCdHGTitlUXL",15) == 2197051109) strcat(s, "h");
if (crc32("fIPjuIDjXed",11) == 2165492875) strcat(s, "t");
if (crc32("LbwrIiwmPgMxsXN",15) == 3896394743) strcat(s, "a");
if (crc32("izaLWQ",6) == 1054296428) strcat(s, "l");
if (crc32("IwRuvpbvQQKO",12) == 3379328319) strcat(s, "I");
if (crc32("RrUMsZFbpI",10) == 2451704867) strcat(s, "l");
if (crc32("OOgRUv",6) == 2682027657) strcat(s, "r");
if (crc32("pejxNIiqCYr",11) == 3372216293) strcat(s, "y");
    return s;
}

char *humorously_adverbs() {
    char *s = calloc(11);
    if (crc32("qMBkVPflQ",9) == 3350984416) strcat(s, "H");
if (crc32("NDJGGGHqx",9) == 1439406547) strcat(s, "h");
if (crc32("UiFOZxJDUKksogL",15) == 3570917131) strcat(s, "z");
if (crc32("VumDk",5) == 602601338) strcat(s, "u");
if (crc32("oCYKkhg",7) == 708368547) strcat(s, "m");
if (crc32("LRkmo",5) == 1945749662) strcat(s, "o");
if (crc32("KoaDj",5) == 4196653632) strcat(s, "r");
if (crc32("QKgaF",5) == 562408892) strcat(s, "o");
if (crc32("qCXCUTNRKy",10) == 2638675515) strcat(s, "n");
if (crc32("fsNXewvEVTciCCe",15) == 1344405052) strcat(s, "u");
if (crc32("UeIFw",5) == 3608315986) strcat(s, "c");
if (crc32("QUAEbymkOQ",10) == 689966284) strcat(s, "s");
if (crc32("pOZFqsStmqq",11) == 4294232318) strcat(s, "l");
if (crc32("TSYAwvpp",8) == 835681716) strcat(s, "y");
    return s;
}

char *unpolemically_adverbs() {
    char *s = calloc(14);
    if (crc32("wxQrgRbjYpYcwcS",15) == 1737728765) strcat(s, "w");
if (crc32("GTtuSIYe",8) == 3224607896) strcat(s, "u");
if (crc32("DHzjgRnT",8) == 2560331659) strcat(s, "n");
if (crc32("pNAXj",5) == 2838190723) strcat(s, "L");
if (crc32("EmIhZzSFq",9) == 2502751299) strcat(s, "p");
if (crc32("dpVST",5) == 613453618) strcat(s, "N");
if (crc32("lBpxBR",6) == 2586894720) strcat(s, "o");
if (crc32("COYXJmRBzhqAZi",14) == 3300267002) strcat(s, "W");
if (crc32("BXoZnHjRi",9) == 3242512867) strcat(s, "l");
if (crc32("nmYHnZtIttp",11) == 3184127412) strcat(s, "e");
if (crc32("gCUokvEvXDIwW",13) == 2606904378) strcat(s, "m");
if (crc32("JSnxdFHXTNtY",12) == 258576184) strcat(s, "O");
if (crc32("drPYofSm",8) == 4268971730) strcat(s, "i");
if (crc32("BtZcSyoavv",10) == 2309512721) strcat(s, "o");
if (crc32("ezteFAdteh",10) == 1083202809) strcat(s, "c");
if (crc32("kEoAL",5) == 3707037241) strcat(s, "P");
if (crc32("mpYqWon",7) == 3140720347) strcat(s, "a");
if (crc32("qcvXnHqSuUaTNeC",15) == 1994538240) strcat(s, "s");
if (crc32("ODHyf",5) == 743583045) strcat(s, "l");
if (crc32("jGBDTLokZLhzoY",14) == 2591405606) strcat(s, "l");
if (crc32("SuhVhy",6) == 414454172) strcat(s, "y");
    return s;
}

char *wrongheadedly_adverbs() {
    char *s = calloc(14);
    if (crc32("HOPbRfcccVuiwhs",15) == 3989695823) strcat(s, "w");
if (crc32("GFFfxKwkR",9) == 2628251031) strcat(s, "r");
if (crc32("XBdGFVgix",9) == 3073599904) strcat(s, "r");
if (crc32("cAvlJPBvRlMeWOf",15) == 2783170427) strcat(s, "o");
if (crc32("xxDxDroV",8) == 2922518756) strcat(s, "N");
if (crc32("XRrahEKUiSFAS",13) == 2865926027) strcat(s, "n");
if (crc32("nNorkxQqqLD",11) == 1149751951) strcat(s, "g");
if (crc32("JTdqmeHjkid",11) == 3133698398) strcat(s, "h");
if (crc32("JXIrgrPAkIU",11) == 621473078) strcat(s, "G");
if (crc32("WNuoguoNovS",11) == 3025471869) strcat(s, "e");
if (crc32("uHjSIc",6) == 1305439609) strcat(s, "a");
if (crc32("YKCDy",5) == 244628161) strcat(s, "d");
if (crc32("hldcXfwSxWRNv",13) == 4144380438) strcat(s, "d");
if (crc32("gCECUVnjVTv",11) == 1820353745) strcat(s, "v");
if (crc32("dQHDk",5) == 3923615998) strcat(s, "e");
if (crc32("ARgSQCc",7) == 2926406653) strcat(s, "d");
if (crc32("FFFyDGdaXGjHIO",14) == 526797947) strcat(s, "n");
if (crc32("OiDnT",5) == 3125049044) strcat(s, "l");
if (crc32("zTbaNjh",7) == 2222744636) strcat(s, "y");
    return s;
}

char *epidemiologically_adverbs() {
    char *s = calloc(18);
    if (crc32("gPcWDPzWz",9) == 1523198510) strcat(s, "e");
if (crc32("TADfpbkMEfOzI",13) == 2696627789) strcat(s, "p");
if (crc32("mOZZvAcGB",9) == 446757246) strcat(s, "S");
if (crc32("YKNHBTypg",9) == 2057696787) strcat(s, "i");
if (crc32("rgySghmYCqHQk",13) == 1865389395) strcat(s, "d");
if (crc32("hiHsfsieANuh",12) == 1188949930) strcat(s, "U");
if (crc32("ZZeaZ",5) == 2843026550) strcat(s, "e");
if (crc32("FMJItkNr",8) == 1999409176) strcat(s, "P");
if (crc32("mQRKokQyRdB",11) == 1957727959) strcat(s, "m");
if (crc32("VXSiQCHBzLIi",12) == 2374830382) strcat(s, "i");
if (crc32("MBMfY",5) == 235847857) strcat(s, "o");
if (crc32("yXqDeoRwX",9) == 3128805879) strcat(s, "l");
if (crc32("kJjJtJkj",8) == 30023824) strcat(s, "o");
if (crc32("CAYVSIdknXrwF",13) == 4001576326) strcat(s, "G");
if (crc32("HEKEBjajsr",10) == 1979174193) strcat(s, "g");
if (crc32("wxPiz",5) == 1258825165) strcat(s, "i");
if (crc32("oKIrcnw",7) == 1851169853) strcat(s, "c");
if (crc32("UlXXvVGGFtiVqCD",15) == 2899809743) strcat(s, "a");
if (crc32("RjpFZ",5) == 4235240985) strcat(s, "h");
if (crc32("BZeRYnaaKETN",12) == 3575379427) strcat(s, "l");
if (crc32("QlDYBMhYGvkqHJ",14) == 65698760) strcat(s, "g");
if (crc32("aqzmBwxnYfoVrkH",15) == 1293181473) strcat(s, "l");
if (crc32("EwdRA",5) == 3940530418) strcat(s, "K");
if (crc32("XEqIUOnZuRGz",12) == 1592700456) strcat(s, "y");
    return s;
}

char *unignominiously_adverbs() {
    char *s = calloc(16);
    if (crc32("gmVPeF",6) == 341866624) strcat(s, "o");
if (crc32("LXRZWORzEatpj",13) == 2793696480) strcat(s, "u");
if (crc32("RehvDlWXh",9) == 3288305646) strcat(s, "n");
if (crc32("zHjoiNSlS",9) == 1705103676) strcat(s, "b");
if (crc32("rrztvXvJRWpI",12) == 3292224403) strcat(s, "i");
if (crc32("vOiAxQtvW",9) == 715568941) strcat(s, "g");
if (crc32("dyNweOqpeamxBC",14) == 2412283215) strcat(s, "n");
if (crc32("AGtSMVw",7) == 3667745984) strcat(s, "H");
if (crc32("HvekqkE",7) == 1602914199) strcat(s, "o");
if (crc32("QGiYAday",8) == 1588812596) strcat(s, "m");
if (crc32("qGTUxPWisE",10) == 4073164931) strcat(s, "w");
if (crc32("gKqPuZHozLfWIvC",15) == 2405894566) strcat(s, "i");
if (crc32("GBfIZdsNJdN",11) == 3208541820) strcat(s, "E");
if (crc32("QZpoKuK",7) == 3771033340) strcat(s, "n");
if (crc32("NXjevUXgqhFWPl",14) == 2696496988) strcat(s, "i");
if (crc32("UFDUcyCCiC",10) == 1180353952) strcat(s, "A");
if (crc32("KjfBHaT",7) == 990499817) strcat(s, "o");
if (crc32("NSEXL",5) == 2197824693) strcat(s, "u");
if (crc32("kiXeyFWpMNIw",12) == 898008578) strcat(s, "s");
if (crc32("hHkGYNU",7) == 948543978) strcat(s, "l");
if (crc32("QNZmFRTzFUBX",12) == 2054801924) strcat(s, "u");
if (crc32("hERQyat",7) == 996937299) strcat(s, "y");
    return s;
}

char *rancorously_adverbs() {
    char *s = calloc(12);
    if (crc32("XHoUITbZ",8) == 3431518500) strcat(s, "r");
if (crc32("WCPSFH",6) == 3301508383) strcat(s, "a");
if (crc32("PWzrAQgqYu",10) == 1652208238) strcat(s, "u");
if (crc32("gXoXzyrTjZM",11) == 327380190) strcat(s, "n");
if (crc32("WfDScV",6) == 7309351) strcat(s, "c");
if (crc32("tRMoWnWMKdnm",12) == 1793152184) strcat(s, "o");
if (crc32("kKurJYxivqfYLax",15) == 1795351634) strcat(s, "r");
if (crc32("bAAQMnQamdeMLcq",15) == 3698868154) strcat(s, "o");
if (crc32("cxtuaurRlPB",11) == 4182534557) strcat(s, "u");
if (crc32("zdNzmDHdsuCfBY",14) == 1763128939) strcat(s, "s");
if (crc32("uCrsRoLWCJjrxnD",15) == 1112305603) strcat(s, "f");
if (crc32("WmIOlWrmHr",10) == 1667790433) strcat(s, "l");
if (crc32("hUyMn",5) == 659430089) strcat(s, "y");
    return s;
}

char *sumptuously_adverbs() {
    char *s = calloc(12);
    if (crc32("WWwHTjVrnVoHa",13) == 2291833294) strcat(s, "s");
if (crc32("CiCxLVHCGbCUQR",14) == 462204551) strcat(s, "W");
if (crc32("bdpTYlid",8) == 1200386896) strcat(s, "u");
if (crc32("lVFsesdNYr",10) == 3859974093) strcat(s, "m");
if (crc32("netUhcnCXVLgq",13) == 603402381) strcat(s, "p");
if (crc32("UmGkhnMpRP",10) == 3699997224) strcat(s, "X");
if (crc32("jIoeIRmW",8) == 4052888278) strcat(s, "t");
if (crc32("hIJolIpDCKnkj",13) == 738250436) strcat(s, "u");
if (crc32("SsyIgRxQXSKsM",13) == 3818748207) strcat(s, "z");
if (crc32("ifWdJVVitd",10) == 1885833160) strcat(s, "o");
if (crc32("nXcQsHXxSH",10) == 4199558470) strcat(s, "t");
if (crc32("kJPUA",5) == 1992490943) strcat(s, "u");
if (crc32("uDhDXbOu",8) == 1785105459) strcat(s, "s");
if (crc32("YpRmHwGpvUwGeae",15) == 4264043768) strcat(s, "U");
if (crc32("ruDrcmecFNDTgt",14) == 1630964024) strcat(s, "l");
if (crc32("nkitQQICEmV",11) == 583008634) strcat(s, "y");
    return s;
}

char *undelectably_adverbs() {
    char *s = calloc(13);
    if (crc32("oLiLZmLDfmcNNf",14) == 2930982969) strcat(s, "u");
if (crc32("MomuMDfCZ",9) == 3644109714) strcat(s, "n");
if (crc32("HlzarBsIQtD",11) == 2207178471) strcat(s, "d");
if (crc32("LrOHk",5) == 1654391361) strcat(s, "J");
if (crc32("qWmGLpEzw",9) == 1037173002) strcat(s, "e");
if (crc32("CggHGiR",7) == 3426955140) strcat(s, "l");
if (crc32("rUqgOaIRsW",10) == 628965312) strcat(s, "e");
if (crc32("nsEQbipnDiyI",12) == 3280058889) strcat(s, "c");
if (crc32("BRygwpzTG",9) == 383108498) strcat(s, "e");
if (crc32("djXJzndc",8) == 2134544482) strcat(s, "t");
if (crc32("XMaYUXjdFXyPS",13) == 3996960310) strcat(s, "a");
if (crc32("WsIIg",5) == 3099417932) strcat(s, "b");
if (crc32("CFliwjs",7) == 3204708124) strcat(s, "x");
if (crc32("vzEsx",5) == 2561621658) strcat(s, "l");
if (crc32("lYeSyEQQtqjf",12) == 2371502206) strcat(s, "G");
if (crc32("QnSpGrNify",10) == 2713757787) strcat(s, "y");
    return s;
}

char *intrudingly_adverbs() {
    char *s = calloc(12);
    if (crc32("iRsnAYkq",8) == 3365034497) strcat(s, "p");
if (crc32("CnnBklRXFgHgFJg",15) == 1343767135) strcat(s, "i");
if (crc32("OdZirdqeVwzamhd",15) == 2814721998) strcat(s, "n");
if (crc32("uRfFARBWVzVk",12) == 2394957695) strcat(s, "n");
if (crc32("CIdvzzn",7) == 3296916822) strcat(s, "t");
if (crc32("SVtCF",5) == 1088694935) strcat(s, "r");
if (crc32("Mbtljr",6) == 1702824590) strcat(s, "u");
if (crc32("HKRLVOhCQM",10) == 1814012000) strcat(s, "b");
if (crc32("pDirHlvLyNqItar",15) == 1833940355) strcat(s, "d");
if (crc32("HHwzOGdcFKH",11) == 3650172268) strcat(s, "i");
if (crc32("IXfruRv",7) == 414699216) strcat(s, "n");
if (crc32("kyONcorShCyh",12) == 2362613859) strcat(s, "E");
if (crc32("aoVzgyb",7) == 3926343773) strcat(s, "g");
if (crc32("INfWxdICzS",10) == 1597114801) strcat(s, "l");
if (crc32("LgsMHKg",7) == 2619058663) strcat(s, "m");
if (crc32("CjgCgfRXbROe",12) == 2503259096) strcat(s, "y");
    return s;
}

char *kindlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("KwYcwtv",7) == 144955233) strcat(s, "H");
if (crc32("knhXTW",6) == 1108765685) strcat(s, "k");
if (crc32("sGwpWVeyCiHKI",13) == 3974156639) strcat(s, "r");
if (crc32("JcwDDTNsLmu",11) == 1812675539) strcat(s, "i");
if (crc32("wBnZYNCt",8) == 272880625) strcat(s, "n");
if (crc32("OAuDQPLxZIwi",12) == 1180329593) strcat(s, "p");
if (crc32("dSMUy",5) == 3850369222) strcat(s, "d");
if (crc32("aYrsDsWv",8) == 971760388) strcat(s, "l");
if (crc32("qvchdHGKMCyRKT",14) == 2064810890) strcat(s, "e");
if (crc32("rjTBu",5) == 2554232205) strcat(s, "s");
if (crc32("uJsJhZNA",8) == 243544618) strcat(s, "s");
if (crc32("ZzYcdHF",7) == 1143074851) strcat(s, "l");
if (crc32("BmYCXrMpJfaMm",13) == 686316016) strcat(s, "y");
    return s;
}

char *bitterly_adverbs() {
    char *s = calloc(9);
    if (crc32("aCybgwEFgUXBfwn",15) == 1397338154) strcat(s, "b");
if (crc32("kaMEvvrMsjvfGH",14) == 3769256078) strcat(s, "i");
if (crc32("xCApnBskuch",11) == 2879206746) strcat(s, "t");
if (crc32("jlJqtGgcoB",10) == 2179837276) strcat(s, "t");
if (crc32("oHlyQAQHgUSMFac",15) == 300094251) strcat(s, "e");
if (crc32("ufEEOjBRtGtrbu",14) == 3646714581) strcat(s, "r");
if (crc32("EoxZrAZ",7) == 709232247) strcat(s, "l");
if (crc32("FMkfWfPPH",9) == 291765983) strcat(s, "D");
if (crc32("QVVAsoZQq",9) == 2899723533) strcat(s, "y");
    return s;
}

char *fetidly_adverbs() {
    char *s = calloc(8);
    if (crc32("RyzfpEWXQOtAri",14) == 3492130260) strcat(s, "f");
if (crc32("iPfaVCrFZKr",11) == 4064017067) strcat(s, "e");
if (crc32("BwMvTXZJNjPo",12) == 2085431692) strcat(s, "H");
if (crc32("RYxnseygaanRqr",14) == 347448241) strcat(s, "t");
if (crc32("fsDgYTTLplDdvx",14) == 3742783548) strcat(s, "z");
if (crc32("fLWPcBMAThFhAj",14) == 2860374970) strcat(s, "i");
if (crc32("gnbhAoJpBOLPa",13) == 3480908794) strcat(s, "D");
if (crc32("HkCHjVrHHeL",11) == 44442950) strcat(s, "d");
if (crc32("pqUhDsYhddjWzM",14) == 2704578693) strcat(s, "l");
if (crc32("ZQMaLgCOvoMaKn",14) == 989322345) strcat(s, "x");
if (crc32("GjncDzeNHcCTaB",14) == 2355894194) strcat(s, "y");
    return s;
}

char *superexcrescently_adverbs() {
    char *s = calloc(18);
    if (crc32("NODZpcka",8) == 3059071888) strcat(s, "r");
if (crc32("hXbnjuZQbzjnrUb",15) == 2969550359) strcat(s, "s");
if (crc32("mOSfLzUxYvNGylL",15) == 420453776) strcat(s, "n");
if (crc32("nkoPOJufW",9) == 885068674) strcat(s, "u");
if (crc32("aIGaTvRFrdM",11) == 167686303) strcat(s, "v");
if (crc32("KPkVirCyPZ",10) == 1969953208) strcat(s, "p");
if (crc32("aCCJyLLRo",9) == 3626192937) strcat(s, "e");
if (crc32("xJZgL",5) == 3486826487) strcat(s, "r");
if (crc32("BeWvWGlVPXv",11) == 1495652652) strcat(s, "X");
if (crc32("FNRWgSrYQAynGVm",15) == 4020226008) strcat(s, "e");
if (crc32("nCLmZmL",7) == 3196986553) strcat(s, "W");
if (crc32("tMSysqoJVIEJ",12) == 1181558205) strcat(s, "x");
if (crc32("dICVSJ",6) == 3919711162) strcat(s, "A");
if (crc32("ddaRyEZsLeG",11) == 2875422794) strcat(s, "c");
if (crc32("KUoIv",5) == 3464809869) strcat(s, "r");
if (crc32("QnLhjmZREnkb",12) == 841905137) strcat(s, "e");
if (crc32("YZXjtIgJ",8) == 3155341409) strcat(s, "s");
if (crc32("xbxSoeJzTxS",11) == 3424819112) strcat(s, "d");
if (crc32("ekPFURXZD",9) == 1159046307) strcat(s, "c");
if (crc32("zAEVFPKk",8) == 1227262471) strcat(s, "e");
if (crc32("wBmGtQwASfBPw",13) == 1287616923) strcat(s, "n");
if (crc32("sdPnssGgZ",9) == 1440339652) strcat(s, "z");
if (crc32("hMMYREjWNZ",10) == 63649804) strcat(s, "t");
if (crc32("uoOQSah",7) == 1285553962) strcat(s, "F");
if (crc32("VfODSxpWrGBESw",14) == 1677375914) strcat(s, "l");
if (crc32("NCHWjmeDTFGxy",13) == 276493712) strcat(s, "p");
if (crc32("erihMNKVB",9) == 928368912) strcat(s, "y");
    return s;
}

char *orally_adverbs() {
    char *s = calloc(7);
    if (crc32("jBZUplsAOl",10) == 217579489) strcat(s, "o");
if (crc32("igIgfApfoQqJKn",14) == 3999997636) strcat(s, "r");
if (crc32("WwIIHByFPlAw",12) == 2419445619) strcat(s, "c");
if (crc32("scaxdQR",7) == 2907603331) strcat(s, "a");
if (crc32("vMMWAlkSWGcyZqc",15) == 3519602077) strcat(s, "l");
if (crc32("iAvitKSgKRSC",12) == 1074774091) strcat(s, "l");
if (crc32("NUXQvrHJTZkctzE",15) == 2750978340) strcat(s, "y");
    return s;
}

char *unspatially_adverbs() {
    char *s = calloc(12);
    if (crc32("esfsfVgxdu",10) == 1652371638) strcat(s, "u");
if (crc32("ggnpLiKurMNabnL",15) == 492529523) strcat(s, "n");
if (crc32("WGkMkjZJJOQmLS",14) == 588421231) strcat(s, "Q");
if (crc32("DRxSD",5) == 2962259019) strcat(s, "s");
if (crc32("LcmEGsvWZJZpbE",14) == 1061391858) strcat(s, "p");
if (crc32("CjLGTb",6) == 854610537) strcat(s, "a");
if (crc32("uPACmft",7) == 2085205801) strcat(s, "P");
if (crc32("YAUnFCAqI",9) == 2293400964) strcat(s, "t");
if (crc32("HpmugTbxU",9) == 164469979) strcat(s, "p");
if (crc32("UUyDB",5) == 2649076052) strcat(s, "i");
if (crc32("VvfwWWi",7) == 1223679421) strcat(s, "a");
if (crc32("FLZmiy",6) == 2707906332) strcat(s, "s");
if (crc32("AvHldcFaz",9) == 2953696532) strcat(s, "l");
if (crc32("VcioQPTEi",9) == 2184438826) strcat(s, "n");
if (crc32("PzupW",5) == 1924755252) strcat(s, "l");
if (crc32("sZeitvZ",7) == 1529272571) strcat(s, "y");
    return s;
}

char *uniridescently_adverbs() {
    char *s = calloc(15);
    if (crc32("qKifDXpJiO",10) == 3489213850) strcat(s, "a");
if (crc32("UyNxLp",6) == 883154314) strcat(s, "u");
if (crc32("eNoamV",6) == 1983086091) strcat(s, "n");
if (crc32("HjtKOsdeBKu",11) == 120747789) strcat(s, "i");
if (crc32("SpKznM",6) == 1966587168) strcat(s, "m");
if (crc32("FPfoICGZZyNMdO",14) == 4192755026) strcat(s, "r");
if (crc32("dAYlOiMsKaag",12) == 4043703017) strcat(s, "i");
if (crc32("RXKeHPKbKUHGLof",15) == 1602682475) strcat(s, "d");
if (crc32("Gelnj",5) == 937265246) strcat(s, "e");
if (crc32("Qjhpc",5) == 1458486736) strcat(s, "X");
if (crc32("KeONRHb",7) == 3591749413) strcat(s, "s");
if (crc32("EYUqUFAcFjNLf",13) == 4113655305) strcat(s, "c");
if (crc32("CBJngmcOv",9) == 3731086552) strcat(s, "c");
if (crc32("IRNgPpcDfbPaMK",14) == 410214923) strcat(s, "P");
if (crc32("GJpnQZvTY",9) == 133068315) strcat(s, "e");
if (crc32("rpnNKCAWi",9) == 4262865555) strcat(s, "M");
if (crc32("msJtERagEHubq",13) == 2303476912) strcat(s, "n");
if (crc32("AzJHvYUgTzL",11) == 534387671) strcat(s, "t");
if (crc32("lMuRkN",6) == 1243842289) strcat(s, "l");
if (crc32("DCdTw",5) == 1726383785) strcat(s, "O");
if (crc32("BVUEkoHDcPFfOFr",15) == 1363560444) strcat(s, "y");
    return s;
}

char *edgingly_adverbs() {
    char *s = calloc(9);
    if (crc32("DosJoZjsFnE",11) == 2156523956) strcat(s, "i");
if (crc32("rmuQUwf",7) == 3198861959) strcat(s, "e");
if (crc32("rgNrTGzZSD",10) == 2526441051) strcat(s, "d");
if (crc32("OpHfOVhHlJOcFa",14) == 2423927910) strcat(s, "g");
if (crc32("ZxvmJEgxBWWQSB",14) == 3472845226) strcat(s, "S");
if (crc32("GnmmZOfsHZ",10) == 646992366) strcat(s, "i");
if (crc32("GhDVCHCCDQEpJip",15) == 1573503471) strcat(s, "H");
if (crc32("QrXPXIMT",8) == 129277381) strcat(s, "n");
if (crc32("YauRMVgEJVFQem",14) == 1353795920) strcat(s, "g");
if (crc32("FnJKNnu",7) == 3513832919) strcat(s, "P");
if (crc32("iAQTb",5) == 1639776730) strcat(s, "l");
if (crc32("DjMPXbxnOqp",11) == 3952249191) strcat(s, "y");
    return s;
}

char *discoverably_adverbs() {
    char *s = calloc(13);
    if (crc32("iBQpepYBiAax",12) == 2397097487) strcat(s, "d");
if (crc32("nmZzfqeLlzpiryk",15) == 1569107572) strcat(s, "i");
if (crc32("RWcXWQEzrKPMNrh",15) == 3704518580) strcat(s, "d");
if (crc32("toROqPU",7) == 163887169) strcat(s, "s");
if (crc32("GTeLvZZFZiSnc",13) == 2947853528) strcat(s, "e");
if (crc32("zoJEgOGkWhOkTi",14) == 4032289983) strcat(s, "c");
if (crc32("jxjraKws",8) == 2053654673) strcat(s, "r");
if (crc32("XNaWfecm",8) == 2479649423) strcat(s, "o");
if (crc32("ZPXDrzkv",8) == 1753239095) strcat(s, "v");
if (crc32("OStVCBFiqd",10) == 2173068124) strcat(s, "e");
if (crc32("cWXVNLjuxowkpr",14) == 3515813239) strcat(s, "d");
if (crc32("kJQOJRxkSlat",12) == 4151376930) strcat(s, "r");
if (crc32("zenfd",5) == 2736309041) strcat(s, "E");
if (crc32("EvOEAP",6) == 2951350243) strcat(s, "a");
if (crc32("cBBznGdu",8) == 2532474637) strcat(s, "b");
if (crc32("KdQVB",5) == 1141399800) strcat(s, "l");
if (crc32("hlqzIYAotEJtjx",14) == 88697269) strcat(s, "b");
if (crc32("grBZtLiiRPO",11) == 1426574188) strcat(s, "y");
    return s;
}

char *inerrable_adverbs() {
    char *s = calloc(10);
    if (crc32("YYsxfjfM",8) == 3184875684) strcat(s, "i");
if (crc32("nahcKArwsWDD",12) == 3799826888) strcat(s, "n");
if (crc32("DHERgsaaqL",10) == 3511960373) strcat(s, "I");
if (crc32("ZZSwJWdsBAJXg",13) == 605485923) strcat(s, "e");
if (crc32("TsjkzRQnaUstUB",14) == 3763329608) strcat(s, "r");
if (crc32("qsmqDz",6) == 2004146754) strcat(s, "r");
if (crc32("HnWxIN",6) == 3358357158) strcat(s, "a");
if (crc32("AGxELyYnpEqZq",13) == 2478252085) strcat(s, "Q");
if (crc32("bsHwJHVZlhrEn",13) == 3303323012) strcat(s, "b");
if (crc32("KvkHskmcxWLA",12) == 990334341) strcat(s, "l");
if (crc32("qvlWSwYIlfjo",12) == 3397724896) strcat(s, "x");
if (crc32("VtKsMsqmKfkm",12) == 849194112) strcat(s, "e");
    return s;
}

char *enrapturedly_adverbs() {
    char *s = calloc(13);
    if (crc32("ncfdZkYIHjRgDV",14) == 1750065310) strcat(s, "p");
if (crc32("vHTxuXygNzcpKU",14) == 2285818927) strcat(s, "e");
if (crc32("JGRyYstznckXvIJ",15) == 1380499492) strcat(s, "n");
if (crc32("dyaYxYZrluNTI",13) == 3341496586) strcat(s, "r");
if (crc32("QQJXMRlEU",9) == 1799583048) strcat(s, "L");
if (crc32("AdCJXyEYmLUS",12) == 518542523) strcat(s, "a");
if (crc32("LRNxTCEmvd",10) == 3382010721) strcat(s, "k");
if (crc32("TrbdETQU",8) == 2582215558) strcat(s, "p");
if (crc32("rWRHBzLHEOMjk",13) == 2584174819) strcat(s, "N");
if (crc32("AEEZazbaoOzrBJ",14) == 1600767474) strcat(s, "t");
if (crc32("exDFcoGRGT",10) == 989069766) strcat(s, "u");
if (crc32("lUiSRKw",7) == 1920425300) strcat(s, "r");
if (crc32("PlUZqXhJDBtWWL",14) == 3732959031) strcat(s, "e");
if (crc32("cLAXPmls",8) == 4291586307) strcat(s, "d");
if (crc32("nDwvF",5) == 2875376713) strcat(s, "u");
if (crc32("BbpKtqwm",8) == 3567379668) strcat(s, "l");
if (crc32("EdkdDJYDoqsEY",13) == 1456214405) strcat(s, "G");
if (crc32("kVqdOliYallo",12) == 3663452344) strcat(s, "y");
    return s;
}

char *hebdomadally_adverbs() {
    char *s = calloc(13);
    if (crc32("sbSbkIKynAXPgMj",15) == 2175222503) strcat(s, "q");
if (crc32("QqOZMfmg",8) == 482168350) strcat(s, "h");
if (crc32("VwAysWo",7) == 3213553692) strcat(s, "v");
if (crc32("NRjhngUi",8) == 2291256032) strcat(s, "e");
if (crc32("LNTECHje",8) == 1573561958) strcat(s, "b");
if (crc32("RltortFUF",9) == 1992806522) strcat(s, "p");
if (crc32("bfmCAudbZ",9) == 1265414707) strcat(s, "d");
if (crc32("xwJjgdLGQXBSUnM",15) == 1600267736) strcat(s, "D");
if (crc32("uCmllpUNj",9) == 4033841528) strcat(s, "o");
if (crc32("gPnSmfYenhaVQ",13) == 786101464) strcat(s, "Q");
if (crc32("RWsSHs",6) == 2624283028) strcat(s, "m");
if (crc32("QQXTNI",6) == 1703530014) strcat(s, "I");
if (crc32("AqNkTtVg",8) == 958053781) strcat(s, "a");
if (crc32("YmGSy",5) == 4160170291) strcat(s, "d");
if (crc32("DqRIPTZR",8) == 2170550655) strcat(s, "T");
if (crc32("likhph",6) == 2623734200) strcat(s, "a");
if (crc32("BymJsaOQTuRhY",13) == 3861069172) strcat(s, "c");
if (crc32("RZPmaNAVg",9) == 2013462350) strcat(s, "l");
if (crc32("TYfJDImtGeAekMA",15) == 25672971) strcat(s, "g");
if (crc32("zGXdNFcIeP",10) == 2263905581) strcat(s, "l");
if (crc32("JYwCj",5) == 1172905352) strcat(s, "y");
    return s;
}

char *potently_adverbs() {
    char *s = calloc(9);
    if (crc32("RlAuXa",6) == 2500034914) strcat(s, "p");
if (crc32("qlvqYanztDWAwa",14) == 94387122) strcat(s, "o");
if (crc32("RFaxdeibjqy",11) == 2485956190) strcat(s, "t");
if (crc32("JHFKVKrCCk",10) == 3784100291) strcat(s, "e");
if (crc32("yNhMZp",6) == 3970768415) strcat(s, "n");
if (crc32("rpEgO",5) == 2438413502) strcat(s, "t");
if (crc32("tkppnvRLMdqNg",13) == 3940866030) strcat(s, "t");
if (crc32("FEsACct",7) == 198319640) strcat(s, "I");
if (crc32("uCOcoY",6) == 2353708130) strcat(s, "l");
if (crc32("NSCVBwwRed",10) == 232191157) strcat(s, "y");
    return s;
}

char *akimbo_adverbs() {
    char *s = calloc(7);
    if (crc32("TxuvoxzkjaitAJ",14) == 497257349) strcat(s, "a");
if (crc32("UChIPUKzwnovo",13) == 128484180) strcat(s, "O");
if (crc32("UPJwOfCWVkmA",12) == 3668041206) strcat(s, "k");
if (crc32("oMTLPkoztIbuWCD",15) == 3075112077) strcat(s, "R");
if (crc32("fZzciV",6) == 1709738784) strcat(s, "i");
if (crc32("bCWwkgoLtvEkIP",14) == 4234802923) strcat(s, "m");
if (crc32("UTHQkFDuXCVY",12) == 304254368) strcat(s, "W");
if (crc32("gDrohfxkl",9) == 3731454717) strcat(s, "b");
if (crc32("JjTmQQOCJIYSz",13) == 3921833582) strcat(s, "S");
if (crc32("ELQTNQSlU",9) == 910340720) strcat(s, "o");
    return s;
}

char *dandiacally_adverbs() {
    char *s = calloc(12);
    if (crc32("izOWQtHbxxHnjL",14) == 2942514397) strcat(s, "d");
if (crc32("ZeSSrioJKjz",11) == 3202665621) strcat(s, "a");
if (crc32("eCLJBoGulwypYlV",15) == 2075897618) strcat(s, "n");
if (crc32("ZigAPVyclUTftSp",15) == 1734961411) strcat(s, "P");
if (crc32("yEHtsVl",7) == 3380999346) strcat(s, "d");
if (crc32("bwHLSTVscSQrPk",14) == 388687597) strcat(s, "i");
if (crc32("tsIBpTsiuTFq",12) == 2617517568) strcat(s, "y");
if (crc32("UmNMHSiQSmlL",12) == 112959675) strcat(s, "a");
if (crc32("dtzajkuRduKCpjn",15) == 171486155) strcat(s, "c");
if (crc32("wlKkPiCrs",9) == 1180165505) strcat(s, "n");
if (crc32("bbYyUyWNKuIG",12) == 3948355784) strcat(s, "a");
if (crc32("sbWBMbsIFkwxIZV",15) == 2689476850) strcat(s, "m");
if (crc32("IiKAw",5) == 2384694614) strcat(s, "l");
if (crc32("wtloyearYhmvow",14) == 3940686063) strcat(s, "H");
if (crc32("MCTsOCJE",8) == 918543917) strcat(s, "l");
if (crc32("qWCyNwIqJ",9) == 2338701273) strcat(s, "w");
if (crc32("dgVHTTtlQxrRQH",14) == 135490084) strcat(s, "y");
    return s;
}

char *dishearteningly_adverbs() {
    char *s = calloc(16);
    if (crc32("IFNqZD",6) == 1362840272) strcat(s, "d");
if (crc32("kZQbjRzutT",10) == 839221574) strcat(s, "i");
if (crc32("thbap",5) == 1397906026) strcat(s, "s");
if (crc32("oYCBoxJHTMPhJJe",15) == 3956239458) strcat(s, "h");
if (crc32("dyqlYpBwHG",10) == 3804111124) strcat(s, "Y");
if (crc32("aCfnBdeewrnu",12) == 2834734036) strcat(s, "e");
if (crc32("EFSVgKnWNrlSS",13) == 3270424006) strcat(s, "D");
if (crc32("WQHKvgEcPVZWz",13) == 3845273216) strcat(s, "a");
if (crc32("xcMyQBg",7) == 2774495949) strcat(s, "U");
if (crc32("NHCvbOLrDjicTn",14) == 61363346) strcat(s, "r");
if (crc32("wAjzQSQnolwe",12) == 2900721853) strcat(s, "S");
if (crc32("XHfnprYos",9) == 2139353956) strcat(s, "t");
if (crc32("EpwMsWFfzGmmbKD",15) == 4048283262) strcat(s, "e");
if (crc32("irfHaALvd",9) == 1041312338) strcat(s, "n");
if (crc32("CUlauZCfpkq",11) == 984061014) strcat(s, "i");
if (crc32("VDXRMKqkUbbPy",13) == 537502441) strcat(s, "n");
if (crc32("xGpqdgHHkPxM",12) == 3084880948) strcat(s, "l");
if (crc32("cfVywm",6) == 3488329679) strcat(s, "g");
if (crc32("ABSfxC",6) == 3207095217) strcat(s, "U");
if (crc32("WXwAn",5) == 1350471493) strcat(s, "l");
if (crc32("KnDiJaJxoiSh",12) == 1532367869) strcat(s, "y");
    return s;
}

char *unarticulately_adverbs() {
    char *s = calloc(15);
    if (crc32("upOVzSaZCrEnf",13) == 3951644482) strcat(s, "V");
if (crc32("vNifGPEnO",9) == 3551937959) strcat(s, "u");
if (crc32("oNKGQeLwofn",11) == 587868128) strcat(s, "t");
if (crc32("KQKenZJPpA",10) == 3140246452) strcat(s, "n");
if (crc32("QoBurLoE",8) == 3003233301) strcat(s, "u");
if (crc32("rjNVMVuEpeT",11) == 3432756751) strcat(s, "a");
if (crc32("VsrwouPnPiehmY",14) == 304599164) strcat(s, "r");
if (crc32("ZQgKtD",6) == 2939303069) strcat(s, "q");
if (crc32("RXSwZK",6) == 3518725898) strcat(s, "t");
if (crc32("kyIeNm",6) == 628844553) strcat(s, "k");
if (crc32("rvOaDCjD",8) == 3602559110) strcat(s, "i");
if (crc32("zHVnTBVFlCNQw",13) == 1100795944) strcat(s, "h");
if (crc32("CiayLHpcawFFiM",14) == 1514098147) strcat(s, "c");
if (crc32("XYvvsIPYNHNDXyD",15) == 449167000) strcat(s, "u");
if (crc32("qNDhVchL",8) == 1524563366) strcat(s, "l");
if (crc32("GcurObIPKhrHpRB",15) == 2781056707) strcat(s, "L");
if (crc32("oYzsYYluWY",10) == 662876942) strcat(s, "a");
if (crc32("FTbQITslC",9) == 3529007780) strcat(s, "F");
if (crc32("nAXEBU",6) == 1191796458) strcat(s, "t");
if (crc32("atkKGYp",7) == 1260428456) strcat(s, "k");
if (crc32("qDdYM",5) == 975980996) strcat(s, "e");
if (crc32("CTzFIQ",6) == 1420844191) strcat(s, "l");
if (crc32("FEgHPHxYPqO",11) == 3960548103) strcat(s, "l");
if (crc32("ZbpjbxEx",8) == 233772131) strcat(s, "T");
if (crc32("GgkUv",5) == 2955470119) strcat(s, "y");
    return s;
}

char *antiegoistically_adverbs() {
    char *s = calloc(17);
    if (crc32("zEzWXAkhxHi",11) == 2811561563) strcat(s, "a");
if (crc32("vnyvcjdEcJm",11) == 608976083) strcat(s, "n");
if (crc32("meFGiVfe",8) == 722346665) strcat(s, "c");
if (crc32("vAWIKO",6) == 3579147549) strcat(s, "t");
if (crc32("FOVwLvzCIz",10) == 582879188) strcat(s, "i");
if (crc32("BDfzRuOd",8) == 121284475) strcat(s, "a");
if (crc32("qmCeTrJ",7) == 2416379995) strcat(s, "e");
if (crc32("pNpBBSXSZsN",11) == 2818701722) strcat(s, "s");
if (crc32("ziQShZKJ",8) == 3837820804) strcat(s, "g");
if (crc32("FYTVhTlxiVqmgAJ",15) == 3355745398) strcat(s, "o");
if (crc32("VbSmhv",6) == 85107709) strcat(s, "i");
if (crc32("qpXqSKKfY",9) == 2518468235) strcat(s, "x");
if (crc32("FVKUrlYRsLSxS",13) == 3520749891) strcat(s, "s");
if (crc32("KeRQsdpJCW",10) == 165836159) strcat(s, "a");
if (crc32("ZkxvrQFDqTo",11) == 3504122940) strcat(s, "t");
if (crc32("kUXbwzNXYiSEyIJ",15) == 3959090868) strcat(s, "m");
if (crc32("oNqnzmhd",8) == 1037510775) strcat(s, "i");
if (crc32("qqlahYL",7) == 2592252305) strcat(s, "c");
if (crc32("KhElCz",6) == 409336078) strcat(s, "l");
if (crc32("yjABOd",6) == 602210875) strcat(s, "a");
if (crc32("gUntLssEAf",10) == 2144790156) strcat(s, "i");
if (crc32("OzFKPpUm",8) == 1083626338) strcat(s, "l");
if (crc32("VjcRhkCku",9) == 3433899885) strcat(s, "l");
if (crc32("WvPEJIX",7) == 2615028550) strcat(s, "E");
if (crc32("qaCnwFoAZGQGB",13) == 2807759469) strcat(s, "y");
    return s;
}

char *centennially_adverbs() {
    char *s = calloc(13);
    if (crc32("HAhZXEZbKO",10) == 1231442549) strcat(s, "c");
if (crc32("CjIOX",5) == 3773890208) strcat(s, "e");
if (crc32("zhsvMSEuaM",10) == 3200432425) strcat(s, "b");
if (crc32("iXgllxUexLq",11) == 601559176) strcat(s, "n");
if (crc32("xzoLGLXYiycyppp",15) == 3329704858) strcat(s, "V");
if (crc32("bLJMCx",6) == 1620900280) strcat(s, "t");
if (crc32("iLVyRVprQeECFuJ",15) == 2928382590) strcat(s, "C");
if (crc32("fqebOmdftNiOYV",14) == 2805729455) strcat(s, "e");
if (crc32("MZmJG",5) == 3103955585) strcat(s, "F");
if (crc32("ooZwAkjd",8) == 1159166921) strcat(s, "n");
if (crc32("PFOWVsDiR",9) == 242477304) strcat(s, "o");
if (crc32("DwydxNhZo",9) == 1082380567) strcat(s, "n");
if (crc32("GPZkzUMoWfvbd",13) == 3401145758) strcat(s, "h");
if (crc32("rQAFjJoVldMg",12) == 2448044711) strcat(s, "i");
if (crc32("VBWwogykPAqGCsf",15) == 694528505) strcat(s, "a");
if (crc32("otKmvCZJMyHsM",13) == 3280327342) strcat(s, "b");
if (crc32("wPtkPT",6) == 3918825634) strcat(s, "l");
if (crc32("iLxuBn",6) == 573433367) strcat(s, "A");
if (crc32("DWlTCgBgR",9) == 2230888767) strcat(s, "l");
if (crc32("hmnqSvooWStCZwZ",15) == 3654499357) strcat(s, "y");
    return s;
}

char *paretically_adverbs() {
    char *s = calloc(12);
    if (crc32("fXNhwhG",7) == 1119523142) strcat(s, "m");
if (crc32("doWTxhpBc",9) == 3927304734) strcat(s, "p");
if (crc32("QWbbIUsY",8) == 651971069) strcat(s, "a");
if (crc32("RPAbEGj",7) == 3038412745) strcat(s, "r");
if (crc32("bJweFhheVlcASqC",15) == 804014189) strcat(s, "e");
if (crc32("GXiqvwEgkmEzc",13) == 3389211980) strcat(s, "Y");
if (crc32("xPvTYUogZQJW",12) == 715651410) strcat(s, "t");
if (crc32("OeUPASpAjyJm",12) == 612544658) strcat(s, "k");
if (crc32("NizmHNch",8) == 2770180813) strcat(s, "i");
if (crc32("YcBKlLlQ",8) == 636672533) strcat(s, "c");
if (crc32("lxMQh",5) == 2900393678) strcat(s, "a");
if (crc32("wPoHjkYwyvEl",12) == 834085273) strcat(s, "l");
if (crc32("bjrNi",5) == 1755262701) strcat(s, "n");
if (crc32("EkdlZJfiAzz",11) == 238474660) strcat(s, "l");
if (crc32("mrQRepRlU",9) == 2686418438) strcat(s, "b");
if (crc32("giDuwaMrBej",11) == 362109101) strcat(s, "y");
    return s;
}

char *additionally_adverbs() {
    char *s = calloc(13);
    if (crc32("eUeTaWb",7) == 307179328) strcat(s, "a");
if (crc32("EnDNWV",6) == 3520439202) strcat(s, "d");
if (crc32("upivptK",7) == 424336111) strcat(s, "E");
if (crc32("guHVwDFNaPTu",12) == 499296126) strcat(s, "d");
if (crc32("xKkLVSyiFLPnZ",13) == 3487994219) strcat(s, "i");
if (crc32("TSIAfg",6) == 4246138697) strcat(s, "v");
if (crc32("vfGmOPBYHLoYBLe",15) == 131270387) strcat(s, "t");
if (crc32("GndhRzD",7) == 2001148649) strcat(s, "i");
if (crc32("PIkdL",5) == 3754506118) strcat(s, "X");
if (crc32("gERWszNaeZn",11) == 3734900617) strcat(s, "o");
if (crc32("CHHHcvVxVmz",11) == 770737227) strcat(s, "b");
if (crc32("liwlMoQuZTWQPE",14) == 3699690509) strcat(s, "n");
if (crc32("uygDuAlXxm",10) == 1332582875) strcat(s, "Z");
if (crc32("uQHLUjlSS",9) == 1285487396) strcat(s, "a");
if (crc32("oRMIzqMGsJC",11) == 366249906) strcat(s, "H");
if (crc32("DuMJEyNBKtJYdoO",15) == 820465262) strcat(s, "l");
if (crc32("tWzOVshhEoLWZ",13) == 3307054018) strcat(s, "l");
if (crc32("CBIYRrCxNLs",11) == 2743230351) strcat(s, "s");
if (crc32("JZoifnn",7) == 2422225705) strcat(s, "y");
    return s;
}

char *nonreasonably_adverbs() {
    char *s = calloc(14);
    if (crc32("aEsbhlm",7) == 3535193277) strcat(s, "g");
if (crc32("YshUM",5) == 63855473) strcat(s, "n");
if (crc32("JKEzsWXRiok",11) == 1254115597) strcat(s, "o");
if (crc32("RrRwUVjD",8) == 1545605204) strcat(s, "j");
if (crc32("YlEjqmqdI",9) == 1455199172) strcat(s, "n");
if (crc32("rWwYOJeIvHi",11) == 3210103325) strcat(s, "r");
if (crc32("wHqfrogSEWEUHZR",15) == 766176446) strcat(s, "e");
if (crc32("jlSjngHaw",9) == 1605308897) strcat(s, "a");
if (crc32("KMpyfZuav",9) == 3983252245) strcat(s, "s");
if (crc32("XIUmNBlJiBei",12) == 2241100407) strcat(s, "o");
if (crc32("uhndHyirbAUtNI",14) == 1486952439) strcat(s, "u");
if (crc32("onzcBg",6) == 837302781) strcat(s, "n");
if (crc32("QSMTzlksrJaPwNe",15) == 3981383040) strcat(s, "a");
if (crc32("AasDAB",6) == 2923254273) strcat(s, "b");
if (crc32("dVBkqzkQtzCXXDb",15) == 726012383) strcat(s, "l");
if (crc32("auDMqOQWtWA",11) == 3074093097) strcat(s, "V");
if (crc32("fWCoWXrUwYBMs",13) == 867268748) strcat(s, "y");
    return s;
}

char *stockstill_adverbs() {
    char *s = calloc(11);
    if (crc32("AAbHuTbAst",10) == 3956229576) strcat(s, "C");
if (crc32("CkpTWjiop",9) == 3694067468) strcat(s, "s");
if (crc32("RmlxzjPveX",10) == 3689362493) strcat(s, "R");
if (crc32("yuotjIeTKcIlQ",13) == 2946742394) strcat(s, "t");
if (crc32("UpgBSjqtm",9) == 3421813161) strcat(s, "o");
if (crc32("uaPGNUfbd",9) == 1001055036) strcat(s, "o");
if (crc32("kLOgBKGKeLLI",12) == 2024582201) strcat(s, "C");
if (crc32("lnxpXXqRUecLmib",15) == 3129931948) strcat(s, "c");
if (crc32("TBnDk",5) == 4011876423) strcat(s, "i");
if (crc32("XGRMrgDicNO",11) == 2096356491) strcat(s, "k");
if (crc32("zSsPCVFKrxu",11) == 491763374) strcat(s, "s");
if (crc32("tbgwNRpJKx",10) == 4127846938) strcat(s, "X");
if (crc32("seYqPrFPdPmPQ",13) == 1423336850) strcat(s, "t");
if (crc32("LTPeQWmGJIt",11) == 2690444102) strcat(s, "e");
if (crc32("ftBPhtJotrJm",12) == 1047072546) strcat(s, "i");
if (crc32("FQakgpk",7) == 944490821) strcat(s, "U");
if (crc32("fiMxvMESdz",10) == 2898599565) strcat(s, "l");
if (crc32("yHbfzXWvHxPGHH",14) == 720416896) strcat(s, "e");
if (crc32("kpNGiCRVRWDS",12) == 3294967799) strcat(s, "l");
    return s;
}

char *stonyheartedly_adverbs() {
    char *s = calloc(15);
    if (crc32("UKaXMXxvwmd",11) == 3150370971) strcat(s, "k");
if (crc32("NqNEwGu",7) == 3435553725) strcat(s, "s");
if (crc32("yctyrRjTYlUrUPm",15) == 766974419) strcat(s, "t");
if (crc32("PeePdJzptdecZ",13) == 3876910574) strcat(s, "t");
if (crc32("PFXdw",5) == 1607707940) strcat(s, "y");
if (crc32("nZIHuadsIGy",11) == 3459263950) strcat(s, "o");
if (crc32("aGequVWkLzvH",12) == 1883589713) strcat(s, "F");
if (crc32("cYITUkNhNHHMCR",14) == 3941758856) strcat(s, "n");
if (crc32("JEOXD",5) == 1837693540) strcat(s, "n");
if (crc32("vFdKrgCXCODodV",14) == 4208882631) strcat(s, "y");
if (crc32("pmcCONiATAReYq",14) == 2814091804) strcat(s, "h");
if (crc32("pRwbGVGH",8) == 2646081058) strcat(s, "U");
if (crc32("TAeiCmZdeAZtN",13) == 279394369) strcat(s, "e");
if (crc32("GFmboKBE",8) == 3981078939) strcat(s, "a");
if (crc32("rJNAXcrgh",9) == 1331790566) strcat(s, "r");
if (crc32("kOCCm",5) == 530997093) strcat(s, "K");
if (crc32("oewjPKwUNuzPnYP",15) == 787930364) strcat(s, "t");
if (crc32("KrfdgJJWseH",11) == 2247852118) strcat(s, "e");
if (crc32("pWHtOasCxyOW",12) == 265844564) strcat(s, "d");
if (crc32("nTPpyyZjfzub",12) == 968950242) strcat(s, "d");
if (crc32("SAVfnCmLmiSByC",14) == 4200595345) strcat(s, "l");
if (crc32("LJSQPRWBvut",11) == 2078003097) strcat(s, "G");
if (crc32("NzUZPkjdI",9) == 2396260938) strcat(s, "y");
    return s;
}

char *altruistically_adverbs() {
    char *s = calloc(15);
    if (crc32("JdjCAzVQR",9) == 1895524305) strcat(s, "a");
if (crc32("CVVWKrb",7) == 3344065376) strcat(s, "T");
if (crc32("UwNEmHCwQgSLgf",14) == 3334663990) strcat(s, "l");
if (crc32("vYUzBibD",8) == 4168070696) strcat(s, "s");
if (crc32("CbAhoeyDNP",10) == 1975058881) strcat(s, "t");
if (crc32("nvOUQL",6) == 1296965748) strcat(s, "k");
if (crc32("bCiCxlUQLnTlVLL",15) == 2801417991) strcat(s, "r");
if (crc32("GWfnYuJyStZBWs",14) == 4075417971) strcat(s, "c");
if (crc32("qWFIMhWocAHg",12) == 3351216745) strcat(s, "u");
if (crc32("haHqpRXTdj",10) == 1523494268) strcat(s, "i");
if (crc32("frpGMgdfW",9) == 287729852) strcat(s, "o");
if (crc32("hnfMGQP",7) == 3587774335) strcat(s, "s");
if (crc32("dnIFZWfIj",9) == 2916251476) strcat(s, "R");
if (crc32("RBtGICOdMuD",11) == 839822004) strcat(s, "t");
if (crc32("igWDyOrJxk",10) == 2775143181) strcat(s, "C");
if (crc32("maTdaTTS",8) == 1010448426) strcat(s, "i");
if (crc32("OLjffRUJVCvbblD",15) == 545894156) strcat(s, "h");
if (crc32("YgEuEwlRsodF",12) == 2956449784) strcat(s, "c");
if (crc32("PrJxKXKbdwnKKIy",15) == 286846683) strcat(s, "a");
if (crc32("weGaDfq",7) == 3401461890) strcat(s, "i");
if (crc32("QcAqECWUiGg",11) == 2206439920) strcat(s, "l");
if (crc32("ugOpmhSMaazQa",13) == 2756463179) strcat(s, "X");
if (crc32("cLakMzBcxkhx",12) == 1730791736) strcat(s, "l");
if (crc32("HTZvcPQtnztePNl",15) == 3706309195) strcat(s, "g");
if (crc32("ztaUoCI",7) == 2325337934) strcat(s, "y");
    return s;
}

char *uncoincidentally_adverbs() {
    char *s = calloc(17);
    if (crc32("aWOzJwbicsiHw",13) == 4161654590) strcat(s, "u");
if (crc32("NASWHqQlH",9) == 4222314190) strcat(s, "b");
if (crc32("PUGJYDbNAbonHPl",15) == 3716524974) strcat(s, "n");
if (crc32("LOrtLrqcpvcXsDu",15) == 3475629416) strcat(s, "H");
if (crc32("UwKTYBesOnDdHFp",15) == 1021630884) strcat(s, "c");
if (crc32("zpGdQX",6) == 1839520096) strcat(s, "o");
if (crc32("yTkthdIIqpb",11) == 654243586) strcat(s, "L");
if (crc32("vRUwbWAXLb",10) == 17308409) strcat(s, "i");
if (crc32("WbwXZswiFwN",11) == 1365235598) strcat(s, "l");
if (crc32("JQBmg",5) == 3612043149) strcat(s, "n");
if (crc32("KkQNymWji",9) == 2025747202) strcat(s, "c");
if (crc32("PKDxn",5) == 2112286500) strcat(s, "h");
if (crc32("eDTwpeOFSkkYqmG",15) == 94037755) strcat(s, "i");
if (crc32("kpkOmEEvdhfr",12) == 4293732402) strcat(s, "d");
if (crc32("AHBRjqfwdBwDt",13) == 999261150) strcat(s, "b");
if (crc32("MrzzKiaDUSay",12) == 883281573) strcat(s, "e");
if (crc32("SmTuzH",6) == 3791127190) strcat(s, "n");
if (crc32("KXpTWO",6) == 3475861092) strcat(s, "t");
if (crc32("uOQtuD",6) == 51460241) strcat(s, "k");
if (crc32("zApeFnN",7) == 4200052192) strcat(s, "a");
if (crc32("hYIZwFgRN",9) == 4110838516) strcat(s, "I");
if (crc32("XUsmSeo",7) == 223750121) strcat(s, "l");
if (crc32("KFmhIke",7) == 342571903) strcat(s, "p");
if (crc32("gyQRBBpyt",9) == 1203420626) strcat(s, "l");
if (crc32("sBEdx",5) == 1616110898) strcat(s, "y");
    return s;
}

char *unsmokily_adverbs() {
    char *s = calloc(10);
    if (crc32("EZtgyGioyNS",11) == 1321027044) strcat(s, "u");
if (crc32("oMWjRcs",7) == 2228565919) strcat(s, "g");
if (crc32("qbFtVmDRDLmyX",13) == 1903675484) strcat(s, "n");
if (crc32("oTJOeaLAewlFW",13) == 3122522462) strcat(s, "s");
if (crc32("RaSFDFlKnbaTuq",14) == 852283126) strcat(s, "k");
if (crc32("rNwAwLYfhACIbE",14) == 1918550984) strcat(s, "m");
if (crc32("kBbPuQ",6) == 2055831165) strcat(s, "l");
if (crc32("cCpttryIYbr",11) == 3376111672) strcat(s, "o");
if (crc32("rsduHoxUUoI",11) == 2758571293) strcat(s, "v");
if (crc32("exAVUVeNPAn",11) == 1540179357) strcat(s, "k");
if (crc32("hUcFGJpmcR",10) == 2153465279) strcat(s, "i");
if (crc32("aZLnGJyViOAnYp",14) == 2123482243) strcat(s, "E");
if (crc32("DCmaqCAGeHQ",11) == 61193840) strcat(s, "l");
if (crc32("nqzLvZKcBFA",11) == 2615821187) strcat(s, "y");
    return s;
}

char *unmistakably_adverbs() {
    char *s = calloc(13);
    if (crc32("XKRyNBxGcG",10) == 288017671) strcat(s, "u");
if (crc32("NAtXmoxzUv",10) == 1223254178) strcat(s, "b");
if (crc32("vFQmr",5) == 233415918) strcat(s, "n");
if (crc32("Zzlcqgklr",9) == 1389337858) strcat(s, "x");
if (crc32("BnFVX",5) == 3266227810) strcat(s, "m");
if (crc32("PHnbsr",6) == 4286324615) strcat(s, "i");
if (crc32("HpmRHPfph",9) == 3488350090) strcat(s, "p");
if (crc32("FgnfxiojZagj",12) == 485945774) strcat(s, "s");
if (crc32("wOyQLKmLIl",10) == 962266960) strcat(s, "P");
if (crc32("FNQNy",5) == 1074240110) strcat(s, "t");
if (crc32("KSSOoAjep",9) == 2987594868) strcat(s, "k");
if (crc32("bBkaLCmSS",9) == 2187634893) strcat(s, "a");
if (crc32("ZstaqFKWfARN",12) == 2693977253) strcat(s, "k");
if (crc32("XZAwFFMhDzJTLT",14) == 913539781) strcat(s, "a");
if (crc32("gJNeyYRMeL",10) == 421328683) strcat(s, "b");
if (crc32("QfqKUshnOy",10) == 3154210156) strcat(s, "l");
if (crc32("JajvBOppRGbM",12) == 2478386313) strcat(s, "b");
if (crc32("xhNbFxGqyHSfsp",14) == 3109327751) strcat(s, "y");
    return s;
}

char *quietly_adverbs() {
    char *s = calloc(8);
    if (crc32("APxhoHed",8) == 2724873731) strcat(s, "q");
if (crc32("XpIMqVNn",8) == 4177500994) strcat(s, "u");
if (crc32("grLQSMAkOUfnE",13) == 4103267449) strcat(s, "K");
if (crc32("imEhaMOXdb",10) == 3662558855) strcat(s, "i");
if (crc32("WXtShxBWDKEST",13) == 1111805100) strcat(s, "Y");
if (crc32("TLMuhHHRdoBNQ",13) == 3683450809) strcat(s, "e");
if (crc32("zmykwZycezN",11) == 3264964408) strcat(s, "P");
if (crc32("hkDLAVUprssV",12) == 2561777075) strcat(s, "t");
if (crc32("mcOIkvrDDsCz",12) == 3648726265) strcat(s, "l");
if (crc32("KyaprveqQr",10) == 1575047511) strcat(s, "y");
    return s;
}

char *doggedly_adverbs() {
    char *s = calloc(9);
    if (crc32("pXYDJsmiR",9) == 2825989321) strcat(s, "d");
if (crc32("tprFd",5) == 3572984501) strcat(s, "U");
if (crc32("JMsEANljLSWG",12) == 3404444051) strcat(s, "o");
if (crc32("ofxMbFkZd",9) == 655523969) strcat(s, "I");
if (crc32("LKzGqRiqR",9) == 2716600609) strcat(s, "g");
if (crc32("LgtkpowOMZEXgPG",15) == 554287694) strcat(s, "g");
if (crc32("ZASHvXhhSfS",11) == 2797808724) strcat(s, "e");
if (crc32("AcuHdRGHMwsg",12) == 423525746) strcat(s, "d");
if (crc32("BuqUZE",6) == 3380568123) strcat(s, "y");
if (crc32("hHmDZkWmpKcr",12) == 1144156051) strcat(s, "l");
if (crc32("HGuKCaOTtIRdwp",14) == 3948869751) strcat(s, "O");
if (crc32("LKDob",5) == 561958761) strcat(s, "y");
    return s;
}

char *indulgently_adverbs() {
    char *s = calloc(12);
    if (crc32("PMkFANp",7) == 306551430) strcat(s, "i");
if (crc32("vgThJjVhiZO",11) == 2206164957) strcat(s, "n");
if (crc32("MPvXK",5) == 3782074970) strcat(s, "s");
if (crc32("fPyaMSEFdn",10) == 1825343477) strcat(s, "d");
if (crc32("AMojrGYUJihz",12) == 2207460409) strcat(s, "S");
if (crc32("iJfQplDGfnuVixY",15) == 1537049126) strcat(s, "u");
if (crc32("qnLLUTxcZnqhg",13) == 1400529674) strcat(s, "C");
if (crc32("CPXjNkzO",8) == 3728789524) strcat(s, "l");
if (crc32("tWCBY",5) == 1049522503) strcat(s, "g");
if (crc32("SJKeLwOjWCfM",12) == 3516299028) strcat(s, "d");
if (crc32("lTucG",5) == 719172424) strcat(s, "e");
if (crc32("STfhvDG",7) == 3699339620) strcat(s, "n");
if (crc32("ETWIvJi",7) == 518758844) strcat(s, "t");
if (crc32("FeFIgq",6) == 49061776) strcat(s, "z");
if (crc32("YWVBXH",6) == 2272132201) strcat(s, "l");
if (crc32("ZqECQ",5) == 3523157508) strcat(s, "Y");
if (crc32("YeDIRzWxYSy",11) == 192907541) strcat(s, "y");
    return s;
}

char *unaesthetically_adverbs() {
    char *s = calloc(16);
    if (crc32("JqqoCVwqqVBmi",13) == 1228822129) strcat(s, "d");
if (crc32("FhJzYXq",7) == 2128384467) strcat(s, "u");
if (crc32("XjMRrTrquq",10) == 3974162938) strcat(s, "n");
if (crc32("sFpiG",5) == 4179607602) strcat(s, "K");
if (crc32("sxWPTxuWrSZO",12) == 2478180194) strcat(s, "a");
if (crc32("YQCYNVTY",8) == 283766697) strcat(s, "T");
if (crc32("ElyXzaV",7) == 2845486291) strcat(s, "e");
if (crc32("rKxdRUc",7) == 2192395428) strcat(s, "s");
if (crc32("ULFeHYqeAOCnW",13) == 779074907) strcat(s, "m");
if (crc32("pThKMxWdmoUd",12) == 519913282) strcat(s, "t");
if (crc32("isMEaCQmlPmXMS",14) == 1860046580) strcat(s, "X");
if (crc32("sjqpnlDk",8) == 2245452991) strcat(s, "h");
if (crc32("DJxSpKxZ",8) == 1113342041) strcat(s, "z");
if (crc32("ruBFAnf",7) == 265284469) strcat(s, "e");
if (crc32("DzKepscFVOaUz",13) == 2241105214) strcat(s, "t");
if (crc32("bwKtmQhy",8) == 2535549380) strcat(s, "i");
if (crc32("YpbnaTErniPB",12) == 3428594428) strcat(s, "c");
if (crc32("ZASUgiGAHrXQiW",14) == 1184958567) strcat(s, "a");
if (crc32("rNjIblW",7) == 2437149321) strcat(s, "l");
if (crc32("ysnJVrb",7) == 1829047710) strcat(s, "l");
if (crc32("oqzAAbN",7) == 3077263245) strcat(s, "h");
if (crc32("spXZbd",6) == 3072335436) strcat(s, "y");
    return s;
}

char *linguistically_adverbs() {
    char *s = calloc(15);
    if (crc32("SZyOXT",6) == 1736031425) strcat(s, "z");
if (crc32("xdSLuPdn",8) == 3920719433) strcat(s, "l");
if (crc32("JtIgDcInPxd",11) == 3608810893) strcat(s, "m");
if (crc32("oOLWJza",7) == 1194135868) strcat(s, "i");
if (crc32("sfwmVIkyxyn",11) == 1409991511) strcat(s, "m");
if (crc32("arqGPxMbPIBmfTe",15) == 1796564565) strcat(s, "n");
if (crc32("GXunqegoaVOoWi",14) == 1149121834) strcat(s, "N");
if (crc32("wRwYTgFmQZBy",12) == 526602585) strcat(s, "g");
if (crc32("ogtVshShi",9) == 3395092962) strcat(s, "u");
if (crc32("NEQMcmVBx",9) == 1144938443) strcat(s, "i");
if (crc32("gVTAWp",6) == 4044577481) strcat(s, "a");
if (crc32("IYObaDCwJZNN",12) == 3438278097) strcat(s, "s");
if (crc32("pSJjdiGAInPqd",13) == 3937036227) strcat(s, "L");
if (crc32("AKPUJyOFIwOO",12) == 1788549390) strcat(s, "t");
if (crc32("nyLJbhV",7) == 182409303) strcat(s, "V");
if (crc32("EqThHyzm",8) == 2471367046) strcat(s, "i");
if (crc32("sawEJo",6) == 301466501) strcat(s, "x");
if (crc32("XEjXXH",6) == 4250765969) strcat(s, "c");
if (crc32("NEmagmfRJ",9) == 383957069) strcat(s, "T");
if (crc32("kmVxkFgBoCibHvn",15) == 337997669) strcat(s, "a");
if (crc32("XamQSYlM",8) == 80291393) strcat(s, "l");
if (crc32("lVrWi",5) == 3798438782) strcat(s, "l");
if (crc32("NLSTQNfS",8) == 3985527542) strcat(s, "X");
if (crc32("EdDUZzoWWao",11) == 579886625) strcat(s, "y");
    return s;
}

char *cornerwise_adverbs() {
    char *s = calloc(11);
    if (crc32("kxrcqwZhJp",10) == 243954180) strcat(s, "W");
if (crc32("bnAZByJYCEQFc",13) == 1035371117) strcat(s, "c");
if (crc32("hZSVsKKU",8) == 3022859624) strcat(s, "O");
if (crc32("yciuRLFAmTdrr",13) == 1584925758) strcat(s, "o");
if (crc32("lqTyNLih",8) == 3053440068) strcat(s, "d");
if (crc32("Xahch",5) == 111585511) strcat(s, "r");
if (crc32("DgskfcQHG",9) == 2302903722) strcat(s, "e");
if (crc32("heXUnoPOU",9) == 2430292257) strcat(s, "n");
if (crc32("eMCbFxe",7) == 3614519236) strcat(s, "e");
if (crc32("IAAArS",6) == 70046015) strcat(s, "x");
if (crc32("jGViZoieT",9) == 1099865312) strcat(s, "r");
if (crc32("uIQUXyD",7) == 1902314439) strcat(s, "L");
if (crc32("rpEBEO",6) == 3125017414) strcat(s, "w");
if (crc32("VkvDtZWHE",9) == 2394348602) strcat(s, "i");
if (crc32("GdIbtRSkmj",10) == 2264328784) strcat(s, "s");
if (crc32("htdytRptVqX",11) == 3018453203) strcat(s, "e");
    return s;
}

char *uncially_adverbs() {
    char *s = calloc(9);
    if (crc32("raAHUzShTa",10) == 2217528430) strcat(s, "p");
if (crc32("sroURgMe",8) == 1640549183) strcat(s, "u");
if (crc32("bLBvTB",6) == 2708552105) strcat(s, "J");
if (crc32("OBtkTkQspO",10) == 1213402923) strcat(s, "n");
if (crc32("ixspffCFhNac",12) == 2247836290) strcat(s, "s");
if (crc32("GRCrJIyiWSjFpCW",15) == 917064717) strcat(s, "c");
if (crc32("reOeJKCemInx",12) == 3733594711) strcat(s, "i");
if (crc32("rGMueUTjmoFyY",13) == 3794991252) strcat(s, "q");
if (crc32("cggLNjEczADl",12) == 1635139965) strcat(s, "a");
if (crc32("ZqDcPh",6) == 45491638) strcat(s, "h");
if (crc32("xFAIqSdvJqqkc",13) == 486978399) strcat(s, "l");
if (crc32("uWXKT",5) == 3169768338) strcat(s, "l");
if (crc32("vDkMWQKmSLZBq",13) == 1769964301) strcat(s, "y");
    return s;
}

char *ipsojure_adverbs() {
    char *s = calloc(9);
    if (crc32("ObgqrLbvwq",10) == 1029468945) strcat(s, "X");
if (crc32("ajtrYjIIuvn",11) == 1386937818) strcat(s, "i");
if (crc32("FHgaUfgHFSkeJ",13) == 619211880) strcat(s, "p");
if (crc32("pmbgqDtC",8) == 2594391285) strcat(s, "v");
if (crc32("aeUuMjGozLe",11) == 741445436) strcat(s, "s");
if (crc32("HpWJwKj",7) == 1885610622) strcat(s, "o");
if (crc32("HPuBRGrtuvaQNQ",14) == 3629381056) strcat(s, "j");
if (crc32("fMfcFnI",7) == 2034510716) strcat(s, "u");
if (crc32("ohYrxCVR",8) == 3388011660) strcat(s, "r");
if (crc32("CLUiOjJpud",10) == 940244988) strcat(s, "e");
    return s;
}

char *nonportentously_adverbs() {
    char *s = calloc(16);
    if (crc32("RvpPWjKwIIm",11) == 1093288478) strcat(s, "D");
if (crc32("ozUHUHMoHJAQ",12) == 332172034) strcat(s, "n");
if (crc32("KZMQZVESgE",10) == 2716470165) strcat(s, "o");
if (crc32("xLkrGYpigkK",11) == 3166686696) strcat(s, "a");
if (crc32("CrqSRMHy",8) == 238380341) strcat(s, "n");
if (crc32("WYuBFNQ",7) == 2210389050) strcat(s, "r");
if (crc32("rpjOxWJnRxsGJK",14) == 415347447) strcat(s, "p");
if (crc32("YCcwGUK",7) == 2963063064) strcat(s, "H");
if (crc32("qYwuCpZaYOw",11) == 877471734) strcat(s, "o");
if (crc32("jFDKpvxZqQdO",12) == 4271952477) strcat(s, "K");
if (crc32("ezkWKtaWeQd",11) == 2850995276) strcat(s, "r");
if (crc32("kbAyMqNaFEbHiK",14) == 2592641621) strcat(s, "Y");
if (crc32("WpyYmXPZ",8) == 1432465734) strcat(s, "t");
if (crc32("iGnDyTgqSRKxeQ",14) == 316126624) strcat(s, "j");
if (crc32("gZLKdajoX",9) == 3513013212) strcat(s, "e");
if (crc32("OQObvFMu",8) == 3327212673) strcat(s, "Y");
if (crc32("KUQzv",5) == 337272871) strcat(s, "n");
if (crc32("PjxvqQUIgDYT",12) == 1476944390) strcat(s, "k");
if (crc32("vqVSrFqR",8) == 3859161882) strcat(s, "t");
if (crc32("ImsviXx",7) == 1661552882) strcat(s, "o");
if (crc32("KJpGjUfXVO",10) == 3429685852) strcat(s, "u");
if (crc32("wbkAobJil",9) == 2865493565) strcat(s, "s");
if (crc32("oeMoE",5) == 1294584916) strcat(s, "l");
if (crc32("JfKUcyly",8) == 2948816194) strcat(s, "r");
if (crc32("vleLErxPtrXw",12) == 801582201) strcat(s, "y");
    return s;
}

char *tinglingly_adverbs() {
    char *s = calloc(11);
    if (crc32("SKnhQ",5) == 3031428467) strcat(s, "a");
if (crc32("SypLixDQHL",10) == 449386729) strcat(s, "t");
if (crc32("hNTFO",5) == 2494698594) strcat(s, "h");
if (crc32("xrcBuw",6) == 319157711) strcat(s, "i");
if (crc32("VEUUWgWO",8) == 1144249125) strcat(s, "n");
if (crc32("oKeGZiTC",8) == 3786790712) strcat(s, "F");
if (crc32("fXitUN",6) == 611480685) strcat(s, "g");
if (crc32("BQmyF",5) == 3069045402) strcat(s, "l");
if (crc32("HbNuMhoS",8) == 2066536351) strcat(s, "O");
if (crc32("bblPoMFpqimq",12) == 1637708431) strcat(s, "i");
if (crc32("IOcjiSlJiRz",11) == 3945610639) strcat(s, "A");
if (crc32("uzzFPgpcOqK",11) == 3312430088) strcat(s, "n");
if (crc32("HOjoGagcCqwAIJ",14) == 312333888) strcat(s, "g");
if (crc32("keQhAEZiaePWDC",14) == 2722035382) strcat(s, "K");
if (crc32("GatXw",5) == 1083183213) strcat(s, "l");
if (crc32("FJAOruMklVNp",12) == 3389000413) strcat(s, "y");
    return s;
}

char *subterraneously_adverbs() {
    char *s = calloc(16);
    if (crc32("GNtYcEOurUo",11) == 2382913413) strcat(s, "q");
if (crc32("DwldhoM",7) == 2135267752) strcat(s, "s");
if (crc32("BEuFUY",6) == 75019601) strcat(s, "D");
if (crc32("wvGIB",5) == 255359799) strcat(s, "u");
if (crc32("hrcRfSATLi",10) == 2489360890) strcat(s, "b");
if (crc32("dtHjCcutTgc",11) == 1422444274) strcat(s, "Z");
if (crc32("nnTxv",5) == 250355610) strcat(s, "t");
if (crc32("wFLLxUtSI",9) == 3253258629) strcat(s, "e");
if (crc32("JrosQjmh",8) == 1150500207) strcat(s, "e");
if (crc32("wOkGaWjstWya",12) == 1502318532) strcat(s, "r");
if (crc32("eRCsADrRndvCCzO",15) == 209666252) strcat(s, "i");
if (crc32("hPODriHbTfp",11) == 835700985) strcat(s, "r");
if (crc32("rvydWJmceZg",11) == 1441607893) strcat(s, "e");
if (crc32("MrmaFxiw",8) == 582386006) strcat(s, "a");
if (crc32("qzNGJSBaBkBljuB",15) == 3034801215) strcat(s, "n");
if (crc32("sahruZEYCoStVQ",14) == 3566181297) strcat(s, "e");
if (crc32("yspNaLXESEp",11) == 2099317725) strcat(s, "o");
if (crc32("RBxqLTVXpgOraHT",15) == 446350158) strcat(s, "u");
if (crc32("NcmWNqHxT",9) == 2499732915) strcat(s, "s");
if (crc32("PHawSE",6) == 765682734) strcat(s, "a");
if (crc32("PtIlbHSjzrnyE",13) == 3162875507) strcat(s, "l");
if (crc32("VpvgIwOTIjeC",12) == 3982967450) strcat(s, "y");
    return s;
}

char *noninstinctively_adverbs() {
    char *s = calloc(17);
    if (crc32("KxZMDSBFpA",10) == 3463491840) strcat(s, "N");
if (crc32("SBWiNhxXn",9) == 2487008777) strcat(s, "n");
if (crc32("GXJjEVyAJRJ",11) == 1286069578) strcat(s, "o");
if (crc32("NEoakwN",7) == 4222459160) strcat(s, "n");
if (crc32("KsuJsXAT",8) == 465079341) strcat(s, "i");
if (crc32("SDaxwXsQJbEriY",14) == 1788335674) strcat(s, "n");
if (crc32("WunSaiYqMbtBLIv",15) == 295736034) strcat(s, "n");
if (crc32("toeHnIBQHUrQLa",14) == 1565375137) strcat(s, "s");
if (crc32("kHaKV",5) == 2934964875) strcat(s, "t");
if (crc32("XPSHQBpSHnNTqG",14) == 4164500429) strcat(s, "i");
if (crc32("UNSlHQE",7) == 3530601016) strcat(s, "u");
if (crc32("QwGCafDjapVXFMy",15) == 3774241512) strcat(s, "n");
if (crc32("sflVgmEwUawrc",13) == 3111966446) strcat(s, "c");
if (crc32("CyjaTxMsK",9) == 2686526277) strcat(s, "t");
if (crc32("xievXRzjFHOBn",13) == 633516741) strcat(s, "i");
if (crc32("nQLbICynuqas",12) == 3242004877) strcat(s, "E");
if (crc32("sSyEvHD",7) == 2341671238) strcat(s, "v");
if (crc32("wZLxPEEGyKLCNe",14) == 3073937310) strcat(s, "t");
if (crc32("neHCIMiY",8) == 3175322784) strcat(s, "e");
if (crc32("SlCKiBa",7) == 484282934) strcat(s, "l");
if (crc32("JHfWMyXubtsSa",13) == 2478798275) strcat(s, "j");
if (crc32("iRtUKumxI",9) == 2659570137) strcat(s, "y");
    return s;
}

char *gladsomely_adverbs() {
    char *s = calloc(11);
    if (crc32("UoeYNiF",7) == 3741631758) strcat(s, "P");
if (crc32("HjnEcZ",6) == 3918334427) strcat(s, "g");
if (crc32("xQmAniMHkmTN",12) == 4005742134) strcat(s, "l");
if (crc32("IUsgHrok",8) == 946629961) strcat(s, "X");
if (crc32("XivEZJd",7) == 1503081204) strcat(s, "a");
if (crc32("Oliig",5) == 752608840) strcat(s, "E");
if (crc32("UJUnDETB",8) == 3338428473) strcat(s, "d");
if (crc32("CYMXkjtQUFgqN",13) == 2170342354) strcat(s, "H");
if (crc32("uhozKPf",7) == 3135174329) strcat(s, "s");
if (crc32("jIbre",5) == 2554207915) strcat(s, "o");
if (crc32("RkKlNCWqIIeOSE",14) == 1889497225) strcat(s, "z");
if (crc32("rixCcSzsCfPWxQc",15) == 3367100028) strcat(s, "m");
if (crc32("fbaCUE",6) == 3164722744) strcat(s, "e");
if (crc32("NIvGBAXNiH",10) == 1709014412) strcat(s, "l");
if (crc32("xrwhugeCAyxvKHZ",15) == 924160621) strcat(s, "h");
if (crc32("EYaawaOBAO",10) == 2037769423) strcat(s, "y");
    return s;
}

char *nonvenomously_adverbs() {
    char *s = calloc(14);
    if (crc32("SsGHcR",6) == 911603109) strcat(s, "n");
if (crc32("VKTpSzqtHjOBcL",14) == 1799370405) strcat(s, "o");
if (crc32("BZYeuupL",8) == 3222631007) strcat(s, "O");
if (crc32("dmKlIUSgrUA",11) == 2984264926) strcat(s, "n");
if (crc32("rcBTW",5) == 413222301) strcat(s, "r");
if (crc32("jFueIVVkV",9) == 4050307954) strcat(s, "v");
if (crc32("fzGtAgxiv",9) == 3698925972) strcat(s, "s");
if (crc32("uALRJMFGOKwnAf",14) == 720606262) strcat(s, "e");
if (crc32("TCxpsNeGpDaCF",13) == 3986835651) strcat(s, "n");
if (crc32("zGaUOlIDUGzrL",13) == 1260218829) strcat(s, "h");
if (crc32("rjkOeunYCAQ",11) == 2956155860) strcat(s, "o");
if (crc32("Hdfcu",5) == 435436601) strcat(s, "U");
if (crc32("bmILeBxKN",9) == 3468646753) strcat(s, "m");
if (crc32("vZquPjlgg",9) == 1686758753) strcat(s, "o");
if (crc32("fMdMvwtj",8) == 3989574288) strcat(s, "V");
if (crc32("BUfzhoFZHYzVES",14) == 1380054603) strcat(s, "u");
if (crc32("AXwUwXeHQk",10) == 2582974432) strcat(s, "s");
if (crc32("PAcXssTSDdc",11) == 1741197959) strcat(s, "l");
if (crc32("qyzpLZNKywB",11) == 2974735244) strcat(s, "y");
    return s;
}

char *unapologetically_adverbs() {
    char *s = calloc(17);
    if (crc32("rWtAqPfWtFmIPBk",15) == 1372254456) strcat(s, "q");
if (crc32("WakEhGulkMUdZ",13) == 2707254815) strcat(s, "u");
if (crc32("xIrdLDeBMp",10) == 3169079811) strcat(s, "J");
if (crc32("phEiCkW",7) == 1111795824) strcat(s, "n");
if (crc32("WUEsawnE",8) == 2233991139) strcat(s, "a");
if (crc32("YqGICbwEyfkW",12) == 1144804653) strcat(s, "b");
if (crc32("PnVMmqfBS",9) == 1823460400) strcat(s, "p");
if (crc32("DIochiDi",8) == 666496888) strcat(s, "o");
if (crc32("pWlWDHyazAVB",12) == 2153238497) strcat(s, "l");
if (crc32("zdHaFJhygHmY",12) == 2527107423) strcat(s, "o");
if (crc32("UaTcgrcTHE",10) == 1984837895) strcat(s, "g");
if (crc32("eUhyZS",6) == 3549379966) strcat(s, "w");
if (crc32("EFzIotZyif",10) == 3223073015) strcat(s, "e");
if (crc32("jrWRyMfeCyvlk",13) == 3815840348) strcat(s, "G");
if (crc32("chGicwdbwwCX",12) == 1546004384) strcat(s, "t");
if (crc32("QpDImuY",7) == 1483990290) strcat(s, "i");
if (crc32("mnTTzC",6) == 3226028308) strcat(s, "o");
if (crc32("ICnxdAzJ",8) == 1535775294) strcat(s, "c");
if (crc32("OeKYV",5) == 2253034749) strcat(s, "w");
if (crc32("wFevfSpQymR",11) == 3052937444) strcat(s, "a");
if (crc32("ZCRiiWf",7) == 3031749200) strcat(s, "h");
if (crc32("qXydgBpezilyvzG",15) == 2702785087) strcat(s, "l");
if (crc32("NkZNGgXuHj",10) == 2635526146) strcat(s, "l");
if (crc32("tLwFhkpkfgYoW",13) == 3146075695) strcat(s, "o");
if (crc32("hOObYX",6) == 153848818) strcat(s, "y");
    return s;
}

char *unappeasingly_adverbs() {
    char *s = calloc(14);
    if (crc32("whNWOr",6) == 3088833466) strcat(s, "m");
if (crc32("xMdzjkLuzqx",11) == 3317073489) strcat(s, "u");
if (crc32("TaYnrXCQXATB",12) == 1330040450) strcat(s, "n");
if (crc32("LOfliHlguGN",11) == 1315657937) strcat(s, "H");
if (crc32("nAvlLFiTpcMQUJL",15) == 1399514021) strcat(s, "a");
if (crc32("tVgNKolVSmdm",12) == 2209411227) strcat(s, "p");
if (crc32("REQCmzc",7) == 3137688698) strcat(s, "p");
if (crc32("gNjjkvtfMcDOxlB",15) == 2102971559) strcat(s, "i");
if (crc32("NOATZoefbATEdO",14) == 170377009) strcat(s, "e");
if (crc32("TtUblYW",7) == 437325096) strcat(s, "s");
if (crc32("xYjmjfO",7) == 3810559721) strcat(s, "a");
if (crc32("lmPKxzotNcq",11) == 2317491110) strcat(s, "s");
if (crc32("PWQkTp",6) == 2791041120) strcat(s, "k");
if (crc32("xNfykjSXiGxJT",13) == 1199758116) strcat(s, "i");
if (crc32("ElvJjVxZhtFB",12) == 1045926225) strcat(s, "n");
if (crc32("RYGSddFah",9) == 1746687802) strcat(s, "g");
if (crc32("xBYEPVX",7) == 1967741629) strcat(s, "i");
if (crc32("DGSdZkXFEQiLS",13) == 2787609181) strcat(s, "l");
if (crc32("JHuZCaiqPTPMQHE",15) == 1747670414) strcat(s, "l");
if (crc32("olUNFBMws",9) == 2444668504) strcat(s, "y");
    return s;
}

char *concerningly_adverbs() {
    char *s = calloc(13);
    if (crc32("kRQjFyXhmZOIjuv",15) == 2097574635) strcat(s, "a");
if (crc32("AfddWu",6) == 1304147727) strcat(s, "c");
if (crc32("QcdJVYNEFTH",11) == 2751424995) strcat(s, "o");
if (crc32("pgkUy",5) == 1633780841) strcat(s, "J");
if (crc32("ZQyWMq",6) == 79022984) strcat(s, "n");
if (crc32("QyDbIV",6) == 4194930830) strcat(s, "y");
if (crc32("mAeXBunrrzCsG",13) == 4135381556) strcat(s, "c");
if (crc32("JqEoIgk",7) == 2979363676) strcat(s, "k");
if (crc32("AMUgn",5) == 537811808) strcat(s, "e");
if (crc32("gKuGoRzCPQxCtwu",15) == 2708818919) strcat(s, "U");
if (crc32("FjpMeRH",7) == 1038232721) strcat(s, "r");
if (crc32("DAGpBJPqA",9) == 2656509433) strcat(s, "N");
if (crc32("QxouPXlZOq",10) == 225039382) strcat(s, "n");
if (crc32("xzvWdwqA",8) == 3619815454) strcat(s, "i");
if (crc32("KraxhlSG",8) == 2790883373) strcat(s, "n");
if (crc32("oGHBcqcz",8) == 2933743469) strcat(s, "g");
if (crc32("uNQIqRFGdx",10) == 3152917515) strcat(s, "l");
if (crc32("RLGpzSmHQVE",11) == 2023587989) strcat(s, "U");
if (crc32("TQugMyGcUj",10) == 4244658504) strcat(s, "y");
    return s;
}

char *predoubtfully_adverbs() {
    char *s = calloc(14);
    if (crc32("FxBTIWXJdh",10) == 3305175656) strcat(s, "e");
if (crc32("usJNIkDEenhX",12) == 44616813) strcat(s, "p");
if (crc32("WbWZqqF",7) == 1202598166) strcat(s, "D");
if (crc32("oAXJFLLvkbVJ",12) == 1751616019) strcat(s, "r");
if (crc32("bIrxyG",6) == 2991574730) strcat(s, "i");
if (crc32("RxRJuanF",8) == 2408976319) strcat(s, "e");
if (crc32("jnbYTNUxhRR",11) == 3652383162) strcat(s, "d");
if (crc32("URWSy",5) == 2800496492) strcat(s, "x");
if (crc32("rTDnqsOs",8) == 3588188106) strcat(s, "o");
if (crc32("kmHYIQQj",8) == 1366285433) strcat(s, "u");
if (crc32("bNvXfSulRvZml",13) == 3747547470) strcat(s, "Q");
if (crc32("sJsIv",5) == 1116939031) strcat(s, "b");
if (crc32("BTlYoTZ",7) == 633505548) strcat(s, "t");
if (crc32("ZQfoBUuejBDA",12) == 1983628915) strcat(s, "r");
if (crc32("InyiBIFj",8) == 1969503774) strcat(s, "f");
if (crc32("jSdxBFV",7) == 1748445673) strcat(s, "y");
if (crc32("OBMenGgbns",10) == 280295308) strcat(s, "u");
if (crc32("sOrjVrOao",9) == 2706008175) strcat(s, "l");
if (crc32("EEAmKkuMcEUgC",13) == 1554332062) strcat(s, "L");
if (crc32("CravMBNvBVS",11) == 1425052627) strcat(s, "l");
if (crc32("yoIwZ",5) == 4222885408) strcat(s, "E");
if (crc32("HaWFgvHi",8) == 2397049711) strcat(s, "y");
    return s;
}

char *ruminantly_adverbs() {
    char *s = calloc(11);
    if (crc32("qGJYeRlE",8) == 3508216427) strcat(s, "a");
if (crc32("RbIiyTibBzCtSWs",15) == 2485988926) strcat(s, "r");
if (crc32("DnIWdVUOrXd",11) == 2436618607) strcat(s, "c");
if (crc32("eaKCiBINZUmd",12) == 1557431904) strcat(s, "u");
if (crc32("eekRTnqjyd",10) == 2410735126) strcat(s, "x");
if (crc32("NnBsAcFeGkobcd",14) == 3864555684) strcat(s, "m");
if (crc32("tYpgiZacX",9) == 261874422) strcat(s, "d");
if (crc32("pYVKWqtzzee",11) == 4159914179) strcat(s, "i");
if (crc32("XjiThCDMUQTT",12) == 1390492750) strcat(s, "K");
if (crc32("RffqAMxpmN",10) == 4070795489) strcat(s, "n");
if (crc32("YaBpuNDbngJRP",13) == 666023702) strcat(s, "a");
if (crc32("pXypUz",6) == 3567135613) strcat(s, "d");
if (crc32("GfZoWjIEpEULpTR",15) == 2191923432) strcat(s, "n");
if (crc32("KIZKmBNANWsdv",13) == 3756911351) strcat(s, "Z");
if (crc32("sAJUVcaFy",9) == 772241460) strcat(s, "t");
if (crc32("afdfiNWzHXg",11) == 1272920929) strcat(s, "l");
if (crc32("xjgbsAl",7) == 2340125408) strcat(s, "K");
if (crc32("IswXPoVhXnPFMK",14) == 1728516590) strcat(s, "y");
    return s;
}

char *bluntly_adverbs() {
    char *s = calloc(8);
    if (crc32("nySKNdjH",8) == 2945117540) strcat(s, "b");
if (crc32("KLqjfxWKHBMF",12) == 919413203) strcat(s, "l");
if (crc32("YgsAKZcFa",9) == 2797999092) strcat(s, "u");
if (crc32("AGbfYYaekhMdAV",14) == 1769956635) strcat(s, "n");
if (crc32("FhXmLuqrDaq",11) == 2044345043) strcat(s, "X");
if (crc32("UrEOlbp",7) == 3205259435) strcat(s, "t");
if (crc32("NlVDCElm",8) == 1732034034) strcat(s, "l");
if (crc32("BjyhjoLNKYWnG",13) == 3270738074) strcat(s, "y");
    return s;
}

char *megaphonically_adverbs() {
    char *s = calloc(15);
    if (crc32("xnawj",5) == 1349851715) strcat(s, "m");
if (crc32("EZpFX",5) == 2777748793) strcat(s, "Z");
if (crc32("TzhqNh",6) == 328025414) strcat(s, "e");
if (crc32("QBaBol",6) == 3272227884) strcat(s, "g");
if (crc32("JbaiKPTgYQSnwPB",15) == 1860565841) strcat(s, "g");
if (crc32("nbhmx",5) == 3027310378) strcat(s, "h");
if (crc32("XkqeGy",6) == 3028529933) strcat(s, "a");
if (crc32("EzBywXTpif",10) == 2833715) strcat(s, "i");
if (crc32("SCcnQvCwJDwkRht",15) == 1112245940) strcat(s, "p");
if (crc32("rsCYBRCpdvx",11) == 3924009379) strcat(s, "M");
if (crc32("KgMYtaQPdjDt",12) == 1042149427) strcat(s, "h");
if (crc32("xfqPHej",7) == 1486725236) strcat(s, "o");
if (crc32("QZbvSUyK",8) == 1355315835) strcat(s, "c");
if (crc32("CFrZinGsdYMwSv",14) == 1387712451) strcat(s, "n");
if (crc32("BmmjPYWfiAl",11) == 739612745) strcat(s, "T");
if (crc32("GYTjrCiqH",9) == 1810908883) strcat(s, "i");
if (crc32("URQCUHszoX",10) == 3751875140) strcat(s, "u");
if (crc32("ukWWIGmtBXPXp",13) == 2999495787) strcat(s, "c");
if (crc32("WYWFlbtgIXSV",12) == 1902440362) strcat(s, "a");
if (crc32("JxpjACB",7) == 4136325688) strcat(s, "S");
if (crc32("dbAEZZFHPCBRZ",13) == 1289159736) strcat(s, "l");
if (crc32("RMTCIhQFSxNoqMY",15) == 323128337) strcat(s, "C");
if (crc32("pnJhegvtbtTXJ",13) == 3650399528) strcat(s, "l");
if (crc32("ZSPFwB",6) == 617746036) strcat(s, "y");
    return s;
}

char *decennially_adverbs() {
    char *s = calloc(12);
    if (crc32("nTMCltuZMmT",11) == 3693444117) strcat(s, "d");
if (crc32("gEUTtQPZWe",10) == 3178754118) strcat(s, "C");
if (crc32("tKmxVWxkAvoOHzR",15) == 4210831186) strcat(s, "e");
if (crc32("WWMnLezjoc",10) == 2570339026) strcat(s, "c");
if (crc32("wJYxwVBKZNACvO",14) == 557473684) strcat(s, "i");
if (crc32("XLgTqRsIBe",10) == 127957373) strcat(s, "e");
if (crc32("AFxdTt",6) == 1246883045) strcat(s, "J");
if (crc32("KeAMTt",6) == 1473949583) strcat(s, "n");
if (crc32("heoYjP",6) == 4041667610) strcat(s, "n");
if (crc32("iGMOlP",6) == 382004095) strcat(s, "E");
if (crc32("wgjGWwNuEN",10) == 1618525068) strcat(s, "i");
if (crc32("ieWCopcbl",9) == 1035017022) strcat(s, "L");
if (crc32("WYfDmUfRbU",10) == 3109378140) strcat(s, "a");
if (crc32("DrUOokbQMHYYA",13) == 1033762258) strcat(s, "r");
if (crc32("XgQhG",5) == 1079168438) strcat(s, "l");
if (crc32("kHIsOp",6) == 2800141057) strcat(s, "j");
if (crc32("PTtLk",5) == 1862981750) strcat(s, "l");
if (crc32("qiEdTGLHiMF",11) == 2356716321) strcat(s, "w");
if (crc32("TEkjOMeNq",9) == 1009621484) strcat(s, "y");
    return s;
}

char *scintillantly_adverbs() {
    char *s = calloc(14);
    if (crc32("pSwMPN",6) == 3851457665) strcat(s, "F");
if (crc32("VWMgHyv",7) == 4083327536) strcat(s, "s");
if (crc32("HRUbGmqWJyRNb",13) == 1579015239) strcat(s, "m");
if (crc32("lXBAWOIDLMniMnL",15) == 4288162542) strcat(s, "c");
if (crc32("gUyzTtJzu",9) == 2312590217) strcat(s, "K");
if (crc32("DiwAIzaRDYH",11) == 2340427054) strcat(s, "i");
if (crc32("LTOSGAqLiqUL",12) == 2505536375) strcat(s, "n");
if (crc32("odERVKbJsoW",11) == 3554066360) strcat(s, "B");
if (crc32("bnTsHVmtdgOtv",13) == 3133178657) strcat(s, "t");
if (crc32("QvAOutLEYXSc",12) == 1057993914) strcat(s, "a");
if (crc32("SIXBHZfa",8) == 2607799310) strcat(s, "i");
if (crc32("JGbfWNwAdwPc",12) == 652763924) strcat(s, "F");
if (crc32("yQpEU",5) == 2209311503) strcat(s, "l");
if (crc32("bkEZhqEltIbSW",13) == 452125126) strcat(s, "l");
if (crc32("PSWRRryQEk",10) == 1785752901) strcat(s, "o");
if (crc32("SpVccxdPuFNjyC",14) == 2406874990) strcat(s, "a");
if (crc32("weoEPSTW",8) == 1557572820) strcat(s, "k");
if (crc32("pJDOgNWRFBhOVS",14) == 1693750433) strcat(s, "n");
if (crc32("nodjqupQIAgCr",13) == 609637090) strcat(s, "U");
if (crc32("BwoMApjvjLTAQE",14) == 452222595) strcat(s, "t");
if (crc32("SFsZaccnXP",10) == 3446966629) strcat(s, "I");
if (crc32("ktakvnE",7) == 1638875549) strcat(s, "l");
if (crc32("pEdhSuzkR",9) == 2513532084) strcat(s, "y");
    return s;
}

char *astringently_adverbs() {
    char *s = calloc(13);
    if (crc32("UbYiAhaqGTYNiW",14) == 793655971) strcat(s, "O");
if (crc32("hFkUJqwTsq",10) == 2757933345) strcat(s, "a");
if (crc32("IdSGiG",6) == 97326174) strcat(s, "s");
if (crc32("tGYTM",5) == 2371643919) strcat(s, "Z");
if (crc32("pfXDYEBRgwsRvK",14) == 386461603) strcat(s, "t");
if (crc32("mktrqfh",7) == 4255581430) strcat(s, "r");
if (crc32("xuEIaewZpdhxd",13) == 1735931128) strcat(s, "i");
if (crc32("rdLDjCYvdg",10) == 2844537066) strcat(s, "Y");
if (crc32("HOlZhXrx",8) == 4284897652) strcat(s, "n");
if (crc32("uFuvrTGyo",9) == 1102857831) strcat(s, "g");
if (crc32("huUZdmYPuWcFP",13) == 1344375625) strcat(s, "e");
if (crc32("BBEfwAImiUtt",12) == 1128081661) strcat(s, "n");
if (crc32("ZiTixljgxEJwYG",14) == 3091375178) strcat(s, "t");
if (crc32("FuOuooNLXmbzn",13) == 3896249357) strcat(s, "l");
if (crc32("ZTRWcpDIOkrFIT",14) == 2814678489) strcat(s, "z");
if (crc32("yQGDKKXR",8) == 728508693) strcat(s, "y");
    return s;
}

char *anthropologically_adverbs() {
    char *s = calloc(18);
    if (crc32("iyjDOHqnQPDGGZQ",15) == 713040178) strcat(s, "X");
if (crc32("pjqmUzjeX",9) == 1711252610) strcat(s, "a");
if (crc32("snHsTGLQ",8) == 2612597892) strcat(s, "a");
if (crc32("UQNuzC",6) == 4211530367) strcat(s, "n");
if (crc32("gTsWolrYNrkYBZ",14) == 1102161229) strcat(s, "t");
if (crc32("jVvkAmL",7) == 3932810000) strcat(s, "M");
if (crc32("IFnuVUqiZvdgRmH",15) == 711370065) strcat(s, "h");
if (crc32("FCjlSNOIAp",10) == 4069447580) strcat(s, "r");
if (crc32("ACMVrqKKhPPnct",14) == 1482319970) strcat(s, "o");
if (crc32("JjKuXeU",7) == 3637194279) strcat(s, "S");
if (crc32("bKDEhMFhUV",10) == 671114830) strcat(s, "p");
if (crc32("IPfZVpEfSoXEVc",14) == 1260968138) strcat(s, "J");
if (crc32("kTabIblTtcMPSE",14) == 4228199920) strcat(s, "o");
if (crc32("xltLXs",6) == 3268720665) strcat(s, "g");
if (crc32("cZtIEfMvKWHGH",13) == 4231841838) strcat(s, "l");
if (crc32("KwlYO",5) == 3544092216) strcat(s, "o");
if (crc32("EbBQIvjOeESabWM",15) == 2588377800) strcat(s, "g");
if (crc32("xCzQdlCYWz",10) == 964205534) strcat(s, "i");
if (crc32("sEVFNZpZwLmjWEj",15) == 4288607522) strcat(s, "c");
if (crc32("LWrWQDiT",8) == 3986712635) strcat(s, "c");
if (crc32("CuPgvyJTFKdHB",13) == 3415681924) strcat(s, "a");
if (crc32("sdeBjfJ",7) == 2463161380) strcat(s, "N");
if (crc32("vgDLGLvlr",9) == 1802428331) strcat(s, "l");
if (crc32("yYQyFrnM",8) == 2882122166) strcat(s, "s");
if (crc32("qWGJKRzH",8) == 1833868894) strcat(s, "l");
if (crc32("OTLxLgXzlbgfkCJ",15) == 1604742637) strcat(s, "q");
if (crc32("CwCGH",5) == 2591714904) strcat(s, "y");
    return s;
}

char *calcareously_adverbs() {
    char *s = calloc(13);
    if (crc32("pVRMg",5) == 891702867) strcat(s, "g");
if (crc32("jPndn",5) == 931107717) strcat(s, "c");
if (crc32("zgBxKDMRnSN",11) == 3041770274) strcat(s, "k");
if (crc32("GnlcYpLxeEbX",12) == 3427974551) strcat(s, "a");
if (crc32("wlAEdMpJBpu",11) == 1658537366) strcat(s, "l");
if (crc32("mjvHyichvYK",11) == 3821268625) strcat(s, "c");
if (crc32("DYNJjmjjXkBtxiW",15) == 847729761) strcat(s, "a");
if (crc32("RYkcRSgD",8) == 742283931) strcat(s, "r");
if (crc32("BGsDjey",7) == 140691555) strcat(s, "g");
if (crc32("XBxRD",5) == 1552048150) strcat(s, "e");
if (crc32("nKwsGlUuAKONmuB",15) == 2794412386) strcat(s, "o");
if (crc32("SDdjncbajduw",12) == 1591575076) strcat(s, "u");
if (crc32("tpTsPCItkU",10) == 3679867785) strcat(s, "s");
if (crc32("kIynyerKjCHjW",13) == 2500924778) strcat(s, "l");
if (crc32("WePNwln",7) == 1375952970) strcat(s, "y");
    return s;
}

char *nontemperately_adverbs() {
    char *s = calloc(15);
    if (crc32("iGUUvMpSmJ",10) == 2704138956) strcat(s, "u");
if (crc32("YojlnLcoEBDAoHa",15) == 2640456516) strcat(s, "n");
if (crc32("NJseEzqTKWppJ",13) == 586072779) strcat(s, "o");
if (crc32("mSCevrycu",9) == 587308219) strcat(s, "o");
if (crc32("cIaPnPhWZW",10) == 3156745338) strcat(s, "n");
if (crc32("ZCIXXKmH",8) == 1330300344) strcat(s, "f");
if (crc32("KxHTu",5) == 3350976429) strcat(s, "t");
if (crc32("YOhmev",6) == 1603402608) strcat(s, "e");
if (crc32("PSritTe",7) == 4082607251) strcat(s, "d");
if (crc32("amThqoEeDnp",11) == 30046385) strcat(s, "m");
if (crc32("kpZHwNcrzs",10) == 4150547972) strcat(s, "D");
if (crc32("zkJsq",5) == 3346668792) strcat(s, "p");
if (crc32("vHarnoix",8) == 2343408178) strcat(s, "f");
if (crc32("PzCmqEFYjX",10) == 96276022) strcat(s, "e");
if (crc32("eEwqnotlEnSDlc",14) == 4105068500) strcat(s, "r");
if (crc32("injZj",5) == 562696575) strcat(s, "a");
if (crc32("TmPLKuzvJamtR",13) == 2704422240) strcat(s, "W");
if (crc32("QqssFlnk",8) == 1541003650) strcat(s, "t");
if (crc32("uzLnKiLBytUly",13) == 3180296534) strcat(s, "e");
if (crc32("xlIqsZ",6) == 921842508) strcat(s, "l");
if (crc32("FAKyjcAefkPSpM",14) == 3261051829) strcat(s, "x");
if (crc32("mfQDqKHPWH",10) == 2443073221) strcat(s, "y");
    return s;
}

char *adinfinitum_adverbs() {
    char *s = calloc(12);
    if (crc32("XBuhvwgoSLOu",12) == 2189986958) strcat(s, "a");
if (crc32("FvbkhP",6) == 229897903) strcat(s, "d");
if (crc32("ZZnGYdjIulev",12) == 2689140280) strcat(s, "Q");
if (crc32("mjFJkp",6) == 3277069932) strcat(s, "i");
if (crc32("AjfFfaRUGDzQS",13) == 1381915317) strcat(s, "K");
if (crc32("rwfmTTrIDZgdcAn",15) == 4120991147) strcat(s, "n");
if (crc32("TAJAYs",6) == 1690960782) strcat(s, "f");
if (crc32("CYizxvUSMMtZT",13) == 3434924604) strcat(s, "F");
if (crc32("ncBnUQQDTsjfr",13) == 695210975) strcat(s, "i");
if (crc32("fOeHAilCPxMyU",13) == 1280866656) strcat(s, "z");
if (crc32("HaBlsu",6) == 2721479211) strcat(s, "n");
if (crc32("uKXkUBsmz",9) == 126002030) strcat(s, "b");
if (crc32("gCsZFpUreGZC",12) == 2563817823) strcat(s, "i");
if (crc32("wwrqDHt",7) == 3930992064) strcat(s, "t");
if (crc32("VgReCURCGd",10) == 1041192359) strcat(s, "u");
if (crc32("MydLf",5) == 3350537067) strcat(s, "m");
    return s;
}

char *semipoisonously_adverbs() {
    char *s = calloc(16);
    if (crc32("QuVtPCcbpukCyjJ",15) == 2024951224) strcat(s, "s");
if (crc32("QXipGd",6) == 3485295269) strcat(s, "a");
if (crc32("KhcLTskb",8) == 2374121224) strcat(s, "e");
if (crc32("ypJApbtLbWcN",12) == 3908791612) strcat(s, "f");
if (crc32("dhHezkLAkNKvgB",14) == 2402428742) strcat(s, "m");
if (crc32("NGhjcTJjHlhA",12) == 295968630) strcat(s, "i");
if (crc32("oPcLotxuE",9) == 51569505) strcat(s, "p");
if (crc32("mMKPTwUyprMLo",13) == 1059032240) strcat(s, "N");
if (crc32("HbzTNbc",7) == 2714612647) strcat(s, "o");
if (crc32("kkYnZQ",6) == 2506582744) strcat(s, "i");
if (crc32("EVYUaDkDs",9) == 2555630354) strcat(s, "F");
if (crc32("bcJMqnGttXnYLN",14) == 2466264762) strcat(s, "s");
if (crc32("ESYBfeGhnNmcZ",13) == 852927307) strcat(s, "b");
if (crc32("BItZLbyMlDG",11) == 2297339659) strcat(s, "o");
if (crc32("WceNQ",5) == 1493743113) strcat(s, "n");
if (crc32("DltllIiXzB",10) == 4132162907) strcat(s, "E");
if (crc32("MhsmkiwQMTRG",12) == 1834605780) strcat(s, "o");
if (crc32("hWMktnfQgXmjE",13) == 2619750353) strcat(s, "u");
if (crc32("IWoYJB",6) == 2177539205) strcat(s, "s");
if (crc32("oSAnASbFWQORZU",14) == 2055656842) strcat(s, "l");
if (crc32("BtYKnYgJDo",10) == 937041453) strcat(s, "H");
if (crc32("fsUkouIbIlG",11) == 3350890689) strcat(s, "y");
    return s;
}

char *nonadjectively_adverbs() {
    char *s = calloc(15);
    if (crc32("REYNXCjiiPDUa",13) == 3410178334) strcat(s, "M");
if (crc32("gFVCDd",6) == 837844751) strcat(s, "n");
if (crc32("WmqEGsTbSA",10) == 1358495877) strcat(s, "o");
if (crc32("zgNBodRYEsP",11) == 192151236) strcat(s, "Z");
if (crc32("kDOoCKWGRQTEGa",14) == 3929209925) strcat(s, "n");
if (crc32("xfRYLK",6) == 2866649305) strcat(s, "f");
if (crc32("aSDwVoGuFAzdwW",14) == 1479711536) strcat(s, "a");
if (crc32("EnSYB",5) == 278525532) strcat(s, "d");
if (crc32("IkTwaWyGSRIpCs",14) == 1305679200) strcat(s, "j");
if (crc32("lJxxqCmv",8) == 3704320722) strcat(s, "P");
if (crc32("xBnAK",5) == 1958268115) strcat(s, "e");
if (crc32("HUWzLFUkNpHH",12) == 4274233717) strcat(s, "c");
if (crc32("aNdgnRmbw",9) == 1705885006) strcat(s, "t");
if (crc32("eShUejgLwa",10) == 3097334811) strcat(s, "g");
if (crc32("MimGcDzoyEsRlhi",15) == 3711724313) strcat(s, "i");
if (crc32("NCZsO",5) == 1622294303) strcat(s, "V");
if (crc32("mgxsBDibAPF",11) == 3159677692) strcat(s, "v");
if (crc32("wFDli",5) == 3149060412) strcat(s, "x");
if (crc32("NRZLGERszgv",11) == 3838463524) strcat(s, "e");
if (crc32("qnKNn",5) == 3963513801) strcat(s, "w");
if (crc32("dOkyXSreZMewD",13) == 2407734716) strcat(s, "l");
if (crc32("BFtuJddMsRyG",12) == 1326762607) strcat(s, "U");
if (crc32("XDoicyrYTHOeL",13) == 2295631311) strcat(s, "y");
    return s;
}

char *unjudicially_adverbs() {
    char *s = calloc(13);
    if (crc32("YltkNkaun",9) == 1603726137) strcat(s, "Z");
if (crc32("ayxveunPZEiRdgu",15) == 3687867230) strcat(s, "u");
if (crc32("EtxbVwusaPvau",13) == 4009231156) strcat(s, "n");
if (crc32("IOMtnd",6) == 714422151) strcat(s, "i");
if (crc32("XJigZEGqL",9) == 2129903133) strcat(s, "j");
if (crc32("fkXmcYXYmY",10) == 2578766056) strcat(s, "u");
if (crc32("pCtcMxGGaDDHifL",15) == 3912181616) strcat(s, "d");
if (crc32("YfdcjROBj",9) == 3181509382) strcat(s, "q");
if (crc32("EGtCZChxrYfdx",13) == 3911137255) strcat(s, "i");
if (crc32("MDsXdrhi",8) == 2555397731) strcat(s, "c");
if (crc32("FcLCkayQV",9) == 636090485) strcat(s, "P");
if (crc32("YqcLZdWrptn",11) == 2152648364) strcat(s, "i");
if (crc32("MuLioabjo",9) == 276872901) strcat(s, "a");
if (crc32("giShtOmHXuoCdwv",15) == 2411187936) strcat(s, "l");
if (crc32("ySFmqpOlPRXzvG",14) == 3087018021) strcat(s, "l");
if (crc32("MlQdVfocWu",10) == 3825776755) strcat(s, "y");
    return s;
}

char *revoltingly_adverbs() {
    char *s = calloc(12);
    if (crc32("OSzZylRV",8) == 46601098) strcat(s, "r");
if (crc32("QOHkdRTn",8) == 1177281425) strcat(s, "A");
if (crc32("guQTLt",6) == 2258741881) strcat(s, "e");
if (crc32("yNWTKcOvKYGYl",13) == 2754089472) strcat(s, "v");
if (crc32("fUjBBovyi",9) == 1652116019) strcat(s, "o");
if (crc32("wHLxtbj",7) == 717011299) strcat(s, "v");
if (crc32("YEXJMSttrZawA",13) == 297588768) strcat(s, "l");
if (crc32("iETqLZrePZ",10) == 1964555832) strcat(s, "t");
if (crc32("QQHsNWdoUDjeeC",14) == 870485278) strcat(s, "e");
if (crc32("VQbIeEFavBnlj",13) == 2579619870) strcat(s, "i");
if (crc32("keMNgXRrLiwO",12) == 1713098925) strcat(s, "n");
if (crc32("PinuY",5) == 3131638422) strcat(s, "g");
if (crc32("SBTFSquFsZ",10) == 1585988582) strcat(s, "l");
if (crc32("kQryF",5) == 1833321378) strcat(s, "y");
    return s;
}

char *springingly_adverbs() {
    char *s = calloc(12);
    if (crc32("qPFyiHTlnySjMbH",15) == 2550336860) strcat(s, "B");
if (crc32("fvvrpYIN",8) == 452649807) strcat(s, "s");
if (crc32("MMOANM",6) == 3950053914) strcat(s, "c");
if (crc32("rMfGrHFijWJPE",13) == 3611487617) strcat(s, "p");
if (crc32("ueFJeCtPyht",11) == 858858742) strcat(s, "L");
if (crc32("lgkyrXCJwQmx",12) == 717149957) strcat(s, "r");
if (crc32("nezaOkSOwROV",12) == 3122309821) strcat(s, "k");
if (crc32("QfHDpkGWn",9) == 1230575495) strcat(s, "i");
if (crc32("FOknHSmzRXBzBAy",15) == 1865534569) strcat(s, "n");
if (crc32("FnnRiq",6) == 1445387506) strcat(s, "d");
if (crc32("ExCJuovbKbGJ",12) == 544561204) strcat(s, "g");
if (crc32("sdGTCwnZDgv",11) == 3136015076) strcat(s, "i");
if (crc32("MzpuCqMv",8) == 2240935355) strcat(s, "n");
if (crc32("lvwaH",5) == 2179694464) strcat(s, "g");
if (crc32("BRDNgly",7) == 1947202499) strcat(s, "l");
if (crc32("BWNrpelYkteOn",13) == 2058601408) strcat(s, "y");
    return s;
}

char *subperiosteally_adverbs() {
    char *s = calloc(16);
    if (crc32("KWkLvxbENVC",11) == 386109086) strcat(s, "F");
if (crc32("VIAPHRqSLblOhsb",15) == 2641131386) strcat(s, "s");
if (crc32("SLzdNSUltRdLKH",14) == 974728075) strcat(s, "W");
if (crc32("yAbyBUtXb",9) == 872169867) strcat(s, "u");
if (crc32("OlYNvE",6) == 2698774747) strcat(s, "b");
if (crc32("RuzmImANCxRUPRw",15) == 2962989594) strcat(s, "b");
if (crc32("QQcoTFBOxJ",10) == 2289544530) strcat(s, "p");
if (crc32("IrZQGRXDh",9) == 71173543) strcat(s, "e");
if (crc32("DsDNZnC",7) == 4011654459) strcat(s, "m");
if (crc32("xtsNhIXAoHlXuSn",15) == 847562307) strcat(s, "r");
if (crc32("LFVSaWTT",8) == 3239555991) strcat(s, "i");
if (crc32("yIOYdRqWDzVvpf",14) == 2803189972) strcat(s, "F");
if (crc32("qrOKeD",6) == 606993481) strcat(s, "o");
if (crc32("BUdPDUZXWx",10) == 1064654518) strcat(s, "s");
if (crc32("gsODaeOZDwJ",11) == 1921658379) strcat(s, "c");
if (crc32("tREOda",6) == 2408247104) strcat(s, "t");
if (crc32("soJeBr",6) == 3790058069) strcat(s, "e");
if (crc32("lYRRfuswN",9) == 235231357) strcat(s, "a");
if (crc32("kxBeYm",6) == 285330707) strcat(s, "u");
if (crc32("GjjNYsJ",7) == 3968888787) strcat(s, "l");
if (crc32("ZMrhAMRwFXcWWx",14) == 860541750) strcat(s, "Y");
if (crc32("slgjMEXzSlm",11) == 1554830285) strcat(s, "l");
if (crc32("MbQvYXYhOJ",10) == 1482060914) strcat(s, "Z");
if (crc32("IXRPArZ",7) == 3256070702) strcat(s, "y");
    return s;
}

char *bovinely_adverbs() {
    char *s = calloc(9);
    if (crc32("PibfdQmxcG",10) == 1931892366) strcat(s, "b");
if (crc32("hzveaUhg",8) == 897750154) strcat(s, "o");
if (crc32("HtPZTcQDU",9) == 603173606) strcat(s, "v");
if (crc32("RDAUP",5) == 3635466803) strcat(s, "B");
if (crc32("lnRojCUsxDKajRK",15) == 2996200047) strcat(s, "i");
if (crc32("bGygMdPmGP",10) == 4047519229) strcat(s, "n");
if (crc32("dKxVhLqqvYYCm",13) == 3956756883) strcat(s, "n");
if (crc32("AZgmZQomPySujQ",14) == 559406808) strcat(s, "e");
if (crc32("wyrVfzauQOKYGh",14) == 217978048) strcat(s, "D");
if (crc32("yMtwQnzWFip",11) == 1287604262) strcat(s, "l");
if (crc32("mMJEwbBrVHl",11) == 889811439) strcat(s, "e");
if (crc32("xSeznXeuEo",10) == 2844029232) strcat(s, "y");
    return s;
}

char *overtenaciously_adverbs() {
    char *s = calloc(16);
    if (crc32("DiVTYAlFbMobo",13) == 174030321) strcat(s, "o");
if (crc32("tHFthuvJChZCv",13) == 1117882719) strcat(s, "v");
if (crc32("oOJLnrLqwR",10) == 700308987) strcat(s, "e");
if (crc32("HZYRgCxex",9) == 496553103) strcat(s, "n");
if (crc32("XgEnInAeHKaKsE",14) == 3882178285) strcat(s, "r");
if (crc32("XAWcWcQRIPl",11) == 2878455990) strcat(s, "J");
if (crc32("loYaqaRlVu",10) == 1145595860) strcat(s, "t");
if (crc32("iPBTGpvMzcE",11) == 1549859552) strcat(s, "e");
if (crc32("JQXknERcAnH",11) == 2006504695) strcat(s, "l");
if (crc32("NUwJZDdmXGeR",12) == 2493618041) strcat(s, "n");
if (crc32("RokTOU",6) == 9758748) strcat(s, "a");
if (crc32("YYFobXGBDKIvqko",15) == 1386256652) strcat(s, "c");
if (crc32("kZxJghmnZHrdVb",14) == 2012110086) strcat(s, "i");
if (crc32("zEibYUmZ",8) == 85422883) strcat(s, "o");
if (crc32("hDywAcKBJwaZHu",14) == 2236046783) strcat(s, "t");
if (crc32("CrWSMWflXxDr",12) == 582048357) strcat(s, "u");
if (crc32("phllGSlcC",9) == 341719262) strcat(s, "F");
if (crc32("sUPHzHc",7) == 3479251964) strcat(s, "s");
if (crc32("kvsqAObXBV",10) == 2358570965) strcat(s, "l");
if (crc32("HqkfZ",5) == 891484416) strcat(s, "Q");
if (crc32("TXzQzSDpk",9) == 682099848) strcat(s, "y");
    return s;
}

char *unpolitely_adverbs() {
    char *s = calloc(11);
    if (crc32("eXhcJvyons",10) == 770675600) strcat(s, "S");
if (crc32("LeGskORvdWTd",12) == 2615051571) strcat(s, "u");
if (crc32("yHljkUkSV",9) == 3760575886) strcat(s, "n");
if (crc32("VKxSfckfi",9) == 3129081312) strcat(s, "p");
if (crc32("QkSvmotpRKDdu",13) == 2275523887) strcat(s, "L");
if (crc32("ibpGYezKpnyYrQj",15) == 2424809355) strcat(s, "o");
if (crc32("GPNZgymYUsSnY",13) == 2639187328) strcat(s, "l");
if (crc32("YpFSpX",6) == 4187697003) strcat(s, "i");
if (crc32("hlVGLnh",7) == 1566248061) strcat(s, "L");
if (crc32("ScBDMqWEvdZMG",13) == 98543279) strcat(s, "t");
if (crc32("tAqQFlhK",8) == 3427284918) strcat(s, "X");
if (crc32("KyXBILYim",9) == 990579441) strcat(s, "e");
if (crc32("nxvvrnaQDdMEs",13) == 2578043288) strcat(s, "j");
if (crc32("xQuhQYomg",9) == 2641444831) strcat(s, "l");
if (crc32("hQCHAMHpvzWB",12) == 1549042732) strcat(s, "y");
    return s;
}

char *progressionally_adverbs() {
    char *s = calloc(16);
    if (crc32("wKyTHowiqfzqIW",14) == 639167067) strcat(s, "e");
if (crc32("wbKwpAisJylOWS",14) == 3698678284) strcat(s, "p");
if (crc32("SMkfeEUfWruys",13) == 1291050771) strcat(s, "r");
if (crc32("ZOoPnbWsUd",10) == 1944568465) strcat(s, "V");
if (crc32("fQQxQOSysQBXa",13) == 127702361) strcat(s, "o");
if (crc32("AvIGW",5) == 3633959550) strcat(s, "g");
if (crc32("MXEOrVbY",8) == 2932679074) strcat(s, "r");
if (crc32("AmrgXGzoo",9) == 1655065289) strcat(s, "e");
if (crc32("JZXLYr",6) == 3488217639) strcat(s, "s");
if (crc32("ZcdAgcVs",8) == 493126615) strcat(s, "t");
if (crc32("jxJmBxOyg",9) == 3736460513) strcat(s, "s");
if (crc32("wOVuD",5) == 1987735420) strcat(s, "m");
if (crc32("JIBacQcruVshtV",14) == 1441552549) strcat(s, "i");
if (crc32("jqhXAcSGfyT",11) == 3514018549) strcat(s, "U");
if (crc32("cjOinCVqv",9) == 396672765) strcat(s, "o");
if (crc32("PjsLOiMqpSv",11) == 2267829709) strcat(s, "Y");
if (crc32("UWvLWXrRBzsV",12) == 3908626610) strcat(s, "n");
if (crc32("lulPVjbSHdmxlnj",15) == 1736626874) strcat(s, "q");
if (crc32("gXVMKnluDgWvy",13) == 22980191) strcat(s, "a");
if (crc32("UYRZSYBgmstrw",13) == 1608642741) strcat(s, "G");
if (crc32("xZlWRzplpYGp",12) == 4059991434) strcat(s, "l");
if (crc32("qQofiXvI",8) == 1110918745) strcat(s, "X");
if (crc32("MvhWSgJDbnph",12) == 1052088329) strcat(s, "l");
if (crc32("ZoXzZ",5) == 3614115899) strcat(s, "X");
if (crc32("ZzWGlOllj",9) == 1922954109) strcat(s, "y");
    return s;
}

char *accusatively_adverbs() {
    char *s = calloc(13);
    if (crc32("xzPJV",5) == 4011876629) strcat(s, "a");
if (crc32("clknEe",6) == 2111372964) strcat(s, "c");
if (crc32("ofVJfULlKmOPFV",14) == 461392875) strcat(s, "c");
if (crc32("tBiSBaBzy",9) == 2591337101) strcat(s, "u");
if (crc32("XYDepyFryxedMp",14) == 2860173276) strcat(s, "N");
if (crc32("WIYolQozH",9) == 1210635892) strcat(s, "s");
if (crc32("LLXMU",5) == 3916673144) strcat(s, "X");
if (crc32("oYPydk",6) == 918551448) strcat(s, "a");
if (crc32("nNiDQfruCvY",11) == 583487147) strcat(s, "G");
if (crc32("jBLMQg",6) == 3815302990) strcat(s, "t");
if (crc32("tkRfVKcpDVjIO",13) == 3583802870) strcat(s, "i");
if (crc32("ZyTkCqEFiAJIP",13) == 2708373673) strcat(s, "N");
if (crc32("TGGAZjiO",8) == 4051701584) strcat(s, "v");
if (crc32("pfjRieRHkQXAO",13) == 1026924128) strcat(s, "G");
if (crc32("cYZEhEpEl",9) == 2311915236) strcat(s, "e");
if (crc32("JwvATHpJrcVvhh",14) == 145890766) strcat(s, "l");
if (crc32("VsydqdhcuWHh",12) == 2943176229) strcat(s, "y");
    return s;
}

char *overcontentedly_adverbs() {
    char *s = calloc(16);
    if (crc32("PsDOnjUaEcHVSkx",15) == 2756233654) strcat(s, "X");
if (crc32("likiojGhOXk",11) == 507367604) strcat(s, "o");
if (crc32("SJELoVC",7) == 553407239) strcat(s, "v");
if (crc32("rUdnbgzGoUir",12) == 2556787280) strcat(s, "a");
if (crc32("wzXVWLzzgGtVv",13) == 3522683124) strcat(s, "e");
if (crc32("rbMJKYgmmRuVoZ",14) == 2650964010) strcat(s, "R");
if (crc32("wjXeVbVuitfHTT",14) == 1803284949) strcat(s, "r");
if (crc32("eiXMSofKFbHg",12) == 1406984822) strcat(s, "T");
if (crc32("udXDcXnwBvKTAN",14) == 1502324482) strcat(s, "c");
if (crc32("CEViPoeUy",9) == 4106888230) strcat(s, "o");
if (crc32("tyRPU",5) == 314924277) strcat(s, "n");
if (crc32("WLPXuS",6) == 4110109388) strcat(s, "W");
if (crc32("odxuLlRtMGxjt",13) == 4127318726) strcat(s, "t");
if (crc32("JbTINci",7) == 320759030) strcat(s, "e");
if (crc32("TWOJgfeldkCV",12) == 2110379442) strcat(s, "c");
if (crc32("tRTQolzh",8) == 3744446720) strcat(s, "n");
if (crc32("oxmyHoV",7) == 1855090661) strcat(s, "t");
if (crc32("CZYUZXmyuYAUpeu",15) == 339594890) strcat(s, "a");
if (crc32("vFIwDvTv",8) == 1759049623) strcat(s, "e");
if (crc32("rmOwGP",6) == 3490709533) strcat(s, "d");
if (crc32("IUGPlkmUgynuHs",14) == 1772300771) strcat(s, "O");
if (crc32("ROSsLSLKKq",10) == 3351437706) strcat(s, "l");
if (crc32("QQWAqlapfvpC",12) == 1867974355) strcat(s, "y");
    return s;
}

char *inutilely_adverbs() {
    char *s = calloc(10);
    if (crc32("XEyeV",5) == 2737431524) strcat(s, "i");
if (crc32("eehwsNnWM",9) == 3869656117) strcat(s, "a");
if (crc32("vPOalkA",7) == 2172427336) strcat(s, "n");
if (crc32("jllRzKVvzaGWHRI",15) == 617132722) strcat(s, "h");
if (crc32("vWvVT",5) == 921808564) strcat(s, "u");
if (crc32("qHcIWzlONxD",11) == 3042435624) strcat(s, "t");
if (crc32("BiKIUuSnxXoZta",14) == 1833765915) strcat(s, "i");
if (crc32("vgUaIpLndgouG",13) == 741527061) strcat(s, "I");
if (crc32("Cmmfaiqxv",9) == 2549849216) strcat(s, "l");
if (crc32("raetubPy",8) == 1982663967) strcat(s, "e");
if (crc32("dzhuaSvC",8) == 3189974004) strcat(s, "u");
if (crc32("SpulBTSftkvWaP",14) == 508008175) strcat(s, "l");
if (crc32("yYCSdCtPEEFQ",12) == 1735151311) strcat(s, "t");
if (crc32("KYOmuElQOhgvBT",14) == 26854296) strcat(s, "y");
    return s;
}

char *definably_adverbs() {
    char *s = calloc(10);
    if (crc32("jPCEmMxbGEdDk",13) == 833436066) strcat(s, "l");
if (crc32("AlZUlesSFwB",11) == 2994608547) strcat(s, "d");
if (crc32("FkmuR",5) == 1067280442) strcat(s, "d");
if (crc32("QYEJGODkQ",9) == 3052134530) strcat(s, "e");
if (crc32("TQslotrvxTRdK",13) == 1510540052) strcat(s, "d");
if (crc32("eVLrIUIZNlM",11) == 4018134587) strcat(s, "f");
if (crc32("sRlHMnANqHzzgU",14) == 2784138936) strcat(s, "i");
if (crc32("jsujwz",6) == 626348831) strcat(s, "h");
if (crc32("ehLFjNxNEhSuK",13) == 3518130900) strcat(s, "n");
if (crc32("jOMRUxX",7) == 1709369822) strcat(s, "a");
if (crc32("gWGZOHY",7) == 3712227429) strcat(s, "b");
if (crc32("JnatjLtAB",9) == 357502399) strcat(s, "C");
if (crc32("KlUOXLHGMPBO",12) == 329413700) strcat(s, "l");
if (crc32("kbCFXfBjw",9) == 1051201062) strcat(s, "p");
if (crc32("thnSLE",6) == 1732933431) strcat(s, "y");
    return s;
}

char *valorously_adverbs() {
    char *s = calloc(11);
    if (crc32("UYeZQNTqHGqqp",13) == 1325571137) strcat(s, "u");
if (crc32("MfGtc",5) == 2452739183) strcat(s, "v");
if (crc32("xKkLKZadSQ",10) == 41624202) strcat(s, "a");
if (crc32("uhrTX",5) == 3851467494) strcat(s, "l");
if (crc32("HeIVnp",6) == 2035302486) strcat(s, "p");
if (crc32("zjacwjUMrDBE",12) == 1530390628) strcat(s, "o");
if (crc32("ttwaygYzofVn",12) == 1106700632) strcat(s, "r");
if (crc32("XAtCOL",6) == 1294673567) strcat(s, "v");
if (crc32("BFtyIaSpOSYj",12) == 966450712) strcat(s, "o");
if (crc32("jerveaE",7) == 328857825) strcat(s, "u");
if (crc32("ALHfUldwabvNup",14) == 712507114) strcat(s, "s");
if (crc32("wSbZRAhpTHSsAk",14) == 3207316088) strcat(s, "G");
if (crc32("KiWojXAgPxxNA",13) == 2331666162) strcat(s, "l");
if (crc32("VMPMlPRKPmXdwI",14) == 2127011794) strcat(s, "y");
    return s;
}

char *mindlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("ZtazYieVfg",10) == 2410799748) strcat(s, "m");
if (crc32("HyOOyYttvaAvi",13) == 750669275) strcat(s, "i");
if (crc32("xGItmal",7) == 2581944819) strcat(s, "n");
if (crc32("jJGAkPGNM",9) == 709689713) strcat(s, "N");
if (crc32("PftXYhwqaiyuxoK",15) == 2869206230) strcat(s, "d");
if (crc32("rgnngIDEi",9) == 150533255) strcat(s, "l");
if (crc32("itJiSSuU",8) == 1984672922) strcat(s, "e");
if (crc32("lvsCII",6) == 2643151486) strcat(s, "s");
if (crc32("LHkuGsYxqGNwN",13) == 4257653150) strcat(s, "s");
if (crc32("rHGvSOZuZCnzFhM",15) == 1895230449) strcat(s, "l");
if (crc32("QNLsJ",5) == 1392625783) strcat(s, "y");
    return s;
}

char *boldly_adverbs() {
    char *s = calloc(7);
    if (crc32("BGLzyqQVPSVNj",13) == 2196740165) strcat(s, "b");
if (crc32("YLLgQFmSMpAQSxC",15) == 1032695583) strcat(s, "o");
if (crc32("UCZRIWKEhs",10) == 2093116863) strcat(s, "I");
if (crc32("kPeKTSUxO",9) == 2932992799) strcat(s, "l");
if (crc32("mtSBmssfeR",10) == 3234231387) strcat(s, "d");
if (crc32("eJQEQHfWrO",10) == 868390936) strcat(s, "l");
if (crc32("pRMqG",5) == 4163523308) strcat(s, "y");
    return s;
}

char *unplatitudinously_adverbs() {
    char *s = calloc(18);
    if (crc32("qsdTXqZvGQX",11) == 3334492376) strcat(s, "u");
if (crc32("fsrxNct",7) == 2949378846) strcat(s, "m");
if (crc32("TCTEQTfflJXmBL",14) == 1851124190) strcat(s, "n");
if (crc32("oEZnk",5) == 834660881) strcat(s, "p");
if (crc32("BxBPCor",7) == 1845847272) strcat(s, "l");
if (crc32("aInbcSufXJtnNmv",15) == 3192093244) strcat(s, "a");
if (crc32("vYExR",5) == 255715270) strcat(s, "N");
if (crc32("UCTmDwDgCqbHek",14) == 1443781083) strcat(s, "t");
if (crc32("fDEPshQtd",9) == 1131052542) strcat(s, "r");
if (crc32("RdUAHphAm",9) == 3304883947) strcat(s, "i");
if (crc32("gdbze",5) == 2579551978) strcat(s, "F");
if (crc32("aLtGbiiIeoKIpLR",15) == 4278166916) strcat(s, "t");
if (crc32("xfKqnzyKuem",11) == 2146834072) strcat(s, "u");
if (crc32("tqivVTGPUSTgraP",15) == 4002201829) strcat(s, "Q");
if (crc32("xggjMPqeSWjpwY",14) == 1196715127) strcat(s, "d");
if (crc32("dDzePUXpLPkBAaD",15) == 3278252859) strcat(s, "r");
if (crc32("TPCtvUHhUrR",11) == 1644187244) strcat(s, "i");
if (crc32("pJUFIF",6) == 2657350273) strcat(s, "n");
if (crc32("VJlSscKM",8) == 2724383237) strcat(s, "x");
if (crc32("jultWEyS",8) == 3307843449) strcat(s, "o");
if (crc32("sIphfh",6) == 3758192112) strcat(s, "S");
if (crc32("PigHOtlFNbr",11) == 2939689042) strcat(s, "u");
if (crc32("JkBPCfYvfVkVB",13) == 3026102037) strcat(s, "s");
if (crc32("zDAdZHuPCMlnYW",14) == 157250505) strcat(s, "G");
if (crc32("NLRLDPDhfLPX",12) == 4041049712) strcat(s, "l");
if (crc32("ixinYog",7) == 1396135182) strcat(s, "U");
if (crc32("zOnUAsdjcQ",10) == 1854468378) strcat(s, "y");
    return s;
}

char *unnaovely_adverbs() {
    char *s = calloc(10);
    if (crc32("URQAqjB",7) == 3636217501) strcat(s, "N");
if (crc32("Bcwrjvo",7) == 2876538461) strcat(s, "u");
if (crc32("WfbiibtHuQRMl",13) == 753054621) strcat(s, "n");
if (crc32("gtirSQFRsFpIn",13) == 3911120894) strcat(s, "n");
if (crc32("WaYQEyTNwkbLAmd",15) == 3601527800) strcat(s, "a");
if (crc32("mVKxNekzqQbUqH",14) == 1766068934) strcat(s, "k");
if (crc32("WKGmmhHYESokl",13) == 3682352210) strcat(s, "o");
if (crc32("oxwsZ",5) == 2916709368) strcat(s, "v");
if (crc32("jPJXZWSzDM",10) == 3304720096) strcat(s, "e");
if (crc32("bmMdLNkFs",9) == 2762876817) strcat(s, "l");
if (crc32("QtXaCP",6) == 2379347862) strcat(s, "y");
    return s;
}

char *inadvisably_adverbs() {
    char *s = calloc(12);
    if (crc32("EEIXdiMvTXFBTJx",15) == 2379480311) strcat(s, "i");
if (crc32("UiZOwiqZFe",10) == 2441396629) strcat(s, "n");
if (crc32("FtTCu",5) == 1698853414) strcat(s, "a");
if (crc32("cldFLDIYdhStke",14) == 741786231) strcat(s, "d");
if (crc32("SGcDYBygeuaYzH",14) == 523405029) strcat(s, "v");
if (crc32("sfptzrBWJxM",11) == 3768218830) strcat(s, "i");
if (crc32("KklmSpPkYVYEj",13) == 907398749) strcat(s, "B");
if (crc32("phCmLmGfqzf",11) == 470373706) strcat(s, "s");
if (crc32("YTLuVqcUx",9) == 4147489215) strcat(s, "i");
if (crc32("JtNXsNShcDRWUSC",15) == 1966082611) strcat(s, "a");
if (crc32("TaBUIEsIxsEspV",14) == 971350016) strcat(s, "u");
if (crc32("aLDZPKQtavRx",12) == 3108113494) strcat(s, "b");
if (crc32("tAFNj",5) == 3411896839) strcat(s, "S");
if (crc32("lBwHHCeEj",9) == 1920277436) strcat(s, "l");
if (crc32("OkIOvils",8) == 941932234) strcat(s, "r");
if (crc32("fIsBzHodaHwXJ",13) == 3480150900) strcat(s, "y");
    return s;
}

char *semiconically_adverbs() {
    char *s = calloc(14);
    if (crc32("jQgLkhGTSUVQgm",14) == 31840475) strcat(s, "s");
if (crc32("BpVlRg",6) == 4268770076) strcat(s, "e");
if (crc32("jlDiEbY",7) == 67686022) strcat(s, "s");
if (crc32("iEkAg",5) == 2164057168) strcat(s, "m");
if (crc32("eiXXSsRAIbSHpXo",15) == 3867997890) strcat(s, "i");
if (crc32("VEAriJu",7) == 1269191505) strcat(s, "c");
if (crc32("mXOzUAixraeZ",12) == 3977843743) strcat(s, "G");
if (crc32("yGNpMu",6) == 1035897430) strcat(s, "o");
if (crc32("pSYIahjWgwT",11) == 1367488204) strcat(s, "I");
if (crc32("bCkhXSB",7) == 1930572515) strcat(s, "n");
if (crc32("JhfnLozwtPKz",12) == 3405065923) strcat(s, "i");
if (crc32("YjMJZrSLXF",10) == 3119536570) strcat(s, "Y");
if (crc32("uSEshOEFDbu",11) == 1745314116) strcat(s, "c");
if (crc32("QVoDnjUp",8) == 325880877) strcat(s, "J");
if (crc32("vjtMxzJAYcuBta",14) == 3155316606) strcat(s, "a");
if (crc32("mlkUTSSu",8) == 1802924168) strcat(s, "l");
if (crc32("ZwRVsVJbPkkFna",14) == 2694749275) strcat(s, "l");
if (crc32("PiJlHIN",7) == 3028177502) strcat(s, "g");
if (crc32("xsFPIKkL",8) == 1169519361) strcat(s, "y");
    return s;
}

char *oft_adverbs() {
    char *s = calloc(4);
    if (crc32("IOFGLKl",7) == 1300780313) strcat(s, "o");
if (crc32("UGLcbRXWmcA",11) == 1176874625) strcat(s, "J");
if (crc32("umwPRhybUrXbV",13) == 2509268700) strcat(s, "f");
if (crc32("XXVTYSKDrEmCHx",14) == 1278942573) strcat(s, "t");
    return s;
}

char *nonhabitually_adverbs() {
    char *s = calloc(14);
    if (crc32("MuznfnQbkx",10) == 661542750) strcat(s, "H");
if (crc32("MBDMTNsZPJu",11) == 1673357379) strcat(s, "n");
if (crc32("XmmVZDhbYdb",11) == 1506269328) strcat(s, "o");
if (crc32("mGEDmhIJnd",10) == 31323372) strcat(s, "s");
if (crc32("AFgDUzVQQFa",11) == 2490263439) strcat(s, "n");
if (crc32("pVkxOLhrnhIrJ",13) == 2736972043) strcat(s, "F");
if (crc32("FdCcfQCFpoeGIk",14) == 2213443979) strcat(s, "h");
if (crc32("urXkiJeaY",9) == 2156350344) strcat(s, "a");
if (crc32("ULdOpYobmrJjjEm",15) == 907382586) strcat(s, "b");
if (crc32("wSosPAqu",8) == 977581579) strcat(s, "i");
if (crc32("xCmshtwsGoFGbH",14) == 549745356) strcat(s, "t");
if (crc32("VdqhpH",6) == 3319297777) strcat(s, "u");
if (crc32("uMDVD",5) == 1711814159) strcat(s, "H");
if (crc32("ZhygKpWVHVHlx",13) == 123931886) strcat(s, "a");
if (crc32("SOqSiZpMOvRWq",13) == 3606303891) strcat(s, "l");
if (crc32("EVFeVHCwVHOfvud",15) == 274013625) strcat(s, "p");
if (crc32("nYxgNTLtxNoIF",13) == 3064672713) strcat(s, "l");
if (crc32("gVbsL",5) == 863843582) strcat(s, "y");
    return s;
}

char *talismanically_adverbs() {
    char *s = calloc(15);
    if (crc32("OgHjMcslcl",10) == 411660527) strcat(s, "a");
if (crc32("YtninVC",7) == 2596487610) strcat(s, "t");
if (crc32("jQxegfYP",8) == 4256250185) strcat(s, "a");
if (crc32("vWeTcshpns",10) == 3917276309) strcat(s, "l");
if (crc32("wTiRTj",6) == 818980752) strcat(s, "i");
if (crc32("dVhyzcwpaKU",11) == 847304643) strcat(s, "N");
if (crc32("wQBsOHWAMLUcvEY",15) == 246763493) strcat(s, "s");
if (crc32("lecLJQoBX",9) == 3935001796) strcat(s, "L");
if (crc32("zGwvTxRdtbh",11) == 1958154109) strcat(s, "m");
if (crc32("URJyFNKex",9) == 2474251320) strcat(s, "a");
if (crc32("DOgRPV",6) == 1588482237) strcat(s, "g");
if (crc32("mFoOojLbklfGHtU",15) == 3699441297) strcat(s, "n");
if (crc32("fMPNJJIkIkLdu",13) == 2738504527) strcat(s, "h");
if (crc32("jrZfXDV",7) == 3961265762) strcat(s, "i");
if (crc32("IiihIRTMz",9) == 2318140956) strcat(s, "J");
if (crc32("SYoLSmTzupFoSeg",15) == 2932450989) strcat(s, "c");
if (crc32("FEASKsaOre",10) == 1783865736) strcat(s, "N");
if (crc32("uPguTDm",7) == 2497888894) strcat(s, "a");
if (crc32("LSbFTWxYLaoYj",13) == 3891090574) strcat(s, "l");
if (crc32("hvQWPK",6) == 367743763) strcat(s, "T");
if (crc32("hgLQEfkdjtrwZ",13) == 2666898829) strcat(s, "l");
if (crc32("JbmtRCRQnxtzJP",14) == 995746098) strcat(s, "y");
    return s;
}

char *terminally_adverbs() {
    char *s = calloc(11);
    if (crc32("PkoTWBGWy",9) == 3789784571) strcat(s, "t");
if (crc32("pZETdeeU",8) == 620911058) strcat(s, "e");
if (crc32("WQtxJwz",7) == 3383910490) strcat(s, "K");
if (crc32("VGaUmNvvzG",10) == 4030120643) strcat(s, "r");
if (crc32("MGdtM",5) == 1818421570) strcat(s, "m");
if (crc32("OhkceMg",7) == 3571746064) strcat(s, "i");
if (crc32("QjDugsZKpFSpBy",14) == 565329877) strcat(s, "n");
if (crc32("kCkSuKnddglUpF",14) == 661156354) strcat(s, "l");
if (crc32("KrECqUbalvBa",12) == 719931943) strcat(s, "a");
if (crc32("PBJaYN",6) == 3638440377) strcat(s, "l");
if (crc32("cmOcnwNVURIvw",13) == 3502236653) strcat(s, "l");
if (crc32("oTBhkaS",7) == 1630143295) strcat(s, "y");
    return s;
}

char *poignantly_adverbs() {
    char *s = calloc(11);
    if (crc32("NUQcCgkidSDclO",14) == 1659790965) strcat(s, "p");
if (crc32("FVLqlyVsAUU",11) == 23873327) strcat(s, "p");
if (crc32("FMfPTvpSvwxsOL",14) == 3332705350) strcat(s, "o");
if (crc32("dTExlaTNX",9) == 468711671) strcat(s, "E");
if (crc32("MHrGRkfQnEj",11) == 3617700598) strcat(s, "i");
if (crc32("SwaBzYDZsMi",11) == 3047787182) strcat(s, "v");
if (crc32("tZkxxSdHHi",10) == 4153622199) strcat(s, "g");
if (crc32("thgWDrfLJJYhc",13) == 3364691232) strcat(s, "M");
if (crc32("GXTwzYdahyf",11) == 658896948) strcat(s, "n");
if (crc32("yEhpENCZ",8) == 785993681) strcat(s, "d");
if (crc32("GEJFZMfDjqnDg",13) == 3972610729) strcat(s, "a");
if (crc32("xyjCWNdoTZNYW",13) == 2964852037) strcat(s, "n");
if (crc32("KiVUQ",5) == 1697046612) strcat(s, "Y");
if (crc32("pIonMFqPyDWWtgK",15) == 1134312046) strcat(s, "t");
if (crc32("ynJVaLxHFkzr",12) == 3380276961) strcat(s, "l");
if (crc32("HsvnBvMOrH",10) == 1439390046) strcat(s, "y");
    return s;
}

char *dismally_adverbs() {
    char *s = calloc(9);
    if (crc32("EPPuXKOMMvQFleM",15) == 1889021010) strcat(s, "t");
if (crc32("DUFNXOHvQQm",11) == 4136303113) strcat(s, "d");
if (crc32("fxWHxmkEGEI",11) == 2058167709) strcat(s, "D");
if (crc32("gPAQSFGmkeZqh",13) == 1711817133) strcat(s, "i");
if (crc32("cmTogACYGaGHktl",15) == 872518488) strcat(s, "s");
if (crc32("iuXXe",5) == 612146974) strcat(s, "n");
if (crc32("vMOsJap",7) == 1406517499) strcat(s, "m");
if (crc32("cFmxHtl",7) == 2079993588) strcat(s, "n");
if (crc32("UDhTDPITpbi",11) == 1509620233) strcat(s, "a");
if (crc32("hvXBHVCUyAmfIc",14) == 2735721209) strcat(s, "l");
if (crc32("kXPtSJBEWnzOkUb",15) == 205256541) strcat(s, "l");
if (crc32("UFPIu",5) == 2487686429) strcat(s, "v");
if (crc32("VaxWUhsBTG",10) == 1285941749) strcat(s, "y");
    return s;
}

char *overcourteously_adverbs() {
    char *s = calloc(16);
    if (crc32("RNXczzOw",8) == 3279957601) strcat(s, "C");
if (crc32("OVTzVDpbHl",10) == 1063992369) strcat(s, "o");
if (crc32("UiFaPaZYIMt",11) == 3078268336) strcat(s, "v");
if (crc32("HoYFnILCdvOqtbH",15) == 1904642626) strcat(s, "e");
if (crc32("LbOYchCGr",9) == 2253141998) strcat(s, "r");
if (crc32("qoDTAqtfJeTJ",12) == 1685818160) strcat(s, "c");
if (crc32("ipQBGuhZuZtZBk",14) == 561800366) strcat(s, "s");
if (crc32("qYQOxnhjCkAan",13) == 3567879160) strcat(s, "o");
if (crc32("dfalVzpL",8) == 2715453425) strcat(s, "u");
if (crc32("cgmyOHWwNGXgzSS",15) == 2007927429) strcat(s, "r");
if (crc32("bGuCaVUIfwma",12) == 3043529473) strcat(s, "v");
if (crc32("csUAvYlRKt",10) == 1570470290) strcat(s, "t");
if (crc32("eMwkV",5) == 3569787858) strcat(s, "q");
if (crc32("nHeRTNmFAIJau",13) == 3551430801) strcat(s, "e");
if (crc32("oJRXOWZwjpNkKt",14) == 3582917787) strcat(s, "s");
if (crc32("FmFBd",5) == 609881246) strcat(s, "o");
if (crc32("hDaeqwQrjNoFzaB",15) == 3277533878) strcat(s, "u");
if (crc32("YtQVWLNAaX",10) == 1354853437) strcat(s, "z");
if (crc32("txCrGVWBRKUjF",13) == 53325124) strcat(s, "s");
if (crc32("wwqJTeI",7) == 3955481445) strcat(s, "s");
if (crc32("QdNFeQe",7) == 41116145) strcat(s, "l");
if (crc32("SDnLAumdxVjuACn",15) == 4174383885) strcat(s, "v");
if (crc32("QmsPX",5) == 2208394275) strcat(s, "y");
    return s;
}

char *antischolastically_adverbs() {
    char *s = calloc(19);
    if (crc32("CttTrOz",7) == 2688898657) strcat(s, "a");
if (crc32("bGOpFZVqZcl",11) == 921311234) strcat(s, "Y");
if (crc32("KYGsfBomRCLFH",13) == 4151056683) strcat(s, "n");
if (crc32("DpwZRMQeTDcopyM",15) == 2258734534) strcat(s, "t");
if (crc32("XXMLAAegAR",10) == 1023457709) strcat(s, "i");
if (crc32("dKkDQ",5) == 1753936525) strcat(s, "h");
if (crc32("ikiHwtlFVRJB",12) == 4031655109) strcat(s, "s");
if (crc32("DidzWeANqi",10) == 1224953656) strcat(s, "q");
if (crc32("hRhIULmAgrLr",12) == 2576328171) strcat(s, "c");
if (crc32("HNaqg",5) == 2039338688) strcat(s, "h");
if (crc32("ljYuUjb",7) == 889148459) strcat(s, "U");
if (crc32("owYaO",5) == 3527449724) strcat(s, "o");
if (crc32("aDFvig",6) == 1029365214) strcat(s, "Q");
if (crc32("sXWXcqIfVPrXg",13) == 1238249203) strcat(s, "l");
if (crc32("wWfbmjsqtSsU",12) == 1819706139) strcat(s, "a");
if (crc32("fqSGdBq",7) == 1074603747) strcat(s, "G");
if (crc32("qrHwSgnoXOXjkh",14) == 4217130073) strcat(s, "s");
if (crc32("TvWNrkBhtvCgzfW",15) == 1035146385) strcat(s, "h");
if (crc32("chXcH",5) == 2992286626) strcat(s, "t");
if (crc32("CkFRKehMUKXemw",14) == 693049063) strcat(s, "f");
if (crc32("QooyVGUA",8) == 3516152864) strcat(s, "i");
if (crc32("WwJgIWRbxkkjJL",14) == 1577011966) strcat(s, "c");
if (crc32("ANkxSdkBPFk",11) == 334087139) strcat(s, "a");
if (crc32("jUXnOQObDeXrEb",14) == 4148702542) strcat(s, "l");
if (crc32("qmTOpQkj",8) == 2401908746) strcat(s, "l");
if (crc32("jyCseEt",7) == 1814346393) strcat(s, "y");
    return s;
}

char *wrongly_adverbs() {
    char *s = calloc(8);
    if (crc32("pZeHJPh",7) == 1471942659) strcat(s, "w");
if (crc32("QgkusMzMaa",10) == 2848562392) strcat(s, "r");
if (crc32("DHxLICgRNTal",12) == 3845313731) strcat(s, "i");
if (crc32("jxQFA",5) == 1907215744) strcat(s, "o");
if (crc32("cqmOyFxeasLhPp",14) == 2095073059) strcat(s, "l");
if (crc32("WhXTPyVKZJXaXf",14) == 730154475) strcat(s, "n");
if (crc32("DzMMKKzzRv",10) == 1283141289) strcat(s, "R");
if (crc32("VyDzOS",6) == 1464121759) strcat(s, "g");
if (crc32("pmdaBGNcwWSeXb",14) == 1591040834) strcat(s, "K");
if (crc32("vKuhzfqZqhUb",12) == 604772413) strcat(s, "l");
if (crc32("itVVnZWrPOYiG",13) == 2324670582) strcat(s, "D");
if (crc32("iPulWdGOE",9) == 3095195173) strcat(s, "y");
    return s;
}

char *adorably_adverbs() {
    char *s = calloc(9);
    if (crc32("eJtAoPfqGKZGfWN",15) == 1766040542) strcat(s, "a");
if (crc32("ZISMBsPKBXPaz",13) == 3306738781) strcat(s, "M");
if (crc32("ELxNUdwGIJQyG",13) == 3551179917) strcat(s, "d");
if (crc32("PYJQUOaZhKIU",12) == 3504452270) strcat(s, "F");
if (crc32("ebzsnDQGLRtopR",14) == 2103627986) strcat(s, "o");
if (crc32("jFDIygYUFRN",11) == 937154937) strcat(s, "r");
if (crc32("PuABQs",6) == 4266128955) strcat(s, "V");
if (crc32("KvVqJKqDPw",10) == 2383746268) strcat(s, "a");
if (crc32("LfenexsFKxPyZM",14) == 3157414417) strcat(s, "q");
if (crc32("ciLScpEHuiINM",13) == 3582054425) strcat(s, "b");
if (crc32("zbshiTcF",8) == 826056476) strcat(s, "n");
if (crc32("BHPlBHKFqQgCAFv",15) == 310575296) strcat(s, "l");
if (crc32("oVOFpiKXTx",10) == 620447458) strcat(s, "y");
    return s;
}

char *supportably_adverbs() {
    char *s = calloc(12);
    if (crc32("pdOUwRx",7) == 1140640284) strcat(s, "s");
if (crc32("JDLkyAYF",8) == 4052986647) strcat(s, "z");
if (crc32("qbztozmmmW",10) == 1274852707) strcat(s, "u");
if (crc32("vRqcJj",6) == 277434013) strcat(s, "p");
if (crc32("dqvewRsfs",9) == 2918149695) strcat(s, "l");
if (crc32("VYuOplVPTsDEnw",14) == 4226009455) strcat(s, "p");
if (crc32("foaRjmTidiZL",12) == 88802722) strcat(s, "o");
if (crc32("YwYccggfXzGk",12) == 209728132) strcat(s, "o");
if (crc32("HfbuFNO",7) == 2008593244) strcat(s, "r");
if (crc32("lBbTa",5) == 80489271) strcat(s, "t");
if (crc32("XomLWZ",6) == 3913110946) strcat(s, "h");
if (crc32("FthUqp",6) == 2522154209) strcat(s, "a");
if (crc32("WaYfmObesay",11) == 884980707) strcat(s, "b");
if (crc32("KrZtDaulclupm",13) == 2695069665) strcat(s, "V");
if (crc32("rVwwWUpATGKV",12) == 1131995094) strcat(s, "l");
if (crc32("kusqcr",6) == 2451986867) strcat(s, "c");
if (crc32("EQsbMn",6) == 908112172) strcat(s, "y");
    return s;
}

char *overmoralizingly_adverbs() {
    char *s = calloc(17);
    if (crc32("kmzAmFPpyAmHZ",13) == 1930754541) strcat(s, "o");
if (crc32("wXwlQWEJITqFx",13) == 4218625816) strcat(s, "i");
if (crc32("iXAyld",6) == 1833277014) strcat(s, "v");
if (crc32("nlyqnWiGX",9) == 2866996953) strcat(s, "j");
if (crc32("yIJArkvguoIBRZJ",15) == 682738380) strcat(s, "e");
if (crc32("fXcMubZzJqyJ",12) == 1145743629) strcat(s, "r");
if (crc32("GYGubeoR",8) == 1737880324) strcat(s, "T");
if (crc32("xkgDQsO",7) == 2427709487) strcat(s, "m");
if (crc32("biGlnKquxxbZJfy",15) == 3613896415) strcat(s, "i");
if (crc32("twwrgwma",8) == 3966489915) strcat(s, "o");
if (crc32("dpewB",5) == 1844413574) strcat(s, "Y");
if (crc32("CGLMoFiW",8) == 3439789537) strcat(s, "r");
if (crc32("TKfbfjFs",8) == 47556175) strcat(s, "M");
if (crc32("JJBxBFUKlCi",11) == 1101865874) strcat(s, "a");
if (crc32("kaSwUtJeOFlW",12) == 75060622) strcat(s, "l");
if (crc32("KZMFRCL",7) == 2742003158) strcat(s, "i");
if (crc32("GsPjRFVXWIHW",12) == 786791046) strcat(s, "z");
if (crc32("ZFYsmN",6) == 1793181831) strcat(s, "i");
if (crc32("uXceRCfwEbfjh",13) == 4174006230) strcat(s, "n");
if (crc32("GeYtp",5) == 1479715972) strcat(s, "g");
if (crc32("DAaFDEYgOQNLOe",14) == 3499885225) strcat(s, "l");
if (crc32("fnJJWvZWUYqx",12) == 2286458453) strcat(s, "v");
if (crc32("NtxJzqlwA",9) == 3918428147) strcat(s, "y");
    return s;
}

char *undelinquently_adverbs() {
    char *s = calloc(15);
    if (crc32("XfrJzMjuoSqy",12) == 3532670507) strcat(s, "u");
if (crc32("OgEJaBu",7) == 4115759951) strcat(s, "n");
if (crc32("oIhfUqCq",8) == 437908117) strcat(s, "d");
if (crc32("HdNfGLAsZJd",11) == 1205930963) strcat(s, "N");
if (crc32("CVZdicLjEbVgu",13) == 2044068951) strcat(s, "e");
if (crc32("kBmAv",5) == 1484807505) strcat(s, "h");
if (crc32("LrptPu",6) == 3898171628) strcat(s, "l");
if (crc32("zAlIZcF",7) == 724690097) strcat(s, "P");
if (crc32("DuyQhtYel",9) == 1293499154) strcat(s, "i");
if (crc32("UXdMCll",7) == 1116973482) strcat(s, "X");
if (crc32("YgaZkoyWMh",10) == 88485697) strcat(s, "n");
if (crc32("qCEkzeV",7) == 3782172093) strcat(s, "q");
if (crc32("xyCsxEM",7) == 3617492821) strcat(s, "u");
if (crc32("gQRqmNXQldRZG",13) == 2347937057) strcat(s, "e");
if (crc32("kTBwUNLydqO",11) == 2926491058) strcat(s, "n");
if (crc32("IDqZUkyj",8) == 2380709661) strcat(s, "D");
if (crc32("WJbsMKUTmuv",11) == 3157190370) strcat(s, "t");
if (crc32("SPpIxtgn",8) == 786721006) strcat(s, "p");
if (crc32("fuKhRBOc",8) == 2959848021) strcat(s, "l");
if (crc32("avqiOSKWuiLauN",14) == 1825822467) strcat(s, "y");
    return s;
}

char *caressingly_adverbs() {
    char *s = calloc(12);
    if (crc32("mfuMpgRqLtTrJP",14) == 1892104515) strcat(s, "c");
if (crc32("tWmOMR",6) == 3648657692) strcat(s, "a");
if (crc32("FHSEurcFCfgXbbC",15) == 1597365690) strcat(s, "q");
if (crc32("RPzGTCpCXnPzGJr",15) == 668051401) strcat(s, "r");
if (crc32("JaPjbILM",8) == 2050577293) strcat(s, "j");
if (crc32("tufUCvYhu",9) == 2767345122) strcat(s, "e");
if (crc32("jaroZ",5) == 2828303147) strcat(s, "s");
if (crc32("cDjyATr",7) == 1487674876) strcat(s, "m");
if (crc32("gEjYIaeYEBR",11) == 759700304) strcat(s, "s");
if (crc32("bIkIviZNpx",10) == 4237952594) strcat(s, "e");
if (crc32("MksMPGyqRdhh",12) == 1758280337) strcat(s, "i");
if (crc32("omdVlKA",7) == 4232714801) strcat(s, "q");
if (crc32("QrBuvr",6) == 1363885363) strcat(s, "n");
if (crc32("YWLmN",5) == 2639028325) strcat(s, "g");
if (crc32("wZYpFPgDsluPS",13) == 1934100156) strcat(s, "r");
if (crc32("HMvmpmvcifICgsa",15) == 3759584248) strcat(s, "l");
if (crc32("gASrQuhB",8) == 464493646) strcat(s, "g");
if (crc32("pqNOXciiMrlnN",13) == 223962846) strcat(s, "y");
    return s;
}

char *savourily_adverbs() {
    char *s = calloc(10);
    if (crc32("Mxkojyedy",9) == 2949836909) strcat(s, "L");
if (crc32("SwqSSPgu",8) == 2539542713) strcat(s, "s");
if (crc32("xsvlnm",6) == 441287064) strcat(s, "u");
if (crc32("IHzmWz",6) == 4038173365) strcat(s, "a");
if (crc32("hCclK",5) == 2216097160) strcat(s, "v");
if (crc32("RmtPkNHW",8) == 1802262393) strcat(s, "o");
if (crc32("ttIqlUrI",8) == 3645432756) strcat(s, "u");
if (crc32("RnhKZKJCkvUsH",13) == 1734607346) strcat(s, "u");
if (crc32("sTCppTtts",9) == 3030426955) strcat(s, "e");
if (crc32("QFYnlBWt",8) == 1988793282) strcat(s, "r");
if (crc32("IZaTJuUbnRFTE",13) == 2989010034) strcat(s, "i");
if (crc32("WdNQUVEafUiHYfn",15) == 105845429) strcat(s, "l");
if (crc32("DWeTUEuxYSOYg",13) == 2224324361) strcat(s, "y");
    return s;
}

char *inhumanly_adverbs() {
    char *s = calloc(10);
    if (crc32("JOVXKTdCqCTJV",13) == 1948630102) strcat(s, "d");
if (crc32("ZuFzbOt",7) == 4191019333) strcat(s, "i");
if (crc32("yGvBuShIyYtGvec",15) == 3114609851) strcat(s, "T");
if (crc32("EGTAWs",6) == 222636594) strcat(s, "n");
if (crc32("sBYUrPm",7) == 358682634) strcat(s, "h");
if (crc32("SzVDExfZMWo",11) == 334109658) strcat(s, "j");
if (crc32("bQKjOvD",7) == 1312667355) strcat(s, "u");
if (crc32("wdGbsBNa",8) == 1603771121) strcat(s, "n");
if (crc32("tngkuS",6) == 1160397278) strcat(s, "m");
if (crc32("LxCKLvjgX",9) == 4284977113) strcat(s, "i");
if (crc32("vbnIcG",6) == 2375135610) strcat(s, "a");
if (crc32("aqBbtiDqOeHmVmu",15) == 301707538) strcat(s, "n");
if (crc32("KvYsxejIcnpdhB",14) == 3651041560) strcat(s, "l");
if (crc32("lrYNrvmW",8) == 391357614) strcat(s, "F");
if (crc32("WFexcfb",7) == 2278303828) strcat(s, "y");
    return s;
}

char *winningly_adverbs() {
    char *s = calloc(10);
    if (crc32("nKvQrNyuGoGfx",13) == 2880833844) strcat(s, "w");
if (crc32("CJnscHVRKpUbQo",14) == 490476804) strcat(s, "W");
if (crc32("bBNxclxmnu",10) == 3260755211) strcat(s, "i");
if (crc32("qmwWngLBzJlfQWM",15) == 3343962299) strcat(s, "B");
if (crc32("JGhYMIGw",8) == 3927663044) strcat(s, "n");
if (crc32("mhftE",5) == 502260503) strcat(s, "w");
if (crc32("XJZlrQIxCUIanB",14) == 98779685) strcat(s, "n");
if (crc32("fdlfTqObi",9) == 2239771550) strcat(s, "B");
if (crc32("vqphP",5) == 4052614528) strcat(s, "i");
if (crc32("RKTOYKMBD",9) == 1432621795) strcat(s, "n");
if (crc32("OGHWPnt",7) == 3280017685) strcat(s, "g");
if (crc32("ygFgIdKt",8) == 2266509877) strcat(s, "l");
if (crc32("LJTFmLf",7) == 2079988612) strcat(s, "y");
    return s;
}

char *pertly_adverbs() {
    char *s = calloc(7);
    if (crc32("SXYitt",6) == 1848467668) strcat(s, "p");
if (crc32("pebyyYNmZOWucBh",15) == 4154703061) strcat(s, "p");
if (crc32("sBhwWcMEIpAG",12) == 2240309345) strcat(s, "e");
if (crc32("NXiYIPEsRltwt",13) == 4155498487) strcat(s, "r");
if (crc32("fMAsmAli",8) == 1765676100) strcat(s, "t");
if (crc32("ixWNf",5) == 2605466456) strcat(s, "F");
if (crc32("ZVuWaUFcTUks",12) == 820209051) strcat(s, "l");
if (crc32("qThIdCeJvpDsIda",15) == 681927878) strcat(s, "Q");
if (crc32("oeVILlPFswtWYF",14) == 2506988350) strcat(s, "y");
    return s;
}

char *sodomitically_adverbs() {
    char *s = calloc(14);
    if (crc32("dBMDMc",6) == 2098329855) strcat(s, "Y");
if (crc32("ipVRwxj",7) == 1158161318) strcat(s, "s");
if (crc32("NWsPHszJrl",10) == 154886377) strcat(s, "o");
if (crc32("VfdJBMY",7) == 406066244) strcat(s, "Z");
if (crc32("jtTGgeDBtDh",11) == 612016230) strcat(s, "d");
if (crc32("zzlICIhyzC",10) == 1867132222) strcat(s, "g");
if (crc32("UQXWbloIKjZmlko",15) == 4086133108) strcat(s, "o");
if (crc32("hfAOQsBucj",10) == 2693257309) strcat(s, "m");
if (crc32("fbSCTUYPDRCPO",13) == 2601710647) strcat(s, "i");
if (crc32("dlaRza",6) == 2107825321) strcat(s, "t");
if (crc32("yTGazDPlzIEOWrb",15) == 1483438118) strcat(s, "g");
if (crc32("NjAHnpcDPmtXtRt",15) == 3713936291) strcat(s, "i");
if (crc32("CYygGZGwdSfqoR",14) == 4082452885) strcat(s, "c");
if (crc32("iwafVxDQSfuhDE",14) == 2618831812) strcat(s, "m");
if (crc32("gFDEh",5) == 3938135191) strcat(s, "a");
if (crc32("CNSGOIsdhFs",11) == 1964030388) strcat(s, "l");
if (crc32("zEhQPvqUKuZFJB",14) == 3822800173) strcat(s, "l");
if (crc32("QSAszD",6) == 3638374990) strcat(s, "y");
    return s;
}

char *indevoutly_adverbs() {
    char *s = calloc(11);
    if (crc32("NVMgReJ",7) == 3030819904) strcat(s, "i");
if (crc32("jdYGAzvMsHTN",12) == 360151228) strcat(s, "i");
if (crc32("wcemTYQFJmeU",12) == 3099462330) strcat(s, "n");
if (crc32("kfDGjFNwPvLclGO",15) == 3313181993) strcat(s, "d");
if (crc32("SWYtXDIIVo",10) == 281097895) strcat(s, "e");
if (crc32("KIgyF",5) == 600273485) strcat(s, "v");
if (crc32("wVRSjkA",7) == 932014922) strcat(s, "o");
if (crc32("nDfXsAem",8) == 2206903326) strcat(s, "m");
if (crc32("YodFXC",6) == 3703918160) strcat(s, "u");
if (crc32("ZSPUD",5) == 3086516755) strcat(s, "t");
if (crc32("qgFmZZDkqbwA",12) == 1128302602) strcat(s, "l");
if (crc32("lYzFHKKJWwOqV",13) == 4286952050) strcat(s, "y");
    return s;
}

char *quasibrotherly_adverbs() {
    char *s = calloc(15);
    if (crc32("sGxWchIHoyNTlMb",15) == 1070009314) strcat(s, "N");
if (crc32("sofHkkgs",8) == 3342337020) strcat(s, "q");
if (crc32("YsETslT",7) == 2165449974) strcat(s, "u");
if (crc32("lLnJjn",6) == 3223035038) strcat(s, "a");
if (crc32("cTRXFYEc",8) == 3537369786) strcat(s, "G");
if (crc32("bJxnjYopwwt",11) == 1980757101) strcat(s, "s");
if (crc32("NOZpkAYnH",9) == 2853179701) strcat(s, "f");
if (crc32("NZxcneJmYUSv",12) == 2682938108) strcat(s, "i");
if (crc32("RxLGOP",6) == 2176572847) strcat(s, "b");
if (crc32("BfmxCjzkZTO",11) == 4284409750) strcat(s, "A");
if (crc32("LrlyrtXSoubzX",13) == 1618974050) strcat(s, "r");
if (crc32("xfCrLUX",7) == 2581586824) strcat(s, "o");
if (crc32("hKHBb",5) == 40091990) strcat(s, "X");
if (crc32("UKXnH",5) == 2601687065) strcat(s, "t");
if (crc32("WlCjCfCI",8) == 1551715196) strcat(s, "L");
if (crc32("kMbTiAj",7) == 59073702) strcat(s, "h");
if (crc32("BQgcyX",6) == 2165067013) strcat(s, "e");
if (crc32("XriPpwwxHjq",11) == 655317776) strcat(s, "r");
if (crc32("PiFkF",5) == 4017084379) strcat(s, "p");
if (crc32("HyBzzHT",7) == 3990114014) strcat(s, "l");
if (crc32("WMGqodB",7) == 725635159) strcat(s, "y");
    return s;
}

char *overderisively_adverbs() {
    char *s = calloc(15);
    if (crc32("yvbjEAi",7) == 2546372546) strcat(s, "I");
if (crc32("UbOCbAozMxSxh",13) == 1811777265) strcat(s, "o");
if (crc32("rmYHxP",6) == 3532357839) strcat(s, "v");
if (crc32("dSiBTJwjQrPPw",13) == 4033680455) strcat(s, "e");
if (crc32("bATiq",5) == 1768784983) strcat(s, "V");
if (crc32("zxMpBfhrKJsrVd",14) == 1797806138) strcat(s, "r");
if (crc32("NpgPWr",6) == 57440035) strcat(s, "n");
if (crc32("tXqPVqT",7) == 1480255577) strcat(s, "d");
if (crc32("UfqNamKCsQGcWs",14) == 2092456569) strcat(s, "r");
if (crc32("hqKjIYrSNw",10) == 2404433536) strcat(s, "e");
if (crc32("yMqzZNobtiumPYN",15) == 3670327323) strcat(s, "T");
if (crc32("lfkTHJBasZupEY",14) == 2687928839) strcat(s, "r");
if (crc32("XBHPFwHdTVXm",12) == 335687836) strcat(s, "i");
if (crc32("addaBuH",7) == 8538577) strcat(s, "q");
if (crc32("BOBaEy",6) == 4113466917) strcat(s, "s");
if (crc32("EiLjmSl",7) == 1689894215) strcat(s, "Q");
if (crc32("EdRMnJneelcuX",13) == 1024681840) strcat(s, "i");
if (crc32("fYWrPT",6) == 1967406551) strcat(s, "p");
if (crc32("lllZXjGIth",10) == 3490355984) strcat(s, "v");
if (crc32("aKjyi",5) == 2713068393) strcat(s, "e");
if (crc32("qZBvQaqfmKn",11) == 1268929639) strcat(s, "B");
if (crc32("fsgao",5) == 1168736520) strcat(s, "l");
if (crc32("zeArM",5) == 495241708) strcat(s, "y");
    return s;
}

char *vacantly_adverbs() {
    char *s = calloc(9);
    if (crc32("RYCMwhqflKvq",12) == 692052794) strcat(s, "m");
if (crc32("dLHEHUq",7) == 3221353179) strcat(s, "v");
if (crc32("CJJtFdDARLjqiDb",15) == 58946839) strcat(s, "a");
if (crc32("mIZwArjHKvgBWCb",15) == 2737280078) strcat(s, "c");
if (crc32("vJuribXkfjHmlfQ",15) == 990979566) strcat(s, "a");
if (crc32("nTStcl",6) == 3693455941) strcat(s, "M");
if (crc32("uqFhdsaYQxOsTh",14) == 1350347996) strcat(s, "n");
if (crc32("nLrLpaNn",8) == 517686320) strcat(s, "t");
if (crc32("RslXkG",6) == 2783042258) strcat(s, "d");
if (crc32("icBpUr",6) == 1551938379) strcat(s, "l");
if (crc32("PZJifT",6) == 601976580) strcat(s, "y");
    return s;
}

char *unsectionally_adverbs() {
    char *s = calloc(14);
    if (crc32("qDelGpwxxZkHJ",13) == 1261567385) strcat(s, "h");
if (crc32("mqAWmIItmBy",11) == 2807541488) strcat(s, "u");
if (crc32("dlsMnBvkHcgoS",13) == 3127775731) strcat(s, "h");
if (crc32("dQsclVTTMGTeJzy",15) == 2594154541) strcat(s, "n");
if (crc32("VgWNFU",6) == 313463636) strcat(s, "u");
if (crc32("dvOKRcZDPrKho",13) == 3452742544) strcat(s, "s");
if (crc32("sxRkFClNn",9) == 1573134390) strcat(s, "e");
if (crc32("fUNvAXNllU",10) == 851964417) strcat(s, "i");
if (crc32("EAyHkguH",8) == 696109850) strcat(s, "c");
if (crc32("YJuZzMWVNO",10) == 847940780) strcat(s, "t");
if (crc32("yzXhesHow",9) == 164724319) strcat(s, "i");
if (crc32("WzaYZdFhX",9) == 1944453373) strcat(s, "c");
if (crc32("xNYzNzoeloLuixY",15) == 1824763994) strcat(s, "o");
if (crc32("QcZOQKwtpGcnXVf",15) == 3546023481) strcat(s, "n");
if (crc32("HFyWR",5) == 996232160) strcat(s, "a");
if (crc32("ZjSPDFSJPfiY",12) == 2649877150) strcat(s, "v");
if (crc32("EjhLLRmAXswZxOZ",15) == 3959930962) strcat(s, "l");
if (crc32("liPkzaFUxTXETT",14) == 1707930293) strcat(s, "l");
if (crc32("SvbuJgdkLV",10) == 346304234) strcat(s, "c");
if (crc32("qNbfaMo",7) == 3461418905) strcat(s, "y");
    return s;
}

char *nongenetically_adverbs() {
    char *s = calloc(15);
    if (crc32("eKgZy",5) == 4293947903) strcat(s, "n");
if (crc32("NtjeIYdj",8) == 3635907818) strcat(s, "T");
if (crc32("AJJDdiycEWiXa",13) == 3861815975) strcat(s, "o");
if (crc32("phQuhMWj",8) == 1501985340) strcat(s, "n");
if (crc32("FgjnTkdKVcXkJKE",15) == 4110592875) strcat(s, "g");
if (crc32("pxLADgvlJDlgWxw",15) == 4065888445) strcat(s, "D");
if (crc32("LgwitqEHeShE",12) == 1334122865) strcat(s, "e");
if (crc32("bMvlqmh",7) == 1443244792) strcat(s, "O");
if (crc32("NaMpTdUMLVTPkes",15) == 1873981139) strcat(s, "n");
if (crc32("EBxSFXz",7) == 1869650825) strcat(s, "e");
if (crc32("ECjLQlVP",8) == 4029027541) strcat(s, "t");
if (crc32("rSGyNIRDt",9) == 3991861993) strcat(s, "z");
if (crc32("yrLnvGzmxwkEaoZ",15) == 2776397105) strcat(s, "i");
if (crc32("RzzreNdvfcQ",11) == 2852086245) strcat(s, "Y");
if (crc32("XeZjsxtbsB",10) == 3276234985) strcat(s, "c");
if (crc32("FYxsSp",6) == 1539726896) strcat(s, "V");
if (crc32("wgrgepLZInVVwG",14) == 2721703640) strcat(s, "a");
if (crc32("ZqkxvDod",8) == 3510089498) strcat(s, "l");
if (crc32("ZtXfgTbeyY",10) == 1882729870) strcat(s, "X");
if (crc32("IjtcTHymmyiKWH",14) == 2684215724) strcat(s, "l");
if (crc32("KpAaLeUf",8) == 3936372813) strcat(s, "V");
if (crc32("BQtpbflywHB",11) == 3419906120) strcat(s, "y");
    return s;
}

char *disquietingly_adverbs() {
    char *s = calloc(14);
    if (crc32("TnevcSwSRpqgJBG",15) == 3360684446) strcat(s, "F");
if (crc32("fNqhBDwlqE",10) == 2580829567) strcat(s, "d");
if (crc32("tGdZeVc",7) == 2886290933) strcat(s, "C");
if (crc32("OJOdSKDc",8) == 42022053) strcat(s, "i");
if (crc32("QceqTqTrliD",11) == 1030893123) strcat(s, "U");
if (crc32("ZdOdJyQJQxXCVRP",15) == 2442448743) strcat(s, "s");
if (crc32("aoexsxkjeCP",11) == 4060221387) strcat(s, "J");
if (crc32("wPoOTfsB",8) == 1469512110) strcat(s, "q");
if (crc32("UZgJLPpubZoWWio",15) == 2185941391) strcat(s, "x");
if (crc32("AQRLusdgdjiCd",13) == 1889686331) strcat(s, "u");
if (crc32("WpLeDGZgDAZzNB",14) == 3087852468) strcat(s, "c");
if (crc32("ekvPM",5) == 2575109049) strcat(s, "i");
if (crc32("CqGQOVRRXmLYND",14) == 1939964243) strcat(s, "R");
if (crc32("iAVEFwbM",8) == 2992204763) strcat(s, "e");
if (crc32("TpaKxXbLrQ",10) == 4282594987) strcat(s, "t");
if (crc32("CPcSGQHMS",9) == 3959708829) strcat(s, "e");
if (crc32("hkWcZwigyqlvbSy",15) == 1322959451) strcat(s, "i");
if (crc32("ilFSIVLLScsYfr",14) == 3617912287) strcat(s, "M");
if (crc32("tgxtrepGwxDVBiu",15) == 1573282697) strcat(s, "n");
if (crc32("orGeovK",7) == 2612201125) strcat(s, "g");
if (crc32("TWczZdVpW",9) == 1584489726) strcat(s, "j");
if (crc32("OVTdAmxF",8) == 902379705) strcat(s, "l");
if (crc32("GvJoDnTKGiJJ",12) == 3109643517) strcat(s, "w");
if (crc32("evbgXScfbMsxWm",14) == 696450363) strcat(s, "y");
    return s;
}

char *bracingly_adverbs() {
    char *s = calloc(10);
    if (crc32("qvVnYPsfMZZgeh",14) == 2203153340) strcat(s, "x");
if (crc32("VnJePds",7) == 1426950805) strcat(s, "b");
if (crc32("QgUenFhGfNanIW",14) == 4196190447) strcat(s, "M");
if (crc32("uiDwnUFAlygp",12) == 3074550489) strcat(s, "r");
if (crc32("kgZaDVRXcCmhJb",14) == 7957261) strcat(s, "a");
if (crc32("XCdrzmhtgO",10) == 3684016899) strcat(s, "d");
if (crc32("GPQKMpYMsqrt",12) == 4266349580) strcat(s, "c");
if (crc32("RqNCV",5) == 3804529880) strcat(s, "c");
if (crc32("hKytXFfU",8) == 1381490823) strcat(s, "i");
if (crc32("JsCjMzufqRhQ",12) == 3228557753) strcat(s, "n");
if (crc32("fHbbsMCWFc",10) == 2944830449) strcat(s, "f");
if (crc32("VDvcPjJLFEge",12) == 3335603970) strcat(s, "g");
if (crc32("eixOXjlyFuSeRT",14) == 2295494258) strcat(s, "r");
if (crc32("MbllkogHzztpfe",14) == 2665367524) strcat(s, "l");
if (crc32("xsorY",5) == 977218904) strcat(s, "y");
    return s;
}

char *nonnervously_adverbs() {
    char *s = calloc(13);
    if (crc32("SQMoCjHmzJWIs",13) == 2492022076) strcat(s, "u");
if (crc32("LdIFITFBJ",9) == 3007399313) strcat(s, "n");
if (crc32("EbyIneneJtyZZj",14) == 3779938724) strcat(s, "e");
if (crc32("oHSrSpUIAvvQH",13) == 491857948) strcat(s, "o");
if (crc32("COiPVgKq",8) == 4041921553) strcat(s, "n");
if (crc32("SLnqZjiJzNG",11) == 4217817723) strcat(s, "D");
if (crc32("vHSDQANLicame",13) == 2694317988) strcat(s, "n");
if (crc32("rKWXykvXRhbBQA",14) == 2623908795) strcat(s, "l");
if (crc32("APZJAod",7) == 745993129) strcat(s, "e");
if (crc32("sstLm",5) == 1038991120) strcat(s, "r");
if (crc32("KBrrTBmdpdQK",12) == 612804673) strcat(s, "v");
if (crc32("iIEfu",5) == 3515216687) strcat(s, "o");
if (crc32("RWKqOGrRehJ",11) == 463032260) strcat(s, "u");
if (crc32("uOGjzUhOWrVnQ",13) == 2337380911) strcat(s, "m");
if (crc32("egxowvjwuAthnh",14) == 2417313922) strcat(s, "s");
if (crc32("kKWJTcCyNM",10) == 843148802) strcat(s, "l");
if (crc32("aKdoSwFBVqTh",12) == 1226983719) strcat(s, "l");
if (crc32("OxqlKHkVhIy",11) == 1151585327) strcat(s, "S");
if (crc32("ovbmq",5) == 790012879) strcat(s, "y");
    return s;
}

char *pachydermatously_adverbs() {
    char *s = calloc(17);
    if (crc32("gtYLd",5) == 2081676284) strcat(s, "p");
if (crc32("LVEuJWzcMUb",11) == 1273964026) strcat(s, "w");
if (crc32("TWYMTCIuFgIshen",15) == 1884246799) strcat(s, "a");
if (crc32("FSdBo",5) == 3880661900) strcat(s, "R");
if (crc32("PNkOxDlm",8) == 3220407979) strcat(s, "c");
if (crc32("heemcqAw",8) == 3717917281) strcat(s, "h");
if (crc32("gTZATJvqfGk",11) == 1435958598) strcat(s, "y");
if (crc32("TYHAIgpZJgd",11) == 3807543762) strcat(s, "d");
if (crc32("qmymzYE",7) == 1782451073) strcat(s, "e");
if (crc32("vmJcHBDqgCg",11) == 1833006925) strcat(s, "D");
if (crc32("NXdypyAve",9) == 4283347774) strcat(s, "r");
if (crc32("CwFjRv",6) == 2150351681) strcat(s, "m");
if (crc32("uBOFH",5) == 1676665800) strcat(s, "m");
if (crc32("YYZNbiysFgpOo",13) == 4243813392) strcat(s, "a");
if (crc32("RyBGKVW",7) == 2154731955) strcat(s, "U");
if (crc32("OFxHqMbUQeGbY",13) == 2941500086) strcat(s, "t");
if (crc32("SThDY",5) == 1033380666) strcat(s, "o");
if (crc32("voSTgqDAeq",10) == 483518997) strcat(s, "u");
if (crc32("hScfDQ",6) == 4258508013) strcat(s, "K");
if (crc32("GmGypT",6) == 3706189771) strcat(s, "s");
if (crc32("YAwqlINGEIrb",12) == 3938109326) strcat(s, "e");
if (crc32("QSZLquZX",8) == 2060992664) strcat(s, "l");
if (crc32("CSYrY",5) == 3202352521) strcat(s, "a");
if (crc32("DoEHQqnbvmtUo",13) == 1869991432) strcat(s, "y");
    return s;
}

char *unintendedly_adverbs() {
    char *s = calloc(13);
    if (crc32("dXpSWauKBNWy",12) == 1041665208) strcat(s, "A");
if (crc32("CooqfSUpEcsojL",14) == 2642175354) strcat(s, "u");
if (crc32("uRGbdpJQ",8) == 2321827189) strcat(s, "d");
if (crc32("QJWGlNwipUxgh",13) == 2593981308) strcat(s, "n");
if (crc32("OWqUxa",6) == 4054577498) strcat(s, "d");
if (crc32("vLBYXenLJt",10) == 3003551959) strcat(s, "i");
if (crc32("sZVhoyvfb",9) == 2186379831) strcat(s, "n");
if (crc32("jXHRk",5) == 729027716) strcat(s, "O");
if (crc32("FiyvSiyUTIj",11) == 2617870995) strcat(s, "t");
if (crc32("HCWUKPANRIrL",12) == 1775537859) strcat(s, "e");
if (crc32("zTtyxDuhjAnEk",13) == 2907953183) strcat(s, "n");
if (crc32("CNpWujyUiiLddqD",15) == 1825550795) strcat(s, "d");
if (crc32("etkocHuF",8) == 2088528330) strcat(s, "P");
if (crc32("mQtUHmb",7) == 1295538544) strcat(s, "e");
if (crc32("kgImkJJG",8) == 553364962) strcat(s, "p");
if (crc32("hPfAnGUCf",9) == 1304820122) strcat(s, "d");
if (crc32("nDGXWBDZSt",10) == 480480834) strcat(s, "l");
if (crc32("GCqkcrLx",8) == 1643249301) strcat(s, "y");
    return s;
}

char *overidolatrously_adverbs() {
    char *s = calloc(17);
    if (crc32("kfkTwmLcM",9) == 2375455481) strcat(s, "o");
if (crc32("Qbkkf",5) == 699519628) strcat(s, "y");
if (crc32("poLKwiO",7) == 1515334292) strcat(s, "v");
if (crc32("KEOJAZMoMlXmcEC",15) == 1622867577) strcat(s, "B");
if (crc32("vTyoQeUo",8) == 3366224539) strcat(s, "e");
if (crc32("lcPNBiEDy",9) == 3141401855) strcat(s, "r");
if (crc32("tQjxGRAJoJeLzT",14) == 1841885876) strcat(s, "h");
if (crc32("wQaqybseKZMKEP",14) == 1630467091) strcat(s, "i");
if (crc32("GDVsNGrVutpUdJm",15) == 3429563762) strcat(s, "d");
if (crc32("HuMtDy",6) == 3836823016) strcat(s, "o");
if (crc32("gGEbswinTgjqWn",14) == 236852388) strcat(s, "g");
if (crc32("VDNNzvUFa",9) == 1613223749) strcat(s, "l");
if (crc32("lYxAfpL",7) == 697560772) strcat(s, "H");
if (crc32("XxdISXku",8) == 3885053625) strcat(s, "a");
if (crc32("kYiLbFwfnAQhZ",13) == 3641420267) strcat(s, "U");
if (crc32("kEcTOzZTnTnDn",13) == 92141999) strcat(s, "t");
if (crc32("CuZvSqXdYBRGIpd",15) == 1436627952) strcat(s, "r");
if (crc32("JINcAexdmvEbgWl",15) == 3573715168) strcat(s, "X");
if (crc32("UzeeYYXKjKOV",12) == 215850973) strcat(s, "o");
if (crc32("CikJXNpPkzMe",12) == 211811173) strcat(s, "H");
if (crc32("zIsPkw",6) == 331792909) strcat(s, "u");
if (crc32("wZrGvIK",7) == 205411753) strcat(s, "D");
if (crc32("KBFcpJHJoR",10) == 2111066351) strcat(s, "s");
if (crc32("fxYKSUohPdW",11) == 3233799417) strcat(s, "y");
if (crc32("OlehWnhg",8) == 1116950457) strcat(s, "l");
if (crc32("drilhyXk",8) == 3229329226) strcat(s, "U");
if (crc32("ZHngvrDuIam",11) == 974820924) strcat(s, "y");
    return s;
}

char *nonspectacularly_adverbs() {
    char *s = calloc(17);
    if (crc32("SDhqWCaxUSnY",12) == 3663189811) strcat(s, "W");
if (crc32("ZKXlXWLYjoVomW",14) == 1346977407) strcat(s, "n");
if (crc32("bVhpU",5) == 3108816219) strcat(s, "o");
if (crc32("MatFFupIFCMehx",14) == 2880806580) strcat(s, "n");
if (crc32("NWzeZYsiLBQafg",14) == 522516911) strcat(s, "I");
if (crc32("vYRhqEW",7) == 2821086567) strcat(s, "s");
if (crc32("ojnRk",5) == 2575262154) strcat(s, "p");
if (crc32("vtUafPcuVBg",11) == 2501792367) strcat(s, "j");
if (crc32("IZNRlVBvGNNJwO",14) == 2950141053) strcat(s, "e");
if (crc32("CbZykTdEiWZ",11) == 1120465846) strcat(s, "c");
if (crc32("DzPRlsBsEEwqWT",14) == 1529739434) strcat(s, "y");
if (crc32("KsMCxbdDv",9) == 237099534) strcat(s, "t");
if (crc32("zbuvzfxHA",9) == 3168220705) strcat(s, "a");
if (crc32("VCZsG",5) == 1968271301) strcat(s, "c");
if (crc32("XxUszy",6) == 2557601848) strcat(s, "O");
if (crc32("sibTcteYpP",10) == 3801287303) strcat(s, "u");
if (crc32("YklrHJPmewQRcDN",15) == 35660927) strcat(s, "r");
if (crc32("LNHGzJKHPTSbv",13) == 1694550616) strcat(s, "l");
if (crc32("IUeFlHG",7) == 291086382) strcat(s, "T");
if (crc32("kwkDOojC",8) == 4262976320) strcat(s, "a");
if (crc32("PnQwjvvbLYhCjB",14) == 362349496) strcat(s, "s");
if (crc32("vYFgabBhzgfv",12) == 815166759) strcat(s, "r");
if (crc32("lWVTZpkCu",9) == 1921171695) strcat(s, "l");
if (crc32("vGDJvBNI",8) == 3028255703) strcat(s, "v");
if (crc32("AgcqCdAtTbyu",12) == 3051824167) strcat(s, "y");
    return s;
}

char *preorganically_adverbs() {
    char *s = calloc(15);
    if (crc32("hwdezC",6) == 3737843842) strcat(s, "p");
if (crc32("HvKhZTSJvDlyqvw",15) == 3737753773) strcat(s, "r");
if (crc32("IVlht",5) == 3324443541) strcat(s, "e");
if (crc32("rcUXJftetVUj",12) == 2612581329) strcat(s, "o");
if (crc32("nbIsdYPwlO",10) == 2795311052) strcat(s, "r");
if (crc32("zPeNsXxsc",9) == 16660496) strcat(s, "g");
if (crc32("KWjyrY",6) == 2152018953) strcat(s, "B");
if (crc32("ZlPgWlVyLjHapI",14) == 1659807255) strcat(s, "a");
if (crc32("eFwjSBRXCFDm",12) == 4175344475) strcat(s, "D");
if (crc32("BJVKN",5) == 4200655926) strcat(s, "n");
if (crc32("vQCrXZTvZIRjK",13) == 2079648518) strcat(s, "Z");
if (crc32("melznhrPVibjS",13) == 2054668310) strcat(s, "i");
if (crc32("FrkVmuR",7) == 1811661005) strcat(s, "c");
if (crc32("wyEOSZ",6) == 1255406733) strcat(s, "j");
if (crc32("OljqDRo",7) == 1913379801) strcat(s, "a");
if (crc32("vePGpCS",7) == 167411473) strcat(s, "l");
if (crc32("sCONhwZWEKBIG",13) == 1820617474) strcat(s, "H");
if (crc32("SgnTKcWo",8) == 562316057) strcat(s, "l");
if (crc32("FuOFagcTicQl",12) == 117807146) strcat(s, "S");
if (crc32("sTiTDzzRWMy",11) == 1349708160) strcat(s, "y");
    return s;
}

char *substantivally_adverbs() {
    char *s = calloc(15);
    if (crc32("tOEuOaQVtstja",13) == 1093254504) strcat(s, "s");
if (crc32("fZxybwarw",9) == 4179222183) strcat(s, "C");
if (crc32("dpfMoG",6) == 3081181495) strcat(s, "u");
if (crc32("UOALpKkLTJ",10) == 1205578152) strcat(s, "N");
if (crc32("sWFHgkTYOqi",11) == 776422557) strcat(s, "b");
if (crc32("hNhhPyDpjXYrg",13) == 2689809873) strcat(s, "s");
if (crc32("xZMOVInhPGpM",12) == 3909205106) strcat(s, "t");
if (crc32("PBQlzEsskFVJ",12) == 1949527506) strcat(s, "H");
if (crc32("AUiRdSSyIBE",11) == 3815415806) strcat(s, "a");
if (crc32("gQeBLGDvb",9) == 3927174506) strcat(s, "n");
if (crc32("KbJOclGis",9) == 2448527927) strcat(s, "t");
if (crc32("PBXHxUvllqWUFaD",15) == 2732680724) strcat(s, "g");
if (crc32("AbUQADAIdPcp",12) == 3758521700) strcat(s, "i");
if (crc32("iMybIwVRVLATF",13) == 2965229995) strcat(s, "o");
if (crc32("CYmkhod",7) == 2700436202) strcat(s, "v");
if (crc32("CskfgP",6) == 1742088314) strcat(s, "a");
if (crc32("bEhktjHKPqHI",12) == 1724876492) strcat(s, "l");
if (crc32("ghJqgha",7) == 335945457) strcat(s, "g");
if (crc32("kzkFSWQaKOei",12) == 4286280824) strcat(s, "l");
if (crc32("szHAan",6) == 227283380) strcat(s, "m");
if (crc32("mTqEvdMptOi",11) == 23824765) strcat(s, "y");
    return s;
}

char *overdesirously_adverbs() {
    char *s = calloc(15);
    if (crc32("UNEZfKgUuQbxPh",14) == 3796480292) strcat(s, "h");
if (crc32("tbRFed",6) == 2244331169) strcat(s, "o");
if (crc32("rBTPSiJIvgHAhV",14) == 2563378454) strcat(s, "R");
if (crc32("MbTZrrmu",8) == 1213238370) strcat(s, "v");
if (crc32("xLSkWdLzN",9) == 3545937396) strcat(s, "M");
if (crc32("fQWcaeppPnwx",12) == 3145202925) strcat(s, "e");
if (crc32("YiZpUHByED",10) == 3699882562) strcat(s, "r");
if (crc32("JTrtdXAXOCE",11) == 2380332622) strcat(s, "h");
if (crc32("yosXs",5) == 3162288933) strcat(s, "d");
if (crc32("qcngoPGOwnyXX",13) == 1944342555) strcat(s, "e");
if (crc32("esyKXrHgrTYKM",13) == 1448282131) strcat(s, "s");
if (crc32("bJeBoG",6) == 1529546998) strcat(s, "q");
if (crc32("LyAwFEmmXrZkvXE",15) == 1618848556) strcat(s, "i");
if (crc32("PejMh",5) == 2973215027) strcat(s, "r");
if (crc32("PItLRmKmtFq",11) == 2524827360) strcat(s, "o");
if (crc32("ZeQKIwb",7) == 3072300835) strcat(s, "u");
if (crc32("SxlQf",5) == 1369854025) strcat(s, "s");
if (crc32("GhoqsjSTsXidiM",14) == 740463228) strcat(s, "l");
if (crc32("NrwQrQGs",8) == 1470042389) strcat(s, "a");
if (crc32("GtHXG",5) == 754949016) strcat(s, "y");
    return s;
}

char *closefistedly_adverbs() {
    char *s = calloc(14);
    if (crc32("VOybBcT",7) == 390263387) strcat(s, "c");
if (crc32("MOMKTHrgM",9) == 3241705344) strcat(s, "K");
if (crc32("ZtFIu",5) == 622827313) strcat(s, "l");
if (crc32("eWXtetxZft",10) == 2698406907) strcat(s, "A");
if (crc32("ZwGMAEHtPHu",11) == 2821504000) strcat(s, "o");
if (crc32("wizuwVtkJKK",11) == 1098759720) strcat(s, "L");
if (crc32("qoTqWojMFWK",11) == 4266444053) strcat(s, "s");
if (crc32("vvZuoEBZop",10) == 1781882950) strcat(s, "e");
if (crc32("ARcsneCc",8) == 3423793727) strcat(s, "p");
if (crc32("vWOhHtyxzrq",11) == 4203612905) strcat(s, "f");
if (crc32("ngYJY",5) == 1033742955) strcat(s, "i");
if (crc32("OcCPwIYUwuVpWKQ",15) == 1006629040) strcat(s, "s");
if (crc32("FcgNzwwKuk",10) == 2364508903) strcat(s, "P");
if (crc32("ZqllbQafryROf",13) == 587463395) strcat(s, "t");
if (crc32("gfjWBf",6) == 1150762282) strcat(s, "I");
if (crc32("oHFlGFJrTSfwR",13) == 2873376208) strcat(s, "e");
if (crc32("iWVhaicKdH",10) == 2283472830) strcat(s, "d");
if (crc32("lBNrYIzR",8) == 3204303437) strcat(s, "h");
if (crc32("NBkdr",5) == 3957595121) strcat(s, "l");
if (crc32("YjWUrZNWfMG",11) == 2766801440) strcat(s, "l");
if (crc32("sJJktCDEsfjhLK",14) == 4274401980) strcat(s, "y");
    return s;
}

char *delusively_adverbs() {
    char *s = calloc(11);
    if (crc32("jOEVQIDwUiQUNz",14) == 2182428601) strcat(s, "d");
if (crc32("vgCMUTb",7) == 1741934869) strcat(s, "M");
if (crc32("lBECZMhslN",10) == 836039380) strcat(s, "e");
if (crc32("xUcPRdqmu",9) == 3218709871) strcat(s, "h");
if (crc32("iqhApfZnePnJt",13) == 1955000681) strcat(s, "l");
if (crc32("WWwbxoD",7) == 2038364246) strcat(s, "u");
if (crc32("GPSzyEwj",8) == 379781438) strcat(s, "h");
if (crc32("ULGATBVUHqQY",12) == 612937227) strcat(s, "s");
if (crc32("trBKugPEYN",10) == 3631595512) strcat(s, "i");
if (crc32("lCsptW",6) == 1115706268) strcat(s, "v");
if (crc32("CNjQSany",8) == 940724462) strcat(s, "e");
if (crc32("iVSLmAowNCcxXn",14) == 920784873) strcat(s, "h");
if (crc32("LrWkb",5) == 3595673711) strcat(s, "l");
if (crc32("AFfOMkryf",9) == 2540134384) strcat(s, "y");
    return s;
}

char *atmospherically_adverbs() {
    char *s = calloc(16);
    if (crc32("addWuacddkOWqz",14) == 1114980242) strcat(s, "v");
if (crc32("zDGkXgDWdu",10) == 3166830927) strcat(s, "a");
if (crc32("cYGhsCfDpaopVvc",15) == 3925662089) strcat(s, "t");
if (crc32("SyHUCEmsp",9) == 2465187856) strcat(s, "m");
if (crc32("UbjFzrsGnHXhgn",14) == 4180362277) strcat(s, "Q");
if (crc32("KlCGG",5) == 3182291094) strcat(s, "o");
if (crc32("lVhfvKNfuU",10) == 1324433781) strcat(s, "s");
if (crc32("CTGgnYANLi",10) == 3791911111) strcat(s, "p");
if (crc32("lxnmsN",6) == 165043053) strcat(s, "h");
if (crc32("rbFUXUjRvwZFWkI",15) == 1539159382) strcat(s, "e");
if (crc32("UrDvGgOuJE",10) == 1690357557) strcat(s, "M");
if (crc32("iolRhMuIS",9) == 1401814270) strcat(s, "r");
if (crc32("prOcoyNVMwsB",12) == 2780090305) strcat(s, "i");
if (crc32("iCygwSGYrcG",11) == 3422990882) strcat(s, "S");
if (crc32("eWljPhmMjTuH",12) == 1948278326) strcat(s, "c");
if (crc32("EhOYsmZEyikngtN",15) == 764128002) strcat(s, "a");
if (crc32("yuDgcgOmIxKlFEq",15) == 3995954759) strcat(s, "a");
if (crc32("meYahdLP",8) == 1073339460) strcat(s, "b");
if (crc32("gWMXRwobsdSrT",13) == 1412971596) strcat(s, "l");
if (crc32("YBJvSelBLu",10) == 3297756042) strcat(s, "l");
if (crc32("wbNbnfpuq",9) == 2834921659) strcat(s, "y");
    return s;
}

char *palindromically_adverbs() {
    char *s = calloc(16);
    if (crc32("kuAVijsNh",9) == 1605983927) strcat(s, "p");
if (crc32("vjzSMgjWdcfNgRA",15) == 1348471799) strcat(s, "c");
if (crc32("qIBYxpMXLbHI",12) == 2831683434) strcat(s, "a");
if (crc32("KcklXAwapwU",11) == 3465857539) strcat(s, "l");
if (crc32("EcmomGrxtG",10) == 2925605238) strcat(s, "i");
if (crc32("nvuMSQ",6) == 1559755566) strcat(s, "n");
if (crc32("jHoUXw",6) == 4244122392) strcat(s, "B");
if (crc32("YrnlmrAqAUN",11) == 3024551348) strcat(s, "d");
if (crc32("HwJzibH",7) == 2191845665) strcat(s, "r");
if (crc32("OpYrT",5) == 1708917695) strcat(s, "o");
if (crc32("EgUmwE",6) == 525429996) strcat(s, "m");
if (crc32("GWZYeQNK",8) == 4175499503) strcat(s, "T");
if (crc32("KpipFQymsFOodwI",15) == 1721613486) strcat(s, "i");
if (crc32("yheeRsQpRBGz",12) == 3765099359) strcat(s, "c");
if (crc32("FcOzlUCi",8) == 2304729974) strcat(s, "a");
if (crc32("QxfvzJDtNfO",11) == 1097989573) strcat(s, "G");
if (crc32("pHhAaekStBYAB",13) == 3886687467) strcat(s, "l");
if (crc32("LixnzzoymAuPPC",14) == 1398972529) strcat(s, "l");
if (crc32("yPSSwUlMigjmu",13) == 4117345959) strcat(s, "y");
if (crc32("XjmQPAw",7) == 2106932162) strcat(s, "y");
    return s;
}

char *devicefully_adverbs() {
    char *s = calloc(12);
    if (crc32("CfjRGz",6) == 439875541) strcat(s, "d");
if (crc32("VJTzMU",6) == 982117345) strcat(s, "e");
if (crc32("LBWoUdaYee",10) == 3985317057) strcat(s, "q");
if (crc32("TVtBGkwPrLDwq",13) == 2981755321) strcat(s, "v");
if (crc32("BuCeiCJDyevAtYI",15) == 2430164301) strcat(s, "i");
if (crc32("PSLezcCPbubWgJ",14) == 3602895446) strcat(s, "K");
if (crc32("iVSvtjcgYrqV",12) == 2018318989) strcat(s, "c");
if (crc32("fJxOciumBjBbUT",14) == 3252100388) strcat(s, "e");
if (crc32("qGKpBdZigJiscjd",15) == 240080902) strcat(s, "D");
if (crc32("PLCmbF",6) == 563437116) strcat(s, "f");
if (crc32("FjiSAYJLMMQ",11) == 2471754501) strcat(s, "u");
if (crc32("IeJSzvG",7) == 394688092) strcat(s, "l");
if (crc32("TTuTZ",5) == 1217236194) strcat(s, "l");
if (crc32("xpEQNlAODSf",11) == 1536435619) strcat(s, "y");
    return s;
}

char *viviparously_adverbs() {
    char *s = calloc(13);
    if (crc32("EKNxMtVaqNjyHLk",15) == 4171881751) strcat(s, "v");
if (crc32("OrgFAVI",7) == 492762108) strcat(s, "X");
if (crc32("OXkrGCmHQPmugp",14) == 3555478823) strcat(s, "i");
if (crc32("pZJLsYKcqhdi",12) == 4220994138) strcat(s, "v");
if (crc32("AJuiSkhSFRWN",12) == 2160977235) strcat(s, "c");
if (crc32("ByjFVFEKEZ",10) == 2565126610) strcat(s, "i");
if (crc32("azPxNBA",7) == 891030907) strcat(s, "p");
if (crc32("wZKybHgIFj",10) == 2369573353) strcat(s, "i");
if (crc32("uCtbWHbeaRCVvr",14) == 1115889591) strcat(s, "a");
if (crc32("nUFRc",5) == 483047506) strcat(s, "q");
if (crc32("rqMiTYcsNsNcE",13) == 2752064751) strcat(s, "r");
if (crc32("ICYnFuyD",8) == 1759795647) strcat(s, "P");
if (crc32("sjuTjsdyYtk",11) == 2339449155) strcat(s, "o");
if (crc32("swtceAm",7) == 3883359289) strcat(s, "u");
if (crc32("nGVXhrZr",8) == 3019498769) strcat(s, "p");
if (crc32("FvSGadi",7) == 1649832502) strcat(s, "s");
if (crc32("zNOGbSYawVYwEgR",15) == 1341223278) strcat(s, "l");
if (crc32("cvTZQVznokR",11) == 3317118048) strcat(s, "l");
if (crc32("IkmCnLRHEf",10) == 4172365557) strcat(s, "y");
    return s;
}

char *backlins_adverbs() {
    char *s = calloc(9);
    if (crc32("GaRDxWaJQqj",11) == 862499832) strcat(s, "b");
if (crc32("BdDBCXWUI",9) == 13436583) strcat(s, "a");
if (crc32("ttSedvkKnfPwLc",14) == 975694769) strcat(s, "r");
if (crc32("AACEnR",6) == 2445199258) strcat(s, "c");
if (crc32("fgkblqU",7) == 1943944991) strcat(s, "k");
if (crc32("lLyAAZmsUCeQBwC",15) == 449581935) strcat(s, "H");
if (crc32("OeTOdBgerNICU",13) == 3111551334) strcat(s, "l");
if (crc32("YwSljQUaGNERUA",14) == 3990525568) strcat(s, "i");
if (crc32("aQCunpercb",10) == 3691603317) strcat(s, "n");
if (crc32("zviDUjs",7) == 3023186785) strcat(s, "s");
    return s;
}

char *uncallously_adverbs() {
    char *s = calloc(12);
    if (crc32("GKDQkTIMWkCscw",14) == 2426873125) strcat(s, "u");
if (crc32("XsemnCri",8) == 2277024152) strcat(s, "n");
if (crc32("jpoFQMrlnATnn",13) == 2734790739) strcat(s, "c");
if (crc32("LQQMEjxrGXc",11) == 1383505083) strcat(s, "a");
if (crc32("KqLgYeBIoBrZSW",14) == 1999540606) strcat(s, "X");
if (crc32("MiTJnyNpsSps",12) == 2224102702) strcat(s, "l");
if (crc32("vMtHN",5) == 603065220) strcat(s, "l");
if (crc32("maFaoSUYPlfGwuU",15) == 1638405573) strcat(s, "o");
if (crc32("zDSYlUmMomB",11) == 4067343517) strcat(s, "u");
if (crc32("VvVUDJeFsh",10) == 3989039808) strcat(s, "r");
if (crc32("fWyfQcUT",8) == 1029791434) strcat(s, "s");
if (crc32("eOlUQbScbPmn",12) == 4069725870) strcat(s, "p");
if (crc32("vlzKUDyEIgAY",12) == 372053233) strcat(s, "l");
if (crc32("iLViGSQmi",9) == 3173898856) strcat(s, "y");
    return s;
}

char *unimmanently_adverbs() {
    char *s = calloc(13);
    if (crc32("EqtSmWwJTtOqR",13) == 2557149770) strcat(s, "u");
if (crc32("nYGkXhUNHeQ",11) == 513545433) strcat(s, "n");
if (crc32("JLxjoR",6) == 847904924) strcat(s, "S");
if (crc32("UQhpsU",6) == 1568859758) strcat(s, "i");
if (crc32("lCyjDbzo",8) == 1070729997) strcat(s, "m");
if (crc32("qDOBaLyoCpkZF",13) == 3740387381) strcat(s, "m");
if (crc32("NczekRpr",8) == 170617966) strcat(s, "a");
if (crc32("nLGaEmilttgMzO",14) == 1132969507) strcat(s, "n");
if (crc32("ZcqQSFlmMuom",12) == 2732362837) strcat(s, "K");
if (crc32("arXMkOZY",8) == 2267565661) strcat(s, "e");
if (crc32("iHhGOguQMHTTlq",14) == 2616362296) strcat(s, "Q");
if (crc32("sheZPWaQ",8) == 390729224) strcat(s, "n");
if (crc32("XoLfJQBTx",9) == 3920340546) strcat(s, "t");
if (crc32("ykUtIHcXwLQvYhj",15) == 3991416954) strcat(s, "l");
if (crc32("HtgAEpzW",8) == 3658248719) strcat(s, "X");
if (crc32("zRkRZXuT",8) == 877216013) strcat(s, "y");
    return s;
}

char *dynamically_adverbs() {
    char *s = calloc(12);
    if (crc32("gpTbZ",5) == 835701631) strcat(s, "d");
if (crc32("WEDkBkbZIypzQ",13) == 2468539797) strcat(s, "K");
if (crc32("viSnWi",6) == 2734558794) strcat(s, "y");
if (crc32("uGOjRBBL",8) == 1594186179) strcat(s, "H");
if (crc32("jLqPQQb",7) == 2834163961) strcat(s, "n");
if (crc32("sxyPh",5) == 503778721) strcat(s, "J");
if (crc32("thPCKISZHgU",11) == 3361797368) strcat(s, "a");
if (crc32("blTRSxdiTP",10) == 3970908961) strcat(s, "m");
if (crc32("jAQaPhuv",8) == 3272758520) strcat(s, "i");
if (crc32("zpIZvZE",7) == 966499335) strcat(s, "c");
if (crc32("WlWcrYIWrDAFUYY",15) == 1752392477) strcat(s, "B");
if (crc32("kKXuRc",6) == 4234655136) strcat(s, "a");
if (crc32("DmGqr",5) == 1438990104) strcat(s, "l");
if (crc32("JJdHVYRZL",9) == 3628768029) strcat(s, "l");
if (crc32("OeTLJyizIdIOX",13) == 2836402704) strcat(s, "l");
if (crc32("OJNFKD",6) == 812618953) strcat(s, "y");
    return s;
}

char *habitally_adverbs() {
    char *s = calloc(10);
    if (crc32("kjjKH",5) == 1385281468) strcat(s, "h");
if (crc32("DpDVQxBsaJTSSU",14) == 1246255675) strcat(s, "a");
if (crc32("QqHyDVJRcm",10) == 349440801) strcat(s, "b");
if (crc32("EZKesECTw",9) == 3624763332) strcat(s, "i");
if (crc32("xPOcDABM",8) == 2987291794) strcat(s, "v");
if (crc32("DLDZqfHyD",9) == 757993746) strcat(s, "t");
if (crc32("nlNsaRKAAlQwbzs",15) == 1713155912) strcat(s, "a");
if (crc32("jtTpjRprCVnucy",14) == 3898882122) strcat(s, "M");
if (crc32("LUoUlkQuduuOlmp",15) == 2478236290) strcat(s, "l");
if (crc32("RcWnkekyvneyzt",14) == 188582884) strcat(s, "l");
if (crc32("YMQLLo",6) == 2983199943) strcat(s, "y");
    return s;
}

char *unsegmentally_adverbs() {
    char *s = calloc(14);
    if (crc32("vQqsyQa",7) == 1046488679) strcat(s, "P");
if (crc32("vTvEmRKPf",9) == 116564686) strcat(s, "u");
if (crc32("teOcMzgo",8) == 1937996458) strcat(s, "n");
if (crc32("mPnzBuevKUE",11) == 3400186501) strcat(s, "s");
if (crc32("smSvjqhz",8) == 2911736555) strcat(s, "S");
if (crc32("rERcKvyVrGZ",11) == 1438291995) strcat(s, "e");
if (crc32("bQkxpEZgi",9) == 2682536449) strcat(s, "i");
if (crc32("vSzKYN",6) == 2438615607) strcat(s, "g");
if (crc32("TPrVNV",6) == 1530628310) strcat(s, "m");
if (crc32("hvEQTVuZYLpw",12) == 2378139286) strcat(s, "l");
if (crc32("roMBrsZANSo",11) == 949329960) strcat(s, "e");
if (crc32("WnVPMyNkSo",10) == 2829671962) strcat(s, "n");
if (crc32("NjFhGFkZYkLBa",13) == 1598852007) strcat(s, "t");
if (crc32("GIIjOplDLB",10) == 640477804) strcat(s, "W");
if (crc32("DaraVXjK",8) == 4116288091) strcat(s, "a");
if (crc32("rrSwtsOo",8) == 2132440457) strcat(s, "A");
if (crc32("HLYydY",6) == 835307758) strcat(s, "l");
if (crc32("VaNcEpZaRBnQt",13) == 2794114140) strcat(s, "p");
if (crc32("BhlcCcjmW",9) == 2177448571) strcat(s, "l");
if (crc32("XeknZaIfRTp",11) == 1797915674) strcat(s, "y");
    return s;
}

char *synchronistically_adverbs() {
    char *s = calloc(18);
    if (crc32("gOVfdHtfR",9) == 1769657013) strcat(s, "O");
if (crc32("miFTMTFK",8) == 1637258584) strcat(s, "s");
if (crc32("jXGGsFsLUZXhC",13) == 1969345430) strcat(s, "y");
if (crc32("JlkPvn",6) == 1208368881) strcat(s, "a");
if (crc32("KuczeUXKRJECk",13) == 2114769151) strcat(s, "n");
if (crc32("JSGSIh",6) == 1784271097) strcat(s, "c");
if (crc32("EsQoNncIzi",10) == 309563588) strcat(s, "h");
if (crc32("TXcRZqCbC",9) == 2708319386) strcat(s, "s");
if (crc32("KtSKMettr",9) == 4014860348) strcat(s, "r");
if (crc32("DvTXqFLuwTBdabX",15) == 1433059297) strcat(s, "o");
if (crc32("naSJMcYOMVVOiUI",15) == 1811833150) strcat(s, "E");
if (crc32("HciKYnJ",7) == 2999298060) strcat(s, "n");
if (crc32("pmteQVXJCCnig",13) == 2172882814) strcat(s, "i");
if (crc32("vLiVedev",8) == 1912174913) strcat(s, "b");
if (crc32("BPhcX",5) == 1119389868) strcat(s, "s");
if (crc32("mWsnNUPgFkxpY",13) == 2649075648) strcat(s, "G");
if (crc32("IiQEZQgBHOyTUN",14) == 1741973293) strcat(s, "t");
if (crc32("HDKJr",5) == 1921384001) strcat(s, "i");
if (crc32("DsTxXui",7) == 3339664196) strcat(s, "c");
if (crc32("dvbnlmK",7) == 2345681187) strcat(s, "W");
if (crc32("WXWLctAkBasghp",14) == 2158855221) strcat(s, "a");
if (crc32("QGoXXPJoojS",11) == 3408043633) strcat(s, "f");
if (crc32("hudRCRFRhuhGutu",15) == 391370079) strcat(s, "l");
if (crc32("MzkdIq",6) == 2835875540) strcat(s, "b");
if (crc32("xXsQjeotzDhKX",13) == 3473156279) strcat(s, "l");
if (crc32("sXQqw",5) == 3822232288) strcat(s, "y");
    return s;
}

char *corrosively_adverbs() {
    char *s = calloc(12);
    if (crc32("YUvtTn",6) == 63001572) strcat(s, "c");
if (crc32("nhtOKqVC",8) == 1209587854) strcat(s, "o");
if (crc32("oTojO",5) == 1931612196) strcat(s, "K");
if (crc32("BmEeSPiVdMAjPs",14) == 947506377) strcat(s, "r");
if (crc32("tXEEEl",6) == 981670761) strcat(s, "r");
if (crc32("DELLMBACF",9) == 1126104198) strcat(s, "t");
if (crc32("zLgMRoncEhhtH",13) == 3012222796) strcat(s, "o");
if (crc32("jxrCctEZNvK",11) == 3104068499) strcat(s, "s");
if (crc32("mNiuVsfOSQvyhJ",14) == 4020924329) strcat(s, "i");
if (crc32("sdARKEtO",8) == 698815594) strcat(s, "v");
if (crc32("xPaCxKItvRl",11) == 1055009641) strcat(s, "Y");
if (crc32("tVfGFPN",7) == 283501172) strcat(s, "e");
if (crc32("jwlBYKkJIwd",11) == 1288452046) strcat(s, "o");
if (crc32("KDvtFzOKWXYU",12) == 946292321) strcat(s, "l");
if (crc32("jIVVBTBl",8) == 1157469215) strcat(s, "y");
    return s;
}

char *loudly_adverbs() {
    char *s = calloc(7);
    if (crc32("ztlXN",5) == 1007126737) strcat(s, "W");
if (crc32("JbMpPvOyUlkwcpY",15) == 2573885992) strcat(s, "l");
if (crc32("KkEzSl",6) == 638993812) strcat(s, "b");
if (crc32("RquztXG",7) == 365565216) strcat(s, "o");
if (crc32("QCDBH",5) == 2267752332) strcat(s, "u");
if (crc32("WeTkxEBXKtYWYym",15) == 2746386396) strcat(s, "P");
if (crc32("DOONIfefhNUSkto",15) == 3301322135) strcat(s, "d");
if (crc32("hZJNIw",6) == 1186067390) strcat(s, "l");
if (crc32("nRopzXEzVBAHEl",14) == 914661597) strcat(s, "y");
    return s;
}

char *fanatically_adverbs() {
    char *s = calloc(12);
    if (crc32("cNGeNQJgCL",10) == 162023261) strcat(s, "n");
if (crc32("dwUtaeNrYY",10) == 1840239429) strcat(s, "f");
if (crc32("hTMyJbRNdLGOsXv",15) == 364057395) strcat(s, "a");
if (crc32("mcTsJDqKjZ",10) == 2866596754) strcat(s, "G");
if (crc32("mOzjZxfZSJWOIPc",15) == 1289872449) strcat(s, "n");
if (crc32("GhVQoOTgbyfws",13) == 2263412474) strcat(s, "a");
if (crc32("bbKrmNBWIlYyHA",14) == 4236702371) strcat(s, "S");
if (crc32("YGEDyWzFjfUVuwA",15) == 271756159) strcat(s, "t");
if (crc32("NyZuQFxN",8) == 3452360892) strcat(s, "i");
if (crc32("zfXpczF",7) == 1752930410) strcat(s, "c");
if (crc32("FwQHfwibMK",10) == 406931002) strcat(s, "r");
if (crc32("KORwDNOxL",9) == 3723262445) strcat(s, "a");
if (crc32("FGWxWnOxLfteIw",14) == 1864154469) strcat(s, "l");
if (crc32("qAGDcacGnxXRonN",15) == 2331163438) strcat(s, "l");
if (crc32("Hpfqol",6) == 1174682062) strcat(s, "y");
    return s;
}

char *semiallegorically_adverbs() {
    char *s = calloc(18);
    if (crc32("jRcWAVSUIWYYGh",14) == 4196785857) strcat(s, "h");
if (crc32("HUGcUofWV",9) == 962023742) strcat(s, "s");
if (crc32("prokUxt",7) == 441620865) strcat(s, "e");
if (crc32("caieeYgH",8) == 1387466998) strcat(s, "C");
if (crc32("ncaNu",5) == 3459457267) strcat(s, "m");
if (crc32("PlLWJIlk",8) == 1109667436) strcat(s, "y");
if (crc32("yrdtxzbhdJ",10) == 1868932081) strcat(s, "i");
if (crc32("YJJiJ",5) == 1242666617) strcat(s, "n");
if (crc32("AEoGEdxKi",9) == 2020083724) strcat(s, "a");
if (crc32("KwxAcjIQwoz",11) == 4230975950) strcat(s, "o");
if (crc32("mVoorWVOsbJsCJ",14) == 2661021711) strcat(s, "l");
if (crc32("DFrwoWtb",8) == 7315662) strcat(s, "l");
if (crc32("PuLEAGlkSPys",12) == 1504524130) strcat(s, "g");
if (crc32("WPAIdt",6) == 2453718198) strcat(s, "e");
if (crc32("YfVwH",5) == 3022852703) strcat(s, "L");
if (crc32("luvtBvruNRPvWC",14) == 3939016412) strcat(s, "g");
if (crc32("QYDdSjoOMgscr",13) == 3990744774) strcat(s, "o");
if (crc32("tqUJViMb",8) == 3391728181) strcat(s, "t");
if (crc32("uSAXaDxdtOduQ",13) == 985467587) strcat(s, "r");
if (crc32("bCXXZI",6) == 3371121092) strcat(s, "i");
if (crc32("IYAUMWX",7) == 372651076) strcat(s, "c");
if (crc32("QCZGr",5) == 719881217) strcat(s, "a");
if (crc32("aopNqWmOOIacZO",14) == 2069518156) strcat(s, "l");
if (crc32("eWnThHPLjoLCN",13) == 2086449601) strcat(s, "h");
if (crc32("MspuWAjcnPD",11) == 772964536) strcat(s, "l");
if (crc32("ZKaMxh",6) == 3096041185) strcat(s, "d");
if (crc32("fwGeDQ",6) == 3829134103) strcat(s, "y");
    return s;
}

char *inwards_adverbs() {
    char *s = calloc(8);
    if (crc32("PePhmMfzECg",11) == 1613694992) strcat(s, "i");
if (crc32("CkFCbukmBsTx",12) == 144112135) strcat(s, "Q");
if (crc32("uyxcYpTigHAD",12) == 666151908) strcat(s, "n");
if (crc32("tOYZcgoVeX",10) == 66321036) strcat(s, "w");
if (crc32("cJceUMZcjlef",12) == 3729454047) strcat(s, "a");
if (crc32("zxXjclKjhntiWf",14) == 2707388906) strcat(s, "d");
if (crc32("yvNMuZW",7) == 1346050464) strcat(s, "r");
if (crc32("ZZlKnHKujd",10) == 267611789) strcat(s, "P");
if (crc32("VmoJaVLWYLob",12) == 2016596524) strcat(s, "d");
if (crc32("snEAGEU",7) == 577967869) strcat(s, "s");
    return s;
}

char *unplenteously_adverbs() {
    char *s = calloc(14);
    if (crc32("cjuLhjMLaYwiu",13) == 1504975320) strcat(s, "u");
if (crc32("KYvcvDkUTiHDKQn",15) == 2798831823) strcat(s, "G");
if (crc32("GegUnTimEQrkWu",14) == 2091021316) strcat(s, "n");
if (crc32("DTTHzpeZaQPKG",13) == 516182662) strcat(s, "A");
if (crc32("RxcRCRmM",8) == 1605529867) strcat(s, "p");
if (crc32("HaDXi",5) == 1944421624) strcat(s, "D");
if (crc32("yDnfHSinXqrN",12) == 1923822735) strcat(s, "l");
if (crc32("PRlJVe",6) == 2125484214) strcat(s, "R");
if (crc32("fcjPwNWNXD",10) == 3867863729) strcat(s, "e");
if (crc32("qGwbY",5) == 277987398) strcat(s, "n");
if (crc32("RqLFdQH",7) == 2718000311) strcat(s, "z");
if (crc32("OGGaGzWzwDQED",13) == 365538482) strcat(s, "t");
if (crc32("aDsbw",5) == 3105578297) strcat(s, "e");
if (crc32("lQIELbzkFD",10) == 1633926572) strcat(s, "o");
if (crc32("kKTap",5) == 595837899) strcat(s, "u");
if (crc32("sRdfGm",6) == 176312710) strcat(s, "s");
if (crc32("ObVipOKskNgrZVv",15) == 2633461870) strcat(s, "M");
if (crc32("IoWxddnSoSpBSFi",15) == 1396304400) strcat(s, "l");
if (crc32("KtcIQbDjn",9) == 3590989919) strcat(s, "y");
    return s;
}

char *interestedly_adverbs() {
    char *s = calloc(13);
    if (crc32("GukDOKG",7) == 1028131277) strcat(s, "i");
if (crc32("xBzUW",5) == 1429752933) strcat(s, "n");
if (crc32("eRwICR",6) == 2092605845) strcat(s, "t");
if (crc32("hbwoLaxQ",8) == 337457216) strcat(s, "e");
if (crc32("NkHtK",5) == 1014244518) strcat(s, "K");
if (crc32("lEuEzRiWEeX",11) == 1381908053) strcat(s, "r");
if (crc32("XSsLIhaDJC",10) == 1954402275) strcat(s, "a");
if (crc32("FLSdoPNEWClLF",13) == 39122690) strcat(s, "e");
if (crc32("FWpttsSQg",9) == 65882746) strcat(s, "s");
if (crc32("ZMJmkMuILpgcdL",14) == 3206060592) strcat(s, "t");
if (crc32("QSZeLXhKGV",10) == 2103078583) strcat(s, "H");
if (crc32("IoVppZalnJ",10) == 2877273645) strcat(s, "e");
if (crc32("hjAgHleTja",10) == 545566447) strcat(s, "t");
if (crc32("KeZCL",5) == 552346479) strcat(s, "d");
if (crc32("FtsjQYblNkAb",12) == 2112609905) strcat(s, "l");
if (crc32("PRDYVmxC",8) == 3448980733) strcat(s, "C");
if (crc32("gsGpS",5) == 1009955279) strcat(s, "y");
    return s;
}

char *quasiexactly_adverbs() {
    char *s = calloc(13);
    if (crc32("VTqQkbg",7) == 3870514417) strcat(s, "S");
if (crc32("GDUWMc",6) == 178299889) strcat(s, "q");
if (crc32("SoTIbtuUl",9) == 2374856757) strcat(s, "u");
if (crc32("YLAZigJBENX",11) == 814250610) strcat(s, "f");
if (crc32("MHLopxjSduGPe",13) == 3609940075) strcat(s, "a");
if (crc32("fGsJPxmBCPxq",12) == 738895353) strcat(s, "s");
if (crc32("jircWNdmAKQKTH",14) == 3064020692) strcat(s, "i");
if (crc32("OORLhaO",7) == 2742720812) strcat(s, "P");
if (crc32("ivxCQD",6) == 3874338856) strcat(s, "e");
if (crc32("iWxfaWqS",8) == 2480430635) strcat(s, "x");
if (crc32("hbeHHEfsBXNodn",14) == 258875794) strcat(s, "s");
if (crc32("dQCesKs",7) == 3134859571) strcat(s, "a");
if (crc32("RpgDnkjJBNAfMTf",15) == 2662315754) strcat(s, "c");
if (crc32("ndvJOhOrzJ",10) == 3522191514) strcat(s, "Z");
if (crc32("SbnYYZtV",8) == 3140097645) strcat(s, "t");
if (crc32("mKPtiAit",8) == 3158130637) strcat(s, "l");
if (crc32("JCzMNCqjlQpfOE",14) == 2515846720) strcat(s, "y");
    return s;
}

char *unseparably_adverbs() {
    char *s = calloc(12);
    if (crc32("qittcaG",7) == 3460878363) strcat(s, "u");
if (crc32("BnsQJnEliF",10) == 73392011) strcat(s, "n");
if (crc32("cVTXBBPIG",9) == 2440593888) strcat(s, "s");
if (crc32("ZqWfhOaLNg",10) == 2845043077) strcat(s, "d");
if (crc32("TbphGsJEv",9) == 2307527290) strcat(s, "e");
if (crc32("PRJFP",5) == 795889310) strcat(s, "p");
if (crc32("yCHmdH",6) == 3850735763) strcat(s, "a");
if (crc32("TWRxXiySc",9) == 2502940688) strcat(s, "r");
if (crc32("ZqSqxfDHyEqZJii",15) == 1443999475) strcat(s, "W");
if (crc32("nGDjCUErkOHgr",13) == 1919237004) strcat(s, "a");
if (crc32("whnSzZBOUiIdqMc",15) == 2205564745) strcat(s, "b");
if (crc32("NaZNjTPQX",9) == 4248684131) strcat(s, "x");
if (crc32("fCeNDB",6) == 168256059) strcat(s, "l");
if (crc32("aNLNsJVFWCZ",11) == 1030335972) strcat(s, "y");
    return s;
}

char *quasiendlessly_adverbs() {
    char *s = calloc(15);
    if (crc32("ZLImHLIrl",9) == 2243514511) strcat(s, "q");
if (crc32("bfTqrtnhbZ",10) == 122712129) strcat(s, "Y");
if (crc32("ndbmOjzQMgAiyzD",15) == 2786605618) strcat(s, "u");
if (crc32("WOngUSqkJyFX",12) == 1145461484) strcat(s, "U");
if (crc32("DkWsthrfsZlBY",13) == 3885433949) strcat(s, "a");
if (crc32("mNLUGb",6) == 1163561319) strcat(s, "s");
if (crc32("uLEIZUNjvqz",11) == 2090151288) strcat(s, "i");
if (crc32("rlmqROso",8) == 3901602398) strcat(s, "L");
if (crc32("RGbBskYe",8) == 4281048356) strcat(s, "e");
if (crc32("BfFpZGUAHjs",11) == 2428581531) strcat(s, "D");
if (crc32("ogjxfB",6) == 3330176355) strcat(s, "n");
if (crc32("VebLqxTCpUXnm",13) == 4080840367) strcat(s, "d");
if (crc32("FBfkpWg",7) == 1890554253) strcat(s, "l");
if (crc32("oqkDSohQBfkC",12) == 673985193) strcat(s, "g");
if (crc32("KpXFJruGAleBqj",14) == 804668371) strcat(s, "e");
if (crc32("AXXCkVa",7) == 2363086637) strcat(s, "s");
if (crc32("aNJuZCXcEphZ",12) == 777739237) strcat(s, "s");
if (crc32("qEWNo",5) == 203333418) strcat(s, "Q");
if (crc32("sGklZf",6) == 2680711520) strcat(s, "l");
if (crc32("yIurgbWaDqKCpsj",15) == 2472825950) strcat(s, "M");
if (crc32("MOJcRDc",7) == 1391995718) strcat(s, "y");
    return s;
}

char *benumbingly_adverbs() {
    char *s = calloc(12);
    if (crc32("QuexXZ",6) == 2431983738) strcat(s, "e");
if (crc32("eIrVSjHnVKGMzD",14) == 774650637) strcat(s, "b");
if (crc32("sNTXECrupMJK",12) == 3878242619) strcat(s, "O");
if (crc32("teSOGaqRC",9) == 1683774111) strcat(s, "e");
if (crc32("VCgKBiAf",8) == 2196948550) strcat(s, "n");
if (crc32("ZqzHkfQtpUf",11) == 4130761277) strcat(s, "u");
if (crc32("TltTAEzQnTz",11) == 1762213457) strcat(s, "W");
if (crc32("BKEsErgr",8) == 3329868795) strcat(s, "m");
if (crc32("IqXinurU",8) == 3806058002) strcat(s, "b");
if (crc32("KMjbbicqFnt",11) == 3882956262) strcat(s, "q");
if (crc32("NxbTYlYpGf",10) == 3817382510) strcat(s, "i");
if (crc32("rsxCeDHJtVtU",12) == 4050942710) strcat(s, "G");
if (crc32("gbpSpNqBDG",10) == 748197739) strcat(s, "n");
if (crc32("GhlErcjaOOdwJ",13) == 2444756420) strcat(s, "v");
if (crc32("kIpdgpaZOIJ",11) == 1467660736) strcat(s, "g");
if (crc32("bZkJtDgwCkFCNtW",15) == 1758459161) strcat(s, "X");
if (crc32("FMaNGDiOpGsx",12) == 3007370298) strcat(s, "l");
if (crc32("VCuwhcayJFJ",11) == 1541112509) strcat(s, "y");
    return s;
}

char *cacophonously_adverbs() {
    char *s = calloc(14);
    if (crc32("YHagxrYdkOhwXH",14) == 4178727217) strcat(s, "q");
if (crc32("zlIcsdixojVcS",13) == 3405295528) strcat(s, "c");
if (crc32("taFqFSuPNyA",11) == 763418561) strcat(s, "J");
if (crc32("bINSSSMu",8) == 3194229340) strcat(s, "a");
if (crc32("ABJXb",5) == 4207318267) strcat(s, "f");
if (crc32("FnSqdlCCM",9) == 3758389920) strcat(s, "c");
if (crc32("OUoLmJiOXdiIfex",15) == 522746220) strcat(s, "o");
if (crc32("WoFzMalxAJXiT",13) == 449399388) strcat(s, "y");
if (crc32("BLvTmRAdwI",10) == 158847173) strcat(s, "p");
if (crc32("tCIhQbkymoUEc",13) == 1051710411) strcat(s, "h");
if (crc32("JNkJlajdeXsym",13) == 1963854245) strcat(s, "o");
if (crc32("cyGfhoFgNERtShb",15) == 4146629221) strcat(s, "n");
if (crc32("LQvdQjnosrDoB",13) == 894412730) strcat(s, "o");
if (crc32("DqzKMrPZjXuC",12) == 1403966528) strcat(s, "z");
if (crc32("Wtueldxacgrvs",13) == 2312954376) strcat(s, "u");
if (crc32("IVhRwAvaQuiojXQ",15) == 199124794) strcat(s, "s");
if (crc32("yhFqpgxOsFcv",12) == 2045057956) strcat(s, "l");
if (crc32("buHhCtA",7) == 1961831625) strcat(s, "y");
    return s;
}

char *treasonously_adverbs() {
    char *s = calloc(13);
    if (crc32("GmArNnXXFcib",12) == 935518037) strcat(s, "W");
if (crc32("IYiuTgkO",8) == 2464755931) strcat(s, "t");
if (crc32("QlUFbPEuFyVAxr",14) == 4138620847) strcat(s, "r");
if (crc32("oRIURPx",7) == 2209993122) strcat(s, "e");
if (crc32("wSQpfWBVvbBI",12) == 2706628646) strcat(s, "a");
if (crc32("kgoWLFK",7) == 1265533510) strcat(s, "X");
if (crc32("BJINvZEyuDUyFos",15) == 3388139465) strcat(s, "s");
if (crc32("rzjycjhxZ",9) == 2796746353) strcat(s, "o");
if (crc32("sjdqyqayBz",10) == 2075745251) strcat(s, "S");
if (crc32("VaEHOORJ",8) == 1250557920) strcat(s, "n");
if (crc32("CduuaaEJdINr",12) == 299439696) strcat(s, "o");
if (crc32("SFCtSdD",7) == 3011799988) strcat(s, "u");
if (crc32("tHdKPipsWTHSn",13) == 2455816271) strcat(s, "s");
if (crc32("sXPqgdVBkYvkO",13) == 1439662213) strcat(s, "l");
if (crc32("KQERSDg",7) == 3104692701) strcat(s, "V");
if (crc32("xVCDQHc",7) == 310179395) strcat(s, "y");
    return s;
}

char *bewilderingly_adverbs() {
    char *s = calloc(14);
    if (crc32("fBAExjUX",8) == 3180505767) strcat(s, "b");
if (crc32("dvMujPBNUOVV",12) == 1781214335) strcat(s, "S");
if (crc32("FWKdBjgam",9) == 3051257563) strcat(s, "e");
if (crc32("vtpFrGugfhSiZX",14) == 1878403554) strcat(s, "g");
if (crc32("BRAgPMOAaP",10) == 2265470594) strcat(s, "w");
if (crc32("ePLfXoJ",7) == 3722512818) strcat(s, "i");
if (crc32("fnHDyaxsymi",11) == 3836769987) strcat(s, "g");
if (crc32("oFLtYYLSOh",10) == 2647218133) strcat(s, "l");
if (crc32("vCBTJmhGMFBCBW",14) == 4110747404) strcat(s, "F");
if (crc32("nEQrGlKgLPyba",13) == 372732744) strcat(s, "d");
if (crc32("HOTZBaum",8) == 3521527773) strcat(s, "e");
if (crc32("wwvpXYUb",8) == 2568489400) strcat(s, "o");
if (crc32("TrnTjt",6) == 3724110009) strcat(s, "r");
if (crc32("JpDBQuJo",8) == 1912441614) strcat(s, "i");
if (crc32("oeFXCFsZizTTqQ",14) == 3782832688) strcat(s, "n");
if (crc32("BRhttEbomeH",11) == 4034340108) strcat(s, "M");
if (crc32("wzEjv",5) == 3648492341) strcat(s, "g");
if (crc32("uVBWJ",5) == 4052941710) strcat(s, "e");
if (crc32("fUwamyyAcFRIc",13) == 3046429270) strcat(s, "l");
if (crc32("CPvKUE",6) == 4093417413) strcat(s, "y");
    return s;
}

char *nonseriously_adverbs() {
    char *s = calloc(13);
    if (crc32("JAcCuhyJxecoD",13) == 4225147224) strcat(s, "m");
if (crc32("alSckAgkwk",10) == 1505944879) strcat(s, "n");
if (crc32("EVIwYFhrxBKP",12) == 2805596096) strcat(s, "W");
if (crc32("VDdJsqmfFMNK",12) == 3735244313) strcat(s, "o");
if (crc32("XSJxLdhZHQxhf",13) == 4145004097) strcat(s, "n");
if (crc32("CdxAndYrBJPPO",13) == 3349634036) strcat(s, "s");
if (crc32("TcMXHHPXo",9) == 2804079568) strcat(s, "e");
if (crc32("WuGzYyDOIHHYw",13) == 4238083816) strcat(s, "r");
if (crc32("aIxperKjOIP",11) == 2861824721) strcat(s, "r");
if (crc32("ipccRYjyRlEv",12) == 2272308334) strcat(s, "i");
if (crc32("hTNXfRDnufFPRs",14) == 2499748678) strcat(s, "o");
if (crc32("XSzOTuLllNg",11) == 2003558536) strcat(s, "m");
if (crc32("amORvdZ",7) == 1697877681) strcat(s, "u");
if (crc32("aeEXEDuWdC",10) == 659198422) strcat(s, "C");
if (crc32("XggXJ",5) == 3242401498) strcat(s, "s");
if (crc32("iveIACIwwRSYJ",13) == 511335973) strcat(s, "l");
if (crc32("GzGfIYEJnMNaKZ",14) == 2116635129) strcat(s, "N");
if (crc32("rqKrgkScB",9) == 663597268) strcat(s, "y");
    return s;
}

char *philatelically_adverbs() {
    char *s = calloc(15);
    if (crc32("zrOndAexEDJ",11) == 1581912986) strcat(s, "U");
if (crc32("CbcksA",6) == 3005536851) strcat(s, "p");
if (crc32("QVlswucrKXeGl",13) == 341368082) strcat(s, "I");
if (crc32("ExsIjuqRzcMtdBm",15) == 863592248) strcat(s, "h");
if (crc32("MhyGrazjCDLFfO",14) == 159022656) strcat(s, "a");
if (crc32("NbBvcsvBLIwWbX",14) == 901069188) strcat(s, "i");
if (crc32("RsBIg",5) == 2080914909) strcat(s, "l");
if (crc32("sdqjJqXqDiEt",12) == 1207034546) strcat(s, "a");
if (crc32("QomaELZOGfGuvM",14) == 1926578027) strcat(s, "t");
if (crc32("xtFNOCXwXdIBu",13) == 797791168) strcat(s, "I");
if (crc32("qItfmgO",7) == 1642809479) strcat(s, "e");
if (crc32("oUAUfGhNrnSyKq",14) == 448242241) strcat(s, "l");
if (crc32("CJzAwwZVemQF",12) == 3317256245) strcat(s, "i");
if (crc32("KGamD",5) == 120967093) strcat(s, "c");
if (crc32("cvchZOCsgb",10) == 2642341959) strcat(s, "a");
if (crc32("Jefwq",5) == 3552553421) strcat(s, "l");
if (crc32("wMeFSfAglSlPo",13) == 513638600) strcat(s, "l");
if (crc32("EqxGOH",6) == 4267539037) strcat(s, "l");
if (crc32("GFFvhoY",7) == 3229698708) strcat(s, "P");
if (crc32("iwCZwcQGeAs",11) == 3172931035) strcat(s, "y");
    return s;
}

char *mercilessly_adverbs() {
    char *s = calloc(12);
    if (crc32("skSJlAmoFu",10) == 1544933075) strcat(s, "J");
if (crc32("ioxfgMLC",8) == 1272026302) strcat(s, "m");
if (crc32("tJBifOkmtQWy",12) == 3316385924) strcat(s, "i");
if (crc32("QdbaywJsWxJrKm",14) == 1358843995) strcat(s, "e");
if (crc32("SStJfBKd",8) == 440866215) strcat(s, "r");
if (crc32("NFRQzbw",7) == 2717371515) strcat(s, "c");
if (crc32("bEqiOidCOEi",11) == 2313022442) strcat(s, "i");
if (crc32("ULXIRlsvWM",10) == 447009582) strcat(s, "l");
if (crc32("MypDPEvTP",9) == 1899137428) strcat(s, "G");
if (crc32("rEVfFIrScYnT",12) == 1433804431) strcat(s, "e");
if (crc32("ycYavZRk",8) == 2739975876) strcat(s, "z");
if (crc32("vuKTlqcWzG",10) == 3339201509) strcat(s, "s");
if (crc32("CYIUxOUfxZceTAv",15) == 2240823727) strcat(s, "s");
if (crc32("epByBqnU",8) == 591591879) strcat(s, "l");
if (crc32("DxjjkQoLqFM",11) == 2361044975) strcat(s, "D");
if (crc32("LHZaKcfjUc",10) == 404098800) strcat(s, "y");
    return s;
}

char *classily_adverbs() {
    char *s = calloc(9);
    if (crc32("pTboXrcXMEq",11) == 179379115) strcat(s, "c");
if (crc32("VFeOVuTTmKvjAXF",15) == 3003802936) strcat(s, "D");
if (crc32("IsSuXTreu",9) == 3702121033) strcat(s, "l");
if (crc32("uJoUdfs",7) == 128541010) strcat(s, "r");
if (crc32("YqOUMDoPtum",11) == 1054568120) strcat(s, "a");
if (crc32("cAHmZcONm",9) == 3629217330) strcat(s, "s");
if (crc32("exJDI",5) == 3747871856) strcat(s, "s");
if (crc32("fGVotX",6) == 3852470940) strcat(s, "N");
if (crc32("pPlbjwfUSkKS",12) == 2751478596) strcat(s, "i");
if (crc32("BvUeMDUsfjlC",12) == 1625585155) strcat(s, "N");
if (crc32("xPgwOeiPUKh",11) == 2267276014) strcat(s, "l");
if (crc32("DbthsVqrUbK",11) == 625603093) strcat(s, "G");
if (crc32("WhVKF",5) == 1451236163) strcat(s, "y");
    return s;
}

char *nongratifyingly_adverbs() {
    char *s = calloc(16);
    if (crc32("MjrXQOipcD",10) == 2399381407) strcat(s, "n");
if (crc32("eZJYzak",7) == 2991691997) strcat(s, "o");
if (crc32("HzRsFRsqk",9) == 2339107766) strcat(s, "n");
if (crc32("LxlSa",5) == 524592955) strcat(s, "g");
if (crc32("JHdLqGplLALMB",13) == 2545065661) strcat(s, "r");
if (crc32("TfQuaiYaA",9) == 3989477660) strcat(s, "S");
if (crc32("sXKgirOBNR",10) == 4203198456) strcat(s, "a");
if (crc32("AKEOAfUQhMJCjt",14) == 2966971652) strcat(s, "d");
if (crc32("bWUaBtnhigVnxXl",15) == 891754865) strcat(s, "t");
if (crc32("FDkQvsQmhgrikKd",15) == 2034876512) strcat(s, "i");
if (crc32("HzRETIkBLBBiZhN",15) == 2403799154) strcat(s, "E");
if (crc32("TrkJcHzEKSVQd",13) == 194355418) strcat(s, "f");
if (crc32("jlhTkvzGHbKh",12) == 1999536407) strcat(s, "S");
if (crc32("pLsyk",5) == 2618842161) strcat(s, "y");
if (crc32("HZMClKdv",8) == 260583879) strcat(s, "E");
if (crc32("PmKlHb",6) == 1244279465) strcat(s, "i");
if (crc32("DItGaQK",7) == 72721953) strcat(s, "n");
if (crc32("vEaMFhBkwr",10) == 1861022166) strcat(s, "g");
if (crc32("izxYR",5) == 3799797236) strcat(s, "l");
if (crc32("rnlKZlawMTNE",12) == 1278731705) strcat(s, "y");
    return s;
}

char *cytogenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("IXqqAYJKKWAgPY",14) == 2513833562) strcat(s, "c");
if (crc32("vreeHC",6) == 2050631437) strcat(s, "y");
if (crc32("QniXoVkMPE",10) == 2532287012) strcat(s, "u");
if (crc32("hEDmfG",6) == 1242592422) strcat(s, "t");
if (crc32("rrFWrumbcDjWY",13) == 3031390709) strcat(s, "J");
if (crc32("hATiy",5) == 3130747859) strcat(s, "o");
if (crc32("qBrQfSUpUGJIzDK",15) == 1888505550) strcat(s, "g");
if (crc32("YqzLYgACcn",10) == 421878326) strcat(s, "u");
if (crc32("VjUOqZjaZzRVT",13) == 1418261171) strcat(s, "e");
if (crc32("FVrnORXMzQqB",12) == 2447285826) strcat(s, "n");
if (crc32("ZhThtaCLLGTi",12) == 2955273035) strcat(s, "N");
if (crc32("XSctx",5) == 1223025630) strcat(s, "e");
if (crc32("FhfiQjcMWbC",11) == 2626571608) strcat(s, "T");
if (crc32("SQuaforDs",9) == 922339895) strcat(s, "t");
if (crc32("wJPnZfiwYCW",11) == 708192047) strcat(s, "h");
if (crc32("sFTyYW",6) == 1795070533) strcat(s, "i");
if (crc32("iZESLnImk",9) == 2105852629) strcat(s, "c");
if (crc32("ttVlEQfvmLo",11) == 2017974453) strcat(s, "j");
if (crc32("GuzYnrdqCWtoC",13) == 4168960101) strcat(s, "a");
if (crc32("pVyqLu",6) == 840236738) strcat(s, "l");
if (crc32("iCceYSPHQzty",12) == 3651429395) strcat(s, "l");
if (crc32("AmmjAFhgwzfvm",13) == 1189660066) strcat(s, "y");
    return s;
}

char *nonpuerilely_adverbs() {
    char *s = calloc(13);
    if (crc32("qzfUDV",6) == 3367064616) strcat(s, "m");
if (crc32("VUAEAOn",7) == 3837836067) strcat(s, "n");
if (crc32("rIjjumpjp",9) == 3038014668) strcat(s, "U");
if (crc32("rRIPVxnSFSnZRrT",15) == 3000414730) strcat(s, "o");
if (crc32("QEhkodotb",9) == 1014349914) strcat(s, "n");
if (crc32("aJOfGwjE",8) == 2796121915) strcat(s, "O");
if (crc32("xPeNXFAtvHA",11) == 2640525404) strcat(s, "p");
if (crc32("fMIsuSBXQm",10) == 481385542) strcat(s, "u");
if (crc32("NndRngpGCKm",11) == 3557457069) strcat(s, "k");
if (crc32("vMdoIRh",7) == 441087478) strcat(s, "e");
if (crc32("oHbAlhmZF",9) == 2050116398) strcat(s, "r");
if (crc32("EwNEkr",6) == 2419967226) strcat(s, "i");
if (crc32("NkBYmT",6) == 2220329325) strcat(s, "l");
if (crc32("ixFZOAYUtP",10) == 1572768996) strcat(s, "L");
if (crc32("AeZdoCYqtWXxYD",14) == 3137741738) strcat(s, "e");
if (crc32("LZQuOvOTuXVT",12) == 3397285417) strcat(s, "l");
if (crc32("GMmeBuvaTgcbio",14) == 1214908102) strcat(s, "y");
    return s;
}

char *gey_adverbs() {
    char *s = calloc(4);
    if (crc32("HfsyLnqiKwOym",13) == 3050927169) strcat(s, "g");
if (crc32("WaNkPnEKRC",10) == 249271616) strcat(s, "U");
if (crc32("gfaBctL",7) == 3862383401) strcat(s, "e");
if (crc32("teGzXEnDLI",10) == 4009020508) strcat(s, "y");
    return s;
}

char *evangelically_adverbs() {
    char *s = calloc(14);
    if (crc32("vsCKB",5) == 114689510) strcat(s, "R");
if (crc32("vlqUaNZCiDDMp",13) == 3286184016) strcat(s, "e");
if (crc32("osvoBudgaMTVwbb",15) == 1244737919) strcat(s, "U");
if (crc32("UeoNs",5) == 3730079367) strcat(s, "v");
if (crc32("skjIklyDLXGTv",13) == 3033222670) strcat(s, "a");
if (crc32("RyPDM",5) == 1644305724) strcat(s, "n");
if (crc32("bmCMcAMTaY",10) == 2652090952) strcat(s, "g");
if (crc32("nUCuoReykgu",11) == 1284031452) strcat(s, "b");
if (crc32("IEftAnN",7) == 4194765924) strcat(s, "e");
if (crc32("ulkMBTbtACO",11) == 1288501633) strcat(s, "l");
if (crc32("cufZkSsTIiP",11) == 2086969294) strcat(s, "E");
if (crc32("sWQLytrgj",9) == 1305298200) strcat(s, "i");
if (crc32("MXSXUDOilSp",11) == 3899851500) strcat(s, "c");
if (crc32("vcthTt",6) == 1474689460) strcat(s, "i");
if (crc32("HMqBXfF",7) == 1649865623) strcat(s, "a");
if (crc32("cPGdIJYr",8) == 2003099181) strcat(s, "G");
if (crc32("LTxaL",5) == 1176548373) strcat(s, "l");
if (crc32("QLWBjeQmqS",10) == 1518279398) strcat(s, "x");
if (crc32("GLGLXFcIe",9) == 990952235) strcat(s, "l");
if (crc32("AGYkG",5) == 2532020929) strcat(s, "V");
if (crc32("LbXESG",6) == 728563035) strcat(s, "y");
    return s;
}

char *intervocalically_adverbs() {
    char *s = calloc(17);
    if (crc32("dhYfJZNfwmgmXG",14) == 3099435906) strcat(s, "i");
if (crc32("qQRAH",5) == 3461871511) strcat(s, "y");
if (crc32("FDXelbOkjet",11) == 2795952960) strcat(s, "n");
if (crc32("ewxYNfBUrppJFI",14) == 2323763057) strcat(s, "t");
if (crc32("EcxnZlx",7) == 3789137321) strcat(s, "e");
if (crc32("vQUzQdsKnr",10) == 3985379690) strcat(s, "J");
if (crc32("SvUmPdEHBzRwRBV",15) == 3563329284) strcat(s, "r");
if (crc32("ArVAjUhRroDwooP",15) == 2748195774) strcat(s, "v");
if (crc32("FbasJdODZPKiee",14) == 2716973334) strcat(s, "o");
if (crc32("XXinWMpTloECd",13) == 2061966398) strcat(s, "r");
if (crc32("LiMnaUSiypz",11) == 4232782379) strcat(s, "c");
if (crc32("vvmOeyX",7) == 3783456100) strcat(s, "c");
if (crc32("VZaIMlkNCEwxTWi",15) == 2703951807) strcat(s, "a");
if (crc32("ANZkYHgZTEM",11) == 2734511914) strcat(s, "l");
if (crc32("iMUOXpsPYX",10) == 2141115398) strcat(s, "T");
if (crc32("TWYnqIrPIUdW",12) == 1944636338) strcat(s, "i");
if (crc32("RQOOMdkSpoP",11) == 2953434561) strcat(s, "c");
if (crc32("HVxlxa",6) == 3616476110) strcat(s, "a");
if (crc32("qIRBAAsAdi",10) == 3491599501) strcat(s, "l");
if (crc32("zRhukXhIbXyQWql",15) == 4042725854) strcat(s, "l");
if (crc32("GOXbNKlqs",9) == 3966943425) strcat(s, "y");
    return s;
}

char *quasiprivately_adverbs() {
    char *s = calloc(15);
    if (crc32("GxkqE",5) == 2197355405) strcat(s, "O");
if (crc32("PBjxMbcgZqQ",11) == 1819197494) strcat(s, "q");
if (crc32("YoOAYT",6) == 879871084) strcat(s, "u");
if (crc32("vZRlic",6) == 1582796148) strcat(s, "a");
if (crc32("FMpqPwDJSN",10) == 2538152090) strcat(s, "s");
if (crc32("vcuQkeocFtFTSKV",15) == 1099071924) strcat(s, "i");
if (crc32("jCgzQFhFIQWm",12) == 1618246953) strcat(s, "p");
if (crc32("rVewNBtFwqZu",12) == 3955250133) strcat(s, "r");
if (crc32("dHdRGM",6) == 638419202) strcat(s, "i");
if (crc32("rZjKOSmnEIdoQL",14) == 1259981558) strcat(s, "v");
if (crc32("pdvmyClrxehgQO",14) == 4096992715) strcat(s, "a");
if (crc32("ipFNU",5) == 953381951) strcat(s, "t");
if (crc32("nwpgLWYvPJhm",12) == 1612118828) strcat(s, "z");
if (crc32("vNADoSeaarXPgJ",14) == 165246302) strcat(s, "e");
if (crc32("fsaRNcOuvFb",11) == 2485826256) strcat(s, "q");
if (crc32("fnQZcPXjHEjjUq",14) == 267654074) strcat(s, "l");
if (crc32("NTxJnFYtvXYJV",13) == 3006862723) strcat(s, "o");
if (crc32("SacqHFMWDuKm",12) == 4277539334) strcat(s, "y");
    return s;
}

char *unmasterfully_adverbs() {
    char *s = calloc(14);
    if (crc32("RmCAmCDalvX",11) == 2100865410) strcat(s, "u");
if (crc32("ZRlVfg",6) == 2110161593) strcat(s, "B");
if (crc32("XXObVARnvjo",11) == 2677330680) strcat(s, "n");
if (crc32("aGwni",5) == 1962489699) strcat(s, "r");
if (crc32("fdkErkFyCa",10) == 167303546) strcat(s, "m");
if (crc32("onfGIF",6) == 454047278) strcat(s, "c");
if (crc32("iITkiEUK",8) == 341155397) strcat(s, "a");
if (crc32("kEpMVdJaCcjTYgj",15) == 2450504673) strcat(s, "b");
if (crc32("lxrJFsqdaHexVbp",15) == 3343177000) strcat(s, "s");
if (crc32("VhsknRQOO",9) == 605302233) strcat(s, "l");
if (crc32("yFePWusAviZEqU",14) == 3613915228) strcat(s, "t");
if (crc32("BCbHuGg",7) == 1152520337) strcat(s, "e");
if (crc32("HWDpweJ",7) == 3799174019) strcat(s, "r");
if (crc32("NZEAo",5) == 89135938) strcat(s, "K");
if (crc32("UcNqi",5) == 1728896714) strcat(s, "f");
if (crc32("ZVUjRnfExNfaRB",14) == 4111065930) strcat(s, "u");
if (crc32("KQaesl",6) == 1555964828) strcat(s, "l");
if (crc32("jOniVIOvd",9) == 850934511) strcat(s, "l");
if (crc32("pOMnTX",6) == 3423948644) strcat(s, "n");
if (crc32("OxuibhnVhqOFdCE",15) == 3239156426) strcat(s, "y");
    return s;
}

char *holily_adverbs() {
    char *s = calloc(7);
    if (crc32("SUlKvhkZXNTAm",13) == 2004920469) strcat(s, "J");
if (crc32("tMtTAiuWpdxLEp",14) == 3642251562) strcat(s, "h");
if (crc32("hPREJdAKp",9) == 731678508) strcat(s, "o");
if (crc32("KKhGTmfnvldRw",13) == 47810631) strcat(s, "T");
if (crc32("snieFUWC",8) == 746252302) strcat(s, "l");
if (crc32("WckupRRxqoz",11) == 2091173527) strcat(s, "i");
if (crc32("iaMlmH",6) == 3129790240) strcat(s, "l");
if (crc32("IaRozFzcBjorJ",13) == 3049594975) strcat(s, "i");
if (crc32("YDDXlc",6) == 1545249342) strcat(s, "y");
    return s;
}

char *decretively_adverbs() {
    char *s = calloc(12);
    if (crc32("qMQZUKKegdZ",11) == 2754284626) strcat(s, "U");
if (crc32("XpxEcXSU",8) == 3107992493) strcat(s, "d");
if (crc32("ktwCrcK",7) == 3398799288) strcat(s, "s");
if (crc32("FthKntMiEG",10) == 3976274140) strcat(s, "e");
if (crc32("fIpLRPHEk",9) == 3412681627) strcat(s, "c");
if (crc32("SsTfnkNu",8) == 2082750575) strcat(s, "t");
if (crc32("WhMLhFpTAjw",11) == 1427316145) strcat(s, "r");
if (crc32("CJjcLKpIIWXwUc",14) == 3954822457) strcat(s, "w");
if (crc32("mpAZhnivZSqaVnY",15) == 1098054042) strcat(s, "e");
if (crc32("YSOdFjNhw",9) == 1478377486) strcat(s, "t");
if (crc32("AIykRJBlUKQhjw",14) == 881186835) strcat(s, "p");
if (crc32("fJmbAjdkvKgOAot",15) == 842338506) strcat(s, "i");
if (crc32("pigJPQG",7) == 3357143613) strcat(s, "o");
if (crc32("WjvRu",5) == 3759430950) strcat(s, "v");
if (crc32("WrcNlXFEDRYE",12) == 1897247714) strcat(s, "e");
if (crc32("ayriEqBeQa",10) == 214375275) strcat(s, "l");
if (crc32("nbuEBDEFkJRdMX",14) == 3271456068) strcat(s, "y");
    return s;
}

char *colonially_adverbs() {
    char *s = calloc(11);
    if (crc32("jXGZENtfc",9) == 3657585657) strcat(s, "c");
if (crc32("CdvXk",5) == 2067009732) strcat(s, "d");
if (crc32("ZgtzwpMypZY",11) == 3235483792) strcat(s, "o");
if (crc32("VQKTWP",6) == 906277022) strcat(s, "k");
if (crc32("RAyPKrjrB",9) == 74077779) strcat(s, "l");
if (crc32("OcFGyAyiT",9) == 3635654285) strcat(s, "o");
if (crc32("UONKMKDNDA",10) == 2698968253) strcat(s, "n");
if (crc32("IlNJjpZWmSdt",12) == 1010041304) strcat(s, "i");
if (crc32("IbqTYiaqarOQ",12) == 3892238060) strcat(s, "v");
if (crc32("mBpNNS",6) == 2855851165) strcat(s, "a");
if (crc32("mEoEIvZXJIL",11) == 506020106) strcat(s, "G");
if (crc32("YxxLpLXqZB",10) == 79903184) strcat(s, "l");
if (crc32("lcMWuVEEKGith",13) == 2229420855) strcat(s, "l");
if (crc32("vBKRQDqYwyUYVe",14) == 994196223) strcat(s, "b");
if (crc32("lUSldcq",7) == 2776008505) strcat(s, "y");
    return s;
}

char *boundlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("cYUsQqwYWKotjf",14) == 648007168) strcat(s, "r");
if (crc32("IpnPt",5) == 1466196962) strcat(s, "b");
if (crc32("dzUPV",5) == 3522660585) strcat(s, "N");
if (crc32("qTTjuAyDbUTaq",13) == 3296945945) strcat(s, "o");
if (crc32("mcxgtfO",7) == 268614583) strcat(s, "u");
if (crc32("HydrUwt",7) == 3285436334) strcat(s, "C");
if (crc32("LmYVxxky",8) == 907709653) strcat(s, "n");
if (crc32("YYGRzzxFLies",12) == 1454554334) strcat(s, "V");
if (crc32("yzQwbX",6) == 1056555829) strcat(s, "d");
if (crc32("UMhXy",5) == 3699688763) strcat(s, "p");
if (crc32("HmPENjaJTD",10) == 939483536) strcat(s, "l");
if (crc32("evzQtGG",7) == 1563561780) strcat(s, "e");
if (crc32("ztWRFGTkpAHRW",13) == 2253662064) strcat(s, "K");
if (crc32("tKweaegDDZHN",12) == 172324831) strcat(s, "s");
if (crc32("MGczpX",6) == 3534563603) strcat(s, "s");
if (crc32("LSKIVwSu",8) == 930127609) strcat(s, "l");
if (crc32("jzORFQaZ",8) == 4103432455) strcat(s, "y");
    return s;
}

char *coldly_adverbs() {
    char *s = calloc(7);
    if (crc32("zXUNKm",6) == 3040993151) strcat(s, "c");
if (crc32("sdqyotomtMQjlyi",15) == 250553590) strcat(s, "o");
if (crc32("oCJVUeCkZRP",11) == 3713995710) strcat(s, "i");
if (crc32("ELhIxxW",7) == 4103105229) strcat(s, "l");
if (crc32("hGqhOoULC",9) == 3973742331) strcat(s, "d");
if (crc32("HjeZZjAc",8) == 1177531279) strcat(s, "l");
if (crc32("muqQTNglmSfwjyv",15) == 3002830746) strcat(s, "y");
    return s;
}

char *unvitally_adverbs() {
    char *s = calloc(10);
    if (crc32("eRzAbdykoPBtTqD",15) == 3513325401) strcat(s, "u");
if (crc32("fziCGomEgtzaXze",15) == 921147746) strcat(s, "n");
if (crc32("rYhZjnMhkOZA",12) == 3277022491) strcat(s, "v");
if (crc32("NUgfh",5) == 356386130) strcat(s, "O");
if (crc32("alVreADAI",9) == 3476103667) strcat(s, "i");
if (crc32("weHIxIPb",8) == 1679226247) strcat(s, "t");
if (crc32("lqOsIJReQgmmKR",14) == 557010191) strcat(s, "a");
if (crc32("mXfxQCrC",8) == 2062507455) strcat(s, "c");
if (crc32("ebPljwuHarZz",12) == 3208436478) strcat(s, "l");
if (crc32("SWlFHvZsRSYL",12) == 2058103270) strcat(s, "l");
if (crc32("LmQshcPo",8) == 1533341611) strcat(s, "y");
    return s;
}

char *Platonically_adverbs() {
    char *s = calloc(13);
    if (crc32("wLcRnyhyu",9) == 3259931132) strcat(s, "N");
if (crc32("dSUwlKaHK",9) == 3683217976) strcat(s, "P");
if (crc32("mqgrrtMKZCD",11) == 1453702137) strcat(s, "y");
if (crc32("EUigCL",6) == 2972454550) strcat(s, "l");
if (crc32("IyyrGkLxLBi",11) == 555602493) strcat(s, "a");
if (crc32("SMSkbo",6) == 2353509987) strcat(s, "t");
if (crc32("SXnzOYTZS",9) == 3710463613) strcat(s, "d");
if (crc32("OrtqdraRVGswD",13) == 2132646934) strcat(s, "o");
if (crc32("bCNTlCURq",9) == 2688467967) strcat(s, "n");
if (crc32("JzvnWS",6) == 2816909936) strcat(s, "i");
if (crc32("oqVJMYTnoRfAifd",15) == 1075874436) strcat(s, "c");
if (crc32("TwKkGuiGxOPvdo",14) == 2890911850) strcat(s, "I");
if (crc32("DNRRMv",6) == 809883463) strcat(s, "a");
if (crc32("WNZwOgLZ",8) == 2442072561) strcat(s, "l");
if (crc32("WslubAUC",8) == 3769618664) strcat(s, "N");
if (crc32("iJFWSVgOhhR",11) == 1978121843) strcat(s, "l");
if (crc32("hLKamvn",7) == 1651909769) strcat(s, "y");
    return s;
}

char *undefeatably_adverbs() {
    char *s = calloc(13);
    if (crc32("LEyigJJE",8) == 1659948572) strcat(s, "u");
if (crc32("XnCuCclQP",9) == 583434925) strcat(s, "w");
if (crc32("JkwbADwkOjC",11) == 2852791626) strcat(s, "n");
if (crc32("HXlAM",5) == 782027924) strcat(s, "u");
if (crc32("diSYHCwqnwnDE",13) == 4218514073) strcat(s, "d");
if (crc32("qqlvrbeEg",9) == 3717737147) strcat(s, "R");
if (crc32("vwBQENiK",8) == 3805193460) strcat(s, "e");
if (crc32("HyRKD",5) == 3046302234) strcat(s, "f");
if (crc32("dZagDpWKeg",10) == 49824588) strcat(s, "e");
if (crc32("uSUkvuzRk",9) == 3156678003) strcat(s, "j");
if (crc32("TdKBalqdCh",10) == 1855140637) strcat(s, "a");
if (crc32("gRUMCLQTrMQ",11) == 1736409166) strcat(s, "t");
if (crc32("srVUsUEQFFZ",11) == 3651033330) strcat(s, "a");
if (crc32("qMwnnUAiADXH",12) == 1244118853) strcat(s, "F");
if (crc32("qlPgqeTMrb",10) == 1213583090) strcat(s, "b");
if (crc32("eftdPx",6) == 2964755879) strcat(s, "K");
if (crc32("XViPYSdI",8) == 1650654616) strcat(s, "l");
if (crc32("fAgylQ",6) == 1508277871) strcat(s, "Y");
if (crc32("nOLBONJ",7) == 2545972601) strcat(s, "y");
    return s;
}

char *superelastically_adverbs() {
    char *s = calloc(17);
    if (crc32("UVTduFiTT",9) == 2513940569) strcat(s, "O");
if (crc32("adqOlWtJEYDYYDk",15) == 2201640898) strcat(s, "s");
if (crc32("GoPMH",5) == 3071160631) strcat(s, "h");
if (crc32("pvOZoAXxVRPnz",13) == 4120005689) strcat(s, "u");
if (crc32("cPITNqqNqXpv",12) == 1735835553) strcat(s, "p");
if (crc32("iHIeGm",6) == 3531683554) strcat(s, "e");
if (crc32("KbNETdtxZJx",11) == 4019475557) strcat(s, "r");
if (crc32("VVOfsdinKDlCo",13) == 2425097649) strcat(s, "u");
if (crc32("IdjtsNl",7) == 2483839822) strcat(s, "e");
if (crc32("lVsvZqbsjK",10) == 1415436108) strcat(s, "l");
if (crc32("bGWdX",5) == 784465124) strcat(s, "a");
if (crc32("XUHkeb",6) == 16293895) strcat(s, "s");
if (crc32("QKgmTzdvC",9) == 500397466) strcat(s, "t");
if (crc32("uYcVaJeV",8) == 1794725941) strcat(s, "i");
if (crc32("hfnOohki",8) == 3733213440) strcat(s, "m");
if (crc32("jiqHbTZNax",10) == 3065137822) strcat(s, "c");
if (crc32("BdNKuZVtljj",11) == 1232513342) strcat(s, "p");
if (crc32("XqBQDCL",7) == 3473404229) strcat(s, "a");
if (crc32("QaiAKRxO",8) == 3115306518) strcat(s, "l");
if (crc32("UyWPmAYQE",9) == 545876133) strcat(s, "b");
if (crc32("jLIiDfdLvHmlv",13) == 80518369) strcat(s, "l");
if (crc32("EYDQPbRWf",9) == 3638310224) strcat(s, "y");
    return s;
}

char *semicolonially_adverbs() {
    char *s = calloc(15);
    if (crc32("KJDrpMNjo",9) == 1635930317) strcat(s, "L");
if (crc32("bxcZLckJy",9) == 792718643) strcat(s, "s");
if (crc32("IDagCo",6) == 4240255298) strcat(s, "e");
if (crc32("BgMJWh",6) == 2520224145) strcat(s, "f");
if (crc32("GiBMzDVL",8) == 1513994425) strcat(s, "m");
if (crc32("SwHORCztyFT",11) == 4026893374) strcat(s, "i");
if (crc32("xKdHqRbbm",9) == 3478802167) strcat(s, "c");
if (crc32("CvXYxXMxgneXjtS",15) == 2367440021) strcat(s, "o");
if (crc32("PsnCYfnogqa",11) == 3648272626) strcat(s, "u");
if (crc32("fikeDcdcXYItg",13) == 629740005) strcat(s, "l");
if (crc32("AMqLqCiBVnlFme",14) == 1645006256) strcat(s, "o");
if (crc32("OHkUKpNADWmi",12) == 361611974) strcat(s, "n");
if (crc32("gkMvKFoSA",9) == 3921093502) strcat(s, "i");
if (crc32("FREnME",6) == 4204335645) strcat(s, "t");
if (crc32("sikyJnZkmesf",12) == 1898970050) strcat(s, "a");
if (crc32("gUTsb",5) == 3724021757) strcat(s, "l");
if (crc32("jhIyQXitFdYLfN",14) == 2608498257) strcat(s, "d");
if (crc32("lTxVHZ",6) == 1992531999) strcat(s, "l");
if (crc32("oWdKLDQn",8) == 2569436288) strcat(s, "y");
    return s;
}

char *myriadly_adverbs() {
    char *s = calloc(9);
    if (crc32("cdOmzYQIl",9) == 3423734485) strcat(s, "e");
if (crc32("OAoDioCTXFTKUdd",15) == 3681682677) strcat(s, "m");
if (crc32("DqIPArwkmWIWJ",13) == 2652770342) strcat(s, "y");
if (crc32("LzGmVOZHbhkSwM",14) == 3849637402) strcat(s, "r");
if (crc32("cQPQSZFrpjy",11) == 213809874) strcat(s, "Y");
if (crc32("CHoLcFuXfOzqh",13) == 1397324537) strcat(s, "i");
if (crc32("WhggXerVJ",9) == 135440380) strcat(s, "C");
if (crc32("pCDprMZgskYGL",13) == 1834364636) strcat(s, "a");
if (crc32("JYZzbN",6) == 629953377) strcat(s, "L");
if (crc32("SqBdVBCSKI",10) == 1090701262) strcat(s, "d");
if (crc32("IiDDMJzDhMon",12) == 2399054278) strcat(s, "s");
if (crc32("uJGyBKKXf",9) == 2377907946) strcat(s, "l");
if (crc32("REwWwXeeqIEEubo",15) == 3472543013) strcat(s, "y");
    return s;
}

char *hypergenetically_adverbs() {
    char *s = calloc(17);
    if (crc32("dsGusP",6) == 2807416590) strcat(s, "h");
if (crc32("pMEKoWDTs",9) == 3475175687) strcat(s, "v");
if (crc32("XpJvcMuBgB",10) == 1033724923) strcat(s, "y");
if (crc32("uhIFCjYR",8) == 3839024050) strcat(s, "p");
if (crc32("RcoaEytWGtDNztG",15) == 4190236835) strcat(s, "e");
if (crc32("BQkCUggHXAKlhh",14) == 523517572) strcat(s, "r");
if (crc32("Bnmdd",5) == 883502997) strcat(s, "g");
if (crc32("eShCCuUiVzCvnaY",15) == 364186783) strcat(s, "W");
if (crc32("OyEAglMuR",9) == 1938264522) strcat(s, "e");
if (crc32("lvKnvbXDo",9) == 1478741684) strcat(s, "r");
if (crc32("EXUirV",6) == 3269484284) strcat(s, "n");
if (crc32("tFdmVBCHYLn",11) == 1177110784) strcat(s, "v");
if (crc32("uajwj",5) == 4241695045) strcat(s, "e");
if (crc32("ulDtwAL",7) == 2199217404) strcat(s, "e");
if (crc32("KZxSI",5) == 2311438280) strcat(s, "t");
if (crc32("PoLmkF",6) == 4055064384) strcat(s, "O");
if (crc32("SbXYJB",6) == 666520214) strcat(s, "i");
if (crc32("PJyqzqNAPMGzc",13) == 2967131882) strcat(s, "c");
if (crc32("uVaJiCaVYhWzmr",14) == 3834051403) strcat(s, "a");
if (crc32("ZOsubNIkyr",10) == 697691496) strcat(s, "n");
if (crc32("GwuBQWTdEY",10) == 3856875655) strcat(s, "l");
if (crc32("yxPbqRMbvXU",11) == 3907013008) strcat(s, "l");
if (crc32("eJqmQkVmvqJFJ",13) == 699974129) strcat(s, "y");
    return s;
}

char *flamingly_adverbs() {
    char *s = calloc(10);
    if (crc32("MDeYAnWpiKU",11) == 3281194594) strcat(s, "f");
if (crc32("PiGPt",5) == 538571627) strcat(s, "l");
if (crc32("TAYfimQBDomX",12) == 455933194) strcat(s, "a");
if (crc32("VSuyDNXOmCYcV",13) == 2117891641) strcat(s, "m");
if (crc32("xqgSRuRNwSXRn",13) == 941396392) strcat(s, "y");
if (crc32("qQobje",6) == 4262688605) strcat(s, "i");
if (crc32("sYQSZXqSUCx",11) == 1649005903) strcat(s, "n");
if (crc32("PazbSQqRXlMoRi",14) == 1906570456) strcat(s, "J");
if (crc32("jCfAYdrPl",9) == 2360966011) strcat(s, "g");
if (crc32("yAbak",5) == 4238194563) strcat(s, "l");
if (crc32("Gplcv",5) == 640333486) strcat(s, "r");
if (crc32("Edpqx",5) == 3732838809) strcat(s, "y");
    return s;
}

char *controversially_adverbs() {
    char *s = calloc(16);
    if (crc32("dWXXGyBk",8) == 2055409293) strcat(s, "c");
if (crc32("TdrMy",5) == 2223946412) strcat(s, "o");
if (crc32("kCKGv",5) == 2701092926) strcat(s, "o");
if (crc32("sLUkZxEkiUwuYOo",15) == 472901084) strcat(s, "n");
if (crc32("SzRWSobh",8) == 1275552256) strcat(s, "P");
if (crc32("DEsIBu",6) == 1375285225) strcat(s, "t");
if (crc32("oqSVMzHWRz",10) == 2964899450) strcat(s, "r");
if (crc32("aRgJQfSYddjq",12) == 2179766356) strcat(s, "s");
if (crc32("wTnpfQ",6) == 3400904946) strcat(s, "o");
if (crc32("ZnFJacttJgRUNon",15) == 3909175206) strcat(s, "v");
if (crc32("QbXmbvzBKYlriHQ",15) == 1807764242) strcat(s, "v");
if (crc32("QuXdWx",6) == 2908840802) strcat(s, "e");
if (crc32("eRvIam",6) == 3587354093) strcat(s, "r");
if (crc32("ruKieZ",6) == 1581083213) strcat(s, "s");
if (crc32("fPCFQLZTCF",10) == 2666187207) strcat(s, "H");
if (crc32("cutswCmJfD",10) == 1775728067) strcat(s, "i");
if (crc32("IxawmDKIw",9) == 3387734913) strcat(s, "n");
if (crc32("bfhJRUutux",10) == 1219418356) strcat(s, "a");
if (crc32("LAPHXEbrkNPsGR",14) == 2832113449) strcat(s, "d");
if (crc32("VVvvAUUbMPDcMVG",15) == 1179031237) strcat(s, "l");
if (crc32("CXlJhWrtPT",10) == 652540970) strcat(s, "q");
if (crc32("OBjbEhNFW",9) == 2714313945) strcat(s, "l");
if (crc32("zQtWzwV",7) == 475231940) strcat(s, "R");
if (crc32("qqZyvDkVirQwqb",14) == 1011426486) strcat(s, "y");
    return s;
}

char *nonnegligibly_adverbs() {
    char *s = calloc(14);
    if (crc32("QZjxgOsgejG",11) == 3285972548) strcat(s, "O");
if (crc32("PiWXiPtEoHB",11) == 4294574547) strcat(s, "n");
if (crc32("oyYegCE",7) == 2624598709) strcat(s, "D");
if (crc32("UXgZwPrm",8) == 3151158679) strcat(s, "o");
if (crc32("KhIiatNryREVBZ",14) == 988273340) strcat(s, "n");
if (crc32("FAqTk",5) == 1673348939) strcat(s, "n");
if (crc32("CcJmPUopg",9) == 693879408) strcat(s, "m");
if (crc32("gwiBaH",6) == 3725644029) strcat(s, "e");
if (crc32("aUpbdlcZEGbjkE",14) == 2721223527) strcat(s, "g");
if (crc32("rkQhEQnfunfIO",13) == 2667093908) strcat(s, "l");
if (crc32("aVuYs",5) == 2086245822) strcat(s, "i");
if (crc32("HTWaBJeUDPgq",12) == 3278949876) strcat(s, "g");
if (crc32("darXdUIi",8) == 1173259790) strcat(s, "T");
if (crc32("TWjghTDQkr",10) == 574775630) strcat(s, "i");
if (crc32("iPZtB",5) == 732420779) strcat(s, "b");
if (crc32("QATmNlDFYDLNE",13) == 1439802551) strcat(s, "x");
if (crc32("JHQIceafdBFBhr",14) == 410741909) strcat(s, "l");
if (crc32("genBuUPzwvR",11) == 2843941699) strcat(s, "y");
    return s;
}

char *ineptly_adverbs() {
    char *s = calloc(8);
    if (crc32("PWzRPeZAC",9) == 381376479) strcat(s, "U");
if (crc32("fHlqxDCvbxF",11) == 2909096583) strcat(s, "i");
if (crc32("LNynZTRImW",10) == 1113524367) strcat(s, "n");
if (crc32("psNiGrcVuh",10) == 1058548826) strcat(s, "e");
if (crc32("DHhUVKsPmz",10) == 1963563550) strcat(s, "V");
if (crc32("jBSvWStPPiMepf",14) == 537569277) strcat(s, "p");
if (crc32("BjndbndTtZ",10) == 962103744) strcat(s, "W");
if (crc32("HjkBIfiHIQREaKq",15) == 1202698728) strcat(s, "t");
if (crc32("TbEZqdQk",8) == 1623999468) strcat(s, "l");
if (crc32("WVHdcMkt",8) == 1976426880) strcat(s, "y");
    return s;
}

char *subadministratively_adverbs() {
    char *s = calloc(20);
    if (crc32("BEOrV",5) == 2887545203) strcat(s, "s");
if (crc32("nQavkBmr",8) == 2954921496) strcat(s, "Z");
if (crc32("NXTkk",5) == 411351720) strcat(s, "u");
if (crc32("NDmKgqE",7) == 1294783981) strcat(s, "b");
if (crc32("RZnoDP",6) == 2138590136) strcat(s, "b");
if (crc32("RRxtmvOsQ",9) == 2933167464) strcat(s, "a");
if (crc32("WlQfXBYkKmZQUM",14) == 2775738367) strcat(s, "R");
if (crc32("rjJBn",5) == 82000411) strcat(s, "d");
if (crc32("fmqmfJUTlPzsTJY",15) == 321343538) strcat(s, "C");
if (crc32("qqtjbrb",7) == 3122827171) strcat(s, "m");
if (crc32("DMerQjViujSxfY",14) == 1567316642) strcat(s, "i");
if (crc32("NiboxmsoosuFKf",14) == 2366342701) strcat(s, "i");
if (crc32("XWPYD",5) == 4008642856) strcat(s, "n");
if (crc32("qJWyXtBSTnJuBJ",14) == 3510924661) strcat(s, "i");
if (crc32("smslAlLNesgHO",13) == 1375440485) strcat(s, "s");
if (crc32("zBjhDAAJynl",11) == 640066996) strcat(s, "t");
if (crc32("tGTEF",5) == 1296258727) strcat(s, "d");
if (crc32("zuQXNWNnkJTbX",13) == 205096018) strcat(s, "r");
if (crc32("pbsEcO",6) == 4269452403) strcat(s, "a");
if (crc32("sJqrTCzYn",9) == 1202232274) strcat(s, "t");
if (crc32("fxXpE",5) == 3515239250) strcat(s, "X");
if (crc32("IsVdaazGQDHU",12) == 1379088764) strcat(s, "i");
if (crc32("uWdFzRIjjfm",11) == 2648501974) strcat(s, "q");
if (crc32("uZYsFSooGw",10) == 1952105830) strcat(s, "v");
if (crc32("ajKiO",5) == 2658195605) strcat(s, "A");
if (crc32("oFQEHPYgaq",10) == 2586846603) strcat(s, "e");
if (crc32("BulSjWjPVWsWGY",14) == 1140739745) strcat(s, "E");
if (crc32("SMhbsLVkS",9) == 2445381448) strcat(s, "l");
if (crc32("RjDHMIRDYQyTnKi",15) == 3804916366) strcat(s, "n");
if (crc32("NHnAyaMTZSg",11) == 1853702164) strcat(s, "y");
    return s;
}

char *intertwistingly_adverbs() {
    char *s = calloc(16);
    if (crc32("dTihiycEAde",11) == 3320959675) strcat(s, "i");
if (crc32("srTJbDoWLd",10) == 3848028229) strcat(s, "n");
if (crc32("BivQdOXpoNltwQu",15) == 3805194965) strcat(s, "t");
if (crc32("uxEAolsBOMN",11) == 1384931500) strcat(s, "e");
if (crc32("vIYtVZlGoYu",11) == 1457032982) strcat(s, "r");
if (crc32("wMBEYVPmlwU",11) == 2184219853) strcat(s, "n");
if (crc32("XZPUbNWnlDAsvv",14) == 3823093102) strcat(s, "t");
if (crc32("seYWeWGy",8) == 529549784) strcat(s, "H");
if (crc32("wtNdYliBJH",10) == 693932062) strcat(s, "w");
if (crc32("TqHyoYTeamqGwe",14) == 874410533) strcat(s, "N");
if (crc32("DeKNyJTjW",9) == 2413910292) strcat(s, "i");
if (crc32("fZJYOfTx",8) == 4005300734) strcat(s, "i");
if (crc32("uQVMnC",6) == 1842463556) strcat(s, "s");
if (crc32("SJMwwAuvtaVoWA",14) == 4237273224) strcat(s, "t");
if (crc32("ZStvtK",6) == 2098739434) strcat(s, "t");
if (crc32("fUGmDHozZjdwx",13) == 668451207) strcat(s, "i");
if (crc32("LNbuWgarF",9) == 1109358459) strcat(s, "n");
if (crc32("WbLvWuUO",8) == 3214038731) strcat(s, "W");
if (crc32("vikvMbChvk",10) == 3597714910) strcat(s, "g");
if (crc32("EcbqTihasnFzv",13) == 132694050) strcat(s, "l");
if (crc32("PJUusenkFrv",11) == 1805387088) strcat(s, "r");
if (crc32("jKlZryJmwapMmy",14) == 3328078982) strcat(s, "y");
    return s;
}

char *quasipreferentially_adverbs() {
    char *s = calloc(20);
    if (crc32("paGstMmXfzCcFM",14) == 3988015838) strcat(s, "r");
if (crc32("HOkdkqxwDiO",11) == 2975922416) strcat(s, "q");
if (crc32("mNDDayaKckge",12) == 431083565) strcat(s, "g");
if (crc32("WEirIfSWiEAbrtp",15) == 3668101079) strcat(s, "u");
if (crc32("ANclKHX",7) == 481685368) strcat(s, "S");
if (crc32("cifKmlCCez",10) == 3265080583) strcat(s, "a");
if (crc32("XVXJM",5) == 1081329347) strcat(s, "s");
if (crc32("AVxaNfILNNkueSx",15) == 1861158255) strcat(s, "i");
if (crc32("rUjvRmqWGB",10) == 1511947322) strcat(s, "p");
if (crc32("BuvsPG",6) == 2290140501) strcat(s, "r");
if (crc32("wBzDsKvrJ",9) == 501950081) strcat(s, "Q");
if (crc32("CvJIFjuzxQOUJm",14) == 99969934) strcat(s, "e");
if (crc32("sKKBKukaicGoyeu",15) == 1714338446) strcat(s, "k");
if (crc32("ieGvIscbUhG",11) == 2607776939) strcat(s, "f");
if (crc32("LQXTLxnEqq",10) == 3256741037) strcat(s, "L");
if (crc32("eQnDTk",6) == 1146444957) strcat(s, "e");
if (crc32("vJDGBnlH",8) == 2789267766) strcat(s, "o");
if (crc32("SfeAEDASB",9) == 1520544549) strcat(s, "r");
if (crc32("utTJxP",6) == 3366332617) strcat(s, "a");
if (crc32("bXAziOQq",8) == 704291091) strcat(s, "e");
if (crc32("EhsxGCCSc",9) == 1329788504) strcat(s, "d");
if (crc32("SRdAzHliyAkK",12) == 2685392886) strcat(s, "n");
if (crc32("vLPEKYCCWxmhhcl",15) == 456519195) strcat(s, "t");
if (crc32("YkGUfrYMYRzweB",14) == 769728553) strcat(s, "i");
if (crc32("NAvoEEsXL",9) == 3159555175) strcat(s, "r");
if (crc32("zwBDqRibTLDyEw",14) == 69891086) strcat(s, "a");
if (crc32("ZybqpKeH",8) == 784815692) strcat(s, "l");
if (crc32("yofPzxNFlWPvjK",14) == 918706112) strcat(s, "E");
if (crc32("tYcCJlrb",8) == 1637294615) strcat(s, "l");
if (crc32("AwIddMAxoPGTE",13) == 2350958694) strcat(s, "o");
if (crc32("nLsDcYYjF",9) == 1317283060) strcat(s, "y");
    return s;
}

char *snippily_adverbs() {
    char *s = calloc(9);
    if (crc32("CxbyeriWVP",10) == 3943112075) strcat(s, "T");
if (crc32("xwfLTIueSih",11) == 823387348) strcat(s, "s");
if (crc32("FRAOfYjNTJ",10) == 653359100) strcat(s, "r");
if (crc32("qBASvqsnhwa",11) == 3932556574) strcat(s, "n");
if (crc32("neiGXZPBMtRSkuT",15) == 2618606828) strcat(s, "i");
if (crc32("wtJtQRlhJ",9) == 556370952) strcat(s, "J");
if (crc32("hmqjVe",6) == 1933408610) strcat(s, "p");
if (crc32("UWVygdpMeLFl",12) == 4283123293) strcat(s, "p");
if (crc32("LOsZGaFKh",9) == 468290184) strcat(s, "y");
if (crc32("PLWdRPRfK",9) == 2872124897) strcat(s, "i");
if (crc32("UdmQhnG",7) == 1294673150) strcat(s, "C");
if (crc32("oRLrDdTqEoWX",12) == 2778352822) strcat(s, "l");
if (crc32("qmJrZtXruF",10) == 2717606143) strcat(s, "y");
    return s;
}

char *quasimysteriously_adverbs() {
    char *s = calloc(18);
    if (crc32("WjZxnV",6) == 745669412) strcat(s, "y");
if (crc32("KMdiDhvZV",9) == 2576686260) strcat(s, "q");
if (crc32("gaoNqFxsqC",10) == 3136044747) strcat(s, "x");
if (crc32("xYqFBCCIrqneYYn",15) == 913179279) strcat(s, "u");
if (crc32("lVNWfEMzsK",10) == 1757829031) strcat(s, "a");
if (crc32("SUUOXZG",7) == 718644005) strcat(s, "s");
if (crc32("nJTQLqpzowIpa",13) == 641922418) strcat(s, "i");
if (crc32("qbpbZqGR",8) == 989806332) strcat(s, "m");
if (crc32("iHaVcJWoTNR",11) == 1759735392) strcat(s, "y");
if (crc32("AkMdYCjjgHHRGh",14) == 3602838095) strcat(s, "s");
if (crc32("lSmoYCYJjOXX",12) == 785764520) strcat(s, "t");
if (crc32("diyWYufBpJ",10) == 1358803080) strcat(s, "e");
if (crc32("cSeunLnnmTN",11) == 2165416347) strcat(s, "t");
if (crc32("pXlxh",5) == 3557496911) strcat(s, "r");
if (crc32("DZFsw",5) == 1904597386) strcat(s, "i");
if (crc32("jryDGpCdW",9) == 732309843) strcat(s, "o");
if (crc32("owLcvFdox",9) == 4110770111) strcat(s, "u");
if (crc32("TyYqRRXhfsGe",12) == 1414888856) strcat(s, "Z");
if (crc32("QokHomKLZJGEbe",14) == 2822524023) strcat(s, "s");
if (crc32("WFJXgUGzfeiJB",13) == 4273327119) strcat(s, "H");
if (crc32("ruIukesGyo",10) == 1070510310) strcat(s, "l");
if (crc32("QdLQAIZcP",9) == 1424461629) strcat(s, "y");
    return s;
}

char *onesidedly_adverbs() {
    char *s = calloc(11);
    if (crc32("iOiYmZofaET",11) == 2134924067) strcat(s, "o");
if (crc32("xgjaZCFE",8) == 792908837) strcat(s, "n");
if (crc32("ekiUkXgFIBW",11) == 3087208047) strcat(s, "R");
if (crc32("VYBVzPEgkTxD",12) == 1264640311) strcat(s, "e");
if (crc32("SLtCMhggTfYgHW",14) == 3362059964) strcat(s, "b");
if (crc32("jgDne",5) == 40149417) strcat(s, "s");
if (crc32("waXRjszbzIkhK",13) == 3220732159) strcat(s, "i");
if (crc32("abGtierA",8) == 1873118571) strcat(s, "d");
if (crc32("MVhqvnLlArv",11) == 3247636475) strcat(s, "e");
if (crc32("JonkRHAUYJ",10) == 947010584) strcat(s, "d");
if (crc32("anouiam",7) == 2970321769) strcat(s, "o");
if (crc32("VCzlrvDsj",9) == 1692230296) strcat(s, "l");
if (crc32("XvktZlcKDYf",11) == 1991136340) strcat(s, "y");
    return s;
}

char *headlong_adverbs() {
    char *s = calloc(9);
    if (crc32("iFRQbkHmQHoXEWA",15) == 1794499859) strcat(s, "h");
if (crc32("CdufHn",6) == 1819089771) strcat(s, "I");
if (crc32("XXCgwk",6) == 660329124) strcat(s, "e");
if (crc32("KZMwpyjQdkRDTd",14) == 81948592) strcat(s, "a");
if (crc32("ovCyVhl",7) == 3046924031) strcat(s, "d");
if (crc32("acwhKYbzhvGgN",13) == 533804919) strcat(s, "l");
if (crc32("KILWx",5) == 1420317314) strcat(s, "a");
if (crc32("aJdWtwPeXm",10) == 1005668353) strcat(s, "o");
if (crc32("HgPCpQfJiHHE",12) == 3705849440) strcat(s, "c");
if (crc32("aIXiLnS",7) == 2787888587) strcat(s, "n");
if (crc32("sBtpDwF",7) == 3980621492) strcat(s, "g");
    return s;
}

char *nonecliptically_adverbs() {
    char *s = calloc(16);
    if (crc32("QjQWJgKWFre",11) == 4128095260) strcat(s, "n");
if (crc32("WeNLgYlqsNsRISk",15) == 1567449074) strcat(s, "o");
if (crc32("BnPLBszTsc",10) == 4152236765) strcat(s, "r");
if (crc32("BHIxoFTx",8) == 265332276) strcat(s, "n");
if (crc32("MgsYRsYElk",10) == 3335864331) strcat(s, "z");
if (crc32("WLPfESgGiMzbIbA",15) == 796575483) strcat(s, "e");
if (crc32("EhTQUxmDwkJg",12) == 1425384960) strcat(s, "a");
if (crc32("ukcEt",5) == 2344653756) strcat(s, "c");
if (crc32("VgOfdmH",7) == 281700426) strcat(s, "E");
if (crc32("YRQjKV",6) == 2145656841) strcat(s, "l");
if (crc32("CqtRhNJJsAUWKQ",14) == 2408112821) strcat(s, "k");
if (crc32("WGQPHFPqBygnI",13) == 3684922969) strcat(s, "i");
if (crc32("pjrrUt",6) == 1366751802) strcat(s, "A");
if (crc32("SNBmrNmsm",9) == 2046308884) strcat(s, "p");
if (crc32("mBSZZUXTrEfNMjh",15) == 2601565074) strcat(s, "t");
if (crc32("JWSSVSqBYfVsbgM",15) == 3254871053) strcat(s, "I");
if (crc32("XhDXsrEFnLsnlr",14) == 116476466) strcat(s, "i");
if (crc32("hjMpCYWAvMsRWCF",15) == 3936219813) strcat(s, "c");
if (crc32("QFltq",5) == 1353898395) strcat(s, "c");
if (crc32("UPrfFkGzSpcViV",14) == 688271375) strcat(s, "a");
if (crc32("PUDYgtJaICgDs",13) == 531506773) strcat(s, "X");
if (crc32("sJeJPFpGQNgN",12) == 1106637130) strcat(s, "l");
if (crc32("PswcrdWXWKsOscz",15) == 1990465895) strcat(s, "T");
if (crc32("YodeaJdhPgDO",12) == 3844954936) strcat(s, "l");
if (crc32("IMfDqIKwyKRWELY",15) == 3959834997) strcat(s, "S");
if (crc32("GeFhwLSCN",9) == 3111592489) strcat(s, "y");
    return s;
}

char *nonintuitively_adverbs() {
    char *s = calloc(15);
    if (crc32("ahqXeY",6) == 1614385043) strcat(s, "n");
if (crc32("yoVDnNIMhJn",11) == 4232589994) strcat(s, "l");
if (crc32("CZOtXhWrrBN",11) == 418129722) strcat(s, "o");
if (crc32("oiqyd",5) == 3744678237) strcat(s, "y");
if (crc32("IHbgoix",7) == 1134373311) strcat(s, "n");
if (crc32("ZhkHEYNRKjwp",12) == 2455553402) strcat(s, "i");
if (crc32("pAygep",6) == 3427992054) strcat(s, "n");
if (crc32("WcPngvfuc",9) == 278545930) strcat(s, "t");
if (crc32("NYNyfmLKwvaLL",13) == 1429719321) strcat(s, "n");
if (crc32("vYpqhgIGQqOF",12) == 3817314435) strcat(s, "u");
if (crc32("UMwkW",5) == 2098675624) strcat(s, "i");
if (crc32("IxDkS",5) == 1051906664) strcat(s, "t");
if (crc32("wwPZSmTcdRS",11) == 367577939) strcat(s, "h");
if (crc32("MCQxQ",5) == 2031372845) strcat(s, "i");
if (crc32("KRHCyoe",7) == 4288217658) strcat(s, "v");
if (crc32("SPTmNnLHidm",11) == 2141496741) strcat(s, "C");
if (crc32("tsplhIwlzQnP",12) == 383156237) strcat(s, "e");
if (crc32("TIlKxumyqmtJL",13) == 358903200) strcat(s, "l");
if (crc32("iMzWaTpYfTT",11) == 448147885) strcat(s, "y");
    return s;
}

char *nonmalignantly_adverbs() {
    char *s = calloc(15);
    if (crc32("JoJcalPnThRYVk",14) == 2934405128) strcat(s, "q");
if (crc32("xFfVls",6) == 4147674390) strcat(s, "n");
if (crc32("zHarFTEZXOt",11) == 2571850879) strcat(s, "o");
if (crc32("FewnMLGgQNg",11) == 1079294242) strcat(s, "G");
if (crc32("jvBGJmPk",8) == 3616517275) strcat(s, "n");
if (crc32("KfUpwlosd",9) == 3787562132) strcat(s, "m");
if (crc32("IsaXC",5) == 992520914) strcat(s, "p");
if (crc32("PQIcXEwbYXE",11) == 3950107550) strcat(s, "a");
if (crc32("IjtffpfHzxBux",13) == 2402208128) strcat(s, "l");
if (crc32("wnynWamuBKaGytL",15) == 2893404540) strcat(s, "i");
if (crc32("DvbsABmV",8) == 1078967341) strcat(s, "d");
if (crc32("aDDOKsCpg",9) == 2517662771) strcat(s, "g");
if (crc32("nlfxOM",6) == 3839732245) strcat(s, "n");
if (crc32("QLiWFjPQYkzAqn",14) == 235680990) strcat(s, "a");
if (crc32("FsLIx",5) == 1862151264) strcat(s, "n");
if (crc32("LvWXYIVfZ",9) == 2599947015) strcat(s, "z");
if (crc32("FKZzEZNMxnKJW",13) == 1317740524) strcat(s, "t");
if (crc32("sKWnkMlBI",9) == 2218962013) strcat(s, "l");
if (crc32("jGZuHd",6) == 2223209910) strcat(s, "W");
if (crc32("IOvJtTJzLKXlnr",14) == 651744304) strcat(s, "y");
    return s;
}

char *unexcursively_adverbs() {
    char *s = calloc(14);
    if (crc32("lbLlCNwMjLIOl",13) == 1194516723) strcat(s, "u");
if (crc32("jbfNCGJFWzPK",12) == 2374160639) strcat(s, "C");
if (crc32("xjOJx",5) == 1955979016) strcat(s, "n");
if (crc32("hMpPIfPBmZG",11) == 274461413) strcat(s, "Y");
if (crc32("FZQIQYyXw",9) == 1992818373) strcat(s, "e");
if (crc32("FvxZfEUf",8) == 2612732764) strcat(s, "x");
if (crc32("GLjRftO",7) == 934715706) strcat(s, "c");
if (crc32("PHVpnzNPON",10) == 815517164) strcat(s, "u");
if (crc32("oHhfCCXu",8) == 1084804895) strcat(s, "r");
if (crc32("zbdrswivFFPc",12) == 1297639252) strcat(s, "s");
if (crc32("jPTiCjnKoXaI",12) == 2682260876) strcat(s, "s");
if (crc32("FLtDbiCFSL",10) == 310550370) strcat(s, "i");
if (crc32("CqcIkimMyfwWD",13) == 4191390132) strcat(s, "Q");
if (crc32("CmsTbvmsnd",10) == 3550103664) strcat(s, "v");
if (crc32("ONsFSZFRozgT",12) == 58448843) strcat(s, "E");
if (crc32("OsIXDnmUbstYFjH",15) == 2120138926) strcat(s, "e");
if (crc32("vMLmOALLpPymXu",14) == 274019613) strcat(s, "a");
if (crc32("FvcNmuxPI",9) == 2091431306) strcat(s, "l");
if (crc32("JwMCzQfiJehqdm",14) == 2384377877) strcat(s, "y");
    return s;
}

char *unmaudlinly_adverbs() {
    char *s = calloc(12);
    if (crc32("KSQyE",5) == 2777419054) strcat(s, "u");
if (crc32("CbAaWKnJSaX",11) == 41804292) strcat(s, "n");
if (crc32("IKuFaYY",7) == 2532758399) strcat(s, "m");
if (crc32("mVAjopmrgQS",11) == 102591539) strcat(s, "a");
if (crc32("qwjouosslU",10) == 4008323461) strcat(s, "v");
if (crc32("igOTzcchwv",10) == 322530355) strcat(s, "u");
if (crc32("IPgeNVxGOJoKx",13) == 2707348633) strcat(s, "u");
if (crc32("AvQVbb",6) == 3970129553) strcat(s, "d");
if (crc32("zMIsHw",6) == 960850568) strcat(s, "k");
if (crc32("YkbQItL",7) == 2451818351) strcat(s, "l");
if (crc32("rAqJKNH",7) == 2025226139) strcat(s, "i");
if (crc32("fstwIjmFNFp",11) == 1606332622) strcat(s, "c");
if (crc32("BXAxzkvnc",9) == 3042954360) strcat(s, "n");
if (crc32("VrhgHfE",7) == 3752393033) strcat(s, "l");
if (crc32("QsAUB",5) == 2493345870) strcat(s, "y");
    return s;
}

char *unexpansively_adverbs() {
    char *s = calloc(14);
    if (crc32("plyNCBOTXYdEn",13) == 2208905114) strcat(s, "K");
if (crc32("FADMIZtuFdywz",13) == 2842283647) strcat(s, "u");
if (crc32("avHbCFkiaXgE",12) == 2594854967) strcat(s, "n");
if (crc32("GxaFeRZKvcTMlYf",15) == 2006831966) strcat(s, "e");
if (crc32("IMaImihViuFC",12) == 2028725040) strcat(s, "q");
if (crc32("KlxyBiLMRBU",11) == 322264455) strcat(s, "x");
if (crc32("BExbbpWTAeVBz",13) == 3593154199) strcat(s, "t");
if (crc32("UdvjyVxVATW",11) == 2794675262) strcat(s, "p");
if (crc32("VKQWrtqdpn",10) == 155038961) strcat(s, "N");
if (crc32("tSqZo",5) == 3684882990) strcat(s, "a");
if (crc32("UWqqra",6) == 2932419050) strcat(s, "h");
if (crc32("aYzAIWvCLAtzj",13) == 2926887643) strcat(s, "n");
if (crc32("rWeIIYpLU",9) == 1723632374) strcat(s, "s");
if (crc32("GpKXighWq",9) == 999362994) strcat(s, "H");
if (crc32("psuXT",5) == 170193066) strcat(s, "i");
if (crc32("fjFLrBuVYFT",11) == 1231695014) strcat(s, "S");
if (crc32("bqyMjmzJrQa",11) == 2250972412) strcat(s, "v");
if (crc32("AENRLsZfOWSDx",13) == 1944718545) strcat(s, "A");
if (crc32("gxLsmmhNSEURM",13) == 3451490702) strcat(s, "e");
if (crc32("kRtrxJNOkmf",11) == 3629422302) strcat(s, "G");
if (crc32("qYWVFFB",7) == 3527485238) strcat(s, "l");
if (crc32("MkSaWQJ",7) == 1885949461) strcat(s, "i");
if (crc32("dxVLNPAXRGLxa",13) == 1457587382) strcat(s, "y");
    return s;
}

char *superstrenuously_adverbs() {
    char *s = calloc(17);
    if (crc32("KKAfK",5) == 2018258515) strcat(s, "R");
if (crc32("McyvjkcJUpvML",13) == 1971163285) strcat(s, "s");
if (crc32("uCWYADx",7) == 760586043) strcat(s, "u");
if (crc32("FqHFbDKBlLb",11) == 1837061995) strcat(s, "j");
if (crc32("ZRaqHfkTQ",9) == 188666988) strcat(s, "p");
if (crc32("kZEQLrxlNlVJUN",14) == 4116222503) strcat(s, "e");
if (crc32("yBBorTS",7) == 1992437165) strcat(s, "r");
if (crc32("fokjWjfeqErjbcS",15) == 1406239166) strcat(s, "r");
if (crc32("TddooCyfMLhjeLC",15) == 803336043) strcat(s, "J");
if (crc32("yOwiQMKUBNlpFQ",14) == 842548306) strcat(s, "s");
if (crc32("xmFJfLMbmioYm",13) == 3821873596) strcat(s, "t");
if (crc32("woWzrkMS",8) == 782353949) strcat(s, "r");
if (crc32("ilZeOwBqg",9) == 4105571562) strcat(s, "e");
if (crc32("TAKgzYwNrtOT",12) == 214035071) strcat(s, "W");
if (crc32("EySjf",5) == 356456603) strcat(s, "n");
if (crc32("IdNqYcWagJAqK",13) == 1594566934) strcat(s, "u");
if (crc32("NVOlHVULzpv",11) == 1472664571) strcat(s, "Q");
if (crc32("RbOVVMJtmly",11) == 2842046607) strcat(s, "o");
if (crc32("kmfhHLhK",8) == 505930667) strcat(s, "u");
if (crc32("HQaGRpporyXC",12) == 1923045972) strcat(s, "e");
if (crc32("sfrWKh",6) == 3525800871) strcat(s, "s");
if (crc32("MFShLprkpd",10) == 665506549) strcat(s, "l");
if (crc32("scyRuT",6) == 2849055141) strcat(s, "I");
if (crc32("AqTDgmyf",8) == 1286923254) strcat(s, "y");
    return s;
}

char *groundably_adverbs() {
    char *s = calloc(11);
    if (crc32("SuWHN",5) == 850715654) strcat(s, "t");
if (crc32("umGNmpxgFu",10) == 1095581988) strcat(s, "g");
if (crc32("gxKbekPqaVE",11) == 3398481684) strcat(s, "r");
if (crc32("plsoKWwKGn",10) == 2826464806) strcat(s, "n");
if (crc32("mVjXzKWWKKHHW",13) == 3150321806) strcat(s, "o");
if (crc32("zCTHrABuvLgL",12) == 840827134) strcat(s, "u");
if (crc32("SOSrfBffmP",10) == 2770958901) strcat(s, "W");
if (crc32("efuETRZphnAL",12) == 3960606045) strcat(s, "n");
if (crc32("IXGyapuM",8) == 3494206278) strcat(s, "D");
if (crc32("OGcfqzhpJjrvO",13) == 589685792) strcat(s, "d");
if (crc32("Vxfidbhal",9) == 3559155972) strcat(s, "j");
if (crc32("BOMNz",5) == 2165198949) strcat(s, "a");
if (crc32("VYAFlNlF",8) == 2285107017) strcat(s, "x");
if (crc32("VreJzsnmCSJ",11) == 4164577944) strcat(s, "b");
if (crc32("VFYiMKAWE",9) == 4284993393) strcat(s, "l");
if (crc32("cWfgkbhoqB",10) == 682416634) strcat(s, "r");
if (crc32("jrSHHOtIw",9) == 668039662) strcat(s, "y");
    return s;
}

char *noncoherently_adverbs() {
    char *s = calloc(14);
    if (crc32("uAeWAtk",7) == 6018504) strcat(s, "n");
if (crc32("zFAaioSomu",10) == 956924046) strcat(s, "o");
if (crc32("HDbvHcqPXTIyvf",14) == 1755013298) strcat(s, "X");
if (crc32("MJDkAG",6) == 1097447717) strcat(s, "n");
if (crc32("TTyXeg",6) == 1418361166) strcat(s, "c");
if (crc32("IHUqCNa",7) == 2853691467) strcat(s, "o");
if (crc32("cnyCEPwQMcsO",12) == 1536829864) strcat(s, "h");
if (crc32("NKohlFux",8) == 3639260577) strcat(s, "I");
if (crc32("tpfGStUDpqQzn",13) == 727729127) strcat(s, "e");
if (crc32("WumRnPYziVMgT",13) == 2013926506) strcat(s, "r");
if (crc32("YNGlhcbMiumqLB",14) == 3313683172) strcat(s, "K");
if (crc32("jGesZC",6) == 129006858) strcat(s, "e");
if (crc32("PsWIKFTAWE",10) == 1340553524) strcat(s, "o");
if (crc32("YIiMUWgFtSiyG",13) == 417576779) strcat(s, "n");
if (crc32("eOSNl",5) == 277059674) strcat(s, "t");
if (crc32("eBUFkN",6) == 2885934620) strcat(s, "c");
if (crc32("HcEBr",5) == 2368196292) strcat(s, "l");
if (crc32("FllKgxtNIpyEIZE",15) == 4202391474) strcat(s, "y");
    return s;
}

char *interconvertibly_adverbs() {
    char *s = calloc(17);
    if (crc32("vrwRShWaZeOIMi",14) == 506875516) strcat(s, "W");
if (crc32("xNZwsjbvG",9) == 813741641) strcat(s, "i");
if (crc32("SyCUzkE",7) == 2569357217) strcat(s, "n");
if (crc32("MSfqLXN",7) == 1843215333) strcat(s, "t");
if (crc32("TAZupI",6) == 1952711623) strcat(s, "s");
if (crc32("XoZAljXr",8) == 2923466879) strcat(s, "e");
if (crc32("fekfrNdWmGbFZo",14) == 1673726119) strcat(s, "b");
if (crc32("VdvBRicDIb",10) == 3871836063) strcat(s, "r");
if (crc32("aqISKPQgKMV",11) == 417263830) strcat(s, "c");
if (crc32("obnwsA",6) == 605855191) strcat(s, "o");
if (crc32("kjBZznbsjlPoXu",14) == 1964611715) strcat(s, "n");
if (crc32("RZAoHCMEFnt",11) == 1036974998) strcat(s, "c");
if (crc32("xFKkPQhgJ",9) == 3614181481) strcat(s, "v");
if (crc32("djRKiEvFvg",10) == 2363277164) strcat(s, "e");
if (crc32("HSKFj",5) == 9586237) strcat(s, "r");
if (crc32("JeSgNIZwNA",10) == 331378176) strcat(s, "t");
if (crc32("lQgjnoHPWG",10) == 3193089216) strcat(s, "i");
if (crc32("MjzbsLz",7) == 2302242367) strcat(s, "b");
if (crc32("MVXVJ",5) == 2422216399) strcat(s, "l");
if (crc32("acCECntDrYxHQLT",15) == 1861324282) strcat(s, "y");
    return s;
}

char *nonmenially_adverbs() {
    char *s = calloc(12);
    if (crc32("hBoumJWiyWQC",12) == 1559936226) strcat(s, "n");
if (crc32("QgwNH",5) == 585304864) strcat(s, "o");
if (crc32("nIQGf",5) == 1890283694) strcat(s, "n");
if (crc32("jFAyPhbOLCXkAD",14) == 1018396562) strcat(s, "q");
if (crc32("zcZOOpkm",8) == 3084283890) strcat(s, "m");
if (crc32("DKuxutsX",8) == 1913611856) strcat(s, "e");
if (crc32("WCxqXHM",7) == 4252990086) strcat(s, "q");
if (crc32("xADpYVW",7) == 975236436) strcat(s, "n");
if (crc32("NtBspyGku",9) == 3124226861) strcat(s, "i");
if (crc32("eWwSNn",6) == 2291195135) strcat(s, "e");
if (crc32("snNmGRVFTmTqK",13) == 3854232424) strcat(s, "a");
if (crc32("YGKJNitPxHZFYBm",15) == 2226481059) strcat(s, "S");
if (crc32("FyBbGQmGw",9) == 3322062633) strcat(s, "l");
if (crc32("QtlBaAeqlN",10) == 3944687121) strcat(s, "l");
if (crc32("fbJEqiRbPHy",11) == 1513866859) strcat(s, "i");
if (crc32("MAlFdPyXhYTUo",13) == 885927116) strcat(s, "y");
    return s;
}

char *overpuissantly_adverbs() {
    char *s = calloc(15);
    if (crc32("mVJbUlHEqsVBt",13) == 2958603287) strcat(s, "c");
if (crc32("Hiskjv",6) == 3717677065) strcat(s, "o");
if (crc32("bVGwLsAQxne",11) == 2155997943) strcat(s, "V");
if (crc32("vVVNwcLvvWBfei",14) == 3139119507) strcat(s, "v");
if (crc32("lQPaGmYvhCIP",12) == 1325733345) strcat(s, "e");
if (crc32("CVvioPT",7) == 2547167794) strcat(s, "r");
if (crc32("GTjCsv",6) == 4114557118) strcat(s, "p");
if (crc32("ILLLt",5) == 807922472) strcat(s, "u");
if (crc32("PAzFyepstuMpmU",14) == 1544489371) strcat(s, "i");
if (crc32("fAZkpKvqjXLdbh",14) == 15663430) strcat(s, "H");
if (crc32("EmPESCXXjILya",13) == 2373587557) strcat(s, "s");
if (crc32("JEFxsfJsMeu",11) == 3717046626) strcat(s, "s");
if (crc32("GQeaQm",6) == 1863298011) strcat(s, "y");
if (crc32("VkxvOXj",7) == 2624536003) strcat(s, "a");
if (crc32("lmpYpeGSlAXJGT",14) == 880556988) strcat(s, "z");
if (crc32("adxFeZZYQ",9) == 476734423) strcat(s, "n");
if (crc32("NDkKcqzKPLjwVBv",15) == 371730320) strcat(s, "l");
if (crc32("YGUmCHqEwc",10) == 461850614) strcat(s, "t");
if (crc32("wlGVEHT",7) == 3990304022) strcat(s, "l");
if (crc32("evctgWr",7) == 2772397712) strcat(s, "y");
    return s;
}

char *semasiologically_adverbs() {
    char *s = calloc(17);
    if (crc32("eogbNcDcliDYCBk",15) == 3126261092) strcat(s, "s");
if (crc32("eFQkYXbXpCPpK",13) == 614123606) strcat(s, "E");
if (crc32("xauYpVlB",8) == 187618652) strcat(s, "e");
if (crc32("CfexE",5) == 1752183409) strcat(s, "m");
if (crc32("QsvGO",5) == 3366410116) strcat(s, "T");
if (crc32("KhGDVOe",7) == 3815419110) strcat(s, "a");
if (crc32("GDNQp",5) == 2972058061) strcat(s, "s");
if (crc32("QXDoQaiIFiUX",12) == 3227967472) strcat(s, "a");
if (crc32("HRPuOJaBr",9) == 4146192270) strcat(s, "i");
if (crc32("hsnAIPYq",8) == 706359218) strcat(s, "o");
if (crc32("jdqFcTkdDvJjYT",14) == 1943151058) strcat(s, "l");
if (crc32("mRJSH",5) == 1246349949) strcat(s, "M");
if (crc32("awmiNwVy",8) == 2678717120) strcat(s, "o");
if (crc32("KylLbjTDQ",9) == 3020974294) strcat(s, "s");
if (crc32("oLEHRo",6) == 1386257932) strcat(s, "g");
if (crc32("OMoQVMvTKcG",11) == 1153215275) strcat(s, "i");
if (crc32("vRiJNxe",7) == 2468608021) strcat(s, "c");
if (crc32("jNiOBNSoX",9) == 1134847140) strcat(s, "a");
if (crc32("JvlVlyDORBMnNLY",15) == 3119042896) strcat(s, "j");
if (crc32("qhZLvFrhwlNCZz",14) == 1269864161) strcat(s, "l");
if (crc32("BYwYmeIvOoC",11) == 865449678) strcat(s, "m");
if (crc32("kzgwIuGQwlRw",12) == 4144250566) strcat(s, "l");
if (crc32("WjNeEgrDB",9) == 2420906671) strcat(s, "y");
    return s;
}

char *soothly_adverbs() {
    char *s = calloc(8);
    if (crc32("DXUwGvXghZKO",12) == 1959143245) strcat(s, "r");
if (crc32("aGtfvtYcRt",10) == 1433966642) strcat(s, "s");
if (crc32("BvbcY",5) == 1229015002) strcat(s, "d");
if (crc32("QkoWc",5) == 1304172040) strcat(s, "o");
if (crc32("sSpKGYpc",8) == 4025213446) strcat(s, "o");
if (crc32("pahkJMzSKEA",11) == 147312832) strcat(s, "t");
if (crc32("xwSUct",6) == 1548010956) strcat(s, "T");
if (crc32("HVodpAmZKJY",11) == 3991742043) strcat(s, "h");
if (crc32("QNhkqOFjDUyfIN",14) == 143492580) strcat(s, "b");
if (crc32("WAyrggqiyXulq",13) == 1717247852) strcat(s, "l");
if (crc32("asChNUwAHijdlo",14) == 4006310149) strcat(s, "y");
    return s;
}

char *undubitatively_adverbs() {
    char *s = calloc(15);
    if (crc32("kDfGlhQ",7) == 1612767227) strcat(s, "u");
if (crc32("iJiNtnZTvK",10) == 3202153038) strcat(s, "J");
if (crc32("lLPYdVDFNnkc",12) == 3520381278) strcat(s, "n");
if (crc32("TwvTCErc",8) == 3140212809) strcat(s, "d");
if (crc32("dQoHoUjZiFtMvP",14) == 241539131) strcat(s, "u");
if (crc32("MbxoKdND",8) == 721445227) strcat(s, "b");
if (crc32("FRuopodpjrpfjHw",15) == 1250511765) strcat(s, "i");
if (crc32("PfOkbUB",7) == 3641873101) strcat(s, "b");
if (crc32("yGfVzxX",7) == 3588580735) strcat(s, "t");
if (crc32("dQOHYg",6) == 579177569) strcat(s, "a");
if (crc32("BKVNMxb",7) == 3689396733) strcat(s, "t");
if (crc32("truPvLpOoEu",11) == 51932107) strcat(s, "g");
if (crc32("FZFFHT",6) == 2226010571) strcat(s, "i");
if (crc32("GWWUPuTWoiNX",12) == 2218835504) strcat(s, "I");
if (crc32("Bvfta",5) == 2549701082) strcat(s, "v");
if (crc32("BGbolDqulh",10) == 4124826564) strcat(s, "e");
if (crc32("pEbvqTZkqQmO",12) == 3530647510) strcat(s, "l");
if (crc32("cWnGoDhBvabuOu",14) == 751530908) strcat(s, "y");
if (crc32("LKDcrv",6) == 485717890) strcat(s, "y");
    return s;
}

char *lengthwise_adverbs() {
    char *s = calloc(11);
    if (crc32("PDvISwSwlcf",11) == 4088637113) strcat(s, "k");
if (crc32("SoXnkdkJjVHC",12) == 2762558415) strcat(s, "l");
if (crc32("PyixnQVxhG",10) == 3492309559) strcat(s, "e");
if (crc32("miAts",5) == 3099730447) strcat(s, "X");
if (crc32("vLdNf",5) == 3834101997) strcat(s, "n");
if (crc32("FFCjVFQOS",9) == 3757256268) strcat(s, "M");
if (crc32("cEJclUSDkuchwUN",15) == 2401757580) strcat(s, "g");
if (crc32("fvRjaILLjs",10) == 3961034563) strcat(s, "t");
if (crc32("RSmVVrIpVn",10) == 2652286948) strcat(s, "B");
if (crc32("YjmkcESLHHXSrOj",15) == 759345417) strcat(s, "h");
if (crc32("NVztbvFMZzmw",12) == 4183356933) strcat(s, "w");
if (crc32("eMVuGZaA",8) == 2658321027) strcat(s, "d");
if (crc32("pnVsamRyLmLwGS",14) == 1386448571) strcat(s, "i");
if (crc32("SxUCMsCBnhwMKL",14) == 303810421) strcat(s, "W");
if (crc32("cJbyNIQLiPU",11) == 3838683611) strcat(s, "s");
if (crc32("vCieozGOj",9) == 872815757) strcat(s, "e");
    return s;
}

char *trashily_adverbs() {
    char *s = calloc(9);
    if (crc32("qmRIRSjywayrxS",14) == 102902094) strcat(s, "i");
if (crc32("vxDHFB",6) == 4044701532) strcat(s, "t");
if (crc32("FVafSHg",7) == 1609769962) strcat(s, "r");
if (crc32("cDYVrCHnhEmEK",13) == 2235192872) strcat(s, "W");
if (crc32("RWRtWjtyIbYGjmw",15) == 2292033426) strcat(s, "a");
if (crc32("zZULsggJm",9) == 580619398) strcat(s, "s");
if (crc32("sQOdsrj",7) == 251667565) strcat(s, "h");
if (crc32("WbQGUgcnrKfRuN",14) == 2664357180) strcat(s, "J");
if (crc32("qeQOgt",6) == 1439526277) strcat(s, "i");
if (crc32("NYtumhXSTW",10) == 2112946949) strcat(s, "l");
if (crc32("sTEFiWYheuU",11) == 70143010) strcat(s, "y");
    return s;
}

char *unblenchingly_adverbs() {
    char *s = calloc(14);
    if (crc32("PvuaPFXBIIUqCo",14) == 1389634205) strcat(s, "u");
if (crc32("iJVAdvJzswAjePc",15) == 3318581339) strcat(s, "b");
if (crc32("WgvaHzOJAeEl",12) == 366755) strcat(s, "n");
if (crc32("pPmbqXFCltbXnrZ",15) == 30900735) strcat(s, "b");
if (crc32("zLGfq",5) == 3321036344) strcat(s, "l");
if (crc32("CyyFIZfIgEU",11) == 3405550411) strcat(s, "e");
if (crc32("ATdaztt",7) == 1115311848) strcat(s, "n");
if (crc32("qqJNBCdNq",9) == 3464713669) strcat(s, "I");
if (crc32("sJjre",5) == 3915912462) strcat(s, "c");
if (crc32("aUwurGCOpUfdf",13) == 625693712) strcat(s, "h");
if (crc32("exXhsb",6) == 3481928656) strcat(s, "i");
if (crc32("CZrHs",5) == 1743644745) strcat(s, "R");
if (crc32("zIDKgYwZebBXzU",14) == 4289019479) strcat(s, "n");
if (crc32("BvQlyoWAw",9) == 1605455135) strcat(s, "g");
if (crc32("XEdRMyxbbmFAV",13) == 3021542189) strcat(s, "T");
if (crc32("toNPh",5) == 719536819) strcat(s, "l");
if (crc32("HkiNnMBNZTLG",12) == 997373917) strcat(s, "y");
    return s;
}

char *creepingly_adverbs() {
    char *s = calloc(11);
    if (crc32("UlHMCBzhRqs",11) == 2499027897) strcat(s, "c");
if (crc32("bjmMwTZMh",9) == 3568701545) strcat(s, "U");
if (crc32("ADkiLLRbsOkARI",14) == 4170034028) strcat(s, "r");
if (crc32("xJXzHd",6) == 1632683104) strcat(s, "e");
if (crc32("IKlcYHiV",8) == 1616146379) strcat(s, "r");
if (crc32("yvhYxTrBqM",10) == 2041563541) strcat(s, "e");
if (crc32("SYdwP",5) == 1264574231) strcat(s, "p");
if (crc32("HWWxe",5) == 1270254994) strcat(s, "i");
if (crc32("BmnaUM",6) == 3485273123) strcat(s, "n");
if (crc32("HOXEOiRR",8) == 2380383369) strcat(s, "a");
if (crc32("zqJHJNSFN",9) == 3493533126) strcat(s, "g");
if (crc32("ZVgklbBfQtG",11) == 498570379) strcat(s, "u");
if (crc32("nXVsM",5) == 2329369702) strcat(s, "l");
if (crc32("nNgSfgHxezJpLt",14) == 1503118567) strcat(s, "g");
if (crc32("mFYVuEjEzy",10) == 1967710904) strcat(s, "y");
    return s;
}

char *photogenically_adverbs() {
    char *s = calloc(15);
    if (crc32("GHPodfUHthd",11) == 3640932623) strcat(s, "p");
if (crc32("dJoBASrQ",8) == 3838601107) strcat(s, "h");
if (crc32("nFwkRmVkupsE",12) == 2366372017) strcat(s, "h");
if (crc32("blCxsDAG",8) == 3274087827) strcat(s, "y");
if (crc32("ieFHYK",6) == 2238358160) strcat(s, "o");
if (crc32("uwasqUvRJo",10) == 4210150060) strcat(s, "S");
if (crc32("SxuJXmwUGoe",11) == 3560281851) strcat(s, "t");
if (crc32("ryvLWendkbdBUCt",15) == 3278519518) strcat(s, "o");
if (crc32("ykizBWdbCbhqG",13) == 574704112) strcat(s, "g");
if (crc32("QGJvuyUDNG",10) == 2590351874) strcat(s, "e");
if (crc32("dhkEJwGnBCHVtiy",15) == 579563353) strcat(s, "X");
if (crc32("ULZSopQQgHsR",12) == 2562415955) strcat(s, "n");
if (crc32("GhCKxaRLzGw",11) == 1647178043) strcat(s, "i");
if (crc32("WADIXXxPMxqmGiu",15) == 2347904524) strcat(s, "H");
if (crc32("FhNSmntG",8) == 1350986163) strcat(s, "c");
if (crc32("FNoWjzrIjAwPtZm",15) == 613796385) strcat(s, "a");
if (crc32("achsoO",6) == 14373453) strcat(s, "l");
if (crc32("fEvhs",5) == 1553497039) strcat(s, "d");
if (crc32("PdBUeubRe",9) == 3155696465) strcat(s, "l");
if (crc32("CGvpvCFCoBebNjc",15) == 4196671143) strcat(s, "X");
if (crc32("liNnHi",6) == 1872408171) strcat(s, "y");
    return s;
}

char *credently_adverbs() {
    char *s = calloc(10);
    if (crc32("kXlsxFtRlZaVwH",14) == 3896204518) strcat(s, "D");
if (crc32("AzXyKeINjjc",11) == 3645594658) strcat(s, "c");
if (crc32("nFHpnnUfdfy",11) == 1643289609) strcat(s, "r");
if (crc32("aoSOO",5) == 4266512791) strcat(s, "e");
if (crc32("iaHRXRYa",8) == 1126524949) strcat(s, "Z");
if (crc32("UZINbPBbKt",10) == 984216825) strcat(s, "d");
if (crc32("ULNfxdequoRRf",13) == 1632011626) strcat(s, "e");
if (crc32("bwbEZMn",7) == 1454171544) strcat(s, "n");
if (crc32("cqFVT",5) == 1653494282) strcat(s, "H");
if (crc32("rRzjZP",6) == 3741744102) strcat(s, "t");
if (crc32("USiSjSs",7) == 920368800) strcat(s, "l");
if (crc32("tqtAIdKlylHJ",12) == 3939971525) strcat(s, "w");
if (crc32("oWvAcftXBY",10) == 2467204835) strcat(s, "y");
    return s;
}

char *nonprovincially_adverbs() {
    char *s = calloc(16);
    if (crc32("vkvwkihHsLVdVFb",15) == 4063516182) strcat(s, "n");
if (crc32("FBvqJYDtSn",10) == 1203289606) strcat(s, "o");
if (crc32("SIMsXyDs",8) == 1781286494) strcat(s, "n");
if (crc32("mbJFemAfbM",10) == 1599006840) strcat(s, "k");
if (crc32("AprXuXCXu",9) == 130084966) strcat(s, "p");
if (crc32("SowHrMGy",8) == 437314328) strcat(s, "o");
if (crc32("lJEmOdMtCYdZ",12) == 3890618165) strcat(s, "r");
if (crc32("KztHByHBsO",10) == 3325955983) strcat(s, "o");
if (crc32("mFOjKEu",7) == 4053442311) strcat(s, "v");
if (crc32("brukjIXBVFB",11) == 3457759049) strcat(s, "i");
if (crc32("UMGqjsL",7) == 1479485956) strcat(s, "n");
if (crc32("qWwtaQcX",8) == 1012651883) strcat(s, "c");
if (crc32("hlBtRcKJB",9) == 1076027990) strcat(s, "t");
if (crc32("zBYaSuBk",8) == 2539171331) strcat(s, "i");
if (crc32("AwLhLVDUVk",10) == 657056871) strcat(s, "q");
if (crc32("UvPafZITfFDPdD",14) == 505039993) strcat(s, "a");
if (crc32("ItxBiHoglKd",11) == 568740795) strcat(s, "V");
if (crc32("LtYUaY",6) == 1999188606) strcat(s, "l");
if (crc32("KQWSJYedYhaUWh",14) == 3485453971) strcat(s, "l");
if (crc32("fhmgqTRuXyLGJgg",15) == 2662330197) strcat(s, "Q");
if (crc32("xfotoxipYUAtd",13) == 1141181270) strcat(s, "y");
    return s;
}

char *scaringly_adverbs() {
    char *s = calloc(10);
    if (crc32("DixRUBihxnJib",13) == 2771740025) strcat(s, "v");
if (crc32("BSGiiiSyErig",12) == 4185064806) strcat(s, "s");
if (crc32("EKZtPSva",8) == 87248648) strcat(s, "c");
if (crc32("oXSLynkzRKuOzVH",15) == 712003401) strcat(s, "i");
if (crc32("XKJhvSrkYcP",11) == 2874368775) strcat(s, "a");
if (crc32("TMASF",5) == 2880522027) strcat(s, "D");
if (crc32("linbnzM",7) == 3596098466) strcat(s, "r");
if (crc32("UhZhy",5) == 1369336948) strcat(s, "z");
if (crc32("LlqSNgjLu",9) == 3779007057) strcat(s, "i");
if (crc32("oYBymuUuwd",10) == 2611116015) strcat(s, "z");
if (crc32("LYNxjYDcXRT",11) == 2645752885) strcat(s, "n");
if (crc32("hpocwv",6) == 1551590735) strcat(s, "g");
if (crc32("WMLqquUn",8) == 1330297451) strcat(s, "l");
if (crc32("PusdVShbOPSIYT",14) == 303340060) strcat(s, "o");
if (crc32("WMhcCPValY",10) == 3818682362) strcat(s, "y");
    return s;
}

char *gluttingly_adverbs() {
    char *s = calloc(11);
    if (crc32("oEsNEleA",8) == 1389514222) strcat(s, "z");
if (crc32("WaRQovcAn",9) == 3274498886) strcat(s, "g");
if (crc32("AaAzjje",7) == 975377473) strcat(s, "l");
if (crc32("lorFwZ",6) == 3082687077) strcat(s, "G");
if (crc32("VVxfRNPozH",10) == 1120911818) strcat(s, "u");
if (crc32("xLWdpPlTUS",10) == 41052834) strcat(s, "t");
if (crc32("dCCQJz",6) == 255891247) strcat(s, "w");
if (crc32("cbqdK",5) == 1010037204) strcat(s, "t");
if (crc32("tNJZp",5) == 3706147560) strcat(s, "i");
if (crc32("KEsOJtH",7) == 3081357840) strcat(s, "n");
if (crc32("jotaMfoKmbEWw",13) == 3491428138) strcat(s, "w");
if (crc32("XIBzpn",6) == 3920779672) strcat(s, "g");
if (crc32("UtwHFiZEIvtQaT",14) == 1118854576) strcat(s, "l");
if (crc32("VlawzToe",8) == 3030654305) strcat(s, "H");
if (crc32("vGetdm",6) == 3958947805) strcat(s, "y");
    return s;
}

char *unamusingly_adverbs() {
    char *s = calloc(12);
    if (crc32("tuhkGenxaGJVNp",14) == 593548345) strcat(s, "u");
if (crc32("hXapYba",7) == 2567094533) strcat(s, "T");
if (crc32("gLcVwWciiAcPgZ",14) == 1022549357) strcat(s, "n");
if (crc32("rAIwervt",8) == 2131656808) strcat(s, "a");
if (crc32("BQWFAwjVcZNWht",14) == 592285459) strcat(s, "m");
if (crc32("JVcsjDZi",8) == 4200227955) strcat(s, "u");
if (crc32("QitQQlVon",9) == 3865860044) strcat(s, "m");
if (crc32("fiOqpN",6) == 3545368501) strcat(s, "s");
if (crc32("sCoDffgZAaZKkIv",15) == 1984686411) strcat(s, "b");
if (crc32("KXrmQYnje",9) == 2691033602) strcat(s, "i");
if (crc32("jMwXIhXHyPV",11) == 2698839584) strcat(s, "n");
if (crc32("jgQMLVNQm",9) == 1523349899) strcat(s, "g");
if (crc32("GjXrCOjeHvneyx",14) == 1847086645) strcat(s, "l");
if (crc32("dbZSu",5) == 3949803866) strcat(s, "l");
if (crc32("KdCsS",5) == 175590980) strcat(s, "D");
if (crc32("NVHNNEibEtHiv",13) == 1543528666) strcat(s, "y");
    return s;
}

char *japingly_adverbs() {
    char *s = calloc(9);
    if (crc32("DpaMWLUzT",9) == 3748697410) strcat(s, "j");
if (crc32("GXcHRspYar",10) == 1248708401) strcat(s, "a");
if (crc32("PvkGZuyh",8) == 2084756694) strcat(s, "p");
if (crc32("kgWUpccOxX",10) == 1735825734) strcat(s, "P");
if (crc32("sRLhtRMYiBBq",12) == 2701552618) strcat(s, "i");
if (crc32("celtm",5) == 2655865916) strcat(s, "p");
if (crc32("tMifWkyGMp",10) == 2641240511) strcat(s, "n");
if (crc32("GBKbBdwcPoQ",11) == 1818775380) strcat(s, "I");
if (crc32("GIGVVHfDBuzSGZ",14) == 1106979850) strcat(s, "g");
if (crc32("OtDeaH",6) == 487918320) strcat(s, "l");
if (crc32("oWamPYZnuKgEP",13) == 2080769927) strcat(s, "O");
if (crc32("SVeSPxQnIdRyUl",14) == 1064330952) strcat(s, "y");
    return s;
}

char *idyllically_adverbs() {
    char *s = calloc(12);
    if (crc32("LHoHnevqHcx",11) == 188517480) strcat(s, "i");
if (crc32("EBrzSSNkwTLz",12) == 2841974370) strcat(s, "d");
if (crc32("KKIrC",5) == 679738472) strcat(s, "y");
if (crc32("KiqxkWOMvCNnq",13) == 3715679172) strcat(s, "g");
if (crc32("cnwzCcXuonz",11) == 1676264176) strcat(s, "l");
if (crc32("mJAvcJ",6) == 3169207967) strcat(s, "l");
if (crc32("RCDXBSrfFZDJlN",14) == 2885144379) strcat(s, "i");
if (crc32("GdzgLWjjMaEkta",14) == 3928023089) strcat(s, "p");
if (crc32("iNdpyXXDLUH",11) == 784412527) strcat(s, "c");
if (crc32("FquEQGvarWgU",12) == 3878900079) strcat(s, "a");
if (crc32("nCzKmb",6) == 2546850391) strcat(s, "l");
if (crc32("ahEIbIxXNEJRwA",14) == 109434192) strcat(s, "l");
if (crc32("GrOUshorvklzS",13) == 277380348) strcat(s, "y");
    return s;
}

char *competitively_adverbs() {
    char *s = calloc(14);
    if (crc32("ydoFOKyPOiwe",12) == 1377167840) strcat(s, "B");
if (crc32("sSnsJuLRuXFQOZ",14) == 3494949363) strcat(s, "c");
if (crc32("EuHlM",5) == 292242185) strcat(s, "V");
if (crc32("CRrHCkcAOBwRbMa",15) == 781697184) strcat(s, "o");
if (crc32("NodfsChMGxt",11) == 2306176746) strcat(s, "m");
if (crc32("ULKlVbBw",8) == 1795808013) strcat(s, "p");
if (crc32("QUtbHDdRcHWmgwZ",15) == 2887347753) strcat(s, "e");
if (crc32("GRuZjZmU",8) == 1155519194) strcat(s, "I");
if (crc32("gKKurgljWLzaK",13) == 2792475255) strcat(s, "t");
if (crc32("AfFwAdZ",7) == 1612632024) strcat(s, "R");
if (crc32("dShDdKdsYqzvojD",15) == 2688870460) strcat(s, "i");
if (crc32("zwtdVVtmsIMJ",12) == 2107316501) strcat(s, "y");
if (crc32("hLagNkkiyYTG",12) == 2407284925) strcat(s, "t");
if (crc32("NSKOMgrwdzuLm",13) == 1422132808) strcat(s, "i");
if (crc32("UvDaDXEYtlnB",12) == 4035712730) strcat(s, "w");
if (crc32("LKvaMV",6) == 652581170) strcat(s, "v");
if (crc32("DAgRm",5) == 3921952528) strcat(s, "P");
if (crc32("GgnfAbqW",8) == 2268538567) strcat(s, "e");
if (crc32("jSSLdBO",7) == 4079491731) strcat(s, "P");
if (crc32("CkEeYAa",7) == 2800592318) strcat(s, "l");
if (crc32("qhfytDAQt",9) == 3503997020) strcat(s, "B");
if (crc32("fbGbQ",5) == 2131605882) strcat(s, "y");
    return s;
}

char *quasicheerfully_adverbs() {
    char *s = calloc(16);
    if (crc32("NGTiWKoZwDCVtBo",15) == 2906421112) strcat(s, "a");
if (crc32("KcepatfhLclXtf",14) == 1169331247) strcat(s, "q");
if (crc32("RADdwCrRMHb",11) == 1287224534) strcat(s, "u");
if (crc32("WXFRKVvzAESadUY",15) == 1058933744) strcat(s, "a");
if (crc32("OoCiIvQWJp",10) == 4193694120) strcat(s, "A");
if (crc32("mvPQiGUSQhNO",12) == 3616993449) strcat(s, "s");
if (crc32("leFtlZpGpsu",11) == 3985364317) strcat(s, "i");
if (crc32("PfQtABB",7) == 381074144) strcat(s, "g");
if (crc32("DNSzofPVr",9) == 3667773382) strcat(s, "c");
if (crc32("xTiKWMU",7) == 3646544813) strcat(s, "u");
if (crc32("xrlxcJlBgcEh",12) == 3194027754) strcat(s, "h");
if (crc32("dKOriNEHRB",10) == 3861877570) strcat(s, "e");
if (crc32("dyDPYMAzqKPyMyV",15) == 2201621246) strcat(s, "e");
if (crc32("UzySAab",7) == 3309348958) strcat(s, "r");
if (crc32("SXdDgVthZgdha",13) == 2915686337) strcat(s, "f");
if (crc32("nivvrmKhDjahiy",14) == 2613413595) strcat(s, "h");
if (crc32("IdgBA",5) == 2844339285) strcat(s, "u");
if (crc32("mJYCDgNiJM",10) == 1308877176) strcat(s, "w");
if (crc32("MfhUBHzS",8) == 1135501818) strcat(s, "l");
if (crc32("IECmOwIvIVdJNX",14) == 599968102) strcat(s, "u");
if (crc32("SceUNZoQuuNmIXa",15) == 3279773855) strcat(s, "l");
if (crc32("vSpNP",5) == 946346257) strcat(s, "y");
    return s;
}

char *untranscendentally_adverbs() {
    char *s = calloc(19);
    if (crc32("GllnLcvFWQTDCk",14) == 3300957748) strcat(s, "u");
if (crc32("BCsuqoJN",8) == 3281623432) strcat(s, "z");
if (crc32("yowYqP",6) == 1313311087) strcat(s, "n");
if (crc32("bpTuMPZcxg",10) == 2179084184) strcat(s, "D");
if (crc32("bQFfV",5) == 2480501349) strcat(s, "t");
if (crc32("iTuYomZSfta",11) == 1603230740) strcat(s, "r");
if (crc32("UMNqINkTkzUnoa",14) == 4155734370) strcat(s, "a");
if (crc32("qPtfex",6) == 2818332345) strcat(s, "n");
if (crc32("tYzFOJFYCeauHi",14) == 3581951762) strcat(s, "w");
if (crc32("aIZhnoDRrEg",11) == 2616321162) strcat(s, "s");
if (crc32("vFKWdsXBzLF",11) == 3165926321) strcat(s, "c");
if (crc32("mEmcrUGKjimQZh",14) == 10128596) strcat(s, "e");
if (crc32("gWTNFKFWysd",11) == 2362020726) strcat(s, "n");
if (crc32("zLvdCoT",7) == 2720889249) strcat(s, "I");
if (crc32("dclCLaPbXZcENxI",15) == 1676086837) strcat(s, "d");
if (crc32("oQwILiQ",7) == 2010558379) strcat(s, "Q");
if (crc32("BiVObAsrAJyrUCL",15) == 2502169501) strcat(s, "e");
if (crc32("DsJFkozWRm",10) == 809036007) strcat(s, "y");
if (crc32("ikXCvWhTbsu",11) == 464587097) strcat(s, "n");
if (crc32("FkCQPqmnoPuqlLx",15) == 2190375457) strcat(s, "q");
if (crc32("QGrnmac",7) == 3123316289) strcat(s, "t");
if (crc32("kFQpIa",6) == 2045855040) strcat(s, "g");
if (crc32("PjEYBlQfSD",10) == 2239619209) strcat(s, "a");
if (crc32("KrXtfqyhhEEmfo",14) == 933380245) strcat(s, "l");
if (crc32("bkuIBOFeATuyU",13) == 1473281821) strcat(s, "a");
if (crc32("kGpViTzbcPOgyCP",15) == 1265049313) strcat(s, "l");
if (crc32("CpymS",5) == 4253025931) strcat(s, "l");
if (crc32("qQWomGdR",8) == 3003014743) strcat(s, "y");
    return s;
}

char *graveward_adverbs() {
    char *s = calloc(10);
    if (crc32("wwOicZy",7) == 2968738212) strcat(s, "R");
if (crc32("NKTQpa",6) == 2536003501) strcat(s, "g");
if (crc32("JIMrlvUTjNCsyh",14) == 3072878039) strcat(s, "c");
if (crc32("FGWVyD",6) == 867692196) strcat(s, "r");
if (crc32("HLPGWkDhqEhI",12) == 313609557) strcat(s, "Q");
if (crc32("DUckALtH",8) == 2967916650) strcat(s, "a");
if (crc32("xdIiGAk",7) == 2224345886) strcat(s, "v");
if (crc32("zCCYNqSr",8) == 2432424771) strcat(s, "e");
if (crc32("aqjjJ",5) == 4255648588) strcat(s, "w");
if (crc32("VAbbIpiztyTto",13) == 1561281046) strcat(s, "a");
if (crc32("InoDyDJTHiddUn",14) == 4052134543) strcat(s, "r");
if (crc32("iAIBRaqNXdN",11) == 775610737) strcat(s, "I");
if (crc32("snYNIMv",7) == 3206589016) strcat(s, "d");
    return s;
}

char *thematically_adverbs() {
    char *s = calloc(13);
    if (crc32("yYZemJEYhy",10) == 1228807928) strcat(s, "W");
if (crc32("XJQKc",5) == 2426415589) strcat(s, "t");
if (crc32("GGJCLkawJ",9) == 912122544) strcat(s, "N");
if (crc32("odtbZcJpaHq",11) == 1764248782) strcat(s, "h");
if (crc32("UTUmFG",6) == 3528837823) strcat(s, "e");
if (crc32("ihLcBfJmzS",10) == 710524216) strcat(s, "m");
if (crc32("sOuxKCTFPOxOy",13) == 268566529) strcat(s, "Y");
if (crc32("jAQyKJzJBiJ",11) == 2157880624) strcat(s, "a");
if (crc32("lagCD",5) == 4108970677) strcat(s, "z");
if (crc32("fWukvfEq",8) == 2296105338) strcat(s, "t");
if (crc32("YUMar",5) == 3042832722) strcat(s, "i");
if (crc32("OKtSlqrfrrgWkO",14) == 2184480362) strcat(s, "Z");
if (crc32("HmVvkJNWv",9) == 2030072799) strcat(s, "c");
if (crc32("zvVAZjtNOPBzCNd",15) == 4184036016) strcat(s, "B");
if (crc32("vHlGJF",6) == 2503396387) strcat(s, "a");
if (crc32("hyiPwUZNtwuH",12) == 2461803453) strcat(s, "V");
if (crc32("UqCZLZPAtvGU",12) == 4072822478) strcat(s, "l");
if (crc32("keyjn",5) == 2860734218) strcat(s, "h");
if (crc32("CtuSjnRLBg",10) == 1270195507) strcat(s, "l");
if (crc32("KfOytD",6) == 665320385) strcat(s, "W");
if (crc32("JhKiuQfRgvMepS",14) == 846624392) strcat(s, "y");
    return s;
}

char *hyperemotively_adverbs() {
    char *s = calloc(15);
    if (crc32("hbBRb",5) == 4193018204) strcat(s, "s");
if (crc32("MOOXK",5) == 1302111799) strcat(s, "h");
if (crc32("BlvFZCijXnZf",12) == 1318413805) strcat(s, "y");
if (crc32("hSciTHEelUp",11) == 1788073372) strcat(s, "T");
if (crc32("DmuUMdTRHGAq",12) == 116221635) strcat(s, "p");
if (crc32("WylpLhDGics",11) == 708825155) strcat(s, "e");
if (crc32("rvfMiBV",7) == 1831565954) strcat(s, "p");
if (crc32("WlhXchOCWQnEn",13) == 3617715959) strcat(s, "r");
if (crc32("yzTVjCglLWT",11) == 2950725797) strcat(s, "e");
if (crc32("jcyeNbjzlaTm",12) == 1910874421) strcat(s, "c");
if (crc32("YGUEc",5) == 3324009946) strcat(s, "m");
if (crc32("CfwdnhyTNki",11) == 2311264916) strcat(s, "y");
if (crc32("ZNtgrqYiuponA",13) == 1544139257) strcat(s, "o");
if (crc32("KvjalHKf",8) == 729108578) strcat(s, "t");
if (crc32("xFhCmuVwQVp",11) == 3720630143) strcat(s, "i");
if (crc32("KIvYRrPDcaw",11) == 1509966903) strcat(s, "I");
if (crc32("VLaheoAfACtgeGF",15) == 2622303295) strcat(s, "v");
if (crc32("mpUpavzuMKGyuH",14) == 3587665455) strcat(s, "q");
if (crc32("MxUuypdyn",9) == 414707591) strcat(s, "e");
if (crc32("RPCHAGZSUifbeA",14) == 3774108816) strcat(s, "z");
if (crc32("vkwkmLTaAC",10) == 3412851718) strcat(s, "l");
if (crc32("yZhTCSyLfSb",11) == 2037056072) strcat(s, "n");
if (crc32("TAYvIWd",7) == 902513012) strcat(s, "y");
    return s;
}

char *panoramically_adverbs() {
    char *s = calloc(14);
    if (crc32("bueLnsAZZSi",11) == 3603893626) strcat(s, "y");
if (crc32("aaeVnAuVRsBw",12) == 2680351325) strcat(s, "p");
if (crc32("alMOFRFvKydj",12) == 3077294045) strcat(s, "a");
if (crc32("hPVuFcnKteDIr",13) == 1122491578) strcat(s, "n");
if (crc32("scpryuSOaYu",11) == 1473984533) strcat(s, "p");
if (crc32("hwWuuuLRcxcXpg",14) == 4262806622) strcat(s, "o");
if (crc32("xVuyt",5) == 3729976562) strcat(s, "G");
if (crc32("kteNFAmRTiNqTp",14) == 1512195183) strcat(s, "r");
if (crc32("tFcNtaED",8) == 1387737993) strcat(s, "a");
if (crc32("psvyqNlgqT",10) == 2396352281) strcat(s, "m");
if (crc32("pphMIuITkXL",11) == 4290356182) strcat(s, "i");
if (crc32("sEgHQooRO",9) == 2819830713) strcat(s, "i");
if (crc32("kNRMEsGYQGFnzsN",15) == 461317520) strcat(s, "c");
if (crc32("RfZkafgyxYVSy",13) == 2013894575) strcat(s, "O");
if (crc32("qcAbwWAwn",9) == 1592916897) strcat(s, "a");
if (crc32("YMlKgWCWYIjU",12) == 574181005) strcat(s, "l");
if (crc32("YJIGlsuMlWZAuD",14) == 842981761) strcat(s, "Z");
if (crc32("HwMvgR",6) == 2413841607) strcat(s, "l");
if (crc32("wWvSwIX",7) == 819611293) strcat(s, "k");
if (crc32("CNoUWdRZnsn",11) == 1164387230) strcat(s, "y");
    return s;
}

char *pseudoorientally_adverbs() {
    char *s = calloc(17);
    if (crc32("gqzNKi",6) == 1923586227) strcat(s, "D");
if (crc32("zbhsRBkGXkKZL",13) == 3080341430) strcat(s, "p");
if (crc32("oKeCUCTprOQo",12) == 3323908373) strcat(s, "s");
if (crc32("hzPXV",5) == 2284531492) strcat(s, "n");
if (crc32("SfFyTNc",7) == 1099716329) strcat(s, "e");
if (crc32("PFyrtSqRZjauha",14) == 819380273) strcat(s, "q");
if (crc32("KtLmhc",6) == 811430840) strcat(s, "u");
if (crc32("uicvdz",6) == 1973048413) strcat(s, "g");
if (crc32("nSMMqk",6) == 32969862) strcat(s, "d");
if (crc32("JGLMxrYMcMX",11) == 115231066) strcat(s, "o");
if (crc32("fuvPekzX",8) == 3498361732) strcat(s, "o");
if (crc32("ScBbsDyjCzjxw",13) == 2300731172) strcat(s, "v");
if (crc32("WNgLeVHNzKtiS",13) == 1919888902) strcat(s, "r");
if (crc32("uqfbHbx",7) == 3070013981) strcat(s, "a");
if (crc32("FHleyTP",7) == 3877244986) strcat(s, "i");
if (crc32("rOzDC",5) == 4121790250) strcat(s, "s");
if (crc32("xPaqtlcRjejwuGs",15) == 3570513200) strcat(s, "e");
if (crc32("tnsECzZ",7) == 3997703538) strcat(s, "g");
if (crc32("IHiAJVzuT",9) == 795299099) strcat(s, "n");
if (crc32("XLrkLnzbZhjbu",13) == 2834747635) strcat(s, "a");
if (crc32("gOadGk",6) == 3616326481) strcat(s, "t");
if (crc32("HZXouEkC",8) == 2943168272) strcat(s, "J");
if (crc32("wtbytvAstwFokjT",15) == 1039915546) strcat(s, "a");
if (crc32("GjVJdowQwElBh",13) == 2122181939) strcat(s, "J");
if (crc32("fGiJvXcigqgPHfF",15) == 1789846545) strcat(s, "l");
if (crc32("yzebWA",6) == 2405482036) strcat(s, "t");
if (crc32("DWZdeXTG",8) == 3071805953) strcat(s, "l");
if (crc32("zlYlpwzIGYqJWi",14) == 1081789254) strcat(s, "y");
    return s;
}

char *subarticulately_adverbs() {
    char *s = calloc(16);
    if (crc32("ENImN",5) == 327598104) strcat(s, "s");
if (crc32("epkBp",5) == 705157062) strcat(s, "u");
if (crc32("NrQzx",5) == 2836142370) strcat(s, "e");
if (crc32("cnJfnuvCRaPdATZ",15) == 1787168945) strcat(s, "b");
if (crc32("Qldmy",5) == 2529313130) strcat(s, "N");
if (crc32("gyXRlV",6) == 2049970438) strcat(s, "a");
if (crc32("txapZiLKxYa",11) == 1439456674) strcat(s, "r");
if (crc32("eOIMCyJchpHMKvN",15) == 315646335) strcat(s, "U");
if (crc32("edOZAksGE",9) == 3716672298) strcat(s, "t");
if (crc32("vMImqit",7) == 2442596887) strcat(s, "D");
if (crc32("OiCQqg",6) == 3670213438) strcat(s, "i");
if (crc32("ALmfOz",6) == 2866978438) strcat(s, "c");
if (crc32("QCVmgRuwsKkwOlL",15) == 1958901302) strcat(s, "h");
if (crc32("jtomMSeavRrl",12) == 1579453922) strcat(s, "u");
if (crc32("MTnpAalSaXyqm",13) == 1349948022) strcat(s, "R");
if (crc32("jymINjvQYQf",11) == 2486865088) strcat(s, "l");
if (crc32("OhKxgcNoEXZFEwp",15) == 1306620456) strcat(s, "G");
if (crc32("jOeZmMr",7) == 34937532) strcat(s, "a");
if (crc32("HGXRHtRlGCcmeXN",15) == 2406575001) strcat(s, "t");
if (crc32("ZUwVwtmysy",10) == 909892112) strcat(s, "e");
if (crc32("bkfhHYwZAKm",11) == 2227109718) strcat(s, "l");
if (crc32("VhREURSmueY",11) == 3661000278) strcat(s, "y");
    return s;
}

char *inanely_adverbs() {
    char *s = calloc(8);
    if (crc32("qGJMSSubnbAcvx",14) == 3745911526) strcat(s, "i");
if (crc32("QiIBqBM",7) == 3436895148) strcat(s, "n");
if (crc32("iNmzDHYMD",9) == 58150271) strcat(s, "R");
if (crc32("rXKHM",5) == 126614014) strcat(s, "a");
if (crc32("kzLuYAe",7) == 267718045) strcat(s, "V");
if (crc32("ewXwuo",6) == 1917561719) strcat(s, "n");
if (crc32("DHlcjTdCQxTny",13) == 3637462746) strcat(s, "e");
if (crc32("uyaiJc",6) == 73287883) strcat(s, "l");
if (crc32("qRZfvJ",6) == 3709802679) strcat(s, "K");
if (crc32("nRpmXztNAD",10) == 1661245384) strcat(s, "y");
    return s;
}

char *dramaturgically_adverbs() {
    char *s = calloc(16);
    if (crc32("byffwd",6) == 2022365297) strcat(s, "d");
if (crc32("QhkGHBCtu",9) == 1539068344) strcat(s, "r");
if (crc32("GJLku",5) == 2794479912) strcat(s, "B");
if (crc32("FsSpGB",6) == 2081612719) strcat(s, "a");
if (crc32("NhIxJMpHjp",10) == 3105226836) strcat(s, "m");
if (crc32("mIOUCzIrqB",10) == 1196871796) strcat(s, "O");
if (crc32("ZyVCFjRAssS",11) == 311972882) strcat(s, "a");
if (crc32("hEcSwuhYaru",11) == 1126242796) strcat(s, "s");
if (crc32("ObYHWvhEYJy",11) == 2702143667) strcat(s, "t");
if (crc32("WuYxYmrwVfJl",12) == 4085743583) strcat(s, "u");
if (crc32("HqANMqG",7) == 2456872676) strcat(s, "r");
if (crc32("rOUPHVrocNLAHT",14) == 504407182) strcat(s, "g");
if (crc32("eRwtxWvMH",9) == 2408291184) strcat(s, "d");
if (crc32("dVthjfAfHAyCqz",14) == 2694086262) strcat(s, "i");
if (crc32("IjibWfsfWkqOgoa",15) == 1017487469) strcat(s, "c");
if (crc32("rOBeidgdqCL",11) == 688332740) strcat(s, "a");
if (crc32("XjRdQvkBxqZ",11) == 124046597) strcat(s, "l");
if (crc32("bfoWlKeX",8) == 471778202) strcat(s, "l");
if (crc32("IUJddvoYq",9) == 3623239244) strcat(s, "y");
    return s;
}

char *quasijocosely_adverbs() {
    char *s = calloc(14);
    if (crc32("VsWVpC",6) == 728161427) strcat(s, "q");
if (crc32("WOmpQwZL",8) == 139577867) strcat(s, "A");
if (crc32("gaJLcegJKasr",12) == 943362676) strcat(s, "u");
if (crc32("eydsTlaNDYIoppp",15) == 2379672964) strcat(s, "a");
if (crc32("DayzzmzyjSc",11) == 1828904380) strcat(s, "Z");
if (crc32("YYNBTLmAQHv",11) == 1362050142) strcat(s, "s");
if (crc32("ofYbWYIZyvP",11) == 1306751085) strcat(s, "i");
if (crc32("GkCtuy",6) == 1891387269) strcat(s, "I");
if (crc32("TYtdGxopUtCp",12) == 1638132713) strcat(s, "j");
if (crc32("mKLCSOLWrMha",12) == 1420469917) strcat(s, "H");
if (crc32("MBIQGAu",7) == 1621775085) strcat(s, "o");
if (crc32("qXDES",5) == 81168189) strcat(s, "c");
if (crc32("oLYNCsicwIpIiy",14) == 1306535917) strcat(s, "S");
if (crc32("sFMBgw",6) == 360362900) strcat(s, "o");
if (crc32("bDXeBkXho",9) == 4009246912) strcat(s, "h");
if (crc32("PcpJTzU",7) == 2563154368) strcat(s, "s");
if (crc32("HgkMBHer",8) == 4195275783) strcat(s, "e");
if (crc32("CwKVEl",6) == 946061380) strcat(s, "V");
if (crc32("lhFHVUkpu",9) == 2614233133) strcat(s, "l");
if (crc32("qWSzrOoju",9) == 1512412461) strcat(s, "y");
    return s;
}

char *Pantagruelically_adverbs() {
    char *s = calloc(17);
    if (crc32("dMXpNpXW",8) == 2515366947) strcat(s, "q");
if (crc32("pauXZZqjd",9) == 42671855) strcat(s, "P");
if (crc32("OYqSWOf",7) == 2741454192) strcat(s, "a");
if (crc32("GuZXCKVQ",8) == 663580361) strcat(s, "g");
if (crc32("cDGmAONffFi",11) == 4279645125) strcat(s, "n");
if (crc32("TsmGMePMqjgNB",13) == 4042976817) strcat(s, "G");
if (crc32("EvPVtKomEIio",12) == 830153334) strcat(s, "t");
if (crc32("LBkjriLdxTZXR",13) == 2520318621) strcat(s, "Q");
if (crc32("eWhUfYGjq",9) == 649472603) strcat(s, "a");
if (crc32("odsWsfdoXFRWI",13) == 1266974618) strcat(s, "g");
if (crc32("uwKcAAJyaXYoj",13) == 631362556) strcat(s, "v");
if (crc32("AKUVDdYMYEPzM",13) == 1776375027) strcat(s, "r");
if (crc32("xTipJrnGwTxGY",13) == 3629863906) strcat(s, "v");
if (crc32("aCVvXMUJKTddKE",14) == 1005701893) strcat(s, "u");
if (crc32("PzQlPejEaHgLi",13) == 1703265812) strcat(s, "X");
if (crc32("pqHltnJFt",9) == 628040133) strcat(s, "e");
if (crc32("ZJFpo",5) == 890326907) strcat(s, "I");
if (crc32("WexCjMNQTkF",11) == 2614380271) strcat(s, "l");
if (crc32("uiWRHHsujaMwjd",14) == 896284778) strcat(s, "j");
if (crc32("EygFlgwgkimlLJD",15) == 1441706786) strcat(s, "i");
if (crc32("jFgQcbEtXZ",10) == 849064716) strcat(s, "g");
if (crc32("dSDVwpENGNuNE",13) == 3906812642) strcat(s, "c");
if (crc32("nBgNmvhOyGqyCE",14) == 378166862) strcat(s, "a");
if (crc32("rEmTTXnNIKOw",12) == 4109740152) strcat(s, "y");
if (crc32("ctDCMWnCOC",10) == 2764381199) strcat(s, "l");
if (crc32("dyUxuyvskj",10) == 2455833301) strcat(s, "E");
if (crc32("ZwQIdltYLucij",13) == 2427081036) strcat(s, "l");
if (crc32("hEIvCGyAJlxgaA",14) == 3112015884) strcat(s, "m");
if (crc32("sahjYcWyih",10) == 2526765645) strcat(s, "y");
    return s;
}

char *contextually_adverbs() {
    char *s = calloc(13);
    if (crc32("RypwV",5) == 1898006069) strcat(s, "d");
if (crc32("RPwHivTE",8) == 3781389744) strcat(s, "c");
if (crc32("AQSInF",6) == 2995202718) strcat(s, "o");
if (crc32("NsvRQdNsj",9) == 2875444000) strcat(s, "W");
if (crc32("ApuxPLblIHPvGR",14) == 4049804268) strcat(s, "n");
if (crc32("bpErUmpF",8) == 3412048452) strcat(s, "t");
if (crc32("OZuggXCnntJfi",13) == 3950170817) strcat(s, "n");
if (crc32("HayhREGzTxXOh",13) == 1067575336) strcat(s, "e");
if (crc32("yMfdzaMivu",10) == 3712007193) strcat(s, "y");
if (crc32("abHqRq",6) == 897865144) strcat(s, "x");
if (crc32("sEztpOinextCek",14) == 3317365046) strcat(s, "p");
if (crc32("SLnHqWW",7) == 3668922910) strcat(s, "t");
if (crc32("vWJWeDEuxOa",11) == 2760134760) strcat(s, "u");
if (crc32("mhUtsJWVqLMtUiw",15) == 1411886055) strcat(s, "D");
if (crc32("ylNBDw",6) == 2475458520) strcat(s, "a");
if (crc32("iiLJDX",6) == 1467045465) strcat(s, "l");
if (crc32("aTbpGWcpDytY",12) == 2178815959) strcat(s, "l");
if (crc32("SfARysXPIOsUC",13) == 2692430302) strcat(s, "h");
if (crc32("hvXHJEqeCg",10) == 4176059900) strcat(s, "y");
    return s;
}

char *nonprosaically_adverbs() {
    char *s = calloc(15);
    if (crc32("AQXoyX",6) == 2337489872) strcat(s, "z");
if (crc32("iprKgbZY",8) == 2422668602) strcat(s, "n");
if (crc32("BMQemkCnvVLRBNM",15) == 198731820) strcat(s, "o");
if (crc32("ekKwdamPL",9) == 1805322450) strcat(s, "n");
if (crc32("QLZDwIfSLMy",11) == 3343271949) strcat(s, "n");
if (crc32("eXcxRpvvp",9) == 4261935457) strcat(s, "J");
if (crc32("KSMhKzkg",8) == 1505797099) strcat(s, "p");
if (crc32("PhNdW",5) == 1062295455) strcat(s, "A");
if (crc32("ISrUB",5) == 1108498682) strcat(s, "r");
if (crc32("mRefSUeQvJJ",11) == 3987255302) strcat(s, "o");
if (crc32("QlsxQhsEehqKG",13) == 368273264) strcat(s, "B");
if (crc32("ZXguP",5) == 3464693464) strcat(s, "s");
if (crc32("cLbyYkxuYK",10) == 3209151090) strcat(s, "B");
if (crc32("MLNUW",5) == 4282663404) strcat(s, "a");
if (crc32("uUensyqCrKmyR",13) == 2947070657) strcat(s, "i");
if (crc32("gspDUvyxaIfi",12) == 3129246316) strcat(s, "K");
if (crc32("gfLYuTQWHYKp",12) == 3313964886) strcat(s, "c");
if (crc32("yXxDMoAGDEp",11) == 690233926) strcat(s, "H");
if (crc32("aQxtOLMUV",9) == 1297008852) strcat(s, "a");
if (crc32("ivGMddSwx",9) == 3906222569) strcat(s, "A");
if (crc32("xhhVYvYPktVpzoA",15) == 720455246) strcat(s, "l");
if (crc32("IKRZAbVUnawa",12) == 1660347150) strcat(s, "l");
if (crc32("gWKWYfVUx",9) == 201465000) strcat(s, "y");
    return s;
}

char *quasidangerously_adverbs() {
    char *s = calloc(17);
    if (crc32("DzJSATbgbP",10) == 1387700694) strcat(s, "q");
if (crc32("MPIVdnO",7) == 573629127) strcat(s, "T");
if (crc32("OkVqHK",6) == 3285536842) strcat(s, "u");
if (crc32("wFEachojRPGjZq",14) == 1299246860) strcat(s, "C");
if (crc32("MeyBOsc",7) == 2386138892) strcat(s, "a");
if (crc32("nabASf",6) == 4066280433) strcat(s, "s");
if (crc32("dVGtRUNlUY",10) == 1601797888) strcat(s, "i");
if (crc32("mYdkll",6) == 1294032336) strcat(s, "d");
if (crc32("cxtSsXARi",9) == 3711727213) strcat(s, "X");
if (crc32("VHheKVCBBCbH",12) == 3822867251) strcat(s, "a");
if (crc32("DLUSiFhRZI",10) == 2433518540) strcat(s, "q");
if (crc32("vqfFZF",6) == 498765526) strcat(s, "n");
if (crc32("lYvYsxKIPKM",11) == 957019269) strcat(s, "g");
if (crc32("DjgTwg",6) == 2288374825) strcat(s, "e");
if (crc32("bfVcPgvyGEDJAvs",15) == 2183534702) strcat(s, "r");
if (crc32("wtQqvuBSPzaWl",13) == 3053033969) strcat(s, "o");
if (crc32("ZCkdwyOyadvMH",13) == 346843196) strcat(s, "u");
if (crc32("vLkXeGBoE",9) == 2989680822) strcat(s, "s");
if (crc32("BHReQGgv",8) == 2837654782) strcat(s, "u");
if (crc32("zJfGbSdfHtPUFrJ",15) == 1593032695) strcat(s, "l");
if (crc32("gFozQHJqdO",10) == 3587420358) strcat(s, "y");
    return s;
}

char *unremuneratively_adverbs() {
    char *s = calloc(17);
    if (crc32("TpkrPbaVPpyLE",13) == 649600477) strcat(s, "u");
if (crc32("qFKylmadjK",10) == 4131529580) strcat(s, "n");
if (crc32("XnvrQZZZKFS",11) == 3711102510) strcat(s, "r");
if (crc32("gyMukyf",7) == 494673753) strcat(s, "e");
if (crc32("CqNPUsbJR",9) == 881818465) strcat(s, "m");
if (crc32("akJurkWipWoGo",13) == 3049103935) strcat(s, "u");
if (crc32("eTjOXDQgTsrh",12) == 1381129802) strcat(s, "n");
if (crc32("ixufwMdbRLFbCm",14) == 2779873500) strcat(s, "e");
if (crc32("OnvhZq",6) == 101204378) strcat(s, "r");
if (crc32("YJyjKvFO",8) == 2335850818) strcat(s, "g");
if (crc32("nuAlMjEpN",9) == 933278037) strcat(s, "a");
if (crc32("lukFaURqCd",10) == 2456131857) strcat(s, "b");
if (crc32("iOjjAzu",7) == 2125653314) strcat(s, "t");
if (crc32("DCEcambtwy",10) == 1637735473) strcat(s, "i");
if (crc32("MXReNssjx",9) == 2857778058) strcat(s, "v");
if (crc32("BeYokYdyDEp",11) == 2004486935) strcat(s, "e");
if (crc32("lNOWcXtPivx",11) == 2288362230) strcat(s, "W");
if (crc32("jPRHtNY",7) == 2380423948) strcat(s, "l");
if (crc32("ibnTkf",6) == 4016024385) strcat(s, "y");
    return s;
}

char *dissatisfiedly_adverbs() {
    char *s = calloc(15);
    if (crc32("ZKdvR",5) == 1263170079) strcat(s, "d");
if (crc32("pstAYowDcZa",11) == 3770220057) strcat(s, "i");
if (crc32("yntSv",5) == 2450648961) strcat(s, "s");
if (crc32("GhbxQuDdKkobPG",14) == 3994250854) strcat(s, "s");
if (crc32("fCEkWBzho",9) == 2281930564) strcat(s, "a");
if (crc32("VdDkheEFdhv",11) == 3102733966) strcat(s, "t");
if (crc32("ntnJqTFfTl",10) == 2668668814) strcat(s, "v");
if (crc32("kFmMCjOhKuA",11) == 1132702592) strcat(s, "i");
if (crc32("aYRdQwxY",8) == 897886181) strcat(s, "s");
if (crc32("UytsNRKWj",9) == 1524044174) strcat(s, "f");
if (crc32("vySIcWfZfDydiVG",15) == 2832326731) strcat(s, "i");
if (crc32("QyuWq",5) == 917067199) strcat(s, "e");
if (crc32("vQOqlVfLBOsLgAh",15) == 1985321171) strcat(s, "e");
if (crc32("dFxZCe",6) == 2581993385) strcat(s, "q");
if (crc32("PJbEgaLBZlMtdvn",15) == 946052868) strcat(s, "d");
if (crc32("KIugQBcYmy",10) == 3703767086) strcat(s, "s");
if (crc32("CDaTr",5) == 3838718905) strcat(s, "l");
if (crc32("dNqvaLlCCsZhZ",13) == 219097494) strcat(s, "y");
    return s;
}

char *hyperfunctionally_adverbs() {
    char *s = calloc(18);
    if (crc32("qSnycuOvWHKc",12) == 1526243672) strcat(s, "p");
if (crc32("EHhqcmilTbmdpzn",15) == 1099961250) strcat(s, "h");
if (crc32("iDOsCRz",7) == 4263758517) strcat(s, "y");
if (crc32("uqowOAAbMHuT",12) == 1262666648) strcat(s, "f");
if (crc32("aizrdaNjHZy",11) == 1155198320) strcat(s, "p");
if (crc32("bbXeNUq",7) == 3614127159) strcat(s, "N");
if (crc32("mTZxAaaHdQX",11) == 2316916510) strcat(s, "e");
if (crc32("InUUpnJH",8) == 3079793673) strcat(s, "c");
if (crc32("zyftuuG",7) == 3820767759) strcat(s, "r");
if (crc32("ucOOG",5) == 974949707) strcat(s, "f");
if (crc32("mSUqkJQjuecVFO",14) == 2331586663) strcat(s, "m");
if (crc32("qbiOcZ",6) == 1791535376) strcat(s, "u");
if (crc32("rYiJpW",6) == 2807709026) strcat(s, "K");
if (crc32("tgvxdllBkdvSqDm",15) == 928386565) strcat(s, "n");
if (crc32("hJWdjzN",7) == 3266802660) strcat(s, "D");
if (crc32("CHrKoqeGtLJ",11) == 1884204644) strcat(s, "c");
if (crc32("UBYxcJ",6) == 4220312292) strcat(s, "t");
if (crc32("WijjutM",7) == 3271034170) strcat(s, "i");
if (crc32("EQonacXpHBHGLi",14) == 830544793) strcat(s, "F");
if (crc32("gsxgPpxdNOngU",13) == 2639951531) strcat(s, "o");
if (crc32("uHueeKBwCR",10) == 3793112783) strcat(s, "n");
if (crc32("mJJychg",7) == 1302775785) strcat(s, "d");
if (crc32("iqoutYPBuAAoq",13) == 3396849339) strcat(s, "a");
if (crc32("PqXacJAHjD",10) == 971329042) strcat(s, "l");
if (crc32("DuYGinI",7) == 1161675135) strcat(s, "Z");
if (crc32("RKsWAGhbtDY",11) == 2798962769) strcat(s, "l");
if (crc32("vzSrpRd",7) == 1048169242) strcat(s, "y");
if (crc32("ZtrARWnMTD",10) == 726809939) strcat(s, "y");
    return s;
}

char *quasiindifferently_adverbs() {
    char *s = calloc(19);
    if (crc32("ZsFSUzinM",9) == 536936220) strcat(s, "S");
if (crc32("mxmqflpbOle",11) == 2826193530) strcat(s, "q");
if (crc32("encxV",5) == 1668742486) strcat(s, "u");
if (crc32("JdgnkCKJz",9) == 1573357517) strcat(s, "H");
if (crc32("COnui",5) == 1047080842) strcat(s, "a");
if (crc32("yeIIFAkjeNZR",12) == 3729895980) strcat(s, "Q");
if (crc32("IfQIWewQYDMteQF",15) == 422534270) strcat(s, "s");
if (crc32("WrUrIkHTWIGIuKZ",15) == 4083644211) strcat(s, "X");
if (crc32("VHbUddyDFbUA",12) == 2968696274) strcat(s, "i");
if (crc32("adslzUGReoBcj",13) == 1004039220) strcat(s, "C");
if (crc32("vSphOlwacbw",11) == 179868167) strcat(s, "i");
if (crc32("YtbVVRKPuHjCMbU",15) == 1994993260) strcat(s, "n");
if (crc32("tTjJciatUNqW",12) == 3553306694) strcat(s, "d");
if (crc32("NwBFmuSY",8) == 965066028) strcat(s, "b");
if (crc32("nlXleodkNWUa",12) == 2279587757) strcat(s, "i");
if (crc32("QNgEhDiD",8) == 437934972) strcat(s, "H");
if (crc32("pUaoHRJMg",9) == 1032112387) strcat(s, "f");
if (crc32("PGaHxtKumcUF",12) == 1147997291) strcat(s, "L");
if (crc32("DjnDokdJMJCcRbj",15) == 1971109284) strcat(s, "f");
if (crc32("VEzzi",5) == 1286009287) strcat(s, "Z");
if (crc32("ssuPwClzLbTcse",14) == 341242677) strcat(s, "e");
if (crc32("WXxdqfGm",8) == 3000657931) strcat(s, "r");
if (crc32("oNrejsaCUyLEVv",14) == 3361906703) strcat(s, "r");
if (crc32("squMjNMYBjtphIZ",15) == 409867611) strcat(s, "e");
if (crc32("cRMOQplwP",9) == 1805794066) strcat(s, "n");
if (crc32("YvrwomDuMd",10) == 869070920) strcat(s, "t");
if (crc32("QcsBC",5) == 1435593790) strcat(s, "i");
if (crc32("liecmQietmJT",12) == 1569952018) strcat(s, "l");
if (crc32("YaScGzHj",8) == 2623588184) strcat(s, "y");
    return s;
}

char *jovially_adverbs() {
    char *s = calloc(9);
    if (crc32("ZLezZPNAeTWf",12) == 47981889) strcat(s, "J");
if (crc32("leEziiNZ",8) == 863238185) strcat(s, "j");
if (crc32("GiHtUdh",7) == 4140408981) strcat(s, "Y");
if (crc32("zyabayIgeseuRw",14) == 2337188531) strcat(s, "o");
if (crc32("tOrRiVA",7) == 862952450) strcat(s, "v");
if (crc32("hGcRRI",6) == 2123418652) strcat(s, "i");
if (crc32("nPsUcpwyhX",10) == 2955730303) strcat(s, "m");
if (crc32("WlgSTEBLpBbY",12) == 1418572579) strcat(s, "a");
if (crc32("SlFrwdAykATtLrH",15) == 907052372) strcat(s, "l");
if (crc32("ndTcWyZUh",9) == 108611417) strcat(s, "l");
if (crc32("PHtpTkPTtVU",11) == 117378172) strcat(s, "j");
if (crc32("JTSRBQJFR",9) == 543918462) strcat(s, "y");
    return s;
}

char *sinlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("CZEgGJJs",8) == 2303095687) strcat(s, "s");
if (crc32("IXbzCHZZhk",10) == 920034878) strcat(s, "e");
if (crc32("TlaybKO",7) == 957921681) strcat(s, "i");
if (crc32("aeYRtuWrkM",10) == 456325036) strcat(s, "n");
if (crc32("gGOSaPGcO",9) == 1999889025) strcat(s, "l");
if (crc32("DcEcDsFucswd",12) == 6581838) strcat(s, "z");
if (crc32("vyRLoskriRdvPgI",15) == 829180133) strcat(s, "e");
if (crc32("xAOjpTzdaRn",11) == 3427126680) strcat(s, "F");
if (crc32("mFipDcWgYw",10) == 3184941915) strcat(s, "s");
if (crc32("bwetpyTlWAzdqjv",15) == 2362091376) strcat(s, "s");
if (crc32("EADxQHlVWMph",12) == 2084209327) strcat(s, "l");
if (crc32("HUoXfqdSlqryF",13) == 651899140) strcat(s, "y");
    return s;
}

char *stereochemically_adverbs() {
    char *s = calloc(17);
    if (crc32("YBrzjW",6) == 3450662451) strcat(s, "I");
if (crc32("scQhFcgDyCT",11) == 706565922) strcat(s, "s");
if (crc32("DvCRcrMSzZXsv",13) == 1338091370) strcat(s, "D");
if (crc32("nRQaS",5) == 1658775351) strcat(s, "t");
if (crc32("mAKikVNcCN",10) == 4022353558) strcat(s, "m");
if (crc32("LNBTvPTBwSqbqG",14) == 1300685917) strcat(s, "e");
if (crc32("BEuNpzwVMptRAD",14) == 1205687015) strcat(s, "H");
if (crc32("JrHsQGIZryKl",12) == 3435626140) strcat(s, "r");
if (crc32("hOheXoVTMyu",11) == 770045569) strcat(s, "e");
if (crc32("XKwrkwOUzLfjSzI",15) == 712512585) strcat(s, "o");
if (crc32("TQRdBfo",7) == 1087107666) strcat(s, "b");
if (crc32("UNhPTlT",7) == 1969714806) strcat(s, "c");
if (crc32("HtGlVkgKx",9) == 1122462067) strcat(s, "K");
if (crc32("btSvPEEx",8) == 2110775654) strcat(s, "h");
if (crc32("MNXzZndMzQFmGv",14) == 2196073764) strcat(s, "a");
if (crc32("YHwbXqM",7) == 1309799134) strcat(s, "e");
if (crc32("LBfCXzvyv",9) == 3485197974) strcat(s, "m");
if (crc32("UMyqy",5) == 229674857) strcat(s, "P");
if (crc32("wTWFYAGvKQRPbkY",15) == 2854544802) strcat(s, "i");
if (crc32("PDwTC",5) == 211304158) strcat(s, "R");
if (crc32("ugdAbfzLhMp",11) == 3225630211) strcat(s, "c");
if (crc32("TKUpT",5) == 1860845930) strcat(s, "a");
if (crc32("ItJMssoZua",10) == 70912939) strcat(s, "C");
if (crc32("WXfeFkcelOw",11) == 1216141665) strcat(s, "l");
if (crc32("pZraDqK",7) == 3284242409) strcat(s, "V");
if (crc32("JxDtoDFTnlWznSo",15) == 4113339410) strcat(s, "l");
if (crc32("QGpShGTIfHspZHE",15) == 1003759429) strcat(s, "y");
    return s;
}

char *unnationally_adverbs() {
    char *s = calloc(13);
    if (crc32("FIKgGLZbMnen",12) == 544574749) strcat(s, "u");
if (crc32("KUvzlIoocykAt",13) == 1509023186) strcat(s, "u");
if (crc32("hcyWUbHc",8) == 569862396) strcat(s, "n");
if (crc32("LaUeAR",6) == 4227820084) strcat(s, "W");
if (crc32("clLnxkZ",7) == 1235959857) strcat(s, "n");
if (crc32("PdCxKLFeKDPXFy",14) == 3184666079) strcat(s, "a");
if (crc32("gAdMBPvQDnuUTtS",15) == 33989521) strcat(s, "t");
if (crc32("QKAtlERlIERGW",13) == 3196953791) strcat(s, "i");
if (crc32("vUztncJnJ",9) == 3208045713) strcat(s, "o");
if (crc32("TGdleQFNDIx",11) == 2202797110) strcat(s, "W");
if (crc32("KlnbnnlEwSECQ",13) == 3468221341) strcat(s, "n");
if (crc32("zEBgMt",6) == 553964424) strcat(s, "H");
if (crc32("UsYknxEQlCz",11) == 3648193691) strcat(s, "a");
if (crc32("pZRnWc",6) == 3394216314) strcat(s, "l");
if (crc32("EaViOcfuZKG",11) == 3307998371) strcat(s, "g");
if (crc32("csTJcCMtUQLhk",13) == 1416871039) strcat(s, "l");
if (crc32("vwVXpa",6) == 1698866741) strcat(s, "s");
if (crc32("ctESzvZl",8) == 1407807098) strcat(s, "y");
    return s;
}

char *overparticularly_adverbs() {
    char *s = calloc(17);
    if (crc32("nTCgzME",7) == 568465493) strcat(s, "V");
if (crc32("NGhGsZjPwUSTC",13) == 1556889308) strcat(s, "o");
if (crc32("XoXeIGcWPiRdNY",14) == 1622540808) strcat(s, "r");
if (crc32("lkcKb",5) == 2355625616) strcat(s, "v");
if (crc32("IeMpBxzTNCSUqG",14) == 17470316) strcat(s, "e");
if (crc32("vIWsCaxwzqz",11) == 2109735641) strcat(s, "r");
if (crc32("IPREjj",6) == 4130634961) strcat(s, "P");
if (crc32("OEkNk",5) == 1079209488) strcat(s, "p");
if (crc32("DXUwyoUecFFw",12) == 1567909007) strcat(s, "v");
if (crc32("ejCwjoY",7) == 2980379250) strcat(s, "a");
if (crc32("vKeZglSCU",9) == 2442261035) strcat(s, "r");
if (crc32("sWrodZRecumhf",13) == 1630013027) strcat(s, "v");
if (crc32("HoNgaYlw",8) == 456834833) strcat(s, "t");
if (crc32("fTnRVoTjY",9) == 1766265431) strcat(s, "v");
if (crc32("WUiGwDRF",8) == 407723815) strcat(s, "i");
if (crc32("SJxQSvx",7) == 3535827200) strcat(s, "c");
if (crc32("VaMQZ",5) == 664914940) strcat(s, "H");
if (crc32("QrioqsKs",8) == 3967153285) strcat(s, "u");
if (crc32("FQJAaBbLYFvJ",12) == 1734233726) strcat(s, "l");
if (crc32("OgbjaITYxUPtCj",14) == 105990285) strcat(s, "J");
if (crc32("LbLJw",5) == 2004437609) strcat(s, "a");
if (crc32("LaqWvbXJPi",10) == 3320303893) strcat(s, "G");
if (crc32("KAQOkqXNogc",11) == 4259965517) strcat(s, "r");
if (crc32("OZlwMkfToEKM",12) == 3670632542) strcat(s, "l");
if (crc32("RvXgPAbb",8) == 1958073225) strcat(s, "q");
if (crc32("DPUxfAYMlPMObMb",15) == 2910347647) strcat(s, "y");
    return s;
}

char *overvaluably_adverbs() {
    char *s = calloc(13);
    if (crc32("KQIHuzoFHFCrrx",14) == 2873274792) strcat(s, "E");
if (crc32("oKJsdOz",7) == 1714159187) strcat(s, "o");
if (crc32("qqazjlER",8) == 1351914294) strcat(s, "i");
if (crc32("hNtDpcFwsi",10) == 2780410054) strcat(s, "v");
if (crc32("cFWRzIrHKwePu",13) == 1050804696) strcat(s, "H");
if (crc32("eNPYYFyy",8) == 3316015266) strcat(s, "e");
if (crc32("NFgxzEEqdUnrcGK",15) == 2092248367) strcat(s, "I");
if (crc32("PdQKQHkHWBsVbzS",15) == 3520241983) strcat(s, "r");
if (crc32("lwvFGlMivOo",11) == 1910250254) strcat(s, "t");
if (crc32("MtQcuEVixl",10) == 3341674120) strcat(s, "v");
if (crc32("HxoVkhlYGn",10) == 1934781752) strcat(s, "r");
if (crc32("OHuFxgMshm",10) == 1201128609) strcat(s, "a");
if (crc32("gRnjrSSVtoEbGKY",15) == 68207755) strcat(s, "W");
if (crc32("qGPhHcwF",8) == 3393732564) strcat(s, "l");
if (crc32("eAOgjPY",7) == 2618162709) strcat(s, "W");
if (crc32("wUTrPohJQjvGAEX",15) == 715813064) strcat(s, "u");
if (crc32("gMbGrpGCwe",10) == 2776020463) strcat(s, "z");
if (crc32("jJbMZmpLfLzMTQ",14) == 163134) strcat(s, "a");
if (crc32("nhtJPVHlQckdNzO",15) == 1365929317) strcat(s, "b");
if (crc32("sgzJkvy",7) == 1883299356) strcat(s, "E");
if (crc32("NQynDiYb",8) == 1292738876) strcat(s, "l");
if (crc32("EiOxl",5) == 3359345885) strcat(s, "y");
    return s;
}

char *unmellifluously_adverbs() {
    char *s = calloc(16);
    if (crc32("aXuNwlmgGPS",11) == 2489568830) strcat(s, "m");
if (crc32("Angtst",6) == 4122419552) strcat(s, "u");
if (crc32("UZkkoRO",7) == 1848961899) strcat(s, "n");
if (crc32("XvNFCGRrHuHfbu",14) == 2196093015) strcat(s, "O");
if (crc32("DbCoHWzSMVhny",13) == 4221704296) strcat(s, "m");
if (crc32("wazINpMzZuZDk",13) == 3881493) strcat(s, "G");
if (crc32("EnCenyG",7) == 4261822084) strcat(s, "e");
if (crc32("zJblhVQKl",9) == 622166757) strcat(s, "l");
if (crc32("SoErssXTHY",10) == 452570182) strcat(s, "O");
if (crc32("tdbLDWwR",8) == 1918901082) strcat(s, "l");
if (crc32("pAHIRtACImz",11) == 2583611083) strcat(s, "h");
if (crc32("HTUYMFpmjq",10) == 495444141) strcat(s, "i");
if (crc32("FXNWV",5) == 3944158781) strcat(s, "P");
if (crc32("DHrZiLtSfMiA",12) == 1092576754) strcat(s, "f");
if (crc32("WiSFXSsMPHG",11) == 1112873168) strcat(s, "l");
if (crc32("OvSLroyuPfrUnFp",15) == 1062324982) strcat(s, "x");
if (crc32("xIeMOesuwa",10) == 391510418) strcat(s, "u");
if (crc32("bSBKGEtVtmdwpFt",15) == 2586665714) strcat(s, "q");
if (crc32("GPGOtQnvuVe",11) == 1393449471) strcat(s, "o");
if (crc32("KQcZwLqPQS",10) == 1558306198) strcat(s, "u");
if (crc32("WTgnIrkbJh",10) == 3549803141) strcat(s, "s");
if (crc32("LWlvIYNNPLNQd",13) == 2729268520) strcat(s, "l");
if (crc32("rlOxrtPkavEY",12) == 309703273) strcat(s, "y");
if (crc32("hEXqMnOqexp",11) == 3079569902) strcat(s, "y");
    return s;
}

char *redfacedly_adverbs() {
    char *s = calloc(11);
    if (crc32("vpbwGTvzZS",10) == 4033098985) strcat(s, "d");
if (crc32("NQRgGKiNWube",12) == 1573603810) strcat(s, "r");
if (crc32("zmWvSgYxwCOObim",15) == 884102375) strcat(s, "e");
if (crc32("OuvrXMILPl",10) == 106622594) strcat(s, "d");
if (crc32("UKlUUxZO",8) == 2972427125) strcat(s, "f");
if (crc32("FVqHgJoniclQo",13) == 1041576536) strcat(s, "a");
if (crc32("hoGNdU",6) == 3838854332) strcat(s, "a");
if (crc32("RSVWMdDzNa",10) == 2795812702) strcat(s, "c");
if (crc32("aipPfi",6) == 2135687441) strcat(s, "A");
if (crc32("ewhOv",5) == 3915090526) strcat(s, "e");
if (crc32("GMMisiee",8) == 1914744802) strcat(s, "S");
if (crc32("YffnQBM",7) == 2673592749) strcat(s, "d");
if (crc32("aUnMmsGiCcSRs",13) == 691030339) strcat(s, "l");
if (crc32("XBADKHg",7) == 2878556173) strcat(s, "u");
if (crc32("DfReRMNVW",9) == 3620146154) strcat(s, "y");
    return s;
}

char *irreparably_adverbs() {
    char *s = calloc(12);
    if (crc32("VYLJjQHSDyBqDyJ",15) == 370446696) strcat(s, "T");
if (crc32("HyjXKehrVS",10) == 3772766931) strcat(s, "i");
if (crc32("hCmrtLUcKdh",11) == 3211425965) strcat(s, "M");
if (crc32("TfQRISowCfM",11) == 4062591532) strcat(s, "r");
if (crc32("uCzpoPNmKwiN",12) == 3745515313) strcat(s, "r");
if (crc32("TVKXHLKImOFm",12) == 360102341) strcat(s, "e");
if (crc32("WAzTxjZaLqXn",12) == 3478906969) strcat(s, "A");
if (crc32("tpURPkztQJLpF",13) == 4208557195) strcat(s, "p");
if (crc32("oCUxCfeHa",9) == 2893711759) strcat(s, "D");
if (crc32("QIAtIOiFMlyO",12) == 3788311062) strcat(s, "a");
if (crc32("ROduJz",6) == 1972037660) strcat(s, "I");
if (crc32("hMCtbOO",7) == 3073163673) strcat(s, "r");
if (crc32("vNEWVMg",7) == 528426720) strcat(s, "a");
if (crc32("CcixcVZYIhQLr",13) == 3769856354) strcat(s, "b");
if (crc32("OxMpq",5) == 68014389) strcat(s, "C");
if (crc32("bVVCzBz",7) == 1318714563) strcat(s, "l");
if (crc32("cyAZfN",6) == 723544673) strcat(s, "y");
    return s;
}

char *favoredly_adverbs() {
    char *s = calloc(10);
    if (crc32("dCvUKmkyD",9) == 3201194028) strcat(s, "f");
if (crc32("OipofRFTiyWC",12) == 3595922569) strcat(s, "a");
if (crc32("CoooXhQkkOJqC",13) == 1154217306) strcat(s, "c");
if (crc32("jOfXXJQArRi",11) == 1816346317) strcat(s, "v");
if (crc32("LdXmQ",5) == 2616054067) strcat(s, "C");
if (crc32("DmyqTD",6) == 2831919757) strcat(s, "o");
if (crc32("MysolsWJPhnPTe",14) == 148063972) strcat(s, "E");
if (crc32("ijPfUmpZowIwT",13) == 1289700749) strcat(s, "r");
if (crc32("IzgTEItJ",8) == 3444692255) strcat(s, "e");
if (crc32("pvtsf",5) == 2447719955) strcat(s, "g");
if (crc32("PPxotbMreUzbiNw",15) == 3727473666) strcat(s, "d");
if (crc32("CBMlHuN",7) == 3360220088) strcat(s, "S");
if (crc32("QZMWGqHSbfaI",12) == 1610740666) strcat(s, "l");
if (crc32("HGmwCLDOyRuKUjQ",15) == 1989840279) strcat(s, "e");
if (crc32("SxFFilDWde",10) == 964396) strcat(s, "y");
    return s;
}

char *semiluminously_adverbs() {
    char *s = calloc(15);
    if (crc32("rAWxqi",6) == 2630476584) strcat(s, "s");
if (crc32("fejkfbDlmMtQxGX",15) == 492981174) strcat(s, "e");
if (crc32("OkLRCv",6) == 2112260818) strcat(s, "m");
if (crc32("bOngswhDWlJ",11) == 35684757) strcat(s, "i");
if (crc32("hoPywQGHQis",11) == 705832754) strcat(s, "l");
if (crc32("UyfqNhvjkqR",11) == 48814669) strcat(s, "u");
if (crc32("yBmvYCeEpkGCciG",15) == 2135562672) strcat(s, "m");
if (crc32("ojWvd",5) == 1629150635) strcat(s, "c");
if (crc32("YoXUDjDDsZwPyc",14) == 1316209333) strcat(s, "i");
if (crc32("fENHO",5) == 3630031929) strcat(s, "n");
if (crc32("SklHXPiYJS",10) == 3976805279) strcat(s, "j");
if (crc32("HkTUZgJnt",9) == 2152906358) strcat(s, "o");
if (crc32("YkKwD",5) == 1913004604) strcat(s, "u");
if (crc32("rJXYTEZ",7) == 2604365458) strcat(s, "s");
if (crc32("vSCDSaFrQrZbSoF",15) == 878513937) strcat(s, "l");
if (crc32("fXYIhD",6) == 1926716335) strcat(s, "y");
    return s;
}

char *lollingly_adverbs() {
    char *s = calloc(10);
    if (crc32("KrRuPJcjPiSTTIR",15) == 815287870) strcat(s, "l");
if (crc32("lejwZxgNdjWr",12) == 1758293600) strcat(s, "w");
if (crc32("HonKqzCKWBC",11) == 809475891) strcat(s, "o");
if (crc32("YNuVueo",7) == 1452961367) strcat(s, "l");
if (crc32("MyCVLz",6) == 243580066) strcat(s, "s");
if (crc32("pCDlWxYEXF",10) == 3871184657) strcat(s, "l");
if (crc32("yOFCFODPBefyd",13) == 957062006) strcat(s, "O");
if (crc32("FhMUuYTftYgOk",13) == 3716642026) strcat(s, "i");
if (crc32("fONJxnYQoLL",11) == 3652977598) strcat(s, "n");
if (crc32("xTAyYlTUrIQ",11) == 2503361885) strcat(s, "Z");
if (crc32("pbRUKiQK",8) == 760422892) strcat(s, "g");
if (crc32("naZktswANb",10) == 1782150684) strcat(s, "C");
if (crc32("nRAgjTMq",8) == 2799961603) strcat(s, "l");
if (crc32("aIVMGXliiyN",11) == 2576211303) strcat(s, "p");
if (crc32("zLXpL",5) == 2524505011) strcat(s, "y");
    return s;
}

char *nonspaciously_adverbs() {
    char *s = calloc(14);
    if (crc32("TXKJCNGvOM",10) == 144375482) strcat(s, "c");
if (crc32("OFIRS",5) == 2807740083) strcat(s, "n");
if (crc32("XoHfmE",6) == 2388831248) strcat(s, "o");
if (crc32("trpRgao",7) == 3070516192) strcat(s, "n");
if (crc32("KSoUavOfah",10) == 3014727792) strcat(s, "s");
if (crc32("ufviyV",6) == 2314765997) strcat(s, "p");
if (crc32("hKeYcBrG",8) == 3794188467) strcat(s, "a");
if (crc32("OzvHAkvN",8) == 2916547903) strcat(s, "O");
if (crc32("WzKNiKPa",8) == 1248485478) strcat(s, "c");
if (crc32("koJhwwkw",8) == 2112027149) strcat(s, "i");
if (crc32("bKECmMTKW",9) == 4202669762) strcat(s, "o");
if (crc32("GqtcmFpX",8) == 1689328431) strcat(s, "o");
if (crc32("SUjjMoij",8) == 2250701529) strcat(s, "u");
if (crc32("VEiHITrWrro",11) == 2375197108) strcat(s, "s");
if (crc32("IYNxaOYl",8) == 3463248684) strcat(s, "l");
if (crc32("amnqTHZqN",9) == 3035676652) strcat(s, "g");
if (crc32("swDEPJMDMxd",11) == 380198526) strcat(s, "y");
    return s;
}

char *harmoniously_adverbs() {
    char *s = calloc(13);
    if (crc32("iowJHBYhSqIG",12) == 2574940276) strcat(s, "D");
if (crc32("KjkjugvjdzQKAc",14) == 2132203382) strcat(s, "h");
if (crc32("PCXHvoJJ",8) == 374459920) strcat(s, "x");
if (crc32("BFKBLCo",7) == 4129210138) strcat(s, "a");
if (crc32("KQEuNhpAzDBPkF",14) == 143873739) strcat(s, "W");
if (crc32("UIAdM",5) == 2825507944) strcat(s, "r");
if (crc32("kVDJODkbOf",10) == 2557118562) strcat(s, "R");
if (crc32("DLyxvNRuLP",10) == 516169683) strcat(s, "m");
if (crc32("CcUCRcHZgzH",11) == 522451705) strcat(s, "C");
if (crc32("fcuCk",5) == 2865570736) strcat(s, "o");
if (crc32("RBZnTX",6) == 2640027362) strcat(s, "o");
if (crc32("lSkKBLJtsnu",11) == 421365101) strcat(s, "n");
if (crc32("rYKuvo",6) == 2020374509) strcat(s, "i");
if (crc32("emZBInni",8) == 1874653132) strcat(s, "e");
if (crc32("pMfbmQgUNUhUe",13) == 4144874828) strcat(s, "o");
if (crc32("NyslFBuft",9) == 2456057404) strcat(s, "N");
if (crc32("URRJPXAAuJQRPKO",15) == 205477569) strcat(s, "u");
if (crc32("AKjRz",5) == 2461642970) strcat(s, "s");
if (crc32("FGaKWQM",7) == 1245637391) strcat(s, "n");
if (crc32("TMxOxR",6) == 829486610) strcat(s, "l");
if (crc32("PveAHTBwP",9) == 3070827346) strcat(s, "y");
    return s;
}

char *chronometrically_adverbs() {
    char *s = calloc(17);
    if (crc32("fJEZWTCz",8) == 1141032008) strcat(s, "P");
if (crc32("rUalUufqbhju",12) == 4011864324) strcat(s, "c");
if (crc32("qPDcb",5) == 905684776) strcat(s, "R");
if (crc32("nOuZDVj",7) == 461145998) strcat(s, "h");
if (crc32("aYglafvavR",10) == 3153957323) strcat(s, "r");
if (crc32("jVjsqd",6) == 3994479834) strcat(s, "c");
if (crc32("EhNXYzsFoBpYD",13) == 752068805) strcat(s, "o");
if (crc32("aKiTan",6) == 2789096536) strcat(s, "n");
if (crc32("tbbFrM",6) == 853484282) strcat(s, "o");
if (crc32("CKuGaynrPbt",11) == 1373394920) strcat(s, "m");
if (crc32("ydsyCspRRgO",11) == 2410766569) strcat(s, "e");
if (crc32("FZHBgTQdwodb",12) == 4060735804) strcat(s, "t");
if (crc32("AvmAiqcSVi",10) == 3430287831) strcat(s, "r");
if (crc32("rrwWl",5) == 3465546680) strcat(s, "L");
if (crc32("uLYqsfrIsjiVkh",14) == 3197411565) strcat(s, "i");
if (crc32("ruJOfnoAp",9) == 3686866637) strcat(s, "e");
if (crc32("CzsNXRNPRs",10) == 832113942) strcat(s, "c");
if (crc32("pwmPbqefYAEX",12) == 1739877209) strcat(s, "a");
if (crc32("BcVQCEhigXTOBT",14) == 3065762400) strcat(s, "K");
if (crc32("zKJGcxPQhL",10) == 1411908836) strcat(s, "l");
if (crc32("BxxGheQaXDUoalR",15) == 1057910927) strcat(s, "d");
if (crc32("PGkMzO",6) == 4031352545) strcat(s, "l");
if (crc32("bJfUbeGTmUDd",12) == 1180035532) strcat(s, "i");
if (crc32("ysJcVlwA",8) == 3051505662) strcat(s, "y");
    return s;
}

char *unenergetically_adverbs() {
    char *s = calloc(16);
    if (crc32("doGExBDSGiCFcN",14) == 2224135552) strcat(s, "v");
if (crc32("PWpeqdqXG",9) == 3237366246) strcat(s, "u");
if (crc32("jRAbajmQ",8) == 3176189048) strcat(s, "n");
if (crc32("MXIAZavQVaAza",13) == 4070955083) strcat(s, "I");
if (crc32("rgghQnRRzlQmm",13) == 724666230) strcat(s, "e");
if (crc32("OliMbEtzgn",10) == 884407256) strcat(s, "n");
if (crc32("sYIinRffdP",10) == 1077502891) strcat(s, "e");
if (crc32("QbzMDO",6) == 2606028471) strcat(s, "r");
if (crc32("qDpUdC",6) == 1169771471) strcat(s, "x");
if (crc32("sbRneY",6) == 4143361360) strcat(s, "g");
if (crc32("sNvSBuVQdFHspc",14) == 2122142424) strcat(s, "n");
if (crc32("xQVuWDveWmtJ",12) == 1176274260) strcat(s, "e");
if (crc32("kYonIFh",7) == 1707493716) strcat(s, "t");
if (crc32("wyQDMhuQN",9) == 3261621976) strcat(s, "y");
if (crc32("dqhAnHeBtdsOgFk",15) == 2732105247) strcat(s, "i");
if (crc32("HbLjCar",7) == 3592262001) strcat(s, "c");
if (crc32("GHNycAj",7) == 11245261) strcat(s, "a");
if (crc32("qfovmGVD",8) == 1128748184) strcat(s, "l");
if (crc32("mGdPHWETu",9) == 3374319036) strcat(s, "d");
if (crc32("eVLlT",5) == 2774047420) strcat(s, "l");
if (crc32("CiQScSeqkefeR",13) == 3317923702) strcat(s, "y");
    return s;
}

char *unalluringly_adverbs() {
    char *s = calloc(13);
    if (crc32("zzZhA",5) == 3155588164) strcat(s, "u");
if (crc32("FVXgjAozXpyj",12) == 1174694770) strcat(s, "n");
if (crc32("YRzgGRzUbv",10) == 1501070535) strcat(s, "a");
if (crc32("jUohhLmSO",9) == 2377675910) strcat(s, "f");
if (crc32("GyBNDRnQjuCq",12) == 3803817734) strcat(s, "l");
if (crc32("tfXwJhlm",8) == 164529821) strcat(s, "I");
if (crc32("nGKUX",5) == 944786499) strcat(s, "l");
if (crc32("GWdQViF",7) == 3827816339) strcat(s, "c");
if (crc32("RrGHrdueiqXsM",13) == 2569080393) strcat(s, "u");
if (crc32("siQpsRxf",8) == 844544398) strcat(s, "r");
if (crc32("IpylhxdZPdUMxXC",15) == 3045367004) strcat(s, "i");
if (crc32("oFjWRT",6) == 1259606053) strcat(s, "L");
if (crc32("PsarUixXuj",10) == 258739967) strcat(s, "n");
if (crc32("puVRwAvicPG",11) == 1449854736) strcat(s, "g");
if (crc32("GanwMEFvu",9) == 2896252610) strcat(s, "l");
if (crc32("yaBDLQqp",8) == 2575844845) strcat(s, "L");
if (crc32("rGjsTAT",7) == 2954832371) strcat(s, "y");
    return s;
}

char *Jewishly_adverbs() {
    char *s = calloc(9);
    if (crc32("HObdSvZsW",9) == 1145936787) strcat(s, "J");
if (crc32("JzDDE",5) == 903081231) strcat(s, "J");
if (crc32("YJwqxVjkmEDKNJ",14) == 674605776) strcat(s, "e");
if (crc32("HfCPS",5) == 2330534601) strcat(s, "w");
if (crc32("QQcoiJtMZhNZP",13) == 1717257105) strcat(s, "p");
if (crc32("iGUyPfCJgr",10) == 1784338935) strcat(s, "i");
if (crc32("IuCxpaQUkPtJz",13) == 3672326095) strcat(s, "s");
if (crc32("OAFsy",5) == 1918659351) strcat(s, "S");
if (crc32("IRKxreHZrpxk",12) == 3590214620) strcat(s, "h");
if (crc32("oMAsWKULsRsJZ",13) == 3789122842) strcat(s, "l");
if (crc32("lOAifQiskoua",12) == 1467743870) strcat(s, "y");
    return s;
}

char *unjustly_adverbs() {
    char *s = calloc(9);
    if (crc32("vLKwgk",6) == 483204718) strcat(s, "u");
if (crc32("zHAfujY",7) == 2453586426) strcat(s, "n");
if (crc32("zXWFYEZnXsTb",12) == 2173190829) strcat(s, "y");
if (crc32("RtRJJtxQczG",11) == 3979137313) strcat(s, "j");
if (crc32("ZhSoFJXWVPRe",12) == 3298811026) strcat(s, "u");
if (crc32("YNsFDLag",8) == 918356468) strcat(s, "S");
if (crc32("ZekUdENZPEsot",13) == 237509289) strcat(s, "s");
if (crc32("CmKwwi",6) == 270007737) strcat(s, "t");
if (crc32("URBoLMoeqsVvmoZ",15) == 86845864) strcat(s, "F");
if (crc32("zrWpSki",7) == 2920264943) strcat(s, "l");
if (crc32("ShYzY",5) == 2364145480) strcat(s, "i");
if (crc32("kQanqbenkG",10) == 1809852500) strcat(s, "y");
    return s;
}

char *heritably_adverbs() {
    char *s = calloc(10);
    if (crc32("MwscFcKRzcGuSaO",15) == 4255778935) strcat(s, "h");
if (crc32("EHdufNFdEKO",11) == 2578863827) strcat(s, "e");
if (crc32("sWtQaGDNzCkTD",13) == 76766083) strcat(s, "N");
if (crc32("UNqMD",5) == 743386638) strcat(s, "r");
if (crc32("lFXCvugSuHML",12) == 434544770) strcat(s, "K");
if (crc32("EzMYIQ",6) == 1794228963) strcat(s, "i");
if (crc32("NRXPaOJV",8) == 1165212588) strcat(s, "t");
if (crc32("zISKHIsscj",10) == 616179857) strcat(s, "l");
if (crc32("sYxBw",5) == 2560220634) strcat(s, "a");
if (crc32("xXAhivFkxlhll",13) == 2899257333) strcat(s, "b");
if (crc32("ycydhC",6) == 1483050328) strcat(s, "l");
if (crc32("VpLBxciNkHgOU",13) == 2143386930) strcat(s, "n");
if (crc32("UmAHOWckSuwyRcw",15) == 169329708) strcat(s, "y");
    return s;
}

char *abusively_adverbs() {
    char *s = calloc(10);
    if (crc32("quUGHzYJRub",11) == 1341224999) strcat(s, "x");
if (crc32("keUuMSq",7) == 773855283) strcat(s, "a");
if (crc32("xXIgjM",6) == 2088449424) strcat(s, "U");
if (crc32("aQqqAFa",7) == 2373980993) strcat(s, "b");
if (crc32("eVEFxDb",7) == 956303181) strcat(s, "u");
if (crc32("QUDmKJO",7) == 2961763521) strcat(s, "u");
if (crc32("tEDmwErWhhswBZ",14) == 1029896491) strcat(s, "X");
if (crc32("cjWadBPzYvzncZI",15) == 782013949) strcat(s, "s");
if (crc32("XoUxRhKQeYjSWe",14) == 941989445) strcat(s, "i");
if (crc32("dxtdHLdHULIznNg",15) == 590864280) strcat(s, "v");
if (crc32("sNxNoAMKEMjpi",13) == 2501413315) strcat(s, "g");
if (crc32("bGqRZXbDLR",10) == 3266854587) strcat(s, "e");
if (crc32("yuXRgXntyEb",11) == 3429042898) strcat(s, "u");
if (crc32("olsKurPLHHFU",12) == 2846199987) strcat(s, "l");
if (crc32("XVcxVl",6) == 3490283571) strcat(s, "x");
if (crc32("rZmjKiUaZyY",11) == 403159450) strcat(s, "y");
    return s;
}

char *undiversely_adverbs() {
    char *s = calloc(12);
    if (crc32("OiOaostQLysqKR",14) == 3490014191) strcat(s, "F");
if (crc32("FezqDd",6) == 3060456752) strcat(s, "u");
if (crc32("DfqIXuUkpjKwK",13) == 2252239549) strcat(s, "n");
if (crc32("yXYfNHIuUuG",11) == 667536885) strcat(s, "i");
if (crc32("rINVgvJOcllJC",13) == 260497657) strcat(s, "d");
if (crc32("lHMXpByReJdhrgy",15) == 4231861172) strcat(s, "i");
if (crc32("ebAtuR",6) == 910906900) strcat(s, "R");
if (crc32("MvurXaoJbIoiEr",14) == 683451226) strcat(s, "v");
if (crc32("mTzvMWyIRjwil",13) == 2938069869) strcat(s, "k");
if (crc32("ROMjtrhtDSNNfRX",15) == 2867993450) strcat(s, "e");
if (crc32("KQGNk",5) == 313700597) strcat(s, "X");
if (crc32("yoldUL",6) == 365275) strcat(s, "r");
if (crc32("GbFJAI",6) == 1449824269) strcat(s, "L");
if (crc32("JAAjg",5) == 3394574476) strcat(s, "s");
if (crc32("ByqoUIyysUEP",12) == 1862970535) strcat(s, "C");
if (crc32("iqgXzkEtv",9) == 64939282) strcat(s, "e");
if (crc32("hQDApGUXdvlmG",13) == 4129836856) strcat(s, "s");
if (crc32("kSZpNMrudtHoxtK",15) == 3326139071) strcat(s, "l");
if (crc32("EoKlOOIKR",9) == 4190077219) strcat(s, "z");
if (crc32("NWBpNadRR",9) == 1365460425) strcat(s, "y");
    return s;
}

char *syllabically_adverbs() {
    char *s = calloc(13);
    if (crc32("vYvzm",5) == 2954508833) strcat(s, "s");
if (crc32("aQbUtoGHST",10) == 3197767179) strcat(s, "Q");
if (crc32("qcoFveMmhjrIyp",14) == 3810785692) strcat(s, "y");
if (crc32("sqcTGiiFZ",9) == 2767911487) strcat(s, "l");
if (crc32("ghaOcxMljLrWQ",13) == 324389118) strcat(s, "b");
if (crc32("YFnHXMFSGlfOcGQ",15) == 1232856653) strcat(s, "l");
if (crc32("xHUvashrSaTY",12) == 321198796) strcat(s, "a");
if (crc32("XxOIALbZ",8) == 299291108) strcat(s, "b");
if (crc32("iPfkhyWND",9) == 7821948) strcat(s, "i");
if (crc32("vvbaK",5) == 1260116813) strcat(s, "m");
if (crc32("ZfMHG",5) == 43419397) strcat(s, "c");
if (crc32("BPsmYSfkUpY",11) == 1334816559) strcat(s, "o");
if (crc32("fqGuiVPYFjzDt",13) == 2205210928) strcat(s, "a");
if (crc32("YmVuYYqSEfFO",12) == 2889910705) strcat(s, "l");
if (crc32("gILCeCzXRpXlpnH",15) == 670758187) strcat(s, "l");
if (crc32("pwVbFedn",8) == 2498871363) strcat(s, "U");
if (crc32("FUTwRJMywHAcI",13) == 2732884064) strcat(s, "y");
    return s;
}

char *cabalistically_adverbs() {
    char *s = calloc(15);
    if (crc32("uAqZt",5) == 2528617830) strcat(s, "c");
if (crc32("QrrGCtWgynZXUX",14) == 2010058009) strcat(s, "R");
if (crc32("bLzziwGpo",9) == 3978483855) strcat(s, "a");
if (crc32("ZNvHOwSBdIiXgX",14) == 2589319027) strcat(s, "b");
if (crc32("cVfpfxowvkd",11) == 2019640241) strcat(s, "t");
if (crc32("ZZyFHm",6) == 133667796) strcat(s, "a");
if (crc32("YObDvIedt",9) == 3368957665) strcat(s, "l");
if (crc32("NAXtz",5) == 2005035907) strcat(s, "f");
if (crc32("wQEZvwHwPybh",12) == 1650382242) strcat(s, "i");
if (crc32("qENZo",5) == 1225260976) strcat(s, "s");
if (crc32("dIKcAqM",7) == 3099441846) strcat(s, "X");
if (crc32("mqKWjEfmGEQvp",13) == 2715703254) strcat(s, "t");
if (crc32("qPNWJt",6) == 107591069) strcat(s, "i");
if (crc32("ZnXqGmdOagPyp",13) == 2433162908) strcat(s, "w");
if (crc32("uFNvViE",7) == 2299717400) strcat(s, "c");
if (crc32("fSETXCZYu",9) == 940225419) strcat(s, "a");
if (crc32("FZHZnXjZ",8) == 2190089092) strcat(s, "Z");
if (crc32("uVcAGdoxAerrUy",14) == 406274538) strcat(s, "l");
if (crc32("DWGttQM",7) == 3390608509) strcat(s, "l");
if (crc32("cXrcIkqQuJstWqR",15) == 2147371466) strcat(s, "y");
    return s;
}

char *unsharply_adverbs() {
    char *s = calloc(10);
    if (crc32("sbWsTYInHPH",11) == 3802789147) strcat(s, "K");
if (crc32("LlcbcnvC",8) == 3355313950) strcat(s, "u");
if (crc32("nYudAedlF",9) == 704803476) strcat(s, "A");
if (crc32("FgYwjNsdtHv",11) == 3703128473) strcat(s, "n");
if (crc32("DGrwjCSMdEVZ",12) == 2274038086) strcat(s, "P");
if (crc32("RYGJGfPM",8) == 1010649829) strcat(s, "s");
if (crc32("UMqDaTYzq",9) == 83089767) strcat(s, "W");
if (crc32("POHVaXBVBP",10) == 3658203407) strcat(s, "h");
if (crc32("UAQsJuVtyiE",11) == 3007124634) strcat(s, "d");
if (crc32("oftjgrnD",8) == 3170206910) strcat(s, "a");
if (crc32("rSxZcngVK",9) == 1328914233) strcat(s, "o");
if (crc32("SGbelZJvjZFCnMX",15) == 3649686468) strcat(s, "r");
if (crc32("MzxRH",5) == 1830362345) strcat(s, "Q");
if (crc32("sxqktj",6) == 2229510734) strcat(s, "p");
if (crc32("KZybpDAxexhvDB",14) == 562147304) strcat(s, "l");
if (crc32("NCgXJyWKyAZc",12) == 66111449) strcat(s, "u");
if (crc32("ChSVDF",6) == 728725767) strcat(s, "y");
    return s;
}

char *premusically_adverbs() {
    char *s = calloc(13);
    if (crc32("SwqroU",6) == 230182641) strcat(s, "p");
if (crc32("WPnKI",5) == 759091115) strcat(s, "X");
if (crc32("oLvSgRHasMmhfoY",15) == 187075242) strcat(s, "r");
if (crc32("DDflHGJasHpcfm",14) == 252112687) strcat(s, "e");
if (crc32("wlxRHFCMPPW",11) == 3506258097) strcat(s, "m");
if (crc32("LFZUznfsWklaJ",13) == 977005289) strcat(s, "u");
if (crc32("BXmSeXUpYMsfKb",14) == 2422722967) strcat(s, "y");
if (crc32("WatndRkVhCe",11) == 4068143860) strcat(s, "s");
if (crc32("GbgZZNpuzOj",11) == 690368800) strcat(s, "i");
if (crc32("XtrSGwNB",8) == 1693230615) strcat(s, "O");
if (crc32("WPZZLZcAjN",10) == 3587678235) strcat(s, "c");
if (crc32("hlTYSCRsbwdurW",14) == 3119624809) strcat(s, "a");
if (crc32("BcpdEJpwRO",10) == 1569549090) strcat(s, "v");
if (crc32("McXndHkfK",9) == 290279419) strcat(s, "l");
if (crc32("ZWTfqTFEATy",11) == 3008049820) strcat(s, "l");
if (crc32("HclYuGY",7) == 1905973721) strcat(s, "y");
    return s;
}

char *unvulgarly_adverbs() {
    char *s = calloc(11);
    if (crc32("LVUmRG",6) == 2732727769) strcat(s, "u");
if (crc32("VIfaRzmkELi",11) == 664687091) strcat(s, "n");
if (crc32("zEZrxtEqab",10) == 1020395363) strcat(s, "V");
if (crc32("REVBEywN",8) == 2584144313) strcat(s, "v");
if (crc32("xyOAUQashlNiqy",14) == 6125353) strcat(s, "u");
if (crc32("iiNZB",5) == 2404280584) strcat(s, "O");
if (crc32("TbKTIM",6) == 3411631966) strcat(s, "l");
if (crc32("uUUJOIZ",7) == 2867250959) strcat(s, "g");
if (crc32("EQwYexwSvt",10) == 650756979) strcat(s, "F");
if (crc32("AOymPZmVqLhcJS",14) == 4049209787) strcat(s, "a");
if (crc32("jXAifj",6) == 1166553379) strcat(s, "S");
if (crc32("lYlSsDRttfV",11) == 405163972) strcat(s, "r");
if (crc32("EzBUd",5) == 3574327748) strcat(s, "o");
if (crc32("aHIUhZZZ",8) == 2188388083) strcat(s, "l");
if (crc32("lqJRcNI",7) == 499326449) strcat(s, "a");
if (crc32("MXDIoTjf",8) == 899283902) strcat(s, "y");
    return s;
}

char *unintermediately_adverbs() {
    char *s = calloc(17);
    if (crc32("ObPHuhLFAe",10) == 2929842027) strcat(s, "H");
if (crc32("oaAkXwdF",8) == 2867308068) strcat(s, "u");
if (crc32("pbHYvL",6) == 2735057084) strcat(s, "s");
if (crc32("dMZTNDTVdKzgWmA",15) == 4251718325) strcat(s, "n");
if (crc32("ByzVNNzidKN",11) == 4080638628) strcat(s, "i");
if (crc32("kSCZuJgyoR",10) == 1922604794) strcat(s, "i");
if (crc32("gUIECCVuQ",9) == 4247569805) strcat(s, "n");
if (crc32("ahhoLhiRFeyI",12) == 4012124496) strcat(s, "a");
if (crc32("ahWioREcmaDNL",13) == 109661408) strcat(s, "t");
if (crc32("MSNFONQLuixEfYt",15) == 205058701) strcat(s, "D");
if (crc32("gsLWBxEPceGOT",13) == 2173598682) strcat(s, "e");
if (crc32("DgFBnlBOaknH",12) == 1200302357) strcat(s, "J");
if (crc32("UBMrnauahz",10) == 454074406) strcat(s, "r");
if (crc32("dtbrTxaJxQ",10) == 609276770) strcat(s, "m");
if (crc32("DXeXMcHkyL",10) == 3280055029) strcat(s, "e");
if (crc32("wOFYKPmqv",9) == 3501670729) strcat(s, "p");
if (crc32("hpXyOyhsvPfrwiV",15) == 3809660397) strcat(s, "d");
if (crc32("NbeQkGwXlailiOB",15) == 4129373119) strcat(s, "i");
if (crc32("rOWEXxgSbCHz",12) == 1633436332) strcat(s, "a");
if (crc32("fqRtdaC",7) == 1546580368) strcat(s, "c");
if (crc32("SvhaTgxKIAMIA",13) == 3314573976) strcat(s, "t");
if (crc32("HzSVnNbfjaTChXL",15) == 2293228112) strcat(s, "e");
if (crc32("EwjuJDcE",8) == 2123476728) strcat(s, "l");
if (crc32("inRFbOnqCKFk",12) == 827719975) strcat(s, "B");
if (crc32("uHvgXQrm",8) == 1305631577) strcat(s, "y");
    return s;
}

char *magnificently_adverbs() {
    char *s = calloc(14);
    if (crc32("fKzemlg",7) == 2455256694) strcat(s, "X");
if (crc32("evyWeCnhUULWsTd",15) == 640455789) strcat(s, "m");
if (crc32("eYuqQ",5) == 1874520061) strcat(s, "p");
if (crc32("ntniELAeYUkzeAN",15) == 2394694108) strcat(s, "a");
if (crc32("MIAwJBi",7) == 2293269970) strcat(s, "g");
if (crc32("qygErylPT",9) == 2703165043) strcat(s, "n");
if (crc32("qmXuS",5) == 156885833) strcat(s, "i");
if (crc32("MICKGV",6) == 2679716568) strcat(s, "f");
if (crc32("tqwMSrPWJuFDeP",14) == 315262130) strcat(s, "i");
if (crc32("Ynnis",5) == 2157262270) strcat(s, "O");
if (crc32("MTTtXmVEshOixb",14) == 4178045941) strcat(s, "c");
if (crc32("kDYleFvmKNm",11) == 1223813214) strcat(s, "e");
if (crc32("jOXGLGXEgnOXpB",14) == 1542187999) strcat(s, "n");
if (crc32("QtemRHp",7) == 394193830) strcat(s, "t");
if (crc32("wbennwBB",8) == 1904197175) strcat(s, "l");
if (crc32("jFdARyRGmTTEIyg",15) == 4150276476) strcat(s, "e");
if (crc32("ngwzCikcjp",10) == 2388934048) strcat(s, "y");
    return s;
}

char *atop_adverbs() {
    char *s = calloc(5);
    if (crc32("bNqAa",5) == 3797550717) strcat(s, "A");
if (crc32("iFGMVMXKN",9) == 4114253220) strcat(s, "a");
if (crc32("KhyPyvXSfjBNb",13) == 1747758919) strcat(s, "H");
if (crc32("DTzsGms",7) == 475372992) strcat(s, "t");
if (crc32("thITi",5) == 3643874452) strcat(s, "M");
if (crc32("okodBTKzmzUR",12) == 3420060251) strcat(s, "o");
if (crc32("MGDFRa",6) == 982412360) strcat(s, "p");
    return s;
}

char *veneratively_adverbs() {
    char *s = calloc(13);
    if (crc32("IVdPegca",8) == 2374429595) strcat(s, "v");
if (crc32("QgOHQalyAU",10) == 2518282685) strcat(s, "S");
if (crc32("yajydbFmPnWg",12) == 2531961381) strcat(s, "e");
if (crc32("PvpaXDgbEIy",11) == 213453730) strcat(s, "k");
if (crc32("WDSAmVwF",8) == 1001392436) strcat(s, "n");
if (crc32("BbYNdQnLkSyiA",13) == 1926917501) strcat(s, "Z");
if (crc32("LUtRzHWfJW",10) == 3837407979) strcat(s, "e");
if (crc32("AjSLoGC",7) == 1802017508) strcat(s, "r");
if (crc32("baBZmBndcysf",12) == 1200876162) strcat(s, "a");
if (crc32("MKkizZNhxPyA",12) == 2367782057) strcat(s, "b");
if (crc32("dHPPfheG",8) == 3661755548) strcat(s, "t");
if (crc32("atJedenCIXPDCuR",15) == 3025980658) strcat(s, "i");
if (crc32("zbRwGIXo",8) == 799280536) strcat(s, "e");
if (crc32("sSeJp",5) == 3043430966) strcat(s, "v");
if (crc32("bRgjQtjIzY",10) == 3101895579) strcat(s, "e");
if (crc32("qLgVMuphO",9) == 135369907) strcat(s, "l");
if (crc32("FpiprNAeuaJW",12) == 33702335) strcat(s, "y");
    return s;
}

char *noneccentrically_adverbs() {
    char *s = calloc(17);
    if (crc32("LZcuqWYMyoyo",12) == 3672665263) strcat(s, "D");
if (crc32("muShsgZzI",9) == 4202104127) strcat(s, "n");
if (crc32("lsUIFbz",7) == 636941170) strcat(s, "S");
if (crc32("cgzbuYAbF",9) == 1794507961) strcat(s, "o");
if (crc32("ujcLznGJjqiCm",13) == 2125115950) strcat(s, "K");
if (crc32("fxeqVgYUSmZA",12) == 4133423578) strcat(s, "n");
if (crc32("eyKrKLSgdHiV",12) == 1558851252) strcat(s, "e");
if (crc32("vrZbTdSuOCNUbi",14) == 2156372464) strcat(s, "c");
if (crc32("sYIPQivXC",9) == 45147336) strcat(s, "e");
if (crc32("SgFSUQunSXUm",12) == 1005970995) strcat(s, "c");
if (crc32("eSvMneRWQsfzio",14) == 3292317785) strcat(s, "e");
if (crc32("DbtqT",5) == 2221153180) strcat(s, "p");
if (crc32("EtgfL",5) == 3006860240) strcat(s, "n");
if (crc32("guHEfJXFQQXjv",13) == 3087242772) strcat(s, "t");
if (crc32("ROAtltUGhGFAVH",14) == 3344298749) strcat(s, "r");
if (crc32("ZeOOd",5) == 769336930) strcat(s, "G");
if (crc32("gDJEuVVxZultrj",14) == 1802698793) strcat(s, "i");
if (crc32("OizcIuSA",8) == 2440962471) strcat(s, "n");
if (crc32("uxyVT",5) == 2187078705) strcat(s, "c");
if (crc32("HYJvwwWdRh",10) == 130916015) strcat(s, "Y");
if (crc32("OEoXarqL",8) == 4023125287) strcat(s, "a");
if (crc32("RFPWxqX",7) == 2543361752) strcat(s, "l");
if (crc32("lomIoTBTcz",10) == 2708415781) strcat(s, "l");
if (crc32("cMKewblCVRf",11) == 566676616) strcat(s, "m");
if (crc32("YAWvsb",6) == 1591247069) strcat(s, "y");
    return s;
}

char *unmeditatively_adverbs() {
    char *s = calloc(15);
    if (crc32("iOaSFMPH",8) == 2690614537) strcat(s, "u");
if (crc32("gDQblQjQNvURHOi",15) == 2146110808) strcat(s, "n");
if (crc32("XKRcgKmKOmqYQ",13) == 4123847412) strcat(s, "m");
if (crc32("RDeOWJFO",8) == 728277062) strcat(s, "e");
if (crc32("GGLyFXSQHs",10) == 59774590) strcat(s, "v");
if (crc32("oRxEcm",6) == 2948227678) strcat(s, "d");
if (crc32("GquRdosItSyecBD",15) == 715613375) strcat(s, "i");
if (crc32("pywtnDscxxGawN",14) == 4004854897) strcat(s, "e");
if (crc32("OaoDDXdQgqIdU",13) == 1390362544) strcat(s, "t");
if (crc32("iNFuZho",7) == 742422035) strcat(s, "a");
if (crc32("jgEeTr",6) == 3327513600) strcat(s, "X");
if (crc32("EQqBjxeNfSCDA",13) == 3742845833) strcat(s, "t");
if (crc32("BUvDHHWnlBjbyS",14) == 3929056636) strcat(s, "i");
if (crc32("ySMBSwIvnQrs",12) == 4087894837) strcat(s, "C");
if (crc32("tTqbwRfRkwZhF",13) == 3248591372) strcat(s, "v");
if (crc32("cXWkshJytC",10) == 3917074966) strcat(s, "e");
if (crc32("NyMHOwDeHdLAq",13) == 3755679176) strcat(s, "W");
if (crc32("aCxRHVbGTAgOg",13) == 2635060507) strcat(s, "l");
if (crc32("aHGljf",6) == 2655229569) strcat(s, "M");
if (crc32("nZHjrQjVy",9) == 404623456) strcat(s, "y");
    return s;
}

char *askance_adverbs() {
    char *s = calloc(8);
    if (crc32("exxKZROEscW",11) == 4018112515) strcat(s, "x");
if (crc32("ThitAguWPI",10) == 217226303) strcat(s, "a");
if (crc32("kAUQgDXVIDy",11) == 907616476) strcat(s, "s");
if (crc32("PtcHofpbsXekl",13) == 2828465916) strcat(s, "l");
if (crc32("iYJkZNH",7) == 561102802) strcat(s, "k");
if (crc32("eOgCcTc",7) == 1487046080) strcat(s, "a");
if (crc32("CTYjDsC",7) == 2974489185) strcat(s, "J");
if (crc32("qohydNijDzPJzT",14) == 573191562) strcat(s, "n");
if (crc32("VTzDKZlpcwsmIPh",15) == 3865007671) strcat(s, "c");
if (crc32("IgpCvFR",7) == 313733309) strcat(s, "m");
if (crc32("RRANqOtmy",9) == 3610706398) strcat(s, "e");
    return s;
}

char *pseudocompetitively_adverbs() {
    char *s = calloc(20);
    if (crc32("yELxiLpHiuLl",12) == 2309409752) strcat(s, "p");
if (crc32("TFgCrmWA",8) == 3869429190) strcat(s, "t");
if (crc32("nktAp",5) == 3868754375) strcat(s, "s");
if (crc32("GNCaBlGMHKueE",13) == 2779990041) strcat(s, "g");
if (crc32("zAsnMXTXLS",10) == 26587562) strcat(s, "e");
if (crc32("IwMENbMMc",9) == 3609620612) strcat(s, "u");
if (crc32("oOtHhHzOjNL",11) == 4022001662) strcat(s, "d");
if (crc32("hQUJqouwt",9) == 2244736469) strcat(s, "o");
if (crc32("SNoqLigdkKBrgrG",15) == 3934467694) strcat(s, "m");
if (crc32("ohvZxDtVz",9) == 2523785549) strcat(s, "c");
if (crc32("jYNxB",5) == 2794826577) strcat(s, "o");
if (crc32("GoPUQvNr",8) == 885354083) strcat(s, "m");
if (crc32("JoTBFr",6) == 725242365) strcat(s, "p");
if (crc32("OpnZSgdCfNrvm",13) == 171523642) strcat(s, "e");
if (crc32("JWwjBsTo",8) == 158881175) strcat(s, "C");
if (crc32("yZEUBpMZEwFLOEB",15) == 2912060068) strcat(s, "t");
if (crc32("YLDBfCBGzelGLk",14) == 3268328770) strcat(s, "V");
if (crc32("oNWvtbABtQ",10) == 1906647116) strcat(s, "i");
if (crc32("tZVrRqtJlJK",11) == 1122893170) strcat(s, "t");
if (crc32("dhdEKva",7) == 4183142050) strcat(s, "i");
if (crc32("YhsfTw",6) == 375849023) strcat(s, "v");
if (crc32("NTcFyQ",6) == 4128680438) strcat(s, "e");
if (crc32("QQzIRRYn",8) == 1226394904) strcat(s, "l");
if (crc32("BOTUGhLLS",9) == 2925958360) strcat(s, "y");
    return s;
}

char *superinnocently_adverbs() {
    char *s = calloc(16);
    if (crc32("RpEByvdgNK",10) == 817257227) strcat(s, "s");
if (crc32("aSoeUs",6) == 775991118) strcat(s, "u");
if (crc32("mepRgMpY",8) == 1569249700) strcat(s, "p");
if (crc32("cnRjbvrxeVUXIXJ",15) == 2530062021) strcat(s, "E");
if (crc32("CseFBT",6) == 1356467543) strcat(s, "e");
if (crc32("nnMDnTNExPch",12) == 3680244672) strcat(s, "M");
if (crc32("UVmBFZCBiDzmaIO",15) == 1122757347) strcat(s, "r");
if (crc32("rIdGbVLMg",9) == 2168435037) strcat(s, "i");
if (crc32("hDepiOOVcFCON",13) == 1435038310) strcat(s, "j");
if (crc32("AKhjNKOv",8) == 952046766) strcat(s, "n");
if (crc32("WobeyJqi",8) == 983644573) strcat(s, "n");
if (crc32("ThlFx",5) == 3804038907) strcat(s, "D");
if (crc32("jlPVnJJqIttbVHr",15) == 482172590) strcat(s, "o");
if (crc32("fVWLqetaD",9) == 1379195458) strcat(s, "c");
if (crc32("ZrhNNywLR",9) == 2124556327) strcat(s, "K");
if (crc32("snNbzQLzPO",10) == 836584002) strcat(s, "e");
if (crc32("kFdoEau",7) == 714168580) strcat(s, "l");
if (crc32("wXtEA",5) == 1548019269) strcat(s, "n");
if (crc32("VmWLmgVafqLwF",13) == 3469001787) strcat(s, "H");
if (crc32("kmQXqGWqz",9) == 1004050303) strcat(s, "t");
if (crc32("CTHDerRLPciaTAZ",15) == 2765363322) strcat(s, "l");
if (crc32("XpWaFrmcTwZdTo",14) == 784092072) strcat(s, "y");
    return s;
}

char *nondangerously_adverbs() {
    char *s = calloc(15);
    if (crc32("QudWE",5) == 2986254412) strcat(s, "f");
if (crc32("KqPUF",5) == 239942328) strcat(s, "n");
if (crc32("ISUBMJyscgZV",12) == 4277234156) strcat(s, "o");
if (crc32("cEXSME",6) == 1653994362) strcat(s, "j");
if (crc32("aCCLM",5) == 3450622094) strcat(s, "n");
if (crc32("IlQAwLCfk",9) == 1408349182) strcat(s, "d");
if (crc32("wUcWd",5) == 2544906188) strcat(s, "R");
if (crc32("IDFBL",5) == 1317393153) strcat(s, "a");
if (crc32("vliXcCBBihKOCHT",15) == 4052519737) strcat(s, "n");
if (crc32("SeKajQWXESQ",11) == 124839586) strcat(s, "j");
if (crc32("TgYWopqcVt",10) == 3850845642) strcat(s, "g");
if (crc32("gokdKZxRNoP",11) == 145112305) strcat(s, "e");
if (crc32("xXrpLJzWXXljj",13) == 704227399) strcat(s, "r");
if (crc32("YGlZo",5) == 2513200968) strcat(s, "v");
if (crc32("BalyvWBO",8) == 2871305924) strcat(s, "o");
if (crc32("MxnSRqDRewD",11) == 1025412837) strcat(s, "b");
if (crc32("MxvAZulckkRqDJx",15) == 3196856062) strcat(s, "u");
if (crc32("fxOpDBZKpbBCLY",14) == 4180887951) strcat(s, "s");
if (crc32("jhyOwU",6) == 2808209074) strcat(s, "l");
if (crc32("jzPjsQ",6) == 1039958002) strcat(s, "y");
    return s;
}

char *assumably_adverbs() {
    char *s = calloc(10);
    if (crc32("fBMecDgP",8) == 3711237820) strcat(s, "U");
if (crc32("LOZlRoLPoNnwKdP",15) == 2997895429) strcat(s, "a");
if (crc32("uPFLvdC",7) == 2549860354) strcat(s, "s");
if (crc32("HmkBFoQQ",8) == 3938148862) strcat(s, "K");
if (crc32("QYofmdUoPVvhLoI",15) == 279262558) strcat(s, "s");
if (crc32("egGOMWltxQ",10) == 2636813705) strcat(s, "u");
if (crc32("mdmhMUXcjxVvV",13) == 2985455268) strcat(s, "r");
if (crc32("IatPmDD",7) == 3986894205) strcat(s, "m");
if (crc32("ueOxRlBcZW",10) == 427232186) strcat(s, "a");
if (crc32("WNbdgzSJoiZ",11) == 2415787180) strcat(s, "b");
if (crc32("ZuHpvjDjuvI",11) == 3750798728) strcat(s, "V");
if (crc32("TPrpsjQ",7) == 2073836888) strcat(s, "l");
if (crc32("QaGcyu",6) == 1082291965) strcat(s, "y");
    return s;
}

char *illhumouredly_adverbs() {
    char *s = calloc(14);
    if (crc32("xovKQrX",7) == 2483663067) strcat(s, "i");
if (crc32("HszvpGTNUsRIy",13) == 2822826280) strcat(s, "r");
if (crc32("jgtTftqZdnNIuE",14) == 1611268298) strcat(s, "l");
if (crc32("zZzXDZRUMi",10) == 1419231377) strcat(s, "l");
if (crc32("HXQMMFz",7) == 149513811) strcat(s, "h");
if (crc32("VbIGXYtNKGMncF",14) == 258765782) strcat(s, "u");
if (crc32("iScqPFrAL",9) == 4031862915) strcat(s, "m");
if (crc32("XoMaPHR",7) == 2255753946) strcat(s, "o");
if (crc32("KdcubfBCueF",11) == 2074424661) strcat(s, "u");
if (crc32("pSbAvtxKzvk",11) == 2819505929) strcat(s, "t");
if (crc32("idejzU",6) == 1977766780) strcat(s, "r");
if (crc32("wDWONVjSwDEsUbD",15) == 3568014043) strcat(s, "q");
if (crc32("tHmkAFAMKmD",11) == 1644271920) strcat(s, "e");
if (crc32("MhzmW",5) == 3750120686) strcat(s, "I");
if (crc32("MTGxcQY",7) == 2423356720) strcat(s, "d");
if (crc32("JRXeUYH",7) == 1103305834) strcat(s, "l");
if (crc32("SQqIetaPyjp",11) == 3209836011) strcat(s, "y");
    return s;
}

char *hecticly_adverbs() {
    char *s = calloc(9);
    if (crc32("bKNWDarIroO",11) == 2667163814) strcat(s, "W");
if (crc32("sowKDfWQTQgq",12) == 3600416746) strcat(s, "h");
if (crc32("irFQizFDEcDLH",13) == 2840381943) strcat(s, "R");
if (crc32("rhcAl",5) == 1549122832) strcat(s, "e");
if (crc32("YiABSjDQuV",10) == 2419634946) strcat(s, "c");
if (crc32("JwcGEQPBtOXp",12) == 2166716721) strcat(s, "t");
if (crc32("qCjYmUyJZJb",11) == 3704283568) strcat(s, "i");
if (crc32("wkCszcFiGEOne",13) == 2922716439) strcat(s, "s");
if (crc32("IOlXvt",6) == 2120509817) strcat(s, "c");
if (crc32("LRurjfrNQpVIQB",14) == 1311040940) strcat(s, "l");
if (crc32("exrLtHxJuT",10) == 3877210891) strcat(s, "y");
    return s;
}

char *feckly_adverbs() {
    char *s = calloc(7);
    if (crc32("XRdCTXdRRa",10) == 2651028281) strcat(s, "A");
if (crc32("iLhZbNMn",8) == 3152004092) strcat(s, "f");
if (crc32("DeGcHyThSWYR",12) == 1284399690) strcat(s, "r");
if (crc32("UNQyXu",6) == 1893644088) strcat(s, "e");
if (crc32("KzQDZXr",7) == 3449722209) strcat(s, "c");
if (crc32("pyKPdnx",7) == 2288140722) strcat(s, "o");
if (crc32("wQhxwmHMzcham",13) == 3900366062) strcat(s, "k");
if (crc32("qKLpjhQi",8) == 1192066346) strcat(s, "l");
if (crc32("vlmCCR",6) == 3587892586) strcat(s, "y");
    return s;
}

char *duly_adverbs() {
    char *s = calloc(5);
    if (crc32("keETWoMGlCmRaX",14) == 1430535711) strcat(s, "d");
if (crc32("pUQlLXC",7) == 3186854659) strcat(s, "u");
if (crc32("mdoDfHFLEcEwCry",15) == 3585198310) strcat(s, "b");
if (crc32("WnzZrVF",7) == 2048512908) strcat(s, "l");
if (crc32("sYzjXMHuGmtu",12) == 1593995875) strcat(s, "y");
    return s;
}

char *mildly_adverbs() {
    char *s = calloc(7);
    if (crc32("XDhAX",5) == 270631271) strcat(s, "m");
if (crc32("kTMzvVaSz",9) == 2526133830) strcat(s, "i");
if (crc32("qAdGqdLR",8) == 3689311595) strcat(s, "l");
if (crc32("IlhXbIovmMe",11) == 2400736001) strcat(s, "C");
if (crc32("cNDquIAVwgwqIx",14) == 1280158664) strcat(s, "d");
if (crc32("yCqxsEiKjE",10) == 257208936) strcat(s, "l");
if (crc32("ZfcrIdGClNo",11) == 3505119818) strcat(s, "B");
if (crc32("bAEachFyaGsvZ",13) == 952933412) strcat(s, "y");
    return s;
}

char *myelographically_adverbs() {
    char *s = calloc(17);
    if (crc32("GNOADeeGOIe",11) == 3787226760) strcat(s, "a");
if (crc32("LNLXwcdeiZCVJj",14) == 3991251315) strcat(s, "m");
if (crc32("LCItbRLVbskXAW",14) == 2276161963) strcat(s, "y");
if (crc32("QpxhmzlLJn",10) == 1510998980) strcat(s, "z");
if (crc32("gXRLnrRetAhHaz",14) == 30097566) strcat(s, "e");
if (crc32("CiUUiaDs",8) == 1318322766) strcat(s, "g");
if (crc32("GdwHb",5) == 1377282236) strcat(s, "l");
if (crc32("QGJlHMomF",9) == 850362691) strcat(s, "o");
if (crc32("BISnmgu",7) == 2564624452) strcat(s, "B");
if (crc32("UMLEtUesyyu",11) == 3112173280) strcat(s, "g");
if (crc32("RrISmQDMXL",10) == 2488273336) strcat(s, "q");
if (crc32("vRASk",5) == 3944379627) strcat(s, "r");
if (crc32("PNtwaJJDYsDuB",13) == 592093681) strcat(s, "b");
if (crc32("lzTvtWnjSvXOxu",14) == 2476398614) strcat(s, "a");
if (crc32("GpzTCmi",7) == 1980630620) strcat(s, "p");
if (crc32("ELWaXpCx",8) == 3009698146) strcat(s, "Z");
if (crc32("MJEglBI",7) == 2886933689) strcat(s, "h");
if (crc32("OnqlnSER",8) == 1875044345) strcat(s, "i");
if (crc32("iVBlR",5) == 2203451266) strcat(s, "c");
if (crc32("IiLTpjsVcAfyl",13) == 2878308745) strcat(s, "W");
if (crc32("gWCcQiuUU",9) == 3082938415) strcat(s, "a");
if (crc32("vvcXFrecqqeN",12) == 1218414881) strcat(s, "l");
if (crc32("mzStNyvN",8) == 2945812687) strcat(s, "T");
if (crc32("IbIwtEJENu",10) == 543183609) strcat(s, "l");
if (crc32("ytoFYlGxP",9) == 389696536) strcat(s, "g");
if (crc32("oJeFwKOTCA",10) == 2084808552) strcat(s, "y");
    return s;
}

char *superseverely_adverbs() {
    char *s = calloc(14);
    if (crc32("SHZOlgrj",8) == 3722849386) strcat(s, "m");
if (crc32("ESpjRvexfcywKb",14) == 3095645878) strcat(s, "s");
if (crc32("lzOvXGsYsttAykg",15) == 93853047) strcat(s, "O");
if (crc32("SfMsiTtDNnyfEGR",15) == 2397755389) strcat(s, "u");
if (crc32("VfgCulQPoCwYqA",14) == 3890285368) strcat(s, "p");
if (crc32("oJSsVEJynmIF",12) == 281577406) strcat(s, "C");
if (crc32("kyuiTBIhdzL",11) == 3164688356) strcat(s, "e");
if (crc32("AHVeijCT",8) == 3368569479) strcat(s, "r");
if (crc32("qEbakXBgDWl",11) == 1953841331) strcat(s, "D");
if (crc32("pfgQZtGaDgzq",12) == 1881074906) strcat(s, "s");
if (crc32("pKNqGfAOXaljOJc",15) == 199989457) strcat(s, "B");
if (crc32("VjZAEnDH",8) == 330981741) strcat(s, "e");
if (crc32("ajrfVFNysK",10) == 1845690954) strcat(s, "q");
if (crc32("lXzhTjDRd",9) == 1525370328) strcat(s, "v");
if (crc32("HpNtnsSZkGtIuH",14) == 3119260109) strcat(s, "M");
if (crc32("TEhXG",5) == 2070261742) strcat(s, "e");
if (crc32("UItxAbDBwyIA",12) == 77404778) strcat(s, "r");
if (crc32("aclFCyCeYHWB",12) == 3290378036) strcat(s, "e");
if (crc32("frilczFC",8) == 1114324555) strcat(s, "l");
if (crc32("ewydX",5) == 1625807705) strcat(s, "Q");
if (crc32("rwVshbBrI",9) == 167804028) strcat(s, "y");
    return s;
}

char *superarduously_adverbs() {
    char *s = calloc(15);
    if (crc32("gjkCSFQBn",9) == 4190075172) strcat(s, "z");
if (crc32("EJbHdwKH",8) == 1206633955) strcat(s, "s");
if (crc32("hQYrl",5) == 3440663485) strcat(s, "r");
if (crc32("xuBQPQRamy",10) == 2321307859) strcat(s, "u");
if (crc32("HMoSbAHYrb",10) == 224125961) strcat(s, "z");
if (crc32("xlvHRTdypkg",11) == 3313641344) strcat(s, "p");
if (crc32("KcOZAifYMMWWog",14) == 2222385410) strcat(s, "w");
if (crc32("iDsqov",6) == 1156624332) strcat(s, "e");
if (crc32("jWTcTrOerv",10) == 1699155111) strcat(s, "r");
if (crc32("RbJXwbCArDR",11) == 1161116540) strcat(s, "a");
if (crc32("XoljZYkptUol",12) == 1092205072) strcat(s, "r");
if (crc32("nKvGeucudB",10) == 1212395301) strcat(s, "c");
if (crc32("gDnKR",5) == 770167574) strcat(s, "d");
if (crc32("AsCAABEwaY",10) == 1805711287) strcat(s, "u");
if (crc32("iybljUpSgSCNEwP",15) == 3205021401) strcat(s, "E");
if (crc32("pemffcaIGP",10) == 2281876085) strcat(s, "o");
if (crc32("zRLNUzBhjMX",11) == 2894616360) strcat(s, "u");
if (crc32("HOwvPQrAUfLN",12) == 301606556) strcat(s, "s");
if (crc32("LLVSuvsUsyfM",12) == 1645663258) strcat(s, "l");
if (crc32("fZvwqiDAEvib",12) == 763698216) strcat(s, "y");
    return s;
}

char *uninterestedly_adverbs() {
    char *s = calloc(15);
    if (crc32("YHmtCa",6) == 2308262222) strcat(s, "u");
if (crc32("dpOIMboUxCYvL",13) == 1131135686) strcat(s, "K");
if (crc32("tvyqESoHy",9) == 2209260033) strcat(s, "n");
if (crc32("ivtwgajR",8) == 3407849324) strcat(s, "J");
if (crc32("hIXSeVdcb",9) == 2957426930) strcat(s, "i");
if (crc32("tHFuyzIiT",9) == 3809279179) strcat(s, "Z");
if (crc32("NleeyEyNCsZdWm",14) == 2113490277) strcat(s, "n");
if (crc32("TMLcPRhUcyQClvM",15) == 1221069883) strcat(s, "t");
if (crc32("AyxsFbbHWHklRM",14) == 636744627) strcat(s, "e");
if (crc32("cvBSOGoqXBwlc",13) == 3167802584) strcat(s, "k");
if (crc32("yAauxIdslVtfGB",14) == 2417834896) strcat(s, "r");
if (crc32("azdXCfA",7) == 4112863068) strcat(s, "V");
if (crc32("FRMihBRUGleKVGO",15) == 1440761008) strcat(s, "e");
if (crc32("qtiKIvWWsPcvg",13) == 2016609680) strcat(s, "s");
if (crc32("FEdmrqFvgLwT",12) == 456722671) strcat(s, "H");
if (crc32("SjBDWfdifu",10) == 1147906358) strcat(s, "t");
if (crc32("LubunbjqTtUEgR",14) == 1920135991) strcat(s, "Q");
if (crc32("NgLefjxRwRoHA",13) == 1608296975) strcat(s, "e");
if (crc32("XtpkZi",6) == 3327803432) strcat(s, "n");
if (crc32("xnSofYFPZbn",11) == 3790574986) strcat(s, "d");
if (crc32("eriVVfNDYwPYedl",15) == 1280733463) strcat(s, "W");
if (crc32("EVbUZPgD",8) == 1653905432) strcat(s, "l");
if (crc32("AJwlDfFfVwdeYLG",15) == 3706374526) strcat(s, "e");
if (crc32("CFIaLXFDoKdo",12) == 4061067738) strcat(s, "y");
    return s;
}

char *unaristocratically_adverbs() {
    char *s = calloc(19);
    if (crc32("fkFoUTfFdiZwb",13) == 3053994970) strcat(s, "u");
if (crc32("dgSHznRoc",9) == 4259566469) strcat(s, "n");
if (crc32("RwnPQadbZMY",11) == 328941983) strcat(s, "a");
if (crc32("XavEEVlKEz",10) == 2793034152) strcat(s, "r");
if (crc32("TXhsuSNbnZoi",12) == 3336577056) strcat(s, "U");
if (crc32("hqCWXsEZ",8) == 1903306255) strcat(s, "i");
if (crc32("CetbTF",6) == 2959286849) strcat(s, "B");
if (crc32("hdGmQSzIcpB",11) == 255582863) strcat(s, "s");
if (crc32("ijruFMrFBIGqFRS",15) == 1933702857) strcat(s, "t");
if (crc32("HqDlyIQqp",9) == 894063345) strcat(s, "o");
if (crc32("NbjDXTMEzDsW",12) == 1581593615) strcat(s, "Z");
if (crc32("jojiCmdNNLkgwZ",14) == 892621271) strcat(s, "c");
if (crc32("HUYxMKLeB",9) == 3658998757) strcat(s, "r");
if (crc32("MXtxPZJZILIpO",13) == 2905316963) strcat(s, "a");
if (crc32("YUcNAGJZCqwk",12) == 3542769144) strcat(s, "Q");
if (crc32("drUEfmlDNeJrhO",14) == 1466692665) strcat(s, "t");
if (crc32("hJVrWSlSHC",10) == 2033993093) strcat(s, "A");
if (crc32("qfquAQdvTYTk",12) == 2033445546) strcat(s, "i");
if (crc32("jAvCUFtTmio",11) == 1170434384) strcat(s, "c");
if (crc32("ktVjPOWqmGKliuS",15) == 4090873753) strcat(s, "a");
if (crc32("ylyJXRiq",8) == 1459168117) strcat(s, "l");
if (crc32("nyLrhpN",7) == 2764073600) strcat(s, "k");
if (crc32("YbiuvrmmWdBanI",14) == 2030398362) strcat(s, "l");
if (crc32("AqhCVxicA",9) == 3916871628) strcat(s, "G");
if (crc32("LVegVNSvbh",10) == 271331891) strcat(s, "y");
    return s;
}

char *disloyally_adverbs() {
    char *s = calloc(11);
    if (crc32("qyPxfKbLIf",10) == 124966727) strcat(s, "B");
if (crc32("LTtutjCEUlz",11) == 1609241499) strcat(s, "d");
if (crc32("ipcRddYlpAmR",12) == 151679927) strcat(s, "N");
if (crc32("PMBdnnicxf",10) == 980875885) strcat(s, "i");
if (crc32("RYtwx",5) == 1854978699) strcat(s, "J");
if (crc32("wlTJgkJGvUq",11) == 1756794362) strcat(s, "s");
if (crc32("NiGQcavDmeI",11) == 1131943806) strcat(s, "G");
if (crc32("NkvbUDtFIuMek",13) == 902093106) strcat(s, "l");
if (crc32("fFzjstaxkXIL",12) == 2289091891) strcat(s, "V");
if (crc32("qbeCmkLps",9) == 3513487700) strcat(s, "o");
if (crc32("qLOCRKMq",8) == 4261015150) strcat(s, "v");
if (crc32("kTXKcZOxNhrzDs",14) == 3216793773) strcat(s, "y");
if (crc32("dGnYyntnitXOEU",14) == 3701050928) strcat(s, "t");
if (crc32("mgEQnSBvngfDHs",14) == 1770216569) strcat(s, "a");
if (crc32("iWpjgVmI",8) == 2244452491) strcat(s, "l");
if (crc32("bnKjZLbmBTUVe",13) == 2131480851) strcat(s, "l");
if (crc32("eiKOz",5) == 1912595016) strcat(s, "K");
if (crc32("CYZsVU",6) == 149557949) strcat(s, "y");
    return s;
}

char *dualistically_adverbs() {
    char *s = calloc(14);
    if (crc32("RJnoMciFKSJ",11) == 2769688041) strcat(s, "d");
if (crc32("ewLNbRWGvOv",11) == 356786677) strcat(s, "u");
if (crc32("rXdTIciRhHmC",12) == 3787409890) strcat(s, "m");
if (crc32("bspFMWlZ",8) == 3028694693) strcat(s, "a");
if (crc32("lZmajpzg",8) == 3204443372) strcat(s, "W");
if (crc32("bnZkGBSOeaF",11) == 340883387) strcat(s, "l");
if (crc32("cjlnk",5) == 754458970) strcat(s, "i");
if (crc32("xrHRd",5) == 116625011) strcat(s, "X");
if (crc32("KjiQMwryd",9) == 2546284670) strcat(s, "s");
if (crc32("szgRY",5) == 2859651823) strcat(s, "x");
if (crc32("LExcKBIMJq",10) == 3263433674) strcat(s, "t");
if (crc32("nTbfE",5) == 3658334388) strcat(s, "i");
if (crc32("TBrXjqeLeVj",11) == 17523423) strcat(s, "c");
if (crc32("ocgkMygoNqeIx",13) == 1133846884) strcat(s, "o");
if (crc32("RZZekSznORNWOO",14) == 1751296897) strcat(s, "a");
if (crc32("TxPfnBvAB",9) == 2108266625) strcat(s, "l");
if (crc32("rkoFq",5) == 1807552900) strcat(s, "l");
if (crc32("TOmcokrIZVIy",12) == 394249342) strcat(s, "y");
    return s;
}

char *eastsoutheastward_adverbs() {
    char *s = calloc(18);
    if (crc32("gLXvN",5) == 3059512874) strcat(s, "e");
if (crc32("aAPxBjiEfJh",11) == 3254014961) strcat(s, "a");
if (crc32("lywuVY",6) == 1799807798) strcat(s, "w");
if (crc32("KYtxalZ",7) == 1507546344) strcat(s, "s");
if (crc32("kTZMqFKPMuqvjpI",15) == 2675872168) strcat(s, "E");
if (crc32("QuzvUSZyHIiUwn",14) == 3988742738) strcat(s, "t");
if (crc32("OjRbqqRFbF",10) == 853384755) strcat(s, "a");
if (crc32("ZFQpNkKOeDlEPz",14) == 6435808) strcat(s, "s");
if (crc32("iSgMkY",6) == 2209394757) strcat(s, "p");
if (crc32("OMpYhg",6) == 2567906581) strcat(s, "o");
if (crc32("vfiYUzTM",8) == 787583026) strcat(s, "s");
if (crc32("FpQQFfUXV",9) == 4131523602) strcat(s, "u");
if (crc32("EyvryZxlDOE",11) == 2464815673) strcat(s, "a");
if (crc32("UwLFfWbzYwDLZN",14) == 1923741818) strcat(s, "t");
if (crc32("xtedaraXaHCE",12) == 2913325981) strcat(s, "h");
if (crc32("RdEIiZwIgyLwF",13) == 110910595) strcat(s, "e");
if (crc32("PGdWe",5) == 3581447474) strcat(s, "B");
if (crc32("QHByADMnVoyjta",14) == 2905984328) strcat(s, "a");
if (crc32("rXjsFNikiIPvJC",14) == 4202957675) strcat(s, "u");
if (crc32("QLzgtzMkOfXGK",13) == 4008766029) strcat(s, "s");
if (crc32("WWzyLTQSkbn",11) == 3328464362) strcat(s, "t");
if (crc32("ewWdNMmk",8) == 1438395682) strcat(s, "v");
if (crc32("QqEiZdFsmoxu",12) == 4208363324) strcat(s, "w");
if (crc32("vMLrFDCGzMvVTYY",15) == 4140459919) strcat(s, "a");
if (crc32("DSfxnusu",8) == 1618551312) strcat(s, "r");
if (crc32("qpViYmIiiQ",10) == 515721890) strcat(s, "K");
if (crc32("xkUDmjUwTscmo",13) == 1356901403) strcat(s, "d");
    return s;
}

char *arrestingly_adverbs() {
    char *s = calloc(12);
    if (crc32("qIGoeuHK",8) == 2568321378) strcat(s, "y");
if (crc32("UCULUBA",7) == 3986650696) strcat(s, "a");
if (crc32("BmMCCfNn",8) == 1231381090) strcat(s, "r");
if (crc32("gljiDaKVa",9) == 3707807708) strcat(s, "r");
if (crc32("RfFqoVmVMxw",11) == 603354923) strcat(s, "e");
if (crc32("QQRdyAEs",8) == 2006263140) strcat(s, "s");
if (crc32("IQNtXfcmXy",10) == 4141561555) strcat(s, "r");
if (crc32("LnCiGpqe",8) == 2226751289) strcat(s, "t");
if (crc32("sDZatGborNCyfs",14) == 229971252) strcat(s, "v");
if (crc32("nFeWpRPMGkbYatG",15) == 1162195849) strcat(s, "i");
if (crc32("mVCoeQi",7) == 3602771138) strcat(s, "Y");
if (crc32("GQyWLMbiJB",10) == 859595491) strcat(s, "n");
if (crc32("DZYJSYDq",8) == 826652842) strcat(s, "f");
if (crc32("dYugk",5) == 3195242931) strcat(s, "g");
if (crc32("LcDuPk",6) == 3926067147) strcat(s, "B");
if (crc32("GQNptTrOUWQ",11) == 882776644) strcat(s, "l");
if (crc32("dNJbFibwodBw",12) == 2447392158) strcat(s, "h");
if (crc32("EGMIBs",6) == 435324299) strcat(s, "y");
    return s;
}

char *intravenously_adverbs() {
    char *s = calloc(14);
    if (crc32("nTjCwnJnE",9) == 352362242) strcat(s, "i");
if (crc32("HEqErNWzIhXOc",13) == 597999440) strcat(s, "M");
if (crc32("XnkucmbVvv",10) == 954605158) strcat(s, "n");
if (crc32("BSaGGYqSzWp",11) == 1646930863) strcat(s, "w");
if (crc32("xsXHVWOukANBny",14) == 1749652138) strcat(s, "t");
if (crc32("LdESFjLzNbicB",13) == 3564271552) strcat(s, "r");
if (crc32("rCsTIxNjIX",10) == 342479915) strcat(s, "K");
if (crc32("zCesWYmzfOucZ",13) == 2852919970) strcat(s, "a");
if (crc32("RnEqOlKe",8) == 908890519) strcat(s, "I");
if (crc32("JXEZHJrUoylU",12) == 3123022039) strcat(s, "v");
if (crc32("IEKMHMjseFG",11) == 1055090637) strcat(s, "e");
if (crc32("bvmJMhJOuIG",11) == 107989205) strcat(s, "n");
if (crc32("BprgBJkIYkz",11) == 931984747) strcat(s, "o");
if (crc32("RuaOXW",6) == 1237321948) strcat(s, "o");
if (crc32("mhCkH",5) == 3586184026) strcat(s, "u");
if (crc32("fXMqwJLjRbwQmKf",15) == 4284608365) strcat(s, "s");
if (crc32("zRJLUjsJtxsUVQ",14) == 1753620648) strcat(s, "l");
if (crc32("XrgkCXoauIP",11) == 4226355759) strcat(s, "y");
    return s;
}

char *massively_adverbs() {
    char *s = calloc(10);
    if (crc32("yVUTZiZXZo",10) == 1085516202) strcat(s, "m");
if (crc32("wargO",5) == 3778549579) strcat(s, "g");
if (crc32("UPCxwmepnnmj",12) == 2430524165) strcat(s, "a");
if (crc32("dpbYPKyUJGLC",12) == 1490099523) strcat(s, "s");
if (crc32("WvUJunlQFIm",11) == 2227121534) strcat(s, "s");
if (crc32("iOupvhgzUvggS",13) == 1413250874) strcat(s, "s");
if (crc32("LXjCIsTVQcfXqdH",15) == 218001750) strcat(s, "i");
if (crc32("nFGVuHpoe",9) == 338206383) strcat(s, "Z");
if (crc32("lIFVDGvaQwGXFYr",15) == 2723954964) strcat(s, "v");
if (crc32("FlwwMWCvPDKh",12) == 4048286260) strcat(s, "I");
if (crc32("SzswgaeSylpu",12) == 768487541) strcat(s, "e");
if (crc32("gHdxUdCPZEkL",12) == 283011183) strcat(s, "j");
if (crc32("PortgrfjKearQ",13) == 4177647185) strcat(s, "l");
if (crc32("fTKEiyGtZX",10) == 1931534747) strcat(s, "s");
if (crc32("xGiWmxBjO",9) == 1154036451) strcat(s, "y");
    return s;
}

char *climatically_adverbs() {
    char *s = calloc(13);
    if (crc32("FAEYBCmzqWteVD",14) == 2361574085) strcat(s, "N");
if (crc32("hjiCDIwBdyYVlo",14) == 2641696306) strcat(s, "c");
if (crc32("JuQNFwl",7) == 137204606) strcat(s, "l");
if (crc32("FQxFMCIDLfGxNTG",15) == 2142306316) strcat(s, "P");
if (crc32("VweNKGZPPT",10) == 3732989863) strcat(s, "i");
if (crc32("RLeOIrsDAicCY",13) == 1748742268) strcat(s, "m");
if (crc32("IEbwJqQF",8) == 3342057430) strcat(s, "y");
if (crc32("sSpHzjYFAQTR",12) == 2707338171) strcat(s, "a");
if (crc32("zSrnymptYPV",11) == 3050716632) strcat(s, "t");
if (crc32("YEXoerqxZitS",12) == 3836093172) strcat(s, "i");
if (crc32("QCPVRPvUJUnq",12) == 1879175612) strcat(s, "c");
if (crc32("moevtiBk",8) == 3337457594) strcat(s, "a");
if (crc32("WrIbIUuGTvcx",12) == 837911203) strcat(s, "U");
if (crc32("JENvKzziVSjALyz",15) == 2157085799) strcat(s, "l");
if (crc32("kcwUGeaqTcXy",12) == 3596738072) strcat(s, "o");
if (crc32("DiXhUaxVz",9) == 737434647) strcat(s, "l");
if (crc32("gDPPkFLRZhU",11) == 3656665984) strcat(s, "y");
    return s;
}

char *unprudentially_adverbs() {
    char *s = calloc(15);
    if (crc32("nJDyWzjxSeg",11) == 1152952058) strcat(s, "u");
if (crc32("fmsOkWMlKduHt",13) == 2809889979) strcat(s, "o");
if (crc32("YAohdyHIfDML",12) == 3259769900) strcat(s, "n");
if (crc32("kfIDvLxDPoJO",12) == 1071963587) strcat(s, "k");
if (crc32("dPwDlLGd",8) == 1419058163) strcat(s, "p");
if (crc32("LbYStLqJSkkHFd",14) == 3206558373) strcat(s, "g");
if (crc32("grwrZqLNAqMm",12) == 1518261332) strcat(s, "r");
if (crc32("YbytDloUDzKngY",14) == 2240644164) strcat(s, "u");
if (crc32("kengr",5) == 4073110826) strcat(s, "d");
if (crc32("mpfcmJjcLleea",13) == 523807954) strcat(s, "q");
if (crc32("ykvTHysxenWx",12) == 1193525908) strcat(s, "e");
if (crc32("QcarvPuR",8) == 4086266242) strcat(s, "n");
if (crc32("baocJBuNJYhMUWr",15) == 1480396886) strcat(s, "t");
if (crc32("FmDVUOmpDO",10) == 3437629544) strcat(s, "t");
if (crc32("CJsJYeFnMbw",11) == 3742405667) strcat(s, "i");
if (crc32("KTPWrKsDOMk",11) == 1772250668) strcat(s, "T");
if (crc32("VIxSQqkYutA",11) == 209207893) strcat(s, "a");
if (crc32("XfqZoWMoNCvJ",12) == 3481574174) strcat(s, "A");
if (crc32("wetytNcoDsiOT",13) == 1712965351) strcat(s, "l");
if (crc32("ZmmvuAqC",8) == 2098592621) strcat(s, "l");
if (crc32("WVOZn",5) == 871335876) strcat(s, "y");
    return s;
}

char *overtightly_adverbs() {
    char *s = calloc(12);
    if (crc32("LPjhwcQaqZUMaR",14) == 303042979) strcat(s, "D");
if (crc32("stlNSStbmaD",11) == 1034384763) strcat(s, "o");
if (crc32("oAiPfhRqB",9) == 3144308413) strcat(s, "v");
if (crc32("Gmnye",5) == 1691479512) strcat(s, "e");
if (crc32("DiUOjiB",7) == 1492805362) strcat(s, "r");
if (crc32("pnJvb",5) == 1681383834) strcat(s, "H");
if (crc32("gHpBlV",6) == 2681316497) strcat(s, "t");
if (crc32("FGKdSfeDOgIfawp",15) == 2412839555) strcat(s, "t");
if (crc32("vGwaIZV",7) == 1979079506) strcat(s, "i");
if (crc32("uVqYMEUaaAokiu",14) == 2846611243) strcat(s, "m");
if (crc32("wmsiILotQv",10) == 4193091080) strcat(s, "g");
if (crc32("BepAMkMIYoACu",13) == 2667341018) strcat(s, "h");
if (crc32("goGVJH",6) == 4266598369) strcat(s, "j");
if (crc32("YaCiBHbT",8) == 1799212333) strcat(s, "t");
if (crc32("fjXRPC",6) == 2281878245) strcat(s, "l");
if (crc32("qZqATxRu",8) == 2449427579) strcat(s, "y");
    return s;
}

char *logily_adverbs() {
    char *s = calloc(7);
    if (crc32("ChtkoqIpZTjrNdj",15) == 1080461488) strcat(s, "l");
if (crc32("fnoTEhzmxUiS",12) == 567548646) strcat(s, "o");
if (crc32("UqrhxSNJSPYRNyS",15) == 790183612) strcat(s, "R");
if (crc32("PVPahixI",8) == 2309981089) strcat(s, "g");
if (crc32("wenIcC",6) == 964953808) strcat(s, "H");
if (crc32("HNjvxRBka",9) == 720195122) strcat(s, "i");
if (crc32("AjlXSWxbnBDQAM",14) == 2042799434) strcat(s, "l");
if (crc32("FarSwRyQmwzV",12) == 2014927682) strcat(s, "y");
    return s;
}

char *cloudlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("DGvraUZgNCxSu",13) == 2472766652) strcat(s, "c");
if (crc32("bmDUIrZQDufh",12) == 1487526288) strcat(s, "l");
if (crc32("pZhDyAUSTFpgk",13) == 1026266604) strcat(s, "Z");
if (crc32("PMsje",5) == 1664252101) strcat(s, "o");
if (crc32("qxqKMlTUDu",10) == 1697283111) strcat(s, "f");
if (crc32("ElRUXTJhneTEeE",14) == 2467714910) strcat(s, "u");
if (crc32("manQeqbGJXQjWs",14) == 1647130087) strcat(s, "Y");
if (crc32("UIZEiCbAPnSeqp",14) == 1477367824) strcat(s, "d");
if (crc32("WOvdGhPVaSkIS",13) == 1571789439) strcat(s, "l");
if (crc32("pFdCPk",6) == 3406870466) strcat(s, "e");
if (crc32("LkCcJtzwesuF",12) == 4221807851) strcat(s, "s");
if (crc32("UKqGKZJc",8) == 3273799860) strcat(s, "I");
if (crc32("ChOiLz",6) == 4179739906) strcat(s, "s");
if (crc32("EDFirNK",7) == 1451925015) strcat(s, "l");
if (crc32("zlxJyMrIF",9) == 388360027) strcat(s, "X");
if (crc32("bbiyhvygQWtF",12) == 2211569883) strcat(s, "y");
    return s;
}

char *unisexually_adverbs() {
    char *s = calloc(12);
    if (crc32("ZetsELL",7) == 1658846346) strcat(s, "u");
if (crc32("QLpDVmRotHTdsSX",15) == 178362454) strcat(s, "H");
if (crc32("cXIFZICWDMWy",12) == 2413720926) strcat(s, "n");
if (crc32("IrkcoMnfRfrP",12) == 1864340104) strcat(s, "i");
if (crc32("bwNqQ",5) == 2205467146) strcat(s, "s");
if (crc32("CHBkPNUmBSsChQ",14) == 1008818465) strcat(s, "r");
if (crc32("qrKXGq",6) == 1143927860) strcat(s, "e");
if (crc32("CdGhtdXaxlnCuN",14) == 139472674) strcat(s, "x");
if (crc32("KwVINTQNZGU",11) == 2054455077) strcat(s, "P");
if (crc32("ThSrbMQGzy",10) == 195215632) strcat(s, "u");
if (crc32("vQBnNfMuQTVJKg",14) == 3481173467) strcat(s, "U");
if (crc32("qcZJhkYVFZPOBL",14) == 1198512775) strcat(s, "a");
if (crc32("gAhIhreMg",9) == 459012981) strcat(s, "l");
if (crc32("OVLkdABbNa",10) == 2542361384) strcat(s, "Y");
if (crc32("gUHTfgoNGcllN",13) == 1661126992) strcat(s, "l");
if (crc32("qDfGpIphutAhY",13) == 1248780253) strcat(s, "y");
    return s;
}

char *alphabetically_adverbs() {
    char *s = calloc(15);
    if (crc32("bdJwEIrqbAWssYs",15) == 3899422924) strcat(s, "Z");
if (crc32("bwBxatMimk",10) == 4258532990) strcat(s, "a");
if (crc32("NCuGp",5) == 357033123) strcat(s, "l");
if (crc32("mUCKAuT",7) == 924739859) strcat(s, "p");
if (crc32("TdJaBTV",7) == 2646552372) strcat(s, "N");
if (crc32("hahqoAwafyx",11) == 2770329138) strcat(s, "h");
if (crc32("BsLrx",5) == 2815190424) strcat(s, "a");
if (crc32("ZMeNsKotEZKtxc",14) == 3141191058) strcat(s, "b");
if (crc32("WcQuwUX",7) == 113469639) strcat(s, "K");
if (crc32("KMNqcupFZ",9) == 654568194) strcat(s, "e");
if (crc32("xhdVHr",6) == 2771383752) strcat(s, "t");
if (crc32("WUeKkS",6) == 1424363109) strcat(s, "i");
if (crc32("OdvOcQ",6) == 2628456575) strcat(s, "L");
if (crc32("vZjsoojxuNhGjzg",15) == 1405922358) strcat(s, "c");
if (crc32("tJyPFYAJ",8) == 453262818) strcat(s, "a");
if (crc32("LpqcQuywVJdt",12) == 1231688390) strcat(s, "l");
if (crc32("WtVIZunIvBiI",12) == 1537990798) strcat(s, "t");
if (crc32("feoNkqqmuJsAo",13) == 3040233466) strcat(s, "l");
if (crc32("EAdwNlye",8) == 3348584092) strcat(s, "y");
    return s;
}

char *nonpliably_adverbs() {
    char *s = calloc(11);
    if (crc32("QayXcfrhQIScp",13) == 944329422) strcat(s, "n");
if (crc32("hXiineoNwRIvn",13) == 793468015) strcat(s, "t");
if (crc32("DlZDtKJzqGdmY",13) == 2389295107) strcat(s, "o");
if (crc32("bdVsZmg",7) == 1407868453) strcat(s, "i");
if (crc32("LIoqI",5) == 3348260988) strcat(s, "n");
if (crc32("igAmGCmEjgn",11) == 1874343299) strcat(s, "M");
if (crc32("yYcprQAoIvDLcK",14) == 700600262) strcat(s, "p");
if (crc32("BQnqhLM",7) == 1463142882) strcat(s, "A");
if (crc32("MebqvRMFus",10) == 1601106436) strcat(s, "l");
if (crc32("KXLCoYUAJoOpkyc",15) == 706371977) strcat(s, "i");
if (crc32("EXsspRkPNQrDwN",14) == 1808713) strcat(s, "a");
if (crc32("GjdzgaLay",9) == 1285971107) strcat(s, "b");
if (crc32("lkGkNMZOPkCM",12) == 3051610077) strcat(s, "l");
if (crc32("ieoICcPnn",9) == 1256396236) strcat(s, "Z");
if (crc32("UNlnqkhLee",10) == 2062960358) strcat(s, "y");
    return s;
}

char *patentably_adverbs() {
    char *s = calloc(11);
    if (crc32("YNQxFRludjw",11) == 4260209264) strcat(s, "n");
if (crc32("nvPBgdvAqiJI",12) == 1769831324) strcat(s, "p");
if (crc32("kyrHtdccNSsdB",13) == 1221672218) strcat(s, "a");
if (crc32("ZkZVhqHwzxUmDs",14) == 4219545371) strcat(s, "q");
if (crc32("RltXgkCdWeNppUf",15) == 4057175383) strcat(s, "t");
if (crc32("jBNHYWtNajEGyW",14) == 3470493611) strcat(s, "R");
if (crc32("HsGFEthifwT",11) == 1723698747) strcat(s, "e");
if (crc32("qGIzsdYBcPOxhZz",15) == 3327697153) strcat(s, "n");
if (crc32("jlclNUNqxXDy",12) == 2919992180) strcat(s, "t");
if (crc32("pbnYUFLdDxhhI",13) == 3241601086) strcat(s, "i");
if (crc32("UphkDxvF",8) == 914879964) strcat(s, "a");
if (crc32("iKQaNGzCVoP",11) == 3088661956) strcat(s, "r");
if (crc32("MtpvDc",6) == 1975251075) strcat(s, "b");
if (crc32("CQBmFBVauy",10) == 924578136) strcat(s, "W");
if (crc32("bqmmhx",6) == 1257613697) strcat(s, "l");
if (crc32("wOzNjFH",7) == 2977321536) strcat(s, "E");
if (crc32("SEUxhgx",7) == 3155878325) strcat(s, "y");
    return s;
}

char *subjudicially_adverbs() {
    char *s = calloc(14);
    if (crc32("BTWYR",5) == 663849521) strcat(s, "s");
if (crc32("vSxhiRc",7) == 3033451343) strcat(s, "u");
if (crc32("dGzWOUFIbg",10) == 289623201) strcat(s, "b");
if (crc32("uVIPBB",6) == 547595121) strcat(s, "j");
if (crc32("MRIPLNwtWkjG",12) == 4038565820) strcat(s, "j");
if (crc32("ljGuwFOqdiMlS",13) == 3601993230) strcat(s, "u");
if (crc32("mPewlnIpjac",11) == 697236710) strcat(s, "g");
if (crc32("bCeBam",6) == 3685627127) strcat(s, "d");
if (crc32("cfiHDsKWQbbRCkn",15) == 2177271011) strcat(s, "r");
if (crc32("qdzhpKFUmPdb",12) == 3868487363) strcat(s, "i");
if (crc32("YKeOU",5) == 593897215) strcat(s, "e");
if (crc32("GIKSFCKmfTbZ",12) == 2282703935) strcat(s, "c");
if (crc32("CcmdUTA",7) == 108141515) strcat(s, "i");
if (crc32("atODxPRixH",10) == 4201539735) strcat(s, "n");
if (crc32("upQlFqs",7) == 3617725104) strcat(s, "a");
if (crc32("zTwJlstZ",8) == 1827043502) strcat(s, "l");
if (crc32("gIwTLMocv",9) == 373936281) strcat(s, "l");
if (crc32("rbJLebAHh",9) == 4162827326) strcat(s, "y");
    return s;
}

char *unguidedly_adverbs() {
    char *s = calloc(11);
    if (crc32("hwVclOwt",8) == 4243983352) strcat(s, "E");
if (crc32("birKPtYWZ",9) == 2218238967) strcat(s, "u");
if (crc32("ZodoXMYnxFIV",12) == 3805342166) strcat(s, "n");
if (crc32("hpuhzTuKXabbDJ",14) == 1924364471) strcat(s, "g");
if (crc32("aXZXrKikKbccoHf",15) == 1051706660) strcat(s, "j");
if (crc32("PouyetjK",8) == 3284914919) strcat(s, "u");
if (crc32("jmDDKBY",7) == 334645060) strcat(s, "i");
if (crc32("eHVWjmjES",9) == 2078890005) strcat(s, "d");
if (crc32("JaUwWWNrcCb",11) == 476056571) strcat(s, "e");
if (crc32("YAOXOSa",7) == 1253031729) strcat(s, "r");
if (crc32("IHMCQjvVbtyuxq",14) == 1083852593) strcat(s, "d");
if (crc32("HLLhnN",6) == 852937545) strcat(s, "l");
if (crc32("DtBUaaQhrTsZ",12) == 2610980143) strcat(s, "F");
if (crc32("OpQBiuwiOgKDhsY",15) == 127072649) strcat(s, "y");
    return s;
}

char *unadroitly_adverbs() {
    char *s = calloc(11);
    if (crc32("KVhsBGxJtYuY",12) == 3837027288) strcat(s, "Z");
if (crc32("wCBpgfsOTjxH",12) == 4124199271) strcat(s, "u");
if (crc32("hcMBaHhmguN",11) == 3746936993) strcat(s, "n");
if (crc32("BJFiqw",6) == 4242255941) strcat(s, "Y");
if (crc32("dmkyvOUQLObJN",13) == 1166310059) strcat(s, "a");
if (crc32("FNXzKcDHWhp",11) == 1645141175) strcat(s, "b");
if (crc32("fCNHEykydodNL",13) == 1022615885) strcat(s, "d");
if (crc32("MStyBFo",7) == 553637219) strcat(s, "r");
if (crc32("TNbfdQ",6) == 934283440) strcat(s, "L");
if (crc32("xqrqFlpMlRV",11) == 189497535) strcat(s, "o");
if (crc32("cMWCYRyCmZPTD",13) == 160412663) strcat(s, "i");
if (crc32("PhDBioePMDaGsBs",15) == 4086403328) strcat(s, "g");
if (crc32("TzWZtG",6) == 27649936) strcat(s, "t");
if (crc32("mIHanTUMbBVBW",13) == 2325363202) strcat(s, "l");
if (crc32("kMofRb",6) == 2008853927) strcat(s, "l");
if (crc32("puCNb",5) == 469294011) strcat(s, "F");
if (crc32("uTGNCmvzSG",10) == 1833627740) strcat(s, "y");
    return s;
}

char *diligently_adverbs() {
    char *s = calloc(11);
    if (crc32("CLlaMwVonUMy",12) == 200970385) strcat(s, "N");
if (crc32("nLnGtjggkZhkXyW",15) == 3249686235) strcat(s, "d");
if (crc32("EiHDnUxoXA",10) == 2517371089) strcat(s, "l");
if (crc32("HigjE",5) == 1018410891) strcat(s, "i");
if (crc32("xvnrpYWv",8) == 1611515873) strcat(s, "l");
if (crc32("QwermbGKqqbn",12) == 2748739206) strcat(s, "c");
if (crc32("GupoQjl",7) == 1808852408) strcat(s, "i");
if (crc32("spXphnINTsElXi",14) == 2053823769) strcat(s, "A");
if (crc32("PEgEa",5) == 2832771058) strcat(s, "g");
if (crc32("wHEdjD",6) == 180737911) strcat(s, "F");
if (crc32("oCXBk",5) == 778111501) strcat(s, "e");
if (crc32("idydgPJDnZweh",13) == 1633442414) strcat(s, "n");
if (crc32("qxjSddAb",8) == 3183948948) strcat(s, "t");
if (crc32("hCvdvBCMX",9) == 2940798095) strcat(s, "l");
if (crc32("NFxKsVLukj",10) == 3985326836) strcat(s, "H");
if (crc32("bCIYg",5) == 1804959818) strcat(s, "y");
    return s;
}

char *unforwardly_adverbs() {
    char *s = calloc(12);
    if (crc32("nPavixlRlAWT",12) == 3406231080) strcat(s, "u");
if (crc32("TbWXRpZnkwM",11) == 3701562131) strcat(s, "n");
if (crc32("ZppAj",5) == 3477741241) strcat(s, "f");
if (crc32("tsPItiZoIHhscCz",15) == 658939226) strcat(s, "o");
if (crc32("zLcVnvVfABWzq",13) == 2316916657) strcat(s, "C");
if (crc32("WPoYKHssHqHMFm",14) == 2885084391) strcat(s, "r");
if (crc32("FXmNKO",6) == 1387244228) strcat(s, "A");
if (crc32("YdQTg",5) == 656020191) strcat(s, "w");
if (crc32("sOJUimxnILyLR",13) == 3281737011) strcat(s, "K");
if (crc32("igMZmwO",7) == 1416786391) strcat(s, "a");
if (crc32("VFzcCzrzmzX",11) == 3288605780) strcat(s, "q");
if (crc32("UyVZRXbWmOSjy",13) == 825146792) strcat(s, "r");
if (crc32("tdEwigUxUPLJ",12) == 507214256) strcat(s, "d");
if (crc32("ntJFe",5) == 1832585460) strcat(s, "x");
if (crc32("zKkTJrdNEywOvIa",15) == 1819065205) strcat(s, "l");
if (crc32("mwsMBXl",7) == 4075435140) strcat(s, "b");
if (crc32("KGSxFpfcs",9) == 466656259) strcat(s, "y");
    return s;
}

char *reservedly_adverbs() {
    char *s = calloc(11);
    if (crc32("tnrxBkCpy",9) == 4157905223) strcat(s, "V");
if (crc32("MZazivKm",8) == 369737085) strcat(s, "r");
if (crc32("xpCjMe",6) == 1062190143) strcat(s, "k");
if (crc32("SPKNNOsNb",9) == 887868145) strcat(s, "e");
if (crc32("NQfpJHpFIhnOYy",14) == 2333715001) strcat(s, "M");
if (crc32("ZXqZLRTErdkSPF",14) == 3222063495) strcat(s, "s");
if (crc32("zqJhIkQHuoDMzF",14) == 2330312303) strcat(s, "e");
if (crc32("yJfBmYKYr",9) == 3602385477) strcat(s, "r");
if (crc32("YMLVLiuO",8) == 3887142361) strcat(s, "v");
if (crc32("etlXpqUpcr",10) == 621347388) strcat(s, "o");
if (crc32("ApCgslKMwgzSt",13) == 4270798907) strcat(s, "e");
if (crc32("vfjoOB",6) == 2196252062) strcat(s, "d");
if (crc32("UxATIerXkwDN",12) == 1812934617) strcat(s, "i");
if (crc32("BKqBUknwVeqkC",13) == 3373859932) strcat(s, "l");
if (crc32("sGzGrrJZw",9) == 2055072174) strcat(s, "P");
if (crc32("JMtXvpDlHvb",11) == 3823196835) strcat(s, "y");
    return s;
}

char *luculently_adverbs() {
    char *s = calloc(11);
    if (crc32("sbEIvrqOYv",10) == 414998927) strcat(s, "l");
if (crc32("tRstF",5) == 2792830123) strcat(s, "k");
if (crc32("aQioeAcZdcCeEY",14) == 1354229763) strcat(s, "u");
if (crc32("cEMwaLtewur",11) == 3144081126) strcat(s, "c");
if (crc32("sKWGTuNvaKqRwXH",15) == 3962200835) strcat(s, "u");
if (crc32("AWHObLrcWbO",11) == 4045282837) strcat(s, "F");
if (crc32("eynaDzBvdYRjnf",14) == 2144091516) strcat(s, "l");
if (crc32("OodJnYEF",8) == 3278042218) strcat(s, "e");
if (crc32("OPbgzABWfTHQiCV",15) == 3836575078) strcat(s, "n");
if (crc32("IrtkCZU",7) == 3286849071) strcat(s, "t");
if (crc32("HVfBDbZm",8) == 2394559705) strcat(s, "f");
if (crc32("XdIjERF",7) == 2116586725) strcat(s, "l");
if (crc32("biGFRXaK",8) == 3820595191) strcat(s, "v");
if (crc32("YfEFCdhZhDxh",12) == 3558628129) strcat(s, "y");
    return s;
}

char *totemically_adverbs() {
    char *s = calloc(12);
    if (crc32("VZJguYpeURB",11) == 3741000269) strcat(s, "t");
if (crc32("cAoQWEtcfeOtend",15) == 626391378) strcat(s, "S");
if (crc32("OjnxFziRwUW",11) == 417314573) strcat(s, "o");
if (crc32("nyEmDVgfrEpxJ",13) == 1271467906) strcat(s, "t");
if (crc32("eNKXmHzNfy",10) == 518915100) strcat(s, "h");
if (crc32("igBmhLai",8) == 138356315) strcat(s, "e");
if (crc32("NktGOt",6) == 3681797762) strcat(s, "m");
if (crc32("tbVaRMEEIyqmq",13) == 877318395) strcat(s, "v");
if (crc32("FGWjavrsxAlnWzg",15) == 3371205973) strcat(s, "i");
if (crc32("sLyLHaPjBFr",11) == 419520108) strcat(s, "c");
if (crc32("fPlUxfNsYVMBNCB",15) == 1882121394) strcat(s, "z");
if (crc32("HESBTqajDTiz",12) == 3096916092) strcat(s, "a");
if (crc32("SGOSTMh",7) == 4078708506) strcat(s, "l");
if (crc32("FJXczoBEsq",10) == 3532149306) strcat(s, "l");
if (crc32("dzKoaBfEavp",11) == 2322703941) strcat(s, "y");
    return s;
}

char *nonjuristically_adverbs() {
    char *s = calloc(16);
    if (crc32("JPbQBfjYCpe",11) == 3325686033) strcat(s, "o");
if (crc32("GvyEeoLgmw",10) == 2018159541) strcat(s, "n");
if (crc32("KVWZKEUHq",9) == 1306634729) strcat(s, "x");
if (crc32("MOScBNfiGVuHtB",14) == 4018437395) strcat(s, "o");
if (crc32("rWDztKQOqx",10) == 1037526802) strcat(s, "n");
if (crc32("sjLxjXibROi",11) == 420328695) strcat(s, "P");
if (crc32("iqcQa",5) == 1376218490) strcat(s, "j");
if (crc32("HjvCSoq",7) == 1774853689) strcat(s, "Q");
if (crc32("kjejUOSJHfHpbG",14) == 31929455) strcat(s, "u");
if (crc32("WoMWGKTNLNa",11) == 359958661) strcat(s, "r");
if (crc32("pEAeJFBfsyLR",12) == 2943058387) strcat(s, "i");
if (crc32("sGvcAzthsmdX",12) == 2499511416) strcat(s, "h");
if (crc32("Bcbyyyt",7) == 3353880996) strcat(s, "s");
if (crc32("aqDTtiSusrppvl",14) == 983137803) strcat(s, "t");
if (crc32("bCJvooJC",8) == 1164922474) strcat(s, "P");
if (crc32("PQREalr",7) == 2837728403) strcat(s, "i");
if (crc32("BniSjxItA",9) == 267543277) strcat(s, "c");
if (crc32("QKDBhjmkS",9) == 2296438019) strcat(s, "V");
if (crc32("bbhlq",5) == 477172513) strcat(s, "a");
if (crc32("kgEdShFFNDIKlvt",15) == 4033668420) strcat(s, "C");
if (crc32("NUCuTEXeh",9) == 2609253003) strcat(s, "l");
if (crc32("iiXDik",6) == 2429190413) strcat(s, "N");
if (crc32("aFtXXPJCR",9) == 1514904353) strcat(s, "l");
if (crc32("VAVVuowTzJSO",12) == 1184357549) strcat(s, "y");
    return s;
}

char *illnaturedly_adverbs() {
    char *s = calloc(13);
    if (crc32("NmoUyERPIb",10) == 1120527686) strcat(s, "X");
if (crc32("vwUWCcXbzSiv",12) == 1475816847) strcat(s, "i");
if (crc32("VUbKOju",7) == 3192219508) strcat(s, "J");
if (crc32("CpboolMDDq",10) == 2165228894) strcat(s, "l");
if (crc32("wFCpvsRsel",10) == 433671757) strcat(s, "l");
if (crc32("EVAtvap",7) == 537604848) strcat(s, "b");
if (crc32("tFySRVjJBG",10) == 3858119642) strcat(s, "n");
if (crc32("fLkmSiACXm",10) == 1847121031) strcat(s, "a");
if (crc32("QvDjFsVinqpC",12) == 2787635421) strcat(s, "t");
if (crc32("DVLMg",5) == 2381741939) strcat(s, "I");
if (crc32("omkdPFC",7) == 722735079) strcat(s, "u");
if (crc32("JQnfux",6) == 3003441789) strcat(s, "c");
if (crc32("rqCkMzadW",9) == 1444735341) strcat(s, "r");
if (crc32("IRqraGLbPiDppj",14) == 4070380874) strcat(s, "e");
if (crc32("ubAyAErjQ",9) == 4276384233) strcat(s, "o");
if (crc32("ZNZTnaevfeQ",11) == 149852323) strcat(s, "d");
if (crc32("jwhlOgjZ",8) == 803222733) strcat(s, "l");
if (crc32("Gpyvst",6) == 1333534556) strcat(s, "y");
    return s;
}

char *incommensurably_adverbs() {
    char *s = calloc(16);
    if (crc32("uGRWlEuxOqqy",12) == 795403184) strcat(s, "T");
if (crc32("xQNlJB",6) == 4219621901) strcat(s, "i");
if (crc32("uaIuSuEM",8) == 3151478605) strcat(s, "n");
if (crc32("ptYyvV",6) == 2700792619) strcat(s, "c");
if (crc32("PjHkXVmyFhg",11) == 1015968358) strcat(s, "f");
if (crc32("ioTDTYvsPFmiRyQ",15) == 3211904612) strcat(s, "o");
if (crc32("lYqQQ",5) == 2362868249) strcat(s, "i");
if (crc32("KoVIzrrAIDAztNH",15) == 2838353136) strcat(s, "m");
if (crc32("WZAohCw",7) == 3965376529) strcat(s, "H");
if (crc32("KYwJWbNVzQDUy",13) == 3106431877) strcat(s, "m");
if (crc32("lOWJhEQIV",9) == 3535095375) strcat(s, "R");
if (crc32("SAevaqZ",7) == 2690425770) strcat(s, "e");
if (crc32("LugaXwsUzVKPQz",14) == 505530714) strcat(s, "V");
if (crc32("KAoUa",5) == 1952175583) strcat(s, "n");
if (crc32("SxabiznlLmEmw",13) == 2298024308) strcat(s, "s");
if (crc32("cuSzzMwpptkoF",13) == 3518805401) strcat(s, "u");
if (crc32("bNOdpMBBUbRo",12) == 1290358165) strcat(s, "s");
if (crc32("rnUgvNQjD",9) == 396741828) strcat(s, "r");
if (crc32("XkGQYAUQ",8) == 3346250590) strcat(s, "p");
if (crc32("dOeZul",6) == 2207985632) strcat(s, "a");
if (crc32("KwdTyHQDrnXjZaB",15) == 3509505380) strcat(s, "H");
if (crc32("nekimHY",7) == 3691576532) strcat(s, "b");
if (crc32("VZzHSQxNy",9) == 2574748447) strcat(s, "l");
if (crc32("fUVplNZ",7) == 1370246455) strcat(s, "y");
    return s;
}

char *certifiably_adverbs() {
    char *s = calloc(12);
    if (crc32("gIrfWEWpLZgW",12) == 2487597286) strcat(s, "k");
if (crc32("iKqqSihOiIIZNb",14) == 183527840) strcat(s, "c");
if (crc32("arONRMFFoI",10) == 559644613) strcat(s, "e");
if (crc32("KtNSGo",6) == 911799458) strcat(s, "V");
if (crc32("bCVhFYO",7) == 3091551385) strcat(s, "r");
if (crc32("lafGAZM",7) == 990029949) strcat(s, "t");
if (crc32("fqdfdHbS",8) == 3553285932) strcat(s, "i");
if (crc32("DUPCRmZg",8) == 407642495) strcat(s, "f");
if (crc32("OYBhdFDuaNvl",12) == 269152477) strcat(s, "r");
if (crc32("xpOAAYdZI",9) == 2759403117) strcat(s, "i");
if (crc32("htAxuZaXAUzVM",13) == 2157340141) strcat(s, "b");
if (crc32("tApxDOkHRy",10) == 3683027162) strcat(s, "a");
if (crc32("MUoiqU",6) == 4023537073) strcat(s, "C");
if (crc32("GXogDh",6) == 1381844710) strcat(s, "b");
if (crc32("OdlHMI",6) == 1623190744) strcat(s, "L");
if (crc32("ymWRcEEba",9) == 1067718877) strcat(s, "l");
if (crc32("vUIFkQPGMYqivr",14) == 203949692) strcat(s, "x");
if (crc32("wvtVsoamlzs",11) == 1843588735) strcat(s, "y");
    return s;
}

char *nonferociously_adverbs() {
    char *s = calloc(15);
    if (crc32("UeHsmIpdpdcjdR",14) == 484897095) strcat(s, "q");
if (crc32("zwFWENbeakz",11) == 575880367) strcat(s, "n");
if (crc32("cuyOktTgjjwgjQR",15) == 3827498039) strcat(s, "o");
if (crc32("JVAFryTAvVlnsw",14) == 1799275901) strcat(s, "F");
if (crc32("ItzrLAKPpdKmE",13) == 2361287107) strcat(s, "n");
if (crc32("QIraQmPxjGO",11) == 2807462705) strcat(s, "T");
if (crc32("YdedZEFsAoFjePo",15) == 1581791890) strcat(s, "f");
if (crc32("vwpzYeSq",8) == 3491715754) strcat(s, "e");
if (crc32("fwaQKOtaP",9) == 1872222311) strcat(s, "O");
if (crc32("FIaCklpGglAqD",13) == 2422864275) strcat(s, "r");
if (crc32("FGcGPrmrVXZ",11) == 1005366062) strcat(s, "o");
if (crc32("QTcmVHE",7) == 3458758607) strcat(s, "c");
if (crc32("VBrKSNBASD",10) == 3257295544) strcat(s, "i");
if (crc32("sodkDRuZCCBJ",12) == 3400484424) strcat(s, "Q");
if (crc32("RzzIsXDmNuar",12) == 147893728) strcat(s, "o");
if (crc32("BoYLDEKVOU",10) == 1316895652) strcat(s, "r");
if (crc32("NPtTovdCin",10) == 3115723585) strcat(s, "u");
if (crc32("PGyVhXz",7) == 842402619) strcat(s, "s");
if (crc32("gjRqpz",6) == 2630589710) strcat(s, "H");
if (crc32("dCFdQx",6) == 824917872) strcat(s, "l");
if (crc32("OdXBqYiCtZ",10) == 967274649) strcat(s, "J");
if (crc32("SORbXoPSCukGUQH",15) == 3459445867) strcat(s, "y");
    return s;
}

char *unjuridically_adverbs() {
    char *s = calloc(14);
    if (crc32("MkTBkkuYWOnlu",13) == 3664846799) strcat(s, "u");
if (crc32("BIOrVVd",7) == 3006614164) strcat(s, "n");
if (crc32("FdKYbAIRL",9) == 1793873398) strcat(s, "y");
if (crc32("gTYuL",5) == 3876606338) strcat(s, "j");
if (crc32("BSMoocTZUWF",11) == 4111577424) strcat(s, "a");
if (crc32("MDCDi",5) == 2693842155) strcat(s, "u");
if (crc32("XjThjXuZuf",10) == 2205040750) strcat(s, "r");
if (crc32("ZOxqlYVy",8) == 3890290154) strcat(s, "i");
if (crc32("jfmuiNSOWcR",11) == 2036817331) strcat(s, "d");
if (crc32("lunCUCPCd",9) == 572420176) strcat(s, "I");
if (crc32("zThCpulROZEM",12) == 1345987308) strcat(s, "i");
if (crc32("nZbmWUnMLNteT",13) == 2018077243) strcat(s, "E");
if (crc32("ujcIWVcxHvhPAD",14) == 1024821795) strcat(s, "c");
if (crc32("HfsUGrNsHbfS",12) == 2684547112) strcat(s, "C");
if (crc32("FAsCVs",6) == 602660756) strcat(s, "a");
if (crc32("wiYHI",5) == 3667961936) strcat(s, "I");
if (crc32("cUpgSsGzx",9) == 2673537786) strcat(s, "l");
if (crc32("omTfSEtwiCM",11) == 2527429135) strcat(s, "l");
if (crc32("vpBzuk",6) == 3555805017) strcat(s, "A");
if (crc32("OgdFb",5) == 4029774900) strcat(s, "y");
    return s;
}

char *nonexponentially_adverbs() {
    char *s = calloc(17);
    if (crc32("spCgaHVY",8) == 3645746067) strcat(s, "j");
if (crc32("nllAAGQf",8) == 2818374092) strcat(s, "n");
if (crc32("WSMMVrT",7) == 4016642865) strcat(s, "R");
if (crc32("LrkPxHSR",8) == 4264989663) strcat(s, "o");
if (crc32("AqJuVGV",7) == 1786260041) strcat(s, "j");
if (crc32("kTxbvidxc",9) == 1071107056) strcat(s, "n");
if (crc32("ZyIjoZGqaXDmOyf",15) == 3766761333) strcat(s, "z");
if (crc32("AkdxSW",6) == 287026506) strcat(s, "e");
if (crc32("BwWGTuC",7) == 34074365) strcat(s, "x");
if (crc32("sakWLh",6) == 747168515) strcat(s, "q");
if (crc32("djqtPa",6) == 4048586988) strcat(s, "p");
if (crc32("HyYwsxG",7) == 1554480178) strcat(s, "o");
if (crc32("rcxChwmcQygJq",13) == 3978028969) strcat(s, "n");
if (crc32("mhWhWETWBJVlv",13) == 2376181508) strcat(s, "a");
if (crc32("QHWVIgosxNPJy",13) == 2907032810) strcat(s, "e");
if (crc32("GkebycFUEDS",11) == 4112473659) strcat(s, "n");
if (crc32("FMxJLBKNyv",10) == 1618073838) strcat(s, "X");
if (crc32("XublxN",6) == 3326989859) strcat(s, "t");
if (crc32("HnqBcmKBQkJf",12) == 3425315687) strcat(s, "i");
if (crc32("GWRbnHlhqFT",11) == 1289129002) strcat(s, "D");
if (crc32("ZiQix",5) == 1966142873) strcat(s, "a");
if (crc32("daFhRY",6) == 1274354411) strcat(s, "d");
if (crc32("KJlnyBEqIdio",12) == 1793412629) strcat(s, "l");
if (crc32("IDjijR",6) == 1024217267) strcat(s, "l");
if (crc32("aqVdygZIvqMmaK",14) == 507185306) strcat(s, "y");
    return s;
}

char *unpeevishly_adverbs() {
    char *s = calloc(12);
    if (crc32("aFHOGUYvW",9) == 839826773) strcat(s, "u");
if (crc32("fVrsZRoqQ",9) == 3592166695) strcat(s, "n");
if (crc32("FOmHXYp",7) == 577244291) strcat(s, "p");
if (crc32("njbiyYnhcWLdC",13) == 4012134887) strcat(s, "N");
if (crc32("ioFxulZgN",9) == 1167672124) strcat(s, "e");
if (crc32("OwHuAooLYsap",12) == 3915064083) strcat(s, "e");
if (crc32("reQlLbuMuZSK",12) == 2858654491) strcat(s, "v");
if (crc32("vEWlEXBz",8) == 513350896) strcat(s, "T");
if (crc32("eRxvBdxswhyTqr",14) == 4160684685) strcat(s, "i");
if (crc32("znLyBZhd",8) == 3098432030) strcat(s, "s");
if (crc32("LNSLwKIkNGDeH",13) == 2046863325) strcat(s, "N");
if (crc32("aocJBziWDtjMZ",13) == 3324987590) strcat(s, "h");
if (crc32("ploCTysgcjWCHW",14) == 2391508436) strcat(s, "l");
if (crc32("EJalCpP",7) == 3911455547) strcat(s, "E");
if (crc32("exkSDia",7) == 1842377148) strcat(s, "y");
    return s;
}

char *precociously_adverbs() {
    char *s = calloc(13);
    if (crc32("LMfkgVrf",8) == 2040263880) strcat(s, "p");
if (crc32("akLOCqeiq",9) == 1287972863) strcat(s, "r");
if (crc32("VKUiX",5) == 2258433849) strcat(s, "e");
if (crc32("MeziQqOEyxO",11) == 1828864940) strcat(s, "a");
if (crc32("wWAcGY",6) == 3915445682) strcat(s, "c");
if (crc32("sJDcCJXnB",9) == 1135057496) strcat(s, "o");
if (crc32("zETEhKMnSyAxb",13) == 1325610854) strcat(s, "c");
if (crc32("odDkfEStA",9) == 2876457834) strcat(s, "u");
if (crc32("AxmYpsqOl",9) == 2000383670) strcat(s, "i");
if (crc32("wkwkDGkjqAH",11) == 3786894453) strcat(s, "e");
if (crc32("sCyxWgo",7) == 220978779) strcat(s, "o");
if (crc32("tFskrRXS",8) == 1309528701) strcat(s, "h");
if (crc32("VDSec",5) == 3352051189) strcat(s, "u");
if (crc32("DStRyGfHtoUVaLe",15) == 2636782940) strcat(s, "s");
if (crc32("shwunyaDCK",10) == 2750649628) strcat(s, "t");
if (crc32("uutMRokj",8) == 116596000) strcat(s, "l");
if (crc32("zcVQPeMl",8) == 3112833930) strcat(s, "y");
    return s;
}

char *overenthusiastically_adverbs() {
    char *s = calloc(21);
    if (crc32("HhxSPTD",7) == 3723448700) strcat(s, "o");
if (crc32("YDKjU",5) == 529256890) strcat(s, "v");
if (crc32("ZMjAjFUvAK",10) == 455726306) strcat(s, "e");
if (crc32("vmcyRjTak",9) == 627846406) strcat(s, "l");
if (crc32("lculbexAUFxbkZy",15) == 3866299167) strcat(s, "r");
if (crc32("AGapszwRvMxHoGM",15) == 1212106697) strcat(s, "s");
if (crc32("TEWMzPNd",8) == 1603171774) strcat(s, "e");
if (crc32("QUrEgHxBV",9) == 2082256632) strcat(s, "K");
if (crc32("OtFKmQwm",8) == 2362827444) strcat(s, "n");
if (crc32("HpAiJT",6) == 1328867176) strcat(s, "F");
if (crc32("hNHmMIBDCnaIuNH",15) == 3798061520) strcat(s, "t");
if (crc32("qOkUVApqPLqehc",14) == 1513735171) strcat(s, "u");
if (crc32("QvznGiWQNRKU",12) == 2326265160) strcat(s, "h");
if (crc32("uuqYNFTRKBkD",12) == 2306875408) strcat(s, "u");
if (crc32("EiKnCYmaM",9) == 1418263510) strcat(s, "s");
if (crc32("pdxQB",5) == 3928228551) strcat(s, "i");
if (crc32("XGwAk",5) == 2856233938) strcat(s, "a");
if (crc32("CGyZRVhagMgoSAZ",15) == 361294646) strcat(s, "s");
if (crc32("VByAKHqXVi",10) == 3700664191) strcat(s, "z");
if (crc32("sTrckYEFsgQ",11) == 3501339860) strcat(s, "t");
if (crc32("mkycWbVZFVI",11) == 4244576723) strcat(s, "i");
if (crc32("bgqvG",5) == 1204753582) strcat(s, "c");
if (crc32("TYRrHSYLRjBam",13) == 3379726676) strcat(s, "A");
if (crc32("VWAAcFvRbd",10) == 592672671) strcat(s, "a");
if (crc32("HXISV",5) == 3436023745) strcat(s, "l");
if (crc32("OdLzMYuAihgpggI",15) == 2224114389) strcat(s, "v");
if (crc32("ImVuWqWRM",9) == 1956625035) strcat(s, "l");
if (crc32("IMpFWFWW",8) == 1526900433) strcat(s, "O");
if (crc32("XLRXnNsY",8) == 2654463614) strcat(s, "y");
    return s;
}

char *runtishly_adverbs() {
    char *s = calloc(10);
    if (crc32("IZUUU",5) == 2177614546) strcat(s, "r");
if (crc32("OsuRzRADv",9) == 3030818499) strcat(s, "u");
if (crc32("MtVCMkceK",9) == 3612759458) strcat(s, "n");
if (crc32("OfzfHopGKKxCpFQ",15) == 1758029284) strcat(s, "t");
if (crc32("VrjxklYfiVhI",12) == 4080833659) strcat(s, "i");
if (crc32("tBHekzg",7) == 3777287646) strcat(s, "s");
if (crc32("RYDorRRWr",9) == 1916757350) strcat(s, "i");
if (crc32("StWtkRxRTdZwWq",14) == 2491643883) strcat(s, "h");
if (crc32("eLqnPdiKzSrOoq",14) == 4126556467) strcat(s, "b");
if (crc32("YqNARyeU",8) == 205150353) strcat(s, "l");
if (crc32("dIQLzaPNPoptw",13) == 3030183303) strcat(s, "y");
    return s;
}

char *nonresonantly_adverbs() {
    char *s = calloc(14);
    if (crc32("ShNtyuzhtzOIc",13) == 2096099404) strcat(s, "n");
if (crc32("DAHnQpc",7) == 3539978805) strcat(s, "W");
if (crc32("CwnBHnwCP",9) == 1818333029) strcat(s, "o");
if (crc32("kgOIDdLWuWgC",12) == 3475413045) strcat(s, "J");
if (crc32("EKoUtTmGBJpZ",12) == 2013089871) strcat(s, "n");
if (crc32("oVrDDkivknO",11) == 2631082608) strcat(s, "P");
if (crc32("DxEMQJLQRB",10) == 41111939) strcat(s, "r");
if (crc32("JVhYowMQ",8) == 49425404) strcat(s, "V");
if (crc32("mIGKAnthYwXiV",13) == 355677058) strcat(s, "e");
if (crc32("dxmlpJcdmMuNcxS",15) == 946296448) strcat(s, "A");
if (crc32("rSORnQlvXTasOdW",15) == 963092681) strcat(s, "s");
if (crc32("CMuljIzVlq",10) == 1862920223) strcat(s, "o");
if (crc32("KYHimuRwbplMT",13) == 1047622847) strcat(s, "t");
if (crc32("YomqKfkO",8) == 1112037552) strcat(s, "n");
if (crc32("JbKMwyKDJig",11) == 1082021553) strcat(s, "a");
if (crc32("yXcRuMGSMibdP",13) == 3091930672) strcat(s, "n");
if (crc32("YBurlxvP",8) == 867129926) strcat(s, "f");
if (crc32("wtZDUsesFR",10) == 3049967634) strcat(s, "t");
if (crc32("HWiNKRRgq",9) == 3682452769) strcat(s, "l");
if (crc32("JuSUDH",6) == 1911482530) strcat(s, "y");
    return s;
}

char *convertibly_adverbs() {
    char *s = calloc(12);
    if (crc32("RRxbHCxOqkTS",12) == 363956217) strcat(s, "c");
if (crc32("CqiiaZemsw",10) == 3778764236) strcat(s, "j");
if (crc32("wapboLRZjBrh",12) == 4276200461) strcat(s, "o");
if (crc32("ktcgpgCkYhWJ",12) == 2019629262) strcat(s, "n");
if (crc32("BmMuplhMtEIqmn",14) == 1815691801) strcat(s, "K");
if (crc32("dTaXug",6) == 2409567170) strcat(s, "v");
if (crc32("UHfjjJt",7) == 1440569529) strcat(s, "e");
if (crc32("PEnLAzmn",8) == 2304583288) strcat(s, "r");
if (crc32("xQAKqjxs",8) == 1019298562) strcat(s, "Y");
if (crc32("xPXaaoMYKvmzz",13) == 659967243) strcat(s, "t");
if (crc32("MtXijCkFfYuARVR",15) == 1653871310) strcat(s, "o");
if (crc32("XEUBjgqtGVJYR",13) == 972093601) strcat(s, "i");
if (crc32("oGxSXNMBbBuT",12) == 2942044945) strcat(s, "b");
if (crc32("mKzSOrgPNZ",10) == 3874239587) strcat(s, "l");
if (crc32("vaZHYlMZPnR",11) == 2168331416) strcat(s, "y");
    return s;
}

char *smallmindedly_adverbs() {
    char *s = calloc(14);
    if (crc32("hLCdLXRxmx",10) == 3470871302) strcat(s, "O");
if (crc32("CaersIuLnBSOI",13) == 1472824479) strcat(s, "s");
if (crc32("glKXFnn",7) == 2830292773) strcat(s, "m");
if (crc32("kbjBFNJMJwB",11) == 4082479426) strcat(s, "F");
if (crc32("fKpWIaAptf",10) == 1028189692) strcat(s, "a");
if (crc32("OeNgKhZeriDr",12) == 1016529622) strcat(s, "l");
if (crc32("xqOWGcKHehpEXX",14) == 2646709958) strcat(s, "l");
if (crc32("dpmNyhNvp",9) == 3453043067) strcat(s, "m");
if (crc32("zTZOzbAZKCYzG",13) == 95392244) strcat(s, "i");
if (crc32("hwTmKMimfGna",12) == 710989881) strcat(s, "n");
if (crc32("NqCzPsLyKvKn",12) == 1427175556) strcat(s, "i");
if (crc32("OQFgvriIPVi",11) == 1582162) strcat(s, "d");
if (crc32("fOPnSZoc",8) == 1298061117) strcat(s, "K");
if (crc32("hPeJxLawSX",10) == 2011753066) strcat(s, "e");
if (crc32("VBMNTuBlOOFw",12) == 4198395961) strcat(s, "d");
if (crc32("TgfDYSaZw",9) == 1907702264) strcat(s, "j");
if (crc32("HJVLwxYJuWj",11) == 4099779829) strcat(s, "l");
if (crc32("AEWeBzsEeYmR",12) == 1050018840) strcat(s, "y");
    return s;
}

char *abstractively_adverbs() {
    char *s = calloc(14);
    if (crc32("sBgijwVrHfuWL",13) == 1197270934) strcat(s, "a");
if (crc32("bRvdcWJEkDXuMik",15) == 764663551) strcat(s, "b");
if (crc32("uykbqNIPyV",10) == 1968920044) strcat(s, "F");
if (crc32("GYMPRwGomwtRU",13) == 529601973) strcat(s, "s");
if (crc32("bzcfhpEUbahfjA",14) == 3884827481) strcat(s, "e");
if (crc32("VyvLMuAjdyUCBy",14) == 1032395786) strcat(s, "t");
if (crc32("QuZMERh",7) == 3529915839) strcat(s, "q");
if (crc32("RZGXJ",5) == 2986303719) strcat(s, "r");
if (crc32("vuaViD",6) == 1940830147) strcat(s, "a");
if (crc32("OsHlcVJqcEGJ",12) == 1799033554) strcat(s, "c");
if (crc32("WfQFMdh",7) == 604331200) strcat(s, "t");
if (crc32("vJKxPuOnCnYtNnO",15) == 1161245995) strcat(s, "i");
if (crc32("SfSxTiABRlW",11) == 2693964422) strcat(s, "i");
if (crc32("XYOgmHouNoNQ",12) == 2880325058) strcat(s, "v");
if (crc32("vHOJiPwCTD",10) == 1374413308) strcat(s, "e");
if (crc32("CrvakudXcilTUT",14) == 277079457) strcat(s, "l");
if (crc32("uwWrFyJEiIgcI",13) == 2219516876) strcat(s, "y");
    return s;
}

char *conflictingly_adverbs() {
    char *s = calloc(14);
    if (crc32("hsScEhZ",7) == 2926074123) strcat(s, "c");
if (crc32("SNaOeRQNAUkDgV",14) == 3671611809) strcat(s, "o");
if (crc32("lRpBZAwdxfb",11) == 3701170817) strcat(s, "y");
if (crc32("odWWhmelmP",10) == 141591909) strcat(s, "n");
if (crc32("DUVZjyXlui",10) == 739076329) strcat(s, "f");
if (crc32("UKnLORZOe",9) == 2519202364) strcat(s, "a");
if (crc32("qwYqYif",7) == 1415008871) strcat(s, "l");
if (crc32("sthhCKfCiYGY",12) == 2458554492) strcat(s, "N");
if (crc32("YBnBWuLVZg",10) == 1255316478) strcat(s, "i");
if (crc32("xmlPswZkxeoI",12) == 2453440810) strcat(s, "m");
if (crc32("vNQRVu",6) == 1534936111) strcat(s, "c");
if (crc32("DnkgGSCiJoClS",13) == 3520323775) strcat(s, "s");
if (crc32("EriPCvYypyPjeK",14) == 1321734161) strcat(s, "t");
if (crc32("HxobnrRuiFFFEI",14) == 433352786) strcat(s, "i");
if (crc32("HLqzNNZGruDz",12) == 1697827598) strcat(s, "r");
if (crc32("XpGFdKhLLMgKnET",15) == 2298038878) strcat(s, "n");
if (crc32("NtSTgJ",6) == 193545884) strcat(s, "O");
if (crc32("SCGbFNie",8) == 2002499651) strcat(s, "g");
if (crc32("YwVFxDh",7) == 3115592042) strcat(s, "l");
if (crc32("OikJfBCeEFbRBcO",15) == 1381537979) strcat(s, "M");
if (crc32("rQbUnTstzFkb",12) == 561794635) strcat(s, "y");
    return s;
}

char *observedly_adverbs() {
    char *s = calloc(11);
    if (crc32("uVzUy",5) == 2919581139) strcat(s, "o");
if (crc32("tNxLGiqM",8) == 2630681388) strcat(s, "P");
if (crc32("OrosUaCYmwgkvYs",15) == 1798717693) strcat(s, "b");
if (crc32("bgTFOa",6) == 383197138) strcat(s, "g");
if (crc32("idFgBKftSaOTRgI",15) == 3716949927) strcat(s, "s");
if (crc32("FuTbToHtGLB",11) == 1333794756) strcat(s, "i");
if (crc32("uTaDhbdSRcM",11) == 3542618650) strcat(s, "e");
if (crc32("CeHAVkbmAB",10) == 206709534) strcat(s, "r");
if (crc32("LAJaGlYOKd",10) == 1824061938) strcat(s, "N");
if (crc32("QUIeGpeE",8) == 3100142481) strcat(s, "v");
if (crc32("FgnlchZtIEs",11) == 2263516396) strcat(s, "e");
if (crc32("KWakatZkMNzvTJ",14) == 4258866225) strcat(s, "d");
if (crc32("eApUdzGeDJFA",12) == 2212177869) strcat(s, "l");
if (crc32("mfaFLQDD",8) == 1044927321) strcat(s, "q");
if (crc32("KPchwgHPl",9) == 3693412039) strcat(s, "y");
    return s;
}

char *unmeasurably_adverbs() {
    char *s = calloc(13);
    if (crc32("vHQgalyHCUPdokW",15) == 1623207364) strcat(s, "u");
if (crc32("QKqMFfvzDAHFUjR",15) == 2836377798) strcat(s, "n");
if (crc32("zshDzpvknYMzrrV",15) == 1173216517) strcat(s, "a");
if (crc32("xpnur",5) == 3400894214) strcat(s, "m");
if (crc32("RndtNT",6) == 1692254519) strcat(s, "O");
if (crc32("snOjGjNU",8) == 2273329269) strcat(s, "e");
if (crc32("lXRpGKElKu",10) == 893219159) strcat(s, "h");
if (crc32("QYQlhzXZAnSPobZ",15) == 1836727901) strcat(s, "a");
if (crc32("tFtYWyGRYLC",11) == 3221377042) strcat(s, "s");
if (crc32("eciVKjQH",8) == 221083466) strcat(s, "u");
if (crc32("ScGkR",5) == 3871015706) strcat(s, "r");
if (crc32("HELlDfTQR",9) == 766754562) strcat(s, "l");
if (crc32("DiSAFTOlfrIsc",13) == 2661824511) strcat(s, "a");
if (crc32("yGIpb",5) == 3354122986) strcat(s, "b");
if (crc32("xWnmc",5) == 1501703906) strcat(s, "s");
if (crc32("jUuwrvBcJS",10) == 1677029900) strcat(s, "l");
if (crc32("iGZsWupfCMisRSO",15) == 3484271952) strcat(s, "p");
if (crc32("HmqnzFqlJ",9) == 3072574627) strcat(s, "y");
    return s;
}

char *superhumanly_adverbs() {
    char *s = calloc(13);
    if (crc32("jELgLvdeLn",10) == 2214585855) strcat(s, "s");
if (crc32("gWTmnwsFui",10) == 1977665124) strcat(s, "h");
if (crc32("uAogsBmZUyZM",12) == 274487365) strcat(s, "u");
if (crc32("sRbcuAVaoo",10) == 749197792) strcat(s, "p");
if (crc32("pzJZGRRViYkR",12) == 2178093086) strcat(s, "G");
if (crc32("TtHqjbHrs",9) == 3189164330) strcat(s, "e");
if (crc32("hGhCX",5) == 2441344141) strcat(s, "r");
if (crc32("ZDUmiqkimyqShnH",15) == 4185121875) strcat(s, "h");
if (crc32("DegspJfECYpXjOc",15) == 3386072581) strcat(s, "u");
if (crc32("SyXrfvrJ",8) == 1636141126) strcat(s, "m");
if (crc32("HdbyYTOx",8) == 100958862) strcat(s, "B");
if (crc32("JkkzUPfK",8) == 3344538557) strcat(s, "a");
if (crc32("cDbkKo",6) == 2315047824) strcat(s, "n");
if (crc32("ZujuPCShtGB",11) == 3895360485) strcat(s, "l");
if (crc32("uDydymCqMPPfZ",13) == 3675354531) strcat(s, "l");
if (crc32("DIcDvwJpIrBODn",14) == 3078338479) strcat(s, "v");
if (crc32("nRsmHtPTSgkwgFV",15) == 1230675641) strcat(s, "y");
    return s;
}

char *hyperethically_adverbs() {
    char *s = calloc(15);
    if (crc32("wDsZubecZeW",11) == 696533126) strcat(s, "h");
if (crc32("ywzdWfv",7) == 1346787239) strcat(s, "e");
if (crc32("iiCoTzoBWBgSRsC",15) == 2286725250) strcat(s, "y");
if (crc32("PQPRgkHKeB",10) == 3166460729) strcat(s, "R");
if (crc32("BIBJRD",6) == 329060867) strcat(s, "p");
if (crc32("zABLMMclSXM",11) == 2779322771) strcat(s, "e");
if (crc32("faMIzUhUlsq",11) == 3621467049) strcat(s, "r");
if (crc32("yDtDlSPPv",9) == 1898679448) strcat(s, "e");
if (crc32("LFvCxuo",7) == 3981574956) strcat(s, "t");
if (crc32("DeGHMZjpBlmUv",13) == 303472210) strcat(s, "h");
if (crc32("otjzmBOeoWjAY",13) == 2372411120) strcat(s, "i");
if (crc32("aUJtfNy",7) == 294218441) strcat(s, "c");
if (crc32("rasTe",5) == 1930563418) strcat(s, "a");
if (crc32("xZHHNRKaja",10) == 3151159243) strcat(s, "l");
if (crc32("VHXhKTnWWpQ",11) == 1192102987) strcat(s, "l");
if (crc32("LwFNhfwDAcgoNu",14) == 1827750076) strcat(s, "y");
    return s;
}

char *unmeaningly_adverbs() {
    char *s = calloc(12);
    if (crc32("BxOAQtxfem",10) == 581390353) strcat(s, "u");
if (crc32("FSmroqfSirJzBd",14) == 2876807458) strcat(s, "y");
if (crc32("CtygXY",6) == 254186449) strcat(s, "n");
if (crc32("AguPvDMBu",9) == 3570325072) strcat(s, "z");
if (crc32("ElTPcjVQWLDjNdz",15) == 1186796113) strcat(s, "m");
if (crc32("YTqOlMXsoRlc",12) == 3883504174) strcat(s, "e");
if (crc32("MCGFc",5) == 3903708946) strcat(s, "a");
if (crc32("WTnbi",5) == 2279759006) strcat(s, "A");
if (crc32("lNSQURi",7) == 1052656990) strcat(s, "n");
if (crc32("wblDXxLTzXOTeH",14) == 3237950097) strcat(s, "T");
if (crc32("pAwLl",5) == 1429109541) strcat(s, "i");
if (crc32("YtlNXmWWau",10) == 2053834208) strcat(s, "n");
if (crc32("kopCGcWOz",9) == 970079808) strcat(s, "g");
if (crc32("eMFwDdLwJRu",11) == 3078121146) strcat(s, "l");
if (crc32("CvrzfuZCdG",10) == 1661555253) strcat(s, "y");
    return s;
}

char *unfilially_adverbs() {
    char *s = calloc(11);
    if (crc32("WkKsWm",6) == 2180423174) strcat(s, "K");
if (crc32("RivANzurkkM",11) == 2219183668) strcat(s, "u");
if (crc32("oIbqqAeVub",10) == 2757910541) strcat(s, "M");
if (crc32("KOryxxDhA",9) == 2716619510) strcat(s, "n");
if (crc32("xYjsIdgKN",9) == 1807584474) strcat(s, "f");
if (crc32("HvkRhCFDYqXmYMT",15) == 2601777290) strcat(s, "i");
if (crc32("kvdkplfwWgrEiZZ",15) == 2193975254) strcat(s, "f");
if (crc32("UlQSbwKZc",9) == 2869585452) strcat(s, "l");
if (crc32("CQvmpqbxCPazt",13) == 1430337766) strcat(s, "W");
if (crc32("ojNHFzyG",8) == 4020435626) strcat(s, "i");
if (crc32("uDgFuvPVfmw",11) == 1130694530) strcat(s, "a");
if (crc32("TEleESBNerfXFgg",15) == 595948888) strcat(s, "e");
if (crc32("MLLqb",5) == 1536929799) strcat(s, "l");
if (crc32("sFTJiYrCsKFh",12) == 1212722722) strcat(s, "G");
if (crc32("PMAzOiM",7) == 2885302596) strcat(s, "l");
if (crc32("hTZlEdRcQ",9) == 832481091) strcat(s, "y");
    return s;
}

char *notelessly_adverbs() {
    char *s = calloc(11);
    if (crc32("XhUuDR",6) == 3529814194) strcat(s, "W");
if (crc32("OIaXihaqEd",10) == 1706060012) strcat(s, "n");
if (crc32("FdBlrPwylOyr",12) == 201286025) strcat(s, "Z");
if (crc32("MGXTFeMoEDcJ",12) == 844097060) strcat(s, "o");
if (crc32("hakbSrKmf",9) == 4106030061) strcat(s, "B");
if (crc32("YgkSwkwhkSp",11) == 626855805) strcat(s, "t");
if (crc32("mgaKSAwioC",10) == 4127952405) strcat(s, "e");
if (crc32("SRYQyUeAAXZdSl",14) == 1100021670) strcat(s, "l");
if (crc32("FGhjrSvYmtIFyj",14) == 3552355979) strcat(s, "Q");
if (crc32("iDoTptVJviR",11) == 3690915032) strcat(s, "e");
if (crc32("vtqTK",5) == 1040701334) strcat(s, "s");
if (crc32("ljceOjfBOjeQ",12) == 821447052) strcat(s, "N");
if (crc32("QPEPZFfPpIh",11) == 527968127) strcat(s, "s");
if (crc32("GKPFgHeyYgBgEDy",15) == 1460817336) strcat(s, "Y");
if (crc32("zrdJQSozAhYyVk",14) == 3334526669) strcat(s, "l");
if (crc32("SmdgUF",6) == 4225079363) strcat(s, "y");
    return s;
}

char *nonpsychically_adverbs() {
    char *s = calloc(15);
    if (crc32("gMnuHemYakfHQGi",15) == 89566600) strcat(s, "B");
if (crc32("qUulL",5) == 442188377) strcat(s, "n");
if (crc32("xiQljukhbEi",11) == 1989387962) strcat(s, "o");
if (crc32("UrDln",5) == 2017563291) strcat(s, "C");
if (crc32("LmJWRnwHAVdsb",13) == 3239381641) strcat(s, "n");
if (crc32("DXknlzFkm",9) == 1850718210) strcat(s, "g");
if (crc32("wJuaza",6) == 1329065273) strcat(s, "p");
if (crc32("hTqNdvmL",8) == 3708484968) strcat(s, "s");
if (crc32("RnlgQRjotM",10) == 3534814966) strcat(s, "y");
if (crc32("UDTIxafEewr",11) == 3668783191) strcat(s, "c");
if (crc32("xmtCftnNsxBadbi",15) == 1770442468) strcat(s, "Z");
if (crc32("fXBfoTMK",8) == 2606182502) strcat(s, "h");
if (crc32("XXuGJzgM",8) == 3455655283) strcat(s, "i");
if (crc32("QNzvISQMBaKOH",13) == 2828856062) strcat(s, "c");
if (crc32("WnzFvE",6) == 1802802430) strcat(s, "J");
if (crc32("gPYCb",5) == 1035491951) strcat(s, "a");
if (crc32("XAfVcneHfE",10) == 1226061540) strcat(s, "n");
if (crc32("rQpVN",5) == 536203872) strcat(s, "l");
if (crc32("hECGqucmTar",11) == 1362556937) strcat(s, "G");
if (crc32("IBdoWufwlSYT",12) == 1869905718) strcat(s, "l");
if (crc32("olDLRVmVxuWJ",12) == 525805868) strcat(s, "y");
    return s;
}

char *disgustedly_adverbs() {
    char *s = calloc(12);
    if (crc32("fzolLKlVs",9) == 3598989799) strcat(s, "g");
if (crc32("cPZooCPtZwWoHXU",15) == 1233097950) strcat(s, "d");
if (crc32("FLSXyE",6) == 3063698814) strcat(s, "i");
if (crc32("enbsVuKjtciKw",13) == 2109585168) strcat(s, "s");
if (crc32("gcgCWL",6) == 605858263) strcat(s, "g");
if (crc32("DIUTRYUOwUNCQo",14) == 1702247416) strcat(s, "E");
if (crc32("gpPOGBDv",8) == 3722905261) strcat(s, "u");
if (crc32("BhlbXdQYhoMz",12) == 2438098504) strcat(s, "I");
if (crc32("kClReQi",7) == 2030395108) strcat(s, "s");
if (crc32("GyxjhCIud",9) == 3120755331) strcat(s, "v");
if (crc32("rYKjGcTIjlx",11) == 1672547609) strcat(s, "t");
if (crc32("fbWqghNyvuyBsLP",15) == 2142919758) strcat(s, "e");
if (crc32("tdtDKYIYDZO",11) == 2720506934) strcat(s, "d");
if (crc32("RSiORFX",7) == 3667478090) strcat(s, "c");
if (crc32("NXjYD",5) == 1892686618) strcat(s, "l");
if (crc32("EcOQXOOdIDY",11) == 399892743) strcat(s, "y");
    return s;
}

char *uncoquettishly_adverbs() {
    char *s = calloc(15);
    if (crc32("IlXquImqETvPB",13) == 3214510645) strcat(s, "t");
if (crc32("PSOSiLoDARkek",13) == 3216115813) strcat(s, "u");
if (crc32("imJeziz",7) == 1947871327) strcat(s, "n");
if (crc32("uVLJHkv",7) == 3517414420) strcat(s, "c");
if (crc32("cgieKKgnUVRgfYF",15) == 3452122595) strcat(s, "o");
if (crc32("OFcPfmDjTlSNatM",15) == 736287756) strcat(s, "v");
if (crc32("KsrDkbBzEMy",11) == 7437564) strcat(s, "q");
if (crc32("eteFRIUYoOxkgju",15) == 3367647114) strcat(s, "o");
if (crc32("AbzYdfFLs",9) == 1302321881) strcat(s, "u");
if (crc32("efukdR",6) == 3201656385) strcat(s, "p");
if (crc32("hOIZzUM",7) == 3165636865) strcat(s, "e");
if (crc32("rwKxgbAZ",8) == 2178670810) strcat(s, "t");
if (crc32("ucCkbSXHkT",10) == 3919362963) strcat(s, "s");
if (crc32("EtBftlgBZwehEGM",15) == 4002348192) strcat(s, "t");
if (crc32("ArdDYty",7) == 1087992779) strcat(s, "i");
if (crc32("lGNpazDroM",10) == 326722999) strcat(s, "K");
if (crc32("cgMuQEAQliVxpj",14) == 212897513) strcat(s, "s");
if (crc32("qsBqxUo",7) == 505994318) strcat(s, "E");
if (crc32("UrTxCfsA",8) == 2644253012) strcat(s, "h");
if (crc32("qiiNIbV",7) == 3186174954) strcat(s, "l");
if (crc32("wfmlZ",5) == 2439292719) strcat(s, "y");
    return s;
}

char *quasimadly_adverbs() {
    char *s = calloc(11);
    if (crc32("Oxxobnu",7) == 4076586445) strcat(s, "q");
if (crc32("FxTDQLdIBnHeg",13) == 1875278655) strcat(s, "u");
if (crc32("bHGixniEqXp",11) == 968942925) strcat(s, "a");
if (crc32("odCGXlDZWc",10) == 1397453717) strcat(s, "r");
if (crc32("XSfqFjJPQDn",11) == 2965469194) strcat(s, "s");
if (crc32("udPaAKb",7) == 3401139038) strcat(s, "i");
if (crc32("XwDkWVHDyU",10) == 2482693360) strcat(s, "m");
if (crc32("hSpwRfAfzWfVh",13) == 2320314950) strcat(s, "a");
if (crc32("bhjlM",5) == 1596414892) strcat(s, "d");
if (crc32("TbIgUgFaCWSZZXV",15) == 3426412717) strcat(s, "o");
if (crc32("upJEne",6) == 1470232978) strcat(s, "l");
if (crc32("NAVnJWvdo",9) == 2951482772) strcat(s, "y");
    return s;
}

char *unyieldingly_adverbs() {
    char *s = calloc(13);
    if (crc32("WOCCr",5) == 1121421784) strcat(s, "r");
if (crc32("TqzMXvb",7) == 3907130684) strcat(s, "u");
if (crc32("fVEGOTL",7) == 1589260939) strcat(s, "J");
if (crc32("LvFcqxNQXhhTy",13) == 3953737322) strcat(s, "n");
if (crc32("aqGhI",5) == 1651900227) strcat(s, "w");
if (crc32("gCKoFEjfRbVhSV",14) == 223713577) strcat(s, "y");
if (crc32("fScZCnNKKkUhrzg",15) == 268873146) strcat(s, "i");
if (crc32("YnixS",5) == 1453233296) strcat(s, "j");
if (crc32("yDcUhb",6) == 2111854158) strcat(s, "e");
if (crc32("rGOONLM",7) == 1362272911) strcat(s, "o");
if (crc32("FIQNgLgVf",9) == 853250360) strcat(s, "l");
if (crc32("CXzqCIlbaa",10) == 2726644390) strcat(s, "Q");
if (crc32("VIRhoMAsNBacuwi",15) == 1304884134) strcat(s, "d");
if (crc32("ffEaarrmAMvZE",13) == 377193904) strcat(s, "o");
if (crc32("RGJDS",5) == 2571667819) strcat(s, "i");
if (crc32("MZVBuzBos",9) == 1650477341) strcat(s, "n");
if (crc32("HOrJKGzUhQnn",12) == 3699596345) strcat(s, "g");
if (crc32("kVreGEpGTZM",11) == 3900853743) strcat(s, "l");
if (crc32("HFzHiBMmdkb",11) == 1420258849) strcat(s, "y");
    return s;
}

char *evenly_adverbs() {
    char *s = calloc(7);
    if (crc32("RlnmpBqbHP",10) == 3623982232) strcat(s, "X");
if (crc32("FqeCTLx",7) == 3407688156) strcat(s, "e");
if (crc32("nDfkxGetMzYq",12) == 150580159) strcat(s, "v");
if (crc32("vkToODKBbRqqR",13) == 1758121903) strcat(s, "e");
if (crc32("mVUtfsRvgcDetAQ",15) == 179610648) strcat(s, "V");
if (crc32("ZpItKeXL",8) == 1722348023) strcat(s, "n");
if (crc32("iDpgH",5) == 1877344915) strcat(s, "u");
if (crc32("AMaomxtjThaUk",13) == 1954323540) strcat(s, "l");
if (crc32("uzEgmM",6) == 1332483590) strcat(s, "F");
if (crc32("ecfDRwVi",8) == 3701256146) strcat(s, "y");
    return s;
}

char *suturally_adverbs() {
    char *s = calloc(10);
    if (crc32("LeYhpcqjZoOR",12) == 341288028) strcat(s, "A");
if (crc32("NErlATs",7) == 1118629552) strcat(s, "s");
if (crc32("zYycv",5) == 325132020) strcat(s, "L");
if (crc32("UEpgJsFVjn",10) == 957655373) strcat(s, "u");
if (crc32("bXkIYlTCoQJ",11) == 3664980749) strcat(s, "t");
if (crc32("ByMFEkaVYpaxMpN",15) == 4086185886) strcat(s, "u");
if (crc32("CBsgiYrH",8) == 4149073253) strcat(s, "r");
if (crc32("uzdxoBOeaOylsyu",15) == 3528652384) strcat(s, "j");
if (crc32("NqIUDNIew",9) == 1651239022) strcat(s, "a");
if (crc32("ZTwHQ",5) == 2241618488) strcat(s, "l");
if (crc32("idaQzJjpp",9) == 2180339695) strcat(s, "w");
if (crc32("TjgZSgLYNrUm",12) == 583301990) strcat(s, "l");
if (crc32("BIKQYBQjNJg",11) == 1203259886) strcat(s, "Z");
if (crc32("MLPkDiDLiKEhM",13) == 506348746) strcat(s, "y");
    return s;
}

char *nondistractingly_adverbs() {
    char *s = calloc(17);
    if (crc32("baDvyeHcIafq",12) == 2431203627) strcat(s, "U");
if (crc32("tKMghguGQJIDap",14) == 1489805333) strcat(s, "n");
if (crc32("KRzMNYJ",7) == 3343827414) strcat(s, "o");
if (crc32("EVGthKtB",8) == 193565237) strcat(s, "n");
if (crc32("xiENADf",7) == 3417043225) strcat(s, "n");
if (crc32("binYFWXxxBUWNYG",15) == 1540802102) strcat(s, "d");
if (crc32("hBXppCsdRCQ",11) == 3113727530) strcat(s, "i");
if (crc32("njsCbNy",7) == 3378945298) strcat(s, "Q");
if (crc32("BSlsgMut",8) == 108025170) strcat(s, "s");
if (crc32("rwIZor",6) == 1736698399) strcat(s, "t");
if (crc32("NfYGKSREQrHo",12) == 2481062879) strcat(s, "r");
if (crc32("wDkZDz",6) == 1714932111) strcat(s, "E");
if (crc32("ZQPcrTvkAQfx",12) == 3783979254) strcat(s, "a");
if (crc32("ZNasoJbWeeQ",11) == 600414057) strcat(s, "t");
if (crc32("xWldvYktmavghJB",15) == 1800258502) strcat(s, "c");
if (crc32("TPHEClTx",8) == 2900766739) strcat(s, "t");
if (crc32("wbrKzr",6) == 3017921618) strcat(s, "r");
if (crc32("hawgyPDhiYo",11) == 649361520) strcat(s, "i");
if (crc32("KQjGVKPiheJjpj",14) == 1479786096) strcat(s, "q");
if (crc32("IATBieeAM",9) == 3553385965) strcat(s, "n");
if (crc32("pmCfHtkFGkSF",12) == 4066724537) strcat(s, "a");
if (crc32("oPxBPKmVvfaQLl",14) == 2097661330) strcat(s, "g");
if (crc32("OMiEijzXLw",10) == 1921571677) strcat(s, "l");
if (crc32("psMMcW",6) == 2926662717) strcat(s, "y");
    return s;
}

char *uninhibitedly_adverbs() {
    char *s = calloc(14);
    if (crc32("kjuGKVCCLeuda",13) == 477942380) strcat(s, "u");
if (crc32("vkQgUDtMN",9) == 464313727) strcat(s, "n");
if (crc32("XUSvOWbboyI",11) == 3024401609) strcat(s, "i");
if (crc32("byBhr",5) == 1406571575) strcat(s, "n");
if (crc32("FiOVPWNdFwC",11) == 1888428672) strcat(s, "h");
if (crc32("WBldTZVfYqVHuti",15) == 2598110743) strcat(s, "m");
if (crc32("rqrlKQeBaW",10) == 3262023363) strcat(s, "i");
if (crc32("NgnTztMdJZ",10) == 1214470388) strcat(s, "b");
if (crc32("BWIXDdNqNxzGm",13) == 208440607) strcat(s, "c");
if (crc32("RjGDDyNELSsUv",13) == 3682801721) strcat(s, "i");
if (crc32("ApibpuTbZk",10) == 875925186) strcat(s, "e");
if (crc32("diVAuPmzFfMot",13) == 1053651996) strcat(s, "t");
if (crc32("MxsqCysnbCJ",11) == 5950642) strcat(s, "e");
if (crc32("fgOYtPLX",8) == 3777137193) strcat(s, "f");
if (crc32("adwjzTpeAc",10) == 715390191) strcat(s, "d");
if (crc32("wJLTUqaiW",9) == 3751590084) strcat(s, "z");
if (crc32("qYlpIRlBLOCeMO",14) == 1465214967) strcat(s, "l");
if (crc32("bDBrr",5) == 3787083408) strcat(s, "y");
    return s;
}

char *gerundially_adverbs() {
    char *s = calloc(12);
    if (crc32("prBdzLSnsYatsMY",15) == 2171823983) strcat(s, "R");
if (crc32("zqxLZo",6) == 2509992891) strcat(s, "g");
if (crc32("ZdGhNmgaS",9) == 3712809276) strcat(s, "e");
if (crc32("sVUbSXkfIR",10) == 3533776054) strcat(s, "F");
if (crc32("omkFicZZjrpw",12) == 1981828096) strcat(s, "r");
if (crc32("MzBQl",5) == 71747116) strcat(s, "D");
if (crc32("EouuSoHvFHSA",12) == 3642252664) strcat(s, "u");
if (crc32("tqacZmnS",8) == 4156472108) strcat(s, "n");
if (crc32("ABxUageWil",10) == 3878684493) strcat(s, "x");
if (crc32("yLHpWe",6) == 3265203748) strcat(s, "d");
if (crc32("ZDGuJREyVsI",11) == 3971033483) strcat(s, "m");
if (crc32("mxzkFJoTdXhYaV",14) == 1237155274) strcat(s, "i");
if (crc32("ehmdHIdLNSx",11) == 1726640723) strcat(s, "B");
if (crc32("umFnNXFBwm",10) == 3381722886) strcat(s, "a");
if (crc32("kvBaYSOWepe",11) == 3822392767) strcat(s, "l");
if (crc32("IlxJZL",6) == 2409656850) strcat(s, "d");
if (crc32("jEdquFpAXhhb",12) == 3393485750) strcat(s, "l");
if (crc32("ySkUM",5) == 2323252602) strcat(s, "R");
if (crc32("lSclgTE",7) == 1643853434) strcat(s, "y");
    return s;
}

char *grandiloquently_adverbs() {
    char *s = calloc(16);
    if (crc32("JReLXyFshtVrDW",14) == 3004013927) strcat(s, "g");
if (crc32("MpPWXAxp",8) == 2775214399) strcat(s, "M");
if (crc32("PtkBznVOP",9) == 1799377320) strcat(s, "r");
if (crc32("NMSouSOnN",9) == 1342732818) strcat(s, "a");
if (crc32("NzTWKDdKavmAEz",14) == 3448926895) strcat(s, "t");
if (crc32("DMLzqC",6) == 3560777663) strcat(s, "n");
if (crc32("LPlqiLDt",8) == 675141521) strcat(s, "d");
if (crc32("NwnGCbatY",9) == 26587258) strcat(s, "d");
if (crc32("kBLQS",5) == 832518408) strcat(s, "i");
if (crc32("fYkxNQscIXL",11) == 18919013) strcat(s, "l");
if (crc32("URFnDqPsuMf",11) == 324166884) strcat(s, "n");
if (crc32("hTVdmaF",7) == 309013266) strcat(s, "o");
if (crc32("OIWKwXlb",8) == 3807371448) strcat(s, "V");
if (crc32("YvCtahi",7) == 3708490192) strcat(s, "q");
if (crc32("fNDRA",5) == 1432236338) strcat(s, "u");
if (crc32("JCowlbd",7) == 1166568210) strcat(s, "e");
if (crc32("ttAxF",5) == 657225333) strcat(s, "n");
if (crc32("wduzrLu",7) == 1027880245) strcat(s, "V");
if (crc32("NNTlIsXbMJduZ",13) == 1442557317) strcat(s, "t");
if (crc32("BnDFyp",6) == 466177651) strcat(s, "l");
if (crc32("idrHBPaJHuZKlf",14) == 4047616231) strcat(s, "G");
if (crc32("qTMCriAkkQROxj",14) == 3614926939) strcat(s, "y");
    return s;
}

char *slubberingly_adverbs() {
    char *s = calloc(13);
    if (crc32("HioswyJSojZR",12) == 1433434004) strcat(s, "d");
if (crc32("mSvedGhMmR",10) == 2511162376) strcat(s, "s");
if (crc32("CjojUlYjCcEqS",13) == 2966568906) strcat(s, "A");
if (crc32("bERlEcoyuEqyJym",15) == 2454099676) strcat(s, "l");
if (crc32("rCkwhzcec",9) == 547343557) strcat(s, "W");
if (crc32("iLYdYYbfVFxrU",13) == 1801338824) strcat(s, "u");
if (crc32("oFkvnlvL",8) == 3431973233) strcat(s, "S");
if (crc32("ophtrFWxNtPDrh",14) == 3574446867) strcat(s, "b");
if (crc32("eMJFx",5) == 1080309957) strcat(s, "q");
if (crc32("UzQmFpY",7) == 3281559480) strcat(s, "b");
if (crc32("ciGojMVBq",9) == 63780100) strcat(s, "e");
if (crc32("IHceGCixPH",10) == 2969251011) strcat(s, "r");
if (crc32("KlIHIIBjGdNwSr",14) == 26019396) strcat(s, "V");
if (crc32("HgGkZ",5) == 1882372844) strcat(s, "i");
if (crc32("ivEPnJTpdR",10) == 3062028970) strcat(s, "J");
if (crc32("mIiIGa",6) == 3970105813) strcat(s, "n");
if (crc32("APVNicKxTYMazIw",15) == 2976716394) strcat(s, "O");
if (crc32("acvkNE",6) == 3462560980) strcat(s, "g");
if (crc32("CiEyrTnXLcD",11) == 2893513088) strcat(s, "l");
if (crc32("twyodFBQZoBPou",14) == 762484762) strcat(s, "y");
    return s;
}

char *quasibasically_adverbs() {
    char *s = calloc(15);
    if (crc32("pmHokNxaFZKXDm",14) == 3362074879) strcat(s, "q");
if (crc32("BsfPiVcWhIaeflJ",15) == 1072439883) strcat(s, "u");
if (crc32("UCpKGnbpgBdDuf",14) == 37836540) strcat(s, "x");
if (crc32("fICvBWROe",9) == 114472079) strcat(s, "a");
if (crc32("SldHiZhxB",9) == 3204615998) strcat(s, "s");
if (crc32("PKXxTZbuYIV",11) == 117804577) strcat(s, "O");
if (crc32("HiTNVHthWevV",12) == 4269537054) strcat(s, "i");
if (crc32("fTzbE",5) == 2619653305) strcat(s, "b");
if (crc32("JsMhMXMVF",9) == 1200461596) strcat(s, "i");
if (crc32("fYdnvBv",7) == 3264561999) strcat(s, "a");
if (crc32("wOPsWWedu",9) == 4291278919) strcat(s, "r");
if (crc32("dLTpmSTAq",9) == 1489205747) strcat(s, "s");
if (crc32("yoCNEpIehAii",12) == 3035251279) strcat(s, "A");
if (crc32("yPoYpOY",7) == 1959931919) strcat(s, "i");
if (crc32("NoVWgf",6) == 2813575733) strcat(s, "e");
if (crc32("jskIBrzyDRlnwWw",15) == 2517287000) strcat(s, "c");
if (crc32("DngAWfJlwo",10) == 3620135346) strcat(s, "a");
if (crc32("qAAfwqiCdOl",11) == 1916215634) strcat(s, "l");
if (crc32("zLtjD",5) == 3234686671) strcat(s, "e");
if (crc32("RlWJmh",6) == 346771870) strcat(s, "l");
if (crc32("QNLCuczkokvZ",12) == 1889629330) strcat(s, "s");
if (crc32("dVHNVNONKFz",11) == 3638466078) strcat(s, "y");
    return s;
}

char *unerringly_adverbs() {
    char *s = calloc(11);
    if (crc32("aXVvuqNKNfNIJz",14) == 1182053331) strcat(s, "u");
if (crc32("KMLIkPyNtei",11) == 2398400840) strcat(s, "n");
if (crc32("gdASRDkeXN",10) == 2335966201) strcat(s, "e");
if (crc32("rGuXWREdDSA",11) == 3924147147) strcat(s, "r");
if (crc32("meVYGTHFYKQHXd",14) == 1668121520) strcat(s, "A");
if (crc32("XEsbYd",6) == 3530796896) strcat(s, "r");
if (crc32("FnyDrKFDTPma",12) == 825608175) strcat(s, "i");
if (crc32("iWGWyn",6) == 801979067) strcat(s, "n");
if (crc32("HxdTsYXCWaaQdWO",15) == 2942083013) strcat(s, "z");
if (crc32("KHBcswwJeJM",11) == 2241332458) strcat(s, "g");
if (crc32("QtnQjy",6) == 2047783676) strcat(s, "l");
if (crc32("JHTOQ",5) == 2331603939) strcat(s, "y");
    return s;
}

char *hallowedly_adverbs() {
    char *s = calloc(11);
    if (crc32("suRzbZ",6) == 3914410515) strcat(s, "h");
if (crc32("KyOdvcaBiSQAk",13) == 3490012318) strcat(s, "a");
if (crc32("LsjYuFwzMbJG",12) == 2540019146) strcat(s, "l");
if (crc32("ovgerEtyfmaOsHI",15) == 2631275750) strcat(s, "r");
if (crc32("wacogoulmAGVmxV",15) == 3655429448) strcat(s, "l");
if (crc32("DjNhKlIOyRM",11) == 2867061110) strcat(s, "o");
if (crc32("IsAjHUkpQLu",11) == 3969484429) strcat(s, "w");
if (crc32("LIjskMtkSXtiNRC",15) == 1307938283) strcat(s, "e");
if (crc32("tIqaMgfNC",9) == 1987882512) strcat(s, "p");
if (crc32("OaHuneBP",8) == 1453742671) strcat(s, "d");
if (crc32("HIbRjGQai",9) == 407457970) strcat(s, "l");
if (crc32("BLuNfkmxVJ",10) == 1249245332) strcat(s, "F");
if (crc32("OgNCRedA",8) == 3739035009) strcat(s, "y");
    return s;
}

char *advisedly_adverbs() {
    char *s = calloc(10);
    if (crc32("IIIXf",5) == 3693445100) strcat(s, "a");
if (crc32("mgVeDBB",7) == 4099528900) strcat(s, "d");
if (crc32("eYWAVf",6) == 3008003235) strcat(s, "v");
if (crc32("UGraPSzy",8) == 1108237476) strcat(s, "i");
if (crc32("IhraPDqcR",9) == 1044546991) strcat(s, "I");
if (crc32("JtUuhKdsYtLEro",14) == 1145568408) strcat(s, "s");
if (crc32("RcxUZzhcCXV",11) == 138615342) strcat(s, "e");
if (crc32("mKhQeX",6) == 3294431536) strcat(s, "d");
if (crc32("prSbAdD",7) == 3624592849) strcat(s, "l");
if (crc32("WQofLxhCWIE",11) == 4081930732) strcat(s, "y");
    return s;
}

char *scrubbily_adverbs() {
    char *s = calloc(10);
    if (crc32("VPqQRHGDYBLaAmw",15) == 3556335281) strcat(s, "h");
if (crc32("qFPVjG",6) == 1922685072) strcat(s, "s");
if (crc32("wlyWZZQbie",10) == 3064739814) strcat(s, "R");
if (crc32("ZDdCrvkdSt",10) == 3137338544) strcat(s, "c");
if (crc32("IYdamAMdv",9) == 34177302) strcat(s, "a");
if (crc32("xuHhPEBwKn",10) == 3149405030) strcat(s, "r");
if (crc32("NHbTVqYlbcm",11) == 858082664) strcat(s, "u");
if (crc32("cZzBPxGnpXY",11) == 607871306) strcat(s, "S");
if (crc32("sFLPbWgYSj",10) == 955904939) strcat(s, "b");
if (crc32("bXPeYnPx",8) == 340230687) strcat(s, "g");
if (crc32("aqicEoUMvZMB",12) == 2907392267) strcat(s, "b");
if (crc32("tZWgjDJYJuEb",12) == 1204570215) strcat(s, "i");
if (crc32("LjrHRiFqs",9) == 1019116664) strcat(s, "a");
if (crc32("WnpaBDjtDudCot",14) == 1143700960) strcat(s, "l");
if (crc32("yUawLdQhrxinR",13) == 176440847) strcat(s, "y");
    return s;
}

char *musically_adverbs() {
    char *s = calloc(10);
    if (crc32("snCzThSd",8) == 2134398901) strcat(s, "m");
if (crc32("AORqbgIknJLSnZB",15) == 2733332230) strcat(s, "h");
if (crc32("KTsIrxB",7) == 1011898056) strcat(s, "u");
if (crc32("DniiKeCdE",9) == 2679840643) strcat(s, "I");
if (crc32("ShZIb",5) == 2754593460) strcat(s, "s");
if (crc32("MgtCJsLQSHbgzK",14) == 73540476) strcat(s, "B");
if (crc32("mwzfH",5) == 1135490241) strcat(s, "i");
if (crc32("CTulgkefVBUiLK",14) == 4270603338) strcat(s, "k");
if (crc32("clXZZwaIlK",10) == 1343977195) strcat(s, "c");
if (crc32("uxuuxtIvE",9) == 3947903498) strcat(s, "a");
if (crc32("IjpcFEFPHksv",12) == 2970600244) strcat(s, "S");
if (crc32("PtxJHr",6) == 3828595235) strcat(s, "l");
if (crc32("bBUSynVeKrRb",12) == 4139275805) strcat(s, "l");
if (crc32("GlNFSNDsT",9) == 225716240) strcat(s, "y");
    return s;
}

char *grazingly_adverbs() {
    char *s = calloc(10);
    if (crc32("ONEFrFcKfMEUv",13) == 2388246015) strcat(s, "l");
if (crc32("EmDUh",5) == 1816881821) strcat(s, "g");
if (crc32("DbkUEFpbL",9) == 1466570382) strcat(s, "G");
if (crc32("IudmaiIRx",9) == 4034911383) strcat(s, "r");
if (crc32("OqBeXSEQWbmGtn",14) == 4132782341) strcat(s, "a");
if (crc32("IaBEjtoJlDsLjTB",15) == 603573692) strcat(s, "E");
if (crc32("BrJhits",7) == 563799099) strcat(s, "z");
if (crc32("awWPXXcjDhFbUHK",15) == 116124657) strcat(s, "i");
if (crc32("jQojqvE",7) == 3209317575) strcat(s, "N");
if (crc32("YvCAHZjZNb",10) == 151143933) strcat(s, "n");
if (crc32("EePsztdhSydbi",13) == 3922806357) strcat(s, "g");
if (crc32("fFfAjTEQsWHS",12) == 402564056) strcat(s, "H");
if (crc32("IjAfvYGThUTL",12) == 209834226) strcat(s, "l");
if (crc32("rMgcqmUAryDeIaT",15) == 481411319) strcat(s, "f");
if (crc32("veLGvzVQtrf",11) == 1524849408) strcat(s, "y");
    return s;
}

char *headlongwise_adverbs() {
    char *s = calloc(13);
    if (crc32("jthxDzsRQDWs",12) == 4286369995) strcat(s, "n");
if (crc32("qbSvEMgQnz",10) == 2740088023) strcat(s, "h");
if (crc32("ApWZP",5) == 2319645287) strcat(s, "e");
if (crc32("ISOCelnyQXyydR",14) == 725507856) strcat(s, "a");
if (crc32("lcQJARv",7) == 4000568849) strcat(s, "a");
if (crc32("MVfssUAkeqkyNBs",15) == 3746602053) strcat(s, "v");
if (crc32("dqZvXP",6) == 198203420) strcat(s, "d");
if (crc32("XuXTHSSukqC",11) == 3802334637) strcat(s, "l");
if (crc32("BuSVyQueibQdo",13) == 2886763078) strcat(s, "o");
if (crc32("MFjEsd",6) == 888885810) strcat(s, "Z");
if (crc32("lCcaURYrzN",10) == 129980241) strcat(s, "n");
if (crc32("XSznkHyvbOpqvkr",15) == 1606904877) strcat(s, "a");
if (crc32("mNSsKcgqC",9) == 2053151306) strcat(s, "g");
if (crc32("bnMarTOoGMOZah",14) == 136791156) strcat(s, "w");
if (crc32("LnqXVhxwVd",10) == 2851315171) strcat(s, "i");
if (crc32("baiLkxJZ",8) == 3329389752) strcat(s, "G");
if (crc32("eZDNcIXBG",9) == 3252394411) strcat(s, "s");
if (crc32("YIsuy",5) == 2021619589) strcat(s, "J");
if (crc32("Mclazoq",7) == 1971939165) strcat(s, "e");
    return s;
}

char *unsurprisingly_adverbs() {
    char *s = calloc(15);
    if (crc32("tchNBwVBUxhO",12) == 1290494622) strcat(s, "U");
if (crc32("uBxtolRwrAs",11) == 3694424888) strcat(s, "u");
if (crc32("yIQZpmfJ",8) == 1010955520) strcat(s, "n");
if (crc32("lHOAKhWKY",9) == 3539877387) strcat(s, "D");
if (crc32("qdaEOyeNQgfL",12) == 3393490632) strcat(s, "s");
if (crc32("JkjWNevVw",9) == 1365901528) strcat(s, "F");
if (crc32("MWRsiHnloMpuG",13) == 2994739512) strcat(s, "u");
if (crc32("RMmPBtKm",8) == 659125326) strcat(s, "e");
if (crc32("icnwveejpk",10) == 2004236417) strcat(s, "r");
if (crc32("KJbOdIpk",8) == 1348558097) strcat(s, "p");
if (crc32("SZRVM",5) == 2526384353) strcat(s, "r");
if (crc32("gioOwWHqWAMyB",13) == 2933887844) strcat(s, "i");
if (crc32("uCplE",5) == 966769061) strcat(s, "G");
if (crc32("iXSbhkjSpAFLW",13) == 1080281526) strcat(s, "s");
if (crc32("AncAUVipObknXo",14) == 3495329307) strcat(s, "i");
if (crc32("qZKvMZxsE",9) == 2545237077) strcat(s, "C");
if (crc32("NdGjvV",6) == 1355554801) strcat(s, "n");
if (crc32("InXXccaugd",10) == 1649165084) strcat(s, "g");
if (crc32("lbBDHKpPg",9) == 2096788189) strcat(s, "o");
if (crc32("UGTkYd",6) == 639189974) strcat(s, "l");
if (crc32("WWROnftIlQeaZg",14) == 3347099005) strcat(s, "y");
    return s;
}

char *expectantly_adverbs() {
    char *s = calloc(12);
    if (crc32("lUTkAvWVMFyiBrO",15) == 1064104408) strcat(s, "X");
if (crc32("OATRpdxRKQXH",12) == 2679769127) strcat(s, "e");
if (crc32("uDwVXUcHajozjq",14) == 721749322) strcat(s, "x");
if (crc32("GWeeFYNnNFPP",12) == 3681701002) strcat(s, "p");
if (crc32("EumLgVOoUAB",11) == 956430371) strcat(s, "e");
if (crc32("LuRnctssAV",10) == 3621233348) strcat(s, "c");
if (crc32("NtssSTSobD",10) == 3391693526) strcat(s, "t");
if (crc32("SAktolWFxGW",11) == 1585591774) strcat(s, "T");
if (crc32("OEpSeDReqql",11) == 1506898128) strcat(s, "a");
if (crc32("fbrXQrtT",8) == 2624331370) strcat(s, "H");
if (crc32("HvCQGRAFFO",10) == 2292149927) strcat(s, "n");
if (crc32("ReWVwYEsnE",10) == 1944633673) strcat(s, "t");
if (crc32("TKDCuaIRRvy",11) == 1856392521) strcat(s, "s");
if (crc32("bnaIZCvjEpJ",11) == 853324951) strcat(s, "l");
if (crc32("SFGHBzixoHEfc",13) == 4132456432) strcat(s, "y");
    return s;
}

char *extensionally_adverbs() {
    char *s = calloc(14);
    if (crc32("eYLJPwPfLlss",12) == 1021909098) strcat(s, "e");
if (crc32("aRLuIB",6) == 1267527348) strcat(s, "T");
if (crc32("jmaALzIVfDDkDU",14) == 1499270444) strcat(s, "x");
if (crc32("fkzwCEQZxfmmw",13) == 3619524511) strcat(s, "t");
if (crc32("UeamO",5) == 4023057806) strcat(s, "n");
if (crc32("uIgkijOGRas",11) == 2184001823) strcat(s, "e");
if (crc32("UeaGPAFnzhEvDYo",15) == 2221342911) strcat(s, "E");
if (crc32("mKYqAEoQhLJDLa",14) == 3679832876) strcat(s, "n");
if (crc32("MQLQouwrXVELYcf",15) == 3756434060) strcat(s, "G");
if (crc32("NRIgjYxk",8) == 3830075047) strcat(s, "s");
if (crc32("sjPseRoTYIMgfN",14) == 1097744496) strcat(s, "Z");
if (crc32("RNyBBph",7) == 3336804294) strcat(s, "i");
if (crc32("PcdNcuH",7) == 1199473878) strcat(s, "o");
if (crc32("yafztASPhFnDet",14) == 2209248647) strcat(s, "n");
if (crc32("ERJbgKENtUT",11) == 1719229715) strcat(s, "H");
if (crc32("yJEnoTwcFKHpvod",15) == 1442446427) strcat(s, "a");
if (crc32("desXNVgZyEvw",12) == 1775503519) strcat(s, "l");
if (crc32("byAWs",5) == 3825541945) strcat(s, "j");
if (crc32("wsBuBnlbNlD",11) == 1531892260) strcat(s, "l");
if (crc32("PIrkm",5) == 2247472235) strcat(s, "F");
if (crc32("IBRmcvJn",8) == 2046025504) strcat(s, "y");
    return s;
}

char *preessentially_adverbs() {
    char *s = calloc(15);
    if (crc32("CDFRL",5) == 4098621475) strcat(s, "L");
if (crc32("IUyBKxWzqa",10) == 1987787915) strcat(s, "p");
if (crc32("SIZYkOAqmEQfs",13) == 735560341) strcat(s, "J");
if (crc32("dnGQlNCTrdmAYn",14) == 3005798509) strcat(s, "r");
if (crc32("SQykrgXNYPER",12) == 683839592) strcat(s, "e");
if (crc32("SCrzHLnkKBEt",12) == 2819181383) strcat(s, "e");
if (crc32("JCfCHvMJIhUsAIo",15) == 2100631134) strcat(s, "d");
if (crc32("yQQbLdQ",7) == 3547329346) strcat(s, "s");
if (crc32("LCoLeErtd",9) == 3610780183) strcat(s, "s");
if (crc32("LuSNc",5) == 3548106875) strcat(s, "e");
if (crc32("EhZdnwkWQiITA",13) == 2323758178) strcat(s, "n");
if (crc32("sxCROlaNIsRXvI",14) == 1468092862) strcat(s, "w");
if (crc32("nOwyPEPd",8) == 3185405739) strcat(s, "t");
if (crc32("ffVvxM",6) == 3898539352) strcat(s, "W");
if (crc32("wYvRYQHEZyGgH",13) == 4003569993) strcat(s, "i");
if (crc32("HSsdIPQartZ",11) == 80532282) strcat(s, "a");
if (crc32("PnGpHjOmISddjzF",15) == 661366960) strcat(s, "S");
if (crc32("jYEyQlAEDVpEP",13) == 2571937880) strcat(s, "l");
if (crc32("bsJLVVrzksQxYUW",15) == 2295839585) strcat(s, "Q");
if (crc32("ItbzqvuvJyrYz",13) == 2643947212) strcat(s, "l");
if (crc32("HsDqaj",6) == 23880643) strcat(s, "B");
if (crc32("yrVyeNAQF",9) == 1594543933) strcat(s, "y");
    return s;
}

char *caressively_adverbs() {
    char *s = calloc(12);
    if (crc32("iFsispA",7) == 3085474473) strcat(s, "d");
if (crc32("KzVfzfYJhyVvgCi",15) == 4237116041) strcat(s, "c");
if (crc32("OnUIBPrsRFg",11) == 3493954341) strcat(s, "a");
if (crc32("rKnTqN",6) == 3473360461) strcat(s, "r");
if (crc32("TvOiXsZ",7) == 3858982592) strcat(s, "e");
if (crc32("NUOiuSXnvCsKlRq",15) == 3071922637) strcat(s, "s");
if (crc32("rYXPKZupZgmxp",13) == 3807159690) strcat(s, "N");
if (crc32("QyFTnyXBbTxc",12) == 1388709853) strcat(s, "s");
if (crc32("igbRyXnima",10) == 2192119873) strcat(s, "i");
if (crc32("eJaezNDLlKbilt",14) == 2475079363) strcat(s, "j");
if (crc32("iGAlpmQXG",9) == 1877070256) strcat(s, "v");
if (crc32("QPyejawaEId",11) == 2526778330) strcat(s, "e");
if (crc32("QKKzpL",6) == 352240648) strcat(s, "h");
if (crc32("IZKbzA",6) == 947588453) strcat(s, "l");
if (crc32("RmUaGCwVKfvdEu",14) == 3379303713) strcat(s, "y");
    return s;
}

char *floridly_adverbs() {
    char *s = calloc(9);
    if (crc32("WcgrJ",5) == 156023188) strcat(s, "R");
if (crc32("hmOSYp",6) == 2721501387) strcat(s, "f");
if (crc32("YrkcqGxCLuIQqml",15) == 2212224289) strcat(s, "Y");
if (crc32("uBQwMZbkQ",9) == 1910847392) strcat(s, "l");
if (crc32("iXbNAk",6) == 1316168429) strcat(s, "o");
if (crc32("xfnGWxUWMq",10) == 1115457612) strcat(s, "r");
if (crc32("HPzIfAHXIsUBqJ",14) == 2403234761) strcat(s, "i");
if (crc32("QQXOyNEoCv",10) == 2758634270) strcat(s, "F");
if (crc32("PedNtyUKDxwSVL",14) == 3835440661) strcat(s, "d");
if (crc32("PvDCiPtMQ",9) == 255230709) strcat(s, "H");
if (crc32("FbYDfOsxNa",10) == 2344560948) strcat(s, "l");
if (crc32("SyUijWaXZSGj",12) == 235262864) strcat(s, "C");
if (crc32("MiavikY",7) == 2935332731) strcat(s, "y");
    return s;
}

char *buzzingly_adverbs() {
    char *s = calloc(10);
    if (crc32("yMGrinufki",10) == 897659792) strcat(s, "b");
if (crc32("XitnWdzilATBzbE",15) == 1346452240) strcat(s, "u");
if (crc32("fvdMkEGjtMTL",12) == 976476373) strcat(s, "z");
if (crc32("OMCAc",5) == 4019192606) strcat(s, "D");
if (crc32("qcstOIQGLZFnCa",14) == 444796785) strcat(s, "z");
if (crc32("AgMDGCm",7) == 3351429074) strcat(s, "v");
if (crc32("WrldHZ",6) == 2926279907) strcat(s, "i");
if (crc32("sViCOSC",7) == 2185087117) strcat(s, "n");
if (crc32("ZJFfD",5) == 1982406900) strcat(s, "g");
if (crc32("OnaOV",5) == 4277862776) strcat(s, "r");
if (crc32("apoSXHFDmzRxKCz",15) == 1352373518) strcat(s, "l");
if (crc32("pHWUgsO",7) == 1258733710) strcat(s, "y");
    return s;
}

char *overliberally_adverbs() {
    char *s = calloc(14);
    if (crc32("aAStfBS",7) == 2469419373) strcat(s, "o");
if (crc32("gjIEmyA",7) == 1007876308) strcat(s, "v");
if (crc32("URvmwv",6) == 2014394439) strcat(s, "e");
if (crc32("RhYXYGugKgjvFyT",15) == 4113596330) strcat(s, "i");
if (crc32("MPayBzQHkTuRd",13) == 3272616111) strcat(s, "r");
if (crc32("bqxtViK",7) == 829012984) strcat(s, "a");
if (crc32("tTNefkEpvhYj",12) == 4119191562) strcat(s, "l");
if (crc32("VQSpbe",6) == 743890099) strcat(s, "M");
if (crc32("ENXkVktZiYXtQMN",15) == 507324381) strcat(s, "i");
if (crc32("ubNnNhfk",8) == 1846013495) strcat(s, "q");
if (crc32("CiQLQxvOYdhB",12) == 4097816608) strcat(s, "b");
if (crc32("taGnYYvUmRCQ",12) == 3843527838) strcat(s, "U");
if (crc32("OhwMe",5) == 3416407331) strcat(s, "e");
if (crc32("DPBcVbixaZMNql",14) == 2477251456) strcat(s, "r");
if (crc32("KydNoZOOhPbVTTR",15) == 2234875501) strcat(s, "a");
if (crc32("jZmcYK",6) == 1671724631) strcat(s, "l");
if (crc32("wEoaFPYsFdf",11) == 3978143208) strcat(s, "l");
if (crc32("JpFdPcJKEtokjlg",15) == 3412084043) strcat(s, "a");
if (crc32("wdBPjiUPwMti",12) == 3923107127) strcat(s, "y");
    return s;
}

char *preaggressively_adverbs() {
    char *s = calloc(16);
    if (crc32("fJNGXYeViUpu",12) == 114394950) strcat(s, "g");
if (crc32("XRdVaNWpOdfQxdu",15) == 3642300556) strcat(s, "p");
if (crc32("rADfM",5) == 717336570) strcat(s, "r");
if (crc32("HUfLd",5) == 2270643253) strcat(s, "f");
if (crc32("JYXjAHMVzwMYLF",14) == 2325884481) strcat(s, "e");
if (crc32("qntZRu",6) == 2049609763) strcat(s, "a");
if (crc32("aqkuAhnHmfPSOSc",15) == 3792119037) strcat(s, "t");
if (crc32("RyJbBuJrOm",10) == 847464180) strcat(s, "g");
if (crc32("pNVPGTcDVdNwEH",14) == 1821025456) strcat(s, "m");
if (crc32("AflMaOOoIrUaEqN",15) == 692322036) strcat(s, "g");
if (crc32("PduHgvsPcPOou",13) == 750869408) strcat(s, "u");
if (crc32("paQaIGZqSaxH",12) == 43924778) strcat(s, "r");
if (crc32("GfjoO",5) == 1945812484) strcat(s, "e");
if (crc32("Jrptk",5) == 3499471760) strcat(s, "s");
if (crc32("ILlqmt",6) == 194708401) strcat(s, "l");
if (crc32("iiqrixXXULUs",12) == 1365709905) strcat(s, "s");
if (crc32("vLVdeGUjPxHrz",13) == 3236778338) strcat(s, "i");
if (crc32("nfGdxZibbijnx",13) == 2328016179) strcat(s, "v");
if (crc32("QFAJoaUjZiqpIZZ",15) == 3557824716) strcat(s, "e");
if (crc32("sUaYMnAXPQMD",12) == 4133437133) strcat(s, "l");
if (crc32("MIzVpnVW",8) == 1150642010) strcat(s, "R");
if (crc32("NqMxFq",6) == 4070511585) strcat(s, "y");
    return s;
}

char *exceptively_adverbs() {
    char *s = calloc(12);
    if (crc32("GyJLqs",6) == 626834693) strcat(s, "e");
if (crc32("kURISdqRiJVDN",13) == 419954316) strcat(s, "x");
if (crc32("kmzRvck",7) == 3894441745) strcat(s, "Z");
if (crc32("sdkKqF",6) == 1773515120) strcat(s, "c");
if (crc32("ORTNrTpQ",8) == 139032414) strcat(s, "G");
if (crc32("DcDZRN",6) == 2536362761) strcat(s, "e");
if (crc32("PTBCJy",6) == 3176079950) strcat(s, "Y");
if (crc32("TyFYLOfShBMlkP",14) == 2357271632) strcat(s, "p");
if (crc32("QRZAyIUmBrYW",12) == 881978644) strcat(s, "d");
if (crc32("LEMFol",6) == 3796080388) strcat(s, "t");
if (crc32("VTeokAQfi",9) == 3623458296) strcat(s, "j");
if (crc32("oPRPEpfVoQe",11) == 550190911) strcat(s, "i");
if (crc32("KVBVUXDxzZ",10) == 3959388058) strcat(s, "v");
if (crc32("HwIVxVb",7) == 4078742768) strcat(s, "p");
if (crc32("SDCuxdWQ",8) == 3203542053) strcat(s, "e");
if (crc32("iwERVdeyyItmBo",14) == 705008176) strcat(s, "l");
if (crc32("upriaHTGOw",10) == 344536804) strcat(s, "d");
if (crc32("azqFoyDhs",9) == 493999424) strcat(s, "y");
    return s;
}

char *covetingly_adverbs() {
    char *s = calloc(11);
    if (crc32("xqznHuITpQEWM",13) == 1159491449) strcat(s, "c");
if (crc32("tfDFEKcKVkbWHU",14) == 1384252065) strcat(s, "o");
if (crc32("apFyueCvnIe",11) == 3455685585) strcat(s, "c");
if (crc32("qevqFCUgkxobE",13) == 3957470964) strcat(s, "v");
if (crc32("fZuPByhbmxpl",12) == 3443678449) strcat(s, "G");
if (crc32("llPBozznGkYtTnX",15) == 3874706443) strcat(s, "e");
if (crc32("TpaapT",6) == 1455019751) strcat(s, "t");
if (crc32("FPqalHEMrIXMW",13) == 2102228494) strcat(s, "i");
if (crc32("kofFgwgGNHkAzWY",15) == 1099667845) strcat(s, "U");
if (crc32("tiTOqV",6) == 1054217526) strcat(s, "n");
if (crc32("OGQOUGSZ",8) == 2590802621) strcat(s, "g");
if (crc32("bvlnV",5) == 1396681948) strcat(s, "l");
if (crc32("AcMlNsBjdHMU",12) == 749258132) strcat(s, "y");
    return s;
}

char *levelly_adverbs() {
    char *s = calloc(8);
    if (crc32("WEDhjV",6) == 2146593995) strcat(s, "l");
if (crc32("bkAZtTinztr",11) == 736818025) strcat(s, "e");
if (crc32("vRMMCqm",7) == 2416682183) strcat(s, "g");
if (crc32("VRUOqrCHyiDmS",13) == 1745415143) strcat(s, "v");
if (crc32("baYxHwIXiRR",11) == 3134113832) strcat(s, "s");
if (crc32("ZFnpljcnpN",10) == 2953342387) strcat(s, "e");
if (crc32("QMPXLRKPBANL",12) == 2003362795) strcat(s, "l");
if (crc32("ztlwarlhAL",10) == 3768810019) strcat(s, "l");
if (crc32("KRCnTlWdjAi",11) == 266759229) strcat(s, "y");
    return s;
}

char *floutingly_adverbs() {
    char *s = calloc(11);
    if (crc32("TWfMIxTSC",9) == 594195708) strcat(s, "f");
if (crc32("NfSQuuKqwpXkz",13) == 3572274540) strcat(s, "y");
if (crc32("VEKSTJteCqfv",12) == 2217509047) strcat(s, "l");
if (crc32("stgMk",5) == 1190305631) strcat(s, "z");
if (crc32("VReUWhBP",8) == 1406259732) strcat(s, "o");
if (crc32("JhctZKwyHczSX",13) == 3774082468) strcat(s, "c");
if (crc32("EOfZGddj",8) == 4294510784) strcat(s, "u");
if (crc32("tPJBjZne",8) == 85910481) strcat(s, "y");
if (crc32("POZrDDpcWkTnKv",14) == 1305141161) strcat(s, "t");
if (crc32("yhYPMASm",8) == 3343234497) strcat(s, "i");
if (crc32("VCXOqQyWlLEDP",13) == 2624253858) strcat(s, "y");
if (crc32("gNNvSx",6) == 2802824220) strcat(s, "n");
if (crc32("ZvtujzV",7) == 2241444529) strcat(s, "g");
if (crc32("ILhSxmZaVGCcud",14) == 2622961374) strcat(s, "l");
if (crc32("rwFRe",5) == 2163923149) strcat(s, "Y");
if (crc32("ZTGNSF",6) == 2745878853) strcat(s, "y");
    return s;
}

char *homogonously_adverbs() {
    char *s = calloc(13);
    if (crc32("eYmNFVJYYUsMjB",14) == 614427835) strcat(s, "h");
if (crc32("htYCYzHQxELQlOl",15) == 4035155709) strcat(s, "S");
if (crc32("UwyeeXYPLFa",11) == 2428175123) strcat(s, "o");
if (crc32("ZzYUe",5) == 226689557) strcat(s, "p");
if (crc32("JPFifNGNflzfs",13) == 3289240696) strcat(s, "m");
if (crc32("ErjbZ",5) == 238204682) strcat(s, "o");
if (crc32("oswWJV",6) == 3784799597) strcat(s, "g");
if (crc32("zVquMH",6) == 272703687) strcat(s, "o");
if (crc32("AstMDyUK",8) == 80849215) strcat(s, "n");
if (crc32("CjcGRIqMwgMU",12) == 1297869648) strcat(s, "o");
if (crc32("REYyF",5) == 3839429721) strcat(s, "Y");
if (crc32("FLPGso",6) == 2449948545) strcat(s, "u");
if (crc32("VeEZidm",7) == 3295143436) strcat(s, "s");
if (crc32("UHznDcPjmn",10) == 2175492995) strcat(s, "l");
if (crc32("khqueShrcAO",11) == 2807740106) strcat(s, "y");
    return s;
}

char *upspringing_adverbs() {
    char *s = calloc(12);
    if (crc32("oFtgFQd",7) == 2143812456) strcat(s, "o");
if (crc32("QNxXtMNMyJ",10) == 2536437987) strcat(s, "u");
if (crc32("DCztNKM",7) == 3706907993) strcat(s, "l");
if (crc32("YDvIWEaTK",9) == 1660259242) strcat(s, "p");
if (crc32("jIXkGiUnMW",10) == 2025482339) strcat(s, "Y");
if (crc32("ghESj",5) == 1493322326) strcat(s, "s");
if (crc32("jUQHO",5) == 3556419305) strcat(s, "Y");
if (crc32("VfRmtsGBjjRPHj",14) == 3484840343) strcat(s, "p");
if (crc32("BbDDpEP",7) == 2986139147) strcat(s, "H");
if (crc32("hojbU",5) == 95407724) strcat(s, "r");
if (crc32("eGMDxRNfJkr",11) == 1734375214) strcat(s, "g");
if (crc32("JbvIQYCiV",9) == 1862874529) strcat(s, "i");
if (crc32("ZbvKhaWPHNqF",12) == 3856763421) strcat(s, "w");
if (crc32("iyNTqpqppH",10) == 2417167983) strcat(s, "n");
if (crc32("JkAJyAyR",8) == 2659089140) strcat(s, "g");
if (crc32("PKhaoOC",7) == 708947825) strcat(s, "i");
if (crc32("zUJEprKpY",9) == 1477405680) strcat(s, "n");
if (crc32("SGlVetTBWjArJ",13) == 2490171508) strcat(s, "g");
if (crc32("yAaeCCEVUdqbw",13) == 998295927) strcat(s, "g");
    return s;
}

char *nonmimetically_adverbs() {
    char *s = calloc(15);
    if (crc32("JkLVAiYuWUatb",13) == 3030525785) strcat(s, "u");
if (crc32("vQaHsiiykDWA",12) == 3667952172) strcat(s, "n");
if (crc32("EjjrjyJ",7) == 4062029527) strcat(s, "t");
if (crc32("MhfvTtZA",8) == 2445569886) strcat(s, "o");
if (crc32("sVVpKIQ",7) == 122655706) strcat(s, "n");
if (crc32("wURnodCqlHWnze",14) == 3613432200) strcat(s, "b");
if (crc32("WqSXlMM",7) == 3323820628) strcat(s, "m");
if (crc32("uPiYcNLvOyDd",12) == 3139881812) strcat(s, "K");
if (crc32("oLWIdRlC",8) == 1456201231) strcat(s, "i");
if (crc32("yAtFxnNUaJLKhhw",15) == 697623908) strcat(s, "m");
if (crc32("gxcjB",5) == 3556204949) strcat(s, "m");
if (crc32("nvtECxi",7) == 2589127041) strcat(s, "e");
if (crc32("POvLDWKwwB",10) == 1508684330) strcat(s, "p");
if (crc32("LdmlgyDaXg",10) == 2090810509) strcat(s, "t");
if (crc32("qZlNTP",6) == 3176630648) strcat(s, "i");
if (crc32("eJVVsLHYOZOpe",13) == 515300647) strcat(s, "c");
if (crc32("tdwOHYGmjKTtCP",14) == 1108440708) strcat(s, "a");
if (crc32("XjugBQAkChRhv",13) == 3184485191) strcat(s, "p");
if (crc32("JrVZkRHGeXsuhqg",15) == 4277469434) strcat(s, "l");
if (crc32("FrOtBgCyH",9) == 696706460) strcat(s, "a");
if (crc32("UGJlSOUKac",10) == 2331505012) strcat(s, "l");
if (crc32("tHGWoFCeKZ",10) == 2286977595) strcat(s, "X");
if (crc32("HcLmvAvPJLAZJuR",15) == 4047842700) strcat(s, "y");
    return s;
}

char *howlingly_adverbs() {
    char *s = calloc(10);
    if (crc32("QctvysclzWJP",12) == 3650590347) strcat(s, "h");
if (crc32("vyaRYJIBH",9) == 1392112213) strcat(s, "r");
if (crc32("jUkkCDsO",8) == 3312891956) strcat(s, "o");
if (crc32("KXqhlqrF",8) == 4259529501) strcat(s, "e");
if (crc32("CVuDxKtLuVBshEP",15) == 695974747) strcat(s, "w");
if (crc32("rAWqbriSvdVr",12) == 1612315564) strcat(s, "h");
if (crc32("ieLWWkYJkXZyuCN",15) == 2414429639) strcat(s, "l");
if (crc32("uZiWCxeKXKPZtN",14) == 935505623) strcat(s, "i");
if (crc32("cJKZurXze",9) == 2852127219) strcat(s, "n");
if (crc32("zzOQxFYN",8) == 55685331) strcat(s, "M");
if (crc32("fcTgQQTluXeU",12) == 390586664) strcat(s, "g");
if (crc32("RxaXrxBtG",9) == 1499205782) strcat(s, "a");
if (crc32("knviG",5) == 4290912590) strcat(s, "l");
if (crc32("uBqWUiNT",8) == 2707558699) strcat(s, "y");
    return s;
}

char *nonsubliminally_adverbs() {
    char *s = calloc(16);
    if (crc32("YhtppAxEbXGLOmb",15) == 3310561911) strcat(s, "U");
if (crc32("MciZfW",6) == 1027321365) strcat(s, "n");
if (crc32("zZkhLodBPWOT",12) == 3934693914) strcat(s, "o");
if (crc32("MRHKJbxblX",10) == 1111493680) strcat(s, "G");
if (crc32("sSInEeZCa",9) == 197293949) strcat(s, "n");
if (crc32("ofuJJnWLGZLXUyC",15) == 1487937197) strcat(s, "S");
if (crc32("tjuMxCFogwFetxs",15) == 1733206434) strcat(s, "s");
if (crc32("kkpeyHfjZN",10) == 2952137403) strcat(s, "u");
if (crc32("XAkaUAg",7) == 2090320530) strcat(s, "D");
if (crc32("RcSjonCDO",9) == 2678751269) strcat(s, "b");
if (crc32("THaHA",5) == 2745829063) strcat(s, "G");
if (crc32("GkNTDomf",8) == 343252069) strcat(s, "l");
if (crc32("ZOUphQMQGXs",11) == 1750121656) strcat(s, "i");
if (crc32("lruenQm",7) == 2078382118) strcat(s, "J");
if (crc32("MFjbsp",6) == 2657634008) strcat(s, "m");
if (crc32("LlPBIyLxBxHFG",13) == 4273244470) strcat(s, "i");
if (crc32("TMvlzB",6) == 1968482299) strcat(s, "a");
if (crc32("KrMPAxsawWysGV",14) == 123335137) strcat(s, "n");
if (crc32("xCbmCGpupX",10) == 2301710007) strcat(s, "a");
if (crc32("dkIirGxjinePWD",14) == 2730548422) strcat(s, "W");
if (crc32("pNKeqrxLFpSH",12) == 3379531682) strcat(s, "l");
if (crc32("ZgqWk",5) == 1759092457) strcat(s, "l");
if (crc32("XXMyDBAIDjzg",12) == 2652534857) strcat(s, "Y");
if (crc32("kGjNUIetlAcnrf",14) == 4051472833) strcat(s, "y");
    return s;
}

char *multilaterally_adverbs() {
    char *s = calloc(15);
    if (crc32("mslqOdHxtiaeS",13) == 2869892636) strcat(s, "f");
if (crc32("vQBIHmwejVG",11) == 686639630) strcat(s, "m");
if (crc32("CjQks",5) == 414546126) strcat(s, "f");
if (crc32("levEbx",6) == 2922829567) strcat(s, "u");
if (crc32("vSvxJAnAwMtP",12) == 1108089287) strcat(s, "l");
if (crc32("FfrDfEuQXk",10) == 1735170359) strcat(s, "z");
if (crc32("XroYO",5) == 3253087489) strcat(s, "t");
if (crc32("smbCBmJJTzbNdX",14) == 1100728276) strcat(s, "i");
if (crc32("GqpUtLGcRK",10) == 1139613144) strcat(s, "l");
if (crc32("VRrwrNoyBvQvQm",14) == 1802975951) strcat(s, "l");
if (crc32("SNsuRZwZrjP",11) == 1915171791) strcat(s, "a");
if (crc32("ntNvKUu",7) == 3256800763) strcat(s, "J");
if (crc32("bTGwEanZeDcky",13) == 3950844407) strcat(s, "t");
if (crc32("KEofOKKFnHZ",11) == 2833619443) strcat(s, "x");
if (crc32("UDaQxIDQE",9) == 1681063980) strcat(s, "e");
if (crc32("risODDkfh",9) == 1497302539) strcat(s, "r");
if (crc32("KYcXrnoNChdnF",13) == 240192605) strcat(s, "a");
if (crc32("ukmXtmexJHnnwWE",15) == 1221327544) strcat(s, "N");
if (crc32("vtCrLsmb",8) == 3917372473) strcat(s, "l");
if (crc32("NbyOM",5) == 2489455493) strcat(s, "l");
if (crc32("fjdov",5) == 2417402378) strcat(s, "y");
    return s;
}

char *ropily_adverbs() {
    char *s = calloc(7);
    if (crc32("OvvvhyeleF",10) == 811643577) strcat(s, "r");
if (crc32("hLEutQiPJdwu",12) == 172507352) strcat(s, "o");
if (crc32("YyPXxRwVphbVUzz",15) == 3883213887) strcat(s, "A");
if (crc32("AGXyKdRldvuHqr",14) == 26987184) strcat(s, "p");
if (crc32("JfRQiGtulm",10) == 3836925669) strcat(s, "i");
if (crc32("ujUBYhtd",8) == 560530008) strcat(s, "i");
if (crc32("wTcvgBiYXjUaTpf",15) == 2131356577) strcat(s, "l");
if (crc32("aAMQNhs",7) == 3109540922) strcat(s, "y");
    return s;
}

char *ideationally_adverbs() {
    char *s = calloc(13);
    if (crc32("gqsPlw",6) == 2978040596) strcat(s, "o");
if (crc32("CNHeEmGDuYkH",12) == 3594455447) strcat(s, "i");
if (crc32("dySUJkzazxiL",12) == 356177465) strcat(s, "d");
if (crc32("UkfScjdZB",9) == 744506264) strcat(s, "e");
if (crc32("JlniPAuEVUseD",13) == 423450016) strcat(s, "k");
if (crc32("HnyiKKVo",8) == 4259988410) strcat(s, "a");
if (crc32("FLXfrgp",7) == 4191111581) strcat(s, "t");
if (crc32("pUKbKgMgVbMGXfw",15) == 2146023747) strcat(s, "d");
if (crc32("TZWDt",5) == 93288129) strcat(s, "i");
if (crc32("gvkfVoomxs",10) == 4210716474) strcat(s, "o");
if (crc32("pUhsbkbfdmCeiF",14) == 161038634) strcat(s, "n");
if (crc32("ymmierN",7) == 3603233618) strcat(s, "Y");
if (crc32("slZJqQaFku",10) == 4107833264) strcat(s, "a");
if (crc32("nOlbiBOKBZSAnu",14) == 2044171627) strcat(s, "A");
if (crc32("xEZwS",5) == 1350414341) strcat(s, "l");
if (crc32("hWggX",5) == 2275263469) strcat(s, "N");
if (crc32("mVTeMShmGNDN",12) == 2805883442) strcat(s, "l");
if (crc32("aoJjkixqUUWbI",13) == 3466531989) strcat(s, "w");
if (crc32("idUseeVZ",8) == 318063510) strcat(s, "y");
    return s;
}

char *Jacobitishly_adverbs() {
    char *s = calloc(13);
    if (crc32("BZHBz",5) == 1287092783) strcat(s, "J");
if (crc32("zeCEA",5) == 1044468532) strcat(s, "g");
if (crc32("VkXJBY",6) == 649848729) strcat(s, "a");
if (crc32("sERvlDMVt",9) == 682639053) strcat(s, "m");
if (crc32("WlwGOLXC",8) == 2908963262) strcat(s, "c");
if (crc32("TYRDWnRLSrIvua",14) == 4117884716) strcat(s, "H");
if (crc32("xgHpn",5) == 1389197944) strcat(s, "o");
if (crc32("OfOpvc",6) == 1676039518) strcat(s, "b");
if (crc32("NHAdMjhSU",9) == 1133747209) strcat(s, "i");
if (crc32("MpwlGDvtRfSYtht",15) == 686954985) strcat(s, "t");
if (crc32("QLNWmlWiatfl",12) == 872817372) strcat(s, "U");
if (crc32("ZeizzsNqsNVLy",13) == 220696795) strcat(s, "i");
if (crc32("CdCjEn",6) == 3210299094) strcat(s, "s");
if (crc32("LuWCOaqsmsSVOhB",15) == 2909189588) strcat(s, "r");
if (crc32("XtYlpCI",7) == 3652411354) strcat(s, "h");
if (crc32("iAsraamkW",9) == 1823084481) strcat(s, "J");
if (crc32("TSIZrFNnj",9) == 2145923361) strcat(s, "l");
if (crc32("LCAFAqDNctyAEp",14) == 2066355162) strcat(s, "K");
if (crc32("HwPuLZLTmTrS",12) == 2559520780) strcat(s, "y");
    return s;
}

char *semimystically_adverbs() {
    char *s = calloc(15);
    if (crc32("sMyfFwIlMMRf",12) == 2670728720) strcat(s, "s");
if (crc32("DbFVHkFnFbsV",12) == 756550979) strcat(s, "e");
if (crc32("dJiXPhmtHeX",11) == 1340862272) strcat(s, "G");
if (crc32("NVbuxQOM",8) == 3511136454) strcat(s, "m");
if (crc32("mdtTCiuqrOdd",12) == 719735702) strcat(s, "i");
if (crc32("FaDTGqpx",8) == 3696922680) strcat(s, "m");
if (crc32("rmlTA",5) == 314421374) strcat(s, "y");
if (crc32("XQVTF",5) == 3994116773) strcat(s, "h");
if (crc32("QAjKy",5) == 2683125662) strcat(s, "s");
if (crc32("wfScBr",6) == 3501587704) strcat(s, "U");
if (crc32("bfPckIuPgCZeWId",15) == 1516978435) strcat(s, "t");
if (crc32("xsIzbxPx",8) == 2160945418) strcat(s, "F");
if (crc32("uqdToEkxQHLKMY",14) == 2297779789) strcat(s, "i");
if (crc32("WitQJSECbT",10) == 3515950238) strcat(s, "c");
if (crc32("XMpRRqIcKlaRGZ",14) == 203218310) strcat(s, "a");
if (crc32("exvyse",6) == 2656738656) strcat(s, "F");
if (crc32("gOZLVJ",6) == 3645413607) strcat(s, "l");
if (crc32("LaLEpRvgLc",10) == 2254378151) strcat(s, "l");
if (crc32("OFyfjdHfSU",10) == 1599413951) strcat(s, "z");
if (crc32("LKVLKKCRipLZju",14) == 534769130) strcat(s, "y");
    return s;
}

char *timidly_adverbs() {
    char *s = calloc(8);
    if (crc32("TRXvXIITjKY",11) == 2949675257) strcat(s, "b");
if (crc32("FxucFrOsN",9) == 4231081951) strcat(s, "t");
if (crc32("edyOvMaPKe",10) == 4066891639) strcat(s, "e");
if (crc32("riXsOIJsI",9) == 550805482) strcat(s, "i");
if (crc32("vhBYeVWLWMPBX",13) == 852622951) strcat(s, "k");
if (crc32("dpQAc",5) == 2433256493) strcat(s, "m");
if (crc32("OPPnFPTeURenD",13) == 1011557896) strcat(s, "i");
if (crc32("ApDrvkse",8) == 20425305) strcat(s, "E");
if (crc32("UZEcqrVjnL",10) == 3971370162) strcat(s, "d");
if (crc32("vTmBy",5) == 3864023021) strcat(s, "z");
if (crc32("gJiAdxzD",8) == 1608007390) strcat(s, "l");
if (crc32("dBuhxAy",7) == 2865870204) strcat(s, "J");
if (crc32("sodZZD",6) == 3281831221) strcat(s, "y");
    return s;
}

char *entanglingly_adverbs() {
    char *s = calloc(13);
    if (crc32("kMFJQyXuDE",10) == 293881499) strcat(s, "X");
if (crc32("FjozZJCC",8) == 48933237) strcat(s, "e");
if (crc32("nnyqPCWllzP",11) == 2882848060) strcat(s, "M");
if (crc32("HUFjIHfcdQnKzJ",14) == 52283947) strcat(s, "n");
if (crc32("kUUQMYleBnY",11) == 582368465) strcat(s, "t");
if (crc32("JWrAOPaXKctOy",13) == 2232556688) strcat(s, "a");
if (crc32("pWnaqYNoaXq",11) == 1824224518) strcat(s, "p");
if (crc32("NyrdbudkAOrw",12) == 247730926) strcat(s, "n");
if (crc32("BEHrhDTj",8) == 2181140847) strcat(s, "g");
if (crc32("PMzlnm",6) == 2417827036) strcat(s, "l");
if (crc32("FrNVaHI",7) == 4010559651) strcat(s, "l");
if (crc32("CmrACsPPInI",11) == 3140006226) strcat(s, "i");
if (crc32("cOLhjMVha",9) == 1359668955) strcat(s, "n");
if (crc32("GVRJSovZMN",10) == 3346695759) strcat(s, "Z");
if (crc32("fZHSTB",6) == 1804845657) strcat(s, "g");
if (crc32("oPCGhFKs",8) == 4212059106) strcat(s, "i");
if (crc32("aUfhCpgRnpr",11) == 1849522085) strcat(s, "l");
if (crc32("paABEzcAs",9) == 1416175246) strcat(s, "y");
    return s;
}

char *untraitorously_adverbs() {
    char *s = calloc(15);
    if (crc32("FHAkTLERTwf",11) == 2630534018) strcat(s, "D");
if (crc32("eQBGOoNoLl",10) == 2661132892) strcat(s, "u");
if (crc32("MGPMyDpy",8) == 2646191561) strcat(s, "n");
if (crc32("NuOkjLFqqLUSohm",15) == 1205537863) strcat(s, "c");
if (crc32("TOxNByf",7) == 799240479) strcat(s, "t");
if (crc32("WWlBKar",7) == 3110605349) strcat(s, "r");
if (crc32("VEZjU",5) == 948168777) strcat(s, "a");
if (crc32("sgHCP",5) == 269956082) strcat(s, "i");
if (crc32("KvZJLQjiRDpf",12) == 1921655940) strcat(s, "F");
if (crc32("rNvdkBlAUtgwa",13) == 4235519618) strcat(s, "t");
if (crc32("HjIcaL",6) == 776631261) strcat(s, "o");
if (crc32("hCeDYoRsWEem",12) == 3088855654) strcat(s, "L");
if (crc32("YuvSsWcW",8) == 2557827259) strcat(s, "r");
if (crc32("KNiExtnJZNCUf",13) == 3521785513) strcat(s, "o");
if (crc32("oncZHxKr",8) == 2921474924) strcat(s, "L");
if (crc32("sxefFSa",7) == 926311597) strcat(s, "u");
if (crc32("fGfwHIVGV",9) == 3489077484) strcat(s, "s");
if (crc32("tsVdnF",6) == 1518003557) strcat(s, "l");
if (crc32("WGqJiAOmrPlbd",13) == 2388327739) strcat(s, "y");
    return s;
}

char *superadequately_adverbs() {
    char *s = calloc(16);
    if (crc32("fyXTcDvBwXA",11) == 771203684) strcat(s, "G");
if (crc32("gPqExCBgp",9) == 3607347818) strcat(s, "s");
if (crc32("GvzxjUeR",8) == 165290019) strcat(s, "u");
if (crc32("HafFTLCqY",9) == 3833305546) strcat(s, "p");
if (crc32("RQNhgl",6) == 2789247905) strcat(s, "e");
if (crc32("hZfJXURw",8) == 256208494) strcat(s, "r");
if (crc32("SgjOuWsaZtWFFL",14) == 2946871120) strcat(s, "b");
if (crc32("xYEdAifYGpVj",12) == 545209968) strcat(s, "a");
if (crc32("MLUQU",5) == 1700112725) strcat(s, "d");
if (crc32("qHMcNaqYvup",11) == 1608878946) strcat(s, "e");
if (crc32("MLAmgsTTgu",10) == 833894548) strcat(s, "q");
if (crc32("amZbDUyMYqi",11) == 1790762762) strcat(s, "n");
if (crc32("wJkkNqJBOKD",11) == 2287934405) strcat(s, "u");
if (crc32("AjMttNcWthmQ",12) == 2686332051) strcat(s, "H");
if (crc32("IQRegY",6) == 2348140206) strcat(s, "a");
if (crc32("GiLKpdBYjBbRAUL",15) == 1137560342) strcat(s, "x");
if (crc32("kcquPl",6) == 1919241922) strcat(s, "t");
if (crc32("fBLvaSfmwPvzuR",14) == 4247280429) strcat(s, "l");
if (crc32("snWHduZ",7) == 816401998) strcat(s, "e");
if (crc32("lThifKmZbbevJ",13) == 2901563426) strcat(s, "l");
if (crc32("WoMZvZIoJO",10) == 3251047228) strcat(s, "p");
if (crc32("VuPrCqKs",8) == 3249807872) strcat(s, "y");
    return s;
}

char *nondisingenuously_adverbs() {
    char *s = calloc(18);
    if (crc32("PNXMjC",6) == 1555293605) strcat(s, "n");
if (crc32("SVjPooS",7) == 512056523) strcat(s, "o");
if (crc32("xMcqfP",6) == 3535566248) strcat(s, "n");
if (crc32("EMZCkQhbIeIruOR",15) == 1169843511) strcat(s, "i");
if (crc32("LIsGAUlSCZl",11) == 1925534967) strcat(s, "d");
if (crc32("idlKllFbrx",10) == 2426620895) strcat(s, "M");
if (crc32("cUTQWW",6) == 3870642010) strcat(s, "i");
if (crc32("vhanaoh",7) == 3757677559) strcat(s, "Q");
if (crc32("ZqUJGi",6) == 3538793717) strcat(s, "s");
if (crc32("achupKkIb",9) == 3762707118) strcat(s, "i");
if (crc32("kugaAZFOBkoLVA",14) == 3895284345) strcat(s, "i");
if (crc32("xEqZgbtFkGCQ",12) == 671600043) strcat(s, "W");
if (crc32("CscJYJ",6) == 798121238) strcat(s, "n");
if (crc32("HpWMsRNDbWbCpH",14) == 4208844030) strcat(s, "g");
if (crc32("HrKmabD",7) == 627188631) strcat(s, "e");
if (crc32("dCaqsGhZRNnBvu",14) == 2339653655) strcat(s, "k");
if (crc32("bumHelNeArULJi",14) == 1427700128) strcat(s, "n");
if (crc32("tzfOEVREhZKhFZX",15) == 881335522) strcat(s, "u");
if (crc32("esTdUt",6) == 3432792680) strcat(s, "o");
if (crc32("WpOMfXLNV",9) == 3495359213) strcat(s, "u");
if (crc32("sjIDChHs",8) == 2409114894) strcat(s, "U");
if (crc32("NkgIeM",6) == 2737788889) strcat(s, "s");
if (crc32("ikVMmhQmrzvCoUV",15) == 2019301421) strcat(s, "l");
if (crc32("usHcJAdNlscNfos",15) == 3079257075) strcat(s, "y");
    return s;
}

char *getetout_adverbs() {
    char *s = calloc(9);
    if (crc32("LxIiURXmvrZli",13) == 718139799) strcat(s, "g");
if (crc32("sBSylmIbVn",10) == 1509547544) strcat(s, "e");
if (crc32("nDuNxacdhyVvirC",15) == 3441435243) strcat(s, "t");
if (crc32("CHPBiQ",6) == 1087188329) strcat(s, "e");
if (crc32("wjilzVVwyXlQdhH",15) == 532107806) strcat(s, "R");
if (crc32("SlxarYJNsVJRcqm",15) == 308118886) strcat(s, "t");
if (crc32("FDoEDmmpXQAk",12) == 1143033830) strcat(s, "K");
if (crc32("aWWYpmin",8) == 2392611294) strcat(s, "o");
if (crc32("NoyyQuXJTfPfVal",15) == 2055151292) strcat(s, "h");
if (crc32("cTQPi",5) == 3212091994) strcat(s, "u");
if (crc32("oPwxkRhjSOU",11) == 3455880499) strcat(s, "t");
    return s;
}

char *foundationally_adverbs() {
    char *s = calloc(15);
    if (crc32("bsrDG",5) == 959799645) strcat(s, "H");
if (crc32("YKxHnCDtSOojBcj",15) == 403295065) strcat(s, "f");
if (crc32("SzCRJ",5) == 3358146194) strcat(s, "K");
if (crc32("UPVNesNCXI",10) == 3685131872) strcat(s, "o");
if (crc32("rdKCnYYJ",8) == 1972307595) strcat(s, "q");
if (crc32("hxrWmlcRtxPFClW",15) == 80628604) strcat(s, "u");
if (crc32("aDYnzJxAL",9) == 2488487814) strcat(s, "i");
if (crc32("ejreLrlBL",9) == 851836154) strcat(s, "n");
if (crc32("oFVsGo",6) == 1161269945) strcat(s, "d");
if (crc32("gJeuuws",7) == 2344962432) strcat(s, "a");
if (crc32("KHBycTVMhNkuTH",14) == 3654357921) strcat(s, "t");
if (crc32("uuRNGYYVtsAn",12) == 465409991) strcat(s, "i");
if (crc32("fsLvRz",6) == 1761510248) strcat(s, "o");
if (crc32("SuHwleXDOsTe",12) == 2717690011) strcat(s, "o");
if (crc32("gtukOs",6) == 250601325) strcat(s, "n");
if (crc32("mEwhhlAaTO",10) == 2805364368) strcat(s, "a");
if (crc32("TaVlgK",6) == 4268720598) strcat(s, "N");
if (crc32("VyvVzHKfIVHV",12) == 3674153643) strcat(s, "l");
if (crc32("TznLbbdci",9) == 277474786) strcat(s, "l");
if (crc32("OOtTPCSsjFX",11) == 391527330) strcat(s, "y");
    return s;
}

char *superinclusively_adverbs() {
    char *s = calloc(17);
    if (crc32("mKcKRgzOd",9) == 3706116432) strcat(s, "z");
if (crc32("xHgEVDBRrh",10) == 3634524780) strcat(s, "s");
if (crc32("LnsbkXp",7) == 1692946123) strcat(s, "b");
if (crc32("OukfpsaOe",9) == 3623500643) strcat(s, "u");
if (crc32("WMsdb",5) == 3522501880) strcat(s, "p");
if (crc32("MmYeLIZG",8) == 2967039744) strcat(s, "x");
if (crc32("OfsshdXUPfIZS",13) == 1008211519) strcat(s, "e");
if (crc32("otgsMsbeS",9) == 110100143) strcat(s, "M");
if (crc32("xOnCXcACLPLLw",13) == 2603002006) strcat(s, "r");
if (crc32("FKUAfpIZWtSedKX",15) == 4187287375) strcat(s, "s");
if (crc32("OIBySoYKSOwUIi",14) == 2715202245) strcat(s, "i");
if (crc32("iowRJtsZX",9) == 4073069357) strcat(s, "n");
if (crc32("qwXoiSTgBk",10) == 3564029757) strcat(s, "c");
if (crc32("nymmW",5) == 2470729961) strcat(s, "l");
if (crc32("MuDEcjPuLbjB",12) == 2289559475) strcat(s, "u");
if (crc32("iGUyFTsoBmps",12) == 201174160) strcat(s, "s");
if (crc32("uUKzGjVrKH",10) == 1691608087) strcat(s, "J");
if (crc32("WudjgxxYUYy",11) == 2497089139) strcat(s, "i");
if (crc32("VQONRr",6) == 3784534869) strcat(s, "v");
if (crc32("kzeWqMs",7) == 3312734164) strcat(s, "R");
if (crc32("yPBJRsPPlQVX",12) == 12199987) strcat(s, "e");
if (crc32("CXpbAoafeDngE",13) == 115181292) strcat(s, "l");
if (crc32("gmmopVmUlddXXf",14) == 3665507785) strcat(s, "y");
    return s;
}

char *fantastically_adverbs() {
    char *s = calloc(14);
    if (crc32("rWRLOEaL",8) == 130732564) strcat(s, "f");
if (crc32("cKNjFbnuTnPDTL",14) == 643102775) strcat(s, "a");
if (crc32("iXJQy",5) == 3977123266) strcat(s, "Y");
if (crc32("gcVBLlRHTWb",11) == 2673148310) strcat(s, "n");
if (crc32("FxDoMDlQQEfUzY",14) == 1983790391) strcat(s, "t");
if (crc32("lRAzAaQdoHF",11) == 2694325835) strcat(s, "d");
if (crc32("WyukgleUuJ",10) == 1656646875) strcat(s, "a");
if (crc32("mDOZCevHNRAAXhs",15) == 3264562844) strcat(s, "k");
if (crc32("sctfKvXTjPDP",12) == 548700807) strcat(s, "s");
if (crc32("xJDilKxLYjjfpzn",15) == 3042716125) strcat(s, "t");
if (crc32("utanPXOJOjP",11) == 4153688345) strcat(s, "i");
if (crc32("vPbIIMniUfmk",12) == 1616317727) strcat(s, "c");
if (crc32("oReeNtooBp",10) == 1438877958) strcat(s, "a");
if (crc32("XDKWCVoghCEd",12) == 1933977814) strcat(s, "r");
if (crc32("KyVkXKx",7) == 2210789461) strcat(s, "l");
if (crc32("oaBzFfLMvRlS",12) == 2788116610) strcat(s, "P");
if (crc32("PLktzNdPdh",10) == 551851866) strcat(s, "l");
if (crc32("bmWXNieMaBkb",12) == 4027895204) strcat(s, "y");
if (crc32("NNOMzGYVCtLjRfF",15) == 2364767130) strcat(s, "y");
    return s;
}

char *writhingly_adverbs() {
    char *s = calloc(11);
    if (crc32("UBqiUT",6) == 2375453774) strcat(s, "X");
if (crc32("yBcxuIcBHLbpfy",14) == 494357452) strcat(s, "w");
if (crc32("FdIyJHCatSgjh",13) == 2027957713) strcat(s, "R");
if (crc32("MrFgMsplkVINx",13) == 3788845656) strcat(s, "r");
if (crc32("VCEfQfr",7) == 975805537) strcat(s, "i");
if (crc32("xZmYdWtbnLOdO",13) == 2400013139) strcat(s, "t");
if (crc32("KyMFw",5) == 4013319132) strcat(s, "h");
if (crc32("iYGduJloW",9) == 3713375130) strcat(s, "i");
if (crc32("iCjlQCHkhxQWQI",14) == 842761284) strcat(s, "n");
if (crc32("QXdTHoXTPTk",11) == 47631486) strcat(s, "g");
if (crc32("uJhQTXBwXJz",11) == 673750087) strcat(s, "l");
if (crc32("yQfhQehcqvhPVVj",15) == 3750116465) strcat(s, "S");
if (crc32("pYJKRuKnoqqPsl",14) == 4033123634) strcat(s, "y");
    return s;
}

char *unexcusedly_adverbs() {
    char *s = calloc(12);
    if (crc32("WfbEsdnQUEQCtc",14) == 1358593449) strcat(s, "u");
if (crc32("VlXHL",5) == 635712115) strcat(s, "n");
if (crc32("JzrOSmfxGtOeo",13) == 325817907) strcat(s, "H");
if (crc32("YShtBirh",8) == 4260928913) strcat(s, "e");
if (crc32("SWarDHhGRndmy",13) == 601329757) strcat(s, "X");
if (crc32("fVWiXSNCv",9) == 1516098345) strcat(s, "x");
if (crc32("LrjPWNuoL",9) == 396856381) strcat(s, "Q");
if (crc32("ouiZIeKLEGbsHi",14) == 2127863159) strcat(s, "c");
if (crc32("YVgwTeDPA",9) == 4263457188) strcat(s, "u");
if (crc32("EIqoN",5) == 2518625803) strcat(s, "s");
if (crc32("lfwRAZmqzHV",11) == 1895261840) strcat(s, "e");
if (crc32("uSIJkWIk",8) == 2821009471) strcat(s, "f");
if (crc32("vjQrIhgivawu",12) == 3260215213) strcat(s, "d");
if (crc32("xcdZPVwv",8) == 1741006740) strcat(s, "M");
if (crc32("knCUXJBihCaS",12) == 3745497359) strcat(s, "l");
if (crc32("wygYkjqCAkVbAFI",15) == 1465369445) strcat(s, "y");
    return s;
}

char *nonparentally_adverbs() {
    char *s = calloc(14);
    if (crc32("BBqRoMudVmuRgAW",15) == 285889241) strcat(s, "n");
if (crc32("owMYWpIVHcika",13) == 628483839) strcat(s, "o");
if (crc32("svRnPTmFPvjfh",13) == 3570119037) strcat(s, "O");
if (crc32("cqFfwkVQLtjy",12) == 1662622422) strcat(s, "n");
if (crc32("MXlsMYZIejT",11) == 249042719) strcat(s, "r");
if (crc32("bNyQMrkRLxRwTUW",15) == 2184487009) strcat(s, "p");
if (crc32("hbwumOgFViozAT",14) == 4131562588) strcat(s, "a");
if (crc32("EajCdOhg",8) == 785573353) strcat(s, "r");
if (crc32("mjsSxCEx",8) == 4236790392) strcat(s, "e");
if (crc32("CnyxDYBC",8) == 2797026592) strcat(s, "n");
if (crc32("fLYYcEJsjSa",11) == 3802914994) strcat(s, "C");
if (crc32("lxQxnaa",7) == 2582246729) strcat(s, "t");
if (crc32("diMYIshMhlN",11) == 228054745) strcat(s, "w");
if (crc32("ilPCQrmOlJ",10) == 4259424421) strcat(s, "a");
if (crc32("ueYDZn",6) == 2017193320) strcat(s, "q");
if (crc32("KQCtXJUHiAg",11) == 1780852282) strcat(s, "l");
if (crc32("bGeyFgK",7) == 1800944455) strcat(s, "l");
if (crc32("ybqhWHRxE",9) == 3232036303) strcat(s, "X");
if (crc32("NRvtprMPHMeSfW",14) == 3914369022) strcat(s, "y");
    return s;
}

char *generously_adverbs() {
    char *s = calloc(11);
    if (crc32("jLldtPoyXE",10) == 21333771) strcat(s, "g");
if (crc32("LTAauEFAmIjXX",13) == 3546780030) strcat(s, "e");
if (crc32("WRtulqnTINLQZP",14) == 1158375465) strcat(s, "n");
if (crc32("qowuTAZKxUhjG",13) == 3640991249) strcat(s, "n");
if (crc32("BNoXmxXgBUsV",12) == 1208207746) strcat(s, "e");
if (crc32("iysxpUWSLI",10) == 4280101320) strcat(s, "r");
if (crc32("tDTilSDFZ",9) == 919177462) strcat(s, "S");
if (crc32("CDDjI",5) == 713442795) strcat(s, "o");
if (crc32("JZVoMHVGBxjc",12) == 3647880484) strcat(s, "u");
if (crc32("iLWcZvLOVrqngz",14) == 3863937148) strcat(s, "s");
if (crc32("CPJRlEjzoSKw",12) == 2582601009) strcat(s, "s");
if (crc32("geJTymtg",8) == 3413093092) strcat(s, "l");
if (crc32("dTRTMlBeZ",9) == 990043123) strcat(s, "o");
if (crc32("zHrbICHJ",8) == 2955389029) strcat(s, "y");
    return s;
}

char *parasitically_adverbs() {
    char *s = calloc(14);
    if (crc32("xfnEBwyBImUrk",13) == 251496151) strcat(s, "p");
if (crc32("amNYy",5) == 3957999541) strcat(s, "y");
if (crc32("xJdXPIpTvi",10) == 501169825) strcat(s, "a");
if (crc32("CHMImSXOaSUGjx",14) == 2813530333) strcat(s, "r");
if (crc32("xsdvcMzqtFEargC",15) == 1787017344) strcat(s, "a");
if (crc32("JoNdvZU",7) == 3692808957) strcat(s, "s");
if (crc32("voyAAojOblqP",12) == 1046704891) strcat(s, "h");
if (crc32("ZnYkaK",6) == 1438311689) strcat(s, "i");
if (crc32("vDpfP",5) == 2497188878) strcat(s, "g");
if (crc32("GjNYhtmN",8) == 2242946957) strcat(s, "t");
if (crc32("SOnvNipvJU",10) == 1912538841) strcat(s, "i");
if (crc32("GCqwgpwjdPVjra",14) == 146790702) strcat(s, "o");
if (crc32("mBtBnEvNQTEPbxq",15) == 1756036624) strcat(s, "c");
if (crc32("yqVOC",5) == 3647642173) strcat(s, "h");
if (crc32("harfAhd",7) == 3982604650) strcat(s, "a");
if (crc32("NtzNceL",7) == 4231245517) strcat(s, "l");
if (crc32("hgBsrAVhR",9) == 4213675364) strcat(s, "k");
if (crc32("MajdOsiIYTD",11) == 1414684579) strcat(s, "l");
if (crc32("CEpJXgGDfPQJFNR",15) == 2539680243) strcat(s, "x");
if (crc32("SEntJcQOmu",10) == 1894794032) strcat(s, "y");
    return s;
}

char *pudgily_adverbs() {
    char *s = calloc(8);
    if (crc32("IqRfNJfwKpasSm",14) == 1362923506) strcat(s, "R");
if (crc32("lRezOSHgpTJPe",13) == 1959873087) strcat(s, "p");
if (crc32("FfoEjR",6) == 1621994775) strcat(s, "o");
if (crc32("AREumis",7) == 3482855363) strcat(s, "u");
if (crc32("hFrWKUMBhWkGE",13) == 370885365) strcat(s, "X");
if (crc32("opnDG",5) == 2291863301) strcat(s, "d");
if (crc32("yJuyG",5) == 2184606157) strcat(s, "g");
if (crc32("xoJRuCygN",9) == 3366699632) strcat(s, "r");
if (crc32("cecAW",5) == 1119105755) strcat(s, "i");
if (crc32("OdboSXMJ",8) == 4039366524) strcat(s, "M");
if (crc32("BkzaLwQatTtnOcZ",15) == 310613318) strcat(s, "l");
if (crc32("CuJZKPkV",8) == 3782804373) strcat(s, "u");
if (crc32("hPnQIDVvFNXi",12) == 798408681) strcat(s, "y");
    return s;
}

char *perseveringly_adverbs() {
    char *s = calloc(14);
    if (crc32("sBRfCg",6) == 1000033635) strcat(s, "p");
if (crc32("CRnyC",5) == 3943966226) strcat(s, "e");
if (crc32("FMCsPoBbvOd",11) == 4292330769) strcat(s, "r");
if (crc32("IxYTp",5) == 2117384081) strcat(s, "s");
if (crc32("XcijHc",6) == 1626875188) strcat(s, "s");
if (crc32("qemAWHCFU",9) == 2899477603) strcat(s, "e");
if (crc32("ihyXPQ",6) == 2849269909) strcat(s, "y");
if (crc32("LCsCKnLFOSKjs",13) == 2536895730) strcat(s, "v");
if (crc32("MBacWHzefoiVpd",14) == 3561284096) strcat(s, "e");
if (crc32("FiDvAaZQgjarZo",14) == 3405056160) strcat(s, "T");
if (crc32("cZTsOOnREQXUdMG",15) == 2231914624) strcat(s, "r");
if (crc32("XluFfypawwE",11) == 3197261063) strcat(s, "i");
if (crc32("yfhFNTwfALjhuei",15) == 1966560562) strcat(s, "L");
if (crc32("gEMWhSzkbNRpKb",14) == 2109070821) strcat(s, "n");
if (crc32("dhpUnSwFGEHZX",13) == 3168841358) strcat(s, "G");
if (crc32("AETmBuY",7) == 398148084) strcat(s, "g");
if (crc32("JCqrBIONV",9) == 1430875973) strcat(s, "l");
if (crc32("iDsAqdXHVjAgJYO",15) == 1770313454) strcat(s, "c");
if (crc32("eduRSwedpyyPfe",14) == 565442587) strcat(s, "y");
    return s;
}

char *unvoraciously_adverbs() {
    char *s = calloc(14);
    if (crc32("RWPhFReTeRM",11) == 3692900359) strcat(s, "u");
if (crc32("QUrqoLuVyOw",11) == 452134178) strcat(s, "Z");
if (crc32("irpBMyIE",8) == 3979555199) strcat(s, "n");
if (crc32("PHiQHBeqFrqPa",13) == 1799335500) strcat(s, "X");
if (crc32("IcZtdigqc",9) == 1490105200) strcat(s, "v");
if (crc32("ICQJgGRURlO",11) == 115981859) strcat(s, "V");
if (crc32("SwtEsD",6) == 2542088313) strcat(s, "o");
if (crc32("JHemmtF",7) == 2912539356) strcat(s, "C");
if (crc32("GxNJqrFxFvhymw",14) == 456490769) strcat(s, "r");
if (crc32("EmFWe",5) == 1825509944) strcat(s, "D");
if (crc32("cElJM",5) == 4149017193) strcat(s, "a");
if (crc32("kNktB",5) == 3288868544) strcat(s, "c");
if (crc32("NhrHpamVzcYkto",14) == 232508212) strcat(s, "i");
if (crc32("FUpXPqQqIewZ",12) == 3443044412) strcat(s, "o");
if (crc32("FuDtWwewwYZ",11) == 141052807) strcat(s, "u");
if (crc32("OOproyu",7) == 3885929292) strcat(s, "w");
if (crc32("AmxNbUFut",9) == 3771552137) strcat(s, "s");
if (crc32("BdjLzuhTXozQb",13) == 1395351779) strcat(s, "l");
if (crc32("GLCYS",5) == 1007521142) strcat(s, "g");
if (crc32("sToyftXFRTQ",11) == 4013412845) strcat(s, "y");
    return s;
}

char *zanily_adverbs() {
    char *s = calloc(7);
    if (crc32("AyrLijtEkDsM",12) == 3899623139) strcat(s, "z");
if (crc32("oQotzbe",7) == 3943341571) strcat(s, "a");
if (crc32("KlaNUIONluolvW",14) == 1440320877) strcat(s, "n");
if (crc32("qTBUQsjx",8) == 2230037746) strcat(s, "i");
if (crc32("TKanXVBHiGVI",12) == 339353714) strcat(s, "H");
if (crc32("KyLfhtGcH",9) == 1523224897) strcat(s, "l");
if (crc32("lYJMsOujNDLYQ",13) == 3108641477) strcat(s, "H");
if (crc32("rXPuJljohpJc",12) == 1089597810) strcat(s, "y");
    return s;
}

char *nonnasally_adverbs() {
    char *s = calloc(11);
    if (crc32("EFVGlgay",8) == 2060925552) strcat(s, "n");
if (crc32("huxSK",5) == 435893336) strcat(s, "o");
if (crc32("CfFkYSsPPVgkWm",14) == 2120027494) strcat(s, "n");
if (crc32("OqPHhbGaFnAt",12) == 834989259) strcat(s, "n");
if (crc32("WorPrYlvNkTD",12) == 2974283024) strcat(s, "a");
if (crc32("GdaiCDcbhcM",11) == 1722465703) strcat(s, "s");
if (crc32("btZKsPPtyhCK",12) == 328465803) strcat(s, "O");
if (crc32("IDIxP",5) == 1953568266) strcat(s, "a");
if (crc32("YlQdLVmH",8) == 3650777605) strcat(s, "l");
if (crc32("IdCLjdNmqDNd",12) == 2435763022) strcat(s, "l");
if (crc32("WetDbAIlIi",10) == 2755864647) strcat(s, "y");
    return s;
}

char *creatively_adverbs() {
    char *s = calloc(11);
    if (crc32("SxggZnHHxuErw",13) == 4036821822) strcat(s, "t");
if (crc32("zciEOmLxSZfSMow",15) == 1703178584) strcat(s, "c");
if (crc32("AarUvrKMw",9) == 3916650457) strcat(s, "O");
if (crc32("dwCJusMfTW",10) == 55369793) strcat(s, "r");
if (crc32("KQHyDgytoytwk",13) == 3231289712) strcat(s, "e");
if (crc32("jkgKYqJvag",10) == 2207119729) strcat(s, "a");
if (crc32("hkpxkNmOYf",10) == 1955193525) strcat(s, "t");
if (crc32("XpvTnwVor",9) == 2405160202) strcat(s, "x");
if (crc32("THWiVQ",6) == 2937038030) strcat(s, "i");
if (crc32("IxEjzTsMcT",10) == 3234922807) strcat(s, "v");
if (crc32("NflrcnKe",8) == 150517561) strcat(s, "e");
if (crc32("JDhUGMSFu",9) == 2405643142) strcat(s, "l");
if (crc32("jfNPsiacTnZa",12) == 2935799024) strcat(s, "y");
    return s;
}

char *nonhypnotically_adverbs() {
    char *s = calloc(16);
    if (crc32("rBqxFSYWUWbkJ",13) == 3330304174) strcat(s, "Q");
if (crc32("XrxAaRvHhzY",11) == 807146034) strcat(s, "n");
if (crc32("bkFpKGagnoAwpwF",15) == 3321180875) strcat(s, "o");
if (crc32("KIxZIyDFdFs",11) == 521897685) strcat(s, "q");
if (crc32("KPEkgtEkQ",9) == 3096698694) strcat(s, "n");
if (crc32("lECTzwjwUoq",11) == 2884379717) strcat(s, "h");
if (crc32("CDzDlJ",6) == 3106786857) strcat(s, "y");
if (crc32("jqrgwgSrTMhS",12) == 3694527080) strcat(s, "q");
if (crc32("IAZvap",6) == 606690048) strcat(s, "p");
if (crc32("VlVkjixzf",9) == 4235985198) strcat(s, "n");
if (crc32("yiaCXntkQtw",11) == 1652008277) strcat(s, "q");
if (crc32("PJyNEHG",7) == 960162918) strcat(s, "o");
if (crc32("pGFRYAmE",8) == 4202707800) strcat(s, "M");
if (crc32("VTSoFCE",7) == 4285875191) strcat(s, "t");
if (crc32("EcOjwOdadIdqq",13) == 1412995356) strcat(s, "c");
if (crc32("eTbnzBg",7) == 2735302202) strcat(s, "i");
if (crc32("UsBVQraT",8) == 1686332035) strcat(s, "c");
if (crc32("qNVGAkCRwunT",12) == 3670965891) strcat(s, "a");
if (crc32("rhjqu",5) == 4271394527) strcat(s, "W");
if (crc32("ETOBTZ",6) == 3334758920) strcat(s, "l");
if (crc32("gfMprNN",7) == 1852296980) strcat(s, "l");
if (crc32("RTtqKqTYklQclT",14) == 1106860510) strcat(s, "j");
if (crc32("iMxvIxyoJ",9) == 1921628815) strcat(s, "y");
    return s;
}

char *afloat_adverbs() {
    char *s = calloc(7);
    if (crc32("vWXoSjk",7) == 1139919467) strcat(s, "a");
if (crc32("PZSjjP",6) == 1823879250) strcat(s, "A");
if (crc32("rDQQulpDmyA",11) == 903262123) strcat(s, "f");
if (crc32("kLEUttjsKckSaZa",15) == 1379510492) strcat(s, "K");
if (crc32("VoTdiOOp",8) == 1781846730) strcat(s, "l");
if (crc32("LXytWLQX",8) == 3883831603) strcat(s, "B");
if (crc32("pCmUeYUuvl",10) == 913126445) strcat(s, "o");
if (crc32("nGkCrfCABBmb",12) == 829968012) strcat(s, "E");
if (crc32("DYhvw",5) == 747956683) strcat(s, "a");
if (crc32("pXTbFsyaoKvg",12) == 1131365283) strcat(s, "R");
if (crc32("ZlSAmZiBLZ",10) == 3937735813) strcat(s, "t");
    return s;
}

char *rippingly_adverbs() {
    char *s = calloc(10);
    if (crc32("FsgNjeDtzpxhCi",14) == 2262111072) strcat(s, "r");
if (crc32("UDLISP",6) == 136738525) strcat(s, "b");
if (crc32("duuhNaACUM",10) == 3532552844) strcat(s, "i");
if (crc32("MeionFhOqTJXDAN",15) == 2775724435) strcat(s, "R");
if (crc32("VoychJEkMrXejt",14) == 2389644995) strcat(s, "p");
if (crc32("jFYylvhM",8) == 1481930755) strcat(s, "p");
if (crc32("Eflfvg",6) == 2466063618) strcat(s, "c");
if (crc32("YIiivQa",7) == 403942450) strcat(s, "i");
if (crc32("BcRkqAKgPQ",10) == 2464658076) strcat(s, "x");
if (crc32("RaieZN",6) == 2379497129) strcat(s, "n");
if (crc32("lkuaIuiqpM",10) == 4183042037) strcat(s, "N");
if (crc32("VknUCvDGFoMpa",13) == 1413686886) strcat(s, "g");
if (crc32("jBcWiwy",7) == 1993575218) strcat(s, "l");
if (crc32("VqTYxgRa",8) == 1329799714) strcat(s, "y");
    return s;
}

char *gutsily_adverbs() {
    char *s = calloc(8);
    if (crc32("LXHPuV",6) == 673955019) strcat(s, "w");
if (crc32("FOJkCoO",7) == 3423014814) strcat(s, "g");
if (crc32("IaGCgi",6) == 1460327291) strcat(s, "u");
if (crc32("KmTakPY",7) == 3396263365) strcat(s, "w");
if (crc32("HuBlfA",6) == 559372744) strcat(s, "t");
if (crc32("uEmtXVvxgnlns",13) == 3587423036) strcat(s, "s");
if (crc32("qzjALaPnP",9) == 1033993036) strcat(s, "Q");
if (crc32("qAtOIBj",7) == 3425812674) strcat(s, "i");
if (crc32("fejCRQDsofmyD",13) == 3839084973) strcat(s, "l");
if (crc32("ADnvwCMp",8) == 1442207706) strcat(s, "W");
if (crc32("cAcoXiqfGgBX",12) == 680573714) strcat(s, "y");
    return s;
}

char *facetely_adverbs() {
    char *s = calloc(9);
    if (crc32("toVYC",5) == 3795429062) strcat(s, "s");
if (crc32("Uebfw",5) == 2361165671) strcat(s, "f");
if (crc32("YWZGnSGYnG",10) == 2777591944) strcat(s, "M");
if (crc32("nultPrWbh",9) == 3469330316) strcat(s, "a");
if (crc32("PeUZSQDFCRnNXir",15) == 1227645024) strcat(s, "c");
if (crc32("LSLahddmRwHxy",13) == 4258601303) strcat(s, "e");
if (crc32("OjdFzJHQ",8) == 2748059815) strcat(s, "t");
if (crc32("UIlUKhCgOLaeO",13) == 816724553) strcat(s, "e");
if (crc32("OphGbgdHOlOKcLe",15) == 1097632890) strcat(s, "q");
if (crc32("DFyQDfTfmHFvs",13) == 420886737) strcat(s, "l");
if (crc32("gzOMosTVzRpcXgI",15) == 3440993694) strcat(s, "O");
if (crc32("EVTkAKyWI",9) == 3702543655) strcat(s, "y");
    return s;
}

char *duodecimally_adverbs() {
    char *s = calloc(13);
    if (crc32("OiPgQxoehTgXxfH",15) == 1656465058) strcat(s, "d");
if (crc32("bXcvuqIRCBX",11) == 1506240254) strcat(s, "u");
if (crc32("BvYnjZfOZVavES",14) == 4223658476) strcat(s, "o");
if (crc32("VnmznE",6) == 134487201) strcat(s, "o");
if (crc32("QUAhkfeAt",9) == 2558813162) strcat(s, "d");
if (crc32("AnkBd",5) == 1798779060) strcat(s, "T");
if (crc32("xjVnbKHrEKDda",13) == 3575544991) strcat(s, "e");
if (crc32("WZRMmbj",7) == 760628608) strcat(s, "B");
if (crc32("GyPYzsxwQivyALI",15) == 1849555427) strcat(s, "c");
if (crc32("ydSuhTZND",9) == 553808619) strcat(s, "B");
if (crc32("nxExdFWwmAAhq",13) == 1023028595) strcat(s, "i");
if (crc32("jellts",6) == 4213019433) strcat(s, "m");
if (crc32("JANNLmZpSJ",10) == 1698590404) strcat(s, "a");
if (crc32("YHjWtdqODDTV",12) == 729831046) strcat(s, "J");
if (crc32("olwwqgJxx",9) == 2064201936) strcat(s, "l");
if (crc32("QiSukli",7) == 2915262412) strcat(s, "l");
if (crc32("VmuFWxWGSyWkpDw",15) == 3246260358) strcat(s, "b");
if (crc32("kAbxQY",6) == 3434654950) strcat(s, "y");
    return s;
}

char *unextravagantly_adverbs() {
    char *s = calloc(16);
    if (crc32("fPpgWQlltKdkAv",14) == 880612778) strcat(s, "M");
if (crc32("xAQsHMW",7) == 877090965) strcat(s, "u");
if (crc32("eEWqbM",6) == 631761159) strcat(s, "n");
if (crc32("oCSseoD",7) == 1242836277) strcat(s, "p");
if (crc32("kWnzHLvbAXOPG",13) == 3732344896) strcat(s, "e");
if (crc32("buXGfzmXj",9) == 2418449133) strcat(s, "g");
if (crc32("uVRsSbTXqHiBMA",14) == 2579045922) strcat(s, "x");
if (crc32("YLwhwnUD",8) == 291077099) strcat(s, "t");
if (crc32("KbberGUWMY",10) == 3531394729) strcat(s, "r");
if (crc32("zDJXQZpvaOdCDn",14) == 4281359423) strcat(s, "a");
if (crc32("DXeOloM",7) == 4103458009) strcat(s, "v");
if (crc32("yduZRjYCsoS",11) == 2936094688) strcat(s, "a");
if (crc32("jhAHrbYznvmmGg",14) == 1064672429) strcat(s, "g");
if (crc32("GFLYfmAKoXduthY",15) == 3653920392) strcat(s, "a");
if (crc32("SyDwCucOqvzSOTX",15) == 3597592823) strcat(s, "n");
if (crc32("WCImrllbbmC",11) == 2139593104) strcat(s, "V");
if (crc32("NQKYHvtuJYVBFTx",15) == 3594538288) strcat(s, "t");
if (crc32("PmCFDATtqV",10) == 630902796) strcat(s, "l");
if (crc32("pkAYbrLRjZ",10) == 4192301888) strcat(s, "F");
if (crc32("DoGHYxOAItbAgkI",15) == 4229343814) strcat(s, "y");
    return s;
}

char *segmentally_adverbs() {
    char *s = calloc(12);
    if (crc32("fMqqBL",6) == 2853923014) strcat(s, "e");
if (crc32("VvQLhMh",7) == 2497293931) strcat(s, "s");
if (crc32("SAxMqHEKACE",11) == 3689465107) strcat(s, "e");
if (crc32("ukbMpU",6) == 3650913819) strcat(s, "g");
if (crc32("msvmdJzWGFfJeh",14) == 3002103909) strcat(s, "N");
if (crc32("rhOgmHAq",8) == 2679608490) strcat(s, "m");
if (crc32("ifpTWCTjxVIzSi",14) == 2417153144) strcat(s, "X");
if (crc32("YnmytU",6) == 2122273848) strcat(s, "e");
if (crc32("uDFsAt",6) == 4289235446) strcat(s, "R");
if (crc32("urrCod",6) == 1919879129) strcat(s, "n");
if (crc32("EOCeFv",6) == 3960223606) strcat(s, "t");
if (crc32("zsRMFUhUZSqez",13) == 2512095673) strcat(s, "a");
if (crc32("JnhtSDEik",9) == 871710607) strcat(s, "l");
if (crc32("SeOSqpEYdb",10) == 301703153) strcat(s, "l");
if (crc32("NYDIEApmHYX",11) == 51193716) strcat(s, "V");
if (crc32("zJLadvA",7) == 1380880565) strcat(s, "y");
    return s;
}

char *justifiably_adverbs() {
    char *s = calloc(12);
    if (crc32("tQoepjXNzLMx",12) == 394808318) strcat(s, "b");
if (crc32("HUFyUwrDO",9) == 3060524793) strcat(s, "j");
if (crc32("rjEUSwyvlE",10) == 3976445171) strcat(s, "R");
if (crc32("ErReiFUv",8) == 598718400) strcat(s, "u");
if (crc32("GrkMqxj",7) == 2371705970) strcat(s, "J");
if (crc32("WeXqxSzitDCp",12) == 337797893) strcat(s, "s");
if (crc32("qsiHkYWX",8) == 3728116944) strcat(s, "D");
if (crc32("jmLJLZGuSMA",11) == 3479498346) strcat(s, "t");
if (crc32("NxFKyFkfP",9) == 2320440271) strcat(s, "z");
if (crc32("zZJylWBWVLsUCT",14) == 911514849) strcat(s, "i");
if (crc32("isDfOx",6) == 1364768530) strcat(s, "f");
if (crc32("surGh",5) == 3222378401) strcat(s, "E");
if (crc32("VFEhXNcYnETMw",13) == 316883833) strcat(s, "i");
if (crc32("aJDRYQwsMA",10) == 1160710926) strcat(s, "a");
if (crc32("IxRbAT",6) == 4278477511) strcat(s, "b");
if (crc32("BbDwBh",6) == 3561905083) strcat(s, "l");
if (crc32("elRyOBUxWQw",11) == 19847339) strcat(s, "L");
if (crc32("LtHtKvxnpA",10) == 4181178760) strcat(s, "y");
    return s;
}

char *chopchop_adverbs() {
    char *s = calloc(9);
    if (crc32("GswdKVPa",8) == 3528848284) strcat(s, "P");
if (crc32("rTcRUimgemiXjrn",15) == 1928502200) strcat(s, "c");
if (crc32("ZLKPItBIJkqtyCn",15) == 3758066370) strcat(s, "D");
if (crc32("yzIVsmlfhzMJ",12) == 1754021597) strcat(s, "h");
if (crc32("rYQvqCWRz",9) == 911325858) strcat(s, "o");
if (crc32("deZhPIzgK",9) == 1347682709) strcat(s, "p");
if (crc32("tPXqNP",6) == 1199126506) strcat(s, "c");
if (crc32("RUhaWu",6) == 3391357622) strcat(s, "a");
if (crc32("TKYsziNqdOxBqI",14) == 3114175554) strcat(s, "h");
if (crc32("LEXjUiZLvrasb",13) == 3581555587) strcat(s, "o");
if (crc32("NFUIvfmiag",10) == 1471035495) strcat(s, "Z");
if (crc32("ePfmHTwj",8) == 2583647859) strcat(s, "p");
    return s;
}

char *warily_adverbs() {
    char *s = calloc(7);
    if (crc32("hjABfEMpL",9) == 1926897399) strcat(s, "w");
if (crc32("fFWqGJem",8) == 3506646451) strcat(s, "a");
if (crc32("hFTlKnKVD",9) == 3076364873) strcat(s, "i");
if (crc32("ccges",5) == 2906505388) strcat(s, "r");
if (crc32("CjuyDkb",7) == 885230347) strcat(s, "i");
if (crc32("youxpLBpXVB",11) == 1659416382) strcat(s, "d");
if (crc32("IiLIXItMWln",11) == 3002399411) strcat(s, "l");
if (crc32("ghvzKIqFsAHogj",14) == 2587780167) strcat(s, "y");
    return s;
}

char *illegally_adverbs() {
    char *s = calloc(10);
    if (crc32("vrqbyfXfURrK",12) == 3217568764) strcat(s, "i");
if (crc32("kGzRUHGSej",10) == 280027644) strcat(s, "l");
if (crc32("cGMJcvHajEuNTAd",15) == 970542712) strcat(s, "l");
if (crc32("orEuuSURRQ",10) == 3779632462) strcat(s, "e");
if (crc32("xQnwiGeMbzS",11) == 331016400) strcat(s, "g");
if (crc32("fEfrhQSUVnjrbc",14) == 355544806) strcat(s, "a");
if (crc32("xRrtnzUn",8) == 188534767) strcat(s, "l");
if (crc32("xkseXWHmV",9) == 3609269139) strcat(s, "l");
if (crc32("xGloz",5) == 1791754083) strcat(s, "P");
if (crc32("HNvBFvP",7) == 4266423379) strcat(s, "y");
    return s;
}

char *nonprogressively_adverbs() {
    char *s = calloc(17);
    if (crc32("hIgjwlMLZwZFTc",14) == 424394120) strcat(s, "n");
if (crc32("tGlnpGQ",7) == 3884505886) strcat(s, "o");
if (crc32("duAkkIqNTuDssJ",14) == 2699252933) strcat(s, "p");
if (crc32("dlqdZY",6) == 2967178792) strcat(s, "n");
if (crc32("GAJxhSjU",8) == 4108609059) strcat(s, "K");
if (crc32("VqKoabhl",8) == 3814762352) strcat(s, "p");
if (crc32("OUUDxbl",7) == 3737440709) strcat(s, "r");
if (crc32("rNWdrj",6) == 3238849563) strcat(s, "O");
if (crc32("mGunVewPpBXNHt",14) == 2180245505) strcat(s, "o");
if (crc32("LzeXnuOf",8) == 1503731809) strcat(s, "g");
if (crc32("NlmQiAwHTo",10) == 3587637130) strcat(s, "J");
if (crc32("QywTTvJ",7) == 3215406540) strcat(s, "r");
if (crc32("qzWADxQuCMFS",12) == 3449826558) strcat(s, "r");
if (crc32("JkFoWqrWopAFgvG",15) == 1185000441) strcat(s, "e");
if (crc32("APYdbVzO",8) == 777968872) strcat(s, "s");
if (crc32("euuMHMjXnDjce",13) == 1485152667) strcat(s, "s");
if (crc32("llOhJKrtQgwdJcd",15) == 197661129) strcat(s, "X");
if (crc32("zRQFSAoDIPO",11) == 3129917886) strcat(s, "i");
if (crc32("VfouptdbU",9) == 3377413558) strcat(s, "v");
if (crc32("WJWInhjuuTHJQL",14) == 4097868449) strcat(s, "O");
if (crc32("gmksvGWr",8) == 4183589358) strcat(s, "e");
if (crc32("YDfTckxVMzQcakC",15) == 1560936267) strcat(s, "l");
if (crc32("AwWyeqiVbHtcz",13) == 152415183) strcat(s, "e");
if (crc32("LwjXAAddtfr",11) == 3423882508) strcat(s, "y");
    return s;
}

char *becomingly_adverbs() {
    char *s = calloc(11);
    if (crc32("TIoVrRM",7) == 1076905817) strcat(s, "b");
if (crc32("qIVOCdWYtXLtwI",14) == 550451618) strcat(s, "E");
if (crc32("BlJpprI",7) == 239738475) strcat(s, "e");
if (crc32("thZlGSF",7) == 423839959) strcat(s, "c");
if (crc32("eVTmH",5) == 3128362362) strcat(s, "o");
if (crc32("FpWNZJrbTeLjZf",14) == 3220506187) strcat(s, "m");
if (crc32("MbItAgNGGEJ",11) == 1700680063) strcat(s, "q");
if (crc32("nePZWg",6) == 1592044568) strcat(s, "i");
if (crc32("kyjxN",5) == 221614024) strcat(s, "n");
if (crc32("xxeabPyPL",9) == 2129619012) strcat(s, "g");
if (crc32("SxslRUixTwB",11) == 2910281789) strcat(s, "L");
if (crc32("tCwCyEM",7) == 278351162) strcat(s, "l");
if (crc32("tulDpu",6) == 426774569) strcat(s, "y");
    return s;
}

char *figuratively_adverbs() {
    char *s = calloc(13);
    if (crc32("hzWKlEXNGn",10) == 4128952089) strcat(s, "U");
if (crc32("ZtVeQbzldH",10) == 2999820271) strcat(s, "f");
if (crc32("ASebnccgbwcWQV",14) == 3568776717) strcat(s, "i");
if (crc32("rCpXRFwzJmZ",11) == 3180113847) strcat(s, "d");
if (crc32("WjGZxZyEcKEvB",13) == 1144261261) strcat(s, "g");
if (crc32("GAkNoqmsRSNjRx",14) == 3479034439) strcat(s, "u");
if (crc32("pOrNr",5) == 838092709) strcat(s, "e");
if (crc32("JbSFwZuK",8) == 3095047640) strcat(s, "r");
if (crc32("RsuEw",5) == 3962474912) strcat(s, "a");
if (crc32("LEjCPMRgF",9) == 2458840941) strcat(s, "t");
if (crc32("oCGEcKxHJDRa",12) == 541260235) strcat(s, "i");
if (crc32("LrexQvAOjls",11) == 3943827533) strcat(s, "B");
if (crc32("CurFLAEnvWKVEIa",15) == 2835876274) strcat(s, "v");
if (crc32("ltnaLJe",7) == 2862590350) strcat(s, "e");
if (crc32("xssjQcWQ",8) == 1619605576) strcat(s, "q");
if (crc32("haZKyftjEX",10) == 2612310727) strcat(s, "l");
if (crc32("vKgThKLCwGGuT",13) == 33887780) strcat(s, "y");
    return s;
}

char *halfheartedly_adverbs() {
    char *s = calloc(14);
    if (crc32("mTVuj",5) == 1961987043) strcat(s, "h");
if (crc32("ArVOmTw",7) == 731208772) strcat(s, "b");
if (crc32("nDorSEn",7) == 1099321281) strcat(s, "a");
if (crc32("kpIBTCuqgbXw",12) == 613384083) strcat(s, "l");
if (crc32("lspXDtB",7) == 4234482904) strcat(s, "e");
if (crc32("SttJC",5) == 3950445284) strcat(s, "f");
if (crc32("YjkdgQwJWhzn",12) == 780134617) strcat(s, "V");
if (crc32("TomgkgKzckJGjT",14) == 915247159) strcat(s, "h");
if (crc32("AjpqXFAHD",9) == 378785827) strcat(s, "Z");
if (crc32("msKemtOMCmM",11) == 1251496345) strcat(s, "e");
if (crc32("ISNtJTctnr",10) == 2104545464) strcat(s, "Q");
if (crc32("noMZSwAyYDqbpvj",15) == 4142903970) strcat(s, "a");
if (crc32("UjoRKYlGzfhrQw",14) == 3628830838) strcat(s, "N");
if (crc32("dYYryDFFHPFdeVE",15) == 1009842001) strcat(s, "r");
if (crc32("ceqGCOwTN",9) == 917293631) strcat(s, "q");
if (crc32("nwsyJNO",7) == 219387434) strcat(s, "t");
if (crc32("csziHzRn",8) == 4246497217) strcat(s, "e");
if (crc32("QhDKlKdhts",10) == 2583071721) strcat(s, "d");
if (crc32("JxEgRBk",7) == 3683847663) strcat(s, "l");
if (crc32("fKUFj",5) == 4252378706) strcat(s, "y");
    return s;
}

char *serologically_adverbs() {
    char *s = calloc(14);
    if (crc32("EFfcFZI",7) == 1318288712) strcat(s, "G");
if (crc32("lBlXTCfmcHCCq",13) == 1836084638) strcat(s, "s");
if (crc32("hBXIXnhO",8) == 1549169581) strcat(s, "A");
if (crc32("NxQcpBzQ",8) == 1315917337) strcat(s, "e");
if (crc32("PGYRTEcacjr",11) == 404905539) strcat(s, "r");
if (crc32("BeoFGlMqXAIfQHe",15) == 3577364743) strcat(s, "f");
if (crc32("RubBIxoCZzDk",12) == 3180456844) strcat(s, "o");
if (crc32("KGeVzEuDFJAiS",13) == 2884551913) strcat(s, "G");
if (crc32("qzxeoLYDfECmfd",14) == 968497137) strcat(s, "l");
if (crc32("DgbIHQqzVPlFC",13) == 748184560) strcat(s, "o");
if (crc32("NQWduIx",7) == 2520180307) strcat(s, "A");
if (crc32("pSdqOzRgFi",10) == 3005189799) strcat(s, "g");
if (crc32("NVmRvlcPmok",11) == 2089244806) strcat(s, "i");
if (crc32("leylmZfByodR",12) == 3868429395) strcat(s, "w");
if (crc32("tktKNoToiBsAvmF",15) == 4294516930) strcat(s, "c");
if (crc32("ctdFX",5) == 1889574898) strcat(s, "a");
if (crc32("LhZRaNuC",8) == 143396934) strcat(s, "l");
if (crc32("JllCYfe",7) == 3125812030) strcat(s, "l");
if (crc32("sRqqrpJTP",9) == 806709326) strcat(s, "I");
if (crc32("CUWnVx",6) == 1850821431) strcat(s, "y");
    return s;
}

char *otherwhile_adverbs() {
    char *s = calloc(11);
    if (crc32("psrgKy",6) == 1316363556) strcat(s, "s");
if (crc32("eTvcZqXXa",9) == 2870041749) strcat(s, "o");
if (crc32("veavMTvjT",9) == 1248178060) strcat(s, "t");
if (crc32("AjvJjpSdPJ",10) == 999442283) strcat(s, "h");
if (crc32("FTXyLcL",7) == 2076639163) strcat(s, "e");
if (crc32("uiOHJfYFBTfnDTY",15) == 312889559) strcat(s, "J");
if (crc32("aQDWtsXRk",9) == 3502811719) strcat(s, "r");
if (crc32("SWzsOqvStOhQioq",15) == 1662924293) strcat(s, "w");
if (crc32("MtGUEORfuaEqN",13) == 523328190) strcat(s, "h");
if (crc32("eYiIVgy",7) == 1980334450) strcat(s, "i");
if (crc32("SUxyPWz",7) == 621906953) strcat(s, "l");
if (crc32("tsrUs",5) == 3625807568) strcat(s, "l");
if (crc32("YqwtdAiUJrYX",12) == 2561790688) strcat(s, "e");
    return s;
}

char *unexceptionally_adverbs() {
    char *s = calloc(16);
    if (crc32("nHdciBBd",8) == 670072782) strcat(s, "u");
if (crc32("TvJZUjntgJvp",12) == 1563514583) strcat(s, "N");
if (crc32("SKiWTnV",7) == 989184088) strcat(s, "n");
if (crc32("vZqVnC",6) == 2080299085) strcat(s, "J");
if (crc32("EjHQnSar",8) == 3121558558) strcat(s, "e");
if (crc32("VJQxg",5) == 831364009) strcat(s, "A");
if (crc32("wkTmas",6) == 4170014816) strcat(s, "x");
if (crc32("onxzZswYjBQPS",13) == 449465937) strcat(s, "M");
if (crc32("BUgxdSubJboXmGU",15) == 2310986023) strcat(s, "c");
if (crc32("LVqgKMrzTCRB",12) == 2104558354) strcat(s, "e");
if (crc32("JGnJVQthrUcCv",13) == 1950451205) strcat(s, "p");
if (crc32("NLELi",5) == 4006633582) strcat(s, "t");
if (crc32("RHTvbVLMt",9) == 367869595) strcat(s, "a");
if (crc32("eSLqAiwSRq",10) == 3423431817) strcat(s, "i");
if (crc32("rcAVKKZZyU",10) == 3140562655) strcat(s, "o");
if (crc32("QKfipBJJnIvNUro",15) == 916827250) strcat(s, "n");
if (crc32("CKcdmPzbdOazB",13) == 17088794) strcat(s, "a");
if (crc32("txtRUIiKRvi",11) == 972430188) strcat(s, "D");
if (crc32("agYhtZAFhvDgt",13) == 4271710981) strcat(s, "l");
if (crc32("rPjIeIFhBJWz",12) == 1703042138) strcat(s, "U");
if (crc32("iOmepc",6) == 944660392) strcat(s, "l");
if (crc32("IGTnNlFgIu",10) == 3345672223) strcat(s, "q");
if (crc32("AGrLC",5) == 1092504189) strcat(s, "y");
    return s;
}

char *unjuicily_adverbs() {
    char *s = calloc(10);
    if (crc32("YWivgE",6) == 707268435) strcat(s, "u");
if (crc32("QPIejbfFJ",9) == 1343990108) strcat(s, "j");
if (crc32("IEJjzLJI",8) == 1075212400) strcat(s, "n");
if (crc32("zLwQoJVJAD",10) == 4180257148) strcat(s, "j");
if (crc32("BZseROAN",8) == 2008762175) strcat(s, "c");
if (crc32("qHEUtuZohJmhjA",14) == 4216791676) strcat(s, "u");
if (crc32("yzvLAOpnUxnj",12) == 3712352307) strcat(s, "K");
if (crc32("ubawJPl",7) == 3070767178) strcat(s, "i");
if (crc32("yjtIQmyq",8) == 3605692471) strcat(s, "c");
if (crc32("REnaneiDd",9) == 1892109154) strcat(s, "i");
if (crc32("xVdcBZzJojEUERp",15) == 3137569614) strcat(s, "l");
if (crc32("eMYNragwyDAM",12) == 2149423504) strcat(s, "r");
if (crc32("pXcJnSGA",8) == 1317760040) strcat(s, "y");
    return s;
}

char *crookedly_adverbs() {
    char *s = calloc(10);
    if (crc32("QhTARpcLEhGaoN",14) == 1299819913) strcat(s, "c");
if (crc32("IlZEMxbnTHGY",12) == 799687978) strcat(s, "r");
if (crc32("edYmuDizIw",10) == 1942852869) strcat(s, "o");
if (crc32("MWdHYMIXhdv",11) == 1880344487) strcat(s, "X");
if (crc32("BuqMj",5) == 91428851) strcat(s, "o");
if (crc32("IbvziaqHucZm",12) == 1875010722) strcat(s, "k");
if (crc32("DAbLqZP",7) == 2769318456) strcat(s, "e");
if (crc32("EatIpZuRqUJyt",13) == 400521870) strcat(s, "d");
if (crc32("guxpnvbMAZLpfvR",15) == 2490013030) strcat(s, "l");
if (crc32("HufWS",5) == 2370088365) strcat(s, "x");
if (crc32("iPesfwH",7) == 4088903921) strcat(s, "y");
    return s;
}

char *dorsoventrally_adverbs() {
    char *s = calloc(15);
    if (crc32("HUSlOTKXzcCEBhg",15) == 3178886613) strcat(s, "w");
if (crc32("YmpUFgwifB",10) == 1049768636) strcat(s, "d");
if (crc32("XRDGKBuZ",8) == 3477909612) strcat(s, "o");
if (crc32("kmzCgdzNpcKA",12) == 528973481) strcat(s, "H");
if (crc32("AwKuAQiY",8) == 355017934) strcat(s, "r");
if (crc32("KOwGgPyU",8) == 530415937) strcat(s, "K");
if (crc32("wvAjglYFJRFdvUT",15) == 1075240847) strcat(s, "s");
if (crc32("VVZsmeOpNXd",11) == 3411542784) strcat(s, "o");
if (crc32("txUOPxDdomaw",12) == 2776218538) strcat(s, "v");
if (crc32("SCqErRnTav",10) == 1816841071) strcat(s, "O");
if (crc32("cZUlUtywv",9) == 3746320487) strcat(s, "e");
if (crc32("GbybQroGUlcTHIy",15) == 3955557607) strcat(s, "a");
if (crc32("gcpFrLCM",8) == 2991373763) strcat(s, "n");
if (crc32("RYhCXig",7) == 166940134) strcat(s, "E");
if (crc32("owRiAlBGOMF",11) == 925522626) strcat(s, "t");
if (crc32("txYxVmlBJPCiZb",14) == 2319497684) strcat(s, "M");
if (crc32("OUxjlBNySlnhPS",14) == 1063955179) strcat(s, "r");
if (crc32("UOeWMwK",7) == 3971286859) strcat(s, "a");
if (crc32("xzhPZvpmvZvx",12) == 3697736090) strcat(s, "l");
if (crc32("obvFeRcQH",9) == 1480914742) strcat(s, "q");
if (crc32("nUeCTxwJwMCBu",13) == 1858093515) strcat(s, "l");
if (crc32("TIUJKxtODFdZJ",13) == 3946673557) strcat(s, "S");
if (crc32("FRzUwlXtyr",10) == 933605234) strcat(s, "y");
    return s;
}

char *unclerically_adverbs() {
    char *s = calloc(13);
    if (crc32("HnYWXv",6) == 1614388166) strcat(s, "u");
if (crc32("tqxFqbxWL",9) == 685635773) strcat(s, "i");
if (crc32("QSTCZ",5) == 565613418) strcat(s, "n");
if (crc32("oDGecixIE",9) == 4106391165) strcat(s, "c");
if (crc32("srTSShzeqHQMcv",14) == 1174559736) strcat(s, "l");
if (crc32("TPsFAiXFUGkv",12) == 4143894696) strcat(s, "e");
if (crc32("vLvAM",5) == 3489747580) strcat(s, "r");
if (crc32("MArtFZStOXHV",12) == 1749235272) strcat(s, "i");
if (crc32("vNYZC",5) == 127368631) strcat(s, "c");
if (crc32("HfLuntGpODCIl",13) == 3968821541) strcat(s, "F");
if (crc32("TzSDPNDmsmkaz",13) == 3419857292) strcat(s, "a");
if (crc32("KamGguqyBaA",11) == 347937498) strcat(s, "q");
if (crc32("qxQVsksOHtZ",11) == 990341628) strcat(s, "l");
if (crc32("NaVMOcbQ",8) == 1281577006) strcat(s, "t");
if (crc32("DIrUqGqDxuWQfP",14) == 3032726069) strcat(s, "l");
if (crc32("kkpwE",5) == 4141806397) strcat(s, "y");
    return s;
}

char *bathymetrically_adverbs() {
    char *s = calloc(16);
    if (crc32("JhnhQSKzYAum",12) == 2556021958) strcat(s, "b");
if (crc32("hLTeUintEcgZUbo",15) == 2668190920) strcat(s, "n");
if (crc32("sfnSIz",6) == 242098326) strcat(s, "a");
if (crc32("PiqpvdTFEx",10) == 1957530748) strcat(s, "t");
if (crc32("UGsXqIzdLlxV",12) == 1980348058) strcat(s, "h");
if (crc32("DlpxjL",6) == 3334102811) strcat(s, "T");
if (crc32("mPatpZLSIOVGJah",15) == 3579146215) strcat(s, "y");
if (crc32("wWDqJN",6) == 4150364436) strcat(s, "m");
if (crc32("beqrfOzprlFtFKh",15) == 4183825742) strcat(s, "a");
if (crc32("kbDkzDeLWZ",10) == 2424846873) strcat(s, "e");
if (crc32("QYpZMk",6) == 3601880361) strcat(s, "t");
if (crc32("FuNbsIwQiZKJfF",14) == 3653090083) strcat(s, "X");
if (crc32("DSChUT",6) == 1041698165) strcat(s, "r");
if (crc32("ZobdO",5) == 353941502) strcat(s, "y");
if (crc32("xvWhDslups",10) == 2371192333) strcat(s, "i");
if (crc32("LbWTyveut",9) == 3433468416) strcat(s, "c");
if (crc32("JTYceo",6) == 1973588929) strcat(s, "d");
if (crc32("wTWZNqGCvXQeLzE",15) == 2596321306) strcat(s, "a");
if (crc32("jQGPJTSXbQ",10) == 4008935700) strcat(s, "E");
if (crc32("HEmrRlqQ",8) == 3029348220) strcat(s, "l");
if (crc32("KZKSyflpXWVxmNA",15) == 1603794062) strcat(s, "l");
if (crc32("dPJlH",5) == 2917125165) strcat(s, "y");
    return s;
}

char *viscously_adverbs() {
    char *s = calloc(10);
    if (crc32("uiQhhKrPTDA",11) == 439168203) strcat(s, "A");
if (crc32("fxhMDOBeeAzsgB",14) == 2406233420) strcat(s, "v");
if (crc32("watQxPp",7) == 3508660081) strcat(s, "b");
if (crc32("RcapHZ",6) == 1248034835) strcat(s, "i");
if (crc32("auCcViLikGN",11) == 449633635) strcat(s, "w");
if (crc32("prUMYtArBynaUoB",15) == 4056613289) strcat(s, "s");
if (crc32("KGawwlRgM",9) == 3583735391) strcat(s, "c");
if (crc32("uzBIjVxEZqZ",11) == 2414282800) strcat(s, "o");
if (crc32("LnznDzqo",8) == 3576817944) strcat(s, "E");
if (crc32("ZWnSRxAaaGekM",13) == 1156570423) strcat(s, "u");
if (crc32("kwhNEl",6) == 3014137376) strcat(s, "T");
if (crc32("FbnAkXYz",8) == 2494900009) strcat(s, "s");
if (crc32("rSlSUscKdCWgC",13) == 445051833) strcat(s, "l");
if (crc32("NZpIqQGzGcUg",12) == 399033438) strcat(s, "a");
if (crc32("CGMsYwYaJ",9) == 3226294662) strcat(s, "y");
    return s;
}

char *superocularly_adverbs() {
    char *s = calloc(14);
    if (crc32("fmClbUl",7) == 1804767470) strcat(s, "T");
if (crc32("qSAeR",5) == 933222115) strcat(s, "s");
if (crc32("zaNzMcgu",8) == 3529056057) strcat(s, "P");
if (crc32("yzVNgP",6) == 4214774244) strcat(s, "u");
if (crc32("jtNgzYyN",8) == 2884744573) strcat(s, "f");
if (crc32("mqqXUbmjCpqLDj",14) == 1518582198) strcat(s, "p");
if (crc32("mqEzPlgKoRo",11) == 811395034) strcat(s, "H");
if (crc32("uSrAefacb",9) == 3548493631) strcat(s, "e");
if (crc32("ykDWUHfb",8) == 977816564) strcat(s, "o");
if (crc32("whjXtRVbM",9) == 3827269537) strcat(s, "r");
if (crc32("HRuPOkInQ",9) == 2286131439) strcat(s, "o");
if (crc32("zoBTXUVs",8) == 3949772051) strcat(s, "c");
if (crc32("WQsqLCwDDUlLyXc",15) == 3564381607) strcat(s, "y");
if (crc32("SYSxE",5) == 2151601190) strcat(s, "u");
if (crc32("XZKNESJKg",9) == 1162715421) strcat(s, "M");
if (crc32("HdScqcnFVeTsQG",14) == 2748849165) strcat(s, "l");
if (crc32("BUrnhVCGVPH",11) == 1882810517) strcat(s, "a");
if (crc32("ACdrFHVKDXeLnJw",15) == 254332214) strcat(s, "r");
if (crc32("OPIGlfDpsd",10) == 773423774) strcat(s, "l");
if (crc32("kYgQyrcgCC",10) == 3024440703) strcat(s, "y");
    return s;
}

char *unacceptably_adverbs() {
    char *s = calloc(13);
    if (crc32("xYgomdyelHwrH",13) == 4045419016) strcat(s, "N");
if (crc32("PBDHYagKUhE",11) == 595037207) strcat(s, "u");
if (crc32("rzkuFkibBYNKJoy",15) == 2214894738) strcat(s, "n");
if (crc32("KixrIOZZYbVS",12) == 2458179140) strcat(s, "a");
if (crc32("KchkQtlEc",9) == 3348544353) strcat(s, "c");
if (crc32("jeCclPekCz",10) == 1244400812) strcat(s, "c");
if (crc32("qEzGUcjQNXJVjlS",15) == 2086672302) strcat(s, "e");
if (crc32("vpXiGfOnzKk",11) == 1099613179) strcat(s, "i");
if (crc32("hTeSloaSnG",10) == 515955797) strcat(s, "p");
if (crc32("sEldTpVayV",10) == 654811294) strcat(s, "t");
if (crc32("bpmDi",5) == 2929424418) strcat(s, "a");
if (crc32("YQwPq",5) == 1284984907) strcat(s, "b");
if (crc32("jWhqhjRdXBju",12) == 3901358052) strcat(s, "z");
if (crc32("MIvNqrvowbtKHNs",15) == 2133021436) strcat(s, "l");
if (crc32("jjYat",5) == 3743816909) strcat(s, "b");
if (crc32("XMQCqdPcHG",10) == 2008265258) strcat(s, "y");
    return s;
}

char *unexcrescently_adverbs() {
    char *s = calloc(15);
    if (crc32("lLHtHUOuBc",10) == 1726572276) strcat(s, "u");
if (crc32("phJrieh",7) == 3732978093) strcat(s, "O");
if (crc32("mMwEzRF",7) == 1839679948) strcat(s, "n");
if (crc32("QZAzX",5) == 2799260141) strcat(s, "e");
if (crc32("dFIrjLEjhAfRJi",14) == 1407716790) strcat(s, "n");
if (crc32("EkJvsdtSN",9) == 2612097575) strcat(s, "x");
if (crc32("pvLOSKouDZJhFVt",15) == 2022763744) strcat(s, "c");
if (crc32("AOryaYrFsEUs",12) == 4011533021) strcat(s, "y");
if (crc32("RSgBRsdSTu",10) == 3342618879) strcat(s, "r");
if (crc32("fXNmCQ",6) == 2616247095) strcat(s, "e");
if (crc32("KsqaRWiimGF",11) == 1867279903) strcat(s, "s");
if (crc32("kdunyOsSAOBCA",13) == 2031330982) strcat(s, "c");
if (crc32("vMYNB",5) == 1284191642) strcat(s, "e");
if (crc32("GPvhfbvAp",9) == 2855873009) strcat(s, "I");
if (crc32("bRghIZayenCrmQ",14) == 4021418108) strcat(s, "n");
if (crc32("NLlsQY",6) == 2314756315) strcat(s, "J");
if (crc32("hIfiWnAuAiJeA",13) == 1325261338) strcat(s, "t");
if (crc32("CCIaC",5) == 3367149449) strcat(s, "u");
if (crc32("gGGyVDcE",8) == 162299215) strcat(s, "l");
if (crc32("CmyMBz",6) == 1162227389) strcat(s, "y");
    return s;
}

char *ogreishly_adverbs() {
    char *s = calloc(10);
    if (crc32("MRTtdnCMwfRTszg",15) == 620828322) strcat(s, "P");
if (crc32("UonpHzC",7) == 479367295) strcat(s, "o");
if (crc32("GFOiKMOtGexI",12) == 2649519967) strcat(s, "g");
if (crc32("hFHaIDqRL",9) == 600539733) strcat(s, "P");
if (crc32("Llzww",5) == 3718835398) strcat(s, "r");
if (crc32("IfigbHIyCPkheSA",15) == 962470376) strcat(s, "e");
if (crc32("uoFAlCOa",8) == 3315770629) strcat(s, "d");
if (crc32("WOAym",5) == 868258816) strcat(s, "i");
if (crc32("ivyGp",5) == 2823415360) strcat(s, "s");
if (crc32("RpwLgVcKFhEq",12) == 3528755571) strcat(s, "F");
if (crc32("cHQHBAJxzHWhuD",14) == 3363661596) strcat(s, "h");
if (crc32("sAYhWwhxi",9) == 3126277055) strcat(s, "L");
if (crc32("THbTZxYap",9) == 727690077) strcat(s, "l");
if (crc32("nQXogMBWm",9) == 3314678067) strcat(s, "X");
if (crc32("zqneBOJjcIBXt",13) == 571162503) strcat(s, "y");
    return s;
}

char *catechetically_adverbs() {
    char *s = calloc(15);
    if (crc32("VBUlSHVaeMSzw",13) == 3348900759) strcat(s, "c");
if (crc32("qCiXPtnUcgw",11) == 3094990083) strcat(s, "t");
if (crc32("CAxybixebXBD",12) == 3897418829) strcat(s, "a");
if (crc32("AqNNVTxlXF",10) == 1221985962) strcat(s, "t");
if (crc32("hEPMZRaGK",9) == 3505426459) strcat(s, "q");
if (crc32("YCRjWPChpIk",11) == 2757836058) strcat(s, "e");
if (crc32("cJhVtNxA",8) == 2033045494) strcat(s, "O");
if (crc32("UEvveSWpgXBFp",13) == 3729770840) strcat(s, "c");
if (crc32("HrPRuKz",7) == 68346911) strcat(s, "h");
if (crc32("IVtvlIgVvcFdCTK",15) == 3114894824) strcat(s, "e");
if (crc32("eNQKThgNrz",10) == 1404242139) strcat(s, "P");
if (crc32("NdpsuClkWcQx",12) == 2623509415) strcat(s, "t");
if (crc32("rsKwGdxXSd",10) == 3539757145) strcat(s, "p");
if (crc32("uMlGHR",6) == 4088301314) strcat(s, "i");
if (crc32("qyBSAvPuctdGn",13) == 2263578618) strcat(s, "S");
if (crc32("IQIqTg",6) == 583558407) strcat(s, "c");
if (crc32("IysMoCkQK",9) == 296053755) strcat(s, "L");
if (crc32("yIApK",5) == 1804952589) strcat(s, "a");
if (crc32("FQMYzvJEHVnk",12) == 3694464967) strcat(s, "q");
if (crc32("TzhhiC",6) == 1979946652) strcat(s, "l");
if (crc32("ULcOyXzIjP",10) == 3284700108) strcat(s, "l");
if (crc32("ikjJIhNHOPbRW",13) == 1387809317) strcat(s, "F");
if (crc32("scrXzPWJjVNwEu",14) == 1258915699) strcat(s, "y");
    return s;
}

char *Machiavellianly_adverbs() {
    char *s = calloc(16);
    if (crc32("CedVSY",6) == 914945229) strcat(s, "M");
if (crc32("BuFwSWJNxSG",11) == 4122058232) strcat(s, "u");
if (crc32("MlrTAfcjXcJTTuE",15) == 3122443229) strcat(s, "a");
if (crc32("EOsNegkxkZlJk",13) == 2022535669) strcat(s, "d");
if (crc32("faHyeroDq",9) == 4001430574) strcat(s, "c");
if (crc32("RSdTnnxpozxrCQ",14) == 75403809) strcat(s, "b");
if (crc32("VfuHcEXEP",9) == 1510785741) strcat(s, "h");
if (crc32("WfSiyJG",7) == 622905841) strcat(s, "i");
if (crc32("DWPiIobcMEit",12) == 2082201590) strcat(s, "a");
if (crc32("WtQIKlZZcOb",11) == 3887997075) strcat(s, "v");
if (crc32("GaUgkEW",7) == 2820867567) strcat(s, "t");
if (crc32("ywgsGjDQL",9) == 3391759137) strcat(s, "e");
if (crc32("MKqJBpoXUQ",10) == 897636611) strcat(s, "l");
if (crc32("geTlQtO",7) == 4150900280) strcat(s, "l");
if (crc32("GlFQtiOWClNJTH",14) == 278663062) strcat(s, "K");
if (crc32("bQfGAHCJcno",11) == 3215418156) strcat(s, "i");
if (crc32("MrIguWIyAeetOw",14) == 324159033) strcat(s, "a");
if (crc32("xNBluSEySuKW",12) == 3446639472) strcat(s, "n");
if (crc32("DdXveqIlE",9) == 3463690711) strcat(s, "l");
if (crc32("RvtBkjv",7) == 2883873888) strcat(s, "y");
    return s;
}

char *memoriter_adverbs() {
    char *s = calloc(10);
    if (crc32("SfVtB",5) == 476849301) strcat(s, "m");
if (crc32("ZZweLlkk",8) == 2918358183) strcat(s, "e");
if (crc32("WJsXvDvfi",9) == 2282180466) strcat(s, "h");
if (crc32("wdmjyDBsoVJruwT",15) == 3202265354) strcat(s, "m");
if (crc32("YjdKjyoAVtbbrxW",15) == 3149804760) strcat(s, "o");
if (crc32("UKoLIHjknTBiRZn",15) == 2985261591) strcat(s, "o");
if (crc32("zGnNlPvnHqPibD",14) == 3921097453) strcat(s, "r");
if (crc32("ntyoWNhvt",9) == 1137783965) strcat(s, "i");
if (crc32("uCXtoMXIXj",10) == 2839511578) strcat(s, "n");
if (crc32("XEnxvkOXKMtv",12) == 2976456657) strcat(s, "t");
if (crc32("tjtDTeTFjxLcbIZ",15) == 2154039848) strcat(s, "E");
if (crc32("XVMlzpEz",8) == 558719907) strcat(s, "e");
if (crc32("OqHeJBIK",8) == 2138052705) strcat(s, "C");
if (crc32("HSPeezhauv",10) == 509772755) strcat(s, "r");
    return s;
}

char *compassionately_adverbs() {
    char *s = calloc(16);
    if (crc32("vDYEydEcTNXTJr",14) == 204836196) strcat(s, "a");
if (crc32("ezvyAHUK",8) == 3882565784) strcat(s, "c");
if (crc32("QdBgqZzqHE",10) == 1275124176) strcat(s, "o");
if (crc32("FRkBaowHM",9) == 1597078726) strcat(s, "A");
if (crc32("omBsgLWpN",9) == 1567069442) strcat(s, "m");
if (crc32("QqVYvsASCxOf",12) == 2233940978) strcat(s, "p");
if (crc32("ohXDtXrasWPYKhe",15) == 86997527) strcat(s, "z");
if (crc32("rdwJnLLQ",8) == 303286556) strcat(s, "a");
if (crc32("SKZFZQlYB",9) == 3162171615) strcat(s, "n");
if (crc32("JSXFsXOFALg",11) == 2365095576) strcat(s, "s");
if (crc32("uUBhPlXf",8) == 581215586) strcat(s, "k");
if (crc32("ppKSu",5) == 2583256651) strcat(s, "s");
if (crc32("WgPgfg",6) == 3988772972) strcat(s, "i");
if (crc32("wgJnjbWb",8) == 1290344035) strcat(s, "o");
if (crc32("geCXUTMW",8) == 3230885282) strcat(s, "n");
if (crc32("zFQIMvRwvwVPzT",14) == 3431173782) strcat(s, "T");
if (crc32("duEExLrMN",9) == 3509991321) strcat(s, "a");
if (crc32("GtUVPWd",7) == 3144303238) strcat(s, "E");
if (crc32("dZDSdoDMQrIUzRG",15) == 2119234514) strcat(s, "t");
if (crc32("lCsZwAhydiEfMEV",15) == 90444262) strcat(s, "a");
if (crc32("xSRVVb",6) == 1869149337) strcat(s, "e");
if (crc32("EuHOVrRqwlQb",12) == 173403772) strcat(s, "l");
if (crc32("FgjjDyItkoMrVU",14) == 1044435083) strcat(s, "y");
    return s;
}

char *perceptually_adverbs() {
    char *s = calloc(13);
    if (crc32("fZwKUNtWsbHoG",13) == 2782007196) strcat(s, "v");
if (crc32("mPTffmslkThC",12) == 3269643872) strcat(s, "p");
if (crc32("wfVwt",5) == 3434769163) strcat(s, "e");
if (crc32("CSUNPHSB",8) == 2772927147) strcat(s, "F");
if (crc32("PIekeQ",6) == 2754825756) strcat(s, "r");
if (crc32("jfgNDwlTeKVZO",13) == 671661460) strcat(s, "c");
if (crc32("QoriRtWCbB",10) == 1624675910) strcat(s, "e");
if (crc32("cRrYZqaW",8) == 2224026319) strcat(s, "p");
if (crc32("cyjkZqfHmYVjW",13) == 3350345688) strcat(s, "t");
if (crc32("APEczmHitykRcf",14) == 1488430957) strcat(s, "n");
if (crc32("PWvPstPp",8) == 4090640663) strcat(s, "u");
if (crc32("hzvSj",5) == 124721498) strcat(s, "a");
if (crc32("PbiTAbptvKstEdy",15) == 1990117683) strcat(s, "l");
if (crc32("xIbceRfoiyHiXAS",15) == 1176130085) strcat(s, "l");
if (crc32("WWWohxqJAv",10) == 1608735920) strcat(s, "l");
if (crc32("UolxGX",6) == 2495647268) strcat(s, "E");
if (crc32("XvCBVWMLs",9) == 2126813240) strcat(s, "y");
    return s;
}

char *quasidisgustedly_adverbs() {
    char *s = calloc(17);
    if (crc32("GSijrIdDJ",9) == 2619553279) strcat(s, "A");
if (crc32("YHcSDsXU",8) == 2195631921) strcat(s, "q");
if (crc32("MvNBallk",8) == 3216389377) strcat(s, "t");
if (crc32("uhbFMZonWN",10) == 632523312) strcat(s, "u");
if (crc32("SzLumobAY",9) == 1444046889) strcat(s, "q");
if (crc32("VPfpAj",6) == 1572844303) strcat(s, "a");
if (crc32("AxUODnsFlWFeDgY",15) == 1838828828) strcat(s, "s");
if (crc32("JFPCKxiseUG",11) == 876200848) strcat(s, "i");
if (crc32("wQGOZiCdEyYK",12) == 2907813469) strcat(s, "d");
if (crc32("yuxBrMVPePGsH",13) == 3809199481) strcat(s, "i");
if (crc32("FIbGwXlmkdUzRnI",15) == 65651574) strcat(s, "s");
if (crc32("wRokRVeTrRkPrXt",15) == 3267971702) strcat(s, "g");
if (crc32("SKyERy",6) == 3586778321) strcat(s, "u");
if (crc32("kfBcYxkXpXeIa",13) == 4286869900) strcat(s, "s");
if (crc32("hToRI",5) == 430920487) strcat(s, "x");
if (crc32("xEXJXrL",7) == 3782774649) strcat(s, "t");
if (crc32("fEpAd",5) == 2346086058) strcat(s, "e");
if (crc32("DNGUyvouEe",10) == 4160005965) strcat(s, "t");
if (crc32("GRHvrGBteJGP",12) == 2509616797) strcat(s, "d");
if (crc32("fRsWAHezzkSl",12) == 2067767665) strcat(s, "l");
if (crc32("eWWvd",5) == 1638381695) strcat(s, "H");
if (crc32("eQfNOLu",7) == 3924592074) strcat(s, "y");
    return s;
}

char *neatly_adverbs() {
    char *s = calloc(7);
    if (crc32("mVmnbRTdCyVOiqf",15) == 684660323) strcat(s, "S");
if (crc32("SzXasyOqqKgyM",13) == 2998058412) strcat(s, "n");
if (crc32("lyaSSPD",7) == 625808227) strcat(s, "e");
if (crc32("WQxeViiaAa",10) == 1638317395) strcat(s, "H");
if (crc32("YEScfRHu",8) == 71960609) strcat(s, "a");
if (crc32("gYFcwoicb",9) == 1978148709) strcat(s, "E");
if (crc32("xStQRMsyP",9) == 1101199141) strcat(s, "t");
if (crc32("hLdRRcMvpQihM",13) == 2706020071) strcat(s, "l");
if (crc32("tPWqNIf",7) == 790325112) strcat(s, "y");
    return s;
}

char *irately_adverbs() {
    char *s = calloc(8);
    if (crc32("VvWIn",5) == 3714560528) strcat(s, "i");
if (crc32("NFErJhDOC",9) == 1275332797) strcat(s, "r");
if (crc32("oFEEGaAPf",9) == 3467931320) strcat(s, "q");
if (crc32("dtXASKknUQvN",12) == 3714616178) strcat(s, "a");
if (crc32("WrPaMvXrWi",10) == 3000661187) strcat(s, "G");
if (crc32("McaUScdaQK",10) == 1811643832) strcat(s, "t");
if (crc32("zrisAzI",7) == 3586025760) strcat(s, "e");
if (crc32("vdqrpnWRPZ",10) == 2771003553) strcat(s, "r");
if (crc32("DikbReQJTw",10) == 455955629) strcat(s, "l");
if (crc32("XSunNRaB",8) == 2954885025) strcat(s, "w");
if (crc32("gDDTK",5) == 2970400382) strcat(s, "y");
    return s;
}

char *enplein_adverbs() {
    char *s = calloc(8);
    if (crc32("kLOgAZkkoheG",12) == 3352454253) strcat(s, "f");
if (crc32("UHwJwZlMjLT",11) == 124842861) strcat(s, "e");
if (crc32("IcNsTNcnukpFJW",14) == 1258920479) strcat(s, "w");
if (crc32("XifXJ",5) == 543032286) strcat(s, "n");
if (crc32("sjCyBASMoh",10) == 3467573090) strcat(s, "p");
if (crc32("YQUrBCxHKI",10) == 887037550) strcat(s, "l");
if (crc32("KtPRoeZZU",9) == 3718449723) strcat(s, "e");
if (crc32("pEIuuYSDfOK",11) == 357908112) strcat(s, "R");
if (crc32("YQORkMItQFoA",12) == 945994735) strcat(s, "i");
if (crc32("hJDOeJcula",10) == 2911022758) strcat(s, "E");
if (crc32("HlDICpGhMCpW",12) == 3286437053) strcat(s, "n");
    return s;
}

char *cosmopolitanly_adverbs() {
    char *s = calloc(15);
    if (crc32("cjgmgI",6) == 794959910) strcat(s, "c");
if (crc32("NLrKSaghlslAyeZ",15) == 1724513259) strcat(s, "U");
if (crc32("fAUwa",5) == 3276019724) strcat(s, "o");
if (crc32("YDnsvWWqmOSkjU",14) == 696195227) strcat(s, "g");
if (crc32("cpZlWcaNJGl",11) == 91921864) strcat(s, "s");
if (crc32("sHaMfpITWkAK",12) == 3441732803) strcat(s, "l");
if (crc32("gapQqqbMWdvKbJ",14) == 2979365794) strcat(s, "m");
if (crc32("JAyVJamiqLj",11) == 1100375107) strcat(s, "o");
if (crc32("NtOsAC",6) == 464878780) strcat(s, "p");
if (crc32("GHJpjgsVXh",10) == 2066244591) strcat(s, "e");
if (crc32("aEguKtYCwymaEY",14) == 3136210063) strcat(s, "o");
if (crc32("gApTVtDAEgUZb",13) == 2072017821) strcat(s, "l");
if (crc32("sOqCGWOTNHjfta",14) == 2757724281) strcat(s, "y");
if (crc32("GbjutIOpxL",10) == 3629659619) strcat(s, "i");
if (crc32("mAXyHwMAR",9) == 405508181) strcat(s, "t");
if (crc32("NFseAejBhoIVMiU",15) == 1360047622) strcat(s, "a");
if (crc32("nPjFreKCTc",10) == 463204627) strcat(s, "n");
if (crc32("WNkFJhh",7) == 2375098933) strcat(s, "l");
if (crc32("nmlJtrVr",8) == 3331698235) strcat(s, "y");
    return s;
}

char *supportlessly_adverbs() {
    char *s = calloc(14);
    if (crc32("oCgsTArSej",10) == 188543510) strcat(s, "U");
if (crc32("DNeVV",5) == 812589378) strcat(s, "s");
if (crc32("yYOZhxXbgSmtSkc",15) == 1676566095) strcat(s, "V");
if (crc32("gVHErnpNotZbJwO",15) == 3463358455) strcat(s, "u");
if (crc32("rktQfygQ",8) == 3835404085) strcat(s, "p");
if (crc32("kGkqMmLxch",10) == 1512536029) strcat(s, "z");
if (crc32("HBACUMaEKCG",11) == 1982385941) strcat(s, "p");
if (crc32("mwKcI",5) == 2081856149) strcat(s, "P");
if (crc32("jDIFkCEQQBSWf",13) == 2506527961) strcat(s, "o");
if (crc32("ePblNOqxDB",10) == 312055627) strcat(s, "r");
if (crc32("jTvxkBMcyvCz",12) == 3749038896) strcat(s, "t");
if (crc32("JfqhAFQapnt",11) == 1733176672) strcat(s, "L");
if (crc32("xGLgFTJcbzMY",12) == 3446939141) strcat(s, "l");
if (crc32("FzOdqZVIsuLLyK",14) == 2191821547) strcat(s, "K");
if (crc32("PEoLFSYOz",9) == 1511373880) strcat(s, "e");
if (crc32("mdNMFOvmbpKKK",13) == 3191126885) strcat(s, "g");
if (crc32("YcroBwG",7) == 3201185976) strcat(s, "s");
if (crc32("lMYVLs",6) == 4113238013) strcat(s, "p");
if (crc32("KwQOv",5) == 3155215652) strcat(s, "s");
if (crc32("ckmJXJzcjLzGkNd",15) == 1398783508) strcat(s, "F");
if (crc32("fnguONCM",8) == 3869694202) strcat(s, "l");
if (crc32("UKUhJeLH",8) == 1436016313) strcat(s, "y");
    return s;
}

char *incomprehensively_adverbs() {
    char *s = calloc(18);
    if (crc32("RrAIPklvDWIMpT",14) == 1744180359) strcat(s, "i");
if (crc32("CZtsUb",6) == 1654568028) strcat(s, "G");
if (crc32("VOIwMVUdJ",9) == 1671616304) strcat(s, "n");
if (crc32("CjQPcUUQch",10) == 127177302) strcat(s, "c");
if (crc32("PPJpx",5) == 969981850) strcat(s, "o");
if (crc32("CLALxtfGaXj",11) == 3739558965) strcat(s, "m");
if (crc32("fcoSbPKgsR",10) == 3166607859) strcat(s, "p");
if (crc32("HksKGLmkwA",10) == 3073875231) strcat(s, "r");
if (crc32("RhiSTqIwITMhRZm",15) == 2375129470) strcat(s, "e");
if (crc32("deUbYUPAtkc",11) == 3870342956) strcat(s, "h");
if (crc32("PrbqWKwqDRklpxO",15) == 939881800) strcat(s, "H");
if (crc32("BTKpLQWcuokEFS",14) == 2368005063) strcat(s, "e");
if (crc32("QeFbkTiejosDe",13) == 2256961651) strcat(s, "n");
if (crc32("yTCQWkcjbZQv",12) == 2072503824) strcat(s, "s");
if (crc32("AohYgiDDB",9) == 2744874549) strcat(s, "i");
if (crc32("PwesuHRVspcy",12) == 2014316712) strcat(s, "D");
if (crc32("CkgyA",5) == 2280180634) strcat(s, "v");
if (crc32("FAcCOeNHz",9) == 3104552870) strcat(s, "e");
if (crc32("kTtNkGmGg",9) == 15088221) strcat(s, "l");
if (crc32("FgCts",5) == 1206074019) strcat(s, "y");
    return s;
}

char *overemotionally_adverbs() {
    char *s = calloc(16);
    if (crc32("EZeRtYiigumeZ",13) == 1562495211) strcat(s, "i");
if (crc32("jXzWawQyubkb",12) == 3087838493) strcat(s, "o");
if (crc32("GWRqE",5) == 629228329) strcat(s, "v");
if (crc32("iPlaiL",6) == 1164700557) strcat(s, "A");
if (crc32("MOWABLHmhyBOYfw",15) == 3869896730) strcat(s, "e");
if (crc32("QzRXKIx",7) == 1369573738) strcat(s, "W");
if (crc32("LnZLdmJzr",9) == 1473863155) strcat(s, "r");
if (crc32("jngvHfJ",7) == 3341073446) strcat(s, "V");
if (crc32("WRlyR",5) == 390128588) strcat(s, "e");
if (crc32("jlNbYO",6) == 4193099151) strcat(s, "m");
if (crc32("nnDaFITd",8) == 510509152) strcat(s, "o");
if (crc32("ZPCGabhBChkWS",13) == 3000149827) strcat(s, "t");
if (crc32("lghaXRsBUGUNf",13) == 70296597) strcat(s, "i");
if (crc32("rApZAHgvqaQTN",13) == 804323589) strcat(s, "E");
if (crc32("KaRlohhtPF",10) == 1297347710) strcat(s, "o");
if (crc32("NvfhZqHHAfLQm",13) == 2024657657) strcat(s, "n");
if (crc32("PTSTUUFgJ",9) == 1091168146) strcat(s, "H");
if (crc32("qjfXDm",6) == 2043301912) strcat(s, "a");
if (crc32("bmZxUBGzHI",10) == 2527103196) strcat(s, "l");
if (crc32("zbEoMqOquY",10) == 1697759385) strcat(s, "i");
if (crc32("JxUCWr",6) == 324875309) strcat(s, "l");
if (crc32("LdSzGWhMvmLM",12) == 1108032177) strcat(s, "y");
    return s;
}

char *sorely_adverbs() {
    char *s = calloc(7);
    if (crc32("PDyidyH",7) == 1371024485) strcat(s, "s");
if (crc32("wdYydnPztROw",12) == 3492446338) strcat(s, "o");
if (crc32("TosfH",5) == 4095536513) strcat(s, "L");
if (crc32("ynWJuWAPb",9) == 946786281) strcat(s, "r");
if (crc32("vqtkcSurfojlFIu",15) == 2931375889) strcat(s, "e");
if (crc32("VocUC",5) == 1891427937) strcat(s, "l");
if (crc32("qzYrOTFrKnENLu",14) == 471220794) strcat(s, "y");
    return s;
}

char *semiinstinctively_adverbs() {
    char *s = calloc(18);
    if (crc32("iTjLtHyeb",9) == 572390725) strcat(s, "s");
if (crc32("SIMNyDZYONSFs",13) == 1981750658) strcat(s, "e");
if (crc32("khPnaFanuihZNip",15) == 769614355) strcat(s, "X");
if (crc32("bJxCayaD",8) == 978903931) strcat(s, "m");
if (crc32("RfXnLcFhzI",10) == 3853854195) strcat(s, "l");
if (crc32("IebRF",5) == 3277327913) strcat(s, "i");
if (crc32("bkhpZoeSSMSLb",13) == 505534207) strcat(s, "i");
if (crc32("JAVPFtpMYrxtA",13) == 2608033498) strcat(s, "y");
if (crc32("fTDBvBQ",7) == 4028947064) strcat(s, "n");
if (crc32("yNGwZoq",7) == 2484104914) strcat(s, "l");
if (crc32("SwoUIpjJeg",10) == 1845641253) strcat(s, "s");
if (crc32("WYjWMHy",7) == 3170638729) strcat(s, "t");
if (crc32("pkYhzzpdmuy",11) == 4126436794) strcat(s, "i");
if (crc32("lcIecCW",7) == 1841526062) strcat(s, "K");
if (crc32("OSlMz",5) == 1911751655) strcat(s, "n");
if (crc32("lVJLvggQMEEUc",13) == 1103176805) strcat(s, "c");
if (crc32("VtppyQnVNvDEymj",15) == 746498931) strcat(s, "t");
if (crc32("KgZvv",5) == 4007194848) strcat(s, "i");
if (crc32("WRVAllGxXcqSo",13) == 690513664) strcat(s, "v");
if (crc32("ghpgEPlVfl",10) == 650831880) strcat(s, "X");
if (crc32("WAoDFIBWR",9) == 3457455791) strcat(s, "e");
if (crc32("BUtYfXwzWN",10) == 3263771190) strcat(s, "l");
if (crc32("JznJTuIqqHDbzY",14) == 1906538343) strcat(s, "y");
    return s;
}

char *superlocally_adverbs() {
    char *s = calloc(13);
    if (crc32("BtggolIKPrT",11) == 2418558836) strcat(s, "t");
if (crc32("RZHwoyBg",8) == 1954628611) strcat(s, "s");
if (crc32("XPfQYeJyVUadpk",14) == 3128602492) strcat(s, "Z");
if (crc32("oOnivWbMEusR",12) == 1306050269) strcat(s, "u");
if (crc32("wBlCmyUyQRfsEQ",14) == 2295972149) strcat(s, "D");
if (crc32("xBgcEPRx",8) == 340083460) strcat(s, "p");
if (crc32("cAltd",5) == 2069491247) strcat(s, "e");
if (crc32("reFkbcTuPAU",11) == 1206566808) strcat(s, "r");
if (crc32("cCysM",5) == 2175813958) strcat(s, "t");
if (crc32("tTgZWrMakquZ",12) == 333135117) strcat(s, "l");
if (crc32("fxsJlx",6) == 771356095) strcat(s, "Z");
if (crc32("genjIoUYWg",10) == 2789571657) strcat(s, "o");
if (crc32("OZLzGWexUl",10) == 282145984) strcat(s, "c");
if (crc32("sJrJIrSgxwLGp",13) == 3484906762) strcat(s, "a");
if (crc32("HUxWINwnC",9) == 4064841283) strcat(s, "m");
if (crc32("yZJRcpsiLoEQ",12) == 631810729) strcat(s, "l");
if (crc32("WvRWGeHKjZlkgeI",15) == 1089991806) strcat(s, "l");
if (crc32("qwcBC",5) == 2473848467) strcat(s, "y");
    return s;
}

char *thus_adverbs() {
    char *s = calloc(5);
    if (crc32("URcClOfsm",9) == 514038003) strcat(s, "t");
if (crc32("QVLTWlk",7) == 752662557) strcat(s, "C");
if (crc32("LMSNRvYNgfNTVFg",15) == 3560665542) strcat(s, "h");
if (crc32("aahjnfqVboLLCIR",15) == 2127814580) strcat(s, "u");
if (crc32("JuZKHQ",6) == 1329053440) strcat(s, "u");
if (crc32("uiklhReKTWLbY",13) == 1315352101) strcat(s, "s");
    return s;
}

char *quasimiraculously_adverbs() {
    char *s = calloc(18);
    if (crc32("jGHmMxhkndY",11) == 3618486469) strcat(s, "u");
if (crc32("WnVMYBHCdjZLZd",14) == 72416402) strcat(s, "q");
if (crc32("pOdcNWxV",8) == 4282866548) strcat(s, "y");
if (crc32("kpBeRe",6) == 3765931401) strcat(s, "u");
if (crc32("WLqDtcD",7) == 607696031) strcat(s, "V");
if (crc32("YwCZprrjDSkpZAk",15) == 148592192) strcat(s, "a");
if (crc32("SCnQBCLcLiZAkbo",15) == 2130169626) strcat(s, "B");
if (crc32("JjqMJP",6) == 113231956) strcat(s, "s");
if (crc32("ZytKyGNWhhadlhP",15) == 974172876) strcat(s, "i");
if (crc32("yVyexmLJeaP",11) == 1653290121) strcat(s, "Z");
if (crc32("eTIRCLVfkvdSQh",14) == 2235333882) strcat(s, "m");
if (crc32("qGUohswFIgGnBQ",14) == 309176841) strcat(s, "i");
if (crc32("kAnDNwBuaDudH",13) == 2068653591) strcat(s, "r");
if (crc32("hYWlcbslz",9) == 2987237234) strcat(s, "a");
if (crc32("VsxUxL",6) == 982846393) strcat(s, "S");
if (crc32("lmMlqzN",7) == 2768555684) strcat(s, "c");
if (crc32("QESNIUyfb",9) == 2805550854) strcat(s, "u");
if (crc32("zDEFcqjDS",9) == 1747992866) strcat(s, "B");
if (crc32("uiDlTKtZGF",10) == 4280711584) strcat(s, "l");
if (crc32("DngyErsyP",9) == 2649950594) strcat(s, "g");
if (crc32("WRvLFYXtWIojyU",14) == 3115214093) strcat(s, "o");
if (crc32("OqxNzrvdnDDSMww",15) == 3550109125) strcat(s, "u");
if (crc32("tnqBGeqOOha",11) == 1412798670) strcat(s, "s");
if (crc32("bgVUhc",6) == 2163479299) strcat(s, "N");
if (crc32("LmbunPnpTZCvCq",14) == 3967196636) strcat(s, "l");
if (crc32("HQjAWiCMm",9) == 957888749) strcat(s, "y");
    return s;
}

char *metallically_adverbs() {
    char *s = calloc(13);
    if (crc32("zIvPpEsCsWxEKV",14) == 488357752) strcat(s, "l");
if (crc32("RLLuVsJyuloW",12) == 1476109046) strcat(s, "m");
if (crc32("xOIXnwqLMVLeob",14) == 244636369) strcat(s, "T");
if (crc32("rURYaeVZHBZ",11) == 3579499471) strcat(s, "e");
if (crc32("lFCFu",5) == 3490657305) strcat(s, "t");
if (crc32("OoBcy",5) == 175170822) strcat(s, "b");
if (crc32("nnHjUHFDkG",10) == 4263903774) strcat(s, "a");
if (crc32("VQhSFMJjlww",11) == 2822622136) strcat(s, "m");
if (crc32("HaGtT",5) == 2143012521) strcat(s, "l");
if (crc32("xCKJquLaK",9) == 3542531970) strcat(s, "c");
if (crc32("vOczWQKRHU",10) == 469689058) strcat(s, "l");
if (crc32("hJLvwqUXQosvgdN",15) == 74828659) strcat(s, "i");
if (crc32("DfpqFFXQPPHjLG",14) == 1587531367) strcat(s, "b");
if (crc32("gozqMApkcinQ",12) == 3726872244) strcat(s, "c");
if (crc32("IYZbV",5) == 2435636111) strcat(s, "a");
if (crc32("sOCLz",5) == 635932379) strcat(s, "l");
if (crc32("wwTEDJwwjNEHK",13) == 732445513) strcat(s, "l");
if (crc32("CXdWxrWNQzE",11) == 3211555242) strcat(s, "a");
if (crc32("qjKuFGubyObjQ",13) == 3311296749) strcat(s, "y");
    return s;
}

char *unventurously_adverbs() {
    char *s = calloc(14);
    if (crc32("eHjRIvnedXnlKW",14) == 3333772444) strcat(s, "u");
if (crc32("ydrNpO",6) == 2030562905) strcat(s, "o");
if (crc32("mlIMYBGT",8) == 4241219175) strcat(s, "n");
if (crc32("KWOilZsOQSU",11) == 1883698479) strcat(s, "v");
if (crc32("HNiKHjN",7) == 1997698750) strcat(s, "e");
if (crc32("InBiDivL",8) == 196371266) strcat(s, "n");
if (crc32("ToLxrC",6) == 391636584) strcat(s, "K");
if (crc32("hopvdfDMFYP",11) == 716996333) strcat(s, "t");
if (crc32("uoiATDRawicaJzW",15) == 3557302584) strcat(s, "J");
if (crc32("wXMOYIieCY",10) == 2180898950) strcat(s, "u");
if (crc32("eeutF",5) == 957533351) strcat(s, "H");
if (crc32("vhGPo",5) == 1547798342) strcat(s, "r");
if (crc32("TIbMAfaN",8) == 1399516672) strcat(s, "c");
if (crc32("knMCVgF",7) == 3537078695) strcat(s, "o");
if (crc32("phCqE",5) == 353728812) strcat(s, "f");
if (crc32("VPuqS",5) == 738205846) strcat(s, "u");
if (crc32("rHpeN",5) == 3994426079) strcat(s, "P");
if (crc32("TnGHq",5) == 3124691396) strcat(s, "s");
if (crc32("dcKxbnoUghh",11) == 2971363933) strcat(s, "U");
if (crc32("uPqHpJfSYD",10) == 3854097223) strcat(s, "l");
if (crc32("xmCLkbL",7) == 1412675829) strcat(s, "y");
    return s;
}

char *callously_adverbs() {
    char *s = calloc(10);
    if (crc32("qJfUPx",6) == 2714672443) strcat(s, "u");
if (crc32("MjtEqhdKvBNLFj",14) == 2313015665) strcat(s, "c");
if (crc32("smunhqLtB",9) == 950525165) strcat(s, "a");
if (crc32("TjPMuVyAX",9) == 271156030) strcat(s, "l");
if (crc32("IimhHhvaGqc",11) == 1550122065) strcat(s, "W");
if (crc32("gIftYzH",7) == 3351187062) strcat(s, "l");
if (crc32("GENnzOKPsX",10) == 2401464925) strcat(s, "F");
if (crc32("qDVjpFcLe",9) == 692385815) strcat(s, "o");
if (crc32("XQPYaTMG",8) == 1601047821) strcat(s, "F");
if (crc32("hTXdYufBVLelgCW",15) == 808603269) strcat(s, "u");
if (crc32("KaLDlN",6) == 2330320735) strcat(s, "B");
if (crc32("ulsoguUz",8) == 3632770509) strcat(s, "s");
if (crc32("JXWpIn",6) == 843522176) strcat(s, "K");
if (crc32("OZpmsxBMbl",10) == 871513364) strcat(s, "l");
if (crc32("ZNowKaO",7) == 1814735407) strcat(s, "Z");
if (crc32("NTPpCvMHnjD",11) == 2079717453) strcat(s, "y");
    return s;
}

char *snubbingly_adverbs() {
    char *s = calloc(11);
    if (crc32("zXQeOEMg",8) == 1819130627) strcat(s, "x");
if (crc32("AgSVBvI",7) == 4266591710) strcat(s, "s");
if (crc32("DTlrHQlFtB",10) == 2546524381) strcat(s, "n");
if (crc32("AknAlzMnIbLaa",13) == 672393327) strcat(s, "s");
if (crc32("zilryPhRgw",10) == 1876660513) strcat(s, "u");
if (crc32("OqQFpRA",7) == 2314912656) strcat(s, "b");
if (crc32("oVLKHwMHdcOLPOD",15) == 2562415257) strcat(s, "j");
if (crc32("nuCIz",5) == 1601581416) strcat(s, "b");
if (crc32("vLevflEW",8) == 2046556940) strcat(s, "k");
if (crc32("EyJglvzfUuK",11) == 2988829476) strcat(s, "i");
if (crc32("oVYEdjnrGqADlig",15) == 1920759874) strcat(s, "n");
if (crc32("iiMRO",5) == 2247768485) strcat(s, "N");
if (crc32("OTAllkAgsISNb",13) == 1298182514) strcat(s, "g");
if (crc32("LxCQVWpqAWiK",12) == 1569943669) strcat(s, "J");
if (crc32("uVAGUfmvVt",10) == 4273076400) strcat(s, "l");
if (crc32("vXnNCIlNoMHaYuK",15) == 2486123837) strcat(s, "y");
    return s;
}

char *meritedly_adverbs() {
    char *s = calloc(10);
    if (crc32("JISpOWEfsgbdRh",14) == 136605882) strcat(s, "f");
if (crc32("LTJzOf",6) == 2050277575) strcat(s, "m");
if (crc32("lDCunrmFOZ",10) == 1116015624) strcat(s, "e");
if (crc32("OMsrcWlQJmJe",12) == 2792285319) strcat(s, "r");
if (crc32("byDBd",5) == 3437531644) strcat(s, "i");
if (crc32("qUtwh",5) == 1928418927) strcat(s, "g");
if (crc32("QJfBCcIKUswb",12) == 3085937031) strcat(s, "t");
if (crc32("yYrGzViv",8) == 2913191736) strcat(s, "e");
if (crc32("QFjKhI",6) == 735296197) strcat(s, "d");
if (crc32("phCjwS",6) == 1298122420) strcat(s, "l");
if (crc32("WeYOo",5) == 2305350091) strcat(s, "y");
    return s;
}

char *superbenignly_adverbs() {
    char *s = calloc(14);
    if (crc32("yqcVGdHsFbkaJC",14) == 498355503) strcat(s, "s");
if (crc32("auVYwxZCS",9) == 3922962458) strcat(s, "S");
if (crc32("KUXAmiDli",9) == 3725580785) strcat(s, "u");
if (crc32("LKUlFOf",7) == 1005093025) strcat(s, "s");
if (crc32("nMydhd",6) == 2639108981) strcat(s, "p");
if (crc32("dsOkcPX",7) == 3426584214) strcat(s, "e");
if (crc32("oUoOMufILiWhtE",14) == 2802135155) strcat(s, "r");
if (crc32("VoTdtnFKF",9) == 2247842699) strcat(s, "b");
if (crc32("iZXKjQxiFZZK",12) == 1810828177) strcat(s, "e");
if (crc32("pxYDPFIkoVVhJzG",15) == 539005732) strcat(s, "O");
if (crc32("NRNmizwUQtXWeu",14) == 2071283265) strcat(s, "n");
if (crc32("gXjiTrCsJhIy",12) == 903026602) strcat(s, "F");
if (crc32("EMTPHocwWpeU",12) == 1339094158) strcat(s, "i");
if (crc32("UkusaVrw",8) == 738918710) strcat(s, "g");
if (crc32("cQHZGwTBDDIm",12) == 970887561) strcat(s, "n");
if (crc32("ZWNNIs",6) == 2140979943) strcat(s, "l");
if (crc32("JflQrtgz",8) == 1207868432) strcat(s, "y");
    return s;
}

char *fierily_adverbs() {
    char *s = calloc(8);
    if (crc32("SEdRGRPKRQQT",12) == 1692671575) strcat(s, "f");
if (crc32("fUXnPMHFVsfY",12) == 1454539770) strcat(s, "i");
if (crc32("sUYrJrQvBkpbgY",14) == 2707475518) strcat(s, "e");
if (crc32("zjDUchy",7) == 1416457295) strcat(s, "H");
if (crc32("drJQjpJ",7) == 972795107) strcat(s, "r");
if (crc32("zrMbhmWFqAaPeh",14) == 2469642009) strcat(s, "i");
if (crc32("NQbjnuUnsWiJm",13) == 2223373443) strcat(s, "l");
if (crc32("trSpJDpYuqhB",12) == 1380701606) strcat(s, "y");
    return s;
}

char *postpaid_adverbs() {
    char *s = calloc(9);
    if (crc32("zKQFsqHQLqPdIgx",15) == 4117086305) strcat(s, "p");
if (crc32("jhygLSWKpVnOsk",14) == 59599243) strcat(s, "j");
if (crc32("jniQyGeNh",9) == 2723618665) strcat(s, "o");
if (crc32("sWlGei",6) == 2659604727) strcat(s, "s");
if (crc32("jcTozhqVgG",10) == 3622823475) strcat(s, "g");
if (crc32("mOVjsu",6) == 1347470257) strcat(s, "t");
if (crc32("BDLxeYKqc",9) == 2800206328) strcat(s, "p");
if (crc32("kuOsLaG",7) == 3961055070) strcat(s, "H");
if (crc32("apoThoXV",8) == 3964210063) strcat(s, "a");
if (crc32("QFJtUd",6) == 2346820509) strcat(s, "i");
if (crc32("EnFzPeRNWKTFXTe",15) == 4221894329) strcat(s, "y");
if (crc32("yjdwOK",6) == 1031292693) strcat(s, "d");
    return s;
}

char *ungaudily_adverbs() {
    char *s = calloc(10);
    if (crc32("RRLGnmUCoIkjiT",14) == 3049523416) strcat(s, "v");
if (crc32("SjTZcFEiwTbsn",13) == 1174572602) strcat(s, "u");
if (crc32("QuhEWGuLYGPIJ",13) == 3999959191) strcat(s, "n");
if (crc32("AkawdLNcjKvCB",13) == 61434001) strcat(s, "F");
if (crc32("kyIWvPTIKscZ",12) == 2268916232) strcat(s, "g");
if (crc32("gWtiSqOe",8) == 3471239984) strcat(s, "I");
if (crc32("nizFGEK",7) == 2111238598) strcat(s, "a");
if (crc32("KwtPfIbdxAVecbA",15) == 1243319048) strcat(s, "u");
if (crc32("ydfTCtMmE",9) == 414617010) strcat(s, "G");
if (crc32("idyWvnnOJvKrSU",14) == 2221811423) strcat(s, "d");
if (crc32("ORzHgontb",9) == 3950520887) strcat(s, "A");
if (crc32("pByiEWTE",8) == 3216105193) strcat(s, "i");
if (crc32("GBEumAK",7) == 1379499103) strcat(s, "A");
if (crc32("VwIrgcxPIB",10) == 1046112493) strcat(s, "l");
if (crc32("rZYSaYQXP",9) == 3672233368) strcat(s, "P");
if (crc32("kHnKwvtlKSf",11) == 3050816863) strcat(s, "y");
    return s;
}

char *tidily_adverbs() {
    char *s = calloc(7);
    if (crc32("bbeAFpV",7) == 1864603587) strcat(s, "t");
if (crc32("weirrAtLntTwA",13) == 4266568747) strcat(s, "c");
if (crc32("aVndT",5) == 2747802874) strcat(s, "i");
if (crc32("oHbFeTqWResh",12) == 2177680702) strcat(s, "l");
if (crc32("FpsctzzlNBkGu",13) == 3250344810) strcat(s, "d");
if (crc32("pQBUKzqTg",9) == 1735800524) strcat(s, "D");
if (crc32("dyGnriszH",9) == 3650612881) strcat(s, "i");
if (crc32("SPMMOkRixd",10) == 3703401073) strcat(s, "j");
if (crc32("CjCmD",5) == 1590976793) strcat(s, "l");
if (crc32("lCchYWKbl",9) == 2842469513) strcat(s, "y");
    return s;
}

char *criminologically_adverbs() {
    char *s = calloc(17);
    if (crc32("plCnmCyOK",9) == 4081041251) strcat(s, "c");
if (crc32("lGcOiNaM",8) == 2141777038) strcat(s, "r");
if (crc32("kBErAV",6) == 315770601) strcat(s, "I");
if (crc32("yMlsB",5) == 2257833358) strcat(s, "i");
if (crc32("cKHJCV",6) == 1785734604) strcat(s, "m");
if (crc32("cWwgEgMCGKpqJ",13) == 2695711605) strcat(s, "i");
if (crc32("kAzyG",5) == 909483830) strcat(s, "a");
if (crc32("lGKGqlOO",8) == 4014646762) strcat(s, "n");
if (crc32("KdxZiQ",6) == 3743160344) strcat(s, "o");
if (crc32("SsDXbps",7) == 635312638) strcat(s, "D");
if (crc32("kHVFKJNHIOjp",12) == 3431782658) strcat(s, "l");
if (crc32("ZsBMFqlPHtRz",12) == 2818134059) strcat(s, "v");
if (crc32("ZngQA",5) == 2157666545) strcat(s, "o");
if (crc32("zZGybMH",7) == 2797315007) strcat(s, "I");
if (crc32("NpTLwtd",7) == 3457758579) strcat(s, "g");
if (crc32("tnVcW",5) == 3261570835) strcat(s, "i");
if (crc32("FaTIweFWWmBDUJo",15) == 631311468) strcat(s, "N");
if (crc32("CjnKA",5) == 3723870977) strcat(s, "c");
if (crc32("NjvpuWCBJyctNfG",15) == 1081837213) strcat(s, "W");
if (crc32("TbLvvrKVkBltNca",15) == 79673447) strcat(s, "a");
if (crc32("ptkDefJG",8) == 3164174542) strcat(s, "l");
if (crc32("WwOAfSKjgfkHhx",14) == 2936750504) strcat(s, "l");
if (crc32("sARMlXdgQUAOXo",14) == 976847391) strcat(s, "Z");
if (crc32("HlPocUOFZNusRCN",15) == 2152784703) strcat(s, "y");
    return s;
}

char *foxily_adverbs() {
    char *s = calloc(7);
    if (crc32("zAPrCPJIadKiAmB",15) == 3463264852) strcat(s, "f");
if (crc32("blhgvVXoVRSFl",13) == 2890569766) strcat(s, "V");
if (crc32("WIzWlPptQn",10) == 1742297802) strcat(s, "o");
if (crc32("pGmMHDEhYZJobhL",15) == 974689185) strcat(s, "K");
if (crc32("VGfewXjmaMJZWD",14) == 741829750) strcat(s, "x");
if (crc32("ZSgOsLzcKdRJ",12) == 1019322204) strcat(s, "B");
if (crc32("oTKCavLRXfZH",12) == 3140593422) strcat(s, "i");
if (crc32("dKsGA",5) == 3166471709) strcat(s, "l");
if (crc32("rZbdVwtym",9) == 2890644971) strcat(s, "l");
if (crc32("gXXtuBDEbKfx",12) == 1141557446) strcat(s, "N");
if (crc32("GZHWIJMDLRpjBlZ",15) == 614697777) strcat(s, "y");
    return s;
}

char *unavengingly_adverbs() {
    char *s = calloc(13);
    if (crc32("OIGOa",5) == 1572463554) strcat(s, "t");
if (crc32("shxaZ",5) == 729311498) strcat(s, "u");
if (crc32("swlrEJ",6) == 1241777496) strcat(s, "n");
if (crc32("RUMXs",5) == 3138289007) strcat(s, "a");
if (crc32("IRxOwnAN",8) == 653823440) strcat(s, "Q");
if (crc32("mYsKPoARYpP",11) == 4056299823) strcat(s, "v");
if (crc32("fkXViJ",6) == 3308455575) strcat(s, "e");
if (crc32("EaXDvWKb",8) == 2586393675) strcat(s, "K");
if (crc32("tEMINl",6) == 2376679450) strcat(s, "n");
if (crc32("dCVxjbw",7) == 1692842692) strcat(s, "p");
if (crc32("QIlIhdaVvI",10) == 2220952728) strcat(s, "g");
if (crc32("spSIWyYv",8) == 2569707246) strcat(s, "N");
if (crc32("mcPeOlnkUVhZdGs",15) == 676149655) strcat(s, "i");
if (crc32("GOiqv",5) == 177149743) strcat(s, "A");
if (crc32("wWcPOgGrksFt",12) == 1446529098) strcat(s, "n");
if (crc32("hNLHnYBcPOng",12) == 1194616795) strcat(s, "g");
if (crc32("rnRIEofPMoB",11) == 1485503858) strcat(s, "l");
if (crc32("WWwREPq",7) == 628122769) strcat(s, "k");
if (crc32("WtUTbtwneZNEy",13) == 2413357402) strcat(s, "y");
    return s;
}

char *aportoise_adverbs() {
    char *s = calloc(10);
    if (crc32("Uoceyoj",7) == 3466393271) strcat(s, "H");
if (crc32("ecoJD",5) == 2261776854) strcat(s, "a");
if (crc32("SCzqbsiTC",9) == 1860087448) strcat(s, "p");
if (crc32("qkgicyu",7) == 61930522) strcat(s, "i");
if (crc32("FSJJYPAJGFulHid",15) == 1785424623) strcat(s, "o");
if (crc32("vOnrwhr",7) == 828317223) strcat(s, "L");
if (crc32("Uwiafvzg",8) == 2461341115) strcat(s, "r");
if (crc32("jdPpApuafcWM",12) == 1336089070) strcat(s, "t");
if (crc32("OsSKyMTdyZlh",12) == 2992014349) strcat(s, "n");
if (crc32("LICLVnTtpKOai",13) == 1261176161) strcat(s, "o");
if (crc32("aOaaGOeeyqexUL",14) == 1303635151) strcat(s, "f");
if (crc32("GScrExvF",8) == 1237811934) strcat(s, "i");
if (crc32("gYKkSIcoUZrc",12) == 1475503584) strcat(s, "s");
if (crc32("GZFkLkm",7) == 3816428229) strcat(s, "q");
if (crc32("iYoEYKfGebMrC",13) == 2250367062) strcat(s, "e");
    return s;
}

char *triply_adverbs() {
    char *s = calloc(7);
    if (crc32("ieaccxEzoayV",12) == 2413253178) strcat(s, "t");
if (crc32("uTNXWmy",7) == 2258496394) strcat(s, "K");
if (crc32("oVpLqHHU",8) == 879129229) strcat(s, "r");
if (crc32("ndEjcszkCnMy",12) == 2336012065) strcat(s, "i");
if (crc32("rZQLOlZem",9) == 1842312975) strcat(s, "Y");
if (crc32("xxZsJJbHyXBY",12) == 2878568000) strcat(s, "p");
if (crc32("wrehkdTmYS",10) == 1800151996) strcat(s, "P");
if (crc32("RakuRJZuJJATW",13) == 840525152) strcat(s, "l");
if (crc32("inivtfQL",8) == 1554774347) strcat(s, "y");
    return s;
}

char *unlimitedly_adverbs() {
    char *s = calloc(12);
    if (crc32("UcfqIDhV",8) == 1711699534) strcat(s, "u");
if (crc32("UHeeTZZeTrMzPkS",15) == 3116723505) strcat(s, "K");
if (crc32("HjqmualtK",9) == 1696933806) strcat(s, "n");
if (crc32("LSrmwfYR",8) == 186020192) strcat(s, "T");
if (crc32("agZRsUNfBhVEZL",14) == 4167482991) strcat(s, "l");
if (crc32("zVmfeBZmz",9) == 3637345727) strcat(s, "w");
if (crc32("ufCEesZmc",9) == 760526354) strcat(s, "i");
if (crc32("zkHhdrnj",8) == 778235046) strcat(s, "m");
if (crc32("krWQrCQTCWlCuz",14) == 2161894554) strcat(s, "i");
if (crc32("rzdxJUFkwX",10) == 1988953799) strcat(s, "T");
if (crc32("jDlkPgMgLHoLJ",13) == 2848501634) strcat(s, "t");
if (crc32("DdNkQj",6) == 1514619979) strcat(s, "C");
if (crc32("vizYuUmfVQXr",12) == 3700800642) strcat(s, "e");
if (crc32("quQihmYQjn",10) == 2901479218) strcat(s, "d");
if (crc32("HELGzpDDEpDb",12) == 4076903046) strcat(s, "l");
if (crc32("AQWfxVgWITBlJOQ",15) == 964960564) strcat(s, "y");
    return s;
}

char *prophetically_adverbs() {
    char *s = calloc(14);
    if (crc32("HIcgKjdwVu",10) == 2479537134) strcat(s, "p");
if (crc32("FEepKHgSAVEuTQ",14) == 3204350636) strcat(s, "A");
if (crc32("cKkhZRhdni",10) == 568287311) strcat(s, "r");
if (crc32("bQHpSdxqTxMk",12) == 2112569368) strcat(s, "o");
if (crc32("OqsPSxh",7) == 2472134012) strcat(s, "t");
if (crc32("gkuTzLZdICrW",12) == 1752080246) strcat(s, "p");
if (crc32("SUGtVbp",7) == 1421917687) strcat(s, "B");
if (crc32("qYAIRHMrwLbbY",13) == 3981985249) strcat(s, "h");
if (crc32("TXFdBvMBftth",12) == 2047464927) strcat(s, "P");
if (crc32("BcwVcfMPayiRHx",14) == 4268415700) strcat(s, "e");
if (crc32("PDTxTJ",6) == 1181533726) strcat(s, "t");
if (crc32("EiQnhkk",7) == 3127178582) strcat(s, "v");
if (crc32("BuuvimkfCF",10) == 37130505) strcat(s, "i");
if (crc32("UzZGDSuNt",9) == 2798280528) strcat(s, "A");
if (crc32("jCvYcBKyHv",10) == 612506692) strcat(s, "c");
if (crc32("WhXXnhQLXi",10) == 511826237) strcat(s, "a");
if (crc32("InqhhCuKKK",10) == 250156422) strcat(s, "C");
if (crc32("xLbnsbS",7) == 4049924186) strcat(s, "l");
if (crc32("KkHVgmDekyX",11) == 3319079793) strcat(s, "l");
if (crc32("KLtKtfmvFov",11) == 95978203) strcat(s, "y");
    return s;
}

char *depravedly_adverbs() {
    char *s = calloc(11);
    if (crc32("VwOHawGXrt",10) == 1326120721) strcat(s, "M");
if (crc32("TKEGZZq",7) == 3217293530) strcat(s, "d");
if (crc32("rDDGWysWvdONsql",15) == 1290087758) strcat(s, "e");
if (crc32("SFTHxwS",7) == 1795878493) strcat(s, "k");
if (crc32("MLUnWPHygBlo",12) == 1753365442) strcat(s, "p");
if (crc32("qIMTbbgX",8) == 470637300) strcat(s, "Q");
if (crc32("ZvwomkPbDhFJt",13) == 1013937161) strcat(s, "r");
if (crc32("lYOUl",5) == 2635779109) strcat(s, "I");
if (crc32("oQUStywC",8) == 4201461805) strcat(s, "a");
if (crc32("QHozSIpJFAhBIM",14) == 3196783871) strcat(s, "v");
if (crc32("KSuekYX",7) == 512768131) strcat(s, "l");
if (crc32("tkgKotMm",8) == 3090286034) strcat(s, "e");
if (crc32("eARjnvJpXNMhMd",14) == 1532717402) strcat(s, "U");
if (crc32("GIdoQfMUrtAHrWL",15) == 2802493001) strcat(s, "d");
if (crc32("rINuUMZi",8) == 3820631043) strcat(s, "F");
if (crc32("vrRGCfOiREYqE",13) == 1348834115) strcat(s, "l");
if (crc32("iGJiU",5) == 4012736150) strcat(s, "i");
if (crc32("lNMtVNeyQco",11) == 2062309802) strcat(s, "y");
    return s;
}

char *ungallantly_adverbs() {
    char *s = calloc(12);
    if (crc32("edKTEeUWozmV",12) == 1681267276) strcat(s, "u");
if (crc32("YKYItrIa",8) == 1256054810) strcat(s, "m");
if (crc32("WFXfIz",6) == 2758985908) strcat(s, "n");
if (crc32("xywZkDPo",8) == 4202095509) strcat(s, "q");
if (crc32("RnsQurzNy",9) == 2346688270) strcat(s, "g");
if (crc32("pMeeSMm",7) == 2277922223) strcat(s, "a");
if (crc32("GZfKtUvegBgy",12) == 878353049) strcat(s, "X");
if (crc32("GLoFLmBYe",9) == 4157065293) strcat(s, "l");
if (crc32("TTVXKDrZNYlb",12) == 1528520690) strcat(s, "M");
if (crc32("RrrTfsBemSa",11) == 384277313) strcat(s, "l");
if (crc32("bFlfvSXM",8) == 3822252280) strcat(s, "a");
if (crc32("OFKxJCRPxz",10) == 1641908215) strcat(s, "n");
if (crc32("IrysCYQLvqcHSqU",15) == 2473940625) strcat(s, "t");
if (crc32("EWLIJheFZT",10) == 1907862739) strcat(s, "l");
if (crc32("rAduymIH",8) == 3304628017) strcat(s, "y");
    return s;
}

char *reflexly_adverbs() {
    char *s = calloc(9);
    if (crc32("HOOKL",5) == 2269604580) strcat(s, "D");
if (crc32("OMkutnCqIdRPvj",14) == 4057180513) strcat(s, "r");
if (crc32("LxOVgrpdCa",10) == 4033988555) strcat(s, "F");
if (crc32("PnEkydNBq",9) == 4210387995) strcat(s, "e");
if (crc32("XvDcajEY",8) == 860232394) strcat(s, "e");
if (crc32("JUyClfMtXXzjZE",14) == 22686671) strcat(s, "f");
if (crc32("sQWScmSbrae",11) == 2800194492) strcat(s, "E");
if (crc32("enfKRmy",7) == 3133778283) strcat(s, "l");
if (crc32("HSSsjKiVfqft",12) == 2278905002) strcat(s, "e");
if (crc32("jZEIapJYa",9) == 912961604) strcat(s, "x");
if (crc32("qwEDvpvb",8) == 512593024) strcat(s, "l");
if (crc32("cRhwwqrYsnDWP",13) == 1980879433) strcat(s, "o");
if (crc32("KnkOpYx",7) == 2774395299) strcat(s, "y");
    return s;
}

char *semiblasphemously_adverbs() {
    char *s = calloc(18);
    if (crc32("xQfzzpENWHHVGB",14) == 193011103) strcat(s, "s");
if (crc32("eKTJQqDKNR",10) == 11244747) strcat(s, "H");
if (crc32("ezJTqtKFjyaXCE",14) == 3452926372) strcat(s, "e");
if (crc32("gGGguOAbCZHS",12) == 3477422406) strcat(s, "m");
if (crc32("MmLHxZsZTGRNnp",14) == 1575679702) strcat(s, "i");
if (crc32("kQtVaiPHSDpfO",13) == 2113642262) strcat(s, "d");
if (crc32("CJWjldyVfL",10) == 2362562074) strcat(s, "b");
if (crc32("EZGLqVJzezwaRJ",14) == 3080139024) strcat(s, "t");
if (crc32("PHERH",5) == 642445659) strcat(s, "l");
if (crc32("KAWNBw",6) == 2436789308) strcat(s, "a");
if (crc32("MTjjcKTP",8) == 2283809107) strcat(s, "l");
if (crc32("YmedOg",6) == 485525660) strcat(s, "s");
if (crc32("pKoehqHAuJN",11) == 317353591) strcat(s, "p");
if (crc32("SvjVIERlToXV",12) == 3199952299) strcat(s, "i");
if (crc32("ssrSHzh",7) == 2143345962) strcat(s, "h");
if (crc32("ejgHDY",6) == 356321558) strcat(s, "I");
if (crc32("tQzOHNwlOIBXLy",14) == 2170399398) strcat(s, "e");
if (crc32("fTbrzAvIhoQ",11) == 3451354825) strcat(s, "V");
if (crc32("ZweeH",5) == 1828251609) strcat(s, "m");
if (crc32("CwgoFGfMlz",10) == 2303756426) strcat(s, "o");
if (crc32("AwMBT",5) == 2203236408) strcat(s, "u");
if (crc32("QsRngBvJIw",10) == 324106703) strcat(s, "d");
if (crc32("mPzrWX",6) == 4261846143) strcat(s, "s");
if (crc32("mKzUFh",6) == 331577966) strcat(s, "z");
if (crc32("eHuEZDVSoGk",11) == 1198788474) strcat(s, "l");
if (crc32("OJImJAKRSuZvSZ",14) == 3928191647) strcat(s, "C");
if (crc32("SARqonwGCXkxuX",14) == 2529206765) strcat(s, "y");
    return s;
}

char *oafishly_adverbs() {
    char *s = calloc(9);
    if (crc32("vfaMP",5) == 3377761030) strcat(s, "o");
if (crc32("bKxWUNjzdLxZXah",15) == 3521695065) strcat(s, "a");
if (crc32("DEQhOqEvhYdIbd",14) == 714040494) strcat(s, "J");
if (crc32("vGaBlz",6) == 259440231) strcat(s, "f");
if (crc32("FOPJwhf",7) == 3494382337) strcat(s, "i");
if (crc32("yuUCP",5) == 3024716900) strcat(s, "s");
if (crc32("fnUAG",5) == 1358485245) strcat(s, "I");
if (crc32("NXrHh",5) == 65316385) strcat(s, "h");
if (crc32("cnuhDnlb",8) == 4223538757) strcat(s, "p");
if (crc32("CsQZciJWziJriJ",14) == 4259114600) strcat(s, "l");
if (crc32("RDqll",5) == 1281011912) strcat(s, "M");
if (crc32("udfIx",5) == 1886077478) strcat(s, "y");
    return s;
}

char *quasiheroically_adverbs() {
    char *s = calloc(16);
    if (crc32("mTGbMzcyIiWc",12) == 197462958) strcat(s, "q");
if (crc32("UEpZtRY",7) == 666147762) strcat(s, "u");
if (crc32("NAWMGN",6) == 3787925403) strcat(s, "a");
if (crc32("hAzcpRCA",8) == 787680786) strcat(s, "s");
if (crc32("FCmywSzLMm",10) == 3345846354) strcat(s, "i");
if (crc32("btchHkGycsRa",12) == 1952845975) strcat(s, "h");
if (crc32("kkOWa",5) == 3644638397) strcat(s, "G");
if (crc32("iOrrSMHEX",9) == 1536366045) strcat(s, "e");
if (crc32("WHAQxlQZmRt",11) == 2038949288) strcat(s, "A");
if (crc32("mySBCB",6) == 407566849) strcat(s, "r");
if (crc32("UUryQdpjhk",10) == 3786186652) strcat(s, "o");
if (crc32("hoOVfuiINoUgIFF",15) == 1522954355) strcat(s, "i");
if (crc32("GvdoxlO",7) == 522151100) strcat(s, "f");
if (crc32("nDnkmNhQda",10) == 409680514) strcat(s, "c");
if (crc32("zlTQlZTNO",9) == 1883561911) strcat(s, "C");
if (crc32("qqZnq",5) == 1816417662) strcat(s, "a");
if (crc32("UoklcJxy",8) == 449727396) strcat(s, "z");
if (crc32("TYpTcBYtR",9) == 3128783565) strcat(s, "l");
if (crc32("HoXQdwXjDvJ",11) == 1374547746) strcat(s, "h");
if (crc32("DRZNo",5) == 3632888729) strcat(s, "l");
if (crc32("TTqHzD",6) == 723429629) strcat(s, "b");
if (crc32("FIJuLybFBV",10) == 758502513) strcat(s, "y");
    return s;
}

char *nonpredatorily_adverbs() {
    char *s = calloc(15);
    if (crc32("yaoCGaBxzFwia",13) == 1516694695) strcat(s, "C");
if (crc32("AxQUoIpvwyBHE",13) == 1072883071) strcat(s, "n");
if (crc32("bcJMKb",6) == 221416380) strcat(s, "O");
if (crc32("ppwfHETpl",9) == 2304716135) strcat(s, "o");
if (crc32("nfiTMp",6) == 2902930421) strcat(s, "n");
if (crc32("cPwayLAovh",10) == 3641319846) strcat(s, "F");
if (crc32("eDKyoCx",7) == 792599517) strcat(s, "p");
if (crc32("qxLldadTSoHqjd",14) == 1988290183) strcat(s, "r");
if (crc32("aehMCnIpd",9) == 3766811895) strcat(s, "e");
if (crc32("EYLCcRMydVapUDP",15) == 2737614417) strcat(s, "w");
if (crc32("RRJkDGe",7) == 1668798463) strcat(s, "d");
if (crc32("hiyhxhBeBn",10) == 2202785969) strcat(s, "a");
if (crc32("NTLLKLPZX",9) == 2249010013) strcat(s, "Y");
if (crc32("BucqyC",6) == 2951277924) strcat(s, "t");
if (crc32("hsHlTO",6) == 1834175633) strcat(s, "k");
if (crc32("dmBFUkULese",11) == 4114355171) strcat(s, "o");
if (crc32("DcLjgbfxh",9) == 1128262431) strcat(s, "r");
if (crc32("CpgFVFeHgVWYUxp",15) == 1476174554) strcat(s, "C");
if (crc32("YVSVfxj",7) == 1727574463) strcat(s, "i");
if (crc32("EogGTa",6) == 3262334849) strcat(s, "l");
if (crc32("efPYeXCUM",9) == 3684882300) strcat(s, "Z");
if (crc32("szVkeHP",7) == 2901863476) strcat(s, "y");
    return s;
}

char *cytologically_adverbs() {
    char *s = calloc(14);
    if (crc32("Rmtaz",5) == 3530769952) strcat(s, "c");
if (crc32("ukBsPG",6) == 828814421) strcat(s, "y");
if (crc32("SOLMymvbRojf",12) == 2092750030) strcat(s, "R");
if (crc32("PPingcsyDURlC",13) == 1375511885) strcat(s, "t");
if (crc32("EvqXNHpIss",10) == 1122738108) strcat(s, "g");
if (crc32("ZeVlCxq",7) == 912983155) strcat(s, "o");
if (crc32("KnqdohXk",8) == 3943902146) strcat(s, "l");
if (crc32("dydCXV",6) == 3768000001) strcat(s, "o");
if (crc32("uhBsazJit",9) == 2356305702) strcat(s, "g");
if (crc32("dWJzDaUswHtBuu",14) == 1898270855) strcat(s, "g");
if (crc32("VaRKxb",6) == 546294942) strcat(s, "G");
if (crc32("wxGpohVbyRUre",13) == 3103973992) strcat(s, "i");
if (crc32("jNREEkcrvOk",11) == 4061123087) strcat(s, "c");
if (crc32("xfPfujaUB",9) == 2288082739) strcat(s, "B");
if (crc32("OqrGNffiy",9) == 3326104243) strcat(s, "a");
if (crc32("fQZlVrKmx",9) == 1040871130) strcat(s, "N");
if (crc32("TJPtd",5) == 2452099404) strcat(s, "l");
if (crc32("MhCmyjjUvN",10) == 2592837385) strcat(s, "j");
if (crc32("qhJXDnwSOh",10) == 2878140323) strcat(s, "l");
if (crc32("HvqdyaTMzTlVeoJ",15) == 2631527163) strcat(s, "l");
if (crc32("JOsvpKVRD",9) == 2033827506) strcat(s, "y");
    return s;
}

char *capitally_adverbs() {
    char *s = calloc(10);
    if (crc32("VJRDKKMaMTdh",12) == 1087085298) strcat(s, "s");
if (crc32("QdwzPVA",7) == 1163766130) strcat(s, "c");
if (crc32("FBroVCeKikita",13) == 447733673) strcat(s, "K");
if (crc32("dcFRqamGD",9) == 382851008) strcat(s, "a");
if (crc32("vAOOREvi",8) == 2475868444) strcat(s, "p");
if (crc32("LBFNEaDcf",9) == 696620088) strcat(s, "i");
if (crc32("cKtTXm",6) == 513481371) strcat(s, "z");
if (crc32("KZtPThu",7) == 1473543857) strcat(s, "t");
if (crc32("Eglzqs",6) == 4125249429) strcat(s, "F");
if (crc32("YdmSqEOUw",9) == 372374717) strcat(s, "a");
if (crc32("SByFyON",7) == 362825763) strcat(s, "j");
if (crc32("mErGKYQohtYC",12) == 364152073) strcat(s, "l");
if (crc32("HRJVuWW",7) == 2665717435) strcat(s, "Z");
if (crc32("uldiWAOby",9) == 657733479) strcat(s, "l");
if (crc32("oothCMg",7) == 254619956) strcat(s, "y");
    return s;
}

char *unevangelically_adverbs() {
    char *s = calloc(16);
    if (crc32("XATgcpKdQhORMZK",15) == 3945789279) strcat(s, "u");
if (crc32("ZKkyNEYut",9) == 3955594653) strcat(s, "s");
if (crc32("FimGkUIypiI",11) == 2400515330) strcat(s, "n");
if (crc32("sbTvTwuGKYqIGf",14) == 3165608278) strcat(s, "y");
if (crc32("lLVVpg",6) == 692671675) strcat(s, "e");
if (crc32("uHakJWv",7) == 1667061715) strcat(s, "R");
if (crc32("ltmKQwIMvPERV",13) == 566870673) strcat(s, "v");
if (crc32("yacmvDZf",8) == 1593460311) strcat(s, "y");
if (crc32("CGFpJyze",8) == 617527043) strcat(s, "a");
if (crc32("cCrFjYHGdmmp",12) == 1517217445) strcat(s, "R");
if (crc32("GCqropvabkKwb",13) == 2519028647) strcat(s, "n");
if (crc32("FPGgP",5) == 4003357319) strcat(s, "g");
if (crc32("gGfavHYexOOLJQu",15) == 2968422601) strcat(s, "t");
if (crc32("yAbMTel",7) == 2637103999) strcat(s, "e");
if (crc32("zkvfWQU",7) == 3002958575) strcat(s, "K");
if (crc32("JMdqWDHzwdHWpm",14) == 2537563707) strcat(s, "l");
if (crc32("ItuTxMn",7) == 472781750) strcat(s, "i");
if (crc32("jEOoNkCbsycP",12) == 3950219276) strcat(s, "D");
if (crc32("JktPpjrkwuxKUmg",15) == 178415373) strcat(s, "c");
if (crc32("WlmXxWdX",8) == 1770478730) strcat(s, "a");
if (crc32("rfPKyzIFpenq",12) == 583852315) strcat(s, "y");
if (crc32("tMCvfPVDieQcZp",14) == 1397598309) strcat(s, "l");
if (crc32("mLKWkVBoO",9) == 715197414) strcat(s, "s");
if (crc32("WvwTtTGIFayp",12) == 4280689808) strcat(s, "l");
if (crc32("RAuwXbiPGH",10) == 825038261) strcat(s, "P");
if (crc32("RYyODaazHOwKMi",14) == 800347510) strcat(s, "y");
    return s;
}

char *irruptively_adverbs() {
    char *s = calloc(12);
    if (crc32("vajAp",5) == 3473748890) strcat(s, "i");
if (crc32("erKvsdJGFC",10) == 3637510892) strcat(s, "r");
if (crc32("aGURPLoqphU",11) == 3624352782) strcat(s, "r");
if (crc32("ntCiQITvulj",11) == 88014011) strcat(s, "Y");
if (crc32("WVYPbrY",7) == 455781599) strcat(s, "u");
if (crc32("ETUFkploHOXnMmz",15) == 3929095753) strcat(s, "D");
if (crc32("kIZrXccAhNYQR",13) == 1572663276) strcat(s, "p");
if (crc32("JlxmkE",6) == 771278230) strcat(s, "t");
if (crc32("VQVjtMmlOv",10) == 4176505808) strcat(s, "i");
if (crc32("XzXbH",5) == 2275445856) strcat(s, "v");
if (crc32("FXvVWBwAAFyRQ",13) == 245100425) strcat(s, "e");
if (crc32("eFXvrQ",6) == 1642650394) strcat(s, "l");
if (crc32("AzgLBW",6) == 209369821) strcat(s, "b");
if (crc32("cleBWjjLxpe",11) == 293470965) strcat(s, "y");
    return s;
}

char *nonamorously_adverbs() {
    char *s = calloc(13);
    if (crc32("fcVErukGV",9) == 3566345399) strcat(s, "E");
if (crc32("JFkGoaGHUX",10) == 1282498001) strcat(s, "n");
if (crc32("fzJgKMABxEqMEZ",14) == 595806113) strcat(s, "o");
if (crc32("jgvIxILkLIqdx",13) == 615017137) strcat(s, "s");
if (crc32("oatIsotoqNicl",13) == 1788830700) strcat(s, "n");
if (crc32("wclKUdjzo",9) == 202130040) strcat(s, "a");
if (crc32("WmEqRCjAByC",11) == 1165916702) strcat(s, "m");
if (crc32("pIcQpf",6) == 1041546148) strcat(s, "a");
if (crc32("MkMxCSofckr",11) == 2272394765) strcat(s, "o");
if (crc32("kCxyFYUJOsAUh",13) == 3202491311) strcat(s, "f");
if (crc32("OEZZRTRYxaCTJxu",15) == 307528943) strcat(s, "r");
if (crc32("naPCXErQ",8) == 25528508) strcat(s, "b");
if (crc32("ACiqErlmEoSdNzG",15) == 1754438716) strcat(s, "o");
if (crc32("LtffJWZu",8) == 914956888) strcat(s, "u");
if (crc32("TkbtJHBDaMtB",12) == 1191400090) strcat(s, "s");
if (crc32("BUndqLrqLhiCoLS",15) == 1533542829) strcat(s, "l");
if (crc32("GEDOXkVZqJsSWe",14) == 1322167750) strcat(s, "y");
    return s;
}

char *leanly_adverbs() {
    char *s = calloc(7);
    if (crc32("aAwYXOI",7) == 1388295407) strcat(s, "V");
if (crc32("rgjYGEpvUjtB",12) == 4038499719) strcat(s, "l");
if (crc32("eNDdSNSmSXldd",13) == 3513871476) strcat(s, "e");
if (crc32("EXKNFjqOSdga",12) == 1038399503) strcat(s, "a");
if (crc32("BfUlsZxeJn",10) == 3094503067) strcat(s, "n");
if (crc32("GhFolbZX",8) == 3156856172) strcat(s, "H");
if (crc32("MbgSnHvm",8) == 1321681085) strcat(s, "l");
if (crc32("YOfsGVgscqpZs",13) == 1546035101) strcat(s, "y");
    return s;
}

char *drably_adverbs() {
    char *s = calloc(7);
    if (crc32("SIETKFIevcV",11) == 4155486315) strcat(s, "d");
if (crc32("bdGuhG",6) == 3348588198) strcat(s, "E");
if (crc32("iLMbo",5) == 1900441307) strcat(s, "r");
if (crc32("yYWrrFklndTQZMR",15) == 681557593) strcat(s, "e");
if (crc32("fVDyuHLgovji",12) == 3212420722) strcat(s, "a");
if (crc32("ssafHOHKAu",10) == 288874138) strcat(s, "b");
if (crc32("yHUzWP",6) == 1376255468) strcat(s, "H");
if (crc32("iWkQtYFs",8) == 3282780371) strcat(s, "l");
if (crc32("fTgwvuOjcS",10) == 903935208) strcat(s, "y");
    return s;
}

char *unreverentially_adverbs() {
    char *s = calloc(16);
    if (crc32("YjNaVKhAASAOg",13) == 4030708823) strcat(s, "h");
if (crc32("EETouIznwVwkC",13) == 2221628320) strcat(s, "u");
if (crc32("PqawYrdY",8) == 973620196) strcat(s, "u");
if (crc32("QkkZBAPoo",9) == 2018172824) strcat(s, "n");
if (crc32("tyvxvjEGilyI",12) == 891392876) strcat(s, "o");
if (crc32("aTduVqIC",8) == 2039817828) strcat(s, "r");
if (crc32("Fsrujy",6) == 3517606866) strcat(s, "P");
if (crc32("QskTHtqHeheDph",14) == 744245903) strcat(s, "e");
if (crc32("toNWNhigVV",10) == 3168286888) strcat(s, "v");
if (crc32("rwNucrrEg",9) == 2729437148) strcat(s, "F");
if (crc32("axETr",5) == 3665225464) strcat(s, "e");
if (crc32("AFlcOFdXxwLdQPA",15) == 2978774657) strcat(s, "r");
if (crc32("BOLqOAWgeNf",11) == 722214377) strcat(s, "K");
if (crc32("LIVUUHzPr",9) == 129951769) strcat(s, "e");
if (crc32("PkNiCukCX",9) == 3997041753) strcat(s, "X");
if (crc32("nsVqUEqTfRWD",12) == 2105696282) strcat(s, "n");
if (crc32("lWVTNBcH",8) == 760395811) strcat(s, "t");
if (crc32("ffsscnh",7) == 2665022897) strcat(s, "i");
if (crc32("kVjNzqDwsvTZPBu",15) == 3196564023) strcat(s, "a");
if (crc32("kbKjhMz",7) == 2577016061) strcat(s, "l");
if (crc32("OAgcSZQfXwJBtU",14) == 2332964175) strcat(s, "l");
if (crc32("ZILOSUw",7) == 364995342) strcat(s, "Z");
if (crc32("WFEzNlfJWlFFQ",13) == 9296640) strcat(s, "y");
    return s;
}

char *assertorily_adverbs() {
    char *s = calloc(12);
    if (crc32("fMtmSTsXtTS",11) == 346495551) strcat(s, "a");
if (crc32("OIgOP",5) == 3587303310) strcat(s, "e");
if (crc32("CUZrdMaUhytpzd",14) == 763311248) strcat(s, "s");
if (crc32("zroFKhryB",9) == 702936828) strcat(s, "s");
if (crc32("AmhPluJK",8) == 2123542356) strcat(s, "e");
if (crc32("nwIsGrCCNyR",11) == 4084605994) strcat(s, "i");
if (crc32("DDAcPWXPZhkY",12) == 669499070) strcat(s, "r");
if (crc32("txcQCldSVMxXfx",14) == 1994158162) strcat(s, "t");
if (crc32("DhISKe",6) == 2194702024) strcat(s, "d");
if (crc32("uVpYXJh",7) == 2641123858) strcat(s, "o");
if (crc32("oIhaET",6) == 1259107906) strcat(s, "r");
if (crc32("FfthJnAXiHcWCLS",15) == 35808995) strcat(s, "i");
if (crc32("xPFqIttMB",9) == 3806800577) strcat(s, "e");
if (crc32("mdzqjmq",7) == 915970614) strcat(s, "l");
if (crc32("WNBdfBvgRMR",11) == 3416996027) strcat(s, "y");
    return s;
}

char *ochlocratically_adverbs() {
    char *s = calloc(16);
    if (crc32("XhNpRcObsAKR",12) == 1144455759) strcat(s, "R");
if (crc32("elytAe",6) == 608985359) strcat(s, "o");
if (crc32("vcNtzBKl",8) == 2856188551) strcat(s, "j");
if (crc32("AntnOqp",7) == 2275605200) strcat(s, "c");
if (crc32("zeQJX",5) == 1370738393) strcat(s, "w");
if (crc32("qhJkVelbc",9) == 4186020673) strcat(s, "h");
if (crc32("uslPhy",6) == 3454986738) strcat(s, "l");
if (crc32("xqnoEHHesjnnO",13) == 2252311982) strcat(s, "o");
if (crc32("VklCTYDECzsvpe",14) == 1374679741) strcat(s, "c");
if (crc32("cxOwsEjcPdPLbfE",15) == 953160538) strcat(s, "r");
if (crc32("MmjfVhRXTYadu",13) == 4185804924) strcat(s, "e");
if (crc32("GMcsMwe",7) == 771419041) strcat(s, "a");
if (crc32("NCfcxkqSXCsPqP",14) == 2870949809) strcat(s, "t");
if (crc32("wgKgihjVDhHElNx",15) == 4160654190) strcat(s, "i");
if (crc32("ScziLqbUNtf",11) == 857678529) strcat(s, "m");
if (crc32("zIJlRcrChhkNz",13) == 3769253556) strcat(s, "c");
if (crc32("ZuOsv",5) == 1509648832) strcat(s, "Z");
if (crc32("AYvcf",5) == 2949197351) strcat(s, "a");
if (crc32("LqzvIOQOSi",10) == 3132167702) strcat(s, "O");
if (crc32("BWGDDFUsQwhduq",14) == 2504405607) strcat(s, "l");
if (crc32("DpLOFZ",6) == 2403663947) strcat(s, "O");
if (crc32("okKGzJoxbs",10) == 4153484527) strcat(s, "l");
if (crc32("oASojfsVxauD",12) == 2967675377) strcat(s, "y");
    return s;
}

char *unscenically_adverbs() {
    char *s = calloc(13);
    if (crc32("aNgcBlwgDydBGJq",15) == 418131765) strcat(s, "u");
if (crc32("lcMqvbIsu",9) == 1527986357) strcat(s, "n");
if (crc32("MyeTPTUEIoas",12) == 379015836) strcat(s, "s");
if (crc32("yLdRTOgl",8) == 1790495547) strcat(s, "n");
if (crc32("QZOshXLtKPB",11) == 537520766) strcat(s, "c");
if (crc32("UBIxdkJkt",9) == 2989067137) strcat(s, "r");
if (crc32("WFaZb",5) == 1486092186) strcat(s, "e");
if (crc32("wFvgzCmtcTb",11) == 92015691) strcat(s, "n");
if (crc32("TfRYKFidksm",11) == 2771141867) strcat(s, "i");
if (crc32("ORVvuMOMsFL",11) == 3373543468) strcat(s, "c");
if (crc32("zaTpONwz",8) == 517424306) strcat(s, "l");
if (crc32("ybscrqOYoddV",12) == 1920686003) strcat(s, "a");
if (crc32("rvKqZIayCZx",11) == 2070052906) strcat(s, "l");
if (crc32("HmgcMipzltSowRj",15) == 2362502659) strcat(s, "l");
if (crc32("yaTXlblpUb",10) == 1317077618) strcat(s, "E");
if (crc32("dQUipXLDtDCzop",14) == 2974113729) strcat(s, "y");
    return s;
}

char *iridescently_adverbs() {
    char *s = calloc(13);
    if (crc32("shiXdanXrrG",11) == 2388276999) strcat(s, "i");
if (crc32("xwNJAQgmrye",11) == 3328069697) strcat(s, "r");
if (crc32("ZovDqsAuMBH",11) == 1294005480) strcat(s, "h");
if (crc32("uXGYTXRTwY",10) == 1215376283) strcat(s, "i");
if (crc32("muYksJzTMvXNqUJ",15) == 95443402) strcat(s, "d");
if (crc32("hPTxHizzk",9) == 470084087) strcat(s, "e");
if (crc32("wLtmDYXDpCoLG",13) == 617275718) strcat(s, "A");
if (crc32("ZRDxB",5) == 3709997312) strcat(s, "s");
if (crc32("ZghacJUj",8) == 2434130026) strcat(s, "c");
if (crc32("ZQavjWxIRQGo",12) == 3534838668) strcat(s, "e");
if (crc32("gFctiOvrlQd",11) == 3714383299) strcat(s, "i");
if (crc32("eCozawvFaAo",11) == 263339812) strcat(s, "n");
if (crc32("ItADvG",6) == 1344384015) strcat(s, "t");
if (crc32("FDmLrJTvnNLuR",13) == 2704441737) strcat(s, "l");
if (crc32("dUnQiO",6) == 915399692) strcat(s, "y");
    return s;
}

char *fretfully_adverbs() {
    char *s = calloc(10);
    if (crc32("YzkmslVivpT",11) == 1548325507) strcat(s, "f");
if (crc32("IMKBImd",7) == 496853736) strcat(s, "q");
if (crc32("VbwvYbYKTbVK",12) == 1731613427) strcat(s, "r");
if (crc32("aLTXGFTJVoaYE",13) == 1464383763) strcat(s, "e");
if (crc32("jCQPwcmVvhGgV",13) == 3547368634) strcat(s, "t");
if (crc32("vDUzddhOT",9) == 3875814461) strcat(s, "P");
if (crc32("mfQQXNxpz",9) == 2842988808) strcat(s, "f");
if (crc32("uoPaZqylnZZE",12) == 4097480857) strcat(s, "u");
if (crc32("KXcpleeqp",9) == 4118189955) strcat(s, "l");
if (crc32("teuoggrJ",8) == 3861447685) strcat(s, "V");
if (crc32("bVJNCjIuzalqadi",15) == 3688365381) strcat(s, "l");
if (crc32("DQnZuhvySdNa",12) == 841375632) strcat(s, "r");
if (crc32("rjhLc",5) == 3742955942) strcat(s, "y");
    return s;
}

char *dramatically_adverbs() {
    char *s = calloc(13);
    if (crc32("JozvEGQffCFIVRf",15) == 651181580) strcat(s, "c");
if (crc32("DknvPYv",7) == 2582534981) strcat(s, "d");
if (crc32("ejxiyVfA",8) == 2652171662) strcat(s, "i");
if (crc32("tcrIJrg",7) == 3723957555) strcat(s, "r");
if (crc32("Woyfajufaacr",12) == 2440164730) strcat(s, "a");
if (crc32("SvJrqgSahgbyqP",14) == 562381469) strcat(s, "Q");
if (crc32("XHVGuRYZOlIxJOQ",15) == 27887333) strcat(s, "m");
if (crc32("iGABTlQcxhvwxz",14) == 968453415) strcat(s, "a");
if (crc32("RDwNABVLTmbyON",14) == 4124040988) strcat(s, "t");
if (crc32("rTDHmUy",7) == 326485139) strcat(s, "a");
if (crc32("VIanQvK",7) == 2139128949) strcat(s, "i");
if (crc32("veulGpFtbok",11) == 3180911076) strcat(s, "c");
if (crc32("xCzjvQbkcizUWF",14) == 490970101) strcat(s, "C");
if (crc32("FGVmRyO",7) == 2706625596) strcat(s, "a");
if (crc32("uZZVQWAvi",9) == 2857570610) strcat(s, "l");
if (crc32("YbfDImygwPhSc",13) == 3170520977) strcat(s, "l");
if (crc32("LtOQBXz",7) == 1212244584) strcat(s, "g");
if (crc32("CXToJfbpyqIOG",13) == 1353671191) strcat(s, "y");
    return s;
}

char *spousally_adverbs() {
    char *s = calloc(10);
    if (crc32("qhISRUuZBGGxIA",14) == 2358156506) strcat(s, "s");
if (crc32("eVBpBu",6) == 3647231475) strcat(s, "p");
if (crc32("VdmRSjDAduvxD",13) == 3193078803) strcat(s, "a");
if (crc32("egXIPMgDRv",10) == 4151445120) strcat(s, "o");
if (crc32("gUGpfWvRa",9) == 3954150491) strcat(s, "u");
if (crc32("jcVMQ",5) == 2577557850) strcat(s, "Y");
if (crc32("znOjeGGaKXRLkd",14) == 3614496656) strcat(s, "s");
if (crc32("bKudboa",7) == 2641834575) strcat(s, "r");
if (crc32("gGzXsVNByrnb",12) == 2629207557) strcat(s, "a");
if (crc32("RZOKAvLCuVIVPIc",15) == 3932652273) strcat(s, "l");
if (crc32("xraDOdEOGpglQrt",15) == 4218453340) strcat(s, "l");
if (crc32("sXQNSzl",7) == 564624065) strcat(s, "y");
    return s;
}

char *sanguinely_adverbs() {
    char *s = calloc(11);
    if (crc32("NAeSOv",6) == 3906520744) strcat(s, "r");
if (crc32("DZPFpA",6) == 3327576211) strcat(s, "s");
if (crc32("aGbUUCbPgHcGd",13) == 522504493) strcat(s, "d");
if (crc32("gczMSIwlDfYhoI",14) == 230522807) strcat(s, "a");
if (crc32("bmnpxKFgNlUiC",13) == 1371321477) strcat(s, "X");
if (crc32("rLouWP",6) == 3318050728) strcat(s, "n");
if (crc32("CoUskPvMH",9) == 3448183287) strcat(s, "a");
if (crc32("OMqlQwRG",8) == 1858445902) strcat(s, "g");
if (crc32("wMeeBZptdX",10) == 1056799661) strcat(s, "x");
if (crc32("XHiFw",5) == 3215327094) strcat(s, "u");
if (crc32("SEUcaPIKfcaYCY",14) == 1377775476) strcat(s, "i");
if (crc32("wQsEYjIg",8) == 1519911900) strcat(s, "n");
if (crc32("WvlJVMspQsg",11) == 1600865780) strcat(s, "e");
if (crc32("QlewhXZSgXLzzGW",15) == 3157946408) strcat(s, "u");
if (crc32("dWTLlsEwHOB",11) == 3073357651) strcat(s, "l");
if (crc32("jxWoxDuasbNLfy",14) == 1032394866) strcat(s, "y");
    return s;
}

char *ravishingly_adverbs() {
    char *s = calloc(12);
    if (crc32("oLBaFVULNTTbf",13) == 2938815946) strcat(s, "r");
if (crc32("aKQidudCBosXzyA",15) == 1508392106) strcat(s, "V");
if (crc32("WYvyEfNpHFK",11) == 845396195) strcat(s, "a");
if (crc32("nRgzNecfdpfnlA",14) == 1640576256) strcat(s, "v");
if (crc32("QlXdCXDj",8) == 4004240171) strcat(s, "i");
if (crc32("ebuSgC",6) == 4252710506) strcat(s, "s");
if (crc32("gHdsWDOoesUXE",13) == 1897308491) strcat(s, "h");
if (crc32("AhoaLBieTE",10) == 482768814) strcat(s, "l");
if (crc32("sTluurRXBHf",11) == 3118530054) strcat(s, "i");
if (crc32("ZMimWkBFmCFvKiF",15) == 1032595158) strcat(s, "n");
if (crc32("SYjjYDgEnLXkll",14) == 2058358264) strcat(s, "X");
if (crc32("FaFcNSztFKCskb",14) == 1331102809) strcat(s, "g");
if (crc32("VSIBiWUcUdvu",12) == 2584001170) strcat(s, "l");
if (crc32("OjYVHnQWHaT",11) == 3717222967) strcat(s, "y");
    return s;
}

char *deploringly_adverbs() {
    char *s = calloc(12);
    if (crc32("PWrmejpjx",9) == 2355383274) strcat(s, "L");
if (crc32("WazdxzFBCU",10) == 3893630270) strcat(s, "d");
if (crc32("VFnISAGgTVyg",12) == 715033698) strcat(s, "e");
if (crc32("mHSnIKNTSSudby",14) == 154427863) strcat(s, "p");
if (crc32("NZsvKwOQNz",10) == 2007816154) strcat(s, "l");
if (crc32("jMDlXORukdIxO",13) == 3399789068) strcat(s, "o");
if (crc32("jWmTaJNiIFbE",12) == 2108603350) strcat(s, "r");
if (crc32("dvVWOdzd",8) == 4252595106) strcat(s, "i");
if (crc32("qsEZvBxpDNRuQKL",15) == 2044367385) strcat(s, "n");
if (crc32("HXCpLNNADCQ",11) == 1790732413) strcat(s, "A");
if (crc32("EBdVfTCONxD",11) == 2334094916) strcat(s, "g");
if (crc32("acEKUiEd",8) == 3482307213) strcat(s, "l");
if (crc32("bOgRsB",6) == 2069168007) strcat(s, "y");
    return s;
}

char *undescriptively_adverbs() {
    char *s = calloc(16);
    if (crc32("bahUxDPOwc",10) == 1499574163) strcat(s, "r");
if (crc32("ceLGlejRVNC",11) == 3241575704) strcat(s, "u");
if (crc32("AEcWFrQTND",10) == 2145969533) strcat(s, "W");
if (crc32("OMLEbYvX",8) == 3059559358) strcat(s, "n");
if (crc32("ITmYOT",6) == 3854593994) strcat(s, "d");
if (crc32("AieiNUwgLLQem",13) == 3950718408) strcat(s, "e");
if (crc32("HAyuMgRPyDKsC",13) == 2183070208) strcat(s, "s");
if (crc32("UgYNey",6) == 1002513698) strcat(s, "s");
if (crc32("bAUwKxuaCCQvHyW",15) == 3512444158) strcat(s, "c");
if (crc32("gDRUPC",6) == 1465714372) strcat(s, "r");
if (crc32("WgrnVYOO",8) == 2580790014) strcat(s, "b");
if (crc32("zhCnX",5) == 1740668137) strcat(s, "i");
if (crc32("bPIwREKnwy",10) == 1522611978) strcat(s, "Y");
if (crc32("ceDNjiTPvRoXCk",14) == 3729456623) strcat(s, "p");
if (crc32("UiXLwHkK",8) == 4101143046) strcat(s, "t");
if (crc32("SxIWRvkDIZ",10) == 739745572) strcat(s, "i");
if (crc32("DSNmnUmKAOu",11) == 2384492679) strcat(s, "v");
if (crc32("naFzKRtH",8) == 103930290) strcat(s, "v");
if (crc32("zJiEMO",6) == 2599638279) strcat(s, "e");
if (crc32("sfQJtExP",8) == 1686860181) strcat(s, "l");
if (crc32("sPOHvTraLtzxkr",14) == 1706322798) strcat(s, "y");
    return s;
}

char *inerrantly_adverbs() {
    char *s = calloc(11);
    if (crc32("vJlEaWIMpGe",11) == 4184138127) strcat(s, "i");
if (crc32("XUifVNgchhbu",12) == 2483526876) strcat(s, "e");
if (crc32("oMZhnqBNJin",11) == 111834808) strcat(s, "n");
if (crc32("vMCMFXBJaFE",11) == 120676764) strcat(s, "b");
if (crc32("qYjMze",6) == 2154749730) strcat(s, "e");
if (crc32("fXqKO",5) == 3860500889) strcat(s, "A");
if (crc32("WjmiDhVAKG",10) == 2102379427) strcat(s, "r");
if (crc32("hXiQEetPJxQsnY",14) == 3083123139) strcat(s, "o");
if (crc32("ygOdQDNh",8) == 589400247) strcat(s, "r");
if (crc32("MobAcmspFOxYtCV",15) == 823807491) strcat(s, "P");
if (crc32("QazZZvqQBRXv",12) == 1345592432) strcat(s, "a");
if (crc32("WNWsgq",6) == 1247355420) strcat(s, "n");
if (crc32("OtscmNAix",9) == 3642047365) strcat(s, "I");
if (crc32("lUhUjhpJdklTfe",14) == 1080629410) strcat(s, "t");
if (crc32("KeUsfwficbNztOw",15) == 3687728549) strcat(s, "v");
if (crc32("ifLMM",5) == 2021077567) strcat(s, "l");
if (crc32("MWNINMVCyKLeT",13) == 2206044824) strcat(s, "y");
    return s;
}

char *somewise_adverbs() {
    char *s = calloc(9);
    if (crc32("wluYomvnsr",10) == 4141194107) strcat(s, "B");
if (crc32("RIjSeXbXZQUhY",13) == 2466585321) strcat(s, "s");
if (crc32("KoucJgprQHK",11) == 1291495028) strcat(s, "t");
if (crc32("FmFeSx",6) == 910819997) strcat(s, "o");
if (crc32("hoLAZUhdb",9) == 625958772) strcat(s, "m");
if (crc32("syQBnmNt",8) == 3505478087) strcat(s, "d");
if (crc32("bVoUJRGUcILkOiY",15) == 2141842030) strcat(s, "e");
if (crc32("ifZbhInksRHl",12) == 1653804775) strcat(s, "x");
if (crc32("tFWOS",5) == 2558516546) strcat(s, "w");
if (crc32("IHkTqDFccfwpE",13) == 2606045897) strcat(s, "i");
if (crc32("LPdZtLk",7) == 253726362) strcat(s, "s");
if (crc32("fUMerkGHy",9) == 2731200271) strcat(s, "e");
    return s;
}

char *sententially_adverbs() {
    char *s = calloc(13);
    if (crc32("mtpOlykRVVsAl",13) == 1466636) strcat(s, "X");
if (crc32("gVdkMRg",7) == 2854630094) strcat(s, "s");
if (crc32("wAktmWOLkGKDr",13) == 3115403007) strcat(s, "f");
if (crc32("XGjMshi",7) == 3926541100) strcat(s, "e");
if (crc32("hpRSXkziZvBi",12) == 333377556) strcat(s, "W");
if (crc32("GMxHQFIidbp",11) == 1238178595) strcat(s, "n");
if (crc32("HqRWOW",6) == 2891326476) strcat(s, "g");
if (crc32("DGqBaqndFPzCHq",14) == 2467317936) strcat(s, "t");
if (crc32("UsXroNL",7) == 2458056482) strcat(s, "v");
if (crc32("aiuPpuuWoCa",11) == 1245214490) strcat(s, "e");
if (crc32("McUCMLegvn",10) == 1748227340) strcat(s, "N");
if (crc32("wTBPeE",6) == 703291690) strcat(s, "n");
if (crc32("aNAVIMcfbxUIMEe",15) == 2237760016) strcat(s, "t");
if (crc32("IfhtesHp",8) == 1636421953) strcat(s, "i");
if (crc32("YzUCEZTn",8) == 710223850) strcat(s, "o");
if (crc32("trpzfxRoPaPK",12) == 597249772) strcat(s, "a");
if (crc32("ugnXw",5) == 2947252977) strcat(s, "l");
if (crc32("dUqdVuQ",7) == 3895802164) strcat(s, "l");
if (crc32("wbLWVGXSTtJTJNC",15) == 1535130154) strcat(s, "y");
    return s;
}

char *drivelingly_adverbs() {
    char *s = calloc(12);
    if (crc32("UGDLGawVXb",10) == 1259043677) strcat(s, "K");
if (crc32("zBfXOPTRolbSyZk",15) == 3216578637) strcat(s, "d");
if (crc32("JjPtYUE",7) == 4223660926) strcat(s, "p");
if (crc32("NRjDPFyjLIVy",12) == 554558006) strcat(s, "r");
if (crc32("dISsJldrsiaX",12) == 208025550) strcat(s, "z");
if (crc32("bprCFj",6) == 3045250166) strcat(s, "i");
if (crc32("yHBdhnkiRNtU",12) == 1990753062) strcat(s, "e");
if (crc32("wYmaFrMCmwYik",13) == 3117497969) strcat(s, "v");
if (crc32("iOWBOopY",8) == 2517173983) strcat(s, "e");
if (crc32("hryTxXayDUqsb",13) == 3373048135) strcat(s, "l");
if (crc32("mrgRWhxNw",9) == 3234122869) strcat(s, "U");
if (crc32("tiuHgDcC",8) == 270337063) strcat(s, "i");
if (crc32("jviiZdwrpDjBKL",14) == 1063313971) strcat(s, "n");
if (crc32("XtRsGb",6) == 1987749280) strcat(s, "n");
if (crc32("AkncEjp",7) == 1028626597) strcat(s, "m");
if (crc32("yooZRh",6) == 1325893561) strcat(s, "g");
if (crc32("CkOHmPGMn",9) == 1759798317) strcat(s, "d");
if (crc32("gUVlO",5) == 1459194232) strcat(s, "l");
if (crc32("WtngTPLkKwmRiIw",15) == 1572147400) strcat(s, "R");
if (crc32("lxGEyYkmKbApMz",14) == 3288255407) strcat(s, "y");
    return s;
}

char *killingly_adverbs() {
    char *s = calloc(10);
    if (crc32("KbTiSolv",8) == 3839680304) strcat(s, "k");
if (crc32("FDmaZF",6) == 2583849449) strcat(s, "i");
if (crc32("WosBsJUgXch",11) == 4063223437) strcat(s, "l");
if (crc32("pvqyk",5) == 692378) strcat(s, "l");
if (crc32("aQOCaXIksePJN",13) == 1884145809) strcat(s, "i");
if (crc32("dGxCprZc",8) == 3769110132) strcat(s, "n");
if (crc32("UGJpzaRRHjoH",12) == 3406023699) strcat(s, "g");
if (crc32("dPqmOW",6) == 1280845288) strcat(s, "P");
if (crc32("NmZKFvObIbTXn",13) == 1165008396) strcat(s, "l");
if (crc32("fLUNmIKz",8) == 4245849799) strcat(s, "u");
if (crc32("dCbfr",5) == 3855487548) strcat(s, "y");
    return s;
}

char *anticlimactically_adverbs() {
    char *s = calloc(18);
    if (crc32("KSUyXx",6) == 3877342654) strcat(s, "s");
if (crc32("CHpSUUotEaEBnq",14) == 1082191840) strcat(s, "a");
if (crc32("ExyJvZGwVlduiu",14) == 3001579793) strcat(s, "F");
if (crc32("RDAfeAZhJ",9) == 64423649) strcat(s, "n");
if (crc32("BMeoPMpNP",9) == 4046697440) strcat(s, "e");
if (crc32("yjhNqvrhFi",10) == 2498916559) strcat(s, "t");
if (crc32("tPvtrYSyMmJfF",13) == 2992736487) strcat(s, "i");
if (crc32("fVVfkWmZGBT",11) == 4010562302) strcat(s, "W");
if (crc32("twZQuqDWyJTIz",13) == 1754857065) strcat(s, "c");
if (crc32("xiboWmuKgwrvQ",13) == 2197525498) strcat(s, "k");
if (crc32("eIHPFpTgItF",11) == 4110151694) strcat(s, "l");
if (crc32("aVAogDthd",9) == 822374566) strcat(s, "y");
if (crc32("qigRDh",6) == 4213914868) strcat(s, "i");
if (crc32("JiRTsP",6) == 4008421137) strcat(s, "m");
if (crc32("HpnCSZAFnP",10) == 299189598) strcat(s, "a");
if (crc32("cZoREgeyGK",10) == 4274942930) strcat(s, "c");
if (crc32("lLozjcRlgyxNouK",15) == 796488157) strcat(s, "t");
if (crc32("eWdMuip",7) == 3318073259) strcat(s, "a");
if (crc32("LsMxa",5) == 2277175684) strcat(s, "i");
if (crc32("sGCdEWc",7) == 3192485909) strcat(s, "m");
if (crc32("kLbDiZEm",8) == 441424155) strcat(s, "c");
if (crc32("VDmAFnBWGb",10) == 1024568228) strcat(s, "I");
if (crc32("DoBwhR",6) == 1988834897) strcat(s, "a");
if (crc32("RBBvCM",6) == 956067872) strcat(s, "H");
if (crc32("PhCRuqw",7) == 2385926365) strcat(s, "l");
if (crc32("bezCeNkRWf",10) == 97609615) strcat(s, "l");
if (crc32("VMUvSxj",7) == 3500707101) strcat(s, "x");
if (crc32("VtFokOvxzTuL",12) == 2669189971) strcat(s, "y");
    return s;
}

char *unhumiliatingly_adverbs() {
    char *s = calloc(16);
    if (crc32("lZvyVVZtbk",10) == 2806213081) strcat(s, "v");
if (crc32("noiBfwrmPPWg",12) == 1033001321) strcat(s, "u");
if (crc32("lEhUy",5) == 4119944590) strcat(s, "J");
if (crc32("URnJNFINE",9) == 4064180876) strcat(s, "n");
if (crc32("XgxmGfuNHQwYZGn",15) == 3291480335) strcat(s, "K");
if (crc32("EQNFxlKCT",9) == 1434078804) strcat(s, "h");
if (crc32("fzqiBkzIwPqFv",13) == 2866899119) strcat(s, "C");
if (crc32("DbNtpABxg",9) == 3999932844) strcat(s, "u");
if (crc32("VoJsOXAPED",10) == 2963539951) strcat(s, "P");
if (crc32("pNbNNFGoiMRpSeH",15) == 3263234828) strcat(s, "m");
if (crc32("LHXxrsUV",8) == 2546921871) strcat(s, "i");
if (crc32("yglOyenvbqWLnn",14) == 1024134398) strcat(s, "J");
if (crc32("onGjudmtbEDhEYY",15) == 1228228760) strcat(s, "l");
if (crc32("yiromJW",7) == 2162111314) strcat(s, "t");
if (crc32("SNCQAYrpeVpb",12) == 2695011151) strcat(s, "i");
if (crc32("ikFZOj",6) == 1682588745) strcat(s, "b");
if (crc32("haDqvxUvDrj",11) == 1302464946) strcat(s, "a");
if (crc32("AuietFkbEVCV",12) == 2707309662) strcat(s, "r");
if (crc32("NPkohypROcG",11) == 1348270052) strcat(s, "t");
if (crc32("vVXkRluNs",9) == 1109340255) strcat(s, "i");
if (crc32("cKnCm",5) == 4273717941) strcat(s, "n");
if (crc32("vhRYM",5) == 3524126084) strcat(s, "x");
if (crc32("eFLAyGHQH",9) == 261047838) strcat(s, "g");
if (crc32("HwMeJgg",7) == 1079185880) strcat(s, "A");
if (crc32("HdgKB",5) == 3693276950) strcat(s, "l");
if (crc32("watbOj",6) == 3380606788) strcat(s, "y");
if (crc32("QHxarUbTTQeQn",13) == 653433873) strcat(s, "y");
    return s;
}

char *unaccidentally_adverbs() {
    char *s = calloc(15);
    if (crc32("PawobAc",7) == 590110804) strcat(s, "u");
if (crc32("FBqcif",6) == 78660337) strcat(s, "L");
if (crc32("ficgJKbUoC",10) == 2832075342) strcat(s, "n");
if (crc32("yLsqDBEH",8) == 2398296297) strcat(s, "a");
if (crc32("HjDvSfkz",8) == 4059854111) strcat(s, "c");
if (crc32("ZXYglSIrGVPuu",13) == 836962443) strcat(s, "d");
if (crc32("SGfUcJW",7) == 3265625436) strcat(s, "c");
if (crc32("nyhwjVCP",8) == 3973842127) strcat(s, "s");
if (crc32("VNSYUvpCrZY",11) == 2738543526) strcat(s, "i");
if (crc32("FmRAN",5) == 3487800615) strcat(s, "d");
if (crc32("ExCuVEv",7) == 1942308208) strcat(s, "e");
if (crc32("DIxQP",5) == 218534292) strcat(s, "y");
if (crc32("lvuiMBDKgAneEE",14) == 3828750713) strcat(s, "n");
if (crc32("fIOdodc",7) == 4154540751) strcat(s, "G");
if (crc32("lyeMrnFJNJl",11) == 3254556728) strcat(s, "t");
if (crc32("BugHE",5) == 3414032685) strcat(s, "a");
if (crc32("THuClq",6) == 4043350468) strcat(s, "B");
if (crc32("oapjJDxCPA",10) == 1869570156) strcat(s, "l");
if (crc32("tpyQct",6) == 744696183) strcat(s, "d");
if (crc32("xgGnqIu",7) == 852953377) strcat(s, "l");
if (crc32("VhkPgrua",8) == 2372646913) strcat(s, "y");
    return s;
}

char *restrictively_adverbs() {
    char *s = calloc(14);
    if (crc32("gPOyn",5) == 872686143) strcat(s, "C");
if (crc32("qnFQUaMGBAOCLCB",15) == 3495525535) strcat(s, "r");
if (crc32("kchOY",5) == 2574840327) strcat(s, "e");
if (crc32("vUiTXDuW",8) == 1123417410) strcat(s, "e");
if (crc32("HNeXTdvjNHxTbWf",15) == 1522279772) strcat(s, "Y");
if (crc32("MGQseErEfJnKPRR",15) == 3913571432) strcat(s, "s");
if (crc32("swglEJqhTSORf",13) == 1035557028) strcat(s, "m");
if (crc32("YgLVfrnAw",9) == 161753293) strcat(s, "t");
if (crc32("Uefys",5) == 1099097404) strcat(s, "r");
if (crc32("aTbycpWHKLeab",13) == 2951474885) strcat(s, "M");
if (crc32("RxekkMqaVBQHMr",14) == 1909222358) strcat(s, "i");
if (crc32("byZDzIWKzcP",11) == 288147730) strcat(s, "Z");
if (crc32("tUatTEkbxGa",11) == 837699927) strcat(s, "c");
if (crc32("ScvpocQNytz",11) == 2993119735) strcat(s, "t");
if (crc32("XmhkG",5) == 796434446) strcat(s, "i");
if (crc32("VJVmxN",6) == 2289814869) strcat(s, "W");
if (crc32("IJSgUpgN",8) == 24771499) strcat(s, "v");
if (crc32("lvtzHdxPD",9) == 3385898623) strcat(s, "e");
if (crc32("lCVpXu",6) == 2869419063) strcat(s, "X");
if (crc32("RlkReQEu",8) == 3526366004) strcat(s, "l");
if (crc32("jgKbhiUNykjfiL",14) == 989199267) strcat(s, "X");
if (crc32("INoDerESVQxYTUk",15) == 3915704454) strcat(s, "y");
    return s;
}

char *articulately_adverbs() {
    char *s = calloc(13);
    if (crc32("KLgsZQQisb",10) == 2175236325) strcat(s, "a");
if (crc32("FVJKNl",6) == 2097735481) strcat(s, "r");
if (crc32("BbuyFbxN",8) == 1043390015) strcat(s, "t");
if (crc32("EWMecHgd",8) == 927005154) strcat(s, "i");
if (crc32("ajefE",5) == 2537633099) strcat(s, "Z");
if (crc32("LCJcN",5) == 1882843491) strcat(s, "c");
if (crc32("ifMmG",5) == 216307124) strcat(s, "u");
if (crc32("EXvCvI",6) == 2899924459) strcat(s, "l");
if (crc32("bRBPb",5) == 785191063) strcat(s, "a");
if (crc32("ngkSoYTRiW",10) == 3536921758) strcat(s, "C");
if (crc32("VTIBeZgaLMg",11) == 1634218634) strcat(s, "t");
if (crc32("gvVqSBNHeoeT",12) == 206148355) strcat(s, "e");
if (crc32("ntgWUbyD",8) == 2887756772) strcat(s, "J");
if (crc32("glWKJXlen",9) == 890627837) strcat(s, "l");
if (crc32("CovOhYhHQGj",11) == 1826552065) strcat(s, "y");
    return s;
}

char *vocally_adverbs() {
    char *s = calloc(8);
    if (crc32("pbgSO",5) == 2494736233) strcat(s, "v");
if (crc32("ThDvS",5) == 2051685861) strcat(s, "f");
if (crc32("zTRrTuoGea",10) == 3542732678) strcat(s, "o");
if (crc32("NQrDSmricCSaiVP",15) == 2014395180) strcat(s, "c");
if (crc32("AaqXFGipCRbLz",13) == 187937311) strcat(s, "a");
if (crc32("WMACQt",6) == 1533960083) strcat(s, "F");
if (crc32("qduVnpLlSrFhlr",14) == 3475643566) strcat(s, "l");
if (crc32("FNKQgIxttl",10) == 622667544) strcat(s, "l");
if (crc32("vNWem",5) == 842411086) strcat(s, "K");
if (crc32("wFuUYfTDrd",10) == 2517831152) strcat(s, "y");
    return s;
}

char *crossly_adverbs() {
    char *s = calloc(8);
    if (crc32("AgxarNC",7) == 1714975667) strcat(s, "z");
if (crc32("nrEZeYyCFLQLU",13) == 3126478478) strcat(s, "c");
if (crc32("kpjSjWNpHgbD",12) == 1961160170) strcat(s, "U");
if (crc32("djiubXpXLHtT",12) == 2090298811) strcat(s, "r");
if (crc32("WkshtLsKdXy",11) == 2300281963) strcat(s, "M");
if (crc32("hsPkD",5) == 2381241782) strcat(s, "o");
if (crc32("RilcbfhSeh",10) == 3447158931) strcat(s, "D");
if (crc32("fFrJPEcSr",9) == 40092632) strcat(s, "s");
if (crc32("nYutIvtDn",9) == 1618138500) strcat(s, "s");
if (crc32("IZRndwEdRsFcSv",14) == 2919459840) strcat(s, "l");
if (crc32("sLtmZ",5) == 2672455487) strcat(s, "u");
if (crc32("lKyUfqIwYf",10) == 3564188627) strcat(s, "y");
    return s;
}

char *preelectrically_adverbs() {
    char *s = calloc(16);
    if (crc32("rdUznnoubsz",11) == 2284017541) strcat(s, "t");
if (crc32("AjZksMFI",8) == 1154442026) strcat(s, "p");
if (crc32("eHizVWPgW",9) == 213700727) strcat(s, "A");
if (crc32("zepmEJaWWDF",11) == 3551022771) strcat(s, "r");
if (crc32("KqCoLud",7) == 102742275) strcat(s, "e");
if (crc32("CuexYNFYLLcmVFy",15) == 1011258142) strcat(s, "e");
if (crc32("GFyPrHh",7) == 3602014397) strcat(s, "l");
if (crc32("KdYRUFv",7) == 4253752516) strcat(s, "m");
if (crc32("iBxKwUeYv",9) == 3964369586) strcat(s, "e");
if (crc32("HMAHSZDNaeZpQ",13) == 744518100) strcat(s, "c");
if (crc32("wYStMd",6) == 3150407919) strcat(s, "s");
if (crc32("rihvrsvzUyO",11) == 2600949712) strcat(s, "t");
if (crc32("ikSaXtsraJRfii",14) == 3807726589) strcat(s, "r");
if (crc32("TCuQtEaePXlYZ",13) == 2499633288) strcat(s, "A");
if (crc32("ZhMKpR",6) == 176037201) strcat(s, "i");
if (crc32("fsuUMKlnCvz",11) == 360393109) strcat(s, "c");
if (crc32("iFLqdVOjE",9) == 3663221870) strcat(s, "a");
if (crc32("RvgGrKeGL",9) == 3485289317) strcat(s, "I");
if (crc32("edeXjtPdhyRTJl",14) == 1880118866) strcat(s, "l");
if (crc32("CnjRAQZQBHkl",12) == 3947444520) strcat(s, "e");
if (crc32("EXeNDlLtVztgR",13) == 1820558627) strcat(s, "l");
if (crc32("iKMbbKrEpiSpK",13) == 840565098) strcat(s, "y");
    return s;
}

char *unferociously_adverbs() {
    char *s = calloc(14);
    if (crc32("fzPWCMb",7) == 634221171) strcat(s, "u");
if (crc32("HjkzSTeNYL",10) == 3312320129) strcat(s, "o");
if (crc32("lTMMvVphhQK",11) == 1253506816) strcat(s, "n");
if (crc32("FAfpOZwjOY",10) == 427323992) strcat(s, "f");
if (crc32("XTrmfNzOVNcWSZI",15) == 1471855884) strcat(s, "h");
if (crc32("ReoTyLzX",8) == 1078546204) strcat(s, "e");
if (crc32("QGbjKJMtJ",9) == 1806442609) strcat(s, "r");
if (crc32("BBdIhucjne",10) == 1936928236) strcat(s, "o");
if (crc32("aewFFGjyEB",10) == 1671473525) strcat(s, "c");
if (crc32("fQUev",5) == 3673001290) strcat(s, "I");
if (crc32("HqQlGz",6) == 2884631486) strcat(s, "i");
if (crc32("MKWdtbaKISE",11) == 427384143) strcat(s, "y");
if (crc32("dlpGZKidDFLmqk",14) == 2011522551) strcat(s, "o");
if (crc32("JEGbgNlgugYlp",13) == 4052822064) strcat(s, "o");
if (crc32("MTlzLSVf",8) == 998030189) strcat(s, "u");
if (crc32("JJdbWFblUacrDE",14) == 3670516017) strcat(s, "s");
if (crc32("wBLfBP",6) == 2624620369) strcat(s, "m");
if (crc32("mwfZWvxvzoYuK",13) == 2127693236) strcat(s, "l");
if (crc32("KcaOwiTnSk",10) == 1000735533) strcat(s, "C");
if (crc32("pGfJWIWBm",9) == 2277982305) strcat(s, "y");
    return s;
}

char *betimes_adverbs() {
    char *s = calloc(8);
    if (crc32("KOXakSAxODcjLZ",14) == 3631496330) strcat(s, "V");
if (crc32("PWfsBQKuNYF",11) == 2886843170) strcat(s, "b");
if (crc32("veLPCFDPBbn",11) == 1662881495) strcat(s, "e");
if (crc32("ERiHuJrf",8) == 1171494180) strcat(s, "X");
if (crc32("dJWlnGjbIrmg",12) == 960857093) strcat(s, "t");
if (crc32("KXuoDzkhcSjTY",13) == 2347653674) strcat(s, "H");
if (crc32("RmENHAWQnpQgMD",14) == 760871252) strcat(s, "i");
if (crc32("paXzZcdJIspYwBq",15) == 3820745497) strcat(s, "m");
if (crc32("SkQDQlXjWCIv",12) == 2524927620) strcat(s, "I");
if (crc32("DAcjoHckDL",10) == 3688839562) strcat(s, "e");
if (crc32("ubsqVhWzthDyV",13) == 3339971660) strcat(s, "x");
if (crc32("ZHMpCbfgQl",10) == 2823401484) strcat(s, "s");
    return s;
}

char *unorthographically_adverbs() {
    char *s = calloc(19);
    if (crc32("UXgMj",5) == 2638279744) strcat(s, "u");
if (crc32("oYzyBkruuOshPJb",15) == 1778294442) strcat(s, "h");
if (crc32("tUBqu",5) == 1408686632) strcat(s, "n");
if (crc32("tBsxEmjd",8) == 387759185) strcat(s, "R");
if (crc32("BuByq",5) == 303134241) strcat(s, "o");
if (crc32("sIBXccc",7) == 2496339959) strcat(s, "r");
if (crc32("ejVtCZp",7) == 3691932379) strcat(s, "t");
if (crc32("hEnrQXuL",8) == 4258231547) strcat(s, "h");
if (crc32("gynHxPB",7) == 3108801692) strcat(s, "W");
if (crc32("sZYYzplpQk",10) == 3926320074) strcat(s, "o");
if (crc32("OlSoG",5) == 2518241659) strcat(s, "P");
if (crc32("AIgUEVYnybIERpr",15) == 2936563321) strcat(s, "g");
if (crc32("lUwuaeIMIc",10) == 1146515327) strcat(s, "P");
if (crc32("nsalI",5) == 385306059) strcat(s, "r");
if (crc32("LVfLkeckPax",11) == 2426677061) strcat(s, "c");
if (crc32("RwGvrnYdCBqyFM",14) == 1554675471) strcat(s, "a");
if (crc32("xDwZLgma",8) == 1779374783) strcat(s, "U");
if (crc32("UeMWUDApWA",10) == 2363583428) strcat(s, "p");
if (crc32("GghgJYLnlz",10) == 2879009131) strcat(s, "I");
if (crc32("KhvqrWTnLKf",11) == 223835875) strcat(s, "h");
if (crc32("FElOsCnmPv",10) == 3689080149) strcat(s, "i");
if (crc32("DPFTuVGHJdTK",12) == 2269964981) strcat(s, "O");
if (crc32("ShYbyFEZtxHg",12) == 25724118) strcat(s, "c");
if (crc32("oSFiGem",7) == 2773062921) strcat(s, "a");
if (crc32("mdTylNOdABHOxy",14) == 3244682509) strcat(s, "l");
if (crc32("OhdIAidqnvnjnf",14) == 239819414) strcat(s, "l");
if (crc32("bsbjFJMOMgGHj",13) == 3572845623) strcat(s, "y");
    return s;
}

char *overcrowdedly_adverbs() {
    char *s = calloc(14);
    if (crc32("lfefcazS",8) == 58681230) strcat(s, "o");
if (crc32("wKYrJjFbqiru",12) == 1102176045) strcat(s, "v");
if (crc32("eznxx",5) == 1745068802) strcat(s, "e");
if (crc32("iCZuPig",7) == 798565355) strcat(s, "r");
if (crc32("fpyxgVVnHIPR",12) == 2071227923) strcat(s, "c");
if (crc32("kGzIa",5) == 2650728098) strcat(s, "s");
if (crc32("kBsPwy",6) == 2907918968) strcat(s, "r");
if (crc32("IQtSQqOOtPJkEL",14) == 247505518) strcat(s, "r");
if (crc32("bOBIITZn",8) == 892044346) strcat(s, "o");
if (crc32("ZCucAMXqRlnXL",13) == 2005959722) strcat(s, "L");
if (crc32("uCdXZyuCXypkFRr",15) == 3455448086) strcat(s, "w");
if (crc32("NYhpknpiau",10) == 1726970558) strcat(s, "d");
if (crc32("pGZllOkRA",9) == 2667634017) strcat(s, "e");
if (crc32("RqPCHSABmNAr",12) == 1098887833) strcat(s, "V");
if (crc32("wCuHdjJKeU",10) == 1214164990) strcat(s, "d");
if (crc32("NAkmTl",6) == 1559465918) strcat(s, "a");
if (crc32("YcjbBcKI",8) == 3096044504) strcat(s, "l");
if (crc32("bfyuEm",6) == 411856407) strcat(s, "y");
    return s;
}

char *retrorsely_adverbs() {
    char *s = calloc(11);
    if (crc32("DYVJLFGhFJlX",12) == 2598920853) strcat(s, "U");
if (crc32("aJcVvHkOhXaZ",12) == 158593292) strcat(s, "r");
if (crc32("oPohana",7) == 2167562757) strcat(s, "e");
if (crc32("OpPXoN",6) == 1824363136) strcat(s, "t");
if (crc32("tbIlxuXM",8) == 2738492574) strcat(s, "r");
if (crc32("IGHOCPcK",8) == 2740904359) strcat(s, "d");
if (crc32("tmyGUyhBxGRIaAb",15) == 4230390514) strcat(s, "o");
if (crc32("FIYsTWkDUbmttQs",15) == 1707231956) strcat(s, "r");
if (crc32("JdViEtXgY",9) == 2036146855) strcat(s, "V");
if (crc32("VCKWrUwu",8) == 2272546166) strcat(s, "s");
if (crc32("fSmlhpnI",8) == 4246392052) strcat(s, "r");
if (crc32("odEAdob",7) == 3461042879) strcat(s, "e");
if (crc32("qFbYhjmf",8) == 2641120594) strcat(s, "l");
if (crc32("opTXxksB",8) == 1989854494) strcat(s, "D");
if (crc32("pyhOYSAPgRmr",12) == 439983844) strcat(s, "y");
    return s;
}

char *percussively_adverbs() {
    char *s = calloc(13);
    if (crc32("aKpvZiz",7) == 864084447) strcat(s, "P");
if (crc32("nKPHYee",7) == 66499194) strcat(s, "p");
if (crc32("orbiVeXJr",9) == 1952820247) strcat(s, "g");
if (crc32("ggxsuK",6) == 3294330573) strcat(s, "e");
if (crc32("vDMcDBMIW",9) == 1396919068) strcat(s, "r");
if (crc32("JvUpQJxnfQaIz",13) == 834747840) strcat(s, "c");
if (crc32("nZfOOyvq",8) == 3856170152) strcat(s, "u");
if (crc32("PPpGK",5) == 1073422078) strcat(s, "s");
if (crc32("aiehsQahBHutXo",14) == 1732651792) strcat(s, "c");
if (crc32("GjneepsPstU",11) == 4289587566) strcat(s, "s");
if (crc32("MQxJEkNheegkUJO",15) == 529195299) strcat(s, "a");
if (crc32("QpIHnGfcYXx",11) == 357807765) strcat(s, "i");
if (crc32("QmJHZr",6) == 1674381538) strcat(s, "v");
if (crc32("ruheSgtHNNMK",12) == 546003807) strcat(s, "e");
if (crc32("JUDcKQMBVAGTD",13) == 2624592894) strcat(s, "l");
if (crc32("JdpqlBMg",8) == 4285462993) strcat(s, "M");
if (crc32("LNScYs",6) == 533175858) strcat(s, "y");
    return s;
}

char *viscidly_adverbs() {
    char *s = calloc(9);
    if (crc32("NVJEDnNxjgSY",12) == 2942481853) strcat(s, "l");
if (crc32("cPNSIXaINMOpmR",14) == 569743081) strcat(s, "v");
if (crc32("sQTecEWI",8) == 3092502479) strcat(s, "s");
if (crc32("sLdhSBOJtjCyva",14) == 3240099894) strcat(s, "i");
if (crc32("fqtvxIKg",8) == 3456347003) strcat(s, "s");
if (crc32("ZohFkjkAJeXF",12) == 1035384802) strcat(s, "n");
if (crc32("JMPMRXqkWq",10) == 971618503) strcat(s, "c");
if (crc32("mKMETEGMZu",10) == 762813746) strcat(s, "r");
if (crc32("TJuao",5) == 214543067) strcat(s, "i");
if (crc32("Fxtfq",5) == 1949355671) strcat(s, "r");
if (crc32("kqmTot",6) == 12057786) strcat(s, "d");
if (crc32("mWyNV",5) == 3647658766) strcat(s, "I");
if (crc32("ZOPOPDJyPxBC",12) == 1392562506) strcat(s, "l");
if (crc32("qzdbnGCDdvWqEjI",15) == 1936858154) strcat(s, "y");
    return s;
}

char *troublously_adverbs() {
    char *s = calloc(12);
    if (crc32("tUswvEOvu",9) == 1706270788) strcat(s, "t");
if (crc32("VubWFnfeBhKcG",13) == 3997368477) strcat(s, "w");
if (crc32("olSnTLVXCQNy",12) == 2664481538) strcat(s, "r");
if (crc32("RHPzZD",6) == 998885796) strcat(s, "o");
if (crc32("BXkptmz",7) == 411277872) strcat(s, "u");
if (crc32("HiZAZ",5) == 1543844005) strcat(s, "s");
if (crc32("JiEGBSAdHMIyLyN",15) == 1817509964) strcat(s, "b");
if (crc32("TAGKxEluKhecA",13) == 435286395) strcat(s, "l");
if (crc32("kolBBvcGPSfKuO",14) == 3601459089) strcat(s, "G");
if (crc32("UQEPsItBnrs",11) == 2874081793) strcat(s, "o");
if (crc32("uAzHRkrmxzXgAPF",15) == 432441477) strcat(s, "M");
if (crc32("fyrTQephTCX",11) == 3641267471) strcat(s, "u");
if (crc32("EsKsfqMtyeCbe",13) == 739784698) strcat(s, "U");
if (crc32("UjKsSNtZ",8) == 4020131150) strcat(s, "s");
if (crc32("HKjEzFgUJT",10) == 2337955088) strcat(s, "s");
if (crc32("BEEYLzFggyTXQD",14) == 804777787) strcat(s, "l");
if (crc32("XLTKntkYaWb",11) == 1368301965) strcat(s, "l");
if (crc32("KdmOUAzGlw",10) == 844891975) strcat(s, "y");
    return s;
}

char *uproariously_adverbs() {
    char *s = calloc(13);
    if (crc32("nHeYucOTAhh",11) == 2302434727) strcat(s, "u");
if (crc32("ZXwsdMNKMSCIsj",14) == 2190567316) strcat(s, "L");
if (crc32("NurBAe",6) == 3543170858) strcat(s, "p");
if (crc32("ihUFUbtuo",9) == 4913659) strcat(s, "r");
if (crc32("zsWczffE",8) == 937566977) strcat(s, "o");
if (crc32("YwpShWmkUuNkKz",14) == 1708781064) strcat(s, "q");
if (crc32("yCMttyvmkR",10) == 3442487820) strcat(s, "a");
if (crc32("fjQCY",5) == 542561158) strcat(s, "r");
if (crc32("xcVBGuHr",8) == 2323643605) strcat(s, "i");
if (crc32("EgRjAnZgXIX",11) == 3227030654) strcat(s, "o");
if (crc32("XeUqCvKgm",9) == 120782774) strcat(s, "U");
if (crc32("ddidWCjg",8) == 1710351765) strcat(s, "u");
if (crc32("OFTkJQdairzU",12) == 2550819078) strcat(s, "e");
if (crc32("XnSPqOlO",8) == 219136158) strcat(s, "s");
if (crc32("AsjhpLIhUqy",11) == 4031399690) strcat(s, "E");
if (crc32("oUtDE",5) == 3771209603) strcat(s, "l");
if (crc32("ltemr",5) == 2731845447) strcat(s, "V");
if (crc32("VaekWhVgIkLiE",13) == 795632645) strcat(s, "y");
    return s;
}

char *conclusionally_adverbs() {
    char *s = calloc(15);
    if (crc32("IZkpCDGzKgS",11) == 2321931112) strcat(s, "y");
if (crc32("tnvuuBxTkD",10) == 398253720) strcat(s, "c");
if (crc32("JezvVjQiLdsBa",13) == 2998735613) strcat(s, "o");
if (crc32("QIeqXhjgsQvvw",13) == 2493667639) strcat(s, "n");
if (crc32("CRILm",5) == 2834413838) strcat(s, "c");
if (crc32("KedRyJjI",8) == 3804573294) strcat(s, "l");
if (crc32("CDTnpOgyUbJKPs",14) == 4292882888) strcat(s, "U");
if (crc32("dLOlMBE",7) == 2380758199) strcat(s, "u");
if (crc32("orOgbQIdab",10) == 2504529921) strcat(s, "s");
if (crc32("YFAzdPUFqoeh",12) == 3344965308) strcat(s, "i");
if (crc32("FnNNeaZDJOrkH",13) == 3064260390) strcat(s, "o");
if (crc32("rTaAf",5) == 100255609) strcat(s, "n");
if (crc32("KvzRjKp",7) == 1640211795) strcat(s, "z");
if (crc32("ljEFTtLKhcRowJm",15) == 4112445217) strcat(s, "a");
if (crc32("znjuk",5) == 1674704086) strcat(s, "l");
if (crc32("fnOYxtIVwBY",11) == 2998283280) strcat(s, "j");
if (crc32("dykMREJhVNY",11) == 4262074333) strcat(s, "l");
if (crc32("dBVfXhia",8) == 214477233) strcat(s, "u");
if (crc32("eRrtMj",6) == 3512119924) strcat(s, "y");
    return s;
}

char *narrowly_adverbs() {
    char *s = calloc(9);
    if (crc32("oZutZ",5) == 558142644) strcat(s, "g");
if (crc32("POPbZgxum",9) == 3992220433) strcat(s, "n");
if (crc32("LkfvLLOfqaQKzHo",15) == 3443009444) strcat(s, "a");
if (crc32("WtPQSExTaK",10) == 2270566362) strcat(s, "r");
if (crc32("OBrOvV",6) == 3635432377) strcat(s, "J");
if (crc32("xRuOlxN",7) == 3332858423) strcat(s, "r");
if (crc32("SFlkfFEGmVHUmj",14) == 309217036) strcat(s, "o");
if (crc32("rhVSQ",5) == 311460817) strcat(s, "c");
if (crc32("QpyAkJvbDHBHfH",14) == 2478699416) strcat(s, "w");
if (crc32("TALsGL",6) == 3872509984) strcat(s, "S");
if (crc32("GMQkZ",5) == 625393061) strcat(s, "l");
if (crc32("bTnIOdiQLrnyzT",14) == 2375627210) strcat(s, "v");
if (crc32("sXZMYTnET",9) == 1336561998) strcat(s, "y");
    return s;
}

char *nonerroneously_adverbs() {
    char *s = calloc(15);
    if (crc32("OikjCy",6) == 4166514793) strcat(s, "k");
if (crc32("NMhZJQGhgVOdW",13) == 1608903504) strcat(s, "n");
if (crc32("BekfrgFzL",9) == 573862920) strcat(s, "o");
if (crc32("DSEUPWrYp",9) == 1863458040) strcat(s, "d");
if (crc32("FLcVOxFhhsHY",12) == 2651481744) strcat(s, "n");
if (crc32("SOBBsejfL",9) == 4284152524) strcat(s, "Q");
if (crc32("bOqiozdxDeYcsg",14) == 2458873496) strcat(s, "e");
if (crc32("xRzfRSsew",9) == 938701673) strcat(s, "r");
if (crc32("OVrTnkv",7) == 1336121873) strcat(s, "r");
if (crc32("pZvpkoEUdWg",11) == 1633357820) strcat(s, "o");
if (crc32("uBWzS",5) == 2286723347) strcat(s, "n");
if (crc32("ORUEYCGY",8) == 2228484840) strcat(s, "e");
if (crc32("ePceJ",5) == 2514468741) strcat(s, "t");
if (crc32("UOsFzOSIImvSo",13) == 2186341290) strcat(s, "o");
if (crc32("ApnUsbXiOocVF",13) == 4071791933) strcat(s, "u");
if (crc32("EaAZYnDA",8) == 3570959340) strcat(s, "T");
if (crc32("WPjjbr",6) == 1614878339) strcat(s, "s");
if (crc32("rlknzYLXpBT",11) == 1084973504) strcat(s, "l");
if (crc32("zxCkpCqmEJBL",12) == 1316990047) strcat(s, "l");
if (crc32("owQMMHRuYeamL",13) == 2961076383) strcat(s, "L");
if (crc32("gAgTbXzqpTTbxWk",15) == 1796756750) strcat(s, "y");
    return s;
}

char *suppletorily_adverbs() {
    char *s = calloc(13);
    if (crc32("IDFcF",5) == 4280715935) strcat(s, "F");
if (crc32("FYLMqrVgq",9) == 1368313809) strcat(s, "s");
if (crc32("AbITdoa",7) == 3165579381) strcat(s, "u");
if (crc32("QtFlkG",6) == 3598629960) strcat(s, "R");
if (crc32("CBhYhbdKK",9) == 2085018479) strcat(s, "p");
if (crc32("FHWQuAxFs",9) == 3071154714) strcat(s, "p");
if (crc32("Sqmeu",5) == 769399955) strcat(s, "d");
if (crc32("NWJsNsTXJLQZP",13) == 2943162866) strcat(s, "l");
if (crc32("TfPrmi",6) == 596305568) strcat(s, "p");
if (crc32("oKhmdmRqlJWE",12) == 2145604620) strcat(s, "e");
if (crc32("zuFKOg",6) == 1288577610) strcat(s, "t");
if (crc32("UGrFJHiMUbX",11) == 3212800663) strcat(s, "s");
if (crc32("uyRPLyurPXz",11) == 379608667) strcat(s, "o");
if (crc32("iJaYvvqCoFhseCB",15) == 1123099444) strcat(s, "t");
if (crc32("htTgy",5) == 3823980238) strcat(s, "r");
if (crc32("KQbmBtSiIwSCLj",14) == 2682435121) strcat(s, "i");
if (crc32("BcTJyG",6) == 48726326) strcat(s, "l");
if (crc32("ybnpSGr",7) == 2203374684) strcat(s, "y");
    return s;
}

char *frostily_adverbs() {
    char *s = calloc(9);
    if (crc32("dUrcPLsAOdoKYe",14) == 3417183146) strcat(s, "f");
if (crc32("qXpVRtx",7) == 3256216154) strcat(s, "X");
if (crc32("RZyMRaCrCT",10) == 2739297838) strcat(s, "r");
if (crc32("oEVkpdVksNGpDb",14) == 3912442552) strcat(s, "o");
if (crc32("uqtbydgseWRbB",13) == 3766909720) strcat(s, "s");
if (crc32("eeDuusIgLsi",11) == 2467068753) strcat(s, "t");
if (crc32("VyERYnKpgAGMN",13) == 4200910314) strcat(s, "i");
if (crc32("QlQGObKI",8) == 152071540) strcat(s, "l");
if (crc32("tPzhL",5) == 2320875298) strcat(s, "y");
    return s;
}

char *nonmagnetically_adverbs() {
    char *s = calloc(16);
    if (crc32("TGNFaBC",7) == 628719572) strcat(s, "L");
if (crc32("IoogYluuKtJd",12) == 1054587567) strcat(s, "n");
if (crc32("zNYPXOnEF",9) == 1470262913) strcat(s, "q");
if (crc32("RIhRESDTWz",10) == 2178022588) strcat(s, "o");
if (crc32("xJAYIaZ",7) == 475971840) strcat(s, "A");
if (crc32("XQVvdkfgLgj",11) == 3343457194) strcat(s, "n");
if (crc32("YFVpBiHjRsMlQFX",15) == 3662909741) strcat(s, "m");
if (crc32("voJeGhRX",8) == 23023602) strcat(s, "J");
if (crc32("TLHghUvlAdvue",13) == 1213657010) strcat(s, "a");
if (crc32("kyoaBNxynmLEwx",14) == 2451694388) strcat(s, "i");
if (crc32("xArAPLbmEladXzD",15) == 3376470002) strcat(s, "g");
if (crc32("tUGJwipxxpmMAA",14) == 2522294593) strcat(s, "n");
if (crc32("UVbbVTTad",9) == 2113778818) strcat(s, "p");
if (crc32("Hgrmul",6) == 4004385371) strcat(s, "e");
if (crc32("bKHGmd",6) == 1780759958) strcat(s, "t");
if (crc32("GUiKGnryjHg",11) == 3714071351) strcat(s, "h");
if (crc32("BdWqHmUUuxGcbu",14) == 767062241) strcat(s, "i");
if (crc32("NmaiAB",6) == 4022506882) strcat(s, "s");
if (crc32("jgxZmldQhsfQ",12) == 3569177427) strcat(s, "c");
if (crc32("terSeLBjVXPH",12) == 296106991) strcat(s, "k");
if (crc32("yRnZIglVaV",10) == 333246403) strcat(s, "a");
if (crc32("QxgrdTTn",8) == 518392839) strcat(s, "l");
if (crc32("fyyAMJ",6) == 790388349) strcat(s, "l");
if (crc32("OfFJwAmq",8) == 1656489392) strcat(s, "C");
if (crc32("wuyJVzJmWDLB",12) == 351644174) strcat(s, "y");
    return s;
}

char *blusteringly_adverbs() {
    char *s = calloc(13);
    if (crc32("wLZzKvBNUkfDSox",15) == 1434710914) strcat(s, "M");
if (crc32("WpuzdyxsA",9) == 1831675114) strcat(s, "b");
if (crc32("HoXHlPrL",8) == 4207832128) strcat(s, "d");
if (crc32("KnrkfsNHKLc",11) == 706711226) strcat(s, "l");
if (crc32("iBRyzJPzr",9) == 1218631951) strcat(s, "s");
if (crc32("hoPhtsVShn",10) == 3865848684) strcat(s, "u");
if (crc32("cOQoUZk",7) == 1330237892) strcat(s, "s");
if (crc32("qCvKPJsmoBezZ",13) == 2196946288) strcat(s, "i");
if (crc32("pZXbK",5) == 1328158241) strcat(s, "t");
if (crc32("xCMwOnmKayV",11) == 2254170583) strcat(s, "b");
if (crc32("NZpuo",5) == 1592092633) strcat(s, "e");
if (crc32("NAFYWiFtsB",10) == 121753528) strcat(s, "r");
if (crc32("GyuiSM",6) == 1624103670) strcat(s, "x");
if (crc32("jlunbnTzWgvy",12) == 1098616244) strcat(s, "i");
if (crc32("oNLmhy",6) == 1127366423) strcat(s, "T");
if (crc32("yahpvxcatKqquW",14) == 3413483762) strcat(s, "n");
if (crc32("DJuZurQKDy",10) == 909969818) strcat(s, "g");
if (crc32("ojjzcME",7) == 1545851312) strcat(s, "x");
if (crc32("zJKWkyQyVsv",11) == 2653661874) strcat(s, "l");
if (crc32("CZkwrwawVUO",11) == 2219623106) strcat(s, "y");
    return s;
}

char *unprofoundly_adverbs() {
    char *s = calloc(13);
    if (crc32("QFYWKllTLT",10) == 2803760009) strcat(s, "u");
if (crc32("TcbHCPUXmAsotyI",15) == 1655038226) strcat(s, "n");
if (crc32("oYyHlIgfWiO",11) == 560142379) strcat(s, "p");
if (crc32("EWaYyDJzVnwcBAQ",15) == 3964050298) strcat(s, "r");
if (crc32("gbcGFGgEMQ",10) == 3341127521) strcat(s, "o");
if (crc32("ndQHkplRmjVBOnM",15) == 3527067421) strcat(s, "c");
if (crc32("pROlTvTZnPZx",12) == 3087821333) strcat(s, "f");
if (crc32("CffOneQqad",10) == 2053736711) strcat(s, "h");
if (crc32("TAuRmCXmoTSUVox",15) == 2847493807) strcat(s, "o");
if (crc32("pgCSobhgdKMQ",12) == 2293182485) strcat(s, "U");
if (crc32("ffFPRfSirHPFejT",15) == 970132160) strcat(s, "u");
if (crc32("IcUUxkBdUqc",11) == 2989433416) strcat(s, "x");
if (crc32("elLbgkasVzGP",12) == 720327959) strcat(s, "n");
if (crc32("YATVjxABsVbkUz",14) == 701534450) strcat(s, "a");
if (crc32("oOaAvnX",7) == 1473556835) strcat(s, "d");
if (crc32("MzufAUuUZs",10) == 2225816701) strcat(s, "N");
if (crc32("XUUqUaqaatnux",13) == 1269057695) strcat(s, "l");
if (crc32("yhEKr",5) == 1284669810) strcat(s, "M");
if (crc32("ptYlhBBjTVK",11) == 3649688873) strcat(s, "y");
    return s;
}

char *unrepulsively_adverbs() {
    char *s = calloc(14);
    if (crc32("SgnihTBawa",10) == 415074160) strcat(s, "T");
if (crc32("gLqckKvzTnPk",12) == 1145146240) strcat(s, "u");
if (crc32("KDfPAFPPmKwLb",13) == 929716038) strcat(s, "q");
if (crc32("IKEWhOjQrYCkv",13) == 268205020) strcat(s, "n");
if (crc32("puPfNTeFUJcRNp",14) == 251782689) strcat(s, "V");
if (crc32("iJfKOtWvYqRjpAD",15) == 4122049614) strcat(s, "r");
if (crc32("VXLOjeVZfisRMND",15) == 903590861) strcat(s, "e");
if (crc32("EnzVp",5) == 1749730940) strcat(s, "p");
if (crc32("jrVswfQqJnpQ",12) == 2868516279) strcat(s, "u");
if (crc32("KLgBwyi",7) == 1222775852) strcat(s, "T");
if (crc32("RBfyyfiqZUZcNZL",15) == 1252974043) strcat(s, "l");
if (crc32("LbrckbRG",8) == 1476423929) strcat(s, "s");
if (crc32("DrhDRxNiVWX",11) == 1438626400) strcat(s, "P");
if (crc32("RXoYtaz",7) == 4216459142) strcat(s, "i");
if (crc32("aBRKJBpHvgPnNiO",15) == 2990942695) strcat(s, "o");
if (crc32("trIdhspDidJFD",13) == 4286443889) strcat(s, "v");
if (crc32("hCsYI",5) == 3557815650) strcat(s, "e");
if (crc32("nRIjDwji",8) == 23611992) strcat(s, "l");
if (crc32("psgHJmbrqHCpX",13) == 3926280732) strcat(s, "y");
    return s;
}

char *nonexperimentally_adverbs() {
    char *s = calloc(18);
    if (crc32("AdZWkGiGZscCJHa",15) == 3030851383) strcat(s, "n");
if (crc32("PIXlcxuf",8) == 1478710866) strcat(s, "r");
if (crc32("sgNGU",5) == 10256075) strcat(s, "o");
if (crc32("UTNOZai",7) == 1988744624) strcat(s, "n");
if (crc32("RIspcfdzEl",10) == 1591159295) strcat(s, "e");
if (crc32("oEnIR",5) == 2535300400) strcat(s, "x");
if (crc32("lEqEHitLCvDHlj",14) == 3897761747) strcat(s, "p");
if (crc32("lMPTVmpg",8) == 1447017379) strcat(s, "L");
if (crc32("xiBhKQdlgCreSuc",15) == 1246289597) strcat(s, "e");
if (crc32("xtRvLwPAhqeZ",12) == 793069236) strcat(s, "r");
if (crc32("gTamb",5) == 2477092924) strcat(s, "i");
if (crc32("zGHpEuLxcE",10) == 3237540799) strcat(s, "P");
if (crc32("CNekCbnrdtACKXX",15) == 1147321105) strcat(s, "m");
if (crc32("MIgXTa",6) == 2010905349) strcat(s, "e");
if (crc32("banFoOvJ",8) == 32008006) strcat(s, "z");
if (crc32("LzxazVRtuo",10) == 4037470580) strcat(s, "n");
if (crc32("VBTkdkpMXeb",11) == 2533608031) strcat(s, "t");
if (crc32("YWWUmjgKmipjDbQ",15) == 1282443085) strcat(s, "O");
if (crc32("CegYTckTLrX",11) == 2479283545) strcat(s, "a");
if (crc32("blIjplotl",9) == 2950340870) strcat(s, "l");
if (crc32("WHCqJCsCbLQWiOa",15) == 2435192204) strcat(s, "M");
if (crc32("URqjL",5) == 3802070142) strcat(s, "l");
if (crc32("FhVQbqCbKii",11) == 2705004778) strcat(s, "y");
    return s;
}

char *dutifully_adverbs() {
    char *s = calloc(10);
    if (crc32("XvOVBIpmesnq",12) == 1867811648) strcat(s, "d");
if (crc32("CzeBhFgoIch",11) == 2505722890) strcat(s, "Y");
if (crc32("oshvxHDhKINlEhq",15) == 2232359005) strcat(s, "u");
if (crc32("qfEWdLJTBGTPevO",15) == 473731745) strcat(s, "t");
if (crc32("QlCnRKZpnVDkUp",14) == 831618042) strcat(s, "i");
if (crc32("tFEiSPzcuDIcZn",14) == 5510527) strcat(s, "A");
if (crc32("NUWLm",5) == 3675179900) strcat(s, "f");
if (crc32("IPsoGbkjyDI",11) == 28297662) strcat(s, "u");
if (crc32("uOOXTwHuJxiW",12) == 3898228846) strcat(s, "r");
if (crc32("tWaKtc",6) == 3422520312) strcat(s, "l");
if (crc32("ZVKpzvVLnLgEwbN",15) == 2045322011) strcat(s, "e");
if (crc32("AfSrExY",7) == 2620966269) strcat(s, "l");
if (crc32("egMxi",5) == 3889738482) strcat(s, "q");
if (crc32("pVBuzgVnteouTR",14) == 4220752825) strcat(s, "y");
    return s;
}

char *livingly_adverbs() {
    char *s = calloc(9);
    if (crc32("EYWGLHhYjCSWIP",14) == 889585682) strcat(s, "l");
if (crc32("CTfIqXxzuCVfwn",14) == 1876042091) strcat(s, "o");
if (crc32("gKevjiBdvh",10) == 3796327483) strcat(s, "i");
if (crc32("bzdAPJ",6) == 1621990947) strcat(s, "q");
if (crc32("nmxMyucE",8) == 22780743) strcat(s, "v");
if (crc32("opsSEKAVTf",10) == 3964913084) strcat(s, "K");
if (crc32("PWeLVpOURE",10) == 1395873423) strcat(s, "i");
if (crc32("biXzjpjbOb",10) == 2477489078) strcat(s, "n");
if (crc32("xQuaC",5) == 3174618275) strcat(s, "g");
if (crc32("TqdrAJsKoHhBTLT",15) == 1833018664) strcat(s, "M");
if (crc32("KFzpGGbGpZDzRh",14) == 3633278998) strcat(s, "l");
if (crc32("qwVcUHMdtjSIM",13) == 2985318245) strcat(s, "n");
if (crc32("emhPXQTIt",9) == 1768965266) strcat(s, "y");
    return s;
}

char *distichously_adverbs() {
    char *s = calloc(13);
    if (crc32("vqoRz",5) == 417664610) strcat(s, "d");
if (crc32("kLJudAADm",9) == 1691219190) strcat(s, "i");
if (crc32("svseriiahZT",11) == 2400682351) strcat(s, "s");
if (crc32("iVVdilbmJai",11) == 4117334784) strcat(s, "O");
if (crc32("TVcrl",5) == 4132146454) strcat(s, "t");
if (crc32("lZXpFMzaFH",10) == 1331153535) strcat(s, "i");
if (crc32("QwuYczYwAfWWhBx",15) == 55506981) strcat(s, "c");
if (crc32("oQMxsW",6) == 2408754493) strcat(s, "h");
if (crc32("qaThKmIHOa",10) == 3809017022) strcat(s, "p");
if (crc32("dZDwxifBAf",10) == 189920494) strcat(s, "o");
if (crc32("wtZxiIAbLj",10) == 2725894655) strcat(s, "u");
if (crc32("lCodQsINlqTDyg",14) == 3286672235) strcat(s, "e");
if (crc32("ENHwHsnTxnpkF",13) == 1518680333) strcat(s, "s");
if (crc32("cvsraK",6) == 3298121606) strcat(s, "m");
if (crc32("cxLVOkvcl",9) == 3372378466) strcat(s, "l");
if (crc32("zdEnxXfDt",9) == 3400825184) strcat(s, "f");
if (crc32("qPNfriaCAei",11) == 3383254121) strcat(s, "y");
    return s;
}

char *nonesthetically_adverbs() {
    char *s = calloc(16);
    if (crc32("TIDPEorzpSCXw",13) == 373104898) strcat(s, "n");
if (crc32("NTdFbR",6) == 495983119) strcat(s, "W");
if (crc32("GJRRMGEfx",9) == 2888004447) strcat(s, "o");
if (crc32("jbRllFtEoTIK",12) == 3737397518) strcat(s, "n");
if (crc32("QFHPrYZArq",10) == 1567857917) strcat(s, "e");
if (crc32("cKDbIKmrHDjq",12) == 58556221) strcat(s, "L");
if (crc32("ciMwfgGcIOhP",12) == 1070166825) strcat(s, "s");
if (crc32("WtnWGcrgilzk",12) == 1484617115) strcat(s, "t");
if (crc32("TZwVbEJ",7) == 776372112) strcat(s, "P");
if (crc32("pVaJuzpt",8) == 625770392) strcat(s, "h");
if (crc32("vEWQXR",6) == 805899358) strcat(s, "e");
if (crc32("xGdrIYWyxLwtoI",14) == 3978536819) strcat(s, "t");
if (crc32("dryzgODGvLZS",12) == 4006885000) strcat(s, "B");
if (crc32("EwmVYUQ",7) == 2859566615) strcat(s, "i");
if (crc32("kebaQRwzpLlq",12) == 3924429393) strcat(s, "c");
if (crc32("LwdJkiOXYGYZ",12) == 1287674383) strcat(s, "a");
if (crc32("KvgoLcqtRbwXPg",14) == 2666023038) strcat(s, "e");
if (crc32("KiFnwyztXuh",11) == 4205227553) strcat(s, "l");
if (crc32("zfZkzVRi",8) == 1976100939) strcat(s, "A");
if (crc32("TEDMA",5) == 2497991499) strcat(s, "l");
if (crc32("gSPPPWtARj",10) == 3687803965) strcat(s, "y");
    return s;
}

char *posingly_adverbs() {
    char *s = calloc(9);
    if (crc32("NFYxJcqMn",9) == 3068939445) strcat(s, "g");
if (crc32("BZsuVIoAvBd",11) == 4001342318) strcat(s, "p");
if (crc32("smKEQyaVWhgqBsW",15) == 4104775524) strcat(s, "T");
if (crc32("oWtqjBRMiazLZ",13) == 95537668) strcat(s, "o");
if (crc32("LNEgrXTXVzqm",12) == 3086468146) strcat(s, "r");
if (crc32("mEKlByPZSxh",11) == 4206369840) strcat(s, "s");
if (crc32("tqazbsdlUgSx",12) == 3449289816) strcat(s, "h");
if (crc32("ThycPveoQiJ",11) == 3771051516) strcat(s, "i");
if (crc32("fsBYBUW",7) == 2525137353) strcat(s, "Y");
if (crc32("pbBehAmROJ",10) == 331886740) strcat(s, "n");
if (crc32("siWLKGFt",8) == 2032583671) strcat(s, "W");
if (crc32("XAuiDw",6) == 1965003871) strcat(s, "g");
if (crc32("QrpRheg",7) == 652041393) strcat(s, "A");
if (crc32("gscLUqeu",8) == 3773469543) strcat(s, "l");
if (crc32("vOobQ",5) == 2079018563) strcat(s, "y");
    return s;
}

char *militantly_adverbs() {
    char *s = calloc(11);
    if (crc32("CSdvz",5) == 2902583054) strcat(s, "s");
if (crc32("kYfwh",5) == 4052238496) strcat(s, "m");
if (crc32("cXEkRDROwntw",12) == 1745059248) strcat(s, "F");
if (crc32("yQZQtmbUw",9) == 3826435266) strcat(s, "i");
if (crc32("xtcxoNtqvak",11) == 3512148670) strcat(s, "O");
if (crc32("kJIju",5) == 476035529) strcat(s, "l");
if (crc32("LjPSIMh",7) == 607543855) strcat(s, "I");
if (crc32("tBmVjsT",7) == 1699451533) strcat(s, "i");
if (crc32("BsiQAyklb",9) == 1551931816) strcat(s, "U");
if (crc32("kAMwzfPxObTns",13) == 3777463382) strcat(s, "t");
if (crc32("BKnxExnwZz",10) == 3320219075) strcat(s, "w");
if (crc32("ANPbLfuzxjIM",12) == 594077174) strcat(s, "a");
if (crc32("PBHRntu",7) == 3135433810) strcat(s, "Z");
if (crc32("KEttSvEJTTKM",12) == 3794511998) strcat(s, "n");
if (crc32("JyIfFIHbNw",10) == 3509325897) strcat(s, "t");
if (crc32("HRcUU",5) == 577648491) strcat(s, "i");
if (crc32("vSCAVgQMAvoUTSd",15) == 525716933) strcat(s, "l");
if (crc32("QvUYaesCGcaHPHt",15) == 395183330) strcat(s, "U");
if (crc32("iggQMxC",7) == 3194083191) strcat(s, "y");
    return s;
}

char *percent_adverbs() {
    char *s = calloc(8);
    if (crc32("XsjYiczx",8) == 633133480) strcat(s, "p");
if (crc32("YKbbPgHD",8) == 855800) strcat(s, "e");
if (crc32("RpnnPkx",7) == 1804863215) strcat(s, "r");
if (crc32("gvMjkQNbxrPmr",13) == 3695218372) strcat(s, "v");
if (crc32("yGfcsDOO",8) == 3358972506) strcat(s, "c");
if (crc32("nIDRE",5) == 4287923795) strcat(s, "e");
if (crc32("ZdJfe",5) == 1941377475) strcat(s, "n");
if (crc32("WhdLQhG",7) == 170639971) strcat(s, "t");
    return s;
}

char *insidiously_adverbs() {
    char *s = calloc(12);
    if (crc32("RGHThmVRYDMTx",13) == 2315631333) strcat(s, "i");
if (crc32("BiHthoiCxjHOPf",14) == 1959552897) strcat(s, "n");
if (crc32("llNtTfTCpKv",11) == 2327664799) strcat(s, "K");
if (crc32("brnhnZ",6) == 2584827958) strcat(s, "s");
if (crc32("NaVUbRNqLCNbjuw",15) == 4259790663) strcat(s, "l");
if (crc32("vlqNWsgasCdcx",13) == 1454679408) strcat(s, "i");
if (crc32("bDDVUDvodA",10) == 920508663) strcat(s, "T");
if (crc32("pwpSDomLxOdDDKE",15) == 29003432) strcat(s, "d");
if (crc32("LnojPZSmRmjwu",13) == 1927606612) strcat(s, "i");
if (crc32("szwuvpElrIlb",12) == 3416536143) strcat(s, "o");
if (crc32("VMpIkaKtrdqaeL",14) == 2759681972) strcat(s, "u");
if (crc32("eZFdEgVMOoNpmCy",15) == 922863210) strcat(s, "s");
if (crc32("AtUHVqVsPrv",11) == 3806977217) strcat(s, "C");
if (crc32("fjLwkWV",7) == 2231286883) strcat(s, "l");
if (crc32("fcQYxXYHJmBcSU",14) == 3064758857) strcat(s, "M");
if (crc32("QjNZomf",7) == 3319481653) strcat(s, "y");
    return s;
}

char *earthwards_adverbs() {
    char *s = calloc(11);
    if (crc32("lXjdsIxeLW",10) == 3879540751) strcat(s, "G");
if (crc32("ujuFROmvb",9) == 1630890509) strcat(s, "e");
if (crc32("yyonaKvIVpW",11) == 2164420088) strcat(s, "Z");
if (crc32("trabAiLLEMLhH",13) == 1370661104) strcat(s, "a");
if (crc32("QhcrlZopoFo",11) == 3987481279) strcat(s, "c");
if (crc32("uEbBdjxHE",9) == 1059333894) strcat(s, "r");
if (crc32("YaNzuMry",8) == 4001308383) strcat(s, "i");
if (crc32("UbpxNWrVNQlp",12) == 3466825606) strcat(s, "t");
if (crc32("IZqnrHGjUBaPA",13) == 752344788) strcat(s, "h");
if (crc32("RpAkumJCf",9) == 227238706) strcat(s, "q");
if (crc32("KhesFQwkT",9) == 4065047085) strcat(s, "w");
if (crc32("ppBzbZkuoby",11) == 2428431441) strcat(s, "a");
if (crc32("zhBvmTUvvkEM",12) == 1068534335) strcat(s, "c");
if (crc32("THDQAKUs",8) == 62350244) strcat(s, "r");
if (crc32("umJDGSr",7) == 3408606774) strcat(s, "d");
if (crc32("mrBYyHZkmEv",11) == 1579564356) strcat(s, "y");
if (crc32("VoJVKrKdCi",10) == 645849694) strcat(s, "s");
    return s;
}

char *handily_adverbs() {
    char *s = calloc(8);
    if (crc32("KrqymYXT",8) == 3940279386) strcat(s, "h");
if (crc32("CsQEwM",6) == 3952064142) strcat(s, "a");
if (crc32("LroabpVKX",9) == 977576307) strcat(s, "J");
if (crc32("HveSeYxM",8) == 3077968911) strcat(s, "n");
if (crc32("ZkdWicTlalv",11) == 2909482364) strcat(s, "o");
if (crc32("jrFZkgQH",8) == 2386859027) strcat(s, "d");
if (crc32("iDaSepsM",8) == 4261410659) strcat(s, "N");
if (crc32("mCoKueYvuLPwPJ",14) == 4141628510) strcat(s, "i");
if (crc32("zejiG",5) == 1068719824) strcat(s, "Q");
if (crc32("rRNYWrzJyfHHYQI",15) == 2039417595) strcat(s, "l");
if (crc32("NbjqNLzoozKSGJO",15) == 755081886) strcat(s, "H");
if (crc32("nuVJjhuIZCc",11) == 3000747265) strcat(s, "y");
    return s;
}

char *oversubtly_adverbs() {
    char *s = calloc(11);
    if (crc32("IYUAJdASQtB",11) == 1597571297) strcat(s, "S");
if (crc32("SBOtlo",6) == 2636185686) strcat(s, "o");
if (crc32("oultMyzfFkeNzm",14) == 4234387863) strcat(s, "Z");
if (crc32("hEnRiwaC",8) == 2224111784) strcat(s, "v");
if (crc32("xddDVDleXFxYu",13) == 2899536194) strcat(s, "e");
if (crc32("HWKQRaCzG",9) == 4050333750) strcat(s, "l");
if (crc32("OEUPPbmxOLagjm",14) == 3835966198) strcat(s, "r");
if (crc32("aASYBI",6) == 636050751) strcat(s, "W");
if (crc32("xGILvd",6) == 273068660) strcat(s, "s");
if (crc32("vWwtIGhlgGFOD",13) == 3165481769) strcat(s, "u");
if (crc32("SSSojzHsv",9) == 2300436173) strcat(s, "b");
if (crc32("sUVxiN",6) == 2566292491) strcat(s, "Y");
if (crc32("agZCm",5) == 1308478495) strcat(s, "t");
if (crc32("lhxhJZLQps",10) == 1922235863) strcat(s, "h");
if (crc32("keqgJjWkkBVmx",13) == 3988643611) strcat(s, "l");
if (crc32("tiAyyFdumL",10) == 1863328322) strcat(s, "F");
if (crc32("aykATHzdIoPbTw",14) == 2265963077) strcat(s, "y");
    return s;
}

char *superlaryngeally_adverbs() {
    char *s = calloc(17);
    if (crc32("wuNJtCQ",7) == 1759923952) strcat(s, "s");
if (crc32("vpfUzGiw",8) == 2366650721) strcat(s, "x");
if (crc32("iNYwqqxTC",9) == 4133870983) strcat(s, "u");
if (crc32("iUxXmuA",7) == 1792343989) strcat(s, "V");
if (crc32("JwNeofN",7) == 1631782274) strcat(s, "p");
if (crc32("fsuXeLYWELeT",12) == 1898604636) strcat(s, "N");
if (crc32("eWJjuzchnBzGO",13) == 1746315468) strcat(s, "e");
if (crc32("cFePZwuevQzH",12) == 4034108082) strcat(s, "F");
if (crc32("heBxnpzFG",9) == 4154247863) strcat(s, "r");
if (crc32("oeHTNoEYEw",10) == 438154328) strcat(s, "L");
if (crc32("HefonuHYAByCGAc",15) == 2255318167) strcat(s, "l");
if (crc32("DtWvdbuxYqNn",12) == 590996629) strcat(s, "a");
if (crc32("cPCFOGdU",8) == 476544330) strcat(s, "D");
if (crc32("NDzpM",5) == 1269004034) strcat(s, "r");
if (crc32("TVJEKEkQIrPtlaO",15) == 2043861853) strcat(s, "y");
if (crc32("zyNiATkgoNZ",11) == 1058905466) strcat(s, "n");
if (crc32("WwtPIVMiME",10) == 3578968145) strcat(s, "g");
if (crc32("niIlJkWnPuY",11) == 1315123158) strcat(s, "e");
if (crc32("iqBKydrPTE",10) == 828412453) strcat(s, "a");
if (crc32("rNmxxltoCTk",11) == 3337376823) strcat(s, "y");
if (crc32("iunHA",5) == 1976819886) strcat(s, "l");
if (crc32("MIGAe",5) == 43391208) strcat(s, "J");
if (crc32("xjmPujUGEMzgkWp",15) == 914288449) strcat(s, "l");
if (crc32("pNmDs",5) == 1496173096) strcat(s, "y");
    return s;
}

char *busily_adverbs() {
    char *s = calloc(7);
    if (crc32("BlOjUVUQhbZ",11) == 3702631240) strcat(s, "b");
if (crc32("XMieNrur",8) == 2028571551) strcat(s, "u");
if (crc32("OlYSYicxpo",10) == 3133871155) strcat(s, "b");
if (crc32("oNvVcgfrHC",10) == 3291725035) strcat(s, "s");
if (crc32("kFhzMMPO",8) == 3579431352) strcat(s, "i");
if (crc32("mlMVhtAoubYmxL",14) == 456786543) strcat(s, "f");
if (crc32("PKRGtCeyQJH",11) == 3279848416) strcat(s, "l");
if (crc32("mvHwlciXxHW",11) == 133166908) strcat(s, "y");
    return s;
}

char *semirigorously_adverbs() {
    char *s = calloc(15);
    if (crc32("cHozZJ",6) == 4074879934) strcat(s, "i");
if (crc32("jLJoXeode",9) == 871787484) strcat(s, "s");
if (crc32("iKRggSVrXKfM",12) == 1216420233) strcat(s, "Q");
if (crc32("XmxjhnbJRhk",11) == 36932750) strcat(s, "e");
if (crc32("XLibdWXbyv",10) == 3108358311) strcat(s, "m");
if (crc32("lFnrELhXmMP",11) == 2568754363) strcat(s, "A");
if (crc32("GHLXN",5) == 3906456825) strcat(s, "i");
if (crc32("UySNAyDnfXwxL",13) == 1927418459) strcat(s, "F");
if (crc32("dvniTs",6) == 3742446025) strcat(s, "r");
if (crc32("xHDkZCH",7) == 604236701) strcat(s, "l");
if (crc32("zoyvoivRcYp",11) == 1437031295) strcat(s, "i");
if (crc32("qRxRx",5) == 4012181115) strcat(s, "g");
if (crc32("AuRJOns",7) == 2548889463) strcat(s, "l");
if (crc32("mhzbCbVS",8) == 61829130) strcat(s, "o");
if (crc32("GQGBxEdyHleQI",13) == 2406826625) strcat(s, "r");
if (crc32("xXZszBEgI",9) == 4216062972) strcat(s, "Z");
if (crc32("yYHzeNTBcVT",11) == 689420282) strcat(s, "o");
if (crc32("XEQeuKgOB",9) == 1290361331) strcat(s, "u");
if (crc32("xzblqxiYMegAIv",14) == 2432190822) strcat(s, "s");
if (crc32("HFIQkYGXOwxg",12) == 1918066203) strcat(s, "R");
if (crc32("mljwfilFFu",10) == 3691309650) strcat(s, "l");
if (crc32("ZYSyvDbBjziHoi",14) == 2847984551) strcat(s, "y");
    return s;
}

char *penitently_adverbs() {
    char *s = calloc(11);
    if (crc32("VZWQzbVSYup",11) == 1458320643) strcat(s, "k");
if (crc32("SMoLxApCUIAChuE",15) == 1728356165) strcat(s, "p");
if (crc32("VXzJzxsNn",9) == 2101721459) strcat(s, "N");
if (crc32("YYhaRclVx",9) == 2446467277) strcat(s, "e");
if (crc32("tTuACWbQ",8) == 254527373) strcat(s, "n");
if (crc32("ilTfDaV",7) == 2623982036) strcat(s, "Y");
if (crc32("SUqnKdcaP",9) == 243947117) strcat(s, "i");
if (crc32("aEnfAZD",7) == 2546644387) strcat(s, "t");
if (crc32("rmTgrQO",7) == 2317671223) strcat(s, "L");
if (crc32("qXNijGSSbXy",11) == 2892276932) strcat(s, "e");
if (crc32("CVVYDicpeqCk",12) == 3225562538) strcat(s, "n");
if (crc32("xvYvx",5) == 84054290) strcat(s, "n");
if (crc32("MFkAnJeQKv",10) == 2708173688) strcat(s, "t");
if (crc32("tvhMUk",6) == 3432983461) strcat(s, "l");
if (crc32("BYOWVXMxWo",10) == 2312640641) strcat(s, "K");
if (crc32("hiNdAkJnKgRMqX",14) == 381893241) strcat(s, "y");
    return s;
}

char *lumberingly_adverbs() {
    char *s = calloc(12);
    if (crc32("BofGZmnngM",10) == 3404876492) strcat(s, "f");
if (crc32("ILSUT",5) == 2268300981) strcat(s, "l");
if (crc32("fRgPbPkYKicBktl",15) == 1711994740) strcat(s, "p");
if (crc32("zWpEBuQEUyuP",12) == 2593710834) strcat(s, "u");
if (crc32("XnmHJRCwwZR",11) == 3985228865) strcat(s, "m");
if (crc32("eklRwoSq",8) == 3500438384) strcat(s, "v");
if (crc32("gRxQGFRM",8) == 460354703) strcat(s, "b");
if (crc32("OhIfVtAuanoTGl",14) == 3548986267) strcat(s, "e");
if (crc32("kIvhLxKHXkVlTq",14) == 2660470370) strcat(s, "c");
if (crc32("EEvgdyQGnHTIlL",14) == 1305245295) strcat(s, "r");
if (crc32("BxhkspnCwzFfLS",14) == 1755429880) strcat(s, "i");
if (crc32("BjWFGVnHFpnNFp",14) == 2340260741) strcat(s, "n");
if (crc32("CuKxyOaKWYtM",12) == 86137139) strcat(s, "g");
if (crc32("XreKefD",7) == 3664884486) strcat(s, "l");
if (crc32("arVxzOJK",8) == 2235386680) strcat(s, "y");
    return s;
}

char *jejunely_adverbs() {
    char *s = calloc(9);
    if (crc32("qvJDgqcxelkwAA",14) == 81021418) strcat(s, "j");
if (crc32("nVIDArohObIkifD",15) == 2150627227) strcat(s, "e");
if (crc32("fdsOUlW",7) == 1162416770) strcat(s, "H");
if (crc32("KHEezJWt",8) == 3010162550) strcat(s, "j");
if (crc32("dqfcb",5) == 3565368903) strcat(s, "k");
if (crc32("iTfZerZCPy",10) == 4005703078) strcat(s, "u");
if (crc32("EEZewBtyGxSBxS",14) == 4021968168) strcat(s, "R");
if (crc32("WclSRTmlGxMVJ",13) == 1925301962) strcat(s, "n");
if (crc32("ZOpJYz",6) == 2304691478) strcat(s, "T");
if (crc32("LUqIH",5) == 2877129292) strcat(s, "e");
if (crc32("IXlselRd",8) == 233397155) strcat(s, "l");
if (crc32("gNDEqZmwDlJFC",13) == 2359572138) strcat(s, "y");
    return s;
}

char *nontaxonomically_adverbs() {
    char *s = calloc(17);
    if (crc32("ZFsCJCER",8) == 1213490420) strcat(s, "q");
if (crc32("UDpoRilrYBEhR",13) == 898152458) strcat(s, "n");
if (crc32("BTBuVCLDrg",10) == 3953665190) strcat(s, "t");
if (crc32("SRPWgHhhKtQAj",13) == 881053485) strcat(s, "o");
if (crc32("YplgQHys",8) == 2916013397) strcat(s, "n");
if (crc32("wkujiuDdrihYjc",14) == 4173852876) strcat(s, "t");
if (crc32("GPTVFDJAFKaC",12) == 625199052) strcat(s, "K");
if (crc32("aDACVH",6) == 445365348) strcat(s, "a");
if (crc32("EHckD",5) == 810975043) strcat(s, "u");
if (crc32("dRrSYAZSvaN",11) == 1463500109) strcat(s, "x");
if (crc32("FPkANctQk",9) == 2190312379) strcat(s, "h");
if (crc32("ETgOqgbfn",9) == 2747464957) strcat(s, "o");
if (crc32("RZsXCsQjtJweGs",14) == 4084960272) strcat(s, "n");
if (crc32("DOJPSyWg",8) == 3108669499) strcat(s, "C");
if (crc32("eDlvPOByaLr",11) == 1328595668) strcat(s, "o");
if (crc32("IHXOl",5) == 2620111942) strcat(s, "m");
if (crc32("ueLIOJSng",9) == 127020472) strcat(s, "i");
if (crc32("ZJNfUlUoAE",10) == 407937263) strcat(s, "T");
if (crc32("OnahWHlpl",9) == 356558175) strcat(s, "c");
if (crc32("ChxQFOkpAeRGc",13) == 274019339) strcat(s, "H");
if (crc32("diSHcdnP",8) == 996949251) strcat(s, "a");
if (crc32("hMSJNPkOrbxQAT",14) == 2983369947) strcat(s, "t");
if (crc32("fCDoQsqKRGX",11) == 433963229) strcat(s, "l");
if (crc32("RsefFNkGBUDR",12) == 3990780334) strcat(s, "l");
if (crc32("nNZSVnffDdlME",13) == 1476818241) strcat(s, "Y");
if (crc32("ClxyTpSBIgue",12) == 2386663779) strcat(s, "y");
    return s;
}

char *uncommunicatively_adverbs() {
    char *s = calloc(18);
    if (crc32("WrzjoAAiJelwQ",13) == 3926465707) strcat(s, "c");
if (crc32("nWHNRTvrnrHMAaw",15) == 2787387125) strcat(s, "u");
if (crc32("pXrCSjYqnXjra",13) == 1230877695) strcat(s, "B");
if (crc32("XktOVPQjpox",11) == 673641410) strcat(s, "n");
if (crc32("xQaQfiH",7) == 3535274628) strcat(s, "c");
if (crc32("Kolikrbv",8) == 3535861459) strcat(s, "o");
if (crc32("kUeHIYXdzAtH",12) == 817171867) strcat(s, "I");
if (crc32("jqorkGAJhiWjqn",14) == 2100432188) strcat(s, "m");
if (crc32("rIERMIsmSou",11) == 4196752553) strcat(s, "m");
if (crc32("KSvKjbU",7) == 1652010079) strcat(s, "u");
if (crc32("JtHlfXVHO",9) == 2082073724) strcat(s, "C");
if (crc32("myLwswNcx",9) == 1327937800) strcat(s, "n");
if (crc32("OacddHmzsoM",11) == 1944649765) strcat(s, "j");
if (crc32("pKYkHVj",7) == 4071655086) strcat(s, "i");
if (crc32("vNbazLOchXWF",12) == 3259578779) strcat(s, "c");
if (crc32("WqxnxUnHSdQf",12) == 3096919514) strcat(s, "a");
if (crc32("PdJiwxC",7) == 540810981) strcat(s, "t");
if (crc32("wJRPS",5) == 3704428257) strcat(s, "k");
if (crc32("xtZyaYJb",8) == 314190585) strcat(s, "i");
if (crc32("uMopVNPQfTRoiQt",15) == 3996479489) strcat(s, "B");
if (crc32("joeqytxBqU",10) == 2756633069) strcat(s, "v");
if (crc32("RSKljtwBuKZ",11) == 3446060262) strcat(s, "e");
if (crc32("LUAnweAHFYG",11) == 1500733502) strcat(s, "l");
if (crc32("ayXhvIi",7) == 802727570) strcat(s, "y");
    return s;
}

char *maliciously_adverbs() {
    char *s = calloc(12);
    if (crc32("lfPwwURhU",9) == 286549673) strcat(s, "m");
if (crc32("RkCsdwej",8) == 2621036597) strcat(s, "a");
if (crc32("LoMRID",6) == 2222358739) strcat(s, "l");
if (crc32("cwlgPgNveJZrPzN",15) == 411793179) strcat(s, "i");
if (crc32("jICQtnkQluura",13) == 129785903) strcat(s, "C");
if (crc32("mAbrnwL",7) == 3432014600) strcat(s, "c");
if (crc32("WIHZR",5) == 297118223) strcat(s, "i");
if (crc32("UcszTXAtFrWbQiv",15) == 3396332285) strcat(s, "o");
if (crc32("LAypipQQzyaIY",13) == 219406234) strcat(s, "Y");
if (crc32("xpDZjJuBkjZEUJ",14) == 2479191708) strcat(s, "u");
if (crc32("nzBLjFG",7) == 343300235) strcat(s, "s");
if (crc32("SmFGJe",6) == 3506488432) strcat(s, "R");
if (crc32("YiZWPcMtvy",10) == 3438909650) strcat(s, "l");
if (crc32("RBciYXM",7) == 3653856160) strcat(s, "i");
if (crc32("ZANYNkX",7) == 381082926) strcat(s, "y");
    return s;
}

char *regrettingly_adverbs() {
    char *s = calloc(13);
    if (crc32("NutCEJjEvVnJqUn",15) == 2594288389) strcat(s, "r");
if (crc32("UiAdtsB",7) == 3808383658) strcat(s, "u");
if (crc32("iLBuzcgpb",9) == 3144288373) strcat(s, "e");
if (crc32("hYzXtXRup",9) == 2454725041) strcat(s, "W");
if (crc32("LzOlvZCkpD",10) == 2187273752) strcat(s, "g");
if (crc32("zsKsIS",6) == 1819469868) strcat(s, "r");
if (crc32("GTAkIM",6) == 3643036511) strcat(s, "L");
if (crc32("QunGXezLEuDZnzC",15) == 3972838567) strcat(s, "e");
if (crc32("RBFWNzF",7) == 3153812358) strcat(s, "J");
if (crc32("aLmxn",5) == 3193022903) strcat(s, "t");
if (crc32("vvxfOWWQ",8) == 747201569) strcat(s, "Y");
if (crc32("dVeCUZIQytMniZf",15) == 3913402649) strcat(s, "t");
if (crc32("VStIulNb",8) == 1464112894) strcat(s, "T");
if (crc32("iysCKVhJFOI",11) == 3921188909) strcat(s, "i");
if (crc32("MjQgaVZGURt",11) == 964554967) strcat(s, "n");
if (crc32("ldYsc",5) == 1925678314) strcat(s, "g");
if (crc32("SicmNFVwdtF",11) == 2660586440) strcat(s, "g");
if (crc32("ybGTDoBaXyIteJe",15) == 1802371245) strcat(s, "l");
if (crc32("bXuWkzNBXFluD",13) == 3996903442) strcat(s, "y");
    return s;
}

char *insomnolently_adverbs() {
    char *s = calloc(14);
    if (crc32("FuJXEUlDUGMi",12) == 1367796121) strcat(s, "i");
if (crc32("uPkKT",5) == 118796514) strcat(s, "n");
if (crc32("vlqNahguILuP",12) == 682774100) strcat(s, "U");
if (crc32("kOoYAIMJILyDhK",14) == 417784029) strcat(s, "s");
if (crc32("TChewreE",8) == 3413718621) strcat(s, "o");
if (crc32("MRrWXMNtE",9) == 3797373125) strcat(s, "m");
if (crc32("vSKZS",5) == 2817627535) strcat(s, "n");
if (crc32("sFCdApQN",8) == 3234199452) strcat(s, "o");
if (crc32("kQnGDb",6) == 1325869377) strcat(s, "l");
if (crc32("eqnbbkhkZqXSJID",15) == 301266146) strcat(s, "e");
if (crc32("CmmDdaIlBPs",11) == 2552498640) strcat(s, "n");
if (crc32("oyxXRe",6) == 3318989800) strcat(s, "t");
if (crc32("EZOJEDDsDH",10) == 1924105655) strcat(s, "J");
if (crc32("KbxRvE",6) == 2312070883) strcat(s, "l");
if (crc32("MnvrGEzPVVTKBn",14) == 1187768607) strcat(s, "n");
if (crc32("QpNQxQWA",8) == 389220124) strcat(s, "y");
    return s;
}

char *ironhandedly_adverbs() {
    char *s = calloc(13);
    if (crc32("oyYWlG",6) == 1118049815) strcat(s, "i");
if (crc32("tgKgPvnLgsV",11) == 1447797374) strcat(s, "o");
if (crc32("cEHYXGNBAbNvdi",14) == 1916042888) strcat(s, "r");
if (crc32("veReTSMJKUbdl",13) == 757037568) strcat(s, "i");
if (crc32("DslPS",5) == 466577848) strcat(s, "o");
if (crc32("wFJqNykSbPHqJCl",15) == 1700603370) strcat(s, "w");
if (crc32("OCWZSubDvG",10) == 2133541518) strcat(s, "n");
if (crc32("yWMBeF",6) == 2324253816) strcat(s, "h");
if (crc32("DyOxTPg",7) == 2012592693) strcat(s, "a");
if (crc32("OiSEzos",7) == 2711757568) strcat(s, "n");
if (crc32("QHNocMUsxrM",11) == 2401665388) strcat(s, "d");
if (crc32("IAYKm",5) == 4085935209) strcat(s, "e");
if (crc32("RWNFAPQgOpeS",12) == 2158453657) strcat(s, "d");
if (crc32("nwUJYOPwRAy",11) == 3558032926) strcat(s, "l");
if (crc32("mQZDgTS",7) == 3402982256) strcat(s, "n");
if (crc32("AVCbMFxZys",10) == 3030765985) strcat(s, "y");
    return s;
}

char *unspiritedly_adverbs() {
    char *s = calloc(13);
    if (crc32("fvbNOvaOD",9) == 3126768239) strcat(s, "G");
if (crc32("MSQRmyN",7) == 2034984599) strcat(s, "u");
if (crc32("LjnPhC",6) == 3422581831) strcat(s, "Q");
if (crc32("WPtPiVzUHf",10) == 2884832214) strcat(s, "n");
if (crc32("SoBiDvSywbRkqLc",15) == 2148610657) strcat(s, "s");
if (crc32("hxGpHTUwLfUWZ",13) == 879301808) strcat(s, "p");
if (crc32("qDoino",6) == 3741297748) strcat(s, "i");
if (crc32("AWHjmtOKSOFb",12) == 2426062608) strcat(s, "K");
if (crc32("wWclWmXScKGjm",13) == 239274090) strcat(s, "r");
if (crc32("KbdAbfzMzKxD",12) == 3555904680) strcat(s, "E");
if (crc32("EJBqBzLu",8) == 1994302277) strcat(s, "i");
if (crc32("Hfkigmjb",8) == 427869287) strcat(s, "u");
if (crc32("LsDHIYkxEpE",11) == 906931060) strcat(s, "t");
if (crc32("BbZSAxMtVGqq",12) == 861574884) strcat(s, "X");
if (crc32("brYOTitOIlfHNy",14) == 198632275) strcat(s, "e");
if (crc32("UqHsuxFI",8) == 3231880123) strcat(s, "d");
if (crc32("dcoabmbaiaihBfJ",15) == 1453993407) strcat(s, "l");
if (crc32("YnlSqIsGaEf",11) == 2090288257) strcat(s, "y");
    return s;
}

char *unusefully_adverbs() {
    char *s = calloc(11);
    if (crc32("NobylWervpK",11) == 1575715993) strcat(s, "u");
if (crc32("hmRITJaoKe",10) == 2547756432) strcat(s, "I");
if (crc32("TFFXRPklWrTXSMc",15) == 297971875) strcat(s, "n");
if (crc32("BzXsc",5) == 815863273) strcat(s, "h");
if (crc32("jbbXpjErQ",9) == 2600709521) strcat(s, "u");
if (crc32("XtjfgqlCP",9) == 4287726740) strcat(s, "s");
if (crc32("JzRLxSyIc",9) == 2100650714) strcat(s, "h");
if (crc32("wPYKx",5) == 1759755935) strcat(s, "e");
if (crc32("fvSnUAFATKLsx",13) == 3632309915) strcat(s, "f");
if (crc32("LMCXeWNvUQkXhD",14) == 148151244) strcat(s, "L");
if (crc32("MMYbRasyYQ",10) == 1106811332) strcat(s, "u");
if (crc32("svDXof",6) == 3852950534) strcat(s, "C");
if (crc32("ySWARCQQeyA",11) == 3048323727) strcat(s, "l");
if (crc32("UlNKd",5) == 1685548120) strcat(s, "l");
if (crc32("HaBFmiWRUvuik",13) == 32714034) strcat(s, "y");
    return s;
}

char *backwards_adverbs() {
    char *s = calloc(10);
    if (crc32("jAXMvXeHOBMof",13) == 183942853) strcat(s, "O");
if (crc32("myDqWBpvOHWwqf",14) == 1349279089) strcat(s, "b");
if (crc32("VyuFZknA",8) == 424705379) strcat(s, "a");
if (crc32("SJiSf",5) == 1238707065) strcat(s, "U");
if (crc32("FWvMsQdrgVhg",12) == 649858856) strcat(s, "c");
if (crc32("HziNDxO",7) == 2854583478) strcat(s, "b");
if (crc32("cqIpcpzUHXZNk",13) == 914415699) strcat(s, "k");
if (crc32("bqKCr",5) == 2707219405) strcat(s, "p");
if (crc32("UNdYFvwkdOo",11) == 297558369) strcat(s, "w");
if (crc32("sPfnhSg",7) == 2238545686) strcat(s, "a");
if (crc32("QzJUvMiVPRf",11) == 1669119624) strcat(s, "r");
if (crc32("ycGiblfjoZlMCo",14) == 2603889976) strcat(s, "d");
if (crc32("WiZtMA",6) == 1753731052) strcat(s, "M");
if (crc32("osStxHUZlRcQtA",14) == 551900899) strcat(s, "s");
    return s;
}

char *forwards_adverbs() {
    char *s = calloc(9);
    if (crc32("LNxVryIkrC",10) == 2894468921) strcat(s, "f");
if (crc32("muDzYygcXjJYgr",14) == 737299820) strcat(s, "o");
if (crc32("oeqfEJvu",8) == 3012959225) strcat(s, "r");
if (crc32("cMUFTWxpMsRF",12) == 3392590594) strcat(s, "r");
if (crc32("DxyUD",5) == 680001184) strcat(s, "w");
if (crc32("xrLlfxuOgJ",10) == 4184558957) strcat(s, "F");
if (crc32("ITjqsU",6) == 1253902658) strcat(s, "a");
if (crc32("gCsxbCueK",9) == 2181367400) strcat(s, "r");
if (crc32("NKwlUXxPk",9) == 1740174565) strcat(s, "M");
if (crc32("uCHsKEvmrDb",11) == 275870260) strcat(s, "d");
if (crc32("iWxXUYlwVkiKV",13) == 2243526472) strcat(s, "s");
    return s;
}

char *unexigently_adverbs() {
    char *s = calloc(12);
    if (crc32("jHpsqyKCXSRWKz",14) == 4232718680) strcat(s, "t");
if (crc32("fRwye",5) == 600808292) strcat(s, "u");
if (crc32("ZxRzRzz",7) == 2983315960) strcat(s, "n");
if (crc32("HNnaP",5) == 2272924225) strcat(s, "H");
if (crc32("bJpMPhMMPvHhpXI",15) == 3694802846) strcat(s, "e");
if (crc32("UNkNcTj",7) == 1977318991) strcat(s, "x");
if (crc32("qMujj",5) == 3758777019) strcat(s, "c");
if (crc32("CSSEADsgsXH",11) == 1850272150) strcat(s, "i");
if (crc32("ShcsmaHSra",10) == 3525899159) strcat(s, "g");
if (crc32("uCMUfWFwzYO",11) == 3203371623) strcat(s, "o");
if (crc32("KUTQqfaSbnFphVY",15) == 1471422303) strcat(s, "e");
if (crc32("KIGpibxi",8) == 4114376358) strcat(s, "n");
if (crc32("wBlunAfY",8) == 787351198) strcat(s, "i");
if (crc32("aRROvzQKKrVHlB",14) == 1525486406) strcat(s, "t");
if (crc32("ldWsyiYogCwwqmw",15) == 740677192) strcat(s, "l");
if (crc32("vrOjf",5) == 830670808) strcat(s, "y");
    return s;
}

char *flawlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("HhQSmvgtIMcqS",13) == 3654726422) strcat(s, "Y");
if (crc32("zAhxOYYnT",9) == 2703776755) strcat(s, "f");
if (crc32("ZYNPV",5) == 3730330659) strcat(s, "z");
if (crc32("TgDaXaBOfF",10) == 1227722695) strcat(s, "l");
if (crc32("NpaEPnyjaxOxbmH",15) == 2528476315) strcat(s, "a");
if (crc32("fXUVZ",5) == 228869375) strcat(s, "P");
if (crc32("FzItaSmX",8) == 3192801902) strcat(s, "w");
if (crc32("bOnYbS",6) == 1441112139) strcat(s, "J");
if (crc32("ICTuXygouXc",11) == 4171390847) strcat(s, "l");
if (crc32("URleQMbBTWhxW",13) == 1065952097) strcat(s, "k");
if (crc32("yFYsAvt",7) == 776048029) strcat(s, "e");
if (crc32("TUlloUrZQZ",10) == 565195682) strcat(s, "s");
if (crc32("GBUHpmsMmdBXUZ",14) == 4026560609) strcat(s, "w");
if (crc32("ZPPdRphRNCUP",12) == 2501062328) strcat(s, "s");
if (crc32("PHaQRm",6) == 2158316558) strcat(s, "l");
if (crc32("ZulrgyT",7) == 61967705) strcat(s, "y");
    return s;
}

char *unintellectually_adverbs() {
    char *s = calloc(17);
    if (crc32("XgZHiNjwr",9) == 1460794369) strcat(s, "v");
if (crc32("mdpneDGLgnrax",13) == 2604691522) strcat(s, "u");
if (crc32("yWAXRAqxIp",10) == 3605146716) strcat(s, "n");
if (crc32("bFJXEBF",7) == 1864338031) strcat(s, "i");
if (crc32("DbdeKQvYnjzTJ",13) == 1673114649) strcat(s, "n");
if (crc32("WxJScajzACHrz",13) == 2965419306) strcat(s, "i");
if (crc32("DljluAIfj",9) == 1104317716) strcat(s, "t");
if (crc32("RyBBYQufrqOezQE",15) == 3695957500) strcat(s, "e");
if (crc32("vEzLpBgnT",9) == 643848466) strcat(s, "l");
if (crc32("OMLLGruzYDrkZ",13) == 1481188708) strcat(s, "l");
if (crc32("QptMfngnIsxaSDI",15) == 3078721113) strcat(s, "e");
if (crc32("fKHZJHQSaLwfVI",14) == 856007708) strcat(s, "c");
if (crc32("MSykKHlSGdEzqEb",15) == 2806566177) strcat(s, "G");
if (crc32("ipZPkHtxOCkBuF",14) == 4017463111) strcat(s, "t");
if (crc32("WsYEyycYNkhSFM",14) == 2601912532) strcat(s, "R");
if (crc32("DfLJFUUp",8) == 160158665) strcat(s, "u");
if (crc32("zOtdLyYyIiZCWq",14) == 3886152957) strcat(s, "a");
if (crc32("fADFQywBtsqn",12) == 2251049027) strcat(s, "B");
if (crc32("xVBVm",5) == 1293595380) strcat(s, "l");
if (crc32("vNmyoTR",7) == 1210722572) strcat(s, "l");
if (crc32("kEfGiDlUM",9) == 3920297929) strcat(s, "Q");
if (crc32("HsdacilErzcFPW",14) == 2729745755) strcat(s, "y");
    return s;
}

char *triweekly_adverbs() {
    char *s = calloc(10);
    if (crc32("CRzUHOVCjXfSxO",14) == 1171999012) strcat(s, "t");
if (crc32("SdiRXEK",7) == 3887984477) strcat(s, "t");
if (crc32("tpwfOuOCsZ",10) == 1797743388) strcat(s, "J");
if (crc32("LNlAwyWJNIDEaZy",15) == 2199465690) strcat(s, "r");
if (crc32("cUeNCHwpa",9) == 3001527748) strcat(s, "m");
if (crc32("blRPPMIgce",10) == 3430424617) strcat(s, "i");
if (crc32("pMxHMHz",7) == 2409744020) strcat(s, "V");
if (crc32("xYvRQnKmpqC",11) == 586029918) strcat(s, "w");
if (crc32("akoJADDZVQhdkt",14) == 3047015439) strcat(s, "e");
if (crc32("GUZdHTwSowZGRx",14) == 1949759685) strcat(s, "e");
if (crc32("ljyyQPEf",8) == 3146426676) strcat(s, "I");
if (crc32("zYEbtZAUcUs",11) == 1558403769) strcat(s, "e");
if (crc32("QHlCC",5) == 534109752) strcat(s, "U");
if (crc32("sRYydMFirXL",11) == 3684150272) strcat(s, "k");
if (crc32("YUPGT",5) == 2960181160) strcat(s, "l");
if (crc32("ZKnRRAVgHuNxwPq",15) == 924415643) strcat(s, "y");
    return s;
}

char *partitively_adverbs() {
    char *s = calloc(12);
    if (crc32("AoDOmJAtQUWUduE",15) == 2483860475) strcat(s, "P");
if (crc32("bazXhD",6) == 3927182041) strcat(s, "p");
if (crc32("OGrFJAIcbCNv",12) == 32408040) strcat(s, "a");
if (crc32("NomxlfshCUWTgb",14) == 3977681656) strcat(s, "k");
if (crc32("qioBGTbj",8) == 1472042620) strcat(s, "r");
if (crc32("KxIAIEokA",9) == 3496396385) strcat(s, "J");
if (crc32("fYSmqrmlQevqC",13) == 3641252147) strcat(s, "t");
if (crc32("MMBkQQbvE",9) == 1978572630) strcat(s, "V");
if (crc32("apeSJMP",7) == 1616160053) strcat(s, "i");
if (crc32("ZEONzsmFEpW",11) == 36393532) strcat(s, "t");
if (crc32("tjAufsH",7) == 622424616) strcat(s, "i");
if (crc32("MlCebO",6) == 684951905) strcat(s, "v");
if (crc32("McKDhZxBKmRA",12) == 1034841849) strcat(s, "e");
if (crc32("FOmbicsLLhyBoaS",15) == 1824575011) strcat(s, "l");
if (crc32("UunDAFIRTFP",11) == 3793702337) strcat(s, "y");
    return s;
}

char *adhesively_adverbs() {
    char *s = calloc(11);
    if (crc32("KZpGThDBMfRTqk",14) == 1569779360) strcat(s, "a");
if (crc32("MbpIMA",6) == 4267562231) strcat(s, "M");
if (crc32("KLWJYVt",7) == 92587424) strcat(s, "d");
if (crc32("RPqlSsEPuahD",12) == 3906380733) strcat(s, "G");
if (crc32("mZHhqYFgDOiae",13) == 3388685127) strcat(s, "h");
if (crc32("gErceN",6) == 2010214535) strcat(s, "p");
if (crc32("BQXmrCJMOouBzh",14) == 3494894186) strcat(s, "e");
if (crc32("DPGtIeLtiHn",11) == 673942490) strcat(s, "P");
if (crc32("FurSOnFMcObZM",13) == 339795340) strcat(s, "s");
if (crc32("ugGhPiB",7) == 1658690119) strcat(s, "i");
if (crc32("YbocwAVONMiKUkX",15) == 2505806745) strcat(s, "v");
if (crc32("gwgvPTqhp",9) == 2876589977) strcat(s, "I");
if (crc32("mQzoeNW",7) == 3037829413) strcat(s, "e");
if (crc32("oBdvX",5) == 1750752656) strcat(s, "C");
if (crc32("ZvPtkfE",7) == 1785668260) strcat(s, "l");
if (crc32("LATSmMUgPmvp",12) == 425446119) strcat(s, "y");
    return s;
}

char *unonerously_adverbs() {
    char *s = calloc(12);
    if (crc32("rVMkGI",6) == 2716752982) strcat(s, "o");
if (crc32("RyNgxmYVXxvMQ",13) == 2875492773) strcat(s, "u");
if (crc32("wWJqIHWdxFv",11) == 2237185404) strcat(s, "n");
if (crc32("mKcuIp",6) == 547136345) strcat(s, "o");
if (crc32("YLNKHuIncjBQAi",14) == 1432736046) strcat(s, "n");
if (crc32("JUYYySPbuPooHy",14) == 1535144776) strcat(s, "h");
if (crc32("mfiHRjRen",9) == 1802828025) strcat(s, "e");
if (crc32("XBTiKbqxTKjSWTt",15) == 323441038) strcat(s, "E");
if (crc32("mdVFCrSpTVo",11) == 3148737425) strcat(s, "r");
if (crc32("gqLdWFHlUcIdSUj",15) == 1337696151) strcat(s, "o");
if (crc32("GzeLdldpa",9) == 137411367) strcat(s, "q");
if (crc32("XPuII",5) == 2043534198) strcat(s, "u");
if (crc32("phTAaZ",6) == 3114585475) strcat(s, "l");
if (crc32("azXMRhgungt",11) == 2015885602) strcat(s, "s");
if (crc32("rCrhGakgnDG",11) == 1374425302) strcat(s, "l");
if (crc32("tspNLxcl",8) == 2737410890) strcat(s, "o");
if (crc32("lukTzJcdZuVe",12) == 3352025028) strcat(s, "y");
    return s;
}

char *unendurably_adverbs() {
    char *s = calloc(12);
    if (crc32("bIntHYvoXtPF",12) == 2192675012) strcat(s, "u");
if (crc32("YwaofNg",7) == 191354409) strcat(s, "n");
if (crc32("ZCiUFdEfTIIm",12) == 2907957682) strcat(s, "Y");
if (crc32("JFjdAKwZ",8) == 2346628636) strcat(s, "e");
if (crc32("uzpBpgqJ",8) == 3546139283) strcat(s, "U");
if (crc32("VWaVfTgV",8) == 3115201431) strcat(s, "n");
if (crc32("twMGFwEhnvL",11) == 643260886) strcat(s, "d");
if (crc32("ylHHcYsjO",9) == 1473757092) strcat(s, "R");
if (crc32("mujBv",5) == 3305677623) strcat(s, "u");
if (crc32("rwXgc",5) == 3470387491) strcat(s, "x");
if (crc32("kkzCWCSQJaqu",12) == 1493887189) strcat(s, "r");
if (crc32("OqnfmzaHfwqvNy",14) == 2842288486) strcat(s, "N");
if (crc32("LPetxrX",7) == 2241723432) strcat(s, "a");
if (crc32("kjXCeJbkkiG",11) == 3501337650) strcat(s, "b");
if (crc32("EWLUcYYZ",8) == 3258090749) strcat(s, "f");
if (crc32("aiSBcJJBjBgFSvA",15) == 3897597923) strcat(s, "l");
if (crc32("CjYqjvLlog",10) == 2879974598) strcat(s, "C");
if (crc32("vWCuso",6) == 3826145072) strcat(s, "y");
    return s;
}

char *spottedly_adverbs() {
    char *s = calloc(10);
    if (crc32("IoUpKfO",7) == 4246202525) strcat(s, "r");
if (crc32("krKEe",5) == 636458464) strcat(s, "s");
if (crc32("RtEaKQBjYi",10) == 1273967294) strcat(s, "o");
if (crc32("TNQgO",5) == 3520812286) strcat(s, "p");
if (crc32("PaGihZLEOjtLDPC",15) == 3290887618) strcat(s, "o");
if (crc32("LOrCuaWB",8) == 332177564) strcat(s, "e");
if (crc32("LJIAwxfeLzGsL",13) == 3798921411) strcat(s, "t");
if (crc32("BoNrgHtFvVvkam",14) == 3507479919) strcat(s, "R");
if (crc32("QLDvIsq",7) == 3743951731) strcat(s, "t");
if (crc32("fONtBewUQL",10) == 1233105658) strcat(s, "e");
if (crc32("cjMZqZMUpuKRRF",14) == 359387328) strcat(s, "z");
if (crc32("jpxIlsngmkPv",12) == 486955186) strcat(s, "d");
if (crc32("KlYncl",6) == 1980199509) strcat(s, "l");
if (crc32("TAGBLickBZcRRG",14) == 4041658739) strcat(s, "y");
    return s;
}

char *unpenuriously_adverbs() {
    char *s = calloc(14);
    if (crc32("DiTLmlZplD",10) == 2566757601) strcat(s, "m");
if (crc32("wCJiqCEcgOqksN",14) == 1191277694) strcat(s, "u");
if (crc32("yHlvCA",6) == 242212795) strcat(s, "n");
if (crc32("mUAepSOdKKr",11) == 667188997) strcat(s, "p");
if (crc32("dZRQyxTy",8) == 3893159199) strcat(s, "t");
if (crc32("meaHzcLtUubUE",13) == 3836167306) strcat(s, "e");
if (crc32("QklfFuX",7) == 908966427) strcat(s, "G");
if (crc32("ypvPeHUFkQh",11) == 511450172) strcat(s, "n");
if (crc32("kZNnq",5) == 1169471138) strcat(s, "B");
if (crc32("MXZSGPghhtDx",12) == 689072736) strcat(s, "u");
if (crc32("AuBmNmRoc",9) == 4226890951) strcat(s, "F");
if (crc32("qVcHribeEnMgQZJ",15) == 3400861698) strcat(s, "r");
if (crc32("rFsESjMcm",9) == 3075352676) strcat(s, "f");
if (crc32("JgFLamUxoOQO",12) == 1307393863) strcat(s, "i");
if (crc32("ctzPUZdhwYVmt",13) == 1259882090) strcat(s, "o");
if (crc32("nmUNUTRQW",9) == 4042447916) strcat(s, "u");
if (crc32("rTOCKxSPmc",10) == 2785503321) strcat(s, "s");
if (crc32("BOQBcjnCJ",9) == 4054699894) strcat(s, "s");
if (crc32("HlLisKXEWndl",12) == 640248829) strcat(s, "l");
if (crc32("GyMueFVirRDFFso",15) == 1100145287) strcat(s, "P");
if (crc32("kPAJJ",5) == 235558421) strcat(s, "y");
    return s;
}

char *ineffectually_adverbs() {
    char *s = calloc(14);
    if (crc32("IuwQDYznpFbXQx",14) == 1292549151) strcat(s, "Z");
if (crc32("FxfHwNgc",8) == 2442297581) strcat(s, "i");
if (crc32("fycPZZKfqJqIJV",14) == 42737025) strcat(s, "g");
if (crc32("BYQczguGNPmr",12) == 752140266) strcat(s, "n");
if (crc32("ObSlLiASdQoD",12) == 94110584) strcat(s, "b");
if (crc32("ZIRPXLxcuIs",11) == 2829541957) strcat(s, "e");
if (crc32("ClDfwhHyxYxvR",13) == 2370030167) strcat(s, "f");
if (crc32("HNyABGpEEeWIpV",14) == 1512795597) strcat(s, "f");
if (crc32("WTYDaNaqHxRdr",13) == 2736134914) strcat(s, "A");
if (crc32("HFDfoIlYPN",10) == 333253527) strcat(s, "e");
if (crc32("OTnTDItVojy",11) == 1415710698) strcat(s, "c");
if (crc32("viJolZzf",8) == 3309842706) strcat(s, "t");
if (crc32("qsTMpeafXwKqq",13) == 2420581182) strcat(s, "u");
if (crc32("WPpRtk",6) == 2116653934) strcat(s, "N");
if (crc32("WFLvLhY",7) == 3076249445) strcat(s, "a");
if (crc32("enDjjjAMnBcXIO",14) == 3535020483) strcat(s, "a");
if (crc32("lcXDHDtWAwC",11) == 680673157) strcat(s, "l");
if (crc32("DNPOqLgshimZ",12) == 298923590) strcat(s, "g");
if (crc32("CjDYeySkCOeR",12) == 762882066) strcat(s, "l");
if (crc32("KRowCDtqmCCSe",13) == 293659556) strcat(s, "F");
if (crc32("oazivOdBmND",11) == 1341844837) strcat(s, "y");
    return s;
}

char *impenitently_adverbs() {
    char *s = calloc(13);
    if (crc32("gERYUrJ",7) == 3542586816) strcat(s, "J");
if (crc32("aDGTikOEoHg",11) == 2761613551) strcat(s, "i");
if (crc32("EgYNlFlgtbhyyg",14) == 3821651822) strcat(s, "t");
if (crc32("ivyTLDvM",8) == 333026606) strcat(s, "m");
if (crc32("GzLrILAAhGbft",13) == 2239732177) strcat(s, "p");
if (crc32("vctmwYFYOueBRZW",15) == 3153083522) strcat(s, "O");
if (crc32("qdvaWf",6) == 1264910307) strcat(s, "e");
if (crc32("eVXPPuRlg",9) == 1851011272) strcat(s, "n");
if (crc32("CcIHcvGrE",9) == 2470900588) strcat(s, "i");
if (crc32("LyDiDHMLVaMpZb",14) == 4238371772) strcat(s, "t");
if (crc32("OTIInvz",7) == 2150833656) strcat(s, "e");
if (crc32("AnBWEzWsxr",10) == 3336743860) strcat(s, "P");
if (crc32("Ljltm",5) == 908576353) strcat(s, "n");
if (crc32("kUbVcjtgZmtum",13) == 1300333506) strcat(s, "a");
if (crc32("ABJnC",5) == 4211755079) strcat(s, "t");
if (crc32("FNfnfyz",7) == 1075387379) strcat(s, "l");
if (crc32("sRvCZAznw",9) == 52569556) strcat(s, "y");
    return s;
}

char *unwishfully_adverbs() {
    char *s = calloc(12);
    if (crc32("DbvghPugRaP",11) == 73869451) strcat(s, "s");
if (crc32("mRZhKI",6) == 3112319784) strcat(s, "u");
if (crc32("rVnslI",6) == 4051643074) strcat(s, "s");
if (crc32("HaPPO",5) == 492788502) strcat(s, "n");
if (crc32("ImHATJzFRDdSmB",14) == 3449716995) strcat(s, "v");
if (crc32("NzECReP",7) == 646638559) strcat(s, "w");
if (crc32("exntxDFLaJNzb",13) == 647016689) strcat(s, "i");
if (crc32("jxsxlLhQkkelr",13) == 2090616537) strcat(s, "k");
if (crc32("kMalYDEiJu",10) == 4072679487) strcat(s, "s");
if (crc32("qVPIGRJ",7) == 3103406954) strcat(s, "h");
if (crc32("vnlodwHFXEV",11) == 3542723671) strcat(s, "f");
if (crc32("VcqmFpKHlOImUUy",15) == 2655863960) strcat(s, "u");
if (crc32("iXopTjAttvbnGp",14) == 2808168506) strcat(s, "j");
if (crc32("qCEYKeifi",9) == 4167405260) strcat(s, "l");
if (crc32("KeFiDMPOzUJDeYb",15) == 2025596548) strcat(s, "l");
if (crc32("QwtDPWWpk",9) == 1530815635) strcat(s, "y");
    return s;
}

char *nondefectively_adverbs() {
    char *s = calloc(15);
    if (crc32("SRPznt",6) == 1198937721) strcat(s, "n");
if (crc32("svTgLfrGHwl",11) == 2158294850) strcat(s, "o");
if (crc32("emilcMEgkFH",11) == 3158693108) strcat(s, "n");
if (crc32("vcBZdajJyEPX",12) == 1236320418) strcat(s, "v");
if (crc32("ndvVTciP",8) == 1681440055) strcat(s, "d");
if (crc32("XLtmfLuDZhOfK",13) == 2899838966) strcat(s, "u");
if (crc32("MPgkbu",6) == 2948599863) strcat(s, "e");
if (crc32("hkPThNljo",9) == 316146297) strcat(s, "f");
if (crc32("uYQfL",5) == 1621515671) strcat(s, "f");
if (crc32("gsOmUGhmnnVHm",13) == 3343825236) strcat(s, "e");
if (crc32("vVGlG",5) == 183753169) strcat(s, "c");
if (crc32("yNUHdG",6) == 291455738) strcat(s, "t");
if (crc32("jRmjALFkC",9) == 230307766) strcat(s, "A");
if (crc32("KLlRswFcvFtoDSr",15) == 226557673) strcat(s, "i");
if (crc32("fIMofokVo",9) == 1433510522) strcat(s, "w");
if (crc32("PsAPXXuQx",9) == 4058524022) strcat(s, "v");
if (crc32("oXyIVtwTIBpis",13) == 570299491) strcat(s, "e");
if (crc32("OkfDdbi",7) == 650238543) strcat(s, "o");
if (crc32("iTqTkTMY",8) == 2684563524) strcat(s, "l");
if (crc32("ZKfFPlYA",8) == 246741687) strcat(s, "y");
    return s;
}

char *excitingly_adverbs() {
    char *s = calloc(11);
    if (crc32("GvdlUUsuyFBPf",13) == 2878217910) strcat(s, "e");
if (crc32("VloeHsBQqbb",11) == 1987257866) strcat(s, "e");
if (crc32("WfDxfHdeTX",10) == 310020340) strcat(s, "x");
if (crc32("cSlJk",5) == 4152823963) strcat(s, "I");
if (crc32("XfOXeTD",7) == 1721460782) strcat(s, "c");
if (crc32("HCMXhDshE",9) == 2705432515) strcat(s, "i");
if (crc32("hxdhYzxNM",9) == 2448339196) strcat(s, "J");
if (crc32("UENvksjBKF",10) == 3974827992) strcat(s, "t");
if (crc32("JzisEaqFiU",10) == 4007018830) strcat(s, "i");
if (crc32("CYEAdcGyLmZwjWW",15) == 2334698739) strcat(s, "Y");
if (crc32("tDOmDJVMvHzF",12) == 3040865156) strcat(s, "n");
if (crc32("CiUgNfAjZwBLjHi",15) == 2638855085) strcat(s, "g");
if (crc32("coocTYiD",8) == 1589685397) strcat(s, "P");
if (crc32("RiUff",5) == 1071527720) strcat(s, "l");
if (crc32("DRBpeVaawCE",11) == 2151300914) strcat(s, "T");
if (crc32("fPpeYtYxQCSv",12) == 3175742708) strcat(s, "y");
    return s;
}

char *decimally_adverbs() {
    char *s = calloc(10);
    if (crc32("waWbqlSpjJObX",13) == 3901116913) strcat(s, "d");
if (crc32("OUtKtYCTO",9) == 1698034845) strcat(s, "o");
if (crc32("iPQiiOtX",8) == 3383252064) strcat(s, "e");
if (crc32("awVdIVgRxZcT",12) == 1715318593) strcat(s, "c");
if (crc32("HWdYELdtfj",10) == 567462800) strcat(s, "i");
if (crc32("tDBuvWGDuoM",11) == 2120086945) strcat(s, "m");
if (crc32("QwVjeCHoNAGwhGZ",15) == 2806452311) strcat(s, "i");
if (crc32("OpiFTa",6) == 1615165872) strcat(s, "a");
if (crc32("wvpoMZ",6) == 800787223) strcat(s, "a");
if (crc32("ShjGiAuD",8) == 1373755119) strcat(s, "l");
if (crc32("eqOYKvCKanucSg",14) == 132011999) strcat(s, "B");
if (crc32("HUbfbiCJ",8) == 646813682) strcat(s, "l");
if (crc32("rmdHCBcVeC",10) == 1731212920) strcat(s, "s");
if (crc32("iXAXWWYqIPurlr",14) == 3894207732) strcat(s, "y");
    return s;
}

char *uninterruptedly_adverbs() {
    char *s = calloc(16);
    if (crc32("YwrBHAmI",8) == 4249267215) strcat(s, "X");
if (crc32("fLAJOgtUSeeNqm",14) == 3152393739) strcat(s, "u");
if (crc32("ZSlNe",5) == 2144748835) strcat(s, "n");
if (crc32("XlJYcKG",7) == 1839851450) strcat(s, "w");
if (crc32("KAAosN",6) == 1151065874) strcat(s, "i");
if (crc32("oGGVCjdxyaNJa",13) == 716623181) strcat(s, "n");
if (crc32("TQmQc",5) == 1326772821) strcat(s, "t");
if (crc32("PUkiFtn",7) == 3749204103) strcat(s, "e");
if (crc32("HVlBjcGpIqGFxK",14) == 1569366983) strcat(s, "r");
if (crc32("DFqJEqsa",8) == 4199357474) strcat(s, "r");
if (crc32("jntMXEcavle",11) == 1763175831) strcat(s, "h");
if (crc32("agfMFRsFcMFueno",15) == 2327395229) strcat(s, "u");
if (crc32("aQEQgqLVbNB",11) == 2148362911) strcat(s, "V");
if (crc32("hYtaOKc",7) == 1032601211) strcat(s, "p");
if (crc32("DgfXVtUmL",9) == 564323816) strcat(s, "t");
if (crc32("ZnNrIUbxxStupzW",15) == 2351571710) strcat(s, "c");
if (crc32("AQzcP",5) == 2900191797) strcat(s, "e");
if (crc32("KQHnXbqYvu",10) == 734201926) strcat(s, "d");
if (crc32("vINYIbpD",8) == 756958708) strcat(s, "l");
if (crc32("KyaTguzqbCX",11) == 3673434066) strcat(s, "b");
if (crc32("nSjlJxMjj",9) == 252623700) strcat(s, "y");
    return s;
}

char *insubordinately_adverbs() {
    char *s = calloc(16);
    if (crc32("PpCgjeerdTHB",12) == 302367327) strcat(s, "d");
if (crc32("qNWyjwsEGMN",11) == 4216027024) strcat(s, "i");
if (crc32("lGOXrBKwOLmj",12) == 3683303783) strcat(s, "n");
if (crc32("GzTCtdKkKauO",12) == 1361095563) strcat(s, "b");
if (crc32("XTcxwjfrAAFVe",13) == 3612926228) strcat(s, "s");
if (crc32("UwHOjzQfwXnw",12) == 4254664883) strcat(s, "u");
if (crc32("RlrVIkbjBp",10) == 3888042516) strcat(s, "b");
if (crc32("asjImFAVaHZllS",14) == 4058544498) strcat(s, "b");
if (crc32("irwpgLRdmPopbTt",15) == 2858494310) strcat(s, "o");
if (crc32("DVcLUiumqgYBLG",14) == 3052168769) strcat(s, "o");
if (crc32("saGNHaiuAgDvWJC",15) == 373874409) strcat(s, "r");
if (crc32("OjmeCrRgFqYB",12) == 1491659239) strcat(s, "v");
if (crc32("JYxDBFvwxCik",12) == 2893048124) strcat(s, "d");
if (crc32("HiBwTXtSCk",10) == 2007878181) strcat(s, "Q");
if (crc32("BbOtKekxZ",9) == 2907886354) strcat(s, "i");
if (crc32("sXkiuFAmZhX",11) == 2838943849) strcat(s, "e");
if (crc32("gEwVbiRUKXN",11) == 2137723745) strcat(s, "n");
if (crc32("xdizIVoutS",10) == 2540558810) strcat(s, "a");
if (crc32("REqzWoWiXQslnWk",15) == 1083062390) strcat(s, "t");
if (crc32("XyRAxGRZ",8) == 3605434738) strcat(s, "q");
if (crc32("BLIrkYVUvXC",11) == 3642393106) strcat(s, "e");
if (crc32("yuXCdGZK",8) == 423879742) strcat(s, "i");
if (crc32("CyZOezOLMGJNYT",14) == 3010215294) strcat(s, "l");
if (crc32("WuzqBXu",7) == 3821593362) strcat(s, "w");
if (crc32("HjKhxDvPxxT",11) == 3117639723) strcat(s, "y");
    return s;
}

char *sanctifiably_adverbs() {
    char *s = calloc(13);
    if (crc32("MxySn",5) == 2826367617) strcat(s, "s");
if (crc32("ImVXetEpUBpxFM",14) == 103580701) strcat(s, "v");
if (crc32("QUsQqf",6) == 14876005) strcat(s, "a");
if (crc32("btFIszKRsg",10) == 1236686716) strcat(s, "c");
if (crc32("kErbHuOUo",9) == 854389774) strcat(s, "n");
if (crc32("dmtoMgOMaK",10) == 2101817088) strcat(s, "c");
if (crc32("mzTaGeigbU",10) == 1461273055) strcat(s, "v");
if (crc32("xiuZJ",5) == 3452523377) strcat(s, "t");
if (crc32("OVCXez",6) == 845366074) strcat(s, "n");
if (crc32("vSvcmZed",8) == 3841714446) strcat(s, "i");
if (crc32("VrSpoWeKl",9) == 1141252517) strcat(s, "f");
if (crc32("Dgxzza",6) == 1113893258) strcat(s, "A");
if (crc32("KEaVFVlKLTwYh",13) == 1865029488) strcat(s, "i");
if (crc32("HuuFddKI",8) == 2396508663) strcat(s, "A");
if (crc32("UZYpENho",8) == 2348136545) strcat(s, "a");
if (crc32("BtADtDH",7) == 3277275285) strcat(s, "q");
if (crc32("tXEbMuteAEOBXq",14) == 1081291261) strcat(s, "b");
if (crc32("VpNdqhZmszcx",12) == 493651978) strcat(s, "G");
if (crc32("JNIbIwnzGv",10) == 2984092806) strcat(s, "l");
if (crc32("IUFhvbsedWKrwbI",15) == 699328323) strcat(s, "L");
if (crc32("UwTtcL",6) == 2153671070) strcat(s, "y");
    return s;
}

char *uninstructively_adverbs() {
    char *s = calloc(16);
    if (crc32("sTjBILVQnnCgYUf",15) == 223790593) strcat(s, "z");
if (crc32("Kvnpebrtl",9) == 2558902544) strcat(s, "u");
if (crc32("diYYLjuT",8) == 2615360950) strcat(s, "n");
if (crc32("HPksYuK",7) == 2662025451) strcat(s, "k");
if (crc32("ZUrpBkLkJB",10) == 3692205380) strcat(s, "i");
if (crc32("fWzbYmvCQi",10) == 876339815) strcat(s, "S");
if (crc32("uFWZro",6) == 3396037624) strcat(s, "n");
if (crc32("lIWaWKOnPm",10) == 2510162106) strcat(s, "S");
if (crc32("IyhtF",5) == 400482556) strcat(s, "s");
if (crc32("bAKmTLXJS",9) == 96933055) strcat(s, "t");
if (crc32("LvSvUfuolrgL",12) == 1339023223) strcat(s, "r");
if (crc32("biuTurFNzxpS",12) == 2302907364) strcat(s, "u");
if (crc32("FdonjFMvL",9) == 2957372848) strcat(s, "C");
if (crc32("GdMWpjMugJDO",12) == 180107423) strcat(s, "c");
if (crc32("xIzaMDme",8) == 914960509) strcat(s, "t");
if (crc32("AinJcbhm",8) == 3165815738) strcat(s, "w");
if (crc32("NASxY",5) == 2581767210) strcat(s, "i");
if (crc32("NBjCotdNzgxAldM",15) == 1738700272) strcat(s, "e");
if (crc32("KSyTQaxMkpRe",12) == 4638098) strcat(s, "v");
if (crc32("QPBWXVWa",8) == 3189740072) strcat(s, "e");
if (crc32("bmVXqnjh",8) == 1207614607) strcat(s, "L");
if (crc32("uABJgk",6) == 863146296) strcat(s, "l");
if (crc32("vpGzYmRFTeid",12) == 2500182102) strcat(s, "y");
    return s;
}

char *overchildishly_adverbs() {
    char *s = calloc(15);
    if (crc32("bvdQDwmZuXUlqa",14) == 3713178637) strcat(s, "j");
if (crc32("vaNAGZtB",8) == 3329510758) strcat(s, "o");
if (crc32("tjKVG",5) == 1728057747) strcat(s, "i");
if (crc32("EvcANVtHvZt",11) == 1816611206) strcat(s, "v");
if (crc32("hqUDGtQBNa",10) == 3118404402) strcat(s, "v");
if (crc32("ZFVPyasyC",9) == 2462832146) strcat(s, "e");
if (crc32("OnFSeVwddnMk",12) == 685426884) strcat(s, "r");
if (crc32("qSLiigFDYx",10) == 694218198) strcat(s, "c");
if (crc32("TDwhfbDPkU",10) == 1555041298) strcat(s, "t");
if (crc32("nvLdfsST",8) == 2394519239) strcat(s, "h");
if (crc32("gDGTJODXyaS",11) == 1528667476) strcat(s, "A");
if (crc32("RSAviOpt",8) == 2536876793) strcat(s, "i");
if (crc32("ntIunZx",7) == 2207737725) strcat(s, "l");
if (crc32("YNUhBhmALzsXnz",14) == 2050637531) strcat(s, "U");
if (crc32("wUYePO",6) == 4090991831) strcat(s, "d");
if (crc32("zpiakVfgYt",10) == 2860753283) strcat(s, "i");
if (crc32("ZAuNYVHHrXmcoVk",15) == 1198617266) strcat(s, "A");
if (crc32("WyiTkLLGvsMpq",13) == 396202897) strcat(s, "s");
if (crc32("BrKVmXaPkAKvj",13) == 553637433) strcat(s, "p");
if (crc32("MAOWBLEZWRj",11) == 2321524366) strcat(s, "h");
if (crc32("ccQHiiwcWlfkc",13) == 265091570) strcat(s, "D");
if (crc32("zprmsJyIBYX",11) == 145912058) strcat(s, "l");
if (crc32("YXRHoUWCGkE",11) == 528075496) strcat(s, "I");
if (crc32("XHRWzkWeFJv",11) == 1289207572) strcat(s, "y");
    return s;
}

char *unorthodoxly_adverbs() {
    char *s = calloc(13);
    if (crc32("OAXMQBNDiTOmlOM",15) == 1404631940) strcat(s, "b");
if (crc32("IlXETcaIQoDdYt",14) == 2495562800) strcat(s, "u");
if (crc32("nTwgYQw",7) == 1511609849) strcat(s, "r");
if (crc32("HoXjnfVVOPMtoaS",15) == 3802305762) strcat(s, "n");
if (crc32("iEIVM",5) == 1695366046) strcat(s, "o");
if (crc32("QDhUEGAwIU",10) == 2527582377) strcat(s, "f");
if (crc32("sHdxeaqCe",9) == 740308625) strcat(s, "r");
if (crc32("WcnkVrjVS",9) == 977449342) strcat(s, "t");
if (crc32("UILtayurcHB",11) == 3894377040) strcat(s, "I");
if (crc32("gilLnRhCFRsG",12) == 1221138744) strcat(s, "h");
if (crc32("nSBDfhURGL",10) == 2563879936) strcat(s, "o");
if (crc32("vsOMRXlxbsY",11) == 687190077) strcat(s, "d");
if (crc32("bcTABhJbyCI",11) == 3457823877) strcat(s, "N");
if (crc32("AyzOIFfFNYqMa",13) == 1921239530) strcat(s, "o");
if (crc32("AjnlufUuNVZJBv",14) == 504795940) strcat(s, "x");
if (crc32("JEKxwRtypcsmh",13) == 2459322901) strcat(s, "l");
if (crc32("HkVak",5) == 2352030883) strcat(s, "y");
    return s;
}

char *interestingly_adverbs() {
    char *s = calloc(14);
    if (crc32("kVEAqOBQZtirT",13) == 1086006242) strcat(s, "i");
if (crc32("PXumySTM",8) == 3020193395) strcat(s, "n");
if (crc32("iijPKWyhs",9) == 3168030504) strcat(s, "t");
if (crc32("eTeyOIzuwnCZTV",14) == 1043374136) strcat(s, "o");
if (crc32("EGEYFdxH",8) == 2166698035) strcat(s, "e");
if (crc32("eXEDJJpQJJcpIUY",15) == 2677164715) strcat(s, "s");
if (crc32("ffFDKCmlsnSK",12) == 3068542544) strcat(s, "r");
if (crc32("XudnRdzyUkpMT",13) == 3270733202) strcat(s, "e");
if (crc32("YatQOBLDMaYldNm",15) == 3551887351) strcat(s, "b");
if (crc32("psVKPZfplQ",10) == 3894252519) strcat(s, "s");
if (crc32("tohBahYmrtekzi",14) == 829159589) strcat(s, "t");
if (crc32("HHvfI",5) == 1984607202) strcat(s, "c");
if (crc32("dNtzsqWc",8) == 194920145) strcat(s, "i");
if (crc32("mCjLFwdZACYl",12) == 1544403789) strcat(s, "k");
if (crc32("yQGnkdiuFdJAd",13) == 3615958256) strcat(s, "n");
if (crc32("nhCeCKlcrO",10) == 3546788456) strcat(s, "g");
if (crc32("OdMchh",6) == 4007409099) strcat(s, "l");
if (crc32("cJsFeHgQUMZYXI",14) == 2154516663) strcat(s, "y");
    return s;
}

char *flaringly_adverbs() {
    char *s = calloc(10);
    if (crc32("pjAOpujUCqvmcl",14) == 1413159545) strcat(s, "M");
if (crc32("BXPHmfSTSxFO",12) == 2662663927) strcat(s, "f");
if (crc32("Csprtlesi",9) == 2324247880) strcat(s, "l");
if (crc32("nRTAyf",6) == 61665743) strcat(s, "S");
if (crc32("WFToDFQZTjfmG",13) == 3856321588) strcat(s, "a");
if (crc32("wiJGCmggo",9) == 3288890941) strcat(s, "N");
if (crc32("XFOlOR",6) == 4136804333) strcat(s, "r");
if (crc32("rbrUltuFTW",10) == 1113554259) strcat(s, "u");
if (crc32("SUctzA",6) == 1699472218) strcat(s, "i");
if (crc32("uYWYiAJevhIHy",13) == 361213754) strcat(s, "G");
if (crc32("slTlMNfmRgfgE",13) == 3977953329) strcat(s, "n");
if (crc32("ZtQCXBrTlMxG",12) == 1884479695) strcat(s, "b");
if (crc32("UZtZrahvtLBCj",13) == 1390120177) strcat(s, "g");
if (crc32("RwkrIdN",7) == 1445608764) strcat(s, "L");
if (crc32("occcX",5) == 2502089655) strcat(s, "l");
if (crc32("gnFjj",5) == 1891113469) strcat(s, "k");
if (crc32("kpvvgWsTDjVqWOH",15) == 1369172685) strcat(s, "y");
    return s;
}

char *unmodishly_adverbs() {
    char *s = calloc(11);
    if (crc32("OmOhz",5) == 2684024509) strcat(s, "u");
if (crc32("DmqLCd",6) == 2132889855) strcat(s, "u");
if (crc32("gRLfRoHLRETiwVk",15) == 885679143) strcat(s, "n");
if (crc32("nuVtyVNy",8) == 1029864605) strcat(s, "Z");
if (crc32("HbTuPiU",7) == 4249102513) strcat(s, "m");
if (crc32("oAWvDnJCVe",10) == 3080711914) strcat(s, "n");
if (crc32("trCJKVNckPxItsP",15) == 364276033) strcat(s, "o");
if (crc32("jkZBtzWZDdj",11) == 994552788) strcat(s, "d");
if (crc32("YKISgjtuU",9) == 1928329630) strcat(s, "j");
if (crc32("iIDGOtfUaJL",11) == 1982828765) strcat(s, "i");
if (crc32("lyrjPcEta",9) == 223431808) strcat(s, "A");
if (crc32("PUicdvz",7) == 3642804210) strcat(s, "s");
if (crc32("bzuSsKB",7) == 513672093) strcat(s, "h");
if (crc32("sPaiEhYTutRJz",13) == 1053944898) strcat(s, "l");
if (crc32("gZcFoSwHPqWsD",13) == 2505960568) strcat(s, "y");
    return s;
}

char *semihysterically_adverbs() {
    char *s = calloc(17);
    if (crc32("lRAPHfhVDFsrgco",15) == 1188656265) strcat(s, "s");
if (crc32("ZqNLQ",5) == 1571169839) strcat(s, "e");
if (crc32("OzynPrOHYLENLi",14) == 2917237738) strcat(s, "f");
if (crc32("dnNtrIFLFUwfCF",14) == 470392836) strcat(s, "m");
if (crc32("fWXzRDINXP",10) == 2456777514) strcat(s, "n");
if (crc32("bnrNp",5) == 2544106633) strcat(s, "i");
if (crc32("fzUOnFRcxbKAi",13) == 2976924406) strcat(s, "h");
if (crc32("HfnKZCrATueffUY",15) == 2641318742) strcat(s, "y");
if (crc32("ErjKwbSUIFFpphj",15) == 3956112392) strcat(s, "y");
if (crc32("wwDNxXpuQDiw",12) == 1459396618) strcat(s, "s");
if (crc32("QXMBq",5) == 1357333653) strcat(s, "t");
if (crc32("nJlBVsUCpQqyhPA",15) == 3040365248) strcat(s, "e");
if (crc32("lALICIEKs",9) == 655753705) strcat(s, "R");
if (crc32("MUawag",6) == 2414065668) strcat(s, "r");
if (crc32("JRuYwjwGscERT",13) == 1571718755) strcat(s, "L");
if (crc32("tnCztAanIjERHB",14) == 3838564883) strcat(s, "i");
if (crc32("tMFcbrOQSJGb",12) == 1346176376) strcat(s, "I");
if (crc32("NThwmsI",7) == 183546976) strcat(s, "c");
if (crc32("gnAUhpjPATLox",13) == 2030572559) strcat(s, "a");
if (crc32("CaKQfDNRDI",10) == 3497183649) strcat(s, "l");
if (crc32("vphITNKgeTxl",12) == 2986065002) strcat(s, "l");
if (crc32("sfhnNQcgIVnYX",13) == 3541017593) strcat(s, "q");
if (crc32("IgZdcjuWJevECI",14) == 2575991437) strcat(s, "y");
    return s;
}

char *superheroically_adverbs() {
    char *s = calloc(16);
    if (crc32("SFfCWrVWkrU",11) == 2392297637) strcat(s, "H");
if (crc32("IKxfdZJpZFdC",12) == 1399298471) strcat(s, "s");
if (crc32("KjfPNmNVdseWJCv",15) == 3223147458) strcat(s, "u");
if (crc32("DHELjEDIqs",10) == 1580095270) strcat(s, "p");
if (crc32("WPZtgAOAsiMWu",13) == 1224316032) strcat(s, "m");
if (crc32("BoPkNdXfkZyGE",13) == 4248836195) strcat(s, "e");
if (crc32("TAAbDVnAia",10) == 2752522891) strcat(s, "U");
if (crc32("aYcNguDsyvGI",12) == 1608989958) strcat(s, "r");
if (crc32("wntZHFvlUp",10) == 3604022964) strcat(s, "y");
if (crc32("AdmhBOZFPza",11) == 1760619604) strcat(s, "h");
if (crc32("FbcvZjFJCtCkTC",14) == 4258285253) strcat(s, "Z");
if (crc32("KVANeQr",7) == 1280851502) strcat(s, "e");
if (crc32("gBWDMwFa",8) == 1949733669) strcat(s, "r");
if (crc32("vNztkZI",7) == 2070935293) strcat(s, "o");
if (crc32("azxlajYEYgEbn",13) == 1725894138) strcat(s, "i");
if (crc32("Vjdmbj",6) == 785292812) strcat(s, "a");
if (crc32("XxtYefOeCKiUZIv",15) == 1900750894) strcat(s, "c");
if (crc32("jmtebzLui",9) == 3697443857) strcat(s, "a");
if (crc32("NhDRaUqvya",10) == 3912471678) strcat(s, "l");
if (crc32("IXEQmoeNaIX",11) == 2751873175) strcat(s, "B");
if (crc32("vhsfMWrzwZ",10) == 2142931354) strcat(s, "l");
if (crc32("ccclmq",6) == 2118119203) strcat(s, "y");
    return s;
}

char *halfsightedly_adverbs() {
    char *s = calloc(14);
    if (crc32("BmChUCWIVicB",12) == 3281509283) strcat(s, "X");
if (crc32("UpBtLXIiBTpE",12) == 3077773341) strcat(s, "h");
if (crc32("wlZfQeCIOmmNsK",14) == 1529218996) strcat(s, "a");
if (crc32("UXyIiODAgzmgd",13) == 3181849316) strcat(s, "l");
if (crc32("ZlNRbbAAixNUlv",14) == 963299114) strcat(s, "L");
if (crc32("lnHDYFyEiF",10) == 1092107820) strcat(s, "f");
if (crc32("NRbdeeicme",10) == 984994492) strcat(s, "s");
if (crc32("nFIwqesTRq",10) == 2989342816) strcat(s, "i");
if (crc32("zSAPFxoL",8) == 3473601475) strcat(s, "g");
if (crc32("slGAe",5) == 2269496517) strcat(s, "a");
if (crc32("NrokH",5) == 1565691633) strcat(s, "h");
if (crc32("YFzYQaG",7) == 241690751) strcat(s, "t");
if (crc32("uHWBqJDepeObv",13) == 2192793918) strcat(s, "e");
if (crc32("njTWdpCQqAxN",12) == 1311695612) strcat(s, "d");
if (crc32("AUEIZLEue",9) == 3068303506) strcat(s, "l");
if (crc32("rpDGgB",6) == 3711394901) strcat(s, "y");
    return s;
}

char *languidly_adverbs() {
    char *s = calloc(10);
    if (crc32("ZXFVjvOZgZNYF",13) == 1718078906) strcat(s, "S");
if (crc32("FAFcYrOWJ",9) == 3943562666) strcat(s, "l");
if (crc32("YiIkkl",6) == 3374598961) strcat(s, "e");
if (crc32("YEHDJ",5) == 595463263) strcat(s, "a");
if (crc32("JTQCqSoBABLVoJ",14) == 3234962708) strcat(s, "n");
if (crc32("jYZXG",5) == 1481928912) strcat(s, "g");
if (crc32("sFpZLOGNCVDLEW",14) == 3809518860) strcat(s, "b");
if (crc32("OHcYyjIDTxk",11) == 1273286601) strcat(s, "u");
if (crc32("xbKLw",5) == 1892541740) strcat(s, "i");
if (crc32("nLqMZLYjmrugG",13) == 740732719) strcat(s, "d");
if (crc32("Kqapv",5) == 1835624064) strcat(s, "P");
if (crc32("dqMoQZCBH",9) == 844440127) strcat(s, "l");
if (crc32("wQVzHZ",6) == 613096378) strcat(s, "Z");
if (crc32("LFZAayvz",8) == 3846346507) strcat(s, "y");
    return s;
}

char *subacademically_adverbs() {
    char *s = calloc(16);
    if (crc32("JtFoPFgW",8) == 3863057968) strcat(s, "s");
if (crc32("oQNmuUYVjg",10) == 1238705777) strcat(s, "s");
if (crc32("snldOHnT",8) == 2775984089) strcat(s, "u");
if (crc32("DeLBg",5) == 2642773539) strcat(s, "g");
if (crc32("JamPlEMGPRBglmb",15) == 3841642306) strcat(s, "b");
if (crc32("fzwYjUf",7) == 2262611425) strcat(s, "n");
if (crc32("dymPIVb",7) == 1409358646) strcat(s, "a");
if (crc32("rNSRLIUEObEm",12) == 728345349) strcat(s, "Y");
if (crc32("Ddmud",5) == 2274171201) strcat(s, "c");
if (crc32("uzOuEQ",6) == 717115026) strcat(s, "l");
if (crc32("ldKREsBZiI",10) == 3817695695) strcat(s, "a");
if (crc32("bDPxUUxnaKztVD",14) == 193694885) strcat(s, "Y");
if (crc32("NjHSeFoqQdkKO",13) == 4027523033) strcat(s, "d");
if (crc32("bUANEo",6) == 228726610) strcat(s, "e");
if (crc32("jzRoS",5) == 2848740106) strcat(s, "i");
if (crc32("eWEJwLRyvPCfD",13) == 2232288093) strcat(s, "m");
if (crc32("SxGxBoiYWSMWewy",15) == 4205988102) strcat(s, "i");
if (crc32("iATDyWwcNVFWZN",14) == 2177382001) strcat(s, "v");
if (crc32("tfGeaPtbaA",10) == 3759082845) strcat(s, "c");
if (crc32("azJvr",5) == 1529224911) strcat(s, "f");
if (crc32("ksKzctYJ",8) == 1690664193) strcat(s, "a");
if (crc32("OiSAFb",6) == 1989256042) strcat(s, "l");
if (crc32("CwsvZJNGjdzr",12) == 4269064016) strcat(s, "l");
if (crc32("cjaXpAXIvLHbF",13) == 2045101567) strcat(s, "y");
    return s;
}

char *semitraditionally_adverbs() {
    char *s = calloc(18);
    if (crc32("eZEVfTOEMnlAM",13) == 292169912) strcat(s, "s");
if (crc32("skNFhqUIl",9) == 2722414853) strcat(s, "u");
if (crc32("lAoXPPef",8) == 3929102152) strcat(s, "e");
if (crc32("ukKUTiDAVJG",11) == 1884398587) strcat(s, "m");
if (crc32("HebiXVfVkMRDCg",14) == 2117616127) strcat(s, "i");
if (crc32("XbXaCX",6) == 1269124174) strcat(s, "t");
if (crc32("ZWTPOuw",7) == 2831738727) strcat(s, "F");
if (crc32("YtHiu",5) == 4255507529) strcat(s, "r");
if (crc32("vnHTuanhHjIQxu",14) == 2468975058) strcat(s, "a");
if (crc32("NimqZGY",7) == 3626393657) strcat(s, "d");
if (crc32("NYxaeVrx",8) == 2336605642) strcat(s, "i");
if (crc32("xhvVdqsy",8) == 555445177) strcat(s, "I");
if (crc32("ReGpSo",6) == 3221195496) strcat(s, "t");
if (crc32("oHgyKJonGgLMXDe",15) == 3907968864) strcat(s, "i");
if (crc32("CHBKUQzK",8) == 2395444794) strcat(s, "o");
if (crc32("eqYWPxEiWHI",11) == 2656527717) strcat(s, "o");
if (crc32("dHbesMdaa",9) == 2272242768) strcat(s, "n");
if (crc32("KMcvKfYwzudM",12) == 3524868430) strcat(s, "l");
if (crc32("IZfdGINOe",9) == 388992854) strcat(s, "a");
if (crc32("wqtEgHJKTs",10) == 3424758385) strcat(s, "l");
if (crc32("ZoPZwRxh",8) == 737763592) strcat(s, "F");
if (crc32("EcSoceKaPcRWk",13) == 415878755) strcat(s, "l");
if (crc32("RKPGwQYLY",9) == 3934771448) strcat(s, "y");
    return s;
}

char *uninterrogatively_adverbs() {
    char *s = calloc(18);
    if (crc32("mVfeSYIJcVd",11) == 2280048819) strcat(s, "u");
if (crc32("FGDhAuOyRXwetd",14) == 3272647575) strcat(s, "n");
if (crc32("mIkIuyDwecCLXhk",15) == 3826334921) strcat(s, "I");
if (crc32("pfEMamQWbwmW",12) == 4005357117) strcat(s, "i");
if (crc32("soRCOvyQBC",10) == 3246503981) strcat(s, "n");
if (crc32("YOVyegpRMR",10) == 479434897) strcat(s, "n");
if (crc32("RgOlhjtJHfe",11) == 1731913284) strcat(s, "t");
if (crc32("ZdFqc",5) == 3626532526) strcat(s, "M");
if (crc32("cZCkwkH",7) == 3605263639) strcat(s, "e");
if (crc32("QhUJG",5) == 3046789485) strcat(s, "r");
if (crc32("BEDiI",5) == 2222414077) strcat(s, "r");
if (crc32("FWIbffVSMEyyQR",14) == 2209938892) strcat(s, "o");
if (crc32("HxaFWMkcocw",11) == 394744443) strcat(s, "g");
if (crc32("wbvreDBnMWoeWh",14) == 4214319464) strcat(s, "a");
if (crc32("NsJVXod",7) == 853414786) strcat(s, "t");
if (crc32("vNNpJNMAKIpcOb",14) == 1531489823) strcat(s, "F");
if (crc32("CGizpXe",7) == 1899623761) strcat(s, "i");
if (crc32("gNLgoU",6) == 651071578) strcat(s, "v");
if (crc32("WvaNShZg",8) == 2649522561) strcat(s, "e");
if (crc32("jIlCHiUYGBbtONe",15) == 287031317) strcat(s, "l");
if (crc32("YzvHTXLlmXr",11) == 2802581993) strcat(s, "y");
    return s;
}

char *supernaturally_adverbs() {
    char *s = calloc(15);
    if (crc32("ZuCfkhDVmnvWV",13) == 1963876533) strcat(s, "Q");
if (crc32("YyOyKBsWNEja",12) == 1677887422) strcat(s, "s");
if (crc32("owtUXOQZQKYKibN",15) == 2228453970) strcat(s, "u");
if (crc32("RmLggQYKuQ",10) == 822257387) strcat(s, "W");
if (crc32("oRpvBucM",8) == 2156507658) strcat(s, "p");
if (crc32("UPQrKaOCB",9) == 3696992801) strcat(s, "e");
if (crc32("VGgegkylnZoEo",13) == 2394872825) strcat(s, "r");
if (crc32("qpJmYnqymw",10) == 3805920551) strcat(s, "F");
if (crc32("XvDAsvP",7) == 2588872238) strcat(s, "n");
if (crc32("OwwIDD",6) == 1403646114) strcat(s, "Q");
if (crc32("opzxcBzFYeJv",12) == 3459410266) strcat(s, "a");
if (crc32("TNeuxgk",7) == 1023374935) strcat(s, "P");
if (crc32("wtfOs",5) == 2604284119) strcat(s, "t");
if (crc32("zErtMtF",7) == 2360140818) strcat(s, "B");
if (crc32("vTrxzlhgmHr",11) == 2453032964) strcat(s, "u");
if (crc32("DlFRjO",6) == 3523170694) strcat(s, "r");
if (crc32("iejXYPykn",9) == 3371440971) strcat(s, "a");
if (crc32("mzlSzALSMC",10) == 3984056691) strcat(s, "l");
if (crc32("qpncMHHlTh",10) == 2034907636) strcat(s, "g");
if (crc32("yPOZKtGscXdPiy",14) == 2990435890) strcat(s, "l");
if (crc32("namxHkPwbktVHKb",15) == 3238550832) strcat(s, "y");
    return s;
}

char *rightdown_adverbs() {
    char *s = calloc(10);
    if (crc32("rdwFNRXAutgStRG",15) == 118036145) strcat(s, "r");
if (crc32("OeVDsSSwP",9) == 2847995439) strcat(s, "r");
if (crc32("gzraTnprvRGHbB",14) == 1493144978) strcat(s, "T");
if (crc32("tPqYGJ",6) == 2159903285) strcat(s, "i");
if (crc32("tnLdATCXnyt",11) == 151018052) strcat(s, "g");
if (crc32("MvIZIcuJ",8) == 2242470788) strcat(s, "i");
if (crc32("lySwotgvyqfqJtB",15) == 3438492055) strcat(s, "h");
if (crc32("pBMguVYdpQZq",12) == 2896151644) strcat(s, "p");
if (crc32("IUnmIWgL",8) == 2876817968) strcat(s, "t");
if (crc32("UuKzkHMMjAXTMp",14) == 4020186020) strcat(s, "d");
if (crc32("PlmZWeHppyb",11) == 91181460) strcat(s, "o");
if (crc32("oYgNjcCFRK",10) == 3647993178) strcat(s, "t");
if (crc32("kPeGbeUuomHo",12) == 926959146) strcat(s, "w");
if (crc32("lQQxRsXchMqRZz",14) == 1653400) strcat(s, "n");
    return s;
}

char *unprintably_adverbs() {
    char *s = calloc(12);
    if (crc32("ZtHiLcvoTYM",11) == 2046893196) strcat(s, "z");
if (crc32("akISwTu",7) == 4056129268) strcat(s, "u");
if (crc32("LnVJYcDz",8) == 1385432646) strcat(s, "s");
if (crc32("eJTirDH",7) == 3673930537) strcat(s, "n");
if (crc32("yMLOfnxeAy",10) == 3539592009) strcat(s, "p");
if (crc32("NTyFfeZGLWyvk",13) == 276334418) strcat(s, "V");
if (crc32("DHbUPJMtCqEyYUH",15) == 909998947) strcat(s, "r");
if (crc32("psZgtCItr",9) == 2848023394) strcat(s, "i");
if (crc32("gYfKCnwv",8) == 3930027377) strcat(s, "n");
if (crc32("cBKFNYqG",8) == 3941928237) strcat(s, "T");
if (crc32("oIvqxRB",7) == 661212354) strcat(s, "t");
if (crc32("amDNSdqVgnPbQe",14) == 1617669214) strcat(s, "a");
if (crc32("uSRmvh",6) == 3078746393) strcat(s, "Q");
if (crc32("dErnTXpD",8) == 1058428306) strcat(s, "b");
if (crc32("xblkJM",6) == 406597513) strcat(s, "N");
if (crc32("KXaMbUpvTGB",11) == 1981681461) strcat(s, "l");
if (crc32("pYESJ",5) == 4164665032) strcat(s, "y");
    return s;
}

char *contrapuntally_adverbs() {
    char *s = calloc(15);
    if (crc32("KhdtyjtmlL",10) == 3274873001) strcat(s, "c");
if (crc32("ivuztdNgwQ",10) == 1462308768) strcat(s, "o");
if (crc32("lBcoQN",6) == 3021713881) strcat(s, "n");
if (crc32("BMIRCdTLHoq",11) == 2406612578) strcat(s, "T");
if (crc32("FDNquxdOR",9) == 285185366) strcat(s, "t");
if (crc32("HeyFJTckoKqgoZN",15) == 1559339786) strcat(s, "E");
if (crc32("dPIazlvQKSt",11) == 3570541336) strcat(s, "r");
if (crc32("ImIJGf",6) == 3347580801) strcat(s, "M");
if (crc32("PaIWTtrxdLG",11) == 2446606956) strcat(s, "a");
if (crc32("jyWdpe",6) == 3884759015) strcat(s, "p");
if (crc32("CxzLKkJj",8) == 1369377038) strcat(s, "D");
if (crc32("QwIblkOBxyoW",12) == 723608796) strcat(s, "u");
if (crc32("wMbDZAoxmiWV",12) == 4251448394) strcat(s, "v");
if (crc32("aLqdnYVdRiKqPE",14) == 899469152) strcat(s, "n");
if (crc32("rBrlUcryehwu",12) == 1794518202) strcat(s, "t");
if (crc32("RJWafumv",8) == 46245072) strcat(s, "a");
if (crc32("TZIUHuU",7) == 2031290451) strcat(s, "l");
if (crc32("nqynvBaghXSb",12) == 1795157215) strcat(s, "l");
if (crc32("VZtuSlHNZ",9) == 4125184175) strcat(s, "l");
if (crc32("rtfaLOr",7) == 1403679838) strcat(s, "y");
    return s;
}

char *quasimusically_adverbs() {
    char *s = calloc(15);
    if (crc32("QNsgSiCyA",9) == 1722968617) strcat(s, "X");
if (crc32("lLAMhcxkYIQHB",13) == 3366873955) strcat(s, "q");
if (crc32("arDTQAoRfZYhPqz",15) == 1566931651) strcat(s, "u");
if (crc32("QXxePDAvmJyk",12) == 1014606279) strcat(s, "T");
if (crc32("guqFbdnPxnBhaRt",15) == 1845956195) strcat(s, "a");
if (crc32("EFdtVrgB",8) == 3083757948) strcat(s, "s");
if (crc32("JggSDJRrMdO",11) == 2367854379) strcat(s, "i");
if (crc32("aARDCWEhxgYTcB",14) == 1810388274) strcat(s, "m");
if (crc32("lGGGad",6) == 1910979568) strcat(s, "h");
if (crc32("MNjKMn",6) == 575559272) strcat(s, "u");
if (crc32("uFoVwfklQ",9) == 3506404272) strcat(s, "s");
if (crc32("VZSAr",5) == 3348095767) strcat(s, "n");
if (crc32("jmmfdhcVaQiNs",13) == 2676452024) strcat(s, "i");
if (crc32("TYbbadQrC",9) == 3199614983) strcat(s, "Y");
if (crc32("GgmLpkQsv",9) == 3520077446) strcat(s, "c");
if (crc32("QTTty",5) == 2382461589) strcat(s, "a");
if (crc32("GRjWLsLOsNte",12) == 1862032041) strcat(s, "p");
if (crc32("PuUTDyBSuWuX",12) == 1404454105) strcat(s, "l");
if (crc32("dNMuWROINnWuUF",14) == 1268369999) strcat(s, "l");
if (crc32("NkkYRIFwM",9) == 267524867) strcat(s, "j");
if (crc32("nntUAFMiNjcUCjs",15) == 1049498105) strcat(s, "y");
    return s;
}

char *materially_adverbs() {
    char *s = calloc(11);
    if (crc32("qxyctxAbh",9) == 1322739925) strcat(s, "m");
if (crc32("GOUnSJH",7) == 3585020543) strcat(s, "a");
if (crc32("VEbLATMzuBD",11) == 3221159542) strcat(s, "t");
if (crc32("IwluV",5) == 4104396342) strcat(s, "e");
if (crc32("RbjqTuU",7) == 1323798272) strcat(s, "r");
if (crc32("jGIoWF",6) == 1034730842) strcat(s, "i");
if (crc32("vhQNAVjSgGhv",12) == 4169698543) strcat(s, "h");
if (crc32("HAoFZccLRVp",11) == 3474321634) strcat(s, "a");
if (crc32("RIgrovp",7) == 2185695593) strcat(s, "V");
if (crc32("BFJdDgBDsHmMMeQ",15) == 3803830012) strcat(s, "l");
if (crc32("AmPgEAX",7) == 1233821394) strcat(s, "d");
if (crc32("lMhtQ",5) == 3798313657) strcat(s, "l");
if (crc32("SuTLKDZtEjg",11) == 3046716008) strcat(s, "y");
    return s;
}

char *necrologically_adverbs() {
    char *s = calloc(15);
    if (crc32("jKOBUYyb",8) == 2093472109) strcat(s, "n");
if (crc32("olKJBithnA",10) == 1664325008) strcat(s, "e");
if (crc32("sXMAL",5) == 1385039217) strcat(s, "X");
if (crc32("szeCLl",6) == 3925491568) strcat(s, "c");
if (crc32("gdlEjzXm",8) == 1665939069) strcat(s, "r");
if (crc32("EqukpMjvbujrT",13) == 3131375482) strcat(s, "u");
if (crc32("jGvvBOSCq",9) == 758600042) strcat(s, "o");
if (crc32("jDfJwZzX",8) == 2130765094) strcat(s, "l");
if (crc32("NfJlPky",7) == 2393410321) strcat(s, "D");
if (crc32("RcjtCpfoH",9) == 4192734503) strcat(s, "o");
if (crc32("GhZCWNMzyqIlzf",14) == 3209617366) strcat(s, "f");
if (crc32("rGIetcXV",8) == 769179845) strcat(s, "g");
if (crc32("PwYdmrfGaQ",10) == 3349571340) strcat(s, "i");
if (crc32("GHvkk",5) == 2118393288) strcat(s, "c");
if (crc32("OqsFDv",6) == 2878369901) strcat(s, "a");
if (crc32("fjAbItlyAk",10) == 855066783) strcat(s, "l");
if (crc32("NMbvXNsFjR",10) == 1101453477) strcat(s, "l");
if (crc32("nwhKHGJfZDgVy",13) == 2974755145) strcat(s, "y");
    return s;
}

char *sanitarily_adverbs() {
    char *s = calloc(11);
    if (crc32("roIPQqOMEeA",11) == 1395888489) strcat(s, "s");
if (crc32("MILtwLayDSjpEY",14) == 1483231999) strcat(s, "M");
if (crc32("aeIJB",5) == 2206703533) strcat(s, "a");
if (crc32("CjqwGY",6) == 3292413747) strcat(s, "n");
if (crc32("mpZuZMDvDcO",11) == 3638102623) strcat(s, "f");
if (crc32("zEfYlPT",7) == 3186029564) strcat(s, "i");
if (crc32("swlOIhRLVgtYJtv",15) == 3033971082) strcat(s, "t");
if (crc32("wmnwehnJ",8) == 1013102292) strcat(s, "e");
if (crc32("yqQHNDxR",8) == 1571327907) strcat(s, "a");
if (crc32("GzuxSxA",7) == 2701610995) strcat(s, "r");
if (crc32("RQRUw",5) == 2705623633) strcat(s, "n");
if (crc32("JQMEZ",5) == 3642933771) strcat(s, "i");
if (crc32("mntdMyDW",8) == 1509973640) strcat(s, "l");
if (crc32("rHwqQHHjauuX",12) == 349907418) strcat(s, "y");
    return s;
}

char *unconflictingly_adverbs() {
    char *s = calloc(16);
    if (crc32("OSfFuEC",7) == 1037640810) strcat(s, "u");
if (crc32("KWHukLIiMJbqNP",14) == 1577949778) strcat(s, "S");
if (crc32("HqxoSFbyCdRbq",13) == 332882452) strcat(s, "n");
if (crc32("UYXLbxfogAtYwPL",15) == 3939062013) strcat(s, "c");
if (crc32("BGTxqQpei",9) == 4065955842) strcat(s, "R");
if (crc32("gBcMrPPAo",9) == 2900877993) strcat(s, "o");
if (crc32("CajfuETe",8) == 2572411365) strcat(s, "n");
if (crc32("KvZOcdEjGUz",11) == 2634199085) strcat(s, "f");
if (crc32("whDPJeozJuzNC",13) == 3221087481) strcat(s, "q");
if (crc32("NIgJMKeMvNtPG",13) == 677540283) strcat(s, "l");
if (crc32("jWdEFeiTZFRgYtJ",15) == 149624343) strcat(s, "k");
if (crc32("ApNqoGLfA",9) == 27724705) strcat(s, "i");
if (crc32("rmaoxCfsSxOhwQW",15) == 3127718543) strcat(s, "j");
if (crc32("qFwnK",5) == 4146174311) strcat(s, "c");
if (crc32("xnOViGGzBbvSKvK",15) == 490829966) strcat(s, "t");
if (crc32("fLOWxna",7) == 3777753476) strcat(s, "G");
if (crc32("eFICjGf",7) == 520670207) strcat(s, "i");
if (crc32("dktLADDz",8) == 3187442997) strcat(s, "R");
if (crc32("aiqxCUCX",8) == 866377112) strcat(s, "n");
if (crc32("CSePWo",6) == 596311882) strcat(s, "y");
if (crc32("OGwNuvTgDgJ",11) == 971766220) strcat(s, "g");
if (crc32("IxqpbYrCDeetKx",14) == 303610844) strcat(s, "Y");
if (crc32("FWjpAOlnA",9) == 755676783) strcat(s, "l");
if (crc32("naDeyTbbcPFD",12) == 4206855556) strcat(s, "y");
    return s;
}

char *quasiconnectively_adverbs() {
    char *s = calloc(18);
    if (crc32("vrEFmFLwhzBaMQ",14) == 2342370376) strcat(s, "O");
if (crc32("gPcLDYAJaKw",11) == 782683247) strcat(s, "q");
if (crc32("GmZorWKWQ",9) == 371720869) strcat(s, "H");
if (crc32("ryISG",5) == 1432536911) strcat(s, "u");
if (crc32("JLepdRrpChK",11) == 2880219798) strcat(s, "w");
if (crc32("JAtfxUt",7) == 1632298892) strcat(s, "a");
if (crc32("zTIWmK",6) == 27861413) strcat(s, "G");
if (crc32("llbqICJGPhA",11) == 1684127708) strcat(s, "s");
if (crc32("pmPxHCdAJBPTImL",15) == 2521509813) strcat(s, "Q");
if (crc32("lfCjyhkPYKj",11) == 784013331) strcat(s, "i");
if (crc32("crWzFsoU",8) == 4092885737) strcat(s, "c");
if (crc32("AKYmj",5) == 4059943243) strcat(s, "o");
if (crc32("BQhPYX",6) == 3198824285) strcat(s, "O");
if (crc32("VZODEdQnqEkCM",13) == 713905866) strcat(s, "n");
if (crc32("NrNGuWGR",8) == 3727809657) strcat(s, "e");
if (crc32("McsXyMycThZtkCc",15) == 775030459) strcat(s, "n");
if (crc32("WOHtgwvQGmA",11) == 728961427) strcat(s, "t");
if (crc32("rwrSfg",6) == 4083675538) strcat(s, "e");
if (crc32("FnlndQDRXSnvsIl",15) == 3462848733) strcat(s, "c");
if (crc32("FdAbYPZviEFiikZ",15) == 2749521237) strcat(s, "t");
if (crc32("nKrzLt",6) == 1072404076) strcat(s, "i");
if (crc32("LpWjRTd",7) == 813502145) strcat(s, "v");
if (crc32("NFMtAvkd",8) == 2121805023) strcat(s, "e");
if (crc32("oNXQXdR",7) == 1668459535) strcat(s, "r");
if (crc32("pfJgxp",6) == 2722154929) strcat(s, "l");
if (crc32("lEsiitrPjSM",11) == 1432992471) strcat(s, "y");
    return s;
}

char *dynamitically_adverbs() {
    char *s = calloc(14);
    if (crc32("PghJBpl",7) == 3660993217) strcat(s, "a");
if (crc32("LxwGUNeVaBV",11) == 394848094) strcat(s, "d");
if (crc32("issrgFnXgXVaP",13) == 4127845186) strcat(s, "y");
if (crc32("kuKwnBHysjNT",12) == 1626523671) strcat(s, "n");
if (crc32("ZjNeqdYbZk",10) == 2865142737) strcat(s, "a");
if (crc32("lBIJM",5) == 3595424010) strcat(s, "m");
if (crc32("DAMpCg",6) == 1972738221) strcat(s, "i");
if (crc32("wlgnx",5) == 337175035) strcat(s, "t");
if (crc32("qAhueVUdTwpE",12) == 1814283684) strcat(s, "N");
if (crc32("pcYqCcAKvAp",11) == 710974720) strcat(s, "i");
if (crc32("MoVUd",5) == 3760640738) strcat(s, "c");
if (crc32("XhUuBv",6) == 765311760) strcat(s, "a");
if (crc32("sYYWhqzUXU",10) == 4187233785) strcat(s, "q");
if (crc32("OZOTGJlOqMlACPi",15) == 1604806160) strcat(s, "l");
if (crc32("EtQtTn",6) == 1620617377) strcat(s, "e");
if (crc32("kUIflHwaPnyQ",12) == 1328155760) strcat(s, "l");
if (crc32("MrBdC",5) == 976086229) strcat(s, "y");
    return s;
}

char *coaxingly_adverbs() {
    char *s = calloc(10);
    if (crc32("WcHCyT",6) == 3227287656) strcat(s, "c");
if (crc32("ETaMACmew",9) == 29244816) strcat(s, "D");
if (crc32("LhvfMXdYsYpICU",14) == 2980544167) strcat(s, "o");
if (crc32("QWzHwFA",7) == 314665694) strcat(s, "a");
if (crc32("NbFgNDxsNHYb",12) == 424581099) strcat(s, "x");
if (crc32("SUhEqZ",6) == 967299547) strcat(s, "K");
if (crc32("GVoTZTwTRDy",11) == 3214612915) strcat(s, "i");
if (crc32("WZYLOmgljlsQjb",14) == 3324798292) strcat(s, "S");
if (crc32("WgYQmxyPINJVF",13) == 4127100533) strcat(s, "n");
if (crc32("IVSmyxEW",8) == 3432626798) strcat(s, "g");
if (crc32("HdQpqVcATVtrPRX",15) == 4249952247) strcat(s, "l");
if (crc32("BFaPPbmVMHyjkC",14) == 2261366463) strcat(s, "y");
    return s;
}

char *biserially_adverbs() {
    char *s = calloc(11);
    if (crc32("bhGPCnDCidHKLbl",15) == 214522118) strcat(s, "k");
if (crc32("URIjXpKwcnSi",12) == 3738779458) strcat(s, "b");
if (crc32("PwHyStbSSj",10) == 146282852) strcat(s, "i");
if (crc32("doYFnhozMI",10) == 1051114158) strcat(s, "s");
if (crc32("WwhhXVr",7) == 179061652) strcat(s, "e");
if (crc32("BBgHxcjNdHst",12) == 663587348) strcat(s, "g");
if (crc32("OjNRfbmCadyDrBt",15) == 2070871971) strcat(s, "r");
if (crc32("HlQzRlW",7) == 3371870433) strcat(s, "t");
if (crc32("xUMNaAZzPOLbS",13) == 1921684009) strcat(s, "i");
if (crc32("MaiHld",6) == 154513357) strcat(s, "E");
if (crc32("HVImtHYKAmwkTJ",14) == 4112614766) strcat(s, "a");
if (crc32("PliqzF",6) == 1541033679) strcat(s, "J");
if (crc32("lBbzlC",6) == 34833188) strcat(s, "l");
if (crc32("qhchjPDx",8) == 1557997455) strcat(s, "T");
if (crc32("PTkfQfaOkn",10) == 356042337) strcat(s, "l");
if (crc32("GztlYujWB",9) == 1207014636) strcat(s, "y");
    return s;
}

char *teknonymously_adverbs() {
    char *s = calloc(14);
    if (crc32("wTYooiqRDsbnd",13) == 2085032984) strcat(s, "i");
if (crc32("kTDsmyMNvbVN",12) == 2861846854) strcat(s, "t");
if (crc32("OqGzLlzsCduw",12) == 1675398855) strcat(s, "e");
if (crc32("BngeoFfFTAKlit",14) == 3759105486) strcat(s, "o");
if (crc32("cZlQW",5) == 2875363136) strcat(s, "k");
if (crc32("JiexMwnYszLTT",13) == 3233862587) strcat(s, "u");
if (crc32("aGUyOWS",7) == 946474102) strcat(s, "n");
if (crc32("NktPcnOu",8) == 1148256011) strcat(s, "o");
if (crc32("bpTODKjvavXuuEx",15) == 3668681085) strcat(s, "n");
if (crc32("oDlTbqoJwCZzm",13) == 2288352379) strcat(s, "E");
if (crc32("GoufGEDwgXQCDTv",15) == 2900607030) strcat(s, "y");
if (crc32("jagdEwoFiobTx",13) == 4234848871) strcat(s, "B");
if (crc32("gfNERTBK",8) == 3688581099) strcat(s, "m");
if (crc32("EGfatTf",7) == 622080334) strcat(s, "o");
if (crc32("zBeKbkLNvGoxFs",14) == 2105404053) strcat(s, "F");
if (crc32("nrctf",5) == 2214943680) strcat(s, "u");
if (crc32("DaJCCWNF",8) == 1169364596) strcat(s, "s");
if (crc32("mSWMQSuuXWmal",13) == 1256484592) strcat(s, "l");
if (crc32("GxEpKN",6) == 284101247) strcat(s, "y");
    return s;
}

char *unfunnily_adverbs() {
    char *s = calloc(10);
    if (crc32("FCxcMHNsREuO",12) == 2255722253) strcat(s, "u");
if (crc32("rCQwLS",6) == 1692023205) strcat(s, "n");
if (crc32("ROFNeYPSTlc",11) == 3499746473) strcat(s, "f");
if (crc32("KXGqd",5) == 4002860987) strcat(s, "u");
if (crc32("nfQBDxMzpSWnKZS",15) == 437640172) strcat(s, "V");
if (crc32("ZrGguAZemVeh",12) == 1327912517) strcat(s, "n");
if (crc32("qvyWws",6) == 3516428860) strcat(s, "n");
if (crc32("flmPh",5) == 637231778) strcat(s, "f");
if (crc32("ZfHfDPfnnw",10) == 3038399916) strcat(s, "i");
if (crc32("kEDRw",5) == 3044402971) strcat(s, "l");
if (crc32("gIGly",5) == 2963129172) strcat(s, "b");
if (crc32("jYTdtJR",7) == 1022872430) strcat(s, "y");
    return s;
}

char *mimically_adverbs() {
    char *s = calloc(10);
    if (crc32("pxXpQcHdzEDR",12) == 2396436706) strcat(s, "m");
if (crc32("LFIiJDyqtg",10) == 1687501086) strcat(s, "i");
if (crc32("qYFZBCQr",8) == 1180500786) strcat(s, "i");
if (crc32("XJsArBk",7) == 4044742026) strcat(s, "m");
if (crc32("BQwCroAIrfHZZL",14) == 2720040883) strcat(s, "n");
if (crc32("JlzaH",5) == 4162224524) strcat(s, "i");
if (crc32("UguXaqVf",8) == 4225819750) strcat(s, "c");
if (crc32("grrFyJJsMbK",11) == 2735618829) strcat(s, "a");
if (crc32("pDwmojPZbShM",12) == 2181814310) strcat(s, "l");
if (crc32("FZgXiLuaPQKzewx",15) == 3550915080) strcat(s, "u");
if (crc32("FWvvIB",6) == 1169253467) strcat(s, "l");
if (crc32("bOjDvIIEW",9) == 803544394) strcat(s, "q");
if (crc32("hgjmkVYE",8) == 153745614) strcat(s, "y");
    return s;
}

char *nonapostolically_adverbs() {
    char *s = calloc(17);
    if (crc32("pdlGLVJQIe",10) == 2836423963) strcat(s, "g");
if (crc32("PcgYlRBUCHbC",12) == 2903052396) strcat(s, "n");
if (crc32("XGpOyKlzetMmaoo",15) == 2015983786) strcat(s, "o");
if (crc32("GCcMJjubuIU",11) == 3079063246) strcat(s, "n");
if (crc32("SfbmtSxCqGQO",12) == 2418378792) strcat(s, "y");
if (crc32("otYCUwBB",8) == 3085725342) strcat(s, "a");
if (crc32("HjxxsmATbuc",11) == 1538605873) strcat(s, "o");
if (crc32("NaYbUXUQtLvnY",13) == 1091905291) strcat(s, "p");
if (crc32("NXTns",5) == 1455929439) strcat(s, "n");
if (crc32("hRdHDUuURZq",11) == 3993948095) strcat(s, "o");
if (crc32("gzxuNJrXtWXBV",13) == 2874119177) strcat(s, "s");
if (crc32("ofxNGxgBzPkiJ",13) == 4061565486) strcat(s, "t");
if (crc32("POVPwh",6) == 439405407) strcat(s, "R");
if (crc32("ScJuH",5) == 3342882540) strcat(s, "o");
if (crc32("bjgeUhMOZjCnMLW",15) == 3692110076) strcat(s, "q");
if (crc32("GVkLBIRhnlV",11) == 3463563687) strcat(s, "l");
if (crc32("SCgAU",5) == 3334181890) strcat(s, "g");
if (crc32("FSTbRAv",7) == 1395516276) strcat(s, "i");
if (crc32("uerFyb",6) == 1402969666) strcat(s, "c");
if (crc32("TVOGXSKP",8) == 1745538031) strcat(s, "w");
if (crc32("rVaGyg",6) == 2602502757) strcat(s, "a");
if (crc32("VsBcLUH",7) == 1750746115) strcat(s, "Z");
if (crc32("jrtpUgPdSmH",11) == 79311728) strcat(s, "l");
if (crc32("MxGUZhkFMDhut",13) == 888041769) strcat(s, "l");
if (crc32("NMaSpF",6) == 2731978919) strcat(s, "G");
if (crc32("QpuJQTRVM",9) == 4115350818) strcat(s, "y");
    return s;
}

char *phrenetically_adverbs() {
    char *s = calloc(14);
    if (crc32("hHRwSsSTRYxfU",13) == 4127753225) strcat(s, "y");
if (crc32("efEMyTdbaVOcOpj",15) == 2272433439) strcat(s, "p");
if (crc32("pFoIYYIvZhEcu",13) == 3354549582) strcat(s, "h");
if (crc32("yLxZic",6) == 3616571614) strcat(s, "m");
if (crc32("GmdpyioRQMaun",13) == 494240059) strcat(s, "r");
if (crc32("sEpLxUtaIYjIrg",14) == 2940003923) strcat(s, "X");
if (crc32("yiUaIpX",7) == 2378879670) strcat(s, "e");
if (crc32("iwCsCpJ",7) == 945169467) strcat(s, "n");
if (crc32("xjYDPRoniX",10) == 2416215350) strcat(s, "T");
if (crc32("OsdRHJ",6) == 2221634572) strcat(s, "e");
if (crc32("LYkCDSh",7) == 4150913570) strcat(s, "t");
if (crc32("beKnH",5) == 3953141047) strcat(s, "C");
if (crc32("UCqDGSU",7) == 1254840080) strcat(s, "i");
if (crc32("ZFYtGLoYxL",10) == 2568008105) strcat(s, "P");
if (crc32("EIWJYQKsISsXp",13) == 2924283409) strcat(s, "c");
if (crc32("GgtPUH",6) == 3215411682) strcat(s, "a");
if (crc32("FNlUNkMuVyGNt",13) == 731208270) strcat(s, "S");
if (crc32("ummSXKnZevOvpq",14) == 2689890377) strcat(s, "l");
if (crc32("VHOEWQOEBpiYSf",14) == 1757878359) strcat(s, "K");
if (crc32("FsliJuw",7) == 3435766701) strcat(s, "l");
if (crc32("VXnSYCyMo",9) == 1330236919) strcat(s, "y");
    return s;
}

char *unspeciously_adverbs() {
    char *s = calloc(13);
    if (crc32("teuxPGsnssqoM",13) == 1766705960) strcat(s, "U");
if (crc32("qKLEaoH",7) == 1347615956) strcat(s, "u");
if (crc32("xuXlUOag",8) == 2769577765) strcat(s, "C");
if (crc32("SaNxaqyxBSpyE",13) == 2335269111) strcat(s, "n");
if (crc32("KoGAqY",6) == 920280550) strcat(s, "K");
if (crc32("HVezphWcfKDPh",13) == 3033385574) strcat(s, "s");
if (crc32("vYhZkTunp",9) == 1767451656) strcat(s, "p");
if (crc32("htEVbrYuJQfYLlR",15) == 2826250875) strcat(s, "e");
if (crc32("rCvNe",5) == 560088957) strcat(s, "K");
if (crc32("uAQxMX",6) == 2257253769) strcat(s, "c");
if (crc32("FtAFVL",6) == 2695182238) strcat(s, "i");
if (crc32("tJONtGAbkQe",11) == 1879741735) strcat(s, "P");
if (crc32("ucHJsdueuAfnxR",14) == 804446407) strcat(s, "o");
if (crc32("sMlTtNGMTfm",11) == 3388033719) strcat(s, "u");
if (crc32("lTTBPGRvABG",11) == 2735794176) strcat(s, "s");
if (crc32("YXSYjKMExmKO",12) == 3201730294) strcat(s, "X");
if (crc32("vlejZ",5) == 2616236229) strcat(s, "l");
if (crc32("ljCgfnABJYW",11) == 3863706297) strcat(s, "N");
if (crc32("fODLJoy",7) == 1090826738) strcat(s, "y");
    return s;
}

char *captiously_adverbs() {
    char *s = calloc(11);
    if (crc32("qKuvSymWerRcNd",14) == 566565346) strcat(s, "c");
if (crc32("WuAzzrDUi",9) == 2854892039) strcat(s, "a");
if (crc32("OkfXguVuhXW",11) == 1043966314) strcat(s, "l");
if (crc32("YHzfrZG",7) == 2593945209) strcat(s, "p");
if (crc32("kLWsMFsS",8) == 2975442914) strcat(s, "H");
if (crc32("dxKaZVeCXABT",12) == 721665085) strcat(s, "t");
if (crc32("jUHdish",7) == 844305853) strcat(s, "i");
if (crc32("icxTNYyNwilE",12) == 4070345341) strcat(s, "o");
if (crc32("QIzrlAkulh",10) == 3222822980) strcat(s, "C");
if (crc32("mWXhPdAvEPuU",12) == 3231940559) strcat(s, "u");
if (crc32("UvRQe",5) == 594511510) strcat(s, "i");
if (crc32("YLwLcj",6) == 1805586807) strcat(s, "s");
if (crc32("wDNEhydNXRNcIj",14) == 2622352159) strcat(s, "l");
if (crc32("LniKqEKS",8) == 2215147937) strcat(s, "v");
if (crc32("cWCpfQClcOVn",12) == 2720285290) strcat(s, "y");
    return s;
}

char *vociferously_adverbs() {
    char *s = calloc(13);
    if (crc32("EitsJFFYbRGqHiQ",15) == 3623521766) strcat(s, "v");
if (crc32("uiRaQPfTFfQ",11) == 1654769025) strcat(s, "k");
if (crc32("CzvzhvKGnI",10) == 2384914896) strcat(s, "o");
if (crc32("nFYuogDlh",9) == 1962648988) strcat(s, "I");
if (crc32("hlVPrkyFqWGQ",12) == 1281578849) strcat(s, "c");
if (crc32("lAuoGzIfGEh",11) == 2764428854) strcat(s, "J");
if (crc32("TiGpMkhjlKOnG",13) == 2973478812) strcat(s, "i");
if (crc32("RRSopJpG",8) == 2259045574) strcat(s, "f");
if (crc32("NwkeFVnMe",9) == 2228710758) strcat(s, "e");
if (crc32("ciVlXdlvMgoguSQ",15) == 3125487310) strcat(s, "r");
if (crc32("VvDkBo",6) == 1379001795) strcat(s, "o");
if (crc32("QbPLdAp",7) == 1117444070) strcat(s, "u");
if (crc32("hrmxTKKAcLAXhr",14) == 2104728970) strcat(s, "s");
if (crc32("WIasFzZERSr",11) == 250094600) strcat(s, "B");
if (crc32("enuwhCKtXUP",11) == 2909274744) strcat(s, "l");
if (crc32("MALZYgUy",8) == 3520562527) strcat(s, "a");
if (crc32("VWmozjXJTErfh",13) == 2313796348) strcat(s, "y");
    return s;
}

char *unauthoritatively_adverbs() {
    char *s = calloc(18);
    if (crc32("hhIrzNbkczwCk",13) == 1897987786) strcat(s, "U");
if (crc32("GHsTWkkYqHZ",11) == 995142060) strcat(s, "u");
if (crc32("tYXxqnlhTliqXoF",15) == 292277063) strcat(s, "K");
if (crc32("ZIcFBEoQi",9) == 239346523) strcat(s, "n");
if (crc32("fdgcQCnJUlMT",12) == 1384092506) strcat(s, "a");
if (crc32("icutCrc",7) == 1663298503) strcat(s, "u");
if (crc32("srsxuwILxGnmx",13) == 4100496855) strcat(s, "t");
if (crc32("dxkMYNigBOdKsik",15) == 3050157991) strcat(s, "x");
if (crc32("magzH",5) == 3293925884) strcat(s, "h");
if (crc32("deIFm",5) == 1275290248) strcat(s, "o");
if (crc32("lsgvZPJshlztyz",14) == 4224365786) strcat(s, "x");
if (crc32("txzPpl",6) == 3956703159) strcat(s, "r");
if (crc32("XqhrpqyypmN",11) == 1654301872) strcat(s, "i");
if (crc32("qIfTbflsBSvw",12) == 3276366368) strcat(s, "B");
if (crc32("IsOhmoM",7) == 1333760761) strcat(s, "t");
if (crc32("WNKMCWWlKdKEyOl",15) == 3583751553) strcat(s, "o");
if (crc32("bmVctIWc",8) == 2745157896) strcat(s, "a");
if (crc32("TeIJsrELs",9) == 2698746595) strcat(s, "y");
if (crc32("TXCfaiTayeNvnBL",15) == 4163461602) strcat(s, "t");
if (crc32("SsEfs",5) == 176179036) strcat(s, "a");
if (crc32("ybHCxlzC",8) == 3809450471) strcat(s, "i");
if (crc32("nFvcPME",7) == 1454784095) strcat(s, "I");
if (crc32("QYLiWwEWUC",10) == 3169354024) strcat(s, "v");
if (crc32("exhycZp",7) == 1556231820) strcat(s, "N");
if (crc32("KcSprBTbF",9) == 3967522866) strcat(s, "e");
if (crc32("eXQbDyZC",8) == 702812248) strcat(s, "l");
if (crc32("nEWjPWzQ",8) == 3614681290) strcat(s, "P");
if (crc32("LUHBGCEm",8) == 1641527371) strcat(s, "y");
    return s;
}

char *unoffensively_adverbs() {
    char *s = calloc(14);
    if (crc32("yEJCOY",6) == 1509356835) strcat(s, "z");
if (crc32("HxDxjuQRoDlJTJ",14) == 1978477120) strcat(s, "u");
if (crc32("keOoDdkYUADzf",13) == 2479175735) strcat(s, "n");
if (crc32("zCPDmdMoFpgsTJn",15) == 2717400390) strcat(s, "z");
if (crc32("YrrIYdEpgRlhKWO",15) == 1923102731) strcat(s, "o");
if (crc32("dccNOdEece",10) == 391822626) strcat(s, "f");
if (crc32("RNzzsX",6) == 721531130) strcat(s, "f");
if (crc32("sFUhmzo",7) == 1007353757) strcat(s, "X");
if (crc32("kApgCFSI",8) == 1238321879) strcat(s, "e");
if (crc32("GEPZMdjbXEAOlc",14) == 4053653674) strcat(s, "n");
if (crc32("GKCPSlX",7) == 3904000323) strcat(s, "R");
if (crc32("lXZAgrChcB",10) == 1220872187) strcat(s, "s");
if (crc32("SqRsW",5) == 4140180096) strcat(s, "h");
if (crc32("sExDzNzbh",9) == 2155424680) strcat(s, "i");
if (crc32("RmlaIJxDx",9) == 1494944863) strcat(s, "k");
if (crc32("PQMlAFe",7) == 1113301883) strcat(s, "v");
if (crc32("KCbwwOGcBSG",11) == 567454701) strcat(s, "e");
if (crc32("qHyaItTQiKpJxAU",15) == 1719837522) strcat(s, "P");
if (crc32("BUNoB",5) == 410121402) strcat(s, "l");
if (crc32("JSMkJsr",7) == 3832662483) strcat(s, "f");
if (crc32("ySfrmbfoHKzcF",13) == 2979285338) strcat(s, "y");
    return s;
}

char *guilefully_adverbs() {
    char *s = calloc(11);
    if (crc32("qKNYiaBd",8) == 3291363354) strcat(s, "g");
if (crc32("CUSCmZMdyPees",13) == 1222208014) strcat(s, "x");
if (crc32("XBmpF",5) == 265496193) strcat(s, "u");
if (crc32("QyQMtvmPkFVCEno",15) == 2912821332) strcat(s, "i");
if (crc32("pnpEKJoQhdOH",12) == 3917918325) strcat(s, "l");
if (crc32("gyfGJS",6) == 3281881252) strcat(s, "e");
if (crc32("jyDqmhv",7) == 615352460) strcat(s, "a");
if (crc32("KSbzqeUWkqs",11) == 2355972176) strcat(s, "f");
if (crc32("qrVDAAJcMG",10) == 2094807443) strcat(s, "Q");
if (crc32("WHJUUIWOYmLzlX",14) == 161312281) strcat(s, "u");
if (crc32("hRCCEGNkBnynTpA",15) == 653884159) strcat(s, "Z");
if (crc32("EsOTXJRgMikqvcO",15) == 533177649) strcat(s, "l");
if (crc32("iVpLcFtIdZNZ",12) == 4074796062) strcat(s, "S");
if (crc32("WZjPZC",6) == 1162662565) strcat(s, "l");
if (crc32("VqheTCpnngP",11) == 3797178985) strcat(s, "y");
    return s;
}

char *uneffusively_adverbs() {
    char *s = calloc(13);
    if (crc32("UOgZPSf",7) == 3302359302) strcat(s, "u");
if (crc32("KcmfeGH",7) == 2748088705) strcat(s, "n");
if (crc32("JeISwUWbOLLY",12) == 2663992772) strcat(s, "K");
if (crc32("lsKjgcIrgGnCg",13) == 1832939178) strcat(s, "e");
if (crc32("XOJzvONso",9) == 1169390315) strcat(s, "B");
if (crc32("BfihglSa",8) == 744137631) strcat(s, "f");
if (crc32("SjTAxTQglGgA",12) == 2431703375) strcat(s, "f");
if (crc32("esgnUsrSg",9) == 2967676021) strcat(s, "k");
if (crc32("aghKvGZ",7) == 619786679) strcat(s, "u");
if (crc32("cuBPvf",6) == 3355549622) strcat(s, "U");
if (crc32("NejWIRMk",8) == 3044292578) strcat(s, "s");
if (crc32("uEhzOX",6) == 3203772087) strcat(s, "K");
if (crc32("BfRXOrwxXDOGG",13) == 2389229197) strcat(s, "i");
if (crc32("GJOjSne",7) == 2489788011) strcat(s, "v");
if (crc32("YHYRPDnV",8) == 4095037784) strcat(s, "e");
if (crc32("jtdXWhaoVev",11) == 1794374458) strcat(s, "H");
if (crc32("gfxVTkBK",8) == 618967928) strcat(s, "l");
if (crc32("hmnaVqZfoUmb",12) == 1376858288) strcat(s, "y");
    return s;
}

char *frighteningly_adverbs() {
    char *s = calloc(14);
    if (crc32("JuaoWBGcvOsXX",13) == 54397781) strcat(s, "f");
if (crc32("PHOgngvdN",9) == 2537235725) strcat(s, "a");
if (crc32("wWPZrcKyesEb",12) == 2506226075) strcat(s, "r");
if (crc32("CHJAsKbvHr",10) == 3807459162) strcat(s, "w");
if (crc32("oUaeDhcZtkfm",12) == 1226656016) strcat(s, "i");
if (crc32("KAksILn",7) == 2490193947) strcat(s, "j");
if (crc32("GJzDYo",6) == 1958290607) strcat(s, "g");
if (crc32("sWdeUffVZyx",11) == 4270155642) strcat(s, "O");
if (crc32("PCNgVr",6) == 3332805540) strcat(s, "h");
if (crc32("dNeQkmzNeP",10) == 1049180788) strcat(s, "t");
if (crc32("fPmIpcZyt",9) == 1184828697) strcat(s, "e");
if (crc32("keJHwDzPYAUA",12) == 2960401999) strcat(s, "i");
if (crc32("wYrJjCiI",8) == 3156937346) strcat(s, "n");
if (crc32("oPhrpgn",7) == 4038152839) strcat(s, "T");
if (crc32("ihPuHipHz",9) == 2681304036) strcat(s, "i");
if (crc32("hpIMyJNVmG",10) == 2458229678) strcat(s, "o");
if (crc32("zokrjDZ",7) == 1508491202) strcat(s, "n");
if (crc32("ytcNbOKQ",8) == 1063589245) strcat(s, "v");
if (crc32("LLeAJQSE",8) == 2884026240) strcat(s, "g");
if (crc32("VHUeHbhstuvCm",13) == 1763414416) strcat(s, "U");
if (crc32("niKxAIEtLUWmDV",14) == 3896093159) strcat(s, "l");
if (crc32("EsdFaMgPoHprimF",15) == 1159646013) strcat(s, "p");
if (crc32("eIMkzPIYcgzq",12) == 1184607771) strcat(s, "y");
    return s;
}

char *uninspiringly_adverbs() {
    char *s = calloc(14);
    if (crc32("cndTwAErcWeH",12) == 1368440100) strcat(s, "x");
if (crc32("oyHICzKhKuyD",12) == 3918796177) strcat(s, "u");
if (crc32("EuxcDRs",7) == 110350461) strcat(s, "n");
if (crc32("qdkCPgrfHgwm",12) == 3787841058) strcat(s, "i");
if (crc32("BLCCpXhUPz",10) == 241015320) strcat(s, "n");
if (crc32("tYjvfOKAsqizh",13) == 2084900372) strcat(s, "s");
if (crc32("SyQzKeFhEyjJv",13) == 766003907) strcat(s, "p");
if (crc32("aOOBPQ",6) == 4117548464) strcat(s, "V");
if (crc32("REEUenKCMY",10) == 3446411690) strcat(s, "i");
if (crc32("JtEYojbS",8) == 4244450985) strcat(s, "Z");
if (crc32("YjMoX",5) == 1479409149) strcat(s, "r");
if (crc32("NelWp",5) == 2339606254) strcat(s, "z");
if (crc32("zVxLBjDozEQEK",13) == 2055322621) strcat(s, "i");
if (crc32("qroEAib",7) == 2458351577) strcat(s, "L");
if (crc32("iQHwHTSRgFxRbv",14) == 3862300475) strcat(s, "n");
if (crc32("eYeheywZsOPicC",14) == 1037646337) strcat(s, "g");
if (crc32("eExdlwLzDnZNE",13) == 3129038802) strcat(s, "F");
if (crc32("vRsUbtUJdboYI",13) == 2719415509) strcat(s, "l");
if (crc32("OxTTqjXy",8) == 3723240773) strcat(s, "y");
    return s;
}

char *unmeasuredly_adverbs() {
    char *s = calloc(13);
    if (crc32("lHpiURl",7) == 4032791355) strcat(s, "u");
if (crc32("xioxv",5) == 1420119920) strcat(s, "u");
if (crc32("gjqhd",5) == 913950320) strcat(s, "z");
if (crc32("mmZNaDbgazNsD",13) == 2857634138) strcat(s, "n");
if (crc32("IdzcmGzNkqgtQpB",15) == 565931948) strcat(s, "f");
if (crc32("vUUNakemTW",10) == 1670378480) strcat(s, "m");
if (crc32("KyyXyKBdVHsqZE",14) == 1887935830) strcat(s, "A");
if (crc32("xNCEFRB",7) == 2691190432) strcat(s, "e");
if (crc32("BDXhQb",6) == 390358098) strcat(s, "I");
if (crc32("UmWLaCqSGMr",11) == 427317482) strcat(s, "a");
if (crc32("pLrQYzgcZXF",11) == 3296327126) strcat(s, "s");
if (crc32("PcnYuVU",7) == 84162347) strcat(s, "u");
if (crc32("iHWQY",5) == 3833113543) strcat(s, "F");
if (crc32("BnGUfmfsdKP",11) == 2306144879) strcat(s, "r");
if (crc32("XWbWVJiMxWAvW",13) == 836318285) strcat(s, "e");
if (crc32("zszlaMKUw",9) == 775649888) strcat(s, "d");
if (crc32("uNdjXAfYl",9) == 4266705295) strcat(s, "l");
if (crc32("nEQAoHTVo",9) == 1307060706) strcat(s, "y");
    return s;
}

char *unaskingly_adverbs() {
    char *s = calloc(11);
    if (crc32("QtnRvFhvusDTfl",14) == 2133256948) strcat(s, "G");
if (crc32("OflDdirgOA",10) == 1771169765) strcat(s, "u");
if (crc32("pJoYjJsNsDjLba",14) == 3193337917) strcat(s, "E");
if (crc32("MMQrFiebVQt",11) == 3261593754) strcat(s, "n");
if (crc32("lutAmPNme",9) == 3710839564) strcat(s, "F");
if (crc32("RclTTiHL",8) == 1048148844) strcat(s, "a");
if (crc32("rLJWZURngjIXx",13) == 3756666303) strcat(s, "s");
if (crc32("qPMcwoCbyAq",11) == 3374637678) strcat(s, "f");
if (crc32("JZmChqEnWbUDjbi",15) == 1123012134) strcat(s, "k");
if (crc32("FppkHs",6) == 1325451723) strcat(s, "i");
if (crc32("RdbqzOvCALd",11) == 103770321) strcat(s, "c");
if (crc32("dmiejoFF",8) == 2336714238) strcat(s, "n");
if (crc32("MncoIFF",7) == 1901000012) strcat(s, "g");
if (crc32("oboApLC",7) == 2214116163) strcat(s, "n");
if (crc32("nBAcQWwF",8) == 2361558658) strcat(s, "l");
if (crc32("tIRwZ",5) == 2828274592) strcat(s, "y");
    return s;
}

char *ungradually_adverbs() {
    char *s = calloc(12);
    if (crc32("mFtCjTGEjzNo",12) == 2030995143) strcat(s, "m");
if (crc32("RMCVn",5) == 3652742722) strcat(s, "u");
if (crc32("BmOPTxg",7) == 3032082169) strcat(s, "n");
if (crc32("HScUlG",6) == 728554308) strcat(s, "c");
if (crc32("KIgfTyrTf",9) == 3933710464) strcat(s, "g");
if (crc32("BlBeZdfqqsGufGV",15) == 1942571755) strcat(s, "r");
if (crc32("wsPoMGThpHMK",12) == 757344184) strcat(s, "j");
if (crc32("DvPuZlTh",8) == 36847007) strcat(s, "a");
if (crc32("VdvfoaaIl",9) == 3324528721) strcat(s, "Q");
if (crc32("oZnxYwNkWhFpqM",14) == 3050228313) strcat(s, "d");
if (crc32("huMAnLki",8) == 3471784886) strcat(s, "R");
if (crc32("lVnDFpgjaCtkKmL",15) == 4004659310) strcat(s, "u");
if (crc32("HRSUEcfNArVX",12) == 407857690) strcat(s, "a");
if (crc32("NfDWfoZkgBohvR",14) == 1800990944) strcat(s, "l");
if (crc32("VRegXMGfVKyuUT",14) == 4205414481) strcat(s, "l");
if (crc32("oSCxalOOj",9) == 2393088925) strcat(s, "Y");
if (crc32("mHTqJeSUXWoSwaL",15) == 2847323450) strcat(s, "y");
    return s;
}

char *incorruptibly_adverbs() {
    char *s = calloc(14);
    if (crc32("DaFLYPDzfZpOxo",14) == 1394440128) strcat(s, "b");
if (crc32("rQXSPBu",7) == 2114873324) strcat(s, "i");
if (crc32("kzaPBQkDpGecyBo",15) == 4116317819) strcat(s, "n");
if (crc32("tJHtxNRMtHWX",12) == 4242079954) strcat(s, "l");
if (crc32("OMQteQDUItTN",12) == 1554227784) strcat(s, "c");
if (crc32("BVmwdbFni",9) == 1073239440) strcat(s, "o");
if (crc32("KHobzVuyB",9) == 1574699171) strcat(s, "n");
if (crc32("iSpahlH",7) == 2224794409) strcat(s, "r");
if (crc32("LyJRWpaLi",9) == 204875368) strcat(s, "r");
if (crc32("ZBdEAtUsbqFneNA",15) == 4215675911) strcat(s, "u");
if (crc32("nNQDnqnFxpsajea",15) == 4220339601) strcat(s, "p");
if (crc32("WmUHrslNx",9) == 4120055806) strcat(s, "L");
if (crc32("klzHgjiiUO",10) == 3696934463) strcat(s, "t");
if (crc32("GSIdJWJs",8) == 1315072763) strcat(s, "i");
if (crc32("OGGfEx",6) == 1012271131) strcat(s, "b");
if (crc32("eLkxfx",6) == 2940532423) strcat(s, "l");
if (crc32("jTvQRXSmmeNgzNq",15) == 408876247) strcat(s, "y");
    return s;
}

char *edgeways_adverbs() {
    char *s = calloc(9);
    if (crc32("sCmwkCRVUz",10) == 3928590524) strcat(s, "q");
if (crc32("eTilROXrws",10) == 320018585) strcat(s, "e");
if (crc32("RMykMEIku",9) == 957290546) strcat(s, "E");
if (crc32("ccJzgimQpjJFDE",14) == 2481806276) strcat(s, "d");
if (crc32("CXAdJAeZ",8) == 1819921749) strcat(s, "g");
if (crc32("LBfBrvolboHU",12) == 3652011098) strcat(s, "e");
if (crc32("ByjmmqC",7) == 3789924347) strcat(s, "w");
if (crc32("oWkHpSWF",8) == 4020979989) strcat(s, "a");
if (crc32("SRPUbD",6) == 4262144004) strcat(s, "y");
if (crc32("wnMtDILVm",9) == 1758776709) strcat(s, "D");
if (crc32("QpPSQTTkshtEwM",14) == 4080156593) strcat(s, "s");
    return s;
}

char *commercially_adverbs() {
    char *s = calloc(13);
    if (crc32("MAZPxDepM",9) == 324183543) strcat(s, "c");
if (crc32("XnNdHlfVKA",10) == 2763476828) strcat(s, "o");
if (crc32("jTXmcuEPeVtrMgR",15) == 685934750) strcat(s, "o");
if (crc32("dFZXqS",6) == 1899543860) strcat(s, "Y");
if (crc32("qbJBqTWJoqPvzt",14) == 829480579) strcat(s, "m");
if (crc32("EqFcMKwbAifLH",13) == 798622235) strcat(s, "h");
if (crc32("OdtmO",5) == 3440234934) strcat(s, "m");
if (crc32("cJYBxxGLeIqWFpJ",15) == 325091998) strcat(s, "a");
if (crc32("pqphDMoRCub",11) == 2236589137) strcat(s, "e");
if (crc32("uAtOmnTfkMrlrU",14) == 1887530315) strcat(s, "r");
if (crc32("zszAUua",7) == 3397572708) strcat(s, "c");
if (crc32("DlcKffTFwLuX",12) == 1924653993) strcat(s, "i");
if (crc32("SPNEngMmLwiqEtM",15) == 857617548) strcat(s, "m");
if (crc32("TjYAgVKehu",10) == 533554236) strcat(s, "a");
if (crc32("lBoQZEryQU",10) == 2058196441) strcat(s, "R");
if (crc32("BRudrjcmNZQoCJN",15) == 2281108801) strcat(s, "l");
if (crc32("utZXRA",6) == 2838930880) strcat(s, "l");
if (crc32("NWDmpjWTDXWMH",13) == 1970829010) strcat(s, "y");
    return s;
}

char *halfradically_adverbs() {
    char *s = calloc(14);
    if (crc32("mgJiDJ",6) == 983739209) strcat(s, "I");
if (crc32("XSifbHGrn",9) == 1261272581) strcat(s, "h");
if (crc32("WxuapY",6) == 3405595579) strcat(s, "H");
if (crc32("olyPhvS",7) == 1839785449) strcat(s, "a");
if (crc32("UmnoPJqUHizm",12) == 2932740832) strcat(s, "W");
if (crc32("plWdxkPXpULpuEm",15) == 459084928) strcat(s, "l");
if (crc32("tdZmH",5) == 3075188328) strcat(s, "f");
if (crc32("bnafYTbjCnCT",12) == 3686097536) strcat(s, "r");
if (crc32("gQQbrtRKVu",10) == 2736657233) strcat(s, "g");
if (crc32("rppMJ",5) == 2837452216) strcat(s, "a");
if (crc32("ybsfb",5) == 1701007479) strcat(s, "d");
if (crc32("YaQEXq",6) == 1324416969) strcat(s, "y");
if (crc32("FuwbnrCMZKiB",12) == 777385737) strcat(s, "i");
if (crc32("vJhmvfblJGVm",12) == 778080409) strcat(s, "c");
if (crc32("ZeTJGKOvtI",10) == 1220720090) strcat(s, "U");
if (crc32("QDuBhlSKRM",10) == 2633300802) strcat(s, "a");
if (crc32("WgPNlyg",7) == 1104270176) strcat(s, "l");
if (crc32("DKFVnkCgRN",10) == 2250708176) strcat(s, "l");
if (crc32("bjwhoLFbq",9) == 3248140560) strcat(s, "J");
if (crc32("ObFFyOuI",8) == 3082635024) strcat(s, "y");
    return s;
}

char *thrasonically_adverbs() {
    char *s = calloc(14);
    if (crc32("zgYqPfMqFJ",10) == 3889865423) strcat(s, "l");
if (crc32("RTWwoJuxKd",10) == 3007946157) strcat(s, "t");
if (crc32("CvPnPHIboGAKl",13) == 2956570716) strcat(s, "c");
if (crc32("KsZTxTH",7) == 2619909655) strcat(s, "h");
if (crc32("GKwmOy",6) == 2134184323) strcat(s, "y");
if (crc32("WXmZqTzA",8) == 2148526183) strcat(s, "r");
if (crc32("JdTKS",5) == 3934242637) strcat(s, "a");
if (crc32("sJmzjeCtY",9) == 859654428) strcat(s, "z");
if (crc32("hPTiipSuBPFwV",13) == 3900158879) strcat(s, "s");
if (crc32("ADlXsEIcrqTrf",13) == 3646624644) strcat(s, "o");
if (crc32("dsrLRcEAOtd",11) == 3390341348) strcat(s, "p");
if (crc32("JpAuIlyd",8) == 3620873500) strcat(s, "n");
if (crc32("EtbMyUjCQIRkGo",14) == 1686801987) strcat(s, "i");
if (crc32("yWNuTI",6) == 42843116) strcat(s, "j");
if (crc32("JGOdg",5) == 2065909716) strcat(s, "c");
if (crc32("hfJUNA",6) == 3001608694) strcat(s, "a");
if (crc32("wlpZjyKGhysIb",13) == 4034474712) strcat(s, "l");
if (crc32("ikJrrs",6) == 117606136) strcat(s, "l");
if (crc32("ZItTKwGdV",9) == 1260966493) strcat(s, "B");
if (crc32("xBBmOugVAHa",11) == 1362516697) strcat(s, "y");
    return s;
}

char *conqueringly_adverbs() {
    char *s = calloc(13);
    if (crc32("ybnzJYieV",9) == 444298309) strcat(s, "J");
if (crc32("NDpUbDfVm",9) == 2308567713) strcat(s, "c");
if (crc32("EiNWWIJwQkuoxmC",15) == 221103205) strcat(s, "o");
if (crc32("sLcmPHJYjeQ",11) == 907530814) strcat(s, "L");
if (crc32("NLXeqnHJJg",10) == 411244735) strcat(s, "n");
if (crc32("CBPsmg",6) == 1634953961) strcat(s, "j");
if (crc32("aWDUaOMYmQoaDdf",15) == 1274804903) strcat(s, "q");
if (crc32("inZvKGjqWyGfH",13) == 341942455) strcat(s, "u");
if (crc32("xGkpLgFvZkdfQ",13) == 3091849745) strcat(s, "r");
if (crc32("cvlRizWoYrssQUB",15) == 33622037) strcat(s, "e");
if (crc32("ryLuYbPgtxuDP",13) == 3582707792) strcat(s, "r");
if (crc32("qwsjrmiakVpJU",13) == 2461026620) strcat(s, "m");
if (crc32("ZBZHW",5) == 689445629) strcat(s, "i");
if (crc32("ieCvtSYlQ",9) == 3995799482) strcat(s, "b");
if (crc32("VfebLgO",7) == 1986461124) strcat(s, "n");
if (crc32("THMGYcfYvah",11) == 1374122804) strcat(s, "b");
if (crc32("qTHarOQDgAEsrpX",15) == 2111661406) strcat(s, "g");
if (crc32("KvAcCHNAeJdGgl",14) == 2351192969) strcat(s, "l");
if (crc32("yROVXnF",7) == 2540806424) strcat(s, "y");
    return s;
}

char *unaffably_adverbs() {
    char *s = calloc(10);
    if (crc32("hxSnPMyqRZ",10) == 1417502418) strcat(s, "m");
if (crc32("utzeWu",6) == 2037677261) strcat(s, "u");
if (crc32("qyCayYScrMqA",12) == 3189006905) strcat(s, "n");
if (crc32("asbqCgJwv",9) == 1311656607) strcat(s, "n");
if (crc32("WLzzYGkADyOLpF",14) == 2842336620) strcat(s, "T");
if (crc32("HxvNaVcZGFZ",11) == 2285921126) strcat(s, "a");
if (crc32("QITKNsySmq",10) == 381347845) strcat(s, "h");
if (crc32("oGgXSUFomwOme",13) == 944197205) strcat(s, "f");
if (crc32("yhKDkfh",7) == 253911049) strcat(s, "f");
if (crc32("gXUwnoZoqrSu",12) == 704897737) strcat(s, "R");
if (crc32("vzOFCfRFqGD",11) == 3204087156) strcat(s, "a");
if (crc32("iQCqogtiDQppc",13) == 1752361832) strcat(s, "b");
if (crc32("wzKqbvdFONL",11) == 402730920) strcat(s, "l");
if (crc32("fBRJAxDjicrOn",13) == 1277728687) strcat(s, "y");
    return s;
}

char *undisconnectedly_adverbs() {
    char *s = calloc(17);
    if (crc32("ozqxaqxIko",10) == 2487784603) strcat(s, "u");
if (crc32("jOorsehXy",9) == 1259882081) strcat(s, "n");
if (crc32("PPQaEQmNWviS",12) == 3578994345) strcat(s, "d");
if (crc32("sRzBkshQ",8) == 1894101708) strcat(s, "i");
if (crc32("lBOOaknU",8) == 842542617) strcat(s, "s");
if (crc32("YKNyJhA",7) == 1857558580) strcat(s, "c");
if (crc32("WQeNMlgEDfyCF",13) == 1416555111) strcat(s, "i");
if (crc32("yPuacljtOrjPCod",15) == 1092633210) strcat(s, "o");
if (crc32("UmaXnYMRLHepQc",14) == 1648393300) strcat(s, "n");
if (crc32("dzPnXQqANFmqkUW",15) == 1190500122) strcat(s, "D");
if (crc32("lkGKJodruC",10) == 2017391075) strcat(s, "n");
if (crc32("ZzrqHVPBfwf",11) == 1930828739) strcat(s, "n");
if (crc32("RgHQVOeZzuSD",12) == 2268152873) strcat(s, "e");
if (crc32("EsGdCFjbEPHhE",13) == 602558279) strcat(s, "P");
if (crc32("DnbdRtNmmfJ",11) == 198945346) strcat(s, "c");
if (crc32("pMeSFTKkuHKDhoa",15) == 3635086968) strcat(s, "t");
if (crc32("obQiTzmvb",9) == 2968479603) strcat(s, "D");
if (crc32("QlLbyCJA",8) == 1148645020) strcat(s, "e");
if (crc32("kXPObsyyxCztrS",14) == 2935790687) strcat(s, "d");
if (crc32("tqlCpKrtZN",10) == 1856525657) strcat(s, "l");
if (crc32("vSXPxp",6) == 3337384283) strcat(s, "y");
    return s;
}

char *doublefacedly_adverbs() {
    char *s = calloc(14);
    if (crc32("otcbrLC",7) == 3689951917) strcat(s, "d");
if (crc32("XHkmoZYN",8) == 2110263136) strcat(s, "S");
if (crc32("ZAMshgldkh",10) == 3753255442) strcat(s, "o");
if (crc32("btPjOTj",7) == 1963511586) strcat(s, "u");
if (crc32("reyahXxQ",8) == 264555428) strcat(s, "O");
if (crc32("fBADSsj",7) == 2180022735) strcat(s, "b");
if (crc32("DFlcsmfCbsS",11) == 2857361077) strcat(s, "I");
if (crc32("EupDAsoccyhNU",13) == 2575177947) strcat(s, "l");
if (crc32("bfUTvfUxVw",10) == 2617622551) strcat(s, "e");
if (crc32("HHBQxXHj",8) == 718272595) strcat(s, "A");
if (crc32("zXyqGnyKYknbOC",14) == 3960269945) strcat(s, "f");
if (crc32("tslCtWVBtybi",12) == 4257845111) strcat(s, "a");
if (crc32("xuDhcPfGv",9) == 2997351982) strcat(s, "x");
if (crc32("bClroiIveEjSpTf",15) == 143473198) strcat(s, "c");
if (crc32("kstnnmAOfS",10) == 986129455) strcat(s, "e");
if (crc32("kSpUCDHL",8) == 2483348625) strcat(s, "M");
if (crc32("DJtaYfAPPrGo",12) == 1756899881) strcat(s, "d");
if (crc32("GFVzOTnwBLiPB",13) == 3938687895) strcat(s, "l");
if (crc32("FsBSVEsYYmKYX",13) == 2243067639) strcat(s, "y");
    return s;
}

char *inexcusably_adverbs() {
    char *s = calloc(12);
    if (crc32("sgxIAsJuwd",10) == 1589279267) strcat(s, "s");
if (crc32("SjzWf",5) == 3846682393) strcat(s, "i");
if (crc32("LFPbxMvoe",9) == 25791590) strcat(s, "T");
if (crc32("oeZaiDWCXviLinW",15) == 2231777887) strcat(s, "n");
if (crc32("zIgfkHg",7) == 2953320088) strcat(s, "C");
if (crc32("kieGRAPoPVqWw",13) == 3580436000) strcat(s, "e");
if (crc32("ssLBYLGUIA",10) == 1220684856) strcat(s, "m");
if (crc32("KLbqlxLLJlXD",12) == 3746681165) strcat(s, "x");
if (crc32("pwOTa",5) == 3576140708) strcat(s, "m");
if (crc32("ghXNxyGGlemJw",13) == 2951976779) strcat(s, "c");
if (crc32("yIbOPTjJtHs",11) == 1071307127) strcat(s, "u");
if (crc32("wIYMptkxCF",10) == 1607053649) strcat(s, "H");
if (crc32("kjixyNNMAL",10) == 1301037396) strcat(s, "s");
if (crc32("OuuxHtwhwAqSXX",14) == 382638368) strcat(s, "s");
if (crc32("dOXQoaFx",8) == 3032698774) strcat(s, "a");
if (crc32("mbmWTdsrYRB",11) == 2677234183) strcat(s, "b");
if (crc32("gpCLporxpkwHFP",14) == 4184622004) strcat(s, "Z");
if (crc32("DjZMEnV",7) == 2428307553) strcat(s, "l");
if (crc32("seZQLrYPbtM",11) == 790441860) strcat(s, "N");
if (crc32("cFFgLYNRQbn",11) == 4175528915) strcat(s, "y");
    return s;
}

char *exceptionally_adverbs() {
    char *s = calloc(14);
    if (crc32("hgQXvu",6) == 912509893) strcat(s, "e");
if (crc32("cqUGmaPLixtzzC",14) == 3307540271) strcat(s, "x");
if (crc32("ZVcYU",5) == 945489693) strcat(s, "b");
if (crc32("LIDsZiyZtOA",11) == 2838869381) strcat(s, "c");
if (crc32("zdjSftIykDQB",12) == 3240643611) strcat(s, "Y");
if (crc32("nwogUTp",7) == 167051182) strcat(s, "e");
if (crc32("BUCNFiTCMItgPT",14) == 4173089421) strcat(s, "p");
if (crc32("ycvEanX",7) == 1736422634) strcat(s, "t");
if (crc32("VBawLWU",7) == 1335081847) strcat(s, "A");
if (crc32("xjyAwLmyyi",10) == 1306639653) strcat(s, "i");
if (crc32("qhxxdmSrsXrNjOZ",15) == 140784416) strcat(s, "o");
if (crc32("sBYLvnPdQvpeXN",14) == 2462544008) strcat(s, "L");
if (crc32("DjRSku",6) == 1595008554) strcat(s, "n");
if (crc32("UySqWJWzAxuECK",14) == 569911066) strcat(s, "a");
if (crc32("KULMoWFp",8) == 1146214386) strcat(s, "l");
if (crc32("FDshaLcWp",9) == 1167037211) strcat(s, "l");
if (crc32("KhwTAoMU",8) == 45442993) strcat(s, "E");
if (crc32("HFUUr",5) == 57587246) strcat(s, "y");
    return s;
}

char *reekingly_adverbs() {
    char *s = calloc(10);
    if (crc32("BgJrRrWjzQcBxae",15) == 3489485663) strcat(s, "j");
if (crc32("QBFprAgyAX",10) == 349721364) strcat(s, "r");
if (crc32("aFollYUXUfrbUdW",15) == 334195361) strcat(s, "e");
if (crc32("dnSEnPe",7) == 628278739) strcat(s, "c");
if (crc32("CKWWCDvszF",10) == 90357298) strcat(s, "e");
if (crc32("tZAZGtjyoWqq",12) == 768481537) strcat(s, "k");
if (crc32("qCqpBTJTxWcJWU",14) == 2836474480) strcat(s, "O");
if (crc32("jDbOrNFL",8) == 1772715612) strcat(s, "i");
if (crc32("dazJRyYSwvP",11) == 2644866622) strcat(s, "h");
if (crc32("eyUKVMBizmx",11) == 1281329339) strcat(s, "n");
if (crc32("JuhUwFNC",8) == 1957374138) strcat(s, "g");
if (crc32("EtaytGajazG",11) == 1984630247) strcat(s, "V");
if (crc32("CXpNJzDWbxIJuA",14) == 4231192491) strcat(s, "l");
if (crc32("onkZH",5) == 2014533337) strcat(s, "P");
if (crc32("xXzEYvdBEwBBwn",14) == 4026268714) strcat(s, "y");
    return s;
}

char *barely_adverbs() {
    char *s = calloc(7);
    if (crc32("vJwvgbiLrANJFb",14) == 788563480) strcat(s, "b");
if (crc32("hewrnbOYXDglHG",14) == 1953492924) strcat(s, "n");
if (crc32("GVgmtmF",7) == 945670691) strcat(s, "a");
if (crc32("PqjUFasi",8) == 1933350912) strcat(s, "o");
if (crc32("Dcisrtl",7) == 381862929) strcat(s, "r");
if (crc32("axzAYJdQSIRn",12) == 352242357) strcat(s, "a");
if (crc32("StbKcMyIPWkea",13) == 2084553252) strcat(s, "e");
if (crc32("dKDTnE",6) == 3466765448) strcat(s, "S");
if (crc32("vDUUmAVCEJnHUQx",15) == 2368788) strcat(s, "l");
if (crc32("qpiooGQpgTe",11) == 3900247914) strcat(s, "k");
if (crc32("WlUxKmda",8) == 3557312847) strcat(s, "y");
    return s;
}

char *noninclusively_adverbs() {
    char *s = calloc(15);
    if (crc32("mVSAOwVxgBtCNN",14) == 4138764403) strcat(s, "n");
if (crc32("ZuHvDkdKSFVNjy",14) == 3902133107) strcat(s, "H");
if (crc32("YkJVaof",7) == 3130428935) strcat(s, "o");
if (crc32("odEKHMbRztp",11) == 3182250822) strcat(s, "H");
if (crc32("ineqjttXIpEx",12) == 3162213205) strcat(s, "n");
if (crc32("FvyfTMXmjpg",11) == 4168349460) strcat(s, "i");
if (crc32("nshZaI",6) == 281750874) strcat(s, "L");
if (crc32("Vudgks",6) == 3976071917) strcat(s, "n");
if (crc32("oMbFthfcGBnRFz",14) == 2215833129) strcat(s, "M");
if (crc32("FRLdXvLLGuCRMy",14) == 2842250379) strcat(s, "c");
if (crc32("UqpaD",5) == 1731554483) strcat(s, "r");
if (crc32("LaDGdmCT",8) == 198324917) strcat(s, "l");
if (crc32("gaMshGf",7) == 451393921) strcat(s, "o");
if (crc32("NOBtQpJZq",9) == 936676728) strcat(s, "u");
if (crc32("WuClLKO",7) == 3258728572) strcat(s, "s");
if (crc32("xSxNVIfgHJBq",12) == 981733025) strcat(s, "i");
if (crc32("ZIlZoXsnxqleLHa",15) == 3012890217) strcat(s, "J");
if (crc32("XvoZtJvEKMdSX",13) == 3255475666) strcat(s, "v");
if (crc32("rrmLnCTcR",9) == 1265712653) strcat(s, "e");
if (crc32("qiHMfVPoFIsnkEj",15) == 2057554184) strcat(s, "l");
if (crc32("ZoiHqifF",8) == 2749324963) strcat(s, "y");
    return s;
}

char *prohibitorily_adverbs() {
    char *s = calloc(14);
    if (crc32("VcNsrlhuIlXvQHJ",15) == 3664267659) strcat(s, "p");
if (crc32("GQSwUiKjZBjaHix",15) == 336455843) strcat(s, "l");
if (crc32("myVeWl",6) == 3773726924) strcat(s, "r");
if (crc32("rzLoNltq",8) == 970352257) strcat(s, "h");
if (crc32("gzYGAstviXOI",12) == 1184282065) strcat(s, "o");
if (crc32("WEXBGEwYMgB",11) == 1943321804) strcat(s, "w");
if (crc32("CuEHFEtZm",9) == 1263012630) strcat(s, "h");
if (crc32("YJcmBSUgRGaPSaH",15) == 617457376) strcat(s, "i");
if (crc32("GyPHeUh",7) == 3324055578) strcat(s, "x");
if (crc32("yWIcLesLfOY",11) == 73114585) strcat(s, "b");
if (crc32("sTFszjE",7) == 3076847604) strcat(s, "n");
if (crc32("XwIldiLLqWGDDhs",15) == 868231546) strcat(s, "i");
if (crc32("eDdMfMqWWosI",12) == 1026748285) strcat(s, "t");
if (crc32("yobxDICbXUiZ",12) == 3527846196) strcat(s, "o");
if (crc32("IZrOG",5) == 2113220215) strcat(s, "f");
if (crc32("GVeZhLSqRijG",12) == 3761437718) strcat(s, "r");
if (crc32("EIbEAmf",7) == 1904562975) strcat(s, "J");
if (crc32("cydyPwz",7) == 3448287799) strcat(s, "i");
if (crc32("mOcOeguUsDlh",12) == 1247662807) strcat(s, "l");
if (crc32("UMmAmmw",7) == 2562314102) strcat(s, "J");
if (crc32("BXUerpDRVUc",11) == 675955466) strcat(s, "y");
    return s;
}

char *unprejudicially_adverbs() {
    char *s = calloc(16);
    if (crc32("pdKWpCXUhA",10) == 1518944291) strcat(s, "u");
if (crc32("AkTMHGTJ",8) == 1567819861) strcat(s, "n");
if (crc32("IZAVcLNxzzJWldD",15) == 2663072713) strcat(s, "p");
if (crc32("ciPZnsvmsZT",11) == 2868069451) strcat(s, "r");
if (crc32("uYORpiSrCHCrip",14) == 775672615) strcat(s, "e");
if (crc32("qXefidbyMJh",11) == 3081455747) strcat(s, "j");
if (crc32("mJpLwTnxMuiewRq",15) == 3789206697) strcat(s, "u");
if (crc32("NAVmab",6) == 3321526927) strcat(s, "B");
if (crc32("fPuhWwPsoPJ",11) == 222102901) strcat(s, "d");
if (crc32("eFXekaRaCHQA",12) == 1508456073) strcat(s, "i");
if (crc32("zteZrYvd",8) == 2043939362) strcat(s, "g");
if (crc32("BdlnSzexMDKcP",13) == 3384819983) strcat(s, "c");
if (crc32("pUcxxXuKGmoH",12) == 634473784) strcat(s, "m");
if (crc32("nuSaGJh",7) == 3708388457) strcat(s, "i");
if (crc32("KaCbpOv",7) == 3222660868) strcat(s, "k");
if (crc32("yKvxDaFwslVK",12) == 2688448167) strcat(s, "a");
if (crc32("FjipbvQMroVqhec",15) == 205329415) strcat(s, "W");
if (crc32("wYhuqvc",7) == 2456610867) strcat(s, "l");
if (crc32("TjSDSxtzkGx",11) == 3348738113) strcat(s, "Z");
if (crc32("XSMJOZqzzzft",12) == 3173630201) strcat(s, "l");
if (crc32("NPEUv",5) == 4053421076) strcat(s, "k");
if (crc32("fyayYKrEvwt",11) == 3135069956) strcat(s, "y");
    return s;
}

char *hyperexcursively_adverbs() {
    char *s = calloc(17);
    if (crc32("VfAnkUSUpUo",11) == 861864233) strcat(s, "h");
if (crc32("BZrEitk",7) == 336998148) strcat(s, "Q");
if (crc32("OUqElRdenthoriB",15) == 2711926833) strcat(s, "y");
if (crc32("JSDbuENYIlEIh",13) == 2762783317) strcat(s, "p");
if (crc32("MpmCNWNQhpo",11) == 2937578562) strcat(s, "e");
if (crc32("WAQEncy",7) == 2719499662) strcat(s, "i");
if (crc32("IApkcsuy",8) == 1358559536) strcat(s, "r");
if (crc32("BOQZk",5) == 1115766606) strcat(s, "d");
if (crc32("DvwxLasF",8) == 2612193306) strcat(s, "e");
if (crc32("rSEFhlqs",8) == 3592309776) strcat(s, "u");
if (crc32("ydimBAKTOjaUHS",14) == 2333848897) strcat(s, "x");
if (crc32("ssgimYiQojqGVDG",15) == 636922066) strcat(s, "c");
if (crc32("KKYTJPhWSsdww",13) == 2578538150) strcat(s, "G");
if (crc32("KogPBulqqjpL",12) == 278603792) strcat(s, "u");
if (crc32("qJexrsIX",8) == 2813510179) strcat(s, "r");
if (crc32("AjIkmAb",7) == 977642351) strcat(s, "s");
if (crc32("gRXQQIBPDYhUk",13) == 4108343980) strcat(s, "s");
if (crc32("UoYDNIwXMJOoYtZ",15) == 3399628770) strcat(s, "A");
if (crc32("ZKokJyrINyYK",12) == 3725751766) strcat(s, "i");
if (crc32("MyEbaLcMaBPRfpG",15) == 2521727325) strcat(s, "s");
if (crc32("plrWJxDMJyfoNT",14) == 2042243313) strcat(s, "v");
if (crc32("NBcZZeAQfKQtngj",15) == 1627797514) strcat(s, "e");
if (crc32("BLeDaEdJSHDek",13) == 1043061446) strcat(s, "l");
if (crc32("FpaUntSRoUolhI",14) == 3965022746) strcat(s, "y");
    return s;
}

char *stagnantly_adverbs() {
    char *s = calloc(11);
    if (crc32("vnMSKOHAe",9) == 483005327) strcat(s, "A");
if (crc32("HTWqqGJaFh",10) == 654204034) strcat(s, "s");
if (crc32("QIjcqwnsNJIDCc",14) == 1982706113) strcat(s, "t");
if (crc32("RGQJaQ",6) == 2768481488) strcat(s, "m");
if (crc32("ESDszJCoVzdpwz",14) == 3721464512) strcat(s, "a");
if (crc32("fhygNNbaSvTVa",13) == 1676255879) strcat(s, "f");
if (crc32("cKNOZPeo",8) == 2670780267) strcat(s, "g");
if (crc32("ZErrdBqxTTQWtoQ",15) == 1822750304) strcat(s, "O");
if (crc32("RMOsq",5) == 3042527796) strcat(s, "n");
if (crc32("EkzeE",5) == 4249655133) strcat(s, "a");
if (crc32("aWlPQRdcPz",10) == 515039334) strcat(s, "n");
if (crc32("djoYsOUhnx",10) == 1233449252) strcat(s, "T");
if (crc32("QpGUB",5) == 2191893266) strcat(s, "t");
if (crc32("gGKgGENTji",10) == 1776855871) strcat(s, "l");
if (crc32("OWjCQbwC",8) == 3996904560) strcat(s, "a");
if (crc32("SJGmIwcv",8) == 1830489436) strcat(s, "y");
    return s;
}

char *touchingly_adverbs() {
    char *s = calloc(11);
    if (crc32("KNkQoSPNEKN",11) == 1829013505) strcat(s, "B");
if (crc32("oBWIiPCGegXhV",13) == 2977777827) strcat(s, "t");
if (crc32("mchqiTgly",9) == 270709948) strcat(s, "o");
if (crc32("nZrPTwGyaNAknC",14) == 4263107351) strcat(s, "n");
if (crc32("ygwAjsxwrPk",11) == 112371881) strcat(s, "u");
if (crc32("iUAPGWNVQDYcvd",14) == 2267413752) strcat(s, "c");
if (crc32("IBiMVYnBPrw",11) == 3722095787) strcat(s, "h");
if (crc32("jICVoePCu",9) == 918491700) strcat(s, "i");
if (crc32("PcrUZW",6) == 2110017804) strcat(s, "n");
if (crc32("RlzrCSnlaMkEq",13) == 24135959) strcat(s, "e");
if (crc32("zOilWgqsW",9) == 2597157847) strcat(s, "g");
if (crc32("HLTakOtZhU",10) == 499550377) strcat(s, "S");
if (crc32("IlVfrAnS",8) == 1781629118) strcat(s, "l");
if (crc32("ASArhHR",7) == 4227747143) strcat(s, "q");
if (crc32("puZlOM",6) == 287535288) strcat(s, "y");
    return s;
}

char *speedfully_adverbs() {
    char *s = calloc(11);
    if (crc32("wgDpaB",6) == 3515729929) strcat(s, "y");
if (crc32("QiYUbaEOUADws",13) == 3104714346) strcat(s, "s");
if (crc32("TaASMCzCY",9) == 464528151) strcat(s, "f");
if (crc32("lXzfQhR",7) == 3652695604) strcat(s, "p");
if (crc32("tQbUPMRkePaqEDC",15) == 1382898655) strcat(s, "N");
if (crc32("Cutzeh",6) == 4024703515) strcat(s, "e");
if (crc32("YqQJbYIyfoCHKB",14) == 1371816271) strcat(s, "e");
if (crc32("lRlbYjeNacAl",12) == 1898576752) strcat(s, "d");
if (crc32("DBwIeLTxexDnjSh",15) == 849791967) strcat(s, "Z");
if (crc32("pUPkXjCMRcC",11) == 873375885) strcat(s, "f");
if (crc32("BTMkDnllE",9) == 2019030138) strcat(s, "u");
if (crc32("OVcoBdCVL",9) == 1731347323) strcat(s, "H");
if (crc32("sYBft",5) == 3649310080) strcat(s, "l");
if (crc32("izJItptcaxoY",12) == 2331214345) strcat(s, "l");
if (crc32("RxuvIoauxlwhwy",14) == 351562350) strcat(s, "r");
if (crc32("kUWdLEAvfebSqz",14) == 575140562) strcat(s, "y");
    return s;
}

char *forth_adverbs() {
    char *s = calloc(6);
    if (crc32("vydzIEs",7) == 3158046835) strcat(s, "Y");
if (crc32("YCoQpINGgKNoxDB",15) == 3423947916) strcat(s, "f");
if (crc32("chzEkORCUpAaWl",14) == 2243298490) strcat(s, "B");
if (crc32("JpWOUMAv",8) == 782921214) strcat(s, "o");
if (crc32("avJIZ",5) == 738779870) strcat(s, "I");
if (crc32("xdTAlJrlS",9) == 779711873) strcat(s, "r");
if (crc32("eLdQuOmJyX",10) == 3217255079) strcat(s, "F");
if (crc32("FsChGukDjqEeK",13) == 12394753) strcat(s, "t");
if (crc32("QpBDA",5) == 176856161) strcat(s, "h");
if (crc32("qbqXclVsTTJ",11) == 3371748741) strcat(s, "h");
    return s;
}

char *seminormally_adverbs() {
    char *s = calloc(13);
    if (crc32("MiirCMZ",7) == 4215284014) strcat(s, "U");
if (crc32("XIfpjjD",7) == 1940867369) strcat(s, "s");
if (crc32("IqtFSISAEpEiDw",14) == 3984164795) strcat(s, "Q");
if (crc32("NWegcfA",7) == 387782348) strcat(s, "e");
if (crc32("ntXeXBBW",8) == 247164827) strcat(s, "L");
if (crc32("grJJZBkRsMR",11) == 3487791932) strcat(s, "m");
if (crc32("jKiGaRkPilaBx",13) == 3299083469) strcat(s, "i");
if (crc32("YWIgOVaR",8) == 1188322001) strcat(s, "J");
if (crc32("uLnKyXQVrJ",10) == 4243526799) strcat(s, "n");
if (crc32("QnRxIbRIkIxeS",13) == 458354918) strcat(s, "o");
if (crc32("BFtudcQFqnsHR",13) == 3319672779) strcat(s, "t");
if (crc32("LtWrsAMQkrC",11) == 3426315691) strcat(s, "r");
if (crc32("NTppXVNbaeY",11) == 4238128461) strcat(s, "m");
if (crc32("bdYpFqhhwfMk",12) == 665922108) strcat(s, "q");
if (crc32("WKYDH",5) == 2407230822) strcat(s, "a");
if (crc32("pTaAnDQJSzsVb",13) == 437516919) strcat(s, "l");
if (crc32("ViFNGBtAzTpXYoG",15) == 4053358319) strcat(s, "l");
if (crc32("vOHYXd",6) == 3886177685) strcat(s, "f");
if (crc32("EFHFaZ",6) == 3825988665) strcat(s, "y");
    return s;
}

char *disappointedly_adverbs() {
    char *s = calloc(15);
    if (crc32("mRZjtHskrwUDEZ",14) == 1444101116) strcat(s, "d");
if (crc32("bCWQXQnWM",9) == 3592587440) strcat(s, "i");
if (crc32("DYuiDpMKxbd",11) == 1319982385) strcat(s, "l");
if (crc32("BZvwFBUD",8) == 1688866004) strcat(s, "s");
if (crc32("vCrvIU",6) == 2745885601) strcat(s, "e");
if (crc32("GynkwDlwK",9) == 3378941474) strcat(s, "a");
if (crc32("nhsgZgZCNJpDe",13) == 4112883252) strcat(s, "m");
if (crc32("zTtRQkJJltaNL",13) == 95601426) strcat(s, "p");
if (crc32("UmpXkWQZpubRqid",15) == 3325630649) strcat(s, "p");
if (crc32("TDfrPBuoLzxT",12) == 3857634685) strcat(s, "o");
if (crc32("OZWISkweicz",11) == 786618505) strcat(s, "i");
if (crc32("QSBWuKM",7) == 4213886376) strcat(s, "g");
if (crc32("erPfD",5) == 2020343855) strcat(s, "n");
if (crc32("EcqLPibsAqJFbG",14) == 2998410054) strcat(s, "U");
if (crc32("VZUPISWjMSgp",12) == 2218152259) strcat(s, "t");
if (crc32("wuvnzgZMgCVNK",13) == 3158471210) strcat(s, "q");
if (crc32("oggwybk",7) == 4262596034) strcat(s, "e");
if (crc32("DwFXlIHVbb",10) == 1407580031) strcat(s, "X");
if (crc32("cYGrmOuuqubYRv",14) == 10094652) strcat(s, "d");
if (crc32("GPLmDVjJqAxix",13) == 3448896337) strcat(s, "l");
if (crc32("TxImG",5) == 3801768435) strcat(s, "y");
    return s;
}

char *overflowingly_adverbs() {
    char *s = calloc(14);
    if (crc32("feGvpUCWpgPqtk",14) == 465734181) strcat(s, "L");
if (crc32("ufQorlWFPC",10) == 1433054273) strcat(s, "o");
if (crc32("XmpxsOm",7) == 2822279682) strcat(s, "J");
if (crc32("mrzgozBtRwD",11) == 3523633584) strcat(s, "v");
if (crc32("aaYVfMNyAeh",11) == 3207901053) strcat(s, "w");
if (crc32("hrDsjj",6) == 2797833523) strcat(s, "e");
if (crc32("TeJFnlryds",10) == 3662207561) strcat(s, "h");
if (crc32("HkLsWGRmYdlT",12) == 3520673689) strcat(s, "r");
if (crc32("AqhJFdVjATH",11) == 2195174015) strcat(s, "k");
if (crc32("FbQRh",5) == 639956807) strcat(s, "f");
if (crc32("jZmWhpWA",8) == 3283605397) strcat(s, "l");
if (crc32("jbblHXIzvoPptq",14) == 1891685243) strcat(s, "o");
if (crc32("zIsAebVkVb",10) == 3993048088) strcat(s, "w");
if (crc32("YxPXodGMUKZlVop",15) == 2043603438) strcat(s, "W");
if (crc32("MHSQKSkRGs",10) == 1552445299) strcat(s, "i");
if (crc32("jiEdhthlT",9) == 3408106255) strcat(s, "n");
if (crc32("hCUySGfhxCo",11) == 3422304680) strcat(s, "g");
if (crc32("dKzyuPEr",8) == 715926012) strcat(s, "l");
if (crc32("NpScOIpRt",9) == 2013260281) strcat(s, "y");
    return s;
}

char *lurchingly_adverbs() {
    char *s = calloc(11);
    if (crc32("MroWQAhSwbuIpMI",15) == 4152910452) strcat(s, "k");
if (crc32("NewzSpXJolXk",12) == 3184073648) strcat(s, "l");
if (crc32("hHjNhGLd",8) == 3257955468) strcat(s, "u");
if (crc32("QARSnzYhRrab",12) == 1685241348) strcat(s, "o");
if (crc32("EjbCog",6) == 4019575314) strcat(s, "r");
if (crc32("VqtAKRKkFk",10) == 996286239) strcat(s, "p");
if (crc32("JPIgvdBQsFsk",12) == 39343557) strcat(s, "c");
if (crc32("ubvzkTFStyvXNoQ",15) == 651195325) strcat(s, "h");
if (crc32("UZwMsSwt",8) == 1768157244) strcat(s, "i");
if (crc32("TqtRiHRNar",10) == 2422385729) strcat(s, "v");
if (crc32("zlcRKWPwR",9) == 260487311) strcat(s, "n");
if (crc32("gVZYBncVF",9) == 560139603) strcat(s, "g");
if (crc32("UuaeKg",6) == 3370474137) strcat(s, "b");
if (crc32("bVKPdU",6) == 2039795661) strcat(s, "l");
if (crc32("jZhOxctuvIP",11) == 1425931812) strcat(s, "s");
if (crc32("yTeXYmgd",8) == 3348415215) strcat(s, "y");
    return s;
}

char *Paulinistically_adverbs() {
    char *s = calloc(16);
    if (crc32("IntQcDmomrAc",12) == 2902348171) strcat(s, "P");
if (crc32("eHNKaCMRyQaGv",13) == 2282457974) strcat(s, "a");
if (crc32("wusfeDflrRGEEYW",15) == 3899139473) strcat(s, "z");
if (crc32("LSRcVIjDidegngw",15) == 2138010610) strcat(s, "u");
if (crc32("CGKMsSeKkMzr",12) == 849005073) strcat(s, "l");
if (crc32("eEghpRW",7) == 3884236931) strcat(s, "i");
if (crc32("KOpYmFmbisi",11) == 1615778313) strcat(s, "k");
if (crc32("zZvFiaWgXwTDNnU",15) == 449919404) strcat(s, "n");
if (crc32("XKtpDsh",7) == 2773129328) strcat(s, "T");
if (crc32("ofXYKFAfHRAOw",13) == 677335515) strcat(s, "i");
if (crc32("xZniEMaaWIIyx",13) == 1831619274) strcat(s, "s");
if (crc32("JKnMjjXCSv",10) == 4161816943) strcat(s, "t");
if (crc32("ZwGvb",5) == 3982884115) strcat(s, "i");
if (crc32("WMMStpDnfkiQ",12) == 1523090229) strcat(s, "U");
if (crc32("dXxdHT",6) == 2671235978) strcat(s, "c");
if (crc32("DjWDlRynv",9) == 1914304783) strcat(s, "a");
if (crc32("nmSMxcnDQcCQ",12) == 2239156923) strcat(s, "T");
if (crc32("cJZSVvoBA",9) == 1327345405) strcat(s, "l");
if (crc32("jQtmMUMpRuEA",12) == 1686391926) strcat(s, "l");
if (crc32("CrHDrJae",8) == 1208679) strcat(s, "s");
if (crc32("CdOEGKkmcmeKjz",14) == 817309397) strcat(s, "y");
    return s;
}

char *taperingly_adverbs() {
    char *s = calloc(11);
    if (crc32("uvlHCDnB",8) == 1517859067) strcat(s, "L");
if (crc32("yFLuWgqwAjo",11) == 1405379592) strcat(s, "t");
if (crc32("kUIBz",5) == 831537331) strcat(s, "s");
if (crc32("tARRwtMaxeFTl",13) == 855541953) strcat(s, "a");
if (crc32("kEHYCVRBD",9) == 2849296195) strcat(s, "P");
if (crc32("YeqYssyspFv",11) == 1690422989) strcat(s, "p");
if (crc32("BcfQaSgMaSzhR",13) == 2320896490) strcat(s, "l");
if (crc32("xinLWnm",7) == 996037360) strcat(s, "e");
if (crc32("TMGYdznll",9) == 3080402061) strcat(s, "O");
if (crc32("FkHREomig",9) == 605162534) strcat(s, "r");
if (crc32("pGOvclLDJNJXe",13) == 1816693757) strcat(s, "Q");
if (crc32("taWLKkKaledRjbU",15) == 2269776264) strcat(s, "i");
if (crc32("IpheYP",6) == 3504044806) strcat(s, "n");
if (crc32("QMMYNrftmVVvS",13) == 2431164863) strcat(s, "N");
if (crc32("xPXuq",5) == 3546865824) strcat(s, "g");
if (crc32("bEbLpURxp",9) == 2661959307) strcat(s, "N");
if (crc32("KJSHvCjXjbul",12) == 2399076226) strcat(s, "l");
if (crc32("PjtePatFYotj",12) == 3451689767) strcat(s, "m");
if (crc32("fWFJWX",6) == 3060024221) strcat(s, "y");
    return s;
}

char *distractively_adverbs() {
    char *s = calloc(14);
    if (crc32("EVXDYHoaWmMdoeE",15) == 2138270632) strcat(s, "A");
if (crc32("woVrXnooRoDzMn",14) == 2955706365) strcat(s, "d");
if (crc32("aoAmejQlRhzDlyD",15) == 4178273921) strcat(s, "B");
if (crc32("jwHEUBDjXqgXfwu",15) == 2589573254) strcat(s, "i");
if (crc32("zUuWYfYssqOt",12) == 2248535210) strcat(s, "h");
if (crc32("IGtYxdWMWn",10) == 1596647865) strcat(s, "s");
if (crc32("LExPyhnFyE",10) == 4231917033) strcat(s, "t");
if (crc32("dELXtlnHsvR",11) == 4168628884) strcat(s, "t");
if (crc32("QKPAzWAWonlgaz",14) == 3396278484) strcat(s, "H");
if (crc32("BOIGjXmszJHrf",13) == 3924984581) strcat(s, "r");
if (crc32("eqVbjQWUpPvfKbL",15) == 2949388615) strcat(s, "x");
if (crc32("njgeV",5) == 1671536592) strcat(s, "a");
if (crc32("JyTCpHHdqIG",11) == 1048324370) strcat(s, "L");
if (crc32("biraKbpsgpZYiSA",15) == 3529905858) strcat(s, "c");
if (crc32("wWPdZkGVrSb",11) == 1978228529) strcat(s, "w");
if (crc32("jPHNmsxOwWrmNe",14) == 1514470940) strcat(s, "t");
if (crc32("meHbbJueXI",10) == 536908471) strcat(s, "I");
if (crc32("mzBKxjDQ",8) == 1758792383) strcat(s, "i");
if (crc32("hWiigUnlUbQOsIZ",15) == 527372410) strcat(s, "v");
if (crc32("ulAyr",5) == 3075401025) strcat(s, "e");
if (crc32("GFzATsHm",8) == 3085999508) strcat(s, "l");
if (crc32("wdpfTePfe",9) == 3070702051) strcat(s, "y");
    return s;
}

char *sociologistically_adverbs() {
    char *s = calloc(18);
    if (crc32("ubNtixYIklqxN",13) == 3130439034) strcat(s, "s");
if (crc32("nhemoVwYvLRnP",13) == 2584028007) strcat(s, "o");
if (crc32("LeqZmf",6) == 1587555985) strcat(s, "c");
if (crc32("MlmYmXbAtSR",11) == 3609775597) strcat(s, "i");
if (crc32("qIETDcJGItnFnIe",15) == 2878793899) strcat(s, "o");
if (crc32("QzYmz",5) == 3292383593) strcat(s, "l");
if (crc32("pdSkVgqn",8) == 3986920249) strcat(s, "o");
if (crc32("uWFroRDDctp",11) == 683483816) strcat(s, "g");
if (crc32("xoLlfg",6) == 4235892238) strcat(s, "u");
if (crc32("cMNTmOI",7) == 263593188) strcat(s, "i");
if (crc32("PeeuMWVW",8) == 2581739755) strcat(s, "s");
if (crc32("AXJUzeYKOdNR",12) == 616117624) strcat(s, "t");
if (crc32("QyYeIYyGLRMyD",13) == 3895964146) strcat(s, "z");
if (crc32("kbTEYdNAVxrI",12) == 3448459458) strcat(s, "i");
if (crc32("UDyzSUVzvwGlS",13) == 2316855395) strcat(s, "i");
if (crc32("HidEnvfOs",9) == 4134145978) strcat(s, "c");
if (crc32("IsJfGrPARwU",11) == 2931411658) strcat(s, "n");
if (crc32("rfAVjpjtAfY",11) == 149112615) strcat(s, "a");
if (crc32("ZULWMSQ",7) == 2028667894) strcat(s, "l");
if (crc32("TCADI",5) == 1977480570) strcat(s, "p");
if (crc32("PQuxIhchHTElidi",15) == 484964783) strcat(s, "l");
if (crc32("EKnOjh",6) == 3174069166) strcat(s, "y");
    return s;
}

char *hackingly_adverbs() {
    char *s = calloc(10);
    if (crc32("ZywtrMHBWQzt",12) == 2063012816) strcat(s, "F");
if (crc32("cijthhHqqyGad",13) == 2250863254) strcat(s, "h");
if (crc32("HfQbKEXtHoPmiM",14) == 27908290) strcat(s, "a");
if (crc32("ikOrVNeDloo",11) == 1885548964) strcat(s, "k");
if (crc32("XJdUyAgm",8) == 517798078) strcat(s, "c");
if (crc32("pPTfIyVeoIg",11) == 3799515458) strcat(s, "k");
if (crc32("hHHCvBa",7) == 1123280046) strcat(s, "Y");
if (crc32("aENYMx",6) == 3788920850) strcat(s, "i");
if (crc32("NONwtTHWuLFwFH",14) == 2296437586) strcat(s, "B");
if (crc32("JeYJAqiBcLUBPiV",15) == 3934657243) strcat(s, "n");
if (crc32("fQtzpxVVWx",10) == 1118935085) strcat(s, "m");
if (crc32("QAudOG",6) == 2682634147) strcat(s, "g");
if (crc32("MVuvGcjIJGJHb",13) == 1126575951) strcat(s, "l");
if (crc32("HaVxnxRc",8) == 2465047604) strcat(s, "S");
if (crc32("ZmgLxK",6) == 2766989622) strcat(s, "y");
    return s;
}

char *bimanually_adverbs() {
    char *s = calloc(11);
    if (crc32("mWLeZxdcq",9) == 483666759) strcat(s, "N");
if (crc32("RiJrnqgrCbsMeAi",15) == 628724458) strcat(s, "b");
if (crc32("NUqojlTSdnz",11) == 507249586) strcat(s, "i");
if (crc32("VKzwI",5) == 192735689) strcat(s, "m");
if (crc32("rGRjVQ",6) == 3375536991) strcat(s, "a");
if (crc32("mcqEtfq",7) == 1339593379) strcat(s, "i");
if (crc32("IPCTMCtCmN",10) == 4175186884) strcat(s, "n");
if (crc32("rTxqWyAXLxa",11) == 1393657663) strcat(s, "u");
if (crc32("wrrYuBiYHGmcX",13) == 697271270) strcat(s, "S");
if (crc32("dHJAgjMyKbPxu",13) == 3610184754) strcat(s, "a");
if (crc32("lsRGcrt",7) == 405578119) strcat(s, "l");
if (crc32("KizuBYofeDYTod",14) == 839347516) strcat(s, "l");
if (crc32("jagRYxvyCU",10) == 926015239) strcat(s, "y");
    return s;
}

char *compellably_adverbs() {
    char *s = calloc(12);
    if (crc32("kzjIkiT",7) == 390197343) strcat(s, "c");
if (crc32("kyRhaNu",7) == 2201067008) strcat(s, "o");
if (crc32("NZMTbs",6) == 3934133981) strcat(s, "l");
if (crc32("GzShkmUyjWMo",12) == 4243088497) strcat(s, "m");
if (crc32("noZBpP",6) == 1170274742) strcat(s, "P");
if (crc32("axfdwONGt",9) == 3010889574) strcat(s, "p");
if (crc32("zqqpevmSDikQ",12) == 904898396) strcat(s, "U");
if (crc32("sOPjKSa",7) == 92686501) strcat(s, "e");
if (crc32("wbQTXUIqry",10) == 1448830888) strcat(s, "H");
if (crc32("GkhnIimjQZ",10) == 2168069167) strcat(s, "l");
if (crc32("zmVRoLnmGl",10) == 3492490453) strcat(s, "x");
if (crc32("eimCf",5) == 3998496625) strcat(s, "l");
if (crc32("GTjgQIvOXZ",10) == 3776385452) strcat(s, "a");
if (crc32("YPExZP",6) == 2135376538) strcat(s, "b");
if (crc32("IWFmwFWxpgTei",13) == 3692754147) strcat(s, "J");
if (crc32("lvXJmzFt",8) == 4263631360) strcat(s, "l");
if (crc32("WtEbIyZjlirQKy",14) == 3788500235) strcat(s, "y");
    return s;
}

char *excusingly_adverbs() {
    char *s = calloc(11);
    if (crc32("RsrscltCdlcjN",13) == 271289085) strcat(s, "w");
if (crc32("RtHQW",5) == 1217013831) strcat(s, "e");
if (crc32("DzDYNKeaAxNg",12) == 132499505) strcat(s, "R");
if (crc32("XqoTXvo",7) == 3571581714) strcat(s, "x");
if (crc32("EGzhtr",6) == 3013265575) strcat(s, "c");
if (crc32("ykNdaUPyzT",10) == 2888934566) strcat(s, "J");
if (crc32("TFEruCImv",9) == 3631339114) strcat(s, "u");
if (crc32("IKybMEryKm",10) == 704651211) strcat(s, "L");
if (crc32("IoFhYXVMkK",10) == 2274720301) strcat(s, "s");
if (crc32("ikZxUN",6) == 1953423818) strcat(s, "k");
if (crc32("nZRBl",5) == 2917346269) strcat(s, "i");
if (crc32("ymrQAffodziuA",13) == 2774279233) strcat(s, "k");
if (crc32("xIxpJNTCp",9) == 3328818008) strcat(s, "n");
if (crc32("lvhJDcYTzLBxg",13) == 3926111153) strcat(s, "g");
if (crc32("wPFZMLaVweeEfLz",15) == 3405918832) strcat(s, "l");
if (crc32("XZRAykVTo",9) == 3964922708) strcat(s, "M");
if (crc32("WAvylp",6) == 1239617821) strcat(s, "y");
    return s;
}

char *unlawfully_adverbs() {
    char *s = calloc(11);
    if (crc32("GrZNp",5) == 4263595544) strcat(s, "Y");
if (crc32("dEuZmFtHptpaj",13) == 1773167310) strcat(s, "u");
if (crc32("hYjDDQjUE",9) == 2855026840) strcat(s, "n");
if (crc32("zkgQTLR",7) == 1576589989) strcat(s, "l");
if (crc32("kvzkxvtLtth",11) == 4185617837) strcat(s, "O");
if (crc32("IfVcACIP",8) == 2759274622) strcat(s, "a");
if (crc32("EWVPOJUPZSb",11) == 3074528332) strcat(s, "w");
if (crc32("kgoKncB",7) == 3255843281) strcat(s, "f");
if (crc32("EZrEyUrn",8) == 2655029900) strcat(s, "u");
if (crc32("wJygico",7) == 3393219742) strcat(s, "T");
if (crc32("LiGMMYXeTrU",11) == 4114045522) strcat(s, "l");
if (crc32("ZJphwuVOwEX",11) == 883410810) strcat(s, "l");
if (crc32("WrQqr",5) == 1752600817) strcat(s, "y");
    return s;
}

char *eventually_adverbs() {
    char *s = calloc(11);
    if (crc32("bHBFZBaYKSBs",12) == 746969485) strcat(s, "e");
if (crc32("LdktTfGqGBWyT",13) == 3614333542) strcat(s, "v");
if (crc32("pOpiABUJ",8) == 4086233000) strcat(s, "t");
if (crc32("yUqIgkyWRiL",11) == 1250459930) strcat(s, "e");
if (crc32("taAtQSjKsqqjM",13) == 1704796409) strcat(s, "w");
if (crc32("xOGQvXacz",9) == 3566143220) strcat(s, "n");
if (crc32("AXDstZcjzkz",11) == 1086167444) strcat(s, "y");
if (crc32("suHgqPhPo",9) == 2270104942) strcat(s, "t");
if (crc32("kDzhPRDYonXU",12) == 3483835279) strcat(s, "R");
if (crc32("TfNZKqlODGf",11) == 3625077141) strcat(s, "u");
if (crc32("CohLMHqbyfzAPi",14) == 2220960214) strcat(s, "a");
if (crc32("XcbYizXCMgcH",12) == 3916695985) strcat(s, "l");
if (crc32("tJMKr",5) == 700302564) strcat(s, "U");
if (crc32("qyNmHp",6) == 3592371765) strcat(s, "l");
if (crc32("rodtyRAAwBUGA",13) == 1875402428) strcat(s, "s");
if (crc32("NsPdl",5) == 1900196647) strcat(s, "y");
    return s;
}

char *unequivalently_adverbs() {
    char *s = calloc(15);
    if (crc32("dIqCMimHyU",10) == 3439663096) strcat(s, "Y");
if (crc32("NavMIgDCEt",10) == 3633005635) strcat(s, "u");
if (crc32("TvLdFHkqOJjuBii",15) == 2684902537) strcat(s, "n");
if (crc32("obaodQCBXRTlYpq",15) == 2571554526) strcat(s, "e");
if (crc32("EyuADrMbHr",10) == 2794065379) strcat(s, "H");
if (crc32("KMwoL",5) == 1288575651) strcat(s, "q");
if (crc32("jfLPjxD",7) == 3911099129) strcat(s, "u");
if (crc32("sCAsoQlsFTjlj",13) == 743110824) strcat(s, "i");
if (crc32("eLlJhCFArmYR",12) == 868651499) strcat(s, "p");
if (crc32("hpxSNX",6) == 1737256844) strcat(s, "v");
if (crc32("DogamWJSxqN",11) == 3288997938) strcat(s, "a");
if (crc32("fBSDiOQsblu",11) == 1229473178) strcat(s, "e");
if (crc32("zPCtAomWwHGNL",13) == 1232295009) strcat(s, "l");
if (crc32("lbJnbu",6) == 455756605) strcat(s, "m");
if (crc32("khmAPSUG",8) == 192998930) strcat(s, "e");
if (crc32("ZvsYPmwDYtODUD",14) == 2292444521) strcat(s, "V");
if (crc32("BPLVDURkNY",10) == 139564352) strcat(s, "n");
if (crc32("CFwGDuwrjKdSDCh",15) == 719969842) strcat(s, "t");
if (crc32("FWagxfkdDnDI",12) == 2807109728) strcat(s, "l");
if (crc32("TuActfqVSNLIpkN",15) == 2068995515) strcat(s, "y");
    return s;
}

char *electrophysiologically_adverbs() {
    char *s = calloc(23);
    if (crc32("vpzJO",5) == 1288811269) strcat(s, "B");
if (crc32("UTDPmtxny",9) == 3201336920) strcat(s, "e");
if (crc32("wmlHEnFe",8) == 1260094749) strcat(s, "l");
if (crc32("XaKrGLSg",8) == 3152126810) strcat(s, "x");
if (crc32("ffyfTGmaMEE",11) == 2443084084) strcat(s, "e");
if (crc32("ZGlBnIbm",8) == 3172441383) strcat(s, "c");
if (crc32("sVuBGCCfbgTuoA",14) == 2571171130) strcat(s, "j");
if (crc32("NAAxkYmikJxAIvJ",15) == 1737739555) strcat(s, "t");
if (crc32("mHmGWyLBGVVU",12) == 3672207643) strcat(s, "r");
if (crc32("hzcEURhptRKXizp",15) == 386814700) strcat(s, "K");
if (crc32("optQHBxsbyyAArn",15) == 1221386971) strcat(s, "o");
if (crc32("SOGFCGD",7) == 2577823879) strcat(s, "p");
if (crc32("DyGmidoNYaqt",12) == 754305232) strcat(s, "h");
if (crc32("JPQNygveXXzm",12) == 2994505712) strcat(s, "G");
if (crc32("KeaPjK",6) == 347408082) strcat(s, "y");
if (crc32("WfQaHYOTIzcy",12) == 2035733154) strcat(s, "C");
if (crc32("yLHAMnSxVo",10) == 3993394819) strcat(s, "s");
if (crc32("tVtOE",5) == 112838453) strcat(s, "i");
if (crc32("rakbdJApjJtw",12) == 1556364341) strcat(s, "o");
if (crc32("opyoaXFyt",9) == 1052253284) strcat(s, "l");
if (crc32("QqQNvU",6) == 3840619195) strcat(s, "i");
if (crc32("VndVC",5) == 3865232450) strcat(s, "o");
if (crc32("SVgeWzGIo",9) == 795164477) strcat(s, "g");
if (crc32("krnQeUXpeNJtSEq",15) == 3598927721) strcat(s, "i");
if (crc32("JjTgLEK",7) == 1572915544) strcat(s, "H");
if (crc32("syjTUW",6) == 3311116351) strcat(s, "c");
if (crc32("cNUsBupXMVpJ",12) == 1491355695) strcat(s, "a");
if (crc32("NVgZwibJ",8) == 240054930) strcat(s, "l");
if (crc32("oPwLvsvIK",9) == 83596963) strcat(s, "K");
if (crc32("KKcWTGcu",8) == 210759705) strcat(s, "l");
if (crc32("IZHsfbBdPUA",11) == 3198680383) strcat(s, "y");
    return s;
}

char *anticly_adverbs() {
    char *s = calloc(8);
    if (crc32("ViQfVcEfvbgL",12) == 3397657016) strcat(s, "a");
if (crc32("VAyZMk",6) == 1939730853) strcat(s, "o");
if (crc32("BANvNuHh",8) == 4246647701) strcat(s, "n");
if (crc32("pWpSaKAqOjXF",12) == 2191381347) strcat(s, "t");
if (crc32("DYkNP",5) == 2456713833) strcat(s, "e");
if (crc32("fZjVGCO",7) == 2904123680) strcat(s, "i");
if (crc32("FeezKSy",7) == 3434315137) strcat(s, "v");
if (crc32("HiXRRoJSXf",10) == 3127540433) strcat(s, "c");
if (crc32("dqFjAAmYYFGnKh",14) == 1944514890) strcat(s, "x");
if (crc32("YjMgmmvptX",10) == 1925265093) strcat(s, "l");
if (crc32("wlYWDwyq",8) == 2988710207) strcat(s, "y");
    return s;
}

char *insensately_adverbs() {
    char *s = calloc(12);
    if (crc32("thuolJg",7) == 2870366123) strcat(s, "i");
if (crc32("QoEAbBeiTEtXOq",14) == 2406794710) strcat(s, "n");
if (crc32("zbsuRMo",7) == 2235138980) strcat(s, "s");
if (crc32("MEEGtRYEKjI",11) == 695272516) strcat(s, "y");
if (crc32("VndEnRMxbm",10) == 2798284697) strcat(s, "e");
if (crc32("fEvgxLTnLn",10) == 97171480) strcat(s, "n");
if (crc32("ZnuFlUd",7) == 1805930983) strcat(s, "s");
if (crc32("PbULYyDFo",9) == 543886819) strcat(s, "a");
if (crc32("UgekDTHdIJcYAs",14) == 2944205831) strcat(s, "t");
if (crc32("Ekrbh",5) == 4144980339) strcat(s, "L");
if (crc32("GRxMMAKoD",9) == 1265121861) strcat(s, "e");
if (crc32("AyQgyPy",7) == 3563472111) strcat(s, "h");
if (crc32("UOOfDWwZYSi",11) == 2456322341) strcat(s, "l");
if (crc32("CSGLAdgCWMWrVo",14) == 875570826) strcat(s, "B");
if (crc32("caOKPgZlzFIWw",13) == 896677579) strcat(s, "y");
    return s;
}

char *nonevolutionally_adverbs() {
    char *s = calloc(17);
    if (crc32("XMXlz",5) == 933564187) strcat(s, "q");
if (crc32("oqAchJlXh",9) == 1142440011) strcat(s, "n");
if (crc32("ayXCXWvkTVW",11) == 2001089085) strcat(s, "o");
if (crc32("MWXngHQA",8) == 2366935563) strcat(s, "n");
if (crc32("HKxjdjyV",8) == 3840374740) strcat(s, "t");
if (crc32("bsIUJDTWAUj",11) == 3854439053) strcat(s, "e");
if (crc32("POGwt",5) == 554475200) strcat(s, "l");
if (crc32("rHtWlfQzU",9) == 715696321) strcat(s, "v");
if (crc32("RNGBjynBhjJvx",13) == 3311018773) strcat(s, "a");
if (crc32("cGXla",5) == 2401341545) strcat(s, "o");
if (crc32("oRVwJHD",7) == 4096010154) strcat(s, "R");
if (crc32("xneMPNcBcvaYX",13) == 95871152) strcat(s, "l");
if (crc32("rfbBIHpZO",9) == 2313448207) strcat(s, "u");
if (crc32("nJQtELogF",9) == 61579771) strcat(s, "c");
if (crc32("iPhMTnY",7) == 3448523718) strcat(s, "t");
if (crc32("qvQJepzVSykko",13) == 786340002) strcat(s, "y");
if (crc32("miZPHnqcAe",10) == 1489096398) strcat(s, "i");
if (crc32("fjoYfDlWT",9) == 68228221) strcat(s, "o");
if (crc32("aQLmyBryZhKY",12) == 1767223150) strcat(s, "n");
if (crc32("NxSuaOxHM",9) == 3520071051) strcat(s, "y");
if (crc32("ZZKWoJGWEceNOb",14) == 2331658849) strcat(s, "a");
if (crc32("iEdsbjeRx",9) == 2866611224) strcat(s, "l");
if (crc32("QIImpVLY",8) == 700313348) strcat(s, "l");
if (crc32("IzCxItIPKOud",12) == 3851491509) strcat(s, "y");
    return s;
}

char *weightedly_adverbs() {
    char *s = calloc(11);
    if (crc32("DofCIOhqvri",11) == 3859279114) strcat(s, "C");
if (crc32("AdIMyCVMBVsuVR",14) == 2674952102) strcat(s, "w");
if (crc32("QDWylooKkbVQc",13) == 1983399227) strcat(s, "G");
if (crc32("msmgPCvVJd",10) == 2125683269) strcat(s, "e");
if (crc32("sDVpWD",6) == 2977748424) strcat(s, "p");
if (crc32("AhbyswM",7) == 1356260266) strcat(s, "i");
if (crc32("JsBnproNGOxz",12) == 3082375334) strcat(s, "c");
if (crc32("eOPUIiJSQ",9) == 2632750501) strcat(s, "g");
if (crc32("tlZAcVieuOqFT",13) == 1860898821) strcat(s, "h");
if (crc32("augyHXB",7) == 3538158810) strcat(s, "n");
if (crc32("TjkReDccv",9) == 3102254855) strcat(s, "t");
if (crc32("dxvYDXXumyfr",12) == 1107562126) strcat(s, "e");
if (crc32("jWOLRQPIpnePpBl",15) == 3150435513) strcat(s, "d");
if (crc32("JpFBLarnslf",11) == 1194820615) strcat(s, "P");
if (crc32("pyehrtF",7) == 1911591140) strcat(s, "l");
if (crc32("OUUmohUZ",8) == 1674535542) strcat(s, "n");
if (crc32("sQidHqVFt",9) == 429557577) strcat(s, "y");
    return s;
}

char *botchily_adverbs() {
    char *s = calloc(9);
    if (crc32("KUgrULtiKAPG",12) == 722557253) strcat(s, "b");
if (crc32("sHAaXHNzyihr",12) == 3124126300) strcat(s, "K");
if (crc32("VRnrJJw",7) == 3269541938) strcat(s, "o");
if (crc32("OEOSRYrlJKcEzj",14) == 1277053573) strcat(s, "z");
if (crc32("shriipFxapbreD",14) == 2291289368) strcat(s, "t");
if (crc32("hGSXkPXBvAAFOpJ",15) == 3394519152) strcat(s, "c");
if (crc32("DDeec",5) == 790099824) strcat(s, "Y");
if (crc32("hmMck",5) == 1256094312) strcat(s, "h");
if (crc32("xHItqNbW",8) == 148768343) strcat(s, "M");
if (crc32("PzoDKztnjOfpNW",14) == 411937237) strcat(s, "i");
if (crc32("DEewDFAlGDlmp",13) == 560917736) strcat(s, "l");
if (crc32("IWmyhkewevwAO",13) == 3637959144) strcat(s, "N");
if (crc32("VUoXlr",6) == 3981420052) strcat(s, "y");
    return s;
}

char *lamentingly_adverbs() {
    char *s = calloc(12);
    if (crc32("KpQdXUtHhs",10) == 2111057121) strcat(s, "l");
if (crc32("fIXfs",5) == 4288819355) strcat(s, "F");
if (crc32("WICChjkroiaM",12) == 2441102661) strcat(s, "a");
if (crc32("BSvXnq",6) == 2087073812) strcat(s, "m");
if (crc32("FehLcK",6) == 299744219) strcat(s, "e");
if (crc32("uppNDGaqxuLk",12) == 2289776388) strcat(s, "n");
if (crc32("HxlmA",5) == 2423208526) strcat(s, "t");
if (crc32("duvBNrmIPP",10) == 3918461731) strcat(s, "i");
if (crc32("kfMosmJhT",9) == 760462615) strcat(s, "V");
if (crc32("pZoAGaTmEuHng",13) == 2382983421) strcat(s, "n");
if (crc32("sprDkqp",7) == 2295185608) strcat(s, "W");
if (crc32("yqEpCmjEsMF",11) == 4247278467) strcat(s, "g");
if (crc32("MANZLrapLsix",12) == 2918634742) strcat(s, "y");
if (crc32("selQq",5) == 2982639048) strcat(s, "l");
if (crc32("KINVKzV",7) == 3547238642) strcat(s, "g");
if (crc32("qImLT",5) == 2487870530) strcat(s, "y");
    return s;
}

char *discommodiously_adverbs() {
    char *s = calloc(16);
    if (crc32("DfUzWe",6) == 2637394526) strcat(s, "m");
if (crc32("rnlhL",5) == 222960338) strcat(s, "d");
if (crc32("rvEPbklChWRe",12) == 2868084893) strcat(s, "q");
if (crc32("mijNDN",6) == 3127179552) strcat(s, "i");
if (crc32("aHClvasjKV",10) == 2273826322) strcat(s, "s");
if (crc32("HpNpDVmKOns",11) == 3300811257) strcat(s, "Q");
if (crc32("cahoriWtx",9) == 1730134024) strcat(s, "c");
if (crc32("FCvzF",5) == 2267634350) strcat(s, "V");
if (crc32("TayhgGj",7) == 3704168278) strcat(s, "o");
if (crc32("uGqlqEL",7) == 2110202765) strcat(s, "y");
if (crc32("hazJKCVGM",9) == 2194544958) strcat(s, "m");
if (crc32("fnnDglzFNGlgtn",14) == 1934143268) strcat(s, "n");
if (crc32("kOZOGKxeoY",10) == 2419654069) strcat(s, "m");
if (crc32("ZIroQCNe",8) == 2140201113) strcat(s, "o");
if (crc32("VWzHDN",6) == 843843950) strcat(s, "A");
if (crc32("cGnquRB",7) == 2190149846) strcat(s, "d");
if (crc32("dMvLOUrgCAC",11) == 2731346061) strcat(s, "i");
if (crc32("nRodAlbwRXOoOEu",15) == 2414327008) strcat(s, "o");
if (crc32("nlNlexgAuNLMU",13) == 1191368951) strcat(s, "W");
if (crc32("IDNeLYWPvwMan",13) == 52358851) strcat(s, "u");
if (crc32("CCUCLZoGyEI",11) == 608573113) strcat(s, "s");
if (crc32("sHMZnwUTE",9) == 1141325439) strcat(s, "T");
if (crc32("ZkTGK",5) == 1831180227) strcat(s, "l");
if (crc32("lZpSmfg",7) == 4235981396) strcat(s, "y");
    return s;
}

char *objurgatorily_adverbs() {
    char *s = calloc(14);
    if (crc32("umuzfFjs",8) == 3208311714) strcat(s, "o");
if (crc32("FgncxdIz",8) == 2379207815) strcat(s, "I");
if (crc32("TQqqe",5) == 651110870) strcat(s, "b");
if (crc32("ecrdWCNqJW",10) == 4288655455) strcat(s, "j");
if (crc32("nhEoIxn",7) == 1684417594) strcat(s, "i");
if (crc32("WwiJgF",6) == 1704660073) strcat(s, "u");
if (crc32("CvViTB",6) == 2717504563) strcat(s, "r");
if (crc32("UDBnHOdCRivZ",12) == 2812735156) strcat(s, "g");
if (crc32("TurRhun",7) == 450315050) strcat(s, "B");
if (crc32("nXoyychYZ",9) == 3739932882) strcat(s, "a");
if (crc32("XbMMAnutW",9) == 2599084351) strcat(s, "P");
if (crc32("gtVcoN",6) == 2140661430) strcat(s, "t");
if (crc32("QoVWJhts",8) == 3484207096) strcat(s, "k");
if (crc32("qvDmxvZqIVjqbjj",15) == 4215478132) strcat(s, "o");
if (crc32("mMjHOloEHyMVX",13) == 3902132816) strcat(s, "T");
if (crc32("DnOAsiflEfcbIf",14) == 837538068) strcat(s, "r");
if (crc32("WuKipUkNA",9) == 1407185127) strcat(s, "i");
if (crc32("tdGaKeYMzOTmHSs",15) == 29774090) strcat(s, "Y");
if (crc32("bjxYZH",6) == 3536421166) strcat(s, "l");
if (crc32("teZiPhOFh",9) == 589175792) strcat(s, "y");
    return s;
}

char *fullsail_adverbs() {
    char *s = calloc(9);
    if (crc32("hOCYWpfDkcMxL",13) == 685446827) strcat(s, "Y");
if (crc32("mXRiJg",6) == 4069088735) strcat(s, "f");
if (crc32("COOxCWrFa",9) == 362992042) strcat(s, "C");
if (crc32("ihlOs",5) == 1404206277) strcat(s, "u");
if (crc32("hwChyfe",7) == 2274105305) strcat(s, "l");
if (crc32("mnoRZRpxbyeEBi",14) == 1564703758) strcat(s, "P");
if (crc32("riSjZNc",7) == 958536605) strcat(s, "l");
if (crc32("uaFyVLql",8) == 1683369245) strcat(s, "s");
if (crc32("NxcoztXNfKWMdZ",14) == 2002367209) strcat(s, "Y");
if (crc32("fVENtOYj",8) == 3530572866) strcat(s, "a");
if (crc32("FPdClSOyXt",10) == 2517736881) strcat(s, "U");
if (crc32("FStNhOjDjIOL",12) == 976159071) strcat(s, "i");
if (crc32("iSFmlMKLkkjmiN",14) == 2959598122) strcat(s, "A");
if (crc32("pAjWgZyghzYKiB",14) == 1350845777) strcat(s, "l");
    return s;
}

char *numismatically_adverbs() {
    char *s = calloc(15);
    if (crc32("posEY",5) == 2512090270) strcat(s, "n");
if (crc32("QiTqNmSNxpYpa",13) == 299138483) strcat(s, "u");
if (crc32("OwWOCXupO",9) == 3573603830) strcat(s, "i");
if (crc32("KsOHBeqOGT",10) == 2745078303) strcat(s, "m");
if (crc32("AjlTwytLSuyA",12) == 545016168) strcat(s, "i");
if (crc32("AgWNSUOPoYd",11) == 1487139263) strcat(s, "s");
if (crc32("sYfZO",5) == 607679335) strcat(s, "m");
if (crc32("fSFolY",6) == 920108792) strcat(s, "a");
if (crc32("zNAZmPh",7) == 2564311413) strcat(s, "t");
if (crc32("NgtVWHbgHhboTy",14) == 4103971332) strcat(s, "T");
if (crc32("BSEbovpxzzIjudS",15) == 2138218872) strcat(s, "i");
if (crc32("TlQfnAtHUMJ",11) == 2138458932) strcat(s, "K");
if (crc32("rdTQuTCPSjFp",12) == 1851055589) strcat(s, "c");
if (crc32("imlQgtHSU",9) == 198617879) strcat(s, "P");
if (crc32("HrzjWpuKhgB",11) == 3050030308) strcat(s, "a");
if (crc32("ytlmcDKbdAHB",12) == 3877213396) strcat(s, "l");
if (crc32("igkuQoTj",8) == 4095505016) strcat(s, "l");
if (crc32("ENuPaueXopWX",12) == 1621943254) strcat(s, "y");
    return s;
}

char *forethoughtfully_adverbs() {
    char *s = calloc(17);
    if (crc32("buEtsGOPZBVHuFK",15) == 2721261746) strcat(s, "f");
if (crc32("iwFkkBKmZZtINRM",15) == 3961277998) strcat(s, "o");
if (crc32("eqWMjoeRghksWQt",15) == 1493566849) strcat(s, "w");
if (crc32("aFPAm",5) == 1792205584) strcat(s, "r");
if (crc32("fRqAt",5) == 1517124575) strcat(s, "e");
if (crc32("poPhSkCmrR",10) == 1314712278) strcat(s, "t");
if (crc32("JlcxHmPjZftERtm",15) == 263769275) strcat(s, "J");
if (crc32("GvyKbxSkOi",10) == 3144511020) strcat(s, "h");
if (crc32("mYvHotkodvTYFK",14) == 997953317) strcat(s, "o");
if (crc32("RAslY",5) == 705777436) strcat(s, "u");
if (crc32("LZfpwyXfdGapGdu",15) == 3541367657) strcat(s, "g");
if (crc32("GDSnSNKn",8) == 2750944251) strcat(s, "C");
if (crc32("QKWogXGWixrGz",13) == 2804038629) strcat(s, "h");
if (crc32("FGGIxvZyLOOnIC",14) == 3403431448) strcat(s, "x");
if (crc32("fQqqVNwIb",9) == 3317466539) strcat(s, "t");
if (crc32("oWeMNhifKcuOHct",15) == 625215603) strcat(s, "h");
if (crc32("UhoChB",6) == 1621889460) strcat(s, "f");
if (crc32("XsWIscSha",9) == 2918387540) strcat(s, "u");
if (crc32("UcCxVHyv",8) == 1436564943) strcat(s, "l");
if (crc32("VjXYaJhlIf",10) == 496370663) strcat(s, "P");
if (crc32("gICUyfGgKaARUa",14) == 1961862627) strcat(s, "l");
if (crc32("LFplZoudsU",10) == 244108567) strcat(s, "Y");
if (crc32("fyqinBegoZUa",12) == 1247276329) strcat(s, "y");
    return s;
}

char *inexorably_adverbs() {
    char *s = calloc(11);
    if (crc32("XPWMPDcrtA",10) == 2412930182) strcat(s, "P");
if (crc32("CNquuIC",7) == 3654945930) strcat(s, "i");
if (crc32("NqkLvsbuwveYkh",14) == 1842220546) strcat(s, "n");
if (crc32("mWpHvBfxstut",12) == 1758184364) strcat(s, "y");
if (crc32("QIHmUZIVWZRzT",13) == 825909336) strcat(s, "e");
if (crc32("AdIkeRPGzufnc",13) == 2086275996) strcat(s, "x");
if (crc32("FmvdslOS",8) == 3123911679) strcat(s, "l");
if (crc32("fYFcJXFhDqW",11) == 4164216468) strcat(s, "o");
if (crc32("uLXGCHkQoXfI",12) == 1836121681) strcat(s, "u");
if (crc32("mOJIZQ",6) == 147957781) strcat(s, "r");
if (crc32("kwwBEJeY",8) == 780299738) strcat(s, "a");
if (crc32("DaGexMJXa",9) == 900044532) strcat(s, "b");
if (crc32("NHSuiQvT",8) == 2882180829) strcat(s, "l");
if (crc32("HCYDpUiqOb",10) == 1704355342) strcat(s, "J");
if (crc32("XSbhvQIkB",9) == 1746373161) strcat(s, "y");
    return s;
}

char *hereafter_adverbs() {
    char *s = calloc(10);
    if (crc32("NrAoplXv",8) == 1384404790) strcat(s, "M");
if (crc32("LbbzpEGfdppmL",13) == 929238801) strcat(s, "h");
if (crc32("RoCFFEFuJrHpY",13) == 3235852764) strcat(s, "e");
if (crc32("fcUZPwPTGL",10) == 257019941) strcat(s, "G");
if (crc32("PjPzjgycPX",10) == 2403139643) strcat(s, "r");
if (crc32("HSbGsRFl",8) == 3592286031) strcat(s, "e");
if (crc32("CZpWRodsBJTCGy",14) == 3991052199) strcat(s, "a");
if (crc32("shTXnryTma",10) == 4270972774) strcat(s, "f");
if (crc32("cfJlVKVuYUrZkMh",15) == 2504166600) strcat(s, "L");
if (crc32("RUJxHv",6) == 804968529) strcat(s, "t");
if (crc32("CORrYTDRu",9) == 750272349) strcat(s, "N");
if (crc32("ENesIakC",8) == 821366228) strcat(s, "e");
if (crc32("aksLsuZrk",9) == 3244031862) strcat(s, "r");
    return s;
}

char *neologically_adverbs() {
    char *s = calloc(13);
    if (crc32("bVans",5) == 1663509906) strcat(s, "b");
if (crc32("LTDtPzf",7) == 3712694385) strcat(s, "n");
if (crc32("fmvFiGUoa",9) == 492032020) strcat(s, "a");
if (crc32("pfZgGxjSsXFzA",13) == 2877835268) strcat(s, "e");
if (crc32("iHqFnwceY",9) == 4025063973) strcat(s, "o");
if (crc32("oPaIhz",6) == 2555527798) strcat(s, "a");
if (crc32("wIDwzvYW",8) == 127366591) strcat(s, "l");
if (crc32("SezgyY",6) == 3478820213) strcat(s, "o");
if (crc32("BkQCSh",6) == 2205736493) strcat(s, "R");
if (crc32("idxulZeactNEyCP",15) == 1581660033) strcat(s, "g");
if (crc32("SIeie",5) == 2557876547) strcat(s, "i");
if (crc32("zGftaRMPX",9) == 3122045900) strcat(s, "c");
if (crc32("AYrruzmfh",9) == 3223647019) strcat(s, "p");
if (crc32("FkGZqpZygowWaKG",15) == 1874350848) strcat(s, "a");
if (crc32("NNlWTBitwqrFbRj",15) == 2244326444) strcat(s, "R");
if (crc32("fCnXeezSUTnN",12) == 2621940391) strcat(s, "l");
if (crc32("GQgvTWknhR",10) == 877687628) strcat(s, "l");
if (crc32("BIDrVFgfhW",10) == 1647320177) strcat(s, "y");
    return s;
}

char *unthickly_adverbs() {
    char *s = calloc(10);
    if (crc32("oKSHUkSTySKL",12) == 617031052) strcat(s, "u");
if (crc32("eRDzSsqi",8) == 3817725490) strcat(s, "n");
if (crc32("ugynPcafZUim",12) == 3311248378) strcat(s, "K");
if (crc32("bdipGlnGB",9) == 733070476) strcat(s, "t");
if (crc32("eANvPRpJyqO",11) == 1741038110) strcat(s, "k");
if (crc32("Fjgia",5) == 2249724182) strcat(s, "h");
if (crc32("oLcoJqnslrLQ",12) == 4192524322) strcat(s, "A");
if (crc32("bkLufTpkCfcQ",12) == 1096970866) strcat(s, "i");
if (crc32("nsrKOfBw",8) == 13478946) strcat(s, "f");
if (crc32("sxYefsYPALJefJJ",15) == 1568281947) strcat(s, "c");
if (crc32("LhtgwuDEpENkL",13) == 2462959747) strcat(s, "k");
if (crc32("vdcALzeruc",10) == 3016532147) strcat(s, "k");
if (crc32("FKadmF",6) == 1302230571) strcat(s, "v");
if (crc32("bGiupmYLJO",10) == 3027232726) strcat(s, "l");
if (crc32("NOkhatZLcg",10) == 3636912337) strcat(s, "y");
    return s;
}

char *unturgidly_adverbs() {
    char *s = calloc(11);
    if (crc32("AmbKaQXfqOEpHg",14) == 1240199902) strcat(s, "u");
if (crc32("EDALhzAPVR",10) == 263095644) strcat(s, "n");
if (crc32("CJTpd",5) == 393350520) strcat(s, "N");
if (crc32("kHEUI",5) == 3372080797) strcat(s, "t");
if (crc32("hehEUgDvPwU",11) == 606598126) strcat(s, "c");
if (crc32("cdVVIeGMLjhd",12) == 1598923499) strcat(s, "u");
if (crc32("InLQzZFPeBgXfI",14) == 249279246) strcat(s, "r");
if (crc32("kHNjj",5) == 1041328690) strcat(s, "g");
if (crc32("djrWqfcq",8) == 3721902604) strcat(s, "V");
if (crc32("jqlfSmGEMcE",11) == 3167623786) strcat(s, "i");
if (crc32("kERCGGfeP",9) == 3077560923) strcat(s, "d");
if (crc32("aiLMMDV",7) == 91525958) strcat(s, "l");
if (crc32("GdRItq",6) == 3174287044) strcat(s, "y");
    return s;
}

char *unbrazenly_adverbs() {
    char *s = calloc(11);
    if (crc32("CGdxGFaKhFg",11) == 2779393521) strcat(s, "u");
if (crc32("SmcABB",6) == 1479334439) strcat(s, "n");
if (crc32("XBtmYutq",8) == 1225439402) strcat(s, "b");
if (crc32("qQptqbH",7) == 507763643) strcat(s, "z");
if (crc32("UfKGbNmMrv",10) == 3507224145) strcat(s, "r");
if (crc32("ECcLZtwpEhgpbHp",15) == 1498001475) strcat(s, "a");
if (crc32("JVfVcQrtYWkfbM",14) == 1274827617) strcat(s, "z");
if (crc32("CEfRBhhyK",9) == 1289560892) strcat(s, "e");
if (crc32("nraEYGi",7) == 3121827346) strcat(s, "V");
if (crc32("XNvpwSu",7) == 1173246896) strcat(s, "n");
if (crc32("jHZTKpPEHD",10) == 3324976776) strcat(s, "X");
if (crc32("MEtExPtXyHRKYF",14) == 88508258) strcat(s, "l");
if (crc32("uOUGabnVp",9) == 81834496) strcat(s, "y");
    return s;
}

char *unpersuasively_adverbs() {
    char *s = calloc(15);
    if (crc32("cVOeXhodck",10) == 9826033) strcat(s, "u");
if (crc32("kXhNHYCbZw",10) == 1331290733) strcat(s, "r");
if (crc32("NnCrfQyjHtAvo",13) == 200187259) strcat(s, "n");
if (crc32("kGattG",6) == 4188674827) strcat(s, "d");
if (crc32("KBmoGnGe",8) == 2871218977) strcat(s, "p");
if (crc32("TLnlIsqCvG",10) == 3626806110) strcat(s, "L");
if (crc32("dwrvKLfmOxDlS",13) == 2325604845) strcat(s, "e");
if (crc32("EBOHNVwXxXO",11) == 3905915579) strcat(s, "r");
if (crc32("KZDuuRtDzLTVsag",15) == 1446264169) strcat(s, "t");
if (crc32("tyPnZtGZYpv",11) == 877848385) strcat(s, "s");
if (crc32("PUBVrT",6) == 1704764866) strcat(s, "u");
if (crc32("vnHRLr",6) == 2581863494) strcat(s, "a");
if (crc32("gzeuUclCkowaRU",14) == 142533172) strcat(s, "u");
if (crc32("BTJNblfyTPArwQ",14) == 1103587362) strcat(s, "s");
if (crc32("lqDqaVHp",8) == 1977247641) strcat(s, "A");
if (crc32("SkeYUrL",7) == 44142924) strcat(s, "i");
if (crc32("EQuazVXUQllLl",13) == 1194165700) strcat(s, "i");
if (crc32("KlHwKnwaep",10) == 1491023107) strcat(s, "v");
if (crc32("WeuvJgoA",8) == 3842714754) strcat(s, "r");
if (crc32("nvtVsdyhGeZClgS",15) == 2558405577) strcat(s, "e");
if (crc32("BgkHaGPJC",9) == 1125586287) strcat(s, "K");
if (crc32("EwrmTGj",7) == 2932667200) strcat(s, "l");
if (crc32("WDjOZDtJQpEnNnQ",15) == 3167327330) strcat(s, "u");
if (crc32("OVYAnfnqMRe",11) == 2622094892) strcat(s, "y");
    return s;
}

char *ichnographically_adverbs() {
    char *s = calloc(17);
    if (crc32("WwMPeoI",7) == 3544501886) strcat(s, "V");
if (crc32("INBpBQuaDlOgNb",14) == 3874547963) strcat(s, "i");
if (crc32("fFBMvBtED",9) == 2920817044) strcat(s, "c");
if (crc32("fVVXxiSJiCsanc",14) == 479075933) strcat(s, "h");
if (crc32("qhfcs",5) == 1527987405) strcat(s, "I");
if (crc32("wmDeoOdjz",9) == 1766920287) strcat(s, "n");
if (crc32("CBbWK",5) == 3289112815) strcat(s, "q");
if (crc32("iwYfSmHia",9) == 2655009894) strcat(s, "o");
if (crc32("HdnVjL",6) == 3503042254) strcat(s, "f");
if (crc32("hwqqujltJL",10) == 1074010594) strcat(s, "g");
if (crc32("jODBdZVxpaguw",13) == 1276495660) strcat(s, "r");
if (crc32("bUcqgHNcTdz",11) == 2158496564) strcat(s, "a");
if (crc32("mJtXA",5) == 1936235118) strcat(s, "p");
if (crc32("DBcVZFUhgeSvH",13) == 1602962074) strcat(s, "b");
if (crc32("IrZBq",5) == 3599852153) strcat(s, "h");
if (crc32("ZmGYIsinVis",11) == 602490124) strcat(s, "i");
if (crc32("loKaALhxpYASNjt",15) == 554736811) strcat(s, "c");
if (crc32("JZSoOHXVgEnVvhV",15) == 1429438068) strcat(s, "a");
if (crc32("svIEOWrPKPCfJv",14) == 863470404) strcat(s, "s");
if (crc32("lajBcdVAllimOxg",15) == 4257457342) strcat(s, "l");
if (crc32("NzoIfK",6) == 4183111666) strcat(s, "l");
if (crc32("psdLBqROsG",10) == 2074948216) strcat(s, "y");
    return s;
}

char *fittingly_adverbs() {
    char *s = calloc(10);
    if (crc32("ZtVVhiKkjg",10) == 124378818) strcat(s, "f");
if (crc32("auAfECkLrsSh",12) == 3331132755) strcat(s, "J");
if (crc32("lIcoMDi",7) == 2630026733) strcat(s, "i");
if (crc32("mPHjXkxI",8) == 46606643) strcat(s, "B");
if (crc32("ZbkDA",5) == 4108501049) strcat(s, "t");
if (crc32("gRxqVeshvHHTIS",14) == 472133597) strcat(s, "m");
if (crc32("cjHqla",6) == 340702315) strcat(s, "t");
if (crc32("HvLLWFHvIyYrx",13) == 1265196074) strcat(s, "i");
if (crc32("LjOuubB",7) == 2898915419) strcat(s, "n");
if (crc32("anEFxWfOgJsyLy",14) == 2232138974) strcat(s, "v");
if (crc32("tIguPgqGfuUK",12) == 599534304) strcat(s, "g");
if (crc32("JTMWKqyLW",9) == 2145052171) strcat(s, "i");
if (crc32("biRQM",5) == 2802565215) strcat(s, "l");
if (crc32("VRhWJmpV",8) == 891563591) strcat(s, "y");
    return s;
}

char *simoniacally_adverbs() {
    char *s = calloc(13);
    if (crc32("KyAzdMTSlV",10) == 640460155) strcat(s, "s");
if (crc32("uFucddgXsCkaeK",14) == 168041869) strcat(s, "i");
if (crc32("YRUbCCxhWFP",11) == 272254273) strcat(s, "m");
if (crc32("cQonU",5) == 3371564296) strcat(s, "o");
if (crc32("sODbIuYHalrD",12) == 3977914008) strcat(s, "n");
if (crc32("LDeUkbAoRtYVkie",15) == 3824199378) strcat(s, "i");
if (crc32("YdPTHRgaFht",11) == 638255528) strcat(s, "E");
if (crc32("dElHbnuD",8) == 3231327943) strcat(s, "a");
if (crc32("jbfaYKlQV",9) == 3413419072) strcat(s, "s");
if (crc32("aUmWTF",6) == 1666078457) strcat(s, "c");
if (crc32("ObYytzRfBOet",12) == 445928073) strcat(s, "a");
if (crc32("FMVlRhxToTAZcna",15) == 2513163323) strcat(s, "l");
if (crc32("WDvIt",5) == 4053041682) strcat(s, "H");
if (crc32("OETEoMf",7) == 3010394381) strcat(s, "l");
if (crc32("IrVoZHSiwpoCN",13) == 3036740402) strcat(s, "E");
if (crc32("NPaDRgWt",8) == 2587205709) strcat(s, "y");
    return s;
}

char *familiarisingly_adverbs() {
    char *s = calloc(16);
    if (crc32("QnOmltW",7) == 3327064560) strcat(s, "f");
if (crc32("yvltIDStgyS",11) == 1265091551) strcat(s, "C");
if (crc32("lBpKYUBCM",9) == 3622216549) strcat(s, "a");
if (crc32("rGBDJZrmoELvK",13) == 1616088655) strcat(s, "H");
if (crc32("tQLOYUxSJqzgqbm",15) == 1279686775) strcat(s, "m");
if (crc32("dgZDgLsqKEEkI",13) == 3083582350) strcat(s, "i");
if (crc32("qUQAWfZlRzN",11) == 2601010447) strcat(s, "l");
if (crc32("qISOdUHyCm",10) == 2529843721) strcat(s, "N");
if (crc32("iYqSHc",6) == 4200132724) strcat(s, "i");
if (crc32("dHNTizpns",9) == 1760952992) strcat(s, "a");
if (crc32("MGjstrLbBSz",11) == 3776346557) strcat(s, "r");
if (crc32("XDRMmjpdA",9) == 3831155093) strcat(s, "i");
if (crc32("GolPU",5) == 2948816506) strcat(s, "s");
if (crc32("ZDbiOBLanW",10) == 2694056112) strcat(s, "B");
if (crc32("TOUFMuhIPQlumN",14) == 2267640752) strcat(s, "i");
if (crc32("LnKtYcd",7) == 2149939408) strcat(s, "n");
if (crc32("dpAtyE",6) == 3760937789) strcat(s, "z");
if (crc32("ukIHqUy",7) == 4050319215) strcat(s, "g");
if (crc32("iaasIfHr",8) == 4050676443) strcat(s, "O");
if (crc32("jrADybUxpktBuGp",15) == 3011724594) strcat(s, "l");
if (crc32("QNjJthrsuGCB",12) == 3609568105) strcat(s, "y");
    return s;
}

char *deliciously_adverbs() {
    char *s = calloc(12);
    if (crc32("xZPzrjJru",9) == 1998221156) strcat(s, "d");
if (crc32("TqXsvNbmiDTFJ",13) == 3343289645) strcat(s, "r");
if (crc32("vhVCSTFkRryuI",13) == 2221652056) strcat(s, "e");
if (crc32("aAoZmwkrRf",10) == 4072538958) strcat(s, "l");
if (crc32("KETADbAHsLmCi",13) == 2494400896) strcat(s, "i");
if (crc32("URtcsFfgINtKpRm",15) == 3286459643) strcat(s, "c");
if (crc32("WERCXXI",7) == 3012703970) strcat(s, "M");
if (crc32("YnJfqVpYxw",10) == 887717621) strcat(s, "i");
if (crc32("QVrQolw",7) == 1663766247) strcat(s, "Y");
if (crc32("NOKqZ",5) == 600034082) strcat(s, "o");
if (crc32("rDueILo",7) == 3115956996) strcat(s, "m");
if (crc32("zPnqEvVvi",9) == 908605960) strcat(s, "u");
if (crc32("pbfUN",5) == 3019024665) strcat(s, "a");
if (crc32("YuUwBYMTvYPdu",13) == 2783293355) strcat(s, "s");
if (crc32("VqZnFWqhvAJRxif",15) == 225590050) strcat(s, "l");
if (crc32("GmMpdEcAOBXz",12) == 3828591299) strcat(s, "y");
    return s;
}

char *gloweringly_adverbs() {
    char *s = calloc(12);
    if (crc32("NnuelPXo",8) == 3896327122) strcat(s, "I");
if (crc32("PocuOjmxgIKhiW",14) == 921490830) strcat(s, "g");
if (crc32("TBPUTZtWSnEFON",14) == 2596198103) strcat(s, "X");
if (crc32("Ypopcd",6) == 1344932467) strcat(s, "l");
if (crc32("amZRaSTU",8) == 1416812791) strcat(s, "o");
if (crc32("vXads",5) == 1065478669) strcat(s, "w");
if (crc32("RRmhVGrPGmQbJ",13) == 903408582) strcat(s, "e");
if (crc32("VAWLCiuhlg",10) == 1601444727) strcat(s, "r");
if (crc32("WtrgvjpvGFPxEI",14) == 2673081151) strcat(s, "i");
if (crc32("YLYMofelYmG",11) == 1483481433) strcat(s, "n");
if (crc32("reLkZbk",7) == 2428624703) strcat(s, "n");
if (crc32("RMwlcE",6) == 2946806717) strcat(s, "g");
if (crc32("bbnKCvBUzWVZ",12) == 3020571438) strcat(s, "l");
if (crc32("LtGbsSnPZIpOH",13) == 793119463) strcat(s, "y");
    return s;
}

char *unvaluably_adverbs() {
    char *s = calloc(11);
    if (crc32("niCnox",6) == 1615676714) strcat(s, "u");
if (crc32("DozyrdnboSzhF",13) == 2201067076) strcat(s, "n");
if (crc32("mvPglJzjweTiXPi",15) == 3486466765) strcat(s, "v");
if (crc32("wBLodgYS",8) == 3993523921) strcat(s, "i");
if (crc32("mLEavLdvq",9) == 1449471250) strcat(s, "a");
if (crc32("FNlocAEhWuOzVi",14) == 2533591883) strcat(s, "F");
if (crc32("wzeHhqfov",9) == 407253807) strcat(s, "l");
if (crc32("gYTrPkguhzfge",13) == 4214141385) strcat(s, "u");
if (crc32("keWCYqXxk",9) == 1982026902) strcat(s, "a");
if (crc32("ZmuXKGFNGzhi",12) == 3796184523) strcat(s, "b");
if (crc32("SZcgqmnIIQ",10) == 1727617837) strcat(s, "a");
if (crc32("BZeDETTbJqkVG",13) == 3840874527) strcat(s, "l");
if (crc32("ElnPTzR",7) == 1251855100) strcat(s, "e");
if (crc32("KxBnRxSwh",9) == 2242153281) strcat(s, "y");
    return s;
}

char *interjectorily_adverbs() {
    char *s = calloc(15);
    if (crc32("nlYfTarSPoKvUAh",15) == 2807169624) strcat(s, "t");
if (crc32("hAWpB",5) == 2463536566) strcat(s, "i");
if (crc32("nKzGv",5) == 4077715776) strcat(s, "n");
if (crc32("eoTPNAbHjRKE",12) == 401147246) strcat(s, "t");
if (crc32("IkmaJXyISNEu",12) == 362766820) strcat(s, "e");
if (crc32("wgXIbbwiePxCA",13) == 3359028406) strcat(s, "r");
if (crc32("ZhjIgkpnwL",10) == 4157475856) strcat(s, "j");
if (crc32("HgvuOzW",7) == 2383610261) strcat(s, "e");
if (crc32("eYuRr",5) == 1520491878) strcat(s, "V");
if (crc32("LwymHUf",7) == 687530350) strcat(s, "c");
if (crc32("NoXIWPJZCtfCVYx",15) == 2492400169) strcat(s, "t");
if (crc32("yRJCemlHARxpAB",14) == 1796081951) strcat(s, "d");
if (crc32("PIGcqnMA",8) == 4171123409) strcat(s, "o");
if (crc32("QajPPmWKVLdq",12) == 3378251804) strcat(s, "r");
if (crc32("jSmcWNNY",8) == 3364436203) strcat(s, "u");
if (crc32("kYtLQ",5) == 2375897230) strcat(s, "i");
if (crc32("WPXNDFUVQy",10) == 84328426) strcat(s, "l");
if (crc32("qloepzuF",8) == 3274317903) strcat(s, "N");
if (crc32("apEIgeGdRAJL",12) == 609052176) strcat(s, "y");
    return s;
}

char *unregretfully_adverbs() {
    char *s = calloc(14);
    if (crc32("xdzvNLfRNhA",11) == 2356043791) strcat(s, "C");
if (crc32("oypOJiSLCoJA",12) == 588490091) strcat(s, "u");
if (crc32("DHHJLeaZhzt",11) == 1113615857) strcat(s, "n");
if (crc32("KExkfdJYV",9) == 3096163021) strcat(s, "b");
if (crc32("ARAQTPZfToqEp",13) == 4215348769) strcat(s, "r");
if (crc32("ODMAWCE",7) == 2352783576) strcat(s, "e");
if (crc32("jIkfBFgBAh",10) == 3630074645) strcat(s, "g");
if (crc32("rGWvmAtjhb",10) == 98744648) strcat(s, "r");
if (crc32("doalLdAfSWT",11) == 1874317020) strcat(s, "y");
if (crc32("rAaWLYx",7) == 2620442084) strcat(s, "e");
if (crc32("MBcrJA",6) == 1092432204) strcat(s, "K");
if (crc32("lyRFP",5) == 782746094) strcat(s, "t");
if (crc32("FyLAcxmdosSS",12) == 1085359688) strcat(s, "p");
if (crc32("aHCvC",5) == 3636208881) strcat(s, "f");
if (crc32("ENcFiXswWt",10) == 1875016636) strcat(s, "d");
if (crc32("sZmMld",6) == 2085533953) strcat(s, "u");
if (crc32("NChsijwvndNi",12) == 2824322669) strcat(s, "l");
if (crc32("oKcgtAHvUMvW",12) == 1833876357) strcat(s, "j");
if (crc32("HkuEXaBrkWAdl",13) == 2325504166) strcat(s, "l");
if (crc32("ghHTaEfHl",9) == 1653900712) strcat(s, "F");
if (crc32("owzLZGCMNo",10) == 3964490504) strcat(s, "y");
    return s;
}

char *calmly_adverbs() {
    char *s = calloc(7);
    if (crc32("sAFhVvFB",8) == 2642434174) strcat(s, "P");
if (crc32("NGnqiHamScFO",12) == 3156329346) strcat(s, "c");
if (crc32("yOVMNYQWrHchNV",14) == 1297470842) strcat(s, "a");
if (crc32("jeHAkwl",7) == 4125353075) strcat(s, "F");
if (crc32("QVPCThluryQ",11) == 889672941) strcat(s, "l");
if (crc32("GQQOIjKzL",9) == 3224375875) strcat(s, "e");
if (crc32("jpOkhUYy",8) == 248009190) strcat(s, "m");
if (crc32("ATgJWBTV",8) == 690400656) strcat(s, "l");
if (crc32("vDsRGbx",7) == 1873026825) strcat(s, "Y");
if (crc32("gAxuoVAxExSCmso",15) == 3514734129) strcat(s, "y");
    return s;
}

char *quibblingly_adverbs() {
    char *s = calloc(12);
    if (crc32("lgnZWc",6) == 2121602552) strcat(s, "q");
if (crc32("qteJWmkdyax",11) == 1954946673) strcat(s, "u");
if (crc32("xVYIfhHa",8) == 2121026626) strcat(s, "i");
if (crc32("wEyqKnX",7) == 779489933) strcat(s, "b");
if (crc32("jfyDda",6) == 3947233545) strcat(s, "M");
if (crc32("NSkroIxWxAjpi",13) == 1303141542) strcat(s, "b");
if (crc32("YtmkIVJoCbO",11) == 927140751) strcat(s, "m");
if (crc32("KwuiwjMZcFzl",12) == 2314976168) strcat(s, "l");
if (crc32("rrGpaKDpbyOaYr",14) == 2992753658) strcat(s, "q");
if (crc32("gcuBJ",5) == 3269405471) strcat(s, "i");
if (crc32("WfJrWunhmRjFmFi",15) == 1096151282) strcat(s, "O");
if (crc32("jiYIRlqsNKpdZAo",15) == 3033261958) strcat(s, "n");
if (crc32("HxZdrXhLF",9) == 27884302) strcat(s, "f");
if (crc32("SvoGPsnl",8) == 8537466) strcat(s, "g");
if (crc32("fyKSvYAnDwRDt",13) == 1363655303) strcat(s, "l");
if (crc32("lPpDqK",6) == 1029829734) strcat(s, "y");
    return s;
}

char *subexternally_adverbs() {
    char *s = calloc(14);
    if (crc32("sLoLgTqlscA",11) == 14278082) strcat(s, "s");
if (crc32("OxYVnqJCg",9) == 1946417965) strcat(s, "u");
if (crc32("mXLQI",5) == 2082046505) strcat(s, "b");
if (crc32("UREMruD",7) == 539382607) strcat(s, "e");
if (crc32("Qaxanmfsz",9) == 3321251930) strcat(s, "c");
if (crc32("TlwZn",5) == 3248574969) strcat(s, "x");
if (crc32("bUdTZwEmBNChH",13) == 2286349707) strcat(s, "t");
if (crc32("GnIeLOBZOf",10) == 3682121376) strcat(s, "a");
if (crc32("yTlUtRVuVn",10) == 404109966) strcat(s, "e");
if (crc32("qUQQFbATfLF",11) == 998343582) strcat(s, "r");
if (crc32("qZczTuyJJmGl",12) == 532574886) strcat(s, "n");
if (crc32("rnCJC",5) == 974614457) strcat(s, "i");
if (crc32("yoqkWIcVfaYL",12) == 850362799) strcat(s, "a");
if (crc32("KHggvFZTbvhv",12) == 2783271517) strcat(s, "l");
if (crc32("VZsZfRyeEcbNcLU",15) == 2470686043) strcat(s, "l");
if (crc32("kZzLnilO",8) == 3949479591) strcat(s, "y");
    return s;
}

char *semireflexively_adverbs() {
    char *s = calloc(16);
    if (crc32("WNWREZo",7) == 1316172181) strcat(s, "s");
if (crc32("xAbVB",5) == 323528299) strcat(s, "e");
if (crc32("YYGhpATYDDOamg",14) == 2870910389) strcat(s, "r");
if (crc32("vFfaaSt",7) == 3520518960) strcat(s, "m");
if (crc32("GHuSvNIRsoBJyY",14) == 204398911) strcat(s, "z");
if (crc32("dipURIgmVcwxyaX",15) == 2077087284) strcat(s, "i");
if (crc32("toPqsFtrPxEkG",13) == 3025166063) strcat(s, "D");
if (crc32("fivGKbxw",8) == 1960952565) strcat(s, "r");
if (crc32("OgdnIuP",7) == 3422412473) strcat(s, "e");
if (crc32("gpRtkXEDJ",9) == 3315297401) strcat(s, "E");
if (crc32("pTSMPnbyKFR",11) == 1736087934) strcat(s, "f");
if (crc32("wbiPDeNOvjrkg",13) == 1341870804) strcat(s, "l");
if (crc32("EFPBpb",6) == 426417979) strcat(s, "a");
if (crc32("hZBnUqgIyCg",11) == 899438180) strcat(s, "e");
if (crc32("gmuPaQDISgevhKm",15) == 2722879154) strcat(s, "x");
if (crc32("jhrJzNvZNKSsdH",14) == 3514731372) strcat(s, "i");
if (crc32("IfDXxEBnnbjf",12) == 2530752847) strcat(s, "v");
if (crc32("HiLYlKJKaRPSyWy",15) == 2134897613) strcat(s, "e");
if (crc32("QoXTP",5) == 1996963999) strcat(s, "l");
if (crc32("bENpZPh",7) == 1562323894) strcat(s, "K");
if (crc32("uItGHCGQIB",10) == 115416320) strcat(s, "y");
    return s;
}

char *grimily_adverbs() {
    char *s = calloc(8);
    if (crc32("PjeMeCVKsyMSJ",13) == 1352022870) strcat(s, "f");
if (crc32("fdmVjnHsmDcOOt",14) == 1396784258) strcat(s, "g");
if (crc32("qPcNpi",6) == 3355496049) strcat(s, "Y");
if (crc32("JnPdpWTEBofVhVW",15) == 2040398659) strcat(s, "r");
if (crc32("eKuKEp",6) == 2575613969) strcat(s, "J");
if (crc32("CduNsEE",7) == 3961283889) strcat(s, "i");
if (crc32("yCSLPHTupd",10) == 1098114888) strcat(s, "m");
if (crc32("gUkTEZOVhxP",11) == 2812506975) strcat(s, "V");
if (crc32("duLGmduiQLQnHvD",15) == 1906443137) strcat(s, "i");
if (crc32("UJkYaveaq",9) == 996097192) strcat(s, "l");
if (crc32("fMdPRSjYYLHa",12) == 2918050258) strcat(s, "i");
if (crc32("VVuvOGHtuF",10) == 3920771528) strcat(s, "y");
    return s;
}

char *supercynically_adverbs() {
    char *s = calloc(15);
    if (crc32("oTDZywHZkvFiRc",14) == 1753824976) strcat(s, "r");
if (crc32("UybggbNOtibTrJ",14) == 1208346854) strcat(s, "s");
if (crc32("dlavQK",6) == 4012705322) strcat(s, "u");
if (crc32("JBqbgOmrQTdyTFa",15) == 440864338) strcat(s, "p");
if (crc32("foXBnacuIMjNR",13) == 1485164000) strcat(s, "p");
if (crc32("vgGGOiUyKE",10) == 642840138) strcat(s, "x");
if (crc32("wZlkEKyXvRhV",12) == 2844063178) strcat(s, "e");
if (crc32("AgYXC",5) == 4192961561) strcat(s, "e");
if (crc32("UJeDMRI",7) == 4163493698) strcat(s, "r");
if (crc32("FsuYJRhBjy",10) == 3357026916) strcat(s, "h");
if (crc32("RMjgJ",5) == 343601230) strcat(s, "c");
if (crc32("LUJudndRXy",10) == 2945283169) strcat(s, "Q");
if (crc32("uIejxysjNww",11) == 484114422) strcat(s, "y");
if (crc32("NUvfgFWO",8) == 2816044381) strcat(s, "h");
if (crc32("rqhLhNUIDxI",11) == 1230655778) strcat(s, "n");
if (crc32("tcprAt",6) == 2107847722) strcat(s, "i");
if (crc32("TcJZyTZz",8) == 970761302) strcat(s, "r");
if (crc32("EHgzNUKImPLqsc",14) == 1989925932) strcat(s, "c");
if (crc32("LznNcFwIBeigqqK",15) == 2384922707) strcat(s, "a");
if (crc32("zcXYjGPyQ",9) == 1683264719) strcat(s, "G");
if (crc32("cLQPYankR",9) == 2202389979) strcat(s, "l");
if (crc32("koExPT",6) == 2728549307) strcat(s, "a");
if (crc32("zYIdzLa",7) == 541978377) strcat(s, "l");
if (crc32("TvprylmeDPEBu",13) == 2596101541) strcat(s, "y");
    return s;
}

char *unostensively_adverbs() {
    char *s = calloc(14);
    if (crc32("XaCCZdYptRtil",13) == 337218446) strcat(s, "M");
if (crc32("eafVSkmsZWGfA",13) == 1634595035) strcat(s, "u");
if (crc32("lZcVsOyRqcaIqc",14) == 2418250470) strcat(s, "n");
if (crc32("NKStjPvC",8) == 937879022) strcat(s, "o");
if (crc32("mVKcNf",6) == 2119470063) strcat(s, "s");
if (crc32("upvRIXjJOG",10) == 1447200591) strcat(s, "K");
if (crc32("cqygohtzhD",10) == 4072851243) strcat(s, "t");
if (crc32("CUMsdAuGO",9) == 4039212213) strcat(s, "e");
if (crc32("umuJpoiRGO",10) == 452168513) strcat(s, "p");
if (crc32("GJSnlQgMSWix",12) == 546700146) strcat(s, "n");
if (crc32("bBHcQOCTnOZrNW",14) == 3674147578) strcat(s, "y");
if (crc32("nrPyrwq",7) == 1042445940) strcat(s, "s");
if (crc32("BAXhKLooUZnozAp",15) == 3790365946) strcat(s, "f");
if (crc32("JkCqGlhByPAqMsk",15) == 3684640881) strcat(s, "i");
if (crc32("rcmVLpwJmsZV",12) == 2488949969) strcat(s, "v");
if (crc32("nHutB",5) == 1750064499) strcat(s, "K");
if (crc32("HqinamQkKyyDlGE",15) == 3271149737) strcat(s, "e");
if (crc32("PXKqfUEHUooymI",14) == 2312531614) strcat(s, "l");
if (crc32("xAjxDnzmIKgzhU",14) == 1960157888) strcat(s, "y");
    return s;
}

char *nonpractically_adverbs() {
    char *s = calloc(15);
    if (crc32("MmtOJXz",7) == 2109934693) strcat(s, "p");
if (crc32("GbIKDCqTysEeqH",14) == 977762908) strcat(s, "n");
if (crc32("ecsBPrDnqxC",11) == 4269320465) strcat(s, "N");
if (crc32("FxYsbFxdFXyTl",13) == 3886809044) strcat(s, "o");
if (crc32("nKkHlXgRTUEk",12) == 3132653337) strcat(s, "n");
if (crc32("mtwdwADQ",8) == 2917353914) strcat(s, "Q");
if (crc32("yZJqPGYeJIcyJ",13) == 2691816790) strcat(s, "p");
if (crc32("sEzJpiUCYztZm",13) == 3818342484) strcat(s, "r");
if (crc32("yEHOqctQKuLzrQ",14) == 3959355795) strcat(s, "B");
if (crc32("phODKvr",7) == 3772198609) strcat(s, "a");
if (crc32("aKwsVhHjDSO",11) == 2799715551) strcat(s, "a");
if (crc32("URAAwEqoSFK",11) == 187431146) strcat(s, "c");
if (crc32("uVTeDGlxb",9) == 3153264876) strcat(s, "e");
if (crc32("RVtzQfYxb",9) == 2809394577) strcat(s, "t");
if (crc32("XEceuzomFgDkfki",15) == 2071470737) strcat(s, "i");
if (crc32("TOoWlzOcHkkRPs",14) == 4247666579) strcat(s, "U");
if (crc32("IuoRuXv",7) == 4098424317) strcat(s, "c");
if (crc32("nwPXtxhrlbdGE",13) == 1849360350) strcat(s, "a");
if (crc32("BHbazkQihnVzTOD",15) == 1848803173) strcat(s, "w");
if (crc32("iSTidBGdhHdi",12) == 594767773) strcat(s, "l");
if (crc32("tthDXambTVad",12) == 3050432961) strcat(s, "l");
if (crc32("vevzhGbsoI",10) == 4278563060) strcat(s, "B");
if (crc32("YAuNA",5) == 3985824969) strcat(s, "y");
    return s;
}

char *uninvincibly_adverbs() {
    char *s = calloc(13);
    if (crc32("YOxrwtMR",8) == 2630440750) strcat(s, "u");
if (crc32("zBjSWM",6) == 4121050118) strcat(s, "v");
if (crc32("XLiUdNnVm",9) == 2567851918) strcat(s, "n");
if (crc32("SKTXiKrXSM",10) == 377651556) strcat(s, "i");
if (crc32("tqenv",5) == 2724779015) strcat(s, "j");
if (crc32("rrggK",5) == 36476024) strcat(s, "n");
if (crc32("WkmlpDwos",9) == 2141151334) strcat(s, "v");
if (crc32("kHbtohfZOI",10) == 1917406548) strcat(s, "i");
if (crc32("rcQzPliooqGkdK",14) == 3008082393) strcat(s, "V");
if (crc32("KxjNxrKKbcPhycj",15) == 2233916689) strcat(s, "n");
if (crc32("vkzWEcTDRnTwCs",14) == 2840339096) strcat(s, "c");
if (crc32("jkfrtBolrgI",11) == 1931190534) strcat(s, "i");
if (crc32("UukSEaFE",8) == 2659107649) strcat(s, "b");
if (crc32("OJXkJKIrsTZCY",13) == 3083814848) strcat(s, "M");
if (crc32("xwegvTMUcuNe",12) == 1465736444) strcat(s, "l");
if (crc32("rjQNxs",6) == 3051104664) strcat(s, "L");
if (crc32("oSUBmquSXf",10) == 3533428039) strcat(s, "y");
    return s;
}

char *suppositively_adverbs() {
    char *s = calloc(14);
    if (crc32("JVgQsowjNXIpe",13) == 2957653179) strcat(s, "s");
if (crc32("bUXRYEeOFjwutzD",15) == 95550950) strcat(s, "m");
if (crc32("cTCcIzCmRfTP",12) == 4066112369) strcat(s, "u");
if (crc32("OjdCoDhNTxx",11) == 3625329634) strcat(s, "x");
if (crc32("ucBEkGqivmDRgGU",15) == 1582180792) strcat(s, "p");
if (crc32("fYwMZoOSbFEeiwO",15) == 4178130540) strcat(s, "A");
if (crc32("ZTSDuWVJWTXurD",14) == 1501702125) strcat(s, "p");
if (crc32("CCeIZqVEfXWbKmh",15) == 2422667809) strcat(s, "o");
if (crc32("HXnXlLEzjaFOcAz",15) == 2495941282) strcat(s, "s");
if (crc32("iniwoXlDLD",10) == 2727671284) strcat(s, "o");
if (crc32("VqiUJqTSiOcENkG",15) == 2128086436) strcat(s, "i");
if (crc32("gYWomxrnZcFjj",13) == 1459555950) strcat(s, "L");
if (crc32("AbOFLPsqC",9) == 254049459) strcat(s, "t");
if (crc32("FNBLdpnK",8) == 2278314055) strcat(s, "H");
if (crc32("PUMfSnTreBd",11) == 2679599545) strcat(s, "i");
if (crc32("NCHHlSTD",8) == 389168720) strcat(s, "v");
if (crc32("xejmCDZ",7) == 1612314821) strcat(s, "i");
if (crc32("LfQRdtjxmWx",11) == 1617839405) strcat(s, "e");
if (crc32("HFXIeDYF",8) == 2182272581) strcat(s, "l");
if (crc32("ibVhhxDjoRlPnCz",15) == 1968869140) strcat(s, "m");
if (crc32("jyfGaG",6) == 329888366) strcat(s, "y");
    return s;
}

char *monetarily_adverbs() {
    char *s = calloc(11);
    if (crc32("XhHBTcULyWaTfc",14) == 3405977752) strcat(s, "m");
if (crc32("XdCnQaRK",8) == 2884537549) strcat(s, "i");
if (crc32("VevnHtuJcrFJfeS",15) == 1088457959) strcat(s, "o");
if (crc32("gtqQFPD",7) == 1271950037) strcat(s, "n");
if (crc32("YuWfmX",6) == 3405356997) strcat(s, "F");
if (crc32("ViyZCaOJfDKRkG",14) == 3036124638) strcat(s, "e");
if (crc32("FeujMGx",7) == 1297429069) strcat(s, "G");
if (crc32("vJxJr",5) == 2858865756) strcat(s, "t");
if (crc32("fIgFiBMtzP",10) == 3326282591) strcat(s, "E");
if (crc32("yUiGTyqBlNV",11) == 3244949751) strcat(s, "a");
if (crc32("jiJpRxsDtWZnFDr",15) == 750477250) strcat(s, "r");
if (crc32("ThmHDEU",7) == 200285426) strcat(s, "D");
if (crc32("nuvSbRQcXM",10) == 2857530407) strcat(s, "i");
if (crc32("YXwAVdc",7) == 515716676) strcat(s, "l");
if (crc32("UohJEFYuELEC",12) == 172189914) strcat(s, "d");
if (crc32("DkffP",5) == 2480952273) strcat(s, "y");
    return s;
}

char *openeyedly_adverbs() {
    char *s = calloc(11);
    if (crc32("QlmHBniUMPTfeQ",14) == 3538957555) strcat(s, "Z");
if (crc32("JapKLlHdzJXIjLY",15) == 3037591132) strcat(s, "o");
if (crc32("FLwTmDCsl",9) == 3628486736) strcat(s, "B");
if (crc32("LnKYPmVPoZlVE",13) == 943173720) strcat(s, "p");
if (crc32("SUSCv",5) == 1233839536) strcat(s, "e");
if (crc32("lVYBB",5) == 4187687118) strcat(s, "K");
if (crc32("zKVrBwjcorjzY",13) == 62746138) strcat(s, "n");
if (crc32("wjzKfJMg",8) == 2628417230) strcat(s, "e");
if (crc32("wQGpcLq",7) == 3284335254) strcat(s, "y");
if (crc32("oQrdhhUblnTw",12) == 3337668832) strcat(s, "v");
if (crc32("OmaIxxyRoQ",10) == 1158735175) strcat(s, "e");
if (crc32("oychEapNdKum",12) == 3586719142) strcat(s, "h");
if (crc32("qzEOfxwsQTSgnh",14) == 31538089) strcat(s, "d");
if (crc32("NiUmDSQYTI",10) == 1375971181) strcat(s, "J");
if (crc32("cwRQTNbJWvItdtU",15) == 3537699184) strcat(s, "l");
if (crc32("xIAjgsQSvjbTVtY",15) == 2084758008) strcat(s, "S");
if (crc32("RJFeZje",7) == 2672761262) strcat(s, "y");
    return s;
}

char *effectively_adverbs() {
    char *s = calloc(12);
    if (crc32("WUepnhPGAwTBpK",14) == 92186575) strcat(s, "w");
if (crc32("xvqgojNaJ",9) == 1202826320) strcat(s, "e");
if (crc32("gcYtmCYZcKKo",12) == 1181881487) strcat(s, "v");
if (crc32("RZyPqpaFE",9) == 1295555127) strcat(s, "f");
if (crc32("uPziFLVp",8) == 3888605722) strcat(s, "f");
if (crc32("uetbllrTSobf",12) == 768743299) strcat(s, "l");
if (crc32("izDzakWcpcXPjlk",15) == 1871340415) strcat(s, "e");
if (crc32("PboyjYaEqG",10) == 4010517180) strcat(s, "c");
if (crc32("VumnMgkspQOLEuN",15) == 3664291001) strcat(s, "t");
if (crc32("wEkEnCvHxMRax",13) == 3379048112) strcat(s, "Y");
if (crc32("KZjxMxz",7) == 604522428) strcat(s, "i");
if (crc32("FQOxbnWRqgg",11) == 344663341) strcat(s, "v");
if (crc32("vTbFB",5) == 3012365289) strcat(s, "b");
if (crc32("rnPFFDaVBOWI",12) == 1056345223) strcat(s, "e");
if (crc32("HEIiLPN",7) == 4103059561) strcat(s, "l");
if (crc32("BQbcSEhIs",9) == 1621278473) strcat(s, "y");
    return s;
}

char *overslowly_adverbs() {
    char *s = calloc(11);
    if (crc32("PkmeZ",5) == 3240966063) strcat(s, "o");
if (crc32("nPDDDTSiixxmj",13) == 1148271699) strcat(s, "v");
if (crc32("CVOwQxpnQ",9) == 773900503) strcat(s, "e");
if (crc32("FgaDfnxQTLgM",12) == 384883066) strcat(s, "a");
if (crc32("YPuNxnsrink",11) == 2741407352) strcat(s, "r");
if (crc32("VvYNwYB",7) == 2546075910) strcat(s, "p");
if (crc32("dBzAkDVFZSzzE",13) == 3144540573) strcat(s, "s");
if (crc32("RoNmVps",7) == 97684023) strcat(s, "c");
if (crc32("VaSixYtGjyqnwPO",15) == 4125650474) strcat(s, "l");
if (crc32("uERsNONPpKz",11) == 38100513) strcat(s, "k");
if (crc32("JkQcjVvluVCEZJO",15) == 1784551492) strcat(s, "o");
if (crc32("JUusHiKoljMU",12) == 2451910169) strcat(s, "m");
if (crc32("gCnVaRA",7) == 1385603906) strcat(s, "w");
if (crc32("QTCuHtfhXt",10) == 2728825706) strcat(s, "X");
if (crc32("qJontIDM",8) == 1030563419) strcat(s, "l");
if (crc32("zcrCBCOHyFOz",12) == 1184042270) strcat(s, "m");
if (crc32("jdCgJD",6) == 3405861986) strcat(s, "y");
    return s;
}

char *overdearly_adverbs() {
    char *s = calloc(11);
    if (crc32("TyCkcmnrv",9) == 4178208310) strcat(s, "g");
if (crc32("LakYTCNRIQto",12) == 3861023528) strcat(s, "o");
if (crc32("iEYyHoS",7) == 424762690) strcat(s, "i");
if (crc32("uqJpiB",6) == 2720716021) strcat(s, "v");
if (crc32("EWLMOYPGfOpS",12) == 2586255866) strcat(s, "k");
if (crc32("gkbByMQkIzK",11) == 1253377146) strcat(s, "e");
if (crc32("WYWgw",5) == 2000323876) strcat(s, "r");
if (crc32("oeIdeFZ",7) == 3312588952) strcat(s, "l");
if (crc32("VBbRk",5) == 1506985352) strcat(s, "d");
if (crc32("XWEvIQ",6) == 441258273) strcat(s, "e");
if (crc32("NNtdFgLkWO",10) == 1451255446) strcat(s, "a");
if (crc32("RsRVuPIp",8) == 408390045) strcat(s, "r");
if (crc32("calwdmZgihZjtY",14) == 3378085639) strcat(s, "l");
if (crc32("BILtSfxklrt",11) == 2936586019) strcat(s, "f");
if (crc32("QlJKfnQvTAGpx",13) == 4232265557) strcat(s, "y");
    return s;
}

char *superfinitely_adverbs() {
    char *s = calloc(14);
    if (crc32("JbmaZubd",8) == 1977500540) strcat(s, "c");
if (crc32("JMnIRrVzoZg",11) == 120528024) strcat(s, "s");
if (crc32("XUgtCXJTSWTVfB",14) == 2545913692) strcat(s, "u");
if (crc32("NVyujFKu",8) == 390141413) strcat(s, "p");
if (crc32("flPJEBEsri",10) == 1473130734) strcat(s, "q");
if (crc32("KkZVk",5) == 1384908579) strcat(s, "e");
if (crc32("AGVexRFc",8) == 2882113746) strcat(s, "j");
if (crc32("TQKYXPbN",8) == 3319462668) strcat(s, "r");
if (crc32("ebRnxxGNlVyItW",14) == 3812899836) strcat(s, "f");
if (crc32("UpTvecgH",8) == 1641278436) strcat(s, "i");
if (crc32("qyWmPQVghE",10) == 303174467) strcat(s, "n");
if (crc32("LPrlyTwxdToGG",13) == 111745597) strcat(s, "i");
if (crc32("skgiJpRdP",9) == 3220348503) strcat(s, "t");
if (crc32("KMvMTKkgcaLLa",13) == 1878483387) strcat(s, "H");
if (crc32("kySuYerJnVrnx",13) == 133056082) strcat(s, "e");
if (crc32("TCKHCbZvqMT",11) == 456426214) strcat(s, "p");
if (crc32("lUzFtWliKjX",11) == 1898359878) strcat(s, "l");
if (crc32("ICsYR",5) == 3368057293) strcat(s, "Y");
if (crc32("wuhfPRBDqp",10) == 3367086753) strcat(s, "y");
    return s;
}

char *nonprofessorially_adverbs() {
    char *s = calloc(18);
    if (crc32("qgtEttF",7) == 3842919896) strcat(s, "n");
if (crc32("ufcBXsZoDkv",11) == 4073449570) strcat(s, "o");
if (crc32("HqARalTZRgBfr",13) == 1542077995) strcat(s, "S");
if (crc32("wWFpHhF",7) == 1438047635) strcat(s, "n");
if (crc32("ivkGNStISh",10) == 1122284279) strcat(s, "p");
if (crc32("VrKjVrTQtkmyO",13) == 441971568) strcat(s, "r");
if (crc32("SyMJuaY",7) == 1061449479) strcat(s, "F");
if (crc32("ZawlzPIOlfAXqA",14) == 4125801410) strcat(s, "o");
if (crc32("npfKKlPNBvrOoUx",15) == 2536234911) strcat(s, "o");
if (crc32("wcwRynu",7) == 2416191388) strcat(s, "f");
if (crc32("aDIHtvzulk",10) == 3159792491) strcat(s, "e");
if (crc32("kdLSECBPgT",10) == 968152529) strcat(s, "t");
if (crc32("jxQiFRHP",8) == 720526078) strcat(s, "s");
if (crc32("rsgJctVT",8) == 2269777678) strcat(s, "d");
if (crc32("iYaBL",5) == 271917858) strcat(s, "s");
if (crc32("gPIZhGrvVG",10) == 3481225560) strcat(s, "z");
if (crc32("AsMSCbGxVEA",11) == 86510838) strcat(s, "o");
if (crc32("jwHeGyl",7) == 265982364) strcat(s, "r");
if (crc32("UlDzQqzs",8) == 3523574836) strcat(s, "S");
if (crc32("jfUapZvMy",9) == 3935653756) strcat(s, "i");
if (crc32("sVLIQTCCYVTO",12) == 1890869922) strcat(s, "a");
if (crc32("rySfDRM",7) == 1547401302) strcat(s, "l");
if (crc32("yFcNCpJZdn",10) == 1074363419) strcat(s, "l");
if (crc32("DrjEkCFLcDq",11) == 2819677684) strcat(s, "y");
    return s;
}

char *lushly_adverbs() {
    char *s = calloc(7);
    if (crc32("jYVqGOWY",8) == 1335166205) strcat(s, "Q");
if (crc32("tFrRuWJdJY",10) == 2568307641) strcat(s, "l");
if (crc32("emuDCZnAF",9) == 1735882629) strcat(s, "g");
if (crc32("xhptOSDI",8) == 2468788151) strcat(s, "u");
if (crc32("QYXtpS",6) == 265521397) strcat(s, "j");
if (crc32("ZIhUaCSQDFzjJV",14) == 876570219) strcat(s, "s");
if (crc32("ysoxJuEGgMef",12) == 234788379) strcat(s, "K");
if (crc32("aFseEbLfkoFNJLe",15) == 3204425865) strcat(s, "h");
if (crc32("dcLVoQwEH",9) == 754586581) strcat(s, "l");
if (crc32("qbSXHrEtdEdPy",13) == 2321583213) strcat(s, "q");
if (crc32("tLYCxaxnolj",11) == 4056485101) strcat(s, "y");
    return s;
}

char *wofully_adverbs() {
    char *s = calloc(8);
    if (crc32("scsZoAEV",8) == 2288337179) strcat(s, "Z");
if (crc32("nkDfZcBuIxPFY",13) == 183127946) strcat(s, "w");
if (crc32("NsXRy",5) == 2609944321) strcat(s, "o");
if (crc32("jaCfXdY",7) == 2915783720) strcat(s, "g");
if (crc32("kAIAFraUHhhlHz",14) == 2507288808) strcat(s, "f");
if (crc32("ZIAmnjUmDN",10) == 1745511502) strcat(s, "u");
if (crc32("YxnVqf",6) == 4132604480) strcat(s, "f");
if (crc32("pTHNzeGsPpFk",12) == 2806714252) strcat(s, "l");
if (crc32("dBilUU",6) == 3530259830) strcat(s, "W");
if (crc32("KIYfmQRoJzzUe",13) == 3943396247) strcat(s, "l");
if (crc32("JSeKnNDMvhVkWG",14) == 554108694) strcat(s, "y");
    return s;
}

char *applicably_adverbs() {
    char *s = calloc(11);
    if (crc32("pfoBRtry",8) == 4238955721) strcat(s, "a");
if (crc32("FoSiF",5) == 1451530935) strcat(s, "v");
if (crc32("OEeTDEya",8) == 2959716644) strcat(s, "p");
if (crc32("winMloEhcM",10) == 2840548856) strcat(s, "W");
if (crc32("ewqWwEL",7) == 1668790031) strcat(s, "p");
if (crc32("WIygBJ",6) == 1992763183) strcat(s, "w");
if (crc32("eHSxlFcHexFcsZ",14) == 2487563930) strcat(s, "l");
if (crc32("yFYwSppLKDSIL",13) == 2184078989) strcat(s, "i");
if (crc32("DqmgQTEd",8) == 912906967) strcat(s, "l");
if (crc32("JRcca",5) == 2341563407) strcat(s, "c");
if (crc32("Fmjhlxz",7) == 892758561) strcat(s, "a");
if (crc32("CCxzPmasghl",11) == 2660277984) strcat(s, "s");
if (crc32("DzSwIO",6) == 3652675427) strcat(s, "b");
if (crc32("sZskxybhJ",9) == 4221117416) strcat(s, "l");
if (crc32("DPJPiKUpL",9) == 1203072045) strcat(s, "p");
if (crc32("TnGpgxGzoMuokNN",15) == 1283812560) strcat(s, "y");
    return s;
}

char *quarrelingly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZQanE",5) == 1944918673) strcat(s, "q");
if (crc32("pfXfxwPc",8) == 1183753281) strcat(s, "u");
if (crc32("SahSxWGfJOyJ",12) == 1391903724) strcat(s, "a");
if (crc32("mFhttkobrZfklUq",15) == 1484312113) strcat(s, "r");
if (crc32("SmfDCxfTUUYSP",13) == 1352333524) strcat(s, "r");
if (crc32("BTWTsSqUTZY",11) == 3299785361) strcat(s, "e");
if (crc32("UUfqMyHfv",9) == 4177186942) strcat(s, "n");
if (crc32("CGNxEHx",7) == 2746586941) strcat(s, "l");
if (crc32("yqpITcrdRLgYe",13) == 3867127920) strcat(s, "X");
if (crc32("NRwXLYVDeQAag",13) == 3213741023) strcat(s, "i");
if (crc32("LspaLbUYEzQsv",13) == 252700139) strcat(s, "n");
if (crc32("KqTBddvuVEyNAzn",15) == 2722421460) strcat(s, "t");
if (crc32("JDXiGSsTVUd",11) == 3667288757) strcat(s, "g");
if (crc32("WAetmAUgJzEib",13) == 3002835985) strcat(s, "A");
if (crc32("fXFeV",5) == 813484268) strcat(s, "l");
if (crc32("ngach",5) == 41779602) strcat(s, "y");
    return s;
}

char *flavourfully_adverbs() {
    char *s = calloc(13);
    if (crc32("LbvEjajDmVmvyye",15) == 3896381784) strcat(s, "f");
if (crc32("MQCfQqdHK",9) == 3760897226) strcat(s, "g");
if (crc32("RbukSWjENeIWNlB",15) == 342540997) strcat(s, "l");
if (crc32("FueSUMOWM",9) == 3816363220) strcat(s, "a");
if (crc32("McKRvYyFoZGUZD",14) == 3435282924) strcat(s, "R");
if (crc32("labvwdp",7) == 3210633015) strcat(s, "v");
if (crc32("UToZA",5) == 2700630333) strcat(s, "G");
if (crc32("LuBgJJ",6) == 410011161) strcat(s, "o");
if (crc32("nDxZaZQAugJyvJ",14) == 1889453843) strcat(s, "r");
if (crc32("qAsEbuYfkMV",11) == 1658144331) strcat(s, "u");
if (crc32("qGIzzzdyYNrmG",13) == 1795530812) strcat(s, "y");
if (crc32("beSkAftkYqyXC",13) == 2619292958) strcat(s, "r");
if (crc32("LSHQji",6) == 776581163) strcat(s, "f");
if (crc32("BCSImFfG",8) == 4023283289) strcat(s, "s");
if (crc32("qnpIxzJojNspP",13) == 3764447176) strcat(s, "u");
if (crc32("CgGWfZTXKaSRLrx",15) == 1932965913) strcat(s, "l");
if (crc32("FXTsXadXAuKMHg",14) == 2121509578) strcat(s, "s");
if (crc32("DLEiOrUN",8) == 1111733059) strcat(s, "l");
if (crc32("GKkuq",5) == 3909640878) strcat(s, "c");
if (crc32("fSbWeqhB",8) == 3265920176) strcat(s, "y");
    return s;
}

char *superlaboriously_adverbs() {
    char *s = calloc(17);
    if (crc32("whqcyirY",8) == 999127814) strcat(s, "s");
if (crc32("CnvYNZ",6) == 185989242) strcat(s, "z");
if (crc32("dWUnPMAchWHGUMd",15) == 2919999989) strcat(s, "u");
if (crc32("wTJXxhIb",8) == 3636838807) strcat(s, "p");
if (crc32("UhAySTKP",8) == 982555172) strcat(s, "e");
if (crc32("pCLyHZMXExHBbmZ",15) == 3115512913) strcat(s, "U");
if (crc32("KkvXKvHcMtote",13) == 250000300) strcat(s, "r");
if (crc32("vCQMr",5) == 2947772542) strcat(s, "l");
if (crc32("MbvwhtDYcfr",11) == 1925466403) strcat(s, "a");
if (crc32("gMBkbnrxgKUAr",13) == 74502232) strcat(s, "b");
if (crc32("JqGxRfdS",8) == 241538581) strcat(s, "z");
if (crc32("kwmCrSq",7) == 186142004) strcat(s, "o");
if (crc32("rmiytlZS",8) == 2913536146) strcat(s, "r");
if (crc32("ggaAJJExOq",10) == 3692501848) strcat(s, "H");
if (crc32("yvWDhGVurIVIbwq",15) == 2407874930) strcat(s, "i");
if (crc32("jxXWrAOZ",8) == 3713073367) strcat(s, "o");
if (crc32("yeyTgJhJKqeZexS",15) == 1917012457) strcat(s, "M");
if (crc32("oXpXdPihZDMuL",13) == 3589591200) strcat(s, "u");
if (crc32("hfJimCViVxapR",13) == 447320907) strcat(s, "s");
if (crc32("sfUJhsJpAsludm",14) == 1301881255) strcat(s, "l");
if (crc32("sywdxbpkxMPsrwX",15) == 3674883136) strcat(s, "N");
if (crc32("EQZaEFFnR",9) == 2347605219) strcat(s, "y");
    return s;
}

char *evidently_adverbs() {
    char *s = calloc(10);
    if (crc32("vijzoWHooOUV",12) == 1053151235) strcat(s, "S");
if (crc32("CECREHwmm",9) == 680784076) strcat(s, "e");
if (crc32("POkKJw",6) == 3752399758) strcat(s, "M");
if (crc32("ErHjCv",6) == 345472824) strcat(s, "v");
if (crc32("ceEJqxK",7) == 1214910734) strcat(s, "i");
if (crc32("ZyQSCYDco",9) == 4039823015) strcat(s, "d");
if (crc32("tUUZHXNt",8) == 396890185) strcat(s, "e");
if (crc32("OcmUhq",6) == 2363837578) strcat(s, "m");
if (crc32("TqYzBqwXZHHLRix",15) == 967611813) strcat(s, "n");
if (crc32("yWnbKXGszGr",11) == 3734157629) strcat(s, "t");
if (crc32("EFDVvHBftRWqy",13) == 1022594164) strcat(s, "X");
if (crc32("SfPYAuhvPFYAsLO",15) == 506803618) strcat(s, "l");
if (crc32("PUyzwsZfnkgHst",14) == 3781088430) strcat(s, "y");
    return s;
}

char *accursedly_adverbs() {
    char *s = calloc(11);
    if (crc32("wlcjPlD",7) == 1449975299) strcat(s, "i");
if (crc32("HhAFBxjUkJPb",12) == 517174368) strcat(s, "a");
if (crc32("gGwmuGHSXMGyOTx",15) == 738255068) strcat(s, "u");
if (crc32("SHlyrgn",7) == 4050443278) strcat(s, "c");
if (crc32("aAoNryVbS",9) == 1480004602) strcat(s, "c");
if (crc32("GRUHlG",6) == 2776162289) strcat(s, "E");
if (crc32("WshXuBQxaC",10) == 2716113457) strcat(s, "u");
if (crc32("jJholRqjO",9) == 1510712200) strcat(s, "O");
if (crc32("ZrZCALFv",8) == 756584219) strcat(s, "r");
if (crc32("muRVzSCKl",9) == 2055227320) strcat(s, "z");
if (crc32("WsFhSEcErbeTqEu",15) == 688594935) strcat(s, "s");
if (crc32("YOrCEloSJykdcX",14) == 1530187358) strcat(s, "m");
if (crc32("SmPjgkgwNjMD",12) == 3696787303) strcat(s, "e");
if (crc32("NNtJATfi",8) == 2279489553) strcat(s, "L");
if (crc32("DgPiJLpOvpbgF",13) == 3218296695) strcat(s, "d");
if (crc32("LvEKbnkyxxino",13) == 1997629351) strcat(s, "N");
if (crc32("JSXpJ",5) == 3594566089) strcat(s, "l");
if (crc32("HZibPNhzn",9) == 1718704806) strcat(s, "y");
    return s;
}

char *unbureaucratically_adverbs() {
    char *s = calloc(19);
    if (crc32("UBhEHug",7) == 3850773021) strcat(s, "C");
if (crc32("rAaeSR",6) == 1271847794) strcat(s, "u");
if (crc32("XIbhX",5) == 2879013767) strcat(s, "n");
if (crc32("GfDMfbdDBiHkv",13) == 4048476239) strcat(s, "g");
if (crc32("tiIXZyKhabtVX",13) == 3726149845) strcat(s, "b");
if (crc32("LmeWe",5) == 340998660) strcat(s, "u");
if (crc32("QZzdRskfH",9) == 2349939979) strcat(s, "J");
if (crc32("NjJjWq",6) == 872667589) strcat(s, "r");
if (crc32("hWONuFiUivNS",12) == 3947274166) strcat(s, "e");
if (crc32("BJcNdC",6) == 1556221058) strcat(s, "a");
if (crc32("qhnlK",5) == 3880613843) strcat(s, "C");
if (crc32("kiJgAkcVUnt",11) == 3536350449) strcat(s, "u");
if (crc32("jCQmiUuoeGJ",11) == 1465943800) strcat(s, "H");
if (crc32("uXNkD",5) == 1947543744) strcat(s, "c");
if (crc32("cpExyCRdwry",11) == 3370969121) strcat(s, "O");
if (crc32("AOWpx",5) == 2027189826) strcat(s, "r");
if (crc32("OtYgjADdVaaiwNP",15) == 1234487939) strcat(s, "a");
if (crc32("sgtvbODEoSrc",12) == 1236940964) strcat(s, "D");
if (crc32("HnDsi",5) == 850899568) strcat(s, "t");
if (crc32("IbBtYeLCqNLyw",13) == 981147730) strcat(s, "i");
if (crc32("bAFadytklJ",10) == 2776332185) strcat(s, "c");
if (crc32("NhuBnIltDKHcOl",14) == 2212896300) strcat(s, "a");
if (crc32("dkvJPZmrqPeZ",12) == 1407505689) strcat(s, "B");
if (crc32("qnflpnOnemRaPLQ",15) == 3649820863) strcat(s, "l");
if (crc32("yTCGhCD",7) == 3849303975) strcat(s, "x");
if (crc32("sjmLrG",6) == 2861245725) strcat(s, "l");
if (crc32("EyZPrUiYoOsAof",14) == 339497732) strcat(s, "i");
if (crc32("GwWGmoBFjwqbbBk",15) == 2729654086) strcat(s, "y");
    return s;
}

char *subventrally_adverbs() {
    char *s = calloc(13);
    if (crc32("SVYYnGVWOgfUKD",14) == 681152865) strcat(s, "h");
if (crc32("wZJagcTsV",9) == 2060453980) strcat(s, "s");
if (crc32("tvBVKinckqXyBhX",15) == 2562878112) strcat(s, "T");
if (crc32("bOIqOA",6) == 3947427702) strcat(s, "u");
if (crc32("hQiceKJzLhqO",12) == 541096757) strcat(s, "b");
if (crc32("MpsZcnn",7) == 2998258896) strcat(s, "v");
if (crc32("LQtHLTkakmG",11) == 3678030421) strcat(s, "L");
if (crc32("EAfCkUedEVqZ",12) == 1320400028) strcat(s, "e");
if (crc32("UdmfWlmsWkkKR",13) == 1792041956) strcat(s, "v");
if (crc32("rAATstyfXMynPZ",14) == 395163390) strcat(s, "n");
if (crc32("oaDtCeNiLIspJ",13) == 1824392116) strcat(s, "o");
if (crc32("xvgLqtIxtxo",11) == 3671500274) strcat(s, "t");
if (crc32("FzaBLDTZRidI",12) == 4041671503) strcat(s, "n");
if (crc32("ygfuiAP",7) == 2129754168) strcat(s, "r");
if (crc32("PDRWuLxH",8) == 2553670961) strcat(s, "u");
if (crc32("xIYbsOmyZfs",11) == 3463256063) strcat(s, "a");
if (crc32("NQdtzsmEP",9) == 3927793049) strcat(s, "l");
if (crc32("reeQLbv",7) == 1735784301) strcat(s, "G");
if (crc32("SanhSUiK",8) == 3993516634) strcat(s, "l");
if (crc32("eKuNafivI",9) == 2222242727) strcat(s, "y");
    return s;
}

char *quasitragically_adverbs() {
    char *s = calloc(16);
    if (crc32("bvKnH",5) == 4179007802) strcat(s, "m");
if (crc32("VMrSmpS",7) == 2841061481) strcat(s, "q");
if (crc32("DaQGJ",5) == 2894375993) strcat(s, "u");
if (crc32("oihxHakRZ",9) == 783920041) strcat(s, "e");
if (crc32("bTyQf",5) == 1039052898) strcat(s, "a");
if (crc32("cDgVCoMpfzBcqDJ",15) == 1551597323) strcat(s, "b");
if (crc32("CoklfTVckt",10) == 3001198558) strcat(s, "s");
if (crc32("zubpWrPpVFVKYpW",15) == 3765316055) strcat(s, "q");
if (crc32("CmBqxMZf",8) == 2621420041) strcat(s, "i");
if (crc32("moWSPr",6) == 1401943768) strcat(s, "P");
if (crc32("OxyaipX",7) == 2995721989) strcat(s, "t");
if (crc32("EoETvHjTwJkuE",13) == 2362418810) strcat(s, "r");
if (crc32("qMWcKtDtLJ",10) == 2408550521) strcat(s, "Q");
if (crc32("ZBcpgYBL",8) == 2103129013) strcat(s, "a");
if (crc32("LvScKAhUdb",10) == 3011936620) strcat(s, "g");
if (crc32("CQLwccfDga",10) == 99797035) strcat(s, "k");
if (crc32("fVcAIjQLZtmOOu",14) == 2974267618) strcat(s, "i");
if (crc32("NwRhLqM",7) == 3619149340) strcat(s, "N");
if (crc32("spLoedCwv",9) == 3073132644) strcat(s, "c");
if (crc32("SwvApwlE",8) == 2442652945) strcat(s, "w");
if (crc32("EeWWpoaCr",9) == 2871245076) strcat(s, "a");
if (crc32("TQUyTbKn",8) == 2861773033) strcat(s, "e");
if (crc32("YxoGytsLqQQ",11) == 1097120261) strcat(s, "l");
if (crc32("tnoURmRatOWDmz",14) == 1921572863) strcat(s, "z");
if (crc32("XXfROpm",7) == 2097617182) strcat(s, "l");
if (crc32("KFZQYlyLV",9) == 3562827171) strcat(s, "y");
    return s;
}

char *largely_adverbs() {
    char *s = calloc(8);
    if (crc32("HrEVxrjFnQHu",12) == 1190745776) strcat(s, "l");
if (crc32("fdiHpPh",7) == 2528530496) strcat(s, "m");
if (crc32("IeujRJEYxQ",10) == 999279120) strcat(s, "a");
if (crc32("BLcyQX",6) == 3673293165) strcat(s, "r");
if (crc32("hXFedCdr",8) == 1259594046) strcat(s, "G");
if (crc32("mUoFPPOzhMnoI",13) == 3798305082) strcat(s, "g");
if (crc32("GVTwklIOEtUf",12) == 3008097196) strcat(s, "a");
if (crc32("UhKuddVElt",10) == 1751856619) strcat(s, "e");
if (crc32("VjzJoZGTtJwgp",13) == 1930959851) strcat(s, "l");
if (crc32("xdHrvC",6) == 539778539) strcat(s, "C");
if (crc32("TCpYVHtRmXyqym",14) == 3070310448) strcat(s, "y");
    return s;
}

char *maniacally_adverbs() {
    char *s = calloc(11);
    if (crc32("AegaGNZFuoz",11) == 2354814641) strcat(s, "k");
if (crc32("BnfJLvH",7) == 3862924486) strcat(s, "m");
if (crc32("doOwKwRV",8) == 4232027408) strcat(s, "A");
if (crc32("wIRbextyCpQ",11) == 1968077370) strcat(s, "a");
if (crc32("BlxMN",5) == 464572600) strcat(s, "n");
if (crc32("WgnEAwjYP",9) == 2192021180) strcat(s, "b");
if (crc32("awWmDdCPVDKRw",13) == 3471555957) strcat(s, "i");
if (crc32("MPqAlSk",7) == 1495249172) strcat(s, "a");
if (crc32("lFdXHr",6) == 2133018244) strcat(s, "Y");
if (crc32("FoWIpvuuTjLj",12) == 4159653868) strcat(s, "c");
if (crc32("yzbPXmM",7) == 3695908961) strcat(s, "a");
if (crc32("sMTFYOXYTxPYy",13) == 2780168281) strcat(s, "l");
if (crc32("uEwInLZDWyiPN",13) == 734980739) strcat(s, "C");
if (crc32("JQOWesQ",7) == 1625199620) strcat(s, "l");
if (crc32("xSTgyVWNcZW",11) == 633389310) strcat(s, "y");
    return s;
}

char *nonsacrilegiously_adverbs() {
    char *s = calloc(18);
    if (crc32("loBkcrgzoL",10) == 1310315156) strcat(s, "u");
if (crc32("uvUVdJs",7) == 1821784606) strcat(s, "n");
if (crc32("kppPxIH",7) == 3051321136) strcat(s, "v");
if (crc32("GsJWw",5) == 334322476) strcat(s, "o");
if (crc32("XZwkTVbN",8) == 1987073411) strcat(s, "n");
if (crc32("asuOMpErb",9) == 4117715371) strcat(s, "I");
if (crc32("mXGCtVKfNp",10) == 1106423405) strcat(s, "s");
if (crc32("HoMCEPuwcNy",11) == 1596889138) strcat(s, "Z");
if (crc32("ZdTpf",5) == 3768482772) strcat(s, "a");
if (crc32("jtnZAgP",7) == 3896667638) strcat(s, "s");
if (crc32("oVCop",5) == 4086985266) strcat(s, "c");
if (crc32("hELwk",5) == 3424475) strcat(s, "r");
if (crc32("xbwzdjv",7) == 2843584892) strcat(s, "E");
if (crc32("OoHBjWbqM",9) == 736086069) strcat(s, "i");
if (crc32("FdDENwEYAXc",11) == 2633104589) strcat(s, "l");
if (crc32("esPeuetyjuqXyU",14) == 1492186284) strcat(s, "e");
if (crc32("VLexMnmKjAuT",12) == 3785449924) strcat(s, "g");
if (crc32("uAkxrvnyCCt",11) == 1548756225) strcat(s, "i");
if (crc32("URIcwrvNN",9) == 2293671598) strcat(s, "l");
if (crc32("MCOsKbqZCMVJ",12) == 1831116231) strcat(s, "o");
if (crc32("wKEnr",5) == 3063283869) strcat(s, "d");
if (crc32("zhIYZIoYkRbf",12) == 1244695493) strcat(s, "u");
if (crc32("AVdWQB",6) == 609244873) strcat(s, "s");
if (crc32("wcCLO",5) == 3954973729) strcat(s, "G");
if (crc32("pyEjQmEnuG",10) == 4118493257) strcat(s, "l");
if (crc32("wcCRjMGx",8) == 2143935689) strcat(s, "y");
    return s;
}

char *nonsuggestively_adverbs() {
    char *s = calloc(16);
    if (crc32("mavWdfwSoO",10) == 432394619) strcat(s, "n");
if (crc32("hcsFjIBMExWKo",13) == 2448718697) strcat(s, "u");
if (crc32("SUvajoknTBf",11) == 2756336241) strcat(s, "o");
if (crc32("nXPmyteKXzWpk",13) == 3369656461) strcat(s, "J");
if (crc32("tTfnSKTNnddO",12) == 1107989570) strcat(s, "n");
if (crc32("WlQtNdS",7) == 1827739889) strcat(s, "s");
if (crc32("fsaUvhepPl",10) == 2736627516) strcat(s, "w");
if (crc32("LIbTbfhyhxTis",13) == 3705959958) strcat(s, "u");
if (crc32("SsgnecPUhXpf",12) == 3739899426) strcat(s, "J");
if (crc32("tgwAnxussc",10) == 1096818409) strcat(s, "g");
if (crc32("GjBbmVfy",8) == 2592762916) strcat(s, "v");
if (crc32("aUfwioMZH",9) == 4192250059) strcat(s, "g");
if (crc32("ubjgNcokIe",10) == 1579255070) strcat(s, "e");
if (crc32("eBHjClHDchcmPaK",15) == 3620335142) strcat(s, "s");
if (crc32("qettPHmSuJZCB",13) == 1630796218) strcat(s, "w");
if (crc32("YAVcNfBKJtnj",12) == 1420817974) strcat(s, "t");
if (crc32("PfLPO",5) == 1572943771) strcat(s, "D");
if (crc32("TLEjmyCwQQk",11) == 3372308877) strcat(s, "i");
if (crc32("oqMvNbDjzx",10) == 2564013580) strcat(s, "i");
if (crc32("ScPPgKXKYyI",11) == 1779956300) strcat(s, "v");
if (crc32("FbvzMqLL",8) == 2855453919) strcat(s, "J");
if (crc32("KgpRzYZ",7) == 4024849800) strcat(s, "e");
if (crc32("YsEVtCSnkhQHg",13) == 1332160520) strcat(s, "d");
if (crc32("rqVlrIRI",8) == 2125331207) strcat(s, "l");
if (crc32("uUoYCWLiGW",10) == 2879741254) strcat(s, "y");
    return s;
}

char *dinkly_adverbs() {
    char *s = calloc(7);
    if (crc32("RLoCfLoKjyb",11) == 881965321) strcat(s, "d");
if (crc32("uPvRWSt",7) == 244696271) strcat(s, "i");
if (crc32("idNkYUoQfr",10) == 582236611) strcat(s, "i");
if (crc32("AeqwrDZLkRb",11) == 2351404273) strcat(s, "a");
if (crc32("pigyoHqEHdbom",13) == 1494388740) strcat(s, "n");
if (crc32("yjGuPJ",6) == 300700834) strcat(s, "d");
if (crc32("cbfLQBaH",8) == 1620041439) strcat(s, "k");
if (crc32("dHCBkUp",7) == 375773705) strcat(s, "F");
if (crc32("HArde",5) == 3862256775) strcat(s, "l");
if (crc32("yRGoRRuBWvkhG",13) == 1339331466) strcat(s, "y");
    return s;
}

char *untributarily_adverbs() {
    char *s = calloc(14);
    if (crc32("TptJTUZKPF",10) == 4045407872) strcat(s, "u");
if (crc32("XqyVVHBqSN",10) == 3334037346) strcat(s, "F");
if (crc32("AOoGeRNL",8) == 1400353667) strcat(s, "n");
if (crc32("cOdnqzbuwXMR",12) == 622678714) strcat(s, "t");
if (crc32("ClAynZWVPQgY",12) == 838526913) strcat(s, "r");
if (crc32("khXAiIlpjQZf",12) == 256188398) strcat(s, "E");
if (crc32("wTwhSStfJV",10) == 324886707) strcat(s, "i");
if (crc32("regWhnuvNqol",12) == 3394019857) strcat(s, "b");
if (crc32("kAffQLaH",8) == 4131131695) strcat(s, "n");
if (crc32("BMAqyhQbVsUuwuM",15) == 1184591017) strcat(s, "u");
if (crc32("TpHhdnVFCL",10) == 1793024602) strcat(s, "t");
if (crc32("QKdfhRTbTvF",11) == 42911944) strcat(s, "o");
if (crc32("lmNneqrCUNP",11) == 3133437617) strcat(s, "a");
if (crc32("ZoOszoLNljddEf",14) == 1354264640) strcat(s, "T");
if (crc32("EFNlVsJZjuLA",12) == 517182148) strcat(s, "r");
if (crc32("cjxSh",5) == 3291886578) strcat(s, "i");
if (crc32("krOQvdjx",8) == 2825853659) strcat(s, "l");
if (crc32("msUqJbuIVYvS",12) == 1066152800) strcat(s, "N");
if (crc32("bmLgzhb",7) == 1495525529) strcat(s, "y");
    return s;
}

char *reflexively_adverbs() {
    char *s = calloc(12);
    if (crc32("fufgBD",6) == 3195469615) strcat(s, "r");
if (crc32("zQAZwuaj",8) == 518282927) strcat(s, "e");
if (crc32("WumoOdROTdvzZWR",15) == 1133591025) strcat(s, "q");
if (crc32("FNsPvM",6) == 3946736741) strcat(s, "f");
if (crc32("VSbFNSSkph",10) == 2979507158) strcat(s, "Q");
if (crc32("wjeaMKZMqat",11) == 1439519443) strcat(s, "l");
if (crc32("OIiSibRUZDCES",13) == 2395601468) strcat(s, "Q");
if (crc32("LJvQH",5) == 609438553) strcat(s, "e");
if (crc32("ybcdCcZykroGCSY",15) == 1346176282) strcat(s, "x");
if (crc32("iChKpXcJbfF",11) == 1729790026) strcat(s, "i");
if (crc32("WqoFSFnPIGr",11) == 401256890) strcat(s, "v");
if (crc32("dVzQAVl",7) == 3930798444) strcat(s, "X");
if (crc32("ZPXNcx",6) == 1081541396) strcat(s, "e");
if (crc32("XefzkgiJSEp",11) == 115445574) strcat(s, "T");
if (crc32("QTHlVqRfj",9) == 3484814259) strcat(s, "l");
if (crc32("WxXyLutfr",9) == 3423250727) strcat(s, "R");
if (crc32("njCeIlwzfps",11) == 2605212728) strcat(s, "y");
    return s;
}

char *demographically_adverbs() {
    char *s = calloc(16);
    if (crc32("RlVMsknFNhDgIr",14) == 2457620112) strcat(s, "U");
if (crc32("pyOBFfiBs",9) == 3504147375) strcat(s, "d");
if (crc32("QOsVYl",6) == 2950737990) strcat(s, "D");
if (crc32("NLCdhB",6) == 3927583435) strcat(s, "e");
if (crc32("cUVzQPG",7) == 4158498609) strcat(s, "m");
if (crc32("qllBqLELWLy",11) == 2564217648) strcat(s, "i");
if (crc32("DvhChXQXP",9) == 3981540636) strcat(s, "o");
if (crc32("fpDaDHR",7) == 2593592646) strcat(s, "g");
if (crc32("VqZMcXWXAnk",11) == 967615875) strcat(s, "r");
if (crc32("mMDPMMmDZZeVMG",14) == 2669862901) strcat(s, "R");
if (crc32("wMTqnIFtsdIBIe",14) == 2261140090) strcat(s, "a");
if (crc32("CjQFkXm",7) == 2376084937) strcat(s, "H");
if (crc32("eHCgaRvcks",10) == 2461460927) strcat(s, "p");
if (crc32("PqQhxMg",7) == 2537108775) strcat(s, "b");
if (crc32("WmKTxSLynz",10) == 4019048525) strcat(s, "h");
if (crc32("BCmprMUO",8) == 2920942274) strcat(s, "i");
if (crc32("PRsFtzuuyV",10) == 1388390956) strcat(s, "c");
if (crc32("jinyvfMDMsBLjS",14) == 3163570392) strcat(s, "a");
if (crc32("pyWcxJTKGvGFoz",14) == 4203494937) strcat(s, "l");
if (crc32("bokqEmJ",7) == 3174635832) strcat(s, "B");
if (crc32("blWKotvraXzrg",13) == 614260627) strcat(s, "l");
if (crc32("kHrYI",5) == 370989205) strcat(s, "h");
if (crc32("oNwFBbabnQXA",12) == 2395333104) strcat(s, "y");
    return s;
}

char *unsanctimoniously_adverbs() {
    char *s = calloc(18);
    if (crc32("nPHaNUHarEtTY",13) == 3923489962) strcat(s, "a");
if (crc32("iLkiAw",6) == 2400735247) strcat(s, "u");
if (crc32("vCbgsNbalnDA",12) == 3020992877) strcat(s, "M");
if (crc32("tKWAvrAypI",10) == 4222543210) strcat(s, "n");
if (crc32("AxImUqZYdujS",12) == 531639621) strcat(s, "s");
if (crc32("wWrjEHkcutPq",12) == 2045489507) strcat(s, "a");
if (crc32("WzWyfuspn",9) == 347535297) strcat(s, "O");
if (crc32("addyWIhHy",9) == 2448853398) strcat(s, "n");
if (crc32("tAUMr",5) == 3519590194) strcat(s, "y");
if (crc32("UxEowjgEgpSgo",13) == 2741976800) strcat(s, "c");
if (crc32("RNbazN",6) == 2345241859) strcat(s, "t");
if (crc32("hrBAVega",8) == 2714250361) strcat(s, "s");
if (crc32("eGYtPEpduudd",12) == 3171511011) strcat(s, "i");
if (crc32("tuFAtoOwNUCo",12) == 2596679432) strcat(s, "H");
if (crc32("ethUTp",6) == 4288586654) strcat(s, "m");
if (crc32("LwIZKPgECmhwD",13) == 3805498765) strcat(s, "o");
if (crc32("DApLvOAzKrU",11) == 2560562159) strcat(s, "n");
if (crc32("drAIsKmFEAx",11) == 1853742214) strcat(s, "B");
if (crc32("QwxiHctUME",10) == 2966909524) strcat(s, "i");
if (crc32("XMfFpkXyui",10) == 2176108709) strcat(s, "o");
if (crc32("OHIeRBwTIhtaK",13) == 835273817) strcat(s, "T");
if (crc32("VMwKeqMkMAQSSn",14) == 1255537605) strcat(s, "u");
if (crc32("CAkhQXPx",8) == 507909162) strcat(s, "s");
if (crc32("TSVrdylnLW",10) == 4143304122) strcat(s, "u");
if (crc32("lKoPbhQvqpct",12) == 4098305623) strcat(s, "l");
if (crc32("lHWecH",6) == 3553495922) strcat(s, "f");
if (crc32("vddzSHxRFLFWg",13) == 1148933482) strcat(s, "y");
    return s;
}

char *nonskeletally_adverbs() {
    char *s = calloc(14);
    if (crc32("jKmvM",5) == 3679313219) strcat(s, "g");
if (crc32("louLzhEGOWm",11) == 1391661746) strcat(s, "n");
if (crc32("doINGMQQTRAcCrh",15) == 3093319119) strcat(s, "o");
if (crc32("wQFBuZphgZdHts",14) == 397075070) strcat(s, "n");
if (crc32("nxqkmkqGRlNN",12) == 240072489) strcat(s, "s");
if (crc32("qIRUsmXrHG",10) == 2334017529) strcat(s, "k");
if (crc32("zFdTlhWZlX",10) == 1630533362) strcat(s, "e");
if (crc32("OaIOnmuL",8) == 520123993) strcat(s, "M");
if (crc32("tgoqTakiy",9) == 3146058087) strcat(s, "l");
if (crc32("yIQujy",6) == 3963202626) strcat(s, "C");
if (crc32("QjeVh",5) == 1985879154) strcat(s, "e");
if (crc32("cJgusUyeaDLol",13) == 736084174) strcat(s, "o");
if (crc32("qItibs",6) == 432253752) strcat(s, "t");
if (crc32("gBmQQCnKaoZ",11) == 2839110005) strcat(s, "o");
if (crc32("uUYYx",5) == 1560898846) strcat(s, "a");
if (crc32("DjwbVeoUlu",10) == 1815787538) strcat(s, "l");
if (crc32("tkgUnqpB",8) == 2335215961) strcat(s, "R");
if (crc32("GZFEXqwMJR",10) == 2758245623) strcat(s, "l");
if (crc32("DmoWGjMXW",9) == 59468074) strcat(s, "y");
    return s;
}

char *atlantad_adverbs() {
    char *s = calloc(9);
    if (crc32("PZyaka",6) == 745657245) strcat(s, "a");
if (crc32("NdjOohrsYjpKuXx",15) == 508592610) strcat(s, "m");
if (crc32("FMsipamDBCY",11) == 3630003882) strcat(s, "t");
if (crc32("gqjAzUeeqMC",11) == 3553010756) strcat(s, "T");
if (crc32("CCBRXNkhd",9) == 3825723621) strcat(s, "l");
if (crc32("QTdZHLUxBsBHd",13) == 3850070559) strcat(s, "Z");
if (crc32("qfocfevD",8) == 2450226503) strcat(s, "a");
if (crc32("eLwNiKRruip",11) == 3045466331) strcat(s, "L");
if (crc32("KKpTWrcyMsCDGvM",15) == 2593020778) strcat(s, "n");
if (crc32("wjPyms",6) == 4246051367) strcat(s, "t");
if (crc32("jisiTVT",7) == 2388613506) strcat(s, "a");
if (crc32("bNuJJldW",8) == 21265145) strcat(s, "D");
if (crc32("ZNgBu",5) == 1626503912) strcat(s, "d");
    return s;
}

char *eudemonistically_adverbs() {
    char *s = calloc(17);
    if (crc32("YRnMEyU",7) == 3065428933) strcat(s, "e");
if (crc32("KoubsEVu",8) == 392411833) strcat(s, "u");
if (crc32("FeXuBSNlYUN",11) == 3658671219) strcat(s, "p");
if (crc32("WGtHOtHFdi",10) == 2958768052) strcat(s, "d");
if (crc32("lweSPkX",7) == 3224558077) strcat(s, "e");
if (crc32("FAvraVyRMAJG",12) == 1593681021) strcat(s, "m");
if (crc32("wziwAYNJD",9) == 1986577394) strcat(s, "m");
if (crc32("bSRDEiu",7) == 3220943196) strcat(s, "o");
if (crc32("BPits",5) == 3930431309) strcat(s, "n");
if (crc32("AQRBfVKurN",10) == 1757862235) strcat(s, "l");
if (crc32("SpgOMvhGgVqRpu",14) == 1380549110) strcat(s, "i");
if (crc32("MfequGFUj",9) == 937578118) strcat(s, "X");
if (crc32("Ukgkse",6) == 3638176290) strcat(s, "s");
if (crc32("eoTSfQSlqIS",11) == 971151740) strcat(s, "t");
if (crc32("qKVqDYQgF",9) == 911670409) strcat(s, "i");
if (crc32("FIxPLg",6) == 3784032376) strcat(s, "U");
if (crc32("tehNTG",6) == 3260687628) strcat(s, "c");
if (crc32("JBHEID",6) == 1170853308) strcat(s, "a");
if (crc32("wHNJhkMMQJHR",12) == 2787138411) strcat(s, "l");
if (crc32("RfRMWzTHBFEGs",13) == 1817503714) strcat(s, "A");
if (crc32("sCESEDgPTYKc",12) == 1208491518) strcat(s, "l");
if (crc32("gecKzCL",7) == 1193475919) strcat(s, "H");
if (crc32("nLqCQSlSYeKmt",13) == 1051381296) strcat(s, "y");
    return s;
}

char *noncensurably_adverbs() {
    char *s = calloc(14);
    if (crc32("CDepYnGw",8) == 1980563085) strcat(s, "v");
if (crc32("mwxqyILcwiZAPw",14) == 2949088571) strcat(s, "n");
if (crc32("IYVxNFrxy",9) == 2333773314) strcat(s, "L");
if (crc32("rAYQBWkBiJodFh",14) == 2219023581) strcat(s, "o");
if (crc32("GVPyU",5) == 1272408654) strcat(s, "n");
if (crc32("EKRhwdtSo",9) == 3066238893) strcat(s, "c");
if (crc32("VrqymXq",7) == 1550403541) strcat(s, "e");
if (crc32("jvCXgVbfgyh",11) == 3608459943) strcat(s, "m");
if (crc32("ZyKKpSLN",8) == 1524984451) strcat(s, "n");
if (crc32("wabtgXenZ",9) == 3852574938) strcat(s, "k");
if (crc32("GDAmYZndiLBJs",13) == 1756322520) strcat(s, "s");
if (crc32("LudXJTf",7) == 2244035807) strcat(s, "V");
if (crc32("OeWudkilONNymq",14) == 1495486157) strcat(s, "u");
if (crc32("XnDYbAoSZ",9) == 3906890761) strcat(s, "r");
if (crc32("luCpFKvYfQZ",11) == 934224931) strcat(s, "t");
if (crc32("aORkLYVqV",9) == 2093894939) strcat(s, "a");
if (crc32("niBaolV",7) == 387473089) strcat(s, "i");
if (crc32("NYsoFrAcLEBLsl",14) == 3085181200) strcat(s, "b");
if (crc32("ykdAGD",6) == 2023251998) strcat(s, "l");
if (crc32("dZURrX",6) == 1663859002) strcat(s, "D");
if (crc32("PRpboaDiMG",10) == 363623006) strcat(s, "y");
    return s;
}

char *dejectedly_adverbs() {
    char *s = calloc(11);
    if (crc32("bdGhoor",7) == 428113710) strcat(s, "d");
if (crc32("YjlLG",5) == 1501411845) strcat(s, "h");
if (crc32("yjaHmMbhjmL",11) == 938712173) strcat(s, "e");
if (crc32("JHrIZQAwwVihLom",15) == 3981483592) strcat(s, "j");
if (crc32("yXgjZpIjGqUgj",13) == 1348769581) strcat(s, "e");
if (crc32("dHlUOhVIne",10) == 2829234045) strcat(s, "c");
if (crc32("mhxavruwu",9) == 4052432545) strcat(s, "t");
if (crc32("wbedgfgq",8) == 201363882) strcat(s, "e");
if (crc32("VNuQFlVaA",9) == 295388387) strcat(s, "d");
if (crc32("QyPuAqAVNRsi",12) == 808900291) strcat(s, "H");
if (crc32("CAJvDp",6) == 1029242654) strcat(s, "l");
if (crc32("XdeYcHfoL",9) == 1734320921) strcat(s, "m");
if (crc32("QBmmjHRdEUwKf",13) == 642889353) strcat(s, "y");
    return s;
}

char *superurgently_adverbs() {
    char *s = calloc(14);
    if (crc32("FSMFGcMtTLy",11) == 2451874556) strcat(s, "s");
if (crc32("YAHLiKqNAkbfhTY",15) == 42839087) strcat(s, "c");
if (crc32("cUxNOCwKngIA",12) == 3563398995) strcat(s, "u");
if (crc32("JJJLujLXpfuWXA",14) == 2099036868) strcat(s, "t");
if (crc32("PJDsabOD",8) == 878546326) strcat(s, "p");
if (crc32("FfmcB",5) == 2580656768) strcat(s, "e");
if (crc32("DlBxmbyogpz",11) == 75601032) strcat(s, "w");
if (crc32("bmZkoqfGzBV",11) == 2580238865) strcat(s, "r");
if (crc32("ZOlaTuUZVw",10) == 4282855265) strcat(s, "u");
if (crc32("QhNTropMeyXGo",13) == 2317651230) strcat(s, "K");
if (crc32("BygENfUHZqmYvru",15) == 1305154363) strcat(s, "r");
if (crc32("WLjdWaPmYmlTY",13) == 3367788517) strcat(s, "g");
if (crc32("uGAOLtCXyOqQuD",14) == 412329737) strcat(s, "u");
if (crc32("LvseOfGYWeV",11) == 3740196964) strcat(s, "e");
if (crc32("tmRHeMUa",8) == 123680303) strcat(s, "n");
if (crc32("HOwhgO",6) == 4103685606) strcat(s, "t");
if (crc32("PcQpwDiJvccq",12) == 1855153815) strcat(s, "l");
if (crc32("JCnDcDTLdlEg",12) == 3977680104) strcat(s, "y");
    return s;
}

char *innocently_adverbs() {
    char *s = calloc(11);
    if (crc32("plOQmMFOnPRTj",13) == 2815938363) strcat(s, "F");
if (crc32("pthpgGXRiF",10) == 3804841585) strcat(s, "i");
if (crc32("nMEQfkw",7) == 313765867) strcat(s, "n");
if (crc32("AvLHj",5) == 27410507) strcat(s, "n");
if (crc32("FYyWvhIzAkKE",12) == 2153100324) strcat(s, "o");
if (crc32("teekXMXP",8) == 1302283394) strcat(s, "c");
if (crc32("OGHiGV",6) == 1297005728) strcat(s, "u");
if (crc32("ohtsdsbmbpDf",12) == 2771253367) strcat(s, "e");
if (crc32("eQtZuZjoBtPcD",13) == 1723754067) strcat(s, "n");
if (crc32("DhJGvOC",7) == 357004365) strcat(s, "t");
if (crc32("HpIrNewplw",10) == 315709267) strcat(s, "l");
if (crc32("DKpIZVzy",8) == 3769688100) strcat(s, "y");
    return s;
}

char *antireligiously_adverbs() {
    char *s = calloc(16);
    if (crc32("pxsHeWU",7) == 3780731017) strcat(s, "f");
if (crc32("EyeniLB",7) == 2923524542) strcat(s, "a");
if (crc32("bCqkSmTg",8) == 941956071) strcat(s, "n");
if (crc32("nrYuZFVv",8) == 1591107426) strcat(s, "E");
if (crc32("JlyALtxFHpMA",12) == 544242948) strcat(s, "t");
if (crc32("xaoZJdPTVXmtqNA",15) == 2988917513) strcat(s, "t");
if (crc32("OVCRvW",6) == 2456564827) strcat(s, "i");
if (crc32("JxtLbywTXtWu",12) == 2587504660) strcat(s, "r");
if (crc32("GaljbwpdY",9) == 1596991664) strcat(s, "f");
if (crc32("LSzozxewFtKeqLf",15) == 2838880868) strcat(s, "e");
if (crc32("pCYxHXO",7) == 705410146) strcat(s, "P");
if (crc32("DvsPa",5) == 4089195591) strcat(s, "l");
if (crc32("lHPcKOFZh",9) == 2155605762) strcat(s, "E");
if (crc32("XkxZPvlAIj",10) == 2567390129) strcat(s, "i");
if (crc32("skWvNivmBRX",11) == 1132338056) strcat(s, "g");
if (crc32("jzRnQEHOz",9) == 2220973468) strcat(s, "i");
if (crc32("jFrEdMdrvWKf",12) == 617148675) strcat(s, "X");
if (crc32("GVdIhpo",7) == 4165936894) strcat(s, "o");
if (crc32("JALZpmfo",8) == 1433348019) strcat(s, "v");
if (crc32("QuweSnmPkTh",11) == 2639169970) strcat(s, "u");
if (crc32("QyXLMvyThFbX",12) == 4240647926) strcat(s, "X");
if (crc32("WpFdmJY",7) == 1273355927) strcat(s, "s");
if (crc32("CSkxXPwiJgO",11) == 2097965290) strcat(s, "V");
if (crc32("LJqWSGevq",9) == 1416469190) strcat(s, "l");
if (crc32("BnfcgTGNjhw",11) == 897819244) strcat(s, "y");
    return s;
}

char *dialogistically_adverbs() {
    char *s = calloc(16);
    if (crc32("tWoMxXzR",8) == 4148038479) strcat(s, "h");
if (crc32("cXrHCLoJId",10) == 3902990940) strcat(s, "d");
if (crc32("WLCJZEfRV",9) == 2432106387) strcat(s, "T");
if (crc32("YAOSaCM",7) == 1980909051) strcat(s, "i");
if (crc32("uylqmBFVkIN",11) == 2050713118) strcat(s, "m");
if (crc32("KUzabNcpOwUHoP",14) == 1532947309) strcat(s, "a");
if (crc32("mWFMhWJRxOo",11) == 2659512756) strcat(s, "l");
if (crc32("FtVVWLSzk",9) == 418090308) strcat(s, "U");
if (crc32("HkJWCAVCg",9) == 2742729946) strcat(s, "o");
if (crc32("IxTOMEZxSYWz",12) == 482998755) strcat(s, "g");
if (crc32("jhNNbHY",7) == 2873211863) strcat(s, "i");
if (crc32("pKjsnwHUYH",10) == 2332747570) strcat(s, "s");
if (crc32("hksnu",5) == 249671168) strcat(s, "t");
if (crc32("FBsqtnuGH",9) == 871761596) strcat(s, "T");
if (crc32("tmColx",6) == 493878243) strcat(s, "i");
if (crc32("gsgGs",5) == 1445701307) strcat(s, "L");
if (crc32("QAWGmzskWobGw",13) == 2705231758) strcat(s, "c");
if (crc32("CFgodwyLZlWXAJ",14) == 2959576859) strcat(s, "T");
if (crc32("tQRMV",5) == 287762050) strcat(s, "a");
if (crc32("lvkIOx",6) == 37033828) strcat(s, "l");
if (crc32("IirXFyJ",7) == 577406338) strcat(s, "z");
if (crc32("UYjOgULZynS",11) == 1732383338) strcat(s, "l");
if (crc32("DiYQC",5) == 40359965) strcat(s, "y");
    return s;
}

char *vixenishly_adverbs() {
    char *s = calloc(11);
    if (crc32("crceUjSS",8) == 735056259) strcat(s, "n");
if (crc32("HqrjdOGNTzVmxGN",15) == 3285636613) strcat(s, "v");
if (crc32("qmeIop",6) == 3519904529) strcat(s, "i");
if (crc32("lIgWEWuONkTIZZ",14) == 2124984206) strcat(s, "e");
if (crc32("SeZpOfkoDPmuG",13) == 2627745471) strcat(s, "x");
if (crc32("aEabtuxPPwEOUGp",15) == 2400451220) strcat(s, "J");
if (crc32("qRZBvjzEaDG",11) == 1774781115) strcat(s, "e");
if (crc32("nlAPYGc",7) == 352895101) strcat(s, "q");
if (crc32("yFxnpkNlQ",9) == 39268322) strcat(s, "n");
if (crc32("LUYgJcuUtvRmelJ",15) == 59017338) strcat(s, "G");
if (crc32("dFekQSFZFmuO",12) == 3989578416) strcat(s, "i");
if (crc32("hQnNkYTOlG",10) == 2962464327) strcat(s, "K");
if (crc32("jEVKXDmgxdRg",12) == 3851661852) strcat(s, "s");
if (crc32("wHzVXbwXKbqitzh",15) == 2048910113) strcat(s, "G");
if (crc32("NIabZ",5) == 1386026586) strcat(s, "h");
if (crc32("OCQlR",5) == 1875131776) strcat(s, "p");
if (crc32("eizfD",5) == 3400405895) strcat(s, "l");
if (crc32("IancEoQijC",10) == 3045410086) strcat(s, "y");
    return s;
}

char *hyperpathetically_adverbs() {
    char *s = calloc(18);
    if (crc32("wcIAxBLDmRNfC",13) == 3660788332) strcat(s, "h");
if (crc32("ZLMMyzJnLnpowl",14) == 4008919323) strcat(s, "y");
if (crc32("rluSnLEVVsRQSlZ",15) == 1655344266) strcat(s, "p");
if (crc32("stpBLjNiMeaBsiQ",15) == 741496985) strcat(s, "a");
if (crc32("dbXEyRYriNG",11) == 4222095426) strcat(s, "e");
if (crc32("TZSXpp",6) == 2421418918) strcat(s, "r");
if (crc32("zuuDylWxHeZAU",13) == 107351968) strcat(s, "p");
if (crc32("pmhiQOjiNK",10) == 437217185) strcat(s, "L");
if (crc32("LyLOLlw",7) == 305649097) strcat(s, "a");
if (crc32("LTaHZf",6) == 492650258) strcat(s, "t");
if (crc32("MMblQQHwvkLDd",13) == 1976693944) strcat(s, "j");
if (crc32("GtmqFRknSxT",11) == 270317238) strcat(s, "h");
if (crc32("GPLSu",5) == 86647041) strcat(s, "s");
if (crc32("cubhySYyZq",10) == 2417293898) strcat(s, "e");
if (crc32("KRgYQCdGKhvsCD",14) == 4090106080) strcat(s, "t");
if (crc32("xRPTrBIX",8) == 2480555784) strcat(s, "K");
if (crc32("JLGfUiZYjoc",11) == 2663372519) strcat(s, "i");
if (crc32("WfpPmGpoOc",10) == 3454640698) strcat(s, "c");
if (crc32("CHlQHMD",7) == 2191710588) strcat(s, "s");
if (crc32("jsWtKG",6) == 1489543914) strcat(s, "a");
if (crc32("UTFOlN",6) == 3179795660) strcat(s, "l");
if (crc32("DNtXSo",6) == 144782700) strcat(s, "l");
if (crc32("ZnnACDZyIuxy",12) == 2640597146) strcat(s, "y");
    return s;
}

char *counterattractively_adverbs() {
    char *s = calloc(20);
    if (crc32("CadLF",5) == 3594961586) strcat(s, "c");
if (crc32("gjZKk",5) == 3488862683) strcat(s, "n");
if (crc32("rcKSLXC",7) == 2052528462) strcat(s, "o");
if (crc32("IWuAztiCYy",10) == 1097024935) strcat(s, "u");
if (crc32("odoNqYficD",10) == 1279380819) strcat(s, "n");
if (crc32("uHckkEa",7) == 3220252966) strcat(s, "Y");
if (crc32("QONYJG",6) == 1446771940) strcat(s, "t");
if (crc32("kqIQnLvU",8) == 63845580) strcat(s, "g");
if (crc32("WWGqTPRTReFxkXX",15) == 3309045358) strcat(s, "e");
if (crc32("BRyEmr",6) == 2846209399) strcat(s, "g");
if (crc32("LuKHlhhK",8) == 3544364532) strcat(s, "r");
if (crc32("CWJdjbQLgpUZfcY",15) == 2994322767) strcat(s, "G");
if (crc32("JbpDpsBnjBjXcUK",15) == 2489515902) strcat(s, "a");
if (crc32("vaLuoMLOhSmHBB",14) == 550138679) strcat(s, "U");
if (crc32("AmPpbmmqeG",10) == 3460512307) strcat(s, "t");
if (crc32("qNERYNnr",8) == 2245980652) strcat(s, "t");
if (crc32("oVohQFodl",9) == 1027348795) strcat(s, "b");
if (crc32("hjvtczkkDxPoyh",14) == 3960162321) strcat(s, "r");
if (crc32("LLAcaIazZc",10) == 3634099547) strcat(s, "a");
if (crc32("GXCZmNFVP",9) == 309320971) strcat(s, "r");
if (crc32("PpBIRABSI",9) == 1329329730) strcat(s, "c");
if (crc32("cmXEp",5) == 4043731224) strcat(s, "n");
if (crc32("SVqshZcSgzIhMA",14) == 3502462903) strcat(s, "t");
if (crc32("YeguplLUKdbPNU",14) == 1061377591) strcat(s, "g");
if (crc32("xiImjSuhQmC",11) == 63943984) strcat(s, "i");
if (crc32("wBykRTKpF",9) == 3359895151) strcat(s, "v");
if (crc32("ukPoeGsbBaQC",12) == 330322627) strcat(s, "K");
if (crc32("goBSmTAczqbi",12) == 2169877988) strcat(s, "e");
if (crc32("texaBwWUDVbsB",13) == 3343569205) strcat(s, "l");
if (crc32("bTqTQ",5) == 43189712) strcat(s, "n");
if (crc32("rqQjemjARTxj",12) == 3979695801) strcat(s, "y");
    return s;
}

char *interacademically_adverbs() {
    char *s = calloc(18);
    if (crc32("yeYRTTOcyCuZD",13) == 2226649734) strcat(s, "u");
if (crc32("uktoBuhNiPasuJM",15) == 3677834153) strcat(s, "i");
if (crc32("taVlVmWHwvXCYF",14) == 1797688044) strcat(s, "K");
if (crc32("YREwsy",6) == 137318720) strcat(s, "n");
if (crc32("WKffEWQfE",9) == 3434585645) strcat(s, "Y");
if (crc32("tjaBryuLINm",11) == 1451329603) strcat(s, "t");
if (crc32("QRDDldTEoBkOtOK",15) == 1936239291) strcat(s, "e");
if (crc32("hksXiYgyCCSgmu",14) == 1438977383) strcat(s, "r");
if (crc32("DiSYZbhtfJAMsP",14) == 1999224054) strcat(s, "r");
if (crc32("fZYxWl",6) == 1104463548) strcat(s, "w");
if (crc32("TkDMbSsnzqo",11) == 4210459064) strcat(s, "a");
if (crc32("gngeCmrmp",9) == 3094668276) strcat(s, "g");
if (crc32("BSqXzXJg",8) == 1809309497) strcat(s, "c");
if (crc32("xznFGgoJFyLR",12) == 4106306858) strcat(s, "l");
if (crc32("jbYQyDvIzcQt",12) == 2688054988) strcat(s, "a");
if (crc32("KXgTMgSlafrigb",14) == 1589867062) strcat(s, "X");
if (crc32("iQaEA",5) == 3832668599) strcat(s, "d");
if (crc32("wcVcFxcVWnW",11) == 2576332082) strcat(s, "x");
if (crc32("APvKOldUXvr",11) == 3402547371) strcat(s, "e");
if (crc32("iEhMNLLJ",8) == 1987487071) strcat(s, "U");
if (crc32("RBPAbIRTsJlID",13) == 2402484017) strcat(s, "m");
if (crc32("jhqpPDPcIw",10) == 595973856) strcat(s, "L");
if (crc32("CcQhWs",6) == 4011838902) strcat(s, "i");
if (crc32("WmJYJWnJIN",10) == 698731481) strcat(s, "c");
if (crc32("mYeYhrhxkHUEq",13) == 3792442962) strcat(s, "X");
if (crc32("sLoSIzCk",8) == 4228448420) strcat(s, "a");
if (crc32("nrJhFNwStrOr",12) == 3747123535) strcat(s, "w");
if (crc32("VtKtE",5) == 2751893873) strcat(s, "l");
if (crc32("VAWYvRScikBDbb",14) == 4193558662) strcat(s, "K");
if (crc32("tWcgxLp",7) == 3129514483) strcat(s, "l");
if (crc32("uGZbKkuJpgRo",12) == 589408092) strcat(s, "y");
    return s;
}

char *ambitionlessly_adverbs() {
    char *s = calloc(15);
    if (crc32("NgHDgQ",6) == 583406129) strcat(s, "f");
if (crc32("xHCGQlUXXIAjmJ",14) == 595347138) strcat(s, "a");
if (crc32("aYCOhv",6) == 1489912420) strcat(s, "G");
if (crc32("chGxcDaMxeWVIx",14) == 49508833) strcat(s, "m");
if (crc32("MPYgzVFFBz",10) == 1543071852) strcat(s, "b");
if (crc32("izsRxFYG",8) == 397672871) strcat(s, "n");
if (crc32("oanWSNmhTxpMDbV",15) == 2707105215) strcat(s, "i");
if (crc32("hrZHb",5) == 1415695769) strcat(s, "t");
if (crc32("aXxrSY",6) == 3799869906) strcat(s, "f");
if (crc32("vqzpAbqOXNsV",12) == 2409787132) strcat(s, "i");
if (crc32("wyainXsgoRAV",12) == 1952828598) strcat(s, "o");
if (crc32("ZapfEztJxn",10) == 2061099154) strcat(s, "n");
if (crc32("smqErg",6) == 920324717) strcat(s, "l");
if (crc32("cVcftTnzrniG",12) == 1439057852) strcat(s, "G");
if (crc32("cOIFNVQTxkzT",12) == 2332218737) strcat(s, "e");
if (crc32("gcJzT",5) == 1312378874) strcat(s, "v");
if (crc32("Vffvlkag",8) == 745564088) strcat(s, "s");
if (crc32("FnLXf",5) == 1700511057) strcat(s, "s");
if (crc32("JQKMckZBBOpDoNg",15) == 1724342166) strcat(s, "l");
if (crc32("FqkDkGo",7) == 905691246) strcat(s, "l");
if (crc32("CpVgByfJx",9) == 3567539391) strcat(s, "y");
    return s;
}

char *prohibitively_adverbs() {
    char *s = calloc(14);
    if (crc32("cWnENLLjutaPDW",14) == 2750215997) strcat(s, "U");
if (crc32("waiQrnCgXlp",11) == 3770562017) strcat(s, "p");
if (crc32("DRunq",5) == 1739049551) strcat(s, "o");
if (crc32("QXZgA",5) == 2275676459) strcat(s, "r");
if (crc32("nBQOiUrCk",9) == 765475598) strcat(s, "q");
if (crc32("CekwxSq",7) == 1154123487) strcat(s, "o");
if (crc32("pbZpVfbnBPsO",12) == 3702383407) strcat(s, "d");
if (crc32("JsKCK",5) == 3950927480) strcat(s, "h");
if (crc32("McnoVsOLBQbEi",13) == 3265827960) strcat(s, "i");
if (crc32("BCtwmkNVelW",11) == 3576978031) strcat(s, "x");
if (crc32("SzoNYYygyZt",11) == 1469999689) strcat(s, "b");
if (crc32("EYmFvbwyrGxlru",14) == 109886011) strcat(s, "W");
if (crc32("pECnSxr",7) == 3710666020) strcat(s, "i");
if (crc32("FTdZbDjwiggrX",13) == 577730156) strcat(s, "P");
if (crc32("XMiPQYf",7) == 3278445941) strcat(s, "t");
if (crc32("KSewbYJVUvI",11) == 3321203535) strcat(s, "N");
if (crc32("lsdSKjYpmaF",11) == 3826796972) strcat(s, "i");
if (crc32("GjfJK",5) == 2014888305) strcat(s, "l");
if (crc32("wLHZuAT",7) == 3612624528) strcat(s, "v");
if (crc32("jUIAOwaWfWdfzyj",15) == 77888883) strcat(s, "e");
if (crc32("fxjxO",5) == 4043912442) strcat(s, "Q");
if (crc32("YYmyssekouldA",13) == 3891119744) strcat(s, "l");
if (crc32("dpOGcnpEzmUiUcR",15) == 1465110097) strcat(s, "y");
    return s;
}

char *perdiem_adverbs() {
    char *s = calloc(8);
    if (crc32("xyHhaKcSFAnLAp",14) == 1762919762) strcat(s, "M");
if (crc32("GSDnCJWDgRzd",12) == 1893070463) strcat(s, "p");
if (crc32("HyfUWTESpooY",12) == 1648922142) strcat(s, "c");
if (crc32("yuwHeimZbefxWbp",15) == 3484859764) strcat(s, "e");
if (crc32("SwRpTs",6) == 1376055434) strcat(s, "r");
if (crc32("UYOpPkobMYksYj",14) == 3360854382) strcat(s, "d");
if (crc32("gdNsGFwdx",9) == 450708852) strcat(s, "P");
if (crc32("fPGaMvH",7) == 1777185576) strcat(s, "i");
if (crc32("lZpyyToRC",9) == 1501379133) strcat(s, "p");
if (crc32("WZWWHrBTFsGb",12) == 505189290) strcat(s, "e");
if (crc32("FeetkfOKOKBC",12) == 962703580) strcat(s, "m");
    return s;
}

char *irritably_adverbs() {
    char *s = calloc(10);
    if (crc32("coFPiMgsB",9) == 2043252095) strcat(s, "p");
if (crc32("ChwgJRSoxMISGa",14) == 2830918568) strcat(s, "i");
if (crc32("PmeYwweZLmWurw",14) == 1562690488) strcat(s, "r");
if (crc32("GAtMfJU",7) == 818481658) strcat(s, "B");
if (crc32("nRFzORO",7) == 3250193665) strcat(s, "r");
if (crc32("IxmJhkAaKWKRf",13) == 1735826471) strcat(s, "i");
if (crc32("sEoLstcKCuVWQi",14) == 1635735030) strcat(s, "t");
if (crc32("kEdsrdhoMtqgaX",14) == 1696108369) strcat(s, "v");
if (crc32("Vdwccmqd",8) == 1413517394) strcat(s, "a");
if (crc32("uQNRpirqj",9) == 3809075773) strcat(s, "b");
if (crc32("hFjmtl",6) == 2568314856) strcat(s, "l");
if (crc32("bVutEAUBphZGeH",14) == 4233676073) strcat(s, "F");
if (crc32("YbIZQT",6) == 824220056) strcat(s, "y");
    return s;
}

char *secularly_adverbs() {
    char *s = calloc(10);
    if (crc32("AslSzjbEW",9) == 2965169149) strcat(s, "o");
if (crc32("gsegfUwIfPP",11) == 1200427332) strcat(s, "s");
if (crc32("eeTgw",5) == 341874562) strcat(s, "e");
if (crc32("pAPdmIJEIbcH",12) == 3489093016) strcat(s, "c");
if (crc32("dOfoCvgRjXIDJ",13) == 962559342) strcat(s, "u");
if (crc32("aFrazpRc",8) == 1892542914) strcat(s, "V");
if (crc32("JTlAaynajk",10) == 3227541703) strcat(s, "l");
if (crc32("RGVLacpyV",9) == 78641166) strcat(s, "a");
if (crc32("pvsjpIAE",8) == 3814614755) strcat(s, "r");
if (crc32("cspydkiu",8) == 2108697648) strcat(s, "l");
if (crc32("StstWnEUcJW",11) == 2567555146) strcat(s, "y");
    return s;
}

char *insociably_adverbs() {
    char *s = calloc(11);
    if (crc32("uHVvBZO",7) == 3961118121) strcat(s, "i");
if (crc32("ryHqvdJHlMObqVx",15) == 3074494032) strcat(s, "x");
if (crc32("WPfoSFfebXMX",12) == 3024198296) strcat(s, "n");
if (crc32("lbpME",5) == 973880148) strcat(s, "K");
if (crc32("SjjkkImNkuy",11) == 2353960452) strcat(s, "s");
if (crc32("lRMVAFTGMkrC",12) == 2085868568) strcat(s, "o");
if (crc32("GOgQO",5) == 352421852) strcat(s, "b");
if (crc32("sqFLUFFEMr",10) == 3447130147) strcat(s, "c");
if (crc32("TZfChsmdAms",11) == 229853237) strcat(s, "i");
if (crc32("rPSfQsjX",8) == 2687511587) strcat(s, "X");
if (crc32("xSwlpU",6) == 2853957112) strcat(s, "a");
if (crc32("judxWUyXt",9) == 1538702039) strcat(s, "b");
if (crc32("CBNxqVzUxgopx",13) == 2402825898) strcat(s, "l");
if (crc32("GFbwlm",6) == 2577103532) strcat(s, "r");
if (crc32("ZCjMkIhBJ",9) == 538664491) strcat(s, "y");
    return s;
}

char *bonnily_adverbs() {
    char *s = calloc(8);
    if (crc32("vvaSX",5) == 1138191220) strcat(s, "b");
if (crc32("NfKZIhUU",8) == 1597940275) strcat(s, "d");
if (crc32("gNJfi",5) == 3963580037) strcat(s, "o");
if (crc32("uBTZPKEXPTMYQ",13) == 2445711622) strcat(s, "n");
if (crc32("cxthfjQMAQgvf",13) == 3438805895) strcat(s, "n");
if (crc32("CvJoL",5) == 1999067137) strcat(s, "i");
if (crc32("ajSmafYGjCAveC",14) == 3427690126) strcat(s, "l");
if (crc32("puBlrLH",7) == 4053503210) strcat(s, "a");
if (crc32("jRLwEnys",8) == 2052702544) strcat(s, "y");
    return s;
}

char *meretriciously_adverbs() {
    char *s = calloc(15);
    if (crc32("eZIDFWakQUZvggR",15) == 4275100322) strcat(s, "m");
if (crc32("hArWhp",6) == 1695718876) strcat(s, "e");
if (crc32("VOssFEwwvwAs",12) == 2732808804) strcat(s, "r");
if (crc32("mAOxPuCnFPijqd",14) == 1840093947) strcat(s, "e");
if (crc32("CNsaMU",6) == 1661716914) strcat(s, "E");
if (crc32("nkELQbZSNcfUlO",14) == 1226608516) strcat(s, "t");
if (crc32("oVFBokGYA",9) == 2078529406) strcat(s, "r");
if (crc32("jhGiJnjCeIE",11) == 2249033216) strcat(s, "Q");
if (crc32("bYovG",5) == 1099109702) strcat(s, "i");
if (crc32("YxAXf",5) == 4198573586) strcat(s, "c");
if (crc32("gtukChUmDG",10) == 2550777787) strcat(s, "Y");
if (crc32("eazDIRqAVZStY",13) == 3948409170) strcat(s, "i");
if (crc32("xYnlsngfWOIVD",13) == 485565852) strcat(s, "d");
if (crc32("FpXboTEffMrzJ",13) == 3501318973) strcat(s, "o");
if (crc32("QxjMqbOWe",9) == 3045807776) strcat(s, "M");
if (crc32("QhzVuoTgbD",10) == 1081229947) strcat(s, "u");
if (crc32("DBighsYBUWYtZy",14) == 744426122) strcat(s, "r");
if (crc32("ZTACOFjVAKS",11) == 3917701680) strcat(s, "s");
if (crc32("ARkkWlth",8) == 2812480646) strcat(s, "l");
if (crc32("yqGlT",5) == 4157824323) strcat(s, "n");
if (crc32("waDOpriGuXdFKzP",15) == 4121792828) strcat(s, "y");
    return s;
}

char *unintuitively_adverbs() {
    char *s = calloc(14);
    if (crc32("YOHjrtGtDepe",12) == 2068263739) strcat(s, "u");
if (crc32("WFTiVc",6) == 2896009663) strcat(s, "X");
if (crc32("GWWhwLIZYdelAtd",15) == 249456868) strcat(s, "n");
if (crc32("qNWBriapm",9) == 154247579) strcat(s, "i");
if (crc32("GysQhZyoktk",11) == 2574283649) strcat(s, "n");
if (crc32("tOLpOlUO",8) == 3710312564) strcat(s, "t");
if (crc32("BkhyqzbRtktn",12) == 616759360) strcat(s, "u");
if (crc32("vGRKMNkbTUN",11) == 2071709525) strcat(s, "i");
if (crc32("TMbuJRfQgcN",11) == 139674939) strcat(s, "t");
if (crc32("akAHmCdnipGKM",13) == 1287869512) strcat(s, "e");
if (crc32("nwODz",5) == 1238073034) strcat(s, "i");
if (crc32("KPsrL",5) == 383275297) strcat(s, "v");
if (crc32("iPPSxtvBFm",10) == 3094912125) strcat(s, "e");
if (crc32("zuLOPFHxKunHJ",13) == 1301717943) strcat(s, "Q");
if (crc32("ntXDEt",6) == 740459954) strcat(s, "l");
if (crc32("JESmxnzTpB",10) == 1075796777) strcat(s, "R");
if (crc32("uujGOXonCVNPkLU",15) == 3589170097) strcat(s, "y");
    return s;
}

char *halfinsinuatingly_adverbs() {
    char *s = calloc(18);
    if (crc32("swiqbS",6) == 3241300374) strcat(s, "h");
if (crc32("SqKXlPesEd",10) == 3473627482) strcat(s, "q");
if (crc32("feOsjGWNdLohnb",14) == 3616212350) strcat(s, "a");
if (crc32("FHyZFeFbTLzMOYA",15) == 4094845606) strcat(s, "l");
if (crc32("qSBndvO",7) == 1954223148) strcat(s, "f");
if (crc32("YKgTQrucMOJ",11) == 2434265240) strcat(s, "w");
if (crc32("KBXaVlRbEuAw",12) == 4056149898) strcat(s, "i");
if (crc32("rWOZDctSIIZs",12) == 2188038757) strcat(s, "n");
if (crc32("qZRcUMlCiD",10) == 2954764176) strcat(s, "v");
if (crc32("JdvnKQnxNy",10) == 2097122823) strcat(s, "s");
if (crc32("qUVDGQgdK",9) == 1923600705) strcat(s, "B");
if (crc32("jcCONVpz",8) == 1093476064) strcat(s, "i");
if (crc32("hZgBmpaNG",9) == 203359711) strcat(s, "n");
if (crc32("FcawkKs",7) == 1370261534) strcat(s, "U");
if (crc32("IxmBqrzkXxEY",12) == 3526830267) strcat(s, "u");
if (crc32("pByPRLXtTNaf",12) == 936282374) strcat(s, "a");
if (crc32("SYHfbeWi",8) == 1139044147) strcat(s, "y");
if (crc32("pEbHRP",6) == 649328265) strcat(s, "t");
if (crc32("jnbAxLBUyp",10) == 1320979064) strcat(s, "i");
if (crc32("gHLcMBgMyXFrLtN",15) == 3215394518) strcat(s, "s");
if (crc32("SvLSQCRxMUM",11) == 3310813078) strcat(s, "n");
if (crc32("uRptRNFIDP",10) == 3439734603) strcat(s, "s");
if (crc32("WjfpywTcLtluK",13) == 3749368346) strcat(s, "g");
if (crc32("ontubMdKxY",10) == 419964713) strcat(s, "l");
if (crc32("krYGLVQugYvwEWW",15) == 3437078753) strcat(s, "k");
if (crc32("UBzIsqfRRimio",13) == 2493490137) strcat(s, "y");
    return s;
}

char *bounteously_adverbs() {
    char *s = calloc(12);
    if (crc32("vrAMeXexJlKq",12) == 3490242582) strcat(s, "b");
if (crc32("ICNhHQwLYeSpm",13) == 478524495) strcat(s, "a");
if (crc32("PlIxWcFfmz",10) == 1411634029) strcat(s, "o");
if (crc32("oZgXHsHEZ",9) == 1724485132) strcat(s, "u");
if (crc32("yZnNJWFhNaGhoF",14) == 170865531) strcat(s, "d");
if (crc32("oVkgK",5) == 3155560006) strcat(s, "n");
if (crc32("VhksCPNqkuLv",12) == 1063250995) strcat(s, "Q");
if (crc32("dxzCvmHoGg",10) == 4120036315) strcat(s, "t");
if (crc32("KXBusMorhk",10) == 3137445257) strcat(s, "I");
if (crc32("cMbYwQKlbB",10) == 59844372) strcat(s, "e");
if (crc32("SxDEDPc",7) == 1948008540) strcat(s, "q");
if (crc32("QeKBJbNE",8) == 3040530038) strcat(s, "o");
if (crc32("zDlNSpyTM",9) == 2399527045) strcat(s, "c");
if (crc32("xWbKSkyKb",9) == 4087490723) strcat(s, "u");
if (crc32("yDwKRUwqX",9) == 3886298530) strcat(s, "s");
if (crc32("nwaMiWF",7) == 2964182075) strcat(s, "l");
if (crc32("ULcwoZZ",7) == 2360087127) strcat(s, "I");
if (crc32("JlbhYpw",7) == 2641512959) strcat(s, "y");
    return s;
}

char *sinedie_adverbs() {
    char *s = calloc(8);
    if (crc32("uqUjgiZYSYnafjw",15) == 1001232771) strcat(s, "s");
if (crc32("LpYKLwosktiu",12) == 2465900017) strcat(s, "i");
if (crc32("UgkVInZdvxf",11) == 720105588) strcat(s, "n");
if (crc32("ecuMPB",6) == 52457348) strcat(s, "R");
if (crc32("nUxYAGA",7) == 2864371095) strcat(s, "e");
if (crc32("KuXSfWTtANZ",11) == 507261213) strcat(s, "Z");
if (crc32("AWVzAYnGI",9) == 3143171090) strcat(s, "d");
if (crc32("VmbqJIaCME",10) == 2780585560) strcat(s, "w");
if (crc32("UuDpskAPCMsY",12) == 2276836230) strcat(s, "i");
if (crc32("VTJvh",5) == 1267792433) strcat(s, "f");
if (crc32("ZvJxKQkrrxdbqb",14) == 2967585583) strcat(s, "e");
    return s;
}

char *unmiraculously_adverbs() {
    char *s = calloc(15);
    if (crc32("SiiwkbJannjbc",13) == 3748483127) strcat(s, "W");
if (crc32("AkteMT",6) == 414491795) strcat(s, "u");
if (crc32("reNqw",5) == 664050643) strcat(s, "T");
if (crc32("fsotcGtrO",9) == 1981932488) strcat(s, "n");
if (crc32("JnxIQVbLW",9) == 1544167864) strcat(s, "Z");
if (crc32("oCtgFxyyuBEBauJ",15) == 1054653085) strcat(s, "m");
if (crc32("tnmNlYzvWHqIrGI",15) == 1558175062) strcat(s, "i");
if (crc32("wbYsqCG",7) == 3687446480) strcat(s, "r");
if (crc32("XLhGf",5) == 114878058) strcat(s, "m");
if (crc32("hEgMjtnjNXgw",12) == 2881196569) strcat(s, "a");
if (crc32("UoXDEkq",7) == 3731641196) strcat(s, "c");
if (crc32("cKnKNGN",7) == 1957570014) strcat(s, "h");
if (crc32("JXEHNmRz",8) == 4190830146) strcat(s, "u");
if (crc32("XzzyNhldkGF",11) == 3792911233) strcat(s, "l");
if (crc32("xcdLAIGSSt",10) == 1085096169) strcat(s, "x");
if (crc32("iSpgAuW",7) == 2154048887) strcat(s, "o");
if (crc32("EbXlDG",6) == 559222925) strcat(s, "h");
if (crc32("CHAevmzw",8) == 904450653) strcat(s, "u");
if (crc32("cSxzwI",6) == 2862027491) strcat(s, "q");
if (crc32("IkJrThzcZfDvGZR",15) == 3697898194) strcat(s, "s");
if (crc32("DtKffBX",7) == 1733313431) strcat(s, "l");
if (crc32("EHbkonFJxgszHr",14) == 1005490044) strcat(s, "L");
if (crc32("sAqfecTwtxlnWS",14) == 3885225678) strcat(s, "y");
    return s;
}

char *affectionately_adverbs() {
    char *s = calloc(15);
    if (crc32("RTyqfospku",10) == 4177016290) strcat(s, "C");
if (crc32("IHbqU",5) == 2870431605) strcat(s, "a");
if (crc32("QyHrgbcOXLOBk",13) == 2825398099) strcat(s, "f");
if (crc32("fTvhNgWckwnHn",13) == 2065514263) strcat(s, "E");
if (crc32("QzqxVJ",6) == 922431186) strcat(s, "f");
if (crc32("bxcXCxlINGVyW",13) == 3272493132) strcat(s, "i");
if (crc32("fvvrCYWDHAwWan",14) == 1496874573) strcat(s, "e");
if (crc32("kxevDytanv",10) == 2623625484) strcat(s, "I");
if (crc32("lBliqk",6) == 913649112) strcat(s, "c");
if (crc32("yMWblo",6) == 4011446256) strcat(s, "B");
if (crc32("bDjKRSWXzoGo",12) == 2059765196) strcat(s, "t");
if (crc32("FkoQpbohiW",10) == 3912914728) strcat(s, "z");
if (crc32("SbmeXa",6) == 397238096) strcat(s, "i");
if (crc32("LKjrv",5) == 4128972002) strcat(s, "o");
if (crc32("ccfUrOBXhhI",11) == 3880594678) strcat(s, "n");
if (crc32("JWwAeJXmKYSaWvm",15) == 317407340) strcat(s, "C");
if (crc32("qVSTgTdxKUpXxe",14) == 1566038485) strcat(s, "a");
if (crc32("HfSPlAW",7) == 3518553458) strcat(s, "Z");
if (crc32("fLKGYYkvC",9) == 2988910460) strcat(s, "t");
if (crc32("EAFrJXwYihcESd",14) == 121797706) strcat(s, "N");
if (crc32("jalcauYqyvK",11) == 1343185185) strcat(s, "e");
if (crc32("MtRsQXLuGoF",11) == 790642216) strcat(s, "K");
if (crc32("qijmdAIVBKv",11) == 586640677) strcat(s, "l");
if (crc32("ZJVjZElODJ",10) == 2409841381) strcat(s, "y");
    return s;
}

char *incredulously_adverbs() {
    char *s = calloc(14);
    if (crc32("sfWXNHzLfN",10) == 2457370765) strcat(s, "F");
if (crc32("gWSxwYnp",8) == 607701674) strcat(s, "i");
if (crc32("HrcgjTYQGvJC",12) == 3801723421) strcat(s, "n");
if (crc32("SYnVV",5) == 3433553277) strcat(s, "u");
if (crc32("nMqouyDsWSFMo",13) == 3245529596) strcat(s, "c");
if (crc32("yAdzaFewRxpDsi",14) == 1142751726) strcat(s, "r");
if (crc32("IJiZWvTjwntkPJ",14) == 3471662743) strcat(s, "t");
if (crc32("HKXyLuUPb",9) == 2033304654) strcat(s, "e");
if (crc32("iluqn",5) == 4060552745) strcat(s, "B");
if (crc32("SIACM",5) == 4260139949) strcat(s, "d");
if (crc32("DRpHOVHzILwDY",13) == 2726616038) strcat(s, "z");
if (crc32("bQUDLNJQYuyUVUF",15) == 4216275431) strcat(s, "u");
if (crc32("TkeYGwthfOdGuzf",15) == 3092777789) strcat(s, "l");
if (crc32("sPMnLCs",7) == 360973579) strcat(s, "A");
if (crc32("AmaxMpPSLCQbWs",14) == 216366474) strcat(s, "o");
if (crc32("sRaGp",5) == 3212616642) strcat(s, "u");
if (crc32("DvFggPtnoKkKAo",14) == 3485500153) strcat(s, "G");
if (crc32("LLlysXDpENVYbB",14) == 1526245970) strcat(s, "s");
if (crc32("FgwMr",5) == 486722243) strcat(s, "l");
if (crc32("PWoigZhtlNayD",13) == 1940428308) strcat(s, "q");
if (crc32("ohANMQKdimZO",12) == 841867608) strcat(s, "y");
    return s;
}

char *halfsuccessfully_adverbs() {
    char *s = calloc(17);
    if (crc32("PxeYzHDc",8) == 3088885715) strcat(s, "h");
if (crc32("beVbJ",5) == 2161846184) strcat(s, "a");
if (crc32("Dcilrk",6) == 991153453) strcat(s, "l");
if (crc32("xCnBraJ",7) == 1638018620) strcat(s, "f");
if (crc32("sXFSsTVXo",9) == 963035818) strcat(s, "s");
if (crc32("Jsdkor",6) == 410671185) strcat(s, "v");
if (crc32("lrOSUNtRoLsjh",13) == 1493227611) strcat(s, "u");
if (crc32("naWakRuh",8) == 3350626604) strcat(s, "e");
if (crc32("xjHUpZXf",8) == 4195260054) strcat(s, "c");
if (crc32("MiQbUv",6) == 3496912828) strcat(s, "c");
if (crc32("kPyKKX",6) == 3594921149) strcat(s, "a");
if (crc32("mxvTZ",5) == 203356362) strcat(s, "e");
if (crc32("ooMputBQ",8) == 3751391303) strcat(s, "A");
if (crc32("HetDbIS",7) == 840898720) strcat(s, "s");
if (crc32("lVVwVdpI",8) == 1652085336) strcat(s, "q");
if (crc32("kHmAPMNg",8) == 1088271014) strcat(s, "s");
if (crc32("FqYPh",5) == 2704797277) strcat(s, "y");
if (crc32("sRasarTP",8) == 4013822616) strcat(s, "f");
if (crc32("kycpGkjSumMO",12) == 2925933025) strcat(s, "u");
if (crc32("gEdQFvsvUxf",11) == 1777077364) strcat(s, "e");
if (crc32("xpdKSoeMNKHzBL",14) == 2700613528) strcat(s, "l");
if (crc32("BeVNXn",6) == 4002060622) strcat(s, "l");
if (crc32("nGMGrgdG",8) == 494761182) strcat(s, "y");
    return s;
}

char *unpiratically_adverbs() {
    char *s = calloc(14);
    if (crc32("YjWKbQ",6) == 2795959347) strcat(s, "u");
if (crc32("SZBovhOR",8) == 2596851844) strcat(s, "u");
if (crc32("cxBmB",5) == 2376343051) strcat(s, "n");
if (crc32("DpjZxIlezGAP",12) == 1090499337) strcat(s, "E");
if (crc32("WRyBksMyozQaGgE",15) == 523193980) strcat(s, "p");
if (crc32("Rthcnj",6) == 2495906615) strcat(s, "B");
if (crc32("rsXLwAyeOPnf",12) == 2406710710) strcat(s, "i");
if (crc32("GkyfKbtQksmtk",13) == 2557739327) strcat(s, "r");
if (crc32("EQKmUoxpkVrntZS",15) == 1551877284) strcat(s, "a");
if (crc32("TfweHfZD",8) == 3196351260) strcat(s, "Q");
if (crc32("BVIdYkMz",8) == 234521054) strcat(s, "t");
if (crc32("QeseZft",7) == 3228350726) strcat(s, "Y");
if (crc32("eAQupNwljzxmpD",14) == 837296967) strcat(s, "i");
if (crc32("OBjDRCGgyDUuBh",14) == 647304010) strcat(s, "c");
if (crc32("SlMPKBIfl",9) == 2795934908) strcat(s, "H");
if (crc32("GNYBAzPQLh",10) == 3740377958) strcat(s, "a");
if (crc32("ERDFjgvrAz",10) == 2133548182) strcat(s, "u");
if (crc32("yugcjJPAptTW",12) == 3234132622) strcat(s, "l");
if (crc32("HPDrGFxJyxXNXlS",15) == 1806873864) strcat(s, "l");
if (crc32("PCsRjBLoawqODq",14) == 3957090842) strcat(s, "g");
if (crc32("dRvzZTVEKLgmFb",14) == 3857269521) strcat(s, "y");
    return s;
}

char *pseudoinvalidly_adverbs() {
    char *s = calloc(16);
    if (crc32("pniHEqZV",8) == 2791954936) strcat(s, "w");
if (crc32("ertUfHvh",8) == 3159817317) strcat(s, "p");
if (crc32("oICUz",5) == 1050411676) strcat(s, "s");
if (crc32("KsunpcxbHUiGFJz",15) == 2021684243) strcat(s, "N");
if (crc32("pfygF",5) == 3483301143) strcat(s, "e");
if (crc32("CLZPhUY",7) == 3120855196) strcat(s, "u");
if (crc32("EEjsVAlNRuSnKY",14) == 2707325092) strcat(s, "D");
if (crc32("uoSoLWps",8) == 857104532) strcat(s, "d");
if (crc32("NqerPldJeniz",12) == 986740876) strcat(s, "m");
if (crc32("XFlwglbMrfRXE",13) == 1541584026) strcat(s, "o");
if (crc32("vZsFAK",6) == 403843356) strcat(s, "c");
if (crc32("LtieJOKuoTa",11) == 3940706557) strcat(s, "i");
if (crc32("HBbSldQzjo",10) == 1698444358) strcat(s, "n");
if (crc32("bOnlhWtJO",9) == 2148246977) strcat(s, "v");
if (crc32("OZppzR",6) == 1377085208) strcat(s, "a");
if (crc32("uQuuLSoygYWPY",13) == 3064219367) strcat(s, "m");
if (crc32("hRkbcC",6) == 298317629) strcat(s, "l");
if (crc32("zhuoaBuTxUJpNMA",15) == 2423321988) strcat(s, "I");
if (crc32("qObxjgotA",9) == 1984176294) strcat(s, "i");
if (crc32("wkKzGluiN",9) == 417472376) strcat(s, "Q");
if (crc32("laiBQaRGUaNKXlf",15) == 2058882045) strcat(s, "d");
if (crc32("SskHhu",6) == 2588903811) strcat(s, "l");
if (crc32("KfYREQhlfQmxPMq",15) == 1198765685) strcat(s, "u");
if (crc32("aQRSdpuZ",8) == 4218928373) strcat(s, "y");
    return s;
}

char *waspily_adverbs() {
    char *s = calloc(8);
    if (crc32("mjImiJ",6) == 1376773487) strcat(s, "w");
if (crc32("HEaPMckjkqqNbz",14) == 2353008926) strcat(s, "a");
if (crc32("BCiQNWH",7) == 2725206803) strcat(s, "f");
if (crc32("OvCyADkxCAfXzS",14) == 152748805) strcat(s, "s");
if (crc32("WSzGx",5) == 3974884952) strcat(s, "W");
if (crc32("tObPrlyPpHEXlu",14) == 2559574779) strcat(s, "p");
if (crc32("zBovfcQACfvn",12) == 27612896) strcat(s, "w");
if (crc32("aFCEKvmNfxJL",12) == 2397189450) strcat(s, "i");
if (crc32("wNgZCwAdGEoC",12) == 540484382) strcat(s, "l");
if (crc32("WEjelISF",8) == 3571302319) strcat(s, "y");
    return s;
}

char *urgingly_adverbs() {
    char *s = calloc(9);
    if (crc32("rLTuCiGnzplbQpc",15) == 975435609) strcat(s, "L");
if (crc32("XczpOtJEXL",10) == 2163449339) strcat(s, "u");
if (crc32("TSshgEya",8) == 2414744112) strcat(s, "K");
if (crc32("vbSOSrqg",8) == 682757965) strcat(s, "r");
if (crc32("hjJloqzNmqmcSfF",15) == 2381692100) strcat(s, "g");
if (crc32("PLwEvWQlIIPH",12) == 506505898) strcat(s, "C");
if (crc32("grsDI",5) == 3785658731) strcat(s, "i");
if (crc32("msobMkdGiAowCZv",15) == 2284184311) strcat(s, "G");
if (crc32("mOmjqguh",8) == 1952277118) strcat(s, "n");
if (crc32("KOqdae",6) == 3550347168) strcat(s, "g");
if (crc32("NpEoMDerIejrjV",14) == 3862350790) strcat(s, "l");
if (crc32("VdXpIQX",7) == 2483775925) strcat(s, "y");
    return s;
}

char *daintily_adverbs() {
    char *s = calloc(9);
    if (crc32("TEdEtrIeHHjmTrM",15) == 1701284138) strcat(s, "R");
if (crc32("TvKoAZqQwpFSOcC",15) == 4036517670) strcat(s, "d");
if (crc32("WaBiZiqNPfjndpN",15) == 3541681419) strcat(s, "a");
if (crc32("WgbsbSIGcPJduV",14) == 3080923614) strcat(s, "i");
if (crc32("VRDDbBIRNBHl",12) == 3284218608) strcat(s, "n");
if (crc32("Wqqrn",5) == 2107799155) strcat(s, "t");
if (crc32("zUdbxGQuuJVYBT",14) == 1633229940) strcat(s, "K");
if (crc32("zSqkUIgAM",9) == 3396944902) strcat(s, "i");
if (crc32("EWJRxGH",7) == 1951273894) strcat(s, "l");
if (crc32("ndBsOYXWqZ",10) == 2328787229) strcat(s, "y");
    return s;
}

char *marvelously_adverbs() {
    char *s = calloc(12);
    if (crc32("dykfavdnPyqH",12) == 1070529404) strcat(s, "L");
if (crc32("jjmFnTQJ",8) == 3992126235) strcat(s, "m");
if (crc32("PMyrbnsd",8) == 659325286) strcat(s, "a");
if (crc32("dePEynLZYweGiit",15) == 202950464) strcat(s, "a");
if (crc32("TkbBXngGz",9) == 2338707181) strcat(s, "r");
if (crc32("ZvPaLzHIcnIvo",13) == 897582337) strcat(s, "v");
if (crc32("KTApCOjAvKF",11) == 3961614017) strcat(s, "e");
if (crc32("pqSsfNCFN",9) == 3254374494) strcat(s, "l");
if (crc32("fLaOJAAcjXbeCKq",15) == 2421841090) strcat(s, "Q");
if (crc32("HzdlQaINbfi",11) == 1142167570) strcat(s, "o");
if (crc32("wEPuNTf",7) == 2412169622) strcat(s, "u");
if (crc32("GxpRzsDpWjCuDZY",15) == 3873782772) strcat(s, "y");
if (crc32("EfHzAaURH",9) == 3307279827) strcat(s, "s");
if (crc32("iOgpLcI",7) == 87150788) strcat(s, "l");
if (crc32("PqaKfxrG",8) == 186364614) strcat(s, "v");
if (crc32("OqTVhxSOJErv",12) == 496948639) strcat(s, "y");
    return s;
}

char *colossally_adverbs() {
    char *s = calloc(11);
    if (crc32("cyWCmPEJE",9) == 1409244268) strcat(s, "P");
if (crc32("eMnlcQtgNVmzzwb",15) == 1350744703) strcat(s, "c");
if (crc32("BcNFJMpW",8) == 16683295) strcat(s, "o");
if (crc32("uoQiBGdTxyGZnl",14) == 3535317192) strcat(s, "b");
if (crc32("jzLBfgy",7) == 4214375654) strcat(s, "l");
if (crc32("IQRPy",5) == 3932972773) strcat(s, "n");
if (crc32("oaJVKtl",7) == 2894585019) strcat(s, "o");
if (crc32("sVVFDrJR",8) == 3108943841) strcat(s, "R");
if (crc32("tSlcGeSyP",9) == 1339992573) strcat(s, "s");
if (crc32("SaSXSvRQ",8) == 202799188) strcat(s, "s");
if (crc32("brOsuQBWWvT",11) == 3280796241) strcat(s, "a");
if (crc32("tcUiAeioMovQkoC",15) == 780598435) strcat(s, "l");
if (crc32("FgzpZNMxRb",10) == 3417302428) strcat(s, "l");
if (crc32("FBGqKu",6) == 952533411) strcat(s, "e");
if (crc32("AEpWhiMws",9) == 2367844902) strcat(s, "l");
if (crc32("EjnLgrFgKb",10) == 231145684) strcat(s, "x");
if (crc32("PKVbwhR",7) == 2225432103) strcat(s, "y");
    return s;
}

char *irreproachably_adverbs() {
    char *s = calloc(15);
    if (crc32("LSikERCnCFTDqn",14) == 1639463113) strcat(s, "i");
if (crc32("HJNpPDUZwyXl",12) == 1503752091) strcat(s, "r");
if (crc32("qppCYIgwEO",10) == 827428440) strcat(s, "r");
if (crc32("aUGTn",5) == 2418516456) strcat(s, "d");
if (crc32("XllnjUaDXLYF",12) == 2582927854) strcat(s, "e");
if (crc32("RKrOwwukDc",10) == 2348910835) strcat(s, "E");
if (crc32("KuHbAidjD",9) == 3999674343) strcat(s, "p");
if (crc32("KMMIWdWXDsjPFA",14) == 2259204059) strcat(s, "r");
if (crc32("PHNwQgMPXg",10) == 1656392867) strcat(s, "o");
if (crc32("vIVTlMG",7) == 622662762) strcat(s, "a");
if (crc32("jowGeEeGEOZdMgk",15) == 1630524309) strcat(s, "c");
if (crc32("DcEFCXJFU",9) == 4113501662) strcat(s, "C");
if (crc32("uefOCgS",7) == 67287594) strcat(s, "h");
if (crc32("NNuTVdLQiPMA",12) == 3869288034) strcat(s, "a");
if (crc32("FhCkpCuY",8) == 1183301752) strcat(s, "t");
if (crc32("ddEYbHuV",8) == 453686585) strcat(s, "b");
if (crc32("HrjjEH",6) == 1079123443) strcat(s, "x");
if (crc32("PXakuXGUAaw",11) == 4096906287) strcat(s, "l");
if (crc32("FQYbcNpxsHCb",12) == 3709080112) strcat(s, "y");
    return s;
}

char *mutagenically_adverbs() {
    char *s = calloc(14);
    if (crc32("KcOnVXX",7) == 422339095) strcat(s, "f");
if (crc32("PPRCIRdOtqpa",12) == 173315816) strcat(s, "m");
if (crc32("BgjrMYJgspuV",12) == 3134059534) strcat(s, "u");
if (crc32("hcZXtcaQLcGtbEr",15) == 2128003100) strcat(s, "t");
if (crc32("aohKAu",6) == 939799029) strcat(s, "U");
if (crc32("fXhdhvZnmaI",11) == 900654707) strcat(s, "a");
if (crc32("twuLqt",6) == 783158067) strcat(s, "g");
if (crc32("xWGAI",5) == 4027646984) strcat(s, "q");
if (crc32("cDVcTIKAPgzjfO",14) == 2711365953) strcat(s, "e");
if (crc32("CnJOFJkMItIbGq",14) == 2320785927) strcat(s, "Z");
if (crc32("dqguOFBSSamjn",13) == 691494271) strcat(s, "n");
if (crc32("xTEwzsgCXbXbe",13) == 1913335485) strcat(s, "i");
if (crc32("ZwXVUXfNBsI",11) == 994433092) strcat(s, "c");
if (crc32("kdzktdH",7) == 65492155) strcat(s, "A");
if (crc32("cKhgKyKOR",9) == 3991391593) strcat(s, "a");
if (crc32("gPWZLWbab",9) == 1119582455) strcat(s, "U");
if (crc32("vuqqF",5) == 284761257) strcat(s, "l");
if (crc32("guYrcjHKyunz",12) == 1253080116) strcat(s, "D");
if (crc32("zWUrWd",6) == 2244719011) strcat(s, "l");
if (crc32("lRCgaWl",7) == 3514170055) strcat(s, "y");
    return s;
}

char *phantasmagorically_adverbs() {
    char *s = calloc(19);
    if (crc32("HwLjqrMgoALpe",13) == 3365035727) strcat(s, "p");
if (crc32("vkowDPZO",8) == 3925988916) strcat(s, "h");
if (crc32("DuhPFNoDYQaSqE",14) == 3085829892) strcat(s, "a");
if (crc32("LvxnQZCzBHrD",12) == 713492197) strcat(s, "O");
if (crc32("bVItWzSqhIrpS",13) == 3702306535) strcat(s, "n");
if (crc32("Vhnde",5) == 4058238916) strcat(s, "t");
if (crc32("fqsmixc",7) == 887089477) strcat(s, "y");
if (crc32("upkZswGpRC",10) == 4198730739) strcat(s, "a");
if (crc32("CVZfMpz",7) == 1132065227) strcat(s, "k");
if (crc32("yYkKlCbY",8) == 1798370336) strcat(s, "s");
if (crc32("uqWHfTUs",8) == 3384612833) strcat(s, "m");
if (crc32("ZAiXwmhEK",9) == 2999661656) strcat(s, "a");
if (crc32("NyUZKoG",7) == 2267341652) strcat(s, "g");
if (crc32("lEwkQ",5) == 1437178439) strcat(s, "f");
if (crc32("eWtRJfzyGRWSdvk",15) == 261613887) strcat(s, "o");
if (crc32("ZChgpZCjhEyrvXf",15) == 2842720185) strcat(s, "r");
if (crc32("wQDXKI",6) == 821581592) strcat(s, "p");
if (crc32("HiLbgHCjO",9) == 4100950087) strcat(s, "i");
if (crc32("MJypXHcHJ",9) == 2102618477) strcat(s, "z");
if (crc32("nrIvuWf",7) == 413738033) strcat(s, "c");
if (crc32("hubrw",5) == 2732162809) strcat(s, "e");
if (crc32("yWXuNjstnOz",11) == 4195786303) strcat(s, "a");
if (crc32("xliQsMqFBirtf",13) == 2657697003) strcat(s, "t");
if (crc32("YuhHk",5) == 197455180) strcat(s, "l");
if (crc32("tohPB",5) == 2629777977) strcat(s, "u");
if (crc32("DIlaDoa",7) == 1969544224) strcat(s, "l");
if (crc32("KrMfQSbHWmDR",12) == 2046567047) strcat(s, "y");
    return s;
}

char *intrepidly_adverbs() {
    char *s = calloc(11);
    if (crc32("KtHFOfCfC",9) == 1450265764) strcat(s, "i");
if (crc32("hyckIsNv",8) == 409582859) strcat(s, "n");
if (crc32("nWTehxPzqwu",11) == 4089660862) strcat(s, "t");
if (crc32("BLBwoM",6) == 3841596330) strcat(s, "r");
if (crc32("NPhGrLJfbIKWDYS",15) == 463752163) strcat(s, "e");
if (crc32("MdWPYGp",7) == 3871024947) strcat(s, "p");
if (crc32("YwsmAPWSOMXH",12) == 2764461948) strcat(s, "i");
if (crc32("iaVFJPb",7) == 724157138) strcat(s, "a");
if (crc32("FuPxWJx",7) == 1249583683) strcat(s, "d");
if (crc32("vCImQJVt",8) == 1029754626) strcat(s, "S");
if (crc32("pdfRKjH",7) == 248328051) strcat(s, "l");
if (crc32("oqTrHtzJ",8) == 3937975392) strcat(s, "o");
if (crc32("sgIVRepsUW",10) == 2952721881) strcat(s, "y");
    return s;
}

char *perinde_adverbs() {
    char *s = calloc(8);
    if (crc32("WnqIq",5) == 3294810999) strcat(s, "p");
if (crc32("PsqOpunFkWkrj",13) == 3741804814) strcat(s, "f");
if (crc32("hxfcBp",6) == 1515259527) strcat(s, "e");
if (crc32("xsIPWnwN",8) == 853170434) strcat(s, "r");
if (crc32("JhwHxTUiPVOl",12) == 2434883864) strcat(s, "O");
if (crc32("eNxTdBKocUVBx",13) == 849093399) strcat(s, "i");
if (crc32("uijZM",5) == 3242631035) strcat(s, "b");
if (crc32("KGrzd",5) == 666400450) strcat(s, "n");
if (crc32("QwUHIj",6) == 1052223963) strcat(s, "c");
if (crc32("cSQQy",5) == 638565318) strcat(s, "d");
if (crc32("nGoiYGmer",9) == 3602644301) strcat(s, "e");
    return s;
}

char *speedingly_adverbs() {
    char *s = calloc(11);
    if (crc32("MMxCZLIxIgY",11) == 3616338089) strcat(s, "v");
if (crc32("NkZSwu",6) == 3760822606) strcat(s, "s");
if (crc32("Yzlcip",6) == 155893955) strcat(s, "z");
if (crc32("tcrudk",6) == 3072210742) strcat(s, "p");
if (crc32("kCoREUX",7) == 861579242) strcat(s, "e");
if (crc32("yjZwkEkgGRz",11) == 3355545183) strcat(s, "H");
if (crc32("wmJjDhEQH",9) == 2384904746) strcat(s, "e");
if (crc32("cWmolIBxSACU",12) == 427838766) strcat(s, "g");
if (crc32("oceaD",5) == 3080231368) strcat(s, "d");
if (crc32("VIDWrECEFJZwuA",14) == 2440492079) strcat(s, "Y");
if (crc32("CZkGZ",5) == 231047083) strcat(s, "i");
if (crc32("oZsogDRzOa",10) == 1379431053) strcat(s, "f");
if (crc32("oCNaktFypCvf",12) == 3655352846) strcat(s, "n");
if (crc32("SemstUrfVabaQe",14) == 2978200443) strcat(s, "g");
if (crc32("TxdSmKehYsKcjK",14) == 1414821295) strcat(s, "n");
if (crc32("MfJIm",5) == 398008965) strcat(s, "l");
if (crc32("nJPlIoFlenmGLjT",15) == 1758076455) strcat(s, "v");
if (crc32("BaRvyx",6) == 3327900739) strcat(s, "y");
    return s;
}

char *stalagmitically_adverbs() {
    char *s = calloc(16);
    if (crc32("InSMnYAoHrmC",12) == 2545085001) strcat(s, "O");
if (crc32("dXpagKuRsGuTZzh",15) == 4249908154) strcat(s, "s");
if (crc32("HdQMbENZjrQLO",13) == 4222545240) strcat(s, "Z");
if (crc32("jcKfDLPZbEK",11) == 3661722531) strcat(s, "t");
if (crc32("eKnSihI",7) == 1592605867) strcat(s, "G");
if (crc32("vTkZxeBrnm",10) == 636585746) strcat(s, "a");
if (crc32("NUXpapEiezdvd",13) == 423903186) strcat(s, "C");
if (crc32("loVHbK",6) == 4089221925) strcat(s, "l");
if (crc32("KbNxahdsR",9) == 1328305978) strcat(s, "a");
if (crc32("UrSOIulOAupQujR",15) == 2965314570) strcat(s, "G");
if (crc32("QpxIzbeMyHl",11) == 1264282835) strcat(s, "g");
if (crc32("eqJiLnLhFJAAlZd",15) == 2778563559) strcat(s, "d");
if (crc32("wEXVwodj",8) == 2610929426) strcat(s, "m");
if (crc32("jmBMPKrTjnE",11) == 2259061167) strcat(s, "i");
if (crc32("XtNaXocjIAxiWsH",15) == 3627411896) strcat(s, "t");
if (crc32("qDXicQiXzi",10) == 2948473104) strcat(s, "i");
if (crc32("LvacgVgZl",9) == 729784006) strcat(s, "M");
if (crc32("YqwCiBzLRgAh",12) == 3141288815) strcat(s, "c");
if (crc32("LBhhUqFMTs",10) == 3672132100) strcat(s, "J");
if (crc32("kSQgmfgRH",9) == 2973242081) strcat(s, "a");
if (crc32("gtUlAZhwc",9) == 3683023752) strcat(s, "m");
if (crc32("xbEWjzIzeuED",12) == 267451736) strcat(s, "l");
if (crc32("DFspy",5) == 1943390374) strcat(s, "R");
if (crc32("EMkEtT",6) == 4078416050) strcat(s, "l");
if (crc32("OnKcmt",6) == 887540087) strcat(s, "h");
if (crc32("avLeNDAkQepZYbM",15) == 1112029721) strcat(s, "y");
    return s;
}

char *educationally_adverbs() {
    char *s = calloc(14);
    if (crc32("HHERpPUqiYPKAY",14) == 1992471219) strcat(s, "Y");
if (crc32("ujBnq",5) == 216650216) strcat(s, "e");
if (crc32("kMumJPJc",8) == 819269229) strcat(s, "q");
if (crc32("txGdJ",5) == 2260116489) strcat(s, "d");
if (crc32("ZQNtmYSOHRBNynC",15) == 2710896622) strcat(s, "u");
if (crc32("XxyXqAvcazGsn",13) == 691900788) strcat(s, "c");
if (crc32("CcmwcAs",7) == 2606419212) strcat(s, "a");
if (crc32("EhgnTOpZiI",10) == 2173877869) strcat(s, "t");
if (crc32("VokDWRUl",8) == 4278145427) strcat(s, "i");
if (crc32("LGOtWtAApGaSNq",14) == 504826869) strcat(s, "m");
if (crc32("gcrRcsrxm",9) == 2656462767) strcat(s, "o");
if (crc32("oCDfwdBDhdO",11) == 1694866198) strcat(s, "n");
if (crc32("dDVQgFV",7) == 4160896165) strcat(s, "M");
if (crc32("xhSiQW",6) == 937486882) strcat(s, "a");
if (crc32("CrBvbPW",7) == 3336924788) strcat(s, "l");
if (crc32("pnGcO",5) == 1941341133) strcat(s, "p");
if (crc32("PkJTO",5) == 1471120531) strcat(s, "l");
if (crc32("dBXIPndKofzg",12) == 3015511829) strcat(s, "J");
if (crc32("cSNJAym",7) == 48534915) strcat(s, "y");
    return s;
}

char *savagely_adverbs() {
    char *s = calloc(9);
    if (crc32("vhpgFSrejogGGgy",15) == 222954638) strcat(s, "s");
if (crc32("UoMKqY",6) == 1271027209) strcat(s, "J");
if (crc32("qhVvHjq",7) == 206197250) strcat(s, "a");
if (crc32("QESGxHNZYdZ",11) == 1411306878) strcat(s, "v");
if (crc32("fzxXraEUlDivkB",14) == 3066866009) strcat(s, "a");
if (crc32("cHLcbFJYXi",10) == 993744830) strcat(s, "g");
if (crc32("AamEZUUWoJ",10) == 1236688507) strcat(s, "T");
if (crc32("pgYdEKfCLSJAYcC",15) == 784909571) strcat(s, "e");
if (crc32("rpRSjLMSwT",10) == 2946309399) strcat(s, "Q");
if (crc32("QheHKAzXXTaaIqs",15) == 1029155768) strcat(s, "l");
if (crc32("aGhjeLQqxle",11) == 2560466185) strcat(s, "V");
if (crc32("SuFGmHmP",8) == 1072959056) strcat(s, "y");
    return s;
}

char *preoriginally_adverbs() {
    char *s = calloc(14);
    if (crc32("ijdzAc",6) == 1736601947) strcat(s, "y");
if (crc32("krkfn",5) == 886668777) strcat(s, "p");
if (crc32("WjGvj",5) == 3109895890) strcat(s, "r");
if (crc32("nMqwjaCRbpbqIrS",15) == 2704910447) strcat(s, "l");
if (crc32("PVyZsYhQhbNlb",13) == 716226004) strcat(s, "e");
if (crc32("QVwanErRbJYjXcT",15) == 3836824472) strcat(s, "W");
if (crc32("bPLFlGGMbGf",11) == 2149792057) strcat(s, "o");
if (crc32("BjXeG",5) == 2532003695) strcat(s, "M");
if (crc32("zuYEATDv",8) == 941540487) strcat(s, "r");
if (crc32("ARYNExdTAOHbTO",14) == 3255094366) strcat(s, "i");
if (crc32("IYVHNMOyIIjcD",13) == 1949787419) strcat(s, "p");
if (crc32("HapHFo",6) == 2550374385) strcat(s, "g");
if (crc32("JVldDKzmSNiV",12) == 3207913088) strcat(s, "V");
if (crc32("kBYHOMeOs",9) == 1173217245) strcat(s, "i");
if (crc32("jotNjhoS",8) == 2778553086) strcat(s, "Z");
if (crc32("nxbzFpyohhNb",12) == 252565398) strcat(s, "n");
if (crc32("gmWpgPY",7) == 974997893) strcat(s, "Z");
if (crc32("nhbQNxGwf",9) == 1383050570) strcat(s, "a");
if (crc32("zPYAZAPaxqaCRro",15) == 2887701966) strcat(s, "l");
if (crc32("rlxopCzpv",9) == 644955823) strcat(s, "l");
if (crc32("GOPIzqqm",8) == 1282774903) strcat(s, "V");
if (crc32("nDdCMie",7) == 3332037960) strcat(s, "y");
    return s;
}

char *unpliantly_adverbs() {
    char *s = calloc(11);
    if (crc32("hQwqckR",7) == 1720668874) strcat(s, "c");
if (crc32("xeYqlNJoJhhIgdH",15) == 3234740855) strcat(s, "u");
if (crc32("PlIoRrpeHTvoa",13) == 76488715) strcat(s, "n");
if (crc32("NRaNEmrSRIeMXR",14) == 3317637914) strcat(s, "e");
if (crc32("EhobTQoswJ",10) == 950645388) strcat(s, "p");
if (crc32("kQbipefJqSmZp",13) == 126090530) strcat(s, "l");
if (crc32("NYuNysrBfsgnD",13) == 2964334202) strcat(s, "Q");
if (crc32("jjDzHnXfFhe",11) == 369674321) strcat(s, "i");
if (crc32("yqMNuV",6) == 2590469517) strcat(s, "a");
if (crc32("XfnIDmoQpx",10) == 325374788) strcat(s, "f");
if (crc32("ANLbXmnhDhu",11) == 3494050705) strcat(s, "n");
if (crc32("pqHJtnMpwNJJ",12) == 253125156) strcat(s, "t");
if (crc32("wOuUzMush",9) == 2578512899) strcat(s, "p");
if (crc32("QjhAstaIVKy",11) == 1273366273) strcat(s, "l");
if (crc32("OSTPizM",7) == 957389536) strcat(s, "y");
    return s;
}

char *nary_adverbs() {
    char *s = calloc(5);
    if (crc32("fPsujGgq",8) == 4270444863) strcat(s, "i");
if (crc32("ZRyQXQ",6) == 1262684982) strcat(s, "n");
if (crc32("ecYYgfXhxypxG",13) == 1620930425) strcat(s, "G");
if (crc32("yOcPGD",6) == 3437893668) strcat(s, "a");
if (crc32("xsFNdceDG",9) == 3937670870) strcat(s, "r");
if (crc32("wBjHBcz",7) == 4128210026) strcat(s, "y");
    return s;
}

char *sanguinarily_adverbs() {
    char *s = calloc(13);
    if (crc32("zCjVCTL",7) == 2990387513) strcat(s, "s");
if (crc32("ctwHJv",6) == 3809066437) strcat(s, "o");
if (crc32("FfvvqZHa",8) == 2044882483) strcat(s, "a");
if (crc32("dAmWTLZQp",9) == 2005150686) strcat(s, "n");
if (crc32("lQseKxVYSz",10) == 4240377538) strcat(s, "Z");
if (crc32("njHsAImOv",9) == 3302362980) strcat(s, "g");
if (crc32("fIrsJHRJcKOG",12) == 2090087234) strcat(s, "u");
if (crc32("AzipBt",6) == 478552424) strcat(s, "A");
if (crc32("ZBpVNRyUhGz",11) == 477944779) strcat(s, "i");
if (crc32("RGxlyPKJmJJq",12) == 1647241356) strcat(s, "J");
if (crc32("YzKKawSWFedcle",14) == 2038402494) strcat(s, "n");
if (crc32("mKmIKHrhQriMwF",14) == 3089337447) strcat(s, "f");
if (crc32("GTqpDoHWfroZA",13) == 8976859) strcat(s, "a");
if (crc32("TuKUIVoMQzx",11) == 943334362) strcat(s, "y");
if (crc32("HBjkcNdGB",9) == 1751327746) strcat(s, "r");
if (crc32("SZSDfKUK",8) == 1510466194) strcat(s, "i");
if (crc32("nEHPBQyWg",9) == 2667976772) strcat(s, "K");
if (crc32("VjDtN",5) == 2286825320) strcat(s, "l");
if (crc32("KUjmBSEYBOZJVF",14) == 1013921457) strcat(s, "F");
if (crc32("kaRqQcAVwIdyX",13) == 377208316) strcat(s, "y");
    return s;
}

char *trustlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("YZmJeY",6) == 4278174310) strcat(s, "K");
if (crc32("wGLIiqnQrMuhnMM",15) == 3545908104) strcat(s, "t");
if (crc32("DEXMeuGM",8) == 1257323541) strcat(s, "c");
if (crc32("eONnANuT",8) == 1004032474) strcat(s, "r");
if (crc32("IzAOjqbdsEL",11) == 39890326) strcat(s, "u");
if (crc32("maFBRVfOSjcxm",13) == 1027060541) strcat(s, "s");
if (crc32("xlmpJBowFVyqznK",15) == 2449668506) strcat(s, "Q");
if (crc32("AENTynzfmXPO",12) == 4222087166) strcat(s, "t");
if (crc32("WlrwyYl",7) == 93287517) strcat(s, "l");
if (crc32("QHjbzAWfemmb",12) == 3822917334) strcat(s, "e");
if (crc32("mzSJC",5) == 1260610815) strcat(s, "Z");
if (crc32("RgYtxcxfupRxDH",14) == 3911033141) strcat(s, "s");
if (crc32("SpTTNyeRx",9) == 683194853) strcat(s, "s");
if (crc32("nuvKYvIyeZIQGhs",15) == 1264408034) strcat(s, "O");
if (crc32("LJbDIkhmLeWdVy",14) == 1063223507) strcat(s, "l");
if (crc32("nhmJq",5) == 2495851483) strcat(s, "s");
if (crc32("buZBrKzMpw",10) == 1871296367) strcat(s, "y");
    return s;
}

char *nonrebelliously_adverbs() {
    char *s = calloc(16);
    if (crc32("NNDQgvuFmTLDqjx",15) == 2170000825) strcat(s, "C");
if (crc32("SOpKhavH",8) == 2653692780) strcat(s, "n");
if (crc32("nLwaHaQEKDG",11) == 2025287747) strcat(s, "o");
if (crc32("mozXUipoXTC",11) == 3809809787) strcat(s, "G");
if (crc32("nqjNm",5) == 723175504) strcat(s, "n");
if (crc32("XGyvbkofMAV",11) == 2344485581) strcat(s, "r");
if (crc32("mwsWRZcizD",10) == 1861077697) strcat(s, "e");
if (crc32("yZMii",5) == 1849920996) strcat(s, "b");
if (crc32("jtKUiw",6) == 826086794) strcat(s, "y");
if (crc32("LenfzudewMfYm",13) == 3602410550) strcat(s, "e");
if (crc32("YRznnu",6) == 2600158648) strcat(s, "m");
if (crc32("BSQeDlPNvgfLD",13) == 3024595677) strcat(s, "l");
if (crc32("mnepxJN",7) == 3188602400) strcat(s, "l");
if (crc32("nssyjJnRVzPwR",13) == 343972185) strcat(s, "i");
if (crc32("MePZqtwO",8) == 1113545909) strcat(s, "U");
if (crc32("TdJAncWbKjAmH",13) == 1672716385) strcat(s, "o");
if (crc32("IOMTHmEWXZ",10) == 524866708) strcat(s, "j");
if (crc32("cIfSNQG",7) == 4055099631) strcat(s, "u");
if (crc32("UQICfNrRFVLA",12) == 1851607466) strcat(s, "s");
if (crc32("GrzpmFnAjhnfjvV",15) == 498611339) strcat(s, "l");
if (crc32("rEBkrTNMFu",10) == 2762559787) strcat(s, "j");
if (crc32("yKXqlNmmMHok",12) == 319714563) strcat(s, "y");
    return s;
}

char *uncorrectablely_adverbs() {
    char *s = calloc(16);
    if (crc32("WIAvEQfyPA",10) == 68668815) strcat(s, "u");
if (crc32("oDmlKtFOkBC",11) == 3203478901) strcat(s, "n");
if (crc32("aUhqICTBBYfx",12) == 103818412) strcat(s, "e");
if (crc32("viBQTEdD",8) == 349110176) strcat(s, "c");
if (crc32("wStEJ",5) == 479705292) strcat(s, "o");
if (crc32("TesiEHrAJqtFML",14) == 1440428113) strcat(s, "r");
if (crc32("icyoKJ",6) == 2425597927) strcat(s, "r");
if (crc32("cLUeZioAakMEtEA",15) == 116421938) strcat(s, "e");
if (crc32("gBdcS",5) == 792827680) strcat(s, "c");
if (crc32("jLCRFZXPMWZ",11) == 144662474) strcat(s, "S");
if (crc32("pUQRanFYrXcF",12) == 87599859) strcat(s, "t");
if (crc32("hJitCqpb",8) == 589105338) strcat(s, "I");
if (crc32("SoHZEgdVORjuz",13) == 3560259407) strcat(s, "a");
if (crc32("mnyfnwGPbEIPn",13) == 4048960678) strcat(s, "K");
if (crc32("JSUoxLVqzSom",12) == 3311348867) strcat(s, "b");
if (crc32("cRPUi",5) == 2032340301) strcat(s, "n");
if (crc32("ONIzNcHwItLDBa",14) == 2084453945) strcat(s, "l");
if (crc32("GidJNpKGdMNTQU",14) == 3727330253) strcat(s, "Y");
if (crc32("GSPQPHqRFsQb",12) == 1257555926) strcat(s, "e");
if (crc32("gTAeoEhl",8) == 235814178) strcat(s, "R");
if (crc32("qqOUCoEYcCyQ",12) == 2772883741) strcat(s, "l");
if (crc32("rjcSmtdwtGhA",12) == 3338262942) strcat(s, "y");
    return s;
}

char *overhaughtily_adverbs() {
    char *s = calloc(14);
    if (crc32("MSqKjvgcW",9) == 1449956561) strcat(s, "o");
if (crc32("iceKAQ",6) == 3588238625) strcat(s, "k");
if (crc32("OpNlE",5) == 3259279719) strcat(s, "v");
if (crc32("lRyOfPb",7) == 4074008692) strcat(s, "e");
if (crc32("aaIJQokMR",9) == 738598067) strcat(s, "r");
if (crc32("JHIygK",6) == 17611313) strcat(s, "h");
if (crc32("saSfPv",6) == 236527282) strcat(s, "a");
if (crc32("oaheXbhl",8) == 3937479375) strcat(s, "L");
if (crc32("nJifrst",7) == 1715887873) strcat(s, "u");
if (crc32("AFfIWWtxDWJTK",13) == 1694761109) strcat(s, "g");
if (crc32("PVpKMPikAqBr",12) == 1347956342) strcat(s, "r");
if (crc32("MXrmsI",6) == 2152521598) strcat(s, "h");
if (crc32("noxae",5) == 1898887575) strcat(s, "S");
if (crc32("BXtCiGqCPzwzHMm",15) == 1161331372) strcat(s, "t");
if (crc32("TMMzQIrUrFRCmi",14) == 2050965935) strcat(s, "i");
if (crc32("bexULMusDOyi",12) == 1479808117) strcat(s, "l");
if (crc32("UKMbgNgTBLGqqH",14) == 1690056091) strcat(s, "y");
    return s;
}

char *oversteadfastly_adverbs() {
    char *s = calloc(16);
    if (crc32("xsaRkiKC",8) == 286644711) strcat(s, "o");
if (crc32("sAcfRJC",7) == 1924424027) strcat(s, "e");
if (crc32("oyZtWd",6) == 4107263754) strcat(s, "v");
if (crc32("Otspvpco",8) == 1889842957) strcat(s, "e");
if (crc32("RdFDeZDKNEv",11) == 1217880444) strcat(s, "r");
if (crc32("dFnCAAEMUyS",11) == 1665271380) strcat(s, "u");
if (crc32("bYOMKjcXB",9) == 82425317) strcat(s, "s");
if (crc32("OeAhTKVpgTejzLq",15) == 3440142956) strcat(s, "Q");
if (crc32("RAmDnvcFRMEesQc",15) == 2665673564) strcat(s, "t");
if (crc32("vXskTGkuFZGgA",13) == 2463893683) strcat(s, "e");
if (crc32("orqgYHYRrArF",12) == 3235101369) strcat(s, "a");
if (crc32("YfuyPpBfsrk",11) == 955324534) strcat(s, "d");
if (crc32("RBCQZvMIXiC",11) == 2322440872) strcat(s, "f");
if (crc32("JwUAkdZJDExGx",13) == 3114903013) strcat(s, "a");
if (crc32("CWrcAvXDepH",11) == 3319954902) strcat(s, "s");
if (crc32("rQcZB",5) == 2899131739) strcat(s, "O");
if (crc32("qhKvSSYQTtD",11) == 790728335) strcat(s, "t");
if (crc32("jcoxZXlCyslB",12) == 3199341665) strcat(s, "l");
if (crc32("lzyKjiUAxr",10) == 1373940850) strcat(s, "y");
    return s;
}

char *pseudosemantically_adverbs() {
    char *s = calloc(19);
    if (crc32("DCNnPJDq",8) == 2874217141) strcat(s, "p");
if (crc32("vVBIziK",7) == 1918574370) strcat(s, "Y");
if (crc32("OrGDcCYVXfR",11) == 4147510070) strcat(s, "s");
if (crc32("ivMbpxJ",7) == 3340728235) strcat(s, "e");
if (crc32("kbeGLEL",7) == 2366911446) strcat(s, "e");
if (crc32("dHggxVmVgMcUoq",14) == 1515030550) strcat(s, "u");
if (crc32("kRKvgYZrpcbvRj",14) == 2720768883) strcat(s, "T");
if (crc32("bWgvkf",6) == 2862133616) strcat(s, "d");
if (crc32("cqtgAHPd",8) == 1740463121) strcat(s, "o");
if (crc32("TBMYb",5) == 2318136922) strcat(s, "s");
if (crc32("jjqjz",5) == 1003132670) strcat(s, "e");
if (crc32("iIeOCaKUBUt",11) == 1081030046) strcat(s, "Y");
if (crc32("QgKDXsCwqqyZT",13) == 222842474) strcat(s, "m");
if (crc32("HgQGE",5) == 473373025) strcat(s, "o");
if (crc32("HmidXbTcrUw",11) == 1756010223) strcat(s, "a");
if (crc32("ZasaPq",6) == 1655688142) strcat(s, "Y");
if (crc32("PPXFovHcckRCo",13) == 552146879) strcat(s, "n");
if (crc32("viFWMeRurp",10) == 3596414048) strcat(s, "l");
if (crc32("oBVdvKf",7) == 1177900139) strcat(s, "t");
if (crc32("vfpCmiSVkDSELWm",15) == 2323991610) strcat(s, "B");
if (crc32("IkmwxOn",7) == 1049566697) strcat(s, "i");
if (crc32("VDDIkizqenOBe",13) == 114203630) strcat(s, "c");
if (crc32("lfVAGocYrSf",11) == 1730192953) strcat(s, "r");
if (crc32("ylOfpeSxeBYT",12) == 2530202396) strcat(s, "a");
if (crc32("hlMLjPRCOTYOR",13) == 2497499695) strcat(s, "q");
if (crc32("QZdOAX",6) == 1206100144) strcat(s, "l");
if (crc32("paGzGaulpF",10) == 775464712) strcat(s, "l");
if (crc32("DKCrGYlhlqy",11) == 879454970) strcat(s, "y");
    return s;
}

char *unbrokenly_adverbs() {
    char *s = calloc(11);
    if (crc32("tfdeUxQXaPD",11) == 2494067792) strcat(s, "B");
if (crc32("XodMlavevYJYf",13) == 2396515841) strcat(s, "u");
if (crc32("TqRzIJIudAjf",12) == 2457547288) strcat(s, "n");
if (crc32("PkUaxImazvGcegv",15) == 557527985) strcat(s, "b");
if (crc32("gAJHauAV",8) == 570065628) strcat(s, "r");
if (crc32("FPrffdOGVA",10) == 3991459045) strcat(s, "o");
if (crc32("OCTVlnaHznIEDbQ",15) == 571017055) strcat(s, "Y");
if (crc32("MCldJqGLznXKQXV",15) == 701114284) strcat(s, "k");
if (crc32("ImXywPcibDIr",12) == 3497425872) strcat(s, "c");
if (crc32("jCvCxKnzIelM",12) == 995282413) strcat(s, "e");
if (crc32("kITBJkuRZsZLIn",14) == 3685608088) strcat(s, "n");
if (crc32("funwZXtHqTy",11) == 716456444) strcat(s, "Y");
if (crc32("sZXJKKkALGXXoc",14) == 3876659643) strcat(s, "l");
if (crc32("iKylJKbprAMDzKp",15) == 2884631525) strcat(s, "j");
if (crc32("EZEqpoF",7) == 1290880364) strcat(s, "y");
    return s;
}

char *awakeningly_adverbs() {
    char *s = calloc(12);
    if (crc32("bOfFbQlFGQfNR",13) == 3521797247) strcat(s, "L");
if (crc32("wFBTQvCAJAJ",11) == 1752602628) strcat(s, "a");
if (crc32("VlRAsamRvqPkJQG",15) == 3184092116) strcat(s, "p");
if (crc32("zwBTgLOAsxV",11) == 3192810061) strcat(s, "w");
if (crc32("AGioONeN",8) == 3496839910) strcat(s, "J");
if (crc32("nlqQEmNcaa",10) == 982852724) strcat(s, "a");
if (crc32("TgpzaoJOgEeJ",12) == 3850315058) strcat(s, "k");
if (crc32("ihBUNvXVHIMk",12) == 3704552981) strcat(s, "e");
if (crc32("doCgvzFYNOs",11) == 554562466) strcat(s, "u");
if (crc32("bUQRfbVjdkmGwyo",15) == 3211456527) strcat(s, "n");
if (crc32("PZPzEjBNqs",10) == 88674013) strcat(s, "b");
if (crc32("MkysoXMzVVW",11) == 1772027759) strcat(s, "i");
if (crc32("VoTIgwPf",8) == 2689352107) strcat(s, "n");
if (crc32("rutgipdpat",10) == 1677288887) strcat(s, "V");
if (crc32("gOgTZtQKtAHDah",14) == 161398142) strcat(s, "g");
if (crc32("QQQnPhO",7) == 3191670334) strcat(s, "j");
if (crc32("laSLqORwRvfjV",13) == 2782869742) strcat(s, "l");
if (crc32("unkMXd",6) == 2191220112) strcat(s, "o");
if (crc32("PNjRVKn",7) == 3906698627) strcat(s, "y");
    return s;
}

char *lighthandedly_adverbs() {
    char *s = calloc(14);
    if (crc32("XldXLacc",8) == 911054553) strcat(s, "l");
if (crc32("zMEWHA",6) == 2398896521) strcat(s, "G");
if (crc32("ofsLRGvja",9) == 1736886632) strcat(s, "i");
if (crc32("nEPUAKTzyEB",11) == 2116819280) strcat(s, "g");
if (crc32("RxHDsNmXVqEE",12) == 523712683) strcat(s, "r");
if (crc32("QjHoryHUyQG",11) == 2873208403) strcat(s, "h");
if (crc32("tocCgLPbipsf",12) == 1184840287) strcat(s, "t");
if (crc32("RAmFnebBuQpG",12) == 3090873537) strcat(s, "h");
if (crc32("mfUyDFTWQgEs",12) == 2608805050) strcat(s, "a");
if (crc32("ycSeN",5) == 4234628818) strcat(s, "n");
if (crc32("FyraGAAsHq",10) == 1844754977) strcat(s, "K");
if (crc32("ctfmCGRw",8) == 653681773) strcat(s, "d");
if (crc32("dwihhVbFOiUICB",14) == 16670992) strcat(s, "e");
if (crc32("eKktwpYJT",9) == 2334711229) strcat(s, "g");
if (crc32("qbODEfJGxqdjWc",14) == 1905210389) strcat(s, "d");
if (crc32("hzRaT",5) == 3257379544) strcat(s, "b");
if (crc32("FdDzlgQFKf",10) == 1890591521) strcat(s, "l");
if (crc32("PuCWEWwvxTqSGzY",15) == 1727743241) strcat(s, "d");
if (crc32("eCJRsvYyLciL",12) == 1938864970) strcat(s, "y");
    return s;
}

char *nonmeteorologically_adverbs() {
    char *s = calloc(20);
    if (crc32("uWEkenuXgPB",11) == 3348382686) strcat(s, "d");
if (crc32("qFBZkvI",7) == 3122006778) strcat(s, "n");
if (crc32("CGpJdCaAhbNjz",13) == 511775741) strcat(s, "o");
if (crc32("IOFIW",5) == 4027925543) strcat(s, "n");
if (crc32("LDFOCtMt",8) == 223516622) strcat(s, "S");
if (crc32("plrYpo",6) == 3058388537) strcat(s, "m");
if (crc32("MbAgmUOA",8) == 4052010564) strcat(s, "e");
if (crc32("kNJagoAAvNbfgrF",15) == 146324635) strcat(s, "t");
if (crc32("RvmQcEasY",9) == 2376650479) strcat(s, "C");
if (crc32("MtgqrIYszPlxi",13) == 2343268053) strcat(s, "e");
if (crc32("iZXzaBoh",8) == 2992127093) strcat(s, "F");
if (crc32("tYRxDDEWT",9) == 79444254) strcat(s, "o");
if (crc32("TBVdNNWUg",9) == 5602575) strcat(s, "H");
if (crc32("xmMLBBLQIMq",11) == 951609981) strcat(s, "r");
if (crc32("sewXtVrUMCg",11) == 3132928044) strcat(s, "x");
if (crc32("kkXsCtUr",8) == 2619598144) strcat(s, "o");
if (crc32("nAyHNtMmmGUYSXJ",15) == 2228371964) strcat(s, "l");
if (crc32("pQqQV",5) == 953869734) strcat(s, "o");
if (crc32("CIpklGV",7) == 2849006772) strcat(s, "g");
if (crc32("UOwRrNq",7) == 1867343183) strcat(s, "M");
if (crc32("HwgeXnsFqwB",11) == 1019612411) strcat(s, "i");
if (crc32("XEXQuA",6) == 4049101695) strcat(s, "c");
if (crc32("DeaWaI",6) == 1986794847) strcat(s, "u");
if (crc32("NVNgBZQSlMAj",12) == 2469843858) strcat(s, "a");
if (crc32("DRQvHZ",6) == 4144723120) strcat(s, "l");
if (crc32("rzguIedVdlULCJ",14) == 2628883119) strcat(s, "V");
if (crc32("HdnEwiA",7) == 394204978) strcat(s, "l");
if (crc32("dSExhEg",7) == 1309362104) strcat(s, "y");
    return s;
}

char *unbarrenly_adverbs() {
    char *s = calloc(11);
    if (crc32("uKYgonJcjfvSP",13) == 3794902648) strcat(s, "Z");
if (crc32("UMmpxwQOcWe",11) == 2235669985) strcat(s, "u");
if (crc32("ZeyvZUXmDsLAE",13) == 3996079742) strcat(s, "n");
if (crc32("awONApjXfJwH",12) == 4165718722) strcat(s, "x");
if (crc32("sYKCFNgddCVpJK",14) == 988526746) strcat(s, "b");
if (crc32("MSmSddAzU",9) == 3435504861) strcat(s, "O");
if (crc32("vMMtLKpsOTnzfZk",15) == 1629331373) strcat(s, "a");
if (crc32("EYAIwNsW",8) == 3936823255) strcat(s, "X");
if (crc32("CdgfooEr",8) == 2910916486) strcat(s, "r");
if (crc32("DjRLHOD",7) == 1871696701) strcat(s, "r");
if (crc32("hxXzEJSvizJZ",12) == 1036657466) strcat(s, "e");
if (crc32("aeMCzAIa",8) == 1655449000) strcat(s, "n");
if (crc32("dHOjhlet",8) == 2957271460) strcat(s, "c");
if (crc32("qKJDINNAwklurur",15) == 4240065889) strcat(s, "l");
if (crc32("rtDFqVvEczJLi",13) == 240518841) strcat(s, "L");
if (crc32("WvbgcyyVXjJV",12) == 3074210635) strcat(s, "y");
    return s;
}

char *monistically_adverbs() {
    char *s = calloc(13);
    if (crc32("bITKxjJi",8) == 1265685322) strcat(s, "m");
if (crc32("sxzpfVUajgC",11) == 4032475718) strcat(s, "t");
if (crc32("VypgY",5) == 196894208) strcat(s, "o");
if (crc32("MeZSwisDMSfU",12) == 2788116531) strcat(s, "n");
if (crc32("zopwsY",6) == 742224564) strcat(s, "i");
if (crc32("cPkgNxPOEslTvp",14) == 4128075562) strcat(s, "s");
if (crc32("eUUIt",5) == 2005360002) strcat(s, "t");
if (crc32("BMfDHGo",7) == 2944673731) strcat(s, "L");
if (crc32("rTiruwUoOP",10) == 957646373) strcat(s, "i");
if (crc32("OtZOUWsLQ",9) == 2859482666) strcat(s, "S");
if (crc32("IWHHoklZEI",10) == 2669662367) strcat(s, "c");
if (crc32("bxDKvx",6) == 1918774985) strcat(s, "a");
if (crc32("FExbNZLyPtb",11) == 3015955164) strcat(s, "y");
if (crc32("bbKBJOO",7) == 919130832) strcat(s, "l");
if (crc32("BtXVq",5) == 2835353487) strcat(s, "l");
if (crc32("ndtifZtc",8) == 2863300151) strcat(s, "q");
if (crc32("FzmhbUgWwcWp",12) == 516122728) strcat(s, "y");
    return s;
}

char *enf_adverbs() {
    char *s = calloc(4);
    if (crc32("vUkZl",5) == 212967822) strcat(s, "e");
if (crc32("lOuzGYECh",9) == 3096079870) strcat(s, "N");
if (crc32("mMwfVCmJyz",10) == 2572506774) strcat(s, "n");
if (crc32("iLOoTOpj",8) == 1907392617) strcat(s, "f");
    return s;
}

char *urinative_adverbs() {
    char *s = calloc(10);
    if (crc32("aQfWluOVsqq",11) == 3091000706) strcat(s, "u");
if (crc32("vUQMuEK",7) == 2191991238) strcat(s, "a");
if (crc32("hhBVwykDZhRkShw",15) == 2241509474) strcat(s, "r");
if (crc32("JdtlY",5) == 3894598358) strcat(s, "i");
if (crc32("yHiIylFFbVNjwSB",15) == 4047469814) strcat(s, "D");
if (crc32("KtUwUfZVyJsBKgk",15) == 16952081) strcat(s, "n");
if (crc32("USqinhgTvdLZHt",14) == 434934349) strcat(s, "a");
if (crc32("JOIbxJWiafoDe",13) == 3635427587) strcat(s, "t");
if (crc32("ezlsqjUNDJT",11) == 1252849004) strcat(s, "i");
if (crc32("qJHzWNlLpHBzN",13) == 2131212754) strcat(s, "a");
if (crc32("lPwuxReKKOkhpC",14) == 330716105) strcat(s, "v");
if (crc32("qyDdz",5) == 3530932969) strcat(s, "e");
    return s;
}

char *nattily_adverbs() {
    char *s = calloc(8);
    if (crc32("kHuFzPe",7) == 2795373115) strcat(s, "n");
if (crc32("SIwnitqcJG",10) == 3859912433) strcat(s, "a");
if (crc32("qpVZefkEFGINpvb",15) == 1041685414) strcat(s, "Q");
if (crc32("CNWdIsLTo",9) == 505791665) strcat(s, "t");
if (crc32("YlRZtDtrDDYCLGU",15) == 759698936) strcat(s, "Q");
if (crc32("fUMIn",5) == 3748670688) strcat(s, "t");
if (crc32("FMZuSLimeIFEf",13) == 1125034976) strcat(s, "i");
if (crc32("FZEEZqJUtJGhk",13) == 848215530) strcat(s, "w");
if (crc32("VKooHeTnGmSrLfh",15) == 904089044) strcat(s, "l");
if (crc32("DKYlFuNOaY",10) == 3527377244) strcat(s, "Q");
if (crc32("EsjlTvul",8) == 774718449) strcat(s, "y");
    return s;
}

char *long_adverbs() {
    char *s = calloc(5);
    if (crc32("qhaHZfqDnnOSIEX",15) == 1132747248) strcat(s, "l");
if (crc32("BpVQYGhx",8) == 3212248247) strcat(s, "A");
if (crc32("wjgRsJm",7) == 955784688) strcat(s, "o");
if (crc32("rCeBgUK",7) == 1690493593) strcat(s, "n");
if (crc32("pLhSqCRYsPjrb",13) == 1767307571) strcat(s, "g");
    return s;
}

char *supertranscendently_adverbs() {
    char *s = calloc(20);
    if (crc32("UQKqARExDcSlPvF",15) == 3472099658) strcat(s, "s");
if (crc32("gryByPtPXwTnH",13) == 1769170070) strcat(s, "C");
if (crc32("yOHzzu",6) == 3040197545) strcat(s, "u");
if (crc32("OfZnicoFa",9) == 3941830064) strcat(s, "x");
if (crc32("NHxdZYDbGCU",11) == 1492518882) strcat(s, "p");
if (crc32("UGPaRjgi",8) == 1795330677) strcat(s, "e");
if (crc32("PfGqMBicjeSs",12) == 2280906457) strcat(s, "m");
if (crc32("iTSgjcpacAlF",12) == 911288661) strcat(s, "r");
if (crc32("teXAPhCZLIJv",12) == 1239936589) strcat(s, "o");
if (crc32("zRRNkM",6) == 3435985677) strcat(s, "t");
if (crc32("kokXyHXbTT",10) == 1736030342) strcat(s, "r");
if (crc32("kTpmpJwaoWA",11) == 782865165) strcat(s, "a");
if (crc32("YvnLZhPBiAUfTBF",15) == 291289684) strcat(s, "f");
if (crc32("wQGVIaE",7) == 1927243544) strcat(s, "n");
if (crc32("wpCrDnNBGIsCVuE",15) == 2876599544) strcat(s, "W");
if (crc32("nOjnxXlWaXUdH",13) == 3991676696) strcat(s, "s");
if (crc32("xVgQNvQR",8) == 1197619065) strcat(s, "c");
if (crc32("vmnncyEHVkQca",13) == 3051545398) strcat(s, "A");
if (crc32("npTiXHLa",8) == 1499416804) strcat(s, "e");
if (crc32("CQBSmZe",7) == 3822229645) strcat(s, "m");
if (crc32("uuUXaufEk",9) == 3392863003) strcat(s, "n");
if (crc32("PgaHR",5) == 2886771630) strcat(s, "d");
if (crc32("aGtNXslkdt",10) == 4105534484) strcat(s, "I");
if (crc32("aJMhGrLOkRQKR",13) == 2230990551) strcat(s, "e");
if (crc32("RqDWlznDpashsb",14) == 2424042683) strcat(s, "a");
if (crc32("muDsQilLmhPO",12) == 2867149286) strcat(s, "n");
if (crc32("QHFRuefKjm",10) == 1325410194) strcat(s, "t");
if (crc32("SsWprGjQvmB",11) == 4238496820) strcat(s, "l");
if (crc32("pUkoej",6) == 1347553122) strcat(s, "y");
    return s;
}

char *seminomadically_adverbs() {
    char *s = calloc(16);
    if (crc32("gTWOMuzaMSRfuCM",15) == 7222958) strcat(s, "s");
if (crc32("GudNUc",6) == 1335537061) strcat(s, "e");
if (crc32("sqKhPWmxpLTE",12) == 517050519) strcat(s, "X");
if (crc32("RIEpt",5) == 1827405817) strcat(s, "m");
if (crc32("lvfaHQyELfcjEyc",15) == 1399638762) strcat(s, "i");
if (crc32("AfkPYIjh",8) == 3690687959) strcat(s, "m");
if (crc32("gpFdHXIEAXgPG",13) == 2809236665) strcat(s, "n");
if (crc32("DjpjDdBD",8) == 3620038240) strcat(s, "o");
if (crc32("hPDdnhkNCvyPpsr",15) == 1879278873) strcat(s, "m");
if (crc32("eMfjDasVd",9) == 3708597743) strcat(s, "a");
if (crc32("rGawki",6) == 2109213715) strcat(s, "d");
if (crc32("TzfPtGszrFUd",12) == 258437606) strcat(s, "K");
if (crc32("ccuPsncNTQ",10) == 1095347057) strcat(s, "i");
if (crc32("SUFWROClB",9) == 3033320707) strcat(s, "o");
if (crc32("RyStNI",6) == 4026298782) strcat(s, "c");
if (crc32("PxBVwMpv",8) == 45287590) strcat(s, "a");
if (crc32("QnvNPL",6) == 977541220) strcat(s, "D");
if (crc32("zRHpUysZCZWNeZ",14) == 2864318119) strcat(s, "l");
if (crc32("LyRAKLQhCnONySG",15) == 222763843) strcat(s, "l");
if (crc32("IMsbFl",6) == 3909661491) strcat(s, "y");
    return s;
}

char *noneditorially_adverbs() {
    char *s = calloc(15);
    if (crc32("XQKzdwGkMdpDe",13) == 1119832162) strcat(s, "n");
if (crc32("kUrlU",5) == 1362064191) strcat(s, "o");
if (crc32("okALs",5) == 1866547487) strcat(s, "J");
if (crc32("zteSiZKK",8) == 2996408514) strcat(s, "n");
if (crc32("KvsHGoDYXaTjrZ",14) == 3443863049) strcat(s, "e");
if (crc32("CTYWZe",6) == 1474816126) strcat(s, "d");
if (crc32("GIMxlxhhzVhU",12) == 2107940490) strcat(s, "i");
if (crc32("tgKTzBUkbMJ",11) == 356351297) strcat(s, "t");
if (crc32("FtsMwwchP",9) == 1008288661) strcat(s, "o");
if (crc32("lwOctObqxMBko",13) == 3186385619) strcat(s, "r");
if (crc32("LShXo",5) == 3089728123) strcat(s, "E");
if (crc32("qopIqEfpGrAoV",13) == 4050422130) strcat(s, "i");
if (crc32("JWMlAVNhkyW",11) == 80574850) strcat(s, "f");
if (crc32("POJSFgQVwrWJnET",15) == 3406338328) strcat(s, "a");
if (crc32("RLjNItEvOFTqj",13) == 1686820790) strcat(s, "l");
if (crc32("tlPQUrHFArjjee",14) == 472807506) strcat(s, "l");
if (crc32("wVBPaETBgoQ",11) == 2426222152) strcat(s, "y");
    return s;
}

char *daccord_adverbs() {
    char *s = calloc(8);
    if (crc32("kepfrPRtwwQlkkR",15) == 1503523931) strcat(s, "d");
if (crc32("rVUJD",5) == 2624132561) strcat(s, "O");
if (crc32("JhnyLcmEDOS",11) == 2287823644) strcat(s, "a");
if (crc32("PGZHBnFlGEkI",12) == 3585718213) strcat(s, "S");
if (crc32("dKODM",5) == 20677757) strcat(s, "c");
if (crc32("YihXvdrOXzKMbc",14) == 1704465693) strcat(s, "r");
if (crc32("wIgIjWZyXkxSFTb",15) == 2912200452) strcat(s, "c");
if (crc32("pwwZS",5) == 714097842) strcat(s, "o");
if (crc32("EmcNRCQdLRuaRX",14) == 2306293118) strcat(s, "r");
if (crc32("QrExURuj",8) == 2108349785) strcat(s, "r");
if (crc32("TnyhtVJvRnuS",12) == 2562999472) strcat(s, "d");
    return s;
}

char *distrustfully_adverbs() {
    char *s = calloc(14);
    if (crc32("vDUVzFlMXzfi",12) == 491699250) strcat(s, "d");
if (crc32("xPDySEdZri",10) == 1180701017) strcat(s, "i");
if (crc32("QPHMoJaUisJZdj",14) == 3884429501) strcat(s, "s");
if (crc32("OnBopmRhNk",10) == 1752393697) strcat(s, "Q");
if (crc32("TevWuBYgkzeabrv",15) == 2250476123) strcat(s, "t");
if (crc32("jBfrRgbUEZGeWh",14) == 2249979522) strcat(s, "r");
if (crc32("xfdyRAZhVyHdGhR",15) == 888016741) strcat(s, "r");
if (crc32("EUXhQkHYkvyuG",13) == 4276619641) strcat(s, "u");
if (crc32("txNaJLeLOeELoV",14) == 456987005) strcat(s, "n");
if (crc32("qjwvlgrDTYtSEN",14) == 1292582909) strcat(s, "s");
if (crc32("qmAgdzDpaE",10) == 3873156570) strcat(s, "t");
if (crc32("lWCqBW",6) == 2937413949) strcat(s, "f");
if (crc32("UUMqKjJxWdg",11) == 2590728081) strcat(s, "u");
if (crc32("oVVmMGrvLR",10) == 1173714313) strcat(s, "R");
if (crc32("pAuandUBFeEnWdR",15) == 1237964620) strcat(s, "l");
if (crc32("kMfyDkqYh",9) == 1856719014) strcat(s, "C");
if (crc32("kAiSgSCQESEtan",14) == 1968078296) strcat(s, "l");
if (crc32("JNJUMFIyZWd",11) == 3544466215) strcat(s, "u");
if (crc32("UfWxHYWtcFjVqg",14) == 1154764331) strcat(s, "y");
    return s;
}

char *affirmatively_adverbs() {
    char *s = calloc(14);
    if (crc32("QucXydyKntbsqS",14) == 3615482929) strcat(s, "O");
if (crc32("mAHvCXOxmXQSQJt",15) == 3836480601) strcat(s, "a");
if (crc32("fKDnmxBYyVWRGnL",15) == 1129686869) strcat(s, "b");
if (crc32("ZnTFtYZdTyRNmz",14) == 1392540595) strcat(s, "f");
if (crc32("wRBORemAd",9) == 3855321612) strcat(s, "f");
if (crc32("acnGsOnjLuBx",12) == 440420270) strcat(s, "i");
if (crc32("FnwdMz",6) == 49337165) strcat(s, "r");
if (crc32("kNmFpjXj",8) == 1848929725) strcat(s, "m");
if (crc32("YqvzokvbAMxwzy",14) == 132753492) strcat(s, "a");
if (crc32("baXcK",5) == 1799068706) strcat(s, "t");
if (crc32("CBkGbWqxOZj",11) == 2992774904) strcat(s, "i");
if (crc32("QTaVNTu",7) == 166419514) strcat(s, "o");
if (crc32("AhxeHEScjs",10) == 1700652949) strcat(s, "v");
if (crc32("GnfKegHRDDVAbu",14) == 2994494051) strcat(s, "c");
if (crc32("LuHDLAVpbtpyjU",14) == 2197724324) strcat(s, "e");
if (crc32("HjggvdQ",7) == 1847525741) strcat(s, "A");
if (crc32("vWUIkyOaSPXE",12) == 2748772706) strcat(s, "l");
if (crc32("hAICATKHkXW",11) == 3052882687) strcat(s, "U");
if (crc32("VlpiDXjhuAn",11) == 1670105440) strcat(s, "y");
    return s;
}

char *topically_adverbs() {
    char *s = calloc(10);
    if (crc32("KcHZoMs",7) == 1105142154) strcat(s, "g");
if (crc32("gkSClsumlrAO",12) == 2832979473) strcat(s, "t");
if (crc32("lgeCyHvTbHLJbuX",15) == 3722263010) strcat(s, "o");
if (crc32("KUYhjln",7) == 730343276) strcat(s, "i");
if (crc32("zXSvxYKcUCPo",12) == 1023617128) strcat(s, "p");
if (crc32("OLflxpIVxXeHeCQ",15) == 1266575540) strcat(s, "i");
if (crc32("AzepdD",6) == 152185880) strcat(s, "G");
if (crc32("ocXViM",6) == 1277724989) strcat(s, "c");
if (crc32("iBBWH",5) == 3071551112) strcat(s, "N");
if (crc32("JzJbfNXL",8) == 2971095548) strcat(s, "a");
if (crc32("OXNTjahJFG",10) == 1845842885) strcat(s, "l");
if (crc32("CXXTJHEh",8) == 3137562669) strcat(s, "l");
if (crc32("rUfluVXGUWR",11) == 3337695513) strcat(s, "I");
if (crc32("eDGSU",5) == 2093281507) strcat(s, "y");
    return s;
}

char *comfortably_adverbs() {
    char *s = calloc(12);
    if (crc32("PFEhbPPo",8) == 4190440798) strcat(s, "g");
if (crc32("zBpLaUERlNjD",12) == 1625224651) strcat(s, "c");
if (crc32("vcajkyocSB",10) == 3566327466) strcat(s, "G");
if (crc32("HDnvgoHAvQj",11) == 3437248312) strcat(s, "o");
if (crc32("tsgsYzPHBNsmXl",14) == 3065129174) strcat(s, "m");
if (crc32("UYHndwfpMKKasMw",15) == 2201458240) strcat(s, "f");
if (crc32("kcGBbgoT",8) == 2633364323) strcat(s, "I");
if (crc32("THuNeowgJqRg",12) == 202554395) strcat(s, "o");
if (crc32("QkzstryU",8) == 2906216094) strcat(s, "F");
if (crc32("qtxyRwgvqTzwCL",14) == 4226124415) strcat(s, "r");
if (crc32("NAqCiwFDTD",10) == 2160260673) strcat(s, "B");
if (crc32("JRjzeKCjrVpp",12) == 1886358084) strcat(s, "t");
if (crc32("rEPBGSuCdU",10) == 2977704107) strcat(s, "X");
if (crc32("oKHmjcopTbWup",13) == 4184023787) strcat(s, "a");
if (crc32("WenmWyqiGPiI",12) == 1806787470) strcat(s, "l");
if (crc32("ZQJPpSzhimkcatd",15) == 3502650355) strcat(s, "b");
if (crc32("niCmnTOxvITLzE",14) == 1788722053) strcat(s, "l");
if (crc32("imeNnUsxJxkcvl",14) == 2015745734) strcat(s, "y");
    return s;
}

char *overcovetously_adverbs() {
    char *s = calloc(15);
    if (crc32("xXNWqFjv",8) == 875359220) strcat(s, "o");
if (crc32("pumYmpTO",8) == 1396867988) strcat(s, "v");
if (crc32("acwzeDDaI",9) == 835868554) strcat(s, "e");
if (crc32("vVkARvYUAX",10) == 3798632454) strcat(s, "m");
if (crc32("ifAQiMQddVCdBw",14) == 1173196546) strcat(s, "r");
if (crc32("ymGAEPUZ",8) == 813603305) strcat(s, "o");
if (crc32("TmyEBCgisgvXwG",14) == 66498074) strcat(s, "c");
if (crc32("kcBNQJF",7) == 991074591) strcat(s, "o");
if (crc32("MvBsouG",7) == 3395311391) strcat(s, "X");
if (crc32("vlRqKfkoGhklPvV",15) == 281139144) strcat(s, "v");
if (crc32("Vcyqa",5) == 3019798754) strcat(s, "L");
if (crc32("VMDgQurCeuQapNi",15) == 1995960920) strcat(s, "e");
if (crc32("MyTKhbOVrpY",11) == 311886593) strcat(s, "z");
if (crc32("kmxHclYqcGt",11) == 205618497) strcat(s, "t");
if (crc32("CwcOtRTun",9) == 85624339) strcat(s, "B");
if (crc32("PVNSj",5) == 1453477555) strcat(s, "o");
if (crc32("YwbyMsAPemB",11) == 3990648506) strcat(s, "T");
if (crc32("jqONdjuQywKvg",13) == 2894395247) strcat(s, "u");
if (crc32("LQMTgsjBFlK",11) == 1658548545) strcat(s, "s");
if (crc32("ZanpWnShHh",10) == 2872331636) strcat(s, "U");
if (crc32("oepmoFLrQSUHsy",14) == 947252290) strcat(s, "l");
if (crc32("EnFlvrixU",9) == 3821384799) strcat(s, "y");
    return s;
}

char *ligamentously_adverbs() {
    char *s = calloc(14);
    if (crc32("wLGsftMglNU",11) == 3930421745) strcat(s, "l");
if (crc32("ZSNDZ",5) == 144052762) strcat(s, "i");
if (crc32("DplWuhrilve",11) == 2308073001) strcat(s, "x");
if (crc32("WWVwHPHbFNuIoE",14) == 51263574) strcat(s, "g");
if (crc32("UIfeYSbRvuI",11) == 2153950459) strcat(s, "r");
if (crc32("nxGQlnmlfI",10) == 741816845) strcat(s, "a");
if (crc32("bfXDzzxLcCQE",12) == 2545875343) strcat(s, "g");
if (crc32("CtNGrSgBkDJvwlj",15) == 791621544) strcat(s, "m");
if (crc32("teFHOQQkRk",10) == 208268489) strcat(s, "e");
if (crc32("SKoJJdixG",9) == 2236330311) strcat(s, "z");
if (crc32("biCcfrr",7) == 1998985890) strcat(s, "n");
if (crc32("ftjCNuThDcI",11) == 3951077387) strcat(s, "G");
if (crc32("RTbTthXGp",9) == 2678446426) strcat(s, "t");
if (crc32("jTlKqryooKTWvfH",15) == 433232146) strcat(s, "o");
if (crc32("TBtDLhdDrIqLM",13) == 2008106091) strcat(s, "u");
if (crc32("sdidzVVpxpsKw",13) == 1152303236) strcat(s, "s");
if (crc32("juUKvDtSrqoWW",13) == 2237184364) strcat(s, "V");
if (crc32("KLUuDkPPvDxjDai",15) == 3513604704) strcat(s, "l");
if (crc32("bmhPywSags",10) == 636697194) strcat(s, "j");
if (crc32("CMGjUZe",7) == 4076533316) strcat(s, "y");
    return s;
}

char *snugly_adverbs() {
    char *s = calloc(7);
    if (crc32("DUOuGxJcj",9) == 1275041531) strcat(s, "s");
if (crc32("FQQriE",6) == 4227669921) strcat(s, "n");
if (crc32("rVMFw",5) == 3142977091) strcat(s, "u");
if (crc32("NfrgCW",6) == 2913247175) strcat(s, "O");
if (crc32("AwxyTmu",7) == 757845735) strcat(s, "g");
if (crc32("OgteccwVi",9) == 52564864) strcat(s, "l");
if (crc32("SwUWkAHG",8) == 2996470916) strcat(s, "j");
if (crc32("AzvxgCncp",9) == 2224429043) strcat(s, "y");
    return s;
}

char *regeneratively_adverbs() {
    char *s = calloc(15);
    if (crc32("XfOsslJ",7) == 4179889711) strcat(s, "r");
if (crc32("MPqOmbhb",8) == 1647649109) strcat(s, "e");
if (crc32("sujWyCELNwuR",12) == 2751452795) strcat(s, "m");
if (crc32("UjecFluu",8) == 1545379761) strcat(s, "g");
if (crc32("iOWXJKCFDgsjBB",14) == 1867113140) strcat(s, "e");
if (crc32("SDVVArPx",8) == 780060887) strcat(s, "U");
if (crc32("ccdLLHRApz",10) == 4095001533) strcat(s, "n");
if (crc32("XXPZUn",6) == 893407503) strcat(s, "B");
if (crc32("MYOLKzfEh",9) == 3774356364) strcat(s, "e");
if (crc32("enloidMNdw",10) == 631017861) strcat(s, "r");
if (crc32("JMaMzYywt",9) == 2151827701) strcat(s, "A");
if (crc32("lJmFc",5) == 1558074650) strcat(s, "a");
if (crc32("iMWuXzoCwTLNqb",14) == 605075721) strcat(s, "q");
if (crc32("bKrWt",5) == 2619526788) strcat(s, "t");
if (crc32("GORTK",5) == 2152060363) strcat(s, "v");
if (crc32("kIMnRpMvAJR",11) == 1066744932) strcat(s, "i");
if (crc32("IhrjtYk",7) == 2637191274) strcat(s, "v");
if (crc32("hqIvPRfiS",9) == 1017177787) strcat(s, "H");
if (crc32("IGUQiOrWIX",10) == 3122977233) strcat(s, "e");
if (crc32("eDSZDkdzPS",10) == 3571870075) strcat(s, "l");
if (crc32("XhPsXkDoEGmjZn",14) == 3177866576) strcat(s, "y");
    return s;
}

char *quite_adverbs() {
    char *s = calloc(6);
    if (crc32("bMSCEQv",7) == 3566565168) strcat(s, "k");
if (crc32("PforMmSSY",9) == 1027581994) strcat(s, "q");
if (crc32("Ouiyje",6) == 3241839369) strcat(s, "u");
if (crc32("ChxbscgfPmgIS",13) == 3631663420) strcat(s, "i");
if (crc32("wsKPDjDnkNchv",13) == 1548717836) strcat(s, "t");
if (crc32("inFSGmuTajTHX",13) == 148806888) strcat(s, "v");
if (crc32("GyiiVS",6) == 1224125299) strcat(s, "e");
    return s;
}

char *nonviviparously_adverbs() {
    char *s = calloc(16);
    if (crc32("vgSji",5) == 1541170604) strcat(s, "f");
if (crc32("dqwFDa",6) == 3393885960) strcat(s, "n");
if (crc32("ofgvGjlgQRGcN",13) == 739876151) strcat(s, "D");
if (crc32("ocsxwe",6) == 3896270285) strcat(s, "o");
if (crc32("cSLQKNxUtWHf",12) == 1114923199) strcat(s, "n");
if (crc32("Tqtzvpsol",9) == 4138235556) strcat(s, "v");
if (crc32("ecUZDoiOIwzGUZS",15) == 959951) strcat(s, "m");
if (crc32("VIxoQDcI",8) == 2652501561) strcat(s, "i");
if (crc32("VCegScBlCIFoE",13) == 600611308) strcat(s, "v");
if (crc32("PJKePfmROfiOa",13) == 524322434) strcat(s, "i");
if (crc32("wNbkokhmjiLku",13) == 4015782411) strcat(s, "h");
if (crc32("MzeZLqzv",8) == 1568632356) strcat(s, "p");
if (crc32("VvqEXZyuG",9) == 3589772694) strcat(s, "a");
if (crc32("NklQatzkxCzDF",13) == 3867452066) strcat(s, "K");
if (crc32("XkGtCiLPECMoo",13) == 4243252582) strcat(s, "r");
if (crc32("QTXZLhvQMDcgSDo",15) == 2970636452) strcat(s, "o");
if (crc32("eIFpvzZwU",9) == 2325838614) strcat(s, "L");
if (crc32("LHqaWF",6) == 1359491556) strcat(s, "u");
if (crc32("EZSzHLwHYROK",12) == 3350428369) strcat(s, "Q");
if (crc32("biixIVXvJhuu",12) == 3531498061) strcat(s, "s");
if (crc32("ywwQvvf",7) == 1194339608) strcat(s, "l");
if (crc32("GNnOECZo",8) == 2694260566) strcat(s, "G");
if (crc32("TYHwTWElHjynW",13) == 1872410535) strcat(s, "y");
    return s;
}

char *foamingly_adverbs() {
    char *s = calloc(10);
    if (crc32("JswZpxjbjyO",11) == 105926821) strcat(s, "f");
if (crc32("DVAjxfpXd",9) == 3469559946) strcat(s, "W");
if (crc32("cqCqPpk",7) == 2994691476) strcat(s, "o");
if (crc32("mEQNdZt",7) == 247645174) strcat(s, "a");
if (crc32("uOoVRYzj",8) == 134089157) strcat(s, "m");
if (crc32("PiajjuV",7) == 4102755909) strcat(s, "i");
if (crc32("EVUBLon",7) == 3514888284) strcat(s, "r");
if (crc32("YPAYQuXHdcDpe",13) == 3173707767) strcat(s, "n");
if (crc32("kANYSXPhSbEnxc",14) == 1778712142) strcat(s, "g");
if (crc32("BAlfaInXogERW",13) == 260735930) strcat(s, "l");
if (crc32("wjMtQxfHeMqOO",13) == 84185730) strcat(s, "y");
    return s;
}

char *unrudely_adverbs() {
    char *s = calloc(9);
    if (crc32("seUaeC",6) == 1097152093) strcat(s, "A");
if (crc32("pDZxuupdr",9) == 1561447371) strcat(s, "u");
if (crc32("EKabksIvuDVaO",13) == 3624109388) strcat(s, "c");
if (crc32("OVmKJHOCoJet",12) == 2931380492) strcat(s, "n");
if (crc32("nUCKdKUFvFc",11) == 3556686119) strcat(s, "r");
if (crc32("BLQqi",5) == 1525141117) strcat(s, "u");
if (crc32("JMgnG",5) == 3812718762) strcat(s, "d");
if (crc32("SVxkFelJwtW",11) == 3225475881) strcat(s, "e");
if (crc32("zPQMhIDrUyswmxo",15) == 1224050699) strcat(s, "g");
if (crc32("YvOzZvxdnUg",11) == 3740520099) strcat(s, "l");
if (crc32("TAPCVrpMZqM",11) == 898095219) strcat(s, "n");
if (crc32("GAdlgopstsOzf",13) == 1620184069) strcat(s, "y");
    return s;
}

char *designedly_adverbs() {
    char *s = calloc(11);
    if (crc32("xHwzFPC",7) == 1854097459) strcat(s, "S");
if (crc32("IpAqtdCdjhs",11) == 2565202226) strcat(s, "d");
if (crc32("vSvIdhTH",8) == 3253259150) strcat(s, "e");
if (crc32("PWyurASgxJP",11) == 848757296) strcat(s, "P");
if (crc32("XGIjKdhqrW",10) == 2686723043) strcat(s, "s");
if (crc32("FAfMb",5) == 2550719234) strcat(s, "i");
if (crc32("ggWKnIJNlsmZJ",13) == 2084283069) strcat(s, "c");
if (crc32("pvCruiS",7) == 1719521564) strcat(s, "g");
if (crc32("KrFtHxY",7) == 694983343) strcat(s, "v");
if (crc32("NBNeqFqMJA",10) == 3242572567) strcat(s, "n");
if (crc32("fiVaK",5) == 1671912837) strcat(s, "e");
if (crc32("rRcUzfCgsvaWj",13) == 3703594001) strcat(s, "X");
if (crc32("ycDAEfFTefAt",12) == 916026179) strcat(s, "d");
if (crc32("XqSjypPmNurFhy",14) == 3344590836) strcat(s, "P");
if (crc32("EhnxuVElQMJT",12) == 2010522144) strcat(s, "l");
if (crc32("xdxzBvLhO",9) == 2035498777) strcat(s, "F");
if (crc32("lXuUGMP",7) == 2804881571) strcat(s, "y");
    return s;
}

char *gyroidally_adverbs() {
    char *s = calloc(11);
    if (crc32("deKguVQj",8) == 4064862020) strcat(s, "Q");
if (crc32("MyeJlIvmQR",10) == 2935299047) strcat(s, "g");
if (crc32("EtKrOPHIUjYepHl",15) == 692656157) strcat(s, "y");
if (crc32("UYXZx",5) == 3098349467) strcat(s, "B");
if (crc32("rHAlekaPZIvpMgr",15) == 247128107) strcat(s, "r");
if (crc32("TwgUYiMJRuMJzE",14) == 771473116) strcat(s, "o");
if (crc32("NXlwiEzRdgpThH",14) == 1100414275) strcat(s, "U");
if (crc32("ykqgzIJpeVY",11) == 1398829781) strcat(s, "i");
if (crc32("FqHWaO",6) == 27774893) strcat(s, "d");
if (crc32("MQhXcAEEFJkjqiz",15) == 439247107) strcat(s, "a");
if (crc32("huHgr",5) == 1762954766) strcat(s, "t");
if (crc32("SWrxq",5) == 2027584375) strcat(s, "l");
if (crc32("qPLDmHzZcCCIRv",14) == 753384118) strcat(s, "f");
if (crc32("sDaeWTbXoKK",11) == 1697318287) strcat(s, "l");
if (crc32("ZAwSlApaiJ",10) == 2248815843) strcat(s, "I");
if (crc32("IeatB",5) == 95287117) strcat(s, "y");
    return s;
}

char *directively_adverbs() {
    char *s = calloc(12);
    if (crc32("vdFJURMpSYVsbPI",15) == 2670750365) strcat(s, "d");
if (crc32("GXxyalNmBUUXnA",14) == 2245126137) strcat(s, "i");
if (crc32("CauSnC",6) == 1103829693) strcat(s, "X");
if (crc32("cOOQCZWXjEZG",12) == 3628624565) strcat(s, "r");
if (crc32("aUSzUabQqxPNRZT",15) == 2223644799) strcat(s, "e");
if (crc32("ohDOsEjh",8) == 3473190247) strcat(s, "f");
if (crc32("zKUKZHtgyf",10) == 865331321) strcat(s, "c");
if (crc32("pZvQMvWIhkv",11) == 3431317101) strcat(s, "t");
if (crc32("NJdLnB",6) == 951842866) strcat(s, "i");
if (crc32("tuAqqFWkEmNo",12) == 2721478717) strcat(s, "v");
if (crc32("pbVECJYY",8) == 318627694) strcat(s, "e");
if (crc32("cEwKGMRPtcDL",12) == 4046893683) strcat(s, "l");
if (crc32("lbxibiuATsXmijh",15) == 2458950217) strcat(s, "y");
    return s;
}

char *deucedly_adverbs() {
    char *s = calloc(9);
    if (crc32("oJFHAPZAtIJxu",13) == 1878725216) strcat(s, "C");
if (crc32("rtaupABEMvI",11) == 896656956) strcat(s, "d");
if (crc32("HoaldkYBXFsANY",14) == 3218589712) strcat(s, "e");
if (crc32("UpcZlBtQaSEPMK",14) == 1089461567) strcat(s, "e");
if (crc32("wehkhfduRa",10) == 3452385856) strcat(s, "u");
if (crc32("IyDAgJ",6) == 3777418948) strcat(s, "D");
if (crc32("IpmRT",5) == 1551540209) strcat(s, "c");
if (crc32("PTHjvbtUcQv",11) == 3992283180) strcat(s, "e");
if (crc32("toGCUFtUI",9) == 1976604662) strcat(s, "r");
if (crc32("rvuAIn",6) == 665982796) strcat(s, "d");
if (crc32("gtLNWYLQYebJ",12) == 445061215) strcat(s, "I");
if (crc32("fGpIFfu",7) == 524735469) strcat(s, "l");
if (crc32("UDxUNQFSMQQL",12) == 1789089468) strcat(s, "x");
if (crc32("mcJrucdoF",9) == 2574619803) strcat(s, "y");
    return s;
}

char *convenably_adverbs() {
    char *s = calloc(11);
    if (crc32("gvxYhlI",7) == 831413310) strcat(s, "V");
if (crc32("sXRkYAQw",8) == 1392455231) strcat(s, "c");
if (crc32("eZzAmM",6) == 918317032) strcat(s, "o");
if (crc32("ahUWebeGlPzilz",14) == 552903532) strcat(s, "L");
if (crc32("VoKxIXzmbY",10) == 1592768427) strcat(s, "n");
if (crc32("BxiLsgiuwLxBYs",14) == 2247598934) strcat(s, "X");
if (crc32("MXqDpEoOaBrOXXV",15) == 3914644983) strcat(s, "v");
if (crc32("whcRwMHKKjglqyZ",15) == 2925664226) strcat(s, "e");
if (crc32("TRlsuAyDpbR",11) == 703125890) strcat(s, "z");
if (crc32("diUufJlKqV",10) == 489538542) strcat(s, "n");
if (crc32("cYTmHYGY",8) == 3958667319) strcat(s, "a");
if (crc32("FTHALlGmet",10) == 2690741077) strcat(s, "o");
if (crc32("YmKxsILqNCwj",12) == 3876339206) strcat(s, "b");
if (crc32("DuAIkBSE",8) == 4015758631) strcat(s, "l");
if (crc32("szNwARClN",9) == 1053006030) strcat(s, "y");
    return s;
}

char *subpellucidly_adverbs() {
    char *s = calloc(14);
    if (crc32("LXQiiYjTgfUST",13) == 2579252816) strcat(s, "D");
if (crc32("eSazFlFtCI",10) == 2010293267) strcat(s, "s");
if (crc32("STcXvleLyNz",11) == 748545303) strcat(s, "u");
if (crc32("kPIlhlfFzRVsHS",14) == 3731492632) strcat(s, "m");
if (crc32("sKoils",6) == 928031811) strcat(s, "b");
if (crc32("wXLkkMBzCPMNGdx",15) == 2100412436) strcat(s, "p");
if (crc32("AWfmFZf",7) == 557298702) strcat(s, "e");
if (crc32("yGxlmgQCXmob",12) == 999060962) strcat(s, "X");
if (crc32("vlWgAaFcW",9) == 951459584) strcat(s, "l");
if (crc32("jShchcshV",9) == 1000223681) strcat(s, "l");
if (crc32("qsglxqEMwMh",11) == 1200089819) strcat(s, "u");
if (crc32("xYJgYoSDoDe",11) == 1286935301) strcat(s, "l");
if (crc32("bnpztkCmVjvHL",13) == 2865265967) strcat(s, "c");
if (crc32("klKxZTPXDrue",12) == 2896437638) strcat(s, "Y");
if (crc32("MHaQLG",6) == 806857538) strcat(s, "i");
if (crc32("nFEXWh",6) == 746166174) strcat(s, "d");
if (crc32("DfeZtezHyv",10) == 2828173475) strcat(s, "S");
if (crc32("EjNsffXimyrvU",13) == 2957762478) strcat(s, "l");
if (crc32("jdbxZEysE",9) == 122736677) strcat(s, "y");
    return s;
}

char *misapprehendingly_adverbs() {
    char *s = calloc(18);
    if (crc32("XeUPa",5) == 1973781889) strcat(s, "q");
if (crc32("BTSFOcyYfHRbEeG",15) == 3622591772) strcat(s, "m");
if (crc32("ukNmGcoYuNFiLL",14) == 3567403438) strcat(s, "i");
if (crc32("HxeYvIbIMz",10) == 4151154439) strcat(s, "E");
if (crc32("MPiWBKRZTdIK",12) == 1127457672) strcat(s, "s");
if (crc32("iGAkCxNsTKFj",12) == 3482925140) strcat(s, "x");
if (crc32("ZnOfoUWjIYvHGgJ",15) == 4107841697) strcat(s, "a");
if (crc32("suefDIVqgWBMfcc",15) == 3722928051) strcat(s, "p");
if (crc32("aluOYSzF",8) == 206394549) strcat(s, "W");
if (crc32("plCTtcVOuoX",11) == 1602304710) strcat(s, "p");
if (crc32("kAzfMQOBYZ",10) == 2951364106) strcat(s, "T");
if (crc32("qcVXmXxB",8) == 3118855275) strcat(s, "r");
if (crc32("JfoujTj",7) == 1029196471) strcat(s, "R");
if (crc32("NVEMzaIRJOLmd",13) == 2351145340) strcat(s, "e");
if (crc32("dsIcWvZeqRnOVw",14) == 4174633195) strcat(s, "A");
if (crc32("RDgWAtmL",8) == 2194583812) strcat(s, "h");
if (crc32("iqLVEDYxhTVpw",13) == 1560929293) strcat(s, "e");
if (crc32("dTwAEHz",7) == 3824282858) strcat(s, "n");
if (crc32("HktrFcEPWISsjP",14) == 1459789797) strcat(s, "t");
if (crc32("kTuFiGYWrPfHBF",14) == 565056904) strcat(s, "d");
if (crc32("yNhUKL",6) == 2184098624) strcat(s, "i");
if (crc32("FTvPYDdENnZM",12) == 1829350485) strcat(s, "n");
if (crc32("oHqLeEDwqbX",11) == 3584494731) strcat(s, "o");
if (crc32("fWUelJVyLosretW",15) == 3314117860) strcat(s, "g");
if (crc32("NiPxeJJWuKgrIK",14) == 2297147642) strcat(s, "y");
if (crc32("edPyJFl",7) == 1720261707) strcat(s, "l");
if (crc32("jJTGB",5) == 2767154258) strcat(s, "Q");
if (crc32("GHCOkyIJhWNiN",13) == 1799399674) strcat(s, "y");
    return s;
}

char *dwarfishly_adverbs() {
    char *s = calloc(11);
    if (crc32("MQEvOMa",7) == 2776732311) strcat(s, "d");
if (crc32("UkUDYFJTWuiq",12) == 3917742403) strcat(s, "w");
if (crc32("vHASNjNezGLG",12) == 1425822766) strcat(s, "a");
if (crc32("IhDlwkGzDjjWMpM",15) == 3283418564) strcat(s, "J");
if (crc32("KwJtYTvTKxrjoe",14) == 2902379603) strcat(s, "r");
if (crc32("WfjoAk",6) == 3250654045) strcat(s, "v");
if (crc32("fujThRGt",8) == 3505423675) strcat(s, "f");
if (crc32("BGsoilk",7) == 3585904740) strcat(s, "i");
if (crc32("khptxEwyiX",10) == 2456046498) strcat(s, "s");
if (crc32("BwhlUgzJh",9) == 1043590738) strcat(s, "k");
if (crc32("onRHfcR",7) == 1240522255) strcat(s, "h");
if (crc32("nCzzqmOBmA",10) == 2836549025) strcat(s, "t");
if (crc32("domtmrqSZRY",11) == 1690330894) strcat(s, "l");
if (crc32("tqBMl",5) == 1799238526) strcat(s, "y");
    return s;
}

char *quasiinfinitely_adverbs() {
    char *s = calloc(16);
    if (crc32("TyiTFSQAN",9) == 3132202930) strcat(s, "o");
if (crc32("BPxPAKZ",7) == 2847071910) strcat(s, "q");
if (crc32("EBfKx",5) == 1713727680) strcat(s, "u");
if (crc32("EmGAsniOrwizX",13) == 1647631985) strcat(s, "X");
if (crc32("lKWAD",5) == 668299669) strcat(s, "a");
if (crc32("FgVglbKuDLKFM",13) == 1991000857) strcat(s, "s");
if (crc32("UxJWbEMeUAq",11) == 3634362575) strcat(s, "i");
if (crc32("UvTKk",5) == 4134423180) strcat(s, "n");
if (crc32("Iupxh",5) == 1063186255) strcat(s, "i");
if (crc32("XenYGMwlR",9) == 3653130631) strcat(s, "n");
if (crc32("pICKoqQnDpjHJSO",15) == 965037456) strcat(s, "f");
if (crc32("oClxx",5) == 19497572) strcat(s, "u");
if (crc32("rkbjH",5) == 89219441) strcat(s, "i");
if (crc32("yYyfRXmRg",9) == 252106) strcat(s, "n");
if (crc32("nzHkF",5) == 2208167032) strcat(s, "i");
if (crc32("jdzStTQIvmxIC",13) == 2762386380) strcat(s, "t");
if (crc32("wRzPkSd",7) == 306307324) strcat(s, "e");
if (crc32("ecnqqUIhNoGD",12) == 3473273425) strcat(s, "a");
if (crc32("XoRdMfhWt",9) == 1528766476) strcat(s, "l");
if (crc32("fXsRhsPLvLKUqVy",15) == 1005306965) strcat(s, "y");
    return s;
}

char *quasifamously_adverbs() {
    char *s = calloc(14);
    if (crc32("MCjiThuHjbibLDr",15) == 2904224171) strcat(s, "J");
if (crc32("MqqGUnFBdd",10) == 1915677900) strcat(s, "q");
if (crc32("LcJRKTEHOyc",11) == 2677673148) strcat(s, "u");
if (crc32("LZwPOdWAhXnn",12) == 4260241303) strcat(s, "A");
if (crc32("VjTBWsueRnlftmR",15) == 2617282045) strcat(s, "a");
if (crc32("PIekBLRFhfvVMBI",15) == 239127105) strcat(s, "s");
if (crc32("CAZcPnnmhDzh",12) == 578639342) strcat(s, "i");
if (crc32("ehWLRLOOilJtEGk",15) == 3672288711) strcat(s, "r");
if (crc32("SPBgyYljNMjWCi",14) == 497084552) strcat(s, "f");
if (crc32("LQiKSsEVbfN",11) == 111949865) strcat(s, "k");
if (crc32("xeARDZWbtzWyta",14) == 4235188195) strcat(s, "a");
if (crc32("mPgLUTOphsbAhx",14) == 1182807425) strcat(s, "m");
if (crc32("bNjWVVimkNLQATx",15) == 881067999) strcat(s, "G");
if (crc32("sSJbcYyHOvi",11) == 2321983056) strcat(s, "o");
if (crc32("SeTmjLa",7) == 4035898201) strcat(s, "u");
if (crc32("EneKz",5) == 1411918975) strcat(s, "P");
if (crc32("GMjwKfWOQkQD",12) == 3261989748) strcat(s, "s");
if (crc32("vBENFSFMiMxFDSd",15) == 796068164) strcat(s, "l");
if (crc32("itjezeW",7) == 2020099953) strcat(s, "y");
    return s;
}

char *unmorosely_adverbs() {
    char *s = calloc(11);
    if (crc32("ZHHlGzHEU",9) == 4111004867) strcat(s, "u");
if (crc32("alHrRqNty",9) == 2458201499) strcat(s, "n");
if (crc32("oFbrPkCQixzy",12) == 325532651) strcat(s, "W");
if (crc32("OLFICHiy",8) == 4028166577) strcat(s, "m");
if (crc32("ppxucOEuRng",11) == 4289814027) strcat(s, "Q");
if (crc32("JpLsEPnPPeRqC",13) == 4190528816) strcat(s, "o");
if (crc32("lbRGhujsJLAhyiN",15) == 102337019) strcat(s, "h");
if (crc32("VjvAlfhGepq",11) == 551349591) strcat(s, "r");
if (crc32("clZwOnLhA",9) == 1090796574) strcat(s, "o");
if (crc32("VkwayWfyxeUHNHE",15) == 3557068116) strcat(s, "y");
if (crc32("lpanuAoZ",8) == 2949044158) strcat(s, "s");
if (crc32("UxehazlngngnHh",14) == 1688381432) strcat(s, "i");
if (crc32("IIlREcundlKfV",13) == 3915690347) strcat(s, "e");
if (crc32("uUphuu",6) == 3597672631) strcat(s, "C");
if (crc32("jrYldd",6) == 658065342) strcat(s, "l");
if (crc32("aLGCYcoAPGx",11) == 3993482450) strcat(s, "y");
    return s;
}

char *illadvisedly_adverbs() {
    char *s = calloc(13);
    if (crc32("kjHRjvPjOxLpS",13) == 289811876) strcat(s, "L");
if (crc32("xUZhUSBLmsf",11) == 2095307134) strcat(s, "i");
if (crc32("TWJAHAutIYSYUt",14) == 528120530) strcat(s, "i");
if (crc32("dpIpSkQoG",9) == 1699760696) strcat(s, "l");
if (crc32("OcXHt",5) == 947220296) strcat(s, "l");
if (crc32("NtXYfmmWPdghRb",14) == 594410108) strcat(s, "w");
if (crc32("IFCsi",5) == 1864239764) strcat(s, "a");
if (crc32("fAWwQajmR",9) == 1250810218) strcat(s, "d");
if (crc32("LriDwY",6) == 155075567) strcat(s, "v");
if (crc32("rAplhv",6) == 1735767358) strcat(s, "k");
if (crc32("ndedUEUnaT",10) == 2834551544) strcat(s, "i");
if (crc32("MvuOUudlXCekdd",14) == 3316942254) strcat(s, "s");
if (crc32("xZLJM",5) == 786294772) strcat(s, "H");
if (crc32("KvNBwSIQVxQ",11) == 242073856) strcat(s, "e");
if (crc32("NjjChP",6) == 1036378618) strcat(s, "x");
if (crc32("WsGvePBVhjKJUsI",15) == 263151777) strcat(s, "d");
if (crc32("mIhgKbhSojLAfUs",15) == 3137309015) strcat(s, "l");
if (crc32("OfyoZkNMOzPI",12) == 4278801354) strcat(s, "y");
    return s;
}

char *nonSabbatically_adverbs() {
    char *s = calloc(16);
    if (crc32("CXXUgJSo",8) == 1430504036) strcat(s, "n");
if (crc32("giJfWYwF",8) == 874425322) strcat(s, "P");
if (crc32("loqQtt",6) == 2001732791) strcat(s, "o");
if (crc32("mgNFKgIEhbHZGdJ",15) == 2234967354) strcat(s, "G");
if (crc32("ebyUlrzNM",9) == 3850713924) strcat(s, "n");
if (crc32("KTyPNjR",7) == 331557439) strcat(s, "S");
if (crc32("XLKhz",5) == 806945225) strcat(s, "F");
if (crc32("kPGyI",5) == 1743068717) strcat(s, "a");
if (crc32("RrwRIfahpZR",11) == 4262881953) strcat(s, "b");
if (crc32("fzSej",5) == 264614469) strcat(s, "b");
if (crc32("IkUALjHlAqbSY",13) == 2444292402) strcat(s, "n");
if (crc32("QdFWFStHe",9) == 3109685797) strcat(s, "a");
if (crc32("LwhpjxkFH",9) == 753832200) strcat(s, "t");
if (crc32("uzNHf",5) == 367491568) strcat(s, "i");
if (crc32("zfnNADui",8) == 1475669479) strcat(s, "c");
if (crc32("KXqtFbhtRydBB",13) == 4181877197) strcat(s, "a");
if (crc32("MHqUUOa",7) == 502461716) strcat(s, "C");
if (crc32("GQqGneLWjGJpPZ",14) == 4063520404) strcat(s, "l");
if (crc32("bxSHUvpqlUJvV",13) == 3034284094) strcat(s, "e");
if (crc32("PNpyMJVsPU",10) == 562042305) strcat(s, "l");
if (crc32("IXgxWUkLfbuvzFg",15) == 2128439981) strcat(s, "y");
    return s;
}

char *phenotypically_adverbs() {
    char *s = calloc(15);
    if (crc32("WZxluATKaF",10) == 2300066567) strcat(s, "p");
if (crc32("fLsvCdR",7) == 3095327599) strcat(s, "t");
if (crc32("aBIOMnPqUexr",12) == 1871548963) strcat(s, "h");
if (crc32("GiBnNxMhIWtrLr",14) == 335244299) strcat(s, "p");
if (crc32("XjDbJbNAGGzgVC",14) == 1566501395) strcat(s, "e");
if (crc32("vqMxeHDULYbhMA",14) == 513394498) strcat(s, "n");
if (crc32("NxaGFQbQ",8) == 930079357) strcat(s, "o");
if (crc32("oCyZomWrKy",10) == 617262695) strcat(s, "T");
if (crc32("AAxFmjUTK",9) == 2898722348) strcat(s, "t");
if (crc32("sZWMixDxCvPMqX",14) == 704882852) strcat(s, "y");
if (crc32("EvevdDefZCst",12) == 1582123828) strcat(s, "p");
if (crc32("JcHOE",5) == 4063024565) strcat(s, "i");
if (crc32("aTCRJ",5) == 628503128) strcat(s, "l");
if (crc32("YoHHn",5) == 2085087448) strcat(s, "c");
if (crc32("MJaVyVfalmz",11) == 806604510) strcat(s, "a");
if (crc32("RwSTSLwqNrEUwsb",15) == 2898249927) strcat(s, "l");
if (crc32("aesHLAJnvLYSmR",14) == 266363627) strcat(s, "l");
if (crc32("VXPnmJWkDxOqEkD",15) == 4053605510) strcat(s, "y");
    return s;
}

char *quasipatriotically_adverbs() {
    char *s = calloc(19);
    if (crc32("GUNGVOfuVlRMT",13) == 3754035497) strcat(s, "B");
if (crc32("RvOCyQ",6) == 3576481055) strcat(s, "q");
if (crc32("TFuWwjmRReDAR",13) == 3872722009) strcat(s, "u");
if (crc32("YtZXJpGt",8) == 3658666185) strcat(s, "a");
if (crc32("tpnSZwAogb",10) == 873699069) strcat(s, "s");
if (crc32("cMdAPZcgeEi",11) == 2437395992) strcat(s, "R");
if (crc32("GbnJXuYOwgOJQ",13) == 1704959619) strcat(s, "i");
if (crc32("RNtiBYi",7) == 2046940213) strcat(s, "p");
if (crc32("MMhcrPDLIJry",12) == 78680665) strcat(s, "a");
if (crc32("BtqakzEPKIfUS",13) == 3182467774) strcat(s, "t");
if (crc32("BFYRQ",5) == 1147015235) strcat(s, "m");
if (crc32("VeASBwvNjhJRGEP",15) == 1454976594) strcat(s, "r");
if (crc32("daXalxppoxlqjLm",15) == 853518234) strcat(s, "i");
if (crc32("sECbFhcEZWrf",12) == 3041222280) strcat(s, "o");
if (crc32("noJruCkjIcQdaSh",15) == 4257210827) strcat(s, "t");
if (crc32("DdLedxW",7) == 1921066356) strcat(s, "i");
if (crc32("AjrElndQSc",10) == 4251187862) strcat(s, "t");
if (crc32("QfmaSEfinAEmdOo",15) == 3027504371) strcat(s, "c");
if (crc32("vGZPuwqyquaM",12) == 2672074466) strcat(s, "a");
if (crc32("RgozY",5) == 2800504893) strcat(s, "l");
if (crc32("CtAVPnAnJuXPbuY",15) == 2223346453) strcat(s, "l");
if (crc32("EUumv",5) == 2819132250) strcat(s, "D");
if (crc32("eCSpJyI",7) == 1431495396) strcat(s, "y");
    return s;
}

char *ductilely_adverbs() {
    char *s = calloc(10);
    if (crc32("TMYVGIrAXURbH",13) == 1896153824) strcat(s, "V");
if (crc32("nbgtu",5) == 1470883165) strcat(s, "d");
if (crc32("aqqXtcfsdIVJuw",14) == 1108737626) strcat(s, "u");
if (crc32("DPgvbIBHWDNIVZ",14) == 2921441611) strcat(s, "c");
if (crc32("FxbqfmilHnJtuIh",15) == 1605658543) strcat(s, "t");
if (crc32("adTZU",5) == 3142006555) strcat(s, "y");
if (crc32("YvKkvGCQkIFW",12) == 3549461164) strcat(s, "i");
if (crc32("clMDGDknnR",10) == 243926887) strcat(s, "l");
if (crc32("ZFQzUTWcmR",10) == 527316300) strcat(s, "W");
if (crc32("XvsUwsICWRjA",12) == 2578734179) strcat(s, "e");
if (crc32("FXRRXuXbfWPJtJ",14) == 2195856226) strcat(s, "D");
if (crc32("GFuQNaduB",9) == 731327849) strcat(s, "l");
if (crc32("GxeSZGHmT",9) == 3328639695) strcat(s, "y");
    return s;
}

char *ever_adverbs() {
    char *s = calloc(5);
    if (crc32("OFTTzigugFAv",12) == 486624188) strcat(s, "e");
if (crc32("RmpltuW",7) == 3788577400) strcat(s, "v");
if (crc32("NBcaBJoSXyRW",12) == 2023899163) strcat(s, "e");
if (crc32("BSAIog",6) == 3056782536) strcat(s, "i");
if (crc32("INqMmuwIjcn",11) == 2924151245) strcat(s, "r");
    return s;
}

char *mythically_adverbs() {
    char *s = calloc(11);
    if (crc32("UaqVCLhxK",9) == 213242335) strcat(s, "R");
if (crc32("UCkQahVMKE",10) == 3128871193) strcat(s, "m");
if (crc32("xuifVdGPvctiZ",13) == 1337586610) strcat(s, "y");
if (crc32("XvUBDa",6) == 3121677649) strcat(s, "k");
if (crc32("BBlWiGg",7) == 764960904) strcat(s, "t");
if (crc32("HvNsZwrljWmVQa",14) == 2841161615) strcat(s, "t");
if (crc32("AfpVRo",6) == 893012742) strcat(s, "h");
if (crc32("aPDhzEicdyg",11) == 191929226) strcat(s, "i");
if (crc32("mAUYVA",6) == 3268633606) strcat(s, "T");
if (crc32("PesjILoD",8) == 3153514140) strcat(s, "c");
if (crc32("sAUGpQwX",8) == 278853670) strcat(s, "a");
if (crc32("HLfuAEFpJCZmpBX",15) == 967634214) strcat(s, "l");
if (crc32("jqpVkzJ",7) == 1648082739) strcat(s, "l");
if (crc32("OfmggGr",7) == 3633444855) strcat(s, "W");
if (crc32("BMFLeTwulXtl",12) == 1709157267) strcat(s, "l");
if (crc32("rATuDb",6) == 3007825067) strcat(s, "y");
    return s;
}

char *statically_adverbs() {
    char *s = calloc(11);
    if (crc32("dBYnFzxfXsLo",12) == 413171851) strcat(s, "H");
if (crc32("MvVVBrrkVyGT",12) == 2834532280) strcat(s, "s");
if (crc32("WnTbdJXWoGUhJ",13) == 3146593353) strcat(s, "U");
if (crc32("xlsCiAiatSmA",12) == 73544255) strcat(s, "t");
if (crc32("hGLhb",5) == 515587690) strcat(s, "a");
if (crc32("weScWjOCJblF",12) == 1161560073) strcat(s, "t");
if (crc32("taIHT",5) == 2840770804) strcat(s, "S");
if (crc32("azyPZxoHpGGm",12) == 3023053792) strcat(s, "i");
if (crc32("pEGZdO",6) == 2867413531) strcat(s, "c");
if (crc32("cEvmrWHcDgDcK",13) == 2382283959) strcat(s, "a");
if (crc32("UoRtTXTj",8) == 494798559) strcat(s, "l");
if (crc32("VILswQWQN",9) == 3403607199) strcat(s, "g");
if (crc32("Vekitbp",7) == 2041240410) strcat(s, "l");
if (crc32("HBGPNRKw",8) == 2946445567) strcat(s, "y");
    return s;
}

char *unconstructively_adverbs() {
    char *s = calloc(17);
    if (crc32("FmkWbKuT",8) == 1631365343) strcat(s, "K");
if (crc32("DEPgXDtCegEwb",13) == 637766424) strcat(s, "u");
if (crc32("tdfBP",5) == 2605324967) strcat(s, "n");
if (crc32("imdSppD",7) == 946939595) strcat(s, "N");
if (crc32("sczFYVHNWYz",11) == 1902150990) strcat(s, "c");
if (crc32("iEcUfLVK",8) == 2818883033) strcat(s, "o");
if (crc32("DxwUkeruFFprLN",14) == 635529100) strcat(s, "Z");
if (crc32("wNeDBOMBFvWhpXD",15) == 2630226956) strcat(s, "n");
if (crc32("OzapPxuwykYGj",13) == 1913509279) strcat(s, "A");
if (crc32("pdJYAk",6) == 1922307613) strcat(s, "s");
if (crc32("QoLGeZKyxR",10) == 2520011110) strcat(s, "t");
if (crc32("wZzwZNbq",8) == 3530340676) strcat(s, "m");
if (crc32("jAHHNzUCpTZTRoU",15) == 3738219850) strcat(s, "r");
if (crc32("HocDNgr",7) == 1209019224) strcat(s, "D");
if (crc32("aJRCmJ",6) == 900428896) strcat(s, "u");
if (crc32("GUJGBQwyxiEw",12) == 325332896) strcat(s, "g");
if (crc32("zqrotY",6) == 76609491) strcat(s, "c");
if (crc32("LJNlXZNjoFHuxi",14) == 299148970) strcat(s, "t");
if (crc32("LvaqIdG",7) == 571439988) strcat(s, "i");
if (crc32("cmZbastJsB",10) == 1494380890) strcat(s, "R");
if (crc32("AqxJt",5) == 1999530591) strcat(s, "v");
if (crc32("PosqxvH",7) == 3837490448) strcat(s, "Q");
if (crc32("RfkQeSONs",9) == 3054553006) strcat(s, "e");
if (crc32("yAIHXKfFfKfQzy",14) == 3283534538) strcat(s, "c");
if (crc32("GYzrnGNt",8) == 1310910762) strcat(s, "l");
if (crc32("HSfnVeBRyc",10) == 391333879) strcat(s, "y");
    return s;
}

char *equidistantly_adverbs() {
    char *s = calloc(14);
    if (crc32("gcHNrdQVEahuOIJ",15) == 2766297524) strcat(s, "e");
if (crc32("ukRxLESGfSLMf",13) == 987018974) strcat(s, "q");
if (crc32("vcwxji",6) == 1663870292) strcat(s, "D");
if (crc32("ivJPSBg",7) == 4162076235) strcat(s, "u");
if (crc32("iALmGAzapzUCNFd",15) == 4032769834) strcat(s, "i");
if (crc32("sjQVpeuoGLaYh",13) == 2285164889) strcat(s, "Z");
if (crc32("bFLKCH",6) == 756282075) strcat(s, "d");
if (crc32("ZWfPAmtK",8) == 1760724755) strcat(s, "i");
if (crc32("jMPgDUmiZkbMKh",14) == 810428634) strcat(s, "s");
if (crc32("hbkWJ",5) == 3644765125) strcat(s, "t");
if (crc32("YbapaYWFGXcn",12) == 4038842304) strcat(s, "a");
if (crc32("yJpqwqGeEv",10) == 3926390706) strcat(s, "n");
if (crc32("YGrWYyexWbYwZ",13) == 1956271507) strcat(s, "c");
if (crc32("lnxACcwwMqY",11) == 1248013296) strcat(s, "t");
if (crc32("afsFV",5) == 245484404) strcat(s, "l");
if (crc32("wPadKAmDuJrHtpu",15) == 841152330) strcat(s, "l");
if (crc32("lyTAMnD",7) == 3789631110) strcat(s, "y");
    return s;
}

char *nonrandomly_adverbs() {
    char *s = calloc(12);
    if (crc32("bEVsWnxcCNdZR",13) == 2052790015) strcat(s, "S");
if (crc32("TdQrV",5) == 1300911472) strcat(s, "n");
if (crc32("KRgTUmcmizN",11) == 1576200196) strcat(s, "P");
if (crc32("ivrtb",5) == 2748194265) strcat(s, "o");
if (crc32("CAkWWOQp",8) == 385181735) strcat(s, "n");
if (crc32("olcEwrWcreiFW",13) == 862957156) strcat(s, "r");
if (crc32("tQLFwblnzyKy",12) == 3131057862) strcat(s, "d");
if (crc32("OZxlSHgEULtUcX",14) == 313909620) strcat(s, "a");
if (crc32("EsZZwLVujcNdDab",15) == 2981569358) strcat(s, "n");
if (crc32("hqaTvYne",8) == 2210053344) strcat(s, "v");
if (crc32("cCuljf",6) == 102685540) strcat(s, "d");
if (crc32("HiLdmcFtsuxcvV",14) == 3142080633) strcat(s, "j");
if (crc32("ASozqloggGZH",12) == 1627724205) strcat(s, "o");
if (crc32("CKajxwfrWJXIF",13) == 2474434317) strcat(s, "y");
if (crc32("ITeDlK",6) == 120262034) strcat(s, "m");
if (crc32("abOvUmzGLKTF",12) == 2000333995) strcat(s, "l");
if (crc32("srUbHod",7) == 3212071973) strcat(s, "Z");
if (crc32("iLNCbCkNHewymi",14) == 309007464) strcat(s, "y");
    return s;
}

char *unsynonymously_adverbs() {
    char *s = calloc(15);
    if (crc32("LBVhaCtKhWic",12) == 3003033368) strcat(s, "u");
if (crc32("MvxUbeq",7) == 610381955) strcat(s, "n");
if (crc32("CqHTMXdLlnP",11) == 539619637) strcat(s, "s");
if (crc32("UyQHQBhvnB",10) == 3129258855) strcat(s, "M");
if (crc32("ExlQuXHccUwODP",14) == 4113693231) strcat(s, "y");
if (crc32("zAKrmaTBp",9) == 2106780562) strcat(s, "n");
if (crc32("eMfqf",5) == 3722176408) strcat(s, "Q");
if (crc32("uMJFToUqsKckM",13) == 5508229) strcat(s, "o");
if (crc32("bingETaE",8) == 926362459) strcat(s, "M");
if (crc32("WtUiBz",6) == 1699833209) strcat(s, "n");
if (crc32("QIVcRPfwtIToj",13) == 3846404969) strcat(s, "y");
if (crc32("IMUeDgJcUoDdVwD",15) == 3512122923) strcat(s, "Y");
if (crc32("ASooQhshDQyl",12) == 1420378437) strcat(s, "m");
if (crc32("gkiHB",5) == 3865262428) strcat(s, "o");
if (crc32("aHwtRAYF",8) == 3011222224) strcat(s, "q");
if (crc32("wIrSXM",6) == 667268205) strcat(s, "u");
if (crc32("nctBBQbk",8) == 192776854) strcat(s, "u");
if (crc32("dIEwn",5) == 4037664098) strcat(s, "s");
if (crc32("FfpNLmileYpBhaB",15) == 1056398337) strcat(s, "z");
if (crc32("wgSBz",5) == 927211828) strcat(s, "l");
if (crc32("neDgAhVjs",9) == 3929592179) strcat(s, "y");
    return s;
}

char *quasicritically_adverbs() {
    char *s = calloc(16);
    if (crc32("hgAxJ",5) == 3506967023) strcat(s, "j");
if (crc32("xunNRfNEuYaOwnE",15) == 2282308588) strcat(s, "q");
if (crc32("NWEQVihkh",9) == 1950507835) strcat(s, "z");
if (crc32("snTgyfHS",8) == 2966815449) strcat(s, "u");
if (crc32("fYZEGmCczkyEY",13) == 1936730831) strcat(s, "a");
if (crc32("VRvwleyZdGjhL",13) == 2141134081) strcat(s, "s");
if (crc32("dzbHPbtji",9) == 1955395213) strcat(s, "i");
if (crc32("OgRLLXj",7) == 3549723824) strcat(s, "E");
if (crc32("aCjngOlDChk",11) == 2119108630) strcat(s, "c");
if (crc32("VfLVxivIdzo",11) == 2875954337) strcat(s, "r");
if (crc32("VUsTtM",6) == 1167951314) strcat(s, "A");
if (crc32("teAwTnhWFpbtHO",14) == 2963206078) strcat(s, "i");
if (crc32("VxjbQdHGBYRK",12) == 2356937247) strcat(s, "t");
if (crc32("nnFElRurvaV",11) == 1483324007) strcat(s, "X");
if (crc32("qeeAlmnvJm",10) == 973520972) strcat(s, "i");
if (crc32("IlcjfHuiI",9) == 2711232284) strcat(s, "c");
if (crc32("dLcLmXIeLz",10) == 2382646582) strcat(s, "k");
if (crc32("fMAxmrcr",8) == 893299647) strcat(s, "a");
if (crc32("ZdBtMif",7) == 2660203750) strcat(s, "a");
if (crc32("GTKhhGXR",8) == 561888311) strcat(s, "l");
if (crc32("PnVaMqeKLJR",11) == 3473460989) strcat(s, "l");
if (crc32("jmPnWRSsi",9) == 4207909433) strcat(s, "j");
if (crc32("zIrGXnuLA",9) == 4956283) strcat(s, "y");
    return s;
}

char *intersystematically_adverbs() {
    char *s = calloc(20);
    if (crc32("mLMfcAXPpnNvC",13) == 3759536214) strcat(s, "i");
if (crc32("piScSM",6) == 605052881) strcat(s, "n");
if (crc32("MQXYCoJKCgV",11) == 2666662996) strcat(s, "U");
if (crc32("mmEQJa",6) == 2510099474) strcat(s, "t");
if (crc32("POKQqbjdVB",10) == 3860482796) strcat(s, "e");
if (crc32("crEQeLjgYcPwu",13) == 2115850865) strcat(s, "L");
if (crc32("bnzNeGoEFT",10) == 3863390929) strcat(s, "r");
if (crc32("EoNTDJBfhgNy",12) == 1385375208) strcat(s, "s");
if (crc32("BGfOZXQpo",9) == 3415616280) strcat(s, "I");
if (crc32("iTMQPSutDWHLGk",14) == 2132889153) strcat(s, "y");
if (crc32("BxfjyNbopqUG",12) == 517289520) strcat(s, "s");
if (crc32("WYBNEnoKPJAFg",13) == 1366081220) strcat(s, "h");
if (crc32("WpCLcRfOY",9) == 3347696590) strcat(s, "t");
if (crc32("LEigs",5) == 2725702400) strcat(s, "v");
if (crc32("BhZUl",5) == 4167044316) strcat(s, "e");
if (crc32("MKXJOD",6) == 1489184849) strcat(s, "m");
if (crc32("RVmtKi",6) == 819347369) strcat(s, "v");
if (crc32("XRIBxFkBzTSpQ",13) == 2130405315) strcat(s, "a");
if (crc32("hReNkcprnxTj",12) == 428036840) strcat(s, "t");
if (crc32("qHYUmAKvsUVU",12) == 2348270082) strcat(s, "i");
if (crc32("IxqHIVhTxckF",12) == 1282473397) strcat(s, "c");
if (crc32("bgGWnnEocpE",11) == 3425551715) strcat(s, "a");
if (crc32("RiocPgJBMXJ",11) == 2629832983) strcat(s, "j");
if (crc32("vRIzwZEeb",9) == 733759459) strcat(s, "l");
if (crc32("LxOKZpUHpbQlJ",13) == 2867301162) strcat(s, "l");
if (crc32("PdfJODTeAb",10) == 3191739555) strcat(s, "y");
    return s;
}

char *prebarbarously_adverbs() {
    char *s = calloc(15);
    if (crc32("SoOVzxMmaNMvr",13) == 1203257819) strcat(s, "l");
if (crc32("qBUEMKPkaoWPS",13) == 969246508) strcat(s, "p");
if (crc32("TYtnAS",6) == 2932533523) strcat(s, "r");
if (crc32("iAFQeJBDt",9) == 870643989) strcat(s, "f");
if (crc32("fmiaX",5) == 1196173729) strcat(s, "e");
if (crc32("qLRxIFPmVtbhjiK",15) == 2450709317) strcat(s, "b");
if (crc32("XuzUAtgHJIFm",12) == 2312758293) strcat(s, "a");
if (crc32("UfFbvp",6) == 1486582059) strcat(s, "k");
if (crc32("TZbeiasAj",9) == 1280019886) strcat(s, "r");
if (crc32("lixulaUynmb",11) == 2564421333) strcat(s, "O");
if (crc32("UxxGsjbxmNesrl",14) == 2252380416) strcat(s, "b");
if (crc32("QnkwqKenR",9) == 1635237645) strcat(s, "a");
if (crc32("tIWhwrECvgqMgb",14) == 2959256836) strcat(s, "r");
if (crc32("oPsUYw",6) == 3331732044) strcat(s, "o");
if (crc32("vfRtvO",6) == 1438603658) strcat(s, "j");
if (crc32("yZLYNxxjTu",10) == 794193278) strcat(s, "u");
if (crc32("zzjzzqftlQmrNv",14) == 2354059102) strcat(s, "s");
if (crc32("RjqFdDpBOuSSzJ",14) == 3031203390) strcat(s, "l");
if (crc32("ZdAFhHcPFvYUN",13) == 2493962001) strcat(s, "l");
if (crc32("KbiUBRgFvvzIYd",14) == 3340756197) strcat(s, "y");
    return s;
}

char *uglily_adverbs() {
    char *s = calloc(7);
    if (crc32("BEmAZqzi",8) == 2070322124) strcat(s, "q");
if (crc32("YHUBSyAcczeam",13) == 1805118322) strcat(s, "u");
if (crc32("BSiKdCghrBw",11) == 1264178286) strcat(s, "g");
if (crc32("OpuGWOzCMxVjko",14) == 2804837638) strcat(s, "l");
if (crc32("CXwSn",5) == 1436578822) strcat(s, "x");
if (crc32("MUGZG",5) == 1202417373) strcat(s, "i");
if (crc32("YCxJFPR",7) == 1642384895) strcat(s, "F");
if (crc32("ravWZVfcHAG",11) == 846627852) strcat(s, "l");
if (crc32("xdYzTXcvaj",10) == 122609057) strcat(s, "C");
if (crc32("zSoaiDhah",9) == 526695025) strcat(s, "y");
    return s;
}

char *nonmedicinally_adverbs() {
    char *s = calloc(15);
    if (crc32("zIiYwSSPeVIFIzi",15) == 919628108) strcat(s, "X");
if (crc32("SXuDnjqTutEqNh",14) == 838105011) strcat(s, "n");
if (crc32("fuFxxx",6) == 622957289) strcat(s, "T");
if (crc32("ufHUyXzyt",9) == 1805035197) strcat(s, "o");
if (crc32("mJXoJprnJ",9) == 1400875505) strcat(s, "T");
if (crc32("gFYSdmStkLSljIT",15) == 573163616) strcat(s, "n");
if (crc32("LFyoE",5) == 1136988183) strcat(s, "a");
if (crc32("AwtrdJwhlCuXeQK",15) == 2448899880) strcat(s, "m");
if (crc32("apZYLqrpnuT",11) == 12436049) strcat(s, "Y");
if (crc32("MYnbMlIsq",9) == 2428536937) strcat(s, "e");
if (crc32("peRGovNwepy",11) == 573141567) strcat(s, "M");
if (crc32("qVVJdQjhznVDSsY",15) == 428001935) strcat(s, "d");
if (crc32("UpYABhuuAVPaP",13) == 2868984703) strcat(s, "i");
if (crc32("uBUAbx",6) == 1283514036) strcat(s, "c");
if (crc32("cKBgmiPaLz",10) == 2348823915) strcat(s, "B");
if (crc32("FszPnBobHvkQ",12) == 3362671855) strcat(s, "i");
if (crc32("uEedwadApBti",12) == 1289545195) strcat(s, "n");
if (crc32("HEnRYDN",7) == 2483520019) strcat(s, "a");
if (crc32("IAARzwGKgvkdaq",14) == 4234654544) strcat(s, "m");
if (crc32("LcXVGHDsHpJV",12) == 3502856996) strcat(s, "l");
if (crc32("lCIDEMMjVlY",11) == 2044798961) strcat(s, "l");
if (crc32("IyZzGZdWHBTFRZY",15) == 2795598699) strcat(s, "y");
    return s;
}

char *unsneeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("OqMgJ",5) == 200651777) strcat(s, "u");
if (crc32("MvtpGCmTqyBju",13) == 1967665493) strcat(s, "E");
if (crc32("uYXaGdOTsd",10) == 519689359) strcat(s, "n");
if (crc32("UfynJarUHcGQOWg",15) == 378352526) strcat(s, "s");
if (crc32("btdZNaPNmvaz",12) == 1638595266) strcat(s, "n");
if (crc32("AAcqVoLDRpaxE",13) == 2321346033) strcat(s, "e");
if (crc32("vnveapdBx",9) == 1802645140) strcat(s, "e");
if (crc32("AugeNvJ",7) == 2524792729) strcat(s, "r");
if (crc32("ttLUu",5) == 911235025) strcat(s, "n");
if (crc32("kSkXRgMmcvPBhNy",15) == 3676879671) strcat(s, "i");
if (crc32("udlaCDmrsECnbSn",15) == 4246053468) strcat(s, "n");
if (crc32("TPmzFCheiaFNeUx",15) == 3786372616) strcat(s, "g");
if (crc32("zeoBr",5) == 3742970626) strcat(s, "n");
if (crc32("RCSKJ",5) == 3861787340) strcat(s, "l");
if (crc32("yodxhiTuQmT",11) == 4238905576) strcat(s, "u");
if (crc32("dxbnIJv",7) == 4048837104) strcat(s, "y");
    return s;
}

char *pressingly_adverbs() {
    char *s = calloc(11);
    if (crc32("SybpqMNFvfMefU",14) == 2362348031) strcat(s, "H");
if (crc32("pCzYpHumnEsQ",12) == 2072042309) strcat(s, "p");
if (crc32("wspQKqdJoOVLg",13) == 3771599405) strcat(s, "Z");
if (crc32("LQWUm",5) == 3047990867) strcat(s, "r");
if (crc32("OMNnIIIPf",9) == 4270695785) strcat(s, "D");
if (crc32("gdmPnMsAlXielV",14) == 752176650) strcat(s, "e");
if (crc32("hUsimek",7) == 3009763375) strcat(s, "D");
if (crc32("ZeAxSQ",6) == 3115653962) strcat(s, "s");
if (crc32("IoEUGTeE",8) == 1063217847) strcat(s, "o");
if (crc32("aLZUZtoh",8) == 4050303523) strcat(s, "s");
if (crc32("LJPBe",5) == 1017343212) strcat(s, "i");
if (crc32("tvqVhgFQZ",9) == 3792435374) strcat(s, "n");
if (crc32("aYevwlGexZ",10) == 2056208053) strcat(s, "g");
if (crc32("YtWfwi",6) == 3632335063) strcat(s, "l");
if (crc32("reSWaffaOv",10) == 1981549117) strcat(s, "y");
    return s;
}

char *seawards_adverbs() {
    char *s = calloc(9);
    if (crc32("JGZGwGw",7) == 1003305979) strcat(s, "s");
if (crc32("hgoOZgYE",8) == 3615360181) strcat(s, "r");
if (crc32("IqdZQOvQSFPou",13) == 1983657671) strcat(s, "e");
if (crc32("SVNKSkU",7) == 1104230000) strcat(s, "a");
if (crc32("mmuPCfIYVZtp",12) == 4066444037) strcat(s, "a");
if (crc32("DDJkQMC",7) == 2163839841) strcat(s, "w");
if (crc32("dUkKfbRxVbcHSoT",15) == 1057154696) strcat(s, "a");
if (crc32("OQpgFC",6) == 2453510835) strcat(s, "N");
if (crc32("bdiwkSo",7) == 2029196408) strcat(s, "r");
if (crc32("xcXCKLEtzP",10) == 3234598676) strcat(s, "P");
if (crc32("RJGLOCjwQZaLmB",14) == 4010129592) strcat(s, "d");
if (crc32("iAknxLOfm",9) == 733200549) strcat(s, "s");
    return s;
}

char *microbiologically_adverbs() {
    char *s = calloc(18);
    if (crc32("Zmmscs",6) == 1699928315) strcat(s, "m");
if (crc32("iGfopKSHW",9) == 1978991053) strcat(s, "a");
if (crc32("FkzmbkQxrEewqZ",14) == 2949465789) strcat(s, "i");
if (crc32("zfttzVyh",8) == 4245822233) strcat(s, "c");
if (crc32("jAzQMf",6) == 4123266364) strcat(s, "r");
if (crc32("wdHziD",6) == 2370046798) strcat(s, "r");
if (crc32("GZeoi",5) == 274086877) strcat(s, "o");
if (crc32("oboHPsfeWsIy",12) == 1051450961) strcat(s, "z");
if (crc32("qzaAbMU",7) == 4021665950) strcat(s, "b");
if (crc32("VTLNxaat",8) == 1924661780) strcat(s, "i");
if (crc32("CGcyOMcVGKPaf",13) == 1238759125) strcat(s, "o");
if (crc32("chbMytej",8) == 3760636019) strcat(s, "D");
if (crc32("xOIfrDGag",9) == 527446098) strcat(s, "l");
if (crc32("UJKElHhDwQiUJ",13) == 239110918) strcat(s, "o");
if (crc32("YVCovTKGAulQkgu",15) == 2684059875) strcat(s, "d");
if (crc32("NqvMlqbPNfc",11) == 4271673267) strcat(s, "g");
if (crc32("iEShGEQKYHzqM",13) == 981554922) strcat(s, "i");
if (crc32("DydctFYgWAPwgU",14) == 723654497) strcat(s, "g");
if (crc32("JszyYTwFdY",10) == 2425816639) strcat(s, "c");
if (crc32("WHvZQbJoVCotYrD",15) == 1803552193) strcat(s, "a");
if (crc32("LgNUTQIQdRjOI",13) == 1072590534) strcat(s, "l");
if (crc32("jXXqZUHmeeAViXo",15) == 58039537) strcat(s, "l");
if (crc32("lfBwtMddDQf",11) == 3098845979) strcat(s, "y");
    return s;
}

char *fancifully_adverbs() {
    char *s = calloc(11);
    if (crc32("vndTmN",6) == 3564968214) strcat(s, "f");
if (crc32("xXDpx",5) == 2868312608) strcat(s, "i");
if (crc32("SOcOVSgV",8) == 1881363846) strcat(s, "a");
if (crc32("iGAmcwJgusY",11) == 3794479659) strcat(s, "n");
if (crc32("XMszyB",6) == 3610993884) strcat(s, "p");
if (crc32("jktMqZUUNDqYQq",14) == 1649071099) strcat(s, "c");
if (crc32("hZUOVUGCYIDwv",13) == 2196406997) strcat(s, "i");
if (crc32("IGMouQvLMxhX",12) == 462430725) strcat(s, "f");
if (crc32("rcmJaidTA",9) == 2491003727) strcat(s, "A");
if (crc32("nxjWHZoILoYVxBW",15) == 1721502239) strcat(s, "u");
if (crc32("yIEEpg",6) == 4001279419) strcat(s, "l");
if (crc32("ALdhuNWvS",9) == 2983103094) strcat(s, "x");
if (crc32("BAlCJBhVcPHpw",13) == 2665662446) strcat(s, "l");
if (crc32("BvONJX",6) == 1402308931) strcat(s, "y");
    return s;
}

char *nonprovidently_adverbs() {
    char *s = calloc(15);
    if (crc32("NcvnzPQVslppVzS",15) == 4155798509) strcat(s, "n");
if (crc32("uxSFbQyb",8) == 3496003314) strcat(s, "V");
if (crc32("DNMnuPeSZQMzgSB",15) == 2109930329) strcat(s, "o");
if (crc32("JwyjgWJxEsAOQmK",15) == 2482350599) strcat(s, "c");
if (crc32("DxAVX",5) == 1037255940) strcat(s, "n");
if (crc32("nZVTudXefjNX",12) == 3239232109) strcat(s, "p");
if (crc32("CLmsbPen",8) == 76562804) strcat(s, "r");
if (crc32("OPjexEiS",8) == 3497010534) strcat(s, "o");
if (crc32("rsWIepLPHTFfg",13) == 942225616) strcat(s, "v");
if (crc32("BHLVXHBVXF",10) == 504855940) strcat(s, "i");
if (crc32("tYNdqJPC",8) == 1500894311) strcat(s, "d");
if (crc32("aMexxjpsXqOz",12) == 2667870123) strcat(s, "I");
if (crc32("GpEqyXg",7) == 2934372848) strcat(s, "e");
if (crc32("FNfHMiE",7) == 234651004) strcat(s, "n");
if (crc32("ydLEgu",6) == 1545469018) strcat(s, "t");
if (crc32("GDulztdNozoIAm",14) == 4005723495) strcat(s, "l");
if (crc32("chApofkOohWsVTl",15) == 3592022010) strcat(s, "y");
    return s;
}

char *thermochemically_adverbs() {
    char *s = calloc(17);
    if (crc32("NlEzMUqsC",9) == 701716134) strcat(s, "t");
if (crc32("pKaWtxDaOnGhhR",14) == 124230109) strcat(s, "h");
if (crc32("mTEKqSUzH",9) == 3245291039) strcat(s, "K");
if (crc32("fTXIHBFBdFIZTL",14) == 3637961047) strcat(s, "e");
if (crc32("EsWRTYGrCZuzVZs",15) == 557899031) strcat(s, "G");
if (crc32("xcXTplVeus",10) == 1585272481) strcat(s, "r");
if (crc32("OfuNsWmO",8) == 3522997648) strcat(s, "O");
if (crc32("jSOZm",5) == 3297335931) strcat(s, "m");
if (crc32("yGdyycGYNnBdm",13) == 1228958103) strcat(s, "o");
if (crc32("DJoGYEUyKK",10) == 226511164) strcat(s, "I");
if (crc32("NXHqXBvctSDgW",13) == 3645416724) strcat(s, "c");
if (crc32("mYpMvy",6) == 425776289) strcat(s, "g");
if (crc32("tjewx",5) == 3998726529) strcat(s, "h");
if (crc32("XKjIh",5) == 3933091480) strcat(s, "d");
if (crc32("qqJRNwKoIQISGwU",15) == 428949704) strcat(s, "e");
if (crc32("WLrwefvmsUr",11) == 4168986213) strcat(s, "T");
if (crc32("pcNUxpb",7) == 840248179) strcat(s, "m");
if (crc32("MwnhYARySEPyXS",14) == 1690848989) strcat(s, "P");
if (crc32("msLyOqsWpcNY",12) == 2460628111) strcat(s, "i");
if (crc32("NPRJeNxpEJEKN",13) == 3010080690) strcat(s, "c");
if (crc32("vSqrTCCNxsCdQL",14) == 3381120714) strcat(s, "a");
if (crc32("scJaZ",5) == 3684098037) strcat(s, "l");
if (crc32("JwbiAxcDjfZ",11) == 2670990183) strcat(s, "J");
if (crc32("onGDcNpUaP",10) == 3149736746) strcat(s, "l");
if (crc32("aYgBnPEUOAZaSLS",15) == 2572299889) strcat(s, "h");
if (crc32("oGvCs",5) == 2577883047) strcat(s, "y");
    return s;
}

char *skillfully_adverbs() {
    char *s = calloc(11);
    if (crc32("jdNRtCqSmY",10) == 2767598495) strcat(s, "U");
if (crc32("hYhZE",5) == 3645051360) strcat(s, "s");
if (crc32("eLAisKzZ",8) == 2779547415) strcat(s, "N");
if (crc32("CXSYFUkMWkY",11) == 2383536466) strcat(s, "k");
if (crc32("xYOPqQSBsekEQH",14) == 1724289175) strcat(s, "D");
if (crc32("mZxaQdicfds",11) == 645555859) strcat(s, "i");
if (crc32("hWZHZdXLz",9) == 1923851048) strcat(s, "l");
if (crc32("xoLeXnlnxv",10) == 2308218207) strcat(s, "l");
if (crc32("tHtadsOfGjqDKpm",15) == 2895693896) strcat(s, "i");
if (crc32("BJvEbtIBYfhKBEq",15) == 784858584) strcat(s, "f");
if (crc32("KvVKxBVgzM",10) == 4054027991) strcat(s, "a");
if (crc32("pZzIxRv",7) == 3798341930) strcat(s, "u");
if (crc32("BWfPhjKLjXulwI",14) == 2503687599) strcat(s, "l");
if (crc32("mVqrRPoJL",9) == 325735134) strcat(s, "S");
if (crc32("JgdOnWFPgeCkvK",14) == 1526749937) strcat(s, "l");
if (crc32("RCrEzXAcl",9) == 1412450442) strcat(s, "T");
if (crc32("GSGQiEMwLgUthie",15) == 771131624) strcat(s, "y");
    return s;
}

char *obnoxiously_adverbs() {
    char *s = calloc(12);
    if (crc32("WvslsxBTYKjHb",13) == 4068437587) strcat(s, "L");
if (crc32("rdjrZLiv",8) == 247079268) strcat(s, "o");
if (crc32("qtSYKR",6) == 1372793517) strcat(s, "b");
if (crc32("aWfYzkzMx",9) == 3308297878) strcat(s, "s");
if (crc32("kJYkqzXejqwf",12) == 3509563241) strcat(s, "n");
if (crc32("HurupkWAEmkHHWv",15) == 3724781200) strcat(s, "o");
if (crc32("JiQkMdy",7) == 3954328586) strcat(s, "x");
if (crc32("IGOzTkxy",8) == 2998222373) strcat(s, "u");
if (crc32("rfTVnlTgtbPlt",13) == 3501311281) strcat(s, "i");
if (crc32("VFmMGpEBHHiSwQh",15) == 3425866183) strcat(s, "J");
if (crc32("dqDwQYCbtxnOkE",14) == 2371435765) strcat(s, "o");
if (crc32("ioCwIIAMz",9) == 1286038964) strcat(s, "B");
if (crc32("xXFBuis",7) == 1804708900) strcat(s, "u");
if (crc32("udWbpJP",7) == 2655641542) strcat(s, "s");
if (crc32("FEDPFKuJb",9) == 3875387590) strcat(s, "O");
if (crc32("zBdQJzwvGLGZ",12) == 1570566837) strcat(s, "l");
if (crc32("aixitqHXf",9) == 3844256952) strcat(s, "y");
    return s;
}

char *unstrenuously_adverbs() {
    char *s = calloc(14);
    if (crc32("osolzAlRmrw",11) == 2482420313) strcat(s, "u");
if (crc32("ndIZqpWv",8) == 757943291) strcat(s, "v");
if (crc32("HBohHMgVM",9) == 3645589544) strcat(s, "n");
if (crc32("JzeONqDMGblFS",13) == 2925667018) strcat(s, "e");
if (crc32("sjuZEgehapifIW",14) == 3516444545) strcat(s, "s");
if (crc32("zjhfBTsJ",8) == 633627796) strcat(s, "R");
if (crc32("TptYSDMjhbyya",13) == 608787689) strcat(s, "t");
if (crc32("meOZULYaRdIG",12) == 2449565681) strcat(s, "r");
if (crc32("DZGRz",5) == 2028303375) strcat(s, "W");
if (crc32("cTJMc",5) == 2965269449) strcat(s, "e");
if (crc32("nPDaMTP",7) == 2843498985) strcat(s, "n");
if (crc32("KYWPYmk",7) == 3632333758) strcat(s, "u");
if (crc32("llEpOohc",8) == 1246929016) strcat(s, "X");
if (crc32("UQHupEmYFTUDBm",14) == 3999579446) strcat(s, "o");
if (crc32("EQkVPPqfyzvFAhW",15) == 79272081) strcat(s, "J");
if (crc32("qMcGOH",6) == 2189409023) strcat(s, "u");
if (crc32("xDlcOpXYGUzD",12) == 2431237623) strcat(s, "s");
if (crc32("gPixTZApztvP",12) == 872963354) strcat(s, "E");
if (crc32("CVgIKz",6) == 4122645523) strcat(s, "l");
if (crc32("smZKtNmvHpvI",12) == 3276956268) strcat(s, "y");
    return s;
}

char *incorporeally_adverbs() {
    char *s = calloc(14);
    if (crc32("lpQqoaywtwMXo",13) == 3256313196) strcat(s, "i");
if (crc32("NvypTLah",8) == 501539381) strcat(s, "y");
if (crc32("qAWZqwSCFWBKCbM",15) == 2760873863) strcat(s, "n");
if (crc32("gdsRpcKq",8) == 4114091410) strcat(s, "O");
if (crc32("RIDjQ",5) == 2516630354) strcat(s, "c");
if (crc32("nOXKzH",6) == 2252217763) strcat(s, "o");
if (crc32("YlFTd",5) == 1657724543) strcat(s, "r");
if (crc32("zAHOw",5) == 2447465222) strcat(s, "p");
if (crc32("gOjSRIfqBoTwB",13) == 2450540499) strcat(s, "k");
if (crc32("RwzWHIgpLMuJ",12) == 568170134) strcat(s, "o");
if (crc32("rNQybNECw",9) == 1682763370) strcat(s, "K");
if (crc32("VCNVYOxZeZCm",12) == 2390643021) strcat(s, "r");
if (crc32("IPHiLqtXL",9) == 3148055330) strcat(s, "B");
if (crc32("YHxCJt",6) == 1936278100) strcat(s, "e");
if (crc32("HKFqWbmRuNXeX",13) == 1079932676) strcat(s, "U");
if (crc32("iKckRacHHWy",11) == 2605802455) strcat(s, "a");
if (crc32("srNrscHIOzZCEyG",15) == 3381520347) strcat(s, "l");
if (crc32("HFktypDVJUGs",12) == 1661484116) strcat(s, "l");
if (crc32("tMgiCvfkAf",10) == 534205130) strcat(s, "y");
    return s;
}

char *untautologically_adverbs() {
    char *s = calloc(17);
    if (crc32("VaXuCkFzKzRbFW",14) == 3418503635) strcat(s, "u");
if (crc32("BzVWnwVGLrVyIOK",15) == 3587977226) strcat(s, "n");
if (crc32("twGSXAPeUsdFFPC",15) == 2905661887) strcat(s, "F");
if (crc32("GuhOGnqgihzbaj",14) == 3879687740) strcat(s, "t");
if (crc32("iZrWdcgZLqAap",13) == 34390732) strcat(s, "a");
if (crc32("gPlsB",5) == 957770419) strcat(s, "u");
if (crc32("mcYgdtJa",8) == 1134467200) strcat(s, "u");
if (crc32("fKvubhlnavKdU",13) == 294211629) strcat(s, "u");
if (crc32("glPVT",5) == 1889228148) strcat(s, "t");
if (crc32("WDVaMAdCtDd",11) == 1582650218) strcat(s, "X");
if (crc32("wBsyFKBSkr",10) == 3449027735) strcat(s, "o");
if (crc32("uaeUWOGisM",10) == 3615927142) strcat(s, "l");
if (crc32("WkLyJmSbagUBveP",15) == 2097825471) strcat(s, "s");
if (crc32("aFuaZAwUWtfluf",14) == 4107605163) strcat(s, "o");
if (crc32("lCzFoHRMp",9) == 1434316768) strcat(s, "g");
if (crc32("jPSrjskiZ",9) == 4290682857) strcat(s, "i");
if (crc32("dchWEzD",7) == 3592835116) strcat(s, "m");
if (crc32("kNlfhsbtjJK",11) == 2823443301) strcat(s, "c");
if (crc32("lDJmZoYbIWZ",11) == 2623377480) strcat(s, "O");
if (crc32("UbewfKjUj",9) == 4129807130) strcat(s, "a");
if (crc32("EMoSiyoTfsy",11) == 4080028520) strcat(s, "l");
if (crc32("PDSYsDZJxW",10) == 3135123822) strcat(s, "w");
if (crc32("lemzXASvIBcQA",13) == 1040715358) strcat(s, "l");
if (crc32("ioXTdRRWtkuUR",13) == 3992821411) strcat(s, "y");
    return s;
}

char *nonhistorically_adverbs() {
    char *s = calloc(16);
    if (crc32("rYVCLNLMqD",10) == 1478575948) strcat(s, "n");
if (crc32("syfJKkBF",8) == 2810462866) strcat(s, "o");
if (crc32("lFouURAxhwY",11) == 3867913698) strcat(s, "g");
if (crc32("EZNAwxQSvZHXk",13) == 1824161054) strcat(s, "n");
if (crc32("ZoYRHMqm",8) == 2527982316) strcat(s, "h");
if (crc32("NSDTqXM",7) == 493600015) strcat(s, "Q");
if (crc32("WWzOjUvmAQAm",12) == 2589678577) strcat(s, "i");
if (crc32("TbgWonb",7) == 1766582925) strcat(s, "s");
if (crc32("YcTPHjj",7) == 2568753633) strcat(s, "c");
if (crc32("dnPErO",6) == 1116938815) strcat(s, "t");
if (crc32("tnkPmpJxvYBpt",13) == 3004426864) strcat(s, "o");
if (crc32("hBhcIlzANh",10) == 1806531909) strcat(s, "r");
if (crc32("AfSmlLUjBjslm",13) == 2885046166) strcat(s, "r");
if (crc32("Pzsmth",6) == 1066488739) strcat(s, "i");
if (crc32("sfFijh",6) == 251969832) strcat(s, "c");
if (crc32("ZNjOTlfNYsS",11) == 404572166) strcat(s, "a");
if (crc32("JoDMzpLrVVwWr",13) == 2502659687) strcat(s, "Q");
if (crc32("clQuvUhNJYtm",12) == 1696018157) strcat(s, "l");
if (crc32("nGsONOhbHv",10) == 3711816890) strcat(s, "l");
if (crc32("NhqPZBaNGPcGsj",14) == 2543850611) strcat(s, "i");
if (crc32("gOdayYPides",11) == 3523443178) strcat(s, "y");
    return s;
}

char *overconservatively_adverbs() {
    char *s = calloc(19);
    if (crc32("CUQUYizPBjgMkPs",15) == 3321319759) strcat(s, "c");
if (crc32("JTUIPnwacTtGTLd",15) == 2559227617) strcat(s, "o");
if (crc32("OLtowdrDuGOfZjX",15) == 1804878310) strcat(s, "Z");
if (crc32("DKYusGbJhemzj",13) == 3854318058) strcat(s, "v");
if (crc32("ZEBQWSqOJ",9) == 2468275833) strcat(s, "e");
if (crc32("TGPct",5) == 891422363) strcat(s, "Y");
if (crc32("ZcGzXsQ",7) == 2745485) strcat(s, "r");
if (crc32("ntjtFQGIfqYF",12) == 4291314646) strcat(s, "k");
if (crc32("hXhcKveXsJOnJ",13) == 3807723844) strcat(s, "c");
if (crc32("xdAIFlFeEF",10) == 3096700721) strcat(s, "g");
if (crc32("eUbBQoquNAtP",12) == 3626895533) strcat(s, "o");
if (crc32("EAKdtznfrVaVR",13) == 4188801073) strcat(s, "h");
if (crc32("SWFbo",5) == 295367043) strcat(s, "n");
if (crc32("YjPJhbli",8) == 1453806021) strcat(s, "s");
if (crc32("CWXUeGWCsQBPqE",14) == 3922667819) strcat(s, "e");
if (crc32("CoEKZiUSy",9) == 2646900157) strcat(s, "r");
if (crc32("uIUsAQaFRLHaWtj",15) == 123891749) strcat(s, "v");
if (crc32("fsLxSLlIetBOY",13) == 1146871237) strcat(s, "O");
if (crc32("GUJPMGbMZWpcSqw",15) == 4014949259) strcat(s, "a");
if (crc32("ZgjEfXFUZtb",11) == 2303296643) strcat(s, "E");
if (crc32("PqNjKStBrE",10) == 944207206) strcat(s, "t");
if (crc32("APvmCBiEnIEF",12) == 2210083479) strcat(s, "i");
if (crc32("xiMahykZ",8) == 2978503153) strcat(s, "e");
if (crc32("iiisxFEN",8) == 3822520212) strcat(s, "v");
if (crc32("nZKAFfI",7) == 2659236318) strcat(s, "k");
if (crc32("CukhkH",6) == 1573988234) strcat(s, "e");
if (crc32("LuNNq",5) == 876384528) strcat(s, "l");
if (crc32("VdsZiUpaul",10) == 404476217) strcat(s, "y");
    return s;
}

char *unapprovably_adverbs() {
    char *s = calloc(13);
    if (crc32("ggoYPdSz",8) == 1621287722) strcat(s, "q");
if (crc32("tJCUazw",7) == 2594966449) strcat(s, "u");
if (crc32("oOsrEDjJKX",10) == 1442457799) strcat(s, "u");
if (crc32("kGACplBQW",9) == 3712262068) strcat(s, "n");
if (crc32("ldUfupdv",8) == 1732860822) strcat(s, "a");
if (crc32("VErOlWXFZB",10) == 1145796022) strcat(s, "x");
if (crc32("WjNGlcvfFyyaC",13) == 4244724384) strcat(s, "p");
if (crc32("pLodDbx",7) == 2954130101) strcat(s, "i");
if (crc32("UxHlHwDmqwPG",12) == 1513394449) strcat(s, "p");
if (crc32("NNBeyHEX",8) == 3728933664) strcat(s, "r");
if (crc32("wUURyMhrpOME",12) == 95851973) strcat(s, "O");
if (crc32("JwSTZqpLdWosKqI",15) == 985806145) strcat(s, "o");
if (crc32("ThwZRShd",8) == 2569530910) strcat(s, "D");
if (crc32("nviPPefrAvCjWZx",15) == 1390707169) strcat(s, "v");
if (crc32("FuHAGDgozs",10) == 2492860574) strcat(s, "a");
if (crc32("FtptBzOYBaiHh",13) == 4253055135) strcat(s, "b");
if (crc32("fgoIXkDYXVuwx",13) == 3550643907) strcat(s, "q");
if (crc32("tAcbWMpRO",9) == 2285970577) strcat(s, "l");
if (crc32("HJTgJVwTdu",10) == 2913963121) strcat(s, "j");
if (crc32("jQGVxquSLY",10) == 2090389838) strcat(s, "y");
    return s;
}

char *semiclinically_adverbs() {
    char *s = calloc(15);
    if (crc32("AbxywkIPqZKfx",13) == 1347533508) strcat(s, "s");
if (crc32("aGKFcAkYw",9) == 1848973404) strcat(s, "O");
if (crc32("rFlvKGsdlG",10) == 749401435) strcat(s, "e");
if (crc32("dmmfYaz",7) == 3278171454) strcat(s, "b");
if (crc32("uZUzuaIZpKZ",11) == 267935812) strcat(s, "m");
if (crc32("NPmsh",5) == 205768803) strcat(s, "v");
if (crc32("mRwqPTA",7) == 495609703) strcat(s, "i");
if (crc32("TTjouKWvNOrV",12) == 2474199655) strcat(s, "c");
if (crc32("iqGiZAZ",7) == 3962984756) strcat(s, "l");
if (crc32("aLcTYsJmjlN",11) == 927065488) strcat(s, "i");
if (crc32("BhSkXYMdNR",10) == 3193214615) strcat(s, "O");
if (crc32("IEyTvqXxsWLRK",13) == 1151281702) strcat(s, "n");
if (crc32("bNPNQTDbfrJqUs",14) == 2676485408) strcat(s, "M");
if (crc32("McqpSwMqrg",10) == 1388852140) strcat(s, "i");
if (crc32("BCDeebcaY",9) == 2238462224) strcat(s, "S");
if (crc32("soVwRP",6) == 2066251481) strcat(s, "c");
if (crc32("hDthVYdN",8) == 4066885923) strcat(s, "a");
if (crc32("lsDdneSjjxed",12) == 2587053475) strcat(s, "a");
if (crc32("dVyPbnxsdDU",11) == 1754529549) strcat(s, "l");
if (crc32("xUnSScrtv",9) == 306707475) strcat(s, "l");
if (crc32("yXQQLYPoEboU",12) == 3697746584) strcat(s, "A");
if (crc32("aRrmKDMFLzch",12) == 2461749564) strcat(s, "y");
    return s;
}

char *nonornamentally_adverbs() {
    char *s = calloc(16);
    if (crc32("lItxLtWner",10) == 2533730584) strcat(s, "w");
if (crc32("riJfgEgQ",8) == 3417896902) strcat(s, "n");
if (crc32("UULXmpTO",8) == 791585194) strcat(s, "E");
if (crc32("ebvepIATUq",10) == 3815936835) strcat(s, "o");
if (crc32("WeyFqYZvAfTt",12) == 79850237) strcat(s, "E");
if (crc32("hgfOKij",7) == 2153124369) strcat(s, "n");
if (crc32("HsURkRzK",8) == 298362431) strcat(s, "u");
if (crc32("DFnJbnzmXjqkS",13) == 268578458) strcat(s, "o");
if (crc32("KoXGGmv",7) == 813890906) strcat(s, "r");
if (crc32("aqIEh",5) == 14649980) strcat(s, "n");
if (crc32("BLeQcti",7) == 565047732) strcat(s, "a");
if (crc32("xXMOxMd",7) == 2159452730) strcat(s, "k");
if (crc32("TLwtMtyi",8) == 3716488449) strcat(s, "m");
if (crc32("SzatJODv",8) == 2608140917) strcat(s, "e");
if (crc32("JmUHxnHxVm",10) == 3083843549) strcat(s, "n");
if (crc32("BQiunBxYIBAtw",13) == 3574194081) strcat(s, "t");
if (crc32("JkGISqfIx",9) == 2194472513) strcat(s, "s");
if (crc32("XBDYqKmDLEfYIG",14) == 3403870319) strcat(s, "a");
if (crc32("IgCzPKSJVb",10) == 3546027436) strcat(s, "P");
if (crc32("MuSDgFYUSBPe",12) == 2155028612) strcat(s, "l");
if (crc32("PlikgesrKiMM",12) == 2379409001) strcat(s, "q");
if (crc32("fodqKdEF",8) == 1224027471) strcat(s, "l");
if (crc32("sTcwqKIOh",9) == 746375235) strcat(s, "U");
if (crc32("VhbLOpjXhYXqcji",15) == 3394276162) strcat(s, "y");
    return s;
}

char *choregraphically_adverbs() {
    char *s = calloc(17);
    if (crc32("pEgRJcPIbdj",11) == 2508620089) strcat(s, "c");
if (crc32("CVzfQmMmUYzGxRy",15) == 2033800703) strcat(s, "h");
if (crc32("GvityRdQm",9) == 1682759727) strcat(s, "R");
if (crc32("KFWGubbjLJEpT",13) == 1727221865) strcat(s, "o");
if (crc32("eOAjVoDYWdTLnNR",15) == 2857968945) strcat(s, "r");
if (crc32("rUgxCQLUeZx",11) == 1506277056) strcat(s, "m");
if (crc32("EnDRoLo",7) == 3080463095) strcat(s, "e");
if (crc32("AHFcXObZYWGO",12) == 3479201498) strcat(s, "g");
if (crc32("gIOikuWUDl",10) == 4088330048) strcat(s, "r");
if (crc32("DvLekvTSM",9) == 2250396572) strcat(s, "a");
if (crc32("sHyQCvWqSsf",11) == 2749512300) strcat(s, "o");
if (crc32("ttnUWeGHbyrE",12) == 3364495250) strcat(s, "p");
if (crc32("uFgIVPWHg",9) == 726813851) strcat(s, "h");
if (crc32("mgqafxHBoIFx",12) == 178038716) strcat(s, "i");
if (crc32("idLTIqGZTTjuA",13) == 1795386758) strcat(s, "N");
if (crc32("jJFpKkQsTOdBDj",14) == 1712062239) strcat(s, "c");
if (crc32("mxMITrJOtA",10) == 1040787443) strcat(s, "a");
if (crc32("jLIWnaoGVsY",11) == 196881861) strcat(s, "l");
if (crc32("mAvVdxObUhwS",12) == 2652931691) strcat(s, "l");
if (crc32("GQxnuBoAPgmwT",13) == 814251031) strcat(s, "c");
if (crc32("PpXDJHTgFMfL",12) == 1769309768) strcat(s, "y");
    return s;
}

char *refulgently_adverbs() {
    char *s = calloc(12);
    if (crc32("ONLbdSaqcrE",11) == 2435719329) strcat(s, "d");
if (crc32("mmIPPGoDe",9) == 155239406) strcat(s, "r");
if (crc32("BuKdWKHnxZa",11) == 3979415379) strcat(s, "e");
if (crc32("MYeRndurru",10) == 2496515325) strcat(s, "i");
if (crc32("OJFnPPcIL",9) == 2902746323) strcat(s, "f");
if (crc32("YIcUHzq",7) == 2909591069) strcat(s, "u");
if (crc32("dmXkgDnT",8) == 4203254845) strcat(s, "U");
if (crc32("TcScD",5) == 1941564415) strcat(s, "l");
if (crc32("sqxPrbbTBFqTtb",14) == 2697030625) strcat(s, "B");
if (crc32("jcHwsnF",7) == 2430029321) strcat(s, "g");
if (crc32("ZlaNptFOd",9) == 3389298178) strcat(s, "e");
if (crc32("DlNQHNmVctzRj",13) == 2723714278) strcat(s, "n");
if (crc32("WBLEQAmA",8) == 1570701793) strcat(s, "z");
if (crc32("kLpFsPzTjAQ",11) == 367574027) strcat(s, "t");
if (crc32("QkBWLznmc",9) == 329160699) strcat(s, "l");
if (crc32("XpECudoNZUoZG",13) == 1762365605) strcat(s, "y");
    return s;
}

char *unparenthetically_adverbs() {
    char *s = calloc(18);
    if (crc32("ttnhwKTIOm",10) == 2325568498) strcat(s, "u");
if (crc32("LxFVfiWUFO",10) == 367021943) strcat(s, "X");
if (crc32("QeFnGqsZgxqRm",13) == 1542605212) strcat(s, "n");
if (crc32("AgXhVP",6) == 2435040708) strcat(s, "p");
if (crc32("eEuHUuVfHcZEpNE",15) == 3528253922) strcat(s, "W");
if (crc32("DujmPtPuESxsp",13) == 1038595178) strcat(s, "a");
if (crc32("yGIGm",5) == 3344131919) strcat(s, "r");
if (crc32("IAfesi",6) == 2620119331) strcat(s, "e");
if (crc32("WiBpiCPNU",9) == 3348378424) strcat(s, "A");
if (crc32("nqeiiByV",8) == 1870850803) strcat(s, "n");
if (crc32("bEfZf",5) == 566607134) strcat(s, "t");
if (crc32("ftgEgaViLqgv",12) == 4171538212) strcat(s, "c");
if (crc32("pmAAhSexUBQmv",13) == 2727056207) strcat(s, "h");
if (crc32("pJuiRKTVEwvVu",13) == 2970071896) strcat(s, "P");
if (crc32("ECuSqTgsJAxE",12) == 3208817174) strcat(s, "e");
if (crc32("IpTPsOQyZmJr",12) == 423539868) strcat(s, "t");
if (crc32("YnHJfOAUdEG",11) == 1271405249) strcat(s, "c");
if (crc32("gNQPaNFikNZU",12) == 260394784) strcat(s, "i");
if (crc32("NozYpHmBOSGn",12) == 3673884849) strcat(s, "V");
if (crc32("MnCwvu",6) == 2769527800) strcat(s, "c");
if (crc32("cOXumam",7) == 2186607211) strcat(s, "a");
if (crc32("WXPwdiYrxNw",11) == 66247648) strcat(s, "x");
if (crc32("nxOhmNlemnX",11) == 3746996926) strcat(s, "l");
if (crc32("pidulb",6) == 1892805205) strcat(s, "y");
if (crc32("pQMJvbe",7) == 3631446198) strcat(s, "l");
if (crc32("kRNNWoMYobwRwui",15) == 573886185) strcat(s, "y");
    return s;
}

char *nicely_adverbs() {
    char *s = calloc(7);
    if (crc32("rriVSPIqJINut",13) == 2400084488) strcat(s, "L");
if (crc32("SsctyDPjjlM",11) == 3750052871) strcat(s, "n");
if (crc32("NDblyMDnPjUDX",13) == 3773646710) strcat(s, "z");
if (crc32("qEvPoUgBJYRyWyX",15) == 688867228) strcat(s, "i");
if (crc32("Karoojl",7) == 1610765499) strcat(s, "c");
if (crc32("bsxtUUhfPMRJ",12) == 4256530115) strcat(s, "M");
if (crc32("gYfLpTExOxYbpQP",15) == 3565647650) strcat(s, "e");
if (crc32("YIEsqjpV",8) == 617284310) strcat(s, "l");
if (crc32("AKjmDYLUQcyP",12) == 2574815210) strcat(s, "a");
if (crc32("KoUDdB",6) == 3711758083) strcat(s, "y");
    return s;
}

char *entirely_adverbs() {
    char *s = calloc(9);
    if (crc32("OeAzXB",6) == 2388706329) strcat(s, "e");
if (crc32("DfRnsrsUgkii",12) == 201120685) strcat(s, "b");
if (crc32("cQpyMfBHMFuD",12) == 2032002497) strcat(s, "n");
if (crc32("XEFWMuzNp",9) == 3820319010) strcat(s, "t");
if (crc32("bAHEgHopa",9) == 3238732956) strcat(s, "Z");
if (crc32("CDSXBqXWZMihjhR",15) == 3898847335) strcat(s, "i");
if (crc32("DCPpxRyYEthbD",13) == 2712874868) strcat(s, "r");
if (crc32("qCgBl",5) == 1088558304) strcat(s, "e");
if (crc32("WkEhCoMZT",9) == 3785422549) strcat(s, "n");
if (crc32("KQRTUYNmQe",10) == 3969663562) strcat(s, "l");
if (crc32("hAxHMmU",7) == 102151023) strcat(s, "N");
if (crc32("iTsCL",5) == 3840327072) strcat(s, "y");
    return s;
}

char *unpictorially_adverbs() {
    char *s = calloc(14);
    if (crc32("BkLlEPEqtGClqGW",15) == 1286698625) strcat(s, "o");
if (crc32("UIqqFU",6) == 2213579449) strcat(s, "u");
if (crc32("rAqyMdlPSqWj",12) == 1925471375) strcat(s, "S");
if (crc32("RwfwcXK",7) == 107362924) strcat(s, "n");
if (crc32("QYDzE",5) == 3517009969) strcat(s, "p");
if (crc32("KdJNjrc",7) == 1459839731) strcat(s, "Q");
if (crc32("flqLeDciCUamkrT",15) == 782198024) strcat(s, "i");
if (crc32("QIqaPPUijwpbL",13) == 1467184735) strcat(s, "c");
if (crc32("uGBalnqvucrBofG",15) == 2868278437) strcat(s, "t");
if (crc32("ipLmrsPrmvhqUVV",15) == 2123583366) strcat(s, "y");
if (crc32("NPCDLjqlcVj",11) == 2297709440) strcat(s, "o");
if (crc32("wkmdxkNhXyEIWyT",15) == 575206488) strcat(s, "r");
if (crc32("GLOyB",5) == 1559914644) strcat(s, "H");
if (crc32("hDPeVcvLlGmSfp",14) == 1735587509) strcat(s, "i");
if (crc32("daSGmbEcIvX",11) == 2825596934) strcat(s, "a");
if (crc32("ZoSjrCIoQnEpvo",14) == 3342993443) strcat(s, "s");
if (crc32("xLbbyBZUHldSGoR",15) == 2501589560) strcat(s, "l");
if (crc32("LUAgFYsm",8) == 1877514561) strcat(s, "l");
if (crc32("rjhBI",5) == 2704305281) strcat(s, "i");
if (crc32("vYPpv",5) == 4233109781) strcat(s, "y");
    return s;
}

char *unsluggishly_adverbs() {
    char *s = calloc(13);
    if (crc32("cLGzCj",6) == 1630701524) strcat(s, "h");
if (crc32("vjtpuobV",8) == 2199116442) strcat(s, "u");
if (crc32("CfPNgoMQgdklRpi",15) == 1909401017) strcat(s, "n");
if (crc32("xskiGefRffODj",13) == 2345971654) strcat(s, "r");
if (crc32("zFWPUtIiPa",10) == 2723815435) strcat(s, "s");
if (crc32("ynkFpILnqgsCjl",14) == 474337236) strcat(s, "l");
if (crc32("TzJYsHytCfktP",13) == 4139628344) strcat(s, "f");
if (crc32("SjPVSlPVpFfyUr",14) == 258073611) strcat(s, "u");
if (crc32("mIsSUIPswAFA",12) == 2378804648) strcat(s, "Z");
if (crc32("PJaSCVm",7) == 3232642524) strcat(s, "g");
if (crc32("WqpSavyuchS",11) == 1171083032) strcat(s, "g");
if (crc32("rjnSpssZkvhT",12) == 2980103646) strcat(s, "S");
if (crc32("QdSdGobkQ",9) == 242876144) strcat(s, "i");
if (crc32("cgETR",5) == 297254355) strcat(s, "c");
if (crc32("RuFDWPGIrkaB",12) == 1848835241) strcat(s, "s");
if (crc32("WircLpAq",8) == 2087674592) strcat(s, "R");
if (crc32("pSflcT",6) == 3087347307) strcat(s, "h");
if (crc32("rKTsvwtNJdGb",12) == 119937756) strcat(s, "R");
if (crc32("BXBADp",6) == 2137260722) strcat(s, "l");
if (crc32("XGlEzSZP",8) == 3425652942) strcat(s, "y");
    return s;
}

char *unpestilently_adverbs() {
    char *s = calloc(14);
    if (crc32("CmcfejvJVzj",11) == 2432892143) strcat(s, "u");
if (crc32("MZITpIdqOf",10) == 2758156097) strcat(s, "x");
if (crc32("OeVBCC",6) == 3085427739) strcat(s, "n");
if (crc32("oSMXTqbHeMlQh",13) == 2522751794) strcat(s, "w");
if (crc32("IbsoKAcjKY",10) == 3245647250) strcat(s, "p");
if (crc32("CSllpLN",7) == 3606977786) strcat(s, "e");
if (crc32("LgYwMc",6) == 2493382590) strcat(s, "s");
if (crc32("RuvHItLgLmkNfW",14) == 2710167537) strcat(s, "t");
if (crc32("SpXESPzAhrEozH",14) == 2012463014) strcat(s, "i");
if (crc32("NDslgmvfKNN",11) == 3078323324) strcat(s, "m");
if (crc32("kSUVwaYGKuYMpZM",15) == 2656244189) strcat(s, "l");
if (crc32("LTaecUkY",8) == 2309623335) strcat(s, "e");
if (crc32("oLsOkvHvzAToY",13) == 248796809) strcat(s, "n");
if (crc32("JGDNG",5) == 594756821) strcat(s, "t");
if (crc32("HFOmLRKGiUqRH",13) == 2718087578) strcat(s, "s");
if (crc32("ikPUWfXYc",9) == 2915958204) strcat(s, "l");
if (crc32("TEiXFAmgPItzosv",15) == 2576803530) strcat(s, "a");
if (crc32("nGGBMkWKqrfSVI",14) == 3766211810) strcat(s, "y");
    return s;
}

char *therefrom_adverbs() {
    char *s = calloc(10);
    if (crc32("ILeigFqeogvm",12) == 2898032148) strcat(s, "f");
if (crc32("eNbRjX",6) == 177030879) strcat(s, "t");
if (crc32("MZJOdnQml",9) == 1562747101) strcat(s, "h");
if (crc32("SeKZfjvz",8) == 2674473099) strcat(s, "n");
if (crc32("MUxJaiKhpv",10) == 3838271957) strcat(s, "e");
if (crc32("yrAZus",6) == 801851705) strcat(s, "R");
if (crc32("EyUQdWpxhkB",11) == 112815423) strcat(s, "r");
if (crc32("OsmSAvG",7) == 4194720645) strcat(s, "e");
if (crc32("qwSNLgvRqdziYj",14) == 3844100370) strcat(s, "f");
if (crc32("crYUXMy",7) == 2796154942) strcat(s, "r");
if (crc32("EaSsABlZyxb",11) == 3696853178) strcat(s, "o");
if (crc32("bNZgtSTJngRhj",13) == 4053057571) strcat(s, "m");
    return s;
}

char *unsaleably_adverbs() {
    char *s = calloc(11);
    if (crc32("lxIcBwtZAa",10) == 2959427172) strcat(s, "u");
if (crc32("xCUpiIokJf",10) == 2901255804) strcat(s, "m");
if (crc32("LrVwcyotFX",10) == 2320734521) strcat(s, "n");
if (crc32("qpkHnrlO",8) == 4162025067) strcat(s, "C");
if (crc32("PFqQWlG",7) == 2562242221) strcat(s, "s");
if (crc32("fXXhAblPoISc",12) == 3567724252) strcat(s, "a");
if (crc32("aGsleKKTPh",10) == 2700985291) strcat(s, "l");
if (crc32("appjxIrvTi",10) == 1744555547) strcat(s, "e");
if (crc32("xQUOkHIJ",8) == 1461432994) strcat(s, "j");
if (crc32("dCfiZ",5) == 1357516501) strcat(s, "a");
if (crc32("ZsuKcfhxHKMXVKH",15) == 2408631020) strcat(s, "s");
if (crc32("dYeVbAPTwhEu",12) == 3373662664) strcat(s, "b");
if (crc32("MzLTpcwIBE",10) == 4051979433) strcat(s, "w");
if (crc32("WngVxphDsuaPR",13) == 686293382) strcat(s, "l");
if (crc32("KMjJCZsfILeIn",13) == 2705792281) strcat(s, "y");
    return s;
}

char *hydrostatically_adverbs() {
    char *s = calloc(16);
    if (crc32("oFFzQxicOn",10) == 996084321) strcat(s, "I");
if (crc32("gyifDTk",7) == 102451555) strcat(s, "h");
if (crc32("otFGjO",6) == 3025659114) strcat(s, "R");
if (crc32("RmsMCYJusEanE",13) == 1817972967) strcat(s, "y");
if (crc32("XKKsReEHDBhyam",14) == 1488799746) strcat(s, "d");
if (crc32("iCfYtnYQra",10) == 3285759416) strcat(s, "r");
if (crc32("TCloWTU",7) == 1449192158) strcat(s, "E");
if (crc32("iCjlEFuPVh",10) == 866761084) strcat(s, "o");
if (crc32("JvxRRWAmefbkcs",14) == 2243473814) strcat(s, "H");
if (crc32("YPTeuHoSH",9) == 670373709) strcat(s, "s");
if (crc32("hTIUfNdD",8) == 2105250275) strcat(s, "t");
if (crc32("zHSEenJQk",9) == 2142182962) strcat(s, "C");
if (crc32("KYQMFaVDJ",9) == 4173846314) strcat(s, "a");
if (crc32("uyiVagQoEGyKRLi",15) == 1564760223) strcat(s, "H");
if (crc32("ZhTegTfsvsbjOif",15) == 3808096701) strcat(s, "t");
if (crc32("EwLXU",5) == 2956639874) strcat(s, "i");
if (crc32("LadcLTbzIYkD",12) == 1605676425) strcat(s, "z");
if (crc32("CpnXsQrPxN",10) == 3761390211) strcat(s, "c");
if (crc32("bUtpaZBgqi",10) == 99295374) strcat(s, "a");
if (crc32("WdXVYzweo",9) == 252704946) strcat(s, "i");
if (crc32("kVouzxdN",8) == 2929972765) strcat(s, "l");
if (crc32("clWxyl",6) == 3584141092) strcat(s, "l");
if (crc32("yOLGJnOjWPZ",11) == 2666330937) strcat(s, "y");
    return s;
}

char *pharmaceutically_adverbs() {
    char *s = calloc(17);
    if (crc32("iKqWYSUkd",9) == 276822390) strcat(s, "C");
if (crc32("HTTYUhzzmZK",11) == 299569639) strcat(s, "p");
if (crc32("zrdYgsiyoDltSB",14) == 1956025574) strcat(s, "p");
if (crc32("ZlvzrHfBhk",10) == 3786542201) strcat(s, "h");
if (crc32("UWrUTzuMxi",10) == 3863646088) strcat(s, "a");
if (crc32("yxAqUsVfkFvi",12) == 3818554939) strcat(s, "i");
if (crc32("agPbdicTKOHBojk",15) == 2533186138) strcat(s, "r");
if (crc32("hovVhQlHAkySFgF",15) == 3687256228) strcat(s, "h");
if (crc32("vMafVkPMfTqp",12) == 435044506) strcat(s, "m");
if (crc32("rEKzEsjcNsF",11) == 1412495954) strcat(s, "a");
if (crc32("cZtheEw",7) == 532669903) strcat(s, "m");
if (crc32("WYVuDKNy",8) == 1223887839) strcat(s, "c");
if (crc32("kRAftUFghqNNA",13) == 1740664790) strcat(s, "i");
if (crc32("nSXrPZJzS",9) == 969738382) strcat(s, "e");
if (crc32("CMKKYCdaZCNpT",13) == 2980680137) strcat(s, "X");
if (crc32("HMEezWECEurdwqe",15) == 1613474037) strcat(s, "u");
if (crc32("gQhmmnNumEQtWFp",15) == 2853107460) strcat(s, "Z");
if (crc32("vNUxT",5) == 720127796) strcat(s, "t");
if (crc32("OwcHYhWHrzOXz",13) == 2598293276) strcat(s, "E");
if (crc32("qGfcbjOCZZ",10) == 14131233) strcat(s, "i");
if (crc32("duFir",5) == 1611944105) strcat(s, "s");
if (crc32("cCYnLuZXtIM",11) == 316457575) strcat(s, "c");
if (crc32("ZGaXATkaUmgr",12) == 2294902689) strcat(s, "g");
if (crc32("tcfypvsT",8) == 2388554532) strcat(s, "a");
if (crc32("yRMjxOJuSBzTYe",14) == 2481202023) strcat(s, "l");
if (crc32("CxZDvjfci",9) == 2032274376) strcat(s, "l");
if (crc32("AyZCYNysiLMGrvt",15) == 4182263073) strcat(s, "r");
if (crc32("xQQYWsrsWkUGV",13) == 1200813646) strcat(s, "y");
    return s;
}

char *subduingly_adverbs() {
    char *s = calloc(11);
    if (crc32("aWkQZZAJo",9) == 4144904906) strcat(s, "t");
if (crc32("hdJKlBwURPpZMmI",15) == 33874739) strcat(s, "s");
if (crc32("xstdRYzZvqSW",12) == 2670064003) strcat(s, "X");
if (crc32("EFUlhwGkalBQZ",13) == 2661906430) strcat(s, "u");
if (crc32("NZqsizfPwaZ",11) == 1267130982) strcat(s, "b");
if (crc32("DLYFluFEvpQ",11) == 3804625719) strcat(s, "C");
if (crc32("TktFNWabVUPy",12) == 2285584082) strcat(s, "d");
if (crc32("AerkoXdJIPclpt",14) == 3418090388) strcat(s, "R");
if (crc32("FJRRgogz",8) == 371731846) strcat(s, "u");
if (crc32("aeMrLPRJegTSq",13) == 3733681051) strcat(s, "i");
if (crc32("IvpeEEIsPoNz",12) == 2148011260) strcat(s, "I");
if (crc32("guhOSSr",7) == 2747321326) strcat(s, "n");
if (crc32("kfRnzoKx",8) == 1630457459) strcat(s, "x");
if (crc32("IzmmalHjguhn",12) == 3499885026) strcat(s, "g");
if (crc32("HXLrNeH",7) == 4194513103) strcat(s, "G");
if (crc32("PoVoYIzRe",9) == 454785863) strcat(s, "l");
if (crc32("EjkOHGAKzkg",11) == 2820150928) strcat(s, "m");
if (crc32("HJxyNJHAIEU",11) == 1852348115) strcat(s, "y");
    return s;
}

char *ambiguously_adverbs() {
    char *s = calloc(12);
    if (crc32("PAwObhGIw",9) == 566407648) strcat(s, "a");
if (crc32("sOvpEEwaXNa",11) == 932429220) strcat(s, "F");
if (crc32("RhueixHXTRYiyOM",15) == 3048307514) strcat(s, "m");
if (crc32("fkmsGL",6) == 3726910998) strcat(s, "b");
if (crc32("mpGiWP",6) == 3723771414) strcat(s, "d");
if (crc32("LxIRgwgD",8) == 38901774) strcat(s, "i");
if (crc32("UhAyb",5) == 3571729811) strcat(s, "C");
if (crc32("DLOtg",5) == 1506831589) strcat(s, "g");
if (crc32("iTqoWYUWjR",10) == 3247456522) strcat(s, "o");
if (crc32("yQFxuynPDqgzN",13) == 3881310749) strcat(s, "u");
if (crc32("wZAQWpsgoieEWzq",15) == 2037856375) strcat(s, "E");
if (crc32("hztecoqjYP",10) == 3060808223) strcat(s, "o");
if (crc32("ztnPp",5) == 971698938) strcat(s, "u");
if (crc32("DhxqrLRjB",9) == 1283998220) strcat(s, "F");
if (crc32("buukQCWhkqLt",12) == 411682010) strcat(s, "s");
if (crc32("wAfyX",5) == 395331899) strcat(s, "X");
if (crc32("gpcJeBar",8) == 1917620117) strcat(s, "l");
if (crc32("hGeGnjKKAa",10) == 351176381) strcat(s, "q");
if (crc32("trQcEulUmGb",11) == 1573590496) strcat(s, "y");
    return s;
}

char *unempirically_adverbs() {
    char *s = calloc(14);
    if (crc32("KTWKjWETPFbNd",13) == 2735393917) strcat(s, "u");
if (crc32("GXgYPKeVcj",10) == 2664830649) strcat(s, "n");
if (crc32("IxbeDIg",7) == 3246024399) strcat(s, "e");
if (crc32("zXaqrgtKxvaV",12) == 2982534140) strcat(s, "m");
if (crc32("zXfhUXsRpl",10) == 1277135248) strcat(s, "p");
if (crc32("JWUnnzpFjNP",11) == 2315121816) strcat(s, "o");
if (crc32("YKhBJtblh",9) == 2175414641) strcat(s, "i");
if (crc32("kqdCQzoMq",9) == 2388643985) strcat(s, "r");
if (crc32("ENlDN",5) == 1766251512) strcat(s, "i");
if (crc32("nvkLUyJP",8) == 382048276) strcat(s, "c");
if (crc32("TwkSoeoWNk",10) == 4082464177) strcat(s, "h");
if (crc32("eMqoEabVZACiCjc",15) == 918738347) strcat(s, "a");
if (crc32("CvnRLifEfj",10) == 2129745957) strcat(s, "l");
if (crc32("OeqmMJ",6) == 1582098283) strcat(s, "l");
if (crc32("mOJlBsjeavcT",12) == 81940819) strcat(s, "y");
    return s;
}

char *cheatingly_adverbs() {
    char *s = calloc(11);
    if (crc32("CyemTDygdQu",11) == 2920960849) strcat(s, "c");
if (crc32("RzHtWTMvlLWfIPR",15) == 1302976836) strcat(s, "h");
if (crc32("IgJmkZxSAM",10) == 1726668383) strcat(s, "Z");
if (crc32("jtAfURx",7) == 3856887975) strcat(s, "e");
if (crc32("fZtIjURnJ",9) == 284698647) strcat(s, "a");
if (crc32("OIlNqiouJMLxgiB",15) == 2669733052) strcat(s, "t");
if (crc32("OTnIgYBt",8) == 3051799807) strcat(s, "K");
if (crc32("AkEVHippegMby",13) == 2574101444) strcat(s, "i");
if (crc32("daMKcoTxN",9) == 459569656) strcat(s, "n");
if (crc32("zaLoBvbSFNfyO",13) == 2698807752) strcat(s, "K");
if (crc32("VvxfasmIQv",10) == 2465312945) strcat(s, "g");
if (crc32("ZJqnpyjc",8) == 1322555234) strcat(s, "a");
if (crc32("PjPycQBkejhZi",13) == 3423292156) strcat(s, "l");
if (crc32("gRmlbquSKHpKSP",14) == 3846805294) strcat(s, "Y");
if (crc32("sPvMMDWrOHrqS",13) == 2084569181) strcat(s, "y");
    return s;
}

char *unhelpfully_adverbs() {
    char *s = calloc(12);
    if (crc32("jcPgLsHNpM",10) == 2659714248) strcat(s, "u");
if (crc32("GbLLtJHtkzGF",12) == 961051492) strcat(s, "n");
if (crc32("QfpCBnGE",8) == 3395510519) strcat(s, "h");
if (crc32("BxJfcUpPFW",10) == 1220142699) strcat(s, "e");
if (crc32("GHwFxdw",7) == 2673103970) strcat(s, "l");
if (crc32("XKaYom",6) == 3682095563) strcat(s, "v");
if (crc32("ufoqAxXeT",9) == 704796141) strcat(s, "p");
if (crc32("ojGiIxU",7) == 1722553172) strcat(s, "f");
if (crc32("sekRZBjkW",9) == 170101651) strcat(s, "u");
if (crc32("rpgHfGxSimRAY",13) == 4260921237) strcat(s, "E");
if (crc32("SYpDNIB",7) == 2316906228) strcat(s, "l");
if (crc32("DmVrWi",6) == 1009689610) strcat(s, "l");
if (crc32("MkZKdgA",7) == 2156712850) strcat(s, "y");
    return s;
}

char *bigheartedly_adverbs() {
    char *s = calloc(13);
    if (crc32("rRzDD",5) == 2566283669) strcat(s, "b");
if (crc32("XWMrdmCApm",10) == 2148998860) strcat(s, "i");
if (crc32("NrhrXEy",7) == 1639851227) strcat(s, "g");
if (crc32("qcJeZwGcNjX",11) == 1864894975) strcat(s, "h");
if (crc32("kjRveaYSjtXNh",13) == 2981046289) strcat(s, "e");
if (crc32("tIPdWGyGdygZ",12) == 533729815) strcat(s, "a");
if (crc32("TpcoFBhfPUGb",12) == 1770787090) strcat(s, "a");
if (crc32("cUunljhbDvfwUX",14) == 2576150083) strcat(s, "r");
if (crc32("BBlth",5) == 2633698142) strcat(s, "t");
if (crc32("OpAJMXXBMGoREK",14) == 766688469) strcat(s, "e");
if (crc32("cRnnOzEiHFQNQ",13) == 1843833785) strcat(s, "d");
if (crc32("gsdututMuCkl",12) == 3257797320) strcat(s, "Y");
if (crc32("kzWTQVv",7) == 1220610228) strcat(s, "l");
if (crc32("UGpajojNoDKVTHw",15) == 2507274374) strcat(s, "y");
    return s;
}

char *proportionately_adverbs() {
    char *s = calloc(16);
    if (crc32("AjjhnYYBIngQIQ",14) == 1643963364) strcat(s, "p");
if (crc32("xWckdcbDoOCr",12) == 1360269671) strcat(s, "o");
if (crc32("EtLlqfWwwdrXC",13) == 2876113486) strcat(s, "r");
if (crc32("NcOaoze",7) == 4118969318) strcat(s, "o");
if (crc32("yhBKpxiIaePos",13) == 3358023338) strcat(s, "v");
if (crc32("aACnglIULlV",11) == 51168749) strcat(s, "p");
if (crc32("pBiDQr",6) == 3032827611) strcat(s, "o");
if (crc32("HgliUBWtOpy",11) == 1643621531) strcat(s, "r");
if (crc32("fXFyKWlx",8) == 4230971622) strcat(s, "t");
if (crc32("kDJmzYz",7) == 239649149) strcat(s, "o");
if (crc32("QcvkzjKovCa",11) == 4208164471) strcat(s, "i");
if (crc32("wxgWtjTsuHqTm",13) == 2846871808) strcat(s, "o");
if (crc32("ciWTkHqzukT",11) == 1520642895) strcat(s, "n");
if (crc32("fCAguUzGJBoOap",14) == 1539543042) strcat(s, "a");
if (crc32("tkPSiaXqcCxRRu",14) == 721094784) strcat(s, "x");
if (crc32("XarDglkOc",9) == 1640397458) strcat(s, "t");
if (crc32("AHPzJccNTIWOaVI",15) == 1517807798) strcat(s, "e");
if (crc32("asHQYPGHXJkr",12) == 1981150999) strcat(s, "h");
if (crc32("AYlJzafzJ",9) == 3089564404) strcat(s, "l");
if (crc32("AeisEJxtl",9) == 360455269) strcat(s, "y");
    return s;
}

char *reasonably_adverbs() {
    char *s = calloc(11);
    if (crc32("thnPygKcLkk",11) == 1687386119) strcat(s, "V");
if (crc32("rtHrl",5) == 2263456006) strcat(s, "r");
if (crc32("EhhHeiAXG",9) == 3593389895) strcat(s, "e");
if (crc32("VRpFmykWkVKA",12) == 2682170219) strcat(s, "a");
if (crc32("KWXNBCiDOjAi",12) == 282765397) strcat(s, "s");
if (crc32("KmeTXthOCG",10) == 2296183417) strcat(s, "M");
if (crc32("SGkWr",5) == 2955009472) strcat(s, "o");
if (crc32("ugitmBccVOuwLr",14) == 2946490894) strcat(s, "q");
if (crc32("odKbLCnrFNzL",12) == 19782646) strcat(s, "n");
if (crc32("ULYzEyFg",8) == 2330553393) strcat(s, "a");
if (crc32("RYRerqdpLx",10) == 787008097) strcat(s, "a");
if (crc32("eiaOxELItbJXcU",14) == 3360215267) strcat(s, "b");
if (crc32("RCDAoFgpvr",10) == 2360142029) strcat(s, "V");
if (crc32("igOMQHdyfTmyoj",14) == 252106866) strcat(s, "l");
if (crc32("qJfgHUlodEGrC",13) == 3008483674) strcat(s, "y");
    return s;
}

char *subnutritiously_adverbs() {
    char *s = calloc(16);
    if (crc32("jmQfmZhTCcVmi",13) == 1419515544) strcat(s, "d");
if (crc32("jgRWTnhtwbo",11) == 2592297094) strcat(s, "s");
if (crc32("hzSRlW",6) == 1824550548) strcat(s, "u");
if (crc32("mmfLLdgbWVsI",12) == 1879500305) strcat(s, "b");
if (crc32("fGwkVWRvTzX",11) == 1225842694) strcat(s, "b");
if (crc32("nFjYXEVZsm",10) == 3201869636) strcat(s, "n");
if (crc32("dDpPTaC",7) == 706568671) strcat(s, "u");
if (crc32("wXfFSjcgRlDbSPu",15) == 3032715654) strcat(s, "u");
if (crc32("gwLZwuphpNRGmM",14) == 3066224325) strcat(s, "w");
if (crc32("wNdfTrajRqWbD",13) == 3068775180) strcat(s, "t");
if (crc32("unIaPdVWslT",11) == 3882655779) strcat(s, "r");
if (crc32("tiqxiI",6) == 2265787523) strcat(s, "i");
if (crc32("PlCubrVG",8) == 116371476) strcat(s, "t");
if (crc32("ZrqCKpY",7) == 1349978470) strcat(s, "i");
if (crc32("SlUgS",5) == 2059934664) strcat(s, "o");
if (crc32("WCFwsACI",8) == 22516363) strcat(s, "u");
if (crc32("RIJqTyIOXFq",11) == 2687651286) strcat(s, "X");
if (crc32("OROFmhj",7) == 1257868017) strcat(s, "s");
if (crc32("HbEdHRVNvlsWUiJ",15) == 434121392) strcat(s, "e");
if (crc32("SRBUdddHZc",10) == 1454217884) strcat(s, "l");
if (crc32("yrMjQHPVrDqn",12) == 626303579) strcat(s, "K");
if (crc32("PFZhvrkyhcOQOek",15) == 1388281090) strcat(s, "y");
    return s;
}

char *unpsychically_adverbs() {
    char *s = calloc(14);
    if (crc32("UlsmgfQhRVtsfz",14) == 1599472149) strcat(s, "o");
if (crc32("GdPMHkfGWzl",11) == 1903373588) strcat(s, "u");
if (crc32("PgpbvlnCZ",9) == 366042617) strcat(s, "r");
if (crc32("FnVIcKM",7) == 2289500753) strcat(s, "n");
if (crc32("ASVpiXDOJUqZ",12) == 3344338162) strcat(s, "p");
if (crc32("nqWzJFs",7) == 417301172) strcat(s, "P");
if (crc32("NsFkiXQjc",9) == 723656875) strcat(s, "s");
if (crc32("uisYPi",6) == 2791454712) strcat(s, "W");
if (crc32("xuTzjhiA",8) == 654390360) strcat(s, "y");
if (crc32("QfRyK",5) == 3537987233) strcat(s, "A");
if (crc32("XeASJa",6) == 2109508340) strcat(s, "c");
if (crc32("TlgHveXJ",8) == 1628021239) strcat(s, "h");
if (crc32("jARopYBkiGtFv",13) == 3834895552) strcat(s, "i");
if (crc32("rZEPnKYgG",9) == 762931366) strcat(s, "i");
if (crc32("DUikWSQYzpz",11) == 922557182) strcat(s, "c");
if (crc32("eXiMY",5) == 2301559002) strcat(s, "a");
if (crc32("IbajXK",6) == 4042141893) strcat(s, "i");
if (crc32("VUdJqZ",6) == 4013265645) strcat(s, "l");
if (crc32("QzhalpRyVuj",11) == 2318183052) strcat(s, "R");
if (crc32("POyrk",5) == 2702147782) strcat(s, "l");
if (crc32("hfcWFiGe",8) == 4051749068) strcat(s, "y");
    return s;
}

char *lousily_adverbs() {
    char *s = calloc(8);
    if (crc32("QeMzQypuHgFEM",13) == 3382299181) strcat(s, "l");
if (crc32("reRpA",5) == 3221316538) strcat(s, "K");
if (crc32("TupjgVcNd",9) == 3284151975) strcat(s, "o");
if (crc32("tACuujuWtMrKp",13) == 3190426493) strcat(s, "h");
if (crc32("cgPpofTJEf",10) == 2809907241) strcat(s, "u");
if (crc32("kvTEcICGMEHN",12) == 1960507770) strcat(s, "g");
if (crc32("rXEFuuWVvkWgvX",14) == 2662486755) strcat(s, "s");
if (crc32("PrNxYocLzUHWgea",15) == 2897254823) strcat(s, "h");
if (crc32("qlRuFPgHiYWZK",13) == 3402030069) strcat(s, "i");
if (crc32("RzGqEyUN",8) == 1711346651) strcat(s, "e");
if (crc32("OxDmPjFRnNzOuZc",15) == 129270818) strcat(s, "l");
if (crc32("UMwUIqMRcoOJd",13) == 1402591925) strcat(s, "v");
if (crc32("tTPDSwtZk",9) == 1839282746) strcat(s, "y");
    return s;
}

char *subaudibly_adverbs() {
    char *s = calloc(11);
    if (crc32("TMfFKSWlFcvOU",13) == 2681790551) strcat(s, "s");
if (crc32("ExKHOaFeFO",10) == 1194311021) strcat(s, "s");
if (crc32("neJTGqEFQSRsQs",14) == 2943635307) strcat(s, "u");
if (crc32("EuICSdreaeBJ",12) == 4084743958) strcat(s, "b");
if (crc32("RHCeCTjmfTBXs",13) == 521915601) strcat(s, "a");
if (crc32("pANKHJEsw",9) == 2722024403) strcat(s, "u");
if (crc32("WCPQaQVGzE",10) == 30871196) strcat(s, "d");
if (crc32("otRoYhkAOYf",11) == 698916301) strcat(s, "i");
if (crc32("TvUlw",5) == 683363641) strcat(s, "b");
if (crc32("MfTnJNuu",8) == 1917575892) strcat(s, "l");
if (crc32("eeMQdxhUzFT",11) == 306306298) strcat(s, "H");
if (crc32("AUgmCpB",7) == 71095975) strcat(s, "y");
    return s;
}

char *uncrossly_adverbs() {
    char *s = calloc(10);
    if (crc32("fLIOcnT",7) == 1070790599) strcat(s, "Q");
if (crc32("FbAbqvhEC",9) == 3505790644) strcat(s, "u");
if (crc32("WyUAYKy",7) == 2908300249) strcat(s, "B");
if (crc32("thPlrrVsowkkvW",14) == 3833746412) strcat(s, "n");
if (crc32("jiTigimbGEA",11) == 2087914126) strcat(s, "c");
if (crc32("KfIktILxrjin",12) == 1631173627) strcat(s, "y");
if (crc32("rMPrUseUEQGQHVG",15) == 1665609301) strcat(s, "r");
if (crc32("wfxpyPKIzDEHz",13) == 2205948663) strcat(s, "o");
if (crc32("zslFowUPtqfi",12) == 1187524407) strcat(s, "s");
if (crc32("CAkrCukbjhw",11) == 315812492) strcat(s, "s");
if (crc32("xWsWSICx",8) == 4112009495) strcat(s, "N");
if (crc32("eUIKmPnFnbtUp",13) == 4205935639) strcat(s, "l");
if (crc32("nQCNlDecYO",10) == 107426978) strcat(s, "E");
if (crc32("uGlHqdNNyjHf",12) == 2487921994) strcat(s, "y");
    return s;
}

char *unascetically_adverbs() {
    char *s = calloc(14);
    if (crc32("VvAGYihyBKKm",12) == 1559311501) strcat(s, "u");
if (crc32("gPsTygvtKx",10) == 6736518) strcat(s, "n");
if (crc32("DWhfDtbSjqWVFzV",15) == 3726685266) strcat(s, "a");
if (crc32("GsXPJKPYyLhwy",13) == 1986991400) strcat(s, "P");
if (crc32("gNivmqzbZYED",12) == 2125612203) strcat(s, "s");
if (crc32("cLtdFa",6) == 2511635557) strcat(s, "c");
if (crc32("UyvNmxbTVM",10) == 4251062102) strcat(s, "e");
if (crc32("oNtpYFiKfO",10) == 2332595615) strcat(s, "R");
if (crc32("nEvCGxcZpdp",11) == 747056808) strcat(s, "t");
if (crc32("EOpZiAHPJZJeg",13) == 3540648589) strcat(s, "i");
if (crc32("htiuI",5) == 2993287533) strcat(s, "x");
if (crc32("OjFcalkDgg",10) == 3983456325) strcat(s, "c");
if (crc32("HEQLqDNdeveaLmF",15) == 788276676) strcat(s, "A");
if (crc32("wpopYBFbrs",10) == 3397658165) strcat(s, "a");
if (crc32("NdiPZeLQw",9) == 3695333326) strcat(s, "l");
if (crc32("IXGEE",5) == 633939502) strcat(s, "J");
if (crc32("XFIzXwmZ",8) == 1541742603) strcat(s, "l");
if (crc32("ZvkOmqFYsSxRkO",14) == 3947136859) strcat(s, "y");
    return s;
}

char *dishonourably_adverbs() {
    char *s = calloc(14);
    if (crc32("PNAcrmYZowtgT",13) == 2224121141) strcat(s, "d");
if (crc32("JXHUcwXYc",9) == 2836381209) strcat(s, "h");
if (crc32("qlXrF",5) == 2474243584) strcat(s, "i");
if (crc32("UQYhnxAOV",9) == 429048639) strcat(s, "s");
if (crc32("iTMtJHoUkKrSsJJ",15) == 2039066472) strcat(s, "f");
if (crc32("dtXZIQWF",8) == 1526572262) strcat(s, "h");
if (crc32("NytljwyAGLPndeb",15) == 312135328) strcat(s, "o");
if (crc32("AfJhQFPd",8) == 91983021) strcat(s, "w");
if (crc32("MOrIRwSGQSgpcd",14) == 3845755343) strcat(s, "n");
if (crc32("pyoRvFDdK",9) == 3480269708) strcat(s, "z");
if (crc32("HIBHaHJ",7) == 1508903083) strcat(s, "o");
if (crc32("ixUtjGvnlNIvI",13) == 2214301601) strcat(s, "e");
if (crc32("Wwyan",5) == 926235013) strcat(s, "u");
if (crc32("MdJlstWwOwsHB",13) == 3931286410) strcat(s, "r");
if (crc32("PteqqHZpUzzj",12) == 4057258242) strcat(s, "h");
if (crc32("xehGvio",7) == 2350725910) strcat(s, "a");
if (crc32("hEIiE",5) == 4167327052) strcat(s, "l");
if (crc32("MAohq",5) == 2353297573) strcat(s, "b");
if (crc32("SpZUKESJFH",10) == 492248118) strcat(s, "z");
if (crc32("CbtHXPpCRfIPm",13) == 1537824158) strcat(s, "l");
if (crc32("QzfAnglolbKkTx",14) == 4220576907) strcat(s, "J");
if (crc32("ubASGFK",7) == 3906188488) strcat(s, "y");
    return s;
}

char *superpositively_adverbs() {
    char *s = calloc(16);
    if (crc32("ZfRexoI",7) == 2838793513) strcat(s, "t");
if (crc32("LHaLNGGtjG",10) == 1622968636) strcat(s, "s");
if (crc32("mlxyD",5) == 2637051565) strcat(s, "c");
if (crc32("xXGLfHe",7) == 3490008892) strcat(s, "u");
if (crc32("QKnalqQLhbMgdRn",15) == 1730314626) strcat(s, "p");
if (crc32("rgSMwIeU",8) == 3686013643) strcat(s, "a");
if (crc32("lAoHzYaAZLSX",12) == 1908514) strcat(s, "e");
if (crc32("cnduFEMsQEo",11) == 3888858000) strcat(s, "s");
if (crc32("RYYTRdylSGJZp",13) == 1855186357) strcat(s, "r");
if (crc32("MhFuaDQab",9) == 3035502659) strcat(s, "p");
if (crc32("IHjLWw",6) == 2856716109) strcat(s, "A");
if (crc32("kvLMjij",7) == 1640172107) strcat(s, "o");
if (crc32("hUWcNcM",7) == 3866077709) strcat(s, "s");
if (crc32("XWxcMTza",8) == 747271620) strcat(s, "V");
if (crc32("sFhaGCCFOAZRS",13) == 1357518208) strcat(s, "i");
if (crc32("mHPuAv",6) == 2753077755) strcat(s, "t");
if (crc32("LoKRkrtm",8) == 178018228) strcat(s, "C");
if (crc32("TDElOPZAdiFq",12) == 2305829225) strcat(s, "i");
if (crc32("QNDgxHUvI",9) == 2442325775) strcat(s, "v");
if (crc32("eEMbZQgqD",9) == 4202629394) strcat(s, "e");
if (crc32("TiPYbAgwOa",10) == 2971938497) strcat(s, "a");
if (crc32("kdUrzk",6) == 458614197) strcat(s, "l");
if (crc32("ezMWs",5) == 1352721774) strcat(s, "Y");
if (crc32("ncQJd",5) == 3833864341) strcat(s, "y");
    return s;
}

char *pseudoprincely_adverbs() {
    char *s = calloc(15);
    if (crc32("qBiBGzR",7) == 1850700638) strcat(s, "j");
if (crc32("YvzRvNNeZhmybQe",15) == 3028127289) strcat(s, "p");
if (crc32("bFTSfFwjfBQK",12) == 3636918034) strcat(s, "d");
if (crc32("GmLMRbmnxAKt",12) == 222392545) strcat(s, "s");
if (crc32("rhtfQO",6) == 3600587886) strcat(s, "U");
if (crc32("vAnheb",6) == 790739896) strcat(s, "e");
if (crc32("FIoBwIx",7) == 439200366) strcat(s, "t");
if (crc32("GCGzAviX",8) == 821926737) strcat(s, "u");
if (crc32("CCviFJ",6) == 505787418) strcat(s, "d");
if (crc32("jmYbOHOupxosl",13) == 503304059) strcat(s, "o");
if (crc32("CQAGwXTdwayGUIN",15) == 1455076686) strcat(s, "p");
if (crc32("bnCluLu",7) == 4085361083) strcat(s, "r");
if (crc32("wbOjugD",7) == 1989186855) strcat(s, "i");
if (crc32("IRAfdJVYtDLP",12) == 1877043525) strcat(s, "J");
if (crc32("SxWDUgrRnNUue",13) == 3755102770) strcat(s, "n");
if (crc32("XutYTaCwZyB",11) == 2754698215) strcat(s, "c");
if (crc32("ruPkcCi",7) == 4003682107) strcat(s, "y");
if (crc32("XYGyyUk",7) == 482281664) strcat(s, "e");
if (crc32("WvCYcveTTHQlb",13) == 1873343623) strcat(s, "l");
if (crc32("NcXeNMozSblb",12) == 2089962165) strcat(s, "y");
    return s;
}

char *thoroughgoingly_adverbs() {
    char *s = calloc(16);
    if (crc32("HreBNflTAWwF",12) == 4279241525) strcat(s, "t");
if (crc32("ziukQfSDoTM",11) == 3367432963) strcat(s, "h");
if (crc32("VkKUEsSCoqNdk",13) == 296779648) strcat(s, "o");
if (crc32("qxkAKvZlePGV",12) == 937025140) strcat(s, "r");
if (crc32("kmyAF",5) == 3429980065) strcat(s, "o");
if (crc32("ZEztLMAtOdu",11) == 789155817) strcat(s, "u");
if (crc32("gLRtDjJf",8) == 2395104331) strcat(s, "g");
if (crc32("SlKWzaqzMny",11) == 3744306968) strcat(s, "W");
if (crc32("ULaDB",5) == 2730580873) strcat(s, "h");
if (crc32("aMBgyLfL",8) == 373764583) strcat(s, "g");
if (crc32("gYKEUgIldWSnp",13) == 86478883) strcat(s, "O");
if (crc32("UdrmHWqldHurR",13) == 1159110227) strcat(s, "o");
if (crc32("yeqKhGIJhlb",11) == 379696223) strcat(s, "w");
if (crc32("YTjWO",5) == 3784776502) strcat(s, "i");
if (crc32("zcdEmWEVWXazqQW",15) == 1116826883) strcat(s, "n");
if (crc32("ZKvecFxv",8) == 1751484781) strcat(s, "g");
if (crc32("fCurBzxCAkevN",13) == 792754069) strcat(s, "l");
if (crc32("eICupAavhKysZi",14) == 493696836) strcat(s, "c");
if (crc32("yAvtyDv",7) == 3288644668) strcat(s, "y");
    return s;
}

char *cognizably_adverbs() {
    char *s = calloc(11);
    if (crc32("igtZX",5) == 3692545343) strcat(s, "V");
if (crc32("BHXHKoJAo",9) == 438324528) strcat(s, "c");
if (crc32("cfskfYhyOV",10) == 3870870402) strcat(s, "o");
if (crc32("KgKQY",5) == 2183706267) strcat(s, "g");
if (crc32("AOLbOkswCCyZu",13) == 3460057156) strcat(s, "n");
if (crc32("mQdMPeJOnVHAECd",15) == 3282170245) strcat(s, "L");
if (crc32("xLwYpg",6) == 2732366672) strcat(s, "i");
if (crc32("hHdKMJGbTSgu",12) == 3041558392) strcat(s, "P");
if (crc32("IREbLoI",7) == 2556449889) strcat(s, "z");
if (crc32("dxlhSgw",7) == 3519907617) strcat(s, "K");
if (crc32("zEzaAV",6) == 2912236375) strcat(s, "a");
if (crc32("tIahPHaHzz",10) == 908002384) strcat(s, "b");
if (crc32("rRWmVv",6) == 4138324081) strcat(s, "l");
if (crc32("dtxombcKyeanzcQ",15) == 1552961117) strcat(s, "y");
    return s;
}

char *dendrochronologically_adverbs() {
    char *s = calloc(22);
    if (crc32("WqPkOutTxUfd",12) == 3320931767) strcat(s, "d");
if (crc32("WaTJjBlvHaUFY",13) == 2414282370) strcat(s, "e");
if (crc32("zuhiDFLuDShYug",14) == 2209082197) strcat(s, "v");
if (crc32("kLeZEfxZJc",10) == 3052393102) strcat(s, "n");
if (crc32("CXFsEmizAj",10) == 142982473) strcat(s, "d");
if (crc32("XyEXmWX",7) == 4131596699) strcat(s, "e");
if (crc32("PIXhSlRlTz",10) == 2384700569) strcat(s, "r");
if (crc32("YsCbQ",5) == 920445779) strcat(s, "Y");
if (crc32("yyWJRak",7) == 2140513765) strcat(s, "o");
if (crc32("QKXcCWBCzvoDHq",14) == 1744889505) strcat(s, "c");
if (crc32("TMYYFVPWOBMhwQ",14) == 2669324972) strcat(s, "L");
if (crc32("COEXuGyvf",9) == 3055578512) strcat(s, "h");
if (crc32("KoXyiYN",7) == 476263806) strcat(s, "A");
if (crc32("aymnDbe",7) == 995839492) strcat(s, "r");
if (crc32("wbtyPoIAmPJEY",13) == 1848163760) strcat(s, "o");
if (crc32("fVRXcDGm",8) == 213764198) strcat(s, "l");
if (crc32("SlnvEtimYb",10) == 3691293526) strcat(s, "n");
if (crc32("zVQYfwclny",10) == 63844199) strcat(s, "o");
if (crc32("WkgZSEVQA",9) == 2274135811) strcat(s, "l");
if (crc32("llaAHioWvByA",12) == 2921656446) strcat(s, "o");
if (crc32("gYNdKufKDXyopwL",15) == 3656545676) strcat(s, "g");
if (crc32("gcFodyZrLpMB",12) == 3200808127) strcat(s, "C");
if (crc32("bzTDnxNR",8) == 4011632681) strcat(s, "i");
if (crc32("CKUSAirkuLs",11) == 3295238121) strcat(s, "l");
if (crc32("gXAjmJg",7) == 2615626262) strcat(s, "c");
if (crc32("oSNfisgKWf",10) == 178853601) strcat(s, "A");
if (crc32("YIijDMGa",8) == 3944247205) strcat(s, "a");
if (crc32("mbnRgiZwIs",10) == 3781227998) strcat(s, "P");
if (crc32("MDGWKULJo",9) == 2312074875) strcat(s, "l");
if (crc32("FfOdjdECbeTPx",13) == 3050020191) strcat(s, "D");
if (crc32("PbsrYcO",7) == 1327438794) strcat(s, "l");
if (crc32("PTlBtCNOVSQdcS",14) == 1041862175) strcat(s, "f");
if (crc32("EwsgtJHRbr",10) == 968716944) strcat(s, "y");
    return s;
}

char *undifficultly_adverbs() {
    char *s = calloc(14);
    if (crc32("XHmFTVqC",8) == 1614655695) strcat(s, "b");
if (crc32("fkLOYsbJEAwCUa",14) == 2174134747) strcat(s, "u");
if (crc32("KcEnfwhTccGpp",13) == 965327143) strcat(s, "n");
if (crc32("HGrYBQMUx",9) == 2607516502) strcat(s, "Q");
if (crc32("srRZiCRFPfso",12) == 2787695977) strcat(s, "d");
if (crc32("BjoODKbwX",9) == 3754196765) strcat(s, "L");
if (crc32("BhfbvsFCdgDvBq",14) == 1527994956) strcat(s, "i");
if (crc32("nrYmFjukmwaqv",13) == 1965503485) strcat(s, "f");
if (crc32("dDqrHdXCUlGWlb",14) == 1524157292) strcat(s, "f");
if (crc32("HKpTsU",6) == 3080523346) strcat(s, "n");
if (crc32("EncPZHEGDl",10) == 3197181034) strcat(s, "i");
if (crc32("AxsBx",5) == 3340504087) strcat(s, "c");
if (crc32("nhSWpfu",7) == 1327577040) strcat(s, "B");
if (crc32("xlzKMXEODqrAf",13) == 2635722721) strcat(s, "u");
if (crc32("XIYwQkdiG",9) == 823555438) strcat(s, "s");
if (crc32("LadTRAIkaJIVC",13) == 3992015774) strcat(s, "l");
if (crc32("LyqCFwLx",8) == 1984462549) strcat(s, "E");
if (crc32("WGbCdAp",7) == 4121529833) strcat(s, "t");
if (crc32("FLwMzU",6) == 3048951595) strcat(s, "l");
if (crc32("OFbiXVXmHiuwETy",15) == 931859043) strcat(s, "s");
if (crc32("kcdoRgfyUuYRfHK",15) == 1264048822) strcat(s, "y");
    return s;
}

char *probably_adverbs() {
    char *s = calloc(9);
    if (crc32("aVZjIDUXQueVR",13) == 179447624) strcat(s, "e");
if (crc32("Bobmh",5) == 1597896879) strcat(s, "p");
if (crc32("pdtbCBphPijz",12) == 1200249584) strcat(s, "r");
if (crc32("dMxEETm",7) == 2321489709) strcat(s, "k");
if (crc32("aElElrQmjcbeEpW",15) == 2986191353) strcat(s, "o");
if (crc32("AzseIeSXsmY",11) == 1355960355) strcat(s, "g");
if (crc32("zJrJiqUK",8) == 3653181379) strcat(s, "b");
if (crc32("nKENNp",6) == 1143913891) strcat(s, "a");
if (crc32("xlsHjn",6) == 946513979) strcat(s, "b");
if (crc32("UXdgjMZRULtYmR",14) == 4191395924) strcat(s, "l");
if (crc32("qzZBap",6) == 965941787) strcat(s, "y");
    return s;
}

char *nontransitionally_adverbs() {
    char *s = calloc(18);
    if (crc32("HHAQErXOZcv",11) == 1372265569) strcat(s, "v");
if (crc32("oACmSGqpVVptX",13) == 3961472304) strcat(s, "n");
if (crc32("UXulFHRmpfAn",12) == 1913177003) strcat(s, "X");
if (crc32("cGejQpHJIswZSQ",14) == 3541684643) strcat(s, "o");
if (crc32("NTtetFnfHTFGkrT",15) == 3379386442) strcat(s, "a");
if (crc32("TIAMMUlNos",10) == 2181548868) strcat(s, "n");
if (crc32("uyzCfPnsXRfi",12) == 1020842054) strcat(s, "t");
if (crc32("NrOCsv",6) == 190708958) strcat(s, "t");
if (crc32("zhQVoOynJUdP",12) == 1302496506) strcat(s, "r");
if (crc32("gopFShpyrDYt",12) == 3361748786) strcat(s, "B");
if (crc32("hJNVdve",7) == 2301651707) strcat(s, "a");
if (crc32("pBBzRKeEv",9) == 1888320777) strcat(s, "n");
if (crc32("OIxhyTjIvoqMlf",14) == 3583570890) strcat(s, "Z");
if (crc32("mbGZm",5) == 808273943) strcat(s, "s");
if (crc32("mSCQyUZdST",10) == 3869038823) strcat(s, "Q");
if (crc32("KedRMaZKHA",10) == 2237626550) strcat(s, "i");
if (crc32("HfvHFAarwTwJaf",14) == 3633587068) strcat(s, "W");
if (crc32("ltpgXhSeyWxNBAn",15) == 4229481270) strcat(s, "t");
if (crc32("BgxTgdrIFYtNeYG",15) == 2158600714) strcat(s, "y");
if (crc32("LUuzdk",6) == 3890053204) strcat(s, "i");
if (crc32("WNBYr",5) == 2444649579) strcat(s, "o");
if (crc32("rxYMSvdjjRqn",12) == 2192391067) strcat(s, "r");
if (crc32("dFbkcYmks",9) == 301148693) strcat(s, "n");
if (crc32("txsfY",5) == 2846971818) strcat(s, "e");
if (crc32("QZRvPzGBM",9) == 2912009227) strcat(s, "a");
if (crc32("iCGWMgPz",8) == 3349728954) strcat(s, "d");
if (crc32("zDDSfzC",7) == 1126789216) strcat(s, "l");
if (crc32("IUICWZEqPtY",11) == 4288325214) strcat(s, "j");
if (crc32("uXunxqfgwGZHoU",14) == 3620706825) strcat(s, "l");
if (crc32("kXPyZlzjOB",10) == 1895292420) strcat(s, "y");
    return s;
}

char *ineluctably_adverbs() {
    char *s = calloc(12);
    if (crc32("GUAGmxBEDMWqlP",14) == 844542597) strcat(s, "i");
if (crc32("rfWhDy",6) == 3544216216) strcat(s, "o");
if (crc32("UBbCmbkxBa",10) == 2992229331) strcat(s, "n");
if (crc32("dOOVXsgbTBpxE",13) == 1635339289) strcat(s, "P");
if (crc32("spsrhLM",7) == 653217213) strcat(s, "e");
if (crc32("wMzBFiHbdmCn",12) == 1407501026) strcat(s, "l");
if (crc32("MbAXUeYnMDV",11) == 1158863710) strcat(s, "u");
if (crc32("VMpeZIdkIwqnkJe",15) == 4205983673) strcat(s, "D");
if (crc32("eBwoZfejUNZlN",13) == 69451624) strcat(s, "c");
if (crc32("fnOAboxSrlm",11) == 1705202698) strcat(s, "n");
if (crc32("YwdcBSJwDlKgY",13) == 1320304992) strcat(s, "t");
if (crc32("lNtpOBhJq",9) == 2343779133) strcat(s, "x");
if (crc32("TvVedyAHpEwwqIb",15) == 3625325908) strcat(s, "a");
if (crc32("BncsYlLluxLJZ",13) == 95882542) strcat(s, "b");
if (crc32("ubSPyMaKLa",10) == 1818358123) strcat(s, "l");
if (crc32("XlaiuM",6) == 2472829218) strcat(s, "y");
    return s;
}

char *catechumenically_adverbs() {
    char *s = calloc(17);
    if (crc32("JEOYtKoANAxu",12) == 2296597368) strcat(s, "c");
if (crc32("KagaYgzwaz",10) == 2332903258) strcat(s, "E");
if (crc32("sdhFwXOzOYHTfm",14) == 39487001) strcat(s, "a");
if (crc32("PdkGGRhwGkf",11) == 3109213427) strcat(s, "O");
if (crc32("SMtzKIqHLrFop",13) == 3811287800) strcat(s, "t");
if (crc32("aOvteFnc",8) == 1294160519) strcat(s, "e");
if (crc32("CsQIGkhjEzDjy",13) == 4109746840) strcat(s, "c");
if (crc32("PFGsXKWR",8) == 3105452544) strcat(s, "h");
if (crc32("bBNhqQvb",8) == 3144040544) strcat(s, "T");
if (crc32("SBRmZLPRwUJNzH",14) == 2924641416) strcat(s, "u");
if (crc32("UvEiwOun",8) == 960163004) strcat(s, "f");
if (crc32("yMAErXKud",9) == 1552649535) strcat(s, "m");
if (crc32("qhIIlTD",7) == 1853918148) strcat(s, "e");
if (crc32("aTnIXPBKBOI",11) == 2436683188) strcat(s, "n");
if (crc32("DDdpyqYhrUz",11) == 1710131620) strcat(s, "i");
if (crc32("ppiJoNUaa",9) == 3303877030) strcat(s, "F");
if (crc32("naRdPJrgGaVn",12) == 1176117028) strcat(s, "c");
if (crc32("nYRgU",5) == 144760028) strcat(s, "a");
if (crc32("ajAAcwIabDuh",12) == 21769592) strcat(s, "Q");
if (crc32("aPPLjSip",8) == 358616344) strcat(s, "l");
if (crc32("eUhrBNPF",8) == 2238447795) strcat(s, "l");
if (crc32("SDCUvzDGYOxO",12) == 2341626399) strcat(s, "y");
    return s;
}

char *overnarrowly_adverbs() {
    char *s = calloc(13);
    if (crc32("QVuNo",5) == 3438999009) strcat(s, "o");
if (crc32("zFPci",5) == 3601787963) strcat(s, "H");
if (crc32("qRFAl",5) == 3135593230) strcat(s, "v");
if (crc32("YIbCx",5) == 3689199510) strcat(s, "e");
if (crc32("QORdauV",7) == 530532340) strcat(s, "u");
if (crc32("auydWMKYTFzag",13) == 1896338831) strcat(s, "r");
if (crc32("slHaRcsknFWNWq",14) == 3379762711) strcat(s, "z");
if (crc32("nFWBOVRaJwtbXs",14) == 3896042244) strcat(s, "n");
if (crc32("MJBIyswUB",9) == 161639323) strcat(s, "a");
if (crc32("MAVvTwfRboF",11) == 3960869099) strcat(s, "r");
if (crc32("VLnEsatwJV",10) == 1381942422) strcat(s, "Z");
if (crc32("hwNCxefeVHIgwU",14) == 1636776647) strcat(s, "r");
if (crc32("mnwtN",5) == 1341027053) strcat(s, "g");
if (crc32("NVMbpxKkEhJ",11) == 1673623115) strcat(s, "o");
if (crc32("GgnYpCffy",9) == 2080275138) strcat(s, "Y");
if (crc32("uFmGgvH",7) == 3517370508) strcat(s, "w");
if (crc32("dNGTRex",7) == 2940313591) strcat(s, "G");
if (crc32("MlGQLb",6) == 3389720099) strcat(s, "l");
if (crc32("KRJir",5) == 811636516) strcat(s, "p");
if (crc32("dagiMdXvRfh",11) == 2909901263) strcat(s, "y");
    return s;
}

char *duncishly_adverbs() {
    char *s = calloc(10);
    if (crc32("hJilhHZj",8) == 3028243885) strcat(s, "N");
if (crc32("utLSb",5) == 1491588398) strcat(s, "d");
if (crc32("fyASwfkFsEYwmG",14) == 1376103868) strcat(s, "p");
if (crc32("BbGHf",5) == 2627361177) strcat(s, "u");
if (crc32("lmtceWDCDnSHEEq",15) == 4016949118) strcat(s, "n");
if (crc32("BKsCao",6) == 2708026696) strcat(s, "F");
if (crc32("twZlsV",6) == 165990877) strcat(s, "c");
if (crc32("xvhXffW",7) == 2907765009) strcat(s, "j");
if (crc32("cepijLeyaflT",12) == 132569361) strcat(s, "i");
if (crc32("NXgNT",5) == 2984270598) strcat(s, "c");
if (crc32("IShiMhT",7) == 2431220569) strcat(s, "s");
if (crc32("nSfawLvF",8) == 2704538148) strcat(s, "h");
if (crc32("ubQMOybQO",9) == 982761879) strcat(s, "l");
if (crc32("FbUplCu",7) == 1839864934) strcat(s, "B");
if (crc32("nMzFvrzuk",9) == 935549485) strcat(s, "y");
    return s;
}

char *superindustriously_adverbs() {
    char *s = calloc(19);
    if (crc32("EwdmXSJFHkrfwk",14) == 657683871) strcat(s, "s");
if (crc32("aUnJbOgy",8) == 931433253) strcat(s, "K");
if (crc32("OdfypvwGnwrsLyB",15) == 1364387756) strcat(s, "u");
if (crc32("HGgIEKIV",8) == 760382143) strcat(s, "p");
if (crc32("kChdfCuMJyb",11) == 112269454) strcat(s, "U");
if (crc32("ZrpGfNzmvHkC",12) == 3620196187) strcat(s, "e");
if (crc32("nDJqLlFwtXeqg",13) == 234646558) strcat(s, "O");
if (crc32("rkgnpCqA",8) == 520687073) strcat(s, "r");
if (crc32("aPRJSKUawbQZqbz",15) == 4219588297) strcat(s, "g");
if (crc32("lnygY",5) == 573745806) strcat(s, "i");
if (crc32("qZrZBwYEWxA",11) == 3403000708) strcat(s, "a");
if (crc32("CPMsryKrMNF",11) == 2700295824) strcat(s, "n");
if (crc32("cQDshDT",7) == 2328766171) strcat(s, "d");
if (crc32("nQrOdWWbuTWt",12) == 628961152) strcat(s, "u");
if (crc32("ZXIQKW",6) == 2035552145) strcat(s, "s");
if (crc32("KSEwdKx",7) == 3919824458) strcat(s, "c");
if (crc32("ADzlanR",7) == 507875066) strcat(s, "t");
if (crc32("WBrUFhsjGG",10) == 3261758491) strcat(s, "s");
if (crc32("wKcfawuhjvHT",12) == 1554369273) strcat(s, "r");
if (crc32("PNmXXHDiIh",10) == 571230662) strcat(s, "X");
if (crc32("bxjELDg",7) == 658489507) strcat(s, "i");
if (crc32("gjwoN",5) == 3615158734) strcat(s, "C");
if (crc32("zPPfWeGl",8) == 2187459581) strcat(s, "o");
if (crc32("pmEPUwCgZC",10) == 2253292602) strcat(s, "u");
if (crc32("beBpaDSKYjxEnTl",15) == 1467821759) strcat(s, "s");
if (crc32("YkhzsPnVEw",10) == 586975429) strcat(s, "m");
if (crc32("NhsOKcoy",8) == 2067900790) strcat(s, "l");
if (crc32("qPoWvFw",7) == 2151760946) strcat(s, "t");
if (crc32("ojewPZpQsZAgoN",14) == 3439906108) strcat(s, "y");
    return s;
}

char *unthriftily_adverbs() {
    char *s = calloc(12);
    if (crc32("sPVHpoOPp",9) == 2745358666) strcat(s, "Q");
if (crc32("gKuBQXyEKQe",11) == 2055099585) strcat(s, "u");
if (crc32("QHDpolmBqQmQ",12) == 1983133812) strcat(s, "n");
if (crc32("HYGtl",5) == 1646702201) strcat(s, "t");
if (crc32("GYABL",5) == 1451881639) strcat(s, "h");
if (crc32("pRHhlEiSQ",9) == 2820552944) strcat(s, "r");
if (crc32("DRkenp",6) == 3058534337) strcat(s, "P");
if (crc32("aAMjXHFFmhW",11) == 1737110779) strcat(s, "i");
if (crc32("alTcKUacnPntVJT",15) == 137634349) strcat(s, "F");
if (crc32("kNfvOHkvEldRCtI",15) == 2326969099) strcat(s, "f");
if (crc32("UMuDtWQOu",9) == 649434039) strcat(s, "t");
if (crc32("agsDDwxr",8) == 194174608) strcat(s, "i");
if (crc32("tRfQlUppkaQyVMs",15) == 1894331663) strcat(s, "l");
if (crc32("yaaDWnfVvTVmIf",14) == 2360841552) strcat(s, "B");
if (crc32("OXXCrFiHk",9) == 1622988325) strcat(s, "y");
    return s;
}

char *inauspiciously_adverbs() {
    char *s = calloc(15);
    if (crc32("uRcaD",5) == 3026868528) strcat(s, "N");
if (crc32("KIzVUqbtiMG",11) == 1456516705) strcat(s, "i");
if (crc32("rEtVrDJxtRfvR",13) == 316576461) strcat(s, "a");
if (crc32("wczVOtHcSXYB",12) == 2678967168) strcat(s, "n");
if (crc32("GpfbltnKGa",10) == 876454073) strcat(s, "a");
if (crc32("LzVjnVBmujw",11) == 2077886742) strcat(s, "b");
if (crc32("miVJluWdreadWBU",15) == 3003836938) strcat(s, "u");
if (crc32("PkRqO",5) == 1884056705) strcat(s, "q");
if (crc32("iVkytpZ",7) == 1446614392) strcat(s, "s");
if (crc32("TveeaXqu",8) == 3311633402) strcat(s, "p");
if (crc32("drhVQ",5) == 3723448239) strcat(s, "i");
if (crc32("nmjfvGJunEHeAG",14) == 1359221145) strcat(s, "c");
if (crc32("NIlGMU",6) == 2340468554) strcat(s, "i");
if (crc32("uCsKbvkyUxqm",12) == 3840057478) strcat(s, "m");
if (crc32("vqJPSWYsfK",10) == 1455412791) strcat(s, "o");
if (crc32("MqYTdrVSRaYDuKx",15) == 4003360548) strcat(s, "i");
if (crc32("SKkpJ",5) == 137390211) strcat(s, "u");
if (crc32("isHpCLb",7) == 2180975273) strcat(s, "w");
if (crc32("KFpLix",6) == 4222618429) strcat(s, "s");
if (crc32("GOuUZNyfedB",11) == 3549489861) strcat(s, "l");
if (crc32("SLXEDsBzZl",10) == 1601118331) strcat(s, "y");
    return s;
}

char *secantly_adverbs() {
    char *s = calloc(9);
    if (crc32("KoezvLzs",8) == 379420043) strcat(s, "Z");
if (crc32("BEokVVfim",9) == 4203618495) strcat(s, "s");
if (crc32("qnsWVXll",8) == 3629200325) strcat(s, "e");
if (crc32("AWFSZsRCaHEeTWn",15) == 1059840596) strcat(s, "z");
if (crc32("bsOcs",5) == 2688552541) strcat(s, "c");
if (crc32("oLmHrEf",7) == 3651152216) strcat(s, "a");
if (crc32("PyIQzX",6) == 1921790048) strcat(s, "n");
if (crc32("XoDIrBu",7) == 209883565) strcat(s, "o");
if (crc32("onzfYoSO",8) == 2312136751) strcat(s, "t");
if (crc32("pqCSaYBq",8) == 3161604822) strcat(s, "m");
if (crc32("wqeEDwk",7) == 1145621872) strcat(s, "l");
if (crc32("QBQTNFHYqfPEhW",14) == 2338508371) strcat(s, "y");
    return s;
}

char *cyclically_adverbs() {
    char *s = calloc(11);
    if (crc32("PNkJadm",7) == 2589605247) strcat(s, "y");
if (crc32("kJLLwIOpnqhSb",13) == 4275107277) strcat(s, "c");
if (crc32("kZTbUwJzHjwg",12) == 4220445524) strcat(s, "y");
if (crc32("zGNzsMX",7) == 1609174959) strcat(s, "b");
if (crc32("plamXQVrmvBKXP",14) == 912099169) strcat(s, "c");
if (crc32("yPPOerJuLxuD",12) == 779660636) strcat(s, "N");
if (crc32("ZukvQuOXtTKYtjT",15) == 3935186810) strcat(s, "l");
if (crc32("lCZYcj",6) == 493729498) strcat(s, "C");
if (crc32("qZmxrwd",7) == 3365659313) strcat(s, "i");
if (crc32("cyAiONFvW",9) == 3142536824) strcat(s, "r");
if (crc32("QuufPIGCKVwB",12) == 961806813) strcat(s, "c");
if (crc32("KzEQUtOXs",9) == 3956222394) strcat(s, "v");
if (crc32("aGaZaXHPTBZaRvn",15) == 3738887624) strcat(s, "a");
if (crc32("PSxDTWgMMCxz",12) == 235594139) strcat(s, "l");
if (crc32("NwqaDlwln",9) == 822408129) strcat(s, "l");
if (crc32("pKmVg",5) == 3882347709) strcat(s, "R");
if (crc32("oFWLK",5) == 3071193156) strcat(s, "y");
    return s;
}

char *elatedly_adverbs() {
    char *s = calloc(9);
    if (crc32("KYHSSk",6) == 2599592138) strcat(s, "e");
if (crc32("PoYnfeqHiYWvi",13) == 2287745578) strcat(s, "l");
if (crc32("LMBbbkyZGFk",11) == 2579840680) strcat(s, "a");
if (crc32("vkolRvj",7) == 274053039) strcat(s, "i");
if (crc32("IGevScC",7) == 2396744410) strcat(s, "t");
if (crc32("xoftgxtMQkCj",12) == 1656507265) strcat(s, "b");
if (crc32("rGEZdO",6) == 937982203) strcat(s, "e");
if (crc32("kivmvVdK",8) == 2625766393) strcat(s, "G");
if (crc32("FbGygASZaXC",11) == 204522854) strcat(s, "d");
if (crc32("wJTezPqQnOzmiS",14) == 1772175623) strcat(s, "T");
if (crc32("CUyqK",5) == 2846402916) strcat(s, "l");
if (crc32("cPNqIby",7) == 514184914) strcat(s, "y");
    return s;
}

char *gastronomically_adverbs() {
    char *s = calloc(16);
    if (crc32("SFRKXTrVKt",10) == 2374107367) strcat(s, "g");
if (crc32("wwWzOVGEy",9) == 4146853008) strcat(s, "K");
if (crc32("NrqPcPHUm",9) == 3345277709) strcat(s, "a");
if (crc32("GGfDeSSA",8) == 2278444097) strcat(s, "C");
if (crc32("rPhgJuAO",8) == 3466966782) strcat(s, "s");
if (crc32("sFiLYIcrDBNY",12) == 2382729837) strcat(s, "t");
if (crc32("hkSbSKww",8) == 2693626987) strcat(s, "v");
if (crc32("JQhVEtFPRuU",11) == 3238764888) strcat(s, "r");
if (crc32("JwQUhaUizLuP",12) == 924519159) strcat(s, "l");
if (crc32("RuEPAGJP",8) == 2625098284) strcat(s, "o");
if (crc32("hLWhgtscFDsUW",13) == 909098600) strcat(s, "J");
if (crc32("rVCjrfB",7) == 2340720843) strcat(s, "n");
if (crc32("cAOqjN",6) == 3254978584) strcat(s, "o");
if (crc32("RONRu",5) == 3591348406) strcat(s, "S");
if (crc32("JhNCXxcor",9) == 2203340455) strcat(s, "m");
if (crc32("hSLXhq",6) == 2658313834) strcat(s, "G");
if (crc32("UNYOMlhxDLVJiG",14) == 447133437) strcat(s, "i");
if (crc32("EfKIWMnGda",10) == 2508438870) strcat(s, "o");
if (crc32("XOSZBYFjyKF",11) == 3848136008) strcat(s, "c");
if (crc32("QEycegkMRZJZPlT",15) == 1668167432) strcat(s, "B");
if (crc32("oIeZH",5) == 1293120897) strcat(s, "a");
if (crc32("tHnqGiXiT",9) == 2183019498) strcat(s, "y");
if (crc32("QzTvwiBnaGHlnr",14) == 3858343794) strcat(s, "l");
if (crc32("SYQMtJCD",8) == 3001175251) strcat(s, "T");
if (crc32("JlCoJmQpyQyHZr",14) == 3158494925) strcat(s, "l");
if (crc32("qoEAsDiBlzzip",13) == 971820671) strcat(s, "y");
    return s;
}

char *antiempirically_adverbs() {
    char *s = calloc(16);
    if (crc32("reEzMZPnRhzKvKc",15) == 264095808) strcat(s, "J");
if (crc32("PBHIBzlGs",9) == 2971168803) strcat(s, "a");
if (crc32("VwEwYclXRibId",13) == 1486895383) strcat(s, "q");
if (crc32("LhIkykSppNHmbxh",15) == 1481633357) strcat(s, "n");
if (crc32("MswBJCmhWjWrMfS",15) == 3476318280) strcat(s, "t");
if (crc32("iJFPkNVX",8) == 3030227880) strcat(s, "t");
if (crc32("DEMykrfCbcrFAzo",15) == 3465488664) strcat(s, "i");
if (crc32("rHbygrjqXMIj",12) == 1612597338) strcat(s, "e");
if (crc32("BIkofIjpETur",12) == 482582333) strcat(s, "m");
if (crc32("BOlsAJktz",9) == 155942689) strcat(s, "p");
if (crc32("qYAjPhipaWS",11) == 3800852258) strcat(s, "z");
if (crc32("HdUCJfWJ",8) == 2025044428) strcat(s, "i");
if (crc32("qCRWVgzGyquUt",13) == 4012447536) strcat(s, "b");
if (crc32("JFTWPbVZ",8) == 8997601) strcat(s, "r");
if (crc32("QbbcaTB",7) == 2558785047) strcat(s, "i");
if (crc32("eBUjniwpooaMKLi",15) == 2594341530) strcat(s, "c");
if (crc32("HpyBclYNqdRlX",13) == 18046766) strcat(s, "a");
if (crc32("gWWPSM",6) == 1196062345) strcat(s, "F");
if (crc32("ZnSfjpgmA",9) == 740885659) strcat(s, "l");
if (crc32("vFYEB",5) == 1168026516) strcat(s, "h");
if (crc32("OZAvZlZpJV",10) == 2294332884) strcat(s, "l");
if (crc32("zKPAOV",6) == 3530623123) strcat(s, "d");
if (crc32("KDVtQZXoB",9) == 2121594712) strcat(s, "y");
    return s;
}

char *reductively_adverbs() {
    char *s = calloc(12);
    if (crc32("bRuMggAsyEIFzAT",15) == 1197499600) strcat(s, "X");
if (crc32("UoGwvKRV",8) == 1688948410) strcat(s, "r");
if (crc32("vpHhUqANWlHznp",14) == 3228310334) strcat(s, "r");
if (crc32("sODUIjOZTXnZfQ",14) == 828071736) strcat(s, "e");
if (crc32("WNvYHtiVzPQSjXx",15) == 3767385028) strcat(s, "Q");
if (crc32("IfjAsm",6) == 2637545386) strcat(s, "d");
if (crc32("DuWYLDtdQbATU",13) == 3838617633) strcat(s, "u");
if (crc32("wKZpLiVO",8) == 3479972344) strcat(s, "p");
if (crc32("DgbhvjcykT",10) == 4027263750) strcat(s, "c");
if (crc32("ZcilkDNxgILBiH",14) == 529845653) strcat(s, "t");
if (crc32("kFhUUeiRv",9) == 263292035) strcat(s, "k");
if (crc32("WcFsp",5) == 1166153296) strcat(s, "i");
if (crc32("wMkKNAwhX",9) == 1899761906) strcat(s, "v");
if (crc32("WWKRPuc",7) == 3472690584) strcat(s, "e");
if (crc32("zvquCG",6) == 3753656284) strcat(s, "l");
if (crc32("MRynX",5) == 614775396) strcat(s, "P");
if (crc32("JSkqHIrZHFHdnHa",15) == 1366376555) strcat(s, "y");
    return s;
}

char *quasireligiously_adverbs() {
    char *s = calloc(17);
    if (crc32("VPzyxs",6) == 575555037) strcat(s, "q");
if (crc32("helNQKoIcJrohx",14) == 3953697107) strcat(s, "u");
if (crc32("wLsCAHje",8) == 1730718495) strcat(s, "q");
if (crc32("ocEeeEswVRds",12) == 2281528852) strcat(s, "a");
if (crc32("ZXNSHzxDDs",10) == 2121583083) strcat(s, "s");
if (crc32("TdejRkOhd",9) == 3745417041) strcat(s, "i");
if (crc32("SWjFOmYORft",11) == 201730231) strcat(s, "r");
if (crc32("NeccUtrtyafTK",13) == 4098375503) strcat(s, "e");
if (crc32("vvWhF",5) == 2777423885) strcat(s, "l");
if (crc32("AjDwaNvZ",8) == 1438693066) strcat(s, "u");
if (crc32("DgucbCIMUaogUi",14) == 2342285474) strcat(s, "i");
if (crc32("ilLUWbtkcF",10) == 1487684855) strcat(s, "V");
if (crc32("OJzkHIElxCbfsNW",15) == 2023127324) strcat(s, "g");
if (crc32("evWwlYRRok",10) == 1574803891) strcat(s, "i");
if (crc32("jCUdSwF",7) == 4008316805) strcat(s, "o");
if (crc32("FiIKqeWvhPSXsuu",15) == 4086555705) strcat(s, "u");
if (crc32("ElcjBdMOJR",10) == 1895757261) strcat(s, "o");
if (crc32("nJwkPnfh",8) == 1098379313) strcat(s, "s");
if (crc32("fMTTO",5) == 3928995629) strcat(s, "l");
if (crc32("JFQQZnB",7) == 111673000) strcat(s, "O");
if (crc32("ceEcrsI",7) == 2599220996) strcat(s, "y");
    return s;
}

char *collarco_adverbs() {
    char *s = calloc(9);
    if (crc32("xYejCcK",7) == 2971755698) strcat(s, "c");
if (crc32("tnDhTyjcdm",10) == 3527589936) strcat(s, "o");
if (crc32("pbECg",5) == 3490484044) strcat(s, "l");
if (crc32("bZvsIMfSSWN",11) == 3607801174) strcat(s, "S");
if (crc32("uhVesXBUoEj",11) == 1071552116) strcat(s, "l");
if (crc32("bRVBWxgcUDxGDJ",14) == 3534080308) strcat(s, "j");
if (crc32("NOtBgmHmMH",10) == 3463460060) strcat(s, "a");
if (crc32("MoqhGU",6) == 1833650615) strcat(s, "m");
if (crc32("FeThAQUj",8) == 1233017764) strcat(s, "r");
if (crc32("tQsSBGv",7) == 1377517293) strcat(s, "B");
if (crc32("lVxGcDCkJyHDlI",14) == 566126469) strcat(s, "c");
if (crc32("zbzIZlPGlNaQUfO",15) == 3884356618) strcat(s, "o");
    return s;
}

char *uninfectiously_adverbs() {
    char *s = calloc(15);
    if (crc32("tXXiPjNSI",9) == 1711500785) strcat(s, "W");
if (crc32("LpbqurrZuQP",11) == 370810629) strcat(s, "u");
if (crc32("nRGLhF",6) == 3135342521) strcat(s, "Q");
if (crc32("NPGprYHFMitu",12) == 2134439622) strcat(s, "n");
if (crc32("sqRTZKMMkb",10) == 1862981318) strcat(s, "i");
if (crc32("yNqJygAxa",9) == 2633649065) strcat(s, "n");
if (crc32("XVjsTJKu",8) == 3195657770) strcat(s, "f");
if (crc32("ONtgKFrtnVLaRf",14) == 3035167435) strcat(s, "t");
if (crc32("qbmadUyTMLhHES",14) == 3123549107) strcat(s, "e");
if (crc32("gFubTEiLASRT",12) == 2808692232) strcat(s, "c");
if (crc32("MsjDACHwBSDGppd",15) == 307944198) strcat(s, "t");
if (crc32("rbKAnGS",7) == 2688539019) strcat(s, "i");
if (crc32("WkYbgBKmxBDSzYq",15) == 4136506184) strcat(s, "o");
if (crc32("KzmIdafLnRy",11) == 2089239590) strcat(s, "o");
if (crc32("NBEZqxuaY",9) == 1989484773) strcat(s, "u");
if (crc32("qhdScpMlSN",10) == 81114520) strcat(s, "s");
if (crc32("RBSXbwMU",8) == 3180029119) strcat(s, "l");
if (crc32("oSXzeilQWVaM",12) == 521020572) strcat(s, "P");
if (crc32("dsyUujJ",7) == 1007891665) strcat(s, "y");
    return s;
}

char *assentingly_adverbs() {
    char *s = calloc(12);
    if (crc32("VwyRmAxGUV",10) == 1167630489) strcat(s, "T");
if (crc32("YlIgsOvUDaTL",12) == 2611913752) strcat(s, "a");
if (crc32("gtGpYLKgYcT",11) == 875167100) strcat(s, "T");
if (crc32("sYmZGZjRAprm",12) == 4270173921) strcat(s, "s");
if (crc32("qxZqzh",6) == 3743695230) strcat(s, "s");
if (crc32("YTjnUKVUEcZheXc",15) == 4219133949) strcat(s, "C");
if (crc32("mVdcZmNGHxnvy",13) == 825653708) strcat(s, "e");
if (crc32("GmLgKpSB",8) == 3553498626) strcat(s, "G");
if (crc32("SxeOmIqihqcAG",13) == 416322083) strcat(s, "n");
if (crc32("bcifBuINpO",10) == 1381143879) strcat(s, "t");
if (crc32("MImFxpzs",8) == 2203506763) strcat(s, "i");
if (crc32("lkpPVqDtTOq",11) == 3844197634) strcat(s, "t");
if (crc32("GBpHqOySGTwbAmt",15) == 1205660826) strcat(s, "n");
if (crc32("MMgMdzPW",8) == 3848448807) strcat(s, "g");
if (crc32("TwjBWaLenTjw",12) == 1849603881) strcat(s, "P");
if (crc32("cguuuFniOZuZKWH",15) == 1249941119) strcat(s, "l");
if (crc32("lpxqPdW",7) == 2852460767) strcat(s, "y");
if (crc32("elkSbr",6) == 3726925016) strcat(s, "y");
    return s;
}

char *contrastedly_adverbs() {
    char *s = calloc(13);
    if (crc32("UbOVfURecZvUgp",14) == 3076635001) strcat(s, "x");
if (crc32("tVYpqDmPCOGKkh",14) == 3391787474) strcat(s, "c");
if (crc32("IXeJxgQmgF",10) == 2046897690) strcat(s, "o");
if (crc32("ipfjVBfY",8) == 4155055064) strcat(s, "n");
if (crc32("SVphkHphNMuiU",13) == 190371453) strcat(s, "t");
if (crc32("wEWdoCHkiceV",12) == 832824157) strcat(s, "r");
if (crc32("cgQhIvelof",10) == 3369745314) strcat(s, "o");
if (crc32("gOPOhJqZSEOXdiS",15) == 2185035289) strcat(s, "a");
if (crc32("pyjsaLHtDyvjQ",13) == 425566458) strcat(s, "s");
if (crc32("fUheJzpdaIsfwYE",15) == 417865569) strcat(s, "t");
if (crc32("jOVqSvXLe",9) == 1843293617) strcat(s, "e");
if (crc32("HJUEhrEkQTgFveu",15) == 1538508921) strcat(s, "e");
if (crc32("HhGxc",5) == 381379360) strcat(s, "d");
if (crc32("fIvkcrhJA",9) == 1074005589) strcat(s, "l");
if (crc32("niipGMQHFe",10) == 3679809334) strcat(s, "y");
    return s;
}

char *isagogically_adverbs() {
    char *s = calloc(13);
    if (crc32("elSRAlqrObYAoX",14) == 2884488440) strcat(s, "i");
if (crc32("mXkzmGAlN",9) == 2633960189) strcat(s, "U");
if (crc32("ZeADlgCKIW",10) == 2076567696) strcat(s, "s");
if (crc32("hWJxyADNS",9) == 1698337385) strcat(s, "a");
if (crc32("bYEXyZvxokygBSG",15) == 3793049430) strcat(s, "h");
if (crc32("qYzIp",5) == 2622297788) strcat(s, "g");
if (crc32("qfqgMtFCcMnjxJ",14) == 1401073322) strcat(s, "o");
if (crc32("PeNDzf",6) == 4147551668) strcat(s, "J");
if (crc32("tOshcfjoQTp",11) == 3077904323) strcat(s, "g");
if (crc32("mIujknAoV",9) == 1141118434) strcat(s, "R");
if (crc32("cGrllhjJhcSzcMP",15) == 2548011838) strcat(s, "i");
if (crc32("QgOFEz",6) == 1811524271) strcat(s, "s");
if (crc32("xBIhCFiRTXlSn",13) == 2987444546) strcat(s, "c");
if (crc32("qyRecfBFkw",10) == 4199714170) strcat(s, "s");
if (crc32("dnxlzMS",7) == 2263541399) strcat(s, "a");
if (crc32("xrfFxaUQ",8) == 1413494007) strcat(s, "l");
if (crc32("wKDpbFukhd",10) == 2272281672) strcat(s, "l");
if (crc32("VJQhWj",6) == 348044075) strcat(s, "y");
    return s;
}

char *uncautiously_adverbs() {
    char *s = calloc(13);
    if (crc32("vVgbJ",5) == 26573848) strcat(s, "y");
if (crc32("Lnfmoq",6) == 1954505974) strcat(s, "u");
if (crc32("NmynZEFp",8) == 2646380260) strcat(s, "n");
if (crc32("AWjOHx",6) == 3067513384) strcat(s, "c");
if (crc32("EpKNyOd",7) == 3609892234) strcat(s, "m");
if (crc32("ymUPeKUevw",10) == 137924551) strcat(s, "a");
if (crc32("aZIJQwRQjbcFP",13) == 1536177453) strcat(s, "u");
if (crc32("bznyXpi",7) == 381063040) strcat(s, "h");
if (crc32("FUNvtgpOF",9) == 2298750451) strcat(s, "t");
if (crc32("MVRmjSCmPQcWa",13) == 1061775305) strcat(s, "i");
if (crc32("EoOLLBlNnaXIs",13) == 3895869891) strcat(s, "h");
if (crc32("HWyylslMtyOeB",13) == 2844357305) strcat(s, "o");
if (crc32("DgygQQ",6) == 749921494) strcat(s, "V");
if (crc32("YEqJSCmcy",9) == 1816999640) strcat(s, "u");
if (crc32("MSSInwBV",8) == 3497958589) strcat(s, "s");
if (crc32("yiFXhUSe",8) == 567974248) strcat(s, "l");
if (crc32("TTMtkBfhyKv",11) == 3335699747) strcat(s, "y");
    return s;
}

char *invulnerably_adverbs() {
    char *s = calloc(13);
    if (crc32("etQeKAqrAoMYcGJ",15) == 1667980746) strcat(s, "p");
if (crc32("JFhxgDJskfGiSvH",15) == 2790142922) strcat(s, "i");
if (crc32("gFMskYrHELn",11) == 2114323942) strcat(s, "k");
if (crc32("WOriJSgjcTn",11) == 1877358727) strcat(s, "n");
if (crc32("NYUfPqCRQjIQ",12) == 238062381) strcat(s, "v");
if (crc32("zFiKufBGeth",11) == 1889994374) strcat(s, "h");
if (crc32("hcNcVpJ",7) == 3020070327) strcat(s, "u");
if (crc32("qlGddHA",7) == 2155345978) strcat(s, "l");
if (crc32("iLLxpjJNuxnzg",13) == 2710534668) strcat(s, "R");
if (crc32("yUZADxyzNW",10) == 2118522086) strcat(s, "n");
if (crc32("VvhNPLw",7) == 1855150833) strcat(s, "W");
if (crc32("OGJdeeJfKNOT",12) == 2592373480) strcat(s, "e");
if (crc32("OxfbKdKYmM",10) == 864446592) strcat(s, "r");
if (crc32("lRNKQkHjNDvMyq",14) == 4225236022) strcat(s, "B");
if (crc32("rlnuLEDbFx",10) == 2667699937) strcat(s, "a");
if (crc32("gsDinQQKJVa",11) == 530528182) strcat(s, "P");
if (crc32("XLJNApqUYBvCbYO",15) == 1966733187) strcat(s, "b");
if (crc32("Muavx",5) == 1410252066) strcat(s, "l");
if (crc32("AwxHzjX",7) == 1576136827) strcat(s, "y");
    return s;
}

char *implacably_adverbs() {
    char *s = calloc(11);
    if (crc32("PrGjtBp",7) == 3704498531) strcat(s, "o");
if (crc32("QrDZx",5) == 1803423933) strcat(s, "i");
if (crc32("LZFBYKWFVQwEq",13) == 4036499907) strcat(s, "m");
if (crc32("xbqtWeOQUmqSHF",14) == 2291294419) strcat(s, "p");
if (crc32("SQdIhDJnpQLtD",13) == 3483413743) strcat(s, "l");
if (crc32("iFEdxhDARH",10) == 2799957239) strcat(s, "a");
if (crc32("MJxFYyd",7) == 85617052) strcat(s, "M");
if (crc32("TrlPfzSsu",9) == 1059930405) strcat(s, "c");
if (crc32("ZeyooaTvRpO",11) == 140940656) strcat(s, "a");
if (crc32("JGrFbbbyHSXWL",13) == 3175571423) strcat(s, "o");
if (crc32("qPVRDv",6) == 3850519716) strcat(s, "b");
if (crc32("NJktadjlwJ",10) == 1246348956) strcat(s, "v");
if (crc32("jvyoqeRNUDsE",12) == 2964636335) strcat(s, "l");
if (crc32("AiMaSoWMdmNY",12) == 2752630664) strcat(s, "A");
if (crc32("zgrbys",6) == 2382213433) strcat(s, "y");
    return s;
}

char *tastefully_adverbs() {
    char *s = calloc(11);
    if (crc32("NARFx",5) == 3899158818) strcat(s, "i");
if (crc32("YyooNwqKSQFR",12) == 2438688474) strcat(s, "t");
if (crc32("PYKjwgAq",8) == 2097689876) strcat(s, "H");
if (crc32("CfZkLd",6) == 3629987267) strcat(s, "a");
if (crc32("jekHW",5) == 2802341389) strcat(s, "D");
if (crc32("wXyhVtYTUp",10) == 2838441548) strcat(s, "s");
if (crc32("zcCOfKzXdVOQ",12) == 2634053072) strcat(s, "t");
if (crc32("xXdQGakbZ",9) == 1646571397) strcat(s, "t");
if (crc32("FGsWepzRSvv",11) == 300068866) strcat(s, "e");
if (crc32("TtYodDQdpqt",11) == 491806931) strcat(s, "l");
if (crc32("CjuzJrOUkpgSVTB",15) == 3215077576) strcat(s, "f");
if (crc32("BXnfOmoQzskj",12) == 452007367) strcat(s, "u");
if (crc32("ubIbVdlcrw",10) == 2150269356) strcat(s, "j");
if (crc32("dvnBGgrLAagy",12) == 2787384384) strcat(s, "l");
if (crc32("BrwOAvQSeiiPE",13) == 2123341669) strcat(s, "V");
if (crc32("ZvOepOwcU",9) == 3220870982) strcat(s, "l");
if (crc32("sGBTQYiPAhKNodY",15) == 1820359297) strcat(s, "h");
if (crc32("jgKpzUcRjzLha",13) == 3731932402) strcat(s, "y");
    return s;
}

char *othergates_adverbs() {
    char *s = calloc(11);
    if (crc32("qRLYahkzdASvDT",14) == 2585317142) strcat(s, "b");
if (crc32("sYbyMoFDKpAzSjR",15) == 4215197775) strcat(s, "o");
if (crc32("NwFbkICsNtGWGT",14) == 4015186029) strcat(s, "t");
if (crc32("qBZIeaGBR",9) == 623642036) strcat(s, "h");
if (crc32("IOaRMJLKMur",11) == 2946273913) strcat(s, "P");
if (crc32("CxQDsvwwr",9) == 270921627) strcat(s, "e");
if (crc32("XDZndEYr",8) == 3486866879) strcat(s, "r");
if (crc32("WkJBiI",6) == 381736134) strcat(s, "J");
if (crc32("SWioeXhCwSL",11) == 2397719918) strcat(s, "g");
if (crc32("pGjnGoEmxizTJlQ",15) == 3924872639) strcat(s, "g");
if (crc32("tdjNwwsbR",9) == 1013980047) strcat(s, "a");
if (crc32("CRZkGogYxrRG",12) == 1060913956) strcat(s, "E");
if (crc32("NicNNPuTEkMfVx",14) == 3999943177) strcat(s, "t");
if (crc32("yaFjIlxhrv",10) == 1515165564) strcat(s, "e");
if (crc32("qGTrYXwKXADjq",13) == 3860599138) strcat(s, "s");
    return s;
}

char *noncredibly_adverbs() {
    char *s = calloc(12);
    if (crc32("GeEgGhwCemgE",12) == 1642731073) strcat(s, "F");
if (crc32("MCUFdNKhQfNbP",13) == 3939290794) strcat(s, "n");
if (crc32("KxsPatnVTNJXY",13) == 4214835900) strcat(s, "H");
if (crc32("GBlzqxdHh",9) == 2411968849) strcat(s, "o");
if (crc32("mVSFxstxYa",10) == 2817467681) strcat(s, "p");
if (crc32("aPkLm",5) == 2184224623) strcat(s, "n");
if (crc32("IjKTeceqfbWnnOI",15) == 4226592097) strcat(s, "c");
if (crc32("oPMyJjaEwwCKqG",14) == 20638846) strcat(s, "p");
if (crc32("dbyRWdsjwumSRm",14) == 3743928035) strcat(s, "r");
if (crc32("xWFbhZNoXGqol",13) == 725850046) strcat(s, "r");
if (crc32("iiIHcDKQbOcZV",13) == 4063130388) strcat(s, "e");
if (crc32("qynKFdd",7) == 2920330344) strcat(s, "d");
if (crc32("gPkPscGxhv",10) == 401636715) strcat(s, "i");
if (crc32("AAVYuGRa",8) == 380731508) strcat(s, "b");
if (crc32("GVXVWnsio",9) == 1796285918) strcat(s, "l");
if (crc32("OywpbpmyC",9) == 2939863024) strcat(s, "y");
    return s;
}

char *allowably_adverbs() {
    char *s = calloc(10);
    if (crc32("CnYsfGhmwRM",11) == 3937074487) strcat(s, "i");
if (crc32("WXKprJ",6) == 1003362672) strcat(s, "a");
if (crc32("hISqKiKXpJuwflT",15) == 3504265409) strcat(s, "l");
if (crc32("JhQzfPJkKaL",11) == 2656525191) strcat(s, "P");
if (crc32("pXpemrkfKu",10) == 225478548) strcat(s, "l");
if (crc32("QKsqgjfryw",10) == 1302109267) strcat(s, "g");
if (crc32("xWiujRga",8) == 3381064271) strcat(s, "o");
if (crc32("rkaGZA",6) == 1460444607) strcat(s, "x");
if (crc32("RvbYjazrxzqIvJ",14) == 374929686) strcat(s, "w");
if (crc32("gKtelNINvhs",11) == 730894768) strcat(s, "C");
if (crc32("eobBt",5) == 717320089) strcat(s, "a");
if (crc32("jEnmrXCxweAbM",13) == 374539165) strcat(s, "b");
if (crc32("eCpbxXl",7) == 3377977470) strcat(s, "l");
if (crc32("saeNgDuGfJFBjK",14) == 181777831) strcat(s, "y");
    return s;
}

char *intermittently_adverbs() {
    char *s = calloc(15);
    if (crc32("HYqbhyLdp",9) == 365946589) strcat(s, "G");
if (crc32("fwPXTgQPJfOFQmd",15) == 1843625353) strcat(s, "i");
if (crc32("GVGlszBSwK",10) == 117401761) strcat(s, "n");
if (crc32("shHBUfWtBfTWW",13) == 3748560060) strcat(s, "n");
if (crc32("xwRyeTcxdEHweB",14) == 2694973111) strcat(s, "L");
if (crc32("lqWBxMNv",8) == 2593432070) strcat(s, "t");
if (crc32("EGlbi",5) == 1922736701) strcat(s, "e");
if (crc32("RwrFZqBoAx",10) == 2945073086) strcat(s, "r");
if (crc32("ztwwTINSIlvXc",13) == 634242390) strcat(s, "v");
if (crc32("AgmKgfwYx",9) == 729161606) strcat(s, "m");
if (crc32("ItQxXaCj",8) == 1949863953) strcat(s, "i");
if (crc32("hLMnwaWd",8) == 1889270804) strcat(s, "t");
if (crc32("KyMrEHVT",8) == 173352319) strcat(s, "t");
if (crc32("Xtypwtgs",8) == 1754921643) strcat(s, "e");
if (crc32("ytIJyvtlibQG",12) == 2474566015) strcat(s, "x");
if (crc32("MwOGEXjlejG",11) == 764925185) strcat(s, "n");
if (crc32("iwOYifbnk",9) == 343052618) strcat(s, "D");
if (crc32("AWhPFJKgsz",10) == 3658966009) strcat(s, "t");
if (crc32("pVhaXvBpU",9) == 4278521134) strcat(s, "l");
if (crc32("OaKNuejBQKHY",12) == 1266253516) strcat(s, "y");
    return s;
}

char *unnomadically_adverbs() {
    char *s = calloc(14);
    if (crc32("GzrhmogQFzqwhDN",15) == 1650759785) strcat(s, "g");
if (crc32("hhFUwgCFYZO",11) == 2879786469) strcat(s, "u");
if (crc32("eraDNHkHdCH",11) == 4119298544) strcat(s, "n");
if (crc32("jQGFN",5) == 2133465690) strcat(s, "e");
if (crc32("SzRHJXsxYRNASf",14) == 1568475829) strcat(s, "n");
if (crc32("WdOjjfRXZQTcu",13) == 2853779045) strcat(s, "X");
if (crc32("AcPHCnPfVSyrep",14) == 503444733) strcat(s, "o");
if (crc32("AoFJKOHLDuiTXRE",15) == 2023836451) strcat(s, "w");
if (crc32("kWwYuRssdyiPXvd",15) == 3942739993) strcat(s, "m");
if (crc32("hLUJgIRbRhqEYKa",15) == 2887431373) strcat(s, "m");
if (crc32("JhyTvHFrMfrVW",13) == 2066602159) strcat(s, "a");
if (crc32("sbJnGVd",7) == 528596887) strcat(s, "d");
if (crc32("bNIdqv",6) == 1714852154) strcat(s, "f");
if (crc32("qGDDVIcRLp",10) == 2553771959) strcat(s, "i");
if (crc32("THMQeq",6) == 1977017061) strcat(s, "c");
if (crc32("pIlmRxIfuQmJrW",14) == 801678473) strcat(s, "k");
if (crc32("dtPwfrgqmtYTBwu",15) == 2677952543) strcat(s, "a");
if (crc32("VMCfTyhzk",9) == 1816612324) strcat(s, "l");
if (crc32("gvXNbMtB",8) == 579972112) strcat(s, "I");
if (crc32("ojvNTKvmEFj",11) == 2702053247) strcat(s, "l");
if (crc32("kbiFIWeXLUgV",12) == 3255774253) strcat(s, "S");
if (crc32("xGfrqSVnB",9) == 909194790) strcat(s, "y");
    return s;
}

char *overdeliberately_adverbs() {
    char *s = calloc(17);
    if (crc32("fPQZovhXgfnOg",13) == 213109019) strcat(s, "T");
if (crc32("KZOhHsM",7) == 548540024) strcat(s, "o");
if (crc32("WYbAC",5) == 3086013902) strcat(s, "v");
if (crc32("XFEFkvxNx",9) == 4143137253) strcat(s, "D");
if (crc32("tMIQA",5) == 2118032046) strcat(s, "e");
if (crc32("uAJzVHRTaZRYk",13) == 3494076483) strcat(s, "r");
if (crc32("gYNvooRWYcK",11) == 2011185191) strcat(s, "d");
if (crc32("SxlappcN",8) == 4133540727) strcat(s, "b");
if (crc32("QHgSkJfQl",9) == 216438784) strcat(s, "e");
if (crc32("DWUZKPf",7) == 3484823253) strcat(s, "o");
if (crc32("VvTseJXYOB",10) == 273190057) strcat(s, "l");
if (crc32("yhpzMpBSyluSsdu",15) == 900541645) strcat(s, "i");
if (crc32("IcQIrua",7) == 511181743) strcat(s, "b");
if (crc32("jbTXpger",8) == 588794976) strcat(s, "J");
if (crc32("gHFvTADbKdX",11) == 1872648113) strcat(s, "e");
if (crc32("SAcDSkJiGovgfd",14) == 2323279830) strcat(s, "r");
if (crc32("uGdHqU",6) == 3877038184) strcat(s, "a");
if (crc32("dQbdNVLJuH",10) == 3071913100) strcat(s, "t");
if (crc32("pLYxsP",6) == 1200875436) strcat(s, "I");
if (crc32("qwAdPV",6) == 1854649897) strcat(s, "e");
if (crc32("ydxKjo",6) == 3785125995) strcat(s, "K");
if (crc32("duFpXoLTrpCXM",13) == 2171115732) strcat(s, "l");
if (crc32("SKrBLLJWbQ",10) == 3823873326) strcat(s, "y");
    return s;
}

char *blandly_adverbs() {
    char *s = calloc(8);
    if (crc32("cTGDYCbWkjWMWqR",15) == 193304634) strcat(s, "b");
if (crc32("RCeIfxlCKAaQeI",14) == 689866592) strcat(s, "K");
if (crc32("YkFBcjeps",9) == 4061462027) strcat(s, "l");
if (crc32("ArEIVpKHW",9) == 2466082289) strcat(s, "a");
if (crc32("heYDfU",6) == 3985103047) strcat(s, "n");
if (crc32("ykXoLGvPF",9) == 1671219575) strcat(s, "F");
if (crc32("UOramXka",8) == 1061185048) strcat(s, "d");
if (crc32("ftakq",5) == 3692237034) strcat(s, "l");
if (crc32("DJKptTho",8) == 515618231) strcat(s, "w");
if (crc32("FsGnEcHVtH",10) == 3306413327) strcat(s, "y");
    return s;
}

char *superzealously_adverbs() {
    char *s = calloc(15);
    if (crc32("vdJqnTcS",8) == 3028264641) strcat(s, "m");
if (crc32("EtpwMXXm",8) == 370729879) strcat(s, "s");
if (crc32("yzbeB",5) == 2015705556) strcat(s, "Q");
if (crc32("mjuxrNZNRVWlX",13) == 3610160370) strcat(s, "u");
if (crc32("hoHud",5) == 1279978751) strcat(s, "Z");
if (crc32("MvYan",5) == 2643760931) strcat(s, "p");
if (crc32("LhfGHYCfAc",10) == 1677575767) strcat(s, "U");
if (crc32("TkoMBYWxP",9) == 4215688377) strcat(s, "e");
if (crc32("jyGpLloZqVqrf",13) == 574086766) strcat(s, "r");
if (crc32("CRQCIyMNRulLO",13) == 658383672) strcat(s, "z");
if (crc32("eHHPmiU",7) == 3948283377) strcat(s, "e");
if (crc32("nYhVRPdMjpbJdIh",15) == 753466419) strcat(s, "e");
if (crc32("NuHQWJz",7) == 439366143) strcat(s, "a");
if (crc32("ggQztGRJjnEuHan",15) == 275557468) strcat(s, "M");
if (crc32("aaXhOQStixVCkm",14) == 3314777915) strcat(s, "l");
if (crc32("lESRaMAvuLEQJ",13) == 181393879) strcat(s, "o");
if (crc32("FpbbPHnWxpqFkgJ",15) == 2495976804) strcat(s, "K");
if (crc32("NjIhyxl",7) == 1938068960) strcat(s, "u");
if (crc32("gtZlTyTHXOpor",13) == 1640586620) strcat(s, "s");
if (crc32("KBxiXyiosRGA",12) == 3265599937) strcat(s, "l");
if (crc32("sdPkGhPKqidoj",13) == 625381462) strcat(s, "L");
if (crc32("LrVpscjWFOtip",13) == 2356220982) strcat(s, "y");
    return s;
}

char *quadrennially_adverbs() {
    char *s = calloc(14);
    if (crc32("qWFzrHWw",8) == 2408026790) strcat(s, "N");
if (crc32("idtukeWEabLmDE",14) == 3226738187) strcat(s, "q");
if (crc32("NTDTGte",7) == 4093988775) strcat(s, "u");
if (crc32("bKgMrofDIiyDl",13) == 21769023) strcat(s, "a");
if (crc32("FsFiEeivHywzsM",14) == 24793581) strcat(s, "d");
if (crc32("iXcHznrMK",9) == 1382578283) strcat(s, "r");
if (crc32("SVEcfgVi",8) == 4107483095) strcat(s, "e");
if (crc32("uTZqUZoceJuNXBL",15) == 2388021408) strcat(s, "v");
if (crc32("YcLCctHfo",9) == 3323426258) strcat(s, "n");
if (crc32("gsOYjAFY",8) == 606187105) strcat(s, "s");
if (crc32("RXEgCaKrK",9) == 598582179) strcat(s, "n");
if (crc32("QrhukFFvMSP",11) == 1760082130) strcat(s, "i");
if (crc32("MhFODdKfsyBT",12) == 2158068825) strcat(s, "a");
if (crc32("SwxvcWgNyE",10) == 4186856891) strcat(s, "T");
if (crc32("fprfAXnvZHROpZ",14) == 3871256181) strcat(s, "l");
if (crc32("rROxrVFeT",9) == 394435030) strcat(s, "l");
if (crc32("kRdAnNHwA",9) == 3592743486) strcat(s, "y");
    return s;
}

char *superthankfully_adverbs() {
    char *s = calloc(16);
    if (crc32("albJsgvrbzID",12) == 1717130151) strcat(s, "Q");
if (crc32("BtXDEAcSbbc",11) == 1667371798) strcat(s, "s");
if (crc32("FTdMubqrkx",10) == 2733571912) strcat(s, "m");
if (crc32("BPkkMnD",7) == 2990430388) strcat(s, "u");
if (crc32("iqRJQnhwrH",10) == 4113182535) strcat(s, "p");
if (crc32("lSHJOEKbciDUjk",14) == 1929401615) strcat(s, "e");
if (crc32("ElOImI",6) == 4178793635) strcat(s, "g");
if (crc32("JdJQteKKJE",10) == 2885225462) strcat(s, "r");
if (crc32("hDxvVvfiykaHH",13) == 330379913) strcat(s, "a");
if (crc32("RMuHDfiAg",9) == 2615341481) strcat(s, "t");
if (crc32("dVfHGQvfYdG",11) == 1315226005) strcat(s, "h");
if (crc32("pDczMeBvZjNfh",13) == 3497121506) strcat(s, "Z");
if (crc32("veagQsY",7) == 865448483) strcat(s, "a");
if (crc32("VGzxcFanFG",10) == 3657398594) strcat(s, "n");
if (crc32("ZPEjbNUkQUhedLe",15) == 345497961) strcat(s, "k");
if (crc32("avpFBegzRWDqY",13) == 2972627584) strcat(s, "f");
if (crc32("hLvMdXyOLVRxM",13) == 3764020673) strcat(s, "u");
if (crc32("IDPvjQIJT",9) == 987137169) strcat(s, "p");
if (crc32("CPUDtXnq",8) == 1247533917) strcat(s, "l");
if (crc32("GeJukQu",7) == 1706578008) strcat(s, "I");
if (crc32("fMvftncUtIUNDX",14) == 3669709580) strcat(s, "l");
if (crc32("bKjBSxwOATp",11) == 703197908) strcat(s, "p");
if (crc32("xhzPWnBjQ",9) == 1262510581) strcat(s, "y");
    return s;
}

char *antimechanistically_adverbs() {
    char *s = calloc(20);
    if (crc32("PHWTPEqNfGPOILv",15) == 1998373370) strcat(s, "q");
if (crc32("SFqLVQOqJX",10) == 3652622439) strcat(s, "a");
if (crc32("JRBfeaRhCR",10) == 821205787) strcat(s, "n");
if (crc32("ANXSdoKwaF",10) == 1722381662) strcat(s, "t");
if (crc32("IeWzqSN",7) == 916424586) strcat(s, "e");
if (crc32("cINmNWeg",8) == 1732373593) strcat(s, "i");
if (crc32("dyjtrCEH",8) == 2880284559) strcat(s, "m");
if (crc32("KRTuBdlRIgXM",12) == 3893546835) strcat(s, "e");
if (crc32("dvgyDjjKkUtWNQ",14) == 3015553400) strcat(s, "c");
if (crc32("ZrmEaAYu",8) == 1201549031) strcat(s, "h");
if (crc32("azyDpnIqIcJD",12) == 287007773) strcat(s, "a");
if (crc32("hIsQKCvcgwBf",12) == 334863046) strcat(s, "n");
if (crc32("qqXvLW",6) == 1728823723) strcat(s, "w");
if (crc32("MyJGOfBzH",9) == 2462715025) strcat(s, "i");
if (crc32("oxCnOMIEZ",9) == 2539465645) strcat(s, "s");
if (crc32("yGMtRvxPX",9) == 2773495595) strcat(s, "t");
if (crc32("LCpBkTwyPnb",11) == 3740016147) strcat(s, "o");
if (crc32("JrOkMshi",8) == 283594769) strcat(s, "i");
if (crc32("vCVSCcgEBOKZNdR",15) == 1490762620) strcat(s, "c");
if (crc32("ubINbBMyd",9) == 2383147072) strcat(s, "z");
if (crc32("JZuwsJAu",8) == 2270030731) strcat(s, "a");
if (crc32("nxwANpTgrybyXU",14) == 448208093) strcat(s, "y");
if (crc32("gMajzWjy",8) == 1363206937) strcat(s, "l");
if (crc32("IqokYwn",7) == 2991024074) strcat(s, "y");
if (crc32("IlGZCz",6) == 3376099149) strcat(s, "l");
if (crc32("GkdBKtIjADuojSP",15) == 672635634) strcat(s, "R");
if (crc32("ieSoASuiv",9) == 2249571522) strcat(s, "y");
    return s;
}

char *stingingly_adverbs() {
    char *s = calloc(11);
    if (crc32("PpjPCYlLQMPpRcG",15) == 3592558018) strcat(s, "x");
if (crc32("ntsAsYiOdk",10) == 535072768) strcat(s, "s");
if (crc32("twOOWQumCSBasV",14) == 3672482484) strcat(s, "t");
if (crc32("IjFZUvn",7) == 797704115) strcat(s, "i");
if (crc32("sQNALDV",7) == 2536062921) strcat(s, "g");
if (crc32("NJEyPS",6) == 702557341) strcat(s, "n");
if (crc32("ZYlJr",5) == 2768772727) strcat(s, "y");
if (crc32("gIZLGUFYd",9) == 1415025676) strcat(s, "g");
if (crc32("nCEIrLwCxKm",11) == 3465155072) strcat(s, "t");
if (crc32("sKJiflLoO",9) == 2387924027) strcat(s, "i");
if (crc32("cvAzfXnZUG",10) == 2835568660) strcat(s, "m");
if (crc32("WoPHPU",6) == 2937410181) strcat(s, "n");
if (crc32("JteQOJConzayd",13) == 843010861) strcat(s, "g");
if (crc32("gmNZU",5) == 86885361) strcat(s, "l");
if (crc32("ulYuBjqSBFPxXlM",15) == 2429743989) strcat(s, "C");
if (crc32("kRAfiTZOhwKRcij",15) == 356468593) strcat(s, "y");
    return s;
}

char *unadjacently_adverbs() {
    char *s = calloc(13);
    if (crc32("DWpuRrgm",8) == 995704235) strcat(s, "u");
if (crc32("rPbeQFnx",8) == 3797786565) strcat(s, "Y");
if (crc32("rqGgZstY",8) == 1407479807) strcat(s, "n");
if (crc32("mUKyAYlPLv",10) == 4222643892) strcat(s, "a");
if (crc32("zvaGWgS",7) == 464733605) strcat(s, "d");
if (crc32("pNruaaAtJfqpm",13) == 3127603613) strcat(s, "j");
if (crc32("kHjSTi",6) == 1806338960) strcat(s, "a");
if (crc32("gEbmnwx",7) == 3670002988) strcat(s, "c");
if (crc32("tMQNlEFyuHlTQdj",15) == 1061109917) strcat(s, "C");
if (crc32("FwVsGTnEAABXM",13) == 1863486360) strcat(s, "e");
if (crc32("WXhXRHUVvFkIm",13) == 2451548204) strcat(s, "n");
if (crc32("eETmUM",6) == 2989079753) strcat(s, "t");
if (crc32("dZOWxF",6) == 3295500180) strcat(s, "v");
if (crc32("whEQEO",6) == 2759764895) strcat(s, "l");
if (crc32("zXlCcdJyNyw",11) == 2840363305) strcat(s, "I");
if (crc32("HvDDweEo",8) == 3249472436) strcat(s, "y");
    return s;
}

char *untransitorily_adverbs() {
    char *s = calloc(15);
    if (crc32("MrNcY",5) == 3372553186) strcat(s, "V");
if (crc32("TbbfBR",6) == 1601198634) strcat(s, "u");
if (crc32("qfgljuiZPJyxVJ",14) == 4021222549) strcat(s, "z");
if (crc32("OVzpdml",7) == 4130091667) strcat(s, "n");
if (crc32("KXUdLBhOAe",10) == 623041959) strcat(s, "t");
if (crc32("RcSGrVjNQEjEM",13) == 2588291830) strcat(s, "r");
if (crc32("FGRRK",5) == 3444065176) strcat(s, "K");
if (crc32("EvIgIV",6) == 2431837580) strcat(s, "a");
if (crc32("JIVRoFC",7) == 522902437) strcat(s, "O");
if (crc32("TiDvdgeYSNJip",13) == 1520149224) strcat(s, "n");
if (crc32("pwxcJyBtutkEje",14) == 1802858202) strcat(s, "m");
if (crc32("EAUsrXiOr",9) == 1747390077) strcat(s, "s");
if (crc32("RGBKFCseMjC",11) == 2813859025) strcat(s, "i");
if (crc32("RuXahaQBW",9) == 4251555896) strcat(s, "t");
if (crc32("vfYPeW",6) == 1308096703) strcat(s, "o");
if (crc32("DqRApkW",7) == 3777573072) strcat(s, "P");
if (crc32("qsJuyoTqYJqIuw",14) == 4010958167) strcat(s, "r");
if (crc32("oRwABKPDxXE",11) == 1074332739) strcat(s, "T");
if (crc32("XnSuQ",5) == 895913759) strcat(s, "i");
if (crc32("paSUTVAVmtk",11) == 2379357286) strcat(s, "k");
if (crc32("PQnOntwBjBHEjhq",15) == 833564089) strcat(s, "l");
if (crc32("qxspKjQEo",9) == 3779083484) strcat(s, "l");
if (crc32("gwTEQXTvvRCCwOc",15) == 472319475) strcat(s, "y");
    return s;
}

char *crapulously_adverbs() {
    char *s = calloc(12);
    if (crc32("lWCjlo",6) == 2623773726) strcat(s, "c");
if (crc32("dzeJKCJFNkGU",12) == 3546980104) strcat(s, "r");
if (crc32("zbTqrJeQh",9) == 2860661574) strcat(s, "t");
if (crc32("qaIQhtNa",8) == 4229470412) strcat(s, "a");
if (crc32("wAUaMsPceTKdlay",15) == 3707398427) strcat(s, "p");
if (crc32("MVEiZqixhnjYo",13) == 2287593817) strcat(s, "s");
if (crc32("xhmyCS",6) == 1152086538) strcat(s, "u");
if (crc32("boIezNRWnf",10) == 1077738781) strcat(s, "l");
if (crc32("rtLSfYVn",8) == 2945632733) strcat(s, "o");
if (crc32("KGWUCbwHDoxlzV",14) == 390720192) strcat(s, "r");
if (crc32("nacXUsuvaFtr",12) == 928522083) strcat(s, "u");
if (crc32("UTbfeBctLKYN",12) == 3795633007) strcat(s, "F");
if (crc32("SaRPf",5) == 1264169351) strcat(s, "s");
if (crc32("jjbgNUHymc",10) == 4094955514) strcat(s, "l");
if (crc32("vEjWMMu",7) == 3562036259) strcat(s, "S");
if (crc32("tOOkw",5) == 984180087) strcat(s, "y");
    return s;
}

char *unfanatically_adverbs() {
    char *s = calloc(14);
    if (crc32("iLHrwgX",7) == 1289698739) strcat(s, "u");
if (crc32("wWfrTT",6) == 3448354833) strcat(s, "Z");
if (crc32("yKKBFunLl",9) == 464585576) strcat(s, "n");
if (crc32("pHQXVBi",7) == 131457051) strcat(s, "f");
if (crc32("uCViGGpIxLwfAB",14) == 1305056861) strcat(s, "a");
if (crc32("DDgTmkJkgOqhFEH",15) == 1053619002) strcat(s, "V");
if (crc32("dnfOqiksHvQhfT",14) == 1946620453) strcat(s, "n");
if (crc32("obwAQASpnBPY",12) == 4228180435) strcat(s, "a");
if (crc32("lhheDxgqszFlwoh",15) == 1226324571) strcat(s, "O");
if (crc32("rhAmlIsS",8) == 1852044732) strcat(s, "t");
if (crc32("ODrwYRuBMTHZKp",14) == 1230090616) strcat(s, "H");
if (crc32("gYcvsXvdD",9) == 1674586640) strcat(s, "i");
if (crc32("IcYgFTGBWR",10) == 4049805792) strcat(s, "c");
if (crc32("LKaUG",5) == 1901412700) strcat(s, "a");
if (crc32("hrhwsHbz",8) == 1385584256) strcat(s, "l");
if (crc32("TKQTKG",6) == 3037521086) strcat(s, "F");
if (crc32("pEXLntwyUjmxvIT",15) == 2730640929) strcat(s, "l");
if (crc32("qkwdhflRSP",10) == 3954936586) strcat(s, "y");
    return s;
}

char *songfully_adverbs() {
    char *s = calloc(10);
    if (crc32("RCwVG",5) == 1488440401) strcat(s, "s");
if (crc32("CyXyPsrhJv",10) == 3016412977) strcat(s, "o");
if (crc32("okBjo",5) == 6734281) strcat(s, "n");
if (crc32("BcoUwrjwImLyj",13) == 3835416304) strcat(s, "g");
if (crc32("BsENkY",6) == 256951074) strcat(s, "f");
if (crc32("bTsjpkvJFHlVFJx",15) == 2088584125) strcat(s, "u");
if (crc32("vjIQZYkLXgtjz",13) == 3769982381) strcat(s, "s");
if (crc32("Klknhe",6) == 3054314256) strcat(s, "l");
if (crc32("rOIvCnNhMX",10) == 466690340) strcat(s, "l");
if (crc32("vzSak",5) == 913455202) strcat(s, "R");
if (crc32("xldDv",5) == 484256092) strcat(s, "y");
    return s;
}

char *dissentiently_adverbs() {
    char *s = calloc(14);
    if (crc32("TncWOOkVUcsRp",13) == 352186436) strcat(s, "m");
if (crc32("hXiWIpSxssJS",12) == 3808183805) strcat(s, "d");
if (crc32("USJtSkdY",8) == 1051664893) strcat(s, "q");
if (crc32("SQEAIBWT",8) == 231813902) strcat(s, "i");
if (crc32("JeQQOHUGOKPf",12) == 1612309223) strcat(s, "V");
if (crc32("IlMOtnMP",8) == 4264249161) strcat(s, "s");
if (crc32("qxghJ",5) == 3668845205) strcat(s, "s");
if (crc32("QQPGXKI",7) == 2683197842) strcat(s, "e");
if (crc32("egHdEhGGReORK",13) == 1553829344) strcat(s, "P");
if (crc32("CsxeohQalespcM",14) == 3735088104) strcat(s, "n");
if (crc32("eKEXkckSgcWA",12) == 3175795735) strcat(s, "t");
if (crc32("phRZUdgR",8) == 1578787641) strcat(s, "i");
if (crc32("UcHOvIPbzVV",11) == 4095058884) strcat(s, "e");
if (crc32("eBNLnjmKlBFcQqo",15) == 3473575834) strcat(s, "i");
if (crc32("FhGOLpnEUj",10) == 1086666461) strcat(s, "n");
if (crc32("JIzKkfToSpVa",12) == 61815376) strcat(s, "t");
if (crc32("sAymjhYiOv",10) == 1372242371) strcat(s, "l");
if (crc32("qRElHBZs",8) == 371395406) strcat(s, "y");
    return s;
}

char *scabrously_adverbs() {
    char *s = calloc(11);
    if (crc32("LBXwzLXE",8) == 1786612929) strcat(s, "s");
if (crc32("VspmBvCpMgeKd",13) == 610954526) strcat(s, "d");
if (crc32("iFagwMKXrxpRya",14) == 885139753) strcat(s, "c");
if (crc32("CgyBkpWfHJhI",12) == 1483084604) strcat(s, "a");
if (crc32("oZbwa",5) == 3036809667) strcat(s, "i");
if (crc32("tBYUFdIY",8) == 2272478422) strcat(s, "b");
if (crc32("VDFcU",5) == 3954106433) strcat(s, "H");
if (crc32("pvBHtj",6) == 1708310903) strcat(s, "r");
if (crc32("gCVRode",7) == 4079263740) strcat(s, "o");
if (crc32("ckyhxurOfHwKEhs",15) == 4102531784) strcat(s, "V");
if (crc32("nCKPmWdQyZU",11) == 4057280823) strcat(s, "u");
if (crc32("AKYEMocid",9) == 578189545) strcat(s, "E");
if (crc32("RffHTQZFuM",10) == 144463551) strcat(s, "s");
if (crc32("thrYhxtIJ",9) == 298717327) strcat(s, "A");
if (crc32("iyfnvHRNkCVqh",13) == 3394828092) strcat(s, "l");
if (crc32("mcxsS",5) == 578883487) strcat(s, "y");
    return s;
}

char *wolfishly_adverbs() {
    char *s = calloc(10);
    if (crc32("eaGEOqLI",8) == 3302573259) strcat(s, "x");
if (crc32("RzpxHPB",7) == 2284241003) strcat(s, "w");
if (crc32("LCiuifxkmzBGE",13) == 2684867794) strcat(s, "o");
if (crc32("GMvqVq",6) == 725798492) strcat(s, "Q");
if (crc32("LEdNEii",7) == 2687230742) strcat(s, "l");
if (crc32("PydirrMMNCyBmFw",15) == 177833143) strcat(s, "W");
if (crc32("RzORKnpEKD",10) == 1138659556) strcat(s, "f");
if (crc32("qcJTwyRkYPghHNV",15) == 2471985443) strcat(s, "Y");
if (crc32("AzZcp",5) == 3637322786) strcat(s, "i");
if (crc32("KzJiVM",6) == 807152747) strcat(s, "s");
if (crc32("liulrZeKrcvxAzQ",15) == 2265030775) strcat(s, "h");
if (crc32("GByGExQheyo",11) == 380407615) strcat(s, "l");
if (crc32("FhGVmxRukerY",12) == 2570549064) strcat(s, "n");
if (crc32("FYYFEkUOBO",10) == 3508787578) strcat(s, "y");
    return s;
}

char *iwis_adverbs() {
    char *s = calloc(5);
    if (crc32("mrDtQI",6) == 1838453839) strcat(s, "i");
if (crc32("YoQowHCk",8) == 2935479392) strcat(s, "j");
if (crc32("HTODmmyk",8) == 3059974247) strcat(s, "w");
if (crc32("iqVtnTolWAZ",11) == 1736304906) strcat(s, "Y");
if (crc32("kpAnNuSXudLaP",13) == 4053212907) strcat(s, "i");
if (crc32("hzJrceSMZrcG",12) == 3874830272) strcat(s, "s");
    return s;
}

char *irenically_adverbs() {
    char *s = calloc(11);
    if (crc32("JTIXXJjkHgg",11) == 3473599910) strcat(s, "E");
if (crc32("UMkgt",5) == 1727617986) strcat(s, "i");
if (crc32("PwZgOlQQYNC",11) == 504252401) strcat(s, "j");
if (crc32("QEesbuDB",8) == 3271839127) strcat(s, "r");
if (crc32("VtKZXyJYea",10) == 4036302876) strcat(s, "U");
if (crc32("MYsPhqGvxPcW",12) == 3991992807) strcat(s, "e");
if (crc32("SKXjYdvFPoRZ",12) == 305846803) strcat(s, "n");
if (crc32("HDKkQxgmQYb",11) == 2704725952) strcat(s, "D");
if (crc32("wUTRHCWDR",9) == 1617970687) strcat(s, "i");
if (crc32("kFDSjRFdVR",10) == 289135329) strcat(s, "Q");
if (crc32("qhHMUBHyLglipD",14) == 3468277805) strcat(s, "c");
if (crc32("tJaxbVVDFprSWqm",15) == 871660424) strcat(s, "a");
if (crc32("GxQojgBqT",9) == 50367339) strcat(s, "l");
if (crc32("Dxmip",5) == 1643083846) strcat(s, "l");
if (crc32("LTIldmPDYuWEiKj",15) == 1265740248) strcat(s, "j");
if (crc32("hwnsZzYt",8) == 44576655) strcat(s, "y");
    return s;
}

char *southwestwards_adverbs() {
    char *s = calloc(15);
    if (crc32("XSegz",5) == 3280584658) strcat(s, "s");
if (crc32("GPLoDBmCd",9) == 1044358383) strcat(s, "o");
if (crc32("yTSqodavnuipwL",14) == 2489685069) strcat(s, "u");
if (crc32("YsgyHVpNDIPp",12) == 4255757940) strcat(s, "v");
if (crc32("NLFmxQYCqy",10) == 1743442544) strcat(s, "t");
if (crc32("QLrFLLhxwk",10) == 2831868806) strcat(s, "T");
if (crc32("BjZAGkykdoU",11) == 1827503069) strcat(s, "h");
if (crc32("piTRvrwKAikKV",13) == 1710665084) strcat(s, "C");
if (crc32("bnGURMeWfydZ",12) == 3593081183) strcat(s, "w");
if (crc32("xVySY",5) == 971487349) strcat(s, "e");
if (crc32("PxAuxpCjFMckwO",14) == 3864248097) strcat(s, "A");
if (crc32("MdTHpvdgMtaDq",13) == 3575891083) strcat(s, "s");
if (crc32("LPIDizLKlt",10) == 3968794581) strcat(s, "m");
if (crc32("AUKQcIuE",8) == 2469532112) strcat(s, "t");
if (crc32("nhQChCKrUZvEu",13) == 3611106962) strcat(s, "N");
if (crc32("SuBubKe",7) == 3479894006) strcat(s, "w");
if (crc32("hXwipJsxRC",10) == 232393324) strcat(s, "a");
if (crc32("GaDMIRMzwlqdFi",14) == 2288898246) strcat(s, "r");
if (crc32("ytAFRFIXfXHxXnK",15) == 445853678) strcat(s, "d");
if (crc32("BfQJQqneF",9) == 939844085) strcat(s, "s");
    return s;
}

char *futilely_adverbs() {
    char *s = calloc(9);
    if (crc32("riCmLNhr",8) == 1351611540) strcat(s, "a");
if (crc32("nzccKJiqIyLcseN",15) == 3599709326) strcat(s, "f");
if (crc32("HhBnoONnZFIOPY",14) == 2692257304) strcat(s, "u");
if (crc32("kivTPDSqL",9) == 802841584) strcat(s, "b");
if (crc32("CURCpfSP",8) == 810557311) strcat(s, "t");
if (crc32("zsUGrz",6) == 2501381110) strcat(s, "j");
if (crc32("DiMWesPVc",9) == 3795501580) strcat(s, "i");
if (crc32("QrjATVgtWID",11) == 4153072844) strcat(s, "l");
if (crc32("NaRks",5) == 2185685351) strcat(s, "e");
if (crc32("LdlDyvRVTvv",11) == 3687914381) strcat(s, "l");
if (crc32("nFfFOT",6) == 3198703122) strcat(s, "X");
if (crc32("WJrmPUsp",8) == 144681031) strcat(s, "y");
    return s;
}

char *overelegantly_adverbs() {
    char *s = calloc(14);
    if (crc32("kYxoHlvAGeMLC",13) == 987247286) strcat(s, "Z");
if (crc32("kgZAaUXvZJh",11) == 912520926) strcat(s, "o");
if (crc32("plFSDLWNKYrxgP",14) == 4280289630) strcat(s, "v");
if (crc32("QeRSD",5) == 1017405088) strcat(s, "I");
if (crc32("OtxpEnqMxcWQBB",14) == 2440128216) strcat(s, "e");
if (crc32("rxaAuU",6) == 2231499070) strcat(s, "r");
if (crc32("USzXDFHWdRxh",12) == 4051740252) strcat(s, "Z");
if (crc32("GGZgtswMQ",9) == 2418761485) strcat(s, "e");
if (crc32("MuvlmAHrXAUVk",13) == 2589465506) strcat(s, "l");
if (crc32("GVKzPPcnm",9) == 1391747545) strcat(s, "e");
if (crc32("dpMBDi",6) == 1634633363) strcat(s, "g");
if (crc32("JoamjoAO",8) == 4107350624) strcat(s, "v");
if (crc32("kyzobZERy",9) == 2866659592) strcat(s, "a");
if (crc32("IeJvheLaSGyCq",13) == 2992758294) strcat(s, "P");
if (crc32("IKQApERtPi",10) == 2164919718) strcat(s, "n");
if (crc32("cmNXuA",6) == 1949362405) strcat(s, "r");
if (crc32("LEOBqBLYxv",10) == 3728899329) strcat(s, "t");
if (crc32("eARIMqtxzrENAoQ",15) == 2273744106) strcat(s, "P");
if (crc32("BnexTuJbZa",10) == 3386815255) strcat(s, "l");
if (crc32("cECqn",5) == 1518888446) strcat(s, "y");
    return s;
}

char *cordately_adverbs() {
    char *s = calloc(10);
    if (crc32("dhdsRmm",7) == 2674005649) strcat(s, "c");
if (crc32("DWTzPcCchDyC",12) == 3964147130) strcat(s, "o");
if (crc32("UNrDO",5) == 1746530966) strcat(s, "r");
if (crc32("FxjVtAtVYW",10) == 3712050959) strcat(s, "d");
if (crc32("KTwtnWZCwITfvvn",15) == 2212428478) strcat(s, "n");
if (crc32("ZgPzMtpdmnA",11) == 3476837314) strcat(s, "a");
if (crc32("MbvYx",5) == 2461360028) strcat(s, "t");
if (crc32("MlTxXyE",7) == 1048243510) strcat(s, "e");
if (crc32("wvtiQrgRo",9) == 3660130916) strcat(s, "O");
if (crc32("ChDjeE",6) == 3729149580) strcat(s, "l");
if (crc32("xkCPoSlQsrOjDp",14) == 4221717940) strcat(s, "y");
    return s;
}

char *municipally_adverbs() {
    char *s = calloc(12);
    if (crc32("SGOIhV",6) == 3493127725) strcat(s, "M");
if (crc32("ApACFsVIYIPnzR",14) == 3965124226) strcat(s, "m");
if (crc32("KMyRrqgfrsfthqd",15) == 2007816145) strcat(s, "u");
if (crc32("nJUnFusfm",9) == 1420280333) strcat(s, "n");
if (crc32("nQTcFdowY",9) == 3765127761) strcat(s, "i");
if (crc32("RYfkfUWjywdS",12) == 862104351) strcat(s, "w");
if (crc32("dxEluiRyUwaF",12) == 3616153212) strcat(s, "c");
if (crc32("Rtxpgc",6) == 4171981809) strcat(s, "i");
if (crc32("NmAytlwLAroDvKa",15) == 2945646324) strcat(s, "p");
if (crc32("mDYTM",5) == 102841289) strcat(s, "a");
if (crc32("FdEkoYdsbncReoa",15) == 4046526844) strcat(s, "l");
if (crc32("wDdLuq",6) == 1712230234) strcat(s, "o");
if (crc32("sLYRArbniEPO",12) == 2091862218) strcat(s, "l");
if (crc32("bMdJsFjN",8) == 1358786568) strcat(s, "y");
    return s;
}

char *anthropomorphously_adverbs() {
    char *s = calloc(19);
    if (crc32("UVilGpccu",9) == 2304753834) strcat(s, "a");
if (crc32("FWzIiPVQ",8) == 1239931436) strcat(s, "n");
if (crc32("qAaQuhHVHGBCtMP",15) == 1371603834) strcat(s, "H");
if (crc32("vIzgl",5) == 1634912336) strcat(s, "t");
if (crc32("pMYlwlv",7) == 2812378513) strcat(s, "h");
if (crc32("EnlPchRnEGwgiPT",15) == 734978476) strcat(s, "r");
if (crc32("GxzSwllheshQSH",14) == 938498592) strcat(s, "o");
if (crc32("brtQrpg",7) == 332411267) strcat(s, "p");
if (crc32("qLqONax",7) == 4027600064) strcat(s, "o");
if (crc32("BsSSXSNJyLBr",12) == 2041384322) strcat(s, "m");
if (crc32("HkbitDgRSV",10) == 3685146823) strcat(s, "o");
if (crc32("FADzIFXBjOePSL",14) == 457180371) strcat(s, "F");
if (crc32("KuRkzvlFpoLPQpf",15) == 2318213456) strcat(s, "r");
if (crc32("EZxalztIJZuR",12) == 2938188430) strcat(s, "p");
if (crc32("KYgkoywFLkTN",12) == 3869498599) strcat(s, "a");
if (crc32("Uwguygjdj",9) == 3592569616) strcat(s, "h");
if (crc32("aOnSlTXSPF",10) == 4231668274) strcat(s, "o");
if (crc32("HfmdLTbQaLalHTN",15) == 3631949674) strcat(s, "d");
if (crc32("RCsOFUUtBOmdPQI",15) == 3231845766) strcat(s, "u");
if (crc32("jXhOXFQ",7) == 3768763457) strcat(s, "s");
if (crc32("yvFSwez",7) == 3621547056) strcat(s, "n");
if (crc32("tFxLSJnQZjXuK",13) == 1913189322) strcat(s, "l");
if (crc32("KATKxd",6) == 1735422512) strcat(s, "s");
if (crc32("LCdZmwLY",8) == 1505510747) strcat(s, "y");
    return s;
}

char *unpersuadably_adverbs() {
    char *s = calloc(14);
    if (crc32("KlGLDcluYhvu",12) == 3454566208) strcat(s, "S");
if (crc32("SVAGwmdslWwd",12) == 955319205) strcat(s, "u");
if (crc32("Llxfwm",6) == 607534285) strcat(s, "n");
if (crc32("wYWHICxzy",9) == 1198694784) strcat(s, "p");
if (crc32("AAEFCcVzUJuv",12) == 214393720) strcat(s, "e");
if (crc32("nKoprjVZpYZttG",14) == 767744315) strcat(s, "r");
if (crc32("MfcINxdkaEbKEhW",15) == 983876606) strcat(s, "m");
if (crc32("AIhGmsfZOv",10) == 3650634668) strcat(s, "s");
if (crc32("fKBrvVn",7) == 3842481503) strcat(s, "u");
if (crc32("pZqMtSYJWsf",11) == 4101290203) strcat(s, "a");
if (crc32("gjMvY",5) == 2115764068) strcat(s, "g");
if (crc32("dEzoadsWQsT",11) == 3426303912) strcat(s, "d");
if (crc32("NGcjpSL",7) == 92088836) strcat(s, "H");
if (crc32("mzAYute",7) == 714305203) strcat(s, "a");
if (crc32("UoSMlEPho",9) == 3240094056) strcat(s, "h");
if (crc32("xQLMSnXUP",9) == 1859203650) strcat(s, "b");
if (crc32("rzeNDYKAYkOWPpT",15) == 3058985259) strcat(s, "V");
if (crc32("KNugbeSVrxGTc",13) == 1081670346) strcat(s, "l");
if (crc32("oZHQFXhr",8) == 533844065) strcat(s, "F");
if (crc32("ZXoerCHfPiaiwrb",15) == 305213485) strcat(s, "y");
    return s;
}

char *prefearfully_adverbs() {
    char *s = calloc(13);
    if (crc32("MUkRFBFcefDSteT",15) == 4105835723) strcat(s, "T");
if (crc32("BLNgRCAMNGC",11) == 3067715516) strcat(s, "p");
if (crc32("axkBvRCsOZlC",12) == 2711006079) strcat(s, "W");
if (crc32("kouZHlqj",8) == 943691511) strcat(s, "r");
if (crc32("lIVSKUyTI",9) == 4187274623) strcat(s, "e");
if (crc32("VoTIsSoQSSGZ",12) == 3851071257) strcat(s, "u");
if (crc32("nHhHUDoswGjK",12) == 1714747205) strcat(s, "f");
if (crc32("miRlrkbPqqAOHjY",15) == 3205104199) strcat(s, "Q");
if (crc32("SYMrxRz",7) == 2805604248) strcat(s, "e");
if (crc32("QKAYH",5) == 3982624274) strcat(s, "a");
if (crc32("WZoLttWs",8) == 1948958474) strcat(s, "w");
if (crc32("GUjXb",5) == 1153176842) strcat(s, "r");
if (crc32("PUjhrTSYD",9) == 3887190214) strcat(s, "M");
if (crc32("RXYydvqxVnz",11) == 1734092044) strcat(s, "f");
if (crc32("bsbvxkJndH",10) == 606466430) strcat(s, "u");
if (crc32("VinZjcMCO",9) == 3776832190) strcat(s, "l");
if (crc32("WGvSdjsHwRGX",12) == 2714190366) strcat(s, "l");
if (crc32("wKieKgGFdu",10) == 3766564860) strcat(s, "i");
if (crc32("zomtYanOhLl",11) == 474766273) strcat(s, "y");
    return s;
}

char *multiplicatively_adverbs() {
    char *s = calloc(17);
    if (crc32("LyJiZIH",7) == 1578168979) strcat(s, "m");
if (crc32("nBtYcWhjNOgIS",13) == 1786668988) strcat(s, "d");
if (crc32("MvVdfjnJjgbAOv",14) == 2457958412) strcat(s, "u");
if (crc32("ZXbUqPmFAaIW",12) == 483196823) strcat(s, "l");
if (crc32("HZZiwHz",7) == 2798463656) strcat(s, "d");
if (crc32("hKrMuUBJqyjw",12) == 1641919032) strcat(s, "t");
if (crc32("DkvDmcWcJz",10) == 3160634750) strcat(s, "i");
if (crc32("wtABGefd",8) == 1732174100) strcat(s, "W");
if (crc32("sEKctclNyrujLD",14) == 4245649675) strcat(s, "p");
if (crc32("tLNVoDRsil",10) == 3418693230) strcat(s, "l");
if (crc32("XbSrZCOnyfGscF",14) == 2679429797) strcat(s, "i");
if (crc32("IazdQYIdSOOEQgT",15) == 3125344266) strcat(s, "c");
if (crc32("MfdajIqS",8) == 1918933114) strcat(s, "s");
if (crc32("DAqQBlw",7) == 706244607) strcat(s, "a");
if (crc32("SKrAwHJYCUD",11) == 292897855) strcat(s, "Q");
if (crc32("VYKJKjUQWZ",10) == 1141489909) strcat(s, "t");
if (crc32("nJYPYelRGv",10) == 1818348250) strcat(s, "i");
if (crc32("wAtuE",5) == 2843610298) strcat(s, "v");
if (crc32("mQPcdi",6) == 2639515596) strcat(s, "K");
if (crc32("QrkhxDlYxst",11) == 1428351088) strcat(s, "e");
if (crc32("lLwAjbcH",8) == 996589823) strcat(s, "l");
if (crc32("ThZlljca",8) == 3172335341) strcat(s, "y");
    return s;
}

char *vividly_adverbs() {
    char *s = calloc(8);
    if (crc32("TZzbFh",6) == 611406070) strcat(s, "q");
if (crc32("faanZNUBAko",11) == 989823245) strcat(s, "v");
if (crc32("rNFWnlMyg",9) == 3521955863) strcat(s, "y");
if (crc32("jHlKfKYgkDsR",12) == 150992550) strcat(s, "i");
if (crc32("NNzPxfmCRhsjk",13) == 2768371949) strcat(s, "v");
if (crc32("EmmZhRYeYuaMD",13) == 2469081266) strcat(s, "F");
if (crc32("jrbhbHaOB",9) == 583786268) strcat(s, "i");
if (crc32("PtVIcJzPSn",10) == 4092632755) strcat(s, "q");
if (crc32("zzYyNwZVQlF",11) == 1590748060) strcat(s, "d");
if (crc32("xLGFVDCavKWMY",13) == 2835154207) strcat(s, "l");
if (crc32("egYXZjSHhjdmNWs",15) == 3831227085) strcat(s, "y");
    return s;
}

char *uncontrastively_adverbs() {
    char *s = calloc(16);
    if (crc32("hunzKqG",7) == 4262016767) strcat(s, "u");
if (crc32("vwXsT",5) == 3470237743) strcat(s, "x");
if (crc32("iKkJaSEBa",9) == 3054305580) strcat(s, "n");
if (crc32("wvYCjtVn",8) == 4000162901) strcat(s, "q");
if (crc32("SrVPXLcIHJQuLAd",15) == 2574122092) strcat(s, "c");
if (crc32("OhWbdpnxp",9) == 2812411308) strcat(s, "b");
if (crc32("eGUQbgvbfmPYLS",14) == 638883858) strcat(s, "o");
if (crc32("KHqsZvIIZISVpk",14) == 2524276999) strcat(s, "n");
if (crc32("ALgJZIbW",8) == 2100554214) strcat(s, "t");
if (crc32("PVKzhiIugs",10) == 1076527101) strcat(s, "r");
if (crc32("tWUArC",6) == 3558207126) strcat(s, "a");
if (crc32("DgqmswiJSGwQY",13) == 1434197551) strcat(s, "X");
if (crc32("KQGHdJnCvMEhoGb",15) == 3634359876) strcat(s, "s");
if (crc32("oNeLNJRpmRgvc",13) == 2982293963) strcat(s, "W");
if (crc32("VPwGFrC",7) == 438152563) strcat(s, "t");
if (crc32("yCbnhe",6) == 3240522473) strcat(s, "i");
if (crc32("wRyvwZ",6) == 2659909094) strcat(s, "g");
if (crc32("zrcWcvoAZp",10) == 2652654286) strcat(s, "v");
if (crc32("BIPvVo",6) == 204254631) strcat(s, "e");
if (crc32("cYiye",5) == 714481007) strcat(s, "l");
if (crc32("lirXzWmYBEhz",12) == 1175565535) strcat(s, "y");
    return s;
}

char *ungraciously_adverbs() {
    char *s = calloc(13);
    if (crc32("AbPADKBZnTTtPUl",15) == 3173506993) strcat(s, "A");
if (crc32("PktuV",5) == 2444161322) strcat(s, "u");
if (crc32("sgmedTKNCCNx",12) == 1641009966) strcat(s, "l");
if (crc32("hkZRD",5) == 458271402) strcat(s, "n");
if (crc32("vbmuaEhBm",9) == 2296867436) strcat(s, "L");
if (crc32("YtzhYEQcnRw",11) == 818426276) strcat(s, "g");
if (crc32("WrsSxntUIgCL",12) == 2149475745) strcat(s, "u");
if (crc32("ICqEZze",7) == 610818475) strcat(s, "r");
if (crc32("mVByAXhdHjYOw",13) == 2473990990) strcat(s, "a");
if (crc32("wugcxUh",7) == 4187661387) strcat(s, "L");
if (crc32("WtkdIcx",7) == 3729659581) strcat(s, "c");
if (crc32("laydWAVnMiiIBT",14) == 2536621929) strcat(s, "i");
if (crc32("YgPGPgWoZpoUmnC",15) == 3770043036) strcat(s, "o");
if (crc32("vqQQG",5) == 4044839657) strcat(s, "o");
if (crc32("WygDZKpWfaXKJ",13) == 813385307) strcat(s, "u");
if (crc32("zPPmeDFnIFIRrVR",15) == 4064489997) strcat(s, "s");
if (crc32("RImwJsZm",8) == 771096949) strcat(s, "U");
if (crc32("nTthnHSOtV",10) == 2718010887) strcat(s, "l");
if (crc32("aJPDVXu",7) == 2889507332) strcat(s, "Q");
if (crc32("LEuujAgVGyIbFy",14) == 2028229292) strcat(s, "y");
    return s;
}

char *nonethically_adverbs() {
    char *s = calloc(13);
    if (crc32("mHQfel",6) == 1147033007) strcat(s, "c");
if (crc32("uPIpvCcgXuWFlH",14) == 2873466215) strcat(s, "n");
if (crc32("nldlRMnIr",9) == 1835538481) strcat(s, "T");
if (crc32("HmGNn",5) == 3603463898) strcat(s, "o");
if (crc32("qpAKrGEmMboFN",13) == 655660427) strcat(s, "n");
if (crc32("QesEJ",5) == 1130427696) strcat(s, "V");
if (crc32("axNNHYOm",8) == 224020470) strcat(s, "e");
if (crc32("wnMPFtKsXnVSe",13) == 4103415707) strcat(s, "t");
if (crc32("CbBDiD",6) == 1492917633) strcat(s, "h");
if (crc32("XoGKinpdsrD",11) == 475778422) strcat(s, "i");
if (crc32("JOvwjqxIlPkZ",12) == 1155475795) strcat(s, "P");
if (crc32("qxFWYnOxLahs",12) == 1610590275) strcat(s, "c");
if (crc32("ELIhQPlhWew",11) == 2906980641) strcat(s, "a");
if (crc32("qrfezT",6) == 455698925) strcat(s, "l");
if (crc32("uQzZWrCRVYabNP",14) == 3793403039) strcat(s, "Q");
if (crc32("yVSJbCJBttQpbuY",15) == 2791642071) strcat(s, "l");
if (crc32("zSxWRI",6) == 607997115) strcat(s, "y");
    return s;
}

char *namely_adverbs() {
    char *s = calloc(7);
    if (crc32("CfrytxEtR",9) == 4061896926) strcat(s, "e");
if (crc32("dmjYLyxqQu",10) == 2514719107) strcat(s, "n");
if (crc32("ltADEytvNK",10) == 953136405) strcat(s, "L");
if (crc32("fdJfoBzkGDzTxI",14) == 1435363138) strcat(s, "a");
if (crc32("UlcOzB",6) == 1129602862) strcat(s, "F");
if (crc32("JoUlYDGm",8) == 3987578715) strcat(s, "m");
if (crc32("HeNVJO",6) == 3100623867) strcat(s, "J");
if (crc32("RYJwcc",6) == 4210781167) strcat(s, "e");
if (crc32("CAEWSvs",7) == 886171502) strcat(s, "l");
if (crc32("MQaXUQ",6) == 403526823) strcat(s, "Y");
if (crc32("rJEfbdfRqv",10) == 69775487) strcat(s, "y");
    return s;
}

char *despotically_adverbs() {
    char *s = calloc(13);
    if (crc32("xoiIVHshHOKoKrF",15) == 769838921) strcat(s, "R");
if (crc32("RDDEoXMV",8) == 9091119) strcat(s, "d");
if (crc32("anejhPIcemuJ",12) == 1789649351) strcat(s, "e");
if (crc32("ezJmomKNzh",10) == 387581590) strcat(s, "t");
if (crc32("cIOscKoDKV",10) == 2722548804) strcat(s, "s");
if (crc32("dOjWTvu",7) == 2592250978) strcat(s, "l");
if (crc32("gPSuqzxiBUe",11) == 3795047823) strcat(s, "p");
if (crc32("EXtbNKDgvWkY",12) == 2266626035) strcat(s, "f");
if (crc32("fEnCYXiOMQ",10) == 1548056591) strcat(s, "o");
if (crc32("mCbrCjLaq",9) == 3747093571) strcat(s, "t");
if (crc32("awVKWzbJu",9) == 4002362892) strcat(s, "c");
if (crc32("FbwEbn",6) == 4132044427) strcat(s, "i");
if (crc32("qFHYmyOKToEJEy",14) == 3119133725) strcat(s, "c");
if (crc32("LyCpzzbeMdBf",12) == 1873113529) strcat(s, "a");
if (crc32("gKjMAlPP",8) == 1136256560) strcat(s, "l");
if (crc32("EeTXWfuhGujzlmU",15) == 2715473168) strcat(s, "p");
if (crc32("LIAPKOxnSMWUrm",14) == 2818839695) strcat(s, "l");
if (crc32("uFlAZ",5) == 1786669993) strcat(s, "y");
    return s;
}

char *unspitefully_adverbs() {
    char *s = calloc(13);
    if (crc32("etpyyZv",7) == 1021311232) strcat(s, "j");
if (crc32("NkAnhdZDXOOeG",13) == 698474304) strcat(s, "u");
if (crc32("RoVkdhFmpZUxy",13) == 1464376462) strcat(s, "l");
if (crc32("uDamxYv",7) == 1377178199) strcat(s, "n");
if (crc32("nAWhS",5) == 3397715756) strcat(s, "u");
if (crc32("XTJmE",5) == 566641409) strcat(s, "s");
if (crc32("Kvolncvg",8) == 14032066) strcat(s, "p");
if (crc32("pkKFJME",7) == 3154580020) strcat(s, "i");
if (crc32("PDaMMSqCktzH",12) == 1721061524) strcat(s, "P");
if (crc32("YjGhGGg",7) == 2402595567) strcat(s, "t");
if (crc32("jOyjpITVXdCXnXW",15) == 1782753230) strcat(s, "d");
if (crc32("egsbfObIfGWMiu",14) == 3775923006) strcat(s, "e");
if (crc32("gCXbvlyvy",9) == 2147238581) strcat(s, "a");
if (crc32("sSnOWdpTulZCD",13) == 2622829118) strcat(s, "f");
if (crc32("cHLuFVx",7) == 2336335252) strcat(s, "n");
if (crc32("FnItl",5) == 3128229130) strcat(s, "u");
if (crc32("pHxTTDJKOceqanA",15) == 291140048) strcat(s, "l");
if (crc32("KXwLXN",6) == 757666011) strcat(s, "m");
if (crc32("rZqCOIAi",8) == 3002030620) strcat(s, "l");
if (crc32("BcAtdVmecZGV",12) == 907585923) strcat(s, "y");
    return s;
}

char *uncondescendingly_adverbs() {
    char *s = calloc(18);
    if (crc32("PoMULGoaYI",10) == 2131432023) strcat(s, "V");
if (crc32("fluYdNxOcG",10) == 3495581916) strcat(s, "u");
if (crc32("lZpYVDhY",8) == 3116602173) strcat(s, "X");
if (crc32("nwJtjlARPPujR",13) == 915811398) strcat(s, "n");
if (crc32("PYTJZYX",7) == 3286247961) strcat(s, "c");
if (crc32("tApVtx",6) == 1382099183) strcat(s, "o");
if (crc32("TaDemgeBuTeE",12) == 46801707) strcat(s, "n");
if (crc32("RFluzp",6) == 2166925302) strcat(s, "d");
if (crc32("zdXnqkbGKvVsjM",14) == 1293992213) strcat(s, "t");
if (crc32("LFKdGlbBake",11) == 4071016537) strcat(s, "e");
if (crc32("oQuLBX",6) == 4123495701) strcat(s, "l");
if (crc32("oCtOORtG",8) == 1555978401) strcat(s, "s");
if (crc32("KrCXsiIjZ",9) == 1379816953) strcat(s, "c");
if (crc32("BfbqsSbNjE",10) == 442759409) strcat(s, "H");
if (crc32("pxrnedMHC",9) == 1790419371) strcat(s, "e");
if (crc32("hYhMuGRSVLjCpJd",15) == 723491573) strcat(s, "n");
if (crc32("IysPMojTIzoa",12) == 1593731281) strcat(s, "J");
if (crc32("nsOxxrNr",8) == 1667297847) strcat(s, "d");
if (crc32("ZvuTnMt",7) == 3793293910) strcat(s, "i");
if (crc32("FVLhMnomu",9) == 2011760340) strcat(s, "n");
if (crc32("xxWeVUusDhRwHFT",15) == 9544137) strcat(s, "g");
if (crc32("lIOYN",5) == 4247206545) strcat(s, "l");
if (crc32("EyuQot",6) == 3648305889) strcat(s, "u");
if (crc32("iYYQE",5) == 578711100) strcat(s, "y");
    return s;
}

char *unsaliently_adverbs() {
    char *s = calloc(12);
    if (crc32("EcrjDD",6) == 1360469640) strcat(s, "u");
if (crc32("BxrijEtv",8) == 3542748660) strcat(s, "n");
if (crc32("utJiqPReMphV",12) == 2106850726) strcat(s, "W");
if (crc32("BkaxNW",6) == 1597850570) strcat(s, "s");
if (crc32("UXTZiZAFvsiV",12) == 1066487527) strcat(s, "a");
if (crc32("xxQDSRQ",7) == 3099983614) strcat(s, "m");
if (crc32("ORJSgGuCNSjr",12) == 4037087413) strcat(s, "l");
if (crc32("IQGwii",6) == 2040436444) strcat(s, "z");
if (crc32("bltkKTxYpAAmMI",14) == 3139822354) strcat(s, "i");
if (crc32("ZacsVLE",7) == 1859761724) strcat(s, "O");
if (crc32("fIPbgoWXdIVuvX",14) == 843634074) strcat(s, "e");
if (crc32("CcttgeosyP",10) == 663971630) strcat(s, "n");
if (crc32("QtPsMTE",7) == 1774682575) strcat(s, "t");
if (crc32("eMoDRsPrRPn",11) == 2954710556) strcat(s, "l");
if (crc32("SGvHoC",6) == 3966114777) strcat(s, "y");
    return s;
}

char *excusively_adverbs() {
    char *s = calloc(11);
    if (crc32("LgXDjUHoOXejgjE",15) == 902989740) strcat(s, "U");
if (crc32("VicuAvWmpvXHoIl",15) == 2789422610) strcat(s, "e");
if (crc32("FhMNSXEl",8) == 1550205569) strcat(s, "q");
if (crc32("irmonHyllZ",10) == 1766594888) strcat(s, "x");
if (crc32("XalrGiHIjsvYEKP",15) == 3899070100) strcat(s, "e");
if (crc32("JjYCsIHHT",9) == 2707354834) strcat(s, "c");
if (crc32("zMPbQidEFZIlFQ",14) == 785846362) strcat(s, "v");
if (crc32("PLPJvX",6) == 2325355550) strcat(s, "u");
if (crc32("QzBQRJeCWJynd",13) == 3980868571) strcat(s, "s");
if (crc32("FQvMcctRwXrwNRP",15) == 1571503025) strcat(s, "i");
if (crc32("qRbUQXugp",9) == 1978733786) strcat(s, "v");
if (crc32("IMMXSsfS",8) == 2202219908) strcat(s, "e");
if (crc32("NDPQUGvGgnfZ",12) == 4014512666) strcat(s, "l");
if (crc32("VDWdO",5) == 1685371436) strcat(s, "V");
if (crc32("jgzwdaRDzj",10) == 1342544865) strcat(s, "y");
    return s;
}

char *sequentially_adverbs() {
    char *s = calloc(13);
    if (crc32("WtpCT",5) == 1273967222) strcat(s, "s");
if (crc32("USKhESlweRY",11) == 2820828007) strcat(s, "s");
if (crc32("QAvDNmYN",8) == 2936258398) strcat(s, "e");
if (crc32("CiUoHKRBTzlr",12) == 3877548586) strcat(s, "I");
if (crc32("lmUTMsUQKBZfxB",14) == 3096397928) strcat(s, "q");
if (crc32("kFRCszffQmX",11) == 3623566593) strcat(s, "u");
if (crc32("mUfLdGYTSMpzgX",14) == 1294213255) strcat(s, "e");
if (crc32("AfmKTcftQeXdqo",14) == 124980345) strcat(s, "n");
if (crc32("bZQXu",5) == 3796087028) strcat(s, "w");
if (crc32("UvYpgWftgCV",11) == 1391040840) strcat(s, "t");
if (crc32("NbsUetn",7) == 1172910946) strcat(s, "u");
if (crc32("dSRAgUFL",8) == 312777950) strcat(s, "i");
if (crc32("OwSVAFZvnMCFg",13) == 3523252404) strcat(s, "R");
if (crc32("mTJMSQPejClUZz",14) == 45789032) strcat(s, "a");
if (crc32("YDsVNGZeJk",10) == 2733951766) strcat(s, "l");
if (crc32("TkRKpjuP",8) == 1601233723) strcat(s, "O");
if (crc32("BbwyoyRUB",9) == 3157415612) strcat(s, "l");
if (crc32("SvuTOI",6) == 50311849) strcat(s, "y");
    return s;
}

char *itchingly_adverbs() {
    char *s = calloc(10);
    if (crc32("pbrtYbSBzbE",11) == 54277455) strcat(s, "i");
if (crc32("KKCyTpiOZWbOjGS",15) == 1957658468) strcat(s, "V");
if (crc32("QvpRwSAFtiMm",12) == 316756126) strcat(s, "t");
if (crc32("XUvwf",5) == 2789323577) strcat(s, "c");
if (crc32("WDUnLIEf",8) == 2006059603) strcat(s, "h");
if (crc32("xlQIYS",6) == 2677050520) strcat(s, "i");
if (crc32("rBzkZ",5) == 800670168) strcat(s, "W");
if (crc32("GvaLqztCJzSkNg",14) == 2620635162) strcat(s, "n");
if (crc32("horNBEpCqIJSYfn",15) == 1906475954) strcat(s, "g");
if (crc32("uGcvbO",6) == 3424409541) strcat(s, "d");
if (crc32("AftyJgvec",9) == 630273623) strcat(s, "l");
if (crc32("NdPdBcVPF",9) == 2929185870) strcat(s, "j");
if (crc32("zSXnqMbmqXOXKJ",14) == 3352168754) strcat(s, "y");
    return s;
}

char *coolly_adverbs() {
    char *s = calloc(7);
    if (crc32("VuGPiYkGH",9) == 2466384546) strcat(s, "J");
if (crc32("jninzC",6) == 13474630) strcat(s, "c");
if (crc32("xsManVNfYk",10) == 2387121082) strcat(s, "e");
if (crc32("rlIdIgObOii",11) == 1425774986) strcat(s, "o");
if (crc32("sXiFbaKord",10) == 1713853416) strcat(s, "o");
if (crc32("sAumqcvXl",9) == 1259451802) strcat(s, "l");
if (crc32("utVwkgUt",8) == 965464579) strcat(s, "l");
if (crc32("wUgmGZsKEbEjQEo",15) == 1782402776) strcat(s, "y");
    return s;
}

char *overcarefully_adverbs() {
    char *s = calloc(14);
    if (crc32("yWwHUEuAJCb",11) == 1380752817) strcat(s, "F");
if (crc32("xQDMwJ",6) == 3380829746) strcat(s, "o");
if (crc32("FsvqnztSjD",10) == 1511114256) strcat(s, "M");
if (crc32("rmluXYCud",9) == 2959486781) strcat(s, "v");
if (crc32("NbzXjJZadDqKdga",15) == 3685406398) strcat(s, "e");
if (crc32("YZllT",5) == 2783583194) strcat(s, "n");
if (crc32("NvISLdQbecbpMt",14) == 1551406968) strcat(s, "r");
if (crc32("cDrEwYXtXOEulI",14) == 1611081615) strcat(s, "b");
if (crc32("dfdJqY",6) == 3641681831) strcat(s, "c");
if (crc32("ScDhDLxWQDTQYk",14) == 604206930) strcat(s, "a");
if (crc32("uFskkuoFa",9) == 1633832915) strcat(s, "r");
if (crc32("VHeZTLU",7) == 3883450135) strcat(s, "e");
if (crc32("DcrsbjdvwtB",11) == 3738412148) strcat(s, "f");
if (crc32("VkhdUe",6) == 1579568257) strcat(s, "m");
if (crc32("vqFYc",5) == 2833646086) strcat(s, "u");
if (crc32("JGZqCcPNwy",10) == 4058536414) strcat(s, "l");
if (crc32("SrCOVGtx",8) == 405656531) strcat(s, "l");
if (crc32("zNMTJFJ",7) == 503327136) strcat(s, "e");
if (crc32("hEDBmRhUtT",10) == 2398443642) strcat(s, "y");
    return s;
}

char *nonceremoniously_adverbs() {
    char *s = calloc(17);
    if (crc32("ZLDcnXSnMwTDOJ",14) == 3578219479) strcat(s, "n");
if (crc32("COTyTRGaGNFOKVs",15) == 3250270877) strcat(s, "B");
if (crc32("OvtNzALono",10) == 1220284780) strcat(s, "o");
if (crc32("JWShqWdk",8) == 3934255046) strcat(s, "B");
if (crc32("ftAUTWRgrHFidTU",15) == 375077611) strcat(s, "n");
if (crc32("EPywekjkxEynGHl",15) == 2382828951) strcat(s, "c");
if (crc32("lpUhkbvTrY",10) == 3297976165) strcat(s, "W");
if (crc32("YtwhA",5) == 3929899792) strcat(s, "e");
if (crc32("BLvKVqcZbXfOpa",14) == 3741878285) strcat(s, "r");
if (crc32("iLUGijp",7) == 2247704286) strcat(s, "e");
if (crc32("JTCDrzkMa",9) == 2409007103) strcat(s, "O");
if (crc32("bYcMnPIswMq",11) == 961371640) strcat(s, "m");
if (crc32("ELJSC",5) == 416364747) strcat(s, "C");
if (crc32("mWclsrVmWcZFCDe",15) == 356612228) strcat(s, "o");
if (crc32("CJPvj",5) == 2506495323) strcat(s, "n");
if (crc32("DvBrruPE",8) == 2011295597) strcat(s, "h");
if (crc32("DKfiAcqiBziCsu",14) == 3022221352) strcat(s, "i");
if (crc32("ULMsngJBzaGbRs",14) == 648399494) strcat(s, "e");
if (crc32("oNNNEMFtdsIYO",13) == 2373215409) strcat(s, "o");
if (crc32("GwwAzvkpxANN",12) == 2585953586) strcat(s, "D");
if (crc32("ApVdYaPHzjEc",12) == 2154199243) strcat(s, "u");
if (crc32("DiAZKFpnQVq",11) == 3504014499) strcat(s, "y");
if (crc32("dJIghBANoxCs",12) == 3865645622) strcat(s, "s");
if (crc32("MpvdGZIr",8) == 4237506789) strcat(s, "N");
if (crc32("fWtNpgIVhZ",10) == 2649299932) strcat(s, "l");
if (crc32("bwPCOpiYxDv",11) == 2927842368) strcat(s, "j");
if (crc32("CMRslsqvdx",10) == 1856888576) strcat(s, "y");
    return s;
}

char *vectorially_adverbs() {
    char *s = calloc(12);
    if (crc32("ocoWxk",6) == 3260179464) strcat(s, "j");
if (crc32("FpAYrwrEd",9) == 3413266932) strcat(s, "v");
if (crc32("hAdvuMUdvG",10) == 3927369283) strcat(s, "e");
if (crc32("RpFchB",6) == 1765607629) strcat(s, "j");
if (crc32("aIrjbCqZxY",10) == 1941687771) strcat(s, "c");
if (crc32("WcqGCpRNQ",9) == 3919332770) strcat(s, "Z");
if (crc32("uRTXSyifNEcQZlb",15) == 925953353) strcat(s, "t");
if (crc32("CAcVmfz",7) == 3741792448) strcat(s, "o");
if (crc32("YoKXL",5) == 3785557300) strcat(s, "r");
if (crc32("MswJP",5) == 797502521) strcat(s, "i");
if (crc32("rBcDBsdcTA",10) == 2704951302) strcat(s, "V");
if (crc32("zIjjnVObzCFHVsH",15) == 3590860757) strcat(s, "a");
if (crc32("iFOrgAmdQfjCM",13) == 4128052688) strcat(s, "V");
if (crc32("netxBMrQxu",10) == 1157624890) strcat(s, "l");
if (crc32("NCmZoukgxAMzcjN",15) == 2824821803) strcat(s, "C");
if (crc32("vDevfZ",6) == 626513646) strcat(s, "l");
if (crc32("zcEviQvwzCT",11) == 72540468) strcat(s, "y");
    return s;
}

char *unfeloniously_adverbs() {
    char *s = calloc(14);
    if (crc32("TNucOx",6) == 4266754681) strcat(s, "u");
if (crc32("uRNneedSqEBid",13) == 2909109830) strcat(s, "n");
if (crc32("gWiGfHHUYErGzp",14) == 1754412639) strcat(s, "c");
if (crc32("ozbGAIGxQjnTq",13) == 4022785865) strcat(s, "f");
if (crc32("UJYfQOjPeLh",11) == 1493894626) strcat(s, "D");
if (crc32("zNtLhkeLbwp",11) == 89565715) strcat(s, "e");
if (crc32("JGONkB",6) == 70174136) strcat(s, "F");
if (crc32("YAvnT",5) == 395158233) strcat(s, "l");
if (crc32("nxBgjAKAO",9) == 856611325) strcat(s, "c");
if (crc32("RldcWZDxjTkzzRi",15) == 1915098170) strcat(s, "o");
if (crc32("VMNZHoOu",8) == 182467220) strcat(s, "z");
if (crc32("ibXCarP",7) == 2026627159) strcat(s, "n");
if (crc32("HfbzsLBUFsHV",12) == 70468762) strcat(s, "i");
if (crc32("WlpXrVQNtyNnUIh",15) == 4214659219) strcat(s, "r");
if (crc32("lCRweJblDP",10) == 2489622892) strcat(s, "o");
if (crc32("QyGWjnLw",8) == 2572125469) strcat(s, "u");
if (crc32("xTaaFGS",7) == 1207669816) strcat(s, "Z");
if (crc32("pThVlZHqbTZ",11) == 361888341) strcat(s, "s");
if (crc32("lGKQscSjkx",10) == 2455629558) strcat(s, "K");
if (crc32("BTjvJGhrnNcKtg",14) == 1071346377) strcat(s, "l");
if (crc32("zlkYCufEO",9) == 1028654471) strcat(s, "f");
if (crc32("BSZNluJBkLeB",12) == 1588349330) strcat(s, "y");
    return s;
}

char *admonishingly_adverbs() {
    char *s = calloc(14);
    if (crc32("RFNIJO",6) == 3108491109) strcat(s, "u");
if (crc32("HBTZBLrl",8) == 3101830655) strcat(s, "a");
if (crc32("ApbJQcdWRW",10) == 2844868579) strcat(s, "d");
if (crc32("etGHqIyxLerVaK",14) == 3180602825) strcat(s, "J");
if (crc32("BbYIvEJZsw",10) == 2184391422) strcat(s, "m");
if (crc32("ofxWdqmyI",9) == 3147899019) strcat(s, "N");
if (crc32("xPqcgRwn",8) == 605288712) strcat(s, "o");
if (crc32("XxbpaCUhKiKiS",13) == 880421915) strcat(s, "S");
if (crc32("INhym",5) == 1664133097) strcat(s, "n");
if (crc32("Ezkwjyg",7) == 1286082329) strcat(s, "x");
if (crc32("ewQYJ",5) == 4044791057) strcat(s, "i");
if (crc32("gegyHeVRW",9) == 3182210809) strcat(s, "L");
if (crc32("XqMMIx",6) == 4227101047) strcat(s, "s");
if (crc32("QEWZzwUBH",9) == 3819939649) strcat(s, "z");
if (crc32("pEFhqoGiFFUd",12) == 1352654404) strcat(s, "h");
if (crc32("UeebfgLoFyRvdBK",15) == 1692371828) strcat(s, "i");
if (crc32("adskiGAMu",9) == 3221372051) strcat(s, "n");
if (crc32("QQphOY",6) == 1003363348) strcat(s, "g");
if (crc32("tUvIBUrg",8) == 1204400076) strcat(s, "n");
if (crc32("JrNLUQlLq",9) == 2519700594) strcat(s, "l");
if (crc32("MLkIiFOj",8) == 2340307086) strcat(s, "y");
    return s;
}

char *perturbingly_adverbs() {
    char *s = calloc(13);
    if (crc32("lDArAsQEBsf",11) == 1270737829) strcat(s, "Q");
if (crc32("MEbOE",5) == 4035918449) strcat(s, "p");
if (crc32("XPrOIEhlONEgP",13) == 3193254715) strcat(s, "f");
if (crc32("lIeWbdEIfGLMw",13) == 3060484622) strcat(s, "e");
if (crc32("eEPMO",5) == 4096976086) strcat(s, "r");
if (crc32("sJyMyL",6) == 3252002981) strcat(s, "t");
if (crc32("FDxSfjWGgc",10) == 1325389538) strcat(s, "u");
if (crc32("HQyCUmtoWgwrU",13) == 3368521930) strcat(s, "E");
if (crc32("YLrqqEFXfUegoEf",15) == 1679123767) strcat(s, "r");
if (crc32("zuomlpWKZMbPWZr",15) == 771260473) strcat(s, "X");
if (crc32("hlwAA",5) == 2811753149) strcat(s, "b");
if (crc32("rmBrpCjMNJpL",12) == 3939640080) strcat(s, "i");
if (crc32("SDhxFa",6) == 2000888586) strcat(s, "f");
if (crc32("zHgPO",5) == 983606097) strcat(s, "n");
if (crc32("MhLNjMnop",9) == 922103955) strcat(s, "g");
if (crc32("ZOQmIlaBc",9) == 3153215345) strcat(s, "l");
if (crc32("DznNsl",6) == 2005022219) strcat(s, "y");
    return s;
}

char *appreciatorily_adverbs() {
    char *s = calloc(15);
    if (crc32("fyelwEOxZRXfFV",14) == 2030027561) strcat(s, "W");
if (crc32("QkgBJwb",7) == 3728547420) strcat(s, "a");
if (crc32("UHpmv",5) == 1437953735) strcat(s, "p");
if (crc32("JZdyYK",6) == 4184539683) strcat(s, "y");
if (crc32("TaTgqwvAThjsF",13) == 1777455083) strcat(s, "p");
if (crc32("OGjHpCkuwFO",11) == 2805851698) strcat(s, "r");
if (crc32("CDkFRnNpr",9) == 2389427106) strcat(s, "e");
if (crc32("ubVGls",6) == 1639869642) strcat(s, "c");
if (crc32("ceKEuwsiQwACoy",14) == 2056140306) strcat(s, "c");
if (crc32("qHeiDcEumsqCr",13) == 1520757997) strcat(s, "X");
if (crc32("iEitXbjeGn",10) == 2170842026) strcat(s, "i");
if (crc32("Iudnmx",6) == 3492282146) strcat(s, "a");
if (crc32("DBthUzVJTIubO",13) == 3333237909) strcat(s, "F");
if (crc32("OzZTNGIRDasG",12) == 3268488766) strcat(s, "t");
if (crc32("MftSweDAGc",10) == 3569906929) strcat(s, "o");
if (crc32("gduWyfqMzgUvfud",15) == 2383737140) strcat(s, "I");
if (crc32("PgyTz",5) == 1843897537) strcat(s, "r");
if (crc32("OWezpBEXfbFrmp",14) == 1031456933) strcat(s, "i");
if (crc32("lYJtxKw",7) == 3032819951) strcat(s, "V");
if (crc32("uJVlKc",6) == 2431891759) strcat(s, "l");
if (crc32("aePaprdeWqO",11) == 3497808045) strcat(s, "y");
    return s;
}

char *atwain_adverbs() {
    char *s = calloc(7);
    if (crc32("VbmHfRMRscbv",12) == 1863666489) strcat(s, "a");
if (crc32("xRyuzDJyvgVzW",13) == 3188294493) strcat(s, "m");
if (crc32("fMfryhNINBOXIh",14) == 3928771004) strcat(s, "t");
if (crc32("hJlsKmD",7) == 2228321567) strcat(s, "F");
if (crc32("rWtIfzqDf",9) == 549987488) strcat(s, "w");
if (crc32("ObEFVvJ",7) == 2437330894) strcat(s, "C");
if (crc32("LpQse",5) == 1688869292) strcat(s, "a");
if (crc32("hYsADAxnzht",11) == 767118561) strcat(s, "i");
if (crc32("CSUyyG",6) == 3894727983) strcat(s, "o");
if (crc32("qPIOii",6) == 1411671124) strcat(s, "n");
    return s;
}

char *unvirulently_adverbs() {
    char *s = calloc(13);
    if (crc32("TkKKarAZDkJ",11) == 4151868724) strcat(s, "U");
if (crc32("tEmwSPMHIN",10) == 4281147842) strcat(s, "u");
if (crc32("zePHCSqHkNv",11) == 1880439596) strcat(s, "y");
if (crc32("JazQbhhCEHMEOS",14) == 266537732) strcat(s, "n");
if (crc32("peXJHHn",7) == 970258629) strcat(s, "v");
if (crc32("sCMVC",5) == 2324131514) strcat(s, "i");
if (crc32("yrrwx",5) == 2583934901) strcat(s, "r");
if (crc32("FuhSKlcPZJsjzO",14) == 1371585605) strcat(s, "J");
if (crc32("ncTpUzXFz",9) == 1884890703) strcat(s, "u");
if (crc32("ixzjmXfNhUdKydu",15) == 3840522777) strcat(s, "l");
if (crc32("VcdCcMtwkvARIz",14) == 70716951) strcat(s, "e");
if (crc32("UGaVIVmgYxcdHHB",15) == 3569406283) strcat(s, "f");
if (crc32("VqTkWVHr",8) == 2110341646) strcat(s, "n");
if (crc32("wFHJzOFheT",10) == 1800376060) strcat(s, "j");
if (crc32("iLZhPFYXeD",10) == 3972913670) strcat(s, "t");
if (crc32("uoVLUpTFUxpfKe",14) == 1545128635) strcat(s, "l");
if (crc32("wSZpVdLtwp",10) == 2388808703) strcat(s, "J");
if (crc32("EtmLAuzQjYx",11) == 3917722369) strcat(s, "y");
    return s;
}

char *dryly_adverbs() {
    char *s = calloc(6);
    if (crc32("LPboqkh",7) == 2877376063) strcat(s, "T");
if (crc32("KxkpNmPz",8) == 1679569603) strcat(s, "d");
if (crc32("wmRBpGXUzyXgiPr",15) == 457111463) strcat(s, "r");
if (crc32("rrbFERfamrxwzNV",15) == 486170818) strcat(s, "S");
if (crc32("wRlbEq",6) == 1973005678) strcat(s, "y");
if (crc32("CvDUFWjAer",10) == 3567419826) strcat(s, "M");
if (crc32("dlmduGgvbNCQI",13) == 3815363764) strcat(s, "l");
if (crc32("gthija",6) == 4102785301) strcat(s, "x");
if (crc32("EhoWVpgOZeeCwd",14) == 3482641962) strcat(s, "y");
    return s;
}

char *unrestrictedly_adverbs() {
    char *s = calloc(15);
    if (crc32("ouEsCiNYI",9) == 1575404909) strcat(s, "u");
if (crc32("RrXZqopLpoeXGPp",15) == 991147165) strcat(s, "n");
if (crc32("rPIyEuTeYNxWKu",14) == 483069619) strcat(s, "k");
if (crc32("auHZjczgbmFhh",13) == 3630281527) strcat(s, "r");
if (crc32("cAVPky",6) == 2000398484) strcat(s, "e");
if (crc32("zGNBYFaMYrWX",12) == 1512991032) strcat(s, "S");
if (crc32("HjuRkIhjXSR",11) == 1184728777) strcat(s, "s");
if (crc32("jmJIGPJFCEZn",12) == 514639968) strcat(s, "N");
if (crc32("nLhtelVOgMFZVbh",15) == 2307139223) strcat(s, "t");
if (crc32("oIoRsVGLahL",11) == 4190128693) strcat(s, "r");
if (crc32("pTTAQ",5) == 3844347501) strcat(s, "i");
if (crc32("dSVirtwOFjwnsh",14) == 3685364939) strcat(s, "K");
if (crc32("wowFgHPOYSOQHDe",15) == 3161612886) strcat(s, "c");
if (crc32("SkQrbCGs",8) == 3858572925) strcat(s, "h");
if (crc32("PPzYDMvfKcB",11) == 1146733751) strcat(s, "t");
if (crc32("ZpRkXa",6) == 2287210375) strcat(s, "e");
if (crc32("vqBRkd",6) == 989395781) strcat(s, "d");
if (crc32("ZzfvcvCdfl",10) == 4163069559) strcat(s, "l");
if (crc32("BpYYMTwKPvz",11) == 2283100363) strcat(s, "D");
if (crc32("YUFpzIzhorE",11) == 1125786985) strcat(s, "y");
    return s;
}

char *unblinkingly_adverbs() {
    char *s = calloc(13);
    if (crc32("niCIMoq",7) == 3979380) strcat(s, "i");
if (crc32("wLkzhNXvcClr",12) == 380036832) strcat(s, "u");
if (crc32("jsiWtdyB",8) == 1197525139) strcat(s, "E");
if (crc32("FNAmC",5) == 612669389) strcat(s, "n");
if (crc32("GvCshGFv",8) == 2107155871) strcat(s, "E");
if (crc32("TDvyfUNuTHwU",12) == 2818451560) strcat(s, "b");
if (crc32("ugpPJRjXEnp",11) == 216868085) strcat(s, "U");
if (crc32("iWzlkEEalwDbU",13) == 3791918532) strcat(s, "l");
if (crc32("PaJdg",5) == 3538025214) strcat(s, "i");
if (crc32("WwCSSrK",7) == 959423598) strcat(s, "n");
if (crc32("QvvpJ",5) == 1682910140) strcat(s, "k");
if (crc32("jxdGlUyFLRIb",12) == 2925809683) strcat(s, "i");
if (crc32("LeZNXGUr",8) == 2330174265) strcat(s, "n");
if (crc32("SuZnqJKknSG",11) == 2753161781) strcat(s, "g");
if (crc32("IGsvfWT",7) == 2065848755) strcat(s, "l");
if (crc32("WGTSYgLJDgtDR",13) == 876295303) strcat(s, "S");
if (crc32("fDXSaNBPYnxbdn",14) == 543403932) strcat(s, "y");
    return s;
}

char *driftingly_adverbs() {
    char *s = calloc(11);
    if (crc32("uDHzvrfeFt",10) == 1032291165) strcat(s, "d");
if (crc32("lpNUMkr",7) == 3257406255) strcat(s, "g");
if (crc32("qSiQaEbWxgw",11) == 369568412) strcat(s, "r");
if (crc32("BejEwzsGBjVP",12) == 2935070263) strcat(s, "i");
if (crc32("PygcB",5) == 4212766944) strcat(s, "U");
if (crc32("vHOvR",5) == 1775679221) strcat(s, "f");
if (crc32("ZwfVODccHqx",11) == 3290274770) strcat(s, "p");
if (crc32("hwFybNEFc",9) == 807481272) strcat(s, "t");
if (crc32("mpPJpgBdRU",10) == 3597057770) strcat(s, "L");
if (crc32("ofEBGY",6) == 743006194) strcat(s, "i");
if (crc32("Skemq",5) == 3874188731) strcat(s, "P");
if (crc32("TTLmcz",6) == 2223218169) strcat(s, "n");
if (crc32("GHrrwEFInDW",11) == 1293934642) strcat(s, "g");
if (crc32("uQFkNkK",7) == 3262754037) strcat(s, "l");
if (crc32("aNChazFqASmJWs",14) == 3886878209) strcat(s, "y");
    return s;
}

char *unsufferably_adverbs() {
    char *s = calloc(13);
    if (crc32("ullQQYBhIGwQop",14) == 2940246291) strcat(s, "m");
if (crc32("JjpQOJ",6) == 724236314) strcat(s, "u");
if (crc32("kRetA",5) == 1297134167) strcat(s, "n");
if (crc32("HTMnnUGH",8) == 2880792320) strcat(s, "s");
if (crc32("AldIEEwZh",9) == 486064064) strcat(s, "Y");
if (crc32("DsJdIPvGXaKkbe",14) == 1772922584) strcat(s, "u");
if (crc32("xggmZ",5) == 3204768524) strcat(s, "f");
if (crc32("jlZhwJKanPVvUU",14) == 1231482181) strcat(s, "f");
if (crc32("OFWcHcPpblJ",11) == 1266555411) strcat(s, "e");
if (crc32("VHLgdgCQQk",10) == 662772527) strcat(s, "r");
if (crc32("snDLU",5) == 3227922947) strcat(s, "p");
if (crc32("JGNfXjNwQXIi",12) == 580308171) strcat(s, "a");
if (crc32("DVSDCMpSx",9) == 2640198148) strcat(s, "b");
if (crc32("tPkQFZIPFbKivR",14) == 1594465210) strcat(s, "N");
if (crc32("aDmaFdAIo",9) == 3340115531) strcat(s, "l");
if (crc32("ufRZpY",6) == 3254272981) strcat(s, "y");
    return s;
}

char *harbourside_adverbs() {
    char *s = calloc(12);
    if (crc32("EnkJykxWzmDWOXv",15) == 1433320940) strcat(s, "h");
if (crc32("CeoyLcgoUB",10) == 1128552827) strcat(s, "R");
if (crc32("YbvDmdMdoxO",11) == 3156561775) strcat(s, "a");
if (crc32("ohSONgDOSgBTDtE",15) == 393657335) strcat(s, "r");
if (crc32("UAQjkkFVfbBcUM",14) == 3591963206) strcat(s, "b");
if (crc32("CnsPwHKIeSlB",12) == 2201194867) strcat(s, "o");
if (crc32("WqxhgZwTa",9) == 2092125847) strcat(s, "p");
if (crc32("gnCPdoFvXaTyJxC",15) == 264796915) strcat(s, "u");
if (crc32("YwtUwyVS",8) == 2852554861) strcat(s, "V");
if (crc32("dXNwf",5) == 444762699) strcat(s, "r");
if (crc32("uqWHNaXAfLi",11) == 3382531058) strcat(s, "s");
if (crc32("ThTDpWbNEVwpsng",15) == 3197156052) strcat(s, "l");
if (crc32("KKVUe",5) == 925970365) strcat(s, "i");
if (crc32("vTbXIyplxfLF",12) == 1564310272) strcat(s, "d");
if (crc32("Wgknm",5) == 2888586080) strcat(s, "R");
if (crc32("XTxEq",5) == 2059413728) strcat(s, "e");
    return s;
}

char *nonstoically_adverbs() {
    char *s = calloc(13);
    if (crc32("sVFHIsBWzWTbxph",15) == 1243202410) strcat(s, "T");
if (crc32("FYUhVcoCr",9) == 750137252) strcat(s, "n");
if (crc32("QkKHIMzxYZtTI",13) == 2311049357) strcat(s, "c");
if (crc32("VmnLmIHxu",9) == 822242025) strcat(s, "o");
if (crc32("YyQRIlQfKJXEEFB",15) == 2129136349) strcat(s, "n");
if (crc32("OxOHIRKBdMlDj",13) == 1674573062) strcat(s, "s");
if (crc32("JIHsGXjV",8) == 685984664) strcat(s, "t");
if (crc32("FhEdskxBfuVBeXP",15) == 125233027) strcat(s, "o");
if (crc32("GTSpNpZPPN",10) == 2874390583) strcat(s, "K");
if (crc32("qxFipjsGUrLOV",13) == 2594610264) strcat(s, "i");
if (crc32("pxhxYQn",7) == 4219142515) strcat(s, "c");
if (crc32("XCcpgY",6) == 2315558244) strcat(s, "m");
if (crc32("UXJoszOm",8) == 3111247958) strcat(s, "a");
if (crc32("hUhZUJDq",8) == 1721683055) strcat(s, "C");
if (crc32("zISCw",5) == 3901976692) strcat(s, "l");
if (crc32("xwXsp",5) == 2215586356) strcat(s, "k");
if (crc32("XGUJHJdm",8) == 1030909635) strcat(s, "l");
if (crc32("aEjrMAmfSY",10) == 3633767591) strcat(s, "y");
if (crc32("dqAjRfhGbaw",11) == 645003297) strcat(s, "y");
    return s;
}

char *alternatively_adverbs() {
    char *s = calloc(14);
    if (crc32("ertGpfei",8) == 4148111914) strcat(s, "a");
if (crc32("qKfuRse",7) == 2928503089) strcat(s, "l");
if (crc32("vWqdSGjDFLIZgAO",15) == 405381785) strcat(s, "o");
if (crc32("kiHtoWK",7) == 3766968870) strcat(s, "t");
if (crc32("XYgOJvGmsuJFH",13) == 3197024494) strcat(s, "e");
if (crc32("MibaYzKKd",9) == 3454891697) strcat(s, "r");
if (crc32("YCxbGMndYrnVyp",14) == 3907887208) strcat(s, "A");
if (crc32("lJRNHW",6) == 169363667) strcat(s, "n");
if (crc32("TSFSyCIJDG",10) == 4258073761) strcat(s, "e");
if (crc32("zEHOBBRnu",9) == 3423907856) strcat(s, "a");
if (crc32("qBdxiJCErHpP",12) == 344116268) strcat(s, "t");
if (crc32("lgGXuYyaUyWB",12) == 2329406958) strcat(s, "i");
if (crc32("GyAQtOrNNzJCjFi",15) == 4293480829) strcat(s, "m");
if (crc32("DJgAKduz",8) == 3116359171) strcat(s, "v");
if (crc32("ebakeDy",7) == 3128653504) strcat(s, "e");
if (crc32("tOINjtmlgNCp",12) == 2332664462) strcat(s, "l");
if (crc32("rBxRYNEVGXsTJ",13) == 612733156) strcat(s, "l");
if (crc32("pGvDRs",6) == 678817079) strcat(s, "y");
    return s;
}

char *semidomestically_adverbs() {
    char *s = calloc(17);
    if (crc32("mHWkyJHXRLhAOM",14) == 2980410759) strcat(s, "s");
if (crc32("guOvFjxVIGW",11) == 4111471775) strcat(s, "e");
if (crc32("NSMXIAGAF",9) == 2612175609) strcat(s, "m");
if (crc32("HcBZUxjuQPPzr",13) == 3967907113) strcat(s, "u");
if (crc32("VnbseHdCeDwd",12) == 2216574377) strcat(s, "i");
if (crc32("rzUQo",5) == 1432942797) strcat(s, "d");
if (crc32("aRIMUCCB",8) == 3328334089) strcat(s, "k");
if (crc32("OvhiZ",5) == 730871129) strcat(s, "o");
if (crc32("iNKOSqiuLimauh",14) == 165015960) strcat(s, "m");
if (crc32("jorvG",5) == 2155147871) strcat(s, "M");
if (crc32("PBSywT",6) == 295643954) strcat(s, "e");
if (crc32("LUSLvuR",7) == 1805951520) strcat(s, "s");
if (crc32("FMmjKd",6) == 1181011206) strcat(s, "c");
if (crc32("FgAREOabIsf",11) == 3127068083) strcat(s, "t");
if (crc32("QpHIHOwdupwT",12) == 3954377449) strcat(s, "i");
if (crc32("JoLak",5) == 2034892444) strcat(s, "r");
if (crc32("JuNSJYkxmNi",11) == 334613704) strcat(s, "c");
if (crc32("fMemKBZUc",9) == 573996393) strcat(s, "c");
if (crc32("pOumIWt",7) == 2863480692) strcat(s, "a");
if (crc32("UridbXWKmhPt",12) == 2335830885) strcat(s, "l");
if (crc32("klgDh",5) == 2645448012) strcat(s, "y");
if (crc32("KsifG",5) == 210925962) strcat(s, "l");
if (crc32("bAPxTOHEcxXdX",13) == 3604490041) strcat(s, "y");
    return s;
}

char *unhomogeneously_adverbs() {
    char *s = calloc(16);
    if (crc32("EbUyzPVTpNtGa",13) == 3688358457) strcat(s, "u");
if (crc32("MnuALEaXWqsC",12) == 196507434) strcat(s, "Q");
if (crc32("jzetSRyMen",10) == 3570543529) strcat(s, "n");
if (crc32("oNukt",5) == 634426749) strcat(s, "h");
if (crc32("jKVZzisdxV",10) == 4101734261) strcat(s, "W");
if (crc32("VSplVa",6) == 3892364950) strcat(s, "o");
if (crc32("kVUzhjrJUXrLqQS",15) == 3284348168) strcat(s, "m");
if (crc32("rrspeLhL",8) == 3441796267) strcat(s, "u");
if (crc32("FZTgxy",6) == 3718832270) strcat(s, "o");
if (crc32("AwDTqOBgyD",10) == 2506731678) strcat(s, "g");
if (crc32("hpoJaBNfuL",10) == 1581191662) strcat(s, "V");
if (crc32("CSduZiaJaR",10) == 151663688) strcat(s, "e");
if (crc32("IfrzDhmHmB",10) == 3318848595) strcat(s, "F");
if (crc32("mJtTnRPzHSWphJ",14) == 2842652661) strcat(s, "n");
if (crc32("hxilZdkkipI",11) == 1158640874) strcat(s, "e");
if (crc32("hutsXqKdg",9) == 100358203) strcat(s, "e");
if (crc32("FrDWlVRHEIF",11) == 2364821964) strcat(s, "q");
if (crc32("IKPdhVox",8) == 1608056286) strcat(s, "o");
if (crc32("OBTlrExXQ",9) == 1057131291) strcat(s, "u");
if (crc32("CEjVgrTicHCYPG",14) == 435913982) strcat(s, "U");
if (crc32("BIqwoyknVW",10) == 4162970240) strcat(s, "s");
if (crc32("dURKFfLgbspBk",13) == 3634259682) strcat(s, "l");
if (crc32("fdGiHg",6) == 2842574260) strcat(s, "y");
    return s;
}

char *unmathematically_adverbs() {
    char *s = calloc(17);
    if (crc32("BhhbooweaT",10) == 1287461332) strcat(s, "J");
if (crc32("QpzkbWTtx",9) == 3461050449) strcat(s, "u");
if (crc32("GaXtRddtM",9) == 2782464764) strcat(s, "v");
if (crc32("PwJbW",5) == 3608176023) strcat(s, "n");
if (crc32("GzCdbio",7) == 3850261736) strcat(s, "z");
if (crc32("cnkEKPpxNIlpF",13) == 2216885647) strcat(s, "m");
if (crc32("QzIDLPhtTCBiXUs",15) == 760677312) strcat(s, "a");
if (crc32("ROyGFNhzlKh",11) == 2909273179) strcat(s, "n");
if (crc32("lsESYMSsYXS",11) == 2202334327) strcat(s, "t");
if (crc32("gblCpQWZkc",10) == 999420164) strcat(s, "h");
if (crc32("HUWTOoamOjMWb",13) == 2620387154) strcat(s, "e");
if (crc32("rWLEJsBLGSq",11) == 2460456697) strcat(s, "m");
if (crc32("sZYJMCFNecLdfmd",15) == 3749781562) strcat(s, "k");
if (crc32("tKSmWOhKfOxlX",13) == 3923410267) strcat(s, "a");
if (crc32("xboNtsLbGR",10) == 3883105298) strcat(s, "t");
if (crc32("RKAVqBCdX",9) == 363015159) strcat(s, "i");
if (crc32("WnGtfYQrHpcVs",13) == 1602439656) strcat(s, "t");
if (crc32("mIgwRZHbg",9) == 959886914) strcat(s, "c");
if (crc32("WzQFtLcNLrlPfAj",15) == 939831725) strcat(s, "a");
if (crc32("GoehLCZSkvCFkhA",15) == 3916648561) strcat(s, "l");
if (crc32("XbNqucJpLD",10) == 536625202) strcat(s, "o");
if (crc32("LvYqHcOL",8) == 1730225728) strcat(s, "l");
if (crc32("dpDIUtcFyUwJl",13) == 4255133613) strcat(s, "B");
if (crc32("TJpyr",5) == 3944717488) strcat(s, "y");
    return s;
}

char *selfsustainingly_adverbs() {
    char *s = calloc(17);
    if (crc32("aezroUDqMoa",11) == 3107212427) strcat(s, "s");
if (crc32("HDfbGiKjkaWO",12) == 3095896351) strcat(s, "e");
if (crc32("KNcipjKsSqxOD",13) == 3793121252) strcat(s, "l");
if (crc32("DaWvGWOLBY",10) == 502895762) strcat(s, "f");
if (crc32("WWOVrXTADb",10) == 2249692946) strcat(s, "N");
if (crc32("BpGNRppq",8) == 715424011) strcat(s, "s");
if (crc32("vqHDibUtyiNacR",14) == 2250338972) strcat(s, "c");
if (crc32("VYqZQiLj",8) == 937922661) strcat(s, "u");
if (crc32("LBOjWKIekQpZU",13) == 1212468621) strcat(s, "g");
if (crc32("YouzKYrxX",9) == 1776238537) strcat(s, "s");
if (crc32("krrUkEGATZADcv",14) == 863571349) strcat(s, "t");
if (crc32("hujgDNE",7) == 2734154514) strcat(s, "A");
if (crc32("BMeOKXGcHeCTb",13) == 2355056261) strcat(s, "a");
if (crc32("ZiYhVc",6) == 1080987534) strcat(s, "i");
if (crc32("YbvQGVNCJKmiVUM",15) == 594509390) strcat(s, "k");
if (crc32("cxJNKdoOzPDMMSU",15) == 795540092) strcat(s, "n");
if (crc32("TMKZctOfrmJOZ",13) == 3653407178) strcat(s, "i");
if (crc32("CvGcFnQ",7) == 2581242399) strcat(s, "S");
if (crc32("bLYSJcBWSyM",11) == 1618575033) strcat(s, "n");
if (crc32("iNEnGNRUKMPQ",12) == 2994464195) strcat(s, "g");
if (crc32("QlSdVwSSNuucj",13) == 2912684186) strcat(s, "p");
if (crc32("PDNqXdDFkZXKCY",14) == 3879707379) strcat(s, "l");
if (crc32("rpTJoFcpNrm",11) == 1924153403) strcat(s, "O");
if (crc32("IOWabmZWvgWl",12) == 1858394205) strcat(s, "y");
    return s;
}

char *derisively_adverbs() {
    char *s = calloc(11);
    if (crc32("lLZddetM",8) == 3980659665) strcat(s, "W");
if (crc32("nCyfeInse",9) == 3198829675) strcat(s, "d");
if (crc32("iKXojwaEOupR",12) == 350252508) strcat(s, "m");
if (crc32("gFDiPBliz",9) == 3798604196) strcat(s, "e");
if (crc32("jwKfqi",6) == 1928186219) strcat(s, "h");
if (crc32("JyjmArZLLCVhUf",14) == 1650935117) strcat(s, "r");
if (crc32("wsxfwiYnHVKwBVt",15) == 3968320694) strcat(s, "N");
if (crc32("TIAjkX",6) == 4134521726) strcat(s, "i");
if (crc32("KULtGpXneXmPqN",14) == 2802166865) strcat(s, "q");
if (crc32("sBfxMdXhAeQaj",13) == 3549980329) strcat(s, "s");
if (crc32("FHlrJmhtYyipisR",15) == 1846506043) strcat(s, "L");
if (crc32("vNaenSSAcJSQl",13) == 1358423874) strcat(s, "i");
if (crc32("qqFChiAWhqZAo",13) == 1759825191) strcat(s, "v");
if (crc32("EjSFZbBnQjovSru",15) == 1262144804) strcat(s, "e");
if (crc32("uMlPse",6) == 1858631872) strcat(s, "l");
if (crc32("kZjLfZ",6) == 877698648) strcat(s, "y");
    return s;
}

char *preeditorially_adverbs() {
    char *s = calloc(15);
    if (crc32("fNylqKhnq",9) == 3787386334) strcat(s, "p");
if (crc32("fSNIAPEvgB",10) == 736622260) strcat(s, "r");
if (crc32("OPtSawFnqxdhoxA",15) == 685614558) strcat(s, "e");
if (crc32("dINzgWPaCRfho",13) == 3029824909) strcat(s, "a");
if (crc32("NcLNl",5) == 1527542404) strcat(s, "e");
if (crc32("lwVPhjwTfOnY",12) == 1022502499) strcat(s, "d");
if (crc32("KggJPQVF",8) == 2371574241) strcat(s, "i");
if (crc32("AZHqdTwR",8) == 451138380) strcat(s, "t");
if (crc32("fmfBNzeMhn",10) == 2733347070) strcat(s, "o");
if (crc32("RsyLsXvQSI",10) == 2677597092) strcat(s, "r");
if (crc32("fSEuTvJb",8) == 2986695411) strcat(s, "i");
if (crc32("xxLvxfiupWzZI",13) == 1271155611) strcat(s, "a");
if (crc32("EfgXZggsglLHTzV",15) == 1851361740) strcat(s, "l");
if (crc32("MSZtKPaNf",9) == 922565611) strcat(s, "V");
if (crc32("fqcRzy",6) == 293568076) strcat(s, "l");
if (crc32("eaKmhWczxMUJ",12) == 2780765706) strcat(s, "q");
if (crc32("SdMXGAUT",8) == 2793825677) strcat(s, "y");
    return s;
}

char *nonnautically_adverbs() {
    char *s = calloc(14);
    if (crc32("bVwNFy",6) == 1086008429) strcat(s, "n");
if (crc32("vZwxJXhkLa",10) == 74318923) strcat(s, "J");
if (crc32("kyqfEPsYz",9) == 3381839385) strcat(s, "o");
if (crc32("mIaLBCSj",8) == 3737392864) strcat(s, "n");
if (crc32("LjSQOCApVKaWHt",14) == 2368340485) strcat(s, "n");
if (crc32("JSOez",5) == 2420444373) strcat(s, "j");
if (crc32("LlydiJELgM",10) == 3684572473) strcat(s, "a");
if (crc32("EAPTqJBivURyKrW",15) == 1775239870) strcat(s, "N");
if (crc32("nCyLdPGKU",9) == 238461606) strcat(s, "u");
if (crc32("GgbnjRSEpUvAOf",14) == 3473602467) strcat(s, "X");
if (crc32("FKwGkqRYQ",9) == 564697325) strcat(s, "t");
if (crc32("YZjRRaq",7) == 7213532) strcat(s, "i");
if (crc32("ppXoEKeydp",10) == 1755808690) strcat(s, "c");
if (crc32("sSbSBUfBK",9) == 3544633018) strcat(s, "a");
if (crc32("NLpYe",5) == 299396526) strcat(s, "o");
if (crc32("XuBeTKhprXp",11) == 3567253322) strcat(s, "l");
if (crc32("xXjNEwNl",8) == 2475401642) strcat(s, "l");
if (crc32("WZKCjNXJwkRH",12) == 3439526252) strcat(s, "y");
    return s;
}

char *doubtingly_adverbs() {
    char *s = calloc(11);
    if (crc32("imvPbTAburI",11) == 2367803055) strcat(s, "d");
if (crc32("OgLTFrFKdwUZmrz",15) == 2106577957) strcat(s, "o");
if (crc32("UsHmXpSPRiXkjYN",15) == 1254850158) strcat(s, "v");
if (crc32("IsnQwd",6) == 3150048991) strcat(s, "u");
if (crc32("HIZSXcWvZ",9) == 49685151) strcat(s, "b");
if (crc32("pgMnMPXHyNQua",13) == 2408795270) strcat(s, "H");
if (crc32("acPoKTbtHLyGbt",14) == 1380176691) strcat(s, "t");
if (crc32("yPlWPCuj",8) == 1544570346) strcat(s, "B");
if (crc32("tjTcb",5) == 405936137) strcat(s, "i");
if (crc32("OhzxypCzo",9) == 2931400625) strcat(s, "n");
if (crc32("uyzBPKHjLvrR",12) == 1764593486) strcat(s, "g");
if (crc32("THsFabsNZJ",10) == 60357259) strcat(s, "k");
if (crc32("NtnTqIrMxBIIPH",14) == 376091697) strcat(s, "l");
if (crc32("eWsAqRLqNpKX",12) == 3773136362) strcat(s, "q");
if (crc32("xJZaGIOVOdSEdq",14) == 1835013311) strcat(s, "y");
    return s;
}

char *fumblingly_adverbs() {
    char *s = calloc(11);
    if (crc32("DYyQnSoEK",9) == 1091380935) strcat(s, "f");
if (crc32("bUXaTIBTu",9) == 4242604528) strcat(s, "u");
if (crc32("OWOjUBYrCa",10) == 543999321) strcat(s, "F");
if (crc32("ToMlScDJCdaXWgj",15) == 2624386886) strcat(s, "m");
if (crc32("PEMtv",5) == 3633112753) strcat(s, "b");
if (crc32("usiCHVdOvmNE",12) == 802434155) strcat(s, "Y");
if (crc32("wXjjtAlIoCnGgPA",15) == 957923811) strcat(s, "l");
if (crc32("WUJmaGeubx",10) == 2887190393) strcat(s, "i");
if (crc32("LFudK",5) == 1476123060) strcat(s, "n");
if (crc32("PeWdMFytnM",10) == 1735582042) strcat(s, "T");
if (crc32("GCpyNB",6) == 2063272090) strcat(s, "g");
if (crc32("NVnkvgYmX",9) == 2434890349) strcat(s, "d");
if (crc32("uXtkg",5) == 4287511028) strcat(s, "l");
if (crc32("KcvWGPB",7) == 3817936544) strcat(s, "C");
if (crc32("AmWVPonvoLYK",12) == 3990166137) strcat(s, "y");
    return s;
}

char *inhumanely_adverbs() {
    char *s = calloc(11);
    if (crc32("nZdyjqEB",8) == 1412798999) strcat(s, "i");
if (crc32("lWCXcZyM",8) == 1842692671) strcat(s, "V");
if (crc32("kJoEGfkDBd",10) == 2311230272) strcat(s, "n");
if (crc32("aPYKSxqu",8) == 3406164540) strcat(s, "h");
if (crc32("bvlMfIjp",8) == 960798292) strcat(s, "H");
if (crc32("LbqRehffxRtxYQ",14) == 167411520) strcat(s, "u");
if (crc32("JMHbOTn",7) == 3637145352) strcat(s, "a");
if (crc32("lUzPMthHuC",10) == 2361601518) strcat(s, "m");
if (crc32("upuTsPDwTacSgcp",15) == 732637742) strcat(s, "a");
if (crc32("MWRSDhzVzAQxYK",14) == 1179500805) strcat(s, "S");
if (crc32("iwlEj",5) == 3310123846) strcat(s, "n");
if (crc32("tiEhnsGfx",9) == 827490874) strcat(s, "e");
if (crc32("OoNzzHAczhDjFQ",14) == 173982503) strcat(s, "X");
if (crc32("LkiAZlaMuv",10) == 1975727086) strcat(s, "l");
if (crc32("eatsGenFrjXkJs",14) == 3738007674) strcat(s, "y");
    return s;
}

char *nonassertively_adverbs() {
    char *s = calloc(15);
    if (crc32("OiKVHZOBEFnGnE",14) == 3565433181) strcat(s, "F");
if (crc32("Bqjllbs",7) == 4093532666) strcat(s, "n");
if (crc32("zgjspw",6) == 4187975175) strcat(s, "m");
if (crc32("cFLPvQJhbHYwdcd",15) == 1498201020) strcat(s, "o");
if (crc32("uYebNNklCYdHs",13) == 906509325) strcat(s, "n");
if (crc32("OqwOcvfwDAWIom",14) == 2025407916) strcat(s, "d");
if (crc32("aRiyjqyVBmvx",12) == 1608595180) strcat(s, "a");
if (crc32("SjOAEjL",7) == 4135535515) strcat(s, "X");
if (crc32("CWuAWOO",7) == 334491596) strcat(s, "s");
if (crc32("EqMXGSNswrDm",12) == 891900573) strcat(s, "Z");
if (crc32("RmRPBbt",7) == 1731153347) strcat(s, "s");
if (crc32("KzvySGUAsJrZ",12) == 1880861730) strcat(s, "e");
if (crc32("yWxDprztvPYeJ",13) == 1023341151) strcat(s, "E");
if (crc32("qKORoyBGLMb",11) == 3465656021) strcat(s, "r");
if (crc32("liVRerpQT",9) == 3062362206) strcat(s, "j");
if (crc32("mQnxSOEC",8) == 2425851135) strcat(s, "t");
if (crc32("rvprGWtkeXqm",12) == 629190170) strcat(s, "y");
if (crc32("bNLCTbNRXLA",11) == 1461833960) strcat(s, "i");
if (crc32("ySafntZqeuTuhD",14) == 1646799783) strcat(s, "q");
if (crc32("ZxTEXUlSaqzv",12) == 2151032035) strcat(s, "v");
if (crc32("lMOVWFWn",8) == 4091198803) strcat(s, "e");
if (crc32("WZIFJDiwmPSI",12) == 1954325098) strcat(s, "B");
if (crc32("RaKEev",6) == 3481177438) strcat(s, "l");
if (crc32("mdxzSju",7) == 702932976) strcat(s, "E");
if (crc32("tKwTW",5) == 4228074748) strcat(s, "y");
    return s;
}

char *noncharitably_adverbs() {
    char *s = calloc(14);
    if (crc32("MiixeKzZheEX",12) == 3324269707) strcat(s, "n");
if (crc32("tfTUKORzfF",10) == 352820980) strcat(s, "S");
if (crc32("jYkCrlbvbSDpto",14) == 2934947725) strcat(s, "o");
if (crc32("CDovjsdKW",9) == 2858135760) strcat(s, "b");
if (crc32("wUgHJMdRCAswn",13) == 4278854308) strcat(s, "n");
if (crc32("hfqEsTj",7) == 315587051) strcat(s, "C");
if (crc32("SVpsSkb",7) == 2660305650) strcat(s, "c");
if (crc32("qawBY",5) == 4985862) strcat(s, "h");
if (crc32("TAKFzD",6) == 3911943668) strcat(s, "c");
if (crc32("zrukYHxHTxwFS",13) == 2671643941) strcat(s, "a");
if (crc32("opEkzGu",7) == 1292876919) strcat(s, "L");
if (crc32("sWvzSUdWR",9) == 3924035819) strcat(s, "r");
if (crc32("RisLMLAKwqMHVG",14) == 114449169) strcat(s, "W");
if (crc32("KjqlFDJHG",9) == 2686212626) strcat(s, "i");
if (crc32("rzzgZixRWTjiOTh",15) == 2452579547) strcat(s, "v");
if (crc32("JmOSDPHMhBNT",12) == 1555374882) strcat(s, "t");
if (crc32("rkxXaBI",7) == 3743649888) strcat(s, "X");
if (crc32("jvpfKnMiVdTTK",13) == 378421577) strcat(s, "a");
if (crc32("DEHGUCNs",8) == 3355292079) strcat(s, "V");
if (crc32("TfhcxEvhLh",10) == 2768998194) strcat(s, "b");
if (crc32("HhsdnDZZTbR",11) == 2029757548) strcat(s, "l");
if (crc32("bHWPQermYN",10) == 1689186390) strcat(s, "E");
if (crc32("Fuzvz",5) == 3718488462) strcat(s, "y");
    return s;
}

char *subimbricately_adverbs() {
    char *s = calloc(15);
    if (crc32("BfZQrzhdnLfDgn",14) == 492164889) strcat(s, "s");
if (crc32("grldCtlNJspsY",13) == 2179509346) strcat(s, "R");
if (crc32("RkXPczn",7) == 3174103947) strcat(s, "u");
if (crc32("zzhGAquhamMN",12) == 2200679664) strcat(s, "I");
if (crc32("TPiQMhUNLV",10) == 699848717) strcat(s, "b");
if (crc32("OKJbKRRCx",9) == 2449945538) strcat(s, "i");
if (crc32("ChyhudaWgQeeWSB",15) == 3227551229) strcat(s, "i");
if (crc32("NvJEdTJwKvEVGF",14) == 2912042633) strcat(s, "m");
if (crc32("ajGJB",5) == 733511158) strcat(s, "Q");
if (crc32("qBDDIFugGgcFkf",14) == 225123481) strcat(s, "b");
if (crc32("noNilmhhguDdSD",14) == 257502210) strcat(s, "r");
if (crc32("vPwXXhfshUxLgb",14) == 2484119706) strcat(s, "i");
if (crc32("JXrvOtYpsssAqU",14) == 2135363448) strcat(s, "L");
if (crc32("FTJAP",5) == 2868569511) strcat(s, "c");
if (crc32("SkaKIuEYRZqbcRQ",15) == 3908952171) strcat(s, "a");
if (crc32("sllaqJ",6) == 4169026837) strcat(s, "t");
if (crc32("cmDTWpCo",8) == 922610421) strcat(s, "T");
if (crc32("dslfZk",6) == 994804951) strcat(s, "e");
if (crc32("eFRLVDiD",8) == 1523322180) strcat(s, "l");
if (crc32("UxyhsjsxICbmgP",14) == 1334325258) strcat(s, "y");
    return s;
}

char *overeffusively_adverbs() {
    char *s = calloc(15);
    if (crc32("ogTXvgD",7) == 1758757169) strcat(s, "b");
if (crc32("GYDKBCfcqfR",11) == 2687804606) strcat(s, "o");
if (crc32("lhGdHNMGksYxP",13) == 2219324929) strcat(s, "v");
if (crc32("sLlrdcnWY",9) == 3063878646) strcat(s, "J");
if (crc32("iXRZmcUbynHUKKw",15) == 1035039902) strcat(s, "e");
if (crc32("wVYfm",5) == 8347463) strcat(s, "r");
if (crc32("KnhjcejOAOfVBNd",15) == 3227827485) strcat(s, "G");
if (crc32("eTbUzRIeYPycr",13) == 3665946185) strcat(s, "e");
if (crc32("SdJTy",5) == 2390890793) strcat(s, "V");
if (crc32("hOGKhAgPmhBbo",13) == 2795588618) strcat(s, "f");
if (crc32("NLkisrSsKA",10) == 1527597024) strcat(s, "f");
if (crc32("GcmeEZo",7) == 351460236) strcat(s, "u");
if (crc32("MYGVLMJJ",8) == 2366709754) strcat(s, "p");
if (crc32("GOEzq",5) == 1795531986) strcat(s, "s");
if (crc32("bZaMQA",6) == 4132356191) strcat(s, "I");
if (crc32("GxAmAQ",6) == 4237576308) strcat(s, "i");
if (crc32("ImncS",5) == 3089092886) strcat(s, "V");
if (crc32("OlrfPdRtq",9) == 1241704656) strcat(s, "v");
if (crc32("HASAScdB",8) == 6688455) strcat(s, "D");
if (crc32("DTXMAhpqizgDKve",15) == 2727915821) strcat(s, "e");
if (crc32("HfKINLMUCKWt",12) == 1254453134) strcat(s, "l");
if (crc32("DXcYse",6) == 2739606723) strcat(s, "k");
if (crc32("VLMZSmgQYmSNt",13) == 38646517) strcat(s, "y");
    return s;
}

char *unscandalously_adverbs() {
    char *s = calloc(15);
    if (crc32("pETgYSW",7) == 1230192790) strcat(s, "O");
if (crc32("MvVKgny",7) == 28480088) strcat(s, "u");
if (crc32("wdyCGRiQxY",10) == 3488803607) strcat(s, "I");
if (crc32("OvsLXm",6) == 2016787738) strcat(s, "n");
if (crc32("rwavEZIZnaaYr",13) == 4204390204) strcat(s, "s");
if (crc32("wfxNWfI",7) == 1299842468) strcat(s, "n");
if (crc32("kNRxMgHftn",10) == 2133762193) strcat(s, "c");
if (crc32("oaLnjlNz",8) == 241517637) strcat(s, "w");
if (crc32("ApAJGkQURlZyl",13) == 3541690304) strcat(s, "a");
if (crc32("hJkgmtVSwf",10) == 775103453) strcat(s, "F");
if (crc32("gGzZhEK",7) == 4231412137) strcat(s, "n");
if (crc32("AYmbfjQi",8) == 2902710807) strcat(s, "d");
if (crc32("zToUVcVaGlc",11) == 3412306438) strcat(s, "a");
if (crc32("jwAZiKwhmXqqUvm",15) == 1672136174) strcat(s, "p");
if (crc32("bLsSwEOdd",9) == 1787072270) strcat(s, "l");
if (crc32("pmbht",5) == 4037532481) strcat(s, "e");
if (crc32("ZPkXDSW",7) == 3843485629) strcat(s, "o");
if (crc32("znrImWf",7) == 2476789156) strcat(s, "u");
if (crc32("QyTbhLREfuLPPwf",15) == 3071193289) strcat(s, "s");
if (crc32("dyDtmwUKP",9) == 4055191736) strcat(s, "l");
if (crc32("OVcUQzXFOHp",11) == 3913964868) strcat(s, "e");
if (crc32("PNBNHYZimNOI",12) == 4045721593) strcat(s, "y");
    return s;
}

char *bioecologically_adverbs() {
    char *s = calloc(16);
    if (crc32("mRospGZV",8) == 416746664) strcat(s, "B");
if (crc32("gaCQzatAhWzNcv",14) == 2461191091) strcat(s, "b");
if (crc32("RuACbwCJASeoBQ",14) == 2016871266) strcat(s, "i");
if (crc32("jNyEyqYoDHeHFce",15) == 4254983488) strcat(s, "o");
if (crc32("VfAwWLfhuVYaYYU",15) == 88434407) strcat(s, "k");
if (crc32("eIeEZGBbxZKfyt",14) == 2876181140) strcat(s, "e");
if (crc32("CjNzwJRYUlUqD",13) == 690939217) strcat(s, "c");
if (crc32("kDbpQyVBlrPxxIG",15) == 2414932831) strcat(s, "c");
if (crc32("XeLba",5) == 3038415467) strcat(s, "t");
if (crc32("PtgAhUu",7) == 2279037729) strcat(s, "o");
if (crc32("FRWOwuICpZ",10) == 3598597850) strcat(s, "l");
if (crc32("FcDsInpsqH",10) == 409583961) strcat(s, "o");
if (crc32("sPSlGJgJPcy",11) == 3143286262) strcat(s, "W");
if (crc32("MVAPHyXEmj",10) == 1567688747) strcat(s, "g");
if (crc32("LnOnClBAXDn",11) == 1629582540) strcat(s, "W");
if (crc32("sIHlPrgXJsP",11) == 3724936997) strcat(s, "i");
if (crc32("lyIvPIBzpb",10) == 1890513836) strcat(s, "c");
if (crc32("bEUjcH",6) == 3953760363) strcat(s, "a");
if (crc32("GzoQGLVThnZ",11) == 1405571801) strcat(s, "l");
if (crc32("QbJTgAbFW",9) == 287547917) strcat(s, "v");
if (crc32("PqrdTncmnJxp",12) == 2130811445) strcat(s, "l");
if (crc32("DgrETnFsDWoWJCK",15) == 789738958) strcat(s, "y");
    return s;
}

char *universally_adverbs() {
    char *s = calloc(12);
    if (crc32("hccbHryRXpgnRz",14) == 2408968079) strcat(s, "O");
if (crc32("xWmpnffcPMHlycS",15) == 4041284089) strcat(s, "u");
if (crc32("jLGik",5) == 1470737753) strcat(s, "Z");
if (crc32("HPVDpAvB",8) == 821773122) strcat(s, "n");
if (crc32("hdkDgByKmefzCe",14) == 3984018746) strcat(s, "i");
if (crc32("HmzLxPRqrwKiL",13) == 1845863668) strcat(s, "v");
if (crc32("CUEXfHlsgeJZ",12) == 1295639435) strcat(s, "e");
if (crc32("RkmTfGXsqwov",12) == 3279840313) strcat(s, "r");
if (crc32("QNhciX",6) == 718598950) strcat(s, "q");
if (crc32("ZKsUdPFbBqEWJZq",15) == 973435716) strcat(s, "s");
if (crc32("UxEsEk",6) == 3067856495) strcat(s, "S");
if (crc32("TRQYz",5) == 3697435527) strcat(s, "a");
if (crc32("iAvAR",5) == 1305708295) strcat(s, "l");
if (crc32("UCcLXg",6) == 58004880) strcat(s, "l");
if (crc32("TbVHmyJVQSsT",12) == 2470418083) strcat(s, "T");
if (crc32("mDzbvuqPtpQrvy",14) == 1312316433) strcat(s, "y");
    return s;
}

char *overlewdly_adverbs() {
    char *s = calloc(11);
    if (crc32("fBkHxRl",7) == 296947717) strcat(s, "o");
if (crc32("VCyqmGUl",8) == 592256871) strcat(s, "E");
if (crc32("VSXPijWzFqCT",12) == 2412503515) strcat(s, "v");
if (crc32("sjNqI",5) == 919271769) strcat(s, "u");
if (crc32("HfhLrAgRUqZ",11) == 1618256342) strcat(s, "e");
if (crc32("RTUREYhrJCMhn",13) == 696682093) strcat(s, "r");
if (crc32("VbkhlKDVbzHX",12) == 1072720260) strcat(s, "o");
if (crc32("TtezGGB",7) == 3710552051) strcat(s, "l");
if (crc32("qTUgQZwNhnGQKO",14) == 3978478160) strcat(s, "e");
if (crc32("myFdK",5) == 3470495654) strcat(s, "x");
if (crc32("GCLHqwMRdYQ",11) == 2251518428) strcat(s, "w");
if (crc32("xXivJQrlaRh",11) == 1222645460) strcat(s, "d");
if (crc32("IRcNVFUDms",10) == 972215393) strcat(s, "r");
if (crc32("qaySZDxgEAhNQma",15) == 336717903) strcat(s, "l");
if (crc32("AlWrKP",6) == 2763707689) strcat(s, "v");
if (crc32("bfGCy",5) == 3167041012) strcat(s, "y");
    return s;
}

char *backoBourke_adverbs() {
    char *s = calloc(12);
    if (crc32("TJBRjUQfzWh",11) == 1246845997) strcat(s, "b");
if (crc32("vOXUpcaPwmQz",12) == 3299389439) strcat(s, "X");
if (crc32("GqFdmqLcTOTED",13) == 3479660429) strcat(s, "a");
if (crc32("Cxntj",5) == 3548876649) strcat(s, "c");
if (crc32("clrfNP",6) == 3952978657) strcat(s, "k");
if (crc32("ixdBDTGeiRWVlWF",15) == 3362678207) strcat(s, "m");
if (crc32("RrFWSGt",7) == 1745874390) strcat(s, "o");
if (crc32("GmpIsgVx",8) == 1962401610) strcat(s, "B");
if (crc32("KFIpJFAlRhjK",12) == 3360256741) strcat(s, "o");
if (crc32("cFnMGVtAvSIRi",13) == 1035482711) strcat(s, "s");
if (crc32("VXlHrdEH",8) == 2315593560) strcat(s, "u");
if (crc32("wtpuebb",7) == 3846432253) strcat(s, "N");
if (crc32("ZzaKWqa",7) == 1029040045) strcat(s, "r");
if (crc32("CnJVOgDuCWYDX",13) == 2773633155) strcat(s, "k");
if (crc32("nwBghnvuz",9) == 1848995018) strcat(s, "Z");
if (crc32("ZOxNqZBzAJlHmU",14) == 3610852212) strcat(s, "e");
    return s;
}

char *nonusuriously_adverbs() {
    char *s = calloc(14);
    if (crc32("ZYDfWExGr",9) == 1490927976) strcat(s, "n");
if (crc32("jIgbXwlQW",9) == 4216495169) strcat(s, "o");
if (crc32("lzVyrBXpOTpHtAG",15) == 2998573423) strcat(s, "M");
if (crc32("cCAIirLDF",9) == 3386912387) strcat(s, "n");
if (crc32("HmLSJAGUKcUZDy",14) == 3075213024) strcat(s, "u");
if (crc32("UkpOckK",7) == 2575372638) strcat(s, "s");
if (crc32("klOjIgxB",8) == 1569295120) strcat(s, "u");
if (crc32("xrqYGggywiAA",12) == 3985285335) strcat(s, "r");
if (crc32("Rjnpi",5) == 2305964785) strcat(s, "i");
if (crc32("GQvwKOtrzr",10) == 2480948255) strcat(s, "R");
if (crc32("SDJbcuTngzAttj",14) == 2684347221) strcat(s, "o");
if (crc32("vmEhpwadQToRvwD",15) == 4170989220) strcat(s, "P");
if (crc32("UcnBfCbaei",10) == 4203501725) strcat(s, "u");
if (crc32("njcYZn",6) == 4028503094) strcat(s, "s");
if (crc32("WvLXs",5) == 1078013131) strcat(s, "i");
if (crc32("uJunbfWaeIjOEhm",15) == 3226943871) strcat(s, "l");
if (crc32("UMbCkQSQGJflB",13) == 2828282309) strcat(s, "C");
if (crc32("sXErsrabBD",10) == 1483166702) strcat(s, "y");
    return s;
}

char *axiomatically_adverbs() {
    char *s = calloc(14);
    if (crc32("FLLtbCGTg",9) == 438733686) strcat(s, "F");
if (crc32("bdMOLu",6) == 4132901336) strcat(s, "a");
if (crc32("VuElDLNTi",9) == 1412481786) strcat(s, "S");
if (crc32("gVqHzQVaDUTgrbY",15) == 1108795446) strcat(s, "x");
if (crc32("uusGHQSwhmKB",12) == 1681183327) strcat(s, "i");
if (crc32("GwXZYiQEhl",10) == 1341079881) strcat(s, "s");
if (crc32("bTKBLDvugxetKdu",15) == 3892626989) strcat(s, "o");
if (crc32("NwvNEDNDVVBDKn",14) == 912529015) strcat(s, "m");
if (crc32("HbGsNBp",7) == 168221322) strcat(s, "W");
if (crc32("PHvjqNKlajjt",12) == 1510772093) strcat(s, "a");
if (crc32("LgpmO",5) == 1236831820) strcat(s, "P");
if (crc32("BsrVBQVjUPbH",12) == 1800733849) strcat(s, "t");
if (crc32("RRbsZCDMXE",10) == 78159358) strcat(s, "T");
if (crc32("fwecFYtwkMqyNA",14) == 1924544874) strcat(s, "i");
if (crc32("faAnwSpPuQ",10) == 1363016568) strcat(s, "l");
if (crc32("dudXgtSbnQBBGl",14) == 3716041909) strcat(s, "c");
if (crc32("pmiTwSmY",8) == 4247585315) strcat(s, "Y");
if (crc32("rzYDzrIhq",9) == 2691764360) strcat(s, "a");
if (crc32("DqyICeERyjPzhY",14) == 92583449) strcat(s, "z");
if (crc32("DmmBtrECebAvL",13) == 2933721434) strcat(s, "l");
if (crc32("DRBGNyMnzhT",11) == 3087841952) strcat(s, "l");
if (crc32("HdoLPDSXI",9) == 1383212729) strcat(s, "t");
if (crc32("xwmDn",5) == 2272811547) strcat(s, "y");
    return s;
}

char *acrobatically_adverbs() {
    char *s = calloc(14);
    if (crc32("bMkXwfOoWxwR",12) == 5313680) strcat(s, "a");
if (crc32("nfvNiLmihBOPqk",14) == 2989343559) strcat(s, "c");
if (crc32("yHMBEDkIQbKXBpd",15) == 2364274317) strcat(s, "V");
if (crc32("rkzTwiEwktnQAh",14) == 3952135644) strcat(s, "r");
if (crc32("GnltuiXwiXUFrCf",15) == 662535816) strcat(s, "o");
if (crc32("Bfnswxr",7) == 236143040) strcat(s, "T");
if (crc32("oolrlt",6) == 3953629627) strcat(s, "b");
if (crc32("UtUPZzpdjqcA",12) == 424945213) strcat(s, "a");
if (crc32("mGivOJUYPZj",11) == 3450332867) strcat(s, "t");
if (crc32("rOENuUXxHLWhJLW",15) == 3736225291) strcat(s, "i");
if (crc32("SJLSmjxqytG",11) == 3170117476) strcat(s, "t");
if (crc32("lqBuiD",6) == 2901395607) strcat(s, "c");
if (crc32("IhWRJKYpEi",10) == 3109332479) strcat(s, "V");
if (crc32("KEHGQldOjCxSwo",14) == 2010770385) strcat(s, "a");
if (crc32("gLEIHdJoy",9) == 4096518945) strcat(s, "l");
if (crc32("sVtGt",5) == 2215820355) strcat(s, "m");
if (crc32("JrKMEODBL",9) == 802728345) strcat(s, "l");
if (crc32("JvDJcYIGIPmyCdq",15) == 3156333176) strcat(s, "D");
if (crc32("LImNSl",6) == 4200725884) strcat(s, "y");
    return s;
}

char *incogitantly_adverbs() {
    char *s = calloc(13);
    if (crc32("QZrnfuxmyFJjh",13) == 562980328) strcat(s, "i");
if (crc32("rabZlcQJ",8) == 2680262327) strcat(s, "i");
if (crc32("KUczGRA",7) == 3555537147) strcat(s, "S");
if (crc32("EBPjmsgidn",10) == 1374237708) strcat(s, "n");
if (crc32("apfgi",5) == 133952472) strcat(s, "Z");
if (crc32("XNdLLRkbI",9) == 4105773903) strcat(s, "c");
if (crc32("VSGaZpnGMqxNS",13) == 3538087071) strcat(s, "K");
if (crc32("chpqnGEOZUsujAn",15) == 456041074) strcat(s, "o");
if (crc32("FNEWa",5) == 3544490124) strcat(s, "g");
if (crc32("ckMIAlFQNHmrbAc",15) == 3229519574) strcat(s, "T");
if (crc32("vramgsmrMyUGH",13) == 3307030700) strcat(s, "i");
if (crc32("uMGxadFYrtie",12) == 3998177607) strcat(s, "G");
if (crc32("iJFbsosNKh",10) == 3013678876) strcat(s, "t");
if (crc32("DnumJmBjt",9) == 4099778202) strcat(s, "r");
if (crc32("keEMHJkz",8) == 3685700971) strcat(s, "a");
if (crc32("gyUNKGDzGbYz",12) == 2949947050) strcat(s, "n");
if (crc32("uJTDCC",6) == 1681419000) strcat(s, "J");
if (crc32("ImHgfAJQf",9) == 4066708927) strcat(s, "t");
if (crc32("bqwZZBYQNfgos",13) == 2518339178) strcat(s, "p");
if (crc32("YDQoOfDNxG",10) == 1222060690) strcat(s, "l");
if (crc32("PblrhSU",7) == 3058268153) strcat(s, "L");
if (crc32("rkadKKAutgRHI",13) == 2798797877) strcat(s, "y");
    return s;
}

char *hermeneutically_adverbs() {
    char *s = calloc(16);
    if (crc32("tskOCjMFzR",10) == 4250324193) strcat(s, "h");
if (crc32("JWStgikr",8) == 1689286474) strcat(s, "e");
if (crc32("BfkpDVdby",9) == 4037250683) strcat(s, "r");
if (crc32("FXQEQLWphD",10) == 2993946638) strcat(s, "m");
if (crc32("RzztrAgzgGT",11) == 1403447225) strcat(s, "E");
if (crc32("OfIXacck",8) == 7785714) strcat(s, "e");
if (crc32("oCxXtVfCGKzVO",13) == 631644246) strcat(s, "n");
if (crc32("BQnpMf",6) == 2553278970) strcat(s, "e");
if (crc32("BMisyJqKnF",10) == 2984194344) strcat(s, "u");
if (crc32("hUxylWraKaHYd",13) == 1307565420) strcat(s, "C");
if (crc32("BtrrQwbdLvMh",12) == 3679599075) strcat(s, "t");
if (crc32("KSSIQHsGp",9) == 3109305729) strcat(s, "i");
if (crc32("UcdfYL",6) == 145642616) strcat(s, "W");
if (crc32("vNNwphesGMFJm",13) == 891684458) strcat(s, "c");
if (crc32("IBkyIqPRqontYN",14) == 4063360396) strcat(s, "a");
if (crc32("gzYyPhMEPcK",11) == 2753779136) strcat(s, "N");
if (crc32("YIFADVtY",8) == 1743345516) strcat(s, "l");
if (crc32("DOdBcZAy",8) == 1138955484) strcat(s, "l");
if (crc32("TtjatMU",7) == 819350555) strcat(s, "E");
if (crc32("jOTWJRUJjcChIDw",15) == 148443272) strcat(s, "y");
    return s;
}

char *abysmally_adverbs() {
    char *s = calloc(10);
    if (crc32("kXaIjEN",7) == 3177423469) strcat(s, "T");
if (crc32("mKjuhdRJJhOdGlP",15) == 2215129340) strcat(s, "a");
if (crc32("yYiCKdstTUBO",12) == 2348156118) strcat(s, "b");
if (crc32("tMRjjlBDaRg",11) == 1628326898) strcat(s, "j");
if (crc32("dSaxhBNhGamvAsT",15) == 2757785872) strcat(s, "y");
if (crc32("kSiVKzxKbtjVSvJ",15) == 1362484980) strcat(s, "s");
if (crc32("XjegJMSLWxpWmTO",15) == 4213496248) strcat(s, "p");
if (crc32("gVjXQISPdRSEIB",14) == 2322703170) strcat(s, "m");
if (crc32("usyzC",5) == 4022289753) strcat(s, "a");
if (crc32("bwSRCUvH",8) == 4103266807) strcat(s, "j");
if (crc32("HffaSMDHUixdL",13) == 2434658239) strcat(s, "l");
if (crc32("JkTmYR",6) == 1713142758) strcat(s, "v");
if (crc32("iBGXzjmtSB",10) == 3887431771) strcat(s, "l");
if (crc32("dBdFdIg",7) == 3698506001) strcat(s, "q");
if (crc32("smDLpVWtV",9) == 453707038) strcat(s, "y");
    return s;
}

char *quasivalidly_adverbs() {
    char *s = calloc(13);
    if (crc32("nLEfKYi",7) == 2482569463) strcat(s, "q");
if (crc32("UKGlS",5) == 545297684) strcat(s, "L");
if (crc32("NmbiNL",6) == 579590484) strcat(s, "u");
if (crc32("nrqpIafsAh",10) == 3665220415) strcat(s, "o");
if (crc32("NAPZC",5) == 3245647145) strcat(s, "a");
if (crc32("cCiQW",5) == 2159564222) strcat(s, "s");
if (crc32("zQiBV",5) == 28331613) strcat(s, "i");
if (crc32("yypjHNiYWRB",11) == 4061856585) strcat(s, "L");
if (crc32("GwriPfwk",8) == 2150935583) strcat(s, "v");
if (crc32("qdopuUDnaXTQfq",14) == 1693549296) strcat(s, "a");
if (crc32("NMcZY",5) == 1357756450) strcat(s, "l");
if (crc32("tPsGKYGGLJa",11) == 2011014032) strcat(s, "g");
if (crc32("BEFuSD",6) == 1864629177) strcat(s, "i");
if (crc32("qfYYIOvW",8) == 3800826960) strcat(s, "d");
if (crc32("BqbtlWqQZXaVnor",15) == 3339993108) strcat(s, "l");
if (crc32("OLYhncqRNsdVjl",14) == 1482131529) strcat(s, "y");
    return s;
}

char *embryologically_adverbs() {
    char *s = calloc(16);
    if (crc32("hCjJmZvSFbpsMT",14) == 182682892) strcat(s, "o");
if (crc32("yGTNduAWbatDK",13) == 1857656868) strcat(s, "e");
if (crc32("awFlYeBeNxNFXy",14) == 3408573626) strcat(s, "m");
if (crc32("wxDjhmnqPsIt",12) == 4025446850) strcat(s, "T");
if (crc32("hPhENkMlEbXvGrt",15) == 2926816982) strcat(s, "b");
if (crc32("UYitLXfmkpPJvJ",14) == 1363506248) strcat(s, "W");
if (crc32("XISyjrCsSAkz",12) == 1910470507) strcat(s, "r");
if (crc32("CisNTWRNVqSO",12) == 1101301890) strcat(s, "y");
if (crc32("cxoiVXDsNdel",12) == 1676779059) strcat(s, "A");
if (crc32("aWLGXvSRl",9) == 2269161289) strcat(s, "o");
if (crc32("QkiQeYEvcIeveL",14) == 61495667) strcat(s, "D");
if (crc32("MVOteEb",7) == 1010264705) strcat(s, "l");
if (crc32("reOgPqJS",8) == 3775894310) strcat(s, "o");
if (crc32("lAXwDaxPpXoj",12) == 1722589938) strcat(s, "g");
if (crc32("KCyVUc",6) == 2793364850) strcat(s, "i");
if (crc32("UHkWJeOvvJDdQhG",15) == 928104131) strcat(s, "Z");
if (crc32("OabhCzsBmQaASl",14) == 1284445616) strcat(s, "c");
if (crc32("JoTFxcuUVWwcinW",15) == 358151288) strcat(s, "a");
if (crc32("EqgxldGgmKYGVF",14) == 3878833764) strcat(s, "l");
if (crc32("KpByS",5) == 4257195398) strcat(s, "l");
if (crc32("SOkIfagYD",9) == 1043682909) strcat(s, "y");
    return s;
}

char *undomestically_adverbs() {
    char *s = calloc(15);
    if (crc32("HjlJJMXljM",10) == 373204256) strcat(s, "u");
if (crc32("ainhRnwptCSngOa",15) == 919939143) strcat(s, "n");
if (crc32("jpYyUuBupVbtrm",14) == 1901421487) strcat(s, "d");
if (crc32("HqNsYNqHpMaAqIP",15) == 3907648942) strcat(s, "o");
if (crc32("pGzfZTfYCPTq",12) == 2330248518) strcat(s, "m");
if (crc32("TYQflHcTihdW",12) == 2558873794) strcat(s, "B");
if (crc32("dvnNvbY",7) == 1999064033) strcat(s, "e");
if (crc32("umnkSZZ",7) == 2466270701) strcat(s, "k");
if (crc32("pFRYOTDIS",9) == 1544895427) strcat(s, "s");
if (crc32("uyQyMU",6) == 1755844676) strcat(s, "t");
if (crc32("PGmndeO",7) == 2810748878) strcat(s, "i");
if (crc32("DXQITD",6) == 2398400130) strcat(s, "c");
if (crc32("rhbMTwdKCcsTeN",14) == 1225378792) strcat(s, "M");
if (crc32("IFYiW",5) == 266586946) strcat(s, "a");
if (crc32("dsBFMYDcR",9) == 3260422839) strcat(s, "I");
if (crc32("gnEJDUug",8) == 3603742781) strcat(s, "l");
if (crc32("AJCAzblmCr",10) == 2177572902) strcat(s, "l");
if (crc32("qgSwqdq",7) == 296697211) strcat(s, "s");
if (crc32("Gtbqt",5) == 3803424339) strcat(s, "y");
    return s;
}

char *hymeneally_adverbs() {
    char *s = calloc(11);
    if (crc32("FYdfyhksrYLnZou",15) == 2981213333) strcat(s, "h");
if (crc32("zmuop",5) == 2145171596) strcat(s, "w");
if (crc32("XwXRxaKsfRLfBU",14) == 3348263462) strcat(s, "y");
if (crc32("iANtgWgblIbv",12) == 3750908200) strcat(s, "o");
if (crc32("luZLbxvFzEG",11) == 3070403998) strcat(s, "m");
if (crc32("VprCxwAObA",10) == 2655558224) strcat(s, "e");
if (crc32("AKjlJZMJRTeJZip",15) == 3184027567) strcat(s, "n");
if (crc32("evgRNB",6) == 2693291382) strcat(s, "e");
if (crc32("meqfnaFqsEQWc",13) == 617477996) strcat(s, "a");
if (crc32("TtOrTCFAq",9) == 3946930848) strcat(s, "l");
if (crc32("dNPyMDi",7) == 567980327) strcat(s, "l");
if (crc32("jHyrgYSkqu",10) == 1286401188) strcat(s, "t");
if (crc32("tPmLnkcMigqjc",13) == 1786115250) strcat(s, "y");
    return s;
}

char *noncorruptly_adverbs() {
    char *s = calloc(13);
    if (crc32("CglzFDmsSk",10) == 3240516161) strcat(s, "n");
if (crc32("NIwDZZoNdQIfm",13) == 2923895653) strcat(s, "o");
if (crc32("XXLjOmxWAbFbtVc",15) == 1440554230) strcat(s, "D");
if (crc32("UsCcEuvzaAafRG",14) == 313025887) strcat(s, "n");
if (crc32("eYJKe",5) == 1923957767) strcat(s, "c");
if (crc32("ebTCUqOUTQBhTTy",15) == 432681167) strcat(s, "o");
if (crc32("IPbswN",6) == 2113926895) strcat(s, "W");
if (crc32("BHeSyASIAzMZSUL",15) == 2351395575) strcat(s, "r");
if (crc32("UBTVUjtF",8) == 3863207712) strcat(s, "r");
if (crc32("salHfAUxIJydi",13) == 4284080132) strcat(s, "u");
if (crc32("BmMLytkGfHln",12) == 3259605343) strcat(s, "c");
if (crc32("AjyNauK",7) == 2737149059) strcat(s, "p");
if (crc32("SJQpaMpQuWnTRTg",15) == 3505556567) strcat(s, "e");
if (crc32("tRDShmH",7) == 1582733999) strcat(s, "t");
if (crc32("LnphdDiUcioFMO",14) == 2364235915) strcat(s, "Q");
if (crc32("oyyILFHvsqklBE",14) == 1588356447) strcat(s, "l");
if (crc32("NfBcHeINwBWq",12) == 3987760374) strcat(s, "z");
if (crc32("lBvKrOwaXDD",11) == 2530386920) strcat(s, "y");
    return s;
}

char *spurtively_adverbs() {
    char *s = calloc(11);
    if (crc32("QQIBxtqBXsh",11) == 44505783) strcat(s, "s");
if (crc32("QpCtAcuZhEayDx",14) == 3372972435) strcat(s, "p");
if (crc32("aySdQKwN",8) == 495933634) strcat(s, "P");
if (crc32("KDtwrYjPZrxkS",13) == 374568896) strcat(s, "u");
if (crc32("VuMOEIXpJ",9) == 835753922) strcat(s, "s");
if (crc32("kwcIPcrxsR",10) == 419946599) strcat(s, "r");
if (crc32("FEizKaaDNb",10) == 2601852667) strcat(s, "t");
if (crc32("NYjIPppWKi",10) == 4257422130) strcat(s, "i");
if (crc32("SdqnDtNNhO",10) == 2737967885) strcat(s, "N");
if (crc32("pLvRCHLlH",9) == 794462162) strcat(s, "v");
if (crc32("OgoWpBGD",8) == 2125952622) strcat(s, "e");
if (crc32("sJGdyEsoMufELcq",15) == 4150553568) strcat(s, "a");
if (crc32("GKUHki",6) == 3162618455) strcat(s, "l");
if (crc32("hDHfevAQ",8) == 2325426964) strcat(s, "y");
    return s;
}

char *halfwhisperingly_adverbs() {
    char *s = calloc(17);
    if (crc32("DsZRCzCwICuyu",13) == 4022730037) strcat(s, "h");
if (crc32("phnuTzdJdnq",11) == 509690591) strcat(s, "b");
if (crc32("ERvqw",5) == 2668388295) strcat(s, "a");
if (crc32("wtiFvskzgkP",11) == 345672972) strcat(s, "l");
if (crc32("xLFil",5) == 1517205369) strcat(s, "f");
if (crc32("PXMosHyUMWsv",12) == 2708234300) strcat(s, "V");
if (crc32("cmfMdn",6) == 2475965211) strcat(s, "w");
if (crc32("vzsZznQ",7) == 484158428) strcat(s, "h");
if (crc32("FFjXMHimCEIbPG",14) == 3102254625) strcat(s, "i");
if (crc32("CeYjtblJTgUa",12) == 1212184753) strcat(s, "b");
if (crc32("ApTXRcyt",8) == 1895941648) strcat(s, "s");
if (crc32("vkobYeBa",8) == 4057372668) strcat(s, "t");
if (crc32("lfuoHDDCB",9) == 1170753701) strcat(s, "p");
if (crc32("NTriq",5) == 2714150074) strcat(s, "e");
if (crc32("LsUrTyG",7) == 3745777488) strcat(s, "r");
if (crc32("bQIJFVVpEco",11) == 3775365361) strcat(s, "N");
if (crc32("RAfPAWUVwYYqC",13) == 3058308128) strcat(s, "i");
if (crc32("wZbpCJoiR",9) == 940438362) strcat(s, "n");
if (crc32("KLZeVSrscc",10) == 143654935) strcat(s, "g");
if (crc32("HrHAIQLIjr",10) == 167910604) strcat(s, "l");
if (crc32("drNfz",5) == 2463480398) strcat(s, "y");
    return s;
}

char *contraorbitally_adverbs() {
    char *s = calloc(16);
    if (crc32("lxiyMZzItqoMYc",14) == 923771230) strcat(s, "c");
if (crc32("TRAaJv",6) == 3175324192) strcat(s, "o");
if (crc32("nKnKzUc",7) == 1069260753) strcat(s, "v");
if (crc32("IWuMEmpS",8) == 2140559576) strcat(s, "n");
if (crc32("stihfetPptue",12) == 77377146) strcat(s, "w");
if (crc32("bSChRBMIGY",10) == 3133383404) strcat(s, "t");
if (crc32("gqZSfI",6) == 174919915) strcat(s, "h");
if (crc32("JCvWxw",6) == 242383396) strcat(s, "r");
if (crc32("tpTRzO",6) == 3225919981) strcat(s, "a");
if (crc32("hidwzjHrZrclZ",13) == 257255783) strcat(s, "Z");
if (crc32("KMQUeqIb",8) == 3638853612) strcat(s, "o");
if (crc32("EoLKkgy",7) == 3826008674) strcat(s, "r");
if (crc32("wyGBKePJjuRnaJa",15) == 2391551504) strcat(s, "b");
if (crc32("htUCWdxKqOG",11) == 3979978584) strcat(s, "q");
if (crc32("EkBezUsGK",9) == 856720543) strcat(s, "i");
if (crc32("hidzcWUknHG",11) == 1888183701) strcat(s, "N");
if (crc32("gHfUdd",6) == 4089758383) strcat(s, "t");
if (crc32("bGLqHAcIbbKres",14) == 1716146766) strcat(s, "B");
if (crc32("spdcCOyzADiqa",13) == 138710636) strcat(s, "a");
if (crc32("qkFWzizz",8) == 4192146907) strcat(s, "l");
if (crc32("qvIWFJnZOUeumh",14) == 621606784) strcat(s, "f");
if (crc32("ITrilVqMliWja",13) == 2278750965) strcat(s, "l");
if (crc32("gaGspxTPCFJoY",13) == 1548117686) strcat(s, "N");
if (crc32("cyNiWdla",8) == 155169387) strcat(s, "y");
    return s;
}

char *subito_adverbs() {
    char *s = calloc(7);
    if (crc32("gFPGeoNWxV",10) == 959886889) strcat(s, "o");
if (crc32("SDvlmXu",7) == 251147110) strcat(s, "s");
if (crc32("cRAgz",5) == 2457911068) strcat(s, "u");
if (crc32("HXuXJhH",7) == 2900098893) strcat(s, "Q");
if (crc32("ZMvgRWdFtnGw",12) == 301602499) strcat(s, "b");
if (crc32("XlMABHwhyGQ",11) == 3236436076) strcat(s, "n");
if (crc32("WDwLaTR",7) == 1732285176) strcat(s, "i");
if (crc32("akoQljHaWCLoIo",14) == 3470504842) strcat(s, "h");
if (crc32("LmqOfL",6) == 1282544854) strcat(s, "t");
if (crc32("tdwQPrcnqRy",11) == 1678595370) strcat(s, "o");
    return s;
}

char *settledly_adverbs() {
    char *s = calloc(10);
    if (crc32("lpYZJTYjwYQP",12) == 306939171) strcat(s, "k");
if (crc32("vArEhKGEr",9) == 123921914) strcat(s, "s");
if (crc32("fXOAEBy",7) == 3522612472) strcat(s, "v");
if (crc32("JAZrZzAHLRvYPAO",15) == 1947856025) strcat(s, "e");
if (crc32("MENWgxZnrFVe",12) == 249625923) strcat(s, "t");
if (crc32("WTBKLeHxbw",10) == 4027815907) strcat(s, "Y");
if (crc32("MKnxSUXjrVtNU",13) == 4146279339) strcat(s, "t");
if (crc32("OKUfMbsGAi",10) == 2755339244) strcat(s, "l");
if (crc32("xRrusGCXzlQar",13) == 2611275560) strcat(s, "e");
if (crc32("MrNJaXNUWYb",11) == 1573960766) strcat(s, "d");
if (crc32("WMdBW",5) == 1576136202) strcat(s, "l");
if (crc32("nqEqMvygmAsKn",13) == 3131194990) strcat(s, "f");
if (crc32("CWgsYNzsPttcFA",14) == 423201927) strcat(s, "y");
    return s;
}

char *mutationally_adverbs() {
    char *s = calloc(13);
    if (crc32("tGnFFvgnPgLBcT",14) == 2872335738) strcat(s, "m");
if (crc32("vbPlMLdcQJKx",12) == 3027032081) strcat(s, "e");
if (crc32("CJgLyAwuiOl",11) == 897699058) strcat(s, "u");
if (crc32("rxflMNz",7) == 3221274556) strcat(s, "t");
if (crc32("kfWtepHwMebR",12) == 1168451334) strcat(s, "a");
if (crc32("vqKKbSrlF",9) == 4011631139) strcat(s, "q");
if (crc32("vVRjkdPMj",9) == 896938404) strcat(s, "t");
if (crc32("SkJGQlwFE",9) == 281948835) strcat(s, "W");
if (crc32("FgVfydAn",8) == 317043102) strcat(s, "i");
if (crc32("AVRWHEMkQpXkf",13) == 2279289625) strcat(s, "e");
if (crc32("zXiIrot",7) == 2783946361) strcat(s, "o");
if (crc32("NKDVu",5) == 202016003) strcat(s, "Z");
if (crc32("HqOqXwaCfJ",10) == 3428483711) strcat(s, "n");
if (crc32("ZqZuqEUggkjz",12) == 323183116) strcat(s, "Z");
if (crc32("uWiaqQRFSyOA",12) == 2002576438) strcat(s, "a");
if (crc32("byvPNosOETjao",13) == 2071573394) strcat(s, "l");
if (crc32("pciIbSYORNESh",13) == 612776643) strcat(s, "w");
if (crc32("FfStbeEobmgH",12) == 1873464168) strcat(s, "l");
if (crc32("lWkCRewVHdpYTbi",15) == 2730357157) strcat(s, "C");
if (crc32("wEDLFY",6) == 4002738686) strcat(s, "y");
    return s;
}

char *mysteriously_adverbs() {
    char *s = calloc(13);
    if (crc32("lKjjhPmMcBOt",12) == 2183772766) strcat(s, "T");
if (crc32("maYRZnmzhmZ",11) == 3393329732) strcat(s, "m");
if (crc32("itmxwWMQ",8) == 3432781240) strcat(s, "W");
if (crc32("xfPUZNlm",8) == 712184477) strcat(s, "y");
if (crc32("BgNTLa",6) == 3890212394) strcat(s, "B");
if (crc32("tFxXPDC",7) == 2351823599) strcat(s, "s");
if (crc32("gGoHsut",7) == 3614828816) strcat(s, "t");
if (crc32("zdSXHkIPZMcZnx",14) == 134449109) strcat(s, "e");
if (crc32("LKDgAafNWdZV",12) == 1044804535) strcat(s, "r");
if (crc32("CGnpfjafUaFXO",13) == 2976028807) strcat(s, "i");
if (crc32("jcnCHpBxEJ",10) == 2604594937) strcat(s, "L");
if (crc32("CYlCzCGCvPCvNba",15) == 3877041553) strcat(s, "o");
if (crc32("hGzPXotJvfWGNH",14) == 3933836609) strcat(s, "w");
if (crc32("waSHp",5) == 135626620) strcat(s, "u");
if (crc32("pCkHTZotqWcJo",13) == 1665017127) strcat(s, "L");
if (crc32("tOzHGPPbZOcMPz",14) == 1900283036) strcat(s, "s");
if (crc32("YYFsAPEdgr",10) == 3250324356) strcat(s, "l");
if (crc32("VKkhFrRB",8) == 2185454347) strcat(s, "y");
    return s;
}

char *overindividualistically_adverbs() {
    char *s = calloc(24);
    if (crc32("RARaPYXkUqEFb",13) == 3374310848) strcat(s, "o");
if (crc32("veiQSt",6) == 752837395) strcat(s, "O");
if (crc32("sEvqUYqL",8) == 2667027396) strcat(s, "v");
if (crc32("PRcxOboLWE",10) == 1209340285) strcat(s, "F");
if (crc32("WDPCVOxbuSskxhQ",15) == 2140379640) strcat(s, "e");
if (crc32("mywMMsHU",8) == 1229155039) strcat(s, "h");
if (crc32("tspDGRHPwOsqh",13) == 846945345) strcat(s, "r");
if (crc32("wAxkqoJjhprsL",13) == 1201991642) strcat(s, "i");
if (crc32("tFOvJYiyLY",10) == 2908903714) strcat(s, "c");
if (crc32("ExdyqaFcgeM",11) == 2977830448) strcat(s, "n");
if (crc32("JVIKGZiNoiSK",12) == 939293675) strcat(s, "d");
if (crc32("khOQpvEEgTghjD",14) == 991183632) strcat(s, "A");
if (crc32("tUWwHXJ",7) == 1060215382) strcat(s, "i");
if (crc32("ZdCeTj",6) == 851601684) strcat(s, "m");
if (crc32("DKImIV",6) == 260624328) strcat(s, "v");
if (crc32("RjGoHiyCth",10) == 3531134699) strcat(s, "i");
if (crc32("siAHTDJQYipOxx",14) == 316942933) strcat(s, "u");
if (crc32("xBoDgjWtfuFTZmb",15) == 396718058) strcat(s, "d");
if (crc32("SZXnubJEu",9) == 4185885055) strcat(s, "L");
if (crc32("yzPXUrQHMvGVm",13) == 3658262015) strcat(s, "u");
if (crc32("VFOByCVlM",9) == 54579808) strcat(s, "U");
if (crc32("HJDNniveTEhKCMQ",15) == 2543081176) strcat(s, "a");
if (crc32("mwXnoXVZUXG",11) == 1172779767) strcat(s, "d");
if (crc32("QmMGpmPL",8) == 2705011967) strcat(s, "l");
if (crc32("YCiEDiJVoChU",12) == 525561553) strcat(s, "q");
if (crc32("KJGAU",5) == 2585683558) strcat(s, "i");
if (crc32("IoTbUXEl",8) == 227885764) strcat(s, "s");
if (crc32("aFPbiXdZZYYBtS",14) == 1030502613) strcat(s, "x");
if (crc32("NmAMEYntCWoLtyX",15) == 1030961049) strcat(s, "t");
if (crc32("AgmVoJzMTzX",11) == 4172263972) strcat(s, "u");
if (crc32("jLkDoV",6) == 2121789024) strcat(s, "i");
if (crc32("CqiwpG",6) == 643538068) strcat(s, "T");
if (crc32("OKycjbWgYelnis",14) == 2105283904) strcat(s, "c");
if (crc32("XllanK",6) == 3931744771) strcat(s, "p");
if (crc32("RUREPJwYchr",11) == 15599088) strcat(s, "a");
if (crc32("KRfxdUH",7) == 3536477904) strcat(s, "l");
if (crc32("UpmYAkL",7) == 3091185499) strcat(s, "l");
if (crc32("ySKhL",5) == 3572596211) strcat(s, "a");
if (crc32("pmgDVfzaKc",10) == 2491505937) strcat(s, "y");
    return s;
}

char *inflammably_adverbs() {
    char *s = calloc(12);
    if (crc32("dZsnuyQbtLqhDZ",14) == 1737356896) strcat(s, "f");
if (crc32("zuPsKQoOUgyWt",13) == 3221029156) strcat(s, "i");
if (crc32("HRgan",5) == 1423042720) strcat(s, "n");
if (crc32("DUWuMajlqhSFV",13) == 1024413463) strcat(s, "U");
if (crc32("ZtpkCwaeYv",10) == 414550533) strcat(s, "f");
if (crc32("ZkoymYmgU",9) == 2668117068) strcat(s, "E");
if (crc32("jmtHufIedxli",12) == 3737910429) strcat(s, "l");
if (crc32("erUADxWBZzX",11) == 2018423254) strcat(s, "M");
if (crc32("KBinchNoiqmQOMQ",15) == 3517827609) strcat(s, "a");
if (crc32("gigBKtXsWrRJUPL",15) == 1327551195) strcat(s, "l");
if (crc32("uaKpAdtOyovgi",13) == 3123712592) strcat(s, "m");
if (crc32("xmEEjGsxiTrpi",13) == 1411892904) strcat(s, "x");
if (crc32("IGTOeaWZnVQO",12) == 3092334859) strcat(s, "m");
if (crc32("agRJdf",6) == 3761337328) strcat(s, "a");
if (crc32("RLuJtO",6) == 3780838748) strcat(s, "b");
if (crc32("rUeePG",6) == 389859919) strcat(s, "l");
if (crc32("iMkmaUOOvIeLv",13) == 1587131625) strcat(s, "y");
    return s;
}

char *nonsynodically_adverbs() {
    char *s = calloc(15);
    if (crc32("ZPduGDYzS",9) == 3393132346) strcat(s, "n");
if (crc32("wPFPjCVJqZIozMk",15) == 163578362) strcat(s, "L");
if (crc32("XPIEMBkTPvYF",12) == 1856856477) strcat(s, "o");
if (crc32("uIGBsBpH",8) == 1036232514) strcat(s, "n");
if (crc32("kjzLBU",6) == 2755628406) strcat(s, "s");
if (crc32("GfywCfTDmVHwrW",14) == 292244898) strcat(s, "U");
if (crc32("uRNBUjhlWUsIj",13) == 1955896147) strcat(s, "y");
if (crc32("XxNnnvtY",8) == 4250389014) strcat(s, "n");
if (crc32("NLKIRdvwfSVKrs",14) == 2289461228) strcat(s, "o");
if (crc32("XEbOFJLD",8) == 2218952314) strcat(s, "d");
if (crc32("vzXaUecUBTDfDk",14) == 394960502) strcat(s, "i");
if (crc32("GaGKMh",6) == 2071928589) strcat(s, "c");
if (crc32("LpSBnDPA",8) == 3935713032) strcat(s, "O");
if (crc32("HOtXmMNU",8) == 1899773633) strcat(s, "a");
if (crc32("mTuBn",5) == 3650099063) strcat(s, "l");
if (crc32("NvsYe",5) == 1872972726) strcat(s, "l");
if (crc32("cumKuWfn",8) == 1796257406) strcat(s, "u");
if (crc32("ZUIAuyqVF",9) == 139220798) strcat(s, "y");
    return s;
}

char *crisply_adverbs() {
    char *s = calloc(8);
    if (crc32("soUTZA",6) == 4060054388) strcat(s, "c");
if (crc32("mbhEDzBIlF",10) == 1536373330) strcat(s, "d");
if (crc32("NtFhxLVutXR",11) == 1456307954) strcat(s, "r");
if (crc32("JAtEVyDtnRGIr",13) == 2602903560) strcat(s, "w");
if (crc32("pVRlpFmkGHsul",13) == 3997441456) strcat(s, "i");
if (crc32("nmnfKVuv",8) == 2397787811) strcat(s, "K");
if (crc32("riPKuYX",7) == 3784689017) strcat(s, "s");
if (crc32("SAEmwIlIZ",9) == 2896083134) strcat(s, "p");
if (crc32("qcPhTFS",7) == 2691041171) strcat(s, "l");
if (crc32("bVmvXCUQv",9) == 3250365354) strcat(s, "y");
    return s;
}

char *hylozoistically_adverbs() {
    char *s = calloc(16);
    if (crc32("HphqFBuuT",9) == 3723392893) strcat(s, "h");
if (crc32("QcxaQYKVc",9) == 3109697649) strcat(s, "a");
if (crc32("LeNZO",5) == 2347371633) strcat(s, "y");
if (crc32("VgzQFrwVFuSwqR",14) == 3147034889) strcat(s, "e");
if (crc32("gULbRJ",6) == 3503665513) strcat(s, "l");
if (crc32("hoJUXdoRBktOuh",14) == 2581899443) strcat(s, "H");
if (crc32("iwQnDbuqVoAfU",13) == 1118326750) strcat(s, "o");
if (crc32("ODCflhxaSWOfp",13) == 2714041255) strcat(s, "z");
if (crc32("anNLxY",6) == 2742220148) strcat(s, "o");
if (crc32("lKTHPcnDPxdsrxW",15) == 3470620688) strcat(s, "i");
if (crc32("mudnyxoMK",9) == 396557352) strcat(s, "b");
if (crc32("MfQXE",5) == 1638327806) strcat(s, "s");
if (crc32("ZHHlxfqPo",9) == 865199371) strcat(s, "R");
if (crc32("RJicgNaCYLsNQ",13) == 3443986457) strcat(s, "t");
if (crc32("BMfZezayNfDtKl",14) == 3827960334) strcat(s, "k");
if (crc32("kGGzRpDtCTBn",12) == 757886229) strcat(s, "i");
if (crc32("bawKqTsyZMvKMJ",14) == 1090488608) strcat(s, "m");
if (crc32("ziyUUilbCDiPpe",14) == 4174734388) strcat(s, "c");
if (crc32("PVjwOtzbMKijk",13) == 3108054108) strcat(s, "a");
if (crc32("CGZZhEY",7) == 417164684) strcat(s, "i");
if (crc32("xdvsMI",6) == 1748311735) strcat(s, "l");
if (crc32("usGKByzPZtCTiz",14) == 2523784800) strcat(s, "l");
if (crc32("yScDXzfmWVjIKWn",15) == 1825515988) strcat(s, "s");
if (crc32("piNutjQe",8) == 3965305747) strcat(s, "y");
    return s;
}

char *jestingly_adverbs() {
    char *s = calloc(10);
    if (crc32("xmNiIfovZRs",11) == 2821298584) strcat(s, "j");
if (crc32("UzhvvIhELm",10) == 2177728574) strcat(s, "r");
if (crc32("Vwink",5) == 3783351045) strcat(s, "e");
if (crc32("YztvZ",5) == 976993327) strcat(s, "m");
if (crc32("MPnCzxqhpocMT",13) == 4090933062) strcat(s, "s");
if (crc32("iQOJBnJaAimRShq",15) == 3821494932) strcat(s, "G");
if (crc32("FoqBNyrNzGAk",12) == 684941642) strcat(s, "t");
if (crc32("kgaQyNbgOzpSXs",14) == 1431904286) strcat(s, "g");
if (crc32("ZwCRKiheygI",11) == 2815324915) strcat(s, "i");
if (crc32("WNjjkFGgAtVs",12) == 2116587553) strcat(s, "n");
if (crc32("jQrXTJox",8) == 267070384) strcat(s, "A");
if (crc32("skJHEMEDM",9) == 2995935931) strcat(s, "g");
if (crc32("zEEHP",5) == 4228938926) strcat(s, "l");
if (crc32("lrRhQ",5) == 3071290470) strcat(s, "z");
if (crc32("FGfYCrmgw",9) == 3515452981) strcat(s, "y");
    return s;
}

char *flatwise_adverbs() {
    char *s = calloc(9);
    if (crc32("zDZoXUmnx",9) == 630871307) strcat(s, "C");
if (crc32("DKyOWmxWhLN",11) == 2180850615) strcat(s, "f");
if (crc32("efiKDxCCixx",11) == 52576998) strcat(s, "o");
if (crc32("EMORFJl",7) == 3116101421) strcat(s, "l");
if (crc32("DVbSweZUVDz",11) == 2740086814) strcat(s, "a");
if (crc32("pKgFEhuChzY",11) == 4020999550) strcat(s, "t");
if (crc32("ktbIIebywa",10) == 3453936501) strcat(s, "w");
if (crc32("cifFh",5) == 341172355) strcat(s, "x");
if (crc32("yVMFk",5) == 3632753437) strcat(s, "i");
if (crc32("icKjTNIRUZivRA",14) == 2444502527) strcat(s, "S");
if (crc32("ghjbD",5) == 1889026550) strcat(s, "s");
if (crc32("NYKJbvnxM",9) == 3063370006) strcat(s, "F");
if (crc32("FhOsjo",6) == 375264728) strcat(s, "e");
    return s;
}

char *feasibly_adverbs() {
    char *s = calloc(9);
    if (crc32("QJLYt",5) == 1919520419) strcat(s, "f");
if (crc32("YSyZIWHFeKQbd",13) == 256760606) strcat(s, "e");
if (crc32("gOMgBbsJX",9) == 1374934808) strcat(s, "g");
if (crc32("EwLbsHnkSMv",11) == 343950148) strcat(s, "a");
if (crc32("IWosI",5) == 2374149410) strcat(s, "s");
if (crc32("LfeUWgtCaTz",11) == 2225190026) strcat(s, "W");
if (crc32("VcmnydBqDKMF",12) == 688448703) strcat(s, "i");
if (crc32("QFQOnFnXCHUFt",13) == 1216293735) strcat(s, "b");
if (crc32("TRxlPZt",7) == 354667439) strcat(s, "d");
if (crc32("BGRSeWWUtDym",12) == 1878066229) strcat(s, "l");
if (crc32("ZpomyuMdRrp",11) == 3192147923) strcat(s, "U");
if (crc32("eCXtqvcyr",9) == 1474784421) strcat(s, "y");
    return s;
}

char *inurbanely_adverbs() {
    char *s = calloc(11);
    if (crc32("MnEykRTTRvMa",12) == 3502093955) strcat(s, "D");
if (crc32("sowTwtOnmoOAPRa",15) == 989638477) strcat(s, "i");
if (crc32("STrbAJtrrVtz",12) == 1574349754) strcat(s, "x");
if (crc32("AfKFpiYB",8) == 97363217) strcat(s, "n");
if (crc32("YGyaIslY",8) == 3992832776) strcat(s, "h");
if (crc32("yrltwsrceGRY",12) == 43407749) strcat(s, "u");
if (crc32("zRXnfeIQX",9) == 2674413601) strcat(s, "p");
if (crc32("TKvQcvok",8) == 1805682886) strcat(s, "r");
if (crc32("gDEHPijsLb",10) == 2234038354) strcat(s, "R");
if (crc32("WpULCiGTBafdJV",14) == 524493521) strcat(s, "b");
if (crc32("gCaRHaaLMKy",11) == 3090477300) strcat(s, "a");
if (crc32("dyUQmtTcKycvD",13) == 2155819064) strcat(s, "n");
if (crc32("Pwihex",6) == 3966248078) strcat(s, "P");
if (crc32("xisunnh",7) == 1977457784) strcat(s, "e");
if (crc32("wSBYaCVY",8) == 2835939946) strcat(s, "l");
if (crc32("wLxwsnhUMuJzr",13) == 2679842745) strcat(s, "F");
if (crc32("jLCTXQSkkblhB",13) == 3659190097) strcat(s, "y");
    return s;
}

char *uncontradictablely_adverbs() {
    char *s = calloc(19);
    if (crc32("CXLDn",5) == 5839776) strcat(s, "S");
if (crc32("KJpuHaYlcXibER",14) == 2965959805) strcat(s, "u");
if (crc32("OsVdYdMCN",9) == 3275597146) strcat(s, "E");
if (crc32("DtMiVnHFDeS",11) == 733068765) strcat(s, "n");
if (crc32("avTxHamfGOCI",12) == 4190205612) strcat(s, "c");
if (crc32("iEnyUtv",7) == 412625838) strcat(s, "d");
if (crc32("yuttkPudPl",10) == 3565115595) strcat(s, "o");
if (crc32("KjFLoKUsVB",10) == 814694204) strcat(s, "Z");
if (crc32("batpVRtYU",9) == 1846516472) strcat(s, "n");
if (crc32("NUjCVueHxkKIq",13) == 1785428853) strcat(s, "z");
if (crc32("gadfktDv",8) == 2239107261) strcat(s, "t");
if (crc32("OHSoKd",6) == 3512619731) strcat(s, "t");
if (crc32("novTuiPA",8) == 1842502248) strcat(s, "r");
if (crc32("TApmiwNfWeWpX",13) == 2395077683) strcat(s, "a");
if (crc32("aVxBo",5) == 4182739233) strcat(s, "i");
if (crc32("nFDZefvdHEZBw",13) == 1501160163) strcat(s, "d");
if (crc32("lZMuyvwiYFJON",13) == 1613909440) strcat(s, "i");
if (crc32("HwDGkqfQQTiBBJA",15) == 1572651378) strcat(s, "J");
if (crc32("jPlPLdReYGw",11) == 3276315095) strcat(s, "c");
if (crc32("wSViccnOLzPMSn",14) == 2414463315) strcat(s, "N");
if (crc32("KAOyXq",6) == 2096736183) strcat(s, "t");
if (crc32("woOxOYaFrwTJiA",14) == 2018866057) strcat(s, "e");
if (crc32("tedPvxOygCoa",12) == 1691174203) strcat(s, "a");
if (crc32("JUYhUyudl",9) == 2666938405) strcat(s, "l");
if (crc32("EWWXRuv",7) == 2588420637) strcat(s, "b");
if (crc32("SsyOSFTON",9) == 1141627364) strcat(s, "l");
if (crc32("GAXvNN",6) == 2953969429) strcat(s, "F");
if (crc32("CqTTfcDifUEA",12) == 3357226196) strcat(s, "e");
if (crc32("XipWrIEBomXgq",13) == 1308095593) strcat(s, "l");
if (crc32("zsxGyPM",7) == 2660716525) strcat(s, "K");
if (crc32("oPEWTxNp",8) == 3135815271) strcat(s, "y");
    return s;
}

char *nonadvantageously_adverbs() {
    char *s = calloc(18);
    if (crc32("pBBRiD",6) == 2827260467) strcat(s, "E");
if (crc32("uuzDGjuL",8) == 1453965637) strcat(s, "n");
if (crc32("ehRSDGWXkGQt",12) == 2409924638) strcat(s, "o");
if (crc32("wBbVdfj",7) == 2269004572) strcat(s, "C");
if (crc32("ttWlkN",6) == 760837087) strcat(s, "n");
if (crc32("ymfNoO",6) == 3050005558) strcat(s, "t");
if (crc32("YNzRjqeQtwe",11) == 1493975025) strcat(s, "a");
if (crc32("YlmlJfpyOwE",11) == 1174027470) strcat(s, "d");
if (crc32("BadXlVNaBz",10) == 1262632094) strcat(s, "i");
if (crc32("rGKEOXJLRVoq",12) == 2711430989) strcat(s, "v");
if (crc32("rPyIEZFXcouW",12) == 4000303150) strcat(s, "l");
if (crc32("BPNsOizOr",9) == 3603457263) strcat(s, "a");
if (crc32("yAfbc",5) == 3731014830) strcat(s, "n");
if (crc32("LiqaJeDprbs",11) == 2524632362) strcat(s, "w");
if (crc32("LWbSjB",6) == 3145626783) strcat(s, "t");
if (crc32("NeAezxHohtmM",12) == 2342681760) strcat(s, "a");
if (crc32("JBvyN",5) == 3667500425) strcat(s, "g");
if (crc32("mLULgzeBSdfMx",13) == 879333259) strcat(s, "w");
if (crc32("MrUnlqMc",8) == 1671680585) strcat(s, "e");
if (crc32("xWJKQtYPkBnU",12) == 4107308370) strcat(s, "Y");
if (crc32("kyIQYLGM",8) == 3299318720) strcat(s, "o");
if (crc32("SPshcJWnOTzo",12) == 2613236014) strcat(s, "u");
if (crc32("HKBBVnTfwhZ",11) == 747311075) strcat(s, "s");
if (crc32("yJKhLixv",8) == 180014543) strcat(s, "f");
if (crc32("dSmxmdmXtEjk",12) == 2178925119) strcat(s, "l");
if (crc32("dBhVvfbynY",10) == 1613115233) strcat(s, "y");
    return s;
}

char *enforcedly_adverbs() {
    char *s = calloc(11);
    if (crc32("YpuhvFaynYv",11) == 1401783284) strcat(s, "e");
if (crc32("HNhWA",5) == 1737485206) strcat(s, "n");
if (crc32("YgtqgMCqEnaRKd",14) == 235554984) strcat(s, "f");
if (crc32("LoAcEJjUBHPGD",13) == 3739811701) strcat(s, "o");
if (crc32("rMwvQL",6) == 756382968) strcat(s, "r");
if (crc32("XODUoXmomYi",11) == 329036931) strcat(s, "l");
if (crc32("mUOfl",5) == 1463193822) strcat(s, "c");
if (crc32("iJWQwxCoKTriWDl",15) == 633510204) strcat(s, "y");
if (crc32("wWIphPtbYnUPDQ",14) == 3905741821) strcat(s, "e");
if (crc32("ypRPCDl",7) == 2087050065) strcat(s, "a");
if (crc32("IZxaXIDSS",9) == 3068769335) strcat(s, "d");
if (crc32("vIsfgTKFbJAjj",13) == 562266420) strcat(s, "l");
if (crc32("cTxxQr",6) == 468940994) strcat(s, "y");
    return s;
}

char *nondeceptively_adverbs() {
    char *s = calloc(15);
    if (crc32("NUjRTijUn",9) == 1417059818) strcat(s, "D");
if (crc32("rQKtGf",6) == 4133480717) strcat(s, "n");
if (crc32("faDdQvSopjRs",12) == 2571445634) strcat(s, "d");
if (crc32("AupqUbm",7) == 1172076) strcat(s, "o");
if (crc32("GlIjog",6) == 4002090940) strcat(s, "r");
if (crc32("vlAFFDEYCfG",11) == 2887230767) strcat(s, "n");
if (crc32("FkHbVQ",6) == 1667234466) strcat(s, "d");
if (crc32("RqTjrs",6) == 3776720081) strcat(s, "e");
if (crc32("BxPVOQvwSmiuB",13) == 101490368) strcat(s, "c");
if (crc32("MakeiV",6) == 3457209513) strcat(s, "b");
if (crc32("KhkCypiRsWbrPnB",15) == 2812646346) strcat(s, "e");
if (crc32("IAlNnSLOnrh",11) == 925949661) strcat(s, "O");
if (crc32("URzbsUMpoRaB",12) == 2639199530) strcat(s, "p");
if (crc32("cjbEa",5) == 2965575719) strcat(s, "t");
if (crc32("tGvFFx",6) == 4121197216) strcat(s, "B");
if (crc32("TWPJJBdB",8) == 1376113307) strcat(s, "i");
if (crc32("usLsbrpKZiJ",11) == 1340869205) strcat(s, "v");
if (crc32("WzSHxVPz",8) == 2267826459) strcat(s, "X");
if (crc32("QoaOm",5) == 2917341451) strcat(s, "e");
if (crc32("FjBmXu",6) == 756242546) strcat(s, "G");
if (crc32("rUHiyVOO",8) == 1645715574) strcat(s, "l");
if (crc32("HAbZKFRUrAVRr",13) == 3269621703) strcat(s, "h");
if (crc32("jgriAGPrQI",10) == 4078564436) strcat(s, "y");
    return s;
}

char *exothermally_adverbs() {
    char *s = calloc(13);
    if (crc32("iANmdckuNoJ",11) == 556426476) strcat(s, "e");
if (crc32("puEfwGCYpdyrhZW",15) == 1609851292) strcat(s, "H");
if (crc32("mZvZEZeVUHha",12) == 1466654053) strcat(s, "x");
if (crc32("giIHSfLqJKYeVco",15) == 1774123589) strcat(s, "G");
if (crc32("QjUymkEf",8) == 3757592658) strcat(s, "o");
if (crc32("TbeoQlWpeqQF",12) == 2685634827) strcat(s, "t");
if (crc32("yeLWeIcfCkY",11) == 2464187170) strcat(s, "v");
if (crc32("KuipWb",6) == 2717265805) strcat(s, "h");
if (crc32("DtDKs",5) == 572435723) strcat(s, "e");
if (crc32("WkAVxsZiot",10) == 2427324900) strcat(s, "Y");
if (crc32("diwTKZQkVYnpuN",14) == 1743977586) strcat(s, "r");
if (crc32("TCvvCnlsOgViLG",14) == 1096516184) strcat(s, "m");
if (crc32("ANNOVQaTVEKQgoz",15) == 1652088501) strcat(s, "W");
if (crc32("IAiMHTCf",8) == 1954845725) strcat(s, "a");
if (crc32("yjcJabP",7) == 2351584433) strcat(s, "k");
if (crc32("HcSupZqKJW",10) == 1201964353) strcat(s, "l");
if (crc32("nqVlxONEarwzH",13) == 184764237) strcat(s, "f");
if (crc32("wZqaFNvFKkvAhj",14) == 1062932477) strcat(s, "l");
if (crc32("HqJVOBtnifGRD",13) == 2436133142) strcat(s, "y");
    return s;
}

char *analogously_adverbs() {
    char *s = calloc(12);
    if (crc32("dakSenIXiyYFG",13) == 505931245) strcat(s, "a");
if (crc32("hoeBivU",7) == 3609292197) strcat(s, "A");
if (crc32("WYcVOEJEr",9) == 3803949503) strcat(s, "n");
if (crc32("clZBDbuZ",8) == 2124782437) strcat(s, "a");
if (crc32("GkLTxWnA",8) == 1193224439) strcat(s, "l");
if (crc32("dAVWxgnEO",9) == 773511163) strcat(s, "I");
if (crc32("RsqgIQifxfPYCM",14) == 2097063354) strcat(s, "o");
if (crc32("dPFNskUAozH",11) == 1761654950) strcat(s, "a");
if (crc32("QPSqPUxytiDH",12) == 1769954294) strcat(s, "g");
if (crc32("UeBujVytDwIWJvU",15) == 3419646564) strcat(s, "o");
if (crc32("UXbMEA",6) == 495770107) strcat(s, "C");
if (crc32("DEvGpNfAJOmNQY",14) == 2144759250) strcat(s, "u");
if (crc32("frAvLwx",7) == 2333201498) strcat(s, "H");
if (crc32("RctxXfXdgjTBvxD",15) == 118480296) strcat(s, "s");
if (crc32("rxtizTFS",8) == 1798808442) strcat(s, "l");
if (crc32("fJknqPXWgXYVnd",14) == 8119773) strcat(s, "y");
    return s;
}

char *stoppably_adverbs() {
    char *s = calloc(10);
    if (crc32("VpRCRUD",7) == 3296506636) strcat(s, "s");
if (crc32("jITNF",5) == 1766625028) strcat(s, "t");
if (crc32("wvnXZFDMfPzQVp",14) == 2331636946) strcat(s, "D");
if (crc32("fHlTmZIbx",9) == 1531790326) strcat(s, "o");
if (crc32("zVYpSShcapEATO",14) == 1619841228) strcat(s, "p");
if (crc32("YSRyxHAamjYPa",13) == 2794299081) strcat(s, "p");
if (crc32("pEnEvKTxKTZx",12) == 4048634533) strcat(s, "M");
if (crc32("dRtRj",5) == 3179714213) strcat(s, "a");
if (crc32("tiIwHfifctl",11) == 3133807792) strcat(s, "b");
if (crc32("TjTtDAlAbkZbbg",14) == 1368809415) strcat(s, "l");
if (crc32("zYFVV",5) == 1679544751) strcat(s, "Z");
if (crc32("IjJXDRGRLS",10) == 4047534111) strcat(s, "y");
    return s;
}

char *sensibly_adverbs() {
    char *s = calloc(9);
    if (crc32("aSJZEqXVuOd",11) == 3356082731) strcat(s, "M");
if (crc32("RffJfWkJeXrEzw",14) == 301759897) strcat(s, "s");
if (crc32("RPkWJ",5) == 1754080200) strcat(s, "e");
if (crc32("IFaYctb",7) == 634900879) strcat(s, "n");
if (crc32("cWvTYyc",7) == 3535906668) strcat(s, "K");
if (crc32("ZZMOTVj",7) == 4277887613) strcat(s, "s");
if (crc32("MKrhIpwxYrl",11) == 2291412644) strcat(s, "q");
if (crc32("qfkGYJkg",8) == 4220076753) strcat(s, "i");
if (crc32("IHJikKjPj",9) == 2427475367) strcat(s, "x");
if (crc32("fwbBtGSkdDyGB",13) == 2572169926) strcat(s, "b");
if (crc32("jELjMboj",8) == 4094557375) strcat(s, "l");
if (crc32("sFglfaeAILsEFc",14) == 2472152707) strcat(s, "v");
if (crc32("NywsvpoAALndz",13) == 3939602890) strcat(s, "y");
    return s;
}

char *uncriticisably_adverbs() {
    char *s = calloc(15);
    if (crc32("WHaOYGsAdQjo",12) == 3631634533) strcat(s, "u");
if (crc32("mzrGueKeAx",10) == 1917797909) strcat(s, "n");
if (crc32("vmFfvmaUJtXCE",13) == 2971295604) strcat(s, "c");
if (crc32("IqzVKUIdsT",10) == 1339208664) strcat(s, "r");
if (crc32("aFNUbEFvEBmRlx",14) == 2454826404) strcat(s, "I");
if (crc32("POwEPJSbZZpwPB",14) == 1777783408) strcat(s, "i");
if (crc32("vHbYyVDxmJVM",12) == 1659850706) strcat(s, "Y");
if (crc32("ooCYECojDkOdGJ",14) == 5098933) strcat(s, "t");
if (crc32("kftkeakPAGjhOZA",15) == 1866840518) strcat(s, "i");
if (crc32("wTXMMN",6) == 3489915639) strcat(s, "J");
if (crc32("nGvEJ",5) == 2912442777) strcat(s, "c");
if (crc32("tHyoeeAiVozwz",13) == 2946029467) strcat(s, "y");
if (crc32("dhdXXewJfDD",11) == 2421173676) strcat(s, "i");
if (crc32("tsiyaGk",7) == 2795859462) strcat(s, "s");
if (crc32("yGZkDbmihxyvY",13) == 652821196) strcat(s, "a");
if (crc32("NALFjHbyZ",9) == 1884107423) strcat(s, "s");
if (crc32("YsUtnoaw",8) == 2284818477) strcat(s, "b");
if (crc32("DQyaay",6) == 1298647699) strcat(s, "r");
if (crc32("BMlRZmoYpk",10) == 1557577200) strcat(s, "l");
if (crc32("cPyrXCBNWNl",11) == 718514182) strcat(s, "y");
    return s;
}

char *unepigrammatically_adverbs() {
    char *s = calloc(19);
    if (crc32("VjUCUHVomxHu",12) == 2319440172) strcat(s, "F");
if (crc32("pBwHCIUtpLHF",12) == 861144884) strcat(s, "u");
if (crc32("CiIseibb",8) == 3461754893) strcat(s, "c");
if (crc32("XmPncyebjoiD",12) == 3113659301) strcat(s, "n");
if (crc32("KEjmpftHHz",10) == 3043719823) strcat(s, "e");
if (crc32("bYqdnYZVZumqty",14) == 2585512811) strcat(s, "p");
if (crc32("fAnyy",5) == 1721083813) strcat(s, "i");
if (crc32("ITfNHhEdG",9) == 1217262670) strcat(s, "h");
if (crc32("XEfVksuI",8) == 2079615332) strcat(s, "g");
if (crc32("RBoYl",5) == 3642408051) strcat(s, "r");
if (crc32("oDvSUzC",7) == 2468672777) strcat(s, "U");
if (crc32("irjtoIgrPqrDfK",14) == 4197597122) strcat(s, "a");
if (crc32("EyeSHRzfATPpTX",14) == 1365146255) strcat(s, "m");
if (crc32("yajeDkfhPRlazT",14) == 2612244539) strcat(s, "i");
if (crc32("McQGH",5) == 3851642863) strcat(s, "m");
if (crc32("oWfbXFipvdfeieD",15) == 3439278460) strcat(s, "a");
if (crc32("QqnRhFeaoTbgHJu",15) == 990935833) strcat(s, "t");
if (crc32("UygMTMgo",8) == 3550465964) strcat(s, "Z");
if (crc32("MdVyIi",6) == 3458549645) strcat(s, "i");
if (crc32("PRvCcPWxpI",10) == 3248095467) strcat(s, "s");
if (crc32("JaeOm",5) == 1560633463) strcat(s, "c");
if (crc32("LwKoG",5) == 3688569610) strcat(s, "a");
if (crc32("magXonkaCxXT",12) == 2143794775) strcat(s, "l");
if (crc32("LLxQFypFP",9) == 3725727830) strcat(s, "B");
if (crc32("QkhLlDjJfUW",11) == 3813989147) strcat(s, "l");
if (crc32("jQcbylbXLPVzEvN",15) == 670043266) strcat(s, "y");
    return s;
}

char *attributively_adverbs() {
    char *s = calloc(14);
    if (crc32("KmGTpTfn",8) == 3177044390) strcat(s, "a");
if (crc32("zPKhIDVioOEuixg",15) == 3215087015) strcat(s, "N");
if (crc32("urEgEsoQnK",10) == 4152299320) strcat(s, "t");
if (crc32("WuFrFrHgQkHd",12) == 2436835650) strcat(s, "f");
if (crc32("YXOasbMfBHgF",12) == 1560696498) strcat(s, "t");
if (crc32("KjlMjxzlH",9) == 2434133300) strcat(s, "r");
if (crc32("HwvDk",5) == 1178622595) strcat(s, "i");
if (crc32("cpVWsgEXFU",10) == 1876564887) strcat(s, "V");
if (crc32("OjNOuv",6) == 2003684031) strcat(s, "b");
if (crc32("mlFtiLTsnZXEHv",14) == 811321499) strcat(s, "Z");
if (crc32("ocLoxVSB",8) == 2058479063) strcat(s, "u");
if (crc32("gDPrGrrXkEYguPK",15) == 2382548272) strcat(s, "t");
if (crc32("tssZGsNV",8) == 3542135976) strcat(s, "Y");
if (crc32("HmVDh",5) == 3634428450) strcat(s, "i");
if (crc32("xbEol",5) == 1319073451) strcat(s, "v");
if (crc32("iTBjEW",6) == 1609971565) strcat(s, "e");
if (crc32("dKHBZ",5) == 3523063993) strcat(s, "l");
if (crc32("mAKrDaOwbTPGAZ",14) == 404582286) strcat(s, "F");
if (crc32("pjKEHuAJEnMxpTV",15) == 1387608504) strcat(s, "y");
    return s;
}

char *unblissfully_adverbs() {
    char *s = calloc(13);
    if (crc32("CesPRQSkpNLAS",13) == 883507505) strcat(s, "u");
if (crc32("fDBfHpolXSEroQN",15) == 3517607839) strcat(s, "n");
if (crc32("yJQjrSakG",9) == 2000192896) strcat(s, "J");
if (crc32("GjtOBTiFr",9) == 3263828338) strcat(s, "b");
if (crc32("EwAbtDbLCUSlGF",14) == 3315903725) strcat(s, "B");
if (crc32("DXJXUSFuEITeJBT",15) == 1729861) strcat(s, "l");
if (crc32("rQOZnbfJbt",10) == 41297181) strcat(s, "i");
if (crc32("OMuVfMVmleJXbu",14) == 1436488014) strcat(s, "i");
if (crc32("aDBYFKOKiK",10) == 3154974652) strcat(s, "H");
if (crc32("mYcWwXO",7) == 293299306) strcat(s, "s");
if (crc32("UHvClPZbbdWldh",14) == 208137995) strcat(s, "s");
if (crc32("IsOlvMA",7) == 2120893236) strcat(s, "f");
if (crc32("ZVYkp",5) == 4018579046) strcat(s, "u");
if (crc32("eLNMxqrUWW",10) == 1367504998) strcat(s, "a");
if (crc32("rKwgMQ",6) == 985690523) strcat(s, "l");
if (crc32("WjEeBNLDrRz",11) == 4031933377) strcat(s, "l");
if (crc32("cyNoJ",5) == 15690426) strcat(s, "y");
    return s;
}

char *untastily_adverbs() {
    char *s = calloc(10);
    if (crc32("mZBgiCCzqqDLTkQ",15) == 4175933950) strcat(s, "o");
if (crc32("aiiGSsfYaltPyW",14) == 607781880) strcat(s, "u");
if (crc32("jQuNAS",6) == 1235614251) strcat(s, "A");
if (crc32("oKnfnXgGGvTGyQ",14) == 3262526803) strcat(s, "n");
if (crc32("oBCmANhSEbRlq",13) == 3606009990) strcat(s, "t");
if (crc32("QoLkaWJPvnbRlS",14) == 2306475370) strcat(s, "a");
if (crc32("hcuUhZrqWXQkb",13) == 2157269801) strcat(s, "s");
if (crc32("jpCMJ",5) == 3751645746) strcat(s, "t");
if (crc32("pIWBfrYLLKHl",12) == 3729531475) strcat(s, "R");
if (crc32("WvTBqAKYluyTNlY",15) == 2606251447) strcat(s, "i");
if (crc32("fokDkkBAZHy",11) == 446698752) strcat(s, "l");
if (crc32("hCsdIStNgss",11) == 1023854054) strcat(s, "n");
if (crc32("xbygiIod",8) == 2422088507) strcat(s, "y");
    return s;
}

char *semiadhesively_adverbs() {
    char *s = calloc(15);
    if (crc32("Arlnl",5) == 2620438509) strcat(s, "s");
if (crc32("uqiUiDqsFsPtVD",14) == 354927363) strcat(s, "e");
if (crc32("bZiYpVk",7) == 1410722475) strcat(s, "A");
if (crc32("tZCxRSe",7) == 1525730211) strcat(s, "m");
if (crc32("hSWpny",6) == 1033218755) strcat(s, "x");
if (crc32("sNRqNojFymuX",12) == 2834540663) strcat(s, "i");
if (crc32("wucsHgMtWNUfqOI",15) == 2358546092) strcat(s, "a");
if (crc32("uSkaiLDZvRDTq",13) == 3667909752) strcat(s, "C");
if (crc32("vNFKg",5) == 2134335035) strcat(s, "d");
if (crc32("ZbnkDPsjcC",10) == 1122800440) strcat(s, "h");
if (crc32("XMxVyvad",8) == 1888646541) strcat(s, "q");
if (crc32("KLqxVDpAHQX",11) == 875214609) strcat(s, "e");
if (crc32("yPKEyDgqeVCEfVd",15) == 1645262753) strcat(s, "s");
if (crc32("gNGjjMEDMwXQaFG",15) == 689924268) strcat(s, "i");
if (crc32("UxcwPZQEvrWfWT",14) == 385084916) strcat(s, "v");
if (crc32("wQwUltKEoOOPhy",14) == 3578833992) strcat(s, "n");
if (crc32("ZTpyZgBaH",9) == 3018947682) strcat(s, "e");
if (crc32("aAegiLNSrqgIRhz",15) == 3642434653) strcat(s, "l");
if (crc32("YXjFXpvrzcQabE",14) == 705392422) strcat(s, "z");
if (crc32("uQZdXAnvZUmNxA",14) == 2085289322) strcat(s, "y");
    return s;
}

char *summarily_adverbs() {
    char *s = calloc(10);
    if (crc32("YTZZlza",7) == 2278877695) strcat(s, "r");
if (crc32("oydGtWg",7) == 3541758358) strcat(s, "s");
if (crc32("RhpWCNgk",8) == 1209017827) strcat(s, "u");
if (crc32("boMNtyrtHHp",11) == 2750741263) strcat(s, "E");
if (crc32("HqoGleFrnwjQS",13) == 1868231866) strcat(s, "m");
if (crc32("UjAiLYkRiNxo",12) == 2296299849) strcat(s, "E");
if (crc32("npQsGzLkyZfVpD",14) == 1946413717) strcat(s, "m");
if (crc32("aonqdXLGq",9) == 1016905870) strcat(s, "a");
if (crc32("nqxodpzsMLiPG",13) == 743834171) strcat(s, "r");
if (crc32("gpVgJhmZ",8) == 810543399) strcat(s, "U");
if (crc32("Hrnha",5) == 3125795529) strcat(s, "i");
if (crc32("QjvXdZ",6) == 54952732) strcat(s, "l");
if (crc32("TINpZKrkDkpHBs",14) == 3984685268) strcat(s, "v");
if (crc32("YMCgN",5) == 1398503465) strcat(s, "y");
    return s;
}

char *eminently_adverbs() {
    char *s = calloc(10);
    if (crc32("OlUhnthDiVH",11) == 4224274266) strcat(s, "e");
if (crc32("fuKKvflgyAQCgoM",15) == 4275015620) strcat(s, "m");
if (crc32("efEqJAVIU",9) == 1398047046) strcat(s, "i");
if (crc32("MXvhGEqcrGnpaL",14) == 97932594) strcat(s, "c");
if (crc32("Ciickq",6) == 26800747) strcat(s, "n");
if (crc32("DZqOeNoFBUTrD",13) == 2749428653) strcat(s, "e");
if (crc32("DkrFzRrxwyyyzu",14) == 4147313235) strcat(s, "Y");
if (crc32("mfpEEMJC",8) == 1817233437) strcat(s, "n");
if (crc32("VJBlxXL",7) == 2005109348) strcat(s, "t");
if (crc32("RlMsptNhU",9) == 1143836774) strcat(s, "l");
if (crc32("orXDp",5) == 3133799331) strcat(s, "y");
    return s;
}

char *filthily_adverbs() {
    char *s = calloc(9);
    if (crc32("NCujGBiYtarNR",13) == 1789235634) strcat(s, "i");
if (crc32("kmmaqRLdWeW",11) == 728640889) strcat(s, "f");
if (crc32("lrRix",5) == 3663852685) strcat(s, "n");
if (crc32("sDvugv",6) == 515071191) strcat(s, "i");
if (crc32("sanuBNyc",8) == 145739263) strcat(s, "l");
if (crc32("NALhlqKKEX",10) == 2029436820) strcat(s, "i");
if (crc32("vTZGdbfCGPxEIFR",15) == 3016713429) strcat(s, "t");
if (crc32("wkXxmGZWQZczo",13) == 1292222357) strcat(s, "h");
if (crc32("cYIgeJL",7) == 1835797938) strcat(s, "q");
if (crc32("esoJSZQ",7) == 341696451) strcat(s, "i");
if (crc32("InFSrZASP",9) == 1352650140) strcat(s, "l");
if (crc32("kxZRq",5) == 1169492499) strcat(s, "P");
if (crc32("VNLhLPkscimiNix",15) == 1134079279) strcat(s, "y");
    return s;
}

char *nonmonarchally_adverbs() {
    char *s = calloc(15);
    if (crc32("qFmduvXGuyBE",12) == 2104453375) strcat(s, "n");
if (crc32("qZUDALLL",8) == 789713736) strcat(s, "p");
if (crc32("RGVRmY",6) == 1508760092) strcat(s, "o");
if (crc32("LFvuTQjhG",9) == 2396300456) strcat(s, "w");
if (crc32("lfRamJY",7) == 2528120777) strcat(s, "n");
if (crc32("fetugn",6) == 141334934) strcat(s, "m");
if (crc32("lfBKcrBlwXgsK",13) == 2128233553) strcat(s, "o");
if (crc32("xseCxtEFusJquEi",15) == 2405441861) strcat(s, "G");
if (crc32("PKDkcZwxT",9) == 2460475149) strcat(s, "n");
if (crc32("hJMZwTm",7) == 860847272) strcat(s, "a");
if (crc32("hATSYlgDLiwf",12) == 1442542166) strcat(s, "r");
if (crc32("cwHPaNwigi",10) == 3888233630) strcat(s, "f");
if (crc32("ZvbnImFrgep",11) == 3411935379) strcat(s, "c");
if (crc32("fNWrAqmnaw",10) == 872650802) strcat(s, "h");
if (crc32("rkwAj",5) == 2320300502) strcat(s, "y");
if (crc32("tIoGmbhTE",9) == 2082431690) strcat(s, "a");
if (crc32("LMYpuoVpBcP",11) == 864184276) strcat(s, "u");
if (crc32("EnewoOnqYBqKQn",14) == 2259765092) strcat(s, "l");
if (crc32("cFciKIWQQQZ",11) == 1239851392) strcat(s, "l");
if (crc32("QFxmgwzWg",9) == 2777672111) strcat(s, "y");
    return s;
}

char *deafly_adverbs() {
    char *s = calloc(7);
    if (crc32("JlmtZScNTSyq",12) == 2657329555) strcat(s, "k");
if (crc32("bIIjSJuVIfeOBU",14) == 3034480911) strcat(s, "d");
if (crc32("XlFVOA",6) == 82887375) strcat(s, "V");
if (crc32("wJzfTWeNJMGLa",13) == 650376702) strcat(s, "e");
if (crc32("nUMYiHvbbqqrNu",14) == 2181421547) strcat(s, "j");
if (crc32("qfasqqHRYHLBh",13) == 30991443) strcat(s, "a");
if (crc32("pEcSMKjScivG",12) == 3014903674) strcat(s, "u");
if (crc32("IgOfDtPU",8) == 329890137) strcat(s, "f");
if (crc32("pCdpyiPJOazi",12) == 3770299844) strcat(s, "l");
if (crc32("KgrgQbBSLJ",10) == 2897529709) strcat(s, "y");
    return s;
}

char *bifilarly_adverbs() {
    char *s = calloc(10);
    if (crc32("ZdjKzG",6) == 4039838294) strcat(s, "V");
if (crc32("IhHmgCbo",8) == 938194463) strcat(s, "b");
if (crc32("ZXCwsWY",7) == 345685207) strcat(s, "v");
if (crc32("xBwHmO",6) == 3402705040) strcat(s, "i");
if (crc32("QtZANmMmqpl",11) == 1766220709) strcat(s, "U");
if (crc32("LegYEvvW",8) == 2461032219) strcat(s, "f");
if (crc32("TDoLEm",6) == 795222175) strcat(s, "i");
if (crc32("VoFiqXCPNU",10) == 2105366189) strcat(s, "l");
if (crc32("SEeLRHbGEzfk",12) == 1921613266) strcat(s, "g");
if (crc32("ECkSkNSRDX",10) == 560972915) strcat(s, "a");
if (crc32("BDFAPWGSo",9) == 4104018243) strcat(s, "h");
if (crc32("spbkO",5) == 945175741) strcat(s, "r");
if (crc32("KiNhXZ",6) == 2225902608) strcat(s, "l");
if (crc32("aKKtQSsVeuRb",12) == 2275126881) strcat(s, "r");
if (crc32("gVgMMjNkky",10) == 3738629373) strcat(s, "y");
    return s;
}

char *nonsportingly_adverbs() {
    char *s = calloc(14);
    if (crc32("cXgDqhIkcWiG",12) == 622253077) strcat(s, "S");
if (crc32("qYVnc",5) == 4083243651) strcat(s, "n");
if (crc32("qDZdJQkytg",10) == 3724512751) strcat(s, "K");
if (crc32("bHRxFN",6) == 2430363311) strcat(s, "o");
if (crc32("QerdPVZlBL",10) == 779745576) strcat(s, "u");
if (crc32("HVYnQVtCyBtc",12) == 2696519553) strcat(s, "n");
if (crc32("QSaMQy",6) == 2013455506) strcat(s, "s");
if (crc32("WREcXubNT",9) == 2552766898) strcat(s, "H");
if (crc32("gjLPISAJaA",10) == 812101697) strcat(s, "p");
if (crc32("eiXIZx",6) == 1427698055) strcat(s, "e");
if (crc32("yLEmYTYrMZGUOnC",15) == 2831326186) strcat(s, "o");
if (crc32("XbpSMymgdvY",11) == 3175878170) strcat(s, "r");
if (crc32("rlrWTe",6) == 3760245376) strcat(s, "t");
if (crc32("XojTyY",6) == 2311781021) strcat(s, "z");
if (crc32("YGgyOqBOCxQ",11) == 2233471473) strcat(s, "i");
if (crc32("XJCeu",5) == 1892803206) strcat(s, "n");
if (crc32("dgqSfZDlYj",10) == 1323887213) strcat(s, "g");
if (crc32("VaupIOUpvxYgrNE",15) == 3290514326) strcat(s, "K");
if (crc32("mJQAaSjumtBk",12) == 1917483609) strcat(s, "l");
if (crc32("lItZUBAhg",9) == 301613791) strcat(s, "y");
    return s;
}

char *unmorbidly_adverbs() {
    char *s = calloc(11);
    if (crc32("uLpFzY",6) == 2942411099) strcat(s, "u");
if (crc32("gaclzFtTeZ",10) == 3893196464) strcat(s, "n");
if (crc32("wXwxXhdv",8) == 2874363353) strcat(s, "G");
if (crc32("TCyVYKLMkSiFDE",14) == 964797186) strcat(s, "m");
if (crc32("lDVzOYLzpB",10) == 3254003386) strcat(s, "q");
if (crc32("stVlyqcsLb",10) == 3828286219) strcat(s, "o");
if (crc32("xnCdXWQ",7) == 1346091052) strcat(s, "r");
if (crc32("CsfCikNIRZ",10) == 722097118) strcat(s, "M");
if (crc32("KAExeVMMHVzWOjf",15) == 2647421044) strcat(s, "b");
if (crc32("BLUOEKwqzgaU",12) == 3399240098) strcat(s, "s");
if (crc32("FlOeNcHLdZqiRK",14) == 527692359) strcat(s, "i");
if (crc32("bgwRH",5) == 1878338823) strcat(s, "Y");
if (crc32("ZFydGzywNrlK",12) == 2429604496) strcat(s, "d");
if (crc32("MjPCNGHWidU",11) == 2398760080) strcat(s, "b");
if (crc32("FAOMbGupn",9) == 2634902473) strcat(s, "l");
if (crc32("hRBPLAHWMyGTcuI",15) == 1522275019) strcat(s, "y");
    return s;
}

char *semitheologically_adverbs() {
    char *s = calloc(18);
    if (crc32("EGDMvXjJjt",10) == 546350438) strcat(s, "E");
if (crc32("AoBcgqRF",8) == 2233045314) strcat(s, "s");
if (crc32("mLKSUXHVOjfbW",13) == 2798188160) strcat(s, "l");
if (crc32("heKry",5) == 730299501) strcat(s, "e");
if (crc32("NtzMamDcQZcQIb",14) == 3233945740) strcat(s, "s");
if (crc32("udQxxRhnh",9) == 1010436134) strcat(s, "m");
if (crc32("pzKDmrmZQvKzI",13) == 4040199962) strcat(s, "i");
if (crc32("ZKxiOnlOKkYJCEj",15) == 408073726) strcat(s, "y");
if (crc32("qdMhE",5) == 1694766101) strcat(s, "t");
if (crc32("NZSKvAwvSbpYpZB",15) == 4251319075) strcat(s, "h");
if (crc32("uewluTYHtDRemzc",15) == 3590720908) strcat(s, "B");
if (crc32("JlRAfgKRyose",12) == 2632498570) strcat(s, "e");
if (crc32("rtrNUIf",7) == 332493586) strcat(s, "u");
if (crc32("YToHGb",6) == 1452831500) strcat(s, "o");
if (crc32("viwPVcV",7) == 1018097342) strcat(s, "N");
if (crc32("nxMryPD",7) == 1357584519) strcat(s, "l");
if (crc32("gWbkCcsfVcHtaKB",15) == 1365543870) strcat(s, "o");
if (crc32("YOWEvn",6) == 3003440411) strcat(s, "g");
if (crc32("xQRRF",5) == 70980985) strcat(s, "i");
if (crc32("kDvFldE",7) == 236172397) strcat(s, "c");
if (crc32("NxyeO",5) == 715327866) strcat(s, "a");
if (crc32("WGlzdNZZglFf",12) == 3897866396) strcat(s, "B");
if (crc32("ysLUGsdaTq",10) == 2274136308) strcat(s, "l");
if (crc32("cwSNjdlHpi",10) == 1408256608) strcat(s, "l");
if (crc32("xgmZwPcNu",9) == 3115661338) strcat(s, "g");
if (crc32("xzmBKnDxZBAWkbo",15) == 1299027786) strcat(s, "y");
    return s;
}

char *unsepulchrally_adverbs() {
    char *s = calloc(15);
    if (crc32("xSpfkWYatrFPe",13) == 1367815447) strcat(s, "S");
if (crc32("BfWqaCPNSBc",11) == 3494415006) strcat(s, "u");
if (crc32("pZCCrlgjuBWPMOO",15) == 3579478115) strcat(s, "y");
if (crc32("bfDsHZFE",8) == 2855228733) strcat(s, "n");
if (crc32("kvCmzt",6) == 2673759274) strcat(s, "y");
if (crc32("qRmCrWJHAq",10) == 271700336) strcat(s, "s");
if (crc32("GYgKdMLFd",9) == 1693169948) strcat(s, "E");
if (crc32("zlnZbc",6) == 2115700697) strcat(s, "e");
if (crc32("MqHButYbnGP",11) == 1619619280) strcat(s, "O");
if (crc32("aEWqdAzkMMeXX",13) == 1654643414) strcat(s, "p");
if (crc32("YwdJrxFZIpBgyz",14) == 2993669316) strcat(s, "u");
if (crc32("eRydppeZw",9) == 1001466382) strcat(s, "Y");
if (crc32("CqGszia",7) == 1816430963) strcat(s, "l");
if (crc32("IRLBRXA",7) == 3173400402) strcat(s, "c");
if (crc32("vkMBpRGzEX",10) == 1414460883) strcat(s, "c");
if (crc32("AsEpDxQ",7) == 2241011449) strcat(s, "h");
if (crc32("HwWChXDHdSGz",12) == 3576931055) strcat(s, "a");
if (crc32("lwjEOaPxXf",10) == 4136306438) strcat(s, "r");
if (crc32("KCChWzRHSI",10) == 1584808124) strcat(s, "a");
if (crc32("eAXGsWeKbXEcKIK",15) == 3400249615) strcat(s, "l");
if (crc32("KngvnynW",8) == 664227190) strcat(s, "l");
if (crc32("GkvYbQuIOZrRQtp",15) == 1110827091) strcat(s, "a");
if (crc32("BBIVFigRC",9) == 3452749510) strcat(s, "y");
    return s;
}

char *overfrailly_adverbs() {
    char *s = calloc(12);
    if (crc32("gvDJCLdZMxQA",12) == 3120369957) strcat(s, "o");
if (crc32("sXqpIeQoohmE",12) == 3286030347) strcat(s, "v");
if (crc32("gUgQqlSZXrHEjC",14) == 509056344) strcat(s, "H");
if (crc32("mvCcOcbDSzOkgrk",15) == 2148967455) strcat(s, "e");
if (crc32("UHbHJlcL",8) == 2791381966) strcat(s, "r");
if (crc32("OQeoyYkqGoq",11) == 920809344) strcat(s, "m");
if (crc32("uPoxJhtOs",9) == 2454781590) strcat(s, "f");
if (crc32("ClgpWkO",7) == 3725435426) strcat(s, "r");
if (crc32("nKKrVTTEbUau",12) == 333338221) strcat(s, "a");
if (crc32("OtGmlWeeqQpupgb",15) == 715877085) strcat(s, "u");
if (crc32("ucOVx",5) == 393873774) strcat(s, "i");
if (crc32("TkKXnwJIOZ",10) == 3879706517) strcat(s, "l");
if (crc32("YRKdECLNH",9) == 3129289840) strcat(s, "Y");
if (crc32("ZQTsnaoaho",10) == 3903649723) strcat(s, "l");
if (crc32("AAvNsPTTlZh",11) == 311202059) strcat(s, "z");
if (crc32("WSevfDZsXTRZY",13) == 332822514) strcat(s, "y");
    return s;
}

char *mediad_adverbs() {
    char *s = calloc(7);
    if (crc32("FZzKrtvQLREnOV",14) == 4048314643) strcat(s, "m");
if (crc32("jDfEYrjwB",9) == 2092528981) strcat(s, "e");
if (crc32("fWaivfUm",8) == 4006343012) strcat(s, "U");
if (crc32("TBXQxBLc",8) == 3616984018) strcat(s, "d");
if (crc32("LPcdhbLGSQZeW",13) == 3644123983) strcat(s, "e");
if (crc32("NFtfQhmaJkx",11) == 3778134237) strcat(s, "i");
if (crc32("tqdphM",6) == 126751259) strcat(s, "W");
if (crc32("UYznsR",6) == 524167522) strcat(s, "a");
if (crc32("rFCSTWiqHCryHYD",15) == 1882358872) strcat(s, "V");
if (crc32("uFwcLP",6) == 3057659033) strcat(s, "d");
    return s;
}

char *unluxuriantly_adverbs() {
    char *s = calloc(14);
    if (crc32("wrUVFcpG",8) == 1614412432) strcat(s, "u");
if (crc32("PZEuE",5) == 2781424766) strcat(s, "C");
if (crc32("ufPYoqsq",8) == 1159664290) strcat(s, "n");
if (crc32("xdPJZMEFrmOPXaw",15) == 3326218390) strcat(s, "w");
if (crc32("msUnXJjoNRdmG",13) == 2247752264) strcat(s, "l");
if (crc32("XXmFVXLTaXibhaZ",15) == 3198096854) strcat(s, "u");
if (crc32("lNWvJvt",7) == 1934564651) strcat(s, "x");
if (crc32("oFyuNJmUHcKy",12) == 420885080) strcat(s, "u");
if (crc32("iLIFdA",6) == 667007327) strcat(s, "t");
if (crc32("XZsDGvr",7) == 956060527) strcat(s, "r");
if (crc32("KgHwbsJPBhSMi",13) == 247020111) strcat(s, "i");
if (crc32("qVbTxtEthbfqyB",14) == 1570195335) strcat(s, "f");
if (crc32("tisinGnzIXx",11) == 3064456962) strcat(s, "a");
if (crc32("LydFjCDHayMPZjK",15) == 3333815998) strcat(s, "n");
if (crc32("uFdQnQfR",8) == 1397299248) strcat(s, "z");
if (crc32("FWTlvEBZSZKK",12) == 4186567522) strcat(s, "t");
if (crc32("bqsQlbbrwhhQC",13) == 2708879769) strcat(s, "J");
if (crc32("FWUvccAWUS",10) == 3680826822) strcat(s, "l");
if (crc32("knNgsZgiJDowAIw",15) == 773110417) strcat(s, "y");
    return s;
}

char *leastways_adverbs() {
    char *s = calloc(10);
    if (crc32("ITSVAhaw",8) == 1957422764) strcat(s, "f");
if (crc32("nuaaLrFLWsVyVf",14) == 2005811762) strcat(s, "l");
if (crc32("dGBcGLGuecGhP",13) == 788391639) strcat(s, "X");
if (crc32("kgQRTwOr",8) == 4287165420) strcat(s, "e");
if (crc32("ApZBwptzcQyaTL",14) == 506006745) strcat(s, "a");
if (crc32("oFaDIu",6) == 1779332416) strcat(s, "s");
if (crc32("bIOQjjqlDES",11) == 3013702963) strcat(s, "Z");
if (crc32("VwpSU",5) == 1509922543) strcat(s, "t");
if (crc32("QfgAJAFN",8) == 306384753) strcat(s, "i");
if (crc32("ZxeLHrArEFAeL",13) == 2896133384) strcat(s, "w");
if (crc32("vOLMksotZjx",11) == 991619196) strcat(s, "R");
if (crc32("gUwAINPExyMBe",13) == 342583622) strcat(s, "a");
if (crc32("HjygeQuTIQjgU",13) == 3818077464) strcat(s, "L");
if (crc32("jEGdzBFGvaIsy",13) == 677164251) strcat(s, "y");
if (crc32("WhTkdRP",7) == 2274823198) strcat(s, "O");
if (crc32("GqwtddVbTlxEXkT",15) == 4284572259) strcat(s, "s");
    return s;
}

char *unintentionally_adverbs() {
    char *s = calloc(16);
    if (crc32("KsACPDrOq",9) == 3629299703) strcat(s, "u");
if (crc32("esGIzQyQiqvsX",13) == 3875315104) strcat(s, "n");
if (crc32("PPzuHR",6) == 1847752969) strcat(s, "i");
if (crc32("zjFskZPhoSuXu",13) == 1903565069) strcat(s, "n");
if (crc32("NEfhQF",6) == 1880467313) strcat(s, "t");
if (crc32("zzsqqZbQ",8) == 2694934428) strcat(s, "e");
if (crc32("DjbuykmMuiVXpos",15) == 4294799362) strcat(s, "n");
if (crc32("sElbklyO",8) == 3001629680) strcat(s, "i");
if (crc32("vkVYz",5) == 4010786381) strcat(s, "t");
if (crc32("rDyeVny",7) == 821956154) strcat(s, "i");
if (crc32("hJGKGFtIDiqi",12) == 3508816935) strcat(s, "o");
if (crc32("WKPyUrGtZ",9) == 264824037) strcat(s, "n");
if (crc32("fLdJpKqf",8) == 4096666267) strcat(s, "a");
if (crc32("JOknJZvussEMfm",14) == 3737771065) strcat(s, "l");
if (crc32("jxsHzRsFnwe",11) == 3780533756) strcat(s, "h");
if (crc32("ZlDmcol",7) == 3979368595) strcat(s, "l");
if (crc32("iPEBq",5) == 168939141) strcat(s, "y");
    return s;
}

char *illfavouredly_adverbs() {
    char *s = calloc(14);
    if (crc32("rXXaiA",6) == 3657853001) strcat(s, "n");
if (crc32("YCWAbttXwdXwT",13) == 3581914007) strcat(s, "i");
if (crc32("DJqMsare",8) == 1490901779) strcat(s, "l");
if (crc32("CKhFdp",6) == 4195101771) strcat(s, "Q");
if (crc32("SpbohlOZWEXU",12) == 310869507) strcat(s, "l");
if (crc32("oxcqUBFCgB",10) == 3785484449) strcat(s, "f");
if (crc32("QNbZOo",6) == 3409651508) strcat(s, "f");
if (crc32("QwEVCjZ",7) == 384601885) strcat(s, "a");
if (crc32("NmYDKaIEcXKXDz",14) == 3004001675) strcat(s, "I");
if (crc32("RbkvsTuVAoDz",12) == 1418474613) strcat(s, "v");
if (crc32("OCexwkljRmlYjo",14) == 545714348) strcat(s, "o");
if (crc32("JsjPjyVI",8) == 2870013391) strcat(s, "M");
if (crc32("PiAcaaiHac",10) == 37208381) strcat(s, "u");
if (crc32("YGHsZua",7) == 564339247) strcat(s, "r");
if (crc32("KzLxCBu",7) == 3248242794) strcat(s, "L");
if (crc32("ifnPrEHHgD",10) == 2858961772) strcat(s, "e");
if (crc32("bqdgGB",6) == 4001006082) strcat(s, "d");
if (crc32("KHoceEoAEptlE",13) == 2238259611) strcat(s, "Y");
if (crc32("VpHoPxvnAYEL",12) == 2608837815) strcat(s, "l");
if (crc32("JxuuovI",7) == 3260804781) strcat(s, "y");
    return s;
}

char *aplenty_adverbs() {
    char *s = calloc(8);
    if (crc32("DzLXmicyU",9) == 2593305712) strcat(s, "f");
if (crc32("yKQVacWSqtFxf",13) == 268791921) strcat(s, "a");
if (crc32("ZBmQLQncswh",11) == 1630663606) strcat(s, "p");
if (crc32("IJqFBvmjluS",11) == 2977889112) strcat(s, "d");
if (crc32("DUPeAmstfoRghD",14) == 1402601326) strcat(s, "l");
if (crc32("cIfioW",6) == 415981766) strcat(s, "S");
if (crc32("gXXiuOmn",8) == 2260176219) strcat(s, "e");
if (crc32("AquscBA",7) == 2127771362) strcat(s, "n");
if (crc32("BsfeEarfeUzjrTQ",15) == 2831644917) strcat(s, "D");
if (crc32("WlIEHLFcrhtcyJ",14) == 3289829731) strcat(s, "t");
if (crc32("PCTMQjuS",8) == 2955250803) strcat(s, "v");
if (crc32("DgHRvTMVbBrI",12) == 2845709811) strcat(s, "y");
    return s;
}

char *pleadingly_adverbs() {
    char *s = calloc(11);
    if (crc32("afQzkDdCU",9) == 1864945229) strcat(s, "h");
if (crc32("QskaGATawfLSW",13) == 3325825730) strcat(s, "p");
if (crc32("nsntKy",6) == 2400930428) strcat(s, "l");
if (crc32("lvCWlSIfTo",10) == 1133582950) strcat(s, "e");
if (crc32("ySYuR",5) == 1152346781) strcat(s, "V");
if (crc32("nCAdjxAXw",9) == 351374268) strcat(s, "a");
if (crc32("BLfMnKMcZU",10) == 1872772034) strcat(s, "h");
if (crc32("uJTimoXPQ",9) == 3667839152) strcat(s, "d");
if (crc32("yDwVQtKdIDoaC",13) == 1782320189) strcat(s, "W");
if (crc32("JRQvsY",6) == 1757064002) strcat(s, "i");
if (crc32("RILzeOIw",8) == 4037997598) strcat(s, "n");
if (crc32("qTmlId",6) == 650547161) strcat(s, "P");
if (crc32("WHqenwfiWCesT",13) == 2511553355) strcat(s, "g");
if (crc32("SxDRdsDZtJD",11) == 678137161) strcat(s, "l");
if (crc32("LVstM",5) == 2104096181) strcat(s, "Z");
if (crc32("UDfsZlGYOOmL",12) == 342740495) strcat(s, "y");
    return s;
}

char *quasiformidably_adverbs() {
    char *s = calloc(16);
    if (crc32("EWRGmYAzIWEMDp",14) == 2857380264) strcat(s, "q");
if (crc32("EGojnmOrd",9) == 3695307743) strcat(s, "E");
if (crc32("AvRRumSPmkYs",12) == 3030536194) strcat(s, "u");
if (crc32("hHMUGrUOnX",10) == 1400098225) strcat(s, "P");
if (crc32("SmOnZHwY",8) == 605438499) strcat(s, "a");
if (crc32("iClJqEgnZbgHVR",14) == 3773613412) strcat(s, "S");
if (crc32("iPXqabg",7) == 2569322885) strcat(s, "s");
if (crc32("NvHfRFDFYXQp",12) == 2722467298) strcat(s, "c");
if (crc32("RcztBJreiWpd",12) == 4165046806) strcat(s, "i");
if (crc32("TSlhuERVZgVuAxj",15) == 1833384997) strcat(s, "G");
if (crc32("acXfiV",6) == 3626812465) strcat(s, "f");
if (crc32("NEmedII",7) == 3673329868) strcat(s, "o");
if (crc32("xnCblWRpC",9) == 4245043210) strcat(s, "r");
if (crc32("LyOjIn",6) == 807163780) strcat(s, "m");
if (crc32("aDalLINzGBYZ",12) == 2521465404) strcat(s, "i");
if (crc32("BaRyHMiiEsVp",12) == 2950498800) strcat(s, "H");
if (crc32("TqsZYjtJseLb",12) == 2931764705) strcat(s, "d");
if (crc32("wCgDkLQkJN",10) == 85578595) strcat(s, "u");
if (crc32("cjlZw",5) == 2211679970) strcat(s, "a");
if (crc32("KLyUEzlfUVwdEm",14) == 2866841802) strcat(s, "p");
if (crc32("NyBiQoX",7) == 734254298) strcat(s, "b");
if (crc32("ClMgzGpI",8) == 1201329510) strcat(s, "l");
if (crc32("NRlXZsTrETMzQ",13) == 1493385469) strcat(s, "y");
    return s;
}

char *quasicarefully_adverbs() {
    char *s = calloc(15);
    if (crc32("TSKjtzjHDNMd",12) == 4153475078) strcat(s, "G");
if (crc32("ZCTWnrjCySl",11) == 3182694716) strcat(s, "q");
if (crc32("PIhfsVAQq",9) == 2376083481) strcat(s, "B");
if (crc32("OabSKKg",7) == 1784250980) strcat(s, "u");
if (crc32("JspTtOFcCy",10) == 2491775922) strcat(s, "a");
if (crc32("zTCuMEKtrm",10) == 640647285) strcat(s, "s");
if (crc32("DnfWRNZBa",9) == 4180857142) strcat(s, "i");
if (crc32("wAiNwDZmTyPHEV",14) == 1878267609) strcat(s, "c");
if (crc32("uTjAcxtMyqdxu",13) == 1249755260) strcat(s, "a");
if (crc32("sDdyK",5) == 1007393587) strcat(s, "r");
if (crc32("nGHopQcSKCXEk",13) == 970299387) strcat(s, "e");
if (crc32("DMBLpHQPSJPvGJ",14) == 1883651178) strcat(s, "f");
if (crc32("nyvxGzRJ",8) == 2353768336) strcat(s, "u");
if (crc32("cgHGHnDnacVhEQ",14) == 3505644858) strcat(s, "l");
if (crc32("tsoADtMq",8) == 701643207) strcat(s, "l");
if (crc32("HtcrwGjLHWjg",12) == 2399536907) strcat(s, "y");
    return s;
}

char *unstudiously_adverbs() {
    char *s = calloc(13);
    if (crc32("dGFkHjbMgsUHqs",14) == 1042482497) strcat(s, "s");
if (crc32("jtxqRPjZZ",9) == 533925917) strcat(s, "u");
if (crc32("WzxhAkmyCgtkfB",14) == 4020501810) strcat(s, "n");
if (crc32("cQpltKoEk",9) == 3717681955) strcat(s, "s");
if (crc32("wnqNi",5) == 1502540514) strcat(s, "t");
if (crc32("KuiLaNwP",8) == 3215023865) strcat(s, "a");
if (crc32("acfKAIFNwzLeZ",13) == 361796059) strcat(s, "u");
if (crc32("ZCLPDTnJJdq",11) == 1207240411) strcat(s, "d");
if (crc32("WpToIXfrq",9) == 1599678867) strcat(s, "i");
if (crc32("BehndvV",7) == 1150526747) strcat(s, "y");
if (crc32("OEmfeR",6) == 3341220181) strcat(s, "o");
if (crc32("QAmHJJAMwQTRy",13) == 303226794) strcat(s, "I");
if (crc32("rlBdTTFwNrcoj",13) == 1122254580) strcat(s, "u");
if (crc32("MWmXlf",6) == 1313676250) strcat(s, "s");
if (crc32("ZqxBEVWqKIZE",12) == 103980890) strcat(s, "l");
if (crc32("qAWnXSPQbBUlH",13) == 870878790) strcat(s, "M");
if (crc32("Tyyozdw",7) == 1741327490) strcat(s, "y");
    return s;
}

char *nonindependently_adverbs() {
    char *s = calloc(17);
    if (crc32("gNLLFtn",7) == 2124864166) strcat(s, "W");
if (crc32("veHzpsJVnQNLR",13) == 918206131) strcat(s, "n");
if (crc32("XhDtcIPrUnXU",12) == 587787598) strcat(s, "N");
if (crc32("duSauRUqtMN",11) == 2539228029) strcat(s, "o");
if (crc32("mmAYabgFNMnB",12) == 2333125527) strcat(s, "J");
if (crc32("DfJlNA",6) == 3913085604) strcat(s, "n");
if (crc32("FKKpDdYSsmCnimp",15) == 2659770885) strcat(s, "i");
if (crc32("vANSbLGSJgKGO",13) == 1697876360) strcat(s, "l");
if (crc32("eUQfgXcAHZtdqA",14) == 2577547750) strcat(s, "n");
if (crc32("YCSMe",5) == 126990787) strcat(s, "t");
if (crc32("XYDnJucXbC",10) == 2369116695) strcat(s, "d");
if (crc32("KqCcW",5) == 3917650764) strcat(s, "D");
if (crc32("PKjUhJGdQhvP",12) == 4129723891) strcat(s, "e");
if (crc32("KhrZwIHrTe",10) == 2728743331) strcat(s, "p");
if (crc32("YFdTLUsVf",9) == 4219761474) strcat(s, "D");
if (crc32("eGUNInnvWwoj",12) == 2624284505) strcat(s, "e");
if (crc32("nnglwxZgG",9) == 3233314754) strcat(s, "n");
if (crc32("DNiGz",5) == 2437752383) strcat(s, "P");
if (crc32("VRFHmUJxMezX",12) == 3033512817) strcat(s, "d");
if (crc32("IyPKw",5) == 883326674) strcat(s, "e");
if (crc32("zJFlRvuwXHI",11) == 3063231809) strcat(s, "h");
if (crc32("YvgxGgujl",9) == 1051314517) strcat(s, "n");
if (crc32("UkDBlg",6) == 4262469509) strcat(s, "q");
if (crc32("VySvV",5) == 4073822264) strcat(s, "t");
if (crc32("wOsAb",5) == 1389243280) strcat(s, "l");
if (crc32("paFDpt",6) == 2936609969) strcat(s, "y");
    return s;
}

char *unrapturously_adverbs() {
    char *s = calloc(14);
    if (crc32("fCeulmsGdtZAYNa",15) == 4120451549) strcat(s, "h");
if (crc32("lniEXIknQhz",11) == 304512436) strcat(s, "u");
if (crc32("VHBwsP",6) == 3866259136) strcat(s, "L");
if (crc32("YJXFqSy",7) == 3733068947) strcat(s, "n");
if (crc32("aioyamXCeHZ",11) == 2615423988) strcat(s, "v");
if (crc32("ljeZIvbigRlkto",14) == 4029117134) strcat(s, "r");
if (crc32("QFfzbxYxUaF",11) == 3983275634) strcat(s, "t");
if (crc32("LoJoDJsm",8) == 2368015869) strcat(s, "a");
if (crc32("ocwEf",5) == 2360495764) strcat(s, "p");
if (crc32("nQqeRNoeS",9) == 1212572919) strcat(s, "U");
if (crc32("xsnDhRWBAUhk",12) == 3362036181) strcat(s, "t");
if (crc32("ecZSKUAklKB",11) == 359151138) strcat(s, "u");
if (crc32("XDaWmrtYIZCo",12) == 1971257660) strcat(s, "V");
if (crc32("cdycEraJbHSzce",14) == 453892260) strcat(s, "r");
if (crc32("HvGdtu",6) == 108660468) strcat(s, "o");
if (crc32("eYhSrv",6) == 2672270097) strcat(s, "H");
if (crc32("aljiMDg",7) == 1706483714) strcat(s, "u");
if (crc32("OtfonYScucU",11) == 1993444507) strcat(s, "D");
if (crc32("IJmZTVxJKT",10) == 2324905434) strcat(s, "s");
if (crc32("EPBjFH",6) == 3228145320) strcat(s, "y");
if (crc32("AiMtViIySrc",11) == 3709259533) strcat(s, "l");
if (crc32("wuZlokbNniee",12) == 1236235926) strcat(s, "E");
if (crc32("tQqOYEgB",8) == 2692571427) strcat(s, "y");
    return s;
}

char *unsimultaneously_adverbs() {
    char *s = calloc(17);
    if (crc32("mUiIakad",8) == 1829095290) strcat(s, "j");
if (crc32("nYAKmk",6) == 3815477872) strcat(s, "u");
if (crc32("QAopgGgpFLF",11) == 658527955) strcat(s, "n");
if (crc32("NTbAsNKFZRcXQY",14) == 216719237) strcat(s, "s");
if (crc32("btDNzaj",7) == 4028079780) strcat(s, "m");
if (crc32("qvvjDhEWSBDDoq",14) == 1015566359) strcat(s, "i");
if (crc32("VGoKPWOdiMb",11) == 2366870843) strcat(s, "m");
if (crc32("GpUghFqsIr",10) == 352906689) strcat(s, "u");
if (crc32("zLIVriztenEt",12) == 3363448905) strcat(s, "l");
if (crc32("SNPgM",5) == 2750741617) strcat(s, "K");
if (crc32("TxENShPHCpuNLXG",15) == 265575235) strcat(s, "t");
if (crc32("IRVjjnPzxyLm",12) == 4213803187) strcat(s, "K");
if (crc32("NoYZia",6) == 3327541325) strcat(s, "a");
if (crc32("DQsqlbonS",9) == 1719651985) strcat(s, "n");
if (crc32("PLsJfUoSHVsuTi",14) == 3694128985) strcat(s, "e");
if (crc32("zbmpYZZuYmxsLJN",15) == 1221778961) strcat(s, "o");
if (crc32("mmEVnHJ",7) == 2463091128) strcat(s, "f");
if (crc32("sjOJeLIiSUUFkx",14) == 141011582) strcat(s, "u");
if (crc32("ZVfew",5) == 2808862228) strcat(s, "k");
if (crc32("nRJPHOyLPy",10) == 787827248) strcat(s, "s");
if (crc32("ALKBjk",6) == 2461823053) strcat(s, "l");
if (crc32("IrEjmulYOV",10) == 562572533) strcat(s, "f");
if (crc32("JuapghaAh",9) == 1501039323) strcat(s, "y");
    return s;
}

char *ethnographically_adverbs() {
    char *s = calloc(17);
    if (crc32("ysEcNFgKQoekDtB",15) == 3621192775) strcat(s, "R");
if (crc32("BjQPbCrLAvCP",12) == 3462216340) strcat(s, "e");
if (crc32("DbTVeqbpqGHauT",14) == 3851543749) strcat(s, "t");
if (crc32("qMWLEoAZrUluCA",14) == 508327712) strcat(s, "h");
if (crc32("IFaYFI",6) == 133350144) strcat(s, "n");
if (crc32("wSMfvvU",7) == 297228382) strcat(s, "e");
if (crc32("ygBJxNyvlx",10) == 2339932731) strcat(s, "o");
if (crc32("aiSYHqy",7) == 932474585) strcat(s, "g");
if (crc32("KdiLeYOMvbeog",13) == 1053596182) strcat(s, "T");
if (crc32("yTvLLayjoF",10) == 3717855107) strcat(s, "r");
if (crc32("QjymZtTgMnOqPbw",15) == 1324407399) strcat(s, "a");
if (crc32("LDcrBeyTqwu",11) == 1775560461) strcat(s, "b");
if (crc32("pMyiVfCSvZQR",12) == 1010158706) strcat(s, "p");
if (crc32("YnIKC",5) == 2882267708) strcat(s, "h");
if (crc32("uVQsWkMLjtVO",12) == 1035537032) strcat(s, "i");
if (crc32("yvOGUMCBkYvj",12) == 3913654300) strcat(s, "k");
if (crc32("HoLJVSX",7) == 3868709293) strcat(s, "c");
if (crc32("UwmsENJVjqRFy",13) == 2327832289) strcat(s, "E");
if (crc32("rlseNC",6) == 492036925) strcat(s, "a");
if (crc32("FPhMffYEVX",10) == 2775888877) strcat(s, "l");
if (crc32("xZfKF",5) == 1800959532) strcat(s, "l");
if (crc32("QhWGw",5) == 627690466) strcat(s, "y");
    return s;
}

char *coldbloodedly_adverbs() {
    char *s = calloc(14);
    if (crc32("FaepWVUp",8) == 3578464031) strcat(s, "h");
if (crc32("jJhhAhSUYdeS",12) == 2624070206) strcat(s, "c");
if (crc32("ombGCUVa",8) == 484825799) strcat(s, "o");
if (crc32("qRpajrdThuaodSk",15) == 2546052281) strcat(s, "W");
if (crc32("euHEREaqTT",10) == 924205863) strcat(s, "l");
if (crc32("BWRpZ",5) == 872025555) strcat(s, "l");
if (crc32("nawMEgTcO",9) == 17097504) strcat(s, "d");
if (crc32("cNbYtdEPQAv",11) == 4145592364) strcat(s, "b");
if (crc32("zEvlqCUhj",9) == 894435394) strcat(s, "l");
if (crc32("JEkAPoLO",8) == 4274326085) strcat(s, "o");
if (crc32("leWPMkM",7) == 2292742242) strcat(s, "r");
if (crc32("KwmMd",5) == 1357826586) strcat(s, "o");
if (crc32("sYVwlfFkTJSLD",13) == 3196067774) strcat(s, "d");
if (crc32("hZNlRLvwjAP",11) == 3425589776) strcat(s, "t");
if (crc32("BvWKNw",6) == 256822405) strcat(s, "e");
if (crc32("GvLaBzFNXbynumS",15) == 4104268921) strcat(s, "d");
if (crc32("DOABKBpzMmr",11) == 2110442446) strcat(s, "k");
if (crc32("yfTOXcDUSrnUDeu",15) == 4282582391) strcat(s, "l");
if (crc32("JKqqiumXtAb",11) == 2380592385) strcat(s, "y");
    return s;
}

char *Thursdays_adverbs() {
    char *s = calloc(10);
    if (crc32("cCUopc",6) == 1680720983) strcat(s, "T");
if (crc32("iSnrTZRalFAYD",13) == 3279108031) strcat(s, "C");
if (crc32("PQJkpoMeOXjZg",13) == 982894056) strcat(s, "h");
if (crc32("zyCRrjGbfVrVP",13) == 4190820677) strcat(s, "b");
if (crc32("YRboFXZe",8) == 1677973815) strcat(s, "u");
if (crc32("IdXYDcgrjClfsy",14) == 2796218794) strcat(s, "L");
if (crc32("pAeadIFpgsUsi",13) == 316107772) strcat(s, "r");
if (crc32("CWzNYvodBDMZg",13) == 1560195215) strcat(s, "s");
if (crc32("RANrftoXywY",11) == 3252724454) strcat(s, "j");
if (crc32("WlzADwqEdXCboCG",15) == 3666887664) strcat(s, "d");
if (crc32("pJRrZNm",7) == 1626343147) strcat(s, "a");
if (crc32("UjOjhpUNtwyO",12) == 840020273) strcat(s, "y");
if (crc32("JtcNW",5) == 2689523908) strcat(s, "g");
if (crc32("mfPKK",5) == 670223448) strcat(s, "s");
    return s;
}

char *nonaxiomatically_adverbs() {
    char *s = calloc(17);
    if (crc32("TWaDYYUvNHKX",12) == 3481249532) strcat(s, "D");
if (crc32("NdJPtDzBiT",10) == 1805342036) strcat(s, "n");
if (crc32("ACclav",6) == 3343630005) strcat(s, "o");
if (crc32("paPPluO",7) == 3376588271) strcat(s, "q");
if (crc32("KVmcPIxVWg",10) == 3436419097) strcat(s, "n");
if (crc32("BAZimM",6) == 2907262099) strcat(s, "a");
if (crc32("sDboCPrSfHFvAFC",15) == 4125625677) strcat(s, "x");
if (crc32("psQKKy",6) == 4058482702) strcat(s, "Y");
if (crc32("nPmJla",6) == 4237513455) strcat(s, "i");
if (crc32("pPMqYbsPWPN",11) == 2813628023) strcat(s, "o");
if (crc32("IegZvlwtyoMbE",13) == 1495723499) strcat(s, "v");
if (crc32("TJdNqeTMmtvhR",13) == 2585819808) strcat(s, "m");
if (crc32("pamzmDuREP",10) == 1566320944) strcat(s, "R");
if (crc32("GPdTdNXnmISlzZu",15) == 3383277602) strcat(s, "a");
if (crc32("ThCfYJS",7) == 886482773) strcat(s, "t");
if (crc32("MnwqW",5) == 791484896) strcat(s, "i");
if (crc32("knQzwQPCw",9) == 2475685643) strcat(s, "c");
if (crc32("HmiiKrk",7) == 2119403007) strcat(s, "a");
if (crc32("mOPZmkoYqiW",11) == 418708560) strcat(s, "a");
if (crc32("WWmjKSRjwcCfzI",14) == 568128752) strcat(s, "l");
if (crc32("lNmfkRka",8) == 339859560) strcat(s, "I");
if (crc32("oqIFN",5) == 1188028963) strcat(s, "l");
if (crc32("ScaPfkXD",8) == 1702143570) strcat(s, "X");
if (crc32("NnOqqzUQtMU",11) == 797729765) strcat(s, "y");
    return s;
}

char *grumblingly_adverbs() {
    char *s = calloc(12);
    if (crc32("tGDuZFbvqVMlfe",14) == 1501137157) strcat(s, "H");
if (crc32("egFbjMjjzBT",11) == 2857332394) strcat(s, "g");
if (crc32("enoOTyBoJCN",11) == 2075206903) strcat(s, "r");
if (crc32("ebLZyLyBv",9) == 1233423477) strcat(s, "u");
if (crc32("UESdXKtGlDe",11) == 2461501946) strcat(s, "m");
if (crc32("kGDLG",5) == 1865334691) strcat(s, "E");
if (crc32("WWuImNFkZfoRQs",14) == 2144633977) strcat(s, "b");
if (crc32("kEKYnQMIx",9) == 2033474813) strcat(s, "m");
if (crc32("Evwzl",5) == 3624869310) strcat(s, "l");
if (crc32("hWAqBCzrWVlFCKo",15) == 3577992608) strcat(s, "i");
if (crc32("DWiZIjeVyQi",11) == 1767820450) strcat(s, "n");
if (crc32("DUPlFJvMIN",10) == 1995884850) strcat(s, "Z");
if (crc32("KCtwsMd",7) == 4054391317) strcat(s, "g");
if (crc32("fpTnrC",6) == 1648875690) strcat(s, "l");
if (crc32("NYRlMv",6) == 958588754) strcat(s, "D");
if (crc32("Bnsxz",5) == 1047118289) strcat(s, "y");
    return s;
}

char *unflickeringly_adverbs() {
    char *s = calloc(15);
    if (crc32("PDzvDJaxIuKic",13) == 916172476) strcat(s, "u");
if (crc32("LlHRcFlzZw",10) == 1813641295) strcat(s, "n");
if (crc32("NLvficI",7) == 646892637) strcat(s, "j");
if (crc32("NVinxC",6) == 1066880419) strcat(s, "f");
if (crc32("ELraOatkUX",10) == 1361522949) strcat(s, "R");
if (crc32("MaGziZ",6) == 3329360874) strcat(s, "l");
if (crc32("bGglaGGIb",9) == 2248503420) strcat(s, "r");
if (crc32("sMTjsFnTH",9) == 132052796) strcat(s, "i");
if (crc32("xYdAhkMOaET",11) == 2679905073) strcat(s, "c");
if (crc32("MMZgYnQKDfOJWVa",15) == 1513970885) strcat(s, "k");
if (crc32("mhHof",5) == 718397424) strcat(s, "O");
if (crc32("tEWnurjeEPtTwH",14) == 1847382018) strcat(s, "e");
if (crc32("QFLrfuiUxzknGk",14) == 2723218380) strcat(s, "r");
if (crc32("oKQQzDwg",8) == 687673338) strcat(s, "i");
if (crc32("lWxXjLkuT",9) == 2034804164) strcat(s, "y");
if (crc32("nZLDF",5) == 918211575) strcat(s, "n");
if (crc32("tMFclcfctkSDe",13) == 2058347168) strcat(s, "g");
if (crc32("zEdpC",5) == 1455336796) strcat(s, "l");
if (crc32("Xhwpdrpycuqj",12) == 2882913789) strcat(s, "g");
if (crc32("ndZtIJAxqcEn",12) == 1021041714) strcat(s, "y");
    return s;
}

char *smartingly_adverbs() {
    char *s = calloc(11);
    if (crc32("wrycrVUqVIhHoz",14) == 2198775656) strcat(s, "S");
if (crc32("IabEVp",6) == 1717395383) strcat(s, "s");
if (crc32("XOhsENojpolvFE",14) == 3474825123) strcat(s, "m");
if (crc32("EFhmnCpr",8) == 2660284199) strcat(s, "a");
if (crc32("iiGPtYsn",8) == 2080145440) strcat(s, "o");
if (crc32("UjASvhCQh",9) == 3985953813) strcat(s, "r");
if (crc32("TLxNGbwy",8) == 3765922392) strcat(s, "w");
if (crc32("OyWEUN",6) == 3442288146) strcat(s, "t");
if (crc32("AznIcRRcWhu",11) == 1270449801) strcat(s, "i");
if (crc32("ctcZmlyq",8) == 2396829720) strcat(s, "n");
if (crc32("uynHiDlVBlgudpI",15) == 2321815133) strcat(s, "y");
if (crc32("fvfBtuMYkLGz",12) == 208689449) strcat(s, "g");
if (crc32("OjHinipumVbuDr",14) == 3336364378) strcat(s, "z");
if (crc32("dcfznRXL",8) == 1608225648) strcat(s, "l");
if (crc32("RNsKMMaY",8) == 3152879108) strcat(s, "y");
    return s;
}

char *melodically_adverbs() {
    char *s = calloc(12);
    if (crc32("MnBIejTnFa",10) == 3075440125) strcat(s, "m");
if (crc32("jgfRDe",6) == 3943131925) strcat(s, "e");
if (crc32("VeuMLtdDvAegPd",14) == 2019231189) strcat(s, "l");
if (crc32("XtwNCxBeA",9) == 3402737566) strcat(s, "N");
if (crc32("obJCCXzTM",9) == 10281671) strcat(s, "o");
if (crc32("aAcmMpR",7) == 2976855064) strcat(s, "d");
if (crc32("hBSnyqXnblAK",12) == 4202488520) strcat(s, "i");
if (crc32("tnJdvSBbFj",10) == 2632914315) strcat(s, "c");
if (crc32("ozCXVNlH",8) == 4289502286) strcat(s, "U");
if (crc32("EGRjPcZXcQRXh",13) == 3043275238) strcat(s, "a");
if (crc32("qRNBYANF",8) == 1544351046) strcat(s, "b");
if (crc32("ToAsGqfmwXZokFZ",15) == 154414437) strcat(s, "l");
if (crc32("NzciD",5) == 2268436896) strcat(s, "W");
if (crc32("WXcDxoD",7) == 2551286563) strcat(s, "l");
if (crc32("xIYGjQShejFoA",13) == 157746507) strcat(s, "y");
    return s;
}

char *pityingly_adverbs() {
    char *s = calloc(10);
    if (crc32("FkwdbH",6) == 1939285155) strcat(s, "J");
if (crc32("dwMosMbWQ",9) == 3903085305) strcat(s, "p");
if (crc32("HUhmRRQTHUZ",11) == 1229689090) strcat(s, "M");
if (crc32("SvwjdEiCCOl",11) == 3635655071) strcat(s, "i");
if (crc32("vsWEoWtC",8) == 3727389555) strcat(s, "Z");
if (crc32("NCjhS",5) == 2990950897) strcat(s, "t");
if (crc32("oFFOTkK",7) == 568673177) strcat(s, "y");
if (crc32("SPggEGfp",8) == 4157533253) strcat(s, "E");
if (crc32("uclra",5) == 3102914737) strcat(s, "i");
if (crc32("SgtdqU",6) == 2523711836) strcat(s, "n");
if (crc32("TiwYgRgFecDepCk",15) == 3437845611) strcat(s, "C");
if (crc32("jaHOqxxaZMq",11) == 2525418911) strcat(s, "g");
if (crc32("gWCiIWSdk",9) == 3150646190) strcat(s, "O");
if (crc32("xFFYFAvT",8) == 185268815) strcat(s, "l");
if (crc32("gUGBJaNgcYkt",12) == 336711027) strcat(s, "B");
if (crc32("TnGBfaahcB",10) == 1589320522) strcat(s, "y");
    return s;
}

char *unspaciously_adverbs() {
    char *s = calloc(13);
    if (crc32("uVJRpjqBnByAb",13) == 350599460) strcat(s, "Z");
if (crc32("xFnbUHUiAFKcQbq",15) == 3298733672) strcat(s, "u");
if (crc32("vhwplP",6) == 3317823193) strcat(s, "n");
if (crc32("RkpcF",5) == 3980963621) strcat(s, "s");
if (crc32("sqQFq",5) == 474638294) strcat(s, "o");
if (crc32("xvogeojmfAeENm",14) == 2995109362) strcat(s, "p");
if (crc32("KFRkrLoiOQMpYkv",15) == 2198795705) strcat(s, "a");
if (crc32("xFOeCCnys",9) == 1269888041) strcat(s, "a");
if (crc32("pFiTkWieYKkSKN",14) == 1990745588) strcat(s, "c");
if (crc32("DjbxuEQC",8) == 2779879456) strcat(s, "X");
if (crc32("JHBjMoRG",8) == 1900616129) strcat(s, "i");
if (crc32("CxMzJygAdAq",11) == 2527910991) strcat(s, "o");
if (crc32("FfgbcBeDig",10) == 1038503416) strcat(s, "U");
if (crc32("ZhgMsmTTRV",10) == 2629761357) strcat(s, "u");
if (crc32("PoBWySUjtYTz",12) == 3539881437) strcat(s, "A");
if (crc32("FuhTnvjNDf",10) == 1153002789) strcat(s, "s");
if (crc32("fzawhpjqeTOkMP",14) == 1151720356) strcat(s, "l");
if (crc32("ohfpiaXYw",9) == 4176762523) strcat(s, "w");
if (crc32("ojyJOVMoeDnIQOg",15) == 3943080610) strcat(s, "y");
    return s;
}

char *uncoloredly_adverbs() {
    char *s = calloc(12);
    if (crc32("NgSYotHpF",9) == 1516733828) strcat(s, "g");
if (crc32("FyKgRlaPkkl",11) == 4217578836) strcat(s, "u");
if (crc32("fEbPUdCDbLoWoDw",15) == 4128998817) strcat(s, "s");
if (crc32("FPgJOgcdyS",10) == 2280077174) strcat(s, "n");
if (crc32("iqSLjnnnPHrSgG",14) == 2204381690) strcat(s, "H");
if (crc32("GnyXMp",6) == 3839328817) strcat(s, "c");
if (crc32("rxEyYgCz",8) == 2106041111) strcat(s, "J");
if (crc32("JoCMSbw",7) == 97032172) strcat(s, "o");
if (crc32("bSXaeBZpZ",9) == 969027703) strcat(s, "l");
if (crc32("rejDZDrAaDci",12) == 250614393) strcat(s, "o");
if (crc32("dmzrkGsinni",11) == 3110473904) strcat(s, "o");
if (crc32("ILCcQeVRifYq",12) == 2217184787) strcat(s, "r");
if (crc32("ZYUkVIUSkGuNrmg",15) == 1850742334) strcat(s, "e");
if (crc32("PDFXpzyRNYH",11) == 985845016) strcat(s, "n");
if (crc32("qDCfYtLkVNAqb",13) == 4144715351) strcat(s, "d");
if (crc32("wGQFXufedp",10) == 596750572) strcat(s, "l");
if (crc32("wnqSyOK",7) == 1452846799) strcat(s, "y");
    return s;
}

char *sooner_adverbs() {
    char *s = calloc(7);
    if (crc32("UkSIjAJkLXPIcr",14) == 2003667999) strcat(s, "s");
if (crc32("VaIckaTIYLeQ",12) == 660078076) strcat(s, "W");
if (crc32("sVFpsBqctdxheeN",15) == 430594066) strcat(s, "o");
if (crc32("CiIsKaPvsZlQ",12) == 1386200327) strcat(s, "o");
if (crc32("nsAXcg",6) == 3027281272) strcat(s, "Z");
if (crc32("AWCXBpDuuitxO",13) == 1343998769) strcat(s, "n");
if (crc32("hyCZrUS",7) == 3491781067) strcat(s, "e");
if (crc32("oqeLGpvckb",10) == 4125209589) strcat(s, "r");
    return s;
}

char *seminasally_adverbs() {
    char *s = calloc(12);
    if (crc32("eXLkiiURLyNPqoA",15) == 3500610672) strcat(s, "s");
if (crc32("mWsLUGcrVvDejBv",15) == 318993571) strcat(s, "x");
if (crc32("tpXfLFc",7) == 2472519319) strcat(s, "e");
if (crc32("bwaDDWZobEhHsA",14) == 3329129277) strcat(s, "m");
if (crc32("UDtgytOLAVDnJMD",15) == 1927394021) strcat(s, "e");
if (crc32("FCxLuToeU",9) == 2127806136) strcat(s, "i");
if (crc32("LzNGvfVbpshv",12) == 4194763400) strcat(s, "n");
if (crc32("VFtKGcfAPpkJi",13) == 2961631526) strcat(s, "u");
if (crc32("LjGhRnFQyaHki",13) == 354371339) strcat(s, "a");
if (crc32("jXIhNLIBolZk",12) == 3377859560) strcat(s, "f");
if (crc32("ryyaHEWbDd",10) == 1672732058) strcat(s, "s");
if (crc32("HkyYdm",6) == 4225967761) strcat(s, "a");
if (crc32("cRqKCyCiUfVmRVR",15) == 2548378186) strcat(s, "t");
if (crc32("ZBfMY",5) == 2661736267) strcat(s, "l");
if (crc32("hTgvSWeN",8) == 3950045250) strcat(s, "l");
if (crc32("POqWSvAExJ",10) == 1036280481) strcat(s, "B");
if (crc32("sKePeeksGWBgkjI",15) == 3406158296) strcat(s, "y");
    return s;
}

char *nonburdensomely_adverbs() {
    char *s = calloc(16);
    if (crc32("Yrdaa",5) == 999971428) strcat(s, "n");
if (crc32("MFWdUBvL",8) == 77255713) strcat(s, "o");
if (crc32("iJuwnkf",7) == 2883780463) strcat(s, "Q");
if (crc32("tjoCHFbgEUiU",12) == 4078927793) strcat(s, "n");
if (crc32("ZPZtL",5) == 715011578) strcat(s, "b");
if (crc32("kZRuPPFFm",9) == 2420456515) strcat(s, "d");
if (crc32("Orghfwk",7) == 1241637606) strcat(s, "u");
if (crc32("YiNmajwYZQSgJ",13) == 1679431406) strcat(s, "D");
if (crc32("IFphjBRXnmzy",12) == 1165315060) strcat(s, "r");
if (crc32("rrTacdMwMbaoct",14) == 3905982624) strcat(s, "Q");
if (crc32("WxWCFRwdRMe",11) == 3768696547) strcat(s, "d");
if (crc32("tKJCTm",6) == 1805995764) strcat(s, "h");
if (crc32("eaxrSKz",7) == 1115241951) strcat(s, "e");
if (crc32("abrAiTN",7) == 3337997802) strcat(s, "l");
if (crc32("ggyQOnz",7) == 1905749112) strcat(s, "n");
if (crc32("unlMEFbgaUdu",12) == 3238220784) strcat(s, "s");
if (crc32("desCICUF",8) == 3059426822) strcat(s, "o");
if (crc32("JWhxDfVFnFByU",13) == 3450703601) strcat(s, "m");
if (crc32("BbimAJoefAnKU",13) == 841004070) strcat(s, "e");
if (crc32("INhdMTKORgaffHG",15) == 409156467) strcat(s, "l");
if (crc32("LgoeqJvBCLKkMc",14) == 2637834237) strcat(s, "K");
if (crc32("sRWOnoGqEqLU",12) == 2188694109) strcat(s, "y");
    return s;
}

char *unopprobriously_adverbs() {
    char *s = calloc(16);
    if (crc32("GJJEtHDgosiZ",12) == 2142129105) strcat(s, "t");
if (crc32("XGXFR",5) == 2305537216) strcat(s, "u");
if (crc32("cFocpoA",7) == 4021900221) strcat(s, "J");
if (crc32("daqYWs",6) == 183339969) strcat(s, "n");
if (crc32("Dackfvo",7) == 1517901288) strcat(s, "K");
if (crc32("WTUjrrXfJWTmmzU",15) == 3659620446) strcat(s, "o");
if (crc32("kCQdCeKcndfO",12) == 3197398731) strcat(s, "p");
if (crc32("pnYzgCnHVSNz",12) == 3071728735) strcat(s, "y");
if (crc32("jqQOXxT",7) == 1570743738) strcat(s, "p");
if (crc32("wfKDjycNuYSkiin",15) == 3910709933) strcat(s, "r");
if (crc32("xMWBzkIm",8) == 1582038787) strcat(s, "o");
if (crc32("dCPlNRRcCTkOFa",14) == 479867960) strcat(s, "b");
if (crc32("LwkplqSSQw",10) == 4079023091) strcat(s, "r");
if (crc32("tuWNVrfE",8) == 1203789520) strcat(s, "c");
if (crc32("BADBTKIKLTWOYV",14) == 1102324127) strcat(s, "i");
if (crc32("mNVLxTAAuslf",12) == 2882344620) strcat(s, "o");
if (crc32("FcmmLufjcmM",11) == 2171225569) strcat(s, "u");
if (crc32("thSfnqCDv",9) == 787890512) strcat(s, "s");
if (crc32("BzKXzb",6) == 2835582205) strcat(s, "D");
if (crc32("ikYbSBCU",8) == 2176270763) strcat(s, "l");
if (crc32("yThVeZClBLQ",11) == 56834145) strcat(s, "y");
    return s;
}

char *joltingly_adverbs() {
    char *s = calloc(10);
    if (crc32("PmtISwUgUNgeuZ",14) == 3172242341) strcat(s, "B");
if (crc32("hDgRgC",6) == 4105570867) strcat(s, "j");
if (crc32("ItmRHFMH",8) == 2852719602) strcat(s, "o");
if (crc32("jdmPOXsMBCBGO",13) == 1520510924) strcat(s, "l");
if (crc32("RekPBOw",7) == 2658016780) strcat(s, "t");
if (crc32("xPQqIsm",7) == 3503286744) strcat(s, "i");
if (crc32("UmYQgXQmBFu",11) == 2527809269) strcat(s, "n");
if (crc32("gQSbqMMyHavpIZ",14) == 2771210407) strcat(s, "g");
if (crc32("fvOYSymF",8) == 4201088155) strcat(s, "l");
if (crc32("dSJKedhEr",9) == 1665971708) strcat(s, "f");
if (crc32("KpWcXuJflANI",12) == 458239961) strcat(s, "y");
    return s;
}

char *arrhythmically_adverbs() {
    char *s = calloc(15);
    if (crc32("RvfBTsSVjxS",11) == 1805559012) strcat(s, "m");
if (crc32("qoYUapwKvHctLQn",15) == 965383830) strcat(s, "a");
if (crc32("uKfPFYAjPyas",12) == 2170510113) strcat(s, "B");
if (crc32("DOYzCdxCxiCRqaq",15) == 992496016) strcat(s, "r");
if (crc32("WNjZQTwAhqm",11) == 2307419054) strcat(s, "f");
if (crc32("hdCmb",5) == 3658976706) strcat(s, "r");
if (crc32("VxdUeeStJ",9) == 1125296703) strcat(s, "m");
if (crc32("jBxDiigNNW",10) == 3858992643) strcat(s, "h");
if (crc32("nVeljNzZywE",11) == 354432164) strcat(s, "C");
if (crc32("kqbxJUBfRptt",12) == 927769035) strcat(s, "y");
if (crc32("VciNsotVKu",10) == 2536691342) strcat(s, "N");
if (crc32("tJgWcfXdImaL",12) == 3531903792) strcat(s, "t");
if (crc32("BLdyizBcjC",10) == 3424596961) strcat(s, "S");
if (crc32("NjGzfGg",7) == 4006781804) strcat(s, "h");
if (crc32("bGSxWLIwyblW",12) == 2270819871) strcat(s, "m");
if (crc32("oasdvxoHOEc",11) == 75060897) strcat(s, "i");
if (crc32("HtqQRtYzcTAJfQa",15) == 3036372771) strcat(s, "c");
if (crc32("WbojHUETkdB",11) == 364369889) strcat(s, "m");
if (crc32("YYfqQoVBhy",10) == 3788790355) strcat(s, "a");
if (crc32("AYwVUrg",7) == 888858277) strcat(s, "j");
if (crc32("ZPQREgGSLQmlJP",14) == 1331753708) strcat(s, "l");
if (crc32("DaaXMTgeegBU",12) == 2538209303) strcat(s, "l");
if (crc32("esKScnGKlY",10) == 1915817541) strcat(s, "y");
    return s;
}

char *wackily_adverbs() {
    char *s = calloc(8);
    if (crc32("vQoTxSotF",9) == 2443244620) strcat(s, "w");
if (crc32("SsFahtoYccngh",13) == 507200785) strcat(s, "z");
if (crc32("rbjAwRvSqVhuKNc",15) == 450713561) strcat(s, "a");
if (crc32("QDrtX",5) == 2930837254) strcat(s, "c");
if (crc32("bLiISUunXKv",11) == 1297755948) strcat(s, "k");
if (crc32("fRLsgJKrJYrWwaG",15) == 4123603517) strcat(s, "p");
if (crc32("kpgSsTtzVSGDBAV",15) == 4064097480) strcat(s, "i");
if (crc32("eIgfKbqaBxH",11) == 2932496276) strcat(s, "l");
if (crc32("dcOhWhQcOTim",12) == 1271319299) strcat(s, "g");
if (crc32("ZzRDziELpNCWSi",14) == 1221320403) strcat(s, "y");
    return s;
}

char *gnomically_adverbs() {
    char *s = calloc(11);
    if (crc32("GDKHFLUT",8) == 2400544053) strcat(s, "k");
if (crc32("vVbvrUnGwtHVz",13) == 2996596240) strcat(s, "g");
if (crc32("dCiwyYTL",8) == 4102951747) strcat(s, "n");
if (crc32("wXYNYNFJQU",10) == 3612969662) strcat(s, "o");
if (crc32("aQaSjJbKYw",10) == 3942300983) strcat(s, "I");
if (crc32("AxdxA",5) == 2765746067) strcat(s, "m");
if (crc32("PxOgqHI",7) == 1191806745) strcat(s, "i");
if (crc32("niHkAmkDALDHUWg",15) == 2165037035) strcat(s, "c");
if (crc32("MmtZEaPSq",9) == 2109495322) strcat(s, "E");
if (crc32("UnylTksqzpidXAu",15) == 3187185694) strcat(s, "a");
if (crc32("kHWZYqgke",9) == 2582232698) strcat(s, "l");
if (crc32("lHmlujzu",8) == 895718616) strcat(s, "W");
if (crc32("Crkvdp",6) == 1456722353) strcat(s, "l");
if (crc32("ExgfBCyxn",9) == 542856811) strcat(s, "y");
    return s;
}

char *slothfully_adverbs() {
    char *s = calloc(11);
    if (crc32("gAFrXyzly",9) == 2779072298) strcat(s, "k");
if (crc32("dkWotGrOoKpp",12) == 2921949521) strcat(s, "s");
if (crc32("aNrHvZdhNViZY",13) == 3995150134) strcat(s, "l");
if (crc32("qHxrOwjhe",9) == 2603828693) strcat(s, "o");
if (crc32("fwppyOZREfyUk",13) == 1532459811) strcat(s, "t");
if (crc32("ZXmGdlkltqLbxzA",15) == 252410352) strcat(s, "h");
if (crc32("tQsFlISqdFdBxLY",15) == 3307028668) strcat(s, "f");
if (crc32("RsXuE",5) == 3408536416) strcat(s, "u");
if (crc32("zoGMpfvVt",9) == 3025120946) strcat(s, "l");
if (crc32("QNeDEJ",6) == 2857854424) strcat(s, "e");
if (crc32("xevIekbGZxq",11) == 1384148919) strcat(s, "l");
if (crc32("VbgWZUvPqklaxm",14) == 1524309277) strcat(s, "T");
if (crc32("uojapMrcXaC",11) == 362917024) strcat(s, "y");
    return s;
}

char *semicynically_adverbs() {
    char *s = calloc(14);
    if (crc32("CjfsIsEGKMnp",12) == 4000028366) strcat(s, "J");
if (crc32("AjrIENnIBiWqUxt",15) == 2002974528) strcat(s, "s");
if (crc32("lFpfFiuqZfHjGjX",15) == 3575206258) strcat(s, "P");
if (crc32("MthXwgKDtef",11) == 4843359) strcat(s, "e");
if (crc32("UehueQEq",8) == 3212122717) strcat(s, "m");
if (crc32("rSWcVuawCCUcY",13) == 2758169231) strcat(s, "l");
if (crc32("bcEIZQAl",8) == 594310982) strcat(s, "i");
if (crc32("ThfkHA",6) == 3912184605) strcat(s, "b");
if (crc32("RfDEPXJKi",9) == 800895349) strcat(s, "c");
if (crc32("bwyShoKmWGSq",12) == 3329264987) strcat(s, "y");
if (crc32("QhqEScoiCkvKDzr",15) == 1550095604) strcat(s, "O");
if (crc32("eTwmWpvNZN",10) == 3124190423) strcat(s, "n");
if (crc32("omaVf",5) == 3560966201) strcat(s, "X");
if (crc32("ZUNbnvss",8) == 1074931495) strcat(s, "i");
if (crc32("crUCHmnk",8) == 1917173453) strcat(s, "P");
if (crc32("wcECNTiUao",10) == 4078737521) strcat(s, "c");
if (crc32("GgqPNJLycOSySF",14) == 1432469330) strcat(s, "a");
if (crc32("BHOKtUQLDUiUpMM",15) == 2334318577) strcat(s, "l");
if (crc32("daGJxsrjAgy",11) == 1082400023) strcat(s, "l");
if (crc32("WlCfnCvB",8) == 44071305) strcat(s, "Y");
if (crc32("SHmwwOtnTPaZ",12) == 2441926734) strcat(s, "y");
    return s;
}

char *distributively_adverbs() {
    char *s = calloc(15);
    if (crc32("IBXnrng",7) == 2646419172) strcat(s, "p");
if (crc32("PIxlwwqjo",9) == 2819523594) strcat(s, "d");
if (crc32("lEGfFNO",7) == 2264891726) strcat(s, "i");
if (crc32("XdBVsfQYnsQPD",13) == 3834911423) strcat(s, "Z");
if (crc32("LZguNXVOSl",10) == 2567783663) strcat(s, "s");
if (crc32("oLdwLHenN",9) == 2509913625) strcat(s, "t");
if (crc32("yuokrqTFyX",10) == 3438696382) strcat(s, "a");
if (crc32("ABAFFWnTvTwaK",13) == 1996708529) strcat(s, "r");
if (crc32("vcJmiDni",8) == 2708132938) strcat(s, "m");
if (crc32("ROuIQxwVgJiwEP",14) == 2444589242) strcat(s, "i");
if (crc32("zpnOSAcjaP",10) == 4226207317) strcat(s, "H");
if (crc32("HGcqpbIZE",9) == 2339348368) strcat(s, "b");
if (crc32("MhjYLqabtSgkrh",14) == 2481073102) strcat(s, "I");
if (crc32("ZxxpctcTYENMhY",14) == 33395427) strcat(s, "u");
if (crc32("guiiEHcVLwUvBO",14) == 3108050831) strcat(s, "t");
if (crc32("fYIPsPZ",7) == 2815949235) strcat(s, "i");
if (crc32("rGHLIvDVgUsV",12) == 695259644) strcat(s, "v");
if (crc32("lbmzzsESuOe",11) == 3772866860) strcat(s, "e");
if (crc32("EJvPfmzeD",9) == 2087684645) strcat(s, "H");
if (crc32("lWXfGKpfoe",10) == 2506200998) strcat(s, "l");
if (crc32("YBUVjaR",7) == 3552784242) strcat(s, "X");
if (crc32("VOuPTuWNs",9) == 4199893237) strcat(s, "y");
    return s;
}

char *dully_adverbs() {
    char *s = calloc(6);
    if (crc32("lQILQbkn",8) == 3329355720) strcat(s, "d");
if (crc32("pZOvoKQIeSlOHnl",15) == 2935918414) strcat(s, "Z");
if (crc32("yGvhCXTpJoiybvA",15) == 2036387752) strcat(s, "u");
if (crc32("bABUao",6) == 1810638025) strcat(s, "l");
if (crc32("gTbKCUimYKAEs",13) == 153907713) strcat(s, "K");
if (crc32("jfGNUC",6) == 1510045191) strcat(s, "l");
if (crc32("GNIELxb",7) == 3982617228) strcat(s, "y");
    return s;
}

char *gaudily_adverbs() {
    char *s = calloc(8);
    if (crc32("YJxWdKAfiSVnCF",14) == 3255537696) strcat(s, "e");
if (crc32("GscOTy",6) == 3098985136) strcat(s, "g");
if (crc32("XbTeNCcTcTcC",12) == 104168118) strcat(s, "a");
if (crc32("HXvMhidBMBTDNv",14) == 314212670) strcat(s, "O");
if (crc32("ZdYjLkszsn",10) == 823156172) strcat(s, "u");
if (crc32("AOLLCtE",7) == 1550452250) strcat(s, "R");
if (crc32("ihHwp",5) == 3797974968) strcat(s, "d");
if (crc32("lphDP",5) == 1214614688) strcat(s, "i");
if (crc32("eFTkuUwl",8) == 2378358293) strcat(s, "R");
if (crc32("MblwgST",7) == 3886948640) strcat(s, "l");
if (crc32("JOlOWUVjqo",10) == 830517702) strcat(s, "H");
if (crc32("OXmIxSqPOELf",12) == 1974027159) strcat(s, "y");
    return s;
}

char *sometime_adverbs() {
    char *s = calloc(9);
    if (crc32("ClmNMLEswVYUW",13) == 117994713) strcat(s, "s");
if (crc32("UnsOgpDrWslPAc",14) == 1802942247) strcat(s, "P");
if (crc32("qTvvMJMR",8) == 2909466902) strcat(s, "o");
if (crc32("hwNSTOJbHcPsT",13) == 3803690552) strcat(s, "m");
if (crc32("cARejSuYY",9) == 2876073885) strcat(s, "e");
if (crc32("PRgOCmKFLjvFR",13) == 1237206586) strcat(s, "t");
if (crc32("WmTjiD",6) == 88779124) strcat(s, "i");
if (crc32("nnyOzSCDosDm",12) == 2787687848) strcat(s, "u");
if (crc32("zTyxWQqJhkzNTW",14) == 1017725262) strcat(s, "m");
if (crc32("ZVIXyW",6) == 4181367898) strcat(s, "b");
if (crc32("WCygUCOJRSL",11) == 2655922469) strcat(s, "e");
    return s;
}

char *etymologically_adverbs() {
    char *s = calloc(15);
    if (crc32("rOmZyXSGMdQ",11) == 1313903777) strcat(s, "e");
if (crc32("FqkbYtz",7) == 2649360738) strcat(s, "t");
if (crc32("uHQXWuPrwFuRAe",14) == 3565171767) strcat(s, "y");
if (crc32("NGwcKvDPkxDv",12) == 1035660639) strcat(s, "c");
if (crc32("AqAcJOyv",8) == 409499331) strcat(s, "m");
if (crc32("kJRHjUVYb",9) == 4158908677) strcat(s, "O");
if (crc32("qOYvY",5) == 3378009110) strcat(s, "o");
if (crc32("cpZzXSygIb",10) == 2870018984) strcat(s, "J");
if (crc32("SrFuirWOy",9) == 1565064333) strcat(s, "l");
if (crc32("nVofcVKawWGpdk",14) == 2857159328) strcat(s, "o");
if (crc32("NJNLSm",6) == 2614006827) strcat(s, "i");
if (crc32("irmnWUrWS",9) == 103705883) strcat(s, "g");
if (crc32("MwbNGhxRwYPCl",13) == 82527812) strcat(s, "i");
if (crc32("YKupAJJhASv",11) == 1687617977) strcat(s, "h");
if (crc32("wXMYgJ",6) == 421583073) strcat(s, "c");
if (crc32("KsciQTFYVjbSvJ",14) == 2506781775) strcat(s, "a");
if (crc32("qyGXEnEvHQTS",12) == 4107288698) strcat(s, "Z");
if (crc32("IhLYngioixI",11) == 3766667946) strcat(s, "l");
if (crc32("HBKixGsHGH",10) == 969153457) strcat(s, "l");
if (crc32("mQGAjW",6) == 1453886333) strcat(s, "F");
if (crc32("UuSwMHLALffyP",13) == 2591675202) strcat(s, "y");
    return s;
}

char *quasigenuinely_adverbs() {
    char *s = calloc(15);
    if (crc32("RtiSJA",6) == 3292447421) strcat(s, "v");
if (crc32("VaFlwIERJpt",11) == 447768424) strcat(s, "q");
if (crc32("VAtcUjwvDbJ",11) == 313152144) strcat(s, "u");
if (crc32("uGXEuiXgcvtri",13) == 1727680870) strcat(s, "h");
if (crc32("zpBajMqH",8) == 820182881) strcat(s, "a");
if (crc32("cjzvYvm",7) == 3397109409) strcat(s, "j");
if (crc32("LISDIng",7) == 179758395) strcat(s, "s");
if (crc32("nZMJSBnIbQ",10) == 3495892756) strcat(s, "U");
if (crc32("PAsrqk",6) == 442801030) strcat(s, "i");
if (crc32("KsoLEvQKqTigaB",14) == 2555761081) strcat(s, "g");
if (crc32("IhbffP",6) == 3043939140) strcat(s, "e");
if (crc32("susBD",5) == 3254272939) strcat(s, "n");
if (crc32("IRIFnyEIB",9) == 106765547) strcat(s, "W");
if (crc32("WChlBJxLkUKxCW",14) == 1613476285) strcat(s, "u");
if (crc32("iASPv",5) == 479184077) strcat(s, "i");
if (crc32("BBFmImvFuwfM",12) == 4157552283) strcat(s, "n");
if (crc32("XsDDnrGRWDS",11) == 2199734130) strcat(s, "e");
if (crc32("zenGPpJaxDKkv",13) == 1852360756) strcat(s, "q");
if (crc32("Gnclm",5) == 1204993859) strcat(s, "l");
if (crc32("IqAbeLOjX",9) == 1391882190) strcat(s, "y");
    return s;
}

char *luetically_adverbs() {
    char *s = calloc(11);
    if (crc32("YaIikkLwd",9) == 2335515924) strcat(s, "l");
if (crc32("dJxLfvy",7) == 1221620339) strcat(s, "u");
if (crc32("FfqeBNAIq",9) == 1631253599) strcat(s, "e");
if (crc32("EJifyhxRbNajZ",13) == 2259521506) strcat(s, "t");
if (crc32("mjzgQqTUqpjP",12) == 1632551908) strcat(s, "i");
if (crc32("wxeSDUgPHd",10) == 3713333722) strcat(s, "S");
if (crc32("OSeWG",5) == 2523369122) strcat(s, "c");
if (crc32("FYXHw",5) == 3936647086) strcat(s, "I");
if (crc32("uYaaESDrMx",10) == 1689756453) strcat(s, "a");
if (crc32("BqGYFLG",7) == 1361345566) strcat(s, "K");
if (crc32("DVEraZvG",8) == 656135872) strcat(s, "l");
if (crc32("ntXAqtrngtIn",12) == 706521157) strcat(s, "h");
if (crc32("NJfYTYErDXIFom",14) == 3012860638) strcat(s, "l");
if (crc32("gGBSWrHs",8) == 251846448) strcat(s, "Q");
if (crc32("KLujwpKYf",9) == 1080643956) strcat(s, "y");
    return s;
}

char *yonder_adverbs() {
    char *s = calloc(7);
    if (crc32("jErBF",5) == 3018802658) strcat(s, "y");
if (crc32("lADhfvbvDdPA",12) == 2080100984) strcat(s, "o");
if (crc32("BonRViBhRWy",11) == 1185500861) strcat(s, "n");
if (crc32("czBlYONo",8) == 322458344) strcat(s, "d");
if (crc32("aOEeRYSZfUaZ",12) == 962613322) strcat(s, "e");
if (crc32("oXIhP",5) == 1794979544) strcat(s, "r");
    return s;
}

char *thickwittedly_adverbs() {
    char *s = calloc(14);
    if (crc32("prrDHJDxt",9) == 1289093368) strcat(s, "t");
if (crc32("ypPkyHAu",8) == 373837507) strcat(s, "y");
if (crc32("mWfnwWRt",8) == 1894757042) strcat(s, "h");
if (crc32("OdgVPdaVydj",11) == 1344418209) strcat(s, "i");
if (crc32("GelAtY",6) == 2869008804) strcat(s, "c");
if (crc32("xmzbKrnN",8) == 3368500063) strcat(s, "k");
if (crc32("PaCvcJXnonEuBRe",15) == 2320777298) strcat(s, "w");
if (crc32("XdtOUx",6) == 2349213569) strcat(s, "k");
if (crc32("XYHlFy",6) == 4102808846) strcat(s, "i");
if (crc32("SnGhwZDjH",9) == 762725314) strcat(s, "S");
if (crc32("auvznLjLubtSA",13) == 1231258974) strcat(s, "t");
if (crc32("mtQzlGgLX",9) == 1656872753) strcat(s, "t");
if (crc32("fUvasAsHzrrgF",13) == 2948125621) strcat(s, "e");
if (crc32("mtSqfT",6) == 1645764604) strcat(s, "z");
if (crc32("NhkPMPkaPEdZNN",14) == 556657565) strcat(s, "d");
if (crc32("LfPQyqlmqyX",11) == 1653349325) strcat(s, "l");
if (crc32("HWxLCBYLbY",10) == 2781622695) strcat(s, "y");
    return s;
}

char *caselessly_adverbs() {
    char *s = calloc(11);
    if (crc32("TvnkZNxyyUxXP",13) == 3008917481) strcat(s, "g");
if (crc32("WxRhbbydgnnyGEa",15) == 122336955) strcat(s, "c");
if (crc32("apsdMLgxyUYEWR",14) == 4078599861) strcat(s, "a");
if (crc32("XbjHOO",6) == 159239104) strcat(s, "s");
if (crc32("wnvxUbVvEwzU",12) == 126237454) strcat(s, "e");
if (crc32("VVcBMFOWso",10) == 1841280564) strcat(s, "c");
if (crc32("czrku",5) == 3978375577) strcat(s, "l");
if (crc32("nLKZZO",6) == 2503403332) strcat(s, "e");
if (crc32("KNZFQxVAD",9) == 1187221474) strcat(s, "z");
if (crc32("UdYSQerTd",9) == 2093746318) strcat(s, "s");
if (crc32("hLEKglbYdtWbFQK",15) == 2556229022) strcat(s, "s");
if (crc32("RpQqvdXIi",9) == 2932945385) strcat(s, "c");
if (crc32("KyVrCwxMroPQPyQ",15) == 66938036) strcat(s, "l");
if (crc32("dDCDBShaF",9) == 4117602353) strcat(s, "y");
    return s;
}

char *authoritatively_adverbs() {
    char *s = calloc(16);
    if (crc32("ZRulYfJxkJl",11) == 3486629586) strcat(s, "U");
if (crc32("tTyybHjCBnBg",12) == 4084806659) strcat(s, "a");
if (crc32("NMzwofjnpwszsO",14) == 2772423990) strcat(s, "h");
if (crc32("dUatCIyR",8) == 48668211) strcat(s, "u");
if (crc32("YFLoJvr",7) == 3053784576) strcat(s, "t");
if (crc32("eFmSCbsWQSAM",12) == 3672486809) strcat(s, "h");
if (crc32("uwmAFn",6) == 367160827) strcat(s, "o");
if (crc32("GbOktCx",7) == 1195803096) strcat(s, "C");
if (crc32("eosvWmAsuOgLv",13) == 2996415389) strcat(s, "r");
if (crc32("OlnUM",5) == 1853980522) strcat(s, "v");
if (crc32("wdPBjAonMZmJip",14) == 1853645880) strcat(s, "i");
if (crc32("GDIAlz",6) == 2717765688) strcat(s, "w");
if (crc32("MFGjsy",6) == 3154106407) strcat(s, "t");
if (crc32("KZnKztYacSeV",12) == 1460222401) strcat(s, "d");
if (crc32("NXTTwM",6) == 3409609264) strcat(s, "a");
if (crc32("EEqdiIpyf",9) == 1062930656) strcat(s, "x");
if (crc32("EMxqOqzD",8) == 811933555) strcat(s, "t");
if (crc32("dDGPgbzSFGppQ",13) == 1780544479) strcat(s, "i");
if (crc32("SHGokYXVXgv",11) == 30298737) strcat(s, "v");
if (crc32("WuIdXkhheb",10) == 1209325927) strcat(s, "F");
if (crc32("xbFibzjNGSJYDIM",15) == 907705081) strcat(s, "e");
if (crc32("NaNowBne",8) == 4062994740) strcat(s, "Z");
if (crc32("tUhWYSFY",8) == 1042991597) strcat(s, "l");
if (crc32("fcSFIqsO",8) == 2347639627) strcat(s, "O");
if (crc32("xOroA",5) == 2017242664) strcat(s, "y");
    return s;
}

char *apostolically_adverbs() {
    char *s = calloc(14);
    if (crc32("QuuIQTvwkmwv",12) == 2625645195) strcat(s, "a");
if (crc32("kScDEKgHeXmmCLx",15) == 1919153928) strcat(s, "p");
if (crc32("yDgqsA",6) == 1796316981) strcat(s, "i");
if (crc32("IEqmJQVTQzDxF",13) == 2366138299) strcat(s, "o");
if (crc32("rUFgHxEhTLElMko",15) == 3904409180) strcat(s, "s");
if (crc32("AgSEeFylMSQVrt",14) == 1789702073) strcat(s, "t");
if (crc32("HjeqZ",5) == 330137002) strcat(s, "o");
if (crc32("aXIqlGfgS",9) == 4105844608) strcat(s, "o");
if (crc32("MiNiMVlILpw",11) == 3200577047) strcat(s, "U");
if (crc32("WnedIkYlXJWmAfI",15) == 3494639189) strcat(s, "l");
if (crc32("qmoqFi",6) == 2282402866) strcat(s, "q");
if (crc32("bdjvNXdxEnZPDcP",15) == 3360514467) strcat(s, "i");
if (crc32("WvasCzlIT",9) == 1535921242) strcat(s, "C");
if (crc32("KGMffPYgyCJ",11) == 3132525133) strcat(s, "c");
if (crc32("GwQDZbprs",9) == 3765774391) strcat(s, "T");
if (crc32("bCJoYtL",7) == 786168251) strcat(s, "a");
if (crc32("ZYoiaJhNRVQpbO",14) == 1174431753) strcat(s, "b");
if (crc32("jjzxAFqozsGwc",13) == 2666575932) strcat(s, "l");
if (crc32("zJgEZorQqBjZ",12) == 957228040) strcat(s, "S");
if (crc32("VvShtoJcFmU",11) == 756712888) strcat(s, "l");
if (crc32("XtJjgiXFUkTQSCX",15) == 791711041) strcat(s, "y");
    return s;
}

char *discreditably_adverbs() {
    char *s = calloc(14);
    if (crc32("cpPxSgpg",8) == 1628408540) strcat(s, "Q");
if (crc32("goSZNxdLdXkemOy",15) == 3418163900) strcat(s, "d");
if (crc32("OijCyMoMF",9) == 2329105199) strcat(s, "i");
if (crc32("LsNLLdele",9) == 51764054) strcat(s, "s");
if (crc32("VIyYiBaNrBiWto",14) == 404836654) strcat(s, "R");
if (crc32("ZvehmfHSMJIzJla",15) == 3166622137) strcat(s, "c");
if (crc32("oOSXOkzQ",8) == 2539301563) strcat(s, "A");
if (crc32("WwzPLlXGtKjS",12) == 3135131586) strcat(s, "r");
if (crc32("HKIBt",5) == 148378948) strcat(s, "e");
if (crc32("FggoUyoBm",9) == 443954749) strcat(s, "y");
if (crc32("ryIRjEZMAESaE",13) == 1031506729) strcat(s, "d");
if (crc32("pmyJgbNB",8) == 2427390296) strcat(s, "s");
if (crc32("wbXrQjoyj",9) == 4146864534) strcat(s, "i");
if (crc32("bBLjG",5) == 2559965792) strcat(s, "O");
if (crc32("TLyTXEHDCW",10) == 2029005236) strcat(s, "t");
if (crc32("xQjoen",6) == 4114235214) strcat(s, "G");
if (crc32("OmKBayndQjIA",12) == 422628102) strcat(s, "a");
if (crc32("fYSOMIAlxkPh",12) == 3538963260) strcat(s, "Q");
if (crc32("ltIiUwluuMoQa",13) == 939388854) strcat(s, "b");
if (crc32("bVKJUDL",7) == 17879992) strcat(s, "l");
if (crc32("leuLeTQZjJpK",12) == 1116729999) strcat(s, "y");
    return s;
}

char *angulately_adverbs() {
    char *s = calloc(11);
    if (crc32("IMOOLEgfJuGE",12) == 3519463761) strcat(s, "a");
if (crc32("fZCCWcuFyLynK",13) == 3086333491) strcat(s, "X");
if (crc32("DcYTx",5) == 2712020248) strcat(s, "n");
if (crc32("tuGrBGa",7) == 64129752) strcat(s, "g");
if (crc32("aXuJlCJsnsqBKMT",15) == 398562351) strcat(s, "F");
if (crc32("fsTLqwaCn",9) == 1321131412) strcat(s, "u");
if (crc32("KBvMAGiRMjwxR",13) == 3547155855) strcat(s, "z");
if (crc32("fKtZH",5) == 4159575612) strcat(s, "l");
if (crc32("yjoRfbwrjSg",11) == 2907889570) strcat(s, "g");
if (crc32("kflSji",6) == 1911905876) strcat(s, "a");
if (crc32("QEtHSMesLrFo",12) == 73124551) strcat(s, "t");
if (crc32("xOroyPEG",8) == 3144853827) strcat(s, "p");
if (crc32("zvBXbRDL",8) == 2291260065) strcat(s, "e");
if (crc32("bLhqiAqR",8) == 3406785901) strcat(s, "Z");
if (crc32("ZJABtxUFQgMI",12) == 284244707) strcat(s, "l");
if (crc32("FqrkH",5) == 1802066685) strcat(s, "y");
    return s;
}

char *inventorially_adverbs() {
    char *s = calloc(14);
    if (crc32("xAOlApTWQOCqaNx",15) == 4055959349) strcat(s, "e");
if (crc32("yjmQfsYKiqoh",12) == 1288314434) strcat(s, "i");
if (crc32("uflvJhKq",8) == 1522840438) strcat(s, "t");
if (crc32("LNjhdb",6) == 2666114740) strcat(s, "n");
if (crc32("dieDVNarOv",10) == 3296043631) strcat(s, "v");
if (crc32("azpcplFPFjt",11) == 752597750) strcat(s, "f");
if (crc32("ScOuIxqlGxZ",11) == 3485272075) strcat(s, "e");
if (crc32("rtznbq",6) == 1676244821) strcat(s, "s");
if (crc32("HxVsr",5) == 3523347649) strcat(s, "n");
if (crc32("rzqplzY",7) == 3162329910) strcat(s, "h");
if (crc32("uCguimYoRRv",11) == 4011642427) strcat(s, "t");
if (crc32("BXhuIN",6) == 3388846909) strcat(s, "a");
if (crc32("AawNwmLHwP",10) == 3096448031) strcat(s, "o");
if (crc32("cjZLvneqUoXPSEx",15) == 1824237046) strcat(s, "e");
if (crc32("HJFddoHgHIuylvw",15) == 2263472692) strcat(s, "r");
if (crc32("giwmQ",5) == 2714829372) strcat(s, "s");
if (crc32("rYYjWZHuiZQ",11) == 1932076959) strcat(s, "i");
if (crc32("ZowEVN",6) == 4203293669) strcat(s, "a");
if (crc32("xMoBoJGyga",10) == 3687874452) strcat(s, "W");
if (crc32("UiWTWJzVQHUx",12) == 3065703937) strcat(s, "l");
if (crc32("xnlQNXSKNbQG",12) == 2305373510) strcat(s, "W");
if (crc32("JBMjB",5) == 2600376897) strcat(s, "l");
if (crc32("KDHkTbixesdV",12) == 4247009767) strcat(s, "y");
    return s;
}

char *nefariously_adverbs() {
    char *s = calloc(12);
    if (crc32("ytwNeJPOqG",10) == 3805884848) strcat(s, "i");
if (crc32("EoNFD",5) == 2564950705) strcat(s, "n");
if (crc32("jRvCs",5) == 914388858) strcat(s, "e");
if (crc32("pQNweUNWJm",10) == 3864393122) strcat(s, "f");
if (crc32("AXYFt",5) == 1060038960) strcat(s, "a");
if (crc32("GFjIe",5) == 3417136072) strcat(s, "r");
if (crc32("jtbgoXhJ",8) == 3993254663) strcat(s, "M");
if (crc32("qVdNez",6) == 2700444402) strcat(s, "i");
if (crc32("PvMIxasVHwspbX",14) == 4147789299) strcat(s, "t");
if (crc32("zVRNtPRH",8) == 3327733351) strcat(s, "o");
if (crc32("PWSWeVG",7) == 2276389606) strcat(s, "z");
if (crc32("Otnie",5) == 863153245) strcat(s, "u");
if (crc32("cKQmBrA",7) == 33766835) strcat(s, "V");
if (crc32("sckqtZ",6) == 2602542380) strcat(s, "s");
if (crc32("nTKNMNJBYFj",11) == 2674681790) strcat(s, "a");
if (crc32("jSGZvROSuyAot",13) == 1858862293) strcat(s, "l");
if (crc32("JrwiXPbzQaJR",12) == 92656302) strcat(s, "y");
    return s;
}

char *invectively_adverbs() {
    char *s = calloc(12);
    if (crc32("PgecdRHGBnVPG",13) == 4054451416) strcat(s, "i");
if (crc32("QVktFfb",7) == 749378087) strcat(s, "n");
if (crc32("IBWSkxeTGqV",11) == 4080105205) strcat(s, "W");
if (crc32("WYvpExh",7) == 2683089204) strcat(s, "v");
if (crc32("zBDWZFUKhKHGHlh",15) == 556363234) strcat(s, "e");
if (crc32("GEfeH",5) == 2901162649) strcat(s, "c");
if (crc32("WQtrqGyWQt",10) == 791128628) strcat(s, "t");
if (crc32("gFJqaxJTozzO",12) == 584713433) strcat(s, "B");
if (crc32("LiWFgCaNDjKw",12) == 2484698179) strcat(s, "i");
if (crc32("AndON",5) == 3507706485) strcat(s, "v");
if (crc32("VdgOlqa",7) == 354005089) strcat(s, "V");
if (crc32("QappwoKJ",8) == 326675478) strcat(s, "e");
if (crc32("pSOrTvQEBVngCk",14) == 851620258) strcat(s, "c");
if (crc32("jHLkscWVt",9) == 1899991912) strcat(s, "l");
if (crc32("qxflPb",6) == 3105150347) strcat(s, "Y");
if (crc32("MGELK",5) == 2870074459) strcat(s, "y");
    return s;
}

char *preadjectivally_adverbs() {
    char *s = calloc(16);
    if (crc32("sWqIqY",6) == 271680033) strcat(s, "x");
if (crc32("hVVKX",5) == 2668267237) strcat(s, "p");
if (crc32("YWTLvoqmRV",10) == 3178189223) strcat(s, "r");
if (crc32("BBBWEhLzVBc",11) == 3303703187) strcat(s, "S");
if (crc32("JsjEVTnwhKV",11) == 983512669) strcat(s, "e");
if (crc32("iwyLAJ",6) == 3306655382) strcat(s, "a");
if (crc32("gJHXeUFgZkQP",12) == 1678998204) strcat(s, "d");
if (crc32("ZVddhjduKvVp",12) == 3389250977) strcat(s, "j");
if (crc32("QELadTRn",8) == 767653252) strcat(s, "E");
if (crc32("rFmRIvvd",8) == 3757044108) strcat(s, "e");
if (crc32("wfhIiUAIc",9) == 2627777194) strcat(s, "E");
if (crc32("tSDZifRHOTafsfW",15) == 4110487600) strcat(s, "c");
if (crc32("ELHpVPxIMaji",12) == 4220572770) strcat(s, "t");
if (crc32("ENfnbKbDbyqNCBp",15) == 3142563350) strcat(s, "K");
if (crc32("mgSAcQoY",8) == 996905370) strcat(s, "i");
if (crc32("Jvxxvoau",8) == 759327991) strcat(s, "v");
if (crc32("RwuvwVLVbwaV",12) == 991694796) strcat(s, "g");
if (crc32("LLJeLSSFqBlgb",13) == 189960712) strcat(s, "a");
if (crc32("fSyatGjAL",9) == 2302831123) strcat(s, "Z");
if (crc32("AFiXdwE",7) == 362562401) strcat(s, "l");
if (crc32("PXDzAyIHjFy",11) == 577102881) strcat(s, "s");
if (crc32("HHjdKXjzQmPvKbM",15) == 1881731205) strcat(s, "l");
if (crc32("YVjHcJHHP",9) == 3503969505) strcat(s, "Y");
if (crc32("MyvdknXKHe",10) == 4063707658) strcat(s, "y");
    return s;
}

char *gullibly_adverbs() {
    char *s = calloc(9);
    if (crc32("dTUrXFux",8) == 4237784096) strcat(s, "w");
if (crc32("PdbQvugseei",11) == 3290103841) strcat(s, "g");
if (crc32("ckksNUmgfrr",11) == 388194440) strcat(s, "u");
if (crc32("zjzKvmSZKAmg",12) == 2514729184) strcat(s, "a");
if (crc32("dfJAUl",6) == 854373838) strcat(s, "l");
if (crc32("TOkaDlnS",8) == 3087646161) strcat(s, "U");
if (crc32("PDuhVkMejTMiof",14) == 3495957387) strcat(s, "l");
if (crc32("bpasfMBgbh",10) == 3832861577) strcat(s, "C");
if (crc32("HsHSUIQdDvvAD",13) == 3068006135) strcat(s, "i");
if (crc32("koRMuZmfIRAZBs",14) == 2347055536) strcat(s, "d");
if (crc32("anQnM",5) == 669259347) strcat(s, "b");
if (crc32("UPgomI",6) == 4134346739) strcat(s, "W");
if (crc32("BXTWqjAvXa",10) == 2947443232) strcat(s, "l");
if (crc32("nbpnL",5) == 2233648311) strcat(s, "o");
if (crc32("kAsPRoIYcYMY",12) == 818420936) strcat(s, "y");
    return s;
}

char *extroversively_adverbs() {
    char *s = calloc(15);
    if (crc32("WzWpyIVMDINjjR",14) == 42892992) strcat(s, "N");
if (crc32("FivOgUH",7) == 3539607997) strcat(s, "e");
if (crc32("DYoPZVeSOmw",11) == 910176450) strcat(s, "r");
if (crc32("biZyGOgNtcSMqu",14) == 747272950) strcat(s, "x");
if (crc32("WHTSboQw",8) == 451729997) strcat(s, "t");
if (crc32("mioIhsiNYzUMEBV",15) == 324420549) strcat(s, "P");
if (crc32("wuETR",5) == 4241652943) strcat(s, "r");
if (crc32("zONKxgGyGJ",10) == 3244303947) strcat(s, "o");
if (crc32("ymKdTmULjcG",11) == 1996703344) strcat(s, "W");
if (crc32("rSTel",5) == 2880688131) strcat(s, "v");
if (crc32("TeDgVmErhv",10) == 4218179435) strcat(s, "T");
if (crc32("oyzRPVidghZL",12) == 2429708498) strcat(s, "e");
if (crc32("saIPQtqlZRvLdI",14) == 1079123902) strcat(s, "r");
if (crc32("fVbsEx",6) == 3430210624) strcat(s, "s");
if (crc32("DQRsQfgxhOL",11) == 3096482423) strcat(s, "w");
if (crc32("hdbjLNaFjBOl",12) == 3282337460) strcat(s, "i");
if (crc32("tKcKZZ",6) == 2430906580) strcat(s, "v");
if (crc32("GWxOu",5) == 4188025498) strcat(s, "L");
if (crc32("heOSIm",6) == 3145917826) strcat(s, "e");
if (crc32("VVXMFVanofoZ",12) == 2971636089) strcat(s, "l");
if (crc32("nnNqjAFtFrefcfh",15) == 1822747604) strcat(s, "f");
if (crc32("GFMisBc",7) == 1674547941) strcat(s, "y");
    return s;
}

char *inadequately_adverbs() {
    char *s = calloc(13);
    if (crc32("GsORNd",6) == 2967561615) strcat(s, "i");
if (crc32("CTSplixR",8) == 840382055) strcat(s, "i");
if (crc32("obQetHhg",8) == 48688442) strcat(s, "n");
if (crc32("sAFIO",5) == 846748980) strcat(s, "K");
if (crc32("rlcEC",5) == 478859802) strcat(s, "a");
if (crc32("EUlIVFIOpXvTNFH",15) == 2949635704) strcat(s, "d");
if (crc32("ssBcXpZQiw",10) == 1285803888) strcat(s, "e");
if (crc32("rmMqaUmVEHbs",12) == 2831069592) strcat(s, "q");
if (crc32("xotmCaMNWCVDzpU",15) == 3413711417) strcat(s, "q");
if (crc32("qsiAcnAcdqKSDo",14) == 4022483975) strcat(s, "U");
if (crc32("BCwjHbHuHTD",11) == 2459084998) strcat(s, "u");
if (crc32("eVjrkUnhnhIjL",13) == 2775242225) strcat(s, "Y");
if (crc32("oUiQrci",7) == 1988713067) strcat(s, "a");
if (crc32("RpBqPywvVjseh",13) == 237129213) strcat(s, "t");
if (crc32("cISoypDO",8) == 248687566) strcat(s, "S");
if (crc32("jUgAoGRHtzSQ",12) == 3689467137) strcat(s, "e");
if (crc32("MGqbysGXOgxWMr",14) == 3048518709) strcat(s, "L");
if (crc32("ZYtEtrnQYe",10) == 1591936875) strcat(s, "l");
if (crc32("nEhGHBJINdztvWH",15) == 1415786475) strcat(s, "m");
if (crc32("JiHJY",5) == 4108819931) strcat(s, "y");
    return s;
}

char *campanologically_adverbs() {
    char *s = calloc(17);
    if (crc32("UltNtINONOMr",12) == 1350460088) strcat(s, "J");
if (crc32("pYMWSqkUBocp",12) == 1311687166) strcat(s, "c");
if (crc32("dbklZAbT",8) == 2691974192) strcat(s, "U");
if (crc32("EgBrXHUjxGSa",12) == 3766210640) strcat(s, "a");
if (crc32("LfBGUCYSwQOeImG",15) == 3006409595) strcat(s, "m");
if (crc32("IgQSDjpP",8) == 3144312399) strcat(s, "h");
if (crc32("YRhpRf",6) == 1588537392) strcat(s, "p");
if (crc32("lcRhoJcByBw",11) == 1066388084) strcat(s, "a");
if (crc32("kupxpDeMIjknVgS",15) == 2372937076) strcat(s, "n");
if (crc32("MOPrYjPW",8) == 1452548416) strcat(s, "o");
if (crc32("bfLiXKiWKlx",11) == 348152189) strcat(s, "l");
if (crc32("KDUZjpTkDfeH",12) == 149649221) strcat(s, "o");
if (crc32("itTlxS",6) == 3863991317) strcat(s, "p");
if (crc32("hUrYUGyRGL",10) == 1317719790) strcat(s, "g");
if (crc32("yBLWEfFHUrNBJ",13) == 1553803902) strcat(s, "h");
if (crc32("GmHrwXfyULNdDoK",15) == 1564829201) strcat(s, "i");
if (crc32("BFeyVQuAkqxdq",13) == 2242141951) strcat(s, "c");
if (crc32("HtpUao",6) == 3173275996) strcat(s, "M");
if (crc32("JIsLzCqWY",9) == 3066063689) strcat(s, "a");
if (crc32("qNVTicki",8) == 906879989) strcat(s, "z");
if (crc32("RqqbZOhBRMCm",12) == 3188161618) strcat(s, "l");
if (crc32("lEZOXXWXGPHqv",13) == 7164429) strcat(s, "i");
if (crc32("gBdaeZgbnZkhpo",14) == 1364049942) strcat(s, "l");
if (crc32("rYLVfU",6) == 2600248657) strcat(s, "f");
if (crc32("XuWmZaxxQX",10) == 2109836942) strcat(s, "y");
    return s;
}

char *quasimethodically_adverbs() {
    char *s = calloc(18);
    if (crc32("ppyFAD",6) == 3116476676) strcat(s, "q");
if (crc32("qhQCtuvSGRsPH",13) == 3648312536) strcat(s, "u");
if (crc32("WSDhMnFRWrW",11) == 3358677568) strcat(s, "a");
if (crc32("KNkcO",5) == 3148507397) strcat(s, "W");
if (crc32("oOUIozMXzH",10) == 3806254210) strcat(s, "s");
if (crc32("oVYnTXBEQZuyu",13) == 2804151090) strcat(s, "s");
if (crc32("GjzSLXtONHBy",12) == 3979204890) strcat(s, "i");
if (crc32("ycTsDYtMCyEDo",13) == 3961208107) strcat(s, "m");
if (crc32("jkVzvxjyOKbM",12) == 331963045) strcat(s, "e");
if (crc32("eqxjwxLMo",9) == 3805052594) strcat(s, "t");
if (crc32("telMFSQmAC",10) == 606514345) strcat(s, "b");
if (crc32("RSurqjec",8) == 3792949546) strcat(s, "h");
if (crc32("lxGMdzG",7) == 3339736137) strcat(s, "o");
if (crc32("svTsa",5) == 1662414805) strcat(s, "d");
if (crc32("PwYqsJGzQ",9) == 1969345447) strcat(s, "i");
if (crc32("QjqCDmi",7) == 1864156903) strcat(s, "i");
if (crc32("CLEpZXTrzUs",11) == 2760222618) strcat(s, "c");
if (crc32("yHMeIxwl",8) == 1330628628) strcat(s, "M");
if (crc32("DThRf",5) == 1168568386) strcat(s, "a");
if (crc32("taqLTwDdxFq",11) == 2180645158) strcat(s, "l");
if (crc32("RDrqgtujaA",10) == 71331119) strcat(s, "l");
if (crc32("lidfRmjwbZw",11) == 3952918241) strcat(s, "y");
    return s;
}

char *illustriously_adverbs() {
    char *s = calloc(14);
    if (crc32("NVBxibeoQS",10) == 70689165) strcat(s, "i");
if (crc32("VmYxE",5) == 973123958) strcat(s, "l");
if (crc32("mvsRIrZdBSDYZdI",15) == 1830179613) strcat(s, "l");
if (crc32("gPeYsTkrQpVol",13) == 1393078135) strcat(s, "u");
if (crc32("vApWnFkqqphpw",13) == 566421683) strcat(s, "s");
if (crc32("AxlCMlUtaneNa",13) == 1314225626) strcat(s, "t");
if (crc32("NIkDlXvsjPyDejO",15) == 1611788076) strcat(s, "r");
if (crc32("tAUjR",5) == 2308292764) strcat(s, "B");
if (crc32("aqfOqhdweNyIPcm",15) == 41743661) strcat(s, "i");
if (crc32("uKqprd",6) == 258229024) strcat(s, "P");
if (crc32("TbVySbyiApqKHo",14) == 757789488) strcat(s, "o");
if (crc32("XszGk",5) == 2348151025) strcat(s, "u");
if (crc32("wouHISAXkHeJ",12) == 3097276132) strcat(s, "x");
if (crc32("gfQGjb",6) == 2290838647) strcat(s, "s");
if (crc32("IbqTAAGKaz",10) == 1400756677) strcat(s, "l");
if (crc32("EKHzHQFhJFqmVV",14) == 1610468313) strcat(s, "y");
    return s;
}

char *unallayably_adverbs() {
    char *s = calloc(12);
    if (crc32("usmNRLV",7) == 2210248971) strcat(s, "A");
if (crc32("SXfpTbQwJSASf",13) == 1853508931) strcat(s, "u");
if (crc32("qhmTc",5) == 3721278563) strcat(s, "W");
if (crc32("dyUFSUaqBTQgj",13) == 3587174647) strcat(s, "n");
if (crc32("GKLSGJGltFLzVk",14) == 3658455472) strcat(s, "a");
if (crc32("NGPWUHfSg",9) == 1092004768) strcat(s, "l");
if (crc32("SIuxEgzV",8) == 1272921229) strcat(s, "l");
if (crc32("GnEVNypMVOz",11) == 1529061026) strcat(s, "a");
if (crc32("adQKoleav",9) == 4169341095) strcat(s, "y");
if (crc32("fknYqFwOr",9) == 1449184635) strcat(s, "a");
if (crc32("ThakRbdBlvcXL",13) == 2165857753) strcat(s, "t");
if (crc32("gTjofwgSjdR",11) == 2941137522) strcat(s, "b");
if (crc32("ALwHwP",6) == 3485419456) strcat(s, "o");
if (crc32("wdDcOPTKA",9) == 1879284211) strcat(s, "l");
if (crc32("QtQqsjBI",8) == 1753208065) strcat(s, "V");
if (crc32("ZHPMB",5) == 1536716769) strcat(s, "y");
    return s;
}

char *congenially_adverbs() {
    char *s = calloc(12);
    if (crc32("zVHFHSekglgzg",13) == 3079978660) strcat(s, "c");
if (crc32("fYKJbBFN",8) == 3219441017) strcat(s, "p");
if (crc32("fyuqcjcXRBpk",12) == 3733579799) strcat(s, "o");
if (crc32("sIgkiwBGZjQTIU",14) == 1912233474) strcat(s, "d");
if (crc32("kEKWJqr",7) == 3348320844) strcat(s, "n");
if (crc32("XXtzdMQdKNsqvP",14) == 1710866387) strcat(s, "g");
if (crc32("Eowlulul",8) == 941902579) strcat(s, "g");
if (crc32("ErBjcRMo",8) == 818674139) strcat(s, "e");
if (crc32("HRSkVq",6) == 1187220220) strcat(s, "n");
if (crc32("ezTodO",6) == 3129942382) strcat(s, "i");
if (crc32("XkwcErJ",7) == 1884626900) strcat(s, "a");
if (crc32("fekPV",5) == 2233106116) strcat(s, "l");
if (crc32("ubOCvSpxoepMV",13) == 2336649601) strcat(s, "l");
if (crc32("jhvZiWeaFkfxmM",14) == 2948495524) strcat(s, "l");
if (crc32("cihACpkgUpODEaK",15) == 2694497482) strcat(s, "J");
if (crc32("gVJlFvYPPNSeCTs",15) == 890865255) strcat(s, "y");
    return s;
}

char *inaccurately_adverbs() {
    char *s = calloc(13);
    if (crc32("uOvnvuH",7) == 174743015) strcat(s, "i");
if (crc32("kDaZfoSkHYFWqRj",15) == 3844318810) strcat(s, "n");
if (crc32("zHNcKrwKXIkrIj",14) == 3291441298) strcat(s, "a");
if (crc32("GLcfFfIy",8) == 2810476846) strcat(s, "c");
if (crc32("SDYefv",6) == 449141816) strcat(s, "d");
if (crc32("SClyx",5) == 3521035296) strcat(s, "c");
if (crc32("mISVc",5) == 1238376225) strcat(s, "a");
if (crc32("fVoBpj",6) == 1245657284) strcat(s, "u");
if (crc32("mlUgeYTXRRmgVv",14) == 1498267829) strcat(s, "r");
if (crc32("rATAWyYxPTZjw",13) == 2133960908) strcat(s, "a");
if (crc32("PysjlNVuuEdUyt",14) == 1723257078) strcat(s, "t");
if (crc32("OoBRnfiVll",10) == 1473005748) strcat(s, "e");
if (crc32("ieNqetKewPmyU",13) == 2927737154) strcat(s, "l");
if (crc32("YZggLQkfQTycmzj",15) == 393939691) strcat(s, "H");
if (crc32("bvbAWDM",7) == 1777334274) strcat(s, "y");
    return s;
}

char *nonpungently_adverbs() {
    char *s = calloc(13);
    if (crc32("JGfBCbkXAyHG",12) == 194270412) strcat(s, "n");
if (crc32("ZRKxRsaZCbNJaD",14) == 3334820242) strcat(s, "o");
if (crc32("llBNDy",6) == 1820431648) strcat(s, "o");
if (crc32("hRVDAfBU",8) == 327059884) strcat(s, "n");
if (crc32("kCvSXR",6) == 453768334) strcat(s, "p");
if (crc32("ZKtXZSkQfuqqUCm",15) == 3656269478) strcat(s, "u");
if (crc32("HWXCA",5) == 2981984835) strcat(s, "d");
if (crc32("uKfALfFhP",9) == 901689383) strcat(s, "n");
if (crc32("LaKrXrCkuqR",11) == 426146927) strcat(s, "h");
if (crc32("HzJlJtQgt",9) == 3341461022) strcat(s, "g");
if (crc32("ohEqKnnwRi",10) == 2221132432) strcat(s, "f");
if (crc32("hhpuVASSb",9) == 2098223996) strcat(s, "e");
if (crc32("rgFiF",5) == 1836491556) strcat(s, "m");
if (crc32("SBgaknXrcsy",11) == 563584480) strcat(s, "n");
if (crc32("qKXgpSS",7) == 678089410) strcat(s, "m");
if (crc32("aFQwQsoma",9) == 83014761) strcat(s, "t");
if (crc32("xZSAdjojUQ",10) == 765552307) strcat(s, "H");
if (crc32("qDblhrhr",8) == 380287357) strcat(s, "l");
if (crc32("YMcpHsMjyCg",11) == 2542175904) strcat(s, "y");
    return s;
}

char *quasicivilly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZmDafsgXPOQ",11) == 234544922) strcat(s, "q");
if (crc32("nOJuaSijIdEYBeR",15) == 1291187732) strcat(s, "U");
if (crc32("pFtRAcsfWnTzyJC",15) == 2478566503) strcat(s, "u");
if (crc32("AMVwfHiI",8) == 4011295723) strcat(s, "a");
if (crc32("PtNEEsXgIjOyUpH",15) == 3220091094) strcat(s, "U");
if (crc32("rRjuWsMZasho",12) == 159746682) strcat(s, "s");
if (crc32("PXfOkUVJGgQ",11) == 3006498357) strcat(s, "i");
if (crc32("pnNANVpugvIFy",13) == 660125878) strcat(s, "s");
if (crc32("avIzHHd",7) == 809611271) strcat(s, "c");
if (crc32("GJwEjruvJasjO",13) == 1079529560) strcat(s, "i");
if (crc32("dStWIjfOS",9) == 4246877469) strcat(s, "v");
if (crc32("UVjnaeZRYuzuT",13) == 2935548802) strcat(s, "i");
if (crc32("RsPxhBkcbizusb",14) == 3021682139) strcat(s, "u");
if (crc32("rwgSp",5) == 1070825113) strcat(s, "l");
if (crc32("tHHqamETeVL",11) == 1038159203) strcat(s, "l");
if (crc32("tvavX",5) == 3521439987) strcat(s, "y");
    return s;
}

char *pallidly_adverbs() {
    char *s = calloc(9);
    if (crc32("BfhfTaHBtGh",11) == 710970676) strcat(s, "p");
if (crc32("MPWwb",5) == 125678391) strcat(s, "a");
if (crc32("xuNTaZYgfswbtI",14) == 4201995198) strcat(s, "l");
if (crc32("sCsSz",5) == 3640512293) strcat(s, "E");
if (crc32("llTQLxPvpypvE",13) == 1437480645) strcat(s, "l");
if (crc32("TxdXYEDhCcheVhi",15) == 4266223814) strcat(s, "C");
if (crc32("oyIxNKLXzeYB",12) == 1048519700) strcat(s, "i");
if (crc32("IHiDdNA",7) == 257936882) strcat(s, "d");
if (crc32("PMRWnPeWQ",9) == 1138202044) strcat(s, "c");
if (crc32("VXBmS",5) == 786933297) strcat(s, "l");
if (crc32("ZLeWyapABdJX",12) == 2981896304) strcat(s, "y");
    return s;
}

char *preveniently_adverbs() {
    char *s = calloc(13);
    if (crc32("bEvUriOXuh",10) == 3682487864) strcat(s, "p");
if (crc32("bsnZhYnZIbmg",12) == 2885335267) strcat(s, "r");
if (crc32("adCtJsRZ",8) == 263911032) strcat(s, "U");
if (crc32("kxMTEOqaZz",10) == 198243313) strcat(s, "e");
if (crc32("sAahzqT",7) == 3714874828) strcat(s, "v");
if (crc32("wnyorN",6) == 1479950622) strcat(s, "e");
if (crc32("gvkMExuvdbaaO",13) == 161789748) strcat(s, "n");
if (crc32("mYLsArsRhDqPyDu",15) == 1580826139) strcat(s, "y");
if (crc32("NtQGSlfQUHuKUcf",15) == 1622824535) strcat(s, "i");
if (crc32("vstvdCnudKv",11) == 3951088142) strcat(s, "D");
if (crc32("nwiWSu",6) == 1458239694) strcat(s, "e");
if (crc32("jfTymfuNW",9) == 1951871041) strcat(s, "n");
if (crc32("kTKCXFe",7) == 1357689458) strcat(s, "n");
if (crc32("nrdxaZljXR",10) == 191589815) strcat(s, "t");
if (crc32("zezVLSnmBnprI",13) == 2759300419) strcat(s, "l");
if (crc32("JCDfSPAZuw",10) == 2753510805) strcat(s, "y");
    return s;
}

char *indictably_adverbs() {
    char *s = calloc(11);
    if (crc32("rvFEzhJnU",9) == 4205801648) strcat(s, "i");
if (crc32("fufysWOrrHB",11) == 2138692903) strcat(s, "n");
if (crc32("WXEhNhMoECdkod",14) == 842505086) strcat(s, "d");
if (crc32("OzhemVGGtdjK",12) == 1325847792) strcat(s, "k");
if (crc32("UGFWwTwWBhByZUm",15) == 556195537) strcat(s, "i");
if (crc32("qAtXGJmRzYWWZmK",15) == 1452750776) strcat(s, "q");
if (crc32("haIEJgGYEu",10) == 123597586) strcat(s, "c");
if (crc32("ImRsGVNIk",9) == 1665182488) strcat(s, "t");
if (crc32("AcWPqGR",7) == 3743427395) strcat(s, "a");
if (crc32("oxTFGeDtPTVNv",13) == 2662075056) strcat(s, "b");
if (crc32("yXcUUv",6) == 2898089220) strcat(s, "O");
if (crc32("wJTJFvHEXb",10) == 3674782922) strcat(s, "l");
if (crc32("ThTdH",5) == 3875578007) strcat(s, "y");
    return s;
}

char *inchmeal_adverbs() {
    char *s = calloc(9);
    if (crc32("GrsFVDM",7) == 2926461075) strcat(s, "i");
if (crc32("OSkluP",6) == 2763403776) strcat(s, "n");
if (crc32("lQwSYVQuAh",10) == 4001530904) strcat(s, "c");
if (crc32("CZAokNnODexBx",13) == 1309393958) strcat(s, "h");
if (crc32("ioAExkJqfo",10) == 4161098290) strcat(s, "m");
if (crc32("rBOFK",5) == 4119750676) strcat(s, "o");
if (crc32("xDoqW",5) == 2606142340) strcat(s, "e");
if (crc32("xvaYaLzhswUA",12) == 3722589445) strcat(s, "a");
if (crc32("UyaULDtOlDQaSdP",15) == 3283014799) strcat(s, "k");
if (crc32("EqsVqj",6) == 2686283394) strcat(s, "l");
    return s;
}

char *unindicatively_adverbs() {
    char *s = calloc(15);
    if (crc32("jPUyaWc",7) == 817115625) strcat(s, "u");
if (crc32("tknVTiHYmATQr",13) == 3278467992) strcat(s, "w");
if (crc32("tMUznWbGDtvypQG",15) == 544514078) strcat(s, "n");
if (crc32("vdjxHvjaCYPDktn",15) == 3237622586) strcat(s, "y");
if (crc32("NMVkBS",6) == 3191476017) strcat(s, "i");
if (crc32("NTlzSRcI",8) == 3047911071) strcat(s, "n");
if (crc32("muVUAYQhVUWI",12) == 96907324) strcat(s, "O");
if (crc32("ImsEKMbf",8) == 1668910907) strcat(s, "d");
if (crc32("DLSLROgLGMZSV",13) == 1232686977) strcat(s, "i");
if (crc32("QIEBomDFJE",10) == 3603182016) strcat(s, "H");
if (crc32("JspotLuay",9) == 1077280431) strcat(s, "c");
if (crc32("qkPruivtEJjdgD",14) == 2840508489) strcat(s, "G");
if (crc32("BMDDUKoSg",9) == 1028987125) strcat(s, "a");
if (crc32("ZMleLl",6) == 2609937088) strcat(s, "t");
if (crc32("higpJwglUXvU",12) == 391503434) strcat(s, "c");
if (crc32("nHHkkd",6) == 1028366143) strcat(s, "i");
if (crc32("NaBYoAy",7) == 1576435045) strcat(s, "v");
if (crc32("bDlcxfrXBXbHxX",14) == 922350100) strcat(s, "e");
if (crc32("JRFKmSyQ",8) == 3425461812) strcat(s, "f");
if (crc32("BICwNUTdRG",10) == 722213463) strcat(s, "l");
if (crc32("pfegEQqnuWY",11) == 1187176479) strcat(s, "y");
if (crc32("GlxuHH",6) == 1129000796) strcat(s, "y");
    return s;
}

char *unproudly_adverbs() {
    char *s = calloc(10);
    if (crc32("mQaww",5) == 859539103) strcat(s, "u");
if (crc32("oHOhAMMjIup",11) == 3785007502) strcat(s, "E");
if (crc32("bBrwEZyVfN",10) == 4038442725) strcat(s, "n");
if (crc32("DvKzCN",6) == 215662173) strcat(s, "p");
if (crc32("SMEucZbhskrW",12) == 268052457) strcat(s, "r");
if (crc32("lIbLikOCUSzAr",13) == 3678664180) strcat(s, "o");
if (crc32("jMFvB",5) == 296346040) strcat(s, "w");
if (crc32("HxPZUaBQej",10) == 3867152380) strcat(s, "u");
if (crc32("kikgRkuKKiBfWW",14) == 4153489175) strcat(s, "k");
if (crc32("FuMjhQ",6) == 3297208758) strcat(s, "d");
if (crc32("ZgXHC",5) == 2812954082) strcat(s, "l");
if (crc32("FFndvvd",7) == 931986297) strcat(s, "Y");
if (crc32("QwdqIK",6) == 471877705) strcat(s, "y");
    return s;
}

char *dextrously_adverbs() {
    char *s = calloc(11);
    if (crc32("KHFYkys",7) == 4231977069) strcat(s, "A");
if (crc32("HTmtJbBaXStdKk",14) == 3524950098) strcat(s, "d");
if (crc32("leJOEFRBhkfCF",13) == 2959343325) strcat(s, "e");
if (crc32("KpAZAFa",7) == 1569813044) strcat(s, "Z");
if (crc32("henpfwsKa",9) == 3590826101) strcat(s, "x");
if (crc32("dOykft",6) == 3464401316) strcat(s, "t");
if (crc32("AnHADxrpteFzlp",14) == 2089354248) strcat(s, "r");
if (crc32("DYnoKsuIDbaDf",13) == 1548664346) strcat(s, "r");
if (crc32("nnlWLj",6) == 1284963940) strcat(s, "o");
if (crc32("BHqjHLEjuor",11) == 1581383049) strcat(s, "g");
if (crc32("bBvZo",5) == 3655900787) strcat(s, "u");
if (crc32("WXCLG",5) == 2214601768) strcat(s, "s");
if (crc32("WgIHUrr",7) == 2513398201) strcat(s, "n");
if (crc32("xhthcngzu",9) == 4021351333) strcat(s, "l");
if (crc32("sjhaJhqJ",8) == 2911475471) strcat(s, "F");
if (crc32("VunhrKhHYAz",11) == 2937490885) strcat(s, "y");
    return s;
}

char *Fridays_adverbs() {
    char *s = calloc(8);
    if (crc32("HYRmpqeMuvECe",13) == 1481240850) strcat(s, "F");
if (crc32("eWoiSHaJRzh",11) == 100596741) strcat(s, "r");
if (crc32("wpJdVFExhGPPuF",14) == 503200192) strcat(s, "i");
if (crc32("iudJMtpEkO",10) == 840167066) strcat(s, "e");
if (crc32("DpksLgWTPQUMoZA",15) == 2423089052) strcat(s, "d");
if (crc32("RAzCEZlLd",9) == 4248037241) strcat(s, "a");
if (crc32("WaliaDSGClmy",12) == 1683880383) strcat(s, "y");
if (crc32("aRGFnBwSizlS",12) == 1646119912) strcat(s, "s");
    return s;
}

char *presently_adverbs() {
    char *s = calloc(10);
    if (crc32("wWATJ",5) == 3800837104) strcat(s, "p");
if (crc32("wisjhrkpgyQRJ",13) == 1750952119) strcat(s, "j");
if (crc32("ooTKZYcH",8) == 1478588916) strcat(s, "r");
if (crc32("NfJKToOBImiAAF",14) == 925669525) strcat(s, "a");
if (crc32("iUNqLfMWjM",10) == 2041513626) strcat(s, "e");
if (crc32("wUZUHNI",7) == 2044970914) strcat(s, "s");
if (crc32("PxvmzPEWxJZ",11) == 1244950500) strcat(s, "l");
if (crc32("nvedCdIBUqoeA",13) == 2425275901) strcat(s, "e");
if (crc32("KEGAPOWsTH",10) == 2690715871) strcat(s, "n");
if (crc32("aMKWctRqHiop",12) == 3454457794) strcat(s, "t");
if (crc32("sFLgBZ",6) == 1047321704) strcat(s, "l");
if (crc32("onConl",6) == 456312212) strcat(s, "y");
    return s;
}

char *herbaceously_adverbs() {
    char *s = calloc(13);
    if (crc32("dwqwIulhOGcXQNo",15) == 218306753) strcat(s, "h");
if (crc32("GkXVfduaXQOQS",13) == 97466789) strcat(s, "d");
if (crc32("dRQkbkTSty",10) == 2497633200) strcat(s, "e");
if (crc32("oKZkHkiCCpx",11) == 2942684489) strcat(s, "r");
if (crc32("YwXZNNKfutUGvnk",15) == 3269522477) strcat(s, "b");
if (crc32("cxbNsijetCH",11) == 3557233749) strcat(s, "a");
if (crc32("mpAJCtquqpg",11) == 2508542249) strcat(s, "T");
if (crc32("GzdcUYnkOqCHF",13) == 3437223048) strcat(s, "c");
if (crc32("bDnqA",5) == 1141949377) strcat(s, "e");
if (crc32("mWVrJmXpKbLtFk",14) == 24326299) strcat(s, "H");
if (crc32("FoanrTzy",8) == 1141803843) strcat(s, "o");
if (crc32("aSWXCIlaC",9) == 1457769763) strcat(s, "f");
if (crc32("uplCzxj",7) == 4003124882) strcat(s, "u");
if (crc32("IGDMcGt",7) == 946778871) strcat(s, "s");
if (crc32("BffxrnSkoSuCGD",14) == 265805149) strcat(s, "B");
if (crc32("YEqIBwJL",8) == 3116027217) strcat(s, "l");
if (crc32("JXnNgVSvRSo",11) == 299871364) strcat(s, "K");
if (crc32("dLUqsSYTAHJ",11) == 2922654107) strcat(s, "y");
    return s;
}

char *malignly_adverbs() {
    char *s = calloc(9);
    if (crc32("luYCSqCoVDWpm",13) == 539237168) strcat(s, "m");
if (crc32("UmsYEknHNmlzVQ",14) == 4078987989) strcat(s, "a");
if (crc32("aqluQsPpGKO",11) == 2270535660) strcat(s, "L");
if (crc32("YSsrl",5) == 623057637) strcat(s, "l");
if (crc32("oQUnnil",7) == 3191399196) strcat(s, "i");
if (crc32("thYQBWxbf",9) == 4186213522) strcat(s, "E");
if (crc32("xrhojCYhOIWzb",13) == 4070326517) strcat(s, "g");
if (crc32("UYSimbRTvjZYTdN",15) == 2411244750) strcat(s, "F");
if (crc32("bPmksnW",7) == 1485315532) strcat(s, "n");
if (crc32("QMTPKwviQkfUl",13) == 2013277663) strcat(s, "l");
if (crc32("xROIlxw",7) == 1465390532) strcat(s, "y");
    return s;
}

char *overaffirmatively_adverbs() {
    char *s = calloc(18);
    if (crc32("RakqiYZgwD",10) == 3652806257) strcat(s, "i");
if (crc32("fcFMnQxIpcB",11) == 1194385294) strcat(s, "o");
if (crc32("opZXC",5) == 1256446733) strcat(s, "v");
if (crc32("utEKUUPcjjsP",12) == 1829133388) strcat(s, "e");
if (crc32("pRKfVAHM",8) == 2703655308) strcat(s, "r");
if (crc32("fXkBLlqj",8) == 3317007321) strcat(s, "U");
if (crc32("MVkhWEOSXa",10) == 3634156435) strcat(s, "a");
if (crc32("CqeFHmps",8) == 1581504102) strcat(s, "e");
if (crc32("LbZoMDqcpE",10) == 45050922) strcat(s, "f");
if (crc32("GpfTQXwkYDWO",12) == 2436330405) strcat(s, "f");
if (crc32("soRxGaHaRFaJU",13) == 554702235) strcat(s, "i");
if (crc32("CVnZWFoMzx",10) == 2210065483) strcat(s, "r");
if (crc32("RCpluqcuKYFDusR",15) == 2638714122) strcat(s, "s");
if (crc32("HjCgeYd",7) == 2516545512) strcat(s, "m");
if (crc32("EOioEqLdiRVQmUJ",15) == 883681674) strcat(s, "r");
if (crc32("RYGLhhgf",8) == 2097771603) strcat(s, "a");
if (crc32("UcQXyFzVdCi",11) == 3121413707) strcat(s, "S");
if (crc32("GNzjhNAP",8) == 770313060) strcat(s, "t");
if (crc32("axEIyKozZQ",10) == 1127182824) strcat(s, "i");
if (crc32("NjwZsel",7) == 2947635519) strcat(s, "R");
if (crc32("WmabNo",6) == 3134569338) strcat(s, "v");
if (crc32("jRCXJngjlHrUGjD",15) == 3355295565) strcat(s, "e");
if (crc32("uBDRljwlAA",10) == 918771648) strcat(s, "E");
if (crc32("uCbpIDeChoLKlO",14) == 4104246801) strcat(s, "l");
if (crc32("rDhlxlNoDIi",11) == 2081829872) strcat(s, "y");
    return s;
}

char *hotheadedly_adverbs() {
    char *s = calloc(12);
    if (crc32("VLWFJglxzvVVf",13) == 3062958474) strcat(s, "h");
if (crc32("hFczUjm",7) == 3962412216) strcat(s, "I");
if (crc32("QHMMnBCMtA",10) == 3975456301) strcat(s, "o");
if (crc32("uTJxMLbovb",10) == 496474239) strcat(s, "p");
if (crc32("pwcdtPgghWfT",12) == 1312109383) strcat(s, "t");
if (crc32("VkFuhATnEdrEndK",15) == 3466172934) strcat(s, "w");
if (crc32("qfZtOnFiwpkfTAZ",15) == 996898866) strcat(s, "h");
if (crc32("kJEyYinLSecRgw",14) == 848730185) strcat(s, "e");
if (crc32("CyNMwDsqtwkRY",13) == 1497621711) strcat(s, "a");
if (crc32("pyYezBGIV",9) == 4094510511) strcat(s, "E");
if (crc32("AGkWEnb",7) == 4226212694) strcat(s, "d");
if (crc32("xvDmCTIVwuB",11) == 3741092989) strcat(s, "e");
if (crc32("PDkGL",5) == 2119343179) strcat(s, "f");
if (crc32("uTtLRATEgCFDcO",14) == 1441822107) strcat(s, "d");
if (crc32("DOQNAfbhklkKXH",14) == 2894905518) strcat(s, "j");
if (crc32("UsrsdXI",7) == 2836633416) strcat(s, "l");
if (crc32("xPGcWeOkckhY",12) == 1042332303) strcat(s, "G");
if (crc32("wMfhnxGBl",9) == 3078964104) strcat(s, "y");
    return s;
}

char *homophonically_adverbs() {
    char *s = calloc(15);
    if (crc32("SIbDN",5) == 296725609) strcat(s, "h");
if (crc32("biwiJwK",7) == 1595877193) strcat(s, "o");
if (crc32("SHFrCHp",7) == 1621550595) strcat(s, "m");
if (crc32("uswvlGkimGI",11) == 2244235983) strcat(s, "f");
if (crc32("UQFpDbvvCE",10) == 1861567778) strcat(s, "o");
if (crc32("YWacppjjyzUp",12) == 839148716) strcat(s, "p");
if (crc32("tvLXrPTgElO",11) == 623846887) strcat(s, "h");
if (crc32("yCXICghTdJqter",14) == 1013997688) strcat(s, "o");
if (crc32("jEEMYmrhhay",11) == 1712006857) strcat(s, "L");
if (crc32("GiSUEBgHREiZ",12) == 2568908138) strcat(s, "n");
if (crc32("qwcKv",5) == 335712761) strcat(s, "i");
if (crc32("hSayo",5) == 3695015100) strcat(s, "c");
if (crc32("IAFNyDUKRCL",11) == 3166501356) strcat(s, "a");
if (crc32("LDYOWsIOpuBU",12) == 3122065319) strcat(s, "H");
if (crc32("dTQhCZsI",8) == 1796330726) strcat(s, "l");
if (crc32("MMEUneSdTWO",11) == 2763505438) strcat(s, "l");
if (crc32("ocViG",5) == 311781153) strcat(s, "G");
if (crc32("GJwFRwZLsS",10) == 1961492934) strcat(s, "y");
    return s;
}

char *nonratably_adverbs() {
    char *s = calloc(11);
    if (crc32("emmHgHeZ",8) == 2163042133) strcat(s, "n");
if (crc32("rcLVDpYuqFqEH",13) == 4197646596) strcat(s, "o");
if (crc32("HFAdhUTc",8) == 2394871091) strcat(s, "n");
if (crc32("ekKWc",5) == 643425906) strcat(s, "r");
if (crc32("CQlSgqiEknC",11) == 603917248) strcat(s, "P");
if (crc32("bGDUfbkrj",9) == 678606016) strcat(s, "a");
if (crc32("XrktH",5) == 2023836305) strcat(s, "t");
if (crc32("MVFUk",5) == 3708904179) strcat(s, "B");
if (crc32("AlBCXP",6) == 1942800289) strcat(s, "a");
if (crc32("NPNBADDfuG",10) == 1656014722) strcat(s, "E");
if (crc32("VhmcFkGfi",9) == 3385234686) strcat(s, "b");
if (crc32("XGROOD",6) == 1203057998) strcat(s, "i");
if (crc32("RqFzcTpoLmfR",12) == 3701568973) strcat(s, "l");
if (crc32("ztxKXPhkJO",10) == 2750356556) strcat(s, "T");
if (crc32("OGKBNDfO",8) == 2315464555) strcat(s, "y");
    return s;
}

char *unexclusively_adverbs() {
    char *s = calloc(14);
    if (crc32("llFHdmsriwEfudS",15) == 248608327) strcat(s, "E");
if (crc32("ThwEkhRdJ",9) == 1412673507) strcat(s, "u");
if (crc32("vcjaPphFQIfrMIR",15) == 2751529572) strcat(s, "n");
if (crc32("NBhzdXNDnHs",11) == 1890136819) strcat(s, "e");
if (crc32("iqDjcHGcjJKRf",13) == 21434036) strcat(s, "e");
if (crc32("JYkfVOtq",8) == 3867326343) strcat(s, "x");
if (crc32("qrgxsdeH",8) == 4104462663) strcat(s, "c");
if (crc32("pKPtXkXmAKsJpy",14) == 4179028461) strcat(s, "k");
if (crc32("DvyrxwlPGelKkb",14) == 853188475) strcat(s, "l");
if (crc32("BfhGGxtAzTVI",12) == 3605727310) strcat(s, "j");
if (crc32("EkXKkbrdOzLP",12) == 1084368099) strcat(s, "u");
if (crc32("gosgASJHpDvn",12) == 1070002068) strcat(s, "s");
if (crc32("RLvKMSI",7) == 2381303444) strcat(s, "i");
if (crc32("AricYAotjGgk",12) == 1359071008) strcat(s, "i");
if (crc32("vxDYMrk",7) == 1375254101) strcat(s, "v");
if (crc32("qsEoIDOkbtE",11) == 2717067250) strcat(s, "e");
if (crc32("pYZunyUcbUp",11) == 557231621) strcat(s, "l");
if (crc32("TdKCNkzmCpc",11) == 88653588) strcat(s, "y");
    return s;
}

char *faintheartedly_adverbs() {
    char *s = calloc(15);
    if (crc32("GslYyEJ",7) == 3342534232) strcat(s, "P");
if (crc32("bbGhEFvDANm",11) == 2393337515) strcat(s, "f");
if (crc32("hBmVj",5) == 1609855424) strcat(s, "a");
if (crc32("qxcycHmkCrCu",12) == 2924956367) strcat(s, "F");
if (crc32("gOPoFdsCwSPVe",13) == 3841690434) strcat(s, "i");
if (crc32("WjoyVk",6) == 2100232328) strcat(s, "n");
if (crc32("EXwwzTYEfMMC",12) == 2888641776) strcat(s, "L");
if (crc32("qKEWBLAhEXUhbEb",15) == 3550437287) strcat(s, "t");
if (crc32("GExZaZysEVv",11) == 1191001823) strcat(s, "s");
if (crc32("pBjveFaPbq",10) == 995187284) strcat(s, "h");
if (crc32("uwkUpIFuODMjF",13) == 3637117653) strcat(s, "e");
if (crc32("keiRWkPrE",9) == 3997951680) strcat(s, "a");
if (crc32("iqEucyeodU",10) == 1518019504) strcat(s, "V");
if (crc32("kcEfyOsEWDc",11) == 473459984) strcat(s, "r");
if (crc32("DrkSpGhjibZXdu",14) == 2684369235) strcat(s, "t");
if (crc32("HBfihWX",7) == 1626825712) strcat(s, "u");
if (crc32("hqHPxkZVdwrrVqE",15) == 2625346687) strcat(s, "e");
if (crc32("QirqHqufBNqJlbN",15) == 2809662642) strcat(s, "P");
if (crc32("lfvzzUNhfcbSht",14) == 1446614311) strcat(s, "d");
if (crc32("IutBOkcTOgB",11) == 3858583979) strcat(s, "y");
if (crc32("JYhPrsMmj",9) == 2900705357) strcat(s, "l");
if (crc32("QYkothohTZxh",12) == 81560698) strcat(s, "l");
if (crc32("YyHvPnQRjDbdJG",14) == 2110736397) strcat(s, "y");
    return s;
}

char *overmilitaristically_adverbs() {
    char *s = calloc(21);
    if (crc32("RaagGFuBOBT",11) == 1766566170) strcat(s, "o");
if (crc32("ZscRBHO",7) == 2234785022) strcat(s, "v");
if (crc32("LMLkBmPe",8) == 3276143328) strcat(s, "A");
if (crc32("ObarV",5) == 1538935215) strcat(s, "e");
if (crc32("PLLQpWYNf",9) == 2824741416) strcat(s, "r");
if (crc32("PvbmuDZNK",9) == 2646375847) strcat(s, "m");
if (crc32("EhWGxxKAlELpwHO",15) == 3546570344) strcat(s, "i");
if (crc32("XlSDIuWEqtm",11) == 1961758291) strcat(s, "F");
if (crc32("OkssXDfLe",9) == 198096992) strcat(s, "l");
if (crc32("tFBEueq",7) == 3204519394) strcat(s, "i");
if (crc32("FjMoF",5) == 2459471845) strcat(s, "h");
if (crc32("kuYpqPDzAW",10) == 2141757693) strcat(s, "t");
if (crc32("nVpceqbZo",9) == 725113368) strcat(s, "m");
if (crc32("cGGSzm",6) == 1536894202) strcat(s, "a");
if (crc32("MpANxoh",7) == 1445216027) strcat(s, "r");
if (crc32("wEnWIpNgYKgzqi",14) == 535891206) strcat(s, "u");
if (crc32("EZCrI",5) == 2454986299) strcat(s, "i");
if (crc32("jXktPQcZprDCYDn",15) == 1954870568) strcat(s, "s");
if (crc32("zhnUxt",6) == 3765319446) strcat(s, "D");
if (crc32("UwjJgK",6) == 1146584625) strcat(s, "t");
if (crc32("fFofevVXW",9) == 2350333209) strcat(s, "m");
if (crc32("ZlNsDjrZyQdHew",14) == 216574639) strcat(s, "i");
if (crc32("BccyS",5) == 479732590) strcat(s, "C");
if (crc32("xxSRrF",6) == 2871468098) strcat(s, "c");
if (crc32("alRWLpzj",8) == 59012373) strcat(s, "a");
if (crc32("GIsnzdUxzKfyMR",14) == 125909187) strcat(s, "M");
if (crc32("dQifPtfTo",9) == 759658788) strcat(s, "l");
if (crc32("wzdWAdhGvpUe",12) == 3747478629) strcat(s, "M");
if (crc32("wRxPjIx",7) == 3446636351) strcat(s, "l");
if (crc32("BnesduLkJed",11) == 3638059614) strcat(s, "G");
if (crc32("HGatvAaNic",10) == 4051720820) strcat(s, "y");
    return s;
}

char *unsulkily_adverbs() {
    char *s = calloc(10);
    if (crc32("IJHAKQhe",8) == 2244207831) strcat(s, "i");
if (crc32("MveXejbKYo",10) == 1399415118) strcat(s, "u");
if (crc32("mOglppAI",8) == 4070419401) strcat(s, "p");
if (crc32("UxAMBKUwXvAO",12) == 2928181353) strcat(s, "n");
if (crc32("nfUjr",5) == 1460933844) strcat(s, "T");
if (crc32("WPyKUqqFCyvcLLm",15) == 2434323163) strcat(s, "s");
if (crc32("owyutgezsRYq",12) == 2449179443) strcat(s, "u");
if (crc32("ubcHajPZNwPXc",13) == 1998622814) strcat(s, "l");
if (crc32("rymZtRCUtCsxe",13) == 708014770) strcat(s, "Y");
if (crc32("mdYTlsawNVTD",12) == 697830524) strcat(s, "k");
if (crc32("bvngAXME",8) == 1675533518) strcat(s, "i");
if (crc32("pMINbgEJwT",10) == 2875785621) strcat(s, "l");
if (crc32("zNmcg",5) == 3548558481) strcat(s, "y");
    return s;
}

char *seedily_adverbs() {
    char *s = calloc(8);
    if (crc32("mJENMDcZdA",10) == 2938202007) strcat(s, "s");
if (crc32("XjkKSgeozqil",12) == 4050649413) strcat(s, "e");
if (crc32("qiKyc",5) == 305600151) strcat(s, "e");
if (crc32("RvujTBOfoI",10) == 3250600046) strcat(s, "d");
if (crc32("hmGTljUPIZ",10) == 1920523077) strcat(s, "t");
if (crc32("MKtJUHrUTsfFHbX",15) == 3061486742) strcat(s, "i");
if (crc32("BPgGIB",6) == 189748615) strcat(s, "V");
if (crc32("QRSkrhzzzvbuRWa",15) == 2100346536) strcat(s, "l");
if (crc32("NsSbB",5) == 4186482487) strcat(s, "y");
    return s;
}

char *nonsystematically_adverbs() {
    char *s = calloc(18);
    if (crc32("vKVJYYUACMc",11) == 2302727108) strcat(s, "m");
if (crc32("QLrSCDtLaxIgvsd",15) == 908402804) strcat(s, "n");
if (crc32("ebGFnr",6) == 1034476712) strcat(s, "o");
if (crc32("ULqmZEgPpEkl",12) == 2306488952) strcat(s, "S");
if (crc32("sawuOloRde",10) == 1070702597) strcat(s, "n");
if (crc32("knjawhzhgUVSsv",14) == 460956937) strcat(s, "s");
if (crc32("ffKlyK",6) == 1768003329) strcat(s, "T");
if (crc32("JPrvo",5) == 3966871248) strcat(s, "y");
if (crc32("auDPat",6) == 270277882) strcat(s, "s");
if (crc32("ysXdccSpZF",10) == 3683799231) strcat(s, "t");
if (crc32("lJILC",5) == 2719708004) strcat(s, "e");
if (crc32("peILFgqxVRzsyBf",15) == 1032827618) strcat(s, "j");
if (crc32("ErLRYoiaJT",10) == 3598512802) strcat(s, "m");
if (crc32("yBEBDvSQUzVrqh",14) == 1377752668) strcat(s, "n");
if (crc32("NizkmBM",7) == 1942703997) strcat(s, "a");
if (crc32("CMGvKpoXxvFeyQE",15) == 3492268806) strcat(s, "t");
if (crc32("sQGyumHkNvXgcD",14) == 2738414522) strcat(s, "i");
if (crc32("DRVckdhRH",9) == 3955549678) strcat(s, "X");
if (crc32("hEsKXIjLFuaaU",13) == 4286187309) strcat(s, "c");
if (crc32("BmhxfFEySO",10) == 85017956) strcat(s, "T");
if (crc32("oqobHxm",7) == 13488225) strcat(s, "a");
if (crc32("EINfHDSpOyV",11) == 1584514018) strcat(s, "l");
if (crc32("FjwNb",5) == 1999574692) strcat(s, "U");
if (crc32("rJDxbdzptlziga",14) == 2960479855) strcat(s, "l");
if (crc32("WiIzUhvcGVYYa",13) == 430732842) strcat(s, "e");
if (crc32("zREmTZqLJytcIKJ",15) == 2321136883) strcat(s, "y");
    return s;
}

char *propitiously_adverbs() {
    char *s = calloc(13);
    if (crc32("AfwLKWEZy",9) == 1299825741) strcat(s, "G");
if (crc32("rpnFGbjpW",9) == 1913190434) strcat(s, "p");
if (crc32("dUwjLVQU",8) == 2224658756) strcat(s, "r");
if (crc32("ZQHyQKzDfbtaul",14) == 427877352) strcat(s, "v");
if (crc32("jvNkX",5) == 3259608273) strcat(s, "o");
if (crc32("igBsTDtaEeBJdbu",15) == 620060479) strcat(s, "t");
if (crc32("SByEwkQs",8) == 166147163) strcat(s, "p");
if (crc32("HkIJtI",6) == 1667839385) strcat(s, "i");
if (crc32("JmuiNdBcB",9) == 2171293257) strcat(s, "t");
if (crc32("VuDMCZIrFGpF",12) == 1873944243) strcat(s, "i");
if (crc32("rnphLsgrE",9) == 1197267356) strcat(s, "o");
if (crc32("HvUJDoe",7) == 3386480601) strcat(s, "s");
if (crc32("GoJrGLwAJjdMgeQ",15) == 476403671) strcat(s, "u");
if (crc32("iborqdChswybkP",14) == 270194434) strcat(s, "s");
if (crc32("tvCpza",6) == 590679187) strcat(s, "G");
if (crc32("EVIaJiksS",9) == 367112745) strcat(s, "l");
if (crc32("hfTfeQL",7) == 1098989268) strcat(s, "h");
if (crc32("UbtqH",5) == 3123038647) strcat(s, "y");
    return s;
}

char *pseudoarticulately_adverbs() {
    char *s = calloc(19);
    if (crc32("fLFIOV",6) == 3333549577) strcat(s, "p");
if (crc32("FhPZJh",6) == 576233087) strcat(s, "s");
if (crc32("ljdOBRF",7) == 3543303917) strcat(s, "j");
if (crc32("kjQjhslefE",10) == 3852620638) strcat(s, "e");
if (crc32("qKeWBORGAlqfqx",14) == 2143678483) strcat(s, "u");
if (crc32("kyDwAp",6) == 3684459075) strcat(s, "d");
if (crc32("uwxcsyBxkgJB",12) == 1941120640) strcat(s, "o");
if (crc32("cFVdGKEI",8) == 1392132804) strcat(s, "a");
if (crc32("RKdRbpANgVvmd",13) == 2094012032) strcat(s, "r");
if (crc32("DlAVrAxbZPJnj",13) == 3179356799) strcat(s, "D");
if (crc32("pDjvVjtxzHnabcb",15) == 1522654111) strcat(s, "t");
if (crc32("airidjYAdk",10) == 3553997684) strcat(s, "h");
if (crc32("mRfLSkGW",8) == 237326986) strcat(s, "i");
if (crc32("AekabcCEhHUE",12) == 3818990645) strcat(s, "c");
if (crc32("qkbxLFIRPQ",10) == 3919844994) strcat(s, "u");
if (crc32("lVMLbXkwwuA",11) == 1696853078) strcat(s, "L");
if (crc32("pubcrUBAdLgFbd",14) == 326731730) strcat(s, "l");
if (crc32("FZzdKWpvwVEnlk",14) == 2050714077) strcat(s, "a");
if (crc32("tTFFgydFL",9) == 3477213430) strcat(s, "t");
if (crc32("uxSXckaqUYkTXIN",15) == 1548423420) strcat(s, "e");
if (crc32("sbJxNlvg",8) == 2885722387) strcat(s, "l");
if (crc32("yGjCuPwarSlO",12) == 1097010539) strcat(s, "f");
if (crc32("joxMflKMRcXK",12) == 2538083626) strcat(s, "y");
    return s;
}

char *aeronautically_adverbs() {
    char *s = calloc(15);
    if (crc32("DQxUYwfVb",9) == 3827514751) strcat(s, "I");
if (crc32("uzsmnhx",7) == 1325942047) strcat(s, "a");
if (crc32("tGVjyUAOpbB",11) == 3822570934) strcat(s, "X");
if (crc32("TsCzPyDZetTDj",13) == 448565) strcat(s, "e");
if (crc32("YPxTI",5) == 3004763529) strcat(s, "r");
if (crc32("tfUFNV",6) == 2800643704) strcat(s, "e");
if (crc32("tjUosmzSnhDpsq",14) == 385093146) strcat(s, "o");
if (crc32("xTeiJBPSvkzU",12) == 2315882263) strcat(s, "n");
if (crc32("GbMshuTlyzm",11) == 2392011849) strcat(s, "s");
if (crc32("HzHlAiumOUCyHB",14) == 3157663580) strcat(s, "a");
if (crc32("YjuyYo",6) == 4168355541) strcat(s, "u");
if (crc32("oVSbSPe",7) == 758147420) strcat(s, "z");
if (crc32("TdZTdXtPC",9) == 3912314303) strcat(s, "t");
if (crc32("JgHvz",5) == 3316441701) strcat(s, "i");
if (crc32("QJEpvVrb",8) == 1165873497) strcat(s, "V");
if (crc32("MvFEWEpoQhuQJg",14) == 3716426991) strcat(s, "c");
if (crc32("vPoCDLHLzfa",11) == 4094923914) strcat(s, "L");
if (crc32("TXQYeYvJFAml",12) == 3036476710) strcat(s, "a");
if (crc32("kOAWydPXVV",10) == 1543759171) strcat(s, "A");
if (crc32("bCyPTiysOpkQ",12) == 3638977819) strcat(s, "l");
if (crc32("PzFGqLcqFy",10) == 2114610678) strcat(s, "X");
if (crc32("qDbQG",5) == 380458592) strcat(s, "l");
if (crc32("VcMEyCwrHj",10) == 4062400886) strcat(s, "l");
if (crc32("HtdLOC",6) == 191576253) strcat(s, "y");
    return s;
}

char *nonnaturally_adverbs() {
    char *s = calloc(13);
    if (crc32("aScWkFK",7) == 2974846122) strcat(s, "n");
if (crc32("eSvtNI",6) == 3927846434) strcat(s, "o");
if (crc32("ValdGf",6) == 722838457) strcat(s, "b");
if (crc32("tRbQuS",6) == 1071219757) strcat(s, "n");
if (crc32("qvkPjUzJiIwFT",13) == 2510272051) strcat(s, "k");
if (crc32("SgVUjDmjrFJPp",13) == 2776798421) strcat(s, "n");
if (crc32("kPSBcWfu",8) == 821547529) strcat(s, "a");
if (crc32("qxCOQsntKI",10) == 1225214344) strcat(s, "t");
if (crc32("oUSxelFwqbjV",12) == 1449234015) strcat(s, "f");
if (crc32("ASmaTfk",7) == 2504002285) strcat(s, "u");
if (crc32("VbdomGyDYMWq",12) == 2891871386) strcat(s, "r");
if (crc32("GuvIxEsomkFXD",13) == 2485885262) strcat(s, "o");
if (crc32("BjuNXRK",7) == 2789347173) strcat(s, "a");
if (crc32("aIuZxSIQQSSfuUU",15) == 157159653) strcat(s, "h");
if (crc32("NNcFsbmLjvptkUE",15) == 488121676) strcat(s, "l");
if (crc32("AlaiIRxSY",9) == 778172996) strcat(s, "P");
if (crc32("tkIBCvGrYWwIaht",15) == 660374028) strcat(s, "l");
if (crc32("MilBevKpbDXivv",14) == 1090083268) strcat(s, "y");
    return s;
}

char *imperialistically_adverbs() {
    char *s = calloc(18);
    if (crc32("gHQdot",6) == 3914762361) strcat(s, "u");
if (crc32("FoVDVvoEOb",10) == 3187015562) strcat(s, "i");
if (crc32("hTByj",5) == 2629690139) strcat(s, "N");
if (crc32("jGnIhzK",7) == 317963110) strcat(s, "m");
if (crc32("nddnmaMaFgbxn",13) == 3585746986) strcat(s, "x");
if (crc32("QRpYooBU",8) == 2403702624) strcat(s, "p");
if (crc32("yaUpGRgDu",9) == 2930940851) strcat(s, "e");
if (crc32("XukyGGwIBlZ",11) == 928287989) strcat(s, "I");
if (crc32("ScrwZULyPMhO",12) == 1579386939) strcat(s, "r");
if (crc32("AeVVopLBJxTp",12) == 3678470822) strcat(s, "i");
if (crc32("fkbmTnNooB",10) == 1778450129) strcat(s, "a");
if (crc32("iRzZv",5) == 3507943481) strcat(s, "P");
if (crc32("aVEjNRVhQHsxO",13) == 3348957546) strcat(s, "l");
if (crc32("tNWjlMvUhN",10) == 3177951631) strcat(s, "i");
if (crc32("dCznKCtvIjYmYLU",15) == 2464897982) strcat(s, "J");
if (crc32("GKGsZheTWZcRt",13) == 2103618218) strcat(s, "s");
if (crc32("CNGIyKZ",7) == 301931808) strcat(s, "t");
if (crc32("jFgCrnxBBXOft",13) == 1564746910) strcat(s, "t");
if (crc32("ngVTBXWbUBoD",12) == 3440326218) strcat(s, "i");
if (crc32("RWIHFBUPImA",11) == 1755468450) strcat(s, "c");
if (crc32("ePlAznrTcmUGgRR",15) == 3657448347) strcat(s, "a");
if (crc32("JBCei",5) == 2783323471) strcat(s, "e");
if (crc32("cgFWXczQv",9) == 231338268) strcat(s, "l");
if (crc32("twwJByqWJaYHcwn",15) == 1028939362) strcat(s, "l");
if (crc32("vrSzRMHc",8) == 3979884999) strcat(s, "Y");
if (crc32("uOlHpJhrVviKrl",14) == 1862032757) strcat(s, "y");
    return s;
}

char *preprudently_adverbs() {
    char *s = calloc(13);
    if (crc32("AMEzKKgTUa",10) == 2657046889) strcat(s, "r");
if (crc32("rCvFeWYjMZs",11) == 2357787987) strcat(s, "p");
if (crc32("sxtaqODc",8) == 1148219803) strcat(s, "r");
if (crc32("xYkcCpg",7) == 539932712) strcat(s, "e");
if (crc32("OGiEpdP",7) == 999410190) strcat(s, "p");
if (crc32("Bwigauzj",8) == 2326471284) strcat(s, "r");
if (crc32("TzkeVMoipVWurY",14) == 753476815) strcat(s, "u");
if (crc32("ZwuAgfpOKeCNjV",14) == 2425123734) strcat(s, "d");
if (crc32("JrPPlFXuIuSArPK",15) == 904555012) strcat(s, "B");
if (crc32("thSfKzfdfQll",12) == 3143321448) strcat(s, "e");
if (crc32("ruIsaqvmh",9) == 448541050) strcat(s, "X");
if (crc32("ZmRCvICActefs",13) == 1442294011) strcat(s, "n");
if (crc32("hpeRrDBEwgITZJ",14) == 2531867790) strcat(s, "P");
if (crc32("mUQuhdc",7) == 3778205971) strcat(s, "t");
if (crc32("VcsQAlXnUMO",11) == 1943647636) strcat(s, "P");
if (crc32("sdcPDTOK",8) == 1734021383) strcat(s, "l");
if (crc32("bjxAr",5) == 1963623043) strcat(s, "H");
if (crc32("KhsGYQUTYJUf",12) == 2175806810) strcat(s, "y");
    return s;
}

char *retractively_adverbs() {
    char *s = calloc(13);
    if (crc32("pIwvsBbQkEDpr",13) == 518316189) strcat(s, "r");
if (crc32("IUugclrCgCJi",12) == 1451889939) strcat(s, "r");
if (crc32("wAhsfESmnZW",11) == 1113765274) strcat(s, "q");
if (crc32("FQOXgIKKwJMf",12) == 2422343217) strcat(s, "e");
if (crc32("ukFWyMlBw",9) == 934522839) strcat(s, "t");
if (crc32("tlpkGWllMuB",11) == 2621970824) strcat(s, "r");
if (crc32("sQDztHwAzrbk",12) == 2449202393) strcat(s, "a");
if (crc32("zvQMYNqoNiGLXp",14) == 4226934206) strcat(s, "c");
if (crc32("lvaBms",6) == 1371375433) strcat(s, "t");
if (crc32("emQZO",5) == 1753240985) strcat(s, "z");
if (crc32("KBDQDTFOOKLNlq",14) == 4181824933) strcat(s, "i");
if (crc32("SUvfhAGsLv",10) == 1071591055) strcat(s, "v");
if (crc32("kuXRRLBPM",9) == 841814605) strcat(s, "t");
if (crc32("APpvcoFfSK",10) == 3572992651) strcat(s, "e");
if (crc32("IicLbZfh",8) == 3918566021) strcat(s, "B");
if (crc32("RcXFEyPZOeVtA",13) == 898590796) strcat(s, "l");
if (crc32("LDaPOT",6) == 2431315404) strcat(s, "y");
    return s;
}

char *antiphonally_adverbs() {
    char *s = calloc(13);
    if (crc32("MImcKhmotNy",11) == 2653925057) strcat(s, "k");
if (crc32("cDGDsPfPzFC",11) == 1042620151) strcat(s, "a");
if (crc32("iQtItxbZKhlivDM",15) == 3880349565) strcat(s, "n");
if (crc32("viVMmQUlZ",9) == 1665497983) strcat(s, "t");
if (crc32("nIxyBjDfGuqt",12) == 1572421805) strcat(s, "V");
if (crc32("SHyHRCXbZn",10) == 3787001696) strcat(s, "i");
if (crc32("kWSvUTZ",7) == 196049300) strcat(s, "p");
if (crc32("yOpljti",7) == 2832036275) strcat(s, "h");
if (crc32("PgXUAyGAKHBKgt",14) == 1743309844) strcat(s, "o");
if (crc32("LoQaRr",6) == 3730644458) strcat(s, "X");
if (crc32("EWzWsSjErNG",11) == 1423660910) strcat(s, "n");
if (crc32("xPEQOqpSGuq",11) == 3375627561) strcat(s, "a");
if (crc32("lYuLtMlKBTF",11) == 957269000) strcat(s, "l");
if (crc32("MpNMrISl",8) == 3305951782) strcat(s, "l");
if (crc32("PcwyTZThYazwSQ",14) == 296419193) strcat(s, "S");
if (crc32("gLpmiBO",7) == 4166199610) strcat(s, "y");
    return s;
}

char *gelatinously_adverbs() {
    char *s = calloc(13);
    if (crc32("wrhFAxXNoMLoTn",14) == 3379175975) strcat(s, "t");
if (crc32("uFncuCNRhZciLeW",15) == 318009019) strcat(s, "g");
if (crc32("ZtbJNt",6) == 3750529683) strcat(s, "P");
if (crc32("PhiuQZG",7) == 1464851206) strcat(s, "e");
if (crc32("DKdxjYvAeWz",11) == 1329416066) strcat(s, "l");
if (crc32("yUyHtgzWFzPLn",13) == 3262320325) strcat(s, "s");
if (crc32("VKvUk",5) == 1890850665) strcat(s, "a");
if (crc32("NySpMWdWXID",11) == 1055917529) strcat(s, "t");
if (crc32("nRMhgVCKSdDd",12) == 4166426307) strcat(s, "t");
if (crc32("MLUeKyAd",8) == 3976733127) strcat(s, "i");
if (crc32("RAhho",5) == 2444514064) strcat(s, "n");
if (crc32("YDWgc",5) == 1889755258) strcat(s, "o");
if (crc32("kfCBhMTjkbNBg",13) == 3410122654) strcat(s, "u");
if (crc32("IByQEbz",7) == 408318182) strcat(s, "s");
if (crc32("uNwIuAfXIu",10) == 1513782252) strcat(s, "p");
if (crc32("SzsQoTNAnwuzZ",13) == 442964908) strcat(s, "l");
if (crc32("nzRvDSj",7) == 2881029703) strcat(s, "y");
    return s;
}

char *lustfully_adverbs() {
    char *s = calloc(10);
    if (crc32("QybqUpFqX",9) == 2462565272) strcat(s, "K");
if (crc32("OsGwxCVa",8) == 464769891) strcat(s, "l");
if (crc32("VYkydWMIX",9) == 244667686) strcat(s, "u");
if (crc32("WGiHpxgzTkwTHQX",15) == 2021617183) strcat(s, "z");
if (crc32("iRRuVpLpdJuppO",14) == 1397396296) strcat(s, "s");
if (crc32("mlDaxXD",7) == 2145597608) strcat(s, "t");
if (crc32("SAXYSXOyU",9) == 2492714780) strcat(s, "y");
if (crc32("ALycahtpdiDRR",13) == 3998069726) strcat(s, "f");
if (crc32("aRNDJTkW",8) == 170181653) strcat(s, "T");
if (crc32("yIhHZYt",7) == 1712563490) strcat(s, "u");
if (crc32("pbLVWCJGFoX",11) == 17818522) strcat(s, "n");
if (crc32("rHKhuSR",7) == 2464724029) strcat(s, "l");
if (crc32("GddDFHBAPRTA",12) == 1654923441) strcat(s, "R");
if (crc32("JRRGvz",6) == 2159414844) strcat(s, "l");
if (crc32("GKzMaTTUn",9) == 899520294) strcat(s, "y");
    return s;
}

char *constrainingly_adverbs() {
    char *s = calloc(15);
    if (crc32("nOQkbTCyoYdWi",13) == 4038849370) strcat(s, "c");
if (crc32("FdYCF",5) == 2186532860) strcat(s, "o");
if (crc32("CajEJFy",7) == 2795012747) strcat(s, "n");
if (crc32("nZmcpmF",7) == 3101471065) strcat(s, "s");
if (crc32("LFymTCdgBCj",11) == 2728913848) strcat(s, "t");
if (crc32("vjiyammhKLzrMRG",15) == 87846509) strcat(s, "i");
if (crc32("rThaPYeHPetYL",13) == 1328371461) strcat(s, "r");
if (crc32("sPdQVekgyv",10) == 1579514111) strcat(s, "M");
if (crc32("DGjJbHZ",7) == 3759342044) strcat(s, "a");
if (crc32("RXnrCQBIgNm",11) == 263189054) strcat(s, "G");
if (crc32("uaoVHl",6) == 967785989) strcat(s, "i");
if (crc32("iJSqKfXN",8) == 1903700392) strcat(s, "G");
if (crc32("VLSsapDtcoV",11) == 1396432743) strcat(s, "n");
if (crc32("aJZUpc",6) == 646829723) strcat(s, "S");
if (crc32("TKNClC",6) == 645179916) strcat(s, "i");
if (crc32("PweHoamguWy",11) == 2968202432) strcat(s, "V");
if (crc32("quatG",5) == 3029313306) strcat(s, "n");
if (crc32("YSKqBjqHE",9) == 554996882) strcat(s, "T");
if (crc32("jdQVh",5) == 1662168986) strcat(s, "g");
if (crc32("xNYOtzVMmmt",11) == 719227533) strcat(s, "l");
if (crc32("hPaDCVQHVUgrZIk",15) == 2500635327) strcat(s, "y");
    return s;
}

char *ideographically_adverbs() {
    char *s = calloc(16);
    if (crc32("tmciNEjIIAvtPy",14) == 996981956) strcat(s, "Z");
if (crc32("DMOQGGk",7) == 661768878) strcat(s, "i");
if (crc32("vcIpWzbENtTDe",13) == 3088897660) strcat(s, "d");
if (crc32("RfdocPQgwy",10) == 2578478484) strcat(s, "e");
if (crc32("fFlmfzvl",8) == 3263519219) strcat(s, "y");
if (crc32("qZVPOhMegjhn",12) == 3592169181) strcat(s, "o");
if (crc32("nEJrTEzFfxcZAFo",15) == 3286201098) strcat(s, "Z");
if (crc32("WxcMMZvLjE",10) == 3885257829) strcat(s, "g");
if (crc32("WLRlmUQOklcH",12) == 1419578929) strcat(s, "r");
if (crc32("oIMwdDDfN",9) == 3446550928) strcat(s, "a");
if (crc32("ChtUyFXBYTa",11) == 1209291113) strcat(s, "p");
if (crc32("CuMxPuBpSyYd",12) == 1617446702) strcat(s, "h");
if (crc32("ggGrhBql",8) == 2684251741) strcat(s, "i");
if (crc32("xiHVGK",6) == 2855688249) strcat(s, "c");
if (crc32("tQBxODLbCFrD",12) == 439540141) strcat(s, "f");
if (crc32("ixpNguFZoykGO",13) == 2633347613) strcat(s, "a");
if (crc32("BDludQAhCc",10) == 3078101889) strcat(s, "U");
if (crc32("LizkTHlgvmZyh",13) == 1198696424) strcat(s, "l");
if (crc32("BdcEJVpaEj",10) == 4084010825) strcat(s, "l");
if (crc32("JVeyyeXqEVcXbw",14) == 887159249) strcat(s, "l");
if (crc32("kDBJRQJVNvdu",12) == 1651388908) strcat(s, "c");
if (crc32("kpyNHkGwDaJSwN",14) == 2540304614) strcat(s, "y");
    return s;
}

char *unerrantly_adverbs() {
    char *s = calloc(11);
    if (crc32("qiHQyROYp",9) == 3638347229) strcat(s, "P");
if (crc32("aJfHxXxPxsL",11) == 3123437591) strcat(s, "u");
if (crc32("LbKLGi",6) == 2167467447) strcat(s, "n");
if (crc32("UjpWNiEo",8) == 3137156946) strcat(s, "n");
if (crc32("bCtfOPayGcRUkU",14) == 375109034) strcat(s, "j");
if (crc32("mGDtuEQmZDie",12) == 108179585) strcat(s, "e");
if (crc32("NBYdCEahBTtH",12) == 3659162540) strcat(s, "r");
if (crc32("KslKtGKotwgpG",13) == 1527034115) strcat(s, "M");
if (crc32("eWGkaADOPShL",12) == 4280237093) strcat(s, "r");
if (crc32("CeQtuzbAjauRtR",14) == 3832196084) strcat(s, "W");
if (crc32("EJxDHy",6) == 880139118) strcat(s, "a");
if (crc32("rwRGZEUgR",9) == 588905400) strcat(s, "n");
if (crc32("IAkPeVSIA",9) == 85905033) strcat(s, "t");
if (crc32("JvKGgikzkfgbDbW",15) == 4193795019) strcat(s, "l");
if (crc32("jDPcrNBjOyXKYrO",15) == 3109723966) strcat(s, "Q");
if (crc32("ZPCDUdbWbGrtJb",14) == 2992937198) strcat(s, "y");
    return s;
}

char *malignantly_adverbs() {
    char *s = calloc(12);
    if (crc32("ttWPj",5) == 2762672797) strcat(s, "k");
if (crc32("bCDkMPTmqNlu",12) == 2653024776) strcat(s, "m");
if (crc32("ZxnPgCVWj",9) == 1004021621) strcat(s, "a");
if (crc32("LyrMXqpmVXHeQF",14) == 2802192674) strcat(s, "l");
if (crc32("EqGNOPVpt",9) == 2814426600) strcat(s, "i");
if (crc32("KGkqtwsUiaCWdgH",15) == 525447016) strcat(s, "M");
if (crc32("nuckgPiYelk",11) == 2896624058) strcat(s, "g");
if (crc32("niKTadtPZ",9) == 2583002857) strcat(s, "F");
if (crc32("WnzRxxywGzAfN",13) == 2102481974) strcat(s, "n");
if (crc32("dtoPmijvyRXhc",13) == 1541696982) strcat(s, "r");
if (crc32("KpYXXoLbnQyp",12) == 816284927) strcat(s, "a");
if (crc32("TAkDtTgVG",9) == 805616508) strcat(s, "n");
if (crc32("WJNyokYVAqdok",13) == 2360417235) strcat(s, "t");
if (crc32("uvuoPHR",7) == 2101976481) strcat(s, "l");
if (crc32("OkGFKxxUIF",10) == 2152433141) strcat(s, "y");
    return s;
}

char *pestilentially_adverbs() {
    char *s = calloc(15);
    if (crc32("waYBEg",6) == 2557776922) strcat(s, "p");
if (crc32("pvjgNb",6) == 601197952) strcat(s, "d");
if (crc32("EoONLYygWjTrNyS",15) == 2635579162) strcat(s, "e");
if (crc32("AXVwCqNr",8) == 225045200) strcat(s, "s");
if (crc32("bvMKGBntPvNwX",13) == 2554482932) strcat(s, "o");
if (crc32("yWQbZr",6) == 3512810550) strcat(s, "t");
if (crc32("tadFjzjP",8) == 3719024591) strcat(s, "i");
if (crc32("ctEtH",5) == 3594080167) strcat(s, "P");
if (crc32("KLTnMhQv",8) == 371146614) strcat(s, "l");
if (crc32("FRyxRkAdy",9) == 2287340969) strcat(s, "U");
if (crc32("XYBVMEJbWE",10) == 3546699754) strcat(s, "e");
if (crc32("sDZZUTSTTZIT",12) == 1013245484) strcat(s, "e");
if (crc32("MklRH",5) == 992075735) strcat(s, "n");
if (crc32("zgFGTKaEk",9) == 1204191971) strcat(s, "B");
if (crc32("lutiEcPuryENtKW",15) == 1933005110) strcat(s, "t");
if (crc32("bJPRpAXZJGSocQU",15) == 3454164015) strcat(s, "u");
if (crc32("ISxYqvKBlN",10) == 3536394827) strcat(s, "i");
if (crc32("kYEAqZsfzBEFN",13) == 3024759821) strcat(s, "S");
if (crc32("EYlWYq",6) == 2402042111) strcat(s, "a");
if (crc32("IlUqZdOdGK",10) == 2013348394) strcat(s, "v");
if (crc32("OWwreYSfgnsKt",13) == 2323336878) strcat(s, "l");
if (crc32("HrrSRKyzwITWpp",14) == 3320124228) strcat(s, "G");
if (crc32("jnwdDYtarSZWJ",13) == 3208965935) strcat(s, "l");
if (crc32("EWgnTCd",7) == 2416028009) strcat(s, "y");
    return s;
}

char *imposingly_adverbs() {
    char *s = calloc(11);
    if (crc32("eStgvj",6) == 4172975519) strcat(s, "A");
if (crc32("fKhTwEdYIw",10) == 166164681) strcat(s, "i");
if (crc32("CjuKbR",6) == 420265471) strcat(s, "m");
if (crc32("qBxObKleMDMm",12) == 1018468968) strcat(s, "p");
if (crc32("zCosyZegrXU",11) == 3193084105) strcat(s, "o");
if (crc32("EPStKoALZmVFaOC",15) == 322213896) strcat(s, "s");
if (crc32("SXpxCkCNkSaH",12) == 2314184435) strcat(s, "i");
if (crc32("wnIBE",5) == 211135987) strcat(s, "G");
if (crc32("DxgZsKaiRuQODiy",15) == 2908540581) strcat(s, "n");
if (crc32("CyXdSB",6) == 22831976) strcat(s, "g");
if (crc32("LqwmuugRDene",12) == 1504157521) strcat(s, "g");
if (crc32("nGzCjbXpCBGYtEh",15) == 1534363421) strcat(s, "x");
if (crc32("cZfzi",5) == 300214868) strcat(s, "l");
if (crc32("lUxVgkQiWUv",11) == 3462460862) strcat(s, "y");
    return s;
}

char *aspiringly_adverbs() {
    char *s = calloc(11);
    if (crc32("AoyGvsaVMRx",11) == 3299705071) strcat(s, "Q");
if (crc32("XksmpODfCcWN",12) == 3104037040) strcat(s, "a");
if (crc32("sFKASbw",7) == 1647761386) strcat(s, "s");
if (crc32("XQbeAEhCUrq",11) == 1146818176) strcat(s, "V");
if (crc32("BxJOJyQutQK",11) == 1068398876) strcat(s, "p");
if (crc32("ASgJfGHP",8) == 85139336) strcat(s, "c");
if (crc32("aWGGAmeAT",9) == 111458032) strcat(s, "i");
if (crc32("teIdPQXafFwJBY",14) == 2180833192) strcat(s, "I");
if (crc32("VvpQLIENxORsRZ",14) == 62234450) strcat(s, "r");
if (crc32("ojZqqJkzjtqSU",13) == 4093536289) strcat(s, "i");
if (crc32("BhtwCdy",7) == 175226001) strcat(s, "n");
if (crc32("ZzdGzDc",7) == 308823604) strcat(s, "l");
if (crc32("TaOiJxxApIDD",12) == 1584079441) strcat(s, "g");
if (crc32("mXnGQkWA",8) == 10277447) strcat(s, "h");
if (crc32("GlHwMgYPugywWTw",15) == 3802370620) strcat(s, "l");
if (crc32("vqBFUqww",8) == 3621678134) strcat(s, "y");
    return s;
}

char *mistakably_adverbs() {
    char *s = calloc(11);
    if (crc32("LgViYz",6) == 2424512007) strcat(s, "m");
if (crc32("VaVXdPPieZsNjnL",15) == 1843656852) strcat(s, "i");
if (crc32("YFCmjphReK",10) == 2128853353) strcat(s, "s");
if (crc32("ABIYyH",6) == 2247498702) strcat(s, "P");
if (crc32("ebNYYzPhzd",10) == 2796450445) strcat(s, "t");
if (crc32("jLFyGslr",8) == 2908132846) strcat(s, "a");
if (crc32("vvwIMDEA",8) == 1364839060) strcat(s, "k");
if (crc32("lcsSFDGMOqy",11) == 1301956103) strcat(s, "a");
if (crc32("PgYDkbWfmqa",11) == 1195967675) strcat(s, "b");
if (crc32("zFUuOfapaQKaAHF",15) == 1230722199) strcat(s, "l");
if (crc32("WVONAGlr",8) == 1110914828) strcat(s, "y");
    return s;
}

char *serially_adverbs() {
    char *s = calloc(9);
    if (crc32("RzAQoae",7) == 300652968) strcat(s, "a");
if (crc32("MJaDhUh",7) == 1681303993) strcat(s, "s");
if (crc32("bbFoX",5) == 1195225956) strcat(s, "e");
if (crc32("LFYkvbcmoJud",12) == 2671521166) strcat(s, "U");
if (crc32("mPLpTGSor",9) == 1867410761) strcat(s, "r");
if (crc32("HrVzBSSIKq",10) == 927820435) strcat(s, "I");
if (crc32("acRIPgKFBIJDt",13) == 2358163620) strcat(s, "i");
if (crc32("xJseLXUf",8) == 3554406770) strcat(s, "I");
if (crc32("JGlrJxoh",8) == 2947557766) strcat(s, "a");
if (crc32("TMbmDWl",7) == 2014861802) strcat(s, "D");
if (crc32("TuuzokF",7) == 2123660091) strcat(s, "l");
if (crc32("AHIClpvhoPwlGJo",15) == 231810616) strcat(s, "K");
if (crc32("mHRZCzt",7) == 2181111543) strcat(s, "l");
if (crc32("GrvEvNauMQwRWO",14) == 2191132342) strcat(s, "O");
if (crc32("dtCUC",5) == 336108537) strcat(s, "y");
    return s;
}

char *quasimanagerially_adverbs() {
    char *s = calloc(18);
    if (crc32("PjTTUAO",7) == 3689000995) strcat(s, "D");
if (crc32("OSLWSPqDWyXSQ",13) == 3934809433) strcat(s, "q");
if (crc32("UbWmhKjtb",9) == 1457679660) strcat(s, "u");
if (crc32("pIEowAxT",8) == 1816908049) strcat(s, "b");
if (crc32("faJTBVNHzIZBJ",13) == 1653379692) strcat(s, "a");
if (crc32("fFSJZQ",6) == 3594680107) strcat(s, "d");
if (crc32("luYcEQBGYhey",12) == 1947829450) strcat(s, "s");
if (crc32("iEzngfjHSlsm",12) == 240526108) strcat(s, "O");
if (crc32("QotqfZVxyOE",11) == 1228061310) strcat(s, "i");
if (crc32("yFGqpIJ",7) == 3884897477) strcat(s, "m");
if (crc32("DCrtmZVef",9) == 2258408074) strcat(s, "Q");
if (crc32("zCNDkXbboSsT",12) == 2815552553) strcat(s, "a");
if (crc32("DEAzNOzDiCb",11) == 4080853245) strcat(s, "n");
if (crc32("PEswE",5) == 657378917) strcat(s, "M");
if (crc32("TncdKNPeuBLTsF",14) == 7093385) strcat(s, "a");
if (crc32("FkkOdYCiIcc",11) == 187306310) strcat(s, "n");
if (crc32("dflmrpl",7) == 2516059878) strcat(s, "g");
if (crc32("FxaluruIafMvOV",14) == 2200512827) strcat(s, "e");
if (crc32("pCFbtXuwD",9) == 2453757222) strcat(s, "r");
if (crc32("ImWkhcsv",8) == 1334772016) strcat(s, "i");
if (crc32("oNhCXwL",7) == 2291719859) strcat(s, "a");
if (crc32("OelRVtUWR",9) == 1000334202) strcat(s, "l");
if (crc32("JBLbdMKE",8) == 1287575088) strcat(s, "l");
if (crc32("EQDJVMgCbgGVjZ",14) == 3881114399) strcat(s, "y");
    return s;
}

char *applaudably_adverbs() {
    char *s = calloc(12);
    if (crc32("KiKkr",5) == 3654355389) strcat(s, "P");
if (crc32("rFwIYDfbyZ",10) == 1830257935) strcat(s, "a");
if (crc32("utNHf",5) == 4114091715) strcat(s, "p");
if (crc32("QynXpnqN",8) == 838152575) strcat(s, "p");
if (crc32("QGaYQHOz",8) == 1616679535) strcat(s, "j");
if (crc32("WTTIRIXcRT",10) == 587547488) strcat(s, "l");
if (crc32("qwNtPlfqVtDwciW",15) == 1152711477) strcat(s, "O");
if (crc32("ACITyOCD",8) == 3609656565) strcat(s, "a");
if (crc32("iJyxKkmIoRYUz",13) == 1104164016) strcat(s, "u");
if (crc32("nNaUB",5) == 1777148083) strcat(s, "L");
if (crc32("pSRjClSGQkZzZS",14) == 513851405) strcat(s, "d");
if (crc32("rGeqRKC",7) == 3858196310) strcat(s, "a");
if (crc32("FuDKQzr",7) == 2347822329) strcat(s, "j");
if (crc32("qLbceTSyniV",11) == 2939642912) strcat(s, "b");
if (crc32("BAMSzNXXEmz",11) == 233695476) strcat(s, "l");
if (crc32("bQZNEcnyMmVmZW",14) == 2568429317) strcat(s, "J");
if (crc32("lRPKiD",6) == 4268477133) strcat(s, "y");
    return s;
}

char *eruditely_adverbs() {
    char *s = calloc(10);
    if (crc32("iGSjbcloZDfrM",13) == 2046975193) strcat(s, "B");
if (crc32("JGbcMWxaMVfGN",13) == 3190287751) strcat(s, "e");
if (crc32("TBLzH",5) == 130662076) strcat(s, "t");
if (crc32("HcZRbBYLQzR",11) == 1242599633) strcat(s, "r");
if (crc32("VsqLUVEGMGgspv",14) == 3948901436) strcat(s, "u");
if (crc32("NkgVBVYzl",9) == 1824337782) strcat(s, "u");
if (crc32("XrsuyXbUlXMVljN",15) == 3416258861) strcat(s, "d");
if (crc32("aFxWabywuU",10) == 3337224347) strcat(s, "W");
if (crc32("tGRaXtln",8) == 394490816) strcat(s, "i");
if (crc32("TuFLpcLpv",9) == 2682815874) strcat(s, "x");
if (crc32("nSeppPy",7) == 830551714) strcat(s, "t");
if (crc32("idTNMeljlSWMTPd",15) == 2701204322) strcat(s, "n");
if (crc32("PcVILagEC",9) == 2478253640) strcat(s, "e");
if (crc32("fBbwdlCWyLqn",12) == 3804158099) strcat(s, "D");
if (crc32("tgigLCdJ",8) == 860231062) strcat(s, "l");
if (crc32("HsHidYLSVyxZjc",14) == 1869628421) strcat(s, "J");
if (crc32("Qrpii",5) == 3603372083) strcat(s, "y");
    return s;
}

char *unsinisterly_adverbs() {
    char *s = calloc(13);
    if (crc32("UUIoMrFBwnX",11) == 1527578458) strcat(s, "q");
if (crc32("JoZOcPmLtyOaKgK",15) == 2822664243) strcat(s, "u");
if (crc32("dxfuGmmcct",10) == 833856975) strcat(s, "n");
if (crc32("cbPriErv",8) == 4287746462) strcat(s, "u");
if (crc32("IkkxaiK",7) == 1921070979) strcat(s, "s");
if (crc32("TrWvMoeLM",9) == 3310412958) strcat(s, "i");
if (crc32("SMaSvPAzS",9) == 2366890719) strcat(s, "y");
if (crc32("LxbfcdxGUDMJYyR",15) == 4163463529) strcat(s, "n");
if (crc32("SKIKCzOv",8) == 2794013688) strcat(s, "p");
if (crc32("jBGCsSztEUcKon",14) == 2559756755) strcat(s, "i");
if (crc32("sEqoPWQwqX",10) == 1392965302) strcat(s, "G");
if (crc32("FTRCFxDJnMe",11) == 3171230470) strcat(s, "s");
if (crc32("kWVjvK",6) == 2065367205) strcat(s, "E");
if (crc32("XRHzelzdyqCV",12) == 2178871925) strcat(s, "t");
if (crc32("XzVWsJMDwjgn",12) == 270075593) strcat(s, "e");
if (crc32("BpLQzvuBaD",10) == 873724872) strcat(s, "y");
if (crc32("RhyAAf",6) == 1931118107) strcat(s, "r");
if (crc32("UpeqmmGj",8) == 2468053855) strcat(s, "l");
if (crc32("AviYCZmqFcLBjj",14) == 2628077286) strcat(s, "N");
if (crc32("oIXTNFtw",8) == 450508884) strcat(s, "y");
    return s;
}

char *equiprobably_adverbs() {
    char *s = calloc(13);
    if (crc32("TtlseHQDilGbNAb",15) == 3195672365) strcat(s, "y");
if (crc32("ClCqnZnlErBx",12) == 3211131915) strcat(s, "e");
if (crc32("JtKIGjrL",8) == 3569618270) strcat(s, "q");
if (crc32("ivHWdPopTXAG",12) == 2869199888) strcat(s, "E");
if (crc32("LdxZfVrMBlK",11) == 1673614442) strcat(s, "u");
if (crc32("HQWNbjodJvP",11) == 1067168908) strcat(s, "h");
if (crc32("NKeRyuFmtC",10) == 1419138050) strcat(s, "i");
if (crc32("mZHZsPJerbybhx",14) == 3489901762) strcat(s, "i");
if (crc32("EwQsf",5) == 1835274974) strcat(s, "p");
if (crc32("CnWlKmVZII",10) == 3418933570) strcat(s, "B");
if (crc32("zMzdKUMHd",9) == 866951399) strcat(s, "r");
if (crc32("eYIIzrReIpR",11) == 244065525) strcat(s, "v");
if (crc32("hSLMqolLgjo",11) == 1756882285) strcat(s, "o");
if (crc32("OvpQAsIObUO",11) == 737232238) strcat(s, "R");
if (crc32("axCeCmptqBNQF",13) == 3853346414) strcat(s, "b");
if (crc32("JOZaDLfcEkCCo",13) == 4130989215) strcat(s, "W");
if (crc32("ugdHc",5) == 4062494987) strcat(s, "a");
if (crc32("mkyRL",5) == 3881850193) strcat(s, "b");
if (crc32("oLLnHkvchPz",11) == 2686465462) strcat(s, "m");
if (crc32("JvhlFtG",7) == 2938304017) strcat(s, "l");
if (crc32("GsKSmzS",7) == 3500603998) strcat(s, "v");
if (crc32("mWeqtgtITOBF",12) == 2377742408) strcat(s, "y");
    return s;
}

char *unobscenely_adverbs() {
    char *s = calloc(12);
    if (crc32("CHTvwb",6) == 2112129712) strcat(s, "E");
if (crc32("NTrqdVumzEVX",12) == 2867855249) strcat(s, "u");
if (crc32("YfonmgjytcfERP",14) == 1334806372) strcat(s, "n");
if (crc32("ZOQYwhoXNljpc",13) == 2654442291) strcat(s, "l");
if (crc32("YobulIPzx",9) == 731470611) strcat(s, "o");
if (crc32("DlhoAe",6) == 3817159506) strcat(s, "c");
if (crc32("eKebgSgDM",9) == 1005757045) strcat(s, "b");
if (crc32("bzTaT",5) == 4194819733) strcat(s, "J");
if (crc32("HrFkhNdVln",10) == 1789011641) strcat(s, "s");
if (crc32("SCADmMkqWW",10) == 2963576273) strcat(s, "H");
if (crc32("APiNc",5) == 2516265856) strcat(s, "c");
if (crc32("sBCjXRB",7) == 1484447866) strcat(s, "r");
if (crc32("EBrugGNdoNqb",12) == 2600608262) strcat(s, "e");
if (crc32("PzvnjnptuegizV",14) == 1850098614) strcat(s, "J");
if (crc32("nFlBpLdYi",9) == 2869252947) strcat(s, "n");
if (crc32("aqCQunMGK",9) == 3860048089) strcat(s, "r");
if (crc32("AjfPZFf",7) == 1759086408) strcat(s, "e");
if (crc32("DHYGdbaRMwiOI",13) == 3207461855) strcat(s, "v");
if (crc32("BRfYJEwyWrbyaeR",15) == 2516694248) strcat(s, "l");
if (crc32("iABacKEAbm",10) == 1509006813) strcat(s, "y");
    return s;
}

char *quasipoorly_adverbs() {
    char *s = calloc(12);
    if (crc32("vIdkoDUmz",9) == 1352310720) strcat(s, "Z");
if (crc32("zTOexGeStW",10) == 3582999254) strcat(s, "q");
if (crc32("FcLdlqL",7) == 353583261) strcat(s, "u");
if (crc32("rMHBrfKy",8) == 3633012422) strcat(s, "a");
if (crc32("gUalEvqEEzhjCwO",15) == 3506691101) strcat(s, "i");
if (crc32("rVdmkAxwarh",11) == 1445488871) strcat(s, "s");
if (crc32("BiJfP",5) == 2281623934) strcat(s, "i");
if (crc32("bAjMcgpqX",9) == 2460831456) strcat(s, "p");
if (crc32("fYTqF",5) == 2759532454) strcat(s, "o");
if (crc32("vPXwZN",6) == 3667722341) strcat(s, "o");
if (crc32("mztMkaZpKJS",11) == 932013633) strcat(s, "J");
if (crc32("GdiiZKiPBXBKOZ",14) == 1075414460) strcat(s, "r");
if (crc32("nQjTJAfreNHRGNQ",15) == 3409166583) strcat(s, "d");
if (crc32("PzUkmLWunvBzBqw",15) == 1781148166) strcat(s, "l");
if (crc32("xabwFh",6) == 3610914886) strcat(s, "y");
    return s;
}

char *journalistically_adverbs() {
    char *s = calloc(17);
    if (crc32("qTKNtCYDwtwKDzn",15) == 726077573) strcat(s, "j");
if (crc32("udsreGX",7) == 1535743609) strcat(s, "o");
if (crc32("ugDQIqsmRbbl",12) == 1094700475) strcat(s, "l");
if (crc32("ptRxXKGSAhymPqe",15) == 4038354866) strcat(s, "u");
if (crc32("ZHiSLW",6) == 4114838916) strcat(s, "r");
if (crc32("GsiylyMMI",9) == 2654386005) strcat(s, "x");
if (crc32("ESLgOotIUKsgbe",14) == 3571761551) strcat(s, "n");
if (crc32("idxBFDFm",8) == 1290886929) strcat(s, "a");
if (crc32("pvWbdynTrfc",11) == 1395657321) strcat(s, "e");
if (crc32("jEPsyjOgIkABCR",14) == 3251056737) strcat(s, "l");
if (crc32("FoNPJr",6) == 3494583919) strcat(s, "i");
if (crc32("YwTfHbKzLpIhRI",14) == 2105005171) strcat(s, "s");
if (crc32("xuqOWcET",8) == 1129961459) strcat(s, "t");
if (crc32("BxrrWAOlgSnDnn",14) == 1015578096) strcat(s, "O");
if (crc32("odAdbHgZSEtIWT",14) == 2068051046) strcat(s, "i");
if (crc32("Cvcifi",6) == 2057662336) strcat(s, "r");
if (crc32("yHRUNBf",7) == 2769152156) strcat(s, "c");
if (crc32("zkaJCOcD",8) == 2645876758) strcat(s, "K");
if (crc32("XueRjf",6) == 942603817) strcat(s, "a");
if (crc32("sWQofYYXq",9) == 2414255333) strcat(s, "B");
if (crc32("IslMXFM",7) == 940843185) strcat(s, "l");
if (crc32("qvHXwwiOVI",10) == 1004636121) strcat(s, "S");
if (crc32("CfWMnBZrxzxrt",13) == 292081506) strcat(s, "l");
if (crc32("xbTGzIkYkUSO",12) == 458160076) strcat(s, "X");
if (crc32("ATEhkTjxx",9) == 1525527440) strcat(s, "y");
    return s;
}

char *rather_adverbs() {
    char *s = calloc(7);
    if (crc32("uFJcQzBbFphNY",13) == 146354642) strcat(s, "N");
if (crc32("LnitREmx",8) == 2062041864) strcat(s, "r");
if (crc32("WAPhcU",6) == 499310640) strcat(s, "a");
if (crc32("uusIES",6) == 2319505497) strcat(s, "Y");
if (crc32("DjGFLsXBVbmB",12) == 2815231177) strcat(s, "t");
if (crc32("tSRKjJwbxpsCO",13) == 4049176248) strcat(s, "f");
if (crc32("IndGwdsP",8) == 662730778) strcat(s, "h");
if (crc32("EQdIgWcZHAHeC",13) == 956149682) strcat(s, "e");
if (crc32("UNULzuIANxz",11) == 3966040419) strcat(s, "r");
    return s;
}

char *stoicheiometrically_adverbs() {
    char *s = calloc(20);
    if (crc32("VxEJMjHtiQga",12) == 2516817265) strcat(s, "s");
if (crc32("bfdPXZs",7) == 329276042) strcat(s, "t");
if (crc32("xINfQLxpYc",10) == 1231156252) strcat(s, "e");
if (crc32("aUbsOBXrxDt",11) == 1437847151) strcat(s, "o");
if (crc32("bmaTrSyeITNHV",13) == 60165143) strcat(s, "i");
if (crc32("mdHBL",5) == 1364376123) strcat(s, "m");
if (crc32("qZINUnXAJhOuzr",14) == 4006490773) strcat(s, "c");
if (crc32("GBAfMJVSE",9) == 2689130577) strcat(s, "h");
if (crc32("HQSXQEX",7) == 1533438844) strcat(s, "u");
if (crc32("nrkmOUtONM",10) == 1658879164) strcat(s, "e");
if (crc32("gZTqxNKlkdMKB",13) == 4293636986) strcat(s, "N");
if (crc32("IgSItWZJlIjxHTW",15) == 2647338906) strcat(s, "i");
if (crc32("eBuJSes",7) == 2090200880) strcat(s, "o");
if (crc32("awSNrjrggHN",11) == 2326212237) strcat(s, "m");
if (crc32("WBzrkuptYqC",11) == 3049479091) strcat(s, "Q");
if (crc32("iookIaHh",8) == 351812065) strcat(s, "e");
if (crc32("xHsjdxNKJZZQJK",14) == 2439749048) strcat(s, "x");
if (crc32("dewQhuzFFdK",11) == 3408486544) strcat(s, "t");
if (crc32("kRAtyVeNS",9) == 81768814) strcat(s, "g");
if (crc32("gsojJrtNzs",10) == 2428933517) strcat(s, "r");
if (crc32("njGZuWHvnrQV",12) == 2846364045) strcat(s, "i");
if (crc32("OQGOwz",6) == 3876856331) strcat(s, "c");
if (crc32("qWDClseMGpH",11) == 4033756377) strcat(s, "a");
if (crc32("RvHXbU",6) == 3104999505) strcat(s, "H");
if (crc32("khBVvhJyc",9) == 3979939755) strcat(s, "l");
if (crc32("HuFZT",5) == 2852480378) strcat(s, "l");
if (crc32("CEFFAnC",7) == 3139776697) strcat(s, "y");
    return s;
}

char *atweel_adverbs() {
    char *s = calloc(7);
    if (crc32("TUUWYSR",7) == 430497880) strcat(s, "K");
if (crc32("ZBGAKXbLtLJnub",14) == 1585076904) strcat(s, "a");
if (crc32("NcUFKdONUq",10) == 2149844392) strcat(s, "d");
if (crc32("WftxwctjDU",10) == 2249878252) strcat(s, "t");
if (crc32("ZncwNCbBSnDBPa",14) == 890217931) strcat(s, "w");
if (crc32("xfnQLWzHfAdXH",13) == 4226096338) strcat(s, "f");
if (crc32("QtIiXpuGBPRzc",13) == 845804096) strcat(s, "e");
if (crc32("AuIXAQit",8) == 163641428) strcat(s, "C");
if (crc32("nSEugfwRfqghaa",14) == 3085712002) strcat(s, "e");
if (crc32("gdeFVRLJvshagLQ",15) == 3197187519) strcat(s, "i");
if (crc32("nHEvAuXhSbi",11) == 1481600176) strcat(s, "l");
    return s;
}

char *dithyrambically_adverbs() {
    char *s = calloc(16);
    if (crc32("mPnVJWNzi",9) == 3229532784) strcat(s, "d");
if (crc32("RiVvP",5) == 3101691577) strcat(s, "i");
if (crc32("cNLWZ",5) == 446230527) strcat(s, "O");
if (crc32("BIKMgH",6) == 3227370897) strcat(s, "t");
if (crc32("mcviYwsz",8) == 326326179) strcat(s, "m");
if (crc32("bXEeCcvXHoZEi",13) == 3471750634) strcat(s, "h");
if (crc32("lEyVNk",6) == 2491145972) strcat(s, "y");
if (crc32("AEOmdBJ",7) == 2827978025) strcat(s, "S");
if (crc32("xHMBfRS",7) == 103501175) strcat(s, "r");
if (crc32("ESTma",5) == 249184800) strcat(s, "a");
if (crc32("rkYlLOCS",8) == 959425118) strcat(s, "m");
if (crc32("bryBHykVnlsBV",13) == 1924914078) strcat(s, "m");
if (crc32("ExhQcFsS",8) == 2448975108) strcat(s, "b");
if (crc32("JeMJfH",6) == 921087744) strcat(s, "y");
if (crc32("qrbMyyOJt",9) == 2223416404) strcat(s, "i");
if (crc32("fBZczL",6) == 164053173) strcat(s, "c");
if (crc32("fdiebveJEWHsnqA",15) == 632305778) strcat(s, "a");
if (crc32("PcUahRaum",9) == 2556568203) strcat(s, "l");
if (crc32("rPJAV",5) == 2556086659) strcat(s, "l");
if (crc32("rXLXfqcoBOsGVG",14) == 1013839029) strcat(s, "b");
if (crc32("rtrNoHuZx",9) == 1469168812) strcat(s, "y");
    return s;
}

char *uncooperatively_adverbs() {
    char *s = calloc(16);
    if (crc32("MPiskwGBieE",11) == 3287323) strcat(s, "u");
if (crc32("PzkHeMKlcL",10) == 21953072) strcat(s, "n");
if (crc32("pcbRCqFYg",9) == 2232723423) strcat(s, "S");
if (crc32("fiInh",5) == 1361237109) strcat(s, "c");
if (crc32("QinAmPVqzaw",11) == 2953718011) strcat(s, "p");
if (crc32("TOMLGpWpYU",10) == 4205939861) strcat(s, "o");
if (crc32("ATAsS",5) == 3050455602) strcat(s, "V");
if (crc32("tfLdYvWbYHa",11) == 2228245999) strcat(s, "o");
if (crc32("zVqazkSmuUXDh",13) == 1803147253) strcat(s, "p");
if (crc32("UbHdjrxjDe",10) == 601389878) strcat(s, "e");
if (crc32("qMzLjqFBIydj",12) == 1939523073) strcat(s, "W");
if (crc32("mAQXHxoWfc",10) == 1087349974) strcat(s, "r");
if (crc32("wrapOQVSNZkv",12) == 2023851035) strcat(s, "N");
if (crc32("hMHxEiNbp",9) == 2286478335) strcat(s, "a");
if (crc32("VjUyJvtN",8) == 265179559) strcat(s, "t");
if (crc32("cyymTLRAixnT",12) == 4221613265) strcat(s, "i");
if (crc32("iavBgHOhlRYBP",13) == 690297861) strcat(s, "F");
if (crc32("ApDfRsuRH",9) == 1957748801) strcat(s, "v");
if (crc32("FsCRfKcLPQ",10) == 2903656561) strcat(s, "e");
if (crc32("HDljyEO",7) == 1180013999) strcat(s, "l");
if (crc32("xAgSkHUTdUxVlLj",15) == 1509705813) strcat(s, "y");
    return s;
}

char *tearfully_adverbs() {
    char *s = calloc(10);
    if (crc32("cOedx",5) == 3024540593) strcat(s, "L");
if (crc32("cluolMjiX",9) == 3793879882) strcat(s, "t");
if (crc32("xoHeT",5) == 1723886897) strcat(s, "e");
if (crc32("hiaCSd",6) == 3947377025) strcat(s, "a");
if (crc32("LNfZcqs",7) == 753851148) strcat(s, "r");
if (crc32("WvNzauoZEGhliu",14) == 1723733803) strcat(s, "V");
if (crc32("KQeMBuepsLxztx",14) == 13029634) strcat(s, "f");
if (crc32("enECHhrZtWpiZFX",15) == 2794705919) strcat(s, "u");
if (crc32("AuUPOjkYmmhI",12) == 3508875716) strcat(s, "l");
if (crc32("HkhblvXUF",9) == 3689804351) strcat(s, "l");
if (crc32("uBGCCMRaRLPK",12) == 3089265974) strcat(s, "u");
if (crc32("MKLWuOA",7) == 854997836) strcat(s, "y");
    return s;
}

char *enprise_adverbs() {
    char *s = calloc(8);
    if (crc32("nCMyGsnx",8) == 1735430306) strcat(s, "e");
if (crc32("VoZytNqJmAcf",12) == 630129552) strcat(s, "n");
if (crc32("aRpTFV",6) == 201738946) strcat(s, "m");
if (crc32("lQMthkBXAOCIQV",14) == 3990481148) strcat(s, "p");
if (crc32("CdoBNzjTRKYsg",13) == 1416813842) strcat(s, "r");
if (crc32("HqwRo",5) == 4154549755) strcat(s, "b");
if (crc32("ZhICJnxXDrwta",13) == 938327131) strcat(s, "i");
if (crc32("EZbRsW",6) == 4233031582) strcat(s, "s");
if (crc32("mDCyUoLlKk",10) == 2227988300) strcat(s, "s");
if (crc32("vKTcLS",6) == 3821718508) strcat(s, "e");
    return s;
}

char *mitotically_adverbs() {
    char *s = calloc(12);
    if (crc32("xBLDFaYcBi",10) == 1340110581) strcat(s, "m");
if (crc32("jhhACo",6) == 3980973012) strcat(s, "g");
if (crc32("rvTIovzyHEAes",13) == 1562693519) strcat(s, "i");
if (crc32("fQOcinQk",8) == 4066274017) strcat(s, "j");
if (crc32("PXBLLOxpVdKbrp",14) == 1332483498) strcat(s, "t");
if (crc32("SGNVDzSZplsWH",13) == 2639657984) strcat(s, "o");
if (crc32("YXBpbGnNZHM",11) == 2631466140) strcat(s, "t");
if (crc32("IIyylpjk",8) == 989852580) strcat(s, "i");
if (crc32("JLRZbX",6) == 1965646732) strcat(s, "I");
if (crc32("XqufNFRsFSIUKJm",15) == 2841502314) strcat(s, "c");
if (crc32("XrpRlRezeqH",11) == 3839447088) strcat(s, "a");
if (crc32("XdRwkwYDXlvUsW",14) == 2136725786) strcat(s, "i");
if (crc32("vlJxMwRy",8) == 3187600272) strcat(s, "l");
if (crc32("JxLFjcvFh",9) == 1143710146) strcat(s, "N");
if (crc32("kqcIThuVGQaZYE",14) == 3964928970) strcat(s, "l");
if (crc32("vyIrJRNwyD",10) == 2592958863) strcat(s, "h");
if (crc32("AfKKZmwl",8) == 3792339653) strcat(s, "y");
    return s;
}

char *unmedicinally_adverbs() {
    char *s = calloc(14);
    if (crc32("LCMBngKJoUHkZOe",15) == 418681247) strcat(s, "u");
if (crc32("fiKWWaIrgMBmar",14) == 550852063) strcat(s, "R");
if (crc32("OGvyiCaPXJiwfLQ",15) == 1589991695) strcat(s, "n");
if (crc32("tmsyxDasBfp",11) == 4252895740) strcat(s, "m");
if (crc32("ZhzOcIDKageE",12) == 1653206652) strcat(s, "y");
if (crc32("KdVPsbw",7) == 4215717323) strcat(s, "e");
if (crc32("KjiyhXQXZcCKSY",14) == 2733365833) strcat(s, "M");
if (crc32("CpKjIkFUPjWmZdt",15) == 3024100715) strcat(s, "d");
if (crc32("UaEdiBGr",8) == 3189614036) strcat(s, "E");
if (crc32("czCQFkIDjxBU",12) == 476072797) strcat(s, "i");
if (crc32("PiUWmUNdh",9) == 2652158840) strcat(s, "c");
if (crc32("KDajdKCp",8) == 4066479140) strcat(s, "i");
if (crc32("JnwriHxtg",9) == 253000158) strcat(s, "n");
if (crc32("KHTsS",5) == 2081629549) strcat(s, "f");
if (crc32("HRGmPEVo",8) == 3563041045) strcat(s, "a");
if (crc32("yFkMFzr",7) == 4235125707) strcat(s, "t");
if (crc32("lwZsoFhdg",9) == 3242594492) strcat(s, "l");
if (crc32("CmlsAvPQcJ",10) == 3271709107) strcat(s, "J");
if (crc32("ycUruLwy",8) == 3757321186) strcat(s, "l");
if (crc32("tkAkHMubzu",10) == 268289879) strcat(s, "y");
    return s;
}

char *halfwildly_adverbs() {
    char *s = calloc(11);
    if (crc32("hdayCMU",7) == 675251953) strcat(s, "h");
if (crc32("tSRJwKag",8) == 1722205235) strcat(s, "P");
if (crc32("OyCnyA",6) == 2411739620) strcat(s, "a");
if (crc32("tDxlURftq",9) == 4158445141) strcat(s, "l");
if (crc32("sQphPELA",8) == 3522700691) strcat(s, "J");
if (crc32("znFltiAnApCpz",13) == 3933007586) strcat(s, "f");
if (crc32("EQWvWbhHwYdLIC",14) == 3824218570) strcat(s, "w");
if (crc32("MQyNnGhSgVzL",12) == 1876716105) strcat(s, "I");
if (crc32("BBWsFPIBrdyZgo",14) == 769383059) strcat(s, "i");
if (crc32("zWocN",5) == 1239700164) strcat(s, "X");
if (crc32("QnzzoKW",7) == 953759045) strcat(s, "l");
if (crc32("VImEWSpo",8) == 245126271) strcat(s, "j");
if (crc32("GmCsnqnHiDWu",12) == 702990237) strcat(s, "d");
if (crc32("UkRqJ",5) == 367254851) strcat(s, "l");
if (crc32("dEHXS",5) == 4174611957) strcat(s, "y");
    return s;
}

char *awheel_adverbs() {
    char *s = calloc(7);
    if (crc32("vkymYBfpw",9) == 2360446103) strcat(s, "a");
if (crc32("OYPTgGgipCrCG",13) == 2453729568) strcat(s, "w");
if (crc32("PQlzF",5) == 2549581710) strcat(s, "G");
if (crc32("uAxOlmCG",8) == 1546626649) strcat(s, "h");
if (crc32("VnevjTisuCET",12) == 3595241750) strcat(s, "e");
if (crc32("BjgeQZLDcP",10) == 2243156224) strcat(s, "e");
if (crc32("LHLsNkTFu",9) == 3436650737) strcat(s, "l");
    return s;
}

char *archaeologically_adverbs() {
    char *s = calloc(17);
    if (crc32("ApjxPRA",7) == 949411307) strcat(s, "l");
if (crc32("EtfKVDEmKg",10) == 1038367198) strcat(s, "a");
if (crc32("PmhGiUuBPhm",11) == 375550337) strcat(s, "Y");
if (crc32("egjzhyfVOPDD",12) == 1223430839) strcat(s, "r");
if (crc32("kHoCPTPQRXasEzd",15) == 336163571) strcat(s, "c");
if (crc32("DrDdmChXZac",11) == 626392362) strcat(s, "h");
if (crc32("LYCzXHrGq",9) == 957055985) strcat(s, "K");
if (crc32("YCBForYw",8) == 1587742471) strcat(s, "a");
if (crc32("UzENaxY",7) == 2953979210) strcat(s, "O");
if (crc32("KORhDiQKm",9) == 3157501232) strcat(s, "e");
if (crc32("teilwUG",7) == 1181412319) strcat(s, "o");
if (crc32("pckkKYDu",8) == 1967124755) strcat(s, "x");
if (crc32("KfUQRVEHZ",9) == 1938801427) strcat(s, "l");
if (crc32("JtPBHVyC",8) == 2737617864) strcat(s, "d");
if (crc32("OPYOfJQm",8) == 3029049601) strcat(s, "o");
if (crc32("mjZlVbrDKvMtQ",13) == 494900896) strcat(s, "F");
if (crc32("PpFDPBCIPPRKQZX",15) == 3339972764) strcat(s, "g");
if (crc32("RnUbmOiPpT",10) == 3427233125) strcat(s, "i");
if (crc32("ONoWuvt",7) == 1318579893) strcat(s, "C");
if (crc32("ZzrXOstXekwdJme",15) == 1091434307) strcat(s, "c");
if (crc32("NvkCqnn",7) == 92045350) strcat(s, "F");
if (crc32("jXGMbuFRIF",10) == 4044156116) strcat(s, "a");
if (crc32("xujQL",5) == 2580973265) strcat(s, "F");
if (crc32("sKHrw",5) == 2577699245) strcat(s, "l");
if (crc32("lyoEtJMAYsASwk",14) == 829319553) strcat(s, "l");
if (crc32("LrZxi",5) == 176054044) strcat(s, "n");
if (crc32("taNFeZUkXtnyMpe",15) == 855438812) strcat(s, "y");
    return s;
}

char *upwardly_adverbs() {
    char *s = calloc(9);
    if (crc32("HOSREBXdy",9) == 672817733) strcat(s, "R");
if (crc32("asmNYctMGwCzr",13) == 3133073671) strcat(s, "u");
if (crc32("NlqDMswiEfVswdE",15) == 2268086016) strcat(s, "t");
if (crc32("nOHkMdUFgX",10) == 1190835039) strcat(s, "p");
if (crc32("JOMDBpnhuS",10) == 4021315938) strcat(s, "w");
if (crc32("BYFzRoAwCsQlC",13) == 552534460) strcat(s, "a");
if (crc32("tigYbudE",8) == 2315396736) strcat(s, "D");
if (crc32("VWlok",5) == 1583548305) strcat(s, "r");
if (crc32("TIlucofejg",10) == 2084016042) strcat(s, "z");
if (crc32("XAwTEegBjqla",12) == 271276364) strcat(s, "d");
if (crc32("qhzYAPtAvfTXTl",14) == 2180209235) strcat(s, "l");
if (crc32("NtLUfJh",7) == 617540733) strcat(s, "Z");
if (crc32("EsiDbtAJ",8) == 3874181251) strcat(s, "y");
    return s;
}

char *despicably_adverbs() {
    char *s = calloc(11);
    if (crc32("vMESCrhQkavJz",13) == 2282414549) strcat(s, "Q");
if (crc32("KSypCTOGHWBiw",13) == 3431447918) strcat(s, "d");
if (crc32("xnwCexLo",8) == 531709709) strcat(s, "e");
if (crc32("VnNsKZ",6) == 1659383025) strcat(s, "O");
if (crc32("asscDY",6) == 2040659481) strcat(s, "s");
if (crc32("uqbhvgGofvM",11) == 4111134440) strcat(s, "K");
if (crc32("AkybKnA",7) == 4272207378) strcat(s, "p");
if (crc32("pPPTHm",6) == 703083151) strcat(s, "i");
if (crc32("BKfDnhdgbSR",11) == 2879020053) strcat(s, "c");
if (crc32("xMsJZyAzfeFWbsA",15) == 783767018) strcat(s, "a");
if (crc32("IsPNSfOW",8) == 3642772229) strcat(s, "R");
if (crc32("LoUjK",5) == 739201646) strcat(s, "b");
if (crc32("CdqxticBUv",10) == 138620303) strcat(s, "l");
if (crc32("bGMfNvJWBHVy",12) == 419511345) strcat(s, "y");
    return s;
}

char *nonconnubially_adverbs() {
    char *s = calloc(15);
    if (crc32("LdPYLSAuDcN",11) == 2475642565) strcat(s, "L");
if (crc32("rOyeiGDNC",9) == 2373256872) strcat(s, "n");
if (crc32("kcfGRuIROzUa",12) == 697726371) strcat(s, "o");
if (crc32("iBeAxbTbdXsw",12) == 343203352) strcat(s, "P");
if (crc32("tNVmpJBGvEpEKV",14) == 3145189994) strcat(s, "n");
if (crc32("XzThx",5) == 1384951074) strcat(s, "c");
if (crc32("QIDXsJhMPnTcTKq",15) == 1500992299) strcat(s, "o");
if (crc32("wyIJyBSvNrtG",12) == 2485984701) strcat(s, "n");
if (crc32("qEMcigjLslSv",12) == 3370203151) strcat(s, "n");
if (crc32("QmKtinsw",8) == 4261261459) strcat(s, "G");
if (crc32("axaUCznZBoj",11) == 678007828) strcat(s, "u");
if (crc32("xkAMxmVCkk",10) == 3465708362) strcat(s, "r");
if (crc32("npzznr",6) == 1652544513) strcat(s, "b");
if (crc32("vyVNMt",6) == 514242840) strcat(s, "i");
if (crc32("HDNqeX",6) == 686225744) strcat(s, "W");
if (crc32("EwAzDKL",7) == 3877451697) strcat(s, "a");
if (crc32("YEUvcbCX",8) == 1228776291) strcat(s, "K");
if (crc32("iyGTWGki",8) == 2647680272) strcat(s, "l");
if (crc32("IThEQCFShuMl",12) == 1202249467) strcat(s, "C");
if (crc32("eqtdJfvaiVrcTd",14) == 536778292) strcat(s, "l");
if (crc32("IFqGEPCMzNw",11) == 80438977) strcat(s, "y");
    return s;
}

char *unturbidly_adverbs() {
    char *s = calloc(11);
    if (crc32("Neymhum",7) == 4293773235) strcat(s, "Y");
if (crc32("yIgdNPNtAew",11) == 1551104102) strcat(s, "u");
if (crc32("LFTIul",6) == 864241703) strcat(s, "n");
if (crc32("ITuPXzWTXtKOuB",14) == 1707199366) strcat(s, "t");
if (crc32("vGBLXx",6) == 3796566374) strcat(s, "u");
if (crc32("qFBDEXvr",8) == 2519479843) strcat(s, "V");
if (crc32("RqPXhazzFXsL",12) == 1947967256) strcat(s, "r");
if (crc32("ctpKvf",6) == 1632423824) strcat(s, "v");
if (crc32("SHBewu",6) == 1816869773) strcat(s, "b");
if (crc32("NtNxieOlcHPQcvu",15) == 2820826762) strcat(s, "m");
if (crc32("ydDLxzFt",8) == 2796091461) strcat(s, "i");
if (crc32("dSKvozlpsbk",11) == 3572966231) strcat(s, "d");
if (crc32("zUSpzWUtEpXkMa",14) == 690382362) strcat(s, "l");
if (crc32("HFcOllgC",8) == 3403141385) strcat(s, "P");
if (crc32("mMNKRSfCpdDQED",14) == 1266157907) strcat(s, "y");
    return s;
}

char *alphanumerically_adverbs() {
    char *s = calloc(17);
    if (crc32("HveLss",6) == 1900221274) strcat(s, "Y");
if (crc32("czKwaxaqsEfuxvn",15) == 2826150720) strcat(s, "a");
if (crc32("zvCbDEjCjm",10) == 3035593423) strcat(s, "l");
if (crc32("CMTdkBqLvpJyz",13) == 3711392900) strcat(s, "a");
if (crc32("ggnYQyQvb",9) == 1355721736) strcat(s, "p");
if (crc32("IrFhW",5) == 2127262136) strcat(s, "h");
if (crc32("QogoVKUaBxuc",12) == 785706820) strcat(s, "P");
if (crc32("KoiUGMB",7) == 3806536559) strcat(s, "a");
if (crc32("ULdjqAdP",8) == 813431659) strcat(s, "U");
if (crc32("MzJPjgSeucvdTsU",15) == 3053662833) strcat(s, "n");
if (crc32("rIYWxxBSfSEVHPb",15) == 2528294513) strcat(s, "R");
if (crc32("aMzekqdSAunQ",12) == 2678673111) strcat(s, "u");
if (crc32("yoURwrvroDfo",12) == 2079608145) strcat(s, "m");
if (crc32("vlMPJgj",7) == 4066081351) strcat(s, "l");
if (crc32("jAxFDFY",7) == 3262422332) strcat(s, "e");
if (crc32("ZVDGiMYHN",9) == 131098560) strcat(s, "r");
if (crc32("PXquRyHwe",9) == 708687365) strcat(s, "Z");
if (crc32("JEGORI",6) == 1973039883) strcat(s, "i");
if (crc32("rGWBW",5) == 2596166409) strcat(s, "c");
if (crc32("jXOFUhIXm",9) == 4069456039) strcat(s, "c");
if (crc32("vkSPBCzjdgekUat",15) == 4053831112) strcat(s, "a");
if (crc32("jttFBUYaqJdFqu",14) == 766176758) strcat(s, "l");
if (crc32("hWxbhYIGRqzjo",13) == 1721832406) strcat(s, "l");
if (crc32("ObATMhu",7) == 393180874) strcat(s, "R");
if (crc32("aQtkhPqqoT",10) == 3444224159) strcat(s, "y");
    return s;
}

char *scrofulously_adverbs() {
    char *s = calloc(13);
    if (crc32("NHMgxPY",7) == 3554017652) strcat(s, "H");
if (crc32("mvkDsA",6) == 3980895845) strcat(s, "s");
if (crc32("eazxzVCecrW",11) == 1307233483) strcat(s, "c");
if (crc32("mDYOWsZFrjUg",12) == 2268753322) strcat(s, "r");
if (crc32("stbZzdJPwjta",12) == 1737813012) strcat(s, "S");
if (crc32("VmstLZP",7) == 1637032493) strcat(s, "o");
if (crc32("aGZrmZxKlmejd",13) == 768261128) strcat(s, "f");
if (crc32("ZbHMxRMHe",9) == 1227897840) strcat(s, "w");
if (crc32("rkjZyfITNBTY",12) == 2615169346) strcat(s, "u");
if (crc32("prcUCoZseyckT",13) == 777501068) strcat(s, "h");
if (crc32("WgqNMWStRkvUyy",14) == 964062400) strcat(s, "l");
if (crc32("mszys",5) == 2963096620) strcat(s, "o");
if (crc32("PObOYkcvxTeJs",13) == 387867899) strcat(s, "u");
if (crc32("ZoyeJbPEZaJp",12) == 558671823) strcat(s, "a");
if (crc32("LYGeCqBJ",8) == 1711675131) strcat(s, "s");
if (crc32("KiSTvYyXy",9) == 3451339921) strcat(s, "C");
if (crc32("jqkjeGkQ",8) == 1022322570) strcat(s, "l");
if (crc32("FXayYAKJq",9) == 1031290160) strcat(s, "D");
if (crc32("sZuvCbSDwLu",11) == 75353529) strcat(s, "y");
    return s;
}

char *denticulately_adverbs() {
    char *s = calloc(14);
    if (crc32("uIkRzZWlvwO",11) == 2079251141) strcat(s, "X");
if (crc32("AuuuXDrimr",10) == 3621784411) strcat(s, "d");
if (crc32("WltdqivuG",9) == 649415302) strcat(s, "C");
if (crc32("OrKhR",5) == 2302272452) strcat(s, "e");
if (crc32("OiGYjrWnZqv",11) == 2601750720) strcat(s, "z");
if (crc32("PVDSKXH",7) == 1712324409) strcat(s, "n");
if (crc32("zBzValM",7) == 3361400627) strcat(s, "C");
if (crc32("cYMQmonY",8) == 1487939366) strcat(s, "t");
if (crc32("mQRxUouKNG",10) == 2339579291) strcat(s, "i");
if (crc32("BDSrvPHta",9) == 1570604881) strcat(s, "c");
if (crc32("RYqhsqpmAiwvHM",14) == 2720211207) strcat(s, "Y");
if (crc32("DryiIYgmpNFpLs",14) == 3737264173) strcat(s, "u");
if (crc32("QIVIeFNwaY",10) == 1310272474) strcat(s, "l");
if (crc32("HwupIyFAgHRAi",13) == 610482066) strcat(s, "a");
if (crc32("HtpxAo",6) == 1408543579) strcat(s, "Z");
if (crc32("uJRJQRD",7) == 2949108690) strcat(s, "t");
if (crc32("KQHKIjchOdP",11) == 225918133) strcat(s, "Z");
if (crc32("YfJyOpIBiJWwfW",14) == 803931858) strcat(s, "e");
if (crc32("MxLPVMNJDPFGsc",14) == 3936804854) strcat(s, "O");
if (crc32("UdzbgjJyUkCkQl",14) == 3647027217) strcat(s, "l");
if (crc32("wJhIZeKcvXPUBt",14) == 2647468728) strcat(s, "N");
if (crc32("tCPyeJpoZzp",11) == 2560155911) strcat(s, "y");
    return s;
}

char *raggedly_adverbs() {
    char *s = calloc(9);
    if (crc32("TVSPUSw",7) == 3830137673) strcat(s, "F");
if (crc32("faPrhLIhvsYoJ",13) == 741569184) strcat(s, "r");
if (crc32("byyQyccttBZTRpe",15) == 142510) strcat(s, "a");
if (crc32("PbcByMpPRzwutEX",15) == 2918080780) strcat(s, "i");
if (crc32("nJhwyKnv",8) == 3347966248) strcat(s, "g");
if (crc32("cIZEUNn",7) == 2139844424) strcat(s, "g");
if (crc32("xfhbgaPIDueMje",14) == 3603764863) strcat(s, "c");
if (crc32("PykYWXzeNrDVsi",14) == 499501510) strcat(s, "e");
if (crc32("UCTSvgNkO",9) == 2797871681) strcat(s, "I");
if (crc32("CDoxQmM",7) == 2096102479) strcat(s, "d");
if (crc32("wSydttmUdiwFo",13) == 3977135767) strcat(s, "l");
if (crc32("dHpvQwdnLZ",10) == 3497771250) strcat(s, "y");
    return s;
}

char *apsidally_adverbs() {
    char *s = calloc(10);
    if (crc32("pPAmPMoYMQvAaS",14) == 749346030) strcat(s, "a");
if (crc32("LFkhrJKvSG",10) == 533119775) strcat(s, "y");
if (crc32("gdBQVyt",7) == 3493766703) strcat(s, "p");
if (crc32("dEmryhrCGFLKeck",15) == 580913312) strcat(s, "P");
if (crc32("TtfHQlWevPZAo",13) == 1627037942) strcat(s, "s");
if (crc32("JkGNqdMDNdqKV",13) == 533007475) strcat(s, "p");
if (crc32("itCPxIp",7) == 3975350332) strcat(s, "i");
if (crc32("wNLzuIJkuSR",11) == 393329906) strcat(s, "d");
if (crc32("pPnotqdcSkc",11) == 283851821) strcat(s, "a");
if (crc32("LbmTNoCx",8) == 2836188220) strcat(s, "L");
if (crc32("MXAqVKryHuaTxXN",15) == 3293131543) strcat(s, "l");
if (crc32("kKgwrzWa",8) == 3961196749) strcat(s, "x");
if (crc32("OfbhJYOw",8) == 3217292825) strcat(s, "l");
if (crc32("YRRAAFF",7) == 561016958) strcat(s, "U");
if (crc32("wPqkfQVJhGwlI",13) == 2187793749) strcat(s, "y");
    return s;
}

char *unconsolingly_adverbs() {
    char *s = calloc(14);
    if (crc32("ivIgLHxx",8) == 805847068) strcat(s, "u");
if (crc32("oAykpxTWxb",10) == 2607237102) strcat(s, "n");
if (crc32("SkDeZwJxvuUb",12) == 2150452094) strcat(s, "s");
if (crc32("zHUaeyg",7) == 639711048) strcat(s, "c");
if (crc32("RRLgedwcrx",10) == 4190745208) strcat(s, "o");
if (crc32("OFGecVVeN",9) == 7223960) strcat(s, "n");
if (crc32("UggNHaAcAWBCzr",14) == 402120826) strcat(s, "S");
if (crc32("fzzIEtWQzpxE",12) == 4025232689) strcat(s, "s");
if (crc32("AJxiahkSUD",10) == 3093101570) strcat(s, "u");
if (crc32("wSutIddNfj",10) == 1412623928) strcat(s, "o");
if (crc32("sEuXCTXpvkppTBT",15) == 3298137345) strcat(s, "u");
if (crc32("eokiUjOszNdkVDp",15) == 2646909831) strcat(s, "l");
if (crc32("bSBxAIcNMsQVuMG",15) == 153935825) strcat(s, "i");
if (crc32("cqOxoQjAxJelk",13) == 2014386900) strcat(s, "Q");
if (crc32("DwkeSqpSuMX",11) == 3754613566) strcat(s, "n");
if (crc32("YYYYEEDIZ",9) == 236120249) strcat(s, "g");
if (crc32("JQVIXhXx",8) == 203955753) strcat(s, "v");
if (crc32("FZuKw",5) == 989294040) strcat(s, "l");
if (crc32("VFGIaCh",7) == 3404172235) strcat(s, "u");
if (crc32("afXZWbrMUEz",11) == 901973341) strcat(s, "y");
    return s;
}

char *deprecatively_adverbs() {
    char *s = calloc(14);
    if (crc32("oCLlSNzNDRG",11) == 861690658) strcat(s, "k");
if (crc32("CbcJRiY",7) == 1312319599) strcat(s, "d");
if (crc32("rmUchDLDQT",10) == 1000454181) strcat(s, "e");
if (crc32("VvPyOldoDvrsUUy",15) == 1168857746) strcat(s, "D");
if (crc32("XeDvezLErH",10) == 1410621400) strcat(s, "p");
if (crc32("HhJAeTSyuh",10) == 3580808414) strcat(s, "r");
if (crc32("fiBVRUm",7) == 223604046) strcat(s, "e");
if (crc32("mTMImMR",7) == 2364036088) strcat(s, "F");
if (crc32("HFXWccKOYIdCe",13) == 1473537255) strcat(s, "c");
if (crc32("siKjdsFKmRytJMe",15) == 3773729544) strcat(s, "a");
if (crc32("wrosdecj",8) == 3867113679) strcat(s, "t");
if (crc32("rzABhZFN",8) == 2012805375) strcat(s, "L");
if (crc32("ZKSJOlETVf",10) == 120196886) strcat(s, "i");
if (crc32("AcYbDUerqdpO",12) == 2090954714) strcat(s, "v");
if (crc32("LrqZjhlpQgc",11) == 3350009916) strcat(s, "o");
if (crc32("TaPqEOO",7) == 2233304823) strcat(s, "e");
if (crc32("sgLuXWUIbYfxQwj",15) == 178788701) strcat(s, "l");
if (crc32("AizUlv",6) == 4282331479) strcat(s, "y");
    return s;
}

char *binomially_adverbs() {
    char *s = calloc(11);
    if (crc32("qjfUUa",6) == 729656432) strcat(s, "b");
if (crc32("zqfQMIO",7) == 3478377099) strcat(s, "i");
if (crc32("kIoPa",5) == 61227667) strcat(s, "E");
if (crc32("hEAMpxJsSH",10) == 4233868250) strcat(s, "n");
if (crc32("oPYCNWpUGX",10) == 3927950832) strcat(s, "o");
if (crc32("lYMZCwJb",8) == 3833276124) strcat(s, "m");
if (crc32("VhiTrelaToV",11) == 3412515872) strcat(s, "a");
if (crc32("YfZkxHppKEI",11) == 2396006196) strcat(s, "i");
if (crc32("mqNvewkdLUCt",12) == 2038589349) strcat(s, "a");
if (crc32("VdZqqlj",7) == 3727749286) strcat(s, "l");
if (crc32("VbcgOMJWkLKT",12) == 3108289736) strcat(s, "l");
if (crc32("hXtpxNXAmtSvntF",15) == 630127522) strcat(s, "y");
    return s;
}

char *uncubically_adverbs() {
    char *s = calloc(12);
    if (crc32("FNgVkJTJPnTxmJ",14) == 2405531690) strcat(s, "w");
if (crc32("zBwgC",5) == 3498708058) strcat(s, "u");
if (crc32("LdAoHFgKGD",10) == 1790807666) strcat(s, "p");
if (crc32("gBNHeWGSw",9) == 1873151261) strcat(s, "n");
if (crc32("TNrDq",5) == 2176551413) strcat(s, "z");
if (crc32("ZEqZhlLxW",9) == 886691067) strcat(s, "c");
if (crc32("pARWi",5) == 3002384443) strcat(s, "u");
if (crc32("NvZDbGOPBmpg",12) == 1407998862) strcat(s, "d");
if (crc32("EDAHol",6) == 3093593550) strcat(s, "b");
if (crc32("rWYYZGwbZc",10) == 2511599738) strcat(s, "i");
if (crc32("QLwoYlWPKJHaxOM",15) == 833091596) strcat(s, "u");
if (crc32("uIJVibwHmRvI",12) == 2681307805) strcat(s, "c");
if (crc32("mMAsMXOsaRdt",12) == 1727555452) strcat(s, "i");
if (crc32("JqMsUaqk",8) == 3277256606) strcat(s, "a");
if (crc32("QQyvKBqL",8) == 2375245371) strcat(s, "C");
if (crc32("TDUXXgdyI",9) == 3856766862) strcat(s, "l");
if (crc32("eTxVBrHPNOwBMw",14) == 1234668722) strcat(s, "p");
if (crc32("aRIYtjpg",8) == 2374600188) strcat(s, "l");
if (crc32("xQaFbDtXBmET",12) == 1498348891) strcat(s, "y");
    return s;
}

char *orinasally_adverbs() {
    char *s = calloc(11);
    if (crc32("IMgvWFbtLoF",11) == 3279791147) strcat(s, "o");
if (crc32("NbeilRxywgmrDr",14) == 3061189120) strcat(s, "r");
if (crc32("wBZNNjcLy",9) == 562533499) strcat(s, "e");
if (crc32("dKyFjuNAWi",10) == 2698969675) strcat(s, "i");
if (crc32("dQnPPmgzqQGC",12) == 2735322544) strcat(s, "n");
if (crc32("pQDFPK",6) == 1846083186) strcat(s, "j");
if (crc32("vArrqJHkBaA",11) == 1377033005) strcat(s, "a");
if (crc32("lepfJmOMerPTHaZ",15) == 1819920459) strcat(s, "s");
if (crc32("JjvITuy",7) == 2328009409) strcat(s, "M");
if (crc32("FOYHtYCF",8) == 3091890611) strcat(s, "a");
if (crc32("hARKWDSEH",9) == 820431338) strcat(s, "l");
if (crc32("pNIDgN",6) == 2536956373) strcat(s, "G");
if (crc32("xmWjttYyxvrq",12) == 2077493965) strcat(s, "l");
if (crc32("GXMRGUCYTStVi",13) == 868970572) strcat(s, "y");
    return s;
}

char *unrubrically_adverbs() {
    char *s = calloc(13);
    if (crc32("swnwoFgNOPqi",12) == 292854686) strcat(s, "f");
if (crc32("JjfnHl",6) == 3961733582) strcat(s, "u");
if (crc32("vYyrgbh",7) == 2927218726) strcat(s, "T");
if (crc32("NtoasDN",7) == 3537231592) strcat(s, "n");
if (crc32("eGuHtaOSxeBn",12) == 1305021217) strcat(s, "r");
if (crc32("DLZfmVoQb",9) == 2384382023) strcat(s, "u");
if (crc32("BimjLt",6) == 3772304380) strcat(s, "b");
if (crc32("jbTwdLsY",8) == 1068277629) strcat(s, "r");
if (crc32("BkRIUgrIbjTZw",13) == 716845489) strcat(s, "i");
if (crc32("vzMUsshp",8) == 3593263354) strcat(s, "c");
if (crc32("yCILHSIXqAaUNz",14) == 1856516206) strcat(s, "K");
if (crc32("gPGOGbu",7) == 4096163331) strcat(s, "a");
if (crc32("wPULXYxKxnsM",12) == 742593933) strcat(s, "l");
if (crc32("kuWmIGCpxpQKFX",14) == 1573370423) strcat(s, "C");
if (crc32("ZKTbjdLVqhXCFi",14) == 930054206) strcat(s, "l");
if (crc32("mlNujSAfZcJMpBd",15) == 187972476) strcat(s, "e");
if (crc32("AaXoscX",7) == 2856921528) strcat(s, "y");
    return s;
}

char *quasimodestly_adverbs() {
    char *s = calloc(14);
    if (crc32("flNcn",5) == 3261705281) strcat(s, "i");
if (crc32("erDjsA",6) == 1041651274) strcat(s, "q");
if (crc32("sGQuOTguKbmyLk",14) == 4075876950) strcat(s, "v");
if (crc32("NVENysHanEM",11) == 735373987) strcat(s, "u");
if (crc32("QlKxltFeaO",10) == 3187226276) strcat(s, "a");
if (crc32("qDSTbDdOxDPgMC",14) == 2390120772) strcat(s, "s");
if (crc32("nWophWwlqcp",11) == 3310439312) strcat(s, "i");
if (crc32("YrIQzcDGh",9) == 3523160993) strcat(s, "m");
if (crc32("WcXUTxaa",8) == 2805404615) strcat(s, "u");
if (crc32("AlYYUINwMLeG",12) == 1125402366) strcat(s, "o");
if (crc32("XiGcMzr",7) == 1920230775) strcat(s, "d");
if (crc32("pwVRpKGdYPYMJd",14) == 2952652520) strcat(s, "A");
if (crc32("PHccJXefutdrkKj",15) == 537190386) strcat(s, "e");
if (crc32("pRHMTb",6) == 2746926764) strcat(s, "s");
if (crc32("iTYxBUSoVMnhC",13) == 3020403787) strcat(s, "U");
if (crc32("iXmvMqvuFI",10) == 27091032) strcat(s, "t");
if (crc32("odbDL",5) == 3374903073) strcat(s, "l");
if (crc32("AuiQl",5) == 1609721731) strcat(s, "y");
    return s;
}

char *ripely_adverbs() {
    char *s = calloc(7);
    if (crc32("qhCJkcKwSZDbS",13) == 1497023363) strcat(s, "r");
if (crc32("NAeEvQ",6) == 4272114766) strcat(s, "i");
if (crc32("jcxBiWnqAeC",11) == 3217830893) strcat(s, "p");
if (crc32("NmtmzQdna",9) == 560444388) strcat(s, "M");
if (crc32("gVANakgZCgn",11) == 1638300982) strcat(s, "e");
if (crc32("NwavXOMN",8) == 1678547180) strcat(s, "l");
if (crc32("mIBAoptkhNWVIen",15) == 3240453469) strcat(s, "y");
    return s;
}

char *overassertively_adverbs() {
    char *s = calloc(16);
    if (crc32("fJteBbzSssqJCC",14) == 105721202) strcat(s, "m");
if (crc32("HDUznFEWi",9) == 3665298072) strcat(s, "o");
if (crc32("EdNvvDVMhp",10) == 630767887) strcat(s, "i");
if (crc32("KbAOBCqn",8) == 3434409352) strcat(s, "v");
if (crc32("regkHkFkrpa",11) == 590891008) strcat(s, "e");
if (crc32("dvLvfvkcbgMo",12) == 551109980) strcat(s, "r");
if (crc32("JUVWhXlxfthYPd",14) == 944698200) strcat(s, "a");
if (crc32("CNeYylvdu",9) == 1002320953) strcat(s, "s");
if (crc32("jSKlOXt",7) == 951009259) strcat(s, "s");
if (crc32("wHKLUtnY",8) == 3102543099) strcat(s, "S");
if (crc32("RCTgBVsz",8) == 1445057833) strcat(s, "e");
if (crc32("fomcS",5) == 1336472316) strcat(s, "r");
if (crc32("ppbqf",5) == 2372478170) strcat(s, "t");
if (crc32("xGJUlAWGR",9) == 517372383) strcat(s, "i");
if (crc32("OAIqskCzLuWUST",14) == 2419915943) strcat(s, "v");
if (crc32("zZRHZlkLmEte",12) == 994378963) strcat(s, "k");
if (crc32("eJJaWHONH",9) == 3537631861) strcat(s, "e");
if (crc32("ilrvq",5) == 719489406) strcat(s, "l");
if (crc32("vmRQpOajNtbb",12) == 602777400) strcat(s, "z");
if (crc32("eRKxr",5) == 3554036166) strcat(s, "y");
    return s;
}

char *tubularly_adverbs() {
    char *s = calloc(10);
    if (crc32("qEsisfeHOgt",11) == 545232925) strcat(s, "t");
if (crc32("VHylpdLRshSkPh",14) == 2004028908) strcat(s, "u");
if (crc32("wchlGY",6) == 966963455) strcat(s, "v");
if (crc32("yfEgTpAEhlGrfM",14) == 2348430493) strcat(s, "b");
if (crc32("zZBSBU",6) == 2029012374) strcat(s, "k");
if (crc32("PcbNSMlz",8) == 4039586040) strcat(s, "u");
if (crc32("LUePBo",6) == 225295757) strcat(s, "Q");
if (crc32("hzfsTiGYlMC",11) == 572914172) strcat(s, "l");
if (crc32("tCRtYKxNScHQ",12) == 3098482198) strcat(s, "a");
if (crc32("RJjGeuMNoiD",11) == 3862780547) strcat(s, "t");
if (crc32("sMmNgDkILD",10) == 2288028501) strcat(s, "r");
if (crc32("hdKFBZtyMWv",11) == 3130250234) strcat(s, "l");
if (crc32("QJjCxpBSnOS",11) == 3717490451) strcat(s, "y");
    return s;
}

char *overearnestly_adverbs() {
    char *s = calloc(14);
    if (crc32("AoVNt",5) == 2866151951) strcat(s, "i");
if (crc32("XMIgWfy",7) == 3188697362) strcat(s, "o");
if (crc32("nRgURySHHVqdY",13) == 2730875722) strcat(s, "v");
if (crc32("UrCWxyM",7) == 1334863452) strcat(s, "v");
if (crc32("nkXTFmzzoNJ",11) == 4123226051) strcat(s, "s");
if (crc32("GKvaOJUiXcgimss",15) == 1685087867) strcat(s, "e");
if (crc32("sAdHFEalKMOMz",13) == 2557656034) strcat(s, "r");
if (crc32("HdGKOYWQDmv",11) == 1877122677) strcat(s, "e");
if (crc32("xPoXWwmpnMtwC",13) == 953680153) strcat(s, "B");
if (crc32("CXEPCjGdimGYjSx",15) == 2675571848) strcat(s, "a");
if (crc32("qQQLBQFZYnfZj",13) == 1590363297) strcat(s, "r");
if (crc32("qFBDPy",6) == 1944318792) strcat(s, "n");
if (crc32("bRAnEr",6) == 3838435707) strcat(s, "e");
if (crc32("MjAHCPlyWfRIs",13) == 1827181001) strcat(s, "s");
if (crc32("IPHIZpwBZVHaOvi",15) == 1079978854) strcat(s, "s");
if (crc32("kGHZMjnO",8) == 3380912934) strcat(s, "t");
if (crc32("bzOOORAY",8) == 544594938) strcat(s, "V");
if (crc32("UHKAorXJ",8) == 3747067450) strcat(s, "l");
if (crc32("UOWVf",5) == 3563452743) strcat(s, "y");
    return s;
}

char *superambitiously_adverbs() {
    char *s = calloc(17);
    if (crc32("pBLojAozD",9) == 282818613) strcat(s, "s");
if (crc32("folCQS",6) == 4075543541) strcat(s, "v");
if (crc32("cFTqpA",6) == 3618235356) strcat(s, "u");
if (crc32("hlkAcVeLcSsvkv",14) == 394260822) strcat(s, "J");
if (crc32("XZjMwo",6) == 2987812447) strcat(s, "p");
if (crc32("yQxlXeOr",8) == 1633931117) strcat(s, "e");
if (crc32("lnjNKUtb",8) == 1329793981) strcat(s, "g");
if (crc32("qfOqW",5) == 2754662560) strcat(s, "r");
if (crc32("BRsVVUeBiHzQfvV",15) == 2668166704) strcat(s, "a");
if (crc32("isuujQNIqaV",11) == 2446672251) strcat(s, "t");
if (crc32("BZTijPwyojM",11) == 32921121) strcat(s, "m");
if (crc32("kqvuSiQNRnJBQ",13) == 1240702178) strcat(s, "b");
if (crc32("EeXmPSgt",8) == 2223873738) strcat(s, "b");
if (crc32("tBWew",5) == 3513662891) strcat(s, "q");
if (crc32("oUWDcU",6) == 3423327119) strcat(s, "i");
if (crc32("SgAqQdhYaJQTFl",14) == 2766774483) strcat(s, "t");
if (crc32("mEuxODeRbUU",11) == 3424111442) strcat(s, "i");
if (crc32("sUvLIF",6) == 1163330938) strcat(s, "o");
if (crc32("nWNjjrL",7) == 3272964607) strcat(s, "u");
if (crc32("KafEykGGlo",10) == 2343535120) strcat(s, "B");
if (crc32("xHyrOxtMZbB",11) == 2387765313) strcat(s, "s");
if (crc32("GUqOzdAPYvzX",12) == 2254587028) strcat(s, "H");
if (crc32("IJGKc",5) == 3582674965) strcat(s, "l");
if (crc32("avADPQ",6) == 3148486749) strcat(s, "k");
if (crc32("RwxoPIRdEszPtQp",15) == 2516331126) strcat(s, "y");
    return s;
}

char *pseudoethically_adverbs() {
    char *s = calloc(16);
    if (crc32("jqNLZYF",7) == 2423021525) strcat(s, "H");
if (crc32("qTcCfmT",7) == 3880813531) strcat(s, "p");
if (crc32("tHmKyjYSDHz",11) == 1523327707) strcat(s, "n");
if (crc32("vfKGZJWG",8) == 2898835495) strcat(s, "s");
if (crc32("ctOpaqKoy",9) == 634337619) strcat(s, "k");
if (crc32("LwilcrRHzcYd",12) == 1843629207) strcat(s, "e");
if (crc32("mJhqRHL",7) == 2348618316) strcat(s, "u");
if (crc32("BEnMDpdhAK",10) == 2592795574) strcat(s, "d");
if (crc32("TajNGaPJCYcEn",13) == 2833198124) strcat(s, "o");
if (crc32("RpTxjzvr",8) == 11811102) strcat(s, "P");
if (crc32("rokpiAHtmG",10) == 2363376012) strcat(s, "e");
if (crc32("kPSeCWLE",8) == 2861986471) strcat(s, "t");
if (crc32("gaTDmHxnn",9) == 702308123) strcat(s, "i");
if (crc32("aPWvouLONi",10) == 1202068927) strcat(s, "h");
if (crc32("aOxHgSUKeeSaG",13) == 121462013) strcat(s, "i");
if (crc32("FppJT",5) == 568929842) strcat(s, "o");
if (crc32("dMAHOnlFbGPxDq",14) == 2948509520) strcat(s, "c");
if (crc32("OkHjcpoTaAXcDC",14) == 642332291) strcat(s, "a");
if (crc32("wraUilIVjjfq",12) == 820624373) strcat(s, "Q");
if (crc32("PhaBvPHtnm",10) == 1388168050) strcat(s, "l");
if (crc32("fHTLVrgwyRrtL",13) == 457000490) strcat(s, "v");
if (crc32("yRmndCiflrYcsSC",15) == 2759373888) strcat(s, "l");
if (crc32("sTrRQMGU",8) == 2488672514) strcat(s, "V");
if (crc32("WgBtmqMPOE",10) == 4153587196) strcat(s, "y");
    return s;
}

char *radiably_adverbs() {
    char *s = calloc(9);
    if (crc32("vDiKrgnfGU",10) == 3165287755) strcat(s, "B");
if (crc32("urJBPFTz",8) == 2810731806) strcat(s, "r");
if (crc32("KjuMuRJ",7) == 1588086574) strcat(s, "c");
if (crc32("vrmSiuAaXZh",11) == 997439816) strcat(s, "a");
if (crc32("QUyuAJLSj",9) == 534763366) strcat(s, "c");
if (crc32("okrcoIzGgzphY",13) == 3356916902) strcat(s, "d");
if (crc32("YWHhOtDEC",9) == 2379227136) strcat(s, "H");
if (crc32("BzLKgykQjXJbRif",15) == 3969405631) strcat(s, "i");
if (crc32("qlGId",5) == 1842461841) strcat(s, "a");
if (crc32("wudzNpXzsNV",11) == 3809811141) strcat(s, "V");
if (crc32("NwJhHeUxvZFsX",13) == 1112541273) strcat(s, "b");
if (crc32("hryRfEaorlUDE",13) == 883864504) strcat(s, "t");
if (crc32("VXheCJLC",8) == 345053204) strcat(s, "l");
if (crc32("YHkJrt",6) == 696991057) strcat(s, "y");
    return s;
}

char *feloniously_adverbs() {
    char *s = calloc(12);
    if (crc32("RzDhXKYFTN",10) == 3699815399) strcat(s, "y");
if (crc32("JeTLdHvGtMtm",12) == 4177068592) strcat(s, "f");
if (crc32("JXkGRfb",7) == 2653683853) strcat(s, "M");
if (crc32("wtknP",5) == 3172650773) strcat(s, "e");
if (crc32("ILHxTIQfP",9) == 1688364300) strcat(s, "l");
if (crc32("HGGhvWzkMnRiqs",14) == 651893114) strcat(s, "N");
if (crc32("VeolioMvgWr",11) == 3339600665) strcat(s, "o");
if (crc32("oqGjl",5) == 2684413283) strcat(s, "n");
if (crc32("eismIUPOmcw",11) == 2764582174) strcat(s, "B");
if (crc32("JtOUlqVwHLvGWcL",15) == 1950323572) strcat(s, "i");
if (crc32("kGDMPCxHua",10) == 1398244233) strcat(s, "o");
if (crc32("muiBdNxqIkmEC",13) == 2021332879) strcat(s, "K");
if (crc32("afdGaKrlzrDP",12) == 4266713252) strcat(s, "u");
if (crc32("EgxgCszbTbLWE",13) == 2589104428) strcat(s, "s");
if (crc32("XiMgztgmWhOZAr",14) == 2856043498) strcat(s, "l");
if (crc32("LtIfFsK",7) == 3580752815) strcat(s, "f");
if (crc32("jamXCaohlnAF",12) == 1512984700) strcat(s, "y");
    return s;
}

char *presystematically_adverbs() {
    char *s = calloc(18);
    if (crc32("cksFAtsirupeF",13) == 1731984038) strcat(s, "a");
if (crc32("rXslpcdY",8) == 2022807905) strcat(s, "p");
if (crc32("LZOWskE",7) == 625995598) strcat(s, "q");
if (crc32("FhRTCK",6) == 4050301381) strcat(s, "r");
if (crc32("QleKvd",6) == 1767898780) strcat(s, "e");
if (crc32("qIFmor",6) == 2252438805) strcat(s, "s");
if (crc32("VKnqoXkGfL",10) == 2697427437) strcat(s, "y");
if (crc32("uQXFYC",6) == 1207966707) strcat(s, "b");
if (crc32("RuGVgVHJbAXYo",13) == 4158599854) strcat(s, "s");
if (crc32("ATWeATT",7) == 2907510258) strcat(s, "t");
if (crc32("KMOJj",5) == 1548286865) strcat(s, "e");
if (crc32("OXEAShFxWu",10) == 3571471245) strcat(s, "m");
if (crc32("iADPIDiwV",9) == 2882643634) strcat(s, "a");
if (crc32("uaAITczb",8) == 2456514290) strcat(s, "h");
if (crc32("zdANklyr",8) == 3918566863) strcat(s, "t");
if (crc32("VUGgHQq",7) == 501777466) strcat(s, "S");
if (crc32("PNMYcuN",7) == 338695512) strcat(s, "i");
if (crc32("rDXVOJQPnzxUUf",14) == 3051069132) strcat(s, "c");
if (crc32("BIHPNfUUzDGQH",13) == 2028502966) strcat(s, "V");
if (crc32("RFyDUMyNF",9) == 2341371420) strcat(s, "a");
if (crc32("pVVQjJVnwkcW",12) == 3407850374) strcat(s, "n");
if (crc32("VkdCatSEJyqyh",13) == 2820856581) strcat(s, "l");
if (crc32("EqxnrVEIRECwkXa",15) == 2704805506) strcat(s, "N");
if (crc32("qVVHWifVSaGE",12) == 2220950464) strcat(s, "l");
if (crc32("PqdHQTruPrw",11) == 2212434214) strcat(s, "y");
    return s;
}

char *dynastically_adverbs() {
    char *s = calloc(13);
    if (crc32("ifWRkVwhCoqMfS",14) == 4215147360) strcat(s, "d");
if (crc32("WOKjXeUE",8) == 3208677357) strcat(s, "y");
if (crc32("JrJAQIChwiNzw",13) == 1431062549) strcat(s, "P");
if (crc32("MmcFEJsrk",9) == 335667280) strcat(s, "n");
if (crc32("eljoIeyv",8) == 3468850187) strcat(s, "n");
if (crc32("QLuRuGbnF",9) == 442987184) strcat(s, "a");
if (crc32("vHdBojANjgRJ",12) == 4128003741) strcat(s, "s");
if (crc32("fDNBnBnZkazcpZX",15) == 493281752) strcat(s, "t");
if (crc32("aJcePkFz",8) == 3755379568) strcat(s, "i");
if (crc32("RxRWuPHa",8) == 2690614191) strcat(s, "c");
if (crc32("xgAzLOHVSP",10) == 4251743325) strcat(s, "c");
if (crc32("GaVCtlXIpnOeClN",15) == 957413798) strcat(s, "m");
if (crc32("BMzmKX",6) == 1635893695) strcat(s, "a");
if (crc32("gdzdqFVbgElBV",13) == 409003518) strcat(s, "l");
if (crc32("UGpoJiJxtNaycMq",15) == 885247403) strcat(s, "l");
if (crc32("unUiLieIQXFJ",12) == 647092929) strcat(s, "y");
    return s;
}

char *overpopularly_adverbs() {
    char *s = calloc(14);
    if (crc32("XBHoeHpv",8) == 480142724) strcat(s, "X");
if (crc32("YPBOU",5) == 668138010) strcat(s, "o");
if (crc32("QMMjAihjy",9) == 1857664895) strcat(s, "v");
if (crc32("mlNZxFUZYmVbXzC",15) == 820014109) strcat(s, "b");
if (crc32("jJuXz",5) == 1904330093) strcat(s, "e");
if (crc32("eJgzwUhldXQF",12) == 630872190) strcat(s, "N");
if (crc32("YysbCojPTC",10) == 1609978422) strcat(s, "r");
if (crc32("GmkllSHbFpJXfd",14) == 384231545) strcat(s, "p");
if (crc32("xrAErcXO",8) == 718343309) strcat(s, "o");
if (crc32("fGhUH",5) == 798814047) strcat(s, "p");
if (crc32("fAoqCmm",7) == 3447903853) strcat(s, "I");
if (crc32("ZLmsJP",6) == 2144481494) strcat(s, "u");
if (crc32("FAsTTJWJMCyoO",13) == 1294019691) strcat(s, "b");
if (crc32("vuuMKJ",6) == 4239151293) strcat(s, "l");
if (crc32("XbUAEJCfNsCuSU",14) == 3190806113) strcat(s, "a");
if (crc32("sJciMNMeVgXvXm",14) == 3324788267) strcat(s, "R");
if (crc32("DYRPdjdWFaQRUpq",15) == 3511600015) strcat(s, "r");
if (crc32("fCkmvY",6) == 3083235372) strcat(s, "l");
if (crc32("HYSlCrFjVgxJXt",14) == 1355418624) strcat(s, "y");
    return s;
}

char *quasityrannically_adverbs() {
    char *s = calloc(18);
    if (crc32("MUswXHNzMLYCfUk",15) == 3248544571) strcat(s, "q");
if (crc32("tWhkqVpYKOOtCG",14) == 363585969) strcat(s, "u");
if (crc32("vPPDjW",6) == 2183785840) strcat(s, "a");
if (crc32("SIfeFncWfAzQ",12) == 3250189550) strcat(s, "s");
if (crc32("EviwuTcX",8) == 3950962277) strcat(s, "a");
if (crc32("XYiPh",5) == 3331356590) strcat(s, "i");
if (crc32("DSeWQlWj",8) == 4225235987) strcat(s, "d");
if (crc32("WcMVO",5) == 390202475) strcat(s, "t");
if (crc32("TigHPLIHvVKYjjD",15) == 1791197144) strcat(s, "L");
if (crc32("GCwVNnYtMUyvjJ",14) == 2141740577) strcat(s, "y");
if (crc32("zKucEqaR",8) == 239742367) strcat(s, "X");
if (crc32("GCoPIFvyGVX",11) == 2738235235) strcat(s, "r");
if (crc32("aPhcraxCHtwtzt",14) == 1435000155) strcat(s, "a");
if (crc32("izUphKh",7) == 1378285978) strcat(s, "K");
if (crc32("fLKLYPaV",8) == 751232512) strcat(s, "n");
if (crc32("iMkGDP",6) == 134470089) strcat(s, "A");
if (crc32("NhCXrBBBWPPAmQw",15) == 247139709) strcat(s, "n");
if (crc32("ALOiKUfk",8) == 2788681732) strcat(s, "i");
if (crc32("kqsFCviJmTLcha",14) == 3032819939) strcat(s, "c");
if (crc32("EHnVaWoqD",9) == 3783930170) strcat(s, "O");
if (crc32("VXmitZUQ",8) == 2563760030) strcat(s, "a");
if (crc32("RGpROjtmoXkPN",13) == 2538797773) strcat(s, "S");
if (crc32("GXbgHYLI",8) == 1450125969) strcat(s, "l");
if (crc32("JqzInquMBxmqNdp",15) == 2666996462) strcat(s, "l");
if (crc32("EnuNnf",6) == 1070585255) strcat(s, "o");
if (crc32("WabOQO",6) == 2872115824) strcat(s, "y");
    return s;
}

char *nonstudiously_adverbs() {
    char *s = calloc(14);
    if (crc32("wzBxYWW",7) == 2644162686) strcat(s, "m");
if (crc32("CjAspnAu",8) == 2013001563) strcat(s, "n");
if (crc32("YRDRymXksw",10) == 2841578746) strcat(s, "R");
if (crc32("CEbhjvgOvw",10) == 2639999266) strcat(s, "o");
if (crc32("UOZKJBcqP",9) == 4174065892) strcat(s, "n");
if (crc32("iTOuAa",6) == 288381792) strcat(s, "s");
if (crc32("kyTiEcxKzBuZ",12) == 4174990195) strcat(s, "G");
if (crc32("SKNnm",5) == 1207789116) strcat(s, "t");
if (crc32("nPokatmd",8) == 726771274) strcat(s, "F");
if (crc32("BtevOhqVxA",10) == 3388667338) strcat(s, "u");
if (crc32("eyYaCn",6) == 2474052690) strcat(s, "d");
if (crc32("TzbbNzYnlggEK",13) == 2153011474) strcat(s, "b");
if (crc32("eRJkTKNLdGxpx",13) == 2812106587) strcat(s, "i");
if (crc32("jNrWWXlHQZRP",12) == 1880171984) strcat(s, "o");
if (crc32("OScBZXINjHuabyK",15) == 698011067) strcat(s, "u");
if (crc32("zFxQrDdp",8) == 2052778289) strcat(s, "s");
if (crc32("QTuCL",5) == 1899639381) strcat(s, "l");
if (crc32("zdMGIr",6) == 4107444592) strcat(s, "y");
    return s;
}

char *impressionistically_adverbs() {
    char *s = calloc(20);
    if (crc32("FqkFZly",7) == 3022089151) strcat(s, "i");
if (crc32("EwDJJzfeuPBAA",13) == 3085313091) strcat(s, "i");
if (crc32("WNWULwGSO",9) == 1489837457) strcat(s, "k");
if (crc32("qYtZAFcCBis",11) == 450898110) strcat(s, "m");
if (crc32("DHkqllsyEDRAjqN",15) == 477537423) strcat(s, "u");
if (crc32("rVQwFLgUF",9) == 722075835) strcat(s, "p");
if (crc32("QBSnw",5) == 2846471055) strcat(s, "r");
if (crc32("RPZzkSvRIFTXqWk",15) == 789717361) strcat(s, "e");
if (crc32("gspMsUZpCJf",11) == 166292570) strcat(s, "s");
if (crc32("sRopP",5) == 1463869864) strcat(s, "X");
if (crc32("iNwImfPxlw",10) == 2616221549) strcat(s, "s");
if (crc32("cLCcZpKDnQFF",12) == 2177261429) strcat(s, "d");
if (crc32("KddNcqGYtZU",11) == 1428232062) strcat(s, "i");
if (crc32("dBnAcfAa",8) == 2820565086) strcat(s, "L");
if (crc32("GoRHpJP",7) == 3424475988) strcat(s, "o");
if (crc32("hswrGFIt",8) == 715059352) strcat(s, "n");
if (crc32("wSjJu",5) == 1003554628) strcat(s, "i");
if (crc32("BgsfftHUWAAZSG",14) == 1557096296) strcat(s, "s");
if (crc32("pUEdysj",7) == 4215656656) strcat(s, "t");
if (crc32("ukggKywU",8) == 1518996116) strcat(s, "i");
if (crc32("nDnOiuD",7) == 1403443566) strcat(s, "c");
if (crc32("QusFlwxcetEiXw",14) == 941308201) strcat(s, "a");
if (crc32("KSuEGBOPtwQGOxK",15) == 2586885759) strcat(s, "h");
if (crc32("JuXqXObRtjO",11) == 2688233462) strcat(s, "l");
if (crc32("VlsehtMPkB",10) == 3711605640) strcat(s, "X");
if (crc32("FHRvCRr",7) == 291596424) strcat(s, "l");
if (crc32("rbTaoiRnjhBIbF",14) == 2157656441) strcat(s, "y");
    return s;
}

char *antipestilently_adverbs() {
    char *s = calloc(16);
    if (crc32("gOifuBUOrYlst",13) == 2964065791) strcat(s, "a");
if (crc32("vaQEEkgahvo",11) == 2034596339) strcat(s, "n");
if (crc32("qIXZreRJS",9) == 2450161470) strcat(s, "t");
if (crc32("wkkapjxTLAHiA",13) == 2383308260) strcat(s, "Q");
if (crc32("gCZdLJ",6) == 2597034085) strcat(s, "i");
if (crc32("MzbPZLKZfF",10) == 746550090) strcat(s, "o");
if (crc32("cqMoM",5) == 1501129135) strcat(s, "p");
if (crc32("xJbfpyxcgvF",11) == 1238961564) strcat(s, "e");
if (crc32("lPgfnxSuMyl",11) == 2076891892) strcat(s, "s");
if (crc32("bnagi",5) == 1221497083) strcat(s, "b");
if (crc32("nyMrVGdi",8) == 1194061409) strcat(s, "t");
if (crc32("ogozOlcbitk",11) == 2372519863) strcat(s, "m");
if (crc32("XEeRFYks",8) == 2100293554) strcat(s, "i");
if (crc32("aqlNcimIODFJV",13) == 3400237895) strcat(s, "y");
if (crc32("rQeiCmIlkpsfyGK",15) == 3696670840) strcat(s, "l");
if (crc32("ccmbUwTrsAW",11) == 2251729404) strcat(s, "e");
if (crc32("GDdowMBaFB",10) == 337185283) strcat(s, "k");
if (crc32("VmgkwkDtrttwv",13) == 2484456552) strcat(s, "n");
if (crc32("MbVXGPdlBicm",12) == 1690565170) strcat(s, "t");
if (crc32("lXpNtGcUbKDl",12) == 2654836099) strcat(s, "l");
if (crc32("HraWiNhRiT",10) == 572927246) strcat(s, "t");
if (crc32("FOTMxjtkRlsC",12) == 2603983939) strcat(s, "y");
    return s;
}

char *antirachitically_adverbs() {
    char *s = calloc(17);
    if (crc32("zWUNG",5) == 3484377739) strcat(s, "a");
if (crc32("DofCGYcnitaxFxl",15) == 1800133175) strcat(s, "c");
if (crc32("sbNinorU",8) == 1692326100) strcat(s, "n");
if (crc32("JdTRInAUUn",10) == 817469375) strcat(s, "x");
if (crc32("qltsxoNJx",9) == 2544848779) strcat(s, "t");
if (crc32("BDVIO",5) == 1950412147) strcat(s, "T");
if (crc32("WZXIyZptrvN",11) == 494023382) strcat(s, "i");
if (crc32("UPawvhNotxXBkA",14) == 3776376753) strcat(s, "r");
if (crc32("GIUDcpkv",8) == 617878818) strcat(s, "a");
if (crc32("QNfKzMc",7) == 3220301724) strcat(s, "c");
if (crc32("miCeDLtk",8) == 746570580) strcat(s, "l");
if (crc32("HtJsZMJyGhIt",12) == 3457721631) strcat(s, "h");
if (crc32("fHjNLQyRozcj",12) == 1742861695) strcat(s, "h");
if (crc32("ZHYlqscxiQHC",12) == 953808881) strcat(s, "i");
if (crc32("GjBrBRIiypSAQyE",15) == 2029140365) strcat(s, "e");
if (crc32("ucXTF",5) == 4249142194) strcat(s, "t");
if (crc32("gcBWhQRbjYRALC",14) == 2207558164) strcat(s, "A");
if (crc32("TVJQMqBaiQ",10) == 3370982014) strcat(s, "i");
if (crc32("QKOtYJOvRXgk",12) == 979702478) strcat(s, "c");
if (crc32("ngrJrfDoep",10) == 1610544720) strcat(s, "j");
if (crc32("tdUxMjONHPSB",12) == 387538896) strcat(s, "a");
if (crc32("zJRBK",5) == 1172490823) strcat(s, "p");
if (crc32("fsVppPHfN",9) == 1310537756) strcat(s, "l");
if (crc32("todILyXDd",9) == 3441310797) strcat(s, "i");
if (crc32("fkCAC",5) == 1209817093) strcat(s, "l");
if (crc32("MGLhWRhrkfMqLh",14) == 153862920) strcat(s, "y");
if (crc32("GiUHotEG",8) == 966778829) strcat(s, "y");
    return s;
}

char *flowerily_adverbs() {
    char *s = calloc(10);
    if (crc32("zvuUTzUKBo",10) == 376563431) strcat(s, "K");
if (crc32("HvbotRek",8) == 120801226) strcat(s, "f");
if (crc32("beSTH",5) == 997224284) strcat(s, "d");
if (crc32("BCwnJqytpFxx",12) == 473829531) strcat(s, "l");
if (crc32("cetBoanaUWBa",12) == 490031166) strcat(s, "A");
if (crc32("kxzGkCcJ",8) == 829195335) strcat(s, "o");
if (crc32("BmBdEKBDyn",10) == 2724707763) strcat(s, "w");
if (crc32("lFtBSLDcOIIbxIN",15) == 424395652) strcat(s, "t");
if (crc32("MLbPeBziiC",10) == 1662500695) strcat(s, "e");
if (crc32("VgDVQvPTzyI",11) == 2491918223) strcat(s, "k");
if (crc32("wkoiojmycduuXJs",15) == 3944021324) strcat(s, "r");
if (crc32("uzcLBFOr",8) == 1090056230) strcat(s, "n");
if (crc32("EwajGcGSrMYrp",13) == 2209834240) strcat(s, "i");
if (crc32("CqRfOatduR",10) == 3090478584) strcat(s, "n");
if (crc32("BZeDyFVGcJfIP",13) == 2132849404) strcat(s, "l");
if (crc32("DyvDxtAyB",9) == 4153538628) strcat(s, "y");
    return s;
}

char *ablock_adverbs() {
    char *s = calloc(7);
    if (crc32("aAxwFz",6) == 774193572) strcat(s, "N");
if (crc32("jUPDyDSBXyhd",12) == 2468576766) strcat(s, "a");
if (crc32("Yqeof",5) == 1665794611) strcat(s, "q");
if (crc32("EKKTNq",6) == 2938906965) strcat(s, "b");
if (crc32("xtYwVom",7) == 2833515509) strcat(s, "l");
if (crc32("mwJUPRLFUtiE",12) == 3445079735) strcat(s, "R");
if (crc32("pYFuKTvSmX",10) == 2815499780) strcat(s, "o");
if (crc32("PVbdrPwPzxoOHwu",15) == 1411543544) strcat(s, "c");
if (crc32("gZnTJI",6) == 3526879975) strcat(s, "Y");
if (crc32("AKkFFkVVGEPnkrT",15) == 294896542) strcat(s, "k");
    return s;
}

char *insolently_adverbs() {
    char *s = calloc(11);
    if (crc32("lWxkA",5) == 285909192) strcat(s, "i");
if (crc32("gdsQrtxyMFJ",11) == 4256810797) strcat(s, "c");
if (crc32("EfxWs",5) == 778590726) strcat(s, "n");
if (crc32("aKBCLUvPMm",10) == 1130776423) strcat(s, "s");
if (crc32("UjLeuSuqPA",10) == 1980398446) strcat(s, "w");
if (crc32("quVQIwbEdKOLeIZ",15) == 1466892877) strcat(s, "o");
if (crc32("LGZbaqyBTRS",11) == 777183140) strcat(s, "e");
if (crc32("xkZBZafrwuOUkoh",15) == 3867714817) strcat(s, "l");
if (crc32("zcmeydWUfe",10) == 2061140450) strcat(s, "N");
if (crc32("PkwIjmFjjFeZJfH",15) == 3207316378) strcat(s, "e");
if (crc32("evuGadCMlalMoT",14) == 1637845618) strcat(s, "n");
if (crc32("grvuTsJrJtS",11) == 3401084103) strcat(s, "t");
if (crc32("vHFLqIvCpmDh",12) == 4163267392) strcat(s, "l");
if (crc32("ygpYrRDt",8) == 828458779) strcat(s, "j");
if (crc32("iWvmTLSDRdUb",12) == 4141129772) strcat(s, "y");
    return s;
}

char *honourably_adverbs() {
    char *s = calloc(11);
    if (crc32("teXnEzcyLiQJmDN",15) == 3955202721) strcat(s, "S");
if (crc32("ojMALOp",7) == 2488416956) strcat(s, "h");
if (crc32("LcwGDOerQXk",11) == 558740141) strcat(s, "o");
if (crc32("HBQYzCu",7) == 3227975351) strcat(s, "G");
if (crc32("FzfSbTPcQWrMda",14) == 339578118) strcat(s, "n");
if (crc32("MbcZOZKE",8) == 2369443600) strcat(s, "d");
if (crc32("gbUsJXPYfltGuz",14) == 3340422756) strcat(s, "o");
if (crc32("dXIAVIMLUH",10) == 3436582364) strcat(s, "l");
if (crc32("qrQmE",5) == 2017309191) strcat(s, "u");
if (crc32("tLkLevOJkbYc",12) == 1914892916) strcat(s, "r");
if (crc32("FhqxAPXr",8) == 4245204809) strcat(s, "D");
if (crc32("tnWVxyWkCLePqpI",15) == 2360341819) strcat(s, "a");
if (crc32("HYIWpsrW",8) == 1847585934) strcat(s, "b");
if (crc32("fDThyLUwCJav",12) == 2605064547) strcat(s, "b");
if (crc32("CdLeLvUPdQnp",12) == 3522856771) strcat(s, "R");
if (crc32("mtsiKTrfd",9) == 3557121504) strcat(s, "l");
if (crc32("GnEtzm",6) == 2799594591) strcat(s, "k");
if (crc32("lhhYpjibACaofw",14) == 80163020) strcat(s, "y");
    return s;
}

char *halfreasonably_adverbs() {
    char *s = calloc(15);
    if (crc32("JOgJHKUMRts",11) == 3592419746) strcat(s, "h");
if (crc32("JcAtXGpZNwvKD",13) == 3083486898) strcat(s, "a");
if (crc32("MVfekKvNbLdryRV",15) == 2460766985) strcat(s, "X");
if (crc32("jghvdLxQBzKYVwA",15) == 3684043887) strcat(s, "l");
if (crc32("WXwtzhhyzGW",11) == 746762074) strcat(s, "f");
if (crc32("XSeAuWRohTR",11) == 839620062) strcat(s, "P");
if (crc32("TotIsrjFn",9) == 3324051837) strcat(s, "r");
if (crc32("ymjEaLjoeB",10) == 1748826297) strcat(s, "F");
if (crc32("szJvGafJhdORPf",14) == 4033630169) strcat(s, "e");
if (crc32("baHFQquARYH",11) == 866513347) strcat(s, "V");
if (crc32("waWpWO",6) == 302320382) strcat(s, "a");
if (crc32("XsfSoR",6) == 2559675834) strcat(s, "r");
if (crc32("wgeyniskgaRxkg",14) == 1394450227) strcat(s, "s");
if (crc32("IKgoeLOmqyDByLI",15) == 1374513973) strcat(s, "o");
if (crc32("SexDgSgWzn",10) == 2989943500) strcat(s, "n");
if (crc32("rVxgSBRBklJrti",14) == 777353926) strcat(s, "A");
if (crc32("PEuuTWHEC",9) == 2541933485) strcat(s, "a");
if (crc32("AVIrSdrAueO",11) == 3644783028) strcat(s, "b");
if (crc32("xdSpGdkPUL",10) == 3811088768) strcat(s, "j");
if (crc32("tKXBmiHUdG",10) == 3893277644) strcat(s, "l");
if (crc32("dUAEodvo",8) == 2626330584) strcat(s, "y");
    return s;
}

char *informatively_adverbs() {
    char *s = calloc(14);
    if (crc32("wFJvMG",6) == 2045540595) strcat(s, "i");
if (crc32("OKrMkxMz",8) == 1993932313) strcat(s, "n");
if (crc32("htvCw",5) == 779213784) strcat(s, "O");
if (crc32("ROeTVcrpyooGl",13) == 3051404881) strcat(s, "f");
if (crc32("KPIHtGoFycdCNqm",15) == 3686124745) strcat(s, "o");
if (crc32("ZcfpLi",6) == 3471033337) strcat(s, "V");
if (crc32("YfKCIKjFJrr",11) == 1218895828) strcat(s, "r");
if (crc32("tKNeSahzTxLS",12) == 2043805250) strcat(s, "w");
if (crc32("kCvvezGBCPDbDK",14) == 4137144365) strcat(s, "m");
if (crc32("mmTyS",5) == 2374147634) strcat(s, "H");
if (crc32("XPjgm",5) == 1504957126) strcat(s, "a");
if (crc32("uMTFLQ",6) == 982952389) strcat(s, "t");
if (crc32("UAyKupbkIJ",10) == 1407291380) strcat(s, "Z");
if (crc32("AVCTNgLQVP",10) == 3326409947) strcat(s, "i");
if (crc32("vMYKChXOyWrj",12) == 1579630676) strcat(s, "v");
if (crc32("CdCzgSeOJ",9) == 3618848240) strcat(s, "e");
if (crc32("ORNfFJGCihxEfH",14) == 1427339972) strcat(s, "l");
if (crc32("NDGnqdFnaFS",11) == 3474852424) strcat(s, "y");
    return s;
}

char *waspishly_adverbs() {
    char *s = calloc(10);
    if (crc32("bLsbIaWLIemGBII",15) == 1800579325) strcat(s, "X");
if (crc32("veipxQkY",8) == 1475415465) strcat(s, "w");
if (crc32("xlYseDqnkF",10) == 1453124235) strcat(s, "a");
if (crc32("HPDvslsnVz",10) == 2287741401) strcat(s, "s");
if (crc32("VGIHS",5) == 3258703614) strcat(s, "p");
if (crc32("rLlejSthDzuERMY",15) == 3350804000) strcat(s, "i");
if (crc32("vYWUinfAcCemBzC",15) == 1726456531) strcat(s, "s");
if (crc32("tIdUOrU",7) == 1085483533) strcat(s, "h");
if (crc32("ZnHuIp",6) == 1206983687) strcat(s, "l");
if (crc32("TmSHjQPde",9) == 2695321410) strcat(s, "t");
if (crc32("BMGzdeFe",8) == 3956987953) strcat(s, "y");
    return s;
}

char *unmanually_adverbs() {
    char *s = calloc(11);
    if (crc32("BlEyjCRf",8) == 3306961248) strcat(s, "X");
if (crc32("sTsOLcpPJ",9) == 286659746) strcat(s, "u");
if (crc32("eBSExIaTvRGkW",13) == 1871094491) strcat(s, "X");
if (crc32("evUlLnPjzro",11) == 1248717876) strcat(s, "n");
if (crc32("EcAvxKbNUASjoN",14) == 2379920069) strcat(s, "H");
if (crc32("IADVn",5) == 2165400044) strcat(s, "m");
if (crc32("yylyCSpsMFCid",13) == 338466986) strcat(s, "a");
if (crc32("WnWZxEexrg",10) == 453143188) strcat(s, "n");
if (crc32("FiuTSymIg",9) == 1988911639) strcat(s, "u");
if (crc32("KKobiGyfm",9) == 1260209931) strcat(s, "A");
if (crc32("byFDZKiHgpYrlB",14) == 786305195) strcat(s, "a");
if (crc32("sEqXeH",6) == 2110187332) strcat(s, "l");
if (crc32("UBuGmyHV",8) == 847778685) strcat(s, "l");
if (crc32("KHebthTZeKqd",12) == 1657536541) strcat(s, "v");
if (crc32("BsmDxhLSanwR",12) == 2200393783) strcat(s, "y");
    return s;
}

char *snarlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("gPfRcapbfsrrpe",14) == 4082527946) strcat(s, "s");
if (crc32("FZXlKNTl",8) == 497580281) strcat(s, "n");
if (crc32("YSvtRuvtWRuhMf",14) == 282486566) strcat(s, "L");
if (crc32("VwKOgeYvTdd",11) == 250037767) strcat(s, "a");
if (crc32("rCwXbcPj",8) == 937250546) strcat(s, "G");
if (crc32("qWIYBYalbmzcn",13) == 3070821306) strcat(s, "r");
if (crc32("TkPlmwQWiBCV",12) == 2008209662) strcat(s, "l");
if (crc32("DXHVhyj",7) == 3850240410) strcat(s, "c");
if (crc32("eYkXUYikU",9) == 1325419782) strcat(s, "i");
if (crc32("qQADcU",6) == 1965367015) strcat(s, "n");
if (crc32("qdRtaEahPNjpmUk",15) == 3789133244) strcat(s, "g");
if (crc32("RsNHshDcpMGLK",13) == 3036980414) strcat(s, "K");
if (crc32("JonryakTOjb",11) == 1390788011) strcat(s, "l");
if (crc32("UMPfbPtfxOAE",12) == 1509935971) strcat(s, "y");
    return s;
}

char *quasieternally_adverbs() {
    char *s = calloc(15);
    if (crc32("hdbkGY",6) == 1106630338) strcat(s, "q");
if (crc32("SkuDps",6) == 4069847047) strcat(s, "P");
if (crc32("rGFuTWiDvKF",11) == 1654450762) strcat(s, "u");
if (crc32("INasl",5) == 321719136) strcat(s, "c");
if (crc32("AZNFmEUGNm",10) == 2663681946) strcat(s, "a");
if (crc32("hotqAZ",6) == 4258831676) strcat(s, "Q");
if (crc32("NMxTsJ",6) == 1943460579) strcat(s, "s");
if (crc32("RyHCxmAHF",9) == 557053622) strcat(s, "i");
if (crc32("zZTUuQCXp",9) == 3733157002) strcat(s, "e");
if (crc32("iUQqsH",6) == 4025129157) strcat(s, "m");
if (crc32("PBPyrD",6) == 1676304637) strcat(s, "t");
if (crc32("UfPqdBn",7) == 4264034111) strcat(s, "e");
if (crc32("ZTdyKgc",7) == 1973138014) strcat(s, "r");
if (crc32("JoWocJMyChXm",12) == 3489693573) strcat(s, "o");
if (crc32("vOyhJPKiTDrKNO",14) == 2483063028) strcat(s, "n");
if (crc32("qJHvL",5) == 2394917256) strcat(s, "a");
if (crc32("CoGMFdAWUGVMNE",14) == 2469418472) strcat(s, "H");
if (crc32("ryVdeOJMobxUH",13) == 4272432677) strcat(s, "l");
if (crc32("qGaVrdsfLXcUoEI",15) == 3438545434) strcat(s, "T");
if (crc32("OFhueUZWVXai",12) == 1968833461) strcat(s, "l");
if (crc32("JQLHvD",6) == 2375771267) strcat(s, "L");
if (crc32("IrTbHBvHKTPbj",13) == 2138435488) strcat(s, "y");
    return s;
}

char *encephalographically_adverbs() {
    char *s = calloc(21);
    if (crc32("FvdcuJo",7) == 2806811004) strcat(s, "e");
if (crc32("abFhlKamdjrmn",13) == 2797335641) strcat(s, "n");
if (crc32("VAnVIOv",7) == 422726066) strcat(s, "S");
if (crc32("CrnQqaSr",8) == 994126685) strcat(s, "c");
if (crc32("eOGMcegPjKVtR",13) == 1283621096) strcat(s, "e");
if (crc32("lwboCAw",7) == 3347226102) strcat(s, "P");
if (crc32("lnLfJlbxgnqXsK",14) == 399193958) strcat(s, "p");
if (crc32("rnDjNNcxid",10) == 1485185479) strcat(s, "h");
if (crc32("bsoizVeLCp",10) == 194048681) strcat(s, "a");
if (crc32("TOZCqkYNrStl",12) == 3450027023) strcat(s, "l");
if (crc32("iVneERu",7) == 1364187850) strcat(s, "F");
if (crc32("NlHPKUmiN",9) == 3134404836) strcat(s, "o");
if (crc32("YWIHnXwedrtoM",13) == 204505732) strcat(s, "J");
if (crc32("gtHQQU",6) == 589178229) strcat(s, "g");
if (crc32("YTNWLe",6) == 1424713484) strcat(s, "E");
if (crc32("DFfHpPKTGEzc",12) == 2576230870) strcat(s, "r");
if (crc32("jLeGFEsYOaCx",12) == 1703661087) strcat(s, "Y");
if (crc32("zrsrmmsKa",9) == 570040415) strcat(s, "a");
if (crc32("XxFgZCjJyu",10) == 3868403571) strcat(s, "p");
if (crc32("YmWkYsPvlXpkwD",14) == 4161973829) strcat(s, "l");
if (crc32("TMiKntnoPQAP",12) == 4175555846) strcat(s, "h");
if (crc32("qLYYFpVYDUCYVo",14) == 3671330489) strcat(s, "i");
if (crc32("sWAlpnDIcr",10) == 1309512264) strcat(s, "U");
if (crc32("iHQbg",5) == 3854773162) strcat(s, "c");
if (crc32("ooeYRUXtcnonYb",14) == 3407390723) strcat(s, "a");
if (crc32("WagBkvCMY",9) == 3896776582) strcat(s, "n");
if (crc32("AxXdjhf",7) == 1760797045) strcat(s, "l");
if (crc32("vqhzQYjT",8) == 1766716596) strcat(s, "q");
if (crc32("dUkvFOUl",8) == 314447024) strcat(s, "l");
if (crc32("HsuPUlJLiSeFI",13) == 9098072) strcat(s, "y");
    return s;
}

char *gamily_adverbs() {
    char *s = calloc(7);
    if (crc32("BGLgEW",6) == 3514928798) strcat(s, "o");
if (crc32("lsNcYfAboiH",11) == 2011983686) strcat(s, "g");
if (crc32("QIbAlCP",7) == 322092544) strcat(s, "l");
if (crc32("qxMdvQz",7) == 1730778932) strcat(s, "a");
if (crc32("uCNuzdwRjOhY",12) == 3393865563) strcat(s, "C");
if (crc32("AhNry",5) == 334965550) strcat(s, "m");
if (crc32("JQbTLXsekHy",11) == 548369653) strcat(s, "e");
if (crc32("zfQTiIItQXW",11) == 1919053640) strcat(s, "i");
if (crc32("MvxySprTVm",10) == 194761278) strcat(s, "l");
if (crc32("BsXlToIJVmr",11) == 1057545329) strcat(s, "y");
    return s;
}

char *pseudoambidextrously_adverbs() {
    char *s = calloc(21);
    if (crc32("LOhxuMfzShNa",12) == 986895191) strcat(s, "U");
if (crc32("QjNECK",6) == 2454909414) strcat(s, "p");
if (crc32("gJncmtVRCdheCcX",15) == 642098652) strcat(s, "V");
if (crc32("uhHXCZm",7) == 2687107746) strcat(s, "s");
if (crc32("DkFwiTwYeTiW",12) == 1053394619) strcat(s, "L");
if (crc32("LZfFlVqrJKcD",12) == 2532758563) strcat(s, "e");
if (crc32("CByUPfDFXuTcEym",15) == 3918188680) strcat(s, "u");
if (crc32("lxZxhovCOKqMD",13) == 1546973144) strcat(s, "M");
if (crc32("IPgFPXRb",8) == 821309979) strcat(s, "d");
if (crc32("LZsagksYRJnd",12) == 3293142525) strcat(s, "o");
if (crc32("VMWdostWUsR",11) == 911922973) strcat(s, "I");
if (crc32("QPUxQz",6) == 4215441269) strcat(s, "a");
if (crc32("VfXcNLrmeOnX",12) == 3560956260) strcat(s, "f");
if (crc32("PotqeoYemEhGl",13) == 2324921590) strcat(s, "m");
if (crc32("TNFPKQCvlULxw",13) == 87671756) strcat(s, "b");
if (crc32("ihRuniEWbwSWt",13) == 1886733590) strcat(s, "z");
if (crc32("EHQEGdqRinlW",12) == 2606828169) strcat(s, "i");
if (crc32("vMIDXrkccQBofSR",15) == 1014579005) strcat(s, "P");
if (crc32("VIZIhgeIZiOmms",14) == 1603918573) strcat(s, "d");
if (crc32("bpSaJuvwLNG",11) == 3184991197) strcat(s, "f");
if (crc32("gJOpwjHxZVgrpSa",15) == 1618145469) strcat(s, "e");
if (crc32("TSgDkvVJm",9) == 970234772) strcat(s, "x");
if (crc32("LikAEVBfoHvAfS",14) == 3900371724) strcat(s, "t");
if (crc32("kMuur",5) == 2340455419) strcat(s, "U");
if (crc32("IxbhFjxOZyAutV",14) == 2262621410) strcat(s, "r");
if (crc32("TWeZYXPqBCFxAsw",15) == 2008276475) strcat(s, "o");
if (crc32("GsHPqAGRw",9) == 3513543121) strcat(s, "u");
if (crc32("jVlfDnyzug",10) == 924971670) strcat(s, "s");
if (crc32("ZVJMxvvL",8) == 395908674) strcat(s, "l");
if (crc32("PdGRgZHvmXZLvcG",15) == 1541437264) strcat(s, "y");
    return s;
}

char *nonphilosophically_adverbs() {
    char *s = calloc(19);
    if (crc32("KUZGEEprwrjzd",13) == 418251980) strcat(s, "n");
if (crc32("npTFeQodb",9) == 329665005) strcat(s, "o");
if (crc32("DxpsFeQdQqBph",13) == 2729428409) strcat(s, "E");
if (crc32("NVYmueGWpHI",11) == 4154306819) strcat(s, "n");
if (crc32("unZPW",5) == 41298679) strcat(s, "p");
if (crc32("INNGutlluevC",12) == 2140634158) strcat(s, "f");
if (crc32("EffWVc",6) == 3082936907) strcat(s, "h");
if (crc32("XRrOwRKaQVa",11) == 3247057331) strcat(s, "o");
if (crc32("iFIwJc",6) == 537242839) strcat(s, "i");
if (crc32("nviYRbYPvRbk",12) == 265991409) strcat(s, "J");
if (crc32("zJeHzygnJz",10) == 2788678491) strcat(s, "l");
if (crc32("xEFHPbhHgDjsW",13) == 3926731282) strcat(s, "l");
if (crc32("TICZXctHa",9) == 1468928463) strcat(s, "o");
if (crc32("mXgiALNZWiq",11) == 2440262060) strcat(s, "N");
if (crc32("LLTRZs",6) == 4132710799) strcat(s, "s");
if (crc32("HbGAfIMYjbGHPXr",15) == 353128404) strcat(s, "o");
if (crc32("ULwMNq",6) == 3782327289) strcat(s, "O");
if (crc32("VffjITjWXEG",11) == 2380964902) strcat(s, "p");
if (crc32("xHfJVfDqGlLz",12) == 572259345) strcat(s, "h");
if (crc32("jnDiIRSVCvHXf",13) == 3845999500) strcat(s, "i");
if (crc32("jIXXjMpmS",9) == 2381182562) strcat(s, "r");
if (crc32("jfmPX",5) == 2498358479) strcat(s, "c");
if (crc32("bDewhXKCQZvLP",13) == 252239791) strcat(s, "a");
if (crc32("HESlNLXnHI",10) == 712505225) strcat(s, "Z");
if (crc32("bgMnefuFSmLss",13) == 2325959619) strcat(s, "l");
if (crc32("takBqYLKh",9) == 4045489286) strcat(s, "S");
if (crc32("GJFColpbbrZ",11) == 2686911952) strcat(s, "l");
if (crc32("xhPZyeKHWLt",11) == 1778349860) strcat(s, "y");
    return s;
}

char *puffingly_adverbs() {
    char *s = calloc(10);
    if (crc32("FXjpRPrTQOR",11) == 2062009072) strcat(s, "p");
if (crc32("IyeilIg",7) == 3297690010) strcat(s, "u");
if (crc32("yEPVLKkaJxKPwb",14) == 1700480916) strcat(s, "f");
if (crc32("sMAgeZsBWDhKVUF",15) == 2163051535) strcat(s, "f");
if (crc32("LdPEfBCCI",9) == 2007628964) strcat(s, "i");
if (crc32("QZiyfaZewFcmq",13) == 454812826) strcat(s, "F");
if (crc32("UWticu",6) == 2857783695) strcat(s, "n");
if (crc32("kjWfg",5) == 4124681929) strcat(s, "g");
if (crc32("sQFeRmM",7) == 3950229083) strcat(s, "l");
if (crc32("KcrbIbYM",8) == 3234335876) strcat(s, "y");
    return s;
}

char *abstractly_adverbs() {
    char *s = calloc(11);
    if (crc32("sYQpIYEA",8) == 3323205165) strcat(s, "a");
if (crc32("OAJXsgex",8) == 2735040734) strcat(s, "b");
if (crc32("ROxGnNxyg",9) == 3626254239) strcat(s, "J");
if (crc32("grfGaZLIxiQZN",13) == 1732408644) strcat(s, "s");
if (crc32("NRRjF",5) == 4266084047) strcat(s, "x");
if (crc32("AWgPInsWp",9) == 1338922247) strcat(s, "t");
if (crc32("AvZGEUPVMH",10) == 2374698541) strcat(s, "Q");
if (crc32("VgVPMVoQ",8) == 2784540554) strcat(s, "r");
if (crc32("UtuKOHiYAJvhx",13) == 622683156) strcat(s, "Z");
if (crc32("YiLHqzKWQx",10) == 4095298223) strcat(s, "a");
if (crc32("clZNRXCb",8) == 1187329930) strcat(s, "c");
if (crc32("GzcMKvWq",8) == 4008721171) strcat(s, "t");
if (crc32("lVExbbiYCtLBmx",14) == 3516963004) strcat(s, "q");
if (crc32("SfXUDgjCrzDA",12) == 1110646306) strcat(s, "l");
if (crc32("QmbIkJZCMHZkv",13) == 2457541012) strcat(s, "B");
if (crc32("GRhwZkmVqaXO",12) == 167193120) strcat(s, "y");
    return s;
}

char *preparedly_adverbs() {
    char *s = calloc(11);
    if (crc32("GsWddF",6) == 869284479) strcat(s, "V");
if (crc32("OeStfOX",7) == 3002334025) strcat(s, "p");
if (crc32("zxdbFDRANvC",11) == 1057541315) strcat(s, "r");
if (crc32("pirCMbGMPR",10) == 3586846585) strcat(s, "E");
if (crc32("IMChPGsWfwkOyE",14) == 1419781845) strcat(s, "e");
if (crc32("ciKWVDAepyOKmJ",14) == 3051013566) strcat(s, "p");
if (crc32("mUhggqjDJJviO",13) == 424373712) strcat(s, "t");
if (crc32("ppBvkHUEulE",11) == 1391498932) strcat(s, "a");
if (crc32("ulixyMNOZmx",11) == 2709025778) strcat(s, "r");
if (crc32("hazjjgmPEe",10) == 4132968693) strcat(s, "a");
if (crc32("mNTerO",6) == 326274372) strcat(s, "e");
if (crc32("LqFxWbJQDGgIQG",14) == 1813771350) strcat(s, "X");
if (crc32("MAmIuo",6) == 1591058691) strcat(s, "d");
if (crc32("hANopAnMILBDl",13) == 241554935) strcat(s, "l");
if (crc32("rfFKkmTDIMVTDE",14) == 4270676955) strcat(s, "N");
if (crc32("haPepJ",6) == 3440420216) strcat(s, "y");
    return s;
}

char *flabbily_adverbs() {
    char *s = calloc(9);
    if (crc32("iksoM",5) == 43519599) strcat(s, "f");
if (crc32("FDddkaVV",8) == 244844206) strcat(s, "l");
if (crc32("SXjdMs",6) == 2753903269) strcat(s, "a");
if (crc32("isRGGhRQMjyiRu",14) == 1272326980) strcat(s, "b");
if (crc32("dleOV",5) == 650460534) strcat(s, "h");
if (crc32("UAXGONNqUkbgp",13) == 3393484325) strcat(s, "b");
if (crc32("JPKHjaZ",7) == 2986494158) strcat(s, "i");
if (crc32("oLBVjXcRMga",11) == 1472595012) strcat(s, "l");
if (crc32("MrfGt",5) == 58579079) strcat(s, "y");
    return s;
}

char *quasiromantically_adverbs() {
    char *s = calloc(18);
    if (crc32("RVmnRFVaM",9) == 4176302836) strcat(s, "C");
if (crc32("wyUspRDSaTt",11) == 3046597108) strcat(s, "q");
if (crc32("esKdkAN",7) == 2356769633) strcat(s, "p");
if (crc32("EoStCtYneTzH",12) == 2541335365) strcat(s, "u");
if (crc32("rxqTvXTTVAV",11) == 3050720436) strcat(s, "q");
if (crc32("FXfYzzVDBy",10) == 1926610451) strcat(s, "a");
if (crc32("bmgdvd",6) == 1338600313) strcat(s, "s");
if (crc32("sKuzQNJJu",9) == 1718945649) strcat(s, "i");
if (crc32("jgitxdiAJ",9) == 1531851210) strcat(s, "z");
if (crc32("tuMlxmnoMlpXT",13) == 2792339024) strcat(s, "r");
if (crc32("jjdeOepUXY",10) == 3089173911) strcat(s, "V");
if (crc32("yWhajjK",7) == 3834874848) strcat(s, "o");
if (crc32("vZOxXVXwtN",10) == 35987776) strcat(s, "m");
if (crc32("zbyGcDPdJtpJIxN",15) == 2418017806) strcat(s, "w");
if (crc32("RfaBYVmtKiejUNM",15) == 3632232430) strcat(s, "a");
if (crc32("FEbFMT",6) == 876213684) strcat(s, "n");
if (crc32("vJNSsBhNzDwjlmq",15) == 1408194377) strcat(s, "V");
if (crc32("JqHEzACH",8) == 854718336) strcat(s, "t");
if (crc32("tstXT",5) == 4268112989) strcat(s, "i");
if (crc32("vXKZNlrL",8) == 2045984667) strcat(s, "M");
if (crc32("ZjjURLkvT",9) == 4046192040) strcat(s, "c");
if (crc32("qKFNnUxGfprQ",12) == 1604815187) strcat(s, "s");
if (crc32("TyImYzrVDFvCui",14) == 1944047327) strcat(s, "a");
if (crc32("BFGczWiKSqwjNd",14) == 3241114526) strcat(s, "G");
if (crc32("MBjrATAFJx",10) == 1209438975) strcat(s, "l");
if (crc32("wrdAOufBgTIG",12) == 3053758005) strcat(s, "P");
if (crc32("gTOZJ",5) == 79958808) strcat(s, "l");
if (crc32("lvaIriH",7) == 1197324959) strcat(s, "A");
if (crc32("hbKSvv",6) == 1417366805) strcat(s, "y");
    return s;
}

char *whiles_adverbs() {
    char *s = calloc(7);
    if (crc32("zkYmrppRO",9) == 4226603707) strcat(s, "h");
if (crc32("kaLziJPRyDSn",12) == 1778279629) strcat(s, "w");
if (crc32("YlUPCKLdVPW",11) == 3505572378) strcat(s, "h");
if (crc32("KsqTXefpoTmkc",13) == 3139583791) strcat(s, "C");
if (crc32("igroaVHiDkzqlAM",15) == 386599685) strcat(s, "i");
if (crc32("kCNLKr",6) == 1668260311) strcat(s, "l");
if (crc32("khHGTfq",7) == 3777639101) strcat(s, "e");
if (crc32("dqUHRdfGM",9) == 12640712) strcat(s, "q");
if (crc32("BvqbYWk",7) == 2330576249) strcat(s, "s");
    return s;
}

char *foully_adverbs() {
    char *s = calloc(7);
    if (crc32("IOxIdIQVEgpcoNd",15) == 4054187543) strcat(s, "f");
if (crc32("ccLpphuLMzKTP",13) == 1319953883) strcat(s, "A");
if (crc32("oFjeY",5) == 742533156) strcat(s, "o");
if (crc32("KCVxPxNQfckHl",13) == 4204157217) strcat(s, "o");
if (crc32("fHgzFWmJal",10) == 396243310) strcat(s, "u");
if (crc32("ddRGCOOz",8) == 3501834941) strcat(s, "l");
if (crc32("vvtNAjNurOnKqLI",15) == 2333971903) strcat(s, "z");
if (crc32("ubFjSRv",7) == 3124317979) strcat(s, "l");
if (crc32("ZFenXNXKTwRAc",13) == 3840942308) strcat(s, "y");
    return s;
}

char *ludicrously_adverbs() {
    char *s = calloc(12);
    if (crc32("DlCIdkUZtrjszV",14) == 756254817) strcat(s, "l");
if (crc32("WkFYjuEDcwgODe",14) == 3586157776) strcat(s, "E");
if (crc32("Atzmu",5) == 4004957424) strcat(s, "u");
if (crc32("ecpWWvHX",8) == 2647656166) strcat(s, "d");
if (crc32("XPnGsmsVO",9) == 2432485765) strcat(s, "T");
if (crc32("pvrHvgalyZMq",12) == 1886630860) strcat(s, "i");
if (crc32("OxOkLtGgqMvugp",14) == 1876036355) strcat(s, "z");
if (crc32("rHEpbv",6) == 2302477202) strcat(s, "c");
if (crc32("ZZMagAvNkNqGhzm",15) == 765669820) strcat(s, "Y");
if (crc32("eBjPUGe",7) == 4134197083) strcat(s, "r");
if (crc32("dusSWaZtYXUk",12) == 2198622876) strcat(s, "P");
if (crc32("oMzYyurl",8) == 3415181680) strcat(s, "o");
if (crc32("llIvDYZuL",9) == 3035678176) strcat(s, "m");
if (crc32("PaqhuGkMH",9) == 1744924741) strcat(s, "u");
if (crc32("UAENcr",6) == 2919721391) strcat(s, "s");
if (crc32("LIGAG",5) == 2340380764) strcat(s, "P");
if (crc32("lcMcQpH",7) == 3970741469) strcat(s, "l");
if (crc32("nnAuu",5) == 1182672464) strcat(s, "J");
if (crc32("ZEvMK",5) == 3975034314) strcat(s, "y");
    return s;
}

char *destitutely_adverbs() {
    char *s = calloc(12);
    if (crc32("ZpNkEFKtIS",10) == 2615057976) strcat(s, "F");
if (crc32("luESeFXVlWPwq",13) == 3235591650) strcat(s, "d");
if (crc32("kccBobDrGP",10) == 2945682264) strcat(s, "e");
if (crc32("jaatfDoNFlPTziW",15) == 1211271235) strcat(s, "f");
if (crc32("pdQQOqtItLgg",12) == 2535992999) strcat(s, "s");
if (crc32("zuwBkGu",7) == 3305469799) strcat(s, "p");
if (crc32("gCELgHtoKz",10) == 2894135913) strcat(s, "t");
if (crc32("LxFAWx",6) == 1085148752) strcat(s, "I");
if (crc32("QgSELyubCT",10) == 1820084724) strcat(s, "i");
if (crc32("FFJabCLKivy",11) == 3290530188) strcat(s, "V");
if (crc32("AIAEKchQwxsBr",13) == 525481318) strcat(s, "t");
if (crc32("DwbQCIAGqFPqTxh",15) == 2710000666) strcat(s, "u");
if (crc32("eRrqqBAHj",9) == 435752600) strcat(s, "r");
if (crc32("pEkzwDz",7) == 2978676440) strcat(s, "t");
if (crc32("WvwfeJXniGOCQ",13) == 3011104413) strcat(s, "Y");
if (crc32("mCAXgJKoikPnkJ",14) == 2863866797) strcat(s, "e");
if (crc32("NJOetrSJHX",10) == 3950128406) strcat(s, "l");
if (crc32("prBuE",5) == 3643154119) strcat(s, "y");
    return s;
}

char *nonequitably_adverbs() {
    char *s = calloc(13);
    if (crc32("yMuMUHh",7) == 514358359) strcat(s, "n");
if (crc32("ABZupLacbJmCFC",14) == 3512361645) strcat(s, "S");
if (crc32("gRbOtrnqE",9) == 2492521623) strcat(s, "o");
if (crc32("iwGYuUnHwpp",11) == 270837946) strcat(s, "n");
if (crc32("tenfnZlQHKFhd",13) == 1398671528) strcat(s, "F");
if (crc32("RLjtBLmst",9) == 2607734095) strcat(s, "e");
if (crc32("uuwFwErMy",9) == 3094522328) strcat(s, "K");
if (crc32("TwxNfZqJ",8) == 1115178740) strcat(s, "q");
if (crc32("wPdUCxLZ",8) == 3088636310) strcat(s, "J");
if (crc32("FnrCChAeS",9) == 111861828) strcat(s, "u");
if (crc32("BCYJDqycDNHbYi",14) == 3014386050) strcat(s, "v");
if (crc32("wjcLbwV",7) == 3149525825) strcat(s, "i");
if (crc32("kfVRt",5) == 2170143087) strcat(s, "t");
if (crc32("iChJIw",6) == 3979287169) strcat(s, "a");
if (crc32("sujeN",5) == 3894378543) strcat(s, "b");
if (crc32("nuVqZgo",7) == 4013990889) strcat(s, "l");
if (crc32("gSfVDYTRHapiP",13) == 67963926) strcat(s, "y");
    return s;
}

char *nontraceably_adverbs() {
    char *s = calloc(13);
    if (crc32("URvHptJZUmPYld",14) == 1035168380) strcat(s, "h");
if (crc32("wMhsLHpI",8) == 868941646) strcat(s, "n");
if (crc32("fnqliKjgCWhYD",13) == 1072938073) strcat(s, "o");
if (crc32("dfuRlqtJHtWEi",13) == 4232844860) strcat(s, "T");
if (crc32("uKoBTlWUvKri",12) == 2233673452) strcat(s, "n");
if (crc32("IXVYdxoGyrqWId",14) == 818034486) strcat(s, "D");
if (crc32("AHYgAQv",7) == 1685525593) strcat(s, "t");
if (crc32("sdKWmuxwKykD",12) == 30794410) strcat(s, "r");
if (crc32("PiKNgKHctsNSv",13) == 1413663175) strcat(s, "a");
if (crc32("uYiht",5) == 4234116271) strcat(s, "c");
if (crc32("lZHNCaKRR",9) == 3514090276) strcat(s, "W");
if (crc32("sWTWlPuf",8) == 1467410636) strcat(s, "e");
if (crc32("CxzdcYivfWF",11) == 2697129021) strcat(s, "h");
if (crc32("mimdpZkIJL",10) == 2622864135) strcat(s, "a");
if (crc32("uckdfFZ",7) == 2963139634) strcat(s, "J");
if (crc32("JTbZbz",6) == 3314410571) strcat(s, "b");
if (crc32("UjsCkFuZEs",10) == 4002342313) strcat(s, "l");
if (crc32("meEMeJaJMddUoMK",15) == 4113036702) strcat(s, "y");
    return s;
}

char *nonlogically_adverbs() {
    char *s = calloc(13);
    if (crc32("tNljTGTpTHs",11) == 2801873997) strcat(s, "n");
if (crc32("yBWvHjmum",9) == 1676769773) strcat(s, "c");
if (crc32("zZTEeREAUioI",12) == 1270118180) strcat(s, "o");
if (crc32("jKUKrsmoBd",10) == 3633160420) strcat(s, "n");
if (crc32("GvuiEdpRytEN",12) == 1115035140) strcat(s, "z");
if (crc32("CqgYXMKONZbMLG",14) == 2373638234) strcat(s, "l");
if (crc32("qjZRQfR",7) == 3053945056) strcat(s, "o");
if (crc32("auJjSXG",7) == 1505411156) strcat(s, "g");
if (crc32("waOZqqbGFYn",11) == 2638389352) strcat(s, "i");
if (crc32("PRHrS",5) == 1251243331) strcat(s, "l");
if (crc32("DEKqFFrc",8) == 2083628917) strcat(s, "c");
if (crc32("isnmspwM",8) == 2309770308) strcat(s, "v");
if (crc32("sZDwoku",7) == 1401938743) strcat(s, "a");
if (crc32("qlfozlNe",8) == 3409595439) strcat(s, "y");
if (crc32("EoYQYvfT",8) == 4002127278) strcat(s, "l");
if (crc32("maBDny",6) == 1088781396) strcat(s, "G");
if (crc32("DMaRpjJdPUVpH",13) == 3379093244) strcat(s, "l");
if (crc32("PaKUOoACRnxgOFs",15) == 702131564) strcat(s, "U");
if (crc32("KSKctUy",7) == 3928429844) strcat(s, "y");
    return s;
}

char *pitiably_adverbs() {
    char *s = calloc(9);
    if (crc32("JHiFjzc",7) == 4033511677) strcat(s, "p");
if (crc32("PptovajGWSFsbBQ",15) == 683736584) strcat(s, "H");
if (crc32("psGmXT",6) == 1547324475) strcat(s, "i");
if (crc32("HacEIPaZWJbalm",14) == 3806888169) strcat(s, "b");
if (crc32("wveDSgIuNVeJZzq",15) == 3290274814) strcat(s, "t");
if (crc32("RiQXeErBfmobAI",14) == 2666854677) strcat(s, "u");
if (crc32("qlWngumOgiPBTA",14) == 4005427713) strcat(s, "i");
if (crc32("QoeRgtHPTR",10) == 3335836048) strcat(s, "I");
if (crc32("IhxCEBDxK",9) == 285799687) strcat(s, "a");
if (crc32("kKKnincimyKRcAZ",15) == 1142521030) strcat(s, "C");
if (crc32("CqpMOUlcwzZ",11) == 3944496507) strcat(s, "b");
if (crc32("dyyCsRXvMIRV",12) == 682454606) strcat(s, "H");
if (crc32("GEZJhe",6) == 2060312550) strcat(s, "l");
if (crc32("XmJGaklOELiJQn",14) == 3565436906) strcat(s, "N");
if (crc32("citroSDUhbBFJiG",15) == 1530071457) strcat(s, "y");
    return s;
}

char *corruptibly_adverbs() {
    char *s = calloc(12);
    if (crc32("xEGqwFbhsTJuLzJ",15) == 3846020858) strcat(s, "S");
if (crc32("rRknbeOoVQr",11) == 3809698996) strcat(s, "c");
if (crc32("UsqESTeWY",9) == 3889073758) strcat(s, "Z");
if (crc32("WflLrQoLGYfCR",13) == 1856695423) strcat(s, "o");
if (crc32("UJWWGOgzY",9) == 2105238279) strcat(s, "r");
if (crc32("XIuqKuGDtWQy",12) == 1765874596) strcat(s, "r");
if (crc32("ahzzsYNPqZa",11) == 2362815907) strcat(s, "N");
if (crc32("mEUwJoQI",8) == 885797923) strcat(s, "r");
if (crc32("fsNtGekoWIwkO",13) == 757702131) strcat(s, "j");
if (crc32("JkdeRG",6) == 1804487823) strcat(s, "u");
if (crc32("yZaVa",5) == 2114307458) strcat(s, "g");
if (crc32("ObkqdMLVhCXfc",13) == 1957016758) strcat(s, "p");
if (crc32("fkoyRTA",7) == 1848878955) strcat(s, "h");
if (crc32("vdPOOqePVOR",11) == 1436811546) strcat(s, "t");
if (crc32("oGhNhorH",8) == 1588597073) strcat(s, "s");
if (crc32("uqpfEJ",6) == 318632046) strcat(s, "i");
if (crc32("NrnBcx",6) == 1491896433) strcat(s, "P");
if (crc32("pUwbiZXBFKyiD",13) == 1893147660) strcat(s, "b");
if (crc32("UREBgrt",7) == 187729129) strcat(s, "l");
if (crc32("ApuKjbFr",8) == 1580815928) strcat(s, "k");
if (crc32("tkoqwzkxU",9) == 2354239121) strcat(s, "y");
    return s;
}

char *unhumbly_adverbs() {
    char *s = calloc(9);
    if (crc32("UZicpd",6) == 3384812256) strcat(s, "m");
if (crc32("xjoHktIC",8) == 3586243592) strcat(s, "u");
if (crc32("XNsssItwJcbsb",13) == 2141969946) strcat(s, "i");
if (crc32("BkVdT",5) == 227599738) strcat(s, "n");
if (crc32("EkZvVB",6) == 2152357226) strcat(s, "h");
if (crc32("KtWwN",5) == 2766464515) strcat(s, "w");
if (crc32("KUarcFVhapxSuTs",15) == 1353461943) strcat(s, "u");
if (crc32("JkoWYw",6) == 2624075612) strcat(s, "v");
if (crc32("MxPyJj",6) == 4235878571) strcat(s, "m");
if (crc32("StPquTwSPIjz",12) == 1507805565) strcat(s, "W");
if (crc32("zaFSwGqb",8) == 3311665833) strcat(s, "b");
if (crc32("nEjOeHLgrVOM",12) == 452514725) strcat(s, "N");
if (crc32("knkzPWZyG",9) == 3354512092) strcat(s, "l");
if (crc32("GCfdXBYLoyR",11) == 349794238) strcat(s, "y");
    return s;
}

char *uncontemptibly_adverbs() {
    char *s = calloc(15);
    if (crc32("JJphTSdz",8) == 1259784551) strcat(s, "f");
if (crc32("AZuHGvUzSdcAs",13) == 296478142) strcat(s, "u");
if (crc32("xBgOKm",6) == 2302257994) strcat(s, "n");
if (crc32("ZoAAgwjREpB",11) == 1906561122) strcat(s, "i");
if (crc32("wNGdsNqXYnbryYm",15) == 142847731) strcat(s, "c");
if (crc32("XmRlUSFhGTbZCSl",15) == 113438495) strcat(s, "k");
if (crc32("wBuZgEK",7) == 1110041656) strcat(s, "o");
if (crc32("ExZVthQw",8) == 535780142) strcat(s, "D");
if (crc32("zJKJkTU",7) == 560574970) strcat(s, "n");
if (crc32("UwffmVeHDH",10) == 1271784832) strcat(s, "t");
if (crc32("DWbmbkCineoGgg",14) == 2628844860) strcat(s, "e");
if (crc32("WujfL",5) == 1898638030) strcat(s, "s");
if (crc32("nljkQYM",7) == 136095678) strcat(s, "m");
if (crc32("HwdeyfLr",8) == 1152295344) strcat(s, "d");
if (crc32("QcCiTeNmt",9) == 3137911178) strcat(s, "p");
if (crc32("XrFaR",5) == 494125564) strcat(s, "K");
if (crc32("JOQDZTiYgX",10) == 1211652721) strcat(s, "t");
if (crc32("cRwhpiMYqbOEYQ",14) == 2112947587) strcat(s, "j");
if (crc32("iRYyQVd",7) == 711992844) strcat(s, "i");
if (crc32("tSrYLvxoN",9) == 976061040) strcat(s, "b");
if (crc32("vgWLsZXrA",9) == 2812147281) strcat(s, "C");
if (crc32("RzvTRsf",7) == 2123993179) strcat(s, "l");
if (crc32("jXBqgxmugZv",11) == 3274219908) strcat(s, "y");
    return s;
}

char *hushfully_adverbs() {
    char *s = calloc(10);
    if (crc32("KfOZNvIvxaakIIN",15) == 4040983740) strcat(s, "G");
if (crc32("YMiNAuxKLNipjr",14) == 3454596806) strcat(s, "h");
if (crc32("qEurR",5) == 1678514042) strcat(s, "u");
if (crc32("GFDsLE",6) == 1821874923) strcat(s, "s");
if (crc32("DLiouxMeegWXZ",13) == 3757846552) strcat(s, "O");
if (crc32("UNLfod",6) == 1063279857) strcat(s, "h");
if (crc32("ToNdKNmdgVud",12) == 2534141348) strcat(s, "U");
if (crc32("wTBidcTxyimG",12) == 1349986150) strcat(s, "f");
if (crc32("dxaoELbgr",9) == 3529864831) strcat(s, "u");
if (crc32("tyEfsBezIpH",11) == 1334972084) strcat(s, "l");
if (crc32("lGAss",5) == 3388088432) strcat(s, "o");
if (crc32("UUNOAxQsTT",10) == 2421634488) strcat(s, "l");
if (crc32("dDAXhIScJSA",11) == 2023739372) strcat(s, "y");
    return s;
}

char *ungrammatically_adverbs() {
    char *s = calloc(16);
    if (crc32("WrLVXgyfxLkGzDL",15) == 3741950773) strcat(s, "E");
if (crc32("rydLQFZd",8) == 4058819922) strcat(s, "u");
if (crc32("ZOIsTvQBzzGkr",13) == 1465232698) strcat(s, "A");
if (crc32("oTHgFhRFGSpH",12) == 2722413901) strcat(s, "n");
if (crc32("WjqFRCcOS",9) == 644872969) strcat(s, "g");
if (crc32("XkYZFKvMT",9) == 3694168159) strcat(s, "N");
if (crc32("zyDVYduDF",9) == 2195678255) strcat(s, "r");
if (crc32("jUkOJmx",7) == 3003921148) strcat(s, "l");
if (crc32("FEkZIZ",6) == 3755542569) strcat(s, "a");
if (crc32("jwtCnn",6) == 3218421629) strcat(s, "f");
if (crc32("amQaYV",6) == 3223131564) strcat(s, "m");
if (crc32("VsfDthJgrwM",11) == 319304790) strcat(s, "m");
if (crc32("zuDOoCZpAATw",12) == 3322841226) strcat(s, "a");
if (crc32("xnVMFnggMVGG",12) == 87513507) strcat(s, "F");
if (crc32("fnNBGYokL",9) == 3163229425) strcat(s, "t");
if (crc32("ZcjwWw",6) == 2092096799) strcat(s, "v");
if (crc32("mhvKWCd",7) == 1364538509) strcat(s, "i");
if (crc32("YjmqefxdtZekz",13) == 1567686256) strcat(s, "c");
if (crc32("jivChlYQeZNAyXP",15) == 71692549) strcat(s, "S");
if (crc32("reYErcMY",8) == 898392502) strcat(s, "a");
if (crc32("SDUpJOHqP",9) == 2285675363) strcat(s, "l");
if (crc32("YzTAcaK",7) == 3101342825) strcat(s, "l");
if (crc32("lRxvmx",6) == 1993973235) strcat(s, "z");
if (crc32("UmWjbd",6) == 2192400018) strcat(s, "y");
    return s;
}

char *mistakenly_adverbs() {
    char *s = calloc(11);
    if (crc32("VWirQy",6) == 2047146152) strcat(s, "m");
if (crc32("ZywOVWvA",8) == 3952840771) strcat(s, "i");
if (crc32("JddjuDh",7) == 1394456383) strcat(s, "s");
if (crc32("GZlylGLXMtDDlM",14) == 2284050402) strcat(s, "A");
if (crc32("aaxVecfizL",10) == 3697120180) strcat(s, "t");
if (crc32("GSxcuksLu",9) == 565518835) strcat(s, "a");
if (crc32("tbbluxdmy",9) == 3047289850) strcat(s, "d");
if (crc32("mcdkqTNRqtIa",12) == 1504766249) strcat(s, "k");
if (crc32("SczGJ",5) == 3079705065) strcat(s, "y");
if (crc32("pjCjj",5) == 734148679) strcat(s, "e");
if (crc32("qtbIakvAvC",10) == 2430979883) strcat(s, "n");
if (crc32("jCdqTkQXZBvg",12) == 599746796) strcat(s, "l");
if (crc32("GoMUmCeF",8) == 3031539309) strcat(s, "W");
if (crc32("VRsKpVH",7) == 2925507596) strcat(s, "y");
    return s;
}

char *nonsympathizingly_adverbs() {
    char *s = calloc(18);
    if (crc32("iUaQdPMsXQjLwj",14) == 767049708) strcat(s, "n");
if (crc32("LVIqVwqFKHpT",12) == 1638895710) strcat(s, "H");
if (crc32("TnaLuBKoCGxQ",12) == 246323938) strcat(s, "o");
if (crc32("sSfVXNIXQ",9) == 3624535687) strcat(s, "q");
if (crc32("snSGP",5) == 419493357) strcat(s, "n");
if (crc32("JnoCjEKVlJh",11) == 228754124) strcat(s, "s");
if (crc32("dPZOVE",6) == 798312914) strcat(s, "y");
if (crc32("rjzkME",6) == 4226457995) strcat(s, "T");
if (crc32("FhkkSQPqFTix",12) == 280050751) strcat(s, "m");
if (crc32("XcgrdUeGxmIkcb",14) == 3155887716) strcat(s, "p");
if (crc32("jXaYWmKAURam",12) == 1680408764) strcat(s, "h");
if (crc32("SsdVbhEfF",9) == 3977175068) strcat(s, "a");
if (crc32("kIrYRyaMUpVmeHA",15) == 2134223569) strcat(s, "t");
if (crc32("BbXuhVqEAycudi",14) == 1642110491) strcat(s, "h");
if (crc32("XSPyS",5) == 3669528556) strcat(s, "Q");
if (crc32("ZhMsv",5) == 2401574708) strcat(s, "i");
if (crc32("yuRMo",5) == 1067993285) strcat(s, "C");
if (crc32("cMpWVCes",8) == 3535253009) strcat(s, "z");
if (crc32("WKkGApxcdNt",11) == 109408624) strcat(s, "v");
if (crc32("QyHan",5) == 2097362097) strcat(s, "i");
if (crc32("qxdllnKcYbvflP",14) == 3460014337) strcat(s, "n");
if (crc32("vIxxuty",7) == 1830460775) strcat(s, "g");
if (crc32("qDaeGOlyeGrxxwL",15) == 1196924931) strcat(s, "r");
if (crc32("HquDaqc",7) == 2755150739) strcat(s, "l");
if (crc32("UqdgVsFPFG",10) == 3106032338) strcat(s, "y");
    return s;
}

char *undispassionately_adverbs() {
    char *s = calloc(18);
    if (crc32("PHRNdmn",7) == 1361917732) strcat(s, "u");
if (crc32("wegrpuIsQZcuWQg",15) == 4109172482) strcat(s, "n");
if (crc32("OiulHYMs",8) == 1032483843) strcat(s, "d");
if (crc32("VBKYxIi",7) == 3000528261) strcat(s, "a");
if (crc32("OOoEfi",6) == 2276616993) strcat(s, "i");
if (crc32("hXLXzVxgoMTsMoH",15) == 304970456) strcat(s, "M");
if (crc32("GGaYeXKUAEy",11) == 3603904108) strcat(s, "s");
if (crc32("zrpqaO",6) == 1021352119) strcat(s, "p");
if (crc32("XCaVtbTrOE",10) == 3810411588) strcat(s, "a");
if (crc32("NlMoxJKafRaDD",13) == 4113717450) strcat(s, "s");
if (crc32("gXYOVXft",8) == 3054637518) strcat(s, "s");
if (crc32("kCtbXmUowkEzrzW",15) == 3857915681) strcat(s, "P");
if (crc32("tiRBI",5) == 774449142) strcat(s, "i");
if (crc32("vJzJFevBEX",10) == 3551356539) strcat(s, "o");
if (crc32("cGFzHVHlB",9) == 977001071) strcat(s, "C");
if (crc32("aHiluy",6) == 1721475122) strcat(s, "n");
if (crc32("lMFGeu",6) == 1201519664) strcat(s, "s");
if (crc32("EWqin",5) == 1273858537) strcat(s, "a");
if (crc32("OSRwhiAKyGXBCRK",15) == 414777855) strcat(s, "t");
if (crc32("NTzLNTcM",8) == 4023842262) strcat(s, "e");
if (crc32("isvDhLPUVJYQoS",14) == 2220691031) strcat(s, "l");
if (crc32("BMZncTfHFWoIam",14) == 737437061) strcat(s, "y");
    return s;
}

char *stealthfully_adverbs() {
    char *s = calloc(13);
    if (crc32("JVmmKLhwnWNHoID",15) == 533463559) strcat(s, "k");
if (crc32("HcgagAq",7) == 1335378148) strcat(s, "s");
if (crc32("keAlgSSIYL",10) == 3456229094) strcat(s, "V");
if (crc32("oUkIcszDXImw",12) == 2552419100) strcat(s, "t");
if (crc32("oujiq",5) == 2699429504) strcat(s, "M");
if (crc32("xixYECU",7) == 2763194896) strcat(s, "e");
if (crc32("eRnihQ",6) == 1642835235) strcat(s, "S");
if (crc32("kuWudlyCV",9) == 2116877702) strcat(s, "a");
if (crc32("dHvQrrtvMh",10) == 3325489945) strcat(s, "l");
if (crc32("zmeMALfciym",11) == 3632293539) strcat(s, "t");
if (crc32("hlamP",5) == 947498865) strcat(s, "J");
if (crc32("GIYFw",5) == 3250748880) strcat(s, "h");
if (crc32("VuKUluUJl",9) == 1031317284) strcat(s, "f");
if (crc32("NgCVcshrKRDPdN",14) == 3147500114) strcat(s, "u");
if (crc32("yIaWQY",6) == 1539763236) strcat(s, "C");
if (crc32("AehzlILpJuR",11) == 2851720079) strcat(s, "l");
if (crc32("QZtEETI",7) == 2999309987) strcat(s, "l");
if (crc32("vzIrZBwoodrUfIH",15) == 548346234) strcat(s, "y");
    return s;
}

char *psychotherapeutically_adverbs() {
    char *s = calloc(22);
    if (crc32("bhCTXFHzwqYs",12) == 1106514686) strcat(s, "L");
if (crc32("pVeXUEjwkvm",11) == 3027137754) strcat(s, "p");
if (crc32("reDxAPKIPq",10) == 660785388) strcat(s, "s");
if (crc32("rCfzOY",6) == 3389444147) strcat(s, "y");
if (crc32("AUnQX",5) == 3678087821) strcat(s, "c");
if (crc32("TABlPJlujcrCHj",14) == 2482842162) strcat(s, "h");
if (crc32("UidNOuUejOuJn",13) == 3762826215) strcat(s, "o");
if (crc32("dpnhV",5) == 2898949448) strcat(s, "t");
if (crc32("ZgGHbCvjYYAP",12) == 1945074122) strcat(s, "h");
if (crc32("ylaeyqYi",8) == 339903761) strcat(s, "e");
if (crc32("dSYpEttat",9) == 3173598960) strcat(s, "J");
if (crc32("HkFsgR",6) == 4214911918) strcat(s, "r");
if (crc32("vtYHGU",6) == 207546777) strcat(s, "a");
if (crc32("iKEhL",5) == 3121258018) strcat(s, "p");
if (crc32("iROBpf",6) == 3882733508) strcat(s, "e");
if (crc32("erHUvQWRQKaKoTw",15) == 4094371008) strcat(s, "u");
if (crc32("cIcqI",5) == 549908262) strcat(s, "p");
if (crc32("QKGwdIHAf",9) == 3653781957) strcat(s, "t");
if (crc32("uQinWKO",7) == 3567624352) strcat(s, "y");
if (crc32("UTpVH",5) == 2997449843) strcat(s, "i");
if (crc32("MhTORrWA",8) == 3762294818) strcat(s, "M");
if (crc32("BdTvUcSwwg",10) == 2682332900) strcat(s, "c");
if (crc32("pTjlKRtNFvfdcgn",15) == 3183280772) strcat(s, "a");
if (crc32("BjDuKjtpTkBJYlU",15) == 3393031577) strcat(s, "l");
if (crc32("SFaCCl",6) == 2935866653) strcat(s, "p");
if (crc32("iZJnSziKZMmrsJM",15) == 346650573) strcat(s, "l");
if (crc32("AzREBmClZ",9) == 423705343) strcat(s, "Y");
if (crc32("vpvaWVBLkXjQ",12) == 860620168) strcat(s, "y");
    return s;
}

char *unsedately_adverbs() {
    char *s = calloc(11);
    if (crc32("umPWHlOKNvR",11) == 4114272717) strcat(s, "u");
if (crc32("TtKBkYEKXfhniT",14) == 1411478108) strcat(s, "D");
if (crc32("faqqakzOpgq",11) == 206116886) strcat(s, "n");
if (crc32("sjYgD",5) == 346757043) strcat(s, "s");
if (crc32("dPwQBYFrW",9) == 2643154500) strcat(s, "k");
if (crc32("wKCrWwGloa",10) == 2996445111) strcat(s, "e");
if (crc32("dUspaAKTbkpV",12) == 2585708034) strcat(s, "d");
if (crc32("AYSStUlqfl",10) == 1772134825) strcat(s, "K");
if (crc32("jqxnQTWpOnXi",12) == 2522748658) strcat(s, "a");
if (crc32("ZAfsptM",7) == 1247246987) strcat(s, "l");
if (crc32("hhdPtfgSgkCEGj",14) == 1733393470) strcat(s, "t");
if (crc32("tkuTHHBeRCPVjW",14) == 3933218482) strcat(s, "n");
if (crc32("GqtFIGsg",8) == 258506496) strcat(s, "e");
if (crc32("FMgrnETPl",9) == 3995136214) strcat(s, "l");
if (crc32("hcTuoom",7) == 2749831136) strcat(s, "u");
if (crc32("zIZCMKbARTL",11) == 458687297) strcat(s, "y");
    return s;
}

char *unplausibly_adverbs() {
    char *s = calloc(12);
    if (crc32("IOkjMc",6) == 2067598017) strcat(s, "u");
if (crc32("iXCpZJNXEYXxF",13) == 4127610357) strcat(s, "B");
if (crc32("dbuPtOwOZFa",11) == 580640601) strcat(s, "n");
if (crc32("aKsUwy",6) == 3182296631) strcat(s, "D");
if (crc32("NdxJXOdp",8) == 4145388075) strcat(s, "p");
if (crc32("DVXAKYqIIH",10) == 3340611823) strcat(s, "V");
if (crc32("IcmBlpHYiChZO",13) == 3703406386) strcat(s, "l");
if (crc32("geQDcqxrpZfUP",13) == 3280108085) strcat(s, "a");
if (crc32("tLwuokWCPRPyUc",14) == 3275063150) strcat(s, "u");
if (crc32("aQYMDYYL",8) == 3729772106) strcat(s, "Z");
if (crc32("evTLgr",6) == 909191940) strcat(s, "s");
if (crc32("yrlMLaPwaYOFv",13) == 2888813360) strcat(s, "i");
if (crc32("suEiVAUlIMpJTnM",15) == 303914217) strcat(s, "b");
if (crc32("YRuhBojLOjFWeCA",15) == 2008669941) strcat(s, "l");
if (crc32("IUruKbUY",8) == 2281210873) strcat(s, "y");
    return s;
}

char *furfuraceously_adverbs() {
    char *s = calloc(15);
    if (crc32("wfsAfOuXlZdstE",14) == 1069995988) strcat(s, "f");
if (crc32("ZFAKUCoCyc",10) == 1002470086) strcat(s, "u");
if (crc32("FehezaPMmhPyWUw",15) == 1903384832) strcat(s, "r");
if (crc32("jVUFYDfzvTF",11) == 850432770) strcat(s, "r");
if (crc32("zPLKYmjVMR",10) == 4273366086) strcat(s, "f");
if (crc32("BeMSaBm",7) == 3611527174) strcat(s, "u");
if (crc32("iiaEQcP",7) == 1072694121) strcat(s, "l");
if (crc32("AzlaBrpEW",9) == 1379598501) strcat(s, "r");
if (crc32("bBjpTNTrMkGR",12) == 3238692055) strcat(s, "a");
if (crc32("gAFEQ",5) == 1479732098) strcat(s, "C");
if (crc32("NNmzPknMyqEYUQ",14) == 3448110600) strcat(s, "c");
if (crc32("LicLKEuUCrNEYxj",15) == 4248823755) strcat(s, "B");
if (crc32("RvtnM",5) == 1783508862) strcat(s, "e");
if (crc32("ebxzLBmKIMtxj",13) == 3666218442) strcat(s, "J");
if (crc32("sKbHFaMXQ",9) == 3868685802) strcat(s, "o");
if (crc32("YZhvYLDB",8) == 143620208) strcat(s, "D");
if (crc32("MCDUyXON",8) == 1417592883) strcat(s, "u");
if (crc32("ffGIySeFsnr",11) == 4014569903) strcat(s, "o");
if (crc32("zetvlfXBRMQI",12) == 4028238654) strcat(s, "s");
if (crc32("yeGfwA",6) == 53401917) strcat(s, "r");
if (crc32("XTGqHikFmX",10) == 1430945466) strcat(s, "l");
if (crc32("OJUJzJktcrk",11) == 1185616021) strcat(s, "y");
    return s;
}

char *superartificially_adverbs() {
    char *s = calloc(18);
    if (crc32("KxAyWqSfBRwZNN",14) == 3841658749) strcat(s, "G");
if (crc32("hVzznRvadkenBNS",15) == 2477218983) strcat(s, "s");
if (crc32("YOTNIOc",7) == 3971338654) strcat(s, "u");
if (crc32("OMlQUkdLZFLlp",13) == 2842408454) strcat(s, "u");
if (crc32("sQuKVfrugwlUStb",15) == 2499368166) strcat(s, "p");
if (crc32("GjflCaD",7) == 1585559687) strcat(s, "C");
if (crc32("OvzCJuBwOB",10) == 1469101848) strcat(s, "e");
if (crc32("FvQbh",5) == 639172988) strcat(s, "r");
if (crc32("zdAIj",5) == 3252262412) strcat(s, "M");
if (crc32("WIJhgie",7) == 2078758011) strcat(s, "a");
if (crc32("SqhJklgjQNjDrja",15) == 2863252091) strcat(s, "q");
if (crc32("HpbquLnfR",9) == 3879679328) strcat(s, "r");
if (crc32("SbnmTl",6) == 3641676471) strcat(s, "t");
if (crc32("RrrNz",5) == 194644959) strcat(s, "V");
if (crc32("rwVMtNQtcUJ",11) == 3179483533) strcat(s, "i");
if (crc32("CKpDAPDaAKbZhL",14) == 4281599438) strcat(s, "s");
if (crc32("UjJnSHOjuFPu",12) == 1135380933) strcat(s, "f");
if (crc32("rHrch",5) == 1096571216) strcat(s, "i");
if (crc32("sFIarUZaYboJlU",14) == 1096912884) strcat(s, "c");
if (crc32("JrBzDfdJQg",10) == 533638577) strcat(s, "o");
if (crc32("YvToCEMMfVRYLTJ",15) == 4079299709) strcat(s, "i");
if (crc32("XFFlvjAVpGIuQFH",15) == 3508010025) strcat(s, "a");
if (crc32("ZztHpYQZ",8) == 3497243811) strcat(s, "h");
if (crc32("PhuxzIQeZvrdD",13) == 3610051457) strcat(s, "l");
if (crc32("DdwrwTXLSUChk",13) == 3611813527) strcat(s, "l");
if (crc32("uMYwH",5) == 3849989102) strcat(s, "y");
    return s;
}

char *fortuitously_adverbs() {
    char *s = calloc(13);
    if (crc32("WorDBVsKg",9) == 1282862101) strcat(s, "f");
if (crc32("WUlWnRUnNCPxFbb",15) == 792034279) strcat(s, "S");
if (crc32("ywobYF",6) == 181222358) strcat(s, "o");
if (crc32("tGtDQeplfxjnNY",14) == 883700007) strcat(s, "G");
if (crc32("UpBMcumHEKKnE",13) == 265187721) strcat(s, "r");
if (crc32("zWdVzRzhs",9) == 1753914728) strcat(s, "z");
if (crc32("qOpJfWawcB",10) == 3887724630) strcat(s, "t");
if (crc32("UDojlOPHbZR",11) == 370634606) strcat(s, "A");
if (crc32("QdbanUdG",8) == 983474832) strcat(s, "u");
if (crc32("LdtZxnaxx",9) == 1743144146) strcat(s, "r");
if (crc32("YdZigQJBpDlBBGf",15) == 1322451752) strcat(s, "i");
if (crc32("zkBakU",6) == 2181023236) strcat(s, "x");
if (crc32("OCsqiFQK",8) == 3656346410) strcat(s, "t");
if (crc32("NAcyu",5) == 958582886) strcat(s, "O");
if (crc32("pRfigKWbPqfFe",13) == 601424926) strcat(s, "o");
if (crc32("UDXtdEiEtYCUz",13) == 3438636349) strcat(s, "V");
if (crc32("ZTsjqbGUEMT",11) == 2412754068) strcat(s, "u");
if (crc32("pGgjUdq",7) == 1345620713) strcat(s, "s");
if (crc32("boFrWDsssuGUrPJ",15) == 562252058) strcat(s, "s");
if (crc32("lUfaGb",6) == 1977351751) strcat(s, "l");
if (crc32("oexuJ",5) == 1327172709) strcat(s, "y");
    return s;
}

char *tonnishly_adverbs() {
    char *s = calloc(10);
    if (crc32("JqxxHgpktwySH",13) == 4009912193) strcat(s, "t");
if (crc32("RzMkUKXnXZXO",12) == 1450177088) strcat(s, "o");
if (crc32("DNpQWBbeq",9) == 3174031208) strcat(s, "o");
if (crc32("cBhyY",5) == 2200165185) strcat(s, "n");
if (crc32("esHNWmlUKzYiY",13) == 4755539) strcat(s, "n");
if (crc32("VNaYWtNFQetDMIn",15) == 3807141797) strcat(s, "i");
if (crc32("rvVbAafXZWDmLH",14) == 4235620954) strcat(s, "R");
if (crc32("ruGqNNtVxAtnI",13) == 720791356) strcat(s, "s");
if (crc32("GRaFIhA",7) == 3390010121) strcat(s, "k");
if (crc32("RTVxkdgoG",9) == 3512110005) strcat(s, "h");
if (crc32("ngFaPf",6) == 3637926744) strcat(s, "Y");
if (crc32("djoaxtIzArnTV",13) == 1546259564) strcat(s, "l");
if (crc32("vqLFCFAGjzDo",12) == 1191157235) strcat(s, "N");
if (crc32("lbNokbzJmrn",11) == 2274030333) strcat(s, "y");
    return s;
}

char *flinchingly_adverbs() {
    char *s = calloc(12);
    if (crc32("qrJBX",5) == 424978978) strcat(s, "f");
if (crc32("ZRupOpAfEJHUcCB",15) == 3663685799) strcat(s, "x");
if (crc32("ahLtBRv",7) == 1872831978) strcat(s, "l");
if (crc32("EDPuBSdyrEboW",13) == 2902787081) strcat(s, "R");
if (crc32("xaNYyabv",8) == 2257078166) strcat(s, "i");
if (crc32("jTmsm",5) == 1537688518) strcat(s, "q");
if (crc32("mVrEWhziaMtA",12) == 1407922116) strcat(s, "n");
if (crc32("LwGze",5) == 806634910) strcat(s, "c");
if (crc32("dmuICBTb",8) == 172526435) strcat(s, "C");
if (crc32("HPdbWxyDihhJ",12) == 2774563406) strcat(s, "h");
if (crc32("WjQmdvGJcAR",11) == 1215204450) strcat(s, "i");
if (crc32("CAygPXoiNFXYeqO",15) == 3259181048) strcat(s, "n");
if (crc32("ZMQoLcGSz",9) == 804173731) strcat(s, "g");
if (crc32("MfMPumLcSoVNRUY",15) == 50963125) strcat(s, "l");
if (crc32("mmPnK",5) == 402693054) strcat(s, "y");
    return s;
}

char *quasigratefully_adverbs() {
    char *s = calloc(16);
    if (crc32("NtDus",5) == 694922967) strcat(s, "q");
if (crc32("LmxnHhteYmGKl",13) == 3979892253) strcat(s, "u");
if (crc32("ondvOgEqp",9) == 1151050918) strcat(s, "i");
if (crc32("DoHxAopwRyyhUT",14) == 3944956688) strcat(s, "a");
if (crc32("fCofbGlaxGXVmN",14) == 496008938) strcat(s, "F");
if (crc32("HgUeJ",5) == 3970232344) strcat(s, "s");
if (crc32("YKJxXNhwCMA",11) == 3082742452) strcat(s, "O");
if (crc32("izhfesGEK",9) == 2082475934) strcat(s, "i");
if (crc32("YXbSMGbIL",9) == 2603234976) strcat(s, "g");
if (crc32("cJiVDevmDg",10) == 2468144440) strcat(s, "l");
if (crc32("SfdBJ",5) == 3158576172) strcat(s, "r");
if (crc32("iKbwDyBYEqeyI",13) == 4023120781) strcat(s, "a");
if (crc32("UehoQSXEaEt",11) == 2209514808) strcat(s, "t");
if (crc32("OtPPbejS",8) == 3397643601) strcat(s, "c");
if (crc32("HmZGzQCLwRxbR",13) == 3954316504) strcat(s, "e");
if (crc32("TnOom",5) == 2062073430) strcat(s, "f");
if (crc32("izKjYITtfMeiZt",14) == 1609151311) strcat(s, "J");
if (crc32("yoyHPabjpYv",11) == 3112596215) strcat(s, "u");
if (crc32("FVhtNxU",7) == 2879162847) strcat(s, "l");
if (crc32("WVTuKeTmGuwjpF",14) == 2385186336) strcat(s, "i");
if (crc32("yTCQU",5) == 3169982369) strcat(s, "l");
if (crc32("SSuimgs",7) == 3927990538) strcat(s, "b");
if (crc32("iMrsglM",7) == 1185003268) strcat(s, "y");
    return s;
}

char *illhumoredly_adverbs() {
    char *s = calloc(13);
    if (crc32("ntKAvOZqiZXzq",13) == 4294645765) strcat(s, "r");
if (crc32("IgoHWPBGWrQ",11) == 713156834) strcat(s, "i");
if (crc32("bwCpUOdDBKj",11) == 104237518) strcat(s, "l");
if (crc32("DPHUptk",7) == 375559593) strcat(s, "h");
if (crc32("EqYGgBFfSt",10) == 3021860628) strcat(s, "l");
if (crc32("NrxtFatwosrFTi",14) == 749578388) strcat(s, "h");
if (crc32("GSGarcFXv",9) == 3502571560) strcat(s, "u");
if (crc32("tHkgsaLoGWgeSAX",15) == 401193651) strcat(s, "G");
if (crc32("byQpkxrRNiDlnCE",15) == 2933831199) strcat(s, "m");
if (crc32("BnWeburL",8) == 876375759) strcat(s, "o");
if (crc32("FGDAU",5) == 2460140627) strcat(s, "r");
if (crc32("tnlTiUjEEbcM",12) == 3788231763) strcat(s, "h");
if (crc32("KMJOVlinm",9) == 1610290549) strcat(s, "e");
if (crc32("NvwRIOFwkIPyC",13) == 1340923884) strcat(s, "z");
if (crc32("gGqUNbm",7) == 3884782884) strcat(s, "d");
if (crc32("LTZUHNQXBYiwb",13) == 1389145291) strcat(s, "B");
if (crc32("pVmytSCBcabbzRc",15) == 1618922973) strcat(s, "l");
if (crc32("HzzHGYq",7) == 2489155209) strcat(s, "y");
    return s;
}

char *quasiintuitively_adverbs() {
    char *s = calloc(17);
    if (crc32("JVxkJEGlo",9) == 3524439545) strcat(s, "u");
if (crc32("juCZPWRZymEQgfI",15) == 2920722923) strcat(s, "q");
if (crc32("DkrUxtRx",8) == 3699206455) strcat(s, "u");
if (crc32("TwbZroMI",8) == 1651808701) strcat(s, "a");
if (crc32("ysKkTHJtvEyvaj",14) == 265656971) strcat(s, "s");
if (crc32("UhgrnPnmpLxMXN",14) == 3992306698) strcat(s, "i");
if (crc32("EQgHAauC",8) == 732946015) strcat(s, "i");
if (crc32("MVUQXT",6) == 983464924) strcat(s, "n");
if (crc32("jXfkM",5) == 590493415) strcat(s, "N");
if (crc32("TuJKP",5) == 1387987348) strcat(s, "t");
if (crc32("pLDMnqYOc",9) == 1588342979) strcat(s, "u");
if (crc32("GFUYxt",6) == 1916269804) strcat(s, "H");
if (crc32("PxrnB",5) == 1684236814) strcat(s, "i");
if (crc32("NeQDbUm",7) == 2147011864) strcat(s, "t");
if (crc32("LjbCm",5) == 2898152287) strcat(s, "i");
if (crc32("VdoUaIKc",8) == 1965537374) strcat(s, "q");
if (crc32("bJxSVjxLV",9) == 515008400) strcat(s, "v");
if (crc32("DavdJjUkzCNb",12) == 3171951975) strcat(s, "e");
if (crc32("oPrtWiMoCatdez",14) == 3470491461) strcat(s, "l");
if (crc32("eMNRcY",6) == 17606486) strcat(s, "y");
    return s;
}

char *tonally_adverbs() {
    char *s = calloc(8);
    if (crc32("ESPaEEvvueJ",11) == 1673623421) strcat(s, "w");
if (crc32("prtlqBWNwkJTL",13) == 3707019233) strcat(s, "t");
if (crc32("iUwLirq",7) == 943472167) strcat(s, "o");
if (crc32("nnnJDbPLsgjrl",13) == 4278844948) strcat(s, "n");
if (crc32("xhJHxCF",7) == 4104535476) strcat(s, "a");
if (crc32("ligJVEA",7) == 1022447894) strcat(s, "Y");
if (crc32("PWbFGTF",7) == 3322071802) strcat(s, "l");
if (crc32("yqDAamURTagcU",13) == 1013979499) strcat(s, "V");
if (crc32("haUMUFGzi",9) == 88071178) strcat(s, "l");
if (crc32("lTHoIwsTrzF",11) == 1451462468) strcat(s, "X");
if (crc32("CxHqU",5) == 609643587) strcat(s, "y");
    return s;
}

char *hypernormally_adverbs() {
    char *s = calloc(14);
    if (crc32("SzfhogSwg",9) == 4232492200) strcat(s, "h");
if (crc32("JxZPBvC",7) == 3328587225) strcat(s, "y");
if (crc32("YpuCUuZCdZG",11) == 3039423627) strcat(s, "p");
if (crc32("rmkwrESycESbE",13) == 2873346756) strcat(s, "g");
if (crc32("zuNLpKoui",9) == 2616254851) strcat(s, "e");
if (crc32("aPGeHO",6) == 3172549451) strcat(s, "U");
if (crc32("ucQgqPGQvXt",11) == 3416278484) strcat(s, "r");
if (crc32("ujRLZEJKohROeX",14) == 1957900976) strcat(s, "n");
if (crc32("bVEKesFEpBmUg",13) == 2741461861) strcat(s, "o");
if (crc32("GkwmhmrwLJQIVVh",15) == 3983813032) strcat(s, "m");
if (crc32("mddMaLtKxzWWXa",14) == 1495722536) strcat(s, "r");
if (crc32("dmhIzWOBQKg",11) == 1643310938) strcat(s, "m");
if (crc32("atYIsfOWIvwUtxo",15) == 3408606468) strcat(s, "a");
if (crc32("yQLZIXzLygglSf",14) == 873691842) strcat(s, "K");
if (crc32("BugZctxqRpVTnWq",15) == 3210634370) strcat(s, "l");
if (crc32("FKMnJpl",7) == 2995004873) strcat(s, "l");
if (crc32("efDwuvmpHziOTU",14) == 241518302) strcat(s, "x");
if (crc32("SGrHUUvPGR",10) == 651065109) strcat(s, "y");
    return s;
}

char *multisonorously_adverbs() {
    char *s = calloc(16);
    if (crc32("UXITJlWuPlcUZJ",14) == 3553884885) strcat(s, "k");
if (crc32("rdluLbiNmxt",11) == 2463991382) strcat(s, "m");
if (crc32("WeHQb",5) == 568479326) strcat(s, "X");
if (crc32("GDRlFulrjpN",11) == 3265180579) strcat(s, "u");
if (crc32("vNwAnp",6) == 1192498214) strcat(s, "n");
if (crc32("rJUDWcTvHimWf",13) == 3960427123) strcat(s, "l");
if (crc32("BueNEYqKmwste",13) == 4244060939) strcat(s, "m");
if (crc32("DItVLwQkVXYsiz",14) == 845227258) strcat(s, "t");
if (crc32("JlPkh",5) == 206408440) strcat(s, "i");
if (crc32("INeoNhARp",9) == 948059961) strcat(s, "s");
if (crc32("SWbhZpHzvoXMYu",14) == 3344430107) strcat(s, "o");
if (crc32("fUXQnrRav",9) == 1322432682) strcat(s, "n");
if (crc32("HIqLu",5) == 1630369023) strcat(s, "o");
if (crc32("YqsJO",5) == 2630599961) strcat(s, "m");
if (crc32("JPSBxwSI",8) == 924883086) strcat(s, "r");
if (crc32("VZxHHOqB",8) == 2567244632) strcat(s, "s");
if (crc32("zwGomXJIcUqTR",13) == 3482435643) strcat(s, "o");
if (crc32("sGWoVboT",8) == 1774543262) strcat(s, "a");
if (crc32("ZRlQnaQVJWERQ",13) == 2437263193) strcat(s, "u");
if (crc32("LhDEIBRoLEO",11) == 540495434) strcat(s, "A");
if (crc32("IHngTZy",7) == 759143273) strcat(s, "s");
if (crc32("tjgvYzMXQ",9) == 3200967516) strcat(s, "l");
if (crc32("mYXEL",5) == 2512166725) strcat(s, "f");
if (crc32("oCWJohNHQtCQhBq",15) == 1700663171) strcat(s, "y");
    return s;
}

char *dissipatedly_adverbs() {
    char *s = calloc(13);
    if (crc32("bKaaKUFKWpvhtTz",15) == 2029829921) strcat(s, "d");
if (crc32("MfAwPbaefVdx",12) == 404684535) strcat(s, "j");
if (crc32("PxFGvSLYWyhYt",13) == 1892185257) strcat(s, "i");
if (crc32("GtUVUKRz",8) == 218921423) strcat(s, "s");
if (crc32("yCroikknGleGRu",14) == 2751760429) strcat(s, "s");
if (crc32("ZgxvnNs",7) == 2412368448) strcat(s, "z");
if (crc32("NSZDGDPiIcb",11) == 240010017) strcat(s, "i");
if (crc32("IsOzFppZqOJc",12) == 1955471971) strcat(s, "j");
if (crc32("zfaNXWyk",8) == 3613946926) strcat(s, "p");
if (crc32("gOFQc",5) == 3402908003) strcat(s, "f");
if (crc32("hiBpXlTehnyJT",13) == 410313800) strcat(s, "a");
if (crc32("lucGugb",7) == 1128656685) strcat(s, "V");
if (crc32("ZRSBRKbbTItU",12) == 3015405146) strcat(s, "t");
if (crc32("AbMZGjkvRdks",12) == 762532199) strcat(s, "e");
if (crc32("EzYRnn",6) == 1226579203) strcat(s, "y");
if (crc32("eDKeZzfZjIKaQz",14) == 1961203245) strcat(s, "d");
if (crc32("ArrDXLwj",8) == 3242964767) strcat(s, "D");
if (crc32("CriSn",5) == 1692209140) strcat(s, "l");
if (crc32("kqHxDUCwN",9) == 439787341) strcat(s, "y");
    return s;
}

char *nonulcerously_adverbs() {
    char *s = calloc(14);
    if (crc32("SVRqYWSa",8) == 263172102) strcat(s, "n");
if (crc32("oOjTJscLpyHV",12) == 1909539420) strcat(s, "o");
if (crc32("WilnggFp",8) == 1620353325) strcat(s, "n");
if (crc32("uPGsvxEsxZvhJfm",15) == 2495693761) strcat(s, "u");
if (crc32("MGCziLuSelRfmR",14) == 2612672353) strcat(s, "i");
if (crc32("ruxZA",5) == 45934892) strcat(s, "l");
if (crc32("CNaIBDhytfwBsb",14) == 1923923051) strcat(s, "c");
if (crc32("ufQOZphFTyQJd",13) == 1705406443) strcat(s, "e");
if (crc32("tePNuRSi",8) == 3923423365) strcat(s, "r");
if (crc32("xGOocWQAyyXRuwL",15) == 2570962871) strcat(s, "o");
if (crc32("yjvXeOpEBowtb",13) == 3812427586) strcat(s, "y");
if (crc32("KSbrXBK",7) == 844104201) strcat(s, "u");
if (crc32("iGlHoXpPTGmSMD",14) == 4255998418) strcat(s, "a");
if (crc32("YpeXXbAETmP",11) == 1121511752) strcat(s, "s");
if (crc32("BcyJgtjYN",9) == 1828161255) strcat(s, "k");
if (crc32("SrCAQcA",7) == 3610611898) strcat(s, "l");
if (crc32("npvXebpIrMgj",12) == 665661901) strcat(s, "I");
if (crc32("sYcNZroGGr",10) == 1408312640) strcat(s, "y");
    return s;
}

char *kenogenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("ICOlBnutEuThfA",14) == 2317552928) strcat(s, "k");
if (crc32("tBGIyRezz",9) == 937367222) strcat(s, "e");
if (crc32("spVVdqHFfmFQ",12) == 2909413392) strcat(s, "n");
if (crc32("JZSCLHWiZuSxE",13) == 1462544557) strcat(s, "j");
if (crc32("prOxiLIiugUOZzh",15) == 520636326) strcat(s, "o");
if (crc32("KelBN",5) == 4146063904) strcat(s, "g");
if (crc32("biXdOym",7) == 2762026457) strcat(s, "e");
if (crc32("KVLCTVBXISr",11) == 3292614327) strcat(s, "n");
if (crc32("enCaDAjCMv",10) == 3891014353) strcat(s, "b");
if (crc32("MvhQFvFmhOuFCJA",15) == 2481075156) strcat(s, "e");
if (crc32("kODSLNNvHCFfOb",14) == 49497355) strcat(s, "e");
if (crc32("ambwhfGpFiJIpEb",15) == 2403140366) strcat(s, "t");
if (crc32("qIaYvFxhkJP",11) == 1929627527) strcat(s, "i");
if (crc32("WOkombcvGDrH",12) == 2242006149) strcat(s, "i");
if (crc32("tVHsEQ",6) == 257403110) strcat(s, "c");
if (crc32("SLPShI",6) == 2701715810) strcat(s, "a");
if (crc32("vyZytkOohM",10) == 3356397527) strcat(s, "p");
if (crc32("YbrRAtUO",8) == 1722044653) strcat(s, "l");
if (crc32("LMEEgUWPXDHzsGa",15) == 2515133694) strcat(s, "W");
if (crc32("vrhVURhQYs",10) == 2861189478) strcat(s, "l");
if (crc32("lcToKQ",6) == 409174107) strcat(s, "y");
    return s;
}

char *untimorously_adverbs() {
    char *s = calloc(13);
    if (crc32("sdtpE",5) == 3060072755) strcat(s, "u");
if (crc32("mIAMQbqmI",9) == 1285830648) strcat(s, "c");
if (crc32("zqSmwLqv",8) == 4181667892) strcat(s, "n");
if (crc32("sizAENFYIRcPY",13) == 2725696831) strcat(s, "t");
if (crc32("OdAnGhidgif",11) == 3802670988) strcat(s, "i");
if (crc32("tKZSKHhowCzo",12) == 1009141626) strcat(s, "m");
if (crc32("qJpiefBD",8) == 18971442) strcat(s, "q");
if (crc32("xhyjSqL",7) == 564235321) strcat(s, "o");
if (crc32("aqrDN",5) == 1816934852) strcat(s, "V");
if (crc32("MUNYSCGq",8) == 2505573214) strcat(s, "r");
if (crc32("rvmypDnIx",9) == 1151848971) strcat(s, "o");
if (crc32("qzjHyltMlZHPNtG",15) == 4285179695) strcat(s, "T");
if (crc32("JeJWQYZv",8) == 3387901168) strcat(s, "u");
if (crc32("OblfTXNbOogF",12) == 3655297096) strcat(s, "A");
if (crc32("pkspVVjlZ",9) == 319427651) strcat(s, "s");
if (crc32("xqbIVExagLKNxY",14) == 1061828233) strcat(s, "l");
if (crc32("URoCznKpXIzXN",13) == 3303918174) strcat(s, "y");
    return s;
}

char *comedically_adverbs() {
    char *s = calloc(12);
    if (crc32("cSxkmPp",7) == 572283976) strcat(s, "c");
if (crc32("jSKoQUQjZtoRb",13) == 908974040) strcat(s, "R");
if (crc32("ocGkGTsGZ",9) == 346415712) strcat(s, "o");
if (crc32("FtODhZpaxg",10) == 495341744) strcat(s, "m");
if (crc32("gcCYqICtscVROtf",15) == 4054442792) strcat(s, "B");
if (crc32("RKlDHfXETYerdZT",15) == 1335333238) strcat(s, "e");
if (crc32("EUjrrHGogPuRGy",14) == 3863481203) strcat(s, "h");
if (crc32("mbmsPCDUsyS",11) == 196594314) strcat(s, "d");
if (crc32("JModcrJxWHDFgS",14) == 89147701) strcat(s, "O");
if (crc32("ngJLuOlGPAUjmDn",15) == 1733792819) strcat(s, "i");
if (crc32("AgjMYBIyiTjaSB",14) == 2081813112) strcat(s, "s");
if (crc32("DNqOlHqzBXVYdiw",15) == 848816233) strcat(s, "c");
if (crc32("CjSuicdicp",10) == 552206817) strcat(s, "f");
if (crc32("AVmQSVLQlYBTAo",14) == 665234996) strcat(s, "a");
if (crc32("gBBzzuSj",8) == 2476440175) strcat(s, "R");
if (crc32("UiWcHWKPvEjRW",13) == 1473157390) strcat(s, "l");
if (crc32("MvylLxfvXw",10) == 3077840116) strcat(s, "l");
if (crc32("jjhFYOBrDenbvj",14) == 2122859934) strcat(s, "y");
    return s;
}

char *gratingly_adverbs() {
    char *s = calloc(10);
    if (crc32("LbUwc",5) == 347885141) strcat(s, "g");
if (crc32("ZgLQqdYOTkxo",12) == 1445119668) strcat(s, "x");
if (crc32("lQIBHbAeKKEsHhl",15) == 965013912) strcat(s, "r");
if (crc32("OCJnFPjnzmlmW",13) == 1362172147) strcat(s, "L");
if (crc32("efSTF",5) == 2788117475) strcat(s, "a");
if (crc32("pQOrbbE",7) == 4246277934) strcat(s, "o");
if (crc32("oAqeOFSsblgzf",13) == 1520082858) strcat(s, "t");
if (crc32("pSXrzZOCnY",10) == 592483434) strcat(s, "i");
if (crc32("gKEKsc",6) == 3393527154) strcat(s, "w");
if (crc32("rTQBwKfyMPs",11) == 877131513) strcat(s, "n");
if (crc32("ByJOkUghoHgyBXl",15) == 2551693245) strcat(s, "a");
if (crc32("qQvvgJqEwW",10) == 1304326749) strcat(s, "g");
if (crc32("RiBGfykgsDOpa",13) == 3849702414) strcat(s, "l");
if (crc32("bWOBgg",6) == 936248439) strcat(s, "y");
    return s;
}

char *imbecilely_adverbs() {
    char *s = calloc(11);
    if (crc32("SpboVx",6) == 2727447420) strcat(s, "i");
if (crc32("agKTYgxSiIrVNS",14) == 1526052453) strcat(s, "u");
if (crc32("bMCmnCcElwoM",12) == 511095243) strcat(s, "m");
if (crc32("IAbrukfkEXxC",12) == 1367780124) strcat(s, "b");
if (crc32("ngpbwxBhqqY",11) == 1540120964) strcat(s, "e");
if (crc32("QfumejtycUJatcd",15) == 2734141294) strcat(s, "e");
if (crc32("leKrPT",6) == 1392196868) strcat(s, "c");
if (crc32("SLigmYLQ",8) == 1566582196) strcat(s, "q");
if (crc32("AjFLAaXfiWE",11) == 3935194769) strcat(s, "i");
if (crc32("OKCcEgxcr",9) == 1296502814) strcat(s, "c");
if (crc32("brHZTw",6) == 1490098982) strcat(s, "l");
if (crc32("wOTxtGDW",8) == 3755688263) strcat(s, "e");
if (crc32("pfMwLetiysn",11) == 2764218662) strcat(s, "l");
if (crc32("hqBpQbOzrlWSYNG",15) == 1123526690) strcat(s, "K");
if (crc32("sUYAvjbdPoyBcB",14) == 2666445399) strcat(s, "y");
    return s;
}

char *slopingly_adverbs() {
    char *s = calloc(10);
    if (crc32("aRJqaDJ",7) == 2065839450) strcat(s, "s");
if (crc32("RgpOFVr",7) == 546286358) strcat(s, "l");
if (crc32("LxBIHpyCB",9) == 84169389) strcat(s, "t");
if (crc32("UAKCDj",6) == 2410260476) strcat(s, "o");
if (crc32("HXvYbg",6) == 4086217225) strcat(s, "p");
if (crc32("vfpqAq",6) == 1114308846) strcat(s, "T");
if (crc32("oYhfaQhQySThbN",14) == 1508431031) strcat(s, "i");
if (crc32("YhszbRmfIeNKmmv",15) == 2205248426) strcat(s, "f");
if (crc32("ExSlyZnUQzkW",12) == 3504741227) strcat(s, "n");
if (crc32("IASxBrPbWXthZL",14) == 1796931601) strcat(s, "d");
if (crc32("NzJhgiRLn",9) == 1037517631) strcat(s, "g");
if (crc32("bIZdbzBbUOk",11) == 1605312497) strcat(s, "C");
if (crc32("ejlXwMnaa",9) == 999002368) strcat(s, "l");
if (crc32("aPgiAFYAwcTm",12) == 945581571) strcat(s, "n");
if (crc32("ZqtYseamBOZV",12) == 1656400536) strcat(s, "y");
    return s;
}

char *nongrievously_adverbs() {
    char *s = calloc(14);
    if (crc32("NdapqnMI",8) == 1374018172) strcat(s, "p");
if (crc32("foPZJFwDOTVDqnY",15) == 374173660) strcat(s, "n");
if (crc32("pauHnfHfoUhOtG",14) == 3718224447) strcat(s, "T");
if (crc32("SIzoxZpKPnzvpIg",15) == 1505180875) strcat(s, "o");
if (crc32("ACdnECDwwGH",11) == 3158455631) strcat(s, "w");
if (crc32("jlMAcNSGGVs",11) == 2122912871) strcat(s, "n");
if (crc32("dlNdTMtsGa",10) == 4269870921) strcat(s, "z");
if (crc32("wtkvEL",6) == 3850897614) strcat(s, "g");
if (crc32("HknXFqbWSlShjen",15) == 3469500293) strcat(s, "r");
if (crc32("vRzHGsq",7) == 3902139381) strcat(s, "i");
if (crc32("ZWMKLcC",7) == 1068584678) strcat(s, "e");
if (crc32("JhkimhKySJ",10) == 2997768774) strcat(s, "D");
if (crc32("GqUZqWQ",7) == 878202118) strcat(s, "v");
if (crc32("ztVHvZQSftsdMBo",15) == 4070210630) strcat(s, "r");
if (crc32("SkaIzyGSN",9) == 4122158904) strcat(s, "o");
if (crc32("HICTsoVB",8) == 444585529) strcat(s, "X");
if (crc32("pFoqaPVYy",9) == 18272929) strcat(s, "u");
if (crc32("MzcxJjqOSZ",10) == 2743888294) strcat(s, "s");
if (crc32("lyRHKxW",7) == 635556216) strcat(s, "Z");
if (crc32("azAfEKEF",8) == 565788358) strcat(s, "l");
if (crc32("AnZexmWEhg",10) == 4121399201) strcat(s, "B");
if (crc32("wLRWS",5) == 884088132) strcat(s, "y");
    return s;
}

char *popularly_adverbs() {
    char *s = calloc(10);
    if (crc32("MbePZZxJd",9) == 1117929223) strcat(s, "p");
if (crc32("QiouknyFu",9) == 3661561331) strcat(s, "d");
if (crc32("FySbY",5) == 740345214) strcat(s, "o");
if (crc32("XfEoLZU",7) == 2188951684) strcat(s, "p");
if (crc32("qWtPUslwNT",10) == 662576865) strcat(s, "u");
if (crc32("xbWvU",5) == 2503483557) strcat(s, "l");
if (crc32("DnXeDiweQmwrwom",15) == 3837533174) strcat(s, "l");
if (crc32("pqznpxXVYW",10) == 779907410) strcat(s, "a");
if (crc32("DQsTpRReIT",10) == 3487825767) strcat(s, "r");
if (crc32("cPSbyFFfJfrld",13) == 638583413) strcat(s, "l");
if (crc32("KpLyEcYClA",10) == 4294747632) strcat(s, "y");
    return s;
}

char *muddlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("ZHWwzIPzeZrBioK",15) == 3684152432) strcat(s, "m");
if (crc32("zqdsjsRKl",9) == 2534862988) strcat(s, "B");
if (crc32("JidNAD",6) == 3719341766) strcat(s, "u");
if (crc32("wiGOIRdph",9) == 1659338340) strcat(s, "e");
if (crc32("xKecEfG",7) == 4068166772) strcat(s, "d");
if (crc32("FbzItudaIHkaWru",15) == 924886892) strcat(s, "d");
if (crc32("HklWLxQkOTTZ",12) == 2525619201) strcat(s, "l");
if (crc32("SijTewrgswo",11) == 3695964889) strcat(s, "V");
if (crc32("RlJeQ",5) == 2364200347) strcat(s, "i");
if (crc32("aoFXW",5) == 4065307852) strcat(s, "n");
if (crc32("WBhFGgEFtOKbgG",14) == 3836536825) strcat(s, "l");
if (crc32("xjExvZgeVlhReSx",15) == 2894155540) strcat(s, "g");
if (crc32("YTUFcr",6) == 2089303715) strcat(s, "w");
if (crc32("lWXtEQaqeyWNLDa",15) == 4014678253) strcat(s, "l");
if (crc32("RljYBUGxGBiO",12) == 1001291296) strcat(s, "U");
if (crc32("gGwjSMFz",8) == 1275896279) strcat(s, "y");
    return s;
}

char *transcendingly_adverbs() {
    char *s = calloc(15);
    if (crc32("Weisyn",6) == 3052765617) strcat(s, "t");
if (crc32("ybpKwkVqT",9) == 888549351) strcat(s, "r");
if (crc32("wtIYdjeCO",9) == 3955344299) strcat(s, "a");
if (crc32("YycMWXQtDydw",12) == 1609780431) strcat(s, "t");
if (crc32("aFnhOe",6) == 1927089152) strcat(s, "n");
if (crc32("KsPiIQJCcxIuxFM",15) == 2480767655) strcat(s, "Q");
if (crc32("BKvRDSrGgB",10) == 377524567) strcat(s, "s");
if (crc32("fdYVzD",6) == 2038995638) strcat(s, "c");
if (crc32("XXdlir",6) == 1949339972) strcat(s, "C");
if (crc32("OOMVllyUvs",10) == 2421185514) strcat(s, "e");
if (crc32("NNFRHKcx",8) == 3836913617) strcat(s, "n");
if (crc32("haYaKEauxTIPFlo",15) == 2285436909) strcat(s, "D");
if (crc32("ROEgRH",6) == 1006584857) strcat(s, "d");
if (crc32("DgejEeCv",8) == 2377906459) strcat(s, "i");
if (crc32("tRbNEy",6) == 1278907280) strcat(s, "U");
if (crc32("xwuyDiJED",9) == 4084547248) strcat(s, "n");
if (crc32("snVdnAuANb",10) == 2196798497) strcat(s, "k");
if (crc32("xKFMW",5) == 2270857026) strcat(s, "g");
if (crc32("kCnxeeXe",8) == 549632074) strcat(s, "u");
if (crc32("zLLwWYY",7) == 3594027033) strcat(s, "l");
if (crc32("wDRegaKvaErl",12) == 2930228894) strcat(s, "y");
    return s;
}

char *hyperdiabolically_adverbs() {
    char *s = calloc(18);
    if (crc32("FeUECf",6) == 1472325426) strcat(s, "J");
if (crc32("ysJzmilCs",9) == 2785932978) strcat(s, "h");
if (crc32("GXZlJbCFIKifVhm",15) == 3650760009) strcat(s, "b");
if (crc32("wlEuUbVvIO",10) == 1410786970) strcat(s, "y");
if (crc32("SuehbKfnCaaXq",13) == 357838092) strcat(s, "T");
if (crc32("iEMjsH",6) == 1577125257) strcat(s, "p");
if (crc32("SjReReYD",8) == 3020538960) strcat(s, "e");
if (crc32("OckgSsDTtET",11) == 3566752117) strcat(s, "r");
if (crc32("gtcEWdzPsnCmnJh",15) == 1627651205) strcat(s, "d");
if (crc32("NuDqunSD",8) == 1234259109) strcat(s, "d");
if (crc32("XyCzNJsJT",9) == 1390627053) strcat(s, "S");
if (crc32("aUIsFJzLNP",10) == 3186212555) strcat(s, "i");
if (crc32("GNIHWsObvzmtL",13) == 4077221889) strcat(s, "a");
if (crc32("PPPOzbeMfQ",10) == 3399748961) strcat(s, "F");
if (crc32("ttpEi",5) == 3283913781) strcat(s, "b");
if (crc32("kDoPp",5) == 2508447326) strcat(s, "o");
if (crc32("VGhXLrkpiDik",12) == 2644274776) strcat(s, "l");
if (crc32("DJNYT",5) == 2036860147) strcat(s, "O");
if (crc32("IaSwgDHCP",9) == 2108766969) strcat(s, "i");
if (crc32("ePiXjMUt",8) == 1159288665) strcat(s, "c");
if (crc32("BkMCxsxDVucWIOS",15) == 1247568172) strcat(s, "O");
if (crc32("TbylYOSJpzw",11) == 565120849) strcat(s, "a");
if (crc32("rwgRer",6) == 2150519287) strcat(s, "W");
if (crc32("TGeJK",5) == 2834745550) strcat(s, "l");
if (crc32("qKXTmrHvfiEcFe",14) == 3056371243) strcat(s, "l");
if (crc32("ZMyUmthgtYAfud",14) == 2368131971) strcat(s, "n");
if (crc32("RjsnHsICgNjjf",13) == 1035579905) strcat(s, "y");
    return s;
}

char *ostentatiously_adverbs() {
    char *s = calloc(15);
    if (crc32("gdoSTA",6) == 439537958) strcat(s, "o");
if (crc32("gmpebJWHlSeKK",13) == 4122050439) strcat(s, "s");
if (crc32("kXVJrfOQj",9) == 3093570557) strcat(s, "t");
if (crc32("BJTFqiXXcmhf",12) == 2015248672) strcat(s, "e");
if (crc32("ShJdMqknc",9) == 1136683376) strcat(s, "T");
if (crc32("xDswyhaSooMw",12) == 2862322893) strcat(s, "n");
if (crc32("jHCxQlAhkLOmoVc",15) == 2199578249) strcat(s, "t");
if (crc32("ZnQjThftK",9) == 981293529) strcat(s, "X");
if (crc32("vslyArXTxA",10) == 3948940042) strcat(s, "a");
if (crc32("TwmuBdfbn",9) == 953570903) strcat(s, "h");
if (crc32("rFKCmUcnji",10) == 966086184) strcat(s, "t");
if (crc32("aonnugEC",8) == 1673773607) strcat(s, "i");
if (crc32("itYEXnTVKUo",11) == 1729052769) strcat(s, "o");
if (crc32("cXfkfScqIy",10) == 119819796) strcat(s, "b");
if (crc32("mvaVphZAqmeArtU",15) == 3457977065) strcat(s, "u");
if (crc32("iXsoYriyotJ",11) == 1235582084) strcat(s, "x");
if (crc32("RAYxYvCgLzQ",11) == 4190236606) strcat(s, "s");
if (crc32("wRnZsVlGUvvk",12) == 3675437454) strcat(s, "l");
if (crc32("dPplHpNV",8) == 2736095706) strcat(s, "y");
    return s;
}

char *diffusedly_adverbs() {
    char *s = calloc(11);
    if (crc32("NKRmjwtPTaEpKaX",15) == 4126274962) strcat(s, "d");
if (crc32("ODfNwkULDI",10) == 3950396012) strcat(s, "i");
if (crc32("HDLDRG",6) == 970915415) strcat(s, "f");
if (crc32("IjNsgBbwCAsff",13) == 3402096406) strcat(s, "f");
if (crc32("BeeZumDoXtnX",12) == 340374463) strcat(s, "u");
if (crc32("QlWmUPH",7) == 2353837812) strcat(s, "s");
if (crc32("BTVAWmbC",8) == 3364829993) strcat(s, "e");
if (crc32("wFPllCHcprxaVU",14) == 3513314424) strcat(s, "d");
if (crc32("TycsQyGxuWxHN",13) == 2412363169) strcat(s, "l");
if (crc32("mZquaexxiuEVBi",14) == 1294165087) strcat(s, "y");
    return s;
}

char *anachronistically_adverbs() {
    char *s = calloc(18);
    if (crc32("bIlPatHmZby",11) == 3982846978) strcat(s, "a");
if (crc32("fLPAgQNpXraqH",13) == 4115776746) strcat(s, "r");
if (crc32("kuDLsxK",7) == 1675427824) strcat(s, "n");
if (crc32("DOeGEbs",7) == 4051067292) strcat(s, "S");
if (crc32("EawvL",5) == 2182749532) strcat(s, "a");
if (crc32("lKIRMkd",7) == 882309103) strcat(s, "c");
if (crc32("UDyKkvjDW",9) == 3952609899) strcat(s, "h");
if (crc32("btvxnuoMsWuiKc",14) == 3275548422) strcat(s, "E");
if (crc32("rRmAkFKfDAvsLae",15) == 3028376835) strcat(s, "r");
if (crc32("JVDghIzmJGqlQYM",15) == 994800804) strcat(s, "a");
if (crc32("IRXUcJiL",8) == 1751103934) strcat(s, "o");
if (crc32("uXaQeyefISNPh",13) == 4161883836) strcat(s, "n");
if (crc32("nmcwhxLOTnchVu",14) == 600420) strcat(s, "i");
if (crc32("aDNJcCZkTWZJjZm",15) == 1232494598) strcat(s, "s");
if (crc32("cryPOZv",7) == 3705865210) strcat(s, "t");
if (crc32("rArHlb",6) == 1206971424) strcat(s, "i");
if (crc32("wAtVlhwVmJ",10) == 1478371034) strcat(s, "c");
if (crc32("tIVNhzhzhb",10) == 399354437) strcat(s, "a");
if (crc32("RXhwddLUoKE",11) == 462435418) strcat(s, "e");
if (crc32("PnZWanfVVd",10) == 3645062306) strcat(s, "l");
if (crc32("lwkYDzfw",8) == 743431241) strcat(s, "l");
if (crc32("JWATKILzIUp",11) == 771564670) strcat(s, "n");
if (crc32("roWqEmJlqYb",11) == 3354399381) strcat(s, "y");
    return s;
}

char *peripherally_adverbs() {
    char *s = calloc(13);
    if (crc32("sUiYKhvdMCkVJYW",15) == 3829414109) strcat(s, "p");
if (crc32("qaSzvvzgMp",10) == 3582545645) strcat(s, "e");
if (crc32("StRyfWRXO",9) == 2788857493) strcat(s, "r");
if (crc32("BmVGTjBX",8) == 1915714093) strcat(s, "i");
if (crc32("RUbxUlwsHDzCr",13) == 380681121) strcat(s, "C");
if (crc32("ISohiCN",7) == 774056451) strcat(s, "p");
if (crc32("XDpHMI",6) == 1945772339) strcat(s, "k");
if (crc32("jqtFOlFNTw",10) == 3143044449) strcat(s, "h");
if (crc32("MwDBfxUhnLBMLX",14) == 2948611490) strcat(s, "Q");
if (crc32("yTHcI",5) == 1238823038) strcat(s, "e");
if (crc32("CaZALYZTkER",11) == 302868201) strcat(s, "m");
if (crc32("udLHaxrACxpm",12) == 3913144946) strcat(s, "r");
if (crc32("IXuPuns",7) == 911591751) strcat(s, "a");
if (crc32("cPEFEerXOFAPTo",14) == 99392440) strcat(s, "V");
if (crc32("ZxNiPNXVihwLj",13) == 4180024405) strcat(s, "l");
if (crc32("sJKhMRQMMZ",10) == 1298758050) strcat(s, "l");
if (crc32("vFfetHvfBFVJK",13) == 1548961550) strcat(s, "y");
    return s;
}

char *unglibly_adverbs() {
    char *s = calloc(9);
    if (crc32("ONtJtpKjlvE",11) == 3992320455) strcat(s, "u");
if (crc32("tEcaSGxXds",10) == 604252500) strcat(s, "j");
if (crc32("TVLssgBu",8) == 3834762291) strcat(s, "n");
if (crc32("lOoyRAOY",8) == 388892390) strcat(s, "d");
if (crc32("HRWoXB",6) == 4026268143) strcat(s, "g");
if (crc32("lDLQbL",6) == 2297586212) strcat(s, "N");
if (crc32("hXOslmfkag",10) == 778472373) strcat(s, "l");
if (crc32("wUNzbTPZzDgm",12) == 2529661364) strcat(s, "i");
if (crc32("NRGGYzuDRYCIXd",14) == 4208116297) strcat(s, "E");
if (crc32("UugPSkUiHxZWIf",14) == 482433400) strcat(s, "b");
if (crc32("KOXIdlxSepEmM",13) == 4039241220) strcat(s, "l");
if (crc32("JZSpVKdFXREic",13) == 3577505425) strcat(s, "C");
if (crc32("PWUhyKbbjQ",10) == 3007236729) strcat(s, "y");
    return s;
}

char *overhostilely_adverbs() {
    char *s = calloc(14);
    if (crc32("lUjOAQlvCOwTK",13) == 2439291540) strcat(s, "o");
if (crc32("wqWmjMXDK",9) == 1817880255) strcat(s, "y");
if (crc32("MsEiuVH",7) == 635912915) strcat(s, "v");
if (crc32("dQagvyL",7) == 897654290) strcat(s, "a");
if (crc32("ICNvpFbZUGVd",12) == 156445186) strcat(s, "e");
if (crc32("hJsBwITtx",9) == 3446238912) strcat(s, "K");
if (crc32("TpMwJtbZVJS",11) == 2075049411) strcat(s, "r");
if (crc32("HjoWYh",6) == 217787472) strcat(s, "c");
if (crc32("SYzqbDSP",8) == 2056004871) strcat(s, "h");
if (crc32("szBJLB",6) == 951016114) strcat(s, "O");
if (crc32("JETFRBbiIVzads",14) == 947657163) strcat(s, "o");
if (crc32("awCSQ",5) == 1807642025) strcat(s, "s");
if (crc32("DVMIVD",6) == 423467590) strcat(s, "t");
if (crc32("CpzJzogp",8) == 241528787) strcat(s, "z");
if (crc32("EWVcC",5) == 3386862963) strcat(s, "i");
if (crc32("ufacOr",6) == 4240316921) strcat(s, "l");
if (crc32("hquPBtfrIqyI",12) == 2652132129) strcat(s, "B");
if (crc32("mZHeQHfemPdqlOd",15) == 1839372536) strcat(s, "e");
if (crc32("uDVzrLFqGhTLA",13) == 2454418688) strcat(s, "E");
if (crc32("RqKGMHxHJOIt",12) == 4221722269) strcat(s, "l");
if (crc32("muFfARszDAQuDS",14) == 3687148161) strcat(s, "y");
    return s;
}

char *longwindedly_adverbs() {
    char *s = calloc(13);
    if (crc32("JjhvoIYLM",9) == 3195976310) strcat(s, "p");
if (crc32("tgwQizOhRBp",11) == 1994212176) strcat(s, "l");
if (crc32("rELBscazNwpm",12) == 3193663828) strcat(s, "o");
if (crc32("xFdXlcwUui",10) == 3158445098) strcat(s, "V");
if (crc32("bwmUOhXG",8) == 2245204905) strcat(s, "n");
if (crc32("RkMXVHu",7) == 1033142251) strcat(s, "Y");
if (crc32("LRYOUTkDTbFs",12) == 1330333447) strcat(s, "g");
if (crc32("DEoljxW",7) == 4227743558) strcat(s, "h");
if (crc32("TfpasNfERAuF",12) == 3831890425) strcat(s, "w");
if (crc32("nlDRiTMN",8) == 3278371994) strcat(s, "i");
if (crc32("uSMYJrY",7) == 1676947610) strcat(s, "O");
if (crc32("oUJuKaKBIIWrZ",13) == 2919852669) strcat(s, "n");
if (crc32("vEojLnB",7) == 412370042) strcat(s, "d");
if (crc32("DdzTJtIztnsA",12) == 4277840244) strcat(s, "e");
if (crc32("PZglOtwJ",8) == 2726488256) strcat(s, "r");
if (crc32("UdSVyn",6) == 1682806212) strcat(s, "d");
if (crc32("fEIBNKnGoELgf",13) == 3351680277) strcat(s, "K");
if (crc32("rbJMF",5) == 1937417921) strcat(s, "l");
if (crc32("qqoLtC",6) == 3299279755) strcat(s, "C");
if (crc32("nkQSrpIyfU",10) == 1400971913) strcat(s, "y");
    return s;
}

char *readily_adverbs() {
    char *s = calloc(8);
    if (crc32("ZmHorhWIotl",11) == 405370120) strcat(s, "l");
if (crc32("vLIUyvC",7) == 250521685) strcat(s, "r");
if (crc32("hFYcflhQPRMf",12) == 3052206958) strcat(s, "e");
if (crc32("tkNEzVRwGFQS",12) == 1999434849) strcat(s, "Y");
if (crc32("jWTrvzHorybLcOg",15) == 2706836161) strcat(s, "a");
if (crc32("FKKcPQ",6) == 3887314937) strcat(s, "d");
if (crc32("JBxkGMxPHv",10) == 1153639213) strcat(s, "q");
if (crc32("zlmLeFTtodUYpj",14) == 3439222482) strcat(s, "i");
if (crc32("TFRXtyaP",8) == 3801774218) strcat(s, "Y");
if (crc32("lOLlMyFNeoIBB",13) == 1464435672) strcat(s, "l");
if (crc32("rOiahWJt",8) == 2015541512) strcat(s, "y");
    return s;
}

char *unsceptically_adverbs() {
    char *s = calloc(14);
    if (crc32("yehfv",5) == 4062048290) strcat(s, "u");
if (crc32("MaHpHOpApVo",11) == 3085502654) strcat(s, "n");
if (crc32("dlnpKRoo",8) == 963271088) strcat(s, "B");
if (crc32("HoqPrGFsDksYSKE",15) == 2807016486) strcat(s, "s");
if (crc32("DesuVCQldv",10) == 3748367842) strcat(s, "o");
if (crc32("fpHBGP",6) == 1867517025) strcat(s, "c");
if (crc32("eoZeUwEEoh",10) == 651213254) strcat(s, "e");
if (crc32("oVPRXiFH",8) == 1810109491) strcat(s, "s");
if (crc32("AaaKcJ",6) == 4128785466) strcat(s, "p");
if (crc32("JpetlSXtBPQ",11) == 1748804623) strcat(s, "t");
if (crc32("RjxnZvCMQZw",11) == 3425860974) strcat(s, "i");
if (crc32("CQQnEAiobC",10) == 915833533) strcat(s, "c");
if (crc32("mPwPFWqEmcgtLh",14) == 3163979908) strcat(s, "D");
if (crc32("OTYcrtWXWjzQS",13) == 3040580422) strcat(s, "a");
if (crc32("aFcoPW",6) == 4182573451) strcat(s, "j");
if (crc32("fmvtBP",6) == 3125132711) strcat(s, "l");
if (crc32("rJtOgbcjgCJ",11) == 2554470402) strcat(s, "l");
if (crc32("IiGGcBnxEyvFlV",14) == 113020125) strcat(s, "y");
    return s;
}

char *subalgebraically_adverbs() {
    char *s = calloc(17);
    if (crc32("KrXqvO",6) == 2479050744) strcat(s, "s");
if (crc32("rsUsaLLcoH",10) == 1204072534) strcat(s, "u");
if (crc32("QavPOwJO",8) == 1245415239) strcat(s, "b");
if (crc32("oPGyJewx",8) == 462028461) strcat(s, "C");
if (crc32("kWTOZs",6) == 4013132465) strcat(s, "a");
if (crc32("hooVylPZkXZVVi",14) == 2443673353) strcat(s, "l");
if (crc32("ZYGInHjDlzBe",12) == 3248846953) strcat(s, "g");
if (crc32("TCkXgkOPVAEkGud",15) == 2888911735) strcat(s, "e");
if (crc32("mFbfHBETcERLNRv",15) == 4156573549) strcat(s, "b");
if (crc32("CaAlUCCaSrfLv",13) == 1580234211) strcat(s, "r");
if (crc32("xcvROmQImo",10) == 596102172) strcat(s, "a");
if (crc32("dGOpJLMrCSUlByL",15) == 2028528851) strcat(s, "i");
if (crc32("NYVybjfyLs",10) == 2849728621) strcat(s, "x");
if (crc32("KheRK",5) == 806154156) strcat(s, "c");
if (crc32("FQWdnyBfBUlxozz",15) == 2072155684) strcat(s, "T");
if (crc32("utWGLqRHks",10) == 1816825736) strcat(s, "a");
if (crc32("feaMyrXOTXF",11) == 1875779774) strcat(s, "l");
if (crc32("qAQaJBtFnsLWSY",14) == 837129154) strcat(s, "l");
if (crc32("iXgfs",5) == 3951752302) strcat(s, "y");
    return s;
}

char *undecipherably_adverbs() {
    char *s = calloc(15);
    if (crc32("AkiLWCfEXmAqxn",14) == 182410901) strcat(s, "c");
if (crc32("cGYBL",5) == 3225136903) strcat(s, "u");
if (crc32("qabBgJkYEDurGjQ",15) == 570967463) strcat(s, "j");
if (crc32("tOsoCZ",6) == 2436433583) strcat(s, "n");
if (crc32("RQGoqgh",7) == 1333669929) strcat(s, "T");
if (crc32("ziHEBWMBiJIDiK",14) == 3850606693) strcat(s, "d");
if (crc32("mGQfobaBfyHGe",13) == 2413699298) strcat(s, "C");
if (crc32("EraqOVsrFoNmpwM",15) == 1406239508) strcat(s, "e");
if (crc32("iJRgI",5) == 2632834478) strcat(s, "q");
if (crc32("qWhovpUIe",9) == 1953545945) strcat(s, "c");
if (crc32("gLwIWrvLEzdFkRK",15) == 303630746) strcat(s, "i");
if (crc32("uSSJIDCxYjCyrdF",15) == 2159811129) strcat(s, "b");
if (crc32("IRAawSctywfBrDU",15) == 650410274) strcat(s, "p");
if (crc32("WzISUdxsHxXJ",12) == 3722352717) strcat(s, "h");
if (crc32("FzBKiuDLoi",10) == 2636355262) strcat(s, "e");
if (crc32("ZlUMPorNCTEMi",13) == 448565158) strcat(s, "r");
if (crc32("axhoGmrGHChJt",13) == 3251877519) strcat(s, "z");
if (crc32("xSfHkUjXKwmdXf",14) == 699844407) strcat(s, "a");
if (crc32("wXPDrXcZJAF",11) == 587236981) strcat(s, "b");
if (crc32("InDeMtuEv",9) == 2605232697) strcat(s, "l");
if (crc32("IvxMksVeaj",10) == 1232566367) strcat(s, "l");
if (crc32("rdmwShNGYbGz",12) == 2914851334) strcat(s, "y");
    return s;
}

char *unsubmissively_adverbs() {
    char *s = calloc(15);
    if (crc32("EHXeJmTPczEml",13) == 1465524801) strcat(s, "i");
if (crc32("NpoWZETvzjrxc",13) == 4219474320) strcat(s, "u");
if (crc32("WaicqJQFQpYq",12) == 3166314464) strcat(s, "D");
if (crc32("lyFYxagUo",9) == 4269459148) strcat(s, "n");
if (crc32("eKlqYNjBO",9) == 2212635766) strcat(s, "f");
if (crc32("vGNVHcMAXHmVB",13) == 3651388080) strcat(s, "s");
if (crc32("NMLSGLyOpXWY",12) == 1794177229) strcat(s, "L");
if (crc32("qYEbghyP",8) == 2052168600) strcat(s, "u");
if (crc32("rDedI",5) == 4004818833) strcat(s, "R");
if (crc32("UVAqzrIag",9) == 3450389076) strcat(s, "b");
if (crc32("bGDHCUwwAUz",11) == 4104228097) strcat(s, "m");
if (crc32("IXBSJvj",7) == 4272328715) strcat(s, "i");
if (crc32("YlAvdeqt",8) == 1256147390) strcat(s, "s");
if (crc32("CENkFfLqE",9) == 2525010530) strcat(s, "s");
if (crc32("ciSSNdrjFqJS",12) == 340793747) strcat(s, "c");
if (crc32("XpuGpC",6) == 1091791297) strcat(s, "i");
if (crc32("wmTbHVbRu",9) == 3470232304) strcat(s, "v");
if (crc32("vIOTI",5) == 4240268892) strcat(s, "e");
if (crc32("uEeXRHDMHBGHz",13) == 3762826930) strcat(s, "Y");
if (crc32("GHSmfHzeyV",10) == 1261145138) strcat(s, "l");
if (crc32("aJHnBppHR",9) == 4033756264) strcat(s, "y");
    return s;
}

char *fasciculately_adverbs() {
    char *s = calloc(14);
    if (crc32("AXfTOoyR",8) == 2020936087) strcat(s, "f");
if (crc32("ucttbMHYjXJNH",13) == 1822016735) strcat(s, "a");
if (crc32("tBxJsJCXOM",10) == 2029330364) strcat(s, "s");
if (crc32("AQeDkGWvrB",10) == 3557412249) strcat(s, "c");
if (crc32("wXBmgoWod",9) == 3564990464) strcat(s, "E");
if (crc32("JKXzMbNvuGYtwIC",15) == 3211805092) strcat(s, "i");
if (crc32("ZPPShmon",8) == 132044948) strcat(s, "c");
if (crc32("MayrHGXFsH",10) == 247087690) strcat(s, "G");
if (crc32("LHdeAyQlgvxvLg",14) == 3183656679) strcat(s, "u");
if (crc32("UqUqYCWvIxtAFm",14) == 2388886729) strcat(s, "Y");
if (crc32("PMilibTYwGd",11) == 2334453441) strcat(s, "l");
if (crc32("AGuSuQMyGMNR",12) == 3918718207) strcat(s, "o");
if (crc32("zSDpx",5) == 2861173467) strcat(s, "a");
if (crc32("MJulXBu",7) == 3800489463) strcat(s, "c");
if (crc32("UEPqr",5) == 2122869182) strcat(s, "t");
if (crc32("TxfMfBxSjkzZGr",14) == 3076153661) strcat(s, "e");
if (crc32("pJMWESY",7) == 3691914576) strcat(s, "l");
if (crc32("qAJjTrMVPcLWIz",14) == 3514395525) strcat(s, "Y");
if (crc32("WKALYwluLUk",11) == 803634016) strcat(s, "y");
    return s;
}

char *drastically_adverbs() {
    char *s = calloc(12);
    if (crc32("BsfrPDEQp",9) == 436712469) strcat(s, "y");
if (crc32("fnWmoa",6) == 2271792390) strcat(s, "d");
if (crc32("FsZrwogAWLZhkH",14) == 3319717177) strcat(s, "B");
if (crc32("fXlNJKfDOVjHOke",15) == 468505873) strcat(s, "r");
if (crc32("puGkvJIRu",9) == 1142382077) strcat(s, "a");
if (crc32("CQSXhdCai",9) == 1294487007) strcat(s, "s");
if (crc32("ZHRArxqOLyF",11) == 1189692831) strcat(s, "t");
if (crc32("ypHUvaY",7) == 1170410507) strcat(s, "i");
if (crc32("trOijHB",7) == 3122551770) strcat(s, "c");
if (crc32("ySkPLRGppau",11) == 3772223903) strcat(s, "F");
if (crc32("lSxysSPAjazig",13) == 94682477) strcat(s, "a");
if (crc32("UvFCDwGokkWHn",13) == 3211680069) strcat(s, "G");
if (crc32("xLRIvDkeY",9) == 1661372813) strcat(s, "l");
if (crc32("bnwyWdO",7) == 1618998726) strcat(s, "l");
if (crc32("OblCowL",7) == 3824121783) strcat(s, "y");
    return s;
}

char *aristocratically_adverbs() {
    char *s = calloc(17);
    if (crc32("xdCloIeenY",10) == 3958618137) strcat(s, "a");
if (crc32("IJwmVFewHXuPn",13) == 1683378078) strcat(s, "Y");
if (crc32("gjAkndQG",8) == 1695785247) strcat(s, "r");
if (crc32("gsUrRTWXgJEs",12) == 2235361156) strcat(s, "E");
if (crc32("rlfqymBYTEyELHs",15) == 2374530041) strcat(s, "i");
if (crc32("WcxEyqPw",8) == 3223551969) strcat(s, "s");
if (crc32("QMipZuFcO",9) == 3595731075) strcat(s, "t");
if (crc32("xwERGUoxjHrI",12) == 27978245) strcat(s, "i");
if (crc32("zGPRqTs",7) == 3705067676) strcat(s, "o");
if (crc32("CxNeUYimPWafXXm",15) == 2505308674) strcat(s, "j");
if (crc32("kQMPBryrZsmJvbt",15) == 921509361) strcat(s, "c");
if (crc32("dSpdkzXvAFjwa",13) == 1182127475) strcat(s, "r");
if (crc32("ZXUFRoKX",8) == 529089854) strcat(s, "Z");
if (crc32("mykTmD",6) == 3608828308) strcat(s, "a");
if (crc32("UqeIVVksIZPUgoJ",15) == 4209094144) strcat(s, "t");
if (crc32("bgNHDCwf",8) == 1177134591) strcat(s, "i");
if (crc32("gzwkUclKUV",10) == 342830831) strcat(s, "E");
if (crc32("WDFoDeNg",8) == 2946510304) strcat(s, "c");
if (crc32("oEgjQiTlQBKE",12) == 2910531380) strcat(s, "W");
if (crc32("hezVXagNfmJJ",12) == 264651275) strcat(s, "a");
if (crc32("mmQCgwTULYUm",12) == 1952171310) strcat(s, "L");
if (crc32("cJRqClCpBKr",11) == 3075920882) strcat(s, "l");
if (crc32("NOhijUR",7) == 1526734137) strcat(s, "L");
if (crc32("QWhuSPsDOb",10) == 1987846527) strcat(s, "l");
if (crc32("WTFgXBteVhYX",12) == 1655344692) strcat(s, "y");
    return s;
}

char *unliterally_adverbs() {
    char *s = calloc(12);
    if (crc32("uPEUvqyZOOF",11) == 465377182) strcat(s, "L");
if (crc32("FjBAYLPeMNAVPDs",15) == 3504150422) strcat(s, "u");
if (crc32("CBOrSStjCTlvoU",14) == 1469849348) strcat(s, "n");
if (crc32("zuLpMBDzwisdD",13) == 578817011) strcat(s, "t");
if (crc32("HqBRYfLs",8) == 3130604887) strcat(s, "l");
if (crc32("rSlBmWKP",8) == 473345655) strcat(s, "i");
if (crc32("wKzHgjsmOonEDTR",15) == 4206086050) strcat(s, "A");
if (crc32("xyfhBkXyAHWUH",13) == 2160623593) strcat(s, "t");
if (crc32("SqRdxERKz",9) == 2590968676) strcat(s, "t");
if (crc32("EFShJFFuGUOGkx",14) == 1364355725) strcat(s, "e");
if (crc32("sPSAJvyEGI",10) == 3179028957) strcat(s, "r");
if (crc32("EIBBUWpF",8) == 2429540850) strcat(s, "a");
if (crc32("NSwbVJ",6) == 363418679) strcat(s, "Y");
if (crc32("MdIPwrsMKTLt",12) == 4183469751) strcat(s, "l");
if (crc32("yCMJPubCx",9) == 1009777790) strcat(s, "l");
if (crc32("NkAoP",5) == 898670684) strcat(s, "y");
    return s;
}

char *unsoberly_adverbs() {
    char *s = calloc(10);
    if (crc32("IFifsNRnTKFgIP",14) == 847576115) strcat(s, "K");
if (crc32("BiIzpb",6) == 1418304587) strcat(s, "u");
if (crc32("NIiBCW",6) == 3390622001) strcat(s, "n");
if (crc32("fWzghTCs",8) == 2466267478) strcat(s, "s");
if (crc32("EGUmFhgjaEu",11) == 3714369585) strcat(s, "L");
if (crc32("nThOnmXVwqSW",12) == 235282514) strcat(s, "o");
if (crc32("LhrxTO",6) == 3700194504) strcat(s, "V");
if (crc32("ZDmnafe",7) == 1932651216) strcat(s, "b");
if (crc32("MColem",6) == 341233054) strcat(s, "e");
if (crc32("oAQnjtBIFvySSYp",15) == 27217984) strcat(s, "r");
if (crc32("AuCoCOXQ",8) == 813887960) strcat(s, "l");
if (crc32("PbgzKxEa",8) == 737327797) strcat(s, "y");
    return s;
}

char *discursively_adverbs() {
    char *s = calloc(13);
    if (crc32("UecVUi",6) == 240368344) strcat(s, "d");
if (crc32("qgmWlFxyEUn",11) == 420787625) strcat(s, "Z");
if (crc32("ppNWgYOSniDJUB",14) == 2516903111) strcat(s, "i");
if (crc32("UGumZGW",7) == 3517370888) strcat(s, "G");
if (crc32("uShlMgUhtbi",11) == 3628023815) strcat(s, "s");
if (crc32("dbZJLUWO",8) == 986766289) strcat(s, "c");
if (crc32("AthuvAuvtACF",12) == 2453444871) strcat(s, "u");
if (crc32("SPHjNcKwyRZ",11) == 1034571025) strcat(s, "t");
if (crc32("iqPTPm",6) == 1938554673) strcat(s, "r");
if (crc32("LxwNR",5) == 1334568608) strcat(s, "s");
if (crc32("xLOuBJZHjZsNqoa",15) == 2205109623) strcat(s, "i");
if (crc32("TwUpSXosbp",10) == 2254207687) strcat(s, "v");
if (crc32("dTMOjurFTQirc",13) == 867432884) strcat(s, "e");
if (crc32("ePOMCUVZze",10) == 1374933333) strcat(s, "g");
if (crc32("BjRikVGmm",9) == 1526112312) strcat(s, "l");
if (crc32("ZjobSKKfDH",10) == 2452927550) strcat(s, "m");
if (crc32("osndOcjWGz",10) == 2731329906) strcat(s, "y");
    return s;
}

char *unpenetratingly_adverbs() {
    char *s = calloc(16);
    if (crc32("UyMzyOaFs",9) == 4080600053) strcat(s, "u");
if (crc32("EzZJVeEFEaISe",13) == 498435958) strcat(s, "I");
if (crc32("MvYKlLvDfJKoXoL",15) == 958435992) strcat(s, "n");
if (crc32("tOeUrBBa",8) == 4001135352) strcat(s, "s");
if (crc32("DMXjKIbilMNMqhE",15) == 1438668137) strcat(s, "p");
if (crc32("rRIWNVoHw",9) == 1403525242) strcat(s, "e");
if (crc32("rYUHnt",6) == 3966201911) strcat(s, "n");
if (crc32("MGEYRU",6) == 1531155666) strcat(s, "x");
if (crc32("MoCVsjGGhEOy",12) == 1100785424) strcat(s, "e");
if (crc32("xUNqrHpVWvzC",12) == 781359216) strcat(s, "t");
if (crc32("blpPhB",6) == 2275847146) strcat(s, "y");
if (crc32("qKpasuXILNYo",12) == 3087106534) strcat(s, "r");
if (crc32("JrYItqpy",8) == 215515775) strcat(s, "s");
if (crc32("yljHXQukHTnq",12) == 1685220656) strcat(s, "a");
if (crc32("bJhIBvzow",9) == 2781524119) strcat(s, "t");
if (crc32("fmnOTptO",8) == 3426019988) strcat(s, "i");
if (crc32("dehDUbKRqNKJ",12) == 988553972) strcat(s, "n");
if (crc32("wsAuGqsuTyde",12) == 290327339) strcat(s, "l");
if (crc32("ImRbpWyb",8) == 1151925305) strcat(s, "g");
if (crc32("tMhXcg",6) == 2150178551) strcat(s, "l");
if (crc32("kbiYrcHKEEjLwPo",15) == 2005128791) strcat(s, "V");
if (crc32("cQmTLBycsJiFrtn",15) == 3816681044) strcat(s, "y");
    return s;
}

char *nonissuably_adverbs() {
    char *s = calloc(12);
    if (crc32("EDqdEoJoEzs",11) == 480928881) strcat(s, "n");
if (crc32("VSNMXo",6) == 1763742708) strcat(s, "U");
if (crc32("Prfqjd",6) == 2699925039) strcat(s, "o");
if (crc32("zOwqU",5) == 3400324097) strcat(s, "n");
if (crc32("VRxqhLp",7) == 3505867986) strcat(s, "q");
if (crc32("LiLnv",5) == 647437400) strcat(s, "i");
if (crc32("ynurTHbli",9) == 2727639855) strcat(s, "s");
if (crc32("WOnngiRcL",9) == 1393007150) strcat(s, "Y");
if (crc32("ZZFwOLBifgMEc",13) == 3532067109) strcat(s, "s");
if (crc32("VWyfzJzSlckXKMW",15) == 108224708) strcat(s, "u");
if (crc32("khzzgqeflc",10) == 3506904078) strcat(s, "H");
if (crc32("KcjPxJAEjB",10) == 634085410) strcat(s, "a");
if (crc32("djGOUJLGkhENl",13) == 2554982480) strcat(s, "a");
if (crc32("NrAVApKDuIVqJx",14) == 512062665) strcat(s, "b");
if (crc32("uLvXuOQkkygWo",13) == 3650750447) strcat(s, "R");
if (crc32("JnpITxruu",9) == 3936481655) strcat(s, "l");
if (crc32("xvMVmoQKjNDemEn",15) == 2389238914) strcat(s, "N");
if (crc32("TdNhERP",7) == 1433749339) strcat(s, "y");
    return s;
}

char *biotechnologically_adverbs() {
    char *s = calloc(19);
    if (crc32("DXYruEw",7) == 680866887) strcat(s, "b");
if (crc32("SCupqfyZpIvli",13) == 316202266) strcat(s, "i");
if (crc32("ETegXETfZcHmkd",14) == 2998810760) strcat(s, "o");
if (crc32("Gzvulub",7) == 741556332) strcat(s, "t");
if (crc32("nBgVEIZYVLc",11) == 2351406438) strcat(s, "U");
if (crc32("UuBnXjsAXdhqo",13) == 1725802035) strcat(s, "e");
if (crc32("MIGxBjFmI",9) == 1144515713) strcat(s, "c");
if (crc32("eboOhBJWijcB",12) == 2927847327) strcat(s, "C");
if (crc32("NPFSqeCL",8) == 3857933604) strcat(s, "h");
if (crc32("YuVBLM",6) == 1655219159) strcat(s, "n");
if (crc32("CEDysd",6) == 2844138905) strcat(s, "o");
if (crc32("hDPCtuXck",9) == 1954900701) strcat(s, "D");
if (crc32("EejrzA",6) == 1751157090) strcat(s, "l");
if (crc32("SeRLNvDzHSr",11) == 2921981913) strcat(s, "o");
if (crc32("fJZruRdHuVV",11) == 2728424572) strcat(s, "g");
if (crc32("fOPWVBqVImC",11) == 4184495991) strcat(s, "i");
if (crc32("DHxWF",5) == 89550744) strcat(s, "c");
if (crc32("qpMpVFtpKRPL",12) == 2599450325) strcat(s, "a");
if (crc32("BxhbeUFFyVTP",12) == 2773524029) strcat(s, "A");
if (crc32("cechBpEzHpcyZfM",15) == 787677639) strcat(s, "l");
if (crc32("DnYwYStR",8) == 79675807) strcat(s, "R");
if (crc32("kQrhxNXyUFvGb",13) == 1826708079) strcat(s, "l");
if (crc32("VdKKrvq",7) == 606657343) strcat(s, "y");
    return s;
}

char *appulsively_adverbs() {
    char *s = calloc(12);
    if (crc32("rKrnATGFabwuR",13) == 3822109152) strcat(s, "U");
if (crc32("FCMEtmuhlxWikK",14) == 2944167134) strcat(s, "a");
if (crc32("TCPSeYnqE",9) == 2209795659) strcat(s, "x");
if (crc32("rxfPhQodjIQxOI",14) == 4186542991) strcat(s, "p");
if (crc32("vRKymVPhLEtA",12) == 3718260507) strcat(s, "u");
if (crc32("MOAlsJ",6) == 685373486) strcat(s, "p");
if (crc32("zvXSuHnQh",9) == 3196675139) strcat(s, "u");
if (crc32("ugsjKyMWS",9) == 3564739645) strcat(s, "J");
if (crc32("KtalYIj",7) == 1908461145) strcat(s, "l");
if (crc32("dRNpuKdOYPY",11) == 855668440) strcat(s, "s");
if (crc32("lpKfEE",6) == 725514500) strcat(s, "D");
if (crc32("MVZjTTjUCojlGig",15) == 1598254051) strcat(s, "i");
if (crc32("ENXTwmNJDfvMx",13) == 3374418529) strcat(s, "b");
if (crc32("hKrxvBiReLL",11) == 329171882) strcat(s, "v");
if (crc32("iQYqQhIqrdBYiSj",15) == 116611201) strcat(s, "e");
if (crc32("luyMRIjFpPvWSm",14) == 910287995) strcat(s, "Q");
if (crc32("tkUQzYbBIgyLTO",14) == 4230775148) strcat(s, "l");
if (crc32("UrFhJfZVeXX",11) == 709916862) strcat(s, "F");
if (crc32("KjphTFdNguZ",11) == 638251407) strcat(s, "y");
    return s;
}

char *cleistogamously_adverbs() {
    char *s = calloc(16);
    if (crc32("MsphszGO",8) == 3736360284) strcat(s, "u");
if (crc32("VUbfcjm",7) == 2585132532) strcat(s, "c");
if (crc32("dncDFwfKdd",10) == 806139744) strcat(s, "x");
if (crc32("YpZIFERML",9) == 363224197) strcat(s, "l");
if (crc32("vSpkhmEcMfTLOg",14) == 2830770874) strcat(s, "e");
if (crc32("amXukFWobTXkyc",14) == 1928596137) strcat(s, "i");
if (crc32("oeBRvhzYTnLJ",12) == 2685751768) strcat(s, "i");
if (crc32("OozyxVIFnKKcrl",14) == 327995245) strcat(s, "s");
if (crc32("PIqAbCPMPoeAEJB",15) == 2347167663) strcat(s, "t");
if (crc32("HjqAlyZa",8) == 2867014280) strcat(s, "S");
if (crc32("xzUBokHCeizR",12) == 2368604981) strcat(s, "o");
if (crc32("sMoZl",5) == 1553844465) strcat(s, "G");
if (crc32("FqVTCc",6) == 642612123) strcat(s, "g");
if (crc32("fHOOehCixtyLO",13) == 3126233104) strcat(s, "d");
if (crc32("ebfpVeGuO",9) == 4213339184) strcat(s, "a");
if (crc32("JuvebmHfi",9) == 3745573296) strcat(s, "M");
if (crc32("EmnIHu",6) == 864616257) strcat(s, "m");
if (crc32("qAiSHNf",7) == 3931050694) strcat(s, "o");
if (crc32("bxRDqFHRfLyacX",14) == 670265365) strcat(s, "u");
if (crc32("CUPokdJtisjquL",14) == 845169610) strcat(s, "s");
if (crc32("LLRZtPCbNJb",11) == 2508927792) strcat(s, "c");
if (crc32("JeJRiFOGNDp",11) == 2437568061) strcat(s, "l");
if (crc32("yAGCrjPEDt",10) == 1675257389) strcat(s, "x");
if (crc32("fzsKSdnNX",9) == 3456883177) strcat(s, "y");
    return s;
}

char *positivistically_adverbs() {
    char *s = calloc(17);
    if (crc32("MxNjHawmSwK",11) == 991497620) strcat(s, "f");
if (crc32("NjqYAKYUNjNm",12) == 3434975572) strcat(s, "p");
if (crc32("VXZLhDFHtsFNQ",13) == 932866457) strcat(s, "f");
if (crc32("EwVFqCJ",7) == 2352624508) strcat(s, "o");
if (crc32("caEcWBEtqtl",11) == 2205356141) strcat(s, "T");
if (crc32("OZhWsxM",7) == 3298746930) strcat(s, "s");
if (crc32("WQWuC",5) == 3956156845) strcat(s, "i");
if (crc32("GWZzq",5) == 3385570388) strcat(s, "r");
if (crc32("DqeCJYUPqHP",11) == 1401396813) strcat(s, "t");
if (crc32("zBKXhyBqOtxO",12) == 4186602267) strcat(s, "i");
if (crc32("RWZNyk",6) == 2157850343) strcat(s, "v");
if (crc32("ENRbQ",5) == 157654451) strcat(s, "i");
if (crc32("DVXgSmgGxjckaoL",15) == 159841054) strcat(s, "s");
if (crc32("prPCbYekwR",10) == 906847597) strcat(s, "t");
if (crc32("xXBzGVdsU",9) == 115666802) strcat(s, "i");
if (crc32("DPSHpkEcPY",10) == 22242062) strcat(s, "c");
if (crc32("aPbFJVCbhcaaQ",13) == 974261204) strcat(s, "a");
if (crc32("pOUVolWmgQc",11) == 3821178661) strcat(s, "b");
if (crc32("ShnqXEcUSCrpDn",14) == 254858226) strcat(s, "l");
if (crc32("KZZdyHeUNJjoFcj",15) == 2965452270) strcat(s, "l");
if (crc32("VyrcJTKxMP",10) == 78703883) strcat(s, "y");
    return s;
}

char *hypernaturally_adverbs() {
    char *s = calloc(15);
    if (crc32("GGfcPDcnKWxw",12) == 942390070) strcat(s, "h");
if (crc32("nYSnJhlObciBsf",14) == 1882587341) strcat(s, "w");
if (crc32("XWsfEM",6) == 1805583983) strcat(s, "y");
if (crc32("LoFMkheeZL",10) == 2555603828) strcat(s, "p");
if (crc32("zoUlCCUUc",9) == 1801864737) strcat(s, "e");
if (crc32("JjKDPbPkKTobrHc",15) == 4288936940) strcat(s, "r");
if (crc32("rJSxJqCm",8) == 1633225209) strcat(s, "n");
if (crc32("EFDITUc",7) == 3464301193) strcat(s, "u");
if (crc32("BrOhTlYjcqRU",12) == 60577530) strcat(s, "a");
if (crc32("NtEMfSxwx",9) == 3027941298) strcat(s, "d");
if (crc32("kKJlUccEfY",10) == 2650952945) strcat(s, "t");
if (crc32("jfjOU",5) == 2008142439) strcat(s, "M");
if (crc32("UmvStdKS",8) == 2049021598) strcat(s, "u");
if (crc32("vjvXWuEHFZMezV",14) == 3536657288) strcat(s, "r");
if (crc32("OMqUpFYPWWsuLI",14) == 1535704775) strcat(s, "a");
if (crc32("fMQWdctvyCjF",12) == 1708077242) strcat(s, "M");
if (crc32("gGOLYjpIyGJOIIX",15) == 127073185) strcat(s, "l");
if (crc32("HUwtcjjBTIai",12) == 1960526969) strcat(s, "l");
if (crc32("KQFTPhwmv",9) == 1837948831) strcat(s, "y");
    return s;
}

char *antidogmatically_adverbs() {
    char *s = calloc(17);
    if (crc32("hSejRwgRH",9) == 2748556054) strcat(s, "a");
if (crc32("TlejpgA",7) == 3077211666) strcat(s, "Q");
if (crc32("ognSIPjFN",9) == 42418656) strcat(s, "n");
if (crc32("VkEHb",5) == 2604842189) strcat(s, "H");
if (crc32("WPKhMhcOPG",10) == 476862017) strcat(s, "t");
if (crc32("UzEiggMPiaARYNo",15) == 2120787937) strcat(s, "i");
if (crc32("Azphd",5) == 3785382719) strcat(s, "c");
if (crc32("JOSUcgFU",8) == 3439130254) strcat(s, "d");
if (crc32("HAFlwK",6) == 1316721728) strcat(s, "n");
if (crc32("TYGemlR",7) == 2340324493) strcat(s, "o");
if (crc32("VqQHQdXi",8) == 2934736883) strcat(s, "y");
if (crc32("qiucEYMyjxyf",12) == 1582072648) strcat(s, "g");
if (crc32("lQLDsLSCidRl",12) == 211340538) strcat(s, "Z");
if (crc32("qwKAqxkkpzqaae",14) == 38007568) strcat(s, "m");
if (crc32("DFXTzeOJ",8) == 1763050203) strcat(s, "a");
if (crc32("VlQTnoQM",8) == 3279905416) strcat(s, "p");
if (crc32("yLySN",5) == 3102778361) strcat(s, "t");
if (crc32("dETlYjJX",8) == 220649146) strcat(s, "j");
if (crc32("DpEhTJM",7) == 566597582) strcat(s, "i");
if (crc32("MBFwHA",6) == 1430766955) strcat(s, "z");
if (crc32("IrPwusbqX",9) == 532679971) strcat(s, "c");
if (crc32("vFjXRzLFI",9) == 2818002283) strcat(s, "T");
if (crc32("pMogwOZxwnOBXPt",15) == 219661893) strcat(s, "a");
if (crc32("zbvkOFtpt",9) == 4223108620) strcat(s, "I");
if (crc32("zmvLhpjoHfF",11) == 2142579360) strcat(s, "l");
if (crc32("mnwAUUsahhSgZoZ",15) == 1276353869) strcat(s, "l");
if (crc32("VHhuKlEeDrMVfh",14) == 2248751044) strcat(s, "F");
if (crc32("dAcHHaRhWTFJSOl",15) == 1142776156) strcat(s, "y");
    return s;
}

char *continuously_adverbs() {
    char *s = calloc(13);
    if (crc32("kljOCjGjBbt",11) == 4213221981) strcat(s, "c");
if (crc32("DAPRGnvLOAy",11) == 3057690820) strcat(s, "o");
if (crc32("WSdXZHhgqG",10) == 805436635) strcat(s, "u");
if (crc32("LehjXRRpqJDA",12) == 3575588076) strcat(s, "n");
if (crc32("qEyjwEKq",8) == 1943381288) strcat(s, "m");
if (crc32("tTYLdWEGZh",10) == 958438247) strcat(s, "t");
if (crc32("fVwywaeqaqbEcb",14) == 315024699) strcat(s, "n");
if (crc32("VdKlVRD",7) == 2178057985) strcat(s, "i");
if (crc32("LsLAzUo",7) == 1853689170) strcat(s, "n");
if (crc32("dLXjUUGIGwfgq",13) == 566778383) strcat(s, "u");
if (crc32("ALDiY",5) == 2741534147) strcat(s, "o");
if (crc32("KfSJsDlJP",9) == 2592107298) strcat(s, "u");
if (crc32("SOutK",5) == 2189526076) strcat(s, "s");
if (crc32("CCVrpCohBQZ",11) == 1707722360) strcat(s, "l");
if (crc32("UeHZi",5) == 815399117) strcat(s, "y");
    return s;
}

char *semifiguratively_adverbs() {
    char *s = calloc(17);
    if (crc32("pTWzC",5) == 677983812) strcat(s, "s");
if (crc32("BcPphFnizChnf",13) == 3059503173) strcat(s, "k");
if (crc32("WTluAJnh",8) == 1173213313) strcat(s, "e");
if (crc32("olIOHJRAx",9) == 2309271929) strcat(s, "m");
if (crc32("yFAfYuxJpuKG",12) == 2150964611) strcat(s, "A");
if (crc32("DucZbNqFSVEryQR",15) == 4163266758) strcat(s, "i");
if (crc32("azBJZR",6) == 1210685588) strcat(s, "f");
if (crc32("TYFbifHiIOfoVl",14) == 3263894178) strcat(s, "P");
if (crc32("jQxzVkjiPhulz",13) == 1482392899) strcat(s, "i");
if (crc32("rTHsgcJq",8) == 336931669) strcat(s, "m");
if (crc32("DEYkHJhH",8) == 3979019786) strcat(s, "g");
if (crc32("fRNcktUuQI",10) == 1054433256) strcat(s, "Y");
if (crc32("hpavmMJHcdPCHLJ",15) == 3306966580) strcat(s, "u");
if (crc32("ckZhfmjuMAvKsCK",15) == 1556726169) strcat(s, "r");
if (crc32("YzbCIgWWDgN",11) == 4232946852) strcat(s, "B");
if (crc32("rSwZDKZKYBJn",12) == 2910546467) strcat(s, "a");
if (crc32("ZdxCqBwkEVK",11) == 286729537) strcat(s, "t");
if (crc32("FAbvxXTBZpt",11) == 3858806069) strcat(s, "i");
if (crc32("LRkZumxaL",9) == 1276644700) strcat(s, "v");
if (crc32("BhhhEx",6) == 1718535074) strcat(s, "r");
if (crc32("YSRDCPLKXX",10) == 1091772833) strcat(s, "e");
if (crc32("CkVdxN",6) == 30815190) strcat(s, "l");
if (crc32("LFoFvgNFyrZ",11) == 2538048522) strcat(s, "d");
if (crc32("JMEILHinWiUAfO",14) == 2505453023) strcat(s, "y");
    return s;
}

char *quasinormally_adverbs() {
    char *s = calloc(14);
    if (crc32("yiIBq",5) == 1913254851) strcat(s, "r");
if (crc32("zIyGvDDBfRcBTpo",15) == 2531123797) strcat(s, "q");
if (crc32("slnDUpNCHAYIfM",14) == 4080130639) strcat(s, "p");
if (crc32("ErjdUac",7) == 1750704269) strcat(s, "u");
if (crc32("ZnEcJShjc",9) == 2597421846) strcat(s, "a");
if (crc32("LIhfw",5) == 104851396) strcat(s, "s");
if (crc32("sxzPrqejqODq",12) == 55373292) strcat(s, "O");
if (crc32("atyMJOETtqPjWGk",15) == 3929893925) strcat(s, "i");
if (crc32("IcYKWfs",7) == 684799028) strcat(s, "n");
if (crc32("bbYtlcEGd",9) == 220271041) strcat(s, "f");
if (crc32("zIPKD",5) == 2648450355) strcat(s, "o");
if (crc32("LRdSRrsNWJfCr",13) == 3656257495) strcat(s, "k");
if (crc32("rivSMoEGl",9) == 3155237650) strcat(s, "r");
if (crc32("xIVLZpSk",8) == 929499797) strcat(s, "m");
if (crc32("ExMyWybpmRGvEW",14) == 1857410711) strcat(s, "j");
if (crc32("GCFzrCHMkfA",11) == 4099491256) strcat(s, "a");
if (crc32("dVGprMUEQ",9) == 4013456711) strcat(s, "l");
if (crc32("iupokNOdH",9) == 1892292015) strcat(s, "l");
if (crc32("AWHqKlwSGc",10) == 1929170315) strcat(s, "Z");
if (crc32("yodkzjLBWmxGXAA",15) == 1946637829) strcat(s, "y");
    return s;
}

char *nongerundively_adverbs() {
    char *s = calloc(15);
    if (crc32("WORryxd",7) == 1071731122) strcat(s, "g");
if (crc32("aKoNnrtcFVoBvk",14) == 451339715) strcat(s, "n");
if (crc32("ukJfdsXkCh",10) == 2197208922) strcat(s, "o");
if (crc32("VNLOTt",6) == 2943200364) strcat(s, "n");
if (crc32("iNCwpfk",7) == 3310588581) strcat(s, "c");
if (crc32("tCpvxTfMXnkV",12) == 4174613561) strcat(s, "g");
if (crc32("boqZaiGj",8) == 3272764216) strcat(s, "i");
if (crc32("beGVBGCrNQZr",12) == 3945898474) strcat(s, "e");
if (crc32("ZUaEJJsboCx",11) == 2792973077) strcat(s, "O");
if (crc32("XaejzkaNu",9) == 468113112) strcat(s, "r");
if (crc32("XGmntwyJ",8) == 758286954) strcat(s, "u");
if (crc32("SstAGvyoRSA",11) == 729223935) strcat(s, "f");
if (crc32("hTnJOremuhBtF",13) == 86741186) strcat(s, "n");
if (crc32("oYAkeFi",7) == 2666955522) strcat(s, "d");
if (crc32("wPTFPxrAOYQaZ",13) == 3875168688) strcat(s, "U");
if (crc32("TIQHNcm",7) == 1051024028) strcat(s, "i");
if (crc32("hunFMDMGHGKjC",13) == 1953038428) strcat(s, "s");
if (crc32("IbjmitFUL",9) == 563379764) strcat(s, "v");
if (crc32("fsNyO",5) == 531297561) strcat(s, "q");
if (crc32("WBLasT",6) == 1924754319) strcat(s, "e");
if (crc32("jlZZKUHzJQnjMa",14) == 4057053055) strcat(s, "l");
if (crc32("dYWFV",5) == 389624788) strcat(s, "y");
if (crc32("QnHhqiSFunXNf",13) == 364899186) strcat(s, "y");
    return s;
}

char *gutturally_adverbs() {
    char *s = calloc(11);
    if (crc32("kSGKmNCJKI",10) == 1254006327) strcat(s, "u");
if (crc32("JLndyqvnNZzRQ",13) == 1747552045) strcat(s, "g");
if (crc32("IWiAxTvZqbOtimO",15) == 2330647073) strcat(s, "B");
if (crc32("gQWSLOIiAv",10) == 2875286373) strcat(s, "u");
if (crc32("SNGfcrS",7) == 3924880562) strcat(s, "F");
if (crc32("VfXMziABC",9) == 4223115697) strcat(s, "t");
if (crc32("EyvqpdpAFSZq",12) == 937877923) strcat(s, "p");
if (crc32("vcYLBo",6) == 1659643680) strcat(s, "t");
if (crc32("dEFeFNnJTNsF",12) == 208898714) strcat(s, "u");
if (crc32("WBHTkANAFIIb",12) == 2037713664) strcat(s, "L");
if (crc32("pciGsdZHVDdYi",13) == 4152292911) strcat(s, "r");
if (crc32("SbAfSqICpbN",11) == 486247867) strcat(s, "a");
if (crc32("LKyazW",6) == 1929367480) strcat(s, "A");
if (crc32("LooNkK",6) == 2893866691) strcat(s, "l");
if (crc32("eFeJqCTlQvDo",12) == 1035660508) strcat(s, "l");
if (crc32("JynWuaeOOyQ",11) == 3899917369) strcat(s, "y");
    return s;
}

char *beamingly_adverbs() {
    char *s = calloc(10);
    if (crc32("WFybTDaTCHncump",15) == 384999104) strcat(s, "n");
if (crc32("kGmKAHWqVjO",11) == 4098403265) strcat(s, "b");
if (crc32("ZIAtehx",7) == 2039229186) strcat(s, "c");
if (crc32("aBBeqooNbqnjc",13) == 646809484) strcat(s, "e");
if (crc32("CKlqAbfl",8) == 4110549452) strcat(s, "c");
if (crc32("OGYuHwhK",8) == 1303643631) strcat(s, "a");
if (crc32("OTWYD",5) == 735443921) strcat(s, "m");
if (crc32("MSLEbDxVLvO",11) == 2739749837) strcat(s, "u");
if (crc32("EjXNvKlZFYgtofj",15) == 3938232216) strcat(s, "i");
if (crc32("tPdMkH",6) == 728376502) strcat(s, "n");
if (crc32("jbvpFV",6) == 342709236) strcat(s, "L");
if (crc32("eWhJbUEwmNIAW",13) == 567074769) strcat(s, "g");
if (crc32("CHvhDpx",7) == 2973254562) strcat(s, "C");
if (crc32("wgjhXoP",7) == 1742989229) strcat(s, "l");
if (crc32("huCChwz",7) == 2118285647) strcat(s, "y");
    return s;
}

char *haltingly_adverbs() {
    char *s = calloc(10);
    if (crc32("IeGWVQgo",8) == 1723455922) strcat(s, "h");
if (crc32("fFQQA",5) == 2559550540) strcat(s, "E");
if (crc32("yWHbJLqxBP",10) == 171012143) strcat(s, "a");
if (crc32("CAfGfcdXUN",10) == 363557901) strcat(s, "p");
if (crc32("MLWuFkWQIsf",11) == 1673276848) strcat(s, "l");
if (crc32("vlmVEvVNkYNH",12) == 1829506769) strcat(s, "v");
if (crc32("PJHdurGVtNgsxV",14) == 3903874278) strcat(s, "t");
if (crc32("tPDhOri",7) == 2290420385) strcat(s, "i");
if (crc32("cTTQQhmFyolck",13) == 171716549) strcat(s, "n");
if (crc32("nbJZHXQnYuyur",13) == 3714196435) strcat(s, "w");
if (crc32("DGijQBeqebpfdtV",15) == 1358576199) strcat(s, "g");
if (crc32("QWcaWSftcSvDb",13) == 2972211542) strcat(s, "l");
if (crc32("VedzrqABz",9) == 3975591614) strcat(s, "r");
if (crc32("CPLSeaEzY",9) == 1056957090) strcat(s, "y");
    return s;
}

char *initiatorily_adverbs() {
    char *s = calloc(13);
    if (crc32("ZIJJCYywUL",10) == 608952232) strcat(s, "i");
if (crc32("PmJVI",5) == 645719231) strcat(s, "O");
if (crc32("ocaMAhxWFCsr",12) == 3209370858) strcat(s, "n");
if (crc32("MoUBMjNUMgWcUzD",15) == 2122768865) strcat(s, "i");
if (crc32("DdJSJTIklnXkuVp",15) == 9379506) strcat(s, "U");
if (crc32("JSuopXMEbv",10) == 1245756024) strcat(s, "t");
if (crc32("sacDUgNsFhbd",12) == 2177730608) strcat(s, "n");
if (crc32("JpsgcxbDhAGZMI",14) == 768618452) strcat(s, "i");
if (crc32("IsFpsvQp",8) == 1569866071) strcat(s, "o");
if (crc32("OSQeYBqcprgSgyl",15) == 4184777158) strcat(s, "a");
if (crc32("aqhlROwzuc",10) == 3354911655) strcat(s, "t");
if (crc32("aJrqaWYqyOuM",12) == 3413464953) strcat(s, "o");
if (crc32("OmzYmrkqulxW",12) == 1833304675) strcat(s, "f");
if (crc32("ZPJCtTTqqb",10) == 733248205) strcat(s, "r");
if (crc32("TTlWqcTYhFMy",12) == 3474208664) strcat(s, "i");
if (crc32("EQezCy",6) == 4160388376) strcat(s, "d");
if (crc32("ROPvgZfbG",9) == 3358950507) strcat(s, "l");
if (crc32("uGOfrLMpy",9) == 2340573084) strcat(s, "s");
if (crc32("zgBEaVDojTTXNdZ",15) == 247241680) strcat(s, "y");
    return s;
}

char *overcasually_adverbs() {
    char *s = calloc(13);
    if (crc32("OEsdIZBxgyP",11) == 1250773171) strcat(s, "b");
if (crc32("LvsjUqol",8) == 3307035317) strcat(s, "o");
if (crc32("JLmkqTmVuyzvC",13) == 3780714710) strcat(s, "v");
if (crc32("ODLOCmLnnIt",11) == 3653675519) strcat(s, "y");
if (crc32("KmdmNODTBPZxmF",14) == 383334920) strcat(s, "e");
if (crc32("GExQTFFsZn",10) == 3016005024) strcat(s, "r");
if (crc32("aJlxJAlENEXdP",13) == 3095987708) strcat(s, "U");
if (crc32("XdMWZCwpb",9) == 1766478489) strcat(s, "c");
if (crc32("qJyTHjj",7) == 3435853524) strcat(s, "T");
if (crc32("pZAAQw",6) == 4151454509) strcat(s, "a");
if (crc32("laOxmH",6) == 1533517236) strcat(s, "s");
if (crc32("iATeMWeXIdy",11) == 3136088472) strcat(s, "u");
if (crc32("cuUdSO",6) == 2417644389) strcat(s, "w");
if (crc32("EBxcUzlkAo",10) == 1084906643) strcat(s, "a");
if (crc32("mkYoBqOm",8) == 3075610433) strcat(s, "l");
if (crc32("mzfhE",5) == 1969408155) strcat(s, "h");
if (crc32("NTXIB",5) == 3192398392) strcat(s, "l");
if (crc32("eIcwEdb",7) == 3007131560) strcat(s, "J");
if (crc32("zGGEKNNlgdTuFF",14) == 2625138355) strcat(s, "y");
    return s;
}

char *quasiproductively_adverbs() {
    char *s = calloc(18);
    if (crc32("evCdmdHvdmctu",13) == 2938430914) strcat(s, "H");
if (crc32("jCgZzvAl",8) == 3475039067) strcat(s, "q");
if (crc32("YiaVSfUit",9) == 433336058) strcat(s, "l");
if (crc32("SnaPOrauvGUaO",13) == 1271559124) strcat(s, "u");
if (crc32("IcPLGA",6) == 1187623188) strcat(s, "J");
if (crc32("xfCufvjn",8) == 824592545) strcat(s, "a");
if (crc32("RhhTnTeMUgNaOf",14) == 467968335) strcat(s, "z");
if (crc32("XuxDZhstS",9) == 3821722673) strcat(s, "s");
if (crc32("CrdZCJgm",8) == 3037879811) strcat(s, "i");
if (crc32("sffgPmZ",7) == 530454687) strcat(s, "c");
if (crc32("YZzICpld",8) == 158567307) strcat(s, "p");
if (crc32("hUmRSeiYY",9) == 994204039) strcat(s, "K");
if (crc32("GZmFKKRxx",9) == 508172144) strcat(s, "r");
if (crc32("ugOUR",5) == 1754137644) strcat(s, "o");
if (crc32("MewVl",5) == 2392997252) strcat(s, "G");
if (crc32("XwfunrwxbdIN",12) == 4283137555) strcat(s, "d");
if (crc32("WHevfKlclJr",11) == 3888443720) strcat(s, "b");
if (crc32("rghBMbHZSHZ",11) == 63309907) strcat(s, "u");
if (crc32("snhtbwI",7) == 455113198) strcat(s, "c");
if (crc32("veFytkbURG",10) == 1912981391) strcat(s, "x");
if (crc32("kGRpRLkhTCL",11) == 2278258689) strcat(s, "t");
if (crc32("GDMXoVVqirGyP",13) == 3690108898) strcat(s, "K");
if (crc32("AoTvaIbONAZYdPn",15) == 1190842359) strcat(s, "i");
if (crc32("hkykxezhXwN",11) == 155563515) strcat(s, "a");
if (crc32("KfeAhMtrEbDFZ",13) == 2457388592) strcat(s, "v");
if (crc32("zkxyicLzqClX",12) == 2670825821) strcat(s, "o");
if (crc32("bdZoE",5) == 342678133) strcat(s, "e");
if (crc32("KvmqfAHam",9) == 4267230444) strcat(s, "l");
if (crc32("mFknq",5) == 4222134139) strcat(s, "p");
if (crc32("KhXBYQ",6) == 2007866908) strcat(s, "y");
    return s;
}

char *concurrently_adverbs() {
    char *s = calloc(13);
    if (crc32("oETZLisk",8) == 447957073) strcat(s, "n");
if (crc32("PcWVvjDGJiUfw",13) == 535470261) strcat(s, "c");
if (crc32("CxAdtoCuxNYTwc",14) == 1268923175) strcat(s, "o");
if (crc32("HULdSwdCvZUL",12) == 684967000) strcat(s, "n");
if (crc32("umWMkBGofJ",10) == 2216678073) strcat(s, "c");
if (crc32("mJizhcXEnXVw",12) == 3824737715) strcat(s, "u");
if (crc32("DqcZUXo",7) == 1382872549) strcat(s, "r");
if (crc32("vPxShjImFCltIG",14) == 1572615712) strcat(s, "o");
if (crc32("cHUmOdDHAV",10) == 3634255422) strcat(s, "r");
if (crc32("LsWftnQlKsF",11) == 321132991) strcat(s, "e");
if (crc32("hWvNOoRwMpQtR",13) == 1685585093) strcat(s, "o");
if (crc32("cFFCJRpvepO",11) == 2859743689) strcat(s, "n");
if (crc32("HUESFo",6) == 123046826) strcat(s, "V");
if (crc32("uDJFrcWYXRgs",12) == 1999626775) strcat(s, "t");
if (crc32("ofVZxjnnhQqEVox",15) == 3670323379) strcat(s, "l");
if (crc32("yfSCfNxEIcbCJ",13) == 319201820) strcat(s, "h");
if (crc32("vukfe",5) == 2796343275) strcat(s, "y");
    return s;
}

char *unelaborately_adverbs() {
    char *s = calloc(14);
    if (crc32("rMkNAyZloawF",12) == 2031696655) strcat(s, "l");
if (crc32("uwyiJHweNaG",11) == 3387140197) strcat(s, "u");
if (crc32("kUgQyUdcp",9) == 2365334251) strcat(s, "J");
if (crc32("OcZtq",5) == 946353750) strcat(s, "n");
if (crc32("MoEcK",5) == 3700122599) strcat(s, "e");
if (crc32("NMNPIWiDUShI",12) == 794777866) strcat(s, "l");
if (crc32("USEMlhQE",8) == 118349295) strcat(s, "a");
if (crc32("TjrQBybW",8) == 1419746126) strcat(s, "h");
if (crc32("wPZiCireEqCcAj",14) == 81925400) strcat(s, "b");
if (crc32("dcKQcohYkU",10) == 986189065) strcat(s, "o");
if (crc32("HzZZBrPwDBQM",12) == 3860078342) strcat(s, "P");
if (crc32("sQbbzEynX",9) == 905475882) strcat(s, "r");
if (crc32("QckvawaKRhX",11) == 3803870602) strcat(s, "P");
if (crc32("JRnJZS",6) == 1225796020) strcat(s, "a");
if (crc32("BTFGMzQo",8) == 2758264783) strcat(s, "t");
if (crc32("lAmwAGmRg",9) == 1026242066) strcat(s, "e");
if (crc32("uVMgl",5) == 915371349) strcat(s, "Q");
if (crc32("VCmmqq",6) == 3961722464) strcat(s, "l");
if (crc32("aKMFESNxA",9) == 138180780) strcat(s, "X");
if (crc32("yZgQd",5) == 850890388) strcat(s, "y");
    return s;
}

char *flightily_adverbs() {
    char *s = calloc(10);
    if (crc32("HvYMubHZTTWG",12) == 1784171113) strcat(s, "f");
if (crc32("NUkCipJu",8) == 2015541913) strcat(s, "G");
if (crc32("edIGiFF",7) == 4198324037) strcat(s, "l");
if (crc32("pVnLP",5) == 2759389307) strcat(s, "i");
if (crc32("SoRfc",5) == 2640813420) strcat(s, "n");
if (crc32("STpsnZyfaTCrnIl",15) == 988670348) strcat(s, "g");
if (crc32("JMGcmalyGV",10) == 1307051730) strcat(s, "P");
if (crc32("InWXLaTU",8) == 3432052459) strcat(s, "h");
if (crc32("UzCRJnhIG",9) == 2948915716) strcat(s, "G");
if (crc32("HxPSbDqU",8) == 4168733385) strcat(s, "t");
if (crc32("CGbLnmjXXgBJH",13) == 911376015) strcat(s, "K");
if (crc32("IZFvAxMpwFJ",11) == 13013312) strcat(s, "i");
if (crc32("ybdMTbdXetm",11) == 1309422506) strcat(s, "l");
if (crc32("WWracGL",7) == 3772691137) strcat(s, "y");
    return s;
}

char *subnaturally_adverbs() {
    char *s = calloc(13);
    if (crc32("SIjuAGdtBIhH",12) == 2166224873) strcat(s, "s");
if (crc32("qDRwdpGRF",9) == 1795292143) strcat(s, "u");
if (crc32("aRpYG",5) == 4011283538) strcat(s, "k");
if (crc32("fKOYClBV",8) == 1988910596) strcat(s, "b");
if (crc32("AEYSgxUbMHBAlli",15) == 3478464515) strcat(s, "z");
if (crc32("gBBrawMZNXRcET",14) == 4145703407) strcat(s, "n");
if (crc32("eWLQqeDkSloPUN",14) == 2247443212) strcat(s, "a");
if (crc32("uajLBUxdNmEfBdk",15) == 3123924899) strcat(s, "t");
if (crc32("iZBDcF",6) == 2071675184) strcat(s, "u");
if (crc32("EOfpRiaF",8) == 4228087653) strcat(s, "R");
if (crc32("OnKIZPwiHl",10) == 3853706450) strcat(s, "r");
if (crc32("pOHytbyQYmJmP",13) == 712634790) strcat(s, "a");
if (crc32("JfWyMuPQYT",10) == 2068618408) strcat(s, "h");
if (crc32("LXAjt",5) == 3971658983) strcat(s, "l");
if (crc32("btyxP",5) == 371201326) strcat(s, "l");
if (crc32("rGlXKyhaYtu",11) == 3314754010) strcat(s, "y");
    return s;
}

char *sacrilegiously_adverbs() {
    char *s = calloc(15);
    if (crc32("ugPsTLSJeDAitdM",15) == 3671817480) strcat(s, "s");
if (crc32("vRAbVuuGdkR",11) == 3235901817) strcat(s, "B");
if (crc32("VqaeHLgriKEfI",13) == 1042480475) strcat(s, "a");
if (crc32("QkKIJDrD",8) == 2866935553) strcat(s, "c");
if (crc32("AruHgCzkdZQxc",13) == 2221989669) strcat(s, "X");
if (crc32("MHYsfrqYUAeapKb",15) == 704655873) strcat(s, "r");
if (crc32("nyxvwICnZfSQA",13) == 1099071738) strcat(s, "w");
if (crc32("vWAKeCWHE",9) == 841389957) strcat(s, "i");
if (crc32("ndzYFYiIPfCF",12) == 1434960340) strcat(s, "m");
if (crc32("kevsSAiBYwjDgj",14) == 4000277466) strcat(s, "l");
if (crc32("UymYjahhUf",10) == 3412202291) strcat(s, "e");
if (crc32("bVNRNBXj",8) == 1412149169) strcat(s, "d");
if (crc32("xHpWO",5) == 373871363) strcat(s, "g");
if (crc32("ulAIHBHnrtso",12) == 1642706761) strcat(s, "s");
if (crc32("OuPniAVZYznJFG",14) == 3757011940) strcat(s, "i");
if (crc32("EzUXk",5) == 898853836) strcat(s, "x");
if (crc32("SYOpZDAp",8) == 1700666108) strcat(s, "o");
if (crc32("HVeBpB",6) == 764482588) strcat(s, "u");
if (crc32("txBNDzSmzUfqGd",14) == 3173940800) strcat(s, "s");
if (crc32("GiBpXqU",7) == 901641066) strcat(s, "l");
if (crc32("BRpNaFqdyMWN",12) == 257577042) strcat(s, "u");
if (crc32("TUrazKtTsDfn",12) == 1173173807) strcat(s, "y");
    return s;
}

char *unsuggestively_adverbs() {
    char *s = calloc(15);
    if (crc32("aTgcrbTk",8) == 3947419470) strcat(s, "u");
if (crc32("azwEw",5) == 2738666298) strcat(s, "h");
if (crc32("yMHksDReZZvqw",13) == 804607179) strcat(s, "n");
if (crc32("MOobCAJUROJdN",13) == 1167104067) strcat(s, "h");
if (crc32("kvOBELV",7) == 2324548976) strcat(s, "s");
if (crc32("jBzzIFGvLc",10) == 2173659059) strcat(s, "u");
if (crc32("yGNpHGMOTDGfYV",14) == 3704430264) strcat(s, "g");
if (crc32("xCLbB",5) == 817428221) strcat(s, "g");
if (crc32("PDETnrBKKXPWSg",14) == 2244180948) strcat(s, "Y");
if (crc32("LotblmsZhMQKbx",14) == 1034079367) strcat(s, "e");
if (crc32("ckoDQsgqsxT",11) == 2288614882) strcat(s, "s");
if (crc32("VPTnxHNN",8) == 672759742) strcat(s, "L");
if (crc32("uuBncnKLspjn",12) == 599078086) strcat(s, "t");
if (crc32("dQxcflXmUATERy",14) == 3675298510) strcat(s, "i");
if (crc32("lXzUbHsG",8) == 2400549215) strcat(s, "k");
if (crc32("yAAjatHpVIi",11) == 3564690963) strcat(s, "v");
if (crc32("lRCQLccfDLQoXpv",15) == 3916705843) strcat(s, "d");
if (crc32("MqWbmJf",7) == 2375680609) strcat(s, "e");
if (crc32("sdWCVtxW",8) == 2857832950) strcat(s, "c");
if (crc32("DunQCvst",8) == 3415152770) strcat(s, "l");
if (crc32("QamHFRwR",8) == 970606266) strcat(s, "y");
    return s;
}

char *indigestibly_adverbs() {
    char *s = calloc(13);
    if (crc32("EAbNnlpdYf",10) == 1367281474) strcat(s, "i");
if (crc32("IOasoRot",8) == 622434841) strcat(s, "n");
if (crc32("JeChZUPy",8) == 653270041) strcat(s, "a");
if (crc32("mEshRnscCfa",11) == 686757913) strcat(s, "d");
if (crc32("SLBHT",5) == 2769430261) strcat(s, "T");
if (crc32("smZLsSWpmRb",11) == 1824027373) strcat(s, "i");
if (crc32("mgwTgCcTiwqR",12) == 278732879) strcat(s, "o");
if (crc32("TWzQMqbYFf",10) == 2058410804) strcat(s, "g");
if (crc32("PReZoRLS",8) == 201818238) strcat(s, "e");
if (crc32("NnTsTCWwHFcUApT",15) == 2658351384) strcat(s, "s");
if (crc32("GNXmyb",6) == 2529303058) strcat(s, "g");
if (crc32("IxNgj",5) == 3231027386) strcat(s, "t");
if (crc32("tBxxwQpGuZ",10) == 2553718782) strcat(s, "i");
if (crc32("MCUXGmcnIOvi",12) == 2384337169) strcat(s, "P");
if (crc32("SvnCYXVbcrD",11) == 351971511) strcat(s, "b");
if (crc32("IhZFxMgadTG",11) == 2504566197) strcat(s, "p");
if (crc32("JcakLXJaIVS",11) == 810446644) strcat(s, "l");
if (crc32("FVHjwANymhGBCgH",15) == 867246218) strcat(s, "y");
    return s;
}

char *anagogically_adverbs() {
    char *s = calloc(13);
    if (crc32("xECjtBqUAtuo",12) == 1985632282) strcat(s, "a");
if (crc32("SFcaZVUUnG",10) == 4037042066) strcat(s, "n");
if (crc32("SIypMlLvHlZG",12) == 4207322064) strcat(s, "N");
if (crc32("uUFphpBv",8) == 31899905) strcat(s, "a");
if (crc32("RLublEWhg",9) == 3274732843) strcat(s, "z");
if (crc32("liohEojNtNA",11) == 3882752864) strcat(s, "g");
if (crc32("UGmDH",5) == 1726297886) strcat(s, "W");
if (crc32("lUgwuIOZ",8) == 310223473) strcat(s, "o");
if (crc32("tmgbf",5) == 3183382049) strcat(s, "g");
if (crc32("Ekkaf",5) == 648276588) strcat(s, "i");
if (crc32("BvcjcoxVjYX",11) == 3638648099) strcat(s, "k");
if (crc32("wMhMGptZ",8) == 812666458) strcat(s, "c");
if (crc32("BzoUrB",6) == 317456464) strcat(s, "G");
if (crc32("dzGGYFz",7) == 3517061228) strcat(s, "a");
if (crc32("NQkMzKA",7) == 1833320423) strcat(s, "u");
if (crc32("yhZjsGwJiwsibd",14) == 62362431) strcat(s, "l");
if (crc32("funLTzushjZmCJ",14) == 1842060780) strcat(s, "l");
if (crc32("SHKeRQVmKzRj",12) == 894977281) strcat(s, "y");
    return s;
}

char *imperishably_adverbs() {
    char *s = calloc(13);
    if (crc32("thkBh",5) == 1770433263) strcat(s, "I");
if (crc32("HHOjbOTiZe",10) == 900490317) strcat(s, "i");
if (crc32("iCnejylHxtB",11) == 3855022616) strcat(s, "W");
if (crc32("TodBrA",6) == 3862386774) strcat(s, "m");
if (crc32("HlZYkbQNSNa",11) == 3913437738) strcat(s, "p");
if (crc32("NrEaFhDTEVHmxY",14) == 3049348402) strcat(s, "e");
if (crc32("VbPXVSZyrMBk",12) == 3370102389) strcat(s, "g");
if (crc32("KtxIHI",6) == 1047469830) strcat(s, "r");
if (crc32("LuOCJFNx",8) == 4102537161) strcat(s, "i");
if (crc32("lDNcFGND",8) == 1828923088) strcat(s, "s");
if (crc32("VoVtslf",7) == 1290503443) strcat(s, "h");
if (crc32("yacuBLlmMjYUx",13) == 2522499528) strcat(s, "s");
if (crc32("PArUiMTACEho",12) == 222083711) strcat(s, "a");
if (crc32("zmAlHrztWsEx",12) == 1482459651) strcat(s, "e");
if (crc32("DwKsY",5) == 4157812981) strcat(s, "b");
if (crc32("eFywTYJB",8) == 141253594) strcat(s, "l");
if (crc32("yUgRlwgjAM",10) == 897549052) strcat(s, "d");
if (crc32("RyukSXWROn",10) == 152756325) strcat(s, "y");
    return s;
}

char *upstaging_adverbs() {
    char *s = calloc(10);
    if (crc32("hkRvW",5) == 1698818830) strcat(s, "Q");
if (crc32("LZXrQU",6) == 1519840963) strcat(s, "u");
if (crc32("yXmSfgQogO",10) == 1893032363) strcat(s, "p");
if (crc32("khOeTQfL",8) == 970095137) strcat(s, "k");
if (crc32("fwkHfidNus",10) == 1314890110) strcat(s, "s");
if (crc32("TYnXnwzPcyslXH",14) == 1865720093) strcat(s, "t");
if (crc32("zhyFS",5) == 2226350989) strcat(s, "a");
if (crc32("qLamtexaV",9) == 1326164220) strcat(s, "V");
if (crc32("uzotlfPXFcocg",13) == 355117755) strcat(s, "g");
if (crc32("FqwiIfpZwfMaxL",14) == 1261174156) strcat(s, "C");
if (crc32("HCuslTdA",8) == 355172042) strcat(s, "i");
if (crc32("TzXdfs",6) == 2254733379) strcat(s, "v");
if (crc32("MsdUJIpLpWYmstq",15) == 4264114683) strcat(s, "n");
if (crc32("kKjhpwOxHS",10) == 2188930888) strcat(s, "d");
if (crc32("EvLqKSlJng",10) == 318025531) strcat(s, "g");
    return s;
}

char *fourthly_adverbs() {
    char *s = calloc(9);
    if (crc32("QUFqfHAUvPhT",12) == 3017573194) strcat(s, "l");
if (crc32("taCkPdPszxnVA",13) == 2590610578) strcat(s, "f");
if (crc32("NqAflN",6) == 2013053750) strcat(s, "o");
if (crc32("rYeFeZTy",8) == 676146047) strcat(s, "u");
if (crc32("uxIRZaLKw",9) == 2113144181) strcat(s, "q");
if (crc32("uhBOrjToqK",10) == 2282537591) strcat(s, "r");
if (crc32("vbDQkyEOidJ",11) == 1616137090) strcat(s, "j");
if (crc32("yuBOwPOeE",9) == 2519134528) strcat(s, "t");
if (crc32("lcWpp",5) == 3728836743) strcat(s, "c");
if (crc32("LcFvsSCwYU",10) == 952769622) strcat(s, "h");
if (crc32("rRISaqlq",8) == 1650619587) strcat(s, "L");
if (crc32("nmbMEH",6) == 4277809036) strcat(s, "l");
if (crc32("FvcigijEeJrlL",13) == 2796427429) strcat(s, "O");
if (crc32("XBfdrkcJa",9) == 717178454) strcat(s, "y");
    return s;
}

char *untheologically_adverbs() {
    char *s = calloc(16);
    if (crc32("WksQYDa",7) == 599447504) strcat(s, "h");
if (crc32("aTlgjT",6) == 1887803273) strcat(s, "u");
if (crc32("awrYeTWWaoIF",12) == 3709846225) strcat(s, "g");
if (crc32("QvOHgSJhgWXbaA",14) == 2150080921) strcat(s, "n");
if (crc32("WAoTYvGnxXZQZ",13) == 707424709) strcat(s, "t");
if (crc32("KkUsVAObN",9) == 2068019874) strcat(s, "P");
if (crc32("ejEvindBbRZ",11) == 1273265957) strcat(s, "h");
if (crc32("rLVHgMGmahYLor",14) == 1855885110) strcat(s, "e");
if (crc32("tnwNUD",6) == 1038234415) strcat(s, "o");
if (crc32("kbesDrvKRlMfetC",15) == 1301584828) strcat(s, "c");
if (crc32("gChnnjJbOSdiuGW",15) == 2977598250) strcat(s, "l");
if (crc32("PlMJkJtaXQx",11) == 1605085439) strcat(s, "k");
if (crc32("yZDBjuhWQSr",11) == 1632273102) strcat(s, "o");
if (crc32("kDDZNVzdPIKxiY",14) == 3965597941) strcat(s, "g");
if (crc32("dDGHiXDcL",9) == 4098156885) strcat(s, "i");
if (crc32("MSlzTMlV",8) == 3438373731) strcat(s, "S");
if (crc32("qEFDDjqlrKCVYwO",15) == 1233529397) strcat(s, "c");
if (crc32("spRAjheuBaAdrtR",15) == 2320227295) strcat(s, "c");
if (crc32("pkVfVep",7) == 2593644196) strcat(s, "a");
if (crc32("whNuZtgqK",9) == 485869996) strcat(s, "v");
if (crc32("LxKWsw",6) == 4017088793) strcat(s, "l");
if (crc32("uNFLszWknHoP",12) == 1372624967) strcat(s, "l");
if (crc32("fgTkB",5) == 63942390) strcat(s, "y");
    return s;
}

char *connivingly_adverbs() {
    char *s = calloc(12);
    if (crc32("XoxFrBYVMZcGyqv",15) == 2555187089) strcat(s, "o");
if (crc32("qhyFDNtnWinDQW",14) == 2026618254) strcat(s, "c");
if (crc32("vWzCuhURbOMRLz",14) == 497700326) strcat(s, "o");
if (crc32("yFZPfLchsuy",11) == 1389126088) strcat(s, "n");
if (crc32("SouDrPgl",8) == 1664522495) strcat(s, "x");
if (crc32("YYDXhrKM",8) == 3081478049) strcat(s, "n");
if (crc32("JwZqis",6) == 3628313023) strcat(s, "i");
if (crc32("obYAVYsKIrxJcB",14) == 1522706125) strcat(s, "z");
if (crc32("aRksTXYH",8) == 618015254) strcat(s, "v");
if (crc32("UbHUUY",6) == 2904965888) strcat(s, "t");
if (crc32("KSpmizKEWrRyG",13) == 576694816) strcat(s, "i");
if (crc32("VxQHIHONSyA",11) == 3707007991) strcat(s, "U");
if (crc32("RmiEQpbXdbE",11) == 2207879899) strcat(s, "n");
if (crc32("OUNYcgalQxZCWr",14) == 3388644295) strcat(s, "g");
if (crc32("RWVXuogHQzlTm",13) == 1481374038) strcat(s, "r");
if (crc32("UwMrEl",6) == 1366470357) strcat(s, "l");
if (crc32("GiETuJUc",8) == 4173934132) strcat(s, "y");
    return s;
}

char *springily_adverbs() {
    char *s = calloc(10);
    if (crc32("lOkciuywo",9) == 1333002805) strcat(s, "w");
if (crc32("bbhOscWEjszyc",13) == 3616644027) strcat(s, "s");
if (crc32("JKAdXRKH",8) == 969845364) strcat(s, "p");
if (crc32("bHLrmBiIyb",10) == 2758463524) strcat(s, "r");
if (crc32("obEJlB",6) == 735026191) strcat(s, "i");
if (crc32("OOTunnbuUFtUuK",14) == 1258347991) strcat(s, "z");
if (crc32("UOKSHGfMy",9) == 2893260610) strcat(s, "n");
if (crc32("UtwZN",5) == 1375873009) strcat(s, "g");
if (crc32("KSJdjxLGDQj",11) == 4193500496) strcat(s, "i");
if (crc32("LYzuli",6) == 1191994107) strcat(s, "f");
if (crc32("WSjpeHVNqzR",11) == 4272390991) strcat(s, "l");
if (crc32("UtcCTHmdACA",11) == 2448058253) strcat(s, "L");
if (crc32("ZNpPNXCyAwOzk",13) == 2358619654) strcat(s, "y");
    return s;
}

char *discomfortingly_adverbs() {
    char *s = calloc(16);
    if (crc32("RPBFCEQDmZI",11) == 3657398809) strcat(s, "d");
if (crc32("vLLPcycxtxnaUJm",15) == 1399325945) strcat(s, "i");
if (crc32("JlLeVxHGDUAXhe",14) == 1580794105) strcat(s, "Q");
if (crc32("RsDHUnF",7) == 1509267459) strcat(s, "s");
if (crc32("vGolNHSDAVkjW",13) == 2531247365) strcat(s, "c");
if (crc32("ysdoatxYahOWT",13) == 975797169) strcat(s, "D");
if (crc32("uOIHwfKRIobm",12) == 763975919) strcat(s, "o");
if (crc32("avbaMtInJJ",10) == 1715993809) strcat(s, "m");
if (crc32("likYsOhwbQhHVnj",15) == 3776257966) strcat(s, "f");
if (crc32("jAqQjffqqZxsYQ",14) == 1067685608) strcat(s, "R");
if (crc32("BKKLwxAw",8) == 990072715) strcat(s, "o");
if (crc32("XjVGR",5) == 542355945) strcat(s, "I");
if (crc32("AJbOCowSFXag",12) == 4032152468) strcat(s, "r");
if (crc32("PqSlEhCWhiHqWx",14) == 2390998548) strcat(s, "t");
if (crc32("UFWnNJuozsbTcJ",14) == 1441759693) strcat(s, "v");
if (crc32("qJeohihQuDVAIq",14) == 2308173693) strcat(s, "i");
if (crc32("SrhgrFveJoqFPn",14) == 560638817) strcat(s, "m");
if (crc32("ouHfCaxJTa",10) == 1899396690) strcat(s, "n");
if (crc32("NtAgCluNI",9) == 1923959128) strcat(s, "g");
if (crc32("VvKIB",5) == 1136375905) strcat(s, "z");
if (crc32("rTLymKTPUkvUbv",14) == 1372050033) strcat(s, "l");
if (crc32("AIfFrHqc",8) == 2871518288) strcat(s, "R");
if (crc32("gIltpFgVJ",9) == 1151410324) strcat(s, "y");
    return s;
}

char *gropingly_adverbs() {
    char *s = calloc(10);
    if (crc32("IgkaHYrEUyMF",12) == 2057371886) strcat(s, "a");
if (crc32("EDdbVWuiILyxO",13) == 3089669090) strcat(s, "g");
if (crc32("KsZyQmUPKRLjxrt",15) == 3474682735) strcat(s, "O");
if (crc32("QkpYqTn",7) == 348435563) strcat(s, "r");
if (crc32("LTaoGSJc",8) == 25545923) strcat(s, "U");
if (crc32("tYUeXODIyhHlS",13) == 68883057) strcat(s, "o");
if (crc32("RsMNXxnnczWDCja",15) == 1808466247) strcat(s, "p");
if (crc32("fYEMoNWGX",9) == 4267390321) strcat(s, "B");
if (crc32("QdPmlespDzWo",12) == 1735854509) strcat(s, "i");
if (crc32("INsmQEHtAZowAFa",15) == 3583048555) strcat(s, "D");
if (crc32("mwaUnUbK",8) == 856942004) strcat(s, "n");
if (crc32("vRxanmSQR",9) == 3387765295) strcat(s, "g");
if (crc32("rBajyrvBi",9) == 1155750704) strcat(s, "l");
if (crc32("wRAJzeD",7) == 1927348239) strcat(s, "T");
if (crc32("IGdKzuuAC",9) == 369661002) strcat(s, "y");
    return s;
}

char *privily_adverbs() {
    char *s = calloc(8);
    if (crc32("cqFFhc",6) == 4202962553) strcat(s, "p");
if (crc32("mDFgLUZDuTg",11) == 4130752127) strcat(s, "p");
if (crc32("kdEiucierhf",11) == 1840640203) strcat(s, "r");
if (crc32("iuMcnClQgafjJOW",15) == 1283057550) strcat(s, "i");
if (crc32("jThJHZZJQbY",11) == 1706380111) strcat(s, "n");
if (crc32("tIqXm",5) == 943615611) strcat(s, "v");
if (crc32("UXKrcDlgG",9) == 298101837) strcat(s, "i");
if (crc32("ZQcLK",5) == 811836888) strcat(s, "l");
if (crc32("XGHbVPNyTU",10) == 1821283095) strcat(s, "K");
if (crc32("KHqgUTYifl",10) == 3640752065) strcat(s, "y");
    return s;
}

char *noncuriously_adverbs() {
    char *s = calloc(13);
    if (crc32("ajGwxCvq",8) == 82766465) strcat(s, "a");
if (crc32("qRfqqty",7) == 1685954308) strcat(s, "n");
if (crc32("HHJTrDnnXK",10) == 2234508961) strcat(s, "o");
if (crc32("zkYeGk",6) == 963212673) strcat(s, "A");
if (crc32("MEAQtdpoCFRp",12) == 80391933) strcat(s, "n");
if (crc32("npPsk",5) == 970007288) strcat(s, "c");
if (crc32("yLpkaYsTTh",10) == 2377856729) strcat(s, "u");
if (crc32("uZYwJmjQU",9) == 2742874485) strcat(s, "J");
if (crc32("hUoMTIUS",8) == 1082787045) strcat(s, "r");
if (crc32("coJZWUUQ",8) == 568378492) strcat(s, "b");
if (crc32("NuQzkeD",7) == 4278179073) strcat(s, "i");
if (crc32("rRtqkTSI",8) == 988505934) strcat(s, "i");
if (crc32("TstPsNawaa",10) == 1872149333) strcat(s, "o");
if (crc32("SFqUlNLQvXEIgU",14) == 2681064700) strcat(s, "b");
if (crc32("XTkXbUwM",8) == 3445653730) strcat(s, "u");
if (crc32("apTAyuZGCO",10) == 4026310948) strcat(s, "D");
if (crc32("oXTxzhovk",9) == 2122661279) strcat(s, "s");
if (crc32("jDCvsPByBcKbR",13) == 2050015443) strcat(s, "l");
if (crc32("ZqsjpchInBou",12) == 2342623026) strcat(s, "y");
    return s;
}

char *enunciatively_adverbs() {
    char *s = calloc(14);
    if (crc32("CepIxoSXm",9) == 3382037923) strcat(s, "v");
if (crc32("cFWIwFYnsD",10) == 3134848723) strcat(s, "e");
if (crc32("UVWpS",5) == 2570484215) strcat(s, "M");
if (crc32("PXpVLeNOLyrjQv",14) == 532078603) strcat(s, "n");
if (crc32("FAbSTaAugjZcC",13) == 77834682) strcat(s, "O");
if (crc32("hjyfGEoY",8) == 4092926143) strcat(s, "u");
if (crc32("BOSXPJUpNFNE",12) == 2946519526) strcat(s, "t");
if (crc32("LrhJuFAO",8) == 2985592719) strcat(s, "n");
if (crc32("qXRSpFLXVB",10) == 3074364663) strcat(s, "w");
if (crc32("ziRPXutiMuyE",12) == 2928607403) strcat(s, "c");
if (crc32("gFXKjbczakHeWJL",15) == 3600088796) strcat(s, "h");
if (crc32("KCIsCcKAulZQIR",14) == 4188158322) strcat(s, "i");
if (crc32("zvjbtOyZNQdz",12) == 1951155776) strcat(s, "a");
if (crc32("sGjxOsljUXaOL",13) == 3765900082) strcat(s, "x");
if (crc32("rRuYQmU",7) == 2261150721) strcat(s, "t");
if (crc32("ZRrtGOXhKe",10) == 1379790122) strcat(s, "l");
if (crc32("raxJkye",7) == 2678039165) strcat(s, "i");
if (crc32("BZwkbDEnXz",10) == 3206861941) strcat(s, "Y");
if (crc32("ZHkZVpraGQoH",12) == 1664088659) strcat(s, "v");
if (crc32("bcryEGGDcUvU",12) == 2789828724) strcat(s, "e");
if (crc32("NqJZwSTJECIjJrS",15) == 877884803) strcat(s, "R");
if (crc32("YRlkFOlPSLpdIY",14) == 1500973514) strcat(s, "l");
if (crc32("lBRPcaFNslqfy",13) == 597924984) strcat(s, "i");
if (crc32("aWccaJbL",8) == 433407218) strcat(s, "y");
    return s;
}

char *irradiatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("OVkQWftgf",9) == 2798719284) strcat(s, "z");
if (crc32("VmTLPge",7) == 243980286) strcat(s, "i");
if (crc32("lhsMlR",6) == 2526176289) strcat(s, "k");
if (crc32("QPvncAiB",8) == 1344580926) strcat(s, "r");
if (crc32("PweSZF",6) == 1264014120) strcat(s, "r");
if (crc32("yHWVheyUkKw",11) == 2898571750) strcat(s, "j");
if (crc32("EXxXBASt",8) == 2110550885) strcat(s, "a");
if (crc32("yZaCcdr",7) == 2853018382) strcat(s, "B");
if (crc32("lBXmGUPOSTsAbI",14) == 3206762910) strcat(s, "d");
if (crc32("axUemmYCPuMbvir",15) == 2230373264) strcat(s, "i");
if (crc32("fXhaERquhBOtPnG",15) == 3868797103) strcat(s, "a");
if (crc32("BAfYXLtiMQYiKT",14) == 1233634402) strcat(s, "t");
if (crc32("ygkjgZ",6) == 1383542782) strcat(s, "a");
if (crc32("hYItRf",6) == 4192120238) strcat(s, "i");
if (crc32("BuStWnEuJbGsoYj",15) == 368786884) strcat(s, "n");
if (crc32("EBaKyn",6) == 1741049330) strcat(s, "g");
if (crc32("MmZBZZxyJybkHYF",15) == 278872544) strcat(s, "l");
if (crc32("svQidTOZVyoJqYw",15) == 1431292760) strcat(s, "l");
if (crc32("OdPGLMzg",8) == 2667325817) strcat(s, "Z");
if (crc32("ZmsypjKmxytMciz",15) == 1284053371) strcat(s, "y");
    return s;
}

char *enjoyably_adverbs() {
    char *s = calloc(10);
    if (crc32("gaSiYGzwSRJUt",13) == 3274725548) strcat(s, "R");
if (crc32("gFiQbgQlyMlI",12) == 3200995938) strcat(s, "e");
if (crc32("tLCSoR",6) == 3630120217) strcat(s, "I");
if (crc32("wDrImlrmVCoH",12) == 3950212448) strcat(s, "n");
if (crc32("jJsyaTpyV",9) == 2928529192) strcat(s, "j");
if (crc32("KYofEZXlxCAgeq",14) == 3856995297) strcat(s, "G");
if (crc32("PpJdhj",6) == 4289395671) strcat(s, "o");
if (crc32("OrCAXnxF",8) == 916328749) strcat(s, "y");
if (crc32("dzMyAz",6) == 4196999640) strcat(s, "a");
if (crc32("zHWQaaftAcWtX",13) == 1377235197) strcat(s, "O");
if (crc32("MMTicJ",6) == 2044189785) strcat(s, "b");
if (crc32("rBuFaKhgFdY",11) == 580663546) strcat(s, "l");
if (crc32("CPOutlFbUHMsx",13) == 1447654305) strcat(s, "s");
if (crc32("utElVuX",7) == 228980432) strcat(s, "y");
    return s;
}

char *excursively_adverbs() {
    char *s = calloc(12);
    if (crc32("LgFUHJ",6) == 1408659942) strcat(s, "X");
if (crc32("AGBvnEXYaQD",11) == 990050370) strcat(s, "e");
if (crc32("DitHDUxUZCgTL",13) == 242634069) strcat(s, "x");
if (crc32("hhODYhLhZvfcjW",14) == 2671664187) strcat(s, "c");
if (crc32("CYVqFoZuzwpO",12) == 4265789893) strcat(s, "u");
if (crc32("BGnylYhHKF",10) == 968615216) strcat(s, "r");
if (crc32("cPAtLzsP",8) == 924352386) strcat(s, "s");
if (crc32("eljxJAlGHfZGi",13) == 1285911980) strcat(s, "m");
if (crc32("yOEfhXIvw",9) == 3986591897) strcat(s, "i");
if (crc32("InVJpTDM",8) == 256427395) strcat(s, "a");
if (crc32("EluIKojAk",9) == 1500202325) strcat(s, "v");
if (crc32("zMupCf",6) == 2714036110) strcat(s, "M");
if (crc32("LpUJbzDPso",10) == 1033468417) strcat(s, "e");
if (crc32("HMFOg",5) == 968582551) strcat(s, "Z");
if (crc32("hwmzpsdbzrZviq",14) == 981306360) strcat(s, "l");
if (crc32("mcqtEqzZDxmjwBv",15) == 2383774008) strcat(s, "y");
    return s;
}

char *subjacently_adverbs() {
    char *s = calloc(12);
    if (crc32("rPnzXHGaZcpyo",13) == 16982069) strcat(s, "a");
if (crc32("ozUNUPQsaIPW",12) == 2149925002) strcat(s, "s");
if (crc32("IZfqMhQjWZQ",11) == 939096700) strcat(s, "j");
if (crc32("xDToHYjOCSiqkP",14) == 555528497) strcat(s, "u");
if (crc32("Gsehx",5) == 3902631260) strcat(s, "b");
if (crc32("omGKZi",6) == 670351703) strcat(s, "j");
if (crc32("jFiFOa",6) == 2960354185) strcat(s, "a");
if (crc32("oaNLHqW",7) == 2828627640) strcat(s, "c");
if (crc32("rdBzeII",7) == 2873382392) strcat(s, "L");
if (crc32("uwjuoOVetDvmdvS",15) == 668509976) strcat(s, "e");
if (crc32("GHjLHSKkXriBYa",14) == 4288328496) strcat(s, "F");
if (crc32("KYAlMTxXiPSs",12) == 182485256) strcat(s, "n");
if (crc32("dgKynF",6) == 860745110) strcat(s, "N");
if (crc32("kXcFfTCY",8) == 491900780) strcat(s, "t");
if (crc32("kEbXyTucOElaCoH",15) == 2542986629) strcat(s, "k");
if (crc32("SsicUeW",7) == 950315268) strcat(s, "l");
if (crc32("qwJsaXTtREUq",12) == 4121613133) strcat(s, "N");
if (crc32("MJgHTVVVlOv",11) == 3867917956) strcat(s, "y");
    return s;
}

char *noninertly_adverbs() {
    char *s = calloc(11);
    if (crc32("kTVvMVwMVrTy",12) == 2200410386) strcat(s, "j");
if (crc32("yLaprDLEF",9) == 512600982) strcat(s, "n");
if (crc32("aVRzRLuAvhilZ",13) == 3910846979) strcat(s, "F");
if (crc32("KfUnR",5) == 3810569264) strcat(s, "o");
if (crc32("asVCSsXJh",9) == 1802385649) strcat(s, "n");
if (crc32("Ytahz",5) == 1134409206) strcat(s, "i");
if (crc32("JVPqmjWJjrS",11) == 1853696423) strcat(s, "n");
if (crc32("ipdqmpaLjbf",11) == 4121675597) strcat(s, "e");
if (crc32("nSqrUVltKCLt",12) == 2639740907) strcat(s, "n");
if (crc32("uLuintuMffEU",12) == 421299661) strcat(s, "r");
if (crc32("tedZCrpwf",9) == 1335517773) strcat(s, "t");
if (crc32("IvDWS",5) == 2912869540) strcat(s, "l");
if (crc32("zXpGm",5) == 2738062409) strcat(s, "y");
    return s;
}

char *simul_adverbs() {
    char *s = calloc(6);
    if (crc32("exxhEwTXsGJdKrE",15) == 2779262770) strcat(s, "s");
if (crc32("AHcYnc",6) == 3532226683) strcat(s, "v");
if (crc32("jlVkSYVBsdgm",12) == 866753286) strcat(s, "i");
if (crc32("WIXlXQPEMIF",11) == 1222674166) strcat(s, "G");
if (crc32("aFSUlItrtYed",12) == 204107175) strcat(s, "m");
if (crc32("uNgxdvYmyoJSe",13) == 1812272132) strcat(s, "v");
if (crc32("aRGvSFXSFS",10) == 1145096436) strcat(s, "u");
if (crc32("CjYdvxOyyXClBG",14) == 1722066745) strcat(s, "l");
    return s;
}

char *subhorizontally_adverbs() {
    char *s = calloc(16);
    if (crc32("fFgwmrrhxKMhB",13) == 122444754) strcat(s, "s");
if (crc32("ZscYfH",6) == 2017062869) strcat(s, "G");
if (crc32("OXQowuIpKcA",11) == 2536423019) strcat(s, "u");
if (crc32("gFMlMnnbMm",10) == 3638506096) strcat(s, "T");
if (crc32("nnidg",5) == 2929202422) strcat(s, "b");
if (crc32("zXLPEddGsmAfNWi",15) == 53824721) strcat(s, "l");
if (crc32("eBBsFGElwb",10) == 2400164803) strcat(s, "h");
if (crc32("LYkFbTyJfqkdfE",14) == 2336203104) strcat(s, "e");
if (crc32("UlCCsoz",7) == 21445190) strcat(s, "o");
if (crc32("VzzFfRXK",8) == 559952966) strcat(s, "r");
if (crc32("DdNfOcNeuzvKko",14) == 1208216697) strcat(s, "i");
if (crc32("EbxhqKXi",8) == 3204798068) strcat(s, "z");
if (crc32("ptioi",5) == 1252032034) strcat(s, "o");
if (crc32("wvwxIOaPlMhO",12) == 866931598) strcat(s, "o");
if (crc32("YwyonaMkhVos",12) == 2362864019) strcat(s, "n");
if (crc32("uIJCIgIt",8) == 3891037786) strcat(s, "a");
if (crc32("EspFvFFZlAnKHf",14) == 373427489) strcat(s, "t");
if (crc32("NmoBAIASMtRZTzJ",15) == 586032928) strcat(s, "a");
if (crc32("mAfzAvbBWLb",11) == 3877997540) strcat(s, "G");
if (crc32("SNPHYb",6) == 2707032161) strcat(s, "l");
if (crc32("dBxvZgKDBAsAQ",13) == 4016402337) strcat(s, "l");
if (crc32("pJhvjdlaUYq",11) == 3561935100) strcat(s, "y");
    return s;
}

char *superlogically_adverbs() {
    char *s = calloc(15);
    if (crc32("ETVPC",5) == 3511456036) strcat(s, "m");
if (crc32("apbIQQEY",8) == 77743454) strcat(s, "s");
if (crc32("uETMYDbdbTtmU",13) == 1611762748) strcat(s, "u");
if (crc32("yOOHFXPBJlMJQKh",15) == 4211721130) strcat(s, "w");
if (crc32("MBObmoShdmHdg",13) == 3798103510) strcat(s, "p");
if (crc32("xnvzoYI",7) == 1500672390) strcat(s, "u");
if (crc32("fPCSrcgfgR",10) == 621051860) strcat(s, "e");
if (crc32("DTOGHBZmuLHx",12) == 4090620873) strcat(s, "r");
if (crc32("UYvYqAaqpDV",11) == 1436136056) strcat(s, "l");
if (crc32("NKYpRaaDzFsbK",13) == 3906392091) strcat(s, "o");
if (crc32("DeCraNl",7) == 855135195) strcat(s, "D");
if (crc32("Vxlcr",5) == 1860984629) strcat(s, "g");
if (crc32("UQIPJHPaLDBLb",13) == 1647202353) strcat(s, "R");
if (crc32("eAzZZImnfNyBEI",14) == 2140922676) strcat(s, "i");
if (crc32("GeJbbyQ",7) == 402150221) strcat(s, "f");
if (crc32("TNwtsxBMAbKwWkr",15) == 1443321371) strcat(s, "c");
if (crc32("orKGBh",6) == 1939091223) strcat(s, "a");
if (crc32("gRZEXkjnWHIrr",13) == 534768499) strcat(s, "l");
if (crc32("vYzpXRafLQH",11) == 815311813) strcat(s, "h");
if (crc32("cUZMMDWKu",9) == 1145471996) strcat(s, "l");
if (crc32("TexEnAbN",8) == 2867651236) strcat(s, "f");
if (crc32("WAWQQZDBRgD",11) == 1143599016) strcat(s, "y");
    return s;
}

char *nongraphically_adverbs() {
    char *s = calloc(15);
    if (crc32("DhgXM",5) == 83852573) strcat(s, "Y");
if (crc32("rdLPh",5) == 1898374268) strcat(s, "n");
if (crc32("HWjcmnSmn",9) == 1310652986) strcat(s, "h");
if (crc32("BPPpqCK",7) == 2117294647) strcat(s, "o");
if (crc32("VoiDsEmEaothZa",14) == 2591872435) strcat(s, "N");
if (crc32("MvHiAoqvdGe",11) == 2078593216) strcat(s, "n");
if (crc32("GYaRFl",6) == 2672648182) strcat(s, "z");
if (crc32("fLPHu",5) == 1977744507) strcat(s, "g");
if (crc32("dSAmWRlhexNGCRm",15) == 3515729005) strcat(s, "r");
if (crc32("zthIvbJrGrHgwb",14) == 455652100) strcat(s, "a");
if (crc32("iioSWsoYCJrU",12) == 853703571) strcat(s, "p");
if (crc32("ToTgA",5) == 3244161909) strcat(s, "c");
if (crc32("dezWyW",6) == 368470775) strcat(s, "h");
if (crc32("OAwnbVeL",8) == 292290026) strcat(s, "E");
if (crc32("XnWuothMwOfDp",13) == 2095802823) strcat(s, "i");
if (crc32("skqxbP",6) == 1733770832) strcat(s, "c");
if (crc32("OqyQfWAOEVVadOH",15) == 3331812825) strcat(s, "a");
if (crc32("GAuOyqFE",8) == 2853492248) strcat(s, "Q");
if (crc32("bhIHqvZdMeyIe",13) == 487739110) strcat(s, "l");
if (crc32("uCrhyrfIMaeCtk",14) == 2707411416) strcat(s, "y");
if (crc32("AwjvlGJqYjBAI",13) == 998208672) strcat(s, "l");
if (crc32("fPUtdjLKcOblCGx",15) == 2349115691) strcat(s, "y");
    return s;
}

char *unserenely_adverbs() {
    char *s = calloc(11);
    if (crc32("KpHqiXAWg",9) == 1827346288) strcat(s, "u");
if (crc32("gNdWY",5) == 1047016049) strcat(s, "n");
if (crc32("ejUfqTKMrGzF",12) == 2232097439) strcat(s, "s");
if (crc32("IjUhyL",6) == 3871332296) strcat(s, "H");
if (crc32("zEFfWqepNRBB",12) == 1410535955) strcat(s, "e");
if (crc32("jrjYDLaiHpH",11) == 3199082539) strcat(s, "n");
if (crc32("hTwNzLFQCJHv",12) == 2282375125) strcat(s, "r");
if (crc32("BRoRsWyIoTbPIP",14) == 134903444) strcat(s, "u");
if (crc32("qqpLJpzfFH",10) == 4090478677) strcat(s, "e");
if (crc32("uDjQCgASvubqreD",15) == 2648050261) strcat(s, "n");
if (crc32("aUWylDGL",8) == 3834498315) strcat(s, "E");
if (crc32("gMEcv",5) == 94994406) strcat(s, "e");
if (crc32("Yclorlwpsuc",11) == 359716001) strcat(s, "l");
if (crc32("PhtHVPCxzGZN",12) == 1740942637) strcat(s, "y");
    return s;
}

char *sternforemost_adverbs() {
    char *s = calloc(14);
    if (crc32("pjKgktzqlHHYBo",14) == 4053480748) strcat(s, "s");
if (crc32("yGbAVDrycgCA",12) == 236969912) strcat(s, "t");
if (crc32("BZDsRcIw",8) == 1741413606) strcat(s, "e");
if (crc32("GJBnG",5) == 3095396521) strcat(s, "r");
if (crc32("vPEIlg",6) == 3117754851) strcat(s, "a");
if (crc32("YdeaCaQrNcTr",12) == 3645448462) strcat(s, "n");
if (crc32("xumTdAqfgLrO",12) == 1166899215) strcat(s, "o");
if (crc32("goGqsJOAuIza",12) == 3933976846) strcat(s, "f");
if (crc32("JnqfbWIDyUrOuz",14) == 1890568244) strcat(s, "o");
if (crc32("yxLvMTeGj",9) == 457418457) strcat(s, "l");
if (crc32("yCWfsPBQrSC",11) == 845735830) strcat(s, "r");
if (crc32("covrFsTgqgILSn",14) == 3757507713) strcat(s, "M");
if (crc32("zvfiJKznpBjfxqd",15) == 146743595) strcat(s, "e");
if (crc32("ZufbPj",6) == 3557247183) strcat(s, "u");
if (crc32("GNgdEyaY",8) == 2998320304) strcat(s, "m");
if (crc32("JOGApSMZkFW",11) == 437965134) strcat(s, "o");
if (crc32("yxZiBM",6) == 2111396199) strcat(s, "s");
if (crc32("YVmFUgFLOzackiq",15) == 3449586499) strcat(s, "t");
    return s;
}

char *illusorily_adverbs() {
    char *s = calloc(11);
    if (crc32("kTNHnrydBXxkJes",15) == 295945626) strcat(s, "U");
if (crc32("wqLlndSBqgkRKfh",15) == 289476302) strcat(s, "i");
if (crc32("HcNggPCAWirjt",13) == 2413961150) strcat(s, "l");
if (crc32("pddXeMnjOcJe",12) == 3243953179) strcat(s, "t");
if (crc32("ptkRlyC",7) == 1051992358) strcat(s, "l");
if (crc32("SNFzpxJ",7) == 3187118894) strcat(s, "L");
if (crc32("hjYErN",6) == 3403561880) strcat(s, "u");
if (crc32("arObCky",7) == 1623690392) strcat(s, "s");
if (crc32("cAsglyRi",8) == 3920441216) strcat(s, "o");
if (crc32("VBDaOnJIhCGV",12) == 245200830) strcat(s, "D");
if (crc32("MRDCI",5) == 2760010786) strcat(s, "r");
if (crc32("yuKSDJepfg",10) == 198849030) strcat(s, "i");
if (crc32("RuWIo",5) == 2556201836) strcat(s, "A");
if (crc32("idoHsz",6) == 1535485830) strcat(s, "l");
if (crc32("VVeQHAbwyq",10) == 3566719465) strcat(s, "y");
    return s;
}

char *uncondensably_adverbs() {
    char *s = calloc(14);
    if (crc32("IirUUKqh",8) == 244768644) strcat(s, "u");
if (crc32("WYaNGRKx",8) == 2354005663) strcat(s, "n");
if (crc32("ZEVBQSLLrRobknu",15) == 2670308168) strcat(s, "X");
if (crc32("enHYgbqhxWMyES",14) == 2704391459) strcat(s, "c");
if (crc32("SGQYS",5) == 339689231) strcat(s, "r");
if (crc32("oGPmo",5) == 3126931606) strcat(s, "o");
if (crc32("aBTVRBvF",8) == 2122043332) strcat(s, "n");
if (crc32("VlqQjDmC",8) == 1677593629) strcat(s, "d");
if (crc32("JgASqCGxLSd",11) == 1532591338) strcat(s, "e");
if (crc32("IwBxqixxgOIl",12) == 3383658057) strcat(s, "o");
if (crc32("WhfgvRZcmxcG",12) == 2783847983) strcat(s, "n");
if (crc32("BbJjTsXzrqjTxjh",15) == 3307111718) strcat(s, "r");
if (crc32("AZgePqJqtenFzQ",14) == 1210901304) strcat(s, "s");
if (crc32("ODXGtXbFDh",10) == 2730402712) strcat(s, "a");
if (crc32("hRaVCZQC",8) == 40000231) strcat(s, "b");
if (crc32("LErbaBYAKMPU",12) == 2107678727) strcat(s, "l");
if (crc32("cqfDokFJXP",10) == 4212523986) strcat(s, "d");
if (crc32("ojPhzCK",7) == 3963663921) strcat(s, "y");
    return s;
}

char *begetter_adverbs() {
    char *s = calloc(9);
    if (crc32("VcRjQLr",7) == 3405291861) strcat(s, "b");
if (crc32("nAhTIkdXQQqXE",13) == 1040072697) strcat(s, "e");
if (crc32("WaSpDLWGfa",10) == 934536037) strcat(s, "o");
if (crc32("KfoSVfjNCZMziq",14) == 1552947192) strcat(s, "g");
if (crc32("qKKuD",5) == 296979269) strcat(s, "e");
if (crc32("wpSaSQpt",8) == 3439762295) strcat(s, "t");
if (crc32("ujvGlZKWJwyRx",13) == 2735815286) strcat(s, "t");
if (crc32("meEXh",5) == 3961664205) strcat(s, "t");
if (crc32("LCXeEzVYtwXsPVG",15) == 4004722437) strcat(s, "z");
if (crc32("ElNLrzR",7) == 3316143798) strcat(s, "e");
if (crc32("iDBDMNHikiAtjX",14) == 3513547488) strcat(s, "r");
    return s;
}

char *overinsolently_adverbs() {
    char *s = calloc(15);
    if (crc32("FClBem",6) == 1404968117) strcat(s, "r");
if (crc32("hFopOMPOGM",10) == 811741618) strcat(s, "o");
if (crc32("RdNFqLKPAwVbIv",14) == 4197110439) strcat(s, "v");
if (crc32("yNhStAIPWzxES",13) == 1938548147) strcat(s, "F");
if (crc32("UVdCyegxt",9) == 3197953043) strcat(s, "e");
if (crc32("KyTfhkkqDKIcZ",13) == 2163951392) strcat(s, "r");
if (crc32("clpXsHfyQCXGwy",14) == 2926824751) strcat(s, "i");
if (crc32("QHuPXgwyeGoS",12) == 927936362) strcat(s, "A");
if (crc32("naVXzrXOT",9) == 3308098044) strcat(s, "n");
if (crc32("zxhCs",5) == 494145082) strcat(s, "y");
if (crc32("gRZJWgTp",8) == 562095870) strcat(s, "s");
if (crc32("XFuHCUOpdpbU",12) == 1999186368) strcat(s, "o");
if (crc32("AiwpRLpmI",9) == 3659179198) strcat(s, "l");
if (crc32("NivfTnPxBaHb",12) == 1323638513) strcat(s, "r");
if (crc32("ejSPhNCZHoCh",12) == 812481559) strcat(s, "e");
if (crc32("UJyLYqWHgN",10) == 317530899) strcat(s, "N");
if (crc32("NnOhp",5) == 2097138539) strcat(s, "n");
if (crc32("NkXNgJ",6) == 2725928586) strcat(s, "t");
if (crc32("nvXunvUBIemHiAR",15) == 2993876588) strcat(s, "l");
if (crc32("zrvCOgVMiQNnR",13) == 4026428627) strcat(s, "y");
    return s;
}

char *nondeficiently_adverbs() {
    char *s = calloc(15);
    if (crc32("grKDixwcIVKVWl",14) == 96520872) strcat(s, "b");
if (crc32("pvJOespRP",9) == 4256115935) strcat(s, "n");
if (crc32("zzYntuqPGsgKv",13) == 507054275) strcat(s, "g");
if (crc32("IolnpZvYeJPYj",13) == 1710198526) strcat(s, "o");
if (crc32("pAZpnQe",7) == 1890434690) strcat(s, "n");
if (crc32("enjDta",6) == 838847624) strcat(s, "u");
if (crc32("PZkzjAZNjOXPF",13) == 2348757601) strcat(s, "d");
if (crc32("ExajnxwuQD",10) == 1853516023) strcat(s, "e");
if (crc32("waZqQhbIodMpzXh",15) == 2777386194) strcat(s, "f");
if (crc32("Jmokgo",6) == 2933225832) strcat(s, "i");
if (crc32("chtsescOsZC",11) == 1610230749) strcat(s, "c");
if (crc32("WhaACYT",7) == 1843438780) strcat(s, "i");
if (crc32("OqFTB",5) == 4245731042) strcat(s, "e");
if (crc32("CjBbwEP",7) == 1160199270) strcat(s, "n");
if (crc32("QkWUk",5) == 1529432208) strcat(s, "t");
if (crc32("eacIMmuTo",9) == 1182433464) strcat(s, "l");
if (crc32("FDIiLeJxU",9) == 137306342) strcat(s, "y");
    return s;
}

char *gloomily_adverbs() {
    char *s = calloc(9);
    if (crc32("OGDsuUtamFB",11) == 3772097673) strcat(s, "g");
if (crc32("eZqNstm",7) == 2020148930) strcat(s, "l");
if (crc32("FRaUk",5) == 606874891) strcat(s, "o");
if (crc32("GmoXQZEyaXZZv",13) == 82322687) strcat(s, "h");
if (crc32("iVlVSdxwNSMYMuQ",15) == 298447245) strcat(s, "o");
if (crc32("OJAbvfHs",8) == 1661241137) strcat(s, "v");
if (crc32("JtCiYjz",7) == 4168494782) strcat(s, "m");
if (crc32("ZBtPWCrji",9) == 1039316283) strcat(s, "U");
if (crc32("OlwELVfEitoexD",14) == 3100387575) strcat(s, "i");
if (crc32("OdIZUB",6) == 4216847851) strcat(s, "l");
if (crc32("imolRvBiMk",10) == 4176601259) strcat(s, "y");
    return s;
}

char *phototelegraphically_adverbs() {
    char *s = calloc(21);
    if (crc32("UxStrzoY",8) == 2644604933) strcat(s, "k");
if (crc32("TIrIfheYbCkM",12) == 3343940402) strcat(s, "p");
if (crc32("hbyLB",5) == 1634830195) strcat(s, "h");
if (crc32("cnAzMO",6) == 3366113744) strcat(s, "y");
if (crc32("QJzlvdXV",8) == 458100172) strcat(s, "o");
if (crc32("NSplSHr",7) == 1250497841) strcat(s, "P");
if (crc32("vpejIqHD",8) == 2465215236) strcat(s, "t");
if (crc32("NSlUuHPdy",9) == 3382577181) strcat(s, "x");
if (crc32("agxywLPkFbVZm",13) == 948624114) strcat(s, "o");
if (crc32("bPwFIYAl",8) == 2962005038) strcat(s, "F");
if (crc32("dDdGgIkOx",9) == 2269538524) strcat(s, "t");
if (crc32("EsSnYcuDIRGIDr",14) == 399609979) strcat(s, "e");
if (crc32("zKZXYvq",7) == 4113451957) strcat(s, "L");
if (crc32("TvezO",5) == 944416224) strcat(s, "l");
if (crc32("NhILIP",6) == 4171116696) strcat(s, "e");
if (crc32("uQDSZC",6) == 490585246) strcat(s, "V");
if (crc32("ASHhKY",6) == 321607845) strcat(s, "g");
if (crc32("SSjyZkmn",8) == 1802560598) strcat(s, "r");
if (crc32("imzhByiEGLAyJg",14) == 2949340756) strcat(s, "a");
if (crc32("LwQykteYp",9) == 2926193987) strcat(s, "p");
if (crc32("NCKdpCvwPmi",11) == 2610584306) strcat(s, "y");
if (crc32("nxJalsMbuv",10) == 4194580262) strcat(s, "h");
if (crc32("hqLsdwHRFjGrcs",14) == 1827913036) strcat(s, "j");
if (crc32("bfZAxsvNXss",11) == 1297370432) strcat(s, "i");
if (crc32("PJGHpRoiSIEA",12) == 903445814) strcat(s, "c");
if (crc32("fPeQoJ",6) == 1117134463) strcat(s, "a");
if (crc32("jFnLjqP",7) == 4190900170) strcat(s, "r");
if (crc32("qQReNVSAPh",10) == 2190927598) strcat(s, "l");
if (crc32("ObvXjrcvthAnAE",14) == 2729889233) strcat(s, "z");
if (crc32("kkvyAEKK",8) == 4023478620) strcat(s, "l");
if (crc32("eIiOXcqeKdi",11) == 1577833473) strcat(s, "n");
if (crc32("VLliCTc",7) == 3350163466) strcat(s, "y");
    return s;
}

char *unclandestinely_adverbs() {
    char *s = calloc(16);
    if (crc32("EZGWwWJHAeslO",13) == 4286268268) strcat(s, "e");
if (crc32("VysvlbzWPVxQXL",14) == 1641838342) strcat(s, "u");
if (crc32("zOVaWPlRi",9) == 1238617500) strcat(s, "n");
if (crc32("PkGWPJ",6) == 271336035) strcat(s, "n");
if (crc32("aejvq",5) == 285962092) strcat(s, "D");
if (crc32("lQqayjvk",8) == 4087009095) strcat(s, "c");
if (crc32("CIDtrDQActtYxS",14) == 4144857657) strcat(s, "j");
if (crc32("pikjPenrPQ",10) == 809731493) strcat(s, "l");
if (crc32("YCoEOy",6) == 1709633978) strcat(s, "l");
if (crc32("eZDgiSS",7) == 3330758888) strcat(s, "a");
if (crc32("XwLkzEAmXUy",11) == 3412580837) strcat(s, "z");
if (crc32("SrLGtHwtVjvco",13) == 491979287) strcat(s, "n");
if (crc32("Nsnlh",5) == 3467996258) strcat(s, "M");
if (crc32("UHeIfsLZqvJZS",13) == 139969670) strcat(s, "d");
if (crc32("YIgGtIUrkrlcB",13) == 913716682) strcat(s, "F");
if (crc32("caBRcEzaJenbFO",14) == 2677494941) strcat(s, "e");
if (crc32("IMgOQCJshTc",11) == 2522124723) strcat(s, "u");
if (crc32("eIwxFCjkFdgT",12) == 1397278543) strcat(s, "s");
if (crc32("pTHEjhvOz",9) == 2451890846) strcat(s, "U");
if (crc32("IzVuqsD",7) == 761529965) strcat(s, "t");
if (crc32("knJBtTnYlzc",11) == 2831252573) strcat(s, "i");
if (crc32("ycBrWrTsUkpb",12) == 1991374861) strcat(s, "n");
if (crc32("lIndAPM",7) == 2833616061) strcat(s, "e");
if (crc32("hExhuHWJDhqFGFF",15) == 2680580319) strcat(s, "l");
if (crc32("QyapXVQiZa",10) == 11357193) strcat(s, "y");
    return s;
}

char *subpolygonally_adverbs() {
    char *s = calloc(15);
    if (crc32("ymDSUb",6) == 1089311173) strcat(s, "P");
if (crc32("WOYzBdU",7) == 3709800394) strcat(s, "s");
if (crc32("ueUooHjo",8) == 749926009) strcat(s, "O");
if (crc32("AqGKtnw",7) == 2135901832) strcat(s, "u");
if (crc32("nheKRpJMubSm",12) == 2068091162) strcat(s, "b");
if (crc32("dTaepaRULP",10) == 1112749778) strcat(s, "p");
if (crc32("wdugauhaJ",9) == 195185343) strcat(s, "q");
if (crc32("sGRRhceluVCmKB",14) == 2857834172) strcat(s, "o");
if (crc32("ikbruUReigCY",12) == 3904456791) strcat(s, "E");
if (crc32("ARsVPklvT",9) == 3207467037) strcat(s, "l");
if (crc32("SiikgkEyD",9) == 541587296) strcat(s, "y");
if (crc32("OQvJPCsObvZ",11) == 764538652) strcat(s, "g");
if (crc32("MNiGm",5) == 3602346083) strcat(s, "o");
if (crc32("DCdqkXtbMkHtSLh",15) == 3256429074) strcat(s, "I");
if (crc32("FmwIKOwc",8) == 2690905205) strcat(s, "n");
if (crc32("jYSkYiluw",9) == 3152721297) strcat(s, "a");
if (crc32("SnEkJp",6) == 1016170183) strcat(s, "M");
if (crc32("FLlBoj",6) == 3089896353) strcat(s, "l");
if (crc32("woXiC",5) == 3620770651) strcat(s, "l");
if (crc32("SszLtAlSrXWJ",12) == 1176789849) strcat(s, "G");
if (crc32("yjvphDIGjypcP",13) == 770952512) strcat(s, "y");
    return s;
}

char *unurbanely_adverbs() {
    char *s = calloc(11);
    if (crc32("OZXEPJWbSvjis",13) == 2899208199) strcat(s, "I");
if (crc32("QuRDpuXJUatLAmy",15) == 2891730468) strcat(s, "u");
if (crc32("DQnSVIplzloRmQv",15) == 6464434) strcat(s, "n");
if (crc32("yBUAII",6) == 1107374435) strcat(s, "n");
if (crc32("qmwlBZzyfyAxU",13) == 526706305) strcat(s, "u");
if (crc32("txFpIvmE",8) == 3538515025) strcat(s, "r");
if (crc32("UiPvxeKPja",10) == 2772717740) strcat(s, "b");
if (crc32("uEgrXwiEKMUQXa",14) == 1049838798) strcat(s, "T");
if (crc32("SuoyEtFkHFMKT",13) == 3866052692) strcat(s, "a");
if (crc32("EoetHRf",7) == 3273438753) strcat(s, "R");
if (crc32("mvWgpTBAFw",10) == 3144600266) strcat(s, "n");
if (crc32("qDdUsPBL",8) == 2115572484) strcat(s, "e");
if (crc32("PXEdeH",6) == 539940960) strcat(s, "f");
if (crc32("vfWUhQbJxMmdphD",15) == 276914239) strcat(s, "l");
if (crc32("ngGykrqdlf",10) == 1592518177) strcat(s, "y");
    return s;
}

char *subcutaneously_adverbs() {
    char *s = calloc(15);
    if (crc32("wUZPVjzrb",9) == 3762102932) strcat(s, "s");
if (crc32("WOQoq",5) == 4092743639) strcat(s, "H");
if (crc32("NuvBlg",6) == 2457260990) strcat(s, "u");
if (crc32("yixRRHbqGwf",11) == 1227375620) strcat(s, "b");
if (crc32("JBuedTj",7) == 3874664005) strcat(s, "N");
if (crc32("qjoDWIXMH",9) == 2594015411) strcat(s, "c");
if (crc32("sUyBfxmDlA",10) == 3355026457) strcat(s, "u");
if (crc32("HuFFsTMu",8) == 1480556736) strcat(s, "t");
if (crc32("haUFsUApa",9) == 2473333270) strcat(s, "a");
if (crc32("aOjFGt",6) == 1612003382) strcat(s, "n");
if (crc32("wginDJkAu",9) == 797685291) strcat(s, "Y");
if (crc32("ZsyZpUoIwYeorNg",15) == 2381431468) strcat(s, "e");
if (crc32("mcFryGnXyRbn",12) == 3962286003) strcat(s, "f");
if (crc32("nRDLaHy",7) == 595522996) strcat(s, "o");
if (crc32("YzJtSAFtKWL",11) == 4180755751) strcat(s, "u");
if (crc32("fdjWNbhCMiaSN",13) == 2818181413) strcat(s, "N");
if (crc32("mYPZwznDPyPBoV",14) == 3873836837) strcat(s, "s");
if (crc32("hFrpKWUubyfTUKe",15) == 1225921079) strcat(s, "l");
if (crc32("IVTEOgnWxGwHa",13) == 3675458416) strcat(s, "y");
    return s;
}

char *voraciously_adverbs() {
    char *s = calloc(12);
    if (crc32("tITGmrBvZiLSB",13) == 1695359088) strcat(s, "v");
if (crc32("oprjxNrMCMdNf",13) == 783530327) strcat(s, "o");
if (crc32("yJRjRsxMf",9) == 2680960179) strcat(s, "r");
if (crc32("rIFVPfRwLVtHewE",15) == 635705412) strcat(s, "a");
if (crc32("ZtuYpqTRzQhf",12) == 2900298042) strcat(s, "A");
if (crc32("pfkGDUEmGoQKwS",14) == 2208593653) strcat(s, "c");
if (crc32("PEuqieE",7) == 3459868379) strcat(s, "L");
if (crc32("OQzfdvBKT",9) == 3328719938) strcat(s, "i");
if (crc32("MGzJkxc",7) == 2600031993) strcat(s, "o");
if (crc32("pOdoZLCu",8) == 4286249566) strcat(s, "H");
if (crc32("uzOlOg",6) == 2143426721) strcat(s, "u");
if (crc32("bzSxBSuzgUFvwe",14) == 406372264) strcat(s, "s");
if (crc32("etUdfIVrPOTXbJn",15) == 2861900306) strcat(s, "l");
if (crc32("fWUrzSWPCSaTAS",14) == 1676300) strcat(s, "y");
    return s;
}

char *effectually_adverbs() {
    char *s = calloc(12);
    if (crc32("xufeKRV",7) == 1975841194) strcat(s, "e");
if (crc32("PCPnKPmDAwqqSp",14) == 4015631887) strcat(s, "f");
if (crc32("JdOEeFG",7) == 2822692827) strcat(s, "d");
if (crc32("cusDWRIQTW",10) == 35077461) strcat(s, "f");
if (crc32("uvWbbQFJMsJaN",13) == 2222431523) strcat(s, "z");
if (crc32("MJgOK",5) == 1235207627) strcat(s, "e");
if (crc32("lngYtFyvxNZ",11) == 1209665134) strcat(s, "c");
if (crc32("hTOhXMWOl",9) == 3174105327) strcat(s, "t");
if (crc32("UBUwprfbkXtjCwz",15) == 1464650683) strcat(s, "u");
if (crc32("xIRBg",5) == 2537383942) strcat(s, "u");
if (crc32("PaqvqtMbpRnORsD",15) == 1947455334) strcat(s, "N");
if (crc32("GBSQmAne",8) == 1681258296) strcat(s, "a");
if (crc32("AzawU",5) == 3685860570) strcat(s, "S");
if (crc32("jgkkJETzi",9) == 711620539) strcat(s, "l");
if (crc32("pLgJiSEb",8) == 1259191722) strcat(s, "l");
if (crc32("vTkBezbPbzdkAH",14) == 4146739418) strcat(s, "F");
if (crc32("aCnzTZThw",9) == 450910409) strcat(s, "y");
    return s;
}

char *curtly_adverbs() {
    char *s = calloc(7);
    if (crc32("sflFcmr",7) == 1479873697) strcat(s, "c");
if (crc32("QHppM",5) == 2412916989) strcat(s, "y");
if (crc32("tKnIrjA",7) == 3916841319) strcat(s, "u");
if (crc32("kkMHPuYiK",9) == 566749486) strcat(s, "r");
if (crc32("YBzRgHigjqNYcm",14) == 3035949460) strcat(s, "t");
if (crc32("qZtYZbeFDRohV",13) == 1615698899) strcat(s, "l");
if (crc32("amjivYTthOsYSf",14) == 2488597235) strcat(s, "B");
if (crc32("CazdSiRKGaWPT",13) == 4226553180) strcat(s, "y");
    return s;
}

char *nonunderstandingly_adverbs() {
    char *s = calloc(19);
    if (crc32("DhQQf",5) == 140475913) strcat(s, "f");
if (crc32("ZWNGPVq",7) == 1293763244) strcat(s, "n");
if (crc32("Bsxgdjdf",8) == 1262334162) strcat(s, "o");
if (crc32("aXCtlsakhR",10) == 2232280462) strcat(s, "n");
if (crc32("inDUdHtjTGyRm",13) == 429560448) strcat(s, "O");
if (crc32("OUHOh",5) == 2857607629) strcat(s, "u");
if (crc32("HAnfElqjbDVWY",13) == 2685838570) strcat(s, "r");
if (crc32("VPjYsNazmoSLuav",15) == 1928780129) strcat(s, "n");
if (crc32("aWFxXALoQBxTQev",15) == 1442521797) strcat(s, "d");
if (crc32("rwCEkmzYli",10) == 3188293921) strcat(s, "T");
if (crc32("wkTknAxwb",9) == 3597210811) strcat(s, "e");
if (crc32("HUxuxa",6) == 2212030945) strcat(s, "r");
if (crc32("nyEIGkKuQfyEi",13) == 1423811291) strcat(s, "s");
if (crc32("cLntuWb",7) == 2576080042) strcat(s, "t");
if (crc32("urTuLPi",7) == 66143633) strcat(s, "a");
if (crc32("CHpVpKnQfrit",12) == 1242439516) strcat(s, "c");
if (crc32("TELHdFOIw",9) == 2394641171) strcat(s, "n");
if (crc32("FRaaoeNg",8) == 3373602417) strcat(s, "d");
if (crc32("CDkdjrDOEjqPyR",14) == 4014004820) strcat(s, "r");
if (crc32("JFNIWlBrmPKW",12) == 4231749484) strcat(s, "i");
if (crc32("LwUtUETlFVxbN",13) == 3663083989) strcat(s, "n");
if (crc32("HEAClAr",7) == 1334551941) strcat(s, "g");
if (crc32("EcBSGUkZ",8) == 2879496942) strcat(s, "A");
if (crc32("GtsjXwV",7) == 3863163614) strcat(s, "l");
if (crc32("ebEgBeK",7) == 3181794490) strcat(s, "y");
    return s;
}

char *spectacularly_adverbs() {
    char *s = calloc(14);
    if (crc32("pvxbYDLgovWTY",13) == 3458014528) strcat(s, "o");
if (crc32("DuRHmkx",7) == 4067224846) strcat(s, "s");
if (crc32("nJVQhXI",7) == 4028482311) strcat(s, "b");
if (crc32("BRnOcTl",7) == 982078415) strcat(s, "p");
if (crc32("wdkQdOOVhnOu",12) == 2404755124) strcat(s, "C");
if (crc32("RzQPGVxukDH",11) == 4237908596) strcat(s, "e");
if (crc32("tWBkzhePqzljdGK",15) == 87241062) strcat(s, "L");
if (crc32("lLHdf",5) == 2431335522) strcat(s, "c");
if (crc32("dGxwsJkTeD",10) == 2733600858) strcat(s, "l");
if (crc32("gylEUodNjyqrR",13) == 2483418383) strcat(s, "t");
if (crc32("OXBjlOlsrmh",11) == 1722041891) strcat(s, "a");
if (crc32("XkkhlWWaPdsKFc",14) == 657420141) strcat(s, "c");
if (crc32("yzMuUV",6) == 170155190) strcat(s, "I");
if (crc32("invYfXMcKBaMYVi",15) == 240382753) strcat(s, "u");
if (crc32("fjxhckcxIIKEse",14) == 1114002976) strcat(s, "l");
if (crc32("QywJpWLPQ",9) == 3345781705) strcat(s, "a");
if (crc32("MEaepsRPnAwtofh",15) == 4125270643) strcat(s, "J");
if (crc32("vyQdQDucMg",10) == 1215870518) strcat(s, "r");
if (crc32("nBVuQwqDCHJGf",13) == 2637166867) strcat(s, "l");
if (crc32("RiJoGKWKQbXyWI",14) == 358316702) strcat(s, "G");
if (crc32("iiPuywDnRxwPRp",14) == 3953163465) strcat(s, "y");
    return s;
}

char *apiece_adverbs() {
    char *s = calloc(7);
    if (crc32("blyXswbt",8) == 1363596428) strcat(s, "l");
if (crc32("xqrNZYmveouNtR",14) == 1018818523) strcat(s, "a");
if (crc32("DqkEX",5) == 374979615) strcat(s, "K");
if (crc32("vImRnUgzqV",10) == 486462938) strcat(s, "p");
if (crc32("KbIqGXLpGErixza",15) == 1146899007) strcat(s, "i");
if (crc32("QGrqyHyt",8) == 1047611015) strcat(s, "e");
if (crc32("EYeOLJHAPUEibui",15) == 2813368431) strcat(s, "c");
if (crc32("jpczVZlJd",9) == 35226698) strcat(s, "t");
if (crc32("viDIUgeSmXpBC",13) == 61833353) strcat(s, "e");
    return s;
}

char *incuriously_adverbs() {
    char *s = calloc(12);
    if (crc32("laAJvZLhMDf",11) == 2963069247) strcat(s, "P");
if (crc32("wohGboJAJsqY",12) == 839248430) strcat(s, "i");
if (crc32("cIcfmbrhcgSZR",13) == 2001904565) strcat(s, "n");
if (crc32("KhUYIPAAuxEVX",13) == 1448133877) strcat(s, "c");
if (crc32("naxhhQRszA",10) == 1855258135) strcat(s, "p");
if (crc32("eXTshG",6) == 3067920416) strcat(s, "u");
if (crc32("OdBegnhowuCVSnf",15) == 3081363693) strcat(s, "I");
if (crc32("klsqDeOBW",9) == 1334341732) strcat(s, "r");
if (crc32("cbjKKie",7) == 145862815) strcat(s, "i");
if (crc32("CFZbYlSMLPpD",12) == 293655287) strcat(s, "o");
if (crc32("VMqFT",5) == 2266575519) strcat(s, "u");
if (crc32("EpkRePnNOaHnK",13) == 3969262628) strcat(s, "W");
if (crc32("lBNzcde",7) == 108247637) strcat(s, "s");
if (crc32("XCsLmOTgBr",10) == 341357485) strcat(s, "l");
if (crc32("Pfoxvnfa",8) == 3983394676) strcat(s, "y");
    return s;
}

char *atypically_adverbs() {
    char *s = calloc(11);
    if (crc32("yrGBnTaFKqwPNz",14) == 696506416) strcat(s, "B");
if (crc32("HwaILw",6) == 2001196994) strcat(s, "a");
if (crc32("JboUbti",7) == 3958652500) strcat(s, "t");
if (crc32("ZLUlYDVpew",10) == 2781639942) strcat(s, "l");
if (crc32("YRSnNHwyGFdTS",13) == 2706701141) strcat(s, "y");
if (crc32("KebYIkOzNlC",11) == 627788391) strcat(s, "R");
if (crc32("JriAabVDLW",10) == 2314443007) strcat(s, "p");
if (crc32("pjIMQxPtqFtJ",12) == 2626633734) strcat(s, "i");
if (crc32("ZOqphfrd",8) == 3782365196) strcat(s, "i");
if (crc32("KEvyrJBtyvYgXs",14) == 3780317604) strcat(s, "c");
if (crc32("OMpoZPVHmqlnd",13) == 3018481811) strcat(s, "q");
if (crc32("irZYvu",6) == 2214391204) strcat(s, "a");
if (crc32("CaKUQoRs",8) == 2154727468) strcat(s, "I");
if (crc32("pSsZJFTyE",9) == 2186572988) strcat(s, "l");
if (crc32("eXdmrF",6) == 3364493468) strcat(s, "V");
if (crc32("rBUrVEQTVK",10) == 3628898880) strcat(s, "l");
if (crc32("JZdgwyOD",8) == 1228229661) strcat(s, "y");
    return s;
}

char *unvenially_adverbs() {
    char *s = calloc(11);
    if (crc32("lmcHIJ",6) == 1342047529) strcat(s, "u");
if (crc32("fXOCqyUmRiad",12) == 3266950758) strcat(s, "n");
if (crc32("LUSKCvR",7) == 2246978191) strcat(s, "M");
if (crc32("qEZcKzAq",8) == 3145678817) strcat(s, "v");
if (crc32("PbCEDFCIDYYZ",12) == 1868628861) strcat(s, "e");
if (crc32("MNEwHspQFa",10) == 293753239) strcat(s, "n");
if (crc32("mzVidmmZndx",11) == 3435619617) strcat(s, "i");
if (crc32("gnmiF",5) == 2597316134) strcat(s, "E");
if (crc32("LOFhOwdiY",9) == 678687863) strcat(s, "a");
if (crc32("BiXLsyOFT",9) == 2052180836) strcat(s, "U");
if (crc32("RcTwWfTVMWIUi",13) == 2453046411) strcat(s, "l");
if (crc32("xvXZJsoT",8) == 724328824) strcat(s, "l");
if (crc32("HyBTRtzuYhzh",12) == 2415087565) strcat(s, "y");
    return s;
}

char *unmilitarily_adverbs() {
    char *s = calloc(13);
    if (crc32("uRwBnljit",9) == 182689674) strcat(s, "t");
if (crc32("rMMfcqjUVwfZCg",14) == 1035549608) strcat(s, "u");
if (crc32("ZrKPXNpxp",9) == 892870985) strcat(s, "n");
if (crc32("wwxgrBooNfPAud",14) == 578968111) strcat(s, "o");
if (crc32("cSJXtv",6) == 606258918) strcat(s, "m");
if (crc32("gtDxKkQIFZLQ",12) == 623908922) strcat(s, "J");
if (crc32("RCvvTcLRTg",10) == 2793753163) strcat(s, "i");
if (crc32("DuANZ",5) == 2745984172) strcat(s, "l");
if (crc32("LVdhgKJkjAFo",12) == 3682300307) strcat(s, "u");
if (crc32("hZtMaVIjaamrz",13) == 3267638835) strcat(s, "i");
if (crc32("OUPhcpZxqWbg",12) == 2259865474) strcat(s, "t");
if (crc32("NMFkwmwcceJRGha",15) == 141739189) strcat(s, "a");
if (crc32("hmlvyWODqlEAt",13) == 344986690) strcat(s, "r");
if (crc32("ZBZjKSQy",8) == 1742091376) strcat(s, "h");
if (crc32("lmcuYDO",7) == 4135091047) strcat(s, "i");
if (crc32("ePhqxsNNOkcyJd",14) == 4034923897) strcat(s, "D");
if (crc32("YIqhBXsuijwBob",14) == 3222976090) strcat(s, "l");
if (crc32("DoNHbEL",7) == 3571322068) strcat(s, "y");
    return s;
}

char *undyingly_adverbs() {
    char *s = calloc(10);
    if (crc32("vewRll",6) == 704109665) strcat(s, "u");
if (crc32("MLBpoUhulR",10) == 3731660254) strcat(s, "n");
if (crc32("eKTkqyKlL",9) == 701190555) strcat(s, "d");
if (crc32("UTaLEDgvPi",10) == 3200028924) strcat(s, "M");
if (crc32("RsBnxi",6) == 3995782878) strcat(s, "y");
if (crc32("PsqMRyCUAhTuHQ",14) == 998009058) strcat(s, "i");
if (crc32("FPdBY",5) == 747448462) strcat(s, "P");
if (crc32("JNsQUtFbb",9) == 524211039) strcat(s, "n");
if (crc32("xvYJvhxCkj",10) == 2898232847) strcat(s, "g");
if (crc32("vjTCkXhjPNesa",13) == 2326201271) strcat(s, "x");
if (crc32("WTztRisGuamu",12) == 1022704537) strcat(s, "l");
if (crc32("lenIRuLJ",8) == 62479952) strcat(s, "K");
if (crc32("BrpPlNFaN",9) == 2791441247) strcat(s, "y");
    return s;
}

char *chicly_adverbs() {
    char *s = calloc(7);
    if (crc32("GCLFdE",6) == 2654175767) strcat(s, "u");
if (crc32("DcaBvDUBZhc",11) == 3578606536) strcat(s, "c");
if (crc32("XFQQHBx",7) == 3230472082) strcat(s, "h");
if (crc32("QbfGyudfmSKJdm",14) == 3877060064) strcat(s, "L");
if (crc32("PGKfFVjRb",9) == 2013716267) strcat(s, "i");
if (crc32("WrPrGHLsSIiGbo",14) == 3614503521) strcat(s, "s");
if (crc32("rTGkWQKRNXpSmtj",15) == 3770652643) strcat(s, "c");
if (crc32("RHnmvLTclp",10) == 1405052738) strcat(s, "o");
if (crc32("nCTGZhXGSaP",11) == 77279044) strcat(s, "l");
if (crc32("kVHTETIA",8) == 1499625060) strcat(s, "S");
if (crc32("tULJTV",6) == 563228109) strcat(s, "y");
    return s;
}

char *inspectingly_adverbs() {
    char *s = calloc(13);
    if (crc32("REkDiafN",8) == 1008948167) strcat(s, "I");
if (crc32("meilPX",6) == 2358397765) strcat(s, "i");
if (crc32("CeqlSthRFrxOJNU",15) == 3276144357) strcat(s, "n");
if (crc32("YMnrwevETpUAMu",14) == 1039759002) strcat(s, "s");
if (crc32("UByACGUHRG",10) == 2176558320) strcat(s, "E");
if (crc32("NSYnS",5) == 2452152865) strcat(s, "p");
if (crc32("QRnFoowT",8) == 2166294264) strcat(s, "e");
if (crc32("ivCjHJdrtcCaSf",14) == 3376009715) strcat(s, "x");
if (crc32("iptHk",5) == 2282225644) strcat(s, "c");
if (crc32("zvyTRRCNPm",10) == 2622857880) strcat(s, "t");
if (crc32("hUvaiamTbdPfOz",14) == 1352761205) strcat(s, "y");
if (crc32("PnFjypL",7) == 68863487) strcat(s, "i");
if (crc32("qvPLGEV",7) == 3439899884) strcat(s, "z");
if (crc32("ytxFyCh",7) == 3236892621) strcat(s, "n");
if (crc32("PKnpOPD",7) == 4246614713) strcat(s, "S");
if (crc32("OQiWAzaePTdvn",13) == 592102586) strcat(s, "g");
if (crc32("NZyxLthcLb",10) == 1728503771) strcat(s, "y");
if (crc32("yEoJi",5) == 3814272962) strcat(s, "l");
if (crc32("zPUgEwpIcrpbt",13) == 2151214020) strcat(s, "w");
if (crc32("keiDJ",5) == 1629643856) strcat(s, "y");
    return s;
}

char *inartistically_adverbs() {
    char *s = calloc(15);
    if (crc32("Brpefy",6) == 1327306117) strcat(s, "i");
if (crc32("jFHzXMByOt",10) == 1518431740) strcat(s, "n");
if (crc32("ZXcLKdtvI",9) == 4220011934) strcat(s, "n");
if (crc32("iNyzzRGhkChevWV",15) == 7935473) strcat(s, "a");
if (crc32("ZJqTyVCeRom",11) == 1080574566) strcat(s, "r");
if (crc32("KpYdbPmLvD",10) == 4196523665) strcat(s, "E");
if (crc32("nbXzKjieVfR",11) == 3781625824) strcat(s, "t");
if (crc32("pGPpJOercBfZt",13) == 4009787607) strcat(s, "i");
if (crc32("RhwMHxeQvdA",11) == 1308559266) strcat(s, "s");
if (crc32("ANHWZomSVODhK",13) == 969355619) strcat(s, "l");
if (crc32("NpfqM",5) == 952988577) strcat(s, "t");
if (crc32("KdNTzCBHt",9) == 1263617483) strcat(s, "i");
if (crc32("ZEKpuvt",7) == 1350901457) strcat(s, "j");
if (crc32("LGsQSNSEVRF",11) == 268707334) strcat(s, "c");
if (crc32("oYBeCMgPex",10) == 169280936) strcat(s, "a");
if (crc32("IpmonTzBKHW",11) == 3953504512) strcat(s, "l");
if (crc32("txuFHHfq",8) == 711970549) strcat(s, "l");
if (crc32("iVKMliOQFZy",11) == 3624493140) strcat(s, "i");
if (crc32("McwafkadeDqCH",13) == 3971845915) strcat(s, "y");
    return s;
}

char *septifragally_adverbs() {
    char *s = calloc(14);
    if (crc32("vbTbHXtWnKgiLlb",15) == 1127210689) strcat(s, "Z");
if (crc32("mQLZEmbCdtfTfc",14) == 2931403926) strcat(s, "s");
if (crc32("ZkaMkFv",7) == 3994112072) strcat(s, "e");
if (crc32("OTiPMjDJdPJwDb",14) == 344802286) strcat(s, "p");
if (crc32("yVLVQgfwXIPI",12) == 1366872438) strcat(s, "t");
if (crc32("NxcmXk",6) == 2360086179) strcat(s, "i");
if (crc32("iqodYLTRPCeoC",13) == 3873214237) strcat(s, "f");
if (crc32("maRTLNtwuJ",10) == 706372691) strcat(s, "g");
if (crc32("SFjEIA",6) == 4005669653) strcat(s, "r");
if (crc32("ICMdrbCsoQobe",13) == 1120177289) strcat(s, "a");
if (crc32("jfuvSKgz",8) == 3725145335) strcat(s, "g");
if (crc32("stwjpZpIiJfD",12) == 3072575590) strcat(s, "a");
if (crc32("XaIfw",5) == 3478551936) strcat(s, "l");
if (crc32("TaOGrVkHiss",11) == 1519401250) strcat(s, "h");
if (crc32("ObIDTf",6) == 1203196833) strcat(s, "l");
if (crc32("CAJtJNFYOxFrtYU",15) == 4098172244) strcat(s, "d");
if (crc32("yemuTQBGWQLPI",13) == 1267116139) strcat(s, "y");
    return s;
}

char *variatively_adverbs() {
    char *s = calloc(12);
    if (crc32("GjScXSdDMvrktu",14) == 1783358911) strcat(s, "V");
if (crc32("ChxzzFCIbl",10) == 3728610477) strcat(s, "v");
if (crc32("KCcXwqNfj",9) == 4288765) strcat(s, "j");
if (crc32("DxZpvmFi",8) == 3752054816) strcat(s, "a");
if (crc32("LGUydsf",7) == 3396412291) strcat(s, "l");
if (crc32("jvJbvqdczJrise",14) == 3000790049) strcat(s, "r");
if (crc32("iLfvltYTeD",10) == 838292803) strcat(s, "T");
if (crc32("TxCHMeGXL",9) == 4104958847) strcat(s, "i");
if (crc32("aPPPPV",6) == 3581622800) strcat(s, "a");
if (crc32("tcrNrUrYl",9) == 1267290119) strcat(s, "q");
if (crc32("JAHAlGGL",8) == 2112651774) strcat(s, "t");
if (crc32("GLJtDxqg",8) == 3425054299) strcat(s, "i");
if (crc32("kFQLskNhQs",10) == 1238745375) strcat(s, "v");
if (crc32("kzkLwbLqhOio",12) == 3318445201) strcat(s, "e");
if (crc32("DVMcpjd",7) == 4281593815) strcat(s, "l");
if (crc32("fFrObAjIMHLSUY",14) == 138965931) strcat(s, "y");
    return s;
}

char *divisively_adverbs() {
    char *s = calloc(11);
    if (crc32("tEkHCPKa",8) == 218667757) strcat(s, "W");
if (crc32("mFKyO",5) == 2108604319) strcat(s, "d");
if (crc32("RXIgEwuOxOYb",12) == 3585635377) strcat(s, "D");
if (crc32("XrSydFAbeaQ",11) == 3746878105) strcat(s, "i");
if (crc32("VMSKnftecr",10) == 3509831853) strcat(s, "t");
if (crc32("bHpBlNwy",8) == 3947531137) strcat(s, "v");
if (crc32("wvsHQMJB",8) == 814563185) strcat(s, "i");
if (crc32("jBTWLZlvpBO",11) == 2132478510) strcat(s, "s");
if (crc32("bvDxn",5) == 1375450829) strcat(s, "i");
if (crc32("fywGQIvOqPUnpVR",15) == 1965250877) strcat(s, "z");
if (crc32("nEtHXtVxRiBhzl",14) == 95680894) strcat(s, "v");
if (crc32("FaXmomEflTQDg",13) == 1966468720) strcat(s, "e");
if (crc32("VOXOiPYizMhNs",13) == 2160270274) strcat(s, "k");
if (crc32("EYgrwLvIJnZqvp",14) == 2810697715) strcat(s, "l");
if (crc32("impHUmkjnqc",11) == 386386298) strcat(s, "w");
if (crc32("DjvyME",6) == 2694622973) strcat(s, "y");
    return s;
}

char *overmerrily_adverbs() {
    char *s = calloc(12);
    if (crc32("aNuYkN",6) == 3646221524) strcat(s, "s");
if (crc32("zZpiXD",6) == 1177705096) strcat(s, "o");
if (crc32("SlWCn",5) == 3642686309) strcat(s, "V");
if (crc32("oYqmSOQTMOXpJP",14) == 4002203912) strcat(s, "v");
if (crc32("GafbRtfcCtzC",12) == 4016004013) strcat(s, "e");
if (crc32("yZtRzBfyYrpkjWP",15) == 3706447406) strcat(s, "r");
if (crc32("SzmaAiPrANNA",12) == 2935384504) strcat(s, "z");
if (crc32("aUrZQH",6) == 4179843873) strcat(s, "m");
if (crc32("MExnxHYLp",9) == 504900447) strcat(s, "E");
if (crc32("lBUqeUZQp",9) == 3120171544) strcat(s, "e");
if (crc32("JHvTyRPJtDrw",12) == 1946730765) strcat(s, "w");
if (crc32("xIABOjgRAe",10) == 1920579527) strcat(s, "r");
if (crc32("MDKkkeUHQ",9) == 3969772458) strcat(s, "r");
if (crc32("AyoMDKuXG",9) == 2067866766) strcat(s, "i");
if (crc32("DRDkIDBhUUwwLLi",15) == 2188221412) strcat(s, "n");
if (crc32("IleKzlYqDV",10) == 3861197204) strcat(s, "l");
if (crc32("yBOFSVPj",8) == 2319516558) strcat(s, "y");
    return s;
}

char *nonerratically_adverbs() {
    char *s = calloc(15);
    if (crc32("UmgDDPCFgD",10) == 126515448) strcat(s, "M");
if (crc32("aZOEM",5) == 946145974) strcat(s, "n");
if (crc32("bEMDc",5) == 2985746255) strcat(s, "o");
if (crc32("NBjbJeaZmI",10) == 4131546462) strcat(s, "k");
if (crc32("hCxmvd",6) == 2533926204) strcat(s, "n");
if (crc32("eQlQQGSIoceVl",13) == 602644676) strcat(s, "a");
if (crc32("VKNim",5) == 3227287435) strcat(s, "e");
if (crc32("TPIWkUBmnMzdSXv",15) == 3675490044) strcat(s, "r");
if (crc32("jLRhn",5) == 2893293658) strcat(s, "r");
if (crc32("EHiLul",6) == 2939569433) strcat(s, "a");
if (crc32("HyDGmYmpnY",10) == 3951133829) strcat(s, "t");
if (crc32("GwHLvQAbMUACg",13) == 4014625719) strcat(s, "i");
if (crc32("sVESFblDHGGDvW",14) == 1285187754) strcat(s, "i");
if (crc32("VsfSQQMTSLRbka",14) == 4168142180) strcat(s, "c");
if (crc32("gSwvYjuQFbRpJ",13) == 1838511760) strcat(s, "a");
if (crc32("LkCKkV",6) == 3604348599) strcat(s, "l");
if (crc32("uEyNmjdlMWVicF",14) == 308618528) strcat(s, "C");
if (crc32("TNtaG",5) == 3084713793) strcat(s, "l");
if (crc32("dUXjYOLWgtW",11) == 742946249) strcat(s, "y");
    return s;
}

char *literately_adverbs() {
    char *s = calloc(11);
    if (crc32("WndvjvIam",9) == 983657810) strcat(s, "l");
if (crc32("RRhOWiLyMAlTJTn",15) == 650507939) strcat(s, "i");
if (crc32("tyMheKijNyzy",12) == 4231594811) strcat(s, "X");
if (crc32("psGteP",6) == 575166563) strcat(s, "t");
if (crc32("QmehlFLUPDW",11) == 1621207559) strcat(s, "N");
if (crc32("uXbtqbM",7) == 3470495713) strcat(s, "e");
if (crc32("gvFoGIi",7) == 667474354) strcat(s, "x");
if (crc32("kIqJqjBcXEh",11) == 1631587340) strcat(s, "r");
if (crc32("NjBHfzY",7) == 3617147171) strcat(s, "a");
if (crc32("pRtUEYiAaYCI",12) == 298921352) strcat(s, "t");
if (crc32("XZJmsY",6) == 2203375135) strcat(s, "D");
if (crc32("ttkvlc",6) == 2357975250) strcat(s, "e");
if (crc32("NykcBBgHsEmzc",13) == 108699561) strcat(s, "Y");
if (crc32("pPshVa",6) == 1810455903) strcat(s, "l");
if (crc32("mrrwXHTudIOEfVt",15) == 2519389856) strcat(s, "U");
if (crc32("bkVqlZkQmATi",12) == 2862061431) strcat(s, "y");
    return s;
}

char *rugosely_adverbs() {
    char *s = calloc(9);
    if (crc32("SmonRbtLMgqh",12) == 1208762135) strcat(s, "r");
if (crc32("nqmBDwnU",8) == 2883872334) strcat(s, "d");
if (crc32("BXPQPwtsWm",10) == 1403277020) strcat(s, "u");
if (crc32("AhEkOOlQ",8) == 2438501455) strcat(s, "r");
if (crc32("HsBHhbydwcwNzLv",15) == 3018786452) strcat(s, "g");
if (crc32("agraGHTIR",9) == 366178977) strcat(s, "r");
if (crc32("mpZychyc",8) == 3730973487) strcat(s, "o");
if (crc32("MgsMZdgPQurT",12) == 3358842978) strcat(s, "L");
if (crc32("BxYRoEVzL",9) == 3958388420) strcat(s, "s");
if (crc32("vsMrDZTv",8) == 4037349248) strcat(s, "e");
if (crc32("ckPTooG",7) == 1881870055) strcat(s, "l");
if (crc32("FAiORj",6) == 77241646) strcat(s, "P");
if (crc32("WgGGdkmCbhFSEvE",15) == 2473411696) strcat(s, "y");
    return s;
}

char *quasiorientally_adverbs() {
    char *s = calloc(16);
    if (crc32("xpMSeeS",7) == 3118958812) strcat(s, "O");
if (crc32("fzWrC",5) == 1341982307) strcat(s, "q");
if (crc32("CGLhK",5) == 3927488531) strcat(s, "u");
if (crc32("yxYKpJMYeK",10) == 793733321) strcat(s, "D");
if (crc32("LnjUckORKv",10) == 2773312727) strcat(s, "a");
if (crc32("nGLsmB",6) == 2786807562) strcat(s, "s");
if (crc32("kGxHhKHqWpwJt",13) == 2676700164) strcat(s, "Y");
if (crc32("crZtgCzkP",9) == 1815319708) strcat(s, "i");
if (crc32("SSIcdwY",7) == 1143755077) strcat(s, "o");
if (crc32("bBDVeVzZlWe",11) == 1948455618) strcat(s, "r");
if (crc32("dhSKAyTAJ",9) == 1619417632) strcat(s, "w");
if (crc32("eoMzPm",6) == 1262088705) strcat(s, "i");
if (crc32("LOmrNzmgQtfQG",13) == 765911416) strcat(s, "x");
if (crc32("extdHER",7) == 1835483691) strcat(s, "e");
if (crc32("HfawODRT",8) == 711480426) strcat(s, "Z");
if (crc32("YHTkgNrjDAhtICc",15) == 3794957979) strcat(s, "n");
if (crc32("rjTOHT",6) == 1144605251) strcat(s, "v");
if (crc32("PVJWiEDpXmK",11) == 1734989703) strcat(s, "t");
if (crc32("NvsmtdVM",8) == 1155398043) strcat(s, "h");
if (crc32("PVAFQNyHK",9) == 3227123610) strcat(s, "a");
if (crc32("IfAvTx",6) == 1191196487) strcat(s, "R");
if (crc32("PHEWhXu",7) == 2410845853) strcat(s, "l");
if (crc32("KpNXzSWVXm",10) == 2268862875) strcat(s, "Q");
if (crc32("qNPepDjmrEOuN",13) == 2950604265) strcat(s, "l");
if (crc32("hebmVpG",7) == 4161058593) strcat(s, "y");
    return s;
}

char *sinningly_adverbs() {
    char *s = calloc(10);
    if (crc32("fAuZmGXRxEF",11) == 4151177129) strcat(s, "Q");
if (crc32("wXjRFtTqyQfle",13) == 1355911893) strcat(s, "s");
if (crc32("ZlSQm",5) == 3913352340) strcat(s, "m");
if (crc32("FWvNrCtOycY",11) == 2336596158) strcat(s, "i");
if (crc32("xgasPikAxyVzMQw",15) == 1276273057) strcat(s, "n");
if (crc32("QCLmhecxSS",10) == 1675647635) strcat(s, "n");
if (crc32("EtXpphXE",8) == 373018212) strcat(s, "Y");
if (crc32("wXjujpwH",8) == 1405352471) strcat(s, "i");
if (crc32("Xrnini",6) == 2179102684) strcat(s, "n");
if (crc32("mcJvJlpFnbHZPM",14) == 1903375044) strcat(s, "g");
if (crc32("dtFWLVQRHfE",11) == 1968680329) strcat(s, "F");
if (crc32("FPIWIyLlJeurN",13) == 636853737) strcat(s, "l");
if (crc32("Sqlorbo",7) == 2904246011) strcat(s, "y");
    return s;
}

char *subglobosely_adverbs() {
    char *s = calloc(13);
    if (crc32("MgEwIxRr",8) == 129293479) strcat(s, "s");
if (crc32("bOmQUgJaKPy",11) == 575047682) strcat(s, "u");
if (crc32("NofnJJZrcDMXtSa",15) == 3136818346) strcat(s, "N");
if (crc32("tcIXRoaMxmkt",12) == 140057632) strcat(s, "b");
if (crc32("VxOMzZr",7) == 1557961050) strcat(s, "g");
if (crc32("khDXc",5) == 119057423) strcat(s, "g");
if (crc32("keWdJCJfMeKvX",13) == 3287273975) strcat(s, "l");
if (crc32("rQrrZuqmXkauK",13) == 3311334410) strcat(s, "l");
if (crc32("uJELvUgdS",9) == 3202565487) strcat(s, "o");
if (crc32("ssJgDJMICPJ",11) == 2252189394) strcat(s, "b");
if (crc32("FluCwEHgUxao",12) == 1639692799) strcat(s, "Z");
if (crc32("BPYhXDYGyy",10) == 2700980395) strcat(s, "o");
if (crc32("nwjtDeZpSl",10) == 27438807) strcat(s, "s");
if (crc32("VPbWaP",6) == 3159853357) strcat(s, "e");
if (crc32("GkNGcAdKqnfxgHK",15) == 3745819919) strcat(s, "l");
if (crc32("EjFdWGBEHk",10) == 2626359906) strcat(s, "y");
    return s;
}

char *transmutably_adverbs() {
    char *s = calloc(13);
    if (crc32("TcWiI",5) == 297506378) strcat(s, "U");
if (crc32("WukajqCGW",9) == 1719264540) strcat(s, "t");
if (crc32("ycMjhJ",6) == 692876959) strcat(s, "z");
if (crc32("BbIfB",5) == 2701171054) strcat(s, "r");
if (crc32("KlGlytzBo",9) == 2509227274) strcat(s, "Z");
if (crc32("ueRXuFcq",8) == 1344132667) strcat(s, "a");
if (crc32("sVbZXNUplePOMD",14) == 1473644000) strcat(s, "n");
if (crc32("HdqBAyKQX",9) == 370549269) strcat(s, "s");
if (crc32("akYHZT",6) == 826867040) strcat(s, "m");
if (crc32("XqqwlzpLAM",10) == 3628115689) strcat(s, "m");
if (crc32("GiMBHnXL",8) == 3628090159) strcat(s, "u");
if (crc32("BSlbgvsIiQbR",12) == 2342704622) strcat(s, "t");
if (crc32("CdPvXFfCtZYkDP",14) == 2197849297) strcat(s, "a");
if (crc32("cQJOe",5) == 1547000908) strcat(s, "b");
if (crc32("VzPRPBHrMBI",11) == 2090201042) strcat(s, "U");
if (crc32("FCJlc",5) == 4174295416) strcat(s, "l");
if (crc32("vgMFILeBTYhNY",13) == 2452304513) strcat(s, "R");
if (crc32("fSnpJFAfjqk",11) == 1385480075) strcat(s, "y");
    return s;
}

char *crabbedly_adverbs() {
    char *s = calloc(10);
    if (crc32("ETiQyGf",7) == 1436686646) strcat(s, "L");
if (crc32("WUKGPWIXgOxQIEg",15) == 2202521757) strcat(s, "c");
if (crc32("NPLatlubvCBECDu",15) == 2616113289) strcat(s, "V");
if (crc32("pAdZpnSme",9) == 2150311492) strcat(s, "r");
if (crc32("AxEbDBeiVxd",11) == 3207916837) strcat(s, "a");
if (crc32("DgHersiUHE",10) == 2247658446) strcat(s, "b");
if (crc32("UKmtgPPcMVjQT",13) == 984670115) strcat(s, "b");
if (crc32("bYFAQ",5) == 315391308) strcat(s, "e");
if (crc32("rpUTgXLvfs",10) == 1296984616) strcat(s, "d");
if (crc32("lXCUpgHhCl",10) == 2418020763) strcat(s, "l");
if (crc32("dwGRhNjv",8) == 3927970288) strcat(s, "y");
    return s;
}

char *preevidently_adverbs() {
    char *s = calloc(13);
    if (crc32("inhyefoOgEjJ",12) == 3630895847) strcat(s, "p");
if (crc32("tPtBMXaQz",9) == 2959656059) strcat(s, "r");
if (crc32("LqDReENMcVoyQz",14) == 1711544392) strcat(s, "e");
if (crc32("qIGgDUoSRvkGnht",15) == 1130694509) strcat(s, "e");
if (crc32("rxfyuspJLqwqWnu",15) == 3778480437) strcat(s, "A");
if (crc32("aFlwD",5) == 2349725437) strcat(s, "v");
if (crc32("MpSXzlGPepo",11) == 3889181207) strcat(s, "i");
if (crc32("LPhkj",5) == 4253478213) strcat(s, "d");
if (crc32("BkCWLNWuhq",10) == 2706451289) strcat(s, "s");
if (crc32("TOHiYCBhEjzf",12) == 812030356) strcat(s, "e");
if (crc32("AmqXbwiopdpl",12) == 3239589506) strcat(s, "c");
if (crc32("AqkAbLbzCIA",11) == 2410938802) strcat(s, "n");
if (crc32("xaqrfJfsud",10) == 1023206726) strcat(s, "w");
if (crc32("YhGkCIzvSTITITD",15) == 1874201624) strcat(s, "t");
if (crc32("osMFrPnMetHhS",13) == 2351430930) strcat(s, "l");
if (crc32("zdqTdZPRPnk",11) == 1610820630) strcat(s, "q");
if (crc32("WIStZT",6) == 1404625703) strcat(s, "y");
    return s;
}

char *anteriorly_adverbs() {
    char *s = calloc(11);
    if (crc32("WipfsQ",6) == 2602610852) strcat(s, "V");
if (crc32("UqrRYQ",6) == 4029211694) strcat(s, "a");
if (crc32("aOLvtmyPKBRfIC",14) == 531788929) strcat(s, "n");
if (crc32("CCJnFnW",7) == 3533667212) strcat(s, "t");
if (crc32("gNWLpLmMA",9) == 3549583394) strcat(s, "x");
if (crc32("lcqkUANADEPc",12) == 4217016957) strcat(s, "e");
if (crc32("pBqrnylmwMMdfY",14) == 2958784187) strcat(s, "r");
if (crc32("AXGOcLeDpOxmAn",14) == 1436021950) strcat(s, "L");
if (crc32("TFfdVmxlWBp",11) == 4229462512) strcat(s, "i");
if (crc32("bsZffEEOGLXU",12) == 3398577927) strcat(s, "o");
if (crc32("punXwB",6) == 3391681384) strcat(s, "r");
if (crc32("xBkczhIEFPcCKub",15) == 4092640629) strcat(s, "W");
if (crc32("SayDJJJe",8) == 2902346890) strcat(s, "l");
if (crc32("ogMvSXNNDObrWJt",15) == 2368649465) strcat(s, "W");
if (crc32("WrLaaarQcb",10) == 322574437) strcat(s, "y");
    return s;
}

char *nontoxically_adverbs() {
    char *s = calloc(13);
    if (crc32("AJPqCcmNRDrIom",14) == 1168053982) strcat(s, "n");
if (crc32("TcFKNzLyq",9) == 4176731302) strcat(s, "g");
if (crc32("VbBDZ",5) == 2364250555) strcat(s, "o");
if (crc32("XHKMPgiCK",9) == 3280954025) strcat(s, "n");
if (crc32("LZXTbau",7) == 3892590342) strcat(s, "t");
if (crc32("FZItnGiVVbFIAJi",15) == 3421279755) strcat(s, "b");
if (crc32("HCihWbpa",8) == 1677921190) strcat(s, "o");
if (crc32("aHXDwFDtLgSTd",13) == 1788875352) strcat(s, "d");
if (crc32("ayKqYZqeNLG",11) == 3521013721) strcat(s, "x");
if (crc32("XAHoIpqmT",9) == 2471013350) strcat(s, "i");
if (crc32("NBkDuLHEMg",10) == 3270784658) strcat(s, "g");
if (crc32("JjAGsrdgkDUWtb",14) == 1228434679) strcat(s, "c");
if (crc32("YNmgkF",6) == 4213514775) strcat(s, "q");
if (crc32("DDKrkYGxtouLei",14) == 2589495953) strcat(s, "a");
if (crc32("yqYRIDpRn",9) == 437984061) strcat(s, "l");
if (crc32("CRstdM",6) == 1498618298) strcat(s, "l");
if (crc32("sblTmKdTmP",10) == 725637969) strcat(s, "O");
if (crc32("qXBksURhFTgX",12) == 1674485577) strcat(s, "y");
    return s;
}

char *unsanguinely_adverbs() {
    char *s = calloc(13);
    if (crc32("PtWhA",5) == 3747653505) strcat(s, "u");
if (crc32("arCEZ",5) == 3609915844) strcat(s, "n");
if (crc32("gGiiNz",6) == 2447550615) strcat(s, "s");
if (crc32("tzptGzDTzE",10) == 3225996968) strcat(s, "a");
if (crc32("IGdNbFD",7) == 4230645924) strcat(s, "A");
if (crc32("HTNQPMfRIrGdQzN",15) == 3340232515) strcat(s, "n");
if (crc32("EvdcLNlCTpEM",12) == 1078175136) strcat(s, "Z");
if (crc32("fCIvZoeHqVtPJZe",15) == 2059889058) strcat(s, "g");
if (crc32("NhYPQtu",7) == 44050717) strcat(s, "S");
if (crc32("cMUkUPvVAOZP",12) == 2678370087) strcat(s, "u");
if (crc32("XcWoORmBeYScx",13) == 3796999582) strcat(s, "S");
if (crc32("JQAQIJ",6) == 3809888719) strcat(s, "i");
if (crc32("JtvJD",5) == 1847276338) strcat(s, "K");
if (crc32("tVOlXZBogdxQ",12) == 1397059253) strcat(s, "n");
if (crc32("PZrzD",5) == 2845147099) strcat(s, "e");
if (crc32("xmZzjkBk",8) == 2720342101) strcat(s, "S");
if (crc32("OibIHEK",7) == 397625542) strcat(s, "l");
if (crc32("SwXnNKTj",8) == 2853656007) strcat(s, "M");
if (crc32("lmEOR",5) == 3615059638) strcat(s, "y");
    return s;
}

char *unnasally_adverbs() {
    char *s = calloc(10);
    if (crc32("cgklz",5) == 1145094185) strcat(s, "V");
if (crc32("GCmSyzbWvQz",11) == 2995903305) strcat(s, "u");
if (crc32("eekyKUgAvVTzbOh",15) == 1779021836) strcat(s, "n");
if (crc32("SYFxpTqYjHCbiDp",15) == 3504851056) strcat(s, "u");
if (crc32("HVEurAwxMXc",11) == 1201812415) strcat(s, "n");
if (crc32("YjXwPAoVBq",10) == 587121783) strcat(s, "S");
if (crc32("byVvw",5) == 3973207243) strcat(s, "a");
if (crc32("SDveIVIWZIgD",12) == 1664105037) strcat(s, "v");
if (crc32("RMXkmF",6) == 1429235300) strcat(s, "s");
if (crc32("PkidlndUNQgcW",13) == 1344962802) strcat(s, "y");
if (crc32("mPchws",6) == 4221468462) strcat(s, "a");
if (crc32("AYqMvRrYT",9) == 3687593122) strcat(s, "l");
if (crc32("diEQrVLvWok",11) == 3724570258) strcat(s, "v");
if (crc32("YAtsHrKgGQaoJtG",15) == 2638640006) strcat(s, "l");
if (crc32("dyZzkTbPhP",10) == 227562424) strcat(s, "r");
if (crc32("uyBHcuB",7) == 4085899126) strcat(s, "y");
    return s;
}

char *granularly_adverbs() {
    char *s = calloc(11);
    if (crc32("YugirfxRS",9) == 15748494) strcat(s, "g");
if (crc32("JLCyccTMDXxrrv",14) == 3441797468) strcat(s, "r");
if (crc32("TYfhx",5) == 3723651670) strcat(s, "i");
if (crc32("gcjVckvvZ",9) == 3849103421) strcat(s, "a");
if (crc32("oagHlWyxUF",10) == 3289872224) strcat(s, "n");
if (crc32("rKIGTlam",8) == 1167612488) strcat(s, "u");
if (crc32("XKGFteadPNblA",13) == 975394518) strcat(s, "l");
if (crc32("tOWkBXPwAvfTdm",14) == 2584909701) strcat(s, "l");
if (crc32("chyZnoCsfAcSpa",14) == 2310990927) strcat(s, "a");
if (crc32("DwWLWHfWozW",11) == 510681643) strcat(s, "H");
if (crc32("GBtkBOmvY",9) == 2278529088) strcat(s, "r");
if (crc32("dkUXTgrSGpyEp",13) == 977241896) strcat(s, "R");
if (crc32("vZoGDysFKZi",11) == 3879019714) strcat(s, "l");
if (crc32("UYmcSDzS",8) == 768117716) strcat(s, "y");
    return s;
}

char *immorally_adverbs() {
    char *s = calloc(10);
    if (crc32("baeEpwi",7) == 3829963513) strcat(s, "D");
if (crc32("NTbvmVMUwgSHsX",14) == 1574327173) strcat(s, "i");
if (crc32("KrzXbWUZAT",10) == 2250058828) strcat(s, "Y");
if (crc32("TPdMdepIeniEy",13) == 1161045825) strcat(s, "m");
if (crc32("zyYzji",6) == 2879847109) strcat(s, "m");
if (crc32("mhSUobOY",8) == 2705068258) strcat(s, "o");
if (crc32("wijctV",6) == 4154037739) strcat(s, "o");
if (crc32("WSjlPWZIQxZJaL",14) == 3515184689) strcat(s, "r");
if (crc32("ZWjbSJFrrsI",11) == 130119008) strcat(s, "a");
if (crc32("OdAGIjnZKZGYeo",14) == 535401448) strcat(s, "y");
if (crc32("IELTruaSZUwhCT",14) == 2140432277) strcat(s, "l");
if (crc32("QieRdFAPwF",10) == 2648579687) strcat(s, "l");
if (crc32("KGcmUomjMN",10) == 2808933610) strcat(s, "K");
if (crc32("UlzFTXUsyLeN",12) == 203338016) strcat(s, "y");
    return s;
}

char *unprogressively_adverbs() {
    char *s = calloc(16);
    if (crc32("aMjNZesGMrZq",12) == 182169613) strcat(s, "q");
if (crc32("aCPwmklAo",9) == 3352716222) strcat(s, "u");
if (crc32("bGcYoYPoQC",10) == 1813001852) strcat(s, "n");
if (crc32("DtzvCeitJbpOZH",14) == 1428649146) strcat(s, "S");
if (crc32("oobcJChifBR",11) == 689831592) strcat(s, "p");
if (crc32("wwEjRNdjvVYh",12) == 3041768154) strcat(s, "j");
if (crc32("zfQGjB",6) == 212688378) strcat(s, "r");
if (crc32("voCIaAHClgis",12) == 3820839348) strcat(s, "g");
if (crc32("sxCHiErJCWUGhWl",15) == 2139912425) strcat(s, "o");
if (crc32("qhywqANkFjk",11) == 2241864042) strcat(s, "K");
if (crc32("GWomNAq",7) == 1795292320) strcat(s, "g");
if (crc32("pDaBmXRfNzjxZHH",15) == 3159722353) strcat(s, "c");
if (crc32("nTKkc",5) == 2318550635) strcat(s, "r");
if (crc32("JUMbalxEa",9) == 3899137885) strcat(s, "e");
if (crc32("fTUOtOpX",8) == 1934995078) strcat(s, "I");
if (crc32("QBbQAAKWagdTO",13) == 1473165703) strcat(s, "s");
if (crc32("zvQvGrk",7) == 4102947325) strcat(s, "b");
if (crc32("ILuBkJvaeX",10) == 2225924265) strcat(s, "s");
if (crc32("gardUaIcj",9) == 1869152300) strcat(s, "j");
if (crc32("UuouXLabHeEZ",12) == 4187929018) strcat(s, "i");
if (crc32("ujfnALPQCDR",11) == 3597594342) strcat(s, "G");
if (crc32("XajZYlN",7) == 42826104) strcat(s, "v");
if (crc32("ekrkA",5) == 2876244086) strcat(s, "e");
if (crc32("WaAqdGW",7) == 189734097) strcat(s, "l");
if (crc32("piPqfwBojktf",12) == 3018389923) strcat(s, "y");
    return s;
}

char *undefendably_adverbs() {
    char *s = calloc(13);
    if (crc32("dnkxEXDNUFBTkL",14) == 2374097620) strcat(s, "C");
if (crc32("dDkeg",5) == 825796130) strcat(s, "u");
if (crc32("rngsJKDsK",9) == 4204607465) strcat(s, "r");
if (crc32("xGWZbVGMbKdg",12) == 1158066502) strcat(s, "n");
if (crc32("MVCXb",5) == 765214009) strcat(s, "k");
if (crc32("vvRZGFL",7) == 2236668323) strcat(s, "d");
if (crc32("xXgBCaecXU",10) == 1307789924) strcat(s, "w");
if (crc32("tCttp",5) == 192891779) strcat(s, "e");
if (crc32("CNWUzjMQaynhIM",14) == 3095766806) strcat(s, "E");
if (crc32("bzFFgNwtVIir",12) == 3530279386) strcat(s, "f");
if (crc32("cumkyaqN",8) == 670873412) strcat(s, "e");
if (crc32("VKnAnzWiSvKat",13) == 2452550924) strcat(s, "n");
if (crc32("QPdBUkxqxMYwKf",14) == 1678897089) strcat(s, "d");
if (crc32("PeZTvCgGVGPU",12) == 1028841406) strcat(s, "a");
if (crc32("vhjMGnfw",8) == 117725992) strcat(s, "b");
if (crc32("zqHQObRVnxCiK",13) == 1483851315) strcat(s, "l");
if (crc32("nMQJhDIaoxgVX",13) == 1282549343) strcat(s, "y");
    return s;
}

char *quaveringly_adverbs() {
    char *s = calloc(12);
    if (crc32("eSwxnzxYe",9) == 2812244331) strcat(s, "e");
if (crc32("eriLZOes",8) == 987152689) strcat(s, "q");
if (crc32("JIfwoRigIR",10) == 863079750) strcat(s, "u");
if (crc32("DhAUim",6) == 2075285943) strcat(s, "x");
if (crc32("OprUNrrCFzY",11) == 4042301536) strcat(s, "a");
if (crc32("IOIAvzGFIKKsWXY",15) == 2765606525) strcat(s, "v");
if (crc32("KSYTsKZDb",9) == 3838902244) strcat(s, "e");
if (crc32("tVXUHgxEI",9) == 2196301068) strcat(s, "r");
if (crc32("OZQjxag",7) == 1137327979) strcat(s, "l");
if (crc32("gNIZVWQCaHPvLo",14) == 3084265231) strcat(s, "i");
if (crc32("WTXURIKyRBumoE",14) == 810539260) strcat(s, "n");
if (crc32("iJCEMfwY",8) == 80728102) strcat(s, "g");
if (crc32("cayTiV",6) == 3494236159) strcat(s, "l");
if (crc32("YgVVYbMABuw",11) == 1455628014) strcat(s, "y");
    return s;
}

char *semisuccessfully_adverbs() {
    char *s = calloc(17);
    if (crc32("KtUwDKwAgMpC",12) == 957746705) strcat(s, "s");
if (crc32("UpDzqBZqQBjhbo",14) == 2438179530) strcat(s, "F");
if (crc32("YdllBhznNf",10) == 191107558) strcat(s, "e");
if (crc32("MxKFVkL",7) == 4055570072) strcat(s, "T");
if (crc32("YdZzZSICGVQfCw",14) == 1969602411) strcat(s, "m");
if (crc32("SqfCn",5) == 1461084916) strcat(s, "i");
if (crc32("EOmHplX",7) == 2992270090) strcat(s, "s");
if (crc32("xcyUQnBlx",9) == 1598029272) strcat(s, "m");
if (crc32("gSnRlsUOi",9) == 2480759281) strcat(s, "u");
if (crc32("SkIPhmbYiVc",11) == 2723410760) strcat(s, "c");
if (crc32("exuGVGl",7) == 4055360976) strcat(s, "R");
if (crc32("rAHJLmRuRMavwCQ",15) == 2738278918) strcat(s, "c");
if (crc32("HDOQwWMfnhKC",12) == 3961298560) strcat(s, "O");
if (crc32("IHQtDUFhfVfc",12) == 2081691119) strcat(s, "e");
if (crc32("NWcBRfvRIh",10) == 326201070) strcat(s, "Z");
if (crc32("EpBKOuioTOx",11) == 3791860672) strcat(s, "s");
if (crc32("nJpxrVZvFfXwsx",14) == 4082244685) strcat(s, "E");
if (crc32("CVgnBcvt",8) == 3829907134) strcat(s, "s");
if (crc32("JMPFAYINuGdAE",13) == 1036693073) strcat(s, "f");
if (crc32("nODIGSIeeEi",11) == 384416994) strcat(s, "u");
if (crc32("VxkizoJCXO",10) == 2559525080) strcat(s, "w");
if (crc32("gBLIze",6) == 3229728777) strcat(s, "l");
if (crc32("pwLoojtizTMHxG",14) == 2852181683) strcat(s, "l");
if (crc32("FgvTJSeHfllPj",13) == 1941800974) strcat(s, "y");
    return s;
}

char *stompingly_adverbs() {
    char *s = calloc(11);
    if (crc32("bkhreozrl",9) == 2176340457) strcat(s, "e");
if (crc32("SEAavsnVZnkf",12) == 1534884682) strcat(s, "s");
if (crc32("rKwJNPZFzwWQFv",14) == 2464645354) strcat(s, "P");
if (crc32("GGaGL",5) == 2742380206) strcat(s, "t");
if (crc32("nyNyS",5) == 1084410592) strcat(s, "y");
if (crc32("KQROSVD",7) == 1857822429) strcat(s, "o");
if (crc32("hLlWexCOdke",11) == 4134955915) strcat(s, "m");
if (crc32("jGJibXySlAfVI",13) == 2975561156) strcat(s, "p");
if (crc32("SCGopPdgzn",10) == 3527166560) strcat(s, "r");
if (crc32("Srcak",5) == 2494610782) strcat(s, "i");
if (crc32("HDbtFhpt",8) == 2291719214) strcat(s, "J");
if (crc32("aarxCUM",7) == 3823229097) strcat(s, "n");
if (crc32("TGHbMJQsLInnbPa",15) == 2588766576) strcat(s, "g");
if (crc32("BgRWQj",6) == 2143305847) strcat(s, "Y");
if (crc32("tSQdSxPFYRzixb",14) == 3569517749) strcat(s, "l");
if (crc32("HrKnlnWB",8) == 4188123406) strcat(s, "y");
    return s;
}

char *mechanomorphically_adverbs() {
    char *s = calloc(19);
    if (crc32("ZhNyhtvs",8) == 3246591688) strcat(s, "V");
if (crc32("jjYecgkfIK",10) == 3126788407) strcat(s, "m");
if (crc32("dpMSLyywGUX",11) == 1874347822) strcat(s, "M");
if (crc32("buMKNRmuRxO",11) == 788134793) strcat(s, "e");
if (crc32("pAJXTrYB",8) == 1830780766) strcat(s, "c");
if (crc32("SAmIqwzvS",9) == 1793900301) strcat(s, "h");
if (crc32("sZzvOLvtosIz",12) == 1040773321) strcat(s, "w");
if (crc32("aPqppCQqhlK",11) == 3583481626) strcat(s, "a");
if (crc32("hncvfZPAgwW",11) == 4284877585) strcat(s, "p");
if (crc32("zUmYGHDP",8) == 788677142) strcat(s, "n");
if (crc32("rwTPYcylk",9) == 289773780) strcat(s, "o");
if (crc32("PJTLZwiGYrCiJ",13) == 2030995773) strcat(s, "m");
if (crc32("kWpuFMqarub",11) == 2147717447) strcat(s, "j");
if (crc32("ZPdWQhfQePK",11) == 125948394) strcat(s, "o");
if (crc32("ZrSwoxBsXDvn",12) == 3677020862) strcat(s, "D");
if (crc32("fVmpdxsnkzyyLl",14) == 2864421033) strcat(s, "r");
if (crc32("fCcbPbFgfkeAN",13) == 725645694) strcat(s, "g");
if (crc32("GThLyubzxQXLoY",14) == 3248966818) strcat(s, "p");
if (crc32("LStWPw",6) == 4113446597) strcat(s, "P");
if (crc32("GIeSFOhh",8) == 2610416156) strcat(s, "h");
if (crc32("XVRAHpVYCmfKBx",14) == 3853992337) strcat(s, "i");
if (crc32("FGkMhBfDDFG",11) == 3979722617) strcat(s, "Z");
if (crc32("IFSEnrgIwENPmP",14) == 4286311209) strcat(s, "c");
if (crc32("hgTCv",5) == 3222686344) strcat(s, "a");
if (crc32("ugixByybvFl",11) == 1890826739) strcat(s, "l");
if (crc32("zOQOuOtKsadPEN",14) == 56306575) strcat(s, "l");
if (crc32("VLnMl",5) == 3811168482) strcat(s, "y");
    return s;
}

char *defensively_adverbs() {
    char *s = calloc(12);
    if (crc32("kThsfBkvoRpehDa",15) == 3310076314) strcat(s, "d");
if (crc32("XINwQSMyBF",10) == 4184822200) strcat(s, "e");
if (crc32("cpxKYIS",7) == 420680136) strcat(s, "f");
if (crc32("AqECqMr",7) == 1572477162) strcat(s, "K");
if (crc32("CnAGvebgJWrfJ",13) == 30934987) strcat(s, "e");
if (crc32("tMZGTZ",6) == 85862069) strcat(s, "n");
if (crc32("ORhZMibCO",9) == 1967423016) strcat(s, "s");
if (crc32("qNXhTmGZSi",10) == 3865465120) strcat(s, "i");
if (crc32("mXkBATa",7) == 2098850019) strcat(s, "r");
if (crc32("juOJknbv",8) == 920072131) strcat(s, "v");
if (crc32("ShifsItrKj",10) == 2756142308) strcat(s, "e");
if (crc32("cftsAFIcZLg",11) == 3621810762) strcat(s, "z");
if (crc32("xKtunexHIKec",12) == 747871183) strcat(s, "l");
if (crc32("UNBgVWbHQ",9) == 3461275194) strcat(s, "H");
if (crc32("ORtHwRW",7) == 279429275) strcat(s, "y");
    return s;
}

char *quasiproudly_adverbs() {
    char *s = calloc(13);
    if (crc32("KNdTg",5) == 3491085852) strcat(s, "q");
if (crc32("BAKUURPlEHgaxQz",15) == 3266849586) strcat(s, "u");
if (crc32("JAxNcR",6) == 3746018116) strcat(s, "K");
if (crc32("gCOOWFwjatrTU",13) == 3133506543) strcat(s, "a");
if (crc32("LXGaRMzZM",9) == 2820109444) strcat(s, "g");
if (crc32("QqOtVluPPP",10) == 3716576759) strcat(s, "s");
if (crc32("MgadozvZba",10) == 1851448329) strcat(s, "S");
if (crc32("YLpLPHP",7) == 1155269646) strcat(s, "i");
if (crc32("lMDZa",5) == 4276890813) strcat(s, "p");
if (crc32("hszEqydps",9) == 1334356286) strcat(s, "r");
if (crc32("avShNWXFP",9) == 373440595) strcat(s, "P");
if (crc32("biybS",5) == 2641834253) strcat(s, "o");
if (crc32("zEfXqR",6) == 1154217861) strcat(s, "u");
if (crc32("SQZGLhdMXF",10) == 1640570708) strcat(s, "d");
if (crc32("yLPRQ",5) == 461365794) strcat(s, "l");
if (crc32("UqzmPFhc",8) == 2074937136) strcat(s, "n");
if (crc32("HLafUtYkMIHiTL",14) == 3765362039) strcat(s, "y");
    return s;
}

char *unrustically_adverbs() {
    char *s = calloc(13);
    if (crc32("utHQeKedBrvZp",13) == 2787830085) strcat(s, "o");
if (crc32("XgPTnDLEJiJS",12) == 2014375662) strcat(s, "u");
if (crc32("rfhfkSgbgQg",11) == 932434237) strcat(s, "G");
if (crc32("rImpUpSap",9) == 907566539) strcat(s, "n");
if (crc32("EjDvpUB",7) == 3147365171) strcat(s, "s");
if (crc32("YdiOsnDDepAStqb",15) == 1601741291) strcat(s, "r");
if (crc32("umHiCKRk",8) == 3099619814) strcat(s, "g");
if (crc32("kEdEtDeiY",9) == 2308869479) strcat(s, "u");
if (crc32("FsxnsFxkYVI",11) == 1737908621) strcat(s, "s");
if (crc32("hlhGNJGBpAb",11) == 4055822214) strcat(s, "t");
if (crc32("fFDuTTVGqJw",11) == 1197329234) strcat(s, "i");
if (crc32("fccCufr",7) == 1942968209) strcat(s, "c");
if (crc32("wbxcywhkBg",10) == 2911933519) strcat(s, "o");
if (crc32("ZwsBoN",6) == 783350734) strcat(s, "a");
if (crc32("AryIVy",6) == 1519428054) strcat(s, "l");
if (crc32("RBvNWT",6) == 1991379053) strcat(s, "B");
if (crc32("umknNooWlGFzq",13) == 228816097) strcat(s, "l");
if (crc32("WOJLArWL",8) == 1158674730) strcat(s, "y");
    return s;
}

char *nonvenally_adverbs() {
    char *s = calloc(11);
    if (crc32("EQMpGPSb",8) == 2478590025) strcat(s, "n");
if (crc32("EaGMzDCarr",10) == 3002688438) strcat(s, "o");
if (crc32("lzrMNYElkTDHMW",14) == 2889640746) strcat(s, "D");
if (crc32("hqLxItgy",8) == 730479906) strcat(s, "n");
if (crc32("ajKgqBWHafMc",12) == 4115793081) strcat(s, "X");
if (crc32("vupxwx",6) == 1391898507) strcat(s, "v");
if (crc32("DqAquuRAus",10) == 2640346419) strcat(s, "T");
if (crc32("BvHCDgEUgs",10) == 4013017501) strcat(s, "e");
if (crc32("MbeZEYkCOjQiKUE",15) == 950979073) strcat(s, "j");
if (crc32("ThIeCGb",7) == 2568112331) strcat(s, "n");
if (crc32("pmuuzbAJDZJx",12) == 3093309402) strcat(s, "a");
if (crc32("OxciTNcy",8) == 154677359) strcat(s, "l");
if (crc32("wzdrTZL",7) == 3876952303) strcat(s, "l");
if (crc32("arcLR",5) == 518423117) strcat(s, "Q");
if (crc32("gYghMMhuqEdlneh",15) == 3198064215) strcat(s, "y");
    return s;
}

char *ungelatinously_adverbs() {
    char *s = calloc(15);
    if (crc32("tGQtcqPa",8) == 4223320249) strcat(s, "u");
if (crc32("sJaSrmIsJVZ",11) == 3972583767) strcat(s, "n");
if (crc32("ltDDgUdyrSRt",12) == 2954158347) strcat(s, "g");
if (crc32("ZUuPOasCC",9) == 2506248324) strcat(s, "e");
if (crc32("mSRsKl",6) == 438411937) strcat(s, "l");
if (crc32("mfpFkbwHJ",9) == 3026828427) strcat(s, "o");
if (crc32("FHtnkIse",8) == 3777220681) strcat(s, "a");
if (crc32("uTxPqBifrOjS",12) == 4046427936) strcat(s, "F");
if (crc32("EtPJPjToezBF",12) == 2444575146) strcat(s, "t");
if (crc32("ywOVYiCYQSASPXE",15) == 1231581947) strcat(s, "i");
if (crc32("KdbgtxzDfPtm",12) == 3554351214) strcat(s, "D");
if (crc32("QRDqMX",6) == 1440859097) strcat(s, "n");
if (crc32("HTtqYCSRnMl",11) == 418000934) strcat(s, "o");
if (crc32("eEmcu",5) == 443234569) strcat(s, "I");
if (crc32("emQyHCMRrJkk",12) == 3295594408) strcat(s, "u");
if (crc32("GLPfPrxPTp",10) == 2104719620) strcat(s, "W");
if (crc32("RcmgFgilAsjSvpO",15) == 2465690280) strcat(s, "s");
if (crc32("LHBlvQUeWEtqh",13) == 2628768768) strcat(s, "x");
if (crc32("PfJDUcNon",9) == 493231362) strcat(s, "l");
if (crc32("CTBWV",5) == 2582784909) strcat(s, "y");
    return s;
}

char *exultingly_adverbs() {
    char *s = calloc(11);
    if (crc32("woxTWy",6) == 2778361938) strcat(s, "e");
if (crc32("IdhgcXQLrm",10) == 1871560413) strcat(s, "x");
if (crc32("bBadOwNXTrcGrzA",15) == 1852081016) strcat(s, "u");
if (crc32("WQWxIssAKeiQ",12) == 3290555211) strcat(s, "a");
if (crc32("MUJPjNuF",8) == 3555718719) strcat(s, "l");
if (crc32("zAoMEDc",7) == 4019697341) strcat(s, "f");
if (crc32("jCLVdxfpJn",10) == 1283458367) strcat(s, "t");
if (crc32("zSPnLTa",7) == 3754095342) strcat(s, "Y");
if (crc32("medoitOkfLFc",12) == 1699204827) strcat(s, "i");
if (crc32("tSxfHyvOswSvk",13) == 2256042291) strcat(s, "T");
if (crc32("dzuypyu",7) == 3846846170) strcat(s, "n");
if (crc32("ICrHd",5) == 2917766285) strcat(s, "b");
if (crc32("mvcRw",5) == 3853063569) strcat(s, "g");
if (crc32("BELVlLIgAnuZkbZ",15) == 795180436) strcat(s, "l");
if (crc32("fqhhbKKI",8) == 2234592802) strcat(s, "y");
    return s;
}

char *disconcertedly_adverbs() {
    char *s = calloc(15);
    if (crc32("crypGusTDuQEbyY",15) == 1761248638) strcat(s, "r");
if (crc32("ckCGCgH",7) == 2096509913) strcat(s, "d");
if (crc32("OOWaiOtk",8) == 3553328851) strcat(s, "k");
if (crc32("FKnrEYmWluuTQEL",15) == 3763900967) strcat(s, "i");
if (crc32("BnCpomkHqYgdFP",14) == 2585359252) strcat(s, "s");
if (crc32("zCIkXUup",8) == 1450490161) strcat(s, "f");
if (crc32("ficJde",6) == 2476356439) strcat(s, "c");
if (crc32("PWiPsfvXO",9) == 1187643157) strcat(s, "J");
if (crc32("HsGcphG",7) == 3037928055) strcat(s, "o");
if (crc32("JlVNJFyIIFTy",12) == 3818213321) strcat(s, "E");
if (crc32("sAjymlvxXctc",12) == 1843640958) strcat(s, "n");
if (crc32("GRNBZOx",7) == 3276556873) strcat(s, "c");
if (crc32("KynKVJPefAvcxSx",15) == 654449459) strcat(s, "e");
if (crc32("dGTArbTMaatBcL",14) == 2660333826) strcat(s, "R");
if (crc32("fGeYWrEvuAbse",13) == 3524687005) strcat(s, "r");
if (crc32("dYWEmEfW",8) == 542263951) strcat(s, "L");
if (crc32("lFWcUiPjLQUduo",14) == 2140320235) strcat(s, "t");
if (crc32("TnhTmdhMuhTq",12) == 950505795) strcat(s, "e");
if (crc32("VTmwn",5) == 3211112094) strcat(s, "d");
if (crc32("sAfOmyuod",9) == 1169295380) strcat(s, "j");
if (crc32("lZfgtQo",7) == 3787018105) strcat(s, "l");
if (crc32("WttxTHWJeJMvdx",14) == 3431419358) strcat(s, "y");
    return s;
}

char *quakily_adverbs() {
    char *s = calloc(8);
    if (crc32("LIeUTx",6) == 2050874296) strcat(s, "q");
if (crc32("KgXlnZwqjG",10) == 3811295922) strcat(s, "u");
if (crc32("QqdpNd",6) == 1983020096) strcat(s, "a");
if (crc32("qCZlQMJqsYlupu",14) == 2781591844) strcat(s, "I");
if (crc32("KkQCvxwHGVBsae",14) == 1018365727) strcat(s, "k");
if (crc32("aGkMojTrM",9) == 223870710) strcat(s, "S");
if (crc32("uriEkOIxAcvoo",13) == 145339470) strcat(s, "i");
if (crc32("EjxCbwr",7) == 4176441265) strcat(s, "h");
if (crc32("LezlmKdGoIBdoKh",15) == 4063021129) strcat(s, "l");
if (crc32("QPgZBwxX",8) == 2649150829) strcat(s, "T");
if (crc32("neEjkBTssImXZQ",14) == 1704715982) strcat(s, "y");
    return s;
}

char *agnatically_adverbs() {
    char *s = calloc(12);
    if (crc32("sRtEgaEriQVNA",13) == 2054945254) strcat(s, "a");
if (crc32("xcOMBOS",7) == 3931969141) strcat(s, "n");
if (crc32("LRnPQAVMLSQTw",13) == 152825346) strcat(s, "g");
if (crc32("jVxkdHsuGRhC",12) == 2799198500) strcat(s, "n");
if (crc32("NLTWRcnXSQlmEYA",15) == 1312146526) strcat(s, "a");
if (crc32("YYewurWnlFWyr",13) == 3959337835) strcat(s, "Q");
if (crc32("MpePdxCWWfwjoEd",15) == 980282755) strcat(s, "t");
if (crc32("eLHYEpbwF",9) == 765595141) strcat(s, "X");
if (crc32("jTwIgZHacQsnYa",14) == 1498919279) strcat(s, "i");
if (crc32("zLpNbzBNdsey",12) == 633797652) strcat(s, "c");
if (crc32("vqhuOhnOZwsA",12) == 2344585729) strcat(s, "e");
if (crc32("cKqagocCdznXI",13) == 2843027558) strcat(s, "a");
if (crc32("JEWrfU",6) == 2786835951) strcat(s, "l");
if (crc32("fwMZFkBs",8) == 1139588163) strcat(s, "n");
if (crc32("iMyMFWc",7) == 4168009639) strcat(s, "l");
if (crc32("LModShHXSHNXvG",14) == 1504377629) strcat(s, "s");
if (crc32("UzyIFDUMGTt",11) == 1059194817) strcat(s, "y");
    return s;
}

char *apishly_adverbs() {
    char *s = calloc(8);
    if (crc32("HmSMDqFgnaR",11) == 116264125) strcat(s, "C");
if (crc32("RPMBP",5) == 2660894452) strcat(s, "a");
if (crc32("RAXuAYL",7) == 3706398428) strcat(s, "p");
if (crc32("PefixYtH",8) == 1572298378) strcat(s, "i");
if (crc32("wOIcfkvsWqL",11) == 1951370355) strcat(s, "N");
if (crc32("TDdaer",6) == 3497941882) strcat(s, "s");
if (crc32("nxdBkVKgOfc",11) == 749558329) strcat(s, "B");
if (crc32("OgOOxYtfh",9) == 768655890) strcat(s, "h");
if (crc32("LGIZnDaYHe",10) == 4124752114) strcat(s, "r");
if (crc32("WzTnOUprHCRnc",13) == 2768871808) strcat(s, "l");
if (crc32("AcclfgxeIz",10) == 1630376588) strcat(s, "y");
    return s;
}

char *figurately_adverbs() {
    char *s = calloc(11);
    if (crc32("xTpbYuqZuBqQb",13) == 336257824) strcat(s, "w");
if (crc32("YuJroQMHgDxjjyF",15) == 770414944) strcat(s, "f");
if (crc32("SZzCVVFNbPmNzH",14) == 367488320) strcat(s, "i");
if (crc32("XwJefkyucfx",11) == 1554458030) strcat(s, "d");
if (crc32("cKJWEsMB",8) == 2126646417) strcat(s, "g");
if (crc32("JwBfoObCoFTwLh",14) == 2792710753) strcat(s, "v");
if (crc32("VSMwgSLZwdLRDlF",15) == 988598712) strcat(s, "u");
if (crc32("UqKbhNtNso",10) == 2006178681) strcat(s, "r");
if (crc32("uFreZwxfnzpI",12) == 2734920695) strcat(s, "a");
if (crc32("uJehvtQKqgQTxu",14) == 2044067415) strcat(s, "u");
if (crc32("vYudpXmLRzlKhaB",15) == 3717003025) strcat(s, "t");
if (crc32("nvmguasnTI",10) == 3209390936) strcat(s, "e");
if (crc32("hUSimXWOxgBu",12) == 3105219901) strcat(s, "l");
if (crc32("VHyWIBGbwwBklk",14) == 2537713809) strcat(s, "l");
if (crc32("HZzyaVWPVgij",12) == 2780478529) strcat(s, "y");
    return s;
}

char *stintingly_adverbs() {
    char *s = calloc(11);
    if (crc32("pyMaL",5) == 1376366858) strcat(s, "s");
if (crc32("VznRu",5) == 2673398209) strcat(s, "t");
if (crc32("iJkfuGEYcCFWn",13) == 706893859) strcat(s, "x");
if (crc32("zitOCC",6) == 608398306) strcat(s, "i");
if (crc32("mScFDpDkoWvrKu",14) == 623640078) strcat(s, "n");
if (crc32("ElGdSrTJ",8) == 4038455940) strcat(s, "t");
if (crc32("LgKmy",5) == 2023044028) strcat(s, "i");
if (crc32("vJsnHQS",7) == 1230082299) strcat(s, "J");
if (crc32("dBFGWbi",7) == 2065906030) strcat(s, "n");
if (crc32("bPgmLeqn",8) == 2744842144) strcat(s, "g");
if (crc32("WgMzzMgODE",10) == 510275083) strcat(s, "b");
if (crc32("cFQQFWcPhxpdsF",14) == 1223604154) strcat(s, "l");
if (crc32("EnFelEucPfeQY",13) == 1439240303) strcat(s, "y");
    return s;
}

char *persuadably_adverbs() {
    char *s = calloc(12);
    if (crc32("wdwVy",5) == 4088039880) strcat(s, "i");
if (crc32("XolXypyXNV",10) == 276318217) strcat(s, "p");
if (crc32("NohrsRJBDo",10) == 2568003559) strcat(s, "e");
if (crc32("nJjaOeOtypmJpr",14) == 591779621) strcat(s, "r");
if (crc32("BXngmaWwRDCInDv",15) == 2853597798) strcat(s, "s");
if (crc32("zwLHvkQiQFS",11) == 917038081) strcat(s, "u");
if (crc32("uTKOpLywl",9) == 2204770497) strcat(s, "B");
if (crc32("ZWCioMcd",8) == 1162931779) strcat(s, "a");
if (crc32("veyhJw",6) == 821606406) strcat(s, "b");
if (crc32("dVnrTUb",7) == 3501445712) strcat(s, "d");
if (crc32("TtisdaEOGg",10) == 1623978433) strcat(s, "a");
if (crc32("uuBBEnAzHJTu",12) == 853904791) strcat(s, "b");
if (crc32("UNNkdWFlaXoX",12) == 3942816381) strcat(s, "m");
if (crc32("oMZLhgAdp",9) == 118176343) strcat(s, "l");
if (crc32("oObhTjZGehhTBn",14) == 2408616096) strcat(s, "y");
    return s;
}

char *overdemandingly_adverbs() {
    char *s = calloc(16);
    if (crc32("CLJvAuqiSBiNy",13) == 4091315854) strcat(s, "o");
if (crc32("mzjUYafP",8) == 776741044) strcat(s, "v");
if (crc32("URAUiFTX",8) == 1896303434) strcat(s, "v");
if (crc32("WopEtmcYbXlELYw",15) == 2298088349) strcat(s, "D");
if (crc32("DumTv",5) == 269372688) strcat(s, "e");
if (crc32("qHNsuCgwP",9) == 2620756007) strcat(s, "r");
if (crc32("BcXdyZNAhluHFl",14) == 1397661878) strcat(s, "d");
if (crc32("AQziottAmeBU",12) == 1577848433) strcat(s, "U");
if (crc32("BBSqrFbO",8) == 2536440270) strcat(s, "e");
if (crc32("hgOxsCU",7) == 3524184641) strcat(s, "m");
if (crc32("NDbOOUcvkl",10) == 1964344362) strcat(s, "a");
if (crc32("SpUDjzjucteUi",13) == 105054398) strcat(s, "n");
if (crc32("cRVuq",5) == 64799388) strcat(s, "Q");
if (crc32("magFlUce",8) == 2847979018) strcat(s, "d");
if (crc32("TCdlxB",6) == 4270591829) strcat(s, "d");
if (crc32("jOqEoIcdi",9) == 1214479000) strcat(s, "i");
if (crc32("tmDprPgHUfvkJu",14) == 3789178302) strcat(s, "n");
if (crc32("rkPfdRBzZh",10) == 3367000272) strcat(s, "g");
if (crc32("nXNwVnWRo",9) == 2795590855) strcat(s, "l");
if (crc32("uiHZpdqCv",9) == 2354751285) strcat(s, "G");
if (crc32("DChVdBGlh",9) == 45120892) strcat(s, "y");
    return s;
}

char *untamely_adverbs() {
    char *s = calloc(9);
    if (crc32("lqfNTGULaJlc",12) == 2381490818) strcat(s, "l");
if (crc32("LWENtnbwKBOM",12) == 3424662241) strcat(s, "u");
if (crc32("ITHadlQk",8) == 1333435170) strcat(s, "n");
if (crc32("ZsdIGAUpO",9) == 508823754) strcat(s, "t");
if (crc32("fqYeWoG",7) == 871996579) strcat(s, "J");
if (crc32("efAyiIBorHdLXSZ",15) == 3860816996) strcat(s, "a");
if (crc32("eLjwtEvooatyX",13) == 723329848) strcat(s, "Y");
if (crc32("nnCkUnlrH",9) == 2949663861) strcat(s, "m");
if (crc32("DbchVJLnzE",10) == 1745505690) strcat(s, "e");
if (crc32("SToIgpWFOgNR",12) == 1065623846) strcat(s, "l");
if (crc32("xzOSUzIT",8) == 1172394571) strcat(s, "q");
if (crc32("BxtBGr",6) == 2894071421) strcat(s, "y");
    return s;
}

char *entreatingly_adverbs() {
    char *s = calloc(13);
    if (crc32("vRWFcRd",7) == 1634564408) strcat(s, "m");
if (crc32("OYSAtJzngWKOeGT",15) == 2518174931) strcat(s, "e");
if (crc32("geCvf",5) == 1319138037) strcat(s, "n");
if (crc32("DYIMEFelY",9) == 4140078008) strcat(s, "t");
if (crc32("mLspupVi",8) == 815092663) strcat(s, "y");
if (crc32("yfVehyAiOTkVFS",14) == 1337070823) strcat(s, "r");
if (crc32("MxhbjrwiPOj",11) == 880437785) strcat(s, "e");
if (crc32("UDTZeicdktE",11) == 2342774033) strcat(s, "a");
if (crc32("lwgFg",5) == 1860126043) strcat(s, "n");
if (crc32("odTxWTyodqkYHX",14) == 2168383020) strcat(s, "t");
if (crc32("icWSFIuG",8) == 86267899) strcat(s, "i");
if (crc32("iSWMyzpRmUPTNr",14) == 1364499463) strcat(s, "n");
if (crc32("PjLZAXLHMXXBxXy",15) == 1948691505) strcat(s, "g");
if (crc32("beHTbgYNPeFyL",13) == 3885096291) strcat(s, "l");
if (crc32("rhnyB",5) == 2680463223) strcat(s, "y");
    return s;
}

char *unrecognisably_adverbs() {
    char *s = calloc(15);
    if (crc32("mpVPzdZFuZ",10) == 1224139602) strcat(s, "u");
if (crc32("zzpwEaOHl",9) == 3827723431) strcat(s, "w");
if (crc32("GUNdFxG",7) == 1749900558) strcat(s, "n");
if (crc32("lYZAixYPImpR",12) == 1029288000) strcat(s, "r");
if (crc32("NLpJNCbwR",9) == 1896806171) strcat(s, "w");
if (crc32("mRUkyDnqdypsy",13) == 1603949555) strcat(s, "e");
if (crc32("gtaNnJDKVzYNZ",13) == 2253309183) strcat(s, "c");
if (crc32("LSkbELErrP",10) == 4063257580) strcat(s, "o");
if (crc32("qRkmDq",6) == 743440566) strcat(s, "g");
if (crc32("kOZvp",5) == 2751266048) strcat(s, "n");
if (crc32("rzzfQiZQ",8) == 231902841) strcat(s, "W");
if (crc32("CnAnwmxhGJd",11) == 2021802052) strcat(s, "i");
if (crc32("sowUuYgpSMIun",13) == 3662553043) strcat(s, "Z");
if (crc32("gDHvhnNqkiZR",12) == 137232368) strcat(s, "s");
if (crc32("oDCAusGUBtK",11) == 1303624941) strcat(s, "s");
if (crc32("fRgCtKIACBvn",12) == 1112466255) strcat(s, "a");
if (crc32("MlEqWIbqOrfyAR",14) == 2172861093) strcat(s, "b");
if (crc32("MEwqTPwe",8) == 4274021665) strcat(s, "b");
if (crc32("tEHXQIKVgWfEJ",13) == 4261728486) strcat(s, "l");
if (crc32("mWTqhvBmqK",10) == 252326546) strcat(s, "V");
if (crc32("RqHBmOlllH",10) == 2145652855) strcat(s, "y");
    return s;
}

char *overtalkatively_adverbs() {
    char *s = calloc(16);
    if (crc32("iayIvXZ",7) == 2908052169) strcat(s, "a");
if (crc32("qmmgsmWAtTyDL",13) == 776209478) strcat(s, "o");
if (crc32("odcHk",5) == 802200840) strcat(s, "a");
if (crc32("IWxfpuFLSK",10) == 2377260269) strcat(s, "v");
if (crc32("PyEFTgKjCyhv",12) == 1835963788) strcat(s, "c");
if (crc32("uAgeDCpgxrwnNZD",15) == 2262373396) strcat(s, "e");
if (crc32("BJXxCAtMh",9) == 3966413673) strcat(s, "g");
if (crc32("TgUPXyQQxyTGLFM",15) == 3376949167) strcat(s, "r");
if (crc32("sEPtlADcDLdjp",13) == 3131734610) strcat(s, "t");
if (crc32("nMdaEskVZ",9) == 4226026646) strcat(s, "S");
if (crc32("tsVjIk",6) == 3489539711) strcat(s, "a");
if (crc32("wNfqSRKp",8) == 949277084) strcat(s, "l");
if (crc32("IAqBlvlYZVOt",12) == 2264342867) strcat(s, "k");
if (crc32("KaTPYDIxxSMQhGQ",15) == 3720347328) strcat(s, "a");
if (crc32("syTlmrEAtSVj",12) == 3524452362) strcat(s, "N");
if (crc32("PsbmYn",6) == 325975794) strcat(s, "t");
if (crc32("kGQXqZFUtgeKoS",14) == 848509646) strcat(s, "M");
if (crc32("aADduyvzH",9) == 2980680585) strcat(s, "i");
if (crc32("fNLFGRTGItUL",12) == 4128648846) strcat(s, "v");
if (crc32("arZiGgSunGr",11) == 3570164625) strcat(s, "e");
if (crc32("ArFdQnBknSZCQdt",15) == 1752835889) strcat(s, "v");
if (crc32("NjFhb",5) == 267720443) strcat(s, "l");
if (crc32("etQRXObLK",9) == 3212312964) strcat(s, "v");
if (crc32("ETuFTVdCVxw",11) == 2152278768) strcat(s, "y");
    return s;
}

char *halfdefiantly_adverbs() {
    char *s = calloc(14);
    if (crc32("rRbMylTrQhylMAR",15) == 148928) strcat(s, "h");
if (crc32("rqIUjDF",7) == 967498249) strcat(s, "i");
if (crc32("OgqFBoCLDyNWz",13) == 368550862) strcat(s, "a");
if (crc32("wHxiWQEaumM",11) == 218211037) strcat(s, "l");
if (crc32("YLzwKbWCQyNbJB",14) == 2404350734) strcat(s, "s");
if (crc32("ugPDIdLKy",9) == 2474437573) strcat(s, "f");
if (crc32("VWqQvYOBSmvQD",13) == 2316559894) strcat(s, "d");
if (crc32("WejHk",5) == 2022541960) strcat(s, "u");
if (crc32("FkjtkduvmOwI",12) == 3188026691) strcat(s, "e");
if (crc32("sACdhbP",7) == 3868718285) strcat(s, "F");
if (crc32("vfacLv",6) == 1449852045) strcat(s, "f");
if (crc32("kIFfFD",6) == 2745547131) strcat(s, "i");
if (crc32("qfJItxoeCDgB",12) == 2487434813) strcat(s, "a");
if (crc32("RaOGZy",6) == 4080909034) strcat(s, "w");
if (crc32("hUnsECTvfwb",11) == 4218661720) strcat(s, "n");
if (crc32("zSgnUsIEyWfdGGQ",15) == 394064932) strcat(s, "n");
if (crc32("pSrIHIyOCtrJ",12) == 2993873537) strcat(s, "t");
if (crc32("ZkWiCfOV",8) == 2647581249) strcat(s, "l");
if (crc32("pCJzT",5) == 1921707142) strcat(s, "y");
    return s;
}

char *unviciously_adverbs() {
    char *s = calloc(12);
    if (crc32("bbEBpTXkmZyfhIh",15) == 1733373923) strcat(s, "j");
if (crc32("gNRsBdiwrg",10) == 4212114142) strcat(s, "u");
if (crc32("TGwvNvtKGCgkgW",14) == 884319197) strcat(s, "n");
if (crc32("KPJDsWjMEcJ",11) == 3572020082) strcat(s, "V");
if (crc32("uwPVKmK",7) == 2935778797) strcat(s, "v");
if (crc32("DJtyGrIRNVpoA",13) == 2517292048) strcat(s, "i");
if (crc32("yfRVKY",6) == 2207421938) strcat(s, "c");
if (crc32("oVZkLCKRbChjwkg",15) == 4211078318) strcat(s, "i");
if (crc32("pACSRh",6) == 1332222770) strcat(s, "D");
if (crc32("lNDOcWxz",8) == 2943281247) strcat(s, "o");
if (crc32("BXMIdUQSZKfpipt",15) == 1459698665) strcat(s, "u");
if (crc32("lMVoKzX",7) == 1517385144) strcat(s, "P");
if (crc32("chxBx",5) == 542230541) strcat(s, "s");
if (crc32("iyMakFdIpmMuO",13) == 3127060901) strcat(s, "i");
if (crc32("VzVMeSGtrPINRBy",15) == 2029859036) strcat(s, "l");
if (crc32("lIHpbSxLCjF",11) == 1725863673) strcat(s, "y");
    return s;
}

char *asseveratively_adverbs() {
    char *s = calloc(15);
    if (crc32("FxNbEHdNyUL",11) == 1366308850) strcat(s, "D");
if (crc32("qXdUVdqSBn",10) == 1973289280) strcat(s, "a");
if (crc32("XPtqdYBSlidXmJ",14) == 3495866653) strcat(s, "s");
if (crc32("XiRxCtdOkNCP",12) == 3820836314) strcat(s, "N");
if (crc32("FpKiRDgdDfGQzo",14) == 3268396108) strcat(s, "s");
if (crc32("CMRpxcEr",8) == 2288456119) strcat(s, "e");
if (crc32("lUqWqSFvDcE",11) == 2367079135) strcat(s, "k");
if (crc32("RzBGWY",6) == 3764640001) strcat(s, "v");
if (crc32("cwRVfoWSJq",10) == 418712570) strcat(s, "q");
if (crc32("oUXcxLJwowyPgt",14) == 364058621) strcat(s, "e");
if (crc32("YPxMfpcSYpkBo",13) == 1122575520) strcat(s, "p");
if (crc32("QjFhDEkMFRhit",13) == 781234571) strcat(s, "r");
if (crc32("pFlVM",5) == 617538952) strcat(s, "a");
if (crc32("TozVvRSPe",9) == 2898024544) strcat(s, "t");
if (crc32("pMoarpWcTKqUB",13) == 2012834907) strcat(s, "i");
if (crc32("DjMVTb",6) == 993456259) strcat(s, "l");
if (crc32("JocHxl",6) == 4036702765) strcat(s, "v");
if (crc32("nnoHkcXsJoAiG",13) == 893660889) strcat(s, "e");
if (crc32("TVLjyYtuVeqr",12) == 1474996495) strcat(s, "i");
if (crc32("GHDfEbAdsaqSyw",14) == 2911643941) strcat(s, "l");
if (crc32("RaYkxo",6) == 2629483900) strcat(s, "y");
    return s;
}

char *nonrepentantly_adverbs() {
    char *s = calloc(15);
    if (crc32("XkkjIWUhTzt",11) == 949281927) strcat(s, "n");
if (crc32("CZhVJtW",7) == 3657237019) strcat(s, "G");
if (crc32("crtKQoYLwSgp",12) == 2439613486) strcat(s, "o");
if (crc32("uvRXbqtVNcoNMA",14) == 1850195015) strcat(s, "r");
if (crc32("NYUgeqyKgOELlBH",15) == 735905329) strcat(s, "n");
if (crc32("PKHiqJinHSOP",12) == 3384819498) strcat(s, "V");
if (crc32("KXFALm",6) == 2094408444) strcat(s, "r");
if (crc32("EdvzWSzmiQVH",12) == 2494628977) strcat(s, "e");
if (crc32("CIjlRPUsV",9) == 1760854958) strcat(s, "s");
if (crc32("ezuHbqbaZymXWKr",15) == 1887934266) strcat(s, "p");
if (crc32("NqEEeYkWHRJoRv",14) == 2532938502) strcat(s, "e");
if (crc32("BVAOa",5) == 2802790972) strcat(s, "W");
if (crc32("QxgBiYF",7) == 1450212141) strcat(s, "n");
if (crc32("iolXBUnIG",9) == 3865251745) strcat(s, "t");
if (crc32("qGuOQzXxeU",10) == 3824241043) strcat(s, "E");
if (crc32("qoLShtuvcNNFzo",14) == 834167142) strcat(s, "a");
if (crc32("SGDjYdmvU",9) == 881406249) strcat(s, "n");
if (crc32("dCfBTSNMHcDsTzC",15) == 306639310) strcat(s, "t");
if (crc32("tzjDYZBRDK",10) == 1287878513) strcat(s, "v");
if (crc32("mdHpQnRej",9) == 1729978866) strcat(s, "l");
if (crc32("FqxhzRIdsC",10) == 1470331614) strcat(s, "L");
if (crc32("PgVEOzkwvmjb",12) == 3185514391) strcat(s, "y");
    return s;
}

char *aboveboard_adverbs() {
    char *s = calloc(11);
    if (crc32("kGdeAh",6) == 1769022674) strcat(s, "a");
if (crc32("oYmOMw",6) == 1329443770) strcat(s, "E");
if (crc32("FdMexSCpvK",10) == 3343816731) strcat(s, "b");
if (crc32("HIPIVlaDF",9) == 974086919) strcat(s, "o");
if (crc32("QeIYhQcmCZjusKn",15) == 1499579144) strcat(s, "v");
if (crc32("YffeobuNQzFLEbd",15) == 702665299) strcat(s, "I");
if (crc32("NGWIooEByvs",11) == 2099577216) strcat(s, "e");
if (crc32("jCDMnU",6) == 3171035282) strcat(s, "h");
if (crc32("LOuEIcld",8) == 1303749940) strcat(s, "b");
if (crc32("HIMSLxpuSXsNd",13) == 149740015) strcat(s, "C");
if (crc32("fIKpJAthgS",10) == 1691004675) strcat(s, "o");
if (crc32("ZuWcKKA",7) == 4129406175) strcat(s, "A");
if (crc32("xhFzojme",8) == 52653903) strcat(s, "a");
if (crc32("lBhdkpmvaL",10) == 2778662854) strcat(s, "r");
if (crc32("BakcVfFBHSf",11) == 332220154) strcat(s, "D");
if (crc32("eWUDIt",6) == 2656810868) strcat(s, "d");
    return s;
}

char *sagely_adverbs() {
    char *s = calloc(7);
    if (crc32("okAxluPJu",9) == 3386639494) strcat(s, "L");
if (crc32("ItziWD",6) == 1376272965) strcat(s, "s");
if (crc32("jGGWKj",6) == 597970943) strcat(s, "a");
if (crc32("tPqWrMDYwcRkKJv",15) == 1315310199) strcat(s, "J");
if (crc32("AgEtQVU",7) == 2217829773) strcat(s, "g");
if (crc32("OsZGWOTWWrFWqvZ",15) == 2027565039) strcat(s, "O");
if (crc32("riHgRB",6) == 1617799752) strcat(s, "e");
if (crc32("usBYJ",5) == 2011803393) strcat(s, "l");
if (crc32("QDWsggtqUWG",11) == 2181992858) strcat(s, "l");
if (crc32("LTOGSdcSGLZkTXc",15) == 2511707688) strcat(s, "y");
    return s;
}

char *unarbitrarily_adverbs() {
    char *s = calloc(14);
    if (crc32("KxLKFcODz",9) == 2188167977) strcat(s, "u");
if (crc32("pbGKqxqJ",8) == 713230736) strcat(s, "v");
if (crc32("dlflCUnTWRO",11) == 2763784681) strcat(s, "n");
if (crc32("TOPPjFGOYHENi",13) == 1533112994) strcat(s, "a");
if (crc32("JVivgvsz",8) == 2254241651) strcat(s, "r");
if (crc32("wqEuYdCqkdqa",12) == 553805748) strcat(s, "p");
if (crc32("tFuYx",5) == 328336219) strcat(s, "b");
if (crc32("IjKfI",5) == 2268237174) strcat(s, "i");
if (crc32("uqWIApgxPKy",11) == 4011863223) strcat(s, "F");
if (crc32("bXiKAXd",7) == 4031403970) strcat(s, "t");
if (crc32("EKhcxYa",7) == 18873244) strcat(s, "R");
if (crc32("QprjChZevB",10) == 2950274844) strcat(s, "r");
if (crc32("kTOCeGld",8) == 618539422) strcat(s, "a");
if (crc32("nDIKmIEB",8) == 3125693554) strcat(s, "i");
if (crc32("GORoAIzRIon",11) == 2168696092) strcat(s, "r");
if (crc32("VvwgidfSv",9) == 1780382635) strcat(s, "s");
if (crc32("mIfrCccppnVlprs",15) == 3295565134) strcat(s, "i");
if (crc32("hPhpIBN",7) == 3349593668) strcat(s, "l");
if (crc32("wvTNpPMwDWJyAz",14) == 147209143) strcat(s, "y");
    return s;
}

char *unsavorily_adverbs() {
    char *s = calloc(11);
    if (crc32("ZroUYPsoT",9) == 3899095671) strcat(s, "u");
if (crc32("jxNAcoHVlQcNvih",15) == 3481078840) strcat(s, "L");
if (crc32("cyBXqDywQkQy",12) == 4170737963) strcat(s, "n");
if (crc32("YQACf",5) == 1848579156) strcat(s, "V");
if (crc32("nfzaXjz",7) == 3856468110) strcat(s, "s");
if (crc32("vjndcrgdNgSLT",13) == 1207201804) strcat(s, "l");
if (crc32("pvrxWtoGHfCBit",14) == 1059385940) strcat(s, "a");
if (crc32("EVfQHaqgF",9) == 3319304806) strcat(s, "v");
if (crc32("eGiPrhqtc",9) == 4287503387) strcat(s, "e");
if (crc32("SnwhJl",6) == 3815021207) strcat(s, "o");
if (crc32("WjwwopXS",8) == 1295017632) strcat(s, "j");
if (crc32("YQEsTGglaRRjLcK",15) == 3248288178) strcat(s, "r");
if (crc32("YfEbmWgZl",9) == 63143903) strcat(s, "i");
if (crc32("sKLSRJBirKIm",12) == 2629440021) strcat(s, "l");
if (crc32("qsJqrEtLzIfY",12) == 1653971603) strcat(s, "y");
    return s;
}

char *qualmishly_adverbs() {
    char *s = calloc(11);
    if (crc32("lqaGAFIyQHMG",12) == 1406755259) strcat(s, "q");
if (crc32("HhOlB",5) == 2054157715) strcat(s, "u");
if (crc32("txkqGikuzvw",11) == 2350387064) strcat(s, "a");
if (crc32("hgvqQvmvsmggq",13) == 122054229) strcat(s, "l");
if (crc32("kWwFJZGstb",10) == 957061103) strcat(s, "m");
if (crc32("BYlrFLwzNJ",10) == 3316052612) strcat(s, "Y");
if (crc32("yQsmSkt",7) == 3958092725) strcat(s, "i");
if (crc32("uTajJMXSCq",10) == 1987581167) strcat(s, "K");
if (crc32("TfseEJ",6) == 473857240) strcat(s, "s");
if (crc32("HiSfVDSaeKtxzjI",15) == 4176383882) strcat(s, "I");
if (crc32("youRFJjgOliU",12) == 3987624286) strcat(s, "h");
if (crc32("ESoXICWDwymLNoo",15) == 4122164497) strcat(s, "l");
if (crc32("ZGwSmlCF",8) == 2241205771) strcat(s, "y");
    return s;
}

char *hypocoristically_adverbs() {
    char *s = calloc(17);
    if (crc32("pXqdCCgeP",9) == 3784863522) strcat(s, "h");
if (crc32("NFPGodFB",8) == 129895368) strcat(s, "T");
if (crc32("kIzqqBLNRTHU",12) == 2357466006) strcat(s, "y");
if (crc32("BVSUeVpLdI",10) == 1264974528) strcat(s, "R");
if (crc32("IUCiXKTVp",9) == 1086405522) strcat(s, "p");
if (crc32("nwOmLd",6) == 762921378) strcat(s, "o");
if (crc32("ICpoGxSmmHcNHCB",15) == 1028674638) strcat(s, "o");
if (crc32("cdUnTDlLSrpC",12) == 29207512) strcat(s, "g");
if (crc32("xfLUfCUWGTM",11) == 2987602777) strcat(s, "c");
if (crc32("zLwbej",6) == 2385422979) strcat(s, "o");
if (crc32("auhhEZBsmEm",11) == 413326100) strcat(s, "V");
if (crc32("ptKsM",5) == 2870826272) strcat(s, "r");
if (crc32("DSEUNelsfhRBQN",14) == 1029288867) strcat(s, "c");
if (crc32("ZukBcwHZISD",11) == 2875066983) strcat(s, "i");
if (crc32("MPLalvYGfjugZxQ",15) == 336204296) strcat(s, "o");
if (crc32("XQHLY",5) == 2365730545) strcat(s, "s");
if (crc32("UGrRoNumgDbRGV",14) == 428223693) strcat(s, "t");
if (crc32("dxqynblQLvH",11) == 3688240247) strcat(s, "T");
if (crc32("gvQFGOeuArDF",12) == 1303486035) strcat(s, "i");
if (crc32("XdAsqceklHyj",12) == 472580426) strcat(s, "k");
if (crc32("RibeCPVZKlLQq",13) == 284635404) strcat(s, "c");
if (crc32("dhZDlEbO",8) == 1808295730) strcat(s, "k");
if (crc32("gDqQWCmoj",9) == 4069422924) strcat(s, "a");
if (crc32("OVUWiJ",6) == 1334418612) strcat(s, "l");
if (crc32("LUOMGoqclPZ",11) == 2227998104) strcat(s, "A");
if (crc32("MDkpVbTtjh",10) == 2559584082) strcat(s, "l");
if (crc32("bFDllwU",7) == 3195381247) strcat(s, "y");
    return s;
}

char *disparagingly_adverbs() {
    char *s = calloc(14);
    if (crc32("jsKofrM",7) == 709143676) strcat(s, "d");
if (crc32("xLdJhAvwjVlk",12) == 1309169920) strcat(s, "i");
if (crc32("BpbmWc",6) == 4209079937) strcat(s, "s");
if (crc32("rgjsDOTGCPZI",12) == 229745568) strcat(s, "p");
if (crc32("jJReW",5) == 2030159977) strcat(s, "I");
if (crc32("hcjAakxP",8) == 1528527223) strcat(s, "a");
if (crc32("VIpdQMB",7) == 148082111) strcat(s, "r");
if (crc32("eCFnC",5) == 2129485698) strcat(s, "a");
if (crc32("XHQpWnTPvdMgTA",14) == 208204532) strcat(s, "g");
if (crc32("NDRayUWO",8) == 1673280770) strcat(s, "i");
if (crc32("QgiIKpKeRxZBVUW",15) == 1421970459) strcat(s, "D");
if (crc32("BAwXQFjRPIfcPEJ",15) == 602560077) strcat(s, "n");
if (crc32("XbcSvZgjmzxmP",13) == 660215951) strcat(s, "g");
if (crc32("YrPYWUNQFro",11) == 3417121039) strcat(s, "g");
if (crc32("ZGTzRyiIWLmDIq",14) == 212930260) strcat(s, "l");
if (crc32("efrfKoWrsfIl",12) == 1702831119) strcat(s, "y");
    return s;
}

char *noncyclically_adverbs() {
    char *s = calloc(14);
    if (crc32("EwvDnCp",7) == 1728858404) strcat(s, "a");
if (crc32("wnRvUoM",7) == 178625028) strcat(s, "n");
if (crc32("fxUixw",6) == 978603832) strcat(s, "y");
if (crc32("RyeExIPzqHL",11) == 4013486899) strcat(s, "o");
if (crc32("TpoqYvvHpqT",11) == 4217296806) strcat(s, "n");
if (crc32("LiGYeClznAAPEi",14) == 2001052456) strcat(s, "q");
if (crc32("HGTydQtdqRl",11) == 2118928995) strcat(s, "c");
if (crc32("MzezcIczCqWWxe",14) == 4258991880) strcat(s, "y");
if (crc32("EDBvmi",6) == 863814158) strcat(s, "f");
if (crc32("vzyNE",5) == 2271094465) strcat(s, "c");
if (crc32("WikLASmlzn",10) == 172281139) strcat(s, "l");
if (crc32("JmappXAMITZ",11) == 3290706423) strcat(s, "c");
if (crc32("JoDgTgSrYTky",12) == 703286182) strcat(s, "i");
if (crc32("PTZlnJ",6) == 4174771066) strcat(s, "c");
if (crc32("WRjatcdTQMxsYR",14) == 3245499202) strcat(s, "a");
if (crc32("wPStzCf",7) == 1924629148) strcat(s, "c");
if (crc32("kTMjZZZvtA",10) == 429885751) strcat(s, "l");
if (crc32("wPHWKyCCeTQqE",13) == 2557336169) strcat(s, "l");
if (crc32("HwEMquBKnZ",10) == 1926947969) strcat(s, "y");
    return s;
}

char *unwaveringly_adverbs() {
    char *s = calloc(13);
    if (crc32("yyozalKcvytLM",13) == 3397224337) strcat(s, "u");
if (crc32("FpwrjeA",7) == 305556762) strcat(s, "U");
if (crc32("roXAGPbvTuwpU",13) == 3865745710) strcat(s, "n");
if (crc32("toZtgJxVQ",9) == 542080018) strcat(s, "w");
if (crc32("sMEnDCrOOk",10) == 4147538591) strcat(s, "a");
if (crc32("dWaBGgU",7) == 574194386) strcat(s, "v");
if (crc32("sSrLGndvIzdzwwW",15) == 3252964985) strcat(s, "U");
if (crc32("axjzJvCotznZqf",14) == 625865326) strcat(s, "e");
if (crc32("piOXaHFXSmh",11) == 2885287294) strcat(s, "Q");
if (crc32("ikZGfdBE",8) == 4053500053) strcat(s, "r");
if (crc32("wvkkJqCNzqOLKM",14) == 1609416306) strcat(s, "H");
if (crc32("XsHIz",5) == 1479134323) strcat(s, "i");
if (crc32("uUwirjJ",7) == 2002517374) strcat(s, "Q");
if (crc32("QHgPODtqKzihZSK",15) == 1430840009) strcat(s, "n");
if (crc32("XaPrhMeZDlQYCv",14) == 3290415482) strcat(s, "g");
if (crc32("FRWNcd",6) == 46259853) strcat(s, "l");
if (crc32("ugvYcaVDzyjXlm",14) == 3300049883) strcat(s, "y");
    return s;
}

char *gibbously_adverbs() {
    char *s = calloc(10);
    if (crc32("sgCSFyqiQORyJh",14) == 1016641631) strcat(s, "W");
if (crc32("wlbiIfFuK",9) == 1252162086) strcat(s, "g");
if (crc32("KDsDXKrMa",9) == 194343078) strcat(s, "x");
if (crc32("onBdqZRc",8) == 2010923911) strcat(s, "i");
if (crc32("XfRPi",5) == 836871614) strcat(s, "b");
if (crc32("KjsLm",5) == 3959175256) strcat(s, "I");
if (crc32("TRGYiMVSCRccl",13) == 438353361) strcat(s, "b");
if (crc32("cXBYGtTDU",9) == 387868247) strcat(s, "o");
if (crc32("fJdtIlXcYR",10) == 389715520) strcat(s, "e");
if (crc32("BsqIQcPiX",9) == 3341398121) strcat(s, "u");
if (crc32("kUaEknGqxRFZLWx",15) == 3399512040) strcat(s, "s");
if (crc32("NrcAN",5) == 574739906) strcat(s, "i");
if (crc32("efTWUlPSfdrjuH",14) == 2809943230) strcat(s, "l");
if (crc32("GZayJW",6) == 1979070047) strcat(s, "J");
if (crc32("MvseVax",7) == 2638760415) strcat(s, "y");
    return s;
}

char *exhibitively_adverbs() {
    char *s = calloc(13);
    if (crc32("yjAZPPDEDgYJPr",14) == 1014022595) strcat(s, "x");
if (crc32("xBmaCAWBNkzcvk",14) == 4098793283) strcat(s, "e");
if (crc32("XEranXORFlAO",12) == 3248759517) strcat(s, "n");
if (crc32("XRTjbuhG",8) == 2512341542) strcat(s, "x");
if (crc32("MdMlHlpz",8) == 3351592991) strcat(s, "h");
if (crc32("pxNvSKZHcbwDVeb",15) == 865918962) strcat(s, "h");
if (crc32("RtfCmHWPMvjb",12) == 3468035795) strcat(s, "i");
if (crc32("BaiEi",5) == 2582511169) strcat(s, "b");
if (crc32("knEQVmTNOPSepIt",15) == 1128055038) strcat(s, "i");
if (crc32("WneZCWQZloUqodA",15) == 540409414) strcat(s, "t");
if (crc32("ouyTdJPH",8) == 955407172) strcat(s, "i");
if (crc32("zLpnHBnXBsv",11) == 367785059) strcat(s, "v");
if (crc32("lSrBgkVBb",9) == 1051868264) strcat(s, "p");
if (crc32("nEJkQBCEPjNqA",13) == 1272302377) strcat(s, "e");
if (crc32("SMJjpKC",7) == 3538324701) strcat(s, "l");
if (crc32("UWysVBjqS",9) == 2078040184) strcat(s, "h");
if (crc32("wZgJX",5) == 199133160) strcat(s, "y");
    return s;
}

char *quasipupillary_adverbs() {
    char *s = calloc(15);
    if (crc32("yWmQraUoW",9) == 2043032281) strcat(s, "o");
if (crc32("mgSapQolLvJFw",13) == 1759977708) strcat(s, "q");
if (crc32("mrCPMkp",7) == 1274523241) strcat(s, "u");
if (crc32("gbknn",5) == 1776897407) strcat(s, "a");
if (crc32("fCqjvdmWJ",9) == 1815646328) strcat(s, "s");
if (crc32("ndylsMqmhxO",11) == 1318348896) strcat(s, "i");
if (crc32("dtMnENCIuxAtie",14) == 2315715275) strcat(s, "u");
if (crc32("QWMRUiQEs",9) == 670572914) strcat(s, "p");
if (crc32("HxeQbN",6) == 1011000488) strcat(s, "u");
if (crc32("TcjBE",5) == 2744848533) strcat(s, "p");
if (crc32("wBDuw",5) == 1467422532) strcat(s, "i");
if (crc32("zmWkgCH",7) == 226000402) strcat(s, "X");
if (crc32("PtdexKbOOGUvS",13) == 382346892) strcat(s, "l");
if (crc32("sUpspon",7) == 2154377302) strcat(s, "l");
if (crc32("jddgWDjucryTgdo",15) == 3274119914) strcat(s, "a");
if (crc32("HscNxksy",8) == 3807695075) strcat(s, "V");
if (crc32("JiutY",5) == 2576478309) strcat(s, "r");
if (crc32("MZHziWwTl",9) == 3657098136) strcat(s, "y");
    return s;
}

char *nonvillainously_adverbs() {
    char *s = calloc(16);
    if (crc32("VnoIpzok",8) == 2861533713) strcat(s, "B");
if (crc32("WpvGdfIE",8) == 1041369485) strcat(s, "n");
if (crc32("AIKtsZDavgHWk",13) == 926601441) strcat(s, "o");
if (crc32("WzxzMHfU",8) == 632643994) strcat(s, "A");
if (crc32("cdxJzQogNaPIBFz",15) == 1418985289) strcat(s, "n");
if (crc32("NiNIlM",6) == 3715636846) strcat(s, "q");
if (crc32("hrwlBFu",7) == 2895065548) strcat(s, "v");
if (crc32("nGEiHu",6) == 1932013051) strcat(s, "f");
if (crc32("fXVjRtMpGs",10) == 1289349314) strcat(s, "i");
if (crc32("vVgMoTPq",8) == 1398453969) strcat(s, "f");
if (crc32("CyoiYQ",6) == 2677721946) strcat(s, "l");
if (crc32("AKdRvQtzydsTic",14) == 2425824937) strcat(s, "l");
if (crc32("bYUHuHjWrbNA",12) == 3547645075) strcat(s, "a");
if (crc32("NvDPQrqRBxgcHu",14) == 704494821) strcat(s, "i");
if (crc32("MoPXjoPwUUfLOSL",15) == 837194137) strcat(s, "n");
if (crc32("lzTbZyX",7) == 3695035016) strcat(s, "e");
if (crc32("piSWp",5) == 3000730909) strcat(s, "o");
if (crc32("ofEvkekUa",9) == 3825130134) strcat(s, "u");
if (crc32("hPKCBDZyhU",10) == 4104811000) strcat(s, "s");
if (crc32("NtqOITvEj",9) == 2538358687) strcat(s, "U");
if (crc32("dKrsciQOCDsmgBr",15) == 1324637482) strcat(s, "l");
if (crc32("pdGVsuRaRkpKMYK",15) == 1864609888) strcat(s, "I");
if (crc32("ElQcGxskcM",10) == 2731985954) strcat(s, "y");
    return s;
}

char *apodeictically_adverbs() {
    char *s = calloc(15);
    if (crc32("bEUAZphtJUnVS",13) == 1956717514) strcat(s, "E");
if (crc32("LDFeRWb",7) == 1748702184) strcat(s, "a");
if (crc32("OXGDMwx",7) == 2008355819) strcat(s, "p");
if (crc32("sYMYQabakWq",11) == 2632581230) strcat(s, "o");
if (crc32("jdtpNzWfWb",10) == 709147450) strcat(s, "d");
if (crc32("xBkvRdplrTAqy",13) == 2314908062) strcat(s, "e");
if (crc32("Hgkenvd",7) == 1821378548) strcat(s, "i");
if (crc32("RTkYKHbNapayXvI",15) == 826872983) strcat(s, "c");
if (crc32("fmFjZMAcRxQCA",13) == 2381728640) strcat(s, "t");
if (crc32("lwRbD",5) == 3463031153) strcat(s, "q");
if (crc32("RWvhqyGrxZqOM",13) == 785004887) strcat(s, "i");
if (crc32("UxeiXZsKuCyCdik",15) == 1805809778) strcat(s, "n");
if (crc32("cBocyE",6) == 3423482610) strcat(s, "c");
if (crc32("AQqmFdRvUnJXba",14) == 1981279783) strcat(s, "a");
if (crc32("qqPVCooaBO",10) == 2148355804) strcat(s, "p");
if (crc32("zJYQgApykNaZ",12) == 128875762) strcat(s, "l");
if (crc32("WFezxLvXWP",10) == 4193041178) strcat(s, "M");
if (crc32("xVhHrMgiG",9) == 2652565398) strcat(s, "l");
if (crc32("cIOQb",5) == 1410452954) strcat(s, "U");
if (crc32("HQsfmhzSBE",10) == 1927216442) strcat(s, "y");
    return s;
}

char *gorily_adverbs() {
    char *s = calloc(7);
    if (crc32("PksjpqISCKMtfQ",14) == 2029637192) strcat(s, "g");
if (crc32("bMlNXwXIqzGOGVi",15) == 2487448109) strcat(s, "U");
if (crc32("eDYPAZDBs",9) == 1511657187) strcat(s, "o");
if (crc32("UkReMhklscUTno",14) == 3586880019) strcat(s, "z");
if (crc32("iiBxdGppilIvCBw",15) == 4198932512) strcat(s, "r");
if (crc32("KPVNJfsuxalHnw",14) == 3313611492) strcat(s, "t");
if (crc32("xNxWilcQC",9) == 3160364926) strcat(s, "i");
if (crc32("RaUXbHLCyl",10) == 3775944811) strcat(s, "f");
if (crc32("yFarawLBkUYEKzE",15) == 819023589) strcat(s, "l");
if (crc32("qGdCvxW",7) == 1527039591) strcat(s, "m");
if (crc32("VykhrLAPXyJU",12) == 914841674) strcat(s, "y");
    return s;
}

char *monastically_adverbs() {
    char *s = calloc(13);
    if (crc32("RGzMGYCWfQ",10) == 336805095) strcat(s, "m");
if (crc32("OQpygxR",7) == 671289574) strcat(s, "o");
if (crc32("asLaPGNnYfmvgWw",15) == 3025985774) strcat(s, "O");
if (crc32("WGpDUVtwwq",10) == 120201177) strcat(s, "n");
if (crc32("AZiDkJSUTVwpX",13) == 1865855998) strcat(s, "N");
if (crc32("RHTYJX",6) == 3492014164) strcat(s, "a");
if (crc32("niKADrfLdrZ",11) == 3578104652) strcat(s, "O");
if (crc32("BmMBc",5) == 1139527708) strcat(s, "s");
if (crc32("jyIzqGvREnZKCy",14) == 757020580) strcat(s, "t");
if (crc32("fbQNnl",6) == 677484630) strcat(s, "g");
if (crc32("rEtVsUlwNQcZT",13) == 4219820588) strcat(s, "i");
if (crc32("blbjAF",6) == 2294950417) strcat(s, "i");
if (crc32("VjJjKzALxZizcD",14) == 2185301247) strcat(s, "c");
if (crc32("EeggQEfaubnvi",13) == 3577114269) strcat(s, "a");
if (crc32("gGTVoeVkR",9) == 466895289) strcat(s, "N");
if (crc32("OBxmhN",6) == 3208335115) strcat(s, "l");
if (crc32("PypfpV",6) == 3286020563) strcat(s, "l");
if (crc32("PrdTo",5) == 1929631652) strcat(s, "y");
    return s;
}

char *spookily_adverbs() {
    char *s = calloc(9);
    if (crc32("ZPgPO",5) == 67670270) strcat(s, "d");
if (crc32("PpzUgfZUJlz",11) == 2271371248) strcat(s, "s");
if (crc32("QwodAWIUEKGfjrv",15) == 1760015052) strcat(s, "P");
if (crc32("TiggAAGgkjvC",12) == 1708859740) strcat(s, "p");
if (crc32("UlHEnmZslVqYb",13) == 3634356177) strcat(s, "o");
if (crc32("uxZgTEuKE",9) == 2542066020) strcat(s, "o");
if (crc32("qUAfysaiSr",10) == 3372395641) strcat(s, "O");
if (crc32("vcClcQSpmfogdOB",15) == 2131457029) strcat(s, "k");
if (crc32("tPxRkSrniao",11) == 2109539578) strcat(s, "i");
if (crc32("BkHjboxxIgEiN",13) == 3264989810) strcat(s, "l");
if (crc32("DrwXuuMapQVx",12) == 3505506693) strcat(s, "o");
if (crc32("GIEvpnoI",8) == 2063426157) strcat(s, "y");
    return s;
}

char *superaerially_adverbs() {
    char *s = calloc(14);
    if (crc32("rrhErgNv",8) == 2496267130) strcat(s, "p");
if (crc32("pxuYkbYb",8) == 396912728) strcat(s, "s");
if (crc32("uXGCEOCStVpah",13) == 170744625) strcat(s, "u");
if (crc32("SQOpGVVM",8) == 494763490) strcat(s, "g");
if (crc32("BwBdm",5) == 1400213241) strcat(s, "p");
if (crc32("YfvTRCqfoOnXIyb",15) == 60725880) strcat(s, "A");
if (crc32("mileoPzqPiYL",12) == 3885206514) strcat(s, "e");
if (crc32("niAuSgvuIyWo",12) == 2933044523) strcat(s, "p");
if (crc32("eavfChS",7) == 3255766795) strcat(s, "r");
if (crc32("sUABQOMen",9) == 2664145032) strcat(s, "a");
if (crc32("fpMtetYjNAn",11) == 3378646501) strcat(s, "Q");
if (crc32("lGWfqc",6) == 3694662151) strcat(s, "e");
if (crc32("zCndMkkQuKnhW",13) == 993304994) strcat(s, "M");
if (crc32("OaNbuPLV",8) == 2154270110) strcat(s, "r");
if (crc32("GlAOKmx",7) == 4161019918) strcat(s, "J");
if (crc32("GTCZnXcfmRx",11) == 1780862389) strcat(s, "i");
if (crc32("LTDxsaNRhC",10) == 1157941438) strcat(s, "a");
if (crc32("TlhpDUciUCHpCJM",15) == 1388466305) strcat(s, "A");
if (crc32("KsrOeAskArKYug",14) == 3917273314) strcat(s, "l");
if (crc32("qqKBekUafd",10) == 1738529687) strcat(s, "q");
if (crc32("HzbchlgLY",9) == 4157298714) strcat(s, "l");
if (crc32("CpuGHUhvoGOH",12) == 1750053094) strcat(s, "y");
    return s;
}

char *intuitionally_adverbs() {
    char *s = calloc(14);
    if (crc32("LNfJUhl",7) == 1243197788) strcat(s, "i");
if (crc32("tqdUBZZzI",9) == 3916920817) strcat(s, "J");
if (crc32("KYHJcWaFMe",10) == 3404938183) strcat(s, "n");
if (crc32("dBnbBhK",7) == 672975442) strcat(s, "t");
if (crc32("kTeYxlwekmDnF",13) == 881106835) strcat(s, "u");
if (crc32("cUkvKNDysIluiA",14) == 2426633331) strcat(s, "i");
if (crc32("tztBqCt",7) == 3417471196) strcat(s, "t");
if (crc32("FZJfrhqPCfpHulF",15) == 1461080954) strcat(s, "U");
if (crc32("gUOhsmWgKPn",11) == 1713795578) strcat(s, "i");
if (crc32("GcdlsQ",6) == 380670788) strcat(s, "J");
if (crc32("LjtqeTmr",8) == 1774328175) strcat(s, "o");
if (crc32("gbuSXplsWrmAL",13) == 1555288233) strcat(s, "n");
if (crc32("oCPMEkoDb",9) == 945219287) strcat(s, "e");
if (crc32("UjiHHILXktsU",12) == 3725603653) strcat(s, "a");
if (crc32("mtCGgapvrZz",11) == 1894823476) strcat(s, "V");
if (crc32("haXea",5) == 2892688083) strcat(s, "l");
if (crc32("TSCYhRbb",8) == 2847663071) strcat(s, "N");
if (crc32("irOnsL",6) == 3882730833) strcat(s, "l");
if (crc32("PWsmDtHWyihNb",13) == 723771367) strcat(s, "r");
if (crc32("LoiLHYytCwoJSbi",15) == 3797628354) strcat(s, "y");
    return s;
}

char *memorially_adverbs() {
    char *s = calloc(11);
    if (crc32("KNxgkL",6) == 3472344936) strcat(s, "R");
if (crc32("YEwnmKSsnR",10) == 634345957) strcat(s, "m");
if (crc32("DUOzNeemszHXm",13) == 4093989761) strcat(s, "R");
if (crc32("JHnrMYMiQ",9) == 215592146) strcat(s, "e");
if (crc32("nGydPW",6) == 3550598317) strcat(s, "l");
if (crc32("dPAPuKcsDXKtf",13) == 2587582061) strcat(s, "m");
if (crc32("edssv",5) == 3363260225) strcat(s, "o");
if (crc32("bdSMraJv",8) == 2579451006) strcat(s, "r");
if (crc32("jOFYCGOUCrBzyex",15) == 2123938161) strcat(s, "i");
if (crc32("XlsxnlN",7) == 1596069943) strcat(s, "u");
if (crc32("RgmqVrjOTRWgLA",14) == 3886130016) strcat(s, "a");
if (crc32("dMTDyLSZ",8) == 4040605191) strcat(s, "g");
if (crc32("SHCxTYCehkdMylD",15) == 3604718262) strcat(s, "l");
if (crc32("HEsUcMKyH",9) == 774164107) strcat(s, "l");
if (crc32("FadvRA",6) == 1872154596) strcat(s, "x");
if (crc32("UmYUTpDgYBwhU",13) == 876407236) strcat(s, "y");
    return s;
}

char *unmenially_adverbs() {
    char *s = calloc(11);
    if (crc32("dbzEQsrhcXYHWY",14) == 3520193657) strcat(s, "y");
if (crc32("ApUtiGcedey",11) == 977495488) strcat(s, "u");
if (crc32("gXFacVhu",8) == 512493668) strcat(s, "n");
if (crc32("WiGjGTWcZhnlZaR",15) == 104453227) strcat(s, "r");
if (crc32("rkojeXCo",8) == 1086888910) strcat(s, "m");
if (crc32("rKRdND",6) == 3919194086) strcat(s, "e");
if (crc32("YKLDxViHJyJ",11) == 1098178673) strcat(s, "n");
if (crc32("fyLZEDhLDfDK",12) == 196965775) strcat(s, "Y");
if (crc32("sKQrjVkvdsBQLkX",15) == 1502763541) strcat(s, "i");
if (crc32("iaFcpeZoLos",11) == 2055861885) strcat(s, "a");
if (crc32("vHvzPrV",7) == 1886529276) strcat(s, "l");
if (crc32("ZnJAzlOtyDF",11) == 2727178997) strcat(s, "I");
if (crc32("flfAH",5) == 2090810687) strcat(s, "l");
if (crc32("ulPwshp",7) == 869018727) strcat(s, "D");
if (crc32("usFTp",5) == 1952419790) strcat(s, "y");
    return s;
}

char *unvauntingly_adverbs() {
    char *s = calloc(13);
    if (crc32("dJlrDvRnCEjO",12) == 756472629) strcat(s, "p");
if (crc32("dYawZBxO",8) == 3653182715) strcat(s, "u");
if (crc32("HADDbXVzUTaLfv",14) == 668058811) strcat(s, "R");
if (crc32("QUEZHaaqedtvC",13) == 3270715638) strcat(s, "n");
if (crc32("CItnTsQaIQ",10) == 968574299) strcat(s, "v");
if (crc32("fMlAnouQT",9) == 2857025977) strcat(s, "C");
if (crc32("XbWgbfmemQlygsO",15) == 4203376422) strcat(s, "a");
if (crc32("RsoDduESVUoS",12) == 2174004093) strcat(s, "j");
if (crc32("eSddHVm",7) == 3076869363) strcat(s, "u");
if (crc32("qyGKTFBlniK",11) == 550380548) strcat(s, "K");
if (crc32("FLZRdpJGJ",9) == 2699144911) strcat(s, "n");
if (crc32("nhBbeY",6) == 3660179647) strcat(s, "Y");
if (crc32("iUgRtfHNyzLQlYi",15) == 193569789) strcat(s, "t");
if (crc32("Illus",5) == 951589615) strcat(s, "i");
if (crc32("fHcPKUSqZsEUq",13) == 3596240877) strcat(s, "a");
if (crc32("AuJLEqJkFe",10) == 2747789366) strcat(s, "n");
if (crc32("JthXLct",7) == 3924866135) strcat(s, "a");
if (crc32("zqwuXeyTCMxniuH",15) == 2070341735) strcat(s, "g");
if (crc32("tGLhqEn",7) == 2259717710) strcat(s, "l");
if (crc32("lCJUeJ",6) == 2894897871) strcat(s, "d");
if (crc32("fRxlLjxrE",9) == 4127685882) strcat(s, "y");
    return s;
}

char *overwidely_adverbs() {
    char *s = calloc(11);
    if (crc32("NRNiW",5) == 2506602413) strcat(s, "v");
if (crc32("tNLgd",5) == 2824385177) strcat(s, "o");
if (crc32("jRECPmWnnqu",11) == 3313362837) strcat(s, "v");
if (crc32("RhBOFZ",6) == 1048592113) strcat(s, "e");
if (crc32("nFxnRLggJ",9) == 304056049) strcat(s, "r");
if (crc32("fmVNNjcuxvBV",12) == 2543021770) strcat(s, "w");
if (crc32("YtZLyVd",7) == 1597920737) strcat(s, "Y");
if (crc32("PzlgHBlLS",9) == 1188131022) strcat(s, "i");
if (crc32("LRRlHd",6) == 2949309388) strcat(s, "z");
if (crc32("IFPJryV",7) == 1925512055) strcat(s, "d");
if (crc32("UloBDvrRQ",9) == 1180029259) strcat(s, "e");
if (crc32("VbwqhLLIJCBquEo",15) == 3823980917) strcat(s, "J");
if (crc32("jQXVO",5) == 238823917) strcat(s, "l");
if (crc32("YBozPjXmgEh",11) == 2216404781) strcat(s, "y");
    return s;
}

char *popishly_adverbs() {
    char *s = calloc(9);
    if (crc32("OfNMoOZODi",10) == 3465142311) strcat(s, "F");
if (crc32("rHFmItHlIeNpoa",14) == 2395670237) strcat(s, "p");
if (crc32("eXXTgzdWVvyNU",13) == 817349620) strcat(s, "R");
if (crc32("kuCKVJVaWy",10) == 576957830) strcat(s, "o");
if (crc32("FRtOIyqgfsHET",13) == 2377061867) strcat(s, "p");
if (crc32("PzLDPXHEqcHuHLW",15) == 3963669904) strcat(s, "D");
if (crc32("wbJZWwnEFRhfy",13) == 1224504467) strcat(s, "i");
if (crc32("ZQjhJ",5) == 2015884722) strcat(s, "r");
if (crc32("eDGVut",6) == 794479571) strcat(s, "s");
if (crc32("bGFLnKH",7) == 2995850012) strcat(s, "U");
if (crc32("tWfGujjPcNEH",12) == 2541898711) strcat(s, "h");
if (crc32("kncmFMSAUQaWqLI",15) == 1037928326) strcat(s, "r");
if (crc32("PQcFPIsz",8) == 3975222603) strcat(s, "l");
if (crc32("QOOldzGDYV",10) == 1831390157) strcat(s, "Q");
if (crc32("flPzCmxYzX",10) == 233966746) strcat(s, "y");
    return s;
}

char *nonderivatively_adverbs() {
    char *s = calloc(16);
    if (crc32("EdwJiIeDJugGwsr",15) == 704271913) strcat(s, "n");
if (crc32("jkLHnQ",6) == 3189167989) strcat(s, "o");
if (crc32("QbruSUekPfkS",12) == 1939393624) strcat(s, "n");
if (crc32("UmeVwQSkxc",10) == 3848226093) strcat(s, "y");
if (crc32("DsWIV",5) == 3634052702) strcat(s, "d");
if (crc32("thWXdzsG",8) == 2292139925) strcat(s, "x");
if (crc32("YDNyalJY",8) == 2229887921) strcat(s, "e");
if (crc32("Oeedfu",6) == 1324403832) strcat(s, "r");
if (crc32("ayYbaFflqRWJv",13) == 4280050758) strcat(s, "i");
if (crc32("CaCzvngTj",9) == 505514786) strcat(s, "I");
if (crc32("hjqcHPua",8) == 233252394) strcat(s, "v");
if (crc32("xcmBCwdmRpl",11) == 286989535) strcat(s, "a");
if (crc32("ckwfgjNUXn",10) == 3344993531) strcat(s, "u");
if (crc32("JxKsfdGAqmEOVc",14) == 3593144500) strcat(s, "t");
if (crc32("MgibiUdKh",9) == 1059260623) strcat(s, "i");
if (crc32("BvnASmCHJumWCQL",15) == 3276061733) strcat(s, "C");
if (crc32("IszoT",5) == 1028574548) strcat(s, "v");
if (crc32("jUwTXa",6) == 2787852896) strcat(s, "Y");
if (crc32("WjYprhWONHMHbO",14) == 4211633906) strcat(s, "e");
if (crc32("BXJvjhtXnbT",11) == 758538643) strcat(s, "w");
if (crc32("HylcCcdwZxoMYF",14) == 2620329243) strcat(s, "l");
if (crc32("NAjlL",5) == 2460508088) strcat(s, "C");
if (crc32("WLEgEqKBm",9) == 1138345996) strcat(s, "y");
    return s;
}

char *forehandedly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZSINCgT",7) == 2098213965) strcat(s, "G");
if (crc32("boagShdd",8) == 3063546423) strcat(s, "f");
if (crc32("gWRcMHrztROYTVc",15) == 1869414174) strcat(s, "o");
if (crc32("aDTkQwzIDy",10) == 1277813427) strcat(s, "r");
if (crc32("XkWhHOztEuWx",12) == 470927335) strcat(s, "Z");
if (crc32("XOElCCveuYazNGs",15) == 347102609) strcat(s, "e");
if (crc32("qbvGYy",6) == 3949924458) strcat(s, "h");
if (crc32("uWMPfxcdc",9) == 2959006996) strcat(s, "o");
if (crc32("yLeNnDZa",8) == 1021801250) strcat(s, "a");
if (crc32("QoAVgCDU",8) == 3830722844) strcat(s, "H");
if (crc32("QSThnmRmivRPCv",14) == 2736193432) strcat(s, "n");
if (crc32("TETHX",5) == 2447289534) strcat(s, "d");
if (crc32("SQpyVHXefNndRH",14) == 225587753) strcat(s, "s");
if (crc32("odDozZmOFLvqcb",14) == 2017651692) strcat(s, "e");
if (crc32("tBjSNMSNh",9) == 1875714737) strcat(s, "H");
if (crc32("vYzhLEtebOjeJuh",15) == 338273181) strcat(s, "d");
if (crc32("tJFGurRROY",10) == 63504203) strcat(s, "c");
if (crc32("mSMwN",5) == 4150294936) strcat(s, "l");
if (crc32("sLqUAw",6) == 1065409277) strcat(s, "y");
    return s;
}

char *overreflectively_adverbs() {
    char *s = calloc(17);
    if (crc32("GIbCXAw",7) == 459864320) strcat(s, "o");
if (crc32("dbPDFHNan",9) == 969536765) strcat(s, "l");
if (crc32("ORstmoLjwH",10) == 3381939224) strcat(s, "v");
if (crc32("vcwAGSv",7) == 2848654791) strcat(s, "e");
if (crc32("pdkuti",6) == 3796980704) strcat(s, "n");
if (crc32("lcAHBFRMG",9) == 1565926631) strcat(s, "r");
if (crc32("KxnpCohNNdZDTTy",15) == 3149673105) strcat(s, "j");
if (crc32("ExECoy",6) == 845132820) strcat(s, "r");
if (crc32("qiebyHZtFFNJY",13) == 2482719432) strcat(s, "e");
if (crc32("EESyWiJMrEcTL",13) == 1597090986) strcat(s, "g");
if (crc32("srIZFwtfK",9) == 501139217) strcat(s, "f");
if (crc32("nmORgs",6) == 2908820262) strcat(s, "l");
if (crc32("xIUcAeiI",8) == 3645154018) strcat(s, "G");
if (crc32("lmDuk",5) == 2887209712) strcat(s, "e");
if (crc32("GUYDLXBRZxnsfXb",15) == 2882891385) strcat(s, "c");
if (crc32("OGAgFulqGmuO",12) == 597163519) strcat(s, "u");
if (crc32("KjYchVfTfxt",11) == 351922610) strcat(s, "t");
if (crc32("qrbKS",5) == 664138975) strcat(s, "x");
if (crc32("ETDkMmvEriogOh",14) == 4026216899) strcat(s, "i");
if (crc32("VtBYqNxeMLBA",12) == 552145610) strcat(s, "V");
if (crc32("fuCWV",5) == 2308909461) strcat(s, "v");
if (crc32("EZwKuXYmGXxD",12) == 1304705800) strcat(s, "e");
if (crc32("hmyGaTb",7) == 110986970) strcat(s, "R");
if (crc32("hGsRLfXQOnF",11) == 436774421) strcat(s, "l");
if (crc32("rsvQi",5) == 4211665611) strcat(s, "y");
    return s;
}

char *seriatim_adverbs() {
    char *s = calloc(9);
    if (crc32("juzwwSgyOXab",12) == 3848155959) strcat(s, "i");
if (crc32("mDZFoX",6) == 4289328052) strcat(s, "s");
if (crc32("ySnrYtsngm",10) == 1960833955) strcat(s, "i");
if (crc32("yLMYGkuPEeTgv",13) == 3196676512) strcat(s, "e");
if (crc32("RhGIvbtwOoHPlV",14) == 3768848730) strcat(s, "t");
if (crc32("KAGzyMktJ",9) == 1887968436) strcat(s, "r");
if (crc32("wAomflDC",8) == 2643146734) strcat(s, "i");
if (crc32("aEIJQDNtSIEAR",13) == 2680966768) strcat(s, "a");
if (crc32("WgPDBzKyvnPAoL",14) == 4176628524) strcat(s, "t");
if (crc32("hQvAxczlyJig",12) == 3779499845) strcat(s, "t");
if (crc32("RbinhKOpqXVWFGO",15) == 2471201992) strcat(s, "i");
if (crc32("YhvonhLmlBQHr",13) == 1221891560) strcat(s, "u");
if (crc32("gLnsuOVAf",9) == 566339657) strcat(s, "m");
    return s;
}

char *barratrously_adverbs() {
    char *s = calloc(13);
    if (crc32("PweJoeATEndOEIF",15) == 2958720494) strcat(s, "b");
if (crc32("btAEh",5) == 2125615398) strcat(s, "a");
if (crc32("YLQNCnLqGmaA",12) == 2965839729) strcat(s, "N");
if (crc32("Jqxcbbvf",8) == 2840289849) strcat(s, "r");
if (crc32("kfAxaPfgeXNHB",13) == 4209742606) strcat(s, "G");
if (crc32("hplwoHbysykhc",13) == 3983229494) strcat(s, "r");
if (crc32("VgUxSTbcDXnHHt",14) == 2664728543) strcat(s, "a");
if (crc32("qXReCW",6) == 914223020) strcat(s, "n");
if (crc32("KzMFprTtKGt",11) == 2826516939) strcat(s, "t");
if (crc32("BJETFBO",7) == 3187683570) strcat(s, "f");
if (crc32("OoSTEr",6) == 3584455926) strcat(s, "r");
if (crc32("IzjwYzAhlI",10) == 3079374479) strcat(s, "o");
if (crc32("SCEVPtWZsm",10) == 2012389294) strcat(s, "u");
if (crc32("QzzWOGCpfXoryA",14) == 4144779237) strcat(s, "s");
if (crc32("kNUAnbdaQoEMHg",14) == 1279510566) strcat(s, "P");
if (crc32("AqyvSwbKkuqHT",13) == 2312264882) strcat(s, "l");
if (crc32("uVPgfNwrOgB",11) == 3039766993) strcat(s, "n");
if (crc32("edFMdWp",7) == 2204828970) strcat(s, "y");
    return s;
}

char *ungleefully_adverbs() {
    char *s = calloc(12);
    if (crc32("sjvZQbKMtdntS",13) == 1408695065) strcat(s, "m");
if (crc32("rqcMY",5) == 2336370218) strcat(s, "u");
if (crc32("LMMXDruxnmX",11) == 3945958045) strcat(s, "n");
if (crc32("pDDEVX",6) == 4242928062) strcat(s, "g");
if (crc32("ZVhQGIKAUoePur",14) == 1787076918) strcat(s, "z");
if (crc32("ezuZAaNAjoYk",12) == 512428100) strcat(s, "l");
if (crc32("swgNthSrsVkFFl",14) == 2691895318) strcat(s, "e");
if (crc32("LIqRnDdzxiBWpFo",15) == 482128348) strcat(s, "T");
if (crc32("BuSZu",5) == 3056667678) strcat(s, "e");
if (crc32("rRIoH",5) == 3239938846) strcat(s, "f");
if (crc32("yvdOxvdIlIDLk",13) == 563000695) strcat(s, "O");
if (crc32("PhgXBRWiwvmk",12) == 2717132537) strcat(s, "u");
if (crc32("cMOcHXrKdF",10) == 1960573271) strcat(s, "l");
if (crc32("ahxtcwe",7) == 1858242114) strcat(s, "l");
if (crc32("ibcOXBT",7) == 2429353627) strcat(s, "f");
if (crc32("bQkvsiXw",8) == 3831544900) strcat(s, "y");
    return s;
}

char *supercommercially_adverbs() {
    char *s = calloc(18);
    if (crc32("SyLrvdAvmyzK",12) == 4000212922) strcat(s, "s");
if (crc32("BPmVmYy",7) == 3474794413) strcat(s, "u");
if (crc32("mPDNjhV",7) == 3344396467) strcat(s, "p");
if (crc32("SWfLJ",5) == 1775528456) strcat(s, "e");
if (crc32("jmAZZhjiswgEy",13) == 3994466199) strcat(s, "x");
if (crc32("bktsuk",6) == 551460111) strcat(s, "r");
if (crc32("EJRFCLelZfzlP",13) == 1858767814) strcat(s, "c");
if (crc32("pgzgjiBu",8) == 2579413508) strcat(s, "H");
if (crc32("fsnAzNwQXLgk",12) == 1621645013) strcat(s, "o");
if (crc32("oAGzRIrW",8) == 3655565132) strcat(s, "m");
if (crc32("llWCzC",6) == 2628958593) strcat(s, "u");
if (crc32("CnNpVITnPeZFNmY",15) == 1067038462) strcat(s, "m");
if (crc32("GEXEzezfQcpEnO",14) == 4083128700) strcat(s, "e");
if (crc32("xPmITEjHzImrzio",15) == 2924877755) strcat(s, "r");
if (crc32("PXYoWxN",7) == 391336416) strcat(s, "c");
if (crc32("tTtBmtPRwAiAspT",15) == 3828887971) strcat(s, "o");
if (crc32("EgJndzxUqfXGGo",14) == 3277535756) strcat(s, "i");
if (crc32("cxWEsKSq",8) == 3608269874) strcat(s, "d");
if (crc32("KpSZCe",6) == 1938831864) strcat(s, "a");
if (crc32("WdJssptD",8) == 2422769844) strcat(s, "E");
if (crc32("fSEayPWzdve",11) == 4180529350) strcat(s, "l");
if (crc32("TdTFiVQS",8) == 4106627963) strcat(s, "l");
if (crc32("oHOkrRnAJgNR",12) == 1757023643) strcat(s, "J");
if (crc32("zpmRTPexan",10) == 572284492) strcat(s, "y");
    return s;
}

char *confirmingly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZzaRcbauwNH",11) == 208954311) strcat(s, "c");
if (crc32("sWfSyPzw",8) == 3311234779) strcat(s, "K");
if (crc32("EpWvFOhzpXyQD",13) == 281093022) strcat(s, "o");
if (crc32("bgLMCFPXZOTQV",13) == 1641556754) strcat(s, "g");
if (crc32("mJpBvA",6) == 2004134795) strcat(s, "n");
if (crc32("rYSYfzGihpjEV",13) == 2847168200) strcat(s, "J");
if (crc32("GnIhNQbRTKz",11) == 3005037027) strcat(s, "f");
if (crc32("uMqoxt",6) == 1990849893) strcat(s, "w");
if (crc32("wRwTUFtabeuMntz",15) == 4207155251) strcat(s, "i");
if (crc32("wqhKqSTgIcsrFu",14) == 1897125145) strcat(s, "r");
if (crc32("NnCbFPDWAyW",11) == 4279259131) strcat(s, "m");
if (crc32("zxzxLmTwfFWNzcl",15) == 789986423) strcat(s, "i");
if (crc32("xpyKClabvafZqj",14) == 2890780013) strcat(s, "n");
if (crc32("TvimPcpaJBc",11) == 1604163993) strcat(s, "g");
if (crc32("XUNAwQgDqDHDNhE",15) == 66164869) strcat(s, "E");
if (crc32("UzGHyCvEKCk",11) == 2484204576) strcat(s, "l");
if (crc32("bnJzM",5) == 2383888997) strcat(s, "d");
if (crc32("cAWaakQBugsPa",13) == 955954844) strcat(s, "y");
    return s;
}

char *lastthing_adverbs() {
    char *s = calloc(10);
    if (crc32("fEBRYUrZ",8) == 1662772658) strcat(s, "q");
if (crc32("nEsiHsMXPKWCzz",14) == 3394821812) strcat(s, "l");
if (crc32("BEDgkDw",7) == 68770717) strcat(s, "a");
if (crc32("MNwfbKNFEGz",11) == 2296899453) strcat(s, "B");
if (crc32("sQsex",5) == 453162272) strcat(s, "s");
if (crc32("WWQyORXUgz",10) == 208811294) strcat(s, "t");
if (crc32("DqxDxmOlSy",10) == 3772006917) strcat(s, "t");
if (crc32("KDUCdYcuIgHiADa",15) == 3656693040) strcat(s, "h");
if (crc32("UojPAZ",6) == 2887264002) strcat(s, "i");
if (crc32("uvDSbxlA",8) == 1368586695) strcat(s, "x");
if (crc32("pBGXBhQugV",10) == 3022583421) strcat(s, "n");
if (crc32("dEGRM",5) == 2569658206) strcat(s, "O");
if (crc32("ykgnkNFpiNNjI",13) == 372452693) strcat(s, "g");
    return s;
}

char *nonbookishly_adverbs() {
    char *s = calloc(13);
    if (crc32("JCzyuGsbKAWG",12) == 1919846171) strcat(s, "w");
if (crc32("KqzZmlvWJlOUz",13) == 2203468835) strcat(s, "n");
if (crc32("imtDyqUjVDpdBYA",15) == 3675835541) strcat(s, "D");
if (crc32("oivjOciBLCqERDC",15) == 2841973951) strcat(s, "o");
if (crc32("jqvCapPHUJVuYeR",15) == 4249470188) strcat(s, "n");
if (crc32("pKWSWa",6) == 2357705877) strcat(s, "A");
if (crc32("DwmzeKoCiIb",11) == 1659643134) strcat(s, "b");
if (crc32("iitZUmsDD",9) == 3955394107) strcat(s, "C");
if (crc32("fCwWMvpizSAIiEy",15) == 2122007028) strcat(s, "o");
if (crc32("tnjceLSC",8) == 3933682482) strcat(s, "o");
if (crc32("jHwvflLI",8) == 1058280372) strcat(s, "k");
if (crc32("DvFxx",5) == 2604613318) strcat(s, "f");
if (crc32("HjySeOwban",10) == 4014316842) strcat(s, "i");
if (crc32("UlwlCKdyjMAdR",13) == 2770797537) strcat(s, "s");
if (crc32("fZMji",5) == 2816401012) strcat(s, "h");
if (crc32("CjZibnlQa",9) == 1692428327) strcat(s, "L");
if (crc32("njLYL",5) == 3643323988) strcat(s, "l");
if (crc32("rBiIMtVgGXf",11) == 2520729009) strcat(s, "y");
    return s;
}

char *allegedly_adverbs() {
    char *s = calloc(10);
    if (crc32("jFWfdRjcyvr",11) == 303031936) strcat(s, "a");
if (crc32("ROhhWpjAGSpYHdZ",15) == 2805913992) strcat(s, "l");
if (crc32("bIrOzGKhW",9) == 3069362882) strcat(s, "l");
if (crc32("KtrHW",5) == 2542146794) strcat(s, "e");
if (crc32("BrWktdRbp",9) == 2897815038) strcat(s, "g");
if (crc32("nBfHsgguOwBkQKq",15) == 4227342819) strcat(s, "e");
if (crc32("SeSMPwlcMPGYe",13) == 3719040748) strcat(s, "t");
if (crc32("YcbdDGSRHgTRtYZ",15) == 2716444979) strcat(s, "d");
if (crc32("nSUiHSdWkT",10) == 3482556264) strcat(s, "l");
if (crc32("NVsmBdNvp",9) == 3488187571) strcat(s, "y");
    return s;
}

char *subvitreously_adverbs() {
    char *s = calloc(14);
    if (crc32("yuHuqcJv",8) == 2427882726) strcat(s, "s");
if (crc32("ptHFrYn",7) == 2706195095) strcat(s, "u");
if (crc32("kMnAwlyDuR",10) == 1042378673) strcat(s, "b");
if (crc32("imPzhfI",7) == 1910172274) strcat(s, "v");
if (crc32("FIOkDnX",7) == 1295630832) strcat(s, "i");
if (crc32("MUaxETIxMT",10) == 1631649437) strcat(s, "E");
if (crc32("yuSidHAEzaRqXZ",14) == 3748109582) strcat(s, "t");
if (crc32("tJlbGcWaGRS",11) == 2324314435) strcat(s, "l");
if (crc32("GQuzZkjjcXcNsOx",15) == 4004099259) strcat(s, "r");
if (crc32("ZuMiOV",6) == 1895024066) strcat(s, "a");
if (crc32("xPbvKQAJme",10) == 3136423196) strcat(s, "e");
if (crc32("lLUchI",6) == 1200703928) strcat(s, "o");
if (crc32("IDLGacCmVfHHbb",14) == 2268695214) strcat(s, "u");
if (crc32("zCAvNhtahCkSL",13) == 1627368766) strcat(s, "s");
if (crc32("cIdRO",5) == 3448573060) strcat(s, "N");
if (crc32("gyUdnhMsGKnqKQc",15) == 2731728076) strcat(s, "l");
if (crc32("xJHYlxKmZ",9) == 2619413625) strcat(s, "y");
    return s;
}

char *electrovalently_adverbs() {
    char *s = calloc(16);
    if (crc32("wEVMeWs",7) == 3358328680) strcat(s, "f");
if (crc32("DOyEcxIDbEEoGxQ",15) == 3626195914) strcat(s, "e");
if (crc32("HoAZczt",7) == 438343408) strcat(s, "l");
if (crc32("RpDOpJlwWFoVOye",15) == 687581300) strcat(s, "v");
if (crc32("zuccYsit",8) == 3052744254) strcat(s, "e");
if (crc32("KnRhJHRtAxCLUWG",15) == 2995759906) strcat(s, "c");
if (crc32("IAwwD",5) == 4028163600) strcat(s, "t");
if (crc32("FfGRNELYoRMQxy",14) == 263728929) strcat(s, "r");
if (crc32("fPHDIHXTMhqLbP",14) == 642467674) strcat(s, "o");
if (crc32("fGqbbdEqjCXj",12) == 942939907) strcat(s, "w");
if (crc32("LUjjbWOJNI",10) == 564871921) strcat(s, "v");
if (crc32("VXjPfadoImDEVLh",15) == 2796853604) strcat(s, "s");
if (crc32("aAQFlSYziAFkTr",14) == 1802363063) strcat(s, "a");
if (crc32("dVOngdwgfs",10) == 457954537) strcat(s, "w");
if (crc32("KxyJOaQAs",9) == 107084312) strcat(s, "l");
if (crc32("EvzRHEjXgjw",11) == 2735745779) strcat(s, "G");
if (crc32("ilLTpYJzfADKV",13) == 3827552169) strcat(s, "e");
if (crc32("UGKOvZmzCF",10) == 3152646930) strcat(s, "n");
if (crc32("dCMDFjEhUBcsl",13) == 3477338975) strcat(s, "f");
if (crc32("nxlKvHT",7) == 3046729240) strcat(s, "t");
if (crc32("wGilPXsl",8) == 2517515521) strcat(s, "P");
if (crc32("SrglhAQ",7) == 546563782) strcat(s, "l");
if (crc32("AlcAZkxzqd",10) == 3620823283) strcat(s, "Z");
if (crc32("mayLIPpDtGP",11) == 1539504371) strcat(s, "y");
    return s;
}

char *beautifully_adverbs() {
    char *s = calloc(12);
    if (crc32("rBEES",5) == 2098208801) strcat(s, "b");
if (crc32("jZGIFQzCVho",11) == 2769024325) strcat(s, "X");
if (crc32("jvFtwlYAszrTSK",14) == 3875355081) strcat(s, "e");
if (crc32("XtBgByNee",9) == 3545849824) strcat(s, "U");
if (crc32("NNdKmzxpEbrxOEq",15) == 3349061855) strcat(s, "a");
if (crc32("amkFE",5) == 3379134750) strcat(s, "f");
if (crc32("megUEBkuK",9) == 2545303880) strcat(s, "u");
if (crc32("wkkiko",6) == 3106051214) strcat(s, "t");
if (crc32("UCXmvwfTgfSyIUB",15) == 2535193102) strcat(s, "i");
if (crc32("dAKsYI",6) == 2004099205) strcat(s, "m");
if (crc32("PCNFl",5) == 4021529151) strcat(s, "f");
if (crc32("hcZIfVRmeMZIGJ",14) == 2349626574) strcat(s, "u");
if (crc32("SvmRhJLxDS",10) == 2476119825) strcat(s, "i");
if (crc32("MmUbXCzdwRHL",12) == 2294324624) strcat(s, "l");
if (crc32("ifpALJzmpzoCrhu",15) == 1607646289) strcat(s, "j");
if (crc32("cxsUGmxVMr",10) == 2408223914) strcat(s, "l");
if (crc32("DOvzMuDiM",9) == 4011529826) strcat(s, "e");
if (crc32("TdNiiZkiuXucMcE",15) == 1457685119) strcat(s, "y");
    return s;
}

char *adventurously_adverbs() {
    char *s = calloc(14);
    if (crc32("OQVzRyjHO",9) == 116564341) strcat(s, "N");
if (crc32("zlzSpEmTJfQmClT",15) == 74227925) strcat(s, "a");
if (crc32("lXzZbHm",7) == 3459902190) strcat(s, "G");
if (crc32("xOKJLc",6) == 897517142) strcat(s, "d");
if (crc32("KOjdQWz",7) == 411690375) strcat(s, "h");
if (crc32("gyXWo",5) == 2975824644) strcat(s, "v");
if (crc32("bYAjKWMLDqF",11) == 1470520881) strcat(s, "z");
if (crc32("GMwtEkzn",8) == 3997248191) strcat(s, "e");
if (crc32("QDtsHmNFzZbykow",15) == 1480834477) strcat(s, "n");
if (crc32("sSlTgmhGoHkOxa",14) == 3521905666) strcat(s, "t");
if (crc32("WtYyQPAxe",9) == 3757491086) strcat(s, "V");
if (crc32("QQzDwYugjKmA",12) == 2664925146) strcat(s, "u");
if (crc32("rYGZFrzPuiel",12) == 156773838) strcat(s, "Q");
if (crc32("PnpsrbAlawy",11) == 611441666) strcat(s, "r");
if (crc32("UqTUtLx",7) == 1640884511) strcat(s, "h");
if (crc32("kzXSm",5) == 3967327683) strcat(s, "o");
if (crc32("mfrSiiIQOwKwa",13) == 1455624135) strcat(s, "u");
if (crc32("jCQmIcRdsYqDU",13) == 942031394) strcat(s, "s");
if (crc32("cEnTYMv",7) == 3371328183) strcat(s, "D");
if (crc32("NOntalKFLyJ",11) == 4000113192) strcat(s, "l");
if (crc32("IcqctP",6) == 2011795540) strcat(s, "f");
if (crc32("vFlUYWfOsvzz",12) == 2577588181) strcat(s, "y");
    return s;
}

char *roomily_adverbs() {
    char *s = calloc(8);
    if (crc32("ocQGb",5) == 2234110557) strcat(s, "r");
if (crc32("oCZPGKJ",7) == 285743899) strcat(s, "s");
if (crc32("MgXiRJ",6) == 2116899830) strcat(s, "o");
if (crc32("haTIMNvvpALdar",14) == 966155157) strcat(s, "o");
if (crc32("gTrVhPuiRpY",11) == 2129703500) strcat(s, "o");
if (crc32("FTbQupjNlQf",11) == 1427846811) strcat(s, "m");
if (crc32("eHHikJLTrA",10) == 2207081177) strcat(s, "i");
if (crc32("DQEPzqXcbcNmzWr",15) == 3034900739) strcat(s, "I");
if (crc32("wUkPOddDUGNP",12) == 1149123931) strcat(s, "l");
if (crc32("NzCVzjZbMqkeS",13) == 1182217745) strcat(s, "y");
    return s;
}

char *unphysiologically_adverbs() {
    char *s = calloc(18);
    if (crc32("saLuLWN",7) == 1605959537) strcat(s, "u");
if (crc32("UlODjYT",7) == 1385252848) strcat(s, "m");
if (crc32("TlWPHJ",6) == 4006610214) strcat(s, "n");
if (crc32("BwCaPG",6) == 706210232) strcat(s, "p");
if (crc32("qkCfg",5) == 3445329879) strcat(s, "k");
if (crc32("lpQhBt",6) == 2541020336) strcat(s, "h");
if (crc32("BlDRyH",6) == 1009091083) strcat(s, "M");
if (crc32("oRouGsndFUPyqcs",15) == 926177017) strcat(s, "y");
if (crc32("OKGtllPOFbJaFSo",15) == 2027656933) strcat(s, "s");
if (crc32("FJaSZivti",9) == 1338741505) strcat(s, "i");
if (crc32("UYPIjCJbIGvWl",13) == 389133913) strcat(s, "r");
if (crc32("wsKkm",5) == 1033832728) strcat(s, "o");
if (crc32("MDtqwsWUhjB",11) == 3206677889) strcat(s, "l");
if (crc32("MoolLoIsP",9) == 163197553) strcat(s, "i");
if (crc32("BlaVC",5) == 3753967456) strcat(s, "o");
if (crc32("gQdWgSsX",8) == 2320590591) strcat(s, "g");
if (crc32("uxywrzg",7) == 737228782) strcat(s, "E");
if (crc32("uxefNC",6) == 3791803613) strcat(s, "i");
if (crc32("FaXAZF",6) == 1822132206) strcat(s, "c");
if (crc32("XXnActLl",8) == 3323279874) strcat(s, "a");
if (crc32("niySYo",6) == 3776877631) strcat(s, "n");
if (crc32("doFfmx",6) == 1164792036) strcat(s, "l");
if (crc32("yiVBBMZwB",9) == 2784117368) strcat(s, "l");
if (crc32("sjHOhQLTWIbO",12) == 682464746) strcat(s, "k");
if (crc32("KXcKGAguduzoPdl",15) == 2867329813) strcat(s, "y");
    return s;
}

char *infra_adverbs() {
    char *s = calloc(6);
    if (crc32("FLSHqQkKFs",10) == 317137975) strcat(s, "l");
if (crc32("kLmGSLOm",8) == 3513482899) strcat(s, "i");
if (crc32("ojgOngdBCjOqOmE",15) == 2379854354) strcat(s, "n");
if (crc32("kNHpiIUgn",9) == 3759256120) strcat(s, "f");
if (crc32("kQXwNkvkB",9) == 3807212094) strcat(s, "r");
if (crc32("uelApG",6) == 2094057317) strcat(s, "a");
    return s;
}

char *ambagiously_adverbs() {
    char *s = calloc(12);
    if (crc32("ZVkSXSWz",8) == 1001015983) strcat(s, "X");
if (crc32("DAqmfjGmFXKgs",13) == 3755106974) strcat(s, "a");
if (crc32("SUPaJ",5) == 3272696142) strcat(s, "m");
if (crc32("zRnAZEjv",8) == 884729482) strcat(s, "X");
if (crc32("hOAQBi",6) == 925985960) strcat(s, "b");
if (crc32("alHqza",6) == 2675664551) strcat(s, "t");
if (crc32("elpsluCxVO",10) == 2282112674) strcat(s, "a");
if (crc32("SzRDrjxLsI",10) == 3677439069) strcat(s, "F");
if (crc32("yfrFerPdbCgC",12) == 2151242149) strcat(s, "g");
if (crc32("cICjuoPrbNbR",12) == 865920353) strcat(s, "i");
if (crc32("cDMTal",6) == 2834846663) strcat(s, "i");
if (crc32("UeJyzJqW",8) == 3912288263) strcat(s, "d");
if (crc32("EdzAotBOn",9) == 4219157351) strcat(s, "o");
if (crc32("QFksLtWY",8) == 2329619653) strcat(s, "x");
if (crc32("VOLCohFsz",9) == 952035273) strcat(s, "u");
if (crc32("dMfPhvNfwXp",11) == 1977919922) strcat(s, "s");
if (crc32("hnHkcTxv",8) == 2901042420) strcat(s, "l");
if (crc32("VMcRanQhSIJts",13) == 3700849705) strcat(s, "G");
if (crc32("yaanb",5) == 2695692943) strcat(s, "y");
    return s;
}

char *forbiddingly_adverbs() {
    char *s = calloc(13);
    if (crc32("GtXFwFufhLiO",12) == 1862526114) strcat(s, "f");
if (crc32("egnohEJowHnW",12) == 3635661343) strcat(s, "o");
if (crc32("YDZAagsB",8) == 88832972) strcat(s, "r");
if (crc32("FePwAbDMOzTQDc",14) == 1061915365) strcat(s, "b");
if (crc32("ntAQTUQXL",9) == 774536342) strcat(s, "i");
if (crc32("oPQRgdnAvu",10) == 370847568) strcat(s, "d");
if (crc32("tiJtytTPReGGX",13) == 796595204) strcat(s, "C");
if (crc32("vxTQtuAHcergxl",14) == 2182609321) strcat(s, "d");
if (crc32("nMAuaTHTLsKLjgM",15) == 1354839292) strcat(s, "i");
if (crc32("ZPPMD",5) == 659994020) strcat(s, "n");
if (crc32("atZhzMgGdX",10) == 2978015656) strcat(s, "g");
if (crc32("QYYNpIEVkQIhbG",14) == 497505754) strcat(s, "l");
if (crc32("HcwcsdEtyqwyrxa",15) == 3622311242) strcat(s, "y");
    return s;
}

char *preworthily_adverbs() {
    char *s = calloc(12);
    if (crc32("ZwnGlZslMSkSC",13) == 2376745128) strcat(s, "p");
if (crc32("LHrJCYI",7) == 2631036724) strcat(s, "r");
if (crc32("CYmYehwXczbp",12) == 2350833791) strcat(s, "e");
if (crc32("VxKKMIedDCbn",12) == 436533955) strcat(s, "w");
if (crc32("CxZbftLUEUp",11) == 1552691026) strcat(s, "c");
if (crc32("FTvfzStKr",9) == 1599898681) strcat(s, "o");
if (crc32("mUAqQtkUrb",10) == 2736513127) strcat(s, "r");
if (crc32("kukCWQ",6) == 3530861433) strcat(s, "Z");
if (crc32("HlHRPWQReSyh",12) == 796848689) strcat(s, "t");
if (crc32("STKIEc",6) == 689751678) strcat(s, "v");
if (crc32("QHIHcfLVLqPYN",13) == 1062748023) strcat(s, "h");
if (crc32("LRwrPLrAlXlXlR",14) == 1965857981) strcat(s, "M");
if (crc32("insueUqXv",9) == 1727119747) strcat(s, "i");
if (crc32("ZokWdGNrhPjqdmG",15) == 3799564348) strcat(s, "l");
if (crc32("xMKFztOj",8) == 10177867) strcat(s, "y");
    return s;
}

char *unidiomatically_adverbs() {
    char *s = calloc(16);
    if (crc32("zaKWeYRdrQl",11) == 1889303234) strcat(s, "t");
if (crc32("hnOEZLWNz",9) == 1035856295) strcat(s, "u");
if (crc32("UTLVlazXiUN",11) == 1521876110) strcat(s, "n");
if (crc32("vydydMwnarz",11) == 2099524343) strcat(s, "i");
if (crc32("EKUBclOkLt",10) == 3367069863) strcat(s, "Q");
if (crc32("cPRqDUotpsq",11) == 1126310869) strcat(s, "d");
if (crc32("CnAXI",5) == 3389467436) strcat(s, "E");
if (crc32("ZcDvm",5) == 2699533843) strcat(s, "i");
if (crc32("nBDSLDDEq",9) == 659084933) strcat(s, "Y");
if (crc32("MMSbeguhZQi",11) == 825508125) strcat(s, "o");
if (crc32("gqfttwQFokrGzZU",15) == 3092015223) strcat(s, "m");
if (crc32("UupGuIcAJfbCHB",14) == 730398314) strcat(s, "a");
if (crc32("ugXWcZrWKOdRfJD",15) == 1947072648) strcat(s, "t");
if (crc32("eJUGQFYHsvK",11) == 568169801) strcat(s, "i");
if (crc32("GJNsaepwGEEXsr",14) == 2549307192) strcat(s, "c");
if (crc32("PCEDQrMvYvUssL",14) == 17470461) strcat(s, "a");
if (crc32("YEncKyTR",8) == 2576558726) strcat(s, "l");
if (crc32("WbNWxlLBSGxILm",14) == 2138175374) strcat(s, "q");
if (crc32("xFXHolflhI",10) == 41918777) strcat(s, "l");
if (crc32("zEmtEjhJhO",10) == 2087484647) strcat(s, "M");
if (crc32("PGImPZsd",8) == 481731760) strcat(s, "y");
    return s;
}

char *semifictionally_adverbs() {
    char *s = calloc(16);
    if (crc32("ZZmfMtnHGkbLTBp",15) == 4219550240) strcat(s, "F");
if (crc32("xLEbtPESLZPFC",13) == 3495870453) strcat(s, "s");
if (crc32("SjRXkRAKsqWeKL",14) == 9890054) strcat(s, "C");
if (crc32("CmqqqjonWX",10) == 3010746901) strcat(s, "e");
if (crc32("vAxTDqUB",8) == 3654851508) strcat(s, "m");
if (crc32("oMnAINX",7) == 655185782) strcat(s, "f");
if (crc32("TqsmgjkDYftSW",13) == 1108304542) strcat(s, "i");
if (crc32("qSxcOUhnororic",14) == 1478235805) strcat(s, "f");
if (crc32("MDbBd",5) == 2214976941) strcat(s, "o");
if (crc32("nFITEglYP",9) == 2901107351) strcat(s, "i");
if (crc32("KblscRAh",8) == 538459197) strcat(s, "c");
if (crc32("cnRlawrDA",9) == 503033112) strcat(s, "t");
if (crc32("kyuIBKlXtAXSWm",14) == 1019178366) strcat(s, "i");
if (crc32("PZEyJDFgbLPPB",13) == 3176342808) strcat(s, "e");
if (crc32("EotdUPDQk",9) == 3307792197) strcat(s, "o");
if (crc32("VzxoHfObCcskVu",14) == 2280351168) strcat(s, "n");
if (crc32("GwcBW",5) == 2814932936) strcat(s, "a");
if (crc32("vMetux",6) == 2672582791) strcat(s, "l");
if (crc32("ElCYAmST",8) == 1789992024) strcat(s, "l");
if (crc32("lIZkMQvvxmuxZWR",15) == 311349503) strcat(s, "y");
    return s;
}

char *corruptly_adverbs() {
    char *s = calloc(10);
    if (crc32("ihdwlIQiHJ",10) == 2623163366) strcat(s, "n");
if (crc32("eVvEXcBoibU",11) == 3358220774) strcat(s, "c");
if (crc32("CUSssdDEfYtom",13) == 125755493) strcat(s, "o");
if (crc32("kSMNUTgYMFaWbtZ",15) == 2945682899) strcat(s, "H");
if (crc32("OuGouQqBP",9) == 3305687192) strcat(s, "r");
if (crc32("CcWwLx",6) == 3632667112) strcat(s, "k");
if (crc32("bkKTYENLoBi",11) == 2917158660) strcat(s, "r");
if (crc32("HxskOOrnHRRyoSs",15) == 1209434845) strcat(s, "J");
if (crc32("aNHjx",5) == 2801672373) strcat(s, "u");
if (crc32("EzCmHtSLp",9) == 2864872657) strcat(s, "x");
if (crc32("JilzUJWpyKTuseV",15) == 2040713005) strcat(s, "p");
if (crc32("vsywhuj",7) == 598890794) strcat(s, "s");
if (crc32("bwkPGXQToNqN",12) == 3033690299) strcat(s, "t");
if (crc32("bQGpjFfATEGVKlA",15) == 2969444802) strcat(s, "j");
if (crc32("DFCpngwmNX",10) == 912793192) strcat(s, "l");
if (crc32("mOzKs",5) == 3876607812) strcat(s, "y");
    return s;
}

char *quasiperpetually_adverbs() {
    char *s = calloc(17);
    if (crc32("VsUswnKODBBsM",13) == 3958773745) strcat(s, "q");
if (crc32("ahZxgFDbpgqmW",13) == 2147761136) strcat(s, "u");
if (crc32("NqBbUFjfsVXLw",13) == 1051664889) strcat(s, "b");
if (crc32("loMAuVeTOBBq",12) == 1396168511) strcat(s, "a");
if (crc32("yXZOqOSdgUpFPg",14) == 2051061537) strcat(s, "s");
if (crc32("ZNYhkCXyzFNg",12) == 226042405) strcat(s, "e");
if (crc32("AVuIgQixBxXh",12) == 3244881986) strcat(s, "i");
if (crc32("ZWImthLcGhQxxky",15) == 565106001) strcat(s, "p");
if (crc32("xuBuOq",6) == 1413835229) strcat(s, "e");
if (crc32("TGtbBGxSnBlzyt",14) == 3706472504) strcat(s, "r");
if (crc32("lNbVZ",5) == 3866987248) strcat(s, "D");
if (crc32("SSksycpDN",9) == 4272533213) strcat(s, "p");
if (crc32("ofYYfawLxTku",12) == 3518721118) strcat(s, "e");
if (crc32("pvWIzDVRCVVw",12) == 3056723881) strcat(s, "t");
if (crc32("JTagNEVnxehkq",13) == 855237975) strcat(s, "u");
if (crc32("bUYXtgPIEeGTURc",15) == 148304150) strcat(s, "d");
if (crc32("pTRuKZ",6) == 3699279583) strcat(s, "a");
if (crc32("rMRTXVAOktiG",12) == 119430431) strcat(s, "l");
if (crc32("seTdrFHLJ",9) == 1094595328) strcat(s, "N");
if (crc32("WBXpYnTSpCHjwzL",15) == 2402141010) strcat(s, "l");
if (crc32("GycbEhlOoNMe",12) == 4026257285) strcat(s, "y");
    return s;
}

char *quasiinfluentially_adverbs() {
    char *s = calloc(19);
    if (crc32("AqEiroljCvku",12) == 661165338) strcat(s, "q");
if (crc32("GDdSAxudHFJtC",13) == 4109399529) strcat(s, "l");
if (crc32("MRCbcBHaXPexLw",14) == 2073419) strcat(s, "u");
if (crc32("CITtr",5) == 2297758573) strcat(s, "y");
if (crc32("StMFlgm",7) == 1502358107) strcat(s, "a");
if (crc32("ywesVQvzHPW",11) == 3430802469) strcat(s, "N");
if (crc32("jxbbyCADXlE",11) == 4038134221) strcat(s, "s");
if (crc32("WPmFN",5) == 1783162938) strcat(s, "O");
if (crc32("jATKa",5) == 1954932421) strcat(s, "i");
if (crc32("ebaRswa",7) == 3456928891) strcat(s, "P");
if (crc32("hxTpJpCZ",8) == 668214304) strcat(s, "i");
if (crc32("BDCQB",5) == 2507853939) strcat(s, "l");
if (crc32("BXMyDKYTiSnK",12) == 1842938126) strcat(s, "n");
if (crc32("MWFHxNaYCAvq",12) == 1762332924) strcat(s, "U");
if (crc32("yKWQL",5) == 3419206404) strcat(s, "f");
if (crc32("CcADz",5) == 2776594621) strcat(s, "l");
if (crc32("TpXWvlryjYfC",12) == 2991306646) strcat(s, "A");
if (crc32("WGGqR",5) == 2353424232) strcat(s, "u");
if (crc32("aeFjKDyS",8) == 1278720924) strcat(s, "k");
if (crc32("yLPGMabqgiNuIlY",15) == 3458868151) strcat(s, "e");
if (crc32("AzgRqLDpIa",10) == 81849957) strcat(s, "y");
if (crc32("yLtFA",5) == 388156207) strcat(s, "n");
if (crc32("JPQPLnq",7) == 438003520) strcat(s, "t");
if (crc32("NZDEgPmplr",10) == 2665382928) strcat(s, "J");
if (crc32("OazOCNPQSp",10) == 1092584208) strcat(s, "i");
if (crc32("PcwYGaCanB",10) == 556252684) strcat(s, "w");
if (crc32("dcNilizoKFdjO",13) == 1417968706) strcat(s, "a");
if (crc32("qWxoojDbbYnbA",13) == 853494650) strcat(s, "l");
if (crc32("cQHSkHPO",8) == 174528401) strcat(s, "B");
if (crc32("dFUUmtHN",8) == 2308484700) strcat(s, "l");
if (crc32("AFlMmNsVtTBAV",13) == 3560615390) strcat(s, "s");
if (crc32("kwaddV",6) == 3621702429) strcat(s, "y");
    return s;
}

char *insomuch_adverbs() {
    char *s = calloc(9);
    if (crc32("IbEQJUrqdTYDldN",15) == 4130565375) strcat(s, "E");
if (crc32("hFvLdTkYmrAE",12) == 224486276) strcat(s, "i");
if (crc32("NfxjQYc",7) == 4212103547) strcat(s, "Y");
if (crc32("sBXyIL",6) == 353327232) strcat(s, "n");
if (crc32("DLQiIUEmoyclTr",14) == 4132078468) strcat(s, "s");
if (crc32("zjOVlc",6) == 2118971080) strcat(s, "o");
if (crc32("rkIpzTUYlqJB",12) == 1737530922) strcat(s, "m");
if (crc32("oahUpHOpkrb",11) == 2951217036) strcat(s, "v");
if (crc32("bHTaodgKRyxKKpV",15) == 2930944067) strcat(s, "u");
if (crc32("ubtjGixf",8) == 3698891474) strcat(s, "c");
if (crc32("OyCJFo",6) == 881651755) strcat(s, "h");
    return s;
}

char *slantly_adverbs() {
    char *s = calloc(8);
    if (crc32("BSzKp",5) == 658986508) strcat(s, "s");
if (crc32("PEKge",5) == 961583695) strcat(s, "l");
if (crc32("ZBWLlmDcsV",10) == 3734591658) strcat(s, "W");
if (crc32("UTIgYvfYXo",10) == 1687602312) strcat(s, "a");
if (crc32("uHPJOnFqezBTJ",13) == 580465563) strcat(s, "n");
if (crc32("lElYjtfT",8) == 675580584) strcat(s, "a");
if (crc32("RdMoowRKDpQmag",14) == 2696937498) strcat(s, "t");
if (crc32("trMmobPHgLnWiv",14) == 2319903032) strcat(s, "l");
if (crc32("VUgHIYI",7) == 3674865008) strcat(s, "F");
if (crc32("TTgmOdsniD",10) == 544542642) strcat(s, "y");
    return s;
}

char *notably_adverbs() {
    char *s = calloc(8);
    if (crc32("bXwBNusJlhXMrzT",15) == 973880860) strcat(s, "g");
if (crc32("azzVju",6) == 315003222) strcat(s, "n");
if (crc32("CklbfyvqdFWFSF",14) == 2696789092) strcat(s, "p");
if (crc32("iboWp",5) == 626780955) strcat(s, "o");
if (crc32("yrIAEo",6) == 1525580213) strcat(s, "y");
if (crc32("wtEhBwF",7) == 3327010019) strcat(s, "t");
if (crc32("vECMEVfwSl",10) == 2091998732) strcat(s, "a");
if (crc32("lurTfucaLr",10) == 3327408960) strcat(s, "b");
if (crc32("TVUNvMXuMpTPAHk",15) == 706310096) strcat(s, "l");
if (crc32("XgUrDVauwRIF",12) == 1581631066) strcat(s, "w");
if (crc32("saYLJjQQi",9) == 1104775945) strcat(s, "y");
    return s;
}

char *uninertly_adverbs() {
    char *s = calloc(10);
    if (crc32("zpClqXQlMPwOJy",14) == 1846230997) strcat(s, "u");
if (crc32("DmrntuQuXa",10) == 1233858180) strcat(s, "A");
if (crc32("Qpchk",5) == 2512100860) strcat(s, "n");
if (crc32("BdfTJnJHJJLQkwH",15) == 122180672) strcat(s, "i");
if (crc32("rreivUwnlJQZAM",14) == 2146423558) strcat(s, "v");
if (crc32("jAQpMHdrHN",10) == 150124338) strcat(s, "n");
if (crc32("KfSOyauWd",9) == 3661544810) strcat(s, "e");
if (crc32("aIkNGfvJPsdmzr",14) == 3552054080) strcat(s, "r");
if (crc32("annCharBnpbOe",13) == 3515070616) strcat(s, "s");
if (crc32("fGDeIKlyNQoSxc",14) == 3114480677) strcat(s, "t");
if (crc32("zgVpjShnH",9) == 1983998868) strcat(s, "L");
if (crc32("SHRcUSnTHo",10) == 263177510) strcat(s, "l");
if (crc32("wagPlXngRXXy",12) == 766953509) strcat(s, "y");
    return s;
}

char *avariciously_adverbs() {
    char *s = calloc(13);
    if (crc32("xacVOiIfvK",10) == 4221121422) strcat(s, "l");
if (crc32("ngfxmXJnkbksEpD",15) == 3518686134) strcat(s, "a");
if (crc32("sAEJiCE",7) == 1789066015) strcat(s, "Y");
if (crc32("lWvaDa",6) == 3978754241) strcat(s, "v");
if (crc32("UJWOCDtdwPnco",13) == 1867567776) strcat(s, "a");
if (crc32("eZDBNpVP",8) == 733395998) strcat(s, "y");
if (crc32("MNRFyUeMJsZ",11) == 2864750117) strcat(s, "r");
if (crc32("aZbxYhxPiYXE",12) == 2142256350) strcat(s, "X");
if (crc32("EUcHTRPQdQBO",12) == 346806270) strcat(s, "i");
if (crc32("GdeEyA",6) == 2378557430) strcat(s, "C");
if (crc32("rkqBMHaXyUgHJRT",15) == 2503691078) strcat(s, "c");
if (crc32("igoASHDfrkx",11) == 679172897) strcat(s, "k");
if (crc32("eSqJEKKQBFKNgu",14) == 2590843873) strcat(s, "i");
if (crc32("sKbNLcgE",8) == 341310051) strcat(s, "o");
if (crc32("yRAgziyQCPBmh",13) == 2121502391) strcat(s, "g");
if (crc32("itiVGHOg",8) == 4134858741) strcat(s, "u");
if (crc32("CxKeqTjxke",10) == 3359684282) strcat(s, "s");
if (crc32("blmMiFjZPgIVvv",14) == 2888227635) strcat(s, "l");
if (crc32("ePiyLgIpNm",10) == 2900273567) strcat(s, "y");
    return s;
}

char *inflagrantedelicto_adverbs() {
    char *s = calloc(19);
    if (crc32("WTkNFX",6) == 946475370) strcat(s, "i");
if (crc32("iAKdpBeEWyn",11) == 1474616319) strcat(s, "n");
if (crc32("VAYEsMKbwHt",11) == 2746862316) strcat(s, "R");
if (crc32("SwvJGpwPjKjk",12) == 3688944243) strcat(s, "f");
if (crc32("yOikCE",6) == 2550269859) strcat(s, "l");
if (crc32("Cqhnvzsny",9) == 491510501) strcat(s, "a");
if (crc32("VkfnIHDE",8) == 707571820) strcat(s, "a");
if (crc32("FqjZF",5) == 1488552576) strcat(s, "g");
if (crc32("rVWXiw",6) == 1943111860) strcat(s, "M");
if (crc32("LLBCZ",5) == 2836879442) strcat(s, "r");
if (crc32("IyYcpuO",7) == 372501977) strcat(s, "K");
if (crc32("yjYsGdFEPa",10) == 2176663628) strcat(s, "a");
if (crc32("kdmSfUcxIwoPM",13) == 2043183972) strcat(s, "t");
if (crc32("ahWYnmbvqSc",11) == 3068966017) strcat(s, "n");
if (crc32("wslNc",5) == 265725085) strcat(s, "t");
if (crc32("riJwKmsFjL",10) == 2579235689) strcat(s, "e");
if (crc32("iHwoOksfWT",10) == 3432602157) strcat(s, "d");
if (crc32("lZRFBi",6) == 3626018259) strcat(s, "U");
if (crc32("RfeRZNObOC",10) == 127224080) strcat(s, "e");
if (crc32("weXMcMQCPEcJOu",14) == 209842118) strcat(s, "l");
if (crc32("LJqOBf",6) == 364957618) strcat(s, "i");
if (crc32("kKyqQqpZ",8) == 2214376788) strcat(s, "l");
if (crc32("xbZolDZwOGVtzTq",15) == 3312650938) strcat(s, "c");
if (crc32("vTMWoOIRyI",10) == 944843043) strcat(s, "t");
if (crc32("jWUMVixmKjNkCVm",15) == 1872326301) strcat(s, "N");
if (crc32("gPSqcCR",7) == 1734577767) strcat(s, "o");
    return s;
}

char *unremotely_adverbs() {
    char *s = calloc(11);
    if (crc32("hmCBJtea",8) == 4121482795) strcat(s, "h");
if (crc32("CQpiKjqdPIQgQjU",15) == 2028378323) strcat(s, "u");
if (crc32("ESEXfXa",7) == 1126917193) strcat(s, "i");
if (crc32("NpPeONVpQTKxrU",14) == 3773530900) strcat(s, "n");
if (crc32("uiDdlnLfR",9) == 703538468) strcat(s, "z");
if (crc32("AyoDROAiNltUod",14) == 82323767) strcat(s, "r");
if (crc32("ssbOZDwYdpMpkuF",15) == 2679968311) strcat(s, "e");
if (crc32("BVlqckmOYAQH",12) == 3194201404) strcat(s, "m");
if (crc32("fKaLH",5) == 4053516912) strcat(s, "o");
if (crc32("euaqlcOqIzceOM",14) == 1473864389) strcat(s, "v");
if (crc32("GGGEfoiEncZRXGo",15) == 2240218462) strcat(s, "t");
if (crc32("dsxfhRlyZeXBA",13) == 1158757506) strcat(s, "e");
if (crc32("eaVzdG",6) == 967965877) strcat(s, "i");
if (crc32("OcLKJsHyOmSa",12) == 1914320206) strcat(s, "l");
if (crc32("MVjZZXE",7) == 11168034) strcat(s, "y");
    return s;
}

char *nonsignificantly_adverbs() {
    char *s = calloc(17);
    if (crc32("OayOE",5) == 3043761641) strcat(s, "n");
if (crc32("xhlghC",6) == 2171106840) strcat(s, "o");
if (crc32("JrnAJ",5) == 2670219208) strcat(s, "i");
if (crc32("XYriKjjvFlacM",13) == 808033113) strcat(s, "n");
if (crc32("oFVkTOYdxhrcN",13) == 812905981) strcat(s, "A");
if (crc32("nAztW",5) == 615683146) strcat(s, "s");
if (crc32("jVoNrL",6) == 3571246756) strcat(s, "i");
if (crc32("MbBUA",5) == 1114101204) strcat(s, "g");
if (crc32("WaKxrdZdoQ",10) == 1729480480) strcat(s, "n");
if (crc32("MeXXOH",6) == 3987915410) strcat(s, "l");
if (crc32("gYaarloZzOqDSZx",15) == 3676839224) strcat(s, "i");
if (crc32("szWto",5) == 2206193140) strcat(s, "f");
if (crc32("aXtYGSjCzT",10) == 2014148856) strcat(s, "i");
if (crc32("fzKoRBUvr",9) == 3233760770) strcat(s, "r");
if (crc32("dzQJhVtmK",9) == 3572933595) strcat(s, "c");
if (crc32("uWnCbGfh",8) == 3732494993) strcat(s, "a");
if (crc32("rPrcd",5) == 3712444939) strcat(s, "n");
if (crc32("TnZzDlSOek",10) == 3820350380) strcat(s, "t");
if (crc32("JeLhUW",6) == 3944112335) strcat(s, "l");
if (crc32("pjyut",5) == 3517884599) strcat(s, "k");
if (crc32("rJMRIdchC",9) == 224150029) strcat(s, "y");
    return s;
}

char *spang_adverbs() {
    char *s = calloc(6);
    if (crc32("zbFHlMWqnFIIwD",14) == 4198117517) strcat(s, "z");
if (crc32("kMnCTwh",7) == 1075470363) strcat(s, "s");
if (crc32("sEmVtDXEWWF",11) == 1631605260) strcat(s, "p");
if (crc32("OrswwhgY",8) == 2685115159) strcat(s, "a");
if (crc32("NLSXiDFm",8) == 3749194896) strcat(s, "A");
if (crc32("AkTXbQli",8) == 2544848310) strcat(s, "n");
if (crc32("zaqkZzYuZYRGPPq",15) == 3610831984) strcat(s, "B");
if (crc32("ZudqMnuRsHD",11) == 3627122622) strcat(s, "g");
    return s;
}

char *quasitheatrically_adverbs() {
    char *s = calloc(18);
    if (crc32("mqAhAGDTFNhpzC",14) == 1924222598) strcat(s, "M");
if (crc32("ckuCjK",6) == 2170675721) strcat(s, "q");
if (crc32("ZszfNqzDXfyXd",13) == 2694996009) strcat(s, "f");
if (crc32("ILoxGWl",7) == 1168584841) strcat(s, "u");
if (crc32("CkueBiTYv",9) == 3075076412) strcat(s, "a");
if (crc32("uNEeTFq",7) == 1611773091) strcat(s, "s");
if (crc32("sTPIc",5) == 490765365) strcat(s, "p");
if (crc32("nXitZuitFNXpRj",14) == 3163887869) strcat(s, "i");
if (crc32("JREvTmSUi",9) == 3991639266) strcat(s, "W");
if (crc32("OrjtYWK",7) == 696477879) strcat(s, "t");
if (crc32("lOmrsDRKnV",10) == 1562092080) strcat(s, "h");
if (crc32("vmraS",5) == 2495085193) strcat(s, "t");
if (crc32("FLlNBsVakkw",11) == 834528257) strcat(s, "e");
if (crc32("yJHatQOEqiISvbZ",15) == 1973632488) strcat(s, "S");
if (crc32("EvpQRnKFhj",10) == 1851214377) strcat(s, "a");
if (crc32("DAkBRSsbeVqhQwT",15) == 267314932) strcat(s, "t");
if (crc32("lnGHPiGPlgP",11) == 2466681928) strcat(s, "r");
if (crc32("OmdeccotofgYad",14) == 3610882960) strcat(s, "i");
if (crc32("CZrpKEPujmzP",12) == 1366416398) strcat(s, "c");
if (crc32("yCrqP",5) == 904114984) strcat(s, "w");
if (crc32("hPTcQzVzm",9) == 2189233308) strcat(s, "a");
if (crc32("DUfuHAJztxxUB",13) == 635500902) strcat(s, "g");
if (crc32("WNiQyr",6) == 741101925) strcat(s, "l");
if (crc32("IZEfmiuFHgPM",12) == 3491326529) strcat(s, "i");
if (crc32("MfPxshOh",8) == 4046912825) strcat(s, "l");
if (crc32("ulvMfXrS",8) == 2073682634) strcat(s, "g");
if (crc32("bculQiZfn",9) == 2957336467) strcat(s, "y");
    return s;
}

char *uninterpretively_adverbs() {
    char *s = calloc(17);
    if (crc32("JDBrWrFelK",10) == 897560076) strcat(s, "k");
if (crc32("tDtuIfD",7) == 2087488122) strcat(s, "u");
if (crc32("YCuKfIeoz",9) == 2833404021) strcat(s, "n");
if (crc32("CUwjQg",6) == 186898407) strcat(s, "i");
if (crc32("IwqdwIAmPbancV",14) == 3797262274) strcat(s, "C");
if (crc32("ajAMWzHGqMuV",12) == 1096710528) strcat(s, "n");
if (crc32("QFvjzGXLzO",10) == 1506623579) strcat(s, "t");
if (crc32("yNiiuJseRvL",11) == 2041598152) strcat(s, "r");
if (crc32("HMOgtUFvxDhpet",14) == 1783376145) strcat(s, "e");
if (crc32("LBKRWfcAH",9) == 4258779337) strcat(s, "r");
if (crc32("qLUZZYpuggsPTi",14) == 2960388904) strcat(s, "U");
if (crc32("XztiywnjqHazfjZ",15) == 1953486619) strcat(s, "p");
if (crc32("WdRTk",5) == 2480561868) strcat(s, "r");
if (crc32("hSJIzYKx",8) == 2047283724) strcat(s, "h");
if (crc32("gzxhBq",6) == 441653481) strcat(s, "e");
if (crc32("ivexjuBHY",9) == 297793232) strcat(s, "K");
if (crc32("meFXPFzcAeJZT",13) == 25744586) strcat(s, "t");
if (crc32("OzhBJIKrIW",10) == 232317541) strcat(s, "i");
if (crc32("LZJjrBv",7) == 3646355933) strcat(s, "v");
if (crc32("AAekohrS",8) == 509140373) strcat(s, "e");
if (crc32("cJZvxG",6) == 3597877334) strcat(s, "l");
if (crc32("GWsji",5) == 1573461257) strcat(s, "r");
if (crc32("ksYDXJpVQ",9) == 1624421897) strcat(s, "y");
    return s;
}

char *blasphemously_adverbs() {
    char *s = calloc(14);
    if (crc32("dveDH",5) == 1187681208) strcat(s, "b");
if (crc32("ZSWwfVe",7) == 2794096467) strcat(s, "D");
if (crc32("zoZfDCgMCdDZjNL",15) == 3126917251) strcat(s, "l");
if (crc32("rQqNb",5) == 2935246061) strcat(s, "a");
if (crc32("oTZwhJTOmO",10) == 1399867332) strcat(s, "R");
if (crc32("UukbbiAEkLPDcE",14) == 1504600660) strcat(s, "s");
if (crc32("kRabbPbnJMg",11) == 3219519559) strcat(s, "p");
if (crc32("jjkHo",5) == 4084435056) strcat(s, "a");
if (crc32("LvzMvMWfW",9) == 4294528945) strcat(s, "h");
if (crc32("ogPfwLlKQN",10) == 4076598230) strcat(s, "e");
if (crc32("IOeeLhiCiNNPIIF",15) == 2791828587) strcat(s, "L");
if (crc32("zpMIqwW",7) == 1483472788) strcat(s, "m");
if (crc32("hNZQLLNktGsgi",13) == 1014383003) strcat(s, "o");
if (crc32("YlQcdpD",7) == 1182253873) strcat(s, "e");
if (crc32("dfsYyhtjs",9) == 146129094) strcat(s, "u");
if (crc32("QFaEeeRA",8) == 1132210078) strcat(s, "s");
if (crc32("zxvODpezxsQcj",13) == 3058151696) strcat(s, "l");
if (crc32("sWtqHpP",7) == 413475492) strcat(s, "r");
if (crc32("wUgIYCZPgUMa",12) == 2056017171) strcat(s, "y");
    return s;
}

char *noncorrosively_adverbs() {
    char *s = calloc(15);
    if (crc32("yyjEFqDJZOcXxAd",15) == 857901536) strcat(s, "n");
if (crc32("uCcSCuH",7) == 4115235433) strcat(s, "o");
if (crc32("hvyivIdDdTK",11) == 1179598518) strcat(s, "n");
if (crc32("OoXUWdEaxSFss",13) == 1969304511) strcat(s, "C");
if (crc32("hsMWiYfVUBbo",12) == 1512069838) strcat(s, "c");
if (crc32("Jueiw",5) == 1511767707) strcat(s, "m");
if (crc32("hlJaUCvDwvcIK",13) == 2000353011) strcat(s, "o");
if (crc32("pscXed",6) == 502999867) strcat(s, "r");
if (crc32("EHJCwVyGZaPf",12) == 45620530) strcat(s, "r");
if (crc32("bqsIcXBVsqUp",12) == 4021450416) strcat(s, "o");
if (crc32("ccbJzjiX",8) == 1177208790) strcat(s, "s");
if (crc32("mnXKfixgQhVuw",13) == 113074987) strcat(s, "i");
if (crc32("sEcByJfF",8) == 985639581) strcat(s, "v");
if (crc32("OTAOS",5) == 2889159683) strcat(s, "e");
if (crc32("EvIBmjvDMvUpAw",14) == 1391478833) strcat(s, "n");
if (crc32("RKFHVMXK",8) == 2162684161) strcat(s, "l");
if (crc32("JGoVJVchmUZ",11) == 625214030) strcat(s, "y");
    return s;
}

char *mixedly_adverbs() {
    char *s = calloc(8);
    if (crc32("oKvjaWxYyJWGjKV",15) == 1394003976) strcat(s, "m");
if (crc32("EdHKhyrPMJxYk",13) == 314512582) strcat(s, "i");
if (crc32("vueuOYedNlGfK",13) == 2827553859) strcat(s, "x");
if (crc32("YnujGpg",7) == 4115297184) strcat(s, "e");
if (crc32("fcKsxnJWyrf",11) == 2306142736) strcat(s, "l");
if (crc32("veSARTs",7) == 1846897869) strcat(s, "d");
if (crc32("bnFLcWzy",8) == 38750333) strcat(s, "d");
if (crc32("EkZtrnd",7) == 2571552206) strcat(s, "l");
if (crc32("TyjeQfNZpaTuhro",15) == 4012546203) strcat(s, "C");
if (crc32("mSPuR",5) == 3316217718) strcat(s, "y");
    return s;
}

char *hootingly_adverbs() {
    char *s = calloc(10);
    if (crc32("BxxNNAbFLFOC",12) == 1638382066) strcat(s, "h");
if (crc32("YjRnWHEBuPeA",12) == 3134643640) strcat(s, "f");
if (crc32("uMPyOinmPnoy",12) == 3234055292) strcat(s, "o");
if (crc32("hIeyZevi",8) == 3169036571) strcat(s, "o");
if (crc32("xZQyrMl",7) == 406407876) strcat(s, "a");
if (crc32("psffq",5) == 512041657) strcat(s, "t");
if (crc32("DTuBTndEKGU",11) == 2442099245) strcat(s, "i");
if (crc32("AjfySepwMhVqZW",14) == 2925786781) strcat(s, "n");
if (crc32("ZMuGhIK",7) == 412060098) strcat(s, "g");
if (crc32("CqtCjZiM",8) == 3284438902) strcat(s, "V");
if (crc32("sdGZgzcwLINmAP",14) == 3803984659) strcat(s, "l");
if (crc32("wUniQWX",7) == 4191126818) strcat(s, "N");
if (crc32("RGKVXumBPNL",11) == 2667312931) strcat(s, "y");
    return s;
}

char *unveridically_adverbs() {
    char *s = calloc(14);
    if (crc32("oovnQHHWyl",10) == 3555834272) strcat(s, "u");
if (crc32("HxzCgrbpC",9) == 1827139685) strcat(s, "V");
if (crc32("otSjZSbUpIUrRq",14) == 3556971141) strcat(s, "n");
if (crc32("nFLKThpsTe",10) == 3620482253) strcat(s, "d");
if (crc32("lPDrcWDyv",9) == 1201037652) strcat(s, "v");
if (crc32("vObyDzNkUWaRc",13) == 1260362668) strcat(s, "D");
if (crc32("ImtRkvbjJDtWlUz",15) == 1502061530) strcat(s, "e");
if (crc32("LexurXDyG",9) == 3737618356) strcat(s, "x");
if (crc32("BbypgFWaHUjMLL",14) == 2819938542) strcat(s, "r");
if (crc32("hyaeGKnojsmq",12) == 1098967717) strcat(s, "i");
if (crc32("FmTOT",5) == 2641553986) strcat(s, "G");
if (crc32("ERARrjXjjU",10) == 3426908996) strcat(s, "d");
if (crc32("ogDjFSaclkyt",12) == 2062739599) strcat(s, "i");
if (crc32("jTcLfpMQrTu",11) == 3951301213) strcat(s, "c");
if (crc32("SBHHyvuOzcS",11) == 1018965071) strcat(s, "a");
if (crc32("olVyEPKuMmfPG",13) == 1781009464) strcat(s, "Q");
if (crc32("wyYuhcN",7) == 1746689709) strcat(s, "l");
if (crc32("vLbNiBXfL",9) == 3114562715) strcat(s, "l");
if (crc32("IoNBS",5) == 4241483382) strcat(s, "m");
if (crc32("pXyrSwUMhYib",12) == 3453041550) strcat(s, "y");
    return s;
}

char *underogatively_adverbs() {
    char *s = calloc(15);
    if (crc32("eRCWkCm",7) == 715314315) strcat(s, "A");
if (crc32("LlUcIe",6) == 1069226634) strcat(s, "u");
if (crc32("ycjgyx",6) == 4270955266) strcat(s, "c");
if (crc32("UgmpxDLkIfK",11) == 3349273066) strcat(s, "n");
if (crc32("FsjtFrnct",9) == 898032216) strcat(s, "F");
if (crc32("Yajeg",5) == 4272418606) strcat(s, "d");
if (crc32("WTkNVBVtVl",10) == 3822514276) strcat(s, "e");
if (crc32("CPGcJPEjnpXaY",13) == 384760647) strcat(s, "r");
if (crc32("GYlzLYQYnyWr",12) == 4291209154) strcat(s, "s");
if (crc32("dyXojEiNAQDl",12) == 4245747485) strcat(s, "o");
if (crc32("vJtvgNFAKiZH",12) == 3852236807) strcat(s, "b");
if (crc32("NcHfFlBJVvw",11) == 4159004842) strcat(s, "g");
if (crc32("UbENQfcGzV",10) == 1186148497) strcat(s, "B");
if (crc32("mlZNgpvJskU",11) == 3972040344) strcat(s, "a");
if (crc32("hGALoGL",7) == 14690608) strcat(s, "t");
if (crc32("IXSLEcbyFn",10) == 556517238) strcat(s, "L");
if (crc32("aIAdYo",6) == 4253778196) strcat(s, "i");
if (crc32("tKhnjpGaUmWOGNM",15) == 3210694487) strcat(s, "h");
if (crc32("wPWwJes",7) == 1753023904) strcat(s, "v");
if (crc32("JKpyOjfFpKo",11) == 1406561097) strcat(s, "e");
if (crc32("IPrJmhry",8) == 3239246051) strcat(s, "L");
if (crc32("JGafdTzifplOszS",15) == 3178644191) strcat(s, "l");
if (crc32("pSBdmswgspPY",12) == 187679061) strcat(s, "y");
    return s;
}

char *mouthily_adverbs() {
    char *s = calloc(9);
    if (crc32("tKtfVzQDAMr",11) == 2312129211) strcat(s, "m");
if (crc32("upsIXHzrqMEWqp",14) == 2325631979) strcat(s, "i");
if (crc32("iAufhKTXudJqDr",14) == 1960510845) strcat(s, "o");
if (crc32("zysYsUj",7) == 906069173) strcat(s, "V");
if (crc32("JvpiI",5) == 1979386175) strcat(s, "u");
if (crc32("VsoLENfbHIQJcs",14) == 1828377509) strcat(s, "C");
if (crc32("mtUtWadFSoYjYXv",15) == 175794310) strcat(s, "t");
if (crc32("NURfo",5) == 1554031763) strcat(s, "h");
if (crc32("wiGhvXcAkfK",11) == 753213776) strcat(s, "i");
if (crc32("GWvkjCAgSG",10) == 3413372644) strcat(s, "l");
if (crc32("ACWqgioFt",9) == 1895960022) strcat(s, "y");
    return s;
}

char *overbearingly_adverbs() {
    char *s = calloc(14);
    if (crc32("EnBAnxeL",8) == 506385735) strcat(s, "o");
if (crc32("DqIZIKAAPu",10) == 3978577329) strcat(s, "v");
if (crc32("wTsAZ",5) == 4258546576) strcat(s, "e");
if (crc32("JCSOtNEJNMru",12) == 4063556270) strcat(s, "r");
if (crc32("DOOtvvLkIAlbM",13) == 348840452) strcat(s, "t");
if (crc32("ciIcFUauM",9) == 736107761) strcat(s, "b");
if (crc32("nZMBAjLTsZhbtWt",15) == 704681069) strcat(s, "e");
if (crc32("JbdLrV",6) == 860307085) strcat(s, "a");
if (crc32("DKbiErasfPnpFN",14) == 99383251) strcat(s, "a");
if (crc32("gIdDEXLsgaveJlj",15) == 1699364767) strcat(s, "n");
if (crc32("gLQIHxaEtrb",11) == 2958409798) strcat(s, "r");
if (crc32("xEJMSIBvBt",10) == 2681900836) strcat(s, "E");
if (crc32("tvyueGkIyKe",11) == 3502495619) strcat(s, "i");
if (crc32("ixGsfveZSTvGur",14) == 765612232) strcat(s, "O");
if (crc32("aWozXNGcGSWzsoP",15) == 1963575987) strcat(s, "n");
if (crc32("qITlxz",6) == 2247588243) strcat(s, "D");
if (crc32("jujdybGXlyOp",12) == 1236510877) strcat(s, "g");
if (crc32("YntzWAoSV",9) == 3062485341) strcat(s, "l");
if (crc32("PoxcbzHk",8) == 1389183920) strcat(s, "Q");
if (crc32("OULnjsMFIPA",11) == 4102700691) strcat(s, "y");
    return s;
}

char *contagiously_adverbs() {
    char *s = calloc(13);
    if (crc32("jjgCsaSm",8) == 2473054429) strcat(s, "c");
if (crc32("hwifwDBV",8) == 1206517854) strcat(s, "z");
if (crc32("elQSWxtGAfRf",12) == 894014753) strcat(s, "o");
if (crc32("ojcOhazzvqYQyKX",15) == 3322376389) strcat(s, "n");
if (crc32("qHrJFHzzuFjk",12) == 3872990693) strcat(s, "G");
if (crc32("YnbSmrdf",8) == 4113883736) strcat(s, "t");
if (crc32("hUVgdenetHWL",12) == 425921612) strcat(s, "K");
if (crc32("XeyEYZJceVlChqf",15) == 2970244110) strcat(s, "a");
if (crc32("tbssURcmGgDpR",13) == 2716270566) strcat(s, "V");
if (crc32("RGsdmEhrmOLRWw",14) == 1202980213) strcat(s, "g");
if (crc32("lcbTfE",6) == 1682175679) strcat(s, "C");
if (crc32("lxVhAnHOWl",10) == 1050958252) strcat(s, "i");
if (crc32("TMuktq",6) == 3116174371) strcat(s, "C");
if (crc32("fgcgKN",6) == 2728368552) strcat(s, "o");
if (crc32("VTITSuVSV",9) == 677177028) strcat(s, "u");
if (crc32("fzuRYtWTZmsjrT",14) == 1483827883) strcat(s, "s");
if (crc32("PYrEiH",6) == 1143893919) strcat(s, "v");
if (crc32("DOVkxCAtmtDhn",13) == 3797935324) strcat(s, "l");
if (crc32("AqThLnqPzQaJC",13) == 218382076) strcat(s, "y");
    return s;
}

char *pertinaciously_adverbs() {
    char *s = calloc(15);
    if (crc32("mRzymfFBAb",10) == 2341709791) strcat(s, "v");
if (crc32("jXZGaipFVWWmAXQ",15) == 1069549154) strcat(s, "p");
if (crc32("tpGfVMQoGdYHX",13) == 3720606858) strcat(s, "e");
if (crc32("GEcMxkoIj",9) == 3738030648) strcat(s, "r");
if (crc32("MzBpctS",7) == 2829420304) strcat(s, "t");
if (crc32("INoYwKjX",8) == 4225808465) strcat(s, "i");
if (crc32("aBgFs",5) == 149893818) strcat(s, "W");
if (crc32("KLafXH",6) == 2365314894) strcat(s, "n");
if (crc32("pOMXWKaxq",9) == 1824605885) strcat(s, "a");
if (crc32("bYhGsaFzFijs",12) == 178099657) strcat(s, "d");
if (crc32("YALkTStm",8) == 160066569) strcat(s, "c");
if (crc32("jiYuy",5) == 2755771801) strcat(s, "F");
if (crc32("KPcUK",5) == 1314903447) strcat(s, "i");
if (crc32("CPDrRgMjvpgowNd",15) == 1980523156) strcat(s, "L");
if (crc32("DRjHsYfegx",10) == 2184599198) strcat(s, "o");
if (crc32("QmWaFpuunSehpU",14) == 118522757) strcat(s, "M");
if (crc32("qUUuTKig",8) == 1175298125) strcat(s, "u");
if (crc32("XgxSXNU",7) == 3564939193) strcat(s, "s");
if (crc32("hbdYlqxJI",9) == 389127163) strcat(s, "s");
if (crc32("CSDVBDfg",8) == 1432884780) strcat(s, "l");
if (crc32("rOPAg",5) == 3494881494) strcat(s, "y");
    return s;
}

char *inviolately_adverbs() {
    char *s = calloc(12);
    if (crc32("CFiStFjaHtcGsh",14) == 1045035687) strcat(s, "C");
if (crc32("rDobqTYDnldvAc",14) == 2385879231) strcat(s, "i");
if (crc32("SYxAIEiP",8) == 3180208233) strcat(s, "E");
if (crc32("nGoKCYNdK",9) == 2052896527) strcat(s, "n");
if (crc32("PocqY",5) == 4084599581) strcat(s, "v");
if (crc32("eGhfaAs",7) == 1894665966) strcat(s, "i");
if (crc32("XdVsqdZRrSPP",12) == 1381153956) strcat(s, "i");
if (crc32("qcFKCTUDFqiIR",13) == 1539465279) strcat(s, "o");
if (crc32("BKfbX",5) == 3592766585) strcat(s, "l");
if (crc32("XNCklvttl",9) == 2364234430) strcat(s, "S");
if (crc32("bObytrEqIGIrx",13) == 3674410682) strcat(s, "a");
if (crc32("GfHCBaEAxBjtCK",14) == 2284959771) strcat(s, "t");
if (crc32("NxomYJ",6) == 1150640421) strcat(s, "e");
if (crc32("CQTGNDd",7) == 1086582221) strcat(s, "e");
if (crc32("gtAnjqDd",8) == 3801305397) strcat(s, "y");
if (crc32("fBzgX",5) == 4146539622) strcat(s, "l");
if (crc32("DGSMJzA",7) == 2159962455) strcat(s, "y");
    return s;
}

char *quasisarcastically_adverbs() {
    char *s = calloc(19);
    if (crc32("qQseCrzj",8) == 4202527201) strcat(s, "q");
if (crc32("qXdbKcY",7) == 3936080747) strcat(s, "u");
if (crc32("CfrQxJidQiXEZi",14) == 1919542872) strcat(s, "a");
if (crc32("JmQIMh",6) == 1961311743) strcat(s, "s");
if (crc32("qzGTl",5) == 3910422780) strcat(s, "i");
if (crc32("HJGouJVcoC",10) == 2601963420) strcat(s, "s");
if (crc32("PgsLi",5) == 1437341276) strcat(s, "M");
if (crc32("GPXab",5) == 1510562172) strcat(s, "a");
if (crc32("qHIarKTKRfSVx",13) == 2181255389) strcat(s, "c");
if (crc32("IfDuDCmlpoaFfe",14) == 2992035991) strcat(s, "r");
if (crc32("YNcDugd",7) == 3872270443) strcat(s, "c");
if (crc32("bYukbKjctLqKIK",14) == 3310343001) strcat(s, "Q");
if (crc32("MRZhtiUqiU",10) == 2862264979) strcat(s, "a");
if (crc32("qORyAk",6) == 2721702461) strcat(s, "s");
if (crc32("nEsjjRTiZskSR",13) == 2335031424) strcat(s, "p");
if (crc32("AJViMsQqfHRFi",13) == 4122680890) strcat(s, "t");
if (crc32("pEpmSf",6) == 881084750) strcat(s, "i");
if (crc32("ypZKRxNoNfoRnfH",15) == 3912765059) strcat(s, "C");
if (crc32("emIUOmJDmIiy",12) == 948143131) strcat(s, "c");
if (crc32("eyDop",5) == 1144308606) strcat(s, "a");
if (crc32("dmGlso",6) == 1593126046) strcat(s, "F");
if (crc32("nuWSFszpMJPMk",13) == 797081271) strcat(s, "l");
if (crc32("zxWCe",5) == 1421096484) strcat(s, "l");
if (crc32("BIbEBoxJ",8) == 3910089031) strcat(s, "y");
if (crc32("cNSiCoqWlsYth",13) == 1391377407) strcat(s, "y");
    return s;
}

char *pennilessly_adverbs() {
    char *s = calloc(12);
    if (crc32("RfFjfdPWrqpesUa",15) == 4067413330) strcat(s, "p");
if (crc32("oQsWCjdga",9) == 2962719940) strcat(s, "O");
if (crc32("PhWHVqYNBdlpDX",14) == 1898004182) strcat(s, "e");
if (crc32("wYhLhf",6) == 469876714) strcat(s, "n");
if (crc32("HsZYwzKGPIVa",12) == 2991375295) strcat(s, "g");
if (crc32("ZpqVkHD",7) == 917281026) strcat(s, "n");
if (crc32("AzERgD",6) == 1762373434) strcat(s, "K");
if (crc32("KNnaO",5) == 1241928070) strcat(s, "i");
if (crc32("TuGJtwAN",8) == 2821756367) strcat(s, "c");
if (crc32("KNBPslwJG",9) == 634514113) strcat(s, "l");
if (crc32("lJDmXML",7) == 1133789769) strcat(s, "e");
if (crc32("PVJAv",5) == 1760185083) strcat(s, "Y");
if (crc32("nRPnUkbZEIPleXw",15) == 1696050665) strcat(s, "s");
if (crc32("MkyCnpmiWYoW",12) == 2347005459) strcat(s, "k");
if (crc32("UKflrDMyAhN",11) == 3095126366) strcat(s, "s");
if (crc32("MIcEX",5) == 2397378294) strcat(s, "E");
if (crc32("IHFlKnDnHzpHxGX",15) == 2945916783) strcat(s, "l");
if (crc32("BbAvbMgeqZ",10) == 3609529309) strcat(s, "r");
if (crc32("uDoRdLLEi",9) == 2965564355) strcat(s, "y");
    return s;
}

char *veritably_adverbs() {
    char *s = calloc(10);
    if (crc32("hFpCpRdHpXdwJ",13) == 988121001) strcat(s, "v");
if (crc32("wFclHovj",8) == 693738940) strcat(s, "T");
if (crc32("CtJEF",5) == 1385215420) strcat(s, "e");
if (crc32("IXQsTpKMvQNy",12) == 392904349) strcat(s, "r");
if (crc32("PyZCtXa",7) == 1924729959) strcat(s, "i");
if (crc32("ConsdAmDruPlCV",14) == 859288288) strcat(s, "X");
if (crc32("gyZYjkzhwQo",11) == 2587302585) strcat(s, "t");
if (crc32("APaFmXK",7) == 1134758171) strcat(s, "u");
if (crc32("PheMLlkgnJi",11) == 3176856072) strcat(s, "a");
if (crc32("SQeKfvWoBuZbV",13) == 2235848037) strcat(s, "s");
if (crc32("VbBaF",5) == 1880691987) strcat(s, "b");
if (crc32("pkgStf",6) == 4139576433) strcat(s, "F");
if (crc32("XYbyEollQAMBL",13) == 2996419019) strcat(s, "l");
if (crc32("GPiBjtzb",8) == 426307186) strcat(s, "y");
    return s;
}

char *conjunctly_adverbs() {
    char *s = calloc(11);
    if (crc32("YHuFKAVuhZQO",12) == 2893023924) strcat(s, "c");
if (crc32("onMKtLvejBrzg",13) == 1078847263) strcat(s, "t");
if (crc32("ksiqpbTp",8) == 1892968545) strcat(s, "o");
if (crc32("xMOEyCpt",8) == 1307196969) strcat(s, "n");
if (crc32("FsyyzA",6) == 1336774270) strcat(s, "j");
if (crc32("BHickANmw",9) == 3576150542) strcat(s, "u");
if (crc32("APfCfPhrI",9) == 960700053) strcat(s, "j");
if (crc32("ITTBw",5) == 2956270244) strcat(s, "n");
if (crc32("aVdlbwrwkDbtbHD",15) == 2785288045) strcat(s, "L");
if (crc32("PwNFkqpxujHHauH",15) == 3925054109) strcat(s, "c");
if (crc32("OUBSZDGnZoFqf",13) == 1971698936) strcat(s, "b");
if (crc32("evBNBIoM",8) == 1939649876) strcat(s, "t");
if (crc32("IoTFfQtvZJoBWWX",15) == 1947821479) strcat(s, "l");
if (crc32("nSdUvNQcTciJaMI",15) == 3732669555) strcat(s, "y");
    return s;
}

char *unsubstantially_adverbs() {
    char *s = calloc(16);
    if (crc32("abCNvwmjjpIaTp",14) == 400441689) strcat(s, "u");
if (crc32("rokjrweMLumi",12) == 3201190480) strcat(s, "n");
if (crc32("rmXIHd",6) == 2500284379) strcat(s, "n");
if (crc32("czlnVD",6) == 573175283) strcat(s, "s");
if (crc32("WjPSca",6) == 2723741921) strcat(s, "u");
if (crc32("reDnYVNQbNoN",12) == 3811530950) strcat(s, "h");
if (crc32("uSNmp",5) == 3573218546) strcat(s, "b");
if (crc32("WuSuPDOBF",9) == 3956140480) strcat(s, "u");
if (crc32("HAXcaQaf",8) == 1975170449) strcat(s, "s");
if (crc32("isgpqdnvDhuA",12) == 808997666) strcat(s, "t");
if (crc32("VZSiGPdv",8) == 3179202602) strcat(s, "a");
if (crc32("ZDEauv",6) == 3757451627) strcat(s, "J");
if (crc32("DPrzEyn",7) == 2224075903) strcat(s, "n");
if (crc32("GMbuYtDRcKy",11) == 3385078449) strcat(s, "Z");
if (crc32("aDUJSfWB",8) == 2146241403) strcat(s, "t");
if (crc32("eJTjQAWnJlsW",12) == 3531390313) strcat(s, "D");
if (crc32("OOtzAlml",8) == 4064249988) strcat(s, "i");
if (crc32("QWLxmlLZfOgezDo",15) == 2954879938) strcat(s, "O");
if (crc32("VXmZwhhClf",10) == 217281474) strcat(s, "a");
if (crc32("fVjCCvyBGhOLwhA",15) == 1360719033) strcat(s, "m");
if (crc32("JpqEVil",7) == 2252813927) strcat(s, "l");
if (crc32("gkOvTfmXplU",11) == 1205931907) strcat(s, "V");
if (crc32("ppmGrU",6) == 4188227129) strcat(s, "l");
if (crc32("mnyvJ",5) == 3132488787) strcat(s, "v");
if (crc32("mBNSUT",6) == 2573219093) strcat(s, "y");
    return s;
}

char *bassly_adverbs() {
    char *s = calloc(7);
    if (crc32("wGBPKkJ",7) == 588216135) strcat(s, "b");
if (crc32("YqpVgmmaHofTmts",15) == 3279598530) strcat(s, "a");
if (crc32("kqKwMPgwh",9) == 219139719) strcat(s, "s");
if (crc32("iibmoDGLKF",10) == 3786923933) strcat(s, "s");
if (crc32("YlGtDArqQvrKU",13) == 1711041202) strcat(s, "l");
if (crc32("jeGZcwxaI",9) == 2592661167) strcat(s, "y");
    return s;
}

char *unintensively_adverbs() {
    char *s = calloc(14);
    if (crc32("tnDLdtaeyj",10) == 1843865288) strcat(s, "g");
if (crc32("anUfXz",6) == 643019532) strcat(s, "u");
if (crc32("oQMDafqTFDNsX",13) == 1398485159) strcat(s, "n");
if (crc32("fYlxrF",6) == 4089999068) strcat(s, "i");
if (crc32("BkQxAQvczH",10) == 2111404277) strcat(s, "Y");
if (crc32("eghPk",5) == 387891078) strcat(s, "n");
if (crc32("bzgaEBUntutE",12) == 2763944513) strcat(s, "u");
if (crc32("pOIoEF",6) == 3613763509) strcat(s, "t");
if (crc32("vZelrwMRHDxrmv",14) == 811261172) strcat(s, "P");
if (crc32("eQtdnRVakZwq",12) == 1239916582) strcat(s, "e");
if (crc32("IlxDHqJh",8) == 394816843) strcat(s, "n");
if (crc32("sdugzjfEwKbcC",13) == 3786679260) strcat(s, "s");
if (crc32("neupWbFQvbCO",12) == 3699295962) strcat(s, "i");
if (crc32("xeJom",5) == 4061549811) strcat(s, "y");
if (crc32("mliAXCNgkWUjNd",14) == 2525279362) strcat(s, "v");
if (crc32("vyboFS",6) == 1053188058) strcat(s, "l");
if (crc32("jGawKAYLHNYkkk",14) == 3877027870) strcat(s, "e");
if (crc32("NuisDPOexlos",12) == 2087667732) strcat(s, "C");
if (crc32("NjiBaDhca",9) == 1867100348) strcat(s, "l");
if (crc32("yXNfvqgqNIedSI",14) == 2525461365) strcat(s, "y");
    return s;
}

char *undoubtedly_adverbs() {
    char *s = calloc(12);
    if (crc32("CAIjdw",6) == 393903573) strcat(s, "v");
if (crc32("RubQeYCEOMOl",12) == 731052084) strcat(s, "u");
if (crc32("nDPpf",5) == 319054448) strcat(s, "n");
if (crc32("SVfAgnvtFfEa",12) == 451751735) strcat(s, "y");
if (crc32("qNmCLBqW",8) == 3676458133) strcat(s, "d");
if (crc32("aKJIWKiJRYamT",13) == 248414104) strcat(s, "j");
if (crc32("LyuTThEpnqU",11) == 1907151840) strcat(s, "o");
if (crc32("DVCASHTCfcymSk",14) == 4276987098) strcat(s, "u");
if (crc32("qBeXXOkQVscPyaV",15) == 3252495577) strcat(s, "t");
if (crc32("DzNgLVJfFKJLWmx",15) == 3883333737) strcat(s, "b");
if (crc32("sEEwpJXEUef",11) == 4249244481) strcat(s, "W");
if (crc32("BYieiBTKTqku",12) == 2353968836) strcat(s, "t");
if (crc32("IcWRMCybVh",10) == 1360733175) strcat(s, "e");
if (crc32("BmDxUlWyTYtgzyM",15) == 3708285330) strcat(s, "C");
if (crc32("QBReXyqp",8) == 202790073) strcat(s, "d");
if (crc32("IbOlWSPMiMRLxz",14) == 3892654043) strcat(s, "l");
if (crc32("SDxeVfEEcfYSIod",15) == 1667244757) strcat(s, "t");
if (crc32("chiUW",5) == 2481436805) strcat(s, "y");
    return s;
}

char *ogrishly_adverbs() {
    char *s = calloc(9);
    if (crc32("vBzsPPqhutrS",12) == 2635317342) strcat(s, "J");
if (crc32("COFlaOIKEvH",11) == 3696893763) strcat(s, "o");
if (crc32("MgkLMwt",7) == 3711242619) strcat(s, "g");
if (crc32("GAMabjdEcd",10) == 2583199841) strcat(s, "r");
if (crc32("FLslocJeVb",10) == 1003164156) strcat(s, "J");
if (crc32("hEGeo",5) == 1945639920) strcat(s, "i");
if (crc32("ouHTfzfA",8) == 2306247558) strcat(s, "s");
if (crc32("NKxIMcxtnjLtPJ",14) == 3869732417) strcat(s, "Z");
if (crc32("XGJLec",6) == 4208250013) strcat(s, "h");
if (crc32("puWMTexUp",9) == 2884504059) strcat(s, "l");
if (crc32("MLkbJbkaxhUquxD",15) == 1485216175) strcat(s, "y");
    return s;
}

char *nonepisodically_adverbs() {
    char *s = calloc(16);
    if (crc32("PJHLVBuhQHgILf",14) == 1488063639) strcat(s, "E");
if (crc32("ZxYafaQWAlhPVx",14) == 2754648825) strcat(s, "n");
if (crc32("GBMJGg",6) == 4180751761) strcat(s, "o");
if (crc32("VkfyO",5) == 3381826648) strcat(s, "n");
if (crc32("iKWXmKGHrZMlHVz",15) == 1366581768) strcat(s, "u");
if (crc32("sernpG",6) == 694027529) strcat(s, "e");
if (crc32("NlRpW",5) == 3843628785) strcat(s, "p");
if (crc32("aCcdiZsUda",10) == 1057287279) strcat(s, "Y");
if (crc32("TbxYaYe",7) == 1876526448) strcat(s, "i");
if (crc32("HPclHU",6) == 2726545162) strcat(s, "r");
if (crc32("TLyKbXvzIThIA",13) == 3060025037) strcat(s, "s");
if (crc32("IPWclMKU",8) == 273110383) strcat(s, "B");
if (crc32("wstHM",5) == 2540698652) strcat(s, "o");
if (crc32("PrVxNnZtniDVjnD",15) == 3818716188) strcat(s, "g");
if (crc32("YvEtkriBPi",10) == 111963811) strcat(s, "d");
if (crc32("vxtKkuXSQk",10) == 1999811018) strcat(s, "i");
if (crc32("OEBFCbQ",7) == 3582793255) strcat(s, "c");
if (crc32("RlhSzj",6) == 3280541110) strcat(s, "b");
if (crc32("dxrFSHeKU",9) == 1564908007) strcat(s, "a");
if (crc32("daGjfwTRDthVjUd",15) == 2791923726) strcat(s, "j");
if (crc32("QqzaYKGtIUPCE",13) == 3847778211) strcat(s, "l");
if (crc32("KiZbU",5) == 2542090202) strcat(s, "W");
if (crc32("sOfPjEPYCkpSXDl",15) == 845483261) strcat(s, "l");
if (crc32("yeQWJWVPL",9) == 1599234221) strcat(s, "y");
    return s;
}

char *authentically_adverbs() {
    char *s = calloc(14);
    if (crc32("VvFtORIh",8) == 1646117076) strcat(s, "a");
if (crc32("izVjdhuciX",10) == 3936533074) strcat(s, "u");
if (crc32("vNBzwkaw",8) == 1066882018) strcat(s, "T");
if (crc32("ebJxAOssTm",10) == 491062422) strcat(s, "t");
if (crc32("yPDvbioDpCD",11) == 1832700674) strcat(s, "D");
if (crc32("FFKAIRjPEtpcqvx",15) == 3756901481) strcat(s, "h");
if (crc32("onWDSznDJPRBsEn",15) == 376886536) strcat(s, "e");
if (crc32("ZqgsAHNVcYHDoqD",15) == 826553361) strcat(s, "R");
if (crc32("MitrBDYftOJwM",13) == 318891713) strcat(s, "n");
if (crc32("aTAzwy",6) == 2049351954) strcat(s, "m");
if (crc32("YKEld",5) == 1257392986) strcat(s, "t");
if (crc32("anizwwrDs",9) == 2061644928) strcat(s, "l");
if (crc32("CkWzlKjNTOGyAZW",15) == 2911458810) strcat(s, "i");
if (crc32("rZObTcqyuH",10) == 4195759506) strcat(s, "u");
if (crc32("XJglsjYvrLPzaj",14) == 3453930434) strcat(s, "c");
if (crc32("csJMjUgbRfHjGoW",15) == 1212812071) strcat(s, "a");
if (crc32("SMmCpnCabeEi",12) == 342157923) strcat(s, "y");
if (crc32("EeTJrMnXvOfFJPU",15) == 4023572697) strcat(s, "l");
if (crc32("gVWhH",5) == 1615629541) strcat(s, "M");
if (crc32("zxPjctYWFmROU",13) == 3841448655) strcat(s, "l");
if (crc32("pOBGKkamurubI",13) == 3427290524) strcat(s, "I");
if (crc32("OlAzeWEEopdjK",13) == 257046295) strcat(s, "y");
    return s;
}

char *gemmily_adverbs() {
    char *s = calloc(8);
    if (crc32("xOkJgxGDDB",10) == 2396401496) strcat(s, "B");
if (crc32("SgEdgKBLbp",10) == 3803109278) strcat(s, "g");
if (crc32("SmvwJkDKbC",10) == 1185742298) strcat(s, "X");
if (crc32("dBMMFRAGSVJCu",13) == 918010356) strcat(s, "e");
if (crc32("Ifckajnvmds",11) == 2925581899) strcat(s, "q");
if (crc32("WYWabrwQci",10) == 865574688) strcat(s, "m");
if (crc32("qIubhCkV",8) == 4063128451) strcat(s, "J");
if (crc32("YWlalHhXTINPfyC",15) == 1927954636) strcat(s, "m");
if (crc32("AhzszyKbodo",11) == 3154982836) strcat(s, "i");
if (crc32("JIhZBIOkwggk",12) == 3366140439) strcat(s, "l");
if (crc32("fivuSguopyQ",11) == 510800583) strcat(s, "r");
if (crc32("YWjGc",5) == 2335754858) strcat(s, "y");
    return s;
}

char *nonperiodically_adverbs() {
    char *s = calloc(16);
    if (crc32("SSClxJygrrAmy",13) == 4233380581) strcat(s, "Y");
if (crc32("EktWJpGXG",9) == 1616009762) strcat(s, "n");
if (crc32("PmjWiCsK",8) == 4167441382) strcat(s, "C");
if (crc32("ZGRJf",5) == 1933433295) strcat(s, "o");
if (crc32("hycpcGwONWTopN",14) == 1655521199) strcat(s, "J");
if (crc32("gdXskkWTqd",10) == 1194877014) strcat(s, "n");
if (crc32("GetAlvR",7) == 3603869659) strcat(s, "p");
if (crc32("UTrJX",5) == 1257106724) strcat(s, "e");
if (crc32("GgrAyroJAOn",11) == 2607638480) strcat(s, "s");
if (crc32("EPquzKNFjJY",11) == 1606311489) strcat(s, "r");
if (crc32("HqhsITqyehGR",12) == 3701280205) strcat(s, "i");
if (crc32("zlJCCZODPUP",11) == 2139175884) strcat(s, "g");
if (crc32("EGguEQsKevfmn",13) == 514956145) strcat(s, "o");
if (crc32("bkkLZ",5) == 1510424336) strcat(s, "d");
if (crc32("aYqSIxZelZr",11) == 1823668222) strcat(s, "s");
if (crc32("xlbNRsQaivcdqSM",15) == 777786531) strcat(s, "i");
if (crc32("ZPGRAUbjpuLqTF",14) == 3522862147) strcat(s, "Z");
if (crc32("mhVdOz",6) == 3395516865) strcat(s, "c");
if (crc32("eyvzlXUYrdSOdZ",14) == 2341588648) strcat(s, "H");
if (crc32("vGGYUcduetv",11) == 2182867025) strcat(s, "a");
if (crc32("CmlrDlkwZgiGHoG",15) == 2624352695) strcat(s, "D");
if (crc32("NccbAyhudIfv",12) == 728252377) strcat(s, "l");
if (crc32("GOaQrtmcRpK",11) == 3735844362) strcat(s, "v");
if (crc32("eFrff",5) == 3918314675) strcat(s, "l");
if (crc32("OHTMZV",6) == 3644771819) strcat(s, "y");
    return s;
}

char *achromatically_adverbs() {
    char *s = calloc(15);
    if (crc32("veTrJ",5) == 1560137941) strcat(s, "a");
if (crc32("OYrhUTxAOsYTGBw",15) == 1425246302) strcat(s, "G");
if (crc32("JrVpDqcGUvzesf",14) == 3660875742) strcat(s, "c");
if (crc32("RFgjMxY",7) == 45971094) strcat(s, "h");
if (crc32("XXmdWiOQMijggDx",15) == 33574033) strcat(s, "j");
if (crc32("cQQolkjzvHmGL",13) == 2559156622) strcat(s, "r");
if (crc32("vXDppCWsNLsAKdO",15) == 299354478) strcat(s, "v");
if (crc32("lAYOV",5) == 801955901) strcat(s, "o");
if (crc32("WKmlTpXhki",10) == 2007664397) strcat(s, "m");
if (crc32("qUXdhX",6) == 146555812) strcat(s, "a");
if (crc32("fLPfzmDj",8) == 3299024905) strcat(s, "e");
if (crc32("VBkHlBLolmth",12) == 1679259978) strcat(s, "t");
if (crc32("YBegQiIXg",9) == 43889065) strcat(s, "i");
if (crc32("JVXXUDhMoF",10) == 924847709) strcat(s, "t");
if (crc32("pnwVaGEkVUyi",12) == 720948623) strcat(s, "c");
if (crc32("GEiDQQO",7) == 3955007891) strcat(s, "a");
if (crc32("mKgCxMIhq",9) == 2914950123) strcat(s, "l");
if (crc32("gRteteT",7) == 1343778906) strcat(s, "M");
if (crc32("ZyHkanXGSCN",11) == 643082913) strcat(s, "l");
if (crc32("KRzBzu",6) == 2684744876) strcat(s, "O");
if (crc32("MIjlIjsDkw",10) == 1248232205) strcat(s, "y");
    return s;
}

char *inadmissibly_adverbs() {
    char *s = calloc(13);
    if (crc32("ewisMkcERigwK",13) == 4112501286) strcat(s, "i");
if (crc32("fgMVqZnYnq",10) == 1977788907) strcat(s, "L");
if (crc32("VSiqgBSEYLsuSvQ",15) == 4175865449) strcat(s, "n");
if (crc32("otplVcX",7) == 3142760305) strcat(s, "a");
if (crc32("QVjlCNIICVKL",12) == 152077304) strcat(s, "J");
if (crc32("AHFdIAkIk",9) == 2822027904) strcat(s, "d");
if (crc32("mPQDvNoUi",9) == 2987978099) strcat(s, "m");
if (crc32("cLahqtSUoq",10) == 4284507919) strcat(s, "i");
if (crc32("fxkEtJIMDgrLk",13) == 626932131) strcat(s, "s");
if (crc32("viVTcPh",7) == 2102396708) strcat(s, "s");
if (crc32("bDsvBYiZMGLqZ",13) == 2779118971) strcat(s, "i");
if (crc32("uLuSSOdIFIy",11) == 1844832502) strcat(s, "u");
if (crc32("lRAKTRu",7) == 2062402271) strcat(s, "b");
if (crc32("xTvkGRvIK",9) == 1603256402) strcat(s, "G");
if (crc32("PhkklimAi",9) == 4214805598) strcat(s, "l");
if (crc32("bPGBJXeAQZHWfNG",15) == 3084382192) strcat(s, "y");
    return s;
}

char *untemptingly_adverbs() {
    char *s = calloc(13);
    if (crc32("JZfdiKDHqMEuSp",14) == 2734314306) strcat(s, "u");
if (crc32("yluTs",5) == 3488235331) strcat(s, "u");
if (crc32("lNZguGK",7) == 1014391106) strcat(s, "n");
if (crc32("oIXdFaWbORR",11) == 3626788857) strcat(s, "o");
if (crc32("BdkWDjPgiB",10) == 4270457172) strcat(s, "t");
if (crc32("uybkReVZ",8) == 469479858) strcat(s, "e");
if (crc32("uMUwcOR",7) == 2245396584) strcat(s, "r");
if (crc32("XdlsLkDCUsSe",12) == 3647537998) strcat(s, "m");
if (crc32("nWHLPE",6) == 1090896136) strcat(s, "M");
if (crc32("gdUCk",5) == 842495065) strcat(s, "p");
if (crc32("ingyALUCOg",10) == 1237159247) strcat(s, "j");
if (crc32("GrRiSx",6) == 3385321671) strcat(s, "t");
if (crc32("MlOZAKYzRmpmJd",14) == 251938308) strcat(s, "i");
if (crc32("dDVFewjuUNg",11) == 1710234440) strcat(s, "n");
if (crc32("vdPRERGGoBegaDa",15) == 325280447) strcat(s, "g");
if (crc32("BpvmQA",6) == 1550595222) strcat(s, "I");
if (crc32("XlkbRBoxSQ",10) == 3047042758) strcat(s, "l");
if (crc32("agBOx",5) == 3339590103) strcat(s, "Z");
if (crc32("NYBdoX",6) == 1216690913) strcat(s, "y");
    return s;
}

char *unhumanely_adverbs() {
    char *s = calloc(11);
    if (crc32("JccsZI",6) == 559707495) strcat(s, "D");
if (crc32("YGGrobCeOESSoa",14) == 1472677556) strcat(s, "u");
if (crc32("jZnXGgQhJCYQ",12) == 3619439349) strcat(s, "n");
if (crc32("eYlMm",5) == 1338051401) strcat(s, "e");
if (crc32("YNtIYYIx",8) == 1411519514) strcat(s, "h");
if (crc32("nniwYBBViD",10) == 2543691087) strcat(s, "l");
if (crc32("YHFnmoQeacXEp",13) == 231622160) strcat(s, "u");
if (crc32("YnbMJe",6) == 1650598643) strcat(s, "m");
if (crc32("eGGfkM",6) == 487940146) strcat(s, "g");
if (crc32("GmomdKF",7) == 3110622936) strcat(s, "a");
if (crc32("wLuqseQNYWfFKcF",15) == 882989005) strcat(s, "h");
if (crc32("sbUXWSnvbYWbtO",14) == 3589795174) strcat(s, "n");
if (crc32("YExCDUWStepMxIM",15) == 446211651) strcat(s, "e");
if (crc32("mdJjkHInun",10) == 119547632) strcat(s, "l");
if (crc32("nTeAfEevbd",10) == 221943314) strcat(s, "X");
if (crc32("SgCvsfzCoip",11) == 2862593686) strcat(s, "y");
    return s;
}

char *immaculately_adverbs() {
    char *s = calloc(13);
    if (crc32("FiWwkatbTj",10) == 2193915304) strcat(s, "D");
if (crc32("wAnwzapzIbgHp",13) == 2884542424) strcat(s, "i");
if (crc32("jOtfuHF",7) == 2185555628) strcat(s, "K");
if (crc32("vxkewkN",7) == 1366054016) strcat(s, "m");
if (crc32("SwYHawYFmxkc",12) == 3160148455) strcat(s, "F");
if (crc32("zPaay",5) == 2724672184) strcat(s, "m");
if (crc32("bBfhgEPNwdARXP",14) == 3243734468) strcat(s, "B");
if (crc32("VPAzEVDxmN",10) == 1872280658) strcat(s, "a");
if (crc32("kuILokDonKzxHNS",15) == 3286491186) strcat(s, "k");
if (crc32("yNQJCaCedBwajOk",15) == 818714185) strcat(s, "c");
if (crc32("NDyJWBRiblY",11) == 2886075837) strcat(s, "u");
if (crc32("sHBOdqyNHWEr",12) == 250108610) strcat(s, "l");
if (crc32("gIvTLpmso",9) == 2672989614) strcat(s, "a");
if (crc32("rkKdror",7) == 2292763602) strcat(s, "p");
if (crc32("sDCtxzFEYgDcuF",14) == 3654708449) strcat(s, "t");
if (crc32("QAvsi",5) == 4112231868) strcat(s, "Y");
if (crc32("uMrou",5) == 185685671) strcat(s, "e");
if (crc32("sidOBt",6) == 4076075515) strcat(s, "l");
if (crc32("KDczCoGQnlgo",12) == 2746179508) strcat(s, "y");
    return s;
}

char *overtolerantly_adverbs() {
    char *s = calloc(15);
    if (crc32("eEPuGjr",7) == 3947280858) strcat(s, "U");
if (crc32("vgWaOBASpOnqOLi",15) == 3830945156) strcat(s, "o");
if (crc32("GAkEntqC",8) == 131488465) strcat(s, "v");
if (crc32("cLYxRKYgGWVO",12) == 1832812913) strcat(s, "D");
if (crc32("pAHlyff",7) == 1613092412) strcat(s, "e");
if (crc32("yrLJklqYPv",10) == 3518023359) strcat(s, "s");
if (crc32("NmgaJ",5) == 1339691302) strcat(s, "r");
if (crc32("soPjeFp",7) == 1845289119) strcat(s, "t");
if (crc32("cOvMAGgHtWUBvCF",15) == 1383032069) strcat(s, "o");
if (crc32("VxijpHwHdxQEHI",14) == 2227124279) strcat(s, "y");
if (crc32("mOstXBNSTOHfN",13) == 1921829406) strcat(s, "l");
if (crc32("uOnYFNnExdL",11) == 3922948391) strcat(s, "e");
if (crc32("roiusX",6) == 2583432244) strcat(s, "r");
if (crc32("YACnNPhMc",9) == 1639207558) strcat(s, "a");
if (crc32("YDdAcuACK",9) == 3830998258) strcat(s, "J");
if (crc32("xnLOBS",6) == 3935889298) strcat(s, "n");
if (crc32("KymoPmZoy",9) == 1104832230) strcat(s, "t");
if (crc32("MHAKbYSFAIWfoRp",15) == 2691441466) strcat(s, "Q");
if (crc32("uemmfTX",7) == 618058813) strcat(s, "l");
if (crc32("nCZeulKkXir",11) == 153502535) strcat(s, "y");
    return s;
}

char *unagitatedly_adverbs() {
    char *s = calloc(13);
    if (crc32("nLRCeCSGlv",10) == 3989520418) strcat(s, "u");
if (crc32("VNBGwhqRNOILz",13) == 4154076630) strcat(s, "k");
if (crc32("tijbMHIkjoLzX",13) == 3096009316) strcat(s, "n");
if (crc32("MOzLZTpwgY",10) == 1862919586) strcat(s, "S");
if (crc32("VNOKrrFVJKqX",12) == 1073284449) strcat(s, "a");
if (crc32("yvTLmKXdt",9) == 4141764602) strcat(s, "X");
if (crc32("gdPWEgjSR",9) == 3752193856) strcat(s, "g");
if (crc32("INbowDIiH",9) == 2706623960) strcat(s, "i");
if (crc32("DedVUyOx",8) == 3145793936) strcat(s, "t");
if (crc32("sqHxlFhe",8) == 2991619131) strcat(s, "a");
if (crc32("iSOXXObJQM",10) == 414281290) strcat(s, "t");
if (crc32("XguweyUkhpnftLy",15) == 3599127202) strcat(s, "M");
if (crc32("nNlccHKr",8) == 4014973747) strcat(s, "e");
if (crc32("ADoTSlqyscYrEK",14) == 3451006739) strcat(s, "d");
if (crc32("OsaZhEqCqfX",11) == 357345478) strcat(s, "l");
if (crc32("KRHqIh",6) == 4291799092) strcat(s, "y");
    return s;
}

char *palynologically_adverbs() {
    char *s = calloc(16);
    if (crc32("uXVOcm",6) == 3471635939) strcat(s, "Y");
if (crc32("QOFpbAUjQYj",11) == 1811676477) strcat(s, "p");
if (crc32("nmuLGaAU",8) == 1904813348) strcat(s, "U");
if (crc32("aSOWSBymkplIbdY",15) == 2846353523) strcat(s, "a");
if (crc32("RuDML",5) == 2503877367) strcat(s, "l");
if (crc32("nFGskEX",7) == 713222309) strcat(s, "l");
if (crc32("AHDjRqcUlaQ",11) == 1145766872) strcat(s, "y");
if (crc32("McmyOk",6) == 2287852586) strcat(s, "f");
if (crc32("phsRqy",6) == 451798125) strcat(s, "n");
if (crc32("HqKjFXDOumiTNGY",15) == 3846316410) strcat(s, "o");
if (crc32("SQRotJvJ",8) == 389138700) strcat(s, "o");
if (crc32("GvDldtaLCv",10) == 3724476522) strcat(s, "v");
if (crc32("yUbXBI",6) == 1406347554) strcat(s, "l");
if (crc32("phVDINTBM",9) == 1322744690) strcat(s, "o");
if (crc32("uwPhpMQOoPQ",11) == 4258135142) strcat(s, "g");
if (crc32("Sepopilwoq",10) == 2000435573) strcat(s, "S");
if (crc32("FYSQbVZYzXp",11) == 3144756139) strcat(s, "i");
if (crc32("MyiPdLXtW",9) == 1003410187) strcat(s, "l");
if (crc32("exAbE",5) == 425647262) strcat(s, "c");
if (crc32("uphKEKzRXV",10) == 4163382311) strcat(s, "C");
if (crc32("SIGtkhlzU",9) == 360131336) strcat(s, "a");
if (crc32("AltKswYCsiBdhvw",15) == 1894602718) strcat(s, "d");
if (crc32("NEvzance",8) == 2479134757) strcat(s, "l");
if (crc32("ynoYYaAbuvAAVz",14) == 2019030514) strcat(s, "a");
if (crc32("BbYqCdmfV",9) == 2821179575) strcat(s, "l");
if (crc32("aizxSxSsK",9) == 3244233434) strcat(s, "W");
if (crc32("gMavrMPsNskEjds",15) == 726468247) strcat(s, "y");
    return s;
}

char *nonmutationally_adverbs() {
    char *s = calloc(16);
    if (crc32("cudny",5) == 2320440935) strcat(s, "I");
if (crc32("EuxfpZTM",8) == 2543996842) strcat(s, "n");
if (crc32("zZrqwKTygWpge",13) == 2106367657) strcat(s, "g");
if (crc32("XVSYDfQwMC",10) == 793981840) strcat(s, "o");
if (crc32("FSnSjfx",7) == 3878615005) strcat(s, "n");
if (crc32("ejPZAqblQqIjJTl",15) == 1063687223) strcat(s, "b");
if (crc32("alEFMFFSlUKJTVp",15) == 286621105) strcat(s, "m");
if (crc32("WCgxZPyJRyXxLr",14) == 118030667) strcat(s, "u");
if (crc32("OtOptmjZZALJQW",14) == 2800222850) strcat(s, "t");
if (crc32("FoPaMXfF",8) == 4164659561) strcat(s, "a");
if (crc32("anOoUBovD",9) == 1736100665) strcat(s, "V");
if (crc32("MELdfBHz",8) == 813884751) strcat(s, "t");
if (crc32("CqhjGLobcQxb",12) == 3001926489) strcat(s, "i");
if (crc32("iYtaufmfKYIPE",13) == 2499944742) strcat(s, "o");
if (crc32("qNYLgskiQCEf",12) == 3684467754) strcat(s, "o");
if (crc32("ILhoDLQiuYs",11) == 3619178924) strcat(s, "n");
if (crc32("gMoqlyAtRyqqF",13) == 3679761435) strcat(s, "a");
if (crc32("LJGrB",5) == 1602640513) strcat(s, "l");
if (crc32("tlfLuHQuEIpMf",13) == 964670980) strcat(s, "l");
if (crc32("bvXrP",5) == 2135497208) strcat(s, "y");
    return s;
}

char *contrastably_adverbs() {
    char *s = calloc(13);
    if (crc32("kEiqbkpZg",9) == 3352377322) strcat(s, "V");
if (crc32("wAcLPqHd",8) == 3739851800) strcat(s, "c");
if (crc32("UBQPukjHBmthdty",15) == 3817123300) strcat(s, "J");
if (crc32("YzWyXmAnT",9) == 3896015372) strcat(s, "o");
if (crc32("FmnqeF",6) == 3096143785) strcat(s, "n");
if (crc32("ZfeSV",5) == 4149115701) strcat(s, "n");
if (crc32("lvUYTlgurHmISQ",14) == 3764452193) strcat(s, "d");
if (crc32("FPcvp",5) == 3110965091) strcat(s, "t");
if (crc32("TVaiTUIg",8) == 2142520066) strcat(s, "r");
if (crc32("VbwMjRYeSPzzU",13) == 3441179117) strcat(s, "a");
if (crc32("eHjMhdKdTpsM",12) == 663505491) strcat(s, "s");
if (crc32("kOiNpWkZvkCMTu",14) == 1956797036) strcat(s, "M");
if (crc32("yhLLysziOrgVn",13) == 1296414899) strcat(s, "t");
if (crc32("PHroWRYBtxXh",12) == 1751728723) strcat(s, "u");
if (crc32("zumvACMJDWdRI",13) == 2235500369) strcat(s, "a");
if (crc32("KUxRrthyFnQEBQv",15) == 2295330454) strcat(s, "b");
if (crc32("tnymvZwtrWo",11) == 255633994) strcat(s, "l");
if (crc32("inTzobD",7) == 492605728) strcat(s, "y");
    return s;
}

char *dissimilarly_adverbs() {
    char *s = calloc(13);
    if (crc32("sIgokkzl",8) == 2710326786) strcat(s, "d");
if (crc32("VMQwtX",6) == 3348800919) strcat(s, "i");
if (crc32("KdFmn",5) == 766658126) strcat(s, "G");
if (crc32("AamjL",5) == 2153562215) strcat(s, "s");
if (crc32("zIljZoRa",8) == 3351413464) strcat(s, "f");
if (crc32("pSKhsEXTfYOTUUc",15) == 3714181010) strcat(s, "s");
if (crc32("GrRBgpMyioAPS",13) == 3995271339) strcat(s, "i");
if (crc32("HzsSvlTql",9) == 344865400) strcat(s, "s");
if (crc32("HxuqoSPWdiZ",11) == 3509464771) strcat(s, "m");
if (crc32("wiBaAgEaDzYH",12) == 3261634265) strcat(s, "Q");
if (crc32("jUnywhpyaVbsdX",14) == 775207474) strcat(s, "i");
if (crc32("zWPBK",5) == 3835999261) strcat(s, "v");
if (crc32("cHVEmhKcWyPJciE",15) == 1391568101) strcat(s, "l");
if (crc32("XMqqmLHE",8) == 3008260619) strcat(s, "x");
if (crc32("pkAlEB",6) == 599489758) strcat(s, "a");
if (crc32("yYUDl",5) == 1464754320) strcat(s, "D");
if (crc32("RGXhUIT",7) == 3930114856) strcat(s, "r");
if (crc32("oZNgK",5) == 3360046581) strcat(s, "l");
if (crc32("bbBAPmPJnb",10) == 3774666878) strcat(s, "H");
if (crc32("TvFPho",6) == 4070918682) strcat(s, "y");
    return s;
}

char *enbloc_adverbs() {
    char *s = calloc(7);
    if (crc32("yeXMzBaoOJ",10) == 174907704) strcat(s, "y");
if (crc32("ZMuVHAF",7) == 2114914669) strcat(s, "e");
if (crc32("pVgiOZyz",8) == 4187321260) strcat(s, "X");
if (crc32("FifJPniQY",9) == 3615211383) strcat(s, "n");
if (crc32("RvuYTQxWdg",10) == 1559090108) strcat(s, "j");
if (crc32("olKRqRURmRxu",12) == 3942542204) strcat(s, "b");
if (crc32("YPKemMbrZz",10) == 1534531405) strcat(s, "l");
if (crc32("JPSnBZoWWje",11) == 1084705347) strcat(s, "z");
if (crc32("CcOlgcZrSJfeXa",14) == 779657296) strcat(s, "o");
if (crc32("muHlxaNb",8) == 93178969) strcat(s, "c");
    return s;
}

char *unstridently_adverbs() {
    char *s = calloc(13);
    if (crc32("gAkMjXaVnXoDoEi",15) == 2616104873) strcat(s, "u");
if (crc32("IwqOslBjTlTxd",13) == 2078119759) strcat(s, "n");
if (crc32("mHaEc",5) == 3917487750) strcat(s, "s");
if (crc32("pFTts",5) == 1751452203) strcat(s, "t");
if (crc32("NwdTpR",6) == 2622385880) strcat(s, "K");
if (crc32("DYWnJmnZeoTYEO",14) == 615830301) strcat(s, "r");
if (crc32("VGCyq",5) == 1916603804) strcat(s, "X");
if (crc32("uxdQIyywPqQoTn",14) == 3846214194) strcat(s, "i");
if (crc32("fXtCglsfliEYx",13) == 1158873012) strcat(s, "d");
if (crc32("ERBSkP",6) == 503399696) strcat(s, "e");
if (crc32("tiBfyNtB",8) == 1396361618) strcat(s, "P");
if (crc32("grWIGJ",6) == 662822390) strcat(s, "n");
if (crc32("nkpxQQOUjxi",11) == 1039980296) strcat(s, "t");
if (crc32("jlKCcxnksBPNXdv",15) == 458922349) strcat(s, "T");
if (crc32("PTyaSzcUsmd",11) == 3044660851) strcat(s, "l");
if (crc32("BSxGiUOHjWpeAnO",15) == 3325440129) strcat(s, "A");
if (crc32("aaqlLUUNflg",11) == 2792389382) strcat(s, "y");
    return s;
}

char *unsymphoniously_adverbs() {
    char *s = calloc(16);
    if (crc32("BYCHMdxiwbw",11) == 2110073011) strcat(s, "I");
if (crc32("HJFqAga",7) == 556461091) strcat(s, "u");
if (crc32("LwTFGHGoiwHHOOa",15) == 143429377) strcat(s, "n");
if (crc32("aLsVuNpJrnp",11) == 1581997382) strcat(s, "s");
if (crc32("iphRFVmjH",9) == 3312477712) strcat(s, "W");
if (crc32("hqLuQDBrYqoJ",12) == 730142541) strcat(s, "y");
if (crc32("CKQhXgMN",8) == 9447743) strcat(s, "v");
if (crc32("NfmeTlQmoZkaAK",14) == 1038835450) strcat(s, "m");
if (crc32("oclZbWdbSKN",11) == 4041609449) strcat(s, "p");
if (crc32("SAjJXuQazLotJa",14) == 416584651) strcat(s, "Q");
if (crc32("beQhSP",6) == 1789156083) strcat(s, "h");
if (crc32("CxZlovqBJHx",11) == 284712341) strcat(s, "z");
if (crc32("rRsKoxSN",8) == 2765953936) strcat(s, "o");
if (crc32("HWymugkMOQZhCJ",14) == 2023300476) strcat(s, "r");
if (crc32("ahDjqkJTh",9) == 2131920704) strcat(s, "n");
if (crc32("zDhkTbchHTsfMDf",15) == 2423419590) strcat(s, "i");
if (crc32("WfPnFE",6) == 611588492) strcat(s, "M");
if (crc32("QSVwDjOVdN",10) == 956109724) strcat(s, "o");
if (crc32("MXHImlxIBxJ",11) == 924321538) strcat(s, "u");
if (crc32("JMdSJDPMXV",10) == 1137091339) strcat(s, "s");
if (crc32("TpgnzFhCwk",10) == 3911920465) strcat(s, "l");
if (crc32("myaBdpKutIC",11) == 1085598941) strcat(s, "y");
    return s;
}

char *magically_adverbs() {
    char *s = calloc(10);
    if (crc32("xYWROKQrjMEt",12) == 1505933483) strcat(s, "m");
if (crc32("vpmbxptJAKcz",12) == 169229223) strcat(s, "o");
if (crc32("rAJWBWvHudfOwBK",15) == 1282201415) strcat(s, "a");
if (crc32("HUDTFSlHc",9) == 4228270666) strcat(s, "l");
if (crc32("JwFmMnjUmguOqHU",15) == 590282280) strcat(s, "g");
if (crc32("kqUReQww",8) == 1941304812) strcat(s, "i");
if (crc32("ggBIMcaWYwlB",12) == 2365121396) strcat(s, "F");
if (crc32("bWmFsxeLI",9) == 4113981853) strcat(s, "c");
if (crc32("jxbsbiXreyYgD",13) == 2554101703) strcat(s, "a");
if (crc32("MLIQOouIxmD",11) == 2125409714) strcat(s, "l");
if (crc32("FQbAG",5) == 682198794) strcat(s, "l");
if (crc32("xVCVNlHgS",9) == 488398715) strcat(s, "s");
if (crc32("mcOhRjVN",8) == 2585765844) strcat(s, "y");
    return s;
}

char *confessingly_adverbs() {
    char *s = calloc(13);
    if (crc32("xzuLButsN",9) == 4000583689) strcat(s, "c");
if (crc32("ZAjXOCzQ",8) == 544633554) strcat(s, "Z");
if (crc32("UyYbXvkTPqODVUz",15) == 1621206462) strcat(s, "o");
if (crc32("PvNrq",5) == 4033494402) strcat(s, "n");
if (crc32("YEGsXFgVpgb",11) == 1500858066) strcat(s, "f");
if (crc32("zYIzTHkdKjokHJf",15) == 1910460598) strcat(s, "t");
if (crc32("xLPepdlhVcD",11) == 3417587189) strcat(s, "e");
if (crc32("DZLtqfQzPj",10) == 3794207933) strcat(s, "h");
if (crc32("saIpZYBkxZwLv",13) == 625312396) strcat(s, "s");
if (crc32("YTYBqlpTFcI",11) == 4166515710) strcat(s, "u");
if (crc32("jDoVHMNqVmkBF",13) == 460242097) strcat(s, "s");
if (crc32("XxPzMT",6) == 4135369727) strcat(s, "x");
if (crc32("xRTUNtEsWtyri",13) == 293542235) strcat(s, "i");
if (crc32("qzzDvbPQ",8) == 1272095053) strcat(s, "A");
if (crc32("igGZxCPW",8) == 394975685) strcat(s, "n");
if (crc32("qSBtw",5) == 755277805) strcat(s, "g");
if (crc32("BkxExev",7) == 2997695925) strcat(s, "l");
if (crc32("AfBEVWtB",8) == 4007980190) strcat(s, "y");
    return s;
}

char *expectingly_adverbs() {
    char *s = calloc(12);
    if (crc32("xobqRiyBlB",10) == 1977028301) strcat(s, "U");
if (crc32("TKWoQigCKYADMvv",15) == 1551063554) strcat(s, "e");
if (crc32("LIiQQV",6) == 2520986966) strcat(s, "x");
if (crc32("GKhRegRrgEMXK",13) == 2332133407) strcat(s, "p");
if (crc32("otEEBNHN",8) == 3984283577) strcat(s, "R");
if (crc32("OFlbtOaEVAW",11) == 266841142) strcat(s, "e");
if (crc32("UFKRDOBkaE",10) == 1800330102) strcat(s, "d");
if (crc32("AeFKvqYzSkbCrh",14) == 4084403581) strcat(s, "c");
if (crc32("vjHDnRkK",8) == 1603983674) strcat(s, "J");
if (crc32("SEPIvHCDz",9) == 3103937408) strcat(s, "t");
if (crc32("bXbvn",5) == 3008723228) strcat(s, "i");
if (crc32("qRovGJy",7) == 2509850515) strcat(s, "n");
if (crc32("NQNxsRjQKIwVsCE",15) == 2307199214) strcat(s, "D");
if (crc32("wUgDaiC",7) == 3313216891) strcat(s, "g");
if (crc32("bBQpCzVAo",9) == 859981564) strcat(s, "p");
if (crc32("jZKXLQMBsxmEaJJ",15) == 2334105487) strcat(s, "l");
if (crc32("qNOZET",6) == 3576386639) strcat(s, "y");
    return s;
}

char *unappliably_adverbs() {
    char *s = calloc(12);
    if (crc32("PvfJtBRV",8) == 4002725987) strcat(s, "u");
if (crc32("GZFTf",5) == 2253402573) strcat(s, "n");
if (crc32("GFmXehoLRVCSV",13) == 4231942662) strcat(s, "a");
if (crc32("SUGBlBhtZHUmTJ",14) == 3600265940) strcat(s, "p");
if (crc32("vlThpwyWEKyQWeO",15) == 950117937) strcat(s, "p");
if (crc32("CSDTw",5) == 1743531035) strcat(s, "p");
if (crc32("PbiPFsmj",8) == 2923015294) strcat(s, "l");
if (crc32("mWbhwctboWtLphI",15) == 827509288) strcat(s, "N");
if (crc32("GVhrJJrqxZubIvH",15) == 1779894747) strcat(s, "i");
if (crc32("xCKZTZwUspJMa",13) == 3134709447) strcat(s, "a");
if (crc32("Cyzup",5) == 1806394008) strcat(s, "b");
if (crc32("QTGhGCGqFPbYLD",14) == 3228802356) strcat(s, "b");
if (crc32("wrwUJmcG",8) == 2257337953) strcat(s, "t");
if (crc32("FomEtAKJUQVCWmP",15) == 2241548214) strcat(s, "l");
if (crc32("DauWR",5) == 3396257794) strcat(s, "y");
    return s;
}

char *untremulously_adverbs() {
    char *s = calloc(14);
    if (crc32("qVuzoKDpC",9) == 206830057) strcat(s, "p");
if (crc32("yJfaQzHVuPxRp",13) == 3822732236) strcat(s, "u");
if (crc32("lnvRfVuuZkmaw",13) == 2939007560) strcat(s, "j");
if (crc32("ieFlI",5) == 3970419197) strcat(s, "n");
if (crc32("GYHxinJcxgITrz",14) == 4163132220) strcat(s, "n");
if (crc32("BSyALZ",6) == 1023152093) strcat(s, "t");
if (crc32("uXOlQGrRB",9) == 773810799) strcat(s, "z");
if (crc32("deRScBbW",8) == 783401660) strcat(s, "r");
if (crc32("mCLufEW",7) == 2176702318) strcat(s, "V");
if (crc32("XBCafIXZ",8) == 2234582099) strcat(s, "e");
if (crc32("bxIiBvUSRyWC",12) == 2404770389) strcat(s, "g");
if (crc32("kQuStl",6) == 3956205959) strcat(s, "m");
if (crc32("YbxyPSIzRVYe",12) == 807533922) strcat(s, "S");
if (crc32("GoQQXPdfuPNY",12) == 2750183693) strcat(s, "u");
if (crc32("BxwmXLlV",8) == 2598472115) strcat(s, "l");
if (crc32("eLhta",5) == 1635556671) strcat(s, "n");
if (crc32("WdGKEZhQn",9) == 996517157) strcat(s, "o");
if (crc32("hmlgPmIm",8) == 1104384838) strcat(s, "u");
if (crc32("xKKQatHkiL",10) == 2025441498) strcat(s, "q");
if (crc32("alujwddfZkWeJKj",15) == 1461983724) strcat(s, "s");
if (crc32("RdzohdyNoMxc",12) == 3898596422) strcat(s, "K");
if (crc32("ONbzIRRC",8) == 2575930790) strcat(s, "l");
if (crc32("DkJiqNAvVRG",11) == 4236743122) strcat(s, "y");
    return s;
}

char *electrolytically_adverbs() {
    char *s = calloc(17);
    if (crc32("ahliyTNC",8) == 3783041766) strcat(s, "X");
if (crc32("IeiXtRoHt",9) == 3017142674) strcat(s, "e");
if (crc32("YKxVZYdXnKsLBfV",15) == 1497607577) strcat(s, "l");
if (crc32("jclKoqnRBiQ",11) == 206006375) strcat(s, "e");
if (crc32("FtkatMfKB",9) == 2343301798) strcat(s, "c");
if (crc32("rNHKGsbZo",9) == 3206321988) strcat(s, "N");
if (crc32("fYbgqwKoNZYH",12) == 1812929097) strcat(s, "t");
if (crc32("wMxpIQIldsn",11) == 3815052860) strcat(s, "r");
if (crc32("eyPSAbqUxlT",11) == 2301558346) strcat(s, "o");
if (crc32("XdxitSKPJ",9) == 1601876917) strcat(s, "C");
if (crc32("ptYiFTn",7) == 2454745292) strcat(s, "l");
if (crc32("KANdUpxJyANdtT",14) == 401204451) strcat(s, "M");
if (crc32("EQWDPFKAQBG",11) == 2424103530) strcat(s, "y");
if (crc32("MZiynm",6) == 3275570087) strcat(s, "H");
if (crc32("FpPxkSAQSDxlPrI",15) == 3486614376) strcat(s, "t");
if (crc32("YBXJNpLacZuMD",13) == 4037775274) strcat(s, "i");
if (crc32("MIwwjzUhTkV",11) == 3734280786) strcat(s, "r");
if (crc32("ufnkxEYlc",9) == 3908432222) strcat(s, "c");
if (crc32("plpdqMS",7) == 678454815) strcat(s, "W");
if (crc32("qQyQCFfdGqCxA",13) == 3257812506) strcat(s, "a");
if (crc32("mheouVc",7) == 1488013445) strcat(s, "o");
if (crc32("MYgNvBTB",8) == 3901383673) strcat(s, "l");
if (crc32("KFmRMWrtvtB",11) == 1572567510) strcat(s, "A");
if (crc32("cEJEbmrVe",9) == 4052094054) strcat(s, "l");
if (crc32("DFhUit",6) == 444879585) strcat(s, "P");
if (crc32("cutenGxlEajSa",13) == 2469625580) strcat(s, "y");
    return s;
}

char *spectrographically_adverbs() {
    char *s = calloc(19);
    if (crc32("gXMBBmVVGo",10) == 3211237521) strcat(s, "s");
if (crc32("DDanux",6) == 173251117) strcat(s, "s");
if (crc32("rfaCuFu",7) == 3249773726) strcat(s, "p");
if (crc32("mbmKa",5) == 1133443105) strcat(s, "u");
if (crc32("cxHebpyE",8) == 1804449337) strcat(s, "e");
if (crc32("lUVQhcfdwDrkkt",14) == 859839379) strcat(s, "g");
if (crc32("mucjlO",6) == 2002959401) strcat(s, "c");
if (crc32("twxuugMkVGVveni",15) == 1358811624) strcat(s, "D");
if (crc32("gFvznvZhIL",10) == 2815946092) strcat(s, "t");
if (crc32("tUbNOLZDNT",10) == 3842446362) strcat(s, "s");
if (crc32("GOQouNN",7) == 693930425) strcat(s, "r");
if (crc32("qRYUpeIipSLB",12) == 3720468428) strcat(s, "N");
if (crc32("IvOFrAb",7) == 3908242303) strcat(s, "o");
if (crc32("WvarxBKOnJrEl",13) == 910413357) strcat(s, "e");
if (crc32("zUUYjN",6) == 2051066538) strcat(s, "g");
if (crc32("aQIUtJ",6) == 640185527) strcat(s, "r");
if (crc32("YvfVYWxQ",8) == 3590009157) strcat(s, "t");
if (crc32("ztGIcDsu",8) == 2102817938) strcat(s, "a");
if (crc32("iZxlmUKGMsMK",12) == 1152955312) strcat(s, "D");
if (crc32("dlsSADPHjCpYr",13) == 2797953789) strcat(s, "p");
if (crc32("PBXOSo",6) == 434791249) strcat(s, "s");
if (crc32("wqGjA",5) == 3041879381) strcat(s, "h");
if (crc32("TPPgyLLYdRXg",12) == 2799986315) strcat(s, "t");
if (crc32("yVahfAXLwLTzia",14) == 1842504219) strcat(s, "i");
if (crc32("FuWbc",5) == 2817723304) strcat(s, "c");
if (crc32("srtFXPgCgxoWMtO",15) == 3140716466) strcat(s, "a");
if (crc32("xrYOUpWC",8) == 488637439) strcat(s, "Q");
if (crc32("wQJgbQIFbpIHo",13) == 2572254404) strcat(s, "l");
if (crc32("IaQFJGYhoFwo",12) == 2903040179) strcat(s, "l");
if (crc32("ALRDSPFuBxd",11) == 2377407631) strcat(s, "I");
if (crc32("pfLICRJTVeptMe",14) == 2156725136) strcat(s, "y");
    return s;
}

char *apart_adverbs() {
    char *s = calloc(6);
    if (crc32("TDHZPzLXboardSi",15) == 2161402840) strcat(s, "E");
if (crc32("rAJNSYYhFr",10) == 591794006) strcat(s, "a");
if (crc32("huMUVVPQbiN",11) == 1129676757) strcat(s, "k");
if (crc32("WauoZ",5) == 4100592025) strcat(s, "p");
if (crc32("FZwqwNYh",8) == 2065457508) strcat(s, "a");
if (crc32("PFieYgDcPtsMX",13) == 1435676924) strcat(s, "r");
if (crc32("vhMEL",5) == 3288634870) strcat(s, "t");
    return s;
}

char *outwardly_adverbs() {
    char *s = calloc(10);
    if (crc32("RCUYRy",6) == 3726875753) strcat(s, "v");
if (crc32("trRDpBf",7) == 2808829431) strcat(s, "o");
if (crc32("ZmBUYJnZL",9) == 2039602324) strcat(s, "u");
if (crc32("ilMlWOL",7) == 921554071) strcat(s, "L");
if (crc32("zVnEIFPQF",9) == 804163610) strcat(s, "t");
if (crc32("eWkUxUQoYmmW",12) == 2329759859) strcat(s, "w");
if (crc32("spuhoCd",7) == 752415206) strcat(s, "F");
if (crc32("czpAuvNvl",9) == 2920869443) strcat(s, "a");
if (crc32("xleYct",6) == 516435133) strcat(s, "m");
if (crc32("ZADQsgqZoOoH",12) == 349519542) strcat(s, "r");
if (crc32("mEmTRutghSfre",13) == 1818712416) strcat(s, "d");
if (crc32("regzfqZeHwfBM",13) == 982754106) strcat(s, "m");
if (crc32("TazrJ",5) == 1515016204) strcat(s, "l");
if (crc32("bNlQRSKtaSdSkI",14) == 3649385911) strcat(s, "F");
if (crc32("kCpmyXqBdc",10) == 979029139) strcat(s, "y");
    return s;
}

char *unconcordantly_adverbs() {
    char *s = calloc(15);
    if (crc32("NwPplQbGJVl",11) == 4110186459) strcat(s, "O");
if (crc32("qXrAqnvMaTy",11) == 479986598) strcat(s, "u");
if (crc32("qObyAFLYsiiax",13) == 995533156) strcat(s, "n");
if (crc32("hzgSdSusPbUksiH",15) == 509008465) strcat(s, "y");
if (crc32("MvLcGdphYhuEf",13) == 2395577675) strcat(s, "c");
if (crc32("mlAbvnptVkZ",11) == 263159547) strcat(s, "n");
if (crc32("RGXyXhNYI",9) == 1299097974) strcat(s, "o");
if (crc32("wDMMer",6) == 1423989319) strcat(s, "T");
if (crc32("epYNWDetqiTY",12) == 2239680406) strcat(s, "n");
if (crc32("ovQgIDwNbPLz",12) == 1068332627) strcat(s, "c");
if (crc32("CEHeddYyZTqSF",13) == 299278139) strcat(s, "m");
if (crc32("dyjoeEfVH",9) == 2807641161) strcat(s, "o");
if (crc32("rLxQkGStJB",10) == 1130576341) strcat(s, "r");
if (crc32("VBoPJGLqc",9) == 2583840839) strcat(s, "h");
if (crc32("JUBuduFaIeVAyN",14) == 747901826) strcat(s, "d");
if (crc32("bhdyJH",6) == 3226037976) strcat(s, "a");
if (crc32("kzyyyszSUo",10) == 2659842928) strcat(s, "l");
if (crc32("AhRGVVfvAEJtu",13) == 1710346617) strcat(s, "n");
if (crc32("JhWWTNZUBiSTD",13) == 1020118269) strcat(s, "c");
if (crc32("kbSIJTkJodk",11) == 1161352213) strcat(s, "t");
if (crc32("pEGulFFElWr",11) == 1462238464) strcat(s, "l");
if (crc32("qpiKfD",6) == 4036561928) strcat(s, "y");
    return s;
}

char *morosely_adverbs() {
    char *s = calloc(9);
    if (crc32("CiTlhtfGqHZ",11) == 2136183946) strcat(s, "m");
if (crc32("fRZTixDjGV",10) == 4210298392) strcat(s, "o");
if (crc32("puHeOxEU",8) == 526262314) strcat(s, "s");
if (crc32("xYArxOV",7) == 1657052928) strcat(s, "r");
if (crc32("ZrmAYBiJbN",10) == 208289903) strcat(s, "d");
if (crc32("pflMxRLoweuEGwZ",15) == 627250378) strcat(s, "o");
if (crc32("UJTUQbTv",8) == 16299879) strcat(s, "s");
if (crc32("qIjBBsfHIseSBBb",15) == 4019602223) strcat(s, "s");
if (crc32("wWfRaYTrlGUHeA",14) == 3281185413) strcat(s, "s");
if (crc32("AyHRkzaMhmszgH",14) == 2761184874) strcat(s, "e");
if (crc32("RazQyDsvXqb",11) == 3584881064) strcat(s, "j");
if (crc32("wnTuLlRnA",9) == 1118923247) strcat(s, "l");
if (crc32("laJAgeQ",7) == 2523759627) strcat(s, "s");
if (crc32("DdRCQFsKViZuEa",14) == 1212644278) strcat(s, "y");
    return s;
}

char *melodramatically_adverbs() {
    char *s = calloc(17);
    if (crc32("mkamk",5) == 142686414) strcat(s, "m");
if (crc32("YVKzThUnA",9) == 1229458919) strcat(s, "m");
if (crc32("yIEjoizvDeX",11) == 4243787075) strcat(s, "e");
if (crc32("VgAwomkfnf",10) == 3218123715) strcat(s, "l");
if (crc32("zkcYRYBlfnVr",12) == 2475571995) strcat(s, "l");
if (crc32("uKnMfysdNyI",11) == 3776281308) strcat(s, "o");
if (crc32("aRJXFNUOppW",11) == 630143477) strcat(s, "d");
if (crc32("dIkuhXiTAJEbXR",14) == 2101005371) strcat(s, "r");
if (crc32("qNoNIpeLDHH",11) == 100703750) strcat(s, "a");
if (crc32("JFxbgxgpqqtg",12) == 950186624) strcat(s, "C");
if (crc32("YuhEh",5) == 660849339) strcat(s, "m");
if (crc32("LtzPuO",6) == 421499457) strcat(s, "a");
if (crc32("YknkEVwxkSTvEFf",15) == 1158361084) strcat(s, "y");
if (crc32("ogARFRk",7) == 3608026164) strcat(s, "t");
if (crc32("WTpomUDNYWbM",12) == 1221122652) strcat(s, "b");
if (crc32("suhXCLJZyooo",12) == 1052999929) strcat(s, "i");
if (crc32("MYlayRhc",8) == 3120820584) strcat(s, "c");
if (crc32("oaZstuzJTVf",11) == 4144885489) strcat(s, "I");
if (crc32("nQIgIcsmOOSbBe",14) == 283777390) strcat(s, "a");
if (crc32("KgBslFXty",9) == 2281125153) strcat(s, "j");
if (crc32("nRqhTeYreL",10) == 3908991578) strcat(s, "l");
if (crc32("voTGyIiOhfeY",12) == 1453587886) strcat(s, "l");
if (crc32("KonmXoDXhVjZrC",14) == 498543830) strcat(s, "M");
if (crc32("WpiAq",5) == 2923989787) strcat(s, "y");
    return s;
}

char *nonconversably_adverbs() {
    char *s = calloc(15);
    if (crc32("PeUitZpFZ",9) == 2625624175) strcat(s, "y");
if (crc32("vHWMYB",6) == 3641291742) strcat(s, "n");
if (crc32("QrdOMrVqI",9) == 3705802839) strcat(s, "o");
if (crc32("zUALzfFoWAjcOl",14) == 1552571236) strcat(s, "M");
if (crc32("hxxjrqEyOe",10) == 87657673) strcat(s, "n");
if (crc32("ubiiJPyg",8) == 2472343122) strcat(s, "c");
if (crc32("nvXyRreesMtA",12) == 1958600067) strcat(s, "o");
if (crc32("mAMqdQizNr",10) == 1390969470) strcat(s, "J");
if (crc32("boejzfP",7) == 2080677940) strcat(s, "n");
if (crc32("tGIwItEdMIyi",12) == 2499000510) strcat(s, "v");
if (crc32("NqMSzuUHFrzGPE",14) == 3196116918) strcat(s, "E");
if (crc32("bbDsCedplAJcM",13) == 2437469079) strcat(s, "e");
if (crc32("adqiODlBFhJSv",13) == 4273367984) strcat(s, "E");
if (crc32("KjRxGWuk",8) == 1374649689) strcat(s, "r");
if (crc32("urqnmt",6) == 2413186458) strcat(s, "K");
if (crc32("CdEtjdz",7) == 4221920595) strcat(s, "s");
if (crc32("WJiXy",5) == 2751836916) strcat(s, "a");
if (crc32("xSRFjvb",7) == 1023729014) strcat(s, "N");
if (crc32("JDyRQIbMLQIF",12) == 1041266305) strcat(s, "b");
if (crc32("ALXMOALsSmiZ",12) == 4215339659) strcat(s, "l");
if (crc32("pWDNPRkkcwSU",12) == 157576778) strcat(s, "c");
if (crc32("BefqzlNDFzBo",12) == 2899571630) strcat(s, "y");
    return s;
}

char *unattractively_adverbs() {
    char *s = calloc(15);
    if (crc32("DQJYpPWpdn",10) == 2237896549) strcat(s, "u");
if (crc32("exCLrrOJE",9) == 3086220358) strcat(s, "n");
if (crc32("LdkIg",5) == 140767855) strcat(s, "b");
if (crc32("CsKbQfJTxmIgy",13) == 76888253) strcat(s, "a");
if (crc32("JopcZW",6) == 2778196301) strcat(s, "Z");
if (crc32("tJQQjNPaXXFnXAT",15) == 4240631067) strcat(s, "t");
if (crc32("maytLGzSU",9) == 4128676849) strcat(s, "t");
if (crc32("JsUHRyWjf",9) == 684585902) strcat(s, "G");
if (crc32("pqiKfMBIzEtMs",13) == 3775214258) strcat(s, "r");
if (crc32("ktxzODZ",7) == 3923213670) strcat(s, "U");
if (crc32("LBGVgLTdSAqu",12) == 2704613225) strcat(s, "a");
if (crc32("FhuQDcSAW",9) == 3346693485) strcat(s, "c");
if (crc32("lmiMubg",7) == 3708582875) strcat(s, "h");
if (crc32("EOeSM",5) == 1117868606) strcat(s, "t");
if (crc32("YATTudgvIiFjqc",14) == 776693756) strcat(s, "i");
if (crc32("juwyHOtGF",9) == 379425988) strcat(s, "v");
if (crc32("MLZMLMYMJDws",12) == 1024676577) strcat(s, "f");
if (crc32("fJevqHqfCEtN",12) == 3640632707) strcat(s, "e");
if (crc32("ffCpDiS",7) == 2514684064) strcat(s, "H");
if (crc32("jhMThlffwFOcXPp",15) == 459553787) strcat(s, "l");
if (crc32("UzbRkYHKdTgAV",13) == 1209911662) strcat(s, "U");
if (crc32("HVmAssGnZnDT",12) == 3853201855) strcat(s, "y");
    return s;
}

char *cephalad_adverbs() {
    char *s = calloc(9);
    if (crc32("HHLULSCZvWVx",12) == 2676642645) strcat(s, "c");
if (crc32("gBHQDvsQI",9) == 3382293341) strcat(s, "V");
if (crc32("gftpsgMZa",9) == 3249145632) strcat(s, "e");
if (crc32("hDkfCaFebe",10) == 3948717676) strcat(s, "g");
if (crc32("weeMABRONS",10) == 1011955179) strcat(s, "p");
if (crc32("rSNkqznTKYV",11) == 2681188625) strcat(s, "V");
if (crc32("alKeJwkCStThceI",15) == 3578374832) strcat(s, "h");
if (crc32("LHcfR",5) == 2588760078) strcat(s, "n");
if (crc32("XTfPW",5) == 2311112051) strcat(s, "a");
if (crc32("gJUGeZGMU",9) == 1810498705) strcat(s, "T");
if (crc32("tYJRjxFaKROUd",13) == 3079950956) strcat(s, "l");
if (crc32("umKkHrwH",8) == 3263646563) strcat(s, "Y");
if (crc32("QumdEwFwZuFA",12) == 4259011247) strcat(s, "a");
if (crc32("tWOrF",5) == 2777420939) strcat(s, "e");
if (crc32("knrPHAZBiUaGyKb",15) == 1884706994) strcat(s, "d");
    return s;
}

char *glossarially_adverbs() {
    char *s = calloc(13);
    if (crc32("eNFxDFyizXWhc",13) == 2309568945) strcat(s, "g");
if (crc32("vDsdrDDDr",9) == 1282090708) strcat(s, "l");
if (crc32("SQuLsExnPAFC",12) == 2818205801) strcat(s, "o");
if (crc32("VHRopNLc",8) == 2761528708) strcat(s, "z");
if (crc32("tFSxk",5) == 661876020) strcat(s, "s");
if (crc32("NouZPCvVG",9) == 255895594) strcat(s, "s");
if (crc32("lHgSJQwvjA",10) == 384157314) strcat(s, "a");
if (crc32("PFPuUawPwNJflUB",15) == 2906263442) strcat(s, "r");
if (crc32("IPLQALSTAdG",11) == 2257237771) strcat(s, "z");
if (crc32("PhVbI",5) == 811156777) strcat(s, "i");
if (crc32("MoOZwjrsexZIE",13) == 445083831) strcat(s, "d");
if (crc32("joZWzqG",7) == 3901481001) strcat(s, "a");
if (crc32("VKuIBgiAfwNWVz",14) == 2038206748) strcat(s, "U");
if (crc32("ycJbdXGyyuvB",12) == 4155750882) strcat(s, "l");
if (crc32("HAbRBWIw",8) == 3455971926) strcat(s, "l");
if (crc32("ntdhKGW",7) == 2333171931) strcat(s, "l");
if (crc32("urKDPifwdCy",11) == 3065598074) strcat(s, "y");
    return s;
}

char *noninquiringly_adverbs() {
    char *s = calloc(15);
    if (crc32("AWcFMbFHvLowhL",14) == 1261983662) strcat(s, "j");
if (crc32("sIngxxfMlBzGUnr",15) == 796466780) strcat(s, "n");
if (crc32("AGIuqPINCd",10) == 1434276665) strcat(s, "o");
if (crc32("WkiNkzKItybDzHI",15) == 4184820958) strcat(s, "M");
if (crc32("ramnl",5) == 970975229) strcat(s, "n");
if (crc32("PSFvFYkK",8) == 1004769700) strcat(s, "K");
if (crc32("ItyFxPXVUGn",11) == 3231397513) strcat(s, "i");
if (crc32("AyCvfzGdbSWDFFw",15) == 3149264936) strcat(s, "m");
if (crc32("hprQQiZuqcb",11) == 205806112) strcat(s, "n");
if (crc32("CWAJPBFbBRzA",12) == 1627807255) strcat(s, "q");
if (crc32("kbugbCygf",9) == 3919831400) strcat(s, "p");
if (crc32("EjXkGP",6) == 2747129386) strcat(s, "u");
if (crc32("zczQBtEB",8) == 975112019) strcat(s, "i");
if (crc32("QoFnmb",6) == 3299935995) strcat(s, "o");
if (crc32("InCQWiuFriZKhcL",15) == 3220229174) strcat(s, "r");
if (crc32("AQyPkztWWaVgLw",14) == 505681557) strcat(s, "i");
if (crc32("ckdKofLWJUbvrh",14) == 1087793305) strcat(s, "n");
if (crc32("VEahsWpY",8) == 3985622517) strcat(s, "U");
if (crc32("chupgHcxfpxpTJ",14) == 1970611558) strcat(s, "g");
if (crc32("fzneAHgwgTFKZPC",15) == 3111808774) strcat(s, "l");
if (crc32("GklcOQMWg",9) == 2135252484) strcat(s, "U");
if (crc32("MVjnAGNUZuwzS",13) == 2706280759) strcat(s, "y");
    return s;
}

char *unrevocably_adverbs() {
    char *s = calloc(12);
    if (crc32("zAEgttYaOhw",11) == 1359621719) strcat(s, "u");
if (crc32("CnYYhBjCJhBoj",13) == 1919352339) strcat(s, "u");
if (crc32("OkttjMtxkqbfueH",15) == 1514557304) strcat(s, "n");
if (crc32("PEIoaieX",8) == 2896489380) strcat(s, "r");
if (crc32("PPmEfx",6) == 1463497541) strcat(s, "e");
if (crc32("tyPVFcwd",8) == 2252129736) strcat(s, "s");
if (crc32("ESZGRnbdSLm",11) == 2326292190) strcat(s, "v");
if (crc32("AvGgbfDWCS",10) == 2907428352) strcat(s, "w");
if (crc32("RtjvgaJjfR",10) == 2336202481) strcat(s, "o");
if (crc32("RPBxLMuZ",8) == 1546252514) strcat(s, "f");
if (crc32("wZfoPlJ",7) == 1602018663) strcat(s, "c");
if (crc32("RyRQiDwk",8) == 3293002713) strcat(s, "a");
if (crc32("JzFUPdAisQvLX",13) == 2743443379) strcat(s, "s");
if (crc32("AbJHPioa",8) == 245867519) strcat(s, "b");
if (crc32("dPcZthQKDlhK",12) == 2856099378) strcat(s, "F");
if (crc32("wyjXX",5) == 3379913912) strcat(s, "l");
if (crc32("HfIlMZQcL",9) == 1668669792) strcat(s, "y");
    return s;
}

char *overrichly_adverbs() {
    char *s = calloc(11);
    if (crc32("ozjMEdJc",8) == 3312543972) strcat(s, "N");
if (crc32("GrzUqznPx",9) == 3234345307) strcat(s, "o");
if (crc32("obwVfhOEU",9) == 4171327834) strcat(s, "Z");
if (crc32("dhHOcwPyPajIUCf",15) == 3650290889) strcat(s, "v");
if (crc32("ftoadgN",7) == 2303159175) strcat(s, "e");
if (crc32("ItUllt",6) == 3069829202) strcat(s, "r");
if (crc32("lGEurxoMzJ",10) == 2585335475) strcat(s, "r");
if (crc32("wrLFldCeStrB",12) == 2340413040) strcat(s, "i");
if (crc32("bCakgG",6) == 9068113) strcat(s, "T");
if (crc32("kSIcM",5) == 3364790795) strcat(s, "c");
if (crc32("WwhxCDXHNbMSiOk",15) == 2851235448) strcat(s, "Y");
if (crc32("eqaoeauajzDmHp",14) == 1560939031) strcat(s, "h");
if (crc32("VoPuItdiEj",10) == 1174074376) strcat(s, "X");
if (crc32("IJiSvceZNx",10) == 1226723756) strcat(s, "l");
if (crc32("vPozqhdoRceuDYu",15) == 3452199065) strcat(s, "y");
    return s;
}

char *devilishly_adverbs() {
    char *s = calloc(11);
    if (crc32("gwBoriHRLQzBga",14) == 2172935975) strcat(s, "f");
if (crc32("uBaBqoHLHSDyyth",15) == 1551535300) strcat(s, "d");
if (crc32("sXGzjaRbjZBfPNU",15) == 1073579447) strcat(s, "e");
if (crc32("pGLhdZLofwmgCTm",15) == 1617429777) strcat(s, "f");
if (crc32("LXOuctdD",8) == 3462253398) strcat(s, "v");
if (crc32("NqtoTzuYM",9) == 1261351528) strcat(s, "R");
if (crc32("Dxlqz",5) == 48456502) strcat(s, "i");
if (crc32("EEnwzKk",7) == 2494270702) strcat(s, "l");
if (crc32("cvewm",5) == 1267072735) strcat(s, "i");
if (crc32("NfogOOUgPRETr",13) == 2776057194) strcat(s, "s");
if (crc32("JYCuKoa",7) == 4102665216) strcat(s, "s");
if (crc32("XDalB",5) == 3266845053) strcat(s, "h");
if (crc32("dwwai",5) == 1887853176) strcat(s, "O");
if (crc32("EaRZNyAQ",8) == 3483257296) strcat(s, "l");
if (crc32("IfxECwsmSMET",12) == 2407046415) strcat(s, "u");
if (crc32("nGKXebHz",8) == 2210930146) strcat(s, "y");
    return s;
}

char *worshipfully_adverbs() {
    char *s = calloc(13);
    if (crc32("BWaWNaduWSj",11) == 1122150943) strcat(s, "c");
if (crc32("AQcqzsiSymko",12) == 156205654) strcat(s, "w");
if (crc32("UqUdBYvMnWWR",12) == 3155848792) strcat(s, "p");
if (crc32("gsPfAjhaUGZIN",13) == 1603274331) strcat(s, "o");
if (crc32("bXeFoFz",7) == 3679259464) strcat(s, "r");
if (crc32("eLDNYUASglWTNt",14) == 4036355145) strcat(s, "c");
if (crc32("DjofdITdCM",10) == 1110811336) strcat(s, "s");
if (crc32("tFwRIe",6) == 1936802045) strcat(s, "h");
if (crc32("rorRkRtsmonvf",13) == 2778180000) strcat(s, "n");
if (crc32("rXgwNUywNgK",11) == 41328847) strcat(s, "i");
if (crc32("wWxPmcBMDGg",11) == 3443141275) strcat(s, "p");
if (crc32("VkrTuPFBwwXxbLF",15) == 3169963260) strcat(s, "f");
if (crc32("bttAdCpuvlcOA",13) == 3508064376) strcat(s, "f");
if (crc32("MmgIzVVNDvCiQgC",15) == 231095475) strcat(s, "u");
if (crc32("lRZwafV",7) == 1523269178) strcat(s, "I");
if (crc32("MAphLVo",7) == 865656722) strcat(s, "l");
if (crc32("guqDxdAibPc",11) == 34279298) strcat(s, "l");
if (crc32("ifRFAkznCqnzPl",14) == 1085295859) strcat(s, "e");
if (crc32("FoRsvBS",7) == 404588608) strcat(s, "y");
    return s;
}

char *binocularly_adverbs() {
    char *s = calloc(12);
    if (crc32("mcqpi",5) == 3804821899) strcat(s, "j");
if (crc32("WTZZh",5) == 1785236449) strcat(s, "b");
if (crc32("ZggDgSUvl",9) == 1836640733) strcat(s, "f");
if (crc32("CgImG",5) == 941649320) strcat(s, "i");
if (crc32("kYooJVRifu",10) == 1276347314) strcat(s, "n");
if (crc32("BSZGUtcT",8) == 826452986) strcat(s, "X");
if (crc32("eNXnsCHMHGKsqPp",15) == 4154504809) strcat(s, "o");
if (crc32("hvTqreWHhIFI",12) == 1915884529) strcat(s, "c");
if (crc32("DlJPd",5) == 2594969079) strcat(s, "a");
if (crc32("HAtvUyNPow",10) == 2472463278) strcat(s, "u");
if (crc32("kdsXvWsJkuRA",12) == 1186192644) strcat(s, "s");
if (crc32("qLaoFr",6) == 881208935) strcat(s, "l");
if (crc32("cHRODjOcqkPh",12) == 942392798) strcat(s, "m");
if (crc32("ckGlFXvhjI",10) == 566384547) strcat(s, "a");
if (crc32("UrjorMbHmwZJ",12) == 2498079067) strcat(s, "r");
if (crc32("CxHTDytTW",9) == 3243389475) strcat(s, "A");
if (crc32("WWQUEUhkfLjWPC",14) == 2834439769) strcat(s, "l");
if (crc32("dKCAyRl",7) == 2909909494) strcat(s, "v");
if (crc32("DggWyEdwMesEd",13) == 1710463483) strcat(s, "y");
    return s;
}

char *nonatheistically_adverbs() {
    char *s = calloc(17);
    if (crc32("iiQzc",5) == 1707914977) strcat(s, "Y");
if (crc32("HnfXoFYMZBN",11) == 2870640521) strcat(s, "n");
if (crc32("dUdOYCmmSkNGg",13) == 1221339561) strcat(s, "o");
if (crc32("UCcKyXBlV",9) == 344742450) strcat(s, "U");
if (crc32("LOEWklTZIUlRdH",14) == 2737593163) strcat(s, "n");
if (crc32("ofSCiPE",7) == 858150169) strcat(s, "a");
if (crc32("wOnNq",5) == 3763741528) strcat(s, "U");
if (crc32("WMNoFBQcM",9) == 1650008087) strcat(s, "t");
if (crc32("yjzBMIpla",9) == 3844089871) strcat(s, "d");
if (crc32("Bbtmbuann",9) == 2409410487) strcat(s, "h");
if (crc32("vxxKQBIW",8) == 3436396212) strcat(s, "e");
if (crc32("ZZRTBJN",7) == 1502401790) strcat(s, "i");
if (crc32("QcOObFKrKyjvgDI",15) == 1316280851) strcat(s, "v");
if (crc32("sqeeAxoRPqRt",12) == 4136495530) strcat(s, "s");
if (crc32("KuWNPPyUI",9) == 3987499318) strcat(s, "t");
if (crc32("qoRqFIfAi",9) == 3705142689) strcat(s, "i");
if (crc32("HXYMthlkSEO",11) == 1186822609) strcat(s, "Q");
if (crc32("gooXrNV",7) == 2223242559) strcat(s, "c");
if (crc32("PhTSqnyT",8) == 510057172) strcat(s, "N");
if (crc32("GzUUycu",7) == 2412178189) strcat(s, "a");
if (crc32("FrMdR",5) == 739357195) strcat(s, "l");
if (crc32("hwchTCUlDJsdRx",14) == 2094939014) strcat(s, "l");
if (crc32("FfJEPhWQ",8) == 943303716) strcat(s, "y");
    return s;
}

char *selfwilledly_adverbs() {
    char *s = calloc(13);
    if (crc32("zOOsB",5) == 1362200428) strcat(s, "s");
if (crc32("KkzSFf",6) == 1379262895) strcat(s, "e");
if (crc32("wmagiTOkraDHS",13) == 2468924876) strcat(s, "H");
if (crc32("mmSEvRvRYUQkJL",14) == 2944533204) strcat(s, "l");
if (crc32("pdyOgkabuaZpjto",15) == 173138206) strcat(s, "U");
if (crc32("GMDKYGMDsXiIkep",15) == 4066264942) strcat(s, "f");
if (crc32("KDgUOyLJmFUGtV",14) == 2035413946) strcat(s, "w");
if (crc32("DuFRdK",6) == 635522530) strcat(s, "i");
if (crc32("rxGHdO",6) == 2704468025) strcat(s, "l");
if (crc32("CUfmVbCsEZu",11) == 1779297851) strcat(s, "l");
if (crc32("SMhnqLIM",8) == 3659989458) strcat(s, "e");
if (crc32("UhNrY",5) == 3187227300) strcat(s, "d");
if (crc32("rgoZzKMJzEmSE",13) == 3069077356) strcat(s, "l");
if (crc32("BNElhFWkIQDXC",13) == 659367740) strcat(s, "y");
    return s;
}

char *negatively_adverbs() {
    char *s = calloc(11);
    if (crc32("lcsWBBWBjAN",11) == 2318933968) strcat(s, "n");
if (crc32("hXKHjsscxbOoMCQ",15) == 3440855223) strcat(s, "I");
if (crc32("YVRBhREEC",9) == 2175227359) strcat(s, "e");
if (crc32("khmQYXJ",7) == 1701837696) strcat(s, "g");
if (crc32("yhTzwDvwMoRZoAl",15) == 3577588737) strcat(s, "G");
if (crc32("stHnPiLEpg",10) == 2979795644) strcat(s, "a");
if (crc32("RgfoOljOQI",10) == 740437264) strcat(s, "t");
if (crc32("dpvWukWoAjFvVa",14) == 2807459982) strcat(s, "i");
if (crc32("yncGWgPTcBLFP",13) == 1706431915) strcat(s, "v");
if (crc32("VJEJvrnwru",10) == 1953680399) strcat(s, "e");
if (crc32("GQuXuqGUeuzWzv",14) == 3936127230) strcat(s, "U");
if (crc32("WKcKIeEMU",9) == 714124396) strcat(s, "l");
if (crc32("prMzDroifMhnAAV",15) == 86527341) strcat(s, "y");
    return s;
}

char *fastuously_adverbs() {
    char *s = calloc(11);
    if (crc32("kdnlwUzJlgD",11) == 3112009820) strcat(s, "P");
if (crc32("qqmnMJXXBUiEcI",14) == 2869545) strcat(s, "f");
if (crc32("GwwocrZbbeBsTN",14) == 1812584459) strcat(s, "i");
if (crc32("wxaIxaGGDcBzZg",14) == 499933660) strcat(s, "a");
if (crc32("WHvQIOqxaRbFoG",14) == 3033775783) strcat(s, "s");
if (crc32("aXDguBbcKTIeyEu",15) == 2113324590) strcat(s, "N");
if (crc32("hxFFhcbokhDZA",13) == 2929917987) strcat(s, "t");
if (crc32("TZPoBlUK",8) == 1914040124) strcat(s, "u");
if (crc32("wdxDIPhgmDwMc",13) == 4123935150) strcat(s, "K");
if (crc32("bQhLKrrLijMUt",13) == 823439225) strcat(s, "o");
if (crc32("RmCxpES",7) == 118047440) strcat(s, "u");
if (crc32("yuSgAwm",7) == 900866704) strcat(s, "M");
if (crc32("wKYuLzcSb",9) == 178575925) strcat(s, "s");
if (crc32("kNXkQSkLAehqGn",14) == 103304133) strcat(s, "H");
if (crc32("IrZFygqpQbKeZ",13) == 1209837125) strcat(s, "l");
if (crc32("BmSnMPGksVosgq",14) == 3231847270) strcat(s, "y");
    return s;
}

char *concessively_adverbs() {
    char *s = calloc(13);
    if (crc32("LWmPHjezgLTTUx",14) == 2856597256) strcat(s, "c");
if (crc32("DpVZx",5) == 1993717722) strcat(s, "o");
if (crc32("HtdDgdHF",8) == 4149988386) strcat(s, "n");
if (crc32("EiTzm",5) == 2641990232) strcat(s, "c");
if (crc32("kNEIV",5) == 4101110216) strcat(s, "d");
if (crc32("ipbjW",5) == 410065545) strcat(s, "e");
if (crc32("FcLEqIMvumeCmD",14) == 4204715614) strcat(s, "s");
if (crc32("AEKFDdPzVI",10) == 3693782125) strcat(s, "s");
if (crc32("MxZfx",5) == 1903744697) strcat(s, "x");
if (crc32("DhmMyaCqGFYNhWK",15) == 3074016269) strcat(s, "i");
if (crc32("jsyvbrGxh",9) == 1519271720) strcat(s, "v");
if (crc32("ShqMBFdnJbwa",12) == 892983866) strcat(s, "L");
if (crc32("DBmrX",5) == 1660552163) strcat(s, "e");
if (crc32("mgvcmrQpTGUOIeN",15) == 1699609829) strcat(s, "l");
if (crc32("SCOlfmnRs",9) == 457650923) strcat(s, "y");
    return s;
}

char *nonrestrictedly_adverbs() {
    char *s = calloc(16);
    if (crc32("hcqhLbSfSbU",11) == 3671033173) strcat(s, "n");
if (crc32("iVrUAYuxhBHRQWf",15) == 1265554480) strcat(s, "s");
if (crc32("hhURZLU",7) == 1988352333) strcat(s, "o");
if (crc32("rKvLvs",6) == 1376295492) strcat(s, "W");
if (crc32("JFRfDNFHTaZGPUH",15) == 1876091908) strcat(s, "n");
if (crc32("uMrZAj",6) == 2924909658) strcat(s, "r");
if (crc32("XwmNjXCqJZFkmR",14) == 1834646775) strcat(s, "x");
if (crc32("JbfBy",5) == 3800226800) strcat(s, "e");
if (crc32("tTiufqXtkDlLUJF",15) == 2139591416) strcat(s, "s");
if (crc32("ATnjDhnOV",9) == 1747682582) strcat(s, "t");
if (crc32("hbFOiu",6) == 3883831544) strcat(s, "r");
if (crc32("DlMbD",5) == 1150931728) strcat(s, "i");
if (crc32("iUpAuyBFm",9) == 3148369299) strcat(s, "S");
if (crc32("LxuRPt",6) == 3740304059) strcat(s, "c");
if (crc32("EWieDijN",8) == 3238179337) strcat(s, "t");
if (crc32("sUUSAGCMOXDxlY",14) == 887772795) strcat(s, "z");
if (crc32("enfWuK",6) == 184644391) strcat(s, "e");
if (crc32("JEjTbxduWszQI",13) == 229321452) strcat(s, "d");
if (crc32("FWHKsTio",8) == 1163362653) strcat(s, "o");
if (crc32("INvRazUyQU",10) == 647544240) strcat(s, "l");
if (crc32("JwQRgprWhSJ",11) == 3727397780) strcat(s, "W");
if (crc32("ntDvS",5) == 4176081624) strcat(s, "y");
    return s;
}

char *Patripassianly_adverbs() {
    char *s = calloc(15);
    if (crc32("gvpcgzVncTsk",12) == 896757901) strcat(s, "w");
if (crc32("uabhWbR",7) == 1185482244) strcat(s, "P");
if (crc32("cjgFlAjiLOVdM",13) == 4102504818) strcat(s, "a");
if (crc32("YHAPoHKHQM",10) == 223589204) strcat(s, "t");
if (crc32("ZCbSMPywXCzOUzN",15) == 3215650304) strcat(s, "r");
if (crc32("PZspTwbhCBFa",12) == 1117156089) strcat(s, "i");
if (crc32("kqCgvpjTjzbCUX",14) == 2408976333) strcat(s, "q");
if (crc32("fiAxGnbbA",9) == 800114037) strcat(s, "p");
if (crc32("EAjuhKxbtw",10) == 1401665829) strcat(s, "G");
if (crc32("pxGvJcXQ",8) == 2718729232) strcat(s, "a");
if (crc32("nffWKgLeztU",11) == 1357252121) strcat(s, "v");
if (crc32("EJiaVOFVDvziy",13) == 1264601717) strcat(s, "s");
if (crc32("kDkNa",5) == 1035216851) strcat(s, "H");
if (crc32("qGumMt",6) == 2503898926) strcat(s, "s");
if (crc32("HJmPWUzi",8) == 2114898581) strcat(s, "K");
if (crc32("xilzJLIBYDX",11) == 3951353438) strcat(s, "i");
if (crc32("eLUfhoXsY",9) == 2676115972) strcat(s, "a");
if (crc32("pliJKWlAIcpJGm",14) == 1668475101) strcat(s, "b");
if (crc32("pAUFKINyBgoO",12) == 2795231228) strcat(s, "n");
if (crc32("JAOwcKlXFJFqKXg",15) == 2937449372) strcat(s, "l");
if (crc32("WuDKGtwIcfGxLsb",15) == 3169151193) strcat(s, "G");
if (crc32("LGoNLvg",7) == 3204475674) strcat(s, "y");
    return s;
}

char *parchedly_adverbs() {
    char *s = calloc(10);
    if (crc32("CFBBoBnPHvLqoTe",15) == 3571881609) strcat(s, "P");
if (crc32("nUbkQTszDvOdz",13) == 2497371299) strcat(s, "p");
if (crc32("gJicqQRROy",10) == 2080279732) strcat(s, "a");
if (crc32("xAPSOTGv",8) == 2620079638) strcat(s, "n");
if (crc32("skDqhsKEuJQXDA",14) == 115377339) strcat(s, "r");
if (crc32("aRjOcD",6) == 545620352) strcat(s, "c");
if (crc32("AttaGw",6) == 2776995300) strcat(s, "h");
if (crc32("lzbjwhXOMjHvQ",13) == 230495612) strcat(s, "e");
if (crc32("FMQULxvdxDHKUp",14) == 3227717001) strcat(s, "j");
if (crc32("OrDnQs",6) == 4031631206) strcat(s, "d");
if (crc32("DEgaYUFt",8) == 1113381226) strcat(s, "l");
if (crc32("bxvOxUBfDWd",11) == 3394307921) strcat(s, "z");
if (crc32("pmKPwJkVMoaS",12) == 3878158492) strcat(s, "y");
    return s;
}

char *fro_adverbs() {
    char *s = calloc(4);
    if (crc32("XHCAHqCluER",11) == 2782370067) strcat(s, "f");
if (crc32("PuJegRyfmsiAsDF",15) == 2633458580) strcat(s, "G");
if (crc32("MJFuPuosddeZjd",14) == 1621330888) strcat(s, "r");
if (crc32("dbwjiOGXJeAYIaB",15) == 40096148) strcat(s, "x");
if (crc32("irwJQVIO",8) == 156060386) strcat(s, "o");
    return s;
}

char *unsinuously_adverbs() {
    char *s = calloc(12);
    if (crc32("irbMVL",6) == 48694101) strcat(s, "o");
if (crc32("fzMFLO",6) == 2076940304) strcat(s, "u");
if (crc32("YfSKrIWglt",10) == 249240160) strcat(s, "K");
if (crc32("ytzgYoS",7) == 316035228) strcat(s, "n");
if (crc32("phstClWtHjfp",12) == 128255702) strcat(s, "B");
if (crc32("dpZoMKODnZ",10) == 721174517) strcat(s, "s");
if (crc32("iHHNO",5) == 3201477697) strcat(s, "Q");
if (crc32("mmPkKkMmzSYD",12) == 1859663592) strcat(s, "i");
if (crc32("RpiSeOj",7) == 3314581483) strcat(s, "Q");
if (crc32("zCMMgcrsbjkq",12) == 1394078691) strcat(s, "n");
if (crc32("VzUWeVcbD",9) == 1347482213) strcat(s, "y");
if (crc32("gkcpcbdoEEojfNc",15) == 3193855860) strcat(s, "u");
if (crc32("shJnIQJnOw",10) == 1491060789) strcat(s, "o");
if (crc32("IRNtirfChTc",11) == 855038204) strcat(s, "e");
if (crc32("SEwpZLhsgcBcdj",14) == 3498371534) strcat(s, "u");
if (crc32("ynPdqZfLbwSw",12) == 1134052217) strcat(s, "s");
if (crc32("FzMuylMxEfoTo",13) == 104544088) strcat(s, "l");
if (crc32("hGmbUfWch",9) == 419445993) strcat(s, "w");
if (crc32("vFQsKLzjj",9) == 396660935) strcat(s, "y");
    return s;
}

char *untheistically_adverbs() {
    char *s = calloc(15);
    if (crc32("iGCtyJPuFgZHe",13) == 3265612476) strcat(s, "Y");
if (crc32("CntMxLFlNp",10) == 3026131398) strcat(s, "u");
if (crc32("ADYAPFa",7) == 223931606) strcat(s, "n");
if (crc32("sdfzkWEP",8) == 1750870818) strcat(s, "p");
if (crc32("BCwWOrN",7) == 766997814) strcat(s, "t");
if (crc32("nAEqdrbJZdW",11) == 1734256368) strcat(s, "L");
if (crc32("yiwIZCPIMc",10) == 4185712823) strcat(s, "h");
if (crc32("HsNts",5) == 795924313) strcat(s, "e");
if (crc32("aZHHjwqg",8) == 2509866946) strcat(s, "i");
if (crc32("sIqoeqYD",8) == 242295178) strcat(s, "s");
if (crc32("DrsAdEKceMEj",12) == 2535825668) strcat(s, "t");
if (crc32("btryxKPh",8) == 532157239) strcat(s, "A");
if (crc32("KTGyzhqUHzar",12) == 2722813127) strcat(s, "i");
if (crc32("JFPqgEctQNUV",12) == 4117188907) strcat(s, "z");
if (crc32("FlhJhJCJvukMx",13) == 2918570840) strcat(s, "c");
if (crc32("rOKhy",5) == 2121615055) strcat(s, "a");
if (crc32("DUjDj",5) == 3954227893) strcat(s, "l");
if (crc32("uHPRUSMiVeJQI",13) == 553316473) strcat(s, "u");
if (crc32("uRCqMeatlgJedV",14) == 3123600780) strcat(s, "l");
if (crc32("NTGHFmnWypz",11) == 946537050) strcat(s, "y");
    return s;
}

char *paradingly_adverbs() {
    char *s = calloc(11);
    if (crc32("hdmvF",5) == 3055711279) strcat(s, "Y");
if (crc32("XFbNUkhoIbLJ",12) == 2955222401) strcat(s, "p");
if (crc32("KnupVzTwqmYU",12) == 1007499856) strcat(s, "a");
if (crc32("DeeGy",5) == 627764619) strcat(s, "x");
if (crc32("csWjbjbVNlyU",12) == 1103200439) strcat(s, "r");
if (crc32("RyxAyElZsjD",11) == 2303095781) strcat(s, "a");
if (crc32("SrVpWAPGF",9) == 3978564072) strcat(s, "d");
if (crc32("YAHrNnlkRhdxr",13) == 1496841833) strcat(s, "a");
if (crc32("NMHUUNTOibdGsi",14) == 2300085593) strcat(s, "i");
if (crc32("iFAbBwsIk",9) == 276451645) strcat(s, "Y");
if (crc32("CSsbJawWy",9) == 1581717502) strcat(s, "n");
if (crc32("MHMPgamivjoTfq",14) == 967606881) strcat(s, "o");
if (crc32("PwfqUqAKNgkpaW",14) == 4250252181) strcat(s, "g");
if (crc32("CslKv",5) == 1272818293) strcat(s, "l");
if (crc32("nOearBwDl",9) == 874552877) strcat(s, "Z");
if (crc32("VmbfRL",6) == 539313090) strcat(s, "y");
    return s;
}

char *nonepigrammatically_adverbs() {
    char *s = calloc(20);
    if (crc32("cBdwqOv",7) == 3149117637) strcat(s, "O");
if (crc32("IcPfiMwByr",10) == 320053802) strcat(s, "n");
if (crc32("ZEQxcLknhvZgam",14) == 127714977) strcat(s, "o");
if (crc32("tXhcBxzaK",9) == 3012214096) strcat(s, "n");
if (crc32("kmWIBn",6) == 2862743102) strcat(s, "P");
if (crc32("YLeNLi",6) == 421409754) strcat(s, "e");
if (crc32("MhDargwFXnrEnQz",15) == 3373366221) strcat(s, "T");
if (crc32("EaqxnIwzJmNnLi",14) == 4044980729) strcat(s, "p");
if (crc32("RauJKmbT",8) == 747532365) strcat(s, "U");
if (crc32("RWdQPmXirDPu",12) == 2700931021) strcat(s, "i");
if (crc32("jQLoOyagWlwCz",13) == 547285324) strcat(s, "H");
if (crc32("YpZwl",5) == 3712979743) strcat(s, "g");
if (crc32("uPvEWoht",8) == 3309379) strcat(s, "r");
if (crc32("HNpDNTDtOn",10) == 101131561) strcat(s, "a");
if (crc32("JSvfjkung",9) == 1123735868) strcat(s, "l");
if (crc32("wnKQaRPF",8) == 2977218501) strcat(s, "m");
if (crc32("OeWOoKzTJHd",11) == 527016301) strcat(s, "m");
if (crc32("vfkDUtigZCzfKJx",15) == 3984418226) strcat(s, "A");
if (crc32("QnoiVprhYP",10) == 2466064980) strcat(s, "a");
if (crc32("VeKTTQ",6) == 3765456649) strcat(s, "u");
if (crc32("vyrrBYM",7) == 1826045760) strcat(s, "t");
if (crc32("RIgADCZjHn",10) == 3972538033) strcat(s, "i");
if (crc32("AwzxlKUOoABzqo",14) == 1743571857) strcat(s, "c");
if (crc32("jGrRnh",6) == 2322534334) strcat(s, "z");
if (crc32("wxncK",5) == 3469477351) strcat(s, "a");
if (crc32("OwNSsPkdBRMi",12) == 2385275871) strcat(s, "S");
if (crc32("GmZIcjWIp",9) == 715294184) strcat(s, "l");
if (crc32("pxqqyWnT",8) == 4203070281) strcat(s, "l");
if (crc32("LBdNwhR",7) == 852572725) strcat(s, "y");
    return s;
}

char *notedly_adverbs() {
    char *s = calloc(8);
    if (crc32("wnQHwPHGLZZZnma",15) == 2544248559) strcat(s, "n");
if (crc32("RMjqZhw",7) == 469406872) strcat(s, "f");
if (crc32("BIwSb",5) == 1637456821) strcat(s, "o");
if (crc32("gjHha",5) == 126055607) strcat(s, "W");
if (crc32("lWnZYoMoc",9) == 1845203742) strcat(s, "t");
if (crc32("EtIDCjOnDPEi",12) == 334295701) strcat(s, "A");
if (crc32("YpNzlbKxPPtZPF",14) == 2703011916) strcat(s, "e");
if (crc32("UnPWZjEWZKl",11) == 1582310876) strcat(s, "d");
if (crc32("vlrtIGbUVZXa",12) == 1890853033) strcat(s, "l");
if (crc32("OAUjmI",6) == 2599578335) strcat(s, "n");
if (crc32("nqyPw",5) == 475599836) strcat(s, "y");
    return s;
}

char *unbiasedly_adverbs() {
    char *s = calloc(11);
    if (crc32("HInfPvvs",8) == 2879326212) strcat(s, "H");
if (crc32("xNePKUVfBMtBuAa",15) == 3672893681) strcat(s, "u");
if (crc32("KRaCgRkSBi",10) == 461681086) strcat(s, "d");
if (crc32("lQDnIHHtx",9) == 657422696) strcat(s, "n");
if (crc32("ftZVfguyAD",10) == 2087846589) strcat(s, "b");
if (crc32("daLQScQjheoD",12) == 1988712670) strcat(s, "i");
if (crc32("cGDspQIW",8) == 1118057891) strcat(s, "a");
if (crc32("IOrfOmeZlDiIf",13) == 3114978946) strcat(s, "s");
if (crc32("leLkxiBHRQJXHpe",15) == 3331519511) strcat(s, "e");
if (crc32("ozFGQLCuoyIsINw",15) == 1021172902) strcat(s, "d");
if (crc32("ucwjmP",6) == 2330179103) strcat(s, "I");
if (crc32("uTZoeUoaaMXx",12) == 1103490499) strcat(s, "l");
if (crc32("WfXAvfJBgPeUuFW",15) == 654517433) strcat(s, "o");
if (crc32("ADfxXOsGemMt",12) == 749571997) strcat(s, "y");
    return s;
}

char *superethically_adverbs() {
    char *s = calloc(15);
    if (crc32("czJxM",5) == 2394193085) strcat(s, "s");
if (crc32("AqIjUfHfROUfaW",14) == 3915986648) strcat(s, "F");
if (crc32("jCLlNenvDpJheNJ",15) == 1768152956) strcat(s, "u");
if (crc32("pQFzDEYmg",9) == 485470535) strcat(s, "X");
if (crc32("QikqzCkQLHS",11) == 2924247582) strcat(s, "p");
if (crc32("ddWnD",5) == 3659131160) strcat(s, "y");
if (crc32("PzvPDndtoPpLf",13) == 3000402487) strcat(s, "e");
if (crc32("tBtWVihFZUu",11) == 3017019824) strcat(s, "r");
if (crc32("fcpqxWs",7) == 2433041309) strcat(s, "Z");
if (crc32("DUGJJpECzuZh",12) == 938848121) strcat(s, "e");
if (crc32("HOZXEUaF",8) == 2911589933) strcat(s, "t");
if (crc32("leXvsinuf",9) == 1167592623) strcat(s, "h");
if (crc32("RHwNBNJtUro",11) == 3561365271) strcat(s, "i");
if (crc32("kkRevUP",7) == 3850814690) strcat(s, "d");
if (crc32("OnRSRPOwA",9) == 2410557429) strcat(s, "c");
if (crc32("HAfos",5) == 3929684913) strcat(s, "a");
if (crc32("VItiq",5) == 3639970855) strcat(s, "j");
if (crc32("OCaSmjpLiyEy",12) == 1218577467) strcat(s, "l");
if (crc32("dSDxqWsncUUwmSi",15) == 1985152055) strcat(s, "l");
if (crc32("KPVVI",5) == 2849816579) strcat(s, "y");
    return s;
}

char *nondiaphanously_adverbs() {
    char *s = calloc(16);
    if (crc32("FpjaDLabNqM",11) == 3486606239) strcat(s, "n");
if (crc32("lhKdd",5) == 1478180977) strcat(s, "u");
if (crc32("NOatElrA",8) == 3579404527) strcat(s, "o");
if (crc32("wxzKloJvlMGuadx",15) == 1459299740) strcat(s, "n");
if (crc32("YGDDPx",6) == 4145033961) strcat(s, "d");
if (crc32("KAoYikZNizLr",12) == 2570871915) strcat(s, "x");
if (crc32("hMdUXD",6) == 686190262) strcat(s, "i");
if (crc32("IYmAs",5) == 424277483) strcat(s, "S");
if (crc32("gPvhLZyJb",9) == 730582409) strcat(s, "a");
if (crc32("WJcOQHnPWALx",12) == 4248766318) strcat(s, "p");
if (crc32("WXlcTf",6) == 1172465071) strcat(s, "m");
if (crc32("OzUTTrrnOGvFM",13) == 1215462194) strcat(s, "h");
if (crc32("ChpuvNfrKWuOD",13) == 3865660109) strcat(s, "A");
if (crc32("ZbZaxf",6) == 1371002717) strcat(s, "a");
if (crc32("SDtbTHwlMkhGH",13) == 1856063745) strcat(s, "i");
if (crc32("CbRoMpaBzqT",11) == 480585287) strcat(s, "n");
if (crc32("eYKhqET",7) == 3539434956) strcat(s, "T");
if (crc32("jwHgT",5) == 3682317345) strcat(s, "o");
if (crc32("nJhrXcBFLCnwcf",14) == 503230795) strcat(s, "u");
if (crc32("qxLktELfvNZ",11) == 1968572862) strcat(s, "s");
if (crc32("vlqhICStpesXb",13) == 1344415430) strcat(s, "p");
if (crc32("mvfVquAEH",9) == 262763707) strcat(s, "l");
if (crc32("TWkqmcDNwib",11) == 3504387260) strcat(s, "w");
if (crc32("XqGMJqLWgyAB",12) == 2705293772) strcat(s, "y");
    return s;
}

char *nontheatrically_adverbs() {
    char *s = calloc(16);
    if (crc32("DhyJSf",6) == 3526686895) strcat(s, "n");
if (crc32("gPraJjyKojeSt",13) == 151477195) strcat(s, "o");
if (crc32("dVVsYGsiPiLxSF",14) == 2891252681) strcat(s, "K");
if (crc32("fWYvkSzgkM",10) == 913270172) strcat(s, "n");
if (crc32("fXPIl",5) == 3622479154) strcat(s, "t");
if (crc32("RvOkCPFAgmt",11) == 2071844901) strcat(s, "h");
if (crc32("OSEXmWDJNKpz",12) == 2660303431) strcat(s, "n");
if (crc32("XewTrHzG",8) == 1661792522) strcat(s, "e");
if (crc32("vndRIJap",8) == 1536579453) strcat(s, "e");
if (crc32("XEKxlXonPFA",11) == 1427057924) strcat(s, "a");
if (crc32("nMAfbJJLHQyB",12) == 2852551232) strcat(s, "C");
if (crc32("MVJETkbbYOaN",12) == 2262656460) strcat(s, "t");
if (crc32("RGixnyEgsFHID",13) == 4094734062) strcat(s, "i");
if (crc32("TxHaHle",7) == 3431429020) strcat(s, "r");
if (crc32("eAPlBOmu",8) == 4127086546) strcat(s, "i");
if (crc32("pODqzLVahBmfe",13) == 3327173992) strcat(s, "c");
if (crc32("JdMtGF",6) == 2037006199) strcat(s, "o");
if (crc32("xRVxCmIr",8) == 3954616010) strcat(s, "a");
if (crc32("vUCRooGpU",9) == 1965020490) strcat(s, "l");
if (crc32("gbHbs",5) == 2622592531) strcat(s, "l");
if (crc32("yimcWypPiSBRDAt",15) == 1940110689) strcat(s, "y");
    return s;
}

char *snufflingly_adverbs() {
    char *s = calloc(12);
    if (crc32("YNMJAq",6) == 1662161204) strcat(s, "L");
if (crc32("AwYcDB",6) == 3462912857) strcat(s, "s");
if (crc32("FEtvFDUgwoik",12) == 2784099641) strcat(s, "G");
if (crc32("gtbyJIOt",8) == 3183363813) strcat(s, "n");
if (crc32("ncfrviAt",8) == 3176901273) strcat(s, "z");
if (crc32("FNkamnJFOAJFUni",15) == 1610681938) strcat(s, "u");
if (crc32("sFMjbnSU",8) == 4095451235) strcat(s, "g");
if (crc32("TvYmlmw",7) == 876461395) strcat(s, "f");
if (crc32("ArKeUVzF",8) == 287442625) strcat(s, "f");
if (crc32("PEAfZsnmnx",10) == 3246772931) strcat(s, "V");
if (crc32("BGQAJisFyU",10) == 1783036226) strcat(s, "l");
if (crc32("zODnPoOfVfF",11) == 3320540774) strcat(s, "i");
if (crc32("OOhSLmHPzylbtJd",15) == 869702420) strcat(s, "i");
if (crc32("TSHJfxRyKXQx",12) == 4284856391) strcat(s, "a");
if (crc32("ceSJu",5) == 1347112804) strcat(s, "n");
if (crc32("magCjIg",7) == 2563816228) strcat(s, "l");
if (crc32("pOHjkDcWN",9) == 3959901011) strcat(s, "g");
if (crc32("kzGcsauTC",9) == 1421056052) strcat(s, "l");
if (crc32("wJbFha",6) == 3339690665) strcat(s, "y");
    return s;
}

char *equatorially_adverbs() {
    char *s = calloc(13);
    if (crc32("fTiRipwJMEaYEQ",14) == 809573858) strcat(s, "e");
if (crc32("TSAOju",6) == 3195907426) strcat(s, "q");
if (crc32("xuGrSWZ",7) == 576705182) strcat(s, "u");
if (crc32("FWRvvwXaWMAOK",13) == 1933495466) strcat(s, "a");
if (crc32("illJXN",6) == 1843084008) strcat(s, "e");
if (crc32("owyWEXLvj",9) == 2551561475) strcat(s, "t");
if (crc32("pxBpt",5) == 2148735771) strcat(s, "u");
if (crc32("shscdQhGGGoH",12) == 2357551563) strcat(s, "o");
if (crc32("RmZhKiXfqJbti",13) == 3523153601) strcat(s, "r");
if (crc32("ckfGIL",6) == 3825815654) strcat(s, "i");
if (crc32("VKJMorTRpuYIFg",14) == 2391467504) strcat(s, "a");
if (crc32("OeJEl",5) == 562706474) strcat(s, "R");
if (crc32("vDqXhRnqX",9) == 3141451549) strcat(s, "l");
if (crc32("nfMJGZS",7) == 4236624290) strcat(s, "V");
if (crc32("XRUEyuGLsxkHfOJ",15) == 2584527972) strcat(s, "l");
if (crc32("tthzjcbym",9) == 218153517) strcat(s, "y");
    return s;
}

char *metaphrastically_adverbs() {
    char *s = calloc(17);
    if (crc32("RZRud",5) == 1475237468) strcat(s, "m");
if (crc32("nrsIBZ",6) == 1327386742) strcat(s, "e");
if (crc32("mFNmIZ",6) == 1138371349) strcat(s, "t");
if (crc32("nLdPViSneU",10) == 534352505) strcat(s, "b");
if (crc32("zkDxj",5) == 2759139797) strcat(s, "a");
if (crc32("LZnHxjyAiaWNtqP",15) == 1984001977) strcat(s, "p");
if (crc32("qASlwE",6) == 3935487512) strcat(s, "h");
if (crc32("gKIofgsuAYbJ",12) == 891170838) strcat(s, "l");
if (crc32("aXlIUYTYsGz",11) == 2755572795) strcat(s, "r");
if (crc32("vgGnaUjMnXxRZ",13) == 1631810537) strcat(s, "h");
if (crc32("Czfko",5) == 3400395851) strcat(s, "a");
if (crc32("JAleMuGviFbxY",13) == 1300580585) strcat(s, "s");
if (crc32("SEDfYZy",7) == 1763346596) strcat(s, "t");
if (crc32("RZTsOrilL",9) == 3154298306) strcat(s, "r");
if (crc32("refKNalhANkts",13) == 3241345325) strcat(s, "i");
if (crc32("fKJGv",5) == 3877023505) strcat(s, "c");
if (crc32("OimFBc",6) == 1340340238) strcat(s, "s");
if (crc32("iMVIqEJvbz",10) == 2967231894) strcat(s, "a");
if (crc32("aBVRFQ",6) == 1951164752) strcat(s, "Y");
if (crc32("MCdDtOm",7) == 1587684161) strcat(s, "l");
if (crc32("fOdbtIcFH",9) == 3516498655) strcat(s, "V");
if (crc32("yHnpIAFipGXabB",14) == 2123580872) strcat(s, "l");
if (crc32("SmOVrPpjxrd",11) == 2965892689) strcat(s, "o");
if (crc32("BvRtdOmcnsz",11) == 1426554340) strcat(s, "y");
    return s;
}

char *nonradically_adverbs() {
    char *s = calloc(13);
    if (crc32("XNXIJnw",7) == 510208687) strcat(s, "n");
if (crc32("KWcUrYpNawHdwHn",15) == 2637533052) strcat(s, "o");
if (crc32("JlxEWD",6) == 525507495) strcat(s, "n");
if (crc32("vWrRsgUq",8) == 3887657519) strcat(s, "Q");
if (crc32("cyrSkOKxtrip",12) == 3707305484) strcat(s, "r");
if (crc32("oFtAjdpGRaXLLj",14) == 744278450) strcat(s, "l");
if (crc32("eemJq",5) == 4136875591) strcat(s, "a");
if (crc32("aczuHUdYpSafwA",14) == 3219682941) strcat(s, "d");
if (crc32("PkvkeivETUSGhOD",15) == 3782457358) strcat(s, "Y");
if (crc32("weXbwCWvnls",11) == 4135446011) strcat(s, "i");
if (crc32("VxmBPtLudY",10) == 344156859) strcat(s, "c");
if (crc32("mEYBbuLthyMrD",13) == 1499807110) strcat(s, "a");
if (crc32("DbqMNX",6) == 1718792147) strcat(s, "l");
if (crc32("tWmJWS",6) == 412815802) strcat(s, "l");
if (crc32("koXwQPfJcl",10) == 1879997973) strcat(s, "y");
    return s;
}

char *overlaxly_adverbs() {
    char *s = calloc(10);
    if (crc32("tRRnRdoODAFvk",13) == 247205644) strcat(s, "t");
if (crc32("JLAzvxyAbmb",11) == 2826981438) strcat(s, "o");
if (crc32("sBXyhfxj",8) == 2017408680) strcat(s, "v");
if (crc32("oVzmxQOeZcMgADo",15) == 2499462991) strcat(s, "e");
if (crc32("zWxvFbvge",9) == 1536064009) strcat(s, "C");
if (crc32("czWyIKvidmq",11) == 3670647519) strcat(s, "r");
if (crc32("lDbXuza",7) == 363321596) strcat(s, "l");
if (crc32("TMLGcvSKKt",10) == 2589376348) strcat(s, "a");
if (crc32("nJIminLHVsp",11) == 171388928) strcat(s, "x");
if (crc32("JOPzEtsKj",9) == 1215799829) strcat(s, "l");
if (crc32("AFSeGgbG",8) == 1279753686) strcat(s, "t");
if (crc32("ErJvvVyzDcS",11) == 1906938337) strcat(s, "y");
    return s;
}

char *unthematically_adverbs() {
    char *s = calloc(15);
    if (crc32("njjRrjvgnDDhEFE",15) == 2306416931) strcat(s, "k");
if (crc32("XhiuahO",7) == 2741021874) strcat(s, "u");
if (crc32("IFuFCjzoVVz",11) == 1061431962) strcat(s, "a");
if (crc32("wIIhn",5) == 329893834) strcat(s, "n");
if (crc32("qqlfqsT",7) == 1755665833) strcat(s, "t");
if (crc32("sMlhEwTOLsD",11) == 3699989871) strcat(s, "h");
if (crc32("zYYIe",5) == 3159047167) strcat(s, "e");
if (crc32("PdnFMQmv",8) == 3347415582) strcat(s, "m");
if (crc32("FkGqwl",6) == 3407064335) strcat(s, "B");
if (crc32("gYPXjJuaHFKEs",13) == 3984783971) strcat(s, "a");
if (crc32("YwgznBoXkwl",11) == 827888445) strcat(s, "C");
if (crc32("mOLPc",5) == 1937184152) strcat(s, "t");
if (crc32("zbXROhNQk",9) == 3064517296) strcat(s, "t");
if (crc32("OqEVhYgEVwh",11) == 1876296412) strcat(s, "i");
if (crc32("bnQhX",5) == 3686348681) strcat(s, "T");
if (crc32("XNZQhfI",7) == 3279225746) strcat(s, "c");
if (crc32("SkmHWj",6) == 1479678580) strcat(s, "l");
if (crc32("LAgsmjKvHKx",11) == 3453159677) strcat(s, "a");
if (crc32("txBvBND",7) == 3662588886) strcat(s, "i");
if (crc32("vVGQPkPOPN",10) == 3323410069) strcat(s, "l");
if (crc32("GKjMJbnOL",9) == 2535330874) strcat(s, "m");
if (crc32("amxgPMEIu",9) == 174187634) strcat(s, "l");
if (crc32("NTwVQZ",6) == 4291083628) strcat(s, "y");
    return s;
}

char *unappallingly_adverbs() {
    char *s = calloc(14);
    if (crc32("WxFrPZQwZrwsT",13) == 981731802) strcat(s, "u");
if (crc32("TZCANjG",7) == 2503948931) strcat(s, "W");
if (crc32("saUMTuVDyZJGp",13) == 76569904) strcat(s, "n");
if (crc32("PzUbfzYOaC",10) == 230937387) strcat(s, "a");
if (crc32("WbWfsdCtaoH",11) == 2733208961) strcat(s, "Z");
if (crc32("YTDZPZanNRdoqWv",15) == 2705104218) strcat(s, "p");
if (crc32("NbBVfVKBBh",10) == 3976362761) strcat(s, "p");
if (crc32("GMCFYSjEEpFYs",13) == 3842876502) strcat(s, "a");
if (crc32("rgAau",5) == 3457201066) strcat(s, "l");
if (crc32("DzEdasN",7) == 1608481432) strcat(s, "v");
if (crc32("IAMMFwWXQGgNzO",14) == 1739039324) strcat(s, "l");
if (crc32("LEDaSAlvRkWam",13) == 909826756) strcat(s, "j");
if (crc32("UdJflLdiDmuyCMf",15) == 529785883) strcat(s, "i");
if (crc32("rxZLhaK",7) == 2041051481) strcat(s, "n");
if (crc32("jSTmBxqlf",9) == 2949143372) strcat(s, "X");
if (crc32("AyFyR",5) == 3121179367) strcat(s, "g");
if (crc32("qVlaGAFySDtQN",13) == 687172498) strcat(s, "Q");
if (crc32("inXAGflVkDQrwil",15) == 783956394) strcat(s, "l");
if (crc32("JphhUNmbJCu",11) == 2140691894) strcat(s, "y");
    return s;
}

char *flashingly_adverbs() {
    char *s = calloc(11);
    if (crc32("QxeyJYjtPDvXGrX",15) == 3243438535) strcat(s, "f");
if (crc32("MxLWvGImuZAfbfV",15) == 453588640) strcat(s, "J");
if (crc32("EGitzdah",8) == 3532247042) strcat(s, "l");
if (crc32("VeJZaJIbgnWxud",14) == 634779778) strcat(s, "a");
if (crc32("PZaNq",5) == 1814402352) strcat(s, "Q");
if (crc32("tedbcytFjqgwJQK",15) == 3583515207) strcat(s, "s");
if (crc32("EptPFCtd",8) == 4201510406) strcat(s, "c");
if (crc32("myTzpDeOxv",10) == 2366175506) strcat(s, "h");
if (crc32("gGVuCeGrfiIY",12) == 1405506890) strcat(s, "i");
if (crc32("DNDKxB",6) == 11721499) strcat(s, "p");
if (crc32("qNyfesrIq",9) == 3809449167) strcat(s, "n");
if (crc32("odokLBelDW",10) == 873854774) strcat(s, "g");
if (crc32("ZRxAntpcqpEU",12) == 3863065413) strcat(s, "D");
if (crc32("EANUt",5) == 2671354754) strcat(s, "l");
if (crc32("lozpudbE",8) == 2393970577) strcat(s, "y");
    return s;
}

char *noncruciformly_adverbs() {
    char *s = calloc(15);
    if (crc32("fNrmEbjJUE",10) == 4201060001) strcat(s, "n");
if (crc32("oCfbYUNnWn",10) == 2480188373) strcat(s, "n");
if (crc32("cOiKoyIy",8) == 3118121781) strcat(s, "o");
if (crc32("wVxJkHHdvqeIZ",13) == 2137964380) strcat(s, "A");
if (crc32("rbMVJMHBW",9) == 1735217864) strcat(s, "n");
if (crc32("RzwxzZhzWQ",10) == 3162970902) strcat(s, "Y");
if (crc32("HvACKHcEpipkYTP",15) == 2613709624) strcat(s, "c");
if (crc32("vUOKbhTb",8) == 860759766) strcat(s, "B");
if (crc32("acRiVBrDi",9) == 428131587) strcat(s, "r");
if (crc32("xtInXYEPl",9) == 1351438247) strcat(s, "u");
if (crc32("DBHLbcTRB",9) == 2195155060) strcat(s, "p");
if (crc32("IPghxlimrapj",12) == 228643829) strcat(s, "c");
if (crc32("OUbnyoNnmrd",11) == 1576854771) strcat(s, "y");
if (crc32("EdZvfGvqIyQ",11) == 1529313211) strcat(s, "i");
if (crc32("UZjBMtSLuxOJMxa",15) == 866477029) strcat(s, "m");
if (crc32("iDpNrRtTjzQ",11) == 3851134317) strcat(s, "f");
if (crc32("VQSNXJKtLwxHqpV",15) == 1023055625) strcat(s, "O");
if (crc32("wlcAeMypfx",10) == 649457098) strcat(s, "o");
if (crc32("XisymtkJB",9) == 1119092010) strcat(s, "r");
if (crc32("DLWAeSAps",9) == 2073697076) strcat(s, "g");
if (crc32("BKPqVNekO",9) == 1675568260) strcat(s, "m");
if (crc32("rKuiFVDGrijs",12) == 915531306) strcat(s, "m");
if (crc32("PtgPtVFNVrlvNU",14) == 2685921111) strcat(s, "l");
if (crc32("OVoeQDzwWl",10) == 1357392189) strcat(s, "m");
if (crc32("uPZVBXmD",8) == 1246873357) strcat(s, "y");
    return s;
}

char *nonblamefully_adverbs() {
    char *s = calloc(14);
    if (crc32("UAYUQ",5) == 2914276786) strcat(s, "n");
if (crc32("lbLOQAWJ",8) == 3727918053) strcat(s, "W");
if (crc32("SOgcaIyKIwzvQ",13) == 1144904331) strcat(s, "o");
if (crc32("LHSah",5) == 1425281506) strcat(s, "n");
if (crc32("IMtUl",5) == 714017067) strcat(s, "b");
if (crc32("aahkkWunM",9) == 2289121395) strcat(s, "Y");
if (crc32("DJOYcMhJmuM",11) == 2174044961) strcat(s, "l");
if (crc32("zxsav",5) == 1224531942) strcat(s, "a");
if (crc32("ZtbeOevU",8) == 3553060331) strcat(s, "s");
if (crc32("HywySI",6) == 2505414469) strcat(s, "m");
if (crc32("EnytRCVI",8) == 261146888) strcat(s, "e");
if (crc32("xEbAJhGGJpzNYO",14) == 2211451797) strcat(s, "n");
if (crc32("MmhUOxSI",8) == 780955356) strcat(s, "f");
if (crc32("zwKDDVqzn",9) == 2653478182) strcat(s, "u");
if (crc32("AZqQGpzmw",9) == 3429126578) strcat(s, "Z");
if (crc32("QVjWsNf",7) == 3688758927) strcat(s, "l");
if (crc32("LsPlKGKtYftdi",13) == 3070708620) strcat(s, "N");
if (crc32("QZCDKEsofeB",11) == 1055234438) strcat(s, "l");
if (crc32("zQHjtZJ",7) == 2870694522) strcat(s, "y");
    return s;
}

char *cussedly_adverbs() {
    char *s = calloc(9);
    if (crc32("AUShdKBwrU",10) == 1824210186) strcat(s, "v");
if (crc32("iFIeYjCzGqaKWL",14) == 2726157268) strcat(s, "c");
if (crc32("LDFKiKph",8) == 197235644) strcat(s, "u");
if (crc32("TVVDmdBJVFuipWl",15) == 440300433) strcat(s, "K");
if (crc32("eIfBofCIaETxt",13) == 2282081284) strcat(s, "s");
if (crc32("GveRIiCRu",9) == 2650251543) strcat(s, "G");
if (crc32("zkRWBXwwBuiqLth",15) == 4236278524) strcat(s, "s");
if (crc32("NLEXFBkWU",9) == 877837483) strcat(s, "e");
if (crc32("rHwyDiklcI",10) == 1204309997) strcat(s, "d");
if (crc32("GNIVpvvIFzyjcxR",15) == 1348614281) strcat(s, "l");
if (crc32("TAOCmSj",7) == 2702061050) strcat(s, "y");
    return s;
}

char *inequitably_adverbs() {
    char *s = calloc(12);
    if (crc32("QCjZguVSCsJ",11) == 3055577338) strcat(s, "e");
if (crc32("EdKwCHBqAyxqKiM",15) == 4160537524) strcat(s, "i");
if (crc32("itHAThMbDsidVi",14) == 2186410622) strcat(s, "a");
if (crc32("KRZaSKHlKVmDLeR",15) == 3992166044) strcat(s, "n");
if (crc32("YtuQI",5) == 3924185846) strcat(s, "e");
if (crc32("yElwg",5) == 1817179170) strcat(s, "q");
if (crc32("vMxVb",5) == 3429999068) strcat(s, "u");
if (crc32("gzDDQGWk",8) == 605885490) strcat(s, "h");
if (crc32("CgoHeIrvUbOFVV",14) == 3953426383) strcat(s, "i");
if (crc32("uFLDc",5) == 396815649) strcat(s, "s");
if (crc32("voQmpdD",7) == 60296511) strcat(s, "t");
if (crc32("tRCOF",5) == 838267597) strcat(s, "a");
if (crc32("xhbKRBAtXew",11) == 677650681) strcat(s, "b");
if (crc32("Cantxrug",8) == 2839361558) strcat(s, "l");
if (crc32("XCwELVaeeqNaWI",14) == 1094988716) strcat(s, "s");
if (crc32("DBGYJQ",6) == 1953255846) strcat(s, "y");
    return s;
}

char *overcleverly_adverbs() {
    char *s = calloc(13);
    if (crc32("WaFDjjLpgLIJcnF",15) == 2756547079) strcat(s, "o");
if (crc32("DplmrboaYrsoyEz",15) == 3851630824) strcat(s, "n");
if (crc32("EPDfwY",6) == 4238445358) strcat(s, "v");
if (crc32("VxEUazP",7) == 4162663505) strcat(s, "l");
if (crc32("flZdnDbAYROXNly",15) == 2993380307) strcat(s, "e");
if (crc32("UmbCV",5) == 422943999) strcat(s, "V");
if (crc32("UDxAHnhnZE",10) == 2637233075) strcat(s, "r");
if (crc32("GvESgdwoMnWCGJS",15) == 3669539986) strcat(s, "c");
if (crc32("HRIrnf",6) == 4275870916) strcat(s, "l");
if (crc32("qwxwzmfdhXilz",13) == 2763340282) strcat(s, "e");
if (crc32("ZFSzLvJk",8) == 3996065323) strcat(s, "v");
if (crc32("iYsagLLEY",9) == 1583462297) strcat(s, "e");
if (crc32("enssftyNay",10) == 1414125403) strcat(s, "r");
if (crc32("kKTIoA",6) == 2818491489) strcat(s, "z");
if (crc32("OkTDumlpkmv",11) == 2502509525) strcat(s, "l");
if (crc32("PXgwkNY",7) == 560893792) strcat(s, "e");
if (crc32("kdsCN",5) == 2147710797) strcat(s, "y");
    return s;
}

char *healthily_adverbs() {
    char *s = calloc(10);
    if (crc32("FxpHrrSyMa",10) == 3424260133) strcat(s, "Y");
if (crc32("wakwRxYdiY",10) == 3489540512) strcat(s, "h");
if (crc32("FVyCs",5) == 3062850837) strcat(s, "e");
if (crc32("EJUeXWnh",8) == 921233557) strcat(s, "a");
if (crc32("FlDwJNGGXaajhpz",15) == 576810975) strcat(s, "b");
if (crc32("upuZIAoyhmink",13) == 1835395839) strcat(s, "l");
if (crc32("wPDIWzZ",7) == 3302998449) strcat(s, "t");
if (crc32("zfuVntvUKQML",12) == 4160342591) strcat(s, "h");
if (crc32("bdxSfUkTbfedV",13) == 1080457268) strcat(s, "i");
if (crc32("uUhfBMmZxOXARhT",15) == 4207784979) strcat(s, "l");
if (crc32("HYfaECfYxR",10) == 3560370658) strcat(s, "y");
    return s;
}

char *unevilly_adverbs() {
    char *s = calloc(9);
    if (crc32("lQeZEXZpmqcYB",13) == 3423980476) strcat(s, "c");
if (crc32("NnaOYdiO",8) == 808485970) strcat(s, "u");
if (crc32("RYuaqsStLoF",11) == 4030504829) strcat(s, "n");
if (crc32("OLfPIjrIkQVe",12) == 1961608401) strcat(s, "J");
if (crc32("VlUiOJq",7) == 1120933944) strcat(s, "e");
if (crc32("FYwdzWPOpy",10) == 3776204942) strcat(s, "v");
if (crc32("QspAwRoQgyEjCCk",15) == 2378280375) strcat(s, "Y");
if (crc32("KgcDeczGmEjZSIi",15) == 1325354413) strcat(s, "i");
if (crc32("QzWFCmQtbsW",11) == 2993850697) strcat(s, "L");
if (crc32("duPfleNOEMKG",12) == 3609171868) strcat(s, "l");
if (crc32("LqJUfIaeMv",10) == 969674289) strcat(s, "f");
if (crc32("ryLxFbQ",7) == 3331253883) strcat(s, "l");
if (crc32("EvmKWb",6) == 2063640843) strcat(s, "y");
    return s;
}

char *nonheretically_adverbs() {
    char *s = calloc(15);
    if (crc32("VkTGnGtjQTqky",13) == 1577222234) strcat(s, "j");
if (crc32("LfwsoRcHSoJFUxn",15) == 972175069) strcat(s, "n");
if (crc32("lYdfEsHZAGgI",12) == 4238319998) strcat(s, "o");
if (crc32("UuZfjHXZgIU",11) == 2496303222) strcat(s, "n");
if (crc32("UgLUMAwceK",10) == 2251071345) strcat(s, "s");
if (crc32("ctNfJGLT",8) == 2985808640) strcat(s, "h");
if (crc32("EMJGMQWpIGLd",12) == 3185093959) strcat(s, "l");
if (crc32("BzqZQAnJdwCjLX",14) == 1125542903) strcat(s, "e");
if (crc32("WHXmYALNPs",10) == 667517781) strcat(s, "r");
if (crc32("AArvoLhEkwHP",12) == 3449570355) strcat(s, "F");
if (crc32("QypchFLYEtPb",12) == 1169829312) strcat(s, "e");
if (crc32("qjkymisyqRDqFd",14) == 3996797512) strcat(s, "t");
if (crc32("cEAwCHEhuIJ",11) == 3840833650) strcat(s, "i");
if (crc32("AOAGMyhia",9) == 1365704676) strcat(s, "i");
if (crc32("PLmVtayqQaSr",12) == 1188051565) strcat(s, "c");
if (crc32("JGvfzanGXmIy",12) == 233456885) strcat(s, "s");
if (crc32("KRGlhhRtmTj",11) == 3614953144) strcat(s, "a");
if (crc32("yncBoZIpMrz",11) == 4148164187) strcat(s, "C");
if (crc32("ZBCuJ",5) == 855746149) strcat(s, "l");
if (crc32("lTMtCtQOeW",10) == 3866410962) strcat(s, "V");
if (crc32("NxGXFqHw",8) == 2164329264) strcat(s, "l");
if (crc32("gAKhvmD",7) == 928401129) strcat(s, "y");
    return s;
}

char *jumpily_adverbs() {
    char *s = calloc(8);
    if (crc32("SsgMsh",6) == 476205971) strcat(s, "j");
if (crc32("pMotWKnWTGDnam",14) == 2504142079) strcat(s, "u");
if (crc32("xAIhK",5) == 524922035) strcat(s, "m");
if (crc32("vbcwkdJodESft",13) == 1542144970) strcat(s, "J");
if (crc32("CLFyfSaUv",9) == 2359762474) strcat(s, "p");
if (crc32("kPLvH",5) == 2603605397) strcat(s, "i");
if (crc32("yDqNwJqhzeSoLg",14) == 590253536) strcat(s, "q");
if (crc32("mrUomyyyJq",10) == 1507133853) strcat(s, "l");
if (crc32("KZQQO",5) == 1695286544) strcat(s, "y");
    return s;
}

char *cylindrically_adverbs() {
    char *s = calloc(14);
    if (crc32("RbzITHOKpwtfh",13) == 4076845826) strcat(s, "c");
if (crc32("DacUoVyf",8) == 1076212059) strcat(s, "R");
if (crc32("hrXQYbGIUVUgNp",14) == 2519425618) strcat(s, "y");
if (crc32("dmeZNP",6) == 726122555) strcat(s, "l");
if (crc32("zRbuZO",6) == 1015705411) strcat(s, "i");
if (crc32("oHubpwmVms",10) == 2789682434) strcat(s, "n");
if (crc32("LHJMtbD",7) == 1285071553) strcat(s, "r");
if (crc32("BeAkENQVMik",11) == 1215071285) strcat(s, "d");
if (crc32("MNzlnPFfvLBk",12) == 3981671437) strcat(s, "A");
if (crc32("uGNXrmsxxSHp",12) == 2573347736) strcat(s, "r");
if (crc32("vAwkmWRD",8) == 2957267167) strcat(s, "H");
if (crc32("NbSVGxqHOBpp",12) == 1646594452) strcat(s, "i");
if (crc32("dWuwQyH",7) == 3745527751) strcat(s, "c");
if (crc32("WlEBDiVi",8) == 2156826426) strcat(s, "a");
if (crc32("UFKlKxtIEhpG",12) == 615704046) strcat(s, "a");
if (crc32("VexiM",5) == 2604211820) strcat(s, "l");
if (crc32("TtSmTIGnO",9) == 79530945) strcat(s, "l");
if (crc32("yprVPZnWdW",10) == 2411479805) strcat(s, "y");
    return s;
}

char *Methodistically_adverbs() {
    char *s = calloc(16);
    if (crc32("BkhovFZcVfbEw",13) == 2234706681) strcat(s, "M");
if (crc32("wNbuQFvwrtzUkA",14) == 1231000890) strcat(s, "e");
if (crc32("VzdFtghcj",9) == 1945731970) strcat(s, "t");
if (crc32("QloaFTFQmLOfTSC",15) == 621308378) strcat(s, "h");
if (crc32("gAdDLaXxDlubDFT",15) == 1255324624) strcat(s, "m");
if (crc32("keHtOXbCHcaoWx",14) == 1856804906) strcat(s, "o");
if (crc32("MMQXRObnGiiLv",13) == 791892283) strcat(s, "B");
if (crc32("CBUnyXd",7) == 3800627892) strcat(s, "d");
if (crc32("vmrmmKHLmERWQ",13) == 589552785) strcat(s, "c");
if (crc32("QLrdrKkjwOhku",13) == 1914225927) strcat(s, "i");
if (crc32("FtRPFsUYX",9) == 299397179) strcat(s, "s");
if (crc32("iipfc",5) == 2814627387) strcat(s, "t");
if (crc32("dewpqLFtTZaMK",13) == 1871034779) strcat(s, "X");
if (crc32("YIRSTXdMJX",10) == 3990403420) strcat(s, "i");
if (crc32("kIJbTZvfEla",11) == 877904750) strcat(s, "c");
if (crc32("DADLssRuA",9) == 3689007563) strcat(s, "J");
if (crc32("EJLeZKkR",8) == 377423022) strcat(s, "a");
if (crc32("oCkSirEv",8) == 565781478) strcat(s, "l");
if (crc32("vFYFnygTInz",11) == 556940427) strcat(s, "J");
if (crc32("qtgMdwwdhFj",11) == 4210807093) strcat(s, "l");
if (crc32("VCiStf",6) == 3004184623) strcat(s, "y");
    return s;
}

char *heartrendingly_adverbs() {
    char *s = calloc(15);
    if (crc32("ViuRRcXNMvqlAaZ",15) == 734987077) strcat(s, "u");
if (crc32("AICHsHuDwFyIFOW",15) == 2494782129) strcat(s, "h");
if (crc32("ESbHJNXOhzs",11) == 3913295781) strcat(s, "I");
if (crc32("nahiSpfLxnoDLB",14) == 1716256301) strcat(s, "e");
if (crc32("dHkNk",5) == 69773528) strcat(s, "a");
if (crc32("GssZgbMN",8) == 1576991493) strcat(s, "r");
if (crc32("BSRlmvusxu",10) == 1713957235) strcat(s, "t");
if (crc32("anNhwk",6) == 3547944455) strcat(s, "r");
if (crc32("pNOeUQQC",8) == 1848707925) strcat(s, "M");
if (crc32("AhRpxN",6) == 2683532534) strcat(s, "e");
if (crc32("jTqdrQzHQaoqMX",14) == 3506129541) strcat(s, "Z");
if (crc32("CnOkSSnEUV",10) == 1718557492) strcat(s, "n");
if (crc32("YvZVOssuay",10) == 1802385079) strcat(s, "I");
if (crc32("hbwbkUwGsAh",11) == 921798433) strcat(s, "d");
if (crc32("MasmlldIGSPBvD",14) == 362741522) strcat(s, "i");
if (crc32("CXleOaUtDBPly",13) == 3968237722) strcat(s, "b");
if (crc32("NWjcA",5) == 2104500666) strcat(s, "n");
if (crc32("birdyaZ",7) == 898678280) strcat(s, "g");
if (crc32("dMdpZYeGOrRrfRT",15) == 1484518770) strcat(s, "q");
if (crc32("KCMOGg",6) == 3042451121) strcat(s, "l");
if (crc32("SDclh",5) == 1834431956) strcat(s, "y");
    return s;
}

char *festively_adverbs() {
    char *s = calloc(10);
    if (crc32("iISdqosyxKicLY",14) == 690527918) strcat(s, "f");
if (crc32("tVFqxUPHLOqHv",13) == 359326534) strcat(s, "H");
if (crc32("TDxNUZz",7) == 4138016519) strcat(s, "e");
if (crc32("euBIWsvqeDWBl",13) == 2650594112) strcat(s, "s");
if (crc32("XvolPeM",7) == 1189392938) strcat(s, "t");
if (crc32("udIuafteoM",10) == 4017420831) strcat(s, "i");
if (crc32("RxGFxTZ",7) == 2507158182) strcat(s, "v");
if (crc32("wyTBrA",6) == 1969544057) strcat(s, "q");
if (crc32("ZcMpu",5) == 3925908044) strcat(s, "e");
if (crc32("nUgkc",5) == 3769282980) strcat(s, "O");
if (crc32("MmGnvuvXiudET",13) == 487366909) strcat(s, "l");
if (crc32("UZwGlhxvUtWhckL",15) == 1588460045) strcat(s, "x");
if (crc32("MrDHCLgpV",9) == 1523591926) strcat(s, "y");
    return s;
}

char *unquizzically_adverbs() {
    char *s = calloc(14);
    if (crc32("fuGThLXxFs",10) == 888157963) strcat(s, "K");
if (crc32("YrxcEGVySQraB",13) == 1394441781) strcat(s, "u");
if (crc32("TpOjz",5) == 881520504) strcat(s, "n");
if (crc32("ERXJgarSbJsQAK",14) == 3161170881) strcat(s, "q");
if (crc32("DmOnnmOVUmUQHe",14) == 2762166363) strcat(s, "B");
if (crc32("jlYPLpqmLa",10) == 2182704048) strcat(s, "u");
if (crc32("FKBJXu",6) == 1509813189) strcat(s, "i");
if (crc32("sFQLukBxoKmmlUY",15) == 2506527718) strcat(s, "z");
if (crc32("RwkADJg",7) == 1553470965) strcat(s, "z");
if (crc32("hjBoNAcRS",9) == 2663039279) strcat(s, "i");
if (crc32("BBdZGbuaAODbwna",15) == 825255979) strcat(s, "c");
if (crc32("NKlIwEsMpQkNx",13) == 1421043247) strcat(s, "a");
if (crc32("Pzdpprpfv",9) == 3451319122) strcat(s, "v");
if (crc32("KJSiiFfnIlYnIj",14) == 2045162052) strcat(s, "l");
if (crc32("VFSlmniRZvQeQo",14) == 1373692495) strcat(s, "l");
if (crc32("KcFfWhb",7) == 4220870609) strcat(s, "y");
    return s;
}

char *lamellarly_adverbs() {
    char *s = calloc(11);
    if (crc32("zpeGxALXrZC",11) == 498458934) strcat(s, "y");
if (crc32("BrpTcyPVHU",10) == 644205072) strcat(s, "l");
if (crc32("VYPBJfDbltZMNm",14) == 3611477982) strcat(s, "a");
if (crc32("yasvKD",6) == 1920445312) strcat(s, "m");
if (crc32("qnyQJQoxoHeYo",13) == 2413369253) strcat(s, "e");
if (crc32("bNnQvw",6) == 314447746) strcat(s, "l");
if (crc32("Zpcud",5) == 2377702752) strcat(s, "l");
if (crc32("Kcano",5) == 922633243) strcat(s, "Y");
if (crc32("NOlmXKARXNMnkL",14) == 89108922) strcat(s, "a");
if (crc32("XeYoyCL",7) == 2084040202) strcat(s, "r");
if (crc32("efQFJH",6) == 2327726655) strcat(s, "l");
if (crc32("ReuQvYHHk",9) == 133825469) strcat(s, "y");
    return s;
}

char *aboon_adverbs() {
    char *s = calloc(6);
    if (crc32("XdFMdrJnXLxgLSM",15) == 3421640298) strcat(s, "a");
if (crc32("IbWSM",5) == 4075223330) strcat(s, "b");
if (crc32("mpTWP",5) == 1664856006) strcat(s, "L");
if (crc32("tDjVLkBRpZS",11) == 2889955176) strcat(s, "o");
if (crc32("hYHKVbD",7) == 1684641497) strcat(s, "o");
if (crc32("jEunYuwnOf",10) == 4082224611) strcat(s, "n");
    return s;
}

char *seaward_adverbs() {
    char *s = calloc(8);
    if (crc32("HHEmafXTMGU",11) == 4267781421) strcat(s, "f");
if (crc32("GSvVU",5) == 1389729859) strcat(s, "s");
if (crc32("RBvmW",5) == 2457474160) strcat(s, "D");
if (crc32("ZAOMHQbpQvIIcu",14) == 3422415640) strcat(s, "e");
if (crc32("QCRxTNYnuJ",10) == 2321735492) strcat(s, "W");
if (crc32("EPimCkx",7) == 1890897742) strcat(s, "a");
if (crc32("qeORkqPMM",9) == 1991795451) strcat(s, "w");
if (crc32("cIXwpswhm",9) == 4243163010) strcat(s, "a");
if (crc32("dOtep",5) == 2019257524) strcat(s, "F");
if (crc32("TlWSjszDBzyLB",13) == 1718988269) strcat(s, "r");
if (crc32("XpMyXF",6) == 2275082578) strcat(s, "e");
if (crc32("LEjOITkHemeP",12) == 4205033723) strcat(s, "d");
    return s;
}

char *spiritoso_adverbs() {
    char *s = calloc(10);
    if (crc32("FNWgFEKi",8) == 699020175) strcat(s, "C");
if (crc32("JCnPJeYzCgZaakV",15) == 3018219486) strcat(s, "s");
if (crc32("AwSKCxW",7) == 2821952537) strcat(s, "t");
if (crc32("CFvvJYWIdK",10) == 2361843713) strcat(s, "p");
if (crc32("zLCZFzTqZMKVTkP",15) == 3907271065) strcat(s, "i");
if (crc32("VjRsvqVvVaBXy",13) == 998474846) strcat(s, "r");
if (crc32("KFeDXVg",7) == 442323450) strcat(s, "i");
if (crc32("QdeAOuVMHId",11) == 1286465291) strcat(s, "e");
if (crc32("wViZZmq",7) == 3365724141) strcat(s, "t");
if (crc32("aNSWFxbQCOJd",12) == 386724971) strcat(s, "q");
if (crc32("dfxzxcQUVhTOUt",14) == 1620989204) strcat(s, "o");
if (crc32("kRZRQLSC",8) == 3344772862) strcat(s, "s");
if (crc32("rEyeJzpXLBjWF",13) == 1211602358) strcat(s, "N");
if (crc32("uLETRSdo",8) == 1130178798) strcat(s, "o");
    return s;
}

char *tetragonally_adverbs() {
    char *s = calloc(13);
    if (crc32("RVrxzVeZUMgrM",13) == 3038434676) strcat(s, "t");
if (crc32("rMkxtloOjet",11) == 1588128242) strcat(s, "l");
if (crc32("FzwmAyAX",8) == 1092083430) strcat(s, "e");
if (crc32("irYhtQCsW",9) == 3556398598) strcat(s, "x");
if (crc32("MkTwYlm",7) == 2027874561) strcat(s, "t");
if (crc32("tRnQTSs",7) == 2727447340) strcat(s, "r");
if (crc32("GgMiX",5) == 4047410311) strcat(s, "g");
if (crc32("qzROQugQvVFCLa",14) == 3223095721) strcat(s, "a");
if (crc32("AUznCKRdVnOkZ",13) == 1052177595) strcat(s, "j");
if (crc32("syWCHAntFaN",11) == 1594890702) strcat(s, "g");
if (crc32("gjENx",5) == 4292779913) strcat(s, "o");
if (crc32("yXQzNj",6) == 2093356588) strcat(s, "n");
if (crc32("NSJsCLBQHxW",11) == 3831663720) strcat(s, "a");
if (crc32("sYorVtmvpKZ",11) == 392915350) strcat(s, "l");
if (crc32("XadvT",5) == 3966123827) strcat(s, "D");
if (crc32("XtsjYcV",7) == 1488544667) strcat(s, "l");
if (crc32("ZnoPicx",7) == 4242608598) strcat(s, "F");
if (crc32("FfSpoOa",7) == 2118772964) strcat(s, "y");
    return s;
}

char *drenchingly_adverbs() {
    char *s = calloc(12);
    if (crc32("tVFFtlMeujNYkAT",15) == 64032432) strcat(s, "v");
if (crc32("HvaTBCSkFXrJAsr",15) == 1780477800) strcat(s, "d");
if (crc32("zAWvpQliHo",10) == 3327762375) strcat(s, "r");
if (crc32("vwiQRtwNGu",10) == 2562122059) strcat(s, "e");
if (crc32("jCQihw",6) == 1342976606) strcat(s, "n");
if (crc32("kzDeuHk",7) == 2917416411) strcat(s, "L");
if (crc32("whgcoanXJJ",10) == 149764538) strcat(s, "c");
if (crc32("FMyHnsNdDeAqbcB",15) == 368939709) strcat(s, "v");
if (crc32("QEjXsnRZGS",10) == 2525617003) strcat(s, "h");
if (crc32("CiRDPlllQlD",11) == 1559909787) strcat(s, "i");
if (crc32("EluFiMzBswiSve",14) == 1157276707) strcat(s, "n");
if (crc32("QDvAo",5) == 1581758728) strcat(s, "U");
if (crc32("FpFCxvJX",8) == 826010904) strcat(s, "g");
if (crc32("qOYeRAYHVAVxfb",14) == 1554600807) strcat(s, "h");
if (crc32("PjKEFOJfrP",10) == 1008992963) strcat(s, "l");
if (crc32("joBCUq",6) == 2696947351) strcat(s, "y");
    return s;
}

char *tenthly_adverbs() {
    char *s = calloc(8);
    if (crc32("iXVlsinsu",9) == 3396489597) strcat(s, "b");
if (crc32("uEYzPCuvlqYz",12) == 2994552883) strcat(s, "t");
if (crc32("NKEwkhe",7) == 1581397072) strcat(s, "e");
if (crc32("wsfQWeilJ",9) == 571833394) strcat(s, "b");
if (crc32("RUCbxLDg",8) == 4181340928) strcat(s, "n");
if (crc32("wividJQpu",9) == 3877202871) strcat(s, "t");
if (crc32("kkEsgflCKP",10) == 3490680736) strcat(s, "h");
if (crc32("WcVsFKnxdpY",11) == 2615042142) strcat(s, "l");
if (crc32("jVBCeUTjFKQ",11) == 1572070756) strcat(s, "y");
    return s;
}

char *subgeometrically_adverbs() {
    char *s = calloc(17);
    if (crc32("iyUlzSIEeWQ",11) == 1768080127) strcat(s, "s");
if (crc32("wTuOGKsHERhpqK",14) == 3018736516) strcat(s, "c");
if (crc32("QTZQRlzdXKi",11) == 2511221301) strcat(s, "u");
if (crc32("ycopmRU",7) == 3374495148) strcat(s, "b");
if (crc32("ATsNT",5) == 1164414740) strcat(s, "h");
if (crc32("iYaRyHlDerwe",12) == 3217634317) strcat(s, "g");
if (crc32("RPqlLz",6) == 3066407426) strcat(s, "e");
if (crc32("ZXuiIuFMAz",10) == 4165124180) strcat(s, "o");
if (crc32("qeMVe",5) == 2803058885) strcat(s, "m");
if (crc32("yerOqUGUQl",10) == 411681492) strcat(s, "e");
if (crc32("MDUBrcLA",8) == 3476989747) strcat(s, "t");
if (crc32("HplTXigJuWRyd",13) == 3279646892) strcat(s, "h");
if (crc32("riFwGRodB",9) == 2535159845) strcat(s, "r");
if (crc32("dHgZASZTrcaA",12) == 2304505886) strcat(s, "i");
if (crc32("jYmCEzT",7) == 1040604833) strcat(s, "R");
if (crc32("oYptPWGSQMNlMB",14) == 4054582841) strcat(s, "c");
if (crc32("rbfqKPpUPoMaeV",14) == 677801471) strcat(s, "a");
if (crc32("fQXPKCkgNTBg",12) == 2496208684) strcat(s, "l");
if (crc32("AutSSmSwbZl",11) == 2559583173) strcat(s, "D");
if (crc32("LbunBNtoC",9) == 3347009844) strcat(s, "l");
if (crc32("UQDUFpbB",8) == 2864593780) strcat(s, "v");
if (crc32("RslEBZ",6) == 10879165) strcat(s, "y");
    return s;
}

char *basely_adverbs() {
    char *s = calloc(7);
    if (crc32("SyGHIxqvHskvY",13) == 3564169281) strcat(s, "b");
if (crc32("AQPmlm",6) == 2678507395) strcat(s, "V");
if (crc32("mNZDkWlsLaY",11) == 2428250179) strcat(s, "a");
if (crc32("VUytaTZyvR",10) == 570136756) strcat(s, "O");
if (crc32("UeWcTbLsZzg",11) == 217420663) strcat(s, "s");
if (crc32("GIVvMIMI",8) == 1733174369) strcat(s, "e");
if (crc32("zhuUBPGtfqcN",12) == 3048357077) strcat(s, "l");
if (crc32("VGCcJUbgUEborBy",15) == 3704495434) strcat(s, "K");
if (crc32("gNYorcqUa",9) == 2939693069) strcat(s, "y");
    return s;
}

char *imitatively_adverbs() {
    char *s = calloc(12);
    if (crc32("dnDanOij",8) == 449042322) strcat(s, "b");
if (crc32("rEkJrMDaUpM",11) == 2026654137) strcat(s, "i");
if (crc32("BUprrrthmkBhQF",14) == 1244225383) strcat(s, "m");
if (crc32("bRhdUjapRRV",11) == 2540941967) strcat(s, "X");
if (crc32("fTwxRjg",7) == 613471716) strcat(s, "i");
if (crc32("HXRmttDgZP",10) == 1783591021) strcat(s, "J");
if (crc32("OhgExZRjVIcU",12) == 3659743536) strcat(s, "t");
if (crc32("aCDbZabeoWM",11) == 33591235) strcat(s, "X");
if (crc32("mEMPqf",6) == 42748052) strcat(s, "a");
if (crc32("CAjcXaaJy",9) == 339261542) strcat(s, "f");
if (crc32("VKOZAsva",8) == 168103319) strcat(s, "t");
if (crc32("VPrGrRiy",8) == 1248817075) strcat(s, "i");
if (crc32("DbsTlQxug",9) == 3701034233) strcat(s, "x");
if (crc32("KAbOeNbh",8) == 241719650) strcat(s, "v");
if (crc32("oGqiKiJzS",9) == 2310311621) strcat(s, "s");
if (crc32("noxpsVXAowT",11) == 3448623037) strcat(s, "e");
if (crc32("pwvoTdWsjqrztJ",14) == 4023141609) strcat(s, "l");
if (crc32("WFqent",6) == 1676022905) strcat(s, "r");
if (crc32("NgLNORNERdL",11) == 1912342349) strcat(s, "y");
    return s;
}

char *appealingly_adverbs() {
    char *s = calloc(12);
    if (crc32("kKmACZrFRSTkGAN",15) == 2394703382) strcat(s, "x");
if (crc32("AcXpl",5) == 2209805700) strcat(s, "a");
if (crc32("XQwGudbSLEMtscH",15) == 2221265460) strcat(s, "m");
if (crc32("qjmeDcoh",8) == 810392932) strcat(s, "p");
if (crc32("ZgryAOm",7) == 2526941878) strcat(s, "Y");
if (crc32("eYsGqBKnqaJk",12) == 3586773487) strcat(s, "p");
if (crc32("WVroHxUAIALt",12) == 3189440707) strcat(s, "A");
if (crc32("kDQAUtbU",8) == 424086279) strcat(s, "e");
if (crc32("UoKiIW",6) == 1799591437) strcat(s, "Z");
if (crc32("VFOpG",5) == 1934601647) strcat(s, "a");
if (crc32("ExDdOTLr",8) == 865627633) strcat(s, "f");
if (crc32("AZAQWhVT",8) == 1446926061) strcat(s, "l");
if (crc32("PeDTC",5) == 1192865966) strcat(s, "t");
if (crc32("BWVtfCTHdNsu",12) == 2576069592) strcat(s, "i");
if (crc32("GyswTYtYjlI",11) == 2087247859) strcat(s, "d");
if (crc32("GTtuQJnBci",10) == 567322511) strcat(s, "n");
if (crc32("eteEWPub",8) == 3870709810) strcat(s, "g");
if (crc32("tktErsnkoZcnPSQ",15) == 3696047641) strcat(s, "l");
if (crc32("SCrVKmvY",8) == 1561944678) strcat(s, "y");
    return s;
}

char *laboringly_adverbs() {
    char *s = calloc(11);
    if (crc32("USJMAQdjQ",9) == 2354728890) strcat(s, "l");
if (crc32("etPmfipuiPuVR",13) == 1418244712) strcat(s, "a");
if (crc32("ueSnNNDGx",9) == 4001918237) strcat(s, "b");
if (crc32("KwqCd",5) == 4264170728) strcat(s, "j");
if (crc32("YYbrq",5) == 880566047) strcat(s, "o");
if (crc32("PXipPV",6) == 3700996792) strcat(s, "i");
if (crc32("tofBVJlaxdqcmGO",15) == 4108740258) strcat(s, "r");
if (crc32("UPtDAvkqix",10) == 3084401967) strcat(s, "i");
if (crc32("xJdyeXXflfYwv",13) == 351194535) strcat(s, "H");
if (crc32("QWWXvriF",8) == 831860856) strcat(s, "n");
if (crc32("ynFQi",5) == 3704991074) strcat(s, "f");
if (crc32("vBYtA",5) == 2823334415) strcat(s, "g");
if (crc32("MNsjaHpzPrT",11) == 1342463546) strcat(s, "l");
if (crc32("VoJeJUGOcurWscU",15) == 3041612447) strcat(s, "m");
if (crc32("EPxYCnEkzZsbRN",14) == 3327413042) strcat(s, "y");
    return s;
}

char *insecurely_adverbs() {
    char *s = calloc(11);
    if (crc32("oDrySVWuZ",9) == 4145224419) strcat(s, "g");
if (crc32("ftLbP",5) == 1898802766) strcat(s, "i");
if (crc32("fhDuKmHmMZkCM",13) == 3187803256) strcat(s, "n");
if (crc32("jNbZMNVe",8) == 1300949138) strcat(s, "W");
if (crc32("yAAsxHGaQYn",11) == 2372852868) strcat(s, "s");
if (crc32("sGNbg",5) == 2744366092) strcat(s, "k");
if (crc32("tCwQfddx",8) == 626223211) strcat(s, "e");
if (crc32("UArXKQvOFCH",11) == 1074918448) strcat(s, "L");
if (crc32("gdSfYRGyFQkgLl",14) == 594357704) strcat(s, "c");
if (crc32("mFrKmrkopCAzq",13) == 2507862629) strcat(s, "c");
if (crc32("cZhEQf",6) == 3266524034) strcat(s, "u");
if (crc32("FVbmKq",6) == 3125234176) strcat(s, "O");
if (crc32("YPpaJg",6) == 1496999336) strcat(s, "r");
if (crc32("uJZTRzdblXvSPtO",15) == 3988499263) strcat(s, "e");
if (crc32("FEcasTqr",8) == 750894189) strcat(s, "l");
if (crc32("xJeDyoGaiSks",12) == 3192754358) strcat(s, "D");
if (crc32("OReLlyAGvtkyDlr",15) == 4099752765) strcat(s, "y");
    return s;
}

char *thereinafter_adverbs() {
    char *s = calloc(13);
    if (crc32("IhyzPVmjE",9) == 3710250207) strcat(s, "m");
if (crc32("KsqIRzTFNksq",12) == 900744735) strcat(s, "t");
if (crc32("CeMwRiK",7) == 416260280) strcat(s, "c");
if (crc32("PMWXym",6) == 3835994853) strcat(s, "h");
if (crc32("wKusDwnZyo",10) == 3572621194) strcat(s, "e");
if (crc32("BZirpvtGsbVNp",13) == 884562971) strcat(s, "r");
if (crc32("grcEPpTIZW",10) == 1032902305) strcat(s, "e");
if (crc32("MUHTHcKscHc",11) == 1051660199) strcat(s, "b");
if (crc32("WFvGMGt",7) == 1113384617) strcat(s, "i");
if (crc32("GuWynyVtsUws",12) == 209524156) strcat(s, "J");
if (crc32("bYzUOCmBfNwBE",13) == 1972357701) strcat(s, "n");
if (crc32("SxYtVpS",7) == 202510899) strcat(s, "a");
if (crc32("rBpIMQf",7) == 3304518792) strcat(s, "f");
if (crc32("TNUevgfvxxo",11) == 4100892578) strcat(s, "g");
if (crc32("jLTzkQ",6) == 46309034) strcat(s, "t");
if (crc32("wuatncqmaRV",11) == 314970084) strcat(s, "c");
if (crc32("PxkdzC",6) == 3977416946) strcat(s, "e");
if (crc32("mXWfdySgHi",10) == 2368161529) strcat(s, "H");
if (crc32("DrwVpQg",7) == 3939614401) strcat(s, "r");
    return s;
}

char *allogenically_adverbs() {
    char *s = calloc(14);
    if (crc32("PDkmTVFH",8) == 2599659228) strcat(s, "S");
if (crc32("fuJAMA",6) == 2678078907) strcat(s, "a");
if (crc32("SXvHHuLeCAdOI",13) == 1259701735) strcat(s, "l");
if (crc32("CbTOpYyspxSFQ",13) == 2421210463) strcat(s, "w");
if (crc32("ypgDejAJOJTvzOQ",15) == 908668853) strcat(s, "l");
if (crc32("jKmyoHfPMiaSBEz",15) == 21763679) strcat(s, "o");
if (crc32("gtZzQgpRDnXJjlM",15) == 1369237080) strcat(s, "f");
if (crc32("srUdz",5) == 1649467343) strcat(s, "g");
if (crc32("zKhZB",5) == 1061955059) strcat(s, "d");
if (crc32("zKidOgv",7) == 2022784072) strcat(s, "e");
if (crc32("UVvszfAiTEXl",12) == 2970145875) strcat(s, "q");
if (crc32("IsvVMBUdTZlsK",13) == 2939833410) strcat(s, "n");
if (crc32("usqLVIvFJulo",12) == 2065029522) strcat(s, "i");
if (crc32("pyhGMytsgtjFHFV",15) == 4098927001) strcat(s, "c");
if (crc32("HqEDndEvCa",10) == 454896405) strcat(s, "a");
if (crc32("IrrjyYSCjdAZ",12) == 2720150153) strcat(s, "l");
if (crc32("RaMTamUdIzc",11) == 3991218447) strcat(s, "a");
if (crc32("xUpyaalS",8) == 1698630071) strcat(s, "l");
if (crc32("ZwoGddKrUVZ",11) == 3271806697) strcat(s, "n");
if (crc32("khuUWbYUJIYvPRh",15) == 2753388142) strcat(s, "y");
    return s;
}

char *overtrustfully_adverbs() {
    char *s = calloc(15);
    if (crc32("mPHHgbPoqYseHa",14) == 276434981) strcat(s, "o");
if (crc32("qtgnEXKAfA",10) == 237899818) strcat(s, "v");
if (crc32("rNGuLVAqKxr",11) == 3652673503) strcat(s, "e");
if (crc32("xvLnuEl",7) == 1113237022) strcat(s, "r");
if (crc32("HlTDw",5) == 4002432220) strcat(s, "t");
if (crc32("gCXrn",5) == 1417834868) strcat(s, "f");
if (crc32("jlVJvtyHWlBCVM",14) == 2220810535) strcat(s, "r");
if (crc32("JDRiYkPDNzSkmlr",15) == 3035969244) strcat(s, "g");
if (crc32("GkAco",5) == 575905820) strcat(s, "u");
if (crc32("lTyFqFvrmW",10) == 1680872054) strcat(s, "s");
if (crc32("BqYpmDQ",7) == 416078716) strcat(s, "s");
if (crc32("yGvfBpj",7) == 3748288064) strcat(s, "f");
if (crc32("JSIWgOzTe",9) == 3825754816) strcat(s, "t");
if (crc32("fwMuYCdL",8) == 1656700500) strcat(s, "f");
if (crc32("aVLXOmOqrjXGosV",15) == 4149116173) strcat(s, "u");
if (crc32("GMaGoGEyHzkNK",13) == 806616786) strcat(s, "W");
if (crc32("pgCFJDBWO",9) == 114604530) strcat(s, "l");
if (crc32("zOXgIlcRUllZ",12) == 726017951) strcat(s, "l");
if (crc32("EukLWjurwixhdn",14) == 4210785357) strcat(s, "y");
    return s;
}

char *halfannoyingly_adverbs() {
    char *s = calloc(15);
    if (crc32("rXVZDNgHUcG",11) == 1346061577) strcat(s, "g");
if (crc32("xvFlQA",6) == 2112361430) strcat(s, "h");
if (crc32("NaAkhQMGyqDkw",13) == 2485455479) strcat(s, "a");
if (crc32("hPauevEmGPcEdU",14) == 188775609) strcat(s, "l");
if (crc32("FRXjNcHF",8) == 2608886324) strcat(s, "f");
if (crc32("dJvKJOwXLm",10) == 325359137) strcat(s, "T");
if (crc32("cLDJVYUB",8) == 3966935874) strcat(s, "a");
if (crc32("BynfTzqdd",9) == 2000309789) strcat(s, "n");
if (crc32("usQcVLRaMCvAE",13) == 3865647147) strcat(s, "n");
if (crc32("vyqLlPgKNpx",11) == 230392474) strcat(s, "C");
if (crc32("WQXikGXSFODUog",14) == 496336506) strcat(s, "o");
if (crc32("imVBI",5) == 1944795695) strcat(s, "L");
if (crc32("pihgiAgodbiIhzy",15) == 1646311839) strcat(s, "y");
if (crc32("GONLbz",6) == 275742129) strcat(s, "A");
if (crc32("TPGVShLRpO",10) == 377775666) strcat(s, "i");
if (crc32("DeeYxCZvoOg",11) == 3947224379) strcat(s, "n");
if (crc32("mHTHkCgDZRj",11) == 3551853753) strcat(s, "g");
if (crc32("DewqEslOiAsYw",13) == 1287962509) strcat(s, "l");
if (crc32("uEAPOMdjTe",10) == 1312424007) strcat(s, "K");
if (crc32("jHNsQsgkCYl",11) == 4070492198) strcat(s, "y");
    return s;
}

char *germinally_adverbs() {
    char *s = calloc(11);
    if (crc32("xSAZzCGmAo",10) == 3893400167) strcat(s, "g");
if (crc32("CdylNiIHxwt",11) == 2048775122) strcat(s, "e");
if (crc32("aEdujRAARFVzP",13) == 1454145434) strcat(s, "r");
if (crc32("WFFGe",5) == 77160000) strcat(s, "m");
if (crc32("ulluDibDBqocuZ",14) == 3121134486) strcat(s, "i");
if (crc32("DYokSSnBzPcSi",13) == 2815426764) strcat(s, "n");
if (crc32("xEyMyEOlQCTqAh",14) == 1295315772) strcat(s, "a");
if (crc32("rAdWeGAYE",9) == 1599989075) strcat(s, "Z");
if (crc32("VoOhuJJzGEhd",12) == 1840655114) strcat(s, "l");
if (crc32("hzgtEVCGN",9) == 3228927613) strcat(s, "l");
if (crc32("ikREBsYwHMcemDV",15) == 1463191798) strcat(s, "u");
if (crc32("OEwEQXOYMOwcbm",14) == 4186019877) strcat(s, "y");
    return s;
}

char *transversally_adverbs() {
    char *s = calloc(14);
    if (crc32("OoDENbPBjFL",11) == 685230460) strcat(s, "t");
if (crc32("Mgmnszv",7) == 756765845) strcat(s, "r");
if (crc32("tlOOX",5) == 2330244592) strcat(s, "I");
if (crc32("twLzxqOpY",9) == 2561546744) strcat(s, "a");
if (crc32("hxnVOr",6) == 3873773170) strcat(s, "n");
if (crc32("pGGwVRNIdHil",12) == 2271065632) strcat(s, "w");
if (crc32("JipGoF",6) == 3893572993) strcat(s, "s");
if (crc32("fhISAXnmOM",10) == 1284529427) strcat(s, "s");
if (crc32("LFabhkees",9) == 2204056822) strcat(s, "v");
if (crc32("EheOAIUAOvOWY",13) == 2366902566) strcat(s, "e");
if (crc32("aeRZMKilzm",10) == 640218927) strcat(s, "r");
if (crc32("XLILFErlWlnjYBL",15) == 3625229827) strcat(s, "s");
if (crc32("WsPSYjL",7) == 3745126722) strcat(s, "U");
if (crc32("cDbUeXNXmtGa",12) == 90588105) strcat(s, "a");
if (crc32("TGEmwBfdXkRoAOd",15) == 3362415760) strcat(s, "l");
if (crc32("hrYWOondqrX",11) == 4135790368) strcat(s, "p");
if (crc32("maKlbmIDsEzH",12) == 3757595615) strcat(s, "l");
if (crc32("RHvbU",5) == 3337069528) strcat(s, "y");
    return s;
}

char *villainously_adverbs() {
    char *s = calloc(13);
    if (crc32("jMHUIvJbJvCLt",13) == 1048865138) strcat(s, "v");
if (crc32("ozEBNExDDcY",11) == 2778078952) strcat(s, "u");
if (crc32("DfgXPeyQKbuJL",13) == 2880620044) strcat(s, "i");
if (crc32("ZKZArwQoNyzyqF",14) == 183259377) strcat(s, "l");
if (crc32("nAbnqDJaqmZsUy",14) == 1760799471) strcat(s, "U");
if (crc32("WxztZXsfTXlHG",13) == 2324285282) strcat(s, "l");
if (crc32("ZihaCBPChekQ",12) == 1117291461) strcat(s, "a");
if (crc32("Gyqfo",5) == 2170498781) strcat(s, "i");
if (crc32("DqzuR",5) == 916037248) strcat(s, "n");
if (crc32("ILfKlGuyExfxiF",14) == 1041570804) strcat(s, "o");
if (crc32("ilKyfy",6) == 3484478503) strcat(s, "u");
if (crc32("dECRgGdUpq",10) == 2516039756) strcat(s, "s");
if (crc32("hMKjtPwf",8) == 3114522554) strcat(s, "l");
if (crc32("QKkynwF",7) == 940344102) strcat(s, "y");
    return s;
}

char *unsardonically_adverbs() {
    char *s = calloc(15);
    if (crc32("XmpBQVmZSzGmnIg",15) == 2223467594) strcat(s, "u");
if (crc32("gFbnSxyXMDcSN",13) == 923615153) strcat(s, "n");
if (crc32("vRqWuXQLfEbAFO",14) == 1777209430) strcat(s, "s");
if (crc32("fZzuq",5) == 4238585109) strcat(s, "X");
if (crc32("BJpTOkmJdLEDLK",14) == 1752998731) strcat(s, "a");
if (crc32("WQWLZKqiFnEwRwL",15) == 1859916046) strcat(s, "b");
if (crc32("QwbUuRQSwbKJ",12) == 912389888) strcat(s, "r");
if (crc32("AZybtJ",6) == 534062346) strcat(s, "s");
if (crc32("GeoivxqfWgpVm",13) == 1590350729) strcat(s, "d");
if (crc32("ZpoMveAD",8) == 2364984445) strcat(s, "o");
if (crc32("UzmvJhDcIObgm",13) == 497653800) strcat(s, "t");
if (crc32("HfZBISYaNldGLlx",15) == 2613091486) strcat(s, "n");
if (crc32("waFnhc",6) == 2250175137) strcat(s, "i");
if (crc32("QqShqtteIVuajd",14) == 3793671455) strcat(s, "a");
if (crc32("VOhND",5) == 3951687815) strcat(s, "c");
if (crc32("TZNUupDDOsMRl",13) == 4011539325) strcat(s, "q");
if (crc32("ErfpaHkcUqoAZ",13) == 2635679255) strcat(s, "a");
if (crc32("CzODIexPN",9) == 841670396) strcat(s, "l");
if (crc32("bmcKSIZauZw",11) == 1097033335) strcat(s, "l");
if (crc32("XOkyHyiMABi",11) == 2324604197) strcat(s, "y");
    return s;
}

char *unheartily_adverbs() {
    char *s = calloc(11);
    if (crc32("sSwdTcrcZ",9) == 258249069) strcat(s, "i");
if (crc32("qvmcTFvEtemXTAC",15) == 2546616189) strcat(s, "u");
if (crc32("TyZMh",5) == 2048066116) strcat(s, "n");
if (crc32("aBqjD",5) == 306308396) strcat(s, "z");
if (crc32("eNjDkodTSxMYOk",14) == 4153841177) strcat(s, "h");
if (crc32("fuyygbDyLXwRiQj",15) == 3246683916) strcat(s, "e");
if (crc32("NbFUJJsvpRTSWz",14) == 2861330560) strcat(s, "a");
if (crc32("gxhESZSehel",11) == 864906558) strcat(s, "S");
if (crc32("PIgSPyL",7) == 2305787848) strcat(s, "r");
if (crc32("haKND",5) == 2407456468) strcat(s, "t");
if (crc32("IDuXOaoT",8) == 3023651908) strcat(s, "i");
if (crc32("ihLyQWC",7) == 2000867510) strcat(s, "s");
if (crc32("NBfIzkKSlGdHSg",14) == 2833070933) strcat(s, "l");
if (crc32("FHNPOhchNSwqy",13) == 1606102508) strcat(s, "g");
if (crc32("eSrtxWDvx",9) == 255866050) strcat(s, "y");
    return s;
}

char *uncategorically_adverbs() {
    char *s = calloc(16);
    if (crc32("yHQoTfYUYEDW",12) == 2337286550) strcat(s, "a");
if (crc32("pxVUgtXGpq",10) == 3605941707) strcat(s, "u");
if (crc32("UjLRzbR",7) == 841061192) strcat(s, "n");
if (crc32("xaiRBmzVh",9) == 4090146629) strcat(s, "c");
if (crc32("RWjlMsqCCQOMLm",14) == 347774735) strcat(s, "a");
if (crc32("bgpSulhKSPa",11) == 3309989689) strcat(s, "a");
if (crc32("cnLFHp",6) == 3570448317) strcat(s, "t");
if (crc32("BQArrFxnj",9) == 2522360463) strcat(s, "d");
if (crc32("bmpex",5) == 4265210450) strcat(s, "e");
if (crc32("hvpPHlkmoqa",11) == 226002502) strcat(s, "c");
if (crc32("zPJbjNFKNX",10) == 1402055457) strcat(s, "g");
if (crc32("FbRpRPctySCd",12) == 3201535657) strcat(s, "o");
if (crc32("CrwkSZAyHzaL",12) == 944052839) strcat(s, "r");
if (crc32("xDXWidfk",8) == 537539299) strcat(s, "i");
if (crc32("GfrAmZH",7) == 191123727) strcat(s, "y");
if (crc32("wTPsqE",6) == 3344880082) strcat(s, "c");
if (crc32("NTXPkyxlYIhhJl",14) == 509738421) strcat(s, "a");
if (crc32("TIczh",5) == 3583739177) strcat(s, "K");
if (crc32("bhiHGjuhfo",10) == 1546858735) strcat(s, "l");
if (crc32("iggtZod",7) == 2423065715) strcat(s, "l");
if (crc32("kYOqx",5) == 2381941293) strcat(s, "y");
    return s;
}

char *pausefully_adverbs() {
    char *s = calloc(11);
    if (crc32("ZXFQG",5) == 2234994286) strcat(s, "p");
if (crc32("BgiyAuAkrZlLg",13) == 3955847729) strcat(s, "a");
if (crc32("GgKdEqSPeaRnYy",14) == 1553585630) strcat(s, "J");
if (crc32("FaBfdAjiAIfq",12) == 1127309092) strcat(s, "u");
if (crc32("OZlnOuF",7) == 3006286056) strcat(s, "s");
if (crc32("MpbWYFSXBpSW",12) == 2550315427) strcat(s, "w");
if (crc32("SeNfussPaKB",11) == 957527663) strcat(s, "e");
if (crc32("HDwDBWeBhNOhnUg",15) == 698336490) strcat(s, "f");
if (crc32("tArBy",5) == 1429984875) strcat(s, "u");
if (crc32("UkZcVxYWEYJKzC",14) == 4011299669) strcat(s, "A");
if (crc32("clUrG",5) == 4136014119) strcat(s, "l");
if (crc32("PWvDpxr",7) == 3234488125) strcat(s, "l");
if (crc32("bdkwXymR",8) == 2709226175) strcat(s, "y");
    return s;
}

char *edgily_adverbs() {
    char *s = calloc(7);
    if (crc32("bukEQlThVmdIeLb",15) == 2209074507) strcat(s, "e");
if (crc32("FMceNaCZWT",10) == 883902798) strcat(s, "V");
if (crc32("WCQgnbPmSo",10) == 2656379966) strcat(s, "d");
if (crc32("vvFnIqxzFnP",11) == 3596744464) strcat(s, "g");
if (crc32("bPYSecAm",8) == 469986517) strcat(s, "i");
if (crc32("mWPOM",5) == 3798610861) strcat(s, "l");
if (crc32("BIFJteQtxwLQM",13) == 2819791048) strcat(s, "W");
if (crc32("YDTeqMnm",8) == 981358228) strcat(s, "y");
    return s;
}

char *indirectly_adverbs() {
    char *s = calloc(11);
    if (crc32("rDgLGc",6) == 4004094430) strcat(s, "i");
if (crc32("nmKrqOczqE",10) == 3560078528) strcat(s, "n");
if (crc32("fUCPUHvFwRw",11) == 1926012208) strcat(s, "u");
if (crc32("BzQaFXf",7) == 3222012375) strcat(s, "d");
if (crc32("kbbPooCqI",9) == 1619267544) strcat(s, "p");
if (crc32("phVoMQSDl",9) == 3241856723) strcat(s, "i");
if (crc32("Llwioaix",8) == 364014013) strcat(s, "r");
if (crc32("koJVo",5) == 2419401924) strcat(s, "w");
if (crc32("MsmtpHXO",8) == 867528657) strcat(s, "e");
if (crc32("XuBHBzApF",9) == 482718992) strcat(s, "c");
if (crc32("XWJtdYWO",8) == 1672637919) strcat(s, "t");
if (crc32("hrpeFCKxw",9) == 1355595847) strcat(s, "l");
if (crc32("PhnBbJWCu",9) == 2346667837) strcat(s, "y");
    return s;
}

char *semiactively_adverbs() {
    char *s = calloc(13);
    if (crc32("ZPpIeCaEDTJ",11) == 3915665575) strcat(s, "s");
if (crc32("Psqggf",6) == 938658266) strcat(s, "V");
if (crc32("VzazRvg",7) == 311157508) strcat(s, "e");
if (crc32("VBkiuOuDqy",10) == 2173216596) strcat(s, "m");
if (crc32("rrfKXpakK",9) == 1723614568) strcat(s, "b");
if (crc32("SzagnOWVXwHxe",13) == 3584897667) strcat(s, "i");
if (crc32("hdHsHvakDMC",11) == 1575461818) strcat(s, "l");
if (crc32("YfeheoVbIKOtwW",14) == 2515047245) strcat(s, "a");
if (crc32("HVlgTqNhFERZZz",14) == 2709665157) strcat(s, "m");
if (crc32("QWveo",5) == 7393716) strcat(s, "c");
if (crc32("kjBUIkOd",8) == 1677309806) strcat(s, "V");
if (crc32("CcbNtOCr",8) == 542504326) strcat(s, "t");
if (crc32("bXcBtyNQ",8) == 2417316940) strcat(s, "O");
if (crc32("WqlfMmWMHkXJ",12) == 4284518752) strcat(s, "i");
if (crc32("kmktqwCLZlsje",13) == 1744752585) strcat(s, "v");
if (crc32("JNFskhN",7) == 2663290167) strcat(s, "e");
if (crc32("HkgiLk",6) == 3529369611) strcat(s, "n");
if (crc32("EcGTdEH",7) == 290780646) strcat(s, "l");
if (crc32("QMzzEsoQsI",10) == 279750201) strcat(s, "X");
if (crc32("fqowoylvPF",10) == 4047982076) strcat(s, "y");
    return s;
}

char *nonebulliently_adverbs() {
    char *s = calloc(15);
    if (crc32("CRYXiQ",6) == 3750849795) strcat(s, "n");
if (crc32("eBFctdqZzKpqD",13) == 908731605) strcat(s, "n");
if (crc32("XcoKi",5) == 3116873412) strcat(s, "Y");
if (crc32("QYTXENPMchm",11) == 2557546841) strcat(s, "o");
if (crc32("pPRctx",6) == 3169555461) strcat(s, "n");
if (crc32("ylAhRdcorSj",11) == 2963732442) strcat(s, "H");
if (crc32("UekKMZswNvc",11) == 3907566902) strcat(s, "e");
if (crc32("PZQwmLUaHPYGP",13) == 564847673) strcat(s, "V");
if (crc32("fajWH",5) == 2608310609) strcat(s, "b");
if (crc32("fnDYT",5) == 4144210827) strcat(s, "K");
if (crc32("GytQUhZiZuZq",12) == 767489077) strcat(s, "u");
if (crc32("cKRLhXc",7) == 3859301368) strcat(s, "B");
if (crc32("IKWFXr",6) == 1477612154) strcat(s, "l");
if (crc32("gmbAoxtFKGs",11) == 2206908397) strcat(s, "l");
if (crc32("IBGSnCpMDAtBrQ",14) == 2162365204) strcat(s, "i");
if (crc32("FygfmZFurNv",11) == 1673101360) strcat(s, "j");
if (crc32("rasMv",5) == 1823270812) strcat(s, "e");
if (crc32("JvRgB",5) == 3766108374) strcat(s, "y");
if (crc32("cxEEMswKrruTzVE",15) == 1310867787) strcat(s, "n");
if (crc32("TkFMlhQ",7) == 1720545987) strcat(s, "t");
if (crc32("GWYMslHgfQr",11) == 2657096338) strcat(s, "l");
if (crc32("fFGetxMgInP",11) == 2218761296) strcat(s, "d");
if (crc32("OssuVZkppS",10) == 342228958) strcat(s, "y");
    return s;
}

char *gerundively_adverbs() {
    char *s = calloc(12);
    if (crc32("TBAXefmlseGZz",13) == 98997981) strcat(s, "g");
if (crc32("TVHDln",6) == 1925439886) strcat(s, "y");
if (crc32("OWQjHkDYcNR",11) == 4266816958) strcat(s, "e");
if (crc32("NKYsmJuUENVYr",13) == 233690344) strcat(s, "y");
if (crc32("rVFlGqTrprre",12) == 1804447760) strcat(s, "r");
if (crc32("qSWzFOs",7) == 421703589) strcat(s, "u");
if (crc32("Yhkcxo",6) == 3089801249) strcat(s, "q");
if (crc32("StXOugupvVb",11) == 2730753293) strcat(s, "n");
if (crc32("rKtigKfg",8) == 899680083) strcat(s, "F");
if (crc32("HlpGKShLQagr",12) == 3937655174) strcat(s, "d");
if (crc32("BxaEiCBm",8) == 253917306) strcat(s, "m");
if (crc32("exBXQYSe",8) == 3570345519) strcat(s, "i");
if (crc32("eleuhNiZVTPgRv",14) == 1214423701) strcat(s, "R");
if (crc32("HcNmJzGwZR",10) == 1385309578) strcat(s, "v");
if (crc32("pDKECEZBVux",11) == 4264664917) strcat(s, "H");
if (crc32("MbRwCOEvMnUTis",14) == 2885423740) strcat(s, "e");
if (crc32("YsxiWmjmw",9) == 2789604544) strcat(s, "L");
if (crc32("BemRRiztYYHra",13) == 3580730802) strcat(s, "l");
if (crc32("QubKIuIlPMU",11) == 3934925718) strcat(s, "G");
if (crc32("ZWVvqIVsKoTwUq",14) == 993935633) strcat(s, "y");
    return s;
}

char *succulently_adverbs() {
    char *s = calloc(12);
    if (crc32("uqkuLUnvC",9) == 1367683132) strcat(s, "f");
if (crc32("wyhQXPjh",8) == 3857570542) strcat(s, "s");
if (crc32("cAbrDO",6) == 3572641534) strcat(s, "s");
if (crc32("yuwdWRIdm",9) == 1123912902) strcat(s, "u");
if (crc32("egsAVuq",7) == 3518150786) strcat(s, "c");
if (crc32("zfPBMaqYSA",10) == 2619209863) strcat(s, "c");
if (crc32("UDGGwHDcqR",10) == 3717227102) strcat(s, "C");
if (crc32("hdBVEKmNXD",10) == 3416640001) strcat(s, "u");
if (crc32("jslRRdH",7) == 849484559) strcat(s, "e");
if (crc32("RyrbStuZcshxDe",14) == 1268820143) strcat(s, "l");
if (crc32("xfqUAQYuyrwUD",13) == 717691781) strcat(s, "H");
if (crc32("QsEiWJKDfKLA",12) == 2071556314) strcat(s, "e");
if (crc32("MvWHnF",6) == 247044619) strcat(s, "D");
if (crc32("LLVOUHybhhDB",12) == 916708542) strcat(s, "n");
if (crc32("osyMOsBesi",10) == 4209428543) strcat(s, "y");
if (crc32("pSfLFxBqt",9) == 915738928) strcat(s, "t");
if (crc32("fzBAetyP",8) == 3593172824) strcat(s, "l");
if (crc32("dxYuJtiqxdU",11) == 592346358) strcat(s, "y");
    return s;
}

char *nonreproductively_adverbs() {
    char *s = calloc(18);
    if (crc32("FTlaxVydnrIlsux",15) == 1037073951) strcat(s, "n");
if (crc32("uWpRKIfoSwePIjo",15) == 2244050218) strcat(s, "p");
if (crc32("nURPaAilTA",10) == 1583581981) strcat(s, "o");
if (crc32("dapkglzyLHqbpPe",15) == 1870568487) strcat(s, "n");
if (crc32("WacZyxLb",8) == 1483087610) strcat(s, "r");
if (crc32("REixdJLoNTQR",12) == 2342167156) strcat(s, "e");
if (crc32("CsjgGWKv",8) == 1477856710) strcat(s, "p");
if (crc32("CwbhOpvQ",8) == 4111399222) strcat(s, "r");
if (crc32("SqEWBYMyMhhu",12) == 2519941509) strcat(s, "L");
if (crc32("spnmv",5) == 940829271) strcat(s, "o");
if (crc32("FwpTNB",6) == 3583185098) strcat(s, "d");
if (crc32("sPEnTmfc",8) == 2901326791) strcat(s, "Z");
if (crc32("PKsHDFiEIfOyi",13) == 2054052218) strcat(s, "u");
if (crc32("BXNkAZuIGxeeCQg",15) == 3004978799) strcat(s, "c");
if (crc32("fMuZhfRGasLpGmn",15) == 4093984192) strcat(s, "k");
if (crc32("thqlFfYDMWEb",12) == 3121316205) strcat(s, "t");
if (crc32("NTKhf",5) == 280284707) strcat(s, "i");
if (crc32("fNYLG",5) == 4128886965) strcat(s, "S");
if (crc32("fRgrONVEwzH",11) == 3633388417) strcat(s, "v");
if (crc32("ZHSfHDAA",8) == 2344790337) strcat(s, "e");
if (crc32("UgKQPAl",7) == 3889570910) strcat(s, "T");
if (crc32("eVohxwTc",8) == 412447276) strcat(s, "l");
if (crc32("tdzfTIC",7) == 517625009) strcat(s, "y");
    return s;
}

char *unspiritually_adverbs() {
    char *s = calloc(14);
    if (crc32("bOgsahpUiKewS",13) == 4048634084) strcat(s, "F");
if (crc32("uFOwGFWPFRIv",12) == 1714663519) strcat(s, "u");
if (crc32("iRXokMxv",8) == 784470854) strcat(s, "O");
if (crc32("BCRZYIGqVWlLxb",14) == 2042874332) strcat(s, "n");
if (crc32("mZNsrljPi",9) == 1374183454) strcat(s, "P");
if (crc32("fQlvTJlFFlTAj",13) == 740438209) strcat(s, "s");
if (crc32("JTLDCGs",7) == 2281312668) strcat(s, "m");
if (crc32("vxyRHDQNB",9) == 3306209922) strcat(s, "p");
if (crc32("eUncdXaanb",10) == 2599811552) strcat(s, "i");
if (crc32("DwbtvB",6) == 1301927118) strcat(s, "r");
if (crc32("Ioowmbb",7) == 3970923456) strcat(s, "i");
if (crc32("drQhaRYb",8) == 3316524078) strcat(s, "v");
if (crc32("dPclPIM",7) == 68361608) strcat(s, "t");
if (crc32("DsljRitSFxqzKZ",14) == 1690351036) strcat(s, "u");
if (crc32("basHWsj",7) == 1315374908) strcat(s, "S");
if (crc32("aImcLmjyLgVM",12) == 2516081177) strcat(s, "a");
if (crc32("jiDFvTeHDTzvKq",14) == 621559526) strcat(s, "H");
if (crc32("iWythMYG",8) == 1771723415) strcat(s, "l");
if (crc32("dZunBbvwQVg",11) == 510819105) strcat(s, "l");
if (crc32("mepuytCRwXQGXYZ",15) == 157481424) strcat(s, "Z");
if (crc32("kMmKdKpEsVHCWOe",15) == 1732436752) strcat(s, "y");
    return s;
}

char *astrictively_adverbs() {
    char *s = calloc(13);
    if (crc32("uqDxrl",6) == 956707883) strcat(s, "a");
if (crc32("yPlvWZV",7) == 871755806) strcat(s, "Z");
if (crc32("yRDuubo",7) == 2360644106) strcat(s, "s");
if (crc32("dvCkBP",6) == 808605409) strcat(s, "t");
if (crc32("rSNiSyZOjKH",11) == 1906217795) strcat(s, "O");
if (crc32("fNoNX",5) == 3814354350) strcat(s, "r");
if (crc32("eBpzHxe",7) == 1555425163) strcat(s, "G");
if (crc32("chkuBXy",7) == 1496536489) strcat(s, "i");
if (crc32("pfVNqeBWtz",10) == 2399554479) strcat(s, "c");
if (crc32("FMTrZGXD",8) == 1773658018) strcat(s, "t");
if (crc32("ofSZgIWHcO",10) == 1615853615) strcat(s, "H");
if (crc32("vTfumhbGF",9) == 4088526937) strcat(s, "i");
if (crc32("OTprbYEcaAbm",12) == 427921502) strcat(s, "k");
if (crc32("aDPpyuH",7) == 103262412) strcat(s, "v");
if (crc32("ZjObZtqNLbr",11) == 2395424779) strcat(s, "H");
if (crc32("OMnkDrFZckDUBe",14) == 1323758764) strcat(s, "e");
if (crc32("jcYorZv",7) == 3301647911) strcat(s, "l");
if (crc32("ybfAUtKi",8) == 1899550371) strcat(s, "n");
if (crc32("PrhZEPNHrnZPUq",14) == 2437926587) strcat(s, "y");
    return s;
}

char *synovially_adverbs() {
    char *s = calloc(11);
    if (crc32("SnSdPgxeZtesI",13) == 3207950110) strcat(s, "s");
if (crc32("AFCObbwGetj",11) == 1015351160) strcat(s, "p");
if (crc32("aZHoygyS",8) == 1369395562) strcat(s, "y");
if (crc32("lgrpDEaWTytNED",14) == 3390832964) strcat(s, "n");
if (crc32("oEVDUJqNXLeraP",14) == 679062280) strcat(s, "x");
if (crc32("oyVPu",5) == 965898866) strcat(s, "o");
if (crc32("XKMDNW",6) == 4213457217) strcat(s, "v");
if (crc32("pWRCqwMafbxYjZ",14) == 650313440) strcat(s, "i");
if (crc32("QPDsop",6) == 3198331405) strcat(s, "a");
if (crc32("MVJnxFF",7) == 3366180155) strcat(s, "l");
if (crc32("WrZvVdubrqwGU",13) == 3643386341) strcat(s, "l");
if (crc32("TvEpKexvAfRLxE",14) == 149878219) strcat(s, "y");
    return s;
}

char *sincerely_adverbs() {
    char *s = calloc(10);
    if (crc32("cVDUGJBk",8) == 2090357176) strcat(s, "s");
if (crc32("hEYpsOvQSwqs",12) == 1969054592) strcat(s, "F");
if (crc32("pFzIGgxBgAgCQoN",15) == 2680679843) strcat(s, "i");
if (crc32("qemYuQjhe",9) == 3473220619) strcat(s, "n");
if (crc32("KDJtuv",6) == 830739396) strcat(s, "e");
if (crc32("MTrnJtWNxdebM",13) == 2131907994) strcat(s, "c");
if (crc32("gzGvwSKHyl",10) == 3028985213) strcat(s, "u");
if (crc32("SuYoUXBueIbTnjS",15) == 1017216188) strcat(s, "e");
if (crc32("jLiJmaZlCT",10) == 1881246635) strcat(s, "r");
if (crc32("rLNKMBcQJnj",11) == 570484605) strcat(s, "U");
if (crc32("TneGL",5) == 1577501588) strcat(s, "e");
if (crc32("PwvTY",5) == 2495989009) strcat(s, "l");
if (crc32("hKhbo",5) == 4017617881) strcat(s, "y");
    return s;
}

char *revertively_adverbs() {
    char *s = calloc(12);
    if (crc32("FeATlCCVzf",10) == 2760100309) strcat(s, "r");
if (crc32("QWkxNsV",7) == 3039999267) strcat(s, "e");
if (crc32("sFXUiHamZRVd",12) == 4077265220) strcat(s, "v");
if (crc32("CauQkHQVfKnKZf",14) == 869870511) strcat(s, "Q");
if (crc32("DlJtRRozIbk",11) == 3177701168) strcat(s, "e");
if (crc32("fTeXGcePA",9) == 393412937) strcat(s, "r");
if (crc32("LkLYn",5) == 267775153) strcat(s, "t");
if (crc32("xfgze",5) == 2473595332) strcat(s, "M");
if (crc32("OpzXoxTngbo",11) == 1888193207) strcat(s, "i");
if (crc32("SxyNada",7) == 2875969032) strcat(s, "J");
if (crc32("ceBXSgZsmOD",11) == 2841827315) strcat(s, "v");
if (crc32("ZbweQdkH",8) == 1705144223) strcat(s, "H");
if (crc32("FBMgbuaGFSb",11) == 2578249849) strcat(s, "e");
if (crc32("kUbhvupIhdmj",12) == 3530672606) strcat(s, "B");
if (crc32("NpEeMOvvOElZdr",14) == 647647878) strcat(s, "l");
if (crc32("lGtkExzqFCqQGU",14) == 3050549435) strcat(s, "z");
if (crc32("ZdgZBVfI",8) == 3705948088) strcat(s, "y");
    return s;
}

char *admirably_adverbs() {
    char *s = calloc(10);
    if (crc32("pGMOjOitXS",10) == 3172796526) strcat(s, "y");
if (crc32("YxGMRmZNAmrda",13) == 1378422886) strcat(s, "a");
if (crc32("aUoyD",5) == 811240399) strcat(s, "D");
if (crc32("vIMQSCIQdfgsS",13) == 3225292013) strcat(s, "d");
if (crc32("TMNILvLE",8) == 3927992209) strcat(s, "h");
if (crc32("vFOdMGLasihSD",13) == 1170104750) strcat(s, "m");
if (crc32("HLPwItzrHbZFF",13) == 2205518272) strcat(s, "M");
if (crc32("wwOqBBFbypZmIG",14) == 2239168154) strcat(s, "i");
if (crc32("xshvJoJjG",9) == 2435774459) strcat(s, "r");
if (crc32("kPeSxkwqtamF",12) == 3767492709) strcat(s, "a");
if (crc32("JFwiTtWZm",9) == 1998137508) strcat(s, "b");
if (crc32("AuzXWBdqE",9) == 2818016472) strcat(s, "l");
if (crc32("UcyxszCX",8) == 3107824704) strcat(s, "y");
    return s;
}

char *antiracially_adverbs() {
    char *s = calloc(13);
    if (crc32("IrJnPMT",7) == 2260863443) strcat(s, "a");
if (crc32("YXZzg",5) == 767051636) strcat(s, "l");
if (crc32("IJlwOMNfcd",10) == 165787436) strcat(s, "n");
if (crc32("jacLvDT",7) == 1204629074) strcat(s, "c");
if (crc32("YPEzjgMCDtKoP",13) == 4177052407) strcat(s, "t");
if (crc32("OIEJOfNBRoTIKD",14) == 3437118489) strcat(s, "i");
if (crc32("BWLkU",5) == 555578540) strcat(s, "B");
if (crc32("esrWnkbycRDm",12) == 1425548081) strcat(s, "r");
if (crc32("YvAwgLiM",8) == 1277583710) strcat(s, "a");
if (crc32("gMevENwVy",9) == 2178341143) strcat(s, "t");
if (crc32("jaGjEhIL",8) == 2093529619) strcat(s, "c");
if (crc32("jNcVmunyQvEREU",14) == 3254563853) strcat(s, "i");
if (crc32("DTJLakYriSKB",12) == 2936098692) strcat(s, "a");
if (crc32("wOQomfnPqdKppxu",15) == 1532612393) strcat(s, "l");
if (crc32("ImWDdR",6) == 2204295935) strcat(s, "z");
if (crc32("ZJCrTuYdPmPT",12) == 1192654835) strcat(s, "l");
if (crc32("yUAee",5) == 3272009960) strcat(s, "F");
if (crc32("OvCboDr",7) == 364724015) strcat(s, "y");
    return s;
}

char *incandescently_adverbs() {
    char *s = calloc(15);
    if (crc32("VWDzbrwy",8) == 1308295204) strcat(s, "T");
if (crc32("FqVqO",5) == 2053430201) strcat(s, "i");
if (crc32("wSpPKxNbLBVChBI",15) == 3103876827) strcat(s, "r");
if (crc32("DjULnEuhsJIPWj",14) == 2407707081) strcat(s, "n");
if (crc32("rHEaytisxiwRLaz",15) == 3746752146) strcat(s, "c");
if (crc32("YnTKmWuoaoO",11) == 412991409) strcat(s, "a");
if (crc32("VPgctOawmtzF",12) == 1101183950) strcat(s, "A");
if (crc32("RVrVCidUdUvwx",13) == 1377599305) strcat(s, "n");
if (crc32("GUyTbDqYRMLRv",13) == 4176375859) strcat(s, "q");
if (crc32("mtiKhsSwTMFwzQG",15) == 535679928) strcat(s, "d");
if (crc32("FJhadHuaYJBrHjl",15) == 3730487409) strcat(s, "e");
if (crc32("zYbcQzUAZooW",12) == 515006739) strcat(s, "s");
if (crc32("uXTIGWl",7) == 742762865) strcat(s, "c");
if (crc32("yQJhXtHB",8) == 1349975589) strcat(s, "q");
if (crc32("PNRXjeUdIktJ",12) == 1617668963) strcat(s, "e");
if (crc32("eSfQZSiqbDqTO",13) == 3246183376) strcat(s, "n");
if (crc32("wwdPhe",6) == 2752748185) strcat(s, "t");
if (crc32("rXyOSZdhi",9) == 888552381) strcat(s, "l");
if (crc32("SorIMDqmAIUNN",13) == 1326072393) strcat(s, "y");
    return s;
}

char *unsolvably_adverbs() {
    char *s = calloc(11);
    if (crc32("zTZFDnpHGDRYR",13) == 2414481556) strcat(s, "u");
if (crc32("hZLqFShNCKBln",13) == 192280930) strcat(s, "n");
if (crc32("wPPlQcz",7) == 1655724701) strcat(s, "n");
if (crc32("sAQPo",5) == 1362114368) strcat(s, "s");
if (crc32("SFUYGNZeBTsoFLI",15) == 3922237529) strcat(s, "w");
if (crc32("RbKGe",5) == 3958471178) strcat(s, "o");
if (crc32("NSlLcijMXZyGj",13) == 240440779) strcat(s, "l");
if (crc32("jHGooDLb",8) == 3701195071) strcat(s, "A");
if (crc32("UjgZtXJCwCdmk",13) == 3421044262) strcat(s, "v");
if (crc32("ieeYsuUi",8) == 3324043724) strcat(s, "a");
if (crc32("eMaYeSke",8) == 3601230876) strcat(s, "U");
if (crc32("NDGgVTdg",8) == 2276082463) strcat(s, "b");
if (crc32("gkSStdkLyfjeG",13) == 2641511131) strcat(s, "W");
if (crc32("TskQcRaKKSNgR",13) == 2839929897) strcat(s, "l");
if (crc32("EnwROeuENuShi",13) == 2451969209) strcat(s, "G");
if (crc32("czTibPGpEBLP",12) == 3394000667) strcat(s, "y");
    return s;
}

char *muscularly_adverbs() {
    char *s = calloc(11);
    if (crc32("AJLgspOqg",9) == 1251914002) strcat(s, "m");
if (crc32("WVNOp",5) == 2081228103) strcat(s, "s");
if (crc32("rLbsVIWtxAC",11) == 1131181598) strcat(s, "u");
if (crc32("XtEYC",5) == 3440829781) strcat(s, "q");
if (crc32("OddRjJSHtXFEAJ",14) == 234569308) strcat(s, "s");
if (crc32("TNvflDkOp",9) == 2405928524) strcat(s, "c");
if (crc32("JfRXBCuHOrG",11) == 3796042614) strcat(s, "u");
if (crc32("iEsUBvCcJaDa",12) == 295585995) strcat(s, "P");
if (crc32("LSGDm",5) == 1348136632) strcat(s, "l");
if (crc32("JzuSfaF",7) == 2191339827) strcat(s, "c");
if (crc32("fXhyenwyhKbg",12) == 1204839519) strcat(s, "a");
if (crc32("ompfHoPUh",9) == 4280764875) strcat(s, "r");
if (crc32("tBKSyrirKEj",11) == 250952641) strcat(s, "l");
if (crc32("MCsfiNEB",8) == 275454348) strcat(s, "y");
    return s;
}

char *postprandially_adverbs() {
    char *s = calloc(15);
    if (crc32("QsyZBaumkEtaap",14) == 3816691886) strcat(s, "p");
if (crc32("SyWiLtqQr",9) == 2630641343) strcat(s, "C");
if (crc32("pjOPMYIfRk",10) == 1904757769) strcat(s, "o");
if (crc32("SLTScMVL",8) == 3460609354) strcat(s, "S");
if (crc32("FZhMs",5) == 2134785636) strcat(s, "s");
if (crc32("HDxoTRsvIRdd",12) == 285699900) strcat(s, "t");
if (crc32("hPeKxlVU",8) == 709206015) strcat(s, "p");
if (crc32("HhnTCAERbgB",11) == 788487526) strcat(s, "y");
if (crc32("gQQEV",5) == 4244193153) strcat(s, "r");
if (crc32("cTAreeO",7) == 2759659553) strcat(s, "a");
if (crc32("PhpuFhDNMbflzl",14) == 1524844879) strcat(s, "n");
if (crc32("YMAqVTskT",9) == 3890661120) strcat(s, "d");
if (crc32("zNKHfIktR",9) == 12915927) strcat(s, "k");
if (crc32("sLenSE",6) == 2028351767) strcat(s, "i");
if (crc32("MzATZcnuOVbS",12) == 3838422275) strcat(s, "a");
if (crc32("ZsxlF",5) == 3240023779) strcat(s, "l");
if (crc32("YevrNFuGuezxF",13) == 2632706530) strcat(s, "l");
if (crc32("CUjexGYSdkJ",11) == 1424619163) strcat(s, "y");
    return s;
}

char *harmfully_adverbs() {
    char *s = calloc(10);
    if (crc32("hfuHNTzAwWY",11) == 3090625153) strcat(s, "h");
if (crc32("cnvMhMLn",8) == 3988893828) strcat(s, "a");
if (crc32("JVNbsIdTjPT",11) == 1282806663) strcat(s, "e");
if (crc32("AoVpLGMRK",9) == 3876391968) strcat(s, "r");
if (crc32("KGSiYbO",7) == 577079712) strcat(s, "m");
if (crc32("EjXHhLqxBfM",11) == 3682700277) strcat(s, "f");
if (crc32("eKvahunXBZE",11) == 1297564741) strcat(s, "u");
if (crc32("cUawj",5) == 1867388973) strcat(s, "N");
if (crc32("ruPHHco",7) == 915645890) strcat(s, "l");
if (crc32("gLjiIbURZTgesh",14) == 920530340) strcat(s, "P");
if (crc32("djCDibrraRl",11) == 2603482199) strcat(s, "l");
if (crc32("NzViKK",6) == 4108029296) strcat(s, "F");
if (crc32("ocLzjncJ",8) == 3544475864) strcat(s, "y");
    return s;
}

char *facultatively_adverbs() {
    char *s = calloc(14);
    if (crc32("dPHpryRwf",9) == 137759201) strcat(s, "w");
if (crc32("MYMEwbibUJPDYyQ",15) == 682120483) strcat(s, "f");
if (crc32("afoBKzCuQCdae",13) == 2406770595) strcat(s, "a");
if (crc32("GjwOu",5) == 2119879823) strcat(s, "c");
if (crc32("lkCcatmbkmTiMf",14) == 892425004) strcat(s, "u");
if (crc32("YgRfHQZZEo",10) == 4233513451) strcat(s, "L");
if (crc32("cSxIIIgEQzWxqi",14) == 3158674980) strcat(s, "l");
if (crc32("jtaNpMG",7) == 3352440468) strcat(s, "A");
if (crc32("fcAQw",5) == 3847897696) strcat(s, "t");
if (crc32("mzYxvV",6) == 2705331768) strcat(s, "a");
if (crc32("NBmoVmYdUlg",11) == 3630066541) strcat(s, "Q");
if (crc32("qOPdwTDmzCFY",12) == 2143251492) strcat(s, "t");
if (crc32("vjHwG",5) == 3274322963) strcat(s, "n");
if (crc32("PlMiEWVyjb",10) == 271665784) strcat(s, "i");
if (crc32("HmCwxXrXJX",10) == 3324303127) strcat(s, "X");
if (crc32("kPNAL",5) == 264334806) strcat(s, "v");
if (crc32("DOKKcPUJ",8) == 1766459519) strcat(s, "n");
if (crc32("ofSvKTfOyXpNw",13) == 1849763020) strcat(s, "e");
if (crc32("OnCbZLNwZAvdD",13) == 609807940) strcat(s, "l");
if (crc32("nMESZOehfJcZh",13) == 554584113) strcat(s, "y");
    return s;
}

char *unreproductively_adverbs() {
    char *s = calloc(17);
    if (crc32("zukUQAFJdN",10) == 1293303763) strcat(s, "t");
if (crc32("YtBTPgwHXyJ",11) == 2683514483) strcat(s, "u");
if (crc32("TYOSWkrIZKZqnqH",15) == 119464894) strcat(s, "D");
if (crc32("ytqnFeYhvvAOsR",14) == 1460805357) strcat(s, "n");
if (crc32("IijHwEZGKagjgd",14) == 2652494956) strcat(s, "r");
if (crc32("vrSeport",8) == 3455551176) strcat(s, "e");
if (crc32("ZTnlvVhC",8) == 2041679537) strcat(s, "I");
if (crc32("ZmCOnXjOEci",11) == 3848495129) strcat(s, "p");
if (crc32("KedWrZKBhVW",11) == 2745306931) strcat(s, "F");
if (crc32("xIBPPxevyCKSki",14) == 3495513378) strcat(s, "r");
if (crc32("AnadYDyJKdQyW",13) == 1402729142) strcat(s, "O");
if (crc32("ScmLrLRGebYjfP",14) == 531690730) strcat(s, "o");
if (crc32("LgmPkdJAAd",10) == 3522291049) strcat(s, "Q");
if (crc32("xoIuYVacjSiyAiY",15) == 270674228) strcat(s, "d");
if (crc32("FPhvmx",6) == 1890820339) strcat(s, "u");
if (crc32("eXLNJifIjMJYsX",14) == 3737804363) strcat(s, "F");
if (crc32("oaevXFdHES",10) == 486722035) strcat(s, "c");
if (crc32("zseJGPlbRdldq",13) == 52860493) strcat(s, "t");
if (crc32("cAOZyUllvHYTEKl",15) == 3486615294) strcat(s, "i");
if (crc32("AiDnt",5) == 743902674) strcat(s, "C");
if (crc32("aZDYWWVSSjXcaWC",15) == 486078298) strcat(s, "v");
if (crc32("ZSdaFCHBvj",10) == 121007092) strcat(s, "J");
if (crc32("dsFAbfGyn",9) == 4196094632) strcat(s, "e");
if (crc32("rLbyNU",6) == 3588166534) strcat(s, "l");
if (crc32("OTvWa",5) == 1861621279) strcat(s, "d");
if (crc32("UrQHvxLoc",9) == 3243721290) strcat(s, "y");
    return s;
}

char *rightly_adverbs() {
    char *s = calloc(8);
    if (crc32("pLRiCqykzF",10) == 1911353283) strcat(s, "r");
if (crc32("rylIdcbVJpIVM",13) == 4072499065) strcat(s, "n");
if (crc32("yYvvxU",6) == 1243868471) strcat(s, "i");
if (crc32("mKxIgVqyuD",10) == 3149849024) strcat(s, "l");
if (crc32("dkuPAxNHkyr",11) == 4119154552) strcat(s, "g");
if (crc32("YaeatxPi",8) == 654869148) strcat(s, "o");
if (crc32("ZjFLtCXE",8) == 676665828) strcat(s, "h");
if (crc32("ManfVTPQbC",10) == 3891816988) strcat(s, "t");
if (crc32("AFenMIgD",8) == 2496480474) strcat(s, "l");
if (crc32("CWhgQOs",7) == 492143385) strcat(s, "f");
if (crc32("CjBVqaV",7) == 644377521) strcat(s, "y");
    return s;
}

char *hypertragically_adverbs() {
    char *s = calloc(16);
    if (crc32("asTYQsL",7) == 1351331178) strcat(s, "h");
if (crc32("wsGOlLQdoKPfABx",15) == 1656714705) strcat(s, "y");
if (crc32("ORJgRh",6) == 2143958769) strcat(s, "p");
if (crc32("jhfcqYlolvL",11) == 1930066580) strcat(s, "e");
if (crc32("NIBAdbo",7) == 1703717023) strcat(s, "r");
if (crc32("hNJFOgbblXfkQoM",15) == 4025165160) strcat(s, "P");
if (crc32("djiLPDkOYrQGj",13) == 2406138073) strcat(s, "t");
if (crc32("DlRlDu",6) == 3984230730) strcat(s, "r");
if (crc32("AKOJetW",7) == 4258989493) strcat(s, "D");
if (crc32("ggRzP",5) == 2588060076) strcat(s, "a");
if (crc32("mMaNPiRjF",9) == 3550147837) strcat(s, "m");
if (crc32("gxTEJx",6) == 199736336) strcat(s, "g");
if (crc32("lXchekFkHL",10) == 202045727) strcat(s, "i");
if (crc32("NoPhLOKGS",9) == 1359043618) strcat(s, "c");
if (crc32("SJKjRU",6) == 3007484021) strcat(s, "a");
if (crc32("NcDQgNVC",8) == 2727142393) strcat(s, "Q");
if (crc32("uclxnvhOuoAbKJI",15) == 2153763433) strcat(s, "l");
if (crc32("WJyPixgNUkr",11) == 1095705732) strcat(s, "l");
if (crc32("vPooawjGqcees",13) == 1752400376) strcat(s, "y");
    return s;
}

char *conciliatingly_adverbs() {
    char *s = calloc(15);
    if (crc32("jLnPjcL",7) == 2095912507) strcat(s, "d");
if (crc32("eJHfj",5) == 2198876006) strcat(s, "c");
if (crc32("LlDNXI",6) == 2257236016) strcat(s, "o");
if (crc32("NCouQaCOTLYEn",13) == 1981013080) strcat(s, "n");
if (crc32("HYsHfjYrwXqX",12) == 1618959647) strcat(s, "c");
if (crc32("KszOlMwQFimzoQ",14) == 1557604803) strcat(s, "B");
if (crc32("OuofVVq",7) == 3527272357) strcat(s, "i");
if (crc32("BRqFghEJOY",10) == 3023933343) strcat(s, "c");
if (crc32("uGngPzaSyJ",10) == 4161868449) strcat(s, "l");
if (crc32("lCpQHuTJWE",10) == 4272670984) strcat(s, "i");
if (crc32("ufcbhe",6) == 241405159) strcat(s, "a");
if (crc32("nmVXrSRX",8) == 3664196043) strcat(s, "t");
if (crc32("esBxyTpDQRk",11) == 3832752020) strcat(s, "i");
if (crc32("AfHTl",5) == 1504069472) strcat(s, "n");
if (crc32("VVbyrFvlZkGRXir",15) == 3171801177) strcat(s, "I");
if (crc32("dtBiSSrv",8) == 3963339923) strcat(s, "g");
if (crc32("fkHjgxLngshm",12) == 3191833529) strcat(s, "l");
if (crc32("HLHCnNGH",8) == 2255192894) strcat(s, "y");
    return s;
}

char *augmentatively_adverbs() {
    char *s = calloc(15);
    if (crc32("OCtZeAs",7) == 1618173164) strcat(s, "a");
if (crc32("BNTxBJmf",8) == 4013717550) strcat(s, "p");
if (crc32("EDmbNkBjHjT",11) == 3910747621) strcat(s, "u");
if (crc32("MkaqRh",6) == 2534939698) strcat(s, "p");
if (crc32("hlhWN",5) == 1019920054) strcat(s, "g");
if (crc32("pAKElxyzJsb",11) == 1094307920) strcat(s, "T");
if (crc32("KLjMCOWyP",9) == 2025690435) strcat(s, "m");
if (crc32("llnWtUcjpqBc",12) == 269613114) strcat(s, "D");
if (crc32("fzYRxPzJeqAGXFr",15) == 4044524402) strcat(s, "e");
if (crc32("SbIFfbGCJFd",11) == 2647867746) strcat(s, "n");
if (crc32("rIaDeoIPRbPS",12) == 4277119054) strcat(s, "u");
if (crc32("AkHiDwpgtJFPjsX",15) == 3815923566) strcat(s, "t");
if (crc32("XJJhs",5) == 600638065) strcat(s, "a");
if (crc32("olPBCeFoyTtpQEf",15) == 2744909795) strcat(s, "t");
if (crc32("LYqOM",5) == 2690799595) strcat(s, "B");
if (crc32("YAQQkXREgUarph",14) == 2585092258) strcat(s, "i");
if (crc32("LgLWiKt",7) == 2330688649) strcat(s, "e");
if (crc32("dPAhAB",6) == 241752092) strcat(s, "v");
if (crc32("iNnSjZ",6) == 3629462023) strcat(s, "e");
if (crc32("jmaFu",5) == 788347226) strcat(s, "X");
if (crc32("YjDCvHq",7) == 3913467449) strcat(s, "l");
if (crc32("iJkUVgtInv",10) == 1588001633) strcat(s, "f");
if (crc32("KHSxFktLugxWCH",14) == 3309663907) strcat(s, "y");
    return s;
}

char *unfractiously_adverbs() {
    char *s = calloc(14);
    if (crc32("JixDCsci",8) == 1664476731) strcat(s, "B");
if (crc32("kiRpMbHHTq",10) == 1223609425) strcat(s, "u");
if (crc32("IssJPvHa",8) == 2094405491) strcat(s, "l");
if (crc32("dVmyUYof",8) == 3894700597) strcat(s, "n");
if (crc32("HPtPIk",6) == 2989698755) strcat(s, "t");
if (crc32("SSmDAJAfjPxjiwT",15) == 3722155837) strcat(s, "f");
if (crc32("hkDAh",5) == 892899026) strcat(s, "k");
if (crc32("mszohqNjnmxkEm",14) == 3516013107) strcat(s, "r");
if (crc32("ACsAMFdcItlpQ",13) == 3434884827) strcat(s, "a");
if (crc32("uWLsoFLZCQAB",12) == 1218375123) strcat(s, "g");
if (crc32("dHacTYSsIuoJjS",14) == 3690945754) strcat(s, "c");
if (crc32("oxnpndLEEmK",11) == 674949734) strcat(s, "U");
if (crc32("SorXL",5) == 2158609290) strcat(s, "t");
if (crc32("uzQjQGZ",7) == 2174081766) strcat(s, "i");
if (crc32("ZxOrCRAPv",9) == 2260432675) strcat(s, "o");
if (crc32("ZELhjeP",7) == 2177338112) strcat(s, "u");
if (crc32("fWhWLnCXeWKMl",13) == 1253248022) strcat(s, "u");
if (crc32("aFdnvFO",7) == 2929994415) strcat(s, "g");
if (crc32("sfKFgk",6) == 3805820895) strcat(s, "s");
if (crc32("UZuFOFZuUdceR",13) == 1880501824) strcat(s, "l");
if (crc32("MWlDTsrITNsOU",13) == 2724716003) strcat(s, "y");
    return s;
}

char *thereabout_adverbs() {
    char *s = calloc(11);
    if (crc32("fbSxVuYBMrpM",12) == 3391468968) strcat(s, "g");
if (crc32("hGbWMpcqoQEzUaV",15) == 217695448) strcat(s, "t");
if (crc32("xzgtHeScMIUgoM",14) == 2614814848) strcat(s, "W");
if (crc32("rgtXGjWB",8) == 1933391215) strcat(s, "h");
if (crc32("twuixurNyypYi",13) == 2400290782) strcat(s, "e");
if (crc32("hSmtiwpQGplPnA",14) == 2479448315) strcat(s, "j");
if (crc32("lwpaVRbGNq",10) == 134481144) strcat(s, "r");
if (crc32("dSYAXuqzS",9) == 1751450239) strcat(s, "e");
if (crc32("IQdtxCmziCbkvE",14) == 4262536063) strcat(s, "K");
if (crc32("SPOlBFxSL",9) == 500655718) strcat(s, "a");
if (crc32("wbIOoxXybWibk",13) == 1909708907) strcat(s, "b");
if (crc32("zBQSGvzWUl",10) == 4081223104) strcat(s, "o");
if (crc32("BdoZajTUmMps",12) == 2202423110) strcat(s, "u");
if (crc32("elwlmMzLDxgA",12) == 152729673) strcat(s, "L");
if (crc32("QcqmBvYpUPrPd",13) == 617221500) strcat(s, "t");
    return s;
}

char *untediously_adverbs() {
    char *s = calloc(12);
    if (crc32("DFaAbOmABH",10) == 104635652) strcat(s, "U");
if (crc32("lYXCK",5) == 1947260591) strcat(s, "u");
if (crc32("dAzuHOEFoBwhrvT",15) == 1336964088) strcat(s, "n");
if (crc32("yjkTCNtZprbkm",13) == 391706746) strcat(s, "m");
if (crc32("hlCbapBXQ",9) == 1683247778) strcat(s, "t");
if (crc32("jQnchcWIAoNpHLJ",15) == 1614188250) strcat(s, "H");
if (crc32("jxkrqKdTwS",10) == 988962454) strcat(s, "e");
if (crc32("afzwWFXNcyC",11) == 3021371321) strcat(s, "F");
if (crc32("VNIUUrJMPJoP",12) == 559450947) strcat(s, "d");
if (crc32("elleoHorBib",11) == 2210334389) strcat(s, "i");
if (crc32("wrxGvEjunSD",11) == 3676382648) strcat(s, "o");
if (crc32("pDZWvHAEk",9) == 592909312) strcat(s, "u");
if (crc32("sEQYp",5) == 46065501) strcat(s, "x");
if (crc32("kMArGBulhKPN",12) == 3465017560) strcat(s, "s");
if (crc32("otKfyKcneU",10) == 2950180215) strcat(s, "T");
if (crc32("EFdkExMtndmbRMc",15) == 53281943) strcat(s, "l");
if (crc32("FxGGzOyL",8) == 4122659039) strcat(s, "f");
if (crc32("JUkOYZzWBFmRT",13) == 1266057419) strcat(s, "y");
    return s;
}

char *noncommendably_adverbs() {
    char *s = calloc(15);
    if (crc32("bKcINiCHHOHtDuS",15) == 2798671848) strcat(s, "U");
if (crc32("LAuuSPul",8) == 821668855) strcat(s, "n");
if (crc32("hzkbUuZDai",10) == 2310866711) strcat(s, "P");
if (crc32("guPOKljB",8) == 3714646209) strcat(s, "o");
if (crc32("cDMOn",5) == 2842637548) strcat(s, "n");
if (crc32("YFrEcICNJSo",11) == 3576802014) strcat(s, "D");
if (crc32("urMawMys",8) == 1420468831) strcat(s, "c");
if (crc32("VHUXhVpygJJM",12) == 1168640862) strcat(s, "H");
if (crc32("VdddqgMBRTrWpL",14) == 1067560662) strcat(s, "o");
if (crc32("nDXHGrvVhPaD",12) == 2666093027) strcat(s, "J");
if (crc32("hUCmmJruERgVr",13) == 1340297298) strcat(s, "m");
if (crc32("WuMFqsN",7) == 4272442345) strcat(s, "m");
if (crc32("xLCADej",7) == 1545835930) strcat(s, "X");
if (crc32("Esyyc",5) == 1591578324) strcat(s, "e");
if (crc32("HCBlnYSihWZBJ",13) == 1060833392) strcat(s, "i");
if (crc32("VDZAkhszINBS",12) == 249885169) strcat(s, "n");
if (crc32("DyZSNKUeQYwiPgt",15) == 1533064592) strcat(s, "d");
if (crc32("QAPFrlPvq",9) == 1559939408) strcat(s, "a");
if (crc32("sbeHcLog",8) == 730330479) strcat(s, "e");
if (crc32("nLowLaHwgYnU",12) == 203628106) strcat(s, "b");
if (crc32("QlDeYtXL",8) == 2129817899) strcat(s, "w");
if (crc32("nbkbd",5) == 681150748) strcat(s, "l");
if (crc32("SpfuYqJsB",9) == 3041031676) strcat(s, "y");
    return s;
}

char *unseraphically_adverbs() {
    char *s = calloc(15);
    if (crc32("GnoekB",6) == 3055496725) strcat(s, "u");
if (crc32("XpMPDWMKWkCaRza",15) == 3572705024) strcat(s, "P");
if (crc32("tnNEgfjEJuYCWBW",15) == 2814195340) strcat(s, "n");
if (crc32("qlswUrLuZSeFgPB",15) == 856734851) strcat(s, "s");
if (crc32("tUTuLUxW",8) == 2627841723) strcat(s, "w");
if (crc32("tBKXxsWiSw",10) == 2678663025) strcat(s, "e");
if (crc32("nujHoMUWdlucG",13) == 1582850719) strcat(s, "T");
if (crc32("ZZFVegubs",9) == 54603646) strcat(s, "r");
if (crc32("gJzRXtsXUNmEW",13) == 1748495854) strcat(s, "a");
if (crc32("ywUKDWPmEat",11) == 3137384481) strcat(s, "p");
if (crc32("vYYFtxxravCxzXr",15) == 1369706647) strcat(s, "P");
if (crc32("UUlgUINb",8) == 334736263) strcat(s, "h");
if (crc32("jsTmXzZOy",9) == 2470982195) strcat(s, "d");
if (crc32("BKuTcy",6) == 2351711394) strcat(s, "i");
if (crc32("YHAPwyLYPRWTGf",14) == 3001443630) strcat(s, "U");
if (crc32("gXvXQEpQGdpk",12) == 3927173466) strcat(s, "c");
if (crc32("tZEqAl",6) == 522900625) strcat(s, "f");
if (crc32("EoqOBKpgu",9) == 4291970881) strcat(s, "a");
if (crc32("QNqSHjzpxTZWAZ",14) == 1656905326) strcat(s, "l");
if (crc32("VqtsyHJm",8) == 3281953403) strcat(s, "l");
if (crc32("QCtuoURvA",9) == 2250762490) strcat(s, "w");
if (crc32("gmuPXRLPhYHCT",13) == 2069407299) strcat(s, "y");
    return s;
}

char *nonfacetiously_adverbs() {
    char *s = calloc(15);
    if (crc32("KNKCH",5) == 1222784207) strcat(s, "h");
if (crc32("XWOShfloaRX",11) == 3589012628) strcat(s, "n");
if (crc32("jMHon",5) == 1245249374) strcat(s, "o");
if (crc32("qkosVr",6) == 1443242963) strcat(s, "Q");
if (crc32("fTAWOMztcrpk",12) == 3953485989) strcat(s, "n");
if (crc32("GIWYeenr",8) == 3035687169) strcat(s, "f");
if (crc32("Rxckfh",6) == 1932031361) strcat(s, "I");
if (crc32("czUdK",5) == 2530893976) strcat(s, "a");
if (crc32("QOvWfvRd",8) == 4221389365) strcat(s, "x");
if (crc32("RCPuYm",6) == 781874215) strcat(s, "c");
if (crc32("jXNIThEh",8) == 918198260) strcat(s, "Q");
if (crc32("bKvlXmPwaPZoMK",14) == 3031062579) strcat(s, "e");
if (crc32("enRcSfWztdmHBnD",15) == 3689606887) strcat(s, "g");
if (crc32("xBMuAb",6) == 85619021) strcat(s, "t");
if (crc32("dLoiLXuRE",9) == 3525892519) strcat(s, "s");
if (crc32("QnVAWVil",8) == 1454577950) strcat(s, "i");
if (crc32("PvqvAtKNWL",10) == 1118963302) strcat(s, "o");
if (crc32("XuecDirQzjHjMb",14) == 2466456130) strcat(s, "u");
if (crc32("EcumO",5) == 3125192595) strcat(s, "k");
if (crc32("uBkEKKUW",8) == 2722094134) strcat(s, "s");
if (crc32("sQisflPkWHzHM",13) == 2113075130) strcat(s, "e");
if (crc32("vbUItNB",7) == 3839312265) strcat(s, "l");
if (crc32("eXZCG",5) == 2058529317) strcat(s, "M");
if (crc32("PZmDUDDqWLaqP",13) == 1981854801) strcat(s, "y");
    return s;
}

char *gigantically_adverbs() {
    char *s = calloc(13);
    if (crc32("fLFIfpAEkMa",11) == 3720822877) strcat(s, "g");
if (crc32("DUevB",5) == 301334701) strcat(s, "I");
if (crc32("jcIrp",5) == 242490395) strcat(s, "i");
if (crc32("KxsLBiwD",8) == 583859383) strcat(s, "b");
if (crc32("DDShVxeT",8) == 2615240536) strcat(s, "g");
if (crc32("TMiteUwR",8) == 4229601789) strcat(s, "t");
if (crc32("JveDPzY",7) == 1309899358) strcat(s, "a");
if (crc32("sLWFPasb",8) == 1986106552) strcat(s, "e");
if (crc32("yilxs",5) == 468266006) strcat(s, "n");
if (crc32("ehrvklvjDDSajH",14) == 476015311) strcat(s, "H");
if (crc32("pSzDZPVPeg",10) == 256425442) strcat(s, "t");
if (crc32("vrdpApZzEdNzSW",14) == 2712402505) strcat(s, "z");
if (crc32("MXFRva",6) == 2565885594) strcat(s, "i");
if (crc32("UvefYwcOZuGwK",13) == 3406774900) strcat(s, "c");
if (crc32("LgLGBqMfIxKbgsv",15) == 83184403) strcat(s, "a");
if (crc32("OkjdZuipOjmnz",13) == 895987392) strcat(s, "l");
if (crc32("jkzAghZcRtMYf",13) == 742416376) strcat(s, "l");
if (crc32("krHZXXaFrAa",11) == 621436102) strcat(s, "y");
    return s;
}

char *intervertebrally_adverbs() {
    char *s = calloc(17);
    if (crc32("tZzZLXVhFQNxGc",14) == 3037066420) strcat(s, "i");
if (crc32("xeSYxxuxHAlzAZJ",15) == 128139359) strcat(s, "j");
if (crc32("ziOrkXTEe",9) == 2209449669) strcat(s, "n");
if (crc32("WHrhTu",6) == 2597073203) strcat(s, "g");
if (crc32("RtcVIaeFFrom",12) == 1912854727) strcat(s, "t");
if (crc32("ALFdMFUOj",9) == 1266775433) strcat(s, "e");
if (crc32("kVbrsakEcjwc",12) == 2624656986) strcat(s, "r");
if (crc32("KqdTGDFIrb",10) == 2800455) strcat(s, "A");
if (crc32("niBVgqlSRO",10) == 1467891535) strcat(s, "v");
if (crc32("KFfpfqqh",8) == 792872572) strcat(s, "e");
if (crc32("UayRNOL",7) == 2580150395) strcat(s, "Z");
if (crc32("nhWGTLdRDF",10) == 3483026854) strcat(s, "r");
if (crc32("TWdixnd",7) == 2594347281) strcat(s, "t");
if (crc32("hwBotUsMrc",10) == 184831593) strcat(s, "e");
if (crc32("HIOXWHevosoq",12) == 533736330) strcat(s, "Q");
if (crc32("THdJgNeFDLGEytE",15) == 760271384) strcat(s, "b");
if (crc32("qcvPh",5) == 2192426579) strcat(s, "r");
if (crc32("xUaooa",6) == 3196146793) strcat(s, "a");
if (crc32("WBgYOByLWojMy",13) == 821716220) strcat(s, "l");
if (crc32("zMSFlyObkrzzc",13) == 3657766757) strcat(s, "l");
if (crc32("YsMrSgxrfzM",11) == 3691677473) strcat(s, "m");
if (crc32("yPAURsMeurYE",12) == 3187255449) strcat(s, "y");
    return s;
}

char *quasidemandingly_adverbs() {
    char *s = calloc(17);
    if (crc32("ctTJBJydaz",10) == 2148415350) strcat(s, "q");
if (crc32("tGgwDUNv",8) == 1607790824) strcat(s, "o");
if (crc32("xPvMBB",6) == 36375852) strcat(s, "u");
if (crc32("chDHho",6) == 2352377519) strcat(s, "a");
if (crc32("nYsBammd",8) == 580706665) strcat(s, "R");
if (crc32("DRBjYn",6) == 3539337584) strcat(s, "s");
if (crc32("dCHlZUOmLFAfc",13) == 4145432022) strcat(s, "w");
if (crc32("pqWiIwuOPOWvtl",14) == 1083054520) strcat(s, "i");
if (crc32("zGlggPl",7) == 1380121108) strcat(s, "B");
if (crc32("CnCbrTGVl",9) == 4008001518) strcat(s, "d");
if (crc32("okdryayQsoveZl",14) == 2234843401) strcat(s, "Z");
if (crc32("turrtG",6) == 636173603) strcat(s, "e");
if (crc32("UaksVnFZFhk",11) == 2718531147) strcat(s, "m");
if (crc32("NxxSNs",6) == 716520230) strcat(s, "a");
if (crc32("vnnBmn",6) == 2433599165) strcat(s, "g");
if (crc32("Dygbrn",6) == 2338909368) strcat(s, "n");
if (crc32("FMkPooRCAMSXcJ",14) == 1969267007) strcat(s, "d");
if (crc32("mzYQW",5) == 2529212772) strcat(s, "i");
if (crc32("QhoHhePXR",9) == 3961877853) strcat(s, "Q");
if (crc32("AdDzUot",7) == 2600369304) strcat(s, "n");
if (crc32("bNKwVcYaNGxumkJ",15) == 2286703331) strcat(s, "Q");
if (crc32("NeqPOOmGYSxDqhl",15) == 1524178503) strcat(s, "g");
if (crc32("BsjQwpBMgpwCWwR",15) == 1086378274) strcat(s, "v");
if (crc32("WfhXlzXjgLvIeBJ",15) == 1468559684) strcat(s, "l");
if (crc32("lCWaNeB",7) == 2873302276) strcat(s, "y");
    return s;
}

char *emulatively_adverbs() {
    char *s = calloc(12);
    if (crc32("SWCqBcFOUB",10) == 3869062105) strcat(s, "U");
if (crc32("gtJdehXBn",9) == 547699155) strcat(s, "e");
if (crc32("mGkRMxTQ",8) == 3905525732) strcat(s, "x");
if (crc32("IWbMkdEluvNDLF",14) == 1957512372) strcat(s, "m");
if (crc32("eHVZxATkA",9) == 3746751930) strcat(s, "R");
if (crc32("svjqHhhaGJkdvF",14) == 2705952506) strcat(s, "u");
if (crc32("vcpgnNuUqdM",11) == 3510934292) strcat(s, "w");
if (crc32("KJmaUQZg",8) == 3820589998) strcat(s, "l");
if (crc32("MkIqjfTRWQiLn",13) == 432846630) strcat(s, "a");
if (crc32("EQBVExRZWqEdZ",13) == 2404305575) strcat(s, "G");
if (crc32("Qhpnw",5) == 1546454124) strcat(s, "t");
if (crc32("KNlGInPIkHyvZGm",15) == 2195409015) strcat(s, "i");
if (crc32("ekPqjfNYrJq",11) == 3808076856) strcat(s, "F");
if (crc32("pckvaIQqSZdsn",13) == 1614630736) strcat(s, "v");
if (crc32("qzbEdswcs",9) == 2371401996) strcat(s, "X");
if (crc32("QrGcTcsorUpB",12) == 2189914935) strcat(s, "e");
if (crc32("hldKcKW",7) == 1571191874) strcat(s, "R");
if (crc32("tgbWSGXVyUXVyD",14) == 3742951967) strcat(s, "l");
if (crc32("nkUaSFYSpLRDeRW",15) == 2587900621) strcat(s, "y");
    return s;
}

char *structurally_adverbs() {
    char *s = calloc(13);
    if (crc32("RDruD",5) == 3825930456) strcat(s, "s");
if (crc32("tDAMfPY",7) == 1757341072) strcat(s, "A");
if (crc32("IMXbRKahvPJim",13) == 710156558) strcat(s, "t");
if (crc32("gpkVt",5) == 2030344170) strcat(s, "r");
if (crc32("NizTAaYn",8) == 1974744306) strcat(s, "W");
if (crc32("fEuSUxkiYfFJ",12) == 3191846841) strcat(s, "u");
if (crc32("djtaUhE",7) == 98039094) strcat(s, "c");
if (crc32("VCtzXZWJLFGEB",13) == 975317899) strcat(s, "o");
if (crc32("PUecQO",6) == 1310043059) strcat(s, "t");
if (crc32("tvGiIxh",7) == 2043450169) strcat(s, "T");
if (crc32("CarfMFbaRo",10) == 851691483) strcat(s, "u");
if (crc32("pqCCNgFswFSs",12) == 2615407328) strcat(s, "c");
if (crc32("wmdPGyQn",8) == 3605658451) strcat(s, "r");
if (crc32("pCVwuIPnHf",10) == 1399031914) strcat(s, "a");
if (crc32("NsxJzD",6) == 1292223536) strcat(s, "l");
if (crc32("lJWFcAPdojMV",12) == 3859000126) strcat(s, "h");
if (crc32("HwQkNv",6) == 4187287545) strcat(s, "l");
if (crc32("GzwMhwFXqSSQ",12) == 2080337439) strcat(s, "i");
if (crc32("ijGjrjUEUZbsaW",14) == 1636427240) strcat(s, "y");
    return s;
}

char *downily_adverbs() {
    char *s = calloc(8);
    if (crc32("ToIdaJ",6) == 636561775) strcat(s, "c");
if (crc32("LOqHBiFjbG",10) == 3821519812) strcat(s, "d");
if (crc32("lxXIiAyosywchfx",15) == 1077310830) strcat(s, "o");
if (crc32("QhNMBIPaEK",10) == 850588818) strcat(s, "y");
if (crc32("otOJBfEMvPDhMaC",15) == 1038712697) strcat(s, "w");
if (crc32("HmAXAkwSo",9) == 1587411452) strcat(s, "n");
if (crc32("wktHIuMooqCN",12) == 2658824594) strcat(s, "i");
if (crc32("qowuIBXNiBooK",13) == 748110769) strcat(s, "l");
if (crc32("Sdmzsf",6) == 1736648311) strcat(s, "y");
    return s;
}

char *eligibly_adverbs() {
    char *s = calloc(9);
    if (crc32("uIkbEvEkIqiLdlb",15) == 2320671985) strcat(s, "V");
if (crc32("BmDvN",5) == 2999927825) strcat(s, "e");
if (crc32("PgzNFqpkSk",10) == 851481403) strcat(s, "l");
if (crc32("iFAfwqwn",8) == 340489820) strcat(s, "N");
if (crc32("etLGGZFdt",9) == 631040925) strcat(s, "i");
if (crc32("UMHZnkIinkYAqz",14) == 110116547) strcat(s, "u");
if (crc32("sxcPmfOsKbjdIhv",15) == 4248044787) strcat(s, "g");
if (crc32("OPTwc",5) == 1717988793) strcat(s, "W");
if (crc32("hLFWjXSINdiY",12) == 272310887) strcat(s, "i");
if (crc32("vlJWp",5) == 809931026) strcat(s, "T");
if (crc32("vMZoD",5) == 724646677) strcat(s, "b");
if (crc32("QkndUG",6) == 597795395) strcat(s, "l");
if (crc32("EuarXCKoJMAdSzL",15) == 3167790186) strcat(s, "O");
if (crc32("orXDXdjLI",9) == 2784915465) strcat(s, "y");
    return s;
}

char *equivocally_adverbs() {
    char *s = calloc(12);
    if (crc32("ADhquN",6) == 3749177954) strcat(s, "g");
if (crc32("fVAMAMW",7) == 1655746234) strcat(s, "e");
if (crc32("bsBuMleNbb",10) == 1393249552) strcat(s, "U");
if (crc32("uYjxvefgGhPXFX",14) == 3555984253) strcat(s, "q");
if (crc32("jFdUDeRTnRHHx",13) == 1013440649) strcat(s, "u");
if (crc32("hjqVAzxzSZ",10) == 4205510657) strcat(s, "n");
if (crc32("iPHbFoEBgV",10) == 4017648579) strcat(s, "i");
if (crc32("dUNjzDy",7) == 3911479708) strcat(s, "v");
if (crc32("HUfpa",5) == 3509298398) strcat(s, "d");
if (crc32("PoWYhEl",7) == 4108571678) strcat(s, "o");
if (crc32("aHblBAUQMvvmQ",13) == 710209479) strcat(s, "d");
if (crc32("ltPRgFXY",8) == 103746109) strcat(s, "c");
if (crc32("KSaSkBSwNSp",11) == 2081141982) strcat(s, "H");
if (crc32("USkAYUdDCGprAe",14) == 2593903771) strcat(s, "a");
if (crc32("HrkomfIXKGZwD",13) == 234515883) strcat(s, "P");
if (crc32("SdzpNUiMjtFd",12) == 3892851489) strcat(s, "l");
if (crc32("eKpDFRD",7) == 1106387483) strcat(s, "l");
if (crc32("KuaCX",5) == 1108454140) strcat(s, "y");
    return s;
}

char *incamera_adverbs() {
    char *s = calloc(9);
    if (crc32("bsbZkqlffNYvjkX",15) == 3585211712) strcat(s, "i");
if (crc32("vvzukrMRZOFXRiN",15) == 482806718) strcat(s, "Y");
if (crc32("CfCJVMyfTPcHsw",14) == 3282347051) strcat(s, "n");
if (crc32("UaaNLzYVhRhRLhx",15) == 3129671679) strcat(s, "c");
if (crc32("XCHrPkkMcDYXVoa",15) == 766604606) strcat(s, "D");
if (crc32("fQxCVLQVXMTQgBC",15) == 891843183) strcat(s, "a");
if (crc32("cBWduTPVJIC",11) == 909496862) strcat(s, "m");
if (crc32("fZYTvYEVfl",10) == 517778137) strcat(s, "e");
if (crc32("QklbkdudH",9) == 1988206084) strcat(s, "r");
if (crc32("XjDWcN",6) == 2082474951) strcat(s, "b");
if (crc32("gntNDHjY",8) == 4105146851) strcat(s, "a");
    return s;
}

char *ideologically_adverbs() {
    char *s = calloc(14);
    if (crc32("KObxMNSM",8) == 2777223821) strcat(s, "i");
if (crc32("fEpcIuZWFc",10) == 466003560) strcat(s, "d");
if (crc32("msoAvFMMmsab",12) == 3762792077) strcat(s, "L");
if (crc32("LoPITZEPCAbf",12) == 2082058057) strcat(s, "e");
if (crc32("LuRALzS",7) == 2164605250) strcat(s, "m");
if (crc32("ZoLnZNNstHZKt",13) == 1087278955) strcat(s, "o");
if (crc32("QZUfKvvirrbc",12) == 2440809770) strcat(s, "l");
if (crc32("oTMsSPAtqIq",11) == 3415207930) strcat(s, "Z");
if (crc32("lDTxJoHtTK",10) == 585417843) strcat(s, "o");
if (crc32("uSQriYZQ",8) == 2920587840) strcat(s, "g");
if (crc32("autjxWTiqow",11) == 979336819) strcat(s, "i");
if (crc32("kierIxPbzLIwBGo",15) == 545970029) strcat(s, "J");
if (crc32("AdrhsEt",7) == 488921296) strcat(s, "c");
if (crc32("PSZiHyJQWDWTXV",14) == 1729133853) strcat(s, "N");
if (crc32("jTMbJPA",7) == 3532914944) strcat(s, "a");
if (crc32("aChNHeSz",8) == 1467340906) strcat(s, "M");
if (crc32("GCdBwGmhig",10) == 3948128527) strcat(s, "l");
if (crc32("ESYPtYKgsWFvq",13) == 1672573350) strcat(s, "l");
if (crc32("esjAU",5) == 1499043227) strcat(s, "l");
if (crc32("pJVHAbSddjrv",12) == 4041573460) strcat(s, "y");
    return s;
}

char *indemonstrably_adverbs() {
    char *s = calloc(15);
    if (crc32("qzrYQmI",7) == 4210061720) strcat(s, "i");
if (crc32("LNswXiOOjKNMaL",14) == 617928564) strcat(s, "c");
if (crc32("ZcWMxga",7) == 1024397838) strcat(s, "n");
if (crc32("tlLGspujbNq",11) == 1157221444) strcat(s, "d");
if (crc32("mLOfEFqpkeLMsO",14) == 2006846328) strcat(s, "p");
if (crc32("pkKvgGFvy",9) == 153520522) strcat(s, "e");
if (crc32("EXghgy",6) == 2620760525) strcat(s, "V");
if (crc32("rYsrJwOAGV",10) == 4240509637) strcat(s, "m");
if (crc32("ypJCjB",6) == 1083477007) strcat(s, "o");
if (crc32("mQJFVkjGjzNZaON",15) == 2985196024) strcat(s, "o");
if (crc32("ekoBwRxvrDAtGS",14) == 2326938135) strcat(s, "n");
if (crc32("wRDremZkYt",10) == 85468586) strcat(s, "P");
if (crc32("OXKRrcLIH",9) == 3960871548) strcat(s, "s");
if (crc32("qQEuRfGZLmSOO",13) == 3038358415) strcat(s, "t");
if (crc32("ocVvMkRkfWnStF",14) == 3426760499) strcat(s, "a");
if (crc32("eodGRKag",8) == 1268420538) strcat(s, "r");
if (crc32("aaiEpwUWHjWI",12) == 1383743275) strcat(s, "a");
if (crc32("MkNhSxRMfilJC",13) == 2984102561) strcat(s, "b");
if (crc32("TuKFpetleIoj",12) == 2232530542) strcat(s, "b");
if (crc32("uOLhMVTfGKy",11) == 3552551673) strcat(s, "l");
if (crc32("uzXjQQ",6) == 2910495091) strcat(s, "y");
    return s;
}

char *unconfoundingly_adverbs() {
    char *s = calloc(16);
    if (crc32("yJjlRAdphlL",11) == 2925271027) strcat(s, "u");
if (crc32("eaoWjIJ",7) == 2998748056) strcat(s, "d");
if (crc32("eODrHkVmxPOWxc",14) == 3134965708) strcat(s, "n");
if (crc32("KpmiRyxtHAYbKyf",15) == 3698554733) strcat(s, "L");
if (crc32("uRPyaPjD",8) == 3423701560) strcat(s, "c");
if (crc32("ajlYzM",6) == 1858659173) strcat(s, "o");
if (crc32("dYJPKjPDvhwo",12) == 167153481) strcat(s, "L");
if (crc32("EorriRM",7) == 4148105667) strcat(s, "n");
if (crc32("kEfZqL",6) == 1976225718) strcat(s, "f");
if (crc32("wGFfrkEWws",10) == 2386272247) strcat(s, "o");
if (crc32("IDIApHpWpVQJt",13) == 175640271) strcat(s, "u");
if (crc32("EGfVlsQFA",9) == 2570667373) strcat(s, "W");
if (crc32("avTJMdCdp",9) == 2300112218) strcat(s, "n");
if (crc32("BBgqHciYrcZpC",13) == 1800952230) strcat(s, "d");
if (crc32("tLDXNjPBJGVSSKZ",15) == 3669455677) strcat(s, "k");
if (crc32("QaXaROhc",8) == 4139606942) strcat(s, "i");
if (crc32("nOWimO",6) == 2121502286) strcat(s, "n");
if (crc32("KjFxfzgmHAnAW",13) == 924558920) strcat(s, "h");
if (crc32("NZkGuCC",7) == 2866248260) strcat(s, "g");
if (crc32("jROwQo",6) == 44947068) strcat(s, "p");
if (crc32("FOnKHpZDFBYfwbD",15) == 1957907594) strcat(s, "l");
if (crc32("moNaWojoqlYD",12) == 3731663677) strcat(s, "v");
if (crc32("oWkhsRCRVZ",10) == 2922252714) strcat(s, "y");
    return s;
}

char *quasiignorantly_adverbs() {
    char *s = calloc(16);
    if (crc32("VLsUdihDLTy",11) == 3361383417) strcat(s, "q");
if (crc32("rbFBdDvYJjpOw",13) == 2162228347) strcat(s, "D");
if (crc32("cJEsIpYK",8) == 37769764) strcat(s, "u");
if (crc32("ofIfWBHRoWG",11) == 3103091436) strcat(s, "n");
if (crc32("TKhafZnoEm",10) == 2869739108) strcat(s, "a");
if (crc32("ZeagJDtsAa",10) == 1804956057) strcat(s, "s");
if (crc32("mbModtPJQXVnspH",15) == 298072882) strcat(s, "o");
if (crc32("vKDHfabjb",9) == 2686265277) strcat(s, "i");
if (crc32("ZXjdzVjNIjqvGJl",15) == 472639663) strcat(s, "f");
if (crc32("WcBPV",5) == 774851600) strcat(s, "i");
if (crc32("KxrYx",5) == 2683116695) strcat(s, "S");
if (crc32("yqebpc",6) == 3849479614) strcat(s, "g");
if (crc32("LnyzhzqhIVMT",12) == 125869157) strcat(s, "I");
if (crc32("yXXhIUMp",8) == 371326860) strcat(s, "n");
if (crc32("ePUprFBWHlKhYc",14) == 1385262218) strcat(s, "o");
if (crc32("WEZQNIXudMCS",12) == 1446160114) strcat(s, "u");
if (crc32("VkTcYJeB",8) == 2097646891) strcat(s, "r");
if (crc32("qowWNMNoqCbr",12) == 2060745191) strcat(s, "a");
if (crc32("KMoCVIGSFIfnZlW",15) == 527242420) strcat(s, "b");
if (crc32("cbFaCRWmTmDYCSG",15) == 2606645018) strcat(s, "n");
if (crc32("HKyjuPaFZUSIj",13) == 2636509200) strcat(s, "t");
if (crc32("nxdtERaXFOORa",13) == 1437112673) strcat(s, "l");
if (crc32("XOtbMJnEcoQ",11) == 1283840860) strcat(s, "y");
    return s;
}

char *probatively_adverbs() {
    char *s = calloc(12);
    if (crc32("YKashcQdZ",9) == 2348299177) strcat(s, "p");
if (crc32("mwksLfCFz",9) == 732135572) strcat(s, "a");
if (crc32("xuukmgzIdIoVyg",14) == 1888212611) strcat(s, "r");
if (crc32("YIVUroqwi",9) == 4078444508) strcat(s, "o");
if (crc32("yCsTbtSydbkMhgp",15) == 748193531) strcat(s, "b");
if (crc32("JRNxByHMRrJkBBn",15) == 1399653656) strcat(s, "k");
if (crc32("MBXtSJ",6) == 2062152416) strcat(s, "a");
if (crc32("bOZjIxfRgRokq",13) == 1942678778) strcat(s, "t");
if (crc32("lhImgHfasqmfIe",14) == 2829854482) strcat(s, "i");
if (crc32("Htvzfkg",7) == 1411394629) strcat(s, "d");
if (crc32("xBTXXuAWdYj",11) == 3976748329) strcat(s, "v");
if (crc32("UFSmgQ",6) == 1424615097) strcat(s, "G");
if (crc32("FMrPen",6) == 3618259248) strcat(s, "e");
if (crc32("KBLZWyY",7) == 637148366) strcat(s, "l");
if (crc32("fBQeLXGGcjc",11) == 987067932) strcat(s, "y");
    return s;
}

char *chantingly_adverbs() {
    char *s = calloc(11);
    if (crc32("ZjrMbxW",7) == 1972065667) strcat(s, "D");
if (crc32("xsjrGr",6) == 3927758491) strcat(s, "c");
if (crc32("TSDyTgEIm",9) == 2180840865) strcat(s, "h");
if (crc32("SkaqAINTuFVnKb",14) == 4161419522) strcat(s, "x");
if (crc32("HKKluwzttVF",11) == 1698385556) strcat(s, "a");
if (crc32("pDVgHDIctW",10) == 2179046559) strcat(s, "v");
if (crc32("AnCYjVGXITmGpl",14) == 2074029535) strcat(s, "n");
if (crc32("muRvAJRz",8) == 3505135001) strcat(s, "G");
if (crc32("TWvokaJpQjlPttE",15) == 3724822336) strcat(s, "t");
if (crc32("kYGkUwT",7) == 1566700474) strcat(s, "V");
if (crc32("zGclkSWONF",10) == 1807328106) strcat(s, "i");
if (crc32("QXdQyEIzojvJC",13) == 3948249086) strcat(s, "n");
if (crc32("HGjUIZ",6) == 754129505) strcat(s, "g");
if (crc32("MKJJiNysgwDGgi",14) == 3879733811) strcat(s, "l");
if (crc32("UChxyOCtn",9) == 3871129836) strcat(s, "k");
if (crc32("sZXVv",5) == 3955806999) strcat(s, "y");
    return s;
}

char *meagrely_adverbs() {
    char *s = calloc(9);
    if (crc32("oPSapanzfXmE",12) == 3936122681) strcat(s, "m");
if (crc32("MhUyJkyfiWXOAhe",15) == 2174068807) strcat(s, "e");
if (crc32("AFmvBwk",7) == 1088883249) strcat(s, "a");
if (crc32("SWarfcs",7) == 809012609) strcat(s, "g");
if (crc32("EzqbWeP",7) == 462022773) strcat(s, "l");
if (crc32("RIGDW",5) == 1981982994) strcat(s, "r");
if (crc32("yFxKRe",6) == 760025104) strcat(s, "e");
if (crc32("fsSRWP",6) == 553230644) strcat(s, "G");
if (crc32("GotCG",5) == 799054952) strcat(s, "l");
if (crc32("TLarE",5) == 3114001337) strcat(s, "M");
if (crc32("OXewpymC",8) == 2583166029) strcat(s, "y");
    return s;
}

char *quasiwickedly_adverbs() {
    char *s = calloc(14);
    if (crc32("OjRASUUPcrwNT",13) == 1641688257) strcat(s, "q");
if (crc32("aLWBEmOIyWii",12) == 477338506) strcat(s, "W");
if (crc32("BVIaamzUJFOgC",13) == 2499642296) strcat(s, "u");
if (crc32("iaWugbbO",8) == 1557301098) strcat(s, "i");
if (crc32("ohKlfjxxQEMXg",13) == 284168119) strcat(s, "a");
if (crc32("CMseFhHWr",9) == 711908849) strcat(s, "s");
if (crc32("fTcIRHBJ",8) == 3775351772) strcat(s, "p");
if (crc32("pKiRhTNjEbi",11) == 2648111826) strcat(s, "i");
if (crc32("QXnbgvEnopAk",12) == 3048475611) strcat(s, "j");
if (crc32("PaJoOl",6) == 2648292692) strcat(s, "w");
if (crc32("fLNLvEvrl",9) == 147153044) strcat(s, "i");
if (crc32("DTvsRjII",8) == 2895310269) strcat(s, "h");
if (crc32("QGcErjaYx",9) == 4001914116) strcat(s, "c");
if (crc32("LEZNxSbSxVtHDn",14) == 2457651518) strcat(s, "k");
if (crc32("LadAZi",6) == 2442997324) strcat(s, "N");
if (crc32("pCMBpMfVLBNLSwx",15) == 1150827590) strcat(s, "e");
if (crc32("RZmUdvGPykdwb",13) == 116954460) strcat(s, "d");
if (crc32("PjrXlKLLZwT",11) == 2238817304) strcat(s, "l");
if (crc32("dIcggdNjUHIwW",13) == 2294370429) strcat(s, "Q");
if (crc32("QtsBfnDKUIjBF",13) == 808960040) strcat(s, "y");
    return s;
}

char *tinily_adverbs() {
    char *s = calloc(7);
    if (crc32("ztWdlrqZKaaOpPI",15) == 2456399941) strcat(s, "t");
if (crc32("BCNvOgZYsLEnWkr",15) == 2998171768) strcat(s, "t");
if (crc32("RTHDebY",7) == 3383515229) strcat(s, "i");
if (crc32("vBAWZVtWBMx",11) == 515419829) strcat(s, "n");
if (crc32("uBblwGQz",8) == 3686131591) strcat(s, "i");
if (crc32("SiVqxLgDIeOO",12) == 3082028884) strcat(s, "X");
if (crc32("UWRgbwmLUTbjV",13) == 3841289466) strcat(s, "l");
if (crc32("dyHHmgUutFtgcmw",15) == 2927954456) strcat(s, "Q");
if (crc32("tiWJOlejWnrsMHb",15) == 3274378642) strcat(s, "y");
    return s;
}

char *antipathetically_adverbs() {
    char *s = calloc(17);
    if (crc32("MRfhWZfeiMPNO",13) == 1971673699) strcat(s, "o");
if (crc32("cyJVwKBZusrui",13) == 1646021577) strcat(s, "a");
if (crc32("tMUJweUhFY",10) == 2269044686) strcat(s, "n");
if (crc32("fxBtRRVaATEMVOi",15) == 3006705766) strcat(s, "t");
if (crc32("mDAfOXOkvpPKuj",14) == 930925332) strcat(s, "i");
if (crc32("HrCUVNWAgppi",12) == 3577532006) strcat(s, "i");
if (crc32("McaEkbNO",8) == 296879149) strcat(s, "p");
if (crc32("BIrUkcjgJWFx",12) == 4102686337) strcat(s, "F");
if (crc32("dITiSFlGGY",10) == 1928772086) strcat(s, "a");
if (crc32("ubcPkQSlIsy",11) == 950068132) strcat(s, "g");
if (crc32("lerSqirCIJy",11) == 807959672) strcat(s, "t");
if (crc32("DDfsDkDBHgppb",13) == 236030683) strcat(s, "h");
if (crc32("okNdVXs",7) == 41500495) strcat(s, "e");
if (crc32("vLHebaTzIMK",11) == 1782654234) strcat(s, "s");
if (crc32("ngbyWL",6) == 3903966891) strcat(s, "t");
if (crc32("qMhUSxbtDPpEN",13) == 3857040589) strcat(s, "i");
if (crc32("MMCBZHbjKUt",11) == 1231824959) strcat(s, "i");
if (crc32("CKCfARiEmW",10) == 373331619) strcat(s, "c");
if (crc32("FKiARUJwngqyCQ",14) == 3531093255) strcat(s, "a");
if (crc32("yFUCJre",7) == 420713002) strcat(s, "l");
if (crc32("MwYdOorwjOjPie",14) == 1216214220) strcat(s, "l");
if (crc32("TkscdCaAj",9) == 4292181552) strcat(s, "y");
    return s;
}

char *uncatastrophically_adverbs() {
    char *s = calloc(19);
    if (crc32("hbOBOAGtVDmcvr",14) == 3914031848) strcat(s, "U");
if (crc32("KdVHnWviFlPvbKi",15) == 2663397793) strcat(s, "u");
if (crc32("NllNW",5) == 2317995286) strcat(s, "n");
if (crc32("HGOnBfd",7) == 2598200954) strcat(s, "U");
if (crc32("urLAJxaKGsIx",12) == 2287822290) strcat(s, "c");
if (crc32("pNAIfBKgweTE",12) == 870354063) strcat(s, "a");
if (crc32("PigwtGtnpM",10) == 2635990759) strcat(s, "A");
if (crc32("AxsbJNsWbSKAHP",14) == 3120170394) strcat(s, "t");
if (crc32("lWYEHbIRXcWXEoY",15) == 4109967717) strcat(s, "a");
if (crc32("WohkNWofgg",10) == 3627235768) strcat(s, "s");
if (crc32("UctYwLqb",8) == 2113548956) strcat(s, "t");
if (crc32("lYInhn",6) == 2160559426) strcat(s, "M");
if (crc32("oFKvFOE",7) == 1571064764) strcat(s, "r");
if (crc32("qjqzMkHSIhHzj",13) == 2254030564) strcat(s, "o");
if (crc32("vwtUcuxTiaqPb",13) == 3325808120) strcat(s, "p");
if (crc32("TYbnX",5) == 3371056083) strcat(s, "B");
if (crc32("MoRAiPZKMTMt",12) == 470729137) strcat(s, "h");
if (crc32("KXRssrvoEjEhcwT",15) == 1706476156) strcat(s, "i");
if (crc32("ohdmOgaKQlT",11) == 2805972006) strcat(s, "c");
if (crc32("OVjUDorGbQgEY",13) == 256601979) strcat(s, "W");
if (crc32("PLVpceFvn",9) == 3562814151) strcat(s, "a");
if (crc32("NTOSudhpIqvXFOF",15) == 4143553133) strcat(s, "l");
if (crc32("WkeXJyHR",8) == 4050008345) strcat(s, "l");
if (crc32("HakVEIIsacx",11) == 1061197693) strcat(s, "y");
    return s;
}

char *aperiodically_adverbs() {
    char *s = calloc(14);
    if (crc32("jvRQzwiiULESS",13) == 1089615831) strcat(s, "a");
if (crc32("TWoYNcudrZLnEW",14) == 1084749666) strcat(s, "a");
if (crc32("nzEVGXMvDrMGM",13) == 1103932001) strcat(s, "p");
if (crc32("axZUDmwdBkjgon",14) == 3778303714) strcat(s, "e");
if (crc32("jSBLtYYhY",9) == 2924058193) strcat(s, "x");
if (crc32("WXrYS",5) == 2361825766) strcat(s, "r");
if (crc32("JauUjcr",7) == 3334856475) strcat(s, "i");
if (crc32("RhnmjDGt",8) == 1383901722) strcat(s, "o");
if (crc32("dfSRz",5) == 400960918) strcat(s, "F");
if (crc32("UDrqufBjjZHx",12) == 1660068239) strcat(s, "d");
if (crc32("UOtBo",5) == 3606045681) strcat(s, "U");
if (crc32("SJQovrcNpP",10) == 1473093286) strcat(s, "i");
if (crc32("TGXhwhkV",8) == 3615477274) strcat(s, "K");
if (crc32("YWjEYz",6) == 3910389044) strcat(s, "c");
if (crc32("SVsyBkKuOCvB",12) == 134078272) strcat(s, "a");
if (crc32("rreUZvfPqMJgwy",14) == 3665450864) strcat(s, "q");
if (crc32("dDdbvFIU",8) == 4054390310) strcat(s, "l");
if (crc32("WovpnNVUwd",10) == 3326250329) strcat(s, "l");
if (crc32("dwkTwUHnfoSobcN",15) == 1212335691) strcat(s, "O");
if (crc32("zWwLOELsBwpq",12) == 2162558215) strcat(s, "y");
    return s;
}

char *quintessentially_adverbs() {
    char *s = calloc(17);
    if (crc32("jVXBT",5) == 713353364) strcat(s, "s");
if (crc32("MqadPXll",8) == 374450122) strcat(s, "q");
if (crc32("chKLq",5) == 2863634574) strcat(s, "I");
if (crc32("VLFzYmvDSVOSMM",14) == 96362242) strcat(s, "u");
if (crc32("stEtczjmezfgOe",14) == 3033450400) strcat(s, "L");
if (crc32("nXcJYtDNjijoR",13) == 1168725980) strcat(s, "i");
if (crc32("eZYGJNpALf",10) == 1401389981) strcat(s, "n");
if (crc32("TpGCOSZ",7) == 1128796177) strcat(s, "t");
if (crc32("mfTTd",5) == 2906695390) strcat(s, "a");
if (crc32("sdZzgDypMr",10) == 1914536283) strcat(s, "e");
if (crc32("OnquCEHAO",9) == 3265688824) strcat(s, "O");
if (crc32("jXteUGGBi",9) == 2623394359) strcat(s, "s");
if (crc32("wtUzTjjECG",10) == 4274761815) strcat(s, "W");
if (crc32("LeJlulMUAK",10) == 2314944478) strcat(s, "s");
if (crc32("HRUdvtXcfXES",12) == 599729354) strcat(s, "O");
if (crc32("bDMGGtsS",8) == 3187031645) strcat(s, "e");
if (crc32("WAVyUdSY",8) == 3330558340) strcat(s, "n");
if (crc32("LGKZTLov",8) == 3949732297) strcat(s, "t");
if (crc32("LtboFl",6) == 4119419870) strcat(s, "i");
if (crc32("iHkFMU",6) == 811399674) strcat(s, "a");
if (crc32("HcrOcKcVwlMjM",13) == 2043005867) strcat(s, "K");
if (crc32("PtivGRbTCdwTFkb",15) == 2974475462) strcat(s, "l");
if (crc32("fPlEXPzYsVLfyMs",15) == 3546260622) strcat(s, "l");
if (crc32("VXFKKTPbsMPRXTR",15) == 2554194251) strcat(s, "l");
if (crc32("PVuTjeyw",8) == 698322092) strcat(s, "J");
if (crc32("EbHEyG",6) == 856766244) strcat(s, "y");
    return s;
}

char *hydrologically_adverbs() {
    char *s = calloc(15);
    if (crc32("bcCIVMxJND",10) == 2475615371) strcat(s, "h");
if (crc32("tyYVCVhY",8) == 4128840577) strcat(s, "y");
if (crc32("GeEUWbWxtjFwZFR",15) == 3041050085) strcat(s, "d");
if (crc32("whVUImThdcGzlyr",15) == 1627853971) strcat(s, "I");
if (crc32("mJzxBfBZrCKhj",13) == 2343759584) strcat(s, "r");
if (crc32("KDCBRlLOwNAE",12) == 1128795343) strcat(s, "o");
if (crc32("ToBiCv",6) == 697737992) strcat(s, "l");
if (crc32("gLbRsl",6) == 2268195097) strcat(s, "o");
if (crc32("vSDsWzTTM",9) == 2958361827) strcat(s, "g");
if (crc32("wzuWXLFPuV",10) == 687551062) strcat(s, "H");
if (crc32("MhPcop",6) == 2562390034) strcat(s, "i");
if (crc32("HOdXklGHXrNcmY",14) == 2485140517) strcat(s, "j");
if (crc32("BTyqpIFt",8) == 3567257950) strcat(s, "c");
if (crc32("byzIJVCSGSkVo",13) == 3339932741) strcat(s, "a");
if (crc32("BpFisuqbZaL",11) == 1742927386) strcat(s, "M");
if (crc32("ILqDGsutmNGblOp",15) == 3872712442) strcat(s, "l");
if (crc32("lYgTZSx",7) == 1004916615) strcat(s, "l");
if (crc32("hLvllCpeFgkcfYM",15) == 2117225807) strcat(s, "E");
if (crc32("afBAVQoeXT",10) == 2542527989) strcat(s, "y");
    return s;
}

char *too_adverbs() {
    char *s = calloc(4);
    if (crc32("eQIEvNIsbLKxxQq",15) == 847155292) strcat(s, "d");
if (crc32("dUwToCzGDY",10) == 1665710738) strcat(s, "t");
if (crc32("PZukBGV",7) == 2157409864) strcat(s, "o");
if (crc32("LycnY",5) == 807578257) strcat(s, "r");
if (crc32("GDPDBVWLAgwNDO",14) == 2228386146) strcat(s, "o");
    return s;
}

char *semiresolutely_adverbs() {
    char *s = calloc(15);
    if (crc32("rvXRpdowPhI",11) == 3020450593) strcat(s, "s");
if (crc32("PVPylRLQS",9) == 833984926) strcat(s, "t");
if (crc32("GxaDHKyrTJ",10) == 3173410434) strcat(s, "e");
if (crc32("nmMTINL",7) == 2019043632) strcat(s, "m");
if (crc32("VnurODdWbGRQmC",14) == 584051180) strcat(s, "i");
if (crc32("YfnXyRTsq",9) == 3360382969) strcat(s, "r");
if (crc32("ZvbjbsMVuUOaJX",14) == 970284984) strcat(s, "R");
if (crc32("cKERRoKONjCsN",13) == 1591592605) strcat(s, "e");
if (crc32("jAekzUHTxQpZ",12) == 1109390286) strcat(s, "s");
if (crc32("zyzGWuDPZm",10) == 3388592151) strcat(s, "o");
if (crc32("UePyqTlo",8) == 2889290139) strcat(s, "N");
if (crc32("SRzxVPv",7) == 3088199402) strcat(s, "l");
if (crc32("VFXrTXEUp",9) == 2175242091) strcat(s, "F");
if (crc32("untZMdXCki",10) == 3649233524) strcat(s, "u");
if (crc32("azmcZfVsLEVj",12) == 2388393764) strcat(s, "x");
if (crc32("wZXdgZCfn",9) == 1369524316) strcat(s, "t");
if (crc32("tnYqGKE",7) == 836474811) strcat(s, "e");
if (crc32("agBXhckmNVqriw",14) == 291219580) strcat(s, "l");
if (crc32("HiinGKIntENlrYn",15) == 3520170802) strcat(s, "y");
    return s;
}

char *noneternally_adverbs() {
    char *s = calloc(13);
    if (crc32("tvblHPTLUxtPqVe",15) == 1465895965) strcat(s, "G");
if (crc32("QJNUdbFbULsoqsj",15) == 3000212661) strcat(s, "n");
if (crc32("qgozKrhrDf",10) == 4236129137) strcat(s, "o");
if (crc32("qfvLZogi",8) == 1412377451) strcat(s, "n");
if (crc32("YkXFUqvNO",9) == 2279062757) strcat(s, "e");
if (crc32("DkJZREHKEVUGlh",14) == 3308671053) strcat(s, "E");
if (crc32("hOktxJUNHWhT",12) == 1179434805) strcat(s, "t");
if (crc32("nxkylBmiB",9) == 1194664961) strcat(s, "r");
if (crc32("YarBHBSrm",9) == 78658693) strcat(s, "e");
if (crc32("PlnUEhHYcTuRzkd",15) == 2557434527) strcat(s, "P");
if (crc32("lBquzZdJiLH",11) == 3065372360) strcat(s, "r");
if (crc32("EOAAurQSxPH",11) == 3920308690) strcat(s, "H");
if (crc32("XXNgndnAU",9) == 2330573336) strcat(s, "n");
if (crc32("UbpogLlbnLoplN",14) == 1122402920) strcat(s, "R");
if (crc32("pGidJLiDNrMHFNk",15) == 3593419771) strcat(s, "a");
if (crc32("irhAYXJzOUDkSrh",15) == 829095991) strcat(s, "D");
if (crc32("HUZpVXKniL",10) == 1762762653) strcat(s, "l");
if (crc32("jMmXlBFKV",9) == 523105936) strcat(s, "l");
if (crc32("RfIaRzQk",8) == 1895787961) strcat(s, "V");
if (crc32("tUpJlu",6) == 781690717) strcat(s, "y");
    return s;
}

char *nonsectionally_adverbs() {
    char *s = calloc(15);
    if (crc32("hgfBxbqALZR",11) == 930796478) strcat(s, "n");
if (crc32("DfcaBxvpXM",10) == 3282020995) strcat(s, "o");
if (crc32("YupdAjqphlzRp",13) == 3474650311) strcat(s, "D");
if (crc32("QysOlfdJzBNpI",13) == 3478628716) strcat(s, "n");
if (crc32("BcmbGo",6) == 3454702274) strcat(s, "s");
if (crc32("VFGjHNdHX",9) == 569819970) strcat(s, "e");
if (crc32("UcizfUyhmun",11) == 2480333064) strcat(s, "c");
if (crc32("fZgEoX",6) == 1253684401) strcat(s, "t");
if (crc32("YcAlzXFvYc",10) == 2573202214) strcat(s, "i");
if (crc32("wmeooN",6) == 4197826549) strcat(s, "o");
if (crc32("sIglxZcqe",9) == 78472163) strcat(s, "n");
if (crc32("GLatKtFqfIz",11) == 2093911963) strcat(s, "a");
if (crc32("DZPtbMFLS",9) == 3339735886) strcat(s, "i");
if (crc32("EDLcWehmDOcRd",13) == 519903620) strcat(s, "l");
if (crc32("icxGlHoRuQ",10) == 6493836) strcat(s, "l");
if (crc32("XiCcWWJLYzlLBFF",15) == 2397064499) strcat(s, "f");
if (crc32("AljDnfi",7) == 2186427875) strcat(s, "y");
    return s;
}

char *southwards_adverbs() {
    char *s = calloc(11);
    if (crc32("qjmbArk",7) == 950067450) strcat(s, "s");
if (crc32("eHsPYOF",7) == 1503986640) strcat(s, "o");
if (crc32("NrrueF",6) == 331071739) strcat(s, "u");
if (crc32("TmKKUBe",7) == 139127857) strcat(s, "t");
if (crc32("EWfHPQjYVlINg",13) == 1353501180) strcat(s, "b");
if (crc32("yBJkzkWoCDxsuB",14) == 3937134090) strcat(s, "h");
if (crc32("pQyzFc",6) == 2186973416) strcat(s, "w");
if (crc32("XIXDHYozJR",10) == 3591962095) strcat(s, "u");
if (crc32("WKDzRZ",6) == 3242808676) strcat(s, "a");
if (crc32("lhrUfULzIBUdy",13) == 1903987751) strcat(s, "r");
if (crc32("KhddOJGWZl",10) == 3458091367) strcat(s, "d");
if (crc32("PNRxF",5) == 3168407579) strcat(s, "O");
if (crc32("mOuHfAbno",9) == 3191426442) strcat(s, "s");
    return s;
}

char *mollifyingly_adverbs() {
    char *s = calloc(13);
    if (crc32("xrWBS",5) == 974958586) strcat(s, "j");
if (crc32("HzAxSzHTIqJyJZ",14) == 350209103) strcat(s, "m");
if (crc32("FfnPEfEqvfoi",12) == 1739586561) strcat(s, "o");
if (crc32("PtNdyCw",7) == 3345278103) strcat(s, "K");
if (crc32("SKJKwN",6) == 1837624188) strcat(s, "l");
if (crc32("brWmPbRpjyQd",12) == 4165553885) strcat(s, "l");
if (crc32("CJfJwFm",7) == 2626682836) strcat(s, "y");
if (crc32("pNzIN",5) == 2910997889) strcat(s, "i");
if (crc32("iMQDMZDbnTP",11) == 274282076) strcat(s, "F");
if (crc32("MZTyZjN",7) == 2707169943) strcat(s, "f");
if (crc32("xuaonOHo",8) == 966747562) strcat(s, "y");
if (crc32("gNzmDDQfjMHGTKp",15) == 3934827806) strcat(s, "i");
if (crc32("klRiOjE",7) == 2164255423) strcat(s, "C");
if (crc32("GFnzgzRGTfYZxq",14) == 1677174777) strcat(s, "n");
if (crc32("MYylun",6) == 3319881528) strcat(s, "A");
if (crc32("ZtwxfNsVKPH",11) == 3591379938) strcat(s, "g");
if (crc32("ioRXTWPZF",9) == 672234363) strcat(s, "N");
if (crc32("bdhGFNdozI",10) == 2791839538) strcat(s, "l");
if (crc32("OeDBhYdyO",9) == 3321498956) strcat(s, "y");
    return s;
}

char *subcortically_adverbs() {
    char *s = calloc(14);
    if (crc32("bjNynWxR",8) == 3375626629) strcat(s, "s");
if (crc32("kjmlfHKudGZ",11) == 4146605522) strcat(s, "u");
if (crc32("vrYhECbWxl",10) == 742833629) strcat(s, "L");
if (crc32("rpGNaJPCjY",10) == 862384519) strcat(s, "b");
if (crc32("ZZkxMyinPenr",12) == 1459743426) strcat(s, "c");
if (crc32("QBHOymkLjbiSzo",14) == 296539997) strcat(s, "o");
if (crc32("oAvNvVhFNMcPT",13) == 2028760368) strcat(s, "o");
if (crc32("oyGGzRlkdMtzQDM",15) == 3125989585) strcat(s, "K");
if (crc32("hwvMKqDblEXT",12) == 101623348) strcat(s, "r");
if (crc32("WBfRzqzLckhur",13) == 261272409) strcat(s, "t");
if (crc32("OkxPzpUSa",9) == 2695043550) strcat(s, "i");
if (crc32("JGtEbm",6) == 51798224) strcat(s, "c");
if (crc32("jbxWmCc",7) == 1285084337) strcat(s, "Y");
if (crc32("LaMYJA",6) == 1817474591) strcat(s, "a");
if (crc32("WCjaxIcP",8) == 2294039194) strcat(s, "Y");
if (crc32("NRfstfLkQb",10) == 3888396032) strcat(s, "l");
if (crc32("LdmzbnOcY",9) == 3581736618) strcat(s, "l");
if (crc32("zlGSiF",6) == 1456903422) strcat(s, "Z");
if (crc32("PyZDcrAetIKDA",13) == 2160913370) strcat(s, "y");
    return s;
}

char *antimonarchically_adverbs() {
    char *s = calloc(18);
    if (crc32("KMSGA",5) == 1348871816) strcat(s, "a");
if (crc32("wyOVG",5) == 3833118920) strcat(s, "n");
if (crc32("XpmFeNYrKXpJc",13) == 3001319509) strcat(s, "T");
if (crc32("ybXJpn",6) == 2291975029) strcat(s, "t");
if (crc32("bFWWwGP",7) == 21019104) strcat(s, "i");
if (crc32("DBaqNLMT",8) == 937532833) strcat(s, "m");
if (crc32("xysLB",5) == 2334016953) strcat(s, "o");
if (crc32("RkErhQbvhEFLbg",14) == 2285722501) strcat(s, "H");
if (crc32("WZpnS",5) == 3041666359) strcat(s, "n");
if (crc32("SwHnu",5) == 491988748) strcat(s, "M");
if (crc32("EUMTkWZICfE",11) == 643627531) strcat(s, "a");
if (crc32("zasWfKVXix",10) == 452078083) strcat(s, "r");
if (crc32("XQyEyf",6) == 1848011693) strcat(s, "c");
if (crc32("gPJmLCRq",8) == 3110881842) strcat(s, "l");
if (crc32("jTvzvIK",7) == 3345787669) strcat(s, "h");
if (crc32("uEIdilKGlJYwrh",14) == 3829556704) strcat(s, "i");
if (crc32("BgicKllhkln",11) == 3550569921) strcat(s, "d");
if (crc32("qzVHgtOM",8) == 1964071089) strcat(s, "c");
if (crc32("mVkbxJO",7) == 1758994608) strcat(s, "V");
if (crc32("aOtquhbqIsK",11) == 2819109603) strcat(s, "a");
if (crc32("itvGhoBuHaB",11) == 3559308170) strcat(s, "e");
if (crc32("mHPPNjkTwBoS",12) == 1130723158) strcat(s, "l");
if (crc32("NPqaxxNRs",9) == 1885643898) strcat(s, "l");
if (crc32("TBzUWTvgZv",10) == 3381279995) strcat(s, "y");
    return s;
}

char *nondyspeptically_adverbs() {
    char *s = calloc(17);
    if (crc32("UyRefm",6) == 1700016915) strcat(s, "F");
if (crc32("oJmWt",5) == 3413412125) strcat(s, "n");
if (crc32("vqrrLXeYyE",10) == 2376087139) strcat(s, "o");
if (crc32("hcXVIAJ",7) == 31659148) strcat(s, "t");
if (crc32("bwIAeCAJBEzfu",13) == 3564788488) strcat(s, "n");
if (crc32("jvNEOeiIIVPyl",13) == 1746546708) strcat(s, "v");
if (crc32("BYFgmm",6) == 3605427509) strcat(s, "d");
if (crc32("kIkqemspMSY",11) == 2279325340) strcat(s, "y");
if (crc32("HnQtsOaOTztT",12) == 122296600) strcat(s, "s");
if (crc32("qSrbvOuwLZgNz",13) == 568164713) strcat(s, "p");
if (crc32("YzqIk",5) == 149893995) strcat(s, "Y");
if (crc32("PzaugbHIV",9) == 3101838211) strcat(s, "e");
if (crc32("XDcSDTpstdHaEc",14) == 2104719927) strcat(s, "p");
if (crc32("MQRYUSxizTLVnW",14) == 228787726) strcat(s, "j");
if (crc32("cTwitCoOHlUk",12) == 1947381473) strcat(s, "t");
if (crc32("XlwnXvngb",9) == 1478952999) strcat(s, "R");
if (crc32("GkDACOr",7) == 1260313218) strcat(s, "i");
if (crc32("hiJmSZiWePdw",12) == 215411094) strcat(s, "c");
if (crc32("LUMGbRu",7) == 127205472) strcat(s, "a");
if (crc32("qkESxM",6) == 3001405358) strcat(s, "l");
if (crc32("PUjVJPud",8) == 281952985) strcat(s, "i");
if (crc32("YWZZMXd",7) == 2890276727) strcat(s, "l");
if (crc32("ZnknCxbEq",9) == 3584984417) strcat(s, "x");
if (crc32("sgscQb",6) == 610362363) strcat(s, "y");
    return s;
}

char *evenhandedly_adverbs() {
    char *s = calloc(13);
    if (crc32("gxFyQkzXEJwRxib",15) == 1958501841) strcat(s, "G");
if (crc32("ZuAoRgSn",8) == 3623005946) strcat(s, "e");
if (crc32("SIihbVBi",8) == 3869171721) strcat(s, "v");
if (crc32("JVhIvYvshBfA",12) == 4214725045) strcat(s, "h");
if (crc32("joeIeKvoB",9) == 3764056402) strcat(s, "e");
if (crc32("jvGTaHHbbNWaR",13) == 886207592) strcat(s, "n");
if (crc32("rpWAcDz",7) == 712398948) strcat(s, "h");
if (crc32("fgfUHTXQ",8) == 727135852) strcat(s, "I");
if (crc32("VKGqHIdISIP",11) == 3068671693) strcat(s, "a");
if (crc32("EnuzjEWJYAPG",12) == 912899221) strcat(s, "O");
if (crc32("nDKGfsdQoAHNaSv",15) == 3363812662) strcat(s, "n");
if (crc32("AHrMrNpN",8) == 2766403467) strcat(s, "v");
if (crc32("NpyBsghpHVa",11) == 2358880419) strcat(s, "d");
if (crc32("HEwsLLZsHN",10) == 447790482) strcat(s, "a");
if (crc32("pczHK",5) == 2527854508) strcat(s, "e");
if (crc32("nSqHwVGjmlf",11) == 825613160) strcat(s, "f");
if (crc32("NfdiZ",5) == 1341370898) strcat(s, "d");
if (crc32("OwOqB",5) == 1062797910) strcat(s, "l");
if (crc32("HRcfNKUGSKq",11) == 342464599) strcat(s, "y");
    return s;
}

char *midships_adverbs() {
    char *s = calloc(9);
    if (crc32("JikquxpWMAgqSu",14) == 807776550) strcat(s, "a");
if (crc32("FTAgpDLTaY",10) == 2260836068) strcat(s, "m");
if (crc32("RVqhRHNQgOlR",12) == 74615671) strcat(s, "i");
if (crc32("AzQIVhdYvWVh",12) == 1986487571) strcat(s, "v");
if (crc32("sRGkWADaGxSiwsB",15) == 2991917173) strcat(s, "d");
if (crc32("KYweOEJNgNaPB",13) == 2599393675) strcat(s, "s");
if (crc32("TehSA",5) == 2830583608) strcat(s, "G");
if (crc32("vsHmLRhRJi",10) == 1425120057) strcat(s, "h");
if (crc32("odkRrCevVIFZ",12) == 3174072844) strcat(s, "i");
if (crc32("ebWsjC",6) == 2057529714) strcat(s, "p");
if (crc32("HpaWj",5) == 3558254283) strcat(s, "s");
    return s;
}

char *nonmethodically_adverbs() {
    char *s = calloc(16);
    if (crc32("iutOcxZnAbUFn",13) == 360664463) strcat(s, "N");
if (crc32("PHodDPp",7) == 1874409332) strcat(s, "n");
if (crc32("PbeGdPSQqKRsY",13) == 3246843353) strcat(s, "O");
if (crc32("NDWDKJpXRhRczEb",15) == 2839175322) strcat(s, "o");
if (crc32("XhSjeBlBQxSxami",15) == 729940634) strcat(s, "n");
if (crc32("hrgSXwysoLXOS",13) == 250369231) strcat(s, "m");
if (crc32("lXSHixHTLcELvz",14) == 4075353201) strcat(s, "e");
if (crc32("FydbFRSWkpi",11) == 2256279812) strcat(s, "Z");
if (crc32("HZXUmbumdP",10) == 1597572490) strcat(s, "t");
if (crc32("WdITTQudTMYD",12) == 3680246644) strcat(s, "h");
if (crc32("MHkZrfjk",8) == 2026962880) strcat(s, "o");
if (crc32("SVeHCOx",7) == 928799712) strcat(s, "X");
if (crc32("sIpTv",5) == 2903269052) strcat(s, "d");
if (crc32("qtSReTByIjjcTmh",15) == 1473400280) strcat(s, "i");
if (crc32("pKUgPqFiW",9) == 3640008139) strcat(s, "c");
if (crc32("HsFOqMtF",8) == 2047373335) strcat(s, "n");
if (crc32("KrpeuHLz",8) == 4272300497) strcat(s, "a");
if (crc32("rFBPhE",6) == 3601353270) strcat(s, "l");
if (crc32("vJcGOO",6) == 3007235060) strcat(s, "l");
if (crc32("JZBLB",5) == 3352371496) strcat(s, "y");
    return s;
}

char *pseudoanatomically_adverbs() {
    char *s = calloc(19);
    if (crc32("GzJGdQNiL",9) == 1025385230) strcat(s, "p");
if (crc32("KwzOSLwV",8) == 172933456) strcat(s, "s");
if (crc32("LXyXoagwhyYHLF",14) == 2899174576) strcat(s, "z");
if (crc32("XSZsGtOKcVYfBjV",15) == 4251347473) strcat(s, "e");
if (crc32("RZalkQqzZOtqinq",15) == 950451022) strcat(s, "u");
if (crc32("iDGYBAY",7) == 3281425657) strcat(s, "d");
if (crc32("NrmAP",5) == 411724763) strcat(s, "Y");
if (crc32("WTQkK",5) == 34017984) strcat(s, "o");
if (crc32("siiLr",5) == 2612999485) strcat(s, "a");
if (crc32("uVBszZ",6) == 2552655591) strcat(s, "O");
if (crc32("jBcXjLjkBIxYOQ",14) == 1221620849) strcat(s, "n");
if (crc32("hkCCE",5) == 746136019) strcat(s, "a");
if (crc32("YkDnysrJM",9) == 4010134398) strcat(s, "t");
if (crc32("VYLGzIJS",8) == 1364366964) strcat(s, "o");
if (crc32("uQbcqSF",7) == 602851290) strcat(s, "K");
if (crc32("iZGISd",6) == 1314608454) strcat(s, "m");
if (crc32("VkdDxIsRVMBlCay",15) == 2971635901) strcat(s, "y");
if (crc32("JdojdPcRHkNNE",13) == 2672220161) strcat(s, "i");
if (crc32("mWzOBSkz",8) == 3516560916) strcat(s, "c");
if (crc32("NvJdDgNa",8) == 425538474) strcat(s, "a");
if (crc32("lTKRIGSKlN",10) == 1351613729) strcat(s, "h");
if (crc32("fiDQTQush",9) == 3659642112) strcat(s, "l");
if (crc32("mBhsYkfNC",9) == 19124907) strcat(s, "l");
if (crc32("jCZamUq",7) == 1788756947) strcat(s, "y");
    return s;
}

char *unpreciously_adverbs() {
    char *s = calloc(13);
    if (crc32("LFklUWLTXO",10) == 4078243714) strcat(s, "u");
if (crc32("RDTUzX",6) == 4261714505) strcat(s, "Q");
if (crc32("oPkHnhgmrnweLs",14) == 1647641274) strcat(s, "n");
if (crc32("Xncqapw",7) == 452124830) strcat(s, "p");
if (crc32("wxbhMu",6) == 3522101303) strcat(s, "i");
if (crc32("TlnsJsUQJKN",11) == 3475945626) strcat(s, "r");
if (crc32("ikSKsp",6) == 2176524297) strcat(s, "e");
if (crc32("QqvKOvmz",8) == 3068556856) strcat(s, "V");
if (crc32("gPxrvC",6) == 4084116381) strcat(s, "c");
if (crc32("bbgcGD",6) == 3796102928) strcat(s, "a");
if (crc32("OACnNRVLXlAnSb",14) == 3224622648) strcat(s, "i");
if (crc32("zwYeeCemqZTHtO",14) == 487723267) strcat(s, "Z");
if (crc32("qOFQOcdPdpvXB",13) == 3551751236) strcat(s, "o");
if (crc32("LsfmExEBq",9) == 234384345) strcat(s, "u");
if (crc32("ZkSgVPPZBYEKV",13) == 1677646073) strcat(s, "G");
if (crc32("pNVjmfinYpXuNw",14) == 746860317) strcat(s, "s");
if (crc32("LARylFB",7) == 4192447416) strcat(s, "n");
if (crc32("ecgUOwBMaN",10) == 189286819) strcat(s, "l");
if (crc32("LWBsTJglwCFZS",13) == 1363984159) strcat(s, "y");
    return s;
}

char *antistrophically_adverbs() {
    char *s = calloc(17);
    if (crc32("kAZUhhHyKVWSUD",14) == 1467098640) strcat(s, "a");
if (crc32("eruwDFqEjgshp",13) == 2419440689) strcat(s, "j");
if (crc32("lJvVjSsw",8) == 2552749369) strcat(s, "n");
if (crc32("qEYrtN",6) == 3672671373) strcat(s, "t");
if (crc32("VeMrUAxxzF",10) == 3673941413) strcat(s, "I");
if (crc32("ZOJmOTzPpFsXdgm",15) == 241186120) strcat(s, "i");
if (crc32("OBpaCqlvLqxQs",13) == 3304754947) strcat(s, "j");
if (crc32("ErrUVJxlogw",11) == 209044677) strcat(s, "s");
if (crc32("ZdVHCG",6) == 3546685260) strcat(s, "t");
if (crc32("jzzoJuztyBEFFb",14) == 3065535805) strcat(s, "m");
if (crc32("cHmXh",5) == 924118039) strcat(s, "r");
if (crc32("YRinDeltvpWnkW",14) == 83364070) strcat(s, "S");
if (crc32("DmMFTuV",7) == 1017902743) strcat(s, "o");
if (crc32("csZBNecwjssW",12) == 253209630) strcat(s, "l");
if (crc32("OGexeDsk",8) == 548520432) strcat(s, "p");
if (crc32("btmFydwTvPqfoC",14) == 1134069746) strcat(s, "h");
if (crc32("lfMWw",5) == 3346330641) strcat(s, "i");
if (crc32("dLpzh",5) == 3949652617) strcat(s, "O");
if (crc32("fnkuXnxQGKlGg",13) == 2630873942) strcat(s, "c");
if (crc32("cjDUQ",5) == 4000056105) strcat(s, "C");
if (crc32("AEmMgQ",6) == 1644888604) strcat(s, "a");
if (crc32("SrKwsuKD",8) == 2728237744) strcat(s, "l");
if (crc32("wniHLxnELtSF",12) == 3425433742) strcat(s, "x");
if (crc32("YeTxyVOakGUi",12) == 3273060527) strcat(s, "l");
if (crc32("XEYWMRU",7) == 1523908078) strcat(s, "y");
    return s;
}

char *quasiunconsciously_adverbs() {
    char *s = calloc(19);
    if (crc32("NRSHZzzvHwJZYZI",15) == 3697143795) strcat(s, "S");
if (crc32("ldRtdBic",8) == 2002072686) strcat(s, "q");
if (crc32("WKSWnXEiF",9) == 4082408156) strcat(s, "b");
if (crc32("WrSSwNrtDH",10) == 549136754) strcat(s, "u");
if (crc32("ahAvKAk",7) == 805322516) strcat(s, "a");
if (crc32("KXtIwONidGoD",12) == 2329424174) strcat(s, "f");
if (crc32("eLBei",5) == 432600853) strcat(s, "s");
if (crc32("WlxxSjM",7) == 2592393970) strcat(s, "i");
if (crc32("BZoolgyeA",9) == 4002789743) strcat(s, "u");
if (crc32("UAKYBecGXfpFl",13) == 3756851410) strcat(s, "v");
if (crc32("UkHdHKWosLaSvEt",15) == 573671145) strcat(s, "n");
if (crc32("aVaCZOzrGJia",12) == 3589914380) strcat(s, "h");
if (crc32("JwrBfph",7) == 4180921383) strcat(s, "c");
if (crc32("jhHyWSGNM",9) == 2992323004) strcat(s, "p");
if (crc32("TWGBwiHsRa",10) == 2376084953) strcat(s, "o");
if (crc32("tJqDSDjtEgzdXAz",15) == 886658059) strcat(s, "n");
if (crc32("BXAyBdGvD",9) == 4206401152) strcat(s, "P");
if (crc32("eRKmIbT",7) == 2806872513) strcat(s, "s");
if (crc32("sWQHHhOswwqLq",13) == 3198297899) strcat(s, "c");
if (crc32("PnFiVxRuuTawYFV",15) == 1575838869) strcat(s, "m");
if (crc32("dkiwak",6) == 2102628057) strcat(s, "i");
if (crc32("LnXiklKlL",9) == 1911614112) strcat(s, "o");
if (crc32("QXZoeQIpW",9) == 4244388234) strcat(s, "u");
if (crc32("qAhlFxbIRMd",11) == 1270851258) strcat(s, "d");
if (crc32("SiUQQf",6) == 958848425) strcat(s, "s");
if (crc32("wSelIVUxlyt",11) == 3204765238) strcat(s, "t");
if (crc32("TKGchBRN",8) == 2867388828) strcat(s, "l");
if (crc32("rhDZoxJz",8) == 1543251824) strcat(s, "t");
if (crc32("nEnxGtaRrSdQVFb",15) == 3025999423) strcat(s, "y");
    return s;
}

char *preexceptionally_adverbs() {
    char *s = calloc(17);
    if (crc32("ptxtLaiTOWGs",12) == 694149931) strcat(s, "C");
if (crc32("XJNgsEUYEGERfIF",15) == 1949621511) strcat(s, "p");
if (crc32("wLYDVfbpqcsC",12) == 1277186029) strcat(s, "W");
if (crc32("ntjbwBroaFQvZ",13) == 1138973718) strcat(s, "r");
if (crc32("vjXQZCW",7) == 2537094128) strcat(s, "i");
if (crc32("AsFqFo",6) == 1540780985) strcat(s, "e");
if (crc32("KSzcRB",6) == 3740197358) strcat(s, "p");
if (crc32("uBRCLBXHEZj",11) == 2307982911) strcat(s, "e");
if (crc32("IpbeXunSTKoH",12) == 1019707787) strcat(s, "x");
if (crc32("AYwnDBd",7) == 400930897) strcat(s, "G");
if (crc32("wTjnIm",6) == 1847389493) strcat(s, "c");
if (crc32("hzgIwaRCNSZ",11) == 789752318) strcat(s, "e");
if (crc32("babkQkAgWMk",11) == 1891235552) strcat(s, "p");
if (crc32("UcwPe",5) == 3382663453) strcat(s, "t");
if (crc32("EgiijyMRT",9) == 1235753605) strcat(s, "x");
if (crc32("aHgRhpwuNHmkTT",14) == 325528158) strcat(s, "i");
if (crc32("WssCd",5) == 4071064634) strcat(s, "o");
if (crc32("RDwiLDqYZL",10) == 1066902410) strcat(s, "n");
if (crc32("DIcSnLWnJ",9) == 1895755006) strcat(s, "R");
if (crc32("gCOYPqqHuoKO",12) == 2226480335) strcat(s, "a");
if (crc32("sICdIynNQnNNhZ",14) == 3933262266) strcat(s, "f");
if (crc32("seVHHDTBDKlT",12) == 3928305142) strcat(s, "l");
if (crc32("yxgqiYnocXwC",12) == 3335931807) strcat(s, "l");
if (crc32("fYvaQETPY",9) == 2768847263) strcat(s, "y");
    return s;
}

char *mortifiedly_adverbs() {
    char *s = calloc(12);
    if (crc32("ZWCqcgwxZYMVW",13) == 3946446721) strcat(s, "D");
if (crc32("hyrNTVInXyO",11) == 2431135423) strcat(s, "m");
if (crc32("HnTKFPnsajWhbuI",15) == 3399906719) strcat(s, "o");
if (crc32("ovpnkJi",7) == 1706571747) strcat(s, "r");
if (crc32("ymGlts",6) == 958169314) strcat(s, "t");
if (crc32("gxEVmZVVytaCsc",14) == 4046382474) strcat(s, "i");
if (crc32("xYbuSVANAhLrux",14) == 298646294) strcat(s, "Q");
if (crc32("IFcoXE",6) == 1357570397) strcat(s, "f");
if (crc32("TlYTIQvYLbqKW",13) == 2819284843) strcat(s, "i");
if (crc32("UGXmhCLgJX",10) == 2124583095) strcat(s, "K");
if (crc32("yogHJelAzIfFv",13) == 3247815591) strcat(s, "e");
if (crc32("xhJKpHVBuB",10) == 682263584) strcat(s, "g");
if (crc32("ZOASyhOLbsggb",13) == 4035235545) strcat(s, "d");
if (crc32("rCvhKdp",7) == 3389788547) strcat(s, "l");
if (crc32("hMZaahjeseqX",12) == 3714147468) strcat(s, "a");
if (crc32("UNegyEaXRsAJWBN",15) == 230751639) strcat(s, "y");
    return s;
}

char *wholly_adverbs() {
    char *s = calloc(7);
    if (crc32("CnQzJhPvfANc",12) == 2728224274) strcat(s, "w");
if (crc32("JcimfYuNr",9) == 2898810378) strcat(s, "J");
if (crc32("LgVwnMrTJvepDb",14) == 2747607338) strcat(s, "h");
if (crc32("KMbnf",5) == 2491646895) strcat(s, "o");
if (crc32("NecwVHWg",8) == 615634421) strcat(s, "E");
if (crc32("CfLHFTmwePEmFHV",15) == 2924046122) strcat(s, "l");
if (crc32("QGrWlgReRky",11) == 4165189022) strcat(s, "l");
if (crc32("xlMznaKNQhTFn",13) == 308036582) strcat(s, "E");
if (crc32("AXtGHsNDyBpqpOO",15) == 2416415285) strcat(s, "y");
    return s;
}

char *instantly_adverbs() {
    char *s = calloc(10);
    if (crc32("wvzDoGDRDl",10) == 1096563690) strcat(s, "i");
if (crc32("SJJqDtcZGc",10) == 1399081599) strcat(s, "M");
if (crc32("AqUiajeuEdMdZ",13) == 2868114680) strcat(s, "n");
if (crc32("vBQGoUI",7) == 3635661775) strcat(s, "s");
if (crc32("aakXoTCHjeRH",12) == 3126978790) strcat(s, "u");
if (crc32("yaiBcmZZDcUDAi",14) == 3046144010) strcat(s, "t");
if (crc32("fVSxrEiZsKy",11) == 731235702) strcat(s, "a");
if (crc32("OYOaWufJxM",10) == 2451013983) strcat(s, "X");
if (crc32("GcrYezbi",8) == 3119938043) strcat(s, "n");
if (crc32("xeVkqfopAbPZv",13) == 515068528) strcat(s, "R");
if (crc32("ClIzORZ",7) == 3190638778) strcat(s, "t");
if (crc32("OMJQcvhFWNPbjq",14) == 216622093) strcat(s, "l");
if (crc32("qLXFSQo",7) == 161664296) strcat(s, "y");
    return s;
}

char *parenthetically_adverbs() {
    char *s = calloc(16);
    if (crc32("YvjHBaLZvVjYo",13) == 3555541927) strcat(s, "L");
if (crc32("HfxXPPyZSS",10) == 241465196) strcat(s, "p");
if (crc32("SISWZEkZMDU",11) == 2575045786) strcat(s, "a");
if (crc32("CYwEPgQIuU",10) == 2592060485) strcat(s, "r");
if (crc32("xKJUaUjKAcL",11) == 2981181147) strcat(s, "e");
if (crc32("lJSiFpZXathZDRj",15) == 2922901941) strcat(s, "c");
if (crc32("KSbvXVPBacBXh",13) == 426246183) strcat(s, "n");
if (crc32("DGFfmOfabpq",11) == 3795076359) strcat(s, "x");
if (crc32("UtthCR",6) == 494665637) strcat(s, "t");
if (crc32("QEiGuO",6) == 761619008) strcat(s, "p");
if (crc32("WqrmZmjfPXC",11) == 3107540316) strcat(s, "h");
if (crc32("YdHDeXeFkASFU",13) == 3754914210) strcat(s, "e");
if (crc32("vZUlF",5) == 4217637996) strcat(s, "r");
if (crc32("cFTWrUbwMeSL",12) == 3839945154) strcat(s, "t");
if (crc32("Fiybe",5) == 2922239470) strcat(s, "t");
if (crc32("sYIApVuXTQevL",13) == 3199462127) strcat(s, "i");
if (crc32("EqoeMj",6) == 4010583187) strcat(s, "c");
if (crc32("csdHJ",5) == 4198429737) strcat(s, "y");
if (crc32("mpEqKYxIl",9) == 2537795280) strcat(s, "a");
if (crc32("GWBPjaktvli",11) == 569749376) strcat(s, "l");
if (crc32("qzBxAvszv",9) == 425900121) strcat(s, "l");
if (crc32("ZKqtqsPLs",9) == 979460890) strcat(s, "D");
if (crc32("uHhVbRKBVHL",11) == 1908885150) strcat(s, "y");
    return s;
}

char *unprohibitively_adverbs() {
    char *s = calloc(16);
    if (crc32("PcMfS",5) == 848624473) strcat(s, "w");
if (crc32("fPRDHg",6) == 2862436844) strcat(s, "u");
if (crc32("JauUjvgw",8) == 3147333806) strcat(s, "n");
if (crc32("ZXODBRapixeZYlz",15) == 1103777154) strcat(s, "p");
if (crc32("ZLdGhWnVKSzWmvj",15) == 3559703161) strcat(s, "r");
if (crc32("DJBWpo",6) == 3298069785) strcat(s, "d");
if (crc32("ckIpUHekgylV",12) == 2944980050) strcat(s, "o");
if (crc32("oSAsutepZKSVSZL",15) == 2840797964) strcat(s, "V");
if (crc32("eitETxDSCFkXtO",14) == 3914925315) strcat(s, "h");
if (crc32("tmUumJVzYwY",11) == 1213769527) strcat(s, "A");
if (crc32("HDwrK",5) == 393139782) strcat(s, "i");
if (crc32("XhKuXLl",7) == 3253906968) strcat(s, "l");
if (crc32("zQWOrASV",8) == 3049796179) strcat(s, "b");
if (crc32("GRYbENGEmA",10) == 2353307338) strcat(s, "i");
if (crc32("XYlsPqXc",8) == 2886673467) strcat(s, "t");
if (crc32("gMingLBAqPMG",12) == 2898171276) strcat(s, "f");
if (crc32("bXlrroE",7) == 1338672186) strcat(s, "i");
if (crc32("Yxwvfl",6) == 2195078663) strcat(s, "v");
if (crc32("xnpURp",6) == 1995317285) strcat(s, "E");
if (crc32("kXHhyhamlYAOMka",15) == 3569344019) strcat(s, "e");
if (crc32("GhMhWOA",7) == 1560804388) strcat(s, "H");
if (crc32("ujzIJzSBYLJrIzA",15) == 3532280081) strcat(s, "l");
if (crc32("dmBto",5) == 2258407643) strcat(s, "y");
    return s;
}

char *prolongably_adverbs() {
    char *s = calloc(12);
    if (crc32("YPYySMKxcYNzIG",14) == 4086488533) strcat(s, "p");
if (crc32("SuZQRQyEgCzhFk",14) == 3369822413) strcat(s, "v");
if (crc32("BCxXYXTXuezn",12) == 1815851900) strcat(s, "r");
if (crc32("ozmgKLp",7) == 4252934791) strcat(s, "o");
if (crc32("LELnnmYlBUckJth",15) == 3435688582) strcat(s, "l");
if (crc32("GQifiUAELzpZWYn",15) == 1927599773) strcat(s, "o");
if (crc32("WypwJbd",7) == 998401257) strcat(s, "T");
if (crc32("NQROHZEFCMwKW",13) == 254641849) strcat(s, "n");
if (crc32("AjxAbdSJU",9) == 1134231804) strcat(s, "J");
if (crc32("MhQNXkEyQjrzH",13) == 932697342) strcat(s, "g");
if (crc32("CVMqsuYH",8) == 3448740945) strcat(s, "a");
if (crc32("ArLeyBXFC",9) == 4102127946) strcat(s, "b");
if (crc32("tCmteM",6) == 1191867944) strcat(s, "Z");
if (crc32("eWNaYmUpZGCLZh",14) == 1215107663) strcat(s, "l");
if (crc32("wxrClWRVmfPgu",13) == 2883537566) strcat(s, "y");
    return s;
}

char *nonsuppositionally_adverbs() {
    char *s = calloc(19);
    if (crc32("pNtZMPOuCExQUYQ",15) == 3488621039) strcat(s, "J");
if (crc32("howBLlEE",8) == 879867301) strcat(s, "n");
if (crc32("HTMnkkPc",8) == 463544958) strcat(s, "o");
if (crc32("geACawfC",8) == 2814899626) strcat(s, "c");
if (crc32("rhDvzfhyPDtvodN",15) == 3262818048) strcat(s, "n");
if (crc32("TJJHPLHybv",10) == 2916114808) strcat(s, "s");
if (crc32("IdtpdVyoHvMBKl",14) == 3869637658) strcat(s, "u");
if (crc32("afDGwExkIhUDjfp",15) == 4293225250) strcat(s, "p");
if (crc32("xsadNyD",7) == 2146640050) strcat(s, "U");
if (crc32("RBxTltMPbiVN",12) == 1351334163) strcat(s, "p");
if (crc32("ZIHjyaWnoWRXeRj",15) == 3618687021) strcat(s, "o");
if (crc32("MifyMokSvSRO",12) == 3806295225) strcat(s, "s");
if (crc32("mVxrlNfVgcnt",12) == 3692082914) strcat(s, "i");
if (crc32("aoznCGvfwnivx",13) == 3521443121) strcat(s, "U");
if (crc32("GZsLlfxwDFQWs",13) == 3715604099) strcat(s, "t");
if (crc32("ovWgAYOGi",9) == 3748253957) strcat(s, "i");
if (crc32("jeHiAnJkPgZf",12) == 3710263321) strcat(s, "U");
if (crc32("USuoi",5) == 1800934341) strcat(s, "o");
if (crc32("ybIlUjkxAkvdaKc",15) == 2132524221) strcat(s, "n");
if (crc32("EZOwSOsFe",9) == 2582488133) strcat(s, "L");
if (crc32("VrbBLrhTDeJ",11) == 3244399186) strcat(s, "a");
if (crc32("KCOZvEmcVZhG",12) == 560341230) strcat(s, "l");
if (crc32("aGNumwp",7) == 1772540419) strcat(s, "l");
if (crc32("bKoSlmhJpG",10) == 723871294) strcat(s, "y");
    return s;
}

char *unadhesively_adverbs() {
    char *s = calloc(13);
    if (crc32("yccbIVQbOZY",11) == 2697732463) strcat(s, "a");
if (crc32("wQMNao",6) == 268926116) strcat(s, "u");
if (crc32("IkOaIwKKcYh",11) == 2535190963) strcat(s, "s");
if (crc32("nutDFuvC",8) == 1495679026) strcat(s, "n");
if (crc32("vHvaeiGwGedbk",13) == 1631423423) strcat(s, "a");
if (crc32("yioMbcyEvukV",12) == 2375865760) strcat(s, "D");
if (crc32("yepoURj",7) == 1773111358) strcat(s, "d");
if (crc32("zaJEfcbG",8) == 2685201379) strcat(s, "h");
if (crc32("VAnOKwbPPgSy",12) == 1278955200) strcat(s, "n");
if (crc32("iAiCUOIA",8) == 3743929880) strcat(s, "e");
if (crc32("QMLQgMEmHrG",11) == 313825305) strcat(s, "g");
if (crc32("OdHBDOp",7) == 3047363446) strcat(s, "s");
if (crc32("cDWUU",5) == 3039171748) strcat(s, "F");
if (crc32("XTaNtKhRlA",10) == 2284537505) strcat(s, "i");
if (crc32("WMvBMWNOvN",10) == 700577214) strcat(s, "m");
if (crc32("ufjAGAmCgPSGGN",14) == 3767749708) strcat(s, "v");
if (crc32("IRSjH",5) == 2066403434) strcat(s, "e");
if (crc32("iMoCvlmnOPxQHOK",15) == 2306188289) strcat(s, "E");
if (crc32("DrVWExeNKJluPHH",15) == 3511465407) strcat(s, "l");
if (crc32("MMdUIwb",7) == 664708450) strcat(s, "y");
    return s;
}

char *agonizedly_adverbs() {
    char *s = calloc(11);
    if (crc32("WZEzSEXC",8) == 1674434799) strcat(s, "a");
if (crc32("ANQMocnkkMQ",11) == 2015267352) strcat(s, "u");
if (crc32("SOcyJWbDirUw",12) == 3183901114) strcat(s, "g");
if (crc32("wKUeQjxXLF",10) == 1956074180) strcat(s, "o");
if (crc32("OtsBxokYGNxx",12) == 172487729) strcat(s, "n");
if (crc32("vAWqTspMTBHu",12) == 693428295) strcat(s, "g");
if (crc32("HBuTFit",7) == 1241853172) strcat(s, "i");
if (crc32("ukwZKe",6) == 3176745943) strcat(s, "z");
if (crc32("NLPzLBj",7) == 2242220124) strcat(s, "T");
if (crc32("zIgXdWf",7) == 3330141101) strcat(s, "e");
if (crc32("pAllOzYzOgiG",12) == 3422255260) strcat(s, "d");
if (crc32("QHdfV",5) == 3297486276) strcat(s, "V");
if (crc32("NaBruxPZgYH",11) == 1424618256) strcat(s, "l");
if (crc32("etpikK",6) == 2929132290) strcat(s, "y");
    return s;
}

char *overgreatly_adverbs() {
    char *s = calloc(12);
    if (crc32("fUmuZsR",7) == 4099304764) strcat(s, "o");
if (crc32("ZkOudehe",8) == 919229502) strcat(s, "D");
if (crc32("ghrBZDtKBsfEHtO",15) == 1413700591) strcat(s, "v");
if (crc32("kecfYFUKT",9) == 3436329129) strcat(s, "D");
if (crc32("GTmYdaZCMaL",11) == 4292069586) strcat(s, "e");
if (crc32("KSuUdAMXw",9) == 137353244) strcat(s, "r");
if (crc32("YseCFXKh",8) == 625626191) strcat(s, "c");
if (crc32("ALVAhlhrAkpodJ",14) == 2079229906) strcat(s, "g");
if (crc32("OEMvFAEmngmpF",13) == 3688176315) strcat(s, "v");
if (crc32("QrHxaEfvwQEnr",13) == 2383612348) strcat(s, "r");
if (crc32("RhwOp",5) == 205121657) strcat(s, "e");
if (crc32("vSbwQDowJ",9) == 284088530) strcat(s, "a");
if (crc32("GisTmfZxh",9) == 1670048630) strcat(s, "t");
if (crc32("jfrrGSKjONHFwXp",15) == 3383269098) strcat(s, "f");
if (crc32("kflBCOsujh",10) == 360761007) strcat(s, "l");
if (crc32("APFEU",5) == 3892767183) strcat(s, "X");
if (crc32("zRTCNrRRg",9) == 3628573684) strcat(s, "y");
    return s;
}

char *dichotomously_adverbs() {
    char *s = calloc(14);
    if (crc32("wWMOT",5) == 3098485869) strcat(s, "d");
if (crc32("wsxxmG",6) == 3163636460) strcat(s, "Q");
if (crc32("pTvGW",5) == 1641317968) strcat(s, "i");
if (crc32("PZHaKxY",7) == 2958966282) strcat(s, "J");
if (crc32("yUkTfnJHUsDuPJ",14) == 531533674) strcat(s, "c");
if (crc32("webTWma",7) == 2279699324) strcat(s, "j");
if (crc32("SMdHNXmiNdgSR",13) == 662515466) strcat(s, "h");
if (crc32("IXsORbbzmVvoxvF",15) == 425533839) strcat(s, "o");
if (crc32("dDYBYoznPNzWg",13) == 4254699321) strcat(s, "J");
if (crc32("kmFCbIJQUmEkIk",14) == 2145103104) strcat(s, "t");
if (crc32("plyXwzX",7) == 362238952) strcat(s, "o");
if (crc32("zDcVCVYgHqZi",12) == 1888270190) strcat(s, "m");
if (crc32("PWJRlntF",8) == 3711154417) strcat(s, "o");
if (crc32("PtBnUK",6) == 995204847) strcat(s, "H");
if (crc32("edzPm",5) == 4083860035) strcat(s, "u");
if (crc32("awmeakSFVMRV",12) == 2033057827) strcat(s, "s");
if (crc32("pYKLZQLAblTYU",13) == 1634224335) strcat(s, "D");
if (crc32("AHsdhwi",7) == 2230943660) strcat(s, "l");
if (crc32("uzwLfateE",9) == 3906257700) strcat(s, "y");
    return s;
}

char *denotatively_adverbs() {
    char *s = calloc(13);
    if (crc32("FmRTwpyDq",9) == 3955256577) strcat(s, "d");
if (crc32("AIcKnVlxLij",11) == 1683881902) strcat(s, "H");
if (crc32("baURhth",7) == 2648970975) strcat(s, "e");
if (crc32("RoAckrAqj",9) == 448120125) strcat(s, "n");
if (crc32("qAlaBJh",7) == 4140744777) strcat(s, "o");
if (crc32("JutDinrvrUb",11) == 2297840093) strcat(s, "o");
if (crc32("JBFOuaqMIukii",13) == 2546971702) strcat(s, "t");
if (crc32("XjhekfWXHEZNWO",14) == 4051151962) strcat(s, "g");
if (crc32("CYTfHEhclos",11) == 2584902604) strcat(s, "a");
if (crc32("VXZxuso",7) == 1790519863) strcat(s, "t");
if (crc32("EqelmSAqL",9) == 876797632) strcat(s, "i");
if (crc32("wCZVKlw",7) == 470116389) strcat(s, "W");
if (crc32("YxHXOvyxeWZk",12) == 3216261411) strcat(s, "v");
if (crc32("PFtvtfMlb",9) == 3193721034) strcat(s, "e");
if (crc32("WKbDCcaPKF",10) == 4064618451) strcat(s, "l");
if (crc32("WoWlqGPIM",9) == 3886996532) strcat(s, "y");
    return s;
}

char *unJesuitically_adverbs() {
    char *s = calloc(15);
    if (crc32("glMBipolKz",10) == 1544999683) strcat(s, "u");
if (crc32("GLXUVBJvKDOoO",13) == 1959142476) strcat(s, "n");
if (crc32("ahnkuIO",7) == 1239378976) strcat(s, "M");
if (crc32("YFADMEUlQT",10) == 253613767) strcat(s, "J");
if (crc32("zkoSdG",6) == 286246004) strcat(s, "e");
if (crc32("RnmZqzP",7) == 893572895) strcat(s, "s");
if (crc32("hUXHJ",5) == 43439238) strcat(s, "t");
if (crc32("UzJZqKxMszbzNs",14) == 4239648326) strcat(s, "u");
if (crc32("PSGnaAzzX",9) == 2455519417) strcat(s, "i");
if (crc32("hGQyTCiola",10) == 86052117) strcat(s, "t");
if (crc32("jUiBiR",6) == 3962883125) strcat(s, "i");
if (crc32("xTGatmqvUpSHXka",15) == 828544348) strcat(s, "c");
if (crc32("DREMVm",6) == 1823614169) strcat(s, "a");
if (crc32("WLUJTzbaajdl",12) == 3615922440) strcat(s, "m");
if (crc32("vAgZWZULfZUDtB",14) == 3015704740) strcat(s, "l");
if (crc32("fLxFC",5) == 310793012) strcat(s, "l");
if (crc32("LrYmGMymkLci",12) == 2764949979) strcat(s, "y");
    return s;
}

char *stilly_adverbs() {
    char *s = calloc(7);
    if (crc32("dJWMjZQxWTwPU",13) == 1888184611) strcat(s, "s");
if (crc32("OQUzHdpIGfcmwdv",15) == 1371059942) strcat(s, "k");
if (crc32("nQXfLYGJoD",10) == 2192270834) strcat(s, "t");
if (crc32("RvgVoDU",7) == 4256600440) strcat(s, "i");
if (crc32("IiaAXzVtjhv",11) == 4258271535) strcat(s, "l");
if (crc32("jrWKkEuXwEJWu",13) == 1779475809) strcat(s, "l");
if (crc32("JmWeNeiubjMoNOM",15) == 1365262697) strcat(s, "y");
    return s;
}

char *nonoppressively_adverbs() {
    char *s = calloc(16);
    if (crc32("BmLfTyNJr",9) == 1709930475) strcat(s, "e");
if (crc32("zYEWtevGNtd",11) == 2989100237) strcat(s, "n");
if (crc32("FUFBQAGWbt",10) == 2147057630) strcat(s, "X");
if (crc32("dWNOGuxhdD",10) == 417421606) strcat(s, "o");
if (crc32("KrzJegUwD",9) == 1866962969) strcat(s, "E");
if (crc32("fgigvwKvxCYx",12) == 1772647008) strcat(s, "n");
if (crc32("XGOYEKIzRU",10) == 3909758522) strcat(s, "o");
if (crc32("lJJoEvXpAsPUXyA",15) == 2442332602) strcat(s, "p");
if (crc32("ttxlDy",6) == 407254244) strcat(s, "i");
if (crc32("wmWToJBAWhkWbWq",15) == 1183636258) strcat(s, "p");
if (crc32("EyXpBqIeoqHlY",13) == 1453474956) strcat(s, "r");
if (crc32("ALbajALLjwd",11) == 515984943) strcat(s, "S");
if (crc32("GyYpAqUqhGAKR",13) == 3546451962) strcat(s, "e");
if (crc32("dnXmGzXFcQRZnJg",15) == 2233797140) strcat(s, "s");
if (crc32("OUaXUvcXtG",10) == 2055468184) strcat(s, "s");
if (crc32("hcmvcmMfdSufvV",14) == 1326384129) strcat(s, "k");
if (crc32("wrIJLsOmUdc",11) == 652294782) strcat(s, "i");
if (crc32("WDMEWK",6) == 702571290) strcat(s, "W");
if (crc32("NTgsnUitqxThFn",14) == 2392234925) strcat(s, "v");
if (crc32("ovxpngiBnm",10) == 933472326) strcat(s, "e");
if (crc32("uCpNLEjSHw",10) == 4248368008) strcat(s, "V");
if (crc32("vkFyUYFcKXxMQtm",15) == 943466552) strcat(s, "l");
if (crc32("aGSMwfwFniMDajQ",15) == 3602632190) strcat(s, "J");
if (crc32("FKpyiu",6) == 3819931540) strcat(s, "y");
    return s;
}

char *interlocally_adverbs() {
    char *s = calloc(13);
    if (crc32("bVcuJCHaB",9) == 3879443678) strcat(s, "i");
if (crc32("NCUjrfopDXXflBo",15) == 1447454209) strcat(s, "n");
if (crc32("SlSfDZiE",8) == 3225263585) strcat(s, "V");
if (crc32("LNvFd",5) == 2624205947) strcat(s, "t");
if (crc32("KtgqiyAyhJMHFjW",15) == 1360009501) strcat(s, "e");
if (crc32("FhJSvFxX",8) == 1542237850) strcat(s, "r");
if (crc32("XCgmHtjOwd",10) == 1958497387) strcat(s, "l");
if (crc32("tHaXgGQqG",9) == 2457628475) strcat(s, "O");
if (crc32("CMKRULUo",8) == 1597126198) strcat(s, "o");
if (crc32("bYvgLJq",7) == 1410170856) strcat(s, "u");
if (crc32("yLQwJxdiMsU",11) == 3809847882) strcat(s, "c");
if (crc32("tkBABGkuK",9) == 40099268) strcat(s, "a");
if (crc32("zPIjB",5) == 3334870287) strcat(s, "l");
if (crc32("wfWDqogPX",9) == 2155804306) strcat(s, "p");
if (crc32("bdoujiaSMvL",11) == 3754136910) strcat(s, "l");
if (crc32("oWaRzDVXB",9) == 3749920981) strcat(s, "M");
if (crc32("oXnjqUqh",8) == 1360412951) strcat(s, "y");
    return s;
}

char *chronoscopically_adverbs() {
    char *s = calloc(17);
    if (crc32("gFoHgdMvtCZXOv",14) == 2606931524) strcat(s, "c");
if (crc32("msAcD",5) == 3999916164) strcat(s, "E");
if (crc32("OvEzXl",6) == 4204049363) strcat(s, "h");
if (crc32("qtknqQQBXszGws",14) == 162605757) strcat(s, "M");
if (crc32("XlMcDHRG",8) == 3362389331) strcat(s, "r");
if (crc32("FxmTykgxjfmKPEJ",15) == 3506340259) strcat(s, "o");
if (crc32("xqOaIAkSn",9) == 712658429) strcat(s, "M");
if (crc32("iEUZyFe",7) == 1213189217) strcat(s, "n");
if (crc32("IPyxcP",6) == 247023636) strcat(s, "g");
if (crc32("YMBAuYTAkn",10) == 2001349120) strcat(s, "o");
if (crc32("NDHGGajBsEhSbtj",15) == 3169600490) strcat(s, "f");
if (crc32("QnkYhRKitzrLDdM",15) == 3047939217) strcat(s, "s");
if (crc32("HYllSpVifOV",11) == 1656032298) strcat(s, "m");
if (crc32("gdnUOjoXSSFKh",13) == 1441030259) strcat(s, "c");
if (crc32("mcouOP",6) == 3569958342) strcat(s, "w");
if (crc32("gpctw",5) == 1236062664) strcat(s, "o");
if (crc32("KaTiRGUCkOACjGM",15) == 71143131) strcat(s, "p");
if (crc32("sDUir",5) == 207982285) strcat(s, "i");
if (crc32("CzYxXKAGwmok",12) == 1311112921) strcat(s, "c");
if (crc32("CTbzhrDNO",9) == 597624002) strcat(s, "T");
if (crc32("HRCEq",5) == 393603791) strcat(s, "a");
if (crc32("PNvGcDdq",8) == 3082299790) strcat(s, "a");
if (crc32("eKUdUixTEzv",11) == 2298903710) strcat(s, "l");
if (crc32("QlzztofPZzAOLph",15) == 2221557460) strcat(s, "B");
if (crc32("VdgPoGiXwvm",11) == 2688849091) strcat(s, "l");
if (crc32("HTFwJt",6) == 2739986928) strcat(s, "p");
if (crc32("hpXzDmNxWZVdBk",14) == 4049826963) strcat(s, "y");
    return s;
}

char *semipopularly_adverbs() {
    char *s = calloc(14);
    if (crc32("GqQLKdqNtth",11) == 3564185581) strcat(s, "g");
if (crc32("mklMWRgvTu",10) == 3763354589) strcat(s, "s");
if (crc32("rxAvVpDOXCQL",12) == 2489345153) strcat(s, "e");
if (crc32("uRqjlvPSVr",10) == 8451820) strcat(s, "T");
if (crc32("JOUtup",6) == 1757709474) strcat(s, "m");
if (crc32("RgfSApOwaVBAx",13) == 449556605) strcat(s, "F");
if (crc32("dJkkGfWnHUBn",12) == 863145620) strcat(s, "i");
if (crc32("OVHQuJeolzXxb",13) == 543307880) strcat(s, "p");
if (crc32("QoMzDmhJCGvc",12) == 4044806464) strcat(s, "o");
if (crc32("ZZwqzWfDYavjm",13) == 676401151) strcat(s, "x");
if (crc32("ORoOKgAndBwo",12) == 2600341271) strcat(s, "p");
if (crc32("VPVptYWqyZPpN",13) == 3063220359) strcat(s, "s");
if (crc32("aEvyQWlPKkMhN",13) == 2504964134) strcat(s, "u");
if (crc32("VpYUwZogqcHSD",13) == 2503673215) strcat(s, "l");
if (crc32("TAvNXrdI",8) == 1003985032) strcat(s, "a");
if (crc32("CsLdNbitkDITY",13) == 1544673758) strcat(s, "t");
if (crc32("cDELjvvW",8) == 3239648878) strcat(s, "r");
if (crc32("GylikBmvg",9) == 4115441867) strcat(s, "P");
if (crc32("egWUEZFvdfZc",12) == 4101772112) strcat(s, "l");
if (crc32("yLDEDFaQFGsmypB",15) == 2603706054) strcat(s, "D");
if (crc32("HghCTZusiY",10) == 1768568119) strcat(s, "y");
    return s;
}

char *indecently_adverbs() {
    char *s = calloc(11);
    if (crc32("gVddk",5) == 2752667614) strcat(s, "j");
if (crc32("tfrBEZicqqg",11) == 4198385884) strcat(s, "i");
if (crc32("WhqrzCzsP",9) == 4078792112) strcat(s, "n");
if (crc32("NYOSE",5) == 2063736936) strcat(s, "d");
if (crc32("udAoYbaLTP",10) == 3984152585) strcat(s, "e");
if (crc32("DPRzA",5) == 460266642) strcat(s, "c");
if (crc32("zonyHFJaBt",10) == 562671655) strcat(s, "e");
if (crc32("RbXHqCwqiubhu",13) == 1249595779) strcat(s, "n");
if (crc32("TTYEGgPC",8) == 3329462696) strcat(s, "t");
if (crc32("cXLKiqMktN",10) == 879501795) strcat(s, "l");
if (crc32("gsGcFUNbeK",10) == 426565554) strcat(s, "X");
if (crc32("fXLQW",5) == 4056321627) strcat(s, "y");
    return s;
}

char *subdiaphragmatically_adverbs() {
    char *s = calloc(21);
    if (crc32("vAiTwqkolDq",11) == 395842444) strcat(s, "X");
if (crc32("bDvAiFawPGM",11) == 3701255459) strcat(s, "s");
if (crc32("ffXrJPUT",8) == 3419446442) strcat(s, "u");
if (crc32("sbjqrkiKR",9) == 4201372695) strcat(s, "j");
if (crc32("ugrMCpAVPoXFul",14) == 1112067190) strcat(s, "b");
if (crc32("QdRqQvTfO",9) == 1927821020) strcat(s, "Y");
if (crc32("kQEWvUHQ",8) == 3091775223) strcat(s, "d");
if (crc32("ajhiBpP",7) == 3091554005) strcat(s, "O");
if (crc32("KwIEtTGb",8) == 322046971) strcat(s, "i");
if (crc32("zuXNRMp",7) == 2279202247) strcat(s, "a");
if (crc32("bgJBumYnKafp",12) == 3663719007) strcat(s, "p");
if (crc32("hmOYLzbTMXwjibg",15) == 3722388351) strcat(s, "h");
if (crc32("WkFiuhBtJxHQj",13) == 993584081) strcat(s, "c");
if (crc32("kDAIhugRzevXS",13) == 3287817925) strcat(s, "r");
if (crc32("XqypMVzKMK",10) == 703040412) strcat(s, "a");
if (crc32("xarCKzeeIHq",11) == 3111289225) strcat(s, "g");
if (crc32("vzVRzpYQpP",10) == 1669059308) strcat(s, "X");
if (crc32("OMWlTpIRWQ",10) == 3194806771) strcat(s, "m");
if (crc32("arYzrcDr",8) == 2453366171) strcat(s, "O");
if (crc32("cidpelHs",8) == 4081454202) strcat(s, "a");
if (crc32("mkUZMqHEHYFLVw",14) == 1859115847) strcat(s, "t");
if (crc32("iZEEDfzNrTEcMI",14) == 2034442743) strcat(s, "i");
if (crc32("PSkHnVdKQLYrMEG",15) == 173831195) strcat(s, "c");
if (crc32("VQAhmuLz",8) == 4176709422) strcat(s, "u");
if (crc32("upBqiNYsp",9) == 991219092) strcat(s, "a");
if (crc32("tzxMmBNUfxpeUp",14) == 1670339946) strcat(s, "r");
if (crc32("VzYkvoM",7) == 343977547) strcat(s, "l");
if (crc32("lXFiukoxrM",10) == 2311688048) strcat(s, "l");
if (crc32("kWSoAauCECWlNtO",15) == 1620376273) strcat(s, "y");
    return s;
}

char *exhaustlessly_adverbs() {
    char *s = calloc(14);
    if (crc32("lAJnpae",7) == 3372959647) strcat(s, "e");
if (crc32("lcLKDGesK",9) == 2451859127) strcat(s, "s");
if (crc32("oUYCPTrtCzMiFR",14) == 2789672278) strcat(s, "x");
if (crc32("naGzqsRJv",9) == 408313781) strcat(s, "W");
if (crc32("cdobocvFpuuDJk",14) == 1950453030) strcat(s, "h");
if (crc32("oeXeLUXdcIJSc",13) == 3791988205) strcat(s, "k");
if (crc32("cGqLz",5) == 2807824456) strcat(s, "a");
if (crc32("PtYfMudSvXNIzlV",15) == 1224716987) strcat(s, "u");
if (crc32("UGRcj",5) == 2188612200) strcat(s, "E");
if (crc32("SQVSTXJpsYc",11) == 2711784666) strcat(s, "s");
if (crc32("JaGfHVZ",7) == 522581821) strcat(s, "v");
if (crc32("oNYsLLXTqbif",12) == 1911272039) strcat(s, "t");
if (crc32("MDuctx",6) == 2894735027) strcat(s, "l");
if (crc32("ErLbLIJmJHxw",12) == 1076866319) strcat(s, "e");
if (crc32("qStdxTM",7) == 1764213878) strcat(s, "s");
if (crc32("bxlwG",5) == 1112560133) strcat(s, "s");
if (crc32("VmieQWILdb",10) == 2631279893) strcat(s, "l");
if (crc32("QdXVIQp",7) == 3779071779) strcat(s, "y");
    return s;
}

char *pisciculturally_adverbs() {
    char *s = calloc(16);
    if (crc32("JLtHIYiAsZGPa",13) == 1640339575) strcat(s, "A");
if (crc32("ynshknzK",8) == 3018899141) strcat(s, "p");
if (crc32("VxbvIFZ",7) == 3311972628) strcat(s, "i");
if (crc32("bkjAC",5) == 2528596864) strcat(s, "K");
if (crc32("NMnGgVCFkmfxzU",14) == 2759709428) strcat(s, "s");
if (crc32("nwhwJXuwwjuyf",13) == 3320765307) strcat(s, "I");
if (crc32("uZusTcHNvHo",11) == 759982277) strcat(s, "c");
if (crc32("aFVObDDhhFVXc",13) == 243161882) strcat(s, "I");
if (crc32("aRLzyGTqen",10) == 3523454832) strcat(s, "i");
if (crc32("OIaar",5) == 1902494931) strcat(s, "c");
if (crc32("LTTpsAhViuEVU",13) == 787850628) strcat(s, "u");
if (crc32("rOgFlbYDc",9) == 1369040178) strcat(s, "r");
if (crc32("RiATzOJVDl",10) == 2694163005) strcat(s, "l");
if (crc32("Fbkszgkk",8) == 3294597834) strcat(s, "B");
if (crc32("ZveenGoppUvwexx",15) == 436119929) strcat(s, "t");
if (crc32("CxjToyKT",8) == 671542641) strcat(s, "E");
if (crc32("YXKlIYWdJ",9) == 2592907610) strcat(s, "u");
if (crc32("cUuyYpIny",9) == 173316874) strcat(s, "G");
if (crc32("QexfwoHwROKZz",13) == 44365214) strcat(s, "r");
if (crc32("aYYoGsmYmCWtX",13) == 243210392) strcat(s, "d");
if (crc32("RGeImkuzULTqqPv",15) == 532998636) strcat(s, "a");
if (crc32("PqIQsRsiVvBQe",13) == 1473325926) strcat(s, "c");
if (crc32("dzeAJ",5) == 2674243945) strcat(s, "l");
if (crc32("urpaxwvWLUClmoX",15) == 440487509) strcat(s, "p");
if (crc32("crTGjqkytAeMQ",13) == 4098597778) strcat(s, "l");
if (crc32("PSHkxEwDIToN",12) == 3654542916) strcat(s, "y");
    return s;
}

char *desirably_adverbs() {
    char *s = calloc(10);
    if (crc32("QfnVNSjzOAlMXjy",15) == 111323944) strcat(s, "d");
if (crc32("zVEhaDmcpc",10) == 3423582741) strcat(s, "e");
if (crc32("WjsoViek",8) == 3898158605) strcat(s, "s");
if (crc32("uvoZiNcWDQVgUwx",15) == 2892922792) strcat(s, "i");
if (crc32("CAskn",5) == 2046196076) strcat(s, "m");
if (crc32("ilZmw",5) == 1558835337) strcat(s, "r");
if (crc32("IOiwZxlUevw",11) == 2115754046) strcat(s, "s");
if (crc32("zOxQZG",6) == 2864835973) strcat(s, "a");
if (crc32("Dfcrt",5) == 3223550934) strcat(s, "D");
if (crc32("kXrRenhBjyzhxZ",14) == 2838636347) strcat(s, "b");
if (crc32("RfsYGu",6) == 1665584270) strcat(s, "l");
if (crc32("dkkfIKdnzd",10) == 3995178632) strcat(s, "y");
    return s;
}

char *unneedfully_adverbs() {
    char *s = calloc(12);
    if (crc32("KBlkgYySOcxZlCz",15) == 3677236030) strcat(s, "c");
if (crc32("FKGlKvB",7) == 3648206237) strcat(s, "u");
if (crc32("XpTxPrgMWyHRQ",13) == 716981494) strcat(s, "I");
if (crc32("fEimR",5) == 1856637026) strcat(s, "n");
if (crc32("lhqnqGpe",8) == 1627203356) strcat(s, "v");
if (crc32("yeHJhodYR",9) == 2430645003) strcat(s, "n");
if (crc32("EfpNICPbiE",10) == 2662082825) strcat(s, "n");
if (crc32("GfOnTtE",7) == 3848780007) strcat(s, "e");
if (crc32("apLtFCo",7) == 953538279) strcat(s, "i");
if (crc32("vzyyRiAC",8) == 3210694468) strcat(s, "e");
if (crc32("mOlvCgLUZeKr",12) == 3870967067) strcat(s, "d");
if (crc32("MqinHwl",7) == 1843830421) strcat(s, "f");
if (crc32("cKLtqCJnwKBg",12) == 1243320966) strcat(s, "r");
if (crc32("NIIavQQZlG",10) == 3787018032) strcat(s, "u");
if (crc32("ALthggJcpJotcv",14) == 4151108424) strcat(s, "l");
if (crc32("LEDkrl",6) == 1353867553) strcat(s, "l");
if (crc32("orAdRmrDD",9) == 3287416692) strcat(s, "l");
if (crc32("uyBbcRg",7) == 833000418) strcat(s, "a");
if (crc32("TqROTL",6) == 1494268418) strcat(s, "y");
    return s;
}

char *inflammatorily_adverbs() {
    char *s = calloc(15);
    if (crc32("OoaDjSOUYxLpX",13) == 867252190) strcat(s, "H");
if (crc32("XamCzP",6) == 4033259787) strcat(s, "i");
if (crc32("DJMVlvCXTN",10) == 287123273) strcat(s, "N");
if (crc32("HqUtBJ",6) == 1830181576) strcat(s, "n");
if (crc32("uropcfERflkzqMG",15) == 4150656780) strcat(s, "f");
if (crc32("GojFfQAHQsAms",13) == 401563003) strcat(s, "l");
if (crc32("TEwCahlbgzafr",13) == 1711673596) strcat(s, "a");
if (crc32("SMZJT",5) == 403063122) strcat(s, "X");
if (crc32("VBExYSQTasmz",12) == 4075050685) strcat(s, "m");
if (crc32("MwRZGFPlLW",10) == 1628612991) strcat(s, "E");
if (crc32("mTMrIfe",7) == 4034110444) strcat(s, "m");
if (crc32("aFBUYcDKzl",10) == 1072472284) strcat(s, "D");
if (crc32("WFCWBsO",7) == 2063194926) strcat(s, "a");
if (crc32("AHRjpgQrFW",10) == 9388076) strcat(s, "y");
if (crc32("WoIfQjfyWzTrEs",14) == 2857067343) strcat(s, "t");
if (crc32("BmeaQ",5) == 63693221) strcat(s, "o");
if (crc32("UQbevPpMpY",10) == 1497611125) strcat(s, "r");
if (crc32("QLbNKYqsctaqefb",15) == 3198067025) strcat(s, "g");
if (crc32("ncxSMOtLWlwokU",14) == 1109538908) strcat(s, "i");
if (crc32("SpzwzVXhXan",11) == 4273815649) strcat(s, "x");
if (crc32("ZPmCVpRrAYVTw",13) == 448710753) strcat(s, "l");
if (crc32("vDJGjPi",7) == 1493735463) strcat(s, "y");
    return s;
}

char *nonbuoyantly_adverbs() {
    char *s = calloc(13);
    if (crc32("gjQucXR",7) == 2261540478) strcat(s, "Q");
if (crc32("VgXKoWSaTOpEsfo",15) == 2335414345) strcat(s, "n");
if (crc32("HbRJZbYcUdLGfK",14) == 2394514799) strcat(s, "p");
if (crc32("UJXKjQjA",8) == 4031597301) strcat(s, "o");
if (crc32("CUykypxswcoh",12) == 4205469535) strcat(s, "n");
if (crc32("ryMcYtPB",8) == 1483158815) strcat(s, "b");
if (crc32("kSRiXwMx",8) == 1811201456) strcat(s, "u");
if (crc32("QZCDCFzXDcblFW",14) == 1161594191) strcat(s, "o");
if (crc32("aLbOUudz",8) == 2316512648) strcat(s, "N");
if (crc32("lqtSrQlKBPqJ",12) == 454213164) strcat(s, "y");
if (crc32("KjgsvHDTAh",10) == 721674099) strcat(s, "a");
if (crc32("kqgzLiaeODhdhr",14) == 823882323) strcat(s, "w");
if (crc32("BwsszaS",7) == 1220912148) strcat(s, "n");
if (crc32("bGHDwYTuhFgSH",13) == 1058020930) strcat(s, "t");
if (crc32("qknVHvdQToMNbX",14) == 1814171013) strcat(s, "l");
if (crc32("giojPt",6) == 4224174767) strcat(s, "y");
    return s;
}

char *evangelistically_adverbs() {
    char *s = calloc(17);
    if (crc32("AcJZcyDJOpI",11) == 904251300) strcat(s, "C");
if (crc32("egrJUZsjhCI",11) == 3149315706) strcat(s, "e");
if (crc32("sXptSaIByifci",13) == 1932011341) strcat(s, "v");
if (crc32("eSVMw",5) == 4219195454) strcat(s, "E");
if (crc32("oETmwpZJIizwb",13) == 4208232546) strcat(s, "a");
if (crc32("EXfuhnkRuUfnCC",14) == 2750543631) strcat(s, "n");
if (crc32("wfvqHmFEL",9) == 204821284) strcat(s, "g");
if (crc32("QkNWUIxsPbTQ",12) == 3044589347) strcat(s, "Y");
if (crc32("ZcstrEmJDKEqP",13) == 3405638677) strcat(s, "e");
if (crc32("WQfGeCpeGhK",11) == 4234328427) strcat(s, "l");
if (crc32("eloGxO",6) == 2720823017) strcat(s, "i");
if (crc32("WyXLdyC",7) == 745232326) strcat(s, "W");
if (crc32("jzndoZr",7) == 931226329) strcat(s, "s");
if (crc32("GzpoQzXSmRue",12) == 3509507922) strcat(s, "t");
if (crc32("ufTwyvYSMte",11) == 4158255869) strcat(s, "i");
if (crc32("bZCALINTR",9) == 2667632928) strcat(s, "U");
if (crc32("VnnIH",5) == 2977797762) strcat(s, "c");
if (crc32("yeZVYXUtyLEZL",13) == 1314746645) strcat(s, "k");
if (crc32("fZooTEkHtWs",11) == 2692893720) strcat(s, "a");
if (crc32("SFtbRQEk",8) == 19854675) strcat(s, "i");
if (crc32("yohTNnx",7) == 800541853) strcat(s, "l");
if (crc32("TPpuewTwAiHG",12) == 2851377591) strcat(s, "l");
if (crc32("YcIBvmMFLBzok",13) == 270188585) strcat(s, "y");
    return s;
}

char *unboyishly_adverbs() {
    char *s = calloc(11);
    if (crc32("xlXhFrUR",8) == 1719950005) strcat(s, "R");
if (crc32("mxfXFCoEQ",9) == 2966423352) strcat(s, "u");
if (crc32("DZtnLU",6) == 965021627) strcat(s, "p");
if (crc32("FwtRiDq",7) == 903288934) strcat(s, "n");
if (crc32("ETqEaCsc",8) == 38860578) strcat(s, "z");
if (crc32("qqkUBSHyUCm",11) == 726286157) strcat(s, "b");
if (crc32("MtIChDsJe",9) == 1700540491) strcat(s, "o");
if (crc32("ynUvHrUncFU",11) == 971791196) strcat(s, "O");
if (crc32("TGHzCNtyyk",10) == 2919888422) strcat(s, "y");
if (crc32("WkAHYEoZJxqg",12) == 84070628) strcat(s, "O");
if (crc32("uexppkQPShMM",12) == 4217677807) strcat(s, "i");
if (crc32("SsBkssIs",8) == 150143344) strcat(s, "s");
if (crc32("hjxItGwYVQILZr",14) == 1044262989) strcat(s, "h");
if (crc32("uoIydzX",7) == 1736832883) strcat(s, "h");
if (crc32("qXhgCStv",8) == 3476668444) strcat(s, "l");
if (crc32("FcSccLT",7) == 3105510698) strcat(s, "T");
if (crc32("uooIbj",6) == 401411380) strcat(s, "y");
    return s;
}

char *thickly_adverbs() {
    char *s = calloc(8);
    if (crc32("NUwXUmKEQ",9) == 4039618589) strcat(s, "V");
if (crc32("XEJLgEwAAQm",11) == 2093114214) strcat(s, "t");
if (crc32("bXknsltWeh",10) == 3038666937) strcat(s, "B");
if (crc32("wtROZhXWHPeKlOX",15) == 1762997377) strcat(s, "h");
if (crc32("IzkfhZrfI",9) == 2559869587) strcat(s, "i");
if (crc32("GjWhFMGXNWcIA",13) == 3812967239) strcat(s, "V");
if (crc32("pOLrGRaJba",10) == 3528085884) strcat(s, "c");
if (crc32("ShJNdbTrKQ",10) == 2081915568) strcat(s, "Q");
if (crc32("dTxUYlwlro",10) == 436379292) strcat(s, "k");
if (crc32("FVPUFSuul",9) == 3978552143) strcat(s, "l");
if (crc32("RvBArA",6) == 3217195025) strcat(s, "K");
if (crc32("CustYQd",7) == 1667063127) strcat(s, "y");
    return s;
}

char *resoundingly_adverbs() {
    char *s = calloc(13);
    if (crc32("PWxsfrt",7) == 2219355787) strcat(s, "D");
if (crc32("NXYuV",5) == 2624936501) strcat(s, "r");
if (crc32("FpWaX",5) == 1858566649) strcat(s, "a");
if (crc32("MdnyFA",6) == 1234641910) strcat(s, "e");
if (crc32("cVEtRLJuTtsQ",12) == 1702793184) strcat(s, "s");
if (crc32("cIIuBkttLyRHqT",14) == 647081522) strcat(s, "N");
if (crc32("LMhnaoICTyi",11) == 1464634875) strcat(s, "o");
if (crc32("PquezgLxGVVyBtW",15) == 3031097252) strcat(s, "u");
if (crc32("CBLAvBxDgO",10) == 279101376) strcat(s, "u");
if (crc32("tiMTCmmcQz",10) == 4045997405) strcat(s, "n");
if (crc32("jMCAbKAurAJrW",13) == 562467184) strcat(s, "d");
if (crc32("xMNoqPYjjwIMuU",14) == 3551413992) strcat(s, "i");
if (crc32("GuXFXJPhG",9) == 2761657418) strcat(s, "n");
if (crc32("AlRQqrnd",8) == 3177311395) strcat(s, "g");
if (crc32("NRWuOxaIP",9) == 588816655) strcat(s, "A");
if (crc32("griKYRZgvCbeS",13) == 4234688982) strcat(s, "l");
if (crc32("BsgUgnMjD",9) == 1089106217) strcat(s, "y");
    return s;
}

char *incomprehensibly_adverbs() {
    char *s = calloc(17);
    if (crc32("quAmHKmoRM",10) == 2305601405) strcat(s, "i");
if (crc32("ijIzbE",6) == 1095559581) strcat(s, "q");
if (crc32("dWtEsCK",7) == 1063990032) strcat(s, "n");
if (crc32("ESLpTYUYb",9) == 4161312542) strcat(s, "c");
if (crc32("xTWkKumsTbJBqvv",15) == 2593999341) strcat(s, "B");
if (crc32("USQsbfUwXoRS",12) == 4218269050) strcat(s, "o");
if (crc32("NaqUqP",6) == 3090671663) strcat(s, "f");
if (crc32("VHZpWAPL",8) == 924538219) strcat(s, "m");
if (crc32("VepXKgbDHFWz",12) == 199707414) strcat(s, "p");
if (crc32("NfXTeEdoCH",10) == 2171597409) strcat(s, "r");
if (crc32("lVOOFsIpYLwfr",13) == 256856705) strcat(s, "e");
if (crc32("sKiLRuDibkPiM",13) == 506749957) strcat(s, "h");
if (crc32("CCqVJfIiOjz",11) == 1546570309) strcat(s, "e");
if (crc32("rTcypwpJPVZEr",13) == 1172471929) strcat(s, "S");
if (crc32("DdevwkGQH",9) == 1015289685) strcat(s, "n");
if (crc32("aDfJMhvbduTolk",14) == 612802929) strcat(s, "J");
if (crc32("xBXhg",5) == 583051001) strcat(s, "s");
if (crc32("nGpcCLNrqz",10) == 1054636988) strcat(s, "i");
if (crc32("PLBfHzzdPShpaHk",15) == 1410577860) strcat(s, "b");
if (crc32("lGDyAluwVR",10) == 3130530909) strcat(s, "l");
if (crc32("DBeEXs",6) == 3338624304) strcat(s, "y");
    return s;
}

char *childishly_adverbs() {
    char *s = calloc(11);
    if (crc32("lRCIee",6) == 1604303232) strcat(s, "c");
if (crc32("vsEVoheUcOYlX",13) == 2194495396) strcat(s, "h");
if (crc32("uFhrJwUPmBS",11) == 3997535406) strcat(s, "u");
if (crc32("MgQsiKSu",8) == 1796434687) strcat(s, "i");
if (crc32("fXHjY",5) == 1609922540) strcat(s, "y");
if (crc32("kZNuHbXcG",9) == 2389297616) strcat(s, "l");
if (crc32("yOeDECHeid",10) == 1848131767) strcat(s, "d");
if (crc32("vZvslQeYaHvDgo",14) == 3114133367) strcat(s, "i");
if (crc32("JdJChTHKT",9) == 2089556641) strcat(s, "s");
if (crc32("rAHvCelFe",9) == 241639648) strcat(s, "c");
if (crc32("sPwyNSelqa",10) == 1485236449) strcat(s, "h");
if (crc32("toBjBnS",7) == 2673783859) strcat(s, "H");
if (crc32("zgOtiWrE",8) == 3500011579) strcat(s, "l");
if (crc32("zAsUgJlBpmpMGHN",15) == 4244091425) strcat(s, "y");
    return s;
}

char *tacitly_adverbs() {
    char *s = calloc(8);
    if (crc32("IAUTMYUvxz",10) == 339568054) strcat(s, "Q");
if (crc32("czOlgaWwxLXHueY",15) == 1440220413) strcat(s, "t");
if (crc32("kvvvMYxTvipWZ",13) == 3655134077) strcat(s, "E");
if (crc32("zquzitr",7) == 2464480629) strcat(s, "a");
if (crc32("TrzajjREshaMwY",14) == 3821669533) strcat(s, "S");
if (crc32("yzSup",5) == 1523931453) strcat(s, "c");
if (crc32("RlqRutkBhiK",11) == 2461836805) strcat(s, "i");
if (crc32("WRuxTXTrdrFLbVX",15) == 998018301) strcat(s, "P");
if (crc32("DWXuxZnqRSX",11) == 1743367341) strcat(s, "t");
if (crc32("vhovtYYU",8) == 590166623) strcat(s, "x");
if (crc32("fVhOLSaSAmG",11) == 1291998638) strcat(s, "l");
if (crc32("vXiqXraDXUtl",12) == 1082357670) strcat(s, "y");
    return s;
}

char *quasifictitiously_adverbs() {
    char *s = calloc(18);
    if (crc32("QxxkemgQeaK",11) == 392223789) strcat(s, "q");
if (crc32("BHeRfIKKDgMSx",13) == 844799300) strcat(s, "K");
if (crc32("qMsOnFdCFA",10) == 3245209832) strcat(s, "u");
if (crc32("lcheBl",6) == 1978105200) strcat(s, "k");
if (crc32("wlnEoFeQcOZAfrT",15) == 1200472841) strcat(s, "a");
if (crc32("QlkrOKIzwyRo",12) == 2757434058) strcat(s, "s");
if (crc32("gkWXAZvaO",9) == 1593808311) strcat(s, "i");
if (crc32("tciZkLBdIm",10) == 3140784752) strcat(s, "l");
if (crc32("iARuvlwir",9) == 1085498929) strcat(s, "f");
if (crc32("MAjbc",5) == 2212045708) strcat(s, "i");
if (crc32("soKpwhrBs",9) == 1007188938) strcat(s, "g");
if (crc32("MfvDznrCgRYouj",14) == 2547476848) strcat(s, "c");
if (crc32("pTsiwSBK",8) == 2281314422) strcat(s, "R");
if (crc32("zGgVjvUkNQxhB",13) == 1292610395) strcat(s, "t");
if (crc32("RNeRKXyrtJzQA",13) == 2324448433) strcat(s, "U");
if (crc32("fIDSaWWAiXMc",12) == 4143385093) strcat(s, "i");
if (crc32("JnXvejGciVZj",12) == 846660877) strcat(s, "t");
if (crc32("aJMyWbTzSGfv",12) == 2325375040) strcat(s, "i");
if (crc32("SPtTugkWni",10) == 3448499786) strcat(s, "f");
if (crc32("rkPgtNmiGMtf",12) == 3424795683) strcat(s, "o");
if (crc32("NDCUWzjryqnTQ",13) == 2396070189) strcat(s, "u");
if (crc32("nELKPzet",8) == 1720308438) strcat(s, "o");
if (crc32("lJRtaYIx",8) == 3499829058) strcat(s, "s");
if (crc32("YJygfeHibBbRlRe",15) == 3498781201) strcat(s, "l");
if (crc32("nxlNdOIli",9) == 593663643) strcat(s, "C");
if (crc32("frQABNwWxVAPzw",14) == 124466607) strcat(s, "y");
    return s;
}

char *overhelpfully_adverbs() {
    char *s = calloc(14);
    if (crc32("RcfightaIELbH",13) == 2492822958) strcat(s, "l");
if (crc32("KKqrNvoKZCnkqKC",15) == 2267876476) strcat(s, "o");
if (crc32("AVwhPhxJmTKL",12) == 2463440205) strcat(s, "K");
if (crc32("hxziAQkwbqvstn",14) == 2735166256) strcat(s, "v");
if (crc32("LfJuKpXlZtQwu",13) == 1725159357) strcat(s, "B");
if (crc32("FOphTbJAVUtKRP",14) == 4118530294) strcat(s, "e");
if (crc32("tulDvEfjgTIbeX",14) == 261997090) strcat(s, "E");
if (crc32("yIbVqvRWn",9) == 4027270637) strcat(s, "r");
if (crc32("doLULN",6) == 3993935580) strcat(s, "L");
if (crc32("RkdBShFiQFOYzwJ",15) == 4268714848) strcat(s, "h");
if (crc32("bRNnpWl",7) == 423019494) strcat(s, "e");
if (crc32("VMznX",5) == 3752280063) strcat(s, "l");
if (crc32("YhQBjivDAXX",11) == 2693199933) strcat(s, "p");
if (crc32("TuEWyUa",7) == 1904854410) strcat(s, "f");
if (crc32("VtLeTqRiYTsTgW",14) == 356623297) strcat(s, "u");
if (crc32("ilhVNGYdw",9) == 3198068322) strcat(s, "l");
if (crc32("mWMiJw",6) == 1695849891) strcat(s, "l");
if (crc32("kRmHpw",6) == 3350834270) strcat(s, "y");
    return s;
}

char *suppositionally_adverbs() {
    char *s = calloc(16);
    if (crc32("NENzdlZj",8) == 3740964294) strcat(s, "E");
if (crc32("nyCUqpMOttHgDk",14) == 3453462725) strcat(s, "s");
if (crc32("dEuovUhuIwR",11) == 555877224) strcat(s, "t");
if (crc32("QRKlI",5) == 416442865) strcat(s, "u");
if (crc32("EizVdBdh",8) == 814495134) strcat(s, "D");
if (crc32("WlHTPgLSIfMT",12) == 1419959324) strcat(s, "p");
if (crc32("YJtgdyzDUDeT",12) == 3729495565) strcat(s, "D");
if (crc32("vrINwHkoma",10) == 3749722066) strcat(s, "p");
if (crc32("lCxnz",5) == 34438497) strcat(s, "o");
if (crc32("HnqCV",5) == 1414164072) strcat(s, "D");
if (crc32("kONgejIFD",9) == 1691868751) strcat(s, "s");
if (crc32("vyvSpBtvAJ",10) == 272530149) strcat(s, "h");
if (crc32("GecCfpDZWMkA",12) == 1991126590) strcat(s, "i");
if (crc32("OuquPmdc",8) == 2225834223) strcat(s, "t");
if (crc32("GQuaaMgMdh",10) == 3425972184) strcat(s, "i");
if (crc32("flBXDo",6) == 739467631) strcat(s, "f");
if (crc32("HMeQuzv",7) == 1168212710) strcat(s, "o");
if (crc32("foJbufBZRrCUS",13) == 217525059) strcat(s, "n");
if (crc32("unIIyQbybrW",11) == 2274185976) strcat(s, "a");
if (crc32("wiqLTwQFyI",10) == 3588135430) strcat(s, "z");
if (crc32("IcmzOshpFkL",11) == 470968852) strcat(s, "l");
if (crc32("PqwYgfRBMoJk",12) == 425204118) strcat(s, "l");
if (crc32("VtLQUnwsWC",10) == 299696710) strcat(s, "I");
if (crc32("lszzUsIPiEQr",12) == 1216194514) strcat(s, "y");
    return s;
}

char *expressionlessly_adverbs() {
    char *s = calloc(17);
    if (crc32("MBjiBxpajz",10) == 1385817510) strcat(s, "u");
if (crc32("noBxtaUBld",10) == 603619298) strcat(s, "e");
if (crc32("foCnZ",5) == 2970181631) strcat(s, "x");
if (crc32("CowHvBIjbxXryik",15) == 2672087408) strcat(s, "p");
if (crc32("OjLLNcFsM",9) == 4162125392) strcat(s, "G");
if (crc32("ERHJBPmlw",9) == 305145989) strcat(s, "r");
if (crc32("SCrlLFAV",8) == 536866396) strcat(s, "e");
if (crc32("qKTYmUUkUDe",11) == 1055543114) strcat(s, "s");
if (crc32("oRRuujAgXWpZG",13) == 1748198953) strcat(s, "s");
if (crc32("pwJtk",5) == 3206161009) strcat(s, "J");
if (crc32("dPSZXjUlevIM",12) == 1102485757) strcat(s, "i");
if (crc32("YTMZfvRwsCbeSxX",15) == 3586392899) strcat(s, "G");
if (crc32("ewaQcIBnL",9) == 1946148057) strcat(s, "o");
if (crc32("XlemTgxHomnmFIs",15) == 1710217989) strcat(s, "n");
if (crc32("RaWORHaTVr",10) == 1645980920) strcat(s, "w");
if (crc32("DxImuwQlpulMu",13) == 3194611696) strcat(s, "l");
if (crc32("IzBauZ",6) == 920924360) strcat(s, "M");
if (crc32("zhsJhTjWK",9) == 1330691155) strcat(s, "e");
if (crc32("GNDiiE",6) == 1203806016) strcat(s, "j");
if (crc32("EqRvGGAig",9) == 2171007637) strcat(s, "s");
if (crc32("PweqZgpjryGoDKM",15) == 3478005749) strcat(s, "j");
if (crc32("tfKwzcwVfPHBI",13) == 4125292522) strcat(s, "s");
if (crc32("bqKpWoIFjrm",11) == 354771953) strcat(s, "l");
if (crc32("ExOiMh",6) == 2065527616) strcat(s, "m");
if (crc32("FhQXKHMV",8) == 142315284) strcat(s, "y");
    return s;
}

char *unmedically_adverbs() {
    char *s = calloc(12);
    if (crc32("uuhWXu",6) == 510912344) strcat(s, "u");
if (crc32("uBfpgFO",7) == 288997571) strcat(s, "n");
if (crc32("uEcxZya",7) == 992626625) strcat(s, "k");
if (crc32("bpXfgZzX",8) == 2593229973) strcat(s, "m");
if (crc32("lSvTTHZxynaCKoR",15) == 1901846768) strcat(s, "l");
if (crc32("TqewOHDFleZERbz",15) == 23875179) strcat(s, "e");
if (crc32("cxuhcPr",7) == 1903860447) strcat(s, "S");
if (crc32("eVQKGazTcZH",11) == 672860289) strcat(s, "d");
if (crc32("FThClNTNsP",10) == 2441963302) strcat(s, "i");
if (crc32("VbOrEhgKkZRa",12) == 3440217289) strcat(s, "i");
if (crc32("ivEINJbgJXIu",12) == 1201731020) strcat(s, "O");
if (crc32("ZpMHUfdD",8) == 1447070046) strcat(s, "c");
if (crc32("zlbyVTkvJnLZtd",14) == 3472792167) strcat(s, "E");
if (crc32("rihXkzuqVTnZcV",14) == 1016360891) strcat(s, "a");
if (crc32("UXynCjwuG",9) == 3011973533) strcat(s, "l");
if (crc32("RnMPSMMAmrEs",12) == 1079697118) strcat(s, "z");
if (crc32("tMTaioxCaGn",11) == 2255450172) strcat(s, "l");
if (crc32("ivgMDNROCBllmN",14) == 1451459989) strcat(s, "y");
    return s;
}

char *unparasitically_adverbs() {
    char *s = calloc(16);
    if (crc32("VHsRyFbE",8) == 1029628416) strcat(s, "Y");
if (crc32("ZnHwruZIGHwjRpr",15) == 706586209) strcat(s, "u");
if (crc32("IisFlDi",7) == 2472767617) strcat(s, "o");
if (crc32("osGWnvwOHf",10) == 2589064363) strcat(s, "n");
if (crc32("oKbAmsNRCOVQGN",14) == 2121605131) strcat(s, "G");
if (crc32("pkkWDbs",7) == 1113296180) strcat(s, "p");
if (crc32("EFByvJxsy",9) == 3678931658) strcat(s, "F");
if (crc32("XwpGiulBREOugV",14) == 4075664920) strcat(s, "a");
if (crc32("BwJaLTbFnLcLo",13) == 2563226302) strcat(s, "r");
if (crc32("nllzxQJ",7) == 2246618028) strcat(s, "d");
if (crc32("oNTKkox",7) == 2894042366) strcat(s, "a");
if (crc32("ccPIqtxTS",9) == 2159666118) strcat(s, "s");
if (crc32("elrzhEGWRbBP",12) == 4254932579) strcat(s, "U");
if (crc32("kAgFOHEVp",9) == 78522673) strcat(s, "i");
if (crc32("myypnFjbtfzD",12) == 3048021300) strcat(s, "A");
if (crc32("twrBOJbWuR",10) == 1991726002) strcat(s, "t");
if (crc32("YurVnPNlBpr",11) == 2518068247) strcat(s, "i");
if (crc32("ZSwFSzkErwMZ",12) == 3400067019) strcat(s, "c");
if (crc32("GWcFimI",7) == 3619380198) strcat(s, "L");
if (crc32("TBXCMdKXVeWUtZ",14) == 1045668833) strcat(s, "a");
if (crc32("rjGHT",5) == 819501168) strcat(s, "l");
if (crc32("uOiuDEfIfJac",12) == 4009623289) strcat(s, "l");
if (crc32("ckInPdmJhF",10) == 2281925223) strcat(s, "C");
if (crc32("FZDsM",5) == 3469575990) strcat(s, "y");
    return s;
}

char *awry_adverbs() {
    char *s = calloc(5);
    if (crc32("AQkfWxQMYcIHPrr",15) == 1842864201) strcat(s, "y");
if (crc32("qSSuSwEagCEX",12) == 4165159431) strcat(s, "a");
if (crc32("QIgtMPnGkJ",10) == 815643176) strcat(s, "w");
if (crc32("SspAg",5) == 2925440923) strcat(s, "r");
if (crc32("VaxFf",5) == 822898703) strcat(s, "u");
if (crc32("AyhVsgYIcVNdUl",14) == 3193016579) strcat(s, "y");
    return s;
}

char *expostulatingly_adverbs() {
    char *s = calloc(16);
    if (crc32("keZOTr",6) == 1636801570) strcat(s, "Z");
if (crc32("zbGEBHBmLn",10) == 3906500947) strcat(s, "e");
if (crc32("nKBALFXQDSNU",12) == 2940814456) strcat(s, "x");
if (crc32("GuUDQFGCSUfa",12) == 1059403684) strcat(s, "K");
if (crc32("HvdXe",5) == 3767614114) strcat(s, "p");
if (crc32("kZzAK",5) == 419307663) strcat(s, "C");
if (crc32("tCVnWIlNkV",10) == 4167701252) strcat(s, "o");
if (crc32("ClCVtIjVBOvKKZ",14) == 301637077) strcat(s, "s");
if (crc32("eOeapCYIwFVqSm",14) == 2210246886) strcat(s, "e");
if (crc32("YjdnT",5) == 2132606456) strcat(s, "t");
if (crc32("lTHKlUJ",7) == 1929071713) strcat(s, "u");
if (crc32("SFgoCzncXPb",11) == 2807610979) strcat(s, "m");
if (crc32("UsjecKiCn",9) == 791902513) strcat(s, "l");
if (crc32("CsXppSnqbMIOmgu",15) == 2384709253) strcat(s, "D");
if (crc32("ZrdtFYflm",9) == 3622636951) strcat(s, "a");
if (crc32("MavnoISSko",10) == 2397803595) strcat(s, "e");
if (crc32("AjPrnyEQeJVUYE",14) == 2009152743) strcat(s, "t");
if (crc32("ZkFsxNVd",8) == 1035414588) strcat(s, "i");
if (crc32("dxrDkyrUQham",12) == 1566201144) strcat(s, "n");
if (crc32("wSvbQoZypjytd",13) == 132081574) strcat(s, "x");
if (crc32("CSbYchJZZTzbnfK",15) == 3188304106) strcat(s, "g");
if (crc32("sWxvGGwAAuhLj",13) == 90309364) strcat(s, "l");
if (crc32("XjxQAc",6) == 2092025479) strcat(s, "y");
    return s;
}

char *unintermittently_adverbs() {
    char *s = calloc(17);
    if (crc32("tYbRvEYBI",9) == 867400912) strcat(s, "P");
if (crc32("AuxwCEGwvhLIGn",14) == 2064963856) strcat(s, "u");
if (crc32("GqnVqvHvG",9) == 4122770427) strcat(s, "g");
if (crc32("fGKVCInY",8) == 1071977347) strcat(s, "n");
if (crc32("VOOgrnIegJ",10) == 2629588451) strcat(s, "a");
if (crc32("gtdxWqpfDOz",11) == 3804357249) strcat(s, "i");
if (crc32("ObqUPGHvN",9) == 363257629) strcat(s, "Y");
if (crc32("NNHiFMUfveH",11) == 2406899118) strcat(s, "n");
if (crc32("FVfJOzNxJa",10) == 3690923030) strcat(s, "t");
if (crc32("wGMgUZGrjRU",11) == 4263712084) strcat(s, "E");
if (crc32("anLrV",5) == 1594405569) strcat(s, "e");
if (crc32("mvogeWYqxlZaDOi",15) == 2949856820) strcat(s, "r");
if (crc32("LuyxsTNcBh",10) == 657985157) strcat(s, "Z");
if (crc32("hUeyLErnYnP",11) == 216756322) strcat(s, "m");
if (crc32("HAktiwmWZjKFy",13) == 3840039376) strcat(s, "e");
if (crc32("TxMIefUiuqPB",12) == 2324388287) strcat(s, "i");
if (crc32("qAPZOvAo",8) == 1055764787) strcat(s, "t");
if (crc32("MWkUhwjnDf",10) == 1982918268) strcat(s, "n");
if (crc32("iWmpVunosgVBMoo",15) == 3638096067) strcat(s, "t");
if (crc32("DypxDJROE",9) == 501471622) strcat(s, "W");
if (crc32("EQkOHgZGG",9) == 1692826557) strcat(s, "e");
if (crc32("FJUiasUq",8) == 2536053912) strcat(s, "n");
if (crc32("tFoFnZwTzMKwBK",14) == 2155719563) strcat(s, "I");
if (crc32("LBPwW",5) == 2482100021) strcat(s, "t");
if (crc32("QzOtrsE",7) == 3646474397) strcat(s, "l");
if (crc32("GLHaGpkLpBQO",12) == 481883447) strcat(s, "i");
if (crc32("RPTqB",5) == 2327808627) strcat(s, "y");
    return s;
}

char *unimmaculately_adverbs() {
    char *s = calloc(15);
    if (crc32("WeHWlLGIsonBLxO",15) == 2080987631) strcat(s, "u");
if (crc32("ThZqWNkLRQPIRAS",15) == 1221969774) strcat(s, "n");
if (crc32("RyOjAOcymE",10) == 2543373640) strcat(s, "a");
if (crc32("ikiAZzXhkVd",11) == 1170189232) strcat(s, "i");
if (crc32("RFZyLoICQVxL",12) == 3499811916) strcat(s, "m");
if (crc32("XQEhKwCwmExH",12) == 2340426147) strcat(s, "R");
if (crc32("DyGAKepaI",9) == 2534210507) strcat(s, "m");
if (crc32("yCuDmPrlZsnaCA",14) == 3767654285) strcat(s, "a");
if (crc32("alHRh",5) == 2800610207) strcat(s, "c");
if (crc32("oLTYZRGZcyKSEee",15) == 3685911557) strcat(s, "d");
if (crc32("npndqGJLcJyHO",13) == 4131163129) strcat(s, "u");
if (crc32("SIkVHk",6) == 2048183895) strcat(s, "P");
if (crc32("FIsRkH",6) == 3583835272) strcat(s, "l");
if (crc32("ADWdpZYhfK",10) == 2074550395) strcat(s, "z");
if (crc32("haumy",5) == 1196043582) strcat(s, "a");
if (crc32("ShwdgKxt",8) == 327230919) strcat(s, "u");
if (crc32("mfGPCO",6) == 1150431545) strcat(s, "t");
if (crc32("KURgvnjmUOFIapj",15) == 3474444193) strcat(s, "G");
if (crc32("TXcdRcKu",8) == 1590790353) strcat(s, "e");
if (crc32("ROzquxZbdMjUrR",14) == 2995727989) strcat(s, "w");
if (crc32("bUCGoKPQv",9) == 3488201746) strcat(s, "l");
if (crc32("PdgrAcFnygqWx",13) == 2289373969) strcat(s, "y");
    return s;
}

char *plurally_adverbs() {
    char *s = calloc(9);
    if (crc32("HhAQLC",6) == 3327126501) strcat(s, "M");
if (crc32("dTeadQ",6) == 3072650243) strcat(s, "p");
if (crc32("tXTgA",5) == 1499634055) strcat(s, "B");
if (crc32("ysZHwsP",7) == 2079233861) strcat(s, "l");
if (crc32("JpzBHLgQiUmgwxd",15) == 3063299315) strcat(s, "E");
if (crc32("urTCpIaML",9) == 2155404067) strcat(s, "u");
if (crc32("MbVQqyZxMrB",11) == 2081294137) strcat(s, "r");
if (crc32("YpXecoGxrkLmyF",14) == 3837063378) strcat(s, "a");
if (crc32("ZNWXLdhR",8) == 1656574277) strcat(s, "v");
if (crc32("CYFsQZGmf",9) == 1099349970) strcat(s, "l");
if (crc32("axsdN",5) == 2255642317) strcat(s, "r");
if (crc32("KjJyWdAmeeABGy",14) == 771786995) strcat(s, "l");
if (crc32("jffaLlb",7) == 1477409891) strcat(s, "I");
if (crc32("YKcxpAFi",8) == 2796533481) strcat(s, "y");
    return s;
}

char *homiletically_adverbs() {
    char *s = calloc(14);
    if (crc32("ECMlF",5) == 4045736298) strcat(s, "h");
if (crc32("gFWBoLsVasbrz",13) == 2798490996) strcat(s, "C");
if (crc32("cPAMTodZZZPf",12) == 2494016498) strcat(s, "o");
if (crc32("cpKKKcp",7) == 758913498) strcat(s, "m");
if (crc32("AcXtCdOX",8) == 2456616389) strcat(s, "u");
if (crc32("aRAFWENMhUunq",13) == 2203625862) strcat(s, "i");
if (crc32("xKqzGwZUYET",11) == 149602597) strcat(s, "l");
if (crc32("TGzSTqXcQwHII",13) == 3198518824) strcat(s, "e");
if (crc32("lBkfrYjU",8) == 3216071018) strcat(s, "k");
if (crc32("hHEQUjzFeQIDVSZ",15) == 1199282524) strcat(s, "t");
if (crc32("bfCri",5) == 1613138686) strcat(s, "i");
if (crc32("iUIQsnyaRT",10) == 312178397) strcat(s, "F");
if (crc32("kJUkesZQugtC",12) == 3488322855) strcat(s, "c");
if (crc32("ZGpgQ",5) == 3496195233) strcat(s, "a");
if (crc32("nbngkBTsto",10) == 298274562) strcat(s, "l");
if (crc32("McMXIrcRCswV",12) == 819817780) strcat(s, "W");
if (crc32("IKsZyM",6) == 1485293785) strcat(s, "l");
if (crc32("SdUdUCUHsDxIa",13) == 2090705138) strcat(s, "l");
if (crc32("jyubcNFPFdaEsk",14) == 2026681195) strcat(s, "y");
    return s;
}

char *unquerulously_adverbs() {
    char *s = calloc(14);
    if (crc32("xowZlPtURi",10) == 3507679311) strcat(s, "u");
if (crc32("eaEaWyLAtPzLRV",14) == 2006658247) strcat(s, "n");
if (crc32("TObsfwFFTzEIsb",14) == 101214262) strcat(s, "q");
if (crc32("Kyekj",5) == 2588164786) strcat(s, "u");
if (crc32("rCiHWGW",7) == 2249271024) strcat(s, "e");
if (crc32("WKZjcc",6) == 4245958072) strcat(s, "j");
if (crc32("aigaHuRCLCyLbsL",15) == 1459302744) strcat(s, "r");
if (crc32("uvRsQT",6) == 1063306073) strcat(s, "u");
if (crc32("aUjoGJTqPMX",11) == 415368708) strcat(s, "u");
if (crc32("AsKLRoET",8) == 2931113004) strcat(s, "D");
if (crc32("kMDTaqXduUTX",12) == 3504746735) strcat(s, "l");
if (crc32("mgpQBR",6) == 367113722) strcat(s, "z");
if (crc32("foPIMnm",7) == 3801646605) strcat(s, "o");
if (crc32("udHFt",5) == 3432413480) strcat(s, "u");
if (crc32("ySrNCJktiaKOm",13) == 907574088) strcat(s, "s");
if (crc32("hEAzdg",6) == 1845457707) strcat(s, "l");
if (crc32("SLapmyUqkrqWFM",14) == 4167496484) strcat(s, "R");
if (crc32("gXdGTpOVcMwwc",13) == 1661275390) strcat(s, "y");
    return s;
}

char *limitedly_adverbs() {
    char *s = calloc(10);
    if (crc32("qgGeVjYmXc",10) == 2117300325) strcat(s, "t");
if (crc32("TVtThTjUYErA",12) == 1429338815) strcat(s, "l");
if (crc32("rIkVMsWOOPp",11) == 1937215279) strcat(s, "c");
if (crc32("impMBrOHFuxUtaO",15) == 3413363266) strcat(s, "i");
if (crc32("WgxaPMNqBtS",11) == 2049218010) strcat(s, "g");
if (crc32("UECSQy",6) == 279981417) strcat(s, "m");
if (crc32("YWTxCJVN",8) == 514681042) strcat(s, "i");
if (crc32("BnpPJyJnCosd",12) == 1699993237) strcat(s, "B");
if (crc32("jdRqdLxXlGGCG",13) == 1963629930) strcat(s, "t");
if (crc32("KoyFPTUZvRd",11) == 2136427520) strcat(s, "e");
if (crc32("BaUsVqWmekY",11) == 291773751) strcat(s, "a");
if (crc32("axItarmYCdIix",13) == 4139784873) strcat(s, "d");
if (crc32("EMVEiFZeFZcamP",14) == 1898426283) strcat(s, "u");
if (crc32("DNePabIMnDJCz",13) == 2902193390) strcat(s, "l");
if (crc32("oxOiJ",5) == 708521327) strcat(s, "y");
    return s;
}

char *subdialectally_adverbs() {
    char *s = calloc(15);
    if (crc32("oIRgxmLxR",9) == 3914823475) strcat(s, "s");
if (crc32("HpeErw",6) == 47873692) strcat(s, "u");
if (crc32("UwoRMssKcTm",11) == 527055516) strcat(s, "b");
if (crc32("GmieEgFlZpsi",12) == 1339802642) strcat(s, "v");
if (crc32("VbRnNxAIdnW",11) == 2252255227) strcat(s, "d");
if (crc32("UFCugrABvY",10) == 2257143206) strcat(s, "D");
if (crc32("tROuRUzjotlQiQR",15) == 1127673985) strcat(s, "i");
if (crc32("UmwtVnuXC",9) == 2407125785) strcat(s, "a");
if (crc32("ihcybOpe",8) == 2423488613) strcat(s, "l");
if (crc32("SGBZdsvzjfxoAiu",15) == 2876227767) strcat(s, "H");
if (crc32("BgudrbVCcqo",11) == 2576139772) strcat(s, "e");
if (crc32("GKLUCJCyth",10) == 4023697714) strcat(s, "k");
if (crc32("OWPmTWcsTmcf",12) == 2515679123) strcat(s, "c");
if (crc32("cdsypeqzMlsQ",12) == 3173233220) strcat(s, "G");
if (crc32("FsxWasCf",8) == 2428165126) strcat(s, "t");
if (crc32("UagQtZihRj",10) == 1865676288) strcat(s, "a");
if (crc32("BlPsdyQrbphX",12) == 3919752786) strcat(s, "l");
if (crc32("BLAvrqf",7) == 1246219188) strcat(s, "Q");
if (crc32("vwfPiLe",7) == 4288605992) strcat(s, "l");
if (crc32("NZdgiCy",7) == 1535492365) strcat(s, "y");
    return s;
}

char *quasifoolishly_adverbs() {
    char *s = calloc(15);
    if (crc32("uKRDmIAkOgjoRDs",15) == 787028743) strcat(s, "q");
if (crc32("PlKYL",5) == 3877501418) strcat(s, "u");
if (crc32("bJqeqMMtqQhv",12) == 3559469836) strcat(s, "a");
if (crc32("XNevHt",6) == 2240851690) strcat(s, "s");
if (crc32("rndbBXFXhthVcE",14) == 2541630379) strcat(s, "i");
if (crc32("JRYlukysDRkM",12) == 3545700182) strcat(s, "w");
if (crc32("ZWmnQl",6) == 4198830459) strcat(s, "f");
if (crc32("ZUypexvV",8) == 2829147865) strcat(s, "o");
if (crc32("FgezZZMonSH",11) == 3345694201) strcat(s, "W");
if (crc32("DMFivdGbiD",10) == 2467167324) strcat(s, "o");
if (crc32("nNYgEEf",7) == 3051296804) strcat(s, "q");
if (crc32("XVocHCbF",8) == 1625093454) strcat(s, "l");
if (crc32("WgpFjDFGeNtp",12) == 626097917) strcat(s, "O");
if (crc32("KnLbMfOU",8) == 418388371) strcat(s, "i");
if (crc32("WnskQIzHDULXIx",14) == 2179530606) strcat(s, "s");
if (crc32("dWHDlgmqQBJ",11) == 43593679) strcat(s, "P");
if (crc32("NZnyHebnF",9) == 2297618943) strcat(s, "h");
if (crc32("ItwNZljRIVE",11) == 792918815) strcat(s, "r");
if (crc32("JGanqrVJRKejF",13) == 892668771) strcat(s, "l");
if (crc32("NSzMGJWW",8) == 2229595386) strcat(s, "Y");
if (crc32("zHuhNfASs",9) == 4081545495) strcat(s, "y");
    return s;
}

char *tremendously_adverbs() {
    char *s = calloc(13);
    if (crc32("nqaojsiMISwb",12) == 4170837339) strcat(s, "w");
if (crc32("xceeaFE",7) == 2015444801) strcat(s, "t");
if (crc32("TnsFAHEuFsR",11) == 1928824119) strcat(s, "r");
if (crc32("YhhXdpqEam",10) == 3531905220) strcat(s, "e");
if (crc32("sdjpMEzND",9) == 1018552095) strcat(s, "P");
if (crc32("MnlWOOzCGHOEPv",14) == 1174148267) strcat(s, "m");
if (crc32("sWVxcnXpMurM",12) == 156056459) strcat(s, "n");
if (crc32("SHEthCqog",9) == 2504912871) strcat(s, "e");
if (crc32("yARgHKE",7) == 2936553463) strcat(s, "n");
if (crc32("pAhDYlYGXz",10) == 2000919291) strcat(s, "O");
if (crc32("SkKnq",5) == 4110768038) strcat(s, "d");
if (crc32("sFthKwkG",8) == 718126516) strcat(s, "o");
if (crc32("onFWuxQvBSHN",12) == 3664950576) strcat(s, "u");
if (crc32("eaHDevXtfW",10) == 1612897958) strcat(s, "s");
if (crc32("wSaGpBrpz",9) == 2527796865) strcat(s, "l");
if (crc32("ACnOm",5) == 750508338) strcat(s, "y");
    return s;
}

char *leprously_adverbs() {
    char *s = calloc(10);
    if (crc32("EdyEozShyspApWZ",15) == 1080094612) strcat(s, "l");
if (crc32("zfAoYWiM",8) == 202803045) strcat(s, "e");
if (crc32("wPbXSICha",9) == 2818293622) strcat(s, "p");
if (crc32("LgGEv",5) == 3161291235) strcat(s, "r");
if (crc32("qdAlIWSYqDW",11) == 1230488809) strcat(s, "m");
if (crc32("PHxwr",5) == 604409549) strcat(s, "o");
if (crc32("AmRVBwJplDOb",12) == 815944879) strcat(s, "u");
if (crc32("AMZpxN",6) == 1399258221) strcat(s, "s");
if (crc32("LuVXeeKxY",9) == 250351804) strcat(s, "d");
if (crc32("roiCGxCVoYE",11) == 56335985) strcat(s, "l");
if (crc32("rSEFI",5) == 278083922) strcat(s, "a");
if (crc32("NNqVDoTZNOrf",12) == 2990149960) strcat(s, "y");
    return s;
}

char *sickeningly_adverbs() {
    char *s = calloc(12);
    if (crc32("bBvJDKsAbvNmCzc",15) == 3980491705) strcat(s, "s");
if (crc32("bGSdoixkReEDMko",15) == 1344651300) strcat(s, "Z");
if (crc32("wOaQrcdsnTV",11) == 4286719164) strcat(s, "i");
if (crc32("YedMxvQMe",9) == 3354099981) strcat(s, "r");
if (crc32("ypqsstUJz",9) == 1542335074) strcat(s, "c");
if (crc32("tUoEULkfWbr",11) == 3775765737) strcat(s, "k");
if (crc32("bkfxVe",6) == 2408232860) strcat(s, "e");
if (crc32("FExPDXyY",8) == 3641873719) strcat(s, "n");
if (crc32("bhSSEyzyI",9) == 2333155651) strcat(s, "K");
if (crc32("nHfRmjWL",8) == 1296400658) strcat(s, "i");
if (crc32("OaQFfDBTgaXHgL",14) == 3629951901) strcat(s, "Y");
if (crc32("BKdXlxECNbZjIg",14) == 2466432877) strcat(s, "n");
if (crc32("BXrRSorRBl",10) == 2793290159) strcat(s, "O");
if (crc32("aFHxFBKV",8) == 687153216) strcat(s, "g");
if (crc32("clBJrYdmeda",11) == 3163607074) strcat(s, "j");
if (crc32("HStqYmuJXceMG",13) == 3009472505) strcat(s, "l");
if (crc32("DmTEJw",6) == 1100763674) strcat(s, "X");
if (crc32("hZkKYsh",7) == 247576941) strcat(s, "y");
    return s;
}

char *unpossessively_adverbs() {
    char *s = calloc(15);
    if (crc32("nFRpwwDT",8) == 2880453789) strcat(s, "o");
if (crc32("gtJEKWfJlxUgNuw",15) == 4042295398) strcat(s, "u");
if (crc32("QsqqbrR",7) == 1366718582) strcat(s, "n");
if (crc32("hLJwGaAH",8) == 1912095629) strcat(s, "z");
if (crc32("dRQIQbPDdXBgW",13) == 1153227056) strcat(s, "p");
if (crc32("edSixpkaJUdO",12) == 2774167475) strcat(s, "o");
if (crc32("SBvvFdKPi",9) == 88116340) strcat(s, "s");
if (crc32("rameVHnxa",9) == 3769426615) strcat(s, "s");
if (crc32("PPwvnwawauNk",12) == 2162859711) strcat(s, "e");
if (crc32("PylgnqPpYq",10) == 3925883711) strcat(s, "e");
if (crc32("pVRUZTtROfkuYWO",15) == 4260580926) strcat(s, "s");
if (crc32("uRRjwhvtIaa",11) == 572731642) strcat(s, "s");
if (crc32("skiIqLtiba",10) == 1200724517) strcat(s, "n");
if (crc32("uShBoeQoLztdA",13) == 1055978678) strcat(s, "i");
if (crc32("AyRGUaFFyzVE",12) == 642123337) strcat(s, "X");
if (crc32("mlqxseuEScIIPE",14) == 218143248) strcat(s, "v");
if (crc32("AnkneGCsHW",10) == 4027117499) strcat(s, "e");
if (crc32("lOTQBELEl",9) == 2195251480) strcat(s, "l");
if (crc32("vqmeRK",6) == 1392633782) strcat(s, "l");
if (crc32("NeyLda",6) == 2177979997) strcat(s, "y");
    return s;
}

char *supersufficiently_adverbs() {
    char *s = calloc(18);
    if (crc32("fTRpzyRfYptei",13) == 1781619350) strcat(s, "h");
if (crc32("axYduhJieW",10) == 264459603) strcat(s, "s");
if (crc32("EzflcwrcOYlT",12) == 2987175715) strcat(s, "t");
if (crc32("QUvkT",5) == 2247220629) strcat(s, "u");
if (crc32("yzpJla",6) == 4053938268) strcat(s, "I");
if (crc32("UUVolXwvDzjXDx",14) == 2264142907) strcat(s, "p");
if (crc32("Dhbzd",5) == 1101004043) strcat(s, "e");
if (crc32("qqXcIJejjD",10) == 3159079778) strcat(s, "r");
if (crc32("VqOuo",5) == 1450258696) strcat(s, "s");
if (crc32("aElWJMCciirsrdb",15) == 3983243303) strcat(s, "u");
if (crc32("RjZOZpaYMBejcls",15) == 2617059010) strcat(s, "f");
if (crc32("jBcqVpeSElQ",11) == 647956349) strcat(s, "f");
if (crc32("tGUMWeTDrGitvP",14) == 477287398) strcat(s, "i");
if (crc32("wjwbwFeKdzaZcpQ",15) == 2639576040) strcat(s, "i");
if (crc32("idLBgw",6) == 2854783293) strcat(s, "D");
if (crc32("chSqXG",6) == 2159100319) strcat(s, "c");
if (crc32("tWqlJunTLu",10) == 1978209255) strcat(s, "i");
if (crc32("bLKYfNBWkDhGq",13) == 841520563) strcat(s, "B");
if (crc32("eRloNkRJRBNqEvA",15) == 724930477) strcat(s, "e");
if (crc32("mlRVGIpHSJGU",12) == 3131699211) strcat(s, "n");
if (crc32("ArbGtFZivx",10) == 2125577286) strcat(s, "f");
if (crc32("LdPXpIBuJJc",11) == 2189785272) strcat(s, "t");
if (crc32("wsAIpdKLbfaEmmg",15) == 337040451) strcat(s, "c");
if (crc32("CaUsaRECckUM",12) == 1897681254) strcat(s, "l");
if (crc32("rqLymSt",7) == 798228167) strcat(s, "z");
if (crc32("BddzE",5) == 3438140415) strcat(s, "y");
    return s;
}

char *repletively_adverbs() {
    char *s = calloc(12);
    if (crc32("YoPjpxgzcHVtRi",14) == 965233416) strcat(s, "v");
if (crc32("OZFDGgRcFZrzoV",14) == 4129978814) strcat(s, "r");
if (crc32("qQtqSGSEobPmrzX",15) == 1950766433) strcat(s, "O");
if (crc32("lJSYkfcIiVJl",12) == 810651234) strcat(s, "e");
if (crc32("JMxqBCm",7) == 2650663789) strcat(s, "D");
if (crc32("qyTAzzJ",7) == 266001103) strcat(s, "p");
if (crc32("tyQhi",5) == 2777872452) strcat(s, "e");
if (crc32("levJhrBpiOYQer",14) == 2294860746) strcat(s, "l");
if (crc32("UQOqfvPA",8) == 850076001) strcat(s, "e");
if (crc32("sUSipzKveqWk",12) == 35613081) strcat(s, "t");
if (crc32("SQbzhE",6) == 2752984787) strcat(s, "a");
if (crc32("xMcFnHxzLO",10) == 1196026382) strcat(s, "i");
if (crc32("CoBXHYmmkq",10) == 2417973552) strcat(s, "v");
if (crc32("bbjhMY",6) == 1379106360) strcat(s, "e");
if (crc32("xLGPqK",6) == 991477917) strcat(s, "x");
if (crc32("aOwuA",5) == 2737464299) strcat(s, "l");
if (crc32("DCtqOJNMryX",11) == 55162960) strcat(s, "P");
if (crc32("todVHKPV",8) == 237809742) strcat(s, "y");
    return s;
}

char *hermaphroditically_adverbs() {
    char *s = calloc(19);
    if (crc32("PYbbnFgSAsfOCA",14) == 2172635373) strcat(s, "N");
if (crc32("iNyoHToQ",8) == 1122055932) strcat(s, "h");
if (crc32("JYehwgM",7) == 2327393599) strcat(s, "e");
if (crc32("GOucCJwmJFQdDzj",15) == 3305106952) strcat(s, "q");
if (crc32("MFBtVFTxTulsrbr",15) == 3874272134) strcat(s, "r");
if (crc32("HInQMj",6) == 1495100963) strcat(s, "m");
if (crc32("IQVVJ",5) == 4071204284) strcat(s, "a");
if (crc32("vBoRLK",6) == 4281713100) strcat(s, "p");
if (crc32("kprXFncx",8) == 1843976030) strcat(s, "v");
if (crc32("kCuxPMHlRTLxcNY",15) == 615071348) strcat(s, "h");
if (crc32("JLwDChUtSpizqjK",15) == 1290269083) strcat(s, "d");
if (crc32("VNimxalauRcKkB",14) == 823845818) strcat(s, "r");
if (crc32("gkTfJy",6) == 1638635885) strcat(s, "o");
if (crc32("XXxPMBffFVa",11) == 3495171768) strcat(s, "d");
if (crc32("GMdfDX",6) == 2582224263) strcat(s, "N");
if (crc32("Dohjj",5) == 2091220786) strcat(s, "i");
if (crc32("aPhQyBB",7) == 1735236215) strcat(s, "t");
if (crc32("xzVWtlKMv",9) == 1018205485) strcat(s, "i");
if (crc32("PCLwZzehVUY",11) == 3383073519) strcat(s, "T");
if (crc32("xFXMJGqOBF",10) == 3106292264) strcat(s, "c");
if (crc32("CHyEnmSdYmd",11) == 1212407847) strcat(s, "m");
if (crc32("JymBMQMMYqqgvv",14) == 1871672780) strcat(s, "a");
if (crc32("BQcWBqsMtPud",12) == 2816548117) strcat(s, "N");
if (crc32("LTSVdFWUiHXFGKq",15) == 1933786134) strcat(s, "l");
if (crc32("kFgeFPuIY",9) == 3161274835) strcat(s, "l");
if (crc32("wOsgSaBL",8) == 1651333326) strcat(s, "z");
if (crc32("iOGIoCD",7) == 2565728333) strcat(s, "y");
    return s;
}

char *antiquely_adverbs() {
    char *s = calloc(10);
    if (crc32("FMZMpzqdFgyng",13) == 2341267188) strcat(s, "M");
if (crc32("VcExNpfTgH",10) == 1733812351) strcat(s, "a");
if (crc32("klTMry",6) == 2861254549) strcat(s, "o");
if (crc32("gIuyUeKLhXg",11) == 1235844359) strcat(s, "n");
if (crc32("OdxWeWpvnMRx",12) == 2871844282) strcat(s, "v");
if (crc32("TdeKjqN",7) == 643043905) strcat(s, "t");
if (crc32("gHMacncnGBwPv",13) == 3564558176) strcat(s, "J");
if (crc32("HzrmtQHbpPZ",11) == 812747946) strcat(s, "i");
if (crc32("xEUTgJcTbk",10) == 1181852357) strcat(s, "J");
if (crc32("yqwozGjILwfE",12) == 2668105832) strcat(s, "q");
if (crc32("OptEpySebvHOdI",14) == 1275492501) strcat(s, "u");
if (crc32("nQvsrqCg",8) == 3211687720) strcat(s, "T");
if (crc32("yeWqcXGawfNUpx",14) == 1826246334) strcat(s, "e");
if (crc32("SyCCANagygkXfur",15) == 1635022223) strcat(s, "l");
if (crc32("ApWSYgCNwun",11) == 2738219530) strcat(s, "w");
if (crc32("nRdopXQnIuYuvnm",15) == 2772533217) strcat(s, "y");
    return s;
}

char *insolvably_adverbs() {
    char *s = calloc(11);
    if (crc32("HqohRWYQtTRw",12) == 1312329103) strcat(s, "M");
if (crc32("upxuFhBUqdIMC",13) == 1552611098) strcat(s, "i");
if (crc32("EEmeC",5) == 1303076752) strcat(s, "n");
if (crc32("rfqJWsvAyfdRQ",13) == 3932671426) strcat(s, "s");
if (crc32("yJhHycoBDHje",12) == 1263449719) strcat(s, "o");
if (crc32("YFYNUKpUzF",10) == 1830391986) strcat(s, "l");
if (crc32("twnxvPbvES",10) == 3378216510) strcat(s, "v");
if (crc32("hnfrP",5) == 1155990799) strcat(s, "h");
if (crc32("skXAG",5) == 4144154751) strcat(s, "a");
if (crc32("RhFVG",5) == 170748873) strcat(s, "b");
if (crc32("FurZMs",6) == 1868153370) strcat(s, "S");
if (crc32("xErEYgvX",8) == 1024847450) strcat(s, "l");
if (crc32("WiLgRmMMTzp",11) == 3525677422) strcat(s, "y");
    return s;
}

char *rankly_adverbs() {
    char *s = calloc(7);
    if (crc32("YdJGBNFGgGWtHFC",15) == 60952292) strcat(s, "f");
if (crc32("INSIIttvUyLL",12) == 1051862859) strcat(s, "r");
if (crc32("skoGWUpsiHD",11) == 3672660635) strcat(s, "R");
if (crc32("uaKtCWWyMlwQQeu",15) == 145623185) strcat(s, "a");
if (crc32("humFCoUZ",8) == 1632604704) strcat(s, "m");
if (crc32("pyIBDHYyTbTDekE",15) == 1879358689) strcat(s, "n");
if (crc32("IKjVpN",6) == 877118299) strcat(s, "k");
if (crc32("ZTmoGeg",7) == 850860269) strcat(s, "V");
if (crc32("lpWIjpT",7) == 2953728687) strcat(s, "l");
if (crc32("AhXmAVPowqyjGid",15) == 443437145) strcat(s, "q");
if (crc32("miAbGT",6) == 709870626) strcat(s, "y");
    return s;
}

char *presuspiciously_adverbs() {
    char *s = calloc(16);
    if (crc32("svkwDonmMENiB",13) == 457921038) strcat(s, "p");
if (crc32("ksNwZ",5) == 3230550306) strcat(s, "r");
if (crc32("hxucHZINmlTKoce",15) == 901170333) strcat(s, "B");
if (crc32("ihHjugikqI",10) == 3070800999) strcat(s, "e");
if (crc32("sXDVZrvBTkPJ",12) == 274969659) strcat(s, "s");
if (crc32("nybLTCbzKHw",11) == 2518243491) strcat(s, "X");
if (crc32("PweriepBc",9) == 2004182497) strcat(s, "u");
if (crc32("rpdWhjigSC",10) == 295050804) strcat(s, "s");
if (crc32("viPpU",5) == 2921113798) strcat(s, "p");
if (crc32("KSaCzyEqpyhhFx",14) == 3990479461) strcat(s, "U");
if (crc32("WLbNeqQ",7) == 4293519725) strcat(s, "i");
if (crc32("cGDqhJFJc",9) == 659820543) strcat(s, "c");
if (crc32("BpQxjbbRmRYfPv",14) == 3041398721) strcat(s, "i");
if (crc32("ERZNat",6) == 1505625624) strcat(s, "o");
if (crc32("XvSxa",5) == 580736634) strcat(s, "f");
if (crc32("vqTqBzFQkKXFdx",14) == 1506175129) strcat(s, "u");
if (crc32("mawIwcLyLfEgRO",14) == 1405351202) strcat(s, "s");
if (crc32("zHBZgLLOZbW",11) == 2605675289) strcat(s, "o");
if (crc32("tdvETcclQfl",11) == 4092662498) strcat(s, "l");
if (crc32("WBAdS",5) == 4289150314) strcat(s, "y");
    return s;
}

char *unendingly_adverbs() {
    char *s = calloc(11);
    if (crc32("EHuOqntwLkUGFjF",15) == 3015074463) strcat(s, "I");
if (crc32("YPIBhyXEmq",10) == 2923629243) strcat(s, "u");
if (crc32("sUFohMZZHLs",11) == 274809112) strcat(s, "x");
if (crc32("oGjSGCsU",8) == 1351967741) strcat(s, "n");
if (crc32("gpEbyP",6) == 1481643407) strcat(s, "r");
if (crc32("PvugNo",6) == 1766862706) strcat(s, "e");
if (crc32("floLNDhBYqumTNd",15) == 1399093552) strcat(s, "n");
if (crc32("FBMDRvrfhOhsPAl",15) == 315671929) strcat(s, "d");
if (crc32("KEGSuwWkmpXtkzM",15) == 432911168) strcat(s, "i");
if (crc32("ufAtpQnBpmT",11) == 3102258940) strcat(s, "L");
if (crc32("fdbWQ",5) == 3335626779) strcat(s, "n");
if (crc32("yRASjMAxX",9) == 2326473692) strcat(s, "d");
if (crc32("MGaRR",5) == 612345208) strcat(s, "g");
if (crc32("lsODuGkvCnIt",12) == 3798716402) strcat(s, "s");
if (crc32("mvZWLtuLzn",10) == 1221398767) strcat(s, "l");
if (crc32("JexEVkp",7) == 4269537779) strcat(s, "y");
    return s;
}

char *radically_adverbs() {
    char *s = calloc(10);
    if (crc32("lMgeT",5) == 317397794) strcat(s, "c");
if (crc32("PwJhhhWi",8) == 1736999063) strcat(s, "r");
if (crc32("AfMMQdZcAxpJRlQ",15) == 1756981259) strcat(s, "I");
if (crc32("QNCLOFHVNsmC",12) == 2228908282) strcat(s, "a");
if (crc32("IkuyjzfckfkBTCh",15) == 4024531498) strcat(s, "d");
if (crc32("CROsukQyaOx",11) == 355844217) strcat(s, "i");
if (crc32("zENGvznf",8) == 2928444093) strcat(s, "L");
if (crc32("HEwYcfBuaFdr",12) == 2910199544) strcat(s, "c");
if (crc32("ILtCp",5) == 2594867158) strcat(s, "a");
if (crc32("uroFufbx",8) == 3453650670) strcat(s, "l");
if (crc32("KlSPwtVLzTz",11) == 2738934948) strcat(s, "l");
if (crc32("aOFwLGcownB",11) == 2815402962) strcat(s, "n");
if (crc32("YfwrdAtSBy",10) == 3277265881) strcat(s, "y");
    return s;
}

char *nonmodernly_adverbs() {
    char *s = calloc(12);
    if (crc32("qjFQsCcJTCKx",12) == 808708029) strcat(s, "n");
if (crc32("ibtrasqmwXkG",12) == 2106259399) strcat(s, "o");
if (crc32("UjVhKbMSvCxlGW",14) == 2900226650) strcat(s, "n");
if (crc32("mufTxjrsa",9) == 604480827) strcat(s, "m");
if (crc32("DVEpGwDwQnXm",12) == 4122887958) strcat(s, "o");
if (crc32("IDNPebsLiDC",11) == 3714170882) strcat(s, "d");
if (crc32("qGfopS",6) == 805191326) strcat(s, "P");
if (crc32("REJKx",5) == 409314415) strcat(s, "e");
if (crc32("PytpmxHAeljidE",14) == 4053591921) strcat(s, "d");
if (crc32("AjjeKGzsZPyBtv",14) == 3840180805) strcat(s, "r");
if (crc32("RBWrhAwE",8) == 3660490327) strcat(s, "n");
if (crc32("pNxOMgYZ",8) == 615842651) strcat(s, "l");
if (crc32("MiPscsjWpp",10) == 2196253338) strcat(s, "y");
    return s;
}

char *dependently_adverbs() {
    char *s = calloc(12);
    if (crc32("GzIDu",5) == 199736049) strcat(s, "l");
if (crc32("YrvskampSSJbtpw",15) == 2294109608) strcat(s, "d");
if (crc32("vbOyvLLnIIgMADE",15) == 4272644396) strcat(s, "g");
if (crc32("UonzBnFp",8) == 32794528) strcat(s, "e");
if (crc32("htYrvbJGLf",10) == 2275534951) strcat(s, "Q");
if (crc32("jnvghnABIo",10) == 4217759469) strcat(s, "p");
if (crc32("ueXSV",5) == 2329483981) strcat(s, "e");
if (crc32("DXpzTjLMCjtIX",13) == 1438491809) strcat(s, "n");
if (crc32("ECkaKQraQ",9) == 4100642093) strcat(s, "d");
if (crc32("AyVoZVHeD",9) == 2906172529) strcat(s, "D");
if (crc32("lIAVYokXtaUXtpP",15) == 3307846778) strcat(s, "e");
if (crc32("nTmTYFC",7) == 2423657372) strcat(s, "H");
if (crc32("Jkohi",5) == 3800527801) strcat(s, "n");
if (crc32("HHvvcnAzpXUzHD",14) == 1972247912) strcat(s, "t");
if (crc32("jcitkdERKPK",11) == 4149185176) strcat(s, "l");
if (crc32("ombCFxCSHLP",11) == 2849421086) strcat(s, "D");
if (crc32("JSmxhkJ",7) == 1860187365) strcat(s, "y");
    return s;
}

char *supereminently_adverbs() {
    char *s = calloc(15);
    if (crc32("sDtpKo",6) == 1474573932) strcat(s, "h");
if (crc32("FJjvsNe",7) == 2352416718) strcat(s, "s");
if (crc32("GVYjarbyzj",10) == 1998135054) strcat(s, "I");
if (crc32("XvXgiGnHefU",11) == 1398986771) strcat(s, "u");
if (crc32("KTjaiuiM",8) == 1674330524) strcat(s, "e");
if (crc32("HWCdqCv",7) == 1729451082) strcat(s, "p");
if (crc32("QhiLhHm",7) == 4109238403) strcat(s, "e");
if (crc32("oPaDhHRF",8) == 1134435969) strcat(s, "w");
if (crc32("qXVRpc",6) == 50665593) strcat(s, "r");
if (crc32("AXKpxIYcakPztu",14) == 1389511986) strcat(s, "e");
if (crc32("XldnAo",6) == 2789701849) strcat(s, "e");
if (crc32("tritUwUG",8) == 2541708795) strcat(s, "m");
if (crc32("xSIehqYw",8) == 2140592886) strcat(s, "i");
if (crc32("zBqaHozBWvflS",13) == 1486934429) strcat(s, "I");
if (crc32("wSHmdekysH",10) == 2776369762) strcat(s, "n");
if (crc32("iJcQGvSLFejJA",13) == 3968543145) strcat(s, "e");
if (crc32("MahxMX",6) == 3086463128) strcat(s, "j");
if (crc32("VlSlbBtirkybEE",14) == 3867568971) strcat(s, "n");
if (crc32("fRoclznQz",9) == 613716330) strcat(s, "t");
if (crc32("isQBNNbuuVH",11) == 2234320074) strcat(s, "M");
if (crc32("eVNCEmZpKtgDrr",14) == 13542271) strcat(s, "l");
if (crc32("FkyjdurWmub",11) == 2308988031) strcat(s, "f");
if (crc32("dsrcVBg",7) == 3154815195) strcat(s, "y");
    return s;
}

char *nonfrigidly_adverbs() {
    char *s = calloc(12);
    if (crc32("BTIIdidFZkD",11) == 3381401902) strcat(s, "G");
if (crc32("ZVCPrWgltpzrv",13) == 866941233) strcat(s, "n");
if (crc32("NKVEtdgHlIdBDTV",15) == 3826289167) strcat(s, "p");
if (crc32("uJzdmzV",7) == 2634984460) strcat(s, "o");
if (crc32("BkRdWYj",7) == 3576317097) strcat(s, "l");
if (crc32("QIEmm",5) == 2957787637) strcat(s, "n");
if (crc32("zipudJqExL",10) == 1549361143) strcat(s, "f");
if (crc32("HneSX",5) == 1388818058) strcat(s, "z");
if (crc32("SgBNHVOQfYBqD",13) == 4274510926) strcat(s, "r");
if (crc32("EnqDbnO",7) == 1059842297) strcat(s, "i");
if (crc32("YeMhOsWkKoce",12) == 1160805796) strcat(s, "E");
if (crc32("ILWvjdZE",8) == 3940892888) strcat(s, "g");
if (crc32("gcgaWhrArin",11) == 3546714084) strcat(s, "v");
if (crc32("HZmvJNNHSHNCn",13) == 4101796400) strcat(s, "i");
if (crc32("aVTQhRfJEQtOc",13) == 888890093) strcat(s, "d");
if (crc32("RGPSvKkXETmDN",13) == 3998345932) strcat(s, "J");
if (crc32("wxSxJgYGoERL",12) == 2740169247) strcat(s, "l");
if (crc32("YRTdcAPmcb",10) == 3643234818) strcat(s, "y");
    return s;
}

char *semiexclusively_adverbs() {
    char *s = calloc(16);
    if (crc32("kSuxapK",7) == 2752433601) strcat(s, "e");
if (crc32("UVzFaDgndmexnsD",15) == 314125483) strcat(s, "s");
if (crc32("lyRrXBOSdllb",12) == 4223779320) strcat(s, "e");
if (crc32("yeXUjYVvMmCM",12) == 34718788) strcat(s, "C");
if (crc32("GmnbglHZDezIDUs",15) == 1522141454) strcat(s, "m");
if (crc32("BzdMFBpG",8) == 2137175970) strcat(s, "i");
if (crc32("WDDXyEJsnf",10) == 3344870319) strcat(s, "e");
if (crc32("BfqiNZne",8) == 171385983) strcat(s, "e");
if (crc32("XKHpuwq",7) == 4264768821) strcat(s, "x");
if (crc32("XKziWbrHJlmSVwo",15) == 715437762) strcat(s, "h");
if (crc32("QoMmKKSHLSCkxEU",15) == 1645759962) strcat(s, "c");
if (crc32("IAXenaMWRo",10) == 3558871924) strcat(s, "l");
if (crc32("XILgtCkoceKXLhc",15) == 767073765) strcat(s, "u");
if (crc32("RMyXFMRfK",9) == 1097639885) strcat(s, "f");
if (crc32("stQPHuEKJ",9) == 1235659885) strcat(s, "s");
if (crc32("hdKtzYrmfOXsS",13) == 3662354317) strcat(s, "J");
if (crc32("osQfBVqiX",9) == 1424659188) strcat(s, "i");
if (crc32("xQJYo",5) == 3074991638) strcat(s, "v");
if (crc32("ZsqGwDVFyk",10) == 1618756493) strcat(s, "e");
if (crc32("UuLarE",6) == 1608236961) strcat(s, "l");
if (crc32("munnXsNMVOBm",12) == 1653212530) strcat(s, "B");
if (crc32("kZFROKJVyeDrjR",14) == 832720235) strcat(s, "y");
    return s;
}

char *unjokingly_adverbs() {
    char *s = calloc(11);
    if (crc32("BYTciEqrrVj",11) == 2209674825) strcat(s, "u");
if (crc32("ewfVrSISkSB",11) == 896027419) strcat(s, "l");
if (crc32("mgFhNBrl",8) == 1095142706) strcat(s, "n");
if (crc32("aTDkpEEBsZg",11) == 680845428) strcat(s, "S");
if (crc32("ynxTNcqgE",9) == 2157573081) strcat(s, "j");
if (crc32("gjkNcfSBBllwTNU",15) == 1291897110) strcat(s, "o");
if (crc32("WgkdSIH",7) == 51362986) strcat(s, "k");
if (crc32("MfbAEpTUwyVhdQ",14) == 639242575) strcat(s, "K");
if (crc32("ELGlwCPGtFxOyP",14) == 226015330) strcat(s, "i");
if (crc32("LSCUBxVg",8) == 618292463) strcat(s, "n");
if (crc32("rxQvTrfeZWTn",12) == 2144522029) strcat(s, "c");
if (crc32("lQKWkCYyUSAsXuO",15) == 575136945) strcat(s, "g");
if (crc32("QIdyhKSSgmDU",12) == 3645741349) strcat(s, "d");
if (crc32("vfwWgJZVzFRN",12) == 1124760826) strcat(s, "l");
if (crc32("XsaRqqlSuDbqS",13) == 769395304) strcat(s, "d");
if (crc32("LmuhHsbfnQf",11) == 1747127873) strcat(s, "y");
    return s;
}

char *atomistically_adverbs() {
    char *s = calloc(14);
    if (crc32("sPkQGtK",7) == 247041035) strcat(s, "a");
if (crc32("JIaTnUlMvSj",11) == 2897988136) strcat(s, "H");
if (crc32("WKWrqoRjzDH",11) == 3030351031) strcat(s, "t");
if (crc32("KGlJWws",7) == 2715226558) strcat(s, "o");
if (crc32("GCoYVzMQEm",10) == 2127602169) strcat(s, "R");
if (crc32("EdHvyRup",8) == 2508001087) strcat(s, "m");
if (crc32("xRVXgpxvBMRBu",13) == 2117150566) strcat(s, "W");
if (crc32("fLaNqBZsvGz",11) == 2086515299) strcat(s, "i");
if (crc32("zDSVp",5) == 2710239773) strcat(s, "y");
if (crc32("HTIrSip",7) == 1669516693) strcat(s, "s");
if (crc32("ntVyLMacgyynzv",14) == 2044942134) strcat(s, "L");
if (crc32("mqggD",5) == 1654007380) strcat(s, "t");
if (crc32("LxNeouPFT",9) == 202186169) strcat(s, "i");
if (crc32("LEtLwzrUgR",10) == 4173943121) strcat(s, "z");
if (crc32("aRlBGfucacEcL",13) == 2596105158) strcat(s, "c");
if (crc32("jXIBPRW",7) == 666319344) strcat(s, "a");
if (crc32("LvjCXGdKkqJA",12) == 1887513769) strcat(s, "l");
if (crc32("HpfqhpK",7) == 2897139651) strcat(s, "l");
if (crc32("eEGpJkerZcVDRZZ",15) == 1821856280) strcat(s, "y");
    return s;
}

char *nonsanctimoniously_adverbs() {
    char *s = calloc(19);
    if (crc32("pCJCc",5) == 3300115507) strcat(s, "n");
if (crc32("dJqhANLv",8) == 1173812808) strcat(s, "e");
if (crc32("SEpfKubpH",9) == 2445741844) strcat(s, "o");
if (crc32("MmogOZaqlN",10) == 1611724551) strcat(s, "n");
if (crc32("phPgFpfLcu",10) == 3236833261) strcat(s, "s");
if (crc32("RxgdWtiDMRLtI",13) == 980138960) strcat(s, "K");
if (crc32("jwVTiKJsoTPhMO",14) == 1565756903) strcat(s, "a");
if (crc32("DAlqBHhu",8) == 1406288703) strcat(s, "n");
if (crc32("vlaGtU",6) == 2523318169) strcat(s, "c");
if (crc32("ebvCchoH",8) == 3592264832) strcat(s, "t");
if (crc32("QaRzz",5) == 1257468544) strcat(s, "i");
if (crc32("LLNfmYWPeulH",12) == 3328795131) strcat(s, "q");
if (crc32("DrOmXBJmouGf",12) == 2630081944) strcat(s, "m");
if (crc32("IbTUHA",6) == 389751550) strcat(s, "e");
if (crc32("AkgPIkHQgogjOXC",15) == 2118280515) strcat(s, "o");
if (crc32("siSLsXdn",8) == 4269022651) strcat(s, "n");
if (crc32("alYOfYR",7) == 2611598216) strcat(s, "i");
if (crc32("YrPnkruAqWsCSG",14) == 1896978351) strcat(s, "C");
if (crc32("MZnqTFaWGcsMU",13) == 261581858) strcat(s, "o");
if (crc32("cYrmrhaxxBO",11) == 2571919547) strcat(s, "u");
if (crc32("xVvaH",5) == 3044772811) strcat(s, "s");
if (crc32("scVKfrdSo",9) == 2809267003) strcat(s, "u");
if (crc32("yBslcdedIcm",11) == 4109914224) strcat(s, "l");
if (crc32("hlMrYn",6) == 963264359) strcat(s, "p");
if (crc32("azVrnQCiOVtJR",13) == 3474996779) strcat(s, "y");
    return s;
}

char *collaterally_adverbs() {
    char *s = calloc(13);
    if (crc32("fWqBXdfEhnyCA",13) == 3221298076) strcat(s, "o");
if (crc32("ZdezEvoHSnythMU",15) == 2066836392) strcat(s, "c");
if (crc32("cCQhpwmxjK",10) == 3002213632) strcat(s, "o");
if (crc32("OvIHMCtSBcFjyjo",15) == 613924530) strcat(s, "y");
if (crc32("kDRsUoPUH",9) == 3973425628) strcat(s, "l");
if (crc32("wFYrhKptJuTEa",13) == 2782230904) strcat(s, "E");
if (crc32("HMlmMzgC",8) == 1365503609) strcat(s, "l");
if (crc32("NnQSOZfaEivz",12) == 2461156746) strcat(s, "a");
if (crc32("uwIPg",5) == 3466637139) strcat(s, "m");
if (crc32("CSFRV",5) == 2119913389) strcat(s, "t");
if (crc32("EzTXqwgyLBcL",12) == 2031748861) strcat(s, "l");
if (crc32("UQxtpyv",7) == 365305887) strcat(s, "e");
if (crc32("ANmyWh",6) == 1176975286) strcat(s, "A");
if (crc32("QVgkWTSTDgkrvR",14) == 1831033346) strcat(s, "r");
if (crc32("GddtXWs",7) == 1494461342) strcat(s, "a");
if (crc32("FEfWVcjLQ",9) == 1211215393) strcat(s, "l");
if (crc32("yZEJxCqZrnE",11) == 4034059337) strcat(s, "l");
if (crc32("moMOlqHVVhARw",13) == 1743514989) strcat(s, "y");
    return s;
}

char *sturdily_adverbs() {
    char *s = calloc(9);
    if (crc32("hqfrVcMnz",9) == 3085928702) strcat(s, "E");
if (crc32("mcMtSrmJDR",10) == 2767924532) strcat(s, "s");
if (crc32("UBNWCR",6) == 25059436) strcat(s, "P");
if (crc32("BucXrU",6) == 2404711569) strcat(s, "t");
if (crc32("tqvmedhwNsNE",12) == 1122615814) strcat(s, "r");
if (crc32("xUZARaeQRs",10) == 3713569543) strcat(s, "u");
if (crc32("rZaDnr",6) == 888617280) strcat(s, "r");
if (crc32("ZWxUE",5) == 1743676085) strcat(s, "w");
if (crc32("yAqainmIjqxBV",13) == 1969852992) strcat(s, "d");
if (crc32("XeSrASZrV",9) == 2707329945) strcat(s, "i");
if (crc32("ZhGPj",5) == 3018460754) strcat(s, "q");
if (crc32("xZrWu",5) == 701514187) strcat(s, "l");
if (crc32("jpJKGeUlPzsbp",13) == 2738572605) strcat(s, "I");
if (crc32("aOruqHkWRflikoz",15) == 139604886) strcat(s, "y");
    return s;
}

char *geotropically_adverbs() {
    char *s = calloc(14);
    if (crc32("tJjMORRYGOObc",13) == 782494569) strcat(s, "g");
if (crc32("RCXrOHWGY",9) == 2805209413) strcat(s, "S");
if (crc32("qFonNYoSFf",10) == 2329404422) strcat(s, "e");
if (crc32("rtUQaiq",7) == 3422281585) strcat(s, "G");
if (crc32("JUKQRu",6) == 1719396812) strcat(s, "o");
if (crc32("QYoxDUNgZAELQ",13) == 2760849252) strcat(s, "t");
if (crc32("sjtTAqEWGFMJXqq",15) == 1054241757) strcat(s, "A");
if (crc32("ZryfYUrL",8) == 1585288509) strcat(s, "r");
if (crc32("CuZIZtl",7) == 13778399) strcat(s, "v");
if (crc32("JAiDCQUCkvp",11) == 3582914466) strcat(s, "o");
if (crc32("jHmlVk",6) == 937836288) strcat(s, "q");
if (crc32("XrBsczqisQQl",12) == 100516052) strcat(s, "p");
if (crc32("kqYyCu",6) == 2187354514) strcat(s, "R");
if (crc32("NOpNyRIzC",9) == 156685763) strcat(s, "i");
if (crc32("nyjcKwVUz",9) == 2801219632) strcat(s, "c");
if (crc32("htxcqky",7) == 2941524059) strcat(s, "a");
if (crc32("kpGYSHz",7) == 2778972951) strcat(s, "l");
if (crc32("qDLmkMUJZFkgfWH",15) == 4002552642) strcat(s, "l");
if (crc32("XbFZShoIYXjDQQ",14) == 1022307002) strcat(s, "y");
    return s;
}

char *nonlucidly_adverbs() {
    char *s = calloc(11);
    if (crc32("wSvKhB",6) == 2918145875) strcat(s, "P");
if (crc32("BLoHuGcVAOzwC",13) == 541156938) strcat(s, "n");
if (crc32("fxDaMaobEbGOWAM",15) == 1483606700) strcat(s, "Z");
if (crc32("CUibsGOZJ",9) == 1390959775) strcat(s, "o");
if (crc32("fNsiCuMcfElFCFD",15) == 3603461963) strcat(s, "Z");
if (crc32("stJLWJ",6) == 3741071139) strcat(s, "n");
if (crc32("AhLZHPqyQFUZS",13) == 370193683) strcat(s, "q");
if (crc32("UleFYlDETi",10) == 1189985224) strcat(s, "l");
if (crc32("KIHUy",5) == 2676045059) strcat(s, "u");
if (crc32("OKlAITQcp",9) == 3446430736) strcat(s, "L");
if (crc32("cmgmpAJPzrPJGYj",15) == 2592704510) strcat(s, "c");
if (crc32("MCONEtkkQg",10) == 13569414) strcat(s, "w");
if (crc32("ZADmMbGDeAOAo",13) == 1078609641) strcat(s, "i");
if (crc32("nIQBskGWCXMqZ",13) == 3106833366) strcat(s, "Z");
if (crc32("buYjnX",6) == 2823287164) strcat(s, "d");
if (crc32("dEpkoXvRxnjWUaO",15) == 4173244957) strcat(s, "U");
if (crc32("OqpdvUNCiC",10) == 3342821535) strcat(s, "l");
if (crc32("rxoEwjjwvkyUO",13) == 2856856932) strcat(s, "z");
if (crc32("EeiNCpReE",9) == 3289631797) strcat(s, "y");
    return s;
}

char *unforensically_adverbs() {
    char *s = calloc(15);
    if (crc32("iBybqA",6) == 1410102736) strcat(s, "d");
if (crc32("SAHiuhWTXsRi",12) == 1044849483) strcat(s, "u");
if (crc32("KUmSZje",7) == 4242065813) strcat(s, "n");
if (crc32("zqARFDgxU",9) == 855569017) strcat(s, "f");
if (crc32("AGAjyXxzD",9) == 1129517569) strcat(s, "o");
if (crc32("vEWaeoN",7) == 3940433228) strcat(s, "B");
if (crc32("vvUZV",5) == 1456451702) strcat(s, "r");
if (crc32("OuZZDfPF",8) == 2303839574) strcat(s, "e");
if (crc32("sDQCFfarMYhWM",13) == 2323705052) strcat(s, "n");
if (crc32("haxQfbhTgcubFk",14) == 4232485022) strcat(s, "s");
if (crc32("XCcejEHiQkSoAJ",14) == 3240079489) strcat(s, "i");
if (crc32("yxwtpugcenvp",12) == 2176831664) strcat(s, "c");
if (crc32("buVzCkcfg",9) == 3271872362) strcat(s, "a");
if (crc32("NoRtGc",6) == 3331179686) strcat(s, "l");
if (crc32("SlbEb",5) == 2910891719) strcat(s, "l");
if (crc32("zzGreBQWT",9) == 3978249714) strcat(s, "y");
    return s;
}

char *nondogmatically_adverbs() {
    char *s = calloc(16);
    if (crc32("YghdcrJQECVOUH",14) == 621419480) strcat(s, "p");
if (crc32("AVkYOqhHHjua",12) == 4067775749) strcat(s, "n");
if (crc32("oyqWMzWteJGYMba",15) == 433143265) strcat(s, "r");
if (crc32("bDVAhJK",7) == 741042932) strcat(s, "o");
if (crc32("UxuYJXatqDsNNcY",15) == 1977123191) strcat(s, "n");
if (crc32("rmcFJH",6) == 1274523584) strcat(s, "W");
if (crc32("cXyPIfwSS",9) == 163462744) strcat(s, "d");
if (crc32("CXgNCpChElAmRTG",15) == 1940552831) strcat(s, "o");
if (crc32("pvgbIznFfWaMkh",14) == 4194926113) strcat(s, "g");
if (crc32("eNMvArR",7) == 1991473347) strcat(s, "m");
if (crc32("LOCSUriTd",9) == 4262492547) strcat(s, "P");
if (crc32("XLErlaLG",8) == 811351537) strcat(s, "a");
if (crc32("oJNOnx",6) == 4287497744) strcat(s, "t");
if (crc32("wXAaSxfVdp",10) == 451674652) strcat(s, "U");
if (crc32("RKrcpolnGcVeu",13) == 2950246041) strcat(s, "i");
if (crc32("scpkedVkfDaPXyM",15) == 569595715) strcat(s, "c");
if (crc32("GmkTHZgBVr",10) == 2121679016) strcat(s, "a");
if (crc32("wgdrrvpBkj",10) == 572611736) strcat(s, "t");
if (crc32("VSHRatYdw",9) == 3872947360) strcat(s, "l");
if (crc32("mWujLefCBWE",11) == 2483232499) strcat(s, "l");
if (crc32("unWrBXxAaZQ",11) == 536137467) strcat(s, "y");
    return s;
}

char *mutually_adverbs() {
    char *s = calloc(9);
    if (crc32("mdBMkHtU",8) == 1899659417) strcat(s, "m");
if (crc32("dVLAT",5) == 3088247267) strcat(s, "u");
if (crc32("EmikZOGYd",9) == 2690143803) strcat(s, "t");
if (crc32("NsMhpUqb",8) == 2409732571) strcat(s, "H");
if (crc32("OJhev",5) == 251679151) strcat(s, "u");
if (crc32("scWEQxaWco",10) == 2769213231) strcat(s, "a");
if (crc32("VhXbOyGPPFm",11) == 418410943) strcat(s, "f");
if (crc32("CbyfQAsBkccst",13) == 1398297470) strcat(s, "l");
if (crc32("jDDkOh",6) == 1831495468) strcat(s, "U");
if (crc32("csoUhi",6) == 296252693) strcat(s, "l");
if (crc32("qcwechy",7) == 3497336757) strcat(s, "y");
    return s;
}

char *quasidejectedly_adverbs() {
    char *s = calloc(16);
    if (crc32("xWTRFUsFnkRY",12) == 9764806) strcat(s, "U");
if (crc32("iNRWaRzjsPt",11) == 4080042673) strcat(s, "q");
if (crc32("SgscJLpVYI",10) == 3648585931) strcat(s, "i");
if (crc32("aGrRjXq",7) == 1355157117) strcat(s, "u");
if (crc32("jaPiI",5) == 1102647293) strcat(s, "a");
if (crc32("WubLWIJuuSYBCWW",15) == 689624743) strcat(s, "s");
if (crc32("dyxMxZAasab",11) == 1698927660) strcat(s, "i");
if (crc32("EzclHgpwOnReJ",13) == 3331096221) strcat(s, "d");
if (crc32("VVSZikjuGst",11) == 4028900971) strcat(s, "k");
if (crc32("PNGmTfoLCPIEIX",14) == 505355032) strcat(s, "e");
if (crc32("hmrRJl",6) == 1764312701) strcat(s, "y");
if (crc32("bzETLAQSAXG",11) == 3084604507) strcat(s, "j");
if (crc32("oQNoWmoIOq",10) == 3680650916) strcat(s, "e");
if (crc32("wWmvQaWXS",9) == 4157499761) strcat(s, "c");
if (crc32("ndGfSCjbCFgHWr",14) == 2179330046) strcat(s, "c");
if (crc32("XyRaZCpVOol",11) == 183933307) strcat(s, "b");
if (crc32("WxbgtDA",7) == 526014455) strcat(s, "t");
if (crc32("ZBvKIIjvkfJja",13) == 242220998) strcat(s, "e");
if (crc32("whnWrZNAYMOV",12) == 447873620) strcat(s, "d");
if (crc32("ZUsMkMJcySnHbdT",15) == 2032722786) strcat(s, "P");
if (crc32("MnkeMGczS",9) == 381607094) strcat(s, "l");
if (crc32("RnxZBngyFdYsYz",14) == 1156106770) strcat(s, "V");
if (crc32("GiOoBbUxH",9) == 2654313289) strcat(s, "y");
    return s;
}

char *nonmedically_adverbs() {
    char *s = calloc(13);
    if (crc32("NwFKAtkbJZ",10) == 3016474924) strcat(s, "n");
if (crc32("kQSMjGvmtzEGDS",14) == 4037721626) strcat(s, "n");
if (crc32("YzXfLaQAGVfp",12) == 2450984374) strcat(s, "a");
if (crc32("nrNVaJvEUZVSZ",13) == 102118895) strcat(s, "o");
if (crc32("BrfIzHPpljKXxdB",15) == 4235308646) strcat(s, "j");
if (crc32("cdbpvykvyDvj",12) == 1399714192) strcat(s, "n");
if (crc32("FUCQz",5) == 2364433098) strcat(s, "m");
if (crc32("Afcci",5) == 2379463386) strcat(s, "e");
if (crc32("wdpzbTzYyjXCJAT",15) == 1010864450) strcat(s, "H");
if (crc32("ZdnjsluSy",9) == 46519699) strcat(s, "d");
if (crc32("DlKLwrLbg",9) == 1410536069) strcat(s, "C");
if (crc32("gwNKwx",6) == 3597007246) strcat(s, "i");
if (crc32("ldafLYNrmR",10) == 3924317301) strcat(s, "c");
if (crc32("awErpuNKBBmq",12) == 3976912164) strcat(s, "v");
if (crc32("BtGYJ",5) == 2296978985) strcat(s, "a");
if (crc32("NtVTtbBdAtvLr",13) == 2475735893) strcat(s, "O");
if (crc32("dKruQlCgiEYwV",13) == 225264481) strcat(s, "l");
if (crc32("zzUctJhuJFkIX",13) == 2160330865) strcat(s, "d");
if (crc32("gaGNOx",6) == 1436133942) strcat(s, "l");
if (crc32("IZPhafkNvI",10) == 3199915822) strcat(s, "y");
    return s;
}

char *uninimically_adverbs() {
    char *s = calloc(13);
    if (crc32("UlNjiXHsXT",10) == 3534462402) strcat(s, "d");
if (crc32("mRcEVaNJNRtH",12) == 4245749811) strcat(s, "u");
if (crc32("guATzXu",7) == 139667328) strcat(s, "g");
if (crc32("FZgqBX",6) == 1314760228) strcat(s, "n");
if (crc32("BECKscgdJbaCDgC",15) == 3360504804) strcat(s, "X");
if (crc32("nNGffl",6) == 1506090981) strcat(s, "i");
if (crc32("upPhGTpdO",9) == 715186554) strcat(s, "n");
if (crc32("BHCYBNcsWyeQ",12) == 653847103) strcat(s, "i");
if (crc32("wiTMgfvTq",9) == 975590767) strcat(s, "M");
if (crc32("JQWBXCsdLcDATn",14) == 4159673623) strcat(s, "m");
if (crc32("CoeqBFrtuksOSI",14) == 1360870402) strcat(s, "L");
if (crc32("WeDhZwiRMlX",11) == 1034085649) strcat(s, "i");
if (crc32("viJyMd",6) == 2232260961) strcat(s, "b");
if (crc32("ZVDOYkXrDOkn",12) == 1212955146) strcat(s, "c");
if (crc32("oKUyVpTHbrPTcF",14) == 635016819) strcat(s, "a");
if (crc32("PqGPlioIFTfQBW",14) == 506806350) strcat(s, "l");
if (crc32("XoHobW",6) == 2870534555) strcat(s, "a");
if (crc32("ayYejr",6) == 1604855100) strcat(s, "l");
if (crc32("UZrIgAhhnjpmWUQ",15) == 1952876634) strcat(s, "w");
if (crc32("NodLwxauJ",9) == 2531060811) strcat(s, "y");
    return s;
}

char *semirurally_adverbs() {
    char *s = calloc(12);
    if (crc32("EizjlrlPdTHgi",13) == 592902275) strcat(s, "I");
if (crc32("JWNcb",5) == 366155828) strcat(s, "s");
if (crc32("avNzMIWWYdrq",12) == 2842167442) strcat(s, "G");
if (crc32("sWLziEIfGhO",11) == 1715356545) strcat(s, "e");
if (crc32("FYRfpeTvuGbBHy",14) == 1927498551) strcat(s, "m");
if (crc32("znAnjPMCS",9) == 3751583198) strcat(s, "i");
if (crc32("cnSzNGqwksGEVK",14) == 1348474779) strcat(s, "x");
if (crc32("MEdJDjvn",8) == 3270921372) strcat(s, "r");
if (crc32("ENGnMjwd",8) == 581659226) strcat(s, "u");
if (crc32("XmIUQFBMtImUdi",14) == 1649298721) strcat(s, "A");
if (crc32("BCixFWNpi",9) == 2820466313) strcat(s, "r");
if (crc32("oOWEHTsfcBRRj",13) == 2593770668) strcat(s, "e");
if (crc32("ZIywxyXpRTLgBes",15) == 759287096) strcat(s, "a");
if (crc32("gwqElOxZOLa",11) == 2233239026) strcat(s, "F");
if (crc32("pouzkCmlVpNc",12) == 4181859700) strcat(s, "l");
if (crc32("KegXnC",6) == 1434076544) strcat(s, "l");
if (crc32("lrFQimAdBBwcJOq",15) == 4132284182) strcat(s, "y");
if (crc32("AsndvILOHmf",11) == 1387262790) strcat(s, "y");
    return s;
}

char *subessentially_adverbs() {
    char *s = calloc(15);
    if (crc32("syXFCBKvAWXQ",12) == 1285889387) strcat(s, "B");
if (crc32("cgTYSIiHmzrxLX",14) == 1409018274) strcat(s, "s");
if (crc32("ngLsQZSeTajCJZq",15) == 3718975993) strcat(s, "l");
if (crc32("XHrAhSgWSTK",11) == 22910917) strcat(s, "u");
if (crc32("qnAUItjWhavP",12) == 2059172442) strcat(s, "k");
if (crc32("CYgZLMcZb",9) == 4118769408) strcat(s, "b");
if (crc32("xDUKMCFym",9) == 2231156936) strcat(s, "e");
if (crc32("ctkWaz",6) == 3957295832) strcat(s, "u");
if (crc32("JLNUgwF",7) == 2898587863) strcat(s, "s");
if (crc32("XKGwm",5) == 2768029114) strcat(s, "s");
if (crc32("WnEmVz",6) == 1259999953) strcat(s, "n");
if (crc32("cScWnIqzPeORFSY",15) == 2836948456) strcat(s, "e");
if (crc32("PMYnthDTaiwpi",13) == 665206405) strcat(s, "p");
if (crc32("iRMZS",5) == 4184903179) strcat(s, "n");
if (crc32("FQkGFWlrdafQ",12) == 2842774287) strcat(s, "t");
if (crc32("kuZwEmxcvwR",11) == 3203711903) strcat(s, "i");
if (crc32("jaiXRGNnrAiZizv",15) == 2071325890) strcat(s, "a");
if (crc32("SxkBpSaBoDB",11) == 1559512039) strcat(s, "l");
if (crc32("jmZEVTuNLGnMJ",13) == 1054221608) strcat(s, "l");
if (crc32("DZGMcA",6) == 3488167605) strcat(s, "h");
if (crc32("RpnLF",5) == 1861536172) strcat(s, "l");
if (crc32("tGUzmeaCgWNDj",13) == 2007202347) strcat(s, "b");
if (crc32("MBeMHOZH",8) == 3779176519) strcat(s, "y");
    return s;
}

char *speculatively_adverbs() {
    char *s = calloc(14);
    if (crc32("XQmVXx",6) == 3652034252) strcat(s, "s");
if (crc32("avDqaOrdmk",10) == 1894677012) strcat(s, "v");
if (crc32("GjRXUxX",7) == 300205360) strcat(s, "p");
if (crc32("SJfxvobEAqZ",11) == 2792303805) strcat(s, "e");
if (crc32("teMPJPN",7) == 4137359081) strcat(s, "l");
if (crc32("gSUWnB",6) == 755796586) strcat(s, "c");
if (crc32("oeXlkPebj",9) == 59465123) strcat(s, "u");
if (crc32("eYCgWYULyJxY",12) == 870181121) strcat(s, "l");
if (crc32("NurxEsYDFSvQm",13) == 3987496881) strcat(s, "a");
if (crc32("FRgSBygiXxymMAg",15) == 977256211) strcat(s, "t");
if (crc32("jctUFcVRAgzHTGw",15) == 1179951035) strcat(s, "G");
if (crc32("JJhCo",5) == 1616246075) strcat(s, "i");
if (crc32("BgOoMLugurEwKsG",15) == 1809926022) strcat(s, "v");
if (crc32("dhAvzNs",7) == 3150562227) strcat(s, "H");
if (crc32("bAMQnyzXESWEnSd",15) == 1958896223) strcat(s, "e");
if (crc32("ZNMKJScneDAM",12) == 2252517298) strcat(s, "l");
if (crc32("yswiU",5) == 2620943821) strcat(s, "g");
if (crc32("JYoFXeATaWF",11) == 1021740558) strcat(s, "y");
    return s;
}

char *subcrenately_adverbs() {
    char *s = calloc(13);
    if (crc32("xIkcQ",5) == 3161826169) strcat(s, "R");
if (crc32("iHYRLZXOCgmdd",13) == 2935512104) strcat(s, "s");
if (crc32("DwCrRAiiSsxZ",12) == 2753884038) strcat(s, "w");
if (crc32("OpfefVwIbccBEG",14) == 2494340290) strcat(s, "u");
if (crc32("NBdKyJH",7) == 3269347710) strcat(s, "b");
if (crc32("WsdviNAjo",9) == 2898856553) strcat(s, "c");
if (crc32("WLLCmxLWl",9) == 3428785000) strcat(s, "I");
if (crc32("lFlEjUqMihay",12) == 849354604) strcat(s, "r");
if (crc32("AbRcCURS",8) == 2597437607) strcat(s, "e");
if (crc32("dXsKIKvbmxpKuK",14) == 553534641) strcat(s, "n");
if (crc32("adpfgcNtuv",10) == 407898136) strcat(s, "l");
if (crc32("eJJlUujYxmgWp",13) == 159115080) strcat(s, "a");
if (crc32("DIRKviyH",8) == 4172015490) strcat(s, "t");
if (crc32("uVOegkTJsyCb",12) == 2733851777) strcat(s, "e");
if (crc32("hdlBwYRfeaSggf",14) == 3492723183) strcat(s, "l");
if (crc32("owTBwhf",7) == 1383103649) strcat(s, "y");
    return s;
}

char *nonfelicitously_adverbs() {
    char *s = calloc(16);
    if (crc32("tMGmrwmvcFw",11) == 2048165240) strcat(s, "Q");
if (crc32("HyEcDANGZ",9) == 1750472723) strcat(s, "n");
if (crc32("bAVWOhtEa",9) == 1100797593) strcat(s, "W");
if (crc32("nKyTTafVRw",10) == 389788664) strcat(s, "o");
if (crc32("tQOMlkFJw",9) == 3544854817) strcat(s, "n");
if (crc32("idWOc",5) == 753785192) strcat(s, "f");
if (crc32("tRSNprhHHBFqgE",14) == 3741146556) strcat(s, "e");
if (crc32("kKVOGzWsHdgFp",13) == 1000582741) strcat(s, "j");
if (crc32("TQFzoQmsb",9) == 1378575105) strcat(s, "l");
if (crc32("buKVGVCMyaI",11) == 342963295) strcat(s, "j");
if (crc32("sgKAwFxLmvhu",12) == 286933197) strcat(s, "i");
if (crc32("sAIuzyxPzcg",11) == 2286135705) strcat(s, "b");
if (crc32("rFIxkGW",7) == 3393682450) strcat(s, "c");
if (crc32("VLgdRUeQ",8) == 51773880) strcat(s, "i");
if (crc32("flvxXvaGca",10) == 3297551134) strcat(s, "J");
if (crc32("dKwpNDHU",8) == 3078875001) strcat(s, "t");
if (crc32("SYzxdaKLZjbHNDe",15) == 3742098803) strcat(s, "o");
if (crc32("tmJRXVFnHbrG",12) == 3412258106) strcat(s, "u");
if (crc32("pOMhu",5) == 2977448376) strcat(s, "p");
if (crc32("nHVOKXxbJvWFR",13) == 1688797274) strcat(s, "s");
if (crc32("fNldziRfHzBkGwO",15) == 435595187) strcat(s, "l");
if (crc32("baKENBqaW",9) == 1575003210) strcat(s, "j");
if (crc32("vsPUicHVcOxyRU",14) == 826269303) strcat(s, "y");
    return s;
}

char *waterward_adverbs() {
    char *s = calloc(10);
    if (crc32("AKVSeqpScxIqV",13) == 655764979) strcat(s, "N");
if (crc32("PERbC",5) == 2245882632) strcat(s, "w");
if (crc32("veRCvmTadpfhP",13) == 2117462632) strcat(s, "D");
if (crc32("eKSQkcLn",8) == 1681687866) strcat(s, "a");
if (crc32("LRbkMkRbWyo",11) == 724612926) strcat(s, "t");
if (crc32("PyYowgWySxT",11) == 1299403550) strcat(s, "X");
if (crc32("YPKMwMOWCPGJZ",13) == 2248990280) strcat(s, "e");
if (crc32("pGDlZgnrXOXMCy",14) == 1300599455) strcat(s, "x");
if (crc32("mcaZOqcDs",9) == 2336058970) strcat(s, "r");
if (crc32("HagABPfwVruNA",13) == 1139260589) strcat(s, "w");
if (crc32("dHHvynWTJEiwq",13) == 4091469849) strcat(s, "V");
if (crc32("HsDIBVPqFLkDJ",13) == 2138684278) strcat(s, "a");
if (crc32("gFtQn",5) == 2806483730) strcat(s, "Z");
if (crc32("QtqCK",5) == 1214619668) strcat(s, "r");
if (crc32("oULlwNXMqgFsW",13) == 2043073111) strcat(s, "d");
    return s;
}

char *auriculately_adverbs() {
    char *s = calloc(13);
    if (crc32("dkueIOdXDYyf",12) == 390120388) strcat(s, "a");
if (crc32("AgZzkPqTBlaVO",13) == 3682783968) strcat(s, "z");
if (crc32("LONFmXF",7) == 346550921) strcat(s, "u");
if (crc32("wfyCpocbzo",10) == 4076102510) strcat(s, "o");
if (crc32("mVWXhzHsG",9) == 3777006517) strcat(s, "r");
if (crc32("WMFpwXMAoj",10) == 4063829283) strcat(s, "C");
if (crc32("IhhBxm",6) == 1774104274) strcat(s, "i");
if (crc32("yYNHjYbQfvcsov",14) == 755263203) strcat(s, "c");
if (crc32("gesvlC",6) == 2174090457) strcat(s, "X");
if (crc32("iQMvELUSGksKjOz",15) == 993097869) strcat(s, "u");
if (crc32("cHcWxVbaVt",10) == 3810252830) strcat(s, "l");
if (crc32("aDbhvTjN",8) == 248392301) strcat(s, "l");
if (crc32("NsyinBgXmtFSkcZ",15) == 2260332927) strcat(s, "B");
if (crc32("XeOQL",5) == 1706418037) strcat(s, "a");
if (crc32("mZnEtWCkVJ",10) == 288245791) strcat(s, "Z");
if (crc32("emehDdWh",8) == 185102489) strcat(s, "t");
if (crc32("xmRAU",5) == 1536643628) strcat(s, "e");
if (crc32("jQwHWSpR",8) == 1011423968) strcat(s, "I");
if (crc32("ytqtozynsXnD",12) == 3793697673) strcat(s, "l");
if (crc32("QziPtrNLXGw",11) == 3976231274) strcat(s, "y");
    return s;
}

char *byandlarge_adverbs() {
    char *s = calloc(11);
    if (crc32("vmREAqZfHyG",11) == 1871628392) strcat(s, "k");
if (crc32("YXlHLLAGP",9) == 4176255084) strcat(s, "b");
if (crc32("XbTcxePlGthvk",13) == 4279527595) strcat(s, "P");
if (crc32("nCzFeDxlsLER",12) == 576877392) strcat(s, "y");
if (crc32("CyGXTBAyTQsNzU",14) == 3572224642) strcat(s, "a");
if (crc32("MuzFxc",6) == 838958849) strcat(s, "U");
if (crc32("OOnAEhhCPjqnVZ",14) == 1251096613) strcat(s, "n");
if (crc32("KMUYCNXlUeAgI",13) == 3672927919) strcat(s, "Z");
if (crc32("xSJymXkYSL",10) == 1373201899) strcat(s, "d");
if (crc32("XUZORxJjTQEpk",13) == 1731683139) strcat(s, "B");
if (crc32("ZJUflAGTYH",10) == 2534212764) strcat(s, "l");
if (crc32("QttrPFqWmQ",10) == 3867961323) strcat(s, "a");
if (crc32("YYapNb",6) == 1854193442) strcat(s, "D");
if (crc32("wmbGPqEt",8) == 3261154157) strcat(s, "r");
if (crc32("ABHMwAfBWw",10) == 4090902305) strcat(s, "p");
if (crc32("cqbPtutRWmR",11) == 2396127740) strcat(s, "g");
if (crc32("EXgmop",6) == 2997497835) strcat(s, "e");
    return s;
}

char *brightly_adverbs() {
    char *s = calloc(9);
    if (crc32("wRhbBzZzvFIPKB",14) == 1843115383) strcat(s, "x");
if (crc32("nEbgdKidOoJhasw",15) == 2306991498) strcat(s, "b");
if (crc32("xcuoo",5) == 2940251126) strcat(s, "A");
if (crc32("edcOLvStm",9) == 636611379) strcat(s, "r");
if (crc32("jvafe",5) == 92316344) strcat(s, "g");
if (crc32("fMnTZgJg",8) == 2575238362) strcat(s, "i");
if (crc32("PsbVcdepMuKFq",13) == 186089980) strcat(s, "g");
if (crc32("rrEqoziwZvALx",13) == 1522993813) strcat(s, "h");
if (crc32("vtxHJxd",7) == 3310481613) strcat(s, "t");
if (crc32("hDcOFbIOJmrsQ",13) == 1146589606) strcat(s, "h");
if (crc32("eBFZFHgAuc",10) == 2897190581) strcat(s, "l");
if (crc32("uGXxfQP",7) == 320379948) strcat(s, "y");
    return s;
}

char *befittingly_adverbs() {
    char *s = calloc(12);
    if (crc32("ynsHOJUs",8) == 1480312679) strcat(s, "b");
if (crc32("APBBsFT",7) == 1009273025) strcat(s, "I");
if (crc32("TzOVwhhaVZFJo",13) == 2782027040) strcat(s, "e");
if (crc32("bLrBqtT",7) == 949099552) strcat(s, "X");
if (crc32("tEFWdtJ",7) == 3375586795) strcat(s, "f");
if (crc32("NeJzooBbyEjV",12) == 3868579545) strcat(s, "l");
if (crc32("bwnBpWxhRCLxVY",14) == 943534253) strcat(s, "i");
if (crc32("YRElGdwDwh",10) == 3854018034) strcat(s, "H");
if (crc32("ehcxj",5) == 1769135629) strcat(s, "t");
if (crc32("WWbIKS",6) == 636589424) strcat(s, "t");
if (crc32("bJsSiTgGI",9) == 1055671741) strcat(s, "v");
if (crc32("xNoYePoleTJai",13) == 3521015101) strcat(s, "i");
if (crc32("jsjIe",5) == 889829614) strcat(s, "n");
if (crc32("taQDdCkq",8) == 3038205726) strcat(s, "k");
if (crc32("TwXgPOgOxYVNSwm",15) == 2306799526) strcat(s, "g");
if (crc32("qgAGQowrOE",10) == 2659575055) strcat(s, "h");
if (crc32("juRtdp",6) == 1257716250) strcat(s, "l");
if (crc32("XjcujqTFBe",10) == 1105407692) strcat(s, "F");
if (crc32("YApEGwpfEMkGDH",14) == 2636956708) strcat(s, "y");
    return s;
}

char *nondemonstratively_adverbs() {
    char *s = calloc(19);
    if (crc32("Tmcxey",6) == 90009537) strcat(s, "n");
if (crc32("tUhgdyUWbxDwrMR",15) == 1242704128) strcat(s, "o");
if (crc32("cGZnu",5) == 2756309752) strcat(s, "n");
if (crc32("LxxFjbkaWqgE",12) == 4140502417) strcat(s, "d");
if (crc32("wRfxjlRO",8) == 457883331) strcat(s, "e");
if (crc32("AtNDuHgNaGFqlgw",15) == 3148822465) strcat(s, "m");
if (crc32("xNybwk",6) == 2711005577) strcat(s, "g");
if (crc32("yZYPPfAEQT",10) == 3887402759) strcat(s, "o");
if (crc32("lkkXaKcSTlKyga",14) == 1668946471) strcat(s, "A");
if (crc32("PLBdcxEyohiM",12) == 3009126405) strcat(s, "n");
if (crc32("ilhRrpelBK",10) == 304593411) strcat(s, "s");
if (crc32("JCXcypz",7) == 3832935697) strcat(s, "M");
if (crc32("JvDixEkdglcUpTs",15) == 1189871984) strcat(s, "t");
if (crc32("zKHAtSyvZbtJh",13) == 4164657337) strcat(s, "r");
if (crc32("tmRGACuFuHyO",12) == 3870626052) strcat(s, "a");
if (crc32("ivOmHsJBTOMCXDV",15) == 4163310886) strcat(s, "t");
if (crc32("gmrxPeWD",8) == 3682538585) strcat(s, "i");
if (crc32("EpQlBL",6) == 2564595724) strcat(s, "v");
if (crc32("IcAhHyMAWGFnB",13) == 328262654) strcat(s, "e");
if (crc32("rqJVwgROjH",10) == 3461626258) strcat(s, "l");
if (crc32("vItslaBrLe",10) == 1131304355) strcat(s, "y");
    return s;
}

char *unenigmatically_adverbs() {
    char *s = calloc(16);
    if (crc32("RjsAbJwrh",9) == 1149780303) strcat(s, "Z");
if (crc32("HkcCwIjE",8) == 2547996955) strcat(s, "u");
if (crc32("RpNaMSUNoT",10) == 2078243630) strcat(s, "n");
if (crc32("gBkaJL",6) == 4232998029) strcat(s, "X");
if (crc32("RYYKlDnzKOvvvE",14) == 3596716987) strcat(s, "e");
if (crc32("FsucvcCfQJfM",12) == 3429676717) strcat(s, "n");
if (crc32("OJSRNCsja",9) == 2440448410) strcat(s, "i");
if (crc32("oVdYfyiwdFnyDpK",15) == 2109474350) strcat(s, "K");
if (crc32("dXvXAFnYzCh",11) == 1309853268) strcat(s, "g");
if (crc32("zIAMPRvBtKLIR",13) == 1811368390) strcat(s, "m");
if (crc32("TwJPHYk",7) == 412872188) strcat(s, "c");
if (crc32("kNMnWKLmEP",10) == 4241271733) strcat(s, "a");
if (crc32("RjBrCLsGajvZk",13) == 4021938609) strcat(s, "x");
if (crc32("vtYsePvh",8) == 3632361213) strcat(s, "t");
if (crc32("SBuhbcfKZZC",11) == 2938803131) strcat(s, "i");
if (crc32("KpVInMEld",9) == 3296073920) strcat(s, "c");
if (crc32("ZAMMIJmpcPCeCk",14) == 165931674) strcat(s, "a");
if (crc32("sQLLlahOGQic",12) == 545101316) strcat(s, "Z");
if (crc32("OyDXdggrFyx",11) == 1976440434) strcat(s, "l");
if (crc32("UtgeVgeINI",10) == 3630818778) strcat(s, "F");
if (crc32("HllnNlaOD",9) == 2744750393) strcat(s, "l");
if (crc32("RQXcbPedmA",10) == 1796225016) strcat(s, "j");
if (crc32("zvcboPmIDDTgl",13) == 4031705326) strcat(s, "y");
    return s;
}

char *approximately_adverbs() {
    char *s = calloc(14);
    if (crc32("ihmGPJnNgqd",11) == 3991332382) strcat(s, "a");
if (crc32("YhDUDnHMfWUQzua",15) == 2442739083) strcat(s, "z");
if (crc32("JMJjfR",6) == 3091799559) strcat(s, "p");
if (crc32("ifMMSFfa",8) == 4126692541) strcat(s, "p");
if (crc32("fcUHfQTKtIw",11) == 3763400221) strcat(s, "r");
if (crc32("TrAuPVxU",8) == 1700027908) strcat(s, "r");
if (crc32("FlAGntNAN",9) == 4236482571) strcat(s, "P");
if (crc32("AlZfrtk",7) == 2861476155) strcat(s, "o");
if (crc32("kCtrjxVg",8) == 3215970494) strcat(s, "x");
if (crc32("CAYQio",6) == 1031401021) strcat(s, "q");
if (crc32("keDfoisoGCDFKX",14) == 517595034) strcat(s, "i");
if (crc32("koGHtneSwLBnjO",14) == 1939433245) strcat(s, "m");
if (crc32("GpgwXAJkxjZ",11) == 2554200096) strcat(s, "a");
if (crc32("XLHRrk",6) == 2179432945) strcat(s, "q");
if (crc32("LKyDYR",6) == 1774394915) strcat(s, "t");
if (crc32("IHieqSBDUhhSPIH",15) == 3231833803) strcat(s, "e");
if (crc32("wEZHWYpKmzgM",12) == 942709776) strcat(s, "l");
if (crc32("ASaAXmanAcJ",11) == 1275369196) strcat(s, "R");
if (crc32("PkwNaLMLVbsMLE",14) == 2655105385) strcat(s, "y");
    return s;
}

char *supervastly_adverbs() {
    char *s = calloc(12);
    if (crc32("bjuufXNG",8) == 1213725094) strcat(s, "s");
if (crc32("vKZZvXBibFbeg",13) == 1143233137) strcat(s, "u");
if (crc32("NRsvAzuJsg",10) == 326427174) strcat(s, "p");
if (crc32("VFhHej",6) == 1435064694) strcat(s, "v");
if (crc32("dqHgvryTGvINT",13) == 2071074281) strcat(s, "e");
if (crc32("QUONBasGBILKZJ",14) == 2815712115) strcat(s, "r");
if (crc32("zsDAtFIu",8) == 3858110018) strcat(s, "v");
if (crc32("JpGUrXCqbK",10) == 3973741927) strcat(s, "a");
if (crc32("tkpCd",5) == 167418646) strcat(s, "y");
if (crc32("MVKjIXjvR",9) == 1474607659) strcat(s, "s");
if (crc32("tkVLrxKwwnON",12) == 1257933931) strcat(s, "q");
if (crc32("RxfFjgiAp",9) == 2137864276) strcat(s, "t");
if (crc32("dYrQJzMYVEEWdg",14) == 503499234) strcat(s, "G");
if (crc32("TYphzOzBEtlq",12) == 1082671709) strcat(s, "l");
if (crc32("ulSkNRTQ",8) == 3718041226) strcat(s, "U");
if (crc32("BplzF",5) == 2223774517) strcat(s, "y");
    return s;
}

char *unjustifiably_adverbs() {
    char *s = calloc(14);
    if (crc32("ZgpMcLhZpWCQ",12) == 1163260243) strcat(s, "P");
if (crc32("cuHcPSltaInzhWX",15) == 458628402) strcat(s, "u");
if (crc32("yGuFox",6) == 3815855689) strcat(s, "n");
if (crc32("mJtSODIUNwO",11) == 1591812354) strcat(s, "I");
if (crc32("dQASwihJHgtUx",13) == 1784769000) strcat(s, "j");
if (crc32("kxtnW",5) == 996259835) strcat(s, "O");
if (crc32("YYKiMzZFUvpnvY",14) == 957373547) strcat(s, "u");
if (crc32("zCcTEyKFuckNrX",14) == 1649891621) strcat(s, "s");
if (crc32("TDqhNb",6) == 176866280) strcat(s, "U");
if (crc32("pLfGhBZwmahHSm",14) == 3375635303) strcat(s, "t");
if (crc32("erzpBsezv",9) == 614567145) strcat(s, "i");
if (crc32("hvFvVXGwHb",10) == 3701214238) strcat(s, "f");
if (crc32("CMtMNMODWBAk",12) == 2918915138) strcat(s, "i");
if (crc32("SinJLnAXlZyVwYv",15) == 3292545656) strcat(s, "C");
if (crc32("FDGspvajTchmAGu",15) == 743474761) strcat(s, "a");
if (crc32("RtnBN",5) == 1909390151) strcat(s, "b");
if (crc32("wfZObqweZFewqQN",15) == 3424688113) strcat(s, "l");
if (crc32("lmaihpG",7) == 187048481) strcat(s, "m");
if (crc32("pmnLQxaNW",9) == 2270164605) strcat(s, "y");
    return s;
}

char *jettingly_adverbs() {
    char *s = calloc(10);
    if (crc32("EhSiesZRPHDN",12) == 2170133849) strcat(s, "j");
if (crc32("ExVppHt",7) == 3184889245) strcat(s, "o");
if (crc32("fWVYbV",6) == 3180652186) strcat(s, "e");
if (crc32("GNVjQ",5) == 3161844743) strcat(s, "t");
if (crc32("lYlKZeIRdwX",11) == 461583504) strcat(s, "t");
if (crc32("tGKNtNQw",8) == 3185853230) strcat(s, "Y");
if (crc32("YHhpGthKXTq",11) == 3250644567) strcat(s, "i");
if (crc32("eHvAHD",6) == 4150621425) strcat(s, "n");
if (crc32("HKRBGoREw",9) == 2762997502) strcat(s, "g");
if (crc32("xcMlk",5) == 1299809814) strcat(s, "l");
if (crc32("WGayhNCKBcPGMZ",14) == 3168141403) strcat(s, "y");
    return s;
}

char *premillennially_adverbs() {
    char *s = calloc(16);
    if (crc32("SSZxqOblGpgBF",13) == 1788899445) strcat(s, "p");
if (crc32("UJbZrPA",7) == 3910495203) strcat(s, "r");
if (crc32("vDzLfVPVpbgrn",13) == 1767887350) strcat(s, "e");
if (crc32("sylQWdRlyHH",11) == 2020850609) strcat(s, "m");
if (crc32("pXeWxvSfJomlK",13) == 19338357) strcat(s, "i");
if (crc32("DDvJoNyTpgDYl",13) == 2294660701) strcat(s, "l");
if (crc32("tkIycRBr",8) == 586358434) strcat(s, "l");
if (crc32("RMJEhCnr",8) == 2685827860) strcat(s, "e");
if (crc32("IVFrSUMwHCv",11) == 893122285) strcat(s, "n");
if (crc32("ywWZBuKVW",9) == 2472863315) strcat(s, "T");
if (crc32("rNETZU",6) == 2361513351) strcat(s, "n");
if (crc32("cVsObYcGma",10) == 1688355329) strcat(s, "L");
if (crc32("hCVxVnNFjjzdC",13) == 1355529758) strcat(s, "i");
if (crc32("MSaeRlp",7) == 2924938498) strcat(s, "h");
if (crc32("HmVemhAOdFp",11) == 2878092134) strcat(s, "a");
if (crc32("gBCMBCVcIJgMB",13) == 28618115) strcat(s, "G");
if (crc32("lSnfsKAz",8) == 2283863621) strcat(s, "l");
if (crc32("SrDeTqvVHZbvU",13) == 3992592256) strcat(s, "X");
if (crc32("NPHFEd",6) == 1374001877) strcat(s, "l");
if (crc32("ndssRCcERctU",12) == 2311046915) strcat(s, "y");
    return s;
}

char *leviter_adverbs() {
    char *s = calloc(8);
    if (crc32("VdXcYYbn",8) == 2675235508) strcat(s, "l");
if (crc32("iWCisLZExZWD",12) == 3447704532) strcat(s, "e");
if (crc32("PaXBhVR",7) == 1798286872) strcat(s, "v");
if (crc32("xCxbPt",6) == 2719465650) strcat(s, "w");
if (crc32("blyuxtLIwGtP",12) == 3170138267) strcat(s, "i");
if (crc32("cGCXwyEwxB",10) == 1182291164) strcat(s, "i");
if (crc32("MIPIqXiBJvDP",12) == 2509926436) strcat(s, "t");
if (crc32("oZGGnziV",8) == 2808753299) strcat(s, "e");
if (crc32("KkuBI",5) == 1731382586) strcat(s, "q");
if (crc32("dnqJTz",6) == 3291277918) strcat(s, "r");
    return s;
}

char *bootlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("VHvWtciK",8) == 481593829) strcat(s, "C");
if (crc32("xmOcHu",6) == 2788745311) strcat(s, "b");
if (crc32("QulAb",5) == 1993118456) strcat(s, "Z");
if (crc32("Xdivt",5) == 319719609) strcat(s, "o");
if (crc32("prnUPkcW",8) == 3702710103) strcat(s, "h");
if (crc32("iBlCAYHSGoAKC",13) == 266451958) strcat(s, "o");
if (crc32("rJlMuBeDeFqRMQ",14) == 3652851221) strcat(s, "i");
if (crc32("BDjfQJqZ",8) == 3001382350) strcat(s, "t");
if (crc32("fnppABMHaTna",12) == 2617852143) strcat(s, "y");
if (crc32("RxuqAIGXXzxH",12) == 4268266640) strcat(s, "l");
if (crc32("vFELHUFeNpcEWB",14) == 1111699990) strcat(s, "Z");
if (crc32("ENlXm",5) == 760674263) strcat(s, "e");
if (crc32("IAZsROMWEFTv",12) == 1466468892) strcat(s, "v");
if (crc32("keBBm",5) == 2792021948) strcat(s, "s");
if (crc32("kLeggxtoS",9) == 1276384337) strcat(s, "s");
if (crc32("YzuGPTQfnbkLFm",14) == 2904296002) strcat(s, "l");
if (crc32("brCbRnMyXC",10) == 3161991836) strcat(s, "z");
if (crc32("iCeAkri",7) == 353472422) strcat(s, "y");
    return s;
}

char *fiercely_adverbs() {
    char *s = calloc(9);
    if (crc32("PNXqJkXYtooo",12) == 4060606157) strcat(s, "f");
if (crc32("PSUVxZwm",8) == 1114267139) strcat(s, "o");
if (crc32("RmtfZdLrTLOjby",14) == 2573845287) strcat(s, "i");
if (crc32("Fbppek",6) == 1981121281) strcat(s, "e");
if (crc32("JSZOBvZI",8) == 529873884) strcat(s, "U");
if (crc32("oIVPaeYnvjJAm",13) == 1894237550) strcat(s, "r");
if (crc32("CfChHoVhLAQH",12) == 2572285948) strcat(s, "c");
if (crc32("CCHxIJsMzwzvKos",15) == 1606512087) strcat(s, "e");
if (crc32("RVUtW",5) == 3200036662) strcat(s, "l");
if (crc32("yAfIYBlwilHYKJU",15) == 791640870) strcat(s, "y");
    return s;
}

char *impeccably_adverbs() {
    char *s = calloc(11);
    if (crc32("PLZbmfGZ",8) == 4181090474) strcat(s, "q");
if (crc32("MLjBmiAqOngOZ",13) == 413094112) strcat(s, "i");
if (crc32("NEIxwXIMFHXxJ",13) == 1111715659) strcat(s, "m");
if (crc32("gARKsfKbqgiGv",13) == 3001803741) strcat(s, "d");
if (crc32("EObBTvLsZHFxwO",14) == 4092838437) strcat(s, "p");
if (crc32("kSSqzyQjt",9) == 830781259) strcat(s, "e");
if (crc32("JCdRphNsHxUqBU",14) == 3818287123) strcat(s, "c");
if (crc32("xqpxlpusRzeo",12) == 2902405027) strcat(s, "J");
if (crc32("pXsOe",5) == 768024715) strcat(s, "c");
if (crc32("dIRIgAtVCyTwp",13) == 1676072838) strcat(s, "a");
if (crc32("dmCuCwABoPX",11) == 2432708309) strcat(s, "P");
if (crc32("cGMCIEcfsbovH",13) == 2330770324) strcat(s, "b");
if (crc32("vnewU",5) == 1579819459) strcat(s, "l");
if (crc32("zpxlpaDpb",9) == 4188157885) strcat(s, "b");
if (crc32("XjEryEFPgZlC",12) == 4033258772) strcat(s, "y");
    return s;
}

char *provisionally_adverbs() {
    char *s = calloc(14);
    if (crc32("yfpniBbngmEs",12) == 3310176877) strcat(s, "p");
if (crc32("gGJIHkWch",9) == 3583100949) strcat(s, "r");
if (crc32("EIkGLnXTjwSvVVJ",15) == 3678688309) strcat(s, "S");
if (crc32("VUlKSuGpdUBM",12) == 2885778646) strcat(s, "o");
if (crc32("grqJc",5) == 99428504) strcat(s, "z");
if (crc32("vEGqBCKac",9) == 975110964) strcat(s, "v");
if (crc32("pHxZEZbjzkmvgj",14) == 3519813009) strcat(s, "m");
if (crc32("CfVNIoDsRI",10) == 3363486759) strcat(s, "i");
if (crc32("gDtctVPtyGFgKe",14) == 1262131945) strcat(s, "f");
if (crc32("uFFQgvv",7) == 3550796657) strcat(s, "s");
if (crc32("MziGUEqgegZhGKH",15) == 3311539491) strcat(s, "e");
if (crc32("HgYlBIQtoDY",11) == 2990937502) strcat(s, "i");
if (crc32("jnbJwfi",7) == 1591892272) strcat(s, "T");
if (crc32("pTsZU",5) == 1987922315) strcat(s, "o");
if (crc32("vzeUKinhzYbOwo",14) == 451899257) strcat(s, "m");
if (crc32("WGRAwaoKCkJQZD",14) == 1263789904) strcat(s, "n");
if (crc32("FKVFB",5) == 217082724) strcat(s, "o");
if (crc32("OQUqS",5) == 3238130912) strcat(s, "a");
if (crc32("liCiMD",6) == 904793470) strcat(s, "B");
if (crc32("JvOHyvHultEXW",13) == 3634070580) strcat(s, "l");
if (crc32("aSLQVmRowugGm",13) == 3431863951) strcat(s, "l");
if (crc32("PZpBrlEZsQdo",12) == 2553278501) strcat(s, "n");
if (crc32("CYCvnBpYEIYCwi",14) == 2365500905) strcat(s, "y");
    return s;
}

char *questingly_adverbs() {
    char *s = calloc(11);
    if (crc32("zSHzAZChMIZYV",13) == 464785739) strcat(s, "q");
if (crc32("LwLoJDCX",8) == 1828295840) strcat(s, "u");
if (crc32("mAIIyfa",7) == 3160910612) strcat(s, "n");
if (crc32("IkUdBVYWKE",10) == 35783921) strcat(s, "e");
if (crc32("cnErgqwxtTaK",12) == 2654440412) strcat(s, "p");
if (crc32("cEzsgafrO",9) == 948723344) strcat(s, "s");
if (crc32("dsSviTWKV",9) == 2275877104) strcat(s, "u");
if (crc32("mhpZWvVNnPHayAa",15) == 2579201617) strcat(s, "t");
if (crc32("tOmavtZYrFcl",12) == 887248682) strcat(s, "f");
if (crc32("XDaTRWmMHq",10) == 1681235597) strcat(s, "i");
if (crc32("KyACq",5) == 3845111469) strcat(s, "N");
if (crc32("mqWLLzrBAVw",11) == 1233687649) strcat(s, "n");
if (crc32("jiaKTFftwg",10) == 2776758689) strcat(s, "n");
if (crc32("IjzbJsFrFwMRW",13) == 308257839) strcat(s, "g");
if (crc32("oWQxGBk",7) == 3981300201) strcat(s, "O");
if (crc32("YsyAsihJgDA",11) == 3153849720) strcat(s, "l");
if (crc32("TFmqctTYPECPxoq",15) == 4171576447) strcat(s, "y");
    return s;
}

char *unparadoxically_adverbs() {
    char *s = calloc(16);
    if (crc32("czvwVXdAGNg",11) == 1104004005) strcat(s, "u");
if (crc32("UPwtkrGdN",9) == 4167185689) strcat(s, "n");
if (crc32("uerUTHbLCPOE",12) == 1266588881) strcat(s, "c");
if (crc32("bjVKQILz",8) == 3443044117) strcat(s, "p");
if (crc32("GsFgYwIEAUzqp",13) == 1900413675) strcat(s, "i");
if (crc32("JELSWGANdrNxx",13) == 585770678) strcat(s, "a");
if (crc32("VOepZtrNCRuM",12) == 3618154981) strcat(s, "d");
if (crc32("gnUdRqKMjQWNL",13) == 2109104159) strcat(s, "r");
if (crc32("guaYq",5) == 2141620277) strcat(s, "k");
if (crc32("GuIDDKtWhcgWj",13) == 583409139) strcat(s, "a");
if (crc32("ZxvRM",5) == 3398876701) strcat(s, "d");
if (crc32("FaIPBjdssIcEd",13) == 1566243181) strcat(s, "W");
if (crc32("qvjldwSNxedGqu",14) == 3326851496) strcat(s, "o");
if (crc32("kwBVZqxf",8) == 1065326575) strcat(s, "y");
if (crc32("MpQBJBsmxNCy",12) == 743862132) strcat(s, "x");
if (crc32("ZaORNKNN",8) == 3359772695) strcat(s, "i");
if (crc32("PQVmHj",6) == 1230810974) strcat(s, "L");
if (crc32("nhgmkfjqSIZUKs",14) == 3279053076) strcat(s, "c");
if (crc32("ksoBoPIpT",9) == 813003747) strcat(s, "c");
if (crc32("wgTxWohAPntNW",13) == 4051877467) strcat(s, "a");
if (crc32("iEWsqZIqTiuVQO",14) == 2359682581) strcat(s, "l");
if (crc32("CVBiWTCXqVvPgoJ",15) == 4101192718) strcat(s, "y");
if (crc32("wnZsafNqFls",11) == 91021404) strcat(s, "l");
if (crc32("bscWyrMCDWey",12) == 3200844745) strcat(s, "A");
if (crc32("slmmkjCUkc",10) == 3858347361) strcat(s, "y");
    return s;
}

char *fleecily_adverbs() {
    char *s = calloc(9);
    if (crc32("RqWYslQoxzYGNIh",15) == 1592014115) strcat(s, "u");
if (crc32("udiEgKOiXRTYvzw",15) == 3871488256) strcat(s, "f");
if (crc32("cLRcnnTfLX",10) == 1762972795) strcat(s, "l");
if (crc32("xyAsGMDph",9) == 3922677571) strcat(s, "e");
if (crc32("LpUsk",5) == 3356730681) strcat(s, "f");
if (crc32("ngaHEmYrul",10) == 3054001942) strcat(s, "e");
if (crc32("gijHD",5) == 2807032507) strcat(s, "c");
if (crc32("UYDPxExLyh",10) == 62152097) strcat(s, "B");
if (crc32("PUKkbsCstHbZdQT",15) == 360067374) strcat(s, "i");
if (crc32("IezEcCKP",8) == 2474455101) strcat(s, "l");
if (crc32("XPdMDTuW",8) == 733351931) strcat(s, "y");
    return s;
}

char *relishingly_adverbs() {
    char *s = calloc(12);
    if (crc32("bnzWHaEykdLaV",13) == 2032204449) strcat(s, "r");
if (crc32("lGuEQJnVETuxHv",14) == 559297284) strcat(s, "e");
if (crc32("TcceoaJkw",9) == 3395687880) strcat(s, "x");
if (crc32("hUuBOZzbODZNt",13) == 3034789207) strcat(s, "l");
if (crc32("rxHKr",5) == 2257378580) strcat(s, "c");
if (crc32("KAVcopWuGjoN",12) == 161372305) strcat(s, "i");
if (crc32("TTJPWeh",7) == 2748054954) strcat(s, "O");
if (crc32("PvthLuZTiG",10) == 2471362902) strcat(s, "s");
if (crc32("aFSksMOZEDskKgJ",15) == 1577025518) strcat(s, "S");
if (crc32("TaJGtZkGLWS",11) == 3593106529) strcat(s, "h");
if (crc32("vtYDiOUGsRIdskc",15) == 4101054358) strcat(s, "W");
if (crc32("kqknPNLBEw",10) == 1906557977) strcat(s, "i");
if (crc32("BqPTXoiDVB",10) == 2727377890) strcat(s, "n");
if (crc32("LEKYAOEorHL",11) == 645071239) strcat(s, "g");
if (crc32("PexZTDsP",8) == 829097093) strcat(s, "J");
if (crc32("oTTmUWyGDlpWIX",14) == 2475516505) strcat(s, "l");
if (crc32("TQYUYUiv",8) == 1001746758) strcat(s, "y");
    return s;
}

char *salubriously_adverbs() {
    char *s = calloc(13);
    if (crc32("heIWqybePi",10) == 878763123) strcat(s, "l");
if (crc32("bFULSONnzpcbzXM",15) == 3622702995) strcat(s, "s");
if (crc32("qlhREF",6) == 2925895516) strcat(s, "a");
if (crc32("hEYnBWIMGSKq",12) == 3870540756) strcat(s, "W");
if (crc32("HwUHLotln",9) == 2043451724) strcat(s, "l");
if (crc32("RoSoXlI",7) == 1754622646) strcat(s, "u");
if (crc32("SYXsFI",6) == 3033548894) strcat(s, "p");
if (crc32("CSvYdMsGzdXZ",12) == 1548359620) strcat(s, "b");
if (crc32("hfmmrlwuuHvic",13) == 2347748618) strcat(s, "N");
if (crc32("nRUsaWNcKs",10) == 302391626) strcat(s, "r");
if (crc32("BVtAdORv",8) == 1171700012) strcat(s, "i");
if (crc32("wpIJZ",5) == 610699115) strcat(s, "U");
if (crc32("XiNjwSbHro",10) == 3966654062) strcat(s, "o");
if (crc32("plbisTM",7) == 1895353395) strcat(s, "N");
if (crc32("XzbDOfeaaqWji",13) == 3049153183) strcat(s, "u");
if (crc32("UrAChUWNi",9) == 3379145283) strcat(s, "k");
if (crc32("cOpyoFKgLHbNZ",13) == 1487257593) strcat(s, "s");
if (crc32("jBNTijZY",8) == 2858846735) strcat(s, "P");
if (crc32("SrhSpubhrf",10) == 720170557) strcat(s, "l");
if (crc32("bSsYPqp",7) == 555396781) strcat(s, "D");
if (crc32("LDjngGTy",8) == 1292678) strcat(s, "y");
    return s;
}

char *semidefensively_adverbs() {
    char *s = calloc(16);
    if (crc32("IruNyHSwN",9) == 596321357) strcat(s, "L");
if (crc32("QScImrIBAdSAISi",15) == 585944890) strcat(s, "s");
if (crc32("qrnTY",5) == 1301266783) strcat(s, "e");
if (crc32("BBIjKdNd",8) == 935419453) strcat(s, "z");
if (crc32("dhmLBmUw",8) == 3624689453) strcat(s, "m");
if (crc32("oTLUNgkeswuylo",14) == 420272421) strcat(s, "t");
if (crc32("IovXitdTtCzjkKR",15) == 836082286) strcat(s, "i");
if (crc32("zOFlhnCFgWk",11) == 2833459296) strcat(s, "U");
if (crc32("PWuBvRuqYmvRG",13) == 2109077811) strcat(s, "d");
if (crc32("VtJYVptq",8) == 895742289) strcat(s, "U");
if (crc32("AnPkHHmeFgia",12) == 2698658916) strcat(s, "e");
if (crc32("bQOmVqnU",8) == 3066568866) strcat(s, "f");
if (crc32("pavhQEigl",9) == 946948814) strcat(s, "F");
if (crc32("vkAzuh",6) == 3920936740) strcat(s, "e");
if (crc32("zdodzq",6) == 1521930294) strcat(s, "g");
if (crc32("tqeVLzsQ",8) == 2023194186) strcat(s, "n");
if (crc32("VBwknZKTtxERSV",14) == 1756203462) strcat(s, "o");
if (crc32("IAHcZA",6) == 2847427213) strcat(s, "s");
if (crc32("LvgcSK",6) == 590500503) strcat(s, "i");
if (crc32("eVFhxQG",7) == 2800657437) strcat(s, "v");
if (crc32("BLkFpbBNUB",10) == 4008084217) strcat(s, "k");
if (crc32("QxigFHbhKm",10) == 964033012) strcat(s, "e");
if (crc32("PQuYC",5) == 183060968) strcat(s, "h");
if (crc32("rmHQMpGcEvI",11) == 4170984186) strcat(s, "l");
if (crc32("JDKVrrORAYmk",12) == 392412111) strcat(s, "L");
if (crc32("RgjEpTt",7) == 2664536772) strcat(s, "y");
    return s;
}

char *dissentingly_adverbs() {
    char *s = calloc(13);
    if (crc32("QhxAONjWUcIJU",13) == 576113864) strcat(s, "Z");
if (crc32("lAnoZV",6) == 4048114249) strcat(s, "d");
if (crc32("ewWXrKcggNyf",12) == 95284285) strcat(s, "i");
if (crc32("uPRVQwkr",8) == 605051488) strcat(s, "s");
if (crc32("HQKLnPtaJvF",11) == 2956408237) strcat(s, "s");
if (crc32("YJZvDMczNwozj",13) == 3534305356) strcat(s, "e");
if (crc32("ibKmSXShPqyRW",13) == 1707032185) strcat(s, "s");
if (crc32("lndnGAgcvKugzT",14) == 499084872) strcat(s, "k");
if (crc32("DiKSUo",6) == 2298963688) strcat(s, "e");
if (crc32("ctBdiLWnT",9) == 2345921291) strcat(s, "d");
if (crc32("RTVxNlvCKxPk",12) == 1485177539) strcat(s, "n");
if (crc32("EtvQn",5) == 3334215429) strcat(s, "Y");
if (crc32("hCLplcrYtMy",11) == 2826734351) strcat(s, "t");
if (crc32("bgWFYcrcupSRBW",14) == 4004483555) strcat(s, "i");
if (crc32("foKFsSytdvWVGHc",15) == 4137999689) strcat(s, "n");
if (crc32("RhpoOtYNEYRZ",12) == 3855704950) strcat(s, "L");
if (crc32("SXcKac",6) == 3468300088) strcat(s, "g");
if (crc32("MTRvOwCswG",10) == 3722935048) strcat(s, "l");
if (crc32("kdhgSfK",7) == 878230987) strcat(s, "y");
    return s;
}

char *supernumerously_adverbs() {
    char *s = calloc(16);
    if (crc32("VeEPRC",6) == 3133792201) strcat(s, "x");
if (crc32("VodkLYivEBzm",12) == 3314855181) strcat(s, "s");
if (crc32("QMCWWy",6) == 1005095132) strcat(s, "M");
if (crc32("ylBUWAjtZZJzp",13) == 2901319183) strcat(s, "u");
if (crc32("HqIyGHBrtPJQJHu",15) == 974346391) strcat(s, "N");
if (crc32("GuuVfCM",7) == 119054659) strcat(s, "p");
if (crc32("KOKdVLDXtsq",11) == 310650044) strcat(s, "e");
if (crc32("CHcUGoFtb",9) == 136123376) strcat(s, "r");
if (crc32("qZZYhZsefu",10) == 253613126) strcat(s, "E");
if (crc32("livXKbHcyLKtl",13) == 4085762015) strcat(s, "n");
if (crc32("magbHQ",6) == 1754568513) strcat(s, "u");
if (crc32("NMGnMsOeciBb",12) == 4101227567) strcat(s, "i");
if (crc32("LVjBCrscxrIKDw",14) == 3359924992) strcat(s, "m");
if (crc32("pCklyA",6) == 4152327940) strcat(s, "e");
if (crc32("UrvHCh",6) == 3329449436) strcat(s, "r");
if (crc32("KLTwGlEi",8) == 2969393309) strcat(s, "o");
if (crc32("CbbWNShWRpNja",13) == 1909868091) strcat(s, "m");
if (crc32("HegveSCTZXlGyP",14) == 3263607161) strcat(s, "u");
if (crc32("QNEwTeagsyuIK",13) == 83857956) strcat(s, "s");
if (crc32("xKdYFbwdlpYq",12) == 1244856807) strcat(s, "l");
if (crc32("vVbqzBFFIHsSgdQ",15) == 269006900) strcat(s, "I");
if (crc32("VDyxTsJGasP",11) == 665368203) strcat(s, "y");
    return s;
}

char *inconsumably_adverbs() {
    char *s = calloc(13);
    if (crc32("tdEzwnZJhAMBlx",14) == 3839293863) strcat(s, "l");
if (crc32("DGnRcdqKFdSPman",15) == 2206463703) strcat(s, "i");
if (crc32("dRvApLzC",8) == 362497021) strcat(s, "n");
if (crc32("sMPKNqsLYQqCzIi",15) == 610037062) strcat(s, "c");
if (crc32("WHkQGXZdByXaEU",14) == 1171971163) strcat(s, "u");
if (crc32("wPLibgrqJaVgG",13) == 771127033) strcat(s, "o");
if (crc32("IMDXbqgKxdoL",12) == 3524747069) strcat(s, "A");
if (crc32("XBslCEXmILcKh",13) == 2430125186) strcat(s, "n");
if (crc32("SsaMQVoDde",10) == 2671070433) strcat(s, "q");
if (crc32("AZhTtf",6) == 2109771295) strcat(s, "s");
if (crc32("CKryIS",6) == 1591902195) strcat(s, "u");
if (crc32("fDNVDnHAFYFRsXl",15) == 2295458483) strcat(s, "m");
if (crc32("wYrPOH",6) == 814411183) strcat(s, "a");
if (crc32("QUQYTrcdZbGdfo",14) == 2559799403) strcat(s, "r");
if (crc32("qqgEkzhIkMVeqNz",15) == 2372302360) strcat(s, "b");
if (crc32("MCebhxrA",8) == 2726747786) strcat(s, "b");
if (crc32("GHjcYCkveJb",11) == 4138833212) strcat(s, "l");
if (crc32("qNSukLkIZfo",11) == 224621030) strcat(s, "y");
    return s;
}

char *bradyauxetically_adverbs() {
    char *s = calloc(17);
    if (crc32("yjaOo",5) == 2239950032) strcat(s, "b");
if (crc32("CdmvzTTWcw",10) == 3609879572) strcat(s, "p");
if (crc32("TaGDLAtXFSom",12) == 798441217) strcat(s, "r");
if (crc32("YyzdAKztMZBXCo",14) == 918401256) strcat(s, "l");
if (crc32("evKdV",5) == 653445155) strcat(s, "a");
if (crc32("kRslRN",6) == 3648279666) strcat(s, "f");
if (crc32("AzYccLrMemrGyY",14) == 1303371226) strcat(s, "d");
if (crc32("CIHTaTopXtmArpl",15) == 3416982992) strcat(s, "y");
if (crc32("abHuTAFWg",9) == 3037920401) strcat(s, "u");
if (crc32("KFmdmGD",7) == 1493286940) strcat(s, "a");
if (crc32("CMztBZTcXgz",11) == 1622995038) strcat(s, "u");
if (crc32("YBHxCPfEvc",10) == 428352548) strcat(s, "F");
if (crc32("BOPjIuVymzanxw",14) == 3102726715) strcat(s, "x");
if (crc32("bInkvktU",8) == 2699534971) strcat(s, "e");
if (crc32("LXkMyT",6) == 4208003350) strcat(s, "j");
if (crc32("ELyuiyxYp",9) == 3450525741) strcat(s, "t");
if (crc32("caCxL",5) == 3219776214) strcat(s, "l");
if (crc32("XoSNUK",6) == 3473144362) strcat(s, "i");
if (crc32("VCCpkf",6) == 2435705228) strcat(s, "T");
if (crc32("WoQAdyTuQkOMr",13) == 3198721201) strcat(s, "c");
if (crc32("ZaXtmnKvUp",10) == 2173186304) strcat(s, "a");
if (crc32("GtLaJ",5) == 1539555907) strcat(s, "l");
if (crc32("IfROXXe",7) == 1055124176) strcat(s, "l");
if (crc32("lixynM",6) == 1550768918) strcat(s, "y");
    return s;
}

char *bisymmetrically_adverbs() {
    char *s = calloc(16);
    if (crc32("BOuUzenvfjWAvis",15) == 2978017807) strcat(s, "b");
if (crc32("QOVpqrnCL",9) == 3108223108) strcat(s, "M");
if (crc32("YwTuaZ",6) == 817632257) strcat(s, "i");
if (crc32("hefqHxUqWYHsL",13) == 507822307) strcat(s, "h");
if (crc32("fKkCrVcjFNOZN",13) == 3192391461) strcat(s, "s");
if (crc32("nplonvmJQyqkIz",14) == 268786662) strcat(s, "y");
if (crc32("JYORxwDOzrso",12) == 60753626) strcat(s, "m");
if (crc32("YwoHvL",6) == 1549181013) strcat(s, "y");
if (crc32("QhuwaU",6) == 3052050331) strcat(s, "m");
if (crc32("VoEYhlFa",8) == 3089082898) strcat(s, "E");
if (crc32("gZIfMnyErpHj",12) == 636957876) strcat(s, "e");
if (crc32("puDMeakiVQzXcVn",15) == 3139822163) strcat(s, "P");
if (crc32("xmNTaAFssT",10) == 1716655524) strcat(s, "t");
if (crc32("uYwxaGyVtjvYEvl",15) == 2499939067) strcat(s, "I");
if (crc32("bWQCXQBLOt",10) == 1098801700) strcat(s, "r");
if (crc32("kNMvnYuVAYvDjc",14) == 3186532873) strcat(s, "e");
if (crc32("KMrSAUwZxYK",11) == 1908330332) strcat(s, "i");
if (crc32("jeoLXfLM",8) == 2405737828) strcat(s, "c");
if (crc32("NUVZTlZbEjLKQ",13) == 3606101674) strcat(s, "k");
if (crc32("xEtLqsE",7) == 2541348394) strcat(s, "a");
if (crc32("xQBCHecMINBrEix",15) == 694779207) strcat(s, "l");
if (crc32("cMMYRe",6) == 159333791) strcat(s, "z");
if (crc32("sBvCtnsQhAXJIaz",15) == 3746876510) strcat(s, "l");
if (crc32("spTajgXzdb",10) == 3745090440) strcat(s, "i");
if (crc32("SaLdPggjG",9) == 92869043) strcat(s, "y");
    return s;
}

char *serfishly_adverbs() {
    char *s = calloc(10);
    if (crc32("wxaQOyXZz",9) == 2480567617) strcat(s, "E");
if (crc32("KXFMMRIYxOsj",12) == 597574406) strcat(s, "s");
if (crc32("ttYHT",5) == 1930738366) strcat(s, "a");
if (crc32("ejMdVA",6) == 4058200174) strcat(s, "e");
if (crc32("PqgXVKJX",8) == 2584084686) strcat(s, "r");
if (crc32("rcSioXkHzUW",11) == 1677234140) strcat(s, "p");
if (crc32("LgKUJPexJzMT",12) == 3888231620) strcat(s, "f");
if (crc32("SFOzTaQrSUHf",12) == 2468485054) strcat(s, "i");
if (crc32("QSZdTNTPuXlsQdT",15) == 2634542917) strcat(s, "d");
if (crc32("yFQxpGdkuew",11) == 2644635611) strcat(s, "s");
if (crc32("QEThiTbumsyxdT",14) == 469723963) strcat(s, "h");
if (crc32("peOHkLMXEUbo",12) == 3044468968) strcat(s, "n");
if (crc32("AKBaSkZgGb",10) == 421055523) strcat(s, "l");
if (crc32("dclgSEW",7) == 19628480) strcat(s, "F");
if (crc32("ZfpCZjrPxP",10) == 3840333949) strcat(s, "y");
    return s;
}

char *intelligibly_adverbs() {
    char *s = calloc(13);
    if (crc32("aTIRAGRkkwBfV",13) == 75193331) strcat(s, "J");
if (crc32("OnVcjyzsmPOPC",13) == 3318374216) strcat(s, "i");
if (crc32("OKZBgORc",8) == 3719562336) strcat(s, "n");
if (crc32("oszqAmJeWPGI",12) == 1275572850) strcat(s, "q");
if (crc32("CjZLbgVoJqFydA",14) == 1578285907) strcat(s, "t");
if (crc32("wlaUUvwfI",9) == 3466220359) strcat(s, "S");
if (crc32("PpLmOEeW",8) == 2650266010) strcat(s, "e");
if (crc32("SvBkhLxQgA",10) == 1076209948) strcat(s, "z");
if (crc32("xyzZUBAMwGkQNXG",15) == 2719010506) strcat(s, "l");
if (crc32("GwAeGQxXBj",10) == 2209740183) strcat(s, "l");
if (crc32("QWOSljLed",9) == 3607857999) strcat(s, "P");
if (crc32("cTComPKhuxB",11) == 3871998125) strcat(s, "i");
if (crc32("QmirsIonriDlMS",14) == 3156094737) strcat(s, "g");
if (crc32("WxEraBISG",9) == 3277979890) strcat(s, "a");
if (crc32("JcQrTZCkg",9) == 2126088037) strcat(s, "i");
if (crc32("fJcOEIFdENZg",12) == 1424279964) strcat(s, "a");
if (crc32("xndPQiMXtrnki",13) == 624944811) strcat(s, "b");
if (crc32("PZNVXXCOSfmXaKv",15) == 120777078) strcat(s, "l");
if (crc32("xlcMBTQyEK",10) == 882194662) strcat(s, "r");
if (crc32("ygpTrmPTPAd",11) == 2164032375) strcat(s, "y");
    return s;
}

char *totally_adverbs() {
    char *s = calloc(8);
    if (crc32("VfClfBs",7) == 712916741) strcat(s, "t");
if (crc32("wqEerlcpdsAap",13) == 3619212053) strcat(s, "e");
if (crc32("wfuoOuzmvsvHtp",14) == 3309048100) strcat(s, "o");
if (crc32("EnoYEDQjvOMh",12) == 3656374179) strcat(s, "t");
if (crc32("UmVlLgbmmVRV",12) == 4116036188) strcat(s, "a");
if (crc32("shSCwS",6) == 2890833642) strcat(s, "l");
if (crc32("qFVJqEEHFp",10) == 1353959614) strcat(s, "l");
if (crc32("UerkiMinJmxVtzU",15) == 240713974) strcat(s, "D");
if (crc32("BLRNscoCMxWpUFZ",15) == 1945492889) strcat(s, "y");
    return s;
}

char *nonreprehensibly_adverbs() {
    char *s = calloc(17);
    if (crc32("FowOaXnhFhU",11) == 3327601997) strcat(s, "n");
if (crc32("jCyVjaeI",8) == 2691671247) strcat(s, "n");
if (crc32("PpCiioHSnCwYo",13) == 208715266) strcat(s, "o");
if (crc32("XqEUSeIPF",9) == 739055808) strcat(s, "n");
if (crc32("DhgzHQHT",8) == 2974266053) strcat(s, "r");
if (crc32("thePMBSfOd",10) == 229037795) strcat(s, "o");
if (crc32("hSnoncbVyyNxUx",14) == 3236889640) strcat(s, "e");
if (crc32("dbvri",5) == 3758887456) strcat(s, "y");
if (crc32("FJxAIqQp",8) == 2831403160) strcat(s, "p");
if (crc32("doxWuvsqxmCy",12) == 185602561) strcat(s, "Q");
if (crc32("VhxKVFzEjm",10) == 1512358267) strcat(s, "r");
if (crc32("rwVYpExHQ",9) == 3732617089) strcat(s, "e");
if (crc32("WrJDNGaXNzCPad",14) == 2533297975) strcat(s, "h");
if (crc32("DYfQcSsi",8) == 3530788587) strcat(s, "e");
if (crc32("OjnnfiX",7) == 3865969012) strcat(s, "n");
if (crc32("wkrMNtYgGq",10) == 3519450006) strcat(s, "B");
if (crc32("TpSbH",5) == 565735140) strcat(s, "s");
if (crc32("xwvTppWOXHq",11) == 1582711168) strcat(s, "P");
if (crc32("OdQpAfh",7) == 3549434873) strcat(s, "i");
if (crc32("zjMmVAOOxpPB",12) == 3090164581) strcat(s, "h");
if (crc32("tEyEPNedOcwJWsN",15) == 3459092944) strcat(s, "b");
if (crc32("GhgmfeAv",8) == 2683313329) strcat(s, "X");
if (crc32("cdjiHmvPoTgbQM",14) == 491014758) strcat(s, "l");
if (crc32("fikdfkp",7) == 1030796476) strcat(s, "C");
if (crc32("vIBDlaDVXi",10) == 1346354715) strcat(s, "y");
    return s;
}

char *dallyingly_adverbs() {
    char *s = calloc(11);
    if (crc32("kIOWiKH",7) == 3782239550) strcat(s, "K");
if (crc32("cEZyo",5) == 4137764767) strcat(s, "d");
if (crc32("gzUxDssymflSk",13) == 1935061688) strcat(s, "P");
if (crc32("qZhjXEY",7) == 2057906563) strcat(s, "a");
if (crc32("ZIChHkNB",8) == 3167965863) strcat(s, "l");
if (crc32("BUqOapLEiN",10) == 722143147) strcat(s, "l");
if (crc32("nBNWtnyVsVx",11) == 1848402946) strcat(s, "y");
if (crc32("lzCnLOrupcM",11) == 1111884965) strcat(s, "i");
if (crc32("PtIRdvVRJ",9) == 2026354803) strcat(s, "n");
if (crc32("dLUeEHPAHR",10) == 3077952523) strcat(s, "E");
if (crc32("pXeOpokvyaGv",12) == 930380984) strcat(s, "g");
if (crc32("XZBdxsCPEx",10) == 3631016628) strcat(s, "R");
if (crc32("qLMbF",5) == 1667508980) strcat(s, "l");
if (crc32("CFGWVA",6) == 818843387) strcat(s, "h");
if (crc32("qLBVmdLEbQMGPXY",15) == 1711969922) strcat(s, "y");
    return s;
}

char *nonmonistically_adverbs() {
    char *s = calloc(16);
    if (crc32("ImwVWsusnzzn",12) == 495933701) strcat(s, "C");
if (crc32("BPDNOxnjkjHRxB",14) == 4274886261) strcat(s, "n");
if (crc32("iDiBSvXNJhIQQS",14) == 731336586) strcat(s, "o");
if (crc32("HYpQr",5) == 3006134273) strcat(s, "M");
if (crc32("VWIlkBkTIFUHmA",14) == 2730579293) strcat(s, "n");
if (crc32("FvtbOBCTNbyKl",13) == 4289965603) strcat(s, "D");
if (crc32("rqrxUQKU",8) == 3609271677) strcat(s, "m");
if (crc32("SLOYYpqjCIeJFh",14) == 1592579127) strcat(s, "o");
if (crc32("GbSKkVWaxEN",11) == 1073495739) strcat(s, "T");
if (crc32("wmHbSaCPNYnN",12) == 2058653615) strcat(s, "n");
if (crc32("YGCOxhyBbLvMzU",14) == 3569181466) strcat(s, "C");
if (crc32("OjqQOlHg",8) == 379088709) strcat(s, "i");
if (crc32("pHuCEeAhNgtnM",13) == 2451255405) strcat(s, "s");
if (crc32("MQqsvfCr",8) == 2546398715) strcat(s, "o");
if (crc32("LmSdcMsXGBWSN",13) == 4278876336) strcat(s, "t");
if (crc32("wQGLJZmNArgZh",13) == 2468117045) strcat(s, "e");
if (crc32("qciYyUnksJEptX",14) == 2492379725) strcat(s, "i");
if (crc32("KljAJ",5) == 2732216002) strcat(s, "c");
if (crc32("vKqlkQUQXmKr",12) == 1412708599) strcat(s, "a");
if (crc32("PJcbP",5) == 2091494695) strcat(s, "l");
if (crc32("RgdPUZx",7) == 647430108) strcat(s, "k");
if (crc32("MqXgD",5) == 2355145725) strcat(s, "l");
if (crc32("dlhZZ",5) == 1950053562) strcat(s, "m");
if (crc32("pIfzF",5) == 3755590190) strcat(s, "y");
    return s;
}

char *stalkingly_adverbs() {
    char *s = calloc(11);
    if (crc32("NdJHzk",6) == 2647864753) strcat(s, "V");
if (crc32("dDLjGUyVO",9) == 657962469) strcat(s, "s");
if (crc32("cJvxHvrxj",9) == 1750087193) strcat(s, "t");
if (crc32("IotZqBDUxj",10) == 4176587388) strcat(s, "G");
if (crc32("RJvDMlhlKIoSBk",14) == 2249035328) strcat(s, "a");
if (crc32("MzpNQuV",7) == 1790276638) strcat(s, "o");
if (crc32("DufqNivZKjVhez",14) == 4252695558) strcat(s, "l");
if (crc32("ahvbhOSxV",9) == 3889719414) strcat(s, "f");
if (crc32("gXQJCwpOnvzXhVD",15) == 795491535) strcat(s, "k");
if (crc32("miGiJTV",7) == 3587830942) strcat(s, "i");
if (crc32("wPbLWplgsfrGEV",14) == 4118428037) strcat(s, "C");
if (crc32("KxLDh",5) == 3916825081) strcat(s, "n");
if (crc32("LCuMiLHaxGGa",12) == 1139946997) strcat(s, "m");
if (crc32("NFEUxuAcOukb",12) == 3014084805) strcat(s, "g");
if (crc32("QphTHgEMFQtYS",13) == 3518681325) strcat(s, "l");
if (crc32("gVLSelQr",8) == 3726968719) strcat(s, "m");
if (crc32("ElLyXvgbOZHzSp",14) == 2506821720) strcat(s, "y");
    return s;
}

char *grumpily_adverbs() {
    char *s = calloc(9);
    if (crc32("pCQLV",5) == 3554777274) strcat(s, "r");
if (crc32("SiRvEPVk",8) == 1636194900) strcat(s, "g");
if (crc32("heDozYjYxmvItaB",15) == 3396192209) strcat(s, "g");
if (crc32("BVQHzBZZS",9) == 3002063170) strcat(s, "r");
if (crc32("JdCIIxAULGsbqmP",15) == 2395978605) strcat(s, "u");
if (crc32("wyHeJeiSTljDn",13) == 2687641369) strcat(s, "U");
if (crc32("gdqwweCdF",9) == 2104160789) strcat(s, "m");
if (crc32("JTkTUOiZ",8) == 4172176114) strcat(s, "g");
if (crc32("Tobcle",6) == 311554131) strcat(s, "p");
if (crc32("WKvOS",5) == 3590028444) strcat(s, "i");
if (crc32("ZBPELCeP",8) == 1043501555) strcat(s, "l");
if (crc32("nStmmpneFuWANZ",14) == 1650371358) strcat(s, "k");
if (crc32("zefoCr",6) == 1915772717) strcat(s, "y");
    return s;
}

char *defectively_adverbs() {
    char *s = calloc(12);
    if (crc32("gxftiRrnADczA",13) == 1489261547) strcat(s, "d");
if (crc32("WgKgJ",5) == 599414368) strcat(s, "S");
if (crc32("xBBQZJyrjgHDnMm",15) == 394125205) strcat(s, "e");
if (crc32("DWXTTVOhxRtU",12) == 4013902292) strcat(s, "X");
if (crc32("WPlWNooZ",8) == 3179969642) strcat(s, "f");
if (crc32("nZITGAtCSZOPjzV",15) == 536715201) strcat(s, "W");
if (crc32("hbfnTnuoeswDK",13) == 1232252653) strcat(s, "e");
if (crc32("PHwHPLwfaHGc",12) == 1657480160) strcat(s, "f");
if (crc32("JGpoaSKm",8) == 2172464194) strcat(s, "c");
if (crc32("HaueVPEBY",9) == 2744961732) strcat(s, "t");
if (crc32("AcOmriyCD",9) == 1785151906) strcat(s, "s");
if (crc32("PstHctBferWMv",13) == 3554124688) strcat(s, "i");
if (crc32("QJqBkBL",7) == 3313322442) strcat(s, "m");
if (crc32("pBihHdLWEpdm",12) == 2792616136) strcat(s, "v");
if (crc32("TjAeEDLguN",10) == 3467504314) strcat(s, "m");
if (crc32("WFAzvBldeZtY",12) == 2267453579) strcat(s, "e");
if (crc32("XaRbwcFhw",9) == 3079115098) strcat(s, "l");
if (crc32("IfDPXMDhuRNubln",15) == 459719779) strcat(s, "y");
    return s;
}

char *corroboratorily_adverbs() {
    char *s = calloc(16);
    if (crc32("CDkvntznIfEvT",13) == 2852288106) strcat(s, "h");
if (crc32("TqglVbIACq",10) == 1889694730) strcat(s, "c");
if (crc32("nSLuBz",6) == 233341449) strcat(s, "o");
if (crc32("VEKKEgRGigB",11) == 429235566) strcat(s, "r");
if (crc32("JcRVrDCPqf",10) == 3297471922) strcat(s, "r");
if (crc32("SRsZjdYJeJXqCDQ",15) == 99856964) strcat(s, "o");
if (crc32("jUlHF",5) == 2649168185) strcat(s, "R");
if (crc32("YqkQvSZov",9) == 2204306660) strcat(s, "b");
if (crc32("lQqGCaLfZQ",10) == 3847462308) strcat(s, "h");
if (crc32("YQXGshvDT",9) == 1268564770) strcat(s, "o");
if (crc32("lUWuLaeedMNuVH",14) == 467277504) strcat(s, "e");
if (crc32("ZGRPTNVeMoZbLM",14) == 3003757987) strcat(s, "r");
if (crc32("LjwyH",5) == 347230737) strcat(s, "e");
if (crc32("fHZNviTJGr",10) == 4226023077) strcat(s, "a");
if (crc32("CHgtSd",6) == 2127392265) strcat(s, "t");
if (crc32("ScfmXU",6) == 1824340495) strcat(s, "X");
if (crc32("vabxWtzzxW",10) == 1280890195) strcat(s, "o");
if (crc32("vKPoKFqXO",9) == 167230783) strcat(s, "E");
if (crc32("XBusJlonNVNMLT",14) == 2480857058) strcat(s, "r");
if (crc32("GPjhPgCquEECfR",14) == 453294083) strcat(s, "i");
if (crc32("YOlwb",5) == 1545079339) strcat(s, "v");
if (crc32("jnAQocEOGEG",11) == 4130243859) strcat(s, "l");
if (crc32("ClqPsAyPy",9) == 532040922) strcat(s, "O");
if (crc32("LyXJCMcJJzAYb",13) == 872671421) strcat(s, "y");
    return s;
}

char *rompishly_adverbs() {
    char *s = calloc(10);
    if (crc32("Ohwob",5) == 775944511) strcat(s, "u");
if (crc32("ouQnh",5) == 1422437611) strcat(s, "r");
if (crc32("mUCxsQxwgbgMi",13) == 3421817550) strcat(s, "S");
if (crc32("yoYZxmgcFTrcVT",14) == 2966581754) strcat(s, "o");
if (crc32("YWerLTgxWMw",11) == 3092579930) strcat(s, "m");
if (crc32("kHECfzS",7) == 1480950460) strcat(s, "r");
if (crc32("wOqfl",5) == 1815568540) strcat(s, "p");
if (crc32("nLKxFNyLAAtvw",13) == 3972886693) strcat(s, "i");
if (crc32("LpRJIxvgepTEaJO",15) == 103398261) strcat(s, "s");
if (crc32("ZoHDKhDYt",9) == 491114107) strcat(s, "c");
if (crc32("FeNQAHFRltbaRN",14) == 3863179330) strcat(s, "h");
if (crc32("AdyRxXSc",8) == 404454464) strcat(s, "l");
if (crc32("utwDOxn",7) == 3659655628) strcat(s, "y");
    return s;
}

char *gyrostatically_adverbs() {
    char *s = calloc(15);
    if (crc32("axbfMlgIpCpJ",12) == 699211037) strcat(s, "B");
if (crc32("TCwOYv",6) == 1723836695) strcat(s, "g");
if (crc32("mEVmOZfU",8) == 158392988) strcat(s, "y");
if (crc32("gNOzuzJGg",9) == 3316054102) strcat(s, "a");
if (crc32("PBcNwUjQdscGUA",14) == 2936804079) strcat(s, "r");
if (crc32("LcfoGLDA",8) == 19898759) strcat(s, "p");
if (crc32("piLho",5) == 1886865049) strcat(s, "o");
if (crc32("fRwCniD",7) == 1910011676) strcat(s, "s");
if (crc32("iGORVTQNLGZvXnj",15) == 1020060188) strcat(s, "R");
if (crc32("IRltqJVpNlcx",12) == 433403376) strcat(s, "t");
if (crc32("tvEZk",5) == 135486258) strcat(s, "d");
if (crc32("HSSkRdriuG",10) == 1712588770) strcat(s, "a");
if (crc32("fPmIHhgUFofu",12) == 16230664) strcat(s, "k");
if (crc32("UigayG",6) == 2147636730) strcat(s, "t");
if (crc32("PlPhoCBiLnBGpL",14) == 1291136146) strcat(s, "i");
if (crc32("TJMtVNUNd",9) == 3830014437) strcat(s, "B");
if (crc32("ZkEROVsuwt",10) == 323365014) strcat(s, "c");
if (crc32("VvuCOsYFNVE",11) == 1954469308) strcat(s, "s");
if (crc32("GKiAPWrJOOKAcMO",15) == 1184175823) strcat(s, "a");
if (crc32("wOhUCBvUEAp",11) == 2730538043) strcat(s, "a");
if (crc32("hgiOdgVytlS",11) == 292050982) strcat(s, "l");
if (crc32("qERFsFNo",8) == 864782619) strcat(s, "G");
if (crc32("vPFpMsmbJVTHEz",14) == 15014286) strcat(s, "l");
if (crc32("dnjoCDuxcIB",11) == 155826275) strcat(s, "y");
    return s;
}

char *unargumentatively_adverbs() {
    char *s = calloc(18);
    if (crc32("inXwfQ",6) == 3371680454) strcat(s, "u");
if (crc32("rCLqkwuRCXa",11) == 364101531) strcat(s, "n");
if (crc32("wUbHOkKwoem",11) == 184012420) strcat(s, "a");
if (crc32("xLRbjGnSJSBSebI",15) == 396106660) strcat(s, "A");
if (crc32("EIuLmzojG",9) == 3541407420) strcat(s, "r");
if (crc32("VMqpE",5) == 4026407115) strcat(s, "i");
if (crc32("CxgmwEsPyLpQwcZ",15) == 1011196046) strcat(s, "g");
if (crc32("wdVxAR",6) == 3732886139) strcat(s, "u");
if (crc32("fdwVTUlabUTpH",13) == 2001690426) strcat(s, "u");
if (crc32("XxyVbnvDlJbad",13) == 911915985) strcat(s, "m");
if (crc32("gtReiGZk",8) == 3121791602) strcat(s, "L");
if (crc32("JrgVKwldcg",10) == 2737389771) strcat(s, "e");
if (crc32("PHYpgpU",7) == 3306965691) strcat(s, "Q");
if (crc32("RtqHNwMXt",9) == 2009117517) strcat(s, "n");
if (crc32("cBANzzJDWQwTFh",14) == 859712610) strcat(s, "t");
if (crc32("lFGBxCh",7) == 2405495660) strcat(s, "c");
if (crc32("PjWwGByrnVishNj",15) == 2641192430) strcat(s, "a");
if (crc32("HYQUFwfWO",9) == 794024087) strcat(s, "V");
if (crc32("UdeGuhwsQ",9) == 3353240209) strcat(s, "t");
if (crc32("ixNSYb",6) == 1126807331) strcat(s, "S");
if (crc32("pligXF",6) == 4808955) strcat(s, "i");
if (crc32("pusIiaZFklzkoQ",14) == 1743877005) strcat(s, "v");
if (crc32("rzDepJcXOr",10) == 2606101211) strcat(s, "e");
if (crc32("rFMOSGQkNZTNpLx",15) == 1412215050) strcat(s, "l");
if (crc32("pyOfXPw",7) == 408295580) strcat(s, "g");
if (crc32("TFMQMdNPUTjapbE",15) == 49456615) strcat(s, "y");
    return s;
}

char *nonamenably_adverbs() {
    char *s = calloc(12);
    if (crc32("rKkbrYVtaeW",11) == 1082355977) strcat(s, "n");
if (crc32("BGArm",5) == 1219148620) strcat(s, "h");
if (crc32("wBAKurBNvdQc",12) == 3289984140) strcat(s, "o");
if (crc32("DJsbeMe",7) == 3788094163) strcat(s, "c");
if (crc32("EUWnVLohg",9) == 3769520880) strcat(s, "n");
if (crc32("wgkYamY",7) == 1917081056) strcat(s, "a");
if (crc32("MfjleunTtrEXY",13) == 2858102624) strcat(s, "z");
if (crc32("EsPnJV",6) == 1375672997) strcat(s, "m");
if (crc32("xBTGrmVFBI",10) == 3603323609) strcat(s, "e");
if (crc32("uibkJsgxcSr",11) == 1333700537) strcat(s, "M");
if (crc32("tBmedCdMaN",10) == 3550386014) strcat(s, "n");
if (crc32("MBxHGbkpGcQw",12) == 3371080069) strcat(s, "u");
if (crc32("qKnBmZcAQg",10) == 1581720009) strcat(s, "a");
if (crc32("lLeeiWNannMc",12) == 468670953) strcat(s, "b");
if (crc32("biafrooFdDpc",12) == 1889939939) strcat(s, "E");
if (crc32("DfbVACQsDOWQM",13) == 3276291432) strcat(s, "l");
if (crc32("vdrXZ",5) == 543585394) strcat(s, "n");
if (crc32("WHAJFzRRtCNsQNh",15) == 3516590023) strcat(s, "y");
    return s;
}

char *undeeply_adverbs() {
    char *s = calloc(9);
    if (crc32("ghRyDO",6) == 2774102246) strcat(s, "d");
if (crc32("bCqrxGIP",8) == 1357761550) strcat(s, "u");
if (crc32("EgBeyeRC",8) == 3689914105) strcat(s, "J");
if (crc32("tXrflZ",6) == 3867683258) strcat(s, "n");
if (crc32("mMrsdXKxc",9) == 577064177) strcat(s, "d");
if (crc32("smMcPpTmuct",11) == 1991242671) strcat(s, "A");
if (crc32("vfCwHjxqkFEhIp",14) == 2724093572) strcat(s, "e");
if (crc32("OTsxM",5) == 3836799790) strcat(s, "k");
if (crc32("VujFtJnwHXKL",12) == 2905496065) strcat(s, "e");
if (crc32("OUlZQeraK",9) == 1630378020) strcat(s, "s");
if (crc32("eTtDOLM",7) == 3837692001) strcat(s, "p");
if (crc32("mcbbO",5) == 1611264022) strcat(s, "M");
if (crc32("xOKIgOcXffyM",12) == 1117855828) strcat(s, "l");
if (crc32("sTHoXl",6) == 3668619559) strcat(s, "y");
    return s;
}

char *fleshlily_adverbs() {
    char *s = calloc(10);
    if (crc32("vQjxZj",6) == 1620059921) strcat(s, "h");
if (crc32("lQRkkeoMQOZB",12) == 1364551054) strcat(s, "f");
if (crc32("cbOTPWoKTrJziA",14) == 704515613) strcat(s, "l");
if (crc32("vtRizm",6) == 511291355) strcat(s, "Z");
if (crc32("rJDvwcfwZvkiu",13) == 1250712378) strcat(s, "e");
if (crc32("OFVGSDzyhCI",11) == 1166168993) strcat(s, "E");
if (crc32("BInKqXpmgVdbhr",14) == 2815740468) strcat(s, "s");
if (crc32("XtjyzAhQMhB",11) == 928117897) strcat(s, "h");
if (crc32("uqbevZDqgkGLjYu",15) == 158781372) strcat(s, "l");
if (crc32("cIocEUAnShaA",12) == 2099903022) strcat(s, "Q");
if (crc32("sxNPFjRa",8) == 3694941326) strcat(s, "i");
if (crc32("MQECcOxF",8) == 953341531) strcat(s, "l");
if (crc32("IKeEGLmglZkGg",13) == 1911426869) strcat(s, "s");
if (crc32("cjgkKCJ",7) == 2029692940) strcat(s, "y");
    return s;
}

char *plutocratically_adverbs() {
    char *s = calloc(16);
    if (crc32("oeydcX",6) == 1799063897) strcat(s, "p");
if (crc32("AyXTHTcccbjRHu",14) == 2495655545) strcat(s, "k");
if (crc32("RlWLQvVp",8) == 764835727) strcat(s, "l");
if (crc32("UsBOxIZyM",9) == 1770828352) strcat(s, "u");
if (crc32("jAKgtTHvcp",10) == 2102939606) strcat(s, "K");
if (crc32("DqxfYWWFJWsvi",13) == 3035832937) strcat(s, "t");
if (crc32("KeIntnnhn",9) == 1743425497) strcat(s, "m");
if (crc32("xeuaJVd",7) == 1934194567) strcat(s, "o");
if (crc32("oyhRSQxSYMOn",12) == 4019001771) strcat(s, "c");
if (crc32("lBUcpHeufPO",11) == 3749021585) strcat(s, "r");
if (crc32("JCCUviXpLEhNn",13) == 993322040) strcat(s, "a");
if (crc32("YItSxexblALy",12) == 912800592) strcat(s, "k");
if (crc32("LjSzMEq",7) == 517471701) strcat(s, "t");
if (crc32("oxGIeVMvekhs",12) == 1521333107) strcat(s, "i");
if (crc32("LKGsVuomsJyfS",13) == 2012050861) strcat(s, "c");
if (crc32("jDuRMIH",7) == 1470828356) strcat(s, "a");
if (crc32("YSiOJFFVsuDXKul",15) == 1768365418) strcat(s, "l");
if (crc32("QIaJFieyjVDsgqi",15) == 2574985529) strcat(s, "e");
if (crc32("NQIVx",5) == 2669988961) strcat(s, "l");
if (crc32("VLCHePvJnGvM",12) == 2755950776) strcat(s, "R");
if (crc32("zWqrAJvk",8) == 833837) strcat(s, "y");
    return s;
}

char *quasiclerically_adverbs() {
    char *s = calloc(16);
    if (crc32("lJWndy",6) == 3765213280) strcat(s, "q");
if (crc32("YmdpVDWTo",9) == 287958189) strcat(s, "C");
if (crc32("IQMYOR",6) == 1685187249) strcat(s, "u");
if (crc32("iDqvWFWV",8) == 1262310381) strcat(s, "l");
if (crc32("AKqltwEKm",9) == 3260797893) strcat(s, "a");
if (crc32("FMJgVp",6) == 422461644) strcat(s, "A");
if (crc32("IalfhsznbJWADlk",15) == 31586529) strcat(s, "s");
if (crc32("QqIXxJY",7) == 843868941) strcat(s, "S");
if (crc32("USgXpWpCnR",10) == 3684019541) strcat(s, "i");
if (crc32("jOvrIVUQIfAJIJ",14) == 250548606) strcat(s, "j");
if (crc32("OjeSGX",6) == 616882474) strcat(s, "c");
if (crc32("uDTwObThltCVpif",15) == 4090033173) strcat(s, "a");
if (crc32("LiGipNQtbFO",11) == 3698786667) strcat(s, "l");
if (crc32("biDHNBR",7) == 1615065070) strcat(s, "e");
if (crc32("NOfOhOtwQ",9) == 1398007588) strcat(s, "r");
if (crc32("ftwnuZkGHGcnpug",15) == 158009414) strcat(s, "e");
if (crc32("CeZZP",5) == 2677906937) strcat(s, "i");
if (crc32("PpHToP",6) == 4169505209) strcat(s, "c");
if (crc32("JvCPtxsW",8) == 97641816) strcat(s, "t");
if (crc32("xlERnlwMlccI",12) == 1659394437) strcat(s, "a");
if (crc32("LgYhTWRFjBmD",12) == 1330417381) strcat(s, "X");
if (crc32("dXDxOwAddeO",11) == 419873695) strcat(s, "l");
if (crc32("qXoIPZmsxj",10) == 1007970212) strcat(s, "h");
if (crc32("loVYElqpcapDjq",14) == 1316876186) strcat(s, "l");
if (crc32("FOiSzXwxiSMsi",13) == 3450404502) strcat(s, "z");
if (crc32("NzxFOhEHoahz",12) == 3192549964) strcat(s, "y");
    return s;
}

char *fructiferously_adverbs() {
    char *s = calloc(15);
    if (crc32("qPzNyrhU",8) == 2618325155) strcat(s, "f");
if (crc32("Zthsd",5) == 1490354768) strcat(s, "r");
if (crc32("sJtNeSKBgTKlbnU",15) == 921828959) strcat(s, "Q");
if (crc32("KUhWYXmP",8) == 1631461904) strcat(s, "u");
if (crc32("iOgwZdieA",9) == 3502390538) strcat(s, "I");
if (crc32("iuacaMtbrjLzg",13) == 2649045762) strcat(s, "c");
if (crc32("TdjXZAtszTUyn",13) == 2885469438) strcat(s, "t");
if (crc32("wHGTRJuN",8) == 678910217) strcat(s, "d");
if (crc32("rIzVvDvh",8) == 1155891364) strcat(s, "i");
if (crc32("bflGFrofKDF",11) == 900922153) strcat(s, "f");
if (crc32("ZjzBzEvKd",9) == 1548759099) strcat(s, "e");
if (crc32("UVnTCDEXkRGIw",13) == 3540356978) strcat(s, "r");
if (crc32("utJlRiPAunzZHjr",15) == 154468797) strcat(s, "C");
if (crc32("mRatGBx",7) == 2667609437) strcat(s, "o");
if (crc32("ddIgh",5) == 2083904797) strcat(s, "S");
if (crc32("tZigREOYb",9) == 3647293341) strcat(s, "u");
if (crc32("yBTjHPGzWGrSW",13) == 1149899190) strcat(s, "s");
if (crc32("xiYnXtRXPat",11) == 2362064197) strcat(s, "k");
if (crc32("CivtVbesub",10) == 2252414013) strcat(s, "l");
if (crc32("nqiMldGSxmRFY",13) == 1920288385) strcat(s, "F");
if (crc32("ydQroWYunfsiD",13) == 3357562617) strcat(s, "y");
    return s;
}

char *overcompetitively_adverbs() {
    char *s = calloc(18);
    if (crc32("KiIcYyeqROiyQQX",15) == 2552092921) strcat(s, "o");
if (crc32("GuTufraVFYYpOQ",14) == 367954124) strcat(s, "x");
if (crc32("djOODiWdDgFFa",13) == 4086614469) strcat(s, "v");
if (crc32("xTekxl",6) == 1128778678) strcat(s, "A");
if (crc32("FbjkvnwXnXcvlb",14) == 1193291200) strcat(s, "e");
if (crc32("jkRKfLzrnJivI",13) == 2564882675) strcat(s, "r");
if (crc32("VjJENMISWsr",11) == 1775130437) strcat(s, "p");
if (crc32("XrKlibWUvfG",11) == 643086298) strcat(s, "c");
if (crc32("qRDUD",5) == 2725966031) strcat(s, "o");
if (crc32("RxVpRisPCIw",11) == 2575412889) strcat(s, "N");
if (crc32("FRYvKIsqYoRr",12) == 1837702325) strcat(s, "m");
if (crc32("fXUnQy",6) == 2452744116) strcat(s, "c");
if (crc32("CMKSnOvyAom",11) == 756798447) strcat(s, "p");
if (crc32("YClKPyGluD",10) == 476561138) strcat(s, "e");
if (crc32("aENwxVSBLPLgXpZ",15) == 1556144022) strcat(s, "t");
if (crc32("dfSki",5) == 189216995) strcat(s, "c");
if (crc32("ZQkmlWfTC",9) == 3529685562) strcat(s, "i");
if (crc32("ajmGjIYeNKgHk",13) == 747479824) strcat(s, "X");
if (crc32("FBkAn",5) == 661052568) strcat(s, "t");
if (crc32("DtWZyupsyoE",11) == 1037388365) strcat(s, "i");
if (crc32("BtYtM",5) == 252542337) strcat(s, "d");
if (crc32("euVCydXP",8) == 3323809035) strcat(s, "v");
if (crc32("MEVjewQDZxeaL",13) == 996738045) strcat(s, "e");
if (crc32("JCdHVn",6) == 909550368) strcat(s, "E");
if (crc32("CokPmncclu",10) == 2747569886) strcat(s, "l");
if (crc32("MEQmmmSzcJUv",12) == 994015682) strcat(s, "y");
    return s;
}

char *quasipractically_adverbs() {
    char *s = calloc(17);
    if (crc32("PcYaUv",6) == 3798218990) strcat(s, "q");
if (crc32("FtLmJwTLhVT",11) == 4122898108) strcat(s, "u");
if (crc32("ITdhmtEtmMPise",14) == 920236914) strcat(s, "y");
if (crc32("guwRQzvQva",10) == 1813022391) strcat(s, "a");
if (crc32("lvFqBnjYyFMrHa",14) == 2175660293) strcat(s, "O");
if (crc32("zSzNeGzgatplqP",14) == 1360748408) strcat(s, "s");
if (crc32("UvWWYTNxTCTFDC",14) == 1002401013) strcat(s, "i");
if (crc32("EWWOgoyzaZT",11) == 4149018094) strcat(s, "D");
if (crc32("BhiDYRHzvBdvTOe",15) == 2560867700) strcat(s, "p");
if (crc32("YhAHe",5) == 1880115268) strcat(s, "W");
if (crc32("BbVFtLAeE",9) == 2941501845) strcat(s, "r");
if (crc32("hYAjJRzyBsRSA",13) == 3071496928) strcat(s, "a");
if (crc32("mrQTs",5) == 471060647) strcat(s, "c");
if (crc32("unJQKt",6) == 287124424) strcat(s, "t");
if (crc32("HgPhgNWxJKxvfmn",15) == 4014865713) strcat(s, "g");
if (crc32("eVNeP",5) == 1886597506) strcat(s, "i");
if (crc32("gTiRUogAmWoGgqQ",15) == 2298145302) strcat(s, "F");
if (crc32("rKZJLe",6) == 1621235263) strcat(s, "c");
if (crc32("AeJge",5) == 3307266420) strcat(s, "a");
if (crc32("BhjCen",6) == 3470246155) strcat(s, "l");
if (crc32("noyWGa",6) == 3660337535) strcat(s, "z");
if (crc32("MoVrTUu",7) == 3143732986) strcat(s, "l");
if (crc32("pfowXUwqEryUjg",14) == 3603191077) strcat(s, "a");
if (crc32("rovGvXpDTc",10) == 3131565986) strcat(s, "y");
    return s;
}

char *uptodately_adverbs() {
    char *s = calloc(11);
    if (crc32("tlcTNQnOgzZmfE",14) == 167208795) strcat(s, "k");
if (crc32("IGvme",5) == 687159678) strcat(s, "u");
if (crc32("bQyvCONLguRtC",13) == 2138841112) strcat(s, "p");
if (crc32("YRMLSOzpq",9) == 2669863228) strcat(s, "t");
if (crc32("uQEPjYpBauv",11) == 498390501) strcat(s, "o");
if (crc32("nNisrqhwKJJsYx",14) == 3698147458) strcat(s, "d");
if (crc32("lDBbUsSY",8) == 3657792227) strcat(s, "a");
if (crc32("JztXsHyQiJ",10) == 610146152) strcat(s, "h");
if (crc32("AoGhW",5) == 3976912652) strcat(s, "t");
if (crc32("QsxjVCARs",9) == 3644608647) strcat(s, "e");
if (crc32("ocAGxPRO",8) == 1421452162) strcat(s, "l");
if (crc32("bcSSYTIIRiDvM",13) == 2035782269) strcat(s, "y");
    return s;
}

char *antispiritually_adverbs() {
    char *s = calloc(16);
    if (crc32("GIsYg",5) == 3546640783) strcat(s, "v");
if (crc32("JzrRUcj",7) == 3162043153) strcat(s, "a");
if (crc32("GADLryFzlxzrRx",14) == 1082478954) strcat(s, "n");
if (crc32("ANkcOr",6) == 4250523875) strcat(s, "t");
if (crc32("sHVOoYSFFfZSB",13) == 1652678708) strcat(s, "i");
if (crc32("HsubtcSO",8) == 603874556) strcat(s, "s");
if (crc32("AWcya",5) == 2075285495) strcat(s, "p");
if (crc32("GQeztgEEWtfaZ",13) == 1125606349) strcat(s, "i");
if (crc32("yFDgN",5) == 1210165401) strcat(s, "F");
if (crc32("DZggKSytsVba",12) == 3823636008) strcat(s, "r");
if (crc32("pngukNZXzXNWwZV",15) == 1101514738) strcat(s, "i");
if (crc32("TCkxWkkRNGn",11) == 3351566971) strcat(s, "E");
if (crc32("gIiSENSSEgBLZeN",15) == 2355938126) strcat(s, "t");
if (crc32("RsmYVxr",7) == 3006663753) strcat(s, "H");
if (crc32("EUxWzM",6) == 73492176) strcat(s, "u");
if (crc32("bBlEhpOQdaAhRW",14) == 2211150436) strcat(s, "a");
if (crc32("JXBNWmBLei",10) == 3256290264) strcat(s, "O");
if (crc32("rdSftYAEWuPyVI",14) == 1716922473) strcat(s, "l");
if (crc32("DpUFjdUtXatymRS",15) == 2093827231) strcat(s, "v");
if (crc32("qExGJveOEFan",12) == 2265329786) strcat(s, "l");
if (crc32("wWgqfhfwoWiQ",12) == 4183063417) strcat(s, "r");
if (crc32("AzDRSZm",7) == 74681958) strcat(s, "y");
    return s;
}

char *quasidiscreetly_adverbs() {
    char *s = calloc(16);
    if (crc32("doZMbrXc",8) == 562601541) strcat(s, "q");
if (crc32("BNoTg",5) == 1007320859) strcat(s, "C");
if (crc32("yyJIrHYzWwlc",12) == 2803196524) strcat(s, "u");
if (crc32("RwmvvzCx",8) == 3469431093) strcat(s, "j");
if (crc32("mimew",5) == 2001395558) strcat(s, "a");
if (crc32("EsDhXFZdQAfe",12) == 1836215289) strcat(s, "X");
if (crc32("RINiUWyvxHj",11) == 3856362852) strcat(s, "s");
if (crc32("foYfYsESDDK",11) == 1896195288) strcat(s, "L");
if (crc32("hZxzTzqfI",9) == 284128886) strcat(s, "i");
if (crc32("hkCwG",5) == 2036183816) strcat(s, "d");
if (crc32("cOerqfPRA",9) == 2010362706) strcat(s, "s");
if (crc32("PEenEeueTUHaHct",15) == 4226841849) strcat(s, "i");
if (crc32("LgTBdDuknQf",11) == 3019211076) strcat(s, "s");
if (crc32("dXdJxZRLeWs",11) == 2458006589) strcat(s, "g");
if (crc32("aslVbEtYOZ",10) == 2105549293) strcat(s, "c");
if (crc32("mXChmuU",7) == 3928737124) strcat(s, "u");
if (crc32("gRMqiPii",8) == 3606167987) strcat(s, "r");
if (crc32("ZCXNjhzB",8) == 2355367694) strcat(s, "e");
if (crc32("AGxArQviuBCE",12) == 3548695651) strcat(s, "e");
if (crc32("psAItbetHtB",11) == 2356324874) strcat(s, "j");
if (crc32("rYUHQYUIRXJbh",13) == 2746591793) strcat(s, "t");
if (crc32("EbuNvnAtJmJJzxU",15) == 312833968) strcat(s, "l");
if (crc32("PiqXvCJdrOShm",13) == 3244811176) strcat(s, "y");
    return s;
}

char *pseudofamously_adverbs() {
    char *s = calloc(15);
    if (crc32("rQHcutRVei",10) == 1174948747) strcat(s, "e");
if (crc32("FzFhGMunS",9) == 1843840618) strcat(s, "p");
if (crc32("oQSOnIN",7) == 3690794286) strcat(s, "q");
if (crc32("cQdUYHjmdhZdik",14) == 3820032991) strcat(s, "s");
if (crc32("DAgdyPFsvSI",11) == 90188262) strcat(s, "e");
if (crc32("PbPzTQXhT",9) == 2455125896) strcat(s, "u");
if (crc32("ewoqATh",7) == 685980991) strcat(s, "b");
if (crc32("yEmFRO",6) == 3729364968) strcat(s, "d");
if (crc32("irfkRQRsX",9) == 1445661335) strcat(s, "p");
if (crc32("maslFGBfAUe",11) == 37506345) strcat(s, "o");
if (crc32("UjfOjBCVxhnss",13) == 3150091264) strcat(s, "f");
if (crc32("AcmlLYWk",8) == 1395859777) strcat(s, "u");
if (crc32("ssioFzso",8) == 2430763321) strcat(s, "a");
if (crc32("tscuWMNrBrH",11) == 3691857759) strcat(s, "m");
if (crc32("noRrsSKrGZUQpZl",15) == 2428992994) strcat(s, "F");
if (crc32("NyPXv",5) == 2423182278) strcat(s, "o");
if (crc32("BZfMaLGXfNVPM",13) == 885595348) strcat(s, "u");
if (crc32("MbqILdnXqZjPvIL",15) == 2703853888) strcat(s, "s");
if (crc32("GWVhDxT",7) == 3103328846) strcat(s, "l");
if (crc32("BFhANKtcnz",10) == 3391921752) strcat(s, "y");
    return s;
}

char *galleywest_adverbs() {
    char *s = calloc(11);
    if (crc32("tdYvtDIaqCS",11) == 1865175902) strcat(s, "g");
if (crc32("uUUqu",5) == 38379554) strcat(s, "f");
if (crc32("zTfoOQaNGpzN",12) == 1696515764) strcat(s, "a");
if (crc32("jTMOymHXrASInuL",15) == 2145112159) strcat(s, "l");
if (crc32("umuGQnyWBj",10) == 3404133574) strcat(s, "l");
if (crc32("dLfjSsgwaAJkIVM",15) == 639172554) strcat(s, "N");
if (crc32("nfxOGcPpJBTbD",13) == 3048161633) strcat(s, "e");
if (crc32("FgWrv",5) == 2696332500) strcat(s, "Q");
if (crc32("QjBNPr",6) == 3929761829) strcat(s, "y");
if (crc32("hpyojDPPQW",10) == 3942253173) strcat(s, "w");
if (crc32("kVgRAKBaG",9) == 3223895856) strcat(s, "S");
if (crc32("RuKDeAi",7) == 3666654163) strcat(s, "e");
if (crc32("yMInC",5) == 2992785217) strcat(s, "R");
if (crc32("AXFpzYEEoBPXEjy",15) == 3960073756) strcat(s, "s");
if (crc32("vUodJ",5) == 2557515730) strcat(s, "t");
    return s;
}

char *noncomprehendingly_adverbs() {
    char *s = calloc(19);
    if (crc32("ASpLt",5) == 626850772) strcat(s, "n");
if (crc32("ygtisTjOiyEkFAv",15) == 95472582) strcat(s, "o");
if (crc32("ffIdzStCopuX",12) == 3355076466) strcat(s, "n");
if (crc32("QYMUmkXg",8) == 632091108) strcat(s, "c");
if (crc32("vHfAniCqS",9) == 1696390522) strcat(s, "o");
if (crc32("DIkrT",5) == 1963616584) strcat(s, "W");
if (crc32("HHilVdyz",8) == 1947373806) strcat(s, "m");
if (crc32("HswpzJMYF",9) == 1212062906) strcat(s, "p");
if (crc32("OzUyVGhTh",9) == 386155769) strcat(s, "I");
if (crc32("nTdnYyOiDFN",11) == 1527606965) strcat(s, "r");
if (crc32("MInpuwyQKS",10) == 1498263076) strcat(s, "e");
if (crc32("OytOKAtyY",9) == 19768097) strcat(s, "h");
if (crc32("HfsmZwOupgb",11) == 2466576121) strcat(s, "e");
if (crc32("KelLt",5) == 3980780233) strcat(s, "b");
if (crc32("qMkupYrIOBi",11) == 719922120) strcat(s, "n");
if (crc32("SdZQTKqZAINkVYd",15) == 3498368500) strcat(s, "T");
if (crc32("TqUbOvLvkE",10) == 1021272190) strcat(s, "d");
if (crc32("aLOuVLBkbPzUEK",14) == 1000594442) strcat(s, "i");
if (crc32("RllaKWEBzDPy",12) == 3737671839) strcat(s, "W");
if (crc32("YyLiJUWP",8) == 3125588786) strcat(s, "n");
if (crc32("iYnxQXn",7) == 2505839020) strcat(s, "g");
if (crc32("oTbqNmwxtIFm",12) == 2986319480) strcat(s, "K");
if (crc32("yoWowbIebm",10) == 1896635754) strcat(s, "l");
if (crc32("wPsiGXFoBGn",11) == 2832679146) strcat(s, "i");
if (crc32("eRdqi",5) == 3143645886) strcat(s, "y");
    return s;
}

char *babyishly_adverbs() {
    char *s = calloc(10);
    if (crc32("kxUnvdyMUphfHc",14) == 3280645543) strcat(s, "b");
if (crc32("wKCYmDWawcBD",12) == 887536849) strcat(s, "a");
if (crc32("NwHdLmgXBNno",12) == 3261200211) strcat(s, "q");
if (crc32("yqYBakNriDFfS",13) == 3045565926) strcat(s, "b");
if (crc32("xErJbu",6) == 990919098) strcat(s, "F");
if (crc32("tdJXzEDLORWV",12) == 89278986) strcat(s, "y");
if (crc32("fGPgiWaJyDUlC",13) == 3485263033) strcat(s, "E");
if (crc32("LZswFKhZ",8) == 3202072839) strcat(s, "i");
if (crc32("IdBxRtqjzblaw",13) == 298406322) strcat(s, "U");
if (crc32("rlCPHTvmtuKbI",13) == 4118378053) strcat(s, "s");
if (crc32("qtrwYIlIBIKSaK",14) == 174973961) strcat(s, "h");
if (crc32("lwkHIsYKPBkmjq",14) == 406773391) strcat(s, "l");
if (crc32("FzWUJsOIzfwblvj",15) == 961319131) strcat(s, "y");
if (crc32("SsSDWIW",7) == 3563397476) strcat(s, "y");
    return s;
}

char *effervescingly_adverbs() {
    char *s = calloc(15);
    if (crc32("gSbwM",5) == 398995806) strcat(s, "e");
if (crc32("uRxXZe",6) == 425096712) strcat(s, "f");
if (crc32("BFGogss",7) == 3780498107) strcat(s, "V");
if (crc32("rnKaecZsKn",10) == 294293029) strcat(s, "f");
if (crc32("DmkIhMsWYHQwi",13) == 1259159060) strcat(s, "r");
if (crc32("QzhrWuydk",9) == 369124434) strcat(s, "e");
if (crc32("BohpVbzoBClN",12) == 1214499583) strcat(s, "H");
if (crc32("AeQxVC",6) == 242432896) strcat(s, "r");
if (crc32("HxUTpTnrYD",10) == 56363085) strcat(s, "e");
if (crc32("WegzGkVkzLW",11) == 1074790549) strcat(s, "v");
if (crc32("FCKqCYXFw",9) == 2927082782) strcat(s, "R");
if (crc32("oaJHHtmxkGUurSQ",15) == 3452636622) strcat(s, "e");
if (crc32("BaymomIqVvtk",12) == 4223321702) strcat(s, "w");
if (crc32("JHGxQOXfFWMw",12) == 2068646140) strcat(s, "s");
if (crc32("vrWXpABXaYCVIx",14) == 3210538579) strcat(s, "c");
if (crc32("iksSthJ",7) == 3742539962) strcat(s, "v");
if (crc32("wUKAPXYUkWUWPq",14) == 3070774579) strcat(s, "i");
if (crc32("QasqhMkCsUy",11) == 2436410983) strcat(s, "n");
if (crc32("UXwwPBMz",8) == 2015329243) strcat(s, "g");
if (crc32("HyOuUj",6) == 2258158436) strcat(s, "V");
if (crc32("VFNrnxbJjHPsjO",14) == 3217152394) strcat(s, "l");
if (crc32("vSrChZXP",8) == 3257518117) strcat(s, "y");
    return s;
}

char *bowingly_adverbs() {
    char *s = calloc(9);
    if (crc32("EIognftPiLPAIu",14) == 4017210266) strcat(s, "b");
if (crc32("mLmNJetEcqmRrF",14) == 809367942) strcat(s, "o");
if (crc32("SCnGsWiewXytw",13) == 3565736809) strcat(s, "t");
if (crc32("htVDELcWO",9) == 3854429912) strcat(s, "w");
if (crc32("cwZCghNwFT",10) == 2692666920) strcat(s, "i");
if (crc32("axBXoghJYLutH",13) == 275877194) strcat(s, "n");
if (crc32("PoAiYrK",7) == 3403113619) strcat(s, "P");
if (crc32("oROXOt",6) == 2346864907) strcat(s, "g");
if (crc32("SVANXgnrtDLh",12) == 3174423902) strcat(s, "X");
if (crc32("ophtMEBsdfybdU",14) == 1513747524) strcat(s, "l");
if (crc32("BWQUgBcQqq",10) == 3852371872) strcat(s, "y");
    return s;
}

char *nonterritorially_adverbs() {
    char *s = calloc(17);
    if (crc32("axrMWwikVvH",11) == 860370415) strcat(s, "t");
if (crc32("pzaIC",5) == 3154711131) strcat(s, "n");
if (crc32("LJPYcAUMa",9) == 3476333459) strcat(s, "s");
if (crc32("bvxxphPL",8) == 3199063031) strcat(s, "o");
if (crc32("EAMxv",5) == 3285049173) strcat(s, "C");
if (crc32("PIotiHSHfnWzR",13) == 2566501710) strcat(s, "n");
if (crc32("rGNvNmPJnO",10) == 3884426159) strcat(s, "t");
if (crc32("kwtcHQ",6) == 302220344) strcat(s, "e");
if (crc32("EpARVSKgEWNMoz",14) == 1692955162) strcat(s, "r");
if (crc32("wqsabGqv",8) == 3421799838) strcat(s, "r");
if (crc32("fKpKHdYAOczV",12) == 1077124182) strcat(s, "c");
if (crc32("pfLEdqVXIoRevsA",15) == 1740994457) strcat(s, "i");
if (crc32("LWONLfAsCxPMzTH",15) == 2388721004) strcat(s, "t");
if (crc32("yjkcCUKL",8) == 1596037577) strcat(s, "G");
if (crc32("nhlQhEViybUJ",12) == 2839171342) strcat(s, "o");
if (crc32("AEsoUhaNS",9) == 4070628166) strcat(s, "C");
if (crc32("kUxvbP",6) == 3780500161) strcat(s, "r");
if (crc32("VjIZuyQdxkbM",12) == 481593556) strcat(s, "i");
if (crc32("KBfJxFomWQ",10) == 4207575772) strcat(s, "E");
if (crc32("CASfqYXb",8) == 3709114864) strcat(s, "a");
if (crc32("AbggCjHEwKQqVff",15) == 244668528) strcat(s, "l");
if (crc32("JnkCRgakbYNMnw",14) == 4142966601) strcat(s, "l");
if (crc32("FFpYjj",6) == 2237094899) strcat(s, "y");
    return s;
}

char *semisolemnly_adverbs() {
    char *s = calloc(13);
    if (crc32("jKzfNXJfD",9) == 3319117311) strcat(s, "A");
if (crc32("TLBqNFs",7) == 3606543570) strcat(s, "s");
if (crc32("fLKQZkgGubzWUyv",15) == 3132487098) strcat(s, "e");
if (crc32("eChxSdvYrkL",11) == 242304763) strcat(s, "I");
if (crc32("ypbmO",5) == 616334234) strcat(s, "m");
if (crc32("RSqqxifH",8) == 3338515132) strcat(s, "i");
if (crc32("YJCckJmoSdSrrS",14) == 2186968138) strcat(s, "s");
if (crc32("sjGeuRrX",8) == 1624567962) strcat(s, "o");
if (crc32("UZZiXkFyVSg",11) == 2105283755) strcat(s, "l");
if (crc32("AjuOzO",6) == 2999992488) strcat(s, "e");
if (crc32("uVtOvtV",7) == 2314849448) strcat(s, "E");
if (crc32("oPCowWXiXCPmnOs",15) == 2719836358) strcat(s, "m");
if (crc32("qcnpChzASe",10) == 1083172592) strcat(s, "v");
if (crc32("sWOrvuPmQjSL",12) == 2838369087) strcat(s, "n");
if (crc32("SBDMgFlllNGjC",13) == 2893193624) strcat(s, "l");
if (crc32("aPAMt",5) == 1085258610) strcat(s, "E");
if (crc32("nDhNMoewwBY",11) == 3755617095) strcat(s, "y");
    return s;
}

char *tunefully_adverbs() {
    char *s = calloc(10);
    if (crc32("cbWTNDZ",7) == 3495738812) strcat(s, "i");
if (crc32("WtyacaojNrK",11) == 904779736) strcat(s, "t");
if (crc32("fEsfB",5) == 2170087275) strcat(s, "u");
if (crc32("MmzfjApN",8) == 1241208098) strcat(s, "o");
if (crc32("oCZDBnLhBho",11) == 373410904) strcat(s, "n");
if (crc32("KnvDqZxwwMwQi",13) == 469173336) strcat(s, "e");
if (crc32("RqCvYJmTqIx",11) == 2281760798) strcat(s, "x");
if (crc32("wtUXLN",6) == 4167251667) strcat(s, "f");
if (crc32("zZtEFAby",8) == 1854037133) strcat(s, "u");
if (crc32("SCWVRTkByTXvbH",14) == 4190635356) strcat(s, "g");
if (crc32("ecTyARsUZg",10) == 530486665) strcat(s, "l");
if (crc32("ETdFVxcQUPOWk",13) == 2412863040) strcat(s, "l");
if (crc32("AiQZWxtpr",9) == 2756009861) strcat(s, "P");
if (crc32("ohfTbEgVN",9) == 1719735593) strcat(s, "y");
    return s;
}

char *ungodlily_adverbs() {
    char *s = calloc(10);
    if (crc32("YKUWQzxtcpHZKT",14) == 2024545760) strcat(s, "J");
if (crc32("LcprIS",6) == 4166618761) strcat(s, "u");
if (crc32("bWuHaVo",7) == 1673154254) strcat(s, "R");
if (crc32("cXQNqn",6) == 2723845304) strcat(s, "n");
if (crc32("PktEFxBFe",9) == 3484780466) strcat(s, "g");
if (crc32("HEiZrSDJGiAqXEi",15) == 1146596316) strcat(s, "o");
if (crc32("LlScfYmHmFbD",12) == 3300843679) strcat(s, "d");
if (crc32("JfwjFaBKFGZ",11) == 2629062188) strcat(s, "l");
if (crc32("oExXyBYU",8) == 3204005381) strcat(s, "G");
if (crc32("BySgZuQMZyb",11) == 4062400060) strcat(s, "i");
if (crc32("BduUNMV",7) == 3837434323) strcat(s, "c");
if (crc32("uyEiPCFabxkW",12) == 794688531) strcat(s, "l");
if (crc32("cfRCeLEBbs",10) == 4294546809) strcat(s, "v");
if (crc32("wxAKUYzzABCH",12) == 65853563) strcat(s, "y");
    return s;
}

char *unstealthily_adverbs() {
    char *s = calloc(13);
    if (crc32("RfywaA",6) == 3695325329) strcat(s, "u");
if (crc32("RFSxrINsGUW",11) == 1656882080) strcat(s, "Y");
if (crc32("amcQtbaOPNc",11) == 3462728139) strcat(s, "n");
if (crc32("uzaYh",5) == 3818445382) strcat(s, "w");
if (crc32("UxYyxoPsTIcHnM",14) == 1045316116) strcat(s, "s");
if (crc32("rxzsNwCAIuXZY",13) == 18791968) strcat(s, "h");
if (crc32("KRyxf",5) == 2417114400) strcat(s, "t");
if (crc32("CdxncQno",8) == 2798972138) strcat(s, "v");
if (crc32("zLegWBCQhc",10) == 1118109951) strcat(s, "e");
if (crc32("DWgpvFx",7) == 3557800181) strcat(s, "a");
if (crc32("YkPViXSisXyao",13) == 777390872) strcat(s, "c");
if (crc32("fOnDehiWHAb",11) == 1319586177) strcat(s, "l");
if (crc32("nGtBeaH",7) == 2510857746) strcat(s, "U");
if (crc32("GFVgXsSAxfh",11) == 931992934) strcat(s, "t");
if (crc32("xRlZcitevpv",11) == 1519046188) strcat(s, "D");
if (crc32("nBjqVNBJR",9) == 3336412507) strcat(s, "h");
if (crc32("YrAVaHznxjHVG",13) == 3334059856) strcat(s, "i");
if (crc32("sqAGkuAl",8) == 833729916) strcat(s, "V");
if (crc32("SRzxktMh",8) == 3501932247) strcat(s, "l");
if (crc32("JpyvksAAscqpio",14) == 229885609) strcat(s, "y");
    return s;
}

char *nontyrannously_adverbs() {
    char *s = calloc(15);
    if (crc32("RrZeWRMrDpE",11) == 1592100420) strcat(s, "n");
if (crc32("cITOO",5) == 2453204633) strcat(s, "X");
if (crc32("pTkUU",5) == 3822102412) strcat(s, "o");
if (crc32("EaEgNlSpXRzTC",13) == 2791865881) strcat(s, "b");
if (crc32("UjfKrNGDUal",11) == 498075717) strcat(s, "n");
if (crc32("KRaLrgTcbslEUS",14) == 2978223267) strcat(s, "t");
if (crc32("qRakqnefPjDjQQ",14) == 3872167500) strcat(s, "x");
if (crc32("KxwWKF",6) == 248914553) strcat(s, "y");
if (crc32("ommWDd",6) == 1529140816) strcat(s, "u");
if (crc32("syeCSJzpeTYi",12) == 761046829) strcat(s, "r");
if (crc32("jHSfuwTHdvDtB",13) == 2664839375) strcat(s, "a");
if (crc32("WNOruTkz",8) == 4059886576) strcat(s, "h");
if (crc32("utefp",5) == 1056119743) strcat(s, "n");
if (crc32("BwMWfdzZR",9) == 267988257) strcat(s, "U");
if (crc32("UTNbxOmmXC",10) == 2584824060) strcat(s, "n");
if (crc32("VulfOf",6) == 3032305016) strcat(s, "o");
if (crc32("qwOrtmJ",7) == 3479430143) strcat(s, "u");
if (crc32("XlqRHbWqiXR",11) == 1234377752) strcat(s, "s");
if (crc32("iYjXsxxppKqKOQN",15) == 575523056) strcat(s, "U");
if (crc32("QvoNKjVrD",9) == 3733077084) strcat(s, "l");
if (crc32("SMxHNsXMzL",10) == 3242480716) strcat(s, "y");
    return s;
}

char *connivently_adverbs() {
    char *s = calloc(12);
    if (crc32("vpBrgkzgCFzBKX",14) == 3265676251) strcat(s, "c");
if (crc32("lfIuBnvArYSIJA",14) == 2747317019) strcat(s, "o");
if (crc32("NFtrk",5) == 3282025808) strcat(s, "c");
if (crc32("ikEcYoCsfsG",11) == 717124178) strcat(s, "n");
if (crc32("XEzVKodzzF",10) == 2036947823) strcat(s, "n");
if (crc32("bGZVYhFaazwA",12) == 1170550119) strcat(s, "v");
if (crc32("OcxTdm",6) == 1727179230) strcat(s, "i");
if (crc32("jGXMAzmUc",9) == 2643040899) strcat(s, "v");
if (crc32("puxqDCi",7) == 857713964) strcat(s, "m");
if (crc32("mSTkk",5) == 1239705725) strcat(s, "e");
if (crc32("QEZqcZxdsAGU",12) == 3365101971) strcat(s, "B");
if (crc32("ikVaZLYZEOiXUP",14) == 240781794) strcat(s, "n");
if (crc32("AxxERS",6) == 508636068) strcat(s, "t");
if (crc32("nyPVE",5) == 1895608410) strcat(s, "l");
if (crc32("JZGFcQyHhEYQHuq",15) == 60714161) strcat(s, "y");
    return s;
}

char *scarcely_adverbs() {
    char *s = calloc(9);
    if (crc32("rYmiXYxPWX",10) == 497345812) strcat(s, "s");
if (crc32("HzILZrSyCM",10) == 908178834) strcat(s, "L");
if (crc32("YmNwUH",6) == 1851750920) strcat(s, "c");
if (crc32("doUrYfCXYrlZ",12) == 2464372756) strcat(s, "a");
if (crc32("BCwpx",5) == 1307571658) strcat(s, "r");
if (crc32("wQUwGeoloedfa",13) == 418821225) strcat(s, "w");
if (crc32("IoxNpGSwpPE",11) == 244334515) strcat(s, "c");
if (crc32("Avlzy",5) == 1344344836) strcat(s, "e");
if (crc32("koCATGeUoTsxYDt",15) == 1268730991) strcat(s, "b");
if (crc32("FvBDHXgVuDZ",11) == 3963790078) strcat(s, "l");
if (crc32("wqxeowHSotrUMol",15) == 3047189968) strcat(s, "p");
if (crc32("DOBKVdHKYCp",11) == 4194195238) strcat(s, "y");
    return s;
}

char *pivotally_adverbs() {
    char *s = calloc(10);
    if (crc32("Aztnzp",6) == 3848647077) strcat(s, "p");
if (crc32("qazybiSjbmI",11) == 3521493781) strcat(s, "R");
if (crc32("vShhRcOdvQZNA",13) == 1583881705) strcat(s, "i");
if (crc32("yhmPJPfSlNgsK",13) == 3411580192) strcat(s, "W");
if (crc32("GjEuoBYCpu",10) == 2576643522) strcat(s, "v");
if (crc32("QXmChgX",7) == 3083097422) strcat(s, "y");
if (crc32("lNKlFDytzlhRPvQ",15) == 105772737) strcat(s, "o");
if (crc32("ndFnCpfw",8) == 3117686) strcat(s, "t");
if (crc32("KSRGsLTaMTmVj",13) == 80383817) strcat(s, "a");
if (crc32("gnWmWEnzS",9) == 1059665180) strcat(s, "t");
if (crc32("uasetEhpVrVS",12) == 3642768787) strcat(s, "l");
if (crc32("rfVZOjkFKRUZzr",14) == 2048949953) strcat(s, "d");
if (crc32("fTxhihlsv",9) == 3040150639) strcat(s, "l");
if (crc32("imKBjQjU",8) == 3133001196) strcat(s, "y");
    return s;
}

char *unfailingly_adverbs() {
    char *s = calloc(12);
    if (crc32("BMXFkfVP",8) == 866415615) strcat(s, "a");
if (crc32("yzmEAsNJFY",10) == 430048710) strcat(s, "u");
if (crc32("jcizjeP",7) == 1021313773) strcat(s, "d");
if (crc32("uIbRIulatqO",11) == 894454886) strcat(s, "n");
if (crc32("liMQrxld",8) == 975933963) strcat(s, "k");
if (crc32("HeGiP",5) == 148437499) strcat(s, "f");
if (crc32("ovevVeVrUbbhi",13) == 456989714) strcat(s, "a");
if (crc32("rjJSWDJ",7) == 3510625832) strcat(s, "V");
if (crc32("DJeANHd",7) == 4192903421) strcat(s, "i");
if (crc32("TKnIPmVIDj",10) == 3727888064) strcat(s, "l");
if (crc32("LGGKoLgkXDAmeE",14) == 2157440898) strcat(s, "G");
if (crc32("LLjyi",5) == 87093349) strcat(s, "i");
if (crc32("QLGnuuLhlgbHsi",14) == 3977310494) strcat(s, "n");
if (crc32("FncfWdsNWhp",11) == 3443705116) strcat(s, "g");
if (crc32("BTbmCVgMHSvvAm",14) == 883995273) strcat(s, "l");
if (crc32("oRary",5) == 3246498643) strcat(s, "y");
    return s;
}

char *suspensively_adverbs() {
    char *s = calloc(13);
    if (crc32("kiNSTaQDPLFV",12) == 3263829126) strcat(s, "s");
if (crc32("ZvfxVlocnSMDD",13) == 2966893466) strcat(s, "z");
if (crc32("kEwvxRlYixtqHm",14) == 538882724) strcat(s, "u");
if (crc32("DbglOpNEakM",11) == 1381711477) strcat(s, "s");
if (crc32("taLwftyA",8) == 32473788) strcat(s, "H");
if (crc32("UzwPlZFIwoifoNh",15) == 4073801808) strcat(s, "p");
if (crc32("sKfvb",5) == 2672778845) strcat(s, "g");
if (crc32("ahDNchNzgDotb",13) == 1489006737) strcat(s, "e");
if (crc32("LSydapukQq",10) == 1183741254) strcat(s, "n");
if (crc32("inXHkicIObpQQQY",15) == 1420497731) strcat(s, "g");
if (crc32("FXrrQG",6) == 3187384535) strcat(s, "s");
if (crc32("mYOSCnMWPl",10) == 2854111980) strcat(s, "i");
if (crc32("nAouQXvXKAPxYQW",15) == 403996777) strcat(s, "o");
if (crc32("RyojUekZAtr",11) == 1685992235) strcat(s, "v");
if (crc32("piDgfiSkoqW",11) == 4181858565) strcat(s, "D");
if (crc32("hyHQJ",5) == 846675044) strcat(s, "e");
if (crc32("fQfbZga",7) == 1151846238) strcat(s, "l");
if (crc32("wtasvrznfWn",11) == 4150487240) strcat(s, "R");
if (crc32("jweJiUdEAeWQ",12) == 734410828) strcat(s, "y");
    return s;
}

char *lewdly_adverbs() {
    char *s = calloc(7);
    if (crc32("MvbGB",5) == 1152152213) strcat(s, "l");
if (crc32("kBSxi",5) == 4063956095) strcat(s, "k");
if (crc32("NYpPdWPlAalKZ",13) == 2474876577) strcat(s, "e");
if (crc32("iBmFwvIZWQSTOAd",15) == 2371293831) strcat(s, "w");
if (crc32("PThhwy",6) == 2167317378) strcat(s, "d");
if (crc32("SAgWfRpEaHs",11) == 3636702362) strcat(s, "l");
if (crc32("KBcFbFTBRQNres",14) == 1268063014) strcat(s, "K");
if (crc32("qxGow",5) == 4123704995) strcat(s, "y");
    return s;
}

char *untempestuously_adverbs() {
    char *s = calloc(16);
    if (crc32("IApie",5) == 4290366901) strcat(s, "p");
if (crc32("xnerRnnab",9) == 4082018369) strcat(s, "u");
if (crc32("mSWecsOXRjhYi",13) == 1899100512) strcat(s, "n");
if (crc32("iwszujKe",8) == 2322141212) strcat(s, "t");
if (crc32("aYnuiVPgutQQlUj",15) == 2837385897) strcat(s, "e");
if (crc32("PTAalgJjU",9) == 3457090848) strcat(s, "G");
if (crc32("TtQDb",5) == 3040569135) strcat(s, "m");
if (crc32("EiyBQgKBns",10) == 3941330356) strcat(s, "p");
if (crc32("umuuLZ",6) == 1532927140) strcat(s, "B");
if (crc32("omCEfgGKXhgCa",13) == 3974085786) strcat(s, "e");
if (crc32("wBOaIOA",7) == 2793099713) strcat(s, "s");
if (crc32("bGgAoUlcNZRX",12) == 2487411738) strcat(s, "t");
if (crc32("VlYCqIit",8) == 2765475302) strcat(s, "R");
if (crc32("kKcBCtPjrPjyvG",14) == 3679395376) strcat(s, "u");
if (crc32("myRTwmEa",8) == 3669300692) strcat(s, "o");
if (crc32("QrIopcExtmETS",13) == 1586479249) strcat(s, "u");
if (crc32("WGmRVJtIkTxOiOm",15) == 3929083719) strcat(s, "s");
if (crc32("XNTjHWDe",8) == 2615236210) strcat(s, "f");
if (crc32("WodJI",5) == 1696349908) strcat(s, "l");
if (crc32("eFmxpRTzP",9) == 1606932644) strcat(s, "y");
    return s;
}

char *bionomically_adverbs() {
    char *s = calloc(13);
    if (crc32("SDLRDCxeRckazSh",15) == 4226963826) strcat(s, "b");
if (crc32("DDJAVZdDfFZrgcg",15) == 593250993) strcat(s, "i");
if (crc32("FQRZERfmS",9) == 1412365394) strcat(s, "o");
if (crc32("UTXwxUOe",8) == 3895991076) strcat(s, "E");
if (crc32("SNeEAk",6) == 2511385436) strcat(s, "n");
if (crc32("NBGuso",6) == 725966165) strcat(s, "o");
if (crc32("qCRYDWzewoiRQ",13) == 2111079213) strcat(s, "m");
if (crc32("cPtTg",5) == 2370066693) strcat(s, "i");
if (crc32("LudNY",5) == 2792720945) strcat(s, "y");
if (crc32("YCrzqUXSWeC",11) == 2803325317) strcat(s, "c");
if (crc32("qoCHuRM",7) == 3187164005) strcat(s, "a");
if (crc32("OmXVyOUnPDxQD",13) == 507214004) strcat(s, "l");
if (crc32("kQWpHmbHnI",10) == 2237566752) strcat(s, "l");
if (crc32("wvAIRMJIqBK",11) == 1931427741) strcat(s, "P");
if (crc32("jqvAemiUGHTt",12) == 3895796212) strcat(s, "y");
    return s;
}

char *yep_adverbs() {
    char *s = calloc(4);
    if (crc32("mSFzdSJjOJ",10) == 2540776374) strcat(s, "y");
if (crc32("rAZQapyu",8) == 3367257497) strcat(s, "e");
if (crc32("hHdawvwq",8) == 3340201620) strcat(s, "p");
    return s;
}

char *orad_adverbs() {
    char *s = calloc(5);
    if (crc32("VgjFKqBpTDCk",12) == 223544191) strcat(s, "o");
if (crc32("AJtLBoCS",8) == 2832742133) strcat(s, "G");
if (crc32("fkDONcdm",8) == 3082092697) strcat(s, "r");
if (crc32("ItSFbPBkufuW",12) == 3453624363) strcat(s, "a");
if (crc32("hwERdOswJInMd",13) == 2451773000) strcat(s, "d");
    return s;
}

char *already_adverbs() {
    char *s = calloc(8);
    if (crc32("ojtsEEwyIXK",11) == 197636338) strcat(s, "P");
if (crc32("gSPGtHkfwFO",11) == 188538227) strcat(s, "a");
if (crc32("akXMHyujg",9) == 3810959925) strcat(s, "l");
if (crc32("AYKtXzDaTZvgP",13) == 2674288979) strcat(s, "c");
if (crc32("xZDUgVX",7) == 2056754443) strcat(s, "r");
if (crc32("ZpkBsoO",7) == 161142396) strcat(s, "h");
if (crc32("iSiqQbLz",8) == 2265771932) strcat(s, "e");
if (crc32("HMXtYQtN",8) == 295736802) strcat(s, "Q");
if (crc32("rKuvgYwOuNCC",12) == 1737996419) strcat(s, "a");
if (crc32("kQwzwfGBNebHKVU",15) == 1480374523) strcat(s, "d");
if (crc32("mcrxzKDaEalBxFZ",15) == 1264730475) strcat(s, "y");
    return s;
}

char *watchfully_adverbs() {
    char *s = calloc(11);
    if (crc32("FGEqKKbvOhc",11) == 2345614232) strcat(s, "m");
if (crc32("XAcVNmden",9) == 2045571478) strcat(s, "w");
if (crc32("DLlEERV",7) == 3647926908) strcat(s, "a");
if (crc32("ljCroSVotf",10) == 4186386390) strcat(s, "t");
if (crc32("kxUhXMdGGcnos",13) == 1300848230) strcat(s, "C");
if (crc32("TNaZTHxyQP",10) == 473775913) strcat(s, "c");
if (crc32("GLsOjXMUprGZO",13) == 797300521) strcat(s, "h");
if (crc32("dKZtUro",7) == 3143287466) strcat(s, "K");
if (crc32("VLOfJ",5) == 2128315553) strcat(s, "f");
if (crc32("alxYRe",6) == 211040774) strcat(s, "p");
if (crc32("UbpOYBo",7) == 4013382634) strcat(s, "u");
if (crc32("zSpsZpEqDJwdvy",14) == 207135458) strcat(s, "Y");
if (crc32("DcroJA",6) == 1919538887) strcat(s, "l");
if (crc32("aRiOizoScyjJ",12) == 3190586737) strcat(s, "l");
if (crc32("GlSRslVbwIY",11) == 3851137995) strcat(s, "y");
    return s;
}

char *dioptrically_adverbs() {
    char *s = calloc(13);
    if (crc32("aoPOJXNwxox",11) == 2936692720) strcat(s, "d");
if (crc32("vnlhj",5) == 717699567) strcat(s, "i");
if (crc32("RNcxHR",6) == 1560538817) strcat(s, "a");
if (crc32("yJRnOcwjdYtvZMB",15) == 2619321411) strcat(s, "o");
if (crc32("elXuiKJ",7) == 2916378966) strcat(s, "p");
if (crc32("MJNOugn",7) == 3763033866) strcat(s, "t");
if (crc32("fRdmJHFZp",9) == 2105278905) strcat(s, "N");
if (crc32("TSWZMQpnk",9) == 4282674895) strcat(s, "r");
if (crc32("qXyoHRRBrMzXh",13) == 4050655832) strcat(s, "i");
if (crc32("UuuAcuqlxMTucZ",14) == 3444402197) strcat(s, "I");
if (crc32("WaClEUvqsB",10) == 815771637) strcat(s, "c");
if (crc32("MZIGlEC",7) == 3961650385) strcat(s, "w");
if (crc32("KlZLPxIZ",8) == 1447019382) strcat(s, "a");
if (crc32("VpmEucPmlAwk",12) == 2088832696) strcat(s, "v");
if (crc32("TkJJNeiOgnx",11) == 2321946729) strcat(s, "l");
if (crc32("cAQuwCB",7) == 2226134431) strcat(s, "m");
if (crc32("EPeUMlzxrGTtkaZ",15) == 2166446462) strcat(s, "l");
if (crc32("HtTVxELZfJoWtn",14) == 1315133327) strcat(s, "W");
if (crc32("rDPKPrZHcckp",12) == 1856982242) strcat(s, "y");
    return s;
}

char *dedicatorily_adverbs() {
    char *s = calloc(13);
    if (crc32("ePurIeZN",8) == 2133946601) strcat(s, "d");
if (crc32("AowkWsppwhu",11) == 538162077) strcat(s, "Q");
if (crc32("HKidyEZOEmW",11) == 25895711) strcat(s, "e");
if (crc32("LRjlkRlI",8) == 2473491780) strcat(s, "K");
if (crc32("yOkgp",5) == 3484194133) strcat(s, "d");
if (crc32("ZCwLaWj",7) == 415049949) strcat(s, "i");
if (crc32("EkLJrfUyLoRRa",13) == 361475792) strcat(s, "c");
if (crc32("YjknyzQ",7) == 633944715) strcat(s, "a");
if (crc32("oATIDefUTeTAF",13) == 1420451394) strcat(s, "t");
if (crc32("WtQttiHHizJPhxG",15) == 446702572) strcat(s, "o");
if (crc32("xXjQK",5) == 114803109) strcat(s, "r");
if (crc32("dZYwswnOGNPIoTg",15) == 1372713398) strcat(s, "y");
if (crc32("EDhoJczw",8) == 3998717922) strcat(s, "i");
if (crc32("bUpvL",5) == 70686778) strcat(s, "j");
if (crc32("kFfJGBaisEspw",13) == 2127114640) strcat(s, "l");
if (crc32("ACklFIGeVgAzivj",15) == 2216853004) strcat(s, "y");
    return s;
}

char *nationally_adverbs() {
    char *s = calloc(11);
    if (crc32("FpNGByeDHXxaSaZ",15) == 2827264622) strcat(s, "D");
if (crc32("ENTJWIXMiOztNBo",15) == 764098855) strcat(s, "n");
if (crc32("WHoXAy",6) == 3693482868) strcat(s, "r");
if (crc32("YGiDM",5) == 782007712) strcat(s, "a");
if (crc32("PmoZhiMkCgsOej",14) == 1662960463) strcat(s, "t");
if (crc32("oasiv",5) == 87315721) strcat(s, "i");
if (crc32("ksLswfUnqKX",11) == 3759372141) strcat(s, "o");
if (crc32("ChFUIbYg",8) == 1782869418) strcat(s, "K");
if (crc32("GOefgKGo",8) == 41485721) strcat(s, "n");
if (crc32("pmVGeHNkjKUKo",13) == 1325074140) strcat(s, "a");
if (crc32("YEeCAc",6) == 3531779646) strcat(s, "b");
if (crc32("tDdJMneqoI",10) == 182894717) strcat(s, "l");
if (crc32("NVozGWVGzoBodhJ",15) == 3405254692) strcat(s, "l");
if (crc32("rPCHSWBlOJIv",12) == 1343116532) strcat(s, "q");
if (crc32("nPHMKBeipjVYjH",14) == 375462949) strcat(s, "y");
    return s;
}

char *cardinally_adverbs() {
    char *s = calloc(11);
    if (crc32("GojQEKDir",9) == 1111441545) strcat(s, "O");
if (crc32("SXaLjdyx",8) == 1266461185) strcat(s, "c");
if (crc32("rramUOYdl",9) == 82555996) strcat(s, "r");
if (crc32("fqfzVT",6) == 1813098237) strcat(s, "a");
if (crc32("DpecK",5) == 3786145983) strcat(s, "r");
if (crc32("ifceOiDI",8) == 3465619426) strcat(s, "w");
if (crc32("rABUrGXfFm",10) == 3111150653) strcat(s, "d");
if (crc32("dDXZUZnFOmY",11) == 137672673) strcat(s, "k");
if (crc32("yToXCs",6) == 1137586364) strcat(s, "i");
if (crc32("YqhwhnFm",8) == 1593713409) strcat(s, "G");
if (crc32("XmxiACzIgH",10) == 2010870287) strcat(s, "n");
if (crc32("gIfgxQVO",8) == 1381460828) strcat(s, "a");
if (crc32("sNTQbiLRHa",10) == 2246338211) strcat(s, "D");
if (crc32("NIXnXV",6) == 1843991165) strcat(s, "l");
if (crc32("WbQXMV",6) == 299572875) strcat(s, "K");
if (crc32("uKFWqq",6) == 61104704) strcat(s, "l");
if (crc32("leJftoRL",8) == 1326813086) strcat(s, "Z");
if (crc32("cmyFue",6) == 1404070315) strcat(s, "y");
    return s;
}

char *contrastively_adverbs() {
    char *s = calloc(14);
    if (crc32("stsReb",6) == 2644701945) strcat(s, "c");
if (crc32("meVFWOQ",7) == 610687909) strcat(s, "o");
if (crc32("heENdpCN",8) == 509556355) strcat(s, "c");
if (crc32("zNLCeRXI",8) == 904750876) strcat(s, "n");
if (crc32("krVjuhQuiXtVmVU",15) == 1290148132) strcat(s, "t");
if (crc32("LrOmrOfSzRL",11) == 3956121385) strcat(s, "L");
if (crc32("sbmWLRhGunVO",12) == 3266654184) strcat(s, "r");
if (crc32("OvnjJ",5) == 428280396) strcat(s, "a");
if (crc32("DuJpbly",7) == 3514392027) strcat(s, "S");
if (crc32("WmMznZt",7) == 1054879250) strcat(s, "s");
if (crc32("wPNhl",5) == 2970508766) strcat(s, "M");
if (crc32("heAwXNAFVpSMi",13) == 3857271488) strcat(s, "t");
if (crc32("IuzTdykED",9) == 343476798) strcat(s, "I");
if (crc32("QoNcxfvqaYRB",12) == 2215147242) strcat(s, "i");
if (crc32("NUtfBhbgJmrrWZJ",15) == 150202590) strcat(s, "E");
if (crc32("mICaFzt",7) == 893177387) strcat(s, "v");
if (crc32("pcgdHGnTFCnhkW",14) == 3725324636) strcat(s, "v");
if (crc32("BsKSSEtTgSctQ",13) == 1822768797) strcat(s, "e");
if (crc32("TuRFb",5) == 1039654033) strcat(s, "l");
if (crc32("qmpOIevtzso",11) == 3945830166) strcat(s, "y");
    return s;
}

char *gyroscopically_adverbs() {
    char *s = calloc(15);
    if (crc32("rScUci",6) == 2982276444) strcat(s, "g");
if (crc32("sfroqXlt",8) == 847105731) strcat(s, "f");
if (crc32("ajIdUpok",8) == 2187837110) strcat(s, "y");
if (crc32("fnOYbNYKJrQGO",13) == 447773233) strcat(s, "r");
if (crc32("ZSagMRfptmPC",12) == 2591247848) strcat(s, "o");
if (crc32("fpIjJaLyCCxB",12) == 541824129) strcat(s, "R");
if (crc32("mekeiGOGQygxSMa",15) == 1884583332) strcat(s, "s");
if (crc32("zTzzJHZzGEcvhba",15) == 4042211714) strcat(s, "u");
if (crc32("RCFQjeVUaanrj",13) == 3516646605) strcat(s, "c");
if (crc32("copKcHEwIyU",11) == 3737876786) strcat(s, "m");
if (crc32("DUPgi",5) == 3857513512) strcat(s, "o");
if (crc32("rRihBdFIje",10) == 1674684339) strcat(s, "M");
if (crc32("piSGiO",6) == 3505589944) strcat(s, "p");
if (crc32("QmVHmtB",7) == 1840916720) strcat(s, "L");
if (crc32("dHYENezcmgV",11) == 2267826490) strcat(s, "i");
if (crc32("WTWsryCBYAzuIn",14) == 1598905004) strcat(s, "w");
if (crc32("aqOnReRzzobgWYS",15) == 1922137141) strcat(s, "c");
if (crc32("qpwQOd",6) == 784774433) strcat(s, "a");
if (crc32("dYfUMjhRbR",10) == 509690645) strcat(s, "D");
if (crc32("FaVuWRqqbZQTXn",14) == 1038906821) strcat(s, "l");
if (crc32("kMAdglhG",8) == 3345594139) strcat(s, "l");
if (crc32("tgCtUcOwmov",11) == 294140023) strcat(s, "y");
    return s;
}

char *transmissively_adverbs() {
    char *s = calloc(15);
    if (crc32("YlgbozTqOoYZ",12) == 3005362251) strcat(s, "t");
if (crc32("UTSiZAwWvMNA",12) == 1445986910) strcat(s, "r");
if (crc32("NnSawH",6) == 709239899) strcat(s, "a");
if (crc32("nxBwvmGcdUndz",13) == 3882130985) strcat(s, "n");
if (crc32("BlmcHUUwAguR",12) == 3999321120) strcat(s, "H");
if (crc32("seFhF",5) == 841260619) strcat(s, "s");
if (crc32("qIgimxVTR",9) == 1036401798) strcat(s, "h");
if (crc32("hGVpoBGKnArgq",13) == 705515276) strcat(s, "m");
if (crc32("DXHkC",5) == 1925009639) strcat(s, "i");
if (crc32("PqxbmN",6) == 4014443086) strcat(s, "j");
if (crc32("bwIPJntzDqCgqak",15) == 3851536138) strcat(s, "s");
if (crc32("dBzXYLAXXKWf",12) == 852007736) strcat(s, "G");
if (crc32("xoYgsglyMbOfkM",14) == 1938196260) strcat(s, "s");
if (crc32("dqqNl",5) == 115256566) strcat(s, "i");
if (crc32("uRhrzTCNVD",10) == 2023664900) strcat(s, "C");
if (crc32("yrXcZsVRSpvU",12) == 3306818571) strcat(s, "v");
if (crc32("aBocfUHfnCe",11) == 3674403411) strcat(s, "e");
if (crc32("JcmftpEgKDG",11) == 4221394258) strcat(s, "l");
if (crc32("FjTmGeXjwL",10) == 1093974720) strcat(s, "i");
if (crc32("XQHyvx",6) == 1985464625) strcat(s, "y");
    return s;
}

char *quasiamusingly_adverbs() {
    char *s = calloc(15);
    if (crc32("IdLoghdp",8) == 4135044923) strcat(s, "j");
if (crc32("FEadZoM",7) == 2115492712) strcat(s, "q");
if (crc32("stLZdIV",7) == 92365792) strcat(s, "u");
if (crc32("wjbAjxZtFB",10) == 1160079911) strcat(s, "T");
if (crc32("qhlqw",5) == 1166704610) strcat(s, "a");
if (crc32("InvJRbNrFGSelBB",15) == 1594612727) strcat(s, "c");
if (crc32("luFhAC",6) == 30077482) strcat(s, "s");
if (crc32("UaRodsU",7) == 1136016388) strcat(s, "r");
if (crc32("YCWaxSWWaS",10) == 450439305) strcat(s, "i");
if (crc32("kqiuPfdJiFt",11) == 2064978981) strcat(s, "Z");
if (crc32("cjYPeLC",7) == 2371231434) strcat(s, "a");
if (crc32("fXWosRgyaZhquNH",15) == 2162884349) strcat(s, "m");
if (crc32("tzBUN",5) == 3947130306) strcat(s, "m");
if (crc32("JXAfVpc",7) == 1973534179) strcat(s, "u");
if (crc32("fmRuSvRrbhOotxh",15) == 566198089) strcat(s, "t");
if (crc32("AdqTXnetHhqNvR",14) == 357517262) strcat(s, "s");
if (crc32("DDOSoWRobG",10) == 4239832912) strcat(s, "D");
if (crc32("hgGwChvinnfV",12) == 3134033777) strcat(s, "i");
if (crc32("ltQRwtUv",8) == 2040933013) strcat(s, "M");
if (crc32("PEXihKqtvmsFt",13) == 276003481) strcat(s, "n");
if (crc32("RkHIGZlzNOtv",12) == 3182241474) strcat(s, "g");
if (crc32("qLYXH",5) == 1152677387) strcat(s, "J");
if (crc32("FuOhWgjTevJcl",13) == 904827286) strcat(s, "l");
if (crc32("ChmDwxNBOxXeYQD",15) == 1798439625) strcat(s, "h");
if (crc32("hpYvIJVeAVAWc",13) == 2396441639) strcat(s, "y");
    return s;
}

char *nonloyally_adverbs() {
    char *s = calloc(11);
    if (crc32("vpAZi",5) == 3740125499) strcat(s, "n");
if (crc32("HwdBbXaZfTrxIpR",15) == 4078874363) strcat(s, "W");
if (crc32("IwlCoQ",6) == 792898544) strcat(s, "o");
if (crc32("GvfnwBgG",8) == 1990147135) strcat(s, "n");
if (crc32("CnqjavR",7) == 4283256599) strcat(s, "l");
if (crc32("RZWvqdPTysRxBs",14) == 2265245453) strcat(s, "t");
if (crc32("IIssfrfzCbnWk",13) == 2187651850) strcat(s, "o");
if (crc32("KicwPqRgwpsS",12) == 2662046901) strcat(s, "y");
if (crc32("RpGxFUogLxDR",12) == 1591697840) strcat(s, "V");
if (crc32("opfpzxGWFQkeMrc",15) == 246810328) strcat(s, "a");
if (crc32("VzgRndyNHmKSA",13) == 1837578496) strcat(s, "l");
if (crc32("wNxFGFzu",8) == 1613426360) strcat(s, "l");
if (crc32("cIhOSunZ",8) == 3041044851) strcat(s, "g");
if (crc32("WFmBugIHji",10) == 3466918081) strcat(s, "y");
    return s;
}

char *unplentifully_adverbs() {
    char *s = calloc(14);
    if (crc32("QSnhiomxEprDfUx",15) == 4119928521) strcat(s, "s");
if (crc32("RpTydR",6) == 2465054145) strcat(s, "u");
if (crc32("XwtwL",5) == 1950730548) strcat(s, "n");
if (crc32("EGLxXb",6) == 1585100640) strcat(s, "p");
if (crc32("ocSTwnBfQ",9) == 1917520970) strcat(s, "l");
if (crc32("USrtPhNady",10) == 954577183) strcat(s, "O");
if (crc32("pNJQvMbChnrK",12) == 1648365026) strcat(s, "e");
if (crc32("PDxhJyAujboex",13) == 3037221190) strcat(s, "n");
if (crc32("PImwyDVTNq",10) == 2564732695) strcat(s, "y");
if (crc32("kMFmSlDmRy",10) == 3275101356) strcat(s, "t");
if (crc32("CvRVtYJhzeFGFN",14) == 2431130370) strcat(s, "i");
if (crc32("VJLqDXbDxJmI",12) == 1315864720) strcat(s, "c");
if (crc32("MCYYDe",6) == 1643302985) strcat(s, "f");
if (crc32("crpgMYsjVTiZqG",14) == 4034653146) strcat(s, "u");
if (crc32("kdBDKYwJTZtu",12) == 1401908185) strcat(s, "l");
if (crc32("hZkqKaOXEZr",11) == 726156762) strcat(s, "i");
if (crc32("EWPtyV",6) == 2154090743) strcat(s, "l");
if (crc32("FBydXCOqrkSvcCR",15) == 171819191) strcat(s, "V");
if (crc32("yDCzFOoPx",9) == 2075009457) strcat(s, "y");
    return s;
}

char *venially_adverbs() {
    char *s = calloc(9);
    if (crc32("bPrmYpbz",8) == 4137563985) strcat(s, "v");
if (crc32("uEgqXImnZuTqZbK",15) == 3698171655) strcat(s, "L");
if (crc32("WVqUD",5) == 1094294087) strcat(s, "e");
if (crc32("xUcMW",5) == 152708069) strcat(s, "n");
if (crc32("OSNSgMq",7) == 2676330840) strcat(s, "T");
if (crc32("PLXQeL",6) == 610856335) strcat(s, "i");
if (crc32("znWySUVM",8) == 825316496) strcat(s, "a");
if (crc32("DDQubfl",7) == 616044237) strcat(s, "u");
if (crc32("TjYNIECGlAWIDbd",15) == 1174070151) strcat(s, "l");
if (crc32("jFHqsBdEyB",10) == 1325727040) strcat(s, "H");
if (crc32("MDUybEa",7) == 911595984) strcat(s, "l");
if (crc32("AJAwweYbhxlbp",13) == 4137891952) strcat(s, "o");
if (crc32("vQOTblAmGLrFStE",15) == 1255262012) strcat(s, "y");
    return s;
}

char *nonconsequentially_adverbs() {
    char *s = calloc(19);
    if (crc32("QuaRJBRUIGtP",12) == 1483872965) strcat(s, "n");
if (crc32("onySzjSfESBBDlR",15) == 2841974710) strcat(s, "k");
if (crc32("UugEahbIym",10) == 2213471858) strcat(s, "o");
if (crc32("gNMEtpT",7) == 4199013993) strcat(s, "n");
if (crc32("qGjQLCUXs",9) == 254187823) strcat(s, "c");
if (crc32("FsFPWIdPNlVg",12) == 42634637) strcat(s, "o");
if (crc32("lBgwZdMLFf",10) == 4169122488) strcat(s, "n");
if (crc32("UrCROib",7) == 603522333) strcat(s, "d");
if (crc32("qCsXHWFpQFGXoh",14) == 2062564971) strcat(s, "s");
if (crc32("KmQSxuK",7) == 4133887310) strcat(s, "J");
if (crc32("jvHhmEhEcFl",11) == 1545929326) strcat(s, "e");
if (crc32("ZIiGdnjah",9) == 4132477349) strcat(s, "q");
if (crc32("pbRxog",6) == 1397224733) strcat(s, "u");
if (crc32("lyyNsbCsNwbz",12) == 1659779253) strcat(s, "f");
if (crc32("aSRFW",5) == 2279399334) strcat(s, "e");
if (crc32("tVzXVIhZQQwxp",13) == 345814585) strcat(s, "t");
if (crc32("eXidNqutH",9) == 2925232758) strcat(s, "n");
if (crc32("swAuHkQYGrhW",12) == 3167844082) strcat(s, "t");
if (crc32("MVjwipSSdlL",11) == 3883064308) strcat(s, "i");
if (crc32("zVnvTjus",8) == 1907494626) strcat(s, "M");
if (crc32("mULkuEbM",8) == 3159296981) strcat(s, "a");
if (crc32("EQnoSOV",7) == 2463713129) strcat(s, "l");
if (crc32("cLqOWGQJrQh",11) == 1672655222) strcat(s, "h");
if (crc32("sQcaGsr",7) == 368767489) strcat(s, "l");
if (crc32("rofRaUyzi",9) == 1116479200) strcat(s, "Z");
if (crc32("cjdbqGC",7) == 1981710512) strcat(s, "y");
    return s;
}

char *fascinatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("RZxlKfpiMCdx",12) == 691104717) strcat(s, "f");
if (crc32("FSNXIvAiCPnno",13) == 472547955) strcat(s, "y");
if (crc32("UeYWeJFAB",9) == 1105053069) strcat(s, "a");
if (crc32("RtbpHArfkL",10) == 2132099741) strcat(s, "s");
if (crc32("JUBjJPRmiAEttVA",15) == 1277452313) strcat(s, "c");
if (crc32("FjhOGiBFKsX",11) == 2882506107) strcat(s, "i");
if (crc32("XypCptU",7) == 3584770658) strcat(s, "n");
if (crc32("YfRauYZoOg",10) == 3868986616) strcat(s, "p");
if (crc32("cCyGOnteHHlXkuO",15) == 1228261573) strcat(s, "a");
if (crc32("pzlcRpdvultm",12) == 2529667901) strcat(s, "t");
if (crc32("uydryETBGGNXE",13) == 1229618175) strcat(s, "i");
if (crc32("VGOvjHtut",9) == 1893460942) strcat(s, "n");
if (crc32("XirMvr",6) == 3139929825) strcat(s, "g");
if (crc32("kOisEPtFjKtujc",14) == 4037308298) strcat(s, "l");
if (crc32("xgljxRW",7) == 2015572370) strcat(s, "l");
if (crc32("eyXIVGxaEZPb",12) == 328858703) strcat(s, "y");
    return s;
}

char *quasimaternally_adverbs() {
    char *s = calloc(16);
    if (crc32("qnmNXFNoBPhrK",13) == 710227561) strcat(s, "q");
if (crc32("YMfyJpkqRE",10) == 2249993225) strcat(s, "u");
if (crc32("StXJCbTPwIfKzl",14) == 3141508272) strcat(s, "a");
if (crc32("gYRNWMAuPVe",11) == 314563595) strcat(s, "Y");
if (crc32("XrnLpCZlGFFA",12) == 3979117221) strcat(s, "s");
if (crc32("OsAitRBItDPVx",13) == 4266548030) strcat(s, "T");
if (crc32("ihPgVqgYxpLC",12) == 367578664) strcat(s, "i");
if (crc32("FLVwmDFHWboOZB",14) == 3496101069) strcat(s, "m");
if (crc32("KOxRQXY",7) == 2153992424) strcat(s, "m");
if (crc32("JuimKWbwNJwWB",13) == 3500399327) strcat(s, "n");
if (crc32("iDBjZhLRMZIZG",13) == 142429351) strcat(s, "a");
if (crc32("YwOzmJxX",8) == 3931081184) strcat(s, "m");
if (crc32("CuKlEbcCENT",11) == 2673811068) strcat(s, "t");
if (crc32("mXiNKadlJhCjGt",14) == 2652186621) strcat(s, "e");
if (crc32("XsrHpvnNH",9) == 1989311036) strcat(s, "r");
if (crc32("iSQfwkdshleL",12) == 2354124479) strcat(s, "n");
if (crc32("kpqUnDZuI",9) == 2351169851) strcat(s, "a");
if (crc32("QaqcvL",6) == 1383975062) strcat(s, "P");
if (crc32("XnqlU",5) == 2462216336) strcat(s, "l");
if (crc32("ndjxA",5) == 3977695394) strcat(s, "V");
if (crc32("EwPrfXyQu",9) == 1904382155) strcat(s, "l");
if (crc32("YmgYOPj",7) == 1850120964) strcat(s, "y");
    return s;
}

char *snappingly_adverbs() {
    char *s = calloc(11);
    if (crc32("HUbgdggVI",9) == 1055956062) strcat(s, "O");
if (crc32("QtlnuwqgPWRjXZS",15) == 348213784) strcat(s, "s");
if (crc32("YmdQqsBXXsSLaDU",15) == 2642094622) strcat(s, "F");
if (crc32("jqmDQ",5) == 240512024) strcat(s, "n");
if (crc32("aaSNFAZeIHav",12) == 966776570) strcat(s, "I");
if (crc32("lkipUwusZVnM",12) == 372230495) strcat(s, "a");
if (crc32("XxXobKNdV",9) == 3044801625) strcat(s, "z");
if (crc32("yymszA",6) == 584935097) strcat(s, "p");
if (crc32("JzyHUcHy",8) == 1390083363) strcat(s, "D");
if (crc32("jdqkOJgFaALH",12) == 2592964644) strcat(s, "p");
if (crc32("VWfqFzqF",8) == 2780073114) strcat(s, "Y");
if (crc32("TLPyKHQETikvUek",15) == 2215233918) strcat(s, "i");
if (crc32("tTzGGkpFwE",10) == 2615789127) strcat(s, "S");
if (crc32("ejfUE",5) == 1313584091) strcat(s, "n");
if (crc32("wPCUhz",6) == 1641296148) strcat(s, "g");
if (crc32("OKXlUnGy",8) == 1207383965) strcat(s, "l");
if (crc32("hKNseMYmckGm",12) == 4284572319) strcat(s, "y");
    return s;
}

char *nonscholastically_adverbs() {
    char *s = calloc(18);
    if (crc32("wVxHSWWfNm",10) == 3109480757) strcat(s, "n");
if (crc32("iGFiVNpKO",9) == 4115870113) strcat(s, "c");
if (crc32("spcnOaZcEY",10) == 2692623155) strcat(s, "o");
if (crc32("iJCozgftg",9) == 2195827528) strcat(s, "a");
if (crc32("SZYthCAV",8) == 4191806581) strcat(s, "n");
if (crc32("sBkRZLhAx",9) == 3731993328) strcat(s, "s");
if (crc32("ZaUhmoqWBEui",12) == 3648166977) strcat(s, "c");
if (crc32("FSVkeYLjT",9) == 216839579) strcat(s, "r");
if (crc32("FMhABzTcyKfmJC",14) == 2265362246) strcat(s, "h");
if (crc32("pjWRRB",6) == 4099820939) strcat(s, "U");
if (crc32("HJsFDcbDaQogfDq",15) == 2994856986) strcat(s, "o");
if (crc32("ktDTHPOAKiZPhk",14) == 807020044) strcat(s, "l");
if (crc32("vXqddIUJEedAf",13) == 175158462) strcat(s, "c");
if (crc32("xlPDhQKpmjaNuYc",15) == 3220712153) strcat(s, "a");
if (crc32("IzumiKrFu",9) == 477836367) strcat(s, "g");
if (crc32("khxtrOWe",8) == 3372962827) strcat(s, "s");
if (crc32("ClzNYiCAmzMUCgW",15) == 677461440) strcat(s, "q");
if (crc32("WOZSsqFsMZM",11) == 3940170370) strcat(s, "t");
if (crc32("EFajAR",6) == 2469988249) strcat(s, "i");
if (crc32("kjNYLsEEIegW",12) == 2723579918) strcat(s, "v");
if (crc32("KBTjUxUEGveiJ",13) == 644850331) strcat(s, "c");
if (crc32("GwTXDMisSlBg",12) == 184631149) strcat(s, "t");
if (crc32("VXPOhWDjjJOEs",13) == 855581038) strcat(s, "a");
if (crc32("ZDxigtW",7) == 2311906161) strcat(s, "F");
if (crc32("dPNUDjWamNvRtsn",15) == 1145706538) strcat(s, "l");
if (crc32("NCMlY",5) == 201143694) strcat(s, "l");
if (crc32("GBbFzhAbA",9) == 2563945243) strcat(s, "y");
    return s;
}

char *unapprovingly_adverbs() {
    char *s = calloc(14);
    if (crc32("hteQfOhxyZa",11) == 3240760982) strcat(s, "u");
if (crc32("vmNbojhkw",9) == 906263529) strcat(s, "A");
if (crc32("NGbwlMWGz",9) == 2326266883) strcat(s, "n");
if (crc32("YTMdXhhn",8) == 1760961082) strcat(s, "a");
if (crc32("djtdFEkXMuzT",12) == 2396729817) strcat(s, "b");
if (crc32("iwNsHXMCuwpk",12) == 4005410171) strcat(s, "p");
if (crc32("thTVF",5) == 738850533) strcat(s, "p");
if (crc32("KLyrIkUEyYFyF",13) == 920474568) strcat(s, "X");
if (crc32("FvxOR",5) == 4154720078) strcat(s, "r");
if (crc32("drrcRferpsYBw",13) == 2945352126) strcat(s, "o");
if (crc32("LyuePOAZCrpiRT",14) == 37595800) strcat(s, "v");
if (crc32("gNQKaQOfzvSQyM",14) == 4041079433) strcat(s, "i");
if (crc32("Xeeck",5) == 404094297) strcat(s, "n");
if (crc32("xihNVoTgcrA",11) == 3941150197) strcat(s, "r");
if (crc32("jknrDHveSfeekFr",15) == 809321433) strcat(s, "g");
if (crc32("LQAdkqSAx",9) == 3525161570) strcat(s, "l");
if (crc32("aTYAnw",6) == 1304105278) strcat(s, "y");
    return s;
}

char *nontyrannically_adverbs() {
    char *s = calloc(16);
    if (crc32("bYHKSCv",7) == 2191150879) strcat(s, "n");
if (crc32("KzZDlmmPnRbUEGH",15) == 320492269) strcat(s, "k");
if (crc32("AFQtLRqn",8) == 1318771127) strcat(s, "o");
if (crc32("ZYtNewsuui",10) == 1093474561) strcat(s, "X");
if (crc32("WWHOUFYl",8) == 1117941914) strcat(s, "n");
if (crc32("mYxdByr",7) == 4139896575) strcat(s, "d");
if (crc32("tlHyyx",6) == 3624955012) strcat(s, "t");
if (crc32("VneLAIFvbuxgaQ",14) == 38856503) strcat(s, "y");
if (crc32("jZjUQA",6) == 4137270490) strcat(s, "r");
if (crc32("WEPvGiIrLYnJbf",14) == 3234326975) strcat(s, "a");
if (crc32("vsJUkAXYAdvqw",13) == 3876277910) strcat(s, "k");
if (crc32("LSvIgjK",7) == 936869474) strcat(s, "n");
if (crc32("ZxtfVNkrbToI",12) == 124654851) strcat(s, "h");
if (crc32("JVhjeWQeOdPNM",13) == 2272407843) strcat(s, "n");
if (crc32("yOrWPlEiQUUrqa",14) == 1952971045) strcat(s, "u");
if (crc32("nvZyDol",7) == 788021601) strcat(s, "i");
if (crc32("REmgNLb",7) == 882139342) strcat(s, "c");
if (crc32("IRDDkCQtQYm",11) == 4104101627) strcat(s, "M");
if (crc32("KydOz",5) == 2010765639) strcat(s, "a");
if (crc32("rNscAOgpzMAad",13) == 3971858969) strcat(s, "V");
if (crc32("eZhErQ",6) == 318636785) strcat(s, "l");
if (crc32("YhrwthvJNjqMxo",14) == 4141480673) strcat(s, "l");
if (crc32("vXbqUYkqDluxY",13) == 2125079806) strcat(s, "y");
    return s;
}

char *unhabitually_adverbs() {
    char *s = calloc(13);
    if (crc32("wHsdE",5) == 2195748517) strcat(s, "u");
if (crc32("tWZOnVWXDtNU",12) == 217609283) strcat(s, "n");
if (crc32("DLZyjNcXjl",10) == 2927862896) strcat(s, "P");
if (crc32("gLqjWc",6) == 2394052983) strcat(s, "h");
if (crc32("QWeQDHKumGkob",13) == 3791747838) strcat(s, "a");
if (crc32("yYHnFn",6) == 1886236584) strcat(s, "h");
if (crc32("vapXI",5) == 448345132) strcat(s, "b");
if (crc32("eRXSrYW",7) == 494710770) strcat(s, "i");
if (crc32("OcVdWhxA",8) == 2176305218) strcat(s, "e");
if (crc32("hCpGDqRI",8) == 888572404) strcat(s, "t");
if (crc32("OIkHaAx",7) == 3141876024) strcat(s, "D");
if (crc32("spceGXLnJkxOJH",14) == 1956924167) strcat(s, "u");
if (crc32("aZUdVbFaRtMr",12) == 932366576) strcat(s, "a");
if (crc32("liXtaZxFd",9) == 2777673880) strcat(s, "l");
if (crc32("QySdAixoklunS",13) == 4111891001) strcat(s, "F");
if (crc32("FbOttcmo",8) == 3342310632) strcat(s, "l");
if (crc32("RiXeGeJ",7) == 4178597472) strcat(s, "y");
    return s;
}

char *principally_adverbs() {
    char *s = calloc(12);
    if (crc32("UHaiXWX",7) == 486561098) strcat(s, "X");
if (crc32("DtApGIzZqwDfq",13) == 2361634482) strcat(s, "p");
if (crc32("UimqCoxHpMD",11) == 4187934187) strcat(s, "r");
if (crc32("BiqgcdBrDSUsLS",14) == 4205472763) strcat(s, "i");
if (crc32("mgREeASPIjOQjx",14) == 2080943336) strcat(s, "n");
if (crc32("nDrkNyNJhN",10) == 3536696778) strcat(s, "N");
if (crc32("PFYAd",5) == 2157900045) strcat(s, "c");
if (crc32("dDJLYpFIESUEUlD",15) == 1270744924) strcat(s, "B");
if (crc32("JgznHddGgWD",11) == 2341748904) strcat(s, "i");
if (crc32("QpIWn",5) == 2295693433) strcat(s, "p");
if (crc32("hYtDtCiJBxAwNsO",15) == 3874024027) strcat(s, "P");
if (crc32("yBKQdeTRkChida",14) == 3835455573) strcat(s, "a");
if (crc32("qGqqk",5) == 1466170541) strcat(s, "J");
if (crc32("snFodACSDcBJ",12) == 1893610376) strcat(s, "l");
if (crc32("KGYzc",5) == 1052488194) strcat(s, "f");
if (crc32("oxQufjTY",8) == 3538145526) strcat(s, "l");
if (crc32("aNzFXlKZ",8) == 1620317267) strcat(s, "B");
if (crc32("mlnKGIt",7) == 1630204230) strcat(s, "y");
    return s;
}

char *fasciately_adverbs() {
    char *s = calloc(11);
    if (crc32("gIAJvTbnpp",10) == 1626124155) strcat(s, "q");
if (crc32("NMKUbpWURbqlmQV",15) == 672368769) strcat(s, "f");
if (crc32("viZrTBmqcgbUgbz",15) == 2335624766) strcat(s, "V");
if (crc32("lWTrqZuqQsdi",12) == 22632779) strcat(s, "a");
if (crc32("JugRAafAaB",10) == 133988419) strcat(s, "l");
if (crc32("vWcFVcQ",7) == 1497301848) strcat(s, "s");
if (crc32("AJFPPWLUPCfQ",12) == 2610408649) strcat(s, "m");
if (crc32("ejkMVbOnfqmXmye",15) == 4195155898) strcat(s, "c");
if (crc32("bBCUMKkPPjgh",12) == 905756671) strcat(s, "i");
if (crc32("AJXSQMmUjigrCvB",15) == 886944891) strcat(s, "a");
if (crc32("KgCGapacoNQn",12) == 1693551729) strcat(s, "O");
if (crc32("UgGROd",6) == 2455175019) strcat(s, "t");
if (crc32("EEgwvnzk",8) == 338206543) strcat(s, "V");
if (crc32("YqOKDfomNlpCYXD",15) == 2328330591) strcat(s, "e");
if (crc32("ySJyKJWvQXWY",12) == 733852389) strcat(s, "d");
if (crc32("IXbxtAxA",8) == 3161257700) strcat(s, "l");
if (crc32("ajHgLPo",7) == 3381017880) strcat(s, "y");
    return s;
}

char *semimonarchically_adverbs() {
    char *s = calloc(18);
    if (crc32("YfQGpuuPHJWe",12) == 338715156) strcat(s, "s");
if (crc32("ZGtkZMmJuhcv",12) == 3657352053) strcat(s, "e");
if (crc32("zJbbpwzO",8) == 389407054) strcat(s, "m");
if (crc32("sPwIEKkI",8) == 807677195) strcat(s, "M");
if (crc32("xgiCO",5) == 3544196033) strcat(s, "i");
if (crc32("yUIIBcanXtj",11) == 1408397529) strcat(s, "m");
if (crc32("ttMFdpj",7) == 3328339396) strcat(s, "o");
if (crc32("cuxrNGODSkw",11) == 1685026102) strcat(s, "c");
if (crc32("JANvt",5) == 2747286322) strcat(s, "n");
if (crc32("FwLFxkwaSbTdmK",14) == 517382892) strcat(s, "H");
if (crc32("taoBeXTY",8) == 425703629) strcat(s, "a");
if (crc32("tufDqjp",7) == 8671884) strcat(s, "t");
if (crc32("VuNMfWfa",8) == 2745573445) strcat(s, "r");
if (crc32("gPrhKACkVuOuF",13) == 1584047890) strcat(s, "l");
if (crc32("KMBoTI",6) == 3615472187) strcat(s, "c");
if (crc32("VYmJnU",6) == 170402665) strcat(s, "h");
if (crc32("wcAzjHSrfKM",11) == 1472563492) strcat(s, "i");
if (crc32("qklCYrk",7) == 3290898556) strcat(s, "c");
if (crc32("FVszbV",6) == 1013274210) strcat(s, "U");
if (crc32("VjeYWN",6) == 3013382319) strcat(s, "a");
if (crc32("wHfCiFrcHNZYZyA",15) == 4053013467) strcat(s, "l");
if (crc32("ySSwWnfNwQ",10) == 2143147570) strcat(s, "l");
if (crc32("zPnrQQeNStYzsNo",15) == 389829798) strcat(s, "R");
if (crc32("XYJhdJsnlR",10) == 1635022287) strcat(s, "y");
    return s;
}

char *selfcentredly_adverbs() {
    char *s = calloc(14);
    if (crc32("qZqFW",5) == 2688548631) strcat(s, "s");
if (crc32("aWRMPGesiAF",11) == 1730319755) strcat(s, "e");
if (crc32("nSJfnAp",7) == 1004508154) strcat(s, "l");
if (crc32("zbysmGjjGBgY",12) == 2694552816) strcat(s, "p");
if (crc32("egnIE",5) == 1413834723) strcat(s, "f");
if (crc32("TReMNxHUJDWbY",13) == 3149806920) strcat(s, "Q");
if (crc32("VSVRBQn",7) == 4220583180) strcat(s, "c");
if (crc32("vpBVyPsMMct",11) == 2347882751) strcat(s, "T");
if (crc32("nRlTojfDWHJAGqG",15) == 223590048) strcat(s, "e");
if (crc32("zeoGlLXmEeAzO",13) == 1045552603) strcat(s, "n");
if (crc32("RtKHIMeLS",9) == 3953129698) strcat(s, "t");
if (crc32("pvYJazW",7) == 2603396683) strcat(s, "r");
if (crc32("FHGZxD",6) == 4060079823) strcat(s, "r");
if (crc32("oEMcxhYgnaJi",12) == 3821900891) strcat(s, "e");
if (crc32("yklIdAep",8) == 297455238) strcat(s, "d");
if (crc32("FyNufmyjuXUTtZJ",15) == 1854857552) strcat(s, "d");
if (crc32("rqiQoZrFrGSR",12) == 2079647336) strcat(s, "l");
if (crc32("WPmdILOnZkMyZ",13) == 2531031810) strcat(s, "n");
if (crc32("yrFJUwkDkTrUMqw",15) == 3828693176) strcat(s, "y");
    return s;
}

char *iteratively_adverbs() {
    char *s = calloc(12);
    if (crc32("CGbrxpLhhGVDA",13) == 1670711470) strcat(s, "i");
if (crc32("UvlSWOZXt",9) == 2140817127) strcat(s, "t");
if (crc32("RFZEeWqUA",9) == 423857732) strcat(s, "e");
if (crc32("ZJJpQN",6) == 2617776721) strcat(s, "r");
if (crc32("cIHCUmwUn",9) == 534481021) strcat(s, "Z");
if (crc32("IbYIDrGuLsxHqC",14) == 1195081211) strcat(s, "a");
if (crc32("eXrblVgQvTKrnB",14) == 1664333168) strcat(s, "i");
if (crc32("fvcLac",6) == 3786612422) strcat(s, "t");
if (crc32("hiSAK",5) == 2277707069) strcat(s, "u");
if (crc32("GfZEAJF",7) == 4168459126) strcat(s, "i");
if (crc32("raVtP",5) == 3045457624) strcat(s, "z");
if (crc32("KgRak",5) == 2253277463) strcat(s, "v");
if (crc32("FcfSb",5) == 3722353326) strcat(s, "d");
if (crc32("PyGsHXHF",8) == 2127247342) strcat(s, "e");
if (crc32("UBbUFrfmqhWI",12) == 4165574972) strcat(s, "l");
if (crc32("HFiyz",5) == 1871129792) strcat(s, "C");
if (crc32("gslvnOZtC",9) == 1298210820) strcat(s, "y");
    return s;
}

char *sortably_adverbs() {
    char *s = calloc(9);
    if (crc32("WQYCAdK",7) == 2443794480) strcat(s, "s");
if (crc32("ALzJiWDYsO",10) == 1193128636) strcat(s, "o");
if (crc32("uICbFZzo",8) == 2770811294) strcat(s, "Z");
if (crc32("SOYnBCEJtHXO",12) == 4185408931) strcat(s, "r");
if (crc32("QbIxDROBqePBn",13) == 4287050118) strcat(s, "t");
if (crc32("ueiNDsRYR",9) == 4187704490) strcat(s, "Q");
if (crc32("FjKOYqGay",9) == 1958881554) strcat(s, "a");
if (crc32("sYnrKVAiBR",10) == 876667673) strcat(s, "t");
if (crc32("tfyom",5) == 1585127583) strcat(s, "b");
if (crc32("tTFuECBur",9) == 1626424221) strcat(s, "l");
if (crc32("xKbDmXbSosQdDn",14) == 3639718129) strcat(s, "y");
    return s;
}

char *spotlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("dikCXCgjeOc",11) == 3274261388) strcat(s, "Y");
if (crc32("GHOjLaMcGUP",11) == 1226370614) strcat(s, "s");
if (crc32("xoCaFNfZEEiQU",13) == 4178984204) strcat(s, "D");
if (crc32("DhTtptYAHNP",11) == 3656053260) strcat(s, "p");
if (crc32("LNOzIJ",6) == 54031539) strcat(s, "o");
if (crc32("jQdJVHCltV",10) == 1205819466) strcat(s, "t");
if (crc32("yIBkjRSbYGyeT",13) == 307924563) strcat(s, "N");
if (crc32("tRuICpKSi",9) == 1729749419) strcat(s, "l");
if (crc32("npSGwBqmJULh",12) == 453501497) strcat(s, "w");
if (crc32("XRKGOQj",7) == 2431776288) strcat(s, "e");
if (crc32("VWsvNfu",7) == 1426634683) strcat(s, "s");
if (crc32("INTlkEkLYECtqJp",15) == 3003601556) strcat(s, "s");
if (crc32("yWMlXSSUvfxdCQt",15) == 1532392943) strcat(s, "I");
if (crc32("XeYauWWAnrjPMFf",15) == 2075169765) strcat(s, "l");
if (crc32("rkBrVZlvWAWh",12) == 135434325) strcat(s, "y");
    return s;
}

char *undissemblingly_adverbs() {
    char *s = calloc(16);
    if (crc32("kBQlCPKa",8) == 803613533) strcat(s, "g");
if (crc32("DzOeLN",6) == 3601480841) strcat(s, "u");
if (crc32("DrHCFOfFYM",10) == 1359996984) strcat(s, "V");
if (crc32("ylulfHwvZp",10) == 4224498203) strcat(s, "n");
if (crc32("wSEWSm",6) == 3858154509) strcat(s, "S");
if (crc32("UbIZWQIHB",9) == 373261448) strcat(s, "d");
if (crc32("ItwdhVxsRcui",12) == 1308028095) strcat(s, "a");
if (crc32("bKfcJC",6) == 1782713513) strcat(s, "i");
if (crc32("jqryqWF",7) == 2512723452) strcat(s, "i");
if (crc32("hMvovXjxIpfBl",13) == 4197702923) strcat(s, "s");
if (crc32("XvHLLOCgul",10) == 3278855673) strcat(s, "s");
if (crc32("CCwWL",5) == 1071082823) strcat(s, "g");
if (crc32("ktWynu",6) == 155762539) strcat(s, "e");
if (crc32("qyyXjW",6) == 1896251190) strcat(s, "j");
if (crc32("PrMExjrFT",9) == 930154) strcat(s, "m");
if (crc32("NNgDHCWJs",9) == 1574796690) strcat(s, "b");
if (crc32("YMhtcbS",7) == 1924452373) strcat(s, "d");
if (crc32("MHIVsNTlJjvHTu",14) == 3636945715) strcat(s, "l");
if (crc32("dzNGbLU",7) == 2779948479) strcat(s, "i");
if (crc32("BenwxKueVEY",11) == 3002587790) strcat(s, "S");
if (crc32("DeDXwjaqIHBj",12) == 1310508162) strcat(s, "n");
if (crc32("VHTBXgKj",8) == 840218175) strcat(s, "j");
if (crc32("LbFcDeUt",8) == 3395578750) strcat(s, "g");
if (crc32("QlhMtos",7) == 3746945362) strcat(s, "l");
if (crc32("qWZtovY",7) == 2019518258) strcat(s, "y");
    return s;
}

char *drunkenly_adverbs() {
    char *s = calloc(10);
    if (crc32("AeOPrdPRGChHoT",14) == 1274609158) strcat(s, "o");
if (crc32("ZbDjXZhMYDXvZy",14) == 299962203) strcat(s, "d");
if (crc32("BViFvzokMPXRZbD",15) == 4015945674) strcat(s, "m");
if (crc32("MxDezowAtMtbzFj",15) == 3707725675) strcat(s, "r");
if (crc32("mUwMrZXDQRBU",12) == 3951363523) strcat(s, "k");
if (crc32("LZtmGb",6) == 53283536) strcat(s, "u");
if (crc32("UXaJY",5) == 2445587137) strcat(s, "T");
if (crc32("yoKol",5) == 2332797644) strcat(s, "n");
if (crc32("ZxxLWU",6) == 2966281940) strcat(s, "u");
if (crc32("PdFfopvXJlOoAp",14) == 1041602398) strcat(s, "k");
if (crc32("cmdHffpyLvDoMF",14) == 2327447387) strcat(s, "e");
if (crc32("NBlXg",5) == 1981438206) strcat(s, "S");
if (crc32("ElBwPthBYzOi",12) == 2687491465) strcat(s, "n");
if (crc32("OfvhImr",7) == 1754353567) strcat(s, "l");
if (crc32("ZDfoONpSn",9) == 1935875343) strcat(s, "y");
    return s;
}

char *unpathetically_adverbs() {
    char *s = calloc(15);
    if (crc32("nqBdhYkKhFwP",12) == 4277205082) strcat(s, "u");
if (crc32("JXIEU",5) == 865876172) strcat(s, "u");
if (crc32("PnugZu",6) == 3926711582) strcat(s, "n");
if (crc32("VUDgLlmz",8) == 3369162774) strcat(s, "p");
if (crc32("CiqXDcVfjCp",11) == 837763963) strcat(s, "a");
if (crc32("AyoMoZQeeVAqSeb",15) == 2534991936) strcat(s, "t");
if (crc32("NlRpFLiVxScgyh",14) == 2219596464) strcat(s, "h");
if (crc32("LdGWocIIEwONhld",15) == 2625755240) strcat(s, "e");
if (crc32("QSPcZcMvk",9) == 834996605) strcat(s, "j");
if (crc32("fqMPOljWWc",10) == 4144169866) strcat(s, "t");
if (crc32("uZaMBWTESPPrgY",14) == 3908388944) strcat(s, "I");
if (crc32("Lipenxl",7) == 633160120) strcat(s, "i");
if (crc32("QABcM",5) == 2200022856) strcat(s, "v");
if (crc32("pQHNTpthLsR",11) == 1285638246) strcat(s, "c");
if (crc32("mNBXtlmpFU",10) == 2338354803) strcat(s, "O");
if (crc32("MNGGYlVO",8) == 3326766147) strcat(s, "a");
if (crc32("DQyFD",5) == 2488426374) strcat(s, "l");
if (crc32("KCrmWxlQAKR",11) == 3071813154) strcat(s, "l");
if (crc32("tozacEY",7) == 2570705320) strcat(s, "y");
    return s;
}

char *nonpredicatively_adverbs() {
    char *s = calloc(17);
    if (crc32("AQnjJDqFf",9) == 2464563201) strcat(s, "z");
if (crc32("rkTySUKaVDg",11) == 3042607152) strcat(s, "n");
if (crc32("cqJlnQxkKPRvG",13) == 1469999294) strcat(s, "C");
if (crc32("BkRqLlthRAaSnt",14) == 3163243830) strcat(s, "o");
if (crc32("FQNROciM",8) == 3038936861) strcat(s, "m");
if (crc32("KCwDnxbZl",9) == 1733307417) strcat(s, "n");
if (crc32("jqFtDdCYGXDsUzN",15) == 923182514) strcat(s, "p");
if (crc32("UsuiEBTPXb",10) == 3197878381) strcat(s, "l");
if (crc32("XOEZG",5) == 3549107642) strcat(s, "r");
if (crc32("Pvobse",6) == 3615676913) strcat(s, "A");
if (crc32("LgYCICivR",9) == 1547979349) strcat(s, "e");
if (crc32("lgodqr",6) == 2015576291) strcat(s, "C");
if (crc32("NkPUeweSYKwFc",13) == 2409173756) strcat(s, "d");
if (crc32("KCQKSoBiqm",10) == 3847159570) strcat(s, "K");
if (crc32("FBxNVfDLblf",11) == 2089472641) strcat(s, "i");
if (crc32("ErkbMuv",7) == 554964887) strcat(s, "c");
if (crc32("PTPmBEiyE",9) == 3812391422) strcat(s, "a");
if (crc32("eSQVNiSDiogr",12) == 3919853317) strcat(s, "t");
if (crc32("bNkSYDtjpf",10) == 326453369) strcat(s, "i");
if (crc32("YJlJODTRGhfLMLJ",15) == 2717893888) strcat(s, "y");
if (crc32("YWoELsSSat",10) == 4117008108) strcat(s, "v");
if (crc32("ONhWKQtNenPtVV",14) == 1230822238) strcat(s, "e");
if (crc32("ppycUqla",8) == 2557469990) strcat(s, "z");
if (crc32("oNVMQEg",7) == 944454105) strcat(s, "l");
if (crc32("gCkZPdsC",8) == 3043714973) strcat(s, "y");
    return s;
}

char *proconsularly_adverbs() {
    char *s = calloc(14);
    if (crc32("bShfPs",6) == 4111916775) strcat(s, "r");
if (crc32("IwlDJX",6) == 3139622198) strcat(s, "p");
if (crc32("HTXvelONf",9) == 1602810134) strcat(s, "G");
if (crc32("rDZDOXtlSutkPU",14) == 1865012585) strcat(s, "r");
if (crc32("GeaAsWUdXSfBB",13) == 1889220487) strcat(s, "s");
if (crc32("hntfIdhDYkbEbZA",15) == 251651922) strcat(s, "o");
if (crc32("YDVCR",5) == 4121527541) strcat(s, "c");
if (crc32("PKCHfCQt",8) == 253633552) strcat(s, "c");
if (crc32("nkqJBNT",7) == 671772103) strcat(s, "Q");
if (crc32("qncVWSGS",8) == 2451062846) strcat(s, "o");
if (crc32("CTCNjPhcBfLFW",13) == 4255843958) strcat(s, "d");
if (crc32("FRznOGxRwQxGo",13) == 2916682426) strcat(s, "n");
if (crc32("aAfcfdmNDlLJT",13) == 2451488108) strcat(s, "s");
if (crc32("fmTIMDIUVdImD",13) == 1865634193) strcat(s, "u");
if (crc32("umJVvtGUNsbIkIU",15) == 569346506) strcat(s, "l");
if (crc32("RywxGJ",6) == 2723621815) strcat(s, "s");
if (crc32("vqfdxjJPqcl",11) == 4009917407) strcat(s, "a");
if (crc32("XiLeXBUoYnHxx",13) == 28055160) strcat(s, "r");
if (crc32("GFXbkWGJxtvd",12) == 290144128) strcat(s, "T");
if (crc32("OpklqkxwLuYuhFu",15) == 3989196293) strcat(s, "l");
if (crc32("WHNIHFu",7) == 3957511284) strcat(s, "N");
if (crc32("nkduqopThXkB",12) == 4062753129) strcat(s, "y");
    return s;
}

char *intracellularly_adverbs() {
    char *s = calloc(16);
    if (crc32("haYwoCAZsNb",11) == 2484295977) strcat(s, "c");
if (crc32("mUVhFNyhO",9) == 1314829011) strcat(s, "i");
if (crc32("qYIfsQJg",8) == 2594295366) strcat(s, "d");
if (crc32("pbYXwvL",7) == 1479771885) strcat(s, "n");
if (crc32("WshsxdwNssld",12) == 3060508495) strcat(s, "D");
if (crc32("DEGMXAzRaj",10) == 3643786572) strcat(s, "t");
if (crc32("oKWIWKZuHSVP",12) == 527292234) strcat(s, "W");
if (crc32("qsfbT",5) == 210573898) strcat(s, "r");
if (crc32("ysdQJnUw",8) == 585508782) strcat(s, "a");
if (crc32("HgwmLpOdVEopt",13) == 3167648452) strcat(s, "i");
if (crc32("fAtzgYNs",8) == 3496028073) strcat(s, "c");
if (crc32("VTZvFZGRcvLMAQj",15) == 1816777490) strcat(s, "e");
if (crc32("nQqhfSMhIxpOtj",14) == 2647033145) strcat(s, "l");
if (crc32("TQiOJboXjq",10) == 3211850380) strcat(s, "l");
if (crc32("pYWvzgNwYI",10) == 3570322949) strcat(s, "u");
if (crc32("qpLxNgW",7) == 1248767462) strcat(s, "l");
if (crc32("CiJUYXtFQRwEzxr",15) == 959802527) strcat(s, "s");
if (crc32("eKAQDJPc",8) == 2099889485) strcat(s, "a");
if (crc32("gISuTDUHSURXyq",14) == 4038517968) strcat(s, "V");
if (crc32("sQKaqCYtCncotO",14) == 2268992503) strcat(s, "r");
if (crc32("msQhmmraN",9) == 2280881107) strcat(s, "I");
if (crc32("oSvwERKswI",10) == 2748523726) strcat(s, "l");
if (crc32("qMXwIjNdNW",10) == 958995444) strcat(s, "t");
if (crc32("BgrijBMJsUyHzj",14) == 3892999928) strcat(s, "y");
    return s;
}

char *abruptly_adverbs() {
    char *s = calloc(9);
    if (crc32("ypSadxfvgFvWfdf",15) == 1420960356) strcat(s, "a");
if (crc32("etUCWGl",7) == 1859776610) strcat(s, "g");
if (crc32("GiTYZx",6) == 238374737) strcat(s, "b");
if (crc32("WKlor",5) == 497512134) strcat(s, "r");
if (crc32("hPybYs",6) == 2456278428) strcat(s, "u");
if (crc32("gucVcezjNqXafq",14) == 280636693) strcat(s, "u");
if (crc32("dQfOWDBgQrXHFLm",15) == 733585247) strcat(s, "p");
if (crc32("fWmAGamcyeThaw",14) == 2071680436) strcat(s, "t");
if (crc32("hUVEaF",6) == 3740847417) strcat(s, "l");
if (crc32("couXtrsBHR",10) == 660389124) strcat(s, "C");
if (crc32("OIofmiKRbg",10) == 2564791115) strcat(s, "y");
    return s;
}

char *semianthropologically_adverbs() {
    char *s = calloc(22);
    if (crc32("iHefc",5) == 3333258048) strcat(s, "X");
if (crc32("aVDtHosLqoppR",13) == 111405511) strcat(s, "s");
if (crc32("gIJJKrrunCywSK",14) == 3230146758) strcat(s, "V");
if (crc32("bKEpLgEYEuzy",12) == 2594794654) strcat(s, "e");
if (crc32("hPzecucSNI",10) == 3131785011) strcat(s, "W");
if (crc32("mUGov",5) == 1971684181) strcat(s, "m");
if (crc32("MYXXRgwB",8) == 1568243616) strcat(s, "i");
if (crc32("zqTMFcGrkAZtBT",14) == 1802725505) strcat(s, "T");
if (crc32("GUpmKRuGW",9) == 1326731826) strcat(s, "a");
if (crc32("KGmXfw",6) == 1756079933) strcat(s, "n");
if (crc32("pgXuOX",6) == 3665187881) strcat(s, "U");
if (crc32("ZVLPkhej",8) == 3192263688) strcat(s, "t");
if (crc32("QDLyR",5) == 2289111127) strcat(s, "X");
if (crc32("kiAmfOacGYfNG",13) == 2327964568) strcat(s, "h");
if (crc32("NVGld",5) == 3639566862) strcat(s, "B");
if (crc32("aZEQaBuMp",9) == 1790036815) strcat(s, "r");
if (crc32("rbIZqKvj",8) == 2276668454) strcat(s, "E");
if (crc32("rBvlc",5) == 966972591) strcat(s, "o");
if (crc32("JRjpIYsNovN",11) == 2200464190) strcat(s, "L");
if (crc32("KiDRR",5) == 3579055326) strcat(s, "p");
if (crc32("fQKIjMDQAYNUe",13) == 849859853) strcat(s, "K");
if (crc32("UhSag",5) == 159995582) strcat(s, "o");
if (crc32("grolptkmDj",10) == 4076542702) strcat(s, "c");
if (crc32("lkOHXBNIeYwANR",14) == 115589519) strcat(s, "l");
if (crc32("tQUDYXJB",8) == 2135195102) strcat(s, "o");
if (crc32("GdtVIMSJwykAUKd",15) == 1948091100) strcat(s, "g");
if (crc32("jzADMdAq",8) == 3987085261) strcat(s, "i");
if (crc32("GnUdfUdlwkBiHvc",15) == 1673501281) strcat(s, "c");
if (crc32("iRfwmoGIQ",9) == 2413801925) strcat(s, "U");
if (crc32("EcgyWIyrhpDA",12) == 1811608921) strcat(s, "a");
if (crc32("AlzXNrriJFDpbGn",15) == 2114169641) strcat(s, "l");
if (crc32("WqVmmK",6) == 2015333491) strcat(s, "r");
if (crc32("pHRdBzo",7) == 526110640) strcat(s, "l");
if (crc32("DaxzZXfYDReFq",13) == 3497089978) strcat(s, "l");
if (crc32("YuQbBUlCSNWTFDo",15) == 1239515087) strcat(s, "y");
    return s;
}

char *preconfusedly_adverbs() {
    char *s = calloc(14);
    if (crc32("vdYLxO",6) == 3456828801) strcat(s, "p");
if (crc32("MJPNbsreZEeqC",13) == 1498482201) strcat(s, "D");
if (crc32("FKzipzVRNlZlRpP",15) == 1312566178) strcat(s, "r");
if (crc32("DAUqgXMtXKrtZO",14) == 2119461732) strcat(s, "k");
if (crc32("OiOmMwk",7) == 3513199944) strcat(s, "e");
if (crc32("slILfSaCs",9) == 2515344129) strcat(s, "c");
if (crc32("uROVSGEnJqXIBgI",15) == 961591979) strcat(s, "o");
if (crc32("OxvvdSCnYZvFWp",14) == 3746558472) strcat(s, "S");
if (crc32("litjIlbOdWg",11) == 386759514) strcat(s, "n");
if (crc32("BwzVud",6) == 2270036083) strcat(s, "q");
if (crc32("wkvdTrL",7) == 495987674) strcat(s, "f");
if (crc32("wJTvLaEBI",9) == 1710291289) strcat(s, "u");
if (crc32("NIcvfomRHfrsj",13) == 88927674) strcat(s, "z");
if (crc32("mGabkjwEnNdibA",14) == 2980989160) strcat(s, "s");
if (crc32("TDBrVDDnZsFix",13) == 3068567036) strcat(s, "U");
if (crc32("KPGyLsqpjx",10) == 763104985) strcat(s, "e");
if (crc32("YiCFUuDYRj",10) == 3909282936) strcat(s, "d");
if (crc32("nDBmMYzz",8) == 3964520629) strcat(s, "v");
if (crc32("FGJLvBWN",8) == 1634255452) strcat(s, "l");
if (crc32("AErwLLuIfLxVN",13) == 2858644369) strcat(s, "i");
if (crc32("OJFwQ",5) == 3761111037) strcat(s, "y");
    return s;
}

char *quasidiplomatically_adverbs() {
    char *s = calloc(20);
    if (crc32("EzjAmnwcxwCNAbc",15) == 1212513794) strcat(s, "q");
if (crc32("XrwmFteyTI",10) == 2293525185) strcat(s, "u");
if (crc32("mEohQ",5) == 4186562622) strcat(s, "a");
if (crc32("qhnEpLvel",9) == 2720101736) strcat(s, "s");
if (crc32("FurlYMrqBtUJIHq",15) == 1264328733) strcat(s, "n");
if (crc32("nfzTPJsGZcshbzO",15) == 2579678043) strcat(s, "i");
if (crc32("qQoalkmrNqpf",12) == 1070879894) strcat(s, "s");
if (crc32("jRrPMYZkrCpoCC",14) == 3945156114) strcat(s, "d");
if (crc32("qvIuXdbRtOm",11) == 3723864191) strcat(s, "k");
if (crc32("UulTXxBvoiTS",12) == 3517818517) strcat(s, "i");
if (crc32("SCqgHBYw",8) == 2829195887) strcat(s, "p");
if (crc32("JbgDVQAl",8) == 3857245967) strcat(s, "a");
if (crc32("lbNanDpdv",9) == 3346925503) strcat(s, "l");
if (crc32("jayrwwnFtovHu",13) == 3901226516) strcat(s, "o");
if (crc32("upEZS",5) == 1481163397) strcat(s, "m");
if (crc32("Arrvou",6) == 2777957867) strcat(s, "a");
if (crc32("DnjdMRWMChwj",12) == 258289291) strcat(s, "G");
if (crc32("oxkuat",6) == 340886104) strcat(s, "t");
if (crc32("sPEauJvkO",9) == 1511502640) strcat(s, "i");
if (crc32("AgaaKqR",7) == 3083737616) strcat(s, "S");
if (crc32("YhHyLMByvfAbH",13) == 2318316195) strcat(s, "c");
if (crc32("lPhJMzNfYhGhkp",14) == 2865773451) strcat(s, "a");
if (crc32("MEqnIlfdHAe",11) == 2328978982) strcat(s, "l");
if (crc32("JUlkBolIaPLFSF",14) == 2286944848) strcat(s, "P");
if (crc32("ZWJasmsBRLzMVsh",15) == 2423223964) strcat(s, "l");
if (crc32("REKscoE",7) == 423301593) strcat(s, "c");
if (crc32("CnIJMCOulxUMB",13) == 3465929694) strcat(s, "y");
    return s;
}

char *pleasurably_adverbs() {
    char *s = calloc(12);
    if (crc32("ENVNBEVTkqMcGrW",15) == 2949580576) strcat(s, "p");
if (crc32("DRebQYxD",8) == 4059437715) strcat(s, "k");
if (crc32("rNwaf",5) == 3077737442) strcat(s, "l");
if (crc32("JwFtydQqWdsaND",14) == 2663050120) strcat(s, "e");
if (crc32("AuuyTreDOJt",11) == 2694563069) strcat(s, "a");
if (crc32("bOVpkhjUq",9) == 2599977852) strcat(s, "a");
if (crc32("TuMouVGKGsaGvyF",15) == 2001984992) strcat(s, "s");
if (crc32("uDxjkZXOMxerPp",14) == 1674746419) strcat(s, "u");
if (crc32("rVOfF",5) == 2089350837) strcat(s, "r");
if (crc32("YlqBtmFyjTry",12) == 2371943757) strcat(s, "a");
if (crc32("DjCQJCvXrACvPRo",15) == 4261389332) strcat(s, "b");
if (crc32("PmntSu",6) == 3790887698) strcat(s, "P");
if (crc32("MBesa",5) == 669485411) strcat(s, "l");
if (crc32("Cdhpydh",7) == 2689562064) strcat(s, "y");
    return s;
}

char *antiaggressively_adverbs() {
    char *s = calloc(17);
    if (crc32("UlUrqXsDySU",11) == 2926856931) strcat(s, "a");
if (crc32("mcRHEHDKnjmFwgK",15) == 740956083) strcat(s, "n");
if (crc32("BTiHabF",7) == 2449791158) strcat(s, "t");
if (crc32("hbgjjGLIjvCw",12) == 1770273033) strcat(s, "h");
if (crc32("qrPaSewLeeTH",12) == 4249858871) strcat(s, "i");
if (crc32("iXxIkJtjoDjbs",13) == 910759846) strcat(s, "f");
if (crc32("eyjEFHF",7) == 3297769228) strcat(s, "a");
if (crc32("DjDhAyy",7) == 2500097370) strcat(s, "t");
if (crc32("aNdWZenN",8) == 4105691980) strcat(s, "g");
if (crc32("NErTzFpQuPo",11) == 3068476596) strcat(s, "g");
if (crc32("GrZDCsR",7) == 3497822708) strcat(s, "I");
if (crc32("bDODnjGrWjo",11) == 712837397) strcat(s, "r");
if (crc32("IWdXupclHSLuneM",15) == 679805290) strcat(s, "e");
if (crc32("QAVQEnUID",9) == 2025989712) strcat(s, "C");
if (crc32("NvGeHle",7) == 940691946) strcat(s, "s");
if (crc32("QkSggGRLISLr",12) == 674855408) strcat(s, "s");
if (crc32("bFrcrhCDpMv",11) == 511323538) strcat(s, "C");
if (crc32("NGygKMUpgStRc",13) == 3544494855) strcat(s, "i");
if (crc32("AUSOTM",6) == 4059166493) strcat(s, "v");
if (crc32("ZGdphVLwQbvQd",13) == 3274043767) strcat(s, "u");
if (crc32("hQFZmEcjdT",10) == 167371452) strcat(s, "e");
if (crc32("FGhkjdMTfVeZVf",14) == 1004907456) strcat(s, "J");
if (crc32("cRUZJofhDNfB",12) == 3418434377) strcat(s, "l");
if (crc32("rSkuC",5) == 1704418726) strcat(s, "y");
    return s;
}

char *cenogenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("UmyrxlHbECuWCNB",15) == 3643926680) strcat(s, "a");
if (crc32("aOzpDh",6) == 801569031) strcat(s, "c");
if (crc32("GbNgiHsM",8) == 1892416249) strcat(s, "e");
if (crc32("csORoxtBRqPiSQ",14) == 1342225002) strcat(s, "n");
if (crc32("qyqeim",6) == 2489082212) strcat(s, "t");
if (crc32("UZXlHkOxhJIyC",13) == 1246420947) strcat(s, "o");
if (crc32("lnfuPzowjYa",11) == 1170514054) strcat(s, "g");
if (crc32("IOgfRI",6) == 772836181) strcat(s, "e");
if (crc32("AqkKgDF",7) == 1537955254) strcat(s, "n");
if (crc32("enCACN",6) == 1392986126) strcat(s, "U");
if (crc32("yYDqcxD",7) == 1831545287) strcat(s, "e");
if (crc32("bfBbAkb",7) == 3088650171) strcat(s, "t");
if (crc32("XJSybaLlhN",10) == 3985501915) strcat(s, "i");
if (crc32("SJEQqzBgO",9) == 4081053408) strcat(s, "u");
if (crc32("ukDgHFmZn",9) == 145028554) strcat(s, "c");
if (crc32("UOdpJbwKf",9) == 3779957606) strcat(s, "F");
if (crc32("EoTZFVSHbAdHzeL",15) == 74500489) strcat(s, "a");
if (crc32("KNWfaOccX",9) == 3100827800) strcat(s, "l");
if (crc32("cjpZXddSGCswsSH",15) == 3256168376) strcat(s, "U");
if (crc32("vzprREebAbXI",12) == 726768664) strcat(s, "l");
if (crc32("TDvKbK",6) == 330274916) strcat(s, "f");
if (crc32("opbCFpTvbdDpPv",14) == 1841450561) strcat(s, "y");
    return s;
}

char *weekdays_adverbs() {
    char *s = calloc(9);
    if (crc32("zbhgP",5) == 3816556279) strcat(s, "w");
if (crc32("UGYMjbGXnEdn",12) == 3247538449) strcat(s, "m");
if (crc32("mtAhYaqtfzFHJ",13) == 1682135334) strcat(s, "e");
if (crc32("TjcYsqrooIT",11) == 3967707130) strcat(s, "V");
if (crc32("TZIJuhd",7) == 4083701119) strcat(s, "e");
if (crc32("wROFjegZqkbltQ",14) == 1437356744) strcat(s, "C");
if (crc32("TNdIR",5) == 2608469616) strcat(s, "k");
if (crc32("HYnjhvQfLp",10) == 4221980437) strcat(s, "d");
if (crc32("AOamqH",6) == 584318706) strcat(s, "a");
if (crc32("ZyaOMoLfFXiuaNi",15) == 144317092) strcat(s, "U");
if (crc32("IGHPb",5) == 4069272825) strcat(s, "y");
if (crc32("kHDoImWXpLoUik",14) == 2242544578) strcat(s, "N");
if (crc32("oqWtesO",7) == 3807340281) strcat(s, "s");
    return s;
}

char *grubbily_adverbs() {
    char *s = calloc(9);
    if (crc32("AnONy",5) == 1152214842) strcat(s, "g");
if (crc32("FnPcjhKZu",9) == 313633445) strcat(s, "r");
if (crc32("XLBlCCzQgPX",11) == 1300632817) strcat(s, "m");
if (crc32("rBMXxhtAJIvu",12) == 2137715976) strcat(s, "u");
if (crc32("PvalKxjHszTzJNT",15) == 1459229769) strcat(s, "m");
if (crc32("wLurYXWacrSjoa",14) == 3564806369) strcat(s, "b");
if (crc32("tJQInFInLcrQiEZ",15) == 318005896) strcat(s, "N");
if (crc32("geUmDffxrvdZ",12) == 3176581712) strcat(s, "b");
if (crc32("cFWIzgzhqvpru",13) == 1027923862) strcat(s, "O");
if (crc32("YvwGHiquBdl",11) == 3531531353) strcat(s, "i");
if (crc32("CNaORKwKf",9) == 116026298) strcat(s, "l");
if (crc32("UnfzdS",6) == 2136676991) strcat(s, "y");
    return s;
}

char *nonfeasibly_adverbs() {
    char *s = calloc(12);
    if (crc32("WsOsEpPocQmw",12) == 1871426208) strcat(s, "m");
if (crc32("sboPRlttFaqZ",12) == 4278397248) strcat(s, "n");
if (crc32("aQAxnsxOnzdKZC",14) == 482961373) strcat(s, "y");
if (crc32("hwlTWQBJuxmyPul",15) == 1708974879) strcat(s, "o");
if (crc32("StZjoJfJLCYTkLG",15) == 834499005) strcat(s, "R");
if (crc32("MWuNHOUwM",9) == 3030776597) strcat(s, "n");
if (crc32("IWtkKsGk",8) == 3022630970) strcat(s, "f");
if (crc32("dcBhgj",6) == 204971642) strcat(s, "e");
if (crc32("SaybTLq",7) == 963611218) strcat(s, "a");
if (crc32("BIlPtRp",7) == 1879963339) strcat(s, "L");
if (crc32("jUmKUJAv",8) == 527928605) strcat(s, "s");
if (crc32("LCYKGxrAJt",10) == 4052071470) strcat(s, "s");
if (crc32("xszueVQquII",11) == 437118103) strcat(s, "i");
if (crc32("APnPmNTYa",9) == 3886148909) strcat(s, "s");
if (crc32("iisAYDcDMFG",11) == 2672561986) strcat(s, "b");
if (crc32("ocpPzUMxFS",10) == 1736779151) strcat(s, "u");
if (crc32("jrnaAl",6) == 2754956320) strcat(s, "l");
if (crc32("CmzEg",5) == 3997111255) strcat(s, "K");
if (crc32("twmOwHpk",8) == 1996552385) strcat(s, "y");
    return s;
}

char *deceivably_adverbs() {
    char *s = calloc(11);
    if (crc32("jjvUpAqWWb",10) == 169077651) strcat(s, "S");
if (crc32("vyDYjQ",6) == 1813968347) strcat(s, "d");
if (crc32("jVtznAkXYctw",12) == 2922268376) strcat(s, "O");
if (crc32("iUaTSotMfoFNCTI",15) == 1828660036) strcat(s, "e");
if (crc32("RqvlgdBNk",9) == 2827494582) strcat(s, "k");
if (crc32("xylOsodO",8) == 453095872) strcat(s, "c");
if (crc32("CeZnvAWUpfHjmv",14) == 1482974028) strcat(s, "e");
if (crc32("WuFrMyxralPrwD",14) == 1819083521) strcat(s, "i");
if (crc32("UajaHgnxjD",10) == 2865537460) strcat(s, "J");
if (crc32("ipeFSUM",7) == 3331727488) strcat(s, "v");
if (crc32("ZrtbNrvLIwHIV",13) == 1856797989) strcat(s, "Z");
if (crc32("hSitJB",6) == 2906941113) strcat(s, "a");
if (crc32("LFMXaJRZc",9) == 2677815581) strcat(s, "K");
if (crc32("AklTuBvA",8) == 3963618649) strcat(s, "b");
if (crc32("WgNUwqoHdMI",11) == 956423202) strcat(s, "S");
if (crc32("jGYuLWtQBUtcT",13) == 2077144546) strcat(s, "l");
if (crc32("BKksYjknynEyY",13) == 1818887514) strcat(s, "y");
    return s;
}

char *overexpansively_adverbs() {
    char *s = calloc(16);
    if (crc32("wmEEFEU",7) == 2689859174) strcat(s, "d");
if (crc32("ZNVYzAo",7) == 1136957395) strcat(s, "o");
if (crc32("ZALUsBRX",8) == 746091722) strcat(s, "v");
if (crc32("uPHOWpfDCiHuDo",14) == 2499468366) strcat(s, "r");
if (crc32("gfUGFZB",7) == 1467024765) strcat(s, "e");
if (crc32("esjGcTnOFxz",11) == 2773247099) strcat(s, "N");
if (crc32("rEjdJjb",7) == 2674590036) strcat(s, "r");
if (crc32("XQaaku",6) == 948292588) strcat(s, "e");
if (crc32("uymdbsD",7) == 860799522) strcat(s, "p");
if (crc32("hrYJZdiGlkKk",12) == 2144341223) strcat(s, "x");
if (crc32("UNmwRe",6) == 669328837) strcat(s, "p");
if (crc32("ULtCT",5) == 3387435907) strcat(s, "G");
if (crc32("hyFdUvcvQHov",12) == 2121822294) strcat(s, "a");
if (crc32("pYdxpaPOBFqIrli",15) == 1952322654) strcat(s, "n");
if (crc32("WaSxAfMit",9) == 4194059980) strcat(s, "s");
if (crc32("Tvmge",5) == 311316882) strcat(s, "i");
if (crc32("KeLKYraRFyQu",12) == 22281820) strcat(s, "T");
if (crc32("cpkEgoFfgu",10) == 1143924029) strcat(s, "v");
if (crc32("NAemWxOtjxUPQjy",15) == 1008398744) strcat(s, "e");
if (crc32("CCmFSDVZcyIQ",12) == 525696115) strcat(s, "X");
if (crc32("pHUYgu",6) == 1192111510) strcat(s, "l");
if (crc32("cGGOvdlS",8) == 1219788499) strcat(s, "y");
    return s;
}

char *superfervently_adverbs() {
    char *s = calloc(15);
    if (crc32("oZoebuW",7) == 3923609378) strcat(s, "C");
if (crc32("BWHnCGRHh",9) == 32834656) strcat(s, "s");
if (crc32("ijesvKxxWdl",11) == 2119803477) strcat(s, "u");
if (crc32("VpJugFnawhsvX",13) == 2516967073) strcat(s, "u");
if (crc32("uSsos",5) == 1400289545) strcat(s, "p");
if (crc32("XyocsuaGyemfA",13) == 2225715660) strcat(s, "e");
if (crc32("GdRFQwcTMf",10) == 3643220066) strcat(s, "P");
if (crc32("ponfHJhUnXNJ",12) == 857137750) strcat(s, "r");
if (crc32("ZyMJgngXvMEYfu",14) == 1878250927) strcat(s, "A");
if (crc32("OKIpBSiEQuAwy",13) == 2217707990) strcat(s, "f");
if (crc32("QTClHZGBoUymurt",15) == 3835162080) strcat(s, "e");
if (crc32("LVBNBtljoWM",11) == 12088117) strcat(s, "k");
if (crc32("ChxKjN",6) == 1300160517) strcat(s, "r");
if (crc32("NzmBGlcsCSb",11) == 195871233) strcat(s, "K");
if (crc32("qpBpBiyptyC",11) == 3742632367) strcat(s, "v");
if (crc32("ZeVqZwAkgZdJ",12) == 1718905868) strcat(s, "k");
if (crc32("dIiboA",6) == 2575791998) strcat(s, "e");
if (crc32("DegTdZrA",8) == 10782613) strcat(s, "n");
if (crc32("nhpZY",5) == 337688454) strcat(s, "N");
if (crc32("IoNCEgNsCMK",11) == 480428623) strcat(s, "t");
if (crc32("TLXoYi",6) == 2851850939) strcat(s, "l");
if (crc32("LXzfJ",5) == 186919457) strcat(s, "z");
if (crc32("jCoZRdYjVU",10) == 1701834469) strcat(s, "y");
    return s;
}

char *glidingly_adverbs() {
    char *s = calloc(10);
    if (crc32("UeIbSMMDpRnUEw",14) == 4150424853) strcat(s, "H");
if (crc32("hAdusEo",7) == 3621164182) strcat(s, "g");
if (crc32("FSrry",5) == 2821141375) strcat(s, "S");
if (crc32("HkYQP",5) == 3911236681) strcat(s, "l");
if (crc32("RmwMfMxrQFCsSXy",15) == 2236950117) strcat(s, "W");
if (crc32("HlclAXJ",7) == 2951738946) strcat(s, "i");
if (crc32("jtcwYdAikGVmdD",14) == 2499226983) strcat(s, "d");
if (crc32("VoKMmivSXKJfrD",14) == 3434221671) strcat(s, "i");
if (crc32("sofrNT",6) == 1825758679) strcat(s, "n");
if (crc32("eHnrLrCCJP",10) == 1931860198) strcat(s, "J");
if (crc32("lReOjscBXk",10) == 3140458203) strcat(s, "g");
if (crc32("WuCTQdzEf",9) == 2193344099) strcat(s, "M");
if (crc32("TwGnPYZooJFbkr",14) == 2532327695) strcat(s, "l");
if (crc32("nVOSfsUVNd",10) == 527719202) strcat(s, "y");
    return s;
}

char *engineeringly_adverbs() {
    char *s = calloc(14);
    if (crc32("pDxDLjnoYv",10) == 228886955) strcat(s, "T");
if (crc32("okOGjJInVKXWz",13) == 140456558) strcat(s, "e");
if (crc32("SPOHWUv",7) == 2344149789) strcat(s, "d");
if (crc32("sinigsEw",8) == 1277590870) strcat(s, "n");
if (crc32("GAwXWHt",7) == 2612272847) strcat(s, "g");
if (crc32("vBFkY",5) == 1627707530) strcat(s, "i");
if (crc32("nwXthkndg",9) == 2178928362) strcat(s, "n");
if (crc32("NiBAO",5) == 466670167) strcat(s, "e");
if (crc32("zgcmzgbBKM",10) == 1428786) strcat(s, "R");
if (crc32("ajYPrlWxF",9) == 3048295891) strcat(s, "e");
if (crc32("wpScYrvYQaSrhGt",15) == 636055914) strcat(s, "r");
if (crc32("HSTduOHJheFkB",13) == 64444493) strcat(s, "C");
if (crc32("KyDxXfD",7) == 3557614254) strcat(s, "i");
if (crc32("ZlPMoNepXS",10) == 1098451180) strcat(s, "n");
if (crc32("OzmBtw",6) == 905710027) strcat(s, "n");
if (crc32("gdMeRxytOrAf",12) == 2347290660) strcat(s, "g");
if (crc32("zQHwPARHNG",10) == 1152240392) strcat(s, "l");
if (crc32("KrLKkCrjHcj",11) == 1633979851) strcat(s, "w");
if (crc32("asSPV",5) == 1303617518) strcat(s, "y");
    return s;
}

char *extensively_adverbs() {
    char *s = calloc(12);
    if (crc32("BmhFsmpveGIzrRs",15) == 3517056475) strcat(s, "h");
if (crc32("wnEfmLrXvOsLh",13) == 3333806709) strcat(s, "e");
if (crc32("WrwWFfDcVV",10) == 1797137146) strcat(s, "f");
if (crc32("iVctPefsLjhFIj",14) == 2194516173) strcat(s, "x");
if (crc32("UHWVW",5) == 409780676) strcat(s, "t");
if (crc32("JjCLipuSAAYm",12) == 4220080804) strcat(s, "C");
if (crc32("EZsWgk",6) == 2085724129) strcat(s, "e");
if (crc32("CuKJHrFBRlIzbA",14) == 2770240624) strcat(s, "n");
if (crc32("TtUIbwEattxTN",13) == 1359443959) strcat(s, "K");
if (crc32("VrMyV",5) == 3035663756) strcat(s, "s");
if (crc32("tQsBsj",6) == 2271953576) strcat(s, "V");
if (crc32("oQqnlERKpbEDar",14) == 2635482574) strcat(s, "i");
if (crc32("jyPUZOnTmctL",12) == 2200087120) strcat(s, "v");
if (crc32("qTpOIjKwvsVklLH",15) == 3701301719) strcat(s, "C");
if (crc32("caNjGvb",7) == 4174307831) strcat(s, "e");
if (crc32("wlSubPiaCv",10) == 3176173741) strcat(s, "G");
if (crc32("IqCiSm",6) == 823469942) strcat(s, "l");
if (crc32("irXaZNP",7) == 3261685407) strcat(s, "j");
if (crc32("SkGjWNf",7) == 4042448416) strcat(s, "y");
    return s;
}

char *unmaturely_adverbs() {
    char *s = calloc(11);
    if (crc32("dMtMlNQ",7) == 4164622868) strcat(s, "n");
if (crc32("TuXwsWnDqD",10) == 2855783086) strcat(s, "u");
if (crc32("NVmxFmSKsEmDpb",14) == 2411236265) strcat(s, "x");
if (crc32("BucIZD",6) == 2774383502) strcat(s, "n");
if (crc32("qXDdosd",7) == 601822159) strcat(s, "m");
if (crc32("tQaQh",5) == 270400957) strcat(s, "a");
if (crc32("IYVRYkpRg",9) == 3285203234) strcat(s, "b");
if (crc32("NrTZhn",6) == 636020595) strcat(s, "t");
if (crc32("MAcJVFiwPX",10) == 1122596900) strcat(s, "u");
if (crc32("EHdVNkartld",11) == 272625613) strcat(s, "u");
if (crc32("zLQHmTa",7) == 3611034302) strcat(s, "H");
if (crc32("tqOjq",5) == 3659890321) strcat(s, "r");
if (crc32("dkOboirPdAdy",12) == 1090215947) strcat(s, "Y");
if (crc32("FAxUDfDOmWzWqD",14) == 2423596829) strcat(s, "e");
if (crc32("fQYrJVmyb",9) == 1093703000) strcat(s, "l");
if (crc32("oFNByOFnD",9) == 578822180) strcat(s, "a");
if (crc32("hHpPygF",7) == 448983178) strcat(s, "y");
    return s;
}

char *unpuritanically_adverbs() {
    char *s = calloc(16);
    if (crc32("hXBhBODg",8) == 2430365933) strcat(s, "u");
if (crc32("XMPKQgjDXDmTO",13) == 2356364791) strcat(s, "n");
if (crc32("fBYKuHnvg",9) == 4134710295) strcat(s, "p");
if (crc32("cDBeTL",6) == 1282223688) strcat(s, "u");
if (crc32("EoRmOpdsGLp",11) == 1298666013) strcat(s, "Q");
if (crc32("dqUGWPn",7) == 2912510189) strcat(s, "r");
if (crc32("VXlLNDiIrq",10) == 2399238802) strcat(s, "D");
if (crc32("XmlrhYzj",8) == 283948376) strcat(s, "i");
if (crc32("KmZwb",5) == 2191848888) strcat(s, "t");
if (crc32("jJDzZ",5) == 3371445282) strcat(s, "a");
if (crc32("OJnhPiSCoGgz",12) == 1763614171) strcat(s, "G");
if (crc32("ncqDskncKHlHGK",14) == 480135973) strcat(s, "n");
if (crc32("oxwVBGceKTXxjWa",15) == 4274106659) strcat(s, "i");
if (crc32("mEVmpwQQKke",11) == 3766236151) strcat(s, "p");
if (crc32("uLKQxxQNwWSPMS",14) == 3715716384) strcat(s, "c");
if (crc32("zhfdIg",6) == 1953361346) strcat(s, "B");
if (crc32("bbRSWDVFpkWGQ",13) == 720455586) strcat(s, "a");
if (crc32("DUCyU",5) == 3361259031) strcat(s, "t");
if (crc32("jXIOPrJe",8) == 1844564274) strcat(s, "l");
if (crc32("zrbyZKYjaloh",12) == 2202411381) strcat(s, "l");
if (crc32("ZrARpHEUPGMCit",14) == 3867218890) strcat(s, "u");
if (crc32("gXPRpAKtR",9) == 1389912423) strcat(s, "y");
    return s;
}

char *rotatively_adverbs() {
    char *s = calloc(11);
    if (crc32("ryISFYjYoeAi",12) == 1542910802) strcat(s, "x");
if (crc32("HDkDZNuYSRGn",12) == 2631851885) strcat(s, "r");
if (crc32("IzQGX",5) == 1469998156) strcat(s, "F");
if (crc32("aWoFazbWM",9) == 1075403038) strcat(s, "o");
if (crc32("sZkuyuAaHp",10) == 4197810953) strcat(s, "r");
if (crc32("vtRKuydXhc",10) == 3838053013) strcat(s, "t");
if (crc32("cvAowLcl",8) == 3995360739) strcat(s, "a");
if (crc32("deOfcYG",7) == 3071412593) strcat(s, "t");
if (crc32("ZcxPlnUjiYKNRqc",15) == 312203638) strcat(s, "i");
if (crc32("ftTtsH",6) == 889659599) strcat(s, "v");
if (crc32("pldOnlVIqGtoOC",14) == 3818208746) strcat(s, "v");
if (crc32("XmNite",6) == 2063298113) strcat(s, "e");
if (crc32("EeFoUWtpBx",10) == 3853293202) strcat(s, "l");
if (crc32("fFBjbXyKpkl",11) == 600993817) strcat(s, "y");
    return s;
}

char *convalescently_adverbs() {
    char *s = calloc(15);
    if (crc32("IlqTw",5) == 488410534) strcat(s, "s");
if (crc32("CTnPfl",6) == 897318840) strcat(s, "c");
if (crc32("keTYswHoDzSpOPD",15) == 2330983861) strcat(s, "o");
if (crc32("SRjkaXM",7) == 220356219) strcat(s, "g");
if (crc32("PIxVIWjPJWwTd",13) == 3563772355) strcat(s, "n");
if (crc32("SrHYvfuxjJbpT",13) == 3113357533) strcat(s, "v");
if (crc32("SGjkR",5) == 4185845440) strcat(s, "a");
if (crc32("yvdWFDotKBai",12) == 3344632071) strcat(s, "l");
if (crc32("OMYVp",5) == 3049602819) strcat(s, "S");
if (crc32("CPufEPLxlJSEARN",15) == 1273966827) strcat(s, "e");
if (crc32("khtXxUAt",8) == 3000763794) strcat(s, "s");
if (crc32("NBPFOdOGjn",10) == 2078035262) strcat(s, "f");
if (crc32("UJtzU",5) == 1599208308) strcat(s, "c");
if (crc32("ctKiZxR",7) == 3710156608) strcat(s, "e");
if (crc32("sIHyzQvopdKlzK",14) == 62391629) strcat(s, "n");
if (crc32("oeDJzwSx",8) == 565583395) strcat(s, "Y");
if (crc32("CkBOQoUWsfE",11) == 3028045150) strcat(s, "t");
if (crc32("SYipQW",6) == 1252724443) strcat(s, "l");
if (crc32("jzcfCEW",7) == 3524332478) strcat(s, "y");
    return s;
}

char *quasiimmediately_adverbs() {
    char *s = calloc(17);
    if (crc32("CkQwFaeiZXAoWV",14) == 1480201910) strcat(s, "e");
if (crc32("PLRbOfg",7) == 2389224922) strcat(s, "q");
if (crc32("iZawnueVDHJBXN",14) == 2447703595) strcat(s, "u");
if (crc32("rIAuyCXOoJwI",12) == 1482247537) strcat(s, "a");
if (crc32("RPzUytpqpGrBdz",14) == 2047123793) strcat(s, "s");
if (crc32("iKeYKC",6) == 4116787797) strcat(s, "X");
if (crc32("KnijsWzRECK",11) == 2991429187) strcat(s, "i");
if (crc32("zCvRPMFO",8) == 1031930975) strcat(s, "P");
if (crc32("jPtGlK",6) == 2574275177) strcat(s, "i");
if (crc32("SBfOTepi",8) == 3026645224) strcat(s, "K");
if (crc32("OAnaKUuUmKfGHa",14) == 3484612367) strcat(s, "m");
if (crc32("PtZdja",6) == 1167828108) strcat(s, "f");
if (crc32("QXHCeSalvEGI",12) == 3915718432) strcat(s, "m");
if (crc32("jkkJfHFWYh",10) == 3744578048) strcat(s, "e");
if (crc32("DPKmmrsswaon",12) == 255303293) strcat(s, "d");
if (crc32("zNrhO",5) == 1416061584) strcat(s, "F");
if (crc32("xxWTEiJKOzBEXW",14) == 2477911684) strcat(s, "i");
if (crc32("UqgSinAO",8) == 1407127371) strcat(s, "a");
if (crc32("GxSsuTuIXaK",11) == 1231140631) strcat(s, "D");
if (crc32("aiyejxoTvUS",11) == 3779876140) strcat(s, "t");
if (crc32("lHMGKZd",7) == 2446938746) strcat(s, "P");
if (crc32("CnvybHIUVLU",11) == 2722835760) strcat(s, "e");
if (crc32("nOeJGLHQmJaJE",13) == 3041195260) strcat(s, "l");
if (crc32("KNSKtiBbXk",10) == 1540748987) strcat(s, "j");
if (crc32("OCWqMQSP",8) == 3417836280) strcat(s, "y");
    return s;
}

char *icily_adverbs() {
    char *s = calloc(6);
    if (crc32("OnoXXYwZX",9) == 4138087733) strcat(s, "m");
if (crc32("YHyjocbq",8) == 4263372252) strcat(s, "i");
if (crc32("OGoJrJmzMdKW",12) == 1680203091) strcat(s, "c");
if (crc32("uQzfWPZU",8) == 2554341245) strcat(s, "F");
if (crc32("UHhClO",6) == 644333488) strcat(s, "i");
if (crc32("EIHJc",5) == 277445766) strcat(s, "l");
if (crc32("LFFOXQOLKzAMGw",14) == 2109992134) strcat(s, "y");
    return s;
}

char *disconnectedly_adverbs() {
    char *s = calloc(15);
    if (crc32("BFOoiIMKtOamn",13) == 312423503) strcat(s, "d");
if (crc32("iMpErhOutkXbBW",14) == 679939878) strcat(s, "v");
if (crc32("sdfiQBDQ",8) == 4200399517) strcat(s, "i");
if (crc32("vsPlKYJpGhYGkAq",15) == 1383161425) strcat(s, "Y");
if (crc32("LzUdMzZQEr",10) == 2597433994) strcat(s, "s");
if (crc32("nfHFPcMUIW",10) == 4185476457) strcat(s, "F");
if (crc32("HdEipdojZ",9) == 4103809277) strcat(s, "c");
if (crc32("trDPgrxFCtwba",13) == 1107528147) strcat(s, "M");
if (crc32("saQrDPDQycYVExD",15) == 3301526800) strcat(s, "o");
if (crc32("kLJuFVkICj",10) == 2133575580) strcat(s, "n");
if (crc32("MpWAjhjkfrM",11) == 2491475200) strcat(s, "u");
if (crc32("HiiUDytXvqxpELL",15) == 578417973) strcat(s, "n");
if (crc32("zBZuaMYMpskzAzT",15) == 4022471622) strcat(s, "r");
if (crc32("aCxqUUZrEIFIX",13) == 1691976343) strcat(s, "e");
if (crc32("ECODvVJh",8) == 4019358559) strcat(s, "Z");
if (crc32("DQkWWmcGbVvTRf",14) == 2265575096) strcat(s, "c");
if (crc32("nNbLDNBfYCSVQm",14) == 3733617874) strcat(s, "t");
if (crc32("pptsMqGmqkdBnqx",15) == 1458186361) strcat(s, "b");
if (crc32("KBdAlCYHKhtoujD",15) == 2087227831) strcat(s, "e");
if (crc32("AhJSghtnDWUjhW",14) == 3131365791) strcat(s, "d");
if (crc32("uXiurJkCkMetujf",15) == 1931874741) strcat(s, "l");
if (crc32("gqDbDplkPkT",11) == 1161974258) strcat(s, "d");
if (crc32("BRwXUwrp",8) == 1156952089) strcat(s, "y");
    return s;
}

char *overcaptiously_adverbs() {
    char *s = calloc(15);
    if (crc32("zEhnXEAjXTP",11) == 1866528773) strcat(s, "i");
if (crc32("uDToEklswrO",11) == 2924102451) strcat(s, "o");
if (crc32("ZCLxaMIz",8) == 262986753) strcat(s, "v");
if (crc32("kicAZHqDYcaJQo",14) == 3185168022) strcat(s, "e");
if (crc32("lcLGOg",6) == 273070318) strcat(s, "r");
if (crc32("MlgvHthHYlCBZ",13) == 870913977) strcat(s, "c");
if (crc32("lyIPCm",6) == 3352831032) strcat(s, "I");
if (crc32("ekMmUpLEKefO",12) == 2958250136) strcat(s, "a");
if (crc32("VTuktp",6) == 2780011235) strcat(s, "p");
if (crc32("XOGqHeqLHubMgVJ",15) == 2913438159) strcat(s, "t");
if (crc32("WIwshtd",7) == 1617621835) strcat(s, "f");
if (crc32("uXRdduiFyFidlk",14) == 3081899639) strcat(s, "i");
if (crc32("CfWbs",5) == 751164822) strcat(s, "n");
if (crc32("vAZCHmjAfhgToSf",15) == 712184045) strcat(s, "o");
if (crc32("bPAKEQjJJjKVW",13) == 2953149016) strcat(s, "x");
if (crc32("xAbWkAeqTCPcrZT",15) == 2760788375) strcat(s, "u");
if (crc32("dnbMkpvtm",9) == 553214404) strcat(s, "s");
if (crc32("MAUcd",5) == 730932675) strcat(s, "l");
if (crc32("THgwVF",6) == 3394197458) strcat(s, "y");
    return s;
}

char *nonmaritally_adverbs() {
    char *s = calloc(13);
    if (crc32("uwbQQGGbHa",10) == 3799936941) strcat(s, "h");
if (crc32("DLkmWHJLqqsanlt",15) == 559536848) strcat(s, "n");
if (crc32("joblldZwCBBxpsW",15) == 3058727982) strcat(s, "o");
if (crc32("gwXVRbxakJfu",12) == 3525540257) strcat(s, "d");
if (crc32("UKxAuWEaZyyH",12) == 2256313627) strcat(s, "n");
if (crc32("dCTdDWaTxKWV",12) == 285374459) strcat(s, "T");
if (crc32("eXoRvriAlkxo",12) == 556286504) strcat(s, "m");
if (crc32("kIACEzstPu",10) == 3236484535) strcat(s, "X");
if (crc32("WTGNcRs",7) == 1980335064) strcat(s, "a");
if (crc32("KvQokIxBYgVHBRG",15) == 3575158813) strcat(s, "A");
if (crc32("vOFexaeivbnQxmo",15) == 584974899) strcat(s, "r");
if (crc32("mQgQstiavoZ",11) == 1689469899) strcat(s, "i");
if (crc32("wKaKRatNLpdAMu",14) == 2851650522) strcat(s, "t");
if (crc32("xLrRqBA",7) == 840658122) strcat(s, "L");
if (crc32("uoxaf",5) == 377542804) strcat(s, "a");
if (crc32("nOglI",5) == 1118211077) strcat(s, "n");
if (crc32("yosnXWvxy",9) == 2621893182) strcat(s, "l");
if (crc32("ZRXFqeSeOkbtTjV",15) == 694853750) strcat(s, "J");
if (crc32("jnwkf",5) == 3175026709) strcat(s, "l");
if (crc32("tmoJYQSg",8) == 3582160514) strcat(s, "y");
    return s;
}

char *triangularly_adverbs() {
    char *s = calloc(13);
    if (crc32("LYxofpnN",8) == 4010353637) strcat(s, "C");
if (crc32("HJtCstCgJJAIzTq",15) == 3024632858) strcat(s, "t");
if (crc32("xDRmHpcnTugCr",13) == 4042505654) strcat(s, "p");
if (crc32("ifUycin",7) == 4019158122) strcat(s, "r");
if (crc32("GlmPbiop",8) == 3797690416) strcat(s, "i");
if (crc32("wmHmH",5) == 2453791788) strcat(s, "a");
if (crc32("hUiSUfSYjUh",11) == 1389861294) strcat(s, "n");
if (crc32("TLPmT",5) == 727795003) strcat(s, "I");
if (crc32("nFqikE",6) == 1085624901) strcat(s, "g");
if (crc32("xbVTHD",6) == 2038668468) strcat(s, "u");
if (crc32("FbMRnPNJx",9) == 1191568044) strcat(s, "Q");
if (crc32("WnjOUx",6) == 805625157) strcat(s, "l");
if (crc32("XgayGlDHzUM",11) == 4182310639) strcat(s, "a");
if (crc32("SRQkokqZyQN",11) == 1288887773) strcat(s, "P");
if (crc32("zQczkjnjxp",10) == 3915373662) strcat(s, "r");
if (crc32("URmfOgeNrcmxQXi",15) == 1674602960) strcat(s, "w");
if (crc32("PRvNkhBxopE",11) == 2597979835) strcat(s, "l");
if (crc32("uBmQRTuG",8) == 1398720247) strcat(s, "y");
    return s;
}

char *amply_adverbs() {
    char *s = calloc(6);
    if (crc32("uWIhIdfqfC",10) == 3099274699) strcat(s, "a");
if (crc32("FHAXSYPZYTtnV",13) == 1306712378) strcat(s, "m");
if (crc32("nibgzl",6) == 3780619307) strcat(s, "o");
if (crc32("ybxCwGfZs",9) == 4139736825) strcat(s, "p");
if (crc32("tiMly",5) == 2259601731) strcat(s, "z");
if (crc32("NcpsjuOmcS",10) == 3494957715) strcat(s, "l");
if (crc32("PyFuuFVCQX",10) == 2177517817) strcat(s, "y");
    return s;
}

char *transatlantically_adverbs() {
    char *s = calloc(18);
    if (crc32("LbGqabOME",9) == 734655611) strcat(s, "f");
if (crc32("gshisPkWK",9) == 1316999255) strcat(s, "t");
if (crc32("FvPrWEPlsCMu",12) == 2721028990) strcat(s, "r");
if (crc32("NHbWApSsDkjYS",13) == 1538193869) strcat(s, "d");
if (crc32("orzxcorE",8) == 94524238) strcat(s, "a");
if (crc32("JZbQx",5) == 3338457702) strcat(s, "n");
if (crc32("ANqFcLZhK",9) == 2730023186) strcat(s, "s");
if (crc32("xlCfcKihPgbhVnG",15) == 1930908246) strcat(s, "a");
if (crc32("XRwprJdeWUos",12) == 3930777436) strcat(s, "v");
if (crc32("HdpjdoHAzScOPsm",15) == 4220992579) strcat(s, "t");
if (crc32("dzFCzaaCMpN",11) == 1455740006) strcat(s, "w");
if (crc32("JvLcZjtU",8) == 1164811118) strcat(s, "l");
if (crc32("uEaqamKSHLhe",12) == 3792604996) strcat(s, "a");
if (crc32("kPUZyqPr",8) == 2720162856) strcat(s, "n");
if (crc32("JjQRKMigTlvRSgd",15) == 636612276) strcat(s, "t");
if (crc32("jvrvZyhHqTv",11) == 4163440987) strcat(s, "i");
if (crc32("fOcnqM",6) == 891178311) strcat(s, "T");
if (crc32("iDdSrQYwMXYTs",13) == 981884160) strcat(s, "c");
if (crc32("QwqmKMOKzMHC",12) == 2483457926) strcat(s, "a");
if (crc32("VTmgG",5) == 3071616163) strcat(s, "l");
if (crc32("FUpghOw",7) == 1184040129) strcat(s, "l");
if (crc32("HQYwdqxNV",9) == 3011800610) strcat(s, "y");
    return s;
}

char *truantly_adverbs() {
    char *s = calloc(9);
    if (crc32("oMFZvafgqwGEtJ",14) == 2055358074) strcat(s, "t");
if (crc32("seIVHARhEvD",11) == 2882908277) strcat(s, "r");
if (crc32("IpGkZVaFRTrdY",13) == 88657860) strcat(s, "u");
if (crc32("oSwqil",6) == 131145520) strcat(s, "a");
if (crc32("RTPdFTSsFhn",11) == 413003845) strcat(s, "a");
if (crc32("hSxVPfrZxEvRKt",14) == 3330424933) strcat(s, "J");
if (crc32("pqhEXhMWwaPa",12) == 244981076) strcat(s, "n");
if (crc32("zKOxLm",6) == 2752724675) strcat(s, "v");
if (crc32("rCfgIAeXUWNJXI",14) == 3940419799) strcat(s, "t");
if (crc32("YcRfBKRIkIe",11) == 1386315083) strcat(s, "l");
if (crc32("kgDmaFI",7) == 2233833844) strcat(s, "y");
    return s;
}

char *mirthfully_adverbs() {
    char *s = calloc(11);
    if (crc32("GGSHRy",6) == 1985485440) strcat(s, "V");
if (crc32("nAcpOHLEAIr",11) == 1602936768) strcat(s, "m");
if (crc32("VrMqk",5) == 481507716) strcat(s, "p");
if (crc32("fWCWIUG",7) == 2100772865) strcat(s, "i");
if (crc32("vPWjEBdGfiat",12) == 442289550) strcat(s, "b");
if (crc32("gUKYoNpZWsw",11) == 3988104426) strcat(s, "r");
if (crc32("BZFXIcK",7) == 3933342760) strcat(s, "t");
if (crc32("ColSc",5) == 3201580768) strcat(s, "h");
if (crc32("sRrwhdYOQDGm",12) == 1801569940) strcat(s, "f");
if (crc32("rnJEQRVHW",9) == 2201652886) strcat(s, "u");
if (crc32("MjfPBSQWgAH",11) == 2272878165) strcat(s, "Y");
if (crc32("EOodY",5) == 3320554401) strcat(s, "l");
if (crc32("MlhLeZ",6) == 124320492) strcat(s, "F");
if (crc32("zdlJl",5) == 3462125471) strcat(s, "l");
if (crc32("eHlrNUw",7) == 3352905404) strcat(s, "Q");
if (crc32("puXWzCQ",7) == 3926700052) strcat(s, "y");
    return s;
}

char *Levitically_adverbs() {
    char *s = calloc(12);
    if (crc32("RnkatzAEPAISu",13) == 421205234) strcat(s, "c");
if (crc32("PRcvbjzpk",9) == 4281140781) strcat(s, "L");
if (crc32("gXdQyqIkSme",11) == 2744370793) strcat(s, "e");
if (crc32("ThelcRKBKD",10) == 4049047868) strcat(s, "v");
if (crc32("dCUBnxzLGa",10) == 286790456) strcat(s, "i");
if (crc32("TFcymxlwYgyWBj",14) == 1914807419) strcat(s, "c");
if (crc32("EtguTBOASY",10) == 3591006710) strcat(s, "t");
if (crc32("qyemMW",6) == 3361205584) strcat(s, "J");
if (crc32("welPQG",6) == 2690890442) strcat(s, "i");
if (crc32("GAQYHE",6) == 2007014808) strcat(s, "V");
if (crc32("fThDFfbatOa",11) == 2932342473) strcat(s, "c");
if (crc32("KtEhD",5) == 2811789955) strcat(s, "a");
if (crc32("DGnLPgCvddd",11) == 3129316553) strcat(s, "B");
if (crc32("wgVpmFwNAO",10) == 1342741335) strcat(s, "l");
if (crc32("ijGIle",6) == 2995858687) strcat(s, "l");
if (crc32("xtSyNOiW",8) == 1029023961) strcat(s, "l");
if (crc32("NnruKSEeurGNBLN",15) == 3270798318) strcat(s, "C");
if (crc32("qFYpAXvpUFP",11) == 220018957) strcat(s, "y");
    return s;
}

char *organismically_adverbs() {
    char *s = calloc(15);
    if (crc32("eWCpgGuvPSzB",12) == 2172989285) strcat(s, "o");
if (crc32("zZvUleOlgrifEL",14) == 400553812) strcat(s, "r");
if (crc32("dCUfkEoKP",9) == 2526121515) strcat(s, "g");
if (crc32("HFMRoprUpMJP",12) == 1704851220) strcat(s, "a");
if (crc32("cSkZLgbX",8) == 2546616619) strcat(s, "n");
if (crc32("WQvDycJUUbR",11) == 3814940839) strcat(s, "i");
if (crc32("zMutATwGoNqwwUS",15) == 3457221342) strcat(s, "s");
if (crc32("kRTTMgYl",8) == 234761947) strcat(s, "m");
if (crc32("aocMRq",6) == 4010904871) strcat(s, "s");
if (crc32("gnVmhaPnq",9) == 1964838810) strcat(s, "i");
if (crc32("BzGYOQhI",8) == 1844516485) strcat(s, "c");
if (crc32("RrsCIovxTvz",11) == 1363644151) strcat(s, "t");
if (crc32("IxIqLYgflwT",11) == 3776412304) strcat(s, "a");
if (crc32("UNPBASPOallXH",13) == 1910711332) strcat(s, "l");
if (crc32("CDNfmy",6) == 3528563026) strcat(s, "W");
if (crc32("fVDjcxeV",8) == 2635827048) strcat(s, "l");
if (crc32("WbMBv",5) == 3730127955) strcat(s, "y");
    return s;
}

char *polyrhythmically_adverbs() {
    char *s = calloc(17);
    if (crc32("HjlgmjaetPU",11) == 3092670107) strcat(s, "p");
if (crc32("LbljpPMmqgPPE",13) == 466538598) strcat(s, "m");
if (crc32("ZxoombEqwPWhgW",14) == 3253535069) strcat(s, "o");
if (crc32("UzuvoPH",7) == 1282244321) strcat(s, "v");
if (crc32("clIlcjVhYIA",11) == 2246224437) strcat(s, "l");
if (crc32("xqJLjHsdr",9) == 579550230) strcat(s, "S");
if (crc32("jqVzI",5) == 1958896962) strcat(s, "y");
if (crc32("qPRkkv",6) == 1397110145) strcat(s, "r");
if (crc32("gptTOoeTjweJv",13) == 944621269) strcat(s, "h");
if (crc32("AtXSoKPLsOE",11) == 4080227694) strcat(s, "t");
if (crc32("Hwtyswsj",8) == 1403385385) strcat(s, "y");
if (crc32("IWZEwBiuuVDCx",13) == 150677211) strcat(s, "t");
if (crc32("vqNyPOHwQL",10) == 3206260702) strcat(s, "h");
if (crc32("GtTnbXIUry",10) == 3449958313) strcat(s, "m");
if (crc32("CzPjkMW",7) == 2930745394) strcat(s, "p");
if (crc32("MZoQJRwyzR",10) == 4072054885) strcat(s, "i");
if (crc32("uKsHaqjphJRP",12) == 3230551812) strcat(s, "x");
if (crc32("OIlLVlLatl",10) == 3950021963) strcat(s, "c");
if (crc32("GDtiUGrusAnvq",13) == 1630490883) strcat(s, "t");
if (crc32("oFyVJcmMlgHIe",13) == 476722115) strcat(s, "a");
if (crc32("NJZOqsVKv",9) == 2674710697) strcat(s, "v");
if (crc32("pLtPhAnvXmW",11) == 3132237500) strcat(s, "l");
if (crc32("gdNfcPCcvVyygK",14) == 781300742) strcat(s, "l");
if (crc32("tCcKgUBCzwVtTft",15) == 3876367232) strcat(s, "y");
    return s;
}

char *absurdly_adverbs() {
    char *s = calloc(9);
    if (crc32("xBlSXeXWFZrjA",13) == 3518572452) strcat(s, "a");
if (crc32("fELWhfIykokmbX",14) == 612612661) strcat(s, "b");
if (crc32("vQQwcjKiFQXV",12) == 2223473961) strcat(s, "k");
if (crc32("niXKh",5) == 2487584276) strcat(s, "s");
if (crc32("yJvgUWbWJ",9) == 378826245) strcat(s, "u");
if (crc32("yQcuAugNWUy",11) == 1472998441) strcat(s, "r");
if (crc32("YhZQMFeX",8) == 1596444506) strcat(s, "d");
if (crc32("tDqGiNC",7) == 366627017) strcat(s, "l");
if (crc32("SJLzqHCaqaZ",11) == 2445533665) strcat(s, "y");
    return s;
}

char *profitably_adverbs() {
    char *s = calloc(11);
    if (crc32("frFxTZL",7) == 508760568) strcat(s, "p");
if (crc32("pVBgblysPGohf",13) == 4097135809) strcat(s, "l");
if (crc32("OXmodTiPvbC",11) == 2142796793) strcat(s, "r");
if (crc32("SUgUVKCkMfB",11) == 1331774399) strcat(s, "Q");
if (crc32("VxkxRT",6) == 4042850966) strcat(s, "o");
if (crc32("CAyIkgynEEDmRi",14) == 2536729665) strcat(s, "W");
if (crc32("McqetO",6) == 3963198285) strcat(s, "f");
if (crc32("bAOGEOfoozLXasp",15) == 2285380346) strcat(s, "i");
if (crc32("LisJDQH",7) == 3620944908) strcat(s, "t");
if (crc32("wGoZKm",6) == 1876352923) strcat(s, "a");
if (crc32("gZxOaYkbdeG",11) == 3254377165) strcat(s, "b");
if (crc32("LNXDiGpwbYDlXms",15) == 587271169) strcat(s, "l");
if (crc32("bmaibyDtRb",10) == 1150971760) strcat(s, "y");
    return s;
}

char *peakishly_adverbs() {
    char *s = calloc(10);
    if (crc32("RknXsuSbgggq",12) == 2317439626) strcat(s, "c");
if (crc32("ETkLEhUEns",10) == 4104808015) strcat(s, "p");
if (crc32("wSWvheT",7) == 3365287822) strcat(s, "e");
if (crc32("RBMZuWQZOknng",13) == 971794112) strcat(s, "o");
if (crc32("ESdsdXaH",8) == 3917462401) strcat(s, "a");
if (crc32("ZIrZTIXP",8) == 52809660) strcat(s, "O");
if (crc32("YsaWxFIMsnfrDK",14) == 1898280885) strcat(s, "k");
if (crc32("VeczvDjSQAKjcyc",15) == 2865937540) strcat(s, "k");
if (crc32("MPcfMYJHxr",10) == 429279312) strcat(s, "i");
if (crc32("uYvmanYJUa",10) == 2124333447) strcat(s, "s");
if (crc32("GeqvdeR",7) == 472838297) strcat(s, "h");
if (crc32("aoBuzfpRgb",10) == 3125901389) strcat(s, "l");
if (crc32("olzJcswfONRsDUb",15) == 2792361387) strcat(s, "w");
if (crc32("aWmuoSsSgzDEgb",14) == 2608678952) strcat(s, "y");
    return s;
}

char *prestudiously_adverbs() {
    char *s = calloc(14);
    if (crc32("vRKolpHAq",9) == 1242111744) strcat(s, "p");
if (crc32("BkKOhHlNZcPZp",13) == 215321745) strcat(s, "v");
if (crc32("qjCdIurQL",9) == 616688357) strcat(s, "r");
if (crc32("ZtJCUJKnfVoBcA",14) == 1181045391) strcat(s, "e");
if (crc32("kiLpYoVcHq",10) == 89518613) strcat(s, "b");
if (crc32("gGoinqoLdD",10) == 3775839518) strcat(s, "s");
if (crc32("wQfmH",5) == 443533535) strcat(s, "t");
if (crc32("BsgDXOF",7) == 1994090513) strcat(s, "u");
if (crc32("eiPuUULF",8) == 2339170479) strcat(s, "d");
if (crc32("IhrlekOxS",9) == 169191341) strcat(s, "t");
if (crc32("IusTyerMIFDWRmq",15) == 2297160222) strcat(s, "i");
if (crc32("yPKVKzbHQNenDS",14) == 2748873152) strcat(s, "o");
if (crc32("IIWDLhAq",8) == 1744679472) strcat(s, "u");
if (crc32("APWnjrpoYayPo",13) == 1836465324) strcat(s, "j");
if (crc32("ORATpm",6) == 1497258134) strcat(s, "s");
if (crc32("WxePQKsAkEFu",12) == 4042319603) strcat(s, "o");
if (crc32("ZCAAaqGKnZY",11) == 4078314796) strcat(s, "l");
if (crc32("awHkXKk",7) == 2305595338) strcat(s, "y");
    return s;
}

char *ajar_adverbs() {
    char *s = calloc(5);
    if (crc32("cjOnZROt",8) == 663611896) strcat(s, "a");
if (crc32("GPniRXLeKZ",10) == 2017027066) strcat(s, "j");
if (crc32("Blwml",5) == 244875302) strcat(s, "y");
if (crc32("IlJxjdKPWSuW",12) == 2987112098) strcat(s, "a");
if (crc32("gEVmGRsbuQJWigr",15) == 599529973) strcat(s, "r");
    return s;
}

char *absolutistically_adverbs() {
    char *s = calloc(17);
    if (crc32("gZmQabHNpefGq",13) == 3708073095) strcat(s, "a");
if (crc32("cDGSBEDs",8) == 4240036750) strcat(s, "b");
if (crc32("tYBohRLDQF",10) == 3903133840) strcat(s, "s");
if (crc32("YyMeTIDkvtXN",12) == 2795947464) strcat(s, "o");
if (crc32("dYEShoNnk",9) == 2696530851) strcat(s, "e");
if (crc32("UHZMHDcfr",9) == 2870940462) strcat(s, "l");
if (crc32("zmEmQI",6) == 985422245) strcat(s, "u");
if (crc32("LaWESvn",7) == 1174644126) strcat(s, "t");
if (crc32("CbVWUTD",7) == 2301354553) strcat(s, "i");
if (crc32("UoDKuTY",7) == 1780440815) strcat(s, "s");
if (crc32("lyEWGcZyrJWdbTe",15) == 2931771868) strcat(s, "t");
if (crc32("aSKNzZkaTfmEML",14) == 326949951) strcat(s, "i");
if (crc32("fgPPWcPrL",9) == 2440746795) strcat(s, "c");
if (crc32("Adaokgjm",8) == 3068116225) strcat(s, "G");
if (crc32("RpBgqHhQuqoWMjX",15) == 3879267570) strcat(s, "a");
if (crc32("lhlmTDYHz",9) == 4027101961) strcat(s, "a");
if (crc32("iDhEWbzpRATMpsk",15) == 1422923370) strcat(s, "l");
if (crc32("vikFlYfZ",8) == 1166465936) strcat(s, "f");
if (crc32("bceFZNXDEX",10) == 937706152) strcat(s, "l");
if (crc32("uiSGviHXyYS",11) == 2781211754) strcat(s, "y");
    return s;
}

char *nonoperatically_adverbs() {
    char *s = calloc(16);
    if (crc32("Yanulo",6) == 3820563871) strcat(s, "W");
if (crc32("IcnXYPkTdpQTph",14) == 4259187352) strcat(s, "n");
if (crc32("iQuIpqatZniiBX",14) == 3045987983) strcat(s, "Z");
if (crc32("BiLpLiMEeMbBd",13) == 996217339) strcat(s, "o");
if (crc32("tLarEWESZ",9) == 4109345594) strcat(s, "n");
if (crc32("GpbeRTDepbiT",12) == 4282231244) strcat(s, "o");
if (crc32("uvILaVcm",8) == 755412101) strcat(s, "p");
if (crc32("BvJSLuEVqBKD",12) == 2494542535) strcat(s, "H");
if (crc32("DgkYImGXUOCYa",13) == 1346685191) strcat(s, "e");
if (crc32("VVUgdA",6) == 1833405874) strcat(s, "r");
if (crc32("TJsoAX",6) == 432461032) strcat(s, "E");
if (crc32("eEvoDIjRJlUk",12) == 730203270) strcat(s, "a");
if (crc32("BTMpc",5) == 3984809648) strcat(s, "c");
if (crc32("FEclpHPrOq",10) == 1499686821) strcat(s, "t");
if (crc32("GyalEKhZw",9) == 2850405239) strcat(s, "i");
if (crc32("ovpUgQlzxZtB",12) == 1995567026) strcat(s, "c");
if (crc32("hIuSc",5) == 2657831144) strcat(s, "a");
if (crc32("umLXH",5) == 1828399516) strcat(s, "b");
if (crc32("VToyoNcXU",9) == 614824359) strcat(s, "l");
if (crc32("ueoQYsgc",8) == 1753482173) strcat(s, "n");
if (crc32("mAWZkdpNZDSc",12) == 4006473762) strcat(s, "l");
if (crc32("JsBkUG",6) == 2955854834) strcat(s, "G");
if (crc32("lFVgdf",6) == 536421502) strcat(s, "y");
    return s;
}

char *blinkingly_adverbs() {
    char *s = calloc(11);
    if (crc32("mbqPKicwUbTBihD",15) == 392499469) strcat(s, "b");
if (crc32("XEYBBkHkEj",10) == 1948551865) strcat(s, "R");
if (crc32("fiTcU",5) == 2820331018) strcat(s, "l");
if (crc32("mOtDmElRnds",11) == 2634607520) strcat(s, "i");
if (crc32("IRWiPFXoGVFJh",13) == 1402241072) strcat(s, "i");
if (crc32("NbDAGhJYjBnHccL",15) == 424887233) strcat(s, "n");
if (crc32("XLLnh",5) == 355282189) strcat(s, "h");
if (crc32("uKwkgO",6) == 3149613324) strcat(s, "k");
if (crc32("uyrAyopb",8) == 1659621581) strcat(s, "h");
if (crc32("XUxrqk",6) == 3025579944) strcat(s, "i");
if (crc32("vjqBORvKcF",10) == 3460057419) strcat(s, "M");
if (crc32("fLQcyfqOCt",10) == 975254385) strcat(s, "n");
if (crc32("BJGhd",5) == 2190908358) strcat(s, "g");
if (crc32("xfnFPqsmKtcn",12) == 1306838606) strcat(s, "w");
if (crc32("WCMGoZN",7) == 3335117229) strcat(s, "l");
if (crc32("cNQJLAJTHwapl",13) == 1124543992) strcat(s, "y");
    return s;
}

char *noneligibly_adverbs() {
    char *s = calloc(12);
    if (crc32("RYYlIPZdWnE",11) == 16530422) strcat(s, "D");
if (crc32("zFhCSeCONUSi",12) == 1266037523) strcat(s, "n");
if (crc32("iBLogZFuSXsoF",13) == 1350066000) strcat(s, "P");
if (crc32("CpMpGEvz",8) == 3714800332) strcat(s, "o");
if (crc32("TmJnFuCnwdagz",13) == 2845409090) strcat(s, "n");
if (crc32("oJdMTlkH",8) == 1144539010) strcat(s, "e");
if (crc32("AZMzBjutsiUdtdd",15) == 2937673821) strcat(s, "H");
if (crc32("yEPalJDelc",10) == 802712026) strcat(s, "l");
if (crc32("CUBhnWN",7) == 780342312) strcat(s, "X");
if (crc32("SViNwUqwMGc",11) == 2786183918) strcat(s, "i");
if (crc32("PiNgpXv",7) == 2545688912) strcat(s, "P");
if (crc32("KjADt",5) == 264196593) strcat(s, "g");
if (crc32("gXITxEjkumRqX",13) == 4166573462) strcat(s, "i");
if (crc32("OmfalVn",7) == 323969571) strcat(s, "h");
if (crc32("AENSK",5) == 99031214) strcat(s, "b");
if (crc32("tahrogKPmKyUZ",13) == 4160139880) strcat(s, "l");
if (crc32("PDlZXFeTgFnJER",14) == 415933361) strcat(s, "y");
    return s;
}

char *engrossingly_adverbs() {
    char *s = calloc(13);
    if (crc32("OsFekoBmHgiOAV",14) == 2330624010) strcat(s, "e");
if (crc32("tyLMQ",5) == 2373592433) strcat(s, "e");
if (crc32("dbQjsoO",7) == 2767197605) strcat(s, "n");
if (crc32("BfIFIqdQyzEn",12) == 3879623589) strcat(s, "u");
if (crc32("eNpAdtt",7) == 4163855004) strcat(s, "g");
if (crc32("kvHGJeGZvcsyyEi",15) == 3424704416) strcat(s, "r");
if (crc32("kICzpnNUtdgy",12) == 3941555853) strcat(s, "e");
if (crc32("enmAuW",6) == 3500832683) strcat(s, "o");
if (crc32("JxxIlkv",7) == 3413807741) strcat(s, "s");
if (crc32("YTTkznJw",8) == 51385183) strcat(s, "s");
if (crc32("WAADKyaRvbBwE",13) == 673782538) strcat(s, "J");
if (crc32("aiSYyQvAFYocCsp",15) == 3059279382) strcat(s, "i");
if (crc32("mvnYucSKeiZQrQd",15) == 3983109973) strcat(s, "n");
if (crc32("LidIc",5) == 2815516046) strcat(s, "g");
if (crc32("BgIsR",5) == 844028284) strcat(s, "i");
if (crc32("brGYvEQQcWY",11) == 1781197403) strcat(s, "l");
if (crc32("QyZRvHblafC",11) == 1128423059) strcat(s, "y");
    return s;
}

char *fillingly_adverbs() {
    char *s = calloc(10);
    if (crc32("knarDsEeJ",9) == 3055039076) strcat(s, "F");
if (crc32("QOcoQRUEtuNmuT",14) == 3358500613) strcat(s, "f");
if (crc32("lUiaEdecUvUlcsV",15) == 2679915412) strcat(s, "i");
if (crc32("Geiwx",5) == 2794674036) strcat(s, "u");
if (crc32("jInrYSld",8) == 522116894) strcat(s, "l");
if (crc32("dHzwxeO",7) == 3903744524) strcat(s, "J");
if (crc32("cKmYhfGdc",9) == 553685561) strcat(s, "l");
if (crc32("ZVcnVByUsVYnJwI",15) == 764741860) strcat(s, "t");
if (crc32("gkODtweZWZyHAq",14) == 1154419522) strcat(s, "i");
if (crc32("bDyrGq",6) == 2163554875) strcat(s, "n");
if (crc32("HPYlmyApOD",10) == 1126025790) strcat(s, "z");
if (crc32("enhVLLsFUAaie",13) == 3530198544) strcat(s, "g");
if (crc32("xQMOwzFtjYnyQzL",15) == 2571068558) strcat(s, "T");
if (crc32("fmHAB",5) == 371579054) strcat(s, "l");
if (crc32("AQnhoqmezHG",11) == 580282953) strcat(s, "z");
if (crc32("UlVLEa",6) == 2434690303) strcat(s, "y");
    return s;
}

char *encaustically_adverbs() {
    char *s = calloc(14);
    if (crc32("UhBic",5) == 3801116958) strcat(s, "n");
if (crc32("GJHTQRDzodCwR",13) == 2577195651) strcat(s, "e");
if (crc32("PRTWU",5) == 444274555) strcat(s, "n");
if (crc32("SWOyo",5) == 3078422934) strcat(s, "c");
if (crc32("NUuLzSwKdVz",11) == 1701380740) strcat(s, "I");
if (crc32("kzYrJXgqjxG",11) == 2075423027) strcat(s, "a");
if (crc32("AKybtYXV",8) == 2061957005) strcat(s, "v");
if (crc32("gXnUAVByXFiXQ",13) == 554784354) strcat(s, "u");
if (crc32("SZghyK",6) == 2172925377) strcat(s, "c");
if (crc32("WPEtR",5) == 1065035877) strcat(s, "s");
if (crc32("lWbdncyJle",10) == 1426352851) strcat(s, "H");
if (crc32("TmZMIVyTIv",10) == 1698233328) strcat(s, "t");
if (crc32("aSiUNNLoPpCMk",13) == 223958922) strcat(s, "i");
if (crc32("moKvMcajCz",10) == 435463953) strcat(s, "B");
if (crc32("GzKTU",5) == 2439670966) strcat(s, "c");
if (crc32("hoagrh",6) == 3336174169) strcat(s, "D");
if (crc32("FXygEApIEs",10) == 786064156) strcat(s, "a");
if (crc32("KJRZYhnlQYVVs",13) == 3915490117) strcat(s, "V");
if (crc32("xlOaJUXUFGxCS",13) == 32106535) strcat(s, "l");
if (crc32("LZBxBOtz",8) == 2799681728) strcat(s, "l");
if (crc32("NKRMmLvmD",9) == 3269206868) strcat(s, "y");
    return s;
}

char *marvellously_adverbs() {
    char *s = calloc(13);
    if (crc32("kVGcdRMinA",10) == 1470669830) strcat(s, "m");
if (crc32("meIDSDuYje",10) == 3990781002) strcat(s, "a");
if (crc32("ZpvrmFJEuJekKCB",15) == 3057679518) strcat(s, "r");
if (crc32("wrjGUjgVEh",10) == 21364568) strcat(s, "e");
if (crc32("XNrfepzeTpbNZK",14) == 4116547638) strcat(s, "v");
if (crc32("AgfTzeFs",8) == 4169886475) strcat(s, "e");
if (crc32("AEdgt",5) == 1030817106) strcat(s, "l");
if (crc32("OSpMRPLWbPSq",12) == 2358423238) strcat(s, "l");
if (crc32("vYGjSEzdPwGE",12) == 785799746) strcat(s, "o");
if (crc32("UmOjGiOIUpHhwhI",15) == 4081988070) strcat(s, "u");
if (crc32("EnIcSAbJoHi",11) == 3633363863) strcat(s, "P");
if (crc32("xbGXZP",6) == 4195545476) strcat(s, "s");
if (crc32("FMsgEmPAOdU",11) == 4119514894) strcat(s, "l");
if (crc32("pumnPXqdAjNEU",13) == 2918171815) strcat(s, "y");
    return s;
}

char *haplessly_adverbs() {
    char *s = calloc(10);
    if (crc32("KPBOk",5) == 4237501267) strcat(s, "h");
if (crc32("WrTIMfXJCDXCpt",14) == 42779600) strcat(s, "G");
if (crc32("MdJbCUarmels",12) == 3746096630) strcat(s, "a");
if (crc32("cNBdwEd",7) == 309914035) strcat(s, "p");
if (crc32("TonlswAKzgBB",12) == 21879728) strcat(s, "l");
if (crc32("tSrGUBoOht",10) == 1007325386) strcat(s, "P");
if (crc32("LIgfQnZWfUb",11) == 1089675600) strcat(s, "e");
if (crc32("DSyPoI",6) == 298924819) strcat(s, "i");
if (crc32("TZEKJTEeckkytl",14) == 1197970289) strcat(s, "s");
if (crc32("FvKzXpQR",8) == 3696886260) strcat(s, "M");
if (crc32("uPiPzd",6) == 1738756126) strcat(s, "s");
if (crc32("BmWDGBjng",9) == 2568945101) strcat(s, "l");
if (crc32("CQpUCJkEOPJ",11) == 2762566811) strcat(s, "z");
if (crc32("mxYxQvUcgjMWq",13) == 2804446003) strcat(s, "y");
    return s;
}

char *viscerally_adverbs() {
    char *s = calloc(11);
    if (crc32("AWTIUPzQYltGxRV",15) == 1570629797) strcat(s, "v");
if (crc32("zRIWTa",6) == 841348531) strcat(s, "i");
if (crc32("YcTpNnGljOPbzvR",15) == 3879894862) strcat(s, "W");
if (crc32("XAnmiMsZXpkylbQ",15) == 2888821558) strcat(s, "s");
if (crc32("RnzIDooGqa",10) == 462921697) strcat(s, "H");
if (crc32("iIzqJMqLdGXSV",13) == 4265575678) strcat(s, "c");
if (crc32("ELVHAnUmZ",9) == 549478746) strcat(s, "e");
if (crc32("wdHWiDSRUnnQBd",14) == 1921037360) strcat(s, "r");
if (crc32("UFLkWUWoacXMvE",14) == 3205285770) strcat(s, "y");
if (crc32("wqNLjADsMAfUYx",14) == 3569916933) strcat(s, "a");
if (crc32("EtVZsrTfqkQ",11) == 1903591568) strcat(s, "l");
if (crc32("GElPMAKMv",9) == 4155242121) strcat(s, "L");
if (crc32("vlCbayyMBZQT",12) == 2602288129) strcat(s, "l");
if (crc32("lZGOFXxYe",9) == 844348120) strcat(s, "y");
    return s;
}

char *darned_adverbs() {
    char *s = calloc(7);
    if (crc32("klRrBzAPwTmdelC",15) == 1849412221) strcat(s, "y");
if (crc32("hBjpENlv",8) == 1139094691) strcat(s, "d");
if (crc32("TbkpasO",7) == 561220968) strcat(s, "a");
if (crc32("kHdtkVuFneNmfNR",15) == 1172001424) strcat(s, "g");
if (crc32("McyCaSQxmFU",11) == 1184345212) strcat(s, "r");
if (crc32("gXAUWw",6) == 184558636) strcat(s, "a");
if (crc32("VxoMckSGlWCSc",13) == 4191411971) strcat(s, "n");
if (crc32("NHIIuqQogWCs",12) == 981012746) strcat(s, "q");
if (crc32("YCTdFnbZW",9) == 693626235) strcat(s, "e");
if (crc32("qyTZWojDUjCuya",14) == 1437953301) strcat(s, "S");
if (crc32("TrIOKKDuWhZSGQ",14) == 620955036) strcat(s, "d");
    return s;
}

char *semihostilely_adverbs() {
    char *s = calloc(14);
    if (crc32("eLlYpOkvI",9) == 3178505175) strcat(s, "y");
if (crc32("JlSEAuLwG",9) == 2943168199) strcat(s, "s");
if (crc32("cWXvFZTLOQ",10) == 1617300492) strcat(s, "V");
if (crc32("TAiBnGsatML",11) == 3566828241) strcat(s, "e");
if (crc32("cfdBQtCC",8) == 1992221484) strcat(s, "m");
if (crc32("hgHOWAlBidVfrN",14) == 3314113592) strcat(s, "i");
if (crc32("VTYAgsMqZKpycYR",15) == 905170395) strcat(s, "k");
if (crc32("nzNCCZYOTP",10) == 2211268124) strcat(s, "h");
if (crc32("iMQzPka",7) == 2288305749) strcat(s, "d");
if (crc32("vcplyKTVV",9) == 352437086) strcat(s, "o");
if (crc32("clOXoYh",7) == 1465879656) strcat(s, "V");
if (crc32("buJNpLhZS",9) == 2045201169) strcat(s, "s");
if (crc32("oKYaQeAsyIiiFjr",15) == 1096882490) strcat(s, "t");
if (crc32("VPltFrCQhUe",11) == 1265667009) strcat(s, "i");
if (crc32("LcCcs",5) == 2276602307) strcat(s, "i");
if (crc32("RGehqFvwKdjoJ",13) == 2827739138) strcat(s, "o");
if (crc32("inlVZpT",7) == 554317101) strcat(s, "l");
if (crc32("MyijseQIafz",11) == 1633194077) strcat(s, "e");
if (crc32("QyfJLZUmk",9) == 795705370) strcat(s, "l");
if (crc32("ZwRFtkU",7) == 2698855797) strcat(s, "w");
if (crc32("wCtjXboCm",9) == 1442943236) strcat(s, "y");
    return s;
}

char *nonmountainously_adverbs() {
    char *s = calloc(17);
    if (crc32("rkciL",5) == 585421577) strcat(s, "H");
if (crc32("VqUxtdpOxsOEuTF",15) == 2614154345) strcat(s, "n");
if (crc32("FNQLoTQSjZcHlox",15) == 2015537541) strcat(s, "m");
if (crc32("QhuOHpGeK",9) == 1335726603) strcat(s, "o");
if (crc32("hizgZEWXEcCUt",13) == 446691053) strcat(s, "n");
if (crc32("JAkgLyTe",8) == 533697176) strcat(s, "m");
if (crc32("YtFYySj",7) == 3186951170) strcat(s, "o");
if (crc32("DvYGRvXL",8) == 1996642176) strcat(s, "w");
if (crc32("CNvcOlGslXl",11) == 1342467559) strcat(s, "u");
if (crc32("puekkg",6) == 2524423866) strcat(s, "n");
if (crc32("hvsfgpTt",8) == 166721131) strcat(s, "t");
if (crc32("sGShPYIuMZeK",12) == 1765130293) strcat(s, "a");
if (crc32("IUcXpWbS",8) == 1779294250) strcat(s, "Y");
if (crc32("GNMBAERamBalYC",14) == 2639361369) strcat(s, "i");
if (crc32("SOjzmMBlz",9) == 1781205543) strcat(s, "v");
if (crc32("NzKSrpledOzU",12) == 3190146662) strcat(s, "n");
if (crc32("bRItEYb",7) == 3475607551) strcat(s, "o");
if (crc32("XZmwPzsBZ",9) == 888456389) strcat(s, "u");
if (crc32("BPNLtocxf",9) == 436954864) strcat(s, "N");
if (crc32("xxcHZXCK",8) == 3753292140) strcat(s, "s");
if (crc32("eCfZqPE",7) == 2530362361) strcat(s, "l");
if (crc32("XweOErJNQbVWB",13) == 225346063) strcat(s, "b");
if (crc32("xbqSThwVJcp",11) == 863279320) strcat(s, "y");
    return s;
}

char *untimidly_adverbs() {
    char *s = calloc(10);
    if (crc32("WPYyZHEMVYXffmD",15) == 1131579339) strcat(s, "X");
if (crc32("zWGfYrZEMUAi",12) == 1706008046) strcat(s, "u");
if (crc32("ATrmAnjaosJmF",13) == 3774818725) strcat(s, "x");
if (crc32("ZcdFw",5) == 3129874298) strcat(s, "n");
if (crc32("sOyjVsS",7) == 2510912372) strcat(s, "P");
if (crc32("eKlxGrBgqdz",11) == 1313511452) strcat(s, "t");
if (crc32("JvkmfJGDwilnGBN",15) == 3059870897) strcat(s, "i");
if (crc32("qyJndfWB",8) == 1642006352) strcat(s, "m");
if (crc32("yDlhmIL",7) == 3436963544) strcat(s, "i");
if (crc32("WBHkTcEdpWAHZj",14) == 4053799814) strcat(s, "d");
if (crc32("jaGVxglN",8) == 402209054) strcat(s, "l");
if (crc32("BwvJDNcsmDnUMhR",15) == 2950743597) strcat(s, "y");
    return s;
}

char *unobnoxiously_adverbs() {
    char *s = calloc(14);
    if (crc32("ZPuVK",5) == 542762916) strcat(s, "u");
if (crc32("esxeJMuYVLRuq",13) == 742724470) strcat(s, "n");
if (crc32("MeJQlpEcsnsJ",12) == 653343126) strcat(s, "d");
if (crc32("QsANjRiCJBMB",12) == 1134073872) strcat(s, "o");
if (crc32("oQgAFXwde",9) == 3266825508) strcat(s, "b");
if (crc32("wdioCOIlqgc",11) == 1402082678) strcat(s, "B");
if (crc32("DwmyS",5) == 3509127987) strcat(s, "n");
if (crc32("jTKloAnsEhdJghD",15) == 1156691342) strcat(s, "o");
if (crc32("hJZKhrcje",9) == 3812626431) strcat(s, "M");
if (crc32("TzSCpu",6) == 831225020) strcat(s, "x");
if (crc32("Vlgezjg",7) == 2417490670) strcat(s, "i");
if (crc32("NjXVBjHCMFjf",12) == 892512062) strcat(s, "L");
if (crc32("IlCiAVspBBS",11) == 2335649257) strcat(s, "o");
if (crc32("fjDRLpyccl",10) == 949585490) strcat(s, "u");
if (crc32("BxgMzShKce",10) == 2152171969) strcat(s, "D");
if (crc32("NQGcrC",6) == 1064120935) strcat(s, "s");
if (crc32("rHiadohOE",9) == 1081794475) strcat(s, "Y");
if (crc32("lOnqwZgIoWWjOSf",15) == 124572464) strcat(s, "l");
if (crc32("PYiietQMx",9) == 787559853) strcat(s, "l");
if (crc32("UXDscIDR",8) == 97321733) strcat(s, "y");
    return s;
}

char *withoutdoors_adverbs() {
    char *s = calloc(13);
    if (crc32("jFRINHGP",8) == 3328625629) strcat(s, "w");
if (crc32("lNduWGx",7) == 1550715689) strcat(s, "i");
if (crc32("VuCWlmUcQmwGlRQ",15) == 3967501979) strcat(s, "t");
if (crc32("vDlEZGxcbTjkNU",14) == 134641971) strcat(s, "h");
if (crc32("suGtyJAp",8) == 4214576582) strcat(s, "B");
if (crc32("SNKOk",5) == 320136243) strcat(s, "o");
if (crc32("hVkYsMXCNTnjPD",14) == 4052902531) strcat(s, "u");
if (crc32("FodDVzAc",8) == 1138845844) strcat(s, "t");
if (crc32("XQVqe",5) == 3728577714) strcat(s, "d");
if (crc32("UrwriY",6) == 1770428141) strcat(s, "o");
if (crc32("nfFYvClh",8) == 311316972) strcat(s, "o");
if (crc32("bqgCnzCKj",9) == 876077356) strcat(s, "N");
if (crc32("qPDuTsSAn",9) == 651639149) strcat(s, "r");
if (crc32("TfzpICQD",8) == 1234327632) strcat(s, "s");
    return s;
}

char *droningly_adverbs() {
    char *s = calloc(10);
    if (crc32("MinQBhuxOXBNx",13) == 691108823) strcat(s, "d");
if (crc32("bzdUmkV",7) == 4287864022) strcat(s, "r");
if (crc32("FoLTCKeSwlvb",12) == 1744304847) strcat(s, "o");
if (crc32("ZVeWbtxGqQdjp",13) == 892595703) strcat(s, "n");
if (crc32("bUrktBFjFN",10) == 392281869) strcat(s, "i");
if (crc32("FkYQgGKFMyejU",13) == 3874848061) strcat(s, "n");
if (crc32("ULgMYCUivo",10) == 1498942163) strcat(s, "e");
if (crc32("KqUXfvttRdU",11) == 2446932586) strcat(s, "g");
if (crc32("PYFKdNnuBSMufM",14) == 3663263689) strcat(s, "l");
if (crc32("EcbCCDOzWADQ",12) == 3723489797) strcat(s, "y");
    return s;
}

char *supervirulently_adverbs() {
    char *s = calloc(16);
    if (crc32("ljAVYIhBKfnM",12) == 989081803) strcat(s, "s");
if (crc32("YyVKkfct",8) == 3747670492) strcat(s, "A");
if (crc32("XNYaAprR",8) == 2536718936) strcat(s, "u");
if (crc32("DwsHp",5) == 2745955209) strcat(s, "p");
if (crc32("AluwsHAwwkyXP",13) == 4213617443) strcat(s, "e");
if (crc32("NwdjvNG",7) == 1902676115) strcat(s, "r");
if (crc32("idmtavrf",8) == 125373721) strcat(s, "v");
if (crc32("OqBgg",5) == 1165406025) strcat(s, "i");
if (crc32("LDeRAYqTZ",9) == 1557303401) strcat(s, "U");
if (crc32("SMwsmBgP",8) == 3364307575) strcat(s, "r");
if (crc32("oLPzkqVRgA",10) == 732792873) strcat(s, "v");
if (crc32("GfhUVlq",7) == 294096081) strcat(s, "u");
if (crc32("BBqmdqlWWWoA",12) == 2299753207) strcat(s, "T");
if (crc32("YZBqXC",6) == 293173841) strcat(s, "l");
if (crc32("FpKYpMCh",8) == 3221323076) strcat(s, "D");
if (crc32("yGICb",5) == 864075738) strcat(s, "e");
if (crc32("AyBxOmqXRMcFKch",15) == 165165550) strcat(s, "n");
if (crc32("NGOGfbZlsByo",12) == 583887450) strcat(s, "h");
if (crc32("KUaghxv",7) == 2646887313) strcat(s, "t");
if (crc32("BKsIPuMVtZ",10) == 3802504303) strcat(s, "a");
if (crc32("KjeHLRt",7) == 3675825273) strcat(s, "l");
if (crc32("rJbbOZGnSIDJh",13) == 58647608) strcat(s, "y");
    return s;
}

char *whereabouts_adverbs() {
    char *s = calloc(12);
    if (crc32("VUsVPSnkVhrG",12) == 2069390265) strcat(s, "w");
if (crc32("uPLACVmeKsjt",12) == 580575170) strcat(s, "h");
if (crc32("WsDMxKNaHKnL",12) == 3803760050) strcat(s, "e");
if (crc32("YKAfQZfOEe",10) == 330567978) strcat(s, "U");
if (crc32("iBWISuVIlmEXb",13) == 2623279977) strcat(s, "r");
if (crc32("BgcfHKOikcwVB",13) == 3504873828) strcat(s, "W");
if (crc32("CKsUYOoThxyccP",14) == 578383014) strcat(s, "e");
if (crc32("LQDvyugm",8) == 559616757) strcat(s, "a");
if (crc32("lZuPTiVSWebpW",13) == 1186813064) strcat(s, "b");
if (crc32("QnejZGui",8) == 112194253) strcat(s, "K");
if (crc32("uiKFjwKxIVpMqq",14) == 758454404) strcat(s, "o");
if (crc32("CBbAxT",6) == 816607490) strcat(s, "a");
if (crc32("klERi",5) == 2474791163) strcat(s, "u");
if (crc32("LqkdSbpYABfEH",13) == 3480248673) strcat(s, "t");
if (crc32("wKNFga",6) == 904036000) strcat(s, "w");
if (crc32("gRPlLjNABZG",11) == 1875002018) strcat(s, "s");
    return s;
}

char *venally_adverbs() {
    char *s = calloc(8);
    if (crc32("BWysfiimaflh",12) == 2315544330) strcat(s, "T");
if (crc32("zoRgTTSwum",10) == 1810421927) strcat(s, "v");
if (crc32("JfiMhYNI",8) == 2790875006) strcat(s, "R");
if (crc32("AumerGlJzlU",11) == 333989030) strcat(s, "e");
if (crc32("DgTLEfgRfPs",11) == 4261498384) strcat(s, "e");
if (crc32("mMvEBoaJiReh",12) == 184425890) strcat(s, "n");
if (crc32("ioPiULNWZLa",11) == 2702668768) strcat(s, "O");
if (crc32("qIBhCbKE",8) == 3897565802) strcat(s, "a");
if (crc32("NSkLAhnao",9) == 3580676241) strcat(s, "V");
if (crc32("LQaJgvHEm",9) == 1642289022) strcat(s, "l");
if (crc32("wZIEDoAyyukqX",13) == 821608645) strcat(s, "l");
if (crc32("mNCUFFl",7) == 3371315959) strcat(s, "B");
if (crc32("RCSwmzzhiZMKaO",14) == 2639552657) strcat(s, "y");
    return s;
}

char *quasiconfidently_adverbs() {
    char *s = calloc(17);
    if (crc32("BrumCfVapZ",10) == 2103799253) strcat(s, "G");
if (crc32("cmEmz",5) == 3341686717) strcat(s, "q");
if (crc32("LqHNxey",7) == 2789231875) strcat(s, "u");
if (crc32("osMNAysCEIOzIL",14) == 2462895071) strcat(s, "a");
if (crc32("FfLOluj",7) == 2223815144) strcat(s, "s");
if (crc32("kmmKs",5) == 2063757476) strcat(s, "i");
if (crc32("nOVqW",5) == 2286790840) strcat(s, "c");
if (crc32("gztVKN",6) == 3566809642) strcat(s, "T");
if (crc32("dRObddimcSC",11) == 548281775) strcat(s, "o");
if (crc32("RhKjSJdNVd",10) == 314995987) strcat(s, "n");
if (crc32("PszTbvChVUNPfVw",15) == 960385516) strcat(s, "f");
if (crc32("LESXaadMhdUR",12) == 2204714127) strcat(s, "i");
if (crc32("zYXXtZZGkQtg",12) == 616010590) strcat(s, "d");
if (crc32("GCZsygcbraFxjOl",15) == 759612937) strcat(s, "e");
if (crc32("dATLN",5) == 791016250) strcat(s, "n");
if (crc32("qINgzyeCtXMILg",14) == 1828913030) strcat(s, "t");
if (crc32("qBzXh",5) == 1541438820) strcat(s, "l");
if (crc32("ArXTDIHA",8) == 4055458660) strcat(s, "N");
if (crc32("rJXzxBz",7) == 1824817097) strcat(s, "y");
    return s;
}

char *waterishly_adverbs() {
    char *s = calloc(11);
    if (crc32("lCpazjRqMiwKIH",14) == 1132570753) strcat(s, "w");
if (crc32("gBOwsuWvnwieES",14) == 3702124329) strcat(s, "P");
if (crc32("aKuJIbgzN",9) == 76917898) strcat(s, "a");
if (crc32("vXOFYIWtcVr",11) == 3506807863) strcat(s, "t");
if (crc32("AnaQHOUIgwh",11) == 4101467130) strcat(s, "H");
if (crc32("UraeJXr",7) == 3013944114) strcat(s, "e");
if (crc32("IjLVzAJMD",9) == 3062733076) strcat(s, "s");
if (crc32("HTRdxVxIZoS",11) == 3828661658) strcat(s, "r");
if (crc32("hVOfHhqelkvurCY",15) == 2476185560) strcat(s, "i");
if (crc32("auZENMahxo",10) == 3754575455) strcat(s, "s");
if (crc32("ZYdezYa",7) == 231650788) strcat(s, "S");
if (crc32("nxIUNkfEAk",10) == 2689478286) strcat(s, "h");
if (crc32("qizwXBUsjZymQJN",15) == 2441044832) strcat(s, "l");
if (crc32("aCiNqyNEffieg",13) == 2274838965) strcat(s, "N");
if (crc32("RMqpGadGyGxW",12) == 1497726253) strcat(s, "y");
    return s;
}

char *viceregally_adverbs() {
    char *s = calloc(12);
    if (crc32("PBXsOdPUWY",10) == 2234701846) strcat(s, "E");
if (crc32("gSwDHsnzyPg",11) == 2478922434) strcat(s, "v");
if (crc32("nNiYLY",6) == 2296187734) strcat(s, "n");
if (crc32("GRualFEhuPnxu",13) == 1985223252) strcat(s, "i");
if (crc32("LfGEoMsmfxv",11) == 1111408026) strcat(s, "Z");
if (crc32("PlDawmRqidLR",12) == 3631256618) strcat(s, "c");
if (crc32("seRnBcTNToBCrWO",15) == 102897631) strcat(s, "e");
if (crc32("UxhowCxHye",10) == 2723870800) strcat(s, "J");
if (crc32("QsKKXUqx",8) == 1738936287) strcat(s, "r");
if (crc32("eQszkuoWlYtGh",13) == 2902017081) strcat(s, "C");
if (crc32("hjNIxgYVCcM",11) == 1118124481) strcat(s, "e");
if (crc32("asQylaQVteNaJJl",15) == 3056061435) strcat(s, "Y");
if (crc32("mjvBzWCmuWQ",11) == 3928177538) strcat(s, "g");
if (crc32("jqOkE",5) == 1029345926) strcat(s, "a");
if (crc32("NtyDERuDHSAG",12) == 336285857) strcat(s, "O");
if (crc32("cUGLeyREMx",10) == 3788200918) strcat(s, "l");
if (crc32("seRJejGpwMKbMa",14) == 235494039) strcat(s, "S");
if (crc32("EYrHtLRZEH",10) == 619649662) strcat(s, "l");
if (crc32("HxUdvfwZc",9) == 3018912401) strcat(s, "y");
    return s;
}

char *monocularly_adverbs() {
    char *s = calloc(12);
    if (crc32("NzclliEBsKN",11) == 4207250717) strcat(s, "m");
if (crc32("ypTNHQykRjjqWx",14) == 1644490404) strcat(s, "r");
if (crc32("oLlCUL",6) == 1860794092) strcat(s, "o");
if (crc32("VeAIHOPzPxE",11) == 200197112) strcat(s, "n");
if (crc32("odxPFProChuBBU",14) == 990019900) strcat(s, "o");
if (crc32("nahtfIXrwXjY",12) == 1604659937) strcat(s, "O");
if (crc32("fYabaMrr",8) == 3177949042) strcat(s, "c");
if (crc32("SpWySclvMmVyPE",14) == 3688909036) strcat(s, "W");
if (crc32("GcPVzAjSuzmz",12) == 577801423) strcat(s, "u");
if (crc32("YwVjfYtlPCrekU",14) == 3686050435) strcat(s, "V");
if (crc32("uouYs",5) == 1679430615) strcat(s, "l");
if (crc32("xriDX",5) == 2014680940) strcat(s, "a");
if (crc32("LwWaWKimtQw",11) == 1233680333) strcat(s, "r");
if (crc32("KgPgcEzX",8) == 3469228987) strcat(s, "Z");
if (crc32("ipAPXewXjG",10) == 2866507081) strcat(s, "l");
if (crc32("IPDUCpCAHRsELg",14) == 1746205344) strcat(s, "u");
if (crc32("RiBJn",5) == 291332417) strcat(s, "y");
    return s;
}

char *synonymously_adverbs() {
    char *s = calloc(13);
    if (crc32("EKHaiaGMJddWn",13) == 2479417298) strcat(s, "H");
if (crc32("TunWJ",5) == 1995066255) strcat(s, "s");
if (crc32("gJTukIWKOkWvjnq",15) == 369975170) strcat(s, "y");
if (crc32("yNyqmKQTPX",10) == 2323323839) strcat(s, "C");
if (crc32("pRxcvVWdvfhNQRa",15) == 335813472) strcat(s, "n");
if (crc32("OgVqooccmwADTo",14) == 377139528) strcat(s, "s");
if (crc32("CetOrRRNPZWDF",13) == 675030869) strcat(s, "o");
if (crc32("KWJDO",5) == 198382519) strcat(s, "M");
if (crc32("fYQztZTsUSjoo",13) == 940400277) strcat(s, "n");
if (crc32("snpDBXNfWyyvC",13) == 1307597870) strcat(s, "y");
if (crc32("RpvYLere",8) == 3376339058) strcat(s, "m");
if (crc32("mIsOyv",6) == 3020470045) strcat(s, "G");
if (crc32("VtHjb",5) == 3607864732) strcat(s, "o");
if (crc32("Yfrdpl",6) == 1776428319) strcat(s, "u");
if (crc32("ApaVgnVEXenCbH",14) == 2164506861) strcat(s, "s");
if (crc32("puRhTIxaiJs",11) == 366391472) strcat(s, "T");
if (crc32("SdyqIl",6) == 1909538361) strcat(s, "l");
if (crc32("AYPGySHyfhzG",12) == 51196657) strcat(s, "y");
    return s;
}

char *overbumptiously_adverbs() {
    char *s = calloc(16);
    if (crc32("kAYCEDVdGEWapJM",15) == 3127937865) strcat(s, "o");
if (crc32("sOQiEDBDnTyP",12) == 2636077468) strcat(s, "Q");
if (crc32("LEAjNVcj",8) == 3941083422) strcat(s, "v");
if (crc32("TAmGtufRaYuCTAf",15) == 767083390) strcat(s, "r");
if (crc32("DfdveD",6) == 3195667945) strcat(s, "e");
if (crc32("RuoUKWblXzM",11) == 3101066898) strcat(s, "F");
if (crc32("ttOYXzGijvQePz",14) == 53627063) strcat(s, "r");
if (crc32("jwJhsBIl",8) == 1701582810) strcat(s, "b");
if (crc32("zhtyIVbB",8) == 3316576758) strcat(s, "u");
if (crc32("UEfEnC",6) == 19226153) strcat(s, "m");
if (crc32("HXfJs",5) == 802747203) strcat(s, "p");
if (crc32("plIYXOl",7) == 3164519381) strcat(s, "t");
if (crc32("MKiydME",7) == 1401236713) strcat(s, "i");
if (crc32("GVyWne",6) == 3987751122) strcat(s, "Q");
if (crc32("xUdLZuOtMha",11) == 42022006) strcat(s, "o");
if (crc32("mEcOlmPL",8) == 3280424526) strcat(s, "u");
if (crc32("TLdivOLwokUI",12) == 3022604095) strcat(s, "u");
if (crc32("bGNxSaphOGXcQE",14) == 991597539) strcat(s, "G");
if (crc32("sLqSVTnIiRdJr",13) == 2100540267) strcat(s, "s");
if (crc32("QakTpKOBCndimlA",15) == 3523637719) strcat(s, "q");
if (crc32("NSjUuazbMBYLJ",13) == 2101044904) strcat(s, "l");
if (crc32("yZEXdgI",7) == 3175216843) strcat(s, "y");
    return s;
}

char *preallowably_adverbs() {
    char *s = calloc(13);
    if (crc32("sDqSXlNb",8) == 3393586425) strcat(s, "p");
if (crc32("XLKfJKUJAVCrnD",14) == 350256496) strcat(s, "r");
if (crc32("XyWrJDkfJHYb",12) == 2146271482) strcat(s, "e");
if (crc32("FKkQXrEBVmeB",12) == 3010457266) strcat(s, "a");
if (crc32("wcEFRUSfE",9) == 4225352379) strcat(s, "v");
if (crc32("twqdgUr",7) == 3620068272) strcat(s, "l");
if (crc32("LiVlTfK",7) == 372259822) strcat(s, "Q");
if (crc32("FDCgvPzZe",9) == 523314544) strcat(s, "l");
if (crc32("hgpeMmknFUJK",12) == 1767486741) strcat(s, "W");
if (crc32("DDAKYzyXCh",10) == 551074484) strcat(s, "o");
if (crc32("WCXAzqrgT",9) == 3402177709) strcat(s, "B");
if (crc32("JCmaML",6) == 3132495882) strcat(s, "w");
if (crc32("rNfhNDVO",8) == 3998628778) strcat(s, "a");
if (crc32("HldLYXyrZxcfJ",13) == 1039269176) strcat(s, "D");
if (crc32("yOiZeJfMBNcHy",13) == 39092539) strcat(s, "b");
if (crc32("CNfwVbAQG",9) == 3749504295) strcat(s, "l");
if (crc32("ZYQWXeIIvuEPb",13) == 1825700496) strcat(s, "m");
if (crc32("GmIeChHhoxw",11) == 932092936) strcat(s, "y");
    return s;
}

char *offendedly_adverbs() {
    char *s = calloc(11);
    if (crc32("szGbCWgwkLDJUIg",15) == 1176719751) strcat(s, "o");
if (crc32("FAepmCRTdhgZ",12) == 2507848590) strcat(s, "f");
if (crc32("qAUuDHOfJQ",10) == 3359012067) strcat(s, "O");
if (crc32("SBMMToyBEvI",11) == 1711465588) strcat(s, "f");
if (crc32("vosWPzTHgkFpX",13) == 4048927991) strcat(s, "e");
if (crc32("rPvXNK",6) == 2691211737) strcat(s, "K");
if (crc32("QomwHV",6) == 1328085674) strcat(s, "n");
if (crc32("wORvVQark",9) == 2715364526) strcat(s, "d");
if (crc32("vATepyBubhoUx",13) == 2052685522) strcat(s, "L");
if (crc32("zScOfglL",8) == 4223356701) strcat(s, "e");
if (crc32("xXFGSXZaTTeRcky",15) == 3347395373) strcat(s, "I");
if (crc32("kGavF",5) == 2177649159) strcat(s, "d");
if (crc32("DvaJoClvWtNo",12) == 3907508975) strcat(s, "l");
if (crc32("yFOtZodG",8) == 229175916) strcat(s, "y");
    return s;
}

char *responsibly_adverbs() {
    char *s = calloc(12);
    if (crc32("LGNagzKFZZ",10) == 2572325614) strcat(s, "r");
if (crc32("QShMjccyw",9) == 3540699862) strcat(s, "e");
if (crc32("buCatU",6) == 3453469327) strcat(s, "E");
if (crc32("PlzoCaPmYk",10) == 3072459513) strcat(s, "s");
if (crc32("oasKkLVNjH",10) == 1626006902) strcat(s, "p");
if (crc32("mVHWl",5) == 3059064011) strcat(s, "m");
if (crc32("sXxcJJvxZptUUJN",15) == 2808853524) strcat(s, "o");
if (crc32("CniTBWj",7) == 1863873289) strcat(s, "p");
if (crc32("htLgyPALKrf",11) == 2558659721) strcat(s, "n");
if (crc32("RDLQono",7) == 987164756) strcat(s, "J");
if (crc32("oKGrvzPMUp",10) == 2375122697) strcat(s, "s");
if (crc32("BpjydYXLPxAGN",13) == 2530879593) strcat(s, "Z");
if (crc32("mvdNCkdBMm",10) == 3525301829) strcat(s, "i");
if (crc32("jNWRJiDnOX",10) == 2788800865) strcat(s, "b");
if (crc32("ckqFPLIAKAbvxAn",15) == 85989518) strcat(s, "h");
if (crc32("GzISmgWXbaS",11) == 1657440799) strcat(s, "l");
if (crc32("ymOBlGuEIPVkq",13) == 102863980) strcat(s, "F");
if (crc32("NlWPiysQkXllkPr",15) == 1811560094) strcat(s, "y");
    return s;
}

char *colourationally_adverbs() {
    char *s = calloc(16);
    if (crc32("LQzqeXpUUBOs",12) == 3019861306) strcat(s, "c");
if (crc32("ofWicXGEDXHcF",13) == 3611551697) strcat(s, "q");
if (crc32("xzIZTMxru",9) == 789425604) strcat(s, "o");
if (crc32("vFoEgd",6) == 1471332572) strcat(s, "O");
if (crc32("OxKtdhVOTbYxue",14) == 3226259625) strcat(s, "l");
if (crc32("jcNjxtEa",8) == 4151569458) strcat(s, "H");
if (crc32("TFigOOZKnsL",11) == 1365279275) strcat(s, "o");
if (crc32("xRFVZMC",7) == 4048658269) strcat(s, "u");
if (crc32("YXABWoIluZEm",12) == 2980376537) strcat(s, "c");
if (crc32("IDiMauheeB",10) == 711942919) strcat(s, "r");
if (crc32("rTOiAa",6) == 1830679340) strcat(s, "a");
if (crc32("HXHjzmJ",7) == 173385763) strcat(s, "E");
if (crc32("ePYHY",5) == 361183712) strcat(s, "t");
if (crc32("jljNnnHTeBKn",12) == 3321555680) strcat(s, "i");
if (crc32("YaKuVxDqZmi",11) == 2998153740) strcat(s, "o");
if (crc32("LWixzDvow",9) == 2538019908) strcat(s, "L");
if (crc32("RUacXUgE",8) == 1446166473) strcat(s, "n");
if (crc32("sNjMKhmiQmyFL",13) == 3693238955) strcat(s, "a");
if (crc32("xWxJDPXGPe",10) == 3745305229) strcat(s, "l");
if (crc32("rPsshABM",8) == 3735973362) strcat(s, "l");
if (crc32("eiGzyoSOn",9) == 819651602) strcat(s, "y");
    return s;
}

char *nonlyrically_adverbs() {
    char *s = calloc(13);
    if (crc32("ExcNE",5) == 3664186042) strcat(s, "n");
if (crc32("QzbKwNJ",7) == 3034405915) strcat(s, "o");
if (crc32("qXGLtp",6) == 614083173) strcat(s, "t");
if (crc32("QDRrSFZNxEYPMTe",15) == 1438759660) strcat(s, "n");
if (crc32("rYGNwor",7) == 1372779961) strcat(s, "l");
if (crc32("uSFoLGuyZtcLk",13) == 773535963) strcat(s, "y");
if (crc32("gmhSUFNh",8) == 1798235841) strcat(s, "r");
if (crc32("VSTpuFiUrlNNR",13) == 105400813) strcat(s, "T");
if (crc32("dNImR",5) == 4213611235) strcat(s, "i");
if (crc32("FFkvoFvZXvCjq",13) == 2275295116) strcat(s, "c");
if (crc32("ndWuZAKK",8) == 165382639) strcat(s, "C");
if (crc32("jWrsMf",6) == 3826898303) strcat(s, "a");
if (crc32("uWkJaTQyRz",10) == 1737527918) strcat(s, "P");
if (crc32("signckjMi",9) == 2585827250) strcat(s, "l");
if (crc32("ijyXgn",6) == 206773520) strcat(s, "V");
if (crc32("dndCQoxkUP",10) == 343619702) strcat(s, "l");
if (crc32("MMlRExtXRz",10) == 3162870458) strcat(s, "y");
    return s;
}

char *nonsynoptically_adverbs() {
    char *s = calloc(16);
    if (crc32("LFHisnm",7) == 2007044038) strcat(s, "n");
if (crc32("ShQnLYUvgQnYVm",14) == 3298858750) strcat(s, "o");
if (crc32("kHsUkH",6) == 1842864770) strcat(s, "A");
if (crc32("JnDCiugrBYn",11) == 2846553763) strcat(s, "n");
if (crc32("ceZSBhiI",8) == 4236813837) strcat(s, "s");
if (crc32("uBavX",5) == 2670447651) strcat(s, "Q");
if (crc32("uCwePhyIxBUAl",13) == 282121377) strcat(s, "y");
if (crc32("hPKFe",5) == 2368368101) strcat(s, "B");
if (crc32("eBOamh",6) == 3532661151) strcat(s, "n");
if (crc32("VVILGFVFmSN",11) == 4212222013) strcat(s, "b");
if (crc32("DeYCpbhXqWHidUn",15) == 1268852534) strcat(s, "o");
if (crc32("iYfzSy",6) == 1415499997) strcat(s, "p");
if (crc32("NoPoyE",6) == 3807856059) strcat(s, "T");
if (crc32("cdtoHtQ",7) == 4076233976) strcat(s, "t");
if (crc32("aLNNxxtmrmGvGrS",15) == 631692457) strcat(s, "f");
if (crc32("IDtGatnWWJNbflM",15) == 459348486) strcat(s, "i");
if (crc32("cdqpxjxG",8) == 2575748900) strcat(s, "c");
if (crc32("avtwH",5) == 1738911935) strcat(s, "a");
if (crc32("TTshqde",7) == 4293352201) strcat(s, "l");
if (crc32("YbkFezkJFPFR",12) == 131490752) strcat(s, "l");
if (crc32("wNCIcTw",7) == 580478559) strcat(s, "l");
if (crc32("dIFejdeibb",10) == 94360182) strcat(s, "y");
    return s;
}

char *unsusceptibly_adverbs() {
    char *s = calloc(14);
    if (crc32("pzdjaOXboB",10) == 763323903) strcat(s, "u");
if (crc32("nlmabWBT",8) == 2868426463) strcat(s, "n");
if (crc32("ugKuUwhLOB",10) == 2128582229) strcat(s, "s");
if (crc32("MVfvip",6) == 526163861) strcat(s, "u");
if (crc32("ikBkCd",6) == 2367467397) strcat(s, "O");
if (crc32("RgRWepAIDAc",11) == 1614821976) strcat(s, "s");
if (crc32("IDxhuFqPM",9) == 1084444178) strcat(s, "K");
if (crc32("elnhqGF",7) == 2532334301) strcat(s, "c");
if (crc32("XWULzfmZpwebaqm",15) == 1336809663) strcat(s, "e");
if (crc32("BcKXAYFMwuiy",12) == 3527880822) strcat(s, "e");
if (crc32("bomeKnbMlpp",11) == 1979019020) strcat(s, "v");
if (crc32("OpviR",5) == 379088077) strcat(s, "p");
if (crc32("EYJnLUuyYiHFf",13) == 1300642462) strcat(s, "t");
if (crc32("zIwOhmULjxIhLA",14) == 3324506843) strcat(s, "T");
if (crc32("TqgMLNxbw",9) == 1897574423) strcat(s, "i");
if (crc32("JMRbsyB",7) == 766868434) strcat(s, "b");
if (crc32("DOpLStrFOz",10) == 843774433) strcat(s, "b");
if (crc32("VGeRpoADoqAZ",12) == 3505994347) strcat(s, "l");
if (crc32("GUxvNahkg",9) == 3925978781) strcat(s, "l");
if (crc32("bcWgUMX",7) == 1777805298) strcat(s, "y");
    return s;
}

char *noncaustically_adverbs() {
    char *s = calloc(15);
    if (crc32("UdsvVjpdlEX",11) == 2445005629) strcat(s, "m");
if (crc32("gDsHOPyarUE",11) == 3925150794) strcat(s, "n");
if (crc32("YsMPrmHKz",9) == 2768185179) strcat(s, "o");
if (crc32("FpQfmXuiYlv",11) == 2080785933) strcat(s, "W");
if (crc32("SyGqUtUKUP",10) == 4165241543) strcat(s, "n");
if (crc32("gmjZOIRL",8) == 3313134833) strcat(s, "c");
if (crc32("xXYOHcHx",8) == 2311085459) strcat(s, "a");
if (crc32("GGJpMWDajUgxnH",14) == 854704768) strcat(s, "F");
if (crc32("wuKmFbahrv",10) == 2290060108) strcat(s, "u");
if (crc32("xrhJEkjbTNnmV",13) == 2437484623) strcat(s, "s");
if (crc32("oqcsFdjDwsLV",12) == 130888587) strcat(s, "t");
if (crc32("rqKXaeA",7) == 960331210) strcat(s, "A");
if (crc32("WslAALBDSPHFIhh",15) == 4235227586) strcat(s, "i");
if (crc32("EOAmiDjQn",9) == 404313092) strcat(s, "c");
if (crc32("mJqDGeRVN",9) == 3644379246) strcat(s, "a");
if (crc32("GdJuBewDyzwlyIU",15) == 541963801) strcat(s, "l");
if (crc32("LkocctdhhOEn",12) == 1211783494) strcat(s, "k");
if (crc32("NhTshQ",6) == 2386704386) strcat(s, "l");
if (crc32("lOOweYsZBmsriQU",15) == 3439979992) strcat(s, "l");
if (crc32("zEpMPxjcesXXI",13) == 699220224) strcat(s, "y");
    return s;
}

char *flatling_adverbs() {
    char *s = calloc(9);
    if (crc32("OdbaXbU",7) == 577009091) strcat(s, "W");
if (crc32("IaprAPupuSMRH",13) == 3287993131) strcat(s, "f");
if (crc32("XOposWqRCnqWj",13) == 2954140706) strcat(s, "Z");
if (crc32("ynwodyq",7) == 1760829391) strcat(s, "l");
if (crc32("GBmjoqxy",8) == 2235229317) strcat(s, "N");
if (crc32("vQGbaRRiercLQNy",15) == 1211385311) strcat(s, "a");
if (crc32("sbpuWOIDtYbwHWa",15) == 3528505690) strcat(s, "E");
if (crc32("yAayPmGjikvfro",14) == 3635691192) strcat(s, "t");
if (crc32("UuWmotkPepy",11) == 2945160195) strcat(s, "l");
if (crc32("tVozGOeJtm",10) == 3330632656) strcat(s, "w");
if (crc32("kRRWggFQMRGVU",13) == 207839195) strcat(s, "i");
if (crc32("QNmmqivjAsooUHI",15) == 3046121619) strcat(s, "T");
if (crc32("RZNnqfpXz",9) == 339588304) strcat(s, "n");
if (crc32("ZJydj",5) == 3681220033) strcat(s, "y");
if (crc32("izMzbFUsyUj",11) == 3470978292) strcat(s, "g");
    return s;
}

char *stammeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("OMhxZGEYYqHdjp",14) == 2754022280) strcat(s, "s");
if (crc32("tiOEHgBQ",8) == 4027631399) strcat(s, "t");
if (crc32("VzjFmHiAc",9) == 1386012964) strcat(s, "Q");
if (crc32("ZpHIL",5) == 4293305700) strcat(s, "a");
if (crc32("dUmMPtjuvk",10) == 106692530) strcat(s, "G");
if (crc32("dqsvXMLsPgb",11) == 2480474635) strcat(s, "m");
if (crc32("JdAXEv",6) == 115111485) strcat(s, "m");
if (crc32("hTTJJxifP",9) == 1801931134) strcat(s, "k");
if (crc32("yyIdwOc",7) == 3690090782) strcat(s, "e");
if (crc32("flMTAaxy",8) == 3848766548) strcat(s, "r");
if (crc32("JpZhUYyePWG",11) == 2666737225) strcat(s, "i");
if (crc32("EpXdfTfzem",10) == 279328737) strcat(s, "J");
if (crc32("ptPHawNUaT",10) == 323509137) strcat(s, "n");
if (crc32("JHsKBJu",7) == 899433465) strcat(s, "g");
if (crc32("KtPudXUEbix",11) == 1858211314) strcat(s, "C");
if (crc32("ohFLGbbWtLOKM",13) == 721095554) strcat(s, "l");
if (crc32("MumeVp",6) == 3935459934) strcat(s, "u");
if (crc32("enbWiWT",7) == 500068337) strcat(s, "y");
    return s;
}

char *imprecatorily_adverbs() {
    char *s = calloc(14);
    if (crc32("NoLHDAxKbNbXTyJ",15) == 3140508799) strcat(s, "Z");
if (crc32("bgIMvIqOMOuq",12) == 1302478908) strcat(s, "i");
if (crc32("ZcwROlYBZU",10) == 101681239) strcat(s, "m");
if (crc32("xdfVMKukjKuFV",13) == 2792564927) strcat(s, "p");
if (crc32("JUritUdyH",9) == 3722063483) strcat(s, "r");
if (crc32("asHPZuXmP",9) == 57776129) strcat(s, "e");
if (crc32("SBGsHMRpEbUm",12) == 823554876) strcat(s, "p");
if (crc32("jLtDYzThH",9) == 1385117527) strcat(s, "c");
if (crc32("JrKndBJloHrTgYe",15) == 567985473) strcat(s, "u");
if (crc32("uGjBjBtWQlfhToV",15) == 3988564775) strcat(s, "a");
if (crc32("sDiyyvVbtWberR",14) == 4212255741) strcat(s, "z");
if (crc32("RKKrmvgYVVE",11) == 3084261162) strcat(s, "t");
if (crc32("SOyDpKRlUS",10) == 4111358613) strcat(s, "E");
if (crc32("EcxLjkyIoTRlqk",14) == 3679439542) strcat(s, "o");
if (crc32("fHDMYXttqjE",11) == 493178011) strcat(s, "r");
if (crc32("udPjfw",6) == 4111762870) strcat(s, "i");
if (crc32("IAUZKFFwsgwdp",13) == 2736103132) strcat(s, "l");
if (crc32("shrrs",5) == 2821136617) strcat(s, "l");
if (crc32("ZdCCA",5) == 2828410490) strcat(s, "y");
    return s;
}

char *pseudoaristocratically_adverbs() {
    char *s = calloc(23);
    if (crc32("oEZXK",5) == 2211273644) strcat(s, "p");
if (crc32("dXGClxLMa",9) == 2643335517) strcat(s, "s");
if (crc32("tRZWLjGdHyehcEu",15) == 99188335) strcat(s, "X");
if (crc32("iCBxrex",7) == 2534930178) strcat(s, "e");
if (crc32("aujhh",5) == 1344871012) strcat(s, "o");
if (crc32("DhfoztBmxA",10) == 3386792885) strcat(s, "u");
if (crc32("sRwKY",5) == 1238412128) strcat(s, "d");
if (crc32("VSdPqN",6) == 428353889) strcat(s, "V");
if (crc32("ZoNqJcRhBhG",11) == 1124620956) strcat(s, "o");
if (crc32("ZWNRmGE",7) == 228892837) strcat(s, "y");
if (crc32("VyeOKmHz",8) == 2305506241) strcat(s, "a");
if (crc32("uMYtI",5) == 3109046459) strcat(s, "r");
if (crc32("OadVPRFunmEN",12) == 4294949346) strcat(s, "i");
if (crc32("VjwXRZlIduswOP",14) == 2371293062) strcat(s, "M");
if (crc32("CDOkMBhATdz",11) == 142873860) strcat(s, "s");
if (crc32("XFyvExV",7) == 4252935221) strcat(s, "t");
if (crc32("NdwQvtWuhMqn",12) == 2070508199) strcat(s, "o");
if (crc32("vivaDSbQAPd",11) == 3829097639) strcat(s, "c");
if (crc32("jVAvJjlVctlEB",13) == 1346895937) strcat(s, "V");
if (crc32("siuKulCjzKKfBhQ",15) == 947317730) strcat(s, "r");
if (crc32("avoVAJ",6) == 1894189998) strcat(s, "a");
if (crc32("pCtFhqsrgXQhUy",14) == 2551231389) strcat(s, "t");
if (crc32("pBiHg",5) == 2099727086) strcat(s, "X");
if (crc32("GUugloRalk",10) == 1390758129) strcat(s, "i");
if (crc32("RMhDkbcry",9) == 623460059) strcat(s, "c");
if (crc32("kVXNxKzxWtKnku",14) == 3956605087) strcat(s, "a");
if (crc32("zjHjrZ",6) == 1169063250) strcat(s, "l");
if (crc32("TRauLGBjJFdUWni",15) == 574858249) strcat(s, "H");
if (crc32("DxFbt",5) == 2976828565) strcat(s, "l");
if (crc32("AXKpsdaHOqK",11) == 2388300672) strcat(s, "y");
if (crc32("AqydCJASbovQKW",14) == 1632384878) strcat(s, "y");
    return s;
}

char *subocularly_adverbs() {
    char *s = calloc(12);
    if (crc32("jbTNxv",6) == 2612311674) strcat(s, "s");
if (crc32("tcFKtKwIiLk",11) == 1946283894) strcat(s, "i");
if (crc32("eoAyt",5) == 746092568) strcat(s, "u");
if (crc32("amnBYCskhynoO",13) == 3446365129) strcat(s, "b");
if (crc32("WMfGyNeJY",9) == 1865593126) strcat(s, "l");
if (crc32("jCslkHz",7) == 940973917) strcat(s, "o");
if (crc32("pjtGRM",6) == 578217311) strcat(s, "e");
if (crc32("UIoTvXFZEiw",11) == 1109264727) strcat(s, "c");
if (crc32("BfbqN",5) == 2533706991) strcat(s, "p");
if (crc32("FokIin",6) == 4277727922) strcat(s, "u");
if (crc32("SsapwDuLx",9) == 2789610999) strcat(s, "l");
if (crc32("cTlsgpkkUSlklf",14) == 505365348) strcat(s, "a");
if (crc32("PBxMsnBNEJtTd",13) == 3801244508) strcat(s, "p");
if (crc32("pirEWoIPJssjht",14) == 3338597852) strcat(s, "r");
if (crc32("VUqOuAtWu",9) == 3663817885) strcat(s, "l");
if (crc32("pXStRPM",7) == 3621363128) strcat(s, "y");
    return s;
}

char *histogenetically_adverbs() {
    char *s = calloc(17);
    if (crc32("LmTYlKErewF",11) == 4141571881) strcat(s, "m");
if (crc32("RXzoOVcXYetAvya",15) == 2027874377) strcat(s, "h");
if (crc32("qBUOcyLNTEAF",12) == 4047535423) strcat(s, "C");
if (crc32("ezJATcIA",8) == 1358941926) strcat(s, "i");
if (crc32("zDXglYqQFVtcGj",14) == 3964076092) strcat(s, "L");
if (crc32("vdBHllVS",8) == 1950947076) strcat(s, "s");
if (crc32("uNeyv",5) == 2237442257) strcat(s, "t");
if (crc32("HgbnMMfDrZYU",12) == 1092180989) strcat(s, "o");
if (crc32("zywxyhoBBZOc",12) == 1284659911) strcat(s, "g");
if (crc32("YcrrIWs",7) == 3424351812) strcat(s, "q");
if (crc32("YpVeYEmZ",8) == 3550434939) strcat(s, "e");
if (crc32("cDVXfWshITn",11) == 15749283) strcat(s, "n");
if (crc32("sZKbJ",5) == 2971143828) strcat(s, "Q");
if (crc32("xnJXONrRXlppnbe",15) == 1036747698) strcat(s, "e");
if (crc32("kRXzZtrBhIeU",12) == 4156754580) strcat(s, "t");
if (crc32("QCQriDWAGnSuk",13) == 2139147980) strcat(s, "i");
if (crc32("tZhUteoEN",9) == 3323287314) strcat(s, "t");
if (crc32("rSZshMcGLOpdyH",14) == 3983626886) strcat(s, "c");
if (crc32("zEJhNGLWwQ",10) == 3382176050) strcat(s, "y");
if (crc32("rtNtl",5) == 3560849970) strcat(s, "a");
if (crc32("SWqJYJhreXQIMhL",15) == 947674365) strcat(s, "M");
if (crc32("DjoXabhtZEcSD",13) == 1546216418) strcat(s, "l");
if (crc32("nkGxTjS",7) == 299631929) strcat(s, "e");
if (crc32("SlrlVerboHWvT",13) == 1696803310) strcat(s, "l");
if (crc32("lPmfWDCzvu",10) == 3435038235) strcat(s, "y");
    return s;
}

char *refreshingly_adverbs() {
    char *s = calloc(13);
    if (crc32("DSsagBptE",9) == 2750283423) strcat(s, "r");
if (crc32("mTgpvjUWxntTt",13) == 2627249478) strcat(s, "e");
if (crc32("KSdqZAdZLHgIdaZ",15) == 2591470191) strcat(s, "g");
if (crc32("klEHWUZix",9) == 3077112369) strcat(s, "f");
if (crc32("yOIQwuQSBrCZjs",14) == 1099104518) strcat(s, "r");
if (crc32("vQoJlAgcGWnpgPj",15) == 1881687619) strcat(s, "e");
if (crc32("mKActZEonJQKH",13) == 2016110104) strcat(s, "s");
if (crc32("dEZFO",5) == 657559931) strcat(s, "h");
if (crc32("PHDEaQzOFfdAEQ",14) == 3398847760) strcat(s, "i");
if (crc32("gJbviCWleqKGENm",15) == 1758733364) strcat(s, "P");
if (crc32("StjQQdYIDTZ",11) == 3264923565) strcat(s, "n");
if (crc32("THDdtAQRQDSVb",13) == 1072263977) strcat(s, "d");
if (crc32("LYxleNo",7) == 1895787888) strcat(s, "g");
if (crc32("rKghhPL",7) == 916498213) strcat(s, "D");
if (crc32("DEyRE",5) == 310409357) strcat(s, "l");
if (crc32("lgeTKYeLTHFAhjd",15) == 3216084598) strcat(s, "g");
if (crc32("mLygYXFgCeymkrV",15) == 1984282644) strcat(s, "y");
    return s;
}

char *breathingly_adverbs() {
    char *s = calloc(12);
    if (crc32("MqvBKU",6) == 1344884395) strcat(s, "F");
if (crc32("QBzoqcPWLlqSy",13) == 2973519166) strcat(s, "b");
if (crc32("jfhbfTDmlLmswJ",14) == 3504641853) strcat(s, "b");
if (crc32("NSZoeCjpnNZLp",13) == 472820422) strcat(s, "r");
if (crc32("RrGrmThdhGY",11) == 1717365145) strcat(s, "e");
if (crc32("hbfXzLPPWQwTZi",14) == 1461920040) strcat(s, "a");
if (crc32("qqOUFZTNw",9) == 4223353765) strcat(s, "L");
if (crc32("ziadVaZXEJtr",12) == 2667226833) strcat(s, "t");
if (crc32("FvckitwQcQXTRih",15) == 3072174233) strcat(s, "h");
if (crc32("YpnibhOEEbYDsZz",15) == 3864227692) strcat(s, "a");
if (crc32("PgNygNsyYZTIt",13) == 2906343355) strcat(s, "i");
if (crc32("xIBlnwvhVtmY",12) == 2707011517) strcat(s, "j");
if (crc32("HPznvEdVuAxWO",13) == 455699371) strcat(s, "n");
if (crc32("XLirDQYNBvTsiTy",15) == 1690791720) strcat(s, "g");
if (crc32("XCsraHuxkivbA",13) == 3365734466) strcat(s, "l");
if (crc32("PnkZaDeonB",10) == 2250207699) strcat(s, "y");
    return s;
}

char *massedly_adverbs() {
    char *s = calloc(9);
    if (crc32("XETtDfY",7) == 2911813084) strcat(s, "m");
if (crc32("bgQrHcOthZiKXRf",15) == 888426534) strcat(s, "a");
if (crc32("CqRFiYQ",7) == 3830350436) strcat(s, "s");
if (crc32("pLgQslldljASDR",14) == 1444626749) strcat(s, "s");
if (crc32("DPInssesti",10) == 4251202018) strcat(s, "e");
if (crc32("BeNpll",6) == 1581055027) strcat(s, "w");
if (crc32("OtrbD",5) == 2312323036) strcat(s, "d");
if (crc32("WiXfAISACUWZmF",14) == 1159083975) strcat(s, "V");
if (crc32("MVFJk",5) == 751228342) strcat(s, "l");
if (crc32("uPdNiZ",6) == 4279068878) strcat(s, "l");
if (crc32("SIXtoJVQtjQhXmd",15) == 3018312585) strcat(s, "y");
    return s;
}

char *exorbitantly_adverbs() {
    char *s = calloc(13);
    if (crc32("crwULmoDgckQsMQ",15) == 1755721208) strcat(s, "e");
if (crc32("OVhin",5) == 3383967762) strcat(s, "H");
if (crc32("hIoticahmPCI",12) == 463069136) strcat(s, "x");
if (crc32("OTrIr",5) == 450098285) strcat(s, "O");
if (crc32("PkxJtPYnMShFt",13) == 550094321) strcat(s, "o");
if (crc32("eZexqNtyaooWFd",14) == 1578433092) strcat(s, "u");
if (crc32("KcdXmNqqPRvfiB",14) == 4248328517) strcat(s, "r");
if (crc32("WBaMNmW",7) == 4053050521) strcat(s, "V");
if (crc32("kUoAWGptl",9) == 1263900990) strcat(s, "b");
if (crc32("kwsmMtj",7) == 3242753787) strcat(s, "t");
if (crc32("xcIrUCsBW",9) == 2093663978) strcat(s, "i");
if (crc32("isWTJkmbgbnPrX",14) == 1293685642) strcat(s, "t");
if (crc32("NYzatFfGne",10) == 1197957147) strcat(s, "a");
if (crc32("LMrpkIHAeDqnn",13) == 3429870920) strcat(s, "n");
if (crc32("gKKTap",6) == 2152957331) strcat(s, "t");
if (crc32("FZIbBOakNPAl",12) == 1610669245) strcat(s, "l");
if (crc32("pbjgZWXpS",9) == 634960437) strcat(s, "y");
    return s;
}

char *malapertly_adverbs() {
    char *s = calloc(11);
    if (crc32("YwuLhaOBg",9) == 404812282) strcat(s, "m");
if (crc32("WhZIEplf",8) == 4023129604) strcat(s, "a");
if (crc32("vJUBnuHqhXsoX",13) == 3984940911) strcat(s, "l");
if (crc32("jZjfRJGdLew",11) == 2201764275) strcat(s, "f");
if (crc32("fANzrnOVwPF",11) == 2150114094) strcat(s, "a");
if (crc32("ffQOv",5) == 1830894978) strcat(s, "L");
if (crc32("DMuUNAeo",8) == 2300702940) strcat(s, "p");
if (crc32("LttGLxGNTm",10) == 1138683390) strcat(s, "e");
if (crc32("mtlrxQiF",8) == 1406414716) strcat(s, "K");
if (crc32("OuYScxPKHy",10) == 2401378026) strcat(s, "r");
if (crc32("ltjYGCnoOdxd",12) == 1593176717) strcat(s, "t");
if (crc32("ZyJSnTPmR",9) == 2401786286) strcat(s, "H");
if (crc32("dKPyMQHAw",9) == 382803359) strcat(s, "l");
if (crc32("iVufFPYFfgkslh",14) == 30838123) strcat(s, "i");
if (crc32("QGhYj",5) == 1162380577) strcat(s, "y");
    return s;
}

char *unambitiously_adverbs() {
    char *s = calloc(14);
    if (crc32("ieOLajOFYYTz",12) == 435156233) strcat(s, "u");
if (crc32("ddEgEXnncXTt",12) == 1462080228) strcat(s, "n");
if (crc32("IHYmFMGJFWXPZoF",15) == 462887035) strcat(s, "n");
if (crc32("VmXCfdthYD",10) == 63081488) strcat(s, "a");
if (crc32("zEzSqlezHlACDC",14) == 2161301786) strcat(s, "m");
if (crc32("diJtJTas",8) == 2815054670) strcat(s, "b");
if (crc32("UVsvoKErjcvgc",13) == 635547200) strcat(s, "Z");
if (crc32("LlDtemegJrS",11) == 3754641462) strcat(s, "i");
if (crc32("ZjGaxBWadbb",11) == 2533658681) strcat(s, "c");
if (crc32("fnLMYywShtc",11) == 1206944781) strcat(s, "t");
if (crc32("gaBHRuXpnaoPxRZ",15) == 813113541) strcat(s, "i");
if (crc32("qSShcU",6) == 3298979095) strcat(s, "o");
if (crc32("sqLZE",5) == 3820769748) strcat(s, "W");
if (crc32("oVwCk",5) == 1672256828) strcat(s, "u");
if (crc32("TFDiXHmnBYVCX",13) == 4227131800) strcat(s, "s");
if (crc32("aXEwzzDOTDJHNyJ",15) == 266548581) strcat(s, "U");
if (crc32("IaQzgfE",7) == 4130287923) strcat(s, "l");
if (crc32("TyeLB",5) == 2489739392) strcat(s, "N");
if (crc32("XCCLvtrRkXgfH",13) == 2807933858) strcat(s, "y");
    return s;
}

char *huddlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("nntcBdO",7) == 3308663554) strcat(s, "h");
if (crc32("UNcjMtLWxTUrL",13) == 3712898969) strcat(s, "u");
if (crc32("cSIArkgNwDKzY",13) == 3882783851) strcat(s, "d");
if (crc32("aOXHhGgzK",9) == 2019227152) strcat(s, "d");
if (crc32("GzrOiudHS",9) == 2232376249) strcat(s, "V");
if (crc32("fJdQgiI",7) == 846054046) strcat(s, "l");
if (crc32("qMbhujbLLfmXb",13) == 1334361904) strcat(s, "V");
if (crc32("VTydZefHmzmzOm",14) == 2496516609) strcat(s, "i");
if (crc32("nsBKySlG",8) == 1229842958) strcat(s, "n");
if (crc32("bYKtaQV",7) == 151502045) strcat(s, "g");
if (crc32("hkVcDRNAftZwsOx",15) == 4053250337) strcat(s, "x");
if (crc32("opVEVaiOTYdD",12) == 3821821272) strcat(s, "l");
if (crc32("jMqTfsW",7) == 1022811421) strcat(s, "y");
    return s;
}

char *nabobishly_adverbs() {
    char *s = calloc(11);
    if (crc32("JPmSo",5) == 3852124615) strcat(s, "V");
if (crc32("jHAuOgypTBhyDO",14) == 641768118) strcat(s, "n");
if (crc32("GwFrWdan",8) == 4199473848) strcat(s, "a");
if (crc32("upGaCWRiEioh",12) == 3500442387) strcat(s, "b");
if (crc32("cvJxOTXO",8) == 3378060806) strcat(s, "L");
if (crc32("icNeUXoe",8) == 899269511) strcat(s, "o");
if (crc32("ajljEY",6) == 182535917) strcat(s, "b");
if (crc32("pXIHlgV",7) == 1944319168) strcat(s, "i");
if (crc32("anqFJGX",7) == 4091608593) strcat(s, "k");
if (crc32("sZVOAYsCTIbTsd",14) == 1820887206) strcat(s, "s");
if (crc32("gLMatLqwdvO",11) == 659365876) strcat(s, "h");
if (crc32("kSwjrkcgJOZvt",13) == 3726544606) strcat(s, "l");
if (crc32("qXnijBZfOyRR",12) == 174696095) strcat(s, "k");
if (crc32("qwZkpXgDFmu",11) == 2646182550) strcat(s, "y");
    return s;
}

char *untrustworthily_adverbs() {
    char *s = calloc(16);
    if (crc32("dVdtkamzJY",10) == 941785882) strcat(s, "u");
if (crc32("qtVvmZngmUH",11) == 4173168948) strcat(s, "n");
if (crc32("eHfqWDbtmlEceG",14) == 2304021246) strcat(s, "o");
if (crc32("nTZosLEEjKmsRze",15) == 3965012539) strcat(s, "t");
if (crc32("xxMsuHJvWN",10) == 2316819445) strcat(s, "X");
if (crc32("uDsxxNINUIa",11) == 1891382285) strcat(s, "r");
if (crc32("jAmCJCIBwaL",11) == 4257309120) strcat(s, "u");
if (crc32("ejFlLmzMqoNN",12) == 129564008) strcat(s, "l");
if (crc32("fesMBqjJRLV",11) == 446916888) strcat(s, "s");
if (crc32("yKNeoNf",7) == 3818421195) strcat(s, "t");
if (crc32("afBxrKOSd",9) == 4061597888) strcat(s, "i");
if (crc32("nMAtHrtI",8) == 5205941) strcat(s, "w");
if (crc32("FHmUaXWvY",9) == 2937157055) strcat(s, "o");
if (crc32("Maemlxnd",8) == 3183383151) strcat(s, "Z");
if (crc32("OpdzpK",6) == 2500695529) strcat(s, "r");
if (crc32("lvhPmXwuhnG",11) == 808342522) strcat(s, "t");
if (crc32("RecKzm",6) == 1124167576) strcat(s, "q");
if (crc32("qqseIbkC",8) == 1462810645) strcat(s, "h");
if (crc32("sTTmCBrUXUU",11) == 775486946) strcat(s, "i");
if (crc32("NYyLBFLYHCxyB",13) == 966234483) strcat(s, "h");
if (crc32("ybGQxuSGhguiER",14) == 3748722587) strcat(s, "l");
if (crc32("sqwIGI",6) == 1767125347) strcat(s, "p");
if (crc32("anUoYgkzux",10) == 2423425019) strcat(s, "y");
    return s;
}

char *nonteleologically_adverbs() {
    char *s = calloc(18);
    if (crc32("zLYwYwYi",8) == 63318464) strcat(s, "n");
if (crc32("riqhuFaAJ",9) == 3765636422) strcat(s, "o");
if (crc32("SfXVNDQ",7) == 1166303182) strcat(s, "n");
if (crc32("lXqPr",5) == 3319399743) strcat(s, "t");
if (crc32("kXRUtAjy",8) == 1793243034) strcat(s, "e");
if (crc32("YVdwPjdvxFk",11) == 4120473246) strcat(s, "l");
if (crc32("JyFMlTWjlvwgjsV",15) == 2410129610) strcat(s, "e");
if (crc32("egkmVsmkUjwVr",13) == 460819212) strcat(s, "o");
if (crc32("WBPxGBKngz",10) == 1725554405) strcat(s, "l");
if (crc32("qQceHFT",7) == 1986491401) strcat(s, "o");
if (crc32("qBgAGbnYJQWmLY",14) == 1347362041) strcat(s, "k");
if (crc32("ThhoRrcwF",9) == 3187116678) strcat(s, "g");
if (crc32("iqdZnPCdjDXgvYk",15) == 375143967) strcat(s, "L");
if (crc32("LlChiKyTGjt",11) == 4004257385) strcat(s, "i");
if (crc32("qpBzIyccYA",10) == 3957060772) strcat(s, "h");
if (crc32("NSoqsWfKUDvmt",13) == 4054540926) strcat(s, "c");
if (crc32("zTAjC",5) == 402858324) strcat(s, "c");
if (crc32("zJOncBjeag",10) == 2072892715) strcat(s, "a");
if (crc32("RKabqDx",7) == 2309460641) strcat(s, "f");
if (crc32("jjuZgbFNgImfC",13) == 835243717) strcat(s, "l");
if (crc32("hkiEL",5) == 908459463) strcat(s, "l");
if (crc32("CRFbnpPSLEaDXO",14) == 1104476838) strcat(s, "W");
if (crc32("rXEuoBMpgpdCGiR",15) == 1330744073) strcat(s, "y");
    return s;
}

char *difficultly_adverbs() {
    char *s = calloc(12);
    if (crc32("tTnpIW",6) == 3076415236) strcat(s, "d");
if (crc32("qefqw",5) == 2174788800) strcat(s, "u");
if (crc32("XjTqBwEgWi",10) == 852718382) strcat(s, "i");
if (crc32("FdEqNRYt",8) == 196945828) strcat(s, "J");
if (crc32("kEnVXCyBobJna",13) == 2606067892) strcat(s, "f");
if (crc32("NeDdlFpVJrF",11) == 1924151533) strcat(s, "f");
if (crc32("EULGpByCLDcvb",13) == 2927512048) strcat(s, "b");
if (crc32("UZWLGmdGD",9) == 638219911) strcat(s, "i");
if (crc32("iYeOnHjYWKcZ",12) == 984263952) strcat(s, "c");
if (crc32("bmBTvmkTcWam",12) == 2977311835) strcat(s, "u");
if (crc32("HCWoAEFBG",9) == 2889403193) strcat(s, "l");
if (crc32("KICWyYDPFx",10) == 798503598) strcat(s, "t");
if (crc32("QXVoMwsccMrXxrJ",15) == 3432526136) strcat(s, "l");
if (crc32("MhYfuvDYxlhIu",13) == 21307747) strcat(s, "z");
if (crc32("twAeMOqVwglnc",13) == 3376448126) strcat(s, "y");
    return s;
}

char *heteroeciously_adverbs() {
    char *s = calloc(15);
    if (crc32("DymyJHswNXlF",12) == 344879655) strcat(s, "W");
if (crc32("dWHnBJRkQY",10) == 3355869953) strcat(s, "h");
if (crc32("kAoGAAyn",8) == 3509849097) strcat(s, "w");
if (crc32("arPKWqzFpB",10) == 43067358) strcat(s, "e");
if (crc32("GGDJTwXM",8) == 1840979009) strcat(s, "O");
if (crc32("OvcaDFin",8) == 1312910233) strcat(s, "t");
if (crc32("vuBCjwsOvNpc",12) == 2996961322) strcat(s, "e");
if (crc32("YtroZMpmSpAk",12) == 3612715947) strcat(s, "Q");
if (crc32("LdPDblKiUZpG",12) == 3787561488) strcat(s, "r");
if (crc32("vojdNDEjbhztx",13) == 1887718863) strcat(s, "o");
if (crc32("BGAOcWsdbUPTjtn",15) == 608757025) strcat(s, "e");
if (crc32("QUBwb",5) == 2405324829) strcat(s, "c");
if (crc32("YqjHbd",6) == 1737749532) strcat(s, "Z");
if (crc32("nBmbqeyeetYh",12) == 3515179271) strcat(s, "i");
if (crc32("GqKEvTrdwFFVv",13) == 2479186207) strcat(s, "o");
if (crc32("yxdZDtAlud",10) == 2478871754) strcat(s, "u");
if (crc32("yPqwdmyEAwa",11) == 2931364614) strcat(s, "s");
if (crc32("pChXlH",6) == 2294399766) strcat(s, "l");
if (crc32("dTUqdMwCwNusE",13) == 3900131181) strcat(s, "G");
if (crc32("GvkgQgindz",10) == 2250446939) strcat(s, "y");
    return s;
}

char *tubulously_adverbs() {
    char *s = calloc(11);
    if (crc32("hBaPomp",7) == 3556377465) strcat(s, "E");
if (crc32("JzoZJdJiUCiME",13) == 2255043592) strcat(s, "t");
if (crc32("zLWWwspzq",9) == 3212798623) strcat(s, "t");
if (crc32("qyTdCasRl",9) == 4039556920) strcat(s, "u");
if (crc32("hraowPOzOcjv",12) == 2680081996) strcat(s, "n");
if (crc32("OYFqTlQyL",9) == 442762369) strcat(s, "b");
if (crc32("OrWnzzeyPe",10) == 1592262940) strcat(s, "H");
if (crc32("GEhDTWppPuGte",13) == 3937917820) strcat(s, "u");
if (crc32("dKQUtnauzBPMbTK",15) == 1623607069) strcat(s, "l");
if (crc32("iEdsFFC",7) == 4094597811) strcat(s, "o");
if (crc32("fBjwMp",6) == 290909600) strcat(s, "q");
if (crc32("ttBiweKBCXgQCR",14) == 518482259) strcat(s, "u");
if (crc32("HbbGR",5) == 1317023049) strcat(s, "s");
if (crc32("eqlaSD",6) == 4119565447) strcat(s, "l");
if (crc32("PsExXalg",8) == 702395417) strcat(s, "A");
if (crc32("kwZhm",5) == 556039752) strcat(s, "y");
    return s;
}

char *epidemically_adverbs() {
    char *s = calloc(13);
    if (crc32("qGEzbPpKihyI",12) == 1173209522) strcat(s, "a");
if (crc32("XmIUfxjFf",9) == 385254338) strcat(s, "e");
if (crc32("emarCVcnEdK",11) == 1316210612) strcat(s, "g");
if (crc32("ZdSHItorNcDTH",13) == 99142664) strcat(s, "p");
if (crc32("EdZgYDLuNwC",11) == 4036215481) strcat(s, "g");
if (crc32("TthVKaGzqb",10) == 3066157709) strcat(s, "i");
if (crc32("bMkZehv",7) == 579800823) strcat(s, "d");
if (crc32("OitEHN",6) == 3760643420) strcat(s, "e");
if (crc32("AuBHarfV",8) == 1897287361) strcat(s, "m");
if (crc32("ivDomCSLmhz",11) == 2715494933) strcat(s, "i");
if (crc32("pJIwNzNixDhSzQd",15) == 335310657) strcat(s, "W");
if (crc32("XjmnZ",5) == 2853552832) strcat(s, "c");
if (crc32("GUQUTaelkK",10) == 466502687) strcat(s, "v");
if (crc32("nJPTYi",6) == 1859139918) strcat(s, "a");
if (crc32("oFudiNVlEq",10) == 943233646) strcat(s, "l");
if (crc32("tOnXkuvvgsNk",12) == 478682208) strcat(s, "r");
if (crc32("aEsNRyJbNJ",10) == 2378997623) strcat(s, "l");
if (crc32("IxtsDMQkjaIGdbk",15) == 441962402) strcat(s, "K");
if (crc32("NudJpSsxEIkWbTr",15) == 1036037920) strcat(s, "y");
    return s;
}

char *reputably_adverbs() {
    char *s = calloc(10);
    if (crc32("HArLAnDfoKW",11) == 279347484) strcat(s, "r");
if (crc32("sPtCsh",6) == 3583890954) strcat(s, "e");
if (crc32("YjtRKjIDcpWk",12) == 1201082271) strcat(s, "p");
if (crc32("JWhvzP",6) == 2238157044) strcat(s, "u");
if (crc32("QHGCch",6) == 3396026016) strcat(s, "T");
if (crc32("ItUipn",6) == 2871494302) strcat(s, "t");
if (crc32("gPwdouLAM",9) == 4002098963) strcat(s, "a");
if (crc32("SiiVLzyfuS",10) == 4286046943) strcat(s, "b");
if (crc32("nuKQFci",7) == 1328637377) strcat(s, "l");
if (crc32("TybytQpfARlKIsC",15) == 4199092767) strcat(s, "m");
if (crc32("rBfKY",5) == 961354760) strcat(s, "y");
    return s;
}

char *unavailingly_adverbs() {
    char *s = calloc(13);
    if (crc32("YgrtaKAzjw",10) == 4076253753) strcat(s, "R");
if (crc32("HSAWcTm",7) == 4104005655) strcat(s, "u");
if (crc32("PoKcxHwy",8) == 1867683123) strcat(s, "n");
if (crc32("GoSHU",5) == 49243278) strcat(s, "a");
if (crc32("jZTQmgFBTGvsP",13) == 4161702870) strcat(s, "m");
if (crc32("jmTGG",5) == 3772333234) strcat(s, "v");
if (crc32("NsSbMPHkCjgB",12) == 131765813) strcat(s, "a");
if (crc32("DbwWFxgwtMbglbm",15) == 4220575135) strcat(s, "i");
if (crc32("spwOGKIYvLk",11) == 1333008808) strcat(s, "l");
if (crc32("WbdHJRJz",8) == 1574801815) strcat(s, "L");
if (crc32("sCNYkyLq",8) == 4270228006) strcat(s, "i");
if (crc32("dFboLTaxYML",11) == 3218005092) strcat(s, "I");
if (crc32("BkpwNnjjJUt",11) == 3605576126) strcat(s, "n");
if (crc32("zpJHKmt",7) == 4209210042) strcat(s, "A");
if (crc32("kiDInTqOK",9) == 3459850981) strcat(s, "g");
if (crc32("NmFUiMcWrqd",11) == 983474528) strcat(s, "I");
if (crc32("SIFWTGPdEu",10) == 2657509415) strcat(s, "l");
if (crc32("fNtSQK",6) == 2131347073) strcat(s, "N");
if (crc32("gkZbGEvQwxi",11) == 401692841) strcat(s, "y");
    return s;
}

char *crankily_adverbs() {
    char *s = calloc(9);
    if (crc32("vkmxbIS",7) == 3883700276) strcat(s, "k");
if (crc32("ZnrHSQm",7) == 198976969) strcat(s, "c");
if (crc32("KjzEVXe",7) == 1244434985) strcat(s, "r");
if (crc32("ptXaZHrYVVylLC",14) == 4036438141) strcat(s, "a");
if (crc32("hqPkrb",6) == 2699941256) strcat(s, "n");
if (crc32("kOuamdWbS",9) == 2898663955) strcat(s, "k");
if (crc32("ZesAbyJX",8) == 893800365) strcat(s, "i");
if (crc32("JIQNCSPEdLPdv",13) == 904057348) strcat(s, "l");
if (crc32("yjGmhEHjlw",10) == 2178912209) strcat(s, "y");
    return s;
}

char *avifaunally_adverbs() {
    char *s = calloc(12);
    if (crc32("FMIGnptxLYInXv",14) == 704697869) strcat(s, "a");
if (crc32("BvDGMQARCBrm",12) == 4192232981) strcat(s, "v");
if (crc32("xSoSdbihQwrbui",14) == 736414705) strcat(s, "m");
if (crc32("baqGQaxrDnZjZz",14) == 2512571971) strcat(s, "i");
if (crc32("iCNWoMSOrBdfbB",14) == 225636793) strcat(s, "J");
if (crc32("czHbxZzqfHXa",12) == 2036643239) strcat(s, "f");
if (crc32("PZzeyCic",8) == 1605596732) strcat(s, "h");
if (crc32("yqFxYCykDnQ",11) == 2461788121) strcat(s, "a");
if (crc32("tkwKVu",6) == 2302291277) strcat(s, "u");
if (crc32("RHXTF",5) == 4187363481) strcat(s, "n");
if (crc32("qwwgARsUFd",10) == 435739538) strcat(s, "t");
if (crc32("UQSgcNmg",8) == 207358202) strcat(s, "a");
if (crc32("ESFwern",7) == 4003752687) strcat(s, "D");
if (crc32("qjnwGOM",7) == 2762968182) strcat(s, "l");
if (crc32("PCdHvYcIUXQg",12) == 2723805728) strcat(s, "x");
if (crc32("SACnsIFmHh",10) == 1496811117) strcat(s, "l");
if (crc32("EMiuVvTKnQWjuTL",15) == 1735963703) strcat(s, "y");
if (crc32("zaCYbXdpKYPJ",12) == 1678196672) strcat(s, "y");
    return s;
}

char *falteringly_adverbs() {
    char *s = calloc(12);
    if (crc32("gMAbwRxe",8) == 4274559812) strcat(s, "f");
if (crc32("hGcapxZWDQ",10) == 1867921514) strcat(s, "a");
if (crc32("WWwnPITfL",9) == 2901110246) strcat(s, "H");
if (crc32("KPrneEIcvEFFm",13) == 322834751) strcat(s, "l");
if (crc32("ecWDjdkeTDzJCJ",14) == 1273772155) strcat(s, "Q");
if (crc32("jAItmYdD",8) == 946934199) strcat(s, "t");
if (crc32("rzMsNLOCOgrk",12) == 3906682015) strcat(s, "w");
if (crc32("hJsqeJnlBtScCr",14) == 3357812572) strcat(s, "e");
if (crc32("rtVMIIKlSyyY",12) == 1039225008) strcat(s, "m");
if (crc32("XHKjG",5) == 2609133306) strcat(s, "r");
if (crc32("auaSkLLhqer",11) == 2423047885) strcat(s, "U");
if (crc32("oVTrUfIWla",10) == 1586917895) strcat(s, "i");
if (crc32("FTxMdpYdKhlO",12) == 2091880499) strcat(s, "n");
if (crc32("PgpbfbsRyPNaT",13) == 2976393237) strcat(s, "F");
if (crc32("bkCapfnUqORORZ",14) == 3976587645) strcat(s, "g");
if (crc32("FzZZVJzMMmXz",12) == 4019407700) strcat(s, "q");
if (crc32("AETpDfAthDFUEx",14) == 1740950925) strcat(s, "l");
if (crc32("opkpeGCHqXfi",12) == 1217951993) strcat(s, "y");
    return s;
}

char *dividedly_adverbs() {
    char *s = calloc(10);
    if (crc32("rAEtletibW",10) == 867342278) strcat(s, "W");
if (crc32("iIHpAZeqN",9) == 1956806556) strcat(s, "d");
if (crc32("TZbCeiHrKrN",11) == 1999844970) strcat(s, "i");
if (crc32("zLAmapFN",8) == 1849991873) strcat(s, "K");
if (crc32("ndtQPa",6) == 3869467090) strcat(s, "v");
if (crc32("vFJfZbCOmSyAKC",14) == 626496527) strcat(s, "i");
if (crc32("AqyNudswLjpe",12) == 2303701631) strcat(s, "k");
if (crc32("YyBdIqLHQreg",12) == 1206167959) strcat(s, "d");
if (crc32("TDcwiyXmrNjK",12) == 2920175359) strcat(s, "k");
if (crc32("IBBOnQRq",8) == 23051467) strcat(s, "e");
if (crc32("rOTOdADnbsIotk",14) == 2463835596) strcat(s, "d");
if (crc32("lRAEkNa",7) == 1235787361) strcat(s, "l");
if (crc32("YrHMlEj",7) == 227692026) strcat(s, "y");
    return s;
}

char *days_adverbs() {
    char *s = calloc(5);
    if (crc32("JtkNvwx",7) == 131148996) strcat(s, "E");
if (crc32("DbsnvsvYbvs",11) == 3991432404) strcat(s, "d");
if (crc32("xYqJanO",7) == 3464823108) strcat(s, "S");
if (crc32("nyvJH",5) == 3573197800) strcat(s, "a");
if (crc32("frvwvElZ",8) == 715864181) strcat(s, "A");
if (crc32("QRGVw",5) == 4110439239) strcat(s, "y");
if (crc32("MqwTJi",6) == 1695748436) strcat(s, "s");
    return s;
}

char *neglectedly_adverbs() {
    char *s = calloc(12);
    if (crc32("JyzxzXrTpXbiFTT",15) == 1244349535) strcat(s, "n");
if (crc32("WayVOMIwwC",10) == 1713669294) strcat(s, "e");
if (crc32("DaEgRohma",9) == 4148176638) strcat(s, "g");
if (crc32("XipLqpNQhEKixq",14) == 1531555424) strcat(s, "l");
if (crc32("pzXCKVfe",8) == 1421851991) strcat(s, "e");
if (crc32("JMQQjY",6) == 738742892) strcat(s, "c");
if (crc32("uqzQhHnaz",9) == 4251962597) strcat(s, "E");
if (crc32("OrCqhgXuiaNi",12) == 3295076416) strcat(s, "t");
if (crc32("PqEyCEGfp",9) == 1800498895) strcat(s, "e");
if (crc32("NfEDcsyTZoh",11) == 1307605845) strcat(s, "d");
if (crc32("sxwShquACFh",11) == 3841301854) strcat(s, "E");
if (crc32("DTMuZhRVIIbPCn",14) == 2396399955) strcat(s, "l");
if (crc32("sXItbH",6) == 2923384186) strcat(s, "y");
    return s;
}

char *unloquaciously_adverbs() {
    char *s = calloc(15);
    if (crc32("cHOksUik",8) == 2652180244) strcat(s, "c");
if (crc32("SLrCOZZfQlX",11) == 3307482084) strcat(s, "u");
if (crc32("vaXNUdHnQZ",10) == 3012114328) strcat(s, "m");
if (crc32("TyHgmOWbzFZriT",14) == 2918414376) strcat(s, "n");
if (crc32("dBvmDPxK",8) == 552387172) strcat(s, "l");
if (crc32("bUZLxwRENaNQ",12) == 3886167225) strcat(s, "o");
if (crc32("kYATkPewTmV",11) == 1579020509) strcat(s, "q");
if (crc32("rYyUVBOQYY",10) == 571893047) strcat(s, "u");
if (crc32("tgQDVJczATLzRl",14) == 885463646) strcat(s, "a");
if (crc32("iLHcNOmDxkxwXbi",15) == 1527872533) strcat(s, "d");
if (crc32("nZFgjBnPUGP",11) == 2395525971) strcat(s, "c");
if (crc32("MzMKW",5) == 633517583) strcat(s, "B");
if (crc32("KvMoQcTnOGxwnWV",15) == 2999381576) strcat(s, "i");
if (crc32("xzCfnrMgoHRrHO",14) == 3822830006) strcat(s, "o");
if (crc32("pcfzwVIoY",9) == 1644732623) strcat(s, "p");
if (crc32("YqvJf",5) == 3734628958) strcat(s, "u");
if (crc32("ZcRRDsAKa",9) == 2007092835) strcat(s, "n");
if (crc32("quIxYytIaPuDHJ",14) == 1992533629) strcat(s, "s");
if (crc32("HNoAoeH",7) == 3289811685) strcat(s, "l");
if (crc32("uBQigdfPpZqI",12) == 2673283725) strcat(s, "y");
    return s;
}

char *retrad_adverbs() {
    char *s = calloc(7);
    if (crc32("OsgvsfIlMPgzKe",14) == 2569140483) strcat(s, "r");
if (crc32("PZFCkHvoVcXwB",13) == 2485905608) strcat(s, "f");
if (crc32("gPsQJTGIwJN",11) == 1245314722) strcat(s, "e");
if (crc32("VngoGDx",7) == 1148182670) strcat(s, "T");
if (crc32("PPkLGt",6) == 4171763422) strcat(s, "t");
if (crc32("JvpMcxagpSOWWGJ",15) == 3618649566) strcat(s, "u");
if (crc32("CgVntDkUWKOWfR",14) == 3965314461) strcat(s, "r");
if (crc32("qdFEDrKhSSNm",12) == 2127242124) strcat(s, "m");
if (crc32("yKtqGXpgtHNX",12) == 2917763987) strcat(s, "a");
if (crc32("CsVHgzCUGEiCUdp",15) == 2673866838) strcat(s, "d");
    return s;
}

char *glimmeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("ujhCapUYAEzA",12) == 1486498344) strcat(s, "e");
if (crc32("Fhfhx",5) == 1352870443) strcat(s, "g");
if (crc32("tKTblhxb",8) == 1292888405) strcat(s, "p");
if (crc32("TzCMkENxWpU",11) == 3584945094) strcat(s, "l");
if (crc32("ixirnxkCWYP",11) == 3873616466) strcat(s, "E");
if (crc32("VsDza",5) == 2416781226) strcat(s, "i");
if (crc32("gizoXLwSTkdi",12) == 936969222) strcat(s, "m");
if (crc32("uqVMbEcCOEtAT",13) == 1820383322) strcat(s, "m");
if (crc32("uePRfhGBK",9) == 636078007) strcat(s, "s");
if (crc32("vktwdihpNc",10) == 3495644858) strcat(s, "e");
if (crc32("ixFmuEFLPkGQOJR",15) == 2580670440) strcat(s, "r");
if (crc32("yXeOR",5) == 2198729150) strcat(s, "V");
if (crc32("xJgxmIziEUNaP",13) == 1425153438) strcat(s, "i");
if (crc32("iVKqdIO",7) == 758339762) strcat(s, "n");
if (crc32("XPWSn",5) == 1461913160) strcat(s, "g");
if (crc32("zXOQAQl",7) == 3979031498) strcat(s, "k");
if (crc32("KknCYarHWI",10) == 569562943) strcat(s, "l");
if (crc32("uhANzEqD",8) == 40333252) strcat(s, "D");
if (crc32("yKerpwqbgDf",11) == 2730359719) strcat(s, "y");
    return s;
}

char *quasiclassically_adverbs() {
    char *s = calloc(17);
    if (crc32("nyVSyUj",7) == 900226144) strcat(s, "q");
if (crc32("ViErcioBLt",10) == 1909149550) strcat(s, "k");
if (crc32("yjYIpnKZzyoc",12) == 1323594792) strcat(s, "u");
if (crc32("uHMOHquNk",9) == 540492797) strcat(s, "a");
if (crc32("KYEBHnacXY",10) == 413774814) strcat(s, "L");
if (crc32("sHSQZ",5) == 1611946438) strcat(s, "s");
if (crc32("wOUBuwV",7) == 3985946487) strcat(s, "o");
if (crc32("LvPXWUNA",8) == 3284773354) strcat(s, "i");
if (crc32("CbJpDPe",7) == 608113440) strcat(s, "c");
if (crc32("Wjplp",5) == 3577138790) strcat(s, "l");
if (crc32("rSxxVe",6) == 2648434811) strcat(s, "m");
if (crc32("RRYNwik",7) == 424221251) strcat(s, "a");
if (crc32("IxwlHTrH",8) == 2525567934) strcat(s, "s");
if (crc32("aedLQonZS",9) == 2754666467) strcat(s, "s");
if (crc32("UHSQWXQ",7) == 74826424) strcat(s, "i");
if (crc32("IEtrrZLHBFR",11) == 3090346154) strcat(s, "c");
if (crc32("UeRKrutk",8) == 2808446033) strcat(s, "u");
if (crc32("NfxldZpCIJeHhCT",15) == 3520421132) strcat(s, "a");
if (crc32("WohbRLAGA",9) == 227421896) strcat(s, "S");
if (crc32("HVdVlRwpsTc",11) == 1351022645) strcat(s, "l");
if (crc32("OxtdthVr",8) == 1451057572) strcat(s, "V");
if (crc32("RFWUoTVGxuf",11) == 604909511) strcat(s, "l");
if (crc32("RQCNx",5) == 3048778605) strcat(s, "y");
    return s;
}

char *noninterruptedly_adverbs() {
    char *s = calloc(17);
    if (crc32("ovKbDnoQRYIsl",13) == 1440775120) strcat(s, "M");
if (crc32("UnwDMuAnhiAQYaG",15) == 2934838425) strcat(s, "n");
if (crc32("mKqLmTygX",9) == 1018618142) strcat(s, "o");
if (crc32("iQAjs",5) == 553063298) strcat(s, "C");
if (crc32("RSayFyNhw",9) == 3089986854) strcat(s, "n");
if (crc32("bZQKfSpA",8) == 3337309338) strcat(s, "i");
if (crc32("nCDHWafvL",9) == 3305747737) strcat(s, "n");
if (crc32("PoHNnLDZ",8) == 1061511762) strcat(s, "L");
if (crc32("CABIv",5) == 286954295) strcat(s, "t");
if (crc32("XqoLAmpISqTzaiO",15) == 150795970) strcat(s, "e");
if (crc32("NmZmNJpsEQz",11) == 951845320) strcat(s, "r");
if (crc32("ioVfGpJj",8) == 3994949359) strcat(s, "r");
if (crc32("YfGVokeIHVH",11) == 3747312098) strcat(s, "u");
if (crc32("IQIpBayzd",9) == 2994967404) strcat(s, "p");
if (crc32("KevHkrAW",8) == 1903228071) strcat(s, "L");
if (crc32("zcrumc",6) == 1376609597) strcat(s, "t");
if (crc32("yKutDbMgaLzxKl",14) == 2311824644) strcat(s, "G");
if (crc32("nzWsqroaERIiM",13) == 4229096913) strcat(s, "e");
if (crc32("Nmxrlq",6) == 4068878351) strcat(s, "d");
if (crc32("xUvetENc",8) == 2581888404) strcat(s, "R");
if (crc32("dkDxAFSQrRb",11) == 360561155) strcat(s, "l");
if (crc32("wizhnshKTOz",11) == 3892563328) strcat(s, "y");
    return s;
}

char *pardi_adverbs() {
    char *s = calloc(6);
    if (crc32("aDfkOLXnIQxp",12) == 624212515) strcat(s, "p");
if (crc32("EgzDFypONvaA",12) == 480917391) strcat(s, "a");
if (crc32("RlfQpWx",7) == 3422967846) strcat(s, "a");
if (crc32("GTYytC",6) == 3623779734) strcat(s, "G");
if (crc32("CoZbsPeLf",9) == 154851777) strcat(s, "r");
if (crc32("NoCgAVfCj",9) == 3348395613) strcat(s, "u");
if (crc32("IrkJo",5) == 3253623477) strcat(s, "d");
if (crc32("uxiHzPHVpRwDnu",14) == 3157203726) strcat(s, "i");
    return s;
}

char *centrically_adverbs() {
    char *s = calloc(12);
    if (crc32("RnWKcmtSkTRraZb",15) == 3371368813) strcat(s, "p");
if (crc32("PtxwtNOCFlcERRi",15) == 2339583399) strcat(s, "c");
if (crc32("GmexOCpp",8) == 4078010215) strcat(s, "e");
if (crc32("BhxTcPxYPRFAXu",14) == 2645615845) strcat(s, "n");
if (crc32("QjEKmYI",7) == 1238457886) strcat(s, "t");
if (crc32("kdeHsjfEPaGCC",13) == 3201185830) strcat(s, "E");
if (crc32("afXRKrfiZhACxzI",15) == 868883720) strcat(s, "r");
if (crc32("kHTyiAW",7) == 1998160833) strcat(s, "i");
if (crc32("PCrRjxJRQAupf",13) == 2982649128) strcat(s, "b");
if (crc32("eqXKCUvrhEz",11) == 200043207) strcat(s, "c");
if (crc32("MsHxTcc",7) == 3246526597) strcat(s, "b");
if (crc32("LZPsLvZgHTKVrK",14) == 2850689022) strcat(s, "a");
if (crc32("gPtgDIqNQHIb",12) == 1329597492) strcat(s, "W");
if (crc32("GGmpEg",6) == 2317948699) strcat(s, "l");
if (crc32("hYwLLPmO",8) == 3490431212) strcat(s, "l");
if (crc32("iMeGPRrYl",9) == 3929347024) strcat(s, "m");
if (crc32("vImTzjCpVHTWjW",14) == 287165857) strcat(s, "y");
    return s;
}

char *cantily_adverbs() {
    char *s = calloc(8);
    if (crc32("pPdFRrmDZoSRd",13) == 517194116) strcat(s, "r");
if (crc32("nfopBjuQsjuNHg",14) == 1035499302) strcat(s, "c");
if (crc32("GIyNYHpzCMiQh",13) == 3571843109) strcat(s, "a");
if (crc32("lKFcpTXZl",9) == 1515199117) strcat(s, "n");
if (crc32("WifwukPxRJ",10) == 1303379485) strcat(s, "t");
if (crc32("CUgSNHKKejehyAi",15) == 4017506813) strcat(s, "i");
if (crc32("SkHLUYmbdTal",12) == 3977121898) strcat(s, "l");
if (crc32("wIOYVOgcd",9) == 3764915547) strcat(s, "y");
    return s;
}

char *unsurrealistically_adverbs() {
    char *s = calloc(19);
    if (crc32("hqBxJncuz",9) == 4147197097) strcat(s, "W");
if (crc32("hYyarGMwqMHEX",13) == 3021066770) strcat(s, "u");
if (crc32("hCrjfcJDiSI",11) == 1445161955) strcat(s, "j");
if (crc32("nCtaLRgcziFsSz",14) == 1877713082) strcat(s, "n");
if (crc32("YkSxnWaRfoSgkxw",15) == 3660129481) strcat(s, "s");
if (crc32("idlpjCJT",8) == 323761533) strcat(s, "u");
if (crc32("UvoCNXgRUR",10) == 2410042558) strcat(s, "a");
if (crc32("jnHsoKWKxw",10) == 1124410267) strcat(s, "r");
if (crc32("WVLjJ",5) == 862167125) strcat(s, "T");
if (crc32("YVWjpo",6) == 3434659365) strcat(s, "r");
if (crc32("WuxKqKW",7) == 385331449) strcat(s, "e");
if (crc32("LzfzKCpWvLnZn",13) == 3057980316) strcat(s, "a");
if (crc32("ZqxIahgYCvdmF",13) == 3056410610) strcat(s, "M");
if (crc32("UPGukijOcXZOU",13) == 3573785248) strcat(s, "l");
if (crc32("zEfCcFxpuEugu",13) == 1901825094) strcat(s, "i");
if (crc32("ZCpEkmqZfi",10) == 3244767583) strcat(s, "d");
if (crc32("gFOwlAxTEbZZO",13) == 592917818) strcat(s, "s");
if (crc32("QVliW",5) == 768239589) strcat(s, "t");
if (crc32("GYfFm",5) == 3060409990) strcat(s, "j");
if (crc32("tEgmjuktk",9) == 2324839344) strcat(s, "i");
if (crc32("PkXEiUxR",8) == 2275540711) strcat(s, "c");
if (crc32("ykcozBNz",8) == 2762482472) strcat(s, "E");
if (crc32("SarGy",5) == 4221533700) strcat(s, "a");
if (crc32("YuennmwvLFyYBW",14) == 3689708958) strcat(s, "C");
if (crc32("SoLiYo",6) == 702104) strcat(s, "l");
if (crc32("DzkxBGmuybzRiEt",15) == 2001001602) strcat(s, "v");
if (crc32("HJLKSOfdfkh",11) == 100316473) strcat(s, "l");
if (crc32("ERAinOajhfebU",13) == 288476360) strcat(s, "g");
if (crc32("EyfLQcqDiHmlt",13) == 3689195921) strcat(s, "y");
    return s;
}

char *quasilaboriously_adverbs() {
    char *s = calloc(17);
    if (crc32("shGNOHYesxKUX",13) == 1749659122) strcat(s, "l");
if (crc32("DKfHioNpVmN",11) == 4231782354) strcat(s, "q");
if (crc32("TqupH",5) == 4050277707) strcat(s, "D");
if (crc32("suJLdq",6) == 2801570439) strcat(s, "u");
if (crc32("wGoYzQ",6) == 3737269232) strcat(s, "k");
if (crc32("HFZWCFzI",8) == 3099660497) strcat(s, "a");
if (crc32("ForTicw",7) == 1138697660) strcat(s, "s");
if (crc32("IbvwHdB",7) == 3114318073) strcat(s, "p");
if (crc32("nkOLxlTMendj",12) == 2026666344) strcat(s, "i");
if (crc32("oOLuJOaMSocZ",12) == 185343471) strcat(s, "V");
if (crc32("gCFSmk",6) == 1641449194) strcat(s, "l");
if (crc32("pFKGRwzsg",9) == 2542809216) strcat(s, "a");
if (crc32("mDqmmsnNL",9) == 57323982) strcat(s, "A");
if (crc32("NkNOTbwrcnToYJb",15) == 3184600931) strcat(s, "b");
if (crc32("AInSuyTy",8) == 3959727160) strcat(s, "o");
if (crc32("tRjpIYMbNywIyjl",15) == 2978654501) strcat(s, "s");
if (crc32("QQczOuKikmJxfbF",15) == 3833584254) strcat(s, "r");
if (crc32("oCirBAaFi",9) == 1086758448) strcat(s, "i");
if (crc32("iaVuUVnXJcUUPg",14) == 2705736394) strcat(s, "A");
if (crc32("KAvmnn",6) == 4007757744) strcat(s, "o");
if (crc32("sQnrIMnlIwu",11) == 1951872671) strcat(s, "f");
if (crc32("tAEcLShQkk",10) == 3327012602) strcat(s, "u");
if (crc32("RlmKqohDWu",10) == 1851150962) strcat(s, "s");
if (crc32("kIFTS",5) == 3812535523) strcat(s, "N");
if (crc32("ngxHR",5) == 2717269430) strcat(s, "l");
if (crc32("GuUSzqwNnsBdz",13) == 1285974984) strcat(s, "W");
if (crc32("rWuOm",5) == 87201597) strcat(s, "y");
    return s;
}

char *technologically_adverbs() {
    char *s = calloc(16);
    if (crc32("RtdRa",5) == 2638893465) strcat(s, "t");
if (crc32("KQLUz",5) == 2485957397) strcat(s, "e");
if (crc32("lGwmRUfamJQ",11) == 569925135) strcat(s, "h");
if (crc32("KXxrvzhTlVb",11) == 1470085622) strcat(s, "c");
if (crc32("lPHiHB",6) == 2530207878) strcat(s, "H");
if (crc32("qRhmZG",6) == 622724382) strcat(s, "h");
if (crc32("SUlVRESW",8) == 1449475111) strcat(s, "q");
if (crc32("KgginJcckyIZFJj",15) == 3677228591) strcat(s, "n");
if (crc32("wteGaz",6) == 514622565) strcat(s, "o");
if (crc32("NZUxhAskgDcvIGQ",15) == 2051382460) strcat(s, "l");
if (crc32("ZZzDowGdNeVA",12) == 3715385502) strcat(s, "v");
if (crc32("vsDZQfo",7) == 360030240) strcat(s, "o");
if (crc32("nRnrMHUdG",9) == 2236963760) strcat(s, "g");
if (crc32("vcllQjKFl",9) == 3354703572) strcat(s, "i");
if (crc32("FYbyP",5) == 2292542718) strcat(s, "i");
if (crc32("zUmyDPsOBt",10) == 864781072) strcat(s, "c");
if (crc32("JGoWsLbDJXpXDNh",15) == 2935659374) strcat(s, "a");
if (crc32("MXFME",5) == 1603156365) strcat(s, "l");
if (crc32("KtulAVP",7) == 4257471231) strcat(s, "l");
if (crc32("uLVSiaVATYLxg",13) == 21533012) strcat(s, "y");
    return s;
}

char *acock_adverbs() {
    char *s = calloc(6);
    if (crc32("QdDlytRyDmJn",12) == 4216965588) strcat(s, "a");
if (crc32("NjyFTZyHeMYo",12) == 2195166228) strcat(s, "S");
if (crc32("OXrVOIjQwy",10) == 812542621) strcat(s, "c");
if (crc32("AwKcqsoXSh",10) == 1702894060) strcat(s, "o");
if (crc32("IllCmzxN",8) == 1691753255) strcat(s, "J");
if (crc32("MMLTv",5) == 286184440) strcat(s, "c");
if (crc32("wGmIG",5) == 3095724205) strcat(s, "q");
if (crc32("LhmhtaaXMMNPj",13) == 2277145960) strcat(s, "k");
    return s;
}

char *unjuvenilely_adverbs() {
    char *s = calloc(13);
    if (crc32("myhXQFqHWaTmej",14) == 3553253941) strcat(s, "u");
if (crc32("XvPIJyAtYowBFP",14) == 508782496) strcat(s, "n");
if (crc32("tXSaQc",6) == 3466868690) strcat(s, "j");
if (crc32("dEhseQyAkAabKr",14) == 3432881320) strcat(s, "u");
if (crc32("VCNdRasd",8) == 3165919511) strcat(s, "v");
if (crc32("kAzADjZcf",9) == 3381938825) strcat(s, "p");
if (crc32("CjujgnpcUbWCNXe",15) == 771404114) strcat(s, "e");
if (crc32("WtfFblL",7) == 448927640) strcat(s, "T");
if (crc32("PZcsMmoPSv",10) == 3412848909) strcat(s, "n");
if (crc32("BQppUv",6) == 3074775403) strcat(s, "i");
if (crc32("zIzBwdf",7) == 1843829878) strcat(s, "f");
if (crc32("CkozCXfgkkMYUW",14) == 327283416) strcat(s, "l");
if (crc32("VfpvQujtw",9) == 1496718295) strcat(s, "e");
if (crc32("iEYcVhLCjGB",11) == 2909371823) strcat(s, "e");
if (crc32("RWuQRcGfgrhWXSk",15) == 3678465776) strcat(s, "l");
if (crc32("NBneCsIaYsclf",13) == 491909743) strcat(s, "y");
    return s;
}

char *hyperromantically_adverbs() {
    char *s = calloc(18);
    if (crc32("MrIkJattZkudPI",14) == 3745447371) strcat(s, "h");
if (crc32("VYupEbm",7) == 3195850244) strcat(s, "h");
if (crc32("JOGYZk",6) == 1009051025) strcat(s, "o");
if (crc32("bJUaoSsJxniTED",14) == 3080223116) strcat(s, "y");
if (crc32("WEBDGbN",7) == 2712971564) strcat(s, "p");
if (crc32("ZsiabE",6) == 4242781577) strcat(s, "e");
if (crc32("HpajSRS",7) == 91623242) strcat(s, "r");
if (crc32("OEAoUFx",7) == 2583628289) strcat(s, "C");
if (crc32("wZxnvztLzz",10) == 580639841) strcat(s, "r");
if (crc32("gFsWmJgcDt",10) == 815830323) strcat(s, "o");
if (crc32("ZgkxQ",5) == 2910345616) strcat(s, "m");
if (crc32("AtCusSHCUn",10) == 2504048834) strcat(s, "a");
if (crc32("JuTJStvPnQ",10) == 3700270290) strcat(s, "I");
if (crc32("OCJuxBN",7) == 3783838354) strcat(s, "n");
if (crc32("cubooEodH",9) == 768996531) strcat(s, "f");
if (crc32("NesnwGkLZa",10) == 2682872787) strcat(s, "t");
if (crc32("MPieugkRbYvazEe",15) == 4002433522) strcat(s, "y");
if (crc32("FPxjJgK",7) == 2646558413) strcat(s, "i");
if (crc32("PILBukcmVNMrA",13) == 1518269532) strcat(s, "X");
if (crc32("GDJMChMswksZ",12) == 3502500702) strcat(s, "c");
if (crc32("xvCkhEIy",8) == 1923097552) strcat(s, "a");
if (crc32("CaToCEnInPpcFAj",15) == 509520367) strcat(s, "i");
if (crc32("OkHlFVXITO",10) == 3279377058) strcat(s, "l");
if (crc32("TDEPiKCjfE",10) == 1804324512) strcat(s, "l");
if (crc32("rcsJDfmxh",9) == 1120251816) strcat(s, "y");
    return s;
}

char *tastily_adverbs() {
    char *s = calloc(8);
    if (crc32("GbGpTPyrhdkLAlp",15) == 362548259) strcat(s, "M");
if (crc32("yFFLolTNwA",10) == 3534350597) strcat(s, "t");
if (crc32("BKToXzgjt",9) == 2029025716) strcat(s, "f");
if (crc32("adXrMiHbGI",10) == 2738601221) strcat(s, "a");
if (crc32("xXorHuD",7) == 621975393) strcat(s, "s");
if (crc32("iOCeOfjZvzCx",12) == 3108544593) strcat(s, "t");
if (crc32("yhswtqJeparBmM",14) == 4184878548) strcat(s, "i");
if (crc32("juETwmoClvau",12) == 2805220010) strcat(s, "b");
if (crc32("pPHFEfIo",8) == 3258521022) strcat(s, "l");
if (crc32("VjmjzCYIluhGz",13) == 1124480241) strcat(s, "e");
if (crc32("ehMKaFFNJa",10) == 656953917) strcat(s, "y");
    return s;
}

char *desirously_adverbs() {
    char *s = calloc(11);
    if (crc32("gVDcWvVdaAcQG",13) == 3672914405) strcat(s, "d");
if (crc32("CwLwh",5) == 374713253) strcat(s, "Z");
if (crc32("sMubOavlBANgtv",14) == 3902861331) strcat(s, "e");
if (crc32("pkNQNHTRU",9) == 3475707612) strcat(s, "R");
if (crc32("tZVNjVvTka",10) == 4215865024) strcat(s, "s");
if (crc32("MGaeRAKOBHbG",12) == 52603644) strcat(s, "A");
if (crc32("zYKrRTWjZVs",11) == 964877023) strcat(s, "i");
if (crc32("qEIObYfFs",9) == 1737422160) strcat(s, "g");
if (crc32("JjxDhvKoQy",10) == 2071740830) strcat(s, "r");
if (crc32("davTYlXwaSZliOF",15) == 2890376030) strcat(s, "B");
if (crc32("NAROiuIUvO",10) == 49607098) strcat(s, "o");
if (crc32("gBoIoIJqgMMjlH",14) == 3177193692) strcat(s, "O");
if (crc32("aFYNQWvsQpzymqP",15) == 3073077935) strcat(s, "u");
if (crc32("TgyKPlQbAG",10) == 4145038932) strcat(s, "s");
if (crc32("jhROufWUMopXN",13) == 1996502886) strcat(s, "T");
if (crc32("LiWKZsTfOXVk",12) == 1836584093) strcat(s, "l");
if (crc32("pxfXrjVqolcZRM",14) == 1370372368) strcat(s, "y");
    return s;
}

char *lenticularly_adverbs() {
    char *s = calloc(13);
    if (crc32("cYbTuJnkDMDamm",14) == 2342775788) strcat(s, "N");
if (crc32("WwIhnTsf",8) == 2190754879) strcat(s, "l");
if (crc32("VnEpxEhSnjo",11) == 4232693005) strcat(s, "e");
if (crc32("gSHAnKRWVJ",10) == 3970434923) strcat(s, "n");
if (crc32("elvrUhaSQEFiqoc",15) == 2701993928) strcat(s, "t");
if (crc32("LzyBu",5) == 2282186011) strcat(s, "x");
if (crc32("XJLHDKJKdVl",11) == 2383066083) strcat(s, "i");
if (crc32("nlIRhy",6) == 3525808283) strcat(s, "c");
if (crc32("JCVYjU",6) == 155896103) strcat(s, "u");
if (crc32("HHRQBKfJLZhiu",13) == 4235716313) strcat(s, "d");
if (crc32("UbrDerjVRUr",11) == 1887535174) strcat(s, "l");
if (crc32("pnCtQQQefyzaaJb",15) == 3079281478) strcat(s, "a");
if (crc32("iDXLmZILSS",10) == 3286663313) strcat(s, "L");
if (crc32("ZrxTooeOAQlPq",13) == 1728679207) strcat(s, "r");
if (crc32("dBSFElEglsIPvH",14) == 470693531) strcat(s, "T");
if (crc32("XHLcEPrAw",9) == 4082676255) strcat(s, "l");
if (crc32("xvVxArnjels",11) == 4170484158) strcat(s, "b");
if (crc32("OdNzkVtmbxt",11) == 2958978739) strcat(s, "y");
    return s;
}

char *uncompassionately_adverbs() {
    char *s = calloc(18);
    if (crc32("lODZLb",6) == 3495390928) strcat(s, "r");
if (crc32("UbihG",5) == 2774813981) strcat(s, "u");
if (crc32("NuShTbW",7) == 2150604525) strcat(s, "K");
if (crc32("sYsDAwfwwIle",12) == 2439411970) strcat(s, "n");
if (crc32("irFJvYuZLZ",10) == 3441057104) strcat(s, "Q");
if (crc32("CSCHENQwQ",9) == 3068332623) strcat(s, "c");
if (crc32("SAMHCeEP",8) == 2791983895) strcat(s, "o");
if (crc32("toRiAZTT",8) == 368073036) strcat(s, "m");
if (crc32("kyNCPYhVEF",10) == 1659251202) strcat(s, "p");
if (crc32("kppyEUMPkRln",12) == 224825924) strcat(s, "a");
if (crc32("vANWDOZQt",9) == 2839964874) strcat(s, "l");
if (crc32("ranDzSAAe",9) == 2758112348) strcat(s, "s");
if (crc32("OlwbKwdlUDAG",12) == 501828151) strcat(s, "s");
if (crc32("WxTzLfoDnX",10) == 958852328) strcat(s, "v");
if (crc32("uxmFBOdAqOFyd",13) == 4275670944) strcat(s, "i");
if (crc32("HocXozMGQl",10) == 1503845509) strcat(s, "u");
if (crc32("bdJtIUQ",7) == 1087751905) strcat(s, "o");
if (crc32("JIrhgIxQEVwr",12) == 3134469029) strcat(s, "V");
if (crc32("oAPePSchW",9) == 135909616) strcat(s, "n");
if (crc32("rqgTUtptMCrcnb",14) == 3166131474) strcat(s, "Y");
if (crc32("hsnBFdPpvhsyL",13) == 507745570) strcat(s, "a");
if (crc32("bLxhzbgpIkg",11) == 3360782805) strcat(s, "t");
if (crc32("rlKHepA",7) == 2295777772) strcat(s, "e");
if (crc32("UBSEVeRhdUAX",12) == 3875455937) strcat(s, "y");
if (crc32("zwusIvOc",8) == 2178603652) strcat(s, "l");
if (crc32("KYFORNkvfHXZ",12) == 634816121) strcat(s, "y");
    return s;
}

char *mosso_adverbs() {
    char *s = calloc(6);
    if (crc32("QYdVy",5) == 4289855992) strcat(s, "m");
if (crc32("LhtVrVoMAtrTNNM",15) == 579396205) strcat(s, "A");
if (crc32("BGOwInJpYoGyL",13) == 964063576) strcat(s, "o");
if (crc32("njoilcswFxM",11) == 4075686768) strcat(s, "s");
if (crc32("lUiyRIYaTsTgD",13) == 2232571525) strcat(s, "s");
if (crc32("QWdKlZF",7) == 3083102396) strcat(s, "o");
    return s;
}

char *disproportionally_adverbs() {
    char *s = calloc(18);
    if (crc32("kNPUPX",6) == 1245962105) strcat(s, "d");
if (crc32("yTjqKBGcZ",9) == 710456310) strcat(s, "i");
if (crc32("gGyDE",5) == 164755530) strcat(s, "p");
if (crc32("fXvzyCaGcB",10) == 3354232118) strcat(s, "s");
if (crc32("XAebBGQItb",10) == 1221855149) strcat(s, "p");
if (crc32("wjzfcZuojLi",11) == 1636622418) strcat(s, "r");
if (crc32("uRxwjg",6) == 453976074) strcat(s, "o");
if (crc32("FMJiJxFFPb",10) == 2257712107) strcat(s, "B");
if (crc32("JKPKIqnERKfCCHA",15) == 2016297713) strcat(s, "p");
if (crc32("UjaIIX",6) == 1952990686) strcat(s, "L");
if (crc32("PARtdUn",7) == 4264280786) strcat(s, "o");
if (crc32("pzGJmNavva",10) == 1068091928) strcat(s, "w");
if (crc32("EeszXlKOUJLYZL",14) == 1570057265) strcat(s, "r");
if (crc32("FxJdddzJkw",10) == 851528275) strcat(s, "t");
if (crc32("YRIosalnUQKd",12) == 2992739795) strcat(s, "r");
if (crc32("PPwiOQGSmOSLA",13) == 3259455332) strcat(s, "i");
if (crc32("CvHiE",5) == 1529189197) strcat(s, "o");
if (crc32("ADYbHOaNd",9) == 3078811894) strcat(s, "n");
if (crc32("wOsVSIt",7) == 43029123) strcat(s, "a");
if (crc32("MLRpHqjKza",10) == 3599691090) strcat(s, "l");
if (crc32("lmEavdwLNbDSTL",14) == 3584127825) strcat(s, "l");
if (crc32("qGMeuSrSnuwaO",13) == 660016756) strcat(s, "l");
if (crc32("PsVCNVCUffz",11) == 2528175436) strcat(s, "V");
if (crc32("eJAisCVEtUyzBr",14) == 4060523905) strcat(s, "y");
    return s;
}

char *nonnoumenally_adverbs() {
    char *s = calloc(14);
    if (crc32("VZxEuJzqOXCzy",13) == 2632313095) strcat(s, "n");
if (crc32("TjbUtMbGPraVVky",15) == 3677567154) strcat(s, "o");
if (crc32("iCFKRtuTqFTH",12) == 3606812582) strcat(s, "n");
if (crc32("aBkmcHLjpfLud",13) == 1686090180) strcat(s, "n");
if (crc32("oNvly",5) == 375832926) strcat(s, "o");
if (crc32("PSJXwQbRraWAWQM",15) == 2284223744) strcat(s, "u");
if (crc32("HewsQGT",7) == 3434190989) strcat(s, "l");
if (crc32("tnxxRzp",7) == 980515983) strcat(s, "m");
if (crc32("vhETIcvEnIA",11) == 499860978) strcat(s, "e");
if (crc32("oHLQwyXWy",9) == 949741846) strcat(s, "n");
if (crc32("RwMqpwkGkas",11) == 2067984553) strcat(s, "J");
if (crc32("kmGWk",5) == 3150149273) strcat(s, "a");
if (crc32("QSIiPXXr",8) == 925705829) strcat(s, "l");
if (crc32("qeUUS",5) == 1370586199) strcat(s, "l");
if (crc32("vTZUdPXEmJGbSAg",15) == 3223444681) strcat(s, "y");
    return s;
}

char *hyperbatically_adverbs() {
    char *s = calloc(15);
    if (crc32("vQEXwuT",7) == 3798870306) strcat(s, "E");
if (crc32("fAbSWvBfJ",9) == 2829310204) strcat(s, "h");
if (crc32("NtEzxdZIHBNxBMk",15) == 107726263) strcat(s, "f");
if (crc32("FqpodCEmRWo",11) == 1564235891) strcat(s, "y");
if (crc32("zbZPNaxRKKcZWz",14) == 1845818311) strcat(s, "p");
if (crc32("MOEOp",5) == 4174717846) strcat(s, "X");
if (crc32("bmLjej",6) == 3023241945) strcat(s, "e");
if (crc32("EdyXjNrV",8) == 4000774925) strcat(s, "r");
if (crc32("ruxNyAehO",9) == 265082337) strcat(s, "e");
if (crc32("PFOhzvlEsVn",11) == 4153368457) strcat(s, "b");
if (crc32("yFSOzEUrgmcfJju",15) == 2722861119) strcat(s, "a");
if (crc32("ahxhHqZACsvG",12) == 372901011) strcat(s, "t");
if (crc32("EjcDYu",6) == 2631245428) strcat(s, "M");
if (crc32("rmZJl",5) == 2747615990) strcat(s, "i");
if (crc32("irmeUPCgKtM",11) == 2092254434) strcat(s, "c");
if (crc32("uDnJLU",6) == 735787898) strcat(s, "z");
if (crc32("eNcrtyzS",8) == 2090878191) strcat(s, "a");
if (crc32("jIsmX",5) == 2602223410) strcat(s, "Y");
if (crc32("NbMJNIlBrH",10) == 1155439019) strcat(s, "l");
if (crc32("UXwSlOCDvCjDB",13) == 3118995377) strcat(s, "l");
if (crc32("qyZcM",5) == 2871691182) strcat(s, "k");
if (crc32("dkdhBXEjPYmsCK",14) == 3990949783) strcat(s, "y");
    return s;
}

char *cryptanalytically_adverbs() {
    char *s = calloc(18);
    if (crc32("qrIDRSOK",8) == 483683587) strcat(s, "L");
if (crc32("CBVubPOCvM",10) == 4143317932) strcat(s, "c");
if (crc32("gWnCJMMEvuHoif",14) == 956549913) strcat(s, "b");
if (crc32("LpNTcciwQ",9) == 1036065380) strcat(s, "r");
if (crc32("JlScD",5) == 4094349898) strcat(s, "y");
if (crc32("qgpfjnSpoN",10) == 4145067009) strcat(s, "p");
if (crc32("gzKmqh",6) == 1845903549) strcat(s, "t");
if (crc32("AvcngHT",7) == 2808895773) strcat(s, "m");
if (crc32("SCdnScTxdC",10) == 2111806294) strcat(s, "a");
if (crc32("TmPKHcNDZwjKy",13) == 785533190) strcat(s, "n");
if (crc32("CRAaxbAhHftgDSC",15) == 129121817) strcat(s, "d");
if (crc32("ZLtXyHKKvZCmuP",14) == 3828972639) strcat(s, "a");
if (crc32("HfEwvDgE",8) == 1989561037) strcat(s, "l");
if (crc32("YuGvKpgSmgjWcHr",15) == 470054746) strcat(s, "y");
if (crc32("gtWvhrVRJXk",11) == 1864019337) strcat(s, "w");
if (crc32("KGFtJSRULKhn",12) == 1246417119) strcat(s, "t");
if (crc32("ZFvXGvzOfq",10) == 1188104970) strcat(s, "p");
if (crc32("uqoCQHzWQ",9) == 601265706) strcat(s, "i");
if (crc32("KtdVNED",7) == 3608616996) strcat(s, "N");
if (crc32("TxdAqPfqr",9) == 3325367846) strcat(s, "c");
if (crc32("BIJXpFp",7) == 3632428736) strcat(s, "a");
if (crc32("IDgioxCUrYlyDg",14) == 2543976113) strcat(s, "l");
if (crc32("tZrgRQsm",8) == 1136464047) strcat(s, "B");
if (crc32("WlnvKKSgCoJD",12) == 126978171) strcat(s, "l");
if (crc32("GcWLSVEdQy",10) == 1919812176) strcat(s, "y");
    return s;
}

char *pseudomythically_adverbs() {
    char *s = calloc(17);
    if (crc32("YZNECKjAa",9) == 3108597417) strcat(s, "u");
if (crc32("ACoEhHMemyTDCIb",15) == 664196249) strcat(s, "p");
if (crc32("HZoUexZaQcTmXgO",15) == 881530108) strcat(s, "s");
if (crc32("sKKCTLgb",8) == 3486687722) strcat(s, "e");
if (crc32("xuMTDBsnL",9) == 3916948633) strcat(s, "M");
if (crc32("dhIWIUJlFzIadqw",15) == 11454429) strcat(s, "u");
if (crc32("FRduCMdHJPjs",12) == 3713433961) strcat(s, "K");
if (crc32("oOLJhJKG",8) == 3436803862) strcat(s, "d");
if (crc32("tWmWfoqZglpL",12) == 1375208113) strcat(s, "o");
if (crc32("jPmTugMH",8) == 1384942275) strcat(s, "m");
if (crc32("VxOxXWOTSxsRS",13) == 3311534519) strcat(s, "R");
if (crc32("KQTqDrXpTZNUbRh",15) == 534454202) strcat(s, "y");
if (crc32("RqnCrWD",7) == 484757750) strcat(s, "y");
if (crc32("lhHtZgVMEv",10) == 167650108) strcat(s, "t");
if (crc32("PPcGZc",6) == 770023601) strcat(s, "B");
if (crc32("JvJGCAR",7) == 2855749372) strcat(s, "h");
if (crc32("rRrbIKHdTesNxXM",15) == 837729556) strcat(s, "i");
if (crc32("TxVJttgKjQhoKvt",15) == 1495505138) strcat(s, "T");
if (crc32("XioFgcksXRiVvv",14) == 1651670783) strcat(s, "c");
if (crc32("KLabZaP",7) == 2336802232) strcat(s, "D");
if (crc32("PaUitGV",7) == 2768568203) strcat(s, "a");
if (crc32("hWHCGLIBPDDt",12) == 2377236357) strcat(s, "i");
if (crc32("aHDbojSiEdBOSl",14) == 2624744449) strcat(s, "l");
if (crc32("QPCcojKA",8) == 3462131744) strcat(s, "W");
if (crc32("PAQpmLTjbEN",11) == 4159870260) strcat(s, "l");
if (crc32("eBWrDdKxXLxmIA",14) == 1680718287) strcat(s, "y");
    return s;
}

char *squarely_adverbs() {
    char *s = calloc(9);
    if (crc32("MfgPdF",6) == 1075155440) strcat(s, "s");
if (crc32("cycTHvMrOqCnJsk",15) == 4097054163) strcat(s, "S");
if (crc32("yccqsZuv",8) == 3577629327) strcat(s, "q");
if (crc32("MAidFyyz",8) == 1948079566) strcat(s, "O");
if (crc32("lJqxYeDcepSl",12) == 1690151723) strcat(s, "u");
if (crc32("BWSpsKDGwUDdpX",14) == 1600255652) strcat(s, "j");
if (crc32("YrRizS",6) == 417459591) strcat(s, "a");
if (crc32("shnJpnMrR",9) == 2607160258) strcat(s, "r");
if (crc32("fFLLh",5) == 1210149481) strcat(s, "b");
if (crc32("jMPIHXRfCxUc",12) == 302720939) strcat(s, "e");
if (crc32("iIrelMmAKXEQXd",14) == 4189822149) strcat(s, "l");
if (crc32("GAchumLZpV",10) == 1983545193) strcat(s, "w");
if (crc32("YlQBWRDufFcj",12) == 3787761905) strcat(s, "y");
    return s;
}

char *undifferently_adverbs() {
    char *s = calloc(14);
    if (crc32("lydswO",6) == 1591273809) strcat(s, "u");
if (crc32("ccrVRYiWSR",10) == 716428543) strcat(s, "M");
if (crc32("BTLvsS",6) == 1225767635) strcat(s, "n");
if (crc32("UeHlFSyEzo",10) == 2317868045) strcat(s, "T");
if (crc32("dCRibZLlonAKta",14) == 1312801486) strcat(s, "d");
if (crc32("EvRGtHINWxyJX",13) == 2606603803) strcat(s, "i");
if (crc32("iEqbAFe",7) == 1676222915) strcat(s, "f");
if (crc32("wkeDa",5) == 4167242664) strcat(s, "X");
if (crc32("MiDUJC",6) == 224672185) strcat(s, "f");
if (crc32("NajctIaD",8) == 2504538029) strcat(s, "e");
if (crc32("Plsvrq",6) == 506023186) strcat(s, "r");
if (crc32("zMRGShQKgypr",12) == 1216508551) strcat(s, "r");
if (crc32("aVCivAJqO",9) == 2620423401) strcat(s, "e");
if (crc32("cEtrrOMYVMqhNwH",15) == 4100149967) strcat(s, "n");
if (crc32("uvjCpTMPfInPl",13) == 3760979694) strcat(s, "t");
if (crc32("zYuCb",5) == 3919051090) strcat(s, "l");
if (crc32("pNoLUiDvomkg",12) == 3453141032) strcat(s, "f");
if (crc32("GtbaodizEfr",11) == 2151950075) strcat(s, "y");
    return s;
}

char *thoughtlessly_adverbs() {
    char *s = calloc(14);
    if (crc32("MSMluuQEeEJLi",13) == 70479582) strcat(s, "t");
if (crc32("ltYOdCED",8) == 826565894) strcat(s, "h");
if (crc32("IKgqXRf",7) == 2603553208) strcat(s, "A");
if (crc32("OlOZX",5) == 861132507) strcat(s, "o");
if (crc32("ZJfvA",5) == 1959559370) strcat(s, "u");
if (crc32("GsoKLAyiioT",11) == 79425043) strcat(s, "E");
if (crc32("KHxIobAfCjU",11) == 3690565292) strcat(s, "g");
if (crc32("qNYArsLGHOwgIX",14) == 959771564) strcat(s, "Q");
if (crc32("lAQfRdilgVB",11) == 3368733210) strcat(s, "h");
if (crc32("LdgPlqSddzbN",12) == 4020677124) strcat(s, "t");
if (crc32("iXkFlabfLVCLMFG",15) == 152438929) strcat(s, "N");
if (crc32("yktoPZwxbV",10) == 1709242767) strcat(s, "l");
if (crc32("UcmxGx",6) == 1096483712) strcat(s, "e");
if (crc32("GYiwjyG",7) == 109975765) strcat(s, "s");
if (crc32("TekRRSmokqiZ",12) == 3347866698) strcat(s, "J");
if (crc32("NUtZrOikeFXnf",13) == 2354187864) strcat(s, "s");
if (crc32("sJqNGemCpUD",11) == 1440896293) strcat(s, "Z");
if (crc32("TXjUhqHs",8) == 2816856322) strcat(s, "l");
if (crc32("pRjjnJ",6) == 2225047551) strcat(s, "y");
    return s;
}

char *opinionatedly_adverbs() {
    char *s = calloc(14);
    if (crc32("SLIJDAySlhqXzGU",15) == 664277512) strcat(s, "Q");
if (crc32("MxRPmOxSSYjzVD",14) == 150937715) strcat(s, "o");
if (crc32("pziAyd",6) == 2329308300) strcat(s, "p");
if (crc32("ArCIlXyHbSYp",12) == 1721285336) strcat(s, "i");
if (crc32("QsaEYdGel",9) == 3441538512) strcat(s, "r");
if (crc32("QrXZVNIWSLOj",12) == 1750959380) strcat(s, "n");
if (crc32("YFWgBfNcGQ",10) == 3267582455) strcat(s, "L");
if (crc32("ptKFxOs",7) == 2497995935) strcat(s, "i");
if (crc32("abIiXWTlqADEfyl",15) == 684970257) strcat(s, "n");
if (crc32("CRIbdQMpNDIWWO",14) == 3343208674) strcat(s, "o");
if (crc32("zdQqSMU",7) == 2697803791) strcat(s, "n");
if (crc32("nrlbJu",6) == 3864600507) strcat(s, "g");
if (crc32("fRWar",5) == 441106458) strcat(s, "a");
if (crc32("AXtyuYlum",9) == 2309796858) strcat(s, "p");
if (crc32("TuxEACPbytsP",12) == 4015525791) strcat(s, "t");
if (crc32("zXTQlMXvnMlOzn",14) == 742463690) strcat(s, "P");
if (crc32("AqLKlJYKBREuT",13) == 2960708963) strcat(s, "e");
if (crc32("qHFDJduy",8) == 3084455230) strcat(s, "U");
if (crc32("hXVmfNPcWdsFsGt",15) == 2390616641) strcat(s, "d");
if (crc32("pLmTtae",7) == 2304573129) strcat(s, "c");
if (crc32("IInWubHly",9) == 1458378431) strcat(s, "l");
if (crc32("TSJifKGUdU",10) == 1275741768) strcat(s, "k");
if (crc32("vygAWJrY",8) == 585519540) strcat(s, "y");
    return s;
}

char *auditorially_adverbs() {
    char *s = calloc(13);
    if (crc32("JxSmUzobaLjqrK",14) == 2989334744) strcat(s, "M");
if (crc32("GyJLrnsnk",9) == 1480985492) strcat(s, "a");
if (crc32("LvaQxErEaAfEu",13) == 2409916111) strcat(s, "z");
if (crc32("WsXCvitY",8) == 1215896910) strcat(s, "u");
if (crc32("ASiftLTPJaTk",12) == 2389863874) strcat(s, "d");
if (crc32("vTKQvmEjr",9) == 3717484475) strcat(s, "i");
if (crc32("Gjnbb",5) == 2395100063) strcat(s, "F");
if (crc32("UhtLI",5) == 3363262971) strcat(s, "t");
if (crc32("symtPSLhUN",10) == 1394036248) strcat(s, "x");
if (crc32("YUCFwHyM",8) == 2116591472) strcat(s, "o");
if (crc32("EcsQbJ",6) == 4008709046) strcat(s, "h");
if (crc32("oBolF",5) == 4179741476) strcat(s, "r");
if (crc32("xtehUhSTJFxj",12) == 4013171325) strcat(s, "i");
if (crc32("XRcNA",5) == 621209977) strcat(s, "Q");
if (crc32("zxUwNgoTCqi",11) == 580520250) strcat(s, "a");
if (crc32("wZfxQPgUTOxxCxr",15) == 3990957475) strcat(s, "A");
if (crc32("NMtWOUI",7) == 3541836580) strcat(s, "l");
if (crc32("rqLqY",5) == 62091515) strcat(s, "m");
if (crc32("VXTzNjDZ",8) == 3809239908) strcat(s, "l");
if (crc32("HMzjWxP",7) == 1227218016) strcat(s, "r");
if (crc32("ifSwUzGPP",9) == 1411634072) strcat(s, "y");
    return s;
}

char *superangelically_adverbs() {
    char *s = calloc(17);
    if (crc32("alojhHo",7) == 3379373087) strcat(s, "F");
if (crc32("vuzsyWCQd",9) == 2098564711) strcat(s, "s");
if (crc32("wepyb",5) == 31267131) strcat(s, "T");
if (crc32("HxqMcYSNPMpk",12) == 4243454331) strcat(s, "u");
if (crc32("OGSlWGZopEk",11) == 2023505481) strcat(s, "p");
if (crc32("VDEJq",5) == 1052945170) strcat(s, "e");
if (crc32("blIvTjR",7) == 2257266023) strcat(s, "S");
if (crc32("veTDGAmiBJ",10) == 3267617857) strcat(s, "r");
if (crc32("qeBUIYBflysZTUY",15) == 1547809442) strcat(s, "p");
if (crc32("LtgcxFp",7) == 540138563) strcat(s, "a");
if (crc32("zfSySPG",7) == 281265469) strcat(s, "c");
if (crc32("XUvdsPx",7) == 2702304898) strcat(s, "n");
if (crc32("UUngEWoMcIg",11) == 3196324145) strcat(s, "g");
if (crc32("vtuUKrSUd",9) == 1719967599) strcat(s, "D");
if (crc32("mfDxTM",6) == 2348051509) strcat(s, "e");
if (crc32("szouoRLFn",9) == 996749653) strcat(s, "l");
if (crc32("UJKrKmUkQJvZKEP",15) == 1823167965) strcat(s, "i");
if (crc32("iaeOlAOcwdBTrH",14) == 3640041791) strcat(s, "c");
if (crc32("cVVSLCugLNz",11) == 3465291995) strcat(s, "Q");
if (crc32("nuHldGNQBKBZ",12) == 3824598279) strcat(s, "a");
if (crc32("SyEjAakDTBE",11) == 3348051231) strcat(s, "m");
if (crc32("RLTVscfohMKwQbu",15) == 869888375) strcat(s, "l");
if (crc32("qvmtbV",6) == 2209420618) strcat(s, "X");
if (crc32("OakPQi",6) == 4241206460) strcat(s, "l");
if (crc32("WPjmSPQs",8) == 242323886) strcat(s, "y");
    return s;
}

char *evocatively_adverbs() {
    char *s = calloc(12);
    if (crc32("ssLml",5) == 3960286797) strcat(s, "e");
if (crc32("kypHACqgE",9) == 289936756) strcat(s, "v");
if (crc32("NBMByyCLH",9) == 878850133) strcat(s, "l");
if (crc32("waUtBbgJTCPX",12) == 3518296209) strcat(s, "o");
if (crc32("pObzaIx",7) == 3837094874) strcat(s, "t");
if (crc32("BiVSTvEiFA",10) == 2781355988) strcat(s, "c");
if (crc32("lVneGrfDUSHHWVV",15) == 1530325044) strcat(s, "y");
if (crc32("DyAbyfaTN",9) == 2634113843) strcat(s, "a");
if (crc32("AnIuQhOq",8) == 3550667084) strcat(s, "e");
if (crc32("nHLlRTXkdyyNKY",14) == 2304202485) strcat(s, "t");
if (crc32("SAJiHF",6) == 1258013533) strcat(s, "i");
if (crc32("wXjfugWkh",9) == 1874216746) strcat(s, "i");
if (crc32("tdNdaWvJLV",10) == 4199541167) strcat(s, "v");
if (crc32("HxpPGQXhxWYzH",13) == 195707248) strcat(s, "e");
if (crc32("qWvDRMd",7) == 1727038953) strcat(s, "T");
if (crc32("fMcQNT",6) == 2300394000) strcat(s, "l");
if (crc32("Fmmxxb",6) == 3734314642) strcat(s, "y");
    return s;
}

char *embarrassingly_adverbs() {
    char *s = calloc(15);
    if (crc32("rqsFly",6) == 1581124650) strcat(s, "i");
if (crc32("aklIR",5) == 1799630642) strcat(s, "e");
if (crc32("VbAcClYIx",9) == 949340798) strcat(s, "k");
if (crc32("VZPmiegXTXuh",12) == 451132550) strcat(s, "m");
if (crc32("xvGVpf",6) == 3309155453) strcat(s, "b");
if (crc32("oeapY",5) == 167813894) strcat(s, "D");
if (crc32("FlmpUTVWRNmZnIp",15) == 1680846893) strcat(s, "a");
if (crc32("rSAPWdgvKEBgpD",14) == 1708453627) strcat(s, "r");
if (crc32("gejjRmBtjli",11) == 2748334438) strcat(s, "h");
if (crc32("yILEbPykgg",10) == 622222802) strcat(s, "r");
if (crc32("NABKRhRJ",8) == 2649440822) strcat(s, "D");
if (crc32("bTzGYvVnIEhiswZ",15) == 655148391) strcat(s, "a");
if (crc32("ebpxsaXT",8) == 4060071360) strcat(s, "c");
if (crc32("efMIkOIbQmQQubu",15) == 456214905) strcat(s, "s");
if (crc32("rwVfSGlwBosMb",13) == 1042471580) strcat(s, "N");
if (crc32("kjrzA",5) == 4280679010) strcat(s, "s");
if (crc32("gkYUE",5) == 2629587050) strcat(s, "y");
if (crc32("QKLwojrqq",9) == 1811021708) strcat(s, "i");
if (crc32("JOYaRraZTY",10) == 1415052170) strcat(s, "C");
if (crc32("zfknDIu",7) == 1216687827) strcat(s, "n");
if (crc32("oXcrDTLtKAknM",13) == 686080388) strcat(s, "W");
if (crc32("JADIXfp",7) == 4084271019) strcat(s, "g");
if (crc32("ErgGFQoiWuAyC",13) == 1152198416) strcat(s, "U");
if (crc32("CSqqwiqHaLztOiX",15) == 3235148557) strcat(s, "l");
if (crc32("udgBxqKWRFkRyQJ",15) == 2820883021) strcat(s, "N");
if (crc32("GbMPhOpwXkFZ",12) == 3099305706) strcat(s, "y");
    return s;
}

char *nonadjustably_adverbs() {
    char *s = calloc(14);
    if (crc32("JEgWgr",6) == 3567732079) strcat(s, "n");
if (crc32("NkFNvWiWpqnEdDU",15) == 1944851960) strcat(s, "o");
if (crc32("pvxbAaFxqekv",12) == 3677745718) strcat(s, "r");
if (crc32("oemEAntIzvxr",12) == 1181872436) strcat(s, "n");
if (crc32("STfHsxeLKGSYDp",14) == 137842652) strcat(s, "I");
if (crc32("sBIMPYj",7) == 2487436444) strcat(s, "a");
if (crc32("nlmejSCkMaeJ",12) == 2107799345) strcat(s, "d");
if (crc32("IecsyTowpZPa",12) == 1487794232) strcat(s, "d");
if (crc32("umLGw",5) == 2953236434) strcat(s, "m");
if (crc32("gzbgamqTvhXvbym",15) == 748942776) strcat(s, "j");
if (crc32("CUmutZJv",8) == 213095) strcat(s, "u");
if (crc32("WMCFpQt",7) == 997977111) strcat(s, "M");
if (crc32("zakEFyElJHinUSE",15) == 1890877876) strcat(s, "s");
if (crc32("YoEYeC",6) == 3686524377) strcat(s, "I");
if (crc32("ontTYPxYUkkrl",13) == 1729761371) strcat(s, "t");
if (crc32("qYUosJ",6) == 3158807097) strcat(s, "j");
if (crc32("TTlyROt",7) == 3635229008) strcat(s, "a");
if (crc32("QpxXbtkMgg",10) == 236053620) strcat(s, "b");
if (crc32("fmnZcHmkGc",10) == 3493196417) strcat(s, "l");
if (crc32("KjfWIFEkuawMyJ",14) == 1131717781) strcat(s, "y");
    return s;
}

char *frontally_adverbs() {
    char *s = calloc(10);
    if (crc32("veqGwmjpRXHqWW",14) == 873947417) strcat(s, "p");
if (crc32("cWzWQHTxDHFNSy",14) == 1997494241) strcat(s, "f");
if (crc32("DqqFYcg",7) == 1777354574) strcat(s, "r");
if (crc32("vCcktCh",7) == 1650985490) strcat(s, "o");
if (crc32("CpafZgTCl",9) == 172903061) strcat(s, "l");
if (crc32("ktzzfxuLHt",10) == 1340871806) strcat(s, "n");
if (crc32("SlNMqYHWbLx",11) == 1306244437) strcat(s, "h");
if (crc32("pMSdaIKybu",10) == 1754559455) strcat(s, "t");
if (crc32("WhlLCowK",8) == 737628602) strcat(s, "a");
if (crc32("FpoQPKvlPHQ",11) == 309424620) strcat(s, "d");
if (crc32("tAokECvusADVr",13) == 1798809290) strcat(s, "l");
if (crc32("FIucbfF",7) == 2900565578) strcat(s, "O");
if (crc32("fXMfXmMtusFHhJ",14) == 1402381503) strcat(s, "l");
if (crc32("LAxKZNQX",8) == 3740068560) strcat(s, "s");
if (crc32("IDNqDR",6) == 191796030) strcat(s, "y");
    return s;
}

char *articulatorily_adverbs() {
    char *s = calloc(15);
    if (crc32("KihnTqoYfPwlFE",14) == 1661991171) strcat(s, "a");
if (crc32("vbxsnNqbhD",10) == 1493516427) strcat(s, "r");
if (crc32("MeFiFlpEtjB",11) == 1638537929) strcat(s, "m");
if (crc32("seCMu",5) == 1674374481) strcat(s, "t");
if (crc32("uHUDCaivOGkjCn",14) == 685605904) strcat(s, "i");
if (crc32("Xkgcern",7) == 1644931323) strcat(s, "i");
if (crc32("SGwoNTh",7) == 1375804666) strcat(s, "c");
if (crc32("AJOVMHdjhPIBUL",14) == 3696926593) strcat(s, "u");
if (crc32("SyEunOdm",8) == 997307231) strcat(s, "l");
if (crc32("orpPEH",6) == 972575565) strcat(s, "a");
if (crc32("QjPgkpwfhY",10) == 4192614281) strcat(s, "t");
if (crc32("elVmUClz",8) == 4038212800) strcat(s, "j");
if (crc32("dcOnhOXVSeH",11) == 3677699484) strcat(s, "o");
if (crc32("cdFGymhb",8) == 3620676698) strcat(s, "w");
if (crc32("NvRrhOidA",9) == 1170168725) strcat(s, "r");
if (crc32("HhrxwBSZWi",10) == 4231446721) strcat(s, "d");
if (crc32("sYNnN",5) == 3729499998) strcat(s, "i");
if (crc32("xnDUXyjGi",9) == 1414933008) strcat(s, "l");
if (crc32("iKpPejzaNTk",11) == 3177935401) strcat(s, "y");
    return s;
}

char *quasiphilosophically_adverbs() {
    char *s = calloc(21);
    if (crc32("GZKzAIe",7) == 4149154004) strcat(s, "q");
if (crc32("mlWHvZQfipvEZX",14) == 3399784373) strcat(s, "c");
if (crc32("hGkhqNZFUUN",11) == 2944415722) strcat(s, "u");
if (crc32("mTQRQcEAWnS",11) == 3671719277) strcat(s, "W");
if (crc32("yHfSOCi",7) == 1554116577) strcat(s, "a");
if (crc32("oyqrzsiDlb",10) == 670465001) strcat(s, "C");
if (crc32("aXjbzQ",6) == 2893873505) strcat(s, "s");
if (crc32("woHfXY",6) == 3467150602) strcat(s, "i");
if (crc32("ZOoJk",5) == 3834379102) strcat(s, "p");
if (crc32("DkMnGSQbU",9) == 3976940567) strcat(s, "h");
if (crc32("wwWIEyE",7) == 1929774651) strcat(s, "X");
if (crc32("DRUoFaSxxOR",11) == 483705076) strcat(s, "i");
if (crc32("LhdrYoAyPffg",12) == 1548618917) strcat(s, "q");
if (crc32("tVURxEsVGO",10) == 2339303538) strcat(s, "l");
if (crc32("ospxNwVn",8) == 2412622118) strcat(s, "l");
if (crc32("mdWumohl",8) == 309017114) strcat(s, "o");
if (crc32("tkRRqrmtnpZk",12) == 2849653842) strcat(s, "R");
if (crc32("uaiUly",6) == 2193087181) strcat(s, "s");
if (crc32("HEiIEX",6) == 318870235) strcat(s, "o");
if (crc32("huujBs",6) == 1991594098) strcat(s, "p");
if (crc32("oHwah",5) == 892361428) strcat(s, "w");
if (crc32("FXiekURgKa",10) == 954877571) strcat(s, "h");
if (crc32("dVPvnffp",8) == 4288363138) strcat(s, "i");
if (crc32("oEeqJ",5) == 3431744783) strcat(s, "b");
if (crc32("ajCpn",5) == 3238181047) strcat(s, "c");
if (crc32("BXPeHdrVQAwLjn",14) == 96377397) strcat(s, "a");
if (crc32("ZvevzHYjYl",10) == 3350493177) strcat(s, "l");
if (crc32("GZNTPWAyZdbnXwK",15) == 2643923085) strcat(s, "l");
if (crc32("NWNFH",5) == 3541804997) strcat(s, "y");
    return s;
}

char *unamusably_adverbs() {
    char *s = calloc(11);
    if (crc32("ExsSumCJrAU",11) == 1938538811) strcat(s, "m");
if (crc32("RgJXr",5) == 2472831830) strcat(s, "u");
if (crc32("HrCuNL",6) == 2640477141) strcat(s, "Q");
if (crc32("vlqAeMviRqRfFNT",15) == 3244486172) strcat(s, "n");
if (crc32("DDxnMdkgmg",10) == 785884339) strcat(s, "a");
if (crc32("ghdjXUOBaz",10) == 3369322132) strcat(s, "x");
if (crc32("wJtwbglJdX",10) == 3146005509) strcat(s, "m");
if (crc32("iQHBtqMZLby",11) == 1043424684) strcat(s, "B");
if (crc32("vOEusw",6) == 2191084793) strcat(s, "u");
if (crc32("ObtKQihbZbVNtUm",15) == 1462642174) strcat(s, "s");
if (crc32("huxKEDVtHyKg",12) == 2713717664) strcat(s, "a");
if (crc32("zmCxl",5) == 1832046009) strcat(s, "b");
if (crc32("SzlPwIRe",8) == 246032534) strcat(s, "A");
if (crc32("LFrqFTjjSMuCwo",14) == 998382878) strcat(s, "l");
if (crc32("XtzRF",5) == 961450670) strcat(s, "W");
if (crc32("oiYoalNboyBgGQi",15) == 3726795647) strcat(s, "y");
    return s;
}

char *caudad_adverbs() {
    char *s = calloc(7);
    if (crc32("PXCwTfmZC",9) == 3163449989) strcat(s, "U");
if (crc32("bNHULYbkueuckQc",15) == 1594435418) strcat(s, "c");
if (crc32("UHOYrHyUTGdCsXK",15) == 4151828949) strcat(s, "M");
if (crc32("nKjYQxuhqJjnJcl",15) == 2643178716) strcat(s, "a");
if (crc32("DhwHdTSMcEwb",12) == 3862593444) strcat(s, "u");
if (crc32("XhmQj",5) == 4105149569) strcat(s, "G");
if (crc32("LkXtWwys",8) == 1320908726) strcat(s, "d");
if (crc32("NeIhqD",6) == 3536236279) strcat(s, "W");
if (crc32("HIGABycOE",9) == 4294674906) strcat(s, "a");
if (crc32("jTdWbVcyZuGtoMs",15) == 1027315257) strcat(s, "d");
    return s;
}

char *unmaternally_adverbs() {
    char *s = calloc(13);
    if (crc32("LiZFFA",6) == 3005645072) strcat(s, "x");
if (crc32("RtjDdzjwi",9) == 1356353707) strcat(s, "u");
if (crc32("XEkoaCFJm",9) == 1587313903) strcat(s, "n");
if (crc32("UEfIpsemElZpyvj",15) == 1945563049) strcat(s, "U");
if (crc32("fBQdHXv",7) == 857756868) strcat(s, "m");
if (crc32("criDZHA",7) == 3112795385) strcat(s, "s");
if (crc32("MVeJwuejA",9) == 3927365478) strcat(s, "a");
if (crc32("JjCRrNdeixmw",12) == 2476762325) strcat(s, "q");
if (crc32("XtTRix",6) == 2633705213) strcat(s, "t");
if (crc32("cTYZw",5) == 576940804) strcat(s, "c");
if (crc32("xltBa",5) == 3581061229) strcat(s, "e");
if (crc32("YGXWSzSPoCOXW",13) == 243956420) strcat(s, "z");
if (crc32("yfxBnENaNYK",11) == 48498966) strcat(s, "r");
if (crc32("wzkaJPrMJVpHbPi",15) == 2440940415) strcat(s, "n");
if (crc32("Dpganabg",8) == 2211413683) strcat(s, "a");
if (crc32("QaOTVxlxIc",10) == 335869979) strcat(s, "l");
if (crc32("vmhbdwjEtbIYR",13) == 1207890517) strcat(s, "l");
if (crc32("tBudJ",5) == 1053789490) strcat(s, "y");
    return s;
}

char *unbenevolently_adverbs() {
    char *s = calloc(15);
    if (crc32("EhuBQTrbDRBXAwA",15) == 1653175431) strcat(s, "u");
if (crc32("PPynsGzo",8) == 1679707328) strcat(s, "e");
if (crc32("igngScRiGErLT",13) == 1156434159) strcat(s, "n");
if (crc32("mFqidRFNU",9) == 3584837218) strcat(s, "I");
if (crc32("DPGrtQhNtQYuxjQ",15) == 349857857) strcat(s, "b");
if (crc32("pyyDniRxN",9) == 823825488) strcat(s, "e");
if (crc32("qkxMert",7) == 2576794966) strcat(s, "l");
if (crc32("izeqYVR",7) == 2705528862) strcat(s, "n");
if (crc32("cpQIKITF",8) == 1035763375) strcat(s, "i");
if (crc32("hbxfECKUb",9) == 2472216945) strcat(s, "e");
if (crc32("WdWoOBPTQxtFhIh",15) == 1968179536) strcat(s, "k");
if (crc32("iyaiXXCsjtNzE",13) == 2868415499) strcat(s, "v");
if (crc32("lfsVO",5) == 1036018056) strcat(s, "k");
if (crc32("LIvqAwTDIrw",11) == 3081015694) strcat(s, "o");
if (crc32("NkaLRMKGtWKUZhZ",15) == 3120685979) strcat(s, "B");
if (crc32("UghFRfcGROXRaah",15) == 3881242700) strcat(s, "l");
if (crc32("XUXYHxZ",7) == 2076081022) strcat(s, "o");
if (crc32("hmtfptTPubJtXbT",15) == 4083809176) strcat(s, "e");
if (crc32("LsWqJUqX",8) == 3277832854) strcat(s, "R");
if (crc32("NtcUxNGLkTbxv",13) == 3361475269) strcat(s, "n");
if (crc32("zSNuYHJDHxxkUew",15) == 1997617159) strcat(s, "t");
if (crc32("MmvKgBhFB",9) == 2333273892) strcat(s, "x");
if (crc32("dfMAQWqgwRACyg",14) == 359904700) strcat(s, "l");
if (crc32("rirYVEMcQkQlE",13) == 2091866545) strcat(s, "P");
if (crc32("THqYDPCfgbIp",12) == 1660537910) strcat(s, "y");
    return s;
}

char *questionably_adverbs() {
    char *s = calloc(13);
    if (crc32("hGkTTocwiBnLOBw",15) == 2428345234) strcat(s, "u");
if (crc32("NnsQlH",6) == 120169839) strcat(s, "q");
if (crc32("XmtHFoErpMki",12) == 2946219990) strcat(s, "u");
if (crc32("oYPHYPWoZU",10) == 219601381) strcat(s, "h");
if (crc32("pIZJpkMqfcLX",12) == 673555138) strcat(s, "e");
if (crc32("uwGzMZoCJynKGA",14) == 3240139202) strcat(s, "D");
if (crc32("dJfDrpLVpxC",11) == 3754841463) strcat(s, "s");
if (crc32("igbgGxbWDdhsS",13) == 2151451669) strcat(s, "t");
if (crc32("PBFnvCd",7) == 831790354) strcat(s, "i");
if (crc32("jbTYzWCPEkQeH",13) == 1075014194) strcat(s, "o");
if (crc32("GNaiNDdpwO",10) == 1968843656) strcat(s, "n");
if (crc32("PwAYTquSahV",11) == 494626250) strcat(s, "a");
if (crc32("XhvvJfmMGDEKLv",14) == 2269195058) strcat(s, "a");
if (crc32("yZkKbiupmYy",11) == 2171580754) strcat(s, "b");
if (crc32("XvjKwjTBbxM",11) == 2037106427) strcat(s, "S");
if (crc32("FVOhwom",7) == 3297341691) strcat(s, "l");
if (crc32("MbUAZEGxCfFONLA",15) == 2461735571) strcat(s, "t");
if (crc32("lBRhxIJgJm",10) == 1163475762) strcat(s, "y");
    return s;
}

char *fidgetingly_adverbs() {
    char *s = calloc(12);
    if (crc32("CTjNLyboVbXDojn",15) == 228351904) strcat(s, "m");
if (crc32("OcpZaGtlIh",10) == 739896924) strcat(s, "f");
if (crc32("zgPLOFXaNLHcv",13) == 2908270214) strcat(s, "i");
if (crc32("GUFhxaCwhhWUD",13) == 2286331789) strcat(s, "K");
if (crc32("JZQCz",5) == 1982568528) strcat(s, "d");
if (crc32("QNlQSaRKgrqFMld",15) == 667748332) strcat(s, "g");
if (crc32("mBDVbkNr",8) == 3784571355) strcat(s, "d");
if (crc32("WFkeyzrAg",9) == 1405190474) strcat(s, "e");
if (crc32("tPGQLdDjeA",10) == 2496614903) strcat(s, "t");
if (crc32("japloLnzKjw",11) == 2590383203) strcat(s, "i");
if (crc32("GNGhCC",6) == 245274381) strcat(s, "d");
if (crc32("MHqRCXYLTlJU",12) == 3911330145) strcat(s, "n");
if (crc32("PmjUsfaXfYZ",11) == 2908729607) strcat(s, "p");
if (crc32("aGIQmfaz",8) == 2630603756) strcat(s, "g");
if (crc32("wnVqlKkozj",10) == 3808279910) strcat(s, "z");
if (crc32("ULuaoCnvYlW",11) == 2211677818) strcat(s, "l");
if (crc32("RppbOcttIYcqU",13) == 555695034) strcat(s, "D");
if (crc32("LRyMkzPWOl",10) == 3978376819) strcat(s, "y");
    return s;
}

char *uncheerily_adverbs() {
    char *s = calloc(11);
    if (crc32("VLaMCCBuOPETnqw",15) == 2595151471) strcat(s, "l");
if (crc32("dHgOlaj",7) == 2042051675) strcat(s, "u");
if (crc32("XzEBwamudOpY",12) == 702452067) strcat(s, "n");
if (crc32("XtpDWhIuEEPRMKE",15) == 1282568037) strcat(s, "V");
if (crc32("JUbaXhUp",8) == 2454213128) strcat(s, "c");
if (crc32("zkqYS",5) == 1658620330) strcat(s, "u");
if (crc32("aojJDWf",7) == 1218238711) strcat(s, "h");
if (crc32("sbQOX",5) == 2521865217) strcat(s, "e");
if (crc32("gTnpjFIY",8) == 3924018188) strcat(s, "H");
if (crc32("YetFRVEuCDcg",12) == 4080730593) strcat(s, "e");
if (crc32("sXViyroJp",9) == 1773072073) strcat(s, "m");
if (crc32("zExEIXqneCXckRu",15) == 2197852098) strcat(s, "r");
if (crc32("etMEDUar",8) == 1717790004) strcat(s, "d");
if (crc32("OUHUenYIFTYPiWx",15) == 221789175) strcat(s, "i");
if (crc32("OLsSkuLUvfu",11) == 342879775) strcat(s, "T");
if (crc32("PIULBk",6) == 1976798479) strcat(s, "l");
if (crc32("plerkfpQfV",10) == 4231390687) strcat(s, "i");
if (crc32("idjgoDdWCsRkpZH",15) == 781873147) strcat(s, "y");
    return s;
}

char *ungeometrically_adverbs() {
    char *s = calloc(16);
    if (crc32("gEXEDXceIK",10) == 3979843207) strcat(s, "h");
if (crc32("FwwBeUjKj",9) == 3504399547) strcat(s, "u");
if (crc32("xQmiZNR",7) == 1571312790) strcat(s, "k");
if (crc32("darfLJ",6) == 3244082448) strcat(s, "n");
if (crc32("zpYVXcFlkcz",11) == 463264120) strcat(s, "S");
if (crc32("lmAucTWdbrxAI",13) == 1974986936) strcat(s, "g");
if (crc32("JzevBgNim",9) == 3978966179) strcat(s, "e");
if (crc32("AwHJAvlpjqWG",12) == 828028513) strcat(s, "o");
if (crc32("ZXrxp",5) == 3414835373) strcat(s, "T");
if (crc32("BDUhSQyoCgK",11) == 2990477917) strcat(s, "m");
if (crc32("ujykQhCbvt",10) == 589433826) strcat(s, "V");
if (crc32("wPEyOJYAz",9) == 153537339) strcat(s, "e");
if (crc32("tiOQwVWduGUV",12) == 2024182524) strcat(s, "W");
if (crc32("ecqNRZDH",8) == 2365010030) strcat(s, "t");
if (crc32("wUOLnzwcd",9) == 3538281139) strcat(s, "r");
if (crc32("QCQIFvBMqgxNES",14) == 2812299299) strcat(s, "h");
if (crc32("RjQDXqrSkKE",11) == 2654582229) strcat(s, "i");
if (crc32("mMhuRwqvxIMWCk",14) == 3294410246) strcat(s, "c");
if (crc32("PnTzIWM",7) == 3347722721) strcat(s, "a");
if (crc32("oPVFRkpboaY",11) == 28224177) strcat(s, "Y");
if (crc32("GVCkLMUTNwn",11) == 2128680437) strcat(s, "l");
if (crc32("ktKtBIJMaT",10) == 175736094) strcat(s, "b");
if (crc32("hcEwK",5) == 2983373694) strcat(s, "l");
if (crc32("UxCKUnWFSJj",11) == 3735802019) strcat(s, "H");
if (crc32("SoxMD",5) == 3025152122) strcat(s, "y");
    return s;
}

char *combatively_adverbs() {
    char *s = calloc(12);
    if (crc32("ZFVZJMBCWPNfLJ",14) == 476725801) strcat(s, "c");
if (crc32("HUCtzYYEJb",10) == 203608189) strcat(s, "F");
if (crc32("kpLhu",5) == 3073638757) strcat(s, "o");
if (crc32("nGfYGFhkOD",10) == 1328582000) strcat(s, "m");
if (crc32("LyBxpNH",7) == 4246105479) strcat(s, "C");
if (crc32("QHXTCKKTMlw",11) == 1130844239) strcat(s, "b");
if (crc32("uhHQow",6) == 1555408639) strcat(s, "a");
if (crc32("DLRptqLynhPXbZ",14) == 1926818061) strcat(s, "p");
if (crc32("SzKXyRZuB",9) == 148901026) strcat(s, "t");
if (crc32("upUZBGmSGEM",11) == 537023676) strcat(s, "d");
if (crc32("iDSEmrSldFRs",12) == 160078739) strcat(s, "i");
if (crc32("SnhQvTMgOsSfyt",14) == 2839353209) strcat(s, "M");
if (crc32("UJEpczcYsXHhhw",14) == 3936571570) strcat(s, "v");
if (crc32("roalsCCkV",9) == 2696610765) strcat(s, "V");
if (crc32("fgfEFG",6) == 1660567037) strcat(s, "e");
if (crc32("PMheeLJuQ",9) == 1973085680) strcat(s, "l");
if (crc32("PjYBUhNpAkHW",12) == 2200615660) strcat(s, "y");
    return s;
}

char *collectivistically_adverbs() {
    char *s = calloc(19);
    if (crc32("pTRdrgY",7) == 1839460869) strcat(s, "o");
if (crc32("QQCqVjgtvYnEKsP",15) == 2659979804) strcat(s, "c");
if (crc32("MmpRqewLBemm",12) == 426889722) strcat(s, "I");
if (crc32("DflIAEezEnwdEjE",15) == 2859951548) strcat(s, "o");
if (crc32("ZNEnf",5) == 1770022011) strcat(s, "u");
if (crc32("YSwGgwQiPC",10) == 4122459410) strcat(s, "l");
if (crc32("KIAoQZglpHMRwg",14) == 2081776105) strcat(s, "l");
if (crc32("EKBJznNhy",9) == 3989713316) strcat(s, "e");
if (crc32("fvMxhINiRJIa",12) == 4277724627) strcat(s, "c");
if (crc32("clBLOLU",7) == 4235323692) strcat(s, "Q");
if (crc32("YOBuRWXvRbpt",12) == 2331161119) strcat(s, "t");
if (crc32("aJIynFec",8) == 2995992946) strcat(s, "n");
if (crc32("vgTvtKJC",8) == 3713042644) strcat(s, "i");
if (crc32("FIknP",5) == 949950207) strcat(s, "c");
if (crc32("DCxpPlVQjcc",11) == 3634013493) strcat(s, "v");
if (crc32("tpkibypgjrOi",12) == 4027798434) strcat(s, "i");
if (crc32("eseoLuj",7) == 555036160) strcat(s, "m");
if (crc32("fzmYMk",6) == 3919251187) strcat(s, "s");
if (crc32("VwVVQBOoKRfYP",13) == 2513936781) strcat(s, "t");
if (crc32("XjkwMrpcHfO",11) == 262591181) strcat(s, "i");
if (crc32("YVCtkGaYT",9) == 801674900) strcat(s, "X");
if (crc32("bgsoNjr",7) == 312407021) strcat(s, "c");
if (crc32("xFQRubrii",9) == 4049408237) strcat(s, "a");
if (crc32("ojWVQkMPW",9) == 1299965878) strcat(s, "x");
if (crc32("KvccsyRlgE",10) == 2548342685) strcat(s, "l");
if (crc32("EtEKNwLaVLX",11) == 2651792622) strcat(s, "l");
if (crc32("IgfhGphkqvY",11) == 683996496) strcat(s, "y");
    return s;
}

char *threateningly_adverbs() {
    char *s = calloc(14);
    if (crc32("aQPhnRcwsG",10) == 2975042038) strcat(s, "t");
if (crc32("fGbelkT",7) == 597666476) strcat(s, "h");
if (crc32("HgChZIvqHUwSM",13) == 1233244299) strcat(s, "e");
if (crc32("gKQTzchMjUz",11) == 4100937521) strcat(s, "r");
if (crc32("YpxChAuSiUUxBZ",14) == 37007023) strcat(s, "J");
if (crc32("GkwhrfgwlFdWO",13) == 2910748221) strcat(s, "e");
if (crc32("qKRQTK",6) == 1832686969) strcat(s, "a");
if (crc32("WfmLjNjYI",9) == 4248135458) strcat(s, "t");
if (crc32("SjCTMPAhBGUM",12) == 2937743607) strcat(s, "e");
if (crc32("JhNjGdTaTDQGnv",14) == 2193118234) strcat(s, "n");
if (crc32("hatZrvsE",8) == 4158901093) strcat(s, "a");
if (crc32("xTWUccdZc",9) == 3927930258) strcat(s, "i");
if (crc32("aoNJau",6) == 860317069) strcat(s, "n");
if (crc32("JsvzD",5) == 1509341328) strcat(s, "g");
if (crc32("zrnGXHoE",8) == 1112318127) strcat(s, "o");
if (crc32("ztzbkOChuCM",11) == 1754703479) strcat(s, "l");
if (crc32("UvDszABAItKuP",13) == 3358668598) strcat(s, "y");
    return s;
}

char *tactlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("nNGVZcHEW",9) == 1216090802) strcat(s, "t");
if (crc32("OxNwHnH",7) == 1505664696) strcat(s, "F");
if (crc32("PLSxUFgqWeolb",13) == 3250137791) strcat(s, "a");
if (crc32("ULbzIZSd",8) == 1129923032) strcat(s, "T");
if (crc32("OikifLCZKHQGt",13) == 56963152) strcat(s, "c");
if (crc32("FHiDePuAiF",10) == 211256900) strcat(s, "t");
if (crc32("nXznCSYJCNk",11) == 1545853906) strcat(s, "W");
if (crc32("HJWUNbcM",8) == 3900465659) strcat(s, "l");
if (crc32("vZCzuFX",7) == 901376097) strcat(s, "e");
if (crc32("ZvFIHDfrCE",10) == 717681880) strcat(s, "s");
if (crc32("ZfbMvHmo",8) == 906902395) strcat(s, "F");
if (crc32("yRbLhXQ",7) == 3206548596) strcat(s, "s");
if (crc32("TYGwbubOOkiSA",13) == 431884914) strcat(s, "l");
if (crc32("wDnlma",6) == 2051314691) strcat(s, "y");
    return s;
}

char *antiparasitically_adverbs() {
    char *s = calloc(18);
    if (crc32("AmZilO",6) == 1393834157) strcat(s, "d");
if (crc32("yuEkwCTdrd",10) == 3997028084) strcat(s, "a");
if (crc32("mjmIkKcKZQC",11) == 4262176279) strcat(s, "n");
if (crc32("vqqOIMtLojqSl",13) == 2514187113) strcat(s, "t");
if (crc32("cekIOhtmPi",10) == 4000837772) strcat(s, "i");
if (crc32("uKalTyRG",8) == 663619426) strcat(s, "p");
if (crc32("BoLCX",5) == 1076931269) strcat(s, "a");
if (crc32("ZulDiaDqbIrCf",13) == 1345417154) strcat(s, "k");
if (crc32("SztjyRNhZp",10) == 2421694817) strcat(s, "r");
if (crc32("iiGFrOdBOyARYb",14) == 4201324097) strcat(s, "a");
if (crc32("lIGuVpdLYakoS",13) == 1400719122) strcat(s, "y");
if (crc32("EZrBPBauopWI",12) == 4072301695) strcat(s, "s");
if (crc32("MgxpFyrJ",8) == 3986744420) strcat(s, "N");
if (crc32("OozAGvH",7) == 854600896) strcat(s, "i");
if (crc32("HnDEUO",6) == 848799099) strcat(s, "B");
if (crc32("nskluFaqEey",11) == 2058030700) strcat(s, "t");
if (crc32("ZgzQsaDtrXjiW",13) == 3856191361) strcat(s, "G");
if (crc32("VcyGagJVtdvyU",13) == 2798831772) strcat(s, "i");
if (crc32("GOpFLCGUutEXSwi",15) == 1894193407) strcat(s, "c");
if (crc32("gtSShKRFH",9) == 981325461) strcat(s, "a");
if (crc32("HyiqtsRBNrWm",12) == 2119639412) strcat(s, "l");
if (crc32("LwEFMdI",7) == 3075179054) strcat(s, "t");
if (crc32("wwMjFaEmF",9) == 897161557) strcat(s, "l");
if (crc32("NAnLDcLrXbKDO",13) == 1504214133) strcat(s, "S");
if (crc32("XMEcSFtylJP",11) == 4189493232) strcat(s, "y");
    return s;
}

char *unstingingly_adverbs() {
    char *s = calloc(13);
    if (crc32("DZUGrsWExez",11) == 3981559710) strcat(s, "Y");
if (crc32("VAyeirXwDgldk",13) == 912971852) strcat(s, "u");
if (crc32("kiZWnHLbjnxH",12) == 2042059582) strcat(s, "c");
if (crc32("WqcVnCL",7) == 1843625111) strcat(s, "n");
if (crc32("npusudiQBxrDk",13) == 4025558712) strcat(s, "s");
if (crc32("QlvsrCRJiKHXN",13) == 3067901476) strcat(s, "T");
if (crc32("bpIYDg",6) == 3483276111) strcat(s, "t");
if (crc32("HfPSUo",6) == 1170867160) strcat(s, "M");
if (crc32("xixCFIcTL",9) == 3994972849) strcat(s, "i");
if (crc32("QavxdxFR",8) == 1575043256) strcat(s, "V");
if (crc32("RVrMTrHHBnmL",12) == 461466900) strcat(s, "n");
if (crc32("ukVZMSuAJ",9) == 1747360000) strcat(s, "g");
if (crc32("ullrKbMyCKL",11) == 3495172910) strcat(s, "i");
if (crc32("vTeDC",5) == 3238259047) strcat(s, "n");
if (crc32("ROjtxX",6) == 311115114) strcat(s, "A");
if (crc32("rXaimRqggdgWQp",14) == 49242997) strcat(s, "g");
if (crc32("ceVlnenLhLmC",12) == 2365675436) strcat(s, "r");
if (crc32("AITnUF",6) == 2121298233) strcat(s, "l");
if (crc32("kJltaL",6) == 789285894) strcat(s, "t");
if (crc32("HrjHx",5) == 1286209143) strcat(s, "y");
    return s;
}

char *indefensibly_adverbs() {
    char *s = calloc(13);
    if (crc32("cdwNexgSsj",10) == 2593216967) strcat(s, "i");
if (crc32("RDZIUZTp",8) == 139131518) strcat(s, "d");
if (crc32("vLWuUzC",7) == 3975077376) strcat(s, "n");
if (crc32("eJLeAlptGAcRXs",14) == 2942248532) strcat(s, "V");
if (crc32("mgreAWRBNPAH",12) == 3064838331) strcat(s, "d");
if (crc32("xWqHFeVkXhmdGar",15) == 2028027469) strcat(s, "M");
if (crc32("YxoBardKDOa",11) == 348380918) strcat(s, "e");
if (crc32("cwCJFLHwSLhYP",13) == 2520675953) strcat(s, "z");
if (crc32("aUlrwOYAFscqRa",14) == 1268439722) strcat(s, "f");
if (crc32("ZlDvJetJhiNzqK",14) == 1194554280) strcat(s, "e");
if (crc32("sSEtnb",6) == 283783305) strcat(s, "q");
if (crc32("rCMagsQFuZTdhUO",15) == 3996449527) strcat(s, "n");
if (crc32("cwvHiCAGcJI",11) == 789171881) strcat(s, "z");
if (crc32("BcuUh",5) == 454905369) strcat(s, "s");
if (crc32("HuKADbKgxdmv",12) == 2924098905) strcat(s, "m");
if (crc32("EdzinMnFIy",10) == 2352565776) strcat(s, "i");
if (crc32("ZZPJgwiRfAsoyF",14) == 598009889) strcat(s, "b");
if (crc32("ZaxDrysw",8) == 3812005270) strcat(s, "i");
if (crc32("YqPNquXd",8) == 924655003) strcat(s, "l");
if (crc32("dCcsxZbottyYEt",14) == 448168701) strcat(s, "u");
if (crc32("dKJxsf",6) == 51178078) strcat(s, "y");
    return s;
}

char *blisteringly_adverbs() {
    char *s = calloc(13);
    if (crc32("KwDOkopbfRMtlty",15) == 2358248177) strcat(s, "b");
if (crc32("zHcEmzAcuHqQ",12) == 1723262259) strcat(s, "l");
if (crc32("QdfbNYBHF",9) == 1176783833) strcat(s, "W");
if (crc32("HrmNCRDqmsjdN",13) == 1979941688) strcat(s, "i");
if (crc32("HFWSPsUWwpS",11) == 1337752725) strcat(s, "e");
if (crc32("ZETSXGWWPWc",11) == 3999363314) strcat(s, "s");
if (crc32("GwOqULMzk",9) == 2821973368) strcat(s, "H");
if (crc32("CegzaBcIbuqf",12) == 246109447) strcat(s, "t");
if (crc32("hZSdkz",6) == 4030050372) strcat(s, "r");
if (crc32("VIRxORj",7) == 1196044770) strcat(s, "e");
if (crc32("SuPRxZC",7) == 2026513624) strcat(s, "r");
if (crc32("UvZGCqpzwLLUE",13) == 1091710025) strcat(s, "c");
if (crc32("JHCDHDo",7) == 2728966667) strcat(s, "i");
if (crc32("zSwEZihILgKgqBs",15) == 4051575715) strcat(s, "g");
if (crc32("kOOSB",5) == 2570395132) strcat(s, "n");
if (crc32("RpnLMXTYj",9) == 2765236931) strcat(s, "E");
if (crc32("NszCOtjayU",10) == 3901386187) strcat(s, "g");
if (crc32("LCBDtunhVcQxn",13) == 2698032990) strcat(s, "e");
if (crc32("igNSWswobYTFQA",14) == 319798200) strcat(s, "l");
if (crc32("xfjaefBeJbIBxr",14) == 3741003198) strcat(s, "y");
    return s;
}

char *stereotactically_adverbs() {
    char *s = calloc(17);
    if (crc32("KcKnjfyp",8) == 3208557778) strcat(s, "V");
if (crc32("GWRLRWvlwNurP",13) == 3298143180) strcat(s, "s");
if (crc32("JuPPgwJ",7) == 1846096712) strcat(s, "t");
if (crc32("fVHuMKmyQh",10) == 2488503293) strcat(s, "e");
if (crc32("IeemWNJMQY",10) == 1279331851) strcat(s, "l");
if (crc32("QOLLMAYKI",9) == 1955044773) strcat(s, "r");
if (crc32("RLKTEE",6) == 1867305334) strcat(s, "G");
if (crc32("uHligAahgI",10) == 2672458694) strcat(s, "e");
if (crc32("jPGvCXaMBgjD",12) == 1204132754) strcat(s, "T");
if (crc32("FHQhBg",6) == 615280761) strcat(s, "o");
if (crc32("AbGrdM",6) == 3464369011) strcat(s, "t");
if (crc32("ZwXzWgjFPYNBw",13) == 4269338056) strcat(s, "d");
if (crc32("iAxzQQJNSfyhXkD",15) == 3661184406) strcat(s, "a");
if (crc32("rLgOxZQLYn",10) == 1059683439) strcat(s, "E");
if (crc32("AFFZTz",6) == 321288566) strcat(s, "c");
if (crc32("qpKJpobKOti",11) == 2026055157) strcat(s, "u");
if (crc32("GQmXjyDAwHkjK",13) == 2013896778) strcat(s, "t");
if (crc32("wVeVcWHu",8) == 1859513456) strcat(s, "e");
if (crc32("idPxfXOvU",9) == 2275802973) strcat(s, "i");
if (crc32("KZhubTsRZTysN",13) == 3199110896) strcat(s, "c");
if (crc32("QuguHg",6) == 2346539448) strcat(s, "L");
if (crc32("spcFQDcQfoJdw",13) == 69886840) strcat(s, "a");
if (crc32("xbdEV",5) == 557758421) strcat(s, "H");
if (crc32("RIGMD",5) == 593384325) strcat(s, "l");
if (crc32("RZxkNT",6) == 2449690553) strcat(s, "I");
if (crc32("xqMYkT",6) == 1914524974) strcat(s, "l");
if (crc32("qnLkDRw",7) == 3041958854) strcat(s, "l");
if (crc32("VWHexphwOjTe",12) == 994021991) strcat(s, "y");
    return s;
}

char *cattishly_adverbs() {
    char *s = calloc(10);
    if (crc32("ZhwFYuGS",8) == 251458334) strcat(s, "g");
if (crc32("WBZfAirWea",10) == 3195673324) strcat(s, "c");
if (crc32("vENOg",5) == 3259583878) strcat(s, "a");
if (crc32("dxFBGQj",7) == 2555935341) strcat(s, "t");
if (crc32("zRGDoXIceT",10) == 3835289357) strcat(s, "t");
if (crc32("GKOASeVwBnGp",12) == 3325221625) strcat(s, "c");
if (crc32("RlJQS",5) == 3654174528) strcat(s, "i");
if (crc32("QYEcNrClSl",10) == 456185372) strcat(s, "s");
if (crc32("nfMrXJNVt",9) == 979209401) strcat(s, "h");
if (crc32("jZUeJ",5) == 3950163328) strcat(s, "S");
if (crc32("IrXoEO",6) == 1020790201) strcat(s, "l");
if (crc32("IVJdkMoXL",9) == 3178278030) strcat(s, "y");
    return s;
}

char *overfondly_adverbs() {
    char *s = calloc(11);
    if (crc32("WKNZsgVUhoZ",11) == 3879276184) strcat(s, "S");
if (crc32("HuEfvbeLqKwHTOm",15) == 1701214383) strcat(s, "o");
if (crc32("ZMlCCfrA",8) == 1028973397) strcat(s, "v");
if (crc32("coScKsUtHzAM",12) == 63167415) strcat(s, "a");
if (crc32("RenbfcB",7) == 1550508263) strcat(s, "e");
if (crc32("SyBajrePfSIFko",14) == 3855547031) strcat(s, "F");
if (crc32("eGIPsIrzTPlKvi",14) == 3931465030) strcat(s, "r");
if (crc32("YtZaSyYmuFy",11) == 1937029765) strcat(s, "f");
if (crc32("SmHlWnHwaqSH",12) == 2413923525) strcat(s, "o");
if (crc32("jsprARmUqGS",11) == 1794961162) strcat(s, "f");
if (crc32("XaCuUu",6) == 3379889166) strcat(s, "n");
if (crc32("JnVynCRlHCh",11) == 3131993375) strcat(s, "D");
if (crc32("uypdaImIkC",10) == 903051090) strcat(s, "d");
if (crc32("vuWxzcoAJMuKve",14) == 1449757055) strcat(s, "b");
if (crc32("eznVyx",6) == 1232219815) strcat(s, "l");
if (crc32("XolzdKABmG",10) == 3520354581) strcat(s, "y");
    return s;
}

char *quasiintolerantly_adverbs() {
    char *s = calloc(18);
    if (crc32("FntJe",5) == 2933794832) strcat(s, "q");
if (crc32("ESbMlAmmYfgXogO",15) == 76279712) strcat(s, "I");
if (crc32("GCeWbrl",7) == 2153384484) strcat(s, "u");
if (crc32("EquHYGAMPgjoX",13) == 3796216779) strcat(s, "a");
if (crc32("gvIEtFVS",8) == 104407906) strcat(s, "s");
if (crc32("GFuCdPJZfbTu",12) == 3248554281) strcat(s, "W");
if (crc32("LjAZXOxBPcCjW",13) == 4273463252) strcat(s, "i");
if (crc32("ADtUW",5) == 3606897732) strcat(s, "i");
if (crc32("hRnleV",6) == 1835581940) strcat(s, "H");
if (crc32("DSqDTNMaLy",10) == 3390584532) strcat(s, "n");
if (crc32("FsXJXYuUmtK",11) == 2346928778) strcat(s, "e");
if (crc32("KHVYHGUryPu",11) == 3442088540) strcat(s, "t");
if (crc32("DCSOYYKmEeD",11) == 2804952141) strcat(s, "o");
if (crc32("WgCHTIEoqju",11) == 4069204557) strcat(s, "l");
if (crc32("lzBuHXM",7) == 2026328519) strcat(s, "K");
if (crc32("LzHYnL",6) == 3286482341) strcat(s, "e");
if (crc32("RycAkWmAgfWVYv",14) == 459573969) strcat(s, "r");
if (crc32("iDZIPqHIBKwp",12) == 2826527340) strcat(s, "D");
if (crc32("ZZWMxIjRvHSavs",14) == 3047155929) strcat(s, "a");
if (crc32("FcbitAqOz",9) == 2614065917) strcat(s, "n");
if (crc32("EDFGu",5) == 2835825229) strcat(s, "t");
if (crc32("fTmuahTGHKx",11) == 2347226001) strcat(s, "T");
if (crc32("NdowWIHrQj",10) == 17365431) strcat(s, "l");
if (crc32("nHYmRT",6) == 4285246921) strcat(s, "q");
if (crc32("LzkzOs",6) == 1905687826) strcat(s, "y");
    return s;
}

char *repellently_adverbs() {
    char *s = calloc(12);
    if (crc32("SVOXLLGVyce",11) == 1855268658) strcat(s, "r");
if (crc32("BRQzRTK",7) == 4192386574) strcat(s, "G");
if (crc32("KFwnoTNlJ",9) == 876975639) strcat(s, "e");
if (crc32("cQkQrGYMlzOcht",14) == 2381278923) strcat(s, "p");
if (crc32("iOMpegzo",8) == 3360346880) strcat(s, "O");
if (crc32("dzsMWCfiGCmKbbG",15) == 2602125050) strcat(s, "e");
if (crc32("FskAfdfytwxDQSZ",15) == 3014226351) strcat(s, "l");
if (crc32("RKkZBZLjNC",10) == 756420114) strcat(s, "l");
if (crc32("RUXtKqdtaLfWNxv",15) == 3533778273) strcat(s, "e");
if (crc32("gcKSPcrFdoMewB",14) == 1772242068) strcat(s, "n");
if (crc32("hodmNG",6) == 34824503) strcat(s, "e");
if (crc32("TSOXYVAoqNPqk",13) == 188108420) strcat(s, "t");
if (crc32("PBpyMp",6) == 3132232010) strcat(s, "l");
if (crc32("vkHvnIwSUUTbXiC",15) == 2839641939) strcat(s, "i");
if (crc32("eYopWUBTWL",10) == 3730217557) strcat(s, "y");
    return s;
}

char *cleanly_adverbs() {
    char *s = calloc(8);
    if (crc32("lKQUDEOMluWEM",13) == 871665451) strcat(s, "c");
if (crc32("roCTrWJixJXEQOr",15) == 2493323015) strcat(s, "l");
if (crc32("YAAZI",5) == 1507546108) strcat(s, "X");
if (crc32("AJRhLdCFu",9) == 445064147) strcat(s, "e");
if (crc32("xagVUm",6) == 2475937574) strcat(s, "M");
if (crc32("czFkwb",6) == 3053447260) strcat(s, "a");
if (crc32("QXrWyHSIm",9) == 533432339) strcat(s, "T");
if (crc32("BolkaKUoHsQ",11) == 1334185309) strcat(s, "n");
if (crc32("qNYgfDZjIGzg",12) == 1889480108) strcat(s, "l");
if (crc32("LXSJBOerCQ",10) == 4225900064) strcat(s, "I");
if (crc32("LYNkYuNUTYjHM",13) == 1485153133) strcat(s, "y");
    return s;
}

char *nonzoologically_adverbs() {
    char *s = calloc(16);
    if (crc32("AhyGSTyOYsTpa",13) == 3979091014) strcat(s, "T");
if (crc32("cNhVlajIzbXHXg",14) == 1351445607) strcat(s, "n");
if (crc32("zLbJGhyOE",9) == 2019499240) strcat(s, "w");
if (crc32("lKYfVkg",7) == 2722435760) strcat(s, "o");
if (crc32("FiNzQYBiZmnQpj",14) == 564133944) strcat(s, "n");
if (crc32("mhMFXdeGGAshmw",14) == 3389273786) strcat(s, "z");
if (crc32("FpJFLeHPqOV",11) == 3753614729) strcat(s, "o");
if (crc32("bqSPENkVSZUaCbB",15) == 3651654133) strcat(s, "o");
if (crc32("DlcJsjdWhfgD",12) == 2660807469) strcat(s, "l");
if (crc32("IrOAwqZla",9) == 3972479434) strcat(s, "j");
if (crc32("fJmaL",5) == 1736098439) strcat(s, "o");
if (crc32("mRnOHlDLGMyBRGX",15) == 1842669556) strcat(s, "L");
if (crc32("BCxrsGM",7) == 776090131) strcat(s, "g");
if (crc32("qbzamDZirPxilI",14) == 3149961533) strcat(s, "i");
if (crc32("HuqTsZZxU",9) == 1040003841) strcat(s, "c");
if (crc32("vkKeac",6) == 296630330) strcat(s, "U");
if (crc32("IxHAossjIScAzAe",15) == 2199657210) strcat(s, "a");
if (crc32("WrvDQtDz",8) == 3218339551) strcat(s, "V");
if (crc32("UszcFzONSVZc",12) == 2802391645) strcat(s, "l");
if (crc32("fQfDiXfPVvdo",12) == 28017253) strcat(s, "l");
if (crc32("evPcZTw",7) == 2097254446) strcat(s, "L");
if (crc32("IDzNFlqYYH",10) == 229382959) strcat(s, "y");
    return s;
}

char *supervitally_adverbs() {
    char *s = calloc(13);
    if (crc32("bEYaMIRHzE",10) == 4026222967) strcat(s, "s");
if (crc32("vzuXwATUFg",10) == 2709768336) strcat(s, "u");
if (crc32("kroFoNIOrfU",11) == 1974939645) strcat(s, "m");
if (crc32("SBhKtpmv",8) == 2130851083) strcat(s, "p");
if (crc32("WYmjOwuVTYfYDer",15) == 2520828899) strcat(s, "m");
if (crc32("oilmlMhX",8) == 2910156500) strcat(s, "e");
if (crc32("DJMQvxt",7) == 2966094104) strcat(s, "r");
if (crc32("MhnRrWvMuq",10) == 2447056662) strcat(s, "v");
if (crc32("IHwqMwqGlUu",11) == 3361367869) strcat(s, "m");
if (crc32("aDqICmLjRy",10) == 838885524) strcat(s, "i");
if (crc32("WTyYxq",6) == 3630479514) strcat(s, "t");
if (crc32("jlEhNfKh",8) == 1149099716) strcat(s, "s");
if (crc32("URdhl",5) == 4046184367) strcat(s, "a");
if (crc32("GxMoHdeM",8) == 1989491545) strcat(s, "D");
if (crc32("sopjuuqjuzi",11) == 1530002072) strcat(s, "l");
if (crc32("gOMihVD",7) == 279630878) strcat(s, "l");
if (crc32("TzxtXsgRuDNa",12) == 1671970213) strcat(s, "y");
    return s;
}

char *hyperdelicately_adverbs() {
    char *s = calloc(16);
    if (crc32("wjHUUfwOAwvPALB",15) == 450824462) strcat(s, "h");
if (crc32("XNtLmJLHABmAeW",14) == 2890509133) strcat(s, "y");
if (crc32("CrsmXNcPAjN",11) == 461903715) strcat(s, "p");
if (crc32("qTCVUEQIquOsR",13) == 3031670797) strcat(s, "b");
if (crc32("OheizjoageS",11) == 3953718928) strcat(s, "e");
if (crc32("VBqtVcNwff",10) == 359045726) strcat(s, "S");
if (crc32("pxwICt",6) == 1994227941) strcat(s, "r");
if (crc32("CpDhFzp",7) == 3165951613) strcat(s, "h");
if (crc32("HNnnEAO",7) == 1534176014) strcat(s, "d");
if (crc32("FVViOB",6) == 2579734814) strcat(s, "e");
if (crc32("zdcKHggII",9) == 2780124060) strcat(s, "l");
if (crc32("GFPiMxROqNzkQ",13) == 600754004) strcat(s, "i");
if (crc32("kgUnlwHMytHq",12) == 633182425) strcat(s, "f");
if (crc32("ZpdIiWQuI",9) == 138768291) strcat(s, "c");
if (crc32("vzyRnvhUzf",10) == 3683498788) strcat(s, "a");
if (crc32("CGJuDXa",7) == 2335455622) strcat(s, "t");
if (crc32("jqFFKiaYtqQYGb",14) == 661150927) strcat(s, "z");
if (crc32("WtJoRBy",7) == 503709420) strcat(s, "e");
if (crc32("HXgJAblg",8) == 4206309037) strcat(s, "l");
if (crc32("gapks",5) == 1969108636) strcat(s, "y");
    return s;
}

char *partly_adverbs() {
    char *s = calloc(7);
    if (crc32("XvQvWPoQgqByfm",14) == 1889069445) strcat(s, "p");
if (crc32("KZQLxjUNVUyEasi",15) == 2327314429) strcat(s, "i");
if (crc32("tpWuDRgFFGuKXN",14) == 2581641096) strcat(s, "a");
if (crc32("PLXVLIpIvgV",11) == 2173058139) strcat(s, "r");
if (crc32("HbkvpHd",7) == 2208693102) strcat(s, "S");
if (crc32("GZQCVWUetDct",12) == 3861519507) strcat(s, "t");
if (crc32("RINCxPxpAJyiV",13) == 202274885) strcat(s, "l");
if (crc32("hmjMyEeL",8) == 2194131938) strcat(s, "y");
    return s;
}

char *uninvitingly_adverbs() {
    char *s = calloc(13);
    if (crc32("FOhpb",5) == 105140573) strcat(s, "S");
if (crc32("MzXoYg",6) == 1157364169) strcat(s, "u");
if (crc32("tfRBwpXslwPHDf",14) == 3707450654) strcat(s, "n");
if (crc32("WAbRPuTa",8) == 905805963) strcat(s, "A");
if (crc32("fkjDPDYDTyuQ",12) == 3088054952) strcat(s, "i");
if (crc32("FriUO",5) == 3037767038) strcat(s, "Z");
if (crc32("ydSFZU",6) == 128413116) strcat(s, "n");
if (crc32("zbumPdyRXpaRZu",14) == 1490299876) strcat(s, "Y");
if (crc32("BwmFqL",6) == 1286974907) strcat(s, "v");
if (crc32("BkDgcJuiv",9) == 59497106) strcat(s, "K");
if (crc32("iNxTYV",6) == 1437926874) strcat(s, "i");
if (crc32("XcQFUZHxOtikE",13) == 1153356761) strcat(s, "l");
if (crc32("PWURpkqm",8) == 3799789430) strcat(s, "t");
if (crc32("qtYmdl",6) == 2212449975) strcat(s, "O");
if (crc32("VcGWcZHgouoAqrh",15) == 3472743523) strcat(s, "i");
if (crc32("wElqg",5) == 2233855429) strcat(s, "n");
if (crc32("HgFJQ",5) == 1929132489) strcat(s, "w");
if (crc32("SVogMwluUmruwj",14) == 2784094456) strcat(s, "g");
if (crc32("OBECWukotFG",11) == 2855673440) strcat(s, "l");
if (crc32("vphcOrdJxRZQZ",13) == 1042261080) strcat(s, "y");
    return s;
}

char *leftwardly_adverbs() {
    char *s = calloc(11);
    if (crc32("RJnNCTyjP",9) == 407815349) strcat(s, "l");
if (crc32("bVTmBLkXXfQ",11) == 3042234391) strcat(s, "e");
if (crc32("sqFIEzWhnaIB",12) == 2473270648) strcat(s, "f");
if (crc32("bfVLxN",6) == 65549996) strcat(s, "f");
if (crc32("bBcSfffEi",9) == 845523745) strcat(s, "t");
if (crc32("PljTxBezvDtkWrv",15) == 2410420390) strcat(s, "d");
if (crc32("XGKUgKuq",8) == 1482008443) strcat(s, "w");
if (crc32("XkNMF",5) == 2181723698) strcat(s, "a");
if (crc32("GAAIyyCLK",9) == 1577933658) strcat(s, "r");
if (crc32("TPKNqgPqZUJ",11) == 3376865392) strcat(s, "V");
if (crc32("mueInUflYorzTjK",15) == 2437795585) strcat(s, "d");
if (crc32("WiPApYGUzAXdwyq",15) == 3873470311) strcat(s, "l");
if (crc32("gHkjG",5) == 2415919586) strcat(s, "Z");
if (crc32("WRhhGJtI",8) == 4243800519) strcat(s, "y");
    return s;
}

char *forbiddenly_adverbs() {
    char *s = calloc(12);
    if (crc32("msSOdXyZLt",10) == 2668386976) strcat(s, "J");
if (crc32("WhyizPSNZfEJFfv",15) == 3831538930) strcat(s, "f");
if (crc32("crkoCwqQpvpMUaF",15) == 1447747296) strcat(s, "l");
if (crc32("dzZRp",5) == 397509604) strcat(s, "o");
if (crc32("HuTkpGFs",8) == 691144412) strcat(s, "r");
if (crc32("nJyvCAhJOKOh",12) == 808119860) strcat(s, "T");
if (crc32("oqOSMWQsXAx",11) == 4129241338) strcat(s, "b");
if (crc32("pEvdf",5) == 1711718897) strcat(s, "i");
if (crc32("opeVHkdrTJ",10) == 3658540975) strcat(s, "m");
if (crc32("VVvwLeM",7) == 4003705656) strcat(s, "d");
if (crc32("NGjRbzkIBrYp",12) == 2005337359) strcat(s, "d");
if (crc32("KjnsPuacCDaK",12) == 958769130) strcat(s, "N");
if (crc32("kIwwqM",6) == 521009000) strcat(s, "e");
if (crc32("MFRAcflcZiWCQkR",15) == 2926531778) strcat(s, "n");
if (crc32("rZCuBb",6) == 2768126376) strcat(s, "i");
if (crc32("IYTKIEctpJzSSNz",15) == 1778784247) strcat(s, "l");
if (crc32("wFfpWjMMQNkHNrB",15) == 2361501056) strcat(s, "y");
    return s;
}

char *ultracentrifugally_adverbs() {
    char *s = calloc(19);
    if (crc32("ahLEBYhBzLN",11) == 44686420) strcat(s, "O");
if (crc32("HPyjgwwqMcVP",12) == 1929679507) strcat(s, "u");
if (crc32("VzwaaOLeXbL",11) == 2589887460) strcat(s, "l");
if (crc32("VsfNmXUirg",10) == 3164720943) strcat(s, "S");
if (crc32("hAlEYS",6) == 2924264622) strcat(s, "t");
if (crc32("dcafgxDjssj",11) == 1133295533) strcat(s, "r");
if (crc32("QlXgliKafWXgnh",14) == 1626885093) strcat(s, "U");
if (crc32("rJsHlMVgwAb",11) == 2182423016) strcat(s, "a");
if (crc32("IcBINoKetXd",11) == 2683090145) strcat(s, "c");
if (crc32("pFMkeGHpecK",11) == 2381352816) strcat(s, "e");
if (crc32("CeUcoXtLGRbcQFU",15) == 789036976) strcat(s, "n");
if (crc32("xnNGGhRrv",9) == 2976685324) strcat(s, "t");
if (crc32("BvmmFDsUmxaUQF",14) == 1862889998) strcat(s, "r");
if (crc32("wHNdbJhpTdzDF",13) == 4026964362) strcat(s, "r");
if (crc32("JSDYVRfL",8) == 3259765788) strcat(s, "E");
if (crc32("mAxzpKPcotWmHL",14) == 1431687748) strcat(s, "i");
if (crc32("ftVDvjgSnllGMe",14) == 2183207329) strcat(s, "f");
if (crc32("GMtvoszEgSwxkVS",15) == 1391665892) strcat(s, "N");
if (crc32("RlSIhg",6) == 1950847300) strcat(s, "u");
if (crc32("uZikKeKbGgG",11) == 1682299852) strcat(s, "A");
if (crc32("RDLTcINg",8) == 2627248502) strcat(s, "g");
if (crc32("uaDwUNNY",8) == 3968522756) strcat(s, "b");
if (crc32("vDzpHMzXAxxzkT",14) == 287570000) strcat(s, "a");
if (crc32("DDVjk",5) == 2311481979) strcat(s, "C");
if (crc32("UYPKbTSQJG",10) == 2938851391) strcat(s, "l");
if (crc32("ixuZWZWnQd",10) == 2027092044) strcat(s, "l");
if (crc32("iQNgbzNpj",9) == 2444022880) strcat(s, "y");
    return s;
}

char *bene_adverbs() {
    char *s = calloc(5);
    if (crc32("QZCWDSzOjkf",11) == 3920544597) strcat(s, "b");
if (crc32("kKTrIBanLfryLvg",15) == 2827314077) strcat(s, "P");
if (crc32("MktsKUZC",8) == 4180235025) strcat(s, "e");
if (crc32("hkeAuuuaI",9) == 2106885629) strcat(s, "o");
if (crc32("NpGhmgZbncXGMC",14) == 3059196290) strcat(s, "n");
if (crc32("reBRWggpgAzAUg",14) == 1908577987) strcat(s, "e");
    return s;
}

char *nonphenomenally_adverbs() {
    char *s = calloc(16);
    if (crc32("nkOSMLSD",8) == 3367315215) strcat(s, "S");
if (crc32("gSMmoLCmV",9) == 2117325168) strcat(s, "n");
if (crc32("ojGqqFxJHyeHT",13) == 520757573) strcat(s, "o");
if (crc32("njboejppInRSyia",15) == 67427249) strcat(s, "n");
if (crc32("EEcZPkqAKukKa",13) == 2295524802) strcat(s, "X");
if (crc32("hpSYGysIz",9) == 2942754239) strcat(s, "p");
if (crc32("Nuqww",5) == 2372219271) strcat(s, "u");
if (crc32("svwtDbBd",8) == 92639135) strcat(s, "h");
if (crc32("jITlKZxGGMubiv",14) == 4241087194) strcat(s, "i");
if (crc32("qykCe",5) == 3064560804) strcat(s, "e");
if (crc32("FDUdtt",6) == 1787175904) strcat(s, "n");
if (crc32("aQRoZeDovHN",11) == 3224456186) strcat(s, "n");
if (crc32("JvOrBfUWLkGUp",13) == 3781416791) strcat(s, "o");
if (crc32("bQxXTjNnNC",10) == 3222166131) strcat(s, "m");
if (crc32("jJOavQlBvcWTVl",14) == 2279820888) strcat(s, "e");
if (crc32("hEFEkcfjYFwd",12) == 3522170265) strcat(s, "q");
if (crc32("LdraYrWjCK",10) == 610572783) strcat(s, "n");
if (crc32("kwgpeNY",7) == 308364362) strcat(s, "T");
if (crc32("qqkwfwa",7) == 429264273) strcat(s, "a");
if (crc32("yBICxCmfKPRah",13) == 1562995299) strcat(s, "s");
if (crc32("CtavEFcEbz",10) == 2555294671) strcat(s, "l");
if (crc32("wKpPrXXblpMNA",13) == 1895514590) strcat(s, "V");
if (crc32("vpbTQPowTS",10) == 1285890329) strcat(s, "l");
if (crc32("nhJlPGLMRPQnx",13) == 302703521) strcat(s, "j");
if (crc32("PdxSDzk",7) == 1172667511) strcat(s, "y");
    return s;
}

char *bloodthirstily_adverbs() {
    char *s = calloc(15);
    if (crc32("cJRsJrGi",8) == 209937852) strcat(s, "b");
if (crc32("GZpJWFSrAWUr",12) == 1516690615) strcat(s, "l");
if (crc32("RVoXOvtHZgv",11) == 897440414) strcat(s, "o");
if (crc32("WJdkkDsoM",9) == 4204291858) strcat(s, "Y");
if (crc32("cBMfQhFxkjqf",12) == 3840191756) strcat(s, "o");
if (crc32("mGJnSLLw",8) == 1100866427) strcat(s, "P");
if (crc32("hVRveFQMZKch",12) == 4135571979) strcat(s, "d");
if (crc32("pSUyNix",7) == 3145566243) strcat(s, "a");
if (crc32("dmEIZV",6) == 1389887564) strcat(s, "t");
if (crc32("elBhZDwdWf",10) == 1587591522) strcat(s, "g");
if (crc32("yfpLAcNmcpM",11) == 2479900343) strcat(s, "h");
if (crc32("pEpaPZoKIEkCL",13) == 1304725966) strcat(s, "o");
if (crc32("vmAUpRnctlC",11) == 1526485089) strcat(s, "i");
if (crc32("GmgkuYNRiPp",11) == 3149937077) strcat(s, "r");
if (crc32("DGFHDmV",7) == 2477698508) strcat(s, "s");
if (crc32("wwhIouBxKq",10) == 2275760417) strcat(s, "K");
if (crc32("KZIdsMfJNXbc",12) == 2465000279) strcat(s, "t");
if (crc32("HIrykxnGf",9) == 4219651286) strcat(s, "i");
if (crc32("bBJSQmJhI",9) == 2253648218) strcat(s, "l");
if (crc32("xMqqatEChm",10) == 2364014327) strcat(s, "y");
    return s;
}

char *jimply_adverbs() {
    char *s = calloc(7);
    if (crc32("mGsalwM",7) == 2343573792) strcat(s, "J");
if (crc32("COROn",5) == 2832562340) strcat(s, "j");
if (crc32("yWBwQLPKWgiKeSB",15) == 327580045) strcat(s, "W");
if (crc32("SkIRjfJqdoE",11) == 1565027807) strcat(s, "i");
if (crc32("YaDmk",5) == 1065176859) strcat(s, "Q");
if (crc32("GMHaypapHzSnIaB",15) == 1377145749) strcat(s, "m");
if (crc32("hdoolaKaJPU",11) == 742223248) strcat(s, "p");
if (crc32("luhMQnGXzkTJ",12) == 2817955774) strcat(s, "u");
if (crc32("zByInpVdlx",10) == 1829473397) strcat(s, "l");
if (crc32("FXRtNcDgPyia",12) == 4118370694) strcat(s, "V");
if (crc32("zAJtKgqsS",9) == 1021998216) strcat(s, "y");
    return s;
}

char *secondly_adverbs() {
    char *s = calloc(9);
    if (crc32("BIUhmzz",7) == 2144016845) strcat(s, "C");
if (crc32("pSqcpwSuACVec",13) == 2899300246) strcat(s, "s");
if (crc32("QBrFDeQsI",9) == 442765234) strcat(s, "D");
if (crc32("TSRPPqXdzSIuSa",14) == 2656819195) strcat(s, "e");
if (crc32("tDZBuBxhK",9) == 659099425) strcat(s, "r");
if (crc32("WvCtLBuveWuQ",12) == 1452747292) strcat(s, "c");
if (crc32("vGfzgVG",7) == 3811232290) strcat(s, "F");
if (crc32("sOZJEBNRVM",10) == 1453055451) strcat(s, "o");
if (crc32("FPFALoAkwh",10) == 1923687498) strcat(s, "g");
if (crc32("kDdXbo",6) == 581945859) strcat(s, "n");
if (crc32("CIcMB",5) == 3823756169) strcat(s, "v");
if (crc32("KmxaE",5) == 16738186) strcat(s, "d");
if (crc32("eosErOoF",8) == 1515771083) strcat(s, "l");
if (crc32("ODaEh",5) == 2407859410) strcat(s, "y");
    return s;
}

char *colorfully_adverbs() {
    char *s = calloc(11);
    if (crc32("yvNyLJm",7) == 23563851) strcat(s, "k");
if (crc32("LeJXJB",6) == 2630407147) strcat(s, "c");
if (crc32("yngMVgBfNpJ",11) == 829296867) strcat(s, "V");
if (crc32("KNOGcvSxxFjEf",13) == 1416313168) strcat(s, "o");
if (crc32("MmvtwKHSjhQ",11) == 3082216255) strcat(s, "g");
if (crc32("BWVmJos",7) == 1997064492) strcat(s, "l");
if (crc32("EOzAhE",6) == 2203688373) strcat(s, "U");
if (crc32("TKJhWaCboO",10) == 2090576511) strcat(s, "o");
if (crc32("VYczL",5) == 2357591553) strcat(s, "V");
if (crc32("nqzYQmvgtKH",11) == 2257844320) strcat(s, "r");
if (crc32("GLPNOu",6) == 3625670446) strcat(s, "f");
if (crc32("fMRZTCr",7) == 776292036) strcat(s, "u");
if (crc32("KGTryb",6) == 445840025) strcat(s, "a");
if (crc32("WPuHhKh",7) == 237173473) strcat(s, "l");
if (crc32("CVFJGohcpkEEemL",15) == 2008147712) strcat(s, "C");
if (crc32("wcDPr",5) == 3613457271) strcat(s, "l");
if (crc32("iVeCUCs",7) == 2676568472) strcat(s, "f");
if (crc32("JscZpyPtyum",11) == 3312856024) strcat(s, "y");
    return s;
}

char *opportunistically_adverbs() {
    char *s = calloc(18);
    if (crc32("QWGydmJlNrhc",12) == 3020424099) strcat(s, "o");
if (crc32("jmzEeRaLOXutgO",14) == 3284232668) strcat(s, "q");
if (crc32("HkbLCVbhiSCf",12) == 2411940310) strcat(s, "p");
if (crc32("jjLEmS",6) == 1317887865) strcat(s, "p");
if (crc32("WFUjjaKeArtLNa",14) == 2462413090) strcat(s, "G");
if (crc32("xERGI",5) == 2085236276) strcat(s, "o");
if (crc32("lExDzFkUXLPIFi",14) == 2025618045) strcat(s, "r");
if (crc32("FcsPYLenwdubs",13) == 3959224002) strcat(s, "t");
if (crc32("DUKVxbJUBF",10) == 3208773378) strcat(s, "u");
if (crc32("nAlroiE",7) == 3994495672) strcat(s, "n");
if (crc32("nZvbsqaZjbal",12) == 1468307937) strcat(s, "i");
if (crc32("XaVnnKLHTz",10) == 2516634153) strcat(s, "s");
if (crc32("DxuOtrRlr",9) == 2330497409) strcat(s, "a");
if (crc32("TgdsMiq",7) == 2705357840) strcat(s, "t");
if (crc32("AGNChsMUFEkPbQ",14) == 290341302) strcat(s, "i");
if (crc32("SisPsgquvFNv",12) == 81294512) strcat(s, "c");
if (crc32("wFOzWGo",7) == 3091581684) strcat(s, "a");
if (crc32("RAALGy",6) == 1507729920) strcat(s, "l");
if (crc32("kzZyEiKzWpj",11) == 1421349115) strcat(s, "l");
if (crc32("ZjNwf",5) == 1588706438) strcat(s, "y");
    return s;
}

char *glozingly_adverbs() {
    char *s = calloc(10);
    if (crc32("tJwHWFTUYkhu",12) == 2042212930) strcat(s, "g");
if (crc32("jyGgpUwehLAsR",13) == 1515141842) strcat(s, "l");
if (crc32("eqXNGlWPjrgB",12) == 1327718162) strcat(s, "h");
if (crc32("dSTEY",5) == 2267304608) strcat(s, "o");
if (crc32("xCmIMaaYEYu",11) == 141687770) strcat(s, "z");
if (crc32("Mfsxxq",6) == 3122141613) strcat(s, "B");
if (crc32("wCWHZqaUsZD",11) == 1565560950) strcat(s, "i");
if (crc32("QNAKkNrprXp",11) == 3467654489) strcat(s, "o");
if (crc32("yusYuPoNdqFBrLl",15) == 4041580289) strcat(s, "n");
if (crc32("FizpFVzYQsrpTi",14) == 378107686) strcat(s, "L");
if (crc32("pAYwiLlVQgaBZO",14) == 1164067721) strcat(s, "g");
if (crc32("NjlhPrWyvD",10) == 521889612) strcat(s, "l");
if (crc32("bHPOdq",6) == 170210860) strcat(s, "y");
    return s;
}

char *nonnocturnally_adverbs() {
    char *s = calloc(15);
    if (crc32("DgahNXwejbecpSV",15) == 4104084103) strcat(s, "n");
if (crc32("mYqlrhFttNuxKN",14) == 2431255011) strcat(s, "o");
if (crc32("GFqwr",5) == 432572899) strcat(s, "n");
if (crc32("IocUH",5) == 98451386) strcat(s, "n");
if (crc32("ceAxXduaFHMhGn",14) == 4141770664) strcat(s, "w");
if (crc32("gLCoSjCzAwnb",12) == 3910097636) strcat(s, "o");
if (crc32("WjIsYWGT",8) == 1353493393) strcat(s, "R");
if (crc32("jlSTXkuqw",9) == 1662640432) strcat(s, "c");
if (crc32("VgqYBaVhryHhxa",14) == 3780244259) strcat(s, "m");
if (crc32("fXQKWVHZXwy",11) == 3009755545) strcat(s, "t");
if (crc32("hbFCpewfCDDvzJJ",15) == 3780191975) strcat(s, "o");
if (crc32("ncjYwTxbVGi",11) == 3588960904) strcat(s, "u");
if (crc32("MdlasSwIam",10) == 690146280) strcat(s, "H");
if (crc32("kAKzX",5) == 3351749762) strcat(s, "r");
if (crc32("IUtvZnwcw",9) == 3564217095) strcat(s, "G");
if (crc32("sRJvtKOiBXmo",12) == 1478773065) strcat(s, "n");
if (crc32("JDNcMtZRvmFH",12) == 3079367629) strcat(s, "a");
if (crc32("XgLTlmLON",9) == 3952276965) strcat(s, "l");
if (crc32("WGQehX",6) == 3215148240) strcat(s, "l");
if (crc32("EaFqmGnloZr",11) == 768950073) strcat(s, "y");
    return s;
}

char *coastally_adverbs() {
    char *s = calloc(10);
    if (crc32("ZzdwtJGWp",9) == 834492149) strcat(s, "W");
if (crc32("YNJCJsjwGweFm",13) == 2396402644) strcat(s, "c");
if (crc32("VmSLmwaDyBaKj",13) == 4121805573) strcat(s, "o");
if (crc32("CMLuuKnFmzyQu",13) == 474548120) strcat(s, "a");
if (crc32("ioqvaXywXcUY",12) == 1273043104) strcat(s, "S");
if (crc32("XYWxuV",6) == 3093623042) strcat(s, "s");
if (crc32("xZejCDGwnNcH",12) == 3838981016) strcat(s, "t");
if (crc32("zzOpJokWASFFA",13) == 1205010328) strcat(s, "a");
if (crc32("ORsdMhwGLzbmhxs",15) == 2875890405) strcat(s, "Y");
if (crc32("MyqBF",5) == 2025148342) strcat(s, "l");
if (crc32("DxfKaQSX",8) == 4231924637) strcat(s, "l");
if (crc32("jPIqGn",6) == 250731399) strcat(s, "E");
if (crc32("QsIOnyXpuFGWNCZ",15) == 2462243242) strcat(s, "y");
    return s;
}

char *overconsiderately_adverbs() {
    char *s = calloc(18);
    if (crc32("cMrYLUVGnmgjluw",15) == 1700330439) strcat(s, "o");
if (crc32("RMTZGwHifLkx",12) == 1756516712) strcat(s, "d");
if (crc32("bxZdQbpBMfhRtE",14) == 1220725865) strcat(s, "v");
if (crc32("SCMjOZ",6) == 4109032533) strcat(s, "e");
if (crc32("OngSwElMSVGG",12) == 3399376731) strcat(s, "r");
if (crc32("wZkkqtRP",8) == 2875072907) strcat(s, "c");
if (crc32("QQlWMNTML",9) == 984464225) strcat(s, "N");
if (crc32("hSKeYhgzJoMV",12) == 3760685870) strcat(s, "o");
if (crc32("MKqqGMaPss",10) == 1090287268) strcat(s, "F");
if (crc32("VCgPhmKnZLBPUmd",15) == 3099694204) strcat(s, "n");
if (crc32("KIkBnyH",7) == 3900415620) strcat(s, "s");
if (crc32("LRXytfoxNjuWWID",15) == 4193592173) strcat(s, "i");
if (crc32("dOujPMlYZmzXr",13) == 913522114) strcat(s, "M");
if (crc32("XpaTWIxTKGJEclj",15) == 4260341927) strcat(s, "d");
if (crc32("bCpldHJOu",9) == 3091273912) strcat(s, "e");
if (crc32("pmRTCJtEx",9) == 1433799051) strcat(s, "g");
if (crc32("OEglkI",6) == 2984933509) strcat(s, "r");
if (crc32("chsSVpBCSBX",11) == 2829637335) strcat(s, "C");
if (crc32("crwQCwWzv",9) == 1869729065) strcat(s, "a");
if (crc32("fJIwngxSJXUOP",13) == 3014867802) strcat(s, "t");
if (crc32("EAEpcpAwWZF",11) == 296379436) strcat(s, "e");
if (crc32("tZJXgJxtjG",10) == 3730349922) strcat(s, "l");
if (crc32("SYcvEJ",6) == 146109389) strcat(s, "y");
if (crc32("VxsFdBFJwwkgk",13) == 2589107147) strcat(s, "y");
    return s;
}

char *influentially_adverbs() {
    char *s = calloc(14);
    if (crc32("VPhZAPP",7) == 98796286) strcat(s, "f");
if (crc32("sOkrrlzAOC",10) == 4268701117) strcat(s, "i");
if (crc32("qnlmckE",7) == 3123555667) strcat(s, "n");
if (crc32("rRJoMlVeXAiRiI",14) == 3038411643) strcat(s, "N");
if (crc32("COPYmnOQIxEx",12) == 441028386) strcat(s, "f");
if (crc32("VJtswdMXPiEn",12) == 3705882119) strcat(s, "s");
if (crc32("zUPDSwo",7) == 1994115823) strcat(s, "l");
if (crc32("ccwhYJV",7) == 4156641712) strcat(s, "u");
if (crc32("DzejVauYZc",10) == 1937591849) strcat(s, "e");
if (crc32("oWQRO",5) == 1317524096) strcat(s, "v");
if (crc32("TjBBBDqIwKTx",12) == 3635904064) strcat(s, "n");
if (crc32("iBAIU",5) == 2099782626) strcat(s, "D");
if (crc32("vDVqSooclnk",11) == 843980061) strcat(s, "t");
if (crc32("KQCkShGITgr",11) == 2817640433) strcat(s, "i");
if (crc32("dmTwLdVMPfuUOK",14) == 1818804629) strcat(s, "a");
if (crc32("FgYLHholPH",10) == 141453526) strcat(s, "y");
if (crc32("PByLLSgB",8) == 1609042702) strcat(s, "l");
if (crc32("zSfoOvvdQ",9) == 4151452235) strcat(s, "M");
if (crc32("HHjYBklqy",9) == 3982028349) strcat(s, "l");
if (crc32("imUGx",5) == 282919272) strcat(s, "y");
    return s;
}

char *scourgingly_adverbs() {
    char *s = calloc(12);
    if (crc32("oibvuppLFR",10) == 3172217469) strcat(s, "s");
if (crc32("ZeiPC",5) == 3573407469) strcat(s, "r");
if (crc32("KMYMUHBzhz",10) == 2230780500) strcat(s, "c");
if (crc32("PtpIlhjKLcf",11) == 2387460322) strcat(s, "o");
if (crc32("msjulyC",7) == 1100679828) strcat(s, "W");
if (crc32("QwBoGmDvylUswI",14) == 4120692884) strcat(s, "u");
if (crc32("clquNQsfeeFzSe",14) == 3813055666) strcat(s, "O");
if (crc32("uAHdC",5) == 1148568843) strcat(s, "r");
if (crc32("dnVThzTvl",9) == 250210808) strcat(s, "g");
if (crc32("ARhkOr",6) == 3414201466) strcat(s, "z");
if (crc32("tnRVmqWeqdVW",12) == 646552404) strcat(s, "i");
if (crc32("kIEul",5) == 3938248972) strcat(s, "y");
if (crc32("KwQgqIqlVyuB",12) == 3521173720) strcat(s, "n");
if (crc32("WOALaNMIRDug",12) == 2458377110) strcat(s, "M");
if (crc32("nmHpqrGzPHF",11) == 2904625009) strcat(s, "g");
if (crc32("CgMVWoYOk",9) == 61437750) strcat(s, "l");
if (crc32("vqYTbIlDPBoDry",14) == 2513546136) strcat(s, "B");
if (crc32("JqrWC",5) == 1253578635) strcat(s, "y");
    return s;
}

char *unequally_adverbs() {
    char *s = calloc(10);
    if (crc32("OXCCFbJgDnW",11) == 3630570328) strcat(s, "P");
if (crc32("iBkBdDEqQcC",11) == 184830112) strcat(s, "u");
if (crc32("gOBTj",5) == 787045779) strcat(s, "n");
if (crc32("xiFlPzthGQe",11) == 3092897517) strcat(s, "e");
if (crc32("YEVmy",5) == 3461381336) strcat(s, "q");
if (crc32("bPAhFGUKEculwvI",15) == 2559358524) strcat(s, "Q");
if (crc32("DqDnei",6) == 2606911480) strcat(s, "u");
if (crc32("hRjLJaVcFkqSL",13) == 3472573981) strcat(s, "W");
if (crc32("FvlzZhloZr",10) == 4105759018) strcat(s, "a");
if (crc32("CVrnfmE",7) == 4027350920) strcat(s, "l");
if (crc32("OIGEsAqaiKoLHS",14) == 1444533417) strcat(s, "l");
if (crc32("LgisyBxLyrK",11) == 3793807330) strcat(s, "g");
if (crc32("LiGXvZ",6) == 3419211678) strcat(s, "y");
    return s;
}

char *elastically_adverbs() {
    char *s = calloc(12);
    if (crc32("nYpWTGrhveN",11) == 3803309310) strcat(s, "e");
if (crc32("NpfjWhxqmedPJK",14) == 3413695131) strcat(s, "l");
if (crc32("tftInsPwDio",11) == 1343519015) strcat(s, "L");
if (crc32("LqpXdCaoENsbFX",14) == 739400928) strcat(s, "a");
if (crc32("TCgOlTQmfC",10) == 2171508513) strcat(s, "s");
if (crc32("lIbYWTXR",8) == 673486075) strcat(s, "P");
if (crc32("iDUKePsp",8) == 1576122119) strcat(s, "t");
if (crc32("GpoWtys",7) == 1045654650) strcat(s, "i");
if (crc32("DdisujmBgnZZcPc",15) == 3655232304) strcat(s, "c");
if (crc32("XxGWBleTQQNt",12) == 4199515712) strcat(s, "a");
if (crc32("rqxgryhgVj",10) == 2280541346) strcat(s, "l");
if (crc32("Lyopl",5) == 2751361898) strcat(s, "j");
if (crc32("hwQRYhkuj",9) == 335525638) strcat(s, "l");
if (crc32("WfkdakvRFwO",11) == 1577060048) strcat(s, "X");
if (crc32("PLoEPsW",7) == 3962205343) strcat(s, "y");
    return s;
}

char *nonrevocably_adverbs() {
    char *s = calloc(13);
    if (crc32("bjaNnpMkoWMd",12) == 1065047078) strcat(s, "t");
if (crc32("SCyWgYUBK",9) == 3063853845) strcat(s, "n");
if (crc32("dbmRANXhlXA",11) == 4145858682) strcat(s, "o");
if (crc32("kvbLBYgq",8) == 3773473999) strcat(s, "n");
if (crc32("EsAVMzRidLS",11) == 2555336847) strcat(s, "H");
if (crc32("hqRVUyq",7) == 4202078211) strcat(s, "r");
if (crc32("oTsMheAlZsqkeI",14) == 1656768766) strcat(s, "e");
if (crc32("PNFQTMA",7) == 4082887133) strcat(s, "F");
if (crc32("UZydcoafiE",10) == 2137445298) strcat(s, "v");
if (crc32("apouvMRTHPqqJCs",15) == 2569426015) strcat(s, "O");
if (crc32("tUXEIXqcQcbnWi",14) == 3515239892) strcat(s, "o");
if (crc32("YZhpkepFd",9) == 359819057) strcat(s, "c");
if (crc32("hVeYPAZZamhg",12) == 876128329) strcat(s, "n");
if (crc32("cKprs",5) == 3562108446) strcat(s, "a");
if (crc32("gGJVbKPKwlFCaO",14) == 875990355) strcat(s, "b");
if (crc32("bFZzXqREsKTGeiK",15) == 2024383228) strcat(s, "C");
if (crc32("YKmVAAIcaQZT",12) == 956797232) strcat(s, "l");
if (crc32("aqvaUZDvWbIJDOM",15) == 3054850536) strcat(s, "y");
    return s;
}

char *disbelievingly_adverbs() {
    char *s = calloc(15);
    if (crc32("SLxZhJocwof",11) == 1464205748) strcat(s, "k");
if (crc32("XSuuG",5) == 4281540704) strcat(s, "d");
if (crc32("EZwaRpYLSnaSs",13) == 1106472504) strcat(s, "j");
if (crc32("NSIONqcIrbPet",13) == 344908853) strcat(s, "i");
if (crc32("KcVcN",5) == 1998045273) strcat(s, "s");
if (crc32("hEejaXxmDBoBdU",14) == 308134548) strcat(s, "b");
if (crc32("mgfmXnLx",8) == 2435874739) strcat(s, "e");
if (crc32("wskusBfkhbtrPUN",15) == 3694206343) strcat(s, "l");
if (crc32("bCTUreRnhlCSR",13) == 3473606116) strcat(s, "i");
if (crc32("FZAzKIe",7) == 506434881) strcat(s, "J");
if (crc32("RQjCXPoiwGPsP",13) == 2262293464) strcat(s, "e");
if (crc32("MgxJvae",7) == 2164800673) strcat(s, "v");
if (crc32("wbcdTr",6) == 1131788433) strcat(s, "r");
if (crc32("ngLpiHNZp",9) == 2161701936) strcat(s, "i");
if (crc32("CAsmjDzrYmS",11) == 3972465075) strcat(s, "U");
if (crc32("OdgrlLVUFCpnr",13) == 2721777661) strcat(s, "n");
if (crc32("zLYDLbVJKAmowlp",15) == 982773668) strcat(s, "V");
if (crc32("qsOnVcuLi",9) == 132853561) strcat(s, "g");
if (crc32("sdrPK",5) == 3235148836) strcat(s, "l");
if (crc32("TFCDAEqPuZWiw",13) == 2848478681) strcat(s, "y");
    return s;
}

char *anticyclically_adverbs() {
    char *s = calloc(15);
    if (crc32("bLJDNVcGSuws",12) == 1398360589) strcat(s, "a");
if (crc32("cMwtupkr",8) == 889032060) strcat(s, "n");
if (crc32("dQqbmiKiTVazqCG",15) == 2625650658) strcat(s, "c");
if (crc32("vgrNRXYyWa",10) == 2983284049) strcat(s, "t");
if (crc32("JKaUhRYqFpcKGk",14) == 744122306) strcat(s, "i");
if (crc32("yeyXj",5) == 3124592215) strcat(s, "c");
if (crc32("cYiBXeoc",8) == 4139313378) strcat(s, "y");
if (crc32("bpOVbUxEVW",10) == 2797848171) strcat(s, "z");
if (crc32("sIwis",5) == 2999055368) strcat(s, "c");
if (crc32("OrlHFzD",7) == 3151067453) strcat(s, "l");
if (crc32("MiMjMIcz",8) == 3441379418) strcat(s, "w");
if (crc32("YWvdFFpPaTrt",12) == 671922778) strcat(s, "i");
if (crc32("gHiIwterJrhRbR",14) == 2437183540) strcat(s, "N");
if (crc32("AjTKMtsq",8) == 242812667) strcat(s, "c");
if (crc32("qgVTeDASBy",10) == 2695008124) strcat(s, "M");
if (crc32("eWWUO",5) == 2306274590) strcat(s, "a");
if (crc32("JFlWW",5) == 723946900) strcat(s, "l");
if (crc32("jdWntJc",7) == 4193077538) strcat(s, "C");
if (crc32("BsIzkQmkSfXq",12) == 1430666189) strcat(s, "l");
if (crc32("TMOpIXvHi",9) == 3316043487) strcat(s, "y");
    return s;
}

char *quasiprepositionally_adverbs() {
    char *s = calloc(21);
    if (crc32("TKEWWkvrcl",10) == 1679941716) strcat(s, "q");
if (crc32("xBLXoLWuL",9) == 2798556842) strcat(s, "B");
if (crc32("pbAmypGi",8) == 3110993528) strcat(s, "u");
if (crc32("QJgBQpbwMcHteX",14) == 1052837021) strcat(s, "a");
if (crc32("rHjyCKgUqHAS",12) == 551114958) strcat(s, "c");
if (crc32("jjiChoyamndLSG",14) == 3088737693) strcat(s, "s");
if (crc32("BDqMBVoKpmZ",11) == 1989854200) strcat(s, "i");
if (crc32("MIXgqMkoCoOe",12) == 1454987947) strcat(s, "p");
if (crc32("slpcNWdnp",9) == 2681697871) strcat(s, "r");
if (crc32("RGIYJktGdGNd",12) == 1182852280) strcat(s, "e");
if (crc32("uObmNo",6) == 2846318492) strcat(s, "S");
if (crc32("hdZdIZx",7) == 293002513) strcat(s, "p");
if (crc32("deiVplxLI",9) == 981000356) strcat(s, "o");
if (crc32("IGmIWy",6) == 425911748) strcat(s, "s");
if (crc32("JEXzzRYpjpepA",13) == 2105642833) strcat(s, "l");
if (crc32("xhZuzbHPp",9) == 3293369104) strcat(s, "i");
if (crc32("fgyOSfkG",8) == 4140956953) strcat(s, "Q");
if (crc32("bshcLvK",7) == 1841933168) strcat(s, "t");
if (crc32("KSYbDtYZjvQrD",13) == 1675339504) strcat(s, "R");
if (crc32("LLLwnur",7) == 2747030656) strcat(s, "i");
if (crc32("WVRrmaFcSUBQL",13) == 2575226370) strcat(s, "M");
if (crc32("crUrbNuhnFNzC",13) == 1130377133) strcat(s, "o");
if (crc32("dgNJdbBwDs",10) == 3208437645) strcat(s, "v");
if (crc32("wYyODWWnGqWRP",13) == 950757608) strcat(s, "n");
if (crc32("WOPlnwyaiELWTZs",15) == 4138357749) strcat(s, "Q");
if (crc32("YThusobRYkdtTvp",15) == 3313033702) strcat(s, "a");
if (crc32("jwoXZJWzWbpacV",14) == 3260429095) strcat(s, "x");
if (crc32("CTpWGboEPVm",11) == 4227118472) strcat(s, "l");
if (crc32("YLYPbdBGPauqxI",14) == 3520879736) strcat(s, "l");
if (crc32("lUZqNbK",7) == 676546208) strcat(s, "A");
if (crc32("DZTRsCsc",8) == 1097029105) strcat(s, "y");
    return s;
}

char *apperceptively_adverbs() {
    char *s = calloc(15);
    if (crc32("SaRSnomHwijVXd",14) == 2655256595) strcat(s, "a");
if (crc32("ryvtbjAByfAad",13) == 1820539086) strcat(s, "g");
if (crc32("iPusrhrSa",9) == 4057980752) strcat(s, "p");
if (crc32("DMJqsGumYq",10) == 2662627866) strcat(s, "p");
if (crc32("DClkYZqJJPcDEt",14) == 444521170) strcat(s, "t");
if (crc32("adFDwTEMmX",10) == 961110866) strcat(s, "e");
if (crc32("zrEjd",5) == 401215011) strcat(s, "r");
if (crc32("JPSBX",5) == 3597262079) strcat(s, "c");
if (crc32("KjpLUvZpJjuGm",13) == 2071211725) strcat(s, "E");
if (crc32("QIQFb",5) == 1303161505) strcat(s, "e");
if (crc32("DCqKazdmEFYabuB",15) == 226128442) strcat(s, "s");
if (crc32("ozYFdXtcMMMd",12) == 3248073167) strcat(s, "p");
if (crc32("wtNIDvMuGFzcP",13) == 3056459055) strcat(s, "t");
if (crc32("gKEmauZOyUqnWHl",15) == 2942714729) strcat(s, "i");
if (crc32("sNhdh",5) == 128425821) strcat(s, "v");
if (crc32("rbVtmbWktbqnwT",14) == 1199917936) strcat(s, "e");
if (crc32("nSOKPSP",7) == 3423138792) strcat(s, "l");
if (crc32("XcnxRXmjI",9) == 3513282816) strcat(s, "y");
    return s;
}

char *pervasively_adverbs() {
    char *s = calloc(12);
    if (crc32("popdAEiUzs",10) == 555921701) strcat(s, "p");
if (crc32("dMySLeStZCj",11) == 3107055297) strcat(s, "q");
if (crc32("OMQhFzhUW",9) == 2475260607) strcat(s, "e");
if (crc32("JbSJrkcFNItwSk",14) == 1975723173) strcat(s, "n");
if (crc32("xfBNQuPw",8) == 49486443) strcat(s, "r");
if (crc32("kXpTFrIYXOOoxZ",14) == 2188674883) strcat(s, "J");
if (crc32("FLuaQYgcJBaay",13) == 1180709642) strcat(s, "v");
if (crc32("eeNBOW",6) == 840050250) strcat(s, "a");
if (crc32("oIKMNlxawv",10) == 3077221337) strcat(s, "s");
if (crc32("LRPLfdo",7) == 1650165888) strcat(s, "S");
if (crc32("WpptcuupUzbI",12) == 694548016) strcat(s, "i");
if (crc32("AghvojmPkBGH",12) == 436669359) strcat(s, "v");
if (crc32("hQWtAP",6) == 910920377) strcat(s, "n");
if (crc32("zZwfFTceL",9) == 246243893) strcat(s, "e");
if (crc32("GRsrfKiWzZqxvS",14) == 2181170963) strcat(s, "E");
if (crc32("pysylPybQU",10) == 2953617975) strcat(s, "l");
if (crc32("LmeHUS",6) == 2687204869) strcat(s, "K");
if (crc32("jXIbHePCueJjMme",15) == 2747047119) strcat(s, "y");
    return s;
}

char *nonrespectably_adverbs() {
    char *s = calloc(15);
    if (crc32("kRHfC",5) == 271700232) strcat(s, "g");
if (crc32("scaCDxBB",8) == 894507709) strcat(s, "n");
if (crc32("etHCwyVsc",9) == 3281164271) strcat(s, "o");
if (crc32("XRrmgFTMJAOV",12) == 2222029427) strcat(s, "n");
if (crc32("AiZhsXOkKzFX",12) == 1190030537) strcat(s, "r");
if (crc32("rJarHfiXrnKg",12) == 2708049577) strcat(s, "z");
if (crc32("eboEBdawKSuIZy",14) == 3036032484) strcat(s, "e");
if (crc32("IadKdKCKhokMt",13) == 2028514455) strcat(s, "f");
if (crc32("JtrUDiQFfi",10) == 1480715285) strcat(s, "s");
if (crc32("QgDkMEksNQzDN",13) == 757995035) strcat(s, "n");
if (crc32("wrenIZDlOwLax",13) == 3766053220) strcat(s, "p");
if (crc32("mBGsSRnp",8) == 1284293407) strcat(s, "e");
if (crc32("ooONq",5) == 896687409) strcat(s, "y");
if (crc32("xgzWPXEgZ",9) == 3476457932) strcat(s, "c");
if (crc32("dQhGfHBg",8) == 2430176590) strcat(s, "s");
if (crc32("GfXIx",5) == 796305873) strcat(s, "t");
if (crc32("zRjMUyE",7) == 2971842294) strcat(s, "V");
if (crc32("AAbBkSpW",8) == 1569430501) strcat(s, "a");
if (crc32("dSdZiUId",8) == 1324015671) strcat(s, "P");
if (crc32("HlGPknoTosiHjh",14) == 3417080794) strcat(s, "b");
if (crc32("GVdYT",5) == 2318807862) strcat(s, "l");
if (crc32("enaxvzLGexR",11) == 1033300870) strcat(s, "l");
if (crc32("pfYkQhcBsymFyTv",15) == 368634878) strcat(s, "y");
    return s;
}

char *foolishly_adverbs() {
    char *s = calloc(10);
    if (crc32("tLjJwlDPThJxXfn",15) == 1613384736) strcat(s, "f");
if (crc32("hMJRpgRdsfhqeX",14) == 2032939469) strcat(s, "n");
if (crc32("YxTdjmqyRKG",11) == 735164543) strcat(s, "o");
if (crc32("wPyWZCCtA",9) == 999509431) strcat(s, "z");
if (crc32("rxsvwlsg",8) == 3474311527) strcat(s, "o");
if (crc32("FYbGEN",6) == 2773522034) strcat(s, "l");
if (crc32("YuhYe",5) == 3215319899) strcat(s, "i");
if (crc32("QsQew",5) == 342700952) strcat(s, "m");
if (crc32("zKJAlouij",9) == 2817130410) strcat(s, "s");
if (crc32("ByblCvfHxwRBl",13) == 4166094090) strcat(s, "h");
if (crc32("cSOsteTV",8) == 3708937486) strcat(s, "Z");
if (crc32("qkyJGRN",7) == 3642165659) strcat(s, "l");
if (crc32("ogqtNVwfysP",11) == 4216839479) strcat(s, "y");
    return s;
}

char *answerlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("OrPEPTvo",8) == 3104060721) strcat(s, "p");
if (crc32("hOVvj",5) == 270829518) strcat(s, "a");
if (crc32("gYvZSlmsOJEyeI",14) == 2775702491) strcat(s, "u");
if (crc32("kcxRhVFAvGa",11) == 1035890082) strcat(s, "n");
if (crc32("Mgext",5) == 1042475855) strcat(s, "s");
if (crc32("wPDPHIf",7) == 1769196117) strcat(s, "Q");
if (crc32("kMWPoo",6) == 1989988552) strcat(s, "w");
if (crc32("ZEZKfiYgz",9) == 3782018555) strcat(s, "d");
if (crc32("DTDDUjvXd",9) == 1547670442) strcat(s, "e");
if (crc32("JVTEPuRkUlUevY",14) == 926303962) strcat(s, "r");
if (crc32("vRTnPxwiWRuL",12) == 2823484056) strcat(s, "l");
if (crc32("DJPEZKTRBDLL",12) == 1236168207) strcat(s, "V");
if (crc32("qJRUhnpv",8) == 2123634990) strcat(s, "e");
if (crc32("eSlSQQSBcPnG",12) == 1217559411) strcat(s, "s");
if (crc32("kaFCI",5) == 1199228530) strcat(s, "o");
if (crc32("haaIRDXMOTFO",12) == 2277410373) strcat(s, "s");
if (crc32("FtvRMHHLJD",10) == 2220278155) strcat(s, "l");
if (crc32("TjvnyLFfmUPg",12) == 2897498697) strcat(s, "y");
    return s;
}

char *frenetically_adverbs() {
    char *s = calloc(13);
    if (crc32("BvIFmHoi",8) == 520639639) strcat(s, "f");
if (crc32("vRikpoPFKrvkOK",14) == 286549456) strcat(s, "r");
if (crc32("btZFXsZffvQ",11) == 1277302015) strcat(s, "e");
if (crc32("hHwLoluVQ",9) == 1157144439) strcat(s, "Q");
if (crc32("SZvpaoQfWIMYr",13) == 1432713022) strcat(s, "n");
if (crc32("ODndiUsZU",9) == 1728725659) strcat(s, "e");
if (crc32("kDuQFdrvPlz",11) == 1441334628) strcat(s, "c");
if (crc32("BEoXVansjpSQ",12) == 1449181145) strcat(s, "t");
if (crc32("BzMVaHYnZksh",12) == 274944747) strcat(s, "i");
if (crc32("duRGYdh",7) == 3707733283) strcat(s, "c");
if (crc32("IJQcxrpOfeayy",13) == 1594593177) strcat(s, "a");
if (crc32("iUUfPC",6) == 2335030006) strcat(s, "l");
if (crc32("yFLEwFTKnX",10) == 3827072278) strcat(s, "r");
if (crc32("jpozQlDLObN",11) == 2863899268) strcat(s, "l");
if (crc32("drKYEN",6) == 3737500073) strcat(s, "k");
if (crc32("HEGJr",5) == 3273875520) strcat(s, "y");
    return s;
}

char *unbeknown_adverbs() {
    char *s = calloc(10);
    if (crc32("gmFNgg",6) == 4169171725) strcat(s, "u");
if (crc32("pYpUOrfBae",10) == 1207859221) strcat(s, "n");
if (crc32("ItKaGjswjq",10) == 614967607) strcat(s, "b");
if (crc32("KFABxZIfiXGplEf",15) == 1284975277) strcat(s, "h");
if (crc32("BtytFJVazNlYg",13) == 681034341) strcat(s, "e");
if (crc32("uyNrcfhuZVtH",12) == 4268763377) strcat(s, "t");
if (crc32("jRhGm",5) == 3193635175) strcat(s, "k");
if (crc32("lKybydIwuVlRfco",15) == 680589458) strcat(s, "n");
if (crc32("TlYyyQzMFM",10) == 560689238) strcat(s, "o");
if (crc32("OOWRPSujPY",10) == 512940997) strcat(s, "E");
if (crc32("gQrZTJSLAFv",11) == 3879253553) strcat(s, "w");
if (crc32("TGWpeFWceofv",12) == 1223613540) strcat(s, "G");
if (crc32("GFYdQKt",7) == 1830672250) strcat(s, "n");
    return s;
}

char *unenviously_adverbs() {
    char *s = calloc(12);
    if (crc32("tzNHtgFeAg",10) == 1126207233) strcat(s, "u");
if (crc32("FCQQiuQkxXxvikV",15) == 3491334424) strcat(s, "L");
if (crc32("VIkMFbOvOxE",11) == 2567639154) strcat(s, "n");
if (crc32("NKzPYPaFngZBaw",14) == 3339878651) strcat(s, "e");
if (crc32("aTMpwedbiOLO",12) == 325696445) strcat(s, "n");
if (crc32("epWPLh",6) == 904539981) strcat(s, "v");
if (crc32("IxUHZ",5) == 3827553514) strcat(s, "i");
if (crc32("psRXeLrm",8) == 834697841) strcat(s, "j");
if (crc32("zeNvltslCodQmT",14) == 3395714885) strcat(s, "o");
if (crc32("yMzLESUxMzefeqi",15) == 3667680731) strcat(s, "u");
if (crc32("sPlDgK",6) == 2542395876) strcat(s, "K");
if (crc32("JBQXqWl",7) == 3498081183) strcat(s, "s");
if (crc32("tHPEDwh",7) == 2623802879) strcat(s, "E");
if (crc32("itQKsNBdmrq",11) == 2864938823) strcat(s, "l");
if (crc32("GOlqCAzT",8) == 452066005) strcat(s, "y");
if (crc32("WvNOKvgaEAKL",12) == 1600166049) strcat(s, "y");
    return s;
}

char *tactually_adverbs() {
    char *s = calloc(10);
    if (crc32("jeERfTQBe",9) == 1403745836) strcat(s, "l");
if (crc32("INIhyKkvlzS",11) == 3983071994) strcat(s, "t");
if (crc32("TAaVPtWZup",10) == 4019168215) strcat(s, "e");
if (crc32("zvLLjwkPp",9) == 2581393288) strcat(s, "a");
if (crc32("hjViwmfqGDgEu",13) == 3620967744) strcat(s, "s");
if (crc32("TUjWEgZrrLOng",13) == 100056104) strcat(s, "c");
if (crc32("rSViZvJLSof",11) == 3759618141) strcat(s, "t");
if (crc32("nNfYfEArsrZa",12) == 2048364146) strcat(s, "l");
if (crc32("WlTSQb",6) == 3590481885) strcat(s, "u");
if (crc32("wLedtkVeLyp",11) == 1821018820) strcat(s, "a");
if (crc32("tKiok",5) == 4184232249) strcat(s, "l");
if (crc32("KvNVLdueJnzBGN",14) == 3846496798) strcat(s, "l");
if (crc32("qvcqF",5) == 2949519433) strcat(s, "y");
    return s;
}

char *aquatically_adverbs() {
    char *s = calloc(12);
    if (crc32("JocwFcWozezhfwD",15) == 2951019899) strcat(s, "z");
if (crc32("lBTme",5) == 767818678) strcat(s, "a");
if (crc32("UWCQWIqCTcYw",12) == 1687622596) strcat(s, "q");
if (crc32("YCvqSSaMsL",10) == 347987847) strcat(s, "u");
if (crc32("WIgvS",5) == 3319018949) strcat(s, "d");
if (crc32("pAzBINufznK",11) == 1648405563) strcat(s, "a");
if (crc32("DJUNmytsPnlbmLY",15) == 85144235) strcat(s, "t");
if (crc32("clzXWLoZ",8) == 2527030890) strcat(s, "B");
if (crc32("QMsUAbrPFXPXKI",14) == 1629702230) strcat(s, "i");
if (crc32("EiYHISWbjggCn",13) == 3352605882) strcat(s, "k");
if (crc32("nXpnKSXrYmmgkc",14) == 2942847259) strcat(s, "c");
if (crc32("kGwneBFY",8) == 2455274346) strcat(s, "a");
if (crc32("hVREOj",6) == 803554673) strcat(s, "l");
if (crc32("UDPBuuzclw",10) == 2593973919) strcat(s, "l");
if (crc32("qWEij",5) == 994254586) strcat(s, "y");
    return s;
}

char *masochistically_adverbs() {
    char *s = calloc(16);
    if (crc32("PLwDuMazPViKY",13) == 2561956801) strcat(s, "z");
if (crc32("VLqfpDiNWObL",12) == 2476877083) strcat(s, "m");
if (crc32("OJXRWmEaKuBwHSM",15) == 488749245) strcat(s, "R");
if (crc32("bTzNWvogDb",10) == 1324331672) strcat(s, "a");
if (crc32("KPdBlclB",8) == 2900476685) strcat(s, "i");
if (crc32("ZSdIRBfio",9) == 3688107929) strcat(s, "s");
if (crc32("IGULGGytouqRuMw",15) == 3284559810) strcat(s, "o");
if (crc32("wnOsodxEzvhnUiG",15) == 619660625) strcat(s, "c");
if (crc32("knCViFYX",8) == 2742390204) strcat(s, "o");
if (crc32("xnolLaCOoWXBwpF",15) == 477829403) strcat(s, "h");
if (crc32("qmbzWGf",7) == 4134754602) strcat(s, "i");
if (crc32("JiUWYWDjksi",11) == 1063553814) strcat(s, "s");
if (crc32("KtXMUQdrUjyctVO",15) == 1849948324) strcat(s, "w");
if (crc32("KUpzPPoqoq",10) == 2664536609) strcat(s, "t");
if (crc32("xPvxEhWSPq",10) == 2756874834) strcat(s, "r");
if (crc32("NJMDe",5) == 80193577) strcat(s, "i");
if (crc32("batrOFwvLFKcI",13) == 1994733966) strcat(s, "S");
if (crc32("CGhWRSuEZOYoxh",14) == 1900818955) strcat(s, "c");
if (crc32("uQfpaaBiKSRS",12) == 3973727393) strcat(s, "c");
if (crc32("sukeRHb",7) == 222164848) strcat(s, "a");
if (crc32("PbpVgFnwjDgGqpW",15) == 704755310) strcat(s, "F");
if (crc32("xOirZfOucO",10) == 838153367) strcat(s, "l");
if (crc32("hwFsDodtYNbnZXz",15) == 3593558003) strcat(s, "Q");
if (crc32("ydpvxkt",7) == 1274816228) strcat(s, "l");
if (crc32("HcJTeJWkb",9) == 1132378230) strcat(s, "y");
    return s;
}

char *mosaically_adverbs() {
    char *s = calloc(11);
    if (crc32("hHkXdtFE",8) == 3275103072) strcat(s, "h");
if (crc32("SVcvZpVkgRTe",12) == 791672488) strcat(s, "m");
if (crc32("idbTFRszIwGlH",13) == 3206706942) strcat(s, "o");
if (crc32("DQhYJSaVCFZZT",13) == 1742960922) strcat(s, "I");
if (crc32("KnnLG",5) == 3301256293) strcat(s, "s");
if (crc32("sZaNbOPkprq",11) == 2605145375) strcat(s, "J");
if (crc32("TadfEgeioBTYs",13) == 312821864) strcat(s, "a");
if (crc32("XTmxSkCWoExERN",14) == 2115466784) strcat(s, "V");
if (crc32("zEqoTX",6) == 2684834383) strcat(s, "i");
if (crc32("PLZJd",5) == 244414203) strcat(s, "c");
if (crc32("ahOeYF",6) == 2286098273) strcat(s, "f");
if (crc32("JduhFPY",7) == 4257828128) strcat(s, "a");
if (crc32("hWCaZDgGkh",10) == 2876791027) strcat(s, "l");
if (crc32("AjKvPZVbrh",10) == 629692107) strcat(s, "l");
if (crc32("Udemz",5) == 2886358001) strcat(s, "y");
    return s;
}

char *nonsedentarily_adverbs() {
    char *s = calloc(15);
    if (crc32("FIbdfpnKFRNtdY",14) == 2035069101) strcat(s, "n");
if (crc32("dOjla",5) == 3747239272) strcat(s, "o");
if (crc32("EVGsVk",6) == 1547463671) strcat(s, "S");
if (crc32("lxzkBgAFJi",10) == 3620653153) strcat(s, "n");
if (crc32("KQuWhXrjPZ",10) == 3146531771) strcat(s, "s");
if (crc32("sHYYCmpwNgTAJi",14) == 1252739830) strcat(s, "e");
if (crc32("TEnMAQT",7) == 4130631631) strcat(s, "L");
if (crc32("MDuPIxjSIs",10) == 4294337472) strcat(s, "d");
if (crc32("PUYvEYB",7) == 2995819008) strcat(s, "L");
if (crc32("WiaKFYVBgqP",11) == 3000789738) strcat(s, "e");
if (crc32("LPQeVJmfPYGeX",13) == 1666695061) strcat(s, "A");
if (crc32("AKyeeCzOvlc",11) == 3016293355) strcat(s, "n");
if (crc32("XFUoCYokNU",10) == 510518161) strcat(s, "e");
if (crc32("PjlJhRpyJZmnPuB",15) == 216291296) strcat(s, "t");
if (crc32("FiPXxC",6) == 1567674000) strcat(s, "a");
if (crc32("UUUhtaR",7) == 3932286297) strcat(s, "U");
if (crc32("SeSGOx",6) == 4015567370) strcat(s, "r");
if (crc32("iAizHJ",6) == 1246475844) strcat(s, "i");
if (crc32("KyevFTJhDQhZd",13) == 3596116620) strcat(s, "L");
if (crc32("WrLUd",5) == 2041902117) strcat(s, "l");
if (crc32("ZXeOAFrwv",9) == 2390902240) strcat(s, "j");
if (crc32("gIbfJo",6) == 4215207717) strcat(s, "y");
    return s;
}

char *singlehandedly_adverbs() {
    char *s = calloc(15);
    if (crc32("unCDUqJdjbNQHv",14) == 3366003641) strcat(s, "s");
if (crc32("zsCKvIAN",8) == 1791283905) strcat(s, "i");
if (crc32("JrIzRODO",8) == 3819062280) strcat(s, "e");
if (crc32("tpnjiyULGhUEMI",14) == 2135002803) strcat(s, "n");
if (crc32("enXPZ",5) == 530781606) strcat(s, "g");
if (crc32("tRqLjSWNJQFxzj",14) == 3645142179) strcat(s, "l");
if (crc32("EFoeWbxxofc",11) == 2359716171) strcat(s, "B");
if (crc32("ethIAimwxYdO",12) == 457935150) strcat(s, "e");
if (crc32("wYTPl",5) == 2933882273) strcat(s, "h");
if (crc32("nZnRPQCpRltjBQL",15) == 3955199594) strcat(s, "P");
if (crc32("MNmsrTJLupR",11) == 2933058956) strcat(s, "a");
if (crc32("xYsOxvfkWr",10) == 3366192266) strcat(s, "n");
if (crc32("ydcXlVefgR",10) == 2165939797) strcat(s, "d");
if (crc32("jLoGdNDUqwPemM",14) == 757376322) strcat(s, "n");
if (crc32("jWNwkDOwvK",10) == 3813056460) strcat(s, "e");
if (crc32("koakRnrk",8) == 1546864524) strcat(s, "d");
if (crc32("BopJLewdptlWa",13) == 1290173925) strcat(s, "J");
if (crc32("rDjFlthm",8) == 4192267590) strcat(s, "l");
if (crc32("OLPzBmGSDRmBm",13) == 3844073786) strcat(s, "U");
if (crc32("EDKrtErC",8) == 843479092) strcat(s, "y");
    return s;
}

char *cogitatingly_adverbs() {
    char *s = calloc(13);
    if (crc32("WddAbWF",7) == 2255985574) strcat(s, "c");
if (crc32("ouCVsbvGJ",9) == 2016542700) strcat(s, "Q");
if (crc32("cpQyYtt",7) == 1073910082) strcat(s, "o");
if (crc32("rTYpYjrVLJbsnkz",15) == 2790336263) strcat(s, "g");
if (crc32("XgvCsKaBNI",10) == 1568469268) strcat(s, "i");
if (crc32("PoOpvFt",7) == 1471196422) strcat(s, "t");
if (crc32("tQYJwvNhaFmJM",13) == 3308661665) strcat(s, "p");
if (crc32("TXFvia",6) == 1312292203) strcat(s, "a");
if (crc32("ddzPcMiVgmjYOm",14) == 2712175067) strcat(s, "t");
if (crc32("iFVpNsmvDTRz",12) == 3498806256) strcat(s, "i");
if (crc32("hbuwixcpiqzM",12) == 1889582584) strcat(s, "n");
if (crc32("YjkTUJ",6) == 2677432449) strcat(s, "g");
if (crc32("PkAqNi",6) == 911147709) strcat(s, "M");
if (crc32("KHukKnDjTgFnIKj",15) == 3098870650) strcat(s, "l");
if (crc32("xWabLLlZHK",10) == 1017363931) strcat(s, "y");
    return s;
}

char *direly_adverbs() {
    char *s = calloc(7);
    if (crc32("VMPAMCWEfWzzW",13) == 1798046865) strcat(s, "v");
if (crc32("stOTd",5) == 1942203685) strcat(s, "d");
if (crc32("dzjRQNjpJl",10) == 3260104849) strcat(s, "q");
if (crc32("lxdBMmdsA",9) == 1035641923) strcat(s, "i");
if (crc32("ngzZxBEAnVX",11) == 1090967891) strcat(s, "F");
if (crc32("xvDnwmU",7) == 1945509651) strcat(s, "r");
if (crc32("HQfxf",5) == 3531410515) strcat(s, "e");
if (crc32("DPswJkOHPj",10) == 3885684827) strcat(s, "l");
if (crc32("QTxUpIpjDcEUDQ",14) == 2320683144) strcat(s, "y");
    return s;
}

char *arrantly_adverbs() {
    char *s = calloc(9);
    if (crc32("TFdPuPYeNvRTO",13) == 1440832844) strcat(s, "Q");
if (crc32("MXrGZgEfPdsz",12) == 2888445285) strcat(s, "a");
if (crc32("mQVDC",5) == 3008782628) strcat(s, "d");
if (crc32("iNTHSO",6) == 887688962) strcat(s, "r");
if (crc32("HlcEfeI",7) == 1708704394) strcat(s, "k");
if (crc32("NQskbtvKweafvf",14) == 2924179607) strcat(s, "r");
if (crc32("gJHLIDqO",8) == 3577632888) strcat(s, "e");
if (crc32("DMbexyZrBMzIe",13) == 3566804477) strcat(s, "a");
if (crc32("CdYBQXG",7) == 2286978866) strcat(s, "n");
if (crc32("UWPZYuLjwGDwIJ",14) == 2459447857) strcat(s, "P");
if (crc32("AzeZpeID",8) == 2545812334) strcat(s, "t");
if (crc32("KCNREK",6) == 3019738909) strcat(s, "l");
if (crc32("yjWdddfOPce",11) == 1109991327) strcat(s, "i");
if (crc32("JbXPWSWuMj",10) == 1073348099) strcat(s, "y");
    return s;
}

char *semiproductively_adverbs() {
    char *s = calloc(17);
    if (crc32("cWUmetG",7) == 3807493926) strcat(s, "s");
if (crc32("cBixqaYIOHSwjgw",15) == 3003623266) strcat(s, "I");
if (crc32("VGigWf",6) == 3680216258) strcat(s, "e");
if (crc32("rwusucMnfaFQs",13) == 4132255721) strcat(s, "E");
if (crc32("bmyDUB",6) == 2884042665) strcat(s, "m");
if (crc32("OIelUnXa",8) == 3128354896) strcat(s, "W");
if (crc32("YPZga",5) == 1225675469) strcat(s, "i");
if (crc32("QRmjFKlOq",9) == 1571153608) strcat(s, "p");
if (crc32("aVzAHPbSgyFkT",13) == 3701036653) strcat(s, "v");
if (crc32("NYcCzaqWTRQlpRi",15) == 488409904) strcat(s, "r");
if (crc32("nCzFZ",5) == 494564365) strcat(s, "o");
if (crc32("yGEsIAYNfKJgVL",14) == 3025378382) strcat(s, "d");
if (crc32("gIpyypXFPQomGF",14) == 4064379797) strcat(s, "u");
if (crc32("RCtxrEttUBlcq",13) == 1417101847) strcat(s, "c");
if (crc32("pUWWYldcpN",10) == 3049812913) strcat(s, "l");
if (crc32("AKqdTpHWYHS",11) == 3794585289) strcat(s, "t");
if (crc32("JrcWaZn",7) == 285096851) strcat(s, "i");
if (crc32("byXRYEKhwXv",11) == 2191474006) strcat(s, "K");
if (crc32("QIYPKPv",7) == 2978295741) strcat(s, "v");
if (crc32("cDgeOyoTFuRaH",13) == 2035782735) strcat(s, "e");
if (crc32("ogWbKxwGL",9) == 217563542) strcat(s, "l");
if (crc32("hgrBIISa",8) == 786603189) strcat(s, "D");
if (crc32("dMzGlUqN",8) == 3908194223) strcat(s, "y");
    return s;
}

char *relievedly_adverbs() {
    char *s = calloc(11);
    if (crc32("bgerunyYy",9) == 580733043) strcat(s, "r");
if (crc32("GOzaP",5) == 733372316) strcat(s, "z");
if (crc32("EEKsuByu",8) == 955017090) strcat(s, "e");
if (crc32("XmTCPqNUM",9) == 2707658446) strcat(s, "J");
if (crc32("hFxGqDVyq",9) == 1116770274) strcat(s, "l");
if (crc32("xWZlMRBIFyqcs",13) == 651971795) strcat(s, "i");
if (crc32("kEUphPJnECGMFd",14) == 3104641206) strcat(s, "F");
if (crc32("EEILEvpjPKKdnv",14) == 3747184485) strcat(s, "e");
if (crc32("PYTHUyNzA",9) == 4271392097) strcat(s, "T");
if (crc32("edBrTOvSP",9) == 2504514687) strcat(s, "v");
if (crc32("uzEeLIprpQVWI",13) == 1247618944) strcat(s, "e");
if (crc32("mNYoSnZT",8) == 3183000529) strcat(s, "d");
if (crc32("aYfIWDD",7) == 784112423) strcat(s, "X");
if (crc32("nTnedjwtRy",10) == 1532367171) strcat(s, "l");
if (crc32("EbIatNsnlacX",12) == 1980088312) strcat(s, "y");
    return s;
}

char *theocratically_adverbs() {
    char *s = calloc(15);
    if (crc32("kxepgWkp",8) == 2411837233) strcat(s, "t");
if (crc32("nRZdjxlSGKHe",12) == 3565212111) strcat(s, "h");
if (crc32("rUSKkYBvAafjK",13) == 3103642883) strcat(s, "e");
if (crc32("CnVXXRtpVrRNR",13) == 546752638) strcat(s, "d");
if (crc32("yDWPoYWIXXK",11) == 4047500330) strcat(s, "o");
if (crc32("BvzYbwqIzujpsO",14) == 802877464) strcat(s, "c");
if (crc32("tEiTGzE",7) == 2887811702) strcat(s, "r");
if (crc32("WxDnF",5) == 3632648916) strcat(s, "m");
if (crc32("HgdNWfnj",8) == 3916730840) strcat(s, "a");
if (crc32("BKUXFeZ",7) == 1997370017) strcat(s, "E");
if (crc32("EDGmqmcYrF",10) == 3100299219) strcat(s, "t");
if (crc32("msCFnLHaGWSfQ",13) == 3375130465) strcat(s, "f");
if (crc32("rptiSRERmXreXFe",15) == 4285126090) strcat(s, "i");
if (crc32("UcAVIjgzGPIM",12) == 668654684) strcat(s, "C");
if (crc32("kagpYNfyxju",11) == 3569362902) strcat(s, "c");
if (crc32("KZwybTUMqali",12) == 912543545) strcat(s, "a");
if (crc32("CSlWsesBvj",10) == 4011215511) strcat(s, "d");
if (crc32("XPEptrYnFuvfkf",14) == 3799228663) strcat(s, "l");
if (crc32("hbMcbSLjkfmdbZg",15) == 3951536483) strcat(s, "l");
if (crc32("RpGhpzelGlODSBT",15) == 2332488222) strcat(s, "y");
    return s;
}

char *cripplingly_adverbs() {
    char *s = calloc(12);
    if (crc32("gvuLpy",6) == 3491247956) strcat(s, "w");
if (crc32("hyBxYIF",7) == 1489569657) strcat(s, "c");
if (crc32("wEJVMyPtWt",10) == 3860961507) strcat(s, "r");
if (crc32("DLlIiRQF",8) == 192986319) strcat(s, "m");
if (crc32("RcvJOEvgOYZzK",13) == 1697481351) strcat(s, "i");
if (crc32("GogVXlAUfZPUSP",14) == 1665830565) strcat(s, "p");
if (crc32("dWciBLVyr",9) == 4143340082) strcat(s, "p");
if (crc32("LTxicvnn",8) == 2537691526) strcat(s, "l");
if (crc32("IWwbDUucr",9) == 588299098) strcat(s, "I");
if (crc32("dMWgfoAl",8) == 3731259766) strcat(s, "i");
if (crc32("RNClHXycDYX",11) == 2555320636) strcat(s, "n");
if (crc32("pSYgTKdiTiV",11) == 105020567) strcat(s, "g");
if (crc32("BjlNrnI",7) == 1670717811) strcat(s, "l");
if (crc32("jLKTbeRjuCKWy",13) == 2130176709) strcat(s, "K");
if (crc32("TxbjajIiGYRwms",14) == 2832597497) strcat(s, "y");
    return s;
}

char *exhypothesi_adverbs() {
    char *s = calloc(12);
    if (crc32("GFIOMSDuIbvt",12) == 1379402063) strcat(s, "R");
if (crc32("HvsrcYojKLsaD",13) == 3907420928) strcat(s, "e");
if (crc32("JrCFxDOwmm",10) == 4101834262) strcat(s, "a");
if (crc32("XHtsufJOynTCv",13) == 2909703551) strcat(s, "x");
if (crc32("lbGgCowK",8) == 2354752063) strcat(s, "h");
if (crc32("lXEAGLdT",8) == 3666741253) strcat(s, "y");
if (crc32("uJUaiAfezymAeU",14) == 3285359535) strcat(s, "p");
if (crc32("crPRIrSXQyMEVY",14) == 841691051) strcat(s, "n");
if (crc32("sYiiQIFkW",9) == 2967806578) strcat(s, "o");
if (crc32("KCfzkZUIKlrR",12) == 3960159383) strcat(s, "Z");
if (crc32("zbCqgV",6) == 2360301372) strcat(s, "t");
if (crc32("lGAJKbfSTrryJ",13) == 3737765015) strcat(s, "h");
if (crc32("jGzzeHUBvbDW",12) == 933739396) strcat(s, "e");
if (crc32("llsAcruesVVZz",13) == 93234100) strcat(s, "s");
if (crc32("ZBGEzkDAW",9) == 3766689352) strcat(s, "i");
if (crc32("AenXhI",6) == 1063675892) strcat(s, "i");
    return s;
}

char *unobservantly_adverbs() {
    char *s = calloc(14);
    if (crc32("bneSqlNbcLR",11) == 2981171886) strcat(s, "u");
if (crc32("asSYWDn",7) == 2739006488) strcat(s, "n");
if (crc32("yeZSlNbVwpLhia",14) == 1215771500) strcat(s, "o");
if (crc32("iwvaLQILMe",10) == 2269044086) strcat(s, "b");
if (crc32("lfJBiw",6) == 628046313) strcat(s, "s");
if (crc32("cguloY",6) == 4182674392) strcat(s, "e");
if (crc32("xMGJANOfq",9) == 1103026467) strcat(s, "r");
if (crc32("HNlCle",6) == 1119225300) strcat(s, "v");
if (crc32("ODiODwuHPWVkH",13) == 1652692496) strcat(s, "a");
if (crc32("CHGJpJiH",8) == 3553336198) strcat(s, "t");
if (crc32("aTCIfHhYsBVKt",13) == 722171429) strcat(s, "n");
if (crc32("sFdYptVaggBS",12) == 3014814435) strcat(s, "m");
if (crc32("eYYAITiAiB",10) == 1560239052) strcat(s, "t");
if (crc32("blnRV",5) == 485275318) strcat(s, "l");
if (crc32("jjFyMt",6) == 2976577542) strcat(s, "o");
if (crc32("xBHgeQHwbV",10) == 3314460377) strcat(s, "y");
    return s;
}

char *manfully_adverbs() {
    char *s = calloc(9);
    if (crc32("kNPTzvrZB",9) == 2739407695) strcat(s, "w");
if (crc32("CbnwAGjwd",9) == 1388811152) strcat(s, "m");
if (crc32("FivksjDvDU",10) == 1612871662) strcat(s, "e");
if (crc32("QWjrbemSLdsgp",13) == 1558208292) strcat(s, "a");
if (crc32("GeltcWfrR",9) == 1831459467) strcat(s, "F");
if (crc32("akQhSWmi",8) == 3392460002) strcat(s, "n");
if (crc32("tARufoglKjYK",12) == 3990992245) strcat(s, "f");
if (crc32("uLdDtITrLILugMR",15) == 2126564269) strcat(s, "u");
if (crc32("aHducSGYDUd",11) == 77410560) strcat(s, "l");
if (crc32("aWBkiSGFE",9) == 3683619830) strcat(s, "l");
if (crc32("reYGxNpe",8) == 2182748022) strcat(s, "b");
if (crc32("eLcOjurvn",9) == 3253139573) strcat(s, "y");
    return s;
}

char *semidramatically_adverbs() {
    char *s = calloc(17);
    if (crc32("guyKkIxSPgjv",12) == 43407679) strcat(s, "N");
if (crc32("WjXpKkZUxQYuWWr",15) == 2651051087) strcat(s, "s");
if (crc32("xacjqkM",7) == 3491564049) strcat(s, "e");
if (crc32("NOlgUlWbsvlXM",13) == 3445459902) strcat(s, "g");
if (crc32("ARIcuFXoF",9) == 4146609812) strcat(s, "m");
if (crc32("qqfSN",5) == 2646289417) strcat(s, "i");
if (crc32("mRGBHtxKN",9) == 3114799157) strcat(s, "E");
if (crc32("XiukEyS",7) == 91665499) strcat(s, "d");
if (crc32("SuGzkGx",7) == 3102969363) strcat(s, "h");
if (crc32("rFAVcnQ",7) == 434930872) strcat(s, "r");
if (crc32("VDcXSJmCfHD",11) == 3863760534) strcat(s, "u");
if (crc32("TkVjRzZ",7) == 4200272647) strcat(s, "a");
if (crc32("GkdvCYqtWB",10) == 2858516745) strcat(s, "v");
if (crc32("eEyhWqExOzHP",12) == 3419260337) strcat(s, "m");
if (crc32("yTuXoXzMjK",10) == 3518359501) strcat(s, "L");
if (crc32("tFwzlnOmemIWPUh",15) == 2995996296) strcat(s, "a");
if (crc32("WqdNX",5) == 3599002664) strcat(s, "U");
if (crc32("HHFdrGIWuv",10) == 1398698762) strcat(s, "t");
if (crc32("cUewhX",6) == 1823706525) strcat(s, "x");
if (crc32("IZJtOxJzT",9) == 2430951536) strcat(s, "i");
if (crc32("qKmDNlBvHCKsv",13) == 1608817994) strcat(s, "j");
if (crc32("dahJPUIsSxJtZH",14) == 992961868) strcat(s, "c");
if (crc32("JyYvccjWsytClRJ",15) == 2515523733) strcat(s, "I");
if (crc32("oOTBYPQNY",9) == 4015620381) strcat(s, "a");
if (crc32("VuEYP",5) == 3821800435) strcat(s, "w");
if (crc32("mNDWTUkFipKx",12) == 2197406784) strcat(s, "l");
if (crc32("GnkyqIafPbHqg",13) == 1734468728) strcat(s, "l");
if (crc32("cAkfyHaSLwOVzF",14) == 1989101616) strcat(s, "q");
if (crc32("mYjNXFmYzTG",11) == 822673444) strcat(s, "y");
    return s;
}

char *prototypically_adverbs() {
    char *s = calloc(15);
    if (crc32("ezRXzXX",7) == 3968191073) strcat(s, "p");
if (crc32("WtxYjw",6) == 157419545) strcat(s, "A");
if (crc32("qhXzgVCGb",9) == 326164557) strcat(s, "r");
if (crc32("kKvxkB",6) == 1226014480) strcat(s, "k");
if (crc32("gYlfTl",6) == 910785009) strcat(s, "o");
if (crc32("PlwwWxSFg",9) == 198243063) strcat(s, "u");
if (crc32("fdGYHjHSpY",10) == 2528263177) strcat(s, "t");
if (crc32("zqADjz",6) == 2754627376) strcat(s, "o");
if (crc32("GcOGYrxHbmVu",12) == 2157508507) strcat(s, "t");
if (crc32("vXKCEeYMvU",10) == 2088535628) strcat(s, "R");
if (crc32("gCnzAGqgGlnzG",13) == 2308767905) strcat(s, "y");
if (crc32("ixVGxa",6) == 101251096) strcat(s, "T");
if (crc32("ioOsgvEIozvpE",13) == 2388048784) strcat(s, "p");
if (crc32("rDxkNAJZuoDLgcx",15) == 2229405951) strcat(s, "i");
if (crc32("SLiQWnowO",9) == 911598592) strcat(s, "F");
if (crc32("qReCdIE",7) == 647331932) strcat(s, "c");
if (crc32("ytxhuLfwUAOEDa",14) == 306540227) strcat(s, "a");
if (crc32("TPIQZJEA",8) == 4023868331) strcat(s, "l");
if (crc32("dbGPTMrmsggIDB",14) == 2912181703) strcat(s, "x");
if (crc32("ouUBh",5) == 1794142105) strcat(s, "l");
if (crc32("xQAcIiO",7) == 3828255188) strcat(s, "y");
    return s;
}

char *illtemperedly_adverbs() {
    char *s = calloc(14);
    if (crc32("mNUykXygypT",11) == 1013116842) strcat(s, "V");
if (crc32("hmJPh",5) == 586373223) strcat(s, "i");
if (crc32("DsBhZaUocnhINvb",15) == 13403158) strcat(s, "l");
if (crc32("yJjLEHhER",9) == 2272011716) strcat(s, "L");
if (crc32("LsVeYisBndyxSz",14) == 945380725) strcat(s, "l");
if (crc32("GcWfJwCykDXL",12) == 4169746483) strcat(s, "t");
if (crc32("vCKRPfjMePPNBUV",15) == 993644307) strcat(s, "e");
if (crc32("iHbIGDIAQDtLss",14) == 1812339531) strcat(s, "m");
if (crc32("cRQqeyZDHLA",11) == 1450989178) strcat(s, "l");
if (crc32("JUKMAGWVhnVO",12) == 2515919914) strcat(s, "p");
if (crc32("yyIqqbZiWffVilD",15) == 2606843295) strcat(s, "e");
if (crc32("ZuDhPDJ",7) == 2087180463) strcat(s, "r");
if (crc32("GRCNFnDxB",9) == 2560196155) strcat(s, "g");
if (crc32("HTelhmlEBanQZO",14) == 2286864303) strcat(s, "e");
if (crc32("HblhsDTer",9) == 1258645531) strcat(s, "v");
if (crc32("lTHwBiyHIkiDaF",14) == 3857961907) strcat(s, "d");
if (crc32("pNkAowl",7) == 4008530706) strcat(s, "l");
if (crc32("bKSttMIEEOVbA",13) == 2739005628) strcat(s, "J");
if (crc32("RexdADUJkwM",11) == 1027599673) strcat(s, "y");
    return s;
}

char *dioeciously_adverbs() {
    char *s = calloc(12);
    if (crc32("eJNbQkCnzVJV",12) == 1459296560) strcat(s, "d");
if (crc32("dIcfCBivNoUJCK",14) == 3376296270) strcat(s, "i");
if (crc32("zqdmmprtPKirfFl",15) == 3976592562) strcat(s, "J");
if (crc32("VdbfYXJVezVoXf",14) == 1491468889) strcat(s, "o");
if (crc32("AwBVr",5) == 2483342945) strcat(s, "j");
if (crc32("EtEcgYdtHgsoA",13) == 4077910939) strcat(s, "e");
if (crc32("lQvLPzdrdJmQ",12) == 2544131530) strcat(s, "z");
if (crc32("QCVcmvvEmjh",11) == 2300632226) strcat(s, "c");
if (crc32("qezbwtKIJkJ",11) == 3662336240) strcat(s, "N");
if (crc32("GvLXhlNkpwYv",12) == 411261026) strcat(s, "i");
if (crc32("VdeYjPLyaRfkym",14) == 3592762648) strcat(s, "o");
if (crc32("tpLMGVoFR",9) == 3003355449) strcat(s, "u");
if (crc32("VSIyTIOVLKzj",12) == 601126612) strcat(s, "E");
if (crc32("vgJBCUFryUcn",12) == 2764567454) strcat(s, "s");
if (crc32("IqloWNocJODaWth",15) == 780215764) strcat(s, "a");
if (crc32("zjDJiIBtrzLRs",13) == 2551674960) strcat(s, "l");
if (crc32("QHYVRg",6) == 2617028734) strcat(s, "y");
    return s;
}

char *semiphenomenally_adverbs() {
    char *s = calloc(17);
    if (crc32("HmxCDhujO",9) == 3863786151) strcat(s, "s");
if (crc32("rzDIhPkbkF",10) == 1171171393) strcat(s, "I");
if (crc32("qMWhMQwHbybdu",13) == 3063043959) strcat(s, "e");
if (crc32("sJBshucRgAaDz",13) == 2140959332) strcat(s, "S");
if (crc32("KyQGZgJp",8) == 4137627633) strcat(s, "m");
if (crc32("ssvzwtCVXH",10) == 3833429718) strcat(s, "i");
if (crc32("JpPSorjbeNkLl",13) == 4151798654) strcat(s, "p");
if (crc32("hJBnqz",6) == 2929737578) strcat(s, "Y");
if (crc32("LMgMbeXHmShDcxY",15) == 500772218) strcat(s, "h");
if (crc32("jlKgUwCqG",9) == 3825986017) strcat(s, "c");
if (crc32("QtdpWFhv",8) == 3098641989) strcat(s, "e");
if (crc32("FHqMp",5) == 4174255824) strcat(s, "R");
if (crc32("EcCnmIEDcSbb",12) == 545927648) strcat(s, "n");
if (crc32("LDZAt",5) == 2423713080) strcat(s, "o");
if (crc32("HqrSyg",6) == 345779815) strcat(s, "m");
if (crc32("pAudUmtZ",8) == 4294216248) strcat(s, "h");
if (crc32("pExYDv",6) == 3395729439) strcat(s, "e");
if (crc32("hkpQSFIVPMnOF",13) == 2955209653) strcat(s, "K");
if (crc32("FhCgK",5) == 1450038265) strcat(s, "n");
if (crc32("JgLRp",5) == 3549970945) strcat(s, "a");
if (crc32("toGqZSYNb",9) == 1396904974) strcat(s, "u");
if (crc32("vNaZFdNNvgFT",12) == 1723204887) strcat(s, "l");
if (crc32("ZQACFmHcIjEe",12) == 2840474047) strcat(s, "l");
if (crc32("DPgfweT",7) == 835449275) strcat(s, "y");
    return s;
}

char *fragmentarily_adverbs() {
    char *s = calloc(14);
    if (crc32("BzzsYQp",7) == 3194055299) strcat(s, "f");
if (crc32("cmbUtPkLT",9) == 2096420687) strcat(s, "s");
if (crc32("UmGQkJE",7) == 2301353765) strcat(s, "r");
if (crc32("KVhdl",5) == 70702963) strcat(s, "a");
if (crc32("FEvtt",5) == 2892335129) strcat(s, "N");
if (crc32("EomQhEDQedzpKiy",15) == 3775809260) strcat(s, "g");
if (crc32("mnkuBFv",7) == 2611736487) strcat(s, "m");
if (crc32("KFVGOHUzicol",12) == 1885247739) strcat(s, "Z");
if (crc32("WDvhEUYUrlntzl",14) == 3070663899) strcat(s, "e");
if (crc32("JsfJymP",7) == 4066551635) strcat(s, "n");
if (crc32("qdlYOW",6) == 2373805139) strcat(s, "t");
if (crc32("MxIEXcXpbypM",12) == 2946323767) strcat(s, "a");
if (crc32("ehgdfCsWU",9) == 152607155) strcat(s, "r");
if (crc32("JleKNddfsT",10) == 270260571) strcat(s, "L");
if (crc32("fesOsIWEwrHrQbM",15) == 2093611688) strcat(s, "i");
if (crc32("uRldYpAcMXiP",12) == 562868211) strcat(s, "p");
if (crc32("GxJEfdEnWqSFkYu",15) == 2840600038) strcat(s, "l");
if (crc32("OvNPklMBCQ",10) == 3726038060) strcat(s, "B");
if (crc32("UdfCijipiPO",11) == 1636514032) strcat(s, "y");
    return s;
}

char *uncreatively_adverbs() {
    char *s = calloc(13);
    if (crc32("fabGvo",6) == 2343507309) strcat(s, "u");
if (crc32("XCeEjU",6) == 3369881061) strcat(s, "Z");
if (crc32("NQYtpuWGrBACW",13) == 513844746) strcat(s, "n");
if (crc32("froqDdgNBAECzBY",15) == 133538991) strcat(s, "m");
if (crc32("mKEAU",5) == 1873219529) strcat(s, "c");
if (crc32("CZnmMpW",7) == 145153739) strcat(s, "r");
if (crc32("aESppcRkh",9) == 957578989) strcat(s, "m");
if (crc32("RCgUNfif",8) == 3317675888) strcat(s, "e");
if (crc32("bVIdckzNE",9) == 1186758054) strcat(s, "a");
if (crc32("WNPyGNWfF",9) == 2535909014) strcat(s, "t");
if (crc32("ziBZPUSu",8) == 1714180055) strcat(s, "i");
if (crc32("nzKiqFuDGJMu",12) == 1802224176) strcat(s, "I");
if (crc32("sgezzmdPnv",10) == 1193204389) strcat(s, "v");
if (crc32("dHaGziwj",8) == 3783378352) strcat(s, "e");
if (crc32("HomfdjdJlHJqUr",14) == 3731217556) strcat(s, "S");
if (crc32("DnDiRaRbYGcWkg",14) == 1283023421) strcat(s, "l");
if (crc32("IkBHC",5) == 3683463598) strcat(s, "y");
    return s;
}

char *lightfully_adverbs() {
    char *s = calloc(11);
    if (crc32("wepawnWtjAM",11) == 2861367057) strcat(s, "W");
if (crc32("sWAZdgZT",8) == 3265662274) strcat(s, "l");
if (crc32("LQVtUVHVMgij",12) == 2181971833) strcat(s, "G");
if (crc32("SgmzsAcwZdADs",13) == 4145281784) strcat(s, "i");
if (crc32("LmTgACGNFpgFE",13) == 1201985814) strcat(s, "d");
if (crc32("XvgwPk",6) == 2954455741) strcat(s, "g");
if (crc32("aYDQnbDg",8) == 1152784790) strcat(s, "U");
if (crc32("mkMkYRBlwnYWnxI",15) == 303195248) strcat(s, "h");
if (crc32("tbFPP",5) == 2221406827) strcat(s, "a");
if (crc32("sZlwLBpE",8) == 2143911647) strcat(s, "t");
if (crc32("jlEoHDue",8) == 1783329634) strcat(s, "f");
if (crc32("HJjngAjb",8) == 457925122) strcat(s, "u");
if (crc32("llGlnJrYKX",10) == 1365586704) strcat(s, "Z");
if (crc32("MjNqDWDdCgjIFCD",15) == 649086162) strcat(s, "l");
if (crc32("HfPCYSIqsDcrIl",14) == 3723224109) strcat(s, "c");
if (crc32("ETVZFQ",6) == 382083470) strcat(s, "l");
if (crc32("LtsMBi",6) == 853788705) strcat(s, "y");
    return s;
}

char *mountainously_adverbs() {
    char *s = calloc(14);
    if (crc32("SCqLSCC",7) == 1234626153) strcat(s, "m");
if (crc32("VDqIyaQdYoRiFD",14) == 1401809876) strcat(s, "A");
if (crc32("nfAfFZuQAhZ",11) == 4114486405) strcat(s, "o");
if (crc32("sbXkX",5) == 1751729704) strcat(s, "u");
if (crc32("evrpMzbwc",9) == 2975897612) strcat(s, "n");
if (crc32("qxwgwRl",7) == 2246866119) strcat(s, "L");
if (crc32("NWvBtDmQXZPpRK",14) == 3164787689) strcat(s, "t");
if (crc32("slerPnHcQX",10) == 1609710115) strcat(s, "a");
if (crc32("GbIAfHe",7) == 801770833) strcat(s, "z");
if (crc32("GEUpoSQe",8) == 1713355190) strcat(s, "i");
if (crc32("FnYHhJnswraVPA",14) == 85941915) strcat(s, "n");
if (crc32("lTugiG",6) == 1318686303) strcat(s, "o");
if (crc32("zCOGSloGh",9) == 890365626) strcat(s, "u");
if (crc32("rpTmjAdyUjaD",12) == 543271027) strcat(s, "s");
if (crc32("KuuPMULNlStk",12) == 4208637226) strcat(s, "v");
if (crc32("aHSmH",5) == 4202599827) strcat(s, "l");
if (crc32("OqaJqjGzjv",10) == 3956996338) strcat(s, "j");
if (crc32("IeSXYxt",7) == 3056578703) strcat(s, "y");
    return s;
}

char *pyramidically_adverbs() {
    char *s = calloc(14);
    if (crc32("EoHwyDF",7) == 3155988217) strcat(s, "p");
if (crc32("KLSYtz",6) == 2738481595) strcat(s, "T");
if (crc32("gXyzAidFoTr",11) == 3844537939) strcat(s, "y");
if (crc32("Kzlxhua",7) == 2913567872) strcat(s, "r");
if (crc32("JTDKwqgDgg",10) == 1424627146) strcat(s, "a");
if (crc32("cHDNPdRdIWPvcS",14) == 605326893) strcat(s, "m");
if (crc32("gUdmk",5) == 2786239053) strcat(s, "Z");
if (crc32("RVcEXaa",7) == 2773818808) strcat(s, "i");
if (crc32("JhiXXQMZRKhR",12) == 213934753) strcat(s, "T");
if (crc32("HccRYKmi",8) == 3342884617) strcat(s, "d");
if (crc32("EeUWKXrrmvB",11) == 3644711821) strcat(s, "i");
if (crc32("MmarilPRoWUdt",13) == 814452338) strcat(s, "O");
if (crc32("WYizdULvL",9) == 3777658399) strcat(s, "c");
if (crc32("AucWKwMyXVYT",12) == 2657176195) strcat(s, "t");
if (crc32("DIpxdFjW",8) == 1906856775) strcat(s, "a");
if (crc32("etTPnmyJX",9) == 1883465132) strcat(s, "O");
if (crc32("YeVxajVKdWkkWMa",15) == 4100524810) strcat(s, "l");
if (crc32("WyzTxcZRzfw",11) == 2171139110) strcat(s, "m");
if (crc32("dZFMnFFv",8) == 2146434960) strcat(s, "l");
if (crc32("JXpdkrRerna",11) == 3591069929) strcat(s, "z");
if (crc32("dOrqAtVk",8) == 1196010715) strcat(s, "y");
    return s;
}

char *fluently_adverbs() {
    char *s = calloc(9);
    if (crc32("cyTDEpnbJ",9) == 185374350) strcat(s, "f");
if (crc32("LEQPOqEjqhcO",12) == 3328631642) strcat(s, "l");
if (crc32("FdEeWzqTRaeZZ",13) == 3979669821) strcat(s, "j");
if (crc32("czpYMAKB",8) == 3724969546) strcat(s, "u");
if (crc32("jWUJozIdprNOH",13) == 1921637097) strcat(s, "U");
if (crc32("vidBiWo",7) == 259088947) strcat(s, "e");
if (crc32("KMIyXDprEQo",11) == 295204646) strcat(s, "n");
if (crc32("RikLEVt",7) == 4096120951) strcat(s, "n");
if (crc32("LsxTlYarlFuB",12) == 1569898492) strcat(s, "t");
if (crc32("bdEyqXXyMlG",11) == 1896686334) strcat(s, "l");
if (crc32("ZdRMBW",6) == 1583573973) strcat(s, "y");
    return s;
}

char *sonorously_adverbs() {
    char *s = calloc(11);
    if (crc32("WCHGEDV",7) == 3428074824) strcat(s, "u");
if (crc32("ybiudIs",7) == 3456767603) strcat(s, "s");
if (crc32("SahiLAKQZJOY",12) == 3553860833) strcat(s, "o");
if (crc32("wVERx",5) == 3283358287) strcat(s, "n");
if (crc32("qdesLjhLcPqLVyB",15) == 2477593379) strcat(s, "o");
if (crc32("ncqLLuIV",8) == 1730878727) strcat(s, "r");
if (crc32("EAbUCRymkoOm",12) == 3950916953) strcat(s, "c");
if (crc32("MRXOWuUqgWcLN",13) == 834157846) strcat(s, "o");
if (crc32("DcCevSGgT",9) == 2324452891) strcat(s, "u");
if (crc32("doDQPhDGL",9) == 2355165372) strcat(s, "N");
if (crc32("BfdWXGlrsGb",11) == 2996186978) strcat(s, "s");
if (crc32("gBzrMnGeB",9) == 784854367) strcat(s, "U");
if (crc32("vurRtFTEjfn",11) == 3635702445) strcat(s, "l");
if (crc32("fabntTvZJ",9) == 376602482) strcat(s, "V");
if (crc32("khmLz",5) == 2051124981) strcat(s, "y");
    return s;
}

char *gaspingly_adverbs() {
    char *s = calloc(10);
    if (crc32("xxOOhal",7) == 2533595333) strcat(s, "k");
if (crc32("hTztuL",6) == 3803071971) strcat(s, "g");
if (crc32("ffWTrMYrKdxaH",13) == 1100275309) strcat(s, "f");
if (crc32("PTDJGMBKoqYE",12) == 1672132548) strcat(s, "a");
if (crc32("jNUEaevljWwQtt",14) == 1397232667) strcat(s, "y");
if (crc32("neGLSjCZf",9) == 2934211057) strcat(s, "s");
if (crc32("OabFqy",6) == 291178546) strcat(s, "p");
if (crc32("YbQfMeOhmU",10) == 151086524) strcat(s, "i");
if (crc32("cDGsPgomoT",10) == 776567365) strcat(s, "n");
if (crc32("KSkweGrgH",9) == 2888714354) strcat(s, "g");
if (crc32("DRpxyXfTJklr",12) == 2720254548) strcat(s, "l");
if (crc32("yijGOi",6) == 1796009602) strcat(s, "y");
    return s;
}

char *insistently_adverbs() {
    char *s = calloc(12);
    if (crc32("BaGRRyHekqOZYaJ",15) == 3713216561) strcat(s, "i");
if (crc32("OKLciQngLmyzf",13) == 3953161500) strcat(s, "n");
if (crc32("PoCVXaprqp",10) == 3412059109) strcat(s, "c");
if (crc32("eUBLYieSBJOIx",13) == 573203642) strcat(s, "s");
if (crc32("yBgHujEwmAmBzpc",15) == 707377264) strcat(s, "J");
if (crc32("PrgoRCvSOSBveaj",15) == 3185670581) strcat(s, "i");
if (crc32("FPSEMg",6) == 1774335435) strcat(s, "a");
if (crc32("lTumqZGRlJ",10) == 2371432786) strcat(s, "s");
if (crc32("DrTTPbHU",8) == 1248952588) strcat(s, "t");
if (crc32("YSPKhHkMlr",10) == 2440867479) strcat(s, "e");
if (crc32("PhSqUPZywyIzkb",14) == 2078170304) strcat(s, "b");
if (crc32("bQpSZUAWvqyWF",13) == 4148006651) strcat(s, "n");
if (crc32("CcDexvLEIKXhuoV",15) == 2817235510) strcat(s, "t");
if (crc32("pfjVbmyEOhB",11) == 358538756) strcat(s, "B");
if (crc32("UitoNRPbJjCnFx",14) == 3298386575) strcat(s, "l");
if (crc32("INjMSj",6) == 435651196) strcat(s, "K");
if (crc32("SLzKh",5) == 1641101217) strcat(s, "y");
    return s;
}

char *planographically_adverbs() {
    char *s = calloc(17);
    if (crc32("NeZDNnRpWRZWH",13) == 2652241949) strcat(s, "p");
if (crc32("IscUbGemZctKY",13) == 3311935093) strcat(s, "l");
if (crc32("pGkFy",5) == 775707726) strcat(s, "k");
if (crc32("YkErrp",6) == 3256008889) strcat(s, "a");
if (crc32("yOGWghnsd",9) == 60284726) strcat(s, "n");
if (crc32("fBQsPVnKAVvnnep",15) == 602717040) strcat(s, "o");
if (crc32("qlRMOQgvllsVMgv",15) == 3531397787) strcat(s, "j");
if (crc32("hlqXREIUnx",10) == 330519186) strcat(s, "g");
if (crc32("CQQayFfcvCMFuH",14) == 985661482) strcat(s, "f");
if (crc32("gqHieuVnlP",10) == 3023586010) strcat(s, "r");
if (crc32("BSCWTaVIm",9) == 1564452520) strcat(s, "u");
if (crc32("kXASzgS",7) == 3381890278) strcat(s, "a");
if (crc32("xjaJCWAuqPOFg",13) == 2557365435) strcat(s, "k");
if (crc32("NIZdWOOmkP",10) == 266693014) strcat(s, "p");
if (crc32("oidASCZaHmpLhF",14) == 3785040722) strcat(s, "A");
if (crc32("zMHbbNOYYJUv",12) == 2950274211) strcat(s, "h");
if (crc32("qviuKpVA",8) == 3067470793) strcat(s, "R");
if (crc32("QwYTTDvjJ",9) == 2221254327) strcat(s, "i");
if (crc32("UYeSKkK",7) == 1103442437) strcat(s, "S");
if (crc32("UbRoVLyRY",9) == 2791418615) strcat(s, "c");
if (crc32("TCoBUCi",7) == 1812476755) strcat(s, "a");
if (crc32("iFemzkzGsHdCG",13) == 3684994536) strcat(s, "m");
if (crc32("nLgpZDU",7) == 2423106828) strcat(s, "l");
if (crc32("XagmsecRWT",10) == 517460465) strcat(s, "Y");
if (crc32("TzIBBnTv",8) == 3805792120) strcat(s, "l");
if (crc32("QFgLk",5) == 3055186939) strcat(s, "y");
    return s;
}

char *certain_adverbs() {
    char *s = calloc(8);
    if (crc32("SsJntRfeL",9) == 459284382) strcat(s, "c");
if (crc32("OiwTBsaaoTmNU",13) == 297792625) strcat(s, "e");
if (crc32("WDPhbgZYqK",10) == 2828695890) strcat(s, "r");
if (crc32("TLvZYs",6) == 523861416) strcat(s, "h");
if (crc32("gGemZZOorL",10) == 620868617) strcat(s, "t");
if (crc32("LPeHuRxXPh",10) == 2332695307) strcat(s, "P");
if (crc32("jPwIfqGPP",9) == 437160866) strcat(s, "a");
if (crc32("NfqsbidAqHkTK",13) == 1244110704) strcat(s, "i");
if (crc32("xotycGcj",8) == 2158343958) strcat(s, "B");
if (crc32("cmvrEoSLUBmaZ",13) == 1867249649) strcat(s, "n");
    return s;
}

char *unuseably_adverbs() {
    char *s = calloc(10);
    if (crc32("aNFtySInvcr",11) == 577455071) strcat(s, "u");
if (crc32("fatGoqRgIHAvJ",13) == 3760118508) strcat(s, "J");
if (crc32("qOFemUKTkVIL",12) == 1276276472) strcat(s, "n");
if (crc32("ZevCzZwgc",9) == 4248333274) strcat(s, "D");
if (crc32("EaPIunnlRI",10) == 887149521) strcat(s, "u");
if (crc32("GLHgcYn",7) == 1290745520) strcat(s, "j");
if (crc32("BkTyKoiWmuRATD",14) == 3564155604) strcat(s, "s");
if (crc32("kmQWANTlxP",10) == 1194242811) strcat(s, "r");
if (crc32("mCfvH",5) == 1662587762) strcat(s, "e");
if (crc32("OppXuVQnbPcC",12) == 3778065050) strcat(s, "a");
if (crc32("LuiJPI",6) == 1197022107) strcat(s, "W");
if (crc32("qXHJIzPy",8) == 3367128995) strcat(s, "b");
if (crc32("NjNFZRCduT",10) == 2794454920) strcat(s, "l");
if (crc32("tTHFZida",8) == 1159271916) strcat(s, "C");
if (crc32("UtPHxUDeX",9) == 164682221) strcat(s, "y");
    return s;
}

char *divertingly_adverbs() {
    char *s = calloc(12);
    if (crc32("TrcMZLZAYz",10) == 400462965) strcat(s, "j");
if (crc32("CjsKe",5) == 4110948339) strcat(s, "d");
if (crc32("fydtdcr",7) == 3988717654) strcat(s, "y");
if (crc32("EtZAOJruwvaxu",13) == 1906797769) strcat(s, "i");
if (crc32("kyKLvtOFq",9) == 3718130568) strcat(s, "v");
if (crc32("NilrDC",6) == 1308078381) strcat(s, "e");
if (crc32("mctBMeVhnif",11) == 1784881047) strcat(s, "r");
if (crc32("bJkxSLcaVi",10) == 2150761158) strcat(s, "t");
if (crc32("nkJXWtJaGsApff",14) == 4142118506) strcat(s, "F");
if (crc32("fLRnnvSvXu",10) == 1425715797) strcat(s, "i");
if (crc32("kunzRFfUyo",10) == 1023398496) strcat(s, "n");
if (crc32("caOPXwbojVnNLmO",15) == 1044252320) strcat(s, "P");
if (crc32("YEFbG",5) == 2492456652) strcat(s, "g");
if (crc32("YKBGLhlCqrWaH",13) == 3247890477) strcat(s, "s");
if (crc32("MOqCTDoUjZ",10) == 3138278139) strcat(s, "l");
if (crc32("uFMsRVbJskS",11) == 2744757388) strcat(s, "C");
if (crc32("FkhXlJpMmVskd",13) == 1124677273) strcat(s, "y");
    return s;
}

char *enmasse_adverbs() {
    char *s = calloc(8);
    if (crc32("pzQswDcEcxBxIgZ",15) == 622474604) strcat(s, "e");
if (crc32("mbUGiX",6) == 709719269) strcat(s, "v");
if (crc32("EPGJM",5) == 3927060065) strcat(s, "n");
if (crc32("xLhxWGNhgBdOr",13) == 3375807995) strcat(s, "u");
if (crc32("Tyvngm",6) == 3351089171) strcat(s, "m");
if (crc32("mjqvtSUjijLiAk",14) == 2827630974) strcat(s, "a");
if (crc32("UIPErVGxSdeTS",13) == 883543954) strcat(s, "s");
if (crc32("wTSBFcAXRfjtgcR",15) == 2351163912) strcat(s, "s");
if (crc32("pZXXvl",6) == 2570375246) strcat(s, "e");
    return s;
}

char *itinerantly_adverbs() {
    char *s = calloc(12);
    if (crc32("KJlrk",5) == 2601302012) strcat(s, "i");
if (crc32("RTmuEvGzLvVd",12) == 2510676694) strcat(s, "t");
if (crc32("WOqCbqIgNi",10) == 604658280) strcat(s, "T");
if (crc32("tvPOwrweH",9) == 1196766003) strcat(s, "i");
if (crc32("yexCGlQEomZKmP",14) == 1501287438) strcat(s, "n");
if (crc32("LcQmcBVglaiPB",13) == 187908605) strcat(s, "e");
if (crc32("VBLteUelCowFFW",14) == 2729310560) strcat(s, "G");
if (crc32("uGiCoOrm",8) == 102718552) strcat(s, "r");
if (crc32("IRDOkVtzdLDfb",13) == 3340105236) strcat(s, "e");
if (crc32("arXoIBmMiuhSK",13) == 1212167280) strcat(s, "a");
if (crc32("hejyGRIaSDmV",12) == 162157980) strcat(s, "n");
if (crc32("kLCymozuBlDUX",13) == 2817382680) strcat(s, "t");
if (crc32("eOoSafqsitxjNs",14) == 2544290008) strcat(s, "z");
if (crc32("wMHsRtpV",8) == 618253269) strcat(s, "l");
if (crc32("xoIUoMCjP",9) == 3721457574) strcat(s, "y");
    return s;
}

char *unclassically_adverbs() {
    char *s = calloc(14);
    if (crc32("PTPxbHb",7) == 3167176654) strcat(s, "J");
if (crc32("QcNHtmMWegeQtT",14) == 1589863921) strcat(s, "u");
if (crc32("OfcmcACyh",9) == 1345199818) strcat(s, "r");
if (crc32("puupxFzJNBKah",13) == 2811829296) strcat(s, "n");
if (crc32("AooUBFtQb",9) == 3359552656) strcat(s, "c");
if (crc32("tyTdHPd",7) == 1583110781) strcat(s, "l");
if (crc32("FKkMLzeMDaWgish",15) == 3643203154) strcat(s, "Q");
if (crc32("pEqsvK",6) == 934030531) strcat(s, "a");
if (crc32("jyZfaehJTMYt",12) == 1860238793) strcat(s, "N");
if (crc32("esCRrJlnWN",10) == 230457461) strcat(s, "s");
if (crc32("QswkSvRhTqp",11) == 2533173131) strcat(s, "N");
if (crc32("ohSHPdw",7) == 2255146752) strcat(s, "s");
if (crc32("XkobUvk",7) == 2891633368) strcat(s, "i");
if (crc32("gsRAWCS",7) == 80210452) strcat(s, "c");
if (crc32("fOcXGetgInyHkl",14) == 177696917) strcat(s, "c");
if (crc32("ieHTzyClkFnp",12) == 3432548981) strcat(s, "o");
if (crc32("ygaYhRVOFpjTDfS",15) == 2535133910) strcat(s, "a");
if (crc32("KURIbjCRXGfPjX",14) == 998302432) strcat(s, "l");
if (crc32("yaPlVrLcvtBWm",13) == 3319305763) strcat(s, "t");
if (crc32("UkMOO",5) == 859231996) strcat(s, "l");
if (crc32("hPzdQeMkIaGVm",13) == 1743249020) strcat(s, "P");
if (crc32("KEdMdTbyWT",10) == 1840086783) strcat(s, "y");
    return s;
}

char *affrontedly_adverbs() {
    char *s = calloc(12);
    if (crc32("wpWvsiyOQ",9) == 3783372070) strcat(s, "k");
if (crc32("cMcQhQnpgcjuTYx",15) == 4077187883) strcat(s, "a");
if (crc32("ubyQKgqOZf",10) == 1671748077) strcat(s, "O");
if (crc32("VgQYpWu",7) == 4203396146) strcat(s, "f");
if (crc32("VRnLyNfzciDU",12) == 1420594744) strcat(s, "f");
if (crc32("kPnvkYxLIGln",12) == 3916243548) strcat(s, "M");
if (crc32("VnzFQtSQOqHOZSK",15) == 1069085999) strcat(s, "r");
if (crc32("BHwfhPEor",9) == 1393033192) strcat(s, "o");
if (crc32("XIjco",5) == 3463831895) strcat(s, "Y");
if (crc32("ueEuk",5) == 93447643) strcat(s, "n");
if (crc32("UtlXnvESMHFMvD",14) == 3439341123) strcat(s, "t");
if (crc32("PmWZUmiqGPkCtZ",14) == 3416215302) strcat(s, "d");
if (crc32("VbYiGO",6) == 549411616) strcat(s, "e");
if (crc32("cnPGHVRlqvB",11) == 2611667072) strcat(s, "a");
if (crc32("ltfnpxKlptIm",12) == 819662352) strcat(s, "d");
if (crc32("vmdSLj",6) == 2706471020) strcat(s, "u");
if (crc32("RFhjHBEEB",9) == 2121977699) strcat(s, "l");
if (crc32("RtyRoZsjgZCGdx",14) == 2924497650) strcat(s, "G");
if (crc32("mcQuISZcBUHuOSY",15) == 4106642291) strcat(s, "y");
    return s;
}

char *nonadjudicatively_adverbs() {
    char *s = calloc(18);
    if (crc32("BdInCxP",7) == 1437785294) strcat(s, "z");
if (crc32("aqRtQp",6) == 2004987567) strcat(s, "n");
if (crc32("fTYXW",5) == 2592616613) strcat(s, "h");
if (crc32("DMsQquDtBCnzZSB",15) == 1441301247) strcat(s, "o");
if (crc32("SbtXScww",8) == 2436330451) strcat(s, "p");
if (crc32("iLtUepMTEEwf",12) == 3239704624) strcat(s, "n");
if (crc32("AesPDI",6) == 2855785120) strcat(s, "a");
if (crc32("tFBkvQULlcNeVH",14) == 2419828400) strcat(s, "d");
if (crc32("ymtJzAyZRA",10) == 3187359860) strcat(s, "j");
if (crc32("AqsbKASWZMYoAXA",15) == 3758998220) strcat(s, "u");
if (crc32("wEaDwXRWXIpX",12) == 2011468464) strcat(s, "d");
if (crc32("ljQxaKcCPjv",11) == 3098919070) strcat(s, "i");
if (crc32("AbMrwRNOZpWCJts",15) == 2984887287) strcat(s, "X");
if (crc32("pPrKTLrKU",9) == 508304917) strcat(s, "c");
if (crc32("wrdsto",6) == 1348098323) strcat(s, "a");
if (crc32("xlgeRcCStQnOQJU",15) == 461518073) strcat(s, "t");
if (crc32("hSRFZEZZzNBc",12) == 3249536824) strcat(s, "i");
if (crc32("fwGgKZvxuHvCbi",14) == 3304188399) strcat(s, "j");
if (crc32("mHUOGK",6) == 3020479000) strcat(s, "v");
if (crc32("HOadKYMmo",9) == 3444673251) strcat(s, "e");
if (crc32("ZvGFFgVLLsfkc",13) == 777585369) strcat(s, "e");
if (crc32("CZYMskDO",8) == 2164888810) strcat(s, "l");
if (crc32("sNWNpri",7) == 4191217881) strcat(s, "y");
    return s;
}

char *viperishly_adverbs() {
    char *s = calloc(11);
    if (crc32("vXPdPeiUkpNgHvX",15) == 3329394651) strcat(s, "v");
if (crc32("BpVDsRJmXEop",12) == 3935014047) strcat(s, "f");
if (crc32("GhCWnzBMukLM",12) == 2513386569) strcat(s, "i");
if (crc32("aiXsdgjnRUnEH",13) == 2033246786) strcat(s, "p");
if (crc32("FkVesTNsvYS",11) == 4170158168) strcat(s, "e");
if (crc32("dWZzZpPjUabjP",13) == 4118025859) strcat(s, "S");
if (crc32("oueeEADdbE",10) == 134514182) strcat(s, "r");
if (crc32("IJNsmfQhOGNDpz",14) == 2865465333) strcat(s, "i");
if (crc32("zXCIQ",5) == 888311433) strcat(s, "s");
if (crc32("mdBRBNpxVYve",12) == 2675217347) strcat(s, "h");
if (crc32("SWdysPPZ",8) == 2459796360) strcat(s, "Y");
if (crc32("oHtjPt",6) == 1814929128) strcat(s, "l");
if (crc32("JEguwITTHfeEiGY",15) == 2246604792) strcat(s, "y");
    return s;
}

char *neurotically_adverbs() {
    char *s = calloc(13);
    if (crc32("CYFbARLDQdHPAwQ",15) == 3680300096) strcat(s, "n");
if (crc32("FrletZFBRGi",11) == 845738908) strcat(s, "e");
if (crc32("ywddd",5) == 2966587546) strcat(s, "I");
if (crc32("wXnUvdgrxuI",11) == 1852420556) strcat(s, "u");
if (crc32("GoKHHVdOyJy",11) == 4090375624) strcat(s, "M");
if (crc32("woUuZBahNsnw",12) == 1759066080) strcat(s, "r");
if (crc32("bcLhcxKdx",9) == 4268570764) strcat(s, "o");
if (crc32("supxFD",6) == 3943253261) strcat(s, "t");
if (crc32("rtRDqLjgOMiLK",13) == 2950167874) strcat(s, "i");
if (crc32("BubpplQoebNQPYn",15) == 1838378211) strcat(s, "c");
if (crc32("ojMJPiCiCI",10) == 3667345151) strcat(s, "a");
if (crc32("dVZHyQgcJguL",12) == 438339570) strcat(s, "k");
if (crc32("UEnLjtqzs",9) == 1653787147) strcat(s, "l");
if (crc32("ctnGnYYpJDgTn",13) == 3104996904) strcat(s, "l");
if (crc32("vVfLXXVzwOUrnZI",15) == 146598249) strcat(s, "y");
    return s;
}

char *unfoully_adverbs() {
    char *s = calloc(9);
    if (crc32("BIRjnQ",6) == 224696364) strcat(s, "x");
if (crc32("sUQas",5) == 1545055349) strcat(s, "u");
if (crc32("sjIBcOPuktwxUME",15) == 2639310162) strcat(s, "n");
if (crc32("RQmfFKnJvMWb",12) == 1814020508) strcat(s, "p");
if (crc32("NKKfM",5) == 720461092) strcat(s, "f");
if (crc32("UIQVkgd",7) == 3624073654) strcat(s, "U");
if (crc32("VmUiXgtCkrPOwI",14) == 960529246) strcat(s, "o");
if (crc32("iSWeWQlKiJ",10) == 943402796) strcat(s, "u");
if (crc32("TJRKGGthnEvxWp",14) == 40762202) strcat(s, "I");
if (crc32("fCKhdETv",8) == 1866251444) strcat(s, "l");
if (crc32("FvnVlElO",8) == 2823805545) strcat(s, "l");
if (crc32("qAtpPvczJC",10) == 405848451) strcat(s, "y");
    return s;
}

char *trivially_adverbs() {
    char *s = calloc(10);
    if (crc32("ToUmBs",6) == 2317394236) strcat(s, "t");
if (crc32("QlAMSwJULC",10) == 600777693) strcat(s, "r");
if (crc32("qqoZaYpuvEnUE",13) == 2286296525) strcat(s, "V");
if (crc32("fkylxTksFHsLzMI",15) == 3572366715) strcat(s, "i");
if (crc32("kONHLN",6) == 168229900) strcat(s, "L");
if (crc32("BbgOYbywNwQik",13) == 829482429) strcat(s, "v");
if (crc32("ftJIc",5) == 3196664575) strcat(s, "v");
if (crc32("AVsplVgcoxmRwG",14) == 3183828288) strcat(s, "i");
if (crc32("DVfxzDTrfnNZ",12) == 647883304) strcat(s, "d");
if (crc32("SnDOERdtai",10) == 2297356858) strcat(s, "a");
if (crc32("QjSWoRhyn",9) == 1453971631) strcat(s, "M");
if (crc32("xrjpClPuBJaLcp",14) == 2127712173) strcat(s, "l");
if (crc32("bMInZFDwnr",10) == 2382747627) strcat(s, "l");
if (crc32("UHMfxwy",7) == 2732702217) strcat(s, "y");
    return s;
}

char *soaringly_adverbs() {
    char *s = calloc(10);
    if (crc32("cdVONQ",6) == 433111158) strcat(s, "E");
if (crc32("POWVyNhr",8) == 1535350136) strcat(s, "s");
if (crc32("dakfL",5) == 558191533) strcat(s, "o");
if (crc32("dPezCbYhXYLox",13) == 3222446949) strcat(s, "v");
if (crc32("APJjoGCnJLezmrs",15) == 48288515) strcat(s, "a");
if (crc32("BDANAorfhsJ",11) == 3578966418) strcat(s, "r");
if (crc32("YMQwFtiE",8) == 305570747) strcat(s, "o");
if (crc32("cRPDFlSBLBRM",12) == 391178346) strcat(s, "i");
if (crc32("YVkHl",5) == 627164774) strcat(s, "n");
if (crc32("SWvYDqo",7) == 1096097489) strcat(s, "i");
if (crc32("tKmlBdUuy",9) == 762804677) strcat(s, "g");
if (crc32("xZPrILo",7) == 290728747) strcat(s, "F");
if (crc32("OUuqPGh",7) == 19985908) strcat(s, "l");
if (crc32("iaWykQRIs",9) == 278393067) strcat(s, "m");
if (crc32("aIZyVsY",7) == 2197449360) strcat(s, "y");
    return s;
}

char *lumpingly_adverbs() {
    char *s = calloc(10);
    if (crc32("HsjtPZPPCZk",11) == 619327117) strcat(s, "V");
if (crc32("BIWoEX",6) == 1532946812) strcat(s, "l");
if (crc32("EnSVUVG",7) == 1180355669) strcat(s, "u");
if (crc32("KAYPgFEfeJRkMGw",15) == 150226898) strcat(s, "R");
if (crc32("IkpCYviN",8) == 219339099) strcat(s, "m");
if (crc32("zLQtaAgpDhvt",12) == 3575965504) strcat(s, "p");
if (crc32("zHsBmuHAQGwWk",13) == 3285708536) strcat(s, "p");
if (crc32("yrAucZqh",8) == 1695117552) strcat(s, "i");
if (crc32("fDBCXBnpWK",10) == 3352357756) strcat(s, "d");
if (crc32("wStXmAqavjpqoc",14) == 2844301197) strcat(s, "n");
if (crc32("vnFCUdoYVXOnKcb",15) == 3608116354) strcat(s, "O");
if (crc32("DfuUDTspLKOYWU",14) == 4256752167) strcat(s, "g");
if (crc32("tewIcWt",7) == 3325853687) strcat(s, "P");
if (crc32("WAbpnJcSgfpobho",15) == 1345611812) strcat(s, "l");
if (crc32("KBBqh",5) == 3729782400) strcat(s, "y");
    return s;
}

char *unlanguidly_adverbs() {
    char *s = calloc(12);
    if (crc32("pQdeueUm",8) == 1750463514) strcat(s, "u");
if (crc32("YCJFGuZsR",9) == 1850693632) strcat(s, "B");
if (crc32("OjKRLwyE",8) == 3844248695) strcat(s, "n");
if (crc32("PXywS",5) == 968139579) strcat(s, "l");
if (crc32("uImCsfDwZ",9) == 1779714449) strcat(s, "Y");
if (crc32("CLOJXE",6) == 1872973335) strcat(s, "a");
if (crc32("YqIbjVCucYSQr",13) == 694019603) strcat(s, "n");
if (crc32("gpslKcCBGQoPxgn",15) == 370339970) strcat(s, "s");
if (crc32("GehgjUAbomp",11) == 3662402815) strcat(s, "g");
if (crc32("bmFaGMPYLFHMEH",14) == 294407955) strcat(s, "C");
if (crc32("RYHqiAFlkRdjKT",14) == 2039651557) strcat(s, "u");
if (crc32("OCYES",5) == 2300666215) strcat(s, "i");
if (crc32("ZhNtA",5) == 1389687648) strcat(s, "O");
if (crc32("JjmGgVmLQkN",11) == 1231331005) strcat(s, "d");
if (crc32("AcdJdfpIIVGElD",14) == 2806504690) strcat(s, "B");
if (crc32("TRfCMJEc",8) == 2352748353) strcat(s, "l");
if (crc32("VnyPGS",6) == 4008877776) strcat(s, "P");
if (crc32("BwgmEJORQiQVLw",14) == 3697546080) strcat(s, "y");
    return s;
}

char *precisely_adverbs() {
    char *s = calloc(10);
    if (crc32("MvLow",5) == 2106684406) strcat(s, "p");
if (crc32("NQQZZguajLh",11) == 1656292639) strcat(s, "r");
if (crc32("FwhTW",5) == 900715463) strcat(s, "d");
if (crc32("sqAujfWO",8) == 4086043540) strcat(s, "e");
if (crc32("GrVhmsDLNBtJ",12) == 2160714023) strcat(s, "g");
if (crc32("OLGZhLOIwlbChrw",15) == 3291539983) strcat(s, "c");
if (crc32("VDQQLPcEO",9) == 2132079046) strcat(s, "i");
if (crc32("hAMZhWqD",8) == 2512518805) strcat(s, "s");
if (crc32("AlPwVvBlh",9) == 2641245076) strcat(s, "e");
if (crc32("gmVSCAnDFaGxpsq",15) == 2298296505) strcat(s, "R");
if (crc32("GfQhMIWNmtD",11) == 2830382412) strcat(s, "l");
if (crc32("ooSfkDfNkH",10) == 1007986305) strcat(s, "Y");
if (crc32("ZWAVo",5) == 2733602432) strcat(s, "y");
    return s;
}

char *shimmeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("ggWcefvGlbnIGX",14) == 2398635991) strcat(s, "I");
if (crc32("ahQIbnXwIPEgx",13) == 82087676) strcat(s, "s");
if (crc32("HtVNoNjxU",9) == 3346717475) strcat(s, "L");
if (crc32("zzMrtDFaEHFfmVu",15) == 1680641989) strcat(s, "h");
if (crc32("nXecnUJsR",9) == 2234424346) strcat(s, "i");
if (crc32("dMFURgDUPJMSN",13) == 3501579657) strcat(s, "m");
if (crc32("UGRrbivKxpP",11) == 3141204905) strcat(s, "m");
if (crc32("bFIgXxLmOpf",11) == 195571840) strcat(s, "e");
if (crc32("BaQTsbpcKIzevxY",15) == 3674021667) strcat(s, "U");
if (crc32("UhzVQWylOeCHVq",14) == 1416500802) strcat(s, "r");
if (crc32("whVnVJsiIBWkZ",13) == 1041439279) strcat(s, "g");
if (crc32("rWbOAwJJ",8) == 473149944) strcat(s, "i");
if (crc32("UNwHqsaGjgnp",12) == 211097773) strcat(s, "n");
if (crc32("HlmqBZzJcArIMmL",15) == 3008680200) strcat(s, "g");
if (crc32("aRjBm",5) == 2056710458) strcat(s, "U");
if (crc32("lMvnJESIhNgU",12) == 3759931200) strcat(s, "l");
if (crc32("yjfKFy",6) == 1399447216) strcat(s, "X");
if (crc32("vDCWpibc",8) == 334435577) strcat(s, "y");
    return s;
}

char *glibly_adverbs() {
    char *s = calloc(7);
    if (crc32("BztIuS",6) == 1082342466) strcat(s, "l");
if (crc32("fYzOzvWNLwlouU",14) == 3240707374) strcat(s, "g");
if (crc32("FTwjLLVE",8) == 3673839582) strcat(s, "l");
if (crc32("CKfHPPPFQ",9) == 1919540485) strcat(s, "B");
if (crc32("TIpFkkAmt",9) == 1051366702) strcat(s, "i");
if (crc32("IgKJvAWp",8) == 1343489236) strcat(s, "A");
if (crc32("zgRIBbyg",8) == 1432554018) strcat(s, "b");
if (crc32("SdxPM",5) == 1764193990) strcat(s, "K");
if (crc32("UrVTODRpTnXQLPC",15) == 1737712483) strcat(s, "l");
if (crc32("ZHXvplqse",9) == 3533134563) strcat(s, "y");
    return s;
}

char *convivially_adverbs() {
    char *s = calloc(12);
    if (crc32("HbEjyGAAo",9) == 339415799) strcat(s, "A");
if (crc32("aowtbC",6) == 1946606694) strcat(s, "c");
if (crc32("YBiOUCERtnqzwQs",15) == 2539539407) strcat(s, "e");
if (crc32("eDmMXFVy",8) == 3874637269) strcat(s, "o");
if (crc32("IYdXvLpJK",9) == 1498156638) strcat(s, "n");
if (crc32("ccnOo",5) == 3649465156) strcat(s, "v");
if (crc32("yfocglsvsN",10) == 2156471033) strcat(s, "i");
if (crc32("lkcCdXMsxLkkR",13) == 1668469315) strcat(s, "o");
if (crc32("nGLDOLpchv",10) == 247486721) strcat(s, "v");
if (crc32("oEovvySKMMqSWF",14) == 2273053197) strcat(s, "h");
if (crc32("UVsGC",5) == 3740137529) strcat(s, "i");
if (crc32("cGXZvUF",7) == 2444460360) strcat(s, "a");
if (crc32("pfLHC",5) == 2403868302) strcat(s, "l");
if (crc32("ZEWeVFCuXRINqu",14) == 3319273928) strcat(s, "l");
if (crc32("isyNxLBYGprdu",13) == 355475684) strcat(s, "y");
if (crc32("nAHUSExG",8) == 4050654013) strcat(s, "y");
    return s;
}

char *Sabbatically_adverbs() {
    char *s = calloc(13);
    if (crc32("xqrhyFYQe",9) == 3849372154) strcat(s, "S");
if (crc32("osQKNY",6) == 3367286578) strcat(s, "E");
if (crc32("OaUcxs",6) == 1932926582) strcat(s, "a");
if (crc32("axJyRhPrmzZXC",13) == 1600008466) strcat(s, "c");
if (crc32("sQwQiXIiUTMgaf",14) == 3687728279) strcat(s, "b");
if (crc32("qSIMxwbwqi",10) == 3431486841) strcat(s, "b");
if (crc32("WwYdIBkHKJFGFgG",15) == 3373513174) strcat(s, "W");
if (crc32("UzEUGdYAxlW",11) == 1744905084) strcat(s, "a");
if (crc32("cclZOiwXdTCEY",13) == 2876809024) strcat(s, "q");
if (crc32("ZOhNW",5) == 2865189976) strcat(s, "t");
if (crc32("AXRBYyEYqsKui",13) == 3425285053) strcat(s, "S");
if (crc32("VROicifbG",9) == 107961467) strcat(s, "i");
if (crc32("BRXyvGz",7) == 3340472265) strcat(s, "g");
if (crc32("kPQUGGDfNfjG",12) == 1422704404) strcat(s, "c");
if (crc32("FEGSCq",6) == 2831371422) strcat(s, "H");
if (crc32("yuWVZrRxjQIW",12) == 3446106483) strcat(s, "a");
if (crc32("lpiHwQioHQ",10) == 1385137194) strcat(s, "l");
if (crc32("hEvrLLf",7) == 1285131163) strcat(s, "l");
if (crc32("RakAIBUGP",9) == 749432837) strcat(s, "V");
if (crc32("DqJkRfqY",8) == 3406198507) strcat(s, "y");
    return s;
}

char *neer_adverbs() {
    char *s = calloc(5);
    if (crc32("gCNCoqu",7) == 1628669237) strcat(s, "n");
if (crc32("vaAICdQgq",9) == 2014155069) strcat(s, "e");
if (crc32("svdUzcBIuBe",11) == 1151574319) strcat(s, "e");
if (crc32("QFswwcsPICFVjKF",15) == 3609167356) strcat(s, "r");
    return s;
}

char *prandially_adverbs() {
    char *s = calloc(11);
    if (crc32("NoEvvrBWso",10) == 3514735492) strcat(s, "p");
if (crc32("NIstN",5) == 1038774586) strcat(s, "k");
if (crc32("dpHJpqOQ",8) == 2032335289) strcat(s, "r");
if (crc32("glwUFpdtOsf",11) == 799279734) strcat(s, "a");
if (crc32("CdpZeN",6) == 3611750499) strcat(s, "n");
if (crc32("UQkpwxA",7) == 420337873) strcat(s, "d");
if (crc32("iqENWMxt",8) == 1826596313) strcat(s, "N");
if (crc32("OZhIarEEnw",10) == 384065237) strcat(s, "i");
if (crc32("QQPkOlBWNqpIXs",14) == 4143679990) strcat(s, "a");
if (crc32("OPjBNEz",7) == 2263133931) strcat(s, "l");
if (crc32("eKsiv",5) == 1001970975) strcat(s, "u");
if (crc32("nXyrIMuGesuB",12) == 2653268346) strcat(s, "l");
if (crc32("dgosD",5) == 977914507) strcat(s, "y");
    return s;
}

char *unimperiously_adverbs() {
    char *s = calloc(14);
    if (crc32("JpTfhrrBJ",9) == 1670725864) strcat(s, "u");
if (crc32("QUOjHfGZO",9) == 551967832) strcat(s, "n");
if (crc32("mcvsL",5) == 2769760096) strcat(s, "i");
if (crc32("cVioaek",7) == 3806760061) strcat(s, "p");
if (crc32("UIpWlyICEEuaS",13) == 2726412037) strcat(s, "m");
if (crc32("meNEkzSOgh",10) == 3787051024) strcat(s, "p");
if (crc32("NJPgdPTmxgm",11) == 4205314817) strcat(s, "e");
if (crc32("yjkrPQdH",8) == 3342804587) strcat(s, "r");
if (crc32("lpVGwhNqIQwFHr",14) == 807469772) strcat(s, "d");
if (crc32("RnKmugGTQPUuOvr",15) == 343163701) strcat(s, "i");
if (crc32("cqCuXlddCfzL",12) == 2387558712) strcat(s, "o");
if (crc32("KkxsoTSI",8) == 1459722980) strcat(s, "u");
if (crc32("aqqIwIAqeiBqOK",14) == 683119869) strcat(s, "Y");
if (crc32("HBGzgeFEP",9) == 1987486427) strcat(s, "s");
if (crc32("jRawKukbRTcIu",13) == 1465146824) strcat(s, "l");
if (crc32("JqrPDcWqmwEO",12) == 804052235) strcat(s, "y");
    return s;
}

char *unsavingly_adverbs() {
    char *s = calloc(11);
    if (crc32("VbaTdsOLVK",10) == 1958859660) strcat(s, "u");
if (crc32("ZwCBpXc",7) == 3498600767) strcat(s, "n");
if (crc32("cLnQQqKHpio",11) == 3279140609) strcat(s, "d");
if (crc32("iLkcxUAHhnfozY",14) == 1400715532) strcat(s, "s");
if (crc32("ijoRpLUXgUsEOy",14) == 1459032611) strcat(s, "K");
if (crc32("pwezPAvrTmbH",12) == 408573677) strcat(s, "a");
if (crc32("eWvpxUSvta",10) == 1439310887) strcat(s, "C");
if (crc32("UvOnYBXq",8) == 3207280959) strcat(s, "v");
if (crc32("aVPdCFdZKJDZWg",14) == 2598141751) strcat(s, "i");
if (crc32("RDAzhw",6) == 1148985656) strcat(s, "n");
if (crc32("CXCgr",5) == 849306770) strcat(s, "z");
if (crc32("CUARXWN",7) == 3060418306) strcat(s, "g");
if (crc32("qpthQbkFZX",10) == 51759866) strcat(s, "l");
if (crc32("ESqkWci",7) == 761086984) strcat(s, "K");
if (crc32("wPDtrbSiFltxfpe",15) == 1683210123) strcat(s, "y");
    return s;
}

char *quasiimpartially_adverbs() {
    char *s = calloc(17);
    if (crc32("mfIvvUdVaGquqFK",15) == 2184062525) strcat(s, "q");
if (crc32("uhiHVEItOGXo",12) == 3709930716) strcat(s, "u");
if (crc32("SqMWUBJZzd",10) == 1986410433) strcat(s, "a");
if (crc32("pVKxj",5) == 3359720027) strcat(s, "v");
if (crc32("yrHwlOCtKIwubW",14) == 3992149014) strcat(s, "s");
if (crc32("PoqLlkPc",8) == 688344816) strcat(s, "Y");
if (crc32("cupKaZeaeoruk",13) == 3771661107) strcat(s, "i");
if (crc32("FCGbyT",6) == 2835038931) strcat(s, "i");
if (crc32("NNgVwxJE",8) == 1334425414) strcat(s, "m");
if (crc32("tJpEl",5) == 2736977704) strcat(s, "p");
if (crc32("wNBRBbNx",8) == 2645191285) strcat(s, "a");
if (crc32("DlUVbj",6) == 2975501272) strcat(s, "C");
if (crc32("GJhIPPpAMeYHV",13) == 3877687711) strcat(s, "r");
if (crc32("WFGGqVvSkJgJq",13) == 2469707847) strcat(s, "O");
if (crc32("nLnwTeDzYFmjYtV",15) == 101811323) strcat(s, "t");
if (crc32("GYtCHNGspXZNx",13) == 2785910279) strcat(s, "i");
if (crc32("GGhTutjGQXO",11) == 2348821606) strcat(s, "a");
if (crc32("lJDUMX",6) == 2194793941) strcat(s, "a");
if (crc32("cguhJUHMU",9) == 3455157733) strcat(s, "l");
if (crc32("hQwbijr",7) == 1579509355) strcat(s, "l");
if (crc32("PqeOBP",6) == 2816790932) strcat(s, "y");
    return s;
}

char *noblemanly_adverbs() {
    char *s = calloc(11);
    if (crc32("OIyUvnSpEkJLI",13) == 4012052010) strcat(s, "n");
if (crc32("qWzXroEDiVkGj",13) == 4014401324) strcat(s, "o");
if (crc32("CiavjiwFWOMs",12) == 3881143146) strcat(s, "K");
if (crc32("OrqYrXpcqhP",11) == 2838329245) strcat(s, "b");
if (crc32("ArQdbOgwxSL",11) == 884356571) strcat(s, "l");
if (crc32("pVoojhUBKY",10) == 4265168509) strcat(s, "k");
if (crc32("TsCqFWvtNtWI",12) == 3143471486) strcat(s, "e");
if (crc32("ieYfMpyNgwPq",12) == 2050879367) strcat(s, "m");
if (crc32("vCrGhQjvXbaTlr",14) == 26913667) strcat(s, "a");
if (crc32("DwICRONUS",9) == 3403962318) strcat(s, "S");
if (crc32("zdjHSMNqsvhM",12) == 1962998283) strcat(s, "n");
if (crc32("TuLUsHt",7) == 1236689489) strcat(s, "l");
if (crc32("qWbkrkpQQuqK",12) == 28278780) strcat(s, "y");
    return s;
}

char *quasigallantly_adverbs() {
    char *s = calloc(15);
    if (crc32("MNbmrpEQsjX",11) == 2233357664) strcat(s, "w");
if (crc32("IMHrhLECPjCFwCb",15) == 3986695283) strcat(s, "q");
if (crc32("GxawLdO",7) == 1852472325) strcat(s, "y");
if (crc32("KyUJwHNGE",9) == 2583759) strcat(s, "u");
if (crc32("pAfVP",5) == 106385817) strcat(s, "O");
if (crc32("BbYMZ",5) == 3627704097) strcat(s, "a");
if (crc32("adxypvEPfKirpiZ",15) == 597068550) strcat(s, "d");
if (crc32("KFEnYZ",6) == 229303863) strcat(s, "s");
if (crc32("kSIoBqJ",7) == 2459436420) strcat(s, "w");
if (crc32("aWPUQSUiKk",10) == 621695289) strcat(s, "i");
if (crc32("UzjBaCsWV",9) == 2193384822) strcat(s, "g");
if (crc32("bjRaXPJvO",9) == 2850065747) strcat(s, "f");
if (crc32("dFruxvnlEsgZkU",14) == 1254313849) strcat(s, "a");
if (crc32("ehTHoTwJNMHuwkI",15) == 4074348721) strcat(s, "l");
if (crc32("hsjezFbhr",9) == 3044322556) strcat(s, "H");
if (crc32("xiIEaBJAPeo",11) == 3864594984) strcat(s, "l");
if (crc32("YQCNqG",6) == 2986988922) strcat(s, "a");
if (crc32("dLanf",5) == 2588606371) strcat(s, "B");
if (crc32("MBpHaagFBWgbXT",14) == 21338722) strcat(s, "n");
if (crc32("vHtgfthI",8) == 751429666) strcat(s, "t");
if (crc32("jrpKjJRwl",9) == 1721457077) strcat(s, "y");
if (crc32("PnpYy",5) == 865730355) strcat(s, "l");
if (crc32("JIGyx",5) == 3884646582) strcat(s, "y");
    return s;
}

char *quasilawfully_adverbs() {
    char *s = calloc(14);
    if (crc32("ydnloFGVHSi",11) == 3964900844) strcat(s, "A");
if (crc32("aKtAdF",6) == 1449299518) strcat(s, "q");
if (crc32("YELqjonW",8) == 1442597198) strcat(s, "y");
if (crc32("NKGpbPPQx",9) == 3072181394) strcat(s, "u");
if (crc32("TSPaSIWfofap",12) == 1506216614) strcat(s, "a");
if (crc32("mAWTP",5) == 3642439588) strcat(s, "B");
if (crc32("zOlHVxDsDSLW",12) == 3954387591) strcat(s, "s");
if (crc32("FTZYrDS",7) == 3624695023) strcat(s, "i");
if (crc32("FKNNFwsPvV",10) == 811885396) strcat(s, "Z");
if (crc32("bVASaQTmY",9) == 285282229) strcat(s, "l");
if (crc32("IuDjvNJHNs",10) == 1839666251) strcat(s, "r");
if (crc32("VzjLkQn",7) == 951624118) strcat(s, "a");
if (crc32("yzxAK",5) == 1153003404) strcat(s, "L");
if (crc32("nNPmCswXdmZwJn",14) == 3690219487) strcat(s, "w");
if (crc32("ulpVbfjPyVXJyR",14) == 2495124256) strcat(s, "f");
if (crc32("DZXzFKUOO",9) == 2749557681) strcat(s, "g");
if (crc32("cNShiRPzFcH",11) == 1261084470) strcat(s, "u");
if (crc32("UuoGEP",6) == 742834684) strcat(s, "l");
if (crc32("fLEhi",5) == 4266921326) strcat(s, "R");
if (crc32("XgjPpyOsmAZKOvx",15) == 3961544690) strcat(s, "l");
if (crc32("EdAzziubfLhaL",13) == 2710760344) strcat(s, "y");
    return s;
}

char *subquarterly_adverbs() {
    char *s = calloc(13);
    if (crc32("GvDEKLIfRq",10) == 1271324332) strcat(s, "F");
if (crc32("VPuScBnpvJvS",12) == 1964028749) strcat(s, "s");
if (crc32("zLoJXrihBkqZ",12) == 145623922) strcat(s, "A");
if (crc32("tWynjQnuaFCt",12) == 789960501) strcat(s, "u");
if (crc32("Hhmnfcebp",9) == 3574051955) strcat(s, "S");
if (crc32("VrIHYIYXyw",10) == 1387785717) strcat(s, "b");
if (crc32("JQPXoxP",7) == 1131014282) strcat(s, "q");
if (crc32("HnotNX",6) == 463397800) strcat(s, "M");
if (crc32("DpvHW",5) == 2646457520) strcat(s, "u");
if (crc32("TCEumZla",8) == 4103096332) strcat(s, "a");
if (crc32("KymvGfDVeshhh",13) == 3404850543) strcat(s, "r");
if (crc32("WpCSHzXGmo",10) == 3684017650) strcat(s, "t");
if (crc32("AcxpcGFGZQYUy",13) == 809179486) strcat(s, "z");
if (crc32("xZPJdEyFO",9) == 1067107343) strcat(s, "e");
if (crc32("gSbYBsBJfz",10) == 693892183) strcat(s, "F");
if (crc32("XDqJRPmPZz",10) == 1721175389) strcat(s, "r");
if (crc32("LoBgNJJdl",9) == 989059247) strcat(s, "l");
if (crc32("KywDTClkzqMyA",13) == 2241147284) strcat(s, "g");
if (crc32("fyOIAW",6) == 1006406509) strcat(s, "y");
    return s;
}

char *needily_adverbs() {
    char *s = calloc(8);
    if (crc32("PHoFUXnuhwuhjN",14) == 595961674) strcat(s, "n");
if (crc32("xdgXBeIGEs",10) == 151402414) strcat(s, "e");
if (crc32("gEqjXuMoljnG",12) == 3884411231) strcat(s, "e");
if (crc32("iGERpWhlkE",10) == 525199828) strcat(s, "d");
if (crc32("MhkkKlOD",8) == 3904538665) strcat(s, "i");
if (crc32("IYOOAVtqcRuo",12) == 2209084235) strcat(s, "l");
if (crc32("zcKnKRCTLjw",11) == 1292689647) strcat(s, "K");
if (crc32("sXsnc",5) == 261876365) strcat(s, "y");
    return s;
}

char *tripinnately_adverbs() {
    char *s = calloc(13);
    if (crc32("BVZnWNbO",8) == 1707815963) strcat(s, "e");
if (crc32("LCoisjeQ",8) == 996110488) strcat(s, "t");
if (crc32("yEpsTQHuIXgoYKj",15) == 698466659) strcat(s, "C");
if (crc32("kcmlMHSHVdaAUZe",15) == 3176487616) strcat(s, "r");
if (crc32("aNYzuSeDurjCxjH",15) == 2672629897) strcat(s, "i");
if (crc32("NksSGl",6) == 3913914039) strcat(s, "S");
if (crc32("lwxXN",5) == 3589044055) strcat(s, "p");
if (crc32("JUJLrWdFJO",10) == 855303989) strcat(s, "r");
if (crc32("izuCWHnvUwkAKjP",15) == 1000467813) strcat(s, "i");
if (crc32("jnDwgGuoGUY",11) == 3289475356) strcat(s, "v");
if (crc32("BGYwFaVdFr",10) == 1683205104) strcat(s, "n");
if (crc32("mrCppFnhsWHNYBe",15) == 1579971919) strcat(s, "e");
if (crc32("lbLaJiGdfiqc",12) == 4075005625) strcat(s, "n");
if (crc32("PFEAHwJQe",9) == 3565184988) strcat(s, "a");
if (crc32("Cqofik",6) == 174957528) strcat(s, "A");
if (crc32("ttqrfRtOhl",10) == 1085263431) strcat(s, "t");
if (crc32("XRmTyaaByCRZTqI",15) == 1081798688) strcat(s, "i");
if (crc32("pyFJWeVDTRvL",12) == 3732531341) strcat(s, "e");
if (crc32("fCIEdwzN",8) == 1321973903) strcat(s, "e");
if (crc32("UsdwpChvyqCDiW",14) == 1126001471) strcat(s, "l");
if (crc32("rMcIphw",7) == 1690724879) strcat(s, "Q");
if (crc32("pNUBOdt",7) == 2827445567) strcat(s, "y");
    return s;
}

char *unpardonably_adverbs() {
    char *s = calloc(13);
    if (crc32("CdWMITwCLaFjB",13) == 1890976237) strcat(s, "u");
if (crc32("lUwKOZ",6) == 1216298781) strcat(s, "n");
if (crc32("PHpMryecNhdzHAz",15) == 3622871949) strcat(s, "j");
if (crc32("HKTNEudznAmKMtf",15) == 3806004020) strcat(s, "p");
if (crc32("lDjDKqGHPS",10) == 3339598) strcat(s, "h");
if (crc32("LsrJOEiX",8) == 4136640567) strcat(s, "a");
if (crc32("HeIKjyWFDPoAxo",14) == 2398468360) strcat(s, "r");
if (crc32("tfmekj",6) == 2604495014) strcat(s, "d");
if (crc32("fYCnN",5) == 411972894) strcat(s, "P");
if (crc32("smiYupYqQzFEMp",14) == 4053497272) strcat(s, "o");
if (crc32("dSQpA",5) == 1137604743) strcat(s, "k");
if (crc32("aOwczVxWX",9) == 1840202228) strcat(s, "n");
if (crc32("MopAVdPcE",9) == 3485381375) strcat(s, "a");
if (crc32("sXXpwvhvnDHx",12) == 3239104652) strcat(s, "b");
if (crc32("Odyinzxuf",9) == 2081110599) strcat(s, "t");
if (crc32("oEhGPaABwvH",11) == 4042541758) strcat(s, "l");
if (crc32("WTvuNwO",7) == 2516904459) strcat(s, "y");
if (crc32("OJMsvQOW",8) == 3650390760) strcat(s, "y");
    return s;
}

char *inaudibly_adverbs() {
    char *s = calloc(10);
    if (crc32("YcRbLVQVPOiSdGR",15) == 1159089421) strcat(s, "P");
if (crc32("nTcUrewvvZST",12) == 4117069424) strcat(s, "i");
if (crc32("wpMdvphTkfwZm",13) == 3781805371) strcat(s, "M");
if (crc32("SdLoUdPTlkQS",12) == 284423931) strcat(s, "n");
if (crc32("QqHQkzhTRCB",11) == 3579927436) strcat(s, "a");
if (crc32("LjLqWStHGt",10) == 3216712105) strcat(s, "A");
if (crc32("OotRPysLE",9) == 2506191977) strcat(s, "u");
if (crc32("hgCTzRaRNJ",10) == 2500582020) strcat(s, "d");
if (crc32("BjlLrrHvb",9) == 301222793) strcat(s, "I");
if (crc32("JZUQEBWEXOa",11) == 230565382) strcat(s, "i");
if (crc32("MQkDFdXg",8) == 933394789) strcat(s, "W");
if (crc32("lVHhIdLs",8) == 3559413337) strcat(s, "b");
if (crc32("zbiblCvIlV",10) == 1115667804) strcat(s, "m");
if (crc32("YCdGuCUSq",9) == 2520666021) strcat(s, "l");
if (crc32("qLooqulgECHfdMc",15) == 139164557) strcat(s, "y");
    return s;
}

char *noncommodiously_adverbs() {
    char *s = calloc(16);
    if (crc32("kCtHJvlJjlYGeKJ",15) == 4065341453) strcat(s, "X");
if (crc32("xKEUsKF",7) == 2435921750) strcat(s, "n");
if (crc32("qWIUjUoW",8) == 41076932) strcat(s, "a");
if (crc32("txnFLfW",7) == 1164908277) strcat(s, "o");
if (crc32("dgjMlSQsJxM",11) == 4143590106) strcat(s, "J");
if (crc32("RdfRgB",6) == 1596806671) strcat(s, "n");
if (crc32("gdNsKIZIsMV",11) == 4168563173) strcat(s, "D");
if (crc32("XxqtMLX",7) == 200724202) strcat(s, "c");
if (crc32("vRiWSbr",7) == 131634564) strcat(s, "e");
if (crc32("iHBmDfEoYNbUAp",14) == 2037413365) strcat(s, "o");
if (crc32("xQzmqgqhWfZSBF",14) == 3771012354) strcat(s, "m");
if (crc32("yuIqqajhl",9) == 2753350441) strcat(s, "m");
if (crc32("hSSqvac",7) == 4215188385) strcat(s, "o");
if (crc32("bfgsCJM",7) == 3447557027) strcat(s, "C");
if (crc32("VvCuMzGv",8) == 4151031785) strcat(s, "d");
if (crc32("JlXTIIGYHmeURZa",15) == 2766100587) strcat(s, "D");
if (crc32("IQwncYajwdTcxp",14) == 2887135917) strcat(s, "i");
if (crc32("yMsJzLlSgpSh",12) == 1192238590) strcat(s, "Q");
if (crc32("lOekDB",6) == 1357523031) strcat(s, "o");
if (crc32("xQtKFXURIDoLtZ",14) == 1856142656) strcat(s, "A");
if (crc32("PTeiU",5) == 1534909565) strcat(s, "u");
if (crc32("PNyhuSjIVp",10) == 4108369213) strcat(s, "s");
if (crc32("wPyQxUyiUTlt",12) == 2212324645) strcat(s, "l");
if (crc32("PAVAna",6) == 4026291928) strcat(s, "s");
if (crc32("aROgZeZeppS",11) == 3025281718) strcat(s, "y");
    return s;
}

char *permissively_adverbs() {
    char *s = calloc(13);
    if (crc32("sZmONGBSTyeiy",13) == 1014705443) strcat(s, "C");
if (crc32("LzpSzZ",6) == 563186233) strcat(s, "p");
if (crc32("vMbuheNbFjyxa",13) == 2291291287) strcat(s, "e");
if (crc32("YVfmYUajOyu",11) == 125442125) strcat(s, "r");
if (crc32("cEwGYCKTduT",11) == 3840137906) strcat(s, "V");
if (crc32("aZQBv",5) == 3499621167) strcat(s, "m");
if (crc32("zwEgs",5) == 373884315) strcat(s, "i");
if (crc32("lJtaPK",6) == 413196329) strcat(s, "b");
if (crc32("mdkVNW",6) == 1996089462) strcat(s, "s");
if (crc32("qRtVXXrnizl",11) == 2836549703) strcat(s, "s");
if (crc32("iBQcmGMvNezdfQB",15) == 2700176419) strcat(s, "Q");
if (crc32("btjYEbtn",8) == 1969703677) strcat(s, "i");
if (crc32("ShRUCepwCLm",11) == 913997197) strcat(s, "v");
if (crc32("cvAxCSHHYf",10) == 2041410150) strcat(s, "e");
if (crc32("vuxNePKDa",9) == 593857060) strcat(s, "l");
if (crc32("XokZrKaYHjLUr",13) == 2914055922) strcat(s, "r");
if (crc32("NeZhyJxxbHQtnxE",15) == 1619164747) strcat(s, "y");
    return s;
}

char *geologically_adverbs() {
    char *s = calloc(13);
    if (crc32("YcXTCZAXGPFGu",13) == 825781355) strcat(s, "C");
if (crc32("JJIAG",5) == 1582896020) strcat(s, "g");
if (crc32("iEUQOeQGACW",11) == 2560359134) strcat(s, "H");
if (crc32("zrBAX",5) == 1270520136) strcat(s, "e");
if (crc32("nDoTtf",6) == 3376228518) strcat(s, "o");
if (crc32("KYEgKLfBWeoaR",13) == 2410930236) strcat(s, "t");
if (crc32("NoKTGieu",8) == 4125567588) strcat(s, "l");
if (crc32("ZxyjmfGFFZI",11) == 1375782815) strcat(s, "o");
if (crc32("SFrMWV",6) == 50298009) strcat(s, "I");
if (crc32("rAYFATa",7) == 1020871559) strcat(s, "g");
if (crc32("stJMdsQVhGRL",12) == 1170158633) strcat(s, "i");
if (crc32("ffHQNm",6) == 3726990442) strcat(s, "e");
if (crc32("feFILxVptKjxQT",14) == 179354654) strcat(s, "c");
if (crc32("nmLFSUIRSobBp",13) == 21563833) strcat(s, "a");
if (crc32("cFdGvK",6) == 2985020615) strcat(s, "l");
if (crc32("TWTDYqFe",8) == 697811440) strcat(s, "d");
if (crc32("qKJDiT",6) == 94162649) strcat(s, "l");
if (crc32("cOjuaBsVmkeqNs",14) == 4274323137) strcat(s, "y");
    return s;
}

char *overcarelessly_adverbs() {
    char *s = calloc(15);
    if (crc32("JwrcVo",6) == 4005048067) strcat(s, "o");
if (crc32("uvUvAGDCpOS",11) == 1686378349) strcat(s, "n");
if (crc32("gXWAXIGx",8) == 1262102883) strcat(s, "v");
if (crc32("uKGHd",5) == 1105420875) strcat(s, "f");
if (crc32("ETXlNI",6) == 223010241) strcat(s, "e");
if (crc32("ICfEI",5) == 3560230672) strcat(s, "r");
if (crc32("qEQOebgFzWDJJLe",15) == 3719049576) strcat(s, "e");
if (crc32("uYdsrzVXQiiYSOC",15) == 1221960881) strcat(s, "c");
if (crc32("HJTWHyIh",8) == 2495856330) strcat(s, "j");
if (crc32("mpSaL",5) == 2714313673) strcat(s, "a");
if (crc32("PtJgMFpxajldw",13) == 2924553370) strcat(s, "t");
if (crc32("oKUfRp",6) == 256013212) strcat(s, "r");
if (crc32("nEgDYDt",7) == 835890997) strcat(s, "R");
if (crc32("sZBLMEtFjm",10) == 3994407266) strcat(s, "e");
if (crc32("ZdOysyqrfhEQZe",14) == 1518893082) strcat(s, "u");
if (crc32("rYIKxFcbpi",10) == 4132108119) strcat(s, "l");
if (crc32("iCElR",5) == 2712959493) strcat(s, "Z");
if (crc32("OddranQyBWNEcc",14) == 2423043466) strcat(s, "e");
if (crc32("ooOjxSCmgDF",11) == 1553621525) strcat(s, "p");
if (crc32("ntLzvOsIhBbLvQ",14) == 2270603402) strcat(s, "s");
if (crc32("QjTWWEPfl",9) == 1826177535) strcat(s, "V");
if (crc32("NaVfHjm",7) == 829873569) strcat(s, "s");
if (crc32("irwPeYy",7) == 741080707) strcat(s, "B");
if (crc32("XxCNHWHRTGRvxW",14) == 1844196507) strcat(s, "l");
if (crc32("yBAXVof",7) == 2344363259) strcat(s, "C");
if (crc32("ZNpIlA",6) == 670248804) strcat(s, "y");
    return s;
}

char *catechistically_adverbs() {
    char *s = calloc(16);
    if (crc32("PLNDJ",5) == 1475042582) strcat(s, "c");
if (crc32("ujtnfRwCHrBrDl",14) == 2629801121) strcat(s, "b");
if (crc32("upEJLkbZtvt",11) == 3855405582) strcat(s, "a");
if (crc32("CYxZshnCuH",10) == 393784191) strcat(s, "t");
if (crc32("bfOrhDpCV",9) == 3324563035) strcat(s, "e");
if (crc32("kAKdRPeERZ",10) == 145072105) strcat(s, "c");
if (crc32("IVlhmYyleQmMRF",14) == 3759885559) strcat(s, "s");
if (crc32("ohQgfW",6) == 430153140) strcat(s, "h");
if (crc32("OwsKeIjYCEGdb",13) == 4039816066) strcat(s, "i");
if (crc32("LmBYWKCUmyZ",11) == 2095097041) strcat(s, "i");
if (crc32("LrhvasszgsoqSiW",15) == 2420973739) strcat(s, "s");
if (crc32("WYMAYEbbHaUkZ",13) == 3703276106) strcat(s, "t");
if (crc32("WNekRFgTrj",10) == 1417102819) strcat(s, "i");
if (crc32("kZrPbJU",7) == 2870168903) strcat(s, "c");
if (crc32("hkPbRIVcuohyTJO",15) == 664800698) strcat(s, "R");
if (crc32("cawJorgR",8) == 2299188258) strcat(s, "a");
if (crc32("RiuNcbZtkF",10) == 3712202870) strcat(s, "l");
if (crc32("sAlNSfhib",9) == 2213360518) strcat(s, "l");
if (crc32("dXouFXWdMNpzzB",14) == 2476381633) strcat(s, "y");
    return s;
}

char *contemporaneously_adverbs() {
    char *s = calloc(18);
    if (crc32("UNCFBi",6) == 30747669) strcat(s, "c");
if (crc32("uJTcRgtQInzuWZi",15) == 2827556737) strcat(s, "d");
if (crc32("rXydUmMoaY",10) == 1830791427) strcat(s, "o");
if (crc32("RxaoyJdSBmOy",12) == 331021107) strcat(s, "g");
if (crc32("PxKCFnAerf",10) == 1000273787) strcat(s, "n");
if (crc32("NYaemsonrl",10) == 2753882219) strcat(s, "K");
if (crc32("RHAKdHTt",8) == 2911908100) strcat(s, "t");
if (crc32("VXCZNC",6) == 181657687) strcat(s, "e");
if (crc32("zbaEHSlSPr",10) == 4244932338) strcat(s, "m");
if (crc32("DxppZ",5) == 1615545680) strcat(s, "d");
if (crc32("dLkBuvvYWqGPl",13) == 3137689401) strcat(s, "p");
if (crc32("FEJuC",5) == 2013520648) strcat(s, "g");
if (crc32("mAnQLBuIvtvN",12) == 653169859) strcat(s, "o");
if (crc32("rSbzPiOAHu",10) == 237012949) strcat(s, "I");
if (crc32("lmdkLuKFxw",10) == 4243618) strcat(s, "r");
if (crc32("NHsuwahM",8) == 2296496584) strcat(s, "a");
if (crc32("stHIQI",6) == 3178089343) strcat(s, "n");
if (crc32("WZNhaywUf",9) == 1149892174) strcat(s, "e");
if (crc32("SyMgdLiNXUwTrIJ",15) == 2465288048) strcat(s, "d");
if (crc32("FOeTWd",6) == 1778936005) strcat(s, "o");
if (crc32("PJxKVWCJVe",10) == 1575658736) strcat(s, "u");
if (crc32("mdUpHTZNZ",9) == 3452497335) strcat(s, "s");
if (crc32("eWUeVbPrSzkeJIC",15) == 1013791786) strcat(s, "o");
if (crc32("GOGPQgNkzenND",13) == 3766648969) strcat(s, "l");
if (crc32("GTyxjtSJgUZoD",13) == 3901839906) strcat(s, "y");
    return s;
}

char *virtually_adverbs() {
    char *s = calloc(10);
    if (crc32("jKphQM",6) == 643079261) strcat(s, "Z");
if (crc32("WiFKLrD",7) == 3665546841) strcat(s, "v");
if (crc32("DmtFwQcAGibLh",13) == 3986338964) strcat(s, "P");
if (crc32("unPcSkHsY",9) == 3478220538) strcat(s, "i");
if (crc32("eTjCJjrkTW",10) == 471806616) strcat(s, "r");
if (crc32("RUnSepaCxr",10) == 3098690990) strcat(s, "t");
if (crc32("hhkRLgxchAL",11) == 741495740) strcat(s, "u");
if (crc32("KtQYAcyz",8) == 2981254290) strcat(s, "z");
if (crc32("cNtyxD",6) == 4048234524) strcat(s, "a");
if (crc32("KdXlwNduupfy",12) == 3357871422) strcat(s, "l");
if (crc32("gEjUviucPcY",11) == 910785406) strcat(s, "l");
if (crc32("woGrAIeDCMHohU",14) == 473094496) strcat(s, "f");
if (crc32("FJuqcYdFZJf",11) == 2320691986) strcat(s, "y");
    return s;
}

char *anomalistically_adverbs() {
    char *s = calloc(16);
    if (crc32("oLRjxuWRJvJ",11) == 2639215537) strcat(s, "Z");
if (crc32("XtTING",6) == 3760977204) strcat(s, "a");
if (crc32("iCjXC",5) == 56007794) strcat(s, "n");
if (crc32("elTzcOHFanQb",12) == 1573399548) strcat(s, "o");
if (crc32("KNhlXMHFMorCe",13) == 176568152) strcat(s, "m");
if (crc32("YOxDRt",6) == 1176309912) strcat(s, "a");
if (crc32("gfcDLJYcReItz",13) == 714828136) strcat(s, "k");
if (crc32("ORWKOEZPIBzVgy",14) == 1811939201) strcat(s, "l");
if (crc32("wQRts",5) == 3527152325) strcat(s, "F");
if (crc32("Ylhlc",5) == 3655769293) strcat(s, "i");
if (crc32("DlsobTYxeKLrb",13) == 3637427671) strcat(s, "G");
if (crc32("CoHiIvY",7) == 723068795) strcat(s, "s");
if (crc32("aejmP",5) == 830749319) strcat(s, "m");
if (crc32("GZpSmeQL",8) == 4006894853) strcat(s, "t");
if (crc32("Jkhcgw",6) == 2705161631) strcat(s, "i");
if (crc32("dXmezwxlCQ",10) == 2841193681) strcat(s, "c");
if (crc32("GbOleZqGCQe",11) == 2647079836) strcat(s, "a");
if (crc32("QfuxbdTk",8) == 1556291174) strcat(s, "l");
if (crc32("dvOEgb",6) == 1172494028) strcat(s, "n");
if (crc32("XzmxwkcmtLpz",12) == 4036616898) strcat(s, "l");
if (crc32("kWRbeEetx",9) == 870160607) strcat(s, "w");
if (crc32("NSNlvLng",8) == 1038365946) strcat(s, "y");
    return s;
}

char *osteopathically_adverbs() {
    char *s = calloc(16);
    if (crc32("orpulW",6) == 3459269976) strcat(s, "o");
if (crc32("dHaynAPxUYFONAT",15) == 1548890590) strcat(s, "f");
if (crc32("xvoWKoRDEzoQsVn",15) == 2369300928) strcat(s, "s");
if (crc32("yxCzniUTuk",10) == 62499731) strcat(s, "u");
if (crc32("hSxORCiucnOVH",13) == 1863148876) strcat(s, "t");
if (crc32("UbxHBCgCMXSxPS",14) == 4039822237) strcat(s, "e");
if (crc32("OejwIHDjv",9) == 3253842989) strcat(s, "W");
if (crc32("OKMsoEnC",8) == 3751302011) strcat(s, "o");
if (crc32("yNqDurJW",8) == 2434478929) strcat(s, "D");
if (crc32("maAGQRtaDGxmr",13) == 2824023397) strcat(s, "p");
if (crc32("eRkUB",5) == 3983041893) strcat(s, "a");
if (crc32("UVYQJ",5) == 1677137714) strcat(s, "i");
if (crc32("wNwaocutvRP",11) == 554020090) strcat(s, "t");
if (crc32("HtWJB",5) == 1650349181) strcat(s, "D");
if (crc32("QwzocT",6) == 1480402754) strcat(s, "h");
if (crc32("joQJZGilRXCLQ",13) == 2325525265) strcat(s, "i");
if (crc32("qIfRiYSBBMar",12) == 3004207886) strcat(s, "c");
if (crc32("gZTecsNh",8) == 2899539947) strcat(s, "a");
if (crc32("FHQZHimLgPzaz",13) == 2117053343) strcat(s, "l");
if (crc32("imGGnx",6) == 3914972043) strcat(s, "R");
if (crc32("avNTgalhJd",10) == 1933906414) strcat(s, "l");
if (crc32("yZoEcvOgx",9) == 3286635955) strcat(s, "y");
    return s;
}

char *labyrinthically_adverbs() {
    char *s = calloc(16);
    if (crc32("sORlkmMZuQbzFQH",15) == 3629011731) strcat(s, "s");
if (crc32("aXPJGJGI",8) == 3160594663) strcat(s, "l");
if (crc32("juZJVu",6) == 1017936529) strcat(s, "a");
if (crc32("ElLOkYtbmRqzkV",14) == 1799647105) strcat(s, "P");
if (crc32("DdCDmVdfRttKj",13) == 1430413211) strcat(s, "b");
if (crc32("CHcYvVwYyqxJ",12) == 2406969795) strcat(s, "y");
if (crc32("FNUEQuG",7) == 72483218) strcat(s, "r");
if (crc32("uLAxi",5) == 339167061) strcat(s, "q");
if (crc32("TxOMAV",6) == 1059101745) strcat(s, "i");
if (crc32("OewPAoDbtWB",11) == 1176074955) strcat(s, "l");
if (crc32("VZUnpz",6) == 952329549) strcat(s, "n");
if (crc32("xgyGtpsrU",9) == 723778936) strcat(s, "t");
if (crc32("DCbjNcNvYffPoqe",15) == 959411622) strcat(s, "h");
if (crc32("npZWVwhs",8) == 2150011613) strcat(s, "i");
if (crc32("fHVivwSCfTHA",12) == 247562775) strcat(s, "i");
if (crc32("rStlmSy",7) == 3915642349) strcat(s, "c");
if (crc32("OvPAMINgVsEZQ",13) == 3286829816) strcat(s, "I");
if (crc32("jnUiFzQjumYXvS",14) == 3515248629) strcat(s, "a");
if (crc32("tjaCGktNh",9) == 1092639731) strcat(s, "h");
if (crc32("nvHiJwZQDVyNiD",14) == 1193489750) strcat(s, "l");
if (crc32("goPafTri",8) == 3844097333) strcat(s, "J");
if (crc32("MwtuhMeEWWps",12) == 1886659648) strcat(s, "l");
if (crc32("bMkvIGtGsE",10) == 1255468494) strcat(s, "y");
    return s;
}

char *noncapitalistically_adverbs() {
    char *s = calloc(20);
    if (crc32("WdUxPBTFxGr",11) == 3953759786) strcat(s, "V");
if (crc32("nkZAMD",6) == 2354066725) strcat(s, "n");
if (crc32("xyrvb",5) == 725703631) strcat(s, "h");
if (crc32("sniqkhffFMX",11) == 1644868042) strcat(s, "o");
if (crc32("HWjBxyR",7) == 408216149) strcat(s, "I");
if (crc32("GgBRZuw",7) == 3070534945) strcat(s, "n");
if (crc32("QZlKRksJFXfFFtI",15) == 3889962070) strcat(s, "c");
if (crc32("tFwPTFWwtypwzNI",15) == 4055755562) strcat(s, "a");
if (crc32("wMBadsA",7) == 3138142399) strcat(s, "Q");
if (crc32("tnXRpPhAdCLf",12) == 2556984790) strcat(s, "p");
if (crc32("mXnSOdbWEfvZggX",15) == 1086973433) strcat(s, "m");
if (crc32("pPVsghzFhHoBC",13) == 929596783) strcat(s, "i");
if (crc32("jByBtoGNwb",10) == 2171910629) strcat(s, "t");
if (crc32("SWAbtGPsK",9) == 3270769295) strcat(s, "o");
if (crc32("iRdYwED",7) == 3048386061) strcat(s, "a");
if (crc32("SkAAS",5) == 4243993950) strcat(s, "g");
if (crc32("EzeMOoElF",9) == 3163816614) strcat(s, "l");
if (crc32("xFpnVevetehdS",13) == 4203611611) strcat(s, "i");
if (crc32("XNcuVkujOZcnf",13) == 3767266289) strcat(s, "l");
if (crc32("QvGoJLaSccbl",12) == 3254827806) strcat(s, "s");
if (crc32("bMdHtgyGHJIbVt",14) == 2009168370) strcat(s, "C");
if (crc32("tcZdfpuKzQnDXR",14) == 3712034623) strcat(s, "t");
if (crc32("VKHhFeBGcGxam",13) == 3045477002) strcat(s, "y");
if (crc32("bSrBOicHge",10) == 1794405010) strcat(s, "i");
if (crc32("dGUQxBWKcPOVQug",15) == 2301172176) strcat(s, "U");
if (crc32("wzMjSwwk",8) == 3656595363) strcat(s, "c");
if (crc32("aENtkLIcDm",10) == 2570181228) strcat(s, "a");
if (crc32("skfBvmBNBZvPWsc",15) == 4125143258) strcat(s, "l");
if (crc32("jgriHMgrCTlYpkq",15) == 3485786151) strcat(s, "w");
if (crc32("atUZILlPAt",10) == 4237401404) strcat(s, "l");
if (crc32("uYcGVLlxnAvd",12) == 2072092418) strcat(s, "y");
    return s;
}

char *intestinally_adverbs() {
    char *s = calloc(13);
    if (crc32("foVicnWf",8) == 3759255546) strcat(s, "z");
if (crc32("IoeDm",5) == 428782687) strcat(s, "i");
if (crc32("xkfLnYtxo",9) == 3145529987) strcat(s, "g");
if (crc32("spdEfZO",7) == 1641758662) strcat(s, "n");
if (crc32("ppXHdUYUKRbZh",13) == 2961238245) strcat(s, "Y");
if (crc32("EYMTaacQiQb",11) == 1937298069) strcat(s, "t");
if (crc32("mAvRgVDpaRVlY",13) == 119303956) strcat(s, "u");
if (crc32("IakGGRgKgyhyJfw",15) == 2225901495) strcat(s, "e");
if (crc32("wFCpggSarUons",13) == 2769551010) strcat(s, "T");
if (crc32("SUXDZyxdFQNU",12) == 2152401667) strcat(s, "s");
if (crc32("iRCmkpZBEMd",11) == 3917106348) strcat(s, "t");
if (crc32("EuSfRCIQDi",10) == 1370542374) strcat(s, "y");
if (crc32("qEzWZsMNkZlROEK",15) == 4280761060) strcat(s, "i");
if (crc32("yEfUcwtc",8) == 2528734541) strcat(s, "U");
if (crc32("ykvhUzIahc",10) == 3694216463) strcat(s, "n");
if (crc32("EJxzAeI",7) == 2389624445) strcat(s, "a");
if (crc32("vUerB",5) == 1315132229) strcat(s, "R");
if (crc32("UNwGmJSbG",9) == 2647347811) strcat(s, "l");
if (crc32("hCrEk",5) == 1106572936) strcat(s, "p");
if (crc32("AyEsxQd",7) == 154785101) strcat(s, "l");
if (crc32("sIYgLZcbOfvERZu",15) == 3241745047) strcat(s, "y");
    return s;
}

char *contentiously_adverbs() {
    char *s = calloc(14);
    if (crc32("KLACLY",6) == 1583708340) strcat(s, "f");
if (crc32("IyEgq",5) == 4263104978) strcat(s, "c");
if (crc32("iiAeLvpCBLcfYO",14) == 3912587731) strcat(s, "W");
if (crc32("dHqJb",5) == 136967134) strcat(s, "o");
if (crc32("NCsIhUGV",8) == 1258079119) strcat(s, "i");
if (crc32("JOrGiDYvgfx",11) == 479033137) strcat(s, "n");
if (crc32("ftSbOUfAnvzd",12) == 4229140895) strcat(s, "t");
if (crc32("JywpVO",6) == 2908869246) strcat(s, "D");
if (crc32("RENzicFDmzS",11) == 741380896) strcat(s, "e");
if (crc32("aycgs",5) == 3714510441) strcat(s, "n");
if (crc32("QBMJofe",7) == 652146602) strcat(s, "Q");
if (crc32("ZCvoNpbug",9) == 2521588324) strcat(s, "t");
if (crc32("gbLFdedCmwGGhBA",15) == 2137929066) strcat(s, "i");
if (crc32("LYeosufLUTKb",12) == 2433506069) strcat(s, "G");
if (crc32("rafFAmC",7) == 3286279608) strcat(s, "o");
if (crc32("MTPFRWZLRQ",10) == 1462319208) strcat(s, "u");
if (crc32("UgYcSAjVHxU",11) == 1676008159) strcat(s, "v");
if (crc32("giHQOx",6) == 720377324) strcat(s, "s");
if (crc32("hbmNegrv",8) == 2664781165) strcat(s, "A");
if (crc32("zGftcKfyHSosxDC",15) == 2526033397) strcat(s, "l");
if (crc32("nBpnjOMQIHLWM",13) == 1117717331) strcat(s, "y");
    return s;
}

char *preeligibly_adverbs() {
    char *s = calloc(12);
    if (crc32("LofRlzVex",9) == 140601555) strcat(s, "p");
if (crc32("otIVsdAF",8) == 2873298662) strcat(s, "r");
if (crc32("BysFdTQvItD",11) == 793460722) strcat(s, "e");
if (crc32("EiqJCdWQTMqJr",13) == 566414197) strcat(s, "I");
if (crc32("Pcvkogdmok",10) == 3254792730) strcat(s, "e");
if (crc32("kzhlSUJqEM",10) == 3781776444) strcat(s, "F");
if (crc32("uVCRWdZRKkXlvFH",15) == 1204071051) strcat(s, "l");
if (crc32("CWrHDC",6) == 1984095486) strcat(s, "i");
if (crc32("YTnWRE",6) == 1809949531) strcat(s, "g");
if (crc32("RfdyxuR",7) == 1934719862) strcat(s, "y");
if (crc32("jMFBC",5) == 626250958) strcat(s, "i");
if (crc32("SrhAFKnNfntaz",13) == 2378949042) strcat(s, "b");
if (crc32("OnOAhFnZGbchb",13) == 3752077128) strcat(s, "e");
if (crc32("VTJgeBymhY",10) == 500369431) strcat(s, "l");
if (crc32("nBwlIfanEbwHBaT",15) == 4078088587) strcat(s, "X");
if (crc32("HJglduLudt",10) == 3291831747) strcat(s, "y");
    return s;
}

char *unadventurously_adverbs() {
    char *s = calloc(16);
    if (crc32("NDLsPyhn",8) == 1414049251) strcat(s, "j");
if (crc32("MZZSLKwpgm",10) == 1433829397) strcat(s, "u");
if (crc32("KYYvoOIxzPxBt",13) == 4268321245) strcat(s, "n");
if (crc32("WFZFVI",6) == 203797624) strcat(s, "s");
if (crc32("txhJPG",6) == 961485799) strcat(s, "a");
if (crc32("zyMDBOH",7) == 2672584181) strcat(s, "h");
if (crc32("xPmPXMaxNXi",11) == 4216706977) strcat(s, "d");
if (crc32("GykiaxqGgEqTnk",14) == 4217823148) strcat(s, "T");
if (crc32("PJcTTOFTQ",9) == 3104816708) strcat(s, "v");
if (crc32("bwnEdeLLgBbhYBi",15) == 4226168488) strcat(s, "e");
if (crc32("KCjzBgD",7) == 2915010668) strcat(s, "n");
if (crc32("QNORIBor",8) == 785715392) strcat(s, "y");
if (crc32("uslhVLYBmmskwjR",15) == 675437669) strcat(s, "t");
if (crc32("VYxJPtIRNrRm",12) == 3052922661) strcat(s, "u");
if (crc32("ePHxU",5) == 3734211199) strcat(s, "r");
if (crc32("hwYyqc",6) == 3633801532) strcat(s, "e");
if (crc32("FaxdjuLGICdZTh",14) == 2236914088) strcat(s, "o");
if (crc32("aVihfmcvaVKLY",13) == 4138322374) strcat(s, "i");
if (crc32("MDVJpWUPy",9) == 3705169453) strcat(s, "u");
if (crc32("OlNPQLVlYrOVWCt",15) == 244253768) strcat(s, "s");
if (crc32("caDXjqclOXxJvxa",15) == 2044827629) strcat(s, "l");
if (crc32("leRdn",5) == 1950746892) strcat(s, "o");
if (crc32("AGjfKzXoqHlI",12) == 1791926477) strcat(s, "y");
    return s;
}

char *spectrophotometrically_adverbs() {
    char *s = calloc(23);
    if (crc32("jHZWrflPnqSFvVg",15) == 2085617790) strcat(s, "f");
if (crc32("GxyxgJNU",8) == 3530915210) strcat(s, "s");
if (crc32("SOrccoXbP",9) == 2976709993) strcat(s, "N");
if (crc32("fJIkUjiJljQ",11) == 3748979725) strcat(s, "p");
if (crc32("vvDilptXtZ",10) == 3899032034) strcat(s, "e");
if (crc32("uxGlG",5) == 230587148) strcat(s, "c");
if (crc32("SdVpfKbjoCUkeLe",15) == 2248358090) strcat(s, "Y");
if (crc32("hSXErKVea",9) == 280825733) strcat(s, "t");
if (crc32("dQbLv",5) == 2010678553) strcat(s, "r");
if (crc32("ZPsncwpqHySc",12) == 2758696368) strcat(s, "o");
if (crc32("nNjoEoPOeoPFi",13) == 1020772405) strcat(s, "p");
if (crc32("SfcokbFXY",9) == 3632891455) strcat(s, "z");
if (crc32("AAnvrMwmtvP",11) == 4175322565) strcat(s, "h");
if (crc32("ulBCikbdJRWh",12) == 2721800198) strcat(s, "o");
if (crc32("RHceq",5) == 2940776533) strcat(s, "t");
if (crc32("sqhsRj",6) == 660632574) strcat(s, "q");
if (crc32("qvYsaUUUU",9) == 3190737272) strcat(s, "o");
if (crc32("JgtomWcHRCsasn",14) == 3016764139) strcat(s, "J");
if (crc32("FyhrkDdcvZSg",12) == 546051266) strcat(s, "m");
if (crc32("EyuakNKsseLQ",12) == 946603113) strcat(s, "e");
if (crc32("irmmezS",7) == 1920876213) strcat(s, "C");
if (crc32("cGpDVytJPGuZvg",14) == 4067279982) strcat(s, "t");
if (crc32("IybLL",5) == 3976409295) strcat(s, "r");
if (crc32("yrrqzdjjNeQt",12) == 2290568576) strcat(s, "i");
if (crc32("LNAGDCO",7) == 3557285687) strcat(s, "Q");
if (crc32("GRcEhHL",7) == 785435337) strcat(s, "c");
if (crc32("cxrztS",6) == 3613478516) strcat(s, "a");
if (crc32("lsAbZ",5) == 1313289243) strcat(s, "l");
if (crc32("ClOIOBLzv",9) == 3805195859) strcat(s, "l");
if (crc32("gFWwJNQOGffAKr",14) == 3363974736) strcat(s, "y");
    return s;
}

char *bigamously_adverbs() {
    char *s = calloc(11);
    if (crc32("CxskXtEnkkejMu",14) == 823963089) strcat(s, "b");
if (crc32("jzimuUGp",8) == 1839747777) strcat(s, "L");
if (crc32("vKFEVtfcL",9) == 1206330427) strcat(s, "i");
if (crc32("bpZlsKOOX",9) == 1538215958) strcat(s, "g");
if (crc32("VtKyePZ",7) == 198649375) strcat(s, "a");
if (crc32("wjXRAVhsTMKXdI",14) == 3388575821) strcat(s, "m");
if (crc32("SKzFuOfHgCiC",12) == 1236789284) strcat(s, "W");
if (crc32("zkAtXjlLydhOGZQ",15) == 1537346652) strcat(s, "o");
if (crc32("PrOmftKVqS",10) == 3383238511) strcat(s, "Z");
if (crc32("cXcRunIoGcVTBu",14) == 1765889403) strcat(s, "u");
if (crc32("PkIhGwjTFptvPPZ",15) == 1315473900) strcat(s, "s");
if (crc32("CQdIFxX",7) == 1404204728) strcat(s, "l");
if (crc32("ngfRirpNG",9) == 2248250586) strcat(s, "y");
    return s;
}

char *equationally_adverbs() {
    char *s = calloc(13);
    if (crc32("lClSZ",5) == 3744425102) strcat(s, "u");
if (crc32("mAWyKYjzcJLkSt",14) == 957246696) strcat(s, "e");
if (crc32("yJwhcR",6) == 3916604775) strcat(s, "H");
if (crc32("sWkibsKYiZcKD",13) == 995492004) strcat(s, "q");
if (crc32("bjWkqWXQTCbOw",13) == 34536918) strcat(s, "u");
if (crc32("edywuaL",7) == 2411228175) strcat(s, "P");
if (crc32("lfttOXUsQQUgUHV",15) == 3368179198) strcat(s, "a");
if (crc32("nSOlHMciZc",10) == 1656942161) strcat(s, "t");
if (crc32("ttpHJlRHPIDPQnP",15) == 3990632611) strcat(s, "i");
if (crc32("yHUZzLaXgr",10) == 1422374289) strcat(s, "o");
if (crc32("UmcEPzvHZw",10) == 2785158632) strcat(s, "c");
if (crc32("uFkCfASB",8) == 3178806493) strcat(s, "n");
if (crc32("uqESLuNxysj",11) == 3515617054) strcat(s, "a");
if (crc32("wpYZxqmMIKQEXaT",15) == 1019859542) strcat(s, "I");
if (crc32("cBCvSReWbUgubc",14) == 523670804) strcat(s, "l");
if (crc32("syIliXIJMb",10) == 2194810929) strcat(s, "l");
if (crc32("yGnzr",5) == 498168417) strcat(s, "y");
    return s;
}

char *uncriticizably_adverbs() {
    char *s = calloc(15);
    if (crc32("qshjzxcNrYgWbvz",15) == 1734207141) strcat(s, "u");
if (crc32("pesDviFkkZek",12) == 3960001323) strcat(s, "n");
if (crc32("wUrZUYryC",9) == 4068758689) strcat(s, "Y");
if (crc32("dnguKveprg",10) == 1317187402) strcat(s, "c");
if (crc32("qSWwJw",6) == 2497454162) strcat(s, "b");
if (crc32("dawpAyQWjYJBh",13) == 619360329) strcat(s, "r");
if (crc32("iBUkuAiRAFBNb",13) == 2937575198) strcat(s, "J");
if (crc32("nvpVU",5) == 224786056) strcat(s, "i");
if (crc32("JbVBqnFVNwLusG",14) == 1121395702) strcat(s, "t");
if (crc32("MbRujSxlZPpcL",13) == 4018498476) strcat(s, "R");
if (crc32("QZsgNtap",8) == 3649014434) strcat(s, "i");
if (crc32("lyaChocMVTSU",12) == 4005442586) strcat(s, "N");
if (crc32("FNjoWpmr",8) == 1083870262) strcat(s, "c");
if (crc32("IKmtTIkRuxPyAe",14) == 33080468) strcat(s, "X");
if (crc32("YBVYHSD",7) == 4132042072) strcat(s, "i");
if (crc32("qsvIf",5) == 2920027603) strcat(s, "z");
if (crc32("iygmCSO",7) == 1209561037) strcat(s, "a");
if (crc32("vQVQtVdznLbove",14) == 2798357922) strcat(s, "b");
if (crc32("YmFCwjCd",8) == 2782809728) strcat(s, "l");
if (crc32("avZzuhyDzZrzzX",14) == 336825996) strcat(s, "l");
if (crc32("ADShsag",7) == 2474638122) strcat(s, "y");
    return s;
}

char *contradictively_adverbs() {
    char *s = calloc(16);
    if (crc32("cEukx",5) == 1827398673) strcat(s, "p");
if (crc32("BtGoHfTtnMyqV",13) == 3202459469) strcat(s, "c");
if (crc32("VmIaDlDiinOzq",13) == 2916123883) strcat(s, "M");
if (crc32("FxiXakzRXHX",11) == 1691131116) strcat(s, "o");
if (crc32("bCbjOdfPwymQt",13) == 2956703458) strcat(s, "n");
if (crc32("LgWLMNas",8) == 1268802021) strcat(s, "y");
if (crc32("sxMaorRWyyuzHWm",15) == 3126363967) strcat(s, "t");
if (crc32("tEvFyqsv",8) == 3543339772) strcat(s, "k");
if (crc32("hcotaGAk",8) == 3972989992) strcat(s, "r");
if (crc32("PsLRWVlyB",9) == 444040724) strcat(s, "q");
if (crc32("LsEVuGNWIZ",10) == 2254119930) strcat(s, "a");
if (crc32("QMXklLOrydgrUaU",15) == 1831580559) strcat(s, "K");
if (crc32("eNIENcoV",8) == 7219921) strcat(s, "d");
if (crc32("xsVUjSgHa",9) == 3596361759) strcat(s, "i");
if (crc32("dLogVIViPVMdiQS",15) == 3325891891) strcat(s, "c");
if (crc32("qlDLAqeLAxAAf",13) == 1487782914) strcat(s, "t");
if (crc32("yHSRJGIEsbLrR",13) == 1888751415) strcat(s, "i");
if (crc32("NkSwHKpJmR",10) == 2502103233) strcat(s, "K");
if (crc32("ZRnxNwdTecid",12) == 4206450739) strcat(s, "v");
if (crc32("JWItrjlrsDpFki",14) == 2671073381) strcat(s, "e");
if (crc32("qeawLJEosPh",11) == 3050267840) strcat(s, "f");
if (crc32("lHaboJZDVZDaJO",14) == 759360488) strcat(s, "l");
if (crc32("Gwauts",6) == 1741912886) strcat(s, "t");
if (crc32("nSJwhkJV",8) == 1707156348) strcat(s, "y");
    return s;
}

char *oclock_adverbs() {
    char *s = calloc(7);
    if (crc32("axsTvOfR",8) == 1704017440) strcat(s, "o");
if (crc32("HfCtV",5) == 4003316524) strcat(s, "Y");
if (crc32("WNEpLxcdgepjl",13) == 900474896) strcat(s, "c");
if (crc32("rsWCcqs",7) == 2280175045) strcat(s, "O");
if (crc32("ELdffr",6) == 115770563) strcat(s, "l");
if (crc32("BYyYXIby",8) == 2920879761) strcat(s, "o");
if (crc32("TNJsOcadVEzo",12) == 3638208982) strcat(s, "O");
if (crc32("RTSWEAKnhCrnfWt",15) == 4223634533) strcat(s, "c");
if (crc32("mXbNnrpV",8) == 3182572691) strcat(s, "k");
    return s;
}

char *unhesitatively_adverbs() {
    char *s = calloc(15);
    if (crc32("pHcWdMtICGBx",12) == 4138526717) strcat(s, "k");
if (crc32("TeSOPnL",7) == 1185092705) strcat(s, "u");
if (crc32("UUoJQbSzu",9) == 523150822) strcat(s, "n");
if (crc32("yuIajBnf",8) == 3254844615) strcat(s, "S");
if (crc32("ZRJJrDGxmF",10) == 2976520565) strcat(s, "h");
if (crc32("RpAILUKorhg",11) == 1477519485) strcat(s, "x");
if (crc32("NWOnWaBalFB",11) == 2339637913) strcat(s, "e");
if (crc32("CEJhmvre",8) == 2130406123) strcat(s, "T");
if (crc32("RHoYsKIz",8) == 1565131204) strcat(s, "s");
if (crc32("DnEyLfqZiNUmsWm",15) == 1749783610) strcat(s, "i");
if (crc32("bGquIgjGTwSa",12) == 2325715259) strcat(s, "K");
if (crc32("KNxHJDsdPyB",11) == 3683251316) strcat(s, "t");
if (crc32("ZvLcRWhP",8) == 1017488852) strcat(s, "p");
if (crc32("jauzmut",7) == 27090824) strcat(s, "a");
if (crc32("PmsLeHpm",8) == 2761782519) strcat(s, "t");
if (crc32("jEvdvyFEFabP",12) == 1593956558) strcat(s, "R");
if (crc32("dxczUsz",7) == 21048077) strcat(s, "i");
if (crc32("eOdnVZDfwwqe",12) == 2403413915) strcat(s, "m");
if (crc32("msnIhOUMGv",10) == 2793682146) strcat(s, "v");
if (crc32("DDSDffNjHHpwhCb",15) == 2386304631) strcat(s, "C");
if (crc32("XqPQzLSfUKOanD",14) == 3188712445) strcat(s, "e");
if (crc32("yRZAisGB",8) == 2642567386) strcat(s, "l");
if (crc32("beZyKtKW",8) == 2396717035) strcat(s, "y");
    return s;
}

char *quasisufficiently_adverbs() {
    char *s = calloc(18);
    if (crc32("OwdyJXIKsNqLoC",14) == 1377876487) strcat(s, "q");
if (crc32("XZLUIVfIRkoEl",13) == 216157494) strcat(s, "u");
if (crc32("kzhLaHAd",8) == 2588002754) strcat(s, "t");
if (crc32("SjkKgV",6) == 3490099092) strcat(s, "a");
if (crc32("HUQmAspnoRc",11) == 615122529) strcat(s, "s");
if (crc32("oUSnijr",7) == 2085581127) strcat(s, "Q");
if (crc32("HXIDTXBXIe",10) == 4048946222) strcat(s, "i");
if (crc32("YrcBhTHXska",11) == 2292241022) strcat(s, "Y");
if (crc32("yBdnHdHuPtn",11) == 3981411151) strcat(s, "s");
if (crc32("oFWueA",6) == 2933227876) strcat(s, "R");
if (crc32("DLOsXTBHpDlJ",12) == 182122088) strcat(s, "u");
if (crc32("FOMAFbkRioZ",11) == 872237060) strcat(s, "f");
if (crc32("qGeyc",5) == 972222963) strcat(s, "q");
if (crc32("abOuDPbGwiQBT",13) == 1534044757) strcat(s, "f");
if (crc32("aIPQystYqmq",11) == 2092208764) strcat(s, "D");
if (crc32("AaojutLAqoi",11) == 2481290291) strcat(s, "i");
if (crc32("tvsxSYZSiFl",11) == 1597437979) strcat(s, "c");
if (crc32("zezujCHBDjTgCx",14) == 2016902925) strcat(s, "i");
if (crc32("KoXeN",5) == 1627780461) strcat(s, "e");
if (crc32("GywSnnSTB",9) == 2418882320) strcat(s, "Y");
if (crc32("UHodOU",6) == 3313064311) strcat(s, "n");
if (crc32("ZEgqf",5) == 3341211911) strcat(s, "t");
if (crc32("qPOJtGbeXnPrgs",14) == 1850201867) strcat(s, "l");
if (crc32("SqATmdLLM",9) == 1098598899) strcat(s, "Y");
if (crc32("dsFuSHTNfHAqo",13) == 1035672539) strcat(s, "y");
    return s;
}

char *unstylishly_adverbs() {
    char *s = calloc(12);
    if (crc32("nvwrqDqMcmbDMcg",15) == 2380402037) strcat(s, "t");
if (crc32("CIqzVWlvBLJAtwA",15) == 4189469051) strcat(s, "u");
if (crc32("IKGvOdmoOVa",11) == 4266123676) strcat(s, "n");
if (crc32("lltphSPhvVYihAN",15) == 2506364451) strcat(s, "y");
if (crc32("jLTrRiz",7) == 2906830284) strcat(s, "s");
if (crc32("SIWoTgTgHNsL",12) == 965419968) strcat(s, "t");
if (crc32("ZRlPMeQEPl",10) == 3561713474) strcat(s, "f");
if (crc32("fgBDWUrLey",10) == 3020969707) strcat(s, "y");
if (crc32("lPIQvifKRXfSbt",14) == 147668072) strcat(s, "l");
if (crc32("NSsREtQfoPl",11) == 1128075890) strcat(s, "i");
if (crc32("MhFcuuouQMdgZR",14) == 3146525287) strcat(s, "T");
if (crc32("jiqwk",5) == 3164829182) strcat(s, "s");
if (crc32("bmAfPCMSr",9) == 3814845655) strcat(s, "M");
if (crc32("XxJavuIQHpMjO",13) == 129943369) strcat(s, "h");
if (crc32("gLKKOSPTlJfQ",12) == 3035173143) strcat(s, "X");
if (crc32("tobuymSacD",10) == 1362036968) strcat(s, "l");
if (crc32("nqBIdzlZEbUoD",13) == 2374399816) strcat(s, "y");
    return s;
}

char *quasidutifully_adverbs() {
    char *s = calloc(15);
    if (crc32("hVmMKpi",7) == 2426455841) strcat(s, "q");
if (crc32("hVhBWcV",7) == 3264638652) strcat(s, "u");
if (crc32("RGXyhWlnPrXE",12) == 4139845191) strcat(s, "a");
if (crc32("CpokvRIGOO",10) == 3936010289) strcat(s, "d");
if (crc32("IcrSF",5) == 3809395652) strcat(s, "s");
if (crc32("pHyPFY",6) == 3376356106) strcat(s, "X");
if (crc32("gutaKPNmVOKUPwU",15) == 3261153625) strcat(s, "i");
if (crc32("LYAgkXSXpOKCWe",14) == 569260118) strcat(s, "a");
if (crc32("xtKlpENB",8) == 3500895255) strcat(s, "d");
if (crc32("nuIRhnjGW",9) == 2063706085) strcat(s, "u");
if (crc32("CfXYwMeRJVQJc",13) == 466251666) strcat(s, "S");
if (crc32("xczjhzejq",9) == 1236125274) strcat(s, "t");
if (crc32("qMrkDPFJsmB",11) == 1109205704) strcat(s, "p");
if (crc32("ZvKdKaA",7) == 1562888086) strcat(s, "i");
if (crc32("ZQCkfUPALi",10) == 4204751759) strcat(s, "f");
if (crc32("XTdIBYzgcYgTbn",14) == 911377143) strcat(s, "u");
if (crc32("HDOyYBeE",8) == 3272827544) strcat(s, "f");
if (crc32("pytKZjbPfMHFeO",14) == 2824927736) strcat(s, "l");
if (crc32("vVCNv",5) == 4220925719) strcat(s, "l");
if (crc32("MhsaEE",6) == 2896902412) strcat(s, "S");
if (crc32("KBjpfKrYEg",10) == 3589956724) strcat(s, "y");
    return s;
}

char *illicitly_adverbs() {
    char *s = calloc(10);
    if (crc32("lVSGQNRARlxcB",13) == 1139944618) strcat(s, "i");
if (crc32("HsefKQqgbCl",11) == 3149291956) strcat(s, "b");
if (crc32("pjWGOztdK",9) == 3471376306) strcat(s, "l");
if (crc32("xyQFD",5) == 920802856) strcat(s, "R");
if (crc32("Hznlq",5) == 102770502) strcat(s, "l");
if (crc32("SUyxYVXg",8) == 1432955862) strcat(s, "i");
if (crc32("BdgLbtEIFH",10) == 2450948444) strcat(s, "S");
if (crc32("OecbAzaunzd",11) == 2213086584) strcat(s, "c");
if (crc32("WyRMDUmhIPoDsDh",15) == 708101044) strcat(s, "p");
if (crc32("sjQxUr",6) == 3210893582) strcat(s, "i");
if (crc32("YtYZTrTdSXMuk",13) == 263621481) strcat(s, "t");
if (crc32("mJFunsFtVsrB",12) == 2258121230) strcat(s, "u");
if (crc32("NurWYo",6) == 2870177782) strcat(s, "l");
if (crc32("kRkcnm",6) == 4113199758) strcat(s, "u");
if (crc32("qunNkDwO",8) == 1931272135) strcat(s, "y");
    return s;
}

char *tearily_adverbs() {
    char *s = calloc(8);
    if (crc32("JVwgmsQbtj",10) == 3631587580) strcat(s, "y");
if (crc32("YgzOifQTDR",10) == 564603228) strcat(s, "t");
if (crc32("dkutPuauhtW",11) == 1219636106) strcat(s, "e");
if (crc32("DqacTqRuiaFGPBD",15) == 3604077303) strcat(s, "a");
if (crc32("hcwAsCtB",8) == 139373979) strcat(s, "c");
if (crc32("CTSFkFOXe",9) == 2141652416) strcat(s, "r");
if (crc32("JgtFLS",6) == 150651698) strcat(s, "F");
if (crc32("galfrdoFB",9) == 450692585) strcat(s, "i");
if (crc32("muFalnSJ",8) == 196665722) strcat(s, "a");
if (crc32("eNEeMKxkPos",11) == 3832158294) strcat(s, "l");
if (crc32("eNFEYuQ",7) == 662711080) strcat(s, "y");
    return s;
}

char *nostalgically_adverbs() {
    char *s = calloc(14);
    if (crc32("GYTJqMyMT",9) == 2969028806) strcat(s, "n");
if (crc32("BaOzucsDbqNbVeC",15) == 343244632) strcat(s, "o");
if (crc32("xqubQcKMQFe",11) == 703272332) strcat(s, "Y");
if (crc32("KMZGgznAXYk",11) == 54143030) strcat(s, "s");
if (crc32("CRQRYQBTswpYtiI",15) == 3606466976) strcat(s, "t");
if (crc32("GnsBsFLdJNCSKMn",15) == 45766019) strcat(s, "a");
if (crc32("egIqvXosBJhNT",13) == 2993908768) strcat(s, "L");
if (crc32("kdZvmYjvpbXY",12) == 2372986510) strcat(s, "l");
if (crc32("eILpU",5) == 2984357651) strcat(s, "o");
if (crc32("gHnkhYKgEpy",11) == 3969421762) strcat(s, "g");
if (crc32("tYtKtLeDtUmMA",13) == 3114821630) strcat(s, "q");
if (crc32("GSxmHiECxyl",11) == 1744095022) strcat(s, "i");
if (crc32("rjoAecyA",8) == 3403166039) strcat(s, "c");
if (crc32("VitsgFldtM",10) == 3985163465) strcat(s, "c");
if (crc32("OrpQHAgb",8) == 1187073953) strcat(s, "a");
if (crc32("KXHleWbUClNs",12) == 1572684621) strcat(s, "k");
if (crc32("iJtiNGVSgWIDPKR",15) == 2034624947) strcat(s, "l");
if (crc32("hVRCICRcnB",10) == 1026499241) strcat(s, "l");
if (crc32("HVjXTNTcgnNKBjm",15) == 2563092155) strcat(s, "w");
if (crc32("JpObQUErSgJbJWk",15) == 2224445296) strcat(s, "y");
    return s;
}

char *unsmirkingly_adverbs() {
    char *s = calloc(13);
    if (crc32("xjjqTHkAW",9) == 3690718500) strcat(s, "H");
if (crc32("ulifuQxKEcphBlK",15) == 676147519) strcat(s, "u");
if (crc32("ULLBV",5) == 4216304632) strcat(s, "R");
if (crc32("mdtmwmpGjBp",11) == 2077526349) strcat(s, "n");
if (crc32("JVqeSXO",7) == 2507262809) strcat(s, "s");
if (crc32("rQajBkDGbHQ",11) == 3835961561) strcat(s, "m");
if (crc32("GtsHPbxGtICmt",13) == 3253411770) strcat(s, "g");
if (crc32("WvOLuTBSQzgpop",14) == 1698886388) strcat(s, "i");
if (crc32("RdMKwEJ",7) == 1907985385) strcat(s, "u");
if (crc32("UAoUSO",6) == 4141158534) strcat(s, "r");
if (crc32("lhcLkOcnlzSS",12) == 1647212986) strcat(s, "k");
if (crc32("ljafXSfPB",9) == 3833159423) strcat(s, "m");
if (crc32("QPmJF",5) == 3715761565) strcat(s, "i");
if (crc32("IKRmVnuWf",9) == 3011448475) strcat(s, "h");
if (crc32("gZfhbAuKaDAt",12) == 3358704633) strcat(s, "n");
if (crc32("fZZRL",5) == 3794535229) strcat(s, "g");
if (crc32("ezxhXeWaNLLsQN",14) == 1120555733) strcat(s, "l");
if (crc32("VzRnnQqcOhN",11) == 903762462) strcat(s, "y");
    return s;
}

char *circumstantially_adverbs() {
    char *s = calloc(17);
    if (crc32("DNTprYatyB",10) == 1231961826) strcat(s, "s");
if (crc32("xMXrlW",6) == 2472266104) strcat(s, "c");
if (crc32("JTHiCRy",7) == 3292240974) strcat(s, "K");
if (crc32("qsviPUvdtUBgp",13) == 2328395625) strcat(s, "i");
if (crc32("UxviNeT",7) == 3659763225) strcat(s, "r");
if (crc32("kkqcKRgTqS",10) == 3763415253) strcat(s, "r");
if (crc32("bHfnKLIvOlwfYB",14) == 1275418238) strcat(s, "A");
if (crc32("AqrTDvUVSHIb",12) == 3740596025) strcat(s, "c");
if (crc32("NdVtlN",6) == 2544479507) strcat(s, "y");
if (crc32("RUlXXmwW",8) == 2942235313) strcat(s, "u");
if (crc32("PNZGg",5) == 2285867399) strcat(s, "m");
if (crc32("iswyxYcaenOOpD",14) == 1693666253) strcat(s, "F");
if (crc32("FVDUKSXu",8) == 3725450613) strcat(s, "s");
if (crc32("ppmnr",5) == 3230200777) strcat(s, "o");
if (crc32("nivPoIpXguVffm",14) == 3300798588) strcat(s, "t");
if (crc32("uskbRmwizelSFGC",15) == 3076098955) strcat(s, "a");
if (crc32("yKgErErGNRlkGIU",15) == 1721202803) strcat(s, "S");
if (crc32("YnpHVRE",7) == 1487361510) strcat(s, "n");
if (crc32("CmRjL",5) == 2675805714) strcat(s, "t");
if (crc32("thosaAZFHUD",11) == 2879697644) strcat(s, "i");
if (crc32("FgEcTI",6) == 1952276381) strcat(s, "a");
if (crc32("TJJgM",5) == 2697260564) strcat(s, "l");
if (crc32("WdbZCP",6) == 2361430461) strcat(s, "l");
if (crc32("nXftZUDoQULsn",13) == 464589965) strcat(s, "y");
    return s;
}

char *undestructibly_adverbs() {
    char *s = calloc(15);
    if (crc32("oBBbrTQnMvBDXW",14) == 2574469933) strcat(s, "u");
if (crc32("gBeesrM",7) == 2400454958) strcat(s, "n");
if (crc32("VISIQXypJEsa",12) == 3314741817) strcat(s, "d");
if (crc32("RMKlKQVhAeS",11) == 2822575674) strcat(s, "e");
if (crc32("bidObDyps",9) == 1317189495) strcat(s, "d");
if (crc32("pgFTIJn",7) == 687757364) strcat(s, "s");
if (crc32("FuBuvDhrmu",10) == 908148937) strcat(s, "t");
if (crc32("MZwQInAuYpH",11) == 996766845) strcat(s, "r");
if (crc32("RAZlOei",7) == 3715284270) strcat(s, "r");
if (crc32("KbSGj",5) == 76243104) strcat(s, "u");
if (crc32("fykBUG",6) == 1498638409) strcat(s, "W");
if (crc32("pRsIODIw",8) == 4266888852) strcat(s, "c");
if (crc32("GkRifm",6) == 1809529705) strcat(s, "t");
if (crc32("wibtoipaheTfPm",14) == 950585101) strcat(s, "i");
if (crc32("CeKSFF",6) == 2916081664) strcat(s, "j");
if (crc32("gIXkpSeK",8) == 2632039720) strcat(s, "b");
if (crc32("YtyIiahRZVls",12) == 343919324) strcat(s, "Z");
if (crc32("ikfYWSnSeb",10) == 3498729462) strcat(s, "l");
if (crc32("apwUIyEWzmjqlYh",15) == 1902624865) strcat(s, "Z");
if (crc32("zmjhYHUFPDVBs",13) == 2317083976) strcat(s, "y");
    return s;
}

char *feverishly_adverbs() {
    char *s = calloc(11);
    if (crc32("WQaTjfdSCVQKN",13) == 3380507282) strcat(s, "f");
if (crc32("FldUj",5) == 1158959332) strcat(s, "e");
if (crc32("qAbRcUVVXB",10) == 119014943) strcat(s, "v");
if (crc32("HrCvSTGNwLJjrU",14) == 1588431887) strcat(s, "e");
if (crc32("HSgIsPXeJJucg",13) == 1166182419) strcat(s, "r");
if (crc32("mDAMocGzaziks",13) == 3856086334) strcat(s, "s");
if (crc32("knzpOO",6) == 872591477) strcat(s, "i");
if (crc32("sKIFILm",7) == 3731585309) strcat(s, "s");
if (crc32("UmuWNj",6) == 209408850) strcat(s, "W");
if (crc32("oZBwZqqwTGKDZT",14) == 1504040775) strcat(s, "h");
if (crc32("YdZOTivRJzQbY",13) == 1337505284) strcat(s, "l");
if (crc32("IJxJRIXvmvnCDdd",15) == 2869020348) strcat(s, "M");
if (crc32("snavOIWMkRDKdV",14) == 3133084268) strcat(s, "y");
    return s;
}

char *supersaintly_adverbs() {
    char *s = calloc(13);
    if (crc32("BgtdnMATDSB",11) == 88532538) strcat(s, "a");
if (crc32("ojFmOrreitC",11) == 281790975) strcat(s, "s");
if (crc32("OaryTbTHNPcgKgD",15) == 2189553326) strcat(s, "R");
if (crc32("vKYHqsnbPH",10) == 1435343987) strcat(s, "u");
if (crc32("loZUtL",6) == 795360458) strcat(s, "p");
if (crc32("OPvozQLRUExjk",13) == 2835127843) strcat(s, "C");
if (crc32("gSrGiQZsPh",10) == 3588940494) strcat(s, "e");
if (crc32("OxqLnZAMd",9) == 1458575041) strcat(s, "r");
if (crc32("BespbQecIbaskl",14) == 2175663367) strcat(s, "s");
if (crc32("ueMKJ",5) == 1396609727) strcat(s, "e");
if (crc32("CaDEUIbx",8) == 1638300545) strcat(s, "a");
if (crc32("HSUoWpbMvH",10) == 1163296118) strcat(s, "i");
if (crc32("QayiOFchcGzRm",13) == 1168259318) strcat(s, "R");
if (crc32("yDPvhLVnn",9) == 2830444833) strcat(s, "n");
if (crc32("mJVaHBoRYwW",11) == 3713592566) strcat(s, "t");
if (crc32("SxUqMVLWXxp",11) == 3222712597) strcat(s, "y");
if (crc32("WSpafvtvFLpiisW",15) == 1120024031) strcat(s, "l");
if (crc32("pVwTEDLCrgcejb",14) == 3437959090) strcat(s, "y");
    return s;
}

char *lachrymosely_adverbs() {
    char *s = calloc(13);
    if (crc32("tVnsTIvo",8) == 519955640) strcat(s, "l");
if (crc32("EITWYufAcpoB",12) == 3907525162) strcat(s, "m");
if (crc32("YMGSaN",6) == 3214647928) strcat(s, "a");
if (crc32("zNUwPpNxG",9) == 781837316) strcat(s, "d");
if (crc32("wKmChmdl",8) == 3582614577) strcat(s, "c");
if (crc32("SuwZW",5) == 1667062170) strcat(s, "p");
if (crc32("oYKbHxFPxFgJkj",14) == 113612801) strcat(s, "h");
if (crc32("gbIHcEWHHgl",11) == 1851402459) strcat(s, "r");
if (crc32("AFDqyALtBvQiU",13) == 3408116267) strcat(s, "y");
if (crc32("viMOFV",6) == 3456633884) strcat(s, "m");
if (crc32("LrBtGBvKyYsdhB",14) == 2797977430) strcat(s, "b");
if (crc32("YVOonEjOHpWynPl",15) == 792670664) strcat(s, "o");
if (crc32("LMwerdM",7) == 1747064368) strcat(s, "X");
if (crc32("iQJvlPZHJZwPyy",14) == 1886655025) strcat(s, "s");
if (crc32("hvcseObARwcWF",13) == 3996150633) strcat(s, "e");
if (crc32("JWrfiWnF",8) == 545905250) strcat(s, "l");
if (crc32("OjHVg",5) == 2600181877) strcat(s, "z");
if (crc32("qxqAFsJmA",9) == 4072899882) strcat(s, "y");
    return s;
}

char *quasicynically_adverbs() {
    char *s = calloc(15);
    if (crc32("cMytvlIQagCiPYi",15) == 2994442782) strcat(s, "A");
if (crc32("rxcwU",5) == 3663066098) strcat(s, "q");
if (crc32("dNZEz",5) == 43554927) strcat(s, "f");
if (crc32("lTebLWnStP",10) == 3831450610) strcat(s, "u");
if (crc32("WOXAMu",6) == 1622352437) strcat(s, "a");
if (crc32("wZmoeOEGLP",10) == 1246857183) strcat(s, "s");
if (crc32("aBrcsIh",7) == 1826165541) strcat(s, "i");
if (crc32("MXPOVYFMxzx",11) == 813064532) strcat(s, "f");
if (crc32("BWkJXxQwQF",10) == 895728312) strcat(s, "c");
if (crc32("VWdNViC",7) == 3896530937) strcat(s, "y");
if (crc32("chdipG",6) == 2720390629) strcat(s, "n");
if (crc32("jtRLvBf",7) == 2220003969) strcat(s, "V");
if (crc32("rARyn",5) == 1565986772) strcat(s, "i");
if (crc32("NhFuhRPyYqFw",12) == 2776408843) strcat(s, "c");
if (crc32("AXamZD",6) == 2393507879) strcat(s, "k");
if (crc32("rFMWfDBhAoMYFI",14) == 3366675187) strcat(s, "a");
if (crc32("hmPXFkwcGyup",12) == 1337627186) strcat(s, "Y");
if (crc32("yOUwcFF",7) == 1870943230) strcat(s, "l");
if (crc32("wKypfVsbqGz",11) == 1839438576) strcat(s, "l");
if (crc32("MfuTCSLkEBNTrR",14) == 3238379321) strcat(s, "y");
    return s;
}

char *wellnigh_adverbs() {
    char *s = calloc(9);
    if (crc32("LJQuIicIMpV",11) == 2890367194) strcat(s, "w");
if (crc32("TYlJScvJ",8) == 346857632) strcat(s, "x");
if (crc32("aavbbjYNwzqDKh",14) == 3278929478) strcat(s, "e");
if (crc32("nBEPUEe",7) == 3565791310) strcat(s, "L");
if (crc32("yodxSP",6) == 2463505385) strcat(s, "l");
if (crc32("fycfKUf",7) == 2250920119) strcat(s, "l");
if (crc32("EmiRUHNWfcQWwZ",14) == 3656934657) strcat(s, "n");
if (crc32("IwFxL",5) == 2310167095) strcat(s, "i");
if (crc32("GsvxHGWPEamSYv",14) == 3871597015) strcat(s, "m");
if (crc32("WszVfFbiTTwG",12) == 4085783354) strcat(s, "g");
if (crc32("kOVQsKdOPDqgUE",14) == 3138554921) strcat(s, "h");
    return s;
}

char *untactfully_adverbs() {
    char *s = calloc(12);
    if (crc32("RUqGBoJfyW",10) == 1829478939) strcat(s, "u");
if (crc32("ZDXdKv",6) == 2300361355) strcat(s, "X");
if (crc32("ZEdLgS",6) == 2581509333) strcat(s, "n");
if (crc32("WtSvtmXqfpKv",12) == 2853478507) strcat(s, "t");
if (crc32("OcGejadgMU",10) == 2761586885) strcat(s, "A");
if (crc32("zHcpSuFc",8) == 2717787778) strcat(s, "a");
if (crc32("Xhxyl",5) == 3502799583) strcat(s, "c");
if (crc32("dQJhT",5) == 475393713) strcat(s, "B");
if (crc32("ikJebjJEWXhtOv",14) == 703166162) strcat(s, "t");
if (crc32("OUnjz",5) == 3827294172) strcat(s, "o");
if (crc32("PkZGVjvVdGjsQls",15) == 19525103) strcat(s, "f");
if (crc32("PQIyTqoVmQx",11) == 3514159942) strcat(s, "S");
if (crc32("YkcVexHvLRAR",12) == 2458046011) strcat(s, "u");
if (crc32("Icrmm",5) == 242688505) strcat(s, "l");
if (crc32("AjjETgMahVhBKa",14) == 3158265552) strcat(s, "l");
if (crc32("prwhdDlkLMG",11) == 2146433205) strcat(s, "y");
    return s;
}

char *heartbrokenly_adverbs() {
    char *s = calloc(14);
    if (crc32("RWSjydOa",8) == 3648415664) strcat(s, "h");
if (crc32("fkVNQZ",6) == 3001911848) strcat(s, "R");
if (crc32("npyDB",5) == 3707267023) strcat(s, "e");
if (crc32("tUNPAVRvFdSFnB",14) == 3574039592) strcat(s, "l");
if (crc32("hZtbLIzzemdzZ",13) == 1943674238) strcat(s, "a");
if (crc32("iBNTOw",6) == 368372271) strcat(s, "r");
if (crc32("hbBUZvkKsJZrk",13) == 3271609295) strcat(s, "t");
if (crc32("ChpmdC",6) == 1412998027) strcat(s, "b");
if (crc32("UzwJYtcApM",10) == 3349035646) strcat(s, "r");
if (crc32("wmiRTPOX",8) == 2122093749) strcat(s, "o");
if (crc32("fTuYrFAwCKDA",12) == 3781841703) strcat(s, "u");
if (crc32("ASvOIFectXViuhr",15) == 2583450262) strcat(s, "k");
if (crc32("jmrKORZyzMYMrgn",15) == 2395886290) strcat(s, "e");
if (crc32("OMysKhfyaDD",11) == 905141496) strcat(s, "n");
if (crc32("NhMldpe",7) == 598942344) strcat(s, "c");
if (crc32("wwCZYTbRT",9) == 3525109364) strcat(s, "l");
if (crc32("TgnIyAzzOr",10) == 11503140) strcat(s, "A");
if (crc32("dzFoqNyW",8) == 428709499) strcat(s, "y");
    return s;
}

char *algometrically_adverbs() {
    char *s = calloc(15);
    if (crc32("LUgSGjEwZNiXXR",14) == 1997372840) strcat(s, "a");
if (crc32("YxALdYOgedpJJ",13) == 4055978015) strcat(s, "l");
if (crc32("WdrIS",5) == 2096745646) strcat(s, "g");
if (crc32("HnPBEI",6) == 1322710262) strcat(s, "o");
if (crc32("mOVqkrFMai",10) == 1887100128) strcat(s, "m");
if (crc32("vJFZnyobGvcsWXb",15) == 4057427662) strcat(s, "e");
if (crc32("ltaIFkTX",8) == 764418772) strcat(s, "t");
if (crc32("fETkfj",6) == 1632723598) strcat(s, "r");
if (crc32("RneMYfqH",8) == 2813571246) strcat(s, "D");
if (crc32("YwWXjIxwnF",10) == 451441865) strcat(s, "i");
if (crc32("xwWniak",7) == 47379502) strcat(s, "z");
if (crc32("XilMlrvGuJTZRbu",15) == 3883042930) strcat(s, "c");
if (crc32("TjXCqyIgppNfq",13) == 3745194169) strcat(s, "a");
if (crc32("zIFoVHxw",8) == 4062900241) strcat(s, "l");
if (crc32("rQFHUKsoCSWUV",13) == 1130252125) strcat(s, "l");
if (crc32("adNrTtwXMuuG",12) == 548543582) strcat(s, "y");
    return s;
}

char *glycolytically_adverbs() {
    char *s = calloc(15);
    if (crc32("fSWVMDtd",8) == 3626122004) strcat(s, "g");
if (crc32("cRqOzzogjsTLm",13) == 3065404723) strcat(s, "Z");
if (crc32("yOrUxzIcns",10) == 3179882924) strcat(s, "l");
if (crc32("WcXLtZEXBKIzBsW",15) == 704916195) strcat(s, "L");
if (crc32("vcMddCX",7) == 2041126347) strcat(s, "y");
if (crc32("pKOtfCmwpu",10) == 4111606003) strcat(s, "j");
if (crc32("eLDqgKVz",8) == 2834702549) strcat(s, "c");
if (crc32("hjhbqAOJbjEeS",13) == 2472260186) strcat(s, "o");
if (crc32("VZLAVsXOq",9) == 21753102) strcat(s, "x");
if (crc32("IcOEvPCyvoZw",12) == 1402144914) strcat(s, "l");
if (crc32("ykDmBaeSqcluv",13) == 3509482902) strcat(s, "y");
if (crc32("bCflvNVqAzpoUH",14) == 3544809043) strcat(s, "o");
if (crc32("uwnsV",5) == 3316332633) strcat(s, "t");
if (crc32("bUrCXRpNVuJO",12) == 2883247511) strcat(s, "q");
if (crc32("ZmnNbYD",7) == 2733764603) strcat(s, "i");
if (crc32("uhqUprmWMFHl",12) == 2220256072) strcat(s, "c");
if (crc32("RjnvkcTtRxqaIP",14) == 696674159) strcat(s, "a");
if (crc32("mJtjMkfwYM",10) == 3058855591) strcat(s, "N");
if (crc32("WfOGFWE",7) == 4270376162) strcat(s, "l");
if (crc32("EsOrHgFmSJCJ",12) == 3759368367) strcat(s, "l");
if (crc32("olwbgPGydkDPZm",14) == 2852791485) strcat(s, "y");
    return s;
}

char *noninstructively_adverbs() {
    char *s = calloc(17);
    if (crc32("JBbwgByyseRiNvB",15) == 4073043158) strcat(s, "n");
if (crc32("odjiDE",6) == 2783712631) strcat(s, "o");
if (crc32("dNiThD",6) == 879382532) strcat(s, "n");
if (crc32("UKQSrIYcfeYA",12) == 283641724) strcat(s, "i");
if (crc32("FOFCx",5) == 595265061) strcat(s, "i");
if (crc32("dyzcGXieS",9) == 3680858171) strcat(s, "n");
if (crc32("kXSfmvEOJ",9) == 3391292442) strcat(s, "s");
if (crc32("XIfnGYPjWnw",11) == 3137649575) strcat(s, "t");
if (crc32("eLaCwK",6) == 80633556) strcat(s, "r");
if (crc32("IMlqlPAJgrFoqJV",15) == 1165084803) strcat(s, "u");
if (crc32("bjxNeh",6) == 2819636783) strcat(s, "c");
if (crc32("tFstAHjMtgHuD",13) == 1783089762) strcat(s, "t");
if (crc32("kfkpcPWoX",9) == 2699056685) strcat(s, "y");
if (crc32("mSCuRtsTkySTJ",13) == 2991864540) strcat(s, "i");
if (crc32("XccnxuMkFRgn",12) == 3181624103) strcat(s, "I");
if (crc32("itXQKuoFNrD",11) == 1106790462) strcat(s, "v");
if (crc32("ZTQDPMQUOytPN",13) == 2149969748) strcat(s, "e");
if (crc32("BEapar",6) == 1992781629) strcat(s, "l");
if (crc32("jbWZPkDpakil",12) == 2333290864) strcat(s, "y");
    return s;
}

char *quasiheartily_adverbs() {
    char *s = calloc(14);
    if (crc32("DGZitozX",8) == 1742247240) strcat(s, "q");
if (crc32("dAbekwBvlrlZtmZ",15) == 899511995) strcat(s, "m");
if (crc32("NRSEJcxuIljdg",13) == 590619161) strcat(s, "u");
if (crc32("sVQScjJ",7) == 91940559) strcat(s, "a");
if (crc32("tHRZzHpuAv",10) == 1124021132) strcat(s, "s");
if (crc32("EHTVppR",7) == 4047444935) strcat(s, "L");
if (crc32("hamjqkAPx",9) == 3814026494) strcat(s, "i");
if (crc32("tKiggROqJgKZZ",13) == 1925306303) strcat(s, "h");
if (crc32("yzRIoSzfA",9) == 1864989524) strcat(s, "L");
if (crc32("zNTYYD",6) == 3245508466) strcat(s, "e");
if (crc32("ZVWQrcjMvNozs",13) == 302170235) strcat(s, "R");
if (crc32("zGOvF",5) == 4003438559) strcat(s, "a");
if (crc32("VEWpmAegM",9) == 1168867073) strcat(s, "r");
if (crc32("JSFlYRChe",9) == 2996781820) strcat(s, "g");
if (crc32("obhMTgNTkn",10) == 391219187) strcat(s, "t");
if (crc32("fkJzwSHQCnGXq",13) == 913099346) strcat(s, "i");
if (crc32("uDnOMtWCWXbYxcv",15) == 2134044551) strcat(s, "H");
if (crc32("mPCvZdiqNZw",11) == 1671664565) strcat(s, "l");
if (crc32("EYEFElkjrPnCD",13) == 1765923491) strcat(s, "H");
if (crc32("kFumTOeSYgU",11) == 2300740815) strcat(s, "y");
    return s;
}

char *galvanically_adverbs() {
    char *s = calloc(13);
    if (crc32("CDKtZpvSBQFLd",13) == 1268088517) strcat(s, "g");
if (crc32("KTSHueYb",8) == 4277017259) strcat(s, "a");
if (crc32("aApRJNKDKLrLB",13) == 4243626153) strcat(s, "l");
if (crc32("nStsNFyCzIjr",12) == 2907414731) strcat(s, "S");
if (crc32("qiPXVyEVUKR",11) == 1670051822) strcat(s, "v");
if (crc32("xVKcrHafz",9) == 2228170015) strcat(s, "y");
if (crc32("vGyuNinKGkXpYLN",15) == 823500935) strcat(s, "a");
if (crc32("GbVxKZtsqTdduGX",15) == 1283847817) strcat(s, "P");
if (crc32("mbJjYMwOQTaro",13) == 54859214) strcat(s, "n");
if (crc32("VZgdAHYRxPZnvw",14) == 968600300) strcat(s, "x");
if (crc32("QQNfuoZXf",9) == 903503901) strcat(s, "i");
if (crc32("lIlwFkJKIWSIAi",14) == 3717395589) strcat(s, "c");
if (crc32("uxzRbySBk",9) == 1825113953) strcat(s, "e");
if (crc32("UoOrjxYi",8) == 694682815) strcat(s, "a");
if (crc32("pbYbQd",6) == 3034169506) strcat(s, "f");
if (crc32("rjbIiR",6) == 4220783476) strcat(s, "l");
if (crc32("zMHYAvR",7) == 1570040508) strcat(s, "e");
if (crc32("AaUCEDyfKNhbdvo",15) == 1008101972) strcat(s, "l");
if (crc32("dcQCwRi",7) == 1528823987) strcat(s, "s");
if (crc32("OLHAtnyMBY",10) == 2762330228) strcat(s, "y");
    return s;
}

char *autohypnotically_adverbs() {
    char *s = calloc(17);
    if (crc32("gsdiYpbQECmNrc",14) == 2812970488) strcat(s, "a");
if (crc32("PZpJlsHqLOv",11) == 945166673) strcat(s, "u");
if (crc32("NOrjchIOE",9) == 4234179503) strcat(s, "t");
if (crc32("UcpqoYtmX",9) == 2202857308) strcat(s, "X");
if (crc32("bVXmr",5) == 3342989756) strcat(s, "o");
if (crc32("loGvai",6) == 3416357218) strcat(s, "h");
if (crc32("QmGtB",5) == 2890480051) strcat(s, "y");
if (crc32("shxwO",5) == 1513961526) strcat(s, "p");
if (crc32("TnSgECRox",9) == 1045028841) strcat(s, "L");
if (crc32("gMFyvcfGXG",10) == 2613386761) strcat(s, "n");
if (crc32("YRTQHCxtlE",10) == 3139363405) strcat(s, "k");
if (crc32("XezlrgQxtOqtM",13) == 2228942221) strcat(s, "o");
if (crc32("wxISWeLc",8) == 3680844072) strcat(s, "t");
if (crc32("PzzivvPJD",9) == 3782602734) strcat(s, "i");
if (crc32("iNHnlOLWe",9) == 1104371325) strcat(s, "c");
if (crc32("gOUcPXxRXgmV",12) == 3662592684) strcat(s, "K");
if (crc32("dfCNNCfUUIU",11) == 2884598155) strcat(s, "a");
if (crc32("yUQAKQ",6) == 2761353063) strcat(s, "E");
if (crc32("ZoVaEnLCGFjmYs",14) == 3690258840) strcat(s, "l");
if (crc32("wcNbqPIrLtH",11) == 1962425986) strcat(s, "Q");
if (crc32("TLdRRojMRWioDpL",15) == 2835027142) strcat(s, "l");
if (crc32("owmurzeRPCIwh",13) == 2782021993) strcat(s, "k");
if (crc32("EprKGoncLeKe",12) == 2148394267) strcat(s, "y");
    return s;
}

char *suffusedly_adverbs() {
    char *s = calloc(11);
    if (crc32("eHeDsmOFSbJ",11) == 2715890773) strcat(s, "F");
if (crc32("JSUYamqp",8) == 62273286) strcat(s, "s");
if (crc32("yCAmMTEh",8) == 2148853128) strcat(s, "S");
if (crc32("HbzyrtgrIBtrleg",15) == 3711370886) strcat(s, "u");
if (crc32("gBWuUGpSYMceTyf",15) == 3101446529) strcat(s, "r");
if (crc32("XqOXqyXkkBJziSD",15) == 1242801462) strcat(s, "f");
if (crc32("uFsPEXQNlS",10) == 2291843606) strcat(s, "G");
if (crc32("HXHmMaxToHrHK",13) == 704822881) strcat(s, "f");
if (crc32("fDbMfEIOy",9) == 1350787606) strcat(s, "u");
if (crc32("LHgBxa",6) == 2842119192) strcat(s, "s");
if (crc32("cVeVv",5) == 2942115643) strcat(s, "C");
if (crc32("OyIjKZC",7) == 3509873773) strcat(s, "e");
if (crc32("KJjTFukuXuQzp",13) == 2863648482) strcat(s, "d");
if (crc32("rUDnq",5) == 2450916128) strcat(s, "H");
if (crc32("GuQnMiWDA",9) == 359042814) strcat(s, "l");
if (crc32("ZlVHXneYvR",10) == 1175220744) strcat(s, "y");
    return s;
}

char *unreprobatively_adverbs() {
    char *s = calloc(16);
    if (crc32("wIuhhHXhx",9) == 2019113528) strcat(s, "u");
if (crc32("NQqvSNKxaCKD",12) == 1902112644) strcat(s, "n");
if (crc32("UQvNGfbhDJl",11) == 3374181637) strcat(s, "k");
if (crc32("CUvQmtvSB",9) == 2289915507) strcat(s, "r");
if (crc32("zFIBKSMldki",11) == 488323909) strcat(s, "e");
if (crc32("udzRdNYaTkxm",12) == 2175818776) strcat(s, "p");
if (crc32("OAOoFybUfE",10) == 2768788964) strcat(s, "b");
if (crc32("IyXgCkSMkadd",12) == 722988270) strcat(s, "r");
if (crc32("mkPINOMZdRd",11) == 4263850284) strcat(s, "o");
if (crc32("LuNGkuYUNnSDw",13) == 3033439172) strcat(s, "b");
if (crc32("mgbzpEbmJNGcB",13) == 1470099832) strcat(s, "C");
if (crc32("yWJgGrSk",8) == 2950588993) strcat(s, "a");
if (crc32("vXzAhQC",7) == 1552573470) strcat(s, "x");
if (crc32("OedJZmX",7) == 1002785433) strcat(s, "t");
if (crc32("SdHWyjxWnro",11) == 2136758042) strcat(s, "J");
if (crc32("SkfeXTtFWEh",11) == 2251449727) strcat(s, "i");
if (crc32("VLVqdsoICDNFAI",14) == 3251938691) strcat(s, "v");
if (crc32("XwtvMdquqCsntul",15) == 2366595439) strcat(s, "e");
if (crc32("LcgOcBQRFKPIL",13) == 44603680) strcat(s, "l");
if (crc32("GRmPkayHZiDnUZ",14) == 3780610120) strcat(s, "G");
if (crc32("bmvmveH",7) == 3120621093) strcat(s, "y");
    return s;
}

char *scoldingly_adverbs() {
    char *s = calloc(11);
    if (crc32("iLeZJveUzz",10) == 850293160) strcat(s, "s");
if (crc32("DMYmxQvn",8) == 248810581) strcat(s, "k");
if (crc32("SKjWdsRNrLBeOI",14) == 2372501187) strcat(s, "c");
if (crc32("SUjdslrKBx",10) == 1201847837) strcat(s, "o");
if (crc32("QwUqjAOULXyVjl",14) == 2978463933) strcat(s, "m");
if (crc32("eLtefEPfFkTFDln",15) == 2171303764) strcat(s, "l");
if (crc32("rQarID",6) == 1992210063) strcat(s, "d");
if (crc32("hrnxqCG",7) == 2374630139) strcat(s, "i");
if (crc32("KXdRUoAzwIzY",12) == 627806789) strcat(s, "n");
if (crc32("loReHvQjbldTZs",14) == 1478151364) strcat(s, "g");
if (crc32("WYIuRvvMBWqnQc",14) == 1881699511) strcat(s, "x");
if (crc32("fpqegqgMPQxMq",13) == 1542486094) strcat(s, "l");
if (crc32("vVpYJax",7) == 3638680220) strcat(s, "y");
    return s;
}

char *pentagonally_adverbs() {
    char *s = calloc(13);
    if (crc32("YhZnw",5) == 1502055579) strcat(s, "p");
if (crc32("VrlNoOhmCCAIB",13) == 2504058070) strcat(s, "e");
if (crc32("awCGhJTVAvvyjDE",15) == 2956015324) strcat(s, "n");
if (crc32("oOcsjSuwTPmFB",13) == 1217458406) strcat(s, "s");
if (crc32("yCoACNEqCZ",10) == 576890258) strcat(s, "t");
if (crc32("PgnzIcFwt",9) == 1111841016) strcat(s, "r");
if (crc32("sBXgaXT",7) == 4221507257) strcat(s, "a");
if (crc32("LvfhfqMQCPLhU",13) == 789834169) strcat(s, "g");
if (crc32("Ilvkx",5) == 1788533278) strcat(s, "o");
if (crc32("CzGZoxTVfNnpMAv",15) == 134819466) strcat(s, "J");
if (crc32("nELpoCuCL",9) == 4288363604) strcat(s, "n");
if (crc32("Shtcz",5) == 3942382880) strcat(s, "a");
if (crc32("wUQpu",5) == 64867446) strcat(s, "o");
if (crc32("UJXnlooR",8) == 188467292) strcat(s, "l");
if (crc32("mZnyF",5) == 540764951) strcat(s, "l");
if (crc32("xFmjLltqQcBb",12) == 3033276901) strcat(s, "y");
    return s;
}

char *noncolonially_adverbs() {
    char *s = calloc(14);
    if (crc32("xOpLmmL",7) == 2194410766) strcat(s, "z");
if (crc32("CMLksZfpSzr",11) == 4072135743) strcat(s, "n");
if (crc32("oDQwedjpvCLKmRF",15) == 3856722562) strcat(s, "Q");
if (crc32("vHLovQDCg",9) == 2683528610) strcat(s, "o");
if (crc32("OSIHgNXgJwZF",12) == 2696071432) strcat(s, "n");
if (crc32("WZXtNXndskuYhZ",14) == 135411771) strcat(s, "p");
if (crc32("PHjHyhoubJRBxeW",15) == 2132775057) strcat(s, "c");
if (crc32("qUIrpcXEJbs",11) == 1814754710) strcat(s, "M");
if (crc32("cUWrWvEk",8) == 2314868136) strcat(s, "o");
if (crc32("SINPKpGN",8) == 1424080136) strcat(s, "l");
if (crc32("wOtOs",5) == 2746364009) strcat(s, "o");
if (crc32("IVqrlhkdtADEYt",14) == 1732837391) strcat(s, "C");
if (crc32("cBXjaA",6) == 727029029) strcat(s, "n");
if (crc32("QRdFDgrpwL",10) == 2945057560) strcat(s, "i");
if (crc32("VVkiiWwxhkRBB",13) == 973568070) strcat(s, "a");
if (crc32("FPspCqy",7) == 240459775) strcat(s, "l");
if (crc32("oFygWmjsVFvyw",13) == 3814570667) strcat(s, "p");
if (crc32("JFBgiWeMRtwI",12) == 2973699770) strcat(s, "l");
if (crc32("cxnIxGPambApnK",14) == 2964146693) strcat(s, "y");
    return s;
}

char *obeyingly_adverbs() {
    char *s = calloc(10);
    if (crc32("jedAwWJ",7) == 197390472) strcat(s, "d");
if (crc32("OJXFHnyNxBZdvE",14) == 2866202686) strcat(s, "o");
if (crc32("RQEsOBK",7) == 1609194395) strcat(s, "b");
if (crc32("iInicRgTww",10) == 3371100680) strcat(s, "e");
if (crc32("TqwVYco",7) == 3752653197) strcat(s, "y");
if (crc32("kPiCkubwNR",10) == 2056749531) strcat(s, "i");
if (crc32("zvcWP",5) == 2280470533) strcat(s, "L");
if (crc32("PVcOqHYxnHFAJ",13) == 1283297611) strcat(s, "n");
if (crc32("BRDbugVUcDpAnJy",15) == 185528219) strcat(s, "z");
if (crc32("WXeOQQg",7) == 342814434) strcat(s, "g");
if (crc32("RzvZmmFhj",9) == 367919929) strcat(s, "a");
if (crc32("aUBBeXIfxunF",12) == 2240035696) strcat(s, "l");
if (crc32("JSZlYYMQYvdCA",13) == 169464896) strcat(s, "y");
    return s;
}

char *gratuitously_adverbs() {
    char *s = calloc(13);
    if (crc32("MUrEPAIoBmG",11) == 214760118) strcat(s, "g");
if (crc32("oWQyso",6) == 870146579) strcat(s, "r");
if (crc32("EnFuJtr",7) == 3131486777) strcat(s, "a");
if (crc32("pCqXAScYe",9) == 3143734390) strcat(s, "t");
if (crc32("muFbRWU",7) == 433815962) strcat(s, "p");
if (crc32("tEVhePnpfpwWt",13) == 2463821013) strcat(s, "u");
if (crc32("WSHYJB",6) == 667907911) strcat(s, "G");
if (crc32("NtUtFrACiPZIB",13) == 909687537) strcat(s, "i");
if (crc32("OeVMXoQLWpZlA",13) == 28678171) strcat(s, "W");
if (crc32("LjDwTzyiqKM",11) == 3588691023) strcat(s, "t");
if (crc32("eNxex",5) == 3323949294) strcat(s, "T");
if (crc32("bBeiBC",6) == 2963918568) strcat(s, "o");
if (crc32("iXeBXc",6) == 1332068890) strcat(s, "u");
if (crc32("RXjYVciWK",9) == 3987329743) strcat(s, "q");
if (crc32("Mgdxle",6) == 857799564) strcat(s, "s");
if (crc32("eqhwAYUEjRgjYHg",15) == 2865237625) strcat(s, "X");
if (crc32("VUTQrMoQairQ",12) == 2251159709) strcat(s, "l");
if (crc32("OAbad",5) == 1111746356) strcat(s, "y");
    return s;
}

char *unmelodically_adverbs() {
    char *s = calloc(14);
    if (crc32("LrWOWZCgK",9) == 884674854) strcat(s, "X");
if (crc32("kubLmRlbjBSc",12) == 1092354754) strcat(s, "u");
if (crc32("pkyUPswKlzf",11) == 1680639706) strcat(s, "n");
if (crc32("aJTRZqcB",8) == 1431912319) strcat(s, "K");
if (crc32("LmeGaGZDQCK",11) == 2819432391) strcat(s, "m");
if (crc32("ExxzFGfOZLxI",12) == 1410150076) strcat(s, "R");
if (crc32("CJDCOtynac",10) == 200303409) strcat(s, "e");
if (crc32("DLzjAF",6) == 2483045235) strcat(s, "D");
if (crc32("jdGdWwAE",8) == 3450823200) strcat(s, "l");
if (crc32("WcfTdRQSpiISO",13) == 421422190) strcat(s, "K");
if (crc32("PUiSheCbSUi",11) == 2485748576) strcat(s, "o");
if (crc32("VgTyJIXRHUdciP",14) == 2537548455) strcat(s, "R");
if (crc32("ualSCzyeBNsSt",13) == 557998289) strcat(s, "d");
if (crc32("NYcdPobMYarG",12) == 1617532657) strcat(s, "O");
if (crc32("NxIrDmIcgf",10) == 2989262377) strcat(s, "i");
if (crc32("InLZZw",6) == 2169187977) strcat(s, "c");
if (crc32("TlXrourWp",9) == 1119787815) strcat(s, "i");
if (crc32("UbbBmdEXniBmevc",15) == 416034602) strcat(s, "a");
if (crc32("HJdplIoJTsEhoC",14) == 3816851624) strcat(s, "T");
if (crc32("MXDSfPa",7) == 3773998224) strcat(s, "l");
if (crc32("ybOKTaFMh",9) == 3283872228) strcat(s, "l");
if (crc32("YcFYOsyqjSi",11) == 1296685435) strcat(s, "y");
    return s;
}

char *inductively_adverbs() {
    char *s = calloc(12);
    if (crc32("DtBbAQaIRyRQwpT",15) == 895526693) strcat(s, "E");
if (crc32("HabdzhYd",8) == 4176848768) strcat(s, "i");
if (crc32("bCdOx",5) == 3398495707) strcat(s, "n");
if (crc32("wLYdNyM",7) == 3253365114) strcat(s, "d");
if (crc32("dFqPX",5) == 2664933252) strcat(s, "u");
if (crc32("tfBkDx",6) == 2287447009) strcat(s, "c");
if (crc32("muuCEUawlD",10) == 693044681) strcat(s, "t");
if (crc32("pTwamvQGzyNlP",13) == 1314887573) strcat(s, "i");
if (crc32("NhRIfN",6) == 1108498983) strcat(s, "k");
if (crc32("WXsKbH",6) == 2191765554) strcat(s, "v");
if (crc32("YJMueiUJoVhz",12) == 3778371468) strcat(s, "e");
if (crc32("dOTHlsZZbw",10) == 1487982429) strcat(s, "O");
if (crc32("fGttrXyfOrNq",12) == 147754109) strcat(s, "l");
if (crc32("RXjlVvnOkP",10) == 336471408) strcat(s, "U");
if (crc32("APFUsuhRfnvarju",15) == 2062061296) strcat(s, "y");
    return s;
}

char *overboard_adverbs() {
    char *s = calloc(10);
    if (crc32("LPzxwZGemrxoQf",14) == 3990293707) strcat(s, "o");
if (crc32("WpVkqfQILZJEt",13) == 1710808480) strcat(s, "w");
if (crc32("WhXfhouOWnz",11) == 3068070266) strcat(s, "v");
if (crc32("XOYOoZ",6) == 799318518) strcat(s, "e");
if (crc32("DtaFLiv",7) == 3547326620) strcat(s, "r");
if (crc32("eifAkSVlx",9) == 3687228020) strcat(s, "b");
if (crc32("umLimnYdSHDHxet",15) == 2184754868) strcat(s, "o");
if (crc32("durXkwaCIVMSYh",14) == 2380952963) strcat(s, "a");
if (crc32("WqnLCPyLFsPGAsd",15) == 2297656365) strcat(s, "Y");
if (crc32("rcWLhUgfz",9) == 1672351537) strcat(s, "r");
if (crc32("nZtHCpgLzu",10) == 2711768487) strcat(s, "U");
if (crc32("aQXLuNaxWM",10) == 623738905) strcat(s, "d");
    return s;
}

char *unexplosively_adverbs() {
    char *s = calloc(14);
    if (crc32("gWdshjYzNlN",11) == 1752154807) strcat(s, "u");
if (crc32("PGLUOtUXBTqdBIH",15) == 3826940147) strcat(s, "n");
if (crc32("melVONdfcHQdiu",14) == 4198330701) strcat(s, "D");
if (crc32("LVYljWemEocfn",13) == 3893222697) strcat(s, "e");
if (crc32("zUiLLGLAfNB",11) == 1540256909) strcat(s, "N");
if (crc32("PouNPGbMe",9) == 454977473) strcat(s, "x");
if (crc32("gZussn",6) == 1927195110) strcat(s, "p");
if (crc32("qoTMNYXqhOtCCi",14) == 2014863633) strcat(s, "l");
if (crc32("LWaVsPKIlowS",12) == 2974103425) strcat(s, "o");
if (crc32("rnzayjoCvbbWXy",14) == 1632554843) strcat(s, "G");
if (crc32("BdFreSEJ",8) == 1383443655) strcat(s, "s");
if (crc32("keYBZRYXH",9) == 308040927) strcat(s, "P");
if (crc32("BeyNtlKVnVEhWbY",15) == 1344115742) strcat(s, "i");
if (crc32("ZvYwrhdLTYHm",12) == 505861733) strcat(s, "v");
if (crc32("VbUIvwCJ",8) == 2788318879) strcat(s, "T");
if (crc32("RmSAwMPE",8) == 1164862378) strcat(s, "e");
if (crc32("xEaaOrdFpKxvlIM",15) == 2229635405) strcat(s, "l");
if (crc32("eNRrE",5) == 1078286107) strcat(s, "C");
if (crc32("kzEslFbikS",10) == 423282504) strcat(s, "y");
    return s;
}

char *pietistically_adverbs() {
    char *s = calloc(14);
    if (crc32("EgOSbCqQjODv",12) == 2929383173) strcat(s, "p");
if (crc32("kKIDjxzIR",9) == 2819703173) strcat(s, "h");
if (crc32("MHoolchr",8) == 1792057893) strcat(s, "i");
if (crc32("eRYfV",5) == 3199224609) strcat(s, "T");
if (crc32("qPSkIYYw",8) == 1654430687) strcat(s, "e");
if (crc32("httRnApISp",10) == 2452598644) strcat(s, "t");
if (crc32("lTPtWYbKvGJ",11) == 3821928303) strcat(s, "p");
if (crc32("SOUTczWPWjp",11) == 4227727715) strcat(s, "i");
if (crc32("wdTfOzqwwlMCUu",14) == 19653121) strcat(s, "d");
if (crc32("kpHaSwQFXM",10) == 1373044591) strcat(s, "s");
if (crc32("eDpQwhWlD",9) == 318401807) strcat(s, "t");
if (crc32("nEygqeI",7) == 3871501654) strcat(s, "G");
if (crc32("OvclfSF",7) == 524627124) strcat(s, "i");
if (crc32("bREbZHbNpNrhPw",14) == 669639089) strcat(s, "c");
if (crc32("QJINePjr",8) == 2451308854) strcat(s, "a");
if (crc32("iJxeWbRJaFFljL",14) == 215793700) strcat(s, "G");
if (crc32("fJLHJlSQCLgQv",13) == 2865849436) strcat(s, "l");
if (crc32("dIwWkVOaQd",10) == 239436028) strcat(s, "f");
if (crc32("PjoqDs",6) == 94472461) strcat(s, "l");
if (crc32("WUAVikoCVtQ",11) == 2985816352) strcat(s, "x");
if (crc32("PHtsnDbdn",9) == 688847907) strcat(s, "y");
    return s;
}

char *simply_adverbs() {
    char *s = calloc(7);
    if (crc32("qhEnj",5) == 2920755576) strcat(s, "M");
if (crc32("elGcDbxgcJNARb",14) == 2845862289) strcat(s, "s");
if (crc32("zEMFXvAqZrgG",12) == 436223262) strcat(s, "m");
if (crc32("KoJEPleBJ",9) == 1599242553) strcat(s, "i");
if (crc32("fqYMS",5) == 2738163141) strcat(s, "b");
if (crc32("TWDcuqXoF",9) == 1437898262) strcat(s, "m");
if (crc32("IwaZeR",6) == 2906215138) strcat(s, "p");
if (crc32("XwOfglFdQa",10) == 3766657492) strcat(s, "L");
if (crc32("KPEdRsBcJl",10) == 590097912) strcat(s, "l");
if (crc32("XBnFRZhBa",9) == 518945061) strcat(s, "y");
    return s;
}

char *inelegantly_adverbs() {
    char *s = calloc(12);
    if (crc32("SLlBhQswJWe",11) == 2205870350) strcat(s, "N");
if (crc32("IZpisMATNhHwn",13) == 2475247671) strcat(s, "i");
if (crc32("dqVDPPbENc",10) == 2532398391) strcat(s, "n");
if (crc32("ZfkwbuhakIqvcNs",15) == 3606573974) strcat(s, "e");
if (crc32("iyYyTDsSKn",10) == 897236533) strcat(s, "l");
if (crc32("qmVVKcdOowT",11) == 3395896050) strcat(s, "e");
if (crc32("dIGVcpEcAJujnk",14) == 3325286643) strcat(s, "f");
if (crc32("sCARF",5) == 2543560277) strcat(s, "g");
if (crc32("DZHujIgESwX",11) == 3383172776) strcat(s, "a");
if (crc32("fLPCXIyWPXvw",12) == 3507216491) strcat(s, "n");
if (crc32("WqlaCPDflPrH",12) == 1982397365) strcat(s, "R");
if (crc32("PvHcvJHqfhHbHq",14) == 1858757957) strcat(s, "t");
if (crc32("qNYrlxxqdOsyD",13) == 3962470669) strcat(s, "l");
if (crc32("BbMnBywTBJa",11) == 1762959562) strcat(s, "y");
    return s;
}

char *oversusceptibly_adverbs() {
    char *s = calloc(16);
    if (crc32("TLrRCpzzJcse",12) == 3820069199) strcat(s, "o");
if (crc32("kWWmaZukiMNXT",13) == 294705856) strcat(s, "v");
if (crc32("dixjFHMEfJKrZj",14) == 223632224) strcat(s, "m");
if (crc32("LUJbjUEH",8) == 3962128930) strcat(s, "e");
if (crc32("gFFLejWzHfWgt",13) == 3799114911) strcat(s, "R");
if (crc32("RYvNCWFVdtu",11) == 3366314634) strcat(s, "r");
if (crc32("edcwsDrQJHKW",12) == 3193103098) strcat(s, "x");
if (crc32("ndRAIwWqPRKQw",13) == 992872865) strcat(s, "s");
if (crc32("wzynywtmxxlR",12) == 117734030) strcat(s, "I");
if (crc32("hpoERLbHdRNx",12) == 1292878015) strcat(s, "u");
if (crc32("qmRWZOCmWmONp",13) == 1979710007) strcat(s, "s");
if (crc32("XquZcRvEFsEVDKr",15) == 137023400) strcat(s, "c");
if (crc32("rzSGyoElxVdjORP",15) == 2725368672) strcat(s, "e");
if (crc32("qjGjrXQVcOZxJt",14) == 1898440889) strcat(s, "p");
if (crc32("AYTdydVWCQrk",12) == 1629547661) strcat(s, "m");
if (crc32("RdvsZsUmpwlGEhp",15) == 4060243041) strcat(s, "t");
if (crc32("cQrQdsyv",8) == 1477800040) strcat(s, "i");
if (crc32("fCZdiTqrCxfr",12) == 1494532021) strcat(s, "b");
if (crc32("SBaUrH",6) == 2500361784) strcat(s, "l");
if (crc32("aAwHZyvFYAiW",12) == 879805173) strcat(s, "T");
if (crc32("nSgxVnXip",9) == 3932038139) strcat(s, "y");
    return s;
}

char *evilmindedly_adverbs() {
    char *s = calloc(13);
    if (crc32("GvipyPNdoGcT",12) == 2882416970) strcat(s, "r");
if (crc32("KRkNLTIBewdI",12) == 3585798814) strcat(s, "e");
if (crc32("rCwbnPsnP",9) == 3624959325) strcat(s, "v");
if (crc32("qKOzzoWMqXNfrf",14) == 4232023971) strcat(s, "i");
if (crc32("jkDrKCTLJFfrteL",15) == 2399991097) strcat(s, "l");
if (crc32("ugNNIZUZlX",10) == 2285842793) strcat(s, "m");
if (crc32("ZVPxHOZRzF",10) == 2115636441) strcat(s, "i");
if (crc32("sTVsHtYoDSCuTmp",15) == 3539103696) strcat(s, "n");
if (crc32("woOGcojpOzlojbn",15) == 1576705955) strcat(s, "d");
if (crc32("jpXYg",5) == 765899969) strcat(s, "x");
if (crc32("FuLxYTQFMOXCo",13) == 3286596259) strcat(s, "e");
if (crc32("yvCYunPzAqHvct",14) == 2640352841) strcat(s, "i");
if (crc32("eKBcJgm",7) == 1315962308) strcat(s, "d");
if (crc32("aqgUOWORtVOSFiV",15) == 129356779) strcat(s, "l");
if (crc32("ZDEIrrJpIc",10) == 843484996) strcat(s, "y");
if (crc32("WHrscHAYIcjbYu",14) == 1975073792) strcat(s, "y");
    return s;
}

char *unsickly_adverbs() {
    char *s = calloc(9);
    if (crc32("GLJylNgsg",9) == 1405840853) strcat(s, "u");
if (crc32("SMWhe",5) == 3594064805) strcat(s, "u");
if (crc32("BZZkufr",7) == 2734637405) strcat(s, "n");
if (crc32("spExROMeDotWu",13) == 268318194) strcat(s, "I");
if (crc32("gpSHNoytRwIqtq",14) == 3630836402) strcat(s, "s");
if (crc32("KYVhaRss",8) == 4122024667) strcat(s, "i");
if (crc32("JGJPiHrAHTnM",12) == 204505933) strcat(s, "N");
if (crc32("ZHsEmnhiPYMDpMx",15) == 1821611890) strcat(s, "c");
if (crc32("ofcQvELPqxhMIv",14) == 3506304680) strcat(s, "o");
if (crc32("eLyZwu",6) == 1140172016) strcat(s, "k");
if (crc32("zUZjQEYD",8) == 1222677540) strcat(s, "l");
if (crc32("uITavlducNAZ",12) == 619382472) strcat(s, "y");
    return s;
}

char *carpingly_adverbs() {
    char *s = calloc(10);
    if (crc32("pscDjGZce",9) == 3716175543) strcat(s, "c");
if (crc32("iEOLqyRXMKFeLj",14) == 313046643) strcat(s, "a");
if (crc32("QFkuf",5) == 3619344630) strcat(s, "U");
if (crc32("WkoYUysMQkUe",12) == 974796621) strcat(s, "r");
if (crc32("ULHkVNDW",8) == 2297186681) strcat(s, "h");
if (crc32("nKEYriSq",8) == 3162353027) strcat(s, "p");
if (crc32("YQkkiMuKXYBBTk",14) == 4215638717) strcat(s, "Q");
if (crc32("SPnwdEirUNKwEu",14) == 1714495536) strcat(s, "i");
if (crc32("zdZTDdDDAt",10) == 897988549) strcat(s, "n");
if (crc32("MmYsZfShNpFbxst",15) == 2975950564) strcat(s, "X");
if (crc32("kNMstllGxylWxlD",15) == 1875405641) strcat(s, "g");
if (crc32("XmMQHubUv",9) == 3054537335) strcat(s, "w");
if (crc32("PEapovURcD",10) == 487114811) strcat(s, "l");
if (crc32("gZEueUTfn",9) == 48458814) strcat(s, "T");
if (crc32("VFXwonrGyxjlS",13) == 2761914698) strcat(s, "y");
    return s;
}

char *defilingly_adverbs() {
    char *s = calloc(11);
    if (crc32("ROBFMu",6) == 177541880) strcat(s, "d");
if (crc32("fRWzHs",6) == 4197068410) strcat(s, "m");
if (crc32("UwEBbMhCVRV",11) == 1694419847) strcat(s, "e");
if (crc32("jSRKcNLW",8) == 2718264557) strcat(s, "f");
if (crc32("FfWVAlVmvoLjUu",14) == 1005184089) strcat(s, "b");
if (crc32("xodWVbszTcZzqN",14) == 3835454248) strcat(s, "i");
if (crc32("mxeuQkOpvztNgKF",15) == 1903280041) strcat(s, "O");
if (crc32("AgVBLqgGgBmrYR",14) == 1557417863) strcat(s, "l");
if (crc32("nNeWjeoIORAwy",13) == 1685934266) strcat(s, "J");
if (crc32("QyqsBxHFucpBDci",15) == 2230239119) strcat(s, "i");
if (crc32("XOaPShSUBQDRGk",14) == 2251123045) strcat(s, "t");
if (crc32("LORZZXoPjbNKj",13) == 1927073137) strcat(s, "n");
if (crc32("IFhAbu",6) == 2648891318) strcat(s, "c");
if (crc32("XmzBQBFY",8) == 892407563) strcat(s, "g");
if (crc32("xlOngJXbP",9) == 725590000) strcat(s, "l");
if (crc32("ZpmbfRpML",9) == 457366725) strcat(s, "y");
    return s;
}

char *alternately_adverbs() {
    char *s = calloc(12);
    if (crc32("qDtpFEFSAjuXVse",15) == 1119372459) strcat(s, "V");
if (crc32("YZLwxds",7) == 2141241899) strcat(s, "a");
if (crc32("pTQCigieCCVUHsb",15) == 1646795849) strcat(s, "l");
if (crc32("tOXjHV",6) == 176388507) strcat(s, "t");
if (crc32("VgXcK",5) == 452058552) strcat(s, "e");
if (crc32("hsihEVanKvGon",13) == 1316953082) strcat(s, "S");
if (crc32("kVFBEThaU",9) == 996290683) strcat(s, "r");
if (crc32("VMJEPB",6) == 1210877521) strcat(s, "G");
if (crc32("ihOQicJxGS",10) == 1319394560) strcat(s, "n");
if (crc32("hAoMSCVx",8) == 3301616596) strcat(s, "a");
if (crc32("PkSPQBH",7) == 3204633419) strcat(s, "t");
if (crc32("lfAgszrxY",9) == 2776887930) strcat(s, "e");
if (crc32("OHHFbEBK",8) == 1383650634) strcat(s, "z");
if (crc32("BoJRPxwxqRxYkUw",15) == 2012417457) strcat(s, "l");
if (crc32("wauFdKE",7) == 1853057421) strcat(s, "g");
if (crc32("jxOudRgb",8) == 1724796366) strcat(s, "y");
    return s;
}

char *semioratorically_adverbs() {
    char *s = calloc(17);
    if (crc32("GHeQP",5) == 4102436796) strcat(s, "s");
if (crc32("VyfkuUGLlxftY",13) == 58861421) strcat(s, "V");
if (crc32("uNxeuGOVSPRiFaG",15) == 2740585959) strcat(s, "e");
if (crc32("YspRGQxJPv",10) == 1221141157) strcat(s, "u");
if (crc32("YrOwGHU",7) == 401896286) strcat(s, "m");
if (crc32("iKmoOvv",7) == 1610594506) strcat(s, "i");
if (crc32("SOfyowJUSB",10) == 4143079966) strcat(s, "W");
if (crc32("MhYvFLWYfRl",11) == 3808539178) strcat(s, "o");
if (crc32("PveCljLUGvNU",12) == 779083509) strcat(s, "F");
if (crc32("ZcXVFOb",7) == 3538313931) strcat(s, "r");
if (crc32("YZwOCQBWCdz",11) == 2933876967) strcat(s, "D");
if (crc32("pfHgzSIFJUjPjL",14) == 3885015587) strcat(s, "a");
if (crc32("ArQGucbdLi",10) == 3797559921) strcat(s, "R");
if (crc32("SzeVS",5) == 3985437097) strcat(s, "t");
if (crc32("XJAlwisHzCQiMt",14) == 2445258953) strcat(s, "o");
if (crc32("ASIsHQjc",8) == 324056304) strcat(s, "t");
if (crc32("sMbYDsXLhiBHxpr",15) == 360459471) strcat(s, "r");
if (crc32("EVmeMza",7) == 2089662353) strcat(s, "z");
if (crc32("CKliqiBmMLfyd",13) == 4289019039) strcat(s, "i");
if (crc32("oicHMg",6) == 492390454) strcat(s, "c");
if (crc32("aYYzouOxzcV",11) == 2604329301) strcat(s, "a");
if (crc32("aCnTNq",6) == 1175663550) strcat(s, "e");
if (crc32("sGoZfZVpncbe",12) == 1505587273) strcat(s, "l");
if (crc32("UyBxLnnwBoCAMEF",15) == 2350202509) strcat(s, "l");
if (crc32("zrLmRON",7) == 3696895135) strcat(s, "e");
if (crc32("iysLBcyYzY",10) == 489922499) strcat(s, "y");
    return s;
}

char *autocatalytically_adverbs() {
    char *s = calloc(18);
    if (crc32("FOWzqAVgPYa",11) == 2954926411) strcat(s, "c");
if (crc32("ppcgMsna",8) == 2120878453) strcat(s, "a");
if (crc32("xSXsYr",6) == 2759629917) strcat(s, "u");
if (crc32("dTMJCFzAxJQE",12) == 2171451723) strcat(s, "t");
if (crc32("FEopKjwIyTci",12) == 3423780681) strcat(s, "o");
if (crc32("DrQICnedQpM",11) == 1157012268) strcat(s, "c");
if (crc32("JrRBY",5) == 3824033861) strcat(s, "z");
if (crc32("vsDPDfqNF",9) == 3975000832) strcat(s, "a");
if (crc32("LNzenDFZGEG",11) == 1694143622) strcat(s, "a");
if (crc32("isduf",5) == 2462959473) strcat(s, "t");
if (crc32("BcWSCmrNcJC",11) == 2221628214) strcat(s, "a");
if (crc32("xgiPECXskxzotd",14) == 2951367486) strcat(s, "r");
if (crc32("wkXHC",5) == 3559723503) strcat(s, "l");
if (crc32("iAOkXPxS",8) == 798432924) strcat(s, "y");
if (crc32("ZKPwzcGmbrDuoAD",15) == 3470086020) strcat(s, "t");
if (crc32("ZiPDoweGqyx",11) == 714321207) strcat(s, "E");
if (crc32("LyjfLSbokfcivS",14) == 1277737786) strcat(s, "i");
if (crc32("rDCIYi",6) == 951897440) strcat(s, "k");
if (crc32("gPbtMyfCBql",11) == 1726972851) strcat(s, "c");
if (crc32("meMSTpuxtlLXfso",15) == 1251525526) strcat(s, "a");
if (crc32("LDyCYVHRCHN",11) == 1328411357) strcat(s, "S");
if (crc32("ZKwvxjcPJicKKR",14) == 2427557463) strcat(s, "l");
if (crc32("qxAsuYxfitbUTX",14) == 901848069) strcat(s, "V");
if (crc32("OWRJAoPiAavpD",13) == 1356290407) strcat(s, "l");
if (crc32("gttpoHvIZFlVwg",14) == 3041751824) strcat(s, "y");
    return s;
}

char *eruptively_adverbs() {
    char *s = calloc(11);
    if (crc32("eqhHM",5) == 2188511421) strcat(s, "H");
if (crc32("imUxRAgVZqYOG",13) == 2899967887) strcat(s, "e");
if (crc32("xbPaMmgyvAmj",12) == 236701950) strcat(s, "y");
if (crc32("EgZbggaqict",11) == 4171161093) strcat(s, "r");
if (crc32("GdQgiTObt",9) == 857797364) strcat(s, "u");
if (crc32("YPDbIFWVb",9) == 1696288002) strcat(s, "F");
if (crc32("rKcmhOAlbdvQga",14) == 887439845) strcat(s, "p");
if (crc32("dWIGBowVqVs",11) == 2119686786) strcat(s, "t");
if (crc32("HVaeEBgVEEZmQs",14) == 3406382907) strcat(s, "i");
if (crc32("zHHFsfhNwJF",11) == 1710005814) strcat(s, "v");
if (crc32("GwshSKtqBokgw",13) == 1022398826) strcat(s, "e");
if (crc32("ayStK",5) == 3881488466) strcat(s, "K");
if (crc32("obWsjHFmq",9) == 2461921095) strcat(s, "l");
if (crc32("fbkEIGthCHhdDKv",15) == 3001725677) strcat(s, "y");
    return s;
}

char *supersuspiciously_adverbs() {
    char *s = calloc(18);
    if (crc32("YIXgBvwsikumnSd",15) == 2829832683) strcat(s, "V");
if (crc32("GxcnJaPnt",9) == 4204578085) strcat(s, "s");
if (crc32("xEKsHZTpmj",10) == 4289268307) strcat(s, "D");
if (crc32("vpSyRMoKz",9) == 1015746296) strcat(s, "u");
if (crc32("UqNXLr",6) == 2047037991) strcat(s, "T");
if (crc32("YmJxTrCDyjHHUdu",15) == 1823283788) strcat(s, "p");
if (crc32("YUpthYBoEFyhLK",14) == 1231222881) strcat(s, "e");
if (crc32("AKwXh",5) == 2002508512) strcat(s, "H");
if (crc32("sMLmecdG",8) == 3562613904) strcat(s, "r");
if (crc32("iXFdDTPVKSc",11) == 3677934411) strcat(s, "s");
if (crc32("wUyTwaaFqU",10) == 3280100077) strcat(s, "u");
if (crc32("EqrGTKEjv",9) == 4183278480) strcat(s, "b");
if (crc32("qDxER",5) == 1148142456) strcat(s, "s");
if (crc32("HodmHlwARnO",11) == 1962398225) strcat(s, "b");
if (crc32("mXMCANTkAHYdUY",14) == 3886109605) strcat(s, "p");
if (crc32("wZlQkjf",7) == 1233423168) strcat(s, "i");
if (crc32("KQgndhcVvewo",12) == 1283333221) strcat(s, "c");
if (crc32("fHPNTxzAk",9) == 754154777) strcat(s, "i");
if (crc32("LxGgtdfu",8) == 1167268523) strcat(s, "o");
if (crc32("skQVVl",6) == 1449550106) strcat(s, "J");
if (crc32("usuTU",5) == 427163712) strcat(s, "u");
if (crc32("ktJrtMflGsq",11) == 3636415744) strcat(s, "s");
if (crc32("FavXVXxqspR",11) == 1662429488) strcat(s, "v");
if (crc32("uoRrFNGjQiRaeRV",15) == 4080633292) strcat(s, "l");
if (crc32("XWKXxeSojgxol",13) == 605096288) strcat(s, "r");
if (crc32("NhMygVPeczahb",13) == 1023104782) strcat(s, "y");
    return s;
}

char *unfactiously_adverbs() {
    char *s = calloc(13);
    if (crc32("NRnLD",5) == 802272694) strcat(s, "u");
if (crc32("knTjvint",8) == 1489070926) strcat(s, "Q");
if (crc32("zlzXEkSCgQRhf",13) == 2832391337) strcat(s, "n");
if (crc32("lXFgsXbE",8) == 3133832168) strcat(s, "f");
if (crc32("yezhfcXX",8) == 1330050951) strcat(s, "f");
if (crc32("vtHAtHLaWpMzY",13) == 1724356335) strcat(s, "a");
if (crc32("xMQnbtqAtXwssGl",15) == 2457299199) strcat(s, "N");
if (crc32("wNNpUR",6) == 766878821) strcat(s, "c");
if (crc32("JzAUBI",6) == 1290288043) strcat(s, "d");
if (crc32("NKfgIzC",7) == 420106683) strcat(s, "t");
if (crc32("LBWsYUbEygTfM",13) == 3141561586) strcat(s, "m");
if (crc32("hvpqOYAAw",9) == 2103858134) strcat(s, "i");
if (crc32("JNAnDezgqM",10) == 2192890500) strcat(s, "L");
if (crc32("eAdpSJjTr",9) == 3482828021) strcat(s, "o");
if (crc32("xZcFHTeZcADug",13) == 1118633717) strcat(s, "T");
if (crc32("nrCdkHfJ",8) == 164285816) strcat(s, "u");
if (crc32("unxTxzwJtY",10) == 1232505166) strcat(s, "s");
if (crc32("CRPgaZdGaUGqbhv",15) == 2500353117) strcat(s, "l");
if (crc32("aIQHzq",6) == 3630375693) strcat(s, "y");
    return s;
}

char *iodometrically_adverbs() {
    char *s = calloc(15);
    if (crc32("luERTkgIJPr",11) == 2770230943) strcat(s, "o");
if (crc32("tHTcu",5) == 2447047291) strcat(s, "i");
if (crc32("xBcqgBZNZXHcE",13) == 317824811) strcat(s, "W");
if (crc32("WIPhSr",6) == 1476274281) strcat(s, "o");
if (crc32("ohDTwGM",7) == 3644535408) strcat(s, "G");
if (crc32("PbAQaiBCVKBV",12) == 3590668741) strcat(s, "d");
if (crc32("EGsuGlQHCtBGcZ",14) == 614451586) strcat(s, "o");
if (crc32("jnuzMeo",7) == 136409088) strcat(s, "m");
if (crc32("lzUywYj",7) == 178743403) strcat(s, "e");
if (crc32("pJUgHzEcqzgFF",13) == 565926033) strcat(s, "t");
if (crc32("qjHinAYDEpwvgKR",15) == 2815444711) strcat(s, "r");
if (crc32("ZonIDjASI",9) == 2945013708) strcat(s, "O");
if (crc32("PEgJhae",7) == 963505083) strcat(s, "i");
if (crc32("ghuBznxv",8) == 1724015159) strcat(s, "c");
if (crc32("dWSyt",5) == 3460551140) strcat(s, "L");
if (crc32("jlXjpXHdNZuLym",14) == 2251832800) strcat(s, "a");
if (crc32("nCSkpIqUB",9) == 2579264284) strcat(s, "w");
if (crc32("NeUEw",5) == 67216768) strcat(s, "l");
if (crc32("xVeMiI",6) == 778380316) strcat(s, "l");
if (crc32("VgVrWuZxlsoxm",13) == 3088520269) strcat(s, "y");
    return s;
}

char *splurgily_adverbs() {
    char *s = calloc(10);
    if (crc32("NeKJkenBKnWp",12) == 1099158560) strcat(s, "s");
if (crc32("vdPumWqdNckcG",13) == 2335349570) strcat(s, "w");
if (crc32("JraARIMdzA",10) == 2893306374) strcat(s, "p");
if (crc32("zwdQo",5) == 1001633063) strcat(s, "U");
if (crc32("GlvacTammkOXxi",14) == 4030549775) strcat(s, "l");
if (crc32("gsPDrFNEbf",10) == 587888948) strcat(s, "a");
if (crc32("MSzQrWBPBndwG",13) == 2484434534) strcat(s, "u");
if (crc32("jjTNKuLphBfhIG",14) == 429140725) strcat(s, "r");
if (crc32("GLLgYH",6) == 2981641120) strcat(s, "g");
if (crc32("McGbynfhs",9) == 1416218165) strcat(s, "i");
if (crc32("bwLbdTvjuKWkwls",15) == 802614641) strcat(s, "l");
if (crc32("ptfCqmHODBEspVY",15) == 2612637531) strcat(s, "M");
if (crc32("AYEvDVNIeoB",11) == 2560430366) strcat(s, "y");
    return s;
}

char *incompactly_adverbs() {
    char *s = calloc(12);
    if (crc32("BcYBWL",6) == 1649137911) strcat(s, "i");
if (crc32("ctPZEE",6) == 309211331) strcat(s, "n");
if (crc32("OEPgj",5) == 1529662236) strcat(s, "c");
if (crc32("SnStfEzRc",9) == 69602093) strcat(s, "z");
if (crc32("hGmDLTulIO",10) == 253677447) strcat(s, "o");
if (crc32("LKVEhF",6) == 190930668) strcat(s, "r");
if (crc32("aHCCNUppaFZhDbw",15) == 141864942) strcat(s, "m");
if (crc32("LTcRIEArYCmw",12) == 1572024193) strcat(s, "p");
if (crc32("nbYnfg",6) == 1120628471) strcat(s, "C");
if (crc32("pRMEtaks",8) == 3164634330) strcat(s, "a");
if (crc32("aWrcZHpngNw",11) == 2325884056) strcat(s, "c");
if (crc32("cuhmjk",6) == 3177013388) strcat(s, "U");
if (crc32("iBwDjNlC",8) == 3393470581) strcat(s, "t");
if (crc32("CRgwNQw",7) == 1677066846) strcat(s, "l");
if (crc32("DmfHWHq",7) == 3329725371) strcat(s, "p");
if (crc32("OPPTBjU",7) == 2832267999) strcat(s, "y");
    return s;
}

char *butyrically_adverbs() {
    char *s = calloc(12);
    if (crc32("bUdBvF",6) == 630017126) strcat(s, "b");
if (crc32("eaqvqk",6) == 571622091) strcat(s, "u");
if (crc32("UMuQmfNdne",10) == 2731785656) strcat(s, "t");
if (crc32("AKKoCb",6) == 764632737) strcat(s, "y");
if (crc32("NdrFQ",5) == 2197501664) strcat(s, "x");
if (crc32("tTXNBaFS",8) == 2985638009) strcat(s, "r");
if (crc32("NXziqELQz",9) == 2254318292) strcat(s, "k");
if (crc32("FsUJsABwOy",10) == 2449690035) strcat(s, "i");
if (crc32("fbkNmNOdHXWw",12) == 1101526464) strcat(s, "c");
if (crc32("ZhFZN",5) == 4013217696) strcat(s, "a");
if (crc32("gvCUoobcv",9) == 1498833566) strcat(s, "l");
if (crc32("kLsBpEMPAWs",11) == 2875173234) strcat(s, "l");
if (crc32("YBLphXoxqDnR",12) == 1932771111) strcat(s, "A");
if (crc32("OlGfJVINhE",10) == 3544712300) strcat(s, "y");
    return s;
}

char *astutely_adverbs() {
    char *s = calloc(9);
    if (crc32("RQjxhSThfdR",11) == 1654087349) strcat(s, "a");
if (crc32("gMHhoDpzzbfAOr",14) == 3322063416) strcat(s, "P");
if (crc32("BdwwjsIdIHTgRWZ",15) == 1989781273) strcat(s, "s");
if (crc32("qOgXpVFK",8) == 594795435) strcat(s, "Q");
if (crc32("BvShByjFtxZT",12) == 4210792170) strcat(s, "t");
if (crc32("VwRvOtBEa",9) == 3799801058) strcat(s, "h");
if (crc32("RRpNuXuQT",9) == 3598920035) strcat(s, "u");
if (crc32("cJrfupDmVSkFKA",14) == 1588736986) strcat(s, "t");
if (crc32("XQtJgrOVXe",10) == 1456332608) strcat(s, "B");
if (crc32("TBDhFDBBZ",9) == 264680281) strcat(s, "e");
if (crc32("tNcznXnN",8) == 3074563643) strcat(s, "l");
if (crc32("vXSsl",5) == 2430947984) strcat(s, "y");
    return s;
}

char *nonconventionally_adverbs() {
    char *s = calloc(18);
    if (crc32("uGFhgFhrP",9) == 424526268) strcat(s, "U");
if (crc32("mASnp",5) == 1101651013) strcat(s, "n");
if (crc32("hUKJM",5) == 2167277266) strcat(s, "u");
if (crc32("xUPtUMvZAPEvUVk",15) == 3671680507) strcat(s, "o");
if (crc32("xEXclEEO",8) == 1579640900) strcat(s, "n");
if (crc32("dRvjyuNoZJuPkf",14) == 138589722) strcat(s, "c");
if (crc32("xLFQnn",6) == 1237701207) strcat(s, "o");
if (crc32("wNzhFnJfq",9) == 2273427579) strcat(s, "n");
if (crc32("YyoHcQH",7) == 753697888) strcat(s, "U");
if (crc32("ePyIydSEpI",10) == 198426116) strcat(s, "v");
if (crc32("oGYRBVdEdZN",11) == 1256882384) strcat(s, "e");
if (crc32("tNfbzSvXe",9) == 2937556845) strcat(s, "n");
if (crc32("RpQSnlOY",8) == 2233548610) strcat(s, "R");
if (crc32("OtsmnON",7) == 1819212175) strcat(s, "t");
if (crc32("UPcAG",5) == 3063375626) strcat(s, "i");
if (crc32("YmjMrZ",6) == 1656709423) strcat(s, "p");
if (crc32("jSWZxwCmmvsLhB",14) == 583561628) strcat(s, "o");
if (crc32("PDGrVgZOWLEQ",12) == 2547708986) strcat(s, "n");
if (crc32("herTlDMvBKu",11) == 3783247840) strcat(s, "V");
if (crc32("BInmf",5) == 885447726) strcat(s, "a");
if (crc32("liXFtub",7) == 3935398365) strcat(s, "l");
if (crc32("IdjdM",5) == 2159342600) strcat(s, "v");
if (crc32("wUOQgWELm",9) == 2127189843) strcat(s, "l");
if (crc32("WeOfAUnqAlR",11) == 1823000909) strcat(s, "y");
    return s;
}

char *uncontagiously_adverbs() {
    char *s = calloc(15);
    if (crc32("TnYbOVICzLVEQVF",15) == 1720874691) strcat(s, "W");
if (crc32("GCNDf",5) == 4019218993) strcat(s, "u");
if (crc32("nNROEgMXB",9) == 1974529856) strcat(s, "x");
if (crc32("ypaiXscJd",9) == 1867650492) strcat(s, "n");
if (crc32("uNhLln",6) == 1248963469) strcat(s, "m");
if (crc32("JoAwyFKIqztx",12) == 3167181934) strcat(s, "c");
if (crc32("XjsaSBcDW",9) == 363152248) strcat(s, "o");
if (crc32("qjyUaTYZHmjJQY",14) == 246046838) strcat(s, "F");
if (crc32("mLogUEfnlXbDQ",13) == 2443504973) strcat(s, "n");
if (crc32("cGXLhNUruH",10) == 2878328141) strcat(s, "A");
if (crc32("peCnLGQapejvsj",14) == 269292050) strcat(s, "t");
if (crc32("VGBcesPUdTsaFtI",15) == 1811599585) strcat(s, "a");
if (crc32("wNbDyBvOF",9) == 3150040670) strcat(s, "g");
if (crc32("NRxzidoTmcf",11) == 1717793699) strcat(s, "K");
if (crc32("XhcqGTSzeq",10) == 3658559980) strcat(s, "i");
if (crc32("YleKXKRwKHxLaGq",15) == 3915610420) strcat(s, "o");
if (crc32("cKsTIRQk",8) == 3448469114) strcat(s, "u");
if (crc32("TRlWkdKUwlx",11) == 4105806267) strcat(s, "s");
if (crc32("ctRupKMuBc",10) == 3572964684) strcat(s, "l");
if (crc32("LYQjDrVrEbOq",12) == 995129324) strcat(s, "w");
if (crc32("PTrZjASR",8) == 3806811252) strcat(s, "y");
    return s;
}

char *quasiconstructively_adverbs() {
    char *s = calloc(20);
    if (crc32("jjCjY",5) == 3192051314) strcat(s, "q");
if (crc32("rwrxTRDfzagT",12) == 443423194) strcat(s, "w");
if (crc32("hOYdaNTwTRvDj",13) == 2980523513) strcat(s, "u");
if (crc32("UDOhzALqei",10) == 269637904) strcat(s, "a");
if (crc32("qJDNfCwwmUVb",12) == 4165684674) strcat(s, "C");
if (crc32("bsuSdLxZhN",10) == 4106058204) strcat(s, "s");
if (crc32("gqEOBqcuy",9) == 2524739112) strcat(s, "i");
if (crc32("TKCxG",5) == 3562527403) strcat(s, "d");
if (crc32("cgSreS",6) == 1888875732) strcat(s, "c");
if (crc32("kHkntQo",7) == 4019738972) strcat(s, "o");
if (crc32("wJkAJuub",8) == 1930132626) strcat(s, "n");
if (crc32("eFsqsnJBnwvtb",13) == 2069942831) strcat(s, "s");
if (crc32("pLbAX",5) == 317520995) strcat(s, "e");
if (crc32("khUprA",6) == 3460538116) strcat(s, "t");
if (crc32("CKlNKaex",8) == 1901696670) strcat(s, "v");
if (crc32("MugDQoNgaCGjgF",14) == 923342454) strcat(s, "r");
if (crc32("pzjpc",5) == 870575322) strcat(s, "d");
if (crc32("mNxlx",5) == 289378210) strcat(s, "u");
if (crc32("BKKNwm",6) == 3105746622) strcat(s, "c");
if (crc32("RGTmgit",7) == 2439766927) strcat(s, "t");
if (crc32("zVYtSXrIq",9) == 385212313) strcat(s, "i");
if (crc32("XYWudEsAxu",10) == 3049388804) strcat(s, "M");
if (crc32("azibhHesm",9) == 1165809971) strcat(s, "v");
if (crc32("nSmILJjheG",10) == 1974659095) strcat(s, "e");
if (crc32("JacylVGJxYZt",12) == 1267635209) strcat(s, "l");
if (crc32("JkQzKkKEK",9) == 1926958882) strcat(s, "u");
if (crc32("ljBiDTkMrpzGSCp",15) == 2093475083) strcat(s, "y");
    return s;
}

char *prepotently_adverbs() {
    char *s = calloc(12);
    if (crc32("FmzTK",5) == 1484889569) strcat(s, "a");
if (crc32("wbtrdpZwPcPRmG",14) == 988809557) strcat(s, "p");
if (crc32("LpcnN",5) == 278248718) strcat(s, "r");
if (crc32("WCoNQZvlXdzJsA",14) == 711521469) strcat(s, "e");
if (crc32("GDkoWosPUdBC",12) == 4199388217) strcat(s, "p");
if (crc32("YfZYrWhw",8) == 2495323490) strcat(s, "o");
if (crc32("qWUgixS",7) == 3262689456) strcat(s, "t");
if (crc32("Pwecyrkyi",9) == 3737454284) strcat(s, "e");
if (crc32("xCIvcGu",7) == 690275558) strcat(s, "n");
if (crc32("dAZqdxApsB",10) == 3452458090) strcat(s, "n");
if (crc32("vqqwixnHcZ",10) == 2299347331) strcat(s, "F");
if (crc32("EbcsArSA",8) == 3438564656) strcat(s, "t");
if (crc32("WOFteAxlPqQP",12) == 3747383341) strcat(s, "l");
if (crc32("wyhxR",5) == 3132224516) strcat(s, "D");
if (crc32("ppWFRZXZVa",10) == 393989382) strcat(s, "y");
    return s;
}

char *quasiconservatively_adverbs() {
    char *s = calloc(20);
    if (crc32("UheoZWVOXXJAOT",14) == 3130654228) strcat(s, "q");
if (crc32("lBZfRHwtU",9) == 3196659011) strcat(s, "r");
if (crc32("HjEKCDWnxOy",11) == 2499891907) strcat(s, "u");
if (crc32("BSJeoAWWimMWntY",15) == 76403116) strcat(s, "H");
if (crc32("NJnSDD",6) == 3329529094) strcat(s, "a");
if (crc32("IRJNsGnqzZ",10) == 3324620058) strcat(s, "s");
if (crc32("DjSTJVdaQCTKda",14) == 2913924726) strcat(s, "q");
if (crc32("qldTwUsn",8) == 633298597) strcat(s, "i");
if (crc32("VGovrJEYPaCnPi",14) == 203965832) strcat(s, "b");
if (crc32("bpJczTXdypFROG",14) == 3113263809) strcat(s, "c");
if (crc32("WNOyvpjuhLnBd",13) == 3080844064) strcat(s, "D");
if (crc32("LBRimorxOEuc",12) == 120899849) strcat(s, "o");
if (crc32("wuItMBYHdsn",11) == 2787389718) strcat(s, "l");
if (crc32("kqNzvf",6) == 3898232784) strcat(s, "n");
if (crc32("BHwnvrqgTOMKkKP",15) == 3790701317) strcat(s, "s");
if (crc32("XJucGKCeTKxx",12) == 2684937877) strcat(s, "J");
if (crc32("kRjFqursa",9) == 679107490) strcat(s, "e");
if (crc32("FOxUaXFCEJxHgUK",15) == 427497977) strcat(s, "r");
if (crc32("VgJwfvDnoB",10) == 2057815336) strcat(s, "v");
if (crc32("kQAzoSCMM",9) == 348837833) strcat(s, "a");
if (crc32("YbfpFKLjXI",10) == 825234163) strcat(s, "t");
if (crc32("emHDgFXMoSulgO",14) == 2863324049) strcat(s, "i");
if (crc32("sSqsucyt",8) == 2485758982) strcat(s, "v");
if (crc32("WMrqDmgrCTBQBpI",15) == 3026687732) strcat(s, "r");
if (crc32("QlUGBmvt",8) == 1496822829) strcat(s, "e");
if (crc32("zzWvcpxZXZrP",12) == 1333423101) strcat(s, "l");
if (crc32("enOWMnldjvtxIL",14) == 990915362) strcat(s, "J");
if (crc32("zJZkKYPdkrVEMVR",15) == 478428752) strcat(s, "y");
    return s;
}

char *incestuously_adverbs() {
    char *s = calloc(13);
    if (crc32("xCtkSoCMzfukR",13) == 3083506641) strcat(s, "i");
if (crc32("zCCChga",7) == 2626145189) strcat(s, "n");
if (crc32("EVCOajhMuMwh",12) == 3022774559) strcat(s, "q");
if (crc32("ZTGowTmlpefUG",13) == 2596190557) strcat(s, "c");
if (crc32("htqecpL",7) == 1728601425) strcat(s, "e");
if (crc32("WtZyBwwsIQnldaI",15) == 3935932994) strcat(s, "s");
if (crc32("fweWWsk",7) == 1975492127) strcat(s, "U");
if (crc32("BKoiYerytK",10) == 2029987632) strcat(s, "t");
if (crc32("tConaz",6) == 3541569366) strcat(s, "u");
if (crc32("YiwZjFF",7) == 3342970251) strcat(s, "t");
if (crc32("URpaoojbsla",11) == 1356236676) strcat(s, "o");
if (crc32("sEKLVdiVjbV",11) == 1871078419) strcat(s, "u");
if (crc32("IyLPCIsMDikD",12) == 1513660211) strcat(s, "s");
if (crc32("sQcbwlt",7) == 2692447043) strcat(s, "J");
if (crc32("uzMHyCiiDBQkt",13) == 483736041) strcat(s, "l");
if (crc32("fiFyKzJ",7) == 2758009119) strcat(s, "y");
    return s;
}

char *nonflatulently_adverbs() {
    char *s = calloc(15);
    if (crc32("lfWrOFRzhixT",12) == 1953973746) strcat(s, "s");
if (crc32("WaInUzkVecScmO",14) == 1005994131) strcat(s, "n");
if (crc32("LESLKzUhzMwju",13) == 630958425) strcat(s, "o");
if (crc32("MNetubO",7) == 3690959026) strcat(s, "n");
if (crc32("uvJEqxfqfrCO",12) == 3956168537) strcat(s, "E");
if (crc32("uKgfNLdRkvjYrgb",15) == 2708133835) strcat(s, "f");
if (crc32("pMQPyVoZ",8) == 78789711) strcat(s, "l");
if (crc32("fzoStXJdO",9) == 270915216) strcat(s, "N");
if (crc32("dlHJYy",6) == 526918114) strcat(s, "a");
if (crc32("pExeUqp",7) == 2467760798) strcat(s, "e");
if (crc32("eMDBWzrYC",9) == 3990479966) strcat(s, "t");
if (crc32("TBRvqBEv",8) == 1536173396) strcat(s, "k");
if (crc32("cRlkTzjKhyJ",11) == 3825367687) strcat(s, "u");
if (crc32("FhftlIXT",8) == 2724314142) strcat(s, "b");
if (crc32("vgqeLFOzbvKCDH",14) == 1579449452) strcat(s, "l");
if (crc32("BleMOwBnN",9) == 3459175558) strcat(s, "e");
if (crc32("ymnZsz",6) == 4066236183) strcat(s, "n");
if (crc32("PTGmcxfZS",9) == 3614888085) strcat(s, "b");
if (crc32("bYXVjB",6) == 2696246422) strcat(s, "t");
if (crc32("sCRLECda",8) == 191454897) strcat(s, "l");
if (crc32("vkGppX",6) == 2598805959) strcat(s, "y");
    return s;
}

char *sinistrorsely_adverbs() {
    char *s = calloc(14);
    if (crc32("zWcRZsOq",8) == 1002173374) strcat(s, "x");
if (crc32("eYzIeX",6) == 3658162787) strcat(s, "s");
if (crc32("rNrYhdadrUv",11) == 3413368370) strcat(s, "i");
if (crc32("tajTlbxrhBrmHb",14) == 1792391887) strcat(s, "V");
if (crc32("zWwcz",5) == 2351228667) strcat(s, "n");
if (crc32("SUkpidFjmUKPKdu",15) == 3483964729) strcat(s, "q");
if (crc32("rcRbKg",6) == 3283532454) strcat(s, "i");
if (crc32("dVcupZpIS",9) == 2058092294) strcat(s, "i");
if (crc32("NlKpliuI",8) == 3805347796) strcat(s, "s");
if (crc32("dCsCMs",6) == 3980275390) strcat(s, "R");
if (crc32("wGGLKPvxfi",10) == 2750196401) strcat(s, "t");
if (crc32("wuXFIfn",7) == 1691424314) strcat(s, "w");
if (crc32("mKFKa",5) == 3065687471) strcat(s, "r");
if (crc32("rKwKffHZn",9) == 2618505863) strcat(s, "o");
if (crc32("VVXjTQaN",8) == 1101199056) strcat(s, "r");
if (crc32("UTIsrDylK",9) == 3079090631) strcat(s, "s");
if (crc32("nsrpznD",7) == 3903902824) strcat(s, "s");
if (crc32("RlyRPA",6) == 1848224649) strcat(s, "e");
if (crc32("lxIJqOEqerGCr",13) == 3701532410) strcat(s, "l");
if (crc32("PAdgSw",6) == 2129956692) strcat(s, "y");
    return s;
}

char *toxicologically_adverbs() {
    char *s = calloc(16);
    if (crc32("WdndXDqnozpVp",13) == 1631510782) strcat(s, "t");
if (crc32("ANeFbeBYZZFYU",13) == 1680174864) strcat(s, "c");
if (crc32("WRvPaedTAZS",11) == 3476530176) strcat(s, "o");
if (crc32("jmafu",5) == 1704776968) strcat(s, "n");
if (crc32("zkivXH",6) == 3920526285) strcat(s, "x");
if (crc32("mXIGST",6) == 1670524581) strcat(s, "i");
if (crc32("QTSEaLUp",8) == 1559130138) strcat(s, "c");
if (crc32("xMGViexNWtq",11) == 2149010864) strcat(s, "I");
if (crc32("SsQrtsYKnfo",11) == 1553815705) strcat(s, "o");
if (crc32("MZMNbKpMElhWX",13) == 3499609998) strcat(s, "l");
if (crc32("WQOBdScOdJE",11) == 3767809033) strcat(s, "z");
if (crc32("WYKzplstBJmS",12) == 1016143924) strcat(s, "o");
if (crc32("SnRSofmfvz",10) == 2202397158) strcat(s, "g");
if (crc32("YcToGiKSE",9) == 1369206153) strcat(s, "c");
if (crc32("gwXpOjav",8) == 3430644297) strcat(s, "i");
if (crc32("bVQIKnJmPBb",11) == 3108319861) strcat(s, "u");
if (crc32("xxSBRjg",7) == 3368576571) strcat(s, "c");
if (crc32("TTeJthvxNrUXo",13) == 510227118) strcat(s, "e");
if (crc32("LhHBGECM",8) == 3252324133) strcat(s, "a");
if (crc32("jLXwAgATkfQChC",14) == 525088858) strcat(s, "T");
if (crc32("WcUuIRp",7) == 4272921859) strcat(s, "l");
if (crc32("YEIWYeCUx",9) == 1269362402) strcat(s, "l");
if (crc32("djeYgAJ",7) == 1999044543) strcat(s, "X");
if (crc32("HazIVzLyAH",10) == 3150845711) strcat(s, "y");
    return s;
}

char *unpreceptively_adverbs() {
    char *s = calloc(15);
    if (crc32("vQhwkhyJHvzzw",13) == 912483060) strcat(s, "g");
if (crc32("JdOwanNBmioMNy",14) == 553275662) strcat(s, "u");
if (crc32("ErnvesmlNoQpAN",14) == 2442343465) strcat(s, "n");
if (crc32("gDjzKVlcbgJCw",13) == 3668515766) strcat(s, "s");
if (crc32("UqjQvjCsI",9) == 233155568) strcat(s, "p");
if (crc32("uBMiPDIBfe",10) == 2511876784) strcat(s, "r");
if (crc32("FMBhLyiiul",10) == 388930716) strcat(s, "e");
if (crc32("jUKsJSbht",9) == 735288684) strcat(s, "Y");
if (crc32("WHROlQfJ",8) == 1876955231) strcat(s, "c");
if (crc32("ZJbPSY",6) == 163819919) strcat(s, "U");
if (crc32("TnKAFvscKvmMl",13) == 935973326) strcat(s, "e");
if (crc32("HyPzgYgm",8) == 3574730771) strcat(s, "t");
if (crc32("fhHpTfu",7) == 3932968828) strcat(s, "p");
if (crc32("GDKPWdQb",8) == 4130320447) strcat(s, "R");
if (crc32("PCgWOEUOoS",10) == 2027061932) strcat(s, "t");
if (crc32("weYQoPjaUO",10) == 3594490397) strcat(s, "J");
if (crc32("qeavjJVdZkZSdw",14) == 937635111) strcat(s, "i");
if (crc32("zsknpA",6) == 629377987) strcat(s, "v");
if (crc32("NrNTdUJvatTqJJz",15) == 1951357130) strcat(s, "V");
if (crc32("nEtljMLvDYakYCG",15) == 3792052670) strcat(s, "e");
if (crc32("tsEIVuKzL",9) == 1782220125) strcat(s, "l");
if (crc32("yRlrqJKgj",9) == 1828288993) strcat(s, "y");
    return s;
}

char *uncontentiously_adverbs() {
    char *s = calloc(16);
    if (crc32("sgCOGX",6) == 1065961659) strcat(s, "u");
if (crc32("JNQYvkuCWwT",11) == 3233856065) strcat(s, "n");
if (crc32("FhfEvxd",7) == 434993845) strcat(s, "c");
if (crc32("yWiOzquCOXAoYmM",15) == 2374525611) strcat(s, "B");
if (crc32("UHIfdOYOuwdbd",13) == 1881373829) strcat(s, "o");
if (crc32("oSGIwssUB",9) == 743494308) strcat(s, "n");
if (crc32("GdiUnGFOHhE",11) == 2851451889) strcat(s, "t");
if (crc32("bnYhJXNXIUXyhk",14) == 4151434369) strcat(s, "A");
if (crc32("RxpwuavJKS",10) == 3179578274) strcat(s, "e");
if (crc32("fLKHNlnkOBH",11) == 363734902) strcat(s, "F");
if (crc32("HJYPKRATp",9) == 812675053) strcat(s, "n");
if (crc32("QQitMLRS",8) == 1279568117) strcat(s, "B");
if (crc32("paCYH",5) == 3720911762) strcat(s, "t");
if (crc32("bvPnGo",6) == 1763530270) strcat(s, "i");
if (crc32("TjTGJTbm",8) == 496031155) strcat(s, "o");
if (crc32("iNmfVYAyhyq",11) == 1324043988) strcat(s, "X");
if (crc32("vCFyVJkUIeA",11) == 2363978025) strcat(s, "u");
if (crc32("UTAhOKDlXtUAI",13) == 736065012) strcat(s, "s");
if (crc32("HRXzFpIkxBv",11) == 4194416347) strcat(s, "l");
if (crc32("gUWvsw",6) == 4025180701) strcat(s, "v");
if (crc32("uzHQpXyDaympnZB",15) == 2928151581) strcat(s, "y");
    return s;
}

char *temptingly_adverbs() {
    char *s = calloc(11);
    if (crc32("tlRlMRRnFY",10) == 2611366087) strcat(s, "t");
if (crc32("SnGaSJBQOpejdZ",14) == 1550132939) strcat(s, "t");
if (crc32("rPxlJBBYfMAK",12) == 3874119492) strcat(s, "e");
if (crc32("tGFuYBk",7) == 1728474301) strcat(s, "m");
if (crc32("kpvpoSVyvqYLo",13) == 1362902558) strcat(s, "p");
if (crc32("mNpPwSQUFcsQUzD",15) == 854939036) strcat(s, "t");
if (crc32("FPkiaWHEyiQ",11) == 4136396331) strcat(s, "i");
if (crc32("gieZEOTxCfPFw",13) == 2973653853) strcat(s, "C");
if (crc32("fVzEfx",6) == 3348516211) strcat(s, "n");
if (crc32("eqJdmcIlN",9) == 253463173) strcat(s, "c");
if (crc32("ISEmBSYj",8) == 3859002274) strcat(s, "g");
if (crc32("cEyipQ",6) == 3453160515) strcat(s, "l");
if (crc32("UjASY",5) == 1786665304) strcat(s, "B");
if (crc32("IszxqZPfGsu",11) == 1362675882) strcat(s, "y");
    return s;
}

char *sinfully_adverbs() {
    char *s = calloc(9);
    if (crc32("mAfprGT",7) == 3583267413) strcat(s, "C");
if (crc32("MNYKQS",6) == 2127499371) strcat(s, "s");
if (crc32("QZyJrDBFECIVu",13) == 3534987941) strcat(s, "i");
if (crc32("tmmDLGikK",9) == 3317782869) strcat(s, "n");
if (crc32("bFLJgAoJYtwtQ",13) == 848831978) strcat(s, "f");
if (crc32("gotgTsOPsNbn",12) == 388842147) strcat(s, "u");
if (crc32("weoTjJMZlZjrg",13) == 2328671407) strcat(s, "A");
if (crc32("WMgVem",6) == 3848477355) strcat(s, "l");
if (crc32("vvEvHA",6) == 3756413686) strcat(s, "l");
if (crc32("ieBvt",5) == 65787883) strcat(s, "y");
    return s;
}

char *nondetrimentally_adverbs() {
    char *s = calloc(17);
    if (crc32("uKDsaLchpTPVfDp",15) == 2484986508) strcat(s, "n");
if (crc32("ycElNVATIfSCdsO",15) == 2794046100) strcat(s, "o");
if (crc32("NUQzClt",7) == 2374041780) strcat(s, "Y");
if (crc32("oJRZieUWhaqy",12) == 659113081) strcat(s, "n");
if (crc32("ctXziyA",7) == 3636663953) strcat(s, "b");
if (crc32("jJXUvbRpw",9) == 2998645365) strcat(s, "d");
if (crc32("bfmwlOYMsKgwiP",14) == 1546776424) strcat(s, "e");
if (crc32("caiGHBFXBXFZYqw",15) == 1580360912) strcat(s, "t");
if (crc32("cLyBR",5) == 932254859) strcat(s, "i");
if (crc32("IDibJMVHAD",10) == 3611964018) strcat(s, "r");
if (crc32("jbDaVOqdrBukRf",14) == 3104140545) strcat(s, "i");
if (crc32("uPPzXhZzR",9) == 1192818630) strcat(s, "m");
if (crc32("ymkngO",6) == 2667346207) strcat(s, "e");
if (crc32("bhZbTDIWbhT",11) == 3368864199) strcat(s, "h");
if (crc32("yOeqVoxIJ",9) == 1778562131) strcat(s, "n");
if (crc32("ZDqKpMguTiPHI",13) == 3512128453) strcat(s, "t");
if (crc32("fXLwyC",6) == 3176562558) strcat(s, "I");
if (crc32("MGOxC",5) == 326574664) strcat(s, "a");
if (crc32("ymOSfburfugn",12) == 1669984221) strcat(s, "l");
if (crc32("dHSIpxtKv",9) == 3172022918) strcat(s, "w");
if (crc32("JWUEDtf",7) == 2830399537) strcat(s, "l");
if (crc32("EyFftPXFNSml",12) == 3579046155) strcat(s, "P");
if (crc32("itfLG",5) == 1316206146) strcat(s, "y");
    return s;
}

char *undangerously_adverbs() {
    char *s = calloc(14);
    if (crc32("OSFRTesxm",9) == 1547131266) strcat(s, "l");
if (crc32("NvqNjMiKwMVdWb",14) == 1532179587) strcat(s, "u");
if (crc32("scEvYSfcQeeaF",13) == 554787318) strcat(s, "a");
if (crc32("lNFMSxZ",7) == 1481073671) strcat(s, "n");
if (crc32("ORqtiD",6) == 3960211626) strcat(s, "P");
if (crc32("SirRv",5) == 2569121134) strcat(s, "d");
if (crc32("yZtDOIwRlacf",12) == 653552790) strcat(s, "G");
if (crc32("UMNMCNuKtXCGTO",14) == 3511526591) strcat(s, "a");
if (crc32("bDQupYHbMGukja",14) == 4041642425) strcat(s, "X");
if (crc32("JbaYryRjDdRA",12) == 2656176423) strcat(s, "n");
if (crc32("gYJGwfpdLZiXMa",14) == 705435545) strcat(s, "g");
if (crc32("IMaDpdEs",8) == 2014603462) strcat(s, "e");
if (crc32("eVtHx",5) == 1276158929) strcat(s, "r");
if (crc32("rlTxkr",6) == 2372244548) strcat(s, "o");
if (crc32("wBLOp",5) == 4291226462) strcat(s, "n");
if (crc32("Kpxdhj",6) == 3432593829) strcat(s, "u");
if (crc32("DpJKOWsaoeMR",12) == 2970475332) strcat(s, "s");
if (crc32("cUOxmpRzoUay",12) == 3399510002) strcat(s, "L");
if (crc32("vZootjVUHHcm",12) == 4186429672) strcat(s, "l");
if (crc32("zALLHoJtjJYbnMk",15) == 227785708) strcat(s, "m");
if (crc32("osEmIRlpNypOrtq",15) == 2119136649) strcat(s, "y");
    return s;
}

char *trigonally_adverbs() {
    char *s = calloc(11);
    if (crc32("mKIuf",5) == 3056970701) strcat(s, "J");
if (crc32("rHrrKIxrzcStt",13) == 2886320115) strcat(s, "t");
if (crc32("yAWMEdXtuWikL",13) == 984782868) strcat(s, "r");
if (crc32("XACxLhjLinc",11) == 1302841539) strcat(s, "i");
if (crc32("DHzoTydYKvsoe",13) == 3658023402) strcat(s, "J");
if (crc32("ZAEIGlVKxX",10) == 1792748911) strcat(s, "g");
if (crc32("hrVJuERNZSRk",12) == 1973752528) strcat(s, "V");
if (crc32("FuBHoKPt",8) == 3972677221) strcat(s, "o");
if (crc32("ObBQUDsv",8) == 3985340303) strcat(s, "K");
if (crc32("lNiXFfOVucwluo",14) == 4127644113) strcat(s, "n");
if (crc32("nwhoYj",6) == 3016347388) strcat(s, "a");
if (crc32("LAGNrVLzquFC",12) == 2659963791) strcat(s, "l");
if (crc32("OEtcRtQTN",9) == 2969584433) strcat(s, "B");
if (crc32("coTtUkVHzIOosJW",15) == 469751382) strcat(s, "l");
if (crc32("CYeYUnBBfhkBdm",14) == 3458762093) strcat(s, "W");
if (crc32("BrAkHAQMmsEJgH",14) == 38259718) strcat(s, "y");
    return s;
}

char *somnolently_adverbs() {
    char *s = calloc(12);
    if (crc32("aPiLCcqBaUn",11) == 3888419201) strcat(s, "s");
if (crc32("ILkXF",5) == 3948690840) strcat(s, "o");
if (crc32("bYTprSASYFFobmF",15) == 1600921960) strcat(s, "k");
if (crc32("CsOQioaZte",10) == 2325067180) strcat(s, "m");
if (crc32("PJKAlaZEoV",10) == 2102741070) strcat(s, "o");
if (crc32("RokcwRUVhoWMW",13) == 1318516832) strcat(s, "n");
if (crc32("NTRAtlCHv",9) == 3754114169) strcat(s, "o");
if (crc32("UztFmhEYkN",10) == 320467163) strcat(s, "l");
if (crc32("MbPbPybgREQOei",14) == 220120359) strcat(s, "q");
if (crc32("FcHltwsJ",8) == 2831129491) strcat(s, "e");
if (crc32("wkkIqwTspqeaY",13) == 2434050513) strcat(s, "n");
if (crc32("NyDuvZ",6) == 3301264202) strcat(s, "t");
if (crc32("rFgkGGgYx",9) == 1872994062) strcat(s, "l");
if (crc32("ZoEthMnPqnSaoS",14) == 2259688676) strcat(s, "y");
    return s;
}

char *expressively_adverbs() {
    char *s = calloc(13);
    if (crc32("IycOgsKrQOiQDx",14) == 280375456) strcat(s, "e");
if (crc32("ndSAnGzVYWENo",13) == 3277336101) strcat(s, "x");
if (crc32("LINTrBb",7) == 3841916205) strcat(s, "G");
if (crc32("OhSvLipokog",11) == 2383486130) strcat(s, "p");
if (crc32("IamtSNtYhzmnxP",14) == 2673800781) strcat(s, "r");
if (crc32("xxIhgmmxOESzSm",14) == 3918520997) strcat(s, "e");
if (crc32("AjcAyyHUWK",10) == 1035828130) strcat(s, "R");
if (crc32("CEhSMmYvsNiyCs",14) == 3847848392) strcat(s, "s");
if (crc32("itZiUVV",7) == 4173351489) strcat(s, "r");
if (crc32("MTTvBKevfXINNTQ",15) == 3613165805) strcat(s, "s");
if (crc32("zSHyiVN",7) == 458862646) strcat(s, "i");
if (crc32("ZUWBYPEVJvEDDk",14) == 2914222169) strcat(s, "v");
if (crc32("zpnkOxLqerbdSQ",14) == 2034691565) strcat(s, "e");
if (crc32("bHTuWWGQSXH",11) == 794352432) strcat(s, "l");
if (crc32("NXxmzxmuqKMEjb",14) == 577033803) strcat(s, "y");
    return s;
}

char *insipidly_adverbs() {
    char *s = calloc(10);
    if (crc32("ERyOEH",6) == 651327624) strcat(s, "p");
if (crc32("QDBRZ",5) == 2802450590) strcat(s, "i");
if (crc32("vtMCTytXTBBheOG",15) == 2777505606) strcat(s, "d");
if (crc32("haMxbNwGB",9) == 825458858) strcat(s, "n");
if (crc32("tkvmcDRnPZRi",12) == 1238075189) strcat(s, "t");
if (crc32("WgDMwYiXPqMn",12) == 3036031866) strcat(s, "s");
if (crc32("qbiCstBZWZ",10) == 2638580303) strcat(s, "i");
if (crc32("mIDOxlWUC",9) == 3946685086) strcat(s, "h");
if (crc32("GUBeCSfNBJAuqAJ",15) == 674971516) strcat(s, "p");
if (crc32("AIXVyELHp",9) == 866116861) strcat(s, "r");
if (crc32("eIRAibSWXlN",11) == 3653246508) strcat(s, "i");
if (crc32("nXPqULSGeZnLzBv",15) == 3940812158) strcat(s, "b");
if (crc32("iuTINcxnprLwbqs",15) == 2890671336) strcat(s, "d");
if (crc32("dQRTqOhPQd",10) == 4290415010) strcat(s, "l");
if (crc32("xaDRyZLiE",9) == 3796776102) strcat(s, "j");
if (crc32("vwajWxV",7) == 4163334534) strcat(s, "y");
    return s;
}

char *deliriously_adverbs() {
    char *s = calloc(12);
    if (crc32("PzAcoUvde",9) == 3633915636) strcat(s, "z");
if (crc32("aWphSbmaleeC",12) == 2539564451) strcat(s, "d");
if (crc32("zPlUoLI",7) == 2659530564) strcat(s, "R");
if (crc32("zfpOqPmJfez",11) == 2625090727) strcat(s, "e");
if (crc32("UTUbJuLwaFnky",13) == 895743587) strcat(s, "l");
if (crc32("GaoUkavIeJYv",12) == 13741911) strcat(s, "m");
if (crc32("mIIqtpKP",8) == 3689959635) strcat(s, "i");
if (crc32("fQZJRfte",8) == 310879921) strcat(s, "r");
if (crc32("mssjzEBO",8) == 4219981411) strcat(s, "i");
if (crc32("WFINQXrBDfDnnLA",15) == 962139407) strcat(s, "o");
if (crc32("jaluncvY",8) == 775987659) strcat(s, "K");
if (crc32("mBnznSa",7) == 4269238683) strcat(s, "u");
if (crc32("XdscqhtLC",9) == 4060293375) strcat(s, "s");
if (crc32("uWxXfHggecgUDwQ",15) == 650132050) strcat(s, "l");
if (crc32("tRfmrrvmzFupLx",14) == 3426655239) strcat(s, "y");
    return s;
}

char *pseudopiously_adverbs() {
    char *s = calloc(14);
    if (crc32("JUjgvKVmmwkH",12) == 2803194635) strcat(s, "p");
if (crc32("iZCfd",5) == 2582828952) strcat(s, "L");
if (crc32("asGkDdtMp",9) == 860667249) strcat(s, "s");
if (crc32("OVusNbx",7) == 3461415208) strcat(s, "e");
if (crc32("WmIKHR",6) == 3875383891) strcat(s, "u");
if (crc32("WuQIvTCqfKbqB",13) == 3139272268) strcat(s, "t");
if (crc32("EhMmeb",6) == 3578937845) strcat(s, "d");
if (crc32("JzbbaV",6) == 2297560614) strcat(s, "o");
if (crc32("vBpftBX",7) == 610633326) strcat(s, "f");
if (crc32("GuAaF",5) == 3792796254) strcat(s, "p");
if (crc32("mdQAGvR",7) == 2130643300) strcat(s, "Y");
if (crc32("WAUSeqgka",9) == 2643412968) strcat(s, "i");
if (crc32("zyGhjW",6) == 3315839196) strcat(s, "o");
if (crc32("JbwAkLLWtfKUV",13) == 362098701) strcat(s, "H");
if (crc32("JkvRWPtYpZIv",12) == 1053347351) strcat(s, "u");
if (crc32("VhRwmftbKyRwdO",14) == 1279567907) strcat(s, "o");
if (crc32("RpzlkDIDsnw",11) == 1620082086) strcat(s, "s");
if (crc32("wQdIZU",6) == 1322243880) strcat(s, "D");
if (crc32("NSBtzsKd",8) == 246264970) strcat(s, "l");
if (crc32("OkWZtCPIEACJDu",14) == 2640522680) strcat(s, "g");
if (crc32("LbQRmuEjkS",10) == 551946844) strcat(s, "y");
    return s;
}

char *halfinstinctively_adverbs() {
    char *s = calloc(18);
    if (crc32("AgCpaou",7) == 1311238999) strcat(s, "K");
if (crc32("VxxRiUkoVTvFp",13) == 3039755497) strcat(s, "h");
if (crc32("QXPfZoSTh",9) == 969888165) strcat(s, "C");
if (crc32("EEpNOGOVeyGwP",13) == 176495305) strcat(s, "a");
if (crc32("KNiZe",5) == 2822791661) strcat(s, "l");
if (crc32("ZKTSXJLATzJKe",13) == 3127028132) strcat(s, "W");
if (crc32("bqlNkkvlwNT",11) == 1129767229) strcat(s, "f");
if (crc32("GGwVUV",6) == 2045564039) strcat(s, "d");
if (crc32("YYlbSEndQfmf",12) == 3087341313) strcat(s, "i");
if (crc32("BAAGKBOehYFXL",13) == 2845759241) strcat(s, "n");
if (crc32("TxraY",5) == 484949812) strcat(s, "L");
if (crc32("DMvSuwCeBvfNf",13) == 1129686105) strcat(s, "s");
if (crc32("eRsDTtcbSdUv",12) == 2646188302) strcat(s, "i");
if (crc32("oimctxhItRhb",12) == 2287547885) strcat(s, "t");
if (crc32("FfoRLtzaBDimvY",14) == 122317397) strcat(s, "i");
if (crc32("RkzcsNRof",9) == 492949480) strcat(s, "n");
if (crc32("WxaaxIOtKImeDuN",15) == 2558876216) strcat(s, "o");
if (crc32("uXIQTvJWpqu",11) == 2840477242) strcat(s, "c");
if (crc32("UDzezsB",7) == 2647792429) strcat(s, "m");
if (crc32("PEocs",5) == 2527855654) strcat(s, "t");
if (crc32("kRjpba",6) == 2385875364) strcat(s, "l");
if (crc32("wejsHKO",7) == 3455441179) strcat(s, "i");
if (crc32("gBbmenixhuBgh",13) == 1688262030) strcat(s, "U");
if (crc32("BzHTBawUWQXqUe",14) == 3162956970) strcat(s, "v");
if (crc32("EbnMfqNNYY",10) == 1798245937) strcat(s, "e");
if (crc32("Bkpbdw",6) == 4063017334) strcat(s, "l");
if (crc32("THInZsflfwoVSA",14) == 272847506) strcat(s, "A");
if (crc32("lbdFJEWGXjy",11) == 3982265750) strcat(s, "y");
    return s;
}

char *resemblingly_adverbs() {
    char *s = calloc(13);
    if (crc32("NeWXFYkO",8) == 606809090) strcat(s, "r");
if (crc32("VxwGfPkdLWfiJ",13) == 3927708055) strcat(s, "e");
if (crc32("RUPttewIgBdauuz",15) == 326810661) strcat(s, "T");
if (crc32("SBXiADdvNJ",10) == 2895906314) strcat(s, "s");
if (crc32("ezxYGFWZ",8) == 689311602) strcat(s, "P");
if (crc32("LbafPgl",7) == 3823134371) strcat(s, "e");
if (crc32("fFJewqztxEGT",12) == 1411284934) strcat(s, "L");
if (crc32("sFkpYeOrPodi",12) == 2631536332) strcat(s, "m");
if (crc32("FhVewnX",7) == 1680833785) strcat(s, "j");
if (crc32("bRTKLL",6) == 2905302079) strcat(s, "b");
if (crc32("igmtDquvOmzpkLY",15) == 3553273655) strcat(s, "m");
if (crc32("uSfRBZOtvbnKI",13) == 1237394968) strcat(s, "l");
if (crc32("qGajYBGOkiDpUNt",15) == 181414731) strcat(s, "h");
if (crc32("NbIMs",5) == 1130268988) strcat(s, "i");
if (crc32("jPeawkzFvCBA",12) == 1396418366) strcat(s, "k");
if (crc32("gLcLe",5) == 393698146) strcat(s, "n");
if (crc32("vASjONDY",8) == 535741236) strcat(s, "G");
if (crc32("OcabF",5) == 3027447039) strcat(s, "g");
if (crc32("PFsRZyCxQHeQPI",14) == 864138100) strcat(s, "D");
if (crc32("OoQCZzghEHoxsr",14) == 436585475) strcat(s, "l");
if (crc32("rfKhmmOOQrrQJmg",15) == 2886620074) strcat(s, "W");
if (crc32("WFgtQIIxyzpccD",14) == 3491111381) strcat(s, "y");
    return s;
}

char *faintingly_adverbs() {
    char *s = calloc(11);
    if (crc32("qcRfkmPD",8) == 332247496) strcat(s, "K");
if (crc32("ZXCenqvNENa",11) == 284281918) strcat(s, "f");
if (crc32("dRLeJJqm",8) == 2750535890) strcat(s, "n");
if (crc32("yCjOkSi",7) == 2631919209) strcat(s, "a");
if (crc32("DgGii",5) == 4168724555) strcat(s, "i");
if (crc32("TqTMmYQdDBzWAT",14) == 3903692463) strcat(s, "i");
if (crc32("lKedQYPerLrxumC",15) == 885979223) strcat(s, "G");
if (crc32("fBHmKSxKZ",9) == 1426903122) strcat(s, "n");
if (crc32("VlYNOeFwoXBe",12) == 2061841711) strcat(s, "R");
if (crc32("SzqASzIpC",9) == 3670920291) strcat(s, "t");
if (crc32("GpELIDVs",8) == 3152867907) strcat(s, "x");
if (crc32("dHyExhnnbH",10) == 61843643) strcat(s, "i");
if (crc32("AUyfqrhXSLmWpeu",15) == 1624663428) strcat(s, "n");
if (crc32("LmnCivOXYTy",11) == 3929442518) strcat(s, "e");
if (crc32("BBttrrjn",8) == 3803474986) strcat(s, "g");
if (crc32("WddWAB",6) == 1627148024) strcat(s, "l");
if (crc32("GYmVmvMGviDi",12) == 770071823) strcat(s, "y");
    return s;
}

char *preposterously_adverbs() {
    char *s = calloc(15);
    if (crc32("gMMNky",6) == 3103414631) strcat(s, "p");
if (crc32("zAuXbEJYgQdvzgo",15) == 1874777183) strcat(s, "V");
if (crc32("UIlXbpuQAqyiVuK",15) == 3184270380) strcat(s, "r");
if (crc32("XnZjSORHplmMR",13) == 272131448) strcat(s, "H");
if (crc32("eLrrFca",7) == 2116957515) strcat(s, "e");
if (crc32("qqvjOAa",7) == 2635415034) strcat(s, "p");
if (crc32("tLNRiOjXntT",11) == 4172180870) strcat(s, "o");
if (crc32("qIbrgwnuRn",10) == 2488143735) strcat(s, "s");
if (crc32("oGRrvXTaFKdRvp",14) == 2001527673) strcat(s, "t");
if (crc32("BgvWiULqsRLf",12) == 720019755) strcat(s, "I");
if (crc32("hQvPGhQyLjRDi",13) == 1164978156) strcat(s, "e");
if (crc32("oOSlOyNWTBsKZJc",15) == 2439299698) strcat(s, "r");
if (crc32("bIdzLBiOVkWSc",13) == 715312147) strcat(s, "F");
if (crc32("AiItYtKMl",9) == 220603244) strcat(s, "o");
if (crc32("HKXZlTlvXnIzdI",14) == 1375150818) strcat(s, "J");
if (crc32("NxpNkYscEWXlMq",14) == 2355814924) strcat(s, "u");
if (crc32("GzwGLXAPRT",10) == 104733524) strcat(s, "s");
if (crc32("txIgLPHS",8) == 3863356096) strcat(s, "l");
if (crc32("UBIZDjBq",8) == 1174349796) strcat(s, "y");
    return s;
}

char *unsonorously_adverbs() {
    char *s = calloc(13);
    if (crc32("VAvhBLgwUfvgXjH",15) == 4259670766) strcat(s, "u");
if (crc32("DiRZsxaAqJeDEvT",15) == 2545962329) strcat(s, "A");
if (crc32("OTsLgTZhdP",10) == 1377661375) strcat(s, "n");
if (crc32("OvSfKwDKmVEiVs",14) == 4216870618) strcat(s, "s");
if (crc32("fYDHQBMt",8) == 1671274583) strcat(s, "T");
if (crc32("qvozH",5) == 2727876065) strcat(s, "o");
if (crc32("TFxTPNIA",8) == 593478309) strcat(s, "R");
if (crc32("TOeaWhnfRgeN",12) == 462089605) strcat(s, "n");
if (crc32("JdYJUUULtl",10) == 3929348441) strcat(s, "j");
if (crc32("kPNoDkAfNzmJQPC",15) == 4073868360) strcat(s, "o");
if (crc32("twgfMhZn",8) == 2727407696) strcat(s, "r");
if (crc32("pmVoaWBaamXV",12) == 1334776352) strcat(s, "p");
if (crc32("jMija",5) == 2659138141) strcat(s, "o");
if (crc32("fXaRLKFOtgNOoz",14) == 3910904938) strcat(s, "D");
if (crc32("SvGjFRcmwrvsx",13) == 2101278247) strcat(s, "u");
if (crc32("rMosmPjoaC",10) == 1883175631) strcat(s, "r");
if (crc32("tTVgfsUIi",9) == 3750024272) strcat(s, "s");
if (crc32("barxGqmaxTgn",12) == 408171205) strcat(s, "f");
if (crc32("EmHaxomSRTlmEzA",15) == 1207471587) strcat(s, "l");
if (crc32("ouKVMslKupamOV",14) == 2326822338) strcat(s, "y");
    return s;
}

char *valiantly_adverbs() {
    char *s = calloc(10);
    if (crc32("fHioPiazAPVM",12) == 693073185) strcat(s, "x");
if (crc32("NRkdtsfktUse",12) == 3639112446) strcat(s, "v");
if (crc32("WiChjxToHzzQI",13) == 2943729920) strcat(s, "J");
if (crc32("TvUxyqVCZbkjP",13) == 1191433550) strcat(s, "a");
if (crc32("wpNjNBKCrHeU",12) == 3042976385) strcat(s, "l");
if (crc32("unOfeXEigIjejbB",15) == 458758012) strcat(s, "i");
if (crc32("nAhDNgCuysycbO",14) == 3184431617) strcat(s, "A");
if (crc32("ZgNMhAoJDA",10) == 1724366454) strcat(s, "a");
if (crc32("lkiQuMvjZJsROnc",15) == 3119880079) strcat(s, "n");
if (crc32("SxfmjmjOFi",10) == 1944765388) strcat(s, "t");
if (crc32("XLuTfyAZVqfq",12) == 3557675750) strcat(s, "l");
if (crc32("MfiyDaAZYxqHbL",14) == 1929163143) strcat(s, "D");
if (crc32("KaTJvbycjlQJaG",14) == 3892923986) strcat(s, "y");
    return s;
}

char *nonmystically_adverbs() {
    char *s = calloc(14);
    if (crc32("KHkWNktQKGJ",11) == 3461104045) strcat(s, "n");
if (crc32("WjZisaKJFQDDnyz",15) == 4070094005) strcat(s, "o");
if (crc32("ZWnIEbc",7) == 502035970) strcat(s, "W");
if (crc32("wQqudkij",8) == 1590102021) strcat(s, "n");
if (crc32("nhUvTlOvO",9) == 2241049702) strcat(s, "m");
if (crc32("BagsdzMzjCax",12) == 343733879) strcat(s, "T");
if (crc32("UBUKsU",6) == 1354572081) strcat(s, "y");
if (crc32("OceaDIf",7) == 2180962940) strcat(s, "s");
if (crc32("BNuIhPvniciu",12) == 45075341) strcat(s, "t");
if (crc32("QwClAOMqJnJVopD",15) == 147535659) strcat(s, "H");
if (crc32("kQlYpmmxH",9) == 693381663) strcat(s, "i");
if (crc32("olkizMdoKLX",11) == 3279456484) strcat(s, "c");
if (crc32("GJHDinTRY",9) == 759393938) strcat(s, "g");
if (crc32("TlbwzFavNgA",11) == 2521243930) strcat(s, "a");
if (crc32("pzCmvdXZ",8) == 2618977104) strcat(s, "e");
if (crc32("txlFKaQAtXMAyIm",15) == 2955501881) strcat(s, "l");
if (crc32("lRPsrYZ",7) == 1712812643) strcat(s, "l");
if (crc32("wUzUm",5) == 3702156576) strcat(s, "y");
    return s;
}

char *nonsacredly_adverbs() {
    char *s = calloc(12);
    if (crc32("yDdhqhQnMzGyFNt",15) == 2083276150) strcat(s, "n");
if (crc32("fsYsXEPBAsn",11) == 3751091288) strcat(s, "C");
if (crc32("TKJFLsuC",8) == 2983865120) strcat(s, "o");
if (crc32("SeoeQpGfx",9) == 924077903) strcat(s, "N");
if (crc32("uECRjlDcPAW",11) == 3367806605) strcat(s, "n");
if (crc32("bHWeRc",6) == 3633130910) strcat(s, "s");
if (crc32("ZzyqqOp",7) == 3857064694) strcat(s, "a");
if (crc32("MCiwD",5) == 3106473505) strcat(s, "c");
if (crc32("NDaZbZxfCaQF",12) == 388057068) strcat(s, "W");
if (crc32("UeAzBS",6) == 4138745805) strcat(s, "r");
if (crc32("eVHAHSCMfHuR",12) == 1772658052) strcat(s, "e");
if (crc32("SjhzcNUiGpt",11) == 810162675) strcat(s, "I");
if (crc32("fjlDfzYs",8) == 1803278228) strcat(s, "d");
if (crc32("LwpTxI",6) == 2954642092) strcat(s, "o");
if (crc32("nDfXKEUrLP",10) == 3236511639) strcat(s, "l");
if (crc32("cMaOHb",6) == 4236369741) strcat(s, "y");
    return s;
}

char *nonaccommodatingly_adverbs() {
    char *s = calloc(19);
    if (crc32("UnWeBWRJ",8) == 2831614109) strcat(s, "c");
if (crc32("OIYyVwiOuloe",12) == 6886451) strcat(s, "n");
if (crc32("tFPhTogP",8) == 301981297) strcat(s, "P");
if (crc32("HHRKKu",6) == 342068319) strcat(s, "o");
if (crc32("zlBBl",5) == 4058324626) strcat(s, "n");
if (crc32("iPpFcWN",7) == 3866029036) strcat(s, "a");
if (crc32("hawQdcp",7) == 2413133759) strcat(s, "c");
if (crc32("jUeNaKMlYmfwvND",15) == 1775709826) strcat(s, "c");
if (crc32("fUOjV",5) == 3661457799) strcat(s, "d");
if (crc32("utxPg",5) == 549601070) strcat(s, "o");
if (crc32("ockTR",5) == 3957572389) strcat(s, "m");
if (crc32("imNtABSohhZUA",13) == 2482609197) strcat(s, "v");
if (crc32("qrKCvwsQzBx",11) == 3437830673) strcat(s, "m");
if (crc32("LPjdNTMM",8) == 2698820042) strcat(s, "o");
if (crc32("SCOFNt",6) == 2860095444) strcat(s, "d");
if (crc32("NyOGzG",6) == 4221099616) strcat(s, "a");
if (crc32("uFajmcvTbffErm",14) == 1338580738) strcat(s, "x");
if (crc32("trKwpXRt",8) == 3470201366) strcat(s, "t");
if (crc32("ZMTjmwzNFhyvZX",14) == 1898220083) strcat(s, "d");
if (crc32("TSHBoR",6) == 332411029) strcat(s, "i");
if (crc32("KLDsXHVKr",9) == 427743590) strcat(s, "I");
if (crc32("gAJAwEwtuFfJHi",14) == 1221768197) strcat(s, "n");
if (crc32("fvmmmJmQU",9) == 2430721934) strcat(s, "g");
if (crc32("XHKCjGdJmRql",12) == 966368070) strcat(s, "l");
if (crc32("tKKsMfpNPZ",10) == 368248506) strcat(s, "H");
if (crc32("JjdtvAuWkmGnULW",15) == 2159475425) strcat(s, "y");
    return s;
}

char *nonfugitively_adverbs() {
    char *s = calloc(14);
    if (crc32("fIfSlEaJZQawFR",14) == 3070419381) strcat(s, "C");
if (crc32("qulckfmUkHJSlF",14) == 520570287) strcat(s, "n");
if (crc32("GQrgsznGVxrcbT",14) == 3412311070) strcat(s, "n");
if (crc32("zRZUpcywaUE",11) == 3625767417) strcat(s, "o");
if (crc32("hPFaFdRnLebCd",13) == 2511812769) strcat(s, "j");
if (crc32("cCXZHzK",7) == 1215975188) strcat(s, "n");
if (crc32("XhtnlftZ",8) == 273565778) strcat(s, "f");
if (crc32("LYFyHxWBWN",10) == 1141689433) strcat(s, "u");
if (crc32("RTvTTMpE",8) == 2700553006) strcat(s, "g");
if (crc32("SfxtYdJHJR",10) == 1127279312) strcat(s, "N");
if (crc32("iqtzxreKwXDeOOm",15) == 2737609161) strcat(s, "i");
if (crc32("LKWtSmuRNJ",10) == 285024734) strcat(s, "t");
if (crc32("WEFvZt",6) == 3378863405) strcat(s, "t");
if (crc32("iBzRAqmq",8) == 280157146) strcat(s, "i");
if (crc32("pfatKzYBDC",10) == 1459273905) strcat(s, "v");
if (crc32("GfmqSQTrDTBMlg",14) == 1166207716) strcat(s, "e");
if (crc32("GksXJujvFQl",11) == 2322359769) strcat(s, "S");
if (crc32("TwGleaSdJXpmHwR",15) == 440453026) strcat(s, "l");
if (crc32("YEOZv",5) == 3709819266) strcat(s, "y");
    return s;
}

char *gruntingly_adverbs() {
    char *s = calloc(11);
    if (crc32("eNUDWrWoqmDImS",14) == 361820679) strcat(s, "G");
if (crc32("pHBogSZoyHSVDIS",15) == 1315375512) strcat(s, "g");
if (crc32("tSfFtI",6) == 1651795207) strcat(s, "F");
if (crc32("cgVCVdEoTo",10) == 1561089057) strcat(s, "r");
if (crc32("zOIJMlrYeUyzY",13) == 538714469) strcat(s, "u");
if (crc32("yunoMbCSRv",10) == 1845067585) strcat(s, "n");
if (crc32("jnpLDzVNF",9) == 2410882133) strcat(s, "S");
if (crc32("fZmbJwyRRWtORtO",15) == 201343328) strcat(s, "t");
if (crc32("UlIZRpcBSv",10) == 844655789) strcat(s, "Z");
if (crc32("PaxxfttH",8) == 1308054111) strcat(s, "i");
if (crc32("hCcdOunoEHGpP",13) == 901886779) strcat(s, "n");
if (crc32("mInkralyxIw",11) == 3684447638) strcat(s, "W");
if (crc32("BPRwDO",6) == 2307762931) strcat(s, "g");
if (crc32("OSjRlNhVUKjdd",13) == 4059947778) strcat(s, "l");
if (crc32("JkGUvFhNhEayf",13) == 2262373252) strcat(s, "l");
if (crc32("eAKdRAxe",8) == 3692716718) strcat(s, "y");
    return s;
}

char *remorselessly_adverbs() {
    char *s = calloc(14);
    if (crc32("MJPGFEm",7) == 3816744427) strcat(s, "g");
if (crc32("leNFhrPq",8) == 3981946886) strcat(s, "r");
if (crc32("KkBlnMdCSQrEixc",15) == 2980530986) strcat(s, "e");
if (crc32("viaWKwGB",8) == 1659492859) strcat(s, "m");
if (crc32("rTnjULQDRpP",11) == 2611113315) strcat(s, "o");
if (crc32("TlYrUIT",7) == 3862926764) strcat(s, "r");
if (crc32("bvhKEsoh",8) == 1655821055) strcat(s, "N");
if (crc32("jzISnsfWn",9) == 92220991) strcat(s, "s");
if (crc32("UgiHWNhlLB",10) == 1176091658) strcat(s, "D");
if (crc32("mNopSg",6) == 2543791718) strcat(s, "e");
if (crc32("jNceRtysDX",10) == 1220830571) strcat(s, "l");
if (crc32("QQWFvOG",7) == 611672334) strcat(s, "e");
if (crc32("YfFnk",5) == 3093691891) strcat(s, "s");
if (crc32("QXsrcF",6) == 1610104282) strcat(s, "B");
if (crc32("BHuKMcmnCyZTz",13) == 2727069462) strcat(s, "s");
if (crc32("gOVkeAlweCBbb",13) == 1910970500) strcat(s, "l");
if (crc32("AsmXlfHKHHrFgj",14) == 2669133132) strcat(s, "y");
    return s;
}

char *sanctimoniously_adverbs() {
    char *s = calloc(16);
    if (crc32("wrAhkQq",7) == 2842180218) strcat(s, "s");
if (crc32("oqStbPjacACppS",14) == 2830667470) strcat(s, "G");
if (crc32("WIoZRfRTeCRXm",13) == 604160911) strcat(s, "a");
if (crc32("uGyGxDIgVDRx",12) == 1377647642) strcat(s, "L");
if (crc32("jHwEcPLRKXG",11) == 233576241) strcat(s, "n");
if (crc32("KxVpguqToYML",12) == 1259984790) strcat(s, "k");
if (crc32("bHKPWVSCNMHUiK",14) == 1658102728) strcat(s, "c");
if (crc32("gkvusVLJe",9) == 3747518771) strcat(s, "r");
if (crc32("gZlNkSbeI",9) == 137020872) strcat(s, "t");
if (crc32("AQrVQ",5) == 2636933277) strcat(s, "E");
if (crc32("bnaebFAmBun",11) == 2645156662) strcat(s, "i");
if (crc32("vzwai",5) == 2902744901) strcat(s, "m");
if (crc32("tFabOCbWFo",10) == 3546792743) strcat(s, "o");
if (crc32("DYrzGlqBsqeihR",14) == 4251212204) strcat(s, "H");
if (crc32("vqVCabvjOyrjuph",15) == 2614529737) strcat(s, "n");
if (crc32("yXbLWbzD",8) == 2572068993) strcat(s, "R");
if (crc32("jDRBdsZH",8) == 764959364) strcat(s, "i");
if (crc32("hkLEEjCw",8) == 607143368) strcat(s, "F");
if (crc32("NUCIVp",6) == 1047347318) strcat(s, "o");
if (crc32("RdRrInkpklE",11) == 3427042091) strcat(s, "u");
if (crc32("BNnlHxCPjdGwgkn",15) == 485362898) strcat(s, "s");
if (crc32("CrIQkRtRyRYE",12) == 1653334215) strcat(s, "l");
if (crc32("eFFGKxnBdNqNYlN",15) == 3678885707) strcat(s, "H");
if (crc32("KTZTYcxxK",9) == 998387465) strcat(s, "y");
    return s;
}

char *quasilegally_adverbs() {
    char *s = calloc(13);
    if (crc32("memQENhLBxWJgtH",15) == 2756904078) strcat(s, "O");
if (crc32("gIjwrPk",7) == 3924711618) strcat(s, "q");
if (crc32("QkjwK",5) == 3947255995) strcat(s, "u");
if (crc32("HCXYFGbcpuClkrI",15) == 4243047235) strcat(s, "a");
if (crc32("xNLSRSERPJuVue",14) == 4250355197) strcat(s, "s");
if (crc32("lyMxGmnOYywFFR",14) == 2272089698) strcat(s, "S");
if (crc32("tgTHilpZ",8) == 1607934160) strcat(s, "i");
if (crc32("XrOYXFgEcd",10) == 841810811) strcat(s, "l");
if (crc32("aFfQlFJhuV",10) == 1673411659) strcat(s, "G");
if (crc32("LcmDhestV",9) == 3291841341) strcat(s, "e");
if (crc32("UTwnjKS",7) == 3911490487) strcat(s, "e");
if (crc32("JzsCIfswzP",10) == 4027131813) strcat(s, "g");
if (crc32("kbhRPQePXOH",11) == 776569792) strcat(s, "a");
if (crc32("SKzCYO",6) == 4022303711) strcat(s, "l");
if (crc32("UvfAzvMoWMr",11) == 2535263345) strcat(s, "l");
if (crc32("SHsyeSDROX",10) == 3243860963) strcat(s, "y");
    return s;
}

char *stownlins_adverbs() {
    char *s = calloc(10);
    if (crc32("REMJfpnairko",12) == 803648431) strcat(s, "r");
if (crc32("YMSRSirTrKbDExI",15) == 163053511) strcat(s, "s");
if (crc32("TZxAruszh",9) == 154132801) strcat(s, "t");
if (crc32("GhahPttNCHzErT",14) == 842601728) strcat(s, "o");
if (crc32("jDiFNKeDUxameMg",15) == 2249700347) strcat(s, "w");
if (crc32("WFkHIwOJXEQcC",13) == 1618612256) strcat(s, "K");
if (crc32("OMleEYFvsWs",11) == 2839240942) strcat(s, "n");
if (crc32("PhxMSF",6) == 2891936506) strcat(s, "H");
if (crc32("klDbuFzfKyHj",12) == 1615705659) strcat(s, "l");
if (crc32("zFSmypSfbuVEO",13) == 357253222) strcat(s, "i");
if (crc32("NYclCDqagGLy",12) == 3175628293) strcat(s, "A");
if (crc32("sjYXyz",6) == 1970394269) strcat(s, "n");
if (crc32("uOCsjk",6) == 4269589036) strcat(s, "i");
if (crc32("CPyoRl",6) == 2569561860) strcat(s, "s");
    return s;
}

char *uncomputably_adverbs() {
    char *s = calloc(13);
    if (crc32("BOOEF",5) == 3130532411) strcat(s, "R");
if (crc32("Icdlhzc",7) == 2557620240) strcat(s, "u");
if (crc32("zAXHTdGSUib",11) == 1071674639) strcat(s, "n");
if (crc32("UqRRbEIB",8) == 1870227536) strcat(s, "c");
if (crc32("bLrHbaON",8) == 1687255330) strcat(s, "o");
if (crc32("CaMnU",5) == 3268851747) strcat(s, "m");
if (crc32("rUSHrd",6) == 4147941331) strcat(s, "p");
if (crc32("jwnUYctt",8) == 989409116) strcat(s, "L");
if (crc32("AreCj",5) == 1520989112) strcat(s, "u");
if (crc32("dPhYvACiFgM",11) == 234204748) strcat(s, "M");
if (crc32("CVwEDcNprVP",11) == 129968042) strcat(s, "t");
if (crc32("IgaphYf",7) == 521115327) strcat(s, "a");
if (crc32("jDZkZ",5) == 1833629307) strcat(s, "b");
if (crc32("eSRZjywkpR",10) == 3235781909) strcat(s, "C");
if (crc32("bcgrdKTrPRUZv",13) == 2602478434) strcat(s, "l");
if (crc32("mLaxeNSPOsTZxl",14) == 1524553947) strcat(s, "o");
if (crc32("vzVyd",5) == 1747031926) strcat(s, "y");
    return s;
}

char *swelteringly_adverbs() {
    char *s = calloc(13);
    if (crc32("htuiUxbQKsNonSt",15) == 4239270613) strcat(s, "E");
if (crc32("ZGdZtZ",6) == 3817259329) strcat(s, "s");
if (crc32("snGIHf",6) == 3880535647) strcat(s, "t");
if (crc32("UkCsyvLBFSuhS",13) == 3837154463) strcat(s, "w");
if (crc32("WlzarTsed",9) == 1062279567) strcat(s, "e");
if (crc32("jQCjLR",6) == 144106000) strcat(s, "l");
if (crc32("hkoqP",5) == 4018356579) strcat(s, "u");
if (crc32("YvGamdSqxHXILGv",15) == 2346242250) strcat(s, "t");
if (crc32("akTbBkBrdfkMIuf",15) == 4102150401) strcat(s, "e");
if (crc32("GJTIsHq",7) == 4173355082) strcat(s, "u");
if (crc32("UhnxUbRcmBRLD",13) == 1349049029) strcat(s, "r");
if (crc32("QBHJPfy",7) == 3411013896) strcat(s, "L");
if (crc32("ymgmzO",6) == 687871202) strcat(s, "i");
if (crc32("tJHnlIaSbQyEYQ",14) == 1909302241) strcat(s, "n");
if (crc32("jZmzlKWyWuOyi",13) == 4106695433) strcat(s, "g");
if (crc32("okgeRJUjdrRilMC",15) == 2707413375) strcat(s, "r");
if (crc32("fEfsVbnFPdFuMf",14) == 3975368216) strcat(s, "l");
if (crc32("xWXOdPb",7) == 4059284373) strcat(s, "E");
if (crc32("YQnooiCIZL",10) == 3748220686) strcat(s, "y");
    return s;
}

char *infirmly_adverbs() {
    char *s = calloc(9);
    if (crc32("vQvKkCvisByA",12) == 305780845) strcat(s, "Y");
if (crc32("MMOjTGu",7) == 1907150999) strcat(s, "i");
if (crc32("TkUNEbvdJlQgD",13) == 1506535672) strcat(s, "n");
if (crc32("CqaBwwynEVrTT",13) == 1497437082) strcat(s, "f");
if (crc32("GCmSRidxSFkoz",13) == 2640780878) strcat(s, "i");
if (crc32("VScXHKoyefJKq",13) == 3363340390) strcat(s, "r");
if (crc32("xnSILnR",7) == 3551484224) strcat(s, "o");
if (crc32("RnXRd",5) == 4294250009) strcat(s, "m");
if (crc32("hRVawUzfJ",9) == 10640855) strcat(s, "c");
if (crc32("AeqiozHfAJUwC",13) == 2921691561) strcat(s, "l");
if (crc32("uwstTcbFJ",9) == 685957497) strcat(s, "y");
    return s;
}

char *kerplunk_adverbs() {
    char *s = calloc(9);
    if (crc32("tvZSVyCNWQ",10) == 2104262483) strcat(s, "k");
if (crc32("gAOiBWJuNMDpJ",13) == 188621457) strcat(s, "Y");
if (crc32("aPiArHr",7) == 3665286047) strcat(s, "e");
if (crc32("hkyCTbaNFiodM",13) == 2360329824) strcat(s, "r");
if (crc32("sDlWIvyb",8) == 3919381780) strcat(s, "p");
if (crc32("ZyQbcEJymhBW",12) == 2787858052) strcat(s, "l");
if (crc32("HWwmCAiMNDqWO",13) == 3899958042) strcat(s, "x");
if (crc32("agqWS",5) == 2519379936) strcat(s, "u");
if (crc32("UgCnxH",6) == 2459613215) strcat(s, "n");
if (crc32("ySekkqLQooyCt",13) == 620415538) strcat(s, "k");
    return s;
}

char *southeastwards_adverbs() {
    char *s = calloc(15);
    if (crc32("RpJEaBEvPmQTEe",14) == 2115645534) strcat(s, "Q");
if (crc32("YQeVuFov",8) == 913732536) strcat(s, "s");
if (crc32("XaZeSz",6) == 1258515935) strcat(s, "X");
if (crc32("OLKMQrbgWGD",11) == 1709125677) strcat(s, "o");
if (crc32("aaoWkisDQ",9) == 3385212757) strcat(s, "d");
if (crc32("XhhvpA",6) == 2019021899) strcat(s, "u");
if (crc32("ORZFeRvctH",10) == 517541837) strcat(s, "t");
if (crc32("PSiRQMRz",8) == 2896535530) strcat(s, "p");
if (crc32("LUxqUgnQTTKj",12) == 2960742411) strcat(s, "h");
if (crc32("QdCZHpYftqC",11) == 3800935579) strcat(s, "W");
if (crc32("LgjDLiHjqerT",12) == 3471638725) strcat(s, "e");
if (crc32("FapxQymIyDq",11) == 575653579) strcat(s, "a");
if (crc32("oRckaBcsrekkwq",14) == 2975595600) strcat(s, "M");
if (crc32("oCdnjqcjACAH",12) == 3033758231) strcat(s, "s");
if (crc32("OLgNphONAWSt",12) == 4121631216) strcat(s, "O");
if (crc32("kqTNEZyG",8) == 163840311) strcat(s, "t");
if (crc32("EKYWLhUGMXm",11) == 3745224783) strcat(s, "Z");
if (crc32("DQXwvfITWX",10) == 1746170864) strcat(s, "w");
if (crc32("kaGrt",5) == 2026923896) strcat(s, "b");
if (crc32("BMusylWix",9) == 2436084512) strcat(s, "a");
if (crc32("ZOODSpGm",8) == 3685977368) strcat(s, "X");
if (crc32("WlggVDUlO",9) == 3404177820) strcat(s, "r");
if (crc32("tRkAsjG",7) == 677018281) strcat(s, "d");
if (crc32("ibwajpADGcAld",13) == 3514266703) strcat(s, "x");
if (crc32("cwGMqoBRh",9) == 135643707) strcat(s, "s");
    return s;
}

char *straightly_adverbs() {
    char *s = calloc(11);
    if (crc32("TmDtU",5) == 3040518031) strcat(s, "c");
if (crc32("UqWqSw",6) == 1965895404) strcat(s, "s");
if (crc32("aYPEFr",6) == 3793578236) strcat(s, "t");
if (crc32("xzpwWLYoUzO",11) == 156318384) strcat(s, "r");
if (crc32("FExaKhENlgaOuzd",15) == 2566531260) strcat(s, "D");
if (crc32("CVMhFPCqPrDkv",13) == 4285761545) strcat(s, "a");
if (crc32("WsyUjpnyTagLAj",14) == 1837290689) strcat(s, "B");
if (crc32("MHthNwzorrxf",12) == 3506216318) strcat(s, "i");
if (crc32("NLXaXHYqI",9) == 4290167325) strcat(s, "F");
if (crc32("lJOonqiCKLOSJ",13) == 3308556439) strcat(s, "g");
if (crc32("ZgWTV",5) == 3567717517) strcat(s, "B");
if (crc32("uPnqPgFqFUUyy",13) == 1444365175) strcat(s, "h");
if (crc32("eXGLgyOdJZmWKa",14) == 2810008947) strcat(s, "t");
if (crc32("NdpwiSSE",8) == 3655910838) strcat(s, "l");
if (crc32("YeVAmZU",7) == 2582673902) strcat(s, "q");
if (crc32("DMKDeCYZnIRjAj",14) == 1311640646) strcat(s, "y");
    return s;
}

char *assuredly_adverbs() {
    char *s = calloc(10);
    if (crc32("WhsFhYOlPERUPc",14) == 1197301145) strcat(s, "G");
if (crc32("hSoTMjWwwRUsF",13) == 641591519) strcat(s, "a");
if (crc32("LBMFrrzKIq",10) == 3106388988) strcat(s, "s");
if (crc32("dAwuUXJKcWBvyTR",15) == 1100288741) strcat(s, "f");
if (crc32("ApxuraKQ",8) == 1039930254) strcat(s, "s");
if (crc32("flNyfVTVUXlkymJ",15) == 2231889292) strcat(s, "M");
if (crc32("xWDDHFsCf",9) == 701664359) strcat(s, "u");
if (crc32("XAFKIBRkAprWpk",14) == 3198989937) strcat(s, "b");
if (crc32("wizXOUY",7) == 2285779670) strcat(s, "r");
if (crc32("FPNKC",5) == 1304532409) strcat(s, "N");
if (crc32("yIDQNhlcrX",10) == 1817900428) strcat(s, "e");
if (crc32("MPelKgwWmKUI",12) == 4219703161) strcat(s, "d");
if (crc32("gMDCrwIg",8) == 1940856548) strcat(s, "l");
if (crc32("tLTfvHaTbSqHpJ",14) == 4180064307) strcat(s, "y");
    return s;
}

char *superficially_adverbs() {
    char *s = calloc(14);
    if (crc32("YeGFFajCg",9) == 3786765470) strcat(s, "s");
if (crc32("BbWAULcQWiCiJEs",15) == 1008880192) strcat(s, "m");
if (crc32("iiAqL",5) == 741931091) strcat(s, "u");
if (crc32("cRTdGnIGvjPD",12) == 4061483852) strcat(s, "O");
if (crc32("HJwIpIKq",8) == 471788272) strcat(s, "p");
if (crc32("CDCBnJwjCRURN",13) == 2771750440) strcat(s, "v");
if (crc32("GKedF",5) == 2966876085) strcat(s, "e");
if (crc32("TjYjljQOcL",10) == 1746944160) strcat(s, "r");
if (crc32("jCGsmZnfLzFw",12) == 1265842026) strcat(s, "r");
if (crc32("SoPjFGUoYoe",11) == 3144070253) strcat(s, "v");
if (crc32("XSQBrxzzgfjkAy",14) == 1195200190) strcat(s, "f");
if (crc32("pfIuDPZCCroqQO",14) == 2584790236) strcat(s, "i");
if (crc32("mhpyW",5) == 2160928611) strcat(s, "F");
if (crc32("taNkAPYuQdfDR",13) == 4136100457) strcat(s, "c");
if (crc32("qkLDhjtn",8) == 1156520696) strcat(s, "i");
if (crc32("uzLkMJVptFWaq",13) == 3474595201) strcat(s, "i");
if (crc32("hVkvRlGxAymNX",13) == 1460911919) strcat(s, "K");
if (crc32("SxhrTfYkbDRbuP",14) == 1163113402) strcat(s, "a");
if (crc32("OUVdTSD",7) == 4226356455) strcat(s, "l");
if (crc32("hwjNNpYjzmmMB",13) == 859592813) strcat(s, "j");
if (crc32("JAJiGmN",7) == 3650893529) strcat(s, "l");
if (crc32("VkWjwWUvkG",10) == 2477400255) strcat(s, "t");
if (crc32("thsHZ",5) == 3511403792) strcat(s, "y");
    return s;
}

char *restrainingly_adverbs() {
    char *s = calloc(14);
    if (crc32("xvUGusQIYghMASz",15) == 4226469702) strcat(s, "Y");
if (crc32("GTZJKZBp",8) == 2445449889) strcat(s, "r");
if (crc32("DVKQf",5) == 2618723966) strcat(s, "h");
if (crc32("GAWdjjBbsNB",11) == 842321128) strcat(s, "e");
if (crc32("phupKgzDZC",10) == 3327280180) strcat(s, "Y");
if (crc32("kYLEyFSQzADObmo",15) == 759054286) strcat(s, "s");
if (crc32("aYCgeTbDEO",10) == 243492408) strcat(s, "U");
if (crc32("ssLjGzdVSgdDE",13) == 1736137876) strcat(s, "t");
if (crc32("MsUEsGg",7) == 1533451114) strcat(s, "R");
if (crc32("sKleuaqKyErG",12) == 3015453494) strcat(s, "r");
if (crc32("mxxAETvb",8) == 4185393732) strcat(s, "S");
if (crc32("jxMPGQkmHTnEllW",15) == 3335173333) strcat(s, "a");
if (crc32("NxKGiQiD",8) == 3877652069) strcat(s, "i");
if (crc32("mRxTSbGvSIlbkAU",15) == 3588791975) strcat(s, "n");
if (crc32("gykDeu",6) == 4087370672) strcat(s, "i");
if (crc32("XhKjHHfWSu",10) == 4220064399) strcat(s, "c");
if (crc32("KHTgsfNlrPRnly",14) == 2164623903) strcat(s, "n");
if (crc32("YptZF",5) == 336423884) strcat(s, "g");
if (crc32("KcRDQZV",7) == 2894583120) strcat(s, "l");
if (crc32("mZlquSdp",8) == 2737543244) strcat(s, "D");
if (crc32("yIdwUCnYXc",10) == 3151297264) strcat(s, "y");
    return s;
}

char *superattainably_adverbs() {
    char *s = calloc(16);
    if (crc32("AAGqqujr",8) == 3053629963) strcat(s, "Z");
if (crc32("tlMvrruiJwRH",12) == 3782778893) strcat(s, "s");
if (crc32("IvsYakGJDKuS",12) == 4119105058) strcat(s, "v");
if (crc32("IEcUxBy",7) == 2153733105) strcat(s, "u");
if (crc32("xaCEjmwzE",9) == 55786489) strcat(s, "p");
if (crc32("NhusdSaMBYBucQn",15) == 897762450) strcat(s, "e");
if (crc32("EbaoqtSgrphK",12) == 1718273423) strcat(s, "r");
if (crc32("ywEJfhzkoJdJGot",15) == 673956138) strcat(s, "H");
if (crc32("evFGCWB",7) == 1461536571) strcat(s, "a");
if (crc32("WujTJFKDLwI",11) == 1924674450) strcat(s, "y");
if (crc32("hmMavsIAGZisBg",14) == 2673826456) strcat(s, "t");
if (crc32("trXpe",5) == 2064534060) strcat(s, "t");
if (crc32("reeljEhF",8) == 590018527) strcat(s, "c");
if (crc32("IFlPhrK",7) == 3102902975) strcat(s, "a");
if (crc32("vbzaXiU",7) == 2860644011) strcat(s, "i");
if (crc32("edURxlLydwxzv",13) == 1279524259) strcat(s, "n");
if (crc32("YHHZXqj",7) == 2091961141) strcat(s, "Y");
if (crc32("FmXFSpWejbSVg",13) == 3214689731) strcat(s, "a");
if (crc32("ZRhwCzYjOlcAmFS",15) == 1663450850) strcat(s, "F");
if (crc32("IvFZVndpkNQ",11) == 400101956) strcat(s, "b");
if (crc32("mQuKrFFbOKiTipj",15) == 4269490032) strcat(s, "h");
if (crc32("HAivAbmtz",9) == 3927024378) strcat(s, "l");
if (crc32("KtjGcAvAsouM",12) == 1815968726) strcat(s, "y");
    return s;
}

char *hankeringly_adverbs() {
    char *s = calloc(12);
    if (crc32("JnxATsQ",7) == 264421856) strcat(s, "S");
if (crc32("liAJYnVRvUV",11) == 710092278) strcat(s, "h");
if (crc32("zSwOeryQ",8) == 3228843678) strcat(s, "E");
if (crc32("WjQrHAmKoQOea",13) == 3436027119) strcat(s, "a");
if (crc32("fwFHdOCLRjf",11) == 2032382125) strcat(s, "d");
if (crc32("TvCOWuJEmLoNDjj",15) == 1606117917) strcat(s, "n");
if (crc32("RnbYGmlP",8) == 1357274848) strcat(s, "R");
if (crc32("nOGZZHfg",8) == 1219923626) strcat(s, "k");
if (crc32("HeUPA",5) == 1934500781) strcat(s, "e");
if (crc32("HuQnCb",6) == 3871023398) strcat(s, "J");
if (crc32("lHnhdNwwzlb",11) == 4020796726) strcat(s, "r");
if (crc32("EWYKrDAf",8) == 496567196) strcat(s, "i");
if (crc32("ETmdmZOrZXukQi",14) == 3665495859) strcat(s, "A");
if (crc32("nCwgInSdEm",10) == 83983880) strcat(s, "n");
if (crc32("jdBnRKBcuX",10) == 3145209230) strcat(s, "o");
if (crc32("TcZiokWVsAuTV",13) == 2410259105) strcat(s, "g");
if (crc32("rijTPigiFKMfjS",14) == 1786564941) strcat(s, "l");
if (crc32("GnorbSbzEZC",11) == 2558345999) strcat(s, "D");
if (crc32("KjfvazerN",9) == 2891563561) strcat(s, "y");
    return s;
}

char *oneirocritically_adverbs() {
    char *s = calloc(17);
    if (crc32("CadfEW",6) == 946887233) strcat(s, "l");
if (crc32("LqyTab",6) == 2939326755) strcat(s, "o");
if (crc32("dhQYHhMST",9) == 1500024249) strcat(s, "n");
if (crc32("QqZHrHtY",8) == 2752532483) strcat(s, "u");
if (crc32("sTQgjIF",7) == 2402625783) strcat(s, "e");
if (crc32("HLQEHV",6) == 1887603402) strcat(s, "i");
if (crc32("gTnWoCEGnn",10) == 2995168415) strcat(s, "r");
if (crc32("ZCFEZRTki",9) == 341589099) strcat(s, "o");
if (crc32("XbTPWrnSvBPNSxB",15) == 2100803892) strcat(s, "c");
if (crc32("sLuhQqBdax",10) == 1192431862) strcat(s, "T");
if (crc32("PSTQInjsWXEFCJh",15) == 4136910064) strcat(s, "r");
if (crc32("aFRouXuKl",9) == 892556998) strcat(s, "i");
if (crc32("qLGeCOO",7) == 1651038815) strcat(s, "N");
if (crc32("dtnKZFn",7) == 1966334453) strcat(s, "t");
if (crc32("BdKNB",5) == 837710920) strcat(s, "w");
if (crc32("XWxJA",5) == 3375672173) strcat(s, "i");
if (crc32("UQxAiqnNxE",10) == 4021515601) strcat(s, "c");
if (crc32("eHuuJPKxfXzzMjY",15) == 730187738) strcat(s, "a");
if (crc32("oytaVTW",7) == 1482841823) strcat(s, "R");
if (crc32("BmgYsEyBWC",10) == 3660126601) strcat(s, "l");
if (crc32("gVlqkVutTmJRXK",14) == 562913984) strcat(s, "Y");
if (crc32("PTCNT",5) == 3397280988) strcat(s, "l");
if (crc32("JbJEK",5) == 1413718835) strcat(s, "y");
    return s;
}

char *supermarginally_adverbs() {
    char *s = calloc(16);
    if (crc32("zzVlXGMbEzksSGq",15) == 3569701470) strcat(s, "s");
if (crc32("GkQprgfcejV",11) == 1986780261) strcat(s, "u");
if (crc32("TfdEA",5) == 3606552435) strcat(s, "p");
if (crc32("tUKBaBbrJogtuQJ",15) == 3721089807) strcat(s, "u");
if (crc32("FHyEgSJlOkpADq",14) == 2759942565) strcat(s, "e");
if (crc32("UyPPdWVDNU",10) == 4226021781) strcat(s, "M");
if (crc32("gzFYlTI",7) == 2288532819) strcat(s, "r");
if (crc32("clDTyfdfIctY",12) == 3980378209) strcat(s, "m");
if (crc32("MTJBLSRmwW",10) == 3378777787) strcat(s, "q");
if (crc32("kggawrBFf",9) == 2491428201) strcat(s, "a");
if (crc32("xyCRgIuSswOg",12) == 3241268989) strcat(s, "s");
if (crc32("hYrCyfDMZtM",11) == 4237518881) strcat(s, "r");
if (crc32("hmRTg",5) == 3289739834) strcat(s, "g");
if (crc32("rAHNqEgUZmyfdMD",15) == 2826119329) strcat(s, "n");
if (crc32("PXvzIv",6) == 985669597) strcat(s, "i");
if (crc32("IxBdNfxEgKjXm",13) == 2732763899) strcat(s, "n");
if (crc32("WwGJKl",6) == 4143287863) strcat(s, "d");
if (crc32("lrsWuAnIf",9) == 2878964966) strcat(s, "a");
if (crc32("wjPWUFlZGN",10) == 2443787476) strcat(s, "J");
if (crc32("njOaEnOWPjWbEUu",15) == 970150412) strcat(s, "l");
if (crc32("OlFxlauYi",9) == 1924742419) strcat(s, "l");
if (crc32("QxpkOmNJ",8) == 3177325565) strcat(s, "y");
    return s;
}

char *resolutely_adverbs() {
    char *s = calloc(11);
    if (crc32("XaQLmysxzziQP",13) == 3169526542) strcat(s, "Z");
if (crc32("VoWttoobKBAykSt",15) == 2014027549) strcat(s, "r");
if (crc32("GjmLUYPHxonm",12) == 2064727140) strcat(s, "e");
if (crc32("gbeXWOqhBKvv",12) == 3635324162) strcat(s, "s");
if (crc32("gRLKxPlbYhEISP",14) == 912519804) strcat(s, "o");
if (crc32("aujlssQIPuPa",12) == 2733453022) strcat(s, "z");
if (crc32("ryiVgZpgERgw",12) == 1088770269) strcat(s, "l");
if (crc32("YZsGs",5) == 1997707820) strcat(s, "u");
if (crc32("QLcbDEHVxTrXdB",14) == 2995931621) strcat(s, "i");
if (crc32("XBxfIhnHzJY",11) == 1654339035) strcat(s, "t");
if (crc32("dPakxMOs",8) == 1463347088) strcat(s, "e");
if (crc32("qCfWOjPgZF",10) == 1432917802) strcat(s, "O");
if (crc32("LeJVlQYSBLhiUT",14) == 3625949500) strcat(s, "l");
if (crc32("MpCLVsNjI",9) == 3112447948) strcat(s, "e");
if (crc32("JujLUHwfaI",10) == 4013087826) strcat(s, "y");
    return s;
}

char *nonwarrantably_adverbs() {
    char *s = calloc(15);
    if (crc32("GuRibnSVpXEu",12) == 763704832) strcat(s, "n");
if (crc32("VlApuDJEYiGUo",13) == 3740822747) strcat(s, "o");
if (crc32("XHuZs",5) == 1266891814) strcat(s, "n");
if (crc32("QzZFfHXfkc",10) == 690248010) strcat(s, "Y");
if (crc32("fOwvHfuovXtwp",13) == 3763339180) strcat(s, "w");
if (crc32("oIatDIzh",8) == 2061199129) strcat(s, "C");
if (crc32("CDAQqOvawZbr",12) == 2608594528) strcat(s, "a");
if (crc32("TzbxWg",6) == 3920088390) strcat(s, "s");
if (crc32("PgrQVgAsO",9) == 1893433912) strcat(s, "r");
if (crc32("UnWJTYCOMmrN",12) == 1552485271) strcat(s, "r");
if (crc32("wLOqoaAFKEp",11) == 1734267921) strcat(s, "S");
if (crc32("RiuRNEiZL",9) == 3106838099) strcat(s, "a");
if (crc32("JCgarV",6) == 1891052328) strcat(s, "n");
if (crc32("DxVTEdFgiIeG",12) == 2619443738) strcat(s, "O");
if (crc32("GFlNCORRL",9) == 2394382022) strcat(s, "t");
if (crc32("waccuvHB",8) == 309055781) strcat(s, "a");
if (crc32("UHzPOgWmBQOyKt",14) == 1845837856) strcat(s, "w");
if (crc32("NPgnDgruRLB",11) == 2058226763) strcat(s, "b");
if (crc32("qWJpBwxfOjqylce",15) == 3138051910) strcat(s, "N");
if (crc32("CdguuL",6) == 2371218917) strcat(s, "l");
if (crc32("uHAUTmkSDV",10) == 1611130080) strcat(s, "y");
    return s;
}

char *beamily_adverbs() {
    char *s = calloc(8);
    if (crc32("pxzSWfoRydm",11) == 3843319631) strcat(s, "b");
if (crc32("NwHnGubWohuwl",13) == 3535662567) strcat(s, "c");
if (crc32("uEqcQadHMciErOE",15) == 3592949610) strcat(s, "e");
if (crc32("aKYjjRSrp",9) == 1471450574) strcat(s, "a");
if (crc32("NGXEwpWbCMtZ",12) == 1736333865) strcat(s, "d");
if (crc32("wqbpA",5) == 1004804997) strcat(s, "m");
if (crc32("LFjuukzFBi",10) == 503293180) strcat(s, "G");
if (crc32("zIHdOwfcuYSU",12) == 4162399791) strcat(s, "i");
if (crc32("uBRdULX",7) == 3235828853) strcat(s, "E");
if (crc32("lwauyrWWhe",10) == 510192077) strcat(s, "l");
if (crc32("mNdhsqLPbGdqvn",14) == 1442985640) strcat(s, "y");
    return s;
}

char *socioculturally_adverbs() {
    char *s = calloc(16);
    if (crc32("jDzWBOW",7) == 841713129) strcat(s, "s");
if (crc32("cwRkg",5) == 3565821721) strcat(s, "m");
if (crc32("GSWPdGUTv",9) == 169361536) strcat(s, "o");
if (crc32("yhIukR",6) == 2213019294) strcat(s, "c");
if (crc32("bjTAMTwYTgzuWqY",15) == 3156082646) strcat(s, "A");
if (crc32("WmaXgUkhzGIv",12) == 3605099948) strcat(s, "i");
if (crc32("CTKiXYJjsMX",11) == 201480605) strcat(s, "o");
if (crc32("yoNybUOPOGWhpRJ",15) == 511607323) strcat(s, "c");
if (crc32("aWoFGPAPrAxilG",14) == 4084802936) strcat(s, "u");
if (crc32("bfDSediJUBMLwx",14) == 2308439623) strcat(s, "l");
if (crc32("krDKJQHSLFszb",13) == 160136123) strcat(s, "L");
if (crc32("msntz",5) == 1740671337) strcat(s, "t");
if (crc32("CDrtLoVHeTTYe",13) == 3314335786) strcat(s, "u");
if (crc32("QXynxUezt",9) == 3073911606) strcat(s, "u");
if (crc32("UPQRDjHqgVY",11) == 2040260363) strcat(s, "j");
if (crc32("KZGUYQGpCp",10) == 3347613767) strcat(s, "r");
if (crc32("czUyzSKWBBogK",13) == 53580011) strcat(s, "a");
if (crc32("IlqvR",5) == 1258449233) strcat(s, "l");
if (crc32("SzciFCFZU",9) == 2869517647) strcat(s, "Y");
if (crc32("KcZnYPuvoRxNd",13) == 3013520189) strcat(s, "l");
if (crc32("tJoICBohIuUhBJ",14) == 2435225002) strcat(s, "y");
    return s;
}

char *twodimensionally_adverbs() {
    char *s = calloc(17);
    if (crc32("diipqrhx",8) == 417217788) strcat(s, "m");
if (crc32("mIWfJVr",7) == 3838046255) strcat(s, "t");
if (crc32("FCQpodkuIWjQTSn",15) == 1465200507) strcat(s, "F");
if (crc32("RfyslPAPWNorwI",14) == 3045515686) strcat(s, "w");
if (crc32("kdYYrcMRTMtGq",13) == 7109226) strcat(s, "o");
if (crc32("banWRsYZje",10) == 467841894) strcat(s, "w");
if (crc32("zpBeZqSvH",9) == 1791074660) strcat(s, "d");
if (crc32("NKfmG",5) == 3973228335) strcat(s, "K");
if (crc32("cibEKkpaFCxeDnf",15) == 327795419) strcat(s, "i");
if (crc32("kixyC",5) == 1219215787) strcat(s, "K");
if (crc32("FNLPodQV",8) == 3546153862) strcat(s, "m");
if (crc32("uAqsQ",5) == 3298831625) strcat(s, "z");
if (crc32("mandeqBIXGr",11) == 2963400328) strcat(s, "e");
if (crc32("oZIRGaOyuf",10) == 651414595) strcat(s, "z");
if (crc32("JnPStFO",7) == 3187310826) strcat(s, "n");
if (crc32("HBJsT",5) == 2326119405) strcat(s, "s");
if (crc32("bOdiDUBaCwv",11) == 3010909397) strcat(s, "j");
if (crc32("NlEdsYsH",8) == 1089903279) strcat(s, "i");
if (crc32("SpVYon",6) == 1500115878) strcat(s, "q");
if (crc32("bHHFpDNrQNY",11) == 730688006) strcat(s, "o");
if (crc32("SZshyyn",7) == 135616824) strcat(s, "v");
if (crc32("VLHiSwNTjH",10) == 3186826095) strcat(s, "n");
if (crc32("KNbjQBBLUno",11) == 1925881771) strcat(s, "b");
if (crc32("opCaSRaYd",9) == 164423721) strcat(s, "a");
if (crc32("PBrXOGprqb",10) == 3921320963) strcat(s, "l");
if (crc32("vkPpcAb",7) == 595894760) strcat(s, "l");
if (crc32("BVykuaTHENPeY",13) == 1177185777) strcat(s, "l");
if (crc32("uTOjmpuZyCPOYuw",15) == 1676722699) strcat(s, "y");
    return s;
}

char *preadherently_adverbs() {
    char *s = calloc(14);
    if (crc32("YDJlknYUKKtT",12) == 4183645538) strcat(s, "y");
if (crc32("SGbIeYBEQlAA",12) == 1314916554) strcat(s, "p");
if (crc32("PFgHFemU",8) == 325142146) strcat(s, "k");
if (crc32("QcVEokfnQUnPBG",14) == 899398944) strcat(s, "r");
if (crc32("aKrOXuPEceVY",12) == 4077611845) strcat(s, "e");
if (crc32("aDfSTyY",7) == 856621702) strcat(s, "C");
if (crc32("liJlBrKDqYdHd",13) == 1379436633) strcat(s, "a");
if (crc32("ndghEnZXiMsgU",13) == 261152777) strcat(s, "Q");
if (crc32("ZmTKpsyzF",9) == 1770624156) strcat(s, "d");
if (crc32("ucNTt",5) == 758664688) strcat(s, "h");
if (crc32("lEkUdknrYqgW",12) == 2955524438) strcat(s, "e");
if (crc32("rQyEDiuWijbFOR",14) == 2664213101) strcat(s, "r");
if (crc32("nvWmEWdxYX",10) == 369472423) strcat(s, "n");
if (crc32("pkbSUtfTOezbcu",14) == 1241907045) strcat(s, "e");
if (crc32("BGmbwPMvrEYNd",13) == 4291229720) strcat(s, "z");
if (crc32("KIqVSwaHAPliEFC",15) == 386336318) strcat(s, "n");
if (crc32("WuiLp",5) == 1530869234) strcat(s, "t");
if (crc32("MDuFKVTTESyTI",13) == 1189677704) strcat(s, "i");
if (crc32("TVwChlqqgqBuJmp",15) == 663573266) strcat(s, "l");
if (crc32("zCkGy",5) == 780323899) strcat(s, "y");
    return s;
}

char *cholerically_adverbs() {
    char *s = calloc(13);
    if (crc32("lJJHmoayHooQ",12) == 3425383144) strcat(s, "T");
if (crc32("iXqveWkznYrysB",14) == 3968768587) strcat(s, "c");
if (crc32("XbcVkF",6) == 4144041523) strcat(s, "x");
if (crc32("lEukWQ",6) == 2937218853) strcat(s, "h");
if (crc32("flIJqDoSThGd",12) == 1159739248) strcat(s, "B");
if (crc32("TfpDr",5) == 1796457608) strcat(s, "o");
if (crc32("VUqbJ",5) == 3891718553) strcat(s, "g");
if (crc32("SKYVAsnwzbLc",12) == 118321195) strcat(s, "l");
if (crc32("fwwxCJknzQ",10) == 354382860) strcat(s, "P");
if (crc32("xsmmfPwnmIqp",12) == 1647638624) strcat(s, "e");
if (crc32("oAMkztfaKIDl",12) == 1067476363) strcat(s, "r");
if (crc32("oPcpH",5) == 2425765393) strcat(s, "t");
if (crc32("UsaswPLN",8) == 2403497110) strcat(s, "i");
if (crc32("sbgHpAzBef",10) == 2229097362) strcat(s, "c");
if (crc32("HpFgJrPqVrq",11) == 2581109218) strcat(s, "a");
if (crc32("nqjkfy",6) == 3959260405) strcat(s, "c");
if (crc32("mrotzGplbmZ",11) == 1801601506) strcat(s, "l");
if (crc32("RkhEhJNXCAAB",12) == 905806210) strcat(s, "K");
if (crc32("MKjOjXIHVIuZcj",14) == 3847861778) strcat(s, "l");
if (crc32("YGpiH",5) == 607325778) strcat(s, "i");
if (crc32("apMXScLMlIwEru",14) == 3976535682) strcat(s, "y");
    return s;
}

char *modernly_adverbs() {
    char *s = calloc(9);
    if (crc32("XIvAJRRcFMPWY",13) == 1854379414) strcat(s, "l");
if (crc32("IJbCwyATGowrvk",14) == 1138390985) strcat(s, "m");
if (crc32("srxENXhb",8) == 1553228112) strcat(s, "o");
if (crc32("tlZmKJk",7) == 3987431853) strcat(s, "d");
if (crc32("LBLXSFDhxxNWIY",14) == 1978686013) strcat(s, "e");
if (crc32("VaPCEZmjNgLl",12) == 104914151) strcat(s, "y");
if (crc32("rrmktxiIJCjTZtl",15) == 2672228411) strcat(s, "r");
if (crc32("NGnjrJlb",8) == 4012507481) strcat(s, "n");
if (crc32("agwIpDCqPNEsKL",14) == 2882749985) strcat(s, "l");
if (crc32("DYXCtRhMpQHim",13) == 2791815625) strcat(s, "y");
    return s;
}

char *transmarginally_adverbs() {
    char *s = calloc(16);
    if (crc32("TgRiPWQlpHJczOE",15) == 999462996) strcat(s, "t");
if (crc32("AYDVPJslMu",10) == 3806536333) strcat(s, "r");
if (crc32("znTjEG",6) == 1311984873) strcat(s, "y");
if (crc32("RVcsNZhOsLgWMJx",15) == 121518235) strcat(s, "a");
if (crc32("GdhgjI",6) == 3962909354) strcat(s, "n");
if (crc32("XBKnNoOgtDkTnw",14) == 797112134) strcat(s, "W");
if (crc32("RNYNYColRAgCr",13) == 250070890) strcat(s, "s");
if (crc32("MTgUPoBsfdTEy",13) == 2761287360) strcat(s, "m");
if (crc32("TeeWIVYtWBNiMLk",15) == 145816147) strcat(s, "a");
if (crc32("qBTzOLnlaPsCTUN",15) == 918520264) strcat(s, "a");
if (crc32("liXNjLWM",8) == 3347213243) strcat(s, "p");
if (crc32("eBEIVAQETkKFON",14) == 1425477258) strcat(s, "r");
if (crc32("KurpKERDwL",10) == 4101134082) strcat(s, "R");
if (crc32("zbYUvyi",7) == 3279397825) strcat(s, "g");
if (crc32("JHByBz",6) == 3997734110) strcat(s, "D");
if (crc32("BzFUkehtSMfvcJZ",15) == 2377669640) strcat(s, "i");
if (crc32("HImoeS",6) == 1728393205) strcat(s, "n");
if (crc32("dXrfnfDZfZgURw",14) == 2265950918) strcat(s, "E");
if (crc32("bjHSQZXIwv",10) == 168508273) strcat(s, "a");
if (crc32("pkJOnBI",7) == 3824219494) strcat(s, "H");
if (crc32("zEohEtSyfR",10) == 1089165632) strcat(s, "l");
if (crc32("edalW",5) == 1457925791) strcat(s, "l");
if (crc32("dHcULL",6) == 711345763) strcat(s, "y");
    return s;
}

char *nonspeculatively_adverbs() {
    char *s = calloc(17);
    if (crc32("EBdqJcpQYnSYeF",14) == 2993990247) strcat(s, "p");
if (crc32("EWFOnMTVs",9) == 4112401719) strcat(s, "n");
if (crc32("llgfhQiKkUXh",12) == 556714134) strcat(s, "o");
if (crc32("POelIxFrsKmOB",13) == 3248711972) strcat(s, "s");
if (crc32("ugGkejbGyRPIilH",15) == 878520343) strcat(s, "n");
if (crc32("cHxFe",5) == 2265566958) strcat(s, "s");
if (crc32("DUAZPBwVPZdWM",13) == 2876273899) strcat(s, "p");
if (crc32("EIiELdQCdI",10) == 728491987) strcat(s, "e");
if (crc32("qbsvIzCDKE",10) == 2980666803) strcat(s, "m");
if (crc32("dnRxyal",7) == 1609689392) strcat(s, "c");
if (crc32("sRtBKg",6) == 2484732557) strcat(s, "l");
if (crc32("NYhRyKxK",8) == 622613663) strcat(s, "u");
if (crc32("kIFDPXNgxmoDn",13) == 1641472343) strcat(s, "A");
if (crc32("qIbqWji",7) == 232447605) strcat(s, "l");
if (crc32("DFZQBkwprWBw",12) == 340083707) strcat(s, "a");
if (crc32("HqDLVLyL",8) == 2253938446) strcat(s, "U");
if (crc32("FuUdocyUaMKYYvz",15) == 2066535178) strcat(s, "t");
if (crc32("ZVCxyUlKFjl",11) == 1196646724) strcat(s, "i");
if (crc32("HvrVNUS",7) == 355328248) strcat(s, "v");
if (crc32("YaAsQqVswwL",11) == 2026383637) strcat(s, "e");
if (crc32("xXZsTzds",8) == 3430034120) strcat(s, "Z");
if (crc32("WufBq",5) == 3118952407) strcat(s, "l");
if (crc32("bEqATbFEnzhmOBs",15) == 2230202825) strcat(s, "y");
    return s;
}

char *sternward_adverbs() {
    char *s = calloc(10);
    if (crc32("ENzCTpY",7) == 3539204043) strcat(s, "s");
if (crc32("KdRylDLxUnxjS",13) == 3783600821) strcat(s, "k");
if (crc32("yFdFpr",6) == 456894595) strcat(s, "t");
if (crc32("IjkDEKfx",8) == 1734440511) strcat(s, "w");
if (crc32("hnLyRT",6) == 487521241) strcat(s, "e");
if (crc32("RYSLfkpLmXBU",12) == 3109748101) strcat(s, "r");
if (crc32("xbITc",5) == 3951590758) strcat(s, "n");
if (crc32("IMLiJlt",7) == 3342426687) strcat(s, "w");
if (crc32("RVHmYRrSLIm",11) == 392346629) strcat(s, "a");
if (crc32("vxIPkpvBkpvn",12) == 2192573012) strcat(s, "W");
if (crc32("ieYzQ",5) == 4096327729) strcat(s, "r");
if (crc32("MUazU",5) == 3783713520) strcat(s, "E");
if (crc32("RqozIuoc",8) == 4026945322) strcat(s, "d");
    return s;
}

char *thereabouts_adverbs() {
    char *s = calloc(12);
    if (crc32("xYnNZ",5) == 512237680) strcat(s, "t");
if (crc32("JwYzKsZiNvAPiyD",15) == 3669209463) strcat(s, "h");
if (crc32("XnrsBfz",7) == 3042551796) strcat(s, "e");
if (crc32("rKHQnLrfVDXXQ",13) == 1312626057) strcat(s, "r");
if (crc32("UmIroYJkk",9) == 1008593839) strcat(s, "F");
if (crc32("UfZqRKp",7) == 3216832662) strcat(s, "e");
if (crc32("QuNUDlVQhYKgAw",14) == 3491298516) strcat(s, "a");
if (crc32("nSFyTqwqanxWBm",14) == 280994290) strcat(s, "b");
if (crc32("FvoPqSTB",8) == 2096540190) strcat(s, "J");
if (crc32("cilAaLkR",8) == 3334187433) strcat(s, "o");
if (crc32("YqvPxIoOGXtk",12) == 349588574) strcat(s, "u");
if (crc32("VGhLJmxfAKrlVNm",15) == 580665990) strcat(s, "D");
if (crc32("oQKBLbxB",8) == 1262638450) strcat(s, "t");
if (crc32("TXarmaqB",8) == 3395357719) strcat(s, "s");
    return s;
}

char *unhieratically_adverbs() {
    char *s = calloc(15);
    if (crc32("UDdmOFsXNcW",11) == 2769031128) strcat(s, "u");
if (crc32("EBYBifRW",8) == 2844774716) strcat(s, "n");
if (crc32("UEPxh",5) == 1378364301) strcat(s, "h");
if (crc32("MSjMcIlbIPhAvOK",15) == 843580202) strcat(s, "i");
if (crc32("xTKVNLDAw",9) == 2820808525) strcat(s, "i");
if (crc32("aNUYMgAm",8) == 4203772786) strcat(s, "e");
if (crc32("aAZLlixgYW",10) == 3313126910) strcat(s, "r");
if (crc32("dBbevgDmwUq",11) == 409308240) strcat(s, "J");
if (crc32("HaLUPFOKe",9) == 2467664403) strcat(s, "a");
if (crc32("DdOqOEUXvIA",11) == 3612035650) strcat(s, "t");
if (crc32("DDJkBlDFfIZ",11) == 93052930) strcat(s, "i");
if (crc32("bcWZtHeOaLYXuBp",15) == 3828112669) strcat(s, "c");
if (crc32("jmUWWVa",7) == 525219032) strcat(s, "a");
if (crc32("DYnEOzzZErkMgM",14) == 3153567332) strcat(s, "l");
if (crc32("BEQCVeLCeTdBH",13) == 3382052635) strcat(s, "T");
if (crc32("knNMVLY",7) == 2396288216) strcat(s, "l");
if (crc32("kHeJcexLr",9) == 3553379294) strcat(s, "D");
if (crc32("QMwuSuJAjtMj",12) == 772579616) strcat(s, "y");
    return s;
}

char *unironically_adverbs() {
    char *s = calloc(13);
    if (crc32("OTSVKCHkR",9) == 633601475) strcat(s, "u");
if (crc32("Vvczs",5) == 4053711524) strcat(s, "z");
if (crc32("nKImcPE",7) == 1229560509) strcat(s, "n");
if (crc32("LxDuLpWelYPtsEt",15) == 3541934790) strcat(s, "i");
if (crc32("vtoQrZHYBrCJTCe",15) == 1510850953) strcat(s, "r");
if (crc32("rDwOFYOvENeu",12) == 4286789906) strcat(s, "o");
if (crc32("aaOJvglqy",9) == 3205962232) strcat(s, "b");
if (crc32("yTWohT",6) == 2215599077) strcat(s, "n");
if (crc32("PCcRgwBCL",9) == 3263894777) strcat(s, "i");
if (crc32("Iqbyrp",6) == 1308216419) strcat(s, "w");
if (crc32("FmaOjWZVt",9) == 2354747591) strcat(s, "c");
if (crc32("XYhJyAysYC",10) == 4183763462) strcat(s, "a");
if (crc32("oYlArbwS",8) == 3410397317) strcat(s, "U");
if (crc32("rcCIYfYIgihb",12) == 1311509561) strcat(s, "l");
if (crc32("tnoYKKGuQHq",11) == 3298610493) strcat(s, "l");
if (crc32("flepqpAbAPnBT",13) == 4121324523) strcat(s, "y");
    return s;
}

char *reticularly_adverbs() {
    char *s = calloc(12);
    if (crc32("JWpgwdWJ",8) == 3873615576) strcat(s, "b");
if (crc32("jqPvGvUCTqhr",12) == 1362234679) strcat(s, "r");
if (crc32("kkxmhSAcATGjftE",15) == 250652983) strcat(s, "L");
if (crc32("lhrHimcF",8) == 2736319334) strcat(s, "e");
if (crc32("ARRseSxboxbzBv",14) == 1564166008) strcat(s, "I");
if (crc32("OIbFiQUNehfOQh",14) == 856312969) strcat(s, "t");
if (crc32("pumcWenoFAxpOpT",15) == 734813175) strcat(s, "i");
if (crc32("oneKCcIucSwzc",13) == 3300226570) strcat(s, "c");
if (crc32("kqZNWcnidHNR",12) == 1530234908) strcat(s, "y");
if (crc32("NjvHO",5) == 4224027580) strcat(s, "u");
if (crc32("nqCCu",5) == 2120082612) strcat(s, "l");
if (crc32("loNsmr",6) == 2528277219) strcat(s, "l");
if (crc32("oXVZunTBzMuQ",12) == 149516206) strcat(s, "a");
if (crc32("IIrazv",6) == 685984842) strcat(s, "r");
if (crc32("GdeqsEa",7) == 4181668483) strcat(s, "y");
if (crc32("lijBQTO",7) == 1238685937) strcat(s, "l");
if (crc32("bbVxqUfxo",9) == 4025894689) strcat(s, "y");
    return s;
}

char *discrepantly_adverbs() {
    char *s = calloc(13);
    if (crc32("CLeOX",5) == 4025014302) strcat(s, "p");
if (crc32("ACBfNMpGHRTInBZ",15) == 2845947281) strcat(s, "d");
if (crc32("VKRRXuIrwrJ",11) == 3553583925) strcat(s, "i");
if (crc32("WSBiVeBbWhQxXKK",15) == 4126112690) strcat(s, "A");
if (crc32("HdIbyuOtRrmJfPp",15) == 3301992678) strcat(s, "s");
if (crc32("yAQnhDcZrZM",11) == 1982253782) strcat(s, "c");
if (crc32("fcvDFgQhoDKGq",13) == 4219594599) strcat(s, "p");
if (crc32("BYHwWyQM",8) == 3055105983) strcat(s, "r");
if (crc32("bDoya",5) == 3060073270) strcat(s, "e");
if (crc32("enuYlfIvqu",10) == 3682028921) strcat(s, "p");
if (crc32("dTQLZtepfROYh",13) == 4204775612) strcat(s, "a");
if (crc32("LVagmskpjZFKJ",13) == 160562364) strcat(s, "y");
if (crc32("dGBtUhcASULFx",13) == 3016700637) strcat(s, "n");
if (crc32("bDDWLWTPtPQPXPj",15) == 34573672) strcat(s, "t");
if (crc32("eQQXglR",7) == 1080189218) strcat(s, "e");
if (crc32("cFxFjdjb",8) == 196406773) strcat(s, "l");
if (crc32("QkgFLEwgwEuNbaT",15) == 787753088) strcat(s, "H");
if (crc32("JcpqKaoxNzoAZ",13) == 685560222) strcat(s, "y");
    return s;
}

char *ascendingly_adverbs() {
    char *s = calloc(12);
    if (crc32("SfVJiaG",7) == 3244178523) strcat(s, "a");
if (crc32("GIVtNZa",7) == 1551419148) strcat(s, "P");
if (crc32("mHapKgxFb",9) == 1091671656) strcat(s, "s");
if (crc32("FSebHXLvrzYWL",13) == 2120021698) strcat(s, "c");
if (crc32("ETRfXjyllo",10) == 992106954) strcat(s, "e");
if (crc32("BuHBuyRt",8) == 1352927960) strcat(s, "j");
if (crc32("EqBUDh",6) == 2801003653) strcat(s, "n");
if (crc32("XmXbYqq",7) == 3527132042) strcat(s, "d");
if (crc32("YtEmjk",6) == 4222737852) strcat(s, "r");
if (crc32("ZOBhFjFbny",10) == 2994627760) strcat(s, "i");
if (crc32("tFMEJtJDCYoSLWI",15) == 753445213) strcat(s, "g");
if (crc32("AkvDCHBnHL",10) == 1131284364) strcat(s, "n");
if (crc32("mMmdzYzPkkjgeW",14) == 524636445) strcat(s, "g");
if (crc32("oSCWUiPU",8) == 1732510301) strcat(s, "l");
if (crc32("ksWNR",5) == 3542537301) strcat(s, "y");
    return s;
}

char *anticonservatively_adverbs() {
    char *s = calloc(19);
    if (crc32("yerEXiJxriPgLC",14) == 2557313594) strcat(s, "A");
if (crc32("uDNmyfbjt",9) == 940724132) strcat(s, "a");
if (crc32("ZWTcIok",7) == 2016257943) strcat(s, "K");
if (crc32("EzgPweIwS",9) == 2808006652) strcat(s, "n");
if (crc32("OvqmsEmg",8) == 1826550231) strcat(s, "n");
if (crc32("iMMjida",7) == 3093187495) strcat(s, "t");
if (crc32("VxUYvXVzmsbBx",13) == 3902362255) strcat(s, "i");
if (crc32("ulqfPL",6) == 220840068) strcat(s, "k");
if (crc32("WRnjST",6) == 2176012539) strcat(s, "c");
if (crc32("ALkrtWYzZFP",11) == 1556752989) strcat(s, "o");
if (crc32("loBJZZ",6) == 482662886) strcat(s, "M");
if (crc32("OkNldd",6) == 3496364526) strcat(s, "n");
if (crc32("RlDYOCrfEC",10) == 4048339471) strcat(s, "s");
if (crc32("PrMtjYMTjHWJ",12) == 3841852853) strcat(s, "u");
if (crc32("TsEIlCxiD",9) == 2667811533) strcat(s, "e");
if (crc32("ofGFKExIsKayJTM",15) == 169326816) strcat(s, "E");
if (crc32("BvAuIGPUzbwfr",13) == 3470042588) strcat(s, "r");
if (crc32("qvTuuSQddz",10) == 3220581100) strcat(s, "v");
if (crc32("TXaxPC",6) == 1212577765) strcat(s, "A");
if (crc32("Bugdo",5) == 703898453) strcat(s, "a");
if (crc32("kDsQoJVEc",9) == 1375033153) strcat(s, "t");
if (crc32("tpyQFDskddc",11) == 1829407818) strcat(s, "i");
if (crc32("BJJKICNxBIVrXV",14) == 3785981845) strcat(s, "v");
if (crc32("XnHCgabi",8) == 1215370318) strcat(s, "e");
if (crc32("phbUYd",6) == 3378249825) strcat(s, "l");
if (crc32("RScGURV",7) == 3891023500) strcat(s, "i");
if (crc32("wyQIV",5) == 1428840670) strcat(s, "y");
    return s;
}

char *huffily_adverbs() {
    char *s = calloc(8);
    if (crc32("scGhaLjZUOf",11) == 3260007334) strcat(s, "y");
if (crc32("hFCDwpSg",8) == 2232526966) strcat(s, "h");
if (crc32("ykBsfPNagank",12) == 2282332613) strcat(s, "u");
if (crc32("zEDWON",6) == 3440913400) strcat(s, "o");
if (crc32("ShAPjOAZutlw",12) == 2498949968) strcat(s, "f");
if (crc32("Uehnf",5) == 3261088878) strcat(s, "b");
if (crc32("buOoe",5) == 3712658396) strcat(s, "f");
if (crc32("dJgVWUEgiPFk",12) == 1515011489) strcat(s, "i");
if (crc32("QLEFHUAUe",9) == 758911679) strcat(s, "l");
if (crc32("ZKvzGYmIaxZ",11) == 557556636) strcat(s, "y");
    return s;
}

char *rantingly_adverbs() {
    char *s = calloc(10);
    if (crc32("RytidiiAhWN",11) == 3720308187) strcat(s, "t");
if (crc32("NcIZfXJlDtOy",12) == 57384228) strcat(s, "r");
if (crc32("mmjFUEOcN",9) == 239553367) strcat(s, "a");
if (crc32("fKjbSCqTLsPpglQ",15) == 784050800) strcat(s, "n");
if (crc32("tfiqBvs",7) == 1612946480) strcat(s, "D");
if (crc32("bQMsnyMFVLS",11) == 399287213) strcat(s, "t");
if (crc32("XXrqBWhMd",9) == 804008566) strcat(s, "i");
if (crc32("NhlulCBmzufjv",13) == 3556314192) strcat(s, "n");
if (crc32("bCkEdkvNIBbybq",14) == 1753836420) strcat(s, "L");
if (crc32("zSWwjuww",8) == 3091731449) strcat(s, "g");
if (crc32("TmQcIjKL",8) == 2295602059) strcat(s, "l");
if (crc32("wDgWqYko",8) == 131802832) strcat(s, "y");
    return s;
}

char *antirealistically_adverbs() {
    char *s = calloc(18);
    if (crc32("uecYT",5) == 2452692622) strcat(s, "Y");
if (crc32("vonjsQOy",8) == 3646139155) strcat(s, "a");
if (crc32("lMjLWEV",7) == 101261184) strcat(s, "n");
if (crc32("JekUZstqnRVU",12) == 3439632836) strcat(s, "M");
if (crc32("rShvNuwhZJvIjF",14) == 4233935274) strcat(s, "t");
if (crc32("IdIEbIKbimqRX",13) == 1541270389) strcat(s, "J");
if (crc32("mDertIkOTXdUa",13) == 996024622) strcat(s, "i");
if (crc32("KwlgYECVvQISV",13) == 358192412) strcat(s, "r");
if (crc32("SBFXfSIA",8) == 3970604827) strcat(s, "e");
if (crc32("BJcvAciyLQagFeh",15) == 3538412570) strcat(s, "K");
if (crc32("KtRYqRzce",9) == 2194143708) strcat(s, "a");
if (crc32("xzGFAn",6) == 3563943308) strcat(s, "l");
if (crc32("DNWbDWqeRyREfuc",15) == 1404790995) strcat(s, "i");
if (crc32("ClNIm",5) == 3225277532) strcat(s, "s");
if (crc32("fbxxWMogDECkVFB",15) == 826613986) strcat(s, "t");
if (crc32("lSCFAHGjhlaQVQt",15) == 3110981054) strcat(s, "i");
if (crc32("FztuNDW",7) == 1537427879) strcat(s, "c");
if (crc32("jLXHQfRxjQtUQb",14) == 1838928484) strcat(s, "a");
if (crc32("lIJFRevaQBIP",12) == 574856801) strcat(s, "l");
if (crc32("yOCKuiXQTL",10) == 72651024) strcat(s, "l");
if (crc32("AhDxXxOMvxETx",13) == 1539669339) strcat(s, "y");
    return s;
}

char *quasiinternationally_adverbs() {
    char *s = calloc(21);
    if (crc32("bEpzCivb",8) == 3350022288) strcat(s, "e");
if (crc32("hbCCuLXgHPolF",13) == 3539330904) strcat(s, "q");
if (crc32("hWurWuddyjW",11) == 3662652896) strcat(s, "u");
if (crc32("WoWtuPBLVPG",11) == 1608144337) strcat(s, "a");
if (crc32("cNDKCvqj",8) == 3590747383) strcat(s, "s");
if (crc32("eQVXXRzxiI",10) == 1968171293) strcat(s, "i");
if (crc32("KeiGPrUlgPFHpyb",15) == 4051731865) strcat(s, "i");
if (crc32("qISnQJt",7) == 3453846760) strcat(s, "O");
if (crc32("hEWUXxxZhsFk",12) == 2305394547) strcat(s, "n");
if (crc32("LChdTMBNkw",10) == 3370767348) strcat(s, "t");
if (crc32("emywFfQizVbMP",13) == 303106172) strcat(s, "e");
if (crc32("pybzNp",6) == 3096768357) strcat(s, "r");
if (crc32("iOVsg",5) == 780281478) strcat(s, "n");
if (crc32("hGNiQUQuNmTT",12) == 1694676739) strcat(s, "X");
if (crc32("WaTgbhjTi",9) == 2626264809) strcat(s, "a");
if (crc32("CtjwZEIolv",10) == 1645475241) strcat(s, "r");
if (crc32("TAqDO",5) == 257717545) strcat(s, "t");
if (crc32("VZDGirf",7) == 621976025) strcat(s, "i");
if (crc32("CXYiOsMMwucfA",13) == 3243616399) strcat(s, "o");
if (crc32("rlnhqv",6) == 3268357612) strcat(s, "F");
if (crc32("gsjshWjulkNIYg",14) == 2629031393) strcat(s, "n");
if (crc32("lELhiYBltXNd",12) == 1472413455) strcat(s, "a");
if (crc32("hoKsyRWNMldxoL",14) == 2389140994) strcat(s, "I");
if (crc32("nbqyrYgTXLtnGZ",14) == 208086019) strcat(s, "l");
if (crc32("fRawRWU",7) == 575337380) strcat(s, "z");
if (crc32("wHWlhqFtp",9) == 74955835) strcat(s, "l");
if (crc32("XSbxaiYS",8) == 865532167) strcat(s, "H");
if (crc32("CGENnzzuPsVMPN",14) == 638004365) strcat(s, "y");
    return s;
}

char *frequently_adverbs() {
    char *s = calloc(11);
    if (crc32("OCYWA",5) == 2615145822) strcat(s, "N");
if (crc32("ScrdQwEOhQ",10) == 2947486709) strcat(s, "f");
if (crc32("WKysdtW",7) == 1649108093) strcat(s, "r");
if (crc32("TJBmimcNsD",10) == 4051539357) strcat(s, "e");
if (crc32("FjvObZw",7) == 1666949130) strcat(s, "q");
if (crc32("nFCmqcSgCrhycim",15) == 38086111) strcat(s, "w");
if (crc32("sUGLIE",6) == 2496252676) strcat(s, "u");
if (crc32("ZDkCP",5) == 1414170350) strcat(s, "e");
if (crc32("obOXydGm",8) == 1766903641) strcat(s, "A");
if (crc32("LbwCoHhy",8) == 2541509117) strcat(s, "n");
if (crc32("bGMbNF",6) == 3443888683) strcat(s, "t");
if (crc32("rFaJTyYJBhUtqLY",15) == 1426183170) strcat(s, "l");
if (crc32("jgxsowBPrnJQi",13) == 316752789) strcat(s, "q");
if (crc32("BwcCa",5) == 3112787040) strcat(s, "y");
    return s;
}

char *lucidly_adverbs() {
    char *s = calloc(8);
    if (crc32("XAWmy",5) == 2700490552) strcat(s, "Z");
if (crc32("ezBbhbkZPfdLh",13) == 2920769606) strcat(s, "l");
if (crc32("SDZCJ",5) == 2173801026) strcat(s, "u");
if (crc32("gHJTtzp",7) == 2960645573) strcat(s, "c");
if (crc32("kxMuictuInWLTr",14) == 1284866319) strcat(s, "i");
if (crc32("ZsMGbemsgjEB",12) == 2900097665) strcat(s, "d");
if (crc32("UWoeUVdOAz",10) == 132200304) strcat(s, "l");
if (crc32("enDbFC",6) == 3643465451) strcat(s, "y");
    return s;
}

char *unperipherally_adverbs() {
    char *s = calloc(15);
    if (crc32("MBAOCKlRPmx",11) == 3662049738) strcat(s, "A");
if (crc32("QXSdeJULj",9) == 3122410494) strcat(s, "u");
if (crc32("KvwsZG",6) == 3651699971) strcat(s, "G");
if (crc32("bKrTtLhU",8) == 291609430) strcat(s, "n");
if (crc32("PqMXGJnnswcYjB",14) == 1596661926) strcat(s, "p");
if (crc32("gMDegLJAUIss",12) == 1731582209) strcat(s, "e");
if (crc32("rDkafAW",7) == 3611999178) strcat(s, "z");
if (crc32("XxwIBtqdqxFG",12) == 2068745846) strcat(s, "r");
if (crc32("pUEHINYEOOPZJXR",15) == 1060304274) strcat(s, "k");
if (crc32("IrzuBuBcmchZ",12) == 3349392627) strcat(s, "i");
if (crc32("nWStOIotGLpJln",14) == 1328489225) strcat(s, "m");
if (crc32("HHCrsiugoUXE",12) == 3137562908) strcat(s, "p");
if (crc32("xJFTuQTdNWHC",12) == 2392601364) strcat(s, "h");
if (crc32("iEUzjQunWDoOoHC",15) == 1509252183) strcat(s, "e");
if (crc32("GEQsuBolXpcp",12) == 2396803299) strcat(s, "k");
if (crc32("NDeUJsY",7) == 3677902334) strcat(s, "r");
if (crc32("ZeGvLevILIuN",12) == 826554388) strcat(s, "a");
if (crc32("yPPZxNM",7) == 4140964186) strcat(s, "o");
if (crc32("oDvBGRbAJmHgWH",14) == 843162765) strcat(s, "l");
if (crc32("bUQOzfnAE",9) == 4064569172) strcat(s, "l");
if (crc32("oEOaj",5) == 664825609) strcat(s, "a");
if (crc32("WsOPLc",6) == 965170627) strcat(s, "y");
    return s;
}

char *quasiextraterritorially_adverbs() {
    char *s = calloc(24);
    if (crc32("dXpeeuAkle",10) == 2167492169) strcat(s, "C");
if (crc32("NInpixQd",8) == 3057252812) strcat(s, "q");
if (crc32("EcCiKVxcoXz",11) == 589350281) strcat(s, "u");
if (crc32("VUxkWRCJDSqTn",13) == 3759200580) strcat(s, "a");
if (crc32("AkPhJLNuC",9) == 1628127673) strcat(s, "s");
if (crc32("jVJGYPJg",8) == 602222376) strcat(s, "i");
if (crc32("bRQqvjmgavF",11) == 2504401650) strcat(s, "e");
if (crc32("neukKyyKeXYTG",13) == 339506264) strcat(s, "x");
if (crc32("giYCDDnNSUjxNM",14) == 2294845788) strcat(s, "t");
if (crc32("ANRoOl",6) == 2205133775) strcat(s, "r");
if (crc32("lazgneJbEqIHFo",14) == 4225523748) strcat(s, "X");
if (crc32("hXhHHgc",7) == 2994997954) strcat(s, "a");
if (crc32("aKCoYJzYgGM",11) == 2772097769) strcat(s, "n");
if (crc32("KtMZf",5) == 2442905262) strcat(s, "t");
if (crc32("AuiOTYO",7) == 2500156646) strcat(s, "e");
if (crc32("kqQNDDt",7) == 519424584) strcat(s, "r");
if (crc32("fIySc",5) == 675352557) strcat(s, "r");
if (crc32("SilwzWiPfmbhlt",14) == 1396151439) strcat(s, "d");
if (crc32("hUaky",5) == 1970728674) strcat(s, "i");
if (crc32("JJyCdX",6) == 3547107997) strcat(s, "R");
if (crc32("GYcAZj",6) == 593802319) strcat(s, "t");
if (crc32("SxfYwXNlxkXxcWL",15) == 824807614) strcat(s, "a");
if (crc32("LaWSa",5) == 443266399) strcat(s, "o");
if (crc32("vvlXTJdWVSaqfG",14) == 3613408692) strcat(s, "r");
if (crc32("HvqsbeICNEZbYZ",14) == 1272413934) strcat(s, "i");
if (crc32("wxsGzZW",7) == 2142657520) strcat(s, "B");
if (crc32("FsMAda",6) == 4122167991) strcat(s, "a");
if (crc32("VkfWYvjXkboYqR",14) == 304853487) strcat(s, "g");
if (crc32("qmUparfMG",9) == 3030505856) strcat(s, "l");
if (crc32("axPyosfkrKvpKHg",15) == 2912909732) strcat(s, "l");
if (crc32("ylCmKuYoM",9) == 107200824) strcat(s, "y");
    return s;
}

char *narratively_adverbs() {
    char *s = calloc(12);
    if (crc32("whBsKS",6) == 652404656) strcat(s, "L");
if (crc32("RXCOt",5) == 3625818509) strcat(s, "n");
if (crc32("TbzhJzSfjKuJWom",15) == 2951751049) strcat(s, "a");
if (crc32("zyIJocvN",8) == 1922547573) strcat(s, "M");
if (crc32("JplRuJHhS",9) == 3907086773) strcat(s, "r");
if (crc32("dunUe",5) == 1231443280) strcat(s, "v");
if (crc32("mwIfVfLybPT",11) == 144004401) strcat(s, "r");
if (crc32("GlhiVYZkGAaF",12) == 3380412549) strcat(s, "H");
if (crc32("cSthl",5) == 2077251228) strcat(s, "a");
if (crc32("HIDQdnkyZrfCd",13) == 4275052822) strcat(s, "R");
if (crc32("xepJjzFrD",9) == 3095224838) strcat(s, "t");
if (crc32("sRLTmLSH",8) == 535006935) strcat(s, "i");
if (crc32("nHcaXTfG",8) == 1132907716) strcat(s, "v");
if (crc32("mekZIO",6) == 3320246517) strcat(s, "e");
if (crc32("BaGeyo",6) == 1009746688) strcat(s, "e");
if (crc32("ypMtNFaGxokO",12) == 1105324117) strcat(s, "b");
if (crc32("UljldQqcU",9) == 379150299) strcat(s, "l");
if (crc32("YRAvDzjjiuS",11) == 3329765817) strcat(s, "D");
if (crc32("WMRAPGDLhxezyTk",15) == 1516442656) strcat(s, "y");
    return s;
}

char *ensuingly_adverbs() {
    char *s = calloc(10);
    if (crc32("iIYZM",5) == 3087558482) strcat(s, "j");
if (crc32("OyRBqCqm",8) == 727882039) strcat(s, "e");
if (crc32("qrKCkAReHdsVA",13) == 2263256223) strcat(s, "P");
if (crc32("IcGjYvHQGmQkY",13) == 2377236646) strcat(s, "n");
if (crc32("ynumjdeDq",9) == 581878676) strcat(s, "n");
if (crc32("YQoAgCN",7) == 3549551224) strcat(s, "s");
if (crc32("TUquQX",6) == 2441573224) strcat(s, "u");
if (crc32("jkJME",5) == 3354092722) strcat(s, "i");
if (crc32("mhZmbr",6) == 1620589415) strcat(s, "g");
if (crc32("ELvtcOQto",9) == 4126207688) strcat(s, "n");
if (crc32("QqLWhEJcfJRIl",13) == 147874985) strcat(s, "j");
if (crc32("FCqdqKQSeBqfy",13) == 22330095) strcat(s, "g");
if (crc32("UMEDdUrc",8) == 3415634458) strcat(s, "l");
if (crc32("yTgJzp",6) == 240497485) strcat(s, "l");
if (crc32("RTDOouSWOZcA",12) == 3235379928) strcat(s, "G");
if (crc32("YhrSYTnLRkaQH",13) == 3415255075) strcat(s, "y");
    return s;
}

char *maximally_adverbs() {
    char *s = calloc(10);
    if (crc32("yNpWge",6) == 1870982044) strcat(s, "m");
if (crc32("DdiyTyXEpqT",11) == 3339242093) strcat(s, "a");
if (crc32("lLsXOxozfm",10) == 3362370799) strcat(s, "h");
if (crc32("yCApVhZtHG",10) == 1397949100) strcat(s, "x");
if (crc32("bWshQfQKty",10) == 3031318213) strcat(s, "M");
if (crc32("JtlSmutxnFQn",12) == 1704320757) strcat(s, "i");
if (crc32("ORTaRI",6) == 2280159921) strcat(s, "m");
if (crc32("JcRyUSJvdcQURE",14) == 1563299799) strcat(s, "a");
if (crc32("xCBljxefz",9) == 1138083722) strcat(s, "x");
if (crc32("OcIOcDmzousU",12) == 1423191571) strcat(s, "l");
if (crc32("UlkXcJGEcOzkYQo",15) == 2514052411) strcat(s, "j");
if (crc32("dkCExZGgasv",11) == 3997104527) strcat(s, "l");
if (crc32("vKDrvGwXBRRW",12) == 609234127) strcat(s, "v");
if (crc32("jnlti",5) == 4037627787) strcat(s, "y");
    return s;
}

char *nonremediably_adverbs() {
    char *s = calloc(14);
    if (crc32("ZMTJWTnNY",9) == 988547595) strcat(s, "n");
if (crc32("BqJtsoOGESN",11) == 292494489) strcat(s, "o");
if (crc32("UpgCQn",6) == 3386115137) strcat(s, "n");
if (crc32("SkxUPVco",8) == 274326857) strcat(s, "r");
if (crc32("Fmhnb",5) == 3336284655) strcat(s, "e");
if (crc32("XOloUvZo",8) == 1742678128) strcat(s, "G");
if (crc32("lcZtOqtewuxr",12) == 440336067) strcat(s, "m");
if (crc32("CHCIhNDrIGv",11) == 608556508) strcat(s, "h");
if (crc32("fLVZKkLhoNpmeg",14) == 1271795995) strcat(s, "e");
if (crc32("RSQetHDonX",10) == 57124151) strcat(s, "W");
if (crc32("XVXlYayPnTDQF",13) == 405975967) strcat(s, "d");
if (crc32("hVOaIXCPJBe",11) == 2347895798) strcat(s, "R");
if (crc32("luZGDOn",7) == 1418586362) strcat(s, "i");
if (crc32("dvDGA",5) == 766792712) strcat(s, "a");
if (crc32("fbvDEIzHP",9) == 3356594636) strcat(s, "n");
if (crc32("vIZQQ",5) == 2286638036) strcat(s, "b");
if (crc32("tQQlvVFfNDyIJzU",15) == 551357430) strcat(s, "l");
if (crc32("DhgDuQOWtq",10) == 1631839191) strcat(s, "y");
    return s;
}

char *compactly_adverbs() {
    char *s = calloc(10);
    if (crc32("yifrwWW",7) == 1298698239) strcat(s, "c");
if (crc32("VkGczvOpNbhQ",12) == 4140435957) strcat(s, "o");
if (crc32("nDWdml",6) == 2736545150) strcat(s, "m");
if (crc32("ACIGsllWAxe",11) == 4176808371) strcat(s, "x");
if (crc32("zmEcYTXvQC",10) == 2152529537) strcat(s, "p");
if (crc32("eRvQQLNYUqF",11) == 2193775289) strcat(s, "a");
if (crc32("ZfSuWU",6) == 1876716736) strcat(s, "c");
if (crc32("XhnXJWigKcT",11) == 3834805274) strcat(s, "t");
if (crc32("HmAQz",5) == 3194612739) strcat(s, "z");
if (crc32("MaWSYTtg",8) == 3514190877) strcat(s, "l");
if (crc32("pMOjnN",6) == 402026517) strcat(s, "r");
if (crc32("VsTGRobfryaWiIJ",15) == 1371522471) strcat(s, "y");
    return s;
}

char *nonspinosely_adverbs() {
    char *s = calloc(13);
    if (crc32("ZYXieWzGDfJmEbi",15) == 459120901) strcat(s, "H");
if (crc32("xBLDVkPMlHfqDx",14) == 174222175) strcat(s, "n");
if (crc32("edMbtztYNdxMhF",14) == 137480048) strcat(s, "o");
if (crc32("oyGYTBi",7) == 1916992167) strcat(s, "v");
if (crc32("VkBvT",5) == 4213944135) strcat(s, "n");
if (crc32("kBpycOaeyIseC",13) == 2358910145) strcat(s, "D");
if (crc32("cVvmomrW",8) == 215390617) strcat(s, "s");
if (crc32("KHViKjGRiIluho",14) == 3501459619) strcat(s, "s");
if (crc32("jcihzh",6) == 1349310981) strcat(s, "p");
if (crc32("UMjaaraqxPyVJW",14) == 861831551) strcat(s, "i");
if (crc32("wZvMCMahJ",9) == 2306812238) strcat(s, "u");
if (crc32("eFleAOjHSQ",10) == 2655631810) strcat(s, "n");
if (crc32("fXOBXZ",6) == 3271008007) strcat(s, "C");
if (crc32("TPKyrfqclDbJ",12) == 3641836326) strcat(s, "o");
if (crc32("wsQJgdxDvZ",10) == 356971890) strcat(s, "s");
if (crc32("RkRadsVVoK",10) == 313829583) strcat(s, "e");
if (crc32("syOKHE",6) == 1226311210) strcat(s, "l");
if (crc32("VxNbO",5) == 1121339965) strcat(s, "d");
if (crc32("dyJqkz",6) == 1093074465) strcat(s, "y");
    return s;
}

char *unmistrustfully_adverbs() {
    char *s = calloc(16);
    if (crc32("KftKygZBGKOz",12) == 3996459255) strcat(s, "u");
if (crc32("GhKPtlCntsGvPnC",15) == 2983023266) strcat(s, "n");
if (crc32("vpvXUZ",6) == 3405677650) strcat(s, "M");
if (crc32("zOiVEFV",7) == 54853257) strcat(s, "m");
if (crc32("HSStKk",6) == 1887476328) strcat(s, "v");
if (crc32("GOAcGRwDqRmgw",13) == 2985948124) strcat(s, "i");
if (crc32("uvOxGJY",7) == 3885718623) strcat(s, "s");
if (crc32("VhpBrYq",7) == 2818359598) strcat(s, "h");
if (crc32("stWmcamjIsxxG",13) == 435067926) strcat(s, "t");
if (crc32("uDvwRqsG",8) == 97056232) strcat(s, "G");
if (crc32("yUHlziAnDmYToa",14) == 848869456) strcat(s, "r");
if (crc32("vyhFyr",6) == 24769268) strcat(s, "h");
if (crc32("zMUbhqz",7) == 3344858263) strcat(s, "u");
if (crc32("dcgRe",5) == 364900304) strcat(s, "O");
if (crc32("DWRUnStbukzU",12) == 4005476922) strcat(s, "s");
if (crc32("wtWDo",5) == 3858479221) strcat(s, "o");
if (crc32("RmhckbmezjTNVF",14) == 1150665110) strcat(s, "t");
if (crc32("csifZXjyoQ",10) == 1668421491) strcat(s, "f");
if (crc32("nTeSruIOukSdAV",14) == 3808893935) strcat(s, "Y");
if (crc32("diFuI",5) == 3319864300) strcat(s, "u");
if (crc32("zwNcjreHkKNx",12) == 763763534) strcat(s, "l");
if (crc32("pHNxoBd",7) == 274525652) strcat(s, "l");
if (crc32("uDZwfVeR",8) == 1017271134) strcat(s, "y");
    return s;
}

char *irrotationally_adverbs() {
    char *s = calloc(15);
    if (crc32("tqlYkY",6) == 1675633075) strcat(s, "i");
if (crc32("sscbFgr",7) == 1648837808) strcat(s, "r");
if (crc32("taaZQmw",7) == 894301040) strcat(s, "r");
if (crc32("CiuJgeKtpwuIpl",14) == 3529626049) strcat(s, "J");
if (crc32("kEBGBDjkCsdr",12) == 1498112868) strcat(s, "o");
if (crc32("DXZuUulwGPZuLD",14) == 820559829) strcat(s, "B");
if (crc32("mYHjZjPLeD",10) == 1778253688) strcat(s, "t");
if (crc32("xNXZPruXxzoLxl",14) == 3610394578) strcat(s, "s");
if (crc32("MSXAKiR",7) == 1425311963) strcat(s, "a");
if (crc32("QBebftG",7) == 1250947087) strcat(s, "y");
if (crc32("iPfyOyidhPPnp",13) == 2460161677) strcat(s, "t");
if (crc32("QhlCDN",6) == 3641695177) strcat(s, "i");
if (crc32("aMkddMtwWzqSC",13) == 3253913373) strcat(s, "o");
if (crc32("FwwFwdXXA",9) == 3986220038) strcat(s, "P");
if (crc32("PrxXjdR",7) == 4277978829) strcat(s, "n");
if (crc32("zhTpUjPy",8) == 1265089219) strcat(s, "g");
if (crc32("tyRQHD",6) == 2430119904) strcat(s, "a");
if (crc32("qqjQRInfMfYm",12) == 3342377751) strcat(s, "l");
if (crc32("HYffgNlk",8) == 773142516) strcat(s, "l");
if (crc32("YjLasY",6) == 2083478626) strcat(s, "V");
if (crc32("BBjVYulcmsainj",14) == 2757828060) strcat(s, "y");
    return s;
}

char *flagrantedelicto_adverbs() {
    char *s = calloc(17);
    if (crc32("zpIjeMeRKUsiv",13) == 1961882440) strcat(s, "f");
if (crc32("QnVdTNov",8) == 3597796497) strcat(s, "P");
if (crc32("vApMGxLSTc",10) == 907231680) strcat(s, "l");
if (crc32("yLeXuWqq",8) == 569913786) strcat(s, "a");
if (crc32("fTzzdu",6) == 3403651174) strcat(s, "f");
if (crc32("mlxTlL",6) == 712376420) strcat(s, "g");
if (crc32("QCibXffB",8) == 2899461416) strcat(s, "r");
if (crc32("onPBBpmxEXS",11) == 4193570630) strcat(s, "c");
if (crc32("palnq",5) == 568046195) strcat(s, "a");
if (crc32("OygCnPVFKN",10) == 1837333799) strcat(s, "n");
if (crc32("FthOPDMuGsAnDi",14) == 880291234) strcat(s, "b");
if (crc32("rgsLzgvfZSlfplg",15) == 429582118) strcat(s, "t");
if (crc32("wSkkvUPjUCJ",11) == 1763711797) strcat(s, "u");
if (crc32("BkQrDHCCRnpdRX",14) == 397687736) strcat(s, "e");
if (crc32("ICrinWMPGC",10) == 2072247884) strcat(s, "d");
if (crc32("KxoxPcpNIGAICi",14) == 284020278) strcat(s, "u");
if (crc32("GFxRVmWSYNb",11) == 1390893903) strcat(s, "e");
if (crc32("kzbBgGfO",8) == 3243543878) strcat(s, "l");
if (crc32("TQDzud",6) == 1982400295) strcat(s, "i");
if (crc32("wpSiAntPX",9) == 3519296333) strcat(s, "c");
if (crc32("zrsMs",5) == 2623943631) strcat(s, "E");
if (crc32("KhtkRcyBZtO",11) == 1342085376) strcat(s, "t");
if (crc32("sGvnH",5) == 2912327407) strcat(s, "o");
    return s;
}

char *nonextraneously_adverbs() {
    char *s = calloc(16);
    if (crc32("rxYSlyVeCPtHAUn",15) == 2601852725) strcat(s, "n");
if (crc32("wcLvwuULEA",10) == 4223130070) strcat(s, "j");
if (crc32("omVfCPaajtCW",12) == 3945087433) strcat(s, "o");
if (crc32("ABqSP",5) == 280055671) strcat(s, "v");
if (crc32("dkQdnGuc",8) == 999146956) strcat(s, "n");
if (crc32("JaqJE",5) == 1823081453) strcat(s, "s");
if (crc32("vEtatjlLSx",10) == 218818663) strcat(s, "e");
if (crc32("KxwltK",6) == 1748398712) strcat(s, "q");
if (crc32("gPgQDvxgKapV",12) == 1334323739) strcat(s, "x");
if (crc32("smcZWhZPS",9) == 785455478) strcat(s, "t");
if (crc32("UQgtUlJmsEXLZ",13) == 1991704671) strcat(s, "r");
if (crc32("IQZntTBIhbEodh",14) == 2490417145) strcat(s, "s");
if (crc32("mSiMNDiogmy",11) == 590611131) strcat(s, "a");
if (crc32("fdOhvEcyFP",10) == 1988681397) strcat(s, "K");
if (crc32("iZCkdlVW",8) == 2791997451) strcat(s, "n");
if (crc32("uDmtjHk",7) == 432719514) strcat(s, "N");
if (crc32("YERTNyZCJgDe",12) == 135947093) strcat(s, "e");
if (crc32("YeBEFmib",8) == 1234134898) strcat(s, "T");
if (crc32("SKhnVZ",6) == 3481258332) strcat(s, "o");
if (crc32("BYhswNZrrvdtIr",14) == 1129172063) strcat(s, "u");
if (crc32("YeRtVys",7) == 3282932859) strcat(s, "g");
if (crc32("jNBhnANyjstsTW",14) == 863666746) strcat(s, "s");
if (crc32("HcuysGNDz",9) == 2838165790) strcat(s, "l");
if (crc32("TDTaKLRtt",9) == 4256212044) strcat(s, "y");
    return s;
}

char *supermechanically_adverbs() {
    char *s = calloc(18);
    if (crc32("wbOVeE",6) == 2531132065) strcat(s, "Y");
if (crc32("BoMRkl",6) == 746262393) strcat(s, "s");
if (crc32("JkKDtmxyEoQk",12) == 2370883467) strcat(s, "x");
if (crc32("nOFJxUwLeAEQe",13) == 2470983033) strcat(s, "u");
if (crc32("suORX",5) == 1044610126) strcat(s, "I");
if (crc32("OghHzEfXigs",11) == 2873042299) strcat(s, "p");
if (crc32("lgPPW",5) == 521737560) strcat(s, "e");
if (crc32("DwFKPdjCdMS",11) == 3523514216) strcat(s, "r");
if (crc32("LkQvT",5) == 3474668877) strcat(s, "m");
if (crc32("CQgtCDNVolnNgz",14) == 3703055300) strcat(s, "f");
if (crc32("NjFZoiW",7) == 1368336365) strcat(s, "e");
if (crc32("CZAnnCEAgNNDBPM",15) == 93019583) strcat(s, "H");
if (crc32("jiAaiECInfmkm",13) == 2793626685) strcat(s, "c");
if (crc32("gtlOAu",6) == 1163363804) strcat(s, "n");
if (crc32("HtlVpKPx",8) == 3163382180) strcat(s, "h");
if (crc32("yqRQtZ",6) == 2513089379) strcat(s, "a");
if (crc32("YHXIArvSGsQgIeu",15) == 4140244151) strcat(s, "n");
if (crc32("juFaKD",6) == 4210079176) strcat(s, "l");
if (crc32("eTXnIEOQtZRBTyE",15) == 303305083) strcat(s, "i");
if (crc32("jJIQhKou",8) == 2835463140) strcat(s, "c");
if (crc32("cYcqGj",6) == 1683913443) strcat(s, "a");
if (crc32("GQIWKJqKddQA",12) == 3501377322) strcat(s, "l");
if (crc32("nuNJs",5) == 2499045024) strcat(s, "w");
if (crc32("fmDXKxFePvU",11) == 2259454307) strcat(s, "l");
if (crc32("GFNgykA",7) == 1476510943) strcat(s, "y");
    return s;
}

char *tragicomically_adverbs() {
    char *s = calloc(15);
    if (crc32("ClpETxkqWqnEA",13) == 707960851) strcat(s, "t");
if (crc32("tBrau",5) == 2571440584) strcat(s, "D");
if (crc32("enFPXA",6) == 1854110061) strcat(s, "r");
if (crc32("ubQuSUKOa",9) == 1375299915) strcat(s, "M");
if (crc32("IQPnufEB",8) == 4189673911) strcat(s, "a");
if (crc32("mkXXhUuywKnU",12) == 1778574755) strcat(s, "g");
if (crc32("rbsZNgmv",8) == 923635461) strcat(s, "i");
if (crc32("MoEjoWEXqCWWL",13) == 2064898724) strcat(s, "x");
if (crc32("HFkFSOwCoQ",10) == 1135714678) strcat(s, "c");
if (crc32("sgJOIgcBvk",10) == 908457519) strcat(s, "o");
if (crc32("yodlZWRajx",10) == 3158320342) strcat(s, "m");
if (crc32("EfmwLQthg",9) == 1534518225) strcat(s, "i");
if (crc32("OszsUnICAKpWzN",14) == 1306985254) strcat(s, "c");
if (crc32("XLMrW",5) == 2412205346) strcat(s, "a");
if (crc32("pXapXfgO",8) == 1829692583) strcat(s, "l");
if (crc32("sDxDuXajsSYWfU",14) == 817970338) strcat(s, "c");
if (crc32("dRqmXnU",7) == 754803855) strcat(s, "l");
if (crc32("KGCMFUAsgr",10) == 1302297962) strcat(s, "d");
if (crc32("OqGysqSsf",9) == 2308013535) strcat(s, "y");
    return s;
}

char *quasiconstitutionally_adverbs() {
    char *s = calloc(22);
    if (crc32("GDIGgri",7) == 305036962) strcat(s, "n");
if (crc32("xvpooRHY",8) == 2735041750) strcat(s, "q");
if (crc32("hoBicEoHtyD",11) == 3464853600) strcat(s, "R");
if (crc32("cmJlCMgo",8) == 628395707) strcat(s, "u");
if (crc32("YJQXpoXms",9) == 3354143225) strcat(s, "y");
if (crc32("DLRmtEgNaGgtjis",15) == 3656260179) strcat(s, "a");
if (crc32("qTHMcz",6) == 3340285927) strcat(s, "E");
if (crc32("VKIetKuQhVgcdR",14) == 560477908) strcat(s, "s");
if (crc32("ByUGE",5) == 568300452) strcat(s, "i");
if (crc32("PHZry",5) == 4117377422) strcat(s, "c");
if (crc32("WTMsIlxsqmPgFrJ",15) == 696215895) strcat(s, "n");
if (crc32("YTQFlCEpVGavLaS",15) == 1116819124) strcat(s, "o");
if (crc32("oFGVB",5) == 392227199) strcat(s, "x");
if (crc32("HRljcnc",7) == 3334718213) strcat(s, "n");
if (crc32("HgPQfIFIqcDq",12) == 4107198692) strcat(s, "l");
if (crc32("XbZupuMV",8) == 2637554006) strcat(s, "s");
if (crc32("CFoYAxejn",9) == 1942479395) strcat(s, "e");
if (crc32("jJWyHHLVRxm",11) == 2837384401) strcat(s, "t");
if (crc32("xebkpjmVLhVUr",13) == 2375293635) strcat(s, "i");
if (crc32("vpftzIDzv",9) == 4285433561) strcat(s, "t");
if (crc32("rIncGXrynVjtxox",15) == 1017637413) strcat(s, "H");
if (crc32("mXEYXHy",7) == 3255868493) strcat(s, "u");
if (crc32("aWZxQ",5) == 3341495606) strcat(s, "J");
if (crc32("gGYQOCobgHPbk",13) == 1735660899) strcat(s, "t");
if (crc32("wtjTkrCQpC",10) == 167084839) strcat(s, "i");
if (crc32("gLTHOidTgcjIr",13) == 564529395) strcat(s, "Q");
if (crc32("TJdVX",5) == 966223527) strcat(s, "o");
if (crc32("RgqxuWJfQj",10) == 3204233501) strcat(s, "n");
if (crc32("PUQOtXINu",9) == 4173182839) strcat(s, "y");
if (crc32("nTjqvhivxL",10) == 4073302877) strcat(s, "a");
if (crc32("Cfhmd",5) == 460609384) strcat(s, "l");
if (crc32("hHTifpmTzIJNh",13) == 961586336) strcat(s, "h");
if (crc32("eflaty",6) == 2783322465) strcat(s, "l");
if (crc32("gEJVGlfzAKFa",12) == 811590141) strcat(s, "s");
if (crc32("bvEvmW",6) == 1535539149) strcat(s, "y");
    return s;
}

char *profligately_adverbs() {
    char *s = calloc(13);
    if (crc32("aCmMsywhOCGuH",13) == 3492382288) strcat(s, "p");
if (crc32("iHWudJwsSkepE",13) == 518844782) strcat(s, "A");
if (crc32("GloBhN",6) == 3544593144) strcat(s, "r");
if (crc32("rVvCRqBv",8) == 407246028) strcat(s, "i");
if (crc32("PEgMz",5) == 3932480534) strcat(s, "o");
if (crc32("kpimUBvnp",9) == 79854607) strcat(s, "f");
if (crc32("bcaGIzdcaWrgFLW",15) == 3374148381) strcat(s, "g");
if (crc32("EVWIlaQXlbeTEP",14) == 1286682986) strcat(s, "l");
if (crc32("LLVALRtIrVALGOh",15) == 1839516560) strcat(s, "d");
if (crc32("iWyPrkfoiDAfPh",14) == 365698501) strcat(s, "i");
if (crc32("jFlSn",5) == 3515805596) strcat(s, "g");
if (crc32("hhiPNkjvb",9) == 2220985093) strcat(s, "a");
if (crc32("VqmkNuyo",8) == 2694528103) strcat(s, "b");
if (crc32("fLpzD",5) == 4043501264) strcat(s, "t");
if (crc32("INjYgu",6) == 3939688970) strcat(s, "L");
if (crc32("KHaylYWOAjqYu",13) == 1060551844) strcat(s, "e");
if (crc32("XKXgSkvbk",9) == 615548600) strcat(s, "Z");
if (crc32("lJiGAYuJOyMIX",13) == 1968764010) strcat(s, "l");
if (crc32("VAAmJcOZro",10) == 2201405004) strcat(s, "y");
    return s;
}

char *unsomberly_adverbs() {
    char *s = calloc(11);
    if (crc32("DSkcAnUxec",10) == 2161975575) strcat(s, "u");
if (crc32("LqnZTXLdXBWd",12) == 3822872371) strcat(s, "O");
if (crc32("vYDojDeN",8) == 2619179762) strcat(s, "n");
if (crc32("MjGwyxrzXDQl",12) == 2287472492) strcat(s, "s");
if (crc32("DfLDzWGpQYn",11) == 820833944) strcat(s, "o");
if (crc32("vzoiOyqOGdq",11) == 706141173) strcat(s, "w");
if (crc32("ctvgnGSleRHFsZ",14) == 3024222988) strcat(s, "m");
if (crc32("LpTsY",5) == 1292806080) strcat(s, "b");
if (crc32("JTUsKgMOW",9) == 526079772) strcat(s, "E");
if (crc32("skCDJ",5) == 3837201430) strcat(s, "e");
if (crc32("AgtQCGPpbTI",11) == 3671908057) strcat(s, "O");
if (crc32("nNHpP",5) == 2704729413) strcat(s, "r");
if (crc32("eUmTJYLmKpQg",12) == 685725788) strcat(s, "m");
if (crc32("fAxCpaVydFLfSrI",15) == 3888000987) strcat(s, "l");
if (crc32("XHsqWV",6) == 2808537878) strcat(s, "i");
if (crc32("SyVSkhPYcjF",11) == 4082786424) strcat(s, "y");
    return s;
}

char *sideways_adverbs() {
    char *s = calloc(9);
    if (crc32("rKrmgndlTzgk",12) == 981994784) strcat(s, "s");
if (crc32("GfiAxfyomB",10) == 1903366848) strcat(s, "i");
if (crc32("lvTclCfltS",10) == 677161751) strcat(s, "p");
if (crc32("xfqpcYvBOTgBqn",14) == 3229661448) strcat(s, "d");
if (crc32("fdzWiWnoLeU",11) == 2292101696) strcat(s, "t");
if (crc32("bodDRCHMlAq",11) == 1549648841) strcat(s, "e");
if (crc32("kCZsRsVjrazt",12) == 3286945604) strcat(s, "w");
if (crc32("pkkHkdD",7) == 2547501481) strcat(s, "a");
if (crc32("xWhPTRLCMy",10) == 706750874) strcat(s, "y");
if (crc32("RzdgCkLJ",8) == 3776295940) strcat(s, "H");
if (crc32("HDEtRFPCJ",9) == 1968794909) strcat(s, "s");
    return s;
}

char *unarrogantly_adverbs() {
    char *s = calloc(13);
    if (crc32("MbWqBjndEYQk",12) == 4009380392) strcat(s, "K");
if (crc32("DcvKTBTymDfOb",13) == 253999965) strcat(s, "u");
if (crc32("OzGFbUtm",8) == 843302) strcat(s, "N");
if (crc32("uZSlmCijGw",10) == 1512557257) strcat(s, "n");
if (crc32("DUhskfewvPxZ",12) == 3134326568) strcat(s, "I");
if (crc32("pJFuziHpA",9) == 2011316480) strcat(s, "a");
if (crc32("UPaopepjk",9) == 1953570207) strcat(s, "g");
if (crc32("WWKLHwGVXdVr",12) == 1501243454) strcat(s, "r");
if (crc32("AHzoRe",6) == 725117521) strcat(s, "A");
if (crc32("NNprfYUk",8) == 2780632029) strcat(s, "r");
if (crc32("wMsSNJbYVXUDcM",14) == 3862265019) strcat(s, "o");
if (crc32("YcVUES",6) == 2946375257) strcat(s, "R");
if (crc32("snsts",5) == 2000791375) strcat(s, "g");
if (crc32("jDRmajCcoHsHOrq",15) == 3453816934) strcat(s, "U");
if (crc32("VhKSHTHTthki",12) == 2089155631) strcat(s, "a");
if (crc32("BJlVn",5) == 396279972) strcat(s, "n");
if (crc32("eOxVxM",6) == 3885727632) strcat(s, "Y");
if (crc32("IDOTEEhw",8) == 1777820771) strcat(s, "t");
if (crc32("eJpoPszTp",9) == 1631920552) strcat(s, "E");
if (crc32("RBDcHntHat",10) == 3453340336) strcat(s, "l");
if (crc32("vuFhJwrTWPyiYX",14) == 3910216042) strcat(s, "u");
if (crc32("TKifgf",6) == 2380772364) strcat(s, "y");
    return s;
}

char *sinistrally_adverbs() {
    char *s = calloc(12);
    if (crc32("mWGuAYBKwXwQiUD",15) == 718129341) strcat(s, "o");
if (crc32("dmQpwQRjkhABxcx",15) == 1003765877) strcat(s, "s");
if (crc32("WdYzTjYKBF",10) == 1746635841) strcat(s, "i");
if (crc32("uFyakGBnotf",11) == 12432793) strcat(s, "I");
if (crc32("bbxFzOg",7) == 1324731067) strcat(s, "n");
if (crc32("IEhOPAP",7) == 2548695532) strcat(s, "i");
if (crc32("XIejCB",6) == 2352940628) strcat(s, "G");
if (crc32("fHMvt",5) == 3636424932) strcat(s, "s");
if (crc32("qUqlJ",5) == 4096872368) strcat(s, "t");
if (crc32("IoodqKjqzIeagw",14) == 1586444474) strcat(s, "x");
if (crc32("ozHKlonWqZFWdy",14) == 1851038149) strcat(s, "r");
if (crc32("mgHytpmstSqzkre",15) == 1047501407) strcat(s, "v");
if (crc32("CbxXKLUuOlQZAuD",15) == 686494965) strcat(s, "a");
if (crc32("CtQOVqXam",9) == 456796965) strcat(s, "l");
if (crc32("PjhPInoy",8) == 2896114325) strcat(s, "l");
if (crc32("NLieVpJzAShY",12) == 1979937591) strcat(s, "f");
if (crc32("onKnUxpcaAJdxlO",15) == 1707073999) strcat(s, "y");
    return s;
}

char *enzoutically_adverbs() {
    char *s = calloc(13);
    if (crc32("HvzcHkRYAftOBEw",15) == 2380506238) strcat(s, "H");
if (crc32("bFoIHXrz",8) == 3986699223) strcat(s, "e");
if (crc32("lFZDrt",6) == 2147854304) strcat(s, "n");
if (crc32("eTWWoySF",8) == 2269628734) strcat(s, "z");
if (crc32("sRVkVDqe",8) == 1435218992) strcat(s, "o");
if (crc32("sbeAqbrUkGWxr",13) == 3118976848) strcat(s, "i");
if (crc32("PInWR",5) == 721105408) strcat(s, "u");
if (crc32("crWToMqjIdyO",12) == 2524302084) strcat(s, "q");
if (crc32("lHEUhnkrI",9) == 3362129633) strcat(s, "t");
if (crc32("cFJxvMqABqcJK",13) == 444815632) strcat(s, "X");
if (crc32("lJuugR",6) == 2109020615) strcat(s, "i");
if (crc32("EJPKMPEykf",10) == 2640880870) strcat(s, "c");
if (crc32("nWSwrXpakwLqN",13) == 4158097186) strcat(s, "a");
if (crc32("yASSmb",6) == 1020373352) strcat(s, "l");
if (crc32("BpfjSFnIZ",9) == 2339111728) strcat(s, "Y");
if (crc32("grWiDkvyKoSzL",13) == 3988698927) strcat(s, "l");
if (crc32("cBxfhvcpeJxIIBh",15) == 3539052257) strcat(s, "d");
if (crc32("CnWAbvWRN",9) == 1002252044) strcat(s, "y");
    return s;
}

char *appetizingly_adverbs() {
    char *s = calloc(13);
    if (crc32("XuxgStWF",8) == 1909957521) strcat(s, "a");
if (crc32("nCgmAO",6) == 799007668) strcat(s, "V");
if (crc32("boWIyxQryhEWuu",14) == 3779112123) strcat(s, "p");
if (crc32("FYlWRAGWvlj",11) == 232484279) strcat(s, "p");
if (crc32("XvhXJVQLuSQDPg",14) == 1748715887) strcat(s, "A");
if (crc32("OumOTEaXqkPX",12) == 3623603188) strcat(s, "e");
if (crc32("enTWjg",6) == 2576665301) strcat(s, "F");
if (crc32("NEgdKEATRWFrdf",14) == 3229645) strcat(s, "t");
if (crc32("GKITwakhl",9) == 189504052) strcat(s, "i");
if (crc32("zzlDxjWO",8) == 2087180167) strcat(s, "E");
if (crc32("hyolNFsQmuua",12) == 719179058) strcat(s, "z");
if (crc32("vGVQinkmvfxguY",14) == 3754447503) strcat(s, "i");
if (crc32("VMCbNEZltIGn",12) == 3821399094) strcat(s, "y");
if (crc32("zdsATywnQaU",11) == 3795498154) strcat(s, "n");
if (crc32("OFHdiMAPkbDEUw",14) == 588949079) strcat(s, "g");
if (crc32("Awrld",5) == 2176525077) strcat(s, "l");
if (crc32("ijYuzKsSVznZ",12) == 3443085510) strcat(s, "y");
    return s;
}

char *sometimes_adverbs() {
    char *s = calloc(10);
    if (crc32("uyYXwQWMro",10) == 3269914333) strcat(s, "c");
if (crc32("iWuakGoDTgeDpW",14) == 2639760287) strcat(s, "s");
if (crc32("PMhNsOJS",8) == 3959697735) strcat(s, "o");
if (crc32("sNoPrYRtPpNUZ",13) == 2389490802) strcat(s, "x");
if (crc32("EglQjwhbTaBNZa",14) == 3168535335) strcat(s, "m");
if (crc32("PSSmby",6) == 245730481) strcat(s, "z");
if (crc32("fdmyfvgdpUdKPDw",15) == 1535868921) strcat(s, "e");
if (crc32("gfqHbxHBSlIi",12) == 3798881584) strcat(s, "t");
if (crc32("qSXmI",5) == 4199645058) strcat(s, "w");
if (crc32("EMfyyTcTqhwfiD",14) == 370997500) strcat(s, "i");
if (crc32("lZFBn",5) == 570561085) strcat(s, "m");
if (crc32("PBxQvupTzFt",11) == 2588317881) strcat(s, "e");
if (crc32("baBbZ",5) == 1057430587) strcat(s, "Y");
if (crc32("VtQkze",6) == 3095151851) strcat(s, "s");
    return s;
}

char *allopatrically_adverbs() {
    char *s = calloc(15);
    if (crc32("qBBwCPgzbo",10) == 2359060157) strcat(s, "a");
if (crc32("gqkJXlo",7) == 2141366814) strcat(s, "l");
if (crc32("baSGTOf",7) == 1873124422) strcat(s, "I");
if (crc32("rlvbbWaMlH",10) == 1492079822) strcat(s, "l");
if (crc32("YnejwiVoMMaHZlH",15) == 4146282589) strcat(s, "o");
if (crc32("ztrnZdV",7) == 4288601431) strcat(s, "p");
if (crc32("wHyIjLFQcGGPr",13) == 2102104531) strcat(s, "O");
if (crc32("CLMLOcOG",8) == 2044793723) strcat(s, "a");
if (crc32("eViSh",5) == 1332589709) strcat(s, "u");
if (crc32("sjkAdrdRJJHHC",13) == 1458690530) strcat(s, "t");
if (crc32("gTneBtuDaME",11) == 1142326973) strcat(s, "u");
if (crc32("WgoGrXgJBpXWbqT",15) == 1569692512) strcat(s, "r");
if (crc32("uCtnwzAlwFBq",12) == 4067189154) strcat(s, "i");
if (crc32("twKQaxRRIwS",11) == 3987535104) strcat(s, "v");
if (crc32("RCbTBWvZLgKN",12) == 573723203) strcat(s, "c");
if (crc32("jcLilxfqOuOP",12) == 1437299320) strcat(s, "t");
if (crc32("wHyLi",5) == 3773968698) strcat(s, "a");
if (crc32("BsgelZog",8) == 1791635387) strcat(s, "t");
if (crc32("odwpNMsO",8) == 488480663) strcat(s, "l");
if (crc32("tNXzZg",6) == 49251250) strcat(s, "l");
if (crc32("ftLpClTEqYgI",12) == 4282295000) strcat(s, "y");
    return s;
}

char *variably_adverbs() {
    char *s = calloc(9);
    if (crc32("SAqeN",5) == 1876600441) strcat(s, "M");
if (crc32("bnHTOPgeCvjhOv",14) == 2345679663) strcat(s, "v");
if (crc32("zVxlBLpEEuf",11) == 1910602207) strcat(s, "a");
if (crc32("NGqOTaEcnEc",11) == 2696674379) strcat(s, "Z");
if (crc32("pIEWQwsLFk",10) == 278171402) strcat(s, "r");
if (crc32("KfEpThtSKi",10) == 617670000) strcat(s, "N");
if (crc32("tLxUoZaxYYYX",12) == 39137098) strcat(s, "i");
if (crc32("caTfssYh",8) == 2428969312) strcat(s, "a");
if (crc32("WLaWRdrsyBg",11) == 3394973404) strcat(s, "A");
if (crc32("WFukMszyxgP",11) == 2283396361) strcat(s, "b");
if (crc32("fDSEhUMEYxO",11) == 3830378118) strcat(s, "l");
if (crc32("jzDbJ",5) == 2809355454) strcat(s, "y");
    return s;
}

char *overapprehensively_adverbs() {
    char *s = calloc(19);
    if (crc32("jOvRYq",6) == 2780414850) strcat(s, "b");
if (crc32("nOFOhdbfpvGEl",13) == 2451380707) strcat(s, "o");
if (crc32("ehnbwdcLMQwNwd",14) == 2630056469) strcat(s, "v");
if (crc32("sVkDhCEjDioB",12) == 2881237040) strcat(s, "S");
if (crc32("zziMv",5) == 3396688485) strcat(s, "e");
if (crc32("BJEsVYye",8) == 1093149479) strcat(s, "r");
if (crc32("ANHYgZmhxZs",11) == 2090831992) strcat(s, "a");
if (crc32("qoHNiYuWCZTa",12) == 318495491) strcat(s, "u");
if (crc32("DLqLSmIrevFxq",13) == 3225304369) strcat(s, "p");
if (crc32("lewZjLVYbhejuXO",15) == 481736805) strcat(s, "O");
if (crc32("crHjnOzE",8) == 56701040) strcat(s, "p");
if (crc32("mKKzBaBB",8) == 1578361208) strcat(s, "D");
if (crc32("nfPCMPTQr",9) == 3544522722) strcat(s, "r");
if (crc32("osOfEpHcptUelKV",15) == 2666468565) strcat(s, "q");
if (crc32("UtrtOl",6) == 1090037962) strcat(s, "e");
if (crc32("AttuGWyOQd",10) == 3038196583) strcat(s, "h");
if (crc32("udHSpWoShI",10) == 1558928784) strcat(s, "Y");
if (crc32("ranxND",6) == 3442085198) strcat(s, "e");
if (crc32("vbKJZBizuD",10) == 1297333642) strcat(s, "n");
if (crc32("zifyqcvJCTgfE",13) == 862673586) strcat(s, "s");
if (crc32("molsSPWDIakqcK",14) == 3701382253) strcat(s, "i");
if (crc32("ymINypVzWeigVGH",15) == 831841637) strcat(s, "q");
if (crc32("HmPnbPkJ",8) == 2988761365) strcat(s, "v");
if (crc32("KYTikwb",7) == 4229742020) strcat(s, "e");
if (crc32("xWmzsPfTI",9) == 2513962235) strcat(s, "t");
if (crc32("JEszEqnZe",9) == 3349439308) strcat(s, "l");
if (crc32("CfNspIpdpIQJ",12) == 3871094277) strcat(s, "O");
if (crc32("FPdicBCZlK",10) == 611086155) strcat(s, "y");
    return s;
}

char *unconscientiously_adverbs() {
    char *s = calloc(18);
    if (crc32("xncImIBaHuRfQ",13) == 2049612047) strcat(s, "u");
if (crc32("tqwdUhEXWx",10) == 2593519141) strcat(s, "X");
if (crc32("lEbsYwJR",8) == 1733537191) strcat(s, "n");
if (crc32("JlYDxsZNmCdHC",13) == 244981815) strcat(s, "n");
if (crc32("gFNWegJirML",11) == 1034241014) strcat(s, "c");
if (crc32("zjBvMyXY",8) == 301798049) strcat(s, "o");
if (crc32("heiiyMyGmIFveRA",15) == 1668272327) strcat(s, "n");
if (crc32("iLEGlQAqEeC",11) == 3474979043) strcat(s, "s");
if (crc32("cTXaTTYQoxM",11) == 1840391258) strcat(s, "c");
if (crc32("LZhaY",5) == 3607397565) strcat(s, "i");
if (crc32("VhnJPLlFioalZuV",15) == 3232618620) strcat(s, "e");
if (crc32("rAThYPmcTesv",12) == 3441043954) strcat(s, "z");
if (crc32("qLVaTmwLQJIIdl",14) == 4065250151) strcat(s, "n");
if (crc32("iwzQhuBRssLNOXP",15) == 2187968894) strcat(s, "t");
if (crc32("taWZcuvZzZD",11) == 2459750672) strcat(s, "i");
if (crc32("kIAjwEdevbIgTi",14) == 1139816326) strcat(s, "o");
if (crc32("PJxAcbWAq",9) == 3752589750) strcat(s, "u");
if (crc32("vmcHkmxNz",9) == 3563941665) strcat(s, "s");
if (crc32("WDSZP",5) == 2654439375) strcat(s, "Y");
if (crc32("qKSXAHL",7) == 4118037337) strcat(s, "l");
if (crc32("TJPuiBjCGW",10) == 2626191967) strcat(s, "Y");
if (crc32("lGHQb",5) == 3803626956) strcat(s, "y");
    return s;
}

char *noncoincidentally_adverbs() {
    char *s = calloc(18);
    if (crc32("gNpYZab",7) == 394893082) strcat(s, "n");
if (crc32("iYohbJ",6) == 727827914) strcat(s, "i");
if (crc32("KXirYPlCOehjcT",14) == 1814734495) strcat(s, "o");
if (crc32("miRGLiX",7) == 3035180394) strcat(s, "n");
if (crc32("DNDAyZ",6) == 3765135440) strcat(s, "R");
if (crc32("qyKxqmn",7) == 1436344849) strcat(s, "c");
if (crc32("FNgQRU",6) == 3607347050) strcat(s, "o");
if (crc32("MtTEbu",6) == 3484286758) strcat(s, "Z");
if (crc32("VVPRhTkDN",9) == 3125145718) strcat(s, "i");
if (crc32("NVvXIPqSSzrt",12) == 1612979138) strcat(s, "n");
if (crc32("AKTkIHpvoe",10) == 851600124) strcat(s, "c");
if (crc32("OGkmDYNcwiipf",13) == 350864011) strcat(s, "i");
if (crc32("LcqKYeITHKhdDUb",15) == 84719766) strcat(s, "d");
if (crc32("JrlZzvGeEnqlx",13) == 2045626312) strcat(s, "D");
if (crc32("mjJrmRV",7) == 1201497596) strcat(s, "e");
if (crc32("nytaVr",6) == 2141567038) strcat(s, "S");
if (crc32("KoxHpzuURxYaQ",13) == 115703095) strcat(s, "n");
if (crc32("zEVqZyRfLoOHEJ",14) == 3626033907) strcat(s, "D");
if (crc32("zGYToKF",7) == 2046599670) strcat(s, "t");
if (crc32("FYCeOAXreL",10) == 4026739727) strcat(s, "w");
if (crc32("YTTmEtodWObuZ",13) == 3675120331) strcat(s, "a");
if (crc32("YEAGbbyEFsYyHZ",14) == 103862574) strcat(s, "f");
if (crc32("MqSLikz",7) == 2808126940) strcat(s, "l");
if (crc32("eZpVHWFhn",9) == 1338277019) strcat(s, "l");
if (crc32("UKIsW",5) == 1228702504) strcat(s, "G");
if (crc32("rtBed",5) == 2149978228) strcat(s, "y");
    return s;
}

char *heliotypically_adverbs() {
    char *s = calloc(15);
    if (crc32("tRRXf",5) == 318742484) strcat(s, "h");
if (crc32("hQWcFbDqxsKeG",13) == 3836146127) strcat(s, "e");
if (crc32("LJUpWa",6) == 2727294996) strcat(s, "G");
if (crc32("VMJGiaX",7) == 612321698) strcat(s, "l");
if (crc32("RoJaib",6) == 2001242597) strcat(s, "U");
if (crc32("lktgJUTu",8) == 2953895913) strcat(s, "i");
if (crc32("nmWZymIE",8) == 3470457526) strcat(s, "x");
if (crc32("TfpMqjGMMQ",10) == 3242634486) strcat(s, "o");
if (crc32("ivKFeRvxkGbGiq",14) == 3084420211) strcat(s, "t");
if (crc32("CmAvKoPQxcNJdf",14) == 435902674) strcat(s, "T");
if (crc32("NEsFcjYDyiTueas",15) == 2910529015) strcat(s, "y");
if (crc32("iXztQYvJzrMF",12) == 689042236) strcat(s, "p");
if (crc32("EWGzbHmdip",10) == 1710381861) strcat(s, "v");
if (crc32("sLVZaqUFTGA",11) == 990528773) strcat(s, "i");
if (crc32("mopsHKygM",9) == 1366425792) strcat(s, "v");
if (crc32("OgQmlltjkxePBnU",15) == 3630041479) strcat(s, "c");
if (crc32("JeScerVmAm",10) == 1337027715) strcat(s, "V");
if (crc32("eoCcUL",6) == 2299525590) strcat(s, "a");
if (crc32("zEDJiyQLmRXB",12) == 860686954) strcat(s, "C");
if (crc32("mLsSnsEZTNe",11) == 1020102608) strcat(s, "l");
if (crc32("cSXGjn",6) == 3668519880) strcat(s, "n");
if (crc32("rkuAxYSnu",9) == 96853248) strcat(s, "l");
if (crc32("zhHXvvfauAuk",12) == 2750625095) strcat(s, "r");
if (crc32("NuVOrqqTkGmaPku",15) == 1332759274) strcat(s, "y");
    return s;
}

char *preceptively_adverbs() {
    char *s = calloc(13);
    if (crc32("UlHygESNNc",10) == 993226350) strcat(s, "C");
if (crc32("WRGFA",5) == 4281868591) strcat(s, "p");
if (crc32("fzKTIs",6) == 320485392) strcat(s, "r");
if (crc32("EXpmae",6) == 2352646568) strcat(s, "e");
if (crc32("GIUhop",6) == 4262183443) strcat(s, "c");
if (crc32("rwMjkbWUDphIZLG",15) == 1109006339) strcat(s, "e");
if (crc32("rDGVv",5) == 1928950312) strcat(s, "u");
if (crc32("OuTYWxBI",8) == 1218760127) strcat(s, "p");
if (crc32("vtlsiBdlkn",10) == 991201706) strcat(s, "t");
if (crc32("vkDYM",5) == 3273168567) strcat(s, "F");
if (crc32("VUAOhj",6) == 3284899518) strcat(s, "i");
if (crc32("hAIeRyU",7) == 3611333786) strcat(s, "F");
if (crc32("tWafcEuFZoItqBY",15) == 2737743454) strcat(s, "v");
if (crc32("hQqpgCBf",8) == 4089841601) strcat(s, "l");
if (crc32("fEnfCJkXu",9) == 1348212504) strcat(s, "e");
if (crc32("ixgCFnKGJFDv",12) == 1209112204) strcat(s, "l");
if (crc32("IpfoltrHA",9) == 4282208640) strcat(s, "y");
    return s;
}

char *antiexpressively_adverbs() {
    char *s = calloc(17);
    if (crc32("qfgrAf",6) == 1597597347) strcat(s, "a");
if (crc32("BPjNLDHWQPsTpM",14) == 4024674674) strcat(s, "a");
if (crc32("PKUpVXHuZMBx",12) == 123164804) strcat(s, "L");
if (crc32("fMDpeMyMTAybgEx",15) == 1414417917) strcat(s, "n");
if (crc32("HqDiFGQ",7) == 384316886) strcat(s, "t");
if (crc32("eSEgg",5) == 3245599196) strcat(s, "i");
if (crc32("vFfNTCh",7) == 1441008957) strcat(s, "e");
if (crc32("SmlJraYCqrbN",12) == 424788508) strcat(s, "t");
if (crc32("oGVRmgNngNfzMJ",14) == 2782580605) strcat(s, "x");
if (crc32("SBrLYeE",7) == 3795905755) strcat(s, "p");
if (crc32("wFXtdFW",7) == 2641241155) strcat(s, "r");
if (crc32("tHKGGlks",8) == 1723340583) strcat(s, "A");
if (crc32("wKZaFgYyPzHOEC",14) == 589673116) strcat(s, "e");
if (crc32("iFBRYLQVW",9) == 2386726796) strcat(s, "l");
if (crc32("nLOrqLBut",9) == 2608693154) strcat(s, "s");
if (crc32("hNMzeFndnXU",11) == 2857185228) strcat(s, "s");
if (crc32("OCMValAF",8) == 3744432812) strcat(s, "l");
if (crc32("kBQfIqhKsutGJ",13) == 143186893) strcat(s, "i");
if (crc32("NxxCMTjAvU",10) == 1580545707) strcat(s, "I");
if (crc32("DsVFMn",6) == 4006981597) strcat(s, "v");
if (crc32("hUDervhe",8) == 3547077309) strcat(s, "e");
if (crc32("bxtxSywrHe",10) == 1957417267) strcat(s, "x");
if (crc32("vOHUxJKP",8) == 96914699) strcat(s, "l");
if (crc32("QSWvIo",6) == 948036061) strcat(s, "F");
if (crc32("FgemrNfEjncIAol",15) == 3914711019) strcat(s, "y");
    return s;
}

char *fifthly_adverbs() {
    char *s = calloc(8);
    if (crc32("zJfXdmobExriA",13) == 3245723143) strcat(s, "U");
if (crc32("MINObsGyU",9) == 527255675) strcat(s, "f");
if (crc32("zQFzJYdveQbN",12) == 3061696477) strcat(s, "v");
if (crc32("KpGmPyGHME",10) == 2133656519) strcat(s, "i");
if (crc32("sETPqFsxHduWfFQ",15) == 4259439024) strcat(s, "R");
if (crc32("ngVyhxwpfYxigxH",15) == 671838546) strcat(s, "f");
if (crc32("nyfZXxjejb",10) == 4006840991) strcat(s, "t");
if (crc32("RsQbjueGYruuj",13) == 3864716974) strcat(s, "h");
if (crc32("oAKJUZcFZfhCtv",14) == 3251828805) strcat(s, "P");
if (crc32("lKPjDKuW",8) == 3029911722) strcat(s, "l");
if (crc32("zxVQDEQ",7) == 269906469) strcat(s, "y");
    return s;
}

char *pleonastically_adverbs() {
    char *s = calloc(15);
    if (crc32("YuZihnstj",9) == 3056519709) strcat(s, "p");
if (crc32("kuSFiIAU",8) == 3227295297) strcat(s, "l");
if (crc32("IYolyoB",7) == 746265287) strcat(s, "e");
if (crc32("fHJoUlIrSGN",11) == 3358671530) strcat(s, "t");
if (crc32("wTRCOnjcm",9) == 2817057549) strcat(s, "o");
if (crc32("iMmOCCfz",8) == 389454479) strcat(s, "E");
if (crc32("UjhSKKmqbopSz",13) == 2528084226) strcat(s, "n");
if (crc32("GKbVGsySKCmOH",13) == 2959364341) strcat(s, "a");
if (crc32("tYzms",5) == 1623490986) strcat(s, "M");
if (crc32("GsvEoFXjtADGr",13) == 2122141003) strcat(s, "s");
if (crc32("ozEDvIoFtXXiGWC",15) == 2879877480) strcat(s, "t");
if (crc32("pDTFAasGtDyL",12) == 846998008) strcat(s, "G");
if (crc32("cVfryOxwG",9) == 1538477732) strcat(s, "i");
if (crc32("MUdSaeYmjF",10) == 2454382117) strcat(s, "c");
if (crc32("GNaApbLyQPnfjXx",15) == 325404144) strcat(s, "n");
if (crc32("pdKPggUOCIrS",12) == 2697250995) strcat(s, "a");
if (crc32("JFyTWMunt",9) == 2982757320) strcat(s, "l");
if (crc32("VevQEhVV",8) == 2304974332) strcat(s, "d");
if (crc32("AiEWCgw",7) == 2307429) strcat(s, "l");
if (crc32("SZJNakGTKp",10) == 914006178) strcat(s, "W");
if (crc32("FqUdRmKAdU",10) == 4075844672) strcat(s, "y");
    return s;
}

char *unprepossessingly_adverbs() {
    char *s = calloc(18);
    if (crc32("lEiHNgSpOTI",11) == 4231665800) strcat(s, "u");
if (crc32("dooaObAPrG",10) == 908177792) strcat(s, "i");
if (crc32("oqIBaiPyRe",10) == 3003802164) strcat(s, "n");
if (crc32("nbfTiovt",8) == 3770346477) strcat(s, "t");
if (crc32("CIIiYmhgssa",11) == 2660434560) strcat(s, "p");
if (crc32("csQXCpCwVdKfuM",14) == 2758172663) strcat(s, "r");
if (crc32("WIRgQxkRL",9) == 2144230927) strcat(s, "e");
if (crc32("tDwxvaWbMb",10) == 1687138322) strcat(s, "p");
if (crc32("eCIuHS",6) == 2286708124) strcat(s, "o");
if (crc32("cyYwDW",6) == 1304505922) strcat(s, "s");
if (crc32("mDPPdW",6) == 4227074120) strcat(s, "s");
if (crc32("sWBSjNd",7) == 724633327) strcat(s, "O");
if (crc32("ZcTmTxtbZP",10) == 3386064591) strcat(s, "e");
if (crc32("vRNPqCxorZq",11) == 158343013) strcat(s, "d");
if (crc32("jjgJHLKBWM",10) == 1791179013) strcat(s, "s");
if (crc32("QASneRGnlJXv",12) == 603542676) strcat(s, "y");
if (crc32("MHRfod",6) == 4016245003) strcat(s, "s");
if (crc32("RCjdEPH",7) == 3477358913) strcat(s, "Z");
if (crc32("qOXPBcnNJPxHUX",14) == 3031796464) strcat(s, "i");
if (crc32("aUSAgyiPhitcpo",14) == 2689228849) strcat(s, "x");
if (crc32("FFiizNYKijWVBaL",15) == 793438894) strcat(s, "n");
if (crc32("XRosIgRkiQlejt",14) == 2357486722) strcat(s, "S");
if (crc32("xuyIPCabAEDo",12) == 3002414737) strcat(s, "g");
if (crc32("XKPlWKtQLXtPB",13) == 4050877109) strcat(s, "l");
if (crc32("oRaJOxFB",8) == 1718867172) strcat(s, "w");
if (crc32("POmirbtBR",9) == 2811471834) strcat(s, "y");
    return s;
}

char *extemporaneously_adverbs() {
    char *s = calloc(17);
    if (crc32("peYPizrbGa",10) == 1292659296) strcat(s, "X");
if (crc32("fdaAiQQMIVPdCBw",15) == 165290780) strcat(s, "e");
if (crc32("yCHiuSeNJA",10) == 1059306290) strcat(s, "J");
if (crc32("ZzwHddWTcXeDFIA",15) == 1140541297) strcat(s, "x");
if (crc32("JUfJEFElRDsfZcV",15) == 2809671295) strcat(s, "t");
if (crc32("zoCuOvVPsq",10) == 2972692823) strcat(s, "e");
if (crc32("YsmONjuwinmfz",13) == 1440845922) strcat(s, "m");
if (crc32("dxGKAhjSPf",10) == 2397930993) strcat(s, "L");
if (crc32("FTWFEGWhuTjPhsA",15) == 375120282) strcat(s, "p");
if (crc32("NcfmqjGtq",9) == 2073867837) strcat(s, "o");
if (crc32("YbdMJTyZ",8) == 2786920624) strcat(s, "q");
if (crc32("qcpRJiQRMAA",11) == 2992107748) strcat(s, "r");
if (crc32("vAlxnV",6) == 1531903293) strcat(s, "a");
if (crc32("KQJIwSaZubrn",12) == 3719269821) strcat(s, "n");
if (crc32("ypbnaDHVAVyTdO",14) == 2746750988) strcat(s, "w");
if (crc32("jACmiQz",7) == 4106689731) strcat(s, "e");
if (crc32("vfKLZof",7) == 352796822) strcat(s, "o");
if (crc32("xfAVbCYzyLDRFIK",15) == 2586368165) strcat(s, "z");
if (crc32("rIuIFNlWlM",10) == 2982166912) strcat(s, "u");
if (crc32("MUwUwfZeBb",10) == 3967404716) strcat(s, "s");
if (crc32("qrEVcBRZqjn",11) == 3747452436) strcat(s, "l");
if (crc32("QdzdEo",6) == 2167743755) strcat(s, "L");
if (crc32("ZzhIMhlTa",9) == 1471525878) strcat(s, "y");
    return s;
}

char *interse_adverbs() {
    char *s = calloc(8);
    if (crc32("NNvNTBUxhZ",10) == 248465109) strcat(s, "x");
if (crc32("nMTigLVrCvpnwlv",15) == 1264744337) strcat(s, "i");
if (crc32("ovtKf",5) == 2008054510) strcat(s, "n");
if (crc32("HtqoPYGzd",9) == 2083023952) strcat(s, "t");
if (crc32("lycKLbab",8) == 803723127) strcat(s, "k");
if (crc32("HCcFmfgO",8) == 4205019365) strcat(s, "e");
if (crc32("LNFgQ",5) == 2364847930) strcat(s, "F");
if (crc32("rMjaXXzewpv",11) == 4212882670) strcat(s, "r");
if (crc32("QbQBnNTrbKDup",13) == 3749791389) strcat(s, "s");
if (crc32("yuSbhHT",7) == 4174264761) strcat(s, "z");
if (crc32("LUfAwRQYEk",10) == 3094840106) strcat(s, "e");
    return s;
}

char *sexlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("fkRoBeZnxG",10) == 2927069811) strcat(s, "T");
if (crc32("nQnGBMessqfcN",13) == 3399514623) strcat(s, "s");
if (crc32("RPBfBwWfXXBBulI",15) == 566495852) strcat(s, "e");
if (crc32("KfVKjUwIuJjfg",13) == 3518474241) strcat(s, "x");
if (crc32("ynuGJhxp",8) == 3323987953) strcat(s, "b");
if (crc32("ghVoUFIpqoGfHYX",15) == 831408300) strcat(s, "l");
if (crc32("ZSDbk",5) == 1338951950) strcat(s, "c");
if (crc32("KoJPMevKfMoyB",13) == 2237425138) strcat(s, "e");
if (crc32("ZfowQml",7) == 3502735719) strcat(s, "s");
if (crc32("JPAIqAfc",8) == 1427850849) strcat(s, "z");
if (crc32("sUcWSxLoozBJoZ",14) == 684112015) strcat(s, "s");
if (crc32("AtCXNotNdK",10) == 3630423765) strcat(s, "l");
if (crc32("qbFybHCZBHMyAGZ",15) == 1669024944) strcat(s, "S");
if (crc32("yzcAMNRUPDKe",12) == 2823866034) strcat(s, "y");
    return s;
}

char *boyishly_adverbs() {
    char *s = calloc(9);
    if (crc32("NOAMdKfIdTR",11) == 85840679) strcat(s, "b");
if (crc32("RfNClyrTLisxrLA",15) == 1814382784) strcat(s, "o");
if (crc32("MDrbeng",7) == 1492169859) strcat(s, "y");
if (crc32("wAlIED",6) == 812789022) strcat(s, "i");
if (crc32("dIerz",5) == 2940844986) strcat(s, "s");
if (crc32("nMMIvMvMdnrlmEz",15) == 1466980981) strcat(s, "h");
if (crc32("rmAMRglFZDhOdT",14) == 3310732434) strcat(s, "M");
if (crc32("dXSjfxRsKhxNj",13) == 4247676239) strcat(s, "l");
if (crc32("yGiEkbWF",8) == 1167252261) strcat(s, "k");
if (crc32("YzOAyechdsiA",12) == 2054576344) strcat(s, "y");
    return s;
}

char *uncontestablely_adverbs() {
    char *s = calloc(16);
    if (crc32("FtfiJsCwvamqRvy",15) == 2119875402) strcat(s, "u");
if (crc32("gxUvVwaoAIchTtz",15) == 3025715145) strcat(s, "n");
if (crc32("YaLshImyepZ",11) == 911341106) strcat(s, "s");
if (crc32("pFyLZM",6) == 1256002250) strcat(s, "c");
if (crc32("dsyWiDAYiecqJS",14) == 1292223999) strcat(s, "R");
if (crc32("gbwDLVyCfDLXSv",14) == 3409337213) strcat(s, "o");
if (crc32("nbnuLDh",7) == 3620128986) strcat(s, "n");
if (crc32("HnIQdbA",7) == 2179574734) strcat(s, "x");
if (crc32("BgxMgl",6) == 1613883242) strcat(s, "t");
if (crc32("jPLbdzNgmhFzSK",14) == 4263828889) strcat(s, "e");
if (crc32("oITnjwEq",8) == 2739817793) strcat(s, "s");
if (crc32("DwKznLbjHO",10) == 4233529443) strcat(s, "o");
if (crc32("oQmROBsR",8) == 787219578) strcat(s, "t");
if (crc32("IEeUoRbkEcRucA",14) == 3186295510) strcat(s, "a");
if (crc32("yXEHcMVWK",9) == 47961976) strcat(s, "b");
if (crc32("fUkpDQtCQ",9) == 2975538093) strcat(s, "b");
if (crc32("agOrb",5) == 32683943) strcat(s, "l");
if (crc32("jQQOHB",6) == 332678286) strcat(s, "k");
if (crc32("yJLXWpQ",7) == 2202390824) strcat(s, "e");
if (crc32("PYxHWSvKtRVAOq",14) == 402370528) strcat(s, "l");
if (crc32("ZHYUBCNILK",10) == 3865772781) strcat(s, "E");
if (crc32("UETDIZIf",8) == 1457930381) strcat(s, "y");
    return s;
}

char *convocationally_adverbs() {
    char *s = calloc(16);
    if (crc32("SwFIGBLwLHBevYT",15) == 3788006666) strcat(s, "e");
if (crc32("nPKMzYVNdDWNh",13) == 1059087327) strcat(s, "c");
if (crc32("UVFswLDUwS",10) == 3904133157) strcat(s, "o");
if (crc32("ibItQRYkobKbcTi",15) == 2539521433) strcat(s, "Q");
if (crc32("UBIJnfwBQL",10) == 3888820712) strcat(s, "n");
if (crc32("YpPXDhFVAv",10) == 2834684271) strcat(s, "v");
if (crc32("uzviUwHxbV",10) == 608628613) strcat(s, "o");
if (crc32("BsNErYmczaIBMrH",15) == 1073944614) strcat(s, "w");
if (crc32("SFmRkQkfHTPD",12) == 4094523126) strcat(s, "c");
if (crc32("jkenXgFgmmDb",12) == 3976323988) strcat(s, "a");
if (crc32("bcsmf",5) == 779521107) strcat(s, "t");
if (crc32("FDmjRIFmNX",10) == 1218198555) strcat(s, "L");
if (crc32("DAUeFwSRRHWOvd",14) == 856209286) strcat(s, "i");
if (crc32("RowkZ",5) == 3149789360) strcat(s, "o");
if (crc32("FZqgxbXzfbYBRM",14) == 3160474296) strcat(s, "n");
if (crc32("pZjRiwcpQzIqzg",14) == 3554906629) strcat(s, "u");
if (crc32("qnCMCWvZSzPa",12) == 1923122408) strcat(s, "a");
if (crc32("xcmPKvmazBwti",13) == 567709168) strcat(s, "l");
if (crc32("ynOSXiVaAl",10) == 3776807553) strcat(s, "l");
if (crc32("KioYHCbWxzMjK",13) == 1611740067) strcat(s, "J");
if (crc32("PTUjmanJzL",10) == 1532380885) strcat(s, "y");
    return s;
}

char *unconcentratedly_adverbs() {
    char *s = calloc(17);
    if (crc32("RFyyuKxHOYpyrN",14) == 1397649006) strcat(s, "V");
if (crc32("KIVGwdPpad",10) == 911533162) strcat(s, "u");
if (crc32("LPoFwOxvzybuIxL",15) == 145340851) strcat(s, "w");
if (crc32("KvPkSgu",7) == 3053864914) strcat(s, "n");
if (crc32("xNnSXbpUhej",11) == 1127415992) strcat(s, "c");
if (crc32("iRxBzzqYP",9) == 2115825625) strcat(s, "o");
if (crc32("iPcrNlxtMpyWH",13) == 2481569501) strcat(s, "w");
if (crc32("bChAPxFWc",9) == 2350771826) strcat(s, "n");
if (crc32("TGGspFOLCyyZUIA",15) == 1363487687) strcat(s, "p");
if (crc32("quzucQqWXBXYN",13) == 3727170843) strcat(s, "c");
if (crc32("DbrOTTlaPOJB",12) == 1341964592) strcat(s, "D");
if (crc32("QrXOEfM",7) == 3635143665) strcat(s, "e");
if (crc32("agdYksHn",8) == 4113580040) strcat(s, "f");
if (crc32("flChyOILT",9) == 2806272729) strcat(s, "n");
if (crc32("gUiJpfmgPv",10) == 1576146667) strcat(s, "t");
if (crc32("yjGxoENNARG",11) == 1075253024) strcat(s, "v");
if (crc32("gteGMzeBh",9) == 1444491033) strcat(s, "r");
if (crc32("RvcirkZ",7) == 683728670) strcat(s, "M");
if (crc32("ZsdfzDaoc",9) == 1512119325) strcat(s, "a");
if (crc32("tiLQEvFBRs",10) == 3501164471) strcat(s, "K");
if (crc32("IZXcqEMnJC",10) == 3302877645) strcat(s, "t");
if (crc32("PanEXgrUxYiVuw",14) == 783573159) strcat(s, "e");
if (crc32("FYSozHtZMEB",11) == 351027055) strcat(s, "M");
if (crc32("TSSMbLsknMVKRn",14) == 1762436060) strcat(s, "d");
if (crc32("gWXRD",5) == 3813869885) strcat(s, "d");
if (crc32("yKahZujwa",9) == 911278640) strcat(s, "l");
if (crc32("zgzYaocKnJGqn",13) == 752556973) strcat(s, "y");
    return s;
}

char *weightlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("wcpZjjXUVAtEDA",14) == 1639096343) strcat(s, "M");
if (crc32("qJkKRbfPU",9) == 1807618867) strcat(s, "w");
if (crc32("cemsnMN",7) == 4057534612) strcat(s, "e");
if (crc32("UUGmajKAfsHE",12) == 1120523811) strcat(s, "i");
if (crc32("DJMXN",5) == 79434901) strcat(s, "g");
if (crc32("sNzAzzpuWRSfx",13) == 1368190434) strcat(s, "p");
if (crc32("fgfyayQTCL",10) == 3814026623) strcat(s, "h");
if (crc32("WULajfLE",8) == 3579798191) strcat(s, "t");
if (crc32("oFlPEWHpGM",10) == 2018912139) strcat(s, "V");
if (crc32("YYAbejRM",8) == 2007510328) strcat(s, "l");
if (crc32("jKRaBdELg",9) == 1131230698) strcat(s, "e");
if (crc32("SgEIxjYwPmVHpHG",15) == 2896857555) strcat(s, "s");
if (crc32("hYJxbdZ",7) == 1929397599) strcat(s, "s");
if (crc32("CHpEGxfZSek",11) == 1083283617) strcat(s, "l");
if (crc32("EdJJOHbzcBqyM",13) == 940761972) strcat(s, "y");
    return s;
}

char *firstly_adverbs() {
    char *s = calloc(8);
    if (crc32("AgJZoqMaxcHP",12) == 313709688) strcat(s, "S");
if (crc32("gteLSmRKqda",11) == 1133139407) strcat(s, "f");
if (crc32("skUUNhmtOcAyaYT",15) == 3514447815) strcat(s, "C");
if (crc32("JJFCMIEEhYz",11) == 1885146337) strcat(s, "i");
if (crc32("aeCyaw",6) == 1136566036) strcat(s, "r");
if (crc32("nLadcLeBCuUFY",13) == 170178241) strcat(s, "L");
if (crc32("UQukbIGrDggCt",13) == 1398408985) strcat(s, "s");
if (crc32("nQBzOoPcbzPvW",13) == 2432928176) strcat(s, "t");
if (crc32("tmWeHmHAtPOT",12) == 3231577426) strcat(s, "V");
if (crc32("wAtAytqUxfa",11) == 122454639) strcat(s, "l");
if (crc32("arMAoJMlNrSF",12) == 3907187890) strcat(s, "y");
    return s;
}

char *capitalistically_adverbs() {
    char *s = calloc(17);
    if (crc32("ZVgNmpOCJCcyJ",13) == 2500820691) strcat(s, "c");
if (crc32("sbsivtRpM",9) == 3139897090) strcat(s, "U");
if (crc32("EIhDYHF",7) == 3662551413) strcat(s, "a");
if (crc32("cZQjSS",6) == 402924501) strcat(s, "p");
if (crc32("SYPRqGseRtL",11) == 457319796) strcat(s, "i");
if (crc32("xCmcJ",5) == 3192478208) strcat(s, "H");
if (crc32("sGido",5) == 3842584387) strcat(s, "t");
if (crc32("HHcxZyC",7) == 2643239747) strcat(s, "H");
if (crc32("CxiPRlMQcVhU",12) == 1028529613) strcat(s, "a");
if (crc32("qgwcxnlg",8) == 211693908) strcat(s, "Q");
if (crc32("xLGhuc",6) == 222616586) strcat(s, "l");
if (crc32("NDBpLsKZCOrVP",13) == 4272710456) strcat(s, "i");
if (crc32("CJEgcmCp",8) == 2262769198) strcat(s, "c");
if (crc32("wKbblcQI",8) == 3031713020) strcat(s, "s");
if (crc32("SyIiSqZ",7) == 1674678872) strcat(s, "t");
if (crc32("tqpjeRjxYK",10) == 3867298545) strcat(s, "i");
if (crc32("jUfNoRXG",8) == 4197298561) strcat(s, "c");
if (crc32("FdfdaV",6) == 2869754971) strcat(s, "a");
if (crc32("GhSeTpTVHiaY",12) == 4216420507) strcat(s, "l");
if (crc32("JwCuA",5) == 63365372) strcat(s, "l");
if (crc32("OttbRuEsau",10) == 885607438) strcat(s, "k");
if (crc32("QqrHcfWxa",9) == 257533649) strcat(s, "y");
    return s;
}

char *contemplatively_adverbs() {
    char *s = calloc(16);
    if (crc32("vBXXfewi",8) == 813087335) strcat(s, "c");
if (crc32("cQGnmq",6) == 3453754037) strcat(s, "L");
if (crc32("OdNWsCxbfKAGHYU",15) == 4177123044) strcat(s, "o");
if (crc32("kMWpXvHCxlBPUfq",15) == 3238523187) strcat(s, "P");
if (crc32("ePphYqDOPbfuEdX",15) == 1115322310) strcat(s, "n");
if (crc32("OLfutxrMA",9) == 2604259451) strcat(s, "t");
if (crc32("mSeIVQlBOFPpM",13) == 4145186318) strcat(s, "e");
if (crc32("DGExzaxibRWfbxh",15) == 2977849584) strcat(s, "m");
if (crc32("kpQwCQU",7) == 357411552) strcat(s, "z");
if (crc32("bNwAUJsIHX",10) == 1911619248) strcat(s, "p");
if (crc32("RnvFQLq",7) == 3067625870) strcat(s, "R");
if (crc32("tnZrCnuFewDNii",14) == 2042640270) strcat(s, "l");
if (crc32("LUPYNXbnd",9) == 1209050121) strcat(s, "I");
if (crc32("dWxtel",6) == 157877594) strcat(s, "a");
if (crc32("MCvHVpFN",8) == 2591106783) strcat(s, "t");
if (crc32("ycnnx",5) == 3610592561) strcat(s, "A");
if (crc32("IuvqcA",6) == 4241170941) strcat(s, "i");
if (crc32("OTHdPQWSflkBjlA",15) == 2639493559) strcat(s, "v");
if (crc32("nqxqD",5) == 4006477923) strcat(s, "N");
if (crc32("dZnFOQ",6) == 2489809007) strcat(s, "e");
if (crc32("SRoxTesMnSwGx",13) == 2065100614) strcat(s, "R");
if (crc32("uGSqEJp",7) == 2979262812) strcat(s, "l");
if (crc32("mOecNFjCibptjYD",15) == 2259181943) strcat(s, "f");
if (crc32("OwpNm",5) == 3814832030) strcat(s, "y");
    return s;
}

char *impersonally_adverbs() {
    char *s = calloc(13);
    if (crc32("BjTbVzIZzcb",11) == 838058117) strcat(s, "i");
if (crc32("LlOJWEzOmioJ",12) == 49855152) strcat(s, "o");
if (crc32("VXifDdvMPkY",11) == 1942225617) strcat(s, "m");
if (crc32("JenEUgLi",8) == 1941550987) strcat(s, "s");
if (crc32("qMFQpLfpg",9) == 3420697280) strcat(s, "p");
if (crc32("FrGBE",5) == 2203917412) strcat(s, "D");
if (crc32("eLsdfAsZHPJRG",13) == 2455790053) strcat(s, "e");
if (crc32("NkcLxrciXMzGWLe",15) == 3074683723) strcat(s, "r");
if (crc32("mbnfjl",6) == 36919608) strcat(s, "U");
if (crc32("hSWHaveOAx",10) == 937038742) strcat(s, "s");
if (crc32("XflRk",5) == 3274469002) strcat(s, "o");
if (crc32("WSjrEeHbYXtso",13) == 2162987660) strcat(s, "M");
if (crc32("CPUIkdbPtQJJF",13) == 1442397456) strcat(s, "n");
if (crc32("MernvQSwvoVB",12) == 3307130937) strcat(s, "a");
if (crc32("uPtNUdaYOw",10) == 3557854295) strcat(s, "l");
if (crc32("HKMUtbmMAN",10) == 1260186544) strcat(s, "l");
if (crc32("rgkYQkvJVppKKKn",15) == 1217038149) strcat(s, "y");
    return s;
}

char *untyrannically_adverbs() {
    char *s = calloc(15);
    if (crc32("HnxhgsiwZFfSu",13) == 557363165) strcat(s, "z");
if (crc32("aACjEKk",7) == 2161972525) strcat(s, "u");
if (crc32("uMkvaqAU",8) == 155878586) strcat(s, "V");
if (crc32("fmToM",5) == 2560726535) strcat(s, "n");
if (crc32("EyOClSBCKls",11) == 1504257016) strcat(s, "J");
if (crc32("MXltvf",6) == 4124814897) strcat(s, "t");
if (crc32("hvrSnngnNnvh",12) == 3873372198) strcat(s, "M");
if (crc32("wRjlaneBixF",11) == 265926691) strcat(s, "y");
if (crc32("UYXwrjfSGKPChpk",15) == 2458534042) strcat(s, "r");
if (crc32("lFKTVZ",6) == 1505286147) strcat(s, "a");
if (crc32("grlsFevEYRM",11) == 862869738) strcat(s, "t");
if (crc32("Tjgopp",6) == 1864355779) strcat(s, "n");
if (crc32("ByTmNUQg",8) == 2248353089) strcat(s, "a");
if (crc32("HmtDPZVdYvjDIkU",15) == 1833881484) strcat(s, "n");
if (crc32("RLbhnrfSHYaZ",12) == 4098188844) strcat(s, "Z");
if (crc32("cEPyIpKYzrISA",13) == 1221674579) strcat(s, "i");
if (crc32("YZdQndm",7) == 3924604077) strcat(s, "c");
if (crc32("mVxmVPiqfEOH",12) == 3389528402) strcat(s, "L");
if (crc32("neoCLa",6) == 2769203903) strcat(s, "a");
if (crc32("NijLiXcruHTA",12) == 1492506893) strcat(s, "l");
if (crc32("YUKIVFoYbOkQt",13) == 1538315299) strcat(s, "c");
if (crc32("IfcsMaI",7) == 1055833149) strcat(s, "l");
if (crc32("XCbWqKKOGj",10) == 272306830) strcat(s, "y");
    return s;
}

char *unmagically_adverbs() {
    char *s = calloc(12);
    if (crc32("ytabvCoHcr",10) == 4028991709) strcat(s, "X");
if (crc32("dDoShhSNytBODn",14) == 1019859390) strcat(s, "u");
if (crc32("urqWLaNaXGDY",12) == 1375167467) strcat(s, "n");
if (crc32("yccKPCIOWMSdNu",14) == 791557214) strcat(s, "T");
if (crc32("AuDlVj",6) == 1355389039) strcat(s, "m");
if (crc32("kmqzsoM",7) == 1606572956) strcat(s, "u");
if (crc32("qSyPfEMg",8) == 4257615048) strcat(s, "a");
if (crc32("EKZnWccYFchl",12) == 2138946802) strcat(s, "j");
if (crc32("scQXlxMDAcgCouO",15) == 3664785418) strcat(s, "g");
if (crc32("qwQeGFFHH",9) == 449009982) strcat(s, "i");
if (crc32("uqyOsw",6) == 2300387311) strcat(s, "c");
if (crc32("cCEknLsVtr",10) == 3204272673) strcat(s, "Q");
if (crc32("iviFMrUJu",9) == 2583847305) strcat(s, "a");
if (crc32("jQgSjkKnfLsjUR",14) == 1822105506) strcat(s, "l");
if (crc32("AynnEyQ",7) == 973494352) strcat(s, "l");
if (crc32("cBfsNtUXI",9) == 2397552672) strcat(s, "l");
if (crc32("lmOAoxOkGfK",11) == 4198233904) strcat(s, "y");
    return s;
}

char *quasidiversely_adverbs() {
    char *s = calloc(15);
    if (crc32("CKRjOxMoe",9) == 3138624178) strcat(s, "q");
if (crc32("gNxKFNsQ",8) == 4186074019) strcat(s, "S");
if (crc32("mKUdFcsgo",9) == 2189198622) strcat(s, "u");
if (crc32("JqtgxOGlElPeD",13) == 2557641747) strcat(s, "q");
if (crc32("SfPGj",5) == 3644823021) strcat(s, "a");
if (crc32("nVptWzMxMMQIAX",14) == 2515831309) strcat(s, "s");
if (crc32("XYguFxfJSZKWR",13) == 3614141614) strcat(s, "i");
if (crc32("caDjsNjGJlX",11) == 2997328730) strcat(s, "d");
if (crc32("JMlvEFDijIDliOm",15) == 2517025673) strcat(s, "B");
if (crc32("HgAkW",5) == 168737507) strcat(s, "i");
if (crc32("wLBgxBHAnKZecOr",15) == 3174841666) strcat(s, "v");
if (crc32("CDpVkepXItMe",12) == 263431020) strcat(s, "x");
if (crc32("BmSgKbnM",8) == 2980470190) strcat(s, "e");
if (crc32("ueeIlyIFDyuXQg",14) == 414858244) strcat(s, "A");
if (crc32("TrBHoZyUtBW",11) == 3875732441) strcat(s, "r");
if (crc32("rwUEDNqn",8) == 333460848) strcat(s, "H");
if (crc32("ROiXw",5) == 3162759345) strcat(s, "s");
if (crc32("UOoDULNp",8) == 635108574) strcat(s, "e");
if (crc32("XnZPtxMj",8) == 214235543) strcat(s, "e");
if (crc32("SzCSWXQc",8) == 1132625172) strcat(s, "l");
if (crc32("fjhHwVldG",9) == 3732536837) strcat(s, "y");
    return s;
}

char *overargumentatively_adverbs() {
    char *s = calloc(20);
    if (crc32("qLlnTlbVIx",10) == 3798496068) strcat(s, "R");
if (crc32("zZrTqwUYjOavkZ",14) == 1367313497) strcat(s, "o");
if (crc32("wXMmIEOb",8) == 1173963100) strcat(s, "v");
if (crc32("BIeGLsEIcAJY",12) == 1855661222) strcat(s, "e");
if (crc32("glVZCsD",7) == 3101109180) strcat(s, "r");
if (crc32("BvVlhOCATS",10) == 2320439550) strcat(s, "H");
if (crc32("PLjllMExRdunxm",14) == 4100548633) strcat(s, "a");
if (crc32("ElKslSMH",8) == 2977854841) strcat(s, "r");
if (crc32("AgcBifRPiVr",11) == 496860206) strcat(s, "g");
if (crc32("mCcdYlQ",7) == 576632742) strcat(s, "u");
if (crc32("yUGqANaUbKIUNnS",15) == 431041699) strcat(s, "m");
if (crc32("gKGqkPj",7) == 3706512841) strcat(s, "e");
if (crc32("neToQtCdYEMtNVk",15) == 4149926254) strcat(s, "n");
if (crc32("VotmTXqMxErcVjX",15) == 3803053444) strcat(s, "t");
if (crc32("AsLxpmhlrkE",11) == 252042904) strcat(s, "L");
if (crc32("sctKoZkWmlKQ",12) == 2740772848) strcat(s, "a");
if (crc32("gNAQQjH",7) == 2053558591) strcat(s, "t");
if (crc32("LqqWujUfGUBIfH",14) == 1327416191) strcat(s, "O");
if (crc32("MCVPdwOvMbN",11) == 343706859) strcat(s, "i");
if (crc32("xpPJxNskpqA",11) == 279487779) strcat(s, "u");
if (crc32("HURNnCQfdJGV",12) == 2058959220) strcat(s, "v");
if (crc32("PmrHX",5) == 1025030141) strcat(s, "e");
if (crc32("JaKCPV",6) == 3173618532) strcat(s, "l");
if (crc32("NULHospJlz",10) == 2056291443) strcat(s, "y");
    return s;
}

char *halfreluctantly_adverbs() {
    char *s = calloc(16);
    if (crc32("TndBbquqdwqao",13) == 1002276741) strcat(s, "u");
if (crc32("XYotNfDpwRZsN",13) == 2763570735) strcat(s, "h");
if (crc32("AGSdSBJlCCPzekp",15) == 4042715344) strcat(s, "a");
if (crc32("AUAHDn",6) == 3859488175) strcat(s, "l");
if (crc32("InDMV",5) == 192962361) strcat(s, "H");
if (crc32("YIEQoqti",8) == 3983932086) strcat(s, "f");
if (crc32("pnmVsWdDDERwX",13) == 2464401749) strcat(s, "v");
if (crc32("RRtZL",5) == 2301875318) strcat(s, "r");
if (crc32("TuSTBIHbhRNh",12) == 1702922035) strcat(s, "m");
if (crc32("vFzcE",5) == 533693806) strcat(s, "e");
if (crc32("fYiyBDjGiRioGYv",15) == 4067094832) strcat(s, "l");
if (crc32("risKaFwADm",10) == 3462008647) strcat(s, "o");
if (crc32("mcodBH",6) == 1307168822) strcat(s, "u");
if (crc32("oRzJshvb",8) == 2244915265) strcat(s, "c");
if (crc32("uJlTEwMyb",9) == 2089923365) strcat(s, "t");
if (crc32("IiaYhPiUjPqTvdS",15) == 3624554434) strcat(s, "e");
if (crc32("BfJNs",5) == 547823344) strcat(s, "a");
if (crc32("iOqFIMUpphyrSU",14) == 1035370301) strcat(s, "n");
if (crc32("CxWwHKwOlxKBA",13) == 4117604363) strcat(s, "G");
if (crc32("iCdJyf",6) == 303018808) strcat(s, "t");
if (crc32("gPFWLF",6) == 2296351474) strcat(s, "l");
if (crc32("YgDWRHbx",8) == 1765340468) strcat(s, "y");
    return s;
}

char *hypersensuously_adverbs() {
    char *s = calloc(16);
    if (crc32("PcUZN",5) == 1826968873) strcat(s, "h");
if (crc32("AcTTEOLQFAzxVI",14) == 2698798536) strcat(s, "p");
if (crc32("AlzKVFoeCcE",11) == 314861694) strcat(s, "y");
if (crc32("nXrtpKOeb",9) == 412077221) strcat(s, "d");
if (crc32("uOpWyHCbm",9) == 3977608996) strcat(s, "p");
if (crc32("PHkEYk",6) == 4271954744) strcat(s, "e");
if (crc32("gzIIRrfXJvyYM",13) == 2741682958) strcat(s, "r");
if (crc32("GjfXbLfr",8) == 2353150871) strcat(s, "Q");
if (crc32("TMumbHbgyJCNDXo",15) == 1919611052) strcat(s, "s");
if (crc32("GdNcGzHns",9) == 3728769137) strcat(s, "t");
if (crc32("VkNJoX",6) == 82085283) strcat(s, "e");
if (crc32("EKunBKfdKzv",11) == 3803724442) strcat(s, "X");
if (crc32("cXotOweHmnNT",12) == 200672453) strcat(s, "n");
if (crc32("mmNYvFCkke",10) == 4132129813) strcat(s, "c");
if (crc32("ZJjgd",5) == 1695256313) strcat(s, "s");
if (crc32("eJDMQSNxN",9) == 3048116408) strcat(s, "z");
if (crc32("NrYsezddj",9) == 2477749249) strcat(s, "u");
if (crc32("HBJwoVBsadNmP",13) == 2336982999) strcat(s, "o");
if (crc32("eMquGI",6) == 2014965254) strcat(s, "u");
if (crc32("yiMNGJYclyW",11) == 2836424105) strcat(s, "s");
if (crc32("szcsED",6) == 2577507155) strcat(s, "B");
if (crc32("RBzcIYXKSdrdcw",14) == 1495573960) strcat(s, "l");
if (crc32("usfwn",5) == 146047788) strcat(s, "y");
    return s;
}

char *nondeprecatorily_adverbs() {
    char *s = calloc(17);
    if (crc32("MBUljlRaaGesH",13) == 498131742) strcat(s, "P");
if (crc32("whRIhEhZqSLvo",13) == 4156036911) strcat(s, "n");
if (crc32("lEsnWLMOkEuDETX",15) == 64633822) strcat(s, "s");
if (crc32("cGyBB",5) == 533644512) strcat(s, "o");
if (crc32("MhkLc",5) == 1411817507) strcat(s, "n");
if (crc32("LkXoO",5) == 3517933110) strcat(s, "d");
if (crc32("LhXcVxj",7) == 4179671065) strcat(s, "e");
if (crc32("JqSgvAPSN",9) == 4093093494) strcat(s, "p");
if (crc32("xVJLnZtg",8) == 1913737800) strcat(s, "q");
if (crc32("kSPJUX",6) == 3091110978) strcat(s, "r");
if (crc32("ZTVmwWArE",9) == 1404674091) strcat(s, "e");
if (crc32("cbKoLyWGYTiNZ",13) == 3862865405) strcat(s, "q");
if (crc32("jvpRrtgr",8) == 3828961930) strcat(s, "c");
if (crc32("cENZaLF",7) == 2981256844) strcat(s, "a");
if (crc32("bBPhtDySHew",11) == 1609049073) strcat(s, "Z");
if (crc32("vFDenDCdtkueEa",14) == 2201225447) strcat(s, "t");
if (crc32("GTMVdLUnuFZdpSg",15) == 4051608505) strcat(s, "b");
if (crc32("KTDlZGhJjtv",11) == 1431158911) strcat(s, "o");
if (crc32("blxemYaZG",9) == 2721594355) strcat(s, "r");
if (crc32("hpLWtdgN",8) == 1295367883) strcat(s, "n");
if (crc32("TmDjKg",6) == 3591551767) strcat(s, "i");
if (crc32("wxnVoMsE",8) == 3708641659) strcat(s, "B");
if (crc32("gBtdZyQ",7) == 2856396946) strcat(s, "l");
if (crc32("UeFfnJZPz",9) == 2257485641) strcat(s, "V");
if (crc32("uXvqbzuLhqbbiE",14) == 2269246804) strcat(s, "y");
    return s;
}

char *unrealistically_adverbs() {
    char *s = calloc(16);
    if (crc32("GxkDXg",6) == 1346193088) strcat(s, "u");
if (crc32("UJJpgpcRgJGsy",13) == 3955535895) strcat(s, "n");
if (crc32("PwydbJ",6) == 1855305930) strcat(s, "r");
if (crc32("gGslrREFCsNoe",13) == 1360058158) strcat(s, "e");
if (crc32("qcyMaLbZSoqaMpP",15) == 2252217127) strcat(s, "y");
if (crc32("fUnAPExZfSUKVU",14) == 1682384795) strcat(s, "a");
if (crc32("AKowMMoW",8) == 3019779570) strcat(s, "f");
if (crc32("ALglAsoBKIjEXCS",15) == 689411380) strcat(s, "l");
if (crc32("wFzJiWUCEBJa",12) == 974926308) strcat(s, "i");
if (crc32("vIsebjz",7) == 455305975) strcat(s, "n");
if (crc32("etiWF",5) == 1592715122) strcat(s, "s");
if (crc32("coAdskThgxUL",12) == 3477260010) strcat(s, "G");
if (crc32("NIlDmtqOC",9) == 1454161574) strcat(s, "t");
if (crc32("HYWIVEITFzmbK",13) == 2580563459) strcat(s, "z");
if (crc32("XDJSyotFhNUWzHa",15) == 2509119882) strcat(s, "i");
if (crc32("MEQBgalVnlB",11) == 1651077957) strcat(s, "o");
if (crc32("PzXSeUfGELX",11) == 975233113) strcat(s, "c");
if (crc32("TuwpNZx",7) == 1432026865) strcat(s, "a");
if (crc32("VWPqEeYFjQh",11) == 3524480551) strcat(s, "l");
if (crc32("lTxKtKAR",8) == 154884795) strcat(s, "l");
if (crc32("dBdAxCbodLKN",12) == 3563440093) strcat(s, "y");
    return s;
}

char *nonincidentally_adverbs() {
    char *s = calloc(16);
    if (crc32("SJznNU",6) == 896829352) strcat(s, "n");
if (crc32("EewmNNwMqE",10) == 2914001919) strcat(s, "n");
if (crc32("YBmRBIuBb",9) == 389830478) strcat(s, "i");
if (crc32("qkwFtsrG",8) == 178710637) strcat(s, "o");
if (crc32("adlfmk",6) == 692190914) strcat(s, "n");
if (crc32("fzmTju",6) == 2403990249) strcat(s, "j");
if (crc32("cwgxb",5) == 3885649034) strcat(s, "i");
if (crc32("jGJGhnzZkXw",11) == 3089858509) strcat(s, "W");
if (crc32("bsOFZbTHUMYRaDC",15) == 3506053447) strcat(s, "n");
if (crc32("rKaSUQ",6) == 2850627681) strcat(s, "j");
if (crc32("GTqqjgPmvtkuyqQ",15) == 77576203) strcat(s, "c");
if (crc32("rlsCAQ",6) == 1437775080) strcat(s, "i");
if (crc32("JybLjm",6) == 2944262131) strcat(s, "d");
if (crc32("huxikAVYyOkXM",13) == 26930919) strcat(s, "x");
if (crc32("BbrKcQlbiT",10) == 3399493854) strcat(s, "e");
if (crc32("HUBrelUWGDxpko",14) == 3534802673) strcat(s, "J");
if (crc32("jOFpKcBBUnBA",12) == 1275295403) strcat(s, "n");
if (crc32("sYeXOwtBkyjBxx",14) == 3013068204) strcat(s, "t");
if (crc32("xckhJi",6) == 473610107) strcat(s, "a");
if (crc32("vuMBCKwTa",9) == 14074933) strcat(s, "l");
if (crc32("xdZDmkQQnNdC",12) == 3683753594) strcat(s, "l");
if (crc32("GkBcyNmRFPKm",12) == 279266650) strcat(s, "y");
    return s;
}

char *ultrasonically_adverbs() {
    char *s = calloc(15);
    if (crc32("JWMwenjEgMQMt",13) == 1466424772) strcat(s, "u");
if (crc32("hUSDxgGXV",9) == 1916971184) strcat(s, "G");
if (crc32("hoyxIvbOPS",10) == 839749844) strcat(s, "l");
if (crc32("kSZffpmNDnqTV",13) == 4293569746) strcat(s, "W");
if (crc32("yzfvemVINww",11) == 2725597580) strcat(s, "t");
if (crc32("Pzdjn",5) == 515326354) strcat(s, "j");
if (crc32("qMmsdUVBwIB",11) == 4257198341) strcat(s, "r");
if (crc32("UUpGQDxdoxmH",12) == 3043994798) strcat(s, "V");
if (crc32("HmCjjQsVDqxG",12) == 3662518899) strcat(s, "a");
if (crc32("LIWFUe",6) == 3488561333) strcat(s, "v");
if (crc32("alONfQnT",8) == 3371382992) strcat(s, "s");
if (crc32("CCnhfaIGoFiB",12) == 255842148) strcat(s, "l");
if (crc32("oqOKQZC",7) == 1957022913) strcat(s, "o");
if (crc32("FVIcxmm",7) == 1986019081) strcat(s, "O");
if (crc32("pIFXPYVI",8) == 2181171795) strcat(s, "n");
if (crc32("vDHAAywlpcHgZB",14) == 1182720617) strcat(s, "i");
if (crc32("ZwnHzsU",7) == 842633160) strcat(s, "c");
if (crc32("YkjNAp",6) == 3814262293) strcat(s, "a");
if (crc32("AzIvbuK",7) == 631976557) strcat(s, "J");
if (crc32("BuqMgqLGNCZ",11) == 2680300177) strcat(s, "l");
if (crc32("wWlbDXs",7) == 2755165846) strcat(s, "l");
if (crc32("JDZDAngsIK",10) == 241743280) strcat(s, "v");
if (crc32("rDHXdeG",7) == 2877573870) strcat(s, "y");
    return s;
}

char *unsparsely_adverbs() {
    char *s = calloc(11);
    if (crc32("mCcUUzIoHbBBwZc",15) == 872803307) strcat(s, "u");
if (crc32("OEOsOep",7) == 3772425720) strcat(s, "n");
if (crc32("IhqBIRtkobsBr",13) == 3891194147) strcat(s, "L");
if (crc32("nkXOkVxeptwFsa",14) == 895250486) strcat(s, "s");
if (crc32("egpvZZc",7) == 2480207112) strcat(s, "S");
if (crc32("tCnKmrpgbX",10) == 1543431085) strcat(s, "p");
if (crc32("bIxpRKzuXNLDt",13) == 3704069476) strcat(s, "R");
if (crc32("yDTYsXf",7) == 2345135847) strcat(s, "a");
if (crc32("KeouDaTdTnkr",12) == 2672040753) strcat(s, "Z");
if (crc32("MHOoMpVEKrPBO",13) == 2625546342) strcat(s, "r");
if (crc32("ABsRTfmcIcDgKd",14) == 3754574531) strcat(s, "b");
if (crc32("prtOLoVIjoUJuB",14) == 1062183286) strcat(s, "s");
if (crc32("OqfaA",5) == 3729317503) strcat(s, "D");
if (crc32("pTasiKyVwRStpOj",15) == 2416140386) strcat(s, "e");
if (crc32("GsDEJWuFDdkIdo",14) == 2120002623) strcat(s, "I");
if (crc32("QtibrYGNzuwFK",13) == 3682462678) strcat(s, "l");
if (crc32("kUHlJVxKZZiLNSO",15) == 4289180634) strcat(s, "y");
    return s;
}

char *noncommunally_adverbs() {
    char *s = calloc(14);
    if (crc32("KsxhPYmIdIGLq",13) == 4270657402) strcat(s, "n");
if (crc32("FSTBoFKWuSQI",12) == 2418387029) strcat(s, "L");
if (crc32("LRoSIgnz",8) == 3378638040) strcat(s, "o");
if (crc32("wiKnuA",6) == 370824520) strcat(s, "g");
if (crc32("DUxKhybw",8) == 1297240595) strcat(s, "n");
if (crc32("XaDuevVIEdzajxC",15) == 1845296227) strcat(s, "b");
if (crc32("ObCDVMeDUFfz",12) == 2399534022) strcat(s, "c");
if (crc32("WdhqmFiAlDSs",12) == 2945116839) strcat(s, "I");
if (crc32("ynbpZBPw",8) == 305013591) strcat(s, "o");
if (crc32("AjDzetbT",8) == 3971343824) strcat(s, "m");
if (crc32("XottTcT",7) == 3583549184) strcat(s, "m");
if (crc32("SsQFzYjB",8) == 323313943) strcat(s, "u");
if (crc32("wzXpbKlNgEdOig",14) == 768315585) strcat(s, "n");
if (crc32("nFHoo",5) == 183496110) strcat(s, "s");
if (crc32("szjwvdoqwQ",10) == 137369920) strcat(s, "a");
if (crc32("jVNPtjraTGwU",12) == 3206242980) strcat(s, "o");
if (crc32("SuYfGMd",7) == 2234366479) strcat(s, "l");
if (crc32("QTtsMypyKyTKm",13) == 925393075) strcat(s, "E");
if (crc32("deMpOCXqJUgJcQD",15) == 2873798010) strcat(s, "l");
if (crc32("DdebiB",6) == 587190393) strcat(s, "y");
    return s;
}

char *pantological_adverbs() {
    char *s = calloc(13);
    if (crc32("uuBgJGBSUrYBU",13) == 1692692400) strcat(s, "W");
if (crc32("brLVLvFMdwPhRYu",15) == 1904171103) strcat(s, "p");
if (crc32("aFgKNVRmy",9) == 4135211549) strcat(s, "a");
if (crc32("ahnEINl",7) == 2339868044) strcat(s, "n");
if (crc32("ebnqlePHXHQ",11) == 3541730443) strcat(s, "U");
if (crc32("fxAJSGRiOVFVwDy",15) == 1734832903) strcat(s, "t");
if (crc32("qBdvHoqw",8) == 3604292339) strcat(s, "o");
if (crc32("aBExo",5) == 980830594) strcat(s, "I");
if (crc32("ehfwRWAVn",9) == 772330791) strcat(s, "l");
if (crc32("yfeGVqdfdpPs",12) == 942218018) strcat(s, "o");
if (crc32("rVitAKnHxUsN",12) == 199151576) strcat(s, "g");
if (crc32("fsFul",5) == 2071374470) strcat(s, "M");
if (crc32("FgwZWOSXVwjDi",13) == 2266490505) strcat(s, "i");
if (crc32("EpRgnUhSuqOQNn",14) == 60271361) strcat(s, "I");
if (crc32("yKnGv",5) == 987906430) strcat(s, "c");
if (crc32("bbzubiKqn",9) == 1096186339) strcat(s, "L");
if (crc32("WBTprAiAACw",11) == 1337393725) strcat(s, "a");
if (crc32("MDTHZzWOsFnTtbx",15) == 3885678627) strcat(s, "l");
    return s;
}

char *distractedly_adverbs() {
    char *s = calloc(13);
    if (crc32("FrTTFLMtq",9) == 4145272364) strcat(s, "d");
if (crc32("mtkoZB",6) == 4020554005) strcat(s, "O");
if (crc32("sjBUIHmacKZsw",13) == 2204702000) strcat(s, "i");
if (crc32("jCWJIxR",7) == 3831240728) strcat(s, "x");
if (crc32("PEUcyKIf",8) == 1265917886) strcat(s, "s");
if (crc32("gcFEmoXNmOSHQC",14) == 1131067894) strcat(s, "t");
if (crc32("iHdOKHxvezVOX",13) == 3031612020) strcat(s, "r");
if (crc32("hBGYAqu",7) == 847994828) strcat(s, "v");
if (crc32("dIjuzuPRSUbhmP",14) == 2680937233) strcat(s, "a");
if (crc32("QvIZu",5) == 2457167876) strcat(s, "c");
if (crc32("uTyVCuwTIRdK",12) == 3176150817) strcat(s, "W");
if (crc32("yhVMiWdiIa",10) == 4118573904) strcat(s, "t");
if (crc32("sTrDKbXcx",9) == 2402667211) strcat(s, "U");
if (crc32("JCdIQ",5) == 801748724) strcat(s, "e");
if (crc32("gVBoOiQSZB",10) == 3046001087) strcat(s, "p");
if (crc32("tLHtTENFYmis",12) == 242133861) strcat(s, "d");
if (crc32("QuYnPW",6) == 4242156111) strcat(s, "l");
if (crc32("hrRXYFCQUzEQZj",14) == 2939525597) strcat(s, "y");
    return s;
}

char *heliocentrically_adverbs() {
    char *s = calloc(17);
    if (crc32("fVhxkcEbsBc",11) == 1655097881) strcat(s, "z");
if (crc32("vJaBgq",6) == 2210429589) strcat(s, "h");
if (crc32("VkuATm",6) == 3996592959) strcat(s, "y");
if (crc32("zlyPTDN",7) == 4215894748) strcat(s, "e");
if (crc32("CxMrCxPVFV",10) == 3546951944) strcat(s, "l");
if (crc32("pqQXLQwDfoZQHT",14) == 2557502793) strcat(s, "U");
if (crc32("tlekMivSN",9) == 3246194123) strcat(s, "i");
if (crc32("zOMhC",5) == 2357504014) strcat(s, "o");
if (crc32("cEwfqIiiSQNK",12) == 2305318823) strcat(s, "c");
if (crc32("hISbBwTJJemgS",13) == 1203978416) strcat(s, "W");
if (crc32("zTdmZuZNJzqlFG",14) == 2506139886) strcat(s, "e");
if (crc32("rfdOoeSGbaKBQ",13) == 2758116402) strcat(s, "E");
if (crc32("wwTokGrDcM",10) == 3082267193) strcat(s, "n");
if (crc32("EiBgy",5) == 1617229307) strcat(s, "t");
if (crc32("yBtfISAZbsqVt",13) == 2197468176) strcat(s, "Z");
if (crc32("Vhjxz",5) == 2643802032) strcat(s, "r");
if (crc32("MfmCHltsQ",9) == 3993558221) strcat(s, "i");
if (crc32("TGTlQC",6) == 2252650723) strcat(s, "Q");
if (crc32("gQxqnBrwmjBea",13) == 1888583987) strcat(s, "c");
if (crc32("zGbJvEQgpnh",11) == 155621725) strcat(s, "v");
if (crc32("JlukJjBJE",9) == 3480499303) strcat(s, "a");
if (crc32("DSGXsM",6) == 850089046) strcat(s, "l");
if (crc32("GwoNDiHukVVUT",13) == 2141838028) strcat(s, "l");
if (crc32("UTwrUeNKNUQrLkg",15) == 2809260844) strcat(s, "y");
    return s;
}

char *languorously_adverbs() {
    char *s = calloc(13);
    if (crc32("uaNzadLMWJIG",12) == 3465389506) strcat(s, "E");
if (crc32("EATKkTSU",8) == 1394217750) strcat(s, "l");
if (crc32("MQCeY",5) == 1829848585) strcat(s, "a");
if (crc32("rclZANsNfsOL",12) == 3901029685) strcat(s, "x");
if (crc32("uJzUEFCMksA",11) == 3983868665) strcat(s, "n");
if (crc32("JHEQMMXZabWmig",14) == 3414242863) strcat(s, "v");
if (crc32("ZHUtcZjmbl",10) == 3599701934) strcat(s, "g");
if (crc32("MHOanoumEGhsRA",14) == 3318435078) strcat(s, "u");
if (crc32("SDXlwHMAdzsCa",13) == 1991760263) strcat(s, "b");
if (crc32("MnPAgMdBgzIU",12) == 751817782) strcat(s, "o");
if (crc32("FIfvHLpUiK",10) == 3155885288) strcat(s, "S");
if (crc32("VNQKXMi",7) == 2991310356) strcat(s, "r");
if (crc32("yOuALVDB",8) == 2863979670) strcat(s, "s");
if (crc32("wUBxU",5) == 4277812089) strcat(s, "o");
if (crc32("FshtKNjZNohJWMl",15) == 1053126930) strcat(s, "J");
if (crc32("fGJXZAhVZOCHDnh",15) == 1182921263) strcat(s, "u");
if (crc32("klofdIrJ",8) == 3681464529) strcat(s, "i");
if (crc32("YfiGgppDjGf",11) == 2435569959) strcat(s, "s");
if (crc32("aPzhFEfTdfZaU",13) == 3586683844) strcat(s, "w");
if (crc32("DdPJmEvKCwM",11) == 2326363636) strcat(s, "l");
if (crc32("HkxadAsAfw",10) == 3779527073) strcat(s, "y");
    return s;
}

char *crampingly_adverbs() {
    char *s = calloc(11);
    if (crc32("OPiFNbi",7) == 274575575) strcat(s, "c");
if (crc32("anWfMX",6) == 2808551277) strcat(s, "M");
if (crc32("GxnUB",5) == 2670564528) strcat(s, "r");
if (crc32("yHKPh",5) == 796743693) strcat(s, "r");
if (crc32("jWruVZIART",10) == 3101876202) strcat(s, "a");
if (crc32("HfbhkXzIvDZgGv",14) == 2965610127) strcat(s, "m");
if (crc32("pxHsRn",6) == 1506988606) strcat(s, "p");
if (crc32("yMmvMRuAwfqts",13) == 3518881641) strcat(s, "v");
if (crc32("awjYCElVhbOIDL",14) == 2963753370) strcat(s, "i");
if (crc32("TKgHiLBZ",8) == 360437968) strcat(s, "q");
if (crc32("KCdiLIqqoUaCA",13) == 789330047) strcat(s, "n");
if (crc32("vDGOeo",6) == 1218434195) strcat(s, "p");
if (crc32("ZzjVGEESsA",10) == 1823005050) strcat(s, "g");
if (crc32("EHbgyG",6) == 1277615445) strcat(s, "l");
if (crc32("SCxnetwyViI",11) == 3065700778) strcat(s, "y");
    return s;
}

char *uncomically_adverbs() {
    char *s = calloc(12);
    if (crc32("pgCtjmRCGOemb",13) == 4063235046) strcat(s, "u");
if (crc32("EDQyafIzFGCaK",13) == 925719263) strcat(s, "n");
if (crc32("JCRSHoAKJwfIXky",15) == 1610102048) strcat(s, "c");
if (crc32("EUUwRgTUJJvN",12) == 2570133776) strcat(s, "F");
if (crc32("OnQAEUP",7) == 3791444521) strcat(s, "o");
if (crc32("GCCvzq",6) == 1602110234) strcat(s, "k");
if (crc32("RASCQwnR",8) == 1493200188) strcat(s, "m");
if (crc32("sIZevGEBXbjgd",13) == 1081261178) strcat(s, "i");
if (crc32("LzlcZbjcRbygwgz",15) == 2159714400) strcat(s, "l");
if (crc32("pofGuwoooLDx",12) == 84472608) strcat(s, "c");
if (crc32("HyABGqOZ",8) == 1663330903) strcat(s, "N");
if (crc32("EtEdJUJN",8) == 712192656) strcat(s, "a");
if (crc32("YROjqZdWOeM",11) == 601229879) strcat(s, "l");
if (crc32("hqQEsgjIJxIyLey",15) == 3419004043) strcat(s, "l");
if (crc32("YXZmhCh",7) == 2934599168) strcat(s, "l");
if (crc32("lEmrAnbMyDuiO",13) == 3111160962) strcat(s, "H");
if (crc32("duioGplQmc",10) == 3221306965) strcat(s, "y");
    return s;
}

char *nonadeptly_adverbs() {
    char *s = calloc(11);
    if (crc32("ICMLYykQzsU",11) == 3236392015) strcat(s, "H");
if (crc32("VDPmz",5) == 1765319012) strcat(s, "n");
if (crc32("XMdZVcBlZwOBqI",14) == 401444873) strcat(s, "o");
if (crc32("CcFtfUXJdaPVa",13) == 1210498112) strcat(s, "n");
if (crc32("zCmoSq",6) == 277977380) strcat(s, "r");
if (crc32("uKmKEmP",7) == 2793258408) strcat(s, "a");
if (crc32("tKLCYDxQvP",10) == 473402574) strcat(s, "d");
if (crc32("vxLNmXLANAmTaZY",15) == 3594502890) strcat(s, "e");
if (crc32("GGPaBKKe",8) == 562466756) strcat(s, "O");
if (crc32("IgSXD",5) == 1478082723) strcat(s, "p");
if (crc32("fMdcDj",6) == 145475190) strcat(s, "t");
if (crc32("VtddJzLNR",9) == 2803478629) strcat(s, "l");
if (crc32("WyxkbTJpDxK",11) == 17122037) strcat(s, "y");
if (crc32("wIOyyFtHhpZc",12) == 3888841978) strcat(s, "y");
    return s;
}

char *nondualistically_adverbs() {
    char *s = calloc(17);
    if (crc32("SVLgh",5) == 3090636219) strcat(s, "Q");
if (crc32("UzQjXtwqpORe",12) == 3049664357) strcat(s, "n");
if (crc32("ycLYOwT",7) == 1048904062) strcat(s, "C");
if (crc32("aGglEffMy",9) == 291817299) strcat(s, "o");
if (crc32("zjQPf",5) == 835787337) strcat(s, "q");
if (crc32("wuUFVkQxyMclpM",14) == 2358393732) strcat(s, "n");
if (crc32("sexLmjq",7) == 4171914590) strcat(s, "d");
if (crc32("yJjIEhhGlZNR",12) == 1848732527) strcat(s, "u");
if (crc32("CVVejR",6) == 3892859523) strcat(s, "C");
if (crc32("gkqlBTOccsLRu",13) == 3121764792) strcat(s, "a");
if (crc32("gbOFCnj",7) == 2180880963) strcat(s, "H");
if (crc32("zvcjmwEgtVJ",11) == 1261229401) strcat(s, "l");
if (crc32("zbUwNGP",7) == 3911678677) strcat(s, "g");
if (crc32("BICELEGgPqFMDgH",15) == 1318352795) strcat(s, "i");
if (crc32("qOmVEbuitlpmf",13) == 3474592193) strcat(s, "s");
if (crc32("gNfqOyeE",8) == 886344816) strcat(s, "i");
if (crc32("NpWdl",5) == 1723337292) strcat(s, "t");
if (crc32("nIbdQfSLPVBnJZY",15) == 2911399868) strcat(s, "i");
if (crc32("GuFgVVRx",8) == 1513975193) strcat(s, "c");
if (crc32("GFoszP",6) == 198158286) strcat(s, "j");
if (crc32("hpDYgGqs",8) == 125988162) strcat(s, "a");
if (crc32("hEEgiP",6) == 4218425117) strcat(s, "l");
if (crc32("absMKuSTR",9) == 2964207494) strcat(s, "M");
if (crc32("KbGrGeGl",8) == 793790619) strcat(s, "l");
if (crc32("DCBnzSrOBITDWFs",15) == 3778100149) strcat(s, "f");
if (crc32("PuQnOpiVSwPpcmf",15) == 2611792874) strcat(s, "y");
    return s;
}

char *dampishly_adverbs() {
    char *s = calloc(10);
    if (crc32("UOGcurrIVdZe",12) == 3264224555) strcat(s, "S");
if (crc32("bjduQTSpulNm",12) == 318005562) strcat(s, "d");
if (crc32("QuRCbiXKLIBY",12) == 888119077) strcat(s, "a");
if (crc32("AHyhD",5) == 2057617871) strcat(s, "m");
if (crc32("JRIRtaoHP",9) == 3052093015) strcat(s, "p");
if (crc32("GNRQBbPmsLY",11) == 1181584727) strcat(s, "q");
if (crc32("MnwyTH",6) == 790555445) strcat(s, "i");
if (crc32("HCRzLHIHg",9) == 403392128) strcat(s, "H");
if (crc32("mkSSWaseswVMe",13) == 2071699112) strcat(s, "s");
if (crc32("raaAN",5) == 1730890429) strcat(s, "C");
if (crc32("fdqenflRZuA",11) == 2120475037) strcat(s, "h");
if (crc32("NnfyYJfVbtLQk",13) == 711001795) strcat(s, "r");
if (crc32("ZxsDatKLXPe",11) == 3601789943) strcat(s, "l");
if (crc32("bPrxAOqrahfWoBx",15) == 1713461967) strcat(s, "V");
if (crc32("oQOjpJznAygnloz",15) == 3647833466) strcat(s, "y");
    return s;
}

char *unenjoyably_adverbs() {
    char *s = calloc(12);
    if (crc32("eJdZA",5) == 1829245021) strcat(s, "u");
if (crc32("qTwrDVqr",8) == 2489066547) strcat(s, "c");
if (crc32("fjngarkcbOIzOO",14) == 1330431798) strcat(s, "n");
if (crc32("wNsDM",5) == 1020560873) strcat(s, "e");
if (crc32("AJFHgeUSmOi",11) == 2664078671) strcat(s, "n");
if (crc32("RATiIUxpWcZh",12) == 184222934) strcat(s, "h");
if (crc32("JUIhFXt",7) == 3677887186) strcat(s, "j");
if (crc32("PJGXHRYhuJUnmuF",15) == 3386654892) strcat(s, "U");
if (crc32("booIe",5) == 427678179) strcat(s, "o");
if (crc32("ShraXmvkigHv",12) == 3066617938) strcat(s, "y");
if (crc32("PHGBB",5) == 2413420154) strcat(s, "a");
if (crc32("nDDrSAkbB",9) == 4266784820) strcat(s, "b");
if (crc32("XrBCMUyKG",9) == 2121949248) strcat(s, "y");
if (crc32("viJLBEH",7) == 2025449692) strcat(s, "l");
if (crc32("GdqlfqgXTfC",11) == 2517633572) strcat(s, "y");
    return s;
}

char *undefiantly_adverbs() {
    char *s = calloc(12);
    if (crc32("BenYksbBVAYETFM",15) == 2860595040) strcat(s, "U");
if (crc32("uIHji",5) == 3304655292) strcat(s, "u");
if (crc32("ekNzRR",6) == 677164176) strcat(s, "n");
if (crc32("xYpwyPDtP",9) == 1012714786) strcat(s, "n");
if (crc32("acndyPsLCj",10) == 1625169074) strcat(s, "d");
if (crc32("PQcLQhJdigu",11) == 3571723401) strcat(s, "e");
if (crc32("pTgJURn",7) == 1901119842) strcat(s, "f");
if (crc32("rjZXpMz",7) == 2451047261) strcat(s, "i");
if (crc32("JaGXUTyxbHpQF",13) == 1640635712) strcat(s, "q");
if (crc32("RnMegKX",7) == 2363900078) strcat(s, "a");
if (crc32("cenuWITYfYVUGG",14) == 170554051) strcat(s, "n");
if (crc32("SEbensDR",8) == 543738654) strcat(s, "t");
if (crc32("yfhQyK",6) == 2684778905) strcat(s, "L");
if (crc32("uRSJzx",6) == 2269471058) strcat(s, "l");
if (crc32("nVITBLzOEdsQ",12) == 80734472) strcat(s, "y");
    return s;
}

char *unprosperously_adverbs() {
    char *s = calloc(15);
    if (crc32("iIaaFswEX",9) == 771453876) strcat(s, "A");
if (crc32("vSjfCIsYmjA",11) == 2080371262) strcat(s, "u");
if (crc32("PENwMWp",7) == 3357016123) strcat(s, "Y");
if (crc32("bjMNFsGQuo",10) == 3673344014) strcat(s, "n");
if (crc32("TNrzleMCYBvnYfM",15) == 32632334) strcat(s, "y");
if (crc32("fCmMxRKJzBWN",12) == 1475702103) strcat(s, "p");
if (crc32("KfzNvqOgeNRKLWH",15) == 1104024202) strcat(s, "g");
if (crc32("jJEvq",5) == 3376410713) strcat(s, "r");
if (crc32("ScelDEctyzcuz",13) == 2651281602) strcat(s, "o");
if (crc32("gvyBkk",6) == 3957405482) strcat(s, "s");
if (crc32("AHXLpMaWC",9) == 2125377012) strcat(s, "p");
if (crc32("hYkotRc",7) == 2625878282) strcat(s, "b");
if (crc32("mjPRMLK",7) == 1123373063) strcat(s, "e");
if (crc32("wHGbgQC",7) == 767140753) strcat(s, "r");
if (crc32("XheFBsRuFQlyQ",13) == 831163935) strcat(s, "i");
if (crc32("mYaPzBrrE",9) == 4004949915) strcat(s, "o");
if (crc32("ZmiMmtXhOrfsh",13) == 2127055445) strcat(s, "e");
if (crc32("icESPJalowGKizc",15) == 1315713186) strcat(s, "u");
if (crc32("LStPsu",6) == 990586634) strcat(s, "B");
if (crc32("VrFQboWZGFnHM",13) == 273741232) strcat(s, "s");
if (crc32("yeyjc",5) == 781292162) strcat(s, "l");
if (crc32("FTsIvXUochrxQv",14) == 2885129101) strcat(s, "y");
    return s;
}

char *tyrannisingly_adverbs() {
    char *s = calloc(14);
    if (crc32("CMaeowLXJJ",10) == 1237261184) strcat(s, "u");
if (crc32("NKfqChuLxPlzvNK",15) == 4068388039) strcat(s, "t");
if (crc32("oIskrncHeJJI",12) == 3894586667) strcat(s, "y");
if (crc32("hXPOyDJrxGjd",12) == 265346632) strcat(s, "r");
if (crc32("CeGtACN",7) == 2236615239) strcat(s, "a");
if (crc32("oGYqs",5) == 1204161035) strcat(s, "n");
if (crc32("JQFftZ",6) == 2652221865) strcat(s, "v");
if (crc32("FkQsgbWlj",9) == 2046119855) strcat(s, "n");
if (crc32("dCQuveZyISuc",12) == 398126447) strcat(s, "i");
if (crc32("LLFfv",5) == 1145660522) strcat(s, "M");
if (crc32("zflXEkAE",8) == 3223136080) strcat(s, "s");
if (crc32("obiiiwbwBJ",10) == 2426898966) strcat(s, "i");
if (crc32("JtIlef",6) == 148484314) strcat(s, "n");
if (crc32("ZeqczlJneargu",13) == 266507446) strcat(s, "o");
if (crc32("bKhkYuzts",9) == 2295993034) strcat(s, "g");
if (crc32("boersMBoz",9) == 2467138994) strcat(s, "Y");
if (crc32("LAnGpnXVlosi",12) == 251101578) strcat(s, "l");
if (crc32("LYfqPuWIJJPrpjQ",15) == 3897845188) strcat(s, "y");
    return s;
}

char *extemporarily_adverbs() {
    char *s = calloc(14);
    if (crc32("OYLelPtPygb",11) == 2974699672) strcat(s, "B");
if (crc32("DdUQfAfhdxJ",11) == 2397064561) strcat(s, "e");
if (crc32("yAANKK",6) == 1969951884) strcat(s, "t");
if (crc32("gtomoARrbIfz",12) == 2698268890) strcat(s, "x");
if (crc32("kmHbGvSFqCF",11) == 3753124440) strcat(s, "S");
if (crc32("xiSnShlhDua",11) == 3347980294) strcat(s, "t");
if (crc32("FvVtFUSKWFJirR",14) == 877914304) strcat(s, "e");
if (crc32("WxOQlpbenPKSdVT",15) == 2397203267) strcat(s, "m");
if (crc32("bZnLBlyCM",9) == 1927978711) strcat(s, "q");
if (crc32("CRBqqWGD",8) == 2225152870) strcat(s, "p");
if (crc32("zUQmDPNHAfnMVE",14) == 4105362944) strcat(s, "o");
if (crc32("RQsZu",5) == 1699607833) strcat(s, "O");
if (crc32("obUIockjoxsEbUX",15) == 306206640) strcat(s, "r");
if (crc32("WfXIgtDLvya",11) == 1102428237) strcat(s, "X");
if (crc32("wQufXDHMyMIQYde",15) == 2709579683) strcat(s, "a");
if (crc32("zABLWvQMcMzbW",13) == 524183811) strcat(s, "X");
if (crc32("soiHVhxFzuHepC",14) == 4148428809) strcat(s, "r");
if (crc32("uorqr",5) == 1259314030) strcat(s, "i");
if (crc32("xvIICaxdPc",10) == 2721232500) strcat(s, "v");
if (crc32("UfBgeggMLcozje",14) == 3077387905) strcat(s, "l");
if (crc32("BRDoMOr",7) == 1881167431) strcat(s, "y");
    return s;
}

char *annually_adverbs() {
    char *s = calloc(9);
    if (crc32("mNxhOmFpoqMAl",13) == 1148762894) strcat(s, "I");
if (crc32("jkthth",6) == 1558983432) strcat(s, "a");
if (crc32("hbdBKy",6) == 294132167) strcat(s, "k");
if (crc32("jBzzxnTknYket",13) == 3132271304) strcat(s, "n");
if (crc32("GyHSIkxDFijK",12) == 4293607528) strcat(s, "k");
if (crc32("inpXiEKrNb",10) == 2407375852) strcat(s, "n");
if (crc32("DbEtZsGJEom",11) == 3611625182) strcat(s, "u");
if (crc32("thwRKS",6) == 4027328131) strcat(s, "a");
if (crc32("oUkddTZYzzTq",12) == 3211721237) strcat(s, "l");
if (crc32("RGXHsgc",7) == 3087778379) strcat(s, "y");
if (crc32("NNtqKKUCt",9) == 2439693668) strcat(s, "l");
if (crc32("qKWKNZ",6) == 2446236100) strcat(s, "y");
    return s;
}

char *terrifyingly_adverbs() {
    char *s = calloc(13);
    if (crc32("gdUuyUtp",8) == 3398575685) strcat(s, "t");
if (crc32("FRkqAqmfZJfDAaQ",15) == 540533375) strcat(s, "e");
if (crc32("ahskkPL",7) == 2265746219) strcat(s, "r");
if (crc32("LeiqfD",6) == 3380699343) strcat(s, "r");
if (crc32("fJXnXRUf",8) == 1470017339) strcat(s, "i");
if (crc32("UcJCNPWcNrnio",13) == 597542012) strcat(s, "f");
if (crc32("akDvREYpkHLeWb",14) == 2336383795) strcat(s, "K");
if (crc32("KQUJOFfBL",9) == 1775225569) strcat(s, "y");
if (crc32("AWtWihZjHH",10) == 1833414533) strcat(s, "i");
if (crc32("HXfdGCmso",9) == 4245666954) strcat(s, "N");
if (crc32("vnNwmwlPNDf",11) == 598881943) strcat(s, "n");
if (crc32("SgAZBi",6) == 2758283490) strcat(s, "g");
if (crc32("IhwzR",5) == 1031024000) strcat(s, "Y");
if (crc32("TqGWgZM",7) == 857746090) strcat(s, "l");
if (crc32("YhXWphVPM",9) == 3890268746) strcat(s, "y");
    return s;
}

char *noncoercively_adverbs() {
    char *s = calloc(14);
    if (crc32("rYmGauMkAKSUnVL",15) == 1759205569) strcat(s, "x");
if (crc32("ZpJnvBE",7) == 1288972516) strcat(s, "n");
if (crc32("DlTmCNpFkpq",11) == 3913180452) strcat(s, "o");
if (crc32("sMDOhZP",7) == 3001003447) strcat(s, "x");
if (crc32("oIAumgb",7) == 951598310) strcat(s, "n");
if (crc32("SvJSXKmJypBdWbD",15) == 2362914067) strcat(s, "c");
if (crc32("kvgHJ",5) == 2242248231) strcat(s, "o");
if (crc32("KXuShAHdjDD",11) == 1439593133) strcat(s, "e");
if (crc32("PYdXXwF",7) == 3667995774) strcat(s, "N");
if (crc32("AtcMzhTcSIztBCW",15) == 3583148135) strcat(s, "r");
if (crc32("YVNkXBfVaFmliR",14) == 4207461394) strcat(s, "c");
if (crc32("decLntwkzlGfHN",14) == 2364262787) strcat(s, "i");
if (crc32("RzbNrPXiFUu",11) == 1312592131) strcat(s, "v");
if (crc32("PLKdmZnbtV",10) == 658272715) strcat(s, "r");
if (crc32("XBrohWyrL",9) == 11862106) strcat(s, "e");
if (crc32("KORXjVR",7) == 1170241886) strcat(s, "l");
if (crc32("AFmnHeLN",8) == 3904019830) strcat(s, "y");
    return s;
}

char *hummingly_adverbs() {
    char *s = calloc(10);
    if (crc32("nElTtWM",7) == 2947696530) strcat(s, "h");
if (crc32("wWFnHNV",7) == 1720982909) strcat(s, "K");
if (crc32("XqqALDYR",8) == 1147033412) strcat(s, "u");
if (crc32("JmxgMEpLcgVQwQ",14) == 3665924858) strcat(s, "m");
if (crc32("pnanzi",6) == 593386045) strcat(s, "G");
if (crc32("JoxIxbOwMaTvwY",14) == 3686929461) strcat(s, "m");
if (crc32("obqkV",5) == 492661955) strcat(s, "i");
if (crc32("NfBOcldgxJ",10) == 2712710750) strcat(s, "W");
if (crc32("EXXqty",6) == 3744788022) strcat(s, "n");
if (crc32("MeHqaPPbVAo",11) == 4065829441) strcat(s, "D");
if (crc32("QDHtvrfaLHcuMzV",15) == 1648138389) strcat(s, "g");
if (crc32("hyIDVIu",7) == 1620522257) strcat(s, "j");
if (crc32("JiHgqp",6) == 4265216361) strcat(s, "l");
if (crc32("lPGedW",6) == 1252434674) strcat(s, "y");
    return s;
}

char *unceremoniously_adverbs() {
    char *s = calloc(16);
    if (crc32("zJnAXkkHqxm",11) == 1343974707) strcat(s, "o");
if (crc32("nExOmla",7) == 2690104682) strcat(s, "u");
if (crc32("QbnnqpuL",8) == 1579940186) strcat(s, "n");
if (crc32("lZmUFMcgvB",10) == 166738455) strcat(s, "c");
if (crc32("XvksalvwgDiYaM",14) == 3476067227) strcat(s, "e");
if (crc32("ecjlB",5) == 1320260266) strcat(s, "E");
if (crc32("GAmXSlpIjSYQq",13) == 2963178373) strcat(s, "r");
if (crc32("CpiefZuJwKON",12) == 1294146763) strcat(s, "e");
if (crc32("ECeFTkkNoxCPno",14) == 837327866) strcat(s, "K");
if (crc32("nlWltbGaDE",10) == 724723516) strcat(s, "m");
if (crc32("iCTcxtVgyXMh",12) == 586290345) strcat(s, "k");
if (crc32("yqVapwNjoSYy",12) == 785952813) strcat(s, "o");
if (crc32("pNDlQcaAgIdXulO",15) == 3634962393) strcat(s, "T");
if (crc32("UNeCLOCwmOpHOu",14) == 3986840584) strcat(s, "n");
if (crc32("QNrDz",5) == 2585620174) strcat(s, "k");
if (crc32("TDUPyZEHEuxj",12) == 3096120338) strcat(s, "i");
if (crc32("zoHfZPmu",8) == 3892655614) strcat(s, "o");
if (crc32("RbCWLrXU",8) == 769000632) strcat(s, "l");
if (crc32("PXytsDN",7) == 490551737) strcat(s, "u");
if (crc32("CYQmn",5) == 2903357738) strcat(s, "y");
if (crc32("IJouSH",6) == 1396191284) strcat(s, "s");
if (crc32("VFvWuX",6) == 3429073184) strcat(s, "R");
if (crc32("BaxvNOwjxWH",11) == 3633193386) strcat(s, "l");
if (crc32("ooTKPfBg",8) == 501152428) strcat(s, "s");
if (crc32("xWKSGogHIe",10) == 3150513189) strcat(s, "y");
    return s;
}

char *overdeferentially_adverbs() {
    char *s = calloc(18);
    if (crc32("cNFKmdfFvwKwg",13) == 3125745594) strcat(s, "o");
if (crc32("NudbicZMsL",10) == 3349589926) strcat(s, "v");
if (crc32("yOxGKGybMtISY",13) == 3865421438) strcat(s, "O");
if (crc32("GUnTTGnny",9) == 1444190863) strcat(s, "e");
if (crc32("ZIVDRuDtJ",9) == 4285002679) strcat(s, "z");
if (crc32("ysmLpwRvFQVzxD",14) == 4278599149) strcat(s, "r");
if (crc32("FbtOmlRUrAbCHBT",15) == 2118311371) strcat(s, "d");
if (crc32("CaTRVHIPBicF",12) == 313806013) strcat(s, "e");
if (crc32("qvNatcVqao",10) == 1022467453) strcat(s, "f");
if (crc32("bZJDNa",6) == 3451121942) strcat(s, "g");
if (crc32("oNZlldDFSelI",12) == 1533488967) strcat(s, "e");
if (crc32("dsqKc",5) == 2938384192) strcat(s, "S");
if (crc32("sBEvJDzomHB",11) == 752503912) strcat(s, "r");
if (crc32("tWrRUgsDCeK",11) == 3568852571) strcat(s, "k");
if (crc32("bSFYbzYEJUVVK",13) == 2085700404) strcat(s, "e");
if (crc32("DlMxqaIagIQRF",13) == 698915617) strcat(s, "D");
if (crc32("XxicRvpbWqtPu",13) == 1621164430) strcat(s, "n");
if (crc32("mVrqulWCdBUbVt",14) == 2303114330) strcat(s, "t");
if (crc32("qLKHKocOCfTwH",13) == 1190472632) strcat(s, "i");
if (crc32("IyDuweh",7) == 2602374567) strcat(s, "a");
if (crc32("kTLxDZKUNGaJCRf",15) == 4051402180) strcat(s, "l");
if (crc32("zYrtPv",6) == 1150542102) strcat(s, "g");
if (crc32("BbAyBSy",7) == 3006338353) strcat(s, "l");
if (crc32("Pxdovr",6) == 1146036339) strcat(s, "y");
    return s;
}

char *nonuprightly_adverbs() {
    char *s = calloc(13);
    if (crc32("kbFcMhmzzK",10) == 1405373891) strcat(s, "n");
if (crc32("NreqGZOCPz",10) == 3028718156) strcat(s, "o");
if (crc32("Mmufcd",6) == 4258116074) strcat(s, "i");
if (crc32("qKgSarAf",8) == 2966057836) strcat(s, "n");
if (crc32("AjnfHDBEXehI",12) == 4160880080) strcat(s, "u");
if (crc32("njHoKVTVsKiP",12) == 3369410577) strcat(s, "p");
if (crc32("fcyvP",5) == 2968383814) strcat(s, "r");
if (crc32("VpSRUjH",7) == 1388150472) strcat(s, "E");
if (crc32("wcbrxuVtkvrgpPM",15) == 4130460894) strcat(s, "i");
if (crc32("EUrfQgwPjUzx",12) == 1378149570) strcat(s, "S");
if (crc32("KiiETpjckd",10) == 278306189) strcat(s, "g");
if (crc32("jvTIDoaekhpetc",14) == 928153109) strcat(s, "T");
if (crc32("zEHhl",5) == 1310963672) strcat(s, "h");
if (crc32("UnbcxvWQhVtwbV",14) == 82537534) strcat(s, "t");
if (crc32("gltpdCiafzRUd",13) == 2794697155) strcat(s, "Q");
if (crc32("dGzbCCIUsJWtS",13) == 463373282) strcat(s, "l");
if (crc32("wQVSchMdWUea",12) == 1245274053) strcat(s, "y");
    return s;
}

char *discontentedly_adverbs() {
    char *s = calloc(15);
    if (crc32("stntrMbwCAjp",12) == 4128432367) strcat(s, "d");
if (crc32("FxybziYBjm",10) == 3287422462) strcat(s, "i");
if (crc32("ssgguHuazUG",11) == 462189123) strcat(s, "W");
if (crc32("TFhJF",5) == 1713586245) strcat(s, "s");
if (crc32("amtGCscZQLJpxjM",15) == 3388706749) strcat(s, "i");
if (crc32("jgyqXpBs",8) == 3549218331) strcat(s, "c");
if (crc32("WJlkJQEhyjqI",12) == 1284264724) strcat(s, "v");
if (crc32("uHwbMdNe",8) == 1981904535) strcat(s, "o");
if (crc32("UlUZmElwR",9) == 3972972220) strcat(s, "n");
if (crc32("ueTejF",6) == 1765957042) strcat(s, "W");
if (crc32("LewjqsAKog",10) == 3899873792) strcat(s, "t");
if (crc32("gNqsIjnOi",9) == 2525396469) strcat(s, "R");
if (crc32("sEobi",5) == 4105476553) strcat(s, "e");
if (crc32("KAEvjmqcmKzSfg",14) == 2709196174) strcat(s, "n");
if (crc32("FZaafmJcLI",10) == 4096350379) strcat(s, "t");
if (crc32("JdsLzA",6) == 1860517014) strcat(s, "H");
if (crc32("ySQCRqXyrV",10) == 17489039) strcat(s, "e");
if (crc32("dCLKcyJDxryP",12) == 4166909946) strcat(s, "K");
if (crc32("ythFhUQel",9) == 2536120499) strcat(s, "d");
if (crc32("CkeylWlq",8) == 783180956) strcat(s, "W");
if (crc32("GnTloXaMsjDu",12) == 3316542042) strcat(s, "l");
if (crc32("FHzTfEKThpTblTT",15) == 2741413950) strcat(s, "y");
    return s;
}

char *unstoutly_adverbs() {
    char *s = calloc(10);
    if (crc32("GkwuoaSmHQ",10) == 3113530353) strcat(s, "u");
if (crc32("gXsLKVMdOd",10) == 1897777212) strcat(s, "n");
if (crc32("sWLzqGnUytKfFp",14) == 3679072656) strcat(s, "s");
if (crc32("cjACOrcqALEykFf",15) == 355878104) strcat(s, "t");
if (crc32("aDERcCugaSPlqG",14) == 205164288) strcat(s, "f");
if (crc32("tKeBMpd",7) == 2646178630) strcat(s, "o");
if (crc32("IeNmaVml",8) == 2767889488) strcat(s, "w");
if (crc32("HAfmxHVuCFPK",12) == 1847469321) strcat(s, "u");
if (crc32("sBOJGKsAxWzOII",14) == 3437828742) strcat(s, "r");
if (crc32("rxNOArwjecUuPB",14) == 2331680601) strcat(s, "t");
if (crc32("OKTjmLNtNM",10) == 4286345858) strcat(s, "t");
if (crc32("WBTFPvK",7) == 3199575314) strcat(s, "l");
if (crc32("MsxfAgtoGlspEAs",15) == 2904665181) strcat(s, "y");
    return s;
}

char *unturbulently_adverbs() {
    char *s = calloc(14);
    if (crc32("LtSXFFYZBbHj",12) == 3556172) strcat(s, "E");
if (crc32("wQCqAs",6) == 1584058839) strcat(s, "u");
if (crc32("cQjCutsC",8) == 1278811836) strcat(s, "i");
if (crc32("CmlXIRUe",8) == 741649862) strcat(s, "n");
if (crc32("IIyifYVhLPkiD",13) == 2483107512) strcat(s, "i");
if (crc32("BGCYCHobHUTa",12) == 3918633543) strcat(s, "t");
if (crc32("fQOEsIxJvXPCPZr",15) == 3725227602) strcat(s, "O");
if (crc32("ceguUbUcjB",10) == 2783171025) strcat(s, "u");
if (crc32("qSGGvWtSUuq",11) == 3410477041) strcat(s, "r");
if (crc32("iKfUfCOg",8) == 2899257052) strcat(s, "U");
if (crc32("QcPZjPxfAfhbT",13) == 3384445098) strcat(s, "b");
if (crc32("IyylSNGNCpsu",12) == 542502242) strcat(s, "u");
if (crc32("PXHVpPTITAlFsF",14) == 3951019286) strcat(s, "l");
if (crc32("lIHQzamNWmYezIk",15) == 90874061) strcat(s, "e");
if (crc32("wjrXyBlVOqz",11) == 3714703748) strcat(s, "X");
if (crc32("oMqPjJzjBgZmw",13) == 1698634826) strcat(s, "n");
if (crc32("TnRZtlPh",8) == 6347466) strcat(s, "t");
if (crc32("GpnDbyyVPUowDFi",15) == 291081449) strcat(s, "l");
if (crc32("HEiIBAHE",8) == 2367831830) strcat(s, "y");
    return s;
}

char *sluttishly_adverbs() {
    char *s = calloc(11);
    if (crc32("EcmpEZZrTmMMYZl",15) == 2541877391) strcat(s, "z");
if (crc32("mwHveN",6) == 3379041981) strcat(s, "s");
if (crc32("yeQNRWNBacVTnj",14) == 790593375) strcat(s, "l");
if (crc32("QGbqRz",6) == 1619158195) strcat(s, "u");
if (crc32("STIuunvrRmoApKM",15) == 3305520969) strcat(s, "L");
if (crc32("xyBTI",5) == 3145632719) strcat(s, "t");
if (crc32("SXpUPwZDlv",10) == 1106243459) strcat(s, "t");
if (crc32("tDKZyuLfS",9) == 739443477) strcat(s, "z");
if (crc32("lectM",5) == 2679611078) strcat(s, "i");
if (crc32("TDihUigrCgPCFEz",15) == 1176415822) strcat(s, "s");
if (crc32("cMYItpOLKwfXSr",14) == 3597943628) strcat(s, "h");
if (crc32("aACUCx",6) == 625620585) strcat(s, "N");
if (crc32("SsvCiBhBzKOttn",14) == 4034017505) strcat(s, "l");
if (crc32("AIGBCDVT",8) == 524132797) strcat(s, "y");
    return s;
}

char *highhandedly_adverbs() {
    char *s = calloc(13);
    if (crc32("sCprmg",6) == 2619416560) strcat(s, "I");
if (crc32("yAXquNJDtD",10) == 3910614248) strcat(s, "h");
if (crc32("oORdMkImJwdJ",12) == 937485937) strcat(s, "x");
if (crc32("PqRdNgQY",8) == 3500931247) strcat(s, "i");
if (crc32("XBxHAoZUaOh",11) == 1787105930) strcat(s, "g");
if (crc32("HmLvNNq",7) == 876217137) strcat(s, "n");
if (crc32("oPUizfXKkTsWZw",14) == 2986878163) strcat(s, "h");
if (crc32("vcjguLpPktmXS",13) == 632946052) strcat(s, "h");
if (crc32("gtrBYLGNbTm",11) == 2708434601) strcat(s, "a");
if (crc32("dyTtBmpkvel",11) == 4286997960) strcat(s, "y");
if (crc32("aTDAFJzZYj",10) == 3578759620) strcat(s, "n");
if (crc32("ZVOVSAybqe",10) == 1163750495) strcat(s, "d");
if (crc32("FIczQepxUP",10) == 2159850765) strcat(s, "Z");
if (crc32("iuIFvhpS",8) == 1056928088) strcat(s, "e");
if (crc32("NZmnUKoMqD",10) == 990958267) strcat(s, "d");
if (crc32("SvbWEUWxe",9) == 212748251) strcat(s, "K");
if (crc32("gycMBnkhpACq",12) == 705453959) strcat(s, "l");
if (crc32("gxCVFy",6) == 1808259103) strcat(s, "M");
if (crc32("EnMJVGxoAm",10) == 1514015699) strcat(s, "y");
    return s;
}

char *Arcadianly_adverbs() {
    char *s = calloc(11);
    if (crc32("vslvzcsfefGEwCY",15) == 127773671) strcat(s, "g");
if (crc32("DzXYWFeqYIzqOnH",15) == 4013725474) strcat(s, "A");
if (crc32("fpTzwUnhIbDn",12) == 3831222513) strcat(s, "u");
if (crc32("ziyiQmMyTNrue",13) == 993133509) strcat(s, "r");
if (crc32("wnUcyrzp",8) == 1584945129) strcat(s, "c");
if (crc32("WwKQXXAHjCxnE",13) == 1003995965) strcat(s, "a");
if (crc32("KtECtboBURMrC",13) == 1567838659) strcat(s, "p");
if (crc32("igpVBaFs",8) == 1338103964) strcat(s, "d");
if (crc32("DhdOAvnoVAq",11) == 178238170) strcat(s, "p");
if (crc32("HxoPMxknc",9) == 3895021038) strcat(s, "i");
if (crc32("HWLHwOYU",8) == 1396227298) strcat(s, "y");
if (crc32("cyfNibRFglQpPZP",15) == 3805867592) strcat(s, "a");
if (crc32("jmveP",5) == 1721970879) strcat(s, "Q");
if (crc32("xjNEwepRBsE",11) == 101979089) strcat(s, "n");
if (crc32("AluwBgeBPRHDy",13) == 289062543) strcat(s, "S");
if (crc32("HIPsZt",6) == 2376911562) strcat(s, "l");
if (crc32("JmpwPjhPJ",9) == 838985639) strcat(s, "q");
if (crc32("RsHeVjDAiZLsC",13) == 4173666383) strcat(s, "y");
    return s;
}

char *constantly_adverbs() {
    char *s = calloc(11);
    if (crc32("KVEzjF",6) == 2396313393) strcat(s, "W");
if (crc32("qLjAXq",6) == 2619124969) strcat(s, "c");
if (crc32("sBMxUieHkIhri",13) == 3655109889) strcat(s, "I");
if (crc32("WJDzqWHBzP",10) == 3480820711) strcat(s, "o");
if (crc32("jZhkhQwoCPWA",12) == 2773939389) strcat(s, "m");
if (crc32("wCXMJUHVKKjHLna",15) == 19965457) strcat(s, "n");
if (crc32("LwDmj",5) == 2809029312) strcat(s, "s");
if (crc32("DykPWoucPIzqMP",14) == 892168263) strcat(s, "t");
if (crc32("ljRPFsUpM",9) == 1185751071) strcat(s, "a");
if (crc32("gDmJY",5) == 437278447) strcat(s, "f");
if (crc32("TpOZkLuBGpmP",12) == 2897943131) strcat(s, "n");
if (crc32("yeukhh",6) == 974354749) strcat(s, "t");
if (crc32("ZBrcMjPar",9) == 2491651835) strcat(s, "z");
if (crc32("bqJeXZuEFd",10) == 3835812221) strcat(s, "l");
if (crc32("XEgoRTzlYeVDVQ",14) == 3747558134) strcat(s, "a");
if (crc32("enKbBAVy",8) == 632347783) strcat(s, "y");
    return s;
}

char *overenviously_adverbs() {
    char *s = calloc(14);
    if (crc32("CRCvLSTupM",10) == 3559363747) strcat(s, "o");
if (crc32("ktotiDxWUiurm",13) == 2759513883) strcat(s, "v");
if (crc32("fcOJcsOFfzLQmAL",15) == 1207520110) strcat(s, "e");
if (crc32("AobEEfQN",8) == 4203759457) strcat(s, "r");
if (crc32("LsUAysVRW",9) == 3512879448) strcat(s, "e");
if (crc32("MeZZmlIMkpj",11) == 220169083) strcat(s, "n");
if (crc32("pcOSYYd",7) == 2493273427) strcat(s, "Q");
if (crc32("JxqGZSDJuEHI",12) == 190422314) strcat(s, "v");
if (crc32("vOYXw",5) == 1710105276) strcat(s, "G");
if (crc32("ZLUmEJDWdyen",12) == 1103268348) strcat(s, "i");
if (crc32("JieyhhvOeMYAt",13) == 2104080679) strcat(s, "n");
if (crc32("FFUgicOhqnfA",12) == 2085180315) strcat(s, "o");
if (crc32("mDTiPTGfztIouV",14) == 233052719) strcat(s, "u");
if (crc32("lpzZlsBndlUdR",13) == 2222062656) strcat(s, "S");
if (crc32("NVafzZskTdFVWwL",15) == 3326202428) strcat(s, "s");
if (crc32("krZeBRuz",8) == 3543011027) strcat(s, "l");
if (crc32("rSHIXAKk",8) == 4105826535) strcat(s, "H");
if (crc32("kymyaKpH",8) == 2039884373) strcat(s, "y");
    return s;
}

char *complimentingly_adverbs() {
    char *s = calloc(16);
    if (crc32("FSTYSk",6) == 2072299076) strcat(s, "c");
if (crc32("DIAVyh",6) == 3018488166) strcat(s, "u");
if (crc32("SywIc",5) == 186128235) strcat(s, "o");
if (crc32("dUAQj",5) == 719684484) strcat(s, "R");
if (crc32("vxZMI",5) == 902236443) strcat(s, "m");
if (crc32("KXuCX",5) == 191289011) strcat(s, "p");
if (crc32("foCMZVcSME",10) == 2791700749) strcat(s, "L");
if (crc32("uKFVB",5) == 3139529858) strcat(s, "l");
if (crc32("dYMgMKeld",9) == 3158297685) strcat(s, "i");
if (crc32("CnkGwwxFGe",10) == 1165227655) strcat(s, "J");
if (crc32("rUZEwkFEuCdy",12) == 3762111097) strcat(s, "m");
if (crc32("jFXzZpu",7) == 154252917) strcat(s, "e");
if (crc32("RQnSXPAPOd",10) == 3624922447) strcat(s, "v");
if (crc32("JPDtIyqJic",10) == 3207557311) strcat(s, "n");
if (crc32("MreGuuFdQdhJi",13) == 2401841486) strcat(s, "D");
if (crc32("WGTuhpWCrJdh",12) == 3656617747) strcat(s, "t");
if (crc32("qwSUSHJ",7) == 2187824761) strcat(s, "i");
if (crc32("CLyafZIqEDJuXBD",15) == 4028275064) strcat(s, "n");
if (crc32("rzvQHgQ",7) == 3617563547) strcat(s, "i");
if (crc32("yzFUS",5) == 2010869110) strcat(s, "g");
if (crc32("vYLsmBTSbyX",11) == 1003216969) strcat(s, "J");
if (crc32("bhkEnWxhZUtUKY",14) == 3659536676) strcat(s, "l");
if (crc32("TSAGFcbSB",9) == 45499806) strcat(s, "w");
if (crc32("yGNiqFHsmtc",11) == 378165297) strcat(s, "y");
    return s;
}

char *initiatively_adverbs() {
    char *s = calloc(13);
    if (crc32("OzJUzJQUdAJxL",13) == 341043496) strcat(s, "F");
if (crc32("YZTYRqkNZHB",11) == 2211560740) strcat(s, "i");
if (crc32("kEVotqTUmkNb",12) == 2818218333) strcat(s, "s");
if (crc32("XTXACnjnYBrvJ",13) == 1405391892) strcat(s, "n");
if (crc32("zYqiGwW",7) == 2630732017) strcat(s, "i");
if (crc32("uiksGZk",7) == 1951310085) strcat(s, "t");
if (crc32("uDjSnhQd",8) == 2470992684) strcat(s, "i");
if (crc32("bJZeIWOCBj",10) == 533462577) strcat(s, "I");
if (crc32("bIiJnMK",7) == 789134089) strcat(s, "a");
if (crc32("hTIevRwlJXgKtbC",15) == 2683894970) strcat(s, "Y");
if (crc32("OKvptRXPco",10) == 1964212113) strcat(s, "t");
if (crc32("gxsUufmzDUOXCy",14) == 2313271204) strcat(s, "i");
if (crc32("hWPbnUuZRgSRfpN",15) == 3137445923) strcat(s, "v");
if (crc32("EinvoCyU",8) == 2860044955) strcat(s, "e");
if (crc32("KDojhpUbDYSDclM",15) == 2956046414) strcat(s, "x");
if (crc32("JdTBtbae",8) == 4187672518) strcat(s, "l");
if (crc32("eUFEGUin",8) == 3075971456) strcat(s, "y");
    return s;
}

char *polemically_adverbs() {
    char *s = calloc(12);
    if (crc32("sRlPBFq",7) == 1683675485) strcat(s, "p");
if (crc32("YEiLR",5) == 3242472150) strcat(s, "o");
if (crc32("NxGcdHg",7) == 163696712) strcat(s, "l");
if (crc32("rXWYXpRviRe",11) == 2726186261) strcat(s, "y");
if (crc32("BAnTnpAOsgtLtA",14) == 24869209) strcat(s, "e");
if (crc32("qxnLWjkeNcgY",12) == 2804886576) strcat(s, "g");
if (crc32("tixGoUwuPCWaih",14) == 2374227822) strcat(s, "m");
if (crc32("fsSEUIOY",8) == 2413053391) strcat(s, "B");
if (crc32("nMJxnFU",7) == 3061879357) strcat(s, "i");
if (crc32("wUBilwQZ",8) == 1824054586) strcat(s, "c");
if (crc32("XLFGAvJBBEFJ",12) == 633266765) strcat(s, "a");
if (crc32("KECPHfOJS",9) == 1461908613) strcat(s, "l");
if (crc32("uexOxHQrvDyFj",13) == 1942315733) strcat(s, "l");
if (crc32("fbpFKDC",7) == 1888753620) strcat(s, "y");
    return s;
}

char *equilaterally_adverbs() {
    char *s = calloc(14);
    if (crc32("HZdDNWsxIzqWM",13) == 2894146953) strcat(s, "U");
if (crc32("qzUKMcbtGTA",11) == 4290313140) strcat(s, "e");
if (crc32("dlcNDaKSqgDy",12) == 2669834038) strcat(s, "q");
if (crc32("AGVGA",5) == 1850957330) strcat(s, "Y");
if (crc32("cJCfFj",6) == 3814636603) strcat(s, "u");
if (crc32("JxjNabgdHKNti",13) == 3185949660) strcat(s, "i");
if (crc32("GlquuY",6) == 1041959066) strcat(s, "l");
if (crc32("eFNpn",5) == 3602816418) strcat(s, "a");
if (crc32("QjrTaitBMAQbPGM",15) == 2411474660) strcat(s, "t");
if (crc32("yBHqWcXdKjNJhi",14) == 2937944002) strcat(s, "e");
if (crc32("LDVhOvVS",8) == 1430857938) strcat(s, "r");
if (crc32("IkiYFQoLapvI",12) == 4179000377) strcat(s, "a");
if (crc32("MWsqjvNxPn",10) == 3420853457) strcat(s, "l");
if (crc32("OjEzfJZyNhZ",11) == 1070109258) strcat(s, "l");
if (crc32("QwlxG",5) == 2066390218) strcat(s, "l");
if (crc32("SIIkMpep",8) == 3702325360) strcat(s, "y");
    return s;
}

char *impishly_adverbs() {
    char *s = calloc(9);
    if (crc32("cdivXjtnbTMQqnt",15) == 2661761564) strcat(s, "i");
if (crc32("xYMkRn",6) == 1825264669) strcat(s, "m");
if (crc32("sPndIfBmbvvZ",12) == 868265069) strcat(s, "w");
if (crc32("mxUTFoVdd",9) == 1173055445) strcat(s, "p");
if (crc32("rzBbzVktndS",11) == 1740807703) strcat(s, "i");
if (crc32("FawqxPFau",9) == 1136969385) strcat(s, "N");
if (crc32("foiTfQ",6) == 1985822430) strcat(s, "s");
if (crc32("guzVswbTbImnZY",14) == 3302430397) strcat(s, "h");
if (crc32("KkmVivObsy",10) == 1111526690) strcat(s, "t");
if (crc32("YQYEVMTYmv",10) == 2876971465) strcat(s, "l");
if (crc32("leuXgzUPW",9) == 3635650493) strcat(s, "s");
if (crc32("ZjpnBWPa",8) == 2076328760) strcat(s, "y");
    return s;
}

char *colourlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("WXLFoKMb",8) == 2083738064) strcat(s, "c");
if (crc32("xLxxJCjHRbaIojs",15) == 1661547626) strcat(s, "o");
if (crc32("POgGGmtLWcV",11) == 716117269) strcat(s, "l");
if (crc32("EOjlvyXTyqY",11) == 4214028361) strcat(s, "V");
if (crc32("YPAnx",5) == 3973320149) strcat(s, "o");
if (crc32("QAjVEV",6) == 774168355) strcat(s, "C");
if (crc32("tucbLWXDOQByYbL",15) == 2884712251) strcat(s, "u");
if (crc32("WJkTYqHFnAj",11) == 440629798) strcat(s, "r");
if (crc32("osQwKJ",6) == 1578411718) strcat(s, "v");
if (crc32("qIabhIJSMHIl",12) == 1412069600) strcat(s, "l");
if (crc32("duChNREinc",10) == 762401974) strcat(s, "e");
if (crc32("eUmsVtaevSy",11) == 1107816328) strcat(s, "j");
if (crc32("FptwUxYv",8) == 3386327884) strcat(s, "s");
if (crc32("RIlDympGqJOMxvI",15) == 2953115913) strcat(s, "s");
if (crc32("XArFkGHilVTUURo",15) == 1908358555) strcat(s, "b");
if (crc32("MDShyqMQbshyx",13) == 1203201380) strcat(s, "l");
if (crc32("uZvaOIhmmvs",11) == 3554998782) strcat(s, "C");
if (crc32("mCxVTOnV",8) == 1305628864) strcat(s, "y");
    return s;
}

char *supplementally_adverbs() {
    char *s = calloc(15);
    if (crc32("PzxZOjEJvK",10) == 1729943234) strcat(s, "G");
if (crc32("fPvTuHytleXYo",13) == 379542211) strcat(s, "s");
if (crc32("EaLzDdm",7) == 2490841781) strcat(s, "u");
if (crc32("HagyAPSIj",9) == 1271753226) strcat(s, "G");
if (crc32("yoWnv",5) == 2051946723) strcat(s, "p");
if (crc32("TJscBbd",7) == 643313055) strcat(s, "z");
if (crc32("BYLIDlBnu",9) == 2205466477) strcat(s, "p");
if (crc32("KEUKkOkSS",9) == 333960655) strcat(s, "z");
if (crc32("NPTQekwRiXHV",12) == 3565743613) strcat(s, "l");
if (crc32("hRZZqWppFfO",11) == 4185615729) strcat(s, "H");
if (crc32("pRIFfPnRRYC",11) == 4261263512) strcat(s, "e");
if (crc32("YMmBlvgLSc",10) == 2194976699) strcat(s, "m");
if (crc32("XvezBE",6) == 2851544642) strcat(s, "b");
if (crc32("twoCxVJbayX",11) == 1095054767) strcat(s, "e");
if (crc32("XxDDJ",5) == 356908279) strcat(s, "n");
if (crc32("cwXoMcmuiuDk",12) == 233203122) strcat(s, "t");
if (crc32("fUwVznbfwjVtfhu",15) == 967858115) strcat(s, "e");
if (crc32("qeiDMoYFVT",10) == 2034536330) strcat(s, "a");
if (crc32("usdVW",5) == 3635071657) strcat(s, "l");
if (crc32("KPiqLbVBOimu",12) == 1711452841) strcat(s, "l");
if (crc32("CxflALYpqKyNKYV",15) == 2197495899) strcat(s, "y");
    return s;
}

char *felly_adverbs() {
    char *s = calloc(6);
    if (crc32("UKNMPWYQ",8) == 3356871204) strcat(s, "Q");
if (crc32("ZlxkCupJyOQczBS",15) == 4097547378) strcat(s, "f");
if (crc32("flhaLXB",7) == 892418989) strcat(s, "k");
if (crc32("xrmXchoIYyazfUX",15) == 204996309) strcat(s, "e");
if (crc32("ihpBMFwpoOs",11) == 943965514) strcat(s, "l");
if (crc32("OWFCLFpeHHGlBeo",15) == 3489179025) strcat(s, "l");
if (crc32("mTGZbUknQKcrw",13) == 739251804) strcat(s, "y");
    return s;
}

char *gleamingly_adverbs() {
    char *s = calloc(11);
    if (crc32("jvBSZOZkICUdnm",14) == 3612016787) strcat(s, "v");
if (crc32("dIHkPxA",7) == 3303482350) strcat(s, "g");
if (crc32("IueRhfhBWaW",11) == 3382971505) strcat(s, "l");
if (crc32("dcddVjVn",8) == 2579960724) strcat(s, "e");
if (crc32("Dycaxmv",7) == 1876604909) strcat(s, "a");
if (crc32("yrwyYNNSEViLupJ",15) == 2127734457) strcat(s, "r");
if (crc32("uFjEpxGku",9) == 1198920972) strcat(s, "m");
if (crc32("ghWZICtev",9) == 3090479593) strcat(s, "i");
if (crc32("eagitlkD",8) == 51588691) strcat(s, "n");
if (crc32("WANWaaWo",8) == 1783007048) strcat(s, "F");
if (crc32("EAqPsRWYCxf",11) == 2651158588) strcat(s, "g");
if (crc32("yuJNmIsND",9) == 1171401407) strcat(s, "l");
if (crc32("pnCLVpJYi",9) == 3204284672) strcat(s, "M");
if (crc32("QKxMm",5) == 2742213407) strcat(s, "y");
    return s;
}

char *aversely_adverbs() {
    char *s = calloc(9);
    if (crc32("nXUBzqK",7) == 2922965842) strcat(s, "M");
if (crc32("AVzGXGPsxu",10) == 2142985118) strcat(s, "a");
if (crc32("ufUGSlxRiDSCaQ",14) == 234230180) strcat(s, "P");
if (crc32("BUegbYUPgFNi",12) == 1762223533) strcat(s, "v");
if (crc32("zriHzqRFFA",10) == 3088342780) strcat(s, "e");
if (crc32("lsWIRWF",7) == 1688128416) strcat(s, "i");
if (crc32("XWIAhoB",7) == 3605366989) strcat(s, "r");
if (crc32("VgJKYhqRPNyNTGZ",15) == 1163026110) strcat(s, "D");
if (crc32("NiapGkuCkMyVOVU",15) == 1113089263) strcat(s, "s");
if (crc32("bzmuIDj",7) == 1351023439) strcat(s, "e");
if (crc32("OlsfsyBvRsz",11) == 2713063696) strcat(s, "S");
if (crc32("YclLvOSVJfRk",12) == 4016510814) strcat(s, "l");
if (crc32("lTrMpQFMUDJMEXX",15) == 1190107031) strcat(s, "r");
if (crc32("RDoeAzVZhVhIVo",14) == 4067915072) strcat(s, "y");
    return s;
}

char *overboastfully_adverbs() {
    char *s = calloc(15);
    if (crc32("caMlDDPdu",9) == 3297324061) strcat(s, "G");
if (crc32("IAFpxdsXArDzFm",14) == 920772656) strcat(s, "o");
if (crc32("ksLXfBltBUUHF",13) == 1223118941) strcat(s, "v");
if (crc32("zgOJtBrK",8) == 2443851010) strcat(s, "e");
if (crc32("AhxxdODZSJqsS",13) == 611597772) strcat(s, "r");
if (crc32("qFPFaxZg",8) == 1613426056) strcat(s, "O");
if (crc32("WmjbMFSeUpEm",12) == 1149417270) strcat(s, "b");
if (crc32("vvaRgoDoFI",10) == 4112080500) strcat(s, "m");
if (crc32("RKthX",5) == 1401441391) strcat(s, "o");
if (crc32("dTuLayhiQnLWK",13) == 703302798) strcat(s, "a");
if (crc32("wytgDgR",7) == 3932622019) strcat(s, "s");
if (crc32("nwFXYxQoRe",10) == 2126613373) strcat(s, "T");
if (crc32("FhOOqdEwaCEJZPy",15) == 3214068169) strcat(s, "t");
if (crc32("HLOdMeVPkv",10) == 291951152) strcat(s, "o");
if (crc32("CsIWn",5) == 2151738229) strcat(s, "f");
if (crc32("xOjbmUECRRrmt",13) == 378610981) strcat(s, "u");
if (crc32("xEblltTe",8) == 146260006) strcat(s, "h");
if (crc32("RhdRNevuDsNoZtc",15) == 3272369016) strcat(s, "l");
if (crc32("uricnlVUADsD",12) == 2841392221) strcat(s, "S");
if (crc32("GyBuvHQNaS",10) == 617436364) strcat(s, "l");
if (crc32("wkRWJ",5) == 1832657411) strcat(s, "y");
    return s;
}

char *hypermagically_adverbs() {
    char *s = calloc(15);
    if (crc32("NBWozkpk",8) == 2871722731) strcat(s, "c");
if (crc32("qUFVijlRbNjHp",13) == 1331568185) strcat(s, "h");
if (crc32("VyqXNCUrrsZbZJu",15) == 4119281444) strcat(s, "X");
if (crc32("DNUCGyzCDNQp",12) == 104409724) strcat(s, "y");
if (crc32("WWBxFUChtzSkg",13) == 1840289223) strcat(s, "D");
if (crc32("xFLQBjisAt",10) == 1871545180) strcat(s, "p");
if (crc32("BVqjav",6) == 390215503) strcat(s, "e");
if (crc32("ogGPqXpVtlir",12) == 1158791748) strcat(s, "D");
if (crc32("WSFXumlbWgqsnb",14) == 4216351228) strcat(s, "r");
if (crc32("wVYldc",6) == 844384924) strcat(s, "m");
if (crc32("gPPKQXuzLODIb",13) == 2465832162) strcat(s, "Z");
if (crc32("TWorDwVNQZjuxGb",15) == 3740006858) strcat(s, "a");
if (crc32("ouMAjTiFn",9) == 2020210215) strcat(s, "Z");
if (crc32("vhKkSri",7) == 1928002659) strcat(s, "g");
if (crc32("hHTQb",5) == 1516851534) strcat(s, "i");
if (crc32("axWRgBhB",8) == 957644446) strcat(s, "r");
if (crc32("SEsCcLXI",8) == 388771397) strcat(s, "c");
if (crc32("ajJJCTrNNQze",12) == 832028321) strcat(s, "n");
if (crc32("qYLxQZcq",8) == 2045065589) strcat(s, "a");
if (crc32("RwPneBYBavpd",12) == 1177547700) strcat(s, "l");
if (crc32("HqMFZiNqZVg",11) == 480961583) strcat(s, "l");
if (crc32("pzjkXKGFqOmJd",13) == 47326802) strcat(s, "l");
if (crc32("hyHlPfzM",8) == 3516651078) strcat(s, "q");
if (crc32("SCXxmOC",7) == 2018395004) strcat(s, "y");
    return s;
}

char *unbribably_adverbs() {
    char *s = calloc(11);
    if (crc32("fICcjI",6) == 1773047663) strcat(s, "u");
if (crc32("WEKumhrLlnNfjai",15) == 2671718456) strcat(s, "O");
if (crc32("czfwr",5) == 2384327371) strcat(s, "n");
if (crc32("sfgLqOWx",8) == 529378407) strcat(s, "c");
if (crc32("XpuBONMzubzaODC",15) == 456369374) strcat(s, "b");
if (crc32("gwDAv",5) == 2480737062) strcat(s, "B");
if (crc32("avqFjscMNpNqobt",15) == 2525649501) strcat(s, "r");
if (crc32("sKIoEyjMoPPbq",13) == 3008524874) strcat(s, "i");
if (crc32("QkhnreoC",8) == 3568939600) strcat(s, "L");
if (crc32("jabLPDvhFYIdCe",14) == 256876886) strcat(s, "b");
if (crc32("NBkceiSRC",9) == 2320159701) strcat(s, "W");
if (crc32("kIscHcODJGLXN",13) == 2234941745) strcat(s, "a");
if (crc32("VHxVEUT",7) == 144085847) strcat(s, "T");
if (crc32("rfwctbtnUNI",11) == 1521208351) strcat(s, "b");
if (crc32("TvRIoqKAE",9) == 4235669195) strcat(s, "g");
if (crc32("gXHtotbVN",9) == 1987459621) strcat(s, "l");
if (crc32("TvlCKPQaATAy",12) == 4017555303) strcat(s, "S");
if (crc32("ztSAanMUTSgv",12) == 1563118437) strcat(s, "y");
    return s;
}

char *doubly_adverbs() {
    char *s = calloc(7);
    if (crc32("NsUeCe",6) == 3871452801) strcat(s, "q");
if (crc32("hYDIRYqiYLN",11) == 3266267432) strcat(s, "d");
if (crc32("PrKZfRTrdeexWUz",15) == 3699249046) strcat(s, "o");
if (crc32("wlyDujuVrN",10) == 2126764327) strcat(s, "u");
if (crc32("Yvlul",5) == 3941873507) strcat(s, "b");
if (crc32("FcwxKupJURN",11) == 2950301086) strcat(s, "z");
if (crc32("TCQpGPnff",9) == 348408709) strcat(s, "l");
if (crc32("REHxX",5) == 1657314267) strcat(s, "V");
if (crc32("UDpyq",5) == 2947126153) strcat(s, "y");
    return s;
}

char *helluva_adverbs() {
    char *s = calloc(8);
    if (crc32("CrBuUSdZxcl",11) == 163976347) strcat(s, "o");
if (crc32("KuQRkmgqikxobMl",15) == 975336309) strcat(s, "h");
if (crc32("nsHlhQ",6) == 2473301965) strcat(s, "e");
if (crc32("rmqwOwjsgdG",11) == 37774659) strcat(s, "l");
if (crc32("TQeRIdXdhH",10) == 2073121403) strcat(s, "j");
if (crc32("wrECrbqfJ",9) == 3789677740) strcat(s, "l");
if (crc32("KiTdwDnZaU",10) == 401614019) strcat(s, "B");
if (crc32("KfWSjr",6) == 3675712814) strcat(s, "u");
if (crc32("mtkHfC",6) == 1193708377) strcat(s, "v");
if (crc32("QXHrWnyTDEOdZ",13) == 1285294269) strcat(s, "A");
if (crc32("IvWdOOGotbAil",13) == 3792968826) strcat(s, "a");
    return s;
}

char *micrometrically_adverbs() {
    char *s = calloc(16);
    if (crc32("aYqxheHsEc",10) == 1492428580) strcat(s, "m");
if (crc32("iXvwzNlwnzgqoWD",15) == 2801807749) strcat(s, "R");
if (crc32("OXjiFIrqucs",11) == 149354299) strcat(s, "i");
if (crc32("YGrtDadqeee",11) == 3939294763) strcat(s, "B");
if (crc32("bbNjfMOct",9) == 2793111011) strcat(s, "c");
if (crc32("gHLyPETZF",9) == 2876428876) strcat(s, "r");
if (crc32("FYwqzbS",7) == 898003809) strcat(s, "r");
if (crc32("wWLteQLJggR",11) == 1650303432) strcat(s, "o");
if (crc32("dLUrW",5) == 4179882605) strcat(s, "m");
if (crc32("OmZsUCzdqMz",11) == 2428371835) strcat(s, "e");
if (crc32("nLnBWrvtw",9) == 197669542) strcat(s, "t");
if (crc32("CwtOWYKuZeWbB",13) == 3886225044) strcat(s, "r");
if (crc32("vxSRd",5) == 2996002943) strcat(s, "i");
if (crc32("VzLbyaJrBj",10) == 4035111078) strcat(s, "Z");
if (crc32("jsfIVbPTv",9) == 3772501142) strcat(s, "c");
if (crc32("ZsQBXrJYg",9) == 1113251278) strcat(s, "J");
if (crc32("FPhEr",5) == 2942133406) strcat(s, "a");
if (crc32("AHbddoYeu",9) == 3461809356) strcat(s, "T");
if (crc32("dqkcenxIYd",10) == 1708973018) strcat(s, "l");
if (crc32("ycFDOiCiOkiSyUC",15) == 3263538760) strcat(s, "g");
if (crc32("QUQttdqkWXCOjfV",15) == 1652777717) strcat(s, "l");
if (crc32("TPUlnzZte",9) == 2808804788) strcat(s, "y");
    return s;
}

char *prealphabetically_adverbs() {
    char *s = calloc(18);
    if (crc32("gHKbT",5) == 1756788982) strcat(s, "n");
if (crc32("mOpyIB",6) == 1451054348) strcat(s, "p");
if (crc32("JtxMIXfFdE",10) == 1658673897) strcat(s, "T");
if (crc32("ESxGkLcqjRw",11) == 151920352) strcat(s, "r");
if (crc32("YjwTeyYdn",9) == 3219323569) strcat(s, "O");
if (crc32("jNERBvDScmPq",12) == 3806729339) strcat(s, "e");
if (crc32("OvQvIQNQAC",10) == 308646567) strcat(s, "m");
if (crc32("afABBMjtEG",10) == 1146345010) strcat(s, "a");
if (crc32("DifJAbqWGhp",11) == 2123208462) strcat(s, "d");
if (crc32("rJqlgSvgpTvw",12) == 2909472623) strcat(s, "l");
if (crc32("UtjwaiUihG",10) == 1032864945) strcat(s, "G");
if (crc32("gWxoQ",5) == 520176825) strcat(s, "p");
if (crc32("SoQnwWHQQWWRDr",14) == 1115643195) strcat(s, "f");
if (crc32("xPXLBjPvx",9) == 2908487394) strcat(s, "h");
if (crc32("gkjpGZHBe",9) == 3088274931) strcat(s, "a");
if (crc32("mKMRnVlBy",9) == 964124330) strcat(s, "b");
if (crc32("VNqMwuOWWhqpJ",13) == 1623185660) strcat(s, "e");
if (crc32("RKMGTsmE",8) == 2835708339) strcat(s, "t");
if (crc32("Gaipl",5) == 2203469576) strcat(s, "i");
if (crc32("olzkvBa",7) == 1751633044) strcat(s, "c");
if (crc32("DSIjNxkJR",9) == 1142649819) strcat(s, "a");
if (crc32("cZYILeqqmUai",12) == 3254453901) strcat(s, "l");
if (crc32("aEZhOWWAlocBzla",15) == 82570127) strcat(s, "Q");
if (crc32("HfLsEFYbE",9) == 2275804466) strcat(s, "l");
if (crc32("CYaAxy",6) == 466647389) strcat(s, "P");
if (crc32("SneBFnJbqKpR",12) == 2305034779) strcat(s, "y");
    return s;
}

char *unresiliently_adverbs() {
    char *s = calloc(14);
    if (crc32("vUHsHfYOVUsVx",13) == 3920501003) strcat(s, "u");
if (crc32("HDyHHmU",7) == 1643655839) strcat(s, "u");
if (crc32("iJDpTHjEBwABPH",14) == 3754993455) strcat(s, "j");
if (crc32("wTGWXcZYt",9) == 1330253967) strcat(s, "n");
if (crc32("okDqLzcJYIcc",12) == 3678654236) strcat(s, "r");
if (crc32("vAgyorSBrcm",11) == 802347923) strcat(s, "E");
if (crc32("VaglUZTaudeMkj",14) == 4151716273) strcat(s, "e");
if (crc32("pWgEJnPvhZzv",12) == 1138955143) strcat(s, "s");
if (crc32("gAsrLHVB",8) == 1440701123) strcat(s, "c");
if (crc32("CqSJsHfTNynh",12) == 3303170365) strcat(s, "i");
if (crc32("XrQtssbeniYAg",13) == 1580091496) strcat(s, "q");
if (crc32("YnWdNyEt",8) == 1937152842) strcat(s, "l");
if (crc32("CVqeVnSjhfgN",12) == 1898556344) strcat(s, "v");
if (crc32("aXmBVvVDLkuwRe",14) == 2448806150) strcat(s, "i");
if (crc32("yLOlzDGPOeWMBu",14) == 2876282317) strcat(s, "e");
if (crc32("TOWHxrpP",8) == 3266252877) strcat(s, "n");
if (crc32("NjxnhBQNzPZC",12) == 1459084031) strcat(s, "t");
if (crc32("lrsVtIsAgrj",11) == 2048698442) strcat(s, "U");
if (crc32("TEUdYyAM",8) == 2661703900) strcat(s, "l");
if (crc32("gMpbcrVZBzUef",13) == 287527178) strcat(s, "y");
if (crc32("QHtoJrZoxpXo",12) == 3962625197) strcat(s, "y");
    return s;
}

char *botchedly_adverbs() {
    char *s = calloc(10);
    if (crc32("ROCXcEutFLX",11) == 955769851) strcat(s, "b");
if (crc32("CsrSitoJhUGWFT",14) == 440193785) strcat(s, "o");
if (crc32("iYvBwCcfPrg",11) == 799095046) strcat(s, "t");
if (crc32("prkvJ",5) == 1428696570) strcat(s, "c");
if (crc32("oAplwFyLu",9) == 2495033201) strcat(s, "s");
if (crc32("qbDxx",5) == 1561603590) strcat(s, "h");
if (crc32("oGGbiDUT",8) == 2258475289) strcat(s, "e");
if (crc32("wuWqmQQrKWp",11) == 3941705060) strcat(s, "d");
if (crc32("tPyGQW",6) == 741342638) strcat(s, "l");
if (crc32("pxvrUxHVIooDg",13) == 2873127291) strcat(s, "y");
    return s;
}

char *pseudocritically_adverbs() {
    char *s = calloc(17);
    if (crc32("QsdpVs",6) == 1952935871) strcat(s, "a");
if (crc32("OezCFOBzdJqpXk",14) == 1273264563) strcat(s, "p");
if (crc32("OPMekXmXq",9) == 987041402) strcat(s, "s");
if (crc32("MFRaOVFRQbOvbu",14) == 2386838837) strcat(s, "e");
if (crc32("nQWOSMspA",9) == 327137911) strcat(s, "F");
if (crc32("kvPiQRzsWnOELcn",15) == 2583243859) strcat(s, "u");
if (crc32("ipWRzQSt",8) == 3930757618) strcat(s, "N");
if (crc32("kEdgiPZmvTIaD",13) == 1265669074) strcat(s, "d");
if (crc32("ohoUygdwNOh",11) == 1280368025) strcat(s, "o");
if (crc32("pWdBhkrZjJjsvP",14) == 2187277778) strcat(s, "m");
if (crc32("SrTCccciqfYKy",13) == 3813026121) strcat(s, "c");
if (crc32("QCAajBhZNijWqp",14) == 425182744) strcat(s, "r");
if (crc32("KzMICdMxz",9) == 1448631982) strcat(s, "r");
if (crc32("wHJwVS",6) == 1962062658) strcat(s, "i");
if (crc32("UhjcZD",6) == 1468869145) strcat(s, "S");
if (crc32("TMUIGSzxyVNIDZi",15) == 2317564133) strcat(s, "t");
if (crc32("xxbVzzNSbk",10) == 472232513) strcat(s, "V");
if (crc32("eByAFglCXTJ",11) == 2755966494) strcat(s, "i");
if (crc32("Gfmwf",5) == 3055331508) strcat(s, "c");
if (crc32("oxpWNpnXybrD",12) == 3733275846) strcat(s, "S");
if (crc32("yzecTImzN",9) == 4282591722) strcat(s, "a");
if (crc32("vwbWOxWXLUTP",12) == 333615806) strcat(s, "J");
if (crc32("EiTzkvqksrdvVZC",15) == 2544743061) strcat(s, "l");
if (crc32("YuTbAxGBkYtPub",14) == 739420271) strcat(s, "l");
if (crc32("wenWjXnOR",9) == 1295308291) strcat(s, "y");
    return s;
}

char *punctatim_adverbs() {
    char *s = calloc(10);
    if (crc32("IjkQBirveHE",11) == 2509460242) strcat(s, "y");
if (crc32("XuHBRfIJRmjb",12) == 1795879634) strcat(s, "p");
if (crc32("VRsJXv",6) == 1454541913) strcat(s, "v");
if (crc32("QKjDZnyFP",9) == 1944746243) strcat(s, "u");
if (crc32("XIsBRS",6) == 2071075699) strcat(s, "C");
if (crc32("EIXNvyTgHAr",11) == 3132995103) strcat(s, "n");
if (crc32("fSTJaPEpCqrla",13) == 3222269751) strcat(s, "c");
if (crc32("uVcyWrrVigFw",12) == 2277386589) strcat(s, "t");
if (crc32("JYlhxADfFT",10) == 1916589979) strcat(s, "m");
if (crc32("XbyrEUTFPck",11) == 252557783) strcat(s, "a");
if (crc32("MKeUxcBztQTJ",12) == 3688219948) strcat(s, "v");
if (crc32("Bnzju",5) == 3656619804) strcat(s, "t");
if (crc32("pqhfPeuXT",9) == 1745979456) strcat(s, "i");
if (crc32("kqLlFXHSYohg",12) == 3412368901) strcat(s, "m");
    return s;
}

char *nonextricably_adverbs() {
    char *s = calloc(14);
    if (crc32("HCWBms",6) == 1526072429) strcat(s, "V");
if (crc32("cefbkDZ",7) == 2743057568) strcat(s, "n");
if (crc32("NhYRSkbDgwWKkr",14) == 1350150668) strcat(s, "N");
if (crc32("sTnyzoCaDEtOq",13) == 3882281210) strcat(s, "o");
if (crc32("wtrDKlTWyzOir",13) == 1115742141) strcat(s, "n");
if (crc32("ifJipI",6) == 3488681564) strcat(s, "U");
if (crc32("ohhjmKKBLN",10) == 1644110658) strcat(s, "e");
if (crc32("haOMg",5) == 20796601) strcat(s, "x");
if (crc32("shhIEu",6) == 2334483785) strcat(s, "F");
if (crc32("vGGUUgweyJ",10) == 1472870213) strcat(s, "t");
if (crc32("erBMqjLsbgwqX",13) == 3480860652) strcat(s, "t");
if (crc32("muhLZLOxDliKcd",14) == 4026852824) strcat(s, "r");
if (crc32("utQtHqtgFuDM",12) == 510075123) strcat(s, "a");
if (crc32("RQOAnkVsWLYVi",13) == 3241464858) strcat(s, "i");
if (crc32("MRozgesL",8) == 3093712570) strcat(s, "f");
if (crc32("mMmVtcpoosbNgE",14) == 4258842707) strcat(s, "c");
if (crc32("dWPcFkML",8) == 3316497576) strcat(s, "a");
if (crc32("guNjEYnMieo",11) == 2159246757) strcat(s, "i");
if (crc32("oDmeKKzBr",9) == 1011368821) strcat(s, "b");
if (crc32("htQDKwAfk",9) == 2039963770) strcat(s, "l");
if (crc32("lNitfaSkXl",10) == 2159103941) strcat(s, "g");
if (crc32("sYrfYKrqcB",10) == 1622346813) strcat(s, "y");
    return s;
}

char *unwanderingly_adverbs() {
    char *s = calloc(14);
    if (crc32("iRoREsPDOHSNM",13) == 148127888) strcat(s, "j");
if (crc32("kJKrsUf",7) == 1637962833) strcat(s, "u");
if (crc32("RkGXbENK",8) == 2300839715) strcat(s, "n");
if (crc32("oOcKkodpXDl",11) == 321118238) strcat(s, "w");
if (crc32("OxSaTAnEBbimvn",14) == 582381715) strcat(s, "a");
if (crc32("tAfPHUJuBwprB",13) == 890169792) strcat(s, "k");
if (crc32("AHwsThERmJCfSm",14) == 2661633993) strcat(s, "n");
if (crc32("QGuOVrx",7) == 2845681437) strcat(s, "K");
if (crc32("UaHIMlmZrM",10) == 2386786416) strcat(s, "d");
if (crc32("jSXteuqjI",9) == 3161903963) strcat(s, "e");
if (crc32("NkqwqffXa",9) == 2895589344) strcat(s, "b");
if (crc32("VaHxxZCfs",9) == 2398135091) strcat(s, "r");
if (crc32("wtZrVpfFVi",10) == 1955675108) strcat(s, "i");
if (crc32("GExCGzGdNJh",11) == 849459057) strcat(s, "Q");
if (crc32("bxYUKHCGrexNdE",14) == 368719890) strcat(s, "n");
if (crc32("WPypvgILbQiws",13) == 926809872) strcat(s, "l");
if (crc32("ZpAbDrrpzOcFN",13) == 3391278350) strcat(s, "g");
if (crc32("IOlIa",5) == 175444616) strcat(s, "l");
if (crc32("fjdkg",5) == 1699644569) strcat(s, "k");
if (crc32("WfaWpoeqZtvUQ",13) == 2345310814) strcat(s, "y");
    return s;
}

char *hypermiraculously_adverbs() {
    char *s = calloc(18);
    if (crc32("kTonVLEVUUwRr",13) == 230138979) strcat(s, "h");
if (crc32("fecgCEPWWRhrtj",14) == 1899122722) strcat(s, "L");
if (crc32("AANgsqQcZaf",11) == 1229321667) strcat(s, "y");
if (crc32("ftgZXOfTPSPPfbS",15) == 31672547) strcat(s, "p");
if (crc32("cHooBNpz",8) == 2056572820) strcat(s, "e");
if (crc32("yvgOFCidkvShRmV",15) == 2210312992) strcat(s, "r");
if (crc32("aJWOchQFB",9) == 2385741548) strcat(s, "T");
if (crc32("OTmELOqfJQ",10) == 3577903260) strcat(s, "m");
if (crc32("GlcbhyAKtamS",12) == 856004513) strcat(s, "i");
if (crc32("nLudLqT",7) == 459045226) strcat(s, "W");
if (crc32("crvBVKGdvy",10) == 1391547955) strcat(s, "r");
if (crc32("ibfBhQ",6) == 369823055) strcat(s, "E");
if (crc32("ziiMN",5) == 2698713738) strcat(s, "a");
if (crc32("Zkxmt",5) == 1097730995) strcat(s, "n");
if (crc32("gxGZmDon",8) == 4140119244) strcat(s, "c");
if (crc32("SMycTA",6) == 403780667) strcat(s, "u");
if (crc32("MevHYx",6) == 2254339992) strcat(s, "h");
if (crc32("eywmG",5) == 3901906746) strcat(s, "l");
if (crc32("BVphX",5) == 2517826675) strcat(s, "o");
if (crc32("fspSbr",6) == 3167683189) strcat(s, "A");
if (crc32("lCzgBTlHRzXIT",13) == 337702798) strcat(s, "u");
if (crc32("MpspQPUABbaL",12) == 1018033467) strcat(s, "s");
if (crc32("Qmmpjd",6) == 2844222867) strcat(s, "C");
if (crc32("fjrMykqNguPVr",13) == 1231349291) strcat(s, "l");
if (crc32("svMcjfsxTfZlp",13) == 119212757) strcat(s, "E");
if (crc32("DMYvnhfuJHL",11) == 2649133255) strcat(s, "y");
    return s;
}

char *harmlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("LmcvZA",6) == 2426032287) strcat(s, "h");
if (crc32("TpWLLlxUUN",10) == 133823549) strcat(s, "R");
if (crc32("LDJEb",5) == 484982301) strcat(s, "a");
if (crc32("DWryoXPqJub",11) == 3252558893) strcat(s, "r");
if (crc32("cGnPTW",6) == 1240246921) strcat(s, "m");
if (crc32("CSOhkIunWdUR",12) == 791442412) strcat(s, "l");
if (crc32("DKOxJcIbJrjkL",13) == 2109665248) strcat(s, "e");
if (crc32("rvPgYMyuul",10) == 1343956619) strcat(s, "s");
if (crc32("LLkUqEa",7) == 2531547969) strcat(s, "s");
if (crc32("ruIBJAZZbnEvih",14) == 895735609) strcat(s, "l");
if (crc32("yUCgN",5) == 3436170431) strcat(s, "q");
if (crc32("jhkMUWdigkMUh",13) == 29438037) strcat(s, "y");
    return s;
}

char *straightaway_adverbs() {
    char *s = calloc(13);
    if (crc32("sKInpkjkllNXMI",14) == 574292628) strcat(s, "s");
if (crc32("ZAnNqWEMPE",10) == 2009613942) strcat(s, "t");
if (crc32("JqHTzPbknHQxLhW",15) == 1734571410) strcat(s, "K");
if (crc32("emWqZQO",7) == 2379280360) strcat(s, "r");
if (crc32("tLNaCEbwH",9) == 593953187) strcat(s, "j");
if (crc32("CXpOKyHypgh",11) == 2806113892) strcat(s, "a");
if (crc32("wZUrvVTclWn",11) == 1800075356) strcat(s, "i");
if (crc32("fPmmkuwPNu",10) == 1802372339) strcat(s, "g");
if (crc32("UyfyNNvWuEFuRPz",15) == 1248556978) strcat(s, "H");
if (crc32("bCcvRoPAEl",10) == 690026166) strcat(s, "h");
if (crc32("ASWpI",5) == 3263048937) strcat(s, "o");
if (crc32("viHSKeSGDpfGrN",14) == 1023819787) strcat(s, "t");
if (crc32("hxHSTYPHv",9) == 2586819588) strcat(s, "f");
if (crc32("rkPbeHwzyNA",11) == 1168544991) strcat(s, "a");
if (crc32("zxvnFizG",8) == 3093125516) strcat(s, "w");
if (crc32("LaUcmKBeALNi",12) == 4213813939) strcat(s, "a");
if (crc32("AiZwCSkSkXetVOJ",15) == 1735054391) strcat(s, "n");
if (crc32("WCLLUGRMa",9) == 1249088098) strcat(s, "y");
    return s;
}

char *waterlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("FWePVwehkYMH",12) == 2541315202) strcat(s, "H");
if (crc32("RAhGoaftsBKMUu",14) == 3217958422) strcat(s, "w");
if (crc32("EPXIGhnuPPlZqg",14) == 2868983423) strcat(s, "a");
if (crc32("YpnRREk",7) == 1599310224) strcat(s, "t");
if (crc32("UmWwqEzMvFE",11) == 3383659212) strcat(s, "e");
if (crc32("ErIYuXtcbce",11) == 1164694876) strcat(s, "r");
if (crc32("tvqKBilpX",9) == 2931659151) strcat(s, "b");
if (crc32("ULkkbTyI",8) == 2096694892) strcat(s, "l");
if (crc32("WzwUyN",6) == 3761093588) strcat(s, "e");
if (crc32("soOqUlvzkr",10) == 2286615493) strcat(s, "t");
if (crc32("nZFMhY",6) == 2284915054) strcat(s, "s");
if (crc32("umSeOMioBIkYP",13) == 474001415) strcat(s, "s");
if (crc32("xLPThrlbDtX",11) == 1659900570) strcat(s, "l");
if (crc32("fyfxTPywZNfQKPR",15) == 1271688786) strcat(s, "F");
if (crc32("TwvhrmDG",8) == 338456822) strcat(s, "y");
    return s;
}

char *quasiemotionally_adverbs() {
    char *s = calloc(17);
    if (crc32("uBShtJ",6) == 2318932048) strcat(s, "q");
if (crc32("diMHOVDpfFrw",12) == 294065813) strcat(s, "u");
if (crc32("ahPuECRlmdnJu",13) == 24915973) strcat(s, "v");
if (crc32("WSsTEMpl",8) == 3614057185) strcat(s, "a");
if (crc32("ktHGs",5) == 2870954487) strcat(s, "i");
if (crc32("YQGlB",5) == 2766122290) strcat(s, "s");
if (crc32("WvrJxMfnZOsKy",13) == 2914283634) strcat(s, "A");
if (crc32("coHHIaQ",7) == 4151499288) strcat(s, "i");
if (crc32("HyyTYNYEE",9) == 4175461437) strcat(s, "N");
if (crc32("uxIwCNzyW",9) == 3526423355) strcat(s, "e");
if (crc32("UlFEfNOI",8) == 1632147705) strcat(s, "m");
if (crc32("DzgfWdUlSEO",11) == 863530588) strcat(s, "o");
if (crc32("ZdiuTixVNRjYxQ",14) == 420937526) strcat(s, "F");
if (crc32("YMQjWNdM",8) == 1004901340) strcat(s, "t");
if (crc32("EyCvOdOTs",9) == 3307203687) strcat(s, "D");
if (crc32("YmtvGjhfvJCma",13) == 85402784) strcat(s, "i");
if (crc32("lhXohrmtqdPalKc",15) == 524742605) strcat(s, "o");
if (crc32("ZhwsTUlr",8) == 3902002582) strcat(s, "n");
if (crc32("JaZNWObuhKpDqss",15) == 63906363) strcat(s, "B");
if (crc32("WihUXDjoKJs",11) == 1726745300) strcat(s, "a");
if (crc32("fJXgXBCrwgwlx",13) == 2192246815) strcat(s, "Y");
if (crc32("tqZPi",5) == 4128069925) strcat(s, "l");
if (crc32("hYIAgiZUHDpKNfd",15) == 3117859316) strcat(s, "l");
if (crc32("SkSpiwRjP",9) == 3583902972) strcat(s, "t");
if (crc32("AGrBZaMWMPs",11) == 210495357) strcat(s, "y");
    return s;
}

char *vexatiously_adverbs() {
    char *s = calloc(12);
    if (crc32("ABWQJFQXXtjUgQV",15) == 1348600228) strcat(s, "v");
if (crc32("DnmcHcHUQkwqF",13) == 3525600595) strcat(s, "D");
if (crc32("xLTMz",5) == 1089508496) strcat(s, "e");
if (crc32("UQTZUfKcqYRJx",13) == 1783971099) strcat(s, "B");
if (crc32("yQKMkmZ",7) == 2055008685) strcat(s, "x");
if (crc32("YojXOSELUWmRk",13) == 4039168530) strcat(s, "F");
if (crc32("FNPDbxWPQU",10) == 2370154546) strcat(s, "a");
if (crc32("DkFcjN",6) == 829502119) strcat(s, "t");
if (crc32("TNtuCw",6) == 1649174595) strcat(s, "i");
if (crc32("MCYjXbqRziTndT",14) == 101009497) strcat(s, "p");
if (crc32("Dlsxtkxxn",9) == 800654863) strcat(s, "o");
if (crc32("BqWiqrWcFOnccZr",15) == 3825276533) strcat(s, "u");
if (crc32("PmLauuPRRj",10) == 1329834271) strcat(s, "s");
if (crc32("yDQiuvGGHdyZ",12) == 4194600691) strcat(s, "T");
if (crc32("HUoPFPEXjsTkCEq",15) == 2865365995) strcat(s, "l");
if (crc32("cqKHIDLpAfTS",12) == 1072521458) strcat(s, "x");
if (crc32("UqENRzuBBnYy",12) == 2572273581) strcat(s, "y");
    return s;
}

char *autographically_adverbs() {
    char *s = calloc(16);
    if (crc32("BcXkZFrtbXXazO",14) == 1199287840) strcat(s, "a");
if (crc32("toYKitNtTmw",11) == 737832841) strcat(s, "N");
if (crc32("dLqXXTRcBdkw",12) == 2767467511) strcat(s, "u");
if (crc32("ZDkTTzlxMs",10) == 393056167) strcat(s, "t");
if (crc32("NqeAG",5) == 848674680) strcat(s, "m");
if (crc32("qUTmuDsNXP",10) == 366090523) strcat(s, "o");
if (crc32("yNLxEOc",7) == 895814840) strcat(s, "Y");
if (crc32("dBzEJ",5) == 3656140910) strcat(s, "g");
if (crc32("XAfRbZBZz",9) == 1210720804) strcat(s, "z");
if (crc32("yaRvTZDWHKWX",12) == 2535639066) strcat(s, "r");
if (crc32("jCHQh",5) == 3437520637) strcat(s, "M");
if (crc32("EnoHcHCnytQM",12) == 4233959001) strcat(s, "a");
if (crc32("UhwYzaa",7) == 1429011139) strcat(s, "P");
if (crc32("YFWHlypeij",10) == 2492187352) strcat(s, "p");
if (crc32("edTYEpAdU",9) == 3366154517) strcat(s, "h");
if (crc32("DtwchcQjzADT",12) == 1747133487) strcat(s, "O");
if (crc32("kXqughLRMEjJlP",14) == 3352669465) strcat(s, "i");
if (crc32("yvJYecvSr",9) == 476848266) strcat(s, "c");
if (crc32("chZGCqzYplOwgtp",15) == 3152204314) strcat(s, "H");
if (crc32("PKFMxpK",7) == 4046993769) strcat(s, "a");
if (crc32("LDzsDZkcPvdhs",13) == 120429569) strcat(s, "l");
if (crc32("ANveqcL",7) == 2992754484) strcat(s, "u");
if (crc32("ukhPAFTuVmj",11) == 3227648279) strcat(s, "l");
if (crc32("VZFtsjyeDP",10) == 4008015461) strcat(s, "r");
if (crc32("MZXOcEH",7) == 1630088108) strcat(s, "y");
    return s;
}

char *preferably_adverbs() {
    char *s = calloc(11);
    if (crc32("AfZsQKVk",8) == 1122737583) strcat(s, "p");
if (crc32("qjUNFIf",7) == 2319399944) strcat(s, "S");
if (crc32("EmDrxqMSyQe",11) == 653302246) strcat(s, "r");
if (crc32("falYifG",7) == 3229370503) strcat(s, "e");
if (crc32("awYWDkGywFvJMU",14) == 1331111741) strcat(s, "C");
if (crc32("MBBEMmmNyYp",11) == 2525922720) strcat(s, "f");
if (crc32("YrcvcKkuHxTriF",14) == 2363551962) strcat(s, "e");
if (crc32("LdzbZflEuw",10) == 1742031012) strcat(s, "r");
if (crc32("PvxVGzgVxFxzTAo",15) == 2051678486) strcat(s, "u");
if (crc32("YEgnmObxbrDxm",13) == 3088183148) strcat(s, "a");
if (crc32("TFsnc",5) == 3434887477) strcat(s, "b");
if (crc32("GWjOuawYWrsaRL",14) == 1935544135) strcat(s, "j");
if (crc32("epjUruQX",8) == 499235429) strcat(s, "l");
if (crc32("WKDRrRqmd",9) == 3348601822) strcat(s, "T");
if (crc32("qyxGYmcFZhQlPUK",15) == 2017996781) strcat(s, "y");
    return s;
}

char *nonmanually_adverbs() {
    char *s = calloc(12);
    if (crc32("OzHVBwRVWHQ",11) == 890264722) strcat(s, "N");
if (crc32("ewbsREF",7) == 3040087841) strcat(s, "n");
if (crc32("bTGYEtmz",8) == 2560214830) strcat(s, "o");
if (crc32("imGZhUnaSFDfkJS",15) == 934577384) strcat(s, "n");
if (crc32("dVbbIOHwEBBw",12) == 1304202562) strcat(s, "t");
if (crc32("guRKeuqTSTym",12) == 487156144) strcat(s, "m");
if (crc32("wUdnQWXgCNzzrMO",15) == 348374143) strcat(s, "a");
if (crc32("FqBeraX",7) == 438399583) strcat(s, "n");
if (crc32("fUMZxzNTGPOo",12) == 915693433) strcat(s, "u");
if (crc32("IOlyMLoSLpS",11) == 2604310978) strcat(s, "a");
if (crc32("lXfLrYRHvUm",11) == 976064825) strcat(s, "o");
if (crc32("GYpwtwENHH",10) == 2309655509) strcat(s, "l");
if (crc32("UzzOScsiTqSchcj",15) == 570772045) strcat(s, "p");
if (crc32("TNvIBtAS",8) == 1359468197) strcat(s, "l");
if (crc32("aXyvww",6) == 4141318160) strcat(s, "F");
if (crc32("twSDLDPWGkm",11) == 1855268019) strcat(s, "y");
    return s;
}

char *nonvacantly_adverbs() {
    char *s = calloc(12);
    if (crc32("WhFWzamf",8) == 3904892406) strcat(s, "n");
if (crc32("EtdUVRYZOjUcnnk",15) == 3255921806) strcat(s, "z");
if (crc32("TsiPxJGXlKVo",12) == 3320532847) strcat(s, "o");
if (crc32("xUltztu",7) == 2380068580) strcat(s, "R");
if (crc32("ucfQdlBMGH",10) == 1155897777) strcat(s, "n");
if (crc32("RYIJIFWKo",9) == 3279643640) strcat(s, "v");
if (crc32("RHgnCgakodv",11) == 3896526071) strcat(s, "a");
if (crc32("GFNJe",5) == 3754223159) strcat(s, "c");
if (crc32("hwBnotfGvFTdzQx",15) == 3658380601) strcat(s, "p");
if (crc32("foqQESTAO",9) == 1617530118) strcat(s, "a");
if (crc32("HDzcbDk",7) == 3117658341) strcat(s, "c");
if (crc32("LHXBNzIrVaq",11) == 2164744332) strcat(s, "n");
if (crc32("arBXJLqXnebYcV",14) == 459549375) strcat(s, "o");
if (crc32("pqrnbHrl",8) == 1429087607) strcat(s, "t");
if (crc32("XkiDyvkHEq",10) == 2323793087) strcat(s, "l");
if (crc32("bGQjCgKqUJv",11) == 2121140976) strcat(s, "y");
    return s;
}

char *unvituperatively_adverbs() {
    char *s = calloc(17);
    if (crc32("dPtYSUv",7) == 1142707369) strcat(s, "u");
if (crc32("fXxVLayTVuKfNIU",15) == 4244313782) strcat(s, "k");
if (crc32("pdBseWTeereD",12) == 1727127794) strcat(s, "n");
if (crc32("nlyAgptcMPH",11) == 3250959612) strcat(s, "v");
if (crc32("AOvfJNsIaHLxo",13) == 1348768253) strcat(s, "Q");
if (crc32("ZjjghebiBMXo",12) == 210470139) strcat(s, "i");
if (crc32("WYrNy",5) == 3930239939) strcat(s, "t");
if (crc32("jUnJGzOILsTBW",13) == 1083479630) strcat(s, "l");
if (crc32("WSkqszMQwd",10) == 611772048) strcat(s, "u");
if (crc32("xMzNcxfJc",9) == 3399615407) strcat(s, "s");
if (crc32("vCnkRFfS",8) == 1916074712) strcat(s, "p");
if (crc32("vSRGn",5) == 318909821) strcat(s, "e");
if (crc32("RQfyT",5) == 665438452) strcat(s, "A");
if (crc32("rKzxPDgxBmdHz",13) == 923416874) strcat(s, "r");
if (crc32("lgtOKmBZW",9) == 1081339292) strcat(s, "a");
if (crc32("WquXqb",6) == 3475847158) strcat(s, "t");
if (crc32("EXwNdQSiD",9) == 3926924983) strcat(s, "K");
if (crc32("tIXWPpERc",9) == 91156326) strcat(s, "i");
if (crc32("aOfLpZZDq",9) == 2011469885) strcat(s, "b");
if (crc32("CPCwdn",6) == 1939438928) strcat(s, "v");
if (crc32("OTWhWZMDSVZATV",14) == 2806470596) strcat(s, "e");
if (crc32("XFwmfT",6) == 4229874834) strcat(s, "o");
if (crc32("JOERlbgYaii",11) == 4004435433) strcat(s, "l");
if (crc32("qICaPHYwCS",10) == 1270341915) strcat(s, "X");
if (crc32("uPNWldqrvCeYMWD",15) == 1548621316) strcat(s, "y");
    return s;
}

char *unsecurely_adverbs() {
    char *s = calloc(11);
    if (crc32("VuewrlIrVp",10) == 941839134) strcat(s, "y");
if (crc32("lLsNH",5) == 191428596) strcat(s, "u");
if (crc32("vREVC",5) == 4010865882) strcat(s, "G");
if (crc32("ZiwAn",5) == 3766080560) strcat(s, "n");
if (crc32("pZaJgm",6) == 795542525) strcat(s, "s");
if (crc32("fRQkj",5) == 4148481140) strcat(s, "e");
if (crc32("VqwUAdTHpSlcRg",14) == 3172717096) strcat(s, "W");
if (crc32("AaYLXoWykcRTZD",14) == 722985942) strcat(s, "c");
if (crc32("kwgHTVQRXEjUWl",14) == 3263225812) strcat(s, "j");
if (crc32("VHyrBHtTO",9) == 905753374) strcat(s, "u");
if (crc32("YCqvHVputd",10) == 1710998671) strcat(s, "p");
if (crc32("zgRuhWU",7) == 1988646796) strcat(s, "r");
if (crc32("PBSMeMfSdcqqocD",15) == 2415273650) strcat(s, "I");
if (crc32("AEfHYshalPFJaA",14) == 1572992650) strcat(s, "e");
if (crc32("umYzZxKUIDplUf",14) == 1735082315) strcat(s, "l");
if (crc32("KRzGfE",6) == 1662816333) strcat(s, "m");
if (crc32("JXlERra",7) == 625409524) strcat(s, "y");
    return s;
}

char *corporeally_adverbs() {
    char *s = calloc(12);
    if (crc32("tFCubRLOTE",10) == 3448898368) strcat(s, "q");
if (crc32("nSWTolbInhkuule",15) == 256352563) strcat(s, "c");
if (crc32("UhBFlxlSFXXIa",13) == 2336947116) strcat(s, "o");
if (crc32("JIivKX",6) == 1925120288) strcat(s, "g");
if (crc32("eCddUGhOR",9) == 4177783108) strcat(s, "r");
if (crc32("VrhuZLIvpo",10) == 1087351067) strcat(s, "p");
if (crc32("bNINq",5) == 3541236987) strcat(s, "b");
if (crc32("xFXqiLnjlbS",11) == 3858440600) strcat(s, "o");
if (crc32("FZMAb",5) == 2277365137) strcat(s, "r");
if (crc32("TIxPcjURobL",11) == 480510597) strcat(s, "b");
if (crc32("xkQmnwmEUrA",11) == 1590004377) strcat(s, "e");
if (crc32("rkhRFf",6) == 2324841193) strcat(s, "a");
if (crc32("ZeQdWyftTWkbrc",14) == 3436912188) strcat(s, "n");
if (crc32("NBZCTkoMz",9) == 45153262) strcat(s, "l");
if (crc32("CBYPXASAro",10) == 3799328107) strcat(s, "l");
if (crc32("wfOcwRHld",9) == 2407845262) strcat(s, "y");
    return s;
}

char *metagenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("gQniwbhtHd",10) == 1142423437) strcat(s, "m");
if (crc32("QwyZIlyuZ",9) == 1380125332) strcat(s, "X");
if (crc32("AuhrQzTD",8) == 3695264918) strcat(s, "e");
if (crc32("phTQMTxgl",9) == 3585775477) strcat(s, "t");
if (crc32("nJfXpkwYF",9) == 1925418840) strcat(s, "a");
if (crc32("WkxiSSQ",7) == 1973492549) strcat(s, "g");
if (crc32("BLrUMdbv",8) == 4079343541) strcat(s, "e");
if (crc32("qxHAyPqa",8) == 3877003268) strcat(s, "o");
if (crc32("TGQVy",5) == 2771683679) strcat(s, "n");
if (crc32("JFnlDTYuHHlplJH",15) == 1718665100) strcat(s, "e");
if (crc32("LggveyEnQCjq",12) == 2797660926) strcat(s, "t");
if (crc32("wxlkjFzu",8) == 1490526731) strcat(s, "i");
if (crc32("gvJauB",6) == 2374322270) strcat(s, "O");
if (crc32("qfDoZiCJwXDSP",13) == 3537455232) strcat(s, "c");
if (crc32("sZkXFSksMjoM",12) == 3039155639) strcat(s, "a");
if (crc32("qEABK",5) == 3196719368) strcat(s, "E");
if (crc32("kdagJmwBmI",10) == 211165876) strcat(s, "l");
if (crc32("VhmASGfCMFt",11) == 1730001274) strcat(s, "l");
if (crc32("PiKFtrpopf",10) == 609483232) strcat(s, "c");
if (crc32("DKJshp",6) == 1427603010) strcat(s, "y");
    return s;
}

char *stramineously_adverbs() {
    char *s = calloc(14);
    if (crc32("axTnqovTyN",10) == 1528846902) strcat(s, "x");
if (crc32("GhUOT",5) == 2750645972) strcat(s, "s");
if (crc32("QUjFPyzfNzeUxV",14) == 419716206) strcat(s, "j");
if (crc32("KeamOtIu",8) == 4211799179) strcat(s, "t");
if (crc32("MfqllX",6) == 717238828) strcat(s, "r");
if (crc32("KKnOBrC",7) == 3662206949) strcat(s, "a");
if (crc32("OmksBHXvPeBF",12) == 280599414) strcat(s, "m");
if (crc32("qMRLHACEomx",11) == 4246995246) strcat(s, "V");
if (crc32("ldOoCmln",8) == 3525287194) strcat(s, "i");
if (crc32("vbwBpvCA",8) == 3337418076) strcat(s, "n");
if (crc32("JcMpVaLePwA",11) == 4185012408) strcat(s, "e");
if (crc32("aDbLsWVPjbFXUrc",15) == 1105135217) strcat(s, "t");
if (crc32("VuGPJXcStLU",11) == 394272221) strcat(s, "o");
if (crc32("kftDIBqtTaml",12) == 1522353693) strcat(s, "K");
if (crc32("pwEjz",5) == 2425084883) strcat(s, "u");
if (crc32("LdcoXNjIUEB",11) == 1822511752) strcat(s, "s");
if (crc32("ttwHEpSoLFBW",12) == 3980729131) strcat(s, "l");
if (crc32("PmhiysmcZlRIjJ",14) == 3685356737) strcat(s, "u");
if (crc32("ehDopmVOPY",10) == 3036341343) strcat(s, "y");
    return s;
}

char *loutishly_adverbs() {
    char *s = calloc(10);
    if (crc32("EStMn",5) == 866926067) strcat(s, "l");
if (crc32("cdtpPhoxvR",10) == 2093763714) strcat(s, "o");
if (crc32("KogPloJvfOAn",12) == 3161001140) strcat(s, "u");
if (crc32("SQzuL",5) == 3194242895) strcat(s, "t");
if (crc32("ykMfXuOOiLBHZsU",15) == 1560210971) strcat(s, "U");
if (crc32("TSwFUMVhBap",11) == 1592004390) strcat(s, "i");
if (crc32("WgCYELMuKn",10) == 799555642) strcat(s, "h");
if (crc32("iPUiDxKXCwRar",13) == 2147937095) strcat(s, "s");
if (crc32("nGEFistvsec",11) == 632040246) strcat(s, "h");
if (crc32("vLGXjpjPih",10) == 2605885966) strcat(s, "P");
if (crc32("DMxosmY",7) == 2690314574) strcat(s, "l");
if (crc32("bpNuV",5) == 2937597063) strcat(s, "a");
if (crc32("dJitq",5) == 1970180926) strcat(s, "y");
    return s;
}

char *therapeutically_adverbs() {
    char *s = calloc(16);
    if (crc32("KtLKOXY",7) == 1107153618) strcat(s, "i");
if (crc32("ZeEtWJIRn",9) == 1017645780) strcat(s, "t");
if (crc32("JToMsiFWUU",10) == 1684268968) strcat(s, "p");
if (crc32("ruoZL",5) == 1701060708) strcat(s, "h");
if (crc32("GezvcaLfm",9) == 2914660443) strcat(s, "t");
if (crc32("tbJUVYhye",9) == 3775341937) strcat(s, "e");
if (crc32("alOzM",5) == 3053160439) strcat(s, "r");
if (crc32("gESFTQNA",8) == 2997236826) strcat(s, "a");
if (crc32("Clzjwq",6) == 3733313556) strcat(s, "Z");
if (crc32("YzbTQ",5) == 2118908963) strcat(s, "p");
if (crc32("LMfmOSm",7) == 2876026237) strcat(s, "e");
if (crc32("ROlFiULSD",9) == 777091049) strcat(s, "u");
if (crc32("rXuzEmRJpCfunQ",14) == 112045055) strcat(s, "y");
if (crc32("cBOes",5) == 2213355439) strcat(s, "t");
if (crc32("yIhazXQVLYlw",12) == 246837820) strcat(s, "i");
if (crc32("jHfaxTIlUb",10) == 2449725836) strcat(s, "c");
if (crc32("RVTEtWssxoGR",12) == 898971062) strcat(s, "a");
if (crc32("HKMogxneoXPlgYU",15) == 1412587739) strcat(s, "q");
if (crc32("YzAEiZwHjYrEKio",15) == 181159904) strcat(s, "l");
if (crc32("ubuBZLHTD",9) == 1219390505) strcat(s, "s");
if (crc32("GkRnSKXaoxtEj",13) == 1400113683) strcat(s, "l");
if (crc32("ylYfQaxrKZiWljI",15) == 2389207140) strcat(s, "m");
if (crc32("TopMGh",6) == 3532883321) strcat(s, "y");
    return s;
}

char *lucklessly_adverbs() {
    char *s = calloc(11);
    if (crc32("TzCwswbxdO",10) == 915677110) strcat(s, "e");
if (crc32("lmgAGrc",7) == 3519922621) strcat(s, "l");
if (crc32("TBEKeWIl",8) == 4019214143) strcat(s, "Z");
if (crc32("hseelyuHTWP",11) == 3902598080) strcat(s, "u");
if (crc32("VzocNgaAYELvV",13) == 2936385081) strcat(s, "c");
if (crc32("LiBfcqtUAzQ",11) == 1317188009) strcat(s, "k");
if (crc32("LViVXI",6) == 762746172) strcat(s, "l");
if (crc32("DDvisQjHBUWSdj",14) == 2086269105) strcat(s, "e");
if (crc32("dmsyYSazcqZjZPU",15) == 565881399) strcat(s, "s");
if (crc32("UMRzwRHnDK",10) == 4051148743) strcat(s, "s");
if (crc32("hAhXjeNgRDoEhbH",15) == 4174893669) strcat(s, "s");
if (crc32("LxDdxXmZi",9) == 1897253548) strcat(s, "l");
if (crc32("KuUKwGXgCvWEq",13) == 3692361399) strcat(s, "I");
if (crc32("EspUEBNwTROQ",12) == 4140440645) strcat(s, "y");
    return s;
}

char *overanimatedly_adverbs() {
    char *s = calloc(15);
    if (crc32("kHwfHIUaIs",10) == 179171276) strcat(s, "o");
if (crc32("IkOcisrVH",9) == 195162235) strcat(s, "v");
if (crc32("tUxkNOClVvrcnON",15) == 1502321313) strcat(s, "e");
if (crc32("ARXfu",5) == 1157268359) strcat(s, "Y");
if (crc32("ZyeIA",5) == 3435807712) strcat(s, "r");
if (crc32("QmIdiyQhl",9) == 2356411238) strcat(s, "a");
if (crc32("YFcqwEXnf",9) == 905033808) strcat(s, "S");
if (crc32("edwKSN",6) == 261912259) strcat(s, "n");
if (crc32("lodQHCUkzCsGV",13) == 1552532478) strcat(s, "I");
if (crc32("npIGoIVxqdC",11) == 956538556) strcat(s, "i");
if (crc32("yoosUBLEBL",10) == 3665947151) strcat(s, "m");
if (crc32("PQlZhs",6) == 3435949531) strcat(s, "a");
if (crc32("anmEPXjzLpsJP",13) == 2749023494) strcat(s, "U");
if (crc32("qHlhQ",5) == 2897607737) strcat(s, "t");
if (crc32("bkchtkWftwFW",12) == 1371529558) strcat(s, "e");
if (crc32("yoavaeUAiIKek",13) == 2822708425) strcat(s, "d");
if (crc32("yMciXaJAntIfvqe",15) == 1589350984) strcat(s, "l");
if (crc32("MxMHJTt",7) == 1437633826) strcat(s, "y");
    return s;
}

char *astonishedly_adverbs() {
    char *s = calloc(13);
    if (crc32("HFrCetCLg",9) == 666214720) strcat(s, "i");
if (crc32("XaDTFKEBuIefyjm",15) == 1290488509) strcat(s, "a");
if (crc32("twJWa",5) == 4100244860) strcat(s, "V");
if (crc32("mmQeCewrtFAIEaO",15) == 2592572534) strcat(s, "s");
if (crc32("JnTWyoMp",8) == 1538542769) strcat(s, "t");
if (crc32("fdXKXoux",8) == 2652501392) strcat(s, "O");
if (crc32("OQuzSuHZp",9) == 667748132) strcat(s, "o");
if (crc32("jaRIM",5) == 3503569704) strcat(s, "n");
if (crc32("LvEIFqbXtb",10) == 4047508363) strcat(s, "u");
if (crc32("IDUPpvKZRUmMAue",15) == 2027467228) strcat(s, "i");
if (crc32("ELkALOxRumMAZG",14) == 3108353557) strcat(s, "s");
if (crc32("BYguCsVIzAs",11) == 2885829066) strcat(s, "h");
if (crc32("RmftaqZgWsRcAC",14) == 2544530319) strcat(s, "z");
if (crc32("AOcrQA",6) == 1945652786) strcat(s, "e");
if (crc32("UAcWz",5) == 4183953909) strcat(s, "m");
if (crc32("rmZPjSNST",9) == 1966538889) strcat(s, "d");
if (crc32("wURLaRZMhtKmhE",14) == 3480879082) strcat(s, "d");
if (crc32("VAsDwyTVY",9) == 2199464650) strcat(s, "l");
if (crc32("ZcPGCMICoyqbIJg",15) == 3504721078) strcat(s, "K");
if (crc32("MDTzqzbd",8) == 3564268971) strcat(s, "y");
    return s;
}

char *unmixedly_adverbs() {
    char *s = calloc(10);
    if (crc32("BDtTSsnLyTPrDh",14) == 2483957665) strcat(s, "u");
if (crc32("mcIOUJNQntY",11) == 409625280) strcat(s, "n");
if (crc32("aaIpuoYGLHb",11) == 2352450934) strcat(s, "m");
if (crc32("GOVluKPU",8) == 1613680244) strcat(s, "i");
if (crc32("PnFRViyEXHA",11) == 180270480) strcat(s, "i");
if (crc32("GTzTcSDDNs",10) == 1735816677) strcat(s, "p");
if (crc32("xTRYdfAsTN",10) == 928987016) strcat(s, "x");
if (crc32("ttlAgUgGrk",10) == 4223288441) strcat(s, "b");
if (crc32("QdmAKfPcRv",10) == 3738924873) strcat(s, "e");
if (crc32("SDcZbzclCPsmhUa",15) == 3418387219) strcat(s, "d");
if (crc32("wMXWSGMVXFAM",12) == 247178645) strcat(s, "V");
if (crc32("iemVR",5) == 2004055913) strcat(s, "l");
if (crc32("rqNSMiVv",8) == 4032172680) strcat(s, "y");
    return s;
}

char *undeviously_adverbs() {
    char *s = calloc(12);
    if (crc32("xZqmYTWjx",9) == 1320299055) strcat(s, "u");
if (crc32("puApKJzAAzQok",13) == 4254785495) strcat(s, "E");
if (crc32("cGSTqc",6) == 2246248059) strcat(s, "n");
if (crc32("VxtvxVLrBZJVhf",14) == 2601725082) strcat(s, "d");
if (crc32("yoopazNeyvouMu",14) == 2423524229) strcat(s, "q");
if (crc32("wchfgrBBJNFcgPm",15) == 3591089484) strcat(s, "e");
if (crc32("kDCbWO",6) == 2951339964) strcat(s, "v");
if (crc32("DBwLRJtGLzbmO",13) == 2495060086) strcat(s, "M");
if (crc32("vpmQuxUWZcTVmfe",15) == 2660639865) strcat(s, "i");
if (crc32("abtJZH",6) == 815471312) strcat(s, "o");
if (crc32("vQabYrxLL",9) == 430982494) strcat(s, "u");
if (crc32("OCOBcLfQK",9) == 2974226950) strcat(s, "s");
if (crc32("PRdpC",5) == 268563935) strcat(s, "l");
if (crc32("DpeejBt",7) == 2904998065) strcat(s, "B");
if (crc32("knPbmo",6) == 2029252313) strcat(s, "y");
    return s;
}

char *convolutely_adverbs() {
    char *s = calloc(12);
    if (crc32("HRthBmBIXKmB",12) == 3643567114) strcat(s, "c");
if (crc32("gkUBfgAPUeIYn",13) == 264970259) strcat(s, "a");
if (crc32("DatcJly",7) == 1457367340) strcat(s, "o");
if (crc32("BSwqISpJoxoQHWG",15) == 2224282686) strcat(s, "B");
if (crc32("pkuPxoI",7) == 1586440037) strcat(s, "n");
if (crc32("OCXdQhGglxtuW",13) == 1015676430) strcat(s, "v");
if (crc32("FJjgI",5) == 4196245062) strcat(s, "n");
if (crc32("ERtCD",5) == 3458776782) strcat(s, "o");
if (crc32("BmpIcJC",7) == 1250857486) strcat(s, "l");
if (crc32("nZcqltjkhRJBUrl",15) == 2314142666) strcat(s, "u");
if (crc32("eLKuHPSsYDnIM",13) == 700815054) strcat(s, "t");
if (crc32("fWWbMwY",7) == 3632228401) strcat(s, "Z");
if (crc32("sFNbXOOLzbubaob",15) == 2376842441) strcat(s, "e");
if (crc32("VVwpzIqaU",9) == 3943334934) strcat(s, "z");
if (crc32("hCcxfUeHbTubEa",14) == 1444978440) strcat(s, "l");
if (crc32("eNgdzxGEPucAXjL",15) == 162696858) strcat(s, "I");
if (crc32("rCAxkyBUGPtF",12) == 1049394963) strcat(s, "y");
    return s;
}

char *inexpiably_adverbs() {
    char *s = calloc(11);
    if (crc32("ywusYbRyjh",10) == 1778958041) strcat(s, "i");
if (crc32("poaqzhGb",8) == 1741093084) strcat(s, "v");
if (crc32("OZiSuJFaxuRXaCR",15) == 371029482) strcat(s, "n");
if (crc32("dUiVS",5) == 4004751739) strcat(s, "b");
if (crc32("ljTyxIxKuck",11) == 3753910462) strcat(s, "e");
if (crc32("IckzegGlHToFPR",14) == 3989823988) strcat(s, "b");
if (crc32("NCdOlAZWRhLqL",13) == 3315551124) strcat(s, "x");
if (crc32("rNaLhomndrigasQ",15) == 552742713) strcat(s, "f");
if (crc32("mGmLsLu",7) == 4280602437) strcat(s, "p");
if (crc32("ZAtxH",5) == 1529931263) strcat(s, "i");
if (crc32("OCBjKt",6) == 2839404655) strcat(s, "j");
if (crc32("yMiZch",6) == 389063603) strcat(s, "a");
if (crc32("hmnwUKpM",8) == 2791884086) strcat(s, "R");
if (crc32("XuuYyULkoughBd",14) == 3087473852) strcat(s, "b");
if (crc32("zzqkmBJXYvxosL",14) == 2899205175) strcat(s, "A");
if (crc32("oEAfIHHxDkhEfoT",15) == 2354756000) strcat(s, "l");
if (crc32("Uabbfc",6) == 1957935647) strcat(s, "y");
    return s;
}

char *subsatirically_adverbs() {
    char *s = calloc(15);
    if (crc32("edvQGGJRCHg",11) == 536352463) strcat(s, "j");
if (crc32("CAogtBiWhS",10) == 3660523086) strcat(s, "s");
if (crc32("FzhSvpdYZK",10) == 1196549555) strcat(s, "C");
if (crc32("BnCNkHhceT",10) == 2491245180) strcat(s, "u");
if (crc32("KAyNd",5) == 3047961864) strcat(s, "b");
if (crc32("bEIxUueQab",10) == 2556776998) strcat(s, "s");
if (crc32("KHANNH",6) == 4086266943) strcat(s, "a");
if (crc32("AmONTjPiGbUQmiN",15) == 1300862297) strcat(s, "t");
if (crc32("spReCPW",7) == 1372176161) strcat(s, "L");
if (crc32("iRvxZ",5) == 253786878) strcat(s, "i");
if (crc32("cpoFoMyHOKzYg",13) == 340332427) strcat(s, "r");
if (crc32("fEvJKipUs",9) == 3125468164) strcat(s, "i");
if (crc32("qdQLBftblWy",11) == 2593577885) strcat(s, "c");
if (crc32("bmyxUwkup",9) == 19337826) strcat(s, "a");
if (crc32("iqNtLxVncGkG",12) == 3540952163) strcat(s, "Y");
if (crc32("WszZm",5) == 531279369) strcat(s, "l");
if (crc32("OIkLKUQuI",9) == 188189399) strcat(s, "i");
if (crc32("CRGxrdIccW",10) == 192285479) strcat(s, "l");
if (crc32("wfDBULMPirkM",12) == 1346837811) strcat(s, "N");
if (crc32("VBzcVcsCAuOnPQW",15) == 1111301582) strcat(s, "y");
    return s;
}

char *subopaquely_adverbs() {
    char *s = calloc(12);
    if (crc32("ZtXisqpv",8) == 550208342) strcat(s, "Z");
if (crc32("LMCTjldiZ",9) == 1558592043) strcat(s, "s");
if (crc32("LbFxwUddOWOJk",13) == 1972949408) strcat(s, "u");
if (crc32("KJgURiBYVAXwavB",15) == 3792686231) strcat(s, "b");
if (crc32("EuXEUd",6) == 318951414) strcat(s, "k");
if (crc32("aiUjbvgwiEJR",12) == 2301766044) strcat(s, "o");
if (crc32("radnCRAkcC",10) == 3627476595) strcat(s, "p");
if (crc32("ZIcSf",5) == 2516349140) strcat(s, "x");
if (crc32("UvvyYVACxmDp",12) == 2506233759) strcat(s, "a");
if (crc32("VZtHMKIshM",10) == 1711643699) strcat(s, "q");
if (crc32("hEBYocIAzwj",11) == 1386481520) strcat(s, "u");
if (crc32("goeloZEHy",9) == 2995616602) strcat(s, "A");
if (crc32("ARTxYHsBweFdy",13) == 840582134) strcat(s, "e");
if (crc32("jvoVPXfOKlMa",12) == 3173730176) strcat(s, "l");
if (crc32("ZdugKRVLKkHdW",13) == 2448650551) strcat(s, "y");
    return s;
}

char *slangily_adverbs() {
    char *s = calloc(9);
    if (crc32("mbIIO",5) == 2386322795) strcat(s, "s");
if (crc32("ZGCIpHcaKZwZZq",14) == 1949998337) strcat(s, "l");
if (crc32("mvSBMQXZZoKzMfa",15) == 1908845183) strcat(s, "l");
if (crc32("CygsiQgWsPIQNt",14) == 2581224666) strcat(s, "a");
if (crc32("rOPCNUr",7) == 2867103510) strcat(s, "n");
if (crc32("kYFTijWljkWYc",13) == 1986433900) strcat(s, "N");
if (crc32("yHABhug",7) == 2487468056) strcat(s, "g");
if (crc32("RAoux",5) == 3896814670) strcat(s, "i");
if (crc32("siESbRf",7) == 1102305498) strcat(s, "l");
if (crc32("ZJPSuONKdyYt",12) == 4097979905) strcat(s, "y");
    return s;
}

char *illfavoredly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZHSfGjAXPhhz",12) == 3968606438) strcat(s, "i");
if (crc32("EDLSZ",5) == 569322903) strcat(s, "l");
if (crc32("aBEYVQyjwORCNEQ",15) == 4085890590) strcat(s, "F");
if (crc32("fhBGdtcQveExrp",14) == 1266093998) strcat(s, "l");
if (crc32("LjGrXVnk",8) == 3792640429) strcat(s, "f");
if (crc32("WCNZwrNI",8) == 1691636098) strcat(s, "J");
if (crc32("VOIkXnxPcgZq",12) == 3503229225) strcat(s, "a");
if (crc32("PSyOZoqt",8) == 1388368477) strcat(s, "v");
if (crc32("isRpJmsHVrnb",12) == 2993947742) strcat(s, "o");
if (crc32("tqNETmUggCZxTpH",15) == 2786417705) strcat(s, "f");
if (crc32("CdHVs",5) == 911324156) strcat(s, "r");
if (crc32("qRRQJuEK",8) == 1138666019) strcat(s, "K");
if (crc32("QsFBajx",7) == 4212106361) strcat(s, "e");
if (crc32("uZOqDOBMM",9) == 3125167591) strcat(s, "d");
if (crc32("TmBWXusCIayKGG",14) == 3718797959) strcat(s, "l");
if (crc32("FqUXtsPzG",9) == 3015197440) strcat(s, "y");
if (crc32("BHZyDlRpMhF",11) == 2431299104) strcat(s, "y");
    return s;
}

char *eccentrically_adverbs() {
    char *s = calloc(14);
    if (crc32("OFYDRJTkem",10) == 2751406198) strcat(s, "e");
if (crc32("NPxbjoxNeXD",11) == 2799350396) strcat(s, "c");
if (crc32("uwKguyDnGL",10) == 975842536) strcat(s, "f");
if (crc32("VywHFyvRRxJx",12) == 975693486) strcat(s, "c");
if (crc32("VccRf",5) == 3873638279) strcat(s, "C");
if (crc32("tgdZSE",6) == 1210856851) strcat(s, "e");
if (crc32("FcEUwwsbYCfBf",13) == 2960769342) strcat(s, "a");
if (crc32("UUQSwR",6) == 3844235163) strcat(s, "n");
if (crc32("oRBjIG",6) == 3085795000) strcat(s, "t");
if (crc32("FOPOGTxAqPZdhU",14) == 3237367037) strcat(s, "Y");
if (crc32("UUKameskMPYXblJ",15) == 3456999653) strcat(s, "r");
if (crc32("zHfnmzJfSikx",12) == 1817572152) strcat(s, "i");
if (crc32("OzQikqqygh",10) == 3802178195) strcat(s, "R");
if (crc32("FaIOLyMq",8) == 3184657366) strcat(s, "c");
if (crc32("XbVZDrIgsFPaKm",14) == 3825846761) strcat(s, "g");
if (crc32("eLrJlA",6) == 5291950) strcat(s, "a");
if (crc32("ESsALzxiaUI",11) == 2385211219) strcat(s, "y");
if (crc32("RDranNgOoOH",11) == 1422102594) strcat(s, "l");
if (crc32("xcYtiTFuwYPHsW",14) == 1624147349) strcat(s, "l");
if (crc32("hdRceVSRtBA",11) == 3604925092) strcat(s, "y");
    return s;
}

char *overprovidently_adverbs() {
    char *s = calloc(16);
    if (crc32("UeqgEjUi",8) == 2151900284) strcat(s, "S");
if (crc32("nlgfPgBlR",9) == 3296798956) strcat(s, "o");
if (crc32("fwRbRRlImRK",11) == 1866964580) strcat(s, "v");
if (crc32("SUzZHqJx",8) == 1218918565) strcat(s, "e");
if (crc32("XZKooMPTfSFu",12) == 633491275) strcat(s, "r");
if (crc32("ynYbyLefV",9) == 1454015884) strcat(s, "p");
if (crc32("szsJidToXJUt",12) == 1928716770) strcat(s, "h");
if (crc32("hEtyHRM",7) == 2662085049) strcat(s, "r");
if (crc32("xNzrxLKoPyhRVu",14) == 1128553541) strcat(s, "u");
if (crc32("WZRkbBG",7) == 425404805) strcat(s, "o");
if (crc32("mdfIQJZBseehNy",14) == 2514454182) strcat(s, "v");
if (crc32("rZqgFBdB",8) == 750841295) strcat(s, "C");
if (crc32("jEDjWgZiALQH",12) == 3925410585) strcat(s, "i");
if (crc32("aJIMos",6) == 79258936) strcat(s, "v");
if (crc32("xtgtUwjew",9) == 3464116896) strcat(s, "d");
if (crc32("GmBXn",5) == 1321967159) strcat(s, "e");
if (crc32("EdTMftHKzUfl",12) == 1315289827) strcat(s, "U");
if (crc32("quYGv",5) == 994211384) strcat(s, "n");
if (crc32("UNzAOxMtUGUdXzd",15) == 3066879603) strcat(s, "t");
if (crc32("YLamWPXLpYufE",13) == 34113166) strcat(s, "l");
if (crc32("mFErK",5) == 2477363015) strcat(s, "y");
    return s;
}

char *filmily_adverbs() {
    char *s = calloc(8);
    if (crc32("FBiCPgz",7) == 326409543) strcat(s, "f");
if (crc32("AsuaGLHzB",9) == 2019408014) strcat(s, "i");
if (crc32("AWDXmEYXDk",10) == 2274002396) strcat(s, "l");
if (crc32("aBGCsqxSPjFjAc",14) == 3274804803) strcat(s, "I");
if (crc32("YOzpEP",6) == 4143379736) strcat(s, "m");
if (crc32("DageKsP",7) == 3671910247) strcat(s, "i");
if (crc32("KCXZNktegDqSA",13) == 1072132533) strcat(s, "h");
if (crc32("eEQQUeHGz",9) == 1587216271) strcat(s, "l");
if (crc32("QcOiWfPMX",9) == 2556018939) strcat(s, "y");
    return s;
}

char *debasingly_adverbs() {
    char *s = calloc(11);
    if (crc32("RrOLCwetQNyP",12) == 475655675) strcat(s, "d");
if (crc32("XAXyrt",6) == 1304231949) strcat(s, "j");
if (crc32("hDaABI",6) == 3348853055) strcat(s, "e");
if (crc32("iZTXYCLAeHxtyY",14) == 574017717) strcat(s, "b");
if (crc32("tSIehWvxy",9) == 2023684354) strcat(s, "a");
if (crc32("ImKwDuhJDX",10) == 2800791817) strcat(s, "s");
if (crc32("TbvzsDZzu",9) == 1088979576) strcat(s, "i");
if (crc32("BsCOoElxk",9) == 1958498296) strcat(s, "n");
if (crc32("KHOPJEKivquh",12) == 633292386) strcat(s, "P");
if (crc32("VaBtVxLqMbV",11) == 1503838153) strcat(s, "g");
if (crc32("kTRZGGK",7) == 3087132841) strcat(s, "x");
if (crc32("YkhIwGVFxLzsr",13) == 2240946998) strcat(s, "l");
if (crc32("ZwwxctsDjcL",11) == 4201101671) strcat(s, "y");
    return s;
}

char *ontogenetically_adverbs() {
    char *s = calloc(16);
    if (crc32("aumWfez",7) == 3906453409) strcat(s, "y");
if (crc32("jjBsUWo",7) == 50118579) strcat(s, "o");
if (crc32("FXbSnNPlWQoJpOn",15) == 389875541) strcat(s, "Z");
if (crc32("IRzIUXgQmpVjF",13) == 3469368534) strcat(s, "n");
if (crc32("CUylpkqSkR",10) == 826821373) strcat(s, "q");
if (crc32("WBfSUmH",7) == 879210898) strcat(s, "t");
if (crc32("oZDqM",5) == 1043180512) strcat(s, "W");
if (crc32("zNcPpKMFc",9) == 3059624628) strcat(s, "o");
if (crc32("YkVaoFvTkWWv",12) == 2706437704) strcat(s, "g");
if (crc32("PPHjXQfTbSkM",12) == 455700041) strcat(s, "n");
if (crc32("TApepiuVEK",10) == 680694491) strcat(s, "e");
if (crc32("JhuUMol",7) == 2322771161) strcat(s, "n");
if (crc32("VxLyxGJR",8) == 4044978092) strcat(s, "e");
if (crc32("ZsyNqruPdBbkjyv",15) == 2167274053) strcat(s, "N");
if (crc32("LHoMyJLnohnZ",12) == 1975213984) strcat(s, "t");
if (crc32("cOhyXOpyFH",10) == 2456096120) strcat(s, "j");
if (crc32("nAzCVk",6) == 2792394515) strcat(s, "i");
if (crc32("VMcVRehJYjRDEsT",15) == 2395096121) strcat(s, "J");
if (crc32("MHbUVjNmwhq",11) == 2283278663) strcat(s, "c");
if (crc32("RfPtiWCD",8) == 2734656014) strcat(s, "U");
if (crc32("hQhrxJuRTrmjOmy",15) == 984232884) strcat(s, "a");
if (crc32("Hhybh",5) == 531728617) strcat(s, "l");
if (crc32("qxzvgJyWyl",10) == 2465508045) strcat(s, "I");
if (crc32("PFpAt",5) == 2864028678) strcat(s, "l");
if (crc32("dyhut",5) == 4103545618) strcat(s, "d");
if (crc32("fnQbPXRB",8) == 905105746) strcat(s, "y");
    return s;
}

char *smugly_adverbs() {
    char *s = calloc(7);
    if (crc32("HXOBjkx",7) == 2088514624) strcat(s, "s");
if (crc32("utMVAQHokjqWvkW",15) == 838523997) strcat(s, "D");
if (crc32("wkhVDSbRieaNIz",14) == 3852498802) strcat(s, "m");
if (crc32("HCWRfeRPLupmVHf",15) == 3514271224) strcat(s, "u");
if (crc32("jRikWBGe",8) == 1118210004) strcat(s, "X");
if (crc32("NuSMTJpWmsbzukH",15) == 1178056521) strcat(s, "g");
if (crc32("pYNvauVBniJ",11) == 19951440) strcat(s, "e");
if (crc32("OnvLkxbZ",8) == 1692310305) strcat(s, "l");
if (crc32("mRFYyglJeO",10) == 2050726699) strcat(s, "K");
if (crc32("QbYGmfpcoFA",11) == 4210177860) strcat(s, "y");
    return s;
}

char *Ciceronically_adverbs() {
    char *s = calloc(14);
    if (crc32("ySIldfJ",7) == 2699379983) strcat(s, "C");
if (crc32("hBVwi",5) == 1650212840) strcat(s, "i");
if (crc32("bqftIXO",7) == 2165072972) strcat(s, "Y");
if (crc32("jdNVLsZGcgCF",12) == 470968228) strcat(s, "c");
if (crc32("ByIuZbLX",8) == 3096482397) strcat(s, "e");
if (crc32("dUPoqalyyGdIHmY",15) == 2880721077) strcat(s, "o");
if (crc32("PnFFaPhIYedUI",13) == 1511902459) strcat(s, "r");
if (crc32("iOUugsAVNwsi",12) == 1405835731) strcat(s, "O");
if (crc32("YKirTFkKNJ",10) == 1722293650) strcat(s, "o");
if (crc32("Uhcjed",6) == 2051352787) strcat(s, "n");
if (crc32("MIgMIhhUfFDbW",13) == 4167402338) strcat(s, "b");
if (crc32("hsIULSUoFKpeH",13) == 1056064959) strcat(s, "i");
if (crc32("jIkIx",5) == 3361449669) strcat(s, "c");
if (crc32("MFeseqWtXt",10) == 1238266108) strcat(s, "y");
if (crc32("pypSYvbdy",9) == 3683376445) strcat(s, "a");
if (crc32("ZfGfW",5) == 2172886256) strcat(s, "G");
if (crc32("OOiJfmglEFgPch",14) == 1967714921) strcat(s, "l");
if (crc32("fajaTpdOkM",10) == 1807470641) strcat(s, "B");
if (crc32("KlOAZmgwEJQN",12) == 1429601162) strcat(s, "l");
if (crc32("xYkzGEiVj",9) == 4116497276) strcat(s, "z");
if (crc32("rVuiZWZR",8) == 216878770) strcat(s, "y");
    return s;
}

char *corruptedly_adverbs() {
    char *s = calloc(12);
    if (crc32("xAeGfwX",7) == 3761421253) strcat(s, "E");
if (crc32("CTEGd",5) == 514359001) strcat(s, "c");
if (crc32("ITcxFN",6) == 271611421) strcat(s, "o");
if (crc32("FZUidzgT",8) == 1854720989) strcat(s, "r");
if (crc32("PkjAhDNCc",9) == 986143839) strcat(s, "r");
if (crc32("ilYBtJV",7) == 4228979762) strcat(s, "o");
if (crc32("ekXaewLjmruql",13) == 2736508705) strcat(s, "u");
if (crc32("rjAtIRPAIguhth",14) == 2468401023) strcat(s, "p");
if (crc32("lgKRfp",6) == 391005396) strcat(s, "L");
if (crc32("IDwyrKUW",8) == 2389413746) strcat(s, "t");
if (crc32("eaDjqunNn",9) == 2197097134) strcat(s, "p");
if (crc32("TgFmboywLqk",11) == 81310143) strcat(s, "e");
if (crc32("idXTFgG",7) == 3929563098) strcat(s, "d");
if (crc32("CTmHU",5) == 4272977268) strcat(s, "l");
if (crc32("LBbUFuf",7) == 1903591221) strcat(s, "U");
if (crc32("YGLsVHbdYjHtV",13) == 2794082149) strcat(s, "y");
    return s;
}

char *superpolitely_adverbs() {
    char *s = calloc(14);
    if (crc32("YrSSFvHNK",9) == 4179446192) strcat(s, "x");
if (crc32("xBHUgOuFZG",10) == 850241944) strcat(s, "s");
if (crc32("zPfCfwg",7) == 3041822274) strcat(s, "Q");
if (crc32("VwHOdPhAPhGGf",13) == 1975127098) strcat(s, "u");
if (crc32("hbstJ",5) == 1973565036) strcat(s, "p");
if (crc32("tunpmfsqGYtsMB",14) == 2448636593) strcat(s, "e");
if (crc32("AxHSyjv",7) == 1410242848) strcat(s, "r");
if (crc32("kmwdIbvxHI",10) == 2377114148) strcat(s, "u");
if (crc32("BSktDbf",7) == 1255430324) strcat(s, "p");
if (crc32("vuJGCd",6) == 1300019803) strcat(s, "o");
if (crc32("SlCghkxEwtUMQO",14) == 2494504610) strcat(s, "F");
if (crc32("jOPgMz",6) == 2979805546) strcat(s, "l");
if (crc32("fxgMYAZvRqGP",12) == 3919233999) strcat(s, "D");
if (crc32("MsQzGauYLqBZ",12) == 754396508) strcat(s, "i");
if (crc32("VMrfvMbHw",9) == 4155001231) strcat(s, "n");
if (crc32("xLMDmxPpT",9) == 2197358374) strcat(s, "t");
if (crc32("xnnbCppzfTaUsou",15) == 2930370918) strcat(s, "e");
if (crc32("BUohRoEgJ",9) == 2637371042) strcat(s, "O");
if (crc32("qJQiElGVXnOEFW",14) == 738370472) strcat(s, "l");
if (crc32("uhBiNMMtKgMQsp",14) == 2469552395) strcat(s, "T");
if (crc32("wOZNH",5) == 963740646) strcat(s, "y");
    return s;
}

char *unstoppably_adverbs() {
    char *s = calloc(12);
    if (crc32("clmrKOKkh",9) == 4258497984) strcat(s, "u");
if (crc32("hGUxJTzCzGeYxLL",15) == 3602959483) strcat(s, "z");
if (crc32("IyCljpUKAr",10) == 2984897819) strcat(s, "n");
if (crc32("fzMZcdjU",8) == 411380399) strcat(s, "s");
if (crc32("UIKCWWUGuwT",11) == 2082166203) strcat(s, "Y");
if (crc32("KIRYfZNNCuf",11) == 3081921311) strcat(s, "t");
if (crc32("XxuFmYmNmUPse",13) == 2698318292) strcat(s, "D");
if (crc32("jcNyQQLZzUipA",13) == 507426281) strcat(s, "o");
if (crc32("pyfjltjfkqSr",12) == 2321942708) strcat(s, "h");
if (crc32("zGhaR",5) == 3435437905) strcat(s, "p");
if (crc32("AYStihNpScDudL",14) == 4026877611) strcat(s, "p");
if (crc32("WTvpzTVqmiHlEc",14) == 503896035) strcat(s, "a");
if (crc32("FgiCTbgmWbJQ",12) == 2783741418) strcat(s, "b");
if (crc32("VWssQ",5) == 1768056627) strcat(s, "l");
if (crc32("LMljGA",6) == 3815266757) strcat(s, "y");
    return s;
}

char *undifferentiably_adverbs() {
    char *s = calloc(17);
    if (crc32("YMtMsPudBqb",11) == 784159588) strcat(s, "h");
if (crc32("EUFazvKJgf",10) == 45218175) strcat(s, "u");
if (crc32("LvuvXFLmzHfcxj",14) == 1172770705) strcat(s, "n");
if (crc32("SsjgfuuMLzcIO",13) == 3140957932) strcat(s, "d");
if (crc32("LdpHnREmf",9) == 3233317503) strcat(s, "i");
if (crc32("DEeIDMmUplOtWe",14) == 2926410555) strcat(s, "d");
if (crc32("iRBiDcZGGuZjf",13) == 1371315356) strcat(s, "f");
if (crc32("gVtqmDWIOFpdBB",14) == 4159852431) strcat(s, "f");
if (crc32("PPPmDWexYJEcEr",14) == 1920192543) strcat(s, "e");
if (crc32("NtKzkQkIsHx",11) == 1546522149) strcat(s, "m");
if (crc32("qfmSCdJ",7) == 1417727650) strcat(s, "r");
if (crc32("AAKYQPjgnaTVED",14) == 790067277) strcat(s, "T");
if (crc32("rTPQFRSJq",9) == 4176358440) strcat(s, "e");
if (crc32("tZRacGtpMx",10) == 3895951163) strcat(s, "P");
if (crc32("WMYxITq",7) == 3587070857) strcat(s, "n");
if (crc32("IgPBhwyBANd",11) == 3532587175) strcat(s, "t");
if (crc32("DNXewPsIhJRJLd",14) == 3158594648) strcat(s, "i");
if (crc32("EoaujLlc",8) == 3151227686) strcat(s, "a");
if (crc32("XRaxTKjmItHW",12) == 3990456142) strcat(s, "D");
if (crc32("TnRSQmfFBxd",11) == 2887893702) strcat(s, "b");
if (crc32("mqvOHy",6) == 3857796464) strcat(s, "l");
if (crc32("xwtacACVOI",10) == 3851409439) strcat(s, "y");
    return s;
}

char *nongeologically_adverbs() {
    char *s = calloc(16);
    if (crc32("ukxIIvg",7) == 4263971111) strcat(s, "D");
if (crc32("FLtKgkEuIdqpSlA",15) == 74300313) strcat(s, "n");
if (crc32("xGcCNk",6) == 1344741905) strcat(s, "y");
if (crc32("PXugRTqVKNjRKv",14) == 3247151980) strcat(s, "o");
if (crc32("FbJxWBhgiWkyVw",14) == 1311132094) strcat(s, "n");
if (crc32("XLRvH",5) == 702363526) strcat(s, "z");
if (crc32("EkRex",5) == 2474298388) strcat(s, "g");
if (crc32("albLv",5) == 3178834453) strcat(s, "e");
if (crc32("HfZtAUn",7) == 2869871702) strcat(s, "K");
if (crc32("uSPYUgSztYY",11) == 3153139805) strcat(s, "o");
if (crc32("XrXyHdDbLWLom",13) == 3705672296) strcat(s, "q");
if (crc32("wMreHBCc",8) == 3540124406) strcat(s, "l");
if (crc32("czTNf",5) == 3594320292) strcat(s, "O");
if (crc32("rcZtDRUK",8) == 3452073695) strcat(s, "o");
if (crc32("zjQFJwTaz",9) == 3951133559) strcat(s, "X");
if (crc32("ENUeE",5) == 1504823692) strcat(s, "g");
if (crc32("laVphIWlaVqmn",13) == 2722041728) strcat(s, "r");
if (crc32("QgSekahSGSK",11) == 234236551) strcat(s, "i");
if (crc32("oQacqXNBA",9) == 744849759) strcat(s, "c");
if (crc32("iIGRuuGDLOcTpm",14) == 1751795122) strcat(s, "a");
if (crc32("ytyASyefWZZW",12) == 2745231802) strcat(s, "i");
if (crc32("trutaSKYl",9) == 2777216831) strcat(s, "l");
if (crc32("nMDLNnTXdHE",11) == 455909346) strcat(s, "g");
if (crc32("knDnwGmfkHSjAKj",15) == 788472067) strcat(s, "l");
if (crc32("oeYiPFjUqVdWC",13) == 404933273) strcat(s, "k");
if (crc32("tragPSSOEG",10) == 618187943) strcat(s, "y");
    return s;
}

char *unconducively_adverbs() {
    char *s = calloc(14);
    if (crc32("aRthMSBzPCJ",11) == 3919734472) strcat(s, "z");
if (crc32("eErtIadBJj",10) == 1522372789) strcat(s, "u");
if (crc32("hNgrwc",6) == 325043994) strcat(s, "I");
if (crc32("EBHvjRTx",8) == 4193805881) strcat(s, "n");
if (crc32("zGpuIfh",7) == 965003653) strcat(s, "b");
if (crc32("ownypMkxPy",10) == 1708389113) strcat(s, "c");
if (crc32("YvDaFJ",6) == 2174272387) strcat(s, "o");
if (crc32("pWDawTnjzssr",12) == 3511618774) strcat(s, "r");
if (crc32("zmNwNRw",7) == 1289570577) strcat(s, "n");
if (crc32("eRbAMWDWA",9) == 1255707793) strcat(s, "d");
if (crc32("FMvcGThDvRbZYyW",15) == 4266630973) strcat(s, "f");
if (crc32("kDuLMifCiYMNPH",14) == 1007448369) strcat(s, "u");
if (crc32("gzpqWa",6) == 3859963529) strcat(s, "c");
if (crc32("WTIviIvUyd",10) == 3297757605) strcat(s, "i");
if (crc32("PfEaNkArVOJvk",13) == 3451963441) strcat(s, "v");
if (crc32("HSRCHzxuOhMDwnn",15) == 1743782197) strcat(s, "e");
if (crc32("BjAPp",5) == 728506572) strcat(s, "l");
if (crc32("jScEZzM",7) == 3811732017) strcat(s, "a");
if (crc32("rfIItBljLrrW",12) == 584106790) strcat(s, "y");
    return s;
}

char *unbrightly_adverbs() {
    char *s = calloc(11);
    if (crc32("gFMxPoGYRz",10) == 733316068) strcat(s, "g");
if (crc32("wKoDdxJocn",10) == 459812365) strcat(s, "u");
if (crc32("oDZQik",6) == 4259477066) strcat(s, "y");
if (crc32("MCNTxNlkWdCxy",13) == 1563743462) strcat(s, "n");
if (crc32("nCXhuUqn",8) == 914820111) strcat(s, "b");
if (crc32("HcqNTwgoPpfOYgO",15) == 2995685625) strcat(s, "S");
if (crc32("mOHWLtAaHC",10) == 330490481) strcat(s, "r");
if (crc32("HjyBFwwilSDyREW",15) == 3531042720) strcat(s, "T");
if (crc32("xvesNgCjV",9) == 3179388094) strcat(s, "i");
if (crc32("OJIzLElcpCjQU",13) == 1149319095) strcat(s, "H");
if (crc32("NlmlQScMj",9) == 2627735947) strcat(s, "g");
if (crc32("tVZVXvqKSJ",10) == 2803882719) strcat(s, "h");
if (crc32("bTGtSNjZcjKXlqD",15) == 3024208578) strcat(s, "y");
if (crc32("qpsmjJCahVUNL",13) == 4095561944) strcat(s, "t");
if (crc32("bqBBBpIO",8) == 1441506347) strcat(s, "S");
if (crc32("KXxPVIyqVdzaAV",14) == 2045261971) strcat(s, "l");
if (crc32("CvwnAmx",7) == 4008819785) strcat(s, "G");
if (crc32("LDEYHBgu",8) == 3870244459) strcat(s, "y");
    return s;
}

char *quasisatirically_adverbs() {
    char *s = calloc(17);
    if (crc32("LkZsgSDCJzs",11) == 3665371228) strcat(s, "q");
if (crc32("usVBqLpq",8) == 3287522422) strcat(s, "F");
if (crc32("IKTirRwjLb",10) == 1514261251) strcat(s, "u");
if (crc32("gvYnVpVHwHPWtl",14) == 1602966884) strcat(s, "b");
if (crc32("YJEEnjrEz",9) == 3509697968) strcat(s, "a");
if (crc32("mIHfUs",6) == 1282525640) strcat(s, "s");
if (crc32("yiZEYz",6) == 3029620683) strcat(s, "M");
if (crc32("cFDiLgauh",9) == 2423050849) strcat(s, "i");
if (crc32("mbWCN",5) == 150781436) strcat(s, "b");
if (crc32("VBnTfojeoxKsA",13) == 1438419659) strcat(s, "s");
if (crc32("KhPdplqjS",9) == 3104948209) strcat(s, "a");
if (crc32("LtyJZA",6) == 4022275683) strcat(s, "t");
if (crc32("AVcbzkObdj",10) == 2977882043) strcat(s, "i");
if (crc32("pDWJGZ",6) == 146934990) strcat(s, "r");
if (crc32("ebddUtw",7) == 2231447381) strcat(s, "p");
if (crc32("fLdGaBjlq",9) == 3835923644) strcat(s, "i");
if (crc32("zAPfgZq",7) == 2426015607) strcat(s, "t");
if (crc32("GyMJETIjCNH",11) == 3982330999) strcat(s, "c");
if (crc32("AEwQBbOlEhUXSN",14) == 1667798234) strcat(s, "M");
if (crc32("MRvcYZby",8) == 3374659705) strcat(s, "a");
if (crc32("vyUBP",5) == 4201813449) strcat(s, "k");
if (crc32("PZuxUzbeoLVVinc",15) == 526759918) strcat(s, "l");
if (crc32("rxucvtpIIm",10) == 3544629819) strcat(s, "l");
if (crc32("zJTCuOpRSX",10) == 2629810335) strcat(s, "y");
    return s;
}

char *nondiligently_adverbs() {
    char *s = calloc(14);
    if (crc32("IhgCoe",6) == 994564119) strcat(s, "n");
if (crc32("RbeFx",5) == 2738834552) strcat(s, "o");
if (crc32("sYlveUMaQI",10) == 3430693032) strcat(s, "p");
if (crc32("dWgbtkgrXNRxIdp",15) == 3168434457) strcat(s, "n");
if (crc32("uXBDEZDVSmHK",12) == 2569741367) strcat(s, "d");
if (crc32("APjSLsGWWz",10) == 1598312911) strcat(s, "i");
if (crc32("ExQtgtmCEivup",13) == 1018893579) strcat(s, "l");
if (crc32("IvJvYF",6) == 3205775723) strcat(s, "i");
if (crc32("cRptVYVakNTbbno",15) == 2586953552) strcat(s, "g");
if (crc32("OFGibImpoXejR",13) == 3218464449) strcat(s, "x");
if (crc32("cObwEHPw",8) == 559030931) strcat(s, "e");
if (crc32("vCwMqjiLQbV",11) == 329869988) strcat(s, "X");
if (crc32("bxMIWzTnYj",10) == 2084170437) strcat(s, "n");
if (crc32("shKtt",5) == 3862354200) strcat(s, "t");
if (crc32("NaIRfAiFTRmq",12) == 3714104322) strcat(s, "l");
if (crc32("LLGLgpyJSRQuf",13) == 4254226661) strcat(s, "B");
if (crc32("xnMAGNZNwBVunu",14) == 2888783874) strcat(s, "y");
    return s;
}

char *caliginously_adverbs() {
    char *s = calloc(13);
    if (crc32("VANkK",5) == 3516195295) strcat(s, "y");
if (crc32("GYMyP",5) == 1998634676) strcat(s, "c");
if (crc32("zYRTcwejZ",9) == 2557649091) strcat(s, "a");
if (crc32("UYyfZMp",7) == 898361938) strcat(s, "L");
if (crc32("iZpbEkWkFFxUKB",14) == 3723579755) strcat(s, "l");
if (crc32("OeOALLQ",7) == 197061939) strcat(s, "G");
if (crc32("MwRoYFeNcTkJo",13) == 1896004290) strcat(s, "i");
if (crc32("rYVwSUEdN",9) == 1104359792) strcat(s, "g");
if (crc32("VOLXuhYJtf",10) == 4001673858) strcat(s, "i");
if (crc32("hnbOlcGINdzWTlx",15) == 2610824148) strcat(s, "L");
if (crc32("ASLBNITglQ",10) == 3370752788) strcat(s, "n");
if (crc32("mIixZ",5) == 1791158509) strcat(s, "o");
if (crc32("PjTHnaeWAdQ",11) == 1941323012) strcat(s, "u");
if (crc32("GAhcj",5) == 2854905510) strcat(s, "s");
if (crc32("FDFtAK",6) == 542873450) strcat(s, "l");
if (crc32("MBMUG",5) == 3162024336) strcat(s, "r");
if (crc32("CyvcjTTDxyMcgtv",15) == 1219216554) strcat(s, "y");
    return s;
}

char *vocatively_adverbs() {
    char *s = calloc(11);
    if (crc32("nHJndLnCWeY",11) == 254445556) strcat(s, "R");
if (crc32("tHCqkL",6) == 1812182943) strcat(s, "v");
if (crc32("GBlJaMncB",9) == 2286971013) strcat(s, "A");
if (crc32("IUrxrXyrCqZSG",13) == 1631416371) strcat(s, "o");
if (crc32("NwCPsZJnZrsv",12) == 290157900) strcat(s, "c");
if (crc32("Txvegh",6) == 714665330) strcat(s, "V");
if (crc32("qHwcTrhbemVtoeZ",15) == 589597002) strcat(s, "a");
if (crc32("fODshJFK",8) == 765591232) strcat(s, "v");
if (crc32("nftQAbAolKSj",12) == 2414501748) strcat(s, "t");
if (crc32("hHVVAwWiWrNynGy",15) == 1513303054) strcat(s, "I");
if (crc32("GUmliBGyYdfy",12) == 2978174401) strcat(s, "i");
if (crc32("nYlkNflfa",9) == 2813697569) strcat(s, "v");
if (crc32("gyfIDmcEFmcwp",13) == 1452741237) strcat(s, "e");
if (crc32("UPqGTQjUMIrOQy",14) == 146343736) strcat(s, "l");
if (crc32("ehoaQm",6) == 378420865) strcat(s, "T");
if (crc32("oCsKK",5) == 4040505485) strcat(s, "y");
    return s;
}

char *unawarely_adverbs() {
    char *s = calloc(10);
    if (crc32("IXDSYupTsrM",11) == 660229736) strcat(s, "u");
if (crc32("hxgToJQJsPg",11) == 2422023726) strcat(s, "n");
if (crc32("IMBYVduVOEfUOC",14) == 2289911639) strcat(s, "a");
if (crc32("tVlzQeJlK",9) == 295903829) strcat(s, "H");
if (crc32("StOTkfEVEsQDIZ",14) == 315232420) strcat(s, "w");
if (crc32("IQduVhPbVEqa",12) == 1532091638) strcat(s, "h");
if (crc32("rZpgpkFuSsu",11) == 117230514) strcat(s, "a");
if (crc32("ZQONverw",8) == 4002121109) strcat(s, "r");
if (crc32("hOUiqbNqr",9) == 145715531) strcat(s, "e");
if (crc32("ngKkvYKNIXqdVf",14) == 609480718) strcat(s, "w");
if (crc32("TbRcXlkoZo",10) == 39280763) strcat(s, "l");
if (crc32("MHrPZpjsnoiq",12) == 2133302720) strcat(s, "s");
if (crc32("rpJUIIgBI",9) == 454883719) strcat(s, "y");
    return s;
}

char *nonclerically_adverbs() {
    char *s = calloc(14);
    if (crc32("cwJGrMMbQQgA",12) == 1851709869) strcat(s, "n");
if (crc32("gBwlaMZkSVYmY",13) == 2513600867) strcat(s, "k");
if (crc32("cdZyAsSpWn",10) == 3440144733) strcat(s, "o");
if (crc32("mvKzgQIPyb",10) == 3215339106) strcat(s, "n");
if (crc32("fYsRyRGYhQti",12) == 843685987) strcat(s, "c");
if (crc32("ThLAUjNi",8) == 27956906) strcat(s, "c");
if (crc32("inYjM",5) == 2112604462) strcat(s, "l");
if (crc32("HdNdL",5) == 505054995) strcat(s, "e");
if (crc32("vIobbg",6) == 2916711113) strcat(s, "o");
if (crc32("bXymYrDaPJ",10) == 2133756412) strcat(s, "r");
if (crc32("ZZXDQMituC",10) == 3056983590) strcat(s, "T");
if (crc32("EanrQZwF",8) == 1965637889) strcat(s, "i");
if (crc32("qoAdmFjVYl",10) == 2468044102) strcat(s, "c");
if (crc32("WhSmLIScakSXJhD",15) == 4189911360) strcat(s, "b");
if (crc32("tUzssU",6) == 2628040560) strcat(s, "a");
if (crc32("wlzNYuwSj",9) == 395409430) strcat(s, "L");
if (crc32("oMWPBuTkW",9) == 1540815353) strcat(s, "l");
if (crc32("YGtgAIXgDwVtZd",14) == 4036287091) strcat(s, "L");
if (crc32("VRmVV",5) == 1049844799) strcat(s, "l");
if (crc32("sftQLRBQUIEmLY",14) == 968807778) strcat(s, "Q");
if (crc32("SpPUlXjzyhH",11) == 3872312136) strcat(s, "y");
    return s;
}

char *nonsurrealistically_adverbs() {
    char *s = calloc(20);
    if (crc32("sfkMHGMRfmyts",13) == 4083005306) strcat(s, "n");
if (crc32("cjvLu",5) == 734248024) strcat(s, "h");
if (crc32("BshDtsCWCG",10) == 4275992644) strcat(s, "o");
if (crc32("CbberEQ",7) == 2226019275) strcat(s, "n");
if (crc32("vAHGEyKsCocwrfG",15) == 2008871982) strcat(s, "s");
if (crc32("XBflacko",8) == 538251003) strcat(s, "u");
if (crc32("jOyOFJlE",8) == 3671751705) strcat(s, "P");
if (crc32("qgvaW",5) == 2113174411) strcat(s, "r");
if (crc32("fvlrAkebqaNtrpZ",15) == 2470413115) strcat(s, "a");
if (crc32("xSGxIerJGRYf",12) == 2457082328) strcat(s, "r");
if (crc32("YNXQyMI",7) == 4017280988) strcat(s, "L");
if (crc32("cyqgWXYbweZTKEc",15) == 775473246) strcat(s, "e");
if (crc32("haVfGFYKK",9) == 1176059820) strcat(s, "a");
if (crc32("cNpIgVnPV",9) == 3292612099) strcat(s, "l");
if (crc32("mvGAAOUnLhMwF",13) == 2642585816) strcat(s, "i");
if (crc32("aFQBtoIsT",9) == 3706904712) strcat(s, "W");
if (crc32("UeUvgFPbY",9) == 1459418365) strcat(s, "s");
if (crc32("CdswIH",6) == 3940538796) strcat(s, "R");
if (crc32("rKckRICVUawB",12) == 391049239) strcat(s, "t");
if (crc32("TqxnTmQTsEtIjo",14) == 2243025489) strcat(s, "l");
if (crc32("AlUSpKdfoyiBO",13) == 1384281204) strcat(s, "i");
if (crc32("FwIdFHYjOgU",11) == 4041038337) strcat(s, "j");
if (crc32("UFWbMwpmFHJuXD",14) == 2186619468) strcat(s, "c");
if (crc32("qIFrnJ",6) == 2686587015) strcat(s, "a");
if (crc32("iiixz",5) == 69124571) strcat(s, "l");
if (crc32("sFdgT",5) == 3477823890) strcat(s, "l");
if (crc32("znQhZb",6) == 3291377166) strcat(s, "C");
if (crc32("xDCmrhovOmJDov",14) == 2112193992) strcat(s, "y");
    return s;
}

char *quasieagerly_adverbs() {
    char *s = calloc(13);
    if (crc32("ZTVzsD",6) == 896525113) strcat(s, "A");
if (crc32("nqcudo",6) == 3770361546) strcat(s, "q");
if (crc32("UMDXtcjPtGp",11) == 1050310418) strcat(s, "u");
if (crc32("bHxbDYOIaUYLz",13) == 277834447) strcat(s, "F");
if (crc32("Xhdipnqp",8) == 329781973) strcat(s, "a");
if (crc32("HeZfuPBjeDyZjp",14) == 3047626955) strcat(s, "s");
if (crc32("OdCExSHNAoFGmhz",15) == 2895926876) strcat(s, "i");
if (crc32("EgqifD",6) == 332853215) strcat(s, "e");
if (crc32("aAdgWfyWm",9) == 4167559932) strcat(s, "T");
if (crc32("jNCtDMsx",8) == 2203799857) strcat(s, "a");
if (crc32("VQBwGXOre",9) == 67330409) strcat(s, "g");
if (crc32("GGqLLC",6) == 1347861584) strcat(s, "e");
if (crc32("MtIdqrkcPEPTKR",14) == 1353127224) strcat(s, "C");
if (crc32("zSBgaENBMQaEBLf",15) == 2571491254) strcat(s, "r");
if (crc32("auojHwuxpVW",11) == 2603217840) strcat(s, "l");
if (crc32("YVswkgt",7) == 2151347790) strcat(s, "y");
    return s;
}

char *quasiapologetically_adverbs() {
    char *s = calloc(20);
    if (crc32("BfKdQirOfY",10) == 1827967479) strcat(s, "O");
if (crc32("pwrvelacR",9) == 3023141121) strcat(s, "q");
if (crc32("rKHndAyJ",8) == 2780480696) strcat(s, "u");
if (crc32("MORtybWAtF",10) == 3127957676) strcat(s, "a");
if (crc32("kAhEGedHGUpkU",13) == 3204400913) strcat(s, "s");
if (crc32("ujJqaI",6) == 3956493265) strcat(s, "i");
if (crc32("BSCnZpsJhle",11) == 3791000408) strcat(s, "a");
if (crc32("RhIMNJxEMeCZTI",14) == 3947014373) strcat(s, "M");
if (crc32("JYwedwOyMBE",11) == 257535692) strcat(s, "p");
if (crc32("KqtxICOuG",9) == 1199770132) strcat(s, "q");
if (crc32("azdcccgmdh",10) == 2720601635) strcat(s, "o");
if (crc32("gXnJWLdWanD",11) == 4077775351) strcat(s, "l");
if (crc32("CUPHb",5) == 3523396061) strcat(s, "o");
if (crc32("bGJKS",5) == 3220253986) strcat(s, "g");
if (crc32("kriWw",5) == 3184277821) strcat(s, "B");
if (crc32("IHsBDcypPM",10) == 2943333880) strcat(s, "e");
if (crc32("ywsAvJPNKfE",11) == 4246292953) strcat(s, "t");
if (crc32("KnmWT",5) == 2125344384) strcat(s, "L");
if (crc32("PAmMsklAZDLvCDP",15) == 1053940285) strcat(s, "i");
if (crc32("MFkTrVxEJa",10) == 1713195034) strcat(s, "c");
if (crc32("pvkEMu",6) == 3538911037) strcat(s, "z");
if (crc32("rKbzCRxZLk",10) == 355792655) strcat(s, "a");
if (crc32("IOnbfdFIsJjXT",13) == 2842723038) strcat(s, "O");
if (crc32("bsvRUAUutFLqK",13) == 1913572763) strcat(s, "l");
if (crc32("zePLEHf",7) == 1059699879) strcat(s, "t");
if (crc32("KoiNdLQT",8) == 2792450156) strcat(s, "l");
if (crc32("kWbnxbWTzSsk",12) == 2017115669) strcat(s, "s");
if (crc32("nWvxCzcA",8) == 3441732668) strcat(s, "y");
    return s;
}

char *gradually_adverbs() {
    char *s = calloc(10);
    if (crc32("KSrJLNIqJQXAiHa",15) == 1354274047) strcat(s, "s");
if (crc32("kMuOBnr",7) == 1664480912) strcat(s, "g");
if (crc32("FIZtJWw",7) == 2392925549) strcat(s, "B");
if (crc32("WoFgZTdXvRCGKBJ",15) == 199584368) strcat(s, "r");
if (crc32("pwcGHDaMCPSSFW",14) == 1054017649) strcat(s, "a");
if (crc32("uGEBxdNwfJBfOlo",15) == 2396246255) strcat(s, "J");
if (crc32("pZanjjgHQ",9) == 591269967) strcat(s, "d");
if (crc32("kxXztIckG",9) == 4274107076) strcat(s, "p");
if (crc32("svquymNUgoaw",12) == 1443566592) strcat(s, "u");
if (crc32("odajgqpKEjr",11) == 376705382) strcat(s, "a");
if (crc32("wraIP",5) == 2535031171) strcat(s, "g");
if (crc32("tBaXqv",6) == 1832228493) strcat(s, "l");
if (crc32("TrmXoxFLF",9) == 2784680022) strcat(s, "f");
if (crc32("hSIQdQLpgneuyNh",15) == 3112889414) strcat(s, "l");
if (crc32("kORhDbhscjmZ",12) == 3738287457) strcat(s, "Q");
if (crc32("qKRcIAnPgBiVL",13) == 3177602982) strcat(s, "y");
    return s;
}

char *unmurmurously_adverbs() {
    char *s = calloc(14);
    if (crc32("jzIaOLdTJfOH",12) == 377458516) strcat(s, "u");
if (crc32("pzKdQVOKo",9) == 2684395539) strcat(s, "n");
if (crc32("YgLEsWcnSbRD",12) == 1505206864) strcat(s, "W");
if (crc32("uQEOrFx",7) == 402835777) strcat(s, "m");
if (crc32("teaGvR",6) == 2062349250) strcat(s, "u");
if (crc32("WraGKMknkWuJ",12) == 135311369) strcat(s, "p");
if (crc32("fVQAXktPunlNgGJ",15) == 3407424834) strcat(s, "r");
if (crc32("EaSojUy",7) == 4283704686) strcat(s, "m");
if (crc32("Bfsvovc",7) == 2384875705) strcat(s, "u");
if (crc32("wNLiFm",6) == 1136826558) strcat(s, "r");
if (crc32("hQOzFGkVsxLKJJf",15) == 2052373038) strcat(s, "L");
if (crc32("fUDCosDdcsCcE",13) == 153141502) strcat(s, "o");
if (crc32("HAAHx",5) == 2586771513) strcat(s, "u");
if (crc32("wFALTzLzJ",9) == 3112519994) strcat(s, "N");
if (crc32("jwyQSuMcPsdc",12) == 1105307261) strcat(s, "s");
if (crc32("JYJOosobjloybxL",15) == 1369457470) strcat(s, "g");
if (crc32("VvSExEJdwvR",11) == 2714916668) strcat(s, "l");
if (crc32("FMBLKjBwf",9) == 3543409659) strcat(s, "B");
if (crc32("TjvpGbtuYaZf",12) == 2017622390) strcat(s, "y");
    return s;
}

char *inimically_adverbs() {
    char *s = calloc(11);
    if (crc32("JFjwrLDSM",9) == 3149197270) strcat(s, "i");
if (crc32("BiBBddwBMJbeNZ",14) == 2634428015) strcat(s, "i");
if (crc32("OdsNTbR",7) == 3236470050) strcat(s, "n");
if (crc32("vdAUvpCuNCeGr",13) == 3403696538) strcat(s, "A");
if (crc32("OTQilyMVtB",10) == 2099109244) strcat(s, "i");
if (crc32("NcdAzvQuonSMl",13) == 4176195350) strcat(s, "m");
if (crc32("xOAphAYsLO",10) == 171463808) strcat(s, "c");
if (crc32("SCBtDPImLK",10) == 2451704627) strcat(s, "i");
if (crc32("fxWlk",5) == 67131853) strcat(s, "c");
if (crc32("ZPBhpmCFtKfFUZ",14) == 1498810717) strcat(s, "a");
if (crc32("oFDvSE",6) == 1291440581) strcat(s, "l");
if (crc32("lxWSsCD",7) == 2580712082) strcat(s, "l");
if (crc32("qMbFkOMGNc",10) == 824086585) strcat(s, "h");
if (crc32("nUTFAtbeGJswFaf",15) == 74735480) strcat(s, "y");
    return s;
}

char *blackly_adverbs() {
    char *s = calloc(8);
    if (crc32("FOTvwxsOH",9) == 3050661770) strcat(s, "p");
if (crc32("rBsKzN",6) == 2498402040) strcat(s, "b");
if (crc32("omxgqKm",7) == 1310069262) strcat(s, "l");
if (crc32("ibkeDvXzBLkASI",14) == 3818229805) strcat(s, "a");
if (crc32("NGniIMMaC",9) == 674639683) strcat(s, "w");
if (crc32("WxLjpkwHl",9) == 2644805475) strcat(s, "c");
if (crc32("nhhLZIc",7) == 1323946288) strcat(s, "k");
if (crc32("MIbuoMJtFKS",11) == 53663402) strcat(s, "k");
if (crc32("GugVvM",6) == 761629229) strcat(s, "l");
if (crc32("BfRRvJrLNY",10) == 3871237613) strcat(s, "o");
if (crc32("FPAkAeP",7) == 1026867152) strcat(s, "y");
    return s;
}

char *unveritably_adverbs() {
    char *s = calloc(12);
    if (crc32("rDztbMIQlc",10) == 2652363959) strcat(s, "A");
if (crc32("hHxzOdqDJXBwOpz",15) == 3790204690) strcat(s, "u");
if (crc32("TmcMvOhSIGP",11) == 4208657862) strcat(s, "n");
if (crc32("ULrCDeow",8) == 3566790339) strcat(s, "v");
if (crc32("BjWbImCn",8) == 73927277) strcat(s, "e");
if (crc32("TGFHS",5) == 3014118051) strcat(s, "r");
if (crc32("bYvZGeEv",8) == 3046166331) strcat(s, "V");
if (crc32("UOqsGSvs",8) == 1828416955) strcat(s, "i");
if (crc32("pnuYGiaIXS",10) == 4115535282) strcat(s, "l");
if (crc32("bSPDQjEbkT",10) == 2179155802) strcat(s, "t");
if (crc32("tfmWBR",6) == 1462194) strcat(s, "F");
if (crc32("vugqbKwfWU",10) == 210693976) strcat(s, "a");
if (crc32("XeExaEuDFqHvVT",14) == 1680853900) strcat(s, "z");
if (crc32("FXYrTWgdiOpCgN",14) == 1756230162) strcat(s, "b");
if (crc32("qBvIa",5) == 2029985716) strcat(s, "l");
if (crc32("GIknYboGk",9) == 2432792244) strcat(s, "l");
if (crc32("JiaEqEBfX",9) == 1563744016) strcat(s, "y");
    return s;
}

char *pseudoeducationally_adverbs() {
    char *s = calloc(20);
    if (crc32("mlpaJl",6) == 1601757892) strcat(s, "g");
if (crc32("DHJahUrV",8) == 3194258325) strcat(s, "p");
if (crc32("ouZKBrlBYJ",10) == 2058749246) strcat(s, "h");
if (crc32("KmHRzlkCZpMMaf",14) == 3200963934) strcat(s, "s");
if (crc32("BXWOSbBw",8) == 3164262722) strcat(s, "k");
if (crc32("fcELpRtZJNMjSR",14) == 378583680) strcat(s, "e");
if (crc32("BkeNOaI",7) == 3067798470) strcat(s, "X");
if (crc32("QpqicqZGfNQyY",13) == 2434656706) strcat(s, "u");
if (crc32("mQOCONfSIA",10) == 1862201035) strcat(s, "d");
if (crc32("csjaKNhYT",9) == 1476747222) strcat(s, "o");
if (crc32("HWAiSL",6) == 1386804898) strcat(s, "e");
if (crc32("LctDyabIHVfbNz",14) == 3912353030) strcat(s, "q");
if (crc32("DQjKr",5) == 4029065595) strcat(s, "d");
if (crc32("GcvAk",5) == 1713175007) strcat(s, "u");
if (crc32("StIQRGDEOwOmW",13) == 2275257912) strcat(s, "S");
if (crc32("jITKdZu",7) == 882799319) strcat(s, "c");
if (crc32("QvxENekFHuxexfN",15) == 3223542534) strcat(s, "Y");
if (crc32("WHHZiUEsYhIvYLR",15) == 2962097644) strcat(s, "a");
if (crc32("WkaJFqvCcal",11) == 3779625015) strcat(s, "B");
if (crc32("xSittwuozD",10) == 4194444367) strcat(s, "t");
if (crc32("yUKeWSVyiFfLTy",14) == 1936746967) strcat(s, "i");
if (crc32("DHFPPQqoyDOvkO",14) == 1845624894) strcat(s, "V");
if (crc32("pucZXlaQrtoOc",13) == 1294633874) strcat(s, "o");
if (crc32("LyHHlLxFgZrHzlK",15) == 4166163575) strcat(s, "n");
if (crc32("jjXAbqisyDMyZTF",15) == 3963971599) strcat(s, "a");
if (crc32("elboYp",6) == 3491342803) strcat(s, "V");
if (crc32("EDBlSFY",7) == 2520457074) strcat(s, "l");
if (crc32("viiIidggXLRgq",13) == 2903426617) strcat(s, "l");
if (crc32("pxvsTPu",7) == 644276323) strcat(s, "z");
if (crc32("QtsxdheeOpAbhwn",15) == 1537561599) strcat(s, "y");
    return s;
}

char *quasidoubtfully_adverbs() {
    char *s = calloc(16);
    if (crc32("FGYBulYRpf",10) == 115276977) strcat(s, "q");
if (crc32("uMfQHoQo",8) == 1804181159) strcat(s, "Q");
if (crc32("NvZhaTLMgykSrAh",15) == 4244535354) strcat(s, "u");
if (crc32("veZhAqOJQ",9) == 2198518838) strcat(s, "U");
if (crc32("sHUeVnSkxuoNyG",14) == 2392083450) strcat(s, "a");
if (crc32("KHEmyBcXZK",10) == 2415823249) strcat(s, "s");
if (crc32("janlSnDvbiGS",12) == 614188462) strcat(s, "i");
if (crc32("NWFZCekABfjcLPW",15) == 2726803517) strcat(s, "i");
if (crc32("PaniKvFXRQiZr",13) == 3818695945) strcat(s, "d");
if (crc32("Oodusgm",7) == 2849427662) strcat(s, "o");
if (crc32("lTxdzXbNV",9) == 3685359109) strcat(s, "u");
if (crc32("NOored",6) == 945186031) strcat(s, "b");
if (crc32("HNotzjKmmiOgzvx",15) == 1547218079) strcat(s, "t");
if (crc32("AIFJdwrrkiyGYZB",15) == 606498417) strcat(s, "P");
if (crc32("piiqUy",6) == 3553256249) strcat(s, "f");
if (crc32("NAWxHysKhTUwXK",14) == 3742210479) strcat(s, "B");
if (crc32("HCnkI",5) == 3963665972) strcat(s, "u");
if (crc32("RHCdBTDKWz",10) == 4221446004) strcat(s, "r");
if (crc32("oQMIKwdY",8) == 31673069) strcat(s, "l");
if (crc32("TWnMLiXgXZM",11) == 3060085751) strcat(s, "m");
if (crc32("gWUZnAkeF",9) == 2601338479) strcat(s, "l");
if (crc32("BulJHaUN",8) == 1162613947) strcat(s, "t");
if (crc32("ghVnEcgPRAPnh",13) == 815864410) strcat(s, "y");
    return s;
}

char *agamically_adverbs() {
    char *s = calloc(11);
    if (crc32("YMwJKETXRJLp",12) == 1971982822) strcat(s, "a");
if (crc32("YAIjSxgV",8) == 487386372) strcat(s, "g");
if (crc32("THytMHDzZV",10) == 1526660395) strcat(s, "X");
if (crc32("QoPoJasmyMJOhDv",15) == 2432952300) strcat(s, "a");
if (crc32("DvyqVlJDYLKd",12) == 4187727812) strcat(s, "m");
if (crc32("drRjpVVBqKgod",13) == 3790909410) strcat(s, "F");
if (crc32("YMmSVK",6) == 2423896473) strcat(s, "i");
if (crc32("PQVkrXccZniqTT",14) == 2009636923) strcat(s, "c");
if (crc32("qYudPqiXMizm",12) == 640448566) strcat(s, "a");
if (crc32("xVfAxkURXcXpwBu",15) == 3366453019) strcat(s, "l");
if (crc32("ZXVkBNK",7) == 1569327689) strcat(s, "l");
if (crc32("YaPMDilvXmOiz",13) == 1121387131) strcat(s, "y");
    return s;
}

char *superexceptionally_adverbs() {
    char *s = calloc(19);
    if (crc32("VKdmKFzetkWUMB",14) == 1410854995) strcat(s, "s");
if (crc32("jWoZMCvwBx",10) == 1495517885) strcat(s, "y");
if (crc32("vpjZeCbtB",9) == 194153397) strcat(s, "u");
if (crc32("SoLSMsUAMqZ",11) == 4157713401) strcat(s, "p");
if (crc32("UZdztcW",7) == 1904028841) strcat(s, "n");
if (crc32("xIWkWMazqZK",11) == 3614851405) strcat(s, "e");
if (crc32("lmnQuUae",8) == 1210235949) strcat(s, "r");
if (crc32("umcmchoYycBb",12) == 3695784007) strcat(s, "e");
if (crc32("NQdtYjhdquP",11) == 4274922257) strcat(s, "x");
if (crc32("IcUKrDiGu",9) == 2041443091) strcat(s, "Y");
if (crc32("fcouMHdFbF",10) == 1046780455) strcat(s, "c");
if (crc32("IABGfrujj",9) == 130905647) strcat(s, "e");
if (crc32("IxBdwvd",7) == 4119469524) strcat(s, "u");
if (crc32("scFmVgRQRGANuro",15) == 3618830637) strcat(s, "p");
if (crc32("ciYBKcdIlTyI",12) == 1500667074) strcat(s, "t");
if (crc32("IJmNYUhGSD",10) == 626106616) strcat(s, "i");
if (crc32("znsPOmdZkJkddLa",15) == 976243931) strcat(s, "o");
if (crc32("ZpDNFZHfqnNQpMk",15) == 524609624) strcat(s, "H");
if (crc32("JQVjzWzalyPQs",13) == 2223887301) strcat(s, "n");
if (crc32("gHqnfoTEm",9) == 4229812575) strcat(s, "a");
if (crc32("WAALKEAkWvDIq",13) == 1270022483) strcat(s, "l");
if (crc32("kZBVNDkIPsLCP",13) == 3602915684) strcat(s, "R");
if (crc32("wnfUTqlfLR",10) == 3011088363) strcat(s, "l");
if (crc32("eUImNzZVGBCoR",13) == 2311897697) strcat(s, "y");
    return s;
}

char *dyspeptically_adverbs() {
    char *s = calloc(14);
    if (crc32("asFTrbttIcw",11) == 1593664295) strcat(s, "Q");
if (crc32("upiyQgAMZx",10) == 482203139) strcat(s, "d");
if (crc32("nMqrN",5) == 2096800714) strcat(s, "x");
if (crc32("DAMYr",5) == 3855212114) strcat(s, "y");
if (crc32("uJUelgp",7) == 2067388345) strcat(s, "g");
if (crc32("qXdIeNIw",8) == 1245850091) strcat(s, "s");
if (crc32("zDeOxSHMnyRCmxJ",15) == 3095031816) strcat(s, "l");
if (crc32("KkPdaSqowLbOiP",14) == 1007758385) strcat(s, "p");
if (crc32("qGaZiKHgyyUQ",12) == 890662603) strcat(s, "e");
if (crc32("soUvcHE",7) == 2330614668) strcat(s, "D");
if (crc32("DPBeeZrLbss",11) == 2087440787) strcat(s, "p");
if (crc32("VGBDqdw",7) == 1672656191) strcat(s, "t");
if (crc32("jKNqUxRDpv",10) == 447682517) strcat(s, "i");
if (crc32("yaaKYUbQHX",10) == 4136223107) strcat(s, "S");
if (crc32("NcoXAWhRzGRVeL",14) == 2393574403) strcat(s, "c");
if (crc32("XsiCmU",6) == 281905831) strcat(s, "a");
if (crc32("pgSSxJWcbOR",11) == 2981337505) strcat(s, "N");
if (crc32("YtcScMFrH",9) == 2253651473) strcat(s, "l");
if (crc32("bfNjHeJBoMlsuP",14) == 2070987041) strcat(s, "r");
if (crc32("wCWSQUvlrGbAQA",14) == 1374564279) strcat(s, "l");
if (crc32("RTgdYmZcqhkASk",14) == 3450980519) strcat(s, "F");
if (crc32("GDRfxxxLWn",10) == 1172305017) strcat(s, "y");
    return s;
}

char *hysteretically_adverbs() {
    char *s = calloc(15);
    if (crc32("YHMZNkhnCocFEDz",15) == 1089373057) strcat(s, "h");
if (crc32("KKCeKJxTQSrqv",13) == 3907489211) strcat(s, "A");
if (crc32("jNrqcUlBda",10) == 3492592159) strcat(s, "y");
if (crc32("XShrwGJdxThYYfy",15) == 1635228882) strcat(s, "F");
if (crc32("RlckAKVz",8) == 1575160162) strcat(s, "s");
if (crc32("VehJF",5) == 2925794293) strcat(s, "t");
if (crc32("ebMTPkaerwzszPG",15) == 552752560) strcat(s, "e");
if (crc32("opXaR",5) == 210629750) strcat(s, "F");
if (crc32("KRrHC",5) == 134557813) strcat(s, "r");
if (crc32("cdnZZzBFwEHC",12) == 1293259002) strcat(s, "a");
if (crc32("vEIfJyV",7) == 118951231) strcat(s, "e");
if (crc32("JFstdCByNmtfgDu",15) == 2121712974) strcat(s, "t");
if (crc32("dakqPsaMHhssfFL",15) == 92157396) strcat(s, "i");
if (crc32("GeaRzkvFUSf",11) == 1121408827) strcat(s, "c");
if (crc32("NuznsLfTW",9) == 1715283087) strcat(s, "a");
if (crc32("ZfjkJJohuGjg",12) == 2574288630) strcat(s, "x");
if (crc32("PGEVmAKLhMh",11) == 4176344211) strcat(s, "l");
if (crc32("eWpypJk",7) == 4245662998) strcat(s, "M");
if (crc32("BPtecEZQPlAw",12) == 2073511036) strcat(s, "l");
if (crc32("CUdrnVRavFYDS",13) == 78065420) strcat(s, "y");
    return s;
}

char *pesteringly_adverbs() {
    char *s = calloc(12);
    if (crc32("ZEriSfX",7) == 4009069150) strcat(s, "B");
if (crc32("QLkrQNSOWtF",11) == 3612985791) strcat(s, "p");
if (crc32("iEYtzlEj",8) == 3313310953) strcat(s, "q");
if (crc32("uYFQTyEDe",9) == 4066719528) strcat(s, "e");
if (crc32("eKynDKNZVyuclWR",15) == 2532224791) strcat(s, "j");
if (crc32("VFXkEBgOsTDujS",14) == 3508220309) strcat(s, "s");
if (crc32("yqAwF",5) == 1878679097) strcat(s, "t");
if (crc32("nfecToe",7) == 554499570) strcat(s, "A");
if (crc32("QGrbkjYMhpdvGie",15) == 1861353586) strcat(s, "e");
if (crc32("FSKcVhXYMEIpe",13) == 1030012632) strcat(s, "r");
if (crc32("XRdSrCYz",8) == 3544060514) strcat(s, "r");
if (crc32("FJxYwUwMEvl",11) == 3250588671) strcat(s, "i");
if (crc32("yYvWp",5) == 1902549958) strcat(s, "n");
if (crc32("AxGNInIysBvgHv",14) == 3114062330) strcat(s, "g");
if (crc32("vjqYrh",6) == 1370816587) strcat(s, "l");
if (crc32("dCgCS",5) == 1201606766) strcat(s, "y");
    return s;
}

char *dreadfully_adverbs() {
    char *s = calloc(11);
    if (crc32("eVFqMDFzsZBP",12) == 1140584550) strcat(s, "u");
if (crc32("VnBvtUgGXjLUeEU",15) == 542798938) strcat(s, "d");
if (crc32("TNeSaDqPlUrzPpC",15) == 976059263) strcat(s, "I");
if (crc32("feyBvhhUw",9) == 2909954389) strcat(s, "r");
if (crc32("iltZz",5) == 202602067) strcat(s, "C");
if (crc32("fAigWGCqaxwHoUa",15) == 1964727232) strcat(s, "e");
if (crc32("AaoIaPDRVshT",12) == 2213147103) strcat(s, "a");
if (crc32("vOBOaCepaGp",11) == 1476371364) strcat(s, "o");
if (crc32("exhdcraOYvJ",11) == 185617634) strcat(s, "d");
if (crc32("RuwYBHTzXpTo",12) == 2402775556) strcat(s, "f");
if (crc32("ruzGAPRa",8) == 311701623) strcat(s, "K");
if (crc32("QegOlSmEbuUFPoY",15) == 2283834460) strcat(s, "u");
if (crc32("PRlrTygeCvGfXv",14) == 2246892137) strcat(s, "l");
if (crc32("JdVLX",5) == 828922988) strcat(s, "l");
if (crc32("NexoFEiLQLcVSSA",15) == 3119757473) strcat(s, "y");
    return s;
}

char *freakishly_adverbs() {
    char *s = calloc(11);
    if (crc32("GYjHnRLDs",9) == 1897595927) strcat(s, "e");
if (crc32("QJIfJybFatSyn",13) == 927556634) strcat(s, "f");
if (crc32("PFmyCSspcwKd",12) == 3783133618) strcat(s, "r");
if (crc32("MVTrTyyFsgO",11) == 509939803) strcat(s, "s");
if (crc32("HMoYQpy",7) == 2679220623) strcat(s, "e");
if (crc32("WNxlkDfBdxSCV",13) == 2685101515) strcat(s, "z");
if (crc32("hquxLVATzCp",11) == 4146968863) strcat(s, "a");
if (crc32("yQzsdjal",8) == 1399784910) strcat(s, "b");
if (crc32("KyAzNGa",7) == 1775614771) strcat(s, "k");
if (crc32("ENPkYImrm",9) == 260331301) strcat(s, "r");
if (crc32("hoQhBiDM",8) == 2669766784) strcat(s, "i");
if (crc32("LOJqGJnmEOoIm",13) == 2091777315) strcat(s, "A");
if (crc32("nuuSuVdjgT",10) == 991909575) strcat(s, "s");
if (crc32("ZgwyBkaoi",9) == 2047278905) strcat(s, "v");
if (crc32("ZNRUaMgiMHzN",12) == 1200499606) strcat(s, "h");
if (crc32("nqlxhfhYl",9) == 2771151831) strcat(s, "f");
if (crc32("AnuVdT",6) == 176392356) strcat(s, "l");
if (crc32("mSVXqrSd",8) == 2985961176) strcat(s, "y");
    return s;
}

char *nonarithmetically_adverbs() {
    char *s = calloc(18);
    if (crc32("nQkyNLaLoU",10) == 2916106831) strcat(s, "B");
if (crc32("VzAOKUxpiCLSWg",14) == 72442775) strcat(s, "n");
if (crc32("bsNPCspNTmYfS",13) == 3047703345) strcat(s, "o");
if (crc32("sjPio",5) == 692451570) strcat(s, "n");
if (crc32("okwGupjZHxuwTDb",15) == 4265133522) strcat(s, "a");
if (crc32("TSBmOHRhaAC",11) == 3907173701) strcat(s, "r");
if (crc32("dhrKPhCGxXr",11) == 1532515407) strcat(s, "A");
if (crc32("RUbAEBh",7) == 1112026647) strcat(s, "i");
if (crc32("Wchwpju",7) == 1797468983) strcat(s, "S");
if (crc32("zvCLsvVTCk",10) == 3659662719) strcat(s, "t");
if (crc32("vhzIuJz",7) == 1599624250) strcat(s, "O");
if (crc32("gVoAJucvzLz",11) == 1588033899) strcat(s, "h");
if (crc32("IdzEtuVKFd",10) == 448800170) strcat(s, "o");
if (crc32("azKtbXZWc",9) == 3944689970) strcat(s, "m");
if (crc32("UKEHmYWLjVE",11) == 3853439806) strcat(s, "F");
if (crc32("HMoIcqJNcubhdbK",15) == 41366894) strcat(s, "e");
if (crc32("TUSqzNDWSipz",12) == 2113613780) strcat(s, "z");
if (crc32("gkzSinHAreSqFp",14) == 846353945) strcat(s, "t");
if (crc32("dDwWvgyCP",9) == 1231624899) strcat(s, "i");
if (crc32("bxwPOrD",7) == 4055198307) strcat(s, "c");
if (crc32("EtoYzNHA",8) == 2535760852) strcat(s, "a");
if (crc32("FbBCy",5) == 19786124) strcat(s, "l");
if (crc32("IEHQDthgo",9) == 3173539652) strcat(s, "l");
if (crc32("EhdIiwCjrWWPQFq",15) == 2895042512) strcat(s, "y");
    return s;
}

char *raveningly_adverbs() {
    char *s = calloc(11);
    if (crc32("zzudJDYjdVmquoG",15) == 1909655157) strcat(s, "r");
if (crc32("qTUsT",5) == 3776738081) strcat(s, "C");
if (crc32("OYysUhR",7) == 3419419441) strcat(s, "a");
if (crc32("YTJiraUL",8) == 2712973122) strcat(s, "x");
if (crc32("LTrHQuNmHGpwFDI",15) == 4224862105) strcat(s, "v");
if (crc32("vpqINNB",7) == 3694578264) strcat(s, "V");
if (crc32("KIrHSGFnhRAqEmB",15) == 1157158639) strcat(s, "e");
if (crc32("sxsJThtIF",9) == 760022104) strcat(s, "Y");
if (crc32("IRmURDLTKOD",11) == 1224307353) strcat(s, "n");
if (crc32("tamCltTAXs",10) == 3783367172) strcat(s, "b");
if (crc32("aFMCTEG",7) == 1315828586) strcat(s, "i");
if (crc32("wCfJVfaPkubja",13) == 3565393781) strcat(s, "n");
if (crc32("QMOutHyiTir",11) == 3801920983) strcat(s, "q");
if (crc32("JFxdxITneYEV",12) == 80034651) strcat(s, "g");
if (crc32("VbREUkKIHiFjUc",14) == 2894861946) strcat(s, "l");
if (crc32("ExYrMTcOTbltJQJ",15) == 736385193) strcat(s, "i");
if (crc32("cHfPuZFpLtc",11) == 472001717) strcat(s, "y");
    return s;
}

char *overnegligently_adverbs() {
    char *s = calloc(16);
    if (crc32("DQxEdf",6) == 2590946526) strcat(s, "P");
if (crc32("mROledEhe",9) == 2456350573) strcat(s, "o");
if (crc32("yplGaNOX",8) == 1149203489) strcat(s, "v");
if (crc32("QhbOVVFkBqHsgf",14) == 3260132611) strcat(s, "f");
if (crc32("vHzKS",5) == 1452927398) strcat(s, "e");
if (crc32("MmLYUVhULUSi",12) == 1140099931) strcat(s, "r");
if (crc32("TxejyikJcKoBG",13) == 1282022063) strcat(s, "n");
if (crc32("isWJwYGfUkksH",13) == 2821885008) strcat(s, "e");
if (crc32("giiwTmHsvPKb",12) == 4083269036) strcat(s, "G");
if (crc32("wrBowmTDIhkiKO",14) == 2626591506) strcat(s, "g");
if (crc32("cXrPGqWUSmnnSL",14) == 3099828550) strcat(s, "N");
if (crc32("QzdEKa",6) == 778005216) strcat(s, "l");
if (crc32("ZbfSua",6) == 3318922058) strcat(s, "P");
if (crc32("LbWivKCrVBALrw",14) == 3186840557) strcat(s, "i");
if (crc32("bCRNXMaPXID",11) == 1604118888) strcat(s, "f");
if (crc32("GavEipAFiByxi",13) == 1476618438) strcat(s, "g");
if (crc32("IowjceoMrVz",11) == 2830675255) strcat(s, "e");
if (crc32("zjCRVCprC",9) == 3718763463) strcat(s, "o");
if (crc32("WUzCEoRzaT",10) == 2759953701) strcat(s, "n");
if (crc32("tsKFHheqfz",10) == 2853413460) strcat(s, "b");
if (crc32("zjTOStiiPJC",11) == 3081856836) strcat(s, "t");
if (crc32("PghystqEqWEXhDM",15) == 1544307829) strcat(s, "l");
if (crc32("sRQHcRtbRok",11) == 531623011) strcat(s, "y");
    return s;
}

char *nonorally_adverbs() {
    char *s = calloc(10);
    if (crc32("MVzxNqruluX",11) == 3419924807) strcat(s, "e");
if (crc32("mHsSOOaWARHRk",13) == 2684926514) strcat(s, "n");
if (crc32("mbYvAsr",7) == 2183648034) strcat(s, "o");
if (crc32("TTEXOHD",7) == 407004488) strcat(s, "N");
if (crc32("vlvnHIkhPGIKhj",14) == 683910925) strcat(s, "n");
if (crc32("AHdvTaaGzmoxLsF",15) == 2663325772) strcat(s, "c");
if (crc32("ZndJuGuOPytaIGu",15) == 3031143017) strcat(s, "o");
if (crc32("MEHDUQZijbPUazb",15) == 2264070262) strcat(s, "y");
if (crc32("KCiCQGXVmxnLGHo",15) == 3315732555) strcat(s, "r");
if (crc32("KnxwgiolWLhMVZX",15) == 951851726) strcat(s, "Y");
if (crc32("GPPYVYu",7) == 3179225649) strcat(s, "a");
if (crc32("drnmQiiEieV",11) == 2929428060) strcat(s, "e");
if (crc32("dUfSqZjfvDNesyB",15) == 3612035620) strcat(s, "l");
if (crc32("DiFSJrHgERS",11) == 457503080) strcat(s, "Q");
if (crc32("bgoXZsVyiGmoH",13) == 3053012556) strcat(s, "l");
if (crc32("thDczADWqARZ",12) == 87780520) strcat(s, "e");
if (crc32("nJreJkImNunjLV",14) == 937243564) strcat(s, "y");
    return s;
}

char *offensively_adverbs() {
    char *s = calloc(12);
    if (crc32("dcmUdvfGJsDH",12) == 604038245) strcat(s, "o");
if (crc32("DiSRTrDyebHCP",13) == 4156012131) strcat(s, "O");
if (crc32("kLGiYtpItBYw",12) == 1278601644) strcat(s, "f");
if (crc32("ibDtG",5) == 4277908781) strcat(s, "V");
if (crc32("lVRpVp",6) == 4038488190) strcat(s, "f");
if (crc32("eRkcCFAD",8) == 2392878198) strcat(s, "N");
if (crc32("ZfBdkNFBZKx",11) == 4288630593) strcat(s, "e");
if (crc32("DrsxZRk",7) == 1224547538) strcat(s, "n");
if (crc32("QCJcCUkf",8) == 940706507) strcat(s, "s");
if (crc32("zyuvJhHUKRDnE",13) == 3849782461) strcat(s, "i");
if (crc32("luHLnPKjsfE",11) == 3365588695) strcat(s, "Y");
if (crc32("eZAAXjELfmEZwtE",15) == 49301910) strcat(s, "v");
if (crc32("DZXeoFEQKOjPY",13) == 3983418325) strcat(s, "e");
if (crc32("gKFEn",5) == 709186073) strcat(s, "t");
if (crc32("PfcZWRdhSNvJNq",14) == 1637325957) strcat(s, "l");
if (crc32("rphJULqBFfZBa",13) == 994581798) strcat(s, "f");
if (crc32("Eqbakig",7) == 136507227) strcat(s, "y");
    return s;
}

char *tartly_adverbs() {
    char *s = calloc(7);
    if (crc32("PrcAoF",6) == 458176044) strcat(s, "t");
if (crc32("hyqshTvDpxkoR",13) == 4221101859) strcat(s, "W");
if (crc32("FUkxZTvuGV",10) == 1530200939) strcat(s, "a");
if (crc32("WFvlUHffVNAnS",13) == 4130060630) strcat(s, "B");
if (crc32("ByGevlNp",8) == 92509019) strcat(s, "r");
if (crc32("EVhXlJWVe",9) == 2841662874) strcat(s, "t");
if (crc32("aKPOxfFhSD",10) == 4107960076) strcat(s, "R");
if (crc32("eccoyReBTW",10) == 2834318157) strcat(s, "l");
if (crc32("WbuEkDOioNdsmE",14) == 3718597077) strcat(s, "g");
if (crc32("RUvvyZyyGmrkR",13) == 2500281015) strcat(s, "y");
    return s;
}

char *Gallice_adverbs() {
    char *s = calloc(8);
    if (crc32("hewJM",5) == 4169840781) strcat(s, "P");
if (crc32("oTHAzGX",7) == 3209193665) strcat(s, "G");
if (crc32("FKWAsQL",7) == 4119675795) strcat(s, "J");
if (crc32("zglXuxe",7) == 452599402) strcat(s, "a");
if (crc32("LsByPWeghUWCy",13) == 3503225556) strcat(s, "l");
if (crc32("qvoFqGbAEVB",11) == 1496195940) strcat(s, "l");
if (crc32("xBCHLOWWNHZsHS",14) == 2801987576) strcat(s, "i");
if (crc32("PLgRum",6) == 766723328) strcat(s, "c");
if (crc32("rFZzqZPTFIwxUH",14) == 4001100120) strcat(s, "c");
if (crc32("CKSEoJXl",8) == 3055256552) strcat(s, "e");
    return s;
}

char *halfmentally_adverbs() {
    char *s = calloc(13);
    if (crc32("vVdzIRzmxyEwzBT",15) == 1886519620) strcat(s, "h");
if (crc32("GrhVwOv",7) == 2417223135) strcat(s, "s");
if (crc32("lCGQznYdeEF",11) == 3233279657) strcat(s, "a");
if (crc32("xTeOHhUrTZvB",12) == 4271022159) strcat(s, "l");
if (crc32("wTDXbmVTI",9) == 1617339627) strcat(s, "f");
if (crc32("hOBYJehofPlrYQ",14) == 76244974) strcat(s, "I");
if (crc32("cHpTkrxD",8) == 2803277230) strcat(s, "m");
if (crc32("eRiDHiEWlQCCNQg",15) == 1205325996) strcat(s, "e");
if (crc32("AGZfVZ",6) == 2510243049) strcat(s, "h");
if (crc32("YIRmeUVHpnV",11) == 1546176698) strcat(s, "n");
if (crc32("kFXef",5) == 1212912167) strcat(s, "t");
if (crc32("yIGdHYTPzWXx",12) == 175069381) strcat(s, "j");
if (crc32("EEnEHPmRDd",10) == 2145957639) strcat(s, "a");
if (crc32("lCFQC",5) == 723720143) strcat(s, "l");
if (crc32("ZhxXrWrBHPP",11) == 3425135268) strcat(s, "v");
if (crc32("gGqXxTFciNr",11) == 777695990) strcat(s, "l");
if (crc32("bMaYXYfINMG",11) == 364134667) strcat(s, "y");
    return s;
}

char *sterically_adverbs() {
    char *s = calloc(11);
    if (crc32("EyTsnDRsU",9) == 2501658583) strcat(s, "e");
if (crc32("kjpEy",5) == 2357050542) strcat(s, "s");
if (crc32("dABGx",5) == 225418751) strcat(s, "s");
if (crc32("ntesuvqrNhhi",12) == 2257384135) strcat(s, "t");
if (crc32("emMWECjPldnn",12) == 3349923660) strcat(s, "e");
if (crc32("HlBPAnTFvj",10) == 1918891742) strcat(s, "Y");
if (crc32("ARZfGDoVB",9) == 2834739375) strcat(s, "r");
if (crc32("jkXsSCH",7) == 1826225593) strcat(s, "i");
if (crc32("chFvTHZyj",9) == 2139463542) strcat(s, "N");
if (crc32("VjuqWHdhPOz",11) == 3679687079) strcat(s, "c");
if (crc32("HTJyAB",6) == 1097070039) strcat(s, "a");
if (crc32("NKBWagSEDkM",11) == 1084368746) strcat(s, "Z");
if (crc32("PIKIIIi",7) == 894404733) strcat(s, "l");
if (crc32("lyHhHEc",7) == 1283079768) strcat(s, "l");
if (crc32("XJHcl",5) == 1320485409) strcat(s, "y");
    return s;
}

char *Spartanically_adverbs() {
    char *s = calloc(14);
    if (crc32("aDimLIl",7) == 1697990444) strcat(s, "S");
if (crc32("WZmPdSadj",9) == 1327681190) strcat(s, "o");
if (crc32("ZJSXdqQjMJ",10) == 2137759583) strcat(s, "p");
if (crc32("VfFzof",6) == 2570556778) strcat(s, "r");
if (crc32("UkAiPTIl",8) == 1685366480) strcat(s, "a");
if (crc32("mUFnIvFFeB",10) == 3755481179) strcat(s, "r");
if (crc32("TINiYylFBGqC",12) == 2634949306) strcat(s, "y");
if (crc32("soxbYO",6) == 1339298673) strcat(s, "t");
if (crc32("kYkExBcTEcTrDWD",15) == 2668327042) strcat(s, "i");
if (crc32("WlUADpOJ",8) == 3999840228) strcat(s, "a");
if (crc32("FxlPQwEICZPEGJ",14) == 1436518396) strcat(s, "F");
if (crc32("QUQFOqe",7) == 2411418174) strcat(s, "n");
if (crc32("byWzqsbOw",9) == 614703295) strcat(s, "i");
if (crc32("GbvfomZcFNycCDi",15) == 159206586) strcat(s, "I");
if (crc32("mDFgR",5) == 1748547393) strcat(s, "c");
if (crc32("CocRQYVglocEdQ",14) == 3751586980) strcat(s, "B");
if (crc32("oaawDTE",7) == 3732074758) strcat(s, "a");
if (crc32("FOSQpJXvwK",10) == 1582946452) strcat(s, "Z");
if (crc32("OfKMqccu",8) == 1336418295) strcat(s, "l");
if (crc32("qjgBhhkJD",9) == 604914656) strcat(s, "l");
if (crc32("GiTZODydnuCP",12) == 2058270305) strcat(s, "y");
    return s;
}

char *saintlily_adverbs() {
    char *s = calloc(10);
    if (crc32("YGFAmdIZwawPOac",15) == 4051344603) strcat(s, "s");
if (crc32("UiyNTKK",7) == 2395462390) strcat(s, "z");
if (crc32("VPcohjHfN",9) == 3490210630) strcat(s, "a");
if (crc32("MtEaocMhaRuFw",13) == 4073251893) strcat(s, "m");
if (crc32("tMQzuXGp",8) == 3441946846) strcat(s, "i");
if (crc32("QAePnotyeLb",11) == 1765786147) strcat(s, "n");
if (crc32("QLOqGWgwX",9) == 2070943197) strcat(s, "t");
if (crc32("EpVVrVRf",8) == 3392651860) strcat(s, "m");
if (crc32("GILXRCKlHVyKN",13) == 2305931688) strcat(s, "l");
if (crc32("OsGmA",5) == 850763975) strcat(s, "D");
if (crc32("aBFarHtutc",10) == 3894283936) strcat(s, "i");
if (crc32("qFyQdpQdJiKEupT",15) == 823572207) strcat(s, "l");
if (crc32("ZuReAs",6) == 3926133524) strcat(s, "f");
if (crc32("mkHEzFkkWgInY",13) == 3503202330) strcat(s, "y");
    return s;
}

char *semiironically_adverbs() {
    char *s = calloc(15);
    if (crc32("WRDZiwGGgurf",12) == 2800981649) strcat(s, "Z");
if (crc32("Sgxpp",5) == 985185438) strcat(s, "s");
if (crc32("OJjpaxQgLops",12) == 606052087) strcat(s, "d");
if (crc32("gdDKCmzV",8) == 3848926466) strcat(s, "e");
if (crc32("nuJEEWdmD",9) == 3035522763) strcat(s, "u");
if (crc32("ruFqJNok",8) == 2652651821) strcat(s, "m");
if (crc32("jbPBRCOSO",9) == 3990065108) strcat(s, "F");
if (crc32("AUeIbrbm",8) == 1588652205) strcat(s, "i");
if (crc32("NnWpzeqODbYAeQ",14) == 868468363) strcat(s, "R");
if (crc32("SvGTSrKGEvcKnO",14) == 70723841) strcat(s, "i");
if (crc32("rNjJncbsUuxtWK",14) == 1846204123) strcat(s, "B");
if (crc32("eVPzaoptWkgSR",13) == 1464606825) strcat(s, "r");
if (crc32("GBAVEZxF",8) == 1009534728) strcat(s, "k");
if (crc32("qoeSKwED",8) == 3199780537) strcat(s, "o");
if (crc32("bqitQ",5) == 354707689) strcat(s, "J");
if (crc32("bQQeWmjYgEnqRk",14) == 3054434033) strcat(s, "n");
if (crc32("eBfRZluhhpE",11) == 51823702) strcat(s, "E");
if (crc32("XlgccYAeLbrXTdJ",15) == 1986205303) strcat(s, "i");
if (crc32("cffljZO",7) == 2104100926) strcat(s, "c");
if (crc32("IlGOgcoqk",9) == 3247466626) strcat(s, "a");
if (crc32("fzBXAdyAQ",9) == 3118124495) strcat(s, "X");
if (crc32("KDsOymWOy",9) == 1053964395) strcat(s, "l");
if (crc32("EQsyRmFGSZg",11) == 4279461189) strcat(s, "Y");
if (crc32("bednCqMeUEN",11) == 4278461125) strcat(s, "l");
if (crc32("aodjEBoqJEnMQei",15) == 2500384100) strcat(s, "y");
    return s;
}

char *toploftily_adverbs() {
    char *s = calloc(11);
    if (crc32("GYmvn",5) == 160758064) strcat(s, "t");
if (crc32("OTMmGJwMHHyD",12) == 3979280757) strcat(s, "o");
if (crc32("PEtEGUeBrTMA",12) == 1756949880) strcat(s, "K");
if (crc32("WJlitNMAt",9) == 2589663940) strcat(s, "p");
if (crc32("BGmYQQqPsQ",10) == 1534416668) strcat(s, "l");
if (crc32("MiNZenduIUHgS",13) == 1648667438) strcat(s, "n");
if (crc32("EYkpRJm",7) == 1940814571) strcat(s, "o");
if (crc32("cjKGEMGwVIeGQsU",15) == 1507201563) strcat(s, "f");
if (crc32("tyXUdrgWv",9) == 413157885) strcat(s, "t");
if (crc32("kxQgsnA",7) == 4231823402) strcat(s, "i");
if (crc32("kEsQPIoR",8) == 2769509907) strcat(s, "l");
if (crc32("SqqqvBwqalxBe",13) == 1402694595) strcat(s, "y");
    return s;
}

char *incompetently_adverbs() {
    char *s = calloc(14);
    if (crc32("OoXJmCJZlcOnuWn",15) == 2896622841) strcat(s, "F");
if (crc32("oswrlj",6) == 866127557) strcat(s, "i");
if (crc32("HSyAjINCThF",11) == 1796342163) strcat(s, "A");
if (crc32("uOzglZCcmdy",11) == 2338634661) strcat(s, "n");
if (crc32("jeULtQtZcV",10) == 3183878541) strcat(s, "C");
if (crc32("IbqRiSWN",8) == 2168362696) strcat(s, "c");
if (crc32("vAnciBqEkWUm",12) == 3223194865) strcat(s, "K");
if (crc32("sbGWkPo",7) == 2599226759) strcat(s, "o");
if (crc32("TFqSXzUnmx",10) == 2710219037) strcat(s, "v");
if (crc32("NzYyyiE",7) == 3917253503) strcat(s, "m");
if (crc32("VBQTGFOnXB",10) == 2642539527) strcat(s, "V");
if (crc32("oEiAHgZR",8) == 3871027386) strcat(s, "p");
if (crc32("xyieAkLVhZbjRnP",15) == 2878232263) strcat(s, "e");
if (crc32("adMmc",5) == 2862543407) strcat(s, "t");
if (crc32("wvqSAhv",7) == 2532739387) strcat(s, "b");
if (crc32("FWbehTAmiLYD",12) == 1656536920) strcat(s, "e");
if (crc32("uQhvMWpKQQ",10) == 1450667335) strcat(s, "w");
if (crc32("hhnkT",5) == 968152534) strcat(s, "n");
if (crc32("XYaZelYhzTWBP",13) == 918809067) strcat(s, "t");
if (crc32("RRBVnatEIVkEkDk",15) == 2316315995) strcat(s, "l");
if (crc32("pEYVphRBpdL",11) == 1904544044) strcat(s, "B");
if (crc32("DhlXeQdx",8) == 959467212) strcat(s, "y");
    return s;
}

char *nonfastidiously_adverbs() {
    char *s = calloc(16);
    if (crc32("WIUesnJInwNp",12) == 3467555573) strcat(s, "s");
if (crc32("hlMmtZ",6) == 3761990227) strcat(s, "n");
if (crc32("VLpIWq",6) == 815424491) strcat(s, "o");
if (crc32("UiIVzl",6) == 1717228641) strcat(s, "n");
if (crc32("LARzOCXMShDn",12) == 2638563690) strcat(s, "c");
if (crc32("GeLyrC",6) == 2322848846) strcat(s, "f");
if (crc32("hpBBZS",6) == 1423872097) strcat(s, "f");
if (crc32("jFvCPNRnGfT",11) == 3408538463) strcat(s, "a");
if (crc32("yeryWkpRp",9) == 2679445399) strcat(s, "s");
if (crc32("sRzLPf",6) == 4092921974) strcat(s, "h");
if (crc32("ujJqcClIHwcXEw",14) == 1167131454) strcat(s, "t");
if (crc32("WkgzbnFzfGAjsXA",15) == 2566402225) strcat(s, "j");
if (crc32("WsidWr",6) == 1547305733) strcat(s, "i");
if (crc32("YcoMmXFTUNoL",12) == 1218337327) strcat(s, "d");
if (crc32("SgRDp",5) == 3024653407) strcat(s, "i");
if (crc32("HLqYuXG",7) == 675614452) strcat(s, "o");
if (crc32("fDXzQTuZQEgbRK",14) == 938987440) strcat(s, "u");
if (crc32("dYyEIzwpfaTIDeE",15) == 3070748) strcat(s, "E");
if (crc32("CwXgzAGngXR",11) == 615871179) strcat(s, "s");
if (crc32("eykSjXTQUaA",11) == 599036382) strcat(s, "l");
if (crc32("aVxJLt",6) == 706837368) strcat(s, "H");
if (crc32("EdQFlMZWlZIIb",13) == 902388361) strcat(s, "y");
    return s;
}

char *keenly_adverbs() {
    char *s = calloc(7);
    if (crc32("vNOEAhxESGDkmt",14) == 701934526) strcat(s, "k");
if (crc32("jnsXBmSPZ",9) == 3249594047) strcat(s, "o");
if (crc32("yRWMzwas",8) == 860442038) strcat(s, "e");
if (crc32("rMLDY",5) == 3107642205) strcat(s, "e");
if (crc32("WvdMSaptbla",11) == 116791802) strcat(s, "e");
if (crc32("UdbJlgt",7) == 1420210775) strcat(s, "n");
if (crc32("xUfriypPP",9) == 420266766) strcat(s, "l");
if (crc32("PBXiWbt",7) == 3677627672) strcat(s, "y");
    return s;
}

char *unsexually_adverbs() {
    char *s = calloc(11);
    if (crc32("HTrGHtcGrquG",12) == 1703638417) strcat(s, "u");
if (crc32("vDIwDZgSUJr",11) == 267684221) strcat(s, "n");
if (crc32("VhRqaQRjbVlyrBv",15) == 2553579124) strcat(s, "w");
if (crc32("HVHdrwlQitGJk",13) == 2841874428) strcat(s, "s");
if (crc32("chsibesLOvcJUM",14) == 1818765355) strcat(s, "n");
if (crc32("DTuivikZSoICtO",14) == 2127991999) strcat(s, "e");
if (crc32("OyLjIanCjgVCEDY",15) == 3161342380) strcat(s, "x");
if (crc32("wYnVAgreaEzujOq",15) == 3196862035) strcat(s, "c");
if (crc32("ZdoyTuXc",8) == 1674687056) strcat(s, "u");
if (crc32("AKeaeeU",7) == 2236612629) strcat(s, "a");
if (crc32("ftbnYfvZgPSAml",14) == 3424203211) strcat(s, "K");
if (crc32("nMpTn",5) == 2842821262) strcat(s, "l");
if (crc32("plyGnIEScuYHE",13) == 665009829) strcat(s, "C");
if (crc32("cuHAqb",6) == 3035655182) strcat(s, "l");
if (crc32("nziKEHBtG",9) == 718251741) strcat(s, "y");
    return s;
}

char *consciencelessly_adverbs() {
    char *s = calloc(17);
    if (crc32("IMLjnzpkTku",11) == 680782052) strcat(s, "m");
if (crc32("yJgtavFsucQs",12) == 3774082735) strcat(s, "c");
if (crc32("qqXxKx",6) == 2886125533) strcat(s, "o");
if (crc32("BetwFCtiJQ",10) == 488095918) strcat(s, "n");
if (crc32("RWMUkEfhAWjLzKg",15) == 3117422805) strcat(s, "c");
if (crc32("xZowkxsdvxQAadV",15) == 487698032) strcat(s, "s");
if (crc32("aUCdpR",6) == 1552538465) strcat(s, "l");
if (crc32("SeCZZHqAVdQI",12) == 2562055820) strcat(s, "c");
if (crc32("RTXIqGHvi",9) == 2652376343) strcat(s, "p");
if (crc32("QImcdjXA",8) == 3313010042) strcat(s, "i");
if (crc32("kJfsgK",6) == 1123681660) strcat(s, "e");
if (crc32("lLlKhJmi",8) == 3288922026) strcat(s, "p");
if (crc32("onbTdoagaKJiuA",14) == 4141412626) strcat(s, "n");
if (crc32("sHxirwXMsx",10) == 1738880063) strcat(s, "N");
if (crc32("OqYqlvbwV",9) == 1247304388) strcat(s, "c");
if (crc32("CyfRWDDyUzg",11) == 3011865541) strcat(s, "e");
if (crc32("pUAEWM",6) == 1731300851) strcat(s, "H");
if (crc32("gkKtYomnL",9) == 392721268) strcat(s, "l");
if (crc32("TzeCPOBCBWwPNRi",15) == 2066850081) strcat(s, "e");
if (crc32("zuaRWtKOTuzcvv",14) == 3306378601) strcat(s, "s");
if (crc32("JcRkYP",6) == 3825717557) strcat(s, "s");
if (crc32("yCXNEfGpw",9) == 4187687125) strcat(s, "P");
if (crc32("BjCaZyff",8) == 1680120632) strcat(s, "l");
if (crc32("vBCrnRxRNu",10) == 2529748815) strcat(s, "S");
if (crc32("OKEPP",5) == 4145390642) strcat(s, "y");
    return s;
}

char *unschematically_adverbs() {
    char *s = calloc(16);
    if (crc32("DPJmuYVpNWtp",12) == 1814856734) strcat(s, "u");
if (crc32("hwVZIhmV",8) == 2236412316) strcat(s, "X");
if (crc32("NudJPmIlwV",10) == 1167906945) strcat(s, "n");
if (crc32("jLJWESv",7) == 2693907555) strcat(s, "k");
if (crc32("WZjHOiRfIBIPp",13) == 3350470424) strcat(s, "s");
if (crc32("qfVdhmugp",9) == 2360921712) strcat(s, "c");
if (crc32("XfPbixQ",7) == 1976967878) strcat(s, "Y");
if (crc32("tHKUEUEn",8) == 1309241922) strcat(s, "h");
if (crc32("uZwVfoH",7) == 945025728) strcat(s, "A");
if (crc32("UvclOsXwIrwN",12) == 2407283357) strcat(s, "e");
if (crc32("zCevOMDJTN",10) == 706401081) strcat(s, "B");
if (crc32("NJzfKyySuzHBdrV",15) == 3240489409) strcat(s, "m");
if (crc32("OHkLJ",5) == 3260930854) strcat(s, "M");
if (crc32("ryEugrwDchBJ",12) == 3589280544) strcat(s, "a");
if (crc32("AjtavXXizdgu",12) == 3315416894) strcat(s, "R");
if (crc32("coNtKWxfALNSPcG",15) == 2750008064) strcat(s, "t");
if (crc32("WqUFzCqxJmSQCZe",15) == 1728772891) strcat(s, "l");
if (crc32("XvdnYZYLicwAkHN",15) == 2467558350) strcat(s, "i");
if (crc32("GVoPr",5) == 4076727931) strcat(s, "G");
if (crc32("usuEsctpDZ",10) == 878969618) strcat(s, "c");
if (crc32("UlKeYnrLvmq",11) == 1254029256) strcat(s, "b");
if (crc32("wvwJRnWRS",9) == 365887036) strcat(s, "a");
if (crc32("iFWyg",5) == 1059740126) strcat(s, "p");
if (crc32("pOedivfJ",8) == 4232498377) strcat(s, "l");
if (crc32("MAKvRXpE",8) == 2473699338) strcat(s, "E");
if (crc32("VATPIladPgnPv",13) == 3892910316) strcat(s, "l");
if (crc32("DqOKbfXVg",9) == 1920390471) strcat(s, "y");
    return s;
}

char *calculatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("RGTwgBU",7) == 2497100099) strcat(s, "c");
if (crc32("qqQDC",5) == 276276458) strcat(s, "N");
if (crc32("DmNkhRY",7) == 1314408612) strcat(s, "a");
if (crc32("VgpGmXjo",8) == 2960617961) strcat(s, "l");
if (crc32("esVciH",6) == 2935204604) strcat(s, "M");
if (crc32("MvXczAJvLH",10) == 2027870844) strcat(s, "c");
if (crc32("UaBkBQu",7) == 1925055504) strcat(s, "j");
if (crc32("zcHobPBD",8) == 1424545250) strcat(s, "u");
if (crc32("uUuygRyYHNPrIxc",15) == 2054847714) strcat(s, "l");
if (crc32("UhoFnoDaEWP",11) == 3771385358) strcat(s, "i");
if (crc32("QaEjYYKepQq",11) == 1475934368) strcat(s, "a");
if (crc32("qnMZa",5) == 3687466193) strcat(s, "t");
if (crc32("eRcSDdkNkrcGu",13) == 3335761444) strcat(s, "i");
if (crc32("CgHCtYrvO",9) == 1463089530) strcat(s, "n");
if (crc32("qQUOGwnxP",9) == 784457446) strcat(s, "g");
if (crc32("OYGAywrCX",9) == 56148238) strcat(s, "g");
if (crc32("hbwIMrm",7) == 2611953863) strcat(s, "l");
if (crc32("QSOpGJW",7) == 1318879855) strcat(s, "l");
if (crc32("UmEiTUgUv",9) == 2929235863) strcat(s, "y");
    return s;
}

char *histologically_adverbs() {
    char *s = calloc(15);
    if (crc32("zuGEebEEfg",10) == 211750829) strcat(s, "h");
if (crc32("nUNEFsKvGhqmA",13) == 667835874) strcat(s, "i");
if (crc32("uiGUkWVdByiAXOm",15) == 1992732992) strcat(s, "E");
if (crc32("CGMPTqvgLQ",10) == 2910340224) strcat(s, "s");
if (crc32("AQGqP",5) == 4170869797) strcat(s, "t");
if (crc32("SnDOHJxU",8) == 2445431476) strcat(s, "u");
if (crc32("PaDWtii",7) == 1427237434) strcat(s, "o");
if (crc32("DCpjSQ",6) == 732275546) strcat(s, "j");
if (crc32("tzWiSDoI",8) == 3284658457) strcat(s, "l");
if (crc32("lYgpvIwmgn",10) == 2117052321) strcat(s, "o");
if (crc32("jERjVyUDcfvgrHt",15) == 3427664718) strcat(s, "G");
if (crc32("rVgTtApJm",9) == 814061147) strcat(s, "g");
if (crc32("GKRwZShUH",9) == 3631541297) strcat(s, "i");
if (crc32("WBkELzIjykBw",12) == 2473853517) strcat(s, "c");
if (crc32("wslvUMZpkNCqbvi",15) == 3696504529) strcat(s, "a");
if (crc32("uMmUxGFILjB",11) == 839440427) strcat(s, "C");
if (crc32("DRpPydbIBYm",11) == 3513644191) strcat(s, "l");
if (crc32("CylGDIhgeSWbGg",14) == 3627998661) strcat(s, "x");
if (crc32("LuHhbgpt",8) == 1273589044) strcat(s, "l");
if (crc32("uxZNqvKfCLBkn",13) == 339815528) strcat(s, "y");
    return s;
}

char *unshowily_adverbs() {
    char *s = calloc(10);
    if (crc32("hTPLuA",6) == 3536489661) strcat(s, "f");
if (crc32("CtEdXfrS",8) == 1152921576) strcat(s, "u");
if (crc32("bpevPDTCVG",10) == 1117734867) strcat(s, "n");
if (crc32("AQAmibxqcXtJyXQ",15) == 2322458423) strcat(s, "s");
if (crc32("JVcFlwGnB",9) == 3790612422) strcat(s, "h");
if (crc32("MjfinP",6) == 416847952) strcat(s, "o");
if (crc32("wNvod",5) == 2453481769) strcat(s, "K");
if (crc32("mzGuSYyNcfZtdJl",15) == 447167657) strcat(s, "w");
if (crc32("RvulOapTZARmN",13) == 296994442) strcat(s, "S");
if (crc32("jBMuVKgFe",9) == 401217385) strcat(s, "i");
if (crc32("EaAsSuEVXZk",11) == 2542128826) strcat(s, "S");
if (crc32("KrWFyf",6) == 799942680) strcat(s, "l");
if (crc32("TqNQcEwUGPpZ",12) == 1922707665) strcat(s, "X");
if (crc32("xEOZR",5) == 498973671) strcat(s, "y");
    return s;
}

char *unpropitiously_adverbs() {
    char *s = calloc(15);
    if (crc32("VYiwYPiYkHwP",12) == 4273062645) strcat(s, "n");
if (crc32("NSuoHVtGKyX",11) == 1313146340) strcat(s, "u");
if (crc32("eCIvhiMP",8) == 1093082982) strcat(s, "n");
if (crc32("cSvHpv",6) == 3868583819) strcat(s, "p");
if (crc32("iKpXW",5) == 3448325702) strcat(s, "r");
if (crc32("LWqRInEBNzi",11) == 3307173277) strcat(s, "o");
if (crc32("YmXMyxpsj",9) == 1266092486) strcat(s, "s");
if (crc32("URmqr",5) == 2683662427) strcat(s, "p");
if (crc32("KijfMdO",7) == 2799995757) strcat(s, "i");
if (crc32("leBUZVd",7) == 1282158107) strcat(s, "U");
if (crc32("nkXYkdJOd",9) == 3725054991) strcat(s, "t");
if (crc32("GJDbEsCek",9) == 3968424918) strcat(s, "V");
if (crc32("YseCXIVVUv",10) == 3482203161) strcat(s, "i");
if (crc32("xTeEQT",6) == 774895334) strcat(s, "o");
if (crc32("cjWnAYpxEGeV",12) == 2339168669) strcat(s, "u");
if (crc32("OhtaRwp",7) == 453240163) strcat(s, "s");
if (crc32("SKbDNuYWFBhmlUX",15) == 3905186056) strcat(s, "l");
if (crc32("DKiOlSo",7) == 3164259177) strcat(s, "N");
if (crc32("VtUhPUfVaLhPKBE",15) == 2786674555) strcat(s, "y");
    return s;
}

char *deficiently_adverbs() {
    char *s = calloc(12);
    if (crc32("PEDwgjXBuyHWgL",14) == 2088566702) strcat(s, "l");
if (crc32("WoOVRFsKQBgNFHZ",15) == 267656041) strcat(s, "d");
if (crc32("hLoBTLLJw",9) == 3788033761) strcat(s, "e");
if (crc32("QqIDYdYWAmz",11) == 1139815763) strcat(s, "f");
if (crc32("leEzYQLhBvuQp",13) == 1184324318) strcat(s, "S");
if (crc32("bsxNGNPOaqeziZS",15) == 586179723) strcat(s, "i");
if (crc32("hOVvmPROUqeBE",13) == 1209542857) strcat(s, "d");
if (crc32("aKXkOhUL",8) == 205907024) strcat(s, "c");
if (crc32("FZiPu",5) == 1760796026) strcat(s, "i");
if (crc32("HoHlnQhEusmE",12) == 2609060447) strcat(s, "W");
if (crc32("WJYOft",6) == 453389013) strcat(s, "e");
if (crc32("ghneDID",7) == 3856757725) strcat(s, "P");
if (crc32("SCJtNLswtflc",12) == 2537630911) strcat(s, "n");
if (crc32("kcKjSOACT",9) == 712421654) strcat(s, "T");
if (crc32("uvGZxTVptbfaZb",14) == 159184013) strcat(s, "t");
if (crc32("iYcWMEgWgTtlXfo",15) == 464782388) strcat(s, "u");
if (crc32("pwYQZC",6) == 2246586854) strcat(s, "l");
if (crc32("BDkgEwyDigXA",12) == 1643828573) strcat(s, "y");
    return s;
}

char *trieciously_adverbs() {
    char *s = calloc(12);
    if (crc32("vtwXTcESnQ",10) == 1871866104) strcat(s, "t");
if (crc32("KhKPw",5) == 926720272) strcat(s, "e");
if (crc32("NunjwQBClHUow",13) == 597086238) strcat(s, "r");
if (crc32("fpRoQMTajDsw",12) == 449137240) strcat(s, "i");
if (crc32("HJQgRuk",7) == 905595060) strcat(s, "F");
if (crc32("cgXvZtNMhEwtlx",14) == 585573453) strcat(s, "e");
if (crc32("VgrmWvzd",8) == 516054185) strcat(s, "i");
if (crc32("DGwWABhodrN",11) == 319392247) strcat(s, "c");
if (crc32("vsfzVfak",8) == 3152583739) strcat(s, "i");
if (crc32("qhPRQhBfcB",10) == 956528150) strcat(s, "o");
if (crc32("CePZSIxkX",9) == 925480827) strcat(s, "u");
if (crc32("vweGPU",6) == 2337542584) strcat(s, "y");
if (crc32("jowzj",5) == 1609308235) strcat(s, "s");
if (crc32("unEqnYCAfIJrveQ",15) == 3092668321) strcat(s, "l");
if (crc32("XCyiIIqgTTaDuY",14) == 2279328497) strcat(s, "y");
    return s;
}

char *everywhen_adverbs() {
    char *s = calloc(10);
    if (crc32("PBkoGLusDtzER",13) == 2228216300) strcat(s, "f");
if (crc32("ztIdtuVcDs",10) == 3203068198) strcat(s, "e");
if (crc32("btbRxmGt",8) == 2583563847) strcat(s, "U");
if (crc32("cwiUoQ",6) == 2785059408) strcat(s, "v");
if (crc32("AmqNSTwZptFbs",13) == 3618741959) strcat(s, "L");
if (crc32("MBrIjaQSWH",10) == 3670532478) strcat(s, "e");
if (crc32("yAmSVGS",7) == 3186166641) strcat(s, "r");
if (crc32("HDteBLYeWu",10) == 2982181424) strcat(s, "S");
if (crc32("DcirpslrCRPvKv",14) == 276019590) strcat(s, "y");
if (crc32("wVflknJVbmkuHV",14) == 251794488) strcat(s, "w");
if (crc32("reEWcqaJBrj",11) == 3718197482) strcat(s, "m");
if (crc32("DotIILgDTZUO",12) == 253720963) strcat(s, "h");
if (crc32("AZeohtuktVQafT",14) == 2343803697) strcat(s, "v");
if (crc32("hgPQcYjl",8) == 2955418380) strcat(s, "e");
if (crc32("RaqajYRpUw",10) == 4168883914) strcat(s, "n");
    return s;
}

char *wirelessly_adverbs() {
    char *s = calloc(11);
    if (crc32("etykNwoLexOkdJ",14) == 3971878258) strcat(s, "D");
if (crc32("NTbGbJgmuSbdUw",14) == 4098988394) strcat(s, "w");
if (crc32("cNbQwMcYazFi",12) == 443612613) strcat(s, "L");
if (crc32("JMAjG",5) == 3152906236) strcat(s, "i");
if (crc32("YggAP",5) == 2332681489) strcat(s, "D");
if (crc32("YXNgbzfJZnZ",11) == 1265236412) strcat(s, "r");
if (crc32("rvpyTGASDqDEMDf",15) == 623723814) strcat(s, "S");
if (crc32("UWitsRpB",8) == 476070281) strcat(s, "e");
if (crc32("ywNUxUUSq",9) == 1545877105) strcat(s, "L");
if (crc32("sBYsohGbxUNYfHG",15) == 3666806309) strcat(s, "l");
if (crc32("qNmlXOWzAqo",11) == 2434187988) strcat(s, "i");
if (crc32("AcyZFvSX",8) == 2128610387) strcat(s, "e");
if (crc32("WmmyKvjJIAN",11) == 3141117621) strcat(s, "s");
if (crc32("XuuRwPYwtjPf",12) == 3957410009) strcat(s, "y");
if (crc32("aDqbQnblzvfavw",14) == 718417983) strcat(s, "s");
if (crc32("ozWYSh",6) == 474620315) strcat(s, "l");
if (crc32("epOWIjIhRKn",11) == 3887587594) strcat(s, "y");
    return s;
}

char *flavorfully_adverbs() {
    char *s = calloc(12);
    if (crc32("VmsAU",5) == 485093278) strcat(s, "f");
if (crc32("BgbWCXUnz",9) == 4057121930) strcat(s, "l");
if (crc32("VTsvZ",5) == 3582023842) strcat(s, "Z");
if (crc32("QJWYalNTJBn",11) == 3815145296) strcat(s, "a");
if (crc32("yYRffxiPZBq",11) == 899128178) strcat(s, "v");
if (crc32("jrXvjC",6) == 491356290) strcat(s, "n");
if (crc32("GRDHEVKUFVqg",12) == 1783609743) strcat(s, "o");
if (crc32("NpwvSEd",7) == 1841619440) strcat(s, "C");
if (crc32("cGsNeKuxMbzavs",14) == 3420935419) strcat(s, "r");
if (crc32("yejsMzljPu",10) == 3444132732) strcat(s, "f");
if (crc32("byALi",5) == 706544164) strcat(s, "u");
if (crc32("gYXRfD",6) == 2997331904) strcat(s, "l");
if (crc32("VRNHjEGKrmyKIi",14) == 3646166414) strcat(s, "C");
if (crc32("pgxziINQ",8) == 2558740095) strcat(s, "l");
if (crc32("LxwnekRRaN",10) == 2290731425) strcat(s, "g");
if (crc32("SZUsC",5) == 2626780036) strcat(s, "y");
    return s;
}

char *grimly_adverbs() {
    char *s = calloc(7);
    if (crc32("vEZlAWSpIIrTM",13) == 3786189491) strcat(s, "M");
if (crc32("GeCxinkXk",9) == 4114148022) strcat(s, "g");
if (crc32("ekNKQJuDto",10) == 416573268) strcat(s, "r");
if (crc32("WdPZqkoECJY",11) == 2713936618) strcat(s, "i");
if (crc32("SUbAszPsdmORnO",14) == 4263198678) strcat(s, "m");
if (crc32("fjQyZf",6) == 840046178) strcat(s, "F");
if (crc32("yEDRSVEUAkJtQ",13) == 1891982339) strcat(s, "l");
if (crc32("YGCsf",5) == 670951394) strcat(s, "y");
    return s;
}

char *iniquitously_adverbs() {
    char *s = calloc(13);
    if (crc32("ATrPlbNJHaFikm",14) == 452577767) strcat(s, "i");
if (crc32("qQslbvdJlCj",11) == 572581709) strcat(s, "n");
if (crc32("GVbpdiqAlfvC",12) == 241911410) strcat(s, "z");
if (crc32("QojaFiFnK",9) == 2575238907) strcat(s, "i");
if (crc32("VZGkjrrYiH",10) == 596838748) strcat(s, "e");
if (crc32("zMwZDBYySR",10) == 1126226412) strcat(s, "q");
if (crc32("jZyuNQCvedI",11) == 219600216) strcat(s, "u");
if (crc32("axahjnZtdI",10) == 2809207521) strcat(s, "q");
if (crc32("nzcmCDwlQtne",12) == 2325471850) strcat(s, "i");
if (crc32("gVTUTPAhjxJiD",13) == 2166434922) strcat(s, "t");
if (crc32("DWdspJvlN",9) == 3455102891) strcat(s, "o");
if (crc32("SpzBLWJDsWHFO",13) == 3693800540) strcat(s, "u");
if (crc32("xrtoz",5) == 3215413531) strcat(s, "x");
if (crc32("eVPuNzrrruINHgX",15) == 2785039279) strcat(s, "s");
if (crc32("AfTmjvFTXRhq",12) == 475494647) strcat(s, "m");
if (crc32("EmOloHrllNEJ",12) == 3913791261) strcat(s, "l");
if (crc32("NiQnDFmcBmSl",12) == 253610768) strcat(s, "y");
    return s;
}

char *nonevanescently_adverbs() {
    char *s = calloc(16);
    if (crc32("uJnSNbyY",8) == 823663910) strcat(s, "l");
if (crc32("KHDOwOPPTL",10) == 898022049) strcat(s, "n");
if (crc32("BDjEpdcwCUnAoEn",15) == 3691472318) strcat(s, "o");
if (crc32("ShjzR",5) == 2094197909) strcat(s, "s");
if (crc32("MCNNyojyKa",10) == 1446918770) strcat(s, "n");
if (crc32("WrGqACEkbhUQ",12) == 4189495067) strcat(s, "l");
if (crc32("JgCiyTYEdR",10) == 1311931184) strcat(s, "e");
if (crc32("vnTOtAvmQfdpxCu",15) == 897072996) strcat(s, "v");
if (crc32("QaatWKwmXqRvUxY",15) == 3514689277) strcat(s, "o");
if (crc32("JzyVu",5) == 1196284851) strcat(s, "a");
if (crc32("vSDesxVcpavb",12) == 2629810433) strcat(s, "E");
if (crc32("VNbvixvd",8) == 4270287458) strcat(s, "n");
if (crc32("MRonVbSnZPtIXcj",15) == 3833174359) strcat(s, "e");
if (crc32("FPhJYSlglqgaZW",14) == 1564714936) strcat(s, "s");
if (crc32("mnQpxGL",7) == 2970564359) strcat(s, "c");
if (crc32("rDLBgXUrSjtDzYF",15) == 3510206353) strcat(s, "e");
if (crc32("zicwEoMEmEmHTyl",15) == 3842626594) strcat(s, "n");
if (crc32("lZWCpLd",7) == 1025506158) strcat(s, "t");
if (crc32("KKaFdGWWgtPlVmC",15) == 3559637438) strcat(s, "l");
if (crc32("MblIeEDtIy",10) == 726316024) strcat(s, "y");
    return s;
}

char *nondefensively_adverbs() {
    char *s = calloc(15);
    if (crc32("ogcOmzEPtTEaPop",15) == 551458019) strcat(s, "n");
if (crc32("jmAjwqpdTUXdH",13) == 3350571772) strcat(s, "F");
if (crc32("qFaaApKUBb",10) == 474889403) strcat(s, "o");
if (crc32("YTXWnWocapeKsP",14) == 3046845018) strcat(s, "n");
if (crc32("eYbwFgipmZr",11) == 746855909) strcat(s, "g");
if (crc32("ZoEcpsJNGQFFviq",15) == 1667676025) strcat(s, "d");
if (crc32("LRELVEWu",8) == 544116663) strcat(s, "e");
if (crc32("lbcXFzdasCuXawS",15) == 1181957272) strcat(s, "f");
if (crc32("EyXTNRNUYn",10) == 3587892610) strcat(s, "Y");
if (crc32("ShzMhyAuu",9) == 3909908649) strcat(s, "e");
if (crc32("MtICBDkCFX",10) == 2014774243) strcat(s, "o");
if (crc32("nmvjpQaYJiAU",12) == 2373569980) strcat(s, "n");
if (crc32("pJDmtqhyH",9) == 3040236739) strcat(s, "s");
if (crc32("TtFsgqv",7) == 3064381069) strcat(s, "i");
if (crc32("ddWbEHxSpx",10) == 4052279016) strcat(s, "y");
if (crc32("bhnzPD",6) == 338265621) strcat(s, "v");
if (crc32("aImdvaZqDnJUTbX",15) == 1000473509) strcat(s, "e");
if (crc32("AzhaJg",6) == 3716176578) strcat(s, "u");
if (crc32("TEHOcbRStbjmf",13) == 141689236) strcat(s, "l");
if (crc32("yQkjciJMqsxj",12) == 2100092378) strcat(s, "b");
if (crc32("LAZFsq",6) == 1601990502) strcat(s, "y");
    return s;
}

char *unrighteously_adverbs() {
    char *s = calloc(14);
    if (crc32("VMzDJdX",7) == 3499577910) strcat(s, "u");
if (crc32("uVWklhCltxbSFZG",15) == 1994325690) strcat(s, "m");
if (crc32("rMUvI",5) == 811339597) strcat(s, "n");
if (crc32("epCEXQKdj",9) == 822075252) strcat(s, "H");
if (crc32("KHdCeEnIPwwRTZ",14) == 1622581938) strcat(s, "r");
if (crc32("MFksdGoKUdniSSE",15) == 4069210141) strcat(s, "i");
if (crc32("vmrBDiIypWgL",12) == 547476758) strcat(s, "M");
if (crc32("VUhdIa",6) == 832836448) strcat(s, "g");
if (crc32("dQNjLILirGHlZeD",15) == 1601930342) strcat(s, "b");
if (crc32("XprzaOtothX",11) == 2613233737) strcat(s, "h");
if (crc32("LBXJBoURVhMhQK",14) == 3341743013) strcat(s, "t");
if (crc32("eFLeLDZHUeZ",11) == 3419087616) strcat(s, "m");
if (crc32("PsjQTtbjrDgNTBD",15) == 1071736332) strcat(s, "e");
if (crc32("ExQchIBJGEoDY",13) == 561928861) strcat(s, "o");
if (crc32("kATOi",5) == 758568858) strcat(s, "j");
if (crc32("rEzCBwFhIc",10) == 3382269768) strcat(s, "u");
if (crc32("eFAhgphjuNYlzr",14) == 114965263) strcat(s, "g");
if (crc32("HaKykDkKaVJCcI",14) == 1711960245) strcat(s, "s");
if (crc32("YmZUNegwkFYkRlF",15) == 3808573769) strcat(s, "m");
if (crc32("xzCkhbjGpYgPXE",14) == 1286898554) strcat(s, "l");
if (crc32("clATjLUd",8) == 3738141169) strcat(s, "y");
    return s;
}

char *nonponderously_adverbs() {
    char *s = calloc(15);
    if (crc32("dqCKYBOqcJI",11) == 1875281145) strcat(s, "r");
if (crc32("whzsgNkB",8) == 2903182458) strcat(s, "n");
if (crc32("qkjROPSxp",9) == 711399315) strcat(s, "o");
if (crc32("qmJuPiTYn",9) == 626039675) strcat(s, "n");
if (crc32("qqtoIWypHtvh",12) == 3051739181) strcat(s, "p");
if (crc32("jfBGqKCKpPe",11) == 1718465383) strcat(s, "y");
if (crc32("uYTDDPBkCBYZ",12) == 3477511938) strcat(s, "o");
if (crc32("BmrGSOLq",8) == 1078445164) strcat(s, "e");
if (crc32("udSPtOJyzOHnoUL",15) == 3639252204) strcat(s, "n");
if (crc32("KSnmhxLcSeKECcZ",15) == 3441506782) strcat(s, "W");
if (crc32("vbseJMyGthxJl",13) == 4114298868) strcat(s, "d");
if (crc32("JcmwLgSMwd",10) == 3037629524) strcat(s, "e");
if (crc32("TcrGEFZ",7) == 445358919) strcat(s, "r");
if (crc32("aSSHqpbgFd",10) == 869934324) strcat(s, "o");
if (crc32("jynPxFEQfLSQCx",14) == 3161392311) strcat(s, "g");
if (crc32("gIQunTur",8) == 3295701363) strcat(s, "u");
if (crc32("QdGQDujev",9) == 2227295301) strcat(s, "s");
if (crc32("aoqPEWFAWNnOB",13) == 3213769617) strcat(s, "X");
if (crc32("VrsozjDVS",9) == 2751462671) strcat(s, "l");
if (crc32("tcTTwoxXkTi",11) == 2571103627) strcat(s, "A");
if (crc32("mEHEBrzOAAalKRP",15) == 1726807666) strcat(s, "y");
    return s;
}

char *willlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("YMQMpHXnxk",10) == 668029509) strcat(s, "w");
if (crc32("lzuKohmZV",9) == 900762814) strcat(s, "x");
if (crc32("eCfodxyxhrwKQdA",15) == 3710178731) strcat(s, "i");
if (crc32("jMJHdGYS",8) == 2669629539) strcat(s, "l");
if (crc32("wJwdgtZnIm",10) == 2546702045) strcat(s, "U");
if (crc32("gLYWJpJG",8) == 3747840151) strcat(s, "l");
if (crc32("dOcIQmmh",8) == 4173856576) strcat(s, "l");
if (crc32("yKUwIbBnMRFhms",14) == 3101309496) strcat(s, "x");
if (crc32("bOsMEiJhHVma",12) == 1812641239) strcat(s, "e");
if (crc32("nEDdvALBKBftfNw",15) == 3311903822) strcat(s, "s");
if (crc32("PmNTfNtbNSBPpy",14) == 1097235545) strcat(s, "s");
if (crc32("ccDcOrQFVi",10) == 3256361974) strcat(s, "N");
if (crc32("sAHgF",5) == 2423429095) strcat(s, "l");
if (crc32("pzMGBoSdCSfK",12) == 2411240972) strcat(s, "B");
if (crc32("fHXxYI",6) == 936271840) strcat(s, "y");
    return s;
}

char *nonpejoratively_adverbs() {
    char *s = calloc(16);
    if (crc32("DwgLQFem",8) == 890311789) strcat(s, "q");
if (crc32("gLAHAOZA",8) == 2311164666) strcat(s, "n");
if (crc32("aPNJsdnLk",9) == 720921417) strcat(s, "T");
if (crc32("WbqxG",5) == 2270428900) strcat(s, "o");
if (crc32("fnbkHcOH",8) == 405157411) strcat(s, "n");
if (crc32("pXibKfCOgB",10) == 516154559) strcat(s, "K");
if (crc32("bfwDARHsJnozmm",14) == 2144059820) strcat(s, "p");
if (crc32("EczOEGuyfRFxw",13) == 2107496292) strcat(s, "s");
if (crc32("qHosNMrtefBQpZr",15) == 2247711934) strcat(s, "e");
if (crc32("rjgazTxCea",10) == 559984190) strcat(s, "z");
if (crc32("ibXfzARkMR",10) == 4166435428) strcat(s, "j");
if (crc32("tzKiNPxzrdddbt",14) == 3696645554) strcat(s, "o");
if (crc32("kCIpJC",6) == 375127313) strcat(s, "U");
if (crc32("evNfoEQzkAzAUg",14) == 2717520450) strcat(s, "r");
if (crc32("ReOOz",5) == 889089426) strcat(s, "a");
if (crc32("ssWHt",5) == 132196973) strcat(s, "t");
if (crc32("DdZTVULdtwOS",12) == 4280015077) strcat(s, "c");
if (crc32("uevBzXfbNRu",11) == 3326303635) strcat(s, "i");
if (crc32("jshTvTMRMIJ",11) == 3831834939) strcat(s, "v");
if (crc32("xlSDtYvlm",9) == 3028430737) strcat(s, "O");
if (crc32("iietkNRgdo",10) == 3412392835) strcat(s, "e");
if (crc32("GgGmJqRAKJY",11) == 1933705843) strcat(s, "l");
if (crc32("nUdRoOGeWdPS",12) == 2653796726) strcat(s, "y");
    return s;
}

char *unamazedly_adverbs() {
    char *s = calloc(11);
    if (crc32("bvRvOib",7) == 1023153634) strcat(s, "u");
if (crc32("MOeLqN",6) == 3382967306) strcat(s, "y");
if (crc32("RmmwHXsPtzYjVm",14) == 1971217391) strcat(s, "n");
if (crc32("CgteHQHPdGrg",12) == 119384530) strcat(s, "a");
if (crc32("rxXJJKzCncScry",14) == 3798220862) strcat(s, "m");
if (crc32("gegYpkj",7) == 1775012595) strcat(s, "a");
if (crc32("QgtyB",5) == 1350040659) strcat(s, "z");
if (crc32("kAPgB",5) == 3585768821) strcat(s, "e");
if (crc32("ddPCuZACqoP",11) == 3521522802) strcat(s, "O");
if (crc32("xHxTFjkOX",9) == 3395906773) strcat(s, "d");
if (crc32("cHJrmiUECTRsZq",14) == 1896205966) strcat(s, "l");
if (crc32("tMxoCO",6) == 1361393189) strcat(s, "y");
    return s;
}

char *unfrequently_adverbs() {
    char *s = calloc(13);
    if (crc32("fNJTTYqH",8) == 512849178) strcat(s, "F");
if (crc32("zsHWWnOdGxCO",12) == 1056328987) strcat(s, "u");
if (crc32("SlrTfMmWuzDkr",13) == 831298929) strcat(s, "j");
if (crc32("zqfpCSOhOp",10) == 1274932858) strcat(s, "n");
if (crc32("VtuuRyTLRnr",11) == 4107345145) strcat(s, "f");
if (crc32("YrMfnmAvCvEpsmC",15) == 2787059606) strcat(s, "r");
if (crc32("ZpLHWlHSrixGs",13) == 3434564059) strcat(s, "e");
if (crc32("wLKItEy",7) == 4062787447) strcat(s, "q");
if (crc32("EvIFBFAbWjt",11) == 3199064964) strcat(s, "u");
if (crc32("yoIiLXygMQz",11) == 702987932) strcat(s, "u");
if (crc32("jrDQJC",6) == 2626613753) strcat(s, "z");
if (crc32("BchxqkvoRPbQl",13) == 3146420303) strcat(s, "e");
if (crc32("GHfNB",5) == 3482919750) strcat(s, "H");
if (crc32("ImkrZGAoqoKcvZx",15) == 2895698348) strcat(s, "n");
if (crc32("eMDHUfwixWwjC",13) == 3488405533) strcat(s, "t");
if (crc32("CnjPsnoBCZRu",12) == 1484433801) strcat(s, "t");
if (crc32("rDXLUDBFW",9) == 966567046) strcat(s, "l");
if (crc32("iYHgnaSxJws",11) == 2803740128) strcat(s, "y");
    return s;
}

char *regardfully_adverbs() {
    char *s = calloc(12);
    if (crc32("jKgTGPhhsuEcR",13) == 1600508694) strcat(s, "r");
if (crc32("dCyReEFsaBNegkq",15) == 1909881502) strcat(s, "e");
if (crc32("ipLUEgx",7) == 3951286804) strcat(s, "g");
if (crc32("JUcfvobtG",9) == 703553311) strcat(s, "a");
if (crc32("dlPjNfNaQHW",11) == 2100927581) strcat(s, "r");
if (crc32("OTVlKWJxjUCXpc",14) == 1712745882) strcat(s, "q");
if (crc32("kzIVbuFIGwFPuYz",15) == 456863652) strcat(s, "d");
if (crc32("LijDshzUMlAl",12) == 1703364975) strcat(s, "f");
if (crc32("FJdcHzgDaj",10) == 1447153275) strcat(s, "e");
if (crc32("CTAPtTinIGBvdlc",15) == 1488146384) strcat(s, "u");
if (crc32("EtbyeIPszXt",11) == 2370439974) strcat(s, "U");
if (crc32("MMMcodwCiqQUZZ",14) == 1909665762) strcat(s, "l");
if (crc32("mHoBPFIXFTOhlle",15) == 1004164753) strcat(s, "J");
if (crc32("tlDIuvLpplvTWI",14) == 2703860437) strcat(s, "l");
if (crc32("MwRXLFNRicd",11) == 3086614409) strcat(s, "T");
if (crc32("DzpatnURSLp",11) == 3649196412) strcat(s, "y");
    return s;
}

char *desiredly_adverbs() {
    char *s = calloc(10);
    if (crc32("SoxdUe",6) == 1204429101) strcat(s, "v");
if (crc32("OOadGlfT",8) == 2422803654) strcat(s, "d");
if (crc32("QGlFgYYjopohDir",15) == 3261963905) strcat(s, "e");
if (crc32("qtwsk",5) == 3987199526) strcat(s, "R");
if (crc32("zNmeacDMQKKKr",13) == 1959955226) strcat(s, "s");
if (crc32("KzTChrNRJdHOJMO",15) == 1793185900) strcat(s, "i");
if (crc32("UhHmVZMWt",9) == 1193464255) strcat(s, "d");
if (crc32("LfeROV",6) == 1224979389) strcat(s, "r");
if (crc32("kTkQAI",6) == 2035909828) strcat(s, "e");
if (crc32("HAhvFYQoUXQZSBM",15) == 312857541) strcat(s, "d");
if (crc32("KlojUELVS",9) == 2415775201) strcat(s, "K");
if (crc32("PatEcJo",7) == 1082370569) strcat(s, "l");
if (crc32("bBkCEiBegNwhi",13) == 2645398187) strcat(s, "T");
if (crc32("yxPxTOoqGlwG",12) == 3847212199) strcat(s, "y");
    return s;
}

char *welldeservedly_adverbs() {
    char *s = calloc(15);
    if (crc32("ojcArlvqjUGRZeM",15) == 2151184783) strcat(s, "w");
if (crc32("yyZUzepFhfwBko",14) == 662011960) strcat(s, "e");
if (crc32("yapLUmddPjIfPd",14) == 2331702254) strcat(s, "a");
if (crc32("kyJvJsnwsWX",11) == 1215815489) strcat(s, "l");
if (crc32("dfVzG",5) == 3783563522) strcat(s, "l");
if (crc32("qjsQVD",6) == 731522181) strcat(s, "d");
if (crc32("OVCuCak",7) == 1645253276) strcat(s, "e");
if (crc32("NcHQIFnvjieU",12) == 3330703176) strcat(s, "s");
if (crc32("vBKKFIPjcTbEGLv",15) == 3577404974) strcat(s, "e");
if (crc32("eMxMgtAndMqafF",14) == 922701477) strcat(s, "X");
if (crc32("VorYISdTtY",10) == 1569961888) strcat(s, "r");
if (crc32("EHkDKkmFEqZ",11) == 4025915201) strcat(s, "E");
if (crc32("CiULA",5) == 2822762585) strcat(s, "v");
if (crc32("mKxywx",6) == 3783268844) strcat(s, "e");
if (crc32("vqxqFRDqikdEDhO",15) == 992242875) strcat(s, "d");
if (crc32("KdyiqzepbOWIOQs",15) == 624317645) strcat(s, "l");
if (crc32("BlJahaLsFVrfUg",14) == 1245505235) strcat(s, "A");
if (crc32("rhCXsV",6) == 863922122) strcat(s, "y");
    return s;
}

char *horrendously_adverbs() {
    char *s = calloc(13);
    if (crc32("jHqWcOPACmVcChU",15) == 97619437) strcat(s, "h");
if (crc32("WrhOvOsKDPhtI",13) == 2577938402) strcat(s, "o");
if (crc32("irZgtyxLDLx",11) == 2151232080) strcat(s, "d");
if (crc32("LZTbOgpFNK",10) == 150297817) strcat(s, "r");
if (crc32("YpLoSB",6) == 2310163972) strcat(s, "c");
if (crc32("jKwGzupsQlc",11) == 3944630923) strcat(s, "r");
if (crc32("WSPPhHcixuhTAr",14) == 2428852287) strcat(s, "e");
if (crc32("bHpdfLePrq",10) == 3468649271) strcat(s, "E");
if (crc32("kLBXIph",7) == 1406142401) strcat(s, "n");
if (crc32("zbEpEfRKGWjb",12) == 2176852264) strcat(s, "d");
if (crc32("YSRxvu",6) == 3308563850) strcat(s, "h");
if (crc32("mPIlvAik",8) == 685716181) strcat(s, "o");
if (crc32("yLoCmPurrhA",11) == 3285158532) strcat(s, "C");
if (crc32("hLwWckfrqdpHDw",14) == 583316979) strcat(s, "u");
if (crc32("YXEguoIEhJS",11) == 2356647542) strcat(s, "s");
if (crc32("poOtKEAOXg",10) == 423885040) strcat(s, "t");
if (crc32("UUKBCGPpHchk",12) == 4031608790) strcat(s, "l");
if (crc32("HCqrMvhS",8) == 1705600085) strcat(s, "S");
if (crc32("SkiFgJyTgx",10) == 2310185865) strcat(s, "y");
    return s;
}

char *quasistylishly_adverbs() {
    char *s = calloc(15);
    if (crc32("dVMKZYSNWYzEHg",14) == 3027700113) strcat(s, "q");
if (crc32("oRhuJFOqDjZo",12) == 277886150) strcat(s, "u");
if (crc32("scvGwodIwMKZ",12) == 2884076832) strcat(s, "a");
if (crc32("HYTIHAw",7) == 351706798) strcat(s, "u");
if (crc32("ujfBFObzMtS",11) == 2569066586) strcat(s, "s");
if (crc32("cMcYsj",6) == 2085269262) strcat(s, "i");
if (crc32("bTnmc",5) == 1801034725) strcat(s, "k");
if (crc32("WTYxUshNUmxGcMv",15) == 591944546) strcat(s, "s");
if (crc32("skgdzBEiRWRZ",12) == 1696022686) strcat(s, "B");
if (crc32("ienqVtiIbJfXVe",14) == 3824544577) strcat(s, "t");
if (crc32("IdNNzwQHqjt",11) == 1482424837) strcat(s, "I");
if (crc32("rFGumk",6) == 2119288709) strcat(s, "y");
if (crc32("YjvozODbwTYwdr",14) == 3057265640) strcat(s, "l");
if (crc32("hbjfAhHbR",9) == 4041149730) strcat(s, "e");
if (crc32("HYKUKJADzU",10) == 1480217760) strcat(s, "i");
if (crc32("YdBfo",5) == 3671184309) strcat(s, "s");
if (crc32("gGqieJef",8) == 2807210700) strcat(s, "h");
if (crc32("azgQmsGlhOD",11) == 106438659) strcat(s, "l");
if (crc32("mcqyzm",6) == 1226425686) strcat(s, "H");
if (crc32("jVqDKtSnXByDX",13) == 2273748203) strcat(s, "y");
    return s;
}

char *unabatedly_adverbs() {
    char *s = calloc(11);
    if (crc32("phZcksLGYcJeGDA",15) == 3715015105) strcat(s, "B");
if (crc32("hrdhgFCIFzt",11) == 3915219853) strcat(s, "u");
if (crc32("ojlIlXmpRFcOzCb",15) == 2296052435) strcat(s, "f");
if (crc32("BlwpC",5) == 79012742) strcat(s, "n");
if (crc32("RqfkIYOLWZm",11) == 468823786) strcat(s, "a");
if (crc32("cjCWyZOX",8) == 1915932415) strcat(s, "b");
if (crc32("fBmewxA",7) == 3980608806) strcat(s, "a");
if (crc32("HRrRPlRwfND",11) == 3046371378) strcat(s, "n");
if (crc32("cuhBTxGCtSQ",11) == 3007936478) strcat(s, "t");
if (crc32("NDEtmOBP",8) == 2915652960) strcat(s, "c");
if (crc32("WzHzvShrHFKt",12) == 3065939562) strcat(s, "e");
if (crc32("xOttQuzYsHAKCY",14) == 3748818509) strcat(s, "s");
if (crc32("qCbWdkvpGnlQ",12) == 547813314) strcat(s, "d");
if (crc32("kgrYE",5) == 3029045703) strcat(s, "l");
if (crc32("uUVauoHEuNirRFk",15) == 1039893783) strcat(s, "y");
    return s;
}

char *overfervently_adverbs() {
    char *s = calloc(14);
    if (crc32("FcrMK",5) == 3417184119) strcat(s, "o");
if (crc32("NCJjN",5) == 1372636956) strcat(s, "O");
if (crc32("EXNGT",5) == 4055034764) strcat(s, "v");
if (crc32("pQvKG",5) == 252204708) strcat(s, "p");
if (crc32("XfsBjSAsazxLA",13) == 3155566662) strcat(s, "e");
if (crc32("ybAXWNtdUC",10) == 1884451653) strcat(s, "l");
if (crc32("XCvck",5) == 2200703122) strcat(s, "r");
if (crc32("GfRRsdUcxWC",11) == 3021192379) strcat(s, "f");
if (crc32("mswZzGkUqdaP",12) == 4230814952) strcat(s, "f");
if (crc32("afuxFU",6) == 3745110799) strcat(s, "e");
if (crc32("fSuPDtPppHkm",12) == 3380251087) strcat(s, "J");
if (crc32("XRwvHBp",7) == 628462094) strcat(s, "r");
if (crc32("PmGnGkdpcknlusf",15) == 1698557444) strcat(s, "v");
if (crc32("jApFYTOC",8) == 1600141403) strcat(s, "e");
if (crc32("SLUFtuFUR",9) == 486928324) strcat(s, "n");
if (crc32("GlfJVN",6) == 3784849335) strcat(s, "t");
if (crc32("HfpULosZJr",10) == 1407695244) strcat(s, "l");
if (crc32("gotNbaHijPewtq",14) == 1751985576) strcat(s, "y");
    return s;
}

char *flickeringly_adverbs() {
    char *s = calloc(13);
    if (crc32("aZSJhgLX",8) == 3974703234) strcat(s, "f");
if (crc32("qITBMACgH",9) == 4070051849) strcat(s, "x");
if (crc32("UABJJmNhe",9) == 2002461754) strcat(s, "l");
if (crc32("NpsYLVO",7) == 3387223642) strcat(s, "W");
if (crc32("NLdJIxWgMvAomJ",14) == 3088458261) strcat(s, "i");
if (crc32("EkGGSBvAJEeT",12) == 550803401) strcat(s, "c");
if (crc32("RRfNhRQeRmr",11) == 1485372330) strcat(s, "X");
if (crc32("spzMxLg",7) == 1143647645) strcat(s, "k");
if (crc32("RBfWNHOMsKEMEHa",15) == 1996511722) strcat(s, "Z");
if (crc32("CRuBBjOj",8) == 2709352558) strcat(s, "e");
if (crc32("OXysEWFrpeq",11) == 2154785011) strcat(s, "r");
if (crc32("UoZgkvcPgItED",13) == 2364526886) strcat(s, "M");
if (crc32("ifAfMayGDfSDAup",15) == 443305418) strcat(s, "i");
if (crc32("emsTEvePbHeSB",13) == 2891617820) strcat(s, "n");
if (crc32("aTcgsjKJqtRqS",13) == 2537283670) strcat(s, "x");
if (crc32("JiePajbrkUF",11) == 2346427954) strcat(s, "g");
if (crc32("cFMCAgZQlBMWGg",14) == 827942772) strcat(s, "Z");
if (crc32("XaJeSyAOGr",10) == 1141326554) strcat(s, "l");
if (crc32("xqaed",5) == 820135932) strcat(s, "P");
if (crc32("kAJxE",5) == 2536882414) strcat(s, "y");
    return s;
}

char *rompingly_adverbs() {
    char *s = calloc(10);
    if (crc32("WRkdVrnBXXCZLdG",15) == 2151933488) strcat(s, "r");
if (crc32("ofmpWINDV",9) == 3765124616) strcat(s, "N");
if (crc32("QqqWiToFuSlt",12) == 1980475581) strcat(s, "o");
if (crc32("VjNYTrLYpPeSPYc",15) == 3181835455) strcat(s, "r");
if (crc32("tBAUeyHKqrZCyE",14) == 3883364309) strcat(s, "m");
if (crc32("xJnoIf",6) == 643841812) strcat(s, "R");
if (crc32("eULBwQHL",8) == 171008652) strcat(s, "p");
if (crc32("ohzIvDAzOHg",11) == 1619460872) strcat(s, "r");
if (crc32("UxbyxGYwEB",10) == 3812087933) strcat(s, "i");
if (crc32("JfvtRoRjcqhaIbR",15) == 924653184) strcat(s, "v");
if (crc32("FsqLzWJDOWNN",12) == 1865289112) strcat(s, "n");
if (crc32("vxahteTqQWltOX",14) == 890601908) strcat(s, "C");
if (crc32("rJECwzw",7) == 467999914) strcat(s, "g");
if (crc32("qVZWPdNU",8) == 2480079118) strcat(s, "l");
if (crc32("jimKTeElNVGdS",13) == 4001495267) strcat(s, "Y");
if (crc32("ZZJfvTC",7) == 3668719289) strcat(s, "y");
    return s;
}

char *peakily_adverbs() {
    char *s = calloc(8);
    if (crc32("YqAhjBNuQA",10) == 1779169679) strcat(s, "N");
if (crc32("aiHOqMGyvLuBRjB",15) == 1763044308) strcat(s, "p");
if (crc32("nVoppPLybBlTZSh",15) == 515986411) strcat(s, "v");
if (crc32("MGYpzJEsNMV",11) == 3389359111) strcat(s, "e");
if (crc32("mTkFUwpLkme",11) == 2536489005) strcat(s, "a");
if (crc32("UUlLAy",6) == 3585733535) strcat(s, "k");
if (crc32("MIxvSSnumj",10) == 195839595) strcat(s, "i");
if (crc32("tDMmPigwTzq",11) == 3740853502) strcat(s, "N");
if (crc32("QWKhFqPrl",9) == 1340695895) strcat(s, "l");
if (crc32("KBgdUMYslJQ",11) == 2979476277) strcat(s, "y");
    return s;
}

char *unecliptically_adverbs() {
    char *s = calloc(15);
    if (crc32("ZfMkvXSIGbSwS",13) == 1189032578) strcat(s, "i");
if (crc32("LzdnMNNJGgjzK",13) == 1570556398) strcat(s, "u");
if (crc32("CZAOMYewUr",10) == 2002779802) strcat(s, "s");
if (crc32("lAaYv",5) == 574800138) strcat(s, "n");
if (crc32("hvITgI",6) == 3132724038) strcat(s, "V");
if (crc32("KPyvOZVLAvFJ",12) == 3092074261) strcat(s, "e");
if (crc32("wTPDZo",6) == 1908365245) strcat(s, "V");
if (crc32("VIODzjLqrZYkjTj",15) == 2263180703) strcat(s, "c");
if (crc32("CqLmYpsQmO",10) == 354107946) strcat(s, "l");
if (crc32("aMHdkkT",7) == 1898049793) strcat(s, "i");
if (crc32("GckQXISUWY",10) == 329075030) strcat(s, "p");
if (crc32("YqMRVUFWVXYwD",13) == 3572166222) strcat(s, "J");
if (crc32("JfEGr",5) == 3176045011) strcat(s, "t");
if (crc32("EEGRYj",6) == 1418171308) strcat(s, "q");
if (crc32("nSHkJzphIIUB",12) == 2631782953) strcat(s, "i");
if (crc32("IazbqjvuizKhJHo",15) == 1571616073) strcat(s, "c");
if (crc32("jNzVTphhuptZL",13) == 2748767225) strcat(s, "a");
if (crc32("FvgTgVwXHjw",11) == 3921032511) strcat(s, "Z");
if (crc32("NzZhBHEMtKGxw",13) == 1841289098) strcat(s, "l");
if (crc32("yJKyzl",6) == 2344584131) strcat(s, "c");
if (crc32("tLUPE",5) == 3452457607) strcat(s, "l");
if (crc32("HBuAu",5) == 2086032300) strcat(s, "T");
if (crc32("MGWXj",5) == 3597954126) strcat(s, "y");
    return s;
}

char *beauteously_adverbs() {
    char *s = calloc(12);
    if (crc32("wlJwTBfuAwvp",12) == 1918225028) strcat(s, "X");
if (crc32("FHqtbv",6) == 1855357187) strcat(s, "b");
if (crc32("WGOZyAaEJqhdt",13) == 1444169541) strcat(s, "o");
if (crc32("EmpDMoZst",9) == 2956210182) strcat(s, "e");
if (crc32("fFMrP",5) == 1696009184) strcat(s, "x");
if (crc32("dkmZtWGaWgrimrX",15) == 4268725369) strcat(s, "a");
if (crc32("vsHKjuqug",9) == 1605650400) strcat(s, "K");
if (crc32("AJnMxmVgpyEYil",14) == 66492244) strcat(s, "u");
if (crc32("CpKYA",5) == 2753789986) strcat(s, "t");
if (crc32("pOnCMWl",7) == 1845251604) strcat(s, "w");
if (crc32("ISbEKRGZHcL",11) == 2169750561) strcat(s, "e");
if (crc32("VjrSPOPTCBp",11) == 2987740738) strcat(s, "z");
if (crc32("UDLsAhqMvq",10) == 77318544) strcat(s, "o");
if (crc32("kaXNFYjnu",9) == 2401822418) strcat(s, "m");
if (crc32("ddyTh",5) == 3628753953) strcat(s, "u");
if (crc32("gOMeL",5) == 2384679392) strcat(s, "t");
if (crc32("RQuDEhiNkZtqYni",15) == 562434348) strcat(s, "s");
if (crc32("IfBlIFJVEacTW",13) == 1649639731) strcat(s, "l");
if (crc32("DABOPYmO",8) == 3711895244) strcat(s, "h");
if (crc32("oYDWOmq",7) == 3157126498) strcat(s, "y");
    return s;
}

char *voluminously_adverbs() {
    char *s = calloc(13);
    if (crc32("LLnDXdxsZkVOnHX",15) == 2604332310) strcat(s, "N");
if (crc32("XAFgsw",6) == 219696686) strcat(s, "v");
if (crc32("nLNbsknBfKCZQ",13) == 2373995756) strcat(s, "n");
if (crc32("LvgTJuTFAuzQ",12) == 3122727041) strcat(s, "o");
if (crc32("mlATUKpQcZrpZWZ",15) == 2392264959) strcat(s, "e");
if (crc32("XOVrKMJVHW",10) == 873976841) strcat(s, "l");
if (crc32("ARkDJgIWNo",10) == 1247425288) strcat(s, "u");
if (crc32("VjLYxP",6) == 2260038933) strcat(s, "m");
if (crc32("vkTlyPza",8) == 3634335448) strcat(s, "i");
if (crc32("qYGYNbxDAu",10) == 2147819485) strcat(s, "h");
if (crc32("JxZqDuMlobAsAU",14) == 98942779) strcat(s, "n");
if (crc32("cIwWrdLzAlw",11) == 3358916529) strcat(s, "w");
if (crc32("hrWGkJBdXjjg",12) == 1444623881) strcat(s, "o");
if (crc32("uEusadKp",8) == 766506812) strcat(s, "O");
if (crc32("oJXck",5) == 3757461604) strcat(s, "u");
if (crc32("NIqeO",5) == 1814546182) strcat(s, "s");
if (crc32("YScqm",5) == 3225250646) strcat(s, "K");
if (crc32("oLsvuiyuvIYZm",13) == 1479735785) strcat(s, "l");
if (crc32("HemQKpzByF",10) == 1579495074) strcat(s, "V");
if (crc32("IfrHmvkvo",9) == 3579611913) strcat(s, "y");
    return s;
}

char *conveniently_adverbs() {
    char *s = calloc(13);
    if (crc32("ucybwMLRiYFKNJ",14) == 198929692) strcat(s, "F");
if (crc32("praoUWMGsm",10) == 1474509950) strcat(s, "c");
if (crc32("JnkjeUlTBirO",12) == 938377604) strcat(s, "N");
if (crc32("fZfFYWI",7) == 3917819812) strcat(s, "o");
if (crc32("WckrStsBpwmyhPp",15) == 2390006692) strcat(s, "n");
if (crc32("GzPszQbqCCy",11) == 452472560) strcat(s, "v");
if (crc32("WORUcinpHJvbPc",14) == 1786408627) strcat(s, "D");
if (crc32("Bggkb",5) == 718101555) strcat(s, "e");
if (crc32("pIDaZz",6) == 1122293211) strcat(s, "n");
if (crc32("BXDvJ",5) == 1918339227) strcat(s, "i");
if (crc32("VSxmHR",6) == 1206377095) strcat(s, "e");
if (crc32("veCMzcYCkSOhhc",14) == 3494428564) strcat(s, "n");
if (crc32("RgzJDDXjytDxkRU",15) == 187775383) strcat(s, "A");
if (crc32("NtlfTAbKsOzjRQg",15) == 888847467) strcat(s, "t");
if (crc32("lsGdxlOV",8) == 1537627726) strcat(s, "l");
if (crc32("RjyplcsI",8) == 4124631269) strcat(s, "u");
if (crc32("edjtNmYK",8) == 2522774027) strcat(s, "y");
    return s;
}

char *plastically_adverbs() {
    char *s = calloc(12);
    if (crc32("yTWXnLn",7) == 4166313157) strcat(s, "Q");
if (crc32("yfAaEgchUbVMs",13) == 1232951357) strcat(s, "p");
if (crc32("eNZdTqjiHuTnly",14) == 722836766) strcat(s, "y");
if (crc32("ktnioDRHaReC",12) == 3635908701) strcat(s, "l");
if (crc32("IZZVmbkAUQy",11) == 1310513207) strcat(s, "R");
if (crc32("IKaTfNPFhsat",12) == 1758154417) strcat(s, "a");
if (crc32("mKQzog",6) == 837800621) strcat(s, "s");
if (crc32("NanlvLKIjaCge",13) == 2497777984) strcat(s, "t");
if (crc32("lQTJqvL",7) == 2091786819) strcat(s, "i");
if (crc32("mlaraIye",8) == 3247253210) strcat(s, "U");
if (crc32("HjEJZeRMAoAHGD",14) == 3439532453) strcat(s, "c");
if (crc32("dOzoUtnzvKK",11) == 3915180288) strcat(s, "a");
if (crc32("JIoussw",7) == 2382825084) strcat(s, "l");
if (crc32("LEiPWVZNRIW",11) == 3839966315) strcat(s, "l");
if (crc32("BTJkCbCs",8) == 2614371626) strcat(s, "S");
if (crc32("jQygZLDlhn",10) == 3756760877) strcat(s, "y");
    return s;
}

char *immitigably_adverbs() {
    char *s = calloc(12);
    if (crc32("vbWjTTEkOC",10) == 815608123) strcat(s, "i");
if (crc32("TEgkXFs",7) == 3755402583) strcat(s, "m");
if (crc32("sjNQysd",7) == 1746693040) strcat(s, "m");
if (crc32("FXhyJDnvRd",10) == 2302479311) strcat(s, "i");
if (crc32("UFVCqbXV",8) == 4060172497) strcat(s, "t");
if (crc32("ixcUQRVHY",9) == 3304074057) strcat(s, "v");
if (crc32("chQuQ",5) == 3313012026) strcat(s, "i");
if (crc32("jXjgbsHBhkoQg",13) == 2074266318) strcat(s, "B");
if (crc32("PqeBTrACXjUDc",13) == 3733394626) strcat(s, "g");
if (crc32("WFOxVy",6) == 727152332) strcat(s, "a");
if (crc32("ddRgSWwHzw",10) == 3309759365) strcat(s, "F");
if (crc32("lwTHW",5) == 3390206530) strcat(s, "b");
if (crc32("VACrNZgErgfGeWc",15) == 229453073) strcat(s, "l");
if (crc32("wrBBZlRhQWvHJm",14) == 694149919) strcat(s, "y");
    return s;
}

char *pinnatedly_adverbs() {
    char *s = calloc(11);
    if (crc32("FjcLW",5) == 539778137) strcat(s, "d");
if (crc32("tMfjZAtZuyPu",12) == 225347049) strcat(s, "p");
if (crc32("ADXqZVLNiYVEIE",14) == 358117225) strcat(s, "i");
if (crc32("VoSrSlcxoU",10) == 684308008) strcat(s, "n");
if (crc32("UkgCsnxUyVhWW",13) == 2641180915) strcat(s, "n");
if (crc32("rneNjfcA",8) == 2159156972) strcat(s, "u");
if (crc32("GpSqKNkhod",10) == 2130492660) strcat(s, "a");
if (crc32("lCysWcgPYOAk",12) == 3972782469) strcat(s, "t");
if (crc32("yWVkdVDEfLHUP",13) == 2779066488) strcat(s, "l");
if (crc32("izvTkZgrG",9) == 3246766721) strcat(s, "e");
if (crc32("WivjioCvUyvUdx",14) == 264325667) strcat(s, "u");
if (crc32("nLMFx",5) == 2975717034) strcat(s, "d");
if (crc32("GPurpsSt",8) == 1176772560) strcat(s, "l");
if (crc32("uHISWLojJT",10) == 765649228) strcat(s, "E");
if (crc32("YTaLNAXx",8) == 2153084220) strcat(s, "y");
    return s;
}

char *cotemporaneously_adverbs() {
    char *s = calloc(17);
    if (crc32("IkvLey",6) == 1911579077) strcat(s, "c");
if (crc32("nJwyPFxYPGJsDD",14) == 3088148252) strcat(s, "o");
if (crc32("gcwewCBN",8) == 2511867739) strcat(s, "t");
if (crc32("NCainNZHobdHU",13) == 2573250644) strcat(s, "e");
if (crc32("taBEpOq",7) == 3423088303) strcat(s, "m");
if (crc32("coObXVelhtRU",12) == 113924848) strcat(s, "p");
if (crc32("gAvqINteRn",10) == 40237219) strcat(s, "g");
if (crc32("rgCCraEGa",9) == 3976832407) strcat(s, "o");
if (crc32("vKYBbTbA",8) == 3962172716) strcat(s, "r");
if (crc32("DbEhUhP",7) == 2863494288) strcat(s, "a");
if (crc32("nEMcqlVdjZQJqZ",14) == 1982046858) strcat(s, "n");
if (crc32("BZICCCt",7) == 3243231022) strcat(s, "e");
if (crc32("zjANi",5) == 3837720521) strcat(s, "D");
if (crc32("HjWfA",5) == 2713024224) strcat(s, "o");
if (crc32("mJveRPlOeqFZ",12) == 4051276636) strcat(s, "u");
if (crc32("GQPtNtstfkg",11) == 1598526408) strcat(s, "s");
if (crc32("SWNtBb",6) == 1273288143) strcat(s, "f");
if (crc32("nfvqqYMsCUhju",13) == 753941040) strcat(s, "l");
if (crc32("FZFNlHZfrvPZ",12) == 1856007834) strcat(s, "h");
if (crc32("ErwEaPDiKUYvBWr",15) == 2005550590) strcat(s, "y");
    return s;
}

char *instanter_adverbs() {
    char *s = calloc(10);
    if (crc32("vwuHkHCxYv",10) == 346523489) strcat(s, "i");
if (crc32("BLfnhjYY",8) == 2665393966) strcat(s, "U");
if (crc32("gyVIQclUnMjg",12) == 656649986) strcat(s, "n");
if (crc32("emPXOhcvJZf",11) == 3668682761) strcat(s, "f");
if (crc32("JsGseQQ",7) == 2452096433) strcat(s, "s");
if (crc32("CSpnPDqCRZsCG",13) == 3937670790) strcat(s, "t");
if (crc32("EKDWwiMIzsxx",12) == 584896025) strcat(s, "U");
if (crc32("MYgzxXHNNbqEmu",14) == 2830559936) strcat(s, "a");
if (crc32("RdpWTe",6) == 1596700171) strcat(s, "N");
if (crc32("CBExRgftvlIuqS",14) == 2802489890) strcat(s, "n");
if (crc32("MBuJUfpGZWX",11) == 1330477321) strcat(s, "t");
if (crc32("azTQL",5) == 3515682522) strcat(s, "e");
if (crc32("yXcMUqtbfXmWzW",14) == 2286199331) strcat(s, "p");
if (crc32("zKpYPvsokEequz",14) == 3101815371) strcat(s, "r");
    return s;
}

char *semiopenly_adverbs() {
    char *s = calloc(11);
    if (crc32("pKiuHtjp",8) == 1408769048) strcat(s, "s");
if (crc32("saosXwBVZ",9) == 3040587291) strcat(s, "Q");
if (crc32("YLNhJMORDCM",11) == 3038570811) strcat(s, "e");
if (crc32("ylwFDTUdJsNUfo",14) == 1519587308) strcat(s, "m");
if (crc32("AFogQbiqbf",10) == 1993344057) strcat(s, "D");
if (crc32("vGeHqwvSUx",10) == 2146548651) strcat(s, "i");
if (crc32("GXYKDZEEamwdU",13) == 3092945503) strcat(s, "o");
if (crc32("JdAPrsnpQ",9) == 2149072091) strcat(s, "N");
if (crc32("dvImsfzfOOB",11) == 1945464436) strcat(s, "p");
if (crc32("JBptizKaTe",10) == 1376125057) strcat(s, "H");
if (crc32("FgEhPLhSdMtT",12) == 3834002339) strcat(s, "e");
if (crc32("rxSYPeGUztwCTWl",15) == 2639992005) strcat(s, "n");
if (crc32("nDwXFjRoGxGRGj",14) == 3911836199) strcat(s, "l");
if (crc32("rvDEptRt",8) == 2367329003) strcat(s, "F");
if (crc32("GskLUM",6) == 1206620658) strcat(s, "y");
    return s;
}

char *superaffluently_adverbs() {
    char *s = calloc(16);
    if (crc32("tcLelFeFmmIdb",13) == 966607951) strcat(s, "z");
if (crc32("eGbYFPf",7) == 1765116582) strcat(s, "s");
if (crc32("mlIINXVwHfgtAg",14) == 3080782055) strcat(s, "u");
if (crc32("VcSjeV",6) == 3019752013) strcat(s, "p");
if (crc32("dIDeavsv",8) == 10852972) strcat(s, "T");
if (crc32("zjrzWcm",7) == 4020998852) strcat(s, "e");
if (crc32("KeXqttNlk",9) == 1940001642) strcat(s, "r");
if (crc32("TZIEV",5) == 1384308401) strcat(s, "b");
if (crc32("hdvOuFHDsVSbZS",14) == 3277742808) strcat(s, "a");
if (crc32("ZNFYYkJm",8) == 151082579) strcat(s, "D");
if (crc32("WiOEtFZa",8) == 2690212265) strcat(s, "f");
if (crc32("KnmtbcNC",8) == 3187644919) strcat(s, "t");
if (crc32("CXmuAKto",8) == 2657833934) strcat(s, "f");
if (crc32("NVAnbKc",7) == 1635807771) strcat(s, "l");
if (crc32("fHTQIBXSTGp",11) == 787077368) strcat(s, "u");
if (crc32("tRVIfcnFXxNWYn",14) == 2490677332) strcat(s, "e");
if (crc32("iPPNEjzFMZTXl",13) == 2349295557) strcat(s, "Z");
if (crc32("lEsxKxDSmjqASNX",15) == 3120476239) strcat(s, "n");
if (crc32("nTElXmmzmMGla",13) == 3834652918) strcat(s, "t");
if (crc32("ODmzdwyoib",10) == 4108281926) strcat(s, "Z");
if (crc32("neGFo",5) == 3793958415) strcat(s, "l");
if (crc32("HdehoAgNQ",9) == 3977245709) strcat(s, "y");
    return s;
}

char *chromosomally_adverbs() {
    char *s = calloc(14);
    if (crc32("pZIuKci",7) == 3546467819) strcat(s, "c");
if (crc32("CxySNCWcnxumRwm",15) == 3804280018) strcat(s, "h");
if (crc32("ysOqaOAfEMXmXmG",15) == 200879227) strcat(s, "r");
if (crc32("SawqCjB",7) == 2710870917) strcat(s, "o");
if (crc32("jApvMMxVxZpWkz",14) == 125413846) strcat(s, "m");
if (crc32("yoMjYoPeVwNd",12) == 2721905800) strcat(s, "F");
if (crc32("OpqqiCIeoBDHe",13) == 285784355) strcat(s, "o");
if (crc32("MDCyVsqoSwT",11) == 2984448056) strcat(s, "E");
if (crc32("AGnVpm",6) == 820070930) strcat(s, "s");
if (crc32("BpLXkWjdfQVH",12) == 1566109950) strcat(s, "o");
if (crc32("NyrtvU",6) == 2163776401) strcat(s, "m");
if (crc32("FqmdcWLe",8) == 962852755) strcat(s, "a");
if (crc32("gntjQtB",7) == 196462465) strcat(s, "O");
if (crc32("ndwPs",5) == 1986878818) strcat(s, "l");
if (crc32("AObUakrbcefH",12) == 1689478357) strcat(s, "l");
if (crc32("GSlwYymiHQPkNar",15) == 2920593201) strcat(s, "y");
    return s;
}

char *unromantically_adverbs() {
    char *s = calloc(15);
    if (crc32("YsgJKolSezGEa",13) == 653690566) strcat(s, "u");
if (crc32("FQlyVXoWVGWU",12) == 264901117) strcat(s, "n");
if (crc32("TyfmcmalMzcG",12) == 4197537284) strcat(s, "l");
if (crc32("cusFIcH",7) == 894226179) strcat(s, "r");
if (crc32("RRKWhkVBfEiZqQ",14) == 3625247282) strcat(s, "s");
if (crc32("zVtQPdIAkapXps",14) == 2600965809) strcat(s, "o");
if (crc32("iyDcYz",6) == 4021664163) strcat(s, "m");
if (crc32("euDQxijcLzY",11) == 4095516494) strcat(s, "a");
if (crc32("LHLLBADCI",9) == 2109348960) strcat(s, "n");
if (crc32("ISVGbziwOeCLJJ",14) == 4232903344) strcat(s, "t");
if (crc32("hWlnQVczVNZWUC",14) == 2895174651) strcat(s, "t");
if (crc32("GTBUyipBWF",10) == 1617754212) strcat(s, "i");
if (crc32("xPZOEjGSHUWH",12) == 340785219) strcat(s, "c");
if (crc32("oZpUBrpMQkpvs",13) == 521538517) strcat(s, "m");
if (crc32("dCqeoKFEuilxeh",14) == 3761745527) strcat(s, "a");
if (crc32("NZyZruNbNRnPCh",14) == 1934207798) strcat(s, "l");
if (crc32("zJVawjHKAcicYM",14) == 951909908) strcat(s, "l");
if (crc32("VDBNawBbLDfu",12) == 1667765799) strcat(s, "l");
if (crc32("iJKScn",6) == 1246725175) strcat(s, "y");
    return s;
}

char *exclamatorily_adverbs() {
    char *s = calloc(14);
    if (crc32("QwYfI",5) == 1785964905) strcat(s, "e");
if (crc32("SqiONzYjEcBgdL",14) == 516977767) strcat(s, "x");
if (crc32("vGXyTARvcz",10) == 1625933433) strcat(s, "c");
if (crc32("yUFHgnR",7) == 3719433711) strcat(s, "K");
if (crc32("dlziUADDj",9) == 2593913021) strcat(s, "l");
if (crc32("cDvTwOsxiNQhINh",15) == 1411275610) strcat(s, "P");
if (crc32("qvRVrvHRASvKGty",15) == 2863131687) strcat(s, "a");
if (crc32("ZOoJKeocI",9) == 3289628463) strcat(s, "D");
if (crc32("vuxtYIShHgqPioV",15) == 961445282) strcat(s, "m");
if (crc32("ImNzqNWKXAZKj",13) == 510063023) strcat(s, "e");
if (crc32("yStShPnq",8) == 1699916523) strcat(s, "a");
if (crc32("zZjHaLAe",8) == 82891661) strcat(s, "X");
if (crc32("IaFbqMyRaQ",10) == 1082010509) strcat(s, "t");
if (crc32("SWpueHQYjU",10) == 300925265) strcat(s, "o");
if (crc32("hkwgeAubXupHlk",14) == 2816666834) strcat(s, "S");
if (crc32("rwaRbSuYeJZcaa",14) == 2686510473) strcat(s, "r");
if (crc32("iAzwkpnMZTz",11) == 2833562914) strcat(s, "o");
if (crc32("zHiFCBq",7) == 2343802227) strcat(s, "i");
if (crc32("pbKNyZfHO",9) == 316255897) strcat(s, "u");
if (crc32("SfRvynnzKjcuzxw",15) == 1611188909) strcat(s, "l");
if (crc32("HYAwZJkWzH",10) == 3954937673) strcat(s, "y");
    return s;
}

char *monolithically_adverbs() {
    char *s = calloc(15);
    if (crc32("TzqZpGPEbYRCmf",14) == 1199877783) strcat(s, "r");
if (crc32("xNGUtfWWdU",10) == 3783897511) strcat(s, "m");
if (crc32("BEpqEpRRMb",10) == 1168098423) strcat(s, "o");
if (crc32("sXlCeAyItxWWOy",14) == 1224166723) strcat(s, "F");
if (crc32("vhaOfz",6) == 3201334635) strcat(s, "n");
if (crc32("RHrykmLK",8) == 2785513176) strcat(s, "o");
if (crc32("aaTqCxRLdHhU",12) == 3117942982) strcat(s, "m");
if (crc32("WbQqvEisrjNj",12) == 552512157) strcat(s, "l");
if (crc32("xIWCWOkbsdN",11) == 1562101224) strcat(s, "i");
if (crc32("dXSqv",5) == 2562194821) strcat(s, "W");
if (crc32("TdKaSBcFKqX",11) == 611395550) strcat(s, "t");
if (crc32("PuVpFcIrRHspo",13) == 2902475810) strcat(s, "T");
if (crc32("AZEZINqpr",9) == 3121603356) strcat(s, "h");
if (crc32("sBTzTAKPqQCih",13) == 1335661704) strcat(s, "i");
if (crc32("kNHEwKWRJF",10) == 2774079020) strcat(s, "c");
if (crc32("dUPKqvxC",8) == 3893356120) strcat(s, "a");
if (crc32("mArnOBZJv",9) == 3732838600) strcat(s, "l");
if (crc32("BahQEDmhtDFM",12) == 3692938802) strcat(s, "b");
if (crc32("QhVBgWjHZaXLwQo",15) == 2309998473) strcat(s, "l");
if (crc32("omEvotKRRNvDLw",14) == 265285580) strcat(s, "p");
if (crc32("OBvhbEBpqetyTpO",15) == 1535977228) strcat(s, "y");
    return s;
}

char *quasiexternally_adverbs() {
    char *s = calloc(16);
    if (crc32("eIPCuGWLo",9) == 1131941280) strcat(s, "q");
if (crc32("qOXOzAQTTVJWTLc",15) == 495035619) strcat(s, "q");
if (crc32("SRRavCvIw",9) == 4024165895) strcat(s, "b");
if (crc32("QvAvRAHtN",9) == 333309555) strcat(s, "u");
if (crc32("qfXoSxqqbzwRdMz",15) == 1409737493) strcat(s, "Z");
if (crc32("CeXjL",5) == 1465787179) strcat(s, "a");
if (crc32("ZlYPBNSe",8) == 420948798) strcat(s, "s");
if (crc32("AlFDUg",6) == 3425148317) strcat(s, "m");
if (crc32("eBdNjCc",7) == 1537510154) strcat(s, "i");
if (crc32("fRrwPSQZ",8) == 1193104746) strcat(s, "e");
if (crc32("bVtgbqJ",7) == 441393050) strcat(s, "x");
if (crc32("FaufiIE",7) == 912995678) strcat(s, "t");
if (crc32("opIpf",5) == 1121631433) strcat(s, "e");
if (crc32("YCInFuvdv",9) == 778081252) strcat(s, "v");
if (crc32("ejRjdmjbolUhIVS",15) == 2714062145) strcat(s, "r");
if (crc32("WieuzqAgJxjAd",13) == 1465553302) strcat(s, "n");
if (crc32("HDOQKDDZfbonJRX",15) == 1875264346) strcat(s, "a");
if (crc32("zfoujuYLKcJRyi",14) == 785923200) strcat(s, "e");
if (crc32("ropOubWRb",9) == 3241046744) strcat(s, "l");
if (crc32("QGnuvHTl",8) == 1914727937) strcat(s, "b");
if (crc32("rMaWMRNDLuGR",12) == 2704855054) strcat(s, "l");
if (crc32("WHvDJ",5) == 3992450845) strcat(s, "m");
if (crc32("rRlxp",5) == 3524932381) strcat(s, "y");
    return s;
}

char *balsamically_adverbs() {
    char *s = calloc(13);
    if (crc32("bxrhfsuYZgZuv",13) == 4049361798) strcat(s, "b");
if (crc32("mfcSTWujhmf",11) == 59216268) strcat(s, "b");
if (crc32("sTCWWOaNSqjrgiG",15) == 774019885) strcat(s, "a");
if (crc32("sqKheW",6) == 2069003173) strcat(s, "z");
if (crc32("TYJprVdRfPq",11) == 2088254945) strcat(s, "l");
if (crc32("ImBTfkQCbYt",11) == 2991985763) strcat(s, "s");
if (crc32("NituIpGILPC",11) == 3359405768) strcat(s, "R");
if (crc32("vdwtQoazvZg",11) == 116041838) strcat(s, "a");
if (crc32("sEjRcQJj",8) == 1015412925) strcat(s, "q");
if (crc32("VSvHVK",6) == 697613984) strcat(s, "m");
if (crc32("NGTZxbVnUQTI",12) == 656376146) strcat(s, "a");
if (crc32("EAQdUQnxp",9) == 4145312590) strcat(s, "i");
if (crc32("nVENKCUvzXMtE",13) == 2296564260) strcat(s, "i");
if (crc32("zjBspjJfAsTxbc",14) == 3999482792) strcat(s, "c");
if (crc32("tcNnJYp",7) == 2200478226) strcat(s, "S");
if (crc32("zlgvNAwZyN",10) == 1169933482) strcat(s, "a");
if (crc32("EIXGdPBwLwX",11) == 918358065) strcat(s, "R");
if (crc32("sOjRBIXLcsr",11) == 1867658645) strcat(s, "l");
if (crc32("HVkbKZVmXcQWDC",14) == 4237242966) strcat(s, "l");
if (crc32("zORYJEfsJw",10) == 782434010) strcat(s, "S");
if (crc32("yCYWM",5) == 633037297) strcat(s, "y");
    return s;
}

char *mantically_adverbs() {
    char *s = calloc(11);
    if (crc32("kUmcbLKxiOBY",12) == 331679584) strcat(s, "F");
if (crc32("jZtKXtpvA",9) == 1449888490) strcat(s, "m");
if (crc32("SjXXhseo",8) == 340909241) strcat(s, "a");
if (crc32("NJEXuMlhCbPq",12) == 1865040099) strcat(s, "n");
if (crc32("djqSsUZwJSQRvV",14) == 1987096925) strcat(s, "n");
if (crc32("wgHLUMmNzi",10) == 404233863) strcat(s, "t");
if (crc32("xJYglyi",7) == 145080577) strcat(s, "j");
if (crc32("rfupZdmUzkGc",12) == 1057185448) strcat(s, "i");
if (crc32("XLpjnZTqYU",10) == 1028134183) strcat(s, "s");
if (crc32("ozGELrY",7) == 2047633155) strcat(s, "c");
if (crc32("nDirHNSZKAYYn",13) == 1505862141) strcat(s, "a");
if (crc32("fKOKsZ",6) == 1969073263) strcat(s, "s");
if (crc32("YtwNuZgjrhS",11) == 1543257236) strcat(s, "l");
if (crc32("WEynFbVhPz",10) == 3706440896) strcat(s, "l");
if (crc32("pzLybCL",7) == 3219420575) strcat(s, "y");
    return s;
}

char *vigilantly_adverbs() {
    char *s = calloc(11);
    if (crc32("spmgrHprq",9) == 3484391706) strcat(s, "v");
if (crc32("RWUDxvvi",8) == 3600744507) strcat(s, "i");
if (crc32("cLMPKOjHYm",10) == 3108551485) strcat(s, "z");
if (crc32("cKBns",5) == 365501117) strcat(s, "g");
if (crc32("PVFTyrAPZ",9) == 1253232165) strcat(s, "l");
if (crc32("GLhdyCKguYG",11) == 192742430) strcat(s, "i");
if (crc32("WxqFRiAJffLfsl",14) == 3506144716) strcat(s, "X");
if (crc32("LBkpkROqgj",10) == 3355350023) strcat(s, "l");
if (crc32("hblxDGpRQNnzCP",14) == 4013651164) strcat(s, "r");
if (crc32("IBQopnSqcUI",11) == 3235139462) strcat(s, "a");
if (crc32("nAakmwpmiaUQH",13) == 2399984100) strcat(s, "W");
if (crc32("BEouSd",6) == 2306292677) strcat(s, "n");
if (crc32("SDRtNDQE",8) == 3935651533) strcat(s, "t");
if (crc32("wTQojaG",7) == 2492774967) strcat(s, "l");
if (crc32("TCjeCcLWIvh",11) == 4063631130) strcat(s, "y");
    return s;
}

char *untropically_adverbs() {
    char *s = calloc(13);
    if (crc32("lyhimfNaJOfQXx",14) == 3807075169) strcat(s, "g");
if (crc32("iEkTpjRmob",10) == 3088382630) strcat(s, "u");
if (crc32("BrKKFOcrsNQ",11) == 2154125248) strcat(s, "C");
if (crc32("LVqDHNnkBR",10) == 1784913991) strcat(s, "n");
if (crc32("kNRzq",5) == 3470898247) strcat(s, "t");
if (crc32("cWUFB",5) == 3091585261) strcat(s, "V");
if (crc32("AGtdKeIbH",9) == 4104546763) strcat(s, "r");
if (crc32("HpVnrs",6) == 260445067) strcat(s, "d");
if (crc32("DnIsLkk",7) == 374778732) strcat(s, "o");
if (crc32("JyEHSKZqVoGrW",13) == 704752222) strcat(s, "p");
if (crc32("WcrpeXCOVuU",11) == 3067626779) strcat(s, "i");
if (crc32("KfdtIWbKPeVb",12) == 2399317995) strcat(s, "P");
if (crc32("ptNkscFhr",9) == 3094248339) strcat(s, "c");
if (crc32("ELXEJMP",7) == 3721086886) strcat(s, "z");
if (crc32("EMleeXUifc",10) == 3869081451) strcat(s, "a");
if (crc32("JrrIkZ",6) == 1693936648) strcat(s, "A");
if (crc32("sXMwRUxJr",9) == 3395340097) strcat(s, "l");
if (crc32("VNZpNxEgs",9) == 2218392970) strcat(s, "w");
if (crc32("sHxOygtgvinWnc",14) == 1192111532) strcat(s, "l");
if (crc32("DmuVvw",6) == 3179119808) strcat(s, "L");
if (crc32("HjZXzOfdtgoxh",13) == 3118035348) strcat(s, "y");
    return s;
}

char *subgranularly_adverbs() {
    char *s = calloc(14);
    if (crc32("ncDrCvVJTkMvu",13) == 2834270807) strcat(s, "R");
if (crc32("UqMRGpV",7) == 897223337) strcat(s, "s");
if (crc32("KGLssjTXtsHEtP",14) == 2113963217) strcat(s, "u");
if (crc32("VWPIKo",6) == 1054848628) strcat(s, "p");
if (crc32("wStTvp",6) == 2128492330) strcat(s, "b");
if (crc32("TaXTeQovZXI",11) == 3523234964) strcat(s, "g");
if (crc32("lUmnRKF",7) == 3563641810) strcat(s, "r");
if (crc32("WxBgR",5) == 1046345891) strcat(s, "a");
if (crc32("vUnBtlmfW",9) == 1453554633) strcat(s, "B");
if (crc32("ilaRDJK",7) == 2770967094) strcat(s, "n");
if (crc32("DhyCcrGk",8) == 1483532973) strcat(s, "u");
if (crc32("DXZRbJLnjNAnLyK",15) == 3740860641) strcat(s, "l");
if (crc32("VtrvKfkdxdV",11) == 2872604779) strcat(s, "a");
if (crc32("jcXlzWNM",8) == 3322716866) strcat(s, "F");
if (crc32("mAaeImv",7) == 232588786) strcat(s, "r");
if (crc32("YQrzP",5) == 1767788246) strcat(s, "l");
if (crc32("GLiWKMVDgd",10) == 3002508033) strcat(s, "y");
    return s;
}

char *undeviatingly_adverbs() {
    char *s = calloc(14);
    if (crc32("hvbLnak",7) == 783414420) strcat(s, "u");
if (crc32("VQygObsOZewab",13) == 4148504113) strcat(s, "n");
if (crc32("WrSbRUCPoIFVQ",13) == 3327748352) strcat(s, "d");
if (crc32("GxrrgR",6) == 1403464168) strcat(s, "e");
if (crc32("qEKwxSUS",8) == 178375807) strcat(s, "Q");
if (crc32("PeLVmtSiSQiJs",13) == 3996772759) strcat(s, "v");
if (crc32("WmEQVHON",8) == 808635661) strcat(s, "d");
if (crc32("IGsHrqAPfFYyH",13) == 2264754001) strcat(s, "i");
if (crc32("QMAyxOURRTK",11) == 597358870) strcat(s, "a");
if (crc32("kgGCsKRsF",9) == 3968065581) strcat(s, "t");
if (crc32("jaVzGuvTpM",10) == 2497344656) strcat(s, "i");
if (crc32("DBiwtypWUKapxxc",15) == 4105413799) strcat(s, "p");
if (crc32("GsPOFpODtLuLPY",14) == 672783377) strcat(s, "n");
if (crc32("fOWrALvuAKMvhKF",15) == 2597856849) strcat(s, "a");
if (crc32("QfsVAFDuJSsDh",13) == 1213065107) strcat(s, "g");
if (crc32("NQchsDcyjaBw",12) == 2806614486) strcat(s, "B");
if (crc32("HbJOjKJjndgHcI",14) == 2557338741) strcat(s, "l");
if (crc32("xHtGlqDzHhzE",12) == 48277833) strcat(s, "I");
if (crc32("PovAJUNBajr",11) == 1471266014) strcat(s, "y");
    return s;
}

char *dancingly_adverbs() {
    char *s = calloc(10);
    if (crc32("OYBaDMnTlOUxQ",13) == 4150458735) strcat(s, "d");
if (crc32("zJrdXXBGyv",10) == 2088974483) strcat(s, "I");
if (crc32("jEhVgGC",7) == 3077451701) strcat(s, "a");
if (crc32("UGzPHcmrjsCVgN",14) == 2447504173) strcat(s, "n");
if (crc32("IqQVR",5) == 3811379575) strcat(s, "p");
if (crc32("aaBVkziotqrmHp",14) == 470948326) strcat(s, "c");
if (crc32("xaejvEdRreVG",12) == 277078144) strcat(s, "i");
if (crc32("rZSIWNLcAdq",11) == 780775764) strcat(s, "n");
if (crc32("HsfqYFw",7) == 2850080568) strcat(s, "g");
if (crc32("dagDhVOTNt",10) == 3629125542) strcat(s, "l");
if (crc32("xvQnOhUy",8) == 525930585) strcat(s, "y");
    return s;
}

char *predisastrously_adverbs() {
    char *s = calloc(16);
    if (crc32("CdhDxyitAxtJp",13) == 2251179547) strcat(s, "E");
if (crc32("zOvZwPMzgJTKp",13) == 3431919566) strcat(s, "p");
if (crc32("pLFYW",5) == 72557423) strcat(s, "r");
if (crc32("oOlVziWvzA",10) == 3912919612) strcat(s, "e");
if (crc32("SrXQmpSzZYBjBa",14) == 2156159791) strcat(s, "d");
if (crc32("ygOVqumIF",9) == 1860958131) strcat(s, "i");
if (crc32("FnLGx",5) == 3727220980) strcat(s, "s");
if (crc32("ZnwoutweJzCYryc",15) == 117127709) strcat(s, "s");
if (crc32("dDFVJdVENjV",11) == 763580793) strcat(s, "a");
if (crc32("VxohCXjDR",9) == 1573381570) strcat(s, "c");
if (crc32("FVENeQXskxLMID",14) == 3069098917) strcat(s, "s");
if (crc32("xliLpaUB",8) == 2571964449) strcat(s, "t");
if (crc32("YIgBdhQYOggxOU",14) == 3850975357) strcat(s, "r");
if (crc32("aGnDXoWTJb",10) == 1260696380) strcat(s, "L");
if (crc32("ofTHrBkjxMoeMdW",15) == 507336318) strcat(s, "o");
if (crc32("DqlvFyvGwV",10) == 1875598565) strcat(s, "u");
if (crc32("joXtNBdbkpUAK",13) == 385904720) strcat(s, "q");
if (crc32("cpOXp",5) == 707671681) strcat(s, "s");
if (crc32("TJedYklFqib",11) == 3541557215) strcat(s, "y");
if (crc32("FoZwMLO",7) == 95629158) strcat(s, "l");
if (crc32("xExRGpoGEaje",12) == 3705804223) strcat(s, "y");
    return s;
}

char *unphilanthropically_adverbs() {
    char *s = calloc(20);
    if (crc32("yVZtxPhXhbkbEPK",15) == 1886586093) strcat(s, "q");
if (crc32("vzfmligQXVdFBI",14) == 563602565) strcat(s, "u");
if (crc32("DlyMETYl",8) == 3769569299) strcat(s, "n");
if (crc32("nazQklGDZ",9) == 2055570075) strcat(s, "w");
if (crc32("BiBtpNHJ",8) == 3789853554) strcat(s, "p");
if (crc32("pXhsx",5) == 759265596) strcat(s, "h");
if (crc32("baadiTaWHvBX",12) == 468801453) strcat(s, "P");
if (crc32("cTizfggu",8) == 692264640) strcat(s, "i");
if (crc32("qHyFsuqXX",9) == 4213874853) strcat(s, "l");
if (crc32("EzXbxsKbnTIZgm",14) == 2202934156) strcat(s, "a");
if (crc32("ievgJmtGvrc",11) == 3909741268) strcat(s, "n");
if (crc32("jPwtKqSWyabst",13) == 2145556307) strcat(s, "t");
if (crc32("YWKkFaoCteIOHCy",15) == 283398612) strcat(s, "h");
if (crc32("MLjCgFrLoEo",11) == 1254770874) strcat(s, "r");
if (crc32("xZoopYxoY",9) == 137305305) strcat(s, "o");
if (crc32("nTOQFwzpYK",10) == 1056112014) strcat(s, "p");
if (crc32("seCeQVJRtHIZ",12) == 1874061880) strcat(s, "i");
if (crc32("EpnWmjWhWcokh",13) == 426760546) strcat(s, "c");
if (crc32("DFNuUCAgtn",10) == 1089294811) strcat(s, "E");
if (crc32("HlfiE",5) == 562200141) strcat(s, "a");
if (crc32("nzAzOdvQiL",10) == 1933489291) strcat(s, "v");
if (crc32("FpkJSyBbYj",10) == 805262298) strcat(s, "l");
if (crc32("hgvCpd",6) == 656381863) strcat(s, "l");
if (crc32("HobjesSXmkZBP",13) == 4278219710) strcat(s, "y");
    return s;
}

char *doltishly_adverbs() {
    char *s = calloc(10);
    if (crc32("FqVKLPJRque",11) == 4287619225) strcat(s, "d");
if (crc32("hAHIhv",6) == 1257095547) strcat(s, "Y");
if (crc32("eLTFGOoJijS",11) == 3033624559) strcat(s, "o");
if (crc32("bXJYPblYDAJp",12) == 372202082) strcat(s, "l");
if (crc32("miKBvIDkOvUyjkm",15) == 876647957) strcat(s, "I");
if (crc32("FnuOPCN",7) == 1551927330) strcat(s, "t");
if (crc32("AkyHTi",6) == 3182765526) strcat(s, "k");
if (crc32("uwHmMh",6) == 3117347213) strcat(s, "i");
if (crc32("NWaiViAECblr",12) == 2675470093) strcat(s, "W");
if (crc32("woUpbpUw",8) == 3618314289) strcat(s, "s");
if (crc32("EunWbZ",6) == 2971294729) strcat(s, "h");
if (crc32("olMkWmRjGykeoPP",15) == 1912596100) strcat(s, "l");
if (crc32("QJDqURPFhtoqrYW",15) == 2950083131) strcat(s, "Q");
if (crc32("LupAsczl",8) == 1765690747) strcat(s, "y");
    return s;
}

char *undiplomatically_adverbs() {
    char *s = calloc(17);
    if (crc32("SNejdflkSIHp",12) == 2848474277) strcat(s, "u");
if (crc32("bGOsRZ",6) == 127954964) strcat(s, "K");
if (crc32("smREsTcOvjSS",12) == 1405290685) strcat(s, "n");
if (crc32("ORunCUURuiXz",12) == 2349561711) strcat(s, "d");
if (crc32("cieiUXlkoAlxKoR",15) == 3299878637) strcat(s, "b");
if (crc32("QZsAAJVMykNqDox",15) == 1884330146) strcat(s, "i");
if (crc32("YnPZmqSKGNhEE",13) == 1197771425) strcat(s, "I");
if (crc32("xMpeWrOPO",9) == 3349175545) strcat(s, "p");
if (crc32("oZfNNugQf",9) == 2378851405) strcat(s, "l");
if (crc32("mjmdYPUv",8) == 2109843233) strcat(s, "o");
if (crc32("gLOWTEODm",9) == 3195571875) strcat(s, "m");
if (crc32("dayWprhNju",10) == 2519253967) strcat(s, "a");
if (crc32("IdnbrgkkTKeited",15) == 83194657) strcat(s, "G");
if (crc32("wIdsndlwMhqEbJ",14) == 908798969) strcat(s, "t");
if (crc32("jCABAYpOcuN",11) == 2536424275) strcat(s, "R");
if (crc32("BFuUNhG",7) == 1702909734) strcat(s, "i");
if (crc32("dmnBTGrXo",9) == 104592279) strcat(s, "c");
if (crc32("rATznk",6) == 2930571034) strcat(s, "a");
if (crc32("qXddEgwmhyg",11) == 1781912304) strcat(s, "d");
if (crc32("EvsCiF",6) == 3088263091) strcat(s, "l");
if (crc32("KPognO",6) == 3750671391) strcat(s, "l");
if (crc32("tVjcvajS",8) == 284254235) strcat(s, "y");
    return s;
}

char *capriccioso_adverbs() {
    char *s = calloc(12);
    if (crc32("vuDaPkDdVfAQ",12) == 2420155411) strcat(s, "c");
if (crc32("KhNlXAlmZUgE",12) == 2734883368) strcat(s, "K");
if (crc32("GvCMe",5) == 1752570626) strcat(s, "a");
if (crc32("khwKwkOm",8) == 2675361772) strcat(s, "p");
if (crc32("RopTAVnTePmAYf",14) == 3583981095) strcat(s, "D");
if (crc32("TzCScXNilRtWx",13) == 139172485) strcat(s, "r");
if (crc32("tkkIk",5) == 2567874893) strcat(s, "i");
if (crc32("ULqxLqsF",8) == 1291661707) strcat(s, "J");
if (crc32("ibujWu",6) == 2986314596) strcat(s, "c");
if (crc32("CJhyv",5) == 2779809364) strcat(s, "n");
if (crc32("MkKBTJ",6) == 2603829249) strcat(s, "c");
if (crc32("oKhNqtfKMJjt",12) == 1547210476) strcat(s, "c");
if (crc32("UrAtGRgIjcI",11) == 2018888774) strcat(s, "i");
if (crc32("rDYqPGXkUUyPU",13) == 695781589) strcat(s, "o");
if (crc32("vKiDnFzHcnd",11) == 1378348679) strcat(s, "s");
if (crc32("vyfPWndSLDEMOPq",15) == 1776029815) strcat(s, "o");
    return s;
}

char *overjoyfully_adverbs() {
    char *s = calloc(13);
    if (crc32("JrNSqxaZKzYfYMS",15) == 994540365) strcat(s, "o");
if (crc32("OOxqcrGDEVZ",11) == 2837024872) strcat(s, "b");
if (crc32("VfnYGdzJkmmsf",13) == 3913076275) strcat(s, "v");
if (crc32("mLaDFbO",7) == 2047610253) strcat(s, "e");
if (crc32("BPiwxSAAS",9) == 3997282741) strcat(s, "N");
if (crc32("IytLtWRT",8) == 1318439949) strcat(s, "r");
if (crc32("IkQkWkpSPh",10) == 1280330362) strcat(s, "j");
if (crc32("ubyoryPQCuLRkeG",15) == 646036974) strcat(s, "e");
if (crc32("dlpgZ",5) == 781403121) strcat(s, "o");
if (crc32("ytEWyHUBbtj",11) == 3989766994) strcat(s, "O");
if (crc32("WddEM",5) == 854089987) strcat(s, "y");
if (crc32("vjeBUxIWlXNp",12) == 2297874407) strcat(s, "f");
if (crc32("iBpqeSHdayVOp",13) == 1771013261) strcat(s, "u");
if (crc32("PSoJDmRSaNXRqQ",14) == 3377292677) strcat(s, "c");
if (crc32("zGeBSimRKtqzqBY",15) == 3098910458) strcat(s, "l");
if (crc32("ScZSmOsm",8) == 710691425) strcat(s, "H");
if (crc32("ogWEt",5) == 3357863531) strcat(s, "l");
if (crc32("EOSiNiMzvYP",11) == 3893539314) strcat(s, "y");
    return s;
}

char *begrudgingly_adverbs() {
    char *s = calloc(13);
    if (crc32("mxwKqZ",6) == 4223081584) strcat(s, "b");
if (crc32("SoOHouE",7) == 3850738208) strcat(s, "e");
if (crc32("UkbLrsVNGnNQv",13) == 172394008) strcat(s, "g");
if (crc32("qElprTAuMPbipBV",15) == 3200060706) strcat(s, "g");
if (crc32("yTzOkzpSfjOsQ",13) == 3258437248) strcat(s, "v");
if (crc32("Wrftw",5) == 1146053422) strcat(s, "r");
if (crc32("ShfxvdqoK",9) == 893500492) strcat(s, "u");
if (crc32("fMCHHbKZYEww",12) == 780659503) strcat(s, "d");
if (crc32("QwXWuQL",7) == 643123332) strcat(s, "n");
if (crc32("AhCDrBiK",8) == 4226474140) strcat(s, "g");
if (crc32("flunVGKf",8) == 1857199106) strcat(s, "i");
if (crc32("sAcUzSvQoC",10) == 3120767908) strcat(s, "x");
if (crc32("mzQNtysb",8) == 1578538569) strcat(s, "n");
if (crc32("iiwcxGdub",9) == 3814250973) strcat(s, "C");
if (crc32("pIMOXWDRNpfsw",13) == 127492361) strcat(s, "g");
if (crc32("yMVxoNXd",8) == 3244831757) strcat(s, "l");
if (crc32("OKhMKpjkM",9) == 393352576) strcat(s, "y");
    return s;
}

char *suggestibly_adverbs() {
    char *s = calloc(12);
    if (crc32("fXAhhBMHzsRtK",13) == 196787940) strcat(s, "s");
if (crc32("nuujZqOn",8) == 2727180239) strcat(s, "b");
if (crc32("roPVKnTIEu",10) == 1377271591) strcat(s, "u");
if (crc32("hRLVPrW",7) == 3200487771) strcat(s, "Y");
if (crc32("AugxxLnncSS",11) == 1477786032) strcat(s, "g");
if (crc32("ISliZIIFx",9) == 1897715490) strcat(s, "e");
if (crc32("VIreUDqhAWuRj",13) == 3848454662) strcat(s, "g");
if (crc32("etgJnBtwSBtDxM",14) == 2156231838) strcat(s, "U");
if (crc32("jJBVRFTLI",9) == 1519364624) strcat(s, "e");
if (crc32("ceztOcxwQ",9) == 378005356) strcat(s, "s");
if (crc32("dvTZJDMDApRUTL",14) == 1687550676) strcat(s, "t");
if (crc32("vZFFD",5) == 3078984140) strcat(s, "i");
if (crc32("QtVGh",5) == 69277242) strcat(s, "L");
if (crc32("DmStKdhtDIryH",13) == 1613721165) strcat(s, "b");
if (crc32("JccONnYDY",9) == 1853146328) strcat(s, "l");
if (crc32("KLHLdxDAti",10) == 2222000566) strcat(s, "y");
    return s;
}

char *unimpassionately_adverbs() {
    char *s = calloc(17);
    if (crc32("pMZQPun",7) == 2568381852) strcat(s, "L");
if (crc32("RFhyWei",7) == 172319520) strcat(s, "u");
if (crc32("EQCQcqPKf",9) == 2403378047) strcat(s, "n");
if (crc32("ArXDBgKP",8) == 2989433378) strcat(s, "i");
if (crc32("nmDcMc",6) == 756402124) strcat(s, "m");
if (crc32("agcYxppSyoDGDr",14) == 2526000685) strcat(s, "R");
if (crc32("LGzqxiFakzQ",11) == 3887060950) strcat(s, "p");
if (crc32("AehUXeGh",8) == 1490002679) strcat(s, "J");
if (crc32("yibJRS",6) == 2667634832) strcat(s, "a");
if (crc32("hMugbkKHaylND",13) == 4294361335) strcat(s, "s");
if (crc32("MrHPHtBXACqmA",13) == 3326435960) strcat(s, "Q");
if (crc32("CjxGoFkyAgMMpg",14) == 2116845948) strcat(s, "s");
if (crc32("ggYcKYODhWzFHjK",15) == 1951703182) strcat(s, "K");
if (crc32("UZsltfGaUapBxV",14) == 323007046) strcat(s, "i");
if (crc32("KQOoRZi",7) == 4195577139) strcat(s, "B");
if (crc32("jtYltifi",8) == 4026500840) strcat(s, "o");
if (crc32("zXSvIhjZL",9) == 453950247) strcat(s, "n");
if (crc32("GHHGYji",7) == 3899183105) strcat(s, "I");
if (crc32("RClAV",5) == 670508196) strcat(s, "a");
if (crc32("HKaLCGXX",8) == 1817914377) strcat(s, "t");
if (crc32("fWlxySXVMaqb",12) == 784392775) strcat(s, "e");
if (crc32("QrMlnueSsfAxPbl",15) == 1418759480) strcat(s, "l");
if (crc32("AaPmUAmpArvm",12) == 3653806948) strcat(s, "y");
    return s;
}

char *overabusively_adverbs() {
    char *s = calloc(14);
    if (crc32("VwGuYPUObFMvZ",13) == 3405423970) strcat(s, "o");
if (crc32("eIUVaxUFEGf",11) == 1789101223) strcat(s, "v");
if (crc32("HZHXXrqtlNUXRLc",15) == 3042978300) strcat(s, "I");
if (crc32("FAezvDAWfUvk",12) == 2726147428) strcat(s, "e");
if (crc32("iaZhbXdRPml",11) == 2480984354) strcat(s, "r");
if (crc32("hEway",5) == 3795573479) strcat(s, "L");
if (crc32("WQHqzmKccVbmaY",14) == 1242485472) strcat(s, "a");
if (crc32("NQITzoAmRAWl",12) == 315392298) strcat(s, "b");
if (crc32("tsyDAtDTefJE",12) == 1521680710) strcat(s, "u");
if (crc32("ngPVATytw",9) == 2926184409) strcat(s, "s");
if (crc32("aKJIZkltQAwW",12) == 1867088127) strcat(s, "i");
if (crc32("KvBMtuiXC",9) == 983649785) strcat(s, "v");
if (crc32("bvDayXbteOAxS",13) == 1379410775) strcat(s, "e");
if (crc32("PedpddOtgSVWEuN",15) == 989564652) strcat(s, "l");
if (crc32("mqdzGpt",7) == 917387276) strcat(s, "c");
if (crc32("tqCVycaXpiZBE",13) == 3827327055) strcat(s, "y");
    return s;
}

char *ratably_adverbs() {
    char *s = calloc(8);
    if (crc32("lGRIkKKQPHBq",12) == 2185043330) strcat(s, "O");
if (crc32("oOlNVUzGT",9) == 770876229) strcat(s, "r");
if (crc32("LXzVK",5) == 1116899127) strcat(s, "V");
if (crc32("aQaUTQWjweb",11) == 3736964654) strcat(s, "a");
if (crc32("AsVtHxLICqhyiA",14) == 2735864928) strcat(s, "t");
if (crc32("YuPCQrPKykkA",12) == 533248641) strcat(s, "a");
if (crc32("fwCALaFepCE",11) == 2849074975) strcat(s, "v");
if (crc32("awgQXSrYlLDpVR",14) == 2416344312) strcat(s, "b");
if (crc32("hVuWffHUoBqg",12) == 3680547699) strcat(s, "l");
if (crc32("VlUqgqPUkYFXr",13) == 1557540285) strcat(s, "y");
    return s;
}

char *unbarbarously_adverbs() {
    char *s = calloc(14);
    if (crc32("EQpnr",5) == 872707722) strcat(s, "u");
if (crc32("TFdrDJkZSxCBI",13) == 222264011) strcat(s, "x");
if (crc32("MrOGI",5) == 1820977657) strcat(s, "n");
if (crc32("LzxkyYQzQtyVPLC",15) == 2440398673) strcat(s, "b");
if (crc32("xrUhFFXNDvuBW",13) == 224722027) strcat(s, "a");
if (crc32("YGxHi",5) == 1082689737) strcat(s, "X");
if (crc32("ucToa",5) == 1843814533) strcat(s, "r");
if (crc32("DztedCttDLboJ",13) == 2916244868) strcat(s, "B");
if (crc32("HMngGE",6) == 3712320530) strcat(s, "b");
if (crc32("QOGUbSnXmEy",11) == 33954757) strcat(s, "m");
if (crc32("HfPcvfbB",8) == 1748442063) strcat(s, "a");
if (crc32("WJzAzchUQuvvI",13) == 1817493109) strcat(s, "r");
if (crc32("nNhEYhVrF",9) == 2151219648) strcat(s, "P");
if (crc32("iCHbqKueE",9) == 1201857813) strcat(s, "o");
if (crc32("ubcXegP",7) == 3118465324) strcat(s, "u");
if (crc32("qYTAZsRcdCB",11) == 3064467714) strcat(s, "s");
if (crc32("vWYUFt",6) == 746100771) strcat(s, "F");
if (crc32("AtmCrFbIW",9) == 3336393340) strcat(s, "l");
if (crc32("RVUwJT",6) == 1398194173) strcat(s, "x");
if (crc32("HGuuBBKa",8) == 521187347) strcat(s, "y");
    return s;
}

char *gauntly_adverbs() {
    char *s = calloc(8);
    if (crc32("GPtefOcDgmFYI",13) == 2309437837) strcat(s, "g");
if (crc32("FFqkDWExGeHXc",13) == 3360533848) strcat(s, "a");
if (crc32("lkdYjWpjWJPjEZ",14) == 1148531179) strcat(s, "h");
if (crc32("EXYwL",5) == 619835612) strcat(s, "u");
if (crc32("BmaDAtIeq",9) == 629582683) strcat(s, "n");
if (crc32("LzaVNKLOTVi",11) == 302705881) strcat(s, "t");
if (crc32("aReHJXe",7) == 10185779) strcat(s, "Y");
if (crc32("MJlFiibA",8) == 3363598511) strcat(s, "l");
if (crc32("WbqLhEmkfXjuo",13) == 3055719520) strcat(s, "s");
if (crc32("RNIoX",5) == 128212057) strcat(s, "y");
    return s;
}

char *dialectally_adverbs() {
    char *s = calloc(12);
    if (crc32("HsoIkBxDH",9) == 1862027685) strcat(s, "W");
if (crc32("hLMVMkgXz",9) == 1139106242) strcat(s, "d");
if (crc32("QWOsSHtfNm",10) == 3968543346) strcat(s, "I");
if (crc32("HTthUHi",7) == 3924740040) strcat(s, "i");
if (crc32("FrHZQjaGiszL",12) == 1743800830) strcat(s, "I");
if (crc32("gxIyoXzeemSap",13) == 911491052) strcat(s, "a");
if (crc32("pbzQISnyVAu",11) == 1983268989) strcat(s, "l");
if (crc32("HVyWKSiLwWuJgo",14) == 699472342) strcat(s, "u");
if (crc32("wuLbzPSRZIYRkyT",15) == 332734676) strcat(s, "e");
if (crc32("pYQgbGlF",8) == 2766435659) strcat(s, "p");
if (crc32("PNQsKfkJVxik",12) == 1783801169) strcat(s, "c");
if (crc32("bqSFYNkDkwpV",12) == 4261976628) strcat(s, "t");
if (crc32("umZQqn",6) == 3731825028) strcat(s, "a");
if (crc32("qpvEMRycBbr",11) == 52862556) strcat(s, "D");
if (crc32("jzrHQBxNq",9) == 2908534731) strcat(s, "l");
if (crc32("RiQgXsTfgwqz",12) == 1162682473) strcat(s, "l");
if (crc32("uAtvDFNjJ",9) == 474298530) strcat(s, "y");
    return s;
}

char *remuneratively_adverbs() {
    char *s = calloc(15);
    if (crc32("eAMqj",5) == 1465511450) strcat(s, "r");
if (crc32("xKrBNz",6) == 361925703) strcat(s, "e");
if (crc32("XHKZdvdnQZo",11) == 1498997258) strcat(s, "m");
if (crc32("kTKiauAwzrX",11) == 4284792099) strcat(s, "u");
if (crc32("KCiZTbVgcZcgD",13) == 341313710) strcat(s, "n");
if (crc32("fMKhpJF",7) == 3601146589) strcat(s, "e");
if (crc32("ZLFIRfeLNKO",11) == 2337739085) strcat(s, "r");
if (crc32("vxOLnuQrC",9) == 3779405069) strcat(s, "L");
if (crc32("APHmqsOhc",9) == 103352843) strcat(s, "a");
if (crc32("SIfQjtbp",8) == 3026959912) strcat(s, "t");
if (crc32("tkzhRxXa",8) == 2496672925) strcat(s, "f");
if (crc32("eqIsmWGI",8) == 831806607) strcat(s, "i");
if (crc32("YHwGJnvSjZ",10) == 1480262621) strcat(s, "v");
if (crc32("ZAnrcJ",6) == 756111151) strcat(s, "e");
if (crc32("XQOERPfxMeQtL",13) == 3722559134) strcat(s, "o");
if (crc32("QxpXFbQs",8) == 3219681162) strcat(s, "l");
if (crc32("KgjLxxZVKJ",10) == 411335700) strcat(s, "y");
    return s;
}

char *Hebraically_adverbs() {
    char *s = calloc(12);
    if (crc32("TuGtNSHcymo",11) == 2821301718) strcat(s, "H");
if (crc32("kbZrpi",6) == 3633809893) strcat(s, "e");
if (crc32("GgoVZFtO",8) == 990715733) strcat(s, "b");
if (crc32("XFlTSLRCMIC",11) == 1184685398) strcat(s, "r");
if (crc32("geVmidMBlvok",12) == 3826380648) strcat(s, "g");
if (crc32("tjAjghM",7) == 4127023299) strcat(s, "a");
if (crc32("HjqgvnEaWzKjq",13) == 2051601575) strcat(s, "a");
if (crc32("ZaCuIQJZnGyIS",13) == 3732361047) strcat(s, "i");
if (crc32("QPGZqTFoTuAOenA",15) == 1680926469) strcat(s, "c");
if (crc32("awYyYwhfVRFHv",13) == 3095067780) strcat(s, "a");
if (crc32("odEXzycmGMPBtYS",15) == 127339560) strcat(s, "l");
if (crc32("CySJuaH",7) == 425973806) strcat(s, "l");
if (crc32("ZBlhJdzVtFV",11) == 2336831946) strcat(s, "y");
    return s;
}

char *friskily_adverbs() {
    char *s = calloc(9);
    if (crc32("ozDEbUvHmLX",11) == 284900812) strcat(s, "Q");
if (crc32("InkJT",5) == 1781160886) strcat(s, "f");
if (crc32("wUjbzKZq",8) == 1077964676) strcat(s, "K");
if (crc32("LtdBPmHmJZiVeu",14) == 2876367916) strcat(s, "r");
if (crc32("vmBZRpQOCkl",11) == 2755040730) strcat(s, "i");
if (crc32("wjTnyNLMrUqs",12) == 1426510956) strcat(s, "h");
if (crc32("rRoGrYldNsPMcNT",15) == 1596920000) strcat(s, "s");
if (crc32("FlqxrIGu",8) == 3996173777) strcat(s, "k");
if (crc32("fpwCDmwqUfSpV",13) == 737024828) strcat(s, "i");
if (crc32("oXSYz",5) == 1722474010) strcat(s, "l");
if (crc32("DAmnizCyhnt",11) == 1124262127) strcat(s, "y");
    return s;
}

char *quasieloquently_adverbs() {
    char *s = calloc(16);
    if (crc32("xcrKXcmFblpPfJ",14) == 2657596302) strcat(s, "q");
if (crc32("MprFvEeCyhoDTxE",15) == 2139982708) strcat(s, "u");
if (crc32("RJVdqDCsGnGIHa",14) == 216177097) strcat(s, "u");
if (crc32("APIbmRn",7) == 1812334866) strcat(s, "M");
if (crc32("WjnxhJnHrEStFuk",15) == 68674559) strcat(s, "a");
if (crc32("DottCwOpWCCVEZL",15) == 834411684) strcat(s, "s");
if (crc32("cvphJZ",6) == 2841033898) strcat(s, "Z");
if (crc32("ZixEbYPvisn",11) == 1586697231) strcat(s, "i");
if (crc32("uvyBZq",6) == 601923609) strcat(s, "F");
if (crc32("ggegTsYF",8) == 1680375120) strcat(s, "e");
if (crc32("BQZuwjPshjOA",12) == 4244166627) strcat(s, "l");
if (crc32("xHcHeaRjvMRO",12) == 408265104) strcat(s, "Y");
if (crc32("nVkiNdDL",8) == 3376255104) strcat(s, "o");
if (crc32("yldutBUOBiC",11) == 1752994333) strcat(s, "L");
if (crc32("bzmtYzrfSVuCs",13) == 1556650609) strcat(s, "q");
if (crc32("yCLHOk",6) == 803315665) strcat(s, "U");
if (crc32("QoJzTBGkcF",10) == 3770762105) strcat(s, "u");
if (crc32("cZbhxMjYdIxAWVu",15) == 2231727289) strcat(s, "e");
if (crc32("bYFYrZQonQLxJ",13) == 2157634250) strcat(s, "n");
if (crc32("VZYjQgUyeC",10) == 1765801311) strcat(s, "t");
if (crc32("GMncpZ",6) == 907359194) strcat(s, "l");
if (crc32("JMDFBJgHo",9) == 3096442301) strcat(s, "d");
if (crc32("AiFSTQTHo",9) == 2109717508) strcat(s, "y");
    return s;
}

char *happily_adverbs() {
    char *s = calloc(8);
    if (crc32("vHdBgPOds",9) == 2471059693) strcat(s, "B");
if (crc32("YUHYpSDdw",9) == 3780268963) strcat(s, "h");
if (crc32("VPSxxiBO",8) == 1537676434) strcat(s, "a");
if (crc32("gWCCKxatLGQ",11) == 2662273945) strcat(s, "D");
if (crc32("OFSeYwJ",7) == 276812597) strcat(s, "p");
if (crc32("scprlZ",6) == 2982930609) strcat(s, "h");
if (crc32("sSNtP",5) == 4225007746) strcat(s, "p");
if (crc32("gYQvhAPB",8) == 362959201) strcat(s, "i");
if (crc32("LAYOpxz",7) == 795934695) strcat(s, "l");
if (crc32("QXxdnwm",7) == 2495703107) strcat(s, "y");
    return s;
}

char *puzzlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("YKtDhCEsJewcm",13) == 4039782848) strcat(s, "p");
if (crc32("ggqozxrbCf",10) == 1665932363) strcat(s, "u");
if (crc32("NKcZeD",6) == 1037088814) strcat(s, "y");
if (crc32("vMVCwzJYPoZD",12) == 843407338) strcat(s, "z");
if (crc32("EwVFOhgoXROvY",13) == 113480902) strcat(s, "m");
if (crc32("yFPLNHjK",8) == 456474733) strcat(s, "z");
if (crc32("ypAhMUQRYnkt",12) == 3381565253) strcat(s, "l");
if (crc32("TdBUoynUt",9) == 1863125612) strcat(s, "h");
if (crc32("tegqMweo",8) == 3098724546) strcat(s, "i");
if (crc32("qfbBpaZRIMc",11) == 1136627496) strcat(s, "n");
if (crc32("pDCVXQCATYnp",12) == 780931133) strcat(s, "g");
if (crc32("ZSBRUsgZ",8) == 3892932035) strcat(s, "u");
if (crc32("dcTphjhv",8) == 1249913282) strcat(s, "l");
if (crc32("cknGkbhrHyHPG",13) == 187598577) strcat(s, "B");
if (crc32("vCdSHbRzG",9) == 2629692097) strcat(s, "y");
    return s;
}

char *quasimaliciously_adverbs() {
    char *s = calloc(17);
    if (crc32("zOuYyIYxIfCF",12) == 1351347012) strcat(s, "q");
if (crc32("MCCuWMKQAMy",11) == 336144802) strcat(s, "u");
if (crc32("GkoLQEHE",8) == 2426164155) strcat(s, "a");
if (crc32("NasghQntOb",10) == 4188493524) strcat(s, "s");
if (crc32("JUdYqDphYkOl",12) == 852609392) strcat(s, "K");
if (crc32("wJWfYAKCL",9) == 1007926871) strcat(s, "i");
if (crc32("nHKtuFzdFZgft",13) == 1564795252) strcat(s, "d");
if (crc32("jykyvRIRpXl",11) == 638019395) strcat(s, "m");
if (crc32("zFkzmdpaSOVR",12) == 2537743489) strcat(s, "a");
if (crc32("GLsfGEo",7) == 3786616978) strcat(s, "l");
if (crc32("nOwFHgidWqaizR",14) == 638391333) strcat(s, "i");
if (crc32("vDMKjDqMgvsMR",13) == 864438127) strcat(s, "c");
if (crc32("zeRmOswgQkravDp",15) == 75673413) strcat(s, "i");
if (crc32("aErMLEe",7) == 3422710412) strcat(s, "o");
if (crc32("czlicGpnE",9) == 1176552744) strcat(s, "J");
if (crc32("didJMWatUs",10) == 2563484897) strcat(s, "u");
if (crc32("hqBSfkpNVhrk",12) == 2812856332) strcat(s, "s");
if (crc32("LopdCDolTqlfee",14) == 3587516526) strcat(s, "n");
if (crc32("qTzbnoOPupPwr",13) == 1436002110) strcat(s, "l");
if (crc32("PfgSmd",6) == 4189701185) strcat(s, "y");
    return s;
}

char *frantically_adverbs() {
    char *s = calloc(12);
    if (crc32("ImWZWdhzYnuBEC",14) == 4103059198) strcat(s, "f");
if (crc32("mlgEZoWuPIBdHq",14) == 2873665465) strcat(s, "N");
if (crc32("AyOUbOEHmyDi",12) == 662965359) strcat(s, "r");
if (crc32("cfwdpZgi",8) == 3178480252) strcat(s, "a");
if (crc32("OsteyVB",7) == 2367712526) strcat(s, "n");
if (crc32("XhTEUsSaEAtxy",13) == 665089342) strcat(s, "t");
if (crc32("rCpCglupmoYNI",13) == 783605992) strcat(s, "E");
if (crc32("WmcPcbkTp",9) == 2296982604) strcat(s, "i");
if (crc32("ENKlQTIaAqZ",11) == 840217823) strcat(s, "N");
if (crc32("CxvAbZJMIgF",11) == 2809424541) strcat(s, "c");
if (crc32("rjKXjqhgO",9) == 99380956) strcat(s, "h");
if (crc32("CUStUmKVMNWaKr",14) == 3715580035) strcat(s, "a");
if (crc32("aeuuuZC",7) == 2029794968) strcat(s, "l");
if (crc32("ZzbpC",5) == 1002051101) strcat(s, "l");
if (crc32("JQSdZBCeq",9) == 2285815269) strcat(s, "O");
if (crc32("sEIfnrLXZyy",11) == 2830630060) strcat(s, "y");
    return s;
}

char *parallelly_adverbs() {
    char *s = calloc(11);
    if (crc32("hYEdVwZwJO",10) == 1169547324) strcat(s, "a");
if (crc32("pWfylQJjZC",10) == 145328020) strcat(s, "p");
if (crc32("TlGUR",5) == 1295897633) strcat(s, "a");
if (crc32("yKuZgbm",7) == 4116863228) strcat(s, "w");
if (crc32("XXYOWfVRvUNzZAO",15) == 2346633360) strcat(s, "r");
if (crc32("IJUVKibDKN",10) == 45278196) strcat(s, "a");
if (crc32("LyHikmagxAO",11) == 1535429337) strcat(s, "p");
if (crc32("MTHotGs",7) == 27610163) strcat(s, "l");
if (crc32("ZlPTUXZIKe",10) == 3212901668) strcat(s, "Z");
if (crc32("CqMTD",5) == 3721793847) strcat(s, "l");
if (crc32("fkrbMjgU",8) == 3081985818) strcat(s, "K");
if (crc32("XSwdBqbYCYbhJW",14) == 215966219) strcat(s, "e");
if (crc32("HlTrvKMRXYwnLx",14) == 1812897387) strcat(s, "l");
if (crc32("JWwJZ",5) == 1378738526) strcat(s, "l");
if (crc32("gPomzijBCYLzuz",14) == 3471018754) strcat(s, "t");
if (crc32("DgERRwuHVfIyw",13) == 1977049039) strcat(s, "y");
    return s;
}

char *genealogically_adverbs() {
    char *s = calloc(15);
    if (crc32("gIxfNMLxzfMAJk",14) == 3581446064) strcat(s, "T");
if (crc32("QnrytjmoHJMjh",13) == 1907176197) strcat(s, "g");
if (crc32("hLOZVBRsxac",11) == 2262279688) strcat(s, "M");
if (crc32("ExCKBm",6) == 601306338) strcat(s, "e");
if (crc32("DQHrgKoChKBjHmO",15) == 3657822168) strcat(s, "n");
if (crc32("CpjbSPCgD",9) == 764496139) strcat(s, "b");
if (crc32("OVUXrq",6) == 1558772023) strcat(s, "e");
if (crc32("nQVckyj",7) == 149897002) strcat(s, "a");
if (crc32("ERqFMRSLHU",10) == 4061146536) strcat(s, "l");
if (crc32("eKxeRdt",7) == 3722841076) strcat(s, "o");
if (crc32("HSkaEYKWUn",10) == 1083485861) strcat(s, "f");
if (crc32("vdQkUKlQSSi",11) == 3182947640) strcat(s, "g");
if (crc32("qOTSjgcWbNupBOk",15) == 3945482739) strcat(s, "i");
if (crc32("TWbsSA",6) == 2979430652) strcat(s, "k");
if (crc32("UntoQunM",8) == 4196664128) strcat(s, "c");
if (crc32("HtAIXHmvyNkE",12) == 3747311099) strcat(s, "a");
if (crc32("dNtvfhn",7) == 1817698258) strcat(s, "u");
if (crc32("SCWxOgGhrSPxm",13) == 338625802) strcat(s, "l");
if (crc32("TQQnQHureRbXK",13) == 2558888724) strcat(s, "l");
if (crc32("HvrJnxjJdRHLa",13) == 1930177954) strcat(s, "y");
    return s;
}

char *seminervously_adverbs() {
    char *s = calloc(14);
    if (crc32("RQvhGImm",8) == 425903429) strcat(s, "s");
if (crc32("srgbfBwj",8) == 1782777297) strcat(s, "e");
if (crc32("rnNfgnyWGNGqDj",14) == 578241713) strcat(s, "m");
if (crc32("PQkwNZXxT",9) == 947753747) strcat(s, "i");
if (crc32("LAbJKAsqfM",10) == 3408880290) strcat(s, "n");
if (crc32("kfMieUHjjbk",11) == 1439468173) strcat(s, "e");
if (crc32("DtGCQLXzxjj",11) == 525576029) strcat(s, "C");
if (crc32("IAJuEcjPtUFy",12) == 3120176991) strcat(s, "r");
if (crc32("SPMbUFBcBTPobl",14) == 3946087925) strcat(s, "r");
if (crc32("bGvMlEqH",8) == 1121634297) strcat(s, "v");
if (crc32("TVCvMTrcje",10) == 766455178) strcat(s, "o");
if (crc32("bbdDG",5) == 492806077) strcat(s, "M");
if (crc32("TGLbtX",6) == 2021454564) strcat(s, "u");
if (crc32("kaybCNVemDuEsCV",15) == 168983001) strcat(s, "j");
if (crc32("AXkwLfyyiw",10) == 2794943884) strcat(s, "s");
if (crc32("FICbopgXWofB",12) == 1216571611) strcat(s, "l");
if (crc32("eEXlIDefNeLq",12) == 4201328408) strcat(s, "y");
    return s;
}

char *nontransitively_adverbs() {
    char *s = calloc(16);
    if (crc32("IqcdtrRbqDi",11) == 4036658825) strcat(s, "N");
if (crc32("qbNVrDbaT",9) == 2435526064) strcat(s, "n");
if (crc32("aNZegeGjWhd",11) == 598845783) strcat(s, "o");
if (crc32("xIKTElHKmQOaU",13) == 148308165) strcat(s, "n");
if (crc32("INeshBDBT",9) == 252091420) strcat(s, "z");
if (crc32("eglcckoQNIb",11) == 3585160255) strcat(s, "t");
if (crc32("kTlRXDd",7) == 39944365) strcat(s, "r");
if (crc32("ZtcfRRNqfqTWv",13) == 1930934457) strcat(s, "a");
if (crc32("gEjQIkjkeNH",11) == 2386798361) strcat(s, "T");
if (crc32("PdqpwRwDbzo",11) == 4097755347) strcat(s, "n");
if (crc32("VZGRP",5) == 1139988439) strcat(s, "s");
if (crc32("aBVYcpYrG",9) == 705312422) strcat(s, "e");
if (crc32("nxdiyLIyk",9) == 600398786) strcat(s, "i");
if (crc32("hENMRUGogEJmwz",14) == 813375536) strcat(s, "t");
if (crc32("oKOlQaiy",8) == 2862400390) strcat(s, "S");
if (crc32("JfJZQxStIsaa",12) == 1103037136) strcat(s, "i");
if (crc32("MEHPnlsiPMnZ",12) == 3730166343) strcat(s, "v");
if (crc32("ENOpW",5) == 2203249452) strcat(s, "A");
if (crc32("mPENsin",7) == 3638118435) strcat(s, "e");
if (crc32("acJZwG",6) == 1428533463) strcat(s, "q");
if (crc32("kezlcX",6) == 3960223001) strcat(s, "l");
if (crc32("EyKWdakfTFUBVcm",15) == 3023874165) strcat(s, "y");
    return s;
}

char *luxuriantly_adverbs() {
    char *s = calloc(12);
    if (crc32("JmlZMhxfekgEtGE",15) == 1459994739) strcat(s, "l");
if (crc32("nzdjNUZIWxm",11) == 2838820043) strcat(s, "u");
if (crc32("TmWtijdPOMQWQSq",15) == 2341941236) strcat(s, "x");
if (crc32("gCjCDJLOKsZPb",13) == 2499556973) strcat(s, "u");
if (crc32("dxuyNgtFLN",10) == 4124250376) strcat(s, "W");
if (crc32("QpqHDBkelaUEZP",14) == 1271696416) strcat(s, "r");
if (crc32("pnyIlzk",7) == 525987742) strcat(s, "i");
if (crc32("FrNLwtrXwnZF",12) == 2046924358) strcat(s, "Y");
if (crc32("DOuMZCzaa",9) == 2087433933) strcat(s, "a");
if (crc32("ptfGrXLIdn",10) == 1681851914) strcat(s, "n");
if (crc32("xswSwVbHdr",10) == 1425373493) strcat(s, "J");
if (crc32("WBBLBWYRmbyOvKw",15) == 2202145945) strcat(s, "t");
if (crc32("GhOmje",6) == 728736025) strcat(s, "l");
if (crc32("RkSqMVNyaLzHgjj",15) == 4067120985) strcat(s, "y");
    return s;
}

char *symphonically_adverbs() {
    char *s = calloc(14);
    if (crc32("XgraBRsiU",9) == 4148964355) strcat(s, "s");
if (crc32("QHIeVyP",7) == 1601784124) strcat(s, "y");
if (crc32("fXHNgBKBoP",10) == 3248458066) strcat(s, "r");
if (crc32("GIRHxnypx",9) == 99822368) strcat(s, "m");
if (crc32("hgVDdqpGu",9) == 1289482655) strcat(s, "c");
if (crc32("upJjULZalmb",11) == 3527447550) strcat(s, "p");
if (crc32("YhAHCDTfpsuXR",13) == 1392807970) strcat(s, "h");
if (crc32("YRVAzNyEt",9) == 1101984687) strcat(s, "u");
if (crc32("igrMFN",6) == 991471356) strcat(s, "o");
if (crc32("cFGUAykARmahmr",14) == 652578711) strcat(s, "A");
if (crc32("kLPUQdWdcXrnJxX",15) == 1402631432) strcat(s, "n");
if (crc32("EPLxg",5) == 2631617953) strcat(s, "u");
if (crc32("rqJiQG",6) == 3408737478) strcat(s, "i");
if (crc32("fWaCrLkOZbFcIKi",15) == 2217375698) strcat(s, "a");
if (crc32("qNKhG",5) == 1074284241) strcat(s, "c");
if (crc32("tiGugrK",7) == 1644080521) strcat(s, "E");
if (crc32("GbvpSKntZvtsfXV",15) == 2102008272) strcat(s, "a");
if (crc32("vanQEAMoaqLq",12) == 222122685) strcat(s, "l");
if (crc32("KUTYMxCWfigSMn",14) == 4212627390) strcat(s, "l");
if (crc32("zBhzQa",6) == 128551836) strcat(s, "y");
    return s;
}

char *enliveningly_adverbs() {
    char *s = calloc(13);
    if (crc32("jEscoso",7) == 3762966297) strcat(s, "e");
if (crc32("UlZwERx",7) == 1682368703) strcat(s, "d");
if (crc32("aiYKuxNNkMBss",13) == 3510169616) strcat(s, "n");
if (crc32("okRJCELQYQRJjEU",15) == 2641440233) strcat(s, "K");
if (crc32("LvXwflnM",8) == 2467609088) strcat(s, "l");
if (crc32("TSEeOPksd",9) == 931467056) strcat(s, "T");
if (crc32("jCAym",5) == 547837839) strcat(s, "i");
if (crc32("EJUUrKHOTSZ",11) == 3089854614) strcat(s, "d");
if (crc32("alAHVujNQPR",11) == 3818191840) strcat(s, "v");
if (crc32("aAbYJpPXUJWml",13) == 3883188183) strcat(s, "e");
if (crc32("qYphWyduovXE",12) == 361927249) strcat(s, "n");
if (crc32("urdck",5) == 3980923901) strcat(s, "i");
if (crc32("DVQMqfQANtdOZ",13) == 1939329272) strcat(s, "n");
if (crc32("XGfGGQq",7) == 2127369961) strcat(s, "g");
if (crc32("OhGXLMcQ",8) == 3435402084) strcat(s, "l");
if (crc32("sNLBLIhavRiflX",14) == 1523516977) strcat(s, "y");
    return s;
}

char *overfluently_adverbs() {
    char *s = calloc(13);
    if (crc32("NWIhQMrOnUdDJFl",15) == 979585052) strcat(s, "o");
if (crc32("pFChfAOSVHrTfW",14) == 2730084606) strcat(s, "v");
if (crc32("GjwXdRkpIWvUEIN",15) == 2255387856) strcat(s, "e");
if (crc32("JxviPlpIpF",10) == 2069586397) strcat(s, "h");
if (crc32("ucAlJGlYuBtrrLn",15) == 2002774497) strcat(s, "r");
if (crc32("IrgwfS",6) == 4095706064) strcat(s, "P");
if (crc32("kKNCAO",6) == 4207151536) strcat(s, "f");
if (crc32("PrhZTlfTNC",10) == 1063945253) strcat(s, "l");
if (crc32("jDNtQVsnU",9) == 4289539519) strcat(s, "p");
if (crc32("VJtoSJYGnAKvKau",15) == 56897198) strcat(s, "u");
if (crc32("cpDMJTPEwIo",11) == 732672056) strcat(s, "e");
if (crc32("yIyzTamOyV",10) == 2647831015) strcat(s, "n");
if (crc32("awGbHKdRM",9) == 3720047650) strcat(s, "t");
if (crc32("OBtxNDFI",8) == 3126957060) strcat(s, "t");
if (crc32("cfholUTTTxrUh",13) == 502032195) strcat(s, "B");
if (crc32("DhcuSDYa",8) == 806957364) strcat(s, "l");
if (crc32("GubUxWbMATINfCu",15) == 3460305693) strcat(s, "Z");
if (crc32("uErncX",6) == 3525412215) strcat(s, "y");
    return s;
}

char *nonpreferentially_adverbs() {
    char *s = calloc(18);
    if (crc32("yeWRKGwZoBYWU",13) == 841756099) strcat(s, "n");
if (crc32("nUqpWy",6) == 3584979312) strcat(s, "l");
if (crc32("ONNqVGsDB",9) == 3835690684) strcat(s, "o");
if (crc32("YCWlLdZlsFgB",12) == 1004346312) strcat(s, "n");
if (crc32("WDYcPlG",7) == 3188419394) strcat(s, "p");
if (crc32("GmdCyvpOTcK",11) == 1278595702) strcat(s, "r");
if (crc32("agiTMyiJYDslzOG",15) == 121194085) strcat(s, "e");
if (crc32("FowpruzjHc",10) == 1387921903) strcat(s, "s");
if (crc32("CvcayxA",7) == 3588297370) strcat(s, "f");
if (crc32("kVArhbls",8) == 1513427424) strcat(s, "e");
if (crc32("jFeHRM",6) == 1032845764) strcat(s, "r");
if (crc32("jcfaflaDYrjNJja",15) == 177131464) strcat(s, "e");
if (crc32("aUVPiIAjngq",11) == 3104313550) strcat(s, "n");
if (crc32("wUDpoqSCWHVU",12) == 1278361343) strcat(s, "t");
if (crc32("PQLKjiEMDTf",11) == 1125681366) strcat(s, "x");
if (crc32("RWJNPxjUCKpXRao",15) == 2380645522) strcat(s, "i");
if (crc32("CVVSktFd",8) == 1953654103) strcat(s, "a");
if (crc32("BEWUNJsm",8) == 3355846683) strcat(s, "l");
if (crc32("EzVyPpmRGveGG",13) == 868392838) strcat(s, "l");
if (crc32("sHmtJzGLGzHnkxK",15) == 506869943) strcat(s, "z");
if (crc32("KThuSdIontnE",12) == 1760243016) strcat(s, "y");
    return s;
}

char *unvaryingly_adverbs() {
    char *s = calloc(12);
    if (crc32("kYHWipsRjbPZWSf",15) == 3292097748) strcat(s, "u");
if (crc32("gAnqyllEPwcU",12) == 3965567380) strcat(s, "R");
if (crc32("SCtuqJw",7) == 3354002240) strcat(s, "n");
if (crc32("KrYNZbukHqtBftV",15) == 3908196099) strcat(s, "v");
if (crc32("grlAgQWjOYsNNEJ",15) == 2134573687) strcat(s, "a");
if (crc32("jPCgFxXtQve",11) == 1485708406) strcat(s, "r");
if (crc32("raXyPMu",7) == 845362132) strcat(s, "y");
if (crc32("BApknMYPt",9) == 3166922348) strcat(s, "i");
if (crc32("OvcLMtHbOta",11) == 388384951) strcat(s, "k");
if (crc32("tHqhibXBnpIjoq",14) == 925455972) strcat(s, "n");
if (crc32("ZKxGTE",6) == 818666771) strcat(s, "g");
if (crc32("lUtmHHFMVlTJrO",14) == 106550242) strcat(s, "Z");
if (crc32("LBTILfLXSj",10) == 1994604521) strcat(s, "l");
if (crc32("qRZhGio",7) == 115577593) strcat(s, "y");
    return s;
}

char *nonambitiously_adverbs() {
    char *s = calloc(15);
    if (crc32("DrXYUkTDR",9) == 853768482) strcat(s, "P");
if (crc32("FbHAyZaI",8) == 345724821) strcat(s, "n");
if (crc32("LunWWBNCPZa",11) == 2955572212) strcat(s, "o");
if (crc32("YBeWxJlnSOu",11) == 1948733518) strcat(s, "n");
if (crc32("aHTfzNW",7) == 1122736800) strcat(s, "a");
if (crc32("AFxnCBa",7) == 1047276588) strcat(s, "m");
if (crc32("POoldq",6) == 1676958932) strcat(s, "b");
if (crc32("HOJUPhLLIg",10) == 1503616044) strcat(s, "i");
if (crc32("uJGahzX",7) == 1061739755) strcat(s, "o");
if (crc32("rxHKJ",5) == 280375033) strcat(s, "t");
if (crc32("KpPmGtTHugEibs",14) == 2963424866) strcat(s, "i");
if (crc32("dWAwwjRHvdRaUpu",15) == 1647162752) strcat(s, "o");
if (crc32("denMtZy",7) == 2865697771) strcat(s, "t");
if (crc32("KpalEVCdMt",10) == 421683382) strcat(s, "u");
if (crc32("bZbXxExKAsE",11) == 1325842617) strcat(s, "s");
if (crc32("VxdfKrz",7) == 2582713466) strcat(s, "l");
if (crc32("lJzIOUkyVUW",11) == 2812917805) strcat(s, "y");
    return s;
}

char *synodically_adverbs() {
    char *s = calloc(12);
    if (crc32("ufzrOpt",7) == 1166892319) strcat(s, "g");
if (crc32("lgLwhlBAcNL",11) == 28582171) strcat(s, "s");
if (crc32("AploZHG",7) == 4203113267) strcat(s, "y");
if (crc32("PoNuAHMtap",10) == 3789631215) strcat(s, "n");
if (crc32("TsSQireQK",9) == 1730230834) strcat(s, "o");
if (crc32("lsLCVprXhPFO",12) == 1983023125) strcat(s, "s");
if (crc32("MQEBwAdKn",9) == 2599962869) strcat(s, "d");
if (crc32("IjfyLtwN",8) == 3065839201) strcat(s, "K");
if (crc32("QWQHFttboLxFYeG",15) == 1597814225) strcat(s, "i");
if (crc32("nZQMsdx",7) == 2463598348) strcat(s, "O");
if (crc32("LxpthOL",7) == 2859883570) strcat(s, "c");
if (crc32("vpWjuHVLi",9) == 3925627134) strcat(s, "a");
if (crc32("QGKAgcCNl",9) == 2027159028) strcat(s, "l");
if (crc32("elUYigJ",7) == 2868565672) strcat(s, "s");
if (crc32("eIIkZ",5) == 51422302) strcat(s, "l");
if (crc32("RDoVLQvPddsHU",13) == 2904372685) strcat(s, "y");
    return s;
}

char *chaffingly_adverbs() {
    char *s = calloc(11);
    if (crc32("reCShyt",7) == 3663035658) strcat(s, "Z");
if (crc32("vNhMkL",6) == 4106868735) strcat(s, "c");
if (crc32("dEMFqfTvAi",10) == 634612333) strcat(s, "h");
if (crc32("ohfddJcmWbZv",12) == 2849105160) strcat(s, "a");
if (crc32("zjexBwzAmbIdiCC",15) == 4270259972) strcat(s, "f");
if (crc32("CLtGNLWX",8) == 3327042208) strcat(s, "s");
if (crc32("uybwQZCSFX",10) == 2236760064) strcat(s, "f");
if (crc32("FkILCsoAbyaT",12) == 3409773524) strcat(s, "G");
if (crc32("CqMPcZW",7) == 3159750996) strcat(s, "i");
if (crc32("XdtMLTfURzr",11) == 2497134401) strcat(s, "n");
if (crc32("rFrqtfFaWSXp",12) == 1062590512) strcat(s, "g");
if (crc32("EVNXDyER",8) == 1045837654) strcat(s, "l");
if (crc32("CNYlD",5) == 2033077911) strcat(s, "y");
    return s;
}

char *morbifically_adverbs() {
    char *s = calloc(13);
    if (crc32("foVEcaIZ",8) == 2384446422) strcat(s, "m");
if (crc32("EMYtGmeKy",9) == 2981993331) strcat(s, "o");
if (crc32("wuaZKl",6) == 602895320) strcat(s, "r");
if (crc32("MtFlWOrd",8) == 815058051) strcat(s, "b");
if (crc32("kLhmEQxC",8) == 663375134) strcat(s, "i");
if (crc32("afsPlXA",7) == 688616907) strcat(s, "f");
if (crc32("HaXKbtfhOBkBS",13) == 913666195) strcat(s, "i");
if (crc32("nDybytpdxuJ",11) == 181157665) strcat(s, "c");
if (crc32("rDoHvsWuk",9) == 3854405804) strcat(s, "a");
if (crc32("eVcYeqQvU",9) == 2132813067) strcat(s, "l");
if (crc32("tYbjPvOYx",9) == 382575520) strcat(s, "H");
if (crc32("efMzinA",7) == 2198686715) strcat(s, "l");
if (crc32("bTFboLBnRuNa",12) == 527029533) strcat(s, "y");
    return s;
}

char *fatidically_adverbs() {
    char *s = calloc(12);
    if (crc32("mFvJbQUqNQqheg",14) == 2176627174) strcat(s, "f");
if (crc32("ozNoGAWupjTNV",13) == 2215595280) strcat(s, "a");
if (crc32("LBrOddlE",8) == 807621961) strcat(s, "y");
if (crc32("DVHZQgThCkxCRuT",15) == 3644978624) strcat(s, "t");
if (crc32("KvDpkieUc",9) == 2653954853) strcat(s, "i");
if (crc32("vroxynEk",8) == 1207605841) strcat(s, "d");
if (crc32("pGvxpHls",8) == 1240807445) strcat(s, "i");
if (crc32("VSVlwtm",7) == 3764923468) strcat(s, "o");
if (crc32("eKuhKBkNe",9) == 3613611574) strcat(s, "c");
if (crc32("rHXBIHOh",8) == 4001688549) strcat(s, "g");
if (crc32("AFHgIekTwSU",11) == 2827988298) strcat(s, "a");
if (crc32("JgQFfWMJu",9) == 959166142) strcat(s, "l");
if (crc32("jBhsYgW",7) == 2620160068) strcat(s, "l");
if (crc32("MkMECJPAcWIsgR",14) == 50797862) strcat(s, "R");
if (crc32("XGdHVRvVaTAGSy",14) == 1616222657) strcat(s, "y");
    return s;
}

char *halfindignantly_adverbs() {
    char *s = calloc(16);
    if (crc32("jMQmguUp",8) == 3487270085) strcat(s, "d");
if (crc32("raYPufeVJfgBKZ",14) == 3267979066) strcat(s, "h");
if (crc32("IaEDJdNcrFW",11) == 1821254995) strcat(s, "N");
if (crc32("KFpfxogNfs",10) == 3055806980) strcat(s, "a");
if (crc32("LjaPr",5) == 3793449084) strcat(s, "z");
if (crc32("fzDyJpYITTipceK",15) == 1838682382) strcat(s, "l");
if (crc32("SojTu",5) == 2771164891) strcat(s, "d");
if (crc32("eTXckmDl",8) == 1757787158) strcat(s, "f");
if (crc32("YKNYeL",6) == 3485120297) strcat(s, "x");
if (crc32("lRkhOfMej",9) == 789211645) strcat(s, "i");
if (crc32("pCtKE",5) == 4036100956) strcat(s, "n");
if (crc32("hRcEsuJUx",9) == 3530359898) strcat(s, "T");
if (crc32("jyrzZCtnpgSPb",13) == 2272774580) strcat(s, "d");
if (crc32("cvunfLtMQSMtD",13) == 2708969893) strcat(s, "d");
if (crc32("SncVRSdznpemVF",14) == 2936090050) strcat(s, "i");
if (crc32("MUEFUcpLqLuch",13) == 3450564604) strcat(s, "c");
if (crc32("YCrAGIIUAvqj",12) == 1811976439) strcat(s, "g");
if (crc32("dLYlAjIWc",9) == 1070422849) strcat(s, "n");
if (crc32("XEMZxbkt",8) == 4237729940) strcat(s, "J");
if (crc32("lBDvF",5) == 984932910) strcat(s, "a");
if (crc32("SUwfAZzpGHF",11) == 23222879) strcat(s, "S");
if (crc32("OeaXWEuIvx",10) == 322820524) strcat(s, "n");
if (crc32("XGXyGrxPsdvK",12) == 4123724448) strcat(s, "t");
if (crc32("XJgfLWrlnzgnNi",14) == 2851536211) strcat(s, "t");
if (crc32("EVsBYZV",7) == 1164713884) strcat(s, "R");
if (crc32("vPrNyI",6) == 509965282) strcat(s, "l");
if (crc32("lJpOjMzFyhf",11) == 2064101989) strcat(s, "y");
    return s;
}

char *measurelessly_adverbs() {
    char *s = calloc(14);
    if (crc32("opPWdqMYcKSuFvq",15) == 548573765) strcat(s, "m");
if (crc32("rjwnfPRmzvZUn",13) == 2217401955) strcat(s, "e");
if (crc32("ewvcrYdUdwTQpe",14) == 905442164) strcat(s, "s");
if (crc32("cJlqzMXoMH",10) == 629526802) strcat(s, "a");
if (crc32("lWwuPgZrqki",11) == 1729526291) strcat(s, "J");
if (crc32("IovOPOAuq",9) == 322167299) strcat(s, "s");
if (crc32("KjeeIvw",7) == 1011204042) strcat(s, "l");
if (crc32("EllkRkZte",9) == 1647923440) strcat(s, "u");
if (crc32("EacBCuWmJ",9) == 2148266795) strcat(s, "P");
if (crc32("RTfiLqekxNisy",13) == 4144610510) strcat(s, "r");
if (crc32("QLnVCcMaCh",10) == 3978107063) strcat(s, "l");
if (crc32("zGuYYQgv",8) == 4283631048) strcat(s, "e");
if (crc32("RGEQbQY",7) == 580729025) strcat(s, "l");
if (crc32("NRzBBNWqxVyYa",13) == 408885254) strcat(s, "x");
if (crc32("vbCyTz",6) == 869125932) strcat(s, "e");
if (crc32("qiRsQenjaZD",11) == 3494960903) strcat(s, "s");
if (crc32("XvGfmawVLoVM",12) == 1033531409) strcat(s, "b");
if (crc32("GFEnby",6) == 3837638662) strcat(s, "s");
if (crc32("MORVjkEFSEBBzwy",15) == 4001973512) strcat(s, "E");
if (crc32("AzbJpRsWMXog",12) == 2009928594) strcat(s, "l");
if (crc32("CwNoTOhFAcBRRp",14) == 950023774) strcat(s, "y");
    return s;
}

char *crammingly_adverbs() {
    char *s = calloc(11);
    if (crc32("EtuLNT",6) == 3315117855) strcat(s, "c");
if (crc32("jRDoQgHxsHk",11) == 209986807) strcat(s, "r");
if (crc32("WLRJXttfmdXLEa",14) == 2403824524) strcat(s, "a");
if (crc32("CTzGgmWFNtMBScI",15) == 1749476626) strcat(s, "m");
if (crc32("uzNrb",5) == 925066128) strcat(s, "m");
if (crc32("bkjqrs",6) == 3484510044) strcat(s, "i");
if (crc32("qiVZjqe",7) == 2618768103) strcat(s, "Y");
if (crc32("BKFqIeQLB",9) == 1967400584) strcat(s, "n");
if (crc32("ajEmEHYjPpOJeLP",15) == 1473135712) strcat(s, "b");
if (crc32("DVgZgCtJbzg",11) == 931897563) strcat(s, "g");
if (crc32("ixnfx",5) == 3552295255) strcat(s, "l");
if (crc32("cCDUAnMaffCZk",13) == 1355001703) strcat(s, "j");
if (crc32("ulBRkvYartCcmc",14) == 2546085315) strcat(s, "y");
    return s;
}

char *caperingly_adverbs() {
    char *s = calloc(11);
    if (crc32("RQXhBsNgRIkQTtO",15) == 2934998777) strcat(s, "c");
if (crc32("DaUqDauPlYZ",11) == 221526191) strcat(s, "r");
if (crc32("VRVvizNXZkru",12) == 3626737429) strcat(s, "a");
if (crc32("bUChxjE",7) == 4286703961) strcat(s, "p");
if (crc32("KfjKsUUmzlr",11) == 1894358208) strcat(s, "i");
if (crc32("YPNTsbq",7) == 2726140854) strcat(s, "e");
if (crc32("cBEzRZZCm",9) == 1003143438) strcat(s, "r");
if (crc32("eFJaHnRNZVWXgs",14) == 850599831) strcat(s, "I");
if (crc32("KZGcl",5) == 850460625) strcat(s, "i");
if (crc32("WYqGyOaSSQVL",12) == 1716011577) strcat(s, "I");
if (crc32("abvgAcBM",8) == 808992138) strcat(s, "n");
if (crc32("dqrcgyAvuW",10) == 1145453458) strcat(s, "g");
if (crc32("QqcKzzgce",9) == 3043734722) strcat(s, "g");
if (crc32("UCYHoEkKtPzgM",13) == 1983981153) strcat(s, "g");
if (crc32("mdMvZUq",7) == 2344263538) strcat(s, "l");
if (crc32("NwktheKNw",9) == 908123378) strcat(s, "y");
    return s;
}

char *underisively_adverbs() {
    char *s = calloc(13);
    if (crc32("ikPxS",5) == 3340717859) strcat(s, "u");
if (crc32("PxrnzRyyFxoC",12) == 1488613241) strcat(s, "U");
if (crc32("qNiSIpcJfKG",11) == 3100947926) strcat(s, "n");
if (crc32("phlqJXgQV",9) == 1658059095) strcat(s, "m");
if (crc32("uFfCZR",6) == 2487127672) strcat(s, "d");
if (crc32("oHzgiEeXHyvAS",13) == 2718439745) strcat(s, "e");
if (crc32("sqMjjbF",7) == 4183745349) strcat(s, "r");
if (crc32("ctsBpJOTgyFhF",13) == 1887783748) strcat(s, "i");
if (crc32("smqiao",6) == 1756920905) strcat(s, "s");
if (crc32("SgaKEmX",7) == 997238006) strcat(s, "S");
if (crc32("PAzFeCxS",8) == 3302102580) strcat(s, "i");
if (crc32("zbTcJvEClHf",11) == 718016465) strcat(s, "v");
if (crc32("tjfnCdbgQY",10) == 3561117226) strcat(s, "o");
if (crc32("UHdonZh",7) == 1091116329) strcat(s, "e");
if (crc32("qMOJe",5) == 661014055) strcat(s, "l");
if (crc32("iajlQubCBDGy",12) == 2914871388) strcat(s, "J");
if (crc32("ayQogFuqzNNXNX",14) == 4138866498) strcat(s, "y");
    return s;
}

char *caustically_adverbs() {
    char *s = calloc(12);
    if (crc32("jecgId",6) == 2973016207) strcat(s, "H");
if (crc32("FiLPImzpcXOB",12) == 1376892034) strcat(s, "c");
if (crc32("ksXhxsGmehFqyE",14) == 3270871592) strcat(s, "a");
if (crc32("DYYRI",5) == 2642557613) strcat(s, "d");
if (crc32("nxqSdthqClBVzhs",15) == 3993991976) strcat(s, "u");
if (crc32("aBDrhvr",7) == 3324318947) strcat(s, "M");
if (crc32("FQAjKX",6) == 2103808015) strcat(s, "s");
if (crc32("NhurXErdUndrt",13) == 1130272415) strcat(s, "l");
if (crc32("mWFlHqyt",8) == 4017867560) strcat(s, "t");
if (crc32("LOphZkae",8) == 1364412817) strcat(s, "N");
if (crc32("mCIeZhvMYexVWTQ",15) == 3576349380) strcat(s, "i");
if (crc32("lYGkwObGtk",10) == 3842308672) strcat(s, "c");
if (crc32("uluPv",5) == 3607622655) strcat(s, "a");
if (crc32("ouhRiXNZpU",10) == 3343937788) strcat(s, "l");
if (crc32("doGBbKqXBPN",11) == 4264254890) strcat(s, "P");
if (crc32("ajeypqWD",8) == 1075420241) strcat(s, "l");
if (crc32("FqFuvVezm",9) == 1735713631) strcat(s, "y");
    return s;
}

char *feignedly_adverbs() {
    char *s = calloc(10);
    if (crc32("OYLXFqX",7) == 466345655) strcat(s, "y");
if (crc32("zosUBeFYsttMc",13) == 292169335) strcat(s, "f");
if (crc32("dZTEj",5) == 1174174780) strcat(s, "e");
if (crc32("RjsTNJRJKGwF",12) == 1648803504) strcat(s, "i");
if (crc32("jzNKxvA",7) == 2442743288) strcat(s, "g");
if (crc32("vdPgNb",6) == 1272458762) strcat(s, "n");
if (crc32("oxsLI",5) == 1991291078) strcat(s, "e");
if (crc32("PCsfTNL",7) == 3983512983) strcat(s, "d");
if (crc32("ltuIlaLQ",8) == 2349379624) strcat(s, "l");
if (crc32("eWUDfYIdWj",10) == 1963217238) strcat(s, "y");
    return s;
}

char *sleeplessly_adverbs() {
    char *s = calloc(12);
    if (crc32("QFVmUYAqUoOYZl",14) == 4083033701) strcat(s, "s");
if (crc32("fakuHgDndHOH",12) == 2103063363) strcat(s, "l");
if (crc32("cSfron",6) == 2145542806) strcat(s, "B");
if (crc32("zHZNXZuBI",9) == 4172106908) strcat(s, "e");
if (crc32("rcJboVFAoqC",11) == 3362517148) strcat(s, "d");
if (crc32("ZaSaZU",6) == 1937622321) strcat(s, "e");
if (crc32("zKsJzTjAUO",10) == 557650080) strcat(s, "o");
if (crc32("lngDLRWBJpLFK",13) == 2021008109) strcat(s, "p");
if (crc32("LsSSnsq",7) == 1411590142) strcat(s, "l");
if (crc32("KJsGSKIEqXi",11) == 2281513022) strcat(s, "S");
if (crc32("AEYHpBTy",8) == 973841801) strcat(s, "e");
if (crc32("jbkXkbz",7) == 3025450579) strcat(s, "s");
if (crc32("knAacNoXxFxUXT",14) == 3282408940) strcat(s, "s");
if (crc32("jLpPFsnENsrLuEJ",15) == 1259445466) strcat(s, "s");
if (crc32("GbBRmsv",7) == 2159986209) strcat(s, "O");
if (crc32("nBtIPlzJRcKWV",13) == 2027782080) strcat(s, "l");
if (crc32("DAZKBKqpaUrvRZ",14) == 3130523254) strcat(s, "R");
if (crc32("bJLAIMVmo",9) == 849093780) strcat(s, "y");
    return s;
}

char *supereffectively_adverbs() {
    char *s = calloc(17);
    if (crc32("LulyDRu",7) == 1688248899) strcat(s, "v");
if (crc32("kErpW",5) == 156178641) strcat(s, "s");
if (crc32("GtSxuJuhX",9) == 3734625464) strcat(s, "u");
if (crc32("cJZkBrj",7) == 3334171753) strcat(s, "r");
if (crc32("dDSnfOb",7) == 1242640117) strcat(s, "p");
if (crc32("cgrFVbkzm",9) == 4029283961) strcat(s, "M");
if (crc32("WoRhUCt",7) == 3635852087) strcat(s, "e");
if (crc32("ywwdfjNtdiU",11) == 2557071695) strcat(s, "r");
if (crc32("GrtRNTnLnBPlGat",15) == 2010522767) strcat(s, "e");
if (crc32("DhGZynI",7) == 3909537541) strcat(s, "c");
if (crc32("lkGcQ",5) == 1370414864) strcat(s, "f");
if (crc32("uSnYzcjqqy",10) == 1832315345) strcat(s, "v");
if (crc32("KhPVt",5) == 3232112878) strcat(s, "f");
if (crc32("XXmBi",5) == 1993799762) strcat(s, "e");
if (crc32("eNmPfxtswGMyfh",14) == 274721290) strcat(s, "N");
if (crc32("CkJuqlFMGPo",11) == 1000449159) strcat(s, "c");
if (crc32("YpJtLkUd",8) == 2044807102) strcat(s, "t");
if (crc32("EirYFr",6) == 3221662459) strcat(s, "i");
if (crc32("KpBLtuiiQkv",11) == 623161825) strcat(s, "v");
if (crc32("hrJgLssS",8) == 3910089925) strcat(s, "e");
if (crc32("lvTsjTIzVU",10) == 2525456658) strcat(s, "W");
if (crc32("vSNdghtt",8) == 3100529200) strcat(s, "l");
if (crc32("YbwUPmnqET",10) == 25699774) strcat(s, "y");
    return s;
}

char *quasiprogressively_adverbs() {
    char *s = calloc(19);
    if (crc32("etZHKFVR",8) == 1897814483) strcat(s, "q");
if (crc32("tiBWm",5) == 968459843) strcat(s, "u");
if (crc32("jZhTubSfpp",10) == 770382412) strcat(s, "l");
if (crc32("VUZeLRdoI",9) == 2074568225) strcat(s, "a");
if (crc32("AfmDrbPGL",9) == 1675302171) strcat(s, "V");
if (crc32("CUWzxtKm",8) == 3435782018) strcat(s, "s");
if (crc32("iAjLtpqiPAQXi",13) == 1327200457) strcat(s, "i");
if (crc32("MAuAiILQ",8) == 1920988350) strcat(s, "p");
if (crc32("WMlIVqtltOSuwAk",15) == 3268889730) strcat(s, "q");
if (crc32("QNsfjXaukUZa",12) == 889779450) strcat(s, "r");
if (crc32("swbgXfm",7) == 1908633066) strcat(s, "o");
if (crc32("pBHSxtAwT",9) == 1243195176) strcat(s, "n");
if (crc32("ImOGaVnZ",8) == 908536781) strcat(s, "g");
if (crc32("JinWQdLor",9) == 475649801) strcat(s, "p");
if (crc32("rnPkZqLOzYNjfd",14) == 1022823185) strcat(s, "r");
if (crc32("UMenbxw",7) == 3082318078) strcat(s, "e");
if (crc32("TeOYFuVCGqcGw",13) == 1608913865) strcat(s, "R");
if (crc32("XKmabKm",7) == 1630287358) strcat(s, "s");
if (crc32("eGvVVssvq",9) == 1086548352) strcat(s, "s");
if (crc32("bRHoBH",6) == 3182940734) strcat(s, "z");
if (crc32("efdsJv",6) == 2928310396) strcat(s, "i");
if (crc32("qnoCp",5) == 1851725020) strcat(s, "h");
if (crc32("IxvnAvSrQ",9) == 311674026) strcat(s, "v");
if (crc32("qZCgL",5) == 2167018214) strcat(s, "e");
if (crc32("xBJEQUnZRMWK",12) == 262372736) strcat(s, "Z");
if (crc32("xigLMeJkB",9) == 2601547648) strcat(s, "l");
if (crc32("YmvvRmPNzKuCaI",14) == 1162281440) strcat(s, "y");
    return s;
}

char *oblongly_adverbs() {
    char *s = calloc(9);
    if (crc32("xjsUFdLBiy",10) == 383936994) strcat(s, "o");
if (crc32("XLtlwdCMwwcWb",13) == 3940766641) strcat(s, "N");
if (crc32("XTDwedE",7) == 149505684) strcat(s, "b");
if (crc32("dftpBXRAWmF",11) == 574728043) strcat(s, "l");
if (crc32("eHhwtLabiESm",12) == 915324275) strcat(s, "k");
if (crc32("hlMOAibFKLun",12) == 3245029929) strcat(s, "o");
if (crc32("tYQYxovqyGlxfnR",15) == 2341191158) strcat(s, "n");
if (crc32("uBiLTIlMMLAm",12) == 1232684710) strcat(s, "g");
if (crc32("PUkFrqDV",8) == 1128517830) strcat(s, "B");
if (crc32("kEGgCb",6) == 1884366992) strcat(s, "l");
if (crc32("JWeob",5) == 2391987815) strcat(s, "C");
if (crc32("tvQPNRHwwi",10) == 155656793) strcat(s, "y");
    return s;
}

char *unpatronizingly_adverbs() {
    char *s = calloc(16);
    if (crc32("MkbsLvOcKv",10) == 884160194) strcat(s, "u");
if (crc32("zEGUurIantJEtJ",14) == 580832398) strcat(s, "J");
if (crc32("LxdMnsllR",9) == 1062076341) strcat(s, "n");
if (crc32("jjuOFvkb",8) == 1094025792) strcat(s, "p");
if (crc32("pVlieYmKtkBnjo",14) == 1069385497) strcat(s, "a");
if (crc32("OZTpiy",6) == 2954307491) strcat(s, "t");
if (crc32("htqICMPDdS",10) == 664358645) strcat(s, "T");
if (crc32("nMEij",5) == 3864504658) strcat(s, "r");
if (crc32("dnTrb",5) == 2758360012) strcat(s, "o");
if (crc32("hLRrKWcNgPrm",12) == 2725864556) strcat(s, "P");
if (crc32("eDBxhiddKaCHf",13) == 3269505107) strcat(s, "n");
if (crc32("OvwtB",5) == 3505005918) strcat(s, "i");
if (crc32("VryYWPagHRGGbSl",15) == 3520489985) strcat(s, "z");
if (crc32("IneRvm",6) == 4070753674) strcat(s, "z");
if (crc32("mJYJGQWBUEUiK",13) == 4067850794) strcat(s, "i");
if (crc32("IFAoqMAME",9) == 4292969445) strcat(s, "n");
if (crc32("PRfnaKiXpeTu",12) == 2130697164) strcat(s, "A");
if (crc32("JukHbWOUmXhH",12) == 1714997745) strcat(s, "g");
if (crc32("VmWJj",5) == 1983903060) strcat(s, "l");
if (crc32("AEZOeDy",7) == 651223440) strcat(s, "o");
if (crc32("kLdtIHtAsaQW",12) == 1495427395) strcat(s, "y");
    return s;
}

char *pseudodramatically_adverbs() {
    char *s = calloc(19);
    if (crc32("OeIXeRUi",8) == 3025451847) strcat(s, "f");
if (crc32("QhgQsuaphqDHtH",14) == 4100470649) strcat(s, "p");
if (crc32("mxaWXgenzmb",11) == 971838255) strcat(s, "D");
if (crc32("goFQLe",6) == 222603365) strcat(s, "s");
if (crc32("fgSQuh",6) == 3784992427) strcat(s, "e");
if (crc32("PbjexAMfZOHAjQ",14) == 3343117951) strcat(s, "L");
if (crc32("FumqZsSTiNvD",12) == 2184054728) strcat(s, "u");
if (crc32("vTTdOBw",7) == 1668147030) strcat(s, "n");
if (crc32("hnXaxURGhbDFqBX",15) == 2245618546) strcat(s, "d");
if (crc32("FAoaBTYMbfSelvm",15) == 2445722014) strcat(s, "o");
if (crc32("xjWGk",5) == 2815675447) strcat(s, "o");
if (crc32("gGXIOBzXikx",11) == 1133502015) strcat(s, "d");
if (crc32("neOSbEelJQBNqkU",15) == 1828796248) strcat(s, "S");
if (crc32("DreMxFeI",8) == 2253311930) strcat(s, "r");
if (crc32("lMLHSUeozqRPyo",14) == 2643323928) strcat(s, "p");
if (crc32("Yflpv",5) == 989359555) strcat(s, "a");
if (crc32("hxKiEg",6) == 3373066162) strcat(s, "m");
if (crc32("DZXTqSSdVifRdrR",15) == 3008849297) strcat(s, "a");
if (crc32("rpIRgjMc",8) == 2137448006) strcat(s, "t");
if (crc32("QjpCooVQXsEH",12) == 4289428838) strcat(s, "r");
if (crc32("BltCrAuZpEWdqq",14) == 1183842485) strcat(s, "i");
if (crc32("yivfAzmxxZgeh",13) == 3654296822) strcat(s, "S");
if (crc32("YSGlFgBtXS",10) == 2464976934) strcat(s, "c");
if (crc32("HwjiBoZDCdu",11) == 179420763) strcat(s, "a");
if (crc32("ailGVOoyjTtxHC",14) == 2386819694) strcat(s, "G");
if (crc32("tExLzjKfGN",10) == 588972612) strcat(s, "l");
if (crc32("kTIZySTomTLr",12) == 3730943892) strcat(s, "D");
if (crc32("yHaDOEF",7) == 3737437704) strcat(s, "l");
if (crc32("FEOhMQxcR",9) == 1050537830) strcat(s, "y");
    return s;
}

char *nonrationalistically_adverbs() {
    char *s = calloc(21);
    if (crc32("UMdJtiRwOsG",11) == 2759055560) strcat(s, "n");
if (crc32("VLNCFcNzGTRxW",13) == 2314450174) strcat(s, "n");
if (crc32("uhZVjyu",7) == 3230409515) strcat(s, "o");
if (crc32("eskZakb",7) == 1327809180) strcat(s, "p");
if (crc32("XScsekuDxGIim",13) == 1168808958) strcat(s, "n");
if (crc32("TSTYjzWNCk",10) == 1215071546) strcat(s, "r");
if (crc32("tJcRNVjpJvzGGxs",15) == 766748977) strcat(s, "a");
if (crc32("EdrZaC",6) == 2982896204) strcat(s, "t");
if (crc32("aeUAkC",6) == 4173039115) strcat(s, "D");
if (crc32("mrlZAAibw",9) == 3703880196) strcat(s, "i");
if (crc32("vyBiawa",7) == 1228589614) strcat(s, "o");
if (crc32("CeWkDeUrFmoQJ",13) == 2213530464) strcat(s, "n");
if (crc32("vcTFFtIJkDWI",12) == 3362524506) strcat(s, "a");
if (crc32("cRQoUnW",7) == 3615690613) strcat(s, "m");
if (crc32("WZorQtDMLDXjh",13) == 3846250359) strcat(s, "l");
if (crc32("cJXnJRwav",9) == 4261923307) strcat(s, "i");
if (crc32("qmtDpk",6) == 64106153) strcat(s, "H");
if (crc32("CfpUJViOXBvpk",13) == 3452661471) strcat(s, "s");
if (crc32("ghLmDXmJVXJ",11) == 1507407930) strcat(s, "B");
if (crc32("EfbmPtfARKUYF",13) == 2722487957) strcat(s, "t");
if (crc32("rSdZPGN",7) == 1098707334) strcat(s, "P");
if (crc32("okSVQggo",8) == 294191512) strcat(s, "i");
if (crc32("SdsPHtkOmB",10) == 1167983423) strcat(s, "i");
if (crc32("EyLKwcuApwqoV",13) == 648773125) strcat(s, "c");
if (crc32("fiZFYQjoVcrcZ",13) == 1116218655) strcat(s, "U");
if (crc32("VuTKFKjbTIZPC",13) == 411077459) strcat(s, "a");
if (crc32("ypOaVKANJ",9) == 358605178) strcat(s, "l");
if (crc32("BHdgIYrn",8) == 4013769160) strcat(s, "w");
if (crc32("MCnDFOC",7) == 4012574673) strcat(s, "l");
if (crc32("irmQngkca",9) == 1696270390) strcat(s, "y");
    return s;
}

char *overdescriptively_adverbs() {
    char *s = calloc(18);
    if (crc32("MPyedEW",7) == 1505311234) strcat(s, "T");
if (crc32("ZObclqMK",8) == 137590199) strcat(s, "o");
if (crc32("tMKkSUcawrNb",12) == 361012474) strcat(s, "v");
if (crc32("uUGajRlUbcS",11) == 604845141) strcat(s, "e");
if (crc32("RZhQnttkSeuV",12) == 299341029) strcat(s, "n");
if (crc32("drXUjMHME",9) == 3265190748) strcat(s, "r");
if (crc32("TVKjQsB",7) == 2744790296) strcat(s, "s");
if (crc32("MDVWzsVQWIs",11) == 1068093092) strcat(s, "d");
if (crc32("rMrrHlGVvVYt",12) == 2340762134) strcat(s, "e");
if (crc32("bSJBeyGEXa",10) == 2184236695) strcat(s, "s");
if (crc32("yNrhwXHPi",9) == 2683109562) strcat(s, "F");
if (crc32("RbHbCa",6) == 3882094310) strcat(s, "c");
if (crc32("MaaJvVBHQZ",10) == 844019477) strcat(s, "r");
if (crc32("VXzAhrmGdk",10) == 1094390514) strcat(s, "i");
if (crc32("EgPHGFQEww",10) == 3439756073) strcat(s, "K");
if (crc32("MVYSnAKlqwjcbC",14) == 3718745982) strcat(s, "p");
if (crc32("cizJDgt",7) == 1162214138) strcat(s, "t");
if (crc32("EeixvQqqP",9) == 503782447) strcat(s, "i");
if (crc32("eOvVRpGOHi",10) == 906678453) strcat(s, "v");
if (crc32("OJFjAhuax",9) == 546848806) strcat(s, "t");
if (crc32("PvHNUOElHk",10) == 3192664663) strcat(s, "e");
if (crc32("DLZbiOwDrH",10) == 2724320943) strcat(s, "K");
if (crc32("dPwzehQbjaoVjM",14) == 3321435906) strcat(s, "l");
if (crc32("VWMLTokrHtn",11) == 2650555084) strcat(s, "C");
if (crc32("PoaioGLWZEUWtRR",15) == 496724135) strcat(s, "y");
    return s;
}

char *electively_adverbs() {
    char *s = calloc(11);
    if (crc32("AlQfYbuiYhD",11) == 2459684528) strcat(s, "S");
if (crc32("PWaQe",5) == 2139510552) strcat(s, "e");
if (crc32("wcdmAkm",7) == 1910790950) strcat(s, "u");
if (crc32("xgHbmrOkqBj",11) == 1271759449) strcat(s, "l");
if (crc32("AUslJF",6) == 677070541) strcat(s, "e");
if (crc32("cFZSsGDSY",9) == 741860729) strcat(s, "d");
if (crc32("JZSxmTdTXasJq",13) == 1045749939) strcat(s, "c");
if (crc32("uLlMkVORyDBKlFf",15) == 632950645) strcat(s, "H");
if (crc32("KcOeO",5) == 1170067382) strcat(s, "t");
if (crc32("JbwlW",5) == 683087444) strcat(s, "i");
if (crc32("fgeZaVPfWH",10) == 1326438037) strcat(s, "F");
if (crc32("aykEVcCXRoz",11) == 2915579023) strcat(s, "v");
if (crc32("CSmuSYTNpZGo",12) == 910183273) strcat(s, "e");
if (crc32("nHBLgca",7) == 1877096548) strcat(s, "l");
if (crc32("zVAIzRlyBMNY",12) == 299261176) strcat(s, "y");
    return s;
}

char *vocationally_adverbs() {
    char *s = calloc(13);
    if (crc32("zbQRpCN",7) == 2250903899) strcat(s, "R");
if (crc32("iLXZpCMIMYHeE",13) == 4091094326) strcat(s, "v");
if (crc32("wvFTSkZtZvA",11) == 3336188659) strcat(s, "Q");
if (crc32("DMjrnPMKrMmnrK",14) == 3477562883) strcat(s, "o");
if (crc32("FVCUdEtzTwAbI",13) == 881880726) strcat(s, "c");
if (crc32("wxwPuqCeJWFEbyV",15) == 1015145558) strcat(s, "c");
if (crc32("ILaCBrnIBlv",11) == 4166950476) strcat(s, "a");
if (crc32("WSVwXidc",8) == 3261527319) strcat(s, "i");
if (crc32("REGHhgLHskvzEcY",15) == 1042294461) strcat(s, "t");
if (crc32("rFrsSapGD",9) == 3407609610) strcat(s, "e");
if (crc32("JJVxdBxuUnBg",12) == 2489492883) strcat(s, "i");
if (crc32("fpist",5) == 2937305811) strcat(s, "o");
if (crc32("eiAnSivVhWs",11) == 3028195525) strcat(s, "n");
if (crc32("ogCOHbCmAUIiXmO",15) == 2260762624) strcat(s, "a");
if (crc32("xKMCD",5) == 1791198251) strcat(s, "Z");
if (crc32("HjXsZ",5) == 389619237) strcat(s, "l");
if (crc32("GpwEElHLg",9) == 47195260) strcat(s, "E");
if (crc32("dQJZYopysQc",11) == 3550497659) strcat(s, "l");
if (crc32("LNSKWJTYxWPSC",13) == 2850391895) strcat(s, "y");
    return s;
}

char *jollily_adverbs() {
    char *s = calloc(8);
    if (crc32("HEzwfsVxNo",10) == 2299595547) strcat(s, "j");
if (crc32("ZvTsfahbaJy",11) == 2119773886) strcat(s, "o");
if (crc32("oPWRpUBKoeyoTNF",15) == 1340839479) strcat(s, "l");
if (crc32("KvPQldIKqpxevif",15) == 1070904983) strcat(s, "l");
if (crc32("HmRPpQmj",8) == 423702710) strcat(s, "E");
if (crc32("LlIeLTDXcacQ",12) == 1729210090) strcat(s, "i");
if (crc32("GMuHkdoFAGKUaL",14) == 3534569404) strcat(s, "l");
if (crc32("VIizHYzzTVY",11) == 706051871) strcat(s, "y");
    return s;
}

char *rathely_adverbs() {
    char *s = calloc(8);
    if (crc32("eWXfEyRCkURq",12) == 1885084531) strcat(s, "r");
if (crc32("JFssGs",6) == 2546245859) strcat(s, "N");
if (crc32("TduZzUlzFao",11) == 2631518492) strcat(s, "a");
if (crc32("pEcMlJBinCdb",12) == 2109515903) strcat(s, "D");
if (crc32("CjkFHDisncU",11) == 3392249015) strcat(s, "t");
if (crc32("ZDHNNFjTbfvDi",13) == 2009916596) strcat(s, "d");
if (crc32("AfKPZBvujiofLNx",15) == 2635238948) strcat(s, "h");
if (crc32("gIvRlPQnkxkSG",13) == 1604379701) strcat(s, "e");
if (crc32("brQQrIvk",8) == 79291221) strcat(s, "c");
if (crc32("IzUIQxmBGyrrfMF",15) == 163628538) strcat(s, "l");
if (crc32("PJCCCblkOTcnsIR",15) == 145739785) strcat(s, "e");
if (crc32("WbqwUXQewCK",11) == 1560458706) strcat(s, "y");
    return s;
}

char *stagily_adverbs() {
    char *s = calloc(8);
    if (crc32("yJrNnGtJnSS",11) == 1420022757) strcat(s, "p");
if (crc32("iIeJDZK",7) == 3634873682) strcat(s, "s");
if (crc32("wKJunFLZhUCuWYE",15) == 3973348077) strcat(s, "e");
if (crc32("cCoxAxSGOTXG",12) == 1749374494) strcat(s, "t");
if (crc32("DlDRg",5) == 912895774) strcat(s, "a");
if (crc32("EbVgfMoCSlZvwFW",15) == 305855886) strcat(s, "g");
if (crc32("tIDuUJQtU",9) == 816135095) strcat(s, "u");
if (crc32("PnMdQgszs",9) == 241889430) strcat(s, "i");
if (crc32("dMtmJbeVEj",10) == 3752980849) strcat(s, "l");
if (crc32("EvMCagdRR",9) == 3535733302) strcat(s, "X");
if (crc32("wKeMV",5) == 1208408252) strcat(s, "y");
    return s;
}

char *semijudicially_adverbs() {
    char *s = calloc(15);
    if (crc32("qoJNECOaRsr",11) == 2980840159) strcat(s, "H");
if (crc32("BKmwrWwCAdntYc",14) == 3795869301) strcat(s, "s");
if (crc32("NspyftdVB",9) == 2197540595) strcat(s, "W");
if (crc32("SQkphofojflVsPl",15) == 953004551) strcat(s, "e");
if (crc32("XmiSFV",6) == 1011002599) strcat(s, "m");
if (crc32("MuFdIQDSdvB",11) == 2113201310) strcat(s, "m");
if (crc32("vmsyR",5) == 1423174082) strcat(s, "i");
if (crc32("UAQGLXHyw",9) == 640513752) strcat(s, "V");
if (crc32("NesRfiuQLqt",11) == 2609442457) strcat(s, "j");
if (crc32("QdYFfokkcmkPGF",14) == 2686772802) strcat(s, "m");
if (crc32("EdqfPuVrNxdTJjv",15) == 483459297) strcat(s, "u");
if (crc32("snvhTzxCSV",10) == 1401382269) strcat(s, "d");
if (crc32("WpWrzzNchhXNGm",14) == 2937390390) strcat(s, "A");
if (crc32("KadXhpKxUgaGaH",14) == 4184518862) strcat(s, "i");
if (crc32("qqPydkZBnQZeQaF",15) == 110366388) strcat(s, "c");
if (crc32("tPndPTxQJfVDAw",14) == 2403927861) strcat(s, "P");
if (crc32("GyAkFgPTlTjihXF",15) == 2962217270) strcat(s, "i");
if (crc32("JDQAniPwWW",10) == 2168210072) strcat(s, "H");
if (crc32("lMVAkRRUDLahQ",13) == 1901222414) strcat(s, "a");
if (crc32("jTckAYk",7) == 3611378321) strcat(s, "l");
if (crc32("FEhVLfWCOnZY",12) == 2344442830) strcat(s, "l");
if (crc32("liZYhYNqJy",10) == 1982438382) strcat(s, "y");
    return s;
}

char *patrimonially_adverbs() {
    char *s = calloc(14);
    if (crc32("tNywnAgpwkk",11) == 339581639) strcat(s, "M");
if (crc32("GknVbEXPZd",10) == 2032100824) strcat(s, "p");
if (crc32("PnGIbWYv",8) == 496165149) strcat(s, "t");
if (crc32("uUMIoQdcBCZbumK",15) == 107582917) strcat(s, "a");
if (crc32("jhhSRnnLNh",10) == 3635958119) strcat(s, "T");
if (crc32("cikwS",5) == 2281736631) strcat(s, "t");
if (crc32("LheBDEWiwn",10) == 1057299289) strcat(s, "U");
if (crc32("gJrqslEMZcJr",12) == 3441367637) strcat(s, "r");
if (crc32("FafVr",5) == 2327613612) strcat(s, "m");
if (crc32("HimuATkZMkD",11) == 3551079227) strcat(s, "i");
if (crc32("ZYHcUJXy",8) == 4034261213) strcat(s, "m");
if (crc32("bTkkXiUuvd",10) == 1536918176) strcat(s, "f");
if (crc32("gkmAYbIpxuaSBW",14) == 2447873563) strcat(s, "o");
if (crc32("BuQQwMPr",8) == 4168830632) strcat(s, "v");
if (crc32("YCguwKDNYn",10) == 3018800603) strcat(s, "n");
if (crc32("EXZGracZaEd",11) == 4005986897) strcat(s, "i");
if (crc32("GQqLzwXm",8) == 2331535654) strcat(s, "a");
if (crc32("AYGyJMuLE",9) == 3033911204) strcat(s, "C");
if (crc32("AhlGoYfv",8) == 658554530) strcat(s, "l");
if (crc32("hTMOlyrWUDm",11) == 1009523896) strcat(s, "U");
if (crc32("mHDGPcPaA",9) == 323310285) strcat(s, "l");
if (crc32("TSMTTrbkDjIGw",13) == 1756014461) strcat(s, "y");
    return s;
}

char *unprecociously_adverbs() {
    char *s = calloc(15);
    if (crc32("AjIuXGIydUP",11) == 440537710) strcat(s, "p");
if (crc32("yYLsGHgIYpdDvbi",15) == 3506406471) strcat(s, "u");
if (crc32("sXZXcsaOK",9) == 3061733252) strcat(s, "n");
if (crc32("tOIUTzjjaFUuz",13) == 2102951477) strcat(s, "u");
if (crc32("AOFMtHIzYE",10) == 1936908929) strcat(s, "p");
if (crc32("ApmbktHAMBVBJ",13) == 3987880363) strcat(s, "r");
if (crc32("lTwal",5) == 3084123364) strcat(s, "e");
if (crc32("LKMdMr",6) == 990363816) strcat(s, "c");
if (crc32("BtbJk",5) == 2960555959) strcat(s, "L");
if (crc32("DyAmsKizTnnWbWZ",15) == 1776957368) strcat(s, "o");
if (crc32("EFifgepKKh",10) == 308569750) strcat(s, "c");
if (crc32("DUZyxHVVe",9) == 4248024876) strcat(s, "i");
if (crc32("MZNJd",5) == 4173080103) strcat(s, "o");
if (crc32("wVdnGC",6) == 3059149095) strcat(s, "u");
if (crc32("jnvWwd",6) == 1257617276) strcat(s, "N");
if (crc32("GodBn",5) == 1747949109) strcat(s, "s");
if (crc32("omXABQb",7) == 646931843) strcat(s, "I");
if (crc32("BRoHNILsMhPK",12) == 2644122190) strcat(s, "l");
if (crc32("hdvoD",5) == 153338761) strcat(s, "T");
if (crc32("qRfBJvmPRF",10) == 153535540) strcat(s, "y");
    return s;
}

char *subaffluently_adverbs() {
    char *s = calloc(14);
    if (crc32("iRCmHPRWV",9) == 3717641336) strcat(s, "d");
if (crc32("qtoGH",5) == 1652135380) strcat(s, "s");
if (crc32("edEbmKd",7) == 2973216674) strcat(s, "O");
if (crc32("TKtpeHIVcBWyhO",14) == 2727034854) strcat(s, "u");
if (crc32("ufOju",5) == 770112542) strcat(s, "b");
if (crc32("DWNQSWRYG",9) == 753017852) strcat(s, "a");
if (crc32("DifcDXAfdaF",11) == 3594089508) strcat(s, "f");
if (crc32("AcbPNeEuOmnv",12) == 4097547575) strcat(s, "f");
if (crc32("xpcJBGQHy",9) == 1529325376) strcat(s, "U");
if (crc32("pyiZW",5) == 3684334050) strcat(s, "l");
if (crc32("LXJOcVyXVGhP",12) == 3006330706) strcat(s, "x");
if (crc32("aNfNXmSL",8) == 4101179157) strcat(s, "u");
if (crc32("joUKmfcaju",10) == 2159808406) strcat(s, "e");
if (crc32("QGvRPmCoSns",11) == 2930194619) strcat(s, "R");
if (crc32("iEvkNpkf",8) == 2194581496) strcat(s, "n");
if (crc32("TtgAk",5) == 2228644079) strcat(s, "Z");
if (crc32("SlajOfjlrQor",12) == 2160491038) strcat(s, "t");
if (crc32("rrnonYPbAqbc",12) == 3777463947) strcat(s, "C");
if (crc32("DWyDuV",6) == 517753210) strcat(s, "l");
if (crc32("dNBjCkIIsukqf",13) == 4147326136) strcat(s, "y");
    return s;
}

char *unpitifully_adverbs() {
    char *s = calloc(12);
    if (crc32("yNocoAZ",7) == 3261649752) strcat(s, "u");
if (crc32("SfYKDc",6) == 2815345149) strcat(s, "n");
if (crc32("bJxbbeYMeb",10) == 1716350371) strcat(s, "I");
if (crc32("AxyDOE",6) == 2895642555) strcat(s, "p");
if (crc32("pwbjoBdWxMoyjy",14) == 1055493462) strcat(s, "A");
if (crc32("pDaiumycgwJeyeE",15) == 1167926957) strcat(s, "i");
if (crc32("srmfQjHlJY",10) == 1272060741) strcat(s, "k");
if (crc32("hLdMdqx",7) == 2135397571) strcat(s, "t");
if (crc32("KUcbSGMs",8) == 3456026439) strcat(s, "M");
if (crc32("LHvTrk",6) == 1129554612) strcat(s, "i");
if (crc32("juvhKXsBsurzs",13) == 3216507687) strcat(s, "f");
if (crc32("VLvzpcitjlA",11) == 3871137034) strcat(s, "a");
if (crc32("UfZlalAaoorZAV",14) == 901047069) strcat(s, "u");
if (crc32("CDWiHKOmMf",10) == 4209144147) strcat(s, "l");
if (crc32("cTSbjAjEUvkLMj",14) == 3798732837) strcat(s, "p");
if (crc32("zBYcpBzXJvyU",12) == 2270464805) strcat(s, "l");
if (crc32("wgxKnYhshgjqg",13) == 1553610713) strcat(s, "O");
if (crc32("TNFEjEedBnNNhHK",15) == 2248786546) strcat(s, "y");
    return s;
}

char *somehow_adverbs() {
    char *s = calloc(8);
    if (crc32("sIEvpnWfXRW",11) == 396174754) strcat(s, "u");
if (crc32("zqSFnlECsn",10) == 125376333) strcat(s, "s");
if (crc32("YsHDJdxbPpKYoY",14) == 3462126104) strcat(s, "o");
if (crc32("gyswSVshgxgHkZ",14) == 1024673233) strcat(s, "J");
if (crc32("UvFoNAfNfgM",11) == 4000903198) strcat(s, "m");
if (crc32("uPVMmNOqGkoFuJ",14) == 3743427459) strcat(s, "e");
if (crc32("wsADtFsmOEaxoF",14) == 4185707919) strcat(s, "P");
if (crc32("RnZZUnnRzjCuZF",14) == 1751812001) strcat(s, "h");
if (crc32("titkEzjY",8) == 3221865443) strcat(s, "D");
if (crc32("iWJoCTGigbRr",12) == 3090831677) strcat(s, "o");
if (crc32("UitUwsjaeC",10) == 1459934497) strcat(s, "w");
    return s;
}

char *digestibly_adverbs() {
    char *s = calloc(11);
    if (crc32("fGLKgQnCocXDoD",14) == 2382666114) strcat(s, "d");
if (crc32("nBWlJtMSINCjZ",13) == 2840684600) strcat(s, "Q");
if (crc32("TNbtltrYrN",10) == 2459846346) strcat(s, "i");
if (crc32("PnZiHYE",7) == 2878126202) strcat(s, "g");
if (crc32("aNPMjA",6) == 2332551143) strcat(s, "x");
if (crc32("NjHqgouvSpVB",12) == 161411646) strcat(s, "e");
if (crc32("oXpWjZarNqB",11) == 2667061162) strcat(s, "a");
if (crc32("gOMMl",5) == 1473648259) strcat(s, "s");
if (crc32("xbqfWHrCpY",10) == 192351238) strcat(s, "t");
if (crc32("FONZAsGB",8) == 764919242) strcat(s, "i");
if (crc32("uBIaLUq",7) == 4226047704) strcat(s, "o");
if (crc32("JznuYg",6) == 2635024554) strcat(s, "b");
if (crc32("tdJzOhSKZrB",11) == 530198486) strcat(s, "L");
if (crc32("YCjFj",5) == 881099591) strcat(s, "l");
if (crc32("qPtOksmQHzeLVvC",15) == 3936243115) strcat(s, "b");
if (crc32("PSsseynsrMTcqSZ",15) == 2822852604) strcat(s, "y");
    return s;
}

char *unprecipitously_adverbs() {
    char *s = calloc(16);
    if (crc32("RWuSYttcixLbW",13) == 1069130506) strcat(s, "h");
if (crc32("xmHHfYueEzj",11) == 1686563746) strcat(s, "u");
if (crc32("uDUDP",5) == 3860306228) strcat(s, "t");
if (crc32("NNnzLYDCGQzk",12) == 2884825450) strcat(s, "n");
if (crc32("QrMADpHstVHk",12) == 2860693084) strcat(s, "p");
if (crc32("ScBHKOESGDUVNS",14) == 1833555048) strcat(s, "H");
if (crc32("ByriTeo",7) == 165382470) strcat(s, "r");
if (crc32("DbsenGLZpifEhzx",15) == 3990868959) strcat(s, "U");
if (crc32("FSBkUgqSMP",10) == 1030535704) strcat(s, "e");
if (crc32("Peawv",5) == 937081565) strcat(s, "G");
if (crc32("RtJlVUZj",8) == 4045794577) strcat(s, "c");
if (crc32("ZEyBXjczerJbWl",14) == 322951224) strcat(s, "i");
if (crc32("OhWswLUF",8) == 1428426447) strcat(s, "p");
if (crc32("YWzFEmaVA",9) == 192064876) strcat(s, "i");
if (crc32("KDDkD",5) == 3399722025) strcat(s, "h");
if (crc32("qLuTXtUbMdDLDpv",15) == 663271677) strcat(s, "t");
if (crc32("OThqlQiAc",9) == 465941792) strcat(s, "o");
if (crc32("WIWvbRSftwQTZR",14) == 2246515567) strcat(s, "N");
if (crc32("SYKMOujBdGfTI",13) == 4227523338) strcat(s, "u");
if (crc32("jdIViWCuUsjLVs",14) == 3030287856) strcat(s, "s");
if (crc32("HoCnUqHafE",10) == 4005253633) strcat(s, "g");
if (crc32("NsFDeEAherqgoc",14) == 1747159708) strcat(s, "l");
if (crc32("XJxVCXnMrZD",11) == 2453531585) strcat(s, "U");
if (crc32("YTqMP",5) == 3435241609) strcat(s, "y");
    return s;
}

char *semischolastically_adverbs() {
    char *s = calloc(19);
    if (crc32("ovYSykFE",8) == 1074282368) strcat(s, "O");
if (crc32("dtbaPDFWWXnvyr",14) == 2328225440) strcat(s, "s");
if (crc32("pcDpJcuJ",8) == 2369113309) strcat(s, "Z");
if (crc32("guCnkOilQXiQr",13) == 1584227326) strcat(s, "e");
if (crc32("SGddDh",6) == 4260183904) strcat(s, "m");
if (crc32("SLzhPEGOTZAO",12) == 2015982334) strcat(s, "Q");
if (crc32("deFlK",5) == 4198067296) strcat(s, "i");
if (crc32("WvyOtFmDj",9) == 2460748881) strcat(s, "A");
if (crc32("fAiCy",5) == 1181970265) strcat(s, "s");
if (crc32("pwehl",5) == 1847872224) strcat(s, "c");
if (crc32("GQnpaiOMals",11) == 40200401) strcat(s, "h");
if (crc32("yBrxWXEiKpu",11) == 1984612102) strcat(s, "o");
if (crc32("vmfgEhKydjf",11) == 254771850) strcat(s, "M");
if (crc32("HWECYcb",7) == 1823527402) strcat(s, "l");
if (crc32("jUpACMV",7) == 1903478895) strcat(s, "b");
if (crc32("VyfucZDOTB",10) == 1981983394) strcat(s, "a");
if (crc32("VRrAtOgOXd",10) == 902226352) strcat(s, "J");
if (crc32("ZuvgJkVfyF",10) == 1358544049) strcat(s, "s");
if (crc32("bDYlZ",5) == 272471332) strcat(s, "t");
if (crc32("NZATUKvsWx",10) == 4209930201) strcat(s, "S");
if (crc32("GshDHZIAfzSqwl",14) == 3250527184) strcat(s, "i");
if (crc32("odMaQhZKoK",10) == 1992641142) strcat(s, "w");
if (crc32("OaWQXoyhuauci",13) == 3860331238) strcat(s, "c");
if (crc32("ZtiNtXYmi",9) == 2275973741) strcat(s, "a");
if (crc32("srLqHIC",7) == 4167168941) strcat(s, "l");
if (crc32("DHSZuX",6) == 3269698830) strcat(s, "l");
if (crc32("yVfQA",5) == 1030852034) strcat(s, "H");
if (crc32("zfDrVn",6) == 149014576) strcat(s, "y");
    return s;
}

char *damningly_adverbs() {
    char *s = calloc(10);
    if (crc32("YZLDAZj",7) == 3052629716) strcat(s, "e");
if (crc32("vTiPIVQs",8) == 737022629) strcat(s, "d");
if (crc32("ciHYJ",5) == 3714568418) strcat(s, "a");
if (crc32("rfJOeoDTIkvKa",13) == 2969677644) strcat(s, "m");
if (crc32("QXJLl",5) == 2821526343) strcat(s, "n");
if (crc32("yWZPUTcNMfExVOI",15) == 3745759616) strcat(s, "i");
if (crc32("CiQDH",5) == 506685993) strcat(s, "n");
if (crc32("pWfxBVxMWpK",11) == 1445039218) strcat(s, "U");
if (crc32("dHSJydAfYOQwq",13) == 2006146432) strcat(s, "g");
if (crc32("jSeGx",5) == 1675760058) strcat(s, "l");
if (crc32("HXJzPilciR",10) == 3317652787) strcat(s, "y");
    return s;
}

char *incomputably_adverbs() {
    char *s = calloc(13);
    if (crc32("BlpzkRezhqDzk",13) == 1481921963) strcat(s, "i");
if (crc32("mwOIsXHJLnLA",12) == 176196706) strcat(s, "n");
if (crc32("CZVNQRUF",8) == 3462976428) strcat(s, "A");
if (crc32("OInJxUDUFApP",12) == 4054120510) strcat(s, "c");
if (crc32("hzfhZjHfAo",10) == 3001569207) strcat(s, "o");
if (crc32("DuQwSQtUJ",9) == 477960932) strcat(s, "m");
if (crc32("vvNnzbFYfc",10) == 495823481) strcat(s, "Q");
if (crc32("SDIbQ",5) == 2567656292) strcat(s, "p");
if (crc32("dOqDPVIc",8) == 3102854491) strcat(s, "u");
if (crc32("ZMEQjghghL",10) == 1703402769) strcat(s, "t");
if (crc32("IouZhFDRweAUolI",15) == 3232072888) strcat(s, "K");
if (crc32("qWHGLC",6) == 1675859880) strcat(s, "a");
if (crc32("lrXRxqgr",8) == 1418779338) strcat(s, "b");
if (crc32("PYxjgLJLkZLyWF",14) == 684600280) strcat(s, "l");
if (crc32("zskrtfBUU",9) == 817625151) strcat(s, "Z");
if (crc32("JeZQNaH",7) == 1524230019) strcat(s, "y");
    return s;
}

char *reluctantly_adverbs() {
    char *s = calloc(12);
    if (crc32("nTcSgDxk",8) == 1794033955) strcat(s, "r");
if (crc32("XkHlNJBtmRoa",12) == 1609866142) strcat(s, "L");
if (crc32("KNfTfJm",7) == 3386933761) strcat(s, "e");
if (crc32("vFLRqNWqHufwGh",14) == 2960738233) strcat(s, "l");
if (crc32("YnkoSX",6) == 3888847614) strcat(s, "u");
if (crc32("kSnSMYE",7) == 2466654299) strcat(s, "i");
if (crc32("DWWxkX",6) == 1085906779) strcat(s, "c");
if (crc32("tQTFVuxZZM",10) == 3752573898) strcat(s, "c");
if (crc32("gsbuqxkWnqMAKIO",15) == 845704088) strcat(s, "t");
if (crc32("HNDujJvbOji",11) == 1454584768) strcat(s, "a");
if (crc32("oqQou",5) == 3502104246) strcat(s, "W");
if (crc32("sjQnsOFgFH",10) == 258658981) strcat(s, "n");
if (crc32("MynMNrBVzsYqtNN",15) == 2974780745) strcat(s, "d");
if (crc32("UawtiwtDsI",10) == 3049815991) strcat(s, "t");
if (crc32("sGHRCxZXd",9) == 3532898617) strcat(s, "l");
if (crc32("YUVvf",5) == 4072233698) strcat(s, "d");
if (crc32("bUaobuqJHYKOin",14) == 3359617437) strcat(s, "y");
    return s;
}

char *sic_adverbs() {
    char *s = calloc(4);
    if (crc32("PhtSWlXTcUG",11) == 1726063887) strcat(s, "N");
if (crc32("qQnNS",5) == 2951795274) strcat(s, "s");
if (crc32("bmeod",5) == 171583244) strcat(s, "i");
if (crc32("RxNGOke",7) == 4013999014) strcat(s, "c");
    return s;
}

char *increasingly_adverbs() {
    char *s = calloc(13);
    if (crc32("JLhDoLmQAWEm",12) == 2836572126) strcat(s, "J");
if (crc32("IakGHwtIkDxOBHm",15) == 1541023034) strcat(s, "i");
if (crc32("wuCCwYrCOUjZulx",15) == 3767617726) strcat(s, "j");
if (crc32("nCIaRbPJ",8) == 1598040800) strcat(s, "n");
if (crc32("hSnbMnKdpN",10) == 1220937124) strcat(s, "M");
if (crc32("kaEUbnsaHc",10) == 784282744) strcat(s, "c");
if (crc32("XMAGEjogiif",11) == 2099798213) strcat(s, "r");
if (crc32("YzZxeGlWVh",10) == 217682219) strcat(s, "K");
if (crc32("ZoqnjBZZRqujXFS",15) == 1859145515) strcat(s, "e");
if (crc32("gxIIEiyAQbsvk",13) == 1627844656) strcat(s, "t");
if (crc32("sDIaPQl",7) == 2302974010) strcat(s, "a");
if (crc32("Zofgc",5) == 1704574258) strcat(s, "s");
if (crc32("EfTpAVJjCjpTpdO",15) == 3433069127) strcat(s, "i");
if (crc32("RDUzysNYW",9) == 2644953195) strcat(s, "w");
if (crc32("JAbhtGOIjGZJ",12) == 1906732878) strcat(s, "n");
if (crc32("KUvqx",5) == 760530062) strcat(s, "g");
if (crc32("lMtOgaQUaOEkDU",14) == 124883536) strcat(s, "e");
if (crc32("OnUPk",5) == 3453268330) strcat(s, "l");
if (crc32("esTahjBOywwu",12) == 3831524683) strcat(s, "y");
    return s;
}

char *tridimensionally_adverbs() {
    char *s = calloc(17);
    if (crc32("lnXRsrmXc",9) == 623109754) strcat(s, "Y");
if (crc32("vnBuylzFRqCJp",13) == 3103829033) strcat(s, "t");
if (crc32("LbusMyYlTNn",11) == 409729897) strcat(s, "r");
if (crc32("DpBqbea",7) == 1116703133) strcat(s, "g");
if (crc32("tAUTrQV",7) == 2198736427) strcat(s, "i");
if (crc32("qioZcCcnE",9) == 2933301933) strcat(s, "W");
if (crc32("xKnxHOTb",8) == 4291466208) strcat(s, "d");
if (crc32("zlOVmJMWoFsZmCC",15) == 4047939529) strcat(s, "i");
if (crc32("loZJw",5) == 207647737) strcat(s, "C");
if (crc32("eSVWiKn",7) == 3522224427) strcat(s, "m");
if (crc32("vLnLueEMREQsMh",14) == 1237899124) strcat(s, "e");
if (crc32("kSkrgeuGcH",10) == 753166943) strcat(s, "n");
if (crc32("sEuQecDBQRDA",12) == 3888114117) strcat(s, "s");
if (crc32("sPAEmrxj",8) == 3834070533) strcat(s, "i");
if (crc32("GucbtEmOSfG",11) == 590804336) strcat(s, "o");
if (crc32("fZDETaXlvqGrk",13) == 577922364) strcat(s, "n");
if (crc32("PsNWvRwq",8) == 888485339) strcat(s, "a");
if (crc32("CaDzYqo",7) == 2874353108) strcat(s, "t");
if (crc32("iSRQVE",6) == 128419401) strcat(s, "l");
if (crc32("ZiPTNOoCEvxhaB",14) == 2180091114) strcat(s, "l");
if (crc32("OUgqMVisWFotIM",14) == 963213096) strcat(s, "Q");
if (crc32("ZNsYKRSaLPwf",12) == 2097967029) strcat(s, "y");
    return s;
}

char *unintrudingly_adverbs() {
    char *s = calloc(14);
    if (crc32("oIyGJhjzx",9) == 1933646577) strcat(s, "y");
if (crc32("UqyhI",5) == 475413275) strcat(s, "u");
if (crc32("ITTszhMazMSyE",13) == 2089522264) strcat(s, "y");
if (crc32("dJWXPtXqCB",10) == 657674050) strcat(s, "n");
if (crc32("dGOqPwTou",9) == 2190648207) strcat(s, "S");
if (crc32("oLFVpaLaAeqV",12) == 3949738475) strcat(s, "i");
if (crc32("UKkBxgYmnva",11) == 2249895018) strcat(s, "n");
if (crc32("gXpMQb",6) == 916444915) strcat(s, "E");
if (crc32("EWGWnYjmyk",10) == 2146722315) strcat(s, "t");
if (crc32("TlpkYIarSxAs",12) == 1315785075) strcat(s, "r");
if (crc32("AKXFdq",6) == 114829316) strcat(s, "u");
if (crc32("FpcYpHVxx",9) == 7682075) strcat(s, "d");
if (crc32("CbtKSqkCtLPSpoy",15) == 3615971338) strcat(s, "X");
if (crc32("OGGENPYFy",9) == 3659144714) strcat(s, "i");
if (crc32("wCcrYA",6) == 2901593483) strcat(s, "n");
if (crc32("fweQLYpfpC",10) == 1609816572) strcat(s, "V");
if (crc32("VgaWapf",7) == 4176169339) strcat(s, "g");
if (crc32("InNelRWfYwlhu",13) == 3709419960) strcat(s, "l");
if (crc32("QsIqAJiZewLJ",12) == 2539291191) strcat(s, "E");
if (crc32("OlXLOGOyk",9) == 2348621765) strcat(s, "y");
    return s;
}

char *privatively_adverbs() {
    char *s = calloc(12);
    if (crc32("gpedDefn",8) == 246459872) strcat(s, "H");
if (crc32("MyMGvmuvpKlBM",13) == 3101181819) strcat(s, "p");
if (crc32("EPXcvWBykzOUls",14) == 3801855808) strcat(s, "K");
if (crc32("uhNXG",5) == 3915179243) strcat(s, "r");
if (crc32("hDjbxPR",7) == 3066016831) strcat(s, "L");
if (crc32("oTkkChqIm",9) == 4185347802) strcat(s, "i");
if (crc32("IWapwBA",7) == 1974843852) strcat(s, "I");
if (crc32("yShMzAVkYjZP",12) == 4247048748) strcat(s, "v");
if (crc32("NJHzW",5) == 2334007359) strcat(s, "a");
if (crc32("luwTDQiheYg",11) == 1823137549) strcat(s, "j");
if (crc32("MraTXMehGtPMK",13) == 2630953379) strcat(s, "t");
if (crc32("DTZJKcxgHc",10) == 2348151216) strcat(s, "P");
if (crc32("ZWPdNhE",7) == 1451428397) strcat(s, "i");
if (crc32("gNOhUPUTTjCqOic",15) == 3022647721) strcat(s, "I");
if (crc32("PAoRtQM",7) == 4176369921) strcat(s, "v");
if (crc32("vPbIlsRTw",9) == 1580091504) strcat(s, "e");
if (crc32("aKcSldzy",8) == 211543427) strcat(s, "l");
if (crc32("bfUYYIqoQIueLnI",15) == 12785645) strcat(s, "i");
if (crc32("ChdUkAvStvHeqrn",15) == 3234428577) strcat(s, "y");
    return s;
}

char *morganatically_adverbs() {
    char *s = calloc(15);
    if (crc32("MsbJVVyffggn",12) == 369567034) strcat(s, "m");
if (crc32("FYLqLlrZOhLS",12) == 3914751809) strcat(s, "o");
if (crc32("GzlnsMT",7) == 1311036158) strcat(s, "r");
if (crc32("ZqiXPPfYcjnt",12) == 735415166) strcat(s, "g");
if (crc32("WDCzoz",6) == 2403897978) strcat(s, "a");
if (crc32("QqIOQ",5) == 68440696) strcat(s, "n");
if (crc32("nwPlutzDkCIdISV",15) == 3865868715) strcat(s, "a");
if (crc32("PsAmlS",6) == 3418797832) strcat(s, "e");
if (crc32("NNUupMmjIvsvNR",14) == 374297857) strcat(s, "t");
if (crc32("leHIXmtoi",9) == 1419554902) strcat(s, "p");
if (crc32("LdJJfqjupkuMEli",15) == 1096625618) strcat(s, "i");
if (crc32("tvSGjsSOn",9) == 2115808175) strcat(s, "N");
if (crc32("WLbakQG",7) == 1819732732) strcat(s, "c");
if (crc32("vVJTEhU",7) == 1583022695) strcat(s, "a");
if (crc32("QxZlDSKcP",9) == 700049170) strcat(s, "l");
if (crc32("pFhNvMHBHHx",11) == 2728164453) strcat(s, "q");
if (crc32("YDCXgJYJtFQv",12) == 2307553205) strcat(s, "l");
if (crc32("zSHhfVNwDFD",11) == 3237361903) strcat(s, "y");
    return s;
}

char *nonthematically_adverbs() {
    char *s = calloc(16);
    if (crc32("XRlwPBWZeMIW",12) == 2080216464) strcat(s, "n");
if (crc32("wSIPXslG",8) == 1707197525) strcat(s, "c");
if (crc32("EzfIckMMohq",11) == 3968182553) strcat(s, "o");
if (crc32("faXLRUrTBCPW",12) == 1583857046) strcat(s, "n");
if (crc32("FtoVIuQ",7) == 4000266902) strcat(s, "t");
if (crc32("HunYIWS",7) == 1324074617) strcat(s, "Z");
if (crc32("pWAEvvipZRYvFe",14) == 2324827910) strcat(s, "h");
if (crc32("xuONOMSd",8) == 3654388547) strcat(s, "g");
if (crc32("QWwVbUzruY",10) == 3812137844) strcat(s, "e");
if (crc32("oltVJXyLdit",11) == 3562642645) strcat(s, "m");
if (crc32("cFToYABwxR",10) == 325179277) strcat(s, "o");
if (crc32("RLTjZEK",7) == 3315538853) strcat(s, "a");
if (crc32("pZgIQecJJLLcALZ",15) == 602891567) strcat(s, "t");
if (crc32("uWiGRAfUANRgL",13) == 11635263) strcat(s, "W");
if (crc32("ROuNlT",6) == 2844559077) strcat(s, "i");
if (crc32("GuIILHngpeu",11) == 1185136838) strcat(s, "R");
if (crc32("FHTgvDuz",8) == 2590376300) strcat(s, "c");
if (crc32("yysVGV",6) == 1168510823) strcat(s, "a");
if (crc32("LsAKyR",6) == 1406492341) strcat(s, "l");
if (crc32("jkoWZGcm",8) == 3173685920) strcat(s, "f");
if (crc32("njqJOVXlb",9) == 3955344463) strcat(s, "l");
if (crc32("owVPKB",6) == 2096494619) strcat(s, "M");
if (crc32("MjGizOEB",8) == 345712111) strcat(s, "y");
    return s;
}

char *antiBiblically_adverbs() {
    char *s = calloc(15);
    if (crc32("RwgZhdxtmZJaR",13) == 410322952) strcat(s, "G");
if (crc32("BEVZh",5) == 601315981) strcat(s, "a");
if (crc32("hQEKW",5) == 2348990180) strcat(s, "n");
if (crc32("LEcKiaCWeO",10) == 3899112266) strcat(s, "n");
if (crc32("aWrzTFZF",8) == 2232075309) strcat(s, "t");
if (crc32("CBtrZYTEC",9) == 4188736586) strcat(s, "i");
if (crc32("YkDHijwoMuTOy",13) == 2209309790) strcat(s, "G");
if (crc32("nYoobBXaqrADt",13) == 3295519700) strcat(s, "B");
if (crc32("sgegIBrlRWTll",13) == 2843782359) strcat(s, "i");
if (crc32("RvEBItxrwO",10) == 2611479145) strcat(s, "W");
if (crc32("UARVaD",6) == 2356151130) strcat(s, "b");
if (crc32("dvlHRTJVms",10) == 1099818761) strcat(s, "l");
if (crc32("euTiQzhnFvhDZcL",15) == 90318074) strcat(s, "p");
if (crc32("UcgQCKS",7) == 2842755609) strcat(s, "i");
if (crc32("dvyXXeyxleN",11) == 1886899889) strcat(s, "c");
if (crc32("KNMmhfDQlHrlXUF",15) == 1318921479) strcat(s, "a");
if (crc32("AucxcYtnsTY",11) == 2866372650) strcat(s, "l");
if (crc32("EVwWZIb",7) == 1674803348) strcat(s, "J");
if (crc32("ECILw",5) == 846628142) strcat(s, "l");
if (crc32("FAfXX",5) == 2612238670) strcat(s, "m");
if (crc32("eBscdQsNBzR",11) == 423164668) strcat(s, "y");
    return s;
}

char *humblingly_adverbs() {
    char *s = calloc(11);
    if (crc32("DkWBCgGXFkrrq",13) == 3940550277) strcat(s, "h");
if (crc32("GkrtzpLGIVlrucN",15) == 4048149899) strcat(s, "z");
if (crc32("pisAeBuG",8) == 4201598534) strcat(s, "u");
if (crc32("oaFYDbVop",9) == 2479191765) strcat(s, "m");
if (crc32("SpFvAOk",7) == 3926198995) strcat(s, "z");
if (crc32("QUANybpxpt",10) == 4207894765) strcat(s, "b");
if (crc32("wVHQibsbig",10) == 3046193616) strcat(s, "F");
if (crc32("yEHflUmEz",9) == 2952619069) strcat(s, "l");
if (crc32("TICwHO",6) == 1977794928) strcat(s, "i");
if (crc32("ZvkGmawMjTaRz",13) == 4059328159) strcat(s, "H");
if (crc32("mHGvYQwnCrpqKu",14) == 91893713) strcat(s, "n");
if (crc32("SyjPOv",6) == 968550224) strcat(s, "g");
if (crc32("UqEptQWq",8) == 188148970) strcat(s, "s");
if (crc32("UMoJSipAWpjyJBB",15) == 3105244184) strcat(s, "l");
if (crc32("ejaQW",5) == 3704688914) strcat(s, "y");
    return s;
}

char *stethoscopically_adverbs() {
    char *s = calloc(17);
    if (crc32("DhThH",5) == 2508233477) strcat(s, "S");
if (crc32("mpdtdYgIBYbM",12) == 3915479511) strcat(s, "s");
if (crc32("rXGVoRsbQmeMXCe",15) == 1533961520) strcat(s, "L");
if (crc32("vbRWsHeEOij",11) == 172551918) strcat(s, "t");
if (crc32("OfCokNBz",8) == 199986116) strcat(s, "e");
if (crc32("zBTmvPa",7) == 844445063) strcat(s, "Z");
if (crc32("NUUUUhqoDpMD",12) == 3337898225) strcat(s, "t");
if (crc32("yfpCpAt",7) == 3994484069) strcat(s, "m");
if (crc32("TkPKrqDWcWJMDXh",15) == 2910849704) strcat(s, "h");
if (crc32("BFRvRFUnoU",10) == 2650610544) strcat(s, "o");
if (crc32("MnaKV",5) == 1697130701) strcat(s, "s");
if (crc32("laFPCdv",7) == 3293040232) strcat(s, "c");
if (crc32("nDtEnGXea",9) == 4171036132) strcat(s, "o");
if (crc32("tViqTrIbU",9) == 964407401) strcat(s, "p");
if (crc32("rFsKef",6) == 349162018) strcat(s, "u");
if (crc32("qcaaT",5) == 1928726675) strcat(s, "i");
if (crc32("USKFnpiBGlpY",12) == 1474846684) strcat(s, "Y");
if (crc32("cqlogZevZmkUQn",14) == 682135058) strcat(s, "c");
if (crc32("waIQNmvwxmig",12) == 1950958943) strcat(s, "a");
if (crc32("zpABuTl",7) == 1923283248) strcat(s, "y");
if (crc32("oOPeJM",6) == 355028863) strcat(s, "l");
if (crc32("VDKulqUMotdX",12) == 1433847774) strcat(s, "C");
if (crc32("pCKVrTyt",8) == 1833662520) strcat(s, "l");
if (crc32("XPIrn",5) == 3439631825) strcat(s, "y");
    return s;
}

char *unethnologically_adverbs() {
    char *s = calloc(17);
    if (crc32("mnsAhnJHqvr",11) == 3269097994) strcat(s, "v");
if (crc32("GHGjcs",6) == 256097903) strcat(s, "u");
if (crc32("bWfRHFXunczf",12) == 2185313790) strcat(s, "n");
if (crc32("ymJfl",5) == 4043486009) strcat(s, "e");
if (crc32("pVahwXsShgleeEM",15) == 1279801979) strcat(s, "B");
if (crc32("TQJvYlDy",8) == 2746863046) strcat(s, "t");
if (crc32("IWAkrMWNZOcLPOb",15) == 3991952013) strcat(s, "v");
if (crc32("IiKnLMqvsoePs",13) == 1192638991) strcat(s, "h");
if (crc32("jNmHOGqRtGZBbI",14) == 2341358925) strcat(s, "Z");
if (crc32("vmUDJjvfnwkW",12) == 1383206690) strcat(s, "n");
if (crc32("XMPHpySIcC",10) == 3158324080) strcat(s, "o");
if (crc32("lOablZNoi",9) == 1970357793) strcat(s, "P");
if (crc32("hmgEqmNroWgCvnu",15) == 473475625) strcat(s, "l");
if (crc32("DCYYFqMhnAG",11) == 382003596) strcat(s, "o");
if (crc32("XsUuTQkhRAmBaY",14) == 2820918203) strcat(s, "b");
if (crc32("AMBRHTgsUXbDG",13) == 1280522564) strcat(s, "g");
if (crc32("wFnMVb",6) == 595431134) strcat(s, "G");
if (crc32("VcLzFnR",7) == 3229879348) strcat(s, "i");
if (crc32("tZMVllPersJCs",13) == 2807522744) strcat(s, "a");
if (crc32("xXFXqnGbNZvyA",13) == 1271594629) strcat(s, "c");
if (crc32("ttmIOUKEAX",10) == 2473694490) strcat(s, "a");
if (crc32("qrrsTAwF",8) == 1279380774) strcat(s, "l");
if (crc32("tRZvXuTuF",9) == 94474245) strcat(s, "R");
if (crc32("zwBFofJUucjG",12) == 2335282474) strcat(s, "l");
if (crc32("BxwgH",5) == 2746310109) strcat(s, "G");
if (crc32("qhKgSSAIMHHhsjd",15) == 1317458022) strcat(s, "y");
    return s;
}

char *unincestuously_adverbs() {
    char *s = calloc(15);
    if (crc32("qpgeWFeDLpvB",12) == 4129368320) strcat(s, "u");
if (crc32("aHLQPqVYrz",10) == 3465136855) strcat(s, "H");
if (crc32("tkAsMQcATEc",11) == 3396935373) strcat(s, "n");
if (crc32("CdPhVRBKxmXuu",13) == 785372240) strcat(s, "i");
if (crc32("lgGuEuOCpPLphHX",15) == 1870796880) strcat(s, "V");
if (crc32("KvcqZKaqgqCqhc",14) == 1974077388) strcat(s, "n");
if (crc32("JsQkVqplseKqY",13) == 3909642813) strcat(s, "X");
if (crc32("jvfIaEPrykWD",12) == 1392500659) strcat(s, "c");
if (crc32("fMlbXmZS",8) == 910050126) strcat(s, "e");
if (crc32("dWlwgcugLhM",11) == 1207641314) strcat(s, "s");
if (crc32("ERpqUQyvu",9) == 3362883698) strcat(s, "t");
if (crc32("fBqEhuIhw",9) == 717714338) strcat(s, "x");
if (crc32("etJRZphOWgGWQpG",15) == 2618734289) strcat(s, "u");
if (crc32("vFIVPmZezpczA",13) == 1943222099) strcat(s, "o");
if (crc32("jcFfsxjAnbOshcv",15) == 4006123250) strcat(s, "w");
if (crc32("cXnxwf",6) == 1920322265) strcat(s, "u");
if (crc32("cDAnAOicQoPkr",13) == 1529739708) strcat(s, "c");
if (crc32("UaCGcW",6) == 242808511) strcat(s, "s");
if (crc32("OvsibHSE",8) == 2067126290) strcat(s, "l");
if (crc32("uYVnqSm",7) == 2460539371) strcat(s, "v");
if (crc32("UqoXDbunKPkDq",13) == 1131693762) strcat(s, "y");
    return s;
}

char *hornily_adverbs() {
    char *s = calloc(8);
    if (crc32("vgKEPOYyLk",10) == 2293659298) strcat(s, "a");
if (crc32("nVQPPTDREi",10) == 2491828306) strcat(s, "h");
if (crc32("EgnCLPA",7) == 661310602) strcat(s, "s");
if (crc32("LTTZBoj",7) == 3706170079) strcat(s, "o");
if (crc32("eVyEfp",6) == 1567365121) strcat(s, "r");
if (crc32("UXyVmWsTrorbA",13) == 431176602) strcat(s, "Q");
if (crc32("EvnUmTH",7) == 1781158977) strcat(s, "n");
if (crc32("KbNQfTKSCtFQLKR",15) == 1863334529) strcat(s, "i");
if (crc32("hQzPQ",5) == 3814748902) strcat(s, "l");
if (crc32("RTnvIaKbmfnj",12) == 1628714224) strcat(s, "y");
    return s;
}

char *Homerically_adverbs() {
    char *s = calloc(12);
    if (crc32("EDZXi",5) == 2394566252) strcat(s, "t");
if (crc32("sRQFrQsWI",9) == 946416561) strcat(s, "H");
if (crc32("pOLzkm",6) == 1575863920) strcat(s, "o");
if (crc32("bSwTMt",6) == 2910151347) strcat(s, "i");
if (crc32("ODKdFaSxzKaR",12) == 941866487) strcat(s, "m");
if (crc32("WUPKrAD",7) == 2633876999) strcat(s, "e");
if (crc32("jIGvyPVMfvJyh",13) == 3845781446) strcat(s, "D");
if (crc32("VUYqBtcuABjANBY",15) == 3809091727) strcat(s, "r");
if (crc32("gnvTBbycNin",11) == 2690346462) strcat(s, "i");
if (crc32("aOBhoOCCCv",10) == 340119901) strcat(s, "K");
if (crc32("nJbgXaQLcj",10) == 382630055) strcat(s, "c");
if (crc32("jowbri",6) == 2534615264) strcat(s, "a");
if (crc32("UDlifj",6) == 3905174045) strcat(s, "l");
if (crc32("eJUToCH",7) == 3194295297) strcat(s, "l");
if (crc32("QwIlGAcHQrgVN",13) == 4016047167) strcat(s, "B");
if (crc32("FDXRVeRSHDap",12) == 1168108206) strcat(s, "y");
    return s;
}

char *unclassifiably_adverbs() {
    char *s = calloc(15);
    if (crc32("WUbQOrYNV",9) == 2078661151) strcat(s, "v");
if (crc32("MrhpIqVFCNxrYRk",15) == 3104610875) strcat(s, "u");
if (crc32("wfEAqGUaOvnvKEg",15) == 2798909531) strcat(s, "P");
if (crc32("UOxDFXdzXYNlQXI",15) == 3150400332) strcat(s, "n");
if (crc32("wbmsQdC",7) == 4269512663) strcat(s, "h");
if (crc32("RzKiXKWk",8) == 2523430155) strcat(s, "c");
if (crc32("qawWvvJkTkEwnlm",15) == 3894154680) strcat(s, "c");
if (crc32("vcMov",5) == 3126986605) strcat(s, "l");
if (crc32("WuydYEtguMsUjO",14) == 2055914611) strcat(s, "c");
if (crc32("VKbqrRhpZapQ",12) == 4136431933) strcat(s, "a");
if (crc32("gGTTYMuEfPQ",11) == 1275216761) strcat(s, "E");
if (crc32("onAEbEpKDd",10) == 3101057413) strcat(s, "s");
if (crc32("RYvZAur",7) == 713038052) strcat(s, "T");
if (crc32("HaDgLWjNOyc",11) == 194020001) strcat(s, "s");
if (crc32("cXHEFoVg",8) == 2594637068) strcat(s, "i");
if (crc32("cxipSBEB",8) == 3376521115) strcat(s, "w");
if (crc32("SmnEEKL",7) == 2873460141) strcat(s, "f");
if (crc32("KmAucGEhzArSCE",14) == 1448418074) strcat(s, "i");
if (crc32("xbKZCoIlMtNhZMd",15) == 2811477843) strcat(s, "a");
if (crc32("eenXcpSIOJpSE",13) == 439840563) strcat(s, "b");
if (crc32("dryeL",5) == 1466339073) strcat(s, "l");
if (crc32("NmjNK",5) == 1626772852) strcat(s, "x");
if (crc32("BFdDrrqz",8) == 132181443) strcat(s, "y");
    return s;
}

char *undeliciously_adverbs() {
    char *s = calloc(14);
    if (crc32("HhbnTUvvI",9) == 3116603492) strcat(s, "u");
if (crc32("LMlOp",5) == 2343385997) strcat(s, "X");
if (crc32("RZbhHcL",7) == 3596623383) strcat(s, "n");
if (crc32("UmHHx",5) == 3882514435) strcat(s, "d");
if (crc32("BRqPnKDHKRZpJKY",15) == 3364278239) strcat(s, "q");
if (crc32("TKcYBfVHa",9) == 2059776031) strcat(s, "e");
if (crc32("NqoBPItWbID",11) == 1409502154) strcat(s, "l");
if (crc32("uzxhiclWiPuCH",13) == 3179084938) strcat(s, "i");
if (crc32("IOEYdWiuxJcsjv",14) == 2596901215) strcat(s, "y");
if (crc32("pnWHtyWKozVjY",13) == 3485640460) strcat(s, "c");
if (crc32("asyAidiPMhw",11) == 3082473192) strcat(s, "R");
if (crc32("JClOM",5) == 1669405829) strcat(s, "i");
if (crc32("bpTgFNtCvjD",11) == 1229138576) strcat(s, "o");
if (crc32("qFJmorQ",7) == 3395423845) strcat(s, "O");
if (crc32("brEyKJg",7) == 3825477378) strcat(s, "u");
if (crc32("XAjaxoVqGT",10) == 4127372870) strcat(s, "u");
if (crc32("wPnbDFLIInJbERq",15) == 526851421) strcat(s, "s");
if (crc32("XXGFdhWKVykLS",13) == 3229172268) strcat(s, "l");
if (crc32("PbkZr",5) == 1237122403) strcat(s, "w");
if (crc32("kwGgCigGmRLGed",14) == 922338654) strcat(s, "y");
    return s;
}

char *chirpingly_adverbs() {
    char *s = calloc(11);
    if (crc32("TYPZCJArZZDAP",13) == 1385282863) strcat(s, "t");
if (crc32("AJNFuRFGXM",10) == 1780181985) strcat(s, "c");
if (crc32("jwKfDbUePpCz",12) == 1872564923) strcat(s, "h");
if (crc32("ITzxYxPuT",9) == 591875872) strcat(s, "i");
if (crc32("BqYoLhF",7) == 1945694542) strcat(s, "P");
if (crc32("LJuEAIJkmWxmoi",14) == 312526316) strcat(s, "r");
if (crc32("BDKTiiTHTdzG",12) == 1211196614) strcat(s, "i");
if (crc32("lMUJVKbzD",9) == 631025876) strcat(s, "p");
if (crc32("INCAUcOGCNste",13) == 2873552326) strcat(s, "k");
if (crc32("bpizUqYhUvp",11) == 1630767135) strcat(s, "i");
if (crc32("nKTzgSldceXmN",13) == 1589004073) strcat(s, "n");
if (crc32("BPAFraEF",8) == 1997919244) strcat(s, "I");
if (crc32("NOkiBjN",7) == 2733777186) strcat(s, "g");
if (crc32("VAAAFzDsy",9) == 2909233797) strcat(s, "l");
if (crc32("VzIEsPbW",8) == 2982529632) strcat(s, "y");
    return s;
}

char *antichristianly_adverbs() {
    char *s = calloc(16);
    if (crc32("XwrFMjZNGdgZ",12) == 1208932732) strcat(s, "v");
if (crc32("wOfsyePIQ",9) == 1324831314) strcat(s, "a");
if (crc32("QXegTCvLg",9) == 2300195958) strcat(s, "e");
if (crc32("zgqAWO",6) == 2167116741) strcat(s, "n");
if (crc32("EHDLgwoDA",9) == 1259689121) strcat(s, "t");
if (crc32("vkWZHyNHkhUpnAJ",15) == 2566444233) strcat(s, "k");
if (crc32("rRUpvfeF",8) == 532151044) strcat(s, "i");
if (crc32("JbfQwOL",7) == 894660652) strcat(s, "f");
if (crc32("ECUhIk",6) == 2965909873) strcat(s, "c");
if (crc32("laMIAy",6) == 2138314023) strcat(s, "z");
if (crc32("CLfpXzMxg",9) == 3706934708) strcat(s, "h");
if (crc32("nNotCQrjr",9) == 2304324631) strcat(s, "a");
if (crc32("eeRfsZvJYv",10) == 596018058) strcat(s, "r");
if (crc32("eLQHFOSg",8) == 1445630225) strcat(s, "i");
if (crc32("anCtyyxfiSHSgu",14) == 2520047168) strcat(s, "s");
if (crc32("EmAiHQgyouE",11) == 3352868785) strcat(s, "k");
if (crc32("ygMTzuZ",7) == 2515642806) strcat(s, "t");
if (crc32("HrLlnMu",7) == 1734403976) strcat(s, "i");
if (crc32("NgjlCY",6) == 234077246) strcat(s, "N");
if (crc32("DvooKcxyn",9) == 2209470860) strcat(s, "a");
if (crc32("HsrcTm",6) == 2328374118) strcat(s, "n");
if (crc32("oUjlsdl",7) == 226560184) strcat(s, "l");
if (crc32("ScVjzTazNJdU",12) == 3317206449) strcat(s, "N");
if (crc32("eTTWoD",6) == 2585789536) strcat(s, "y");
    return s;
}

char *Anglicanly_adverbs() {
    char *s = calloc(11);
    if (crc32("aWcQJoITqrh",11) == 2639206122) strcat(s, "C");
if (crc32("CRedaqwNjLgQVaD",15) == 3089460543) strcat(s, "A");
if (crc32("SrtujqlgH",9) == 3693441341) strcat(s, "A");
if (crc32("lHAgzjyBPt",10) == 402424333) strcat(s, "n");
if (crc32("GSXQzqyGQVN",11) == 606775682) strcat(s, "O");
if (crc32("vlGCenzFcSZQUu",14) == 982832149) strcat(s, "g");
if (crc32("NzTLelbHQ",9) == 762596727) strcat(s, "l");
if (crc32("BrZVeHBl",8) == 2309391652) strcat(s, "R");
if (crc32("eiAejqjUvuDYY",13) == 2001145606) strcat(s, "i");
if (crc32("zGcdrjNN",8) == 1076141378) strcat(s, "c");
if (crc32("ATGzlviCVsRe",12) == 877643356) strcat(s, "a");
if (crc32("amDfYbydrbz",11) == 2284385879) strcat(s, "M");
if (crc32("GirxpZAALiU",11) == 3374204774) strcat(s, "n");
if (crc32("ZoASHGPewkZLtz",14) == 584997529) strcat(s, "l");
if (crc32("fXQzvbaHIoavkpT",15) == 239936572) strcat(s, "y");
    return s;
}

char *desultorily_adverbs() {
    char *s = calloc(12);
    if (crc32("IbShxWuRU",9) == 2929906730) strcat(s, "d");
if (crc32("heQGsNKgz",9) == 3455876338) strcat(s, "l");
if (crc32("ppJkK",5) == 1321571628) strcat(s, "e");
if (crc32("NDHLCqLcbRtC",12) == 1615449918) strcat(s, "s");
if (crc32("ufOFa",5) == 1593505073) strcat(s, "C");
if (crc32("kkMSdolvh",9) == 1850665564) strcat(s, "u");
if (crc32("qKakDz",6) == 121725193) strcat(s, "d");
if (crc32("avcBBfRYbMdWC",13) == 3796466045) strcat(s, "l");
if (crc32("gMsELSHarIt",11) == 4065056099) strcat(s, "B");
if (crc32("dKkTCA",6) == 1352211993) strcat(s, "t");
if (crc32("LBAbXgsvbh",10) == 2565726590) strcat(s, "o");
if (crc32("GqHyDSyOjLfZ",12) == 2179265279) strcat(s, "G");
if (crc32("vvCeoM",6) == 933162573) strcat(s, "r");
if (crc32("WVdIainhcLV",11) == 1727287783) strcat(s, "g");
if (crc32("nLfjPyfVFPrPCj",14) == 1306590848) strcat(s, "i");
if (crc32("fkkLaOJiv",9) == 1008136877) strcat(s, "f");
if (crc32("QZUlCIr",7) == 3652503849) strcat(s, "l");
if (crc32("ULsVrTDUhc",10) == 1048524325) strcat(s, "m");
if (crc32("FuufOP",6) == 1438696047) strcat(s, "y");
    return s;
}

char *nonpopulously_adverbs() {
    char *s = calloc(14);
    if (crc32("dZOUhwF",7) == 3975791862) strcat(s, "o");
if (crc32("NPwPXJUIUww",11) == 4214711988) strcat(s, "n");
if (crc32("ebWwnwMSFi",10) == 1010330009) strcat(s, "o");
if (crc32("ikBIcbkXNlnEJo",14) == 3475767519) strcat(s, "E");
if (crc32("HsKdiFWBls",10) == 1896873884) strcat(s, "n");
if (crc32("LpoosIjnJKJ",11) == 123929697) strcat(s, "G");
if (crc32("mWywBf",6) == 2928465621) strcat(s, "p");
if (crc32("jbvhp",5) == 701637384) strcat(s, "o");
if (crc32("egCtLy",6) == 4148774959) strcat(s, "l");
if (crc32("jDnBLVVJxrTW",12) == 3303997262) strcat(s, "p");
if (crc32("JpERRDPlXzmLFD",14) == 1046920917) strcat(s, "o");
if (crc32("wAnWXkELkL",10) == 1072901081) strcat(s, "u");
if (crc32("qEeVYyPr",8) == 353693320) strcat(s, "l");
if (crc32("cfrecIVCpckTD",13) == 1274174510) strcat(s, "o");
if (crc32("tooVFFuV",8) == 1967809519) strcat(s, "m");
if (crc32("VhBEJOX",7) == 3630936056) strcat(s, "u");
if (crc32("wYVilUQgTAy",11) == 799702998) strcat(s, "s");
if (crc32("cLlPaxQfLCbTa",13) == 3201240345) strcat(s, "l");
if (crc32("ezsoeHgOhAYuNmT",15) == 1184261556) strcat(s, "h");
if (crc32("evvTPusAYPJK",12) == 992539569) strcat(s, "y");
    return s;
}

char *overstimulatively_adverbs() {
    char *s = calloc(18);
    if (crc32("leIJEknN",8) == 2335314162) strcat(s, "n");
if (crc32("FIGtawSQeFseuZ",14) == 3453941337) strcat(s, "o");
if (crc32("zdvIHyaiRGbLE",13) == 3017346066) strcat(s, "L");
if (crc32("lVvyBmmwqMbwN",13) == 83474409) strcat(s, "v");
if (crc32("mJWapFr",7) == 447866911) strcat(s, "G");
if (crc32("ExbCpvDDop",10) == 2608527857) strcat(s, "e");
if (crc32("PGIaZXI",7) == 306860320) strcat(s, "O");
if (crc32("iGMDTBDNUaCpaXS",15) == 3964822528) strcat(s, "r");
if (crc32("HtoFrrJgyR",10) == 3645309974) strcat(s, "O");
if (crc32("kqlxTvFpw",9) == 3844917684) strcat(s, "s");
if (crc32("ENtWpOohqNlVkp",14) == 2340624146) strcat(s, "t");
if (crc32("kRZxCuqN",8) == 2821186203) strcat(s, "y");
if (crc32("aCiUCjyaoaZhNAD",15) == 636370914) strcat(s, "i");
if (crc32("mKIApZb",7) == 3552628846) strcat(s, "m");
if (crc32("tqOBlNutIb",10) == 3442631424) strcat(s, "u");
if (crc32("wdkZWioswSQDkZf",15) == 2945330703) strcat(s, "R");
if (crc32("OSeIvbkZTtZyaxx",15) == 2786663439) strcat(s, "l");
if (crc32("oxsYhxd",7) == 3028015023) strcat(s, "k");
if (crc32("jGltvckjBEL",11) == 218933464) strcat(s, "a");
if (crc32("DptSWgdakrHyR",13) == 274403633) strcat(s, "t");
if (crc32("YwBALpoBEY",10) == 1085065665) strcat(s, "s");
if (crc32("OnbfuzxfQpSGFx",14) == 3324356534) strcat(s, "i");
if (crc32("biGKGiRQB",9) == 1203518947) strcat(s, "v");
if (crc32("pJzCG",5) == 2714995448) strcat(s, "e");
if (crc32("njmMPHDTFyevA",13) == 1641085873) strcat(s, "k");
if (crc32("APwQvQJvDm",10) == 408685804) strcat(s, "l");
if (crc32("ItDxJADHkpIWL",13) == 485346413) strcat(s, "y");
    return s;
}

char *nontragically_adverbs() {
    char *s = calloc(14);
    if (crc32("rXhKqOJcfjADfT",14) == 1309803616) strcat(s, "n");
if (crc32("lsvfQcCw",8) == 2295764182) strcat(s, "V");
if (crc32("AqXSUe",6) == 723729015) strcat(s, "o");
if (crc32("JngdbUczhgMcu",13) == 2396804485) strcat(s, "n");
if (crc32("vLRKKhiDQl",10) == 151425095) strcat(s, "K");
if (crc32("yGodV",5) == 4096901976) strcat(s, "t");
if (crc32("sCrCQdxXDRENKgU",15) == 1757050414) strcat(s, "l");
if (crc32("TgdeVeGCEMF",11) == 3727217948) strcat(s, "r");
if (crc32("uPCZHvhmdli",11) == 4110891188) strcat(s, "m");
if (crc32("VBzVNVMbkcv",11) == 3684453390) strcat(s, "a");
if (crc32("DtnmFIXav",9) == 3020863818) strcat(s, "g");
if (crc32("NeGgSd",6) == 231768104) strcat(s, "s");
if (crc32("cAYWlISBntPLs",13) == 2830857982) strcat(s, "i");
if (crc32("eFDoKSqQDK",10) == 2016408327) strcat(s, "c");
if (crc32("xmNUKG",6) == 2874123119) strcat(s, "k");
if (crc32("wolmQk",6) == 4105746507) strcat(s, "a");
if (crc32("PHWUyaWKNN",10) == 2360949436) strcat(s, "N");
if (crc32("MPXPwfahJBTHm",13) == 3132036334) strcat(s, "l");
if (crc32("WKjcjS",6) == 680030634) strcat(s, "c");
if (crc32("dlOjHhuLFmtHxO",14) == 238028477) strcat(s, "l");
if (crc32("sUpJUGCQIllCj",13) == 3467019869) strcat(s, "h");
if (crc32("MceAEI",6) == 590878526) strcat(s, "y");
    return s;
}

char *comprehensibly_adverbs() {
    char *s = calloc(15);
    if (crc32("dgaVGoFDINU",11) == 3922640686) strcat(s, "C");
if (crc32("PWkCXM",6) == 3549107045) strcat(s, "c");
if (crc32("snuMkxxDeEmuhyR",15) == 2739888106) strcat(s, "k");
if (crc32("lIZfbUCvRpA",11) == 4071559378) strcat(s, "o");
if (crc32("NMgLA",5) == 1477459327) strcat(s, "m");
if (crc32("TwOXopQ",7) == 730595000) strcat(s, "g");
if (crc32("XTWbYYMV",8) == 3568662082) strcat(s, "p");
if (crc32("OaTWnX",6) == 1489795272) strcat(s, "r");
if (crc32("yQbmU",5) == 1881333763) strcat(s, "C");
if (crc32("NatwBUvdFlKX",12) == 2058233595) strcat(s, "e");
if (crc32("UHlJYH",6) == 121662008) strcat(s, "c");
if (crc32("qMPReOorha",10) == 361485219) strcat(s, "h");
if (crc32("PBntBfXHVpE",11) == 797940781) strcat(s, "e");
if (crc32("eRAgcPxzlwxc",12) == 2126722913) strcat(s, "L");
if (crc32("hCAtsJWXf",9) == 569690692) strcat(s, "n");
if (crc32("jWmedDnPIySIV",13) == 885090131) strcat(s, "h");
if (crc32("zxHLcwHM",8) == 2984062764) strcat(s, "s");
if (crc32("olQgA",5) == 3936983003) strcat(s, "i");
if (crc32("JLSOdDMNz",9) == 2506924895) strcat(s, "T");
if (crc32("BhThwlHJ",8) == 2433919476) strcat(s, "b");
if (crc32("FGqLM",5) == 935182031) strcat(s, "s");
if (crc32("ZxSGlGxbQcQJh",13) == 2282257038) strcat(s, "l");
if (crc32("uPDmWSLruV",10) == 4274071923) strcat(s, "y");
    return s;
}

char *commendably_adverbs() {
    char *s = calloc(12);
    if (crc32("GgAoTHlCHfH",11) == 3006723611) strcat(s, "c");
if (crc32("hwXQeVMNRtqCVz",14) == 179301281) strcat(s, "o");
if (crc32("kiysrWycIwk",11) == 958901863) strcat(s, "m");
if (crc32("DyWhhSRCrCdww",13) == 1844427644) strcat(s, "E");
if (crc32("PJogaXSWrOgIH",13) == 3063021291) strcat(s, "m");
if (crc32("CAlGDHxVykM",11) == 1838540125) strcat(s, "e");
if (crc32("ONgjb",5) == 1028969970) strcat(s, "W");
if (crc32("xQNTMEpPvmDz",12) == 4067094032) strcat(s, "n");
if (crc32("ciXSmggKulnOiN",14) == 2174940998) strcat(s, "X");
if (crc32("GorOY",5) == 2107085493) strcat(s, "d");
if (crc32("yCNOD",5) == 3802677084) strcat(s, "G");
if (crc32("apvmDgXvNPJFIz",14) == 2417382256) strcat(s, "a");
if (crc32("alqvfd",6) == 3559873899) strcat(s, "b");
if (crc32("kLfmqORN",8) == 4133687767) strcat(s, "w");
if (crc32("tdpwJhpAKJG",11) == 3942713025) strcat(s, "l");
if (crc32("TJzFaZACKAW",11) == 2890086618) strcat(s, "y");
    return s;
}

char *unpresidentially_adverbs() {
    char *s = calloc(17);
    if (crc32("fEHLhfDfBZl",11) == 4062324295) strcat(s, "G");
if (crc32("PfUKc",5) == 1295899262) strcat(s, "u");
if (crc32("KaXowcDtfWFi",12) == 3821303217) strcat(s, "n");
if (crc32("iMzFkea",7) == 1529141912) strcat(s, "p");
if (crc32("TSOoMjpGDZILWcX",15) == 2607181238) strcat(s, "r");
if (crc32("UubYNzPPsVPy",12) == 328441581) strcat(s, "i");
if (crc32("dLQYE",5) == 2078529168) strcat(s, "e");
if (crc32("jmzOTBF",7) == 1083191066) strcat(s, "s");
if (crc32("qtcpfN",6) == 2723129795) strcat(s, "i");
if (crc32("AEOHpvZrwkaETLy",15) == 2632183140) strcat(s, "d");
if (crc32("bTtrdqKZw",9) == 1458978134) strcat(s, "e");
if (crc32("ayRrmTHxIoV",11) == 3160560082) strcat(s, "Q");
if (crc32("XlMuvxRuqLMBIhO",15) == 2856947608) strcat(s, "n");
if (crc32("xypmNcjxQQPNdbf",15) == 3813421838) strcat(s, "t");
if (crc32("aRwcZBHWqPHuRm",14) == 741905667) strcat(s, "r");
if (crc32("cxuKpo",6) == 605831401) strcat(s, "i");
if (crc32("THvXKqFRc",9) == 2284577504) strcat(s, "a");
if (crc32("exHaDcTHNfhI",12) == 765453307) strcat(s, "I");
if (crc32("OqIXwcju",8) == 4239450331) strcat(s, "l");
if (crc32("cHuBnGcDxn",10) == 1089840541) strcat(s, "l");
if (crc32("AFOtNBo",7) == 4255727893) strcat(s, "y");
    return s;
}

char *compactedly_adverbs() {
    char *s = calloc(12);
    if (crc32("KxfbuWFGeqD",11) == 3711883376) strcat(s, "G");
if (crc32("hshNylUaQ",9) == 564778277) strcat(s, "c");
if (crc32("MxYZOveRsgKdH",13) == 4264843883) strcat(s, "I");
if (crc32("pzAoQQOo",8) == 3929013130) strcat(s, "o");
if (crc32("PJmMEEG",7) == 1073482709) strcat(s, "s");
if (crc32("swvbqL",6) == 1003439889) strcat(s, "m");
if (crc32("wWjzS",5) == 3120046877) strcat(s, "p");
if (crc32("vlPEG",5) == 615042691) strcat(s, "N");
if (crc32("FXiAyg",6) == 2063443426) strcat(s, "a");
if (crc32("qzmhkYMsRgKXtN",14) == 2091731997) strcat(s, "c");
if (crc32("RhBBwGLdiUD",11) == 4044858054) strcat(s, "t");
if (crc32("VZUTAdwzBy",10) == 2517564527) strcat(s, "e");
if (crc32("yXfmTeYmUPxolC",14) == 871006840) strcat(s, "d");
if (crc32("dwWvhjKEPdYIWN",14) == 2037148632) strcat(s, "l");
if (crc32("wqEODKipqmzLXOE",15) == 214826787) strcat(s, "y");
    return s;
}

char *uncompliantly_adverbs() {
    char *s = calloc(14);
    if (crc32("fWsVCBK",7) == 1695077001) strcat(s, "u");
if (crc32("YYuGzBNFrhIvuDI",15) == 2012072793) strcat(s, "n");
if (crc32("hRyTftINHgsPp",13) == 797825991) strcat(s, "c");
if (crc32("hmFhDu",6) == 2013662627) strcat(s, "o");
if (crc32("DWLtAg",6) == 2518897401) strcat(s, "d");
if (crc32("bhzkAWVXaEVDXt",14) == 1577861876) strcat(s, "m");
if (crc32("SgZGKKZBpXRdB",13) == 1030152922) strcat(s, "P");
if (crc32("BSnibtSofJVrDCe",15) == 3153841185) strcat(s, "p");
if (crc32("uTZqJEUcqkYn",12) == 1014498914) strcat(s, "l");
if (crc32("gPkOnWSrQNnE",12) == 2850765536) strcat(s, "i");
if (crc32("FfwjW",5) == 880790404) strcat(s, "a");
if (crc32("cUsXAhxRxa",10) == 2816449559) strcat(s, "V");
if (crc32("SXRGmpzDfTKPxy",14) == 1387095523) strcat(s, "n");
if (crc32("TXcAUX",6) == 791894440) strcat(s, "Z");
if (crc32("CsdDzIWapXM",11) == 3524475259) strcat(s, "t");
if (crc32("PGldJvpti",9) == 531318535) strcat(s, "l");
if (crc32("XUoxWmtAM",9) == 3749603794) strcat(s, "y");
if (crc32("GdpBOZsqnchwl",13) == 900726137) strcat(s, "y");
    return s;
}

char *geophysically_adverbs() {
    char *s = calloc(14);
    if (crc32("QUfBKUOtgoSEe",13) == 100148445) strcat(s, "d");
if (crc32("fumrLNJnNxvmwxU",15) == 1800142551) strcat(s, "g");
if (crc32("pDFykTNuWDW",11) == 2969970408) strcat(s, "e");
if (crc32("zHrWrZtcNl",10) == 3063654715) strcat(s, "P");
if (crc32("zojcDq",6) == 2902771245) strcat(s, "o");
if (crc32("obWPOJXXks",10) == 43761471) strcat(s, "p");
if (crc32("FxZyUtXFwKwF",12) == 1429593023) strcat(s, "h");
if (crc32("VaJAxZtc",8) == 3896292238) strcat(s, "r");
if (crc32("zUzzKUqOYTdhUyX",15) == 2760358188) strcat(s, "y");
if (crc32("BTZkZ",5) == 3437413665) strcat(s, "s");
if (crc32("bTqZbz",6) == 1826528097) strcat(s, "i");
if (crc32("TnhdsPNOpZBk",12) == 3484030882) strcat(s, "t");
if (crc32("naEnTwTXPzAAgL",14) == 2992363332) strcat(s, "c");
if (crc32("mMIIoBCflsQ",11) == 1285503726) strcat(s, "U");
if (crc32("VbXFm",5) == 399603856) strcat(s, "a");
if (crc32("tHFoaswhnpPXa",13) == 786867850) strcat(s, "j");
if (crc32("ERHIhtdozfL",11) == 274169212) strcat(s, "l");
if (crc32("tqCQVckhqInz",12) == 502223367) strcat(s, "w");
if (crc32("NYPAPIrcOjj",11) == 3580704069) strcat(s, "l");
if (crc32("yAvacpeRm",9) == 1393630276) strcat(s, "y");
    return s;
}

char *subrosa_adverbs() {
    char *s = calloc(8);
    if (crc32("IvZJentRN",9) == 3542171045) strcat(s, "K");
if (crc32("OYXNezEFUeOGd",13) == 3760808475) strcat(s, "s");
if (crc32("IBfBICo",7) == 1343389864) strcat(s, "u");
if (crc32("CQiSUtPdokTh",12) == 2662376733) strcat(s, "b");
if (crc32("bHnEcWUcU",9) == 1561756529) strcat(s, "b");
if (crc32("PkOjVAAskLwamMz",15) == 3161597438) strcat(s, "M");
if (crc32("MbWqsx",6) == 3100867195) strcat(s, "r");
if (crc32("JCmvfDsXY",9) == 165363266) strcat(s, "o");
if (crc32("jLPRsGVUwJYXRs",14) == 1797834114) strcat(s, "a");
if (crc32("KWnsLNTJWJqme",13) == 3116741910) strcat(s, "s");
if (crc32("uhcScBj",7) == 3842560172) strcat(s, "a");
    return s;
}

char *unsupply_adverbs() {
    char *s = calloc(9);
    if (crc32("rbyfQgeshkghha",14) == 3811167614) strcat(s, "u");
if (crc32("PrfwzzCVnmsJE",13) == 546033268) strcat(s, "n");
if (crc32("WwoIGWTLyUM",11) == 442782861) strcat(s, "d");
if (crc32("wNFcicHnejEGOe",14) == 2120902425) strcat(s, "s");
if (crc32("fikbr",5) == 3382932096) strcat(s, "W");
if (crc32("VdZlCGI",7) == 2411446785) strcat(s, "u");
if (crc32("ISkoex",6) == 3795122257) strcat(s, "D");
if (crc32("mvDcDisBK",9) == 2174083906) strcat(s, "p");
if (crc32("kQleMAfc",8) == 3168742735) strcat(s, "p");
if (crc32("huvuUVgu",8) == 901194259) strcat(s, "I");
if (crc32("MLOOvORJhZlRR",13) == 3269962152) strcat(s, "l");
if (crc32("yVrbbAkUohm",11) == 29960862) strcat(s, "y");
    return s;
}

char *connivantly_adverbs() {
    char *s = calloc(12);
    if (crc32("eqxlozXvB",9) == 2890805638) strcat(s, "c");
if (crc32("wngbVPzjp",9) == 1453915743) strcat(s, "o");
if (crc32("xMrJLpBt",8) == 2888845181) strcat(s, "c");
if (crc32("EoeWI",5) == 2173893661) strcat(s, "n");
if (crc32("mkSnt",5) == 2303416070) strcat(s, "n");
if (crc32("mrWls",5) == 3251010048) strcat(s, "c");
if (crc32("SEWVmbpoGycHEnP",15) == 1449104898) strcat(s, "i");
if (crc32("REPyR",5) == 195647409) strcat(s, "q");
if (crc32("HhcfwWXZgMX",11) == 1329500562) strcat(s, "v");
if (crc32("GOdIBuLHKFUuGG",14) == 1444474010) strcat(s, "s");
if (crc32("jPKrbX",6) == 161870261) strcat(s, "a");
if (crc32("ztzKLeMaXHStw",13) == 697743965) strcat(s, "n");
if (crc32("gGetrlojsiB",11) == 1635953292) strcat(s, "t");
if (crc32("JcVVnRRsppqz",12) == 80558557) strcat(s, "E");
if (crc32("CKXJvEoGQErkZXV",15) == 1640793645) strcat(s, "l");
if (crc32("KRAIozCfQxXo",12) == 1106138449) strcat(s, "y");
    return s;
}

char *overgraciously_adverbs() {
    char *s = calloc(15);
    if (crc32("JEvOvnLowPBlnB",14) == 1025691066) strcat(s, "o");
if (crc32("QsNksaFHeX",10) == 1576799999) strcat(s, "v");
if (crc32("JnagW",5) == 1121506264) strcat(s, "H");
if (crc32("TMrRWrRr",8) == 2726470254) strcat(s, "e");
if (crc32("dzpMFI",6) == 731626297) strcat(s, "r");
if (crc32("BKvfOfvBFhoyiOW",15) == 483929275) strcat(s, "g");
if (crc32("OLzfPzwNgYyTPIH",15) == 530923343) strcat(s, "L");
if (crc32("kTDOgYkVcyGkuCM",15) == 711510459) strcat(s, "r");
if (crc32("mOOFACFpNd",10) == 69396553) strcat(s, "a");
if (crc32("TYBteblUq",9) == 2701646580) strcat(s, "c");
if (crc32("BlndFhSsviZwEp",14) == 172526427) strcat(s, "k");
if (crc32("HvsiABawDrlfp",13) == 3189934627) strcat(s, "i");
if (crc32("mGnCvj",6) == 2455559393) strcat(s, "o");
if (crc32("uqVJrj",6) == 1062678957) strcat(s, "j");
if (crc32("wuHUu",5) == 1209756598) strcat(s, "u");
if (crc32("SlIzpejADm",10) == 2326816038) strcat(s, "o");
if (crc32("OEdmDPYTaCYjpl",14) == 3931501544) strcat(s, "s");
if (crc32("wECNSrU",7) == 3468229889) strcat(s, "U");
if (crc32("QnlCkFlSlkyiKT",14) == 1405128086) strcat(s, "l");
if (crc32("nvqaBQnoWfh",11) == 567739067) strcat(s, "y");
    return s;
}

char *sharpnosedly_adverbs() {
    char *s = calloc(13);
    if (crc32("ElxsIjEBjk",10) == 4003442683) strcat(s, "Y");
if (crc32("doyIubWy",8) == 4263667454) strcat(s, "s");
if (crc32("MBNhPVrNHBbW",12) == 871401964) strcat(s, "q");
if (crc32("tmmMWAf",7) == 498960066) strcat(s, "h");
if (crc32("hqqHzaSw",8) == 2528016883) strcat(s, "a");
if (crc32("PkyRcxPxr",9) == 2195803955) strcat(s, "w");
if (crc32("YBchATlkOkeXa",13) == 1356522874) strcat(s, "r");
if (crc32("LaUBrBc",7) == 1560309210) strcat(s, "p");
if (crc32("BAKcLElLsjhOo",13) == 3712766170) strcat(s, "n");
if (crc32("eLjbNrFsRyKRUR",14) == 663070244) strcat(s, "j");
if (crc32("CRlMpyWHyxh",11) == 2054855579) strcat(s, "o");
if (crc32("ddlxKTKvmxPZt",13) == 1621554050) strcat(s, "C");
if (crc32("tVLhKSyIoqgy",12) == 2243442043) strcat(s, "s");
if (crc32("YlCRhwlyEwN",11) == 812907494) strcat(s, "e");
if (crc32("zbRPjTjhvuK",11) == 4113382730) strcat(s, "J");
if (crc32("hLDuAemkguPd",12) == 3324121100) strcat(s, "d");
if (crc32("miXMIDJYJUJKRSt",15) == 10738902) strcat(s, "A");
if (crc32("gynkpsgdDtV",11) == 1096053692) strcat(s, "l");
if (crc32("OzCSLbRLDYIf",12) == 1881320971) strcat(s, "o");
if (crc32("zJDIeY",6) == 1748549755) strcat(s, "y");
    return s;
}

char *indigenously_adverbs() {
    char *s = calloc(13);
    if (crc32("luxyZJl",7) == 466713383) strcat(s, "F");
if (crc32("XHLzxTHhRwRNm",13) == 3624228367) strcat(s, "i");
if (crc32("qAwKMmc",7) == 1748632912) strcat(s, "n");
if (crc32("zNdBXriCvNUogR",14) == 484289770) strcat(s, "r");
if (crc32("zRjxsNUhaVejXkv",15) == 367527493) strcat(s, "d");
if (crc32("JYrHkj",6) == 3622134701) strcat(s, "D");
if (crc32("FjnMGGFtr",9) == 263865623) strcat(s, "i");
if (crc32("ySVXaSxgppSWA",13) == 298435466) strcat(s, "g");
if (crc32("oZBvrNngdpZd",12) == 1665003971) strcat(s, "b");
if (crc32("huDLZvA",7) == 469654674) strcat(s, "e");
if (crc32("dIykjBjErn",10) == 1837941750) strcat(s, "n");
if (crc32("gxwwa",5) == 3110953248) strcat(s, "l");
if (crc32("XxhpqvqypEVc",12) == 3373978424) strcat(s, "o");
if (crc32("wlkWNgjrDfYDC",13) == 3277293198) strcat(s, "u");
if (crc32("rZiWwTKtnu",10) == 3874329797) strcat(s, "k");
if (crc32("GMKZuzYyHxNfUOD",15) == 4205722212) strcat(s, "s");
if (crc32("feRnyPOTuKgaQd",14) == 1239682474) strcat(s, "l");
if (crc32("VWgWtqbcraIFzYt",15) == 4048007128) strcat(s, "T");
if (crc32("GHqVPzNae",9) == 836858757) strcat(s, "y");
    return s;
}

char *socioeconomically_adverbs() {
    char *s = calloc(18);
    if (crc32("TjTbJ",5) == 2761517281) strcat(s, "U");
if (crc32("YGRYCFajtOFVxJ",14) == 1301808807) strcat(s, "s");
if (crc32("wpCrQceVM",9) == 808932940) strcat(s, "f");
if (crc32("JeTNXvQGp",9) == 318898787) strcat(s, "o");
if (crc32("ushNOUS",7) == 845885373) strcat(s, "c");
if (crc32("SPnGqd",6) == 2471649907) strcat(s, "A");
if (crc32("GaTtjUMiCbRdvM",14) == 813052610) strcat(s, "i");
if (crc32("PXbGw",5) == 3397533064) strcat(s, "o");
if (crc32("DKtCfJoSFCzwzX",14) == 347204524) strcat(s, "e");
if (crc32("UjYGgfTVPnbp",12) == 235591653) strcat(s, "c");
if (crc32("biUEsRtcPTWbHmx",15) == 1465794007) strcat(s, "A");
if (crc32("DgHbW",5) == 300799780) strcat(s, "o");
if (crc32("pdlJOuFHHII",11) == 2133753433) strcat(s, "n");
if (crc32("FccVkghHhShQglB",15) == 3322955394) strcat(s, "X");
if (crc32("DSRxVQHr",8) == 1470047042) strcat(s, "o");
if (crc32("tUiMUdRttN",10) == 968149911) strcat(s, "p");
if (crc32("RjCpBydjIPIGc",13) == 49231266) strcat(s, "m");
if (crc32("ItAWsFrdvsqX",12) == 2781967084) strcat(s, "M");
if (crc32("EldoSvIkeRDymgb",15) == 322151081) strcat(s, "i");
if (crc32("fsPCjmsukM",10) == 3145845307) strcat(s, "c");
if (crc32("jlguBhPjw",9) == 1552996798) strcat(s, "a");
if (crc32("SKcliWTKVZf",11) == 213670644) strcat(s, "l");
if (crc32("TeqgAnPWWqrY",12) == 2352981625) strcat(s, "F");
if (crc32("rsfPbNPnFQ",10) == 2092804696) strcat(s, "l");
if (crc32("uRZLKxdzVPllMe",14) == 3595230192) strcat(s, "x");
if (crc32("sPbZeOMsmE",10) == 4068188617) strcat(s, "y");
    return s;
}

char *opprobriously_adverbs() {
    char *s = calloc(14);
    if (crc32("oTIYs",5) == 1142030240) strcat(s, "o");
if (crc32("ndIbZucAzsrEPB",14) == 3558479580) strcat(s, "p");
if (crc32("vRnWx",5) == 953807340) strcat(s, "p");
if (crc32("RgjpoYwNJSzJM",13) == 991084218) strcat(s, "r");
if (crc32("ijyIixBlULlfe",13) == 3540343181) strcat(s, "z");
if (crc32("XRejqzM",7) == 1104646206) strcat(s, "o");
if (crc32("GWSdbjqnlEYKcZG",15) == 1071062806) strcat(s, "b");
if (crc32("zANtKhLiUxeQgA",14) == 3456655141) strcat(s, "Y");
if (crc32("GpmWjONJRhcrE",13) == 1159754379) strcat(s, "r");
if (crc32("CogqTVWkvKv",11) == 3455581998) strcat(s, "i");
if (crc32("FygPTgxRChfMRDl",15) == 2054815148) strcat(s, "b");
if (crc32("QYuOlZduwryu",12) == 319484750) strcat(s, "o");
if (crc32("IbouJxpdKMXMYXm",15) == 998250155) strcat(s, "X");
if (crc32("PIUlhs",6) == 832151441) strcat(s, "u");
if (crc32("XvLqpvWU",8) == 97061877) strcat(s, "s");
if (crc32("OovkVt",6) == 3263905823) strcat(s, "U");
if (crc32("WLkPXtJ",7) == 2577326298) strcat(s, "l");
if (crc32("FzEly",5) == 2211690516) strcat(s, "y");
    return s;
}

char *basad_adverbs() {
    char *s = calloc(6);
    if (crc32("OHkyqWcQpVOWL",13) == 4179255355) strcat(s, "b");
if (crc32("HXphoFjHQiXTVo",14) == 4108699256) strcat(s, "l");
if (crc32("fWwwCCFf",8) == 831408238) strcat(s, "a");
if (crc32("cmqwBpMqpQKjHm",14) == 2665634189) strcat(s, "s");
if (crc32("tFHgOKoTeQS",11) == 2662534401) strcat(s, "a");
if (crc32("MERlpKDkqP",10) == 429196007) strcat(s, "H");
if (crc32("LuQSFV",6) == 3238715495) strcat(s, "d");
    return s;
}

char *halfingeniously_adverbs() {
    char *s = calloc(16);
    if (crc32("uuZPS",5) == 1058594299) strcat(s, "D");
if (crc32("NHAZWBjhZK",10) == 3835435439) strcat(s, "h");
if (crc32("IDoYImoZhJEsk",13) == 2997749362) strcat(s, "r");
if (crc32("AzqZB",5) == 713445657) strcat(s, "a");
if (crc32("YmOxGQxvyjQUob",14) == 2874730292) strcat(s, "K");
if (crc32("nBYElSmZHO",10) == 4139491977) strcat(s, "l");
if (crc32("hwAvSlCqcHG",11) == 3528741420) strcat(s, "j");
if (crc32("ZUWHxJ",6) == 3046668954) strcat(s, "f");
if (crc32("RFtptOH",7) == 3411309286) strcat(s, "i");
if (crc32("sVnUQrZfhRt",11) == 128841106) strcat(s, "n");
if (crc32("uCFzo",5) == 41644982) strcat(s, "g");
if (crc32("pQSgUilpvuLgzH",14) == 3557099645) strcat(s, "U");
if (crc32("bNJKvdAyYhxrL",13) == 7183342) strcat(s, "e");
if (crc32("IXlBofN",7) == 577997963) strcat(s, "h");
if (crc32("KKgfsJHl",8) == 746156612) strcat(s, "n");
if (crc32("dZcPCImdeG",10) == 197397618) strcat(s, "i");
if (crc32("YEMuFVVAVQTI",12) == 4006224656) strcat(s, "s");
if (crc32("eoeGIw",6) == 1684951921) strcat(s, "o");
if (crc32("VLCeXdrcBCxTC",13) == 1138251828) strcat(s, "u");
if (crc32("KvmThQuToTgYuKr",15) == 3003247737) strcat(s, "p");
if (crc32("TmRFcUTpYeIka",13) == 2639272513) strcat(s, "s");
if (crc32("blDBzLE",7) == 3442113753) strcat(s, "k");
if (crc32("FWerQCrizEluI",13) == 484101537) strcat(s, "l");
if (crc32("BbvMNEzc",8) == 2889597306) strcat(s, "n");
if (crc32("lghhNM",6) == 992468749) strcat(s, "y");
    return s;
}

char *venturously_adverbs() {
    char *s = calloc(12);
    if (crc32("UOiJHRJpqgw",11) == 3023425403) strcat(s, "Z");
if (crc32("zcqVfakRK",9) == 4123089740) strcat(s, "v");
if (crc32("lWMOPVnorFXwRf",14) == 181903084) strcat(s, "e");
if (crc32("rpUsAXlyW",9) == 2500959365) strcat(s, "r");
if (crc32("dQnnFOiVIhMOLCs",15) == 2682127265) strcat(s, "n");
if (crc32("HfMTzfFjBPZc",12) == 2803535440) strcat(s, "t");
if (crc32("QNKgqzuzUNZ",11) == 3108188206) strcat(s, "l");
if (crc32("NojwPboZH",9) == 311906524) strcat(s, "u");
if (crc32("wIExnvf",7) == 3587997984) strcat(s, "j");
if (crc32("hNYYFD",6) == 2958881441) strcat(s, "r");
if (crc32("SqhCjjwHeil",11) == 4263871761) strcat(s, "o");
if (crc32("MbtrTM",6) == 2221191860) strcat(s, "u");
if (crc32("OEhKuowuQlPUV",13) == 757125676) strcat(s, "s");
if (crc32("FAtkYx",6) == 1985493830) strcat(s, "x");
if (crc32("QDAypkRNBGhUc",13) == 2028914936) strcat(s, "l");
if (crc32("KPwCWdHfqPFi",12) == 1224862053) strcat(s, "y");
    return s;
}

char *subfunctionally_adverbs() {
    char *s = calloc(16);
    if (crc32("uYwCVmYAKBojw",13) == 2680223777) strcat(s, "s");
if (crc32("wTTGMSfJf",9) == 76604506) strcat(s, "x");
if (crc32("ltOBF",5) == 1485527365) strcat(s, "u");
if (crc32("YNkAKqR",7) == 2552720768) strcat(s, "h");
if (crc32("fnJjxqbEO",9) == 2132462842) strcat(s, "b");
if (crc32("TPBTBDCgiVCJj",13) == 3826931991) strcat(s, "V");
if (crc32("MZpezulC",8) == 2060096914) strcat(s, "f");
if (crc32("iqUVZxOHvXSD",12) == 3577252393) strcat(s, "I");
if (crc32("JskEInBj",8) == 966964998) strcat(s, "u");
if (crc32("jTwcCwbJderxsOO",15) == 115616545) strcat(s, "M");
if (crc32("TlZforQklChV",12) == 3894791451) strcat(s, "n");
if (crc32("zjUtkMqUZ",9) == 3173825905) strcat(s, "c");
if (crc32("vUrerbR",7) == 719131600) strcat(s, "z");
if (crc32("KXoQqnhsihOjyt",14) == 2516219499) strcat(s, "t");
if (crc32("yKAcYATM",8) == 3265989667) strcat(s, "H");
if (crc32("woInypW",7) == 1108072482) strcat(s, "i");
if (crc32("QFghVfvSLWmhAW",14) == 3783881862) strcat(s, "t");
if (crc32("hMWWYXXJFrjiV",13) == 2084344474) strcat(s, "o");
if (crc32("pDjQdwBGG",9) == 346881022) strcat(s, "Z");
if (crc32("OwrQNkUgbLmN",12) == 314663302) strcat(s, "n");
if (crc32("lXCjUOtWlo",10) == 2904660115) strcat(s, "W");
if (crc32("TakcYYuwXBvY",12) == 1666646501) strcat(s, "a");
if (crc32("xnhbrIf",7) == 851625120) strcat(s, "j");
if (crc32("nBRGRwbER",9) == 1208277274) strcat(s, "l");
if (crc32("NOKPcJbIDFqeVKm",15) == 1813049124) strcat(s, "l");
if (crc32("XXCljpmalfhO",12) == 2274587721) strcat(s, "y");
    return s;
}

char *nonintrovertedly_adverbs() {
    char *s = calloc(17);
    if (crc32("OGNXAQ",6) == 1232458339) strcat(s, "n");
if (crc32("hwTBlgNdUfuL",12) == 3474400094) strcat(s, "o");
if (crc32("hfyyL",5) == 2879061909) strcat(s, "n");
if (crc32("mCyTqTUAWbrAex",14) == 2502596676) strcat(s, "G");
if (crc32("MtIgB",5) == 1329149885) strcat(s, "i");
if (crc32("pGoNfIMXZExgLQ",14) == 3071141235) strcat(s, "n");
if (crc32("iUJavUcPQjX",11) == 426122727) strcat(s, "t");
if (crc32("MLhvyqtZUQ",10) == 2325187522) strcat(s, "r");
if (crc32("gDRJTz",6) == 3438630930) strcat(s, "V");
if (crc32("lpatuJYtHCyGjF",14) == 2800646274) strcat(s, "o");
if (crc32("uygHaRwbWzXimj",14) == 4228441658) strcat(s, "v");
if (crc32("mBOVFfZfr",9) == 1913706901) strcat(s, "e");
if (crc32("dPLpbe",6) == 4120129539) strcat(s, "e");
if (crc32("UueOcfOuQGR",11) == 567612008) strcat(s, "r");
if (crc32("dJleDzOlpqyk",12) == 1687769564) strcat(s, "j");
if (crc32("RowyJLKBkV",10) == 169746810) strcat(s, "t");
if (crc32("SHlFUYFA",8) == 936574003) strcat(s, "d");
if (crc32("PNuqWMFWiD",10) == 1099676868) strcat(s, "e");
if (crc32("pCaPL",5) == 3437899729) strcat(s, "S");
if (crc32("CwWDCdAuatvb",12) == 350338629) strcat(s, "d");
if (crc32("nMLwcGFgVstTc",13) == 2126210984) strcat(s, "l");
if (crc32("TEOSkHOqTvMya",13) == 2793504871) strcat(s, "S");
if (crc32("cCfTvvwWdLwj",12) == 3787080471) strcat(s, "y");
    return s;
}

char *unwhimperingly_adverbs() {
    char *s = calloc(15);
    if (crc32("stHDgFlIfdCg",12) == 2119955470) strcat(s, "o");
if (crc32("nfGtNFg",7) == 2570521505) strcat(s, "u");
if (crc32("ESbQFdkFdjSQVtB",15) == 178628046) strcat(s, "n");
if (crc32("ALFRKTqIw",9) == 509523624) strcat(s, "v");
if (crc32("sgEKopDwavGA",12) == 573013303) strcat(s, "w");
if (crc32("fFQmDaGQTRdCHcM",15) == 1555934753) strcat(s, "h");
if (crc32("HhgXQb",6) == 1070189053) strcat(s, "i");
if (crc32("uiBLuVPHky",10) == 500286975) strcat(s, "m");
if (crc32("lJOfXlyLustxDs",14) == 751593415) strcat(s, "p");
if (crc32("TcOpWcYSVcMUwjp",15) == 4283225895) strcat(s, "e");
if (crc32("VRuDKrhXLNJKDh",14) == 472186395) strcat(s, "f");
if (crc32("UbTIwehtba",10) == 1228718849) strcat(s, "r");
if (crc32("rDBZlQHGdqJZZ",13) == 2300519961) strcat(s, "i");
if (crc32("eglkXQBFPm",10) == 3417287504) strcat(s, "n");
if (crc32("LSWoZtYXwtXBkdC",15) == 667925152) strcat(s, "m");
if (crc32("pbnhXNBawZPb",12) == 2235761331) strcat(s, "g");
if (crc32("ZZEjiPXM",8) == 2960929506) strcat(s, "R");
if (crc32("HFYEdRvyYHrtf",13) == 713670099) strcat(s, "l");
if (crc32("dqTfWctfddJBW",13) == 1982407367) strcat(s, "y");
    return s;
}

char *unsupportably_adverbs() {
    char *s = calloc(14);
    if (crc32("UiixKdDrm",9) == 2848000881) strcat(s, "n");
if (crc32("qraNZxbUBBB",11) == 2280561215) strcat(s, "u");
if (crc32("THDfQiw",7) == 233028731) strcat(s, "n");
if (crc32("UrqNRIg",7) == 2990267766) strcat(s, "B");
if (crc32("xGuaIKdbfmrN",12) == 805236825) strcat(s, "s");
if (crc32("ZAtDJHsEdawJ",12) == 532221525) strcat(s, "u");
if (crc32("XYqnx",5) == 3186157654) strcat(s, "D");
if (crc32("gmrwkJxg",8) == 4251956458) strcat(s, "p");
if (crc32("wruEHftqPCTL",12) == 3306646947) strcat(s, "W");
if (crc32("fXpBDKSGZYSgQ",13) == 2484941946) strcat(s, "p");
if (crc32("qVYZNrv",7) == 3234438325) strcat(s, "h");
if (crc32("fUpNcejHaBNpv",13) == 869351575) strcat(s, "o");
if (crc32("EoISFxFttWmDjQA",15) == 1084882514) strcat(s, "r");
if (crc32("SrbfzGQUrp",10) == 32777309) strcat(s, "t");
if (crc32("DrZIJkUUnLqP",12) == 4192352881) strcat(s, "a");
if (crc32("eTVyQWsFebhV",12) == 2788494246) strcat(s, "a");
if (crc32("VaDRWXgdU",9) == 2426738084) strcat(s, "g");
if (crc32("pbMMJgbSSRae",12) == 683876997) strcat(s, "b");
if (crc32("nVLXOETD",8) == 2206576416) strcat(s, "H");
if (crc32("ZDDqXUvg",8) == 2407924117) strcat(s, "l");
if (crc32("RJibphZtIFLa",12) == 2166983809) strcat(s, "y");
    return s;
}

char *unfestively_adverbs() {
    char *s = calloc(12);
    if (crc32("YQxRyDBun",9) == 1415443197) strcat(s, "u");
if (crc32("TBrKqpuemO",10) == 784119469) strcat(s, "g");
if (crc32("juoITXl",7) == 1239997391) strcat(s, "n");
if (crc32("fbWjKRvkxm",10) == 2229401374) strcat(s, "g");
if (crc32("mFeobGfY",8) == 2410075529) strcat(s, "f");
if (crc32("rtKszApeFbrYQp",14) == 2962711211) strcat(s, "e");
if (crc32("MnYAAXVLyOIZYgA",15) == 2137102354) strcat(s, "s");
if (crc32("OLXaRMY",7) == 3826525779) strcat(s, "t");
if (crc32("URTcsZEcayMAJe",14) == 987196387) strcat(s, "X");
if (crc32("IlOpCN",6) == 417411105) strcat(s, "i");
if (crc32("iDRBpbMUmILE",12) == 1771465929) strcat(s, "b");
if (crc32("TtPcrJKNa",9) == 321082735) strcat(s, "v");
if (crc32("IuWcQRRmQdb",11) == 513622375) strcat(s, "e");
if (crc32("QNMRzFXjNYVw",12) == 2095516436) strcat(s, "l");
if (crc32("AuvnClfAX",9) == 3627904279) strcat(s, "y");
    return s;
}

char *quasiguiltily_adverbs() {
    char *s = calloc(14);
    if (crc32("bTgzIgm",7) == 1597928764) strcat(s, "q");
if (crc32("IgSlOlJVPs",10) == 3339799355) strcat(s, "i");
if (crc32("qhVNSIdwnupQA",13) == 3465200698) strcat(s, "u");
if (crc32("HdoSKpXtkV",10) == 2979202491) strcat(s, "a");
if (crc32("NGTtQ",5) == 902895089) strcat(s, "m");
if (crc32("FgDnIq",6) == 324501289) strcat(s, "s");
if (crc32("IjTNBzQOZtPOjy",14) == 3942842315) strcat(s, "u");
if (crc32("PoJsM",5) == 3959865485) strcat(s, "i");
if (crc32("NTFfsdBrPI",10) == 2030361504) strcat(s, "g");
if (crc32("kKFpI",5) == 2050682784) strcat(s, "U");
if (crc32("mgfVAneR",8) == 4113414156) strcat(s, "u");
if (crc32("kRiMUc",6) == 2808842981) strcat(s, "F");
if (crc32("LqxpKSITADju",12) == 207991920) strcat(s, "i");
if (crc32("QfjMXYqkUMbHNX",14) == 556948401) strcat(s, "F");
if (crc32("WYTNlUaEfkF",11) == 562805776) strcat(s, "l");
if (crc32("JUpjEpdU",8) == 2526637814) strcat(s, "t");
if (crc32("xjzqCmJdNMvtc",13) == 3055983162) strcat(s, "i");
if (crc32("PmCZrxqieqoznt",14) == 449589053) strcat(s, "U");
if (crc32("sRiQgPnefiYLg",13) == 4160404163) strcat(s, "l");
if (crc32("NimEBeVUWS",10) == 2300064510) strcat(s, "Y");
if (crc32("GAQVmoNKYjpxlpt",15) == 4113556608) strcat(s, "y");
    return s;
}

char *deceptively_adverbs() {
    char *s = calloc(12);
    if (crc32("dCEOAsucjPCClpo",15) == 682744687) strcat(s, "d");
if (crc32("RTtuBtjIuS",10) == 581406498) strcat(s, "e");
if (crc32("LWObvBkzTCONT",13) == 2945580584) strcat(s, "e");
if (crc32("mSKCbRHkXFgqhIi",15) == 270098453) strcat(s, "c");
if (crc32("UqkhW",5) == 4194005350) strcat(s, "e");
if (crc32("CcZdfVcyuPpSKG",14) == 904080075) strcat(s, "n");
if (crc32("DJNBC",5) == 3362139306) strcat(s, "p");
if (crc32("fmZGeZcjMiF",11) == 3194771012) strcat(s, "W");
if (crc32("mSHCjWjVM",9) == 1244664922) strcat(s, "t");
if (crc32("RWQmLuLX",8) == 1616872330) strcat(s, "m");
if (crc32("viRCu",5) == 1654470992) strcat(s, "i");
if (crc32("VkWgmAfidcA",11) == 1340270163) strcat(s, "Z");
if (crc32("ZRXpfGsIsgrcrJf",15) == 802838437) strcat(s, "v");
if (crc32("FrJsYSVbqoZDgq",14) == 2344835192) strcat(s, "e");
if (crc32("WnCLUwpvvkdDC",13) == 4846442) strcat(s, "R");
if (crc32("lnsEXe",6) == 2828510588) strcat(s, "l");
if (crc32("qyrtUQtH",8) == 2489974557) strcat(s, "y");
    return s;
}

char *uncomprehensively_adverbs() {
    char *s = calloc(18);
    if (crc32("WtRqAMcUozn",11) == 3058982939) strcat(s, "u");
if (crc32("sHaKznaUrQY",11) == 1558116658) strcat(s, "j");
if (crc32("PGsQhpIaU",9) == 2004900362) strcat(s, "n");
if (crc32("EjfCkuLLtmStFVa",15) == 693091123) strcat(s, "c");
if (crc32("BlOwGMla",8) == 2047652732) strcat(s, "o");
if (crc32("MEneI",5) == 2672313110) strcat(s, "m");
if (crc32("QILFMqPjqbimNAr",15) == 3208235061) strcat(s, "p");
if (crc32("TFZGjkS",7) == 3170499677) strcat(s, "I");
if (crc32("utYbUzNn",8) == 813954421) strcat(s, "r");
if (crc32("XyvlTkJXmaYvbXT",15) == 1672617981) strcat(s, "a");
if (crc32("CnxOdfQ",7) == 2964452202) strcat(s, "e");
if (crc32("CTqRrbbZ",8) == 3740922410) strcat(s, "H");
if (crc32("mbeigkMZntc",11) == 164975891) strcat(s, "h");
if (crc32("DBVrJuTBY",9) == 4258242959) strcat(s, "e");
if (crc32("haSNpudqa",9) == 3705718245) strcat(s, "n");
if (crc32("GkZAhMp",7) == 2095995342) strcat(s, "s");
if (crc32("IKbsNhsruykW",12) == 3244791087) strcat(s, "i");
if (crc32("dJGWXxReFwbj",12) == 309222151) strcat(s, "N");
if (crc32("Gxyexk",6) == 261135754) strcat(s, "v");
if (crc32("kMrwe",5) == 1265497977) strcat(s, "e");
if (crc32("nUYQT",5) == 2956471654) strcat(s, "l");
if (crc32("yQNUhpo",7) == 1641443777) strcat(s, "M");
if (crc32("jimkGmsJkMN",11) == 999261919) strcat(s, "y");
    return s;
}

char *pragmatically_adverbs() {
    char *s = calloc(14);
    if (crc32("eyOABdy",7) == 3398577760) strcat(s, "p");
if (crc32("cOqWOKvdylpUq",13) == 249068263) strcat(s, "Q");
if (crc32("ooCCkljDRjxF",12) == 3912958660) strcat(s, "r");
if (crc32("PoyxNyKclo",10) == 3622613035) strcat(s, "d");
if (crc32("TJwhCnsu",8) == 80066536) strcat(s, "a");
if (crc32("rGxMGGp",7) == 3471981821) strcat(s, "g");
if (crc32("dumGWvhBF",9) == 609874722) strcat(s, "m");
if (crc32("OifToFmFiOYx",12) == 2759461952) strcat(s, "a");
if (crc32("sPLUAeOt",8) == 2709322365) strcat(s, "t");
if (crc32("oImGxzIDDG",10) == 3304225380) strcat(s, "D");
if (crc32("yicrwjDt",8) == 3048504136) strcat(s, "i");
if (crc32("QrgUilqSMlKv",12) == 3483117075) strcat(s, "c");
if (crc32("AUimQOadwRKC",12) == 3094944378) strcat(s, "a");
if (crc32("ImWIrKV",7) == 1380591885) strcat(s, "l");
if (crc32("dZggfYR",7) == 1613076905) strcat(s, "l");
if (crc32("VtkRQEUFARqi",12) == 3646834531) strcat(s, "y");
    return s;
}

char *pharmacologically_adverbs() {
    char *s = calloc(18);
    if (crc32("lZCMjAizZPqu",12) == 2343828221) strcat(s, "d");
if (crc32("tAgNozcLUhQ",11) == 1396266132) strcat(s, "p");
if (crc32("TNaXjaJo",8) == 2711886258) strcat(s, "h");
if (crc32("XraOjeEv",8) == 3018169159) strcat(s, "O");
if (crc32("QVxDpp",6) == 1734468927) strcat(s, "a");
if (crc32("qYYvSxHjjvVRCsx",15) == 2445954397) strcat(s, "T");
if (crc32("RJULXT",6) == 2045804850) strcat(s, "r");
if (crc32("olbWDaaBWpdu",12) == 4205109712) strcat(s, "m");
if (crc32("czaUZd",6) == 1926855427) strcat(s, "D");
if (crc32("ZaGETBdpQhwn",12) == 1139671733) strcat(s, "a");
if (crc32("MtdxmfcxQyA",11) == 558770649) strcat(s, "c");
if (crc32("cwfraPHjkFDFQyK",15) == 1347152874) strcat(s, "o");
if (crc32("LoWnXUGAfFxFkib",15) == 2032928683) strcat(s, "j");
if (crc32("dyNEME",6) == 2560526883) strcat(s, "l");
if (crc32("UlkMJkK",7) == 3984983996) strcat(s, "G");
if (crc32("xyPkobweG",9) == 1951007718) strcat(s, "o");
if (crc32("HVgqbKiPSGN",11) == 2378259051) strcat(s, "g");
if (crc32("zYHIoSMlj",9) == 1451874742) strcat(s, "C");
if (crc32("DJrCeLZlhrF",11) == 2616996216) strcat(s, "i");
if (crc32("ofvCCOHZ",8) == 500849984) strcat(s, "A");
if (crc32("vURjll",6) == 893554627) strcat(s, "c");
if (crc32("IVdLQNjUVC",10) == 1380144100) strcat(s, "r");
if (crc32("GlWmxYUqkZsk",12) == 2440255702) strcat(s, "a");
if (crc32("CokqGmsLD",9) == 1005264076) strcat(s, "l");
if (crc32("aJdxFipGVUSXz",13) == 2013727632) strcat(s, "l");
if (crc32("kGvrghMVMsACa",13) == 3747687493) strcat(s, "W");
if (crc32("xeGiKHWtk",9) == 309193540) strcat(s, "l");
if (crc32("VqBLZHLBAhDG",12) == 2873073133) strcat(s, "h");
if (crc32("AdTut",5) == 2036357194) strcat(s, "y");
    return s;
}

char *hoveringly_adverbs() {
    char *s = calloc(11);
    if (crc32("vcNLtaxwHtxRBAw",15) == 1021912728) strcat(s, "B");
if (crc32("vdsBSQvkqmgsEYG",15) == 1571650174) strcat(s, "h");
if (crc32("FzXgWcwGwMPE",12) == 19500963) strcat(s, "o");
if (crc32("jmcYMj",6) == 4107584656) strcat(s, "g");
if (crc32("ZEgSM",5) == 3425199719) strcat(s, "v");
if (crc32("DYdBIdW",7) == 1976842165) strcat(s, "Z");
if (crc32("wJUpKYDznIQUIPz",15) == 2553746457) strcat(s, "e");
if (crc32("OgxAJeVibNZV",12) == 1646394062) strcat(s, "c");
if (crc32("BiHDgxuPsiXOF",13) == 457183305) strcat(s, "r");
if (crc32("caOwJ",5) == 379316132) strcat(s, "i");
if (crc32("gwCYU",5) == 261896251) strcat(s, "O");
if (crc32("MoJtHZWVO",9) == 529876385) strcat(s, "n");
if (crc32("BqMvRbZkH",9) == 1890731680) strcat(s, "q");
if (crc32("PSMOWZhLzhSJe",13) == 958693341) strcat(s, "g");
if (crc32("wvDyLqvHxL",10) == 3036203826) strcat(s, "l");
if (crc32("qXgOvbXtoKRJE",13) == 2528258769) strcat(s, "h");
if (crc32("EgCOpFanIVasJc",14) == 1835101233) strcat(s, "y");
    return s;
}

char *scribblingly_adverbs() {
    char *s = calloc(13);
    if (crc32("ECAcCN",6) == 3427309139) strcat(s, "E");
if (crc32("yjTnndkknHHJ",12) == 1770233283) strcat(s, "s");
if (crc32("eWEiGsROVPMunk",14) == 3337823126) strcat(s, "c");
if (crc32("yuYizDmHg",9) == 3412218531) strcat(s, "r");
if (crc32("BKSKTxTEsmHJAK",14) == 1332117875) strcat(s, "g");
if (crc32("BGyqMtAn",8) == 508016143) strcat(s, "i");
if (crc32("eHwUFfl",7) == 3249416182) strcat(s, "h");
if (crc32("AQMDoTqtyn",10) == 364546714) strcat(s, "b");
if (crc32("pqqUSWkUmyltc",13) == 536077908) strcat(s, "k");
if (crc32("bUIQJT",6) == 3925814811) strcat(s, "b");
if (crc32("vsPejcLhuPwB",12) == 2598254889) strcat(s, "l");
if (crc32("hGxQJVPMp",9) == 3220490154) strcat(s, "i");
if (crc32("rKQbaoaosQ",10) == 1570560697) strcat(s, "n");
if (crc32("bUbCnjmfchy",11) == 719381212) strcat(s, "n");
if (crc32("RABnZdHVj",9) == 1192799365) strcat(s, "g");
if (crc32("AXzDwMXKV",9) == 2757004734) strcat(s, "l");
if (crc32("ZarHjyUGHpxRnf",14) == 4283015262) strcat(s, "F");
if (crc32("zfDSjEFYB",9) == 1470771162) strcat(s, "y");
    return s;
}

char *manlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("liXeUGwLGvLdctS",15) == 2461289689) strcat(s, "a");
if (crc32("bOLloyAJ",8) == 653872932) strcat(s, "m");
if (crc32("bqAULljrKkgYdF",14) == 2911361316) strcat(s, "a");
if (crc32("wEpsyDdRk",9) == 2414833745) strcat(s, "n");
if (crc32("GssZzcZljiGFFUB",15) == 921158704) strcat(s, "S");
if (crc32("gntgVE",6) == 3248747214) strcat(s, "l");
if (crc32("XkSwtNPfFLmHP",13) == 3077757998) strcat(s, "B");
if (crc32("mHBPpSShFt",10) == 4027757862) strcat(s, "e");
if (crc32("qtmeXXmroOtuk",13) == 64199401) strcat(s, "s");
if (crc32("kwdMaWCjeNOej",13) == 294650916) strcat(s, "s");
if (crc32("RmqewfUigfsHN",13) == 3460368618) strcat(s, "l");
if (crc32("XTSRcQSvPWDFnrZ",15) == 1698589019) strcat(s, "z");
if (crc32("iSyKiaHFi",9) == 712233086) strcat(s, "y");
    return s;
}

char *inconspicuously_adverbs() {
    char *s = calloc(16);
    if (crc32("CJItVzNm",8) == 3971477357) strcat(s, "i");
if (crc32("mfOpFQiwYRJ",11) == 287059899) strcat(s, "n");
if (crc32("WYhgq",5) == 2976809660) strcat(s, "n");
if (crc32("rwmpzGk",7) == 756606941) strcat(s, "T");
if (crc32("zcOlEidBvJdlOY",14) == 308477251) strcat(s, "c");
if (crc32("owWVexBpj",9) == 4059834065) strcat(s, "o");
if (crc32("HRUvNEze",8) == 139860695) strcat(s, "X");
if (crc32("gDfBudFtH",9) == 455044517) strcat(s, "n");
if (crc32("IUBvGNxFrCgqll",14) == 4115726519) strcat(s, "s");
if (crc32("MhjZwjMaovJiB",13) == 2084182129) strcat(s, "j");
if (crc32("BIQAy",5) == 2949126360) strcat(s, "p");
if (crc32("MLuYgLBx",8) == 450127432) strcat(s, "X");
if (crc32("YtdORiM",7) == 3342709302) strcat(s, "i");
if (crc32("IBjkUw",6) == 2719125254) strcat(s, "c");
if (crc32("pAmiIVPvgHzu",12) == 1432809271) strcat(s, "X");
if (crc32("WUAThpFBSw",10) == 1036592918) strcat(s, "u");
if (crc32("hISyfprtIxWE",12) == 155938871) strcat(s, "o");
if (crc32("aKqYC",5) == 4294607500) strcat(s, "u");
if (crc32("gBWWEC",6) == 3690082604) strcat(s, "s");
if (crc32("wqStiEvCWcnx",12) == 1234394363) strcat(s, "l");
if (crc32("GXiTbt",6) == 1589042355) strcat(s, "M");
if (crc32("WYbTOWV",7) == 4214626319) strcat(s, "y");
    return s;
}

char *hypercritically_adverbs() {
    char *s = calloc(16);
    if (crc32("wMegYXuHRVXm",12) == 410797808) strcat(s, "h");
if (crc32("ojsDpXNq",8) == 3608599203) strcat(s, "Q");
if (crc32("UJLffWXG",8) == 454284163) strcat(s, "y");
if (crc32("ECZuHA",6) == 1056303507) strcat(s, "p");
if (crc32("KpRrwknnBQKWDP",14) == 1776185533) strcat(s, "b");
if (crc32("YMyukTglAXN",11) == 1838340355) strcat(s, "e");
if (crc32("kLRqNYvDxYu",11) == 803806710) strcat(s, "F");
if (crc32("zriPzs",6) == 2921798504) strcat(s, "r");
if (crc32("jxVkPDxjDMVgb",13) == 750979966) strcat(s, "c");
if (crc32("JwuhpfAfOacF",12) == 1275999544) strcat(s, "r");
if (crc32("ZzbuhqnTCPrP",12) == 4214348017) strcat(s, "i");
if (crc32("bCPjPpULy",9) == 4118476692) strcat(s, "t");
if (crc32("AClNiqBFUgd",11) == 3347318511) strcat(s, "i");
if (crc32("PJUyefwGQgW",11) == 3919895501) strcat(s, "c");
if (crc32("ANtKPmb",7) == 357984434) strcat(s, "a");
if (crc32("qWklJPKgmDXBxKA",15) == 3936910098) strcat(s, "l");
if (crc32("uENCrvg",7) == 1043919798) strcat(s, "U");
if (crc32("UazXl",5) == 3662360681) strcat(s, "l");
if (crc32("CeUMNlhJR",9) == 1878548654) strcat(s, "M");
if (crc32("sCCaPVn",7) == 2143176648) strcat(s, "y");
    return s;
}

char *unbalkingly_adverbs() {
    char *s = calloc(12);
    if (crc32("wYqfTu",6) == 3334321066) strcat(s, "F");
if (crc32("sAOpu",5) == 795763938) strcat(s, "u");
if (crc32("otvcEOT",7) == 1117153323) strcat(s, "n");
if (crc32("MnPiFATuEmvrxj",14) == 3436516958) strcat(s, "o");
if (crc32("cRhyLggmmzyxYI",14) == 1083147638) strcat(s, "b");
if (crc32("mFktoz",6) == 4032445422) strcat(s, "Z");
if (crc32("AnzctgGsfk",10) == 2207228680) strcat(s, "a");
if (crc32("ATKFNcq",7) == 4292755177) strcat(s, "I");
if (crc32("OMBUxwTPpqSH",12) == 2829053382) strcat(s, "l");
if (crc32("eooCsJkdltNFA",13) == 4262191685) strcat(s, "k");
if (crc32("qjaZJzF",7) == 1235018793) strcat(s, "i");
if (crc32("lqJpt",5) == 1648739169) strcat(s, "Z");
if (crc32("VkCMdOniefTVCQ",14) == 439145933) strcat(s, "n");
if (crc32("elXXqxJRRxVRrl",14) == 3661453383) strcat(s, "D");
if (crc32("aHhlYdAARYJm",12) == 1932880065) strcat(s, "g");
if (crc32("FRICuPzQUNhQ",12) == 2487124093) strcat(s, "K");
if (crc32("NRBSuOH",7) == 1850336016) strcat(s, "l");
if (crc32("efIvUF",6) == 295367494) strcat(s, "y");
    return s;
}

char *spryly_adverbs() {
    char *s = calloc(7);
    if (crc32("qhxTdFikhKHWjaf",15) == 566086316) strcat(s, "w");
if (crc32("JaGSvVmJ",8) == 4251965940) strcat(s, "s");
if (crc32("mDtjmAzvAB",10) == 2733351609) strcat(s, "H");
if (crc32("HQawFXLaPNaWO",13) == 3103212146) strcat(s, "p");
if (crc32("ddzlTQoHz",9) == 110955763) strcat(s, "t");
if (crc32("BfTqNg",6) == 1230013643) strcat(s, "r");
if (crc32("kyWjSet",7) == 3342870010) strcat(s, "y");
if (crc32("CZYUrXWbxWa",11) == 1991880020) strcat(s, "j");
if (crc32("XjmWNwsXUpJLcA",14) == 1473962477) strcat(s, "l");
if (crc32("xjIrruWvDF",10) == 2244079935) strcat(s, "B");
if (crc32("dNjXpuinGP",10) == 2531507105) strcat(s, "y");
    return s;
}

char *nonprolixly_adverbs() {
    char *s = calloc(12);
    if (crc32("aBJcmsGTCZ",10) == 407658683) strcat(s, "n");
if (crc32("TAXFZKGE",8) == 11377361) strcat(s, "o");
if (crc32("AtVENkX",7) == 1837610848) strcat(s, "n");
if (crc32("UFkPKJbhnKx",11) == 1218662608) strcat(s, "m");
if (crc32("HUHSiAXxiOcZb",13) == 1847241933) strcat(s, "p");
if (crc32("PFyNy",5) == 1548601339) strcat(s, "r");
if (crc32("aFtIrzt",7) == 1304010590) strcat(s, "q");
if (crc32("DOKvok",6) == 3687064103) strcat(s, "o");
if (crc32("IRIoIRfIrLw",11) == 1112738710) strcat(s, "y");
if (crc32("wBcLJVBEL",9) == 2800229518) strcat(s, "l");
if (crc32("ydHGdeU",7) == 4110178777) strcat(s, "E");
if (crc32("PBwTZxY",7) == 1741588556) strcat(s, "i");
if (crc32("EcrFKWblSKPIsj",14) == 1202701100) strcat(s, "x");
if (crc32("OUzEkKJrKXRKN",13) == 2505367614) strcat(s, "l");
if (crc32("ZKnrzlVhmSpn",12) == 2678432873) strcat(s, "p");
if (crc32("gHIOGmlnKmnHBd",14) == 2466585371) strcat(s, "y");
    return s;
}

char *ungratefully_adverbs() {
    char *s = calloc(13);
    if (crc32("uDZBUlEw",8) == 1082237764) strcat(s, "u");
if (crc32("JkzSr",5) == 2029409943) strcat(s, "i");
if (crc32("kOuIE",5) == 2659193538) strcat(s, "n");
if (crc32("UymDBkxplfLFe",13) == 188066235) strcat(s, "h");
if (crc32("qptxiFSUVNr",11) == 2350328814) strcat(s, "g");
if (crc32("sJoai",5) == 2281364060) strcat(s, "r");
if (crc32("yQgXEX",6) == 3028077029) strcat(s, "a");
if (crc32("kmdJQRHHgqIhtaq",15) == 2752782646) strcat(s, "u");
if (crc32("EyxQsXaVvPU",11) == 2459736804) strcat(s, "t");
if (crc32("WtrKqrPqZ",9) == 317383507) strcat(s, "e");
if (crc32("HsavfgdUtFKvPAZ",15) == 4036407769) strcat(s, "q");
if (crc32("xgEfI",5) == 3817335191) strcat(s, "f");
if (crc32("kcNez",5) == 671291609) strcat(s, "q");
if (crc32("CRtrHAnyDnqKY",13) == 913178685) strcat(s, "u");
if (crc32("RNKfZJ",6) == 2184416189) strcat(s, "Z");
if (crc32("OwVXCaAaBIQuaL",14) == 3544001417) strcat(s, "l");
if (crc32("DcAzQ",5) == 4196812432) strcat(s, "l");
if (crc32("NCCaMSDjKFt",11) == 757210481) strcat(s, "F");
if (crc32("fGYhXOBsQiHJma",14) == 2851392137) strcat(s, "y");
    return s;
}

char *savoringly_adverbs() {
    char *s = calloc(11);
    if (crc32("roykLEUgvnsIbp",14) == 2148360998) strcat(s, "s");
if (crc32("SqTBFALGx",9) == 878401545) strcat(s, "a");
if (crc32("yLbcXOz",7) == 2483951951) strcat(s, "z");
if (crc32("YpHfxyLqJ",9) == 1004107215) strcat(s, "v");
if (crc32("DefZk",5) == 2982655033) strcat(s, "o");
if (crc32("rbNJVkV",7) == 3877959382) strcat(s, "v");
if (crc32("NUAvieMZpnFLDB",14) == 441363322) strcat(s, "r");
if (crc32("lRCTzEgEkJLMWUI",15) == 1815848048) strcat(s, "y");
if (crc32("WmhkuV",6) == 2881202255) strcat(s, "i");
if (crc32("eziamvbrOhrYO",13) == 2766641181) strcat(s, "n");
if (crc32("JyGiIXQR",8) == 2156302126) strcat(s, "g");
if (crc32("CQxwRPS",7) == 938934055) strcat(s, "l");
if (crc32("ZNhxIdHiAIeC",12) == 894585200) strcat(s, "y");
    return s;
}

char *farforthly_adverbs() {
    char *s = calloc(11);
    if (crc32("usLIXSmAUkPhfTH",15) == 331166408) strcat(s, "G");
if (crc32("RiDRE",5) == 997686506) strcat(s, "f");
if (crc32("zFMEyFrgqj",10) == 1989822280) strcat(s, "f");
if (crc32("SfnduHjUj",9) == 3016215065) strcat(s, "a");
if (crc32("xiYeroc",7) == 878820384) strcat(s, "x");
if (crc32("aRvogjBkjgT",11) == 3890128174) strcat(s, "r");
if (crc32("ZLxLpIPSIJtXSn",14) == 459861368) strcat(s, "a");
if (crc32("oqBFrawiG",9) == 34414389) strcat(s, "f");
if (crc32("OQglEnpjHTRcd",13) == 3554383722) strcat(s, "o");
if (crc32("SKGnByClmfyO",12) == 2001740483) strcat(s, "r");
if (crc32("rYVibkIZHQEk",12) == 3517382535) strcat(s, "t");
if (crc32("SmKXKdvmS",9) == 991923953) strcat(s, "X");
if (crc32("OEDgg",5) == 1051900941) strcat(s, "h");
if (crc32("aPoPbtlzJ",9) == 1765808947) strcat(s, "L");
if (crc32("HQowDo",6) == 744071313) strcat(s, "l");
if (crc32("oksgmakJVqVplY",14) == 3037048039) strcat(s, "y");
    return s;
}

char *frumpishly_adverbs() {
    char *s = calloc(11);
    if (crc32("tEfSGR",6) == 3304806338) strcat(s, "b");
if (crc32("oRDMtcQeaMZpn",13) == 4242563774) strcat(s, "f");
if (crc32("scCJVl",6) == 2233847624) strcat(s, "v");
if (crc32("NsdTOrVkpiDe",12) == 142528787) strcat(s, "r");
if (crc32("OUboDN",6) == 1760169122) strcat(s, "u");
if (crc32("HVvfGq",6) == 161084) strcat(s, "r");
if (crc32("ddnNWKAVee",10) == 3141506561) strcat(s, "m");
if (crc32("LcsNJcALfWa",11) == 560154120) strcat(s, "p");
if (crc32("joYspb",6) == 1878950560) strcat(s, "i");
if (crc32("DFwRR",5) == 2306375598) strcat(s, "s");
if (crc32("vgXgwsBRRqXXVT",14) == 3044547353) strcat(s, "Q");
if (crc32("NWntGQrKxQg",11) == 2871494232) strcat(s, "h");
if (crc32("moxcqaR",7) == 1982651198) strcat(s, "J");
if (crc32("ikGPa",5) == 1274807804) strcat(s, "l");
if (crc32("rDMJg",5) == 4031039039) strcat(s, "y");
    return s;
}

char *longly_adverbs() {
    char *s = calloc(7);
    if (crc32("UXMLHdSAWfBJ",12) == 1784419487) strcat(s, "l");
if (crc32("trxarvcrwvrE",12) == 3367569971) strcat(s, "N");
if (crc32("eEtAQ",5) == 2647423109) strcat(s, "o");
if (crc32("XHfvr",5) == 466975287) strcat(s, "n");
if (crc32("nNoxUTABNk",10) == 2571429017) strcat(s, "g");
if (crc32("tyuRtlCo",8) == 2099966323) strcat(s, "w");
if (crc32("ptLDYkM",7) == 2244714718) strcat(s, "l");
if (crc32("AkRdUCsXimpNYnm",15) == 1472911986) strcat(s, "w");
if (crc32("cTgIF",5) == 2940448569) strcat(s, "y");
    return s;
}

char *disdainfully_adverbs() {
    char *s = calloc(13);
    if (crc32("uhTJj",5) == 2126265376) strcat(s, "e");
if (crc32("BQmmHocFKMpWZFO",15) == 1297749371) strcat(s, "d");
if (crc32("AwIXNcTFehfXFN",14) == 214524471) strcat(s, "i");
if (crc32("tkxNjhRSGVxLbe",14) == 1366046089) strcat(s, "s");
if (crc32("WdHVKgZZfnubU",13) == 2359746705) strcat(s, "M");
if (crc32("FIJku",5) == 753300106) strcat(s, "d");
if (crc32("kGOnYWF",7) == 250775572) strcat(s, "a");
if (crc32("JwPOzcmNRdfals",14) == 1573846974) strcat(s, "i");
if (crc32("diBPtPZv",8) == 620586014) strcat(s, "n");
if (crc32("nutLYS",6) == 3066561802) strcat(s, "f");
if (crc32("yjjyNDIk",8) == 1406512757) strcat(s, "u");
if (crc32("BrSXgM",6) == 3485410041) strcat(s, "v");
if (crc32("pVkxSDdhX",9) == 128752493) strcat(s, "l");
if (crc32("RujLQCc",7) == 303586136) strcat(s, "l");
if (crc32("bCXLqAlAgVEwRO",14) == 3725126307) strcat(s, "y");
    return s;
}

char *adoptively_adverbs() {
    char *s = calloc(11);
    if (crc32("RMuAzNpxDlB",11) == 741130684) strcat(s, "a");
if (crc32("iByWt",5) == 2595184638) strcat(s, "a");
if (crc32("SrctbTaIRojV",12) == 3983226998) strcat(s, "d");
if (crc32("xzwcXawBPwF",11) == 1207985733) strcat(s, "W");
if (crc32("gyerquRhVxdOW",13) == 2437232012) strcat(s, "o");
if (crc32("XdnTB",5) == 2118733189) strcat(s, "p");
if (crc32("bFBZxt",6) == 1503823117) strcat(s, "A");
if (crc32("qTBtG",5) == 2517276664) strcat(s, "t");
if (crc32("thKlBRimr",9) == 1873003932) strcat(s, "Y");
if (crc32("ZjmmGoSeXAl",11) == 354228993) strcat(s, "i");
if (crc32("URDUS",5) == 367590604) strcat(s, "v");
if (crc32("IFbHBFfZD",9) == 1696281688) strcat(s, "e");
if (crc32("DxgvgyvrZei",11) == 585290997) strcat(s, "l");
if (crc32("jlmItzDynRaUOu",14) == 2158389471) strcat(s, "y");
    return s;
}

char *cravingly_adverbs() {
    char *s = calloc(10);
    if (crc32("aQJvTbbdwF",10) == 590926965) strcat(s, "x");
if (crc32("qCgrr",5) == 1705713520) strcat(s, "c");
if (crc32("AMtjYTjTdB",10) == 4203496281) strcat(s, "r");
if (crc32("gkYCrIu",7) == 525681897) strcat(s, "o");
if (crc32("iCyFuCYZy",9) == 2740546499) strcat(s, "a");
if (crc32("gaiGaWIxjea",11) == 1602808989) strcat(s, "v");
if (crc32("mpddlz",6) == 2121851593) strcat(s, "i");
if (crc32("KORlcyGMiGU",11) == 1760387558) strcat(s, "x");
if (crc32("OuZuNAHnPFX",11) == 4059962789) strcat(s, "n");
if (crc32("AYrYDQ",6) == 3716722622) strcat(s, "C");
if (crc32("LNEjWPJRDJv",11) == 3209755001) strcat(s, "g");
if (crc32("IfTzJudyARXh",12) == 2805820903) strcat(s, "l");
if (crc32("mqqyKoxvqraVeee",15) == 679649109) strcat(s, "o");
if (crc32("hhPgGbdmi",9) == 3834072690) strcat(s, "y");
    return s;
}

char *uninferably_adverbs() {
    char *s = calloc(12);
    if (crc32("pEQxZADQzTZeJP",14) == 1989308816) strcat(s, "n");
if (crc32("MUYesavITsODAm",14) == 422509825) strcat(s, "u");
if (crc32("upHwuyYJ",8) == 3182953422) strcat(s, "A");
if (crc32("ZdmlDTI",7) == 1069194228) strcat(s, "n");
if (crc32("UFjFqaiPTcwvui",14) == 2755556118) strcat(s, "i");
if (crc32("lFdDgLxh",8) == 805030473) strcat(s, "m");
if (crc32("OHxqurd",7) == 3555273366) strcat(s, "n");
if (crc32("ldTgYNGa",8) == 1746832185) strcat(s, "f");
if (crc32("yMTswWs",7) == 2576912370) strcat(s, "w");
if (crc32("MqepkantxCHFnB",14) == 2716758) strcat(s, "e");
if (crc32("AylVbR",6) == 3430691134) strcat(s, "s");
if (crc32("JsgaFahA",8) == 3939081402) strcat(s, "r");
if (crc32("SzEFpPNnVqoA",12) == 2330041472) strcat(s, "j");
if (crc32("BqalGkJevk",10) == 725960051) strcat(s, "a");
if (crc32("YBjtLhOuKyoYDg",14) == 3219851581) strcat(s, "V");
if (crc32("sCjeXIO",7) == 3006124690) strcat(s, "b");
if (crc32("ZdQBgkxIaSbCqC",14) == 558918353) strcat(s, "N");
if (crc32("KAHJPXV",7) == 530088392) strcat(s, "l");
if (crc32("XTFmlFWvBFIxb",13) == 2962577075) strcat(s, "y");
    return s;
}

char *artistically_adverbs() {
    char *s = calloc(13);
    if (crc32("tSvguTQBypDMjbc",15) == 129412599) strcat(s, "a");
if (crc32("mjssipv",7) == 3368359514) strcat(s, "r");
if (crc32("TMWQzqaaUOq",11) == 4080359657) strcat(s, "D");
if (crc32("nnOuJvALuFdbN",13) == 3532343243) strcat(s, "t");
if (crc32("oapyw",5) == 985123223) strcat(s, "i");
if (crc32("gRNlJQCjZe",10) == 3871981212) strcat(s, "s");
if (crc32("xVBhVYfrp",9) == 4028570325) strcat(s, "h");
if (crc32("QoeeAyjOt",9) == 489765073) strcat(s, "t");
if (crc32("zYAmxpIawYpDZot",15) == 1736683920) strcat(s, "F");
if (crc32("PgaLs",5) == 2215999220) strcat(s, "i");
if (crc32("OZVxpfJweiFR",12) == 2367807499) strcat(s, "a");
if (crc32("YHjiaRK",7) == 2098211495) strcat(s, "c");
if (crc32("dQscPaYqyt",10) == 609303197) strcat(s, "a");
if (crc32("cmyYtmHktu",10) == 816761711) strcat(s, "t");
if (crc32("xmecgPROOiAy",12) == 3056054630) strcat(s, "l");
if (crc32("rnxNWopLWkRp",12) == 3504101737) strcat(s, "H");
if (crc32("gNHHOI",6) == 456687165) strcat(s, "l");
if (crc32("WHIMy",5) == 965602407) strcat(s, "j");
if (crc32("UglftsiG",8) == 2984048755) strcat(s, "y");
    return s;
}

char *goodheartedly_adverbs() {
    char *s = calloc(14);
    if (crc32("lyHVtKZhEc",10) == 173465328) strcat(s, "g");
if (crc32("HOmXaEyYhplfAR",14) == 2928432781) strcat(s, "g");
if (crc32("hKIjaEmaSE",10) == 1534310708) strcat(s, "s");
if (crc32("HPhsk",5) == 4246397770) strcat(s, "o");
if (crc32("zlIdLjrduLz",11) == 972396066) strcat(s, "o");
if (crc32("WLgjIEJc",8) == 3287507661) strcat(s, "Q");
if (crc32("bMpBioKspB",10) == 4283909082) strcat(s, "d");
if (crc32("QnFdlLU",7) == 642159704) strcat(s, "U");
if (crc32("RWXsHtVGwM",10) == 266528592) strcat(s, "h");
if (crc32("NHUVTszF",8) == 2641800354) strcat(s, "e");
if (crc32("QWfyIQvkzy",10) == 1926244701) strcat(s, "s");
if (crc32("cHfMOs",6) == 2411924191) strcat(s, "a");
if (crc32("ptmDKAy",7) == 672655849) strcat(s, "r");
if (crc32("kBVdMuQlprh",11) == 3623181813) strcat(s, "t");
if (crc32("rArSUDDyrlev",12) == 2158392283) strcat(s, "l");
if (crc32("pPGVZcJsiat",11) == 193948195) strcat(s, "e");
if (crc32("ueCzVpze",8) == 808296438) strcat(s, "d");
if (crc32("JvyTqxYkPCO",11) == 211446294) strcat(s, "l");
if (crc32("BoQGhxVZqs",10) == 4034325686) strcat(s, "p");
if (crc32("RFutHj",6) == 3186194655) strcat(s, "y");
    return s;
}

char *forwardly_adverbs() {
    char *s = calloc(10);
    if (crc32("LlXinPCWs",9) == 1440757905) strcat(s, "H");
if (crc32("xFjXH",5) == 4275702778) strcat(s, "f");
if (crc32("WoaYpzLffrGaat",14) == 3870977) strcat(s, "y");
if (crc32("FRlVOjRp",8) == 2822787488) strcat(s, "o");
if (crc32("JNqjL",5) == 163658087) strcat(s, "e");
if (crc32("fPoazPOS",8) == 3762176348) strcat(s, "r");
if (crc32("JXFSPASgnXVs",12) == 3047195321) strcat(s, "V");
if (crc32("jRsCBEoAYt",10) == 3528999788) strcat(s, "w");
if (crc32("vCIwMU",6) == 1141017670) strcat(s, "P");
if (crc32("XUcFJwtTzlGcRvu",15) == 3338774432) strcat(s, "a");
if (crc32("lGJXovPw",8) == 313666748) strcat(s, "k");
if (crc32("njMkW",5) == 3221176830) strcat(s, "r");
if (crc32("EossTUsXAkc",11) == 4162020374) strcat(s, "R");
if (crc32("ERXJUnqrohJU",12) == 2743989671) strcat(s, "d");
if (crc32("DBbmaLeX",8) == 3101673573) strcat(s, "l");
if (crc32("PiTlxhYfkyJvPP",14) == 1505471934) strcat(s, "y");
    return s;
}

char *stingily_adverbs() {
    char *s = calloc(9);
    if (crc32("OsqwRnEHj",9) == 3816404502) strcat(s, "s");
if (crc32("jQLwphYsIHm",11) == 3671758437) strcat(s, "e");
if (crc32("eUMiMcZxm",9) == 3676497572) strcat(s, "t");
if (crc32("dgTOitEFmhLQtc",14) == 4004521369) strcat(s, "u");
if (crc32("HpFbTwlXY",9) == 1469527893) strcat(s, "i");
if (crc32("lhdMHZGwjqnl",12) == 3521890097) strcat(s, "n");
if (crc32("fQuiCTmDPry",11) == 1071945764) strcat(s, "g");
if (crc32("ctEbEMTkmhbzWl",14) == 2420044623) strcat(s, "i");
if (crc32("ZrHeH",5) == 1741179912) strcat(s, "e");
if (crc32("xXodwjAAQzyesa",14) == 694202644) strcat(s, "l");
if (crc32("UMaNdpkpV",9) == 2600416001) strcat(s, "y");
    return s;
}

char *inapplicably_adverbs() {
    char *s = calloc(13);
    if (crc32("IpMYWvHty",9) == 1889484086) strcat(s, "A");
if (crc32("eQQmCoqPZCZqrV",14) == 1492859480) strcat(s, "i");
if (crc32("wHmiLllWOCCgetA",15) == 1802368649) strcat(s, "v");
if (crc32("mpuCNz",6) == 208520310) strcat(s, "n");
if (crc32("xdVJPhlyldHiU",13) == 2742082468) strcat(s, "W");
if (crc32("KJDBbdnLECvMs",13) == 864572897) strcat(s, "a");
if (crc32("PsBiIsovmZme",12) == 3160844048) strcat(s, "B");
if (crc32("afKsVCTVy",9) == 3763342855) strcat(s, "p");
if (crc32("ZpkOFRROhviJ",12) == 923988830) strcat(s, "p");
if (crc32("Luvupqpxt",9) == 607382183) strcat(s, "G");
if (crc32("XVliGQsdBIyZfik",15) == 3576079150) strcat(s, "l");
if (crc32("jZXXBXNAWdQfjE",14) == 307689461) strcat(s, "i");
if (crc32("jnGoXiClCZcQ",12) == 3011226604) strcat(s, "c");
if (crc32("icAGuoSAHhimT",13) == 509484707) strcat(s, "z");
if (crc32("GBFtGRgIxEpXsEs",15) == 894718029) strcat(s, "a");
if (crc32("DetgDgS",7) == 2273390270) strcat(s, "L");
if (crc32("RemkU",5) == 1426990051) strcat(s, "b");
if (crc32("tydsDuvtP",9) == 2916509127) strcat(s, "g");
if (crc32("kvcDmIHp",8) == 2594842696) strcat(s, "l");
if (crc32("JzNbKb",6) == 751490621) strcat(s, "y");
    return s;
}

char *physiognomonically_adverbs() {
    char *s = calloc(19);
    if (crc32("nyBXEMFXXcz",11) == 4119754740) strcat(s, "p");
if (crc32("tbQNuhgYixLjHpL",15) == 439107556) strcat(s, "k");
if (crc32("aJVmu",5) == 248828898) strcat(s, "h");
if (crc32("WfbaoBaXyfuA",12) == 221725374) strcat(s, "y");
if (crc32("KPRNv",5) == 3478570955) strcat(s, "N");
if (crc32("UaUbmldWm",9) == 1864996414) strcat(s, "s");
if (crc32("HSDirjk",7) == 2580045818) strcat(s, "i");
if (crc32("mhvBpLVUbj",10) == 1897905538) strcat(s, "o");
if (crc32("CsHgpqiRXONK",12) == 2674631601) strcat(s, "g");
if (crc32("UpkhVveaKAKuAAr",15) == 2038193741) strcat(s, "X");
if (crc32("hsVxzmzWI",9) == 1571551953) strcat(s, "n");
if (crc32("aSRDOAVwVgrdmv",14) == 3359520747) strcat(s, "o");
if (crc32("OYkAa",5) == 2122499408) strcat(s, "u");
if (crc32("uAEJWMFm",8) == 2508208521) strcat(s, "m");
if (crc32("vRcZay",6) == 874758336) strcat(s, "L");
if (crc32("NDLvEdOBvMvCyJV",15) == 1098715694) strcat(s, "o");
if (crc32("ioCqQhArLa",10) == 2770313025) strcat(s, "s");
if (crc32("ReEfBaurI",9) == 195212972) strcat(s, "n");
if (crc32("ZzIxP",5) == 1137013962) strcat(s, "i");
if (crc32("uVnwblP",7) == 11818595) strcat(s, "B");
if (crc32("mxxJYYteBLBcGw",14) == 2749955847) strcat(s, "c");
if (crc32("NTKdKBzT",8) == 23030579) strcat(s, "a");
if (crc32("yCsCEd",6) == 1580485440) strcat(s, "G");
if (crc32("PcIGzhZDKWYn",12) == 939407735) strcat(s, "l");
if (crc32("ZjsumX",6) == 176273397) strcat(s, "u");
if (crc32("mqgGYwZUcchMOx",14) == 3046284045) strcat(s, "l");
if (crc32("FjohBzYH",8) == 2398344228) strcat(s, "y");
    return s;
}

char *antimystically_adverbs() {
    char *s = calloc(15);
    if (crc32("cULRELhAub",10) == 2538563403) strcat(s, "a");
if (crc32("aEkuxxyLcVwQIt",14) == 1842220037) strcat(s, "B");
if (crc32("JbEKXxpkNdIP",12) == 1328296913) strcat(s, "n");
if (crc32("gYfnIqchDlz",11) == 2190962776) strcat(s, "t");
if (crc32("VlsHMYxyTDM",11) == 250904066) strcat(s, "N");
if (crc32("thnkEceUBYJ",11) == 1162872184) strcat(s, "i");
if (crc32("zjjMbShcKx",10) == 2385221026) strcat(s, "M");
if (crc32("nHqOgLgBp",9) == 432224544) strcat(s, "m");
if (crc32("dHiFRTnjAzq",11) == 3415454850) strcat(s, "y");
if (crc32("BtGSdXdV",8) == 773923888) strcat(s, "s");
if (crc32("HdEVCsAppBi",11) == 3704192777) strcat(s, "o");
if (crc32("CjRAZbevA",9) == 3848140823) strcat(s, "t");
if (crc32("dkGAWKT",7) == 4232562329) strcat(s, "l");
if (crc32("faFzGvso",8) == 3148087937) strcat(s, "i");
if (crc32("lEpopqNdBMkeE",13) == 3955784847) strcat(s, "c");
if (crc32("PWxJllKJOsbZZNQ",15) == 1911468827) strcat(s, "i");
if (crc32("qDHKEHTsrnEzQN",14) == 2925327856) strcat(s, "a");
if (crc32("fbGzRiXtMKZYPk",14) == 2069599251) strcat(s, "l");
if (crc32("VmSXuihbXNPWuwL",15) == 534614596) strcat(s, "l");
if (crc32("FlnEJbgqyLo",11) == 3111369885) strcat(s, "r");
if (crc32("zyEVEX",6) == 3288110385) strcat(s, "y");
    return s;
}

char *hyperobtrusively_adverbs() {
    char *s = calloc(17);
    if (crc32("jJZKteJo",8) == 396606511) strcat(s, "U");
if (crc32("SqXeHr",6) == 962914590) strcat(s, "h");
if (crc32("CGGZYAnBTXFk",12) == 3122281663) strcat(s, "y");
if (crc32("PhHYYerN",8) == 706819478) strcat(s, "p");
if (crc32("LlJfG",5) == 3983153712) strcat(s, "S");
if (crc32("RGhBkSxPrf",10) == 1382923467) strcat(s, "e");
if (crc32("mlMSnIFgN",9) == 2032668781) strcat(s, "L");
if (crc32("GtavUHrmcFdcP",13) == 2237912874) strcat(s, "r");
if (crc32("ySomcOdG",8) == 3696065362) strcat(s, "S");
if (crc32("XomUpgM",7) == 2678399312) strcat(s, "o");
if (crc32("AVAPQoYgbbVIt",13) == 2416406917) strcat(s, "X");
if (crc32("MDPJablK",8) == 2579243707) strcat(s, "b");
if (crc32("wAoGFw",6) == 3164904751) strcat(s, "t");
if (crc32("rcICXcnmJN",10) == 161653452) strcat(s, "r");
if (crc32("TOYPlQNhor",10) == 2283302733) strcat(s, "G");
if (crc32("dBHKwUjctr",10) == 2047912984) strcat(s, "u");
if (crc32("bWmkvaZAbzsu",12) == 1223897468) strcat(s, "S");
if (crc32("rIYciZpmwJIiCO",14) == 2628814689) strcat(s, "s");
if (crc32("ZaXydr",6) == 3420949171) strcat(s, "n");
if (crc32("PElUAlopRuM",11) == 338793618) strcat(s, "i");
if (crc32("twnldPMaRWMkqMJ",15) == 150061767) strcat(s, "v");
if (crc32("CCWpfwjaILqmlu",14) == 2982889103) strcat(s, "e");
if (crc32("rtgnt",5) == 1088642512) strcat(s, "l");
if (crc32("DErTxUGiHIA",11) == 2423751589) strcat(s, "N");
if (crc32("rOCfKvxHL",9) == 535874393) strcat(s, "y");
    return s;
}

char *recurringly_adverbs() {
    char *s = calloc(12);
    if (crc32("jvNbgAqzupNPrYz",15) == 4107559915) strcat(s, "G");
if (crc32("AFaoAOgKMvxDM",13) == 1005627396) strcat(s, "r");
if (crc32("mBHwwCd",7) == 4000518139) strcat(s, "n");
if (crc32("TrvhjZJSojU",11) == 1599813995) strcat(s, "e");
if (crc32("tjkDWy",6) == 998074411) strcat(s, "W");
if (crc32("VxpwFk",6) == 3832901469) strcat(s, "c");
if (crc32("uLPHa",5) == 1031200305) strcat(s, "N");
if (crc32("cakVfvwh",8) == 2931900660) strcat(s, "u");
if (crc32("dMvltvushcTfOT",14) == 1609896628) strcat(s, "m");
if (crc32("ryiYTqFhFgrW",12) == 890870748) strcat(s, "r");
if (crc32("miuBMej",7) == 3543958615) strcat(s, "f");
if (crc32("HSFFQ",5) == 3108060234) strcat(s, "r");
if (crc32("owAcRJEyqSXOhL",14) == 1487527716) strcat(s, "i");
if (crc32("bmBVUCa",7) == 1055148297) strcat(s, "f");
if (crc32("UWYvm",5) == 1224758807) strcat(s, "n");
if (crc32("WOnVDHg",7) == 3515956550) strcat(s, "g");
if (crc32("QCitNxdGmt",10) == 1067085478) strcat(s, "l");
if (crc32("IVfvxioVBrRJKNM",15) == 1931496768) strcat(s, "K");
if (crc32("EtvhaIg",7) == 680829268) strcat(s, "y");
    return s;
}

char *erroneously_adverbs() {
    char *s = calloc(12);
    if (crc32("GedEgGVGy",9) == 3274215927) strcat(s, "A");
if (crc32("pNVuIKFaB",9) == 3095538039) strcat(s, "e");
if (crc32("ewwlPgbj",8) == 3795479362) strcat(s, "r");
if (crc32("PcPvTuVbzncIZ",13) == 2798991403) strcat(s, "p");
if (crc32("hQmMHTdQ",8) == 3748609895) strcat(s, "r");
if (crc32("hvpuxAGUsTTaiX",14) == 1023659430) strcat(s, "o");
if (crc32("ESyBpU",6) == 3940282222) strcat(s, "R");
if (crc32("RPEtux",6) == 993254314) strcat(s, "n");
if (crc32("AmueqsjnCJYWSzL",15) == 3667481333) strcat(s, "e");
if (crc32("fHykoZyMXYa",11) == 870585040) strcat(s, "N");
if (crc32("rxlxrf",6) == 2889877549) strcat(s, "o");
if (crc32("xlUplHlKVj",10) == 23392836) strcat(s, "p");
if (crc32("NQVrUKblPh",10) == 3023993085) strcat(s, "u");
if (crc32("PLrdfVfQtcMX",12) == 3429146450) strcat(s, "T");
if (crc32("oFxVDhL",7) == 3146397819) strcat(s, "s");
if (crc32("grnKSxOL",8) == 1391949678) strcat(s, "l");
if (crc32("oitBGvmCnh",10) == 2942330865) strcat(s, "y");
    return s;
}

char *covinously_adverbs() {
    char *s = calloc(11);
    if (crc32("HvoHJQrtzE",10) == 2036948989) strcat(s, "c");
if (crc32("HlLNUVyq",8) == 17310232) strcat(s, "o");
if (crc32("nJVdHvdVDqnBgCN",15) == 3115124729) strcat(s, "R");
if (crc32("aRbRwxLu",8) == 443519327) strcat(s, "v");
if (crc32("luZLMHQSIg",10) == 3779791026) strcat(s, "i");
if (crc32("beJchaSpdQQ",11) == 2411604687) strcat(s, "M");
if (crc32("AKDQPSe",7) == 79657122) strcat(s, "n");
if (crc32("oMAioejVfjnju",13) == 1225513802) strcat(s, "G");
if (crc32("GJORYtPf",8) == 3779789605) strcat(s, "o");
if (crc32("QKCRUbITdnL",11) == 2858837700) strcat(s, "u");
if (crc32("CCRuXEKcruP",11) == 3472746854) strcat(s, "s");
if (crc32("TxNpxjH",7) == 2626463909) strcat(s, "l");
if (crc32("pWURAdY",7) == 2466648204) strcat(s, "y");
    return s;
}

char *benevolently_adverbs() {
    char *s = calloc(13);
    if (crc32("ukozvaspNYEl",12) == 329178021) strcat(s, "b");
if (crc32("vbZZPsfe",8) == 1598514708) strcat(s, "e");
if (crc32("HZxRnjateJTAc",13) == 1549350279) strcat(s, "n");
if (crc32("UHwigkcFUbJk",12) == 988357862) strcat(s, "e");
if (crc32("KFHvVSO",7) == 975936797) strcat(s, "q");
if (crc32("vQRLDlSFuDVyy",13) == 1136161831) strcat(s, "v");
if (crc32("ENsJksU",7) == 2940692341) strcat(s, "o");
if (crc32("xbdnUcXaS",9) == 2754897761) strcat(s, "X");
if (crc32("bhnpzrS",7) == 2664599689) strcat(s, "l");
if (crc32("kumZJOUMhRn",11) == 2187582581) strcat(s, "e");
if (crc32("iBvsoP",6) == 945256823) strcat(s, "Q");
if (crc32("HdjgBjtU",8) == 1188114031) strcat(s, "n");
if (crc32("GkEPdjjPJCcP",12) == 265271475) strcat(s, "t");
if (crc32("YslKFsNu",8) == 1456962562) strcat(s, "F");
if (crc32("WJiOTEb",7) == 3348054338) strcat(s, "l");
if (crc32("LiZtbdxnM",9) == 4166688918) strcat(s, "y");
    return s;
}

char *acidimetrically_adverbs() {
    char *s = calloc(16);
    if (crc32("FlMVbB",6) == 457720696) strcat(s, "i");
if (crc32("qvTsOdGaV",9) == 3558765386) strcat(s, "a");
if (crc32("RbtSAajYltqMT",13) == 3573186735) strcat(s, "p");
if (crc32("kpCUeAFwnve",11) == 784844194) strcat(s, "c");
if (crc32("KYaFnM",6) == 1837373472) strcat(s, "h");
if (crc32("AhmfrHF",7) == 338864689) strcat(s, "i");
if (crc32("hSwjzY",6) == 1578710896) strcat(s, "d");
if (crc32("xKJJHlLWMgnUfW",14) == 711089390) strcat(s, "e");
if (crc32("nAmMxqk",7) == 1016843164) strcat(s, "i");
if (crc32("WWpYx",5) == 2073928862) strcat(s, "m");
if (crc32("CxoqMe",6) == 3218420674) strcat(s, "e");
if (crc32("lNDYMLOuJ",9) == 900344361) strcat(s, "t");
if (crc32("zYsaRBmZ",8) == 945139244) strcat(s, "A");
if (crc32("QHMzYSHs",8) == 2730345401) strcat(s, "r");
if (crc32("cOuYIUoSQWr",11) == 4082939104) strcat(s, "o");
if (crc32("LXXYJeHVLdHImtX",15) == 3141746284) strcat(s, "i");
if (crc32("YbZRdgx",7) == 138447548) strcat(s, "i");
if (crc32("QXBEQHGmvHFaP",13) == 4137135245) strcat(s, "c");
if (crc32("TEYxiAVyv",9) == 162601880) strcat(s, "Y");
if (crc32("qpxDWuvMGzeMRJ",14) == 1038487890) strcat(s, "a");
if (crc32("kqDaT",5) == 2620431535) strcat(s, "l");
if (crc32("gnPIYIPUchk",11) == 4274615737) strcat(s, "l");
if (crc32("suRktYKditGFJ",13) == 2425762714) strcat(s, "c");
if (crc32("YMjNnEsMiOYjI",13) == 572474208) strcat(s, "y");
    return s;
}

char *awedly_adverbs() {
    char *s = calloc(7);
    if (crc32("VsTmvumdK",9) == 3333544979) strcat(s, "R");
if (crc32("lgmCGDXMWFHS",12) == 3620297609) strcat(s, "a");
if (crc32("RDNOZAY",7) == 61210027) strcat(s, "w");
if (crc32("qsUZfyCGW",9) == 3344497469) strcat(s, "e");
if (crc32("pgyhtBw",7) == 3236391670) strcat(s, "o");
if (crc32("XnccPOHEEmvf",12) == 3107067582) strcat(s, "d");
if (crc32("hGoaNqKNURA",11) == 32374917) strcat(s, "l");
if (crc32("PFcTZqur",8) == 1882301921) strcat(s, "U");
if (crc32("REEvCyCtfFU",11) == 2655263591) strcat(s, "y");
    return s;
}

char *overplainly_adverbs() {
    char *s = calloc(12);
    if (crc32("bULeb",5) == 464897938) strcat(s, "o");
if (crc32("IYyKK",5) == 50267455) strcat(s, "S");
if (crc32("MfMZrti",7) == 1250332046) strcat(s, "v");
if (crc32("wzJsob",6) == 4148198904) strcat(s, "e");
if (crc32("qnaIuNklAzfC",12) == 3796211208) strcat(s, "r");
if (crc32("UKRbyhj",7) == 1214936597) strcat(s, "O");
if (crc32("KEhmmMaPZzh",11) == 2336408525) strcat(s, "p");
if (crc32("jtZhWOAksYNJg",13) == 2482733811) strcat(s, "A");
if (crc32("nKcWDmkww",9) == 589824044) strcat(s, "l");
if (crc32("vLNfNfHelXAu",12) == 3538719500) strcat(s, "i");
if (crc32("RKBmXWP",7) == 1542986967) strcat(s, "a");
if (crc32("PqIWaiNWyuNrWK",14) == 1548287687) strcat(s, "i");
if (crc32("ODmIPVAZERViPqA",15) == 3377479948) strcat(s, "n");
if (crc32("XlskczmieHc",11) == 2728164095) strcat(s, "t");
if (crc32("lJNHDEP",7) == 1462536631) strcat(s, "l");
if (crc32("FfhmK",5) == 2017846593) strcat(s, "y");
    return s;
}

char *stupendously_adverbs() {
    char *s = calloc(13);
    if (crc32("NLqcyaPfbie",11) == 3600729728) strcat(s, "e");
if (crc32("IXPSFWVERvN",11) == 1867138872) strcat(s, "s");
if (crc32("ZUyls",5) == 1602867589) strcat(s, "r");
if (crc32("wvGkQB",6) == 2823061849) strcat(s, "t");
if (crc32("DPSqsm",6) == 2793583593) strcat(s, "u");
if (crc32("MaPGMhjqmHCNbj",14) == 3962005758) strcat(s, "k");
if (crc32("ZSAlS",5) == 659243817) strcat(s, "p");
if (crc32("yoMYYtgNznFKs",13) == 2074834089) strcat(s, "e");
if (crc32("YMDmn",5) == 2543167214) strcat(s, "n");
if (crc32("OGWVsSMrCVFsj",13) == 1763438699) strcat(s, "d");
if (crc32("HaOkjdzNTeLpb",13) == 3816035475) strcat(s, "o");
if (crc32("hxxAHpj",7) == 3567250382) strcat(s, "u");
if (crc32("aKeCeXNTmkW",11) == 4133064966) strcat(s, "o");
if (crc32("sANFa",5) == 3177860061) strcat(s, "s");
if (crc32("YYCqGXECMuEtK",13) == 2218119834) strcat(s, "O");
if (crc32("kPDInHZiMkLP",12) == 774013741) strcat(s, "l");
if (crc32("ldeuJcNNBC",10) == 1396765794) strcat(s, "v");
if (crc32("VyjFhJpf",8) == 4181089124) strcat(s, "y");
    return s;
}

char *cheerily_adverbs() {
    char *s = calloc(9);
    if (crc32("mJKhkCSbA",9) == 4218313674) strcat(s, "B");
if (crc32("epdQuhAvqbdHaw",14) == 935789450) strcat(s, "c");
if (crc32("RqhvVsFMFM",10) == 3729945352) strcat(s, "w");
if (crc32("iaTallvhGx",10) == 3008329791) strcat(s, "h");
if (crc32("qLziYxn",7) == 217407545) strcat(s, "E");
if (crc32("DKotHSsFIYoE",12) == 3818398052) strcat(s, "e");
if (crc32("CHxGx",5) == 1020640370) strcat(s, "e");
if (crc32("fzAXcMqobxp",11) == 1896406710) strcat(s, "P");
if (crc32("UdQfGouqDsyFb",13) == 303846566) strcat(s, "r");
if (crc32("WrOEgRCkQFH",11) == 2407762485) strcat(s, "y");
if (crc32("jgCroIMJfAAhg",13) == 3731075104) strcat(s, "i");
if (crc32("LdYJSZHf",8) == 2043245472) strcat(s, "l");
if (crc32("ImxSjce",7) == 3737590615) strcat(s, "y");
    return s;
}

char *unmetaphysically_adverbs() {
    char *s = calloc(17);
    if (crc32("PvnmFKfn",8) == 3086873046) strcat(s, "u");
if (crc32("WHmwfY",6) == 2088001959) strcat(s, "s");
if (crc32("JFwSDqanr",9) == 2466385151) strcat(s, "n");
if (crc32("GZDmQdIK",8) == 839378989) strcat(s, "s");
if (crc32("MXRlTsTJthTzxR",14) == 4030861626) strcat(s, "m");
if (crc32("yNKcpgFJxldpKg",14) == 3479617852) strcat(s, "Y");
if (crc32("gdbYoDICtg",10) == 2905178964) strcat(s, "e");
if (crc32("WZSDiv",6) == 1837939396) strcat(s, "D");
if (crc32("amoWrGLwMivsIZC",15) == 3888054922) strcat(s, "t");
if (crc32("FLBOOmZFrFMJV",13) == 3313989625) strcat(s, "u");
if (crc32("xQqzGEZSLksslcs",15) == 1448694697) strcat(s, "a");
if (crc32("OzQezxGVob",10) == 3850644793) strcat(s, "p");
if (crc32("mvJbSAGHYMmU",12) == 1231708050) strcat(s, "w");
if (crc32("SFhwvRXHA",9) == 2685961417) strcat(s, "h");
if (crc32("WiHJvytwSxWEJO",14) == 836234046) strcat(s, "y");
if (crc32("FLHDqJGt",8) == 31317646) strcat(s, "s");
if (crc32("VbEpWFQM",8) == 3305477285) strcat(s, "i");
if (crc32("SzKtMEFNxXC",11) == 4058845409) strcat(s, "o");
if (crc32("gLMWCPdztQzZCsB",15) == 997771280) strcat(s, "c");
if (crc32("VtMOznemzmhtCrc",15) == 128118676) strcat(s, "n");
if (crc32("ViYpYWRyQI",10) == 913824371) strcat(s, "a");
if (crc32("fKPZdqVW",8) == 4042822314) strcat(s, "C");
if (crc32("yRsCdM",6) == 3717647972) strcat(s, "l");
if (crc32("nnqJtpgYW",9) == 3885373432) strcat(s, "l");
if (crc32("FJaBVtOXlWAurcD",15) == 1205568460) strcat(s, "y");
    return s;
}

char *organizationally_adverbs() {
    char *s = calloc(17);
    if (crc32("wRmtCtTg",8) == 412990977) strcat(s, "o");
if (crc32("UxXqZzjJBAkp",12) == 2003628353) strcat(s, "r");
if (crc32("wfrJZyCMlCU",11) == 1515353261) strcat(s, "g");
if (crc32("qpkcvnvRmAXxLj",14) == 3255180883) strcat(s, "r");
if (crc32("GKhOd",5) == 455000171) strcat(s, "a");
if (crc32("VrGNiiKfCroQ",12) == 3864101374) strcat(s, "n");
if (crc32("kHdZExyNKS",10) == 3865899566) strcat(s, "C");
if (crc32("RHjmZPmI",8) == 3663176356) strcat(s, "i");
if (crc32("YCEzbnF",7) == 435036635) strcat(s, "z");
if (crc32("pOCoABZagWwwoRv",15) == 2054645555) strcat(s, "a");
if (crc32("GXShEvulMoLsmo",14) == 1991725364) strcat(s, "t");
if (crc32("MqYgxuVrlNo",11) == 3661170671) strcat(s, "t");
if (crc32("VEyYNlcHeEFzubN",15) == 869651681) strcat(s, "i");
if (crc32("ovmYzQzhkRddPQd",15) == 2195674445) strcat(s, "o");
if (crc32("pIczZLmQJm",10) == 2712169864) strcat(s, "L");
if (crc32("ILaVwmvyL",9) == 1313411596) strcat(s, "n");
if (crc32("AuZrl",5) == 3346418475) strcat(s, "a");
if (crc32("RTsecqoTJW",10) == 631541316) strcat(s, "H");
if (crc32("nMgLKYBgbE",10) == 664316022) strcat(s, "l");
if (crc32("rkKuJeWjDZLEalr",15) == 448718961) strcat(s, "l");
if (crc32("REmooS",6) == 4200008579) strcat(s, "y");
    return s;
}

char *nonfamiliarly_adverbs() {
    char *s = calloc(14);
    if (crc32("eTkXnjhSwQKnX",13) == 640834246) strcat(s, "j");
if (crc32("cBLGBXBUwPk",11) == 4291570829) strcat(s, "n");
if (crc32("IonAz",5) == 3950979644) strcat(s, "o");
if (crc32("JFCYCmGo",8) == 3991969500) strcat(s, "n");
if (crc32("nXlKd",5) == 2059430630) strcat(s, "O");
if (crc32("hGRaAmWrimePFf",14) == 997469169) strcat(s, "f");
if (crc32("WMStfvPFpOR",11) == 663176169) strcat(s, "a");
if (crc32("JJNhyZ",6) == 1158547330) strcat(s, "m");
if (crc32("qLbSbgHwfzzi",12) == 2403848245) strcat(s, "S");
if (crc32("PWuqkWvhFGb",11) == 3935708282) strcat(s, "i");
if (crc32("oCFgXqizVVEDu",13) == 3929382705) strcat(s, "l");
if (crc32("kfmStSnhxcQlQPH",15) == 2175784450) strcat(s, "m");
if (crc32("lqWhiD",6) == 3755368217) strcat(s, "i");
if (crc32("cthxTMb",7) == 2521330510) strcat(s, "y");
if (crc32("IjfRse",6) == 44595208) strcat(s, "a");
if (crc32("BuMqPuvZ",8) == 3461291066) strcat(s, "M");
if (crc32("FQLABDh",7) == 1739388090) strcat(s, "r");
if (crc32("OiOCsEi",7) == 3154184322) strcat(s, "l");
if (crc32("bHzeE",5) == 1703983781) strcat(s, "D");
if (crc32("eZzzaqXXt",9) == 3872267004) strcat(s, "y");
    return s;
}

char *nondevotionally_adverbs() {
    char *s = calloc(16);
    if (crc32("MeqwgMbM",8) == 78474381) strcat(s, "n");
if (crc32("maYPad",6) == 2640139772) strcat(s, "o");
if (crc32("vHyQBHQy",8) == 2487889745) strcat(s, "o");
if (crc32("YvMyHiBbsRWNpd",14) == 3845354622) strcat(s, "n");
if (crc32("VbxAGweQz",9) == 2038725925) strcat(s, "K");
if (crc32("MmlviDdcjs",10) == 123585773) strcat(s, "d");
if (crc32("TqeGrCdpIONCIJr",15) == 121923878) strcat(s, "e");
if (crc32("SeGKIUvwaP",10) == 315288121) strcat(s, "v");
if (crc32("zbDJpTESEnSA",12) == 2310573168) strcat(s, "K");
if (crc32("NdYEOkwX",8) == 526758683) strcat(s, "o");
if (crc32("WslwqrY",7) == 101680386) strcat(s, "t");
if (crc32("wgEqNAaPwHx",11) == 201660330) strcat(s, "o");
if (crc32("KZtZVUHWpvby",12) == 1982229875) strcat(s, "i");
if (crc32("vNWETGjymhv",11) == 3725780006) strcat(s, "o");
if (crc32("HwODWM",6) == 1346932404) strcat(s, "n");
if (crc32("qRaTJezBgRXhpG",14) == 489500380) strcat(s, "a");
if (crc32("GKCzJizYQjqkoPA",15) == 2362455830) strcat(s, "l");
if (crc32("ZJnOxb",6) == 3941692317) strcat(s, "l");
if (crc32("fvgxNcETjhzJf",13) == 2470310216) strcat(s, "a");
if (crc32("ibDQiuOmpDmESh",14) == 1365493972) strcat(s, "y");
    return s;
}

char *unthinkingly_adverbs() {
    char *s = calloc(13);
    if (crc32("FQDutble",8) == 4044834876) strcat(s, "u");
if (crc32("wktcluMevhfF",12) == 3174482240) strcat(s, "n");
if (crc32("aIdNHB",6) == 131865310) strcat(s, "H");
if (crc32("GXqyDIlfFDQwJZ",14) == 3251740965) strcat(s, "t");
if (crc32("hMKnPk",6) == 2089245884) strcat(s, "i");
if (crc32("KgaCBKRfzPsho",13) == 1571308822) strcat(s, "h");
if (crc32("ZMdIZAarcmLP",12) == 576953932) strcat(s, "i");
if (crc32("VWqVVq",6) == 2440525585) strcat(s, "n");
if (crc32("htwNZbPVf",9) == 4063614252) strcat(s, "k");
if (crc32("bySfefPN",8) == 2030670979) strcat(s, "i");
if (crc32("ZqPRug",6) == 4258189177) strcat(s, "n");
if (crc32("EeowLrhZYGOH",12) == 424657132) strcat(s, "g");
if (crc32("pzYsGTXs",8) == 2617780592) strcat(s, "q");
if (crc32("lTlfPNSCvYJukcd",15) == 59721261) strcat(s, "l");
if (crc32("ssndOoca",8) == 2290645347) strcat(s, "q");
if (crc32("csEalM",6) == 2771015382) strcat(s, "y");
    return s;
}

char *quasifashionably_adverbs() {
    char *s = calloc(17);
    if (crc32("iUTvvigmlieB",12) == 2809013374) strcat(s, "b");
if (crc32("BKvohga",7) == 1753056653) strcat(s, "q");
if (crc32("hQcXepjMBHrLVb",14) == 1508933220) strcat(s, "u");
if (crc32("HlzlertWKfY",11) == 3056445643) strcat(s, "a");
if (crc32("kYiwsQCD",8) == 88871576) strcat(s, "Y");
if (crc32("kAndKpaRbTLz",12) == 4094706470) strcat(s, "s");
if (crc32("GPXOnrdFExsvU",13) == 2287621157) strcat(s, "i");
if (crc32("FADVzs",6) == 1842025913) strcat(s, "f");
if (crc32("HIEXXTeiTsatT",13) == 2082879431) strcat(s, "a");
if (crc32("tigZoTXn",8) == 3839646599) strcat(s, "s");
if (crc32("tilejQZmAPF",11) == 762645763) strcat(s, "h");
if (crc32("tMMSZYrqxDzRPE",14) == 3086353337) strcat(s, "W");
if (crc32("ZxZqKDOVXdXhy",13) == 1586267919) strcat(s, "i");
if (crc32("ambJjObUFHx",11) == 3180698908) strcat(s, "z");
if (crc32("cDVSkqqx",8) == 4287149174) strcat(s, "o");
if (crc32("nsZvqr",6) == 1101919765) strcat(s, "n");
if (crc32("pUhHaRXLU",9) == 1802700711) strcat(s, "F");
if (crc32("ZPvLKpvZmgy",11) == 1768908185) strcat(s, "a");
if (crc32("Nsvfy",5) == 209862044) strcat(s, "n");
if (crc32("BJnYbGTQFkV",11) == 1924392315) strcat(s, "b");
if (crc32("wKWHbbuGzvzplV",14) == 632712965) strcat(s, "l");
if (crc32("GeImZqmVbKj",11) == 1365314994) strcat(s, "R");
if (crc32("pjiZmcySn",9) == 3426202537) strcat(s, "y");
    return s;
}

char *ruffly_adverbs() {
    char *s = calloc(7);
    if (crc32("GSpQe",5) == 1069564570) strcat(s, "r");
if (crc32("kogiNSJUCSIx",12) == 3404096605) strcat(s, "u");
if (crc32("EANhZEcbuAySYGy",15) == 3536123466) strcat(s, "x");
if (crc32("wcyUBqcAU",9) == 1079931840) strcat(s, "f");
if (crc32("HVBuxJbQ",8) == 1869937634) strcat(s, "U");
if (crc32("EiXeOQCtGttLM",13) == 2612957297) strcat(s, "f");
if (crc32("KBvpOcdlCcn",11) == 3448740408) strcat(s, "N");
if (crc32("mkgOmgMk",8) == 1934424453) strcat(s, "l");
if (crc32("jOMIQWY",7) == 2332007486) strcat(s, "x");
if (crc32("GiVxiN",6) == 2791463844) strcat(s, "y");
    return s;
}

char *dimensionally_adverbs() {
    char *s = calloc(14);
    if (crc32("jomwAXlRnDCV",12) == 4154030630) strcat(s, "d");
if (crc32("hRAnplnbjAd",11) == 2511325025) strcat(s, "X");
if (crc32("rYwGhQgRFyplY",13) == 3768277086) strcat(s, "i");
if (crc32("eCMFqBuIVyA",11) == 1357201901) strcat(s, "D");
if (crc32("radQiJsYrkcSqs",14) == 2033094384) strcat(s, "m");
if (crc32("NvDgPQTZURZPGIe",15) == 1474827765) strcat(s, "O");
if (crc32("OFdBPhgWEBcARFr",15) == 3778007236) strcat(s, "e");
if (crc32("hZBQxgPFDRkZ",12) == 2645736724) strcat(s, "l");
if (crc32("GGmjaSOG",8) == 3523718004) strcat(s, "n");
if (crc32("TjDIwSsP",8) == 2915643569) strcat(s, "s");
if (crc32("ZayFmugDWmZGrwT",15) == 2456330010) strcat(s, "y");
if (crc32("oCGwGEaTnzwnM",13) == 1804705174) strcat(s, "i");
if (crc32("ppfrKaqzgDiS",12) == 503582698) strcat(s, "o");
if (crc32("icLwJaQIfGjHRTl",15) == 1102089392) strcat(s, "N");
if (crc32("IKSOpl",6) == 2146676075) strcat(s, "n");
if (crc32("BEAUHdgnjHI",11) == 798300208) strcat(s, "a");
if (crc32("KrSGUvv",7) == 1317953930) strcat(s, "l");
if (crc32("fkLALXyTLkfBbLg",15) == 2765348450) strcat(s, "t");
if (crc32("DkkXEXXgqlaggf",14) == 1580275139) strcat(s, "l");
if (crc32("SIvXlvvTYQVzv",13) == 542136589) strcat(s, "y");
    return s;
}

char *unangularly_adverbs() {
    char *s = calloc(12);
    if (crc32("wzOScIqZQoon",12) == 2083371980) strcat(s, "y");
if (crc32("gvDwUZVIWiefI",13) == 4015042958) strcat(s, "u");
if (crc32("okecgQSzTTcl",12) == 406228540) strcat(s, "s");
if (crc32("EsvjZNgG",8) == 3415621177) strcat(s, "n");
if (crc32("LVHjeqrrsjQO",12) == 2829604680) strcat(s, "r");
if (crc32("JCcYWaNiUT",10) == 1207586318) strcat(s, "a");
if (crc32("iMZFnOQDZWzt",12) == 2184497530) strcat(s, "n");
if (crc32("iECZkjFFnf",10) == 337399986) strcat(s, "B");
if (crc32("jmCtyuJYSbxFwI",14) == 2918889949) strcat(s, "g");
if (crc32("MSrywlVtfkH",11) == 4270938591) strcat(s, "u");
if (crc32("mrZKQLt",7) == 4248994719) strcat(s, "q");
if (crc32("nEonDIa",7) == 3044447019) strcat(s, "l");
if (crc32("kjoDi",5) == 2678815174) strcat(s, "a");
if (crc32("EyNlgGuZagSw",12) == 2712042705) strcat(s, "j");
if (crc32("hybQgUQuRgH",11) == 378970463) strcat(s, "r");
if (crc32("MDxgZDyDenvogx",14) == 2615802214) strcat(s, "w");
if (crc32("RPzRogOYHiv",11) == 4155947632) strcat(s, "l");
if (crc32("fENMiamBOCoVied",15) == 2472166211) strcat(s, "y");
    return s;
}

char *unviolently_adverbs() {
    char *s = calloc(12);
    if (crc32("qDStrxwLZpeH",12) == 2011012941) strcat(s, "u");
if (crc32("OxEYFJUKSoK",11) == 4163539868) strcat(s, "R");
if (crc32("fBTZVEpsVEkC",12) == 2765932577) strcat(s, "n");
if (crc32("aazLfKw",7) == 1457977894) strcat(s, "k");
if (crc32("rhtsVGUKKVfE",12) == 529514785) strcat(s, "v");
if (crc32("utMRmQJVtsxYd",13) == 694438215) strcat(s, "F");
if (crc32("pkFJxLCAzcOaGBg",15) == 3960748567) strcat(s, "i");
if (crc32("iJRroMBcbLgX",12) == 77836893) strcat(s, "d");
if (crc32("CBjLpHauBGgt",12) == 1549614483) strcat(s, "o");
if (crc32("zcnxhHGI",8) == 697557519) strcat(s, "l");
if (crc32("kFMUtRMONVhwU",13) == 3349898163) strcat(s, "f");
if (crc32("vskdQnEAYwzVn",13) == 1129384342) strcat(s, "e");
if (crc32("cWpVHMWpIkHZIfk",15) == 871895478) strcat(s, "l");
if (crc32("BsiJPvyrtqtLqL",14) == 2241444422) strcat(s, "n");
if (crc32("AakpJUBh",8) == 641372332) strcat(s, "c");
if (crc32("SYZehhAlEvXNo",13) == 3252246361) strcat(s, "t");
if (crc32("MBPJg",5) == 3802171031) strcat(s, "l");
if (crc32("eOjfpAOKemMD",12) == 3148678900) strcat(s, "o");
if (crc32("YLwuPQ",6) == 88425340) strcat(s, "y");
    return s;
}

char *verbally_adverbs() {
    char *s = calloc(9);
    if (crc32("OFbPxvPLP",9) == 3298454826) strcat(s, "v");
if (crc32("cgZCsMrCN",9) == 3448193125) strcat(s, "z");
if (crc32("atJGg",5) == 2546907908) strcat(s, "e");
if (crc32("JNCxqZhxhxnakk",14) == 4203224871) strcat(s, "b");
if (crc32("GCKVC",5) == 3668642894) strcat(s, "r");
if (crc32("oTypGL",6) == 3210301795) strcat(s, "p");
if (crc32("zgCdfqkNO",9) == 3066464688) strcat(s, "b");
if (crc32("BcMCgkzeBvkd",12) == 2834459463) strcat(s, "K");
if (crc32("hxEldmcTHxS",11) == 1294745235) strcat(s, "a");
if (crc32("yMnSlarjui",10) == 677609637) strcat(s, "l");
if (crc32("MEOYk",5) == 5527514) strcat(s, "l");
if (crc32("DcQOSNJPgCo",11) == 2807691196) strcat(s, "j");
if (crc32("HcuoOUlaZaqUiMv",15) == 2755664310) strcat(s, "y");
    return s;
}

char *nonritualistically_adverbs() {
    char *s = calloc(19);
    if (crc32("oIDqqGgZySq",11) == 332694863) strcat(s, "n");
if (crc32("VunGXHUuXBEul",13) == 614818350) strcat(s, "o");
if (crc32("kGYCxqhH",8) == 1934029260) strcat(s, "n");
if (crc32("ShCCwPPzFbiyuL",14) == 2807071082) strcat(s, "r");
if (crc32("twZZFTXar",9) == 4144599365) strcat(s, "j");
if (crc32("SWkldTBmr",9) == 824791504) strcat(s, "i");
if (crc32("kKCwKaWdzLPGJ",13) == 2868646840) strcat(s, "p");
if (crc32("SWxeIfznHAWXXZ",14) == 487840545) strcat(s, "t");
if (crc32("QjDVBi",6) == 464744341) strcat(s, "q");
if (crc32("ujCLeYBVOA",10) == 1546790072) strcat(s, "u");
if (crc32("CrXmt",5) == 4258488916) strcat(s, "a");
if (crc32("dhUxZPAOy",9) == 708124577) strcat(s, "F");
if (crc32("yJFFRjtxbsCQ",12) == 2844370663) strcat(s, "l");
if (crc32("vxAiccEJBCu",11) == 257785708) strcat(s, "E");
if (crc32("CBHfAyVE",8) == 1979864977) strcat(s, "i");
if (crc32("RwgyvUUmcSsL",12) == 160805950) strcat(s, "s");
if (crc32("XQCYfQ",6) == 2849851637) strcat(s, "W");
if (crc32("TsqPxOMesB",10) == 1594100347) strcat(s, "t");
if (crc32("BUMTDFp",7) == 3531339765) strcat(s, "s");
if (crc32("bPgJUsvmUiAXkW",14) == 830635235) strcat(s, "i");
if (crc32("NqVURKCbTCCT",12) == 2872342036) strcat(s, "c");
if (crc32("ApoqaAdpmri",11) == 3993524306) strcat(s, "a");
if (crc32("KMoUePwFiqf",11) == 3033066726) strcat(s, "P");
if (crc32("UcYlvYXIG",9) == 585686714) strcat(s, "l");
if (crc32("iCQisqtgMqRi",12) == 1952315482) strcat(s, "l");
if (crc32("MMGqFep",7) == 247369337) strcat(s, "y");
    return s;
}

char *unexorbitantly_adverbs() {
    char *s = calloc(15);
    if (crc32("aBFHBbzUtuOyR",13) == 2512735379) strcat(s, "u");
if (crc32("kybtiunFGjDuT",13) == 1239042751) strcat(s, "n");
if (crc32("qbRcsniNGDHP",12) == 125306633) strcat(s, "e");
if (crc32("yuNMfYtMQdo",11) == 1298787341) strcat(s, "x");
if (crc32("EwodHYE",7) == 4178824318) strcat(s, "k");
if (crc32("DUjYrKQ",7) == 1282962182) strcat(s, "o");
if (crc32("EyEjSIZQYngQjU",14) == 271720457) strcat(s, "r");
if (crc32("SHzCLDVxBkyrXFr",15) == 917205785) strcat(s, "b");
if (crc32("IqGTJNH",7) == 1385015112) strcat(s, "n");
if (crc32("xuBHAyyTaFe",11) == 2567461523) strcat(s, "i");
if (crc32("ONTomuDwaOJLUzq",15) == 1985449089) strcat(s, "t");
if (crc32("uWntoI",6) == 3365528385) strcat(s, "Y");
if (crc32("pcCpcYsONBjI",12) == 880574374) strcat(s, "a");
if (crc32("KXPMwEt",7) == 3775417340) strcat(s, "n");
if (crc32("CjvhU",5) == 1494872456) strcat(s, "l");
if (crc32("yjEQdmtf",8) == 3100932965) strcat(s, "t");
if (crc32("gqXWLaVPuZebK",13) == 3609080936) strcat(s, "C");
if (crc32("gkctbgMU",8) == 921576241) strcat(s, "l");
if (crc32("vYStr",5) == 2635570769) strcat(s, "y");
    return s;
}

char *uncausatively_adverbs() {
    char *s = calloc(14);
    if (crc32("hDXSZhFOwOHmqS",14) == 4112067133) strcat(s, "M");
if (crc32("UCexWsZUxHzxFf",14) == 1925778201) strcat(s, "u");
if (crc32("ycazEQRWuYvBaJr",15) == 1980145659) strcat(s, "s");
if (crc32("XkcYeDi",7) == 1771409588) strcat(s, "n");
if (crc32("qyTdfslbqN",10) == 1497425815) strcat(s, "A");
if (crc32("XrJEtECKB",9) == 654555950) strcat(s, "c");
if (crc32("VWgBFWQ",7) == 2634821960) strcat(s, "d");
if (crc32("zhrMNd",6) == 795345606) strcat(s, "a");
if (crc32("DrMgrHIJpmvuvb",14) == 1018241002) strcat(s, "H");
if (crc32("dHEdDLMKv",9) == 917524372) strcat(s, "u");
if (crc32("HVmjDfJUfrVG",12) == 1711633029) strcat(s, "s");
if (crc32("aiRuZe",6) == 2834966011) strcat(s, "a");
if (crc32("aDrFXsHI",8) == 936436344) strcat(s, "t");
if (crc32("QvFYWKAtsWUvtG",14) == 1608374371) strcat(s, "i");
if (crc32("XlPpQF",6) == 2923322935) strcat(s, "v");
if (crc32("PbOPktRSvjlL",12) == 712712856) strcat(s, "n");
if (crc32("YxYPBfDg",8) == 3654969058) strcat(s, "e");
if (crc32("GbwSarFLfQvK",12) == 471099199) strcat(s, "Z");
if (crc32("BJswQbF",7) == 229325081) strcat(s, "l");
if (crc32("RRuCK",5) == 2751194177) strcat(s, "t");
if (crc32("cOwAw",5) == 2910476005) strcat(s, "y");
    return s;
}

char *awfully_adverbs() {
    char *s = calloc(8);
    if (crc32("WjvXpxFc",8) == 1101246948) strcat(s, "Z");
if (crc32("eMLRI",5) == 8600966) strcat(s, "a");
if (crc32("hjCKVWgTJ",9) == 3022716449) strcat(s, "w");
if (crc32("XWkwR",5) == 3684956633) strcat(s, "X");
if (crc32("BaxbDnka",8) == 3445308619) strcat(s, "f");
if (crc32("OHzronGCgpGdhCX",15) == 2180869835) strcat(s, "u");
if (crc32("cFywMhEaHu",10) == 1261108927) strcat(s, "p");
if (crc32("JMIsCCqyFXQQk",13) == 2107275612) strcat(s, "l");
if (crc32("hOdvUa",6) == 2525458277) strcat(s, "l");
if (crc32("ICyRfpMAltfN",12) == 1665125023) strcat(s, "y");
    return s;
}

char *overproportionately_adverbs() {
    char *s = calloc(20);
    if (crc32("GYnjEKJKIXBrN",13) == 1795220280) strcat(s, "o");
if (crc32("KstVtZUWkyiCtX",14) == 13197295) strcat(s, "v");
if (crc32("wjImUiPDuQ",10) == 136895549) strcat(s, "Z");
if (crc32("RntPaUjG",8) == 2672801621) strcat(s, "e");
if (crc32("GrtgwzJ",7) == 3807311569) strcat(s, "r");
if (crc32("EMAscuy",7) == 360764363) strcat(s, "p");
if (crc32("sEbmKfZOYRhlfS",14) == 2423320317) strcat(s, "r");
if (crc32("YMnfPJWD",8) == 4099379600) strcat(s, "S");
if (crc32("FaduCQ",6) == 3990331748) strcat(s, "o");
if (crc32("QPNhoiBZKdQKAa",14) == 3099943659) strcat(s, "p");
if (crc32("MdGERE",6) == 2418003194) strcat(s, "o");
if (crc32("cmljmGdxWCa",11) == 3485678564) strcat(s, "r");
if (crc32("vKuYOSrrzpDOD",13) == 1668373780) strcat(s, "N");
if (crc32("aazXWnSvS",9) == 2913139119) strcat(s, "t");
if (crc32("BlRvzNbuB",9) == 1031448093) strcat(s, "u");
if (crc32("sOkVrOwKgbyj",12) == 2666848872) strcat(s, "i");
if (crc32("ARQfx",5) == 1891365345) strcat(s, "I");
if (crc32("DaBJvEyKm",9) == 2778189390) strcat(s, "o");
if (crc32("XVhGYwnkODd",11) == 374365764) strcat(s, "n");
if (crc32("NDLMCSONbnFYEBu",15) == 3658539487) strcat(s, "a");
if (crc32("VngUOhpMyXlk",12) == 1672401505) strcat(s, "e");
if (crc32("kbIUVl",6) == 344807002) strcat(s, "t");
if (crc32("Iacmy",5) == 3711524275) strcat(s, "p");
if (crc32("WTaQwljkHPPXZ",13) == 3957397664) strcat(s, "e");
if (crc32("AtpKI",5) == 220584119) strcat(s, "g");
if (crc32("IaRKJxKvfuMw",12) == 360034627) strcat(s, "l");
if (crc32("qJuZazXzPXyvTvQ",15) == 562021181) strcat(s, "T");
if (crc32("dBWeSloes",9) == 2923136671) strcat(s, "y");
    return s;
}

char *intracutaneously_adverbs() {
    char *s = calloc(17);
    if (crc32("VWqvukTTTV",10) == 1761177343) strcat(s, "i");
if (crc32("DwEPgB",6) == 484544101) strcat(s, "n");
if (crc32("MlWnoPkXgE",10) == 3800613780) strcat(s, "d");
if (crc32("GsuEENGtW",9) == 3216085911) strcat(s, "t");
if (crc32("HrpZoT",6) == 1437365106) strcat(s, "r");
if (crc32("zxooFYvyyCcTRkY",15) == 4203324937) strcat(s, "k");
if (crc32("txNgLKxWgujt",12) == 3385077107) strcat(s, "a");
if (crc32("EIEUcKFQAhzoqFo",15) == 3454630511) strcat(s, "G");
if (crc32("LaCCKpZDgFKvqyr",15) == 2761745986) strcat(s, "c");
if (crc32("pEnMb",5) == 924346571) strcat(s, "u");
if (crc32("ixBchr",6) == 1971253668) strcat(s, "s");
if (crc32("upXLQ",5) == 3189778013) strcat(s, "t");
if (crc32("WBTRUC",6) == 2167687637) strcat(s, "a");
if (crc32("JvmyuhtapQb",11) == 1420957779) strcat(s, "X");
if (crc32("PmXFZ",5) == 2018457705) strcat(s, "n");
if (crc32("JHruQTaxpHEvwtC",15) == 85229648) strcat(s, "C");
if (crc32("JEQqBFkuob",10) == 1197685435) strcat(s, "e");
if (crc32("luRUjLSOXBi",11) == 935461962) strcat(s, "H");
if (crc32("qTPJWtn",7) == 75297034) strcat(s, "o");
if (crc32("KNyigiMLqIAPfCO",15) == 2033044006) strcat(s, "u");
if (crc32("xUfRBvHoACxiMe",14) == 3016920862) strcat(s, "Z");
if (crc32("DBSScfQ",7) == 2901010462) strcat(s, "s");
if (crc32("wxcfZFAdSKVF",12) == 1514051796) strcat(s, "e");
if (crc32("nwjgEoL",7) == 3471786001) strcat(s, "l");
if (crc32("lywdfmTfUM",10) == 3068639514) strcat(s, "W");
if (crc32("hoSWb",5) == 882472906) strcat(s, "y");
    return s;
}

char *cannibalistically_adverbs() {
    char *s = calloc(18);
    if (crc32("GnFzxz",6) == 900912096) strcat(s, "c");
if (crc32("fZOdTlQgqOUg",12) == 2610066167) strcat(s, "w");
if (crc32("gOiWvsKaHUBreJ",14) == 3597977333) strcat(s, "a");
if (crc32("MkzDCj",6) == 3921940265) strcat(s, "n");
if (crc32("jFhBnI",6) == 495026221) strcat(s, "j");
if (crc32("DjLzimLYEWiiLOl",15) == 3261788980) strcat(s, "n");
if (crc32("PBLOywuKPd",10) == 3508452801) strcat(s, "i");
if (crc32("fZSFwjhufv",10) == 3350289445) strcat(s, "b");
if (crc32("RYfHceUpSK",10) == 3602320594) strcat(s, "k");
if (crc32("xiAPZdcIDzLA",12) == 29042663) strcat(s, "a");
if (crc32("JtkXhlXUV",9) == 320521783) strcat(s, "l");
if (crc32("yUpgWuHqlKt",11) == 2860333929) strcat(s, "w");
if (crc32("keGqOnPhd",9) == 1811617133) strcat(s, "i");
if (crc32("XiKWlkhgazGVrwi",15) == 1746632948) strcat(s, "s");
if (crc32("hUaLwOxQdxkibY",14) == 1685852005) strcat(s, "L");
if (crc32("yuctTrYoQjbAM",13) == 3455592854) strcat(s, "t");
if (crc32("qySqh",5) == 252764224) strcat(s, "i");
if (crc32("KlWzGNwW",8) == 379325514) strcat(s, "c");
if (crc32("NOATEx",6) == 3321822813) strcat(s, "a");
if (crc32("DshyGcBxlLEb",12) == 2243319254) strcat(s, "l");
if (crc32("HeVDgO",6) == 3545622877) strcat(s, "C");
if (crc32("UXwkoRybRNjnnkl",15) == 1509744007) strcat(s, "l");
if (crc32("OHcFh",5) == 3992599751) strcat(s, "y");
    return s;
}

char *thereat_adverbs() {
    char *s = calloc(8);
    if (crc32("FpuFwVlqFMEq",12) == 81153213) strcat(s, "s");
if (crc32("lqcfL",5) == 1329536587) strcat(s, "t");
if (crc32("zyMabCRqLGQdHM",14) == 795146893) strcat(s, "K");
if (crc32("yPlzcuoH",8) == 3631728566) strcat(s, "h");
if (crc32("JmpMjkvE",8) == 3640307724) strcat(s, "m");
if (crc32("qQmJLQAzwKUXFwL",15) == 3860812223) strcat(s, "e");
if (crc32("tYvXhfYP",8) == 3964533798) strcat(s, "F");
if (crc32("ntxiYdQbNoMg",12) == 1591915359) strcat(s, "r");
if (crc32("cspqJibZKZGP",12) == 3417556404) strcat(s, "o");
if (crc32("sUxnDfTUUKDDouU",15) == 1835752502) strcat(s, "e");
if (crc32("TukWi",5) == 3527866390) strcat(s, "a");
if (crc32("NnfNRi",6) == 3642441757) strcat(s, "N");
if (crc32("FvxCXkjZU",9) == 2376383201) strcat(s, "t");
    return s;
}

char *culturally_adverbs() {
    char *s = calloc(11);
    if (crc32("sVdhdPIFL",9) == 2662991295) strcat(s, "o");
if (crc32("Xuuzq",5) == 843602388) strcat(s, "c");
if (crc32("RDjNOOtIxu",10) == 4030226103) strcat(s, "u");
if (crc32("sJhJrrcVzzw",11) == 2500282272) strcat(s, "l");
if (crc32("VmIblGIH",8) == 4182833429) strcat(s, "T");
if (crc32("QPTvIGhyeKVmyF",14) == 1363945578) strcat(s, "t");
if (crc32("YQwjSnQKAtqS",12) == 3794335607) strcat(s, "u");
if (crc32("KpmxbPLQlthnuSl",15) == 2065356372) strcat(s, "r");
if (crc32("foYcCREqvsNNR",13) == 2052410349) strcat(s, "a");
if (crc32("HaDVlVmOYW",10) == 1124701711) strcat(s, "T");
if (crc32("PRqjTwdL",8) == 4237828225) strcat(s, "l");
if (crc32("POjZU",5) == 592654062) strcat(s, "l");
if (crc32("IfTtLJg",7) == 1911330621) strcat(s, "M");
if (crc32("tOYRmQWHxLeAyv",14) == 284938975) strcat(s, "y");
    return s;
}

char *smudgedly_adverbs() {
    char *s = calloc(10);
    if (crc32("qIaFlNaqzuOfPOM",15) == 3201702107) strcat(s, "s");
if (crc32("waBpM",5) == 2515909196) strcat(s, "k");
if (crc32("pMRKSbZt",8) == 119285021) strcat(s, "m");
if (crc32("JQvIQZaRiC",10) == 3064898771) strcat(s, "u");
if (crc32("QmYeVoxK",8) == 1665147785) strcat(s, "o");
if (crc32("duxsUQcykMmC",12) == 3126976111) strcat(s, "d");
if (crc32("vTEii",5) == 48184510) strcat(s, "g");
if (crc32("dnfecqcEnfx",11) == 1408819982) strcat(s, "O");
if (crc32("TzaZKqsA",8) == 1370628301) strcat(s, "e");
if (crc32("DdSXahoJzhnTV",13) == 3670409607) strcat(s, "d");
if (crc32("ReUHVFWdPUFCVD",14) == 573134768) strcat(s, "S");
if (crc32("KhlPjpnSsBML",12) == 3114129954) strcat(s, "l");
if (crc32("AgPLYqn",7) == 1937771381) strcat(s, "M");
if (crc32("xTLzqfeytmYa",12) == 2701532491) strcat(s, "y");
    return s;
}

char *nonhieratically_adverbs() {
    char *s = calloc(16);
    if (crc32("qEECZh",6) == 1015312348) strcat(s, "n");
if (crc32("pIfOvmZjWIZoF",13) == 1507401222) strcat(s, "o");
if (crc32("uYGUpKL",7) == 648802593) strcat(s, "n");
if (crc32("CjTuMtXK",8) == 3079519022) strcat(s, "a");
if (crc32("DlcpTeqhLoxQPPi",15) == 2667836096) strcat(s, "h");
if (crc32("uGgIlagHHe",10) == 1153434536) strcat(s, "i");
if (crc32("hKnBQpLeS",9) == 293132441) strcat(s, "e");
if (crc32("MBivOJvQwnctsi",14) == 2968607299) strcat(s, "Q");
if (crc32("aenoUWSKfHk",11) == 2904785206) strcat(s, "r");
if (crc32("zwUswRVHHRrIv",13) == 762985815) strcat(s, "a");
if (crc32("CtVOLcqD",8) == 111515119) strcat(s, "t");
if (crc32("OEhobCQt",8) == 3140201621) strcat(s, "i");
if (crc32("pilCxGfHjwW",11) == 4029368364) strcat(s, "i");
if (crc32("HegYgylvcx",10) == 2697507948) strcat(s, "n");
if (crc32("FQCIvpvMqqEZ",12) == 1632117576) strcat(s, "c");
if (crc32("oBAOyG",6) == 611906604) strcat(s, "a");
if (crc32("IExtjrbcruq",11) == 1031620285) strcat(s, "j");
if (crc32("CrxWsrddWnOwqA",14) == 1069854876) strcat(s, "l");
if (crc32("VGwWbQ",6) == 381253492) strcat(s, "i");
if (crc32("SxsncmZXGeY",11) == 1858917648) strcat(s, "l");
if (crc32("qaNkFARFGQNUzA",14) == 1022183286) strcat(s, "X");
if (crc32("EWbtaJB",7) == 1177192493) strcat(s, "y");
    return s;
}

char *nonmeteorically_adverbs() {
    char *s = calloc(16);
    if (crc32("HLxkWtHImq",10) == 1797693846) strcat(s, "n");
if (crc32("kEiNefiQyy",10) == 986453442) strcat(s, "T");
if (crc32("ICvSs",5) == 310771717) strcat(s, "o");
if (crc32("iRDZjfHjZpl",11) == 2097477313) strcat(s, "n");
if (crc32("YseYCGLSi",9) == 3863966462) strcat(s, "f");
if (crc32("tAKEz",5) == 2831798025) strcat(s, "m");
if (crc32("jCiTxkZUiMXw",12) == 3722145505) strcat(s, "e");
if (crc32("AleIECyxLxK",11) == 761444739) strcat(s, "t");
if (crc32("cSZBejRmo",9) == 4199824595) strcat(s, "e");
if (crc32("uhncBxSFyRF",11) == 1430005533) strcat(s, "o");
if (crc32("YjEnFP",6) == 1779064866) strcat(s, "r");
if (crc32("HYVYp",5) == 925262381) strcat(s, "J");
if (crc32("btTeDXNOxnow",12) == 3314992573) strcat(s, "i");
if (crc32("HnlQkuZ",7) == 842021371) strcat(s, "f");
if (crc32("ZZyywLRG",8) == 299065165) strcat(s, "c");
if (crc32("xPivydQoUzDS",12) == 1559378046) strcat(s, "a");
if (crc32("HzspvZxRPeu",11) == 979969401) strcat(s, "F");
if (crc32("hfqCN",5) == 1848512888) strcat(s, "l");
if (crc32("yeVxyQE",7) == 3688484124) strcat(s, "f");
if (crc32("xnGLRRZZhzxb",12) == 2157990319) strcat(s, "l");
if (crc32("TZDixeIhSZ",10) == 3087185002) strcat(s, "i");
if (crc32("YpaKtM",6) == 3757730763) strcat(s, "y");
    return s;
}

char *rectangularly_adverbs() {
    char *s = calloc(14);
    if (crc32("LvmluzUrd",9) == 1714631750) strcat(s, "S");
if (crc32("qmVaQDHgj",9) == 566621807) strcat(s, "r");
if (crc32("dlGXsBbo",8) == 3635592180) strcat(s, "b");
if (crc32("nwopQHk",7) == 2938219749) strcat(s, "e");
if (crc32("diERHgXESPr",11) == 1420060083) strcat(s, "J");
if (crc32("zQvuUtM",7) == 295478028) strcat(s, "c");
if (crc32("YARgYqvyd",9) == 3708659250) strcat(s, "u");
if (crc32("KNpyyS",6) == 253660310) strcat(s, "t");
if (crc32("nFnYxCDPBAr",11) == 2814670807) strcat(s, "M");
if (crc32("VKScIXhxEf",10) == 3341543289) strcat(s, "a");
if (crc32("PXvarGrFhHM",11) == 80518446) strcat(s, "n");
if (crc32("CwCetYxS",8) == 2706744697) strcat(s, "g");
if (crc32("wDXvHghuORd",11) == 2790789771) strcat(s, "u");
if (crc32("UNidNAWJGWW",11) == 2650179273) strcat(s, "l");
if (crc32("dKUJoRKGK",9) == 348189161) strcat(s, "a");
if (crc32("xjxHSWdd",8) == 1101416792) strcat(s, "r");
if (crc32("VXwgEkBd",8) == 3755657902) strcat(s, "T");
if (crc32("tCAFYTVahhIOX",13) == 6050072) strcat(s, "l");
if (crc32("bHmJwVPw",8) == 3424807985) strcat(s, "y");
    return s;
}

char *balefully_adverbs() {
    char *s = calloc(10);
    if (crc32("Dpqbs",5) == 3415900876) strcat(s, "b");
if (crc32("IaTXXY",6) == 2077392139) strcat(s, "a");
if (crc32("HqZOKi",6) == 419546548) strcat(s, "I");
if (crc32("rzktuFqOdEnyu",13) == 713172020) strcat(s, "l");
if (crc32("boiCNp",6) == 2796012706) strcat(s, "U");
if (crc32("PTLSakEwrpre",12) == 1947285894) strcat(s, "e");
if (crc32("WdIFWHPeJ",9) == 4137912245) strcat(s, "P");
if (crc32("ZZmQnfbnxi",10) == 1089404177) strcat(s, "f");
if (crc32("MurZFe",6) == 147876235) strcat(s, "u");
if (crc32("bRynziC",7) == 3987997826) strcat(s, "l");
if (crc32("rHEbk",5) == 2894676379) strcat(s, "m");
if (crc32("VHxpdHcMjWFUfZr",15) == 3503511439) strcat(s, "l");
if (crc32("nNMAkagNBOzj",12) == 1828115561) strcat(s, "o");
if (crc32("epWNaldPM",9) == 2804410419) strcat(s, "y");
    return s;
}

char *quasivenerably_adverbs() {
    char *s = calloc(15);
    if (crc32("dTYIwlCnqTfAWKP",15) == 1670695702) strcat(s, "W");
if (crc32("vNgrqR",6) == 3384779452) strcat(s, "q");
if (crc32("dijHsEOuHCoJlF",14) == 271779659) strcat(s, "u");
if (crc32("UuzRlbEYhQgbkIv",15) == 2677909225) strcat(s, "Z");
if (crc32("PkHpzxiZ",8) == 3264040298) strcat(s, "a");
if (crc32("wHqmzFjdhvQ",11) == 1222090514) strcat(s, "s");
if (crc32("NajpdzsEl",9) == 3034158821) strcat(s, "R");
if (crc32("XqBaphlFJuA",11) == 2562251933) strcat(s, "i");
if (crc32("BKKucAObzk",10) == 1640906485) strcat(s, "M");
if (crc32("DplzhmY",7) == 4201267011) strcat(s, "v");
if (crc32("xrIdFIbdIy",10) == 3407562128) strcat(s, "e");
if (crc32("dPNkTYYcPJYZv",13) == 2099790022) strcat(s, "y");
if (crc32("oCaiswZj",8) == 2340915046) strcat(s, "n");
if (crc32("fdmEb",5) == 43069201) strcat(s, "U");
if (crc32("Gotaf",5) == 3296446998) strcat(s, "e");
if (crc32("UaEtbtDQbDxe",12) == 3911948459) strcat(s, "B");
if (crc32("yXGMDqUGxOOMwn",14) == 1063037170) strcat(s, "r");
if (crc32("dAnqF",5) == 2768256866) strcat(s, "c");
if (crc32("LjytatZUa",9) == 2862266478) strcat(s, "a");
if (crc32("nmoCJrPDXuUxQ",13) == 4160820419) strcat(s, "T");
if (crc32("wfJFJSKmhdxhguy",15) == 1039466849) strcat(s, "b");
if (crc32("YLQOYLtzSyNz",12) == 3876144409) strcat(s, "l");
if (crc32("dlEuQQxcRuSsmCa",15) == 3767825749) strcat(s, "J");
if (crc32("iBSvQwsWovjPEKm",15) == 3921867464) strcat(s, "y");
    return s;
}

char *Jacobitically_adverbs() {
    char *s = calloc(14);
    if (crc32("BKLjmfBg",8) == 1996611505) strcat(s, "J");
if (crc32("WAUVcQawBEutnmD",15) == 297157717) strcat(s, "a");
if (crc32("hukhrGJjjixz",12) == 1818961459) strcat(s, "k");
if (crc32("WjzvXXrgpHn",11) == 3760884979) strcat(s, "c");
if (crc32("VvOQbio",7) == 2338453785) strcat(s, "o");
if (crc32("eFaYUxTfgDc",11) == 3547720991) strcat(s, "X");
if (crc32("ZNvpUEn",7) == 2135272492) strcat(s, "b");
if (crc32("IGrGpqlaM",9) == 371544989) strcat(s, "V");
if (crc32("FnoMbBz",7) == 3281599360) strcat(s, "i");
if (crc32("fBjbnYweUxl",11) == 1357118484) strcat(s, "d");
if (crc32("JkAcTi",6) == 1919141240) strcat(s, "t");
if (crc32("pqLMvCqs",8) == 4115432544) strcat(s, "u");
if (crc32("uRCYymLIkAFvN",13) == 2668241206) strcat(s, "i");
if (crc32("nShzMXeZVixo",12) == 3890534682) strcat(s, "c");
if (crc32("SpGDwgukcxRFIsc",15) == 3233757821) strcat(s, "y");
if (crc32("sFtoeEdbsIE",11) == 828068853) strcat(s, "a");
if (crc32("eYkFJOvx",8) == 1240329443) strcat(s, "x");
if (crc32("URFIsGnkd",9) == 4033737815) strcat(s, "l");
if (crc32("yCiBFJZkgGMLk",13) == 3879905941) strcat(s, "l");
if (crc32("LjBhT",5) == 3179706590) strcat(s, "y");
    return s;
}

char *sinistrad_adverbs() {
    char *s = calloc(10);
    if (crc32("leyhlRiVS",9) == 2967892736) strcat(s, "z");
if (crc32("OCSPTSAsCvTF",12) == 2003517241) strcat(s, "s");
if (crc32("ijQIt",5) == 490139816) strcat(s, "i");
if (crc32("KPiHbChFN",9) == 3536053702) strcat(s, "X");
if (crc32("jCjhbhGw",8) == 4151673859) strcat(s, "n");
if (crc32("oKxIxkuAd",9) == 855042874) strcat(s, "i");
if (crc32("raZkIjhWmFmjjGa",15) == 398611281) strcat(s, "s");
if (crc32("AhAKBkMX",8) == 1019027842) strcat(s, "c");
if (crc32("XxrRiEYBYFRJ",12) == 2817060900) strcat(s, "t");
if (crc32("lSEOPQQZq",9) == 775972771) strcat(s, "r");
if (crc32("XyvLKGAJjfqU",12) == 298107507) strcat(s, "a");
if (crc32("uZlgQohvuak",11) == 1159157251) strcat(s, "d");
    return s;
}

char *logogrammatically_adverbs() {
    char *s = calloc(18);
    if (crc32("guaGuDIg",8) == 2974135029) strcat(s, "Y");
if (crc32("cXguDXongWT",11) == 2426850423) strcat(s, "l");
if (crc32("GRpOTtlDXR",10) == 3077705618) strcat(s, "o");
if (crc32("OFEYVKaWaTpoW",13) == 2841994901) strcat(s, "D");
if (crc32("bgDTvJPxb",9) == 3274997673) strcat(s, "g");
if (crc32("kzpPUxvG",8) == 2758206160) strcat(s, "o");
if (crc32("edTLFRLchWLLv",13) == 976641714) strcat(s, "o");
if (crc32("kVmzZekeQZbQ",12) == 2218721163) strcat(s, "g");
if (crc32("xDNFZawuF",9) == 3405025594) strcat(s, "S");
if (crc32("CKgtAcAXXOzOePP",15) == 902403102) strcat(s, "r");
if (crc32("lqPDfBurkrzSUCQ",15) == 4148594504) strcat(s, "p");
if (crc32("bngVl",5) == 458512644) strcat(s, "a");
if (crc32("SxTkMfevMJhhpw",14) == 2376988368) strcat(s, "m");
if (crc32("rMsRRg",6) == 460552399) strcat(s, "F");
if (crc32("rPUxxLQfWCA",11) == 1022500224) strcat(s, "m");
if (crc32("tVKOFzSZ",8) == 2363920102) strcat(s, "d");
if (crc32("qUhQpz",6) == 2370586051) strcat(s, "a");
if (crc32("oCwcHWzvOnbsm",13) == 3662081843) strcat(s, "j");
if (crc32("XuksqrFlYz",10) == 3289086042) strcat(s, "t");
if (crc32("cHSysse",7) == 3617376157) strcat(s, "A");
if (crc32("syxNLYwuFlKp",12) == 233840563) strcat(s, "i");
if (crc32("miggrCUtBFgUlT",14) == 2859902955) strcat(s, "c");
if (crc32("UnxpBiCfr",9) == 3556259176) strcat(s, "e");
if (crc32("HUzou",5) == 3374187608) strcat(s, "a");
if (crc32("WCZxeEBcoAVjVVY",15) == 3578097590) strcat(s, "l");
if (crc32("QZdbbRH",7) == 4087288275) strcat(s, "l");
if (crc32("FivljSOckgYL",12) == 137643985) strcat(s, "y");
    return s;
}

char *mazily_adverbs() {
    char *s = calloc(7);
    if (crc32("QrcfWSqrSEAKCFi",15) == 290604268) strcat(s, "m");
if (crc32("tweIAKIaqPJBpPG",15) == 378965121) strcat(s, "a");
if (crc32("tGwjRfUQNeRciZ",14) == 3400439913) strcat(s, "M");
if (crc32("CjxGPhfEdIX",11) == 4241813654) strcat(s, "z");
if (crc32("adyWYuOGIfwjB",13) == 2926443351) strcat(s, "i");
if (crc32("emdNwlwaFYT",11) == 3195800478) strcat(s, "l");
if (crc32("wSMxdmhr",8) == 1284165614) strcat(s, "y");
    return s;
}

char *amusingly_adverbs() {
    char *s = calloc(10);
    if (crc32("BcVUvmGp",8) == 3815335893) strcat(s, "K");
if (crc32("RivXSMrMqtEdg",13) == 3665974741) strcat(s, "a");
if (crc32("OUngmdcsKHMJe",13) == 4028783059) strcat(s, "m");
if (crc32("DPvsqmV",7) == 701923250) strcat(s, "u");
if (crc32("GHyqSyRdxIxFgob",15) == 420361416) strcat(s, "s");
if (crc32("yghdRA",6) == 2276290749) strcat(s, "p");
if (crc32("VnkwjrhJOYibFF",14) == 1891102789) strcat(s, "i");
if (crc32("fdSwBuiUynSdS",13) == 1067002434) strcat(s, "g");
if (crc32("Kmoyh",5) == 3729921619) strcat(s, "n");
if (crc32("WoxsUmjHD",9) == 2653817394) strcat(s, "g");
if (crc32("XRYYmCch",8) == 4278253128) strcat(s, "l");
if (crc32("QQFeTAUGggE",11) == 903752612) strcat(s, "y");
    return s;
}

char *domineeringly_adverbs() {
    char *s = calloc(14);
    if (crc32("nJalxBH",7) == 4274026318) strcat(s, "X");
if (crc32("hPQXGHh",7) == 745382687) strcat(s, "d");
if (crc32("DGarnBb",7) == 2041268723) strcat(s, "o");
if (crc32("bRrmBbAdwC",10) == 748110582) strcat(s, "m");
if (crc32("gBurJlPEU",9) == 4095389273) strcat(s, "y");
if (crc32("QUNpDGreYCL",11) == 3710544995) strcat(s, "i");
if (crc32("ZkfZc",5) == 2148754139) strcat(s, "n");
if (crc32("qTrxzClbgWBRo",13) == 2220371676) strcat(s, "e");
if (crc32("euBWwiB",7) == 3831341183) strcat(s, "b");
if (crc32("SULntLUhoGNjT",13) == 3726030724) strcat(s, "e");
if (crc32("ILDnsehe",8) == 3321555509) strcat(s, "r");
if (crc32("mCAkJfvLl",9) == 3384857588) strcat(s, "O");
if (crc32("fXbIQXVEG",9) == 2105605852) strcat(s, "i");
if (crc32("ZAbra",5) == 4224076507) strcat(s, "n");
if (crc32("iciFhtxgPwsMu",13) == 2579554290) strcat(s, "g");
if (crc32("HSpDtCnVPMSd",12) == 1478096694) strcat(s, "u");
if (crc32("fbBOLIqSv",9) == 1895361961) strcat(s, "l");
if (crc32("bvPnlJNg",8) == 3809053368) strcat(s, "y");
    return s;
}

char *shrilly_adverbs() {
    char *s = calloc(8);
    if (crc32("kfoxd",5) == 2368497172) strcat(s, "r");
if (crc32("twYYllAlW",9) == 271728217) strcat(s, "s");
if (crc32("lPLwMInf",8) == 3141648649) strcat(s, "h");
if (crc32("XYdxngsCxos",11) == 4294306133) strcat(s, "N");
if (crc32("kzPqgU",6) == 3473994634) strcat(s, "r");
if (crc32("WYwrcU",6) == 1627819346) strcat(s, "i");
if (crc32("cpYKBOreYvkqPZG",15) == 3495402400) strcat(s, "S");
if (crc32("XfHPLQcNUUols",13) == 801381536) strcat(s, "l");
if (crc32("YXvInzb",7) == 2665408375) strcat(s, "Z");
if (crc32("mHrXShJj",8) == 791440576) strcat(s, "l");
if (crc32("OaBBYsAxoOS",11) == 2585822563) strcat(s, "Z");
if (crc32("cbcdWCtOb",9) == 3156566535) strcat(s, "y");
    return s;
}

char *firmly_adverbs() {
    char *s = calloc(7);
    if (crc32("PpSyxEvymhpXPFE",15) == 123815779) strcat(s, "f");
if (crc32("AXpUzcMzTY",10) == 244748122) strcat(s, "f");
if (crc32("nJOgJGui",8) == 1920869216) strcat(s, "i");
if (crc32("AelrXFrKb",9) == 2287681033) strcat(s, "Z");
if (crc32("rGYLuzZVh",9) == 784385507) strcat(s, "r");
if (crc32("wmEOZGDyV",9) == 3512272952) strcat(s, "l");
if (crc32("eqcPCzPMgFKrYmJ",15) == 1819379931) strcat(s, "m");
if (crc32("KbUlBmc",7) == 1755915274) strcat(s, "l");
if (crc32("inMoL",5) == 361280599) strcat(s, "i");
if (crc32("ByKYEXzbqWS",11) == 2136544447) strcat(s, "y");
    return s;
}

char *impalpably_adverbs() {
    char *s = calloc(11);
    if (crc32("TcbPxIKF",8) == 785209824) strcat(s, "i");
if (crc32("tAGNkqhZkhvtzN",14) == 354224437) strcat(s, "q");
if (crc32("UQQII",5) == 111515294) strcat(s, "m");
if (crc32("OjEJbcFfK",9) == 3043873380) strcat(s, "T");
if (crc32("nBlUzsbYpZpq",12) == 1435127347) strcat(s, "p");
if (crc32("HnpYsyKgzAIRID",14) == 493551756) strcat(s, "a");
if (crc32("tIPsNRWWcL",10) == 2641919492) strcat(s, "C");
if (crc32("asKIWvCxCcm",11) == 141035396) strcat(s, "l");
if (crc32("dypHqkCKdq",10) == 4067250599) strcat(s, "O");
if (crc32("OmFExuu",7) == 3371823716) strcat(s, "p");
if (crc32("hzZHDqBwMGI",11) == 291824407) strcat(s, "a");
if (crc32("xPCjUYqUyxAFqv",14) == 1495793877) strcat(s, "b");
if (crc32("qMXnWMDaYHeDcAQ",15) == 106828279) strcat(s, "l");
if (crc32("tIOsP",5) == 2451476867) strcat(s, "n");
if (crc32("bCsCdv",6) == 1477208874) strcat(s, "y");
    return s;
}

char *breathlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("KxydGyrFgSeeJ",13) == 365909549) strcat(s, "Y");
if (crc32("fWHCyXoWPJq",11) == 3754628295) strcat(s, "b");
if (crc32("jaoPhydnxDCi",12) == 2213533622) strcat(s, "r");
if (crc32("AuvxAgiltZDKLQM",15) == 656976548) strcat(s, "e");
if (crc32("gWhKHUs",7) == 1228003935) strcat(s, "C");
if (crc32("VJSSIbLtFVJo",12) == 3664690855) strcat(s, "a");
if (crc32("abEMmxHND",9) == 885089558) strcat(s, "t");
if (crc32("LRpkB",5) == 1880063996) strcat(s, "h");
if (crc32("wwJzGfBlegI",11) == 3108340993) strcat(s, "l");
if (crc32("XVSYxaDVCu",10) == 1754426476) strcat(s, "r");
if (crc32("FlsDEbumfiZFv",13) == 3977647451) strcat(s, "e");
if (crc32("VsPZzJjkSlvQuk",14) == 2964414495) strcat(s, "s");
if (crc32("XblwTRxnjBRg",12) == 44343313) strcat(s, "L");
if (crc32("mIZxsiqVut",10) == 163964054) strcat(s, "s");
if (crc32("CqARAdMrxJGN",12) == 2040012442) strcat(s, "l");
if (crc32("DcniqPpC",8) == 2879569541) strcat(s, "y");
    return s;
}

char *corroboratively_adverbs() {
    char *s = calloc(16);
    if (crc32("RmZttBauvrh",11) == 309561060) strcat(s, "c");
if (crc32("XthMXxlKtkOeZ",13) == 1842580981) strcat(s, "c");
if (crc32("EZoRkWxXHXkINQ",14) == 122229234) strcat(s, "o");
if (crc32("MOWdGkttF",9) == 2199642380) strcat(s, "N");
if (crc32("bScHJTJvj",9) == 3913486829) strcat(s, "r");
if (crc32("iPbDdNxysYi",11) == 3134608438) strcat(s, "r");
if (crc32("NKxZvV",6) == 2675878467) strcat(s, "o");
if (crc32("EvAhljg",7) == 3224142075) strcat(s, "b");
if (crc32("auWPUqKIXVv",11) == 1867220155) strcat(s, "H");
if (crc32("aGbbLEjwOk",10) == 2845183098) strcat(s, "o");
if (crc32("tLMXHISFuhmGGcH",15) == 620015242) strcat(s, "r");
if (crc32("XkqcKitqw",9) == 675873288) strcat(s, "M");
if (crc32("zidgYPReDnw",11) == 926766472) strcat(s, "a");
if (crc32("eYroiRiH",8) == 4089629343) strcat(s, "t");
if (crc32("WiPpPKLrASqS",12) == 816764025) strcat(s, "i");
if (crc32("wwvZYhVSKvjMyQ",14) == 3898035047) strcat(s, "p");
if (crc32("rsEGy",5) == 3691648177) strcat(s, "v");
if (crc32("IwCrwjDAo",9) == 1563555452) strcat(s, "e");
if (crc32("tBrRdCgpeBx",11) == 1208107999) strcat(s, "e");
if (crc32("uBGcWBRul",9) == 4195596500) strcat(s, "l");
if (crc32("wrqSdQJZxBQSQ",13) == 1549359986) strcat(s, "O");
if (crc32("iAeIbjw",7) == 3936917751) strcat(s, "y");
    return s;
}

char *unautomatically_adverbs() {
    char *s = calloc(16);
    if (crc32("XWuUhICvpoyJWS",14) == 1892518477) strcat(s, "v");
if (crc32("wHcxTDXCBeBxCF",14) == 1582161411) strcat(s, "u");
if (crc32("wfqxIthAFFTsyOY",15) == 3446921559) strcat(s, "q");
if (crc32("WysnSrQNnzouF",13) == 3542532705) strcat(s, "n");
if (crc32("krPMGZZBmHFQhAw",15) == 4134560417) strcat(s, "a");
if (crc32("ZBdfoOh",7) == 3222462732) strcat(s, "t");
if (crc32("eTcqxfILe",9) == 2449573157) strcat(s, "u");
if (crc32("elubycQ",7) == 2455054835) strcat(s, "t");
if (crc32("htICK",5) == 3459043019) strcat(s, "o");
if (crc32("nrantif",7) == 1018318542) strcat(s, "m");
if (crc32("qkjMZjhdyo",10) == 2901112696) strcat(s, "a");
if (crc32("haBLklxSk",9) == 1514888501) strcat(s, "T");
if (crc32("ztLwmVcei",9) == 3617796126) strcat(s, "t");
if (crc32("sUpstdiXay",10) == 979288919) strcat(s, "i");
if (crc32("mQVQWTxZHglIM",13) == 1666676511) strcat(s, "A");
if (crc32("kkwkhUi",7) == 1683856976) strcat(s, "c");
if (crc32("BJFcbJakjyI",11) == 2317435603) strcat(s, "f");
if (crc32("bGxvnBHeHTBC",12) == 2588617297) strcat(s, "a");
if (crc32("VSqKUuzaYnxVr",13) == 88039745) strcat(s, "l");
if (crc32("HFrIQ",5) == 2054998628) strcat(s, "l");
if (crc32("QAichB",6) == 2312124919) strcat(s, "J");
if (crc32("nsVSYhjZXjFmkQ",14) == 2426870451) strcat(s, "y");
    return s;
}

char *conjugably_adverbs() {
    char *s = calloc(11);
    if (crc32("ZUDxAf",6) == 669730877) strcat(s, "Z");
if (crc32("eCPudQ",6) == 1919055627) strcat(s, "c");
if (crc32("WbSgiJ",6) == 3882639277) strcat(s, "h");
if (crc32("jrpJJRd",7) == 1181002248) strcat(s, "o");
if (crc32("eRfjSiiSVOI",11) == 1899570520) strcat(s, "J");
if (crc32("sbKXx",5) == 3104579321) strcat(s, "n");
if (crc32("OencmvlygDz",11) == 3347978170) strcat(s, "j");
if (crc32("xOxZZtPRLKgW",12) == 4276347185) strcat(s, "u");
if (crc32("jyqSrOcITBPagT",14) == 833599016) strcat(s, "Z");
if (crc32("vkNblWDFD",9) == 320886568) strcat(s, "g");
if (crc32("zjfmdGDA",8) == 1721760688) strcat(s, "R");
if (crc32("QghmNrlkjorU",12) == 232049685) strcat(s, "a");
if (crc32("jgssYylV",8) == 4290328476) strcat(s, "b");
if (crc32("tTfnBeSiRZcef",13) == 2013998118) strcat(s, "l");
if (crc32("AUoUkk",6) == 3073754085) strcat(s, "F");
if (crc32("WmEujkuDvLSGV",13) == 3770723869) strcat(s, "y");
    return s;
}

char *overhotly_adverbs() {
    char *s = calloc(10);
    if (crc32("mhhLat",6) == 7783712) strcat(s, "o");
if (crc32("VLYKc",5) == 82352608) strcat(s, "v");
if (crc32("zLTtcnSGO",9) == 3937259495) strcat(s, "f");
if (crc32("DEiGNqqjYPRCyK",14) == 1420436387) strcat(s, "e");
if (crc32("EezyNgln",8) == 3180562057) strcat(s, "p");
if (crc32("hmeYI",5) == 2353656493) strcat(s, "r");
if (crc32("GZLxLCqGcJo",11) == 684568892) strcat(s, "h");
if (crc32("SLYqefYeBqQumLa",15) == 3305441688) strcat(s, "o");
if (crc32("HoGcoXxAa",9) == 430628886) strcat(s, "t");
if (crc32("InpUn",5) == 1896857611) strcat(s, "l");
if (crc32("xtfNgb",6) == 3081280769) strcat(s, "y");
    return s;
}

char *subcandidly_adverbs() {
    char *s = calloc(12);
    if (crc32("PCrAnyMFXi",10) == 751938170) strcat(s, "s");
if (crc32("BdLDoe",6) == 7892428) strcat(s, "Q");
if (crc32("ZDvJeUxJrgMITo",14) == 1324435517) strcat(s, "u");
if (crc32("IsTsy",5) == 817738672) strcat(s, "y");
if (crc32("WWQpmXGouz",10) == 3226245901) strcat(s, "b");
if (crc32("JPyAl",5) == 3911891135) strcat(s, "c");
if (crc32("gVBjV",5) == 1834099324) strcat(s, "a");
if (crc32("rdYcyRwxdIvcRQ",14) == 3592040643) strcat(s, "f");
if (crc32("bkKkb",5) == 2425189131) strcat(s, "n");
if (crc32("LNhzADhwBxFZ",12) == 1887580402) strcat(s, "x");
if (crc32("ieVoBMaSkA",10) == 3195711760) strcat(s, "d");
if (crc32("ocWlMVcJtvh",11) == 2610187520) strcat(s, "Y");
if (crc32("ijfVkPHOQy",10) == 2760578743) strcat(s, "i");
if (crc32("ZYkibIOGk",9) == 4129745235) strcat(s, "d");
if (crc32("EAysJoQMHDl",11) == 410190091) strcat(s, "l");
if (crc32("oIoXxgLdzaT",11) == 1705643841) strcat(s, "y");
    return s;
}

char *greyly_adverbs() {
    char *s = calloc(7);
    if (crc32("rGpxhjwzcbFYU",13) == 3836713313) strcat(s, "g");
if (crc32("VwEkLXK",7) == 1310910368) strcat(s, "k");
if (crc32("wjteJf",6) == 1885449940) strcat(s, "r");
if (crc32("AEJZsIe",7) == 3701613264) strcat(s, "e");
if (crc32("zuZrNLwoaCKRqG",14) == 3197048951) strcat(s, "k");
if (crc32("cRggnBjxhlJgFVr",15) == 378193969) strcat(s, "y");
if (crc32("XmYaPBU",7) == 978845626) strcat(s, "l");
if (crc32("iEPWzZxg",8) == 1804716432) strcat(s, "y");
    return s;
}

char *gloatingly_adverbs() {
    char *s = calloc(11);
    if (crc32("IXERslaVYzRJ",12) == 3682647803) strcat(s, "g");
if (crc32("zZpRvZW",7) == 2784356972) strcat(s, "b");
if (crc32("CAMoM",5) == 1754512906) strcat(s, "l");
if (crc32("vwrmtHyXx",9) == 2904715742) strcat(s, "A");
if (crc32("bAqSxxXvOx",10) == 3567219858) strcat(s, "o");
if (crc32("eUZarWvNUIVH",12) == 1892231223) strcat(s, "B");
if (crc32("tNLrqqkD",8) == 3549218276) strcat(s, "a");
if (crc32("OUGPTejuojkTfwf",15) == 842036227) strcat(s, "t");
if (crc32("eodhXnsvQp",10) == 2817130747) strcat(s, "i");
if (crc32("mlRxm",5) == 1840060575) strcat(s, "n");
if (crc32("zpYqYJosR",9) == 450406392) strcat(s, "R");
if (crc32("psAubyJVMsexCmc",15) == 1617235557) strcat(s, "g");
if (crc32("gigXO",5) == 1921495601) strcat(s, "l");
if (crc32("AClhppjdHAXOOJO",15) == 3544508164) strcat(s, "M");
if (crc32("inRNfQm",7) == 1415433637) strcat(s, "y");
    return s;
}

char *bifidly_adverbs() {
    char *s = calloc(8);
    if (crc32("DmLuim",6) == 3115209448) strcat(s, "n");
if (crc32("vLOklpN",7) == 2740742343) strcat(s, "b");
if (crc32("AShmAYPvJmAjM",13) == 3638518366) strcat(s, "k");
if (crc32("YgGfCbLVWzV",11) == 2326393789) strcat(s, "i");
if (crc32("RsqxSFg",7) == 3584464146) strcat(s, "f");
if (crc32("RiDHTUjWpI",10) == 3770730615) strcat(s, "V");
if (crc32("isZJidIjrkHTXwH",15) == 325132502) strcat(s, "i");
if (crc32("OwvxzqClsGPdKo",14) == 1309051785) strcat(s, "d");
if (crc32("khsSLO",6) == 3320621325) strcat(s, "a");
if (crc32("JjPWgWAFMlP",11) == 3926100071) strcat(s, "l");
if (crc32("cuHcDEW",7) == 845087770) strcat(s, "y");
    return s;
}

char *conciliatorily_adverbs() {
    char *s = calloc(15);
    if (crc32("tWnelT",6) == 1083449275) strcat(s, "B");
if (crc32("qdJgsuYyFC",10) == 362086840) strcat(s, "c");
if (crc32("yuxegJiFq",9) == 3231429875) strcat(s, "o");
if (crc32("vhUbZbPAzDlEaS",14) == 3733992796) strcat(s, "n");
if (crc32("eCllT",5) == 4208098289) strcat(s, "c");
if (crc32("xsHTUF",6) == 3749365900) strcat(s, "y");
if (crc32("derRKjLWyWuc",12) == 2411063705) strcat(s, "i");
if (crc32("IHmlGgJO",8) == 1286750186) strcat(s, "s");
if (crc32("xJMlXQGkB",9) == 1595512198) strcat(s, "l");
if (crc32("JqUSUw",6) == 2882667068) strcat(s, "l");
if (crc32("NZqDMIzDG",9) == 2312996907) strcat(s, "i");
if (crc32("xunLlhZinV",10) == 3059669032) strcat(s, "a");
if (crc32("beRKOKlBLxMAYX",14) == 1250699440) strcat(s, "t");
if (crc32("njcTvSl",7) == 4036585108) strcat(s, "o");
if (crc32("jrYCRQcxqK",10) == 620654264) strcat(s, "r");
if (crc32("GdKQWe",6) == 644124421) strcat(s, "i");
if (crc32("QyStdBihROjqto",14) == 241733218) strcat(s, "A");
if (crc32("MEiFmgJsAcSGBh",14) == 1111950702) strcat(s, "l");
if (crc32("ysyHrxIfedI",11) == 347082865) strcat(s, "j");
if (crc32("xeYCyAiTVupfhIE",15) == 2543695134) strcat(s, "y");
    return s;
}

char *clamorously_adverbs() {
    char *s = calloc(12);
    if (crc32("RenbkxHaC",9) == 119704982) strcat(s, "z");
if (crc32("MCVAitxtQtuIFw",14) == 2222493205) strcat(s, "c");
if (crc32("RrgdRRYtfr",10) == 2064975236) strcat(s, "A");
if (crc32("SxYaVsVsc",9) == 3519540847) strcat(s, "l");
if (crc32("ENtFbJKfoPbh",12) == 2991788069) strcat(s, "V");
if (crc32("ljbLyXMN",8) == 3048517614) strcat(s, "a");
if (crc32("gIsNUisFVLOH",12) == 1087969836) strcat(s, "m");
if (crc32("xJNPFMLVXCoV",12) == 2589541789) strcat(s, "P");
if (crc32("AysQXCtGxtywz",13) == 621362376) strcat(s, "o");
if (crc32("aqAEpRgL",8) == 3916235180) strcat(s, "c");
if (crc32("MXqHrUiDqrwbq",13) == 283414861) strcat(s, "r");
if (crc32("NMIWwThTxQT",11) == 4085878057) strcat(s, "w");
if (crc32("dQyJAbk",7) == 3655270463) strcat(s, "o");
if (crc32("ZFIyHqEFklhYFE",14) == 3591008515) strcat(s, "G");
if (crc32("BbAxjNok",8) == 160386535) strcat(s, "u");
if (crc32("vXWhwU",6) == 263924924) strcat(s, "s");
if (crc32("rLuMuBvsamPwv",13) == 264026690) strcat(s, "l");
if (crc32("ZkoIYnbCAuUwuqe",15) == 3597952957) strcat(s, "C");
if (crc32("lqrtBsp",7) == 1363321160) strcat(s, "y");
    return s;
}

char *curelessly_adverbs() {
    char *s = calloc(11);
    if (crc32("vVIyr",5) == 1634457324) strcat(s, "c");
if (crc32("PynZcGxgK",9) == 416936643) strcat(s, "u");
if (crc32("dfcNMShLCpPU",12) == 1636553024) strcat(s, "r");
if (crc32("LmknygAlGEj",11) == 2772771823) strcat(s, "e");
if (crc32("tlHZvVwOGitaVC",14) == 3699728740) strcat(s, "l");
if (crc32("RwlGIOI",7) == 1655373024) strcat(s, "e");
if (crc32("OnUnAINjamroh",13) == 1261061930) strcat(s, "s");
if (crc32("FAPBJUxX",8) == 2995495907) strcat(s, "y");
if (crc32("zRABFTREAm",10) == 2973817133) strcat(s, "s");
if (crc32("eGUKwpyr",8) == 3976915079) strcat(s, "l");
if (crc32("gspNQonEgKVomr",14) == 1877203010) strcat(s, "m");
if (crc32("pbIuoEq",7) == 3569204581) strcat(s, "y");
    return s;
}

char *whimsically_adverbs() {
    char *s = calloc(12);
    if (crc32("NgQOYVGb",8) == 1476640038) strcat(s, "l");
if (crc32("wLzywY",6) == 395132116) strcat(s, "w");
if (crc32("blvCi",5) == 260111450) strcat(s, "V");
if (crc32("DuhMicZHCLK",11) == 990255407) strcat(s, "h");
if (crc32("awBiLQAuFiiZNf",14) == 3941214774) strcat(s, "i");
if (crc32("rITMD",5) == 4244595112) strcat(s, "m");
if (crc32("MFxqzdAkiHzATTK",15) == 193766252) strcat(s, "C");
if (crc32("islKojC",7) == 762311501) strcat(s, "s");
if (crc32("TXIFsCHm",8) == 1533384651) strcat(s, "i");
if (crc32("autHz",5) == 2717986349) strcat(s, "t");
if (crc32("VCWHWIyDhAEH",12) == 2891339855) strcat(s, "c");
if (crc32("XnqYiB",6) == 3944661121) strcat(s, "a");
if (crc32("iTKVbwEZRosfgVV",15) == 3595728944) strcat(s, "l");
if (crc32("COEFfYR",7) == 2594945452) strcat(s, "l");
if (crc32("UtJSQgbbv",9) == 2597008432) strcat(s, "y");
    return s;
}

char *unpresumptively_adverbs() {
    char *s = calloc(16);
    if (crc32("iAucHKlxf",9) == 1974782005) strcat(s, "v");
if (crc32("dckpVhVEahWEZz",14) == 1010799875) strcat(s, "u");
if (crc32("RPUdPYNFKPts",12) == 996490100) strcat(s, "r");
if (crc32("aVfPE",5) == 2084677191) strcat(s, "n");
if (crc32("hUdppi",6) == 2685655987) strcat(s, "r");
if (crc32("lacAefis",8) == 432365834) strcat(s, "p");
if (crc32("KXhZCygKFMin",12) == 3195548542) strcat(s, "s");
if (crc32("eqVMUtVwjAxkZO",14) == 3087746335) strcat(s, "r");
if (crc32("OsqHKr",6) == 778768832) strcat(s, "s");
if (crc32("NKCIrvkAmQpzTY",14) == 3137166571) strcat(s, "e");
if (crc32("NHXIxXYNclKP",12) == 2448677165) strcat(s, "l");
if (crc32("WsVPCWapSebWj",13) == 4292662460) strcat(s, "s");
if (crc32("ImQSYxMHxIlUm",13) == 2511164465) strcat(s, "u");
if (crc32("DMtEIRSFxM",10) == 1301264042) strcat(s, "m");
if (crc32("pObALmfZv",9) == 3743272940) strcat(s, "p");
if (crc32("YJDtTN",6) == 1220966829) strcat(s, "x");
if (crc32("dgNrCxZRv",9) == 2389583129) strcat(s, "t");
if (crc32("XizzWm",6) == 1579173133) strcat(s, "i");
if (crc32("HBhXsRW",7) == 618035534) strcat(s, "v");
if (crc32("WaELFPn",7) == 1678258607) strcat(s, "H");
if (crc32("CsNxyPETN",9) == 3600878183) strcat(s, "e");
if (crc32("MuccZIjRNjizmf",14) == 2997164147) strcat(s, "l");
if (crc32("tGxbiNfmHgsuB",13) == 2925359073) strcat(s, "D");
if (crc32("ZlSaPvvdPEy",11) == 2579505948) strcat(s, "y");
    return s;
}

char *unphysically_adverbs() {
    char *s = calloc(13);
    if (crc32("CCFhL",5) == 4136189745) strcat(s, "u");
if (crc32("VImVAf",6) == 3526932356) strcat(s, "n");
if (crc32("fZjJMFFsRB",10) == 3854383924) strcat(s, "p");
if (crc32("RJeaD",5) == 593815260) strcat(s, "Y");
if (crc32("wYmgHxKqQo",10) == 1630742579) strcat(s, "h");
if (crc32("tjziUhc",7) == 2185464951) strcat(s, "L");
if (crc32("rYxLFXuGO",9) == 121890455) strcat(s, "y");
if (crc32("mywJOWmLSspgX",13) == 1883156602) strcat(s, "s");
if (crc32("rDadkVJfIlnv",12) == 2053337307) strcat(s, "i");
if (crc32("NVStdLsqNCnSHb",14) == 2073829191) strcat(s, "c");
if (crc32("nfbfsPFF",8) == 935400807) strcat(s, "a");
if (crc32("SPuClovzMoDbHTn",15) == 669667519) strcat(s, "O");
if (crc32("UwxZFvzCUeSdQxx",15) == 3800315048) strcat(s, "l");
if (crc32("NXphWpUrRjxH",12) == 2792852312) strcat(s, "l");
if (crc32("HWzDDAHgGIqHG",13) == 6290962) strcat(s, "M");
if (crc32("osmKxNqGPAUw",12) == 3436800025) strcat(s, "y");
    return s;
}

char *snaringly_adverbs() {
    char *s = calloc(10);
    if (crc32("wDetBVLwRiDawc",14) == 3545210589) strcat(s, "A");
if (crc32("eOOWtwKggNrZE",13) == 1498307531) strcat(s, "s");
if (crc32("IINxTpVNuvu",11) == 3604532260) strcat(s, "n");
if (crc32("hkIUrcUFzIoGDY",14) == 3774951385) strcat(s, "a");
if (crc32("GbrOlJfASJgkY",13) == 1876209898) strcat(s, "k");
if (crc32("SHmKbuVUFK",10) == 1848864155) strcat(s, "r");
if (crc32("oCTDHlbhfUhjkk",14) == 2249266073) strcat(s, "i");
if (crc32("FbSiDFVXUGMdt",13) == 3053215454) strcat(s, "C");
if (crc32("xaUzuy",6) == 751118031) strcat(s, "n");
if (crc32("LlNrVUleKUeZU",13) == 3179403927) strcat(s, "g");
if (crc32("cmplNjEHuoyDVHl",15) == 3075343081) strcat(s, "l");
if (crc32("KYoWakv",7) == 3408115511) strcat(s, "y");
    return s;
}

char *lightheadedly_adverbs() {
    char *s = calloc(14);
    if (crc32("KFQFtuJLk",9) == 1755949872) strcat(s, "Y");
if (crc32("ANkbS",5) == 961643584) strcat(s, "l");
if (crc32("nOZUgDRzxZhUd",13) == 2250920143) strcat(s, "R");
if (crc32("dgjNRhKbaOGi",12) == 2747673745) strcat(s, "i");
if (crc32("PBbiRLBiqP",10) == 2966166764) strcat(s, "k");
if (crc32("wxacfxYZ",8) == 2774714126) strcat(s, "g");
if (crc32("swtjddUk",8) == 723413182) strcat(s, "k");
if (crc32("KkEDSPgIGmQmhUD",15) == 3425100935) strcat(s, "h");
if (crc32("FAajuRoaDOhm",12) == 4124586879) strcat(s, "i");
if (crc32("jXjpjIpshLLMXb",14) == 608268913) strcat(s, "t");
if (crc32("aUWBUAOXuPMtPM",14) == 4128043301) strcat(s, "S");
if (crc32("ZMSDDLFSBuMj",12) == 1648444377) strcat(s, "h");
if (crc32("BYUQAkUIqQUWGOv",15) == 803790955) strcat(s, "e");
if (crc32("rQjPWkeQ",8) == 3565484939) strcat(s, "L");
if (crc32("XnDLo",5) == 3823807227) strcat(s, "a");
if (crc32("vYmWKwGja",9) == 3716869037) strcat(s, "d");
if (crc32("NJSDqWHAwL",10) == 1957088386) strcat(s, "u");
if (crc32("yuUjfRy",7) == 4128620788) strcat(s, "e");
if (crc32("EPljr",5) == 4259876607) strcat(s, "d");
if (crc32("MErAhv",6) == 909890926) strcat(s, "l");
if (crc32("JIGUo",5) == 1567223519) strcat(s, "y");
    return s;
}

char *fundamentally_adverbs() {
    char *s = calloc(14);
    if (crc32("CjUMnyTAML",10) == 1867569555) strcat(s, "t");
if (crc32("puzKHeGkvG",10) == 3039754645) strcat(s, "f");
if (crc32("OuNZtaca",8) == 1016784010) strcat(s, "j");
if (crc32("wsgAPMIVKaIcP",13) == 2927094676) strcat(s, "u");
if (crc32("DCJvv",5) == 3548727518) strcat(s, "K");
if (crc32("QrKEnguCmpllw",13) == 2877911192) strcat(s, "n");
if (crc32("kdnTqQU",7) == 484448038) strcat(s, "Z");
if (crc32("FqfbGHXSg",9) == 314399052) strcat(s, "d");
if (crc32("lUvZDspZoxWg",12) == 1427281256) strcat(s, "a");
if (crc32("fjfmwsMkMeqjA",13) == 1777118233) strcat(s, "m");
if (crc32("yvnNHgDW",8) == 4271561696) strcat(s, "e");
if (crc32("BblHzoRarFgmYP",14) == 1909863776) strcat(s, "n");
if (crc32("mimDGnmlgpOvPzt",15) == 3543555884) strcat(s, "m");
if (crc32("gkwRVDcoUMNu",12) == 1624282621) strcat(s, "t");
if (crc32("tnBEHfvS",8) == 3721335451) strcat(s, "a");
if (crc32("RZVPEbYPouacXW",14) == 1790920144) strcat(s, "l");
if (crc32("rrqxYb",6) == 899589822) strcat(s, "l");
if (crc32("UpHMZA",6) == 1933472433) strcat(s, "y");
    return s;
}

char *unamiably_adverbs() {
    char *s = calloc(10);
    if (crc32("whWNRuTIZxMV",12) == 3735745668) strcat(s, "u");
if (crc32("voWFGeoUQWZUdWc",15) == 2700873707) strcat(s, "n");
if (crc32("PmXPmsjJiOFyBe",14) == 2501312334) strcat(s, "u");
if (crc32("vOmbcomkp",9) == 293899311) strcat(s, "a");
if (crc32("QSDZQg",6) == 62870507) strcat(s, "n");
if (crc32("ITmOJsc",7) == 3566292067) strcat(s, "m");
if (crc32("EHvUCYYbIqjcv",13) == 3071122031) strcat(s, "B");
if (crc32("UXfcVpL",7) == 198799291) strcat(s, "i");
if (crc32("UKeMsax",7) == 3309170429) strcat(s, "a");
if (crc32("chNqdjQhXL",10) == 4222601756) strcat(s, "K");
if (crc32("IFXuNlqXyUZRwL",14) == 3566761246) strcat(s, "b");
if (crc32("Zacocjz",7) == 3244430009) strcat(s, "q");
if (crc32("mPQLeRC",7) == 2255936869) strcat(s, "l");
if (crc32("WtvAVzTO",8) == 2492970464) strcat(s, "x");
if (crc32("clMESFjPc",9) == 2489713383) strcat(s, "y");
    return s;
}

char *telltalely_adverbs() {
    char *s = calloc(11);
    if (crc32("lPCbH",5) == 217944557) strcat(s, "t");
if (crc32("iaBoyc",6) == 1656442682) strcat(s, "e");
if (crc32("VCevadjAIVfq",12) == 1719823918) strcat(s, "l");
if (crc32("WmUqTbdCCQcdFHj",15) == 185986133) strcat(s, "v");
if (crc32("tSKdbiZGBE",10) == 2558251292) strcat(s, "l");
if (crc32("MVJCe",5) == 931712791) strcat(s, "C");
if (crc32("lYkyCWvqDDNYT",13) == 1879238181) strcat(s, "t");
if (crc32("cWrrMp",6) == 905993169) strcat(s, "a");
if (crc32("JgBbwtVNJfOyexG",15) == 3174287304) strcat(s, "Y");
if (crc32("UUYtF",5) == 2105738590) strcat(s, "l");
if (crc32("afwvQBgs",8) == 329430217) strcat(s, "c");
if (crc32("BFxilRKGNhtBkFH",15) == 2517883090) strcat(s, "e");
if (crc32("QvCPeJLLQCiKrf",14) == 2495494697) strcat(s, "l");
if (crc32("LWQIJZCETt",10) == 3724462170) strcat(s, "o");
if (crc32("doRmWqvJFMerY",13) == 938363226) strcat(s, "y");
    return s;
}

char *unprovidentially_adverbs() {
    char *s = calloc(17);
    if (crc32("goojDuPvVL",10) == 3888354548) strcat(s, "C");
if (crc32("jTsqtREh",8) == 4287989649) strcat(s, "u");
if (crc32("IAcfbhUi",8) == 1031991777) strcat(s, "g");
if (crc32("hcuXLKMwJfBO",12) == 427961363) strcat(s, "n");
if (crc32("akDvMEUvOGiI",12) == 2538724217) strcat(s, "W");
if (crc32("XVXiLktPPThxC",13) == 4080128234) strcat(s, "p");
if (crc32("NjYxMcPdI",9) == 394523592) strcat(s, "R");
if (crc32("pwFkStYn",8) == 2624439795) strcat(s, "r");
if (crc32("sltTSTjYbskvRI",14) == 1578191692) strcat(s, "V");
if (crc32("NjaHoFM",7) == 922782458) strcat(s, "o");
if (crc32("brapWRhwx",9) == 1626517352) strcat(s, "m");
if (crc32("jMFwxEgNH",9) == 2452471839) strcat(s, "v");
if (crc32("oeWIRJgXIH",10) == 2500156765) strcat(s, "i");
if (crc32("xZbHRqiEUx",10) == 685456660) strcat(s, "d");
if (crc32("IJYwFufmFWRv",12) == 125836154) strcat(s, "c");
if (crc32("rpofpwz",7) == 1825129661) strcat(s, "e");
if (crc32("sXpNVyAagyHwYZ",14) == 426240116) strcat(s, "n");
if (crc32("SBKOHasV",8) == 1133278490) strcat(s, "n");
if (crc32("tBdYZWVhaXa",11) == 720909297) strcat(s, "t");
if (crc32("eQTXPmDFCm",10) == 746254200) strcat(s, "Z");
if (crc32("RqloPWeqVt",10) == 670446048) strcat(s, "i");
if (crc32("WUZZJPv",7) == 2141902141) strcat(s, "E");
if (crc32("xyrPdlx",7) == 4270923631) strcat(s, "a");
if (crc32("byAJllkl",8) == 2859176342) strcat(s, "l");
if (crc32("koYGypKNiDFiQS",14) == 4042027138) strcat(s, "A");
if (crc32("iZUDNfkUjEeurt",14) == 2081772182) strcat(s, "l");
if (crc32("QCUFXD",6) == 3797156959) strcat(s, "y");
    return s;
}

char *superbelievably_adverbs() {
    char *s = calloc(16);
    if (crc32("MPlKWu",6) == 3476500399) strcat(s, "P");
if (crc32("hKVtOhptD",9) == 4023466924) strcat(s, "s");
if (crc32("nXpRHBJM",8) == 1401796912) strcat(s, "K");
if (crc32("ZMTNe",5) == 3848851879) strcat(s, "u");
if (crc32("wGakUgTwukq",11) == 1991014290) strcat(s, "Z");
if (crc32("VOXUJCNwWL",10) == 2968576172) strcat(s, "p");
if (crc32("UBuphDs",7) == 4022422837) strcat(s, "e");
if (crc32("bOykbFycEs",10) == 4272333805) strcat(s, "N");
if (crc32("LUzdMLQCmqqHtnL",15) == 1812650836) strcat(s, "r");
if (crc32("lKCZvTDZy",9) == 3703318544) strcat(s, "b");
if (crc32("uAvCGoSjRsmkg",13) == 1183897707) strcat(s, "e");
if (crc32("QawEnGJEGLh",11) == 67119486) strcat(s, "l");
if (crc32("kPeQZMw",7) == 3501007325) strcat(s, "i");
if (crc32("WXyJonUifNcDeA",14) == 2221567661) strcat(s, "e");
if (crc32("kWZYyZGUhcxClxD",15) == 2229913662) strcat(s, "A");
if (crc32("iUgtAFj",7) == 1783780520) strcat(s, "v");
if (crc32("sVVcLjC",7) == 3198275337) strcat(s, "S");
if (crc32("qiudwrUGofaIx",13) == 2697777026) strcat(s, "a");
if (crc32("GUqQdcBlAJ",10) == 4011890) strcat(s, "b");
if (crc32("mmDAP",5) == 2606129555) strcat(s, "l");
if (crc32("kgiamrK",7) == 2862393030) strcat(s, "y");
    return s;
}

char *nonconcordant_adverbs() {
    char *s = calloc(14);
    if (crc32("RJvyZxOZXKHOBur",15) == 989774487) strcat(s, "n");
if (crc32("ERKYeW",6) == 1853437793) strcat(s, "o");
if (crc32("HWSmoaJjtvkwa",13) == 500574759) strcat(s, "J");
if (crc32("diBCc",5) == 2421156755) strcat(s, "n");
if (crc32("zQIsAuIcNwJHtj",14) == 2726372754) strcat(s, "c");
if (crc32("oGjdJkcTKafkK",13) == 1692610581) strcat(s, "o");
if (crc32("DqUCFFZsgF",10) == 2995842798) strcat(s, "n");
if (crc32("oQABhdWXXtAHNj",14) == 3941161206) strcat(s, "l");
if (crc32("pRgpeAGigQRgX",13) == 3479565993) strcat(s, "c");
if (crc32("rikfeFKBOHIDtol",15) == 365642533) strcat(s, "o");
if (crc32("uacqGrqnCyDxFW",14) == 1971643881) strcat(s, "r");
if (crc32("cUfByutuT",9) == 4047670295) strcat(s, "d");
if (crc32("QbkqHSFoEWd",11) == 957727536) strcat(s, "a");
if (crc32("htFvSLo",7) == 3277466795) strcat(s, "n");
if (crc32("SfcdnkSpaqNixV",14) == 3823504362) strcat(s, "t");
    return s;
}

char *tanto_adverbs() {
    char *s = calloc(6);
    if (crc32("jRaUYQEULzZ",11) == 141706189) strcat(s, "t");
if (crc32("nHfXnisZku",10) == 1548718263) strcat(s, "c");
if (crc32("utmHmdEKSurS",12) == 3906732531) strcat(s, "a");
if (crc32("euEWa",5) == 1913621240) strcat(s, "n");
if (crc32("TlHzocCiSivGZK",14) == 1455724603) strcat(s, "I");
if (crc32("YHNciSizP",9) == 3975400540) strcat(s, "t");
if (crc32("DXsqDNCWKEq",11) == 341689372) strcat(s, "o");
    return s;
}

char *unagilely_adverbs() {
    char *s = calloc(10);
    if (crc32("AmuETBdoSaJ",11) == 2650374282) strcat(s, "u");
if (crc32("GMLtnGBe",8) == 1188376345) strcat(s, "n");
if (crc32("dJkOtTulnpRGK",13) == 3327682934) strcat(s, "a");
if (crc32("wJyNHBUdiec",11) == 2951031709) strcat(s, "g");
if (crc32("IYLPScybHwQkXQ",14) == 2493739521) strcat(s, "i");
if (crc32("zLMVkaLdfU",10) == 3087125186) strcat(s, "l");
if (crc32("kwFEpvZZt",9) == 662043856) strcat(s, "e");
if (crc32("rTjFiZFDU",9) == 3563511017) strcat(s, "l");
if (crc32("jHUrsqxmicP",11) == 4253852653) strcat(s, "y");
    return s;
}

char *preobediently_adverbs() {
    char *s = calloc(14);
    if (crc32("fGuhVnxAnLI",11) == 2376025476) strcat(s, "w");
if (crc32("itKLUpdCTYMc",12) == 366965759) strcat(s, "p");
if (crc32("vIBotYqaWX",10) == 3552987071) strcat(s, "r");
if (crc32("gGWUcuVZsnPM",12) == 448661737) strcat(s, "M");
if (crc32("qObsRD",6) == 2512118657) strcat(s, "e");
if (crc32("tohNiRg",7) == 4083159818) strcat(s, "G");
if (crc32("AnpkhmAmUjdyUa",14) == 1395775995) strcat(s, "o");
if (crc32("YTXvxOjwFm",10) == 765002764) strcat(s, "b");
if (crc32("kblcP",5) == 3717846301) strcat(s, "e");
if (crc32("oNolSlCpEFGkbrf",15) == 353992480) strcat(s, "d");
if (crc32("QFibslYVPKNFOgB",15) == 3707679706) strcat(s, "W");
if (crc32("tGBcXYIORzOkST",14) == 2399813817) strcat(s, "i");
if (crc32("xohyl",5) == 1020765531) strcat(s, "q");
if (crc32("QSGhUMYlkUo",11) == 3790770233) strcat(s, "e");
if (crc32("hWOvvxaYfaIQFQ",14) == 2875240415) strcat(s, "T");
if (crc32("zYXIaCmD",8) == 191200619) strcat(s, "n");
if (crc32("XlcxQBO",7) == 1184768555) strcat(s, "z");
if (crc32("hYEzgCpoNb",10) == 964610870) strcat(s, "t");
if (crc32("hLpXUZgf",8) == 1049796454) strcat(s, "a");
if (crc32("oLAFWDrgQHR",11) == 2379594262) strcat(s, "l");
if (crc32("uqvfbdsyeFQA",12) == 1651075576) strcat(s, "y");
    return s;
}

char *paltrily_adverbs() {
    char *s = calloc(9);
    if (crc32("AlLUGmrLDlx",11) == 1891122625) strcat(s, "z");
if (crc32("KUnvNekhnpnaC",13) == 1998007107) strcat(s, "p");
if (crc32("DqjybPbPgZRTm",13) == 787494295) strcat(s, "p");
if (crc32("GbZmawFIkN",10) == 2650640595) strcat(s, "a");
if (crc32("ptkmjCKHGOKwUDc",15) == 2423426840) strcat(s, "l");
if (crc32("HcfGHyENpldPupY",15) == 1566998084) strcat(s, "t");
if (crc32("SgLovBaSMcNtm",13) == 3745434464) strcat(s, "r");
if (crc32("hnBdlFvB",8) == 2010607152) strcat(s, "i");
if (crc32("WEIPCntUBrCUDzD",15) == 1947123267) strcat(s, "H");
if (crc32("BRvHlOiAjq",10) == 306833490) strcat(s, "l");
if (crc32("ttlgEqKu",8) == 1664543403) strcat(s, "h");
if (crc32("LjPwjEuLiSr",11) == 1575983588) strcat(s, "y");
    return s;
}

char *precranially_adverbs() {
    char *s = calloc(13);
    if (crc32("ttAAYKTstO",10) == 3068141639) strcat(s, "Q");
if (crc32("IQCKEvstHYa",11) == 3181308148) strcat(s, "p");
if (crc32("jvnAtWSunYAH",12) == 755038869) strcat(s, "H");
if (crc32("kHvrZWTUhQzLwFi",15) == 3336620503) strcat(s, "r");
if (crc32("yTzCfeBLZIJAmgG",15) == 4080828745) strcat(s, "o");
if (crc32("jNtGfIT",7) == 2358138737) strcat(s, "e");
if (crc32("ChGuHoRAz",9) == 2768899157) strcat(s, "j");
if (crc32("sALYL",5) == 913034584) strcat(s, "c");
if (crc32("DfiWxHxhfFUbIEZ",15) == 2323107338) strcat(s, "r");
if (crc32("Tgujzdb",7) == 3901079112) strcat(s, "l");
if (crc32("Uftiq",5) == 3898166961) strcat(s, "a");
if (crc32("XFnlAsWMtrCd",12) == 4050594612) strcat(s, "Z");
if (crc32("lPpdx",5) == 1515412750) strcat(s, "n");
if (crc32("hytslkFK",8) == 2031078192) strcat(s, "J");
if (crc32("Lqpqh",5) == 2837335073) strcat(s, "i");
if (crc32("eWAjSKkLoXIoe",13) == 4268109051) strcat(s, "a");
if (crc32("rGDQlWklTO",10) == 3823839204) strcat(s, "l");
if (crc32("MaxhUpygba",10) == 3675919040) strcat(s, "R");
if (crc32("asFFIFVTGkILNYN",15) == 1896645066) strcat(s, "l");
if (crc32("QVYCWu",6) == 3490675979) strcat(s, "y");
    return s;
}

char *inflatedly_adverbs() {
    char *s = calloc(11);
    if (crc32("osqZHLKBltxTWx",14) == 652517993) strcat(s, "i");
if (crc32("JsbXKLILGHnWVxA",15) == 4058856736) strcat(s, "L");
if (crc32("EONezS",6) == 647053843) strcat(s, "n");
if (crc32("GNuSRbJ",7) == 1877109523) strcat(s, "f");
if (crc32("mbiKeUAhgntAti",14) == 1326410130) strcat(s, "l");
if (crc32("GBjlQRWs",8) == 1077723057) strcat(s, "a");
if (crc32("ZCNHTpGifKzYQK",14) == 956041744) strcat(s, "t");
if (crc32("zTbOmLQh",8) == 2369595729) strcat(s, "T");
if (crc32("WYMNaduYbctTa",13) == 2959318026) strcat(s, "e");
if (crc32("HkHnHeB",7) == 1463146148) strcat(s, "O");
if (crc32("nRlPXuYZSgjeaZZ",15) == 2223639104) strcat(s, "d");
if (crc32("VEpOhEfiNQwHXi",14) == 1878643413) strcat(s, "l");
if (crc32("IMSfWvwvRF",10) == 1267226402) strcat(s, "y");
    return s;
}

char *unintrospectively_adverbs() {
    char *s = calloc(18);
    if (crc32("rxkpzuY",7) == 7991528) strcat(s, "g");
if (crc32("pxPPRPLzg",9) == 2954640948) strcat(s, "u");
if (crc32("jCfpCIKj",8) == 1322021368) strcat(s, "f");
if (crc32("KcDnj",5) == 3776458203) strcat(s, "n");
if (crc32("dmlVcUuFj",9) == 4224721439) strcat(s, "b");
if (crc32("ApCEZXp",7) == 2229742562) strcat(s, "i");
if (crc32("aMioqRSkEfvTM",13) == 1199286312) strcat(s, "v");
if (crc32("fouGoU",6) == 2757604480) strcat(s, "n");
if (crc32("LBbxLFLcl",9) == 510074967) strcat(s, "t");
if (crc32("iCbpwvm",7) == 1788183088) strcat(s, "w");
if (crc32("qZZaO",5) == 1569618981) strcat(s, "r");
if (crc32("RzKoI",5) == 299484979) strcat(s, "o");
if (crc32("mVtkctrQNTh",11) == 1509401055) strcat(s, "s");
if (crc32("nppHLAX",7) == 3305712407) strcat(s, "h");
if (crc32("XnWvebQGVlfw",12) == 1614779985) strcat(s, "p");
if (crc32("TKSyTKlGOhDjsA",14) == 2461134002) strcat(s, "e");
if (crc32("YaDtqbjKEoR",11) == 2094022119) strcat(s, "c");
if (crc32("CJJYlsvsGYY",11) == 1858334708) strcat(s, "t");
if (crc32("dCWQcnyaHMdasvt",15) == 3834059085) strcat(s, "i");
if (crc32("yptomNXFz",9) == 3686445565) strcat(s, "S");
if (crc32("IttvPYoufK",10) == 1368592420) strcat(s, "v");
if (crc32("HdpdlTZjoMA",11) == 112128941) strcat(s, "H");
if (crc32("BVtAfiCYcuP",11) == 78142373) strcat(s, "e");
if (crc32("XEckQCuLak",10) == 544321836) strcat(s, "f");
if (crc32("KiWkRvfEomKx",12) == 744424790) strcat(s, "l");
if (crc32("RAPtlk",6) == 1780085229) strcat(s, "I");
if (crc32("QDThXz",6) == 461031787) strcat(s, "y");
    return s;
}

char *dispersedly_adverbs() {
    char *s = calloc(12);
    if (crc32("iNfnFN",6) == 314168312) strcat(s, "d");
if (crc32("hqBqhfaC",8) == 2347433810) strcat(s, "i");
if (crc32("AkPDpsbEjGhiZq",14) == 3135462078) strcat(s, "u");
if (crc32("zDDZwcNsV",9) == 2910712069) strcat(s, "s");
if (crc32("mKfsKX",6) == 893364077) strcat(s, "V");
if (crc32("MUwvE",5) == 3036643791) strcat(s, "p");
if (crc32("IVjEWbu",7) == 3430657702) strcat(s, "N");
if (crc32("JWlijSxUauHyw",13) == 2432640469) strcat(s, "e");
if (crc32("JBpDK",5) == 3298188554) strcat(s, "r");
if (crc32("UlMZubQj",8) == 314243654) strcat(s, "A");
if (crc32("eUXoKrgDyabeX",13) == 1941576667) strcat(s, "s");
if (crc32("yYHboxC",7) == 1516789998) strcat(s, "Y");
if (crc32("cAYnyn",6) == 4203382092) strcat(s, "e");
if (crc32("yWcQLqn",7) == 2553645149) strcat(s, "P");
if (crc32("jQCrhHRUGmhSP",13) == 1266430864) strcat(s, "d");
if (crc32("FitExupDbmEjOk",14) == 4118629649) strcat(s, "A");
if (crc32("ZHqfOfkfVLt",11) == 1920200136) strcat(s, "l");
if (crc32("GHiYEpW",7) == 1905113878) strcat(s, "y");
    return s;
}

char *uninventively_adverbs() {
    char *s = calloc(14);
    if (crc32("lKQyzAzKDv",10) == 251548797) strcat(s, "u");
if (crc32("LDkndLFMLESUIRF",15) == 1680703295) strcat(s, "n");
if (crc32("bHCSopfLWs",10) == 3182838062) strcat(s, "i");
if (crc32("IAtsSVvXf",9) == 4085516896) strcat(s, "n");
if (crc32("yOxQNWQ",7) == 856898509) strcat(s, "v");
if (crc32("sCjmIkB",7) == 1321585542) strcat(s, "d");
if (crc32("UdIMRguVvve",11) == 283484440) strcat(s, "e");
if (crc32("FTIysaCH",8) == 303266748) strcat(s, "n");
if (crc32("oBboDi",6) == 3036376224) strcat(s, "E");
if (crc32("iSZTXwBqYl",10) == 1990719279) strcat(s, "t");
if (crc32("NfFNx",5) == 2074071837) strcat(s, "i");
if (crc32("oowYkj",6) == 3991489408) strcat(s, "v");
if (crc32("grBmLjd",7) == 3242372859) strcat(s, "U");
if (crc32("mgIZMGTjEOIF",12) == 800392301) strcat(s, "e");
if (crc32("hagDS",5) == 2020066109) strcat(s, "e");
if (crc32("swXNLu",6) == 2140725294) strcat(s, "l");
if (crc32("jGnAMNOC",8) == 2038846708) strcat(s, "y");
    return s;
}

char *sequaciously_adverbs() {
    char *s = calloc(13);
    if (crc32("gBksb",5) == 3229416619) strcat(s, "c");
if (crc32("bhSxAnO",7) == 3634351922) strcat(s, "s");
if (crc32("sKUrxyM",7) == 226704628) strcat(s, "O");
if (crc32("UsZmZ",5) == 1973272242) strcat(s, "e");
if (crc32("iNwiHyy",7) == 1906210917) strcat(s, "d");
if (crc32("dPNhYAxfkFrZJp",14) == 707810201) strcat(s, "q");
if (crc32("EokYPTKDtpZRzGp",15) == 3990449215) strcat(s, "h");
if (crc32("uwcVi",5) == 2481346256) strcat(s, "u");
if (crc32("XXeVuv",6) == 552398786) strcat(s, "q");
if (crc32("jPocfXHYRNZq",12) == 686605694) strcat(s, "a");
if (crc32("DpwIONqdgsdZr",13) == 3840130966) strcat(s, "c");
if (crc32("qVlKhpbHUlc",11) == 487631948) strcat(s, "M");
if (crc32("EOBaYoXTIjQ",11) == 2967112412) strcat(s, "i");
if (crc32("hMYtFYDPmq",10) == 1068508454) strcat(s, "o");
if (crc32("JocDytclNuH",11) == 1330613522) strcat(s, "t");
if (crc32("FVaUg",5) == 2734225015) strcat(s, "u");
if (crc32("OHMcZJebrU",10) == 524474633) strcat(s, "s");
if (crc32("cjYDy",5) == 230192760) strcat(s, "y");
if (crc32("oXlaZNXFBlPh",12) == 219392251) strcat(s, "l");
if (crc32("IxoFJxJkysLZ",12) == 2945676043) strcat(s, "y");
    return s;
}

char *nohow_adverbs() {
    char *s = calloc(6);
    if (crc32("sgxAO",5) == 3269936595) strcat(s, "R");
if (crc32("ycozFpwGs",9) == 2821479991) strcat(s, "n");
if (crc32("TTlpwXLWKm",10) == 2434586121) strcat(s, "o");
if (crc32("upuZfoW",7) == 3870075367) strcat(s, "h");
if (crc32("MMEEzSbCePXxk",13) == 1789010905) strcat(s, "o");
if (crc32("ZjiJDoEj",8) == 3291368903) strcat(s, "w");
    return s;
}

char *medicably_adverbs() {
    char *s = calloc(10);
    if (crc32("SUdTfgGXJhOIF",13) == 981037824) strcat(s, "w");
if (crc32("xUWlXxCiSLKzKz",14) == 4155932580) strcat(s, "m");
if (crc32("GKMGJgfXLprfKl",14) == 2680976434) strcat(s, "b");
if (crc32("pukorPMVvd",10) == 327426375) strcat(s, "e");
if (crc32("vYrHaGbnct",10) == 3155741490) strcat(s, "d");
if (crc32("IKtKUMQCOxneVTH",15) == 1339591833) strcat(s, "i");
if (crc32("hWIfzX",6) == 3312506832) strcat(s, "c");
if (crc32("xggjFmGegAKgK",13) == 2354573899) strcat(s, "a");
if (crc32("voYhp",5) == 4133008398) strcat(s, "c");
if (crc32("SqEtnHWKmLdK",12) == 104736988) strcat(s, "b");
if (crc32("MDpSto",6) == 1022146262) strcat(s, "l");
if (crc32("auYnhpzd",8) == 2515480987) strcat(s, "f");
if (crc32("kwsmpmFQ",8) == 3154587836) strcat(s, "y");
    return s;
}

char *populously_adverbs() {
    char *s = calloc(11);
    if (crc32("WBjPxvIw",8) == 1761881683) strcat(s, "p");
if (crc32("ptGiXuEs",8) == 1336640281) strcat(s, "o");
if (crc32("NwQLZMPaDTtHB",13) == 2322873589) strcat(s, "p");
if (crc32("YeniSpoA",8) == 3797171198) strcat(s, "T");
if (crc32("jhVEBLgPATMoJ",13) == 470127945) strcat(s, "u");
if (crc32("BFsGjEqAynpxgfH",15) == 3597488567) strcat(s, "W");
if (crc32("fxeRsdIOaQNm",12) == 2415844291) strcat(s, "l");
if (crc32("gmbQbxudVA",10) == 409659792) strcat(s, "o");
if (crc32("kRVbLQ",6) == 4266828844) strcat(s, "j");
if (crc32("DAntNjcQUKbJNWF",15) == 894083141) strcat(s, "u");
if (crc32("nGrMNHyJbTRV",12) == 489046323) strcat(s, "s");
if (crc32("KLDDvg",6) == 1054690476) strcat(s, "l");
if (crc32("zigTBSmSKpLtSZu",15) == 1220896951) strcat(s, "l");
if (crc32("bSeymO",6) == 3366614795) strcat(s, "a");
if (crc32("yxBYRMyeJXj",11) == 3972393013) strcat(s, "y");
    return s;
}

char *noisily_adverbs() {
    char *s = calloc(8);
    if (crc32("xHyVjvaLQ",9) == 1615758073) strcat(s, "n");
if (crc32("eQaPuPgArKXWiv",14) == 2670366204) strcat(s, "o");
if (crc32("xYRQzGX",7) == 3450373279) strcat(s, "y");
if (crc32("FqTeBndLZlLp",12) == 1791958286) strcat(s, "i");
if (crc32("Vfrwg",5) == 412170070) strcat(s, "U");
if (crc32("heWKqtwxnKWKUZO",15) == 4162568588) strcat(s, "s");
if (crc32("MbdVxhfMrgmBVH",14) == 2151270570) strcat(s, "i");
if (crc32("OLlYy",5) == 967123689) strcat(s, "Q");
if (crc32("MalImNSuq",9) == 2953702892) strcat(s, "l");
if (crc32("YNvSjIDjfT",10) == 985839624) strcat(s, "y");
    return s;
}

char *imaginably_adverbs() {
    char *s = calloc(11);
    if (crc32("xNROKo",6) == 1697787892) strcat(s, "i");
if (crc32("urWzCVRa",8) == 186944119) strcat(s, "m");
if (crc32("UMurxhYSFWcoYS",14) == 3701912965) strcat(s, "e");
if (crc32("TlgLnTLRrQLJwc",14) == 2327191871) strcat(s, "a");
if (crc32("ocKWKjdS",8) == 3284004181) strcat(s, "g");
if (crc32("TenkEyQLRDeSJ",13) == 2551667248) strcat(s, "i");
if (crc32("bIEFPXvNM",9) == 2818231609) strcat(s, "G");
if (crc32("mgOfpFJoc",9) == 4053506714) strcat(s, "n");
if (crc32("AsLNu",5) == 3775412423) strcat(s, "Z");
if (crc32("FkLbwml",7) == 289516584) strcat(s, "a");
if (crc32("ioSnHwUVpaSCAJC",15) == 2744626837) strcat(s, "D");
if (crc32("VeaJjh",6) == 405487683) strcat(s, "b");
if (crc32("bDTvnnOgO",9) == 384390043) strcat(s, "m");
if (crc32("nCDkMpmzpHmx",12) == 2126040521) strcat(s, "l");
if (crc32("pFAPaRzVD",9) == 894754439) strcat(s, "V");
if (crc32("RUdiIzdUseYN",12) == 1516713736) strcat(s, "y");
    return s;
}

char *mellowly_adverbs() {
    char *s = calloc(9);
    if (crc32("nHOqVuaRxnVKksk",15) == 524824898) strcat(s, "Z");
if (crc32("nXPYEG",6) == 1183399533) strcat(s, "m");
if (crc32("dKpqLgiKUq",10) == 145311984) strcat(s, "e");
if (crc32("CLgRsWFevCuRwA",14) == 438902993) strcat(s, "l");
if (crc32("ANNWGIQedtP",11) == 1133061286) strcat(s, "W");
if (crc32("jQkpQL",6) == 2042761752) strcat(s, "l");
if (crc32("APbiH",5) == 4023881540) strcat(s, "o");
if (crc32("HOcjUSPHjGu",11) == 1556026231) strcat(s, "C");
if (crc32("cFpoeusd",8) == 483588049) strcat(s, "w");
if (crc32("KgduohQ",7) == 201411820) strcat(s, "l");
if (crc32("zkSsfJBlMZJ",11) == 2371686308) strcat(s, "N");
if (crc32("adoqFdwVb",9) == 958694574) strcat(s, "y");
    return s;
}

char *unlikably_adverbs() {
    char *s = calloc(10);
    if (crc32("hfQlRjRwzA",10) == 2905382531) strcat(s, "u");
if (crc32("LdEBVys",7) == 1936489099) strcat(s, "n");
if (crc32("droHzMcqLk",10) == 4114588410) strcat(s, "r");
if (crc32("bKdubsYgqn",10) == 475258119) strcat(s, "l");
if (crc32("xHJhSSzieZLIP",13) == 513585932) strcat(s, "i");
if (crc32("OTcRMMbbEGK",11) == 545598322) strcat(s, "k");
if (crc32("AuXijKh",7) == 2132160528) strcat(s, "a");
if (crc32("WTTrsZB",7) == 3749643186) strcat(s, "l");
if (crc32("tXUTcEoeFEHYds",14) == 3751600081) strcat(s, "b");
if (crc32("IezBOKlFwX",10) == 466589336) strcat(s, "t");
if (crc32("uKyRUMeWrqxzrBw",15) == 132144087) strcat(s, "l");
if (crc32("LflWwdVZDylPCeE",15) == 1818126248) strcat(s, "c");
if (crc32("iccKGAkYM",9) == 2038524974) strcat(s, "y");
    return s;
}

char *evaporatively_adverbs() {
    char *s = calloc(14);
    if (crc32("bOQgqohUPLu",11) == 4088575609) strcat(s, "J");
if (crc32("cVsHtXR",7) == 3116937001) strcat(s, "e");
if (crc32("UcWIT",5) == 990688991) strcat(s, "v");
if (crc32("bwojProGKQwHZW",14) == 1320534079) strcat(s, "j");
if (crc32("EuvMNsuQZSwaO",13) == 1136780114) strcat(s, "a");
if (crc32("VgPTblOLXcXpusC",15) == 1557593769) strcat(s, "p");
if (crc32("uSksAfThSWDM",12) == 3842690278) strcat(s, "Q");
if (crc32("kRPhlVzBBu",10) == 646925165) strcat(s, "o");
if (crc32("LrrkdWUGxdi",11) == 1558877798) strcat(s, "D");
if (crc32("LpekffGQ",8) == 2967513016) strcat(s, "r");
if (crc32("acdte",5) == 1924578260) strcat(s, "a");
if (crc32("CWtgVmlJuuxREk",14) == 303192146) strcat(s, "Y");
if (crc32("FVZLthZGcJXPcH",14) == 1578333161) strcat(s, "t");
if (crc32("xqUatfLhKvBb",12) == 280376866) strcat(s, "x");
if (crc32("SRVMf",5) == 1369580040) strcat(s, "i");
if (crc32("aKXcCjUdosl",11) == 883355337) strcat(s, "i");
if (crc32("ZdGOVF",6) == 2118053809) strcat(s, "v");
if (crc32("UEExDr",6) == 2711938088) strcat(s, "e");
if (crc32("RANaD",5) == 1161638424) strcat(s, "A");
if (crc32("kKSaeNpe",8) == 3841731961) strcat(s, "l");
if (crc32("mGQCnGXTsiivh",13) == 3721663120) strcat(s, "Y");
if (crc32("qbISqfsLNRBtLks",15) == 2246768218) strcat(s, "y");
    return s;
}

char *pseudoaggressively_adverbs() {
    char *s = calloc(19);
    if (crc32("gRYICccF",8) == 4153532665) strcat(s, "u");
if (crc32("ljSHUml",7) == 2804335832) strcat(s, "p");
if (crc32("zfKWpgMcTUYnBsm",15) == 1303700655) strcat(s, "s");
if (crc32("lftPsWrAemgsfBp",15) == 1902912814) strcat(s, "o");
if (crc32("vENkdRLJYFbgYU",14) == 2198844396) strcat(s, "e");
if (crc32("pDXeQjzRcRo",11) == 2999963242) strcat(s, "u");
if (crc32("WaTNhKRddpIa",12) == 2542702025) strcat(s, "d");
if (crc32("OAffosSPtuBynUz",15) == 1016145426) strcat(s, "M");
if (crc32("CPIRALfJiJ",10) == 2126250195) strcat(s, "o");
if (crc32("nxkqknsc",8) == 2810333621) strcat(s, "a");
if (crc32("fWnUqTeVqFTnSg",14) == 2756131249) strcat(s, "g");
if (crc32("bDRnfMKkSUD",11) == 1600922231) strcat(s, "a");
if (crc32("gwSXEppDBtezLS",14) == 1466063420) strcat(s, "g");
if (crc32("QhLJTB",6) == 3724653244) strcat(s, "R");
if (crc32("EutVOBhRXnCY",12) == 2730783836) strcat(s, "r");
if (crc32("YETpcvXnuKe",11) == 811055176) strcat(s, "X");
if (crc32("QlAauNfgM",9) == 29516083) strcat(s, "e");
if (crc32("NqtjvhOgdrHB",12) == 4026380736) strcat(s, "s");
if (crc32("FeJERtFWUoMh",12) == 4197791568) strcat(s, "Y");
if (crc32("zbDXTXrueWL",11) == 2342370930) strcat(s, "s");
if (crc32("BvgvphGNRDm",11) == 169487673) strcat(s, "h");
if (crc32("npwyptFquP",10) == 3598516254) strcat(s, "i");
if (crc32("rwRcFEeg",8) == 2248558756) strcat(s, "I");
if (crc32("aVZWdWptde",10) == 3819635200) strcat(s, "v");
if (crc32("zMRRTARAFFCq",12) == 1758082204) strcat(s, "e");
if (crc32("iCafIQxi",8) == 2226282625) strcat(s, "Y");
if (crc32("BgZCs",5) == 831759528) strcat(s, "l");
if (crc32("JHETWGDKItq",11) == 2436336616) strcat(s, "y");
    return s;
}

char *superinfinitely_adverbs() {
    char *s = calloc(16);
    if (crc32("ZooescuSGrfpkk",14) == 2815740816) strcat(s, "Q");
if (crc32("RkKfwNVbeBU",11) == 2241994501) strcat(s, "s");
if (crc32("CYVldNefvuln",12) == 1081361695) strcat(s, "u");
if (crc32("mcTbuAtWLssJ",12) == 2238939345) strcat(s, "P");
if (crc32("xAQWsGfQUBj",11) == 3415577340) strcat(s, "p");
if (crc32("jJPQYozYLag",11) == 662841603) strcat(s, "e");
if (crc32("oYhdlzFnIY",10) == 494098022) strcat(s, "i");
if (crc32("GLrQGjkZkrqt",12) == 3002716842) strcat(s, "r");
if (crc32("kTUEojd",7) == 109434894) strcat(s, "K");
if (crc32("uOjMTRhcsBYoX",13) == 1446300087) strcat(s, "i");
if (crc32("UZqvtSRWYz",10) == 2295849314) strcat(s, "n");
if (crc32("qujWpXTPnOEWKR",14) == 3037059965) strcat(s, "D");
if (crc32("LRAUYUgA",8) == 1824016690) strcat(s, "f");
if (crc32("RZspbwnymGiOjBN",15) == 3934067466) strcat(s, "R");
if (crc32("APIJjBmRpAZ",11) == 1424291861) strcat(s, "i");
if (crc32("oSnauHK",7) == 1149515727) strcat(s, "n");
if (crc32("XoPZdNmzk",9) == 4031645869) strcat(s, "i");
if (crc32("ywsTLKub",8) == 3363934712) strcat(s, "m");
if (crc32("SMQaVmnuz",9) == 2273994451) strcat(s, "t");
if (crc32("cUvxLzQr",8) == 3008982902) strcat(s, "p");
if (crc32("EKHiHtnLiBijRV",14) == 836286266) strcat(s, "e");
if (crc32("KyzAekBH",8) == 1430064289) strcat(s, "l");
if (crc32("nbluXaWllECvOr",14) == 75988854) strcat(s, "f");
if (crc32("HTdUEQp",7) == 1745015454) strcat(s, "y");
    return s;
}

char *nonimperially_adverbs() {
    char *s = calloc(14);
    if (crc32("UvpgexKsGYYC",12) == 2368175150) strcat(s, "U");
if (crc32("MWilek",6) == 1295910453) strcat(s, "n");
if (crc32("UaGizUMOSR",10) == 2530764817) strcat(s, "o");
if (crc32("SHXKRFhqd",9) == 1319283062) strcat(s, "p");
if (crc32("mIkNmNsOn",9) == 1344376310) strcat(s, "n");
if (crc32("teXtc",5) == 2395081268) strcat(s, "p");
if (crc32("rcwpbFzGHk",10) == 1060990408) strcat(s, "i");
if (crc32("oYqcnBhviQvb",12) == 1709917394) strcat(s, "t");
if (crc32("NbNumPE",7) == 2336520629) strcat(s, "m");
if (crc32("XeJZKRcKeceKN",13) == 2394333451) strcat(s, "J");
if (crc32("gQIVatEHvNJtGc",14) == 2733620189) strcat(s, "p");
if (crc32("cKCNCVLTBfVqkp",14) == 2388722576) strcat(s, "G");
if (crc32("iBjXdHpGMG",10) == 661583752) strcat(s, "e");
if (crc32("KJOXdGDDumwVvx",14) == 775505713) strcat(s, "g");
if (crc32("uwzSBFIDaEl",11) == 2237408133) strcat(s, "r");
if (crc32("cbghAhsBqVhlAlb",15) == 2420874824) strcat(s, "i");
if (crc32("TVTcDdhiv",9) == 1370377831) strcat(s, "a");
if (crc32("JAAXqZJ",7) == 4008578958) strcat(s, "P");
if (crc32("wFIhrMrK",8) == 537564515) strcat(s, "l");
if (crc32("QYlNepfHQ",9) == 4104200580) strcat(s, "c");
if (crc32("tfXzAoEoCHcqv",13) == 986925510) strcat(s, "l");
if (crc32("CivdAhTd",8) == 216008155) strcat(s, "j");
if (crc32("dJjnpeKJ",8) == 4264700184) strcat(s, "y");
    return s;
}

char *nowhither_adverbs() {
    char *s = calloc(10);
    if (crc32("wkjWVRhJ",8) == 3542713241) strcat(s, "n");
if (crc32("qXDQVYeRKNnYV",13) == 3237814075) strcat(s, "y");
if (crc32("DxeSzVHsfrbA",12) == 1334076632) strcat(s, "o");
if (crc32("UDqTAhDrSYRD",12) == 2264222666) strcat(s, "w");
if (crc32("XANhqIPfxUvDvG",14) == 4292163898) strcat(s, "h");
if (crc32("SQylZXwREzofy",13) == 4118603391) strcat(s, "W");
if (crc32("vNgqVWcr",8) == 3173318648) strcat(s, "i");
if (crc32("VgjRbDggeMFy",12) == 2252436296) strcat(s, "y");
if (crc32("wcSEscGFHEXfx",13) == 176750089) strcat(s, "t");
if (crc32("HIshxvfwbJuu",12) == 3777871134) strcat(s, "h");
if (crc32("CRhSzJr",7) == 137294721) strcat(s, "Z");
if (crc32("SZkpqr",6) == 2038582373) strcat(s, "e");
if (crc32("tJwifQfttbB",11) == 1861325946) strcat(s, "R");
if (crc32("yYCGrImkwLPotGe",15) == 1431028752) strcat(s, "r");
    return s;
}

char *nonsubstitutionally_adverbs() {
    char *s = calloc(20);
    if (crc32("khcYYTlyUwF",11) == 3913040000) strcat(s, "i");
if (crc32("QLbbeEZb",8) == 1082803440) strcat(s, "n");
if (crc32("kqlFT",5) == 4133484914) strcat(s, "J");
if (crc32("wRxxGehFQ",9) == 1201590264) strcat(s, "o");
if (crc32("XaaJU",5) == 3062749094) strcat(s, "x");
if (crc32("HYiKmCO",7) == 1678143467) strcat(s, "n");
if (crc32("KXbJUfMPMMf",11) == 4031240191) strcat(s, "m");
if (crc32("lYYFfQzrUp",10) == 2230517212) strcat(s, "s");
if (crc32("eQUwAYPh",8) == 1859207345) strcat(s, "l");
if (crc32("NUmknqO",7) == 3398465916) strcat(s, "u");
if (crc32("lvxao",5) == 2141135926) strcat(s, "J");
if (crc32("CTBeGhukPPwCXM",14) == 3841055584) strcat(s, "b");
if (crc32("PUfIx",5) == 836599190) strcat(s, "s");
if (crc32("TOlBVGENlbvxUzt",15) == 4052339596) strcat(s, "t");
if (crc32("RxtBaKj",7) == 2736826169) strcat(s, "i");
if (crc32("UJkrRFQ",7) == 3101781264) strcat(s, "i");
if (crc32("qqxBfcTvBXEO",12) == 2778030048) strcat(s, "h");
if (crc32("zboXdBtFlrTpBi",14) == 583375078) strcat(s, "t");
if (crc32("SoAckBu",7) == 639871891) strcat(s, "f");
if (crc32("eqUvfUiVZpipkco",15) == 784906487) strcat(s, "u");
if (crc32("DwDfJafzKiStW",13) == 870782907) strcat(s, "x");
if (crc32("teIxOZEraSXfqcQ",15) == 1818185876) strcat(s, "t");
if (crc32("qQawjCedmXgaw",13) == 2237445865) strcat(s, "x");
if (crc32("sXvNPjZY",8) == 2983328740) strcat(s, "i");
if (crc32("bPPpqyXZAizdfuE",15) == 3711537879) strcat(s, "o");
if (crc32("hkOlWxNi",8) == 3139831062) strcat(s, "C");
if (crc32("YhaVpeFPbhoHTNJ",15) == 2413266370) strcat(s, "n");
if (crc32("jfWXgQRm",8) == 1839443887) strcat(s, "e");
if (crc32("eIxrjtFgvMDWw",13) == 2275815635) strcat(s, "a");
if (crc32("GQjeoZjQ",8) == 4242831418) strcat(s, "K");
if (crc32("EYkbewRUbpkH",12) == 2966763168) strcat(s, "l");
if (crc32("AtvlULkzG",9) == 2947510272) strcat(s, "l");
if (crc32("wGuTfydIyhEILg",14) == 3495952741) strcat(s, "z");
if (crc32("EdZgFmlLEl",10) == 1773672958) strcat(s, "y");
    return s;
}

char *accommodatingly_adverbs() {
    char *s = calloc(16);
    if (crc32("KoiyESKmtXkBnH",14) == 4016549740) strcat(s, "a");
if (crc32("BSvrGC",6) == 1790031893) strcat(s, "c");
if (crc32("lqVwYxUQuVQ",11) == 4292264319) strcat(s, "c");
if (crc32("mVHHng",6) == 1528033732) strcat(s, "C");
if (crc32("iSxKihVp",8) == 3437746392) strcat(s, "c");
if (crc32("PxgOFRvLXFuXX",13) == 2361122709) strcat(s, "o");
if (crc32("DECSQiFdQvXvM",13) == 2575838446) strcat(s, "y");
if (crc32("pEItLqqRcSsam",13) == 43702219) strcat(s, "m");
if (crc32("wqkUpX",6) == 2944952780) strcat(s, "m");
if (crc32("PWyRU",5) == 1615316671) strcat(s, "o");
if (crc32("uPyNzXKmz",9) == 3828264924) strcat(s, "d");
if (crc32("HJgYwJoqbMb",11) == 2790680298) strcat(s, "k");
if (crc32("vviJKuACFLTpB",13) == 1979543408) strcat(s, "a");
if (crc32("NPDMzZGjRjo",11) == 287945354) strcat(s, "t");
if (crc32("xxeyNurUDucjCq",14) == 2071577502) strcat(s, "q");
if (crc32("TwdVVidOgS",10) == 2327460805) strcat(s, "i");
if (crc32("gUrkkwe",7) == 4180650459) strcat(s, "n");
if (crc32("rrimNYJQpqdUrM",14) == 1226037430) strcat(s, "g");
if (crc32("lIDtDuCxWAM",11) == 3242669390) strcat(s, "f");
if (crc32("gAQqCQsjo",9) == 111830372) strcat(s, "l");
if (crc32("awOxDdmExkXvy",13) == 1498479675) strcat(s, "y");
    return s;
}

char *unfrictionally_adverbs() {
    char *s = calloc(15);
    if (crc32("AUBWeYwvUi",10) == 535944449) strcat(s, "u");
if (crc32("MtCgAeggVV",10) == 3704945698) strcat(s, "n");
if (crc32("XaNHiy",6) == 1844027332) strcat(s, "f");
if (crc32("srevgFgfB",9) == 3194293919) strcat(s, "R");
if (crc32("JkAKKcnEyVxzYJh",15) == 3872953281) strcat(s, "r");
if (crc32("kASxXvB",7) == 465414373) strcat(s, "F");
if (crc32("nXQTTophjj",10) == 952834613) strcat(s, "i");
if (crc32("mawLxm",6) == 4202160448) strcat(s, "c");
if (crc32("wzKByzOPebhPi",13) == 3479069978) strcat(s, "b");
if (crc32("SGPkwY",6) == 743273121) strcat(s, "t");
if (crc32("HEzUlFUZHSJD",12) == 4127840768) strcat(s, "i");
if (crc32("bNqAqKEcUjDKrUn",15) == 2528334331) strcat(s, "i");
if (crc32("THZPdSoEXh",10) == 432375805) strcat(s, "o");
if (crc32("sLOLgjGTDwN",11) == 4030361169) strcat(s, "R");
if (crc32("eTzKLe",6) == 1026679110) strcat(s, "n");
if (crc32("bmMmxH",6) == 600596161) strcat(s, "a");
if (crc32("sljIPA",6) == 4026976762) strcat(s, "l");
if (crc32("nwhWWp",6) == 4199591456) strcat(s, "l");
if (crc32("UrULibnIWGZeVQJ",15) == 3506581836) strcat(s, "Z");
if (crc32("YTvgbRMnNb",10) == 1283787069) strcat(s, "y");
    return s;
}

char *nonclassically_adverbs() {
    char *s = calloc(15);
    if (crc32("awlFMCmZi",9) == 2204404058) strcat(s, "n");
if (crc32("iKLBlcOVECfSWqZ",15) == 4054974524) strcat(s, "m");
if (crc32("OUClj",5) == 4137769057) strcat(s, "o");
if (crc32("NrrzRUAR",8) == 4211096101) strcat(s, "X");
if (crc32("HuVDAhgd",8) == 1403064639) strcat(s, "n");
if (crc32("JfgFIznDzWvsh",13) == 1142391250) strcat(s, "B");
if (crc32("CHjROUdzt",9) == 2130198478) strcat(s, "c");
if (crc32("uYxSpPOYls",10) == 3556520955) strcat(s, "l");
if (crc32("xMzWxrDJ",8) == 3735958942) strcat(s, "Q");
if (crc32("FyiPzUpIvqBkm",13) == 3858990771) strcat(s, "a");
if (crc32("kYpCBpBH",8) == 2503736443) strcat(s, "s");
if (crc32("hyyda",5) == 16282566) strcat(s, "a");
if (crc32("LvJTzKdTzHMG",12) == 201577178) strcat(s, "s");
if (crc32("TRaeziHKpbwwo",13) == 2364627002) strcat(s, "i");
if (crc32("aLlIdRXZhV",10) == 584465111) strcat(s, "c");
if (crc32("rjrVIXWYvGsLT",13) == 2428373439) strcat(s, "z");
if (crc32("affQXMQ",7) == 819442016) strcat(s, "a");
if (crc32("PAmZB",5) == 1158728351) strcat(s, "l");
if (crc32("MTTSjvoH",8) == 1980335940) strcat(s, "l");
if (crc32("ltuJBCvQ",8) == 2502254082) strcat(s, "y");
    return s;
}

char *subprofitably_adverbs() {
    char *s = calloc(14);
    if (crc32("mugZe",5) == 3413502435) strcat(s, "s");
if (crc32("BzTBNFisAdhAUJ",14) == 3470293126) strcat(s, "i");
if (crc32("GsXtSpWmxIsj",12) == 1614793589) strcat(s, "u");
if (crc32("szmaI",5) == 963517584) strcat(s, "T");
if (crc32("UxFZhSQxCKuaZ",13) == 28966883) strcat(s, "b");
if (crc32("QHrgzjtPNs",10) == 3889581595) strcat(s, "E");
if (crc32("fpiOuVGhTobsr",13) == 3538560843) strcat(s, "p");
if (crc32("BWuxEZ",6) == 3860579883) strcat(s, "R");
if (crc32("ssttxYpZxgZWkh",14) == 4259764677) strcat(s, "r");
if (crc32("uEFuMkqqSiJcNMP",15) == 5412911) strcat(s, "h");
if (crc32("ymAqz",5) == 201354527) strcat(s, "o");
if (crc32("PjSQgJYQG",9) == 4149313486) strcat(s, "f");
if (crc32("wHSvpuSCRzxIDGD",15) == 2374733502) strcat(s, "x");
if (crc32("mvBDiGy",7) == 1305753649) strcat(s, "i");
if (crc32("FUagnqhEbGVrM",13) == 2518221159) strcat(s, "T");
if (crc32("aJIzIDG",7) == 1290347416) strcat(s, "t");
if (crc32("XPOVtAj",7) == 2732644657) strcat(s, "a");
if (crc32("dKeqjHnqNiGYfko",15) == 3301513095) strcat(s, "V");
if (crc32("WuZpbdZkBcVWK",13) == 536583481) strcat(s, "b");
if (crc32("LZTpaIJPqBv",11) == 815622738) strcat(s, "W");
if (crc32("RTqavQgdVBO",11) == 2601669190) strcat(s, "l");
if (crc32("lZsGETSpiaYJQH",14) == 3875046722) strcat(s, "g");
if (crc32("ruGSKPgR",8) == 3617129971) strcat(s, "y");
    return s;
}

char *pryingly_adverbs() {
    char *s = calloc(9);
    if (crc32("uznJIZJjFM",10) == 4130232464) strcat(s, "p");
if (crc32("zseZPzM",7) == 480361070) strcat(s, "r");
if (crc32("JWNnEVhnfVt",11) == 2652238407) strcat(s, "y");
if (crc32("JBnzOeKFUXkGnuf",15) == 3960617120) strcat(s, "i");
if (crc32("uSUyeSaUVK",10) == 529204806) strcat(s, "n");
if (crc32("iSxIWsasTJXiXw",14) == 3958662379) strcat(s, "g");
if (crc32("YZKpiX",6) == 562794930) strcat(s, "l");
if (crc32("BUxwD",5) == 1408192756) strcat(s, "y");
    return s;
}

char *libidinously_adverbs() {
    char *s = calloc(13);
    if (crc32("DjMteSqelm",10) == 1467431708) strcat(s, "l");
if (crc32("ufLCkOOisDsTBG",14) == 1233299960) strcat(s, "O");
if (crc32("VwUBDOGZGxpehFM",15) == 816274620) strcat(s, "i");
if (crc32("OTjgJwQ",7) == 2411419179) strcat(s, "r");
if (crc32("NTYzniByspW",11) == 4040571391) strcat(s, "b");
if (crc32("mxFfIoAR",8) == 4155001573) strcat(s, "i");
if (crc32("TvvFUinkLqC",11) == 12490293) strcat(s, "d");
if (crc32("SYdvucfXLkh",11) == 772717206) strcat(s, "V");
if (crc32("KLslLOpjNPpk",12) == 3081134613) strcat(s, "i");
if (crc32("DpNYEcyYwtAEz",13) == 3960226166) strcat(s, "n");
if (crc32("BYObsnYNBk",10) == 2020788620) strcat(s, "L");
if (crc32("bxlHX",5) == 2542171596) strcat(s, "o");
if (crc32("JAATsfzIw",9) == 1039826688) strcat(s, "a");
if (crc32("GWIBVVjCGQWh",12) == 1144945103) strcat(s, "u");
if (crc32("OmOPD",5) == 1466636915) strcat(s, "Z");
if (crc32("nCFIpzCimjwpKdT",15) == 2962049161) strcat(s, "s");
if (crc32("nwATRjdS",8) == 1470895285) strcat(s, "l");
if (crc32("zcCVKxV",7) == 3003136534) strcat(s, "y");
    return s;
}

char *joyfully_adverbs() {
    char *s = calloc(9);
    if (crc32("pNKvarWDjcdmNE",14) == 81001473) strcat(s, "n");
if (crc32("ihfYy",5) == 2724767194) strcat(s, "j");
if (crc32("nhtCxZgUFc",10) == 3173657793) strcat(s, "o");
if (crc32("IAgwNwzqxDP",11) == 3993198635) strcat(s, "y");
if (crc32("iHRMDFEtqhVp",12) == 3237043570) strcat(s, "f");
if (crc32("FBlqDyhGHtZ",11) == 3754425520) strcat(s, "z");
if (crc32("vzaUd",5) == 1882460109) strcat(s, "u");
if (crc32("NFKliPtklygpIZ",14) == 1882508715) strcat(s, "l");
if (crc32("ZXoQiATdp",9) == 2560206712) strcat(s, "s");
if (crc32("EnaAnGb",7) == 1620489651) strcat(s, "l");
if (crc32("YdmHhcWz",8) == 2104666458) strcat(s, "y");
    return s;
}

char *uncarnivorously_adverbs() {
    char *s = calloc(16);
    if (crc32("JIVLYQby",8) == 3998329686) strcat(s, "u");
if (crc32("EIylCMFp",8) == 2733020656) strcat(s, "n");
if (crc32("znRTiN",6) == 311671572) strcat(s, "c");
if (crc32("VweaBCkrJFyez",13) == 1967562566) strcat(s, "o");
if (crc32("XJdWh",5) == 3282405963) strcat(s, "a");
if (crc32("aiXQIuMIrO",10) == 3660873590) strcat(s, "r");
if (crc32("xBRSMmBiqrKEkc",14) == 4100490704) strcat(s, "E");
if (crc32("XAtpVKqXTFKNTUW",15) == 2151544655) strcat(s, "n");
if (crc32("SVdQAAJlSKd",11) == 3568423687) strcat(s, "i");
if (crc32("vOHpaQmEK",9) == 304547198) strcat(s, "v");
if (crc32("SZpBzZAQT",9) == 4240220125) strcat(s, "w");
if (crc32("dGokXHPrvXzZuji",15) == 425762268) strcat(s, "o");
if (crc32("LPnNxXZlNAzqu",13) == 2407461235) strcat(s, "i");
if (crc32("Prfbs",5) == 3986345712) strcat(s, "r");
if (crc32("ehXHIA",6) == 931038361) strcat(s, "l");
if (crc32("RUwYi",5) == 1988875538) strcat(s, "o");
if (crc32("aJDarg",6) == 715027630) strcat(s, "o");
if (crc32("wmGErxRMpmpMk",13) == 2757377971) strcat(s, "u");
if (crc32("ddujWrP",7) == 197718185) strcat(s, "s");
if (crc32("LViwdpxNnqM",11) == 4013429050) strcat(s, "l");
if (crc32("SeDBxIcycRwV",12) == 115279028) strcat(s, "y");
    return s;
}

char *gratefully_adverbs() {
    char *s = calloc(11);
    if (crc32("BdijvJWKbtZzD",13) == 2992399828) strcat(s, "k");
if (crc32("ROTCHVolbJ",10) == 1289594589) strcat(s, "g");
if (crc32("eQHCoRnIc",9) == 1358845167) strcat(s, "S");
if (crc32("DBYRohsfxDUY",12) == 4177825413) strcat(s, "r");
if (crc32("WEjqWEprLuiDSS",14) == 3449654903) strcat(s, "a");
if (crc32("YTjxjkQj",8) == 2260904679) strcat(s, "t");
if (crc32("vMUMk",5) == 739116881) strcat(s, "e");
if (crc32("IgYoDcY",7) == 340169294) strcat(s, "f");
if (crc32("vHOmZZzHvbN",11) == 3944313648) strcat(s, "f");
if (crc32("QvFjrP",6) == 3815304678) strcat(s, "r");
if (crc32("lFAdE",5) == 1390450427) strcat(s, "u");
if (crc32("jSeqhIJRzKWQJb",14) == 1949248839) strcat(s, "l");
if (crc32("kleaZtJJ",8) == 856270154) strcat(s, "l");
if (crc32("ijTtVsGF",8) == 2254160044) strcat(s, "l");
if (crc32("KNkINSvhJEVi",12) == 4071370742) strcat(s, "M");
if (crc32("nCYzXw",6) == 3473896317) strcat(s, "y");
    return s;
}

char *untoughly_adverbs() {
    char *s = calloc(10);
    if (crc32("cUtpCQNqlFfObyj",15) == 2195419376) strcat(s, "G");
if (crc32("NOuqiqNQGB",10) == 376165058) strcat(s, "u");
if (crc32("MGVTMjjyHveJ",12) == 4050821921) strcat(s, "n");
if (crc32("aEKXmYHRVCIN",12) == 2968762884) strcat(s, "t");
if (crc32("HyDmIsfIf",9) == 1587690391) strcat(s, "O");
if (crc32("uUFaMHVaqivB",12) == 3634508610) strcat(s, "o");
if (crc32("WfrkiWuQDbMTIQ",14) == 1076762870) strcat(s, "H");
if (crc32("OtVlzP",6) == 1385102759) strcat(s, "u");
if (crc32("HoSdPfbnHiB",11) == 2825485331) strcat(s, "o");
if (crc32("cJaegrTQeseeS",13) == 2317231121) strcat(s, "g");
if (crc32("wdoyaDRtjkeg",12) == 2377263070) strcat(s, "h");
if (crc32("AKnoeHijKtvGX",13) == 642855777) strcat(s, "h");
if (crc32("YtxYKKvhtjhT",12) == 2305725909) strcat(s, "l");
if (crc32("TjLhtTE",7) == 2294603065) strcat(s, "G");
if (crc32("aTvtqVS",7) == 4274849937) strcat(s, "y");
    return s;
}

char *meristematically_adverbs() {
    char *s = calloc(17);
    if (crc32("zsaNWIGW",8) == 3271507601) strcat(s, "m");
if (crc32("HZNnPJHH",8) == 3165749709) strcat(s, "q");
if (crc32("YAZwSk",6) == 1093185073) strcat(s, "e");
if (crc32("dxsNbaYypgVs",12) == 3735798822) strcat(s, "U");
if (crc32("HxPpVSknZ",9) == 2393414599) strcat(s, "r");
if (crc32("wedEp",5) == 335373683) strcat(s, "i");
if (crc32("FUJBwWvHbtMwxH",14) == 3643245373) strcat(s, "s");
if (crc32("AKQzuMradfLJ",12) == 120455517) strcat(s, "t");
if (crc32("jyNeH",5) == 3758343814) strcat(s, "s");
if (crc32("WaRChf",6) == 506861155) strcat(s, "e");
if (crc32("gKvhTagYHgaFSv",14) == 3278835594) strcat(s, "m");
if (crc32("TbQPfyP",7) == 410546571) strcat(s, "a");
if (crc32("TmcSy",5) == 807601086) strcat(s, "t");
if (crc32("oXwNDzihhS",10) == 3226087852) strcat(s, "i");
if (crc32("uSGNTfDmLNphxWT",15) == 241658831) strcat(s, "c");
if (crc32("xAjYZjyfgPxkmvs",15) == 3786672654) strcat(s, "y");
if (crc32("SnQUOYRd",8) == 812335326) strcat(s, "a");
if (crc32("qmPLaQKvaLvmL",13) == 3789924420) strcat(s, "l");
if (crc32("JjLPcUcNPkTI",12) == 4250681737) strcat(s, "l");
if (crc32("yXmxgpfOGpDi",12) == 2938678809) strcat(s, "y");
    return s;
}

char *superexplicitly_adverbs() {
    char *s = calloc(16);
    if (crc32("SSccV",5) == 3865074582) strcat(s, "s");
if (crc32("BlkHVxohAMJzB",13) == 3659751150) strcat(s, "u");
if (crc32("ZatjB",5) == 1663292172) strcat(s, "p");
if (crc32("VlOkgyMW",8) == 3885536294) strcat(s, "e");
if (crc32("AUiymmWuGCMcr",13) == 3687346179) strcat(s, "t");
if (crc32("kezTL",5) == 3705916957) strcat(s, "r");
if (crc32("VZvfgPthyHtjlkB",15) == 2691467441) strcat(s, "e");
if (crc32("VZXuGZS",7) == 1286321600) strcat(s, "L");
if (crc32("RInEgfylUdsXAFo",15) == 1687239358) strcat(s, "x");
if (crc32("JPkvGLwT",8) == 308339848) strcat(s, "v");
if (crc32("XDkeQ",5) == 2589156924) strcat(s, "p");
if (crc32("VPkHE",5) == 2813816634) strcat(s, "Q");
if (crc32("UtKuXmRkspetw",13) == 2481623610) strcat(s, "l");
if (crc32("Elwzkdvrx",9) == 1060370304) strcat(s, "i");
if (crc32("xhlZDiBstmCJqM",14) == 23695577) strcat(s, "c");
if (crc32("zogsQjTjshwynH",14) == 3314550203) strcat(s, "q");
if (crc32("ZlacSUpLuc",10) == 3209800081) strcat(s, "i");
if (crc32("WeERK",5) == 4148047850) strcat(s, "o");
if (crc32("WykpkxzuftznDpZ",15) == 2668161082) strcat(s, "t");
if (crc32("gZbVwGoZLPHnu",13) == 2196579938) strcat(s, "l");
if (crc32("JYxqp",5) == 3132045535) strcat(s, "o");
if (crc32("GvbnBBPuRQmNz",13) == 2412389181) strcat(s, "y");
    return s;
}

char *indulgingly_adverbs() {
    char *s = calloc(12);
    if (crc32("KTKWoL",6) == 2703732701) strcat(s, "i");
if (crc32("zoWTv",5) == 407346250) strcat(s, "n");
if (crc32("wBtVDTFnon",10) == 2187814268) strcat(s, "d");
if (crc32("FqcFLWzKfRK",11) == 2847190769) strcat(s, "A");
if (crc32("kdWWAGAhmQcGdRy",15) == 1482496514) strcat(s, "u");
if (crc32("kinWULojqHtX",12) == 3879071953) strcat(s, "l");
if (crc32("cxFGsnXtAR",10) == 3566161686) strcat(s, "J");
if (crc32("MhIftKtjzVbS",12) == 2531612171) strcat(s, "g");
if (crc32("iDkSdEOAosoH",12) == 3813910039) strcat(s, "x");
if (crc32("LQluuBzwk",9) == 3012421736) strcat(s, "i");
if (crc32("OXSZSU",6) == 1974156758) strcat(s, "n");
if (crc32("qSocR",5) == 5967335) strcat(s, "y");
if (crc32("ufYJvyNVwj",10) == 2178640455) strcat(s, "g");
if (crc32("QxvcuS",6) == 3167619539) strcat(s, "d");
if (crc32("ZgAwemQZwNquk",13) == 4223096410) strcat(s, "l");
if (crc32("PjVKggcOQijVDDu",15) == 1274152189) strcat(s, "r");
if (crc32("uEWiPPmoIEgUZ",13) == 2959921819) strcat(s, "y");
    return s;
}

char *cursedly_adverbs() {
    char *s = calloc(9);
    if (crc32("grjBtDQBQIl",11) == 671103283) strcat(s, "v");
if (crc32("WqsqQQl",7) == 1548455460) strcat(s, "c");
if (crc32("tjdkyHcqPWZN",12) == 356508379) strcat(s, "u");
if (crc32("MsXoO",5) == 175965138) strcat(s, "f");
if (crc32("NHvlFaQVXDbZu",13) == 2063454683) strcat(s, "r");
if (crc32("xjWhlT",6) == 3184585630) strcat(s, "j");
if (crc32("jwiZZjYTwHk",11) == 362255810) strcat(s, "s");
if (crc32("kqqwKlgQYoZIjyh",15) == 639068325) strcat(s, "g");
if (crc32("vQJWkGsVJBDOcX",14) == 2782258519) strcat(s, "e");
if (crc32("gfYse",5) == 2849660482) strcat(s, "d");
if (crc32("MyvGi",5) == 2874970159) strcat(s, "l");
if (crc32("gZrbzCDldwma",12) == 3321980192) strcat(s, "u");
if (crc32("WNHFOiPDqEsGgZC",15) == 2287769360) strcat(s, "y");
    return s;
}

char *wagglingly_adverbs() {
    char *s = calloc(11);
    if (crc32("pLLVsoJKURWYBj",14) == 2642084486) strcat(s, "w");
if (crc32("iBEgffGS",8) == 316208874) strcat(s, "a");
if (crc32("qSeBnzp",7) == 4198109273) strcat(s, "g");
if (crc32("qvBxQjwWQecVa",13) == 3524207027) strcat(s, "C");
if (crc32("ldgMwMbLd",9) == 2330240447) strcat(s, "g");
if (crc32("oljAi",5) == 888977012) strcat(s, "l");
if (crc32("CQbToPmZKR",10) == 1229241192) strcat(s, "i");
if (crc32("dXSACFZYXUnE",12) == 3837291086) strcat(s, "q");
if (crc32("CUjfsBkZcdpEXK",14) == 153936921) strcat(s, "n");
if (crc32("BpZzKSURTT",10) == 4142180885) strcat(s, "o");
if (crc32("pdgcDnyxyXgnKv",14) == 1696028091) strcat(s, "g");
if (crc32("lXofWeKzszcxN",13) == 3273267051) strcat(s, "M");
if (crc32("gsFxZ",5) == 2364926292) strcat(s, "l");
if (crc32("bPNtGSFrMgMIWKQ",15) == 2225776978) strcat(s, "y");
    return s;
}

char *botanically_adverbs() {
    char *s = calloc(12);
    if (crc32("DhiAhdJddENfiJD",15) == 3266657303) strcat(s, "b");
if (crc32("RKAXmS",6) == 1826235060) strcat(s, "R");
if (crc32("QnWVFRO",7) == 1419543127) strcat(s, "o");
if (crc32("mmePlNp",7) == 3309358324) strcat(s, "X");
if (crc32("vapzqu",6) == 3975778716) strcat(s, "t");
if (crc32("gsAewWldCnFrsj",14) == 2692369055) strcat(s, "a");
if (crc32("CBQWpSuQXvRtC",13) == 4002558783) strcat(s, "n");
if (crc32("CMrRgRsiGPzdQ",13) == 964850128) strcat(s, "X");
if (crc32("hPyPgb",6) == 2667438061) strcat(s, "i");
if (crc32("jmkzWsjEr",9) == 3260966217) strcat(s, "c");
if (crc32("ahiAYzZPiznt",12) == 122502178) strcat(s, "W");
if (crc32("ZSLcxFLQFqY",11) == 2110235755) strcat(s, "a");
if (crc32("ourWnEOGrTebHG",14) == 2548914577) strcat(s, "c");
if (crc32("niDwSxh",7) == 4176501381) strcat(s, "l");
if (crc32("dHdcmMnZOwFoJFl",15) == 664698216) strcat(s, "F");
if (crc32("FGHDwGTVcU",10) == 93984677) strcat(s, "l");
if (crc32("OyoLOQOBKAWNa",13) == 847507616) strcat(s, "y");
    return s;
}

char *compellingly_adverbs() {
    char *s = calloc(13);
    if (crc32("LBJBFeHy",8) == 2775469063) strcat(s, "c");
if (crc32("wziVkXnWfVbNW",13) == 593008773) strcat(s, "o");
if (crc32("FlzOdxnxhknIAUg",15) == 3390564631) strcat(s, "m");
if (crc32("maJne",5) == 2679181167) strcat(s, "p");
if (crc32("SVmyZOMpufjZWs",14) == 3594891482) strcat(s, "w");
if (crc32("jLCukaerh",9) == 41817679) strcat(s, "e");
if (crc32("kjRsUAZQK",9) == 2956333277) strcat(s, "l");
if (crc32("jInAgCigvb",10) == 2880316292) strcat(s, "l");
if (crc32("OxvzIXljzmE",11) == 3272922310) strcat(s, "i");
if (crc32("fdLfMuVPNfnabvm",15) == 4124624256) strcat(s, "n");
if (crc32("qhewORmhvgf",11) == 2054793607) strcat(s, "G");
if (crc32("vgFoCteIVzxjndp",15) == 2847778184) strcat(s, "g");
if (crc32("qudldshFxvuXlk",14) == 3801128283) strcat(s, "a");
if (crc32("FbEppnJHrmmVBrf",15) == 3705588450) strcat(s, "l");
if (crc32("kagVIi",6) == 3098357149) strcat(s, "o");
if (crc32("QMWHdMLFYcsseoR",15) == 3736081381) strcat(s, "y");
    return s;
}

char *nondependably_adverbs() {
    char *s = calloc(14);
    if (crc32("ipaEQ",5) == 39119169) strcat(s, "P");
if (crc32("KcqQMf",6) == 1429479626) strcat(s, "n");
if (crc32("OEOGLIKkAHn",11) == 4292715605) strcat(s, "o");
if (crc32("nzwRhJWbk",9) == 2650966412) strcat(s, "n");
if (crc32("pEwxjA",6) == 2260224879) strcat(s, "K");
if (crc32("DdWLYcoTUFU",11) == 225348812) strcat(s, "d");
if (crc32("LTxAMW",6) == 1807783972) strcat(s, "e");
if (crc32("PJoaxUMVyCIE",12) == 1368843554) strcat(s, "p");
if (crc32("ahTtMDT",7) == 3349480632) strcat(s, "g");
if (crc32("svvqmzhOREvPQJw",15) == 3846530699) strcat(s, "e");
if (crc32("bIsNWG",6) == 390159234) strcat(s, "r");
if (crc32("fWQqKoxpFSYTYn",14) == 2231619425) strcat(s, "n");
if (crc32("pwOHUFMKLL",10) == 3149886323) strcat(s, "d");
if (crc32("ZtLGBO",6) == 2428420475) strcat(s, "a");
if (crc32("nfFUhbvrztMO",12) == 1723679400) strcat(s, "X");
if (crc32("JRZijIcA",8) == 886648629) strcat(s, "b");
if (crc32("kalYNdmj",8) == 1755301508) strcat(s, "h");
if (crc32("LZNKpjlyNLHEZ",13) == 2212546880) strcat(s, "l");
if (crc32("HyCSsHdbHsU",11) == 2473251703) strcat(s, "y");
    return s;
}

char *categorically_adverbs() {
    char *s = calloc(14);
    if (crc32("nBFAsZRPf",9) == 3243470298) strcat(s, "J");
if (crc32("KbxSGCYwNn",10) == 3028831336) strcat(s, "c");
if (crc32("kNbnBLMkTAFr",12) == 2142285849) strcat(s, "a");
if (crc32("knvQjIBbnNNQgY",14) == 2901046047) strcat(s, "t");
if (crc32("zaPOHvxjjCDPHSh",15) == 497132798) strcat(s, "e");
if (crc32("LdHguK",6) == 93586149) strcat(s, "g");
if (crc32("whEjQUdXxEQkwz",14) == 1148324451) strcat(s, "I");
if (crc32("FAkJjknVysBUi",13) == 198294132) strcat(s, "o");
if (crc32("KrcwemVsKW",10) == 1273417588) strcat(s, "r");
if (crc32("kLOaxqe",7) == 1684059648) strcat(s, "i");
if (crc32("FOmkN",5) == 2240058391) strcat(s, "c");
if (crc32("nnWPZmaal",9) == 2536312297) strcat(s, "a");
if (crc32("nBGJdueKRBZLY",13) == 1471449076) strcat(s, "f");
if (crc32("YUelmCXsmIGSA",13) == 981447518) strcat(s, "l");
if (crc32("wCjtYfOGyuXVe",13) == 2970161480) strcat(s, "l");
if (crc32("TYOWrpauWKB",11) == 3538143254) strcat(s, "y");
    return s;
}

char *posthypnotically_adverbs() {
    char *s = calloc(17);
    if (crc32("DGFSofTUGLU",11) == 2807705879) strcat(s, "p");
if (crc32("jJQBxwv",7) == 2885521858) strcat(s, "o");
if (crc32("KhvkYcTykmXgn",13) == 436804025) strcat(s, "T");
if (crc32("ziYqgF",6) == 3647783346) strcat(s, "s");
if (crc32("FCxplVq",7) == 466117969) strcat(s, "t");
if (crc32("wAQRxLgpPUVIR",13) == 410744694) strcat(s, "c");
if (crc32("LMdvwdZHTiyajuT",15) == 1300620420) strcat(s, "h");
if (crc32("kvEIKepJkn",10) == 2972445791) strcat(s, "b");
if (crc32("IuioXVBWgqXHXq",14) == 1024130353) strcat(s, "y");
if (crc32("gyZINeSORmhKDxw",15) == 697291804) strcat(s, "R");
if (crc32("VbwAAkGn",8) == 3958291040) strcat(s, "p");
if (crc32("lDSJOrLXmO",10) == 2164916201) strcat(s, "y");
if (crc32("DuFlUNrEktege",13) == 1224270553) strcat(s, "n");
if (crc32("FpHleNYcqnP",11) == 1951865728) strcat(s, "o");
if (crc32("iwzEJzBTed",10) == 1682293579) strcat(s, "t");
if (crc32("YWbGltCoHEAgyBl",15) == 4077849650) strcat(s, "e");
if (crc32("oBeSjQKNXN",10) == 3225374597) strcat(s, "i");
if (crc32("afTnzl",6) == 4092214625) strcat(s, "c");
if (crc32("MKBVkQ",6) == 947330259) strcat(s, "n");
if (crc32("ArOdGLl",7) == 973083786) strcat(s, "a");
if (crc32("lhJogQHS",8) == 4006866935) strcat(s, "l");
if (crc32("CpfGgz",6) == 3408255250) strcat(s, "I");
if (crc32("bHvaAcACYDsqhPi",15) == 585404850) strcat(s, "l");
if (crc32("ywTgemYbgfWG",12) == 1056013927) strcat(s, "t");
if (crc32("ZAmmESliEsP",11) == 4190223843) strcat(s, "y");
    return s;
}

char *culinarily_adverbs() {
    char *s = calloc(11);
    if (crc32("FnExukhWTHKngto",15) == 4268437874) strcat(s, "K");
if (crc32("ZTRlUCIz",8) == 1958637076) strcat(s, "c");
if (crc32("xFDkTEXsKrqSCzB",15) == 4196068300) strcat(s, "u");
if (crc32("hJeQNSYuAcka",12) == 2909473898) strcat(s, "B");
if (crc32("VFrFhiSsfOm",11) == 3232558737) strcat(s, "l");
if (crc32("PbYocUpZ",8) == 209156682) strcat(s, "V");
if (crc32("uNXLoFimDDOx",12) == 4227099461) strcat(s, "i");
if (crc32("uJtzVjH",7) == 168499074) strcat(s, "n");
if (crc32("GpahUrTXJVdov",13) == 2980403224) strcat(s, "a");
if (crc32("lAcCmkVijm",10) == 803385034) strcat(s, "d");
if (crc32("fIinZMfCCRpx",12) == 525395453) strcat(s, "r");
if (crc32("HXlLZYNGNF",10) == 3301954299) strcat(s, "i");
if (crc32("tuRphR",6) == 234356677) strcat(s, "l");
if (crc32("CRRqmtJlqRJlZ",13) == 1713140665) strcat(s, "y");
    return s;
}

char *unpatristically_adverbs() {
    char *s = calloc(16);
    if (crc32("qOgkUekY",8) == 1794744110) strcat(s, "u");
if (crc32("CqcWCwcgnwQnHQ",14) == 407553864) strcat(s, "n");
if (crc32("gBbxldGVnN",10) == 3523751912) strcat(s, "a");
if (crc32("bmIXVjxDXnlzAgE",15) == 2442603924) strcat(s, "p");
if (crc32("WsUeblaRqYWTo",13) == 1894908089) strcat(s, "N");
if (crc32("fywFpXfhvZnR",12) == 438911937) strcat(s, "a");
if (crc32("TpoHIRBGZYSZ",12) == 1605926046) strcat(s, "p");
if (crc32("pYYBX",5) == 1298642564) strcat(s, "t");
if (crc32("hNvsG",5) == 2826767995) strcat(s, "r");
if (crc32("UvrIVBUtvRvk",12) == 2568860532) strcat(s, "B");
if (crc32("lkjKGGDLlQsK",12) == 3990240473) strcat(s, "i");
if (crc32("WHeWwvEF",8) == 722092216) strcat(s, "s");
if (crc32("VAEtswbkipeTnk",14) == 395673859) strcat(s, "X");
if (crc32("LnDyCCKFHhkT",12) == 368665363) strcat(s, "t");
if (crc32("WVcHhdJgrMqH",12) == 4074167001) strcat(s, "i");
if (crc32("rAQuNSz",7) == 3297094302) strcat(s, "y");
if (crc32("DCGImqMwiICUVJu",15) == 1527407524) strcat(s, "c");
if (crc32("gXxFRrDJThIeEN",14) == 492177336) strcat(s, "L");
if (crc32("stXcpwBRocAOLP",14) == 993601344) strcat(s, "a");
if (crc32("rZiGotCsQupT",12) == 2601305500) strcat(s, "m");
if (crc32("MQSDlk",6) == 3128182593) strcat(s, "l");
if (crc32("mwmIFjhwD",9) == 4221949691) strcat(s, "l");
if (crc32("CiJFgaWQTHGRMN",14) == 1629158328) strcat(s, "y");
    return s;
}

char *untechnically_adverbs() {
    char *s = calloc(14);
    if (crc32("BixivaJk",8) == 3025193047) strcat(s, "u");
if (crc32("FQpPRRBhHJj",11) == 1459407155) strcat(s, "n");
if (crc32("qxFMr",5) == 600860219) strcat(s, "t");
if (crc32("izFrYHPLtuGq",12) == 487550305) strcat(s, "e");
if (crc32("KQTiPwlNkxKAE",13) == 1770654930) strcat(s, "c");
if (crc32("ERHjlsVrT",9) == 3397489043) strcat(s, "J");
if (crc32("zZwgCsrT",8) == 1278991791) strcat(s, "h");
if (crc32("SholVt",6) == 194739600) strcat(s, "n");
if (crc32("WBKChAJiAK",10) == 1182902408) strcat(s, "P");
if (crc32("DmZSsGIb",8) == 2120925406) strcat(s, "i");
if (crc32("RZWPpCgafABfE",13) == 4053929296) strcat(s, "c");
if (crc32("THDJWEkvaAjE",12) == 3368254832) strcat(s, "D");
if (crc32("SyFEKeLmra",10) == 2522105561) strcat(s, "a");
if (crc32("bHizZQdVEkrB",12) == 1528630397) strcat(s, "X");
if (crc32("cZqbZlaKbqYt",12) == 1231071324) strcat(s, "l");
if (crc32("gcVlfLhDt",9) == 1735794711) strcat(s, "m");
if (crc32("atOhrlBSgogfX",13) == 798659227) strcat(s, "l");
if (crc32("oPSUTCz",7) == 1867359110) strcat(s, "y");
    return s;
}

char *congruently_adverbs() {
    char *s = calloc(12);
    if (crc32("QhOXB",5) == 2897605527) strcat(s, "c");
if (crc32("ZKJChHSUow",10) == 3475641267) strcat(s, "o");
if (crc32("zHRfiSIteQxO",12) == 188586287) strcat(s, "X");
if (crc32("hXeXExPVwurtjl",14) == 121437660) strcat(s, "n");
if (crc32("RnKFgS",6) == 911872531) strcat(s, "g");
if (crc32("NpzYDLWA",8) == 3006291419) strcat(s, "r");
if (crc32("gInPvrj",7) == 1565838319) strcat(s, "W");
if (crc32("XPeSZcExjnTlnzu",15) == 3022870804) strcat(s, "u");
if (crc32("ZcoLpXNySkcVNDS",15) == 3909204735) strcat(s, "g");
if (crc32("naSyAF",6) == 3542874118) strcat(s, "e");
if (crc32("vnOilroZON",10) == 2692905304) strcat(s, "l");
if (crc32("aGbKg",5) == 4022055967) strcat(s, "n");
if (crc32("wsKnZDRFXfd",11) == 3427898613) strcat(s, "t");
if (crc32("SOCVyxDsgtB",11) == 1163737379) strcat(s, "l");
if (crc32("RTjvAxAbkADkHb",14) == 587743258) strcat(s, "D");
if (crc32("TuYMJG",6) == 998681082) strcat(s, "y");
    return s;
}

char *unhorizontally_adverbs() {
    char *s = calloc(15);
    if (crc32("WfMcKMMThgSXNPF",15) == 4027047591) strcat(s, "u");
if (crc32("voGvzexezJtq",12) == 2281006468) strcat(s, "r");
if (crc32("bRHnZOPwstXF",12) == 1892970446) strcat(s, "n");
if (crc32("IvgUwLBCYUvH",12) == 3873337991) strcat(s, "p");
if (crc32("rzVdAlzAIRLZ",12) == 586226658) strcat(s, "h");
if (crc32("MsluWFlyULA",11) == 1998905501) strcat(s, "o");
if (crc32("YVwMCwbnkk",10) == 3954741323) strcat(s, "R");
if (crc32("rgtfr",5) == 1033213877) strcat(s, "r");
if (crc32("PFQzoPdKU",9) == 3280989537) strcat(s, "i");
if (crc32("rgnnixmA",8) == 486439268) strcat(s, "z");
if (crc32("wbJVX",5) == 3903053640) strcat(s, "o");
if (crc32("gVEKXimXWB",10) == 1153205974) strcat(s, "n");
if (crc32("dDfeqxNd",8) == 12034809) strcat(s, "Q");
if (crc32("wXimzDUdf",9) == 913307362) strcat(s, "t");
if (crc32("dCqRdJcC",8) == 2927696911) strcat(s, "a");
if (crc32("pMtqAKQQPCnpbB",14) == 3150448487) strcat(s, "l");
if (crc32("GVdmrHZqV",9) == 4047246831) strcat(s, "f");
if (crc32("uYUqr",5) == 2739760246) strcat(s, "l");
if (crc32("AkyDUWRVQGlpG",13) == 4278096500) strcat(s, "W");
if (crc32("BKEkN",5) == 3375936216) strcat(s, "y");
    return s;
}

char *superdifficultly_adverbs() {
    char *s = calloc(17);
    if (crc32("hFkkNCHjaZ",10) == 1320904480) strcat(s, "s");
if (crc32("adSvpaYfrsar",12) == 280722781) strcat(s, "u");
if (crc32("ygkuRC",6) == 2034797763) strcat(s, "J");
if (crc32("bXZfGH",6) == 3544761292) strcat(s, "p");
if (crc32("RtCuxSNbpsLd",12) == 3127180375) strcat(s, "e");
if (crc32("FZfEPcDZ",8) == 820168857) strcat(s, "S");
if (crc32("umHvxRqAa",9) == 2467214166) strcat(s, "r");
if (crc32("tjPqW",5) == 830211109) strcat(s, "d");
if (crc32("SzEPMAGF",8) == 2847189581) strcat(s, "i");
if (crc32("ihRkOxI",7) == 2685299372) strcat(s, "P");
if (crc32("UaEeesIpITI",11) == 2487031537) strcat(s, "f");
if (crc32("auyrTkR",7) == 2307893078) strcat(s, "b");
if (crc32("SvYPBoxofxK",11) == 809021965) strcat(s, "f");
if (crc32("cUfDDArTpi",10) == 4173614514) strcat(s, "O");
if (crc32("MPslW",5) == 3351007922) strcat(s, "i");
if (crc32("WdqCNTsxtyMfWwR",15) == 4080218840) strcat(s, "c");
if (crc32("XkgDdsCd",8) == 102654692) strcat(s, "I");
if (crc32("zipEhLpfuzft",12) == 12594068) strcat(s, "u");
if (crc32("fpUszAAcv",9) == 4009668836) strcat(s, "t");
if (crc32("ZoaWnQIjLKxrh",13) == 212870175) strcat(s, "l");
if (crc32("PqvxDUwNDxfh",12) == 2074653503) strcat(s, "Y");
if (crc32("miWnAgvWfOc",11) == 916614334) strcat(s, "t");
if (crc32("wnRiW",5) == 492283307) strcat(s, "N");
if (crc32("saxWf",5) == 4026780530) strcat(s, "l");
if (crc32("WKsuuiQhSjK",11) == 191559341) strcat(s, "y");
    return s;
}

char *photomechanically_adverbs() {
    char *s = calloc(18);
    if (crc32("BcEaPeoBacOwZ",13) == 3701728653) strcat(s, "p");
if (crc32("DzzpmmqrtgvRc",13) == 3027144887) strcat(s, "s");
if (crc32("JayRsBm",7) == 2357365322) strcat(s, "h");
if (crc32("YidiOtLXuu",10) == 4190742815) strcat(s, "C");
if (crc32("qwFOkedAMOfEJ",13) == 2684449839) strcat(s, "o");
if (crc32("YVYCfB",6) == 253371444) strcat(s, "D");
if (crc32("dIlDqikpcHWdPU",14) == 3823427193) strcat(s, "t");
if (crc32("AjqcUaVnrit",11) == 1777724149) strcat(s, "o");
if (crc32("pnKdnDbptGgq",12) == 2892819964) strcat(s, "D");
if (crc32("DWoLopwqEOyJCo",14) == 2941469731) strcat(s, "m");
if (crc32("ziIYpSfMk",9) == 3075652079) strcat(s, "B");
if (crc32("kTMcKNBQyUCV",12) == 3873761143) strcat(s, "e");
if (crc32("JOEXSBjWqVglsD",14) == 1389963135) strcat(s, "c");
if (crc32("xScKwzXU",8) == 1862579534) strcat(s, "h");
if (crc32("ujtyeNAlldOmGp",14) == 3759725677) strcat(s, "e");
if (crc32("mENzsZFmV",9) == 2824600535) strcat(s, "a");
if (crc32("xfnAJtsLKYclU",13) == 2624862888) strcat(s, "n");
if (crc32("YgTdlGQDD",9) == 2152792733) strcat(s, "F");
if (crc32("YRFWcGfLdJFiR",13) == 1057115352) strcat(s, "i");
if (crc32("XvKaFJyuleSwNs",14) == 3675289074) strcat(s, "c");
if (crc32("PuuHgUM",7) == 3089865241) strcat(s, "R");
if (crc32("tSjrGzhGgkD",11) == 1859379993) strcat(s, "a");
if (crc32("IogTqVbkz",9) == 2329965005) strcat(s, "p");
if (crc32("TdfLBsSGCvrjV",13) == 407344448) strcat(s, "l");
if (crc32("eTEwyeg",7) == 628785415) strcat(s, "l");
if (crc32("DMLpMGeZQhxPVe",14) == 197364890) strcat(s, "y");
    return s;
}

char *imperturbably_adverbs() {
    char *s = calloc(14);
    if (crc32("uSSfMH",6) == 1034708990) strcat(s, "i");
if (crc32("HwLAnCwMxYuZTcJ",15) == 1494690387) strcat(s, "w");
if (crc32("AnuWydiurdSFNQ",14) == 2603782811) strcat(s, "m");
if (crc32("uCNmPJwvbmya",12) == 2572210344) strcat(s, "S");
if (crc32("caQyFj",6) == 3089488247) strcat(s, "p");
if (crc32("pCPHFffzQlZpB",13) == 1547181395) strcat(s, "e");
if (crc32("SQIWZZ",6) == 650922639) strcat(s, "R");
if (crc32("NUMIUXBJtQNkWu",14) == 782066470) strcat(s, "r");
if (crc32("AIOLUGJRG",9) == 954455655) strcat(s, "t");
if (crc32("PjkHuNp",7) == 3411121527) strcat(s, "u");
if (crc32("xMpvcPrNRwv",11) == 197498921) strcat(s, "O");
if (crc32("EvXNyCVtUuwVSye",15) == 1293957137) strcat(s, "r");
if (crc32("elkXczol",8) == 1299563357) strcat(s, "b");
if (crc32("eaNOCJaWaTiMFOb",15) == 2267389525) strcat(s, "b");
if (crc32("BJDhIkTM",8) == 2894431565) strcat(s, "W");
if (crc32("WnEvtg",6) == 3799557156) strcat(s, "a");
if (crc32("abxZosiciqZsaPk",15) == 4217326839) strcat(s, "b");
if (crc32("oUYqIPMdCdANohJ",15) == 468533533) strcat(s, "Q");
if (crc32("EQgEpGDPoaiFhtj",15) == 789332985) strcat(s, "l");
if (crc32("uCdYEYEKKAIMWr",14) == 3274138222) strcat(s, "y");
    return s;
}

char *nondramatically_adverbs() {
    char *s = calloc(16);
    if (crc32("eAyAR",5) == 3887903548) strcat(s, "I");
if (crc32("HzvqpskJE",9) == 972020336) strcat(s, "n");
if (crc32("vXWHdlajpYAyLI",14) == 3875494550) strcat(s, "W");
if (crc32("FUywiH",6) == 327254246) strcat(s, "o");
if (crc32("OtefLQkTLTDBiK",14) == 2293224909) strcat(s, "n");
if (crc32("CorYackNGfMl",12) == 957651764) strcat(s, "M");
if (crc32("vAGBneWr",8) == 52124214) strcat(s, "d");
if (crc32("kzyxJxKs",8) == 3168254970) strcat(s, "v");
if (crc32("WyHVhhrNN",9) == 288174876) strcat(s, "r");
if (crc32("vvpSufc",7) == 1524875848) strcat(s, "a");
if (crc32("rdCmlZMRCnxwHSY",15) == 320598948) strcat(s, "m");
if (crc32("hUkLXBsWmODsF",13) == 687689955) strcat(s, "a");
if (crc32("CHLrIkUUdwYnap",14) == 1390092158) strcat(s, "G");
if (crc32("eLLJbDaQVqfi",12) == 2155983620) strcat(s, "t");
if (crc32("BUMIKs",6) == 3474311832) strcat(s, "i");
if (crc32("BYHZkj",6) == 3535029984) strcat(s, "c");
if (crc32("qJZanvOpHtmtLhx",15) == 1532447797) strcat(s, "X");
if (crc32("kjWkVPtfYTdVCC",14) == 354847942) strcat(s, "a");
if (crc32("iFPbQMvwsMOaYN",14) == 3184184792) strcat(s, "l");
if (crc32("wBhcJ",5) == 2923973814) strcat(s, "n");
if (crc32("MbOFJxcVViy",11) == 2411300345) strcat(s, "l");
if (crc32("jPuLbc",6) == 425149851) strcat(s, "b");
if (crc32("kmexCDiWtcNko",13) == 3573679022) strcat(s, "y");
    return s;
}

char *severally_adverbs() {
    char *s = calloc(10);
    if (crc32("pJqxfKsgqAEgo",13) == 1088669356) strcat(s, "s");
if (crc32("ItcKu",5) == 250584298) strcat(s, "e");
if (crc32("JtKlewWXaNXX",12) == 1964504161) strcat(s, "v");
if (crc32("ryGMcp",6) == 1673443480) strcat(s, "e");
if (crc32("UGdqfJLTidzO",12) == 1713349276) strcat(s, "r");
if (crc32("OIXSFgJPYoYsP",13) == 1763466153) strcat(s, "a");
if (crc32("YhCJvopLDnX",11) == 3875472293) strcat(s, "a");
if (crc32("TrVBsPFIeCmQy",13) == 2247303637) strcat(s, "l");
if (crc32("bZYkeD",6) == 501327386) strcat(s, "l");
if (crc32("NtAAWVRi",8) == 1653461133) strcat(s, "y");
    return s;
}

char *quasicommandingly_adverbs() {
    char *s = calloc(18);
    if (crc32("aILFZdqzS",9) == 1963952792) strcat(s, "q");
if (crc32("aajZFRsBY",9) == 652520698) strcat(s, "s");
if (crc32("RXAtZfe",7) == 660675032) strcat(s, "u");
if (crc32("VQEgbCfui",9) == 1109715352) strcat(s, "k");
if (crc32("oDNZnrRdoaumIzE",15) == 441044881) strcat(s, "a");
if (crc32("vKvjoKOjY",9) == 2959536767) strcat(s, "H");
if (crc32("eOVpBOrfwTr",11) == 151670747) strcat(s, "s");
if (crc32("xNmtjd",6) == 1905300435) strcat(s, "U");
if (crc32("CUWFZbTT",8) == 685225188) strcat(s, "i");
if (crc32("ImMtBOIRDjcTyod",15) == 2038108149) strcat(s, "c");
if (crc32("ejjlABpdvciH",12) == 4252286113) strcat(s, "w");
if (crc32("VjKUSMMVbhpELJU",15) == 684434126) strcat(s, "o");
if (crc32("ROvlVuANGf",10) == 104175391) strcat(s, "w");
if (crc32("aqHnHSc",7) == 4161615870) strcat(s, "m");
if (crc32("KgYTcotSkV",10) == 998580706) strcat(s, "m");
if (crc32("NmGOmfsgpyIDbW",14) == 3087544720) strcat(s, "a");
if (crc32("isZKLuDb",8) == 1057022463) strcat(s, "a");
if (crc32("HrVMcEpdpa",10) == 692022044) strcat(s, "n");
if (crc32("knfqKvWRKh",10) == 2032587150) strcat(s, "z");
if (crc32("BsYALIK",7) == 1825590867) strcat(s, "d");
if (crc32("GUiwoBvs",8) == 3931503462) strcat(s, "U");
if (crc32("kYqWDlGGIG",10) == 3773443939) strcat(s, "i");
if (crc32("ZvPVVwhMbLoU",12) == 3973828114) strcat(s, "n");
if (crc32("mccvk",5) == 1736904661) strcat(s, "g");
if (crc32("mVRDcTtxeJz",11) == 3464289720) strcat(s, "l");
if (crc32("RipVdkisGP",10) == 4222855495) strcat(s, "y");
    return s;
}

char *indefectibly_adverbs() {
    char *s = calloc(13);
    if (crc32("PTCFBqzz",8) == 3100618671) strcat(s, "i");
if (crc32("nMBCJkQRgMmbkn",14) == 3640890117) strcat(s, "Y");
if (crc32("SDetALfFbUxLM",13) == 3249406227) strcat(s, "n");
if (crc32("tuFXmDdTpFeiS",13) == 510490079) strcat(s, "W");
if (crc32("dNCnJdefbhUs",12) == 1700250420) strcat(s, "d");
if (crc32("nUqqKodpfDdhp",13) == 1860475574) strcat(s, "C");
if (crc32("SXRUTFdTDcV",11) == 4235713587) strcat(s, "e");
if (crc32("PqfSxeBIEzzKO",13) == 1140432182) strcat(s, "f");
if (crc32("jmXGzeFkIXfwx",13) == 2733658930) strcat(s, "e");
if (crc32("ntAmTiRXdpTxQ",13) == 3436044039) strcat(s, "c");
if (crc32("BjbtgkeQ",8) == 1710248102) strcat(s, "N");
if (crc32("OzjZDv",6) == 3832349565) strcat(s, "t");
if (crc32("Eyehrd",6) == 323324768) strcat(s, "f");
if (crc32("AVQGCpLXcjtl",12) == 4097471885) strcat(s, "i");
if (crc32("cUIeYO",6) == 2881701133) strcat(s, "N");
if (crc32("hSgcvQBHdZ",10) == 396819643) strcat(s, "b");
if (crc32("WlrloYJHpnaVent",15) == 3537030005) strcat(s, "l");
if (crc32("PGKmWsAIH",9) == 2654496155) strcat(s, "y");
    return s;
}

char *latently_adverbs() {
    char *s = calloc(9);
    if (crc32("mzWqeN",6) == 1020101440) strcat(s, "l");
if (crc32("LNQXXkjK",8) == 4105322766) strcat(s, "a");
if (crc32("AoRNaeQxqF",10) == 11364861) strcat(s, "t");
if (crc32("NYAqjnpzsdRERV",14) == 1445947003) strcat(s, "F");
if (crc32("JeoQi",5) == 215779632) strcat(s, "e");
if (crc32("Fgdeq",5) == 3342215418) strcat(s, "n");
if (crc32("hghWJxsvSi",10) == 397140567) strcat(s, "t");
if (crc32("iKkKfBiheS",10) == 1336810923) strcat(s, "l");
if (crc32("qbBygMzRXHkuG",13) == 57838393) strcat(s, "y");
    return s;
}

char *frictionlessly_adverbs() {
    char *s = calloc(15);
    if (crc32("FohaOgKFzpCbaI",14) == 413610618) strcat(s, "f");
if (crc32("VeWFvGtwMoX",11) == 2907389880) strcat(s, "r");
if (crc32("atjulyT",7) == 2085326252) strcat(s, "i");
if (crc32("nbOIrEYh",8) == 4034365432) strcat(s, "h");
if (crc32("bBxYukNIpcU",11) == 620676205) strcat(s, "c");
if (crc32("LHlDmdF",7) == 782497072) strcat(s, "p");
if (crc32("AsXIYy",6) == 4175846642) strcat(s, "t");
if (crc32("lalvMGVI",8) == 961146817) strcat(s, "i");
if (crc32("VqrAaLvIc",9) == 3903114403) strcat(s, "o");
if (crc32("meFwlffG",8) == 2198092756) strcat(s, "n");
if (crc32("AWFAd",5) == 1163028074) strcat(s, "e");
if (crc32("yfHDRSDZL",9) == 2623937254) strcat(s, "l");
if (crc32("ZsTATpbBPrwQ",12) == 1478957044) strcat(s, "m");
if (crc32("qyzdhKX",7) == 3431011650) strcat(s, "e");
if (crc32("pIYKNRUW",8) == 980678306) strcat(s, "s");
if (crc32("kcSHlu",6) == 1131777675) strcat(s, "s");
if (crc32("otMfdppBOBo",11) == 2746357285) strcat(s, "Y");
if (crc32("jGKOusYoZbNcqeF",15) == 1440430839) strcat(s, "l");
if (crc32("GNLSlHfsl",9) == 1735562657) strcat(s, "y");
    return s;
}

char *preexclusively_adverbs() {
    char *s = calloc(15);
    if (crc32("fAvaauoAvOk",11) == 2390712428) strcat(s, "p");
if (crc32("rkVPNxOhvfGfo",13) == 1772264046) strcat(s, "r");
if (crc32("tsFUezgGPkeDqe",14) == 2196448202) strcat(s, "n");
if (crc32("YZrfCacsRN",10) == 213326516) strcat(s, "e");
if (crc32("nRnPute",7) == 1800065198) strcat(s, "r");
if (crc32("FqddoGldT",9) == 4129051525) strcat(s, "e");
if (crc32("LDsdWbyuvw",10) == 444725653) strcat(s, "E");
if (crc32("BmzWmwuBfEQLOE",14) == 359418425) strcat(s, "x");
if (crc32("ShqupWyPjdyx",12) == 258590901) strcat(s, "s");
if (crc32("SgcCG",5) == 1713188912) strcat(s, "c");
if (crc32("QayrHqwJKSdy",12) == 2974049400) strcat(s, "f");
if (crc32("hdOvHMNzbJM",11) == 1547909066) strcat(s, "l");
if (crc32("AokDdLqzrsaEAR",14) == 150669676) strcat(s, "O");
if (crc32("wTBPoIkWmKF",11) == 2291086366) strcat(s, "u");
if (crc32("IRuenXlbxjDKHYq",15) == 2677142196) strcat(s, "s");
if (crc32("VrgQBCUgjiTSQ",13) == 1212891128) strcat(s, "w");
if (crc32("EGvTmXWAqg",10) == 3795217345) strcat(s, "i");
if (crc32("vOfmBLWXqx",10) == 1712272099) strcat(s, "v");
if (crc32("SFUyPmmozKnc",12) == 1245172564) strcat(s, "e");
if (crc32("xFBSvkOTSEeBvsU",15) == 3389371162) strcat(s, "o");
if (crc32("vWtTmb",6) == 445511837) strcat(s, "l");
if (crc32("rhEnmOHHykcw",12) == 362808564) strcat(s, "y");
    return s;
}

char *halfseriously_adverbs() {
    char *s = calloc(14);
    if (crc32("pBeVdUPVaNcyJJ",14) == 2801109003) strcat(s, "p");
if (crc32("eSBowrW",7) == 909544431) strcat(s, "h");
if (crc32("ZULkzcsZ",8) == 2280578402) strcat(s, "a");
if (crc32("MsnodZyMdxF",11) == 2392327712) strcat(s, "l");
if (crc32("CfOfMkGGteC",11) == 3906314759) strcat(s, "P");
if (crc32("yoOBcSD",7) == 1547064896) strcat(s, "f");
if (crc32("zLPIKJAGMelnpC",14) == 126918567) strcat(s, "s");
if (crc32("eVvZdJsEjvVFNS",14) == 3115318801) strcat(s, "i");
if (crc32("CSzNX",5) == 1390748419) strcat(s, "e");
if (crc32("FOZYkPz",7) == 3141771323) strcat(s, "Z");
if (crc32("cbGkapqJsKRkiB",14) == 2640306444) strcat(s, "r");
if (crc32("VLJjtyR",7) == 2007363286) strcat(s, "D");
if (crc32("DwUflTiKnAHs",12) == 3840308580) strcat(s, "i");
if (crc32("UYnyrvWgpykzYQw",15) == 468421835) strcat(s, "o");
if (crc32("hMrofvneLxWg",12) == 3965354394) strcat(s, "J");
if (crc32("lOJZcxkJVwR",11) == 468460947) strcat(s, "u");
if (crc32("RVEkiGdOs",9) == 1043744592) strcat(s, "s");
if (crc32("MjTtje",6) == 3808824869) strcat(s, "A");
if (crc32("SSuGjI",6) == 4249739027) strcat(s, "l");
if (crc32("WDTPESHQHslTt",13) == 528122400) strcat(s, "y");
    return s;
}

char *nonjuridically_adverbs() {
    char *s = calloc(15);
    if (crc32("QXPDHqsKf",9) == 3893647614) strcat(s, "n");
if (crc32("xiBeLdtAtMWdz",13) == 2307294774) strcat(s, "Z");
if (crc32("kVkfwTAflPEDoiQ",15) == 757799002) strcat(s, "o");
if (crc32("sjUmNCTygwD",11) == 407958666) strcat(s, "f");
if (crc32("braWDBWpBS",10) == 2516717989) strcat(s, "n");
if (crc32("JWJPfbIc",8) == 2124303850) strcat(s, "s");
if (crc32("iHLhnVZVgM",10) == 111417915) strcat(s, "j");
if (crc32("TDwsXcuwKNBs",12) == 3998269649) strcat(s, "u");
if (crc32("hZAZMKAolxhxHGF",15) == 788795974) strcat(s, "B");
if (crc32("LGSJEFBDdWdc",12) == 159947684) strcat(s, "r");
if (crc32("CvmLOl",6) == 2361169283) strcat(s, "O");
if (crc32("EURCiRr",7) == 1844357365) strcat(s, "i");
if (crc32("nrQfQdc",7) == 2741358702) strcat(s, "d");
if (crc32("RkwhvljfMMhFMuU",15) == 1767464159) strcat(s, "i");
if (crc32("hqZCqkryXeh",11) == 2507250894) strcat(s, "k");
if (crc32("TLfTGERvsiqhI",13) == 1178867506) strcat(s, "c");
if (crc32("yPxfbEyPO",9) == 3017889840) strcat(s, "c");
if (crc32("wCRyw",5) == 1540743407) strcat(s, "a");
if (crc32("zqxIDssIniel",12) == 3946337877) strcat(s, "q");
if (crc32("tkruJr",6) == 3892501787) strcat(s, "l");
if (crc32("UImxhNlixi",10) == 1287179094) strcat(s, "P");
if (crc32("XEHFxAulvXBVbIR",15) == 794681688) strcat(s, "l");
if (crc32("yFakw",5) == 2380432806) strcat(s, "y");
    return s;
}

char *perennially_adverbs() {
    char *s = calloc(12);
    if (crc32("lRQzRlFYSVVvUKe",15) == 1966819171) strcat(s, "p");
if (crc32("iqxmZJ",6) == 3276255126) strcat(s, "u");
if (crc32("ARdoku",6) == 1723613015) strcat(s, "e");
if (crc32("SwSjBBilVZkt",12) == 3917391581) strcat(s, "r");
if (crc32("uBmeYfUiLSuMB",13) == 2241780905) strcat(s, "e");
if (crc32("IuzZHT",6) == 2020996976) strcat(s, "s");
if (crc32("dQpqkr",6) == 567937555) strcat(s, "n");
if (crc32("KOOnq",5) == 3460078827) strcat(s, "F");
if (crc32("PZYKW",5) == 3748565174) strcat(s, "n");
if (crc32("hzjjmPaEozaZB",13) == 3848970635) strcat(s, "i");
if (crc32("VkPmAsZb",8) == 1228656912) strcat(s, "k");
if (crc32("LDHgbUuDLvF",11) == 1704247183) strcat(s, "a");
if (crc32("nXaSG",5) == 3735184079) strcat(s, "l");
if (crc32("PXqLJGbvCu",10) == 238918687) strcat(s, "l");
if (crc32("PrBylRgzgu",10) == 1579310176) strcat(s, "y");
    return s;
}

char *decreasingly_adverbs() {
    char *s = calloc(13);
    if (crc32("PjcHy",5) == 4047656541) strcat(s, "d");
if (crc32("sDagVQwbuIdlFp",14) == 4266992231) strcat(s, "M");
if (crc32("IzefBU",6) == 3004906038) strcat(s, "e");
if (crc32("GuyiymxiGBNZn",13) == 2707618201) strcat(s, "n");
if (crc32("kcoUgq",6) == 166716515) strcat(s, "c");
if (crc32("CqBVZSdyfHMDv",13) == 4196022165) strcat(s, "o");
if (crc32("kudwwfZROtyYBW",14) == 2999881347) strcat(s, "r");
if (crc32("qTrvkPDaBiptM",13) == 1378473979) strcat(s, "o");
if (crc32("UzbFcQ",6) == 3915863925) strcat(s, "e");
if (crc32("FccPJFKCTJg",11) == 1919884097) strcat(s, "a");
if (crc32("joocVeiemMyZM",13) == 1585684272) strcat(s, "K");
if (crc32("szvYbPn",7) == 1897947245) strcat(s, "s");
if (crc32("epvkCAeKWgQVK",13) == 4112013180) strcat(s, "i");
if (crc32("VTAHEAvZH",9) == 3972966237) strcat(s, "n");
if (crc32("lTHXP",5) == 3104812916) strcat(s, "g");
if (crc32("qvtOaGa",7) == 364558697) strcat(s, "q");
if (crc32("LjFEgPKKXhkLv",13) == 3039205971) strcat(s, "l");
if (crc32("CLAzMWEjQvXC",12) == 597872546) strcat(s, "Q");
if (crc32("ROuGTJdCDtJ",11) == 2332768218) strcat(s, "y");
    return s;
}

char *quasimagically_adverbs() {
    char *s = calloc(15);
    if (crc32("PqClTKn",7) == 1460515856) strcat(s, "F");
if (crc32("FHYnZk",6) == 1849225302) strcat(s, "q");
if (crc32("eUWnIZhyUjCiZ",13) == 2907039362) strcat(s, "a");
if (crc32("qyNrX",5) == 370848524) strcat(s, "u");
if (crc32("XsAXYCBXVCznso",14) == 681620101) strcat(s, "a");
if (crc32("RETMXSjWBdcsJqA",15) == 4173516474) strcat(s, "s");
if (crc32("NKJjdpblGbWJ",12) == 3404339487) strcat(s, "A");
if (crc32("CCUGfMNIaOhgIo",14) == 4288192065) strcat(s, "i");
if (crc32("TwJdmS",6) == 2868200343) strcat(s, "I");
if (crc32("smQQbkbd",8) == 2810506811) strcat(s, "m");
if (crc32("zISpKQHZC",9) == 3007395017) strcat(s, "e");
if (crc32("HMPREiVGFFrPtg",14) == 3830996903) strcat(s, "a");
if (crc32("TtQCVtNU",8) == 3163388068) strcat(s, "g");
if (crc32("fDJyjBLLegsWYa",14) == 2114828085) strcat(s, "i");
if (crc32("LoosdxAyWT",10) == 3622947454) strcat(s, "l");
if (crc32("UlRjggqoizF",11) == 1162090274) strcat(s, "c");
if (crc32("sHiWvuo",7) == 3190184566) strcat(s, "a");
if (crc32("wibxfY",6) == 3642403575) strcat(s, "l");
if (crc32("fTzonbGAReVvy",13) == 2535441990) strcat(s, "l");
if (crc32("zPamskw",7) == 1422155982) strcat(s, "C");
if (crc32("fqnBPaVu",8) == 1742870813) strcat(s, "y");
    return s;
}

char *overtimidly_adverbs() {
    char *s = calloc(12);
    if (crc32("YjwTZkxAmAl",11) == 166347686) strcat(s, "o");
if (crc32("JvnsqynVr",9) == 4178312046) strcat(s, "H");
if (crc32("aNKmfAcoLDYrARj",15) == 1481933149) strcat(s, "v");
if (crc32("tuEDXbxZvAbbOp",14) == 784658132) strcat(s, "e");
if (crc32("JTOdpVFLjMqNjlz",15) == 2133580610) strcat(s, "p");
if (crc32("XkviDjHdmL",10) == 442633339) strcat(s, "r");
if (crc32("PGaHPN",6) == 4113580979) strcat(s, "C");
if (crc32("qvRMeUsOM",9) == 3898082624) strcat(s, "t");
if (crc32("GTUbE",5) == 1402256336) strcat(s, "i");
if (crc32("sBGXWK",6) == 3193990645) strcat(s, "B");
if (crc32("XYkwWMrrbBQ",11) == 381215079) strcat(s, "m");
if (crc32("fQznyDzxZUAVD",13) == 3923337936) strcat(s, "i");
if (crc32("kkRqTJi",7) == 3002309557) strcat(s, "d");
if (crc32("gizRMjUblLT",11) == 4017303527) strcat(s, "Y");
if (crc32("LdqEKjkL",8) == 3300018045) strcat(s, "l");
if (crc32("TTwHjfTUimroAD",14) == 125588837) strcat(s, "y");
    return s;
}

char *unvividly_adverbs() {
    char *s = calloc(10);
    if (crc32("vPkrmdGXqajgF",13) == 255996465) strcat(s, "t");
if (crc32("OKXxWfvJvxLEV",13) == 2093483854) strcat(s, "u");
if (crc32("rPlRQuc",7) == 1012838968) strcat(s, "n");
if (crc32("gufbjy",6) == 2793303280) strcat(s, "j");
if (crc32("AHlysFcys",9) == 3368987284) strcat(s, "v");
if (crc32("Zhkpn",5) == 2342842099) strcat(s, "i");
if (crc32("osnIrKDU",8) == 3835287190) strcat(s, "v");
if (crc32("enIUViSvcsAsKp",14) == 1631774369) strcat(s, "f");
if (crc32("lUdSziXdTLKnjyI",15) == 3039592800) strcat(s, "i");
if (crc32("VmmZAVWvOxtOA",13) == 2360724309) strcat(s, "D");
if (crc32("eTXowxXMwxSldVj",15) == 380801251) strcat(s, "d");
if (crc32("ubHlfphLMjH",11) == 3615323376) strcat(s, "l");
if (crc32("bmGyT",5) == 2907142320) strcat(s, "D");
if (crc32("oYBBBsxGBuC",11) == 699827203) strcat(s, "y");
    return s;
}

char *skilfully_adverbs() {
    char *s = calloc(10);
    if (crc32("cFxvNvNulonra",13) == 2583894678) strcat(s, "a");
if (crc32("udROe",5) == 1716896821) strcat(s, "s");
if (crc32("IerytH",6) == 1446014857) strcat(s, "P");
if (crc32("iNmMJffqcwIzjuY",15) == 3516176524) strcat(s, "k");
if (crc32("BNtsPjN",7) == 2158269365) strcat(s, "q");
if (crc32("SRRFGqvIyzkUbvA",15) == 2581340494) strcat(s, "i");
if (crc32("MfEqBPjTGg",10) == 2778125248) strcat(s, "l");
if (crc32("TydyZOUA",8) == 3011020147) strcat(s, "f");
if (crc32("jlmon",5) == 3420159200) strcat(s, "d");
if (crc32("jAqEKjTSkcutWT",14) == 2981681486) strcat(s, "u");
if (crc32("FqdEaR",6) == 2548548844) strcat(s, "l");
if (crc32("xnpFmSmGrZz",11) == 1609706464) strcat(s, "l");
if (crc32("IxMPN",5) == 1859611142) strcat(s, "y");
    return s;
}

char *adventively_adverbs() {
    char *s = calloc(12);
    if (crc32("EFHbKF",6) == 2686814818) strcat(s, "a");
if (crc32("WUUcqyrDRB",10) == 3523200055) strcat(s, "z");
if (crc32("rYcPdGAaA",9) == 2733716609) strcat(s, "d");
if (crc32("eABPUcfmXDHH",12) == 367359788) strcat(s, "v");
if (crc32("hiamhrVSjfZ",11) == 2271650320) strcat(s, "h");
if (crc32("zSodNcQY",8) == 1607602731) strcat(s, "e");
if (crc32("qcIxJAqmRQXNRY",14) == 2626781491) strcat(s, "n");
if (crc32("ycGBBU",6) == 4025369057) strcat(s, "t");
if (crc32("uGhMrvd",7) == 2509398341) strcat(s, "i");
if (crc32("eBgfqzs",7) == 2059577156) strcat(s, "v");
if (crc32("SPbOQWaHI",9) == 936063968) strcat(s, "e");
if (crc32("QuiTME",6) == 3155565068) strcat(s, "D");
if (crc32("VnAzmFV",7) == 3936491753) strcat(s, "l");
if (crc32("xGwJNvXWfbLKJ",13) == 4085141393) strcat(s, "y");
    return s;
}

char *unverbosely_adverbs() {
    char *s = calloc(12);
    if (crc32("UjIEXSFw",8) == 3882288709) strcat(s, "u");
if (crc32("VKzALFtRLc",10) == 4148712294) strcat(s, "H");
if (crc32("pkjAv",5) == 3331556203) strcat(s, "n");
if (crc32("QjOCMgrj",8) == 1337289664) strcat(s, "b");
if (crc32("jcUAOYVwg",9) == 1945526637) strcat(s, "v");
if (crc32("VChmpxatzbp",11) == 938094544) strcat(s, "e");
if (crc32("DQzAibfpQafUXEF",15) == 1040669331) strcat(s, "W");
if (crc32("ZkZjk",5) == 2097135854) strcat(s, "r");
if (crc32("zrndsCgkYpe",11) == 1428026022) strcat(s, "z");
if (crc32("nhjyuQh",7) == 3573861071) strcat(s, "b");
if (crc32("YvjiUxflE",9) == 2400723738) strcat(s, "s");
if (crc32("IfyOnHpWvXtNd",13) == 2215737884) strcat(s, "o");
if (crc32("rsEDmCh",7) == 930796703) strcat(s, "s");
if (crc32("SbLgTBlYDgw",11) == 1371670385) strcat(s, "e");
if (crc32("BGfSesudrep",11) == 2745253942) strcat(s, "l");
if (crc32("GtpMvyzKff",10) == 2108499368) strcat(s, "y");
    return s;
}

char *thinkably_adverbs() {
    char *s = calloc(10);
    if (crc32("TmEHwMgB",8) == 3699495381) strcat(s, "n");
if (crc32("IVczvzZmmUU",11) == 685389739) strcat(s, "t");
if (crc32("LDiRzHhcfaG",11) == 880870424) strcat(s, "h");
if (crc32("RPuRuMnOhGo",11) == 2472835466) strcat(s, "i");
if (crc32("nHstgwdWPKoO",12) == 1065317099) strcat(s, "n");
if (crc32("QoYXai",6) == 1829306099) strcat(s, "V");
if (crc32("VcNCIoFN",8) == 4108592491) strcat(s, "k");
if (crc32("fpAhMS",6) == 1147419117) strcat(s, "a");
if (crc32("OAPCelgTRbu",11) == 1532386720) strcat(s, "b");
if (crc32("RTrFKiQ",7) == 1472727778) strcat(s, "l");
if (crc32("hSNZk",5) == 1458095641) strcat(s, "y");
    return s;
}

char *cyclonically_adverbs() {
    char *s = calloc(13);
    if (crc32("LhVOpACUCHtiH",13) == 2993893877) strcat(s, "j");
if (crc32("OqSJmyUlgRen",12) == 1455886924) strcat(s, "c");
if (crc32("BUpWZTc",7) == 3610716406) strcat(s, "l");
if (crc32("RpmtSXB",7) == 598853919) strcat(s, "y");
if (crc32("LxjmH",5) == 415127704) strcat(s, "c");
if (crc32("npVAVBCf",8) == 819456448) strcat(s, "X");
if (crc32("MbqGYExQyO",10) == 2079607793) strcat(s, "l");
if (crc32("EIsSWyUif",9) == 246868721) strcat(s, "r");
if (crc32("zsWEzzckkXBvzT",14) == 3774160502) strcat(s, "o");
if (crc32("JcoTc",5) == 3050079062) strcat(s, "w");
if (crc32("THCweT",6) == 3805117379) strcat(s, "n");
if (crc32("WEvmBagEwhWvnD",14) == 1303287203) strcat(s, "i");
if (crc32("aPshZXJRCr",10) == 1157937372) strcat(s, "K");
if (crc32("jhIyB",5) == 4065727313) strcat(s, "c");
if (crc32("aXpPxOYTVzNh",12) == 2439426177) strcat(s, "U");
if (crc32("PuTyjxkK",8) == 2230787975) strcat(s, "a");
if (crc32("oYYGIRR",7) == 2322648626) strcat(s, "l");
if (crc32("roSdOO",6) == 1676227902) strcat(s, "B");
if (crc32("yestuCIombPJld",14) == 1160578265) strcat(s, "l");
if (crc32("JtWxTXhLtb",10) == 3082342512) strcat(s, "y");
    return s;
}

char *halfcontemptuously_adverbs() {
    char *s = calloc(19);
    if (crc32("pvfDqxWlVYiQiZ",14) == 2144473057) strcat(s, "y");
if (crc32("nBghrpA",7) == 2825159646) strcat(s, "h");
if (crc32("gGiiTNqS",8) == 2136213076) strcat(s, "a");
if (crc32("luZMIDYrFNysEH",14) == 3533190545) strcat(s, "c");
if (crc32("whVFwEgXu",9) == 275525594) strcat(s, "l");
if (crc32("lDVDiflGTLTgm",13) == 2035708916) strcat(s, "f");
if (crc32("fTdOQWjOFZxdXq",14) == 2926141865) strcat(s, "c");
if (crc32("AygWgNFPF",9) == 3266252709) strcat(s, "o");
if (crc32("WDkAQr",6) == 2381221013) strcat(s, "n");
if (crc32("WmBJThBOOyaxD",13) == 2825960989) strcat(s, "J");
if (crc32("ZoUXoEOOUS",10) == 657730447) strcat(s, "t");
if (crc32("gchMXyLPGbXX",12) == 3772733084) strcat(s, "m");
if (crc32("KCqkXDe",7) == 2975555484) strcat(s, "e");
if (crc32("ZEGULbitZj",10) == 3900808956) strcat(s, "m");
if (crc32("RhXToeeuai",10) == 4219764999) strcat(s, "K");
if (crc32("IwARcnD",7) == 2651968164) strcat(s, "p");
if (crc32("DCroLsrrad",10) == 1725767945) strcat(s, "t");
if (crc32("NGfKNlZqW",9) == 1791692202) strcat(s, "u");
if (crc32("XDGIhqnd",8) == 314519926) strcat(s, "M");
if (crc32("zKbHD",5) == 991399813) strcat(s, "o");
if (crc32("rdUyaVdJJBGSby",14) == 1590210458) strcat(s, "o");
if (crc32("SJxOugpaLHp",11) == 2018073726) strcat(s, "u");
if (crc32("nzynb",5) == 3879758667) strcat(s, "s");
if (crc32("DnJTLmJXkWeF",12) == 248655058) strcat(s, "K");
if (crc32("nzLxBDOGgpSFzv",14) == 583279949) strcat(s, "l");
if (crc32("SRhOMM",6) == 2984599077) strcat(s, "y");
    return s;
}

char *sapiently_adverbs() {
    char *s = calloc(10);
    if (crc32("MSrqe",5) == 3502299300) strcat(s, "l");
if (crc32("XePbguiAcRpB",12) == 1961917873) strcat(s, "s");
if (crc32("ZSvqDbOAUk",10) == 904911045) strcat(s, "Z");
if (crc32("JmJKRtINxyZy",12) == 3003667095) strcat(s, "a");
if (crc32("nkFTgxooypD",11) == 3242716264) strcat(s, "T");
if (crc32("biAiNtgTuZ",10) == 284365085) strcat(s, "p");
if (crc32("FpOmR",5) == 1415452071) strcat(s, "i");
if (crc32("rbQobmApd",9) == 3727393944) strcat(s, "v");
if (crc32("IkhgfdKuGnLKRQJ",15) == 1078647862) strcat(s, "e");
if (crc32("OLUgzuY",7) == 2343732567) strcat(s, "z");
if (crc32("mZfWK",5) == 1537101630) strcat(s, "n");
if (crc32("PSGgpTf",7) == 1450586910) strcat(s, "t");
if (crc32("GRwOeWuPeK",10) == 22634420) strcat(s, "e");
if (crc32("DKAPnhp",7) == 1497463897) strcat(s, "l");
if (crc32("XfuCY",5) == 1214368010) strcat(s, "f");
if (crc32("vvEaSHLFFavUSea",15) == 1797199899) strcat(s, "y");
    return s;
}

char *favoringly_adverbs() {
    char *s = calloc(11);
    if (crc32("Mymnv",5) == 1918979744) strcat(s, "f");
if (crc32("dqIiIxWsVLq",11) == 922315922) strcat(s, "F");
if (crc32("GupKvluxFbTrA",13) == 2268891333) strcat(s, "a");
if (crc32("zXOgKqhCAF",10) == 2380563685) strcat(s, "g");
if (crc32("zetJaSeXhujlN",13) == 3110081490) strcat(s, "v");
if (crc32("PxhwsDzJAFdU",12) == 1690861692) strcat(s, "n");
if (crc32("jPcXzU",6) == 2773701046) strcat(s, "o");
if (crc32("jIpSSAqhRvyvL",13) == 581419739) strcat(s, "p");
if (crc32("NEyOuagnIM",10) == 3295917176) strcat(s, "r");
if (crc32("OTbYWpVSfPzW",12) == 3194471529) strcat(s, "i");
if (crc32("gpJOB",5) == 338790332) strcat(s, "n");
if (crc32("fSYlmFxMGPx",11) == 1421728594) strcat(s, "g");
if (crc32("nybCxMLs",8) == 3235234495) strcat(s, "g");
if (crc32("GuZqcZMyJ",9) == 3601332135) strcat(s, "U");
if (crc32("SXcZjxjFDpC",11) == 2468554448) strcat(s, "l");
if (crc32("FecvXiPiJGt",11) == 3116655347) strcat(s, "y");
    return s;
}

char *denunciatively_adverbs() {
    char *s = calloc(15);
    if (crc32("FkHWkWNto",9) == 1042722367) strcat(s, "d");
if (crc32("ONxHxwQgv",9) == 643252271) strcat(s, "d");
if (crc32("rCLwdaMcaMvG",12) == 1673896421) strcat(s, "W");
if (crc32("YVAzbLiIk",9) == 1838757427) strcat(s, "e");
if (crc32("pRitgDmdaVMzrm",14) == 1203315373) strcat(s, "n");
if (crc32("obpnisQWuSZXrPK",15) == 3504703366) strcat(s, "l");
if (crc32("vfzjMJV",7) == 3680269564) strcat(s, "u");
if (crc32("KndmsIV",7) == 873087613) strcat(s, "s");
if (crc32("XBnukh",6) == 1066357149) strcat(s, "n");
if (crc32("zSYxWJOXuFP",11) == 3751057570) strcat(s, "w");
if (crc32("sfSgnfTRmC",10) == 1953014689) strcat(s, "c");
if (crc32("NQrNIuUcwMZVo",13) == 3769387723) strcat(s, "I");
if (crc32("etbWWsmlFbjgSX",14) == 1957467572) strcat(s, "i");
if (crc32("OinjSUlsRBL",11) == 3409460473) strcat(s, "B");
if (crc32("iCuQAuAKrdsY",12) == 3703615761) strcat(s, "a");
if (crc32("fJYFsXRj",8) == 1361080158) strcat(s, "t");
if (crc32("YKbaDSdNZNXItMi",15) == 2182534383) strcat(s, "Z");
if (crc32("TVynXteexetZCn",14) == 4189123051) strcat(s, "i");
if (crc32("AQzoY",5) == 2041879965) strcat(s, "v");
if (crc32("gUeKOpNrYE",10) == 1893622878) strcat(s, "e");
if (crc32("hCfCAZ",6) == 1488113884) strcat(s, "T");
if (crc32("nAeVVSPx",8) == 3383546722) strcat(s, "l");
if (crc32("cPtshFigZyJEnS",14) == 684541508) strcat(s, "N");
if (crc32("CLpbLSYqwpK",11) == 2994265363) strcat(s, "y");
    return s;
}

char *indispensably_adverbs() {
    char *s = calloc(14);
    if (crc32("mtRzHWUli",9) == 45780374) strcat(s, "A");
if (crc32("huFYaIkrRNTMtz",14) == 3456146529) strcat(s, "i");
if (crc32("lhxvib",6) == 850260764) strcat(s, "p");
if (crc32("vRRAJvwVDiDyhme",15) == 2962202375) strcat(s, "n");
if (crc32("hCaGHkqtudxXbv",14) == 481190661) strcat(s, "d");
if (crc32("DujskPhQ",8) == 29000093) strcat(s, "X");
if (crc32("KMvJMIUFaKs",11) == 517855285) strcat(s, "i");
if (crc32("IQuuNyKvtfZy",12) == 151608972) strcat(s, "H");
if (crc32("lHtgMInSgvJE",12) == 692921260) strcat(s, "s");
if (crc32("WPPUpftGzme",11) == 3732420966) strcat(s, "d");
if (crc32("laATFJsDVObR",12) == 4048752959) strcat(s, "p");
if (crc32("kOzJEWNHdgsOiq",14) == 2171294527) strcat(s, "C");
if (crc32("hKapbOQiRatk",12) == 2755387533) strcat(s, "e");
if (crc32("xJfTZxOXbbWU",12) == 2089445494) strcat(s, "u");
if (crc32("XrwHyW",6) == 1369365027) strcat(s, "n");
if (crc32("lSqFIU",6) == 745126949) strcat(s, "s");
if (crc32("OtQfCCDFLac",11) == 1079175282) strcat(s, "q");
if (crc32("dDQldIReDHoi",12) == 4089648671) strcat(s, "a");
if (crc32("CtRCdqN",7) == 1540412393) strcat(s, "b");
if (crc32("WBgSoP",6) == 1805505372) strcat(s, "f");
if (crc32("QgGCFbXP",8) == 1402263568) strcat(s, "l");
if (crc32("HLsUnmYIJnV",11) == 425760785) strcat(s, "O");
if (crc32("WxsFFMtB",8) == 2868898880) strcat(s, "y");
    return s;
}

char *unfashionably_adverbs() {
    char *s = calloc(14);
    if (crc32("TdEHDAKc",8) == 1589201989) strcat(s, "u");
if (crc32("PyGBBOStXncHFy",14) == 1205585673) strcat(s, "n");
if (crc32("feVCCIY",7) == 2757448345) strcat(s, "q");
if (crc32("svcLCiyCKsT",11) == 3748430816) strcat(s, "f");
if (crc32("fbqaUrCJcY",10) == 2001168166) strcat(s, "a");
if (crc32("kdEVEux",7) == 2198484732) strcat(s, "s");
if (crc32("SeHSKTIupTaDL",13) == 762138989) strcat(s, "h");
if (crc32("wURZctCUivUO",12) == 775653946) strcat(s, "C");
if (crc32("TzBmMGoAgr",10) == 1755225987) strcat(s, "i");
if (crc32("bxVkBJwmcgiKJ",13) == 274274179) strcat(s, "E");
if (crc32("ueZswNmw",8) == 3651492811) strcat(s, "o");
if (crc32("woHlH",5) == 559095270) strcat(s, "n");
if (crc32("ZzlnJZP",7) == 3726717955) strcat(s, "q");
if (crc32("EtvNWuClQhWL",12) == 4222736670) strcat(s, "a");
if (crc32("JBZMAhdj",8) == 1936848984) strcat(s, "L");
if (crc32("OmdkFAxijXlZThS",15) == 768463586) strcat(s, "b");
if (crc32("EDkuqKC",7) == 83779499) strcat(s, "l");
if (crc32("PohlaUStwYgv",12) == 1720106743) strcat(s, "o");
if (crc32("uAXIqZhVZYFs",12) == 340862739) strcat(s, "y");
    return s;
}

char *uncourageously_adverbs() {
    char *s = calloc(15);
    if (crc32("sYikcclXiYDAmM",14) == 4096540259) strcat(s, "p");
if (crc32("PTYNaYYwHlNLe",13) == 427509250) strcat(s, "u");
if (crc32("kCeCCRkOxZ",10) == 3762270044) strcat(s, "d");
if (crc32("gMNiSloqfRCtR",13) == 3245597073) strcat(s, "n");
if (crc32("LKiFNT",6) == 3602824305) strcat(s, "c");
if (crc32("GblBdFnJY",9) == 1209478857) strcat(s, "o");
if (crc32("RgYwOJSyY",9) == 1817413926) strcat(s, "u");
if (crc32("SRczT",5) == 735245511) strcat(s, "r");
if (crc32("jifFTzBvpScO",12) == 3814227008) strcat(s, "a");
if (crc32("HmDhQLVEoCIv",12) == 2142731319) strcat(s, "g");
if (crc32("bMpaeDujTrLHFUx",15) == 808488460) strcat(s, "e");
if (crc32("JerzFWoGmylFyp",14) == 1666326068) strcat(s, "o");
if (crc32("WcbZh",5) == 770506705) strcat(s, "u");
if (crc32("oAEvwueh",8) == 4071707312) strcat(s, "i");
if (crc32("lWgIdesr",8) == 71822276) strcat(s, "s");
if (crc32("yifRfroCLEdN",12) == 3575010754) strcat(s, "l");
if (crc32("OxnlLkFwLkNTW",13) == 3667240085) strcat(s, "y");
    return s;
}

char *interiorly_adverbs() {
    char *s = calloc(11);
    if (crc32("gsjIaivYgc",10) == 227797640) strcat(s, "i");
if (crc32("yxnhjhb",7) == 1463838115) strcat(s, "y");
if (crc32("MliZTPne",8) == 679592583) strcat(s, "n");
if (crc32("DryYoTB",7) == 2087549772) strcat(s, "V");
if (crc32("rvBIxNgKBGhbU",13) == 2151433120) strcat(s, "t");
if (crc32("RIOketp",7) == 1430044923) strcat(s, "R");
if (crc32("IBhiqAqMR",9) == 448384418) strcat(s, "e");
if (crc32("HqMzedjc",8) == 3715033968) strcat(s, "r");
if (crc32("SQGQLPTCvmqy",12) == 366379088) strcat(s, "C");
if (crc32("uqrkXq",6) == 4266339982) strcat(s, "i");
if (crc32("HdhGig",6) == 4161619974) strcat(s, "e");
if (crc32("tRIrj",5) == 1683051334) strcat(s, "o");
if (crc32("dzXvlEgJCcMqw",13) == 3143007222) strcat(s, "r");
if (crc32("iXctHHlxvBBsdG",14) == 3133908281) strcat(s, "j");
if (crc32("KGtujywReUJXqu",14) == 392180533) strcat(s, "l");
if (crc32("gZZKLjgnfTx",11) == 967442197) strcat(s, "y");
    return s;
}

char *conversely_adverbs() {
    char *s = calloc(11);
    if (crc32("KwHyOSkH",8) == 1019296693) strcat(s, "J");
if (crc32("kwNaQ",5) == 3299258922) strcat(s, "c");
if (crc32("LOoLvo",6) == 2908132708) strcat(s, "o");
if (crc32("peNapDabd",9) == 3768093097) strcat(s, "n");
if (crc32("HeHrAlpiecCp",12) == 3846716114) strcat(s, "v");
if (crc32("JPZrOdBKYdx",11) == 2623534481) strcat(s, "v");
if (crc32("hNlmq",5) == 2721546907) strcat(s, "e");
if (crc32("XpjzJkCl",8) == 259870979) strcat(s, "n");
if (crc32("kOtbvirIJR",10) == 2269260654) strcat(s, "r");
if (crc32("CWToyTnOFVcG",12) == 1884887761) strcat(s, "U");
if (crc32("UCNEBELftGLfM",13) == 608562828) strcat(s, "s");
if (crc32("DjCUCnBRuynqyJw",15) == 2564043696) strcat(s, "k");
if (crc32("AKtCVUhUHHKaUd",14) == 3256410871) strcat(s, "e");
if (crc32("vlQdMfzWsj",10) == 625947990) strcat(s, "l");
if (crc32("PynNUDeO",8) == 3915393082) strcat(s, "y");
    return s;
}

char *nonbusily_adverbs() {
    char *s = calloc(10);
    if (crc32("tDJnJMhtstcg",12) == 3845249299) strcat(s, "n");
if (crc32("lreevaqJBRj",11) == 2130136839) strcat(s, "g");
if (crc32("iqrZKNXgb",9) == 529964166) strcat(s, "o");
if (crc32("MiyBuzsdIsoqG",13) == 2011908065) strcat(s, "G");
if (crc32("dfwUGKwrzdcyswA",15) == 3481604206) strcat(s, "n");
if (crc32("RHLMZd",6) == 990704222) strcat(s, "b");
if (crc32("NjClyHpkLer",11) == 422112232) strcat(s, "u");
if (crc32("yLFCPIurkzaZU",13) == 135715184) strcat(s, "s");
if (crc32("OldKcPrKrGn",11) == 2869210519) strcat(s, "i");
if (crc32("tIXZbpRM",8) == 1273723002) strcat(s, "l");
if (crc32("UStauOOxXCp",11) == 1556864273) strcat(s, "y");
    return s;
}

char *widely_adverbs() {
    char *s = calloc(7);
    if (crc32("nOKcToKM",8) == 3037274185) strcat(s, "w");
if (crc32("bbyeImQ",7) == 2402773931) strcat(s, "i");
if (crc32("EjvyYNIpWHz",11) == 1723570394) strcat(s, "d");
if (crc32("VfRPzPLxhLmJhT",14) == 919704548) strcat(s, "e");
if (crc32("WuNvHJnbiBKm",12) == 842650356) strcat(s, "t");
if (crc32("ROKSXRruewfrO",13) == 1837405571) strcat(s, "l");
if (crc32("KowDoneknEgmR",13) == 349263080) strcat(s, "j");
if (crc32("uzevxA",6) == 3824571540) strcat(s, "y");
    return s;
}

char *contrariously_adverbs() {
    char *s = calloc(14);
    if (crc32("rfwtsF",6) == 3756464573) strcat(s, "c");
if (crc32("IknLXLVmBFzJ",12) == 3937167868) strcat(s, "o");
if (crc32("FVRBrLQYHHsA",12) == 3286939261) strcat(s, "n");
if (crc32("RAaTv",5) == 1980070578) strcat(s, "I");
if (crc32("JSdOidmfVGzCQ",13) == 4087091829) strcat(s, "t");
if (crc32("nZPgi",5) == 2292517084) strcat(s, "a");
if (crc32("oeXQGgRQNdr",11) == 2948764176) strcat(s, "r");
if (crc32("gNKso",5) == 1211317094) strcat(s, "h");
if (crc32("xyVauuxcLPmI",12) == 583072089) strcat(s, "a");
if (crc32("MqCXIHKc",8) == 558899395) strcat(s, "s");
if (crc32("CxqSXI",6) == 834079511) strcat(s, "r");
if (crc32("GIsdMJYfnLrWuuz",15) == 3756286893) strcat(s, "i");
if (crc32("WIVZKSiqE",9) == 2868368088) strcat(s, "o");
if (crc32("yyhnlpplpi",10) == 657511584) strcat(s, "s");
if (crc32("IkNZxpWFDoDK",12) == 3051763791) strcat(s, "u");
if (crc32("nEnHoSr",7) == 1297504203) strcat(s, "v");
if (crc32("WssJUp",6) == 2373311674) strcat(s, "s");
if (crc32("tPSKEADo",8) == 2451567033) strcat(s, "n");
if (crc32("OoFMSWxap",9) == 631022508) strcat(s, "l");
if (crc32("VrkgLN",6) == 2215655647) strcat(s, "y");
    return s;
}

char *justly_adverbs() {
    char *s = calloc(7);
    if (crc32("KhQwD",5) == 1603476754) strcat(s, "t");
if (crc32("syedCFoIGAwU",12) == 3141740866) strcat(s, "j");
if (crc32("UEdVGyk",7) == 3480111592) strcat(s, "a");
if (crc32("YOpCSAy",7) == 186514314) strcat(s, "u");
if (crc32("FiFXJJoiCw",10) == 3522929) strcat(s, "B");
if (crc32("OoLRP",5) == 3852649814) strcat(s, "s");
if (crc32("WRnkNFMQxCcoo",13) == 2923302800) strcat(s, "t");
if (crc32("JwCnGF",6) == 3214711016) strcat(s, "l");
if (crc32("FGthDwj",7) == 3768614497) strcat(s, "y");
    return s;
}

char *patricianly_adverbs() {
    char *s = calloc(12);
    if (crc32("ovFyHz",6) == 896384948) strcat(s, "c");
if (crc32("zEfxzurtfMMna",13) == 3592181444) strcat(s, "p");
if (crc32("nsUipMz",7) == 1948909158) strcat(s, "T");
if (crc32("EtDDtfyEdIihZJf",15) == 3459272890) strcat(s, "a");
if (crc32("UtRMijBqdvxyaRo",15) == 1112864661) strcat(s, "t");
if (crc32("frnNmIu",7) == 2709590070) strcat(s, "n");
if (crc32("XmhBDGRDQNYLrNO",15) == 1159030459) strcat(s, "r");
if (crc32("OZiQkUeRbcCfyc",14) == 2954396613) strcat(s, "i");
if (crc32("rITtwNE",7) == 3740316249) strcat(s, "c");
if (crc32("IAykHyhvOZWPRZG",15) == 2711782144) strcat(s, "i");
if (crc32("iDcsEQvc",8) == 4283641818) strcat(s, "b");
if (crc32("VOJBjfvdSd",10) == 1488744801) strcat(s, "a");
if (crc32("BvvaHjzAkHUAYZ",14) == 3445657940) strcat(s, "n");
if (crc32("ZwBpwxUua",9) == 3709537403) strcat(s, "H");
if (crc32("mNxDLBTcfGkF",12) == 3119751130) strcat(s, "l");
if (crc32("wHeQhLFIWekviEM",15) == 2772432302) strcat(s, "y");
    return s;
}

char *nonchimerically_adverbs() {
    char *s = calloc(16);
    if (crc32("fqLnCWuLkvE",11) == 2542430298) strcat(s, "S");
if (crc32("PIgyGEYmgtIgs",13) == 1385837795) strcat(s, "n");
if (crc32("fZpenSQAs",9) == 191708777) strcat(s, "o");
if (crc32("ylvhQGhq",8) == 1365946509) strcat(s, "T");
if (crc32("NHthse",6) == 2000735110) strcat(s, "n");
if (crc32("GWDzMCykEtaiY",13) == 139210410) strcat(s, "c");
if (crc32("dtFarbZ",7) == 2903492641) strcat(s, "h");
if (crc32("QwivFPwZgmYL",12) == 2425810714) strcat(s, "Q");
if (crc32("XVYmzpIiwVE",11) == 1676740808) strcat(s, "i");
if (crc32("yTBUhcCM",8) == 3573479636) strcat(s, "m");
if (crc32("WSCqXglG",8) == 1931264319) strcat(s, "O");
if (crc32("zyUQIfflfuhmt",13) == 294271455) strcat(s, "e");
if (crc32("KpHRxkjYnOFPfMD",15) == 2981784203) strcat(s, "r");
if (crc32("OCzQhQIxUhQWqa",14) == 469898924) strcat(s, "i");
if (crc32("ylKRKvP",7) == 2268598098) strcat(s, "x");
if (crc32("RZyJfiVU",8) == 1698792979) strcat(s, "c");
if (crc32("hCMgBUDrwi",10) == 2673612834) strcat(s, "a");
if (crc32("GjAXmxUFL",9) == 3691255578) strcat(s, "u");
if (crc32("fKamlDhUfKi",11) == 1404920858) strcat(s, "l");
if (crc32("boewixdtlsORje",14) == 397247551) strcat(s, "l");
if (crc32("mfoGiYnSYbRV",12) == 170391093) strcat(s, "N");
if (crc32("LGbYWZANdo",10) == 526665961) strcat(s, "y");
    return s;
}

char *furrily_adverbs() {
    char *s = calloc(8);
    if (crc32("PkDytq",6) == 1890160357) strcat(s, "f");
if (crc32("jIXyK",5) == 2397088489) strcat(s, "u");
if (crc32("oXVQiXdOpX",10) == 3197246630) strcat(s, "r");
if (crc32("vPyzPrivfx",10) == 1698691869) strcat(s, "r");
if (crc32("wHtVxhQmgKxT",12) == 2300862497) strcat(s, "i");
if (crc32("lVAFhFlVrcyjhN",14) == 999716901) strcat(s, "f");
if (crc32("mqhBxpdkPMUC",12) == 3051139243) strcat(s, "l");
if (crc32("RNJTiq",6) == 3576698319) strcat(s, "o");
if (crc32("gaLXfDzFR",9) == 3642275115) strcat(s, "y");
    return s;
}

char *horrifiedly_adverbs() {
    char *s = calloc(12);
    if (crc32("hbYGtloVBjxMncI",15) == 2567852407) strcat(s, "E");
if (crc32("NlScQ",5) == 1817677921) strcat(s, "h");
if (crc32("GojruxNEnG",10) == 787468317) strcat(s, "p");
if (crc32("cKdsyEsHQjdKn",13) == 2760411916) strcat(s, "o");
if (crc32("CFwptwhz",8) == 2718545665) strcat(s, "r");
if (crc32("pXCnoTGKWdrq",12) == 3169763177) strcat(s, "r");
if (crc32("wkSicuXUtu",10) == 2723867913) strcat(s, "U");
if (crc32("iKvKToa",7) == 1866417790) strcat(s, "i");
if (crc32("JgYCXtCecSrptA",14) == 2285985965) strcat(s, "f");
if (crc32("XLbCa",5) == 3039938260) strcat(s, "i");
if (crc32("IEOFgWJfopKfhqi",15) == 2545968465) strcat(s, "e");
if (crc32("TrBYEvVOUZNgGe",14) == 3961145849) strcat(s, "J");
if (crc32("EbjnGVxHxyTuj",13) == 1221798289) strcat(s, "d");
if (crc32("mYpYICPtppoZT",13) == 3341506817) strcat(s, "l");
if (crc32("EawfpBNFD",9) == 1339376503) strcat(s, "Q");
if (crc32("OUvBH",5) == 174471122) strcat(s, "y");
    return s;
}

char *deathlessly_adverbs() {
    char *s = calloc(12);
    if (crc32("NEbiVX",6) == 1839027539) strcat(s, "s");
if (crc32("wxmxp",5) == 3568802048) strcat(s, "d");
if (crc32("aamhyFTEIoDq",12) == 529663149) strcat(s, "e");
if (crc32("CCIesgDNySdE",12) == 2044688195) strcat(s, "G");
if (crc32("rWFFknttCYREK",13) == 164312493) strcat(s, "a");
if (crc32("tuRkYvShHFDapVA",15) == 2359010555) strcat(s, "t");
if (crc32("nfRMckjFehb",11) == 2935287765) strcat(s, "h");
if (crc32("bLghoQQPruDfu",13) == 3351235727) strcat(s, "l");
if (crc32("GAZDRPv",7) == 3539216067) strcat(s, "e");
if (crc32("ruKgwmznoUiJc",13) == 1949793020) strcat(s, "s");
if (crc32("yuGXjy",6) == 1935658699) strcat(s, "A");
if (crc32("hXivJOSDN",9) == 4271588983) strcat(s, "s");
if (crc32("viItu",5) == 3289886498) strcat(s, "U");
if (crc32("QPCheq",6) == 3203270201) strcat(s, "l");
if (crc32("nPhcZzPUKtm",11) == 413368688) strcat(s, "T");
if (crc32("aCGFHDpwB",9) == 2181471742) strcat(s, "y");
    return s;
}

char *superromantically_adverbs() {
    char *s = calloc(18);
    if (crc32("ElhWBjCi",8) == 4046482217) strcat(s, "K");
if (crc32("kpKgTs",6) == 1014301882) strcat(s, "s");
if (crc32("ZhppjS",6) == 16348923) strcat(s, "e");
if (crc32("juhiCt",6) == 473392256) strcat(s, "u");
if (crc32("cUFSfyXS",8) == 695520857) strcat(s, "p");
if (crc32("swMKEMxPHM",10) == 1393928577) strcat(s, "R");
if (crc32("SAgnT",5) == 1087992639) strcat(s, "e");
if (crc32("BfTkjSYPxsjk",12) == 2364487194) strcat(s, "r");
if (crc32("pbfdbdxAJMJWeT",14) == 3878371817) strcat(s, "j");
if (crc32("hCxlvNxDq",9) == 3804064595) strcat(s, "r");
if (crc32("ubBvpShPOBSM",12) == 1825246173) strcat(s, "I");
if (crc32("zuTNFvxkihlnpz",14) == 965607117) strcat(s, "o");
if (crc32("SHOpFoXeZG",10) == 334880442) strcat(s, "b");
if (crc32("MntnxegzV",9) == 4185312322) strcat(s, "m");
if (crc32("omUQOc",6) == 456488943) strcat(s, "a");
if (crc32("wPoiz",5) == 2821152915) strcat(s, "K");
if (crc32("DSdTc",5) == 4149961366) strcat(s, "n");
if (crc32("YgRPxcdxODxu",12) == 2149192559) strcat(s, "t");
if (crc32("FwEFEynhbQMgbdr",15) == 3703573411) strcat(s, "i");
if (crc32("spDaqZWStU",10) == 1424926987) strcat(s, "c");
if (crc32("ZTuoQPYgTFg",11) == 4127732755) strcat(s, "a");
if (crc32("UIoEkvliHMuPd",13) == 1039687829) strcat(s, "P");
if (crc32("FwoJOjSEsNOh",12) == 3937812217) strcat(s, "l");
if (crc32("tITDEIBKwk",10) == 3245304541) strcat(s, "g");
if (crc32("atGdTeXWjI",10) == 500490590) strcat(s, "l");
if (crc32("JTehM",5) == 1304388838) strcat(s, "K");
if (crc32("HLLCjpefvwATFql",15) == 590421168) strcat(s, "y");
    return s;
}

char *secondarily_adverbs() {
    char *s = calloc(12);
    if (crc32("NcwszNkxzNVA",12) == 2157068384) strcat(s, "G");
if (crc32("ZAXBwXHCoqeixgR",15) == 2380788326) strcat(s, "s");
if (crc32("YBCPBaBrTaPtH",13) == 3275180641) strcat(s, "e");
if (crc32("GmfpDUGS",8) == 3091189645) strcat(s, "c");
if (crc32("BiMhmlbuDLQVuy",14) == 1742372264) strcat(s, "o");
if (crc32("vSROb",5) == 1468910552) strcat(s, "F");
if (crc32("jQepYlmLNVYZuF",14) == 3126144272) strcat(s, "n");
if (crc32("tuaNrxbJvtnP",12) == 3410892993) strcat(s, "d");
if (crc32("oFZLJpEJKffB",12) == 1000821026) strcat(s, "d");
if (crc32("UNcGNcBCYgF",11) == 1124270812) strcat(s, "a");
if (crc32("DahkqAYBjoWV",12) == 1615170880) strcat(s, "H");
if (crc32("ADAqrVmE",8) == 1325778470) strcat(s, "r");
if (crc32("qMUjInee",8) == 784488414) strcat(s, "i");
if (crc32("iSCOagIBtfVCNVE",15) == 390185719) strcat(s, "U");
if (crc32("ZwxchoAEEgWM",12) == 3436331417) strcat(s, "l");
if (crc32("wDSXRAg",7) == 82615190) strcat(s, "y");
    return s;
}

char *impressively_adverbs() {
    char *s = calloc(13);
    if (crc32("SWXMPiuYRedSH",13) == 1743208292) strcat(s, "u");
if (crc32("ztVnnHjEV",9) == 3951151265) strcat(s, "i");
if (crc32("MLjNNZwyXGP",11) == 4207060667) strcat(s, "u");
if (crc32("zItPMiogj",9) == 2212668838) strcat(s, "m");
if (crc32("xmbaTNIvqIamS",13) == 958967954) strcat(s, "p");
if (crc32("ETcBdwDGBK",10) == 2736973763) strcat(s, "r");
if (crc32("SgmGWooC",8) == 3066174910) strcat(s, "e");
if (crc32("fNqBTxIRx",9) == 938007880) strcat(s, "s");
if (crc32("UOUcmFHbzt",10) == 3227698313) strcat(s, "O");
if (crc32("yabSgPMCuG",10) == 2928483839) strcat(s, "s");
if (crc32("KUEWYDIOlAh",11) == 1441000955) strcat(s, "i");
if (crc32("aFyWNptmZsSNSu",14) == 3637229848) strcat(s, "Y");
if (crc32("euLZxYOXNE",10) == 2348909154) strcat(s, "v");
if (crc32("QChPSmPDmYCeqb",14) == 582654275) strcat(s, "T");
if (crc32("WFTwS",5) == 197626420) strcat(s, "e");
if (crc32("ZRDqjpcKNpB",11) == 3564737655) strcat(s, "l");
if (crc32("YQvmfKwXfcuYmg",14) == 2311800742) strcat(s, "E");
if (crc32("vfsygyjlpJnf",12) == 1448302065) strcat(s, "y");
    return s;
}

char *enrichingly_adverbs() {
    char *s = calloc(12);
    if (crc32("sSURfYxADiy",11) == 1090084815) strcat(s, "L");
if (crc32("bQGdvqh",7) == 1026623698) strcat(s, "e");
if (crc32("IGPcCdGh",8) == 3703695784) strcat(s, "x");
if (crc32("hyFOAZZJWVcxB",13) == 3333618034) strcat(s, "n");
if (crc32("tqZvFhlRgGgsVnP",15) == 376104034) strcat(s, "F");
if (crc32("XFbRpZefBvabg",13) == 2767438460) strcat(s, "r");
if (crc32("GHRxqPw",7) == 2354070863) strcat(s, "f");
if (crc32("KxEMb",5) == 3618662433) strcat(s, "i");
if (crc32("axxauaMlIBrQ",12) == 2421647969) strcat(s, "c");
if (crc32("pxSktMTL",8) == 3565880988) strcat(s, "Z");
if (crc32("aQDHTJ",6) == 1429780715) strcat(s, "h");
if (crc32("ScpfNxdZyFKRvt",14) == 1265700271) strcat(s, "i");
if (crc32("KNqVaxWd",8) == 345058469) strcat(s, "n");
if (crc32("eaiCiCxdlfyzNcm",15) == 1572959535) strcat(s, "g");
if (crc32("wwaebQUfSYfeXa",14) == 3924751843) strcat(s, "l");
if (crc32("DdeCmAQpNz",10) == 2955889020) strcat(s, "y");
    return s;
}

char *languishingly_adverbs() {
    char *s = calloc(14);
    if (crc32("SMgBC",5) == 2968330990) strcat(s, "l");
if (crc32("XpjoNp",6) == 134604977) strcat(s, "l");
if (crc32("RmLKDVLWm",9) == 3944423859) strcat(s, "a");
if (crc32("SMEXnaMpzBJGmK",14) == 3806940409) strcat(s, "s");
if (crc32("jUcdYbIvgvYeBL",14) == 2358544496) strcat(s, "n");
if (crc32("iAkyx",5) == 2500444681) strcat(s, "g");
if (crc32("EKSvT",5) == 979023888) strcat(s, "M");
if (crc32("RZvqveNpzoyVTSu",15) == 1258674787) strcat(s, "u");
if (crc32("KkKPRKQ",7) == 1316195666) strcat(s, "z");
if (crc32("XkXqcD",6) == 3675714978) strcat(s, "i");
if (crc32("CUYXzf",6) == 481825800) strcat(s, "Y");
if (crc32("xrGZcvBXoNd",11) == 2412644648) strcat(s, "s");
if (crc32("GSKsClxFmNKNi",13) == 1733082489) strcat(s, "b");
if (crc32("hRxhfbLnvjsoJ",13) == 19224888) strcat(s, "h");
if (crc32("lQzEkz",6) == 89770399) strcat(s, "a");
if (crc32("xihmxtVL",8) == 4014267687) strcat(s, "i");
if (crc32("sYvtmVeGdF",10) == 3056024946) strcat(s, "n");
if (crc32("nrCWwpkT",8) == 1009633399) strcat(s, "o");
if (crc32("LBPnYpmBLIzESj",14) == 394009225) strcat(s, "g");
if (crc32("THCezQJOhEUKMi",14) == 1705088039) strcat(s, "l");
if (crc32("KqYcuJmudQjmja",14) == 2072198071) strcat(s, "j");
if (crc32("NfswKTfIVgMnxDa",15) == 1438210224) strcat(s, "y");
    return s;
}

char *quasibrilliantly_adverbs() {
    char *s = calloc(17);
    if (crc32("WwWmAMbknJE",11) == 1665972629) strcat(s, "q");
if (crc32("QgMLxlxIrpRv",12) == 3541818636) strcat(s, "u");
if (crc32("zCbVOtjaZWaHIj",14) == 3972904489) strcat(s, "A");
if (crc32("TAjzwDKHxQB",11) == 2337292194) strcat(s, "a");
if (crc32("lWcxMQPrywhi",12) == 281466376) strcat(s, "s");
if (crc32("jbaXezNG",8) == 1253052748) strcat(s, "c");
if (crc32("qzAUrX",6) == 4088960536) strcat(s, "i");
if (crc32("ALSHzZjoPUENig",14) == 2060193052) strcat(s, "b");
if (crc32("mGdFzbbPPWDzmZ",14) == 2372858719) strcat(s, "r");
if (crc32("liIyYqBxFwtC",12) == 2209935432) strcat(s, "i");
if (crc32("tdPwsxLXn",9) == 2600730931) strcat(s, "l");
if (crc32("PPjDReBsHRSX",12) == 2373614633) strcat(s, "l");
if (crc32("ReSMMlQ",7) == 3400849320) strcat(s, "i");
if (crc32("yUkXfjN",7) == 447277819) strcat(s, "a");
if (crc32("ZgSYHdfD",8) == 3652848796) strcat(s, "n");
if (crc32("jXHtgpzCVnT",11) == 3201726024) strcat(s, "n");
if (crc32("tdsFgTv",7) == 1169813567) strcat(s, "F");
if (crc32("QtlzHOk",7) == 53845884) strcat(s, "t");
if (crc32("xDCCRXFWLdzpQy",14) == 3458665104) strcat(s, "l");
if (crc32("ziQHmxybUYMqxg",14) == 1162072231) strcat(s, "B");
if (crc32("MGDIrIGYr",9) == 3073833108) strcat(s, "y");
    return s;
}

char *quasigenerously_adverbs() {
    char *s = calloc(16);
    if (crc32("JIjmlxc",7) == 2801634397) strcat(s, "a");
if (crc32("dcmHnOLXmTfj",12) == 3808844591) strcat(s, "q");
if (crc32("wZzaBfwMQH",10) == 31325693) strcat(s, "u");
if (crc32("IStJz",5) == 1148562855) strcat(s, "n");
if (crc32("lNoOSnLwLJSrz",13) == 1598655738) strcat(s, "a");
if (crc32("ZkncA",5) == 3928613223) strcat(s, "g");
if (crc32("VNGDiKs",7) == 2333697339) strcat(s, "s");
if (crc32("WbSAsOPrrPWvSyD",15) == 1988120222) strcat(s, "i");
if (crc32("MyVJjSKAjXkJebI",15) == 1394346584) strcat(s, "R");
if (crc32("YHiXSUCiLos",11) == 3606059425) strcat(s, "g");
if (crc32("vCGPYOUtvl",10) == 2619857552) strcat(s, "e");
if (crc32("YiDvu",5) == 2610339057) strcat(s, "n");
if (crc32("gFptfbROZBrUQZ",14) == 2814356916) strcat(s, "h");
if (crc32("TysgPnfcKClk",12) == 1204440294) strcat(s, "e");
if (crc32("crMibCkP",8) == 1774475828) strcat(s, "r");
if (crc32("netiADcPuuRzj",13) == 3079042348) strcat(s, "d");
if (crc32("FAuWFUmghQN",11) == 152980928) strcat(s, "o");
if (crc32("TvcGVlfSdTX",11) == 440504167) strcat(s, "u");
if (crc32("ClzNQZDFuyii",12) == 1260306437) strcat(s, "s");
if (crc32("NXfVVjTfWj",10) == 1295613305) strcat(s, "R");
if (crc32("ZAvccjUt",8) == 3156649924) strcat(s, "l");
if (crc32("xktGNbQLAolcprR",15) == 191942473) strcat(s, "y");
    return s;
}

char *oldfashionedly_adverbs() {
    char *s = calloc(15);
    if (crc32("BJPGdEapR",9) == 4180427036) strcat(s, "P");
if (crc32("EkGBaJ",6) == 2676471650) strcat(s, "o");
if (crc32("cReEw",5) == 1959226301) strcat(s, "l");
if (crc32("TQtXfGBWDVjoP",13) == 4140163814) strcat(s, "p");
if (crc32("MoiOBTML",8) == 1057591162) strcat(s, "d");
if (crc32("dOJHaddkgmEDf",13) == 4016664247) strcat(s, "p");
if (crc32("YnBRVycYlZJZcL",14) == 4193738856) strcat(s, "f");
if (crc32("mOfniTdcY",9) == 2733935336) strcat(s, "a");
if (crc32("LEpuQtFIQPFjqa",14) == 476438217) strcat(s, "U");
if (crc32("ONWIvP",6) == 2475749858) strcat(s, "s");
if (crc32("lSjaApHOm",9) == 1518671406) strcat(s, "C");
if (crc32("AhReDYsp",8) == 198496005) strcat(s, "h");
if (crc32("bMHAKMaRpeIsvaP",15) == 2594168569) strcat(s, "i");
if (crc32("dcBumYkuiCeztA",14) == 1113159807) strcat(s, "o");
if (crc32("OVIzNsAHA",9) == 3643508370) strcat(s, "n");
if (crc32("XEaviqzMFAoZxN",14) == 3660782620) strcat(s, "e");
if (crc32("EACzKuNRhzeHj",13) == 3852358629) strcat(s, "x");
if (crc32("WYvpeb",6) == 886652112) strcat(s, "d");
if (crc32("rthGdRHjasrgeKt",15) == 1814152032) strcat(s, "l");
if (crc32("Pocegp",6) == 3138950322) strcat(s, "y");
    return s;
}

char *tristfully_adverbs() {
    char *s = calloc(11);
    if (crc32("rGAMag",6) == 3911255782) strcat(s, "t");
if (crc32("LOMqw",5) == 408008837) strcat(s, "r");
if (crc32("YmUyJ",5) == 955183891) strcat(s, "i");
if (crc32("FNrdXLVUw",9) == 2626102732) strcat(s, "B");
if (crc32("BCABm",5) == 3987004530) strcat(s, "s");
if (crc32("qSdjb",5) == 727988964) strcat(s, "N");
if (crc32("CkhYu",5) == 948198576) strcat(s, "t");
if (crc32("ceVBJXaIQV",10) == 4104822274) strcat(s, "f");
if (crc32("dneYFipenE",10) == 3943035278) strcat(s, "Q");
if (crc32("UrYlommHfiMb",12) == 108406273) strcat(s, "u");
if (crc32("XtPgRjAhysL",11) == 262544037) strcat(s, "O");
if (crc32("jsxPcmEpoc",10) == 2435197328) strcat(s, "l");
if (crc32("HGmFKzKaV",9) == 989552567) strcat(s, "l");
if (crc32("odDeXfOCmqvXnQ",14) == 3288082643) strcat(s, "A");
if (crc32("ZencJGqPGA",10) == 1639690803) strcat(s, "y");
    return s;
}

char *lyingly_adverbs() {
    char *s = calloc(8);
    if (crc32("pTwFIE",6) == 4090866161) strcat(s, "l");
if (crc32("yZxoXgdRWPlDbEz",15) == 3690934797) strcat(s, "l");
if (crc32("aQeitOVuO",9) == 3329617408) strcat(s, "Z");
if (crc32("nMDKNdumWl",10) == 475136477) strcat(s, "y");
if (crc32("uQPeUEbIo",9) == 2396769110) strcat(s, "S");
if (crc32("SFWXvf",6) == 95036445) strcat(s, "i");
if (crc32("QyvbDXUYsCT",11) == 1041663106) strcat(s, "n");
if (crc32("hJzqYUk",7) == 3252563447) strcat(s, "v");
if (crc32("fLAjwGOg",8) == 3229711148) strcat(s, "g");
if (crc32("IpxYHGTBo",9) == 510465033) strcat(s, "q");
if (crc32("rqcnTNrlA",9) == 4189649207) strcat(s, "l");
if (crc32("WvqwnB",6) == 927617850) strcat(s, "y");
    return s;
}

char *quasiharmfully_adverbs() {
    char *s = calloc(15);
    if (crc32("IvJybpzEG",9) == 1423089757) strcat(s, "y");
if (crc32("CiXxauj",7) == 3617998483) strcat(s, "q");
if (crc32("hNuThAW",7) == 1066623265) strcat(s, "u");
if (crc32("mpnmmfkkoUNIdwD",15) == 2870570314) strcat(s, "a");
if (crc32("WjKaU",5) == 60976669) strcat(s, "s");
if (crc32("JVHgoecIQnW",11) == 709390339) strcat(s, "i");
if (crc32("bgVsVE",6) == 311201533) strcat(s, "m");
if (crc32("wAgpxxUJcFH",11) == 4054669989) strcat(s, "h");
if (crc32("wjZYw",5) == 3038435265) strcat(s, "a");
if (crc32("SKdNbT",6) == 3782668020) strcat(s, "a");
if (crc32("cpkXjyyrGzVoC",13) == 2410278772) strcat(s, "r");
if (crc32("ZMhfwNGVukNkpLN",15) == 1805101999) strcat(s, "m");
if (crc32("urKCCzxzaO",10) == 2070781720) strcat(s, "f");
if (crc32("cSlgl",5) == 2977768255) strcat(s, "a");
if (crc32("PbmpbIAO",8) == 2163222186) strcat(s, "u");
if (crc32("CbvVbywpI",9) == 591912443) strcat(s, "I");
if (crc32("nSDhWKfCTy",10) == 3619845130) strcat(s, "l");
if (crc32("faVtOBIenaJasj",14) == 428877532) strcat(s, "l");
if (crc32("tYcHlnrXdymD",12) == 1546815565) strcat(s, "y");
    return s;
}

char *aboriginally_adverbs() {
    char *s = calloc(13);
    if (crc32("TfbnK",5) == 523039642) strcat(s, "V");
if (crc32("FSqMGDIDvv",10) == 2423593754) strcat(s, "a");
if (crc32("YqvoGHTWUM",10) == 3463556057) strcat(s, "b");
if (crc32("VxYvugXkrXFNmL",14) == 2520636786) strcat(s, "Q");
if (crc32("dmZHuVd",7) == 2398681500) strcat(s, "o");
if (crc32("QgYJDZkVbkNnPA",14) == 429895669) strcat(s, "r");
if (crc32("xKIGTxTT",8) == 4238852883) strcat(s, "G");
if (crc32("srupRy",6) == 371368915) strcat(s, "i");
if (crc32("IfBHu",5) == 3864886506) strcat(s, "g");
if (crc32("LyRAju",6) == 615713014) strcat(s, "m");
if (crc32("sdggTioB",8) == 2134477533) strcat(s, "i");
if (crc32("TyCjAEbU",8) == 378503145) strcat(s, "i");
if (crc32("dZQuUny",7) == 2931968294) strcat(s, "n");
if (crc32("qomRiQIVx",9) == 2312781214) strcat(s, "a");
if (crc32("aeUstUKKwSZCU",13) == 3629722531) strcat(s, "l");
if (crc32("bVOKjFTDePgp",12) == 1520439277) strcat(s, "l");
if (crc32("lbtsQQMG",8) == 1663970210) strcat(s, "y");
    return s;
}

char *spikily_adverbs() {
    char *s = calloc(8);
    if (crc32("AmgDrJyvOsQG",12) == 2691695750) strcat(s, "V");
if (crc32("zUsSp",5) == 515332417) strcat(s, "s");
if (crc32("ksiqyjUqZucUP",13) == 3812945329) strcat(s, "p");
if (crc32("eXKTTffXTwbdmk",14) == 2097804019) strcat(s, "C");
if (crc32("OVNiUBJ",7) == 1780745975) strcat(s, "i");
if (crc32("ZKgSikjlAVAs",12) == 4166758004) strcat(s, "k");
if (crc32("NMIyCyHKPry",11) == 1625764855) strcat(s, "i");
if (crc32("wfbpdUc",7) == 1522123753) strcat(s, "T");
if (crc32("hCCTHSILsZanOPb",15) == 131255191) strcat(s, "l");
if (crc32("JHVfNKRJ",8) == 2143193378) strcat(s, "y");
    return s;
}

char *nonfunctionally_adverbs() {
    char *s = calloc(16);
    if (crc32("fREAH",5) == 1307839358) strcat(s, "j");
if (crc32("evfORQUVuidrL",13) == 884743898) strcat(s, "n");
if (crc32("FbtTeDTzyK",10) == 2264124308) strcat(s, "I");
if (crc32("KqFepBSs",8) == 2476874786) strcat(s, "o");
if (crc32("zYgOfSZHnmVObNj",15) == 1793440568) strcat(s, "n");
if (crc32("VARZDgU",7) == 3105936464) strcat(s, "f");
if (crc32("aoksyn",6) == 579927979) strcat(s, "c");
if (crc32("KEyUFiJgJAgc",12) == 2690193520) strcat(s, "u");
if (crc32("TmJzllPZVP",10) == 4465528) strcat(s, "n");
if (crc32("cqHHhxlG",8) == 2136026811) strcat(s, "c");
if (crc32("zDaZKQK",7) == 562737769) strcat(s, "O");
if (crc32("ZmTLXgLq",8) == 2035702176) strcat(s, "t");
if (crc32("MTotuGncFz",10) == 2151362544) strcat(s, "i");
if (crc32("XSfku",5) == 538885785) strcat(s, "a");
if (crc32("AvkPMuhlkAtWrz",14) == 2413645030) strcat(s, "o");
if (crc32("clPKh",5) == 903973508) strcat(s, "o");
if (crc32("LYNxrsvQ",8) == 2737137073) strcat(s, "n");
if (crc32("feZJogeWeEYK",12) == 975467624) strcat(s, "a");
if (crc32("kIqzEABmK",9) == 531831572) strcat(s, "a");
if (crc32("dQPSoZHjp",9) == 3649668483) strcat(s, "l");
if (crc32("lheKH",5) == 1105519642) strcat(s, "l");
if (crc32("VaisMa",6) == 2696682162) strcat(s, "y");
    return s;
}

char *catalytically_adverbs() {
    char *s = calloc(14);
    if (crc32("XmRgkaXIlEL",11) == 480645629) strcat(s, "c");
if (crc32("lhUmBiENnJP",11) == 3025244768) strcat(s, "a");
if (crc32("WDkvxhlrgjB",11) == 4124493547) strcat(s, "t");
if (crc32("SrlBx",5) == 2784742620) strcat(s, "a");
if (crc32("zWpeabxhuBY",11) == 595735068) strcat(s, "j");
if (crc32("pDjILTsfkL",10) == 2143262487) strcat(s, "l");
if (crc32("kReHpJAmYPZW",12) == 2997578822) strcat(s, "O");
if (crc32("iNiDhIxl",8) == 503414248) strcat(s, "y");
if (crc32("jXMIe",5) == 2134425780) strcat(s, "t");
if (crc32("stYwjXkzlBpVq",13) == 1795910146) strcat(s, "y");
if (crc32("OUrunlGSfNjd",12) == 761166105) strcat(s, "i");
if (crc32("sIpZerk",7) == 3165448970) strcat(s, "c");
if (crc32("ZbjHiJLv",8) == 2726835840) strcat(s, "a");
if (crc32("XaLbn",5) == 59319323) strcat(s, "u");
if (crc32("ibNQIdmob",9) == 3079677154) strcat(s, "l");
if (crc32("NPbNyQtguhQfJ",13) == 864371720) strcat(s, "l");
if (crc32("DQluzxQTdcog",12) == 3867891931) strcat(s, "w");
if (crc32("ojAhdbcZc",9) == 29362962) strcat(s, "y");
    return s;
}

char *embarrassedly_adverbs() {
    char *s = calloc(14);
    if (crc32("bqQAGkitXFB",11) == 2432911171) strcat(s, "B");
if (crc32("CJjTPLqKLk",10) == 4083649573) strcat(s, "e");
if (crc32("UayBXusHPlTNI",13) == 3877371362) strcat(s, "m");
if (crc32("xjiPDVqC",8) == 2265911883) strcat(s, "b");
if (crc32("qiwEVnojlSmAnq",14) == 3124469377) strcat(s, "a");
if (crc32("SBsUuTep",8) == 1870743764) strcat(s, "r");
if (crc32("lGsDgGPcyL",10) == 4279249723) strcat(s, "r");
if (crc32("BLKkbOEqoupDYtW",15) == 1263192303) strcat(s, "g");
if (crc32("TKmKTsMwW",9) == 1804885609) strcat(s, "a");
if (crc32("oMmQyAYuqmnKA",13) == 1289333014) strcat(s, "s");
if (crc32("utomJZgbduCYuAa",15) == 420237961) strcat(s, "K");
if (crc32("DJtxtucXBkgX",12) == 3797173869) strcat(s, "s");
if (crc32("vrHrt",5) == 2074604426) strcat(s, "b");
if (crc32("ZnLVdg",6) == 1365355713) strcat(s, "e");
if (crc32("fQcAmCNx",8) == 3841474361) strcat(s, "g");
if (crc32("jAlpluTrO",9) == 498859340) strcat(s, "d");
if (crc32("mqwopqoYgn",10) == 3022918478) strcat(s, "l");
if (crc32("aRSyd",5) == 3651967454) strcat(s, "y");
    return s;
}

char *preluxuriously_adverbs() {
    char *s = calloc(15);
    if (crc32("FgyTWfr",7) == 3304375885) strcat(s, "x");
if (crc32("jcKlTOPlbAkDJbj",15) == 2191137838) strcat(s, "p");
if (crc32("VNLDECzYzKv",11) == 3439035575) strcat(s, "g");
if (crc32("ZQKrfWHPZdG",11) == 3348323905) strcat(s, "r");
if (crc32("AVKAXUiqlADwwPd",15) == 4267568096) strcat(s, "h");
if (crc32("cvzdTVerPDZY",12) == 1985306393) strcat(s, "e");
if (crc32("beoFXJuUWSbZKJ",14) == 2759150304) strcat(s, "l");
if (crc32("gDnUxuHFcCKKyUS",15) == 2287932934) strcat(s, "P");
if (crc32("rbSYzS",6) == 2310868229) strcat(s, "u");
if (crc32("mtKkFmeBEeaMR",13) == 4090483573) strcat(s, "y");
if (crc32("bPRBJULFDRRFW",13) == 462335246) strcat(s, "x");
if (crc32("mJYEFSsjUSi",11) == 1316244044) strcat(s, "u");
if (crc32("PzCHKePtHD",10) == 172807261) strcat(s, "r");
if (crc32("ZypDPWVBlAV",11) == 940135992) strcat(s, "i");
if (crc32("MSPiWcpYr",9) == 4208677459) strcat(s, "K");
if (crc32("hxVgRzNyzlZeeZ",14) == 906564753) strcat(s, "o");
if (crc32("Nhzmwj",6) == 2756086223) strcat(s, "u");
if (crc32("mSNSmrzm",8) == 925610217) strcat(s, "m");
if (crc32("RbgLaqOkMJft",12) == 2663298738) strcat(s, "s");
if (crc32("vUQjxcu",7) == 2222186078) strcat(s, "L");
if (crc32("IwOoVMm",7) == 4259022031) strcat(s, "l");
if (crc32("FbDja",5) == 4043204148) strcat(s, "X");
if (crc32("TanFmxgyPavN",12) == 2820090498) strcat(s, "y");
    return s;
}

char *pratingly_adverbs() {
    char *s = calloc(10);
    if (crc32("OqntUHVtTFRZK",13) == 3246186029) strcat(s, "m");
if (crc32("ojFYRZQ",7) == 457903341) strcat(s, "p");
if (crc32("ufIqy",5) == 2313881373) strcat(s, "r");
if (crc32("ORJisCtwvd",10) == 1649468769) strcat(s, "a");
if (crc32("ulvasnjntC",10) == 396583050) strcat(s, "t");
if (crc32("UpIuRuhunfV",11) == 3947280830) strcat(s, "i");
if (crc32("UtWYEPZfqPZHPE",14) == 841324241) strcat(s, "v");
if (crc32("XdXLhnllJ",9) == 2142582427) strcat(s, "n");
if (crc32("CKMrLFQCqstf",12) == 2542689730) strcat(s, "g");
if (crc32("xsvwoHyqQGDujy",14) == 1929214003) strcat(s, "l");
if (crc32("WbbLmemBriI",11) == 1017276366) strcat(s, "U");
if (crc32("QheFHgy",7) == 1848157974) strcat(s, "y");
    return s;
}

char *bushily_adverbs() {
    char *s = calloc(8);
    if (crc32("seTYnW",6) == 2154692152) strcat(s, "U");
if (crc32("xgnOHoKtu",9) == 1324285053) strcat(s, "b");
if (crc32("HKyvXvuM",8) == 3183907263) strcat(s, "M");
if (crc32("SccenJIVpAToyk",14) == 4163505981) strcat(s, "u");
if (crc32("GLrQglI",7) == 3463744972) strcat(s, "U");
if (crc32("VisSldRuTzwRr",13) == 2306421235) strcat(s, "s");
if (crc32("UmQsRwzybJNxEaP",15) == 2928245900) strcat(s, "h");
if (crc32("hyzLsB",6) == 1080398079) strcat(s, "i");
if (crc32("yXdLJTwzrI",10) == 696337380) strcat(s, "l");
if (crc32("hDArcd",6) == 3909738990) strcat(s, "c");
if (crc32("PfYyKG",6) == 3173939891) strcat(s, "y");
    return s;
}

char *uncordially_adverbs() {
    char *s = calloc(12);
    if (crc32("nZWJQhD",7) == 1777883248) strcat(s, "S");
if (crc32("SIzzOaAbOyQA",12) == 3648346544) strcat(s, "u");
if (crc32("MRnKA",5) == 143272600) strcat(s, "E");
if (crc32("AzjHbLMJUtZEogK",15) == 855136959) strcat(s, "n");
if (crc32("ykISBTiJMmaaqC",14) == 1796928409) strcat(s, "c");
if (crc32("gwpSkotKGznM",12) == 3507159222) strcat(s, "b");
if (crc32("IBnMa",5) == 2683820863) strcat(s, "o");
if (crc32("rfaLzXlpCnVq",12) == 483110355) strcat(s, "H");
if (crc32("qQgcBDHz",8) == 2246538910) strcat(s, "r");
if (crc32("TjgTDKiKUxuIK",13) == 2382187403) strcat(s, "d");
if (crc32("NTIkvbIzPEx",11) == 1865911077) strcat(s, "a");
if (crc32("tRTWtXDPhV",10) == 3097768200) strcat(s, "i");
if (crc32("baXcUXv",7) == 3923421357) strcat(s, "w");
if (crc32("CjFYnTm",7) == 2412450552) strcat(s, "a");
if (crc32("OKPtVn",6) == 3203467745) strcat(s, "l");
if (crc32("osAYWYWkA",9) == 2528174497) strcat(s, "X");
if (crc32("dSIJGazXPPP",11) == 1366714463) strcat(s, "l");
if (crc32("USLDSHLKLfDNyw",14) == 2868542619) strcat(s, "y");
    return s;
}

char *thuddingly_adverbs() {
    char *s = calloc(11);
    if (crc32("KmOrVI",6) == 3256622915) strcat(s, "t");
if (crc32("QuYTKmfHIC",10) == 3826632147) strcat(s, "k");
if (crc32("GnGUcWU",7) == 2622790395) strcat(s, "h");
if (crc32("pCYoOzw",7) == 3472458342) strcat(s, "u");
if (crc32("cJOaC",5) == 823274445) strcat(s, "i");
if (crc32("AkQNm",5) == 2131873039) strcat(s, "d");
if (crc32("osGSTR",6) == 2323287857) strcat(s, "m");
if (crc32("UqiYW",5) == 1008902842) strcat(s, "d");
if (crc32("vCepdMjDfEOe",12) == 4164734493) strcat(s, "p");
if (crc32("uWMgsRtPTC",10) == 1876352391) strcat(s, "i");
if (crc32("BJDxkRXLg",9) == 24335304) strcat(s, "N");
if (crc32("cjiegozHlpsnPBi",15) == 2637763968) strcat(s, "n");
if (crc32("cixPtPCgGgulVv",14) == 458966867) strcat(s, "Z");
if (crc32("kYiEsTl",7) == 3419422791) strcat(s, "g");
if (crc32("hEIZlQX",7) == 702367650) strcat(s, "Y");
if (crc32("vieQIddEemoMKKg",15) == 3547038225) strcat(s, "l");
if (crc32("OVeNePEAeG",10) == 1288108375) strcat(s, "y");
    return s;
}

char *woodenly_adverbs() {
    char *s = calloc(9);
    if (crc32("PwQefK",6) == 431661246) strcat(s, "w");
if (crc32("AwFccy",6) == 2916337617) strcat(s, "o");
if (crc32("qbiRFJsNcs",10) == 1853942760) strcat(s, "c");
if (crc32("sanvcmUtmFYnwEE",15) == 338580073) strcat(s, "o");
if (crc32("bhomLTTTPRIXfb",14) == 3729122380) strcat(s, "d");
if (crc32("LJUnWFsNHUFX",12) == 3133579256) strcat(s, "a");
if (crc32("SfWKWvc",7) == 1408752211) strcat(s, "e");
if (crc32("nBZvuIs",7) == 2182026746) strcat(s, "n");
if (crc32("DWxWlQyrxiSLfC",14) == 3885459368) strcat(s, "l");
if (crc32("AxfcelE",7) == 2503373572) strcat(s, "L");
if (crc32("kXYGSObEUI",10) == 3083420354) strcat(s, "y");
    return s;
}

char *cheekily_adverbs() {
    char *s = calloc(9);
    if (crc32("jcxyHIcMgSwcs",13) == 1415644115) strcat(s, "c");
if (crc32("gvHjY",5) == 1579479430) strcat(s, "r");
if (crc32("oUTXrQOdGpplYSu",15) == 3835905526) strcat(s, "h");
if (crc32("oTLdjiyEQK",10) == 4241470023) strcat(s, "X");
if (crc32("FkfCSDsgvfpDX",13) == 1707270909) strcat(s, "e");
if (crc32("XJgqS",5) == 3006684690) strcat(s, "e");
if (crc32("TXyJEmiuKA",10) == 1517822407) strcat(s, "s");
if (crc32("IHKwl",5) == 2513706388) strcat(s, "k");
if (crc32("OKQqJCsXzQsgymc",15) == 3939813786) strcat(s, "i");
if (crc32("ogvGzlI",7) == 438081890) strcat(s, "l");
if (crc32("yVhhE",5) == 835775477) strcat(s, "y");
    return s;
}

char *noninferentially_adverbs() {
    char *s = calloc(17);
    if (crc32("zcMptMEUBtEDNDL",15) == 1653767329) strcat(s, "n");
if (crc32("IxHhD",5) == 2673278216) strcat(s, "o");
if (crc32("JYBajSKTjbsme",13) == 237014342) strcat(s, "k");
if (crc32("yTZavVkUjsxO",12) == 1412220387) strcat(s, "n");
if (crc32("WxyeFicGcaS",11) == 267598703) strcat(s, "i");
if (crc32("ZZiGdoJhm",9) == 624804142) strcat(s, "n");
if (crc32("KQjmwBlsgjYaqyT",15) == 866222267) strcat(s, "G");
if (crc32("cnhqkdkCVWs",11) == 3280902767) strcat(s, "f");
if (crc32("AaNUbqVu",8) == 2901965844) strcat(s, "U");
if (crc32("WDlRxd",6) == 3201008575) strcat(s, "e");
if (crc32("eexkeCBLztRJet",14) == 1449701507) strcat(s, "r");
if (crc32("mByfks",6) == 854817888) strcat(s, "e");
if (crc32("XTmFWp",6) == 2217223729) strcat(s, "n");
if (crc32("nXfuwwnwOIGACBU",15) == 281007507) strcat(s, "v");
if (crc32("njXgc",5) == 672373724) strcat(s, "t");
if (crc32("QEEjWXqSmtFzH",13) == 3835346797) strcat(s, "u");
if (crc32("RIGKSHtrLLpEPN",14) == 737693303) strcat(s, "i");
if (crc32("TUYQwe",6) == 1358157232) strcat(s, "a");
if (crc32("hngONz",6) == 1887050326) strcat(s, "l");
if (crc32("nwWlrPmy",8) == 2428877715) strcat(s, "l");
if (crc32("tVfvDe",6) == 1910405108) strcat(s, "y");
    return s;
}

char *riotously_adverbs() {
    char *s = calloc(10);
    if (crc32("QGAYxzBh",8) == 4207850157) strcat(s, "r");
if (crc32("pCoCp",5) == 2123039206) strcat(s, "i");
if (crc32("eNapVmDaAA",10) == 1737387376) strcat(s, "g");
if (crc32("Osuvuael",8) == 739774379) strcat(s, "o");
if (crc32("AXngUlUJuLK",11) == 3960306264) strcat(s, "i");
if (crc32("IdbFq",5) == 3992394518) strcat(s, "t");
if (crc32("IwaNXvkFHqJ",11) == 726239127) strcat(s, "H");
if (crc32("VTRUSngHQQDwaR",14) == 189399703) strcat(s, "o");
if (crc32("hRKVwOmJ",8) == 3420369793) strcat(s, "u");
if (crc32("shxSTAdvxpendf",14) == 2265068757) strcat(s, "s");
if (crc32("ptMhMSvKuoZ",11) == 3899938857) strcat(s, "l");
if (crc32("mzQvfuppWIXGR",13) == 3538897474) strcat(s, "y");
    return s;
}

char *militarily_adverbs() {
    char *s = calloc(11);
    if (crc32("zPlRgsErW",9) == 3265124945) strcat(s, "T");
if (crc32("JZtsW",5) == 3526653661) strcat(s, "m");
if (crc32("KPbhlERGe",9) == 2459920162) strcat(s, "J");
if (crc32("LZazmImQLFqJ",12) == 2711164490) strcat(s, "i");
if (crc32("zrRZjAXfHY",10) == 3894031729) strcat(s, "l");
if (crc32("dETsuMrrwwCi",12) == 3266792053) strcat(s, "i");
if (crc32("CgbmNdghThLbPOB",15) == 555430092) strcat(s, "Y");
if (crc32("uoYRSMOgl",9) == 2706246318) strcat(s, "t");
if (crc32("WAVjBYNkCrWRwk",14) == 1343381052) strcat(s, "L");
if (crc32("BswFHjqtmpv",11) == 2883540533) strcat(s, "a");
if (crc32("EVduMbTwL",9) == 3055126454) strcat(s, "Y");
if (crc32("GMHBrZamKRJUkKG",15) == 358553478) strcat(s, "r");
if (crc32("bJxOsq",6) == 283141643) strcat(s, "i");
if (crc32("pbeCTnSFZEwBKMk",15) == 182376648) strcat(s, "l");
if (crc32("sfHLGaIAD",9) == 3087854134) strcat(s, "y");
    return s;
}

char *unsportively_adverbs() {
    char *s = calloc(13);
    if (crc32("mhAVcVmzs",9) == 123532214) strcat(s, "O");
if (crc32("WZdzBtxwb",9) == 3201465089) strcat(s, "u");
if (crc32("oxBdd",5) == 1268501950) strcat(s, "n");
if (crc32("qXyRtxm",7) == 628483451) strcat(s, "s");
if (crc32("SWxTbe",6) == 3729045536) strcat(s, "T");
if (crc32("SBqNoARfONSUut",14) == 3583222750) strcat(s, "p");
if (crc32("OrCcPEgw",8) == 1771386421) strcat(s, "O");
if (crc32("HXmGRzLaj",9) == 334245988) strcat(s, "o");
if (crc32("wqnJOCJGzEd",11) == 944845456) strcat(s, "r");
if (crc32("Pndiuui",7) == 2661677125) strcat(s, "S");
if (crc32("mnbQYa",6) == 2386016471) strcat(s, "t");
if (crc32("pXDNyHA",7) == 624604060) strcat(s, "i");
if (crc32("PGHPfeEfx",9) == 3452654109) strcat(s, "v");
if (crc32("lySDJIdHlUBI",12) == 3797581685) strcat(s, "m");
if (crc32("NZaSrtNlUhM",11) == 1668801753) strcat(s, "e");
if (crc32("sEibz",5) == 1312539728) strcat(s, "I");
if (crc32("VxTBHp",6) == 4251161645) strcat(s, "l");
if (crc32("vLyHEaFvAAtjX",13) == 3045828796) strcat(s, "y");
    return s;
}

char *noncasuistically_adverbs() {
    char *s = calloc(17);
    if (crc32("ybIIRd",6) == 622387944) strcat(s, "n");
if (crc32("uoOmt",5) == 2940734828) strcat(s, "K");
if (crc32("cBJCJ",5) == 436065896) strcat(s, "o");
if (crc32("jxFkX",5) == 746949210) strcat(s, "n");
if (crc32("HPsLgOGi",8) == 2738634345) strcat(s, "U");
if (crc32("fWNXznS",7) == 3716281450) strcat(s, "c");
if (crc32("ZmzUljfHDYi",11) == 686550282) strcat(s, "a");
if (crc32("OiVhnAZzq",9) == 444055446) strcat(s, "s");
if (crc32("OIBKeqoMQP",10) == 3957705883) strcat(s, "X");
if (crc32("WZyvJfDTlXSz",12) == 465224652) strcat(s, "u");
if (crc32("eETVgx",6) == 567551722) strcat(s, "i");
if (crc32("zZkJnrbOpj",10) == 3193054561) strcat(s, "Q");
if (crc32("VthogR",6) == 1971819023) strcat(s, "s");
if (crc32("DjNqbVIfwTvgs",13) == 3916977304) strcat(s, "Z");
if (crc32("cKGQsdfpj",9) == 1968855992) strcat(s, "t");
if (crc32("gMnrGJwRzboLr",13) == 3405801553) strcat(s, "i");
if (crc32("TdrCWQOxJiCBX",13) == 1695773153) strcat(s, "c");
if (crc32("AgAjEYlulaC",11) == 3878323732) strcat(s, "S");
if (crc32("YAbIeCPuwAhgLj",14) == 1529080563) strcat(s, "a");
if (crc32("hZMtesuLg",9) == 1395509521) strcat(s, "E");
if (crc32("AIDlXfS",7) == 682557250) strcat(s, "l");
if (crc32("iHLmogi",7) == 1767861342) strcat(s, "l");
if (crc32("XSzUfJWFy",9) == 3306225438) strcat(s, "Q");
if (crc32("pLFIeCMCWurqyQp",15) == 2468981484) strcat(s, "y");
    return s;
}

char *quasigravely_adverbs() {
    char *s = calloc(13);
    if (crc32("GKNSASlbZK",10) == 3444563041) strcat(s, "q");
if (crc32("guYGbsZwACOGJAO",15) == 2256566740) strcat(s, "B");
if (crc32("LYjdEpPo",8) == 4144871644) strcat(s, "u");
if (crc32("sBaMGFKojYNC",12) == 2071617318) strcat(s, "a");
if (crc32("rYFiSBPcu",9) == 2728864255) strcat(s, "W");
if (crc32("yxYmeAr",7) == 3872858321) strcat(s, "s");
if (crc32("MSHiFofbkDnbd",13) == 2795014354) strcat(s, "z");
if (crc32("OfHZuYA",7) == 86636359) strcat(s, "i");
if (crc32("bdqNJZip",8) == 897628172) strcat(s, "W");
if (crc32("JVmxe",5) == 2687949265) strcat(s, "g");
if (crc32("aGRVXcxH",8) == 2704334022) strcat(s, "n");
if (crc32("hSeoO",5) == 4240591231) strcat(s, "r");
if (crc32("CqBid",5) == 1533839350) strcat(s, "I");
if (crc32("IXRrwsKwet",10) == 3729243779) strcat(s, "a");
if (crc32("PsublZkYAumlBw",14) == 2986653857) strcat(s, "g");
if (crc32("QpuvBDFXAQOoul",14) == 3389780948) strcat(s, "v");
if (crc32("TKYLTarZ",8) == 292978326) strcat(s, "V");
if (crc32("mDxsJbbc",8) == 4211191818) strcat(s, "e");
if (crc32("InXCxMxuPVucKDs",15) == 3566477096) strcat(s, "i");
if (crc32("CvBidEOOky",10) == 1950335291) strcat(s, "l");
if (crc32("AiQigfkXDNfjEde",15) == 2187784095) strcat(s, "x");
if (crc32("CGJiN",5) == 2279866735) strcat(s, "y");
    return s;
}

char *corpulently_adverbs() {
    char *s = calloc(12);
    if (crc32("LteQwxqyRHrzK",13) == 4071365244) strcat(s, "G");
if (crc32("jUyJzrDmZQZW",12) == 1042315711) strcat(s, "c");
if (crc32("ANSEqkKLrziijKg",15) == 2155269187) strcat(s, "o");
if (crc32("DMrMCqPTRyOPvk",14) == 2172119256) strcat(s, "d");
if (crc32("oICnTTUX",8) == 2668790388) strcat(s, "r");
if (crc32("tjvQFZkUpJwmgni",15) == 2720692544) strcat(s, "w");
if (crc32("oJRTMWpufWnRVuo",15) == 265826991) strcat(s, "p");
if (crc32("ZZIzuxJ",7) == 986465675) strcat(s, "j");
if (crc32("bWwabvyX",8) == 4193647617) strcat(s, "u");
if (crc32("OyzSEw",6) == 2451117162) strcat(s, "l");
if (crc32("VrcFY",5) == 1789697436) strcat(s, "h");
if (crc32("EydprItPnAL",11) == 732278261) strcat(s, "e");
if (crc32("KhumdWlXRqipTs",14) == 1976697646) strcat(s, "n");
if (crc32("wwjCQjlTFGsMUQ",14) == 850316223) strcat(s, "t");
if (crc32("wSiLHVpwKrcFXyV",15) == 1561168234) strcat(s, "l");
if (crc32("RimtcRlSyH",10) == 1860703339) strcat(s, "c");
if (crc32("GnVcQAzdPRC",11) == 1234351195) strcat(s, "y");
    return s;
}

char *designingly_adverbs() {
    char *s = calloc(12);
    if (crc32("HbJWNrObsuMBGGG",15) == 3611646356) strcat(s, "X");
if (crc32("UGErYjWWzpJT",12) == 1313606320) strcat(s, "d");
if (crc32("BGnMsxGOyncKOIU",15) == 2615544162) strcat(s, "e");
if (crc32("bfuYC",5) == 2181926286) strcat(s, "W");
if (crc32("gTFdUHvLcXJa",12) == 739640973) strcat(s, "s");
if (crc32("EZyJbwoqOU",10) == 2069450491) strcat(s, "i");
if (crc32("lwozJj",6) == 1997469691) strcat(s, "N");
if (crc32("LDibxnWXxPDziAg",15) == 1370659542) strcat(s, "g");
if (crc32("SDpBIHUZwAlA",12) == 3407108172) strcat(s, "T");
if (crc32("tphIoRw",7) == 3293600488) strcat(s, "n");
if (crc32("QvUhWWvlYPjq",12) == 2068361810) strcat(s, "n");
if (crc32("crFUCalBYmkMohL",15) == 2185201962) strcat(s, "i");
if (crc32("vBZCduwfAhDmr",13) == 437344406) strcat(s, "K");
if (crc32("ozXAAvZFyU",10) == 1167678888) strcat(s, "n");
if (crc32("OSKxjNyk",8) == 563961953) strcat(s, "g");
if (crc32("yPkMzPvNQhD",11) == 3279294149) strcat(s, "l");
if (crc32("sVpmTlYoRLyjsU",14) == 4241420103) strcat(s, "y");
    return s;
}

char *apathetically_adverbs() {
    char *s = calloc(14);
    if (crc32("DoFmsUwSpU",10) == 603687939) strcat(s, "a");
if (crc32("hBGNnzpWdM",10) == 1102844218) strcat(s, "T");
if (crc32("RfGxvR",6) == 1188511094) strcat(s, "p");
if (crc32("iyKhTG",6) == 1447392328) strcat(s, "a");
if (crc32("JsXtnWxiicZrNB",14) == 2105905355) strcat(s, "t");
if (crc32("eIVKkDC",7) == 2830220325) strcat(s, "h");
if (crc32("pGuWuquWNb",10) == 3176104795) strcat(s, "v");
if (crc32("BHLURH",6) == 3505317094) strcat(s, "e");
if (crc32("yhjmIpvbtYzaZ",13) == 2326072645) strcat(s, "t");
if (crc32("UshTae",6) == 3106437701) strcat(s, "G");
if (crc32("SmlksI",6) == 1679480701) strcat(s, "i");
if (crc32("iowGlUl",7) == 4124344762) strcat(s, "c");
if (crc32("aBwubnAIMeUk",12) == 3368933797) strcat(s, "P");
if (crc32("goBfDkGIMQq",11) == 4131184934) strcat(s, "a");
if (crc32("uKjJT",5) == 2564111114) strcat(s, "l");
if (crc32("uewiIYfxqBYim",13) == 3288649976) strcat(s, "l");
if (crc32("rotquIIbX",9) == 1291235399) strcat(s, "r");
if (crc32("qArVtCI",7) == 4189002631) strcat(s, "y");
    return s;
}

char *afire_adverbs() {
    char *s = calloc(6);
    if (crc32("kLppLVT",7) == 4099293198) strcat(s, "n");
if (crc32("MexIEALSUalcNKm",15) == 211019760) strcat(s, "a");
if (crc32("JtKdZLZZcC",10) == 1869025062) strcat(s, "O");
if (crc32("veeoyYahpFUnrE",14) == 2853600702) strcat(s, "f");
if (crc32("HTdfashmhwhH",12) == 1281566863) strcat(s, "i");
if (crc32("WtjkXdoDfcdF",12) == 1646672004) strcat(s, "a");
if (crc32("HLPqbvPH",8) == 3609356072) strcat(s, "r");
if (crc32("ZmQLLyhQsqPr",12) == 3639160642) strcat(s, "g");
if (crc32("XnMnpTZShVqIO",13) == 3067300146) strcat(s, "e");
    return s;
}

char *tolerably_adverbs() {
    char *s = calloc(10);
    if (crc32("azGvuQ",6) == 1559047702) strcat(s, "k");
if (crc32("hhwVG",5) == 3289728073) strcat(s, "t");
if (crc32("ypfsobf",7) == 2938608057) strcat(s, "V");
if (crc32("jfMDvFs",7) == 3879841767) strcat(s, "o");
if (crc32("FFECzES",7) == 1544421422) strcat(s, "l");
if (crc32("rNsGiC",6) == 513337069) strcat(s, "d");
if (crc32("EYdEHXmNE",9) == 1450242560) strcat(s, "e");
if (crc32("xpZQRpPzRJKcRXU",15) == 3814302774) strcat(s, "r");
if (crc32("VkcjAJthAsizmh",14) == 1450999523) strcat(s, "a");
if (crc32("XidMXza",7) == 1300737237) strcat(s, "T");
if (crc32("oxzboWvSk",9) == 1097893096) strcat(s, "b");
if (crc32("ePVetEGK",8) == 2579739372) strcat(s, "l");
if (crc32("FynOb",5) == 1999951845) strcat(s, "l");
if (crc32("LnpsqOoNRg",10) == 3669627654) strcat(s, "y");
    return s;
}

char *nastily_adverbs() {
    char *s = calloc(8);
    if (crc32("iHNLtE",6) == 3105144574) strcat(s, "n");
if (crc32("oaxtPGiUNQFA",12) == 1113030479) strcat(s, "a");
if (crc32("awjbCiLnvltMPm",14) == 1509586079) strcat(s, "P");
if (crc32("aVEKDsyHpoJAL",13) == 2228901565) strcat(s, "s");
if (crc32("NRnWVxhdq",9) == 1423438078) strcat(s, "t");
if (crc32("GZGtd",5) == 4229439092) strcat(s, "i");
if (crc32("qZuFZLJCx",9) == 766380397) strcat(s, "I");
if (crc32("PRugRsaS",8) == 1300539542) strcat(s, "l");
if (crc32("nHVKe",5) == 383699668) strcat(s, "A");
if (crc32("JhHWzRrbaXM",11) == 2407534107) strcat(s, "y");
    return s;
}

char *idealistically_adverbs() {
    char *s = calloc(15);
    if (crc32("jypWdZvTnlDg",12) == 1102439462) strcat(s, "K");
if (crc32("bmUhT",5) == 1204380919) strcat(s, "i");
if (crc32("ZxeHczm",7) == 1502454549) strcat(s, "q");
if (crc32("UghJeyO",7) == 4061738284) strcat(s, "d");
if (crc32("pyesiKbqWOBBIdJ",15) == 15929856) strcat(s, "l");
if (crc32("EdsZySdhmfYp",12) == 3967095162) strcat(s, "e");
if (crc32("NAWbvIVvvx",10) == 752181878) strcat(s, "r");
if (crc32("dTYJseKpsDYVm",13) == 2124953857) strcat(s, "a");
if (crc32("qTDxKeVt",8) == 917109175) strcat(s, "l");
if (crc32("tclHBW",6) == 3352993530) strcat(s, "i");
if (crc32("ZuJGnCctalcJyLA",15) == 3615544043) strcat(s, "s");
if (crc32("HDMmB",5) == 529369658) strcat(s, "i");
if (crc32("ExUYKNoJ",8) == 4041546050) strcat(s, "t");
if (crc32("vVRGWXt",7) == 1288304220) strcat(s, "T");
if (crc32("FWQMnQN",7) == 3082561345) strcat(s, "i");
if (crc32("CuQPO",5) == 3023487224) strcat(s, "c");
if (crc32("QZfMdgStJ",9) == 1703236698) strcat(s, "a");
if (crc32("NjOSFECVxuSHOcW",15) == 1491862785) strcat(s, "w");
if (crc32("rkIRljpHmotK",12) == 367243997) strcat(s, "l");
if (crc32("dLuQhZ",6) == 1748346202) strcat(s, "x");
if (crc32("lNoNZkWIfyjJHZ",14) == 2694313130) strcat(s, "l");
if (crc32("fMsSytF",7) == 785026760) strcat(s, "y");
    return s;
}

char *unheavily_adverbs() {
    char *s = calloc(10);
    if (crc32("dFylTAY",7) == 784762244) strcat(s, "u");
if (crc32("pjxQifPRYtjx",12) == 553498090) strcat(s, "n");
if (crc32("rFdibSlpX",9) == 2086848303) strcat(s, "K");
if (crc32("CpZlkRo",7) == 4059841876) strcat(s, "h");
if (crc32("bOlecqxDkbTDk",13) == 619589420) strcat(s, "X");
if (crc32("yOWcOdnjxLIUvP",14) == 3995357645) strcat(s, "e");
if (crc32("wdXRlxY",7) == 264467605) strcat(s, "X");
if (crc32("sLklilNZaEzhrH",14) == 996684716) strcat(s, "a");
if (crc32("wzhAOwMVsXW",11) == 1690448751) strcat(s, "v");
if (crc32("YNpARjoQoSeov",13) == 2802186559) strcat(s, "i");
if (crc32("LcqDOhtzCYcKGrO",15) == 2841893988) strcat(s, "l");
if (crc32("RMWjMuupaowMd",13) == 3096507429) strcat(s, "y");
    return s;
}

char *warmly_adverbs() {
    char *s = calloc(7);
    if (crc32("TOffC",5) == 1790225243) strcat(s, "h");
if (crc32("QZNxUhHLvmjKg",13) == 1660204498) strcat(s, "w");
if (crc32("ZYiLqXpUTqScO",13) == 3895454469) strcat(s, "g");
if (crc32("ckQqCdNbkUkmOD",14) == 1019973008) strcat(s, "a");
if (crc32("BLOel",5) == 4158403455) strcat(s, "G");
if (crc32("DypOXIR",7) == 4258382117) strcat(s, "r");
if (crc32("psqgj",5) == 4211623559) strcat(s, "E");
if (crc32("HHpjWPHuGigvs",13) == 3630195862) strcat(s, "m");
if (crc32("XtrNXAiPvb",10) == 3932106402) strcat(s, "z");
if (crc32("haDOFvzGLA",10) == 4142212670) strcat(s, "l");
if (crc32("gxwYygBKCcOZyeX",15) == 613410084) strcat(s, "V");
if (crc32("KpVVdZeUVS",10) == 1073085160) strcat(s, "y");
    return s;
}

char *nontroppo_adverbs() {
    char *s = calloc(10);
    if (crc32("dldsoNSPFCsKm",13) == 3552284831) strcat(s, "i");
if (crc32("MCtoQaQxZ",9) == 143394249) strcat(s, "n");
if (crc32("ebEMYr",6) == 3122248997) strcat(s, "U");
if (crc32("DAoNKwvbtDQvzTO",15) == 3986944390) strcat(s, "o");
if (crc32("qewMpeqxtr",10) == 1232431364) strcat(s, "n");
if (crc32("ipDmdTwsd",9) == 2300135414) strcat(s, "t");
if (crc32("ZOucUxBkKaUdlFo",15) == 3139301456) strcat(s, "r");
if (crc32("wHEVXCu",7) == 100692664) strcat(s, "g");
if (crc32("GJtoWmlzO",9) == 874720974) strcat(s, "o");
if (crc32("rdDhBwRytJYCTr",14) == 2332666137) strcat(s, "p");
if (crc32("OPxkSdmTdAtKbdH",15) == 840878384) strcat(s, "a");
if (crc32("GpErQBmB",8) == 1052502265) strcat(s, "p");
if (crc32("NvKgVJrvcdRio",13) == 914328600) strcat(s, "o");
    return s;
}

char *quasiorganically_adverbs() {
    char *s = calloc(17);
    if (crc32("PDkCEM",6) == 195531307) strcat(s, "q");
if (crc32("SxaTRf",6) == 2412221557) strcat(s, "D");
if (crc32("MTDXYHnyaqsJyfj",15) == 1399210348) strcat(s, "u");
if (crc32("AlBZr",5) == 3739704291) strcat(s, "p");
if (crc32("NXDGr",5) == 1509481142) strcat(s, "a");
if (crc32("hpcVrLXt",8) == 2212531102) strcat(s, "E");
if (crc32("yWUbQmPYXOMHps",14) == 2653983427) strcat(s, "s");
if (crc32("XxMgoxIcyUKl",12) == 1564867524) strcat(s, "i");
if (crc32("pAVlPhBklKIYD",13) == 1564340842) strcat(s, "E");
if (crc32("sctstVwKSMBG",12) == 229502733) strcat(s, "o");
if (crc32("wgeGFLbxC",9) == 3689105018) strcat(s, "f");
if (crc32("VVrAws",6) == 3311022197) strcat(s, "r");
if (crc32("AmhDlKoVR",9) == 4106574499) strcat(s, "r");
if (crc32("uDPGNXoKkFdyUp",14) == 3394828173) strcat(s, "g");
if (crc32("ZFCBCjrBiEV",11) == 3356911126) strcat(s, "a");
if (crc32("aJYHKS",6) == 1229600612) strcat(s, "n");
if (crc32("JmOSSRC",7) == 3721287857) strcat(s, "o");
if (crc32("ixdzkJGP",8) == 276807605) strcat(s, "i");
if (crc32("NdehAKM",7) == 3233678451) strcat(s, "U");
if (crc32("iRuWiaTWS",9) == 3582253250) strcat(s, "c");
if (crc32("ILjnpngVWsr",11) == 2250280745) strcat(s, "a");
if (crc32("JWbVuK",6) == 4077744640) strcat(s, "T");
if (crc32("LNrUMzqVsCJNd",13) == 3827062639) strcat(s, "l");
if (crc32("droOqbdNN",9) == 4047305779) strcat(s, "J");
if (crc32("DQoEvhUlkOnkuR",14) == 496078278) strcat(s, "l");
if (crc32("VtGyPuFU",8) == 509571990) strcat(s, "H");
if (crc32("lFJznf",6) == 3945207024) strcat(s, "y");
    return s;
}

char *overprolifically_adverbs() {
    char *s = calloc(17);
    if (crc32("SKhmsSdweEQNkKl",15) == 3723151977) strcat(s, "o");
if (crc32("rxTHbgaiHKiniGn",15) == 361877587) strcat(s, "A");
if (crc32("NRGJSyJhZXA",11) == 2426755200) strcat(s, "v");
if (crc32("SQDweMKJuXw",11) == 169503901) strcat(s, "U");
if (crc32("FjyqYgPCpJg",11) == 821723843) strcat(s, "e");
if (crc32("mkUfnNVaweUUPg",14) == 3809845362) strcat(s, "w");
if (crc32("KEoFKiYaiTJ",11) == 1524884480) strcat(s, "r");
if (crc32("sPnrXFgrS",9) == 646437898) strcat(s, "I");
if (crc32("aeyeukduod",10) == 1510205634) strcat(s, "p");
if (crc32("eXIzMsvcaFpx",12) == 2162691341) strcat(s, "U");
if (crc32("MRYiBkBbXgxb",12) == 68867406) strcat(s, "r");
if (crc32("NLjqymToHNI",11) == 1083922258) strcat(s, "U");
if (crc32("waRujWRPX",9) == 3024378048) strcat(s, "o");
if (crc32("QyhTgeZFuROn",12) == 821594352) strcat(s, "h");
if (crc32("hszksslOyHpsYAw",15) == 2073566081) strcat(s, "l");
if (crc32("flnhLhRNHcjsGRH",15) == 2403438391) strcat(s, "U");
if (crc32("oLIjvjKKjejQ",12) == 3223289286) strcat(s, "i");
if (crc32("MYuYdB",6) == 2445860389) strcat(s, "f");
if (crc32("SKhLqQIBtin",11) == 2214703561) strcat(s, "M");
if (crc32("fUVRgVjQD",9) == 2278570010) strcat(s, "i");
if (crc32("tpuXkaSWaqW",11) == 2302089174) strcat(s, "C");
if (crc32("FDEOwXLiCteR",12) == 2785265207) strcat(s, "c");
if (crc32("elkgLpa",7) == 533571175) strcat(s, "a");
if (crc32("LVTPoT",6) == 3350082119) strcat(s, "w");
if (crc32("zQVzRMz",7) == 994615918) strcat(s, "l");
if (crc32("erxeyNcAMMn",11) == 247219974) strcat(s, "t");
if (crc32("EvuTzASLKC",10) == 3099607503) strcat(s, "l");
if (crc32("grabvi",6) == 2732827978) strcat(s, "y");
    return s;
}

char *nonsensically_adverbs() {
    char *s = calloc(14);
    if (crc32("sOyrxVT",7) == 1657790986) strcat(s, "e");
if (crc32("pDgRak",6) == 2027718073) strcat(s, "n");
if (crc32("JAIZeSwwakN",11) == 674825286) strcat(s, "o");
if (crc32("JjsHRUyG",8) == 1754984823) strcat(s, "q");
if (crc32("LhVihFFSz",9) == 4029907206) strcat(s, "n");
if (crc32("nqzRKWdNCVQe",12) == 2703128094) strcat(s, "s");
if (crc32("UrwVOs",6) == 1319580195) strcat(s, "e");
if (crc32("vxYzzEXpwuw",11) == 1151963640) strcat(s, "l");
if (crc32("scRhekmSrfdTo",13) == 2670820158) strcat(s, "n");
if (crc32("wLBSJqQ",7) == 1708530446) strcat(s, "O");
if (crc32("KaHEZvS",7) == 917368029) strcat(s, "s");
if (crc32("KoLubUPSBmM",11) == 2582203880) strcat(s, "R");
if (crc32("TxJftDvJiE",10) == 4096109450) strcat(s, "i");
if (crc32("ptiRAKQzAMw",11) == 254914183) strcat(s, "G");
if (crc32("oNXmoZucXqaRP",13) == 534655331) strcat(s, "c");
if (crc32("kmsHVIhxUh",10) == 2355212058) strcat(s, "S");
if (crc32("IpkYTGErUVUPq",13) == 2461412657) strcat(s, "a");
if (crc32("XMeOW",5) == 1808625057) strcat(s, "l");
if (crc32("UgAMDg",6) == 1523906139) strcat(s, "G");
if (crc32("RbpOUIArbHtx",12) == 623338793) strcat(s, "l");
if (crc32("yHfGuXaKwrZdSC",14) == 3383722693) strcat(s, "y");
    return s;
}

char *unmordantly_adverbs() {
    char *s = calloc(12);
    if (crc32("WTscQiVoOfZcVK",14) == 1476516883) strcat(s, "q");
if (crc32("nWIaaTqySvhF",12) == 2260502700) strcat(s, "u");
if (crc32("BuBDbWrjx",9) == 3855728420) strcat(s, "D");
if (crc32("EBfMiXEqoNwY",12) == 2166634968) strcat(s, "n");
if (crc32("tzWYgqrZd",9) == 246730407) strcat(s, "E");
if (crc32("EslWyxkXYkpBT",13) == 2487340636) strcat(s, "m");
if (crc32("lAIhwyDkoLm",11) == 1509718537) strcat(s, "o");
if (crc32("iCoFWJFmtBAHm",13) == 3943473622) strcat(s, "r");
if (crc32("TIEKhj",6) == 971418998) strcat(s, "H");
if (crc32("sDDlUBDdkUeDmEA",15) == 3497947108) strcat(s, "d");
if (crc32("RHgcmC",6) == 756434837) strcat(s, "d");
if (crc32("RQhdqWmgqBYEbEs",15) == 3105688701) strcat(s, "a");
if (crc32("NFWLUcRPl",9) == 2728196315) strcat(s, "A");
if (crc32("hfWdujf",7) == 2887167951) strcat(s, "n");
if (crc32("mlsJdAizjpYJcMR",15) == 4143576333) strcat(s, "e");
if (crc32("gnSNkHLVdiJsUmK",15) == 288286923) strcat(s, "t");
if (crc32("EHcbFOYczPj",11) == 1231291948) strcat(s, "b");
if (crc32("vOnwrw",6) == 4013261289) strcat(s, "l");
if (crc32("mQLlYoSh",8) == 3426209532) strcat(s, "J");
if (crc32("YtDJDFuuqA",10) == 1010210618) strcat(s, "y");
    return s;
}

char *unwildly_adverbs() {
    char *s = calloc(9);
    if (crc32("WLScWBbq",8) == 3102698309) strcat(s, "u");
if (crc32("bNBSSFC",7) == 393968105) strcat(s, "M");
if (crc32("nTcJWXqwMkIdkLX",15) == 1323957936) strcat(s, "n");
if (crc32("MiThyCFrXU",10) == 2720832335) strcat(s, "w");
if (crc32("FdKnhtMBsdin",12) == 348142134) strcat(s, "i");
if (crc32("TvCoFr",6) == 2186116464) strcat(s, "l");
if (crc32("VLJouWCLODS",11) == 3696653250) strcat(s, "k");
if (crc32("hgGYc",5) == 59132305) strcat(s, "d");
if (crc32("aGZBJq",6) == 1884266485) strcat(s, "F");
if (crc32("vZWNGE",6) == 2336908057) strcat(s, "l");
if (crc32("ERaWsRuZZGYrvX",14) == 438504650) strcat(s, "G");
if (crc32("uptyjdZvql",10) == 294816956) strcat(s, "y");
    return s;
}

char *unauspiciously_adverbs() {
    char *s = calloc(15);
    if (crc32("RoqYhyCtNNQ",11) == 2715835765) strcat(s, "u");
if (crc32("UFRVhvwlKiUM",12) == 1605899475) strcat(s, "n");
if (crc32("LiwyJdHtW",9) == 528948794) strcat(s, "e");
if (crc32("yRZMSqxlAP",10) == 2007986882) strcat(s, "a");
if (crc32("jxOHtv",6) == 1099332659) strcat(s, "J");
if (crc32("bAokuP",6) == 2408145368) strcat(s, "u");
if (crc32("lElcLSRXYL",10) == 2365031802) strcat(s, "r");
if (crc32("qWmTybILOzfB",12) == 3038653442) strcat(s, "s");
if (crc32("qBgrFYdR",8) == 3954636837) strcat(s, "p");
if (crc32("MdlDogQRo",9) == 3234273514) strcat(s, "p");
if (crc32("moEAoDSqpdfpg",13) == 3314313137) strcat(s, "I");
if (crc32("dGdynkjLzMXWve",14) == 3501898563) strcat(s, "i");
if (crc32("oDhqnsNnEC",10) == 3738997610) strcat(s, "c");
if (crc32("OLMwkCw",7) == 3739941924) strcat(s, "w");
if (crc32("TXmbZvZNEu",10) == 1701448333) strcat(s, "i");
if (crc32("wAucbO",6) == 1705942480) strcat(s, "o");
if (crc32("UirpGFnvtjgvDiv",15) == 2317972804) strcat(s, "u");
if (crc32("XPVofUwRCYEVpdR",15) == 2648063669) strcat(s, "O");
if (crc32("eyqUQGVEEqDXlsk",15) == 1857170176) strcat(s, "s");
if (crc32("KoGyMIjMn",9) == 4066808883) strcat(s, "l");
if (crc32("hOAMuFh",7) == 1621507854) strcat(s, "y");
    return s;
}

char *unwilfully_adverbs() {
    char *s = calloc(11);
    if (crc32("KVPyR",5) == 1581277147) strcat(s, "H");
if (crc32("iYyGqlwHabjJdo",14) == 2621606262) strcat(s, "u");
if (crc32("IJLLnIL",7) == 2992999374) strcat(s, "n");
if (crc32("ClHygjgvYVZu",12) == 2811161824) strcat(s, "Z");
if (crc32("SRBIDp",6) == 4081949333) strcat(s, "w");
if (crc32("AWxCpvb",7) == 4019081914) strcat(s, "n");
if (crc32("KHyirK",6) == 300471377) strcat(s, "i");
if (crc32("BfjTxXnrQF",10) == 2676787466) strcat(s, "l");
if (crc32("gMDxQoDyYbtnX",13) == 3366364299) strcat(s, "f");
if (crc32("HCMTchxFvJ",10) == 4264051967) strcat(s, "u");
if (crc32("fefWB",5) == 4258934396) strcat(s, "l");
if (crc32("lTnoOCPIYYHZG",13) == 2127973723) strcat(s, "l");
if (crc32("KwUxVWLantiqhC",14) == 1712224416) strcat(s, "y");
    return s;
}

char *periodically_adverbs() {
    char *s = calloc(13);
    if (crc32("DEYHgqobHxdkC",13) == 3559812309) strcat(s, "p");
if (crc32("GtCgYC",6) == 4015522105) strcat(s, "e");
if (crc32("MNyIWTva",8) == 3305070217) strcat(s, "r");
if (crc32("HXMxGizMWM",10) == 3445228033) strcat(s, "i");
if (crc32("fYJnXh",6) == 3716644891) strcat(s, "o");
if (crc32("YBjJneZ",7) == 2682769130) strcat(s, "d");
if (crc32("sWLRlQAzMUdgJb",14) == 921304890) strcat(s, "i");
if (crc32("BUGihFWRlGblxE",14) == 720176166) strcat(s, "c");
if (crc32("HDDzJcJxJ",9) == 56315144) strcat(s, "a");
if (crc32("lZXGdDVWPcNU",12) == 2968375155) strcat(s, "U");
if (crc32("GQUhefUwwQyBga",14) == 634811754) strcat(s, "l");
if (crc32("PpKeLKGcxvskKL",14) == 2910661159) strcat(s, "l");
if (crc32("cTqudSvOG",9) == 961868228) strcat(s, "y");
    return s;
}

char *plumosely_adverbs() {
    char *s = calloc(10);
    if (crc32("MXJcEBandAXsOn",14) == 3310434163) strcat(s, "V");
if (crc32("udhRmkBAaafk",12) == 2142358062) strcat(s, "p");
if (crc32("pAsWmvTGFYi",11) == 2774175403) strcat(s, "l");
if (crc32("xQukFB",6) == 74089651) strcat(s, "Q");
if (crc32("ZenIDF",6) == 3793562324) strcat(s, "u");
if (crc32("RGMQOLACGwVxO",13) == 141942691) strcat(s, "m");
if (crc32("UbUyRsUgO",9) == 2352214955) strcat(s, "o");
if (crc32("qpSZOspnQeqAOtj",15) == 711495262) strcat(s, "s");
if (crc32("gsUyafP",7) == 326977776) strcat(s, "f");
if (crc32("fFmGKeY",7) == 3180890171) strcat(s, "e");
if (crc32("poKYBtfXDUQObj",14) == 4144649606) strcat(s, "l");
if (crc32("jGxTOfrcaNM",11) == 2501924485) strcat(s, "O");
if (crc32("IZNsRGyDmlEoMk",14) == 788838421) strcat(s, "y");
    return s;
}

char *supernegligently_adverbs() {
    char *s = calloc(17);
    if (crc32("SRDyKXdJNA",10) == 4072562760) strcat(s, "s");
if (crc32("RFqPgloNoWGVxZG",15) == 2224645248) strcat(s, "u");
if (crc32("nmZFFHghWBqNp",13) == 1944767398) strcat(s, "N");
if (crc32("SJhcKMIM",8) == 2034534687) strcat(s, "p");
if (crc32("VHZir",5) == 1154405948) strcat(s, "e");
if (crc32("PHTzzNaf",8) == 1553659494) strcat(s, "Q");
if (crc32("lMCxjBfqhnv",11) == 1859942788) strcat(s, "r");
if (crc32("SdQfHbEOupJlqg",14) == 2236154066) strcat(s, "n");
if (crc32("gyYVb",5) == 2635639856) strcat(s, "X");
if (crc32("xZVocUg",7) == 1701027598) strcat(s, "e");
if (crc32("exnOCZdUeQP",11) == 2447539524) strcat(s, "N");
if (crc32("UeazoYFy",8) == 1584576105) strcat(s, "g");
if (crc32("aWSejMJlxYcbi",13) == 4033607005) strcat(s, "l");
if (crc32("hSsyXTZPjIJpc",13) == 216285011) strcat(s, "d");
if (crc32("XhXLWoz",7) == 2333491561) strcat(s, "i");
if (crc32("EXZBzforfw",10) == 304224246) strcat(s, "e");
if (crc32("pyVgHwXABbgghC",14) == 3656831903) strcat(s, "g");
if (crc32("bwlklHq",7) == 2045305702) strcat(s, "e");
if (crc32("RiQUYqEkm",9) == 2301835112) strcat(s, "n");
if (crc32("MMnZCxoaq",9) == 2758215248) strcat(s, "t");
if (crc32("qnfNfbSClBaAbQL",15) == 1185206996) strcat(s, "u");
if (crc32("GQMxpzKleAnFx",13) == 2899428987) strcat(s, "l");
if (crc32("TjKWCTdg",8) == 1148711789) strcat(s, "y");
    return s;
}

char *tastelessly_adverbs() {
    char *s = calloc(12);
    if (crc32("ysbBxJBv",8) == 1823202711) strcat(s, "l");
if (crc32("POywWpMWWwVym",13) == 2194881690) strcat(s, "t");
if (crc32("apkzCm",6) == 3601727796) strcat(s, "a");
if (crc32("cVXWf",5) == 3310541320) strcat(s, "s");
if (crc32("BlWHJsWP",8) == 2021061821) strcat(s, "m");
if (crc32("KLuwJ",5) == 2626589892) strcat(s, "t");
if (crc32("xAjeSrvygeftM",13) == 4014070555) strcat(s, "e");
if (crc32("YnImUBsnWWEXVRw",15) == 1023189405) strcat(s, "l");
if (crc32("gwxetVt",7) == 3899765544) strcat(s, "e");
if (crc32("mshrcuhIylCe",12) == 1451985716) strcat(s, "s");
if (crc32("LEtoCKI",7) == 1075095189) strcat(s, "s");
if (crc32("qXjNQp",6) == 2766491977) strcat(s, "l");
if (crc32("GSkyFvldxvn",11) == 810936905) strcat(s, "y");
    return s;
}

char *oversparingly_adverbs() {
    char *s = calloc(14);
    if (crc32("JBEPjAE",7) == 3456959256) strcat(s, "o");
if (crc32("QbojC",5) == 3300638103) strcat(s, "X");
if (crc32("fbtdKvCT",8) == 951449398) strcat(s, "v");
if (crc32("tORQYMFMNwqVgt",14) == 3384924940) strcat(s, "e");
if (crc32("zRtAjZar",8) == 4001718902) strcat(s, "r");
if (crc32("joMsUcfEAaIB",12) == 71130950) strcat(s, "p");
if (crc32("pQAIIQtMKFMA",12) == 440932951) strcat(s, "s");
if (crc32("oGutnCFi",8) == 499477941) strcat(s, "m");
if (crc32("mTmybgynbomJC",13) == 780418880) strcat(s, "p");
if (crc32("lOGSI",5) == 3000256988) strcat(s, "a");
if (crc32("dIDzfaqlPkO",11) == 136594722) strcat(s, "N");
if (crc32("YNvngJ",6) == 3441971760) strcat(s, "r");
if (crc32("PXHLBbThgFwea",13) == 1677693460) strcat(s, "i");
if (crc32("ZJeLnVNMtfFCbo",14) == 3640609675) strcat(s, "n");
if (crc32("muOaTkN",7) == 151218496) strcat(s, "g");
if (crc32("aZbjspozr",9) == 564930629) strcat(s, "l");
if (crc32("TulsYQnK",8) == 2725339466) strcat(s, "L");
if (crc32("JLyKxDehzeXHUQG",15) == 3426540642) strcat(s, "y");
    return s;
}

char *quasiexceptionally_adverbs() {
    char *s = calloc(19);
    if (crc32("DqnGpcsDCgxNkoa",15) == 2522186279) strcat(s, "l");
if (crc32("sflYrMEbHzV",11) == 3235701424) strcat(s, "q");
if (crc32("SqmDWDgHDPplAH",14) == 1609484802) strcat(s, "u");
if (crc32("KVTTshLpP",9) == 1146910659) strcat(s, "b");
if (crc32("HNoiamxeyaedTc",14) == 1634236558) strcat(s, "a");
if (crc32("FvWCwcDrzmRfL",13) == 2561687796) strcat(s, "s");
if (crc32("cwhHfgRAxKBjoUF",15) == 2272723270) strcat(s, "b");
if (crc32("SSTFBvjfrE",10) == 1002251623) strcat(s, "i");
if (crc32("oSrBUnpcGcJnWu",14) == 2345619754) strcat(s, "e");
if (crc32("WtrFhmON",8) == 3417430628) strcat(s, "h");
if (crc32("TqMCRxzNhdt",11) == 3104567806) strcat(s, "x");
if (crc32("YKoQeU",6) == 3100641423) strcat(s, "c");
if (crc32("gSzpFd",6) == 1729056304) strcat(s, "e");
if (crc32("SaqDMBZewlHCDCt",15) == 2151198129) strcat(s, "X");
if (crc32("SYDfMQL",7) == 3009829888) strcat(s, "p");
if (crc32("mDuzZbgzYBAl",12) == 3363174796) strcat(s, "t");
if (crc32("UkwdeXjmuqACsb",14) == 3939955229) strcat(s, "L");
if (crc32("duYXKP",6) == 3218701130) strcat(s, "i");
if (crc32("leDKpvS",7) == 2217864579) strcat(s, "k");
if (crc32("lJqhhhFYikDwe",13) == 103417867) strcat(s, "o");
if (crc32("OWzjDapokkRmyvh",15) == 3913613382) strcat(s, "n");
if (crc32("myMegpnhSivqK",13) == 3236811446) strcat(s, "a");
if (crc32("VazfdrbYB",9) == 1065160619) strcat(s, "e");
if (crc32("VljzSrQBkNJHDy",14) == 815885134) strcat(s, "l");
if (crc32("LzNmREUnqqJax",13) == 3253408821) strcat(s, "f");
if (crc32("eVLUWGBIjOz",11) == 1763640389) strcat(s, "l");
if (crc32("akjawWN",7) == 3081126381) strcat(s, "y");
    return s;
}

char *overhighly_adverbs() {
    char *s = calloc(11);
    if (crc32("LhOCQ",5) == 424487648) strcat(s, "o");
if (crc32("rzaMcVnuUCG",11) == 2530414058) strcat(s, "v");
if (crc32("ytSBCkPoAjLU",12) == 920693527) strcat(s, "e");
if (crc32("OoivSzfmEm",10) == 2529882257) strcat(s, "r");
if (crc32("GFYzqRHPTsQYPF",14) == 618491940) strcat(s, "k");
if (crc32("XjzUnFJpuU",10) == 3223705018) strcat(s, "h");
if (crc32("OKUXoygmd",9) == 3476210517) strcat(s, "u");
if (crc32("jAuiUmmJAmUhFLb",15) == 3622174458) strcat(s, "i");
if (crc32("GrHWKfoQbhH",11) == 3903142183) strcat(s, "G");
if (crc32("NrhqvRcfMuG",11) == 1456982702) strcat(s, "g");
if (crc32("jQDMKqElKzHmPTy",15) == 4216697282) strcat(s, "V");
if (crc32("zcSnYOPgHbsdJ",13) == 3733610531) strcat(s, "h");
if (crc32("ATzDLUKJldd",11) == 168147523) strcat(s, "l");
if (crc32("lbQHIT",6) == 1837342641) strcat(s, "y");
    return s;
}

char *revengefully_adverbs() {
    char *s = calloc(13);
    if (crc32("bpbwZERqdGSNSR",14) == 3160044305) strcat(s, "r");
if (crc32("RQPCeYZQd",9) == 3505353645) strcat(s, "v");
if (crc32("TOoBJp",6) == 3065400466) strcat(s, "e");
if (crc32("stAmHATnkgFE",12) == 312306196) strcat(s, "v");
if (crc32("GDbNSpjDeYG",11) == 1762446552) strcat(s, "e");
if (crc32("XFGtmLGoIROqHvD",15) == 2338081811) strcat(s, "e");
if (crc32("zTAWdEKcqUzj",12) == 576221256) strcat(s, "n");
if (crc32("zSfEKi",6) == 1585840567) strcat(s, "U");
if (crc32("WNFfvisGCRwVY",13) == 312790420) strcat(s, "g");
if (crc32("UAjNwr",6) == 3642725316) strcat(s, "k");
if (crc32("nMzfpARn",8) == 28631537) strcat(s, "e");
if (crc32("GyxIjSARBtjG",12) == 2687381380) strcat(s, "c");
if (crc32("hLFlOyBSi",9) == 1025491353) strcat(s, "f");
if (crc32("PksDxRFQO",9) == 239738390) strcat(s, "Y");
if (crc32("xhuaqrJyag",10) == 1795915347) strcat(s, "u");
if (crc32("IZUsEzxxDx",10) == 1080853602) strcat(s, "M");
if (crc32("nmYYUyXveP",10) == 4161378444) strcat(s, "l");
if (crc32("PErFXvBns",9) == 1351349609) strcat(s, "l");
if (crc32("dbjYMChfFdn",11) == 3248640111) strcat(s, "j");
if (crc32("heMMwKNAHYcxCH",14) == 1591762832) strcat(s, "y");
    return s;
}

char *shrinkingly_adverbs() {
    char *s = calloc(12);
    if (crc32("pMBQQrylOeTI",12) == 1959603635) strcat(s, "l");
if (crc32("jYrIiQZweOzPQEJ",15) == 434972341) strcat(s, "s");
if (crc32("AWpXVUtpaD",10) == 3018567615) strcat(s, "F");
if (crc32("odJLtiXiRGH",11) == 2495567284) strcat(s, "h");
if (crc32("NUrCWlPi",8) == 3903047170) strcat(s, "r");
if (crc32("wctQoeQl",8) == 3859540786) strcat(s, "o");
if (crc32("xpAhslbA",8) == 4126025015) strcat(s, "i");
if (crc32("ctQtGUMJhllM",12) == 4000239986) strcat(s, "r");
if (crc32("zoLZTBIAj",9) == 1664180894) strcat(s, "n");
if (crc32("njJkCZpqOQZ",11) == 3366113374) strcat(s, "k");
if (crc32("vrCoizHmZOqk",12) == 3600556491) strcat(s, "i");
if (crc32("IXObcE",6) == 2585243292) strcat(s, "S");
if (crc32("vTfEnhaAmGL",11) == 3143789801) strcat(s, "n");
if (crc32("rrOZcLEdPuvMDmR",15) == 520201466) strcat(s, "I");
if (crc32("EmGznGDSROTFC",13) == 695402517) strcat(s, "g");
if (crc32("WHsEDpachKylpuG",15) == 738463504) strcat(s, "l");
if (crc32("UnJrtqnmnB",10) == 1206343701) strcat(s, "y");
    return s;
}

char *musicologically_adverbs() {
    char *s = calloc(16);
    if (crc32("rKCRYJnxGCDKdWV",15) == 400193477) strcat(s, "m");
if (crc32("FpyYuMytGBcN",12) == 92713366) strcat(s, "z");
if (crc32("ciapXZRQSW",10) == 590251114) strcat(s, "u");
if (crc32("wtOolCEk",8) == 1790874447) strcat(s, "s");
if (crc32("QqODHCITtP",10) == 1135871480) strcat(s, "i");
if (crc32("geqnjfDLDaS",11) == 1934518778) strcat(s, "o");
if (crc32("XbhkVFWvTgBNq",13) == 3753103038) strcat(s, "c");
if (crc32("piLueGQkWpro",12) == 3798326175) strcat(s, "V");
if (crc32("kibpzsbqRGp",11) == 2661283430) strcat(s, "o");
if (crc32("GuDsdhXzdyidG",13) == 3307058358) strcat(s, "N");
if (crc32("ebOKjQgVptjcW",13) == 3694970884) strcat(s, "l");
if (crc32("kPbhVA",6) == 3509829429) strcat(s, "o");
if (crc32("zZPuBiNeQezAZZ",14) == 1834480527) strcat(s, "G");
if (crc32("SZMbR",5) == 3083700910) strcat(s, "g");
if (crc32("fsrRsttqDzRVUw",14) == 3208533658) strcat(s, "i");
if (crc32("EHPuknO",7) == 1429842989) strcat(s, "c");
if (crc32("eJwvYAPBIVzIc",13) == 954532774) strcat(s, "w");
if (crc32("cxwfvt",6) == 1656697787) strcat(s, "a");
if (crc32("yilxUrOP",8) == 4291316537) strcat(s, "V");
if (crc32("tuTmpdlD",8) == 2580358352) strcat(s, "l");
if (crc32("eQloKbHlLluqHxL",15) == 3143618547) strcat(s, "y");
if (crc32("XFuWnKWQYTG",11) == 3441387896) strcat(s, "l");
if (crc32("rmqCiOev",8) == 572498371) strcat(s, "y");
    return s;
}

char *uncritically_adverbs() {
    char *s = calloc(13);
    if (crc32("CTRUBqcfOPYfQ",13) == 3871640459) strcat(s, "u");
if (crc32("RQVvZeHCwCWvBJS",15) == 893627001) strcat(s, "I");
if (crc32("wbjXcHSNow",10) == 3183524123) strcat(s, "n");
if (crc32("IANoreYsf",9) == 3504185299) strcat(s, "c");
if (crc32("YhvViqQI",8) == 2793220526) strcat(s, "S");
if (crc32("yUoVPv",6) == 1706393883) strcat(s, "r");
if (crc32("KZgTie",6) == 1558765646) strcat(s, "b");
if (crc32("IMipzg",6) == 758109089) strcat(s, "i");
if (crc32("fUMHWlDdQwc",11) == 1842630718) strcat(s, "A");
if (crc32("FuTCRt",6) == 2963736306) strcat(s, "t");
if (crc32("hWzHMOPPoAnd",12) == 399857194) strcat(s, "i");
if (crc32("EzRTWqpKiLfxsvb",15) == 3608942346) strcat(s, "m");
if (crc32("AXyxfonX",8) == 3064526560) strcat(s, "c");
if (crc32("SwNlRpcWrsKbi",13) == 449854243) strcat(s, "a");
if (crc32("tnomueveLN",10) == 604734519) strcat(s, "H");
if (crc32("KqWejBorum",10) == 977417730) strcat(s, "l");
if (crc32("aowMoOkahciLu",13) == 3095410400) strcat(s, "l");
if (crc32("cDPILtGvVAOtE",13) == 3828557103) strcat(s, "k");
if (crc32("QiRuTaPaZJvHt",13) == 874338872) strcat(s, "y");
    return s;
}

char *seclusively_adverbs() {
    char *s = calloc(12);
    if (crc32("xIleATnNuIvpMVD",15) == 588535208) strcat(s, "c");
if (crc32("FcmtZaCJ",8) == 676258409) strcat(s, "s");
if (crc32("ZisHnOXAmNNCv",13) == 3515495027) strcat(s, "e");
if (crc32("RHFcIzso",8) == 4161809765) strcat(s, "U");
if (crc32("zbYSsXvRpJhRA",13) == 1503438605) strcat(s, "c");
if (crc32("enQPAmcCGEfmWEC",15) == 4064758042) strcat(s, "l");
if (crc32("xnVHqPjiSzn",11) == 926718102) strcat(s, "N");
if (crc32("WkjGfZoH",8) == 365439167) strcat(s, "u");
if (crc32("MPYokyWj",8) == 722876489) strcat(s, "s");
if (crc32("rBYEV",5) == 3910223305) strcat(s, "I");
if (crc32("AzJarEsx",8) == 792138127) strcat(s, "i");
if (crc32("WaNVdl",6) == 4224405674) strcat(s, "k");
if (crc32("DMWMPBXbOuqcR",13) == 2992986012) strcat(s, "v");
if (crc32("EcVLtziFxzRfhlQ",15) == 68047977) strcat(s, "s");
if (crc32("rfjQAyQi",8) == 543892338) strcat(s, "e");
if (crc32("teNnCQRbcdAwLFp",15) == 930430012) strcat(s, "l");
if (crc32("syfrVqJrFYGKQe",14) == 2214279933) strcat(s, "y");
    return s;
}

char *unprofusely_adverbs() {
    char *s = calloc(12);
    if (crc32("ZynuFpbHYNumEKm",15) == 3939478959) strcat(s, "J");
if (crc32("CqqjlrzzxfA",11) == 1322777923) strcat(s, "u");
if (crc32("fSogZvsIPPZ",11) == 2268604808) strcat(s, "n");
if (crc32("cVXuCNb",7) == 385738542) strcat(s, "p");
if (crc32("ElhoDrEkikeOw",13) == 3739735858) strcat(s, "r");
if (crc32("xYXsAyYnrxyj",12) == 1619474422) strcat(s, "o");
if (crc32("lsvIzMmioRnmr",13) == 4163496796) strcat(s, "f");
if (crc32("npKcGE",6) == 3320113630) strcat(s, "u");
if (crc32("nrKbxKHekVL",11) == 1559937177) strcat(s, "s");
if (crc32("fglEqgQDQXs",11) == 2370901442) strcat(s, "k");
if (crc32("IvIJdSuvLu",10) == 1222456339) strcat(s, "e");
if (crc32("sqfVOPycV",9) == 2134949223) strcat(s, "G");
if (crc32("MZkWeuSk",8) == 2905295139) strcat(s, "l");
if (crc32("gBYna",5) == 1322769111) strcat(s, "N");
if (crc32("nMxZZZVan",9) == 3664531566) strcat(s, "y");
    return s;
}

char *nonantagonistically_adverbs() {
    char *s = calloc(20);
    if (crc32("eTcRhBySCyS",11) == 2159274489) strcat(s, "H");
if (crc32("syxMMFcRvVBFftg",15) == 731476413) strcat(s, "n");
if (crc32("FAmErDXXml",10) == 4156741118) strcat(s, "o");
if (crc32("FGfOgj",6) == 1702621284) strcat(s, "X");
if (crc32("QKVYZflKqAax",12) == 3220176075) strcat(s, "n");
if (crc32("BflnnZbb",8) == 1091145228) strcat(s, "I");
if (crc32("KKFiwcAHYz",10) == 1727424092) strcat(s, "a");
if (crc32("DpdocVsll",9) == 2759032958) strcat(s, "n");
if (crc32("VtQqsdsKfa",10) == 2723980107) strcat(s, "x");
if (crc32("GJUjdaWR",8) == 2752442890) strcat(s, "t");
if (crc32("ltrMIHzpULWng",13) == 2534291341) strcat(s, "i");
if (crc32("wjqaLsVnI",9) == 3264304772) strcat(s, "a");
if (crc32("LvdJuYcPKZ",10) == 2345318715) strcat(s, "A");
if (crc32("OKjRQEJ",7) == 2387599309) strcat(s, "g");
if (crc32("lGyIxRble",9) == 969187747) strcat(s, "o");
if (crc32("pNrSuqusejoxcd",14) == 755600706) strcat(s, "n");
if (crc32("JsfrsbxAFQuNY",13) == 252931236) strcat(s, "x");
if (crc32("UGPSiRuHqt",10) == 1867773989) strcat(s, "i");
if (crc32("SNQYTte",7) == 340479570) strcat(s, "s");
if (crc32("zyazWWb",7) == 299475184) strcat(s, "y");
if (crc32("XJQgSbbqqrJkTQ",14) == 1435577960) strcat(s, "t");
if (crc32("CXnknsoHPj",10) == 994606616) strcat(s, "z");
if (crc32("zZKqsTAXLQWNPeQ",15) == 3822687109) strcat(s, "i");
if (crc32("FmVSzE",6) == 58902035) strcat(s, "B");
if (crc32("PBvWHipcDR",10) == 1631615120) strcat(s, "c");
if (crc32("WNykJaBbXn",10) == 1007410298) strcat(s, "a");
if (crc32("HcvJA",5) == 3691216403) strcat(s, "l");
if (crc32("rOBtYfXLIrmarf",14) == 2746963812) strcat(s, "P");
if (crc32("DNIGXnB",7) == 1247389225) strcat(s, "l");
if (crc32("pPzmhPqlx",9) == 4264275540) strcat(s, "q");
if (crc32("iyanfTj",7) == 4012831496) strcat(s, "y");
    return s;
}

char *quasipeacefully_adverbs() {
    char *s = calloc(16);
    if (crc32("PwKLzQAyLFVuqZw",15) == 3816202056) strcat(s, "q");
if (crc32("bUVCV",5) == 4205689502) strcat(s, "a");
if (crc32("mNhawqrrIsMExi",14) == 784233034) strcat(s, "u");
if (crc32("hNgFy",5) == 1139634183) strcat(s, "m");
if (crc32("PQtzVMh",7) == 523526476) strcat(s, "a");
if (crc32("fttDScu",7) == 4258811181) strcat(s, "s");
if (crc32("nrzGep",6) == 972441925) strcat(s, "i");
if (crc32("cmFugXD",7) == 1447159733) strcat(s, "p");
if (crc32("iRHFH",5) == 2477381713) strcat(s, "e");
if (crc32("YRkqGLItwNLmrwb",15) == 832285371) strcat(s, "Y");
if (crc32("xxTsAWowAxXlB",13) == 488824871) strcat(s, "a");
if (crc32("rrDylfaDXx",10) == 677439845) strcat(s, "m");
if (crc32("dDLgTmkxbC",10) == 1891471942) strcat(s, "c");
if (crc32("DaHOyet",7) == 740553194) strcat(s, "C");
if (crc32("hzKAq",5) == 3645757094) strcat(s, "e");
if (crc32("QhZeb",5) == 3636820781) strcat(s, "m");
if (crc32("bRvbIqNRV",9) == 3220870251) strcat(s, "f");
if (crc32("XKgKRL",6) == 1407573399) strcat(s, "u");
if (crc32("fwEEmnoIBOGlYv",14) == 48740756) strcat(s, "T");
if (crc32("NruveDsPkEYIi",13) == 2867975165) strcat(s, "l");
if (crc32("plZgPVteKn",10) == 216594083) strcat(s, "G");
if (crc32("poxArSCBD",9) == 2674567837) strcat(s, "l");
if (crc32("QPkaWJdTj",9) == 3739987669) strcat(s, "y");
    return s;
}

char *dolorously_adverbs() {
    char *s = calloc(11);
    if (crc32("ByVyPi",6) == 761336221) strcat(s, "C");
if (crc32("GTUneQwBH",9) == 118498668) strcat(s, "d");
if (crc32("GCbDpIiiLpKdpyY",15) == 4001885369) strcat(s, "o");
if (crc32("HakuUL",6) == 4028631372) strcat(s, "l");
if (crc32("HTJBsbHdLqot",12) == 2089984179) strcat(s, "o");
if (crc32("swbTXUIfPA",10) == 778753221) strcat(s, "r");
if (crc32("Mztqfc",6) == 412088338) strcat(s, "b");
if (crc32("BfitPePEQJhdgRa",15) == 4194556970) strcat(s, "o");
if (crc32("OwcgZlfZBRCwGQz",15) == 2389245833) strcat(s, "u");
if (crc32("IyXIDusxFWTuUp",14) == 2121388739) strcat(s, "x");
if (crc32("KMpPHzx",7) == 2952707112) strcat(s, "s");
if (crc32("XXQGnMAJYbnJN",13) == 3386716689) strcat(s, "E");
if (crc32("lCqmNNOSWe",10) == 4075488403) strcat(s, "l");
if (crc32("HetGh",5) == 233837440) strcat(s, "y");
    return s;
}

char *unpredicatively_adverbs() {
    char *s = calloc(16);
    if (crc32("uFUnRnYdW",9) == 4261777972) strcat(s, "u");
if (crc32("dlCCR",5) == 110928246) strcat(s, "S");
if (crc32("BsAnvrecGCH",11) == 2478845374) strcat(s, "n");
if (crc32("wLQjWeiScbqVe",13) == 1406467594) strcat(s, "p");
if (crc32("HyxtLkN",7) == 3631507589) strcat(s, "u");
if (crc32("rtPUMlNwi",9) == 2421641760) strcat(s, "r");
if (crc32("CkHYIKGk",8) == 1644311367) strcat(s, "e");
if (crc32("AkklKdr",7) == 1659904887) strcat(s, "O");
if (crc32("YsGzsI",6) == 1887845504) strcat(s, "d");
if (crc32("HqaBjiW",7) == 3150556672) strcat(s, "i");
if (crc32("JyEZAIM",7) == 1024966441) strcat(s, "c");
if (crc32("RknFZuhfi",9) == 1525356539) strcat(s, "a");
if (crc32("rPZoXhX",7) == 1372086741) strcat(s, "t");
if (crc32("YWFtOQ",6) == 2524585602) strcat(s, "i");
if (crc32("QBeslwoEYYcUaX",14) == 1703819550) strcat(s, "v");
if (crc32("ZTNcRkIrqChw",12) == 2005837097) strcat(s, "e");
if (crc32("sFmrFdgdw",9) == 2378300191) strcat(s, "l");
if (crc32("kvcUFe",6) == 2105311927) strcat(s, "y");
    return s;
}

char *aplanatically_adverbs() {
    char *s = calloc(14);
    if (crc32("hgrfoImukxhT",12) == 1445142636) strcat(s, "l");
if (crc32("zobuHIfWapaG",12) == 635633502) strcat(s, "a");
if (crc32("gWWtJDRD",8) == 1930326765) strcat(s, "u");
if (crc32("APIONRVWMuU",11) == 3257469029) strcat(s, "p");
if (crc32("rRBXnzyDqfR",11) == 1962566924) strcat(s, "l");
if (crc32("KDgEtFCxqYkqa",13) == 2376246862) strcat(s, "a");
if (crc32("rCvXFCMQnRRds",13) == 799876118) strcat(s, "H");
if (crc32("uwvcPbbTJnja",12) == 1551620741) strcat(s, "n");
if (crc32("hbrXfXTP",8) == 1429230137) strcat(s, "V");
if (crc32("zcPyNEMVJu",10) == 3308186243) strcat(s, "a");
if (crc32("DNuErYObs",9) == 2872637362) strcat(s, "W");
if (crc32("cypPaNj",7) == 3007869368) strcat(s, "t");
if (crc32("ERhZSy",6) == 756813609) strcat(s, "P");
if (crc32("gdytPTUz",8) == 925809862) strcat(s, "i");
if (crc32("AQvgrRQHsLEyhA",14) == 3218147853) strcat(s, "h");
if (crc32("fYJBhEj",7) == 460883550) strcat(s, "c");
if (crc32("dLBfCeyIfV",10) == 3936165497) strcat(s, "x");
if (crc32("mchSSBDxh",9) == 3132143611) strcat(s, "a");
if (crc32("KZuEJErdM",9) == 2146289022) strcat(s, "l");
if (crc32("agAmFLyMFxgP",12) == 835267029) strcat(s, "r");
if (crc32("HFbAWkFynwr",11) == 3673368228) strcat(s, "l");
if (crc32("LtKFUU",6) == 1114632955) strcat(s, "O");
if (crc32("wAvqZQgGUn",10) == 139648512) strcat(s, "y");
    return s;
}

char *braggingly_adverbs() {
    char *s = calloc(11);
    if (crc32("WjZZtP",6) == 2367000777) strcat(s, "O");
if (crc32("gDCrvsVBWDAlLO",14) == 2998544941) strcat(s, "b");
if (crc32("lwIdAEn",7) == 1889963538) strcat(s, "r");
if (crc32("uzgya",5) == 2309036973) strcat(s, "O");
if (crc32("owqiairoaGwGz",13) == 2656424109) strcat(s, "a");
if (crc32("eJjrCQzOcohu",12) == 1386911016) strcat(s, "g");
if (crc32("hBbqXMuGDzpJ",12) == 257976345) strcat(s, "g");
if (crc32("VutSzdhXRYM",11) == 3986716333) strcat(s, "i");
if (crc32("YFmhq",5) == 1422822336) strcat(s, "R");
if (crc32("VNVAQvWvVbBEQ",13) == 1847968657) strcat(s, "n");
if (crc32("LYOGdsJNrs",10) == 2668008271) strcat(s, "d");
if (crc32("ElDdkLWnMlGL",12) == 3460776284) strcat(s, "g");
if (crc32("aikirtsmEoyJIHP",15) == 477487887) strcat(s, "S");
if (crc32("RxuFEqHr",8) == 1588132720) strcat(s, "l");
if (crc32("ZlgNUXpPeM",10) == 2058721900) strcat(s, "y");
    return s;
}

char *obediently_adverbs() {
    char *s = calloc(11);
    if (crc32("OwXgPvRi",8) == 1343044896) strcat(s, "o");
if (crc32("FPYpkTRTcCKruC",14) == 3478435723) strcat(s, "b");
if (crc32("ossJWONzuBKy",12) == 1127016133) strcat(s, "j");
if (crc32("tFSXEGqIKyXBcrl",15) == 638581326) strcat(s, "e");
if (crc32("gLuiMVbevjdTiFU",15) == 1443964450) strcat(s, "f");
if (crc32("bLXnsQRZ",8) == 2774526173) strcat(s, "d");
if (crc32("fDyQAPA",7) == 3707226575) strcat(s, "Y");
if (crc32("BByHXEnAAZFUM",13) == 3406846664) strcat(s, "i");
if (crc32("NDnzKyPVBb",10) == 1047279808) strcat(s, "e");
if (crc32("uTxaTAiZJtYP",12) == 4273042153) strcat(s, "f");
if (crc32("VzbERnMdFRqnO",13) == 3383284901) strcat(s, "n");
if (crc32("pKqblQE",7) == 2782783555) strcat(s, "t");
if (crc32("eStOyFcCJJ",10) == 965531038) strcat(s, "l");
if (crc32("NVrzHeCxpdpk",12) == 2711185880) strcat(s, "M");
if (crc32("BsFzVp",6) == 383643986) strcat(s, "y");
    return s;
}

char *undecadently_adverbs() {
    char *s = calloc(13);
    if (crc32("cAxfPZJHjk",10) == 652051990) strcat(s, "b");
if (crc32("deCSry",6) == 2701041924) strcat(s, "u");
if (crc32("iMLpekPa",8) == 495701039) strcat(s, "V");
if (crc32("NoFigRGIvIKsWGZ",15) == 1721606299) strcat(s, "n");
if (crc32("DtDnkqMf",8) == 2197821080) strcat(s, "K");
if (crc32("USJFQfugO",9) == 3116655242) strcat(s, "d");
if (crc32("VuCqPhlSrGK",11) == 136072023) strcat(s, "w");
if (crc32("DcMVLRHoDyVPcp",14) == 2817556508) strcat(s, "e");
if (crc32("kDTKJPMSQkQ",11) == 2417985032) strcat(s, "t");
if (crc32("DHuXvLvLjzdujVg",15) == 3638163912) strcat(s, "c");
if (crc32("auHsBBYa",8) == 2307255317) strcat(s, "a");
if (crc32("vjzPeHKBZu",10) == 2690632162) strcat(s, "d");
if (crc32("yYGEHcZJcJWGqN",14) == 3575949753) strcat(s, "x");
if (crc32("YjeFeCwYH",9) == 3824126791) strcat(s, "e");
if (crc32("IOLPSLPXY",9) == 1236804715) strcat(s, "n");
if (crc32("WNiNsZlqqDWGE",13) == 2600864548) strcat(s, "C");
if (crc32("JywrFGkSpqPDB",13) == 3551619259) strcat(s, "t");
if (crc32("jZRyyu",6) == 3290279700) strcat(s, "p");
if (crc32("TAtrrFHBfAboW",13) == 3170252202) strcat(s, "l");
if (crc32("JWHQzLCJ",8) == 3978967067) strcat(s, "y");
    return s;
}

char *unpresumptuously_adverbs() {
    char *s = calloc(17);
    if (crc32("lhDxNlgyETQNt",13) == 1171525430) strcat(s, "u");
if (crc32("RaarxLrCfPQuiJa",15) == 2289409917) strcat(s, "n");
if (crc32("wLztmiNuTahl",12) == 3774330724) strcat(s, "l");
if (crc32("rtyJlfNF",8) == 1643239514) strcat(s, "p");
if (crc32("AslgYa",6) == 416407749) strcat(s, "a");
if (crc32("qoQnxTjvYLDJ",12) == 2133505691) strcat(s, "r");
if (crc32("PDqXsWnW",8) == 1448448658) strcat(s, "e");
if (crc32("bsSIl",5) == 1461687700) strcat(s, "s");
if (crc32("DtPaKchLdsG",11) == 3261935260) strcat(s, "q");
if (crc32("BbZmQ",5) == 3626638418) strcat(s, "u");
if (crc32("TvhOuI",6) == 2287181755) strcat(s, "m");
if (crc32("cXmpUcUtHRu",11) == 877058691) strcat(s, "p");
if (crc32("YwDiP",5) == 2903402116) strcat(s, "t");
if (crc32("qNZak",5) == 3203815484) strcat(s, "u");
if (crc32("aOfjjlxuFJBc",12) == 2531138639) strcat(s, "o");
if (crc32("tgyOb",5) == 3824975561) strcat(s, "u");
if (crc32("GKfed",5) == 2129338697) strcat(s, "s");
if (crc32("hmYoudzSeu",10) == 3737196895) strcat(s, "l");
if (crc32("iTcVNtVb",8) == 591526886) strcat(s, "y");
    return s;
}

char *unsoporiferously_adverbs() {
    char *s = calloc(17);
    if (crc32("XkNvg",5) == 399644408) strcat(s, "w");
if (crc32("ZHfoPIOKdJYD",12) == 405319601) strcat(s, "u");
if (crc32("IJRDo",5) == 1095268714) strcat(s, "n");
if (crc32("OHvQJZxGfn",10) == 1549226350) strcat(s, "T");
if (crc32("QiLUlTRWNelNwOc",15) == 826523784) strcat(s, "s");
if (crc32("raZMZsq",7) == 2094355952) strcat(s, "o");
if (crc32("qwCMEMsF",8) == 3592176688) strcat(s, "T");
if (crc32("yosUsUjf",8) == 4273533539) strcat(s, "p");
if (crc32("vXhss",5) == 2116562803) strcat(s, "w");
if (crc32("xNNCTDMpe",9) == 3218966409) strcat(s, "o");
if (crc32("kGXkxNLWNYm",11) == 594399227) strcat(s, "r");
if (crc32("nLKdwSDMSstSL",13) == 347683732) strcat(s, "i");
if (crc32("PvDxeh",6) == 3735632945) strcat(s, "f");
if (crc32("tABykBTQPE",10) == 2135619608) strcat(s, "f");
if (crc32("HFCBQjzLRQOK",12) == 3989532815) strcat(s, "e");
if (crc32("XsBAETvyHKFE",12) == 1751137430) strcat(s, "r");
if (crc32("KOqhTS",6) == 3071037931) strcat(s, "o");
if (crc32("DZDDlKl",7) == 796663199) strcat(s, "u");
if (crc32("EqWZVZXCkZcOd",13) == 1942169309) strcat(s, "f");
if (crc32("ccpjSKOjIgZMBn",14) == 1650600418) strcat(s, "s");
if (crc32("CcyEDY",6) == 5773200) strcat(s, "l");
if (crc32("nQHblEsqbCo",11) == 4212095124) strcat(s, "y");
    return s;
}

char *unperilously_adverbs() {
    char *s = calloc(13);
    if (crc32("iuuzbihSAw",10) == 1050167712) strcat(s, "Q");
if (crc32("EyJpcU",6) == 4011652564) strcat(s, "u");
if (crc32("rIEjNPVDLgTaScq",15) == 763861482) strcat(s, "P");
if (crc32("NZVoAZrMnooVBd",14) == 2415100406) strcat(s, "n");
if (crc32("qqWSvqwBNNCp",12) == 1965814179) strcat(s, "p");
if (crc32("woeuZApCE",9) == 3781192672) strcat(s, "A");
if (crc32("yqovvxpYKwREG",13) == 1562490858) strcat(s, "e");
if (crc32("lHkJCe",6) == 3520171023) strcat(s, "r");
if (crc32("SZUBFHhy",8) == 627443051) strcat(s, "s");
if (crc32("OoxNbrA",7) == 862295645) strcat(s, "i");
if (crc32("nssJGHC",7) == 589888397) strcat(s, "l");
if (crc32("FooZayapTV",10) == 3242500076) strcat(s, "o");
if (crc32("RcHoyU",6) == 3603013321) strcat(s, "u");
if (crc32("DHZhRKsTtC",10) == 2587903182) strcat(s, "h");
if (crc32("kSyRDF",6) == 3739717709) strcat(s, "s");
if (crc32("EJXBOVqaxfGOx",13) == 3177239536) strcat(s, "l");
if (crc32("OyHjUJYIF",9) == 3219998369) strcat(s, "M");
if (crc32("EZxNmknNiy",10) == 1903659055) strcat(s, "y");
    return s;
}

char *insinuatively_adverbs() {
    char *s = calloc(14);
    if (crc32("hjqZAQflQ",9) == 684691466) strcat(s, "i");
if (crc32("EfVOQrH",7) == 698781110) strcat(s, "n");
if (crc32("ttigXSSYfBJIBPT",15) == 1009909788) strcat(s, "R");
if (crc32("amRnIuPZZP",10) == 611702333) strcat(s, "s");
if (crc32("KtFGXVVuRC",10) == 4158382944) strcat(s, "d");
if (crc32("DQhhxAsT",8) == 3077935258) strcat(s, "i");
if (crc32("Abejis",6) == 2730485224) strcat(s, "n");
if (crc32("efIMELkDJUdyO",13) == 1394200296) strcat(s, "u");
if (crc32("YRegre",6) == 1451433891) strcat(s, "c");
if (crc32("dSyjOpqWehL",11) == 1943646986) strcat(s, "a");
if (crc32("EYGOoPczrBtikm",14) == 1397748014) strcat(s, "K");
if (crc32("TWxgnXoGgFvrptW",15) == 4013408529) strcat(s, "t");
if (crc32("OgyiJeRXidDFaE",14) == 3450581160) strcat(s, "T");
if (crc32("tqBRT",5) == 2389083518) strcat(s, "i");
if (crc32("usOePDf",7) == 615118824) strcat(s, "v");
if (crc32("CkfsolSp",8) == 3360022170) strcat(s, "e");
if (crc32("JbpQzGJqZ",9) == 3007493475) strcat(s, "b");
if (crc32("bKkvy",5) == 2113617701) strcat(s, "l");
if (crc32("eYouxlS",7) == 1154720308) strcat(s, "T");
if (crc32("wvtdkNpw",8) == 3346231562) strcat(s, "y");
    return s;
}

char *worthily_adverbs() {
    char *s = calloc(9);
    if (crc32("YvTjW",5) == 3168625905) strcat(s, "w");
if (crc32("ioonGoBMt",9) == 3090513327) strcat(s, "o");
if (crc32("YOXiPGMEpy",10) == 3235453804) strcat(s, "r");
if (crc32("hakUYwMNzUKSnC",14) == 1481701121) strcat(s, "p");
if (crc32("JtqZymGX",8) == 4214573851) strcat(s, "t");
if (crc32("nFTEb",5) == 4292966360) strcat(s, "F");
if (crc32("YCkrUIbdQbMfZ",13) == 2458067990) strcat(s, "h");
if (crc32("cAuGpcaE",8) == 1709785078) strcat(s, "J");
if (crc32("hyPYHdnPhjh",11) == 549880155) strcat(s, "i");
if (crc32("MJUhPNquCfy",11) == 2793043620) strcat(s, "q");
if (crc32("EGWVanNuaR",10) == 198448726) strcat(s, "l");
if (crc32("ZKLWc",5) == 758479627) strcat(s, "L");
if (crc32("DxQULp",6) == 4188452734) strcat(s, "y");
    return s;
}

char *taxonomically_adverbs() {
    char *s = calloc(14);
    if (crc32("HHbGvnyMJwa",11) == 3700446024) strcat(s, "t");
if (crc32("OKpTbLwAaIVMS",13) == 3858957953) strcat(s, "a");
if (crc32("tXFAgydmFgBsvJG",15) == 454854885) strcat(s, "x");
if (crc32("KDJjZ",5) == 2497078014) strcat(s, "o");
if (crc32("zHWxMfpqrORmkf",14) == 1065871058) strcat(s, "n");
if (crc32("iYudwIiKaqlZG",13) == 938009340) strcat(s, "o");
if (crc32("ghKEnifr",8) == 3543471379) strcat(s, "y");
if (crc32("icNvwtLAAfwQS",13) == 644010976) strcat(s, "m");
if (crc32("dafxIFogq",9) == 1366925150) strcat(s, "i");
if (crc32("OXscthRhneAQKj",14) == 1477749651) strcat(s, "U");
if (crc32("cBKdpC",6) == 3736076898) strcat(s, "c");
if (crc32("ZhqvPB",6) == 2030289495) strcat(s, "R");
if (crc32("dEUjLhIpn",9) == 3348499425) strcat(s, "a");
if (crc32("dlMLQlDuDF",10) == 1485081105) strcat(s, "E");
if (crc32("cqExCqPsUKiyJBc",15) == 2317762135) strcat(s, "l");
if (crc32("cwHqZLQQmfrP",12) == 4012748995) strcat(s, "l");
if (crc32("pPSArLOQ",8) == 560425496) strcat(s, "S");
if (crc32("EPwZQpr",7) == 2497278767) strcat(s, "y");
    return s;
}

char *uncontinually_adverbs() {
    char *s = calloc(14);
    if (crc32("WVwwiHj",7) == 3457350323) strcat(s, "u");
if (crc32("IZGUvitOSfLkuf",14) == 1540157215) strcat(s, "D");
if (crc32("IXMzymnkeSlOEH",14) == 3968438370) strcat(s, "n");
if (crc32("ebMnmZFFbgYj",12) == 3827953621) strcat(s, "c");
if (crc32("clWJKmCPbVek",12) == 2048812783) strcat(s, "o");
if (crc32("FaeayDveNVNbkV",14) == 796200392) strcat(s, "w");
if (crc32("aRrVE",5) == 3193347386) strcat(s, "n");
if (crc32("AxwXDHjILfBglMn",15) == 3819102048) strcat(s, "t");
if (crc32("kgrMzU",6) == 3896259486) strcat(s, "g");
if (crc32("dFtPgUWW",8) == 1921752402) strcat(s, "i");
if (crc32("iaGUqUklzSoN",12) == 759707851) strcat(s, "n");
if (crc32("hROgClzaxi",10) == 2292436555) strcat(s, "u");
if (crc32("igwIVdcS",8) == 161089051) strcat(s, "S");
if (crc32("qKxUiFwGQgOb",12) == 318238757) strcat(s, "a");
if (crc32("RKzjOiDRiGF",11) == 1072132876) strcat(s, "l");
if (crc32("SAteWHSEZE",10) == 433551920) strcat(s, "l");
if (crc32("WKqrpY",6) == 3032707771) strcat(s, "S");
if (crc32("ALLRoZ",6) == 1071915003) strcat(s, "y");
    return s;
}

char *banefully_adverbs() {
    char *s = calloc(10);
    if (crc32("myfyqGvVQiSk",12) == 1015146023) strcat(s, "b");
if (crc32("VOvIdfQlzjgzcNf",15) == 2888829119) strcat(s, "e");
if (crc32("QByMopdOCm",10) == 4099851849) strcat(s, "a");
if (crc32("YeydghLE",8) == 202717558) strcat(s, "n");
if (crc32("lyVezQQiP",9) == 2240084981) strcat(s, "e");
if (crc32("KtiarIHtCoG",11) == 348962599) strcat(s, "u");
if (crc32("AkJznyP",7) == 3694996315) strcat(s, "f");
if (crc32("fJBtjqLOzsQrnL",14) == 3534951866) strcat(s, "F");
if (crc32("lIXEHtbYIS",10) == 72522690) strcat(s, "u");
if (crc32("nOqPp",5) == 2631555157) strcat(s, "l");
if (crc32("tLaPOqoKUDe",11) == 1574411057) strcat(s, "C");
if (crc32("BJhGhG",6) == 801782553) strcat(s, "l");
if (crc32("dSnExxHr",8) == 2325070282) strcat(s, "a");
if (crc32("yciIOvhxymIdpR",14) == 1087628033) strcat(s, "y");
    return s;
}

char *verily_adverbs() {
    char *s = calloc(7);
    if (crc32("kZxyukiFTBf",11) == 3040157737) strcat(s, "v");
if (crc32("nfWquhAW",8) == 1000321944) strcat(s, "W");
if (crc32("WTjoiWAeC",9) == 3016565009) strcat(s, "e");
if (crc32("ykjYQgsCIRyM",12) == 2558696346) strcat(s, "V");
if (crc32("DQYPQ",5) == 3713681498) strcat(s, "r");
if (crc32("XVOUTeS",7) == 2754724507) strcat(s, "f");
if (crc32("zVteFcAK",8) == 626306450) strcat(s, "i");
if (crc32("OyhschbnNu",10) == 3046923354) strcat(s, "H");
if (crc32("zambFDjUbQTlSLz",15) == 2998775735) strcat(s, "l");
if (crc32("kcjWhUZ",7) == 357787905) strcat(s, "y");
    return s;
}

char *overgrievously_adverbs() {
    char *s = calloc(15);
    if (crc32("jMWzEKGVClzwc",13) == 494137739) strcat(s, "o");
if (crc32("HSAVB",5) == 1920104768) strcat(s, "v");
if (crc32("EfgGz",5) == 4234534763) strcat(s, "Y");
if (crc32("xfkfQnMBKw",10) == 1792420199) strcat(s, "e");
if (crc32("AUtFJtaUVQPziG",14) == 780885689) strcat(s, "F");
if (crc32("xfgOdniWAUZJ",12) == 1719706658) strcat(s, "r");
if (crc32("cDoWAOnkS",9) == 1384153913) strcat(s, "D");
if (crc32("wccyHxBbjkQstA",14) == 2919736259) strcat(s, "g");
if (crc32("hIKjOVWhLSeln",13) == 1018220640) strcat(s, "r");
if (crc32("dXiNstkouSiWTO",14) == 1442691262) strcat(s, "i");
if (crc32("fBSFv",5) == 283841687) strcat(s, "E");
if (crc32("VgIyIEoQos",10) == 3182839435) strcat(s, "e");
if (crc32("JEVygNT",7) == 3034085801) strcat(s, "Y");
if (crc32("OhIGCpRWxudl",12) == 843240749) strcat(s, "v");
if (crc32("sVUdyb",6) == 3617193553) strcat(s, "b");
if (crc32("yDTPErnHOPJB",12) == 460513762) strcat(s, "o");
if (crc32("qyrhZzhNDNg",11) == 3053910624) strcat(s, "u");
if (crc32("MHxBgEXKhgyy",12) == 3285926299) strcat(s, "M");
if (crc32("fCbUalrpDnyYv",13) == 4062623574) strcat(s, "s");
if (crc32("dpcOHmX",7) == 1060696043) strcat(s, "l");
if (crc32("iRhhbio",7) == 3082104765) strcat(s, "y");
    return s;
}

char *flowingly_adverbs() {
    char *s = calloc(10);
    if (crc32("sPvJzoS",7) == 3318744293) strcat(s, "y");
if (crc32("rZQWRXF",7) == 2596416938) strcat(s, "f");
if (crc32("DEoLREJbBGyxE",13) == 3827200238) strcat(s, "Q");
if (crc32("EyHfvciEevsrX",13) == 195678186) strcat(s, "l");
if (crc32("hSIyxy",6) == 2736382207) strcat(s, "d");
if (crc32("VhLkMRLJzNYnW",13) == 3440617146) strcat(s, "o");
if (crc32("yHABcZwHxorRc",13) == 361359524) strcat(s, "E");
if (crc32("IFgDYpmboUxCr",13) == 24912971) strcat(s, "w");
if (crc32("oyfsEBHFNVk",11) == 1997141902) strcat(s, "f");
if (crc32("wjtfon",6) == 2484029528) strcat(s, "i");
if (crc32("bfiUB",5) == 3260268113) strcat(s, "B");
if (crc32("CegIEXgpneBkP",13) == 1207020180) strcat(s, "n");
if (crc32("lAyuCiXYIpwxva",14) == 2844629582) strcat(s, "g");
if (crc32("hlicvivQTUS",11) == 529816528) strcat(s, "g");
if (crc32("tZuNFw",6) == 651424851) strcat(s, "z");
if (crc32("MwvjaYlvINZuIlL",15) == 2972285395) strcat(s, "l");
if (crc32("jilVIXm",7) == 299836547) strcat(s, "y");
    return s;
}

char *Hellenically_adverbs() {
    char *s = calloc(13);
    if (crc32("OuqHSREZuUWB",12) == 3556591666) strcat(s, "H");
if (crc32("zdXktU",6) == 1839219852) strcat(s, "e");
if (crc32("jvEfADWuiDXPn",13) == 2694855481) strcat(s, "l");
if (crc32("aRbgOhatN",9) == 1248235276) strcat(s, "N");
if (crc32("eKBHcTMGEvzVTTB",15) == 2380597824) strcat(s, "l");
if (crc32("jClwhLQacAM",11) == 465576365) strcat(s, "z");
if (crc32("zCMZYsUMzN",10) == 2232810728) strcat(s, "e");
if (crc32("gjrRgcrH",8) == 496844052) strcat(s, "n");
if (crc32("uqiOlmyqoIv",11) == 2290442463) strcat(s, "X");
if (crc32("UdmctPnYQPX",11) == 2146504949) strcat(s, "i");
if (crc32("lOmuJjkT",8) == 2501276307) strcat(s, "e");
if (crc32("IKCJhfMk",8) == 2735537888) strcat(s, "c");
if (crc32("QcjDXJrHU",9) == 3203473775) strcat(s, "Z");
if (crc32("ECndf",5) == 949574419) strcat(s, "a");
if (crc32("hDHDsHMy",8) == 4078790751) strcat(s, "l");
if (crc32("EMrRqnBEuMRotB",14) == 1171756463) strcat(s, "p");
if (crc32("RyOdXGfaRI",10) == 1475621587) strcat(s, "l");
if (crc32("MyGWTfqP",8) == 1667138182) strcat(s, "y");
    return s;
}

char *confoundingly_adverbs() {
    char *s = calloc(14);
    if (crc32("oEjpQo",6) == 2796856574) strcat(s, "c");
if (crc32("esVpqBPWqhEydOr",15) == 1900510945) strcat(s, "k");
if (crc32("VcqfY",5) == 750891661) strcat(s, "o");
if (crc32("PUGIMsPRtxPeiS",14) == 3534751077) strcat(s, "n");
if (crc32("DrVuQtgaGq",10) == 1059135926) strcat(s, "F");
if (crc32("pCfDnkWFaBmK",12) == 75720003) strcat(s, "f");
if (crc32("MtaMVeiEUhGT",12) == 370992017) strcat(s, "o");
if (crc32("FULffjteoaF",11) == 4089003731) strcat(s, "U");
if (crc32("DBFankSctJPQ",12) == 972543607) strcat(s, "u");
if (crc32("JaxJHhFtVPkx",12) == 1401347579) strcat(s, "n");
if (crc32("whvKiKYElReXe",13) == 3354364565) strcat(s, "d");
if (crc32("EeLtnn",6) == 3288761089) strcat(s, "D");
if (crc32("UhzzfonirLfwlPy",15) == 1766845955) strcat(s, "i");
if (crc32("tHVyNjFqjJgMo",13) == 2612434427) strcat(s, "n");
if (crc32("DpBIFgWmBjPS",12) == 3013790522) strcat(s, "g");
if (crc32("VKcjOXlBWPBAQD",14) == 2624925988) strcat(s, "k");
if (crc32("IFaFWm",6) == 2136137868) strcat(s, "l");
if (crc32("DtaLICWuV",9) == 1796998950) strcat(s, "a");
if (crc32("UIfjuCXIEdWP",12) == 1045733938) strcat(s, "y");
    return s;
}

char *unsullenly_adverbs() {
    char *s = calloc(11);
    if (crc32("vXqFxVomDiUrCmK",15) == 2319403162) strcat(s, "u");
if (crc32("CeNeAIHnsguX",12) == 3119679953) strcat(s, "R");
if (crc32("BDCLK",5) == 1064933590) strcat(s, "n");
if (crc32("NdlnnipniUYlb",13) == 1121032645) strcat(s, "P");
if (crc32("RtSCVJ",6) == 760909785) strcat(s, "s");
if (crc32("GIbTzjie",8) == 783422349) strcat(s, "U");
if (crc32("AeVknimLJ",9) == 2134577008) strcat(s, "u");
if (crc32("ANgry",5) == 1889145587) strcat(s, "D");
if (crc32("GOvhWjqGIP",10) == 1647217739) strcat(s, "l");
if (crc32("mOOkgpITWQoO",12) == 1006012952) strcat(s, "Q");
if (crc32("GunLtWwYCGmgK",13) == 2542329103) strcat(s, "l");
if (crc32("UioipbvHXTxat",13) == 1934236394) strcat(s, "e");
if (crc32("ytnOlquP",8) == 1000838851) strcat(s, "n");
if (crc32("feBlM",5) == 2277359796) strcat(s, "W");
if (crc32("DzhwkKymjmgWR",13) == 36508628) strcat(s, "l");
if (crc32("qLVYJNgxvL",10) == 2043558362) strcat(s, "F");
if (crc32("AyjyQLMViolxa",13) == 3779250942) strcat(s, "y");
    return s;
}

char *advantageously_adverbs() {
    char *s = calloc(15);
    if (crc32("mADkXEpedkq",11) == 3675300704) strcat(s, "a");
if (crc32("SUlcxaQ",7) == 2620093917) strcat(s, "d");
if (crc32("OdGsJxWJApy",11) == 1614371314) strcat(s, "v");
if (crc32("iuDhKnDBLO",10) == 1761853867) strcat(s, "h");
if (crc32("MbmdPqMsmLc",11) == 2835232058) strcat(s, "a");
if (crc32("cVAZgvwf",8) == 4291189275) strcat(s, "n");
if (crc32("IqbwPX",6) == 1225734226) strcat(s, "Z");
if (crc32("kKQfXROkLbaygp",14) == 3785715678) strcat(s, "t");
if (crc32("qqbmsrkQ",8) == 3754158103) strcat(s, "a");
if (crc32("gNSLtmH",7) == 3019016275) strcat(s, "g");
if (crc32("cxSnXGBwU",9) == 3662694784) strcat(s, "e");
if (crc32("BTjHsTgP",8) == 1258605923) strcat(s, "o");
if (crc32("uJQwjGM",7) == 1861837835) strcat(s, "f");
if (crc32("hDiKULJcJv",10) == 3890509376) strcat(s, "u");
if (crc32("nMGxosrK",8) == 3611407553) strcat(s, "D");
if (crc32("pKLeyrIaTlrjFoX",15) == 3717002020) strcat(s, "s");
if (crc32("UKPelfD",7) == 3190706391) strcat(s, "l");
if (crc32("nyQMTXuTfYq",11) == 4143153368) strcat(s, "y");
    return s;
}

char *irremissibly_adverbs() {
    char *s = calloc(13);
    if (crc32("caoBKgFzFdlqa",13) == 4145780699) strcat(s, "O");
if (crc32("JDwRsrDPRySQ",12) == 3440193345) strcat(s, "i");
if (crc32("DTXTmeVLnJN",11) == 2842677863) strcat(s, "Q");
if (crc32("MMTihhFVd",9) == 114620789) strcat(s, "r");
if (crc32("BELztIfODXDz",12) == 4071007833) strcat(s, "P");
if (crc32("BNbHwlYvyScpiT",14) == 53715132) strcat(s, "r");
if (crc32("ajpdDPN",7) == 777888923) strcat(s, "D");
if (crc32("lUPMGZVc",8) == 1624521040) strcat(s, "e");
if (crc32("vjnveR",6) == 2840664955) strcat(s, "m");
if (crc32("JULUeMTMGMW",11) == 781536635) strcat(s, "i");
if (crc32("DizdgqFYr",9) == 4246323840) strcat(s, "N");
if (crc32("nMqTIVidUvNo",12) == 3147410473) strcat(s, "s");
if (crc32("ybNiYOioM",9) == 792134796) strcat(s, "y");
if (crc32("bkkajlS",7) == 4033134850) strcat(s, "s");
if (crc32("MJSRpCd",7) == 3267411490) strcat(s, "M");
if (crc32("ulcmaAStRcWIRRx",15) == 762173453) strcat(s, "i");
if (crc32("VrXzyWfeXyIgjBf",15) == 1749796791) strcat(s, "b");
if (crc32("vsPvZVUcMRcKCGj",15) == 2040681845) strcat(s, "l");
if (crc32("UJkssaMlWLRTYta",15) == 788241857) strcat(s, "K");
if (crc32("hmEtgibeGjTw",12) == 2563571166) strcat(s, "y");
    return s;
}

char *trenchantly_adverbs() {
    char *s = calloc(12);
    if (crc32("XRywct",6) == 1027893793) strcat(s, "l");
if (crc32("HxDUFjvDCiwWqTc",15) == 474115701) strcat(s, "t");
if (crc32("nnkYJVmf",8) == 29005846) strcat(s, "y");
if (crc32("XklNcsQOeaPVTJ",14) == 1242415408) strcat(s, "r");
if (crc32("UudDbI",6) == 1202708993) strcat(s, "e");
if (crc32("BevhIosLS",9) == 3582310969) strcat(s, "e");
if (crc32("WRXvK",5) == 3620805263) strcat(s, "n");
if (crc32("ipTRuJqRYbtokid",15) == 579706984) strcat(s, "h");
if (crc32("qkkwDjWmf",9) == 4150221551) strcat(s, "c");
if (crc32("kAlczuSX",8) == 166060775) strcat(s, "h");
if (crc32("ZpLVcIHs",8) == 621878041) strcat(s, "a");
if (crc32("SMHqsleDaUbaUJ",14) == 951848384) strcat(s, "F");
if (crc32("reOurWQdFL",10) == 1624279015) strcat(s, "n");
if (crc32("ghsCOgLz",8) == 3662339817) strcat(s, "A");
if (crc32("cCMzNa",6) == 1151770861) strcat(s, "t");
if (crc32("iqmdOwjMqEIXbcw",15) == 1505156929) strcat(s, "l");
if (crc32("zHrpL",5) == 750827474) strcat(s, "y");
    return s;
}

char *preofficially_adverbs() {
    char *s = calloc(14);
    if (crc32("rkiOAMznfetRtI",14) == 993951461) strcat(s, "p");
if (crc32("MWvRMWow",8) == 2196342329) strcat(s, "r");
if (crc32("vnnQxrJvcjNjcA",14) == 2277659298) strcat(s, "r");
if (crc32("faLxpbjleJBrJ",13) == 1151418251) strcat(s, "e");
if (crc32("TulnaBdhRkWyncX",15) == 3255863980) strcat(s, "o");
if (crc32("lzXykMHJNtekJQ",14) == 2356294043) strcat(s, "d");
if (crc32("sQgCMwADkZkSyR",14) == 3286855854) strcat(s, "f");
if (crc32("dFmftYDXjMaFVC",14) == 909476926) strcat(s, "f");
if (crc32("JivyxzijV",9) == 1454961418) strcat(s, "i");
if (crc32("BJocczIeqsSbRj",14) == 1506852954) strcat(s, "m");
if (crc32("EXEaWR",6) == 1937001509) strcat(s, "c");
if (crc32("NiaCbEywGd",10) == 2648322931) strcat(s, "i");
if (crc32("mmHJVdcxsfv",11) == 2818157818) strcat(s, "Z");
if (crc32("EVILOsiYwEZsuWI",15) == 3385007830) strcat(s, "a");
if (crc32("lSPmIjRSQZa",11) == 2933849250) strcat(s, "l");
if (crc32("lKsMcZ",6) == 4175678400) strcat(s, "M");
if (crc32("StzaenPNtAXtu",13) == 1571490136) strcat(s, "l");
if (crc32("TFXTxtIQBzUs",12) == 1948491123) strcat(s, "E");
if (crc32("TZNyhT",6) == 3048682683) strcat(s, "y");
    return s;
}

char *archeologically_adverbs() {
    char *s = calloc(16);
    if (crc32("EssqlOIau",9) == 4049234810) strcat(s, "a");
if (crc32("rgNSmoeeZsRY",12) == 1445007588) strcat(s, "r");
if (crc32("ePuMi",5) == 2138981005) strcat(s, "c");
if (crc32("tUuEzcbW",8) == 469644715) strcat(s, "h");
if (crc32("QoeqnqiTJ",9) == 1765965838) strcat(s, "e");
if (crc32("aMevCvPsTmScc",13) == 2063913813) strcat(s, "o");
if (crc32("FHcPlbI",7) == 4004014172) strcat(s, "q");
if (crc32("PtboMlxsBqmu",12) == 1812119996) strcat(s, "l");
if (crc32("deNQVDIRJibJ",12) == 2948353085) strcat(s, "o");
if (crc32("bZTrOrExABYx",12) == 3060938477) strcat(s, "b");
if (crc32("IOGWRwXk",8) == 3781557312) strcat(s, "g");
if (crc32("sOIbcAWSmxtTcR",14) == 4282951180) strcat(s, "i");
if (crc32("bzmcN",5) == 3202981704) strcat(s, "c");
if (crc32("CpMXVSfhf",9) == 2709770028) strcat(s, "Z");
if (crc32("WvNsNfqpnk",10) == 1595993552) strcat(s, "a");
if (crc32("afRgJlqAWvfch",13) == 3488629601) strcat(s, "l");
if (crc32("cRmwnP",6) == 1972766250) strcat(s, "l");
if (crc32("sCHVMr",6) == 3999989725) strcat(s, "y");
    return s;
}

char *subautomatically_adverbs() {
    char *s = calloc(17);
    if (crc32("ySMmUisJvSDD",12) == 2462791595) strcat(s, "q");
if (crc32("XFhjrNQiURy",11) == 1511361372) strcat(s, "s");
if (crc32("KBMDaHknVr",10) == 1465075850) strcat(s, "G");
if (crc32("HoxMNPVlEmRtrf",14) == 758081187) strcat(s, "u");
if (crc32("TIfCTTmiUc",10) == 2729090990) strcat(s, "O");
if (crc32("yqcwtkJfvRJq",12) == 1181363839) strcat(s, "b");
if (crc32("CMKGvuMozV",10) == 2004566126) strcat(s, "B");
if (crc32("hTpSBphfeBLGYF",14) == 3376788175) strcat(s, "a");
if (crc32("QYeYabgz",8) == 1971083628) strcat(s, "u");
if (crc32("DxqkZ",5) == 308739861) strcat(s, "A");
if (crc32("vcCZsKC",7) == 2377701929) strcat(s, "t");
if (crc32("TvreCI",6) == 187791875) strcat(s, "o");
if (crc32("fnleL",5) == 274221166) strcat(s, "N");
if (crc32("OKkuepE",7) == 2670130065) strcat(s, "m");
if (crc32("HtVtDHd",7) == 3743373182) strcat(s, "S");
if (crc32("QtJhM",5) == 4282970681) strcat(s, "a");
if (crc32("MLSPmkMPTbbL",12) == 1194164045) strcat(s, "t");
if (crc32("XIuJPCHy",8) == 3250941676) strcat(s, "z");
if (crc32("lgZerWQjs",9) == 3074720820) strcat(s, "i");
if (crc32("AESjpcaLvSkvmAE",15) == 665368058) strcat(s, "Q");
if (crc32("ROAFul",6) == 1809099053) strcat(s, "c");
if (crc32("bcHlilq",7) == 3321756731) strcat(s, "O");
if (crc32("ykNqW",5) == 1743268235) strcat(s, "a");
if (crc32("cKFaKU",6) == 4016513100) strcat(s, "l");
if (crc32("OsRcm",5) == 2814313134) strcat(s, "z");
if (crc32("sjVcTBDNoLiNPGv",15) == 93693033) strcat(s, "l");
if (crc32("ehmDxXNJi",9) == 247225582) strcat(s, "y");
    return s;
}

char *dogmatically_adverbs() {
    char *s = calloc(13);
    if (crc32("vXncAEB",7) == 2763451548) strcat(s, "h");
if (crc32("gENon",5) == 1938911154) strcat(s, "d");
if (crc32("yFCxICq",7) == 4005628575) strcat(s, "R");
if (crc32("QcEdWvys",8) == 1149301211) strcat(s, "o");
if (crc32("MSCynfq",7) == 4037834930) strcat(s, "x");
if (crc32("dgOYfJqDpIsEElO",15) == 967146496) strcat(s, "g");
if (crc32("hLSKnqiQTyzY",12) == 4209219033) strcat(s, "m");
if (crc32("UpwdCZEzXFz",11) == 19299493) strcat(s, "K");
if (crc32("dXxBwjpqsMjz",12) == 4023322342) strcat(s, "a");
if (crc32("JZpLMmKKNeafX",13) == 546450009) strcat(s, "M");
if (crc32("mzDFL",5) == 232309821) strcat(s, "t");
if (crc32("SUiqTOxlRVwl",12) == 102792700) strcat(s, "i");
if (crc32("GakKFXmekgwBCRM",15) == 3262933520) strcat(s, "V");
if (crc32("GHShmbld",8) == 323934252) strcat(s, "c");
if (crc32("CeqynTFcIrASESB",15) == 3478947791) strcat(s, "a");
if (crc32("FfZjoJ",6) == 516153453) strcat(s, "a");
if (crc32("cSusPY",6) == 3796589551) strcat(s, "l");
if (crc32("PPvhlzLWDLy",11) == 128338000) strcat(s, "s");
if (crc32("dweGMBgMrnhG",12) == 416865349) strcat(s, "l");
if (crc32("IllSqrdXIn",10) == 1762323308) strcat(s, "q");
if (crc32("rPENpoMkUaTCQ",13) == 2947081736) strcat(s, "y");
    return s;
}

char *inconsolably_adverbs() {
    char *s = calloc(13);
    if (crc32("YOcXJViqaZEP",12) == 2066240311) strcat(s, "i");
if (crc32("KKYxBSI",7) == 2678373632) strcat(s, "s");
if (crc32("oyiNGXWfi",9) == 2011184310) strcat(s, "n");
if (crc32("cnHISLFw",8) == 1791363298) strcat(s, "E");
if (crc32("hjfTIbfrBsibG",13) == 2092982268) strcat(s, "c");
if (crc32("ohjRMBhLeLG",11) == 1366413617) strcat(s, "o");
if (crc32("XeVLDy",6) == 2208427424) strcat(s, "V");
if (crc32("NhkMfUxbkO",10) == 2280849697) strcat(s, "n");
if (crc32("DMUlKmJrk",9) == 2235528604) strcat(s, "s");
if (crc32("RlerEJGHoIlBq",13) == 2412017719) strcat(s, "o");
if (crc32("ruVrfZec",8) == 3751101172) strcat(s, "l");
if (crc32("oxGwl",5) == 804625095) strcat(s, "T");
if (crc32("VGHIvUeQq",9) == 3679799703) strcat(s, "a");
if (crc32("vXyfJCZgIcV",11) == 2314754397) strcat(s, "F");
if (crc32("AFTdTk",6) == 2909998602) strcat(s, "b");
if (crc32("yvbAUzKOEpK",11) == 910531353) strcat(s, "P");
if (crc32("MqNNjghokUcVYdA",15) == 3782145900) strcat(s, "l");
if (crc32("svOYCD",6) == 2463830583) strcat(s, "M");
if (crc32("LKgjaiXhMfZC",12) == 2163620613) strcat(s, "y");
    return s;
}

char *trustily_adverbs() {
    char *s = calloc(9);
    if (crc32("uypyIjaTrhBaEic",15) == 3028362981) strcat(s, "c");
if (crc32("rJDbLexTiXBgBML",15) == 298038933) strcat(s, "t");
if (crc32("bZAYDIUe",8) == 275251142) strcat(s, "r");
if (crc32("JGMsqsAwDYrrwF",14) == 442207471) strcat(s, "P");
if (crc32("QgEeZdjmERjUT",13) == 547315700) strcat(s, "u");
if (crc32("aFYwFhdUMZOXxZ",14) == 4135383206) strcat(s, "s");
if (crc32("hjZfEs",6) == 1035248439) strcat(s, "a");
if (crc32("VgojUnQxzJ",10) == 1497688861) strcat(s, "t");
if (crc32("RhOQYgcT",8) == 3875120967) strcat(s, "J");
if (crc32("TiqfWAbWfHmIlRH",15) == 1638922327) strcat(s, "i");
if (crc32("CvyBstrfnTWdw",13) == 1533299447) strcat(s, "l");
if (crc32("jJkxdZ",6) == 906269396) strcat(s, "y");
    return s;
}

char *uninstrumentally_adverbs() {
    char *s = calloc(17);
    if (crc32("BUtflPklu",9) == 2359404250) strcat(s, "O");
if (crc32("rUPJZCcWPldrzEO",15) == 528633532) strcat(s, "u");
if (crc32("kjMLyqqvftCs",12) == 3549262570) strcat(s, "n");
if (crc32("efDbkBsFvXivX",13) == 1520927537) strcat(s, "m");
if (crc32("qkNRc",5) == 3364217246) strcat(s, "i");
if (crc32("hbhPr",5) == 914716578) strcat(s, "l");
if (crc32("BjqihEk",7) == 1956741100) strcat(s, "n");
if (crc32("OcOTLoWIQ",9) == 913887063) strcat(s, "s");
if (crc32("JdNacmZBADTCrRx",15) == 4034490218) strcat(s, "y");
if (crc32("kRkvgOLCEPFUbd",14) == 2743363548) strcat(s, "t");
if (crc32("BsujfVbIQr",10) == 3608849092) strcat(s, "A");
if (crc32("HUHbCZldYNRQvFe",15) == 612257408) strcat(s, "r");
if (crc32("poNcHDRQW",9) == 3226966210) strcat(s, "u");
if (crc32("PsXZmjAjTJ",10) == 3674766780) strcat(s, "m");
if (crc32("XRvgHExrUzsF",12) == 1028757292) strcat(s, "F");
if (crc32("aQctq",5) == 922831110) strcat(s, "e");
if (crc32("FCVshForLz",10) == 2149069675) strcat(s, "f");
if (crc32("AbdUWoKFovP",11) == 1779665170) strcat(s, "n");
if (crc32("ODbWFCFGAs",10) == 3013033843) strcat(s, "r");
if (crc32("zpKcJTVYu",9) == 2461235635) strcat(s, "t");
if (crc32("HYymLlcm",8) == 2302981600) strcat(s, "a");
if (crc32("oJjWULvu",8) == 3380150115) strcat(s, "w");
if (crc32("vmvhaaOioeBZNxu",15) == 2200209945) strcat(s, "l");
if (crc32("NAvgz",5) == 3361300429) strcat(s, "l");
if (crc32("vHPTxhhcD",9) == 1704429416) strcat(s, "y");
    return s;
}

char *pseudogentlemanly_adverbs() {
    char *s = calloc(18);
    if (crc32("AOfrhtsaSyQma",13) == 1490083778) strcat(s, "p");
if (crc32("LOcNlylXoxLLXS",14) == 1855424035) strcat(s, "P");
if (crc32("MRxhRHyCusjHW",13) == 905180677) strcat(s, "s");
if (crc32("lPTmRxxKtoew",12) == 808900677) strcat(s, "z");
if (crc32("ckAtOpKVD",9) == 749360710) strcat(s, "e");
if (crc32("TtdCiocNWkBbbO",14) == 557719264) strcat(s, "U");
if (crc32("OWqaVRWlhDIpgq",14) == 2433121448) strcat(s, "u");
if (crc32("CzoPwZkLyiRp",12) == 631407201) strcat(s, "d");
if (crc32("NuBPgRIjSZMuBgp",15) == 3257196245) strcat(s, "o");
if (crc32("btIYoIDNvbrKML",14) == 982490679) strcat(s, "g");
if (crc32("dDUNeQ",6) == 3372776657) strcat(s, "d");
if (crc32("jTgIwtg",7) == 562039810) strcat(s, "e");
if (crc32("xxbRwHsfYIfLg",13) == 89444149) strcat(s, "n");
if (crc32("CwCeFpVy",8) == 475474118) strcat(s, "t");
if (crc32("TCBcOy",6) == 3607320579) strcat(s, "m");
if (crc32("sWjZtTfnfxFs",12) == 1955736586) strcat(s, "l");
if (crc32("RdeehYtgjh",10) == 3128656786) strcat(s, "e");
if (crc32("fwWQQmMQYulaug",14) == 4244139581) strcat(s, "m");
if (crc32("UeTRucR",7) == 2174782370) strcat(s, "a");
if (crc32("CKmnwPovP",9) == 2080671292) strcat(s, "n");
if (crc32("uVmLUCQfQ",9) == 1718145515) strcat(s, "l");
if (crc32("FnTOIXl",7) == 3481312279) strcat(s, "y");
    return s;
}

char *starrily_adverbs() {
    char *s = calloc(9);
    if (crc32("KnYQbXtmf",9) == 3288424096) strcat(s, "s");
if (crc32("jRQoeSXSNlIOJ",13) == 766078383) strcat(s, "t");
if (crc32("nvkSlKiA",8) == 2782375086) strcat(s, "E");
if (crc32("LupwtZx",7) == 123775159) strcat(s, "a");
if (crc32("OsqZjW",6) == 769579070) strcat(s, "A");
if (crc32("XIeGchGvP",9) == 2505683232) strcat(s, "r");
if (crc32("wWDbVkBWlv",10) == 4020860801) strcat(s, "x");
if (crc32("lPTiwoasaelqqii",15) == 976403298) strcat(s, "r");
if (crc32("fUlelgJSbuhKnL",14) == 2481957321) strcat(s, "b");
if (crc32("smNfaMHdhE",10) == 1586404999) strcat(s, "i");
if (crc32("OikSHCQqZLnvv",13) == 2802580600) strcat(s, "l");
if (crc32("wVWFKL",6) == 78445194) strcat(s, "t");
if (crc32("dgrDlSVrTRvb",12) == 1704900537) strcat(s, "y");
    return s;
}

char *silviculturally_adverbs() {
    char *s = calloc(16);
    if (crc32("ArfQZjT",7) == 277508067) strcat(s, "P");
if (crc32("gBDkEmBYzvnzX",13) == 3353035250) strcat(s, "s");
if (crc32("BoipenNYN",9) == 10017666) strcat(s, "i");
if (crc32("XNuhSoVnUuj",11) == 2195626586) strcat(s, "l");
if (crc32("hXpbHJtl",8) == 2950650274) strcat(s, "d");
if (crc32("RqwaVUq",7) == 2848976772) strcat(s, "v");
if (crc32("KTsZMeaW",8) == 2547086313) strcat(s, "i");
if (crc32("ReBbvT",6) == 3464180743) strcat(s, "c");
if (crc32("OCMGK",5) == 862191480) strcat(s, "c");
if (crc32("ElECLmHGr",9) == 1094863410) strcat(s, "u");
if (crc32("WowIkFgaavY",11) == 1644236046) strcat(s, "l");
if (crc32("FqVlSGvUuzWoDeA",15) == 1821316334) strcat(s, "n");
if (crc32("xxngZha",7) == 3553874703) strcat(s, "t");
if (crc32("ULDvyEUoiMO",11) == 1590221207) strcat(s, "u");
if (crc32("uPpecI",6) == 812829731) strcat(s, "a");
if (crc32("ysIJmqSWcnpng",13) == 4061050974) strcat(s, "r");
if (crc32("dUmvwe",6) == 381873550) strcat(s, "a");
if (crc32("bHoexnmqBXvHbq",14) == 2181617700) strcat(s, "q");
if (crc32("nFcCUBXBc",9) == 461183272) strcat(s, "l");
if (crc32("agEeV",5) == 676479570) strcat(s, "l");
if (crc32("QyXmiPM",7) == 3496857398) strcat(s, "F");
if (crc32("SyGpxcUGb",9) == 42296222) strcat(s, "y");
    return s;
}

char *stridulously_adverbs() {
    char *s = calloc(13);
    if (crc32("NWciIJjPsZGt",12) == 2385918559) strcat(s, "s");
if (crc32("WzBHTqbwnNpiYRA",15) == 2942126681) strcat(s, "t");
if (crc32("CyJoXxjiTxdpTvC",15) == 2115070106) strcat(s, "r");
if (crc32("bMhRLphrSWMJ",12) == 1714088214) strcat(s, "N");
if (crc32("AfOJKHQwjjFurtW",15) == 3473895146) strcat(s, "i");
if (crc32("qoNPLtXzzgiLcgO",15) == 2155915441) strcat(s, "d");
if (crc32("rcfakEg",7) == 3880327801) strcat(s, "u");
if (crc32("gMeCPoYHdfEHHXx",15) == 913201221) strcat(s, "i");
if (crc32("GkgrsLFGqBkKm",13) == 237005679) strcat(s, "l");
if (crc32("IkTsLcloeIhvn",13) == 828434880) strcat(s, "M");
if (crc32("PZFvnV",6) == 1486544853) strcat(s, "o");
if (crc32("KHHZYUpIidQ",11) == 487906100) strcat(s, "u");
if (crc32("LOnWZGokv",9) == 3969148573) strcat(s, "s");
if (crc32("aIETZCmNXzhtQ",13) == 3599398620) strcat(s, "a");
if (crc32("eCvdTmJW",8) == 3271197277) strcat(s, "l");
if (crc32("cLtocgJlSnMhAUZ",15) == 1191452498) strcat(s, "m");
if (crc32("NNhxNwC",7) == 1315721576) strcat(s, "y");
    return s;
}

char *wretchedly_adverbs() {
    char *s = calloc(11);
    if (crc32("XClmxxZzV",9) == 1020507274) strcat(s, "F");
if (crc32("KPCiPumjGWKg",12) == 3827484239) strcat(s, "w");
if (crc32("VdunCnjEY",9) == 555593210) strcat(s, "r");
if (crc32("KasDkEqa",8) == 2318852405) strcat(s, "e");
if (crc32("cbmJNLnpSi",10) == 2197487653) strcat(s, "t");
if (crc32("pLPwYvE",7) == 661918165) strcat(s, "H");
if (crc32("NmSoQMVWdMqBOsL",15) == 2416688754) strcat(s, "c");
if (crc32("JxPwFZ",6) == 3401311458) strcat(s, "G");
if (crc32("JVMZw",5) == 3429935193) strcat(s, "h");
if (crc32("hJRdoEwqy",9) == 3684470989) strcat(s, "y");
if (crc32("EQjFEaM",7) == 598351391) strcat(s, "e");
if (crc32("lhzseE",6) == 733998594) strcat(s, "d");
if (crc32("kwGVOf",6) == 633456580) strcat(s, "l");
if (crc32("JYmhsetQ",8) == 2396889190) strcat(s, "G");
if (crc32("zNkZiAaOqPgVP",13) == 2296087817) strcat(s, "y");
    return s;
}

char *overstoutly_adverbs() {
    char *s = calloc(12);
    if (crc32("gnLZMpYseXy",11) == 1456911670) strcat(s, "o");
if (crc32("HIDiemJqEPD",11) == 939975574) strcat(s, "v");
if (crc32("QfNyYPFiJqA",11) == 3400340805) strcat(s, "e");
if (crc32("LRsXc",5) == 3393959115) strcat(s, "r");
if (crc32("YtfDpeAaenHGajx",15) == 1344653854) strcat(s, "s");
if (crc32("gKfnGCHrwKN",11) == 363081790) strcat(s, "T");
if (crc32("QfxderYNUZPg",12) == 1532015648) strcat(s, "t");
if (crc32("jMcaGfD",7) == 3868071653) strcat(s, "A");
if (crc32("Umjpsb",6) == 736616045) strcat(s, "o");
if (crc32("tUQdnIVyoW",10) == 2388756067) strcat(s, "w");
if (crc32("HjuhKM",6) == 2156799899) strcat(s, "u");
if (crc32("ANcnHXP",7) == 682171858) strcat(s, "t");
if (crc32("arVwEsOfzwFObM",14) == 278123452) strcat(s, "g");
if (crc32("xQdTkMh",7) == 4023922683) strcat(s, "l");
if (crc32("ZLWUrHEjSjzNd",13) == 3395986646) strcat(s, "y");
    return s;
}

char *uncomplacently_adverbs() {
    char *s = calloc(15);
    if (crc32("fUlcJzgf",8) == 713370907) strcat(s, "B");
if (crc32("vRqFoxxiiuSzPQt",15) == 2311413616) strcat(s, "u");
if (crc32("fGxQTOOkK",9) == 1142041116) strcat(s, "c");
if (crc32("IQkChndSezgIlb",14) == 3023720478) strcat(s, "n");
if (crc32("GxqlG",5) == 4139321800) strcat(s, "c");
if (crc32("sCWEe",5) == 685018227) strcat(s, "o");
if (crc32("QPuKLREbNeyMWbX",15) == 3436277087) strcat(s, "m");
if (crc32("hpucHFpyPAprbhR",15) == 1219033109) strcat(s, "p");
if (crc32("eQQguGHS",8) == 2008935698) strcat(s, "l");
if (crc32("vIQoSqbtUYLK",12) == 839897928) strcat(s, "a");
if (crc32("HoUnhNaTigu",11) == 376209842) strcat(s, "I");
if (crc32("FSxjMeQQy",9) == 2908508853) strcat(s, "c");
if (crc32("UVQJaxO",7) == 2006347154) strcat(s, "a");
if (crc32("rpiGSWWKHGbZ",12) == 787800784) strcat(s, "e");
if (crc32("KQYcb",5) == 347200429) strcat(s, "n");
if (crc32("qeEDPhjw",8) == 4060789499) strcat(s, "t");
if (crc32("uEskDNcUW",9) == 1400644593) strcat(s, "a");
if (crc32("xPQzSpoEJf",10) == 1833550171) strcat(s, "l");
if (crc32("ajxYiVsuVt",10) == 4199275984) strcat(s, "c");
if (crc32("prZWzzR",7) == 440668108) strcat(s, "y");
    return s;
}

char *condensedly_adverbs() {
    char *s = calloc(12);
    if (crc32("ZgReXDSFjHCWKir",15) == 2189317392) strcat(s, "Q");
if (crc32("hCOcxYxf",8) == 3179418744) strcat(s, "c");
if (crc32("MXFAQuF",7) == 218103421) strcat(s, "o");
if (crc32("IArDsWNIaA",10) == 4026109180) strcat(s, "f");
if (crc32("guDAYpPnk",9) == 1566913275) strcat(s, "n");
if (crc32("auAdaC",6) == 3156018315) strcat(s, "d");
if (crc32("hpXpSy",6) == 1320174665) strcat(s, "e");
if (crc32("FxvQtjpcc",9) == 2127822869) strcat(s, "H");
if (crc32("ckHiE",5) == 949433099) strcat(s, "n");
if (crc32("eThGRkmGk",9) == 3588327) strcat(s, "s");
if (crc32("HIMopIMk",8) == 2659107389) strcat(s, "h");
if (crc32("MXqdnap",7) == 1177625990) strcat(s, "e");
if (crc32("fiilUpFMd",9) == 3066325085) strcat(s, "u");
if (crc32("iiTHHGeazCINTn",14) == 4141608857) strcat(s, "d");
if (crc32("NJAGYGs",7) == 1368524118) strcat(s, "l");
if (crc32("nWMUhvNaZRL",11) == 646117359) strcat(s, "u");
if (crc32("MhCEEqCOGhJZCiC",15) == 2782758967) strcat(s, "y");
    return s;
}

char *featly_adverbs() {
    char *s = calloc(7);
    if (crc32("gZzrEABK",8) == 3623258571) strcat(s, "S");
if (crc32("kpTunHpnahRcQn",14) == 2378854360) strcat(s, "f");
if (crc32("hIbJA",5) == 3378648545) strcat(s, "e");
if (crc32("cUqyxNeCocVW",12) == 1957299713) strcat(s, "a");
if (crc32("BowMfALxaJUvs",13) == 2590505898) strcat(s, "k");
if (crc32("fwPsfGVkxsqWC",13) == 1163109801) strcat(s, "t");
if (crc32("JNGnHWwGX",9) == 2543792759) strcat(s, "l");
if (crc32("RbjFTjfOexnv",12) == 650551936) strcat(s, "y");
    return s;
}

char *halfconvincingly_adverbs() {
    char *s = calloc(17);
    if (crc32("SWbYELWVWYZ",11) == 1780966297) strcat(s, "h");
if (crc32("vwxhOmYEWGyHIC",14) == 3100568926) strcat(s, "P");
if (crc32("lTOByNxHHk",10) == 3723148052) strcat(s, "a");
if (crc32("qSIvkSZTqCrbSc",14) == 3814460111) strcat(s, "L");
if (crc32("vNrKLiZxkex",11) == 628061964) strcat(s, "l");
if (crc32("Wmdzg",5) == 3431320931) strcat(s, "f");
if (crc32("JcjcOeGovqdSsIz",15) == 497918953) strcat(s, "c");
if (crc32("aEhDgxJaG",9) == 1337985851) strcat(s, "l");
if (crc32("uNbsSqbFi",9) == 2224766107) strcat(s, "o");
if (crc32("mJtbJhzImfNU",12) == 3664925626) strcat(s, "a");
if (crc32("SwMbKyApuoRWd",13) == 2814676328) strcat(s, "n");
if (crc32("ctmgHXQZpFsU",12) == 703698523) strcat(s, "v");
if (crc32("ePNunkYHDpvcr",13) == 4113041948) strcat(s, "w");
if (crc32("KzovnhZLlPygnU",14) == 2163077831) strcat(s, "i");
if (crc32("lKRDuKOpfeJI",12) == 4219391538) strcat(s, "W");
if (crc32("SyQmVmg",7) == 83299051) strcat(s, "n");
if (crc32("AgxMaE",6) == 4065176110) strcat(s, "c");
if (crc32("OeYaq",5) == 686830023) strcat(s, "i");
if (crc32("QcemX",5) == 3339092343) strcat(s, "D");
if (crc32("TNXKqyVdjFLIeZn",15) == 49269398) strcat(s, "n");
if (crc32("MUfKLsHlrZVKHL",14) == 545498060) strcat(s, "a");
if (crc32("XzJNgPL",7) == 3324949669) strcat(s, "g");
if (crc32("kkCWtU",6) == 3512918769) strcat(s, "O");
if (crc32("WlSZsTVxyj",10) == 4179816480) strcat(s, "l");
if (crc32("KYDdIGpztRfZV",13) == 20046800) strcat(s, "d");
if (crc32("XRiDLiEQTLBVJF",14) == 701862606) strcat(s, "y");
    return s;
}

char *commendingly_adverbs() {
    char *s = calloc(13);
    if (crc32("MXFEu",5) == 2978906921) strcat(s, "c");
if (crc32("MdlgLzBD",8) == 2662960303) strcat(s, "z");
if (crc32("AnpxSsGCewQzAj",14) == 689716434) strcat(s, "o");
if (crc32("XkOOZVZU",8) == 3643405637) strcat(s, "m");
if (crc32("RTpDvnYtkhxmUA",14) == 609821286) strcat(s, "Y");
if (crc32("siHWAMZCqzfI",12) == 1546229397) strcat(s, "m");
if (crc32("aWJDBuAtXfATP",13) == 2462304177) strcat(s, "O");
if (crc32("fDmmgRufAiwyevB",15) == 1199031075) strcat(s, "e");
if (crc32("uZQeUqUNwFouxK",14) == 468690011) strcat(s, "I");
if (crc32("qYxAc",5) == 3551398148) strcat(s, "n");
if (crc32("ISniYi",6) == 634257506) strcat(s, "d");
if (crc32("ANzlFVxbrnok",12) == 1377485888) strcat(s, "g");
if (crc32("UxDDIglsxvNIAP",14) == 3490907723) strcat(s, "i");
if (crc32("iidcuvbbgSpLK",13) == 1630167219) strcat(s, "T");
if (crc32("KBBsQBMkoZxS",12) == 3887540823) strcat(s, "n");
if (crc32("SyxvytUuJOf",11) == 718518615) strcat(s, "T");
if (crc32("lfhNjGYLXUmpLAL",15) == 3994525415) strcat(s, "g");
if (crc32("vJOqZ",5) == 2185584779) strcat(s, "l");
if (crc32("VBVnelTagafDYBZ",15) == 1327146859) strcat(s, "b");
if (crc32("whaJXLWNTDBarEv",15) == 285471181) strcat(s, "y");
    return s;
}

char *unassailably_adverbs() {
    char *s = calloc(13);
    if (crc32("CGWecZlrJNPNYnA",15) == 3087525368) strcat(s, "R");
if (crc32("MuALCIufXZRfl",13) == 3741639997) strcat(s, "u");
if (crc32("vVIEvOXLTjbSJ",13) == 2155218428) strcat(s, "O");
if (crc32("zWWIPehpFpE",11) == 3895198982) strcat(s, "n");
if (crc32("CfSDzRAzbD",10) == 1716348362) strcat(s, "a");
if (crc32("rlzRw",5) == 3317538828) strcat(s, "b");
if (crc32("cDFMewdb",8) == 218860513) strcat(s, "s");
if (crc32("wbSwLTDHauQNjYC",15) == 105966264) strcat(s, "I");
if (crc32("BvCODlbMlkJe",12) == 3273556424) strcat(s, "s");
if (crc32("DmNEjtAYG",9) == 2692672458) strcat(s, "a");
if (crc32("yOgZvtNiZyKM",12) == 3191198877) strcat(s, "j");
if (crc32("vgyqybkYRy",10) == 941542327) strcat(s, "i");
if (crc32("iseGhaC",7) == 2350047690) strcat(s, "l");
if (crc32("QKtsgaUPJHm",11) == 4220811910) strcat(s, "a");
if (crc32("SQbzlLVOHTGGxq",14) == 3375678006) strcat(s, "b");
if (crc32("CbNoefaankeYsm",14) == 3130120716) strcat(s, "o");
if (crc32("hZmMwpnoF",9) == 2209154351) strcat(s, "l");
if (crc32("bvkBflihDgRFwV",14) == 672172075) strcat(s, "y");
    return s;
}

char *prehistorically_adverbs() {
    char *s = calloc(16);
    if (crc32("cjHZHDWC",8) == 3056908934) strcat(s, "p");
if (crc32("uxXIxGd",7) == 2235005320) strcat(s, "r");
if (crc32("YKfLOkCuQeccf",13) == 510897430) strcat(s, "g");
if (crc32("OlRmK",5) == 856950546) strcat(s, "e");
if (crc32("BHYEUnQe",8) == 720609428) strcat(s, "A");
if (crc32("sesOxAyLsHsU",12) == 555752625) strcat(s, "h");
if (crc32("USXAt",5) == 2000502159) strcat(s, "K");
if (crc32("smyxflJeim",10) == 2158374523) strcat(s, "i");
if (crc32("LrGnHpZZJn",10) == 529935976) strcat(s, "U");
if (crc32("fkEPdE",6) == 1188861627) strcat(s, "s");
if (crc32("PbjkqlkYmVBmqMf",15) == 3821878373) strcat(s, "f");
if (crc32("rcnlB",5) == 2138111586) strcat(s, "t");
if (crc32("RfUWGCECKH",10) == 2656857847) strcat(s, "n");
if (crc32("lVKNoSIottFeXl",14) == 1640535073) strcat(s, "o");
if (crc32("uLiKyrXJODUFPcw",15) == 736265640) strcat(s, "M");
if (crc32("LOundurP",8) == 1151522922) strcat(s, "r");
if (crc32("QOnilLVasUqi",12) == 3448263573) strcat(s, "i");
if (crc32("QLWPsSkS",8) == 657368029) strcat(s, "I");
if (crc32("jeQwGSwRURK",11) == 255523861) strcat(s, "c");
if (crc32("hNlAXr",6) == 968837053) strcat(s, "d");
if (crc32("toBiZgyRw",9) == 2004655844) strcat(s, "a");
if (crc32("bmycXaUR",8) == 3929480077) strcat(s, "l");
if (crc32("rlLuFyoHmCWxy",13) == 4212877687) strcat(s, "l");
if (crc32("fdJTTqbua",9) == 2787330377) strcat(s, "Q");
if (crc32("sLAkU",5) == 1170373223) strcat(s, "y");
    return s;
}

char *tyrannously_adverbs() {
    char *s = calloc(12);
    if (crc32("lNZoHomncUp",11) == 3066618870) strcat(s, "t");
if (crc32("jFbeQG",6) == 1530244627) strcat(s, "y");
if (crc32("JeCZANfysRZyTDy",15) == 399324500) strcat(s, "c");
if (crc32("YzfdCbnsYLMVu",13) == 1553469921) strcat(s, "r");
if (crc32("icWnmKw",7) == 293580081) strcat(s, "b");
if (crc32("xsLXizbmsNvvsdC",15) == 237372753) strcat(s, "a");
if (crc32("nAbEGC",6) == 1362888507) strcat(s, "n");
if (crc32("Zndtx",5) == 892044871) strcat(s, "n");
if (crc32("Wngjtqo",7) == 2394435237) strcat(s, "o");
if (crc32("ETxIKE",6) == 3879685786) strcat(s, "u");
if (crc32("rRaGy",5) == 4223677142) strcat(s, "s");
if (crc32("UuuVAtftGnkUF",13) == 683339648) strcat(s, "l");
if (crc32("YLNCnmDbTn",10) == 4219690875) strcat(s, "t");
if (crc32("qpOgtNJhV",9) == 797645987) strcat(s, "y");
    return s;
}

char *thermoscopically_adverbs() {
    char *s = calloc(17);
    if (crc32("mBbxvu",6) == 4266044307) strcat(s, "k");
if (crc32("xEisi",5) == 3559978874) strcat(s, "t");
if (crc32("POPWx",5) == 3391147587) strcat(s, "c");
if (crc32("QGfpCHQGYNmvDZ",14) == 3492957207) strcat(s, "h");
if (crc32("jUrbNBqbqnkZFt",14) == 3452098911) strcat(s, "e");
if (crc32("aQpBuSXsTWIfL",13) == 4167082849) strcat(s, "n");
if (crc32("wfTHTNw",7) == 840156221) strcat(s, "r");
if (crc32("VOBFs",5) == 54435982) strcat(s, "U");
if (crc32("IjiHrLDaQkT",11) == 2685069924) strcat(s, "m");
if (crc32("rOUxWERVYBR",11) == 3558670524) strcat(s, "o");
if (crc32("iHvXzp",6) == 1603570865) strcat(s, "s");
if (crc32("gDqyRcBf",8) == 1996431553) strcat(s, "c");
if (crc32("sKkhFFE",7) == 3783383609) strcat(s, "o");
if (crc32("eRwhroojouV",11) == 1045346024) strcat(s, "p");
if (crc32("QQnMWNIA",8) == 755366804) strcat(s, "v");
if (crc32("RXnAocmLht",10) == 3712790219) strcat(s, "i");
if (crc32("JJBjXgToQzHXN",13) == 676415272) strcat(s, "y");
if (crc32("ZewIbgMxr",9) == 4232761970) strcat(s, "c");
if (crc32("LiFUFss",7) == 2740270937) strcat(s, "a");
if (crc32("HjzAv",5) == 4082676793) strcat(s, "l");
if (crc32("qJWcYDmzf",9) == 3253065826) strcat(s, "l");
if (crc32("QnxLpdyTbIHd",12) == 3154244921) strcat(s, "X");
if (crc32("gRLCg",5) == 4248176624) strcat(s, "y");
    return s;
}

char *untrivially_adverbs() {
    char *s = calloc(12);
    if (crc32("HXXKrIZ",7) == 3798377006) strcat(s, "D");
if (crc32("ZonYrFbIiXU",11) == 2261729291) strcat(s, "u");
if (crc32("XnvarXp",7) == 1011389658) strcat(s, "Y");
if (crc32("WwNqwatCv",9) == 2068304930) strcat(s, "n");
if (crc32("iMgsOqQcvG",10) == 1951049395) strcat(s, "t");
if (crc32("STkXdl",6) == 2780219035) strcat(s, "a");
if (crc32("gxnAvyeakTexpcy",15) == 1282940972) strcat(s, "r");
if (crc32("aDlzH",5) == 464992325) strcat(s, "D");
if (crc32("qeYtj",5) == 2335250648) strcat(s, "i");
if (crc32("MPLagLgmirNUZ",13) == 3730856329) strcat(s, "y");
if (crc32("CQWMfZSNp",9) == 803862730) strcat(s, "v");
if (crc32("gfIBnivkTGRzQpx",15) == 584205511) strcat(s, "i");
if (crc32("EJeixxJPC",9) == 4108793261) strcat(s, "p");
if (crc32("RxSbRavqD",9) == 1153007377) strcat(s, "a");
if (crc32("MWfUyWTcNtrU",12) == 840611127) strcat(s, "g");
if (crc32("yIFxCfi",7) == 3236303612) strcat(s, "l");
if (crc32("sQCMZCIsnuiZ",12) == 3814911059) strcat(s, "m");
if (crc32("ShQDPnyNfOa",11) == 523847892) strcat(s, "l");
if (crc32("vecDtnvWSBaLqDJ",15) == 2009595352) strcat(s, "b");
if (crc32("XaJiisOywwG",11) == 2511586250) strcat(s, "y");
    return s;
}

char *uneuphoniously_adverbs() {
    char *s = calloc(15);
    if (crc32("QtXXrrVItbYGevi",15) == 210537594) strcat(s, "d");
if (crc32("VcGhYItqLQx",11) == 3180616625) strcat(s, "u");
if (crc32("PoLXzlmTohovU",13) == 1895930883) strcat(s, "n");
if (crc32("ipZNdYyVkHhll",13) == 724649706) strcat(s, "e");
if (crc32("ehBqsFR",7) == 604304265) strcat(s, "u");
if (crc32("oDaDhUgC",8) == 3824861343) strcat(s, "p");
if (crc32("FyZSu",5) == 3614741920) strcat(s, "h");
if (crc32("MbZgQqFvpRYok",13) == 2757445804) strcat(s, "o");
if (crc32("pQInThZlhGiCD",13) == 4235484011) strcat(s, "M");
if (crc32("IktlGFhpfPx",11) == 4150354802) strcat(s, "n");
if (crc32("JWCjfgWsTDLKSa",14) == 239567679) strcat(s, "z");
if (crc32("ztEAss",6) == 128289856) strcat(s, "i");
if (crc32("kCrUaS",6) == 3915883079) strcat(s, "o");
if (crc32("gNZcZBAGy",9) == 1339970400) strcat(s, "u");
if (crc32("yvSlmAoZ",8) == 1586648957) strcat(s, "s");
if (crc32("gmoRjQ",6) == 3979270943) strcat(s, "A");
if (crc32("tAVfPnbTcxI",11) == 1460218165) strcat(s, "l");
if (crc32("oFZvupUBgqUlWF",14) == 2470639837) strcat(s, "D");
if (crc32("kiZuYrZHOOHOKA",14) == 4190824814) strcat(s, "y");
    return s;
}

char *overgloomily_adverbs() {
    char *s = calloc(13);
    if (crc32("qlGMKQgMDytr",12) == 864442487) strcat(s, "o");
if (crc32("BskwSzUjmZwsqc",14) == 3368646897) strcat(s, "n");
if (crc32("kmKNKPrkLax",11) == 582246336) strcat(s, "v");
if (crc32("dAPXiJMQSA",10) == 512109218) strcat(s, "e");
if (crc32("fdoXFkrC",8) == 4122939224) strcat(s, "r");
if (crc32("qLIanZ",6) == 4083476808) strcat(s, "s");
if (crc32("DCFEzUVXJLwBwuz",15) == 2318922172) strcat(s, "g");
if (crc32("FHCdRlTZD",9) == 1041037304) strcat(s, "l");
if (crc32("QsnBGBuZW",9) == 2388108324) strcat(s, "n");
if (crc32("NzmRugchfQDCuC",14) == 2209063978) strcat(s, "o");
if (crc32("BgOPdHL",7) == 1119088572) strcat(s, "o");
if (crc32("IIGhnLKMApp",11) == 2989409926) strcat(s, "p");
if (crc32("ouWAyy",6) == 2314512472) strcat(s, "m");
if (crc32("bQJTxqwOFK",10) == 3585515039) strcat(s, "i");
if (crc32("lDBABb",6) == 379258976) strcat(s, "t");
if (crc32("geHwzIxDsZLRP",13) == 749653555) strcat(s, "l");
if (crc32("ShERQlZaEj",10) == 3589897823) strcat(s, "y");
    return s;
}

char *predomestically_adverbs() {
    char *s = calloc(16);
    if (crc32("KsdSEOpXiuwWX",13) == 2016277614) strcat(s, "s");
if (crc32("eauyg",5) == 1803223993) strcat(s, "p");
if (crc32("FrSuQZRSf",9) == 3995029827) strcat(s, "f");
if (crc32("xfsrpgMCS",9) == 785094477) strcat(s, "r");
if (crc32("oZfPaIVY",8) == 3787685604) strcat(s, "g");
if (crc32("ZOYHC",5) == 3287197700) strcat(s, "e");
if (crc32("RHULtRTJ",8) == 3519946642) strcat(s, "U");
if (crc32("ZPGmO",5) == 1013579131) strcat(s, "d");
if (crc32("sRbrDHehDw",10) == 2808869148) strcat(s, "o");
if (crc32("AdgwpjWKv",9) == 1294364643) strcat(s, "m");
if (crc32("tvKJhL",6) == 328922002) strcat(s, "J");
if (crc32("TiPfmbojOnzlp",13) == 4261003859) strcat(s, "e");
if (crc32("uAHrI",5) == 3090717122) strcat(s, "s");
if (crc32("vRAgM",5) == 2177185313) strcat(s, "E");
if (crc32("jsDhtztutcau",12) == 2640076562) strcat(s, "t");
if (crc32("tYEey",5) == 2026545841) strcat(s, "w");
if (crc32("ExJgaudS",8) == 2086312907) strcat(s, "i");
if (crc32("UiiPzOFB",8) == 815265950) strcat(s, "c");
if (crc32("cWLhGbCRLAX",11) == 1493407025) strcat(s, "j");
if (crc32("wUqWHNtkBoxurB",14) == 3201870675) strcat(s, "a");
if (crc32("INPoQm",6) == 1718873696) strcat(s, "l");
if (crc32("cLVFn",5) == 2909465563) strcat(s, "l");
if (crc32("LdWpHEKlpa",10) == 3841375644) strcat(s, "m");
if (crc32("sTsdKoUP",8) == 3529146776) strcat(s, "y");
    return s;
}

char *phyletically_adverbs() {
    char *s = calloc(13);
    if (crc32("tQrDajHso",9) == 1789607753) strcat(s, "p");
if (crc32("kFrISQz",7) == 3579375318) strcat(s, "h");
if (crc32("GfiCATOqGPWL",12) == 2774278686) strcat(s, "y");
if (crc32("jnzZyCB",7) == 2401295090) strcat(s, "l");
if (crc32("QnREflxQXuRDIdx",15) == 2211704933) strcat(s, "o");
if (crc32("lJIHJOfbSRFC",12) == 2914556444) strcat(s, "e");
if (crc32("FECAzFfMJYqdvPT",15) == 2118936564) strcat(s, "t");
if (crc32("GUStb",5) == 1446486203) strcat(s, "i");
if (crc32("AOjjOy",6) == 1574767910) strcat(s, "m");
if (crc32("ArjGirNZjfl",11) == 1304224030) strcat(s, "c");
if (crc32("fvQpByI",7) == 3661728749) strcat(s, "W");
if (crc32("DpUgQt",6) == 2572874259) strcat(s, "a");
if (crc32("ACleLTXxLIeYP",13) == 2601341720) strcat(s, "B");
if (crc32("BsFFi",5) == 2076259147) strcat(s, "l");
if (crc32("QSNNdDlAkBOQ",12) == 3342792882) strcat(s, "R");
if (crc32("eZuocLQWj",9) == 1230671874) strcat(s, "l");
if (crc32("llTyLeh",7) == 1468773119) strcat(s, "y");
    return s;
}

char *overgreedily_adverbs() {
    char *s = calloc(13);
    if (crc32("tLeNcxWGXG",10) == 1044072262) strcat(s, "Y");
if (crc32("JmxyTUfq",8) == 504420446) strcat(s, "o");
if (crc32("keckDj",6) == 4192129063) strcat(s, "H");
if (crc32("EWJpduRcjSfxb",13) == 4172567236) strcat(s, "v");
if (crc32("zlWEnWTSVYiz",12) == 2105620065) strcat(s, "U");
if (crc32("SkUTTjCdEUYh",12) == 3326021218) strcat(s, "e");
if (crc32("DRbfdWuHQzqWPp",14) == 901654081) strcat(s, "N");
if (crc32("lPCXruTGBXDA",12) == 2040649327) strcat(s, "r");
if (crc32("IzSRQAqpGiyF",12) == 2798522573) strcat(s, "g");
if (crc32("BqlkUiD",7) == 1076151801) strcat(s, "b");
if (crc32("DgLXdHIAuty",11) == 1514268334) strcat(s, "r");
if (crc32("uTZFpIXseZp",11) == 3071845427) strcat(s, "e");
if (crc32("TRpfWhXur",9) == 1470355251) strcat(s, "D");
if (crc32("LBipcqRFzboxkZ",14) == 3161734461) strcat(s, "e");
if (crc32("GasNxSaGWpw",11) == 966029966) strcat(s, "Z");
if (crc32("rfyRVabcrqnOj",13) == 1831046583) strcat(s, "d");
if (crc32("ezZUYrGlIdOQR",13) == 2080854402) strcat(s, "n");
if (crc32("agRQWyMYHzP",11) == 281360037) strcat(s, "i");
if (crc32("bmYcSEI",7) == 4042501452) strcat(s, "R");
if (crc32("KVFrcmpxXXqp",12) == 2607551294) strcat(s, "l");
if (crc32("ADIxFvykJjwJFd",14) == 1701933118) strcat(s, "F");
if (crc32("pNpsWVEFk",9) == 623178813) strcat(s, "y");
    return s;
}

char *terribly_adverbs() {
    char *s = calloc(9);
    if (crc32("vBwzsnpmpfyW",12) == 4041186287) strcat(s, "t");
if (crc32("aUtJKJnsnv",10) == 2508310530) strcat(s, "e");
if (crc32("FskaNMAQuPxEBL",14) == 1851528154) strcat(s, "r");
if (crc32("MyucLhsmpGwy",12) == 824314519) strcat(s, "H");
if (crc32("VnvXxHk",7) == 798890958) strcat(s, "r");
if (crc32("ZGOfJUrzYc",10) == 2520155000) strcat(s, "i");
if (crc32("cxwdzmYAkZcyfM",14) == 3432302162) strcat(s, "b");
if (crc32("NqPQfdxDVG",10) == 3382335170) strcat(s, "C");
if (crc32("quabeEtJ",8) == 1008801119) strcat(s, "l");
if (crc32("gotEfbLcXXuRX",13) == 435902101) strcat(s, "y");
    return s;
}

char *trop_adverbs() {
    char *s = calloc(5);
    if (crc32("ZZUCSs",6) == 3101802304) strcat(s, "t");
if (crc32("DkHHPVGtdtcBlu",14) == 469259190) strcat(s, "Y");
if (crc32("KJIHpjPQVsXPU",13) == 4149192792) strcat(s, "r");
if (crc32("Ucwolpi",7) == 297173943) strcat(s, "D");
if (crc32("OsOGXzbIY",9) == 291354607) strcat(s, "o");
if (crc32("NtCEIsVFcGEbopM",15) == 943245192) strcat(s, "p");
    return s;
}

char *extraversively_adverbs() {
    char *s = calloc(15);
    if (crc32("snESMbFjHwpf",12) == 2760681228) strcat(s, "T");
if (crc32("wqtkZCXLNGpuX",13) == 3123181211) strcat(s, "e");
if (crc32("vDpEslAmKu",10) == 2700187033) strcat(s, "x");
if (crc32("mFmhqKoiG",9) == 1035634598) strcat(s, "t");
if (crc32("INfYDslA",8) == 2558459944) strcat(s, "P");
if (crc32("xxloMdHSSjtVA",13) == 2760877841) strcat(s, "r");
if (crc32("QAizxWr",7) == 1568232219) strcat(s, "a");
if (crc32("cOZWaGAVrjek",12) == 2659279110) strcat(s, "Q");
if (crc32("uIvvAVpWi",9) == 649862023) strcat(s, "v");
if (crc32("FVsSyVpXt",9) == 3826121828) strcat(s, "e");
if (crc32("wWnFpvYGpo",10) == 1338306078) strcat(s, "r");
if (crc32("gTkwjCeyIVurg",13) == 2557848167) strcat(s, "s");
if (crc32("MoHzNQ",6) == 227350893) strcat(s, "b");
if (crc32("ZVteidmYFjCFlH",14) == 478383029) strcat(s, "i");
if (crc32("IspaWcJKXyEQf",13) == 74998856) strcat(s, "v");
if (crc32("VMvHU",5) == 168171935) strcat(s, "Z");
if (crc32("qukHEAlIe",9) == 1640920940) strcat(s, "e");
if (crc32("XEfJicuSg",9) == 4034589812) strcat(s, "c");
if (crc32("RbOZnxEHKN",10) == 4027628179) strcat(s, "l");
if (crc32("wVYJRkdQaoOo",12) == 3622365571) strcat(s, "y");
    return s;
}

char *aft_adverbs() {
    char *s = calloc(4);
    if (crc32("NbKEKQZxe",9) == 2554042679) strcat(s, "K");
if (crc32("HzPlyJiBVwuvfwL",15) == 598664792) strcat(s, "a");
if (crc32("XmKFiFCNUP",10) == 3734994905) strcat(s, "l");
if (crc32("QiElxvlZFM",10) == 1199699031) strcat(s, "f");
if (crc32("dgVIzDtg",8) == 456327036) strcat(s, "t");
    return s;
}

char *huntedly_adverbs() {
    char *s = calloc(9);
    if (crc32("DCBBGlEGbGVQDE",14) == 1126276593) strcat(s, "h");
if (crc32("ryqjDywUNzyBnKL",15) == 671276514) strcat(s, "u");
if (crc32("tNDATVAQiJrM",12) == 4165367382) strcat(s, "n");
if (crc32("OMEBnpqxaStFMpN",15) == 2087724411) strcat(s, "t");
if (crc32("uhXMNJ",6) == 3446141574) strcat(s, "e");
if (crc32("KuCwDJjF",8) == 258642102) strcat(s, "x");
if (crc32("fzcjFBC",7) == 204955171) strcat(s, "d");
if (crc32("YqLITJpmDIrqD",13) == 337087244) strcat(s, "l");
if (crc32("UlYIyyISWYry",12) == 1220042256) strcat(s, "l");
if (crc32("ofXMV",5) == 1719469535) strcat(s, "y");
    return s;
}

char *flirtatiously_adverbs() {
    char *s = calloc(14);
    if (crc32("eIPkHEnQavuo",12) == 2254839045) strcat(s, "f");
if (crc32("sBbOr",5) == 1973890629) strcat(s, "a");
if (crc32("FVIGBAynWFOXNc",14) == 1971790167) strcat(s, "l");
if (crc32("phidflxOTvFxY",13) == 2023415998) strcat(s, "a");
if (crc32("KBsVTVSyQ",9) == 2042587129) strcat(s, "i");
if (crc32("pBkCmtIut",9) == 2197518552) strcat(s, "r");
if (crc32("LWMKLDTNesxNuo",14) == 3934952847) strcat(s, "t");
if (crc32("yFOgQu",6) == 1199320107) strcat(s, "a");
if (crc32("dQMCNZH",7) == 1115996097) strcat(s, "e");
if (crc32("SuNOEDHWPVaY",12) == 1265738696) strcat(s, "t");
if (crc32("fnDivvImlKxMUx",14) == 2751641744) strcat(s, "V");
if (crc32("DnynWOXxqwlOTy",14) == 3018442613) strcat(s, "i");
if (crc32("CuFqFBdEeiMzEC",14) == 348135033) strcat(s, "o");
if (crc32("bVtPyvBieaCmNk",14) == 4281366370) strcat(s, "A");
if (crc32("VNVGYuMvY",9) == 4085042803) strcat(s, "u");
if (crc32("cfUrm",5) == 763405305) strcat(s, "w");
if (crc32("salwrw",6) == 1795180980) strcat(s, "s");
if (crc32("fjUgTAVLVfliOP",14) == 174708479) strcat(s, "w");
if (crc32("emBLfhTKWsPND",13) == 3201016857) strcat(s, "l");
if (crc32("fkXTEhmyseSS",12) == 2279379052) strcat(s, "y");
    return s;
}

char *septically_adverbs() {
    char *s = calloc(11);
    if (crc32("tIlmVPWryuK",11) == 3917156077) strcat(s, "r");
if (crc32("TdevenfZfiBIj",13) == 247445595) strcat(s, "s");
if (crc32("wwDbx",5) == 96372432) strcat(s, "e");
if (crc32("UUYyfCHdUeUHCO",14) == 2330619707) strcat(s, "L");
if (crc32("IAyMLEdLoOXOD",13) == 2463324671) strcat(s, "p");
if (crc32("sSrkWifBxcHmMV",14) == 485569788) strcat(s, "Q");
if (crc32("UbNTPMrYjvld",12) == 4229662595) strcat(s, "t");
if (crc32("cFEZtEtwf",9) == 3774617146) strcat(s, "i");
if (crc32("OPvUvceu",8) == 3673084140) strcat(s, "x");
if (crc32("pfvBlIOHiN",10) == 828454132) strcat(s, "c");
if (crc32("yDmIS",5) == 3194058294) strcat(s, "d");
if (crc32("hfgDAmAjWte",11) == 2967111451) strcat(s, "a");
if (crc32("LMTbErAOfmc",11) == 3748551796) strcat(s, "l");
if (crc32("RtahGL",6) == 908816536) strcat(s, "D");
if (crc32("cxaUozlQL",9) == 255266417) strcat(s, "l");
if (crc32("gjFpyJqOO",9) == 1996701305) strcat(s, "y");
    return s;
}

char *overabundantly_adverbs() {
    char *s = calloc(15);
    if (crc32("hrVBMrwZqBDBWe",14) == 819145259) strcat(s, "o");
if (crc32("MwFlWsmJj",9) == 602639366) strcat(s, "v");
if (crc32("FCTSzvQEofBzgvc",15) == 3775520477) strcat(s, "l");
if (crc32("TEAmDrpfs",9) == 1019459709) strcat(s, "e");
if (crc32("ulQXzgQYZV",10) == 2030921869) strcat(s, "Z");
if (crc32("ZaYzuojoErj",11) == 500709332) strcat(s, "r");
if (crc32("AvIgnhYXBHl",11) == 606543690) strcat(s, "a");
if (crc32("FUULRuLDcTzrlQ",14) == 3105038539) strcat(s, "f");
if (crc32("PmfGiSqANuRAHkV",15) == 2818402360) strcat(s, "b");
if (crc32("TasWDpvZaYX",11) == 630213893) strcat(s, "u");
if (crc32("UTYtxVCmtLus",12) == 778242370) strcat(s, "n");
if (crc32("dgHFHvE",7) == 549595924) strcat(s, "d");
if (crc32("DyAstXVeA",9) == 3391688728) strcat(s, "a");
if (crc32("TAkyJ",5) == 4018985050) strcat(s, "E");
if (crc32("RugqfysGWh",10) == 3838644883) strcat(s, "n");
if (crc32("YbswohDtiW",10) == 2303757916) strcat(s, "t");
if (crc32("pjManryROO",10) == 4110699672) strcat(s, "D");
if (crc32("WGjGNI",6) == 170789416) strcat(s, "l");
if (crc32("fwsLxoMiO",9) == 580190565) strcat(s, "t");
if (crc32("WexbJDtQyaWXa",13) == 896388563) strcat(s, "y");
    return s;
}

char *selfconsistently_adverbs() {
    char *s = calloc(17);
    if (crc32("vwzPn",5) == 261064410) strcat(s, "s");
if (crc32("xVnCAOr",7) == 2402103306) strcat(s, "e");
if (crc32("xTtDbymNfireIv",14) == 1745292339) strcat(s, "o");
if (crc32("rYuFtLCtCZOeWgt",15) == 2535660507) strcat(s, "l");
if (crc32("nxwRduNqXjFKw",13) == 3697798041) strcat(s, "A");
if (crc32("WxSFWpjxTl",10) == 1941464000) strcat(s, "f");
if (crc32("QISlWrrNl",9) == 4000787548) strcat(s, "c");
if (crc32("XBvHeSBA",8) == 3455898830) strcat(s, "t");
if (crc32("qSXoRYsDnyUQQi",14) == 3658791532) strcat(s, "o");
if (crc32("NxcMHjPNBVrDIja",15) == 349619497) strcat(s, "N");
if (crc32("HGCjusZqovTwGP",14) == 2401693668) strcat(s, "n");
if (crc32("KkmgBjiMS",9) == 336785492) strcat(s, "n");
if (crc32("KBujvbTGBLu",11) == 4057423080) strcat(s, "s");
if (crc32("VDNVkKGfNQ",10) == 112977146) strcat(s, "z");
if (crc32("kEdBcRpFpF",10) == 3131455050) strcat(s, "i");
if (crc32("usunqcLdhOyWlwY",15) == 2895042166) strcat(s, "s");
if (crc32("mOzuNFkhv",9) == 2702393765) strcat(s, "t");
if (crc32("CDLmLHajchP",11) == 3699586837) strcat(s, "e");
if (crc32("DbFYcququcUT",12) == 1002558770) strcat(s, "n");
if (crc32("NzXaYDcHsebK",12) == 1283209292) strcat(s, "s");
if (crc32("xrWMXWg",7) == 2748268195) strcat(s, "t");
if (crc32("XZdRyefCkX",10) == 3904422403) strcat(s, "G");
if (crc32("tYrts",5) == 2841629040) strcat(s, "l");
if (crc32("faDRjGaDxRONGi",14) == 2423915473) strcat(s, "A");
if (crc32("gqwZAdsg",8) == 707118381) strcat(s, "y");
    return s;
}

char *aback_adverbs() {
    char *s = calloc(6);
    if (crc32("IdXoNkkleRcm",12) == 541700786) strcat(s, "q");
if (crc32("tRYyTqgPCiQkuc",14) == 1843521104) strcat(s, "a");
if (crc32("xsXLsfIz",8) == 864634024) strcat(s, "W");
if (crc32("XSjFDLGxG",9) == 81222843) strcat(s, "b");
if (crc32("QxovfMXnJ",9) == 751078092) strcat(s, "a");
if (crc32("faNcBeD",7) == 1658292062) strcat(s, "c");
if (crc32("sJNNydDqyACtEF",14) == 4031144683) strcat(s, "k");
    return s;
}

char *unimaginatively_adverbs() {
    char *s = calloc(16);
    if (crc32("RQGGKhTgt",9) == 1176172413) strcat(s, "N");
if (crc32("LiljLnxRinUNHn",14) == 1794027149) strcat(s, "u");
if (crc32("KQaAKVw",7) == 3305584742) strcat(s, "n");
if (crc32("MpEBSuNOLF",10) == 3000146899) strcat(s, "i");
if (crc32("PdtkmkJUodA",11) == 3472414858) strcat(s, "m");
if (crc32("kVIIWRRhFiMP",12) == 2922166062) strcat(s, "K");
if (crc32("mVOTrPtMYAmho",13) == 1723689661) strcat(s, "a");
if (crc32("jacdybCKr",9) == 2693377268) strcat(s, "g");
if (crc32("BGdDhQ",6) == 1797147416) strcat(s, "i");
if (crc32("YqHOwKGmwoIYc",13) == 7573225) strcat(s, "n");
if (crc32("EgskhzdoFdv",11) == 1794886032) strcat(s, "a");
if (crc32("hjkuWCGPz",9) == 2341044395) strcat(s, "r");
if (crc32("PFWfhLsrAdswQ",13) == 2907505894) strcat(s, "t");
if (crc32("vwCVJqrfTfkLOHP",15) == 1416701225) strcat(s, "i");
if (crc32("bNXMMjqb",8) == 448849468) strcat(s, "v");
if (crc32("QiehqaG",7) == 958726318) strcat(s, "r");
if (crc32("AfoBMpCFyG",10) == 3325281233) strcat(s, "e");
if (crc32("zatWXKYdtJss",12) == 517053299) strcat(s, "l");
if (crc32("XkFTDIm",7) == 429031070) strcat(s, "y");
    return s;
}

char *antisensuously_adverbs() {
    char *s = calloc(15);
    if (crc32("ORkFWmaUHTDyQlx",15) == 1279644557) strcat(s, "y");
if (crc32("nvdGIHo",7) == 1795799192) strcat(s, "a");
if (crc32("OKUCNhvQf",9) == 2143304932) strcat(s, "o");
if (crc32("OzELLJLqV",9) == 270336042) strcat(s, "n");
if (crc32("VoUAERxgUiCKz",13) == 2858456757) strcat(s, "t");
if (crc32("nxMryVhHf",9) == 2923050486) strcat(s, "i");
if (crc32("QAWvCs",6) == 125637809) strcat(s, "s");
if (crc32("AbzqENAtD",9) == 2502611862) strcat(s, "e");
if (crc32("fyvIFva",7) == 4268656316) strcat(s, "n");
if (crc32("rEFVNbqdHr",10) == 3868349013) strcat(s, "s");
if (crc32("BXiVF",5) == 518846711) strcat(s, "i");
if (crc32("KhbiMwwt",8) == 2000952348) strcat(s, "u");
if (crc32("KtqZALiYegCjPy",14) == 2618718422) strcat(s, "o");
if (crc32("wEfOUvNz",8) == 1575572836) strcat(s, "R");
if (crc32("YKrsRhbonfOa",12) == 1057955774) strcat(s, "u");
if (crc32("xvQTvRZ",7) == 2378384062) strcat(s, "s");
if (crc32("oqwbITqT",8) == 564943645) strcat(s, "u");
if (crc32("sMYfOUmYqZrlHEz",15) == 3568704210) strcat(s, "l");
if (crc32("fXNqaTm",7) == 2579244679) strcat(s, "L");
if (crc32("TrIzL",5) == 527883401) strcat(s, "y");
    return s;
}

char *scripturally_adverbs() {
    char *s = calloc(13);
    if (crc32("tQzxkzYxh",9) == 1751531722) strcat(s, "B");
if (crc32("akHHOl",6) == 2403658003) strcat(s, "s");
if (crc32("cIwRkVwLVClXHi",14) == 3162236454) strcat(s, "c");
if (crc32("vCQElsSfrj",10) == 485672080) strcat(s, "r");
if (crc32("xPyVmEWIMmYeOFn",15) == 3417995748) strcat(s, "r");
if (crc32("vOlHFs",6) == 3595361313) strcat(s, "i");
if (crc32("EHyDcVShDYGWZRF",15) == 850436481) strcat(s, "u");
if (crc32("wWDIeKfsszJ",11) == 2491227113) strcat(s, "p");
if (crc32("ZYPzVZSBtGy",11) == 904005885) strcat(s, "N");
if (crc32("fIjxCGMM",8) == 1932960062) strcat(s, "t");
if (crc32("iHBbL",5) == 1461702595) strcat(s, "u");
if (crc32("DsdIpTFPUnk",11) == 194365015) strcat(s, "r");
if (crc32("ATMXMFli",8) == 207995331) strcat(s, "a");
if (crc32("mKQjakjcpNjBE",13) == 472918011) strcat(s, "l");
if (crc32("nMLMCQP",7) == 1003340179) strcat(s, "i");
if (crc32("dMYtEiooCP",10) == 492018784) strcat(s, "l");
if (crc32("pGkRCsPAAajGKRq",15) == 2263553527) strcat(s, "F");
if (crc32("CFwSElbTaDelS",13) == 137530340) strcat(s, "y");
    return s;
}

char *nonabidingly_adverbs() {
    char *s = calloc(13);
    if (crc32("VKOjCWLJV",9) == 3296988632) strcat(s, "N");
if (crc32("eBsdAkSOGfDUy",13) == 3128893297) strcat(s, "n");
if (crc32("fhDHPsyQupSXE",13) == 2035820753) strcat(s, "j");
if (crc32("tmkQSTH",7) == 1683544130) strcat(s, "o");
if (crc32("bLvGnG",6) == 1102728357) strcat(s, "n");
if (crc32("FNUYsO",6) == 4073665121) strcat(s, "a");
if (crc32("ZWDDPRI",7) == 1500940409) strcat(s, "b");
if (crc32("UzddNpEBXP",10) == 480254471) strcat(s, "R");
if (crc32("EPcsdN",6) == 966113639) strcat(s, "i");
if (crc32("XpCQNm",6) == 300615628) strcat(s, "d");
if (crc32("GxnumUZINbO",11) == 3897179260) strcat(s, "i");
if (crc32("nbpJaTYFc",9) == 1392843561) strcat(s, "n");
if (crc32("oWchOhAafROAtOL",15) == 1203038320) strcat(s, "g");
if (crc32("bWPEdr",6) == 2081153555) strcat(s, "l");
if (crc32("RGSemCfKxEPlB",13) == 262646651) strcat(s, "C");
if (crc32("jdNoreksD",9) == 683163037) strcat(s, "y");
    return s;
}

char *telegraphically_adverbs() {
    char *s = calloc(16);
    if (crc32("aQuuosPas",9) == 1788652241) strcat(s, "t");
if (crc32("UwnhSc",6) == 3832274104) strcat(s, "r");
if (crc32("NHSqkObGCrWkbbA",15) == 2361653009) strcat(s, "e");
if (crc32("QjYyHgmVHY",10) == 217809394) strcat(s, "l");
if (crc32("zrhkcywqjJAnd",13) == 1546395520) strcat(s, "e");
if (crc32("GUcuFkHFjyY",11) == 3585238919) strcat(s, "x");
if (crc32("kLayZPAKzEOHSZ",14) == 3788687029) strcat(s, "g");
if (crc32("RltvuGMlSRRQ",12) == 624544357) strcat(s, "r");
if (crc32("pOfIbzrww",9) == 2666281477) strcat(s, "T");
if (crc32("aIqWxTKRTt",10) == 2842040931) strcat(s, "a");
if (crc32("eaEKwHnthTLNI",13) == 180906864) strcat(s, "q");
if (crc32("PtNJFVzcJ",9) == 3202116967) strcat(s, "p");
if (crc32("wpLHrAkeBuHZGYw",15) == 3023513579) strcat(s, "h");
if (crc32("VCpDiLTMUv",10) == 2111766967) strcat(s, "C");
if (crc32("LSzBl",5) == 1572081515) strcat(s, "i");
if (crc32("ALOhmlM",7) == 1019336886) strcat(s, "V");
if (crc32("wbuhJyCPVezxu",13) == 3847599708) strcat(s, "c");
if (crc32("IBDmEvbAVzVQ",12) == 3953261169) strcat(s, "a");
if (crc32("QsZgVvsU",8) == 2300387602) strcat(s, "z");
if (crc32("hIVIN",5) == 1368528639) strcat(s, "l");
if (crc32("XUufemWRizfpZHY",15) == 4048355118) strcat(s, "E");
if (crc32("PJxnbTgEGcZZi",13) == 860426061) strcat(s, "l");
if (crc32("VgkkdwTO",8) == 3924112470) strcat(s, "y");
    return s;
}

char *nonseditiously_adverbs() {
    char *s = calloc(15);
    if (crc32("xTxHSMykMyo",11) == 641136769) strcat(s, "W");
if (crc32("LriXsWcwDaORznq",15) == 1391442392) strcat(s, "n");
if (crc32("NnivqIvGhxnHGA",14) == 3126827486) strcat(s, "o");
if (crc32("MFPkyWXYWtMlj",13) == 828989492) strcat(s, "n");
if (crc32("oWcOrtkrraXFS",13) == 1474134560) strcat(s, "g");
if (crc32("KQyanoGiDfKujD",14) == 539666546) strcat(s, "s");
if (crc32("fjJZnXcADKTH",12) == 3526970262) strcat(s, "R");
if (crc32("TAxQEsGfCuCznhp",15) == 3557459505) strcat(s, "e");
if (crc32("jmOIfpSkdqVoWK",14) == 248160968) strcat(s, "K");
if (crc32("eyjDi",5) == 1694301501) strcat(s, "d");
if (crc32("eFqWhiKbnxdwsEZ",15) == 499772073) strcat(s, "F");
if (crc32("fmbhnOXQV",9) == 3697471370) strcat(s, "i");
if (crc32("juVEMkJLIsxFGYi",15) == 2785736835) strcat(s, "E");
if (crc32("ijxdP",5) == 914568185) strcat(s, "t");
if (crc32("EWDVIhJn",8) == 3842826284) strcat(s, "n");
if (crc32("qGCfPTHQRPkY",12) == 2625610152) strcat(s, "i");
if (crc32("eLXHnctBAfZKzT",14) == 1478294086) strcat(s, "z");
if (crc32("PMGwWBTQVz",10) == 961323739) strcat(s, "o");
if (crc32("IgkqOV",6) == 4269442100) strcat(s, "u");
if (crc32("MmmiRxlNpTzBLL",14) == 3799543827) strcat(s, "g");
if (crc32("pMayDDxGNnSaw",13) == 2206079422) strcat(s, "s");
if (crc32("rvCuKfZElCq",11) == 3462582974) strcat(s, "l");
if (crc32("epwgCZwQvJCMVJh",15) == 1292038719) strcat(s, "y");
    return s;
}

char *quasifiscally_adverbs() {
    char *s = calloc(14);
    if (crc32("yVTEuxc",7) == 1047857615) strcat(s, "q");
if (crc32("NygyzWXUHhQ",11) == 203086724) strcat(s, "u");
if (crc32("XHHXc",5) == 3079624957) strcat(s, "m");
if (crc32("frCUFBBeog",10) == 2186874042) strcat(s, "a");
if (crc32("hQyNxywFKOiNblj",15) == 2406235452) strcat(s, "i");
if (crc32("MUqhugShAwV",11) == 1948160526) strcat(s, "s");
if (crc32("nehJrQNesOXQ",12) == 1907104352) strcat(s, "i");
if (crc32("OePAHQXylOa",11) == 744991716) strcat(s, "f");
if (crc32("xFvJk",5) == 829771855) strcat(s, "i");
if (crc32("HzhFARidY",9) == 2403127958) strcat(s, "s");
if (crc32("ptQRbbcm",8) == 4093376639) strcat(s, "c");
if (crc32("nlNMzrDMBOhV",12) == 1491892536) strcat(s, "a");
if (crc32("BPWzpr",6) == 1439266420) strcat(s, "l");
if (crc32("HZSHVvs",7) == 575669267) strcat(s, "G");
if (crc32("Dnudr",5) == 1560845740) strcat(s, "l");
if (crc32("RVPvaEFEEls",11) == 3861384261) strcat(s, "x");
if (crc32("qmqdM",5) == 2534637653) strcat(s, "y");
    return s;
}

char *unhumorously_adverbs() {
    char *s = calloc(13);
    if (crc32("KfyYJIwU",8) == 268488162) strcat(s, "u");
if (crc32("ulAbxDNjrfjET",13) == 1280716823) strcat(s, "t");
if (crc32("nXmLO",5) == 339287303) strcat(s, "n");
if (crc32("LFNIMsqoShpgQb",14) == 1179348203) strcat(s, "x");
if (crc32("mdNIjBu",7) == 1121429578) strcat(s, "h");
if (crc32("TWUZkw",6) == 1066803397) strcat(s, "L");
if (crc32("MmuYwcToLk",10) == 1055010256) strcat(s, "u");
if (crc32("yEyKtJXWz",9) == 3735593780) strcat(s, "E");
if (crc32("WNBFoScWw",9) == 1969782602) strcat(s, "m");
if (crc32("vxqjeXwhxNEgW",13) == 2292102733) strcat(s, "o");
if (crc32("WGdAO",5) == 168674811) strcat(s, "r");
if (crc32("UVsJKLW",7) == 2843834045) strcat(s, "o");
if (crc32("UVIjUxhrDuuT",12) == 957545405) strcat(s, "u");
if (crc32("juaSQAAtHajx",12) == 652220415) strcat(s, "s");
if (crc32("NiYKSxaFdUteZo",14) == 4027102006) strcat(s, "l");
if (crc32("QMFvIX",6) == 2383785486) strcat(s, "F");
if (crc32("uCWxKBsq",8) == 809718069) strcat(s, "y");
    return s;
}

char *nonhierarchically_adverbs() {
    char *s = calloc(18);
    if (crc32("gRHXBDKT",8) == 3643487447) strcat(s, "n");
if (crc32("JdFkLpkdiUxPLv",14) == 1578924803) strcat(s, "o");
if (crc32("wVKJOxvRpWSbg",13) == 921516600) strcat(s, "G");
if (crc32("sCruSgsBdt",10) == 3031145488) strcat(s, "n");
if (crc32("KBXjHZIUtG",10) == 1654229054) strcat(s, "h");
if (crc32("ImMiITNgyuDV",12) == 3518428116) strcat(s, "m");
if (crc32("LftEMeBvL",9) == 1444099018) strcat(s, "i");
if (crc32("GKNWdzZmIyWHzDO",15) == 686370625) strcat(s, "e");
if (crc32("FGNSwatDZO",10) == 1669057062) strcat(s, "r");
if (crc32("vBJgolouYeww",12) == 1297915369) strcat(s, "r");
if (crc32("vzFLTCK",7) == 4025703446) strcat(s, "a");
if (crc32("GnKIFuRwoGYl",12) == 675571510) strcat(s, "U");
if (crc32("XVpjQwfyhvaOMe",14) == 1169232506) strcat(s, "r");
if (crc32("KrvpsyinUTRs",12) == 875061173) strcat(s, "i");
if (crc32("dnAelJEsrs",10) == 3499359558) strcat(s, "c");
if (crc32("BTDmBTop",8) == 1178628105) strcat(s, "A");
if (crc32("VZTRnJbmc",9) == 678161463) strcat(s, "h");
if (crc32("lWpcjhrira",10) == 2311955821) strcat(s, "i");
if (crc32("UHfeD",5) == 120303228) strcat(s, "T");
if (crc32("NFuyTYYInFtr",12) == 2481956224) strcat(s, "c");
if (crc32("Jvrwh",5) == 3998741200) strcat(s, "a");
if (crc32("xvUxo",5) == 289980479) strcat(s, "l");
if (crc32("FYkvMuoGtfGeQz",14) == 770771847) strcat(s, "l");
if (crc32("dtZRmrrkzqmvWj",14) == 4197960767) strcat(s, "y");
    return s;
}

char *epidermically_adverbs() {
    char *s = calloc(14);
    if (crc32("mtSUGUeTKOofCCJ",15) == 1875005674) strcat(s, "e");
if (crc32("dHnAxorYfdSQSeA",15) == 2565542567) strcat(s, "Z");
if (crc32("taKcVgIeYzRSL",13) == 3959323266) strcat(s, "p");
if (crc32("QzuHq",5) == 2320203650) strcat(s, "i");
if (crc32("dfelfpo",7) == 2725403108) strcat(s, "d");
if (crc32("EBwLtdpS",8) == 849215922) strcat(s, "w");
if (crc32("lAtPOZPHPqDZir",14) == 1428189733) strcat(s, "e");
if (crc32("oxJecGEYH",9) == 526018989) strcat(s, "r");
if (crc32("AulOPWHYmS",10) == 2405413749) strcat(s, "s");
if (crc32("AaVllrdUJgtCif",14) == 1687970546) strcat(s, "m");
if (crc32("trJXdZ",6) == 1287945925) strcat(s, "s");
if (crc32("LkTcHz",6) == 2704579915) strcat(s, "i");
if (crc32("nCXHPUyjLFDR",12) == 1131398613) strcat(s, "g");
if (crc32("bwdqQHLk",8) == 39853663) strcat(s, "c");
if (crc32("RkuBFaetOudB",12) == 2404455276) strcat(s, "P");
if (crc32("rnAgjwOEfziqMS",14) == 2171113246) strcat(s, "a");
if (crc32("BnvXknuy",8) == 3589576084) strcat(s, "l");
if (crc32("oTapmhdBGrhDfnb",15) == 2824552514) strcat(s, "B");
if (crc32("tRSXaZyJymW",11) == 2873263981) strcat(s, "l");
if (crc32("qsrTXrsOyslSXHz",15) == 4108518714) strcat(s, "L");
if (crc32("JQdKUVZEG",9) == 878127334) strcat(s, "y");
    return s;
}

char *percontra_adverbs() {
    char *s = calloc(10);
    if (crc32("InXldCqVYoc",11) == 3459264351) strcat(s, "p");
if (crc32("JUOtPhicXGaOmwz",15) == 2247619484) strcat(s, "e");
if (crc32("QMVyOEqzLR",10) == 1298758599) strcat(s, "r");
if (crc32("oDwZCBltqo",10) == 28341807) strcat(s, "s");
if (crc32("WowfNxtwEt",10) == 3860782349) strcat(s, "c");
if (crc32("iJdMZnx",7) == 3972446830) strcat(s, "o");
if (crc32("MVeJO",5) == 718195166) strcat(s, "n");
if (crc32("IkcKmTVUuBCN",12) == 2209610621) strcat(s, "u");
if (crc32("cRPcCEuzr",9) == 3005835382) strcat(s, "t");
if (crc32("TZEXHOVHsa",10) == 147850488) strcat(s, "m");
if (crc32("Jkwyqv",6) == 3546913201) strcat(s, "r");
if (crc32("rBtyNVKO",8) == 3668334462) strcat(s, "a");
    return s;
}

char *unassumingly_adverbs() {
    char *s = calloc(13);
    if (crc32("inVVTuh",7) == 1895692761) strcat(s, "q");
if (crc32("EEqQLWzij",9) == 358328799) strcat(s, "u");
if (crc32("FXEWSIesEaS",11) == 3736621609) strcat(s, "n");
if (crc32("xmydNIj",7) == 1088381852) strcat(s, "a");
if (crc32("BmRlQIDPeQEKxlK",15) == 1988936329) strcat(s, "A");
if (crc32("dtkPpVSaUpNNFjt",15) == 2114952239) strcat(s, "s");
if (crc32("IALPR",5) == 4130859861) strcat(s, "s");
if (crc32("KkPMTlVrQptm",12) == 2152577391) strcat(s, "y");
if (crc32("nPKztmeFobin",12) == 3121476772) strcat(s, "u");
if (crc32("Ctejq",5) == 3407882499) strcat(s, "m");
if (crc32("FfdIntXsGUKJT",13) == 2058960549) strcat(s, "i");
if (crc32("eHEDUbsXce",10) == 3499543085) strcat(s, "e");
if (crc32("UlBhHyWcrmbesd",14) == 1383324156) strcat(s, "n");
if (crc32("gTDIByUqnORq",12) == 2400308010) strcat(s, "g");
if (crc32("oxbAYyRuXGxCH",13) == 137096444) strcat(s, "l");
if (crc32("xxhHz",5) == 1874793431) strcat(s, "y");
    return s;
}

char *perspectively_adverbs() {
    char *s = calloc(14);
    if (crc32("ezQINNdCdJv",11) == 3234808104) strcat(s, "p");
if (crc32("dQhVWLGnUxG",11) == 3088686002) strcat(s, "g");
if (crc32("EGXxHnvXgalO",12) == 4193796003) strcat(s, "e");
if (crc32("hCEtVlWsFEPg",12) == 504914607) strcat(s, "r");
if (crc32("YgPKGjs",7) == 812281379) strcat(s, "J");
if (crc32("JApGHCdP",8) == 2557757957) strcat(s, "s");
if (crc32("xOxRnNEtxFSplX",14) == 565428246) strcat(s, "p");
if (crc32("sBWziExVlO",10) == 1867848963) strcat(s, "v");
if (crc32("KJuRdH",6) == 2354173589) strcat(s, "e");
if (crc32("nxbuAE",6) == 2125105036) strcat(s, "W");
if (crc32("GJCsVESEF",9) == 2065754534) strcat(s, "c");
if (crc32("IEAZuBIzX",9) == 1965570523) strcat(s, "t");
if (crc32("JtnhYEZphb",10) == 3934982851) strcat(s, "K");
if (crc32("lgXxg",5) == 1787747046) strcat(s, "i");
if (crc32("XhWrpaeCoDolj",13) == 1166692892) strcat(s, "v");
if (crc32("rCkMKtlJjYaR",12) == 889483281) strcat(s, "e");
if (crc32("roklUgmyBmKbnQP",15) == 2814113787) strcat(s, "m");
if (crc32("fYRaavjL",8) == 325134114) strcat(s, "l");
if (crc32("CzAafdXhcH",10) == 4157172069) strcat(s, "y");
    return s;
}

char *amphibiously_adverbs() {
    char *s = calloc(13);
    if (crc32("DrAJTI",6) == 694881372) strcat(s, "a");
if (crc32("JzNIIEjOaycQhqk",15) == 1123506208) strcat(s, "m");
if (crc32("UPXWCuqSodiNx",13) == 2779894702) strcat(s, "p");
if (crc32("iMGzFFnmH",9) == 211091799) strcat(s, "h");
if (crc32("ohlsSgjUOz",10) == 1355091476) strcat(s, "f");
if (crc32("kELAOKhTsclYZNy",15) == 2296383492) strcat(s, "i");
if (crc32("EhqieJdRr",9) == 3368378555) strcat(s, "b");
if (crc32("GwDVntbXUgUk",12) == 1120935768) strcat(s, "i");
if (crc32("TarbdDDuZOOOnQM",15) == 2650289131) strcat(s, "F");
if (crc32("VFMmuTYZGYpHxL",14) == 2128662470) strcat(s, "o");
if (crc32("fyeJiNwuArzwzBP",15) == 4032849360) strcat(s, "u");
if (crc32("xRKpnvW",7) == 2308103431) strcat(s, "s");
if (crc32("pfSiUb",6) == 2651965252) strcat(s, "o");
if (crc32("PTqAHCGVSjVdcqW",15) == 2852803067) strcat(s, "l");
if (crc32("bwTJVSizksVKKRl",15) == 1354979251) strcat(s, "G");
if (crc32("YKfruARYJNUS",12) == 3829986190) strcat(s, "y");
    return s;
}

char *semiilliterately_adverbs() {
    char *s = calloc(17);
    if (crc32("KWxZdhdKbksZmel",15) == 2562535678) strcat(s, "s");
if (crc32("FAwFOicZgIoCm",13) == 1114765447) strcat(s, "e");
if (crc32("NLguwCLybyNak",13) == 2716355934) strcat(s, "m");
if (crc32("BlmlcmpRj",9) == 1656460636) strcat(s, "i");
if (crc32("pZOuK",5) == 1405101890) strcat(s, "i");
if (crc32("EiCbEpsQzMR",11) == 2083797829) strcat(s, "p");
if (crc32("ccdXXRQjpH",10) == 1005118369) strcat(s, "l");
if (crc32("oGQBUbJKMNqV",12) == 1602978797) strcat(s, "l");
if (crc32("wrIDfdjIbWh",11) == 580496141) strcat(s, "i");
if (crc32("KTqvZR",6) == 1593861146) strcat(s, "t");
if (crc32("TctPK",5) == 955762661) strcat(s, "e");
if (crc32("EqdAowPI",8) == 1073137962) strcat(s, "e");
if (crc32("KCEbsgS",7) == 718102674) strcat(s, "y");
if (crc32("MqjHPQTVxwmK",12) == 2006635263) strcat(s, "r");
if (crc32("JLlAgYY",7) == 1320241314) strcat(s, "a");
if (crc32("aholxrySiyFBWUS",15) == 513584070) strcat(s, "L");
if (crc32("OITWwWdD",8) == 3055283586) strcat(s, "t");
if (crc32("WeJZBQljAjVE",12) == 434653375) strcat(s, "F");
if (crc32("ffWzYrPWzSH",11) == 170257034) strcat(s, "e");
if (crc32("AMmyJAelFhyaN",13) == 2001278236) strcat(s, "c");
if (crc32("XLdlSHplyLLqneg",15) == 3283416818) strcat(s, "l");
if (crc32("Ybaghz",6) == 2856839423) strcat(s, "y");
    return s;
}

char *thankfully_adverbs() {
    char *s = calloc(11);
    if (crc32("foVMpa",6) == 4154706861) strcat(s, "t");
if (crc32("PvoxC",5) == 4225607775) strcat(s, "h");
if (crc32("gmMxZXWTYG",10) == 3913217260) strcat(s, "r");
if (crc32("QEflLxXAO",9) == 724261786) strcat(s, "a");
if (crc32("pdpUYfBqhspZgh",14) == 2868300195) strcat(s, "n");
if (crc32("EQrWA",5) == 4159762292) strcat(s, "p");
if (crc32("tHynu",5) == 350310789) strcat(s, "k");
if (crc32("wdKHatUQ",8) == 3130023592) strcat(s, "f");
if (crc32("yJZnWXR",7) == 2113006439) strcat(s, "u");
if (crc32("hWxgf",5) == 3979738223) strcat(s, "l");
if (crc32("tilAHpv",7) == 1024106823) strcat(s, "l");
if (crc32("SmAxGzN",7) == 3242373108) strcat(s, "y");
    return s;
}

char *consolitorily_adverbs() {
    char *s = calloc(14);
    if (crc32("kvUWzw",6) == 737343763) strcat(s, "c");
if (crc32("KmYtAqsNKdLAj",13) == 3348379455) strcat(s, "c");
if (crc32("KUyDrseVSs",10) == 2055538238) strcat(s, "o");
if (crc32("yQuXceUsve",10) == 1226722498) strcat(s, "n");
if (crc32("zyGXmF",6) == 3292128121) strcat(s, "s");
if (crc32("GMCrlzinaiRoSGK",15) == 624440818) strcat(s, "o");
if (crc32("zxPtFAgGRmH",11) == 2827262867) strcat(s, "Z");
if (crc32("HGWeO",5) == 1064861639) strcat(s, "l");
if (crc32("bacxqvBKkwKjNzb",15) == 143440536) strcat(s, "s");
if (crc32("RUOaUjeGWdgQt",13) == 2364931333) strcat(s, "i");
if (crc32("GjOAsnloCNR",11) == 4288126931) strcat(s, "t");
if (crc32("rjFOuRbZXakhtt",14) == 639269897) strcat(s, "x");
if (crc32("XBgIMFcKotfjfcn",15) == 1880828996) strcat(s, "o");
if (crc32("ADkouE",6) == 602358352) strcat(s, "r");
if (crc32("QrBAtgimfkwFub",14) == 3685245970) strcat(s, "i");
if (crc32("VeywgUbmeaQ",11) == 2919535205) strcat(s, "b");
if (crc32("UywozyUWNCWv",12) == 448186019) strcat(s, "l");
if (crc32("mIVCzmfU",8) == 4053857727) strcat(s, "g");
if (crc32("sxJuVWXEpzf",11) == 2516755353) strcat(s, "y");
    return s;
}

char *cuneately_adverbs() {
    char *s = calloc(10);
    if (crc32("DHQGNdPTc",9) == 1034372948) strcat(s, "c");
if (crc32("VruMWcBuDZAgcNI",15) == 3764301349) strcat(s, "n");
if (crc32("rORjlqZjjBdg",12) == 3300284389) strcat(s, "u");
if (crc32("NFaslefhFrOFjlF",15) == 1273635028) strcat(s, "x");
if (crc32("rjOUcaP",7) == 882408483) strcat(s, "n");
if (crc32("lAYyhqeqM",9) == 3820875025) strcat(s, "B");
if (crc32("cqDaxSqyzupy",12) == 3465984097) strcat(s, "e");
if (crc32("vrywYOaChXKRLt",14) == 101906560) strcat(s, "t");
if (crc32("MUMAejiG",8) == 1698556692) strcat(s, "a");
if (crc32("uQdABDXoZFLdec",14) == 4099940714) strcat(s, "b");
if (crc32("aTjcMSxU",8) == 577230277) strcat(s, "t");
if (crc32("rWTYSLVBSF",10) == 2405803571) strcat(s, "h");
if (crc32("ANnJMEwEVQO",11) == 1615707491) strcat(s, "e");
if (crc32("YvHJCjpx",8) == 1763127873) strcat(s, "V");
if (crc32("vakfLbrxqc",10) == 3556838124) strcat(s, "l");
if (crc32("ooiCGTyy",8) == 385981068) strcat(s, "I");
if (crc32("XjZzOJYrWnRSrSI",15) == 1328124875) strcat(s, "y");
    return s;
}

char *overseverely_adverbs() {
    char *s = calloc(13);
    if (crc32("iFLqIO",6) == 178462583) strcat(s, "o");
if (crc32("UjxSvp",6) == 3608338653) strcat(s, "v");
if (crc32("onbATk",6) == 2325884415) strcat(s, "e");
if (crc32("NCqvtjtr",8) == 2807469749) strcat(s, "o");
if (crc32("vuuaefC",7) == 1778224132) strcat(s, "r");
if (crc32("JcTIsA",6) == 3598604783) strcat(s, "s");
if (crc32("VVFTAXF",7) == 149358859) strcat(s, "s");
if (crc32("pOAegMPzVFOU",12) == 3408664824) strcat(s, "e");
if (crc32("hWUuiEUET",9) == 3351570538) strcat(s, "v");
if (crc32("NcMBLCmm",8) == 1137045998) strcat(s, "p");
if (crc32("YgzBovl",7) == 3259325246) strcat(s, "e");
if (crc32("wOlotDdtxLy",11) == 2762139107) strcat(s, "o");
if (crc32("fXZDFNgUFsrNAs",14) == 2498274549) strcat(s, "r");
if (crc32("RlMmFKWTYR",10) == 1523536443) strcat(s, "r");
if (crc32("LYFYazDIiVJcNQy",15) == 2817778610) strcat(s, "e");
if (crc32("hEGEJrbBlBmXmwY",15) == 2070772517) strcat(s, "l");
if (crc32("NLSja",5) == 998159546) strcat(s, "y");
    return s;
}

char *fictively_adverbs() {
    char *s = calloc(10);
    if (crc32("PVgJcNguMS",10) == 2715997904) strcat(s, "N");
if (crc32("FXFxIFRMsVa",11) == 2388192465) strcat(s, "f");
if (crc32("hIMvZiYmxRBXt",13) == 3297309839) strcat(s, "i");
if (crc32("StqtuyN",7) == 44997028) strcat(s, "c");
if (crc32("DeWUIo",6) == 1380208895) strcat(s, "x");
if (crc32("lBPJDVTKxMc",11) == 1100138792) strcat(s, "t");
if (crc32("alPbnUu",7) == 3276631493) strcat(s, "i");
if (crc32("JOOYzfiJAS",10) == 2971741491) strcat(s, "v");
if (crc32("wSeqvaaBMNSMzm",14) == 3340477386) strcat(s, "G");
if (crc32("GyemvXwt",8) == 503084588) strcat(s, "e");
if (crc32("bmmmVXPPcb",10) == 2723296357) strcat(s, "l");
if (crc32("BheAxXbx",8) == 1314451515) strcat(s, "y");
    return s;
}

char *uneffulgently_adverbs() {
    char *s = calloc(14);
    if (crc32("ihasoV",6) == 2184906363) strcat(s, "u");
if (crc32("FQFPEicj",8) == 1434540422) strcat(s, "z");
if (crc32("RDIaqqaNt",9) == 1660364067) strcat(s, "n");
if (crc32("jgdvun",6) == 1337469453) strcat(s, "S");
if (crc32("YqCdRcKJS",9) == 1375687043) strcat(s, "e");
if (crc32("UMDJaXuqdD",10) == 1828652572) strcat(s, "f");
if (crc32("fgherOSJZdzNga",14) == 3197415475) strcat(s, "f");
if (crc32("uRWmZWQxtAab",12) == 1261862436) strcat(s, "s");
if (crc32("VEdNq",5) == 3684509092) strcat(s, "u");
if (crc32("VDtPmfI",7) == 3518650765) strcat(s, "p");
if (crc32("spKtB",5) == 3156292593) strcat(s, "l");
if (crc32("NSlGATQuPIZJck",14) == 2114771900) strcat(s, "x");
if (crc32("AZeTzzlVefcjen",14) == 2515625832) strcat(s, "g");
if (crc32("YxMzZWpXdKY",11) == 2953227135) strcat(s, "e");
if (crc32("cfxGHGNOlzx",11) == 2644863588) strcat(s, "n");
if (crc32("vvIurcICD",9) == 4208746108) strcat(s, "t");
if (crc32("vEzdaKhDqQMsnID",15) == 2668394763) strcat(s, "T");
if (crc32("SigRVg",6) == 1493497227) strcat(s, "l");
if (crc32("supkCBWc",8) == 2242367373) strcat(s, "i");
if (crc32("EhtPaQHVb",9) == 2208040387) strcat(s, "y");
    return s;
}

char *crustily_adverbs() {
    char *s = calloc(9);
    if (crc32("PrAAWWBmdfzm",12) == 3709821609) strcat(s, "c");
if (crc32("vmyZj",5) == 574195218) strcat(s, "q");
if (crc32("PGzspYljBxz",11) == 3281361252) strcat(s, "r");
if (crc32("qjnZpcbqEE",10) == 3952917110) strcat(s, "u");
if (crc32("zxVkMMAXIrOzQ",13) == 2917067837) strcat(s, "s");
if (crc32("cGDva",5) == 707801254) strcat(s, "t");
if (crc32("AZJuHFGv",8) == 3030933821) strcat(s, "i");
if (crc32("pTkVJCNzOUyGr",13) == 1665301015) strcat(s, "l");
if (crc32("JnfLiIUHcqPfmfG",15) == 3942372872) strcat(s, "y");
    return s;
}

char *unconformably_adverbs() {
    char *s = calloc(14);
    if (crc32("XpvZSnjND",9) == 2839783062) strcat(s, "r");
if (crc32("pzYfkaQXPMF",11) == 1270634196) strcat(s, "u");
if (crc32("WiHTWHPThZoaTiH",15) == 2728448783) strcat(s, "g");
if (crc32("yYTytNgxxZGi",12) == 2310138782) strcat(s, "n");
if (crc32("OIgoUZn",7) == 3350847496) strcat(s, "P");
if (crc32("rWKlVz",6) == 754094394) strcat(s, "c");
if (crc32("MVwds",5) == 285526891) strcat(s, "o");
if (crc32("FVsoGDdNgap",11) == 1123209785) strcat(s, "n");
if (crc32("qwuwz",5) == 1995209711) strcat(s, "f");
if (crc32("QxhGafQVbVBCYS",14) == 3120923564) strcat(s, "o");
if (crc32("BmLSuEJxcxuPM",13) == 958132850) strcat(s, "g");
if (crc32("zySpFIKpPcSX",12) == 1171353912) strcat(s, "r");
if (crc32("DZNldFRIZg",10) == 717038316) strcat(s, "m");
if (crc32("HDiJrBIhPKZ",11) == 2455824498) strcat(s, "x");
if (crc32("uRQiXgcjmJ",10) == 3383377804) strcat(s, "a");
if (crc32("SoAwY",5) == 2731648412) strcat(s, "U");
if (crc32("PGwOftCeTrn",11) == 3169373355) strcat(s, "b");
if (crc32("CNCRF",5) == 2160645102) strcat(s, "R");
if (crc32("MferEn",6) == 1761572588) strcat(s, "l");
if (crc32("aYcQYBhLbKvb",12) == 1128847488) strcat(s, "y");
    return s;
}

char *carefully_adverbs() {
    char *s = calloc(10);
    if (crc32("OuMzxMioIcf",11) == 2715723266) strcat(s, "w");
if (crc32("mruycg",6) == 478003558) strcat(s, "c");
if (crc32("lUpOiRtqsE",10) == 3496309774) strcat(s, "a");
if (crc32("UEnXKkTBbcY",11) == 3340392438) strcat(s, "r");
if (crc32("SoAJxceX",8) == 4122573319) strcat(s, "T");
if (crc32("xNNqsNV",7) == 4189866940) strcat(s, "e");
if (crc32("luAoaQTFvv",10) == 3718917975) strcat(s, "F");
if (crc32("pLpbKguhizHYV",13) == 1889508202) strcat(s, "f");
if (crc32("fcCfeGPLfjm",11) == 3672415384) strcat(s, "u");
if (crc32("fhldyCns",8) == 1155374808) strcat(s, "A");
if (crc32("zYCPMiO",7) == 11908707) strcat(s, "l");
if (crc32("DGcIGwe",7) == 797462345) strcat(s, "l");
if (crc32("pfKKGMTcROpGO",13) == 1331201492) strcat(s, "j");
if (crc32("zRhoCiOoV",9) == 2544551191) strcat(s, "y");
    return s;
}

char *proscriptively_adverbs() {
    char *s = calloc(15);
    if (crc32("VUQTz",5) == 2865073129) strcat(s, "L");
if (crc32("jBySsAplLCPDIfE",15) == 699822220) strcat(s, "p");
if (crc32("beJosGi",7) == 2141010752) strcat(s, "i");
if (crc32("ZJiJZTRa",8) == 20579224) strcat(s, "r");
if (crc32("fgXXvobW",8) == 1563575371) strcat(s, "k");
if (crc32("mGouwKpwNQLC",12) == 2909179196) strcat(s, "o");
if (crc32("EaFqMthVT",9) == 2812641668) strcat(s, "I");
if (crc32("CJSoNrS",7) == 3486871598) strcat(s, "s");
if (crc32("CHmFVREHNkO",11) == 325398783) strcat(s, "s");
if (crc32("QbaLhZiXeqmbAcF",15) == 275134983) strcat(s, "c");
if (crc32("HfDllY",6) == 438446004) strcat(s, "X");
if (crc32("GqJtchEwdQ",10) == 535155015) strcat(s, "r");
if (crc32("rygZgDXsthkPyf",14) == 692075672) strcat(s, "i");
if (crc32("LlpIECCjsbm",11) == 1547112706) strcat(s, "p");
if (crc32("YWGyO",5) == 363561989) strcat(s, "p");
if (crc32("HEeACPGl",8) == 2866978349) strcat(s, "t");
if (crc32("sdCnJWyB",8) == 2489184257) strcat(s, "V");
if (crc32("MHaBbImbWx",10) == 464852840) strcat(s, "i");
if (crc32("fOZvsKCq",8) == 3815865604) strcat(s, "v");
if (crc32("oKMJPrh",7) == 1604670395) strcat(s, "X");
if (crc32("MHKeWWFrsU",10) == 761063301) strcat(s, "e");
if (crc32("JmCHGKxe",8) == 1986208687) strcat(s, "l");
if (crc32("sizdr",5) == 3632432830) strcat(s, "y");
    return s;
}

char *tetrahedrally_adverbs() {
    char *s = calloc(14);
    if (crc32("mgEXGHkbid",10) == 2912703293) strcat(s, "t");
if (crc32("cranxEz",7) == 2035278219) strcat(s, "e");
if (crc32("TdCNzA",6) == 1652596986) strcat(s, "X");
if (crc32("UADOBsrQWOKsTwT",15) == 1948512193) strcat(s, "t");
if (crc32("PeBVHUayl",9) == 1655690878) strcat(s, "r");
if (crc32("phBXDrhzgGB",11) == 3222829833) strcat(s, "E");
if (crc32("ThskbQu",7) == 882410264) strcat(s, "a");
if (crc32("lsIdVGx",7) == 884780578) strcat(s, "h");
if (crc32("adaRh",5) == 1422245407) strcat(s, "e");
if (crc32("fuXZGoomUcq",11) == 1735328644) strcat(s, "d");
if (crc32("umSnYRho",8) == 1284685214) strcat(s, "X");
if (crc32("xXsHmsqnORCtquz",15) == 539115344) strcat(s, "r");
if (crc32("ZmvUxKt",7) == 988120575) strcat(s, "a");
if (crc32("PiHgeIsrGuMfrgP",15) == 3594378264) strcat(s, "l");
if (crc32("pucAzmbb",8) == 741059746) strcat(s, "l");
if (crc32("ukBIrPo",7) == 2451703508) strcat(s, "F");
if (crc32("DWZrmpbHm",9) == 2981524111) strcat(s, "y");
    return s;
}

char *uxoriously_adverbs() {
    char *s = calloc(11);
    if (crc32("DZLiW",5) == 4149315151) strcat(s, "u");
if (crc32("gFgJJsHbJ",9) == 243924104) strcat(s, "T");
if (crc32("DDStdaeQgqfHWaj",15) == 1943178693) strcat(s, "x");
if (crc32("jwGHOfg",7) == 1861405810) strcat(s, "E");
if (crc32("fkbmpsjdjIHUaiP",15) == 3616565704) strcat(s, "o");
if (crc32("ccolejMA",8) == 1954058921) strcat(s, "B");
if (crc32("kGFefYkl",8) == 1592859584) strcat(s, "r");
if (crc32("hAtLIPQkLihcYTY",15) == 3066263900) strcat(s, "i");
if (crc32("FAPyBxQ",7) == 1440330117) strcat(s, "p");
if (crc32("lfApcACyWixywf",14) == 353889902) strcat(s, "o");
if (crc32("OEmJGG",6) == 2019529860) strcat(s, "s");
if (crc32("wcDnDbOoLjzv",12) == 1298630201) strcat(s, "u");
if (crc32("tpErbYwVOynNFRq",15) == 1640708487) strcat(s, "e");
if (crc32("bxOecSrvV",9) == 2858522510) strcat(s, "s");
if (crc32("Vosmudk",7) == 2006364000) strcat(s, "x");
if (crc32("WUAPpyGBRF",10) == 3681204124) strcat(s, "l");
if (crc32("tsyikfhQ",8) == 964855005) strcat(s, "y");
    return s;
}

char *charitably_adverbs() {
    char *s = calloc(11);
    if (crc32("XLOTCeJfNyina",13) == 2854234863) strcat(s, "c");
if (crc32("ZwTFgjeFg",9) == 1688720684) strcat(s, "k");
if (crc32("uTmemQojbt",10) == 3649769380) strcat(s, "h");
if (crc32("XctMIcDyzepOy",13) == 3874332386) strcat(s, "w");
if (crc32("vKxswLwJO",9) == 1678626664) strcat(s, "a");
if (crc32("IMyJngchuNmPd",13) == 4135196117) strcat(s, "H");
if (crc32("NQBzB",5) == 1816957340) strcat(s, "r");
if (crc32("uvfhsepWiiuDJ",13) == 929376724) strcat(s, "i");
if (crc32("zlZSCH",6) == 782286595) strcat(s, "t");
if (crc32("FjkKrPRgnsqnzn",14) == 1269151123) strcat(s, "a");
if (crc32("OmzAMTIcIUZd",12) == 208604779) strcat(s, "z");
if (crc32("BoyUfO",6) == 1102346549) strcat(s, "b");
if (crc32("zETHkpZpfGN",11) == 3938852822) strcat(s, "b");
if (crc32("hwxBsLFYSJWyRc",14) == 2955427303) strcat(s, "l");
if (crc32("YRoHQOvauXSS",12) == 778958686) strcat(s, "u");
if (crc32("TPEAx",5) == 22108629) strcat(s, "y");
    return s;
}

char *rattling_adverbs() {
    char *s = calloc(9);
    if (crc32("OMHeyvT",7) == 3713117413) strcat(s, "i");
if (crc32("BnocFYRN",8) == 920181964) strcat(s, "r");
if (crc32("pkGgdB",6) == 502084201) strcat(s, "M");
if (crc32("xXdnbCLYvQvT",12) == 1270787309) strcat(s, "a");
if (crc32("nssUiP",6) == 4058462117) strcat(s, "t");
if (crc32("IeYzrRE",7) == 4228491912) strcat(s, "t");
if (crc32("yVQCraqqzQwOhGs",15) == 3273868352) strcat(s, "l");
if (crc32("oypGZtX",7) == 2087121250) strcat(s, "i");
if (crc32("beRlijWbLtog",12) == 559366668) strcat(s, "j");
if (crc32("usPxQzj",7) == 769344920) strcat(s, "n");
if (crc32("ZNirITClrNoiTG",14) == 3523893346) strcat(s, "w");
if (crc32("vLXzMQzvOm",10) == 1208610640) strcat(s, "g");
    return s;
}

char *unsubversively_adverbs() {
    char *s = calloc(15);
    if (crc32("JuPQFdmvQLYW",12) == 880615532) strcat(s, "u");
if (crc32("kVMOQuxv",8) == 3560316936) strcat(s, "M");
if (crc32("RaemoWGjN",9) == 4245881285) strcat(s, "n");
if (crc32("GKQlszFQWYgce",13) == 3934383657) strcat(s, "s");
if (crc32("AgSHbQtbzy",10) == 659957007) strcat(s, "L");
if (crc32("rqJaSdJCNaMw",12) == 3793787447) strcat(s, "u");
if (crc32("oUqnhdPuRnNSzm",14) == 3924975905) strcat(s, "o");
if (crc32("aSmHmsa",7) == 2065498832) strcat(s, "b");
if (crc32("ypJcF",5) == 4122804712) strcat(s, "v");
if (crc32("bJnPOdfsdII",11) == 2848587728) strcat(s, "W");
if (crc32("URUxzTJsDf",10) == 3617736948) strcat(s, "e");
if (crc32("mGngJQgZACyRsAn",15) == 3480274777) strcat(s, "P");
if (crc32("NjaQKP",6) == 3239097992) strcat(s, "r");
if (crc32("ycMcxI",6) == 2289307492) strcat(s, "s");
if (crc32("XTdThadhzIW",11) == 2917501866) strcat(s, "i");
if (crc32("QoPKEvbWcRBTTAy",15) == 905407754) strcat(s, "v");
if (crc32("CpBdNdqm",8) == 826845446) strcat(s, "e");
if (crc32("cZhNSAEljMl",11) == 1140432958) strcat(s, "l");
if (crc32("sTIbrbhC",8) == 2471919083) strcat(s, "l");
if (crc32("fXMuNGNOcm",10) == 1483667624) strcat(s, "y");
    return s;
}

char *pseudoarchaically_adverbs() {
    char *s = calloc(18);
    if (crc32("hwohtbDI",8) == 1369917119) strcat(s, "I");
if (crc32("njZvudWk",8) == 1755775140) strcat(s, "p");
if (crc32("QKOGNYXyyv",10) == 2329487342) strcat(s, "s");
if (crc32("YrMWJOXHjPkexwo",15) == 1954723602) strcat(s, "Y");
if (crc32("RfWujT",6) == 285344210) strcat(s, "e");
if (crc32("tbVSApf",7) == 1412056412) strcat(s, "u");
if (crc32("pfRekz",6) == 3042167331) strcat(s, "d");
if (crc32("KHGqIgzhdzmfD",13) == 3945715020) strcat(s, "o");
if (crc32("oExeefmJ",8) == 1294524031) strcat(s, "W");
if (crc32("buCGs",5) == 2111392067) strcat(s, "a");
if (crc32("XQFieupXFEaPNDv",15) == 1737071555) strcat(s, "p");
if (crc32("ZYBYM",5) == 311354049) strcat(s, "r");
if (crc32("AcaqnDzrlsPW",12) == 3740109827) strcat(s, "f");
if (crc32("vyfEuhMvBIxuA",13) == 3770142739) strcat(s, "c");
if (crc32("xOkHUFE",7) == 3326443202) strcat(s, "h");
if (crc32("jMYfE",5) == 595982206) strcat(s, "p");
if (crc32("eWUeeYqwbwWA",12) == 1108510719) strcat(s, "a");
if (crc32("RXmWhIOX",8) == 2006733685) strcat(s, "A");
if (crc32("zvQCmiDOhvjzmFc",15) == 1913184973) strcat(s, "i");
if (crc32("FJIZQlqYWydh",12) == 2628164211) strcat(s, "M");
if (crc32("TeSRamJfgEqqh",13) == 3012406072) strcat(s, "c");
if (crc32("amowJHqVGc",10) == 2718828874) strcat(s, "W");
if (crc32("sQJiVaFmDcVXjP",14) == 2853096302) strcat(s, "a");
if (crc32("ayYrziyvvhQNLnl",15) == 3520982550) strcat(s, "b");
if (crc32("sFbZLu",6) == 1734369905) strcat(s, "l");
if (crc32("HCspHnptyD",10) == 595160025) strcat(s, "V");
if (crc32("sqCKQWrrghZJP",13) == 1289024356) strcat(s, "l");
if (crc32("npdLYjA",7) == 219362331) strcat(s, "y");
    return s;
}

char *doubtably_adverbs() {
    char *s = calloc(10);
    if (crc32("yJyUQxnc",8) == 3960358067) strcat(s, "d");
if (crc32("XTrIfmsHnNhq",12) == 567096763) strcat(s, "d");
if (crc32("BAjHZVpMQBmPPG",14) == 2339999056) strcat(s, "o");
if (crc32("owrTXgrYF",9) == 579845255) strcat(s, "u");
if (crc32("vrScD",5) == 538814305) strcat(s, "b");
if (crc32("XWhhwx",6) == 3750647965) strcat(s, "k");
if (crc32("HqnyLWSFZWlq",12) == 131641030) strcat(s, "t");
if (crc32("LuXcWnzr",8) == 3829866525) strcat(s, "a");
if (crc32("bMdZLm",6) == 1978194517) strcat(s, "D");
if (crc32("ehOvmMWQG",9) == 3069981448) strcat(s, "b");
if (crc32("sCNvBCxoybjI",12) == 1264527564) strcat(s, "l");
if (crc32("KIPUsy",6) == 219111776) strcat(s, "y");
    return s;
}

char *logarithmically_adverbs() {
    char *s = calloc(16);
    if (crc32("yewPfThEwihuNN",14) == 2574991171) strcat(s, "l");
if (crc32("tNtmGzXwJ",9) == 3711721657) strcat(s, "t");
if (crc32("qHxfhk",6) == 2359954129) strcat(s, "o");
if (crc32("KGlRSwV",7) == 2343215113) strcat(s, "G");
if (crc32("Wwcehvt",7) == 3617246815) strcat(s, "g");
if (crc32("rViuIRAftCbpT",13) == 3910731556) strcat(s, "a");
if (crc32("cpoxAFAzhLqrwLk",15) == 125100924) strcat(s, "r");
if (crc32("PqNCbAkVPa",10) == 556396321) strcat(s, "V");
if (crc32("xXYnnHVXuBzin",13) == 2421443004) strcat(s, "i");
if (crc32("hExMiDleVgrVgDg",15) == 943852664) strcat(s, "F");
if (crc32("emVJA",5) == 1036035189) strcat(s, "t");
if (crc32("ISJWq",5) == 3513807474) strcat(s, "H");
if (crc32("xsoftSfPGXM",11) == 3890129298) strcat(s, "h");
if (crc32("dvhICgRlGme",11) == 1792787613) strcat(s, "m");
if (crc32("YDKSpKO",7) == 3899412715) strcat(s, "i");
if (crc32("LHcYXAqssWUgaj",14) == 3502447078) strcat(s, "z");
if (crc32("qAnKOn",6) == 1861415866) strcat(s, "c");
if (crc32("UhMcu",5) == 298439314) strcat(s, "I");
if (crc32("TuSGtnYkdHU",11) == 1149608945) strcat(s, "a");
if (crc32("ekqzQSLFyaDSDcA",15) == 115146677) strcat(s, "l");
if (crc32("buMoxHWkLnUCQrB",15) == 1695808781) strcat(s, "k");
if (crc32("thCRqfDByWgn",12) == 1588794196) strcat(s, "l");
if (crc32("rKpaMSJpLsHcu",13) == 3216526616) strcat(s, "y");
    return s;
}

char *anymore_adverbs() {
    char *s = calloc(8);
    if (crc32("VNvmxOoqZ",9) == 339778109) strcat(s, "a");
if (crc32("FLnsox",6) == 3291817413) strcat(s, "n");
if (crc32("yHEHVJSr",8) == 708419700) strcat(s, "y");
if (crc32("EuJGZFPDu",9) == 1887448184) strcat(s, "m");
if (crc32("ObnHecDNm",9) == 524630693) strcat(s, "o");
if (crc32("OZSoYgwAdLVk",12) == 416011226) strcat(s, "y");
if (crc32("PghPpMggxBfU",12) == 3430921019) strcat(s, "r");
if (crc32("zrmbpB",6) == 363203025) strcat(s, "t");
if (crc32("yuWOagnjmSldbh",14) == 853533801) strcat(s, "e");
    return s;
}

char *noninterdependently_adverbs() {
    char *s = calloc(20);
    if (crc32("igpQBGhjKGBYx",13) == 3508871361) strcat(s, "J");
if (crc32("svXvETTmknbHgS",14) == 1848499374) strcat(s, "n");
if (crc32("iUHTF",5) == 2436021564) strcat(s, "o");
if (crc32("TQNSjjZkjQFc",12) == 1347659468) strcat(s, "n");
if (crc32("xUmzANR",7) == 3780091606) strcat(s, "i");
if (crc32("XJyhRTzoQDVEN",13) == 3332625666) strcat(s, "H");
if (crc32("zljGNWytYcOwLa",14) == 2087169357) strcat(s, "n");
if (crc32("NqOuhIBwPWpK",12) == 4225529728) strcat(s, "W");
if (crc32("rlEHPeQVAkcXSI",14) == 60651365) strcat(s, "t");
if (crc32("OxTDNSEqMpFK",12) == 3638125957) strcat(s, "h");
if (crc32("nHkWeLyEJ",9) == 3504203833) strcat(s, "e");
if (crc32("PyNohDUqXWTcq",13) == 3169721582) strcat(s, "r");
if (crc32("WmdSUpxjFYZll",13) == 284338714) strcat(s, "d");
if (crc32("DVfWIJHTeTo",11) == 3623637232) strcat(s, "e");
if (crc32("QEmIXqiqbh",10) == 4252324334) strcat(s, "N");
if (crc32("WFXcsjsr",8) == 2777061715) strcat(s, "p");
if (crc32("ZKHRVNz",7) == 152594973) strcat(s, "g");
if (crc32("PKYsGyKxzzrxTB",14) == 637197895) strcat(s, "e");
if (crc32("xbiPi",5) == 3327341600) strcat(s, "v");
if (crc32("pqLoDcy",7) == 1604736972) strcat(s, "n");
if (crc32("xdmpskAdUULFkW",14) == 2919065917) strcat(s, "d");
if (crc32("wwHvpNbWEODk",12) == 483944050) strcat(s, "e");
if (crc32("PltAaAStkRB",11) == 3060596607) strcat(s, "n");
if (crc32("PmZbrVHPl",9) == 3711092662) strcat(s, "V");
if (crc32("wOLKvUboQYhdYkn",15) == 4124732569) strcat(s, "t");
if (crc32("QHqkRKGj",8) == 2856483739) strcat(s, "l");
if (crc32("plhsKFrJwViuEt",14) == 1289332326) strcat(s, "y");
    return s;
}

char *extrovertively_adverbs() {
    char *s = calloc(15);
    if (crc32("DndqJwJREyiga",13) == 1713546383) strcat(s, "P");
if (crc32("jOmMTU",6) == 3067498081) strcat(s, "e");
if (crc32("xUgBrfrPj",9) == 1640178577) strcat(s, "x");
if (crc32("SitFQlQZrJK",11) == 2920209102) strcat(s, "L");
if (crc32("UKURdamagpp",11) == 1194954403) strcat(s, "t");
if (crc32("tvRsqWkGI",9) == 3447132576) strcat(s, "p");
if (crc32("osJsaBvyA",9) == 282390752) strcat(s, "r");
if (crc32("tygdh",5) == 513778900) strcat(s, "c");
if (crc32("LowfPwSiykWiKe",14) == 1859137487) strcat(s, "o");
if (crc32("ptwNRPcgjZThVp",14) == 791688935) strcat(s, "v");
if (crc32("XyesomLbqu",10) == 1909396978) strcat(s, "z");
if (crc32("jtHEEesDt",9) == 638458138) strcat(s, "e");
if (crc32("nClnSnNy",8) == 1346824572) strcat(s, "r");
if (crc32("rnXRPdL",7) == 2940583645) strcat(s, "t");
if (crc32("uZksRWfkwVBnHkO",15) == 1611219307) strcat(s, "i");
if (crc32("pwsvlUnadw",10) == 4273984529) strcat(s, "v");
if (crc32("QTpQSLSHmHOpRda",15) == 4222297391) strcat(s, "e");
if (crc32("GhkPhQoSKL",10) == 246598424) strcat(s, "I");
if (crc32("kkSLaxjquPM",11) == 784686892) strcat(s, "l");
if (crc32("TjrSwEclhA",10) == 619000057) strcat(s, "y");
    return s;
}

char *carousingly_adverbs() {
    char *s = calloc(12);
    if (crc32("sAPKznsEV",9) == 1929301304) strcat(s, "b");
if (crc32("IWWVksQCBqUNXjq",15) == 1627264959) strcat(s, "c");
if (crc32("HZJTWpRL",8) == 2388893167) strcat(s, "a");
if (crc32("TJjHheiAJvCGT",13) == 1751612858) strcat(s, "w");
if (crc32("jnxJgr",6) == 2040408486) strcat(s, "r");
if (crc32("lWkbUs",6) == 3983776642) strcat(s, "o");
if (crc32("mwENLuqzvwsfB",13) == 1880963942) strcat(s, "u");
if (crc32("UlKAMymUrVjSRyJ",15) == 1395298794) strcat(s, "b");
if (crc32("JbjKQueGAvwFtwf",15) == 2749948502) strcat(s, "s");
if (crc32("zRubgpS",7) == 2766802381) strcat(s, "i");
if (crc32("nWKwX",5) == 3489357308) strcat(s, "n");
if (crc32("BCoBAkXnSVuj",12) == 3696265971) strcat(s, "g");
if (crc32("WXNGQPLczPKkt",13) == 1367916443) strcat(s, "K");
if (crc32("szKDVBgZX",9) == 775951487) strcat(s, "l");
if (crc32("rGUvWgH",7) == 511157777) strcat(s, "N");
if (crc32("nycRkMdlDrY",11) == 1317840121) strcat(s, "y");
    return s;
}

char *festally_adverbs() {
    char *s = calloc(9);
    if (crc32("SiaLkmtGGD",10) == 1364568540) strcat(s, "W");
if (crc32("ZNdZUtEL",8) == 158936450) strcat(s, "f");
if (crc32("vRSYTm",6) == 2037113618) strcat(s, "e");
if (crc32("RKGtLGsUYPN",11) == 604224592) strcat(s, "s");
if (crc32("xSAgFGLrQtnpADL",15) == 805190529) strcat(s, "t");
if (crc32("OtUQfcLXyik",11) == 4000395124) strcat(s, "n");
if (crc32("MqygfJNtz",9) == 2792584516) strcat(s, "a");
if (crc32("JBxRfl",6) == 517946050) strcat(s, "Q");
if (crc32("gSqjVsi",7) == 2432936095) strcat(s, "l");
if (crc32("BQjZgYKHZJETP",13) == 4223527042) strcat(s, "l");
if (crc32("CZNpVhENvyuaR",13) == 3812464864) strcat(s, "K");
if (crc32("KmCGGtuxourUJp",14) == 4248267232) strcat(s, "y");
    return s;
}

char *overfrequently_adverbs() {
    char *s = calloc(15);
    if (crc32("TBJnOIqeeGNhR",13) == 3244162752) strcat(s, "o");
if (crc32("xrDefGWYQ",9) == 2771218734) strcat(s, "v");
if (crc32("TQVKvcFaZGPN",12) == 226503345) strcat(s, "c");
if (crc32("iezEIjYiRnH",11) == 2494574423) strcat(s, "e");
if (crc32("WDtUGaMRG",9) == 3811432236) strcat(s, "W");
if (crc32("TOjGWqmugTyYea",14) == 2388562807) strcat(s, "r");
if (crc32("PfnmGIgSGZliQ",13) == 150855048) strcat(s, "f");
if (crc32("SYGtX",5) == 1419967583) strcat(s, "r");
if (crc32("YUqJCSm",7) == 2536553363) strcat(s, "e");
if (crc32("DJLDwwtSr",9) == 188200198) strcat(s, "q");
if (crc32("ytzyTDxViX",10) == 1521576939) strcat(s, "y");
if (crc32("KqbvmRAbJJND",12) == 496947693) strcat(s, "u");
if (crc32("RSliVEanV",9) == 689139939) strcat(s, "e");
if (crc32("rWEWZBpGW",9) == 1031755178) strcat(s, "n");
if (crc32("SMfzxsKIsYSaq",13) == 4062650341) strcat(s, "C");
if (crc32("OyYGeOCEFHk",11) == 3675001740) strcat(s, "t");
if (crc32("KvdVl",5) == 1646841092) strcat(s, "w");
if (crc32("CVqLQZK",7) == 3943439563) strcat(s, "l");
if (crc32("pqxYrASQawjkIbl",15) == 1821727997) strcat(s, "r");
if (crc32("ZGtWAgRRYnsglxX",15) == 409905561) strcat(s, "y");
    return s;
}

char *gnathonically_adverbs() {
    char *s = calloc(14);
    if (crc32("fELaqpEyC",9) == 4113511680) strcat(s, "x");
if (crc32("FujAUs",6) == 1928486506) strcat(s, "g");
if (crc32("eaqyPPEhtmF",11) == 2099798435) strcat(s, "n");
if (crc32("eZqHmACBHtXJpq",14) == 886185014) strcat(s, "a");
if (crc32("MZaZpQwn",8) == 757199436) strcat(s, "t");
if (crc32("nmxIHqZHOKgJ",12) == 651921639) strcat(s, "o");
if (crc32("tjkunkMtcza",11) == 2169459312) strcat(s, "h");
if (crc32("HSlWKXaXCIFzTpC",15) == 3804928287) strcat(s, "o");
if (crc32("OCrsmFzRTfAWpkh",15) == 3269212328) strcat(s, "x");
if (crc32("IPBCVcw",7) == 56857888) strcat(s, "n");
if (crc32("mBxLgCtksyBQTn",14) == 1867948615) strcat(s, "c");
if (crc32("cIaawJHfIrhJxM",14) == 3017041716) strcat(s, "i");
if (crc32("pDhvwyLMAS",10) == 955951702) strcat(s, "i");
if (crc32("zbOdnnO",7) == 2717625732) strcat(s, "c");
if (crc32("unbPtA",6) == 2067015729) strcat(s, "a");
if (crc32("DypGpxFdgjZLZi",14) == 766909022) strcat(s, "l");
if (crc32("QKIaTGZNCIizN",13) == 755304038) strcat(s, "l");
if (crc32("QaSzJcqHfkXCsab",15) == 447998362) strcat(s, "l");
if (crc32("atyLEefJoVoXz",13) == 3290611529) strcat(s, "y");
    return s;
}

char *unrhetorically_adverbs() {
    char *s = calloc(15);
    if (crc32("bTyNrne",7) == 3441239729) strcat(s, "E");
if (crc32("QHSDdDY",7) == 1501351840) strcat(s, "u");
if (crc32("TjDTp",5) == 2591340483) strcat(s, "Z");
if (crc32("GnyZf",5) == 1219350808) strcat(s, "n");
if (crc32("ocKgMlYPPxAqgqu",15) == 1138815139) strcat(s, "r");
if (crc32("LzqWApZTAsoRItu",15) == 2571137624) strcat(s, "h");
if (crc32("QVcDnSlPwVpPid",14) == 967386362) strcat(s, "R");
if (crc32("TvwAvFrmq",9) == 646599007) strcat(s, "e");
if (crc32("qKvUWjzdQJoUi",13) == 2916865526) strcat(s, "t");
if (crc32("VmivJXUnZoMGDHW",15) == 2549549832) strcat(s, "V");
if (crc32("nrRqH",5) == 863725) strcat(s, "o");
if (crc32("HktLaII",7) == 847582748) strcat(s, "r");
if (crc32("GSvoft",6) == 3040617525) strcat(s, "i");
if (crc32("aOktbJ",6) == 2960400219) strcat(s, "B");
if (crc32("OFmiCFOYO",9) == 2595894588) strcat(s, "c");
if (crc32("XCpRCasSDZmkMjj",15) == 546666794) strcat(s, "R");
if (crc32("BamTKMCoQhlWI",13) == 1747263217) strcat(s, "a");
if (crc32("BXnWkMWrTseRGKY",15) == 88557213) strcat(s, "e");
if (crc32("HjipVCzqn",9) == 752757219) strcat(s, "l");
if (crc32("AiWWRe",6) == 1805174905) strcat(s, "l");
if (crc32("cTQpTbrEzC",10) == 2056203434) strcat(s, "y");
    return s;
}

char *remonstratively_adverbs() {
    char *s = calloc(16);
    if (crc32("aJNVkS",6) == 1328346919) strcat(s, "l");
if (crc32("SHNqCH",6) == 3740283007) strcat(s, "r");
if (crc32("XwnXBQgoCKex",12) == 4255937081) strcat(s, "e");
if (crc32("yJlqOfqwoviGgh",14) == 3695651451) strcat(s, "e");
if (crc32("pnXcD",5) == 3286560599) strcat(s, "b");
if (crc32("wYxOvoaT",8) == 1427576806) strcat(s, "m");
if (crc32("ZKKazjZXjh",10) == 1365362306) strcat(s, "W");
if (crc32("BuQfZhBbyfLS",12) == 2018066156) strcat(s, "o");
if (crc32("rhgYz",5) == 3389157468) strcat(s, "b");
if (crc32("JkMpemoUCuOMhvW",15) == 2882599765) strcat(s, "n");
if (crc32("sgzdQiTH",8) == 3850864969) strcat(s, "v");
if (crc32("tANFKvwghlJUDwG",15) == 2299012523) strcat(s, "s");
if (crc32("AmYiCOLGvp",10) == 418066281) strcat(s, "x");
if (crc32("RzhEpcojWCqgXp",14) == 423296161) strcat(s, "t");
if (crc32("XRyFkFhMKwoYjZH",15) == 2276744385) strcat(s, "r");
if (crc32("qoyhFqRF",8) == 3384491549) strcat(s, "Y");
if (crc32("dwBAcaFconNck",13) == 2425041568) strcat(s, "a");
if (crc32("EQLPHuxQGtcg",12) == 4075192743) strcat(s, "t");
if (crc32("fAHtwxXcjCb",11) == 1026052310) strcat(s, "i");
if (crc32("HLTJEk",6) == 2714111897) strcat(s, "v");
if (crc32("oBzxiUEaUDge",12) == 3298318022) strcat(s, "B");
if (crc32("waiygsQVnrx",11) == 3897072583) strcat(s, "e");
if (crc32("VmayRqzsXzqjHA",14) == 553848011) strcat(s, "r");
if (crc32("lvpCcPpeS",9) == 4165182243) strcat(s, "l");
if (crc32("ehKZqEmTb",9) == 3939107912) strcat(s, "U");
if (crc32("sadFMn",6) == 3081268224) strcat(s, "y");
    return s;
}

char *jurally_adverbs() {
    char *s = calloc(8);
    if (crc32("hAovcnWwZLS",11) == 2991274664) strcat(s, "t");
if (crc32("PsOPLlQFm",9) == 484737758) strcat(s, "j");
if (crc32("LCvFQxaNjuI",11) == 189911423) strcat(s, "u");
if (crc32("jpaPNJvg",8) == 2802365499) strcat(s, "m");
if (crc32("jOEAAoybBbbS",12) == 3314250823) strcat(s, "r");
if (crc32("TIMdtGXYwogL",12) == 532401040) strcat(s, "a");
if (crc32("bHjjVrvPVokFp",13) == 699633963) strcat(s, "l");
if (crc32("PvbcEdDWDXODc",13) == 577533384) strcat(s, "O");
if (crc32("sdXBfF",6) == 2172213542) strcat(s, "l");
if (crc32("bRchGNYTp",9) == 196352006) strcat(s, "B");
if (crc32("uixqndbT",8) == 328560764) strcat(s, "y");
    return s;
}

char *nontalkatively_adverbs() {
    char *s = calloc(15);
    if (crc32("LqXXBern",8) == 1009122914) strcat(s, "M");
if (crc32("eFTFMRWOnHh",11) == 229772249) strcat(s, "n");
if (crc32("EpwVSj",6) == 3659322317) strcat(s, "a");
if (crc32("zSXhf",5) == 3349345781) strcat(s, "o");
if (crc32("fLIfgpdcsteMi",13) == 237372470) strcat(s, "R");
if (crc32("NTlxM",5) == 3418912087) strcat(s, "n");
if (crc32("khlJFIYtcGXSuWY",15) == 3700824770) strcat(s, "t");
if (crc32("iyyGjSjkg",9) == 2981692756) strcat(s, "k");
if (crc32("zBopARLlUNczn",13) == 4209403413) strcat(s, "a");
if (crc32("aZyRQlWfTkAUste",15) == 1250041588) strcat(s, "l");
if (crc32("TAZyaJvW",8) == 2098755552) strcat(s, "k");
if (crc32("rZoMv",5) == 1589297704) strcat(s, "a");
if (crc32("rVofPBlrbUUKfDe",15) == 3890492381) strcat(s, "t");
if (crc32("zbVNVKqUk",9) == 3619994435) strcat(s, "i");
if (crc32("tAcLcqWeYwuUBYg",15) == 4188680395) strcat(s, "v");
if (crc32("CAvwyRCUJMhz",12) == 1186347191) strcat(s, "x");
if (crc32("qvIkZMWGSZhIxP",14) == 3367776723) strcat(s, "e");
if (crc32("RsmZgBibY",9) == 3008188606) strcat(s, "A");
if (crc32("bdwORagoNP",10) == 641627731) strcat(s, "l");
if (crc32("HbLNalXWX",9) == 2150833533) strcat(s, "y");
    return s;
}

char *insuppressibly_adverbs() {
    char *s = calloc(15);
    if (crc32("qqQSSNb",7) == 1752854180) strcat(s, "i");
if (crc32("MuZggazvpJZO",12) == 1632666981) strcat(s, "Y");
if (crc32("sQBuLhwwEhbTVVD",15) == 2543056012) strcat(s, "n");
if (crc32("QEEkzfiJb",9) == 3579719600) strcat(s, "s");
if (crc32("MeTzxfqXYBr",11) == 2276656003) strcat(s, "u");
if (crc32("PrslnYtUZeB",11) == 1310044329) strcat(s, "p");
if (crc32("VSJisXrTt",9) == 2640937163) strcat(s, "p");
if (crc32("AtMeYCQXDLlPP",13) == 2449560233) strcat(s, "r");
if (crc32("PUVtb",5) == 2184980930) strcat(s, "e");
if (crc32("lmErxLUFNLmYpcl",15) == 1905327146) strcat(s, "s");
if (crc32("LviEIFqQmM",10) == 2751826365) strcat(s, "s");
if (crc32("QdvMRp",6) == 4097573957) strcat(s, "i");
if (crc32("DkfSuXLyiYI",11) == 638052547) strcat(s, "b");
if (crc32("OqmFq",5) == 1882184655) strcat(s, "q");
if (crc32("vCmTPSkufw",10) == 1397790030) strcat(s, "l");
if (crc32("gSLpgZIRVcHZ",12) == 233024219) strcat(s, "w");
if (crc32("JzTdYcCV",8) == 3405957139) strcat(s, "y");
    return s;
}

char *nonfluidly_adverbs() {
    char *s = calloc(11);
    if (crc32("mgvaMFwS",8) == 1556373483) strcat(s, "G");
if (crc32("ryHIBZNAjBcLWG",14) == 434387132) strcat(s, "n");
if (crc32("ncopbLjJuSTEU",13) == 156949111) strcat(s, "o");
if (crc32("udwUcSC",7) == 1578743101) strcat(s, "e");
if (crc32("sIHkdh",6) == 827193134) strcat(s, "n");
if (crc32("SsXjaxrew",9) == 3172689231) strcat(s, "f");
if (crc32("lZgQBbPhM",9) == 1804789434) strcat(s, "l");
if (crc32("kYUIDUBYPZNr",12) == 3717517085) strcat(s, "u");
if (crc32("iIIgen",6) == 3537820838) strcat(s, "i");
if (crc32("aepvwjKXxN",10) == 964339188) strcat(s, "v");
if (crc32("PWPeIScKyVMxYV",14) == 4013619633) strcat(s, "d");
if (crc32("WCSlj",5) == 3479514897) strcat(s, "l");
if (crc32("ZgmtJYj",7) == 836023327) strcat(s, "y");
    return s;
}

char *evolutionarily_adverbs() {
    char *s = calloc(15);
    if (crc32("XhqdZ",5) == 4023367893) strcat(s, "e");
if (crc32("xDXzpzsQmHcW",12) == 1764933378) strcat(s, "S");
if (crc32("ziklrZOelQ",10) == 1605414765) strcat(s, "v");
if (crc32("TPiCXxvVsPELis",14) == 3399048395) strcat(s, "o");
if (crc32("LaEwzopUOCwMuC",14) == 1979017714) strcat(s, "z");
if (crc32("ruFQNeDy",8) == 1634655326) strcat(s, "l");
if (crc32("XscwvjY",7) == 2451908727) strcat(s, "b");
if (crc32("bmtVWzyoOgbJlv",14) == 4213478298) strcat(s, "u");
if (crc32("JLmtiRi",7) == 2073538028) strcat(s, "t");
if (crc32("lBfFfqNmeue",11) == 857339164) strcat(s, "m");
if (crc32("ymBfjAFxvwzgRQ",14) == 3427745223) strcat(s, "i");
if (crc32("FAXUwmZR",8) == 190113215) strcat(s, "o");
if (crc32("qLMfPZqFVe",10) == 2430164531) strcat(s, "n");
if (crc32("sYtkIR",6) == 522857658) strcat(s, "w");
if (crc32("bonMln",6) == 795154745) strcat(s, "a");
if (crc32("xAbThYdJufqRf",13) == 3606753070) strcat(s, "r");
if (crc32("dInAoBrtbWH",11) == 104656393) strcat(s, "i");
if (crc32("pVrMxBUNFyWir",13) == 1844646317) strcat(s, "l");
if (crc32("PhlzgkgwiabDayj",15) == 3427307698) strcat(s, "P");
if (crc32("tGIxGpVTVabKt",13) == 2208240499) strcat(s, "y");
    return s;
}

char *nonofficially_adverbs() {
    char *s = calloc(14);
    if (crc32("tlvCMUJQyMNzbs",14) == 3718365346) strcat(s, "T");
if (crc32("RlcXpjBpXiSZ",12) == 1765995026) strcat(s, "n");
if (crc32("PpyaxsmZ",8) == 863002892) strcat(s, "v");
if (crc32("MXiVOaQidyH",11) == 1149436282) strcat(s, "o");
if (crc32("REwVkTcEvzpVN",13) == 478425415) strcat(s, "n");
if (crc32("IqXln",5) == 1101995296) strcat(s, "o");
if (crc32("hhsnYJBz",8) == 3428199741) strcat(s, "f");
if (crc32("WOEFuuwjolsJNYu",15) == 2526861349) strcat(s, "T");
if (crc32("zXeLMuBb",8) == 3607484904) strcat(s, "f");
if (crc32("qwlGSPpuTxs",11) == 3473891134) strcat(s, "p");
if (crc32("jazfPCiAZSq",11) == 1593618211) strcat(s, "i");
if (crc32("ypyleFkPsEMe",12) == 507234579) strcat(s, "c");
if (crc32("npFRXfUaL",9) == 3350241636) strcat(s, "i");
if (crc32("KAMpi",5) == 3424114359) strcat(s, "G");
if (crc32("eQOGEJVtiSa",11) == 964341824) strcat(s, "a");
if (crc32("hLobmtwSZPqxU",13) == 4174071334) strcat(s, "F");
if (crc32("znlQN",5) == 3719347589) strcat(s, "l");
if (crc32("gAHWDpEZYLIjMkT",15) == 3773733457) strcat(s, "l");
if (crc32("zoiXvjGac",9) == 3359371070) strcat(s, "t");
if (crc32("znjOOItmarL",11) == 4121482270) strcat(s, "y");
    return s;
}

char *quasiefficiently_adverbs() {
    char *s = calloc(17);
    if (crc32("ziPdg",5) == 2375402258) strcat(s, "q");
if (crc32("qPdyqTFxHY",10) == 1554709950) strcat(s, "x");
if (crc32("QAeflR",6) == 520925144) strcat(s, "u");
if (crc32("OgGpXdvllxKsU",13) == 1011455520) strcat(s, "a");
if (crc32("VBosyQyHR",9) == 489154258) strcat(s, "s");
if (crc32("skKlMO",6) == 2096765089) strcat(s, "i");
if (crc32("kzNkiPCgBUCnG",13) == 2933678071) strcat(s, "J");
if (crc32("cxULPowC",8) == 581744341) strcat(s, "e");
if (crc32("JObJZk",6) == 3014950305) strcat(s, "f");
if (crc32("RyUkCSJtEFUboLI",15) == 941013967) strcat(s, "f");
if (crc32("XMhdlISeEWY",11) == 4155649687) strcat(s, "i");
if (crc32("dFDYGRiA",8) == 1804463897) strcat(s, "c");
if (crc32("MKbdrP",6) == 2243217341) strcat(s, "i");
if (crc32("EpxDu",5) == 4118620867) strcat(s, "K");
if (crc32("vnKatmlEvYQPo",13) == 540475784) strcat(s, "e");
if (crc32("FeYsuQI",7) == 2157016196) strcat(s, "W");
if (crc32("iQEoFmh",7) == 1357590660) strcat(s, "n");
if (crc32("yGMXQhTEuLFLG",13) == 3544815023) strcat(s, "g");
if (crc32("TUbUiOmngJLJexR",15) == 862705976) strcat(s, "t");
if (crc32("BwJKbxYsEH",10) == 2755578140) strcat(s, "Q");
if (crc32("nsuuu",5) == 3115815928) strcat(s, "l");
if (crc32("BelVSUcWnRWihLG",15) == 3671162405) strcat(s, "y");
    return s;
}

char *fulsomely_adverbs() {
    char *s = calloc(10);
    if (crc32("mGJpHGnifzd",11) == 294795383) strcat(s, "M");
if (crc32("USqlhboC",8) == 1309946409) strcat(s, "f");
if (crc32("SQIcfHpoqCZb",12) == 3689857786) strcat(s, "F");
if (crc32("csoPAirj",8) == 4088896518) strcat(s, "u");
if (crc32("qQPBnjd",7) == 2385199240) strcat(s, "l");
if (crc32("yfwMRHlrwJUmXAi",15) == 3485456855) strcat(s, "M");
if (crc32("GEcHkXqQii",10) == 1989500766) strcat(s, "s");
if (crc32("gzpzlHae",8) == 3245733266) strcat(s, "o");
if (crc32("CrNrWb",6) == 3252957721) strcat(s, "o");
if (crc32("ADYEsQjO",8) == 4050675110) strcat(s, "r");
if (crc32("uvIdvsfPjtBcW",13) == 2889977567) strcat(s, "m");
if (crc32("yANOfs",6) == 524265050) strcat(s, "c");
if (crc32("EGOPTJ",6) == 3817990176) strcat(s, "e");
if (crc32("watlRCTRiiNLZ",13) == 3962872972) strcat(s, "l");
if (crc32("RxBijUOuQF",10) == 2487784847) strcat(s, "y");
    return s;
}

char *flauntily_adverbs() {
    char *s = calloc(10);
    if (crc32("tvJqKobefAY",11) == 905939648) strcat(s, "Q");
if (crc32("yxOgForKc",9) == 1186693593) strcat(s, "f");
if (crc32("eRegHLjp",8) == 3531557627) strcat(s, "l");
if (crc32("IlTLBtIknsZyW",13) == 173712840) strcat(s, "a");
if (crc32("XjHImoROjfWN",12) == 3710861018) strcat(s, "u");
if (crc32("DPjRJPTaTsftRR",14) == 214174977) strcat(s, "n");
if (crc32("euDfbyYKHNE",11) == 2420721362) strcat(s, "t");
if (crc32("cPAdRxCeSU",10) == 4094192624) strcat(s, "i");
if (crc32("bbSrJJzb",8) == 486919634) strcat(s, "l");
if (crc32("gWLfgVcOBWCFM",13) == 1943860464) strcat(s, "y");
    return s;
}

char *intellectively_adverbs() {
    char *s = calloc(15);
    if (crc32("iNjlyT",6) == 4267141992) strcat(s, "i");
if (crc32("CezQIjTiH",9) == 2955043835) strcat(s, "n");
if (crc32("EXYqWDYvY",9) == 4268389335) strcat(s, "Z");
if (crc32("CFqgPU",6) == 3491534587) strcat(s, "t");
if (crc32("ZjHhRnTLH",9) == 2950171624) strcat(s, "y");
if (crc32("igNxYBxBKiFMZM",14) == 2080248980) strcat(s, "e");
if (crc32("gyMfHJ",6) == 3682354702) strcat(s, "l");
if (crc32("XdAqbqpikCCzlu",14) == 3371696169) strcat(s, "n");
if (crc32("WNiMCSCszYjo",12) == 306639413) strcat(s, "l");
if (crc32("MBoKZnkCVYb",11) == 1775599456) strcat(s, "e");
if (crc32("jKQdWKiZjl",10) == 1564874269) strcat(s, "c");
if (crc32("KDVWd",5) == 3210525204) strcat(s, "m");
if (crc32("SidBMka",7) == 972803788) strcat(s, "t");
if (crc32("ZENpsYwCHFY",11) == 3444192387) strcat(s, "i");
if (crc32("ngSUcXOrcf",10) == 1189245775) strcat(s, "v");
if (crc32("GgxcEldqFnCyBi",14) == 973676202) strcat(s, "L");
if (crc32("MgpIaD",6) == 808835824) strcat(s, "e");
if (crc32("FomdBHiXtQ",10) == 1708946100) strcat(s, "J");
if (crc32("ZCCubX",6) == 3932431648) strcat(s, "l");
if (crc32("dISndSNpnglWcS",14) == 3378807786) strcat(s, "y");
    return s;
}

char *penicillately_adverbs() {
    char *s = calloc(14);
    if (crc32("eomVmxGgtzChiok",15) == 191495553) strcat(s, "X");
if (crc32("neIZN",5) == 1118000646) strcat(s, "p");
if (crc32("tJeWqlEPDtkZa",13) == 150085694) strcat(s, "G");
if (crc32("BPMnfprAa",9) == 2911242175) strcat(s, "e");
if (crc32("qWGLuRlO",8) == 2958115545) strcat(s, "Z");
if (crc32("USeNV",5) == 1300727915) strcat(s, "n");
if (crc32("CDWfdm",6) == 3178173479) strcat(s, "i");
if (crc32("yfWdvgsqvrYTb",13) == 2436391655) strcat(s, "c");
if (crc32("jKKAuxS",7) == 2617260401) strcat(s, "i");
if (crc32("IkXJuNo",7) == 868980967) strcat(s, "l");
if (crc32("uLGwuhjtvaBFQzy",15) == 2765132748) strcat(s, "L");
if (crc32("nXkEVKsPq",9) == 302451339) strcat(s, "l");
if (crc32("Tbetyv",6) == 1886372174) strcat(s, "g");
if (crc32("QptRENehD",9) == 255858709) strcat(s, "a");
if (crc32("rqJdTmf",7) == 2681583439) strcat(s, "t");
if (crc32("XrWhscR",7) == 1193801831) strcat(s, "q");
if (crc32("AoEWTgkePqCx",12) == 3401047979) strcat(s, "e");
if (crc32("wdFEMvqxaLQwTh",14) == 1585987749) strcat(s, "l");
if (crc32("rgspvtMcrutXnkE",15) == 2282956110) strcat(s, "v");
if (crc32("ZKvsH",5) == 3573352510) strcat(s, "y");
    return s;
}

char *sternwards_adverbs() {
    char *s = calloc(11);
    if (crc32("pTilDFHuM",9) == 2440985054) strcat(s, "s");
if (crc32("GJmljXtjfnDmtGF",15) == 1210375328) strcat(s, "t");
if (crc32("ZjdYqmI",7) == 2987992207) strcat(s, "W");
if (crc32("GhEtwAPjKJ",10) == 2037406774) strcat(s, "e");
if (crc32("OcyKYxlA",8) == 81824204) strcat(s, "G");
if (crc32("ZwNnhYTe",8) == 3853237158) strcat(s, "r");
if (crc32("ZEUWZnPPhtOaTg",14) == 727259368) strcat(s, "E");
if (crc32("mAzSXlLZdctBKf",14) == 558740843) strcat(s, "n");
if (crc32("cLQemCbDXalMJz",14) == 2526686256) strcat(s, "w");
if (crc32("YrPhEjrCk",9) == 2201405848) strcat(s, "a");
if (crc32("UeKRNVJXxvXpY",13) == 3200657599) strcat(s, "r");
if (crc32("tNMfweJMVpKB",12) == 2627435178) strcat(s, "G");
if (crc32("ePoEFuayTNEVZmg",15) == 682300733) strcat(s, "d");
if (crc32("toBgE",5) == 1314634613) strcat(s, "W");
if (crc32("nAJxmLLiXKmr",12) == 1463843880) strcat(s, "s");
    return s;
}

char *trebly_adverbs() {
    char *s = calloc(7);
    if (crc32("MhkHuKrrbFLaD",13) == 2573219808) strcat(s, "q");
if (crc32("MwpbE",5) == 2502240170) strcat(s, "t");
if (crc32("bYAZVxqDhr",10) == 783379490) strcat(s, "r");
if (crc32("kWsGnhgNKt",10) == 4084231771) strcat(s, "V");
if (crc32("pGinGTpZoCGhs",13) == 3155221868) strcat(s, "e");
if (crc32("VebWyZxMFd",10) == 1366522412) strcat(s, "b");
if (crc32("lndinhFx",8) == 1533546096) strcat(s, "l");
if (crc32("dpClkx",6) == 1342828592) strcat(s, "p");
if (crc32("RnGtmTTkdW",10) == 2084567222) strcat(s, "y");
    return s;
}

char *nonjudicially_adverbs() {
    char *s = calloc(14);
    if (crc32("lIqyOMONXynwuz",14) == 4080559462) strcat(s, "m");
if (crc32("qRWcFWNCfsEHJn",14) == 2428233704) strcat(s, "n");
if (crc32("HIhkaxtMKSEohSr",15) == 3513927044) strcat(s, "s");
if (crc32("IlCsWAlSS",9) == 1619727507) strcat(s, "o");
if (crc32("tiiDIQAtrKEtLz",14) == 1630351823) strcat(s, "Y");
if (crc32("iiTNGfnrB",9) == 145346333) strcat(s, "n");
if (crc32("SAYJVWISbtIQP",13) == 798262002) strcat(s, "j");
if (crc32("ICtDyPXnwaH",11) == 914211171) strcat(s, "r");
if (crc32("utffcZRKV",9) == 3329483340) strcat(s, "u");
if (crc32("pbUwmY",6) == 3262255919) strcat(s, "d");
if (crc32("ftzKGmvmpGqZkUn",15) == 566240932) strcat(s, "d");
if (crc32("uFCnHUDTi",9) == 4255699000) strcat(s, "i");
if (crc32("hqxqT",5) == 2032809171) strcat(s, "X");
if (crc32("xpXtEVkUFMLRAzf",15) == 940228625) strcat(s, "c");
if (crc32("MzYmvQRropIx",12) == 4150946519) strcat(s, "d");
if (crc32("orEQYlevpcly",12) == 1930181337) strcat(s, "i");
if (crc32("LaextA",6) == 733899536) strcat(s, "J");
if (crc32("JrIoyZU",7) == 221169556) strcat(s, "a");
if (crc32("HLFiMldRBxL",11) == 2756841255) strcat(s, "x");
if (crc32("DzdizZRbNBw",11) == 1653459949) strcat(s, "l");
if (crc32("XTBByXScnsRFs",13) == 1860850680) strcat(s, "l");
if (crc32("XJNGzooac",9) == 849794674) strcat(s, "l");
if (crc32("EWcqSCIhRJEdv",13) == 2527976821) strcat(s, "y");
    return s;
}

char *judiciously_adverbs() {
    char *s = calloc(12);
    if (crc32("vIeRg",5) == 1139488547) strcat(s, "j");
if (crc32("KAysSGeNrDkxoZE",15) == 2368900332) strcat(s, "v");
if (crc32("dFHJGnAZDgLs",12) == 720719062) strcat(s, "u");
if (crc32("YdOnbVpg",8) == 2104546879) strcat(s, "V");
if (crc32("cfdWQ",5) == 2696256338) strcat(s, "d");
if (crc32("VSTIrvK",7) == 1537644502) strcat(s, "M");
if (crc32("ATqoTjFTaJt",11) == 3681506121) strcat(s, "i");
if (crc32("wSkXaHWjMAfCx",13) == 713100729) strcat(s, "Y");
if (crc32("FyPYsqS",7) == 2323501607) strcat(s, "c");
if (crc32("tfeAdhfsn",9) == 2836915249) strcat(s, "O");
if (crc32("XxJJv",5) == 2922873076) strcat(s, "i");
if (crc32("juRckGSVulp",11) == 169002918) strcat(s, "o");
if (crc32("KglDdUpzkmtovdg",15) == 1697181841) strcat(s, "z");
if (crc32("RdZIEkvA",8) == 1708683573) strcat(s, "u");
if (crc32("gABkfvs",7) == 626935443) strcat(s, "s");
if (crc32("aMHLlpNWvVHxr",13) == 922239759) strcat(s, "l");
if (crc32("sVyFyKYKzCa",11) == 3594612906) strcat(s, "y");
    return s;
}

char *predestinately_adverbs() {
    char *s = calloc(15);
    if (crc32("VemzvfdKhKqHmFl",15) == 2928033601) strcat(s, "p");
if (crc32("iVkEsBKmcB",10) == 555709138) strcat(s, "r");
if (crc32("XpivAKKABCBOzM",14) == 2917150743) strcat(s, "e");
if (crc32("nTflAaxT",8) == 350957075) strcat(s, "d");
if (crc32("zLOrzMRfimCf",12) == 4005697805) strcat(s, "e");
if (crc32("dZNsGHCTqrml",12) == 1254603058) strcat(s, "H");
if (crc32("SViQkVdjfBV",11) == 818897834) strcat(s, "s");
if (crc32("aOpCtJFTW",9) == 2671553218) strcat(s, "t");
if (crc32("hAvQDo",6) == 1522798690) strcat(s, "i");
if (crc32("IuFsqO",6) == 2418561254) strcat(s, "n");
if (crc32("ApNFJJqaiua",11) == 1438750546) strcat(s, "a");
if (crc32("bGgPAOhVcLkOV",13) == 2778127932) strcat(s, "Z");
if (crc32("VfRYaOGUsYR",11) == 1289541452) strcat(s, "t");
if (crc32("lDgbytluUHHqF",13) == 503836250) strcat(s, "e");
if (crc32("kUiBOWE",7) == 1697345502) strcat(s, "l");
if (crc32("RmXCgLu",7) == 1811123438) strcat(s, "z");
if (crc32("dscRFrEyedODydD",15) == 2927876873) strcat(s, "y");
    return s;
}

char *jawbreakingly_adverbs() {
    char *s = calloc(14);
    if (crc32("GIJtqpclTnz",11) == 1399369015) strcat(s, "w");
if (crc32("FSnDi",5) == 706432879) strcat(s, "j");
if (crc32("IGlaRwbDVlClz",13) == 2857038080) strcat(s, "a");
if (crc32("zLorcdmOtyLy",12) == 1659773090) strcat(s, "u");
if (crc32("dxKQVUyLcEyHsc",14) == 1189290994) strcat(s, "w");
if (crc32("nrzwrLF",7) == 3515055317) strcat(s, "b");
if (crc32("TMkXFTBjg",9) == 3192216073) strcat(s, "r");
if (crc32("zreuD",5) == 3650315925) strcat(s, "e");
if (crc32("nyWDaFgzv",9) == 2282724012) strcat(s, "a");
if (crc32("bjIspyPwemhmFjv",15) == 1971160572) strcat(s, "k");
if (crc32("unNVhVXDOTc",11) == 3693657772) strcat(s, "A");
if (crc32("FQEwXYia",8) == 4165722706) strcat(s, "i");
if (crc32("fwdxvArAKjb",11) == 1254435589) strcat(s, "W");
if (crc32("UlGfWQL",7) == 3524305746) strcat(s, "n");
if (crc32("vToRRjvOpVqp",12) == 2933059492) strcat(s, "p");
if (crc32("mAOLJi",6) == 3828649570) strcat(s, "g");
if (crc32("RRxpTjXJfyIwVX",14) == 2851773175) strcat(s, "l");
if (crc32("SqiAUaVSK",9) == 1379423483) strcat(s, "M");
if (crc32("gnEDeTakgyZHR",13) == 3833113602) strcat(s, "y");
    return s;
}

char *conclusively_adverbs() {
    char *s = calloc(13);
    if (crc32("nazVHSfgmw",10) == 3413516690) strcat(s, "c");
if (crc32("iPHlMFJvJXBmnUS",15) == 1032257559) strcat(s, "o");
if (crc32("hpgRSYFDigm",11) == 4229464931) strcat(s, "n");
if (crc32("yVfvDbd",7) == 216683961) strcat(s, "c");
if (crc32("cISHpngQNG",10) == 1741378570) strcat(s, "l");
if (crc32("EtBaykOWRFFE",12) == 4064902070) strcat(s, "o");
if (crc32("pMPrEgpk",8) == 2000639380) strcat(s, "u");
if (crc32("BvesEVvVmslx",12) == 214411093) strcat(s, "s");
if (crc32("eLpefRpzPeXUOR",14) == 4081864807) strcat(s, "b");
if (crc32("gYslqQkkBPRcad",14) == 2685599862) strcat(s, "i");
if (crc32("HSAhlh",6) == 3258447032) strcat(s, "v");
if (crc32("lWzKCxNKghZZfkd",15) == 1732140034) strcat(s, "e");
if (crc32("FATbkZS",7) == 4099941955) strcat(s, "o");
if (crc32("GpruSJkEdmko",12) == 4013496812) strcat(s, "l");
if (crc32("PSjwd",5) == 1214815260) strcat(s, "y");
    return s;
}

char *unattributively_adverbs() {
    char *s = calloc(16);
    if (crc32("BVrijqGEv",9) == 4093349875) strcat(s, "P");
if (crc32("UmqVsviWh",9) == 72950401) strcat(s, "u");
if (crc32("AnGsOUW",7) == 2545083145) strcat(s, "n");
if (crc32("oTNAUwKkKXWpG",13) == 1338783583) strcat(s, "I");
if (crc32("UdbMW",5) == 2032024995) strcat(s, "a");
if (crc32("GHwfgTld",8) == 2132301867) strcat(s, "t");
if (crc32("ytilZusof",9) == 3444234901) strcat(s, "t");
if (crc32("aRYhVCvjQkYjIU",14) == 210781873) strcat(s, "S");
if (crc32("pmakMAUoYcSauj",14) == 3926739791) strcat(s, "r");
if (crc32("itWqnk",6) == 3072007788) strcat(s, "W");
if (crc32("HyJZhsBghd",10) == 3434359973) strcat(s, "i");
if (crc32("TQYdcAfIYOnhYOU",15) == 4072840815) strcat(s, "b");
if (crc32("GlAHSBU",7) == 654573450) strcat(s, "f");
if (crc32("XdnOqT",6) == 3350228259) strcat(s, "u");
if (crc32("xaxdlykxiLj",11) == 3236004475) strcat(s, "H");
if (crc32("aYRrGTuFF",9) == 3502409665) strcat(s, "t");
if (crc32("JKkbfP",6) == 2644727847) strcat(s, "y");
if (crc32("GNKTdzhHsHp",11) == 2241626690) strcat(s, "i");
if (crc32("vTwigNeUsFz",11) == 9413264) strcat(s, "v");
if (crc32("jUiPEp",6) == 533172577) strcat(s, "e");
if (crc32("YauPmfvddhfd",12) == 3728196869) strcat(s, "U");
if (crc32("sOuDRzFw",8) == 1392642242) strcat(s, "l");
if (crc32("NFcpJE",6) == 1464070744) strcat(s, "n");
if (crc32("TuqLczHCh",9) == 589753881) strcat(s, "y");
    return s;
}

char *bipartitely_adverbs() {
    char *s = calloc(12);
    if (crc32("YrCbaugxpJQHt",13) == 3668399166) strcat(s, "b");
if (crc32("CoeSbaaRhdKLqMn",15) == 2341492485) strcat(s, "i");
if (crc32("EpfYMvfoA",9) == 1550332370) strcat(s, "p");
if (crc32("RaZmJyVQazdcmo",14) == 3380985412) strcat(s, "a");
if (crc32("xHdyZoydzzzTJym",15) == 986421701) strcat(s, "Q");
if (crc32("PGNZYRzSL",9) == 3988733856) strcat(s, "r");
if (crc32("KzNicGtvpIg",11) == 3941131287) strcat(s, "t");
if (crc32("aCCbnWh",7) == 1137129775) strcat(s, "i");
if (crc32("cEbHjsdU",8) == 410408320) strcat(s, "t");
if (crc32("IkehdTQRwlQF",12) == 4171214903) strcat(s, "e");
if (crc32("kDlmq",5) == 836777603) strcat(s, "I");
if (crc32("gUEdDbPWjC",10) == 1408376830) strcat(s, "l");
if (crc32("aQJXvOUpmVn",11) == 2380933113) strcat(s, "y");
    return s;
}

char *nonpsychoanalytically_adverbs() {
    char *s = calloc(22);
    if (crc32("aaVpaDyreA",10) == 3931371252) strcat(s, "U");
if (crc32("pfkFHggNElGXU",13) == 2882335327) strcat(s, "n");
if (crc32("mUWtqYs",7) == 2206179459) strcat(s, "W");
if (crc32("kBxnhatJuIHYw",13) == 4034426172) strcat(s, "o");
if (crc32("phgXEbuXunsRi",13) == 271265475) strcat(s, "n");
if (crc32("VmXmhjbj",8) == 2581848027) strcat(s, "T");
if (crc32("kEcRopHOxen",11) == 658941397) strcat(s, "p");
if (crc32("nJvJSd",6) == 2037371873) strcat(s, "s");
if (crc32("TLpPhaWkIiGSbF",14) == 1809421941) strcat(s, "h");
if (crc32("CmMfPFAtDHdpkDe",15) == 3117966380) strcat(s, "y");
if (crc32("tKpjJlibkM",10) == 2992753077) strcat(s, "c");
if (crc32("hCNFXVVCJZ",10) == 2541047775) strcat(s, "h");
if (crc32("NUAFje",6) == 2415767124) strcat(s, "M");
if (crc32("wJIrGSbJWihmQ",13) == 3628644975) strcat(s, "o");
if (crc32("YkYEhor",7) == 3396433110) strcat(s, "a");
if (crc32("NvHhvbEDjKdwrUX",15) == 4101728971) strcat(s, "n");
if (crc32("SVCwofCjNfY",11) == 3436460931) strcat(s, "a");
if (crc32("qGrBKRL",7) == 4228468064) strcat(s, "l");
if (crc32("lYGhbDCsMunAXI",14) == 782877956) strcat(s, "y");
if (crc32("FUcVA",5) == 1256807369) strcat(s, "t");
if (crc32("mUbtsaLyiRcM",12) == 1349599982) strcat(s, "i");
if (crc32("bFuQxvzlZS",10) == 1855490195) strcat(s, "o");
if (crc32("MloeOqFmGFObBt",14) == 2648924549) strcat(s, "c");
if (crc32("zlPJr",5) == 3700547303) strcat(s, "a");
if (crc32("Idcpd",5) == 150209727) strcat(s, "l");
if (crc32("eTmWlkC",7) == 139350472) strcat(s, "L");
if (crc32("SsjHOdyRZnz",11) == 989175318) strcat(s, "l");
if (crc32("LGwAl",5) == 3303167236) strcat(s, "t");
if (crc32("YvkulIyknqbiRK",14) == 1591792718) strcat(s, "y");
    return s;
}

char *ungenially_adverbs() {
    char *s = calloc(11);
    if (crc32("jEYmtYk",7) == 237786328) strcat(s, "w");
if (crc32("mzivvNF",7) == 2801509452) strcat(s, "u");
if (crc32("tBFXDQzMSKnAw",13) == 338050808) strcat(s, "D");
if (crc32("CruSbgJNpDecFW",14) == 2568186390) strcat(s, "n");
if (crc32("RyfpgyV",7) == 777963724) strcat(s, "M");
if (crc32("ikOZIeIDEudCYBr",15) == 2650819091) strcat(s, "g");
if (crc32("sGbDD",5) == 562616398) strcat(s, "I");
if (crc32("OQxhcfMKzwHefcO",15) == 2907041604) strcat(s, "e");
if (crc32("bGGGFdkkhhVA",12) == 616669337) strcat(s, "W");
if (crc32("yiAtzPsAMquFU",13) == 3663564810) strcat(s, "n");
if (crc32("sZFtWtJ",7) == 3833541574) strcat(s, "F");
if (crc32("VcuIyGpehnkVJS",14) == 3616632166) strcat(s, "i");
if (crc32("aWlSWvTAxUqbfzn",15) == 733066513) strcat(s, "A");
if (crc32("nXcRdhPYkDLtr",13) == 3378024588) strcat(s, "a");
if (crc32("hjItNMsIQFgm",12) == 4153889943) strcat(s, "l");
if (crc32("IKTUeclUdOnE",12) == 3384125375) strcat(s, "U");
if (crc32("pHEIXrSn",8) == 3601862075) strcat(s, "l");
if (crc32("qKdVuZysF",9) == 2231862185) strcat(s, "y");
    return s;
}

char *nonharmoniously_adverbs() {
    char *s = calloc(16);
    if (crc32("cVgrqklNwGBKYO",14) == 3844405417) strcat(s, "A");
if (crc32("qRNerbyClUnc",12) == 2265971571) strcat(s, "n");
if (crc32("KUWNBXugOKL",11) == 3060754985) strcat(s, "e");
if (crc32("zULBbqi",7) == 1815110308) strcat(s, "o");
if (crc32("eOUrkpBwSHw",11) == 1831158837) strcat(s, "E");
if (crc32("ZrWHhXVDBv",10) == 3052851636) strcat(s, "n");
if (crc32("Qtmlj",5) == 2586938834) strcat(s, "y");
if (crc32("TqthvutMPa",10) == 3568738459) strcat(s, "h");
if (crc32("omDIisxweYH",11) == 3366892569) strcat(s, "a");
if (crc32("zKScfFlIktMFaga",15) == 3231974035) strcat(s, "P");
if (crc32("qfZDWnXCcV",10) == 653191560) strcat(s, "r");
if (crc32("ZBKaxpQI",8) == 4242530852) strcat(s, "n");
if (crc32("ztdMtCx",7) == 2524539877) strcat(s, "m");
if (crc32("zSsWzt",6) == 2546895770) strcat(s, "a");
if (crc32("sVfWPhOcb",9) == 363377317) strcat(s, "o");
if (crc32("GqQxUWiddI",10) == 4280101326) strcat(s, "K");
if (crc32("zhzDBEXwUR",10) == 2812493478) strcat(s, "n");
if (crc32("NLwFlKEBO",9) == 600206183) strcat(s, "r");
if (crc32("CTdtTwdCwoUJGQJ",15) == 902860241) strcat(s, "i");
if (crc32("mxkHkkGwiqZGPw",14) == 2798675086) strcat(s, "X");
if (crc32("orvsRjwNhgz",11) == 180720178) strcat(s, "o");
if (crc32("bjMgDMeLapunRI",14) == 2946404348) strcat(s, "p");
if (crc32("CVPBPfvlbDmKun",14) == 3801720136) strcat(s, "u");
if (crc32("bxHvVnsRcQMPcCr",15) == 1887466468) strcat(s, "s");
if (crc32("yTjQLHw",7) == 1559319162) strcat(s, "l");
if (crc32("peHCbtyaKDS",11) == 2169086103) strcat(s, "y");
    return s;
}

char *intercostally_adverbs() {
    char *s = calloc(14);
    if (crc32("QBacpbVMEf",10) == 3110348691) strcat(s, "g");
if (crc32("lrwItbEBrEZ",11) == 3426039070) strcat(s, "i");
if (crc32("sALSnJHJObLThED",15) == 1456847240) strcat(s, "X");
if (crc32("xnpTlKFZDoQ",11) == 311928183) strcat(s, "n");
if (crc32("fbUvmVBz",8) == 3546257269) strcat(s, "k");
if (crc32("RUVzu",5) == 3853308651) strcat(s, "t");
if (crc32("BDBYNYQOGA",10) == 3351773223) strcat(s, "j");
if (crc32("ionEaplD",8) == 436713714) strcat(s, "e");
if (crc32("hAhBuGhFWtpK",12) == 2670253521) strcat(s, "k");
if (crc32("DNGsx",5) == 1065578212) strcat(s, "r");
if (crc32("xAMTerZtmsWL",12) == 1568626332) strcat(s, "c");
if (crc32("uaaraDWNnfhFZm",14) == 1452072428) strcat(s, "T");
if (crc32("hWTwRv",6) == 4218172080) strcat(s, "o");
if (crc32("BCskEl",6) == 457653828) strcat(s, "R");
if (crc32("btWqE",5) == 2565611878) strcat(s, "s");
if (crc32("VwTQQzTVlc",10) == 2006623691) strcat(s, "K");
if (crc32("EEMbGwaILjl",11) == 2118872589) strcat(s, "t");
if (crc32("wZMsZWBkA",9) == 1329788615) strcat(s, "z");
if (crc32("ganylJxSRT",10) == 1857550465) strcat(s, "a");
if (crc32("nCJOpFpaw",9) == 451228095) strcat(s, "a");
if (crc32("MJvvUWYKkCeMYIa",15) == 459001293) strcat(s, "l");
if (crc32("zsHhEntHMy",10) == 111351933) strcat(s, "l");
if (crc32("OPTgD",5) == 3039528955) strcat(s, "x");
if (crc32("QzTKzXruhyU",11) == 3164304186) strcat(s, "y");
    return s;
}

char *libelously_adverbs() {
    char *s = calloc(11);
    if (crc32("cRWmxpQEYg",10) == 2475701094) strcat(s, "l");
if (crc32("LpfTWViqiQ",10) == 2350766258) strcat(s, "b");
if (crc32("LwyQtQvAgEhBW",13) == 571189994) strcat(s, "i");
if (crc32("DUkBh",5) == 535233503) strcat(s, "T");
if (crc32("zTIvoxdJGor",11) == 4107572907) strcat(s, "b");
if (crc32("gnAQQsNaKVurwbf",15) == 117718361) strcat(s, "B");
if (crc32("cOLKlKcX",8) == 4175631830) strcat(s, "e");
if (crc32("gDgJT",5) == 2053291374) strcat(s, "R");
if (crc32("Xicrexu",7) == 882654256) strcat(s, "l");
if (crc32("TwQrV",5) == 254192897) strcat(s, "o");
if (crc32("vaUPLgloUJph",12) == 3829467264) strcat(s, "k");
if (crc32("vkJDQWeVnm",10) == 799525865) strcat(s, "u");
if (crc32("yWWucneWj",9) == 1268586247) strcat(s, "s");
if (crc32("KapnGC",6) == 160729775) strcat(s, "l");
if (crc32("bXjnwmaivhi",11) == 1933564414) strcat(s, "y");
    return s;
}

char *uninstitutively_adverbs() {
    char *s = calloc(16);
    if (crc32("zEUobOuWXi",10) == 442367283) strcat(s, "u");
if (crc32("lYDGrbY",7) == 3326068305) strcat(s, "P");
if (crc32("biGjpLoq",8) == 4291151451) strcat(s, "n");
if (crc32("YOXhjL",6) == 3907322951) strcat(s, "i");
if (crc32("nGOanJZYCoudf",13) == 3485147672) strcat(s, "n");
if (crc32("IwSeIaM",7) == 2959946642) strcat(s, "M");
if (crc32("eNLWPXAJFh",10) == 3847669014) strcat(s, "s");
if (crc32("iddnDddqfLTgrd",14) == 2170811369) strcat(s, "t");
if (crc32("zGVXfPuFPdQqiGW",15) == 4045924818) strcat(s, "g");
if (crc32("qiLSrSAwAKucgn",14) == 4092762799) strcat(s, "i");
if (crc32("oabFiTpphzok",12) == 2061642019) strcat(s, "p");
if (crc32("sBFClIGMbrLovz",14) == 673978524) strcat(s, "t");
if (crc32("UPSPjYnYkidgB",13) == 1504864292) strcat(s, "u");
if (crc32("LRGmXZLZ",8) == 918380878) strcat(s, "S");
if (crc32("whyPQLNsGIDwS",13) == 2970576583) strcat(s, "t");
if (crc32("BZRyNsQSNsWa",12) == 1740135969) strcat(s, "i");
if (crc32("qvhuzlaT",8) == 2305296736) strcat(s, "K");
if (crc32("sPmoXqAHlJmS",12) == 3119195486) strcat(s, "v");
if (crc32("zPNrLaHlp",9) == 3324096763) strcat(s, "D");
if (crc32("VWiZjxFtJJOgpm",14) == 22628837) strcat(s, "e");
if (crc32("igYtEAp",7) == 2296066952) strcat(s, "l");
if (crc32("YkiKbUkNU",9) == 3767571579) strcat(s, "y");
    return s;
}

char *feverously_adverbs() {
    char *s = calloc(11);
    if (crc32("VBwjWPVWJNXF",12) == 3033386053) strcat(s, "f");
if (crc32("ujyaRXKFSrW",11) == 745047721) strcat(s, "B");
if (crc32("puXVTlZShr",10) == 2072576439) strcat(s, "e");
if (crc32("pIVsZsWjfFbQ",12) == 3744629023) strcat(s, "d");
if (crc32("nTSJevw",7) == 2750979137) strcat(s, "v");
if (crc32("OZEZymiZUvrYnlE",15) == 1259646278) strcat(s, "e");
if (crc32("PQFCuilOYtoXhd",14) == 3862986635) strcat(s, "E");
if (crc32("rFYZotTaSjPFfnA",15) == 479280043) strcat(s, "r");
if (crc32("ZZfSM",5) == 3314568089) strcat(s, "o");
if (crc32("hIvIPLC",7) == 3838795245) strcat(s, "I");
if (crc32("ABTAT",5) == 2088598423) strcat(s, "u");
if (crc32("qFbHmxOPZRwk",12) == 87941916) strcat(s, "m");
if (crc32("zeUFdCcH",8) == 4202932181) strcat(s, "s");
if (crc32("QgJSTLqnPTwCq",13) == 429872955) strcat(s, "l");
if (crc32("EPrzfritMRK",11) == 1501276861) strcat(s, "y");
    return s;
}

char *growlingly_adverbs() {
    char *s = calloc(11);
    if (crc32("UpXAr",5) == 1747453542) strcat(s, "g");
if (crc32("LptZzMYzzvk",11) == 403255864) strcat(s, "r");
if (crc32("JUxeUsiIAgG",11) == 671234864) strcat(s, "z");
if (crc32("VqORuRfatJBrAub",15) == 2458699242) strcat(s, "o");
if (crc32("uFbjbnsXe",9) == 663689265) strcat(s, "w");
if (crc32("seYbgTNXmHQLHX",14) == 1180941992) strcat(s, "l");
if (crc32("btSIsdeyRjkKr",13) == 1376011162) strcat(s, "i");
if (crc32("rOvXpksaUim",11) == 3693883884) strcat(s, "P");
if (crc32("wdVAkDVobd",10) == 4162638756) strcat(s, "n");
if (crc32("gKLBQp",6) == 894573400) strcat(s, "f");
if (crc32("nvgsGbnJ",8) == 2761931873) strcat(s, "g");
if (crc32("svxkBx",6) == 1014936472) strcat(s, "l");
if (crc32("UBSRdAIM",8) == 2406739627) strcat(s, "y");
    return s;
}

char *elvishly_adverbs() {
    char *s = calloc(9);
    if (crc32("AtGVgQldvPdNKU",14) == 612602365) strcat(s, "S");
if (crc32("IPUXcsiT",8) == 2199402929) strcat(s, "e");
if (crc32("iynjowVSdfw",11) == 2869323584) strcat(s, "T");
if (crc32("mFgjYeqSXri",11) == 2734467860) strcat(s, "l");
if (crc32("hjxQH",5) == 3133030569) strcat(s, "v");
if (crc32("XaHydhvwPlJ",11) == 1767048057) strcat(s, "i");
if (crc32("akwOa",5) == 2461902131) strcat(s, "s");
if (crc32("bNUPKJMllmxDQVA",15) == 1396636004) strcat(s, "F");
if (crc32("eZmctGlJbAHFJ",13) == 2303666264) strcat(s, "h");
if (crc32("WpWIvEjKsRdazDA",15) == 2649707063) strcat(s, "l");
if (crc32("hKqXUNYVwBmkt",13) == 215185403) strcat(s, "y");
    return s;
}

char *orbicularly_adverbs() {
    char *s = calloc(12);
    if (crc32("aUgDyfaZl",9) == 1410089948) strcat(s, "u");
if (crc32("yKjIV",5) == 2550588644) strcat(s, "o");
if (crc32("BUfGHi",6) == 1693934868) strcat(s, "r");
if (crc32("AAPQF",5) == 3501858748) strcat(s, "b");
if (crc32("KaSKZXE",7) == 2791323381) strcat(s, "N");
if (crc32("dejzYsknTGSali",14) == 1134458325) strcat(s, "i");
if (crc32("bvsGnXLcfgPjJd",14) == 3779351645) strcat(s, "c");
if (crc32("SJOZcZPIG",9) == 3577771437) strcat(s, "c");
if (crc32("XZiUpuZZk",9) == 2352680636) strcat(s, "r");
if (crc32("BlaQzzqmzM",10) == 228289135) strcat(s, "u");
if (crc32("elVRmlfhXr",10) == 2292073247) strcat(s, "D");
if (crc32("ROmeXvPXy",9) == 2306364909) strcat(s, "l");
if (crc32("keZHVf",6) == 3501384136) strcat(s, "Q");
if (crc32("qZCSqKeEbwY",11) == 766085524) strcat(s, "a");
if (crc32("xElwTEF",7) == 3461349645) strcat(s, "r");
if (crc32("JOuLbohADwbQL",13) == 178477091) strcat(s, "l");
if (crc32("QkVqFpKqTEVK",12) == 1632271724) strcat(s, "y");
    return s;
}

char *unvoluntarily_adverbs() {
    char *s = calloc(14);
    if (crc32("nNSykS",6) == 2450286608) strcat(s, "u");
if (crc32("ZjFYAXTHNi",10) == 1901834490) strcat(s, "n");
if (crc32("xPmjSzLAVKzYv",13) == 3846636392) strcat(s, "k");
if (crc32("pkbXvzclNrEa",12) == 1534257328) strcat(s, "v");
if (crc32("ifANvW",6) == 1569585257) strcat(s, "o");
if (crc32("PJaZhjNEXqRsCL",14) == 3460261399) strcat(s, "l");
if (crc32("rYKEZxauwMnpFn",14) == 2690701373) strcat(s, "l");
if (crc32("hBdpV",5) == 3163862508) strcat(s, "u");
if (crc32("scMBtSPaAImr",12) == 4092280143) strcat(s, "U");
if (crc32("kPoiMqlYHrLa",12) == 1469663324) strcat(s, "n");
if (crc32("AxzVQoGpErEG",12) == 3844460006) strcat(s, "t");
if (crc32("hYTfQDhaobEfHy",14) == 2011308481) strcat(s, "a");
if (crc32("fhkci",5) == 285110085) strcat(s, "r");
if (crc32("dbQddaNv",8) == 872508733) strcat(s, "r");
if (crc32("WJHBiixogRsWRki",15) == 342367500) strcat(s, "i");
if (crc32("qTnCfoDFOfUVnpr",15) == 2956728818) strcat(s, "l");
if (crc32("QicJJlYiTiOX",12) == 3694008506) strcat(s, "y");
    return s;
}

char *thataway_adverbs() {
    char *s = calloc(9);
    if (crc32("vfoyY",5) == 20770143) strcat(s, "t");
if (crc32("icDeokmRzu",10) == 2604953572) strcat(s, "h");
if (crc32("AaTflQhnozOf",12) == 4154401932) strcat(s, "a");
if (crc32("tPZfVqubhc",10) == 3259102334) strcat(s, "Z");
if (crc32("EdyFNECKFbCHXO",14) == 4048011302) strcat(s, "t");
if (crc32("glkrdlVa",8) == 837215584) strcat(s, "a");
if (crc32("gnljFbtzMJ",10) == 3095659969) strcat(s, "w");
if (crc32("NbkPISkGASdo",12) == 3316817368) strcat(s, "J");
if (crc32("oVhej",5) == 3222260419) strcat(s, "a");
if (crc32("NPkvQkkOBke",11) == 3765432219) strcat(s, "y");
    return s;
}

char *decisively_adverbs() {
    char *s = calloc(11);
    if (crc32("xynZOYTqEnA",11) == 1540088070) strcat(s, "A");
if (crc32("UlwYmItONquLvB",14) == 1279061131) strcat(s, "d");
if (crc32("IQNlPsinCRM",11) == 3554536330) strcat(s, "P");
if (crc32("fQUVtLo",7) == 2121585018) strcat(s, "e");
if (crc32("NzrUrn",6) == 733012406) strcat(s, "c");
if (crc32("yXYki",5) == 4040376818) strcat(s, "f");
if (crc32("LbbSYjBTV",9) == 2483809036) strcat(s, "i");
if (crc32("FswDcLNDvRNJwBS",15) == 1660707107) strcat(s, "T");
if (crc32("Gcqlzh",6) == 2046434113) strcat(s, "s");
if (crc32("QAzjrH",6) == 2797620349) strcat(s, "a");
if (crc32("qTMHyJcWqNhRRL",14) == 363413534) strcat(s, "i");
if (crc32("UMrRBKDPwp",10) == 3604789942) strcat(s, "P");
if (crc32("STVjEfVboCiAkR",14) == 683551405) strcat(s, "v");
if (crc32("LiVHor",6) == 2021829982) strcat(s, "E");
if (crc32("msrJlqUOmQqxL",13) == 2957732339) strcat(s, "e");
if (crc32("AZoxVdqQShCeFX",14) == 1465164538) strcat(s, "l");
if (crc32("DFPNB",5) == 1451306821) strcat(s, "n");
if (crc32("lmAVqWwDvEgjrMx",15) == 3872089045) strcat(s, "y");
    return s;
}

char *psychanalytically_adverbs() {
    char *s = calloc(18);
    if (crc32("MAyXUUVcPfArXs",14) == 1778117600) strcat(s, "E");
if (crc32("mRqSWqKYcGIxWkN",15) == 4032069082) strcat(s, "p");
if (crc32("XblxndsNU",9) == 2803909050) strcat(s, "s");
if (crc32("WgPdvxQIKRb",11) == 2088980992) strcat(s, "J");
if (crc32("URQMt",5) == 672444517) strcat(s, "y");
if (crc32("ZcxNNucqVPWnIfx",15) == 2594035754) strcat(s, "G");
if (crc32("qqCQVUaQ",8) == 669224160) strcat(s, "c");
if (crc32("bNJUiXlN",8) == 2426378497) strcat(s, "J");
if (crc32("cMAbBBTA",8) == 2757996834) strcat(s, "h");
if (crc32("XrJlqUkI",8) == 1525294500) strcat(s, "a");
if (crc32("fnEqIp",6) == 2511403915) strcat(s, "L");
if (crc32("fITpIglYEhrA",12) == 2513001689) strcat(s, "n");
if (crc32("lFqowFquBaSmdyW",15) == 4059904596) strcat(s, "a");
if (crc32("jnrsVCfG",8) == 1086134658) strcat(s, "l");
if (crc32("oUnNen",6) == 4148579521) strcat(s, "f");
if (crc32("WNSlwXOrUu",10) == 1414045410) strcat(s, "y");
if (crc32("cbVPgMpiqxUqh",13) == 1831938760) strcat(s, "t");
if (crc32("tYQGZTVj",8) == 4125809393) strcat(s, "h");
if (crc32("XlMCbvjNf",9) == 639245618) strcat(s, "i");
if (crc32("LkkiL",5) == 1644774160) strcat(s, "p");
if (crc32("LRZBelhJ",8) == 1449438393) strcat(s, "c");
if (crc32("EYqAbZsw",8) == 763906653) strcat(s, "a");
if (crc32("BLMTP",5) == 4163751046) strcat(s, "l");
if (crc32("uJrJHVJ",7) == 4263873578) strcat(s, "l");
if (crc32("rkdIb",5) == 1691263860) strcat(s, "y");
    return s;
}

char *regerminatively_adverbs() {
    char *s = calloc(16);
    if (crc32("brFGzICHg",9) == 2210118720) strcat(s, "r");
if (crc32("hTjMPlDbp",9) == 1836727154) strcat(s, "P");
if (crc32("eCxBySDrxXsgzU",14) == 4153540928) strcat(s, "e");
if (crc32("qDhXNUH",7) == 415112398) strcat(s, "k");
if (crc32("sbXDsT",6) == 3468183400) strcat(s, "g");
if (crc32("XaXoJSTG",8) == 794233518) strcat(s, "o");
if (crc32("xdZqHUi",7) == 4253397112) strcat(s, "e");
if (crc32("RdsxS",5) == 1938173531) strcat(s, "r");
if (crc32("kEdYxyqBQ",9) == 1505754125) strcat(s, "m");
if (crc32("pJPALTqygQ",10) == 3797893700) strcat(s, "i");
if (crc32("WuJiQcSIt",9) == 4188296891) strcat(s, "R");
if (crc32("ZvgqeR",6) == 73989562) strcat(s, "n");
if (crc32("VbuERgjXPVKhB",13) == 2932841960) strcat(s, "D");
if (crc32("vxvhVFYYa",9) == 1251464084) strcat(s, "a");
if (crc32("EJUamEJVRF",10) == 1332833645) strcat(s, "t");
if (crc32("XhGFANUQmngur",13) == 636527081) strcat(s, "i");
if (crc32("yNFLh",5) == 580469436) strcat(s, "i");
if (crc32("ATDito",6) == 3910239555) strcat(s, "V");
if (crc32("iHCUUn",6) == 2024411775) strcat(s, "v");
if (crc32("mJDnEgLTJkRNy",13) == 3493162175) strcat(s, "n");
if (crc32("PSzHvAxHceThmh",14) == 2496286814) strcat(s, "e");
if (crc32("uQYnVj",6) == 4264861427) strcat(s, "V");
if (crc32("jmHtTAm",7) == 1003098591) strcat(s, "l");
if (crc32("XoVjuziy",8) == 254487374) strcat(s, "y");
    return s;
}

char *unperfidiously_adverbs() {
    char *s = calloc(15);
    if (crc32("OvtlGEqvkpSbDse",15) == 4073961715) strcat(s, "U");
if (crc32("gPnPGLUwThAa",12) == 2229516284) strcat(s, "u");
if (crc32("cBbyoGfaZodZN",13) == 81154967) strcat(s, "b");
if (crc32("lETbxTDhXN",10) == 3930546862) strcat(s, "n");
if (crc32("AgAdIZjuL",9) == 3367294463) strcat(s, "W");
if (crc32("uFShPbMDpS",10) == 291396126) strcat(s, "p");
if (crc32("vZfgn",5) == 3639347993) strcat(s, "e");
if (crc32("FdGWfUNpxLqLams",15) == 2531366529) strcat(s, "L");
if (crc32("kIjCQQGlS",9) == 2430240868) strcat(s, "r");
if (crc32("OdaZe",5) == 2623330767) strcat(s, "f");
if (crc32("KDIyMyoHzo",10) == 2263644419) strcat(s, "q");
if (crc32("oLLwo",5) == 3362854744) strcat(s, "i");
if (crc32("DftgjsQGJ",9) == 3045914530) strcat(s, "k");
if (crc32("qkKTxC",6) == 2966258463) strcat(s, "d");
if (crc32("TBbhbgANPyYUcfD",15) == 868411431) strcat(s, "i");
if (crc32("JbWkUH",6) == 1284275406) strcat(s, "Z");
if (crc32("IWgiAoS",7) == 1360483486) strcat(s, "o");
if (crc32("jDfhoevcUGUUj",13) == 2651454454) strcat(s, "u");
if (crc32("MNBQfypUY",9) == 1615518409) strcat(s, "s");
if (crc32("lzTRQkM",7) == 167082256) strcat(s, "O");
if (crc32("ohvjadsiWhY",11) == 949062139) strcat(s, "l");
if (crc32("ZAbkIbDlBQ",10) == 3630580939) strcat(s, "g");
if (crc32("JUvmCXhxExDaw",13) == 3683128787) strcat(s, "y");
    return s;
}

char *nonperpendicularly_adverbs() {
    char *s = calloc(19);
    if (crc32("RoZTVls",7) == 2386396127) strcat(s, "n");
if (crc32("qXpBSjz",7) == 1340193359) strcat(s, "O");
if (crc32("zacwodSow",9) == 3731100951) strcat(s, "o");
if (crc32("WQWOYobrmDv",11) == 2316120937) strcat(s, "n");
if (crc32("qhCEyZwvijoVHz",14) == 2847486798) strcat(s, "p");
if (crc32("pQWzm",5) == 3277966265) strcat(s, "e");
if (crc32("QniquCYxQEs",11) == 147545340) strcat(s, "r");
if (crc32("HxBTOPp",7) == 2177403534) strcat(s, "j");
if (crc32("ktXammzfQyWrsLN",15) == 3982611206) strcat(s, "p");
if (crc32("PdqTtJXExpOXwF",14) == 4014847769) strcat(s, "q");
if (crc32("kfGjpFHRQr",10) == 432595361) strcat(s, "e");
if (crc32("kUMqZOw",7) == 3822393623) strcat(s, "n");
if (crc32("UhcUpVaiKGN",11) == 1579601420) strcat(s, "d");
if (crc32("aPiTCFZLLUnnGSJ",15) == 2820604414) strcat(s, "i");
if (crc32("dEShQDXdxWdBvVB",15) == 1144207895) strcat(s, "c");
if (crc32("taWuVwAGiOfE",12) == 2962713737) strcat(s, "u");
if (crc32("BrvQaL",6) == 4040910531) strcat(s, "X");
if (crc32("rTAWulR",7) == 1557834935) strcat(s, "l");
if (crc32("lXHKGlF",7) == 907273354) strcat(s, "a");
if (crc32("UwlBavldZ",9) == 1463517272) strcat(s, "r");
if (crc32("GPZmduYAMcShRh",14) == 1118320162) strcat(s, "l");
if (crc32("lkxmmtjW",8) == 1205056792) strcat(s, "Y");
if (crc32("veTWTOEChgMwN",13) == 4029432176) strcat(s, "y");
    return s;
}

char *photosynthetically_adverbs() {
    char *s = calloc(19);
    if (crc32("ppCjJ",5) == 789098356) strcat(s, "p");
if (crc32("dstSwiBtV",9) == 3050300410) strcat(s, "t");
if (crc32("YVFJK",5) == 2194195516) strcat(s, "h");
if (crc32("sbvxvEbhAtmm",12) == 2481424719) strcat(s, "o");
if (crc32("lFkSLsiJeHbi",12) == 1675204945) strcat(s, "x");
if (crc32("tvkXeBZdkn",10) == 3209497407) strcat(s, "t");
if (crc32("uEJbRBbUXwQ",11) == 50073285) strcat(s, "p");
if (crc32("LqZteOgHMIdC",12) == 3710007926) strcat(s, "o");
if (crc32("oeMkCRGGFDxcEI",14) == 1554805217) strcat(s, "s");
if (crc32("COiMbdN",7) == 813383813) strcat(s, "y");
if (crc32("giWfPACWjP",10) == 3938625457) strcat(s, "n");
if (crc32("KDbfx",5) == 971166807) strcat(s, "j");
if (crc32("KFWFmQoRMv",10) == 297096709) strcat(s, "t");
if (crc32("ISmCEg",6) == 57548000) strcat(s, "h");
if (crc32("aKLYTepbNNZui",13) == 4047757056) strcat(s, "A");
if (crc32("NxTQpKPjhlERe",13) == 3786417851) strcat(s, "e");
if (crc32("RtboDJiEMAVCjE",14) == 1579131403) strcat(s, "U");
if (crc32("VaZdCYkVX",9) == 2336559782) strcat(s, "t");
if (crc32("dHjCYZTT",8) == 1035386772) strcat(s, "M");
if (crc32("FtmXVRHXrZPsDN",14) == 3361941503) strcat(s, "i");
if (crc32("IawtWO",6) == 2337172417) strcat(s, "c");
if (crc32("hhdoxRp",7) == 3290459248) strcat(s, "W");
if (crc32("ccRTUvOcR",9) == 4026712402) strcat(s, "a");
if (crc32("JUxWPJvpGYx",11) == 3835361983) strcat(s, "K");
if (crc32("zEavwuDWfMsDA",13) == 551180073) strcat(s, "l");
if (crc32("BTVdckzVTWyY",12) == 3254035119) strcat(s, "g");
if (crc32("eqNHstAU",8) == 855033468) strcat(s, "l");
if (crc32("iovdrotyFhwJ",12) == 988550112) strcat(s, "r");
if (crc32("kCjwZvcpxc",10) == 3503175610) strcat(s, "y");
    return s;
}

char *complimentarily_adverbs() {
    char *s = calloc(16);
    if (crc32("QgafYNxHWD",10) == 3782350225) strcat(s, "c");
if (crc32("vzKfAvHnteDJ",12) == 522175437) strcat(s, "d");
if (crc32("ZMlbH",5) == 3019788884) strcat(s, "o");
if (crc32("poPUWgNNLlRmQ",13) == 1006682814) strcat(s, "P");
if (crc32("ujmKX",5) == 2511968446) strcat(s, "m");
if (crc32("QEGLnsGaplMPq",13) == 2449371776) strcat(s, "p");
if (crc32("UCuwVYwcPWWHhh",14) == 792176543) strcat(s, "l");
if (crc32("FoAriGpVP",9) == 813259250) strcat(s, "n");
if (crc32("nWekYba",7) == 3834123618) strcat(s, "i");
if (crc32("YXpkmxy",7) == 1345915736) strcat(s, "m");
if (crc32("dFWQDjFPjNeOGrI",15) == 4164325517) strcat(s, "v");
if (crc32("BcAKwIFIiVLuh",13) == 1133305824) strcat(s, "e");
if (crc32("XHPzobmYEMAdgWb",15) == 3176390751) strcat(s, "n");
if (crc32("eGLXvRbPsmPxq",13) == 781373212) strcat(s, "C");
if (crc32("lmdip",5) == 4165501089) strcat(s, "t");
if (crc32("wHKMvB",6) == 445034545) strcat(s, "a");
if (crc32("OBlkaG",6) == 250862571) strcat(s, "G");
if (crc32("OailUxqxlWLE",12) == 3057199360) strcat(s, "r");
if (crc32("YzCVWTToPhPlyyO",15) == 2442601111) strcat(s, "L");
if (crc32("DfKsDtHoBN",10) == 609128485) strcat(s, "i");
if (crc32("QuAqhQbnKrKs",12) == 1221047262) strcat(s, "O");
if (crc32("uZqCZTsFjZV",11) == 2644845899) strcat(s, "l");
if (crc32("ChJlKPeQnSc",11) == 1386514850) strcat(s, "d");
if (crc32("qQsFhYdtm",9) == 3021319656) strcat(s, "y");
    return s;
}

char *synaptically_adverbs() {
    char *s = calloc(13);
    if (crc32("VcCQAkbevjKi",12) == 631132840) strcat(s, "s");
if (crc32("qrIDRWQnuGuZ",12) == 2666649372) strcat(s, "Q");
if (crc32("oyiKaBUKCMIYpa",14) == 1524541986) strcat(s, "y");
if (crc32("KrZgU",5) == 2023818543) strcat(s, "n");
if (crc32("QlDdQrnPi",9) == 2506830537) strcat(s, "T");
if (crc32("qOEQDClBro",10) == 1451587783) strcat(s, "a");
if (crc32("PWUfmvDONIv",11) == 3715606888) strcat(s, "p");
if (crc32("HeuMSLIdTCIm",12) == 1802024019) strcat(s, "t");
if (crc32("nEbMglTRhinr",12) == 1483988170) strcat(s, "i");
if (crc32("iKSds",5) == 3221412757) strcat(s, "A");
if (crc32("IWbxy",5) == 1081597718) strcat(s, "c");
if (crc32("LSSYeiJnk",9) == 2002062550) strcat(s, "a");
if (crc32("HeeFYEwicOQ",11) == 215776719) strcat(s, "l");
if (crc32("wjKcrzJicpmb",12) == 443298418) strcat(s, "G");
if (crc32("VfOpeUIt",8) == 160280194) strcat(s, "l");
if (crc32("RJVVQSZmSDEmWfk",15) == 4151692410) strcat(s, "s");
if (crc32("RwlrVjyQRUh",11) == 2389053400) strcat(s, "y");
    return s;
}

char *understandably_adverbs() {
    char *s = calloc(15);
    if (crc32("IscfMDmffM",10) == 1583410160) strcat(s, "u");
if (crc32("kSsgY",5) == 2680476468) strcat(s, "n");
if (crc32("YCFAcZEb",8) == 2150664279) strcat(s, "d");
if (crc32("OCZtYEN",7) == 1327136869) strcat(s, "e");
if (crc32("RhCUsCdRboQA",12) == 4204743661) strcat(s, "r");
if (crc32("HxCwIiwAaCPmxIr",15) == 973138685) strcat(s, "s");
if (crc32("mpKkzcIbuSlzI",13) == 2427906831) strcat(s, "f");
if (crc32("pwEsEgAk",8) == 3540652706) strcat(s, "t");
if (crc32("MeeWKEGz",8) == 548135117) strcat(s, "l");
if (crc32("RsaIMo",6) == 721287656) strcat(s, "a");
if (crc32("jkDnbTzvW",9) == 1391384384) strcat(s, "n");
if (crc32("paBkOsNgxMkZz",13) == 3468580427) strcat(s, "p");
if (crc32("voKoonvRm",9) == 4173125271) strcat(s, "d");
if (crc32("qmtnlyTDjaYfxs",14) == 3851550020) strcat(s, "a");
if (crc32("CoATmaBRlrxI",12) == 164464333) strcat(s, "b");
if (crc32("XqleGedlWcY",11) == 2238437836) strcat(s, "d");
if (crc32("iCnjkRHMnUsxCJo",15) == 3280319651) strcat(s, "l");
if (crc32("MgEHzUCgOgHGFMb",15) == 3153368290) strcat(s, "y");
    return s;
}

char *pleasingly_adverbs() {
    char *s = calloc(11);
    if (crc32("GCPCe",5) == 2845655763) strcat(s, "K");
if (crc32("wSTSkvigPha",11) == 2275319068) strcat(s, "p");
if (crc32("LNCfePbJqt",10) == 3547099186) strcat(s, "l");
if (crc32("VigeSuluJpn",11) == 3351139206) strcat(s, "e");
if (crc32("sVymNUd",7) == 1352859608) strcat(s, "a");
if (crc32("MRCkmosmOTu",11) == 1084736043) strcat(s, "s");
if (crc32("ygjKBpUotIb",11) == 387035254) strcat(s, "S");
if (crc32("quGQgYkDgI",10) == 2016799407) strcat(s, "i");
if (crc32("krMLxMt",7) == 22570282) strcat(s, "k");
if (crc32("QMyoXOzgEBGL",12) == 3808176386) strcat(s, "n");
if (crc32("FJSDDbxoRUzKa",13) == 1200542761) strcat(s, "g");
if (crc32("PwwVbclN",8) == 2365676598) strcat(s, "J");
if (crc32("MbuHFUBOgfOZkLb",15) == 694530085) strcat(s, "l");
if (crc32("leReVoCxunZtkmo",15) == 2055231006) strcat(s, "y");
    return s;
}

char *swayingly_adverbs() {
    char *s = calloc(10);
    if (crc32("TUwNqG",6) == 2220756882) strcat(s, "s");
if (crc32("ucnJMAiKuDwtZc",14) == 363614763) strcat(s, "w");
if (crc32("pLuKBLV",7) == 2908064747) strcat(s, "I");
if (crc32("WRyeJpWduFfXMqH",15) == 1081729117) strcat(s, "a");
if (crc32("LjxHwkpBvXM",11) == 1899630230) strcat(s, "S");
if (crc32("lHzhJGfByHBnQ",13) == 2408822406) strcat(s, "y");
if (crc32("zcBPaOGZhmko",12) == 3219572761) strcat(s, "i");
if (crc32("WFdaoFdTQSuifL",14) == 3574530340) strcat(s, "n");
if (crc32("qbovCCqNA",9) == 2675602062) strcat(s, "g");
if (crc32("pcTTaOtchFRCQYC",15) == 3453133125) strcat(s, "X");
if (crc32("duRLFjP",7) == 2852483967) strcat(s, "l");
if (crc32("gmHUmKczBCwM",12) == 314948602) strcat(s, "y");
    return s;
}

char *gradatim_adverbs() {
    char *s = calloc(9);
    if (crc32("RWCbmbQNjKOy",12) == 3088632211) strcat(s, "X");
if (crc32("dqCxoozxPaNe",12) == 2546963230) strcat(s, "g");
if (crc32("kwGTeBsjqmr",11) == 785752069) strcat(s, "v");
if (crc32("igjzaPx",7) == 3972252659) strcat(s, "r");
if (crc32("glBPN",5) == 1453985891) strcat(s, "g");
if (crc32("wAascYcjm",9) == 3114067707) strcat(s, "a");
if (crc32("bhpszQc",7) == 2569495722) strcat(s, "Z");
if (crc32("yGCvvHMNYzW",11) == 3943168100) strcat(s, "d");
if (crc32("hNjBMavbpM",10) == 2425671646) strcat(s, "a");
if (crc32("QSNvIeMLax",10) == 3784396648) strcat(s, "y");
if (crc32("pdzsAou",7) == 2614861865) strcat(s, "t");
if (crc32("Ysiflsjj",8) == 1003770622) strcat(s, "w");
if (crc32("SdYEM",5) == 3957043456) strcat(s, "i");
if (crc32("VMgcykGipMlX",12) == 3771609389) strcat(s, "m");
    return s;
}

char *anthropomorphically_adverbs() {
    char *s = calloc(20);
    if (crc32("ckCbsyOo",8) == 1351569263) strcat(s, "a");
if (crc32("ldgNrjnc",8) == 3138750637) strcat(s, "f");
if (crc32("oJtvnsPU",8) == 1179104231) strcat(s, "n");
if (crc32("OUVFijzX",8) == 1511535102) strcat(s, "t");
if (crc32("TbwMIBKXi",9) == 2672661002) strcat(s, "h");
if (crc32("vFwBvDucZFnSoU",14) == 889490372) strcat(s, "k");
if (crc32("BANXyoF",7) == 1165779856) strcat(s, "r");
if (crc32("bFFspZip",8) == 1500176810) strcat(s, "o");
if (crc32("RVvLt",5) == 827300358) strcat(s, "p");
if (crc32("PLYGRcllljJGpPI",15) == 3477084364) strcat(s, "o");
if (crc32("ugmENyapWjiwFr",14) == 1521279681) strcat(s, "r");
if (crc32("rJwUrzZs",8) == 2632978104) strcat(s, "m");
if (crc32("ErKiCf",6) == 3814579887) strcat(s, "s");
if (crc32("uRUlzaCQkmgTtn",14) == 2415418771) strcat(s, "o");
if (crc32("LPEUXLWnnr",10) == 704019565) strcat(s, "r");
if (crc32("MUvAQB",6) == 2110229505) strcat(s, "v");
if (crc32("cteZGTvf",8) == 3107535231) strcat(s, "p");
if (crc32("xppshAKRUkAphuk",15) == 511491228) strcat(s, "h");
if (crc32("RleuOD",6) == 4107594202) strcat(s, "i");
if (crc32("qZoom",5) == 885864244) strcat(s, "c");
if (crc32("PgaTAeQucXgTqJe",15) == 2608998360) strcat(s, "q");
if (crc32("lkjHPKxIxOLMW",13) == 3474152498) strcat(s, "a");
if (crc32("LTqEFkCfCT",10) == 2066821813) strcat(s, "l");
if (crc32("wOMUH",5) == 3973986174) strcat(s, "q");
if (crc32("WJltBJM",7) == 480726982) strcat(s, "l");
if (crc32("jHFNuCw",7) == 1341365234) strcat(s, "Z");
if (crc32("kNwGSykKqubq",12) == 376708734) strcat(s, "y");
    return s;
}

char *quasicontinuously_adverbs() {
    char *s = calloc(18);
    if (crc32("oAcEDBHY",8) == 3717792743) strcat(s, "q");
if (crc32("lXCULmLkIXJ",11) == 3163995793) strcat(s, "u");
if (crc32("gJXBzIH",7) == 3597762029) strcat(s, "C");
if (crc32("dlfBhLK",7) == 1103784059) strcat(s, "a");
if (crc32("oMqyglqFHArkdO",14) == 3779127640) strcat(s, "s");
if (crc32("sEyaQW",6) == 2783637430) strcat(s, "i");
if (crc32("fIYGudMnixMjmxY",15) == 2535504411) strcat(s, "c");
if (crc32("UbtlZuQs",8) == 1161767608) strcat(s, "s");
if (crc32("PhQnGDFih",9) == 1575870778) strcat(s, "o");
if (crc32("CUJQNv",6) == 2754190500) strcat(s, "H");
if (crc32("WfsOqcH",7) == 3142763989) strcat(s, "n");
if (crc32("QWUgXrCKyLeMXM",14) == 3898744658) strcat(s, "t");
if (crc32("jFyqEVOczyFXOYT",15) == 1779526947) strcat(s, "B");
if (crc32("PNaeHWhRCQYIPhR",15) == 1389633159) strcat(s, "i");
if (crc32("fSopF",5) == 1253080165) strcat(s, "I");
if (crc32("tpKINDaUT",9) == 2552748393) strcat(s, "n");
if (crc32("rAQRgWLUnTr",11) == 766695217) strcat(s, "D");
if (crc32("VudSLUNdrYtq",12) == 738211288) strcat(s, "u");
if (crc32("bihhPoYsFnTQdhA",15) == 2299833166) strcat(s, "o");
if (crc32("iOzfwRNrMi",10) == 548029503) strcat(s, "r");
if (crc32("RKHzgog",7) == 1553190921) strcat(s, "u");
if (crc32("aInNkMrCqsVZMD",14) == 3880249432) strcat(s, "s");
if (crc32("sAYOzP",6) == 489357579) strcat(s, "r");
if (crc32("VGBxMSEuQf",10) == 1824042254) strcat(s, "l");
if (crc32("UTwXvFYwZC",10) == 1733612133) strcat(s, "y");
    return s;
}

char *anticryptically_adverbs() {
    char *s = calloc(16);
    if (crc32("PlxEuBM",7) == 867693428) strcat(s, "K");
if (crc32("fxeIkQoFinxUpOA",15) == 2723601314) strcat(s, "a");
if (crc32("mWGglwmoaPhZSZ",14) == 4233010288) strcat(s, "E");
if (crc32("NJkqFm",6) == 3135704404) strcat(s, "n");
if (crc32("unfPyFXJyfH",11) == 490235632) strcat(s, "t");
if (crc32("nFjnrOEaYiKnC",13) == 3996062095) strcat(s, "m");
if (crc32("YKDhaYHnUn",10) == 1749455944) strcat(s, "i");
if (crc32("OopHkRxFziL",11) == 1479679450) strcat(s, "W");
if (crc32("htvGEpqujg",10) == 207359055) strcat(s, "c");
if (crc32("MTsCgZuwVwtp",12) == 48644241) strcat(s, "S");
if (crc32("nvtfHkkWmNQlg",13) == 3211580601) strcat(s, "r");
if (crc32("sjxMC",5) == 3693830895) strcat(s, "y");
if (crc32("JRSgvcYCRWjb",12) == 999876017) strcat(s, "p");
if (crc32("UifgSqBLF",9) == 4037157594) strcat(s, "t");
if (crc32("dTSKa",5) == 2839406988) strcat(s, "i");
if (crc32("WwJPcfttDv",10) == 3050060447) strcat(s, "c");
if (crc32("jWSbWdVO",8) == 3088390243) strcat(s, "a");
if (crc32("XoTxfXpe",8) == 2930233615) strcat(s, "l");
if (crc32("APbHkwDt",8) == 2405040354) strcat(s, "p");
if (crc32("veBzBG",6) == 2145858502) strcat(s, "l");
if (crc32("gMTRYidx",8) == 6556959) strcat(s, "n");
if (crc32("FPTIDiephwf",11) == 3527133993) strcat(s, "y");
    return s;
}

char *interferingly_adverbs() {
    char *s = calloc(14);
    if (crc32("AKhOxCY",7) == 1608126744) strcat(s, "g");
if (crc32("wrjRdxScKNlVW",13) == 3786679608) strcat(s, "i");
if (crc32("DloRLQNMcahwyE",14) == 3243340889) strcat(s, "O");
if (crc32("wSGTCbmnBzXK",12) == 1271359116) strcat(s, "n");
if (crc32("dCqWCXXBX",9) == 3485101125) strcat(s, "t");
if (crc32("zWOSuxTtPXQ",11) == 2746157253) strcat(s, "x");
if (crc32("kKFQmYaTbQ",10) == 3741051953) strcat(s, "e");
if (crc32("zPDMVXEyPQ",10) == 6379333) strcat(s, "O");
if (crc32("tjIpKvDyG",9) == 3497894631) strcat(s, "r");
if (crc32("tegbYBnUttiF",12) == 329597353) strcat(s, "X");
if (crc32("mtOGsC",6) == 1419711001) strcat(s, "f");
if (crc32("OGjSTphR",8) == 194523367) strcat(s, "Y");
if (crc32("jFolFiPrZHEGPo",14) == 2763771287) strcat(s, "e");
if (crc32("dsrYjjp",7) == 3496183687) strcat(s, "r");
if (crc32("zkWWSzqgsCd",11) == 1297079151) strcat(s, "k");
if (crc32("lEBJsz",6) == 2788528908) strcat(s, "i");
if (crc32("ZHOWFmazMKtCsKf",15) == 1518711744) strcat(s, "S");
if (crc32("ljGrSXUFEFTge",13) == 1675263013) strcat(s, "n");
if (crc32("CUiQSeyzEBx",11) == 1121481614) strcat(s, "g");
if (crc32("CivnuRZ",7) == 1028055879) strcat(s, "P");
if (crc32("eEEBwYAIkMoAryX",15) == 3157014426) strcat(s, "l");
if (crc32("HeTTFxv",7) == 1597926853) strcat(s, "t");
if (crc32("shKZjAldn",9) == 3712801454) strcat(s, "y");
    return s;
}

char *allegorically_adverbs() {
    char *s = calloc(14);
    if (crc32("WWYEqiR",7) == 2536888300) strcat(s, "a");
if (crc32("fGgCPTNL",8) == 1233176103) strcat(s, "l");
if (crc32("VNPbIyaORIvbZO",14) == 1524791110) strcat(s, "l");
if (crc32("TqENfwBDYF",10) == 2877695345) strcat(s, "s");
if (crc32("LlBPTxXgoRiQt",13) == 2923652474) strcat(s, "e");
if (crc32("ZwNtkf",6) == 2418224707) strcat(s, "F");
if (crc32("bOfSSKqpjl",10) == 3394713613) strcat(s, "g");
if (crc32("xPoDRUXQ",8) == 149840561) strcat(s, "o");
if (crc32("YuRXBYSsbqj",11) == 3365454784) strcat(s, "R");
if (crc32("tUpSmSIr",8) == 1883399586) strcat(s, "r");
if (crc32("ZQXkLgByjFHVmiK",15) == 2014201835) strcat(s, "m");
if (crc32("DNBYshb",7) == 3563297243) strcat(s, "i");
if (crc32("aAYaZQthw",9) == 2755256764) strcat(s, "R");
if (crc32("QyAGrVNiQdwsR",13) == 503736918) strcat(s, "c");
if (crc32("FfIDVFN",7) == 2063159358) strcat(s, "a");
if (crc32("HuzPbdBmMtS",11) == 2189896527) strcat(s, "l");
if (crc32("sIydIDzCVUi",11) == 2185439033) strcat(s, "l");
if (crc32("AiFxKsewwBjTrPn",15) == 669955892) strcat(s, "R");
if (crc32("oWwabUKpfGLn",12) == 3442209485) strcat(s, "y");
    return s;
}

char *overlogically_adverbs() {
    char *s = calloc(14);
    if (crc32("kjLaICbYSVuq",12) == 2822584706) strcat(s, "o");
if (crc32("GvboqIj",7) == 2565064512) strcat(s, "v");
if (crc32("BCKORAN",7) == 1012796114) strcat(s, "e");
if (crc32("TGuycSIaRDwuXU",14) == 1576827835) strcat(s, "r");
if (crc32("RMkvjZBwDk",10) == 2257953867) strcat(s, "l");
if (crc32("mWhKLOMnNPvO",12) == 2001886790) strcat(s, "H");
if (crc32("KhwtZmepo",9) == 125658952) strcat(s, "o");
if (crc32("cfLQNXmqJWS",11) == 3812558297) strcat(s, "g");
if (crc32("itJFbLkuuj",10) == 1706856230) strcat(s, "i");
if (crc32("JlIMPykwXI",10) == 1499474660) strcat(s, "Q");
if (crc32("jdWby",5) == 3053781037) strcat(s, "c");
if (crc32("naRwNgm",7) == 1389195512) strcat(s, "a");
if (crc32("rbxCsAUVS",9) == 368512309) strcat(s, "l");
if (crc32("PBiBbmvzAPWF",12) == 670800633) strcat(s, "l");
if (crc32("FGxlxUCKaodWqgT",15) == 2747209304) strcat(s, "y");
    return s;
}

char *quasigenteelly_adverbs() {
    char *s = calloc(15);
    if (crc32("UYQjnMMfuBnVGOB",15) == 185884374) strcat(s, "q");
if (crc32("ZqcxIguDeKPR",12) == 573105733) strcat(s, "u");
if (crc32("sSTyKb",6) == 3971561031) strcat(s, "a");
if (crc32("zNicaCxtWG",10) == 2388984751) strcat(s, "K");
if (crc32("hUCTahfAFdzS",12) == 3479489296) strcat(s, "s");
if (crc32("bPoFUCarIPehm",13) == 3070331957) strcat(s, "i");
if (crc32("XIaJk",5) == 2511967294) strcat(s, "j");
if (crc32("gkxNIAJL",8) == 3568786724) strcat(s, "g");
if (crc32("DmNlN",5) == 182293055) strcat(s, "C");
if (crc32("gxqLMLPCLEsoJDF",15) == 3194295177) strcat(s, "e");
if (crc32("icbqSKYrcTlnrU",14) == 4066957862) strcat(s, "b");
if (crc32("kyfaRE",6) == 4266680197) strcat(s, "n");
if (crc32("WHsvuCQqFNkJbgN",15) == 3511632542) strcat(s, "v");
if (crc32("LBMUDJMLmZ",10) == 2575623203) strcat(s, "t");
if (crc32("DIMTehuIdzCL",12) == 3322767192) strcat(s, "e");
if (crc32("ypohE",5) == 2982546834) strcat(s, "e");
if (crc32("etbDeuNLkhNRoW",14) == 2518768374) strcat(s, "Y");
if (crc32("LMlynJzrxF",10) == 3178663515) strcat(s, "l");
if (crc32("TkgSs",5) == 481466233) strcat(s, "h");
if (crc32("KuUXbIXOLZPazqz",15) == 2588396866) strcat(s, "l");
if (crc32("hTdpQV",6) == 1508627791) strcat(s, "y");
    return s;
}

char *churchward_adverbs() {
    char *s = calloc(11);
    if (crc32("nlwFHRpGI",9) == 3899416767) strcat(s, "c");
if (crc32("wFWSplUOPak",11) == 4081897437) strcat(s, "U");
if (crc32("ooDXJvlbFhFTZRb",15) == 2717672679) strcat(s, "h");
if (crc32("GvosyM",6) == 376389846) strcat(s, "u");
if (crc32("lMSBY",5) == 1302116751) strcat(s, "r");
if (crc32("PvqFhp",6) == 2439715363) strcat(s, "c");
if (crc32("mFFfLwqgC",9) == 945053487) strcat(s, "i");
if (crc32("GziUoX",6) == 3144784229) strcat(s, "h");
if (crc32("mXxWXkKcAGuWRz",14) == 2575777945) strcat(s, "H");
if (crc32("HyKGdK",6) == 2136267230) strcat(s, "w");
if (crc32("AffMOWBF",8) == 1402137236) strcat(s, "D");
if (crc32("wKkLeL",6) == 2055299965) strcat(s, "a");
if (crc32("ZhQMfGf",7) == 3670046265) strcat(s, "s");
if (crc32("cXJLunAaydsRWjg",15) == 2807972696) strcat(s, "r");
if (crc32("ffrpfqtPJ",9) == 2631347538) strcat(s, "d");
if (crc32("rSskO",5) == 2857753754) strcat(s, "d");
    return s;
}

char *dilatably_adverbs() {
    char *s = calloc(10);
    if (crc32("vcxQQRq",7) == 3830890153) strcat(s, "d");
if (crc32("MRlPfRCHvbfCAu",14) == 79014341) strcat(s, "Q");
if (crc32("ZhiNlOfsppyR",12) == 1839335623) strcat(s, "i");
if (crc32("MKWqrTnd",8) == 1605228021) strcat(s, "l");
if (crc32("HTBEcoSa",8) == 2998072806) strcat(s, "N");
if (crc32("WGKSzarTgkU",11) == 1566031391) strcat(s, "a");
if (crc32("WHOccpewT",9) == 1597133700) strcat(s, "i");
if (crc32("vdVWbHsQVoQVe",13) == 253538264) strcat(s, "t");
if (crc32("GNvmULU",7) == 3153497101) strcat(s, "a");
if (crc32("uiVKARR",7) == 2335273934) strcat(s, "b");
if (crc32("SYven",5) == 2791771875) strcat(s, "V");
if (crc32("EJNhGdgeE",9) == 938548357) strcat(s, "l");
if (crc32("wPvPfOlHS",9) == 2286608570) strcat(s, "D");
if (crc32("HzvReMGnIQTtPn",14) == 43379158) strcat(s, "y");
    return s;
}

char *accordantly_adverbs() {
    char *s = calloc(12);
    if (crc32("LPTihwAbTRYxdp",14) == 104116812) strcat(s, "z");
if (crc32("nFmyGLQ",7) == 3708069747) strcat(s, "a");
if (crc32("oSCwU",5) == 3827601419) strcat(s, "l");
if (crc32("ahUQoogzczbfWBe",15) == 3179787916) strcat(s, "c");
if (crc32("hKepvLNftwwm",12) == 1269144562) strcat(s, "c");
if (crc32("jqnbK",5) == 850339871) strcat(s, "o");
if (crc32("VXizYIY",7) == 4252357774) strcat(s, "r");
if (crc32("LxyTJLiqFUr",11) == 3178481464) strcat(s, "Z");
if (crc32("qgvTEPoRHkLjwa",14) == 2729141130) strcat(s, "d");
if (crc32("ruxfwjtjRnhtkl",14) == 895587196) strcat(s, "a");
if (crc32("xTSEhnneksBAss",14) == 341146076) strcat(s, "P");
if (crc32("mDzIHyiXFEnVYP",14) == 15419006) strcat(s, "n");
if (crc32("ztivEqqSQ",9) == 4086454327) strcat(s, "t");
if (crc32("yBsOrGOsdHhIz",13) == 1087676021) strcat(s, "s");
if (crc32("EqepqLvicx",10) == 1283696729) strcat(s, "l");
if (crc32("APQrSFKxlbgCmcQ",15) == 1997903734) strcat(s, "y");
    return s;
}

char *puritanically_adverbs() {
    char *s = calloc(14);
    if (crc32("hhoDupfb",8) == 1231244059) strcat(s, "F");
if (crc32("epDkHRyWJw",10) == 443166726) strcat(s, "p");
if (crc32("kJxYN",5) == 2090252922) strcat(s, "u");
if (crc32("qDhsKHoUTAWfNg",14) == 2355460411) strcat(s, "J");
if (crc32("KrePWoGTcVoFRg",14) == 2486695337) strcat(s, "r");
if (crc32("vAbJOa",6) == 2824604444) strcat(s, "i");
if (crc32("gnPUhzTTkL",10) == 3785870472) strcat(s, "t");
if (crc32("tFatSwygg",9) == 474888879) strcat(s, "U");
if (crc32("FCQPRxT",7) == 433951467) strcat(s, "a");
if (crc32("qCORhLPQ",8) == 3978531567) strcat(s, "n");
if (crc32("FnjYsjLaInoR",12) == 2895752650) strcat(s, "i");
if (crc32("jUuMouV",7) == 627986337) strcat(s, "c");
if (crc32("QXwdvtffAr",10) == 1911377883) strcat(s, "a");
if (crc32("MWQrBtEEAJ",10) == 1728778642) strcat(s, "O");
if (crc32("CHqiQobkrGy",11) == 863847063) strcat(s, "l");
if (crc32("IcXphCfsbA",10) == 1803446398) strcat(s, "l");
if (crc32("JCmqxfYKAGooQm",14) == 2468084249) strcat(s, "y");
    return s;
}

char *hereinbefore_adverbs() {
    char *s = calloc(13);
    if (crc32("SNevUWCzooTWE",13) == 2712018474) strcat(s, "n");
if (crc32("BqgjKSokIKICvly",15) == 43609104) strcat(s, "h");
if (crc32("FjUQfzgEcFsFwv",14) == 881249249) strcat(s, "p");
if (crc32("HiRYSeF",7) == 3630861791) strcat(s, "e");
if (crc32("yejgDIBnGNw",11) == 2127703216) strcat(s, "r");
if (crc32("VAjkHL",6) == 2557906004) strcat(s, "S");
if (crc32("lLaFN",5) == 896577495) strcat(s, "e");
if (crc32("KJABUCFsLktps",13) == 3146972167) strcat(s, "f");
if (crc32("qOgBAw",6) == 1509145744) strcat(s, "i");
if (crc32("egQDvrGr",8) == 3247156394) strcat(s, "n");
if (crc32("ZnMAImTNv",9) == 88769975) strcat(s, "b");
if (crc32("rICvkahAc",9) == 4045831989) strcat(s, "Q");
if (crc32("YvfEGWQoZJjMC",13) == 2058749098) strcat(s, "e");
if (crc32("jLIrFmUAtXqlyw",14) == 1490217037) strcat(s, "f");
if (crc32("DDJuRL",6) == 3641456607) strcat(s, "o");
if (crc32("efxYf",5) == 485997671) strcat(s, "r");
if (crc32("ZdnrbtrdxFs",11) == 3229137703) strcat(s, "F");
if (crc32("mGQYHUHIHPLPTr",14) == 381044900) strcat(s, "e");
    return s;
}

char *frothily_adverbs() {
    char *s = calloc(9);
    if (crc32("dmxBfvnqNZn",11) == 2443975586) strcat(s, "L");
if (crc32("lUvXyw",6) == 576751697) strcat(s, "f");
if (crc32("FWQiPPm",7) == 224761729) strcat(s, "r");
if (crc32("PYgOaSYhfqc",11) == 1544060415) strcat(s, "o");
if (crc32("ztWgggplNOXAHFX",15) == 2784317990) strcat(s, "e");
if (crc32("XdqWUGOacQ",10) == 2684392754) strcat(s, "t");
if (crc32("BLHwTfRgIk",10) == 1716731053) strcat(s, "m");
if (crc32("izloseZayxt",11) == 2378681072) strcat(s, "h");
if (crc32("aguEolaEsNiENi",14) == 1994269827) strcat(s, "Z");
if (crc32("sagsdYx",7) == 2879721975) strcat(s, "i");
if (crc32("XNAZxrhFUZ",10) == 2669609395) strcat(s, "l");
if (crc32("TmgqaqHrHKJ",11) == 1611066747) strcat(s, "y");
    return s;
}

char *superimportantly_adverbs() {
    char *s = calloc(17);
    if (crc32("PNkDFCTsfYn",11) == 925002330) strcat(s, "t");
if (crc32("JOpjipMLUxohrD",14) == 2118363743) strcat(s, "s");
if (crc32("sCDgEIf",7) == 832119603) strcat(s, "u");
if (crc32("ILBNdvSnx",9) == 3849353247) strcat(s, "p");
if (crc32("DuRmRWbpcsFs",12) == 784829939) strcat(s, "X");
if (crc32("asTLEcaqKXHOx",13) == 2463506265) strcat(s, "e");
if (crc32("vazDJFeGQJ",10) == 3957655664) strcat(s, "r");
if (crc32("rXUWjkRT",8) == 255440735) strcat(s, "N");
if (crc32("hkJDbFXqk",9) == 736576785) strcat(s, "i");
if (crc32("dydZXJTDjmM",11) == 3202190120) strcat(s, "m");
if (crc32("GddKSrty",8) == 944029718) strcat(s, "x");
if (crc32("DoGjjvNMC",9) == 162497149) strcat(s, "p");
if (crc32("TZxNwoymUlAi",12) == 2621931098) strcat(s, "e");
if (crc32("YqwoE",5) == 2513379836) strcat(s, "o");
if (crc32("xbqYEvb",7) == 3655923483) strcat(s, "r");
if (crc32("ePtwPPxfpnFlBK",14) == 2371625498) strcat(s, "t");
if (crc32("mEorHbwJ",8) == 2714441438) strcat(s, "a");
if (crc32("xuIAflJaHyTvQl",14) == 4033857737) strcat(s, "e");
if (crc32("NfxhxtbIq",9) == 3186114577) strcat(s, "n");
if (crc32("kplbK",5) == 3036132004) strcat(s, "t");
if (crc32("eLGywKmIRmV",11) == 836969337) strcat(s, "l");
if (crc32("pIHmpkfoVNRofN",14) == 1936256599) strcat(s, "u");
if (crc32("jXuSXfmyWnMz",12) == 4025170629) strcat(s, "y");
    return s;
}

char *semiovally_adverbs() {
    char *s = calloc(11);
    if (crc32("vQcUn",5) == 3830848130) strcat(s, "s");
if (crc32("DWxjxSOGQVzy",12) == 2872732639) strcat(s, "e");
if (crc32("JZwvLjyQyum",11) == 2557987532) strcat(s, "m");
if (crc32("qTOXz",5) == 4287308564) strcat(s, "i");
if (crc32("QNkJJvN",7) == 577617322) strcat(s, "C");
if (crc32("cGKkv",5) == 1574149696) strcat(s, "o");
if (crc32("zKjhgqzs",8) == 4052557605) strcat(s, "v");
if (crc32("eJhMqHnaiXW",11) == 2074801796) strcat(s, "A");
if (crc32("uukPzmlvibSorL",14) == 1227889980) strcat(s, "a");
if (crc32("nMKmrJlMYFhKt",13) == 2488807012) strcat(s, "l");
if (crc32("pMaIvd",6) == 3987729510) strcat(s, "N");
if (crc32("BaGTeJPNiBI",11) == 247817199) strcat(s, "l");
if (crc32("MMinHqawens",11) == 847118939) strcat(s, "o");
if (crc32("BguVp",5) == 2889749211) strcat(s, "y");
    return s;
}

char *diminishingly_adverbs() {
    char *s = calloc(14);
    if (crc32("ZHfDFhbEJTs",11) == 2118581247) strcat(s, "T");
if (crc32("KLsVTJ",6) == 272335850) strcat(s, "d");
if (crc32("QhePUyKseMQ",11) == 1335584115) strcat(s, "i");
if (crc32("nkaIweYtNERNWw",14) == 4214601344) strcat(s, "g");
if (crc32("PjLadal",7) == 2121477042) strcat(s, "m");
if (crc32("sgqzikn",7) == 3513526644) strcat(s, "B");
if (crc32("iKWxpS",6) == 1618993442) strcat(s, "i");
if (crc32("vDQXw",5) == 4288685142) strcat(s, "D");
if (crc32("VtgTCCMine",10) == 2302316876) strcat(s, "n");
if (crc32("uknzHqz",7) == 2616351314) strcat(s, "i");
if (crc32("bXSFQ",5) == 4292668789) strcat(s, "s");
if (crc32("bLcklmNAQNYlFk",14) == 3894449162) strcat(s, "y");
if (crc32("kxIfh",5) == 2312022582) strcat(s, "h");
if (crc32("PlKHwq",6) == 2490277575) strcat(s, "i");
if (crc32("ePIuRCorV",9) == 945784715) strcat(s, "n");
if (crc32("rnIiGKEupTMS",12) == 4109030476) strcat(s, "P");
if (crc32("vARFNYt",7) == 1818856222) strcat(s, "g");
if (crc32("rXnLaMQdL",9) == 3274036131) strcat(s, "l");
if (crc32("xbpJRqN",7) == 3313164022) strcat(s, "E");
if (crc32("rXtLDFVpjAdRVV",14) == 1321002481) strcat(s, "y");
    return s;
}

char *protractedly_adverbs() {
    char *s = calloc(13);
    if (crc32("vlBbfcvJmODjFmz",15) == 212025968) strcat(s, "p");
if (crc32("PkMtfbvOYAmosU",14) == 1715732017) strcat(s, "z");
if (crc32("WoTfhxVxD",9) == 157891439) strcat(s, "r");
if (crc32("JCwxteLgAAZuCb",14) == 3020031372) strcat(s, "T");
if (crc32("QLObbnPAPtVY",12) == 1535417335) strcat(s, "o");
if (crc32("qxphyaYrlDXRXAj",15) == 2491731992) strcat(s, "E");
if (crc32("VVecpzPdVdtOzNx",15) == 2765366666) strcat(s, "t");
if (crc32("bsKgnebGRfUN",12) == 3403156908) strcat(s, "F");
if (crc32("tsJXbhhlnuYQ",12) == 393159642) strcat(s, "r");
if (crc32("biZkDpUrDt",10) == 3397670796) strcat(s, "k");
if (crc32("OkNphoIn",8) == 3859183366) strcat(s, "a");
if (crc32("IzciweqbegIua",13) == 4239016815) strcat(s, "c");
if (crc32("ZdrFMiymW",9) == 4100804670) strcat(s, "w");
if (crc32("STGxntZYqTpc",12) == 3383252282) strcat(s, "t");
if (crc32("rZwHLcBQUby",11) == 1164515050) strcat(s, "e");
if (crc32("OLpFNHih",8) == 3384249644) strcat(s, "j");
if (crc32("tnVGziiSX",9) == 2584982974) strcat(s, "d");
if (crc32("MZNMFsHjLG",10) == 1687831018) strcat(s, "C");
if (crc32("Odpuj",5) == 52114804) strcat(s, "l");
if (crc32("BxfUzAAvAWb",11) == 1308293983) strcat(s, "t");
if (crc32("VlCxKuwmjbvguJ",14) == 2225966167) strcat(s, "y");
    return s;
}

char *blushingly_adverbs() {
    char *s = calloc(11);
    if (crc32("yCsbwcYKBW",10) == 1544922547) strcat(s, "J");
if (crc32("TNprFwjByGJH",12) == 3029918618) strcat(s, "b");
if (crc32("hBdHNvcKJvXylCf",15) == 1912220141) strcat(s, "l");
if (crc32("UChqzJbiCDp",11) == 1701395700) strcat(s, "u");
if (crc32("AnEUnlbbfALlZXD",15) == 1822721293) strcat(s, "s");
if (crc32("HENVWUKkjs",10) == 956384666) strcat(s, "h");
if (crc32("QyLslYqsBFM",11) == 3312275097) strcat(s, "i");
if (crc32("vvepyisUDN",10) == 3663626353) strcat(s, "T");
if (crc32("PlRsQSBcAiNuP",13) == 2514749261) strcat(s, "n");
if (crc32("EeUvdapHpK",10) == 4079220337) strcat(s, "g");
if (crc32("yqyVPoTehB",10) == 3581804482) strcat(s, "l");
if (crc32("eUUwjbRKuupaaA",14) == 1848919944) strcat(s, "y");
    return s;
}

char *absolutely_adverbs() {
    char *s = calloc(11);
    if (crc32("SyEDWXswMMFoeFx",15) == 640451904) strcat(s, "P");
if (crc32("krPBKQQR",8) == 3125241390) strcat(s, "a");
if (crc32("hFqMwwhwrAC",11) == 1995707641) strcat(s, "b");
if (crc32("DCjKjFplnzR",11) == 2839062403) strcat(s, "s");
if (crc32("pSfRLqVmX",9) == 1197841335) strcat(s, "a");
if (crc32("lumzTx",6) == 4024803899) strcat(s, "o");
if (crc32("HSFLhUAefS",10) == 2215583154) strcat(s, "k");
if (crc32("WpmzXgpPHt",10) == 3902002014) strcat(s, "l");
if (crc32("ylIEwqUXLOJE",12) == 2035714306) strcat(s, "j");
if (crc32("cUMFXJTaz",9) == 968216926) strcat(s, "u");
if (crc32("OVEijmgJnsr",11) == 2111543094) strcat(s, "t");
if (crc32("dWbxtOu",7) == 2573167912) strcat(s, "j");
if (crc32("EEmVUt",6) == 1335725229) strcat(s, "e");
if (crc32("lgadeq",6) == 2408055966) strcat(s, "h");
if (crc32("qiWQoMDYqSQhBfU",15) == 2566629677) strcat(s, "l");
if (crc32("gLSyAAfx",8) == 4238743432) strcat(s, "j");
if (crc32("DKgaBXfL",8) == 539327942) strcat(s, "y");
    return s;
}

char *upstairs_adverbs() {
    char *s = calloc(9);
    if (crc32("JFUFZ",5) == 2897623040) strcat(s, "p");
if (crc32("SLtIPltB",8) == 2704400390) strcat(s, "u");
if (crc32("EbyBgRc",7) == 3725562054) strcat(s, "S");
if (crc32("FsgSEUgo",8) == 203329969) strcat(s, "p");
if (crc32("wDqkgiAieEDP",12) == 2988408339) strcat(s, "K");
if (crc32("XBNFFwk",7) == 1483969683) strcat(s, "s");
if (crc32("EfBwNPlqMCjn",12) == 4010106952) strcat(s, "t");
if (crc32("yuGZTnaBeabfmZw",15) == 3241433253) strcat(s, "N");
if (crc32("ANXapEjaHaMEL",13) == 1458229987) strcat(s, "a");
if (crc32("tFhmaDqJMit",11) == 143357177) strcat(s, "i");
if (crc32("dRqLbL",6) == 2898270209) strcat(s, "i");
if (crc32("lbNrN",5) == 4255548912) strcat(s, "r");
if (crc32("WbLicBevoIpSr",13) == 1162222524) strcat(s, "C");
if (crc32("qUwAMVNMd",9) == 3403018675) strcat(s, "s");
    return s;
}

char *overponderously_adverbs() {
    char *s = calloc(16);
    if (crc32("cwxElLvmaRqS",12) == 2134629379) strcat(s, "g");
if (crc32("RrKWnLUTFqkKcY",14) == 837448622) strcat(s, "o");
if (crc32("ZmZmTisjxK",10) == 4144541584) strcat(s, "v");
if (crc32("FEYVM",5) == 3460479799) strcat(s, "D");
if (crc32("SJBxmVf",7) == 2769674440) strcat(s, "e");
if (crc32("QigspjdDOEoLpB",14) == 3238520413) strcat(s, "r");
if (crc32("MdGpyoFxZ",9) == 3997063989) strcat(s, "A");
if (crc32("IPBjAurFhEy",11) == 2821994893) strcat(s, "p");
if (crc32("oiuFulHEUOFDXrE",15) == 2788811847) strcat(s, "O");
if (crc32("NHXkoamlOuZq",12) == 2151737028) strcat(s, "o");
if (crc32("jBwSdQRtcAp",11) == 3784020017) strcat(s, "n");
if (crc32("rtNSEzlaWBtrLp",14) == 382841966) strcat(s, "i");
if (crc32("HAwiHZTWb",9) == 2441115184) strcat(s, "d");
if (crc32("NeifoyjPDFoKVik",15) == 3681227042) strcat(s, "e");
if (crc32("mLesJpCbNX",10) == 605546969) strcat(s, "r");
if (crc32("OjZlwu",6) == 1287724124) strcat(s, "Y");
if (crc32("dhPFhiWmmqEoBM",14) == 3228941476) strcat(s, "o");
if (crc32("YzVpPbQgoFNTZG",14) == 2142669847) strcat(s, "u");
if (crc32("GXcbYFwFMmpDzRX",15) == 1748750719) strcat(s, "f");
if (crc32("msGYanGaCM",10) == 3807218333) strcat(s, "s");
if (crc32("gLXLImcrnYIkma",14) == 3055227088) strcat(s, "B");
if (crc32("WzbFi",5) == 2441972239) strcat(s, "l");
if (crc32("fMPOUVmDBaZg",12) == 3054084695) strcat(s, "y");
    return s;
}

char *superglottally_adverbs() {
    char *s = calloc(15);
    if (crc32("UUfSngak",8) == 318409074) strcat(s, "s");
if (crc32("gPqUGrcEHGDL",12) == 4164532293) strcat(s, "s");
if (crc32("BJnfEfvykXdi",12) == 1760084967) strcat(s, "u");
if (crc32("yJheoSCNmiwN",12) == 683425550) strcat(s, "p");
if (crc32("DVLTZR",6) == 1749882543) strcat(s, "y");
if (crc32("JdUmvXWbdvIyRaA",15) == 2264185717) strcat(s, "e");
if (crc32("QHVHl",5) == 2305088456) strcat(s, "r");
if (crc32("LroBDmxSRX",10) == 3139548992) strcat(s, "g");
if (crc32("FtrpPxYZi",9) == 2457928495) strcat(s, "l");
if (crc32("zXumlNo",7) == 1072543462) strcat(s, "o");
if (crc32("RLvHzdOnucJ",11) == 355572625) strcat(s, "h");
if (crc32("NZhDVIqGRk",10) == 1279292545) strcat(s, "t");
if (crc32("BrYUmS",6) == 2382561468) strcat(s, "t");
if (crc32("ydmHZEOn",8) == 3337728344) strcat(s, "B");
if (crc32("lOYWnlERT",9) == 3456976627) strcat(s, "a");
if (crc32("LsauZcY",7) == 3591304325) strcat(s, "G");
if (crc32("UjKVb",5) == 1373124678) strcat(s, "l");
if (crc32("SxjMhwCWYboLuU",14) == 802244800) strcat(s, "U");
if (crc32("twcreTn",7) == 3054087793) strcat(s, "l");
if (crc32("IJfyWhaj",8) == 1517834728) strcat(s, "R");
if (crc32("fNbxrbyO",8) == 2046268617) strcat(s, "y");
    return s;
}

char *atomically_adverbs() {
    char *s = calloc(11);
    if (crc32("arGSwzuasVTLoQ",14) == 3498190385) strcat(s, "H");
if (crc32("ZEFDBEKQMs",10) == 4181480596) strcat(s, "a");
if (crc32("BlpGFCcdBvioL",13) == 3537403954) strcat(s, "O");
if (crc32("YdiRskkf",8) == 575324409) strcat(s, "t");
if (crc32("yqBwHYAMrOJsY",13) == 210194490) strcat(s, "K");
if (crc32("ieGQWKlLO",9) == 4126719872) strcat(s, "o");
if (crc32("eBDtNUBvlbcJiEP",15) == 2683265289) strcat(s, "m");
if (crc32("McFKwEFg",8) == 1854543218) strcat(s, "i");
if (crc32("rwBpm",5) == 1891767693) strcat(s, "U");
if (crc32("YoqPHYvqrQkRUA",14) == 3273242949) strcat(s, "c");
if (crc32("fiyyu",5) == 332192170) strcat(s, "a");
if (crc32("DHHVyhelecOXktI",15) == 2226554781) strcat(s, "l");
if (crc32("lRVYnOav",8) == 3695644785) strcat(s, "l");
if (crc32("xLtiyLoCmfRyEZ",14) == 4080100437) strcat(s, "y");
    return s;
}

char *nonpacifically_adverbs() {
    char *s = calloc(15);
    if (crc32("QtWQrtWnrotG",12) == 1285301764) strcat(s, "n");
if (crc32("eNvBxRT",7) == 904591026) strcat(s, "Q");
if (crc32("xAmeslUdPeDVEW",14) == 1675886796) strcat(s, "o");
if (crc32("BpMmrizQD",9) == 2270874183) strcat(s, "K");
if (crc32("rusqtdgCKm",10) == 3412074487) strcat(s, "n");
if (crc32("EXLrf",5) == 2563812564) strcat(s, "p");
if (crc32("EUyMoDdqE",9) == 2017054129) strcat(s, "G");
if (crc32("lfpemkhIbpqRo",13) == 2908960761) strcat(s, "a");
if (crc32("wauWadctwsVjr",13) == 3933760040) strcat(s, "E");
if (crc32("qWtax",5) == 629828125) strcat(s, "c");
if (crc32("vpNxxkDXceOFr",13) == 2003348920) strcat(s, "i");
if (crc32("TLDmRaPp",8) == 2198664) strcat(s, "f");
if (crc32("jOOqM",5) == 2472046589) strcat(s, "i");
if (crc32("bTwxIvfDS",9) == 1930935210) strcat(s, "Z");
if (crc32("yjpRCQHC",8) == 2208346464) strcat(s, "c");
if (crc32("uIWTNpbLWT",10) == 3209996687) strcat(s, "a");
if (crc32("uIKDlWOrjNDFDd",14) == 78267505) strcat(s, "a");
if (crc32("ZVZLjsczH",9) == 541922512) strcat(s, "l");
if (crc32("JvckrADicGN",11) == 2084280883) strcat(s, "l");
if (crc32("lqPtQauAIuy",11) == 967162860) strcat(s, "k");
if (crc32("SxdhRqOCwU",10) == 1493879048) strcat(s, "y");
    return s;
}

char *detractively_adverbs() {
    char *s = calloc(13);
    if (crc32("NpicDbuhKhQKW",13) == 3497143937) strcat(s, "t");
if (crc32("XiovBlJJOAhEZ",13) == 1369085852) strcat(s, "d");
if (crc32("sfPqTvJeSBwtLQ",14) == 137979019) strcat(s, "T");
if (crc32("PNPeJbQyqsinx",13) == 3216973533) strcat(s, "e");
if (crc32("ZdQIS",5) == 3636873407) strcat(s, "P");
if (crc32("fvArSdEmMHdKT",13) == 4242468290) strcat(s, "t");
if (crc32("MTBSJr",6) == 1029073891) strcat(s, "A");
if (crc32("ZflIJLwRrlhaIv",14) == 2623472884) strcat(s, "r");
if (crc32("nTyUfUKFVQDnu",13) == 1385028678) strcat(s, "b");
if (crc32("TfwUuZGxPBXno",13) == 3704713131) strcat(s, "a");
if (crc32("SLpNCgHeeyLZvfX",15) == 2170882394) strcat(s, "Y");
if (crc32("kqUkq",5) == 809462053) strcat(s, "c");
if (crc32("HEzdppAafPaNM",13) == 190966096) strcat(s, "t");
if (crc32("QOHANoJmA",9) == 3900579466) strcat(s, "i");
if (crc32("TuYhXPLUbUWk",12) == 2430270571) strcat(s, "v");
if (crc32("FWIRoBV",7) == 452263401) strcat(s, "B");
if (crc32("UWhnryEcpTl",11) == 990118690) strcat(s, "e");
if (crc32("aQhfOqpvJuB",11) == 3784238987) strcat(s, "E");
if (crc32("fLkyyFJVvvFhLgs",15) == 2741932657) strcat(s, "l");
if (crc32("oDWniKPi",8) == 2996947452) strcat(s, "P");
if (crc32("HMklmB",6) == 398574154) strcat(s, "y");
    return s;
}

char *bumpily_adverbs() {
    char *s = calloc(8);
    if (crc32("KuTfckPJNDcBCP",14) == 3705005915) strcat(s, "b");
if (crc32("XZXpDkhrQle",11) == 1107027553) strcat(s, "u");
if (crc32("aWsHx",5) == 73626865) strcat(s, "m");
if (crc32("YXxICI",6) == 2545198936) strcat(s, "p");
if (crc32("OTKYNkIQiuTJY",13) == 744182503) strcat(s, "i");
if (crc32("NqLwgL",6) == 1684147144) strcat(s, "g");
if (crc32("TpUeyoVDlePs",12) == 106816382) strcat(s, "l");
if (crc32("nROkH",5) == 3882619959) strcat(s, "x");
if (crc32("qGiwPcDROX",10) == 496633849) strcat(s, "y");
    return s;
}

char *scrapingly_adverbs() {
    char *s = calloc(11);
    if (crc32("WidIite",7) == 4022749541) strcat(s, "s");
if (crc32("shuEO",5) == 1498076250) strcat(s, "g");
if (crc32("PsGduJ",6) == 2388792590) strcat(s, "c");
if (crc32("eVRyhvKUvfw",11) == 495149985) strcat(s, "T");
if (crc32("nhwxMkOsf",9) == 676945088) strcat(s, "r");
if (crc32("azPtx",5) == 3745550071) strcat(s, "t");
if (crc32("DgwPvAFqGhaCpw",14) == 3994460884) strcat(s, "a");
if (crc32("xeawahgPYOOfsV",14) == 487072974) strcat(s, "u");
if (crc32("UVKcuNJ",7) == 2586813327) strcat(s, "p");
if (crc32("QBcHvJlRuyKdKjx",15) == 1131561894) strcat(s, "i");
if (crc32("sbvMuAF",7) == 221451971) strcat(s, "G");
if (crc32("kTcRgqSwROUFIp",14) == 3765007632) strcat(s, "n");
if (crc32("qWBVnRWzLWgPmu",14) == 3537413315) strcat(s, "g");
if (crc32("rXelHRPDe",9) == 1817628016) strcat(s, "P");
if (crc32("RLpdFHBft",9) == 626051594) strcat(s, "l");
if (crc32("QbWVXVKeLLulDw",14) == 2043390031) strcat(s, "y");
    return s;
}

char *convictively_adverbs() {
    char *s = calloc(13);
    if (crc32("IfOmIFL",7) == 666874018) strcat(s, "c");
if (crc32("uMvjWF",6) == 723468201) strcat(s, "o");
if (crc32("LhujOCVbSxpL",12) == 2426678358) strcat(s, "Z");
if (crc32("kwTcWOrSFBxKu",13) == 3706063550) strcat(s, "n");
if (crc32("EJbzoyVqRvaiJM",14) == 404621935) strcat(s, "r");
if (crc32("yNlcvINf",8) == 2560194211) strcat(s, "v");
if (crc32("EomkPYV",7) == 2058733501) strcat(s, "i");
if (crc32("SOPdePMfpYQwC",13) == 1288738874) strcat(s, "c");
if (crc32("LoMNWmhV",8) == 185774427) strcat(s, "t");
if (crc32("oEtmRntcsGgri",13) == 924422331) strcat(s, "i");
if (crc32("khyUq",5) == 1148567122) strcat(s, "E");
if (crc32("kOxTSV",6) == 3757204971) strcat(s, "v");
if (crc32("lDAXHpQbilK",11) == 1084947162) strcat(s, "Z");
if (crc32("BzIpFsnDbn",10) == 4029312117) strcat(s, "e");
if (crc32("earpZoRsZbVR",12) == 2779741813) strcat(s, "u");
if (crc32("DyEWDyfHOzcSs",13) == 3226653472) strcat(s, "l");
if (crc32("usevoMbQ",8) == 3843289379) strcat(s, "J");
if (crc32("cTKJkIYMeCKUc",13) == 2774867958) strcat(s, "y");
    return s;
}

char *reposedly_adverbs() {
    char *s = calloc(10);
    if (crc32("OirowCLEBoyPZ",13) == 2728993986) strcat(s, "r");
if (crc32("nNOQhpsry",9) == 2603931760) strcat(s, "r");
if (crc32("rKEbmwfOOTGmGfS",15) == 4051806852) strcat(s, "e");
if (crc32("HrBzNbmf",8) == 1363506685) strcat(s, "p");
if (crc32("ZBLCelaqn",9) == 2511562848) strcat(s, "o");
if (crc32("NUDYlys",7) == 1414307937) strcat(s, "z");
if (crc32("QPPOTjHXAqLH",12) == 1528320446) strcat(s, "s");
if (crc32("CZorFhE",7) == 706702132) strcat(s, "n");
if (crc32("hBurdjShBJ",10) == 3309618424) strcat(s, "e");
if (crc32("MZCGflet",8) == 1763685346) strcat(s, "p");
if (crc32("eBzBHozelPAhPh",14) == 1971291127) strcat(s, "d");
if (crc32("NoIbN",5) == 4215285149) strcat(s, "l");
if (crc32("MhVpJsmKbcSvH",13) == 4272753861) strcat(s, "y");
    return s;
}

char *goodnaturedly_adverbs() {
    char *s = calloc(14);
    if (crc32("xBwOzPpDCJNnzGM",15) == 3129197446) strcat(s, "M");
if (crc32("qyoIFLmIFbHOP",13) == 1164280315) strcat(s, "g");
if (crc32("wRsEHGGCMELP",12) == 3707545334) strcat(s, "o");
if (crc32("qYDxyjClqXtvX",13) == 3625151535) strcat(s, "o");
if (crc32("QieYqIF",7) == 1003866484) strcat(s, "d");
if (crc32("SPABarA",7) == 2190872201) strcat(s, "n");
if (crc32("qnRaAQCys",9) == 2546908045) strcat(s, "h");
if (crc32("YuobGUMTvle",11) == 4094658050) strcat(s, "a");
if (crc32("JhacV",5) == 1430904820) strcat(s, "O");
if (crc32("vnJuunIzmIWBUzo",15) == 2604716045) strcat(s, "t");
if (crc32("pupHIF",6) == 543207376) strcat(s, "u");
if (crc32("zTdGYSBxKceCdpL",15) == 3540202762) strcat(s, "r");
if (crc32("ywDBYTOMZErTE",13) == 4167893872) strcat(s, "y");
if (crc32("oSuwKxHecnRie",13) == 434708743) strcat(s, "e");
if (crc32("oMVOQWyayB",10) == 895894527) strcat(s, "q");
if (crc32("XSseVAjgQHyV",12) == 703671012) strcat(s, "d");
if (crc32("EAjiJeqfC",9) == 16532505) strcat(s, "l");
if (crc32("fECZAJIU",8) == 4209370458) strcat(s, "y");
    return s;
}

char *supernormally_adverbs() {
    char *s = calloc(14);
    if (crc32("ZNoyQtz",7) == 1336104777) strcat(s, "u");
if (crc32("QPeWsOu",7) == 309459676) strcat(s, "s");
if (crc32("bYXgtyhAm",9) == 1576967539) strcat(s, "u");
if (crc32("dzjYsp",6) == 4062465488) strcat(s, "p");
if (crc32("ebkRtgmJ",8) == 415973768) strcat(s, "V");
if (crc32("gqwFsrE",7) == 2877698093) strcat(s, "e");
if (crc32("uOnJopjqoDHw",12) == 1819739228) strcat(s, "r");
if (crc32("sbeRLyWiOr",10) == 4098778441) strcat(s, "n");
if (crc32("WtPSx",5) == 282316227) strcat(s, "V");
if (crc32("BzODpq",6) == 4243171201) strcat(s, "o");
if (crc32("yMQSCTjsEHNRYVh",15) == 605870220) strcat(s, "w");
if (crc32("ZJphtgMEdGYh",12) == 617825441) strcat(s, "r");
if (crc32("VrYxu",5) == 346277395) strcat(s, "m");
if (crc32("URczNjptaxZX",12) == 1220490370) strcat(s, "a");
if (crc32("CFWpbpaK",8) == 3055336593) strcat(s, "C");
if (crc32("zvUmY",5) == 2475155666) strcat(s, "l");
if (crc32("KsLVlwXTwprcq",13) == 1061390518) strcat(s, "l");
if (crc32("yRDAruvlQJS",11) == 2276522101) strcat(s, "l");
if (crc32("SjrKrZ",6) == 2156919878) strcat(s, "X");
if (crc32("kCymjPjmGJvQR",13) == 1874929205) strcat(s, "y");
    return s;
}

char *impermanently_adverbs() {
    char *s = calloc(14);
    if (crc32("XvyNqbEsVt",10) == 262364082) strcat(s, "i");
if (crc32("IpBqlSpXsZbzvA",14) == 509642673) strcat(s, "b");
if (crc32("zihvXos",7) == 1415570851) strcat(s, "m");
if (crc32("STyqxzXj",8) == 2842052977) strcat(s, "p");
if (crc32("fbeolDrt",8) == 4282045504) strcat(s, "C");
if (crc32("DYfQYFtAnMJnxsG",15) == 3629373204) strcat(s, "e");
if (crc32("Pbefp",5) == 1117827976) strcat(s, "r");
if (crc32("rymixVkounXaofH",15) == 3917360357) strcat(s, "m");
if (crc32("VqzbrBDZVWgENm",14) == 2435695689) strcat(s, "p");
if (crc32("CUvyZdLPiP",10) == 511733552) strcat(s, "a");
if (crc32("TYxOYeCn",8) == 3228477896) strcat(s, "a");
if (crc32("JXIoRzOHADkHA",13) == 56140298) strcat(s, "n");
if (crc32("jiRKdHwcHNB",11) == 663533374) strcat(s, "y");
if (crc32("lVNIUjBFLyD",11) == 398694201) strcat(s, "e");
if (crc32("LetYjXRkKGX",11) == 4102229014) strcat(s, "O");
if (crc32("mLCQNRWacUCGx",13) == 4283192059) strcat(s, "n");
if (crc32("fiOBQdP",7) == 3066764493) strcat(s, "t");
if (crc32("xSyyvcyivK",10) == 3205145590) strcat(s, "D");
if (crc32("EOGQYqDTvdA",11) == 1330584257) strcat(s, "l");
if (crc32("nlJHAVvqbgQA",12) == 3466431891) strcat(s, "y");
    return s;
}

char *genuinely_adverbs() {
    char *s = calloc(10);
    if (crc32("MsbCOQsySyjzEvl",15) == 4099826876) strcat(s, "L");
if (crc32("BbWNjHaAaa",10) == 905617727) strcat(s, "g");
if (crc32("KcRpmxaGfQD",11) == 2219922309) strcat(s, "L");
if (crc32("jRVoeNc",7) == 3550995381) strcat(s, "e");
if (crc32("pKuBziXWImJ",11) == 2821479798) strcat(s, "I");
if (crc32("TVLfWYoabOmd",12) == 3144114028) strcat(s, "n");
if (crc32("XYoWE",5) == 3364077998) strcat(s, "u");
if (crc32("ibPxrGC",7) == 1467894391) strcat(s, "i");
if (crc32("mNDQAtUaWVgaecH",15) == 422429459) strcat(s, "n");
if (crc32("LbLtOPiozuOrRPr",15) == 1397810602) strcat(s, "e");
if (crc32("FyJoiDCjXGumPyR",15) == 4008412228) strcat(s, "I");
if (crc32("JCyLMCQMAxpCuRQ",15) == 1135747979) strcat(s, "l");
if (crc32("GjxNVXGJSYC",11) == 3732177033) strcat(s, "N");
if (crc32("OQhBjyqbIBkK",12) == 1528050848) strcat(s, "y");
    return s;
}

char *villously_adverbs() {
    char *s = calloc(10);
    if (crc32("TOZRIQsWWdDzX",13) == 2104642277) strcat(s, "v");
if (crc32("vbHotQDRUXCll",13) == 1500542139) strcat(s, "i");
if (crc32("UjXJtNmUsdUqxb",14) == 537654334) strcat(s, "P");
if (crc32("xNAUiS",6) == 3203582852) strcat(s, "l");
if (crc32("UgUxtexAqFXPCNh",15) == 1836598042) strcat(s, "l");
if (crc32("qmsXLLNhWChbk",13) == 1918911897) strcat(s, "J");
if (crc32("hivGeLoJO",9) == 2090679148) strcat(s, "o");
if (crc32("FDZxeg",6) == 1763553074) strcat(s, "E");
if (crc32("zkOgy",5) == 3787751796) strcat(s, "u");
if (crc32("vYzMu",5) == 980155175) strcat(s, "s");
if (crc32("YjOcYtxukF",10) == 64450902) strcat(s, "q");
if (crc32("hykqapZFNIhCI",13) == 2730155524) strcat(s, "l");
if (crc32("nlUAASeI",8) == 2405264043) strcat(s, "y");
    return s;
}

char *nonorchestrally_adverbs() {
    char *s = calloc(16);
    if (crc32("zzEwDLxUT",9) == 865708802) strcat(s, "n");
if (crc32("LmFbiTFkewYo",12) == 1969143247) strcat(s, "m");
if (crc32("ulonFWbvpW",10) == 3551444436) strcat(s, "o");
if (crc32("dVmzM",5) == 1960141678) strcat(s, "W");
if (crc32("PlYLAPSKcCTF",12) == 423357001) strcat(s, "n");
if (crc32("EqBcJJcmLcT",11) == 2032377453) strcat(s, "o");
if (crc32("AmOkZcZdNyw",11) == 1363702497) strcat(s, "r");
if (crc32("wcuMphTk",8) == 2608553960) strcat(s, "O");
if (crc32("dsoKiUOWoUNQW",13) == 2991119329) strcat(s, "c");
if (crc32("YfygpgtxYlBtF",13) == 3330946199) strcat(s, "h");
if (crc32("RaWIEpeayhRri",13) == 2281901427) strcat(s, "e");
if (crc32("CTMVphOtFYRR",12) == 4137826588) strcat(s, "W");
if (crc32("MWzeWkDn",8) == 3873758322) strcat(s, "s");
if (crc32("vQkbiLTySkAwNN",14) == 904678087) strcat(s, "Z");
if (crc32("glpMxm",6) == 1063867417) strcat(s, "t");
if (crc32("OjvWhRQWJnlY",12) == 143674621) strcat(s, "Y");
if (crc32("ErwWyHsGrje",11) == 586172545) strcat(s, "r");
if (crc32("KjjZVJZJ",8) == 2699668503) strcat(s, "a");
if (crc32("wEIPMStNxeB",11) == 3791650229) strcat(s, "l");
if (crc32("VBIWGNmNoBIisdS",15) == 3460352214) strcat(s, "l");
if (crc32("mtpBxuBnhbiVljk",15) == 4030575941) strcat(s, "b");
if (crc32("jpuHSNaNMHylfFp",15) == 1719678800) strcat(s, "y");
    return s;
}

char *afore_adverbs() {
    char *s = calloc(6);
    if (crc32("WzAtevmRD",9) == 2769485716) strcat(s, "N");
if (crc32("tqAMXEm",7) == 2507857302) strcat(s, "a");
if (crc32("WGkZNDgDNjYtQuJ",15) == 2544955345) strcat(s, "g");
if (crc32("mSuveMZeY",9) == 2686267937) strcat(s, "f");
if (crc32("GQBssBEqF",9) == 2710729848) strcat(s, "h");
if (crc32("QYWnwaubsaD",11) == 1434381239) strcat(s, "o");
if (crc32("zoYyLfCdFWRYx",13) == 2108405417) strcat(s, "l");
if (crc32("OzmLvDxcxC",10) == 3184712188) strcat(s, "r");
if (crc32("PeIqt",5) == 3972953146) strcat(s, "e");
    return s;
}

char *nonidyllically_adverbs() {
    char *s = calloc(15);
    if (crc32("yRgUkTpmgX",10) == 3576531645) strcat(s, "n");
if (crc32("ATTveRGupt",10) == 3587966993) strcat(s, "o");
if (crc32("cmwxbEYp",8) == 1415662149) strcat(s, "W");
if (crc32("SKjPQJO",7) == 1942620604) strcat(s, "n");
if (crc32("oLCMrKjjnmJcJG",14) == 2079153417) strcat(s, "e");
if (crc32("AkVLYtJgO",9) == 4201814683) strcat(s, "i");
if (crc32("JiiFVeEzNbEM",12) == 430516459) strcat(s, "d");
if (crc32("NzyMSKOoflacQC",14) == 3645976038) strcat(s, "y");
if (crc32("KfnhKZPQGQM",11) == 2870730027) strcat(s, "y");
if (crc32("FavWyyo",7) == 562531359) strcat(s, "l");
if (crc32("Wlvoat",6) == 2979836934) strcat(s, "q");
if (crc32("zsxNLzrQyinkw",13) == 424109684) strcat(s, "l");
if (crc32("sduMDakqVOz",11) == 3057859599) strcat(s, "o");
if (crc32("PKvosVitzvM",11) == 2690094503) strcat(s, "i");
if (crc32("tfgQaEqfwzm",11) == 1204663549) strcat(s, "c");
if (crc32("zTLvHualAQJli",13) == 3533904192) strcat(s, "a");
if (crc32("ZvWWXe",6) == 450286328) strcat(s, "l");
if (crc32("wZBQfNcMDoyyLBl",15) == 2113995260) strcat(s, "l");
if (crc32("jaaUUwJVXoNF",12) == 2815474540) strcat(s, "j");
if (crc32("onrpNJ",6) == 55975746) strcat(s, "y");
    return s;
}

char *incorruptly_adverbs() {
    char *s = calloc(12);
    if (crc32("qUmDcrkKRiqjnJ",14) == 222249526) strcat(s, "P");
if (crc32("BYURWSASN",9) == 1317965390) strcat(s, "i");
if (crc32("tHERdXceocytKFH",15) == 1229425208) strcat(s, "N");
if (crc32("NCiZeO",6) == 1110390826) strcat(s, "n");
if (crc32("ShCXMVAdkQvAX",13) == 4235398898) strcat(s, "c");
if (crc32("pOkucvDoGcJTZ",13) == 1670626185) strcat(s, "G");
if (crc32("YFrRBFH",7) == 3171718754) strcat(s, "o");
if (crc32("iVlBXoEWXLJ",11) == 2730521996) strcat(s, "r");
if (crc32("FpuByhiG",8) == 319824416) strcat(s, "r");
if (crc32("uaufz",5) == 2185915898) strcat(s, "J");
if (crc32("UJWVxQklcEj",11) == 2201193627) strcat(s, "u");
if (crc32("jrgtPmdL",8) == 2484373613) strcat(s, "S");
if (crc32("jOtBigkEPbQ",11) == 509012548) strcat(s, "p");
if (crc32("VkhndNbS",8) == 1141681985) strcat(s, "q");
if (crc32("YCisJawnBYwcH",13) == 1340269852) strcat(s, "t");
if (crc32("aESqjBqsGfGIRbM",15) == 1824534552) strcat(s, "l");
if (crc32("fjSSVNxZPmRYK",13) == 2642585444) strcat(s, "x");
if (crc32("NitviSN",7) == 2740036648) strcat(s, "y");
    return s;
}

char *alarmingly_adverbs() {
    char *s = calloc(11);
    if (crc32("pROcgZqU",8) == 3076229715) strcat(s, "a");
if (crc32("dPhccvjlZMFa",12) == 3958639096) strcat(s, "l");
if (crc32("YkYHLTcg",8) == 908919024) strcat(s, "W");
if (crc32("lqWEfO",6) == 4278800365) strcat(s, "a");
if (crc32("hDQqeRvCikKleJ",14) == 2561060010) strcat(s, "K");
if (crc32("aNTQkAbxYOpUX",13) == 1532137563) strcat(s, "r");
if (crc32("OHJzBVEdwJHyzq",14) == 2440358068) strcat(s, "m");
if (crc32("FmxAAJkvO",9) == 3460834873) strcat(s, "z");
if (crc32("ybIFvrbwQd",10) == 4258079737) strcat(s, "i");
if (crc32("IlwiZH",6) == 1290433725) strcat(s, "n");
if (crc32("UBxDeDQhRefk",12) == 3083435586) strcat(s, "g");
if (crc32("EFHqGeKrJIHfYp",14) == 2845354) strcat(s, "m");
if (crc32("nPCGMztJhV",10) == 3465566293) strcat(s, "l");
if (crc32("iKcnrZ",6) == 4029818223) strcat(s, "W");
if (crc32("xvBmUMbtAuCzw",13) == 3625010338) strcat(s, "y");
    return s;
}

char *nontechnologically_adverbs() {
    char *s = calloc(19);
    if (crc32("qTsRWoyDFHj",11) == 609061405) strcat(s, "n");
if (crc32("RXwgOoQdsC",10) == 3140398301) strcat(s, "t");
if (crc32("lJJIECNMmNgP",12) == 3941856177) strcat(s, "o");
if (crc32("hhUkKntUuA",10) == 2705741713) strcat(s, "q");
if (crc32("NUIjTE",6) == 257883658) strcat(s, "n");
if (crc32("EPsMidFHoF",10) == 1103177997) strcat(s, "C");
if (crc32("OCjmVgVRqLbzHXZ",15) == 301120009) strcat(s, "t");
if (crc32("RPNAL",5) == 2750461729) strcat(s, "e");
if (crc32("xtprzIsqHn",10) == 1035337609) strcat(s, "c");
if (crc32("KpTRFwids",9) == 3317123332) strcat(s, "j");
if (crc32("qeOVtvRDxJhIfoX",15) == 2566630557) strcat(s, "h");
if (crc32("jbmDsdrnFfXioG",14) == 2396353971) strcat(s, "Q");
if (crc32("nLJCE",5) == 2433579131) strcat(s, "n");
if (crc32("xayQKZKAIIwZGH",14) == 3957788327) strcat(s, "N");
if (crc32("WiKBZLldjTUF",12) == 3171235991) strcat(s, "o");
if (crc32("WpXay",5) == 280930348) strcat(s, "l");
if (crc32("FJjxiMhQ",8) == 2235736017) strcat(s, "o");
if (crc32("cJuUMNVkGHePKat",15) == 2856500733) strcat(s, "g");
if (crc32("DmzUbfsXejTN",12) == 1280677209) strcat(s, "V");
if (crc32("MVeKZnkPkLhIh",13) == 3713974648) strcat(s, "i");
if (crc32("JolszelGM",9) == 1422448280) strcat(s, "b");
if (crc32("CvxtKNQpJZ",10) == 1444418530) strcat(s, "c");
if (crc32("gQygNnENTEl",11) == 3056262238) strcat(s, "K");
if (crc32("kjjskFe",7) == 3368276566) strcat(s, "a");
if (crc32("xuJjwNZxMEGl",12) == 1163513788) strcat(s, "B");
if (crc32("iBFcZI",6) == 129026666) strcat(s, "l");
if (crc32("XPeHFMAhHQcHbp",14) == 4129137122) strcat(s, "P");
if (crc32("JzkqVKNZpNyAVwc",15) == 3806958495) strcat(s, "l");
if (crc32("pVwvIyBSdd",10) == 4120541741) strcat(s, "y");
    return s;
}

char *unstupidly_adverbs() {
    char *s = calloc(11);
    if (crc32("YyPVBZzVlgoOIF",14) == 1005740672) strcat(s, "u");
if (crc32("iEaIKmVKnNr",11) == 1219536515) strcat(s, "Q");
if (crc32("cxZLHb",6) == 2955684162) strcat(s, "n");
if (crc32("DydSSVaF",8) == 1567435972) strcat(s, "s");
if (crc32("DuvGcBulZ",9) == 3814829381) strcat(s, "s");
if (crc32("zxftSYvrqcjIjd",14) == 4251685031) strcat(s, "t");
if (crc32("QlxVDPQHtCnHlA",14) == 2765331109) strcat(s, "u");
if (crc32("mWrlVJaIj",9) == 559880409) strcat(s, "w");
if (crc32("eTnRjM",6) == 131502767) strcat(s, "p");
if (crc32("bDmmCVuPBOJxrIm",15) == 1517413857) strcat(s, "i");
if (crc32("iJDbWjWtIp",10) == 2192538314) strcat(s, "d");
if (crc32("sEHXqLoMOgk",11) == 789778215) strcat(s, "x");
if (crc32("qZySR",5) == 3925064756) strcat(s, "l");
if (crc32("VQtfbjVQy",9) == 3982885808) strcat(s, "y");
    return s;
}

char *nontreasonably_adverbs() {
    char *s = calloc(15);
    if (crc32("lIrFOXoDyfGmS",13) == 3238230683) strcat(s, "e");
if (crc32("aZFaQqNslh",10) == 1558013440) strcat(s, "n");
if (crc32("ZARdXNgXdAPUX",13) == 1177434569) strcat(s, "b");
if (crc32("hDJZWh",6) == 3674727387) strcat(s, "o");
if (crc32("PaXnLl",6) == 1294343092) strcat(s, "n");
if (crc32("qkFNtaPNAboPKqL",15) == 4147976523) strcat(s, "d");
if (crc32("oJKjd",5) == 2162944917) strcat(s, "t");
if (crc32("dZIZu",5) == 4238830332) strcat(s, "c");
if (crc32("kliSzWZQ",8) == 3316908781) strcat(s, "r");
if (crc32("eUXgEH",6) == 2938173435) strcat(s, "e");
if (crc32("tHohCgOhIh",10) == 234099646) strcat(s, "X");
if (crc32("vRtegeWr",8) == 3643414008) strcat(s, "a");
if (crc32("mCbEdBYoGxMb",12) == 1510781419) strcat(s, "q");
if (crc32("lMiZkPJV",8) == 2464676384) strcat(s, "s");
if (crc32("FZMEHj",6) == 1645654566) strcat(s, "t");
if (crc32("oetdlRAeytnv",12) == 1605511938) strcat(s, "o");
if (crc32("PAXlwuymW",9) == 3742205660) strcat(s, "S");
if (crc32("bcbFqWXBkwugB",13) == 3083093905) strcat(s, "n");
if (crc32("QVgBmxw",7) == 2979963502) strcat(s, "a");
if (crc32("pxzfTuBQQs",10) == 464307544) strcat(s, "b");
if (crc32("ObaNA",5) == 2879042967) strcat(s, "l");
if (crc32("oKQquLFYFIHes",13) == 3247965575) strcat(s, "e");
if (crc32("fFFlWZXA",8) == 2515959564) strcat(s, "y");
    return s;
}

char *thereby_adverbs() {
    char *s = calloc(8);
    if (crc32("VVeYMSUfrOYxwj",14) == 891019518) strcat(s, "M");
if (crc32("UzTXnJPFS",9) == 1045261817) strcat(s, "t");
if (crc32("IdWcwgbAUzDXYF",14) == 1087437427) strcat(s, "h");
if (crc32("iYXkwYKd",8) == 2404101783) strcat(s, "U");
if (crc32("IlfWjrLjoypi",12) == 4109097843) strcat(s, "e");
if (crc32("vFxVQBPu",8) == 3802094452) strcat(s, "r");
if (crc32("SHrsHU",6) == 2834571002) strcat(s, "F");
if (crc32("MyjMvvInoeRY",12) == 3856644984) strcat(s, "e");
if (crc32("WMQZoqYyKTGonh",14) == 4125974412) strcat(s, "b");
if (crc32("clnrURqGH",9) == 4115157768) strcat(s, "r");
if (crc32("SCmNCObAYUncu",13) == 3444831808) strcat(s, "y");
    return s;
}

char *overremissly_adverbs() {
    char *s = calloc(13);
    if (crc32("BYMXUhqQnsmhvc",14) == 2012696574) strcat(s, "P");
if (crc32("MugEEohBy",9) == 1659160661) strcat(s, "o");
if (crc32("rQJRTOsgKJkt",12) == 4200257924) strcat(s, "v");
if (crc32("bSjfpkTKqSsoj",13) == 2401506247) strcat(s, "e");
if (crc32("XlHIFuyNPI",10) == 2179387296) strcat(s, "M");
if (crc32("npHCPCascQAdFLX",15) == 3074825435) strcat(s, "r");
if (crc32("uXyoLzTW",8) == 94047708) strcat(s, "r");
if (crc32("QQOENhmFVPaL",12) == 3965580929) strcat(s, "J");
if (crc32("RJEnTqp",7) == 3248219652) strcat(s, "e");
if (crc32("chrsMRPzjLGXLG",14) == 568184952) strcat(s, "P");
if (crc32("FxljQD",6) == 1203768333) strcat(s, "m");
if (crc32("juMBVfWefgkZUMq",15) == 3346705582) strcat(s, "i");
if (crc32("KkrDHQWH",8) == 3453910506) strcat(s, "s");
if (crc32("CqRCuirLKGFej",13) == 2070181679) strcat(s, "s");
if (crc32("wHSOjGLt",8) == 3456167985) strcat(s, "l");
if (crc32("QDFjAyKklbQrGk",14) == 1992881646) strcat(s, "y");
    return s;
}

char *profusely_adverbs() {
    char *s = calloc(10);
    if (crc32("iSTIvRF",7) == 457504137) strcat(s, "U");
if (crc32("ppVcph",6) == 2341730614) strcat(s, "p");
if (crc32("NqeqDyUddR",10) == 29832544) strcat(s, "r");
if (crc32("unzAFoY",7) == 3184849130) strcat(s, "C");
if (crc32("AxShbALYULS",11) == 3875334507) strcat(s, "o");
if (crc32("DyCSHunDj",9) == 2484205520) strcat(s, "H");
if (crc32("roSzOfnTjsLu",12) == 3726583185) strcat(s, "f");
if (crc32("jKiehbEPQIn",11) == 2547618555) strcat(s, "u");
if (crc32("OEXOblfUvcrfBm",14) == 80609337) strcat(s, "v");
if (crc32("VwdgfNAhImPMPm",14) == 2139849335) strcat(s, "s");
if (crc32("leRbYUBNGIWc",12) == 3930161907) strcat(s, "P");
if (crc32("lltqicZQiiRo",12) == 2634889814) strcat(s, "e");
if (crc32("WZgsReK",7) == 1599419390) strcat(s, "h");
if (crc32("VpJwvEpU",8) == 4077489200) strcat(s, "l");
if (crc32("EiUYaYrcK",9) == 221803726) strcat(s, "y");
    return s;
}

char *jabbingly_adverbs() {
    char *s = calloc(10);
    if (crc32("NcKlJb",6) == 4277177761) strcat(s, "j");
if (crc32("gRjixjCzZlRnKu",14) == 2585851230) strcat(s, "a");
if (crc32("rPfYZ",5) == 3872021982) strcat(s, "d");
if (crc32("MzOmHnd",7) == 3469621814) strcat(s, "b");
if (crc32("scvjOkTUjxYKU",13) == 2521760247) strcat(s, "b");
if (crc32("JFfNg",5) == 2607321590) strcat(s, "i");
if (crc32("lUzqxDtMtBFE",12) == 2434822110) strcat(s, "n");
if (crc32("sGYBWElckAnzZ",13) == 2975347040) strcat(s, "g");
if (crc32("njQBUIqqDmzauMY",15) == 4091052169) strcat(s, "l");
if (crc32("gEjUIf",6) == 2221571199) strcat(s, "E");
if (crc32("woTzZEeSjbelt",13) == 4231897739) strcat(s, "y");
    return s;
}

char *verbatim_adverbs() {
    char *s = calloc(9);
    if (crc32("FgRZmXtWtECFInD",15) == 3110990627) strcat(s, "v");
if (crc32("VdMIW",5) == 1774420906) strcat(s, "e");
if (crc32("hhCbGbgCEcrpm",13) == 2971967192) strcat(s, "f");
if (crc32("IVEytgkjjlF",11) == 4052400227) strcat(s, "r");
if (crc32("DvJlyCUXI",9) == 4144178414) strcat(s, "Q");
if (crc32("hDgpHETIwYb",11) == 404118135) strcat(s, "b");
if (crc32("Lojoa",5) == 2501338702) strcat(s, "q");
if (crc32("kELTTrUbZPh",11) == 3783155806) strcat(s, "a");
if (crc32("mKqOG",5) == 570367555) strcat(s, "t");
if (crc32("dOJiWNjGhFglou",14) == 3032962972) strcat(s, "i");
if (crc32("WcmeDInLnlqhn",13) == 2581448775) strcat(s, "X");
if (crc32("hBMVCUHZ",8) == 3789899137) strcat(s, "m");
    return s;
}

char *supermorosely_adverbs() {
    char *s = calloc(14);
    if (crc32("rkGiwmYgBlo",11) == 4170572266) strcat(s, "s");
if (crc32("WPdyiRVJpDkf",12) == 2588862458) strcat(s, "C");
if (crc32("THSeYcGxZLZvAu",14) == 3004372560) strcat(s, "u");
if (crc32("rQQYsdIIQSw",11) == 2076970634) strcat(s, "p");
if (crc32("xMFFZopvDith",12) == 3276624968) strcat(s, "E");
if (crc32("lsLNu",5) == 3565154751) strcat(s, "e");
if (crc32("nEuZHgWp",8) == 704343038) strcat(s, "r");
if (crc32("sHdxI",5) == 2177397990) strcat(s, "m");
if (crc32("HmRSzZkhjjTP",12) == 4125597465) strcat(s, "o");
if (crc32("fiJNyHRhkCnDTaj",15) == 1500507896) strcat(s, "U");
if (crc32("FhIblQWCwa",10) == 3118869248) strcat(s, "r");
if (crc32("LlAmVOngEvuGXe",14) == 1179206028) strcat(s, "F");
if (crc32("owDSJ",5) == 1537477793) strcat(s, "o");
if (crc32("EbXRN",5) == 3159897061) strcat(s, "s");
if (crc32("FYxCgNPwiTRo",12) == 2271109255) strcat(s, "X");
if (crc32("nalJiRHle",9) == 4077084215) strcat(s, "e");
if (crc32("OWZjksudm",9) == 1444654268) strcat(s, "c");
if (crc32("nGAumcgPv",9) == 3994540090) strcat(s, "l");
if (crc32("WVgyPldhvrQvgOm",15) == 3976896145) strcat(s, "y");
    return s;
}

char *usurpingly_adverbs() {
    char *s = calloc(11);
    if (crc32("FLTsgLyK",8) == 1019730594) strcat(s, "H");
if (crc32("kScXMDqc",8) == 2163193081) strcat(s, "u");
if (crc32("hGSnkBn",7) == 3219494682) strcat(s, "s");
if (crc32("aXUUAAOWM",9) == 1786099058) strcat(s, "l");
if (crc32("JdKGpXJGTnkG",12) == 231238990) strcat(s, "u");
if (crc32("DDJXtt",6) == 2885802937) strcat(s, "w");
if (crc32("XjHXCeTFcIJzK",13) == 1476572785) strcat(s, "r");
if (crc32("kEeWnMDBKaPj",12) == 1574792081) strcat(s, "h");
if (crc32("rLFJVHIOzZSsTUr",15) == 3151301439) strcat(s, "p");
if (crc32("MfrWdXm",7) == 2532107656) strcat(s, "e");
if (crc32("ueFXulzrwENUxwn",15) == 4293121965) strcat(s, "i");
if (crc32("CYmHwWNkCKuXQ",13) == 1788347215) strcat(s, "n");
if (crc32("GadeHXNHA",9) == 1111362654) strcat(s, "g");
if (crc32("dpinRna",7) == 144687740) strcat(s, "l");
if (crc32("QLyydeJDcZtB",12) == 3662862834) strcat(s, "W");
if (crc32("MKZYZlpesexuTfQ",15) == 273055684) strcat(s, "y");
    return s;
}

char *nonoffensively_adverbs() {
    char *s = calloc(15);
    if (crc32("Xwryp",5) == 3240420495) strcat(s, "n");
if (crc32("uoqJmZzIyEi",11) == 1676615622) strcat(s, "o");
if (crc32("MwxnMAbTNaAjM",13) == 3983165166) strcat(s, "o");
if (crc32("cZMqNAEXYbya",12) == 2182601569) strcat(s, "n");
if (crc32("MeZhIINrdVxsv",13) == 1853547832) strcat(s, "o");
if (crc32("rMNROi",6) == 3657335) strcat(s, "f");
if (crc32("lGSAcVmyFI",10) == 2836087431) strcat(s, "f");
if (crc32("UgKeseJetnHWiOV",15) == 1287552002) strcat(s, "e");
if (crc32("qcAIsLMyW",9) == 2308842728) strcat(s, "n");
if (crc32("OAwym",5) == 2741610066) strcat(s, "s");
if (crc32("glcZLaX",7) == 1930728112) strcat(s, "Q");
if (crc32("vZQZGEzlmIXddC",14) == 440626812) strcat(s, "i");
if (crc32("dMQzOefud",9) == 549643872) strcat(s, "d");
if (crc32("kezEJ",5) == 1717127224) strcat(s, "v");
if (crc32("pfmwBdD",7) == 841763217) strcat(s, "C");
if (crc32("ekmyXzZYqgvkIlg",15) == 3141443636) strcat(s, "e");
if (crc32("reiyTLudOU",10) == 3293965594) strcat(s, "l");
if (crc32("rrufVNURy",9) == 2976871851) strcat(s, "y");
    return s;
}

char *lyrately_adverbs() {
    char *s = calloc(9);
    if (crc32("BauHQg",6) == 85868545) strcat(s, "l");
if (crc32("qHuKiY",6) == 4042381960) strcat(s, "V");
if (crc32("EXPwx",5) == 177487846) strcat(s, "y");
if (crc32("aZJnR",5) == 72687697) strcat(s, "O");
if (crc32("DlPXOVaSuihE",12) == 3728128672) strcat(s, "r");
if (crc32("tBTMtGvPED",10) == 3167464231) strcat(s, "a");
if (crc32("ghyrxyNoNPGg",12) == 1257097550) strcat(s, "t");
if (crc32("sSbIarDxZoTAEu",14) == 324594086) strcat(s, "t");
if (crc32("nccGha",6) == 2524557789) strcat(s, "e");
if (crc32("vWEAil",6) == 668478773) strcat(s, "N");
if (crc32("gHRVySZklpHCtFj",15) == 2240255093) strcat(s, "l");
if (crc32("uhcmCyeyzDO",11) == 3003601993) strcat(s, "i");
if (crc32("tUvot",5) == 3553794093) strcat(s, "y");
    return s;
}

char *scathelessly_adverbs() {
    char *s = calloc(13);
    if (crc32("QwGfJTZxPFRa",12) == 1583312989) strcat(s, "s");
if (crc32("AcBxpfUidJxuUG",14) == 2931202149) strcat(s, "c");
if (crc32("lMFvC",5) == 3721704632) strcat(s, "z");
if (crc32("KDQiDjVPsEZ",11) == 2520840964) strcat(s, "a");
if (crc32("mUSFcJxa",8) == 2336590184) strcat(s, "t");
if (crc32("YbpYyDyIGDfdJG",14) == 4140661456) strcat(s, "h");
if (crc32("MzKLrz",6) == 690645169) strcat(s, "e");
if (crc32("rNPOXhEzsRML",12) == 1908924780) strcat(s, "l");
if (crc32("HgcRffHIKPXd",12) == 991821771) strcat(s, "s");
if (crc32("IeiXAybcGURzvd",14) == 3062935964) strcat(s, "e");
if (crc32("TFLJOPtTx",9) == 3379730513) strcat(s, "s");
if (crc32("CNZNGxjShzzNaT",14) == 3645965728) strcat(s, "H");
if (crc32("kygxbWTnNzTdHo",14) == 2533125783) strcat(s, "s");
if (crc32("nZQUK",5) == 254583929) strcat(s, "l");
if (crc32("txDSlEkobWMR",12) == 348054329) strcat(s, "y");
    return s;
}

char *pretemperately_adverbs() {
    char *s = calloc(15);
    if (crc32("XlGQGdsszcfihn",14) == 4027681942) strcat(s, "v");
if (crc32("gCILRQe",7) == 802163574) strcat(s, "p");
if (crc32("cteUhzhMYhwl",12) == 3505025483) strcat(s, "j");
if (crc32("joATlnDXeOAF",12) == 3856549133) strcat(s, "r");
if (crc32("qdyXKW",6) == 2400480461) strcat(s, "e");
if (crc32("KRmZYFMkBWkUkt",14) == 1034583826) strcat(s, "d");
if (crc32("MtpgmN",6) == 1774647898) strcat(s, "t");
if (crc32("KFhBgzYNhhZE",12) == 2521675101) strcat(s, "e");
if (crc32("sHVXOVkCFCz",11) == 902003908) strcat(s, "z");
if (crc32("jOowrEkkloEHok",14) == 1961426831) strcat(s, "m");
if (crc32("MeSlHGcsPXkIX",13) == 2824641180) strcat(s, "b");
if (crc32("AKXFhcwv",8) == 2624358983) strcat(s, "p");
if (crc32("bsTJcaZZvth",11) == 33388074) strcat(s, "z");
if (crc32("tEjSnHSI",8) == 3056674833) strcat(s, "e");
if (crc32("lSiuJwdxsqI",11) == 753666409) strcat(s, "r");
if (crc32("OUjrWCAGHblQEq",14) == 2518984781) strcat(s, "q");
if (crc32("ZXHyjnGOdiZQIu",14) == 3358368640) strcat(s, "a");
if (crc32("FNiNDPQ",7) == 3463167266) strcat(s, "A");
if (crc32("gNYmkUaG",8) == 4078272672) strcat(s, "t");
if (crc32("bqeANooQEtT",11) == 1563831279) strcat(s, "e");
if (crc32("hmhoHmGz",8) == 2889842570) strcat(s, "q");
if (crc32("hIZnpCvkiuXA",12) == 1335776728) strcat(s, "l");
if (crc32("lYaRQYZuks",10) == 896491443) strcat(s, "Y");
if (crc32("dUeXfn",6) == 632181779) strcat(s, "y");
    return s;
}

char *chickenheartedly_adverbs() {
    char *s = calloc(17);
    if (crc32("wPxMsEdCBZJDDX",14) == 2191327016) strcat(s, "c");
if (crc32("CJXqKj",6) == 483916555) strcat(s, "I");
if (crc32("JgMfFutJC",9) == 2969781765) strcat(s, "h");
if (crc32("oBISpBSrm",9) == 554892742) strcat(s, "E");
if (crc32("gbzam",5) == 1788660045) strcat(s, "i");
if (crc32("fGAlrM",6) == 1775818043) strcat(s, "M");
if (crc32("AUlCErJWmTcS",12) == 3574542696) strcat(s, "c");
if (crc32("jZBBLbgAivboWy",14) == 1700860605) strcat(s, "B");
if (crc32("wlxtJqUFICkgEt",14) == 3194876541) strcat(s, "k");
if (crc32("UAwVFaNbpSkdmiR",15) == 1803369831) strcat(s, "e");
if (crc32("VrAMB",5) == 471487330) strcat(s, "n");
if (crc32("AOPJQYSCzDsI",12) == 1618370177) strcat(s, "X");
if (crc32("bfPwIuGgyGvMK",13) == 3471286927) strcat(s, "h");
if (crc32("ZyQuUYAH",8) == 3875574442) strcat(s, "A");
if (crc32("tHVaSf",6) == 3687237231) strcat(s, "e");
if (crc32("QhXsqxnC",8) == 692371325) strcat(s, "D");
if (crc32("YRBYHDDjVCaojzs",15) == 4220774420) strcat(s, "a");
if (crc32("FFAzKkk",7) == 3062383595) strcat(s, "T");
if (crc32("elgHEyPsueKUO",13) == 748777277) strcat(s, "r");
if (crc32("PkdzRrkMHZ",10) == 2101270854) strcat(s, "t");
if (crc32("KddRSadCKkKfS",13) == 4259197456) strcat(s, "l");
if (crc32("WBzaPZlxwKkWy",13) == 132708753) strcat(s, "e");
if (crc32("aIbKqW",6) == 155358765) strcat(s, "d");
if (crc32("bpEkrpbCBJHgUY",14) == 593500603) strcat(s, "S");
if (crc32("Wpzykki",7) == 596401583) strcat(s, "l");
if (crc32("OzXoenM",7) == 1553411093) strcat(s, "N");
if (crc32("CwhyiJvFARN",11) == 1957527520) strcat(s, "y");
    return s;
}

char *venturesomely_adverbs() {
    char *s = calloc(14);
    if (crc32("DGeLYyW",7) == 3623532719) strcat(s, "v");
if (crc32("bvoRbzLYgf",10) == 3258765669) strcat(s, "e");
if (crc32("SQISIQUY",8) == 2612766294) strcat(s, "o");
if (crc32("WcuHCLabJt",10) == 3472932036) strcat(s, "n");
if (crc32("frFVCGu",7) == 1796005667) strcat(s, "u");
if (crc32("YSCVHPuQur",10) == 210202500) strcat(s, "t");
if (crc32("TceKNBsc",8) == 2708926443) strcat(s, "u");
if (crc32("PQftQjjiOONW",12) == 661358032) strcat(s, "r");
if (crc32("QWcSvrqvqgd",11) == 1104954079) strcat(s, "e");
if (crc32("jEEBlKhk",8) == 904387287) strcat(s, "s");
if (crc32("shfdftdVWttFR",13) == 2934663240) strcat(s, "y");
if (crc32("qfOFg",5) == 317603896) strcat(s, "o");
if (crc32("bUAatGG",7) == 4265916121) strcat(s, "M");
if (crc32("oKtknEKbxQfHE",13) == 1045010885) strcat(s, "m");
if (crc32("tedTWLXmMHInosa",15) == 3225166860) strcat(s, "e");
if (crc32("wTlMVE",6) == 2308172852) strcat(s, "l");
if (crc32("sLgsKral",8) == 1280829309) strcat(s, "y");
    return s;
}

char *unsacredly_adverbs() {
    char *s = calloc(11);
    if (crc32("VAarPl",6) == 618031055) strcat(s, "u");
if (crc32("sHbbJWAZ",8) == 1766964922) strcat(s, "n");
if (crc32("WwQJrnKy",8) == 2142536130) strcat(s, "s");
if (crc32("flRJwOqQztvDLUD",15) == 4012936312) strcat(s, "T");
if (crc32("zdijOsMIuB",10) == 2145369266) strcat(s, "a");
if (crc32("pvTzEMYs",8) == 340420960) strcat(s, "c");
if (crc32("QFruUJF",7) == 1447959842) strcat(s, "S");
if (crc32("aFNWpToTeDr",11) == 1622334656) strcat(s, "r");
if (crc32("joOQhvH",7) == 2699724459) strcat(s, "z");
if (crc32("YECPyZgFrif",11) == 2764957893) strcat(s, "e");
if (crc32("DrWtvFSJeSe",11) == 4268928600) strcat(s, "d");
if (crc32("tIPOZysLYlGXJnK",15) == 3029819030) strcat(s, "W");
if (crc32("wuNxpcu",7) == 2622101109) strcat(s, "l");
if (crc32("SIfkn",5) == 1070865424) strcat(s, "y");
    return s;
}

char *inquisitorially_adverbs() {
    char *s = calloc(16);
    if (crc32("bDrweXtOJtqOu",13) == 3777140972) strcat(s, "Z");
if (crc32("ZOnSEWDOKH",10) == 1247224189) strcat(s, "i");
if (crc32("nfnAlQgVTmQMKof",15) == 3246861989) strcat(s, "n");
if (crc32("ATkHcumA",8) == 3746722666) strcat(s, "o");
if (crc32("XlqbEgP",7) == 2424021703) strcat(s, "q");
if (crc32("DVKqmFjKSGq",11) == 64426045) strcat(s, "s");
if (crc32("LiVcL",5) == 1149541633) strcat(s, "u");
if (crc32("uDOesV",6) == 1278172172) strcat(s, "i");
if (crc32("MkWalbz",7) == 2369739746) strcat(s, "C");
if (crc32("EBMvtHDK",8) == 4249912007) strcat(s, "s");
if (crc32("WMRcLPqRTuJdCVB",15) == 3138577783) strcat(s, "i");
if (crc32("MlRPcnjAiKJb",12) == 2596197371) strcat(s, "t");
if (crc32("FAFjlOhYDIqA",12) == 637189118) strcat(s, "T");
if (crc32("cMxcYhnBj",9) == 2255006966) strcat(s, "o");
if (crc32("vCrbjJSawK",10) == 2809099244) strcat(s, "r");
if (crc32("TxfwhRuKEWiXw",13) == 1582227359) strcat(s, "i");
if (crc32("RfLCKZMzyxavJI",14) == 454289135) strcat(s, "E");
if (crc32("ComVrpqVHVoC",12) == 2487521782) strcat(s, "a");
if (crc32("fZwPqkPcWc",10) == 3540958981) strcat(s, "l");
if (crc32("hTHHbXXDa",9) == 4026953224) strcat(s, "D");
if (crc32("jkgElWBLcwAJQnn",15) == 1683888781) strcat(s, "l");
if (crc32("zVfmNXQQ",8) == 17861750) strcat(s, "y");
    return s;
}

char *halfclearly_adverbs() {
    char *s = calloc(12);
    if (crc32("YGfPV",5) == 2164991012) strcat(s, "h");
if (crc32("PvIQjVF",7) == 1938741867) strcat(s, "a");
if (crc32("cWzfLbfNBHWEmPR",15) == 1970588393) strcat(s, "i");
if (crc32("ZwbdA",5) == 158365881) strcat(s, "l");
if (crc32("gbGFZ",5) == 609724644) strcat(s, "f");
if (crc32("CRRkLinXO",9) == 2391587647) strcat(s, "e");
if (crc32("nTZSiyZMEQF",11) == 2258620419) strcat(s, "c");
if (crc32("qazxUDbqIztmKYE",15) == 1059709643) strcat(s, "x");
if (crc32("judQAth",7) == 2401524610) strcat(s, "l");
if (crc32("tQbWpo",6) == 787221133) strcat(s, "e");
if (crc32("JoVfftdbsnUbI",13) == 4165289097) strcat(s, "y");
if (crc32("aeMJLDqww",9) == 3428606414) strcat(s, "a");
if (crc32("OgjpwcTbp",9) == 1262169370) strcat(s, "S");
if (crc32("vxozyUX",7) == 320419503) strcat(s, "r");
if (crc32("hHjNaQMnFQ",10) == 1179445781) strcat(s, "l");
if (crc32("siBSXolHMEF",11) == 2339488951) strcat(s, "y");
    return s;
}

char *unhomiletically_adverbs() {
    char *s = calloc(16);
    if (crc32("eevrZSiRien",11) == 1116506131) strcat(s, "C");
if (crc32("ZMEkvmKeDfW",11) == 711260271) strcat(s, "u");
if (crc32("VUGBAXx",7) == 117458941) strcat(s, "n");
if (crc32("RbMLwdA",7) == 2028688571) strcat(s, "o");
if (crc32("IOhqRPzuQrRal",13) == 233694877) strcat(s, "h");
if (crc32("vuXoxw",6) == 960404721) strcat(s, "o");
if (crc32("oHFhflrtkHj",11) == 2853834453) strcat(s, "m");
if (crc32("AKCoyEZYPm",10) == 3617696511) strcat(s, "z");
if (crc32("ZUqPDvvFm",9) == 2086212033) strcat(s, "i");
if (crc32("NWYmnlTpbMIdbbs",15) == 4066334267) strcat(s, "h");
if (crc32("CMmlyyTZPhsPm",13) == 2105191847) strcat(s, "l");
if (crc32("jcBOVTVXUziQDr",14) == 1395188338) strcat(s, "e");
if (crc32("WvYBnlFeLQRydJl",15) == 690093825) strcat(s, "Q");
if (crc32("gZzcuRFLiXz",11) == 4217661704) strcat(s, "t");
if (crc32("axGugEjC",8) == 636266493) strcat(s, "i");
if (crc32("rGFin",5) == 701581813) strcat(s, "c");
if (crc32("SYhjFrEccyhrsnT",15) == 1847003157) strcat(s, "a");
if (crc32("NibruZZhM",9) == 802068352) strcat(s, "V");
if (crc32("XciBFFUAFiIk",12) == 2790901465) strcat(s, "l");
if (crc32("HdbeWgxcnYnDO",13) == 3239734389) strcat(s, "l");
if (crc32("OpievT",6) == 2874082058) strcat(s, "y");
    return s;
}

char *aimfully_adverbs() {
    char *s = calloc(9);
    if (crc32("TGOFsVLHdbxnif",14) == 1198021555) strcat(s, "B");
if (crc32("RTuUk",5) == 2399684665) strcat(s, "a");
if (crc32("mBDtXQ",6) == 236654550) strcat(s, "i");
if (crc32("iFqtcGlcWA",10) == 2967348877) strcat(s, "m");
if (crc32("hKPxdBXFaNoC",12) == 385359675) strcat(s, "f");
if (crc32("aGeprHTofHDcOV",14) == 1976544636) strcat(s, "c");
if (crc32("difvEUJzA",9) == 3640207440) strcat(s, "u");
if (crc32("nOSNXSraHYYpco",14) == 2000633313) strcat(s, "j");
if (crc32("BndQrFuZDJKkFW",14) == 4128051320) strcat(s, "l");
if (crc32("TPrxlrzMTAdpFgK",15) == 3624028597) strcat(s, "l");
if (crc32("gVINyKvMoGwkbdB",15) == 2634971997) strcat(s, "t");
if (crc32("fJKWV",5) == 801411290) strcat(s, "y");
    return s;
}

char *nonvigilantly_adverbs() {
    char *s = calloc(14);
    if (crc32("LLmmdQbrwWYWsJ",14) == 899203693) strcat(s, "n");
if (crc32("VbeAJUaTuACBkgV",15) == 3885709255) strcat(s, "o");
if (crc32("Erbdm",5) == 4006011963) strcat(s, "n");
if (crc32("IqqQAVuOqu",10) == 3248378994) strcat(s, "v");
if (crc32("UwnBJTL",7) == 822730864) strcat(s, "i");
if (crc32("KDphmlG",7) == 689316175) strcat(s, "g");
if (crc32("MZGzy",5) == 1261258626) strcat(s, "i");
if (crc32("hQZXINsVqFJM",12) == 912987485) strcat(s, "l");
if (crc32("bAAppKEufObrfHA",15) == 3346534922) strcat(s, "A");
if (crc32("GQSGzMmEtIOCc",13) == 166264578) strcat(s, "a");
if (crc32("UNQhPip",7) == 2863973511) strcat(s, "n");
if (crc32("CKYVeSWjB",9) == 3685417373) strcat(s, "a");
if (crc32("fQBxtFBOLWlY",12) == 545395374) strcat(s, "t");
if (crc32("sOagJfV",7) == 1893928128) strcat(s, "l");
if (crc32("TSKYB",5) == 2315404482) strcat(s, "R");
if (crc32("hxghweLofiD",11) == 1499894842) strcat(s, "y");
    return s;
}

char *nonneutrally_adverbs() {
    char *s = calloc(13);
    if (crc32("RMEBjSIC",8) == 3089384792) strcat(s, "M");
if (crc32("yveUgX",6) == 3271436041) strcat(s, "n");
if (crc32("QjhiaiOyKZJurT",14) == 3356262346) strcat(s, "J");
if (crc32("UqSLHDbcmMAqGTw",15) == 3246104244) strcat(s, "o");
if (crc32("LPrMKfw",7) == 2645473413) strcat(s, "y");
if (crc32("cDVmXrzTqnYviWw",15) == 941372546) strcat(s, "n");
if (crc32("qSUURqrrKzg",11) == 4251386086) strcat(s, "i");
if (crc32("tfMGuXQeZDR",11) == 3529330413) strcat(s, "n");
if (crc32("jdmUK",5) == 3341390303) strcat(s, "e");
if (crc32("ByBzz",5) == 799105154) strcat(s, "E");
if (crc32("rMzqAc",6) == 992189864) strcat(s, "u");
if (crc32("hCQgIGhylQgHLpB",15) == 2184869957) strcat(s, "Z");
if (crc32("SHBxzgLyPru",11) == 257996439) strcat(s, "t");
if (crc32("klUefFA",7) == 895830327) strcat(s, "E");
if (crc32("RiRHwIZjPjdwwvo",15) == 2049518039) strcat(s, "r");
if (crc32("TayGYzrc",8) == 2040544108) strcat(s, "a");
if (crc32("BpyxLdAspK",10) == 1257798636) strcat(s, "l");
if (crc32("yclvygCz",8) == 116599001) strcat(s, "D");
if (crc32("wiNxC",5) == 3116970069) strcat(s, "l");
if (crc32("LFXsFf",6) == 1142365175) strcat(s, "y");
    return s;
}

char *rockingly_adverbs() {
    char *s = calloc(10);
    if (crc32("yoKGshaRdNMJa",13) == 409206023) strcat(s, "r");
if (crc32("jrflSCWEBCWq",12) == 3350983186) strcat(s, "o");
if (crc32("lnyOt",5) == 984635473) strcat(s, "c");
if (crc32("pSSKtAfvnF",10) == 3539685340) strcat(s, "i");
if (crc32("cBnlDddZaOFbH",13) == 2426476787) strcat(s, "k");
if (crc32("PhNJg",5) == 2943733995) strcat(s, "g");
if (crc32("ZAkJPHVH",8) == 313135473) strcat(s, "i");
if (crc32("yezfnYL",7) == 1204848978) strcat(s, "n");
if (crc32("rFHRdoWYtpDo",12) == 2834533095) strcat(s, "g");
if (crc32("ibONjkgAP",9) == 4079093728) strcat(s, "l");
if (crc32("KXRxB",5) == 1412925093) strcat(s, "v");
if (crc32("sJJeDpLFw",9) == 4172720104) strcat(s, "y");
    return s;
}

char *changelessly_adverbs() {
    char *s = calloc(13);
    if (crc32("llImDpt",7) == 1026018023) strcat(s, "c");
if (crc32("ZuaUtiUAmac",11) == 3266816266) strcat(s, "P");
if (crc32("SclwDHGxhxrCiX",14) == 2181914634) strcat(s, "h");
if (crc32("qvIKPqmkAgR",11) == 460045386) strcat(s, "x");
if (crc32("rnkUfDPYXqh",11) == 609021013) strcat(s, "a");
if (crc32("eGHfxxlDErsIJX",14) == 3148889406) strcat(s, "n");
if (crc32("YkXLUFxrEIaTW",13) == 3301484569) strcat(s, "g");
if (crc32("rUexGk",6) == 882446873) strcat(s, "e");
if (crc32("aiWEeZWn",8) == 3950869213) strcat(s, "a");
if (crc32("cKqbVCJ",7) == 844915476) strcat(s, "l");
if (crc32("stpxCvzLzyE",11) == 4172147120) strcat(s, "z");
if (crc32("eBSKFExui",9) == 2874831889) strcat(s, "e");
if (crc32("JTPiPanrnnLo",12) == 544484177) strcat(s, "a");
if (crc32("xjHeHXmrtQb",11) == 1890279329) strcat(s, "s");
if (crc32("QeyzwxTYWOgvzP",14) == 2991009923) strcat(s, "p");
if (crc32("UaRmC",5) == 3858094302) strcat(s, "s");
if (crc32("giEVZEnGdnTkhb",14) == 1290414887) strcat(s, "l");
if (crc32("aItDTNA",7) == 3675471016) strcat(s, "f");
if (crc32("rRcXJAp",7) == 3013384766) strcat(s, "y");
    return s;
}

char *nonastronomically_adverbs() {
    char *s = calloc(18);
    if (crc32("PgmbcPcvrDQotn",14) == 2999964048) strcat(s, "J");
if (crc32("ttaAcnnJAyTd",12) == 2893990443) strcat(s, "n");
if (crc32("MlUkDLtsh",9) == 897345116) strcat(s, "o");
if (crc32("PlcbaajjcR",10) == 399855140) strcat(s, "n");
if (crc32("UTEwqGHgHxU",11) == 4099903485) strcat(s, "n");
if (crc32("gnhzqoznVk",10) == 2756756234) strcat(s, "a");
if (crc32("vENYH",5) == 1962984712) strcat(s, "s");
if (crc32("pOalHA",6) == 2607773139) strcat(s, "t");
if (crc32("FjPvsgQDMUO",11) == 189470814) strcat(s, "r");
if (crc32("LeZXNNRXlQTcU",13) == 3349652832) strcat(s, "o");
if (crc32("CJfQuHqscIp",11) == 2531551740) strcat(s, "C");
if (crc32("NOmANAOWNYZtG",13) == 595133991) strcat(s, "n");
if (crc32("YuNOCSSPoHKz",12) == 1716735412) strcat(s, "G");
if (crc32("rkoTer",6) == 3082528254) strcat(s, "o");
if (crc32("RIqWb",5) == 3568941734) strcat(s, "a");
if (crc32("zbjWQAvLRfPPhF",14) == 2686009827) strcat(s, "m");
if (crc32("CwrnPoDMghNdX",13) == 4062464952) strcat(s, "e");
if (crc32("AVlsBPb",7) == 3935755241) strcat(s, "i");
if (crc32("hNRbsvXPxZrS",12) == 1268981563) strcat(s, "c");
if (crc32("iHjCJP",6) == 1875650282) strcat(s, "L");
if (crc32("qqjqTHdFVyI",11) == 2609361421) strcat(s, "a");
if (crc32("oovzzsyRSyq",11) == 1731229803) strcat(s, "g");
if (crc32("YozSb",5) == 4213726871) strcat(s, "l");
if (crc32("vGapnRus",8) == 2605639522) strcat(s, "l");
if (crc32("HexpWDXcqmpwW",13) == 1774235012) strcat(s, "F");
if (crc32("UJhGe",5) == 106748274) strcat(s, "y");
    return s;
}

char *erringly_adverbs() {
    char *s = calloc(9);
    if (crc32("PrnWsvEc",8) == 2206007406) strcat(s, "e");
if (crc32("SXGCjLGUUn",10) == 1463265826) strcat(s, "N");
if (crc32("LpxcPU",6) == 1965723230) strcat(s, "r");
if (crc32("SAmKZWZwDNOHnTD",15) == 4037347274) strcat(s, "r");
if (crc32("tBSZouDpRt",10) == 3831131375) strcat(s, "T");
if (crc32("Ogsvlah",7) == 3032088987) strcat(s, "i");
if (crc32("phDETlsLBV",10) == 2306245605) strcat(s, "N");
if (crc32("UeFcKysZWVMl",12) == 3320742379) strcat(s, "n");
if (crc32("DxWLfObwp",9) == 4118550601) strcat(s, "c");
if (crc32("iaXUEVaEeV",10) == 4123126162) strcat(s, "g");
if (crc32("WfUEQbuDPzYO",12) == 51832332) strcat(s, "Z");
if (crc32("ltbEp",5) == 3907358632) strcat(s, "l");
if (crc32("vHlqUUprnkoObo",14) == 3523107807) strcat(s, "E");
if (crc32("kckZMFPnMhfIWUX",15) == 1191315806) strcat(s, "y");
    return s;
}

char *quasiradically_adverbs() {
    char *s = calloc(15);
    if (crc32("SqRNDmfGBtd",11) == 2515448538) strcat(s, "q");
if (crc32("fGQGJYuhJyxO",12) == 2394442447) strcat(s, "B");
if (crc32("ESeFGDIgAqZF",12) == 2435190320) strcat(s, "u");
if (crc32("qxURtamCNBiYQ",13) == 3392558543) strcat(s, "a");
if (crc32("TvbrWoyQlvjUO",13) == 546786245) strcat(s, "s");
if (crc32("HaqZaqPSLYdd",12) == 3933502473) strcat(s, "u");
if (crc32("xwTlEcnsJMsO",12) == 3172441261) strcat(s, "i");
if (crc32("WJwVqqnYt",9) == 3524679919) strcat(s, "r");
if (crc32("UcbndwQuMSalqAx",15) == 3629608894) strcat(s, "a");
if (crc32("hjjkCiTdMClPifU",15) == 618276160) strcat(s, "d");
if (crc32("QVORGkJErbf",11) == 4194126726) strcat(s, "b");
if (crc32("LXtzOu",6) == 730784650) strcat(s, "i");
if (crc32("HrhioqcIQKk",11) == 4231140884) strcat(s, "c");
if (crc32("iQVAtKlPExCRCe",14) == 517452902) strcat(s, "C");
if (crc32("mEBPhrLCi",9) == 193738614) strcat(s, "a");
if (crc32("VDjqeOPeGkAc",12) == 3885187495) strcat(s, "l");
if (crc32("MzuutwrYbx",10) == 3349951326) strcat(s, "l");
if (crc32("FSGwYRedPlnnl",13) == 2612767845) strcat(s, "z");
if (crc32("EShhHbUTCvE",11) == 4047877199) strcat(s, "y");
    return s;
}

char *tetartohedrally_adverbs() {
    char *s = calloc(16);
    if (crc32("KEqFXe",6) == 123322120) strcat(s, "B");
if (crc32("iYoKvvPQtpPK",12) == 3063265325) strcat(s, "t");
if (crc32("tRTtwXnB",8) == 2513712587) strcat(s, "e");
if (crc32("GmxcjYoTJCP",11) == 864715532) strcat(s, "t");
if (crc32("gVGbHAGCjv",10) == 981148794) strcat(s, "a");
if (crc32("uXbwtogwpa",10) == 4116983632) strcat(s, "E");
if (crc32("RURzQhQBXDx",11) == 2287167827) strcat(s, "r");
if (crc32("WwdvFj",6) == 3696682191) strcat(s, "p");
if (crc32("DmAvreurXTFXts",14) == 1978536086) strcat(s, "t");
if (crc32("IHehZXVgTt",10) == 1258964587) strcat(s, "o");
if (crc32("lAIqcyQ",7) == 3625600505) strcat(s, "c");
if (crc32("BzvYFNCd",8) == 4211787862) strcat(s, "h");
if (crc32("fnRCFKELxKA",11) == 2891915738) strcat(s, "e");
if (crc32("HNjvOFhsMqDVx",13) == 796799446) strcat(s, "i");
if (crc32("rnZBo",5) == 3768598186) strcat(s, "d");
if (crc32("ujovPTjHL",9) == 3278188009) strcat(s, "r");
if (crc32("AqtgsGdex",9) == 1110978787) strcat(s, "G");
if (crc32("rvZaQa",6) == 4111100684) strcat(s, "a");
if (crc32("naVxWkVDc",9) == 2292180947) strcat(s, "p");
if (crc32("DGrpcxrjmN",10) == 1320578754) strcat(s, "l");
if (crc32("AjtSf",5) == 2442501109) strcat(s, "l");
if (crc32("UZTVaufxtd",10) == 3995077290) strcat(s, "c");
if (crc32("wYWeRPQhmr",10) == 2382039477) strcat(s, "y");
    return s;
}

char *calculably_adverbs() {
    char *s = calloc(11);
    if (crc32("IrxYxkfVMCjXwi",14) == 2749786359) strcat(s, "j");
if (crc32("wUHjgfat",8) == 1140257270) strcat(s, "c");
if (crc32("AjLpzo",6) == 732591590) strcat(s, "a");
if (crc32("UTVRtBMFApoD",12) == 2226270370) strcat(s, "l");
if (crc32("lHvnXwUBNcOBUV",14) == 1411493330) strcat(s, "C");
if (crc32("Sbhuxr",6) == 762276206) strcat(s, "c");
if (crc32("SgSXYSvOJopJhLM",15) == 3676730043) strcat(s, "b");
if (crc32("vzEUW",5) == 4037050599) strcat(s, "u");
if (crc32("dgSJQ",5) == 1952562990) strcat(s, "l");
if (crc32("zZUkfxDg",8) == 3763772244) strcat(s, "C");
if (crc32("RAHiK",5) == 2363605088) strcat(s, "a");
if (crc32("HidTMDVM",8) == 2082528355) strcat(s, "h");
if (crc32("fbgFMbMZd",9) == 2401991968) strcat(s, "b");
if (crc32("hfGsvPbJfaALZx",14) == 312333270) strcat(s, "W");
if (crc32("xYhYyPcn",8) == 3811535928) strcat(s, "l");
if (crc32("LIVsd",5) == 2613151892) strcat(s, "y");
    return s;
}

char *hungeringly_adverbs() {
    char *s = calloc(12);
    if (crc32("oemNLmZeTor",11) == 3028300436) strcat(s, "J");
if (crc32("bQCwxoH",7) == 1873568894) strcat(s, "h");
if (crc32("MzOPDoRKuyBOAvL",15) == 364391418) strcat(s, "u");
if (crc32("smirWscct",9) == 2871080612) strcat(s, "Q");
if (crc32("pPgmETmXTkBBn",13) == 2704757189) strcat(s, "n");
if (crc32("hlDyHLsAL",9) == 1667358334) strcat(s, "g");
if (crc32("uvkFPTHuGad",11) == 3978684931) strcat(s, "e");
if (crc32("dbOmU",5) == 1468375009) strcat(s, "a");
if (crc32("CbcUaqiPYVforIM",15) == 1010759397) strcat(s, "r");
if (crc32("dOJkERmB",8) == 1217559657) strcat(s, "i");
if (crc32("hWebNWvrWhMwAA",14) == 1303861789) strcat(s, "n");
if (crc32("DQYrwvaZxnTalZa",15) == 3762374967) strcat(s, "R");
if (crc32("XmnBGZwyTROLYs",14) == 1245773610) strcat(s, "g");
if (crc32("myQsJl",6) == 2474688827) strcat(s, "d");
if (crc32("amZHFl",6) == 735459566) strcat(s, "l");
if (crc32("CBytNqNROo",10) == 2405696369) strcat(s, "P");
if (crc32("lamVv",5) == 217222047) strcat(s, "y");
    return s;
}

char *correctly_adverbs() {
    char *s = calloc(10);
    if (crc32("EQwikwOdE",9) == 1907459150) strcat(s, "U");
if (crc32("EwLvUUrbFNMAcl",14) == 1229719307) strcat(s, "c");
if (crc32("djnHciOVLJvax",13) == 1436867289) strcat(s, "o");
if (crc32("yqamYy",6) == 354764545) strcat(s, "H");
if (crc32("sOtadFrYeayT",12) == 244241985) strcat(s, "r");
if (crc32("TJonfDRwjL",10) == 1796206279) strcat(s, "W");
if (crc32("SOFepUQnUtNo",12) == 3496047638) strcat(s, "r");
if (crc32("SkkmPYkgnoEFi",13) == 2956498380) strcat(s, "e");
if (crc32("CKlauDjWH",9) == 396813227) strcat(s, "c");
if (crc32("XTQSyxpRgJwllZ",14) == 1645883567) strcat(s, "Z");
if (crc32("qiqmeJtbLJ",10) == 2951435015) strcat(s, "t");
if (crc32("fDJnV",5) == 3227320420) strcat(s, "l");
if (crc32("fTgwujkPqMtK",12) == 405166697) strcat(s, "R");
if (crc32("SgIAFgudInGEvG",14) == 2628311845) strcat(s, "y");
    return s;
}

char *overlearnedly_adverbs() {
    char *s = calloc(14);
    if (crc32("tfHHpUwP",8) == 613109847) strcat(s, "o");
if (crc32("VHNtnqYZYURzE",13) == 1902491761) strcat(s, "v");
if (crc32("tTsBQjcRrUdqR",13) == 3952055266) strcat(s, "e");
if (crc32("RqwmVAoloJLgJxr",15) == 1129009768) strcat(s, "G");
if (crc32("eBiTuh",6) == 4151471711) strcat(s, "r");
if (crc32("OLMHC",5) == 3121543997) strcat(s, "a");
if (crc32("UEnASjhnCKFzJg",14) == 3746272760) strcat(s, "l");
if (crc32("iaoSzRIOho",10) == 1102119638) strcat(s, "Q");
if (crc32("xdkZQCUTQ",9) == 4184468589) strcat(s, "e");
if (crc32("FJzIhwUOqymBvw",14) == 306194592) strcat(s, "C");
if (crc32("iNihWSYSmSE",11) == 1684005342) strcat(s, "a");
if (crc32("HeJhS",5) == 2148665939) strcat(s, "r");
if (crc32("wGXDcCf",7) == 2415914429) strcat(s, "n");
if (crc32("NCPKyw",6) == 1254692140) strcat(s, "Z");
if (crc32("hMwKsgJQRPA",11) == 2000302545) strcat(s, "e");
if (crc32("JjgJCaDlLoW",11) == 500733124) strcat(s, "d");
if (crc32("gqVpyXDd",8) == 2084837679) strcat(s, "l");
if (crc32("lkhhT",5) == 4045534089) strcat(s, "y");
    return s;
}

char *discernably_adverbs() {
    char *s = calloc(12);
    if (crc32("XtwFvdQqa",9) == 1416513467) strcat(s, "d");
if (crc32("PAFMakUPzCWYlcI",15) == 3515615553) strcat(s, "Z");
if (crc32("JuvRpJtPUVfGVs",14) == 487910390) strcat(s, "i");
if (crc32("YighjdLkbzaTk",13) == 978557181) strcat(s, "G");
if (crc32("mBuigWKYmjlFx",13) == 3188845978) strcat(s, "s");
if (crc32("uIbQPNLhQgE",11) == 586983251) strcat(s, "z");
if (crc32("QFHdfAXLDXe",11) == 3172102079) strcat(s, "c");
if (crc32("XvsKspF",7) == 1149081611) strcat(s, "e");
if (crc32("xWSrNTJXtVAyP",13) == 941541191) strcat(s, "f");
if (crc32("OFVvidwwhFaah",13) == 3685060896) strcat(s, "r");
if (crc32("enOzYvUirsr",11) == 604809685) strcat(s, "k");
if (crc32("WCGttksWrUSS",12) == 3274630486) strcat(s, "n");
if (crc32("jIcOo",5) == 331470140) strcat(s, "a");
if (crc32("moZkPmb",7) == 3735668415) strcat(s, "w");
if (crc32("rHxOuFzg",8) == 4019320565) strcat(s, "b");
if (crc32("ZlJsTAoFxOrW",12) == 2544572094) strcat(s, "l");
if (crc32("WHHBSqxjpSnZJoZ",15) == 3876318091) strcat(s, "P");
if (crc32("YDRhASSDYFqcd",13) == 504937181) strcat(s, "y");
    return s;
}

char *beforetime_adverbs() {
    char *s = calloc(11);
    if (crc32("jiNPBWfqIVOx",12) == 1790467329) strcat(s, "D");
if (crc32("lxEZjx",6) == 192658630) strcat(s, "b");
if (crc32("pRnHRGdypx",10) == 794766799) strcat(s, "C");
if (crc32("IcrWQxLZ",8) == 3679847946) strcat(s, "e");
if (crc32("EhuCElWHv",9) == 1330173973) strcat(s, "f");
if (crc32("oSheVhuFSfsfOQt",15) == 2589088135) strcat(s, "o");
if (crc32("wkviq",5) == 2729852518) strcat(s, "r");
if (crc32("mBcQbjSGNDUk",12) == 3502288991) strcat(s, "e");
if (crc32("FDFrsXpj",8) == 4193951357) strcat(s, "t");
if (crc32("lGXlPQ",6) == 1142834567) strcat(s, "U");
if (crc32("JaziCkcP",8) == 649971460) strcat(s, "i");
if (crc32("KlsiiaC",7) == 2957684599) strcat(s, "w");
if (crc32("WXztWlxOaRhgBOm",15) == 78514818) strcat(s, "m");
if (crc32("pByigOeww",9) == 595540178) strcat(s, "e");
    return s;
}

char *tawdrily_adverbs() {
    char *s = calloc(9);
    if (crc32("zbVkfkDTgZI",11) == 2508349483) strcat(s, "R");
if (crc32("FtIHBtsVWuxJvf",14) == 2828887147) strcat(s, "t");
if (crc32("pwcrurRvN",9) == 1001847505) strcat(s, "a");
if (crc32("dYGxzlrYFNMpy",13) == 329011871) strcat(s, "t");
if (crc32("hsUQMYN",7) == 2845712118) strcat(s, "w");
if (crc32("zrBOQYicf",9) == 2148520361) strcat(s, "l");
if (crc32("XbVqiVnmOw",10) == 1481911769) strcat(s, "d");
if (crc32("fYHcxlby",8) == 1764107559) strcat(s, "r");
if (crc32("AmhzfDFgkXyFf",13) == 3173088318) strcat(s, "N");
if (crc32("qRApG",5) == 3578508153) strcat(s, "i");
if (crc32("YLIRvVUAEE",10) == 3893845007) strcat(s, "R");
if (crc32("SarCh",5) == 4114848754) strcat(s, "l");
if (crc32("RAnrfsmhgmj",11) == 2327142373) strcat(s, "y");
    return s;
}

char *taxably_adverbs() {
    char *s = calloc(8);
    if (crc32("xjeYhJKNQXmK",12) == 1466081324) strcat(s, "N");
if (crc32("QXEWXNnXdQNLO",13) == 212428547) strcat(s, "t");
if (crc32("ZVhpeBERb",9) == 2121983484) strcat(s, "R");
if (crc32("GjhEXGFyvtf",11) == 2833937802) strcat(s, "a");
if (crc32("aPofnERnHxJTcX",14) == 573620987) strcat(s, "x");
if (crc32("QcbcJEzJj",9) == 1877012915) strcat(s, "P");
if (crc32("bdGbF",5) == 741721505) strcat(s, "a");
if (crc32("KyCZiUppMushSMg",15) == 3214013183) strcat(s, "b");
if (crc32("TrnglCiU",8) == 2051483799) strcat(s, "l");
if (crc32("ecwllRRLwlSPNea",15) == 3284930603) strcat(s, "y");
    return s;
}

char *existentialistically_adverbs() {
    char *s = calloc(21);
    if (crc32("IFdhMSfIwADTIz",14) == 2565807831) strcat(s, "e");
if (crc32("WllkSGjcg",9) == 1426581372) strcat(s, "e");
if (crc32("mYPpv",5) == 3948971910) strcat(s, "x");
if (crc32("svbgLMAPWLaW",12) == 3536600556) strcat(s, "i");
if (crc32("TFhyXS",6) == 3571195274) strcat(s, "s");
if (crc32("jIaitJoKvTl",11) == 349388318) strcat(s, "t");
if (crc32("QtcuDJJNCwLQI",13) == 407505595) strcat(s, "E");
if (crc32("IbApdKyZPZZVYWM",15) == 3505834101) strcat(s, "e");
if (crc32("WArpEeGfnbxJ",12) == 105161503) strcat(s, "r");
if (crc32("MbqtZQXIFvaCMSL",15) == 3200849640) strcat(s, "n");
if (crc32("wZqSlMCIlVVAR",13) == 2430171435) strcat(s, "t");
if (crc32("ychWqTpC",8) == 2049684751) strcat(s, "i");
if (crc32("XOajmNMP",8) == 2972519458) strcat(s, "k");
if (crc32("jdWqkz",6) == 1093616416) strcat(s, "a");
if (crc32("eHUDLoMPKOhA",12) == 1541661512) strcat(s, "l");
if (crc32("QSxYDykIgmIHA",13) == 2760123250) strcat(s, "l");
if (crc32("imQTsnkwzWqhGsF",15) == 3382586602) strcat(s, "Z");
if (crc32("WGyXbdffHkMR",12) == 4041982117) strcat(s, "i");
if (crc32("DedGW",5) == 339685498) strcat(s, "c");
if (crc32("cgemYnCX",8) == 107234381) strcat(s, "s");
if (crc32("qTTUYkkG",8) == 1163139864) strcat(s, "r");
if (crc32("UlQkAKZMvAr",11) == 3660997874) strcat(s, "t");
if (crc32("pXryOuLnI",9) == 844505728) strcat(s, "g");
if (crc32("BOYwDWf",7) == 1436884202) strcat(s, "i");
if (crc32("PlsbNpnHugq",11) == 808481265) strcat(s, "X");
if (crc32("bZKqpCpACiHyKIR",15) == 1333428651) strcat(s, "c");
if (crc32("mLBFzAUcD",9) == 3092586518) strcat(s, "o");
if (crc32("WXmqWT",6) == 2913562145) strcat(s, "a");
if (crc32("IniAJvh",7) == 2275205633) strcat(s, "H");
if (crc32("ZNJdvuOPkEwCGMw",15) == 2685368170) strcat(s, "l");
if (crc32("jgJgvTtNhAq",11) == 2630820837) strcat(s, "l");
if (crc32("kfUvqpG",7) == 3865262975) strcat(s, "y");
    return s;
}

char *depreciatingly_adverbs() {
    char *s = calloc(15);
    if (crc32("lTIRAJ",6) == 3016695580) strcat(s, "u");
if (crc32("wZnYDJTNICnI",12) == 4245109120) strcat(s, "d");
if (crc32("seLfTvqRxuJR",12) == 222715756) strcat(s, "e");
if (crc32("OYbXChtucZPthx",14) == 2558088521) strcat(s, "y");
if (crc32("qOwarPabVf",10) == 2390640456) strcat(s, "p");
if (crc32("yVvIXRJp",8) == 3071166949) strcat(s, "L");
if (crc32("tRNuGBpA",8) == 2787872228) strcat(s, "r");
if (crc32("icAtQIEelQEF",12) == 2470997313) strcat(s, "e");
if (crc32("tSCgXWzhPjhxK",13) == 1413450426) strcat(s, "c");
if (crc32("lWYWpTzYyIrQNi",14) == 3023775378) strcat(s, "T");
if (crc32("cKezM",5) == 3338960934) strcat(s, "i");
if (crc32("OsmaX",5) == 1012067492) strcat(s, "a");
if (crc32("qKDhwvKei",9) == 1950885502) strcat(s, "t");
if (crc32("gzkwWocmxcd",11) == 4219889105) strcat(s, "d");
if (crc32("ZxSQhKdtGKfj",12) == 3767236806) strcat(s, "i");
if (crc32("GuweDiZpl",9) == 769902566) strcat(s, "t");
if (crc32("szybxarpwvF",11) == 1619285895) strcat(s, "n");
if (crc32("PkquhXS",7) == 2148311257) strcat(s, "w");
if (crc32("MDhaovyjtH",10) == 3396089442) strcat(s, "g");
if (crc32("serXFvwUlbJlz",13) == 2451158818) strcat(s, "P");
if (crc32("IQvSrDRAjYEHqo",14) == 3789049060) strcat(s, "l");
if (crc32("wkcAxziFBtJP",12) == 2141879071) strcat(s, "Y");
if (crc32("kxAIMVcHncfC",12) == 1020864658) strcat(s, "y");
    return s;
}

char *oversocially_adverbs() {
    char *s = calloc(13);
    if (crc32("KjuOkDHGmHBOqy",14) == 1252915493) strcat(s, "o");
if (crc32("dITJxO",6) == 2808331390) strcat(s, "Y");
if (crc32("GGuVnxGXMahMWp",14) == 2589939507) strcat(s, "v");
if (crc32("FzjPwuVZISMK",12) == 1505316435) strcat(s, "R");
if (crc32("CiKkUgqerA",10) == 1839051735) strcat(s, "e");
if (crc32("SBlsMQacD",9) == 2602548049) strcat(s, "k");
if (crc32("qLyTddE",7) == 1472048381) strcat(s, "r");
if (crc32("HbLZJIKTmYXnV",13) == 188390392) strcat(s, "S");
if (crc32("sPuNFnAzdxHk",12) == 435431186) strcat(s, "s");
if (crc32("gCZIOjuYWTp",11) == 3318603205) strcat(s, "G");
if (crc32("jYejajcvPoIZma",14) == 1598943979) strcat(s, "o");
if (crc32("xsKDExkyxfS",11) == 1371071667) strcat(s, "c");
if (crc32("enyXNBSybPr",11) == 791318508) strcat(s, "i");
if (crc32("PEmyaydUIGS",11) == 3058652625) strcat(s, "a");
if (crc32("uqBzuxkKZTwtka",14) == 4051462424) strcat(s, "a");
if (crc32("AUirFqOawgj",11) == 1429230071) strcat(s, "l");
if (crc32("OyUbuCDZZGUXyA",14) == 3571994424) strcat(s, "E");
if (crc32("ODkjwZFtMIPlZP",14) == 335501146) strcat(s, "l");
if (crc32("NomVY",5) == 3666746347) strcat(s, "S");
if (crc32("mEmxAnLBjSB",11) == 1783963429) strcat(s, "y");
    return s;
}

char *moilingly_adverbs() {
    char *s = calloc(10);
    if (crc32("qjxvTuYl",8) == 1037658637) strcat(s, "E");
if (crc32("RPyIVeVif",9) == 2102934303) strcat(s, "m");
if (crc32("BURcazUsOFZfKsZ",15) == 2368911992) strcat(s, "W");
if (crc32("BWTseIm",7) == 3083732346) strcat(s, "o");
if (crc32("dlNwYzDEil",10) == 2666945595) strcat(s, "i");
if (crc32("AbShlSPhxjESL",13) == 4010576922) strcat(s, "L");
if (crc32("ijMLyakuJem",11) == 2313907198) strcat(s, "l");
if (crc32("xAiLrjqpDkwMDc",14) == 41118946) strcat(s, "i");
if (crc32("KDaTPTZmCZb",11) == 3742107955) strcat(s, "h");
if (crc32("qLRjGAn",7) == 2401037412) strcat(s, "n");
if (crc32("wiBLt",5) == 2163902941) strcat(s, "m");
if (crc32("LFStOVIfKe",10) == 3292845094) strcat(s, "g");
if (crc32("ASSwGZQPMFc",11) == 660484184) strcat(s, "L");
if (crc32("zSIjztYu",8) == 2906027657) strcat(s, "l");
if (crc32("CXDVzXkBHzifyG",14) == 640193379) strcat(s, "y");
    return s;
}

char *anaerobically_adverbs() {
    char *s = calloc(14);
    if (crc32("KvCcnOzj",8) == 297517675) strcat(s, "a");
if (crc32("iRyADSgXTAoq",12) == 3125905267) strcat(s, "X");
if (crc32("qOIjZbCYdXnF",12) == 4232190951) strcat(s, "n");
if (crc32("iyFudEYXLMmAUI",14) == 536998143) strcat(s, "a");
if (crc32("EYZnlDD",7) == 2208010415) strcat(s, "E");
if (crc32("cMowupy",7) == 765653720) strcat(s, "e");
if (crc32("uEtpUPO",7) == 762032304) strcat(s, "r");
if (crc32("oMaGJw",6) == 3669739751) strcat(s, "o");
if (crc32("zhFylG",6) == 1253933436) strcat(s, "X");
if (crc32("ecJNhGrIDHRZs",13) == 1962964092) strcat(s, "b");
if (crc32("lFqvToKMWJzL",12) == 440493086) strcat(s, "i");
if (crc32("adwDRJ",6) == 2905425841) strcat(s, "r");
if (crc32("zGyoLh",6) == 3148972341) strcat(s, "c");
if (crc32("ougtaI",6) == 4132553779) strcat(s, "r");
if (crc32("AGFLM",5) == 2244225590) strcat(s, "a");
if (crc32("pRFMpIHYcwecpSk",15) == 3705605310) strcat(s, "l");
if (crc32("eimUXkm",7) == 3197548903) strcat(s, "t");
if (crc32("sWXCIZ",6) == 1613206885) strcat(s, "l");
if (crc32("WwaHLhPd",8) == 3746005356) strcat(s, "y");
    return s;
}

char *nowhence_adverbs() {
    char *s = calloc(9);
    if (crc32("isYuxE",6) == 739019246) strcat(s, "j");
if (crc32("IcetQd",6) == 4051237235) strcat(s, "n");
if (crc32("HBmGUHuI",8) == 3445992915) strcat(s, "o");
if (crc32("WsUWlyob",8) == 269410402) strcat(s, "v");
if (crc32("JMykAyywpBrDoi",14) == 2358613784) strcat(s, "w");
if (crc32("bjClW",5) == 3597740137) strcat(s, "A");
if (crc32("mgWFEkJ",7) == 820087882) strcat(s, "h");
if (crc32("VmcUbBftfmjxtq",14) == 3883574006) strcat(s, "e");
if (crc32("BBysDdaYNiUYOP",14) == 1812466798) strcat(s, "n");
if (crc32("kJBkTVqUcllPzP",14) == 1806596467) strcat(s, "y");
if (crc32("hugIFltTDrtqC",13) == 3214240171) strcat(s, "c");
if (crc32("yBMGG",5) == 3724469630) strcat(s, "R");
if (crc32("CrGkUcF",7) == 327800977) strcat(s, "e");
    return s;
}

char *indicially_adverbs() {
    char *s = calloc(11);
    if (crc32("mNntgzYpdM",10) == 3280665) strcat(s, "O");
if (crc32("doMzgMvZibRg",12) == 2607341306) strcat(s, "i");
if (crc32("FPUOJcFg",8) == 2105741835) strcat(s, "D");
if (crc32("sqjTmJOnC",9) == 224572577) strcat(s, "n");
if (crc32("AhxLOyCM",8) == 4125851699) strcat(s, "h");
if (crc32("APgodoIMVY",10) == 2944362310) strcat(s, "d");
if (crc32("LBKolorMbKR",11) == 1312352997) strcat(s, "R");
if (crc32("orPoTsacKe",10) == 4225246698) strcat(s, "i");
if (crc32("ykhlmk",6) == 3328310116) strcat(s, "c");
if (crc32("OusBcn",6) == 2102203039) strcat(s, "x");
if (crc32("dBNLWgYbqqvs",12) == 2301114616) strcat(s, "i");
if (crc32("qkPEJitl",8) == 2886488257) strcat(s, "a");
if (crc32("DqRUS",5) == 2409554047) strcat(s, "n");
if (crc32("AKQlkQGEzyA",11) == 1447877233) strcat(s, "l");
if (crc32("trzkUVFxe",9) == 2625172004) strcat(s, "P");
if (crc32("pIMZqbOiX",9) == 1466238135) strcat(s, "l");
if (crc32("PVHukaPsjt",10) == 558354280) strcat(s, "e");
if (crc32("AGRois",6) == 3232319343) strcat(s, "y");
    return s;
}

char *soberingly_adverbs() {
    char *s = calloc(11);
    if (crc32("MztJheFjcpogWcR",15) == 2407404774) strcat(s, "b");
if (crc32("JzCBJ",5) == 4135141789) strcat(s, "s");
if (crc32("rJADcSWXaChQSt",14) == 3384452061) strcat(s, "s");
if (crc32("WTjUC",5) == 1697090558) strcat(s, "o");
if (crc32("XSsgyGRSMSBuqzJ",15) == 799519569) strcat(s, "b");
if (crc32("yZQPNQbTRIQx",12) == 2928166225) strcat(s, "e");
if (crc32("ZiiGqhIfmup",11) == 1072204740) strcat(s, "J");
if (crc32("ZmcZmYrmIgUAReY",15) == 1506915599) strcat(s, "r");
if (crc32("UxIIZNmIUpl",11) == 4112387671) strcat(s, "e");
if (crc32("GbVAZmHSjOclz",13) == 2550172077) strcat(s, "i");
if (crc32("RQrMfraucXvHkV",14) == 1469404392) strcat(s, "c");
if (crc32("pQFMdrC",7) == 3038351788) strcat(s, "n");
if (crc32("sljysYARzdU",11) == 2463114320) strcat(s, "m");
if (crc32("PihqBJLVysxpTBG",15) == 722792668) strcat(s, "g");
if (crc32("ILLVnfyImxHXkd",14) == 3770546126) strcat(s, "z");
if (crc32("BlPYaXBmzrPAWzz",15) == 578253595) strcat(s, "l");
if (crc32("HRHOchiQMur",11) == 40979433) strcat(s, "y");
    return s;
}

char *semiofficially_adverbs() {
    char *s = calloc(15);
    if (crc32("YwteHgSW",8) == 2957248892) strcat(s, "s");
if (crc32("VACppBfheBrwhG",14) == 3495441672) strcat(s, "e");
if (crc32("ZpzpNlYhO",9) == 4174761195) strcat(s, "S");
if (crc32("aHNsKtgPLParMed",15) == 3991935990) strcat(s, "m");
if (crc32("bdBflEAqNolFBe",14) == 852346588) strcat(s, "i");
if (crc32("OfRkyDpV",8) == 1229562643) strcat(s, "B");
if (crc32("FqKaKCOMaftIBA",14) == 108379901) strcat(s, "o");
if (crc32("EIHefNw",7) == 1508144069) strcat(s, "l");
if (crc32("cSeSGNaqOAuz",12) == 3650427752) strcat(s, "f");
if (crc32("nREPyBHvBeJ",11) == 4123874236) strcat(s, "f");
if (crc32("aNWBqbMSSdCEtAy",15) == 2984062320) strcat(s, "i");
if (crc32("gBmLqcrRI",9) == 2610567570) strcat(s, "g");
if (crc32("pSReXwyzqAId",12) == 3962224018) strcat(s, "c");
if (crc32("ITDcO",5) == 143529129) strcat(s, "i");
if (crc32("uwDCAWbt",8) == 1765769142) strcat(s, "a");
if (crc32("aQahqJTmuc",10) == 2794458253) strcat(s, "p");
if (crc32("wytvfqsF",8) == 2360732808) strcat(s, "l");
if (crc32("ZjwnHTCJX",9) == 2731429482) strcat(s, "K");
if (crc32("veQvVO",6) == 337931700) strcat(s, "l");
if (crc32("NNbTtGLnOyYv",12) == 1634970201) strcat(s, "y");
    return s;
}

char *indefinitely_adverbs() {
    char *s = calloc(13);
    if (crc32("PpAalU",6) == 4234827268) strcat(s, "i");
if (crc32("KjqJciy",7) == 2506346472) strcat(s, "n");
if (crc32("YkRGoq",6) == 339014393) strcat(s, "R");
if (crc32("icIESSHYgHCcUAJ",15) == 2472662313) strcat(s, "d");
if (crc32("PRmWv",5) == 2477176854) strcat(s, "e");
if (crc32("IAVgoCipaTMZBoy",15) == 2933388731) strcat(s, "f");
if (crc32("nhlWeJDIS",9) == 926308235) strcat(s, "I");
if (crc32("tMkZv",5) == 515798244) strcat(s, "i");
if (crc32("cfZgPLyFPFgsR",13) == 874137196) strcat(s, "n");
if (crc32("IySJLZEbnY",10) == 4016794319) strcat(s, "U");
if (crc32("TAtPPRCqftnON",13) == 474034143) strcat(s, "i");
if (crc32("StcbtcRDgtG",11) == 2898811621) strcat(s, "t");
if (crc32("nWEfdtEHc",9) == 653349223) strcat(s, "e");
if (crc32("qLHagnQdVDR",11) == 490711166) strcat(s, "e");
if (crc32("OxVFYJaqISA",11) == 2773139339) strcat(s, "l");
if (crc32("fGwmuavtYWfgA",13) == 2869164258) strcat(s, "y");
    return s;
}

char *patronisingly_adverbs() {
    char *s = calloc(14);
    if (crc32("DmYMDGCWRA",10) == 1893796616) strcat(s, "V");
if (crc32("feFJsZNRJnQds",13) == 2450891104) strcat(s, "p");
if (crc32("uolADphaw",9) == 120539525) strcat(s, "M");
if (crc32("ZdeHeMhDkZ",10) == 3744516601) strcat(s, "a");
if (crc32("snigclVS",8) == 378511030) strcat(s, "p");
if (crc32("nxiGuiXN",8) == 1108161197) strcat(s, "t");
if (crc32("VHuSsoQIF",9) == 363161401) strcat(s, "x");
if (crc32("pFFDsaBc",8) == 3165694530) strcat(s, "r");
if (crc32("USYZNqURaEIcK",13) == 1739193744) strcat(s, "M");
if (crc32("QxTZyiLDHTjYU",13) == 40761567) strcat(s, "o");
if (crc32("ibuJJ",5) == 1894289417) strcat(s, "H");
if (crc32("DgGwaUxLrY",10) == 2912982055) strcat(s, "n");
if (crc32("pYzIQOY",7) == 294165158) strcat(s, "c");
if (crc32("tDTeqfHd",8) == 3591877522) strcat(s, "i");
if (crc32("FopxwXjWsPYPj",13) == 337058138) strcat(s, "l");
if (crc32("MZLNwNq",7) == 3945474020) strcat(s, "s");
if (crc32("aQBnhGWeumw",11) == 4190763800) strcat(s, "i");
if (crc32("ikBYZARKxxSj",12) == 2030225175) strcat(s, "n");
if (crc32("dqGneiqdYnQa",12) == 1776055337) strcat(s, "T");
if (crc32("ixiIKg",6) == 2930063564) strcat(s, "g");
if (crc32("zbqAZltP",8) == 607359204) strcat(s, "l");
if (crc32("iLeOOslEOHix",12) == 2091556588) strcat(s, "N");
if (crc32("XKMQrfAhVlvHBPr",15) == 365056332) strcat(s, "y");
    return s;
}

char *unloathly_adverbs() {
    char *s = calloc(10);
    if (crc32("FSZmdWuKiovdr",13) == 2776809063) strcat(s, "U");
if (crc32("bndhWE",6) == 3543155358) strcat(s, "u");
if (crc32("oyInrHRIXKvf",12) == 1887719034) strcat(s, "n");
if (crc32("SPUyCFCcb",9) == 397527483) strcat(s, "m");
if (crc32("AjGUzceuDyqI",12) == 3195858156) strcat(s, "l");
if (crc32("aQpUwq",6) == 825063803) strcat(s, "o");
if (crc32("yGLLTgPCfh",10) == 2118626286) strcat(s, "n");
if (crc32("iDWPtGhUSovwquR",15) == 3524517361) strcat(s, "a");
if (crc32("TrhfGbOaOZlDZ",13) == 1098594258) strcat(s, "t");
if (crc32("mneQim",6) == 3306224310) strcat(s, "h");
if (crc32("NmmSrvQqvUciKHF",15) == 930218238) strcat(s, "g");
if (crc32("iOtEFjwKw",9) == 2931567357) strcat(s, "l");
if (crc32("wlUEJGPrHPZQfyf",15) == 3899341818) strcat(s, "y");
    return s;
}

char *nonadverbially_adverbs() {
    char *s = calloc(15);
    if (crc32("hkDWIjEIxckPE",13) == 719144919) strcat(s, "n");
if (crc32("XNkbgDDhNWwhy",13) == 2250537143) strcat(s, "o");
if (crc32("uKdBztd",7) == 283008679) strcat(s, "n");
if (crc32("mohiJy",6) == 2215714031) strcat(s, "n");
if (crc32("ZqrVEeEzglSmS",13) == 933707062) strcat(s, "a");
if (crc32("AMgOGlXkOkxsl",13) == 3023267171) strcat(s, "d");
if (crc32("tUBJpdDSoJ",10) == 2067751769) strcat(s, "X");
if (crc32("zWmxy",5) == 2913622653) strcat(s, "v");
if (crc32("KIAQEOrCsWVI",12) == 2802554792) strcat(s, "r");
if (crc32("hKizsRAOIqRWCzH",15) == 711226375) strcat(s, "e");
if (crc32("GXUMo",5) == 3504731603) strcat(s, "r");
if (crc32("SpBrEvjCaxCRMd",14) == 524118317) strcat(s, "v");
if (crc32("VCnTqqjyJY",10) == 2972894186) strcat(s, "b");
if (crc32("ztnFqK",6) == 1877829862) strcat(s, "i");
if (crc32("TcHqYawvWTck",12) == 1240035726) strcat(s, "a");
if (crc32("UXnmowdvkMAjMey",15) == 3359351578) strcat(s, "x");
if (crc32("JgsHiQlvDxRMBzk",15) == 259517634) strcat(s, "l");
if (crc32("EBJMN",5) == 3465733467) strcat(s, "l");
if (crc32("paVxzeXFRdIo",12) == 2916385558) strcat(s, "U");
if (crc32("bLNascPDFmdW",12) == 2601983543) strcat(s, "y");
    return s;
}

char *graphically_adverbs() {
    char *s = calloc(12);
    if (crc32("PhIAWPCAFj",10) == 3014585836) strcat(s, "g");
if (crc32("fJoDkG",6) == 122399002) strcat(s, "r");
if (crc32("SNCOrFdZHPCKDb",14) == 1511583086) strcat(s, "a");
if (crc32("iqgsNoKnevqIbD",14) == 1184401471) strcat(s, "j");
if (crc32("oQTQWCBQoxuK",12) == 2868336580) strcat(s, "p");
if (crc32("OpNsgseLQizQP",13) == 1102762564) strcat(s, "h");
if (crc32("bGoyahyN",8) == 3521620159) strcat(s, "i");
if (crc32("mJCQNxOQ",8) == 604652608) strcat(s, "U");
if (crc32("BIsexJ",6) == 3771231541) strcat(s, "c");
if (crc32("aOnaUKOBfWIjq",13) == 2574453475) strcat(s, "a");
if (crc32("qoaIKPQLCAQIxI",14) == 2546380703) strcat(s, "l");
if (crc32("EzvJGr",6) == 1868561558) strcat(s, "l");
if (crc32("TrlONbeMxVelpk",14) == 4196752877) strcat(s, "y");
    return s;
}

char *woefully_adverbs() {
    char *s = calloc(9);
    if (crc32("URIowf",6) == 3463058618) strcat(s, "w");
if (crc32("JjlzwVOFBM",10) == 1995795737) strcat(s, "k");
if (crc32("FwHYZZ",6) == 3574996180) strcat(s, "o");
if (crc32("WoSleab",7) == 1631071596) strcat(s, "S");
if (crc32("gUXJmdOzRWEzrN",14) == 219758036) strcat(s, "e");
if (crc32("XMeekHkCXMOjoPd",15) == 3830421871) strcat(s, "T");
if (crc32("ZKTdNcquVHKM",12) == 361368746) strcat(s, "f");
if (crc32("lyjpPfzNTYwbnjj",15) == 1434361835) strcat(s, "c");
if (crc32("YaoavUj",7) == 1252453034) strcat(s, "u");
if (crc32("qRIXwG",6) == 1058713809) strcat(s, "l");
if (crc32("YuFAYPkDPCScMBP",15) == 1345951548) strcat(s, "m");
if (crc32("mBcJW",5) == 597017334) strcat(s, "l");
if (crc32("RsHkKgDuUIWOtIR",15) == 2680734811) strcat(s, "y");
    return s;
}

char *unaspiringly_adverbs() {
    char *s = calloc(13);
    if (crc32("NlWPJHNckOvypSm",15) == 238112193) strcat(s, "u");
if (crc32("ZsFYX",5) == 3084247468) strcat(s, "n");
if (crc32("LhwSIzdAKTD",11) == 2712673166) strcat(s, "W");
if (crc32("FccRgGWUZta",11) == 656832071) strcat(s, "a");
if (crc32("WkvATNJzKgWQEg",14) == 1004246256) strcat(s, "j");
if (crc32("PRdWuT",6) == 476476864) strcat(s, "s");
if (crc32("LKzBQ",5) == 2423340042) strcat(s, "p");
if (crc32("WMHWyGEzV",9) == 2082338335) strcat(s, "v");
if (crc32("SwxQn",5) == 473023361) strcat(s, "i");
if (crc32("RUmho",5) == 3473873918) strcat(s, "K");
if (crc32("XDtpDpCcIQjMTQ",14) == 3628795209) strcat(s, "r");
if (crc32("LgqBXXq",7) == 2836851881) strcat(s, "c");
if (crc32("tUrsXyz",7) == 252848970) strcat(s, "i");
if (crc32("URInA",5) == 3181082682) strcat(s, "L");
if (crc32("WHsFMzTzmFqI",12) == 3049868457) strcat(s, "n");
if (crc32("WkjxH",5) == 2358231786) strcat(s, "Z");
if (crc32("qQlvVMnjyRR",11) == 84376747) strcat(s, "g");
if (crc32("CjKjvWHANpLWhDb",15) == 3319632561) strcat(s, "X");
if (crc32("HJQBHcCTdpYZ",12) == 3689171175) strcat(s, "l");
if (crc32("wnLOL",5) == 260070032) strcat(s, "J");
if (crc32("AHEZPXkYpbE",11) == 1068247266) strcat(s, "y");
    return s;
}

char *unvainly_adverbs() {
    char *s = calloc(9);
    if (crc32("dcVZFnra",8) == 506804162) strcat(s, "E");
if (crc32("NLHTNJYLeN",10) == 398940039) strcat(s, "u");
if (crc32("KAIWPWSlXFRaA",13) == 3969449017) strcat(s, "n");
if (crc32("YOqosIGajVIup",13) == 178246646) strcat(s, "q");
if (crc32("bWmtaZI",7) == 326161207) strcat(s, "v");
if (crc32("RKbNDKzR",8) == 3133611664) strcat(s, "P");
if (crc32("VeDpm",5) == 371624776) strcat(s, "a");
if (crc32("lPLvYvwmX",9) == 2574729259) strcat(s, "I");
if (crc32("lhniWrNSFPgce",13) == 3732255015) strcat(s, "i");
if (crc32("rSbfFqY",7) == 3250239554) strcat(s, "n");
if (crc32("ZvTOwdHAFKoU",12) == 918533874) strcat(s, "C");
if (crc32("YGwomLUdG",9) == 4176722415) strcat(s, "l");
if (crc32("JXTEcJhlb",9) == 4150954403) strcat(s, "Y");
if (crc32("rPUDok",6) == 2088687510) strcat(s, "y");
    return s;
}

char *garrulously_adverbs() {
    char *s = calloc(12);
    if (crc32("gvRxOoB",7) == 801599280) strcat(s, "A");
if (crc32("VarZUNaKGFVo",12) == 2320023546) strcat(s, "g");
if (crc32("ltRSNOU",7) == 3427196068) strcat(s, "a");
if (crc32("QjYTsnroM",9) == 1713808390) strcat(s, "P");
if (crc32("OKmSJD",6) == 3162434931) strcat(s, "r");
if (crc32("skjThZlVL",9) == 3318421630) strcat(s, "r");
if (crc32("oHVeZ",5) == 2028278361) strcat(s, "u");
if (crc32("mKKqzTUrz",9) == 2298698903) strcat(s, "l");
if (crc32("YVSIMPhVboqdbWe",15) == 1553456138) strcat(s, "W");
if (crc32("xxxTruJoO",9) == 1017637781) strcat(s, "o");
if (crc32("nOunReL",7) == 1526257527) strcat(s, "u");
if (crc32("bhylKKiDCxBonF",14) == 1837226689) strcat(s, "H");
if (crc32("iKsCbHr",7) == 485919608) strcat(s, "s");
if (crc32("UKgrOEVA",8) == 4028040081) strcat(s, "l");
if (crc32("GCHKNTA",7) == 1385584535) strcat(s, "Y");
if (crc32("JdhAKNwpkhH",11) == 1204973394) strcat(s, "y");
    return s;
}

char *askew_adverbs() {
    char *s = calloc(6);
    if (crc32("URWenHirsFPNN",13) == 149461536) strcat(s, "a");
if (crc32("ctpfW",5) == 1857334637) strcat(s, "s");
if (crc32("XBeHK",5) == 982470399) strcat(s, "e");
if (crc32("rYFBBsTgnfjkj",13) == 2517479802) strcat(s, "k");
if (crc32("uNnpOFHHMlbE",12) == 1604460022) strcat(s, "j");
if (crc32("OzYdLpTqxcq",11) == 3768970464) strcat(s, "e");
if (crc32("YzdiPjMSqwkGXs",14) == 2708274992) strcat(s, "w");
    return s;
}

char *halfjokingly_adverbs() {
    char *s = calloc(13);
    if (crc32("XgyxoSkOq",9) == 3180802631) strcat(s, "h");
if (crc32("RXkCAxobq",9) == 3293169896) strcat(s, "a");
if (crc32("mKQEyk",6) == 1486326233) strcat(s, "c");
if (crc32("FXxNOLzDuEvlLxz",15) == 3545766752) strcat(s, "l");
if (crc32("tylcUUnHCUReysO",15) == 2952324154) strcat(s, "o");
if (crc32("scwFYmdcaSHI",12) == 1863661713) strcat(s, "f");
if (crc32("uHmyhfnyaCBtE",13) == 2371307844) strcat(s, "P");
if (crc32("YZQsXqreNoY",11) == 1422685266) strcat(s, "j");
if (crc32("hHwolrRMcWxPM",13) == 1489590802) strcat(s, "B");
if (crc32("qIPelgLi",8) == 3722298092) strcat(s, "o");
if (crc32("yWmEUUic",8) == 3793140369) strcat(s, "k");
if (crc32("VeeFpHprTRMV",12) == 2891580674) strcat(s, "i");
if (crc32("XQXiZ",5) == 3689181097) strcat(s, "q");
if (crc32("YogOwuOLHVEKI",13) == 2606877372) strcat(s, "n");
if (crc32("JWrMWaBNZvyNw",13) == 4144034399) strcat(s, "v");
if (crc32("ABnlcSD",7) == 3234100516) strcat(s, "g");
if (crc32("ZmJrjsptY",9) == 994911216) strcat(s, "j");
if (crc32("qvjOzoA",7) == 2686789202) strcat(s, "l");
if (crc32("MyrmGsVCOsMFwZ",14) == 235475908) strcat(s, "A");
if (crc32("WfjHiKCjisMQW",13) == 403321256) strcat(s, "y");
    return s;
}

char *anticipatively_adverbs() {
    char *s = calloc(15);
    if (crc32("PIrgDlSSqy",10) == 2599647794) strcat(s, "g");
if (crc32("jSBqJGOOANUZGOm",15) == 3237679820) strcat(s, "a");
if (crc32("YOcIQjyQAXf",11) == 1487714887) strcat(s, "n");
if (crc32("uliSJn",6) == 1859727000) strcat(s, "y");
if (crc32("fwIKVVBZK",9) == 1352179825) strcat(s, "t");
if (crc32("vQvZVIUB",8) == 3948213079) strcat(s, "i");
if (crc32("hoVFUYeRfP",10) == 4268195887) strcat(s, "R");
if (crc32("gjIxmi",6) == 796005348) strcat(s, "c");
if (crc32("IxqHvdDcrbnavsC",15) == 3490215812) strcat(s, "i");
if (crc32("tIcSdJa",7) == 3586869390) strcat(s, "p");
if (crc32("lhmXZq",6) == 315989886) strcat(s, "e");
if (crc32("WgRhhgphh",9) == 3489036217) strcat(s, "a");
if (crc32("FRhjw",5) == 2397506358) strcat(s, "k");
if (crc32("xpgmntrhZzLwyE",14) == 671021554) strcat(s, "t");
if (crc32("gzUgO",5) == 3807791019) strcat(s, "K");
if (crc32("RTgfwHTxJSM",11) == 2550532634) strcat(s, "i");
if (crc32("ApMiEMAZ",8) == 4258115981) strcat(s, "v");
if (crc32("yEfBJyyoCAmHg",13) == 1821073323) strcat(s, "v");
if (crc32("fMKWozychro",11) == 928002911) strcat(s, "e");
if (crc32("zPLXUiwE",8) == 3598950538) strcat(s, "l");
if (crc32("zwzMPDliGRtuK",13) == 3863876204) strcat(s, "Q");
if (crc32("ihrgCbNZg",9) == 473668161) strcat(s, "y");
    return s;
}

char *adrift_adverbs() {
    char *s = calloc(7);
    if (crc32("IEOkOCA",7) == 111206301) strcat(s, "Y");
if (crc32("BvzPuDGiLEiMKJ",14) == 548865554) strcat(s, "a");
if (crc32("iDgzeXJ",7) == 2456552334) strcat(s, "d");
if (crc32("UfekfTJwSchS",12) == 1725178588) strcat(s, "r");
if (crc32("xDobV",5) == 2378097280) strcat(s, "i");
if (crc32("GijFSVgsNxmOjDr",15) == 3105173508) strcat(s, "t");
if (crc32("eftvo",5) == 2116928970) strcat(s, "f");
if (crc32("hUNQK",5) == 2870567110) strcat(s, "t");
    return s;
}

char *wholesomely_adverbs() {
    char *s = calloc(12);
    if (crc32("dtRtgjxnxLNMtj",14) == 3930598371) strcat(s, "j");
if (crc32("mIHlBnXeJodIg",13) == 4253157712) strcat(s, "w");
if (crc32("jvfaeLkgyFM",11) == 1078658779) strcat(s, "d");
if (crc32("jTMKTVibXkyGZoe",15) == 1474864773) strcat(s, "h");
if (crc32("lzywZITDgxcJqcw",15) == 3728383068) strcat(s, "f");
if (crc32("qjyjeR",6) == 1822826225) strcat(s, "o");
if (crc32("FVudtTNblBmJG",13) == 4210210098) strcat(s, "r");
if (crc32("klgcHiPpzVJ",11) == 2641541722) strcat(s, "l");
if (crc32("ZEjCUuKGJn",10) == 609283402) strcat(s, "q");
if (crc32("PiewbJP",7) == 483844470) strcat(s, "e");
if (crc32("VzGElfsKC",9) == 3070885899) strcat(s, "h");
if (crc32("RcuPZkjfIW",10) == 1935804418) strcat(s, "s");
if (crc32("aYFSaW",6) == 460062571) strcat(s, "C");
if (crc32("bddydN",6) == 3890032576) strcat(s, "o");
if (crc32("FgNmV",5) == 2671760559) strcat(s, "m");
if (crc32("rMccAwJU",8) == 2650304045) strcat(s, "e");
if (crc32("eJMCNWuG",8) == 420425233) strcat(s, "l");
if (crc32("AEsOYBBQW",9) == 1287418252) strcat(s, "y");
    return s;
}

char *semblably_adverbs() {
    char *s = calloc(10);
    if (crc32("zzuKtVkWbesA",12) == 189926848) strcat(s, "h");
if (crc32("drgVsQnptTrBP",13) == 4073698323) strcat(s, "s");
if (crc32("XpbpmLkppXdr",12) == 2141158368) strcat(s, "e");
if (crc32("IpVfrkTSe",9) == 3234211590) strcat(s, "Z");
if (crc32("djhDVfGIzlOVXK",14) == 2671813039) strcat(s, "m");
if (crc32("RxzlVOQ",7) == 259618867) strcat(s, "b");
if (crc32("ieGiOZyzHYsiPNS",15) == 1089437433) strcat(s, "l");
if (crc32("gBpshKOZfoQFG",13) == 2570588426) strcat(s, "a");
if (crc32("qtBYsdmVapZYI",13) == 3816392980) strcat(s, "b");
if (crc32("TyGdoVB",7) == 3787575637) strcat(s, "f");
if (crc32("zNkAHrZ",7) == 3310501349) strcat(s, "l");
if (crc32("ZETpQf",6) == 2232717024) strcat(s, "b");
if (crc32("hwRyguVjVj",10) == 367583212) strcat(s, "y");
    return s;
}

char *mutably_adverbs() {
    char *s = calloc(8);
    if (crc32("HIFJdoTq",8) == 2341579441) strcat(s, "m");
if (crc32("pdLiISsZpqwXjqG",15) == 619231417) strcat(s, "T");
if (crc32("fUVzn",5) == 996672833) strcat(s, "u");
if (crc32("yQYyr",5) == 1657461492) strcat(s, "t");
if (crc32("JUXBgppDnCscqme",15) == 3189771589) strcat(s, "I");
if (crc32("ntNFxHJwuvqgNd",14) == 2367291974) strcat(s, "a");
if (crc32("TEmTelEuwYwYtZS",15) == 3826546992) strcat(s, "b");
if (crc32("NQPxshDCIExYD",13) == 944402511) strcat(s, "l");
if (crc32("UcCcFZwIzFfl",12) == 4245930787) strcat(s, "F");
if (crc32("qaXntqOGj",9) == 2300358760) strcat(s, "y");
    return s;
}

char *unsombrely_adverbs() {
    char *s = calloc(11);
    if (crc32("BZsewtbhAx",10) == 2787921843) strcat(s, "Z");
if (crc32("eCNlzsGbZSD",11) == 2445488631) strcat(s, "u");
if (crc32("TjARVtKCnbgW",12) == 3876655812) strcat(s, "k");
if (crc32("VFQrQQbvtJAdEZm",15) == 1272941527) strcat(s, "n");
if (crc32("zROSEundtVNHHu",14) == 1640781810) strcat(s, "s");
if (crc32("ojTzeRHwgArZ",12) == 2067071235) strcat(s, "o");
if (crc32("nlkwThabpH",10) == 2467378524) strcat(s, "o");
if (crc32("UxaSWiKAtfNt",12) == 2216143896) strcat(s, "n");
if (crc32("qRLvgyyijF",10) == 3883931902) strcat(s, "m");
if (crc32("CfNPungD",8) == 1655834882) strcat(s, "b");
if (crc32("rdymY",5) == 979994570) strcat(s, "j");
if (crc32("nuBRLXvJHMNMsmW",15) == 1874987284) strcat(s, "r");
if (crc32("HQqjhuFwbKaRn",13) == 1087365968) strcat(s, "e");
if (crc32("xSCjvniqbjZav",13) == 2789426055) strcat(s, "l");
if (crc32("LxEvwAldo",9) == 2673424691) strcat(s, "y");
    return s;
}

char *sempre_adverbs() {
    char *s = calloc(7);
    if (crc32("aKOsa",5) == 1795475418) strcat(s, "s");
if (crc32("MXDAmShBgXPatJ",14) == 2908650717) strcat(s, "e");
if (crc32("TQRDvkcpO",9) == 301583325) strcat(s, "q");
if (crc32("cljubJzePh",10) == 2017850878) strcat(s, "m");
if (crc32("rCQgwIx",7) == 4127916741) strcat(s, "G");
if (crc32("lvPIEIZUOsMP",12) == 3712689557) strcat(s, "p");
if (crc32("qnYcNbZPAVYWB",13) == 441654925) strcat(s, "r");
if (crc32("OuUNnudSmaJIvT",14) == 4237558370) strcat(s, "e");
    return s;
}

char *noneducationally_adverbs() {
    char *s = calloc(17);
    if (crc32("jQkuja",6) == 107242430) strcat(s, "n");
if (crc32("ZMsqLRCCuMJFfcf",15) == 845209381) strcat(s, "a");
if (crc32("QzbissGQOAtCBe",14) == 2227539610) strcat(s, "o");
if (crc32("MGDehuQBVTmnmS",14) == 2039272652) strcat(s, "n");
if (crc32("guvfLr",6) == 1976084789) strcat(s, "e");
if (crc32("OfMHhZO",7) == 3366331764) strcat(s, "F");
if (crc32("fedoxArVBmJUFE",14) == 3246287057) strcat(s, "d");
if (crc32("EPvTfOJq",8) == 2138962311) strcat(s, "u");
if (crc32("pNtDYrPmoNTYs",13) == 3140142037) strcat(s, "c");
if (crc32("HSraNTPaYjbC",12) == 2938149589) strcat(s, "E");
if (crc32("OvkRQfdRDoQ",11) == 3279317294) strcat(s, "a");
if (crc32("GkgFSuOUoLx",11) == 1144541002) strcat(s, "t");
if (crc32("NOcCLjJDQXpZ",12) == 3710061120) strcat(s, "i");
if (crc32("SRnJGOPf",8) == 3191095042) strcat(s, "x");
if (crc32("AjhOqftO",8) == 2738805894) strcat(s, "o");
if (crc32("EqHHeMrXEb",10) == 753185599) strcat(s, "m");
if (crc32("bAWdDgcblML",11) == 3249349215) strcat(s, "n");
if (crc32("nGWDQzlzYz",10) == 271462345) strcat(s, "d");
if (crc32("LhsPniqo",8) == 1631256076) strcat(s, "a");
if (crc32("ZliHdTIzMK",10) == 1526524000) strcat(s, "A");
if (crc32("DSRbkSzgAnS",11) == 4280540414) strcat(s, "l");
if (crc32("NBNVVbvJGLlTNPh",15) == 3624993209) strcat(s, "l");
if (crc32("IBoMUtIBM",9) == 2424279113) strcat(s, "y");
    return s;
}

char *unambiently_adverbs() {
    char *s = calloc(12);
    if (crc32("SWkxFFcGcQOV",12) == 1621127124) strcat(s, "p");
if (crc32("voJULzx",7) == 4150797390) strcat(s, "u");
if (crc32("qzGfrq",6) == 1062926877) strcat(s, "l");
if (crc32("JiPztmn",7) == 1205648849) strcat(s, "n");
if (crc32("CwqZylmc",8) == 232944527) strcat(s, "J");
if (crc32("DeTTSfKI",8) == 3264752626) strcat(s, "a");
if (crc32("PUwWGsHF",8) == 714494776) strcat(s, "m");
if (crc32("zAeoPL",6) == 4098499902) strcat(s, "b");
if (crc32("VqUlbCQYLfAA",12) == 310930067) strcat(s, "i");
if (crc32("EEmwT",5) == 3062672004) strcat(s, "e");
if (crc32("yDMKVSSYfttkYz",14) == 141024602) strcat(s, "Q");
if (crc32("EVALB",5) == 219264792) strcat(s, "n");
if (crc32("suYZaoAUzV",10) == 1338049726) strcat(s, "t");
if (crc32("RhUzESOS",8) == 1659511576) strcat(s, "l");
if (crc32("IoFoK",5) == 4167342566) strcat(s, "s");
if (crc32("aAwDTFaVCqg",11) == 1630622466) strcat(s, "y");
    return s;
}

char *eloquently_adverbs() {
    char *s = calloc(11);
    if (crc32("dhThGfyVDBDl",12) == 183174676) strcat(s, "e");
if (crc32("OrKoebPWvYhGv",13) == 3189026016) strcat(s, "l");
if (crc32("gIXlePkatlbh",12) == 1443091266) strcat(s, "o");
if (crc32("RXgJNM",6) == 1166808159) strcat(s, "q");
if (crc32("kbNLPsdqV",9) == 2083813137) strcat(s, "u");
if (crc32("ktXFfDj",7) == 2016091890) strcat(s, "t");
if (crc32("KhXtkRaQTQVBdM",14) == 367940606) strcat(s, "e");
if (crc32("rRMHjqH",7) == 944759278) strcat(s, "V");
if (crc32("ppkoeFNxgAu",11) == 2034436563) strcat(s, "n");
if (crc32("cZrXwQLoeTHRdiJ",15) == 187684570) strcat(s, "t");
if (crc32("flOkDaVEE",9) == 94308338) strcat(s, "G");
if (crc32("IwRIowICT",9) == 2334383516) strcat(s, "l");
if (crc32("yFVvcJEXAiwvnO",14) == 2513893439) strcat(s, "O");
if (crc32("xhoQvqQkxqAXU",13) == 1391440889) strcat(s, "y");
    return s;
}

char *quasieducationally_adverbs() {
    char *s = calloc(19);
    if (crc32("fHloKO",6) == 3229175813) strcat(s, "q");
if (crc32("vGXoMiq",7) == 271631848) strcat(s, "m");
if (crc32("uuMUKd",6) == 2168720730) strcat(s, "u");
if (crc32("cPxQzsACXyTax",13) == 186304271) strcat(s, "L");
if (crc32("WnhQjH",6) == 4071784740) strcat(s, "a");
if (crc32("crbgkxpGutJKj",13) == 109178560) strcat(s, "s");
if (crc32("bDxvEswk",8) == 2519243489) strcat(s, "i");
if (crc32("fXrNsjVsw",9) == 1154218714) strcat(s, "d");
if (crc32("rNUYvrdTFLrugr",14) == 3749335813) strcat(s, "e");
if (crc32("ZEDAL",5) == 4191215259) strcat(s, "d");
if (crc32("eYqZhdrAlctdS",13) == 4115918102) strcat(s, "u");
if (crc32("GXSAIitSmvs",11) == 1262217730) strcat(s, "c");
if (crc32("PJDDjEQM",8) == 1623374111) strcat(s, "a");
if (crc32("sAGaWKRPCguOVi",14) == 403003353) strcat(s, "h");
if (crc32("EZVersZbOmoNWik",15) == 1839405993) strcat(s, "t");
if (crc32("znTcYbirka",10) == 129720609) strcat(s, "w");
if (crc32("HhTjcKrHGam",11) == 2481590823) strcat(s, "i");
if (crc32("QHccMeS",7) == 719654851) strcat(s, "I");
if (crc32("czXizWX",7) == 183133425) strcat(s, "o");
if (crc32("nokQbXxzkk",10) == 356105994) strcat(s, "L");
if (crc32("txmcvM",6) == 436665472) strcat(s, "n");
if (crc32("xUXOOxnMDGeVrFT",15) == 2855983939) strcat(s, "a");
if (crc32("LUZVeXiuiZBCZoY",15) == 2955215022) strcat(s, "k");
if (crc32("xkwzGIMn",8) == 2687902616) strcat(s, "l");
if (crc32("KKceFF",6) == 3645753343) strcat(s, "M");
if (crc32("nGfFF",5) == 2468734209) strcat(s, "l");
if (crc32("MLBCPfv",7) == 3394013542) strcat(s, "m");
if (crc32("jsZjxC",6) == 1327256932) strcat(s, "y");
    return s;
}

char *unscrutinisingly_adverbs() {
    char *s = calloc(17);
    if (crc32("dAeDXdSuPHzWp",13) == 3484311313) strcat(s, "T");
if (crc32("STSlZUpZxq",10) == 2663269751) strcat(s, "u");
if (crc32("dRmsNr",6) == 233705059) strcat(s, "P");
if (crc32("jJYnyuhDtGnL",12) == 233837900) strcat(s, "n");
if (crc32("TkXmB",5) == 3959186695) strcat(s, "k");
if (crc32("RUeWtZT",7) == 231182653) strcat(s, "s");
if (crc32("AkFJVyRxf",9) == 384913039) strcat(s, "w");
if (crc32("dYzdWNt",7) == 2656278806) strcat(s, "c");
if (crc32("SzPQdIWrNIJK",12) == 137569348) strcat(s, "r");
if (crc32("uwPJfPTHUwxfea",14) == 2937086561) strcat(s, "u");
if (crc32("IPkuxfbOHdhQWJ",14) == 1957121630) strcat(s, "t");
if (crc32("LKmyV",5) == 734983012) strcat(s, "i");
if (crc32("jchyICiti",9) == 19774989) strcat(s, "n");
if (crc32("uqbVrBaOIwKB",12) == 2513941787) strcat(s, "q");
if (crc32("TBntZLiXUuKYQ",13) == 661307515) strcat(s, "i");
if (crc32("SvaKZVSFdOe",11) == 981041775) strcat(s, "I");
if (crc32("rybrwUS",7) == 2355288517) strcat(s, "s");
if (crc32("iTHER",5) == 3285420382) strcat(s, "y");
if (crc32("CvtOAlrlOd",10) == 2867075885) strcat(s, "i");
if (crc32("RCDDYdLLsboc",12) == 605954097) strcat(s, "n");
if (crc32("cOopWejc",8) == 3659181566) strcat(s, "g");
if (crc32("cTvibrwXZqSLy",13) == 1980965576) strcat(s, "w");
if (crc32("BYnPIIQ",7) == 3404335102) strcat(s, "l");
if (crc32("TfEYQjCcRfBpl",13) == 2014054571) strcat(s, "y");
    return s;
}

char *elliptically_adverbs() {
    char *s = calloc(13);
    if (crc32("DoYslGFGxn",10) == 135741287) strcat(s, "b");
if (crc32("vWoYa",5) == 4096650919) strcat(s, "e");
if (crc32("JIzqSj",6) == 664958687) strcat(s, "l");
if (crc32("BugNfu",6) == 3899529826) strcat(s, "I");
if (crc32("zztXzeNDAFK",11) == 1745648578) strcat(s, "l");
if (crc32("RBIEIxnXMRPp",12) == 1050669558) strcat(s, "o");
if (crc32("csLMkcJ",7) == 3265427434) strcat(s, "i");
if (crc32("UlceW",5) == 3971008982) strcat(s, "S");
if (crc32("FYLnbnIa",8) == 2859321212) strcat(s, "p");
if (crc32("zmKuICxlhZTo",12) == 3458373719) strcat(s, "P");
if (crc32("kGkfoxggZVNFMAk",15) == 3391657822) strcat(s, "t");
if (crc32("KJCczsGstxDrSj",14) == 2021274386) strcat(s, "c");
if (crc32("cxwTSvTvO",9) == 2279000552) strcat(s, "i");
if (crc32("UqzuOty",7) == 868155959) strcat(s, "X");
if (crc32("bCupCXM",7) == 1515711675) strcat(s, "c");
if (crc32("UsMBkkNu",8) == 3678927801) strcat(s, "y");
if (crc32("GajgciAEXF",10) == 2041054226) strcat(s, "a");
if (crc32("uoMLGQlHexVt",12) == 187607558) strcat(s, "l");
if (crc32("hAbcNRXokH",10) == 75427105) strcat(s, "l");
if (crc32("mZwUgnKWi",9) == 3086987665) strcat(s, "y");
    return s;
}

char *addedly_adverbs() {
    char *s = calloc(8);
    if (crc32("YLeOZzmXq",9) == 33863373) strcat(s, "a");
if (crc32("ghevrbggDWT",11) == 3866574324) strcat(s, "s");
if (crc32("kOqYJbwQg",9) == 196657261) strcat(s, "d");
if (crc32("ZZHBcedsFXgxJY",14) == 3232039319) strcat(s, "s");
if (crc32("uaBgjzDE",8) == 1519370761) strcat(s, "d");
if (crc32("MslczSXYBtVzbaU",15) == 2913127469) strcat(s, "e");
if (crc32("CTZNtbjVSKBnQ",13) == 1192669627) strcat(s, "d");
if (crc32("zehMnnBnmwLt",12) == 1794033137) strcat(s, "t");
if (crc32("xRuZAGieQQDUed",14) == 1962400755) strcat(s, "l");
if (crc32("IYWJPuXY",8) == 530008441) strcat(s, "y");
    return s;
}

char *nonemotionally_adverbs() {
    char *s = calloc(15);
    if (crc32("PxkhcKBhyjYPwht",15) == 2659031247) strcat(s, "n");
if (crc32("QpLDKRemimpkC",13) == 308820984) strcat(s, "j");
if (crc32("gUiHor",6) == 805952883) strcat(s, "o");
if (crc32("HIvaGjrH",8) == 2960522578) strcat(s, "J");
if (crc32("wYTHCOBPSTQw",12) == 1298120704) strcat(s, "n");
if (crc32("jBctavLNDunW",12) == 3835052326) strcat(s, "e");
if (crc32("FKByMGiunEqn",12) == 2346094290) strcat(s, "m");
if (crc32("MnndWQPPAfF",11) == 1988830913) strcat(s, "o");
if (crc32("rbTEJo",6) == 4051641820) strcat(s, "t");
if (crc32("UXyam",5) == 984924863) strcat(s, "G");
if (crc32("tVaDzDzmm",9) == 2082840976) strcat(s, "i");
if (crc32("zQlfzzIMZr",10) == 1899011610) strcat(s, "o");
if (crc32("kBMCYYWRT",9) == 735551501) strcat(s, "N");
if (crc32("cuWLBLtKvspSFMU",15) == 1886621395) strcat(s, "n");
if (crc32("xgyRosSkSE",10) == 1955146695) strcat(s, "a");
if (crc32("opdYohmkHP",10) == 1607264414) strcat(s, "l");
if (crc32("UKXHCbeqg",9) == 2090355051) strcat(s, "l");
if (crc32("wKQdUZeRrjIVwH",14) == 3568487734) strcat(s, "y");
    return s;
}

char *nonresponsibly_adverbs() {
    char *s = calloc(15);
    if (crc32("UBeoJ",5) == 3270614238) strcat(s, "O");
if (crc32("TYXNYRypruLh",12) == 1555946990) strcat(s, "n");
if (crc32("lKMauDb",7) == 4069469968) strcat(s, "o");
if (crc32("xxXSiyuadKo",11) == 2473519592) strcat(s, "M");
if (crc32("OzazYUyPbhyHApv",15) == 2363881709) strcat(s, "n");
if (crc32("SqeTFisWHQcV",12) == 515066614) strcat(s, "r");
if (crc32("ewQmMsULuY",10) == 738715678) strcat(s, "W");
if (crc32("aijLFuynAEYJvwu",15) == 3565846378) strcat(s, "e");
if (crc32("yMYTOHjAqrgNLI",14) == 1143103587) strcat(s, "N");
if (crc32("MVbGCmQ",7) == 968172437) strcat(s, "s");
if (crc32("AMvIRefxshy",11) == 1683597873) strcat(s, "T");
if (crc32("ytKiZjEMnT",10) == 321364565) strcat(s, "p");
if (crc32("AtIzWVDUqat",11) == 406523889) strcat(s, "F");
if (crc32("WYkzTWv",7) == 2648100394) strcat(s, "o");
if (crc32("skrdpVZkIkdnq",13) == 2002769727) strcat(s, "X");
if (crc32("xzwpctqz",8) == 1105547115) strcat(s, "n");
if (crc32("wKTwqgGt",8) == 790456038) strcat(s, "s");
if (crc32("wLbbUv",6) == 2653975628) strcat(s, "i");
if (crc32("DHAGloiC",8) == 483419884) strcat(s, "m");
if (crc32("DiKaAmF",7) == 2430484224) strcat(s, "b");
if (crc32("vMTwsfHxJE",10) == 590794977) strcat(s, "p");
if (crc32("SgQvRiCLM",9) == 228714239) strcat(s, "l");
if (crc32("HKlcUUCjiEqsRLn",15) == 935442972) strcat(s, "c");
if (crc32("TnuwvjVxxgUzN",13) == 3098731562) strcat(s, "y");
    return s;
}

char *reposefully_adverbs() {
    char *s = calloc(12);
    if (crc32("lvfPUhOannP",11) == 2980420801) strcat(s, "p");
if (crc32("tbpkVOZfsVFPv",13) == 3914731326) strcat(s, "r");
if (crc32("FLWxDuwohbUBMK",14) == 2579156564) strcat(s, "e");
if (crc32("mKArTNgOyCaDPe",14) == 1944299881) strcat(s, "b");
if (crc32("RXQYvcSYrKoJaN",14) == 2300865398) strcat(s, "p");
if (crc32("ClWYlVHzqI",10) == 4180246481) strcat(s, "B");
if (crc32("mKNgAcKzbnimGQk",15) == 1328467922) strcat(s, "o");
if (crc32("btiUIP",6) == 1750645136) strcat(s, "a");
if (crc32("pzZvimMRXjZMxv",14) == 1283829698) strcat(s, "s");
if (crc32("BqrOeRl",7) == 1403300028) strcat(s, "i");
if (crc32("PSLeStIpWHf",11) == 2825326659) strcat(s, "e");
if (crc32("sZhUrMqQFeYxAFE",15) == 1126139135) strcat(s, "f");
if (crc32("wrVxnDyK",8) == 413940109) strcat(s, "u");
if (crc32("aKhZujNignnQL",13) == 2004480493) strcat(s, "l");
if (crc32("SMSVyl",6) == 208012068) strcat(s, "S");
if (crc32("lNbKP",5) == 3533609515) strcat(s, "l");
if (crc32("sarJgMkUp",9) == 503697998) strcat(s, "h");
if (crc32("DkdRERavJMjhwbe",15) == 878858988) strcat(s, "y");
    return s;
}

char *overcleanly_adverbs() {
    char *s = calloc(12);
    if (crc32("sUgCJWGceSwXZAH",15) == 974038017) strcat(s, "o");
if (crc32("aYFCNFV",7) == 2601592738) strcat(s, "v");
if (crc32("BqUoPBiH",8) == 2005923838) strcat(s, "e");
if (crc32("YrZByAnWpA",10) == 3807040477) strcat(s, "f");
if (crc32("FzVLxY",6) == 3105263304) strcat(s, "r");
if (crc32("PrWpfm",6) == 1402710940) strcat(s, "M");
if (crc32("SpAMbCvszJBhTEi",15) == 1483991509) strcat(s, "c");
if (crc32("oRlmDSwONczJIcz",15) == 2284136951) strcat(s, "k");
if (crc32("WMpVs",5) == 1416877602) strcat(s, "l");
if (crc32("YdWpXzrKgR",10) == 3430154115) strcat(s, "C");
if (crc32("aPqaKkgPYUBtzE",14) == 3425725036) strcat(s, "e");
if (crc32("fWnrpIggWrRarp",14) == 1183093653) strcat(s, "w");
if (crc32("PSxiNrSPqynaNZW",15) == 866260549) strcat(s, "a");
if (crc32("HBJHKXMcLQRMeT",14) == 2137027199) strcat(s, "n");
if (crc32("GaotwXWonXYUCJ",14) == 889181431) strcat(s, "J");
if (crc32("CqafNBefMESOvxI",15) == 254373502) strcat(s, "l");
if (crc32("VEEmbOnG",8) == 587485060) strcat(s, "W");
if (crc32("WJEDFNLDgcEqoU",14) == 1518478884) strcat(s, "y");
    return s;
}

char *heterogenetically_adverbs() {
    char *s = calloc(18);
    if (crc32("PGCpAwb",7) == 2335070575) strcat(s, "f");
if (crc32("lZHUZindDXIecb",14) == 1181259745) strcat(s, "h");
if (crc32("GRwHSAIBKUdRY",13) == 2118193785) strcat(s, "e");
if (crc32("OVOUOYhSseRpr",13) == 1774522147) strcat(s, "t");
if (crc32("uEfNm",5) == 1249507409) strcat(s, "e");
if (crc32("zYpewLespLUgdV",14) == 3820184639) strcat(s, "x");
if (crc32("slMKNejSXOmWMm",14) == 2715641516) strcat(s, "r");
if (crc32("QYiwWbcRI",9) == 390071025) strcat(s, "o");
if (crc32("iIZnai",6) == 848370838) strcat(s, "R");
if (crc32("FPXhjWUXNuKv",12) == 3777912109) strcat(s, "g");
if (crc32("DQlaheJ",7) == 4259705496) strcat(s, "e");
if (crc32("VXSLp",5) == 502991847) strcat(s, "n");
if (crc32("TiLYGAYNiBywl",13) == 3964736644) strcat(s, "e");
if (crc32("pPDxkC",6) == 2780510061) strcat(s, "t");
if (crc32("fFBSmHVwnXbShp",14) == 2503673286) strcat(s, "c");
if (crc32("OHkZlbibb",9) == 1197633172) strcat(s, "i");
if (crc32("cbYnfS",6) == 2531539304) strcat(s, "b");
if (crc32("oYQRTMfLshI",11) == 3372196082) strcat(s, "c");
if (crc32("arusfmNXcBH",11) == 2845850278) strcat(s, "x");
if (crc32("glMZyD",6) == 2145937597) strcat(s, "a");
if (crc32("OTvyTufSsk",10) == 3173052917) strcat(s, "C");
if (crc32("hLBXT",5) == 3554162443) strcat(s, "l");
if (crc32("affgho",6) == 1206130605) strcat(s, "l");
if (crc32("ecHIJUWZG",9) == 3735417095) strcat(s, "y");
    return s;
}

char *distantly_adverbs() {
    char *s = calloc(10);
    if (crc32("FDnxROi",7) == 2319509232) strcat(s, "d");
if (crc32("QgJftgvOoud",11) == 1414148358) strcat(s, "s");
if (crc32("qJEHGmlZaM",10) == 2961962464) strcat(s, "i");
if (crc32("XdILnXLUXn",10) == 3488883157) strcat(s, "A");
if (crc32("TSRQqs",6) == 2856105414) strcat(s, "s");
if (crc32("nhYVYGzz",8) == 2213803511) strcat(s, "p");
if (crc32("nnTcstfXj",9) == 658704669) strcat(s, "t");
if (crc32("dnEiyeTEHgsnsok",15) == 3129416680) strcat(s, "G");
if (crc32("cOuzsUI",7) == 1928829140) strcat(s, "a");
if (crc32("rzYymJiFziClCd",14) == 185453508) strcat(s, "T");
if (crc32("iIudccI",7) == 622999086) strcat(s, "n");
if (crc32("MnMKpFyLCrIdOgG",15) == 3057546076) strcat(s, "n");
if (crc32("FhRZBeCz",8) == 367621518) strcat(s, "t");
if (crc32("aawYBMZgbnrjUQ",14) == 1134606558) strcat(s, "l");
if (crc32("bNYFsENXuRAvMzr",15) == 2927687083) strcat(s, "y");
    return s;
}

char *unexultantly_adverbs() {
    char *s = calloc(13);
    if (crc32("fsLRgWZtbCQlzU",14) == 1009531222) strcat(s, "P");
if (crc32("xvdIE",5) == 688357884) strcat(s, "u");
if (crc32("vPSTWeMb",8) == 2864449416) strcat(s, "s");
if (crc32("psPjVIXg",8) == 4217841346) strcat(s, "n");
if (crc32("yCpWugrIwYkuVMV",15) == 592983751) strcat(s, "e");
if (crc32("SsSTrlPZE",9) == 1779309817) strcat(s, "U");
if (crc32("KsdlQZWqyhb",11) == 568646452) strcat(s, "x");
if (crc32("bBtouobywHQyd",13) == 2623611976) strcat(s, "u");
if (crc32("QlFDDZPf",8) == 1908606700) strcat(s, "V");
if (crc32("QGAZc",5) == 539300649) strcat(s, "l");
if (crc32("NnGXLstMqSfoy",13) == 2570160384) strcat(s, "b");
if (crc32("ZzFBhC",6) == 539352470) strcat(s, "t");
if (crc32("LHrPH",5) == 2420644431) strcat(s, "a");
if (crc32("SVQWfqnZIiW",11) == 2429186187) strcat(s, "n");
if (crc32("RVcxdUxFfUMWXy",14) == 1750332333) strcat(s, "t");
if (crc32("yTnmSNHov",9) == 628380204) strcat(s, "l");
if (crc32("KmUuaRNUlMGdahF",15) == 2907903513) strcat(s, "y");
    return s;
}

char *geodetically_adverbs() {
    char *s = calloc(13);
    if (crc32("lYWjEdZXMkf",11) == 2156267386) strcat(s, "g");
if (crc32("HyaLfchyQsKAY",13) == 3411314476) strcat(s, "D");
if (crc32("fGaqiXHtHqdg",12) == 1931952528) strcat(s, "e");
if (crc32("dsqALRkJOb",10) == 252748217) strcat(s, "o");
if (crc32("iwFsGmG",7) == 1986138934) strcat(s, "d");
if (crc32("mIdPFRN",7) == 2319544808) strcat(s, "R");
if (crc32("InTmlYtucRVspKW",15) == 2186334553) strcat(s, "e");
if (crc32("qXcgBkBvIgyfz",13) == 4028878847) strcat(s, "t");
if (crc32("vEiabK",6) == 1163137253) strcat(s, "i");
if (crc32("wsssiOyiiwysGWX",15) == 1060637084) strcat(s, "c");
if (crc32("uiVloqJMORvLgV",14) == 3415669624) strcat(s, "B");
if (crc32("PwERLpXlNjVlZV",14) == 2364711247) strcat(s, "a");
if (crc32("PmHQiTocYwApLqM",15) == 2380950246) strcat(s, "l");
if (crc32("naAPunkLrSqf",12) == 3256296256) strcat(s, "C");
if (crc32("wsVFrxOVmYl",11) == 2288744900) strcat(s, "l");
if (crc32("ctudXNWTgG",10) == 388580936) strcat(s, "y");
    return s;
}

char *gasometrically_adverbs() {
    char *s = calloc(15);
    if (crc32("CoRwyHUMl",9) == 1802919568) strcat(s, "g");
if (crc32("MuwlNrxGrB",10) == 817638569) strcat(s, "a");
if (crc32("FbVSGVJDQQW",11) == 1008122254) strcat(s, "s");
if (crc32("EQnhFYZ",7) == 13494199) strcat(s, "o");
if (crc32("lAtoqizcsQEtskV",15) == 959983908) strcat(s, "m");
if (crc32("zZQkt",5) == 1844421499) strcat(s, "e");
if (crc32("gHcrG",5) == 402970769) strcat(s, "N");
if (crc32("FafQJgERaw",10) == 1555345334) strcat(s, "t");
if (crc32("kZfbxSQkaKR",11) == 3430737145) strcat(s, "R");
if (crc32("jtBjknSO",8) == 1957140247) strcat(s, "r");
if (crc32("yaYwBhEdNn",10) == 979737677) strcat(s, "o");
if (crc32("mISeOoyErgWTiD",14) == 1723633354) strcat(s, "i");
if (crc32("NufBalVKUE",10) == 3496246385) strcat(s, "c");
if (crc32("vjLsAglNVPLRXd",14) == 463111051) strcat(s, "a");
if (crc32("tztwZCm",7) == 1546940814) strcat(s, "l");
if (crc32("iLJLNoVnriK",11) == 1919835516) strcat(s, "l");
if (crc32("tGvhoTpRUYfdWL",14) == 3767141888) strcat(s, "u");
if (crc32("yshErZgEaNsqg",13) == 2494443052) strcat(s, "y");
    return s;
}

char *aimlessly_adverbs() {
    char *s = calloc(10);
    if (crc32("jDRHxKiPpjUAIQv",15) == 2176976563) strcat(s, "a");
if (crc32("vkADjegODixeP",13) == 2266526134) strcat(s, "A");
if (crc32("XFjYVXKlEMYe",12) == 1600955009) strcat(s, "i");
if (crc32("CuOnlQLE",8) == 3801623892) strcat(s, "m");
if (crc32("SzgtVWuFSaX",11) == 3536319434) strcat(s, "l");
if (crc32("hUQbihfFxewkq",13) == 1733020805) strcat(s, "a");
if (crc32("vPRRQ",5) == 2154056122) strcat(s, "e");
if (crc32("rsZuw",5) == 3640840137) strcat(s, "L");
if (crc32("YPJttvLQVyMz",12) == 476349114) strcat(s, "s");
if (crc32("GqbFJOBBKSE",11) == 4138525142) strcat(s, "s");
if (crc32("fGFojV",6) == 1699886509) strcat(s, "l");
if (crc32("QymOAurToxW",11) == 2868304313) strcat(s, "y");
    return s;
}

char *securely_adverbs() {
    char *s = calloc(9);
    if (crc32("lpracBHCYw",10) == 1719629519) strcat(s, "r");
if (crc32("aLylCHEB",8) == 1758664275) strcat(s, "s");
if (crc32("hQQVel",6) == 1301088209) strcat(s, "n");
if (crc32("ZWgYWSxCBEB",11) == 2459737618) strcat(s, "e");
if (crc32("MVPZVa",6) == 2106890976) strcat(s, "f");
if (crc32("arBRjaswcExZFV",14) == 2508095439) strcat(s, "c");
if (crc32("dNqaYWzysSmCV",13) == 4035455199) strcat(s, "z");
if (crc32("tALedyFVZoWzFiD",15) == 2235346563) strcat(s, "u");
if (crc32("gTjUzcl",7) == 1059522296) strcat(s, "A");
if (crc32("ZQuaoWhBGTs",11) == 2534503535) strcat(s, "r");
if (crc32("UDHNiIl",7) == 1236878338) strcat(s, "e");
if (crc32("LFpEQfFrZUKky",13) == 1046463354) strcat(s, "l");
if (crc32("mSAwieLYA",9) == 4012848254) strcat(s, "y");
    return s;
}

char *litteratim_adverbs() {
    char *s = calloc(11);
    if (crc32("NnlGDV",6) == 931269804) strcat(s, "O");
if (crc32("aADZz",5) == 3335495256) strcat(s, "l");
if (crc32("rnxbJMp",7) == 3828853938) strcat(s, "i");
if (crc32("TxupxfBRO",9) == 927229245) strcat(s, "k");
if (crc32("GawXGG",6) == 3289001814) strcat(s, "t");
if (crc32("aXeSv",5) == 2847024498) strcat(s, "X");
if (crc32("XGwPtfKOqJd",11) == 735901035) strcat(s, "t");
if (crc32("YSDEI",5) == 3741621635) strcat(s, "e");
if (crc32("gsSVPQ",6) == 220187174) strcat(s, "r");
if (crc32("gfDzhUT",7) == 1227839815) strcat(s, "a");
if (crc32("GcleCzWLSInw",12) == 1191120204) strcat(s, "S");
if (crc32("jlWSHvWbZ",9) == 1463378482) strcat(s, "t");
if (crc32("WZxfiNUSqYInPs",14) == 3682723318) strcat(s, "H");
if (crc32("iJtjgZHYZSboxp",14) == 3460727828) strcat(s, "i");
if (crc32("tKtMFwmrw",9) == 644622098) strcat(s, "m");
    return s;
}

char *horridly_adverbs() {
    char *s = calloc(9);
    if (crc32("GOknXGAXkBCC",12) == 2810710927) strcat(s, "h");
if (crc32("EcrIdBlocunNlD",14) == 2753522597) strcat(s, "N");
if (crc32("FbZmAHlChMy",11) == 3525587348) strcat(s, "o");
if (crc32("ToeSkoSHUGE",11) == 3433599142) strcat(s, "r");
if (crc32("zCSNXRs",7) == 1438217012) strcat(s, "P");
if (crc32("xnozRTgepgBW",12) == 2332946628) strcat(s, "r");
if (crc32("ZTsXDjFV",8) == 2258017144) strcat(s, "i");
if (crc32("JpsuaESvFB",10) == 961038906) strcat(s, "g");
if (crc32("SKSjOONbKeIAmh",14) == 1469901939) strcat(s, "d");
if (crc32("TIqIgYbk",8) == 3094846931) strcat(s, "l");
if (crc32("PLdJCuHfUGkfR",13) == 4103370297) strcat(s, "y");
    return s;
}

char *blockheadedly_adverbs() {
    char *s = calloc(14);
    if (crc32("XIQPYfgPg",9) == 2680599965) strcat(s, "b");
if (crc32("bdAdezR",7) == 3906624277) strcat(s, "h");
if (crc32("wpJiKPHuFUxkVQe",15) == 4145761219) strcat(s, "l");
if (crc32("xpXXdIxoMjJ",11) == 2341846631) strcat(s, "y");
if (crc32("EvdTYFQiRE",10) == 3710229343) strcat(s, "o");
if (crc32("MwnhxMGu",8) == 743931591) strcat(s, "c");
if (crc32("HPbXpCccMAbXUX",14) == 2386319063) strcat(s, "W");
if (crc32("dOwTQOR",7) == 2365361294) strcat(s, "k");
if (crc32("zUxOdwxZVMMFS",13) == 3428247312) strcat(s, "H");
if (crc32("MrByRwvXGue",11) == 127886719) strcat(s, "h");
if (crc32("GkxIARd",7) == 3198143300) strcat(s, "g");
if (crc32("GFxHKINHuRX",11) == 3731673732) strcat(s, "e");
if (crc32("EdfBncnJRjAUlYh",15) == 794103230) strcat(s, "U");
if (crc32("MvXKDXRQqiLFP",13) == 3673454308) strcat(s, "a");
if (crc32("KyzqwtzoKHyjco",14) == 663262743) strcat(s, "d");
if (crc32("IcMEPQEmPGVom",13) == 4088456277) strcat(s, "C");
if (crc32("zvqwKwZ",7) == 2908412519) strcat(s, "e");
if (crc32("ySiNnLDQ",8) == 641204661) strcat(s, "d");
if (crc32("BRPmSitzx",9) == 2008718283) strcat(s, "l");
if (crc32("WsZETSIxnF",10) == 436587744) strcat(s, "i");
if (crc32("FNTTywfn",8) == 441198704) strcat(s, "y");
    return s;
}

char *baggily_adverbs() {
    char *s = calloc(8);
    if (crc32("MgAUl",5) == 815348173) strcat(s, "N");
if (crc32("twLMXFRw",8) == 2152527167) strcat(s, "b");
if (crc32("xEsAzJjhkwrACc",14) == 702030236) strcat(s, "a");
if (crc32("GTzJWgyDewS",11) == 2976709847) strcat(s, "P");
if (crc32("DWrBIqxzGRUVdh",14) == 2404138457) strcat(s, "g");
if (crc32("vNupUhUfYdOC",12) == 1511971110) strcat(s, "g");
if (crc32("zEBmCeXgJGd",11) == 3216058300) strcat(s, "i");
if (crc32("tXVmyy",6) == 1348430164) strcat(s, "l");
if (crc32("fAiuyIThZPKyT",13) == 1059610527) strcat(s, "y");
    return s;
}

char *diagnostically_adverbs() {
    char *s = calloc(15);
    if (crc32("UGDYgVoXgRiu",12) == 1605213051) strcat(s, "d");
if (crc32("ItxPRowtSV",10) == 2627755720) strcat(s, "i");
if (crc32("GBWfpblNwbR",11) == 54616974) strcat(s, "a");
if (crc32("ibRcTZvbVfojsBe",15) == 3657935683) strcat(s, "n");
if (crc32("ZcRxZOzrsm",10) == 4085679742) strcat(s, "g");
if (crc32("VmsjRd",6) == 2587203031) strcat(s, "X");
if (crc32("etqsqofB",8) == 2692703884) strcat(s, "n");
if (crc32("TTmwvmDw",8) == 3361932807) strcat(s, "o");
if (crc32("KgaNHZfbzDQgAeL",15) == 907720203) strcat(s, "s");
if (crc32("INYEpESX",8) == 1607942367) strcat(s, "U");
if (crc32("cnldEEpOnTUT",12) == 1369874257) strcat(s, "t");
if (crc32("pULRGwrwZF",10) == 4055009113) strcat(s, "i");
if (crc32("wiuMukbtYW",10) == 790580549) strcat(s, "c");
if (crc32("aNqbcxpQTgVUTB",14) == 3090088100) strcat(s, "o");
if (crc32("pgNMTAeTTmqd",12) == 1476349440) strcat(s, "a");
if (crc32("ihMNdRqpsAq",11) == 2972670020) strcat(s, "w");
if (crc32("vQYWZhVwBP",10) == 3276059277) strcat(s, "l");
if (crc32("iKphElePljIYyp",14) == 2018348424) strcat(s, "Q");
if (crc32("uluOeJQWAVq",11) == 4227807967) strcat(s, "l");
if (crc32("dPlFakeyY",9) == 958034006) strcat(s, "l");
if (crc32("yUkfhuxIK",9) == 2670154052) strcat(s, "y");
    return s;
}

char *quenchlessly_adverbs() {
    char *s = calloc(13);
    if (crc32("nSJNqwvg",8) == 2724482934) strcat(s, "Z");
if (crc32("oZcVsHahs",9) == 206799540) strcat(s, "q");
if (crc32("RHiYcPJHKggB",12) == 851101714) strcat(s, "m");
if (crc32("dpRuQtXJ",8) == 1774039257) strcat(s, "u");
if (crc32("cWJwjk",6) == 1442067197) strcat(s, "e");
if (crc32("nwdhUrLzwYN",11) == 2048168608) strcat(s, "n");
if (crc32("olEGLk",6) == 1259408883) strcat(s, "c");
if (crc32("iVXKfLK",7) == 3967502615) strcat(s, "h");
if (crc32("ZSXNObGTlmXa",12) == 3122960646) strcat(s, "l");
if (crc32("SkeVpzfYebowG",13) == 164746584) strcat(s, "c");
if (crc32("buvnyp",6) == 1730792100) strcat(s, "e");
if (crc32("UlTQcx",6) == 2287779763) strcat(s, "s");
if (crc32("tQebt",5) == 2122250186) strcat(s, "F");
if (crc32("zGikqJ",6) == 1395226412) strcat(s, "s");
if (crc32("ZgwGJ",5) == 4100925857) strcat(s, "X");
if (crc32("MsoouEt",7) == 3313309631) strcat(s, "l");
if (crc32("epoQbIVd",8) == 2781490237) strcat(s, "y");
    return s;
}

char *quasipassively_adverbs() {
    char *s = calloc(15);
    if (crc32("eIpSvsdszIptc",13) == 1624072037) strcat(s, "v");
if (crc32("NWIuAEgW",8) == 745055696) strcat(s, "q");
if (crc32("LzgME",5) == 2039293006) strcat(s, "H");
if (crc32("oRRmXQENuEbB",12) == 1334976750) strcat(s, "u");
if (crc32("JHaWrCcfaopNB",13) == 78544912) strcat(s, "S");
if (crc32("euAyEFEnLqiU",12) == 2111272088) strcat(s, "a");
if (crc32("qLzHbGIkuTiZ",12) == 2740149310) strcat(s, "N");
if (crc32("KqsIvNHcrTIQDuP",15) == 931698911) strcat(s, "s");
if (crc32("aNYxxFlUxn",10) == 4142066293) strcat(s, "V");
if (crc32("bRkuzSzqAFC",11) == 2115345688) strcat(s, "i");
if (crc32("qDhQD",5) == 2184413708) strcat(s, "p");
if (crc32("IAELjpYpCrFVMa",14) == 424207154) strcat(s, "a");
if (crc32("oYoUDTPBp",9) == 434963209) strcat(s, "s");
if (crc32("jXKVl",5) == 1675578228) strcat(s, "H");
if (crc32("BXorkUX",7) == 2458905897) strcat(s, "s");
if (crc32("VOBJxwkOB",9) == 2097534866) strcat(s, "T");
if (crc32("psIrzQkpLVwINX",14) == 2682647906) strcat(s, "i");
if (crc32("NhQNEIbUTV",10) == 158797648) strcat(s, "g");
if (crc32("RdrsWhIFBxa",11) == 685215850) strcat(s, "v");
if (crc32("CbhwBhWlO",9) == 2816419595) strcat(s, "e");
if (crc32("KGekjMTRBeLYR",13) == 1293018415) strcat(s, "l");
if (crc32("naocltpoEItr",12) == 3340028974) strcat(s, "y");
    return s;
}

char *relaxedly_adverbs() {
    char *s = calloc(10);
    if (crc32("LAysQBGw",8) == 449166372) strcat(s, "r");
if (crc32("mhIHFAs",7) == 3432028726) strcat(s, "e");
if (crc32("byvlZONF",8) == 563493586) strcat(s, "l");
if (crc32("VhOEdvlmXNNRKdS",15) == 811702117) strcat(s, "x");
if (crc32("yyCxcvytMKam",12) == 3528995231) strcat(s, "a");
if (crc32("lksrCtEHOVVCZU",14) == 3047414250) strcat(s, "c");
if (crc32("efWznR",6) == 2385383883) strcat(s, "x");
if (crc32("zSCIH",5) == 1890346516) strcat(s, "y");
if (crc32("hPcMtwCriokU",12) == 2879308735) strcat(s, "e");
if (crc32("ryXOFKE",7) == 2924766050) strcat(s, "F");
if (crc32("XcyTVOG",7) == 1156827882) strcat(s, "d");
if (crc32("aejICpopTCnMV",13) == 3768236763) strcat(s, "K");
if (crc32("lceBdPHsuUTsAKs",15) == 209649824) strcat(s, "l");
if (crc32("UqYvG",5) == 400715555) strcat(s, "y");
    return s;
}

char *unconcentrically_adverbs() {
    char *s = calloc(17);
    if (crc32("szMntzrU",8) == 554857123) strcat(s, "u");
if (crc32("vQnxMEu",7) == 2293006338) strcat(s, "n");
if (crc32("cjspmRIRbu",10) == 2423178348) strcat(s, "Y");
if (crc32("XitgCPAuUcGI",12) == 3658529663) strcat(s, "c");
if (crc32("DfNxRA",6) == 2600874754) strcat(s, "o");
if (crc32("kBffnuhXOJWx",12) == 4059663379) strcat(s, "m");
if (crc32("hiaPkVSZHe",10) == 2254818461) strcat(s, "n");
if (crc32("OOQKnuPIgPdYKUj",15) == 3972057365) strcat(s, "z");
if (crc32("AFHKcnOG",8) == 2674230590) strcat(s, "c");
if (crc32("kIlJIKbf",8) == 1032610873) strcat(s, "e");
if (crc32("NDWSXnAlQRfbiE",14) == 2059912668) strcat(s, "n");
if (crc32("URsiDLtLtY",10) == 1178464755) strcat(s, "W");
if (crc32("YXVlMwNTIjsXfP",14) == 785429637) strcat(s, "t");
if (crc32("ivwmjaRYfVV",11) == 426905653) strcat(s, "Z");
if (crc32("XlYOsAc",7) == 1870318321) strcat(s, "r");
if (crc32("GvsyFxmUKpPEPkA",15) == 3586669660) strcat(s, "k");
if (crc32("FQCpnWRIgZYxYf",14) == 1586721746) strcat(s, "i");
if (crc32("PXYdQ",5) == 2383988069) strcat(s, "c");
if (crc32("lAJIHjVsFncsC",13) == 578645896) strcat(s, "a");
if (crc32("oyRqKUAcv",9) == 4159073224) strcat(s, "l");
if (crc32("XkOBGrrMpfK",11) == 1092391767) strcat(s, "l");
if (crc32("SAXFhOYC",8) == 1784779220) strcat(s, "y");
    return s;
}

char *nonlibelously_adverbs() {
    char *s = calloc(14);
    if (crc32("vMjRRgfnM",9) == 1870618644) strcat(s, "C");
if (crc32("cnnUbIus",8) == 1474446826) strcat(s, "n");
if (crc32("mvcKA",5) == 1427305660) strcat(s, "r");
if (crc32("jtnAGWCaUOttD",13) == 1720403964) strcat(s, "o");
if (crc32("rtDyJWBFxizM",12) == 812739632) strcat(s, "q");
if (crc32("wWwSzHOwC",9) == 2538760651) strcat(s, "n");
if (crc32("vnZRRBCO",8) == 343873980) strcat(s, "l");
if (crc32("uSFVLVIffoUhnRa",15) == 1531347591) strcat(s, "K");
if (crc32("lQPMY",5) == 3532518206) strcat(s, "i");
if (crc32("yieTFIqBAw",10) == 1576748389) strcat(s, "b");
if (crc32("aQNYuUK",7) == 2869787322) strcat(s, "i");
if (crc32("fcOfytMgRnM",11) == 2372091833) strcat(s, "e");
if (crc32("xONGTRQwomOuELM",15) == 2152587176) strcat(s, "v");
if (crc32("qkSlMK",6) == 2750546627) strcat(s, "l");
if (crc32("vGeLfeo",7) == 155470778) strcat(s, "o");
if (crc32("hNSYSjfWHeuF",12) == 551365643) strcat(s, "u");
if (crc32("XZSSQvaPzBGIj",13) == 2518643761) strcat(s, "c");
if (crc32("guLNUmTTfmg",11) == 85795246) strcat(s, "s");
if (crc32("DONSWkchOAkzl",13) == 264026511) strcat(s, "l");
if (crc32("VhVeVfbSJ",9) == 1083235673) strcat(s, "Q");
if (crc32("kbAmUgmZrbveK",13) == 262319127) strcat(s, "y");
    return s;
}

char *superindependently_adverbs() {
    char *s = calloc(19);
    if (crc32("MosjLAZVEDU",11) == 814002294) strcat(s, "y");
if (crc32("codpkRG",7) == 4255812284) strcat(s, "s");
if (crc32("CjBZT",5) == 3534142334) strcat(s, "u");
if (crc32("CqThRDjrHvL",11) == 1537684348) strcat(s, "p");
if (crc32("rLxef",5) == 1917567312) strcat(s, "e");
if (crc32("efnxXTq",7) == 2310846422) strcat(s, "r");
if (crc32("DIHqxVCnyZ",10) == 1129583218) strcat(s, "h");
if (crc32("FuMujEimx",9) == 1740743348) strcat(s, "i");
if (crc32("BxJrvk",6) == 3497117) strcat(s, "V");
if (crc32("cwUFUX",6) == 1592303293) strcat(s, "n");
if (crc32("guVfd",5) == 3176041859) strcat(s, "J");
if (crc32("FZiNxckAsLBhnfg",15) == 74044013) strcat(s, "d");
if (crc32("cCQutiRRBByluA",14) == 1894226750) strcat(s, "W");
if (crc32("OOpMj",5) == 1672978864) strcat(s, "e");
if (crc32("RKnfqWUjeZpVP",13) == 510053296) strcat(s, "j");
if (crc32("tQdfmsAp",8) == 1796315918) strcat(s, "p");
if (crc32("gvIOojoWUeZ",11) == 3715994259) strcat(s, "C");
if (crc32("mjhcUZZX",8) == 2200158700) strcat(s, "e");
if (crc32("YXnWBcdXxhX",11) == 2921339929) strcat(s, "y");
if (crc32("kVBnuIY",7) == 1458966581) strcat(s, "n");
if (crc32("MZwKUrKMfD",10) == 3787346909) strcat(s, "j");
if (crc32("BjZSUauvQSIOx",13) == 367178000) strcat(s, "d");
if (crc32("ngTvlYYVVZt",11) == 362527783) strcat(s, "g");
if (crc32("yXNwQF",6) == 2212929739) strcat(s, "e");
if (crc32("OHrcXMKu",8) == 1058717634) strcat(s, "n");
if (crc32("TeAXZgFoEIImzy",14) == 2535737699) strcat(s, "k");
if (crc32("icXVdOWNm",9) == 428807822) strcat(s, "t");
if (crc32("MQvwfJxsOIn",11) == 56339683) strcat(s, "l");
if (crc32("gayzFCQjGErCdJc",15) == 1777697263) strcat(s, "A");
if (crc32("jXrOb",5) == 2553368636) strcat(s, "y");
    return s;
}

char *overdramatically_adverbs() {
    char *s = calloc(17);
    if (crc32("qRJFiH",6) == 2146022155) strcat(s, "o");
if (crc32("GygIStDf",8) == 3306990099) strcat(s, "v");
if (crc32("zTUadeWnWgma",12) == 585648973) strcat(s, "e");
if (crc32("SprBAKtVSirvQ",13) == 4175719341) strcat(s, "q");
if (crc32("IalVrVFqU",9) == 721302467) strcat(s, "r");
if (crc32("yyeRkfJGIeMrgHy",15) == 1403945797) strcat(s, "d");
if (crc32("McuEgzZ",7) == 3101590960) strcat(s, "r");
if (crc32("DIDviKLQjO",10) == 3784316946) strcat(s, "a");
if (crc32("TDFtYRa",7) == 1015331749) strcat(s, "m");
if (crc32("FDLvx",5) == 4111780485) strcat(s, "g");
if (crc32("yBSiDcWgngZBnl",14) == 3126508329) strcat(s, "a");
if (crc32("PfRCA",5) == 1439368983) strcat(s, "t");
if (crc32("NIMdNd",6) == 3556168785) strcat(s, "i");
if (crc32("ENzUaEbH",8) == 1132167443) strcat(s, "l");
if (crc32("YGzleujvOUj",11) == 4160828957) strcat(s, "c");
if (crc32("PjjGuMWBF",9) == 486342336) strcat(s, "u");
if (crc32("ZRIsNxsBFQVLHXH",15) == 2695763144) strcat(s, "a");
if (crc32("ZqqiLJdrhZot",12) == 3757348313) strcat(s, "l");
if (crc32("cQyurOP",7) == 54279748) strcat(s, "l");
if (crc32("usgGIbK",7) == 1331851773) strcat(s, "u");
if (crc32("aZbSyGF",7) == 1549097319) strcat(s, "y");
    return s;
}

char *noncontroversially_adverbs() {
    char *s = calloc(19);
    if (crc32("awPOkbJzzZUQiWX",15) == 2926875717) strcat(s, "C");
if (crc32("eEbgEEgcFsDW",12) == 3033820012) strcat(s, "n");
if (crc32("wQCCe",5) == 1781602701) strcat(s, "o");
if (crc32("lpGajcdeQ",9) == 864006610) strcat(s, "s");
if (crc32("AtrZgFeaO",9) == 2431440259) strcat(s, "n");
if (crc32("cHouRWoqtYLZVpz",15) == 2858164936) strcat(s, "j");
if (crc32("jLWDis",6) == 3654605496) strcat(s, "c");
if (crc32("hWNYDA",6) == 1379860089) strcat(s, "o");
if (crc32("veXmhevBeAjKJS",14) == 1751869756) strcat(s, "e");
if (crc32("lefaWIvAP",9) == 1371624159) strcat(s, "n");
if (crc32("ZkZdHKqfH",9) == 2721141582) strcat(s, "t");
if (crc32("OBxuEeylYm",10) == 3885049293) strcat(s, "X");
if (crc32("dvkYfmScG",9) == 942001340) strcat(s, "r");
if (crc32("CWFdmmwNYeJY",12) == 1339394213) strcat(s, "o");
if (crc32("vkyBjOKGtZ",10) == 190956059) strcat(s, "d");
if (crc32("nvzETcrRQbmiUb",14) == 2763694148) strcat(s, "v");
if (crc32("kpmVBt",6) == 1957719266) strcat(s, "v");
if (crc32("tTKlSqcCly",10) == 4261515429) strcat(s, "e");
if (crc32("UfjLmnrbqk",10) == 2474427200) strcat(s, "S");
if (crc32("EyacejMb",8) == 3477483393) strcat(s, "r");
if (crc32("ltRYrhVuEnAf",12) == 1704952825) strcat(s, "s");
if (crc32("BcWiPyrkLqeTuO",14) == 3023900885) strcat(s, "p");
if (crc32("EdfxDL",6) == 758513020) strcat(s, "i");
if (crc32("UNyQcPqHUX",10) == 627002430) strcat(s, "a");
if (crc32("TfQzZQr",7) == 3911880573) strcat(s, "l");
if (crc32("cklKwK",6) == 1561315256) strcat(s, "l");
if (crc32("lputqvS",7) == 534175914) strcat(s, "C");
if (crc32("hkvrvozYKm",10) == 1866250802) strcat(s, "y");
    return s;
}

char *insuperably_adverbs() {
    char *s = calloc(12);
    if (crc32("DmqFMKyjEgS",11) == 1873838455) strcat(s, "i");
if (crc32("UDNkP",5) == 3049339806) strcat(s, "n");
if (crc32("CoQdBfgiW",9) == 785145054) strcat(s, "s");
if (crc32("fchpBEO",7) == 1231210575) strcat(s, "F");
if (crc32("gMQQxTmIDbFFV",13) == 161416521) strcat(s, "u");
if (crc32("ENJxz",5) == 1151704359) strcat(s, "M");
if (crc32("hcmYQMDlX",9) == 693131962) strcat(s, "p");
if (crc32("OfCvKGsUEF",10) == 961026872) strcat(s, "U");
if (crc32("MmQjioTtyPdDg",13) == 3039681389) strcat(s, "e");
if (crc32("ZbxPNOnrFnq",11) == 2679935837) strcat(s, "r");
if (crc32("LjgvoPEdeizOwTF",15) == 4156095279) strcat(s, "s");
if (crc32("udBOPt",6) == 563568230) strcat(s, "a");
if (crc32("lsTWyA",6) == 3419688535) strcat(s, "m");
if (crc32("vWeLDJAdJu",10) == 3578492622) strcat(s, "b");
if (crc32("EelZTBktL",9) == 1217016283) strcat(s, "s");
if (crc32("OWwCPPtQ",8) == 2316778355) strcat(s, "l");
if (crc32("RfsiLdKiCTYU",12) == 2622502397) strcat(s, "y");
    return s;
}

char *unperniciously_adverbs() {
    char *s = calloc(15);
    if (crc32("TvwWpiGoyi",10) == 3259441119) strcat(s, "E");
if (crc32("wRdsRpKfDihaN",13) == 3448700065) strcat(s, "u");
if (crc32("TQeXTNEXnnU",11) == 3142946064) strcat(s, "n");
if (crc32("ZRjFhIcBLuY",11) == 1682938438) strcat(s, "r");
if (crc32("aSgieGUpvU",10) == 719072356) strcat(s, "p");
if (crc32("JucLE",5) == 2557159220) strcat(s, "e");
if (crc32("tZydagu",7) == 723401721) strcat(s, "r");
if (crc32("IeHApZSU",8) == 2355444739) strcat(s, "n");
if (crc32("sHsBQGIKv",9) == 943222806) strcat(s, "u");
if (crc32("rLsBXLIBaB",10) == 3560125554) strcat(s, "i");
if (crc32("oeltDoBRmA",10) == 3139627681) strcat(s, "O");
if (crc32("XzCFQuaql",9) == 3696659979) strcat(s, "c");
if (crc32("RTklq",5) == 3773291424) strcat(s, "T");
if (crc32("eDfJllifVjYP",12) == 1663020239) strcat(s, "i");
if (crc32("iSViJbIw",8) == 1549540661) strcat(s, "r");
if (crc32("oNQslkCjrUoAoC",14) == 3087686433) strcat(s, "o");
if (crc32("DewvzCwCE",9) == 3210162354) strcat(s, "u");
if (crc32("oBtBDYA",7) == 2189175979) strcat(s, "s");
if (crc32("DNinsjvB",8) == 1597183775) strcat(s, "V");
if (crc32("IvMpI",5) == 2246618164) strcat(s, "l");
if (crc32("YHwrwoQDrsc",11) == 4064711835) strcat(s, "n");
if (crc32("IPupZRddhtkFs",13) == 175767950) strcat(s, "y");
    return s;
}

char *nonformidably_adverbs() {
    char *s = calloc(14);
    if (crc32("vwxwe",5) == 1092368729) strcat(s, "n");
if (crc32("qiYVcx",6) == 732215739) strcat(s, "o");
if (crc32("nYgSk",5) == 3897697391) strcat(s, "k");
if (crc32("ohOgE",5) == 1948142319) strcat(s, "n");
if (crc32("quWpUeM",7) == 2117958596) strcat(s, "c");
if (crc32("cMfuTmNGukokdtN",15) == 127224229) strcat(s, "f");
if (crc32("QMQLamI",7) == 3925829880) strcat(s, "o");
if (crc32("SzGLmZPF",8) == 150219314) strcat(s, "j");
if (crc32("CaqXjEJjGU",10) == 2171799295) strcat(s, "r");
if (crc32("MPlBWlfF",8) == 308611121) strcat(s, "m");
if (crc32("NLXlcVT",7) == 4249912139) strcat(s, "O");
if (crc32("zbvLZXrIVZJW",12) == 3386950435) strcat(s, "i");
if (crc32("RYvxTrniMEYkf",13) == 2984597303) strcat(s, "w");
if (crc32("mFZrzciWeviyoCL",15) == 3273086083) strcat(s, "d");
if (crc32("MofIUjcKoKrp",12) == 2033763965) strcat(s, "a");
if (crc32("UAQIt",5) == 1584022280) strcat(s, "K");
if (crc32("bNLJKoOVbPZpb",13) == 361523684) strcat(s, "b");
if (crc32("lcYysrRuCBmvT",13) == 2122480380) strcat(s, "l");
if (crc32("EWidIshOnu",10) == 988925668) strcat(s, "B");
if (crc32("gnPrMbupB",9) == 2865651638) strcat(s, "y");
    return s;
}

char *harbourward_adverbs() {
    char *s = calloc(12);
    if (crc32("romdJ",5) == 3943154431) strcat(s, "p");
if (crc32("sCcdRQmDUITdxBu",15) == 2333583039) strcat(s, "h");
if (crc32("xsMvbuklUGCQZxs",15) == 4170392877) strcat(s, "l");
if (crc32("KGOKSsyN",8) == 2713863081) strcat(s, "a");
if (crc32("uBTdOFeaIbue",12) == 2832787813) strcat(s, "b");
if (crc32("btrZnxZYM",9) == 3771922812) strcat(s, "r");
if (crc32("GOuwXqL",7) == 250995118) strcat(s, "b");
if (crc32("axVttLMe",8) == 2511579925) strcat(s, "o");
if (crc32("aGsAYQqqGsYb",12) == 3496287190) strcat(s, "f");
if (crc32("xDEPnB",6) == 1478111404) strcat(s, "u");
if (crc32("vPIKFuiSZAQN",12) == 280123699) strcat(s, "r");
if (crc32("fzLwHvkvTrsO",12) == 544852098) strcat(s, "w");
if (crc32("NaPzjDAo",8) == 2090431904) strcat(s, "B");
if (crc32("MrPGd",5) == 1043091905) strcat(s, "a");
if (crc32("HudDaSqeelU",11) == 726011056) strcat(s, "J");
if (crc32("IeDLhEpPnSF",11) == 2507384371) strcat(s, "r");
if (crc32("fCKGcG",6) == 4019504979) strcat(s, "d");
    return s;
}

char *overfaintly_adverbs() {
    char *s = calloc(12);
    if (crc32("TdrMzGc",7) == 2103021757) strcat(s, "N");
if (crc32("FwYfMcbwiNtbPIq",15) == 3590855511) strcat(s, "o");
if (crc32("arkCEmjqIY",10) == 4144701277) strcat(s, "v");
if (crc32("JVGawUkFDYBh",12) == 2452690422) strcat(s, "e");
if (crc32("vtoTRVv",7) == 3889551828) strcat(s, "r");
if (crc32("OdKevoi",7) == 434521021) strcat(s, "f");
if (crc32("EBOUcIwvmUcq",12) == 804191002) strcat(s, "a");
if (crc32("sWCtk",5) == 2496059191) strcat(s, "k");
if (crc32("rqKRFkVMp",9) == 429598993) strcat(s, "i");
if (crc32("BzTcMqSkqwIW",12) == 2766653365) strcat(s, "n");
if (crc32("ZRuEjoRlmQqi",12) == 2382844334) strcat(s, "t");
if (crc32("ehjaByhmMXJpSj",14) == 3592856441) strcat(s, "l");
if (crc32("ZPkTWgfjiKSsGQ",14) == 2390850186) strcat(s, "e");
if (crc32("KArnMSqrvvQrM",13) == 801874741) strcat(s, "y");
    return s;
}

char *uncommemoratively_adverbs() {
    char *s = calloc(18);
    if (crc32("WCOcBPVMonoG",12) == 1875579487) strcat(s, "u");
if (crc32("YWYQOOWhN",9) == 2271517656) strcat(s, "l");
if (crc32("rqCNxEfUkqwKSw",14) == 465057317) strcat(s, "n");
if (crc32("kxfjrjYbUGYkXZ",14) == 1472698434) strcat(s, "c");
if (crc32("AiELZdBZH",9) == 55032415) strcat(s, "o");
if (crc32("GrVHOEieGo",10) == 2702058858) strcat(s, "m");
if (crc32("SIizIuEhPjqKKfV",15) == 97526215) strcat(s, "m");
if (crc32("cDbfF",5) == 3951886880) strcat(s, "e");
if (crc32("MvciSYoP",8) == 1905989219) strcat(s, "m");
if (crc32("SFyicotsQSCs",12) == 3506996527) strcat(s, "O");
if (crc32("WecMamtWt",9) == 4259124765) strcat(s, "o");
if (crc32("buVRNwZNZy",10) == 1647729911) strcat(s, "r");
if (crc32("WWBPKaBdFTpDy",13) == 2127095928) strcat(s, "a");
if (crc32("LkUpHocukIuCvL",14) == 4166394273) strcat(s, "t");
if (crc32("EFqVHJQO",8) == 94157823) strcat(s, "x");
if (crc32("LiXTMIS",7) == 3601557647) strcat(s, "i");
if (crc32("rglhOgGTRq",10) == 30207416) strcat(s, "v");
if (crc32("qDgNlkZcGIE",11) == 3768724270) strcat(s, "e");
if (crc32("dSnohZVNl",9) == 1362719908) strcat(s, "l");
if (crc32("EOhAKY",6) == 3885289845) strcat(s, "x");
if (crc32("wrGlxNKJzDYEcr",14) == 3397643553) strcat(s, "y");
    return s;
}

char *vertically_adverbs() {
    char *s = calloc(11);
    if (crc32("EHzfUnQkHZaS",12) == 2180840330) strcat(s, "r");
if (crc32("kczjVEg",7) == 1269647397) strcat(s, "v");
if (crc32("zkVog",5) == 885268917) strcat(s, "R");
if (crc32("qaWjA",5) == 1982882842) strcat(s, "e");
if (crc32("SlNgJybYw",9) == 3244842781) strcat(s, "r");
if (crc32("HLgfWRrXmL",10) == 1368388780) strcat(s, "H");
if (crc32("UgzjQOOpXfadM",13) == 3881913024) strcat(s, "t");
if (crc32("HIGBIgRI",8) == 1387137942) strcat(s, "i");
if (crc32("VkolQGzSVQ",10) == 2074018092) strcat(s, "c");
if (crc32("xPSRHKyGNibN",12) == 2940346978) strcat(s, "a");
if (crc32("LmNUGrql",8) == 1720169587) strcat(s, "y");
if (crc32("LlWsuy",6) == 3999683777) strcat(s, "l");
if (crc32("MMQLhxDULqkO",12) == 4204601328) strcat(s, "l");
if (crc32("mTsPPyVtFaF",11) == 394835736) strcat(s, "y");
    return s;
}

char *odiously_adverbs() {
    char *s = calloc(9);
    if (crc32("rfNGrTminHdxdL",14) == 3704435671) strcat(s, "Y");
if (crc32("uabVdKy",7) == 2559227124) strcat(s, "o");
if (crc32("PSQtGjtw",8) == 672680627) strcat(s, "P");
if (crc32("XETVdtlwhaVL",12) == 189030891) strcat(s, "d");
if (crc32("zhdcmbA",7) == 1659728924) strcat(s, "i");
if (crc32("LEiQoHedIImcLsD",15) == 45980208) strcat(s, "o");
if (crc32("QXhkBABbiP",10) == 1953501443) strcat(s, "u");
if (crc32("eElQEKbMavSSf",13) == 1188438405) strcat(s, "s");
if (crc32("YqcVu",5) == 3076066527) strcat(s, "O");
if (crc32("SxBBrzJJgvrHObT",15) == 715099504) strcat(s, "l");
if (crc32("lOkZqlDmsuqEKCy",15) == 2767287568) strcat(s, "y");
    return s;
}

char *supercritically_adverbs() {
    char *s = calloc(16);
    if (crc32("RfGXrhlQrUMMeD",14) == 1875980423) strcat(s, "A");
if (crc32("vtBNUWv",7) == 4252279390) strcat(s, "s");
if (crc32("GHDguZqCGV",10) == 2890135991) strcat(s, "u");
if (crc32("kcMPwrWZjANSsQs",15) == 1672291881) strcat(s, "p");
if (crc32("OjuUfPaQg",9) == 440488991) strcat(s, "P");
if (crc32("JKFVfplPioGHzNc",15) == 2869550914) strcat(s, "e");
if (crc32("tIyYBiaskydwlT",14) == 3749436943) strcat(s, "r");
if (crc32("tobOLaDmA",9) == 405321163) strcat(s, "c");
if (crc32("KevDComC",8) == 1308560587) strcat(s, "r");
if (crc32("EyySVAGZvhd",11) == 2704431171) strcat(s, "D");
if (crc32("FnboD",5) == 317667179) strcat(s, "i");
if (crc32("BDRFElYNhnuze",13) == 4002526063) strcat(s, "b");
if (crc32("hGvVacnrxTy",11) == 75459048) strcat(s, "t");
if (crc32("SvfAAXQTIcfZwz",14) == 4018186368) strcat(s, "i");
if (crc32("OuQKJ",5) == 2184808742) strcat(s, "T");
if (crc32("bTjGBCHlGpL",11) == 1602146368) strcat(s, "c");
if (crc32("DPAbeeaCUjfhVb",14) == 4090959981) strcat(s, "a");
if (crc32("UIgQHyWka",9) == 3923211991) strcat(s, "E");
if (crc32("zowmIEC",7) == 3019432880) strcat(s, "l");
if (crc32("xNASZst",7) == 1949650410) strcat(s, "s");
if (crc32("ChIwUfPH",8) == 1811522410) strcat(s, "l");
if (crc32("qYGlTZmI",8) == 719405533) strcat(s, "w");
if (crc32("qTuGzweFe",9) == 3973967752) strcat(s, "y");
    return s;
}

char *halfexpectantly_adverbs() {
    char *s = calloc(16);
    if (crc32("fPXME",5) == 982745357) strcat(s, "h");
if (crc32("VnhMoQrGol",10) == 195074373) strcat(s, "a");
if (crc32("kjrSLleBthcdwA",14) == 2923747039) strcat(s, "q");
if (crc32("eyeTHdyYF",9) == 2119324134) strcat(s, "l");
if (crc32("MVqEbBB",7) == 1468357677) strcat(s, "L");
if (crc32("gVDiaTGXITwnBx",14) == 1714756489) strcat(s, "f");
if (crc32("tDuFfHFZ",8) == 38363911) strcat(s, "u");
if (crc32("TIAlTe",6) == 4065645025) strcat(s, "e");
if (crc32("PcUSWJsMUhwUP",13) == 833141727) strcat(s, "x");
if (crc32("rucJYGt",7) == 477253138) strcat(s, "p");
if (crc32("pTxednihSsnGqkK",15) == 4005394762) strcat(s, "e");
if (crc32("XfvYdBv",7) == 2057742681) strcat(s, "N");
if (crc32("AthMZ",5) == 3477185045) strcat(s, "c");
if (crc32("wzzbLkzJd",9) == 712260828) strcat(s, "t");
if (crc32("BbcKwrlXVgYaQ",13) == 2107233035) strcat(s, "a");
if (crc32("vvlqtgzbpMnPh",13) == 3424977890) strcat(s, "n");
if (crc32("jVjcmanCt",9) == 837216217) strcat(s, "t");
if (crc32("omBthseOqnEMxb",14) == 1416580560) strcat(s, "r");
if (crc32("ylgKpDF",7) == 2750871346) strcat(s, "l");
if (crc32("IHmDUO",6) == 1852184157) strcat(s, "y");
    return s;
}

char *vibrantly_adverbs() {
    char *s = calloc(10);
    if (crc32("PlMXolcYQnFff",13) == 198720017) strcat(s, "j");
if (crc32("ciqAQRgcwPFF",12) == 2593106626) strcat(s, "v");
if (crc32("qIgKHzBLaa",10) == 1180984090) strcat(s, "O");
if (crc32("BgSxqhDfc",9) == 2476746055) strcat(s, "i");
if (crc32("SAQhfSKfIzZfZkq",15) == 3917092362) strcat(s, "x");
if (crc32("AxTrUGLljgkrpV",14) == 926637683) strcat(s, "b");
if (crc32("LbRtmjYk",8) == 1481792856) strcat(s, "b");
if (crc32("UKUxWByyTtvG",12) == 3975170843) strcat(s, "r");
if (crc32("sKomIoxryOwRVTl",15) == 1349919866) strcat(s, "F");
if (crc32("PSxJxEZE",8) == 1228134232) strcat(s, "a");
if (crc32("JimOQpBrOCxCR",13) == 76683080) strcat(s, "u");
if (crc32("ZJiMJJHiKohzUmM",15) == 1037515112) strcat(s, "n");
if (crc32("XAmwR",5) == 1224592341) strcat(s, "t");
if (crc32("VfszQ",5) == 4030153662) strcat(s, "l");
if (crc32("XQiMXpIoDQWeWX",14) == 3927239095) strcat(s, "w");
if (crc32("NjavXoFXhFArtK",14) == 4044405816) strcat(s, "y");
    return s;
}

char *muzzily_adverbs() {
    char *s = calloc(8);
    if (crc32("HpmDrSKcQfesh",13) == 3698450794) strcat(s, "g");
if (crc32("oxdfkVwZ",8) == 1504659784) strcat(s, "m");
if (crc32("BipFsJl",7) == 3172099067) strcat(s, "i");
if (crc32("adbFRc",6) == 2815847711) strcat(s, "u");
if (crc32("zVdfhCid",8) == 4010727623) strcat(s, "z");
if (crc32("MzGvqPmUYqPqxL",14) == 1671551764) strcat(s, "z");
if (crc32("uIIjpuQnryx",11) == 723306373) strcat(s, "z");
if (crc32("jsPGy",5) == 2524424553) strcat(s, "i");
if (crc32("YyGELhRMrJY",11) == 3126010568) strcat(s, "l");
if (crc32("fPcxLXwoEjPtQ",13) == 3572545504) strcat(s, "S");
if (crc32("yJtbXrlkCmN",11) == 2368722012) strcat(s, "y");
    return s;
}

char *excellently_adverbs() {
    char *s = calloc(12);
    if (crc32("iSJAAnog",8) == 599365057) strcat(s, "e");
if (crc32("QLKQsX",6) == 474781805) strcat(s, "p");
if (crc32("YOoaKXGIqyK",11) == 2021687303) strcat(s, "x");
if (crc32("RSMeidaRy",9) == 2783185617) strcat(s, "Q");
if (crc32("inNudXQ",7) == 726588198) strcat(s, "c");
if (crc32("yZsUiRkIdgH",11) == 2858242126) strcat(s, "W");
if (crc32("kzBNtrg",7) == 2059133666) strcat(s, "e");
if (crc32("bSfszd",6) == 3748381791) strcat(s, "H");
if (crc32("leFQF",5) == 3725595554) strcat(s, "l");
if (crc32("HqqXQunDkYm",11) == 3829721373) strcat(s, "p");
if (crc32("dcrrQbsCAbmf",12) == 3194477860) strcat(s, "l");
if (crc32("Hutmstg",7) == 99215233) strcat(s, "v");
if (crc32("YqxtAGlmxbJceU",14) == 1286076633) strcat(s, "e");
if (crc32("oSJKKeCQSDcn",12) == 2116507307) strcat(s, "n");
if (crc32("xoseQ",5) == 2431578704) strcat(s, "u");
if (crc32("GJUNgUeDThZmEg",14) == 4117800552) strcat(s, "t");
if (crc32("JIuxAR",6) == 3165307126) strcat(s, "g");
if (crc32("BSqneXQDDjobeWs",15) == 3942062114) strcat(s, "l");
if (crc32("QWTzlOvmFcEv",12) == 295995207) strcat(s, "y");
    return s;
}

char *emotively_adverbs() {
    char *s = calloc(10);
    if (crc32("BhroXf",6) == 236896627) strcat(s, "e");
if (crc32("LJdEpVAyLi",10) == 3262738566) strcat(s, "m");
if (crc32("zEELPSkvgK",10) == 1894143135) strcat(s, "o");
if (crc32("HVIuzwpHRGXoUGn",15) == 992874329) strcat(s, "t");
if (crc32("bhwwboPdpooQ",12) == 2440827738) strcat(s, "b");
if (crc32("EDOsoGjgBxmkVFR",15) == 3786266501) strcat(s, "i");
if (crc32("EqZWaPj",7) == 3764417870) strcat(s, "c");
if (crc32("WerWvsRBVnQlK",13) == 1221863178) strcat(s, "v");
if (crc32("VlnKBArsHcUQ",12) == 2176119171) strcat(s, "c");
if (crc32("qfUJTPEHNUV",11) == 573377878) strcat(s, "e");
if (crc32("oeBxsW",6) == 2203099949) strcat(s, "l");
if (crc32("QlhNqB",6) == 4260705641) strcat(s, "O");
if (crc32("lLsDjSCUO",9) == 845953625) strcat(s, "y");
    return s;
}

char *oversweetly_adverbs() {
    char *s = calloc(12);
    if (crc32("YNijIve",7) == 1231187646) strcat(s, "B");
if (crc32("mEGnz",5) == 892447136) strcat(s, "o");
if (crc32("yKDGOafObpF",11) == 2007574982) strcat(s, "v");
if (crc32("dIjgUjs",7) == 2211971978) strcat(s, "e");
if (crc32("eAXHZYvjxBTQa",13) == 3200310017) strcat(s, "U");
if (crc32("RxDVKQnAMzipl",13) == 3294975753) strcat(s, "r");
if (crc32("yGxIkxrcFS",10) == 4044420230) strcat(s, "s");
if (crc32("srMKPA",6) == 297247728) strcat(s, "s");
if (crc32("DSgrlRuOKxl",11) == 2843379807) strcat(s, "w");
if (crc32("JOavpywzD",9) == 1364944452) strcat(s, "O");
if (crc32("tCBOOIgs",8) == 4284770522) strcat(s, "e");
if (crc32("RVlDDLLCwnS",11) == 1812036853) strcat(s, "e");
if (crc32("XrjxPuhQNgUWc",13) == 3111576787) strcat(s, "p");
if (crc32("mBAws",5) == 1320680471) strcat(s, "t");
if (crc32("eeUYqJTEzN",10) == 3448538838) strcat(s, "l");
if (crc32("eJJMLBmQ",8) == 2244140441) strcat(s, "x");
if (crc32("kVrgrq",6) == 3523709757) strcat(s, "y");
    return s;
}

char *intensely_adverbs() {
    char *s = calloc(10);
    if (crc32("sjNduOEAYRMB",12) == 1934321452) strcat(s, "i");
if (crc32("rjtSvkHnKmb",11) == 2511424796) strcat(s, "J");
if (crc32("xOfszCCGszJGDh",14) == 2059472428) strcat(s, "n");
if (crc32("ieXEAbn",7) == 746787658) strcat(s, "L");
if (crc32("jiLWaxDQLBBhiq",14) == 2176693462) strcat(s, "t");
if (crc32("EVgeUlPrzmqG",12) == 2943979123) strcat(s, "R");
if (crc32("gkQBKnRm",8) == 1720624522) strcat(s, "e");
if (crc32("DOIzyO",6) == 1481392846) strcat(s, "n");
if (crc32("yZWHRaaALyn",11) == 340825824) strcat(s, "q");
if (crc32("UfUaFYmEeJJrh",13) == 1064405974) strcat(s, "s");
if (crc32("YNiCKLittrAerw",14) == 2630787171) strcat(s, "W");
if (crc32("MuPtE",5) == 469310486) strcat(s, "e");
if (crc32("oLgUNFfiGfrYGI",14) == 1258002138) strcat(s, "l");
if (crc32("McAAaRYw",8) == 2244582951) strcat(s, "y");
    return s;
}

char *demurely_adverbs() {
    char *s = calloc(9);
    if (crc32("AcCXmHSaew",10) == 3746951433) strcat(s, "p");
if (crc32("RnOIVeOnrsyKHkQ",15) == 1212682119) strcat(s, "d");
if (crc32("Jgaui",5) == 1570999575) strcat(s, "e");
if (crc32("XMYlLodzTyJNOmf",15) == 2652757244) strcat(s, "m");
if (crc32("WRcnsWzoKfFvGn",14) == 2888762701) strcat(s, "A");
if (crc32("grTbuS",6) == 2285316008) strcat(s, "u");
if (crc32("VxiBnGKe",8) == 2757621427) strcat(s, "r");
if (crc32("AqgqsppkKNIbueF",15) == 2448076893) strcat(s, "e");
if (crc32("JKvZVf",6) == 1466796904) strcat(s, "l");
if (crc32("WtFSTTP",7) == 3650633899) strcat(s, "r");
if (crc32("pbDzWJnCzp",10) == 2913021168) strcat(s, "y");
    return s;
}

char *slenderly_adverbs() {
    char *s = calloc(10);
    if (crc32("JiBeNCwulpNLmKE",15) == 2420942048) strcat(s, "s");
if (crc32("rqnRF",5) == 3284712978) strcat(s, "l");
if (crc32("BboxCzbzEyPyB",13) == 3503686154) strcat(s, "e");
if (crc32("bmMVIicGquI",11) == 3589306885) strcat(s, "n");
if (crc32("mdDUv",5) == 452820145) strcat(s, "d");
if (crc32("QOkqw",5) == 111639710) strcat(s, "F");
if (crc32("xwhdJkizENmUft",14) == 2934516407) strcat(s, "e");
if (crc32("qFYzewyDVEXQ",12) == 2095688649) strcat(s, "k");
if (crc32("STrGbsTi",8) == 3892930134) strcat(s, "r");
if (crc32("tDEVcELqOxOmGg",14) == 625324723) strcat(s, "l");
if (crc32("HGtiecYTK",9) == 2979460591) strcat(s, "c");
if (crc32("smzrAwCq",8) == 175629782) strcat(s, "y");
    return s;
}

char *excusably_adverbs() {
    char *s = calloc(10);
    if (crc32("HPNcjYfDxY",10) == 2585787928) strcat(s, "e");
if (crc32("dTRyRJmkPNooOnt",15) == 3247754175) strcat(s, "x");
if (crc32("xaEWmLuy",8) == 1934342070) strcat(s, "H");
if (crc32("rlPnURgTWUMkVZq",15) == 3015494666) strcat(s, "c");
if (crc32("GPLbn",5) == 1673350456) strcat(s, "u");
if (crc32("yKQDiqLdsk",10) == 939423933) strcat(s, "s");
if (crc32("WZVAsSYpRa",10) == 2361538103) strcat(s, "a");
if (crc32("QWblUaIGt",9) == 1538139100) strcat(s, "b");
if (crc32("BcMVsrsuFsVyYww",15) == 309106867) strcat(s, "l");
if (crc32("lKNyqDKFGwp",11) == 245291660) strcat(s, "Z");
if (crc32("AZpztAkG",8) == 1145366575) strcat(s, "y");
    return s;
}

char *peerlessly_adverbs() {
    char *s = calloc(11);
    if (crc32("KpLzVjxyFvCAwmq",15) == 2821922794) strcat(s, "f");
if (crc32("yMjspbFYdm",10) == 1576066245) strcat(s, "p");
if (crc32("jgIfq",5) == 3636423823) strcat(s, "e");
if (crc32("LrbSsnMPPGZwUC",14) == 1722966470) strcat(s, "e");
if (crc32("GjlNbMf",7) == 3929992195) strcat(s, "C");
if (crc32("vuKmuRWDLVHBh",13) == 733614741) strcat(s, "r");
if (crc32("bnoOfATjPK",10) == 2400768534) strcat(s, "X");
if (crc32("fPaLaGoIiZGxsKf",15) == 950847604) strcat(s, "l");
if (crc32("XVexKt",6) == 3011495606) strcat(s, "G");
if (crc32("dcVPUkYk",8) == 1615955693) strcat(s, "e");
if (crc32("JXElJKgdhXVuPfg",15) == 830110479) strcat(s, "Q");
if (crc32("kogVOTqMmuWjSTZ",15) == 3308009158) strcat(s, "s");
if (crc32("SfZbwSb",7) == 3521403079) strcat(s, "s");
if (crc32("mWEugZhTEXlvZvM",15) == 713323282) strcat(s, "O");
if (crc32("RBnXnDj",7) == 943097483) strcat(s, "l");
if (crc32("tFRdzvkgzoMrXe",14) == 3771212069) strcat(s, "S");
if (crc32("VZYuOwdU",8) == 3810826295) strcat(s, "y");
    return s;
}

char *unhurriedly_adverbs() {
    char *s = calloc(12);
    if (crc32("TujOyuL",7) == 2012117752) strcat(s, "u");
if (crc32("qaYnBGKoV",9) == 2213695395) strcat(s, "M");
if (crc32("PFQSKIMBr",9) == 3106429699) strcat(s, "n");
if (crc32("ETMYuTYxHEeAuE",14) == 2161854294) strcat(s, "h");
if (crc32("ETPZBvTYdTH",11) == 397182749) strcat(s, "S");
if (crc32("ZuDHFrJMP",9) == 4089328781) strcat(s, "u");
if (crc32("bfUNwDd",7) == 832756530) strcat(s, "r");
if (crc32("pHxRLJHT",8) == 3814578579) strcat(s, "r");
if (crc32("anRrAc",6) == 3541659254) strcat(s, "l");
if (crc32("cvmPJ",5) == 978954345) strcat(s, "r");
if (crc32("EJmDNmuTgLiZKmW",15) == 1278461099) strcat(s, "l");
if (crc32("HulcfalbKLfwv",13) == 1706859408) strcat(s, "i");
if (crc32("LtQqtu",6) == 4003628416) strcat(s, "A");
if (crc32("gVmgGBELZYU",11) == 1121858341) strcat(s, "e");
if (crc32("AJmkRFBQCekKpOD",15) == 542171547) strcat(s, "d");
if (crc32("MMBTcO",6) == 3975484584) strcat(s, "v");
if (crc32("XvjiBkyUWq",10) == 2537538975) strcat(s, "l");
if (crc32("bAndqeO",7) == 2094871431) strcat(s, "y");
    return s;
}

char *unsequentially_adverbs() {
    char *s = calloc(15);
    if (crc32("LjDqbQJcQyrtad",14) == 2806883626) strcat(s, "u");
if (crc32("UOHnAAZvdrN",11) == 300053272) strcat(s, "D");
if (crc32("gQxqvYhA",8) == 2561386701) strcat(s, "n");
if (crc32("UvzveMw",7) == 4117259427) strcat(s, "u");
if (crc32("kmtaBfzCCL",10) == 3841483439) strcat(s, "s");
if (crc32("FiSDl",5) == 3914651110) strcat(s, "e");
if (crc32("XzufIMaH",8) == 3709295958) strcat(s, "d");
if (crc32("EATqvRsFoEL",11) == 2377646686) strcat(s, "q");
if (crc32("DRDgnoDlsZaZF",13) == 2888824639) strcat(s, "D");
if (crc32("GNOsxvtJIGV",11) == 2400175548) strcat(s, "u");
if (crc32("RmnjubirINGxQx",14) == 3433143897) strcat(s, "y");
if (crc32("GrVmLvaFd",9) == 811502169) strcat(s, "e");
if (crc32("nXNkY",5) == 1292413501) strcat(s, "J");
if (crc32("amBqDIPZUXD",11) == 592337174) strcat(s, "n");
if (crc32("nEljSRgf",8) == 573174892) strcat(s, "t");
if (crc32("qRqDdxDzio",10) == 2714016242) strcat(s, "l");
if (crc32("zitUtk",6) == 2420131210) strcat(s, "i");
if (crc32("siuFQSzCdHQlKF",14) == 2463536124) strcat(s, "I");
if (crc32("FPZeteb",7) == 548149387) strcat(s, "a");
if (crc32("lGSOlmvzSF",10) == 4240938970) strcat(s, "l");
if (crc32("ZyOQGrFUHMnNU",13) == 391419257) strcat(s, "W");
if (crc32("QSVWoZiPmv",10) == 1126099188) strcat(s, "l");
if (crc32("NHFivjMEkJpNRN",14) == 2797845692) strcat(s, "y");
    return s;
}

char *nonastringently_adverbs() {
    char *s = calloc(16);
    if (crc32("xygeP",5) == 667852982) strcat(s, "n");
if (crc32("jDsLKSu",7) == 1768109201) strcat(s, "K");
if (crc32("AFexpNd",7) == 698128150) strcat(s, "o");
if (crc32("ExYZjAxFY",9) == 146618297) strcat(s, "n");
if (crc32("XrwiwlLOHrwVulH",15) == 3776606108) strcat(s, "Q");
if (crc32("xYgve",5) == 2963311161) strcat(s, "a");
if (crc32("gTiIGkliD",9) == 961399294) strcat(s, "B");
if (crc32("FLdvigsiaZr",11) == 4270185802) strcat(s, "s");
if (crc32("bHfaw",5) == 802983810) strcat(s, "B");
if (crc32("VVFvhtgqH",9) == 3222024059) strcat(s, "t");
if (crc32("uONbNrCokCsRHvD",15) == 1193745336) strcat(s, "r");
if (crc32("HRyNFNgX",8) == 1804191491) strcat(s, "i");
if (crc32("SquitvemehgE",12) == 389232699) strcat(s, "n");
if (crc32("WNMHygQjW",9) == 453648190) strcat(s, "w");
if (crc32("YLJLBxEq",8) == 1590945663) strcat(s, "g");
if (crc32("ifqXUuVdxOiuPHO",15) == 673394747) strcat(s, "x");
if (crc32("YXHGuHM",7) == 3343636503) strcat(s, "e");
if (crc32("iGPkxzVg",8) == 801699694) strcat(s, "a");
if (crc32("HltojKnkmy",10) == 1642709779) strcat(s, "n");
if (crc32("SqqeYVSnpiqIm",13) == 2578821445) strcat(s, "t");
if (crc32("wuVWVwt",7) == 1373808847) strcat(s, "l");
if (crc32("HAPpYYiEpJacIS",14) == 1087190788) strcat(s, "y");
    return s;
}

char *fleeringly_adverbs() {
    char *s = calloc(11);
    if (crc32("nAARhCuu",8) == 863717635) strcat(s, "w");
if (crc32("AqEFCDeBSKxHthi",15) == 602550816) strcat(s, "f");
if (crc32("nrYRAD",6) == 2062933643) strcat(s, "x");
if (crc32("GJhRwmti",8) == 3383724654) strcat(s, "l");
if (crc32("TQdJBtwwMdjOyJ",14) == 70551893) strcat(s, "e");
if (crc32("imwELHRFJcR",11) == 875355553) strcat(s, "V");
if (crc32("DiULoqRMiQQo",12) == 4089376540) strcat(s, "e");
if (crc32("MzZxslU",7) == 1256189344) strcat(s, "r");
if (crc32("cvMYHyG",7) == 2229498366) strcat(s, "i");
if (crc32("bfykiGwCiqX",11) == 3036002929) strcat(s, "n");
if (crc32("tctMJRGotgs",11) == 2560137126) strcat(s, "g");
if (crc32("vjxQHhvPZIqD",12) == 1757908835) strcat(s, "i");
if (crc32("BIJOZHNDSs",10) == 2428423448) strcat(s, "l");
if (crc32("mdZPLtZddhmVSD",14) == 1670327353) strcat(s, "y");
    return s;
}

char *unpedagogically_adverbs() {
    char *s = calloc(16);
    if (crc32("IOtVfJQ",7) == 677922961) strcat(s, "l");
if (crc32("fxYhYsaxiPrby",13) == 36822160) strcat(s, "u");
if (crc32("bNfcd",5) == 374265481) strcat(s, "n");
if (crc32("HyxelhOy",8) == 956673065) strcat(s, "p");
if (crc32("aGzyX",5) == 1056809714) strcat(s, "Y");
if (crc32("kNdEgXCxole",11) == 1358750936) strcat(s, "e");
if (crc32("umYUVQgy",8) == 821843005) strcat(s, "d");
if (crc32("rqbNfliBb",9) == 1580238074) strcat(s, "U");
if (crc32("ltHBpzTOQDmR",12) == 2644465959) strcat(s, "a");
if (crc32("wrakoGUIHpKkgj",14) == 3881602079) strcat(s, "G");
if (crc32("tBPiTd",6) == 457254721) strcat(s, "g");
if (crc32("GUTLDog",7) == 4188155736) strcat(s, "w");
if (crc32("cPTddvmpI",9) == 3504876701) strcat(s, "o");
if (crc32("ryXmiyCFrSZ",11) == 1168921702) strcat(s, "U");
if (crc32("DFsuny",6) == 196046408) strcat(s, "g");
if (crc32("MRrGXlCmkt",10) == 526641331) strcat(s, "i");
if (crc32("HsZDEJfmEhbH",12) == 4244192268) strcat(s, "c");
if (crc32("nFYvgfyjgHohE",13) == 3207162805) strcat(s, "a");
if (crc32("ZSvkxYyuYyZt",12) == 2990975849) strcat(s, "f");
if (crc32("dbTit",5) == 3009280703) strcat(s, "l");
if (crc32("OGEjrVgiJZdumx",14) == 1107524621) strcat(s, "f");
if (crc32("ZwrkdFyjO",9) == 1320690635) strcat(s, "l");
if (crc32("YjzJCXuBTWUA",12) == 3128169153) strcat(s, "f");
if (crc32("ILbFXLPlI",9) == 1551323725) strcat(s, "y");
    return s;
}

char *incessantly_adverbs() {
    char *s = calloc(12);
    if (crc32("CYSce",5) == 1921427702) strcat(s, "i");
if (crc32("TrWAYNuzFvC",11) == 4132467508) strcat(s, "n");
if (crc32("VctEz",5) == 3227262816) strcat(s, "P");
if (crc32("ggtSsIQqDrtFKsG",15) == 34475731) strcat(s, "c");
if (crc32("awNhAEu",7) == 2384733935) strcat(s, "c");
if (crc32("tbPbtsXcr",9) == 1489860694) strcat(s, "e");
if (crc32("PhSnnGnweBwW",12) == 441703746) strcat(s, "k");
if (crc32("fYqsA",5) == 917466252) strcat(s, "s");
if (crc32("sXthmtWSrP",10) == 1363648402) strcat(s, "s");
if (crc32("LnXIesJyaPMx",12) == 3271039180) strcat(s, "c");
if (crc32("yNvhDACwWLd",11) == 204948666) strcat(s, "a");
if (crc32("qEmWCJIZY",9) == 3504076598) strcat(s, "P");
if (crc32("LUxulWHwcHMTkQq",15) == 415981265) strcat(s, "n");
if (crc32("IlLzvNL",7) == 1501974334) strcat(s, "W");
if (crc32("xiwAvmsrHNG",11) == 3476824274) strcat(s, "t");
if (crc32("XpzXaUKXYFiss",13) == 1066564794) strcat(s, "l");
if (crc32("OOBZPLznjenWp",13) == 318621677) strcat(s, "Y");
if (crc32("JGFcWUUJQ",9) == 758885769) strcat(s, "y");
    return s;
}

char *nonadhesively_adverbs() {
    char *s = calloc(14);
    if (crc32("vlVYlbrka",9) == 2941543663) strcat(s, "n");
if (crc32("sfKqcJWCkJhUfJ",14) == 2376679343) strcat(s, "o");
if (crc32("DHcqEfy",7) == 2937947875) strcat(s, "n");
if (crc32("tZbzAykMsrF",11) == 1501786054) strcat(s, "a");
if (crc32("yYpvPfAjz",9) == 3115789526) strcat(s, "d");
if (crc32("sJmYTmdkjsv",11) == 2043370508) strcat(s, "h");
if (crc32("xThOvLCLVMMxP",13) == 2403888468) strcat(s, "e");
if (crc32("BpyOzMdod",9) == 1198336219) strcat(s, "V");
if (crc32("zbRyFDN",7) == 3049953811) strcat(s, "s");
if (crc32("ZqoYbjQSGOke",12) == 2945779207) strcat(s, "i");
if (crc32("BxMgHES",7) == 3728758481) strcat(s, "S");
if (crc32("nSljqOq",7) == 3245739955) strcat(s, "v");
if (crc32("xioVRwSprSd",11) == 1292335978) strcat(s, "B");
if (crc32("zElhWE",6) == 1326511250) strcat(s, "e");
if (crc32("yvTnPP",6) == 1015782074) strcat(s, "l");
if (crc32("XNCdzCpD",8) == 981147503) strcat(s, "y");
    return s;
}

char *nonirrevocably_adverbs() {
    char *s = calloc(15);
    if (crc32("HwvXxdccHclcAbg",15) == 3925786620) strcat(s, "M");
if (crc32("obRwjXknA",9) == 913073077) strcat(s, "n");
if (crc32("KUFHPu",6) == 6131311) strcat(s, "L");
if (crc32("TRftM",5) == 1708224370) strcat(s, "o");
if (crc32("pqzoHqo",7) == 1070280845) strcat(s, "O");
if (crc32("WeLqZlHzm",9) == 2968361111) strcat(s, "n");
if (crc32("LanDmSZdZR",10) == 3166132735) strcat(s, "i");
if (crc32("MQtdnEkVTtzyD",13) == 2110096300) strcat(s, "y");
if (crc32("qDTlwymyhXSVfb",14) == 159467934) strcat(s, "r");
if (crc32("pFIreaFQ",8) == 1776836599) strcat(s, "X");
if (crc32("YAADsiZor",9) == 1852045775) strcat(s, "r");
if (crc32("DgWLgvfxCgIBs",13) == 2939041270) strcat(s, "s");
if (crc32("ZpqKItCJ",8) == 1514681347) strcat(s, "e");
if (crc32("VRRuxawknhZwT",13) == 3161660436) strcat(s, "t");
if (crc32("IpJFk",5) == 4189074940) strcat(s, "v");
if (crc32("yQGiUreeLi",10) == 3650328309) strcat(s, "h");
if (crc32("quJVAGmjBluu",12) == 3256552142) strcat(s, "o");
if (crc32("TgSnQJeFynwHh",13) == 1816674331) strcat(s, "c");
if (crc32("btYJuc",6) == 3042426002) strcat(s, "a");
if (crc32("IJPEDSO",7) == 117389022) strcat(s, "e");
if (crc32("vbXWHjswZ",9) == 2006979477) strcat(s, "b");
if (crc32("ZdkvYtqJIRoVT",13) == 2415034945) strcat(s, "r");
if (crc32("uQVPZug",7) == 2013600839) strcat(s, "l");
if (crc32("MXNEuFYpg",9) == 1356317920) strcat(s, "R");
if (crc32("WdvfyGD",7) == 353236783) strcat(s, "y");
    return s;
}

char *noninstructionally_adverbs() {
    char *s = calloc(19);
    if (crc32("wWXqcfUTuNjKea",14) == 1183401665) strcat(s, "n");
if (crc32("vqvHSra",7) == 1322093618) strcat(s, "P");
if (crc32("klAZWzjKLjUYJm",14) == 2207345709) strcat(s, "o");
if (crc32("TZTdRsVw",8) == 829591014) strcat(s, "K");
if (crc32("vOxeRC",6) == 836054691) strcat(s, "n");
if (crc32("XSzQQtbSKPB",11) == 3846154997) strcat(s, "v");
if (crc32("iDRCvdZH",8) == 2098093622) strcat(s, "i");
if (crc32("wzzBVgCuZ",9) == 4284211449) strcat(s, "n");
if (crc32("xYltYSJmjJJ",11) == 3654908005) strcat(s, "f");
if (crc32("CIOUbKuYmH",10) == 2560698632) strcat(s, "s");
if (crc32("DXkVTF",6) == 423890315) strcat(s, "U");
if (crc32("aXxwEzbyzCGPd",13) == 2431771332) strcat(s, "t");
if (crc32("MmjTZ",5) == 3206818423) strcat(s, "r");
if (crc32("ycLUzkXH",8) == 2926572481) strcat(s, "u");
if (crc32("TLzqWsNzfpwL",12) == 3484577773) strcat(s, "c");
if (crc32("PHUaQeXn",8) == 1337182104) strcat(s, "U");
if (crc32("ukIsvoIgpFOutq",14) == 3179599654) strcat(s, "t");
if (crc32("IwtefZzQQnQc",12) == 2421745780) strcat(s, "i");
if (crc32("ZBTjHFnMMroI",12) == 1059339418) strcat(s, "C");
if (crc32("APmEGgWRagPtIzL",15) == 2653975413) strcat(s, "o");
if (crc32("TgItGvTnw",9) == 2828307912) strcat(s, "n");
if (crc32("temDAeetcTt",11) == 1425666713) strcat(s, "K");
if (crc32("viWtfsshdxPQNU",14) == 1249293873) strcat(s, "a");
if (crc32("QaTDUT",6) == 1249158425) strcat(s, "l");
if (crc32("KAzDeZMwhHRRv",13) == 2415666619) strcat(s, "X");
if (crc32("ZSmgfhzVrtjCy",13) == 2969920380) strcat(s, "l");
if (crc32("cMRzil",6) == 1469618077) strcat(s, "y");
    return s;
}

char *malgr_adverbs() {
    char *s = calloc(6);
    if (crc32("zhmdugLTH",9) == 329651611) strcat(s, "z");
if (crc32("AeJwtU",6) == 3511770962) strcat(s, "m");
if (crc32("pLqkb",5) == 4085023347) strcat(s, "i");
if (crc32("oyAmBTqGyUQ",11) == 646628232) strcat(s, "a");
if (crc32("pskXITh",7) == 2512026494) strcat(s, "i");
if (crc32("jAwyCugh",8) == 2531191666) strcat(s, "l");
if (crc32("FGTrfWhNgtC",11) == 1508810878) strcat(s, "G");
if (crc32("vwHFGMXvgPAjkjB",15) == 1129325757) strcat(s, "g");
if (crc32("hEygjBoD",8) == 3278992837) strcat(s, "r");
    return s;
}

char *lifelessly_adverbs() {
    char *s = calloc(11);
    if (crc32("XXmOvjoXbPCE",12) == 849649458) strcat(s, "l");
if (crc32("jDJaTI",6) == 1454519866) strcat(s, "K");
if (crc32("LQxPR",5) == 1303150326) strcat(s, "i");
if (crc32("CvFxnEi",7) == 3085303626) strcat(s, "f");
if (crc32("cvXeZ",5) == 1200045513) strcat(s, "w");
if (crc32("WYpeeiudu",9) == 1782210337) strcat(s, "e");
if (crc32("IuTCDOgcCi",10) == 3534661701) strcat(s, "l");
if (crc32("MPXjngDVDJITCLD",15) == 650495927) strcat(s, "e");
if (crc32("VrANZWcQDX",10) == 3937980058) strcat(s, "s");
if (crc32("ErrZdLY",7) == 331945944) strcat(s, "D");
if (crc32("nhKdctwTOiUZHeX",15) == 259546825) strcat(s, "s");
if (crc32("aJVlbVo",7) == 3540363274) strcat(s, "R");
if (crc32("GfSdiE",6) == 2432876507) strcat(s, "l");
if (crc32("YonPazqMkV",10) == 245645027) strcat(s, "n");
if (crc32("olemUrmwimQhNM",14) == 1257790621) strcat(s, "y");
    return s;
}

char *overobediently_adverbs() {
    char *s = calloc(15);
    if (crc32("vPRxKnesE",9) == 2243061894) strcat(s, "e");
if (crc32("MgHPwxDnPalyL",13) == 1855911334) strcat(s, "o");
if (crc32("kfEovqamtVNLU",13) == 63398794) strcat(s, "v");
if (crc32("hIJPNOPwOplruB",14) == 3770619508) strcat(s, "e");
if (crc32("OkBcWGla",8) == 2456542616) strcat(s, "U");
if (crc32("AqOlMv",6) == 3481218683) strcat(s, "r");
if (crc32("avhLFOMMGOnUr",13) == 2700264896) strcat(s, "o");
if (crc32("DdeIsCrWYXYeDj",14) == 1258249099) strcat(s, "b");
if (crc32("VDLsEuutg",9) == 26731986) strcat(s, "Z");
if (crc32("TEKslS",6) == 2537951659) strcat(s, "e");
if (crc32("VMtfzWSRrrXRs",13) == 2317867454) strcat(s, "L");
if (crc32("VjlBfFA",7) == 4068150050) strcat(s, "d");
if (crc32("VfTjDufiVTR",11) == 3247731523) strcat(s, "i");
if (crc32("jkevek",6) == 128943954) strcat(s, "w");
if (crc32("xGeSEUGvYzfSLv",14) == 2023114789) strcat(s, "e");
if (crc32("iROkllPs",8) == 1303012783) strcat(s, "n");
if (crc32("IkWcGbI",7) == 3301107380) strcat(s, "j");
if (crc32("rqsAEtMZJevP",12) == 1209775511) strcat(s, "t");
if (crc32("ffZRo",5) == 4206245206) strcat(s, "l");
if (crc32("LIcivcGnsDr",11) == 3271111725) strcat(s, "z");
if (crc32("PsXughuVDFSUW",13) == 2542344072) strcat(s, "y");
    return s;
}

char *overtediously_adverbs() {
    char *s = calloc(14);
    if (crc32("mqWBhmTpSuPEh",13) == 3298160727) strcat(s, "p");
if (crc32("LbnwfjuggfRDMut",15) == 879503485) strcat(s, "o");
if (crc32("MLRuQGpHKfqV",12) == 3117996148) strcat(s, "u");
if (crc32("OGYIGxQfJvFFb",13) == 66641706) strcat(s, "v");
if (crc32("tLmToRtYTzMznZX",15) == 294142963) strcat(s, "p");
if (crc32("puWtsgkrNbirWW",14) == 2383641788) strcat(s, "e");
if (crc32("cqdHftHzJfIuutV",15) == 3094942776) strcat(s, "r");
if (crc32("uQJEFOTnchuLWA",14) == 2015891061) strcat(s, "t");
if (crc32("PYKRBs",6) == 2686528525) strcat(s, "e");
if (crc32("PIQVhqIjT",9) == 191028749) strcat(s, "d");
if (crc32("CiXiAloeaLZ",11) == 1475561727) strcat(s, "W");
if (crc32("dpjWBo",6) == 4183781948) strcat(s, "i");
if (crc32("JGqTrjKEaPz",11) == 4260239116) strcat(s, "W");
if (crc32("ObVKewHk",8) == 3284456559) strcat(s, "o");
if (crc32("ncJYQ",5) == 3282823605) strcat(s, "u");
if (crc32("OWQFCJgwm",9) == 662257099) strcat(s, "y");
if (crc32("TwCzhAyEazmnWJ",14) == 1159865655) strcat(s, "s");
if (crc32("FoouMZNDDQxjO",13) == 2549932966) strcat(s, "L");
if (crc32("MaiGk",5) == 3347409470) strcat(s, "l");
if (crc32("JHpzP",5) == 1619750911) strcat(s, "y");
    return s;
}

char *superciliously_adverbs() {
    char *s = calloc(15);
    if (crc32("VjXdFY",6) == 3912782806) strcat(s, "x");
if (crc32("xWODLseocb",10) == 875160506) strcat(s, "s");
if (crc32("fWlimiAcC",9) == 45066896) strcat(s, "u");
if (crc32("BjsnQOFEuEAOdD",14) == 753368563) strcat(s, "Y");
if (crc32("ZAQJgtJnJ",9) == 269921307) strcat(s, "p");
if (crc32("XHpoPAQT",8) == 4055298292) strcat(s, "e");
if (crc32("ptrCEKwwSdV",11) == 815081120) strcat(s, "r");
if (crc32("oKYmQhaOaKxFMS",14) == 4125704557) strcat(s, "c");
if (crc32("FqLwFiBs",8) == 27116315) strcat(s, "i");
if (crc32("ZSrhzpRw",8) == 1785544444) strcat(s, "p");
if (crc32("iMqjDolLpVJhuN",14) == 3645983813) strcat(s, "l");
if (crc32("plVZGGan",8) == 292478932) strcat(s, "D");
if (crc32("YdouCJvujnQaxp",14) == 2875919545) strcat(s, "i");
if (crc32("IWMNmimgAJ",10) == 3930954930) strcat(s, "o");
if (crc32("IfVSwISM",8) == 246037585) strcat(s, "u");
if (crc32("eCXdZ",5) == 2936716096) strcat(s, "T");
if (crc32("fcnkQKP",7) == 618127814) strcat(s, "s");
if (crc32("ncSwHylTuexNnT",14) == 1558795753) strcat(s, "v");
if (crc32("jAfVrg",6) == 3315460404) strcat(s, "l");
if (crc32("IzwCWrwsuppLVaS",15) == 1770993355) strcat(s, "P");
if (crc32("OqjiyJ",6) == 4028063132) strcat(s, "y");
    return s;
}

char *uneloquently_adverbs() {
    char *s = calloc(13);
    if (crc32("FrfEgsBcUPfi",12) == 1177750561) strcat(s, "u");
if (crc32("vAVuuNmUhI",10) == 2044814398) strcat(s, "I");
if (crc32("VudZDlLVwHOccNw",15) == 3626068695) strcat(s, "n");
if (crc32("ojulJJBGj",9) == 3116313618) strcat(s, "m");
if (crc32("BwbiaRKde",9) == 117073017) strcat(s, "e");
if (crc32("EmVRXDgfLtkf",12) == 2382171501) strcat(s, "n");
if (crc32("bVIlno",6) == 3255773834) strcat(s, "l");
if (crc32("eFWosdBbFFlkbD",14) == 2200771557) strcat(s, "P");
if (crc32("XlpMdCUcEMONT",13) == 1032100340) strcat(s, "o");
if (crc32("BDYCRXn",7) == 2334141897) strcat(s, "R");
if (crc32("weulVfVYK",9) == 1627298419) strcat(s, "q");
if (crc32("NkkdJHqvAAiHbOc",15) == 3243118995) strcat(s, "u");
if (crc32("MItfnQtWydbrN",13) == 1227128878) strcat(s, "e");
if (crc32("XUNnvz",6) == 1373365492) strcat(s, "n");
if (crc32("yFuxcVEnoKVmhSX",15) == 1675568854) strcat(s, "t");
if (crc32("qXxAl",5) == 4222448624) strcat(s, "l");
if (crc32("GrznSPWntWh",11) == 1823906212) strcat(s, "y");
    return s;
}

char *whizzingly_adverbs() {
    char *s = calloc(11);
    if (crc32("EZoVujZLpXkKmbK",15) == 2837470029) strcat(s, "w");
if (crc32("XdKQNGGsBA",10) == 4126295955) strcat(s, "h");
if (crc32("ZiPWRdwj",8) == 1449565448) strcat(s, "v");
if (crc32("fbLvdyot",8) == 1005454631) strcat(s, "i");
if (crc32("NFicGtAsvrUg",12) == 2555675000) strcat(s, "z");
if (crc32("GgRxvLKXPpPmHf",14) == 2131251372) strcat(s, "n");
if (crc32("MTRlwPD",7) == 2251879230) strcat(s, "z");
if (crc32("lswNVMzyRJt",11) == 3769814904) strcat(s, "i");
if (crc32("YXeqEFZdJROBeiS",15) == 1392321450) strcat(s, "n");
if (crc32("JjmPfcRtRbUq",12) == 1860614559) strcat(s, "g");
if (crc32("qNqRP",5) == 3482221865) strcat(s, "l");
if (crc32("EpNMWfMBlLoFKI",14) == 2770116781) strcat(s, "Y");
if (crc32("sduoafEJUu",10) == 2240542484) strcat(s, "y");
    return s;
}

char *irrevocably_adverbs() {
    char *s = calloc(12);
    if (crc32("rnvVc",5) == 4142864976) strcat(s, "i");
if (crc32("AfRWxVvJlPJWSz",14) == 3077914484) strcat(s, "r");
if (crc32("IJjXwpIWuad",11) == 1162041853) strcat(s, "r");
if (crc32("yRMsdIFsfnJ",11) == 2040287660) strcat(s, "t");
if (crc32("GgWvSA",6) == 510028866) strcat(s, "e");
if (crc32("hNhylerkJE",10) == 242648694) strcat(s, "e");
if (crc32("SqEMujQTER",10) == 2329070646) strcat(s, "v");
if (crc32("OCyorXdvtVdkq",13) == 3341050542) strcat(s, "U");
if (crc32("zZLWuq",6) == 2762165191) strcat(s, "o");
if (crc32("TEFyeeYRz",9) == 2853054326) strcat(s, "K");
if (crc32("bIaiuTpbicnLNdx",15) == 2872622074) strcat(s, "c");
if (crc32("eheVtpHzThjC",12) == 2897126406) strcat(s, "P");
if (crc32("jwqQFPjVsWoUfy",14) == 3122179514) strcat(s, "a");
if (crc32("gnbWBfIC",8) == 3899787098) strcat(s, "J");
if (crc32("ifaWblRvXoHKm",13) == 573486477) strcat(s, "b");
if (crc32("OiMmJuLTNvNyaKr",15) == 907189194) strcat(s, "l");
if (crc32("kWfOoyLK",8) == 2407054329) strcat(s, "y");
    return s;
}

char *unmanageably_adverbs() {
    char *s = calloc(13);
    if (crc32("HOobjQLrTd",10) == 3297616066) strcat(s, "u");
if (crc32("rYyOg",5) == 613321208) strcat(s, "M");
if (crc32("tAnLeAvauYGS",12) == 3445588533) strcat(s, "n");
if (crc32("ugsGXQT",7) == 594895739) strcat(s, "m");
if (crc32("VLldRvTPdJtkncm",15) == 183170853) strcat(s, "g");
if (crc32("XWuFk",5) == 3068313316) strcat(s, "a");
if (crc32("MTieiXcCA",9) == 2104293316) strcat(s, "d");
if (crc32("eGYqbD",6) == 3328472560) strcat(s, "n");
if (crc32("wlKrSJOKurP",11) == 2500835871) strcat(s, "o");
if (crc32("qGEalJNFReGQ",12) == 22049263) strcat(s, "a");
if (crc32("hsiKxvcUFYM",11) == 795326865) strcat(s, "g");
if (crc32("HBrybPgKDvPC",12) == 1555367144) strcat(s, "n");
if (crc32("LzPvqwSdAXR",11) == 1598276910) strcat(s, "e");
if (crc32("jjxESPUj",8) == 2734851983) strcat(s, "a");
if (crc32("hzgCu",5) == 3712077753) strcat(s, "b");
if (crc32("zIwVREjM",8) == 2826916747) strcat(s, "l");
if (crc32("thXPewiTeFqAxZ",14) == 4037187160) strcat(s, "J");
if (crc32("FmgXeKiMuaYeN",13) == 3758961490) strcat(s, "y");
    return s;
}

char *invalidly_adverbs() {
    char *s = calloc(10);
    if (crc32("ndBkX",5) == 3301141601) strcat(s, "i");
if (crc32("IubUHu",6) == 1261438677) strcat(s, "n");
if (crc32("WQgVUpKxsSRtkFV",15) == 3584211931) strcat(s, "s");
if (crc32("cQudiLkURd",10) == 3519060006) strcat(s, "v");
if (crc32("ElDVyz",6) == 598941184) strcat(s, "h");
if (crc32("mTltTHaxAkKJ",12) == 771221250) strcat(s, "a");
if (crc32("HqYpneLxK",9) == 189027397) strcat(s, "l");
if (crc32("ekWirIDOT",9) == 3180306976) strcat(s, "i");
if (crc32("Ippcudb",7) == 2947944827) strcat(s, "x");
if (crc32("rEYvqkO",7) == 4143987539) strcat(s, "d");
if (crc32("EQtBzYRmBym",11) == 174022053) strcat(s, "l");
if (crc32("TqdnaAvdQxdKl",13) == 1473662471) strcat(s, "y");
    return s;
}

char *superingeniously_adverbs() {
    char *s = calloc(17);
    if (crc32("WaFSmSv",7) == 3728890864) strcat(s, "s");
if (crc32("fOygd",5) == 3091074336) strcat(s, "T");
if (crc32("djnMjZENuL",10) == 844501741) strcat(s, "u");
if (crc32("xLCcQi",6) == 126597583) strcat(s, "C");
if (crc32("eHCLLuMErTAZktt",15) == 373605307) strcat(s, "p");
if (crc32("dDZIrj",6) == 3829520605) strcat(s, "e");
if (crc32("wtFoQf",6) == 1362295121) strcat(s, "r");
if (crc32("hHDPTwTTZ",9) == 2625236624) strcat(s, "A");
if (crc32("kLiggXciPfi",11) == 3944722283) strcat(s, "i");
if (crc32("SaKuwXhHx",9) == 3380988352) strcat(s, "n");
if (crc32("EEsvZIJjTFC",11) == 1002064501) strcat(s, "k");
if (crc32("qveMX",5) == 582951015) strcat(s, "g");
if (crc32("mvbcBGlCeHBEVB",14) == 739036307) strcat(s, "e");
if (crc32("WiLouYvqz",9) == 3810992585) strcat(s, "p");
if (crc32("YeMVCZsTOVkH",12) == 2756848720) strcat(s, "n");
if (crc32("PZFalspS",8) == 3893910266) strcat(s, "b");
if (crc32("dpylWFRfEAK",11) == 3143086847) strcat(s, "i");
if (crc32("DfnRGqRTRNKw",12) == 1076203142) strcat(s, "o");
if (crc32("zLjQJHkaa",9) == 2086269129) strcat(s, "T");
if (crc32("RMZHvQmZ",8) == 3937145269) strcat(s, "u");
if (crc32("rQDIRQ",6) == 227003523) strcat(s, "s");
if (crc32("cOojRfNasWU",11) == 3103995272) strcat(s, "l");
if (crc32("menMsFjQzehgA",13) == 4144830393) strcat(s, "f");
if (crc32("lkhGBHunoDwQVmM",15) == 512853418) strcat(s, "y");
    return s;
}

char *uncompetently_adverbs() {
    char *s = calloc(14);
    if (crc32("zgoEiTyPeq",10) == 2188399092) strcat(s, "u");
if (crc32("vieRgAmLCELJRYz",15) == 4287966753) strcat(s, "l");
if (crc32("ltYXuBesiXu",11) == 1464503883) strcat(s, "n");
if (crc32("QPzoYHnQeZf",11) == 2911450090) strcat(s, "c");
if (crc32("mwyumARxl",9) == 1098861481) strcat(s, "o");
if (crc32("UElsnnhDoAY",11) == 2591608002) strcat(s, "Q");
if (crc32("oWGJiRFha",9) == 67064319) strcat(s, "m");
if (crc32("ABKozZDZe",9) == 3862644939) strcat(s, "p");
if (crc32("sQShLYzxqbhhkB",14) == 1137208223) strcat(s, "Q");
if (crc32("oslXchU",7) == 3286962353) strcat(s, "e");
if (crc32("sUOlVpkpE",9) == 1136356206) strcat(s, "K");
if (crc32("gtkSVGhExyTwX",13) == 240947950) strcat(s, "t");
if (crc32("PfyDOwaspssgn",13) == 2185205597) strcat(s, "e");
if (crc32("nuiiwYBxA",9) == 1463755693) strcat(s, "j");
if (crc32("ffxotDy",7) == 4017391016) strcat(s, "n");
if (crc32("QKdeIYTL",8) == 1557737376) strcat(s, "t");
if (crc32("lkOKl",5) == 3531493671) strcat(s, "K");
if (crc32("GLjOfAnWqU",10) == 1882453288) strcat(s, "l");
if (crc32("jwJekufSJf",10) == 1571759174) strcat(s, "y");
    return s;
}

char *overdeliciously_adverbs() {
    char *s = calloc(16);
    if (crc32("AzpRUaRkHY",10) == 417672353) strcat(s, "o");
if (crc32("mLNaUcRlo",9) == 4051310996) strcat(s, "J");
if (crc32("WEVDqo",6) == 1116082121) strcat(s, "v");
if (crc32("UjMfS",5) == 3904556011) strcat(s, "u");
if (crc32("gBSjOviWyOVzp",13) == 970293592) strcat(s, "e");
if (crc32("akmKFyHCzuxdqZU",15) == 1901286294) strcat(s, "r");
if (crc32("SwrXPXT",7) == 3929326329) strcat(s, "H");
if (crc32("aOdYoTRHttTIX",13) == 4188814356) strcat(s, "d");
if (crc32("ccFHUmjoB",9) == 521908370) strcat(s, "e");
if (crc32("fzcxj",5) == 3569499081) strcat(s, "l");
if (crc32("GjgKaGbGYS",10) == 2652499340) strcat(s, "i");
if (crc32("GvdgKLZa",8) == 60681227) strcat(s, "y");
if (crc32("dfuserBirv",10) == 613475122) strcat(s, "c");
if (crc32("PTrDToooWcS",11) == 1498114119) strcat(s, "J");
if (crc32("diLJvEkmlzAFed",14) == 221180864) strcat(s, "i");
if (crc32("JBcgpfR",7) == 3521430494) strcat(s, "p");
if (crc32("sZXPRjByVIWw",12) == 1319145717) strcat(s, "o");
if (crc32("dxjXD",5) == 1848072076) strcat(s, "I");
if (crc32("WTgNAA",6) == 1503039701) strcat(s, "u");
if (crc32("pgJdxBUkprv",11) == 3370023281) strcat(s, "s");
if (crc32("WyvDBLaoUXyVb",13) == 4088019926) strcat(s, "l");
if (crc32("HcZmZzhIZqXIOM",14) == 596739751) strcat(s, "y");
    return s;
}

char *urbanistically_adverbs() {
    char *s = calloc(15);
    if (crc32("FcfOwSCalucH",12) == 4144521476) strcat(s, "C");
if (crc32("DvwlkrGANgX",11) == 3606035982) strcat(s, "u");
if (crc32("GmCSoOmiBi",10) == 3699735909) strcat(s, "r");
if (crc32("oekHitcG",8) == 208238207) strcat(s, "b");
if (crc32("KUtgYDcD",8) == 3196081688) strcat(s, "Y");
if (crc32("DhsGhuBSoL",10) == 661563792) strcat(s, "a");
if (crc32("hHeBpdwPT",9) == 959030374) strcat(s, "s");
if (crc32("VxPiOGVdQohh",12) == 3164960332) strcat(s, "n");
if (crc32("haoYnNy",7) == 1179081286) strcat(s, "I");
if (crc32("ttBIOMKSCQIySj",14) == 45913186) strcat(s, "i");
if (crc32("BCmYJdoxEEG",11) == 1571713657) strcat(s, "e");
if (crc32("NgtbMsQhn",9) == 3302311181) strcat(s, "s");
if (crc32("gJdXqTjTh",9) == 2706483916) strcat(s, "t");
if (crc32("tfsjkKsgXoK",11) == 1678944304) strcat(s, "y");
if (crc32("GkuWhBwhND",10) == 720060602) strcat(s, "i");
if (crc32("NnwvZUAx",8) == 2607977679) strcat(s, "c");
if (crc32("ffnydFj",7) == 3741872101) strcat(s, "a");
if (crc32("ptGNHrS",7) == 3779931287) strcat(s, "l");
if (crc32("fhhEJBloV",9) == 793554784) strcat(s, "l");
if (crc32("SUQtMPwSuOOdzCU",15) == 1155942520) strcat(s, "y");
    return s;
}

char *peradventure_adverbs() {
    char *s = calloc(13);
    if (crc32("jgrHauQtpJCeD",13) == 3024510667) strcat(s, "j");
if (crc32("RmJbEfqnGWvFXW",14) == 1161042677) strcat(s, "p");
if (crc32("MKfoss",6) == 3187670840) strcat(s, "e");
if (crc32("EQTRHyBnm",9) == 3096132378) strcat(s, "r");
if (crc32("fSpetROoaFkKklp",15) == 2524599551) strcat(s, "a");
if (crc32("eCrsLPUGHWwPZBd",15) == 1665032527) strcat(s, "d");
if (crc32("eyhPzjIlIj",10) == 3228111488) strcat(s, "E");
if (crc32("UJvbcykfLPQtN",13) == 1655323654) strcat(s, "v");
if (crc32("EyUvVOt",7) == 1502477019) strcat(s, "Y");
if (crc32("fEKqrSCnMB",10) == 3123332849) strcat(s, "e");
if (crc32("DPzraVYIYQu",11) == 1415746384) strcat(s, "i");
if (crc32("NiRRilOBnZpKmF",14) == 2392901855) strcat(s, "n");
if (crc32("AKeUBPer",8) == 2515784511) strcat(s, "t");
if (crc32("QBcxmNvNyfsiBGr",15) == 3551298246) strcat(s, "t");
if (crc32("PrVlyiH",7) == 2850595392) strcat(s, "u");
if (crc32("MMAcpTVSLqyJ",12) == 4009261168) strcat(s, "r");
if (crc32("vSZdd",5) == 1131274938) strcat(s, "e");
    return s;
}

char *esoterically_adverbs() {
    char *s = calloc(13);
    if (crc32("edfGIOJbnYybACU",15) == 3872947106) strcat(s, "e");
if (crc32("JcEdnxe",7) == 1331150803) strcat(s, "s");
if (crc32("JIRdfOslDELVw",13) == 4202294550) strcat(s, "o");
if (crc32("SAPCUGkUvxsGXyv",15) == 2579873702) strcat(s, "t");
if (crc32("cHJcmVOWJ",9) == 2648811495) strcat(s, "T");
if (crc32("bjbPuenBYDyYq",13) == 2669291117) strcat(s, "e");
if (crc32("GMxBRifLjF",10) == 2920577465) strcat(s, "r");
if (crc32("fYROEvPDpKe",11) == 2809603662) strcat(s, "i");
if (crc32("dWqiSUqIX",9) == 1339678386) strcat(s, "c");
if (crc32("GIrjmskgDUf",11) == 1383027974) strcat(s, "a");
if (crc32("tzPireIOpNjUYTM",15) == 2006176633) strcat(s, "z");
if (crc32("qgHHhEaOOPcNKV",14) == 1938261109) strcat(s, "l");
if (crc32("fdpwOQObro",10) == 280522234) strcat(s, "C");
if (crc32("WCdgEUqJ",8) == 2445609006) strcat(s, "l");
if (crc32("SvBQkoR",7) == 539673111) strcat(s, "y");
    return s;
}

char *goodhumouredly_adverbs() {
    char *s = calloc(15);
    if (crc32("shIPqWIyHXDgI",13) == 1133885819) strcat(s, "g");
if (crc32("oxvroixjGf",10) == 1565071433) strcat(s, "J");
if (crc32("fiCBduiMngA",11) == 3268883307) strcat(s, "o");
if (crc32("aWDGwaybqCz",11) == 2953770293) strcat(s, "o");
if (crc32("KdmPGb",6) == 2080126554) strcat(s, "t");
if (crc32("PowYqfkT",8) == 453564298) strcat(s, "d");
if (crc32("RpbBVUu",7) == 893605956) strcat(s, "i");
if (crc32("ciMCf",5) == 1499038769) strcat(s, "h");
if (crc32("mqLDR",5) == 2958284828) strcat(s, "l");
if (crc32("lrnuPnfTQoBorl",14) == 4172105263) strcat(s, "u");
if (crc32("EsxUpLRVthXyZ",13) == 3808318009) strcat(s, "m");
if (crc32("KEqxCL",6) == 1762747225) strcat(s, "o");
if (crc32("tZFqnp",6) == 333777805) strcat(s, "u");
if (crc32("uxIbViijk",9) == 803823631) strcat(s, "Z");
if (crc32("bDXeCqxTDadf",12) == 1524015175) strcat(s, "r");
if (crc32("amnKsGDsYte",11) == 2054382275) strcat(s, "U");
if (crc32("MTDnXaaNhX",10) == 2762724113) strcat(s, "e");
if (crc32("ldctoAvRneSU",12) == 3097047204) strcat(s, "l");
if (crc32("CdxdJroMuivXgsv",15) == 3170031469) strcat(s, "d");
if (crc32("JjTFbUMooFpz",12) == 2135375297) strcat(s, "l");
if (crc32("uzAmHf",6) == 2795086836) strcat(s, "l");
if (crc32("DJVLwXZvjGbC",12) == 3428024741) strcat(s, "g");
if (crc32("REEVfFS",7) == 282944551) strcat(s, "y");
    return s;
}

char *inclusively_adverbs() {
    char *s = calloc(12);
    if (crc32("iWosRydRByyOv",13) == 1610902448) strcat(s, "i");
if (crc32("DELWCHtLiItolC",14) == 4105875577) strcat(s, "k");
if (crc32("yVZuEX",6) == 881385530) strcat(s, "n");
if (crc32("EXsWypADF",9) == 3721126685) strcat(s, "c");
if (crc32("DxiOSGRBIh",10) == 1380347328) strcat(s, "l");
if (crc32("ZigyFzM",7) == 2170264334) strcat(s, "K");
if (crc32("DPuPLLJ",7) == 1759263453) strcat(s, "u");
if (crc32("jyGeBuREnaVseuE",15) == 2840813390) strcat(s, "s");
if (crc32("mBEQAhYTSPn",11) == 1862094601) strcat(s, "i");
if (crc32("TMfmIO",6) == 3377173261) strcat(s, "B");
if (crc32("XQEYxDPZnE",10) == 3871129029) strcat(s, "v");
if (crc32("LpGzpn",6) == 3927585744) strcat(s, "e");
if (crc32("HDYTG",5) == 4023743139) strcat(s, "l");
if (crc32("xzEAURwoSycDP",13) == 1957355826) strcat(s, "L");
if (crc32("DHWDtbTSyGOU",12) == 789627598) strcat(s, "y");
    return s;
}

char *fatalistically_adverbs() {
    char *s = calloc(15);
    if (crc32("hldpGzII",8) == 861604176) strcat(s, "F");
if (crc32("diPCbNiFtU",10) == 722960298) strcat(s, "f");
if (crc32("mGhuAvD",7) == 3917420707) strcat(s, "a");
if (crc32("GzxPuFweMoLM",12) == 1522985036) strcat(s, "U");
if (crc32("zkoFKvA",7) == 371951016) strcat(s, "t");
if (crc32("nyegelQpxpjsbe",14) == 1718350890) strcat(s, "l");
if (crc32("nYGEzbacM",9) == 3407680997) strcat(s, "a");
if (crc32("CYLhqq",6) == 2589131559) strcat(s, "R");
if (crc32("vrvYoHVNcCuDMks",15) == 288912906) strcat(s, "l");
if (crc32("sNYNQiPpPw",10) == 237992166) strcat(s, "i");
if (crc32("HXvrnLt",7) == 2344187248) strcat(s, "z");
if (crc32("xdyNJZppwtO",11) == 3027295442) strcat(s, "s");
if (crc32("aRTwajWriLojoRB",15) == 1661326929) strcat(s, "v");
if (crc32("DEZVvtoWBLB",11) == 3825410710) strcat(s, "t");
if (crc32("qGDeQwpSlFjhtMi",15) == 3893251919) strcat(s, "c");
if (crc32("DjaggcH",7) == 4255850252) strcat(s, "i");
if (crc32("jvxYzClXyRAYp",13) == 4247976849) strcat(s, "B");
if (crc32("ldmxfqfQdWLiF",13) == 3337093591) strcat(s, "c");
if (crc32("bEDZxXEUa",9) == 346461198) strcat(s, "V");
if (crc32("ztjqQeDNvPCbGyn",15) == 3556721590) strcat(s, "a");
if (crc32("jtnqccWjUQuIZQM",15) == 1171414187) strcat(s, "l");
if (crc32("IgZrWrMkTh",10) == 300012351) strcat(s, "c");
if (crc32("UvucAJ",6) == 4060667541) strcat(s, "l");
if (crc32("hVMlEaISXmnmNSE",15) == 2393763580) strcat(s, "x");
if (crc32("gxiuxFasQsHec",13) == 2952037127) strcat(s, "y");
    return s;
}

char *uncalmly_adverbs() {
    char *s = calloc(9);
    if (crc32("qGYrebZQiR",10) == 1112364509) strcat(s, "C");
if (crc32("DTuyNwgymRbXmK",14) == 4195364432) strcat(s, "u");
if (crc32("sVSOohtXV",9) == 1767342872) strcat(s, "E");
if (crc32("iIetXJajwAK",11) == 196948339) strcat(s, "n");
if (crc32("hOLpo",5) == 3630962512) strcat(s, "s");
if (crc32("tikaUMf",7) == 1287240336) strcat(s, "c");
if (crc32("RphzqhxkUX",10) == 3535839136) strcat(s, "j");
if (crc32("plKdCzYfBthgcF",14) == 2429093977) strcat(s, "a");
if (crc32("FZhqE",5) == 4226348696) strcat(s, "x");
if (crc32("BauIV",5) == 2516764260) strcat(s, "l");
if (crc32("JqJVPNK",7) == 2216112035) strcat(s, "K");
if (crc32("tZAwfD",6) == 1674719547) strcat(s, "m");
if (crc32("uVWSadLVbhP",11) == 1859212076) strcat(s, "A");
if (crc32("ZPeFMwxZWKye",12) == 2832498578) strcat(s, "l");
if (crc32("tRMkefYdf",9) == 2270020341) strcat(s, "Q");
if (crc32("MtNAdvpgwhWfDgq",15) == 3970198302) strcat(s, "y");
    return s;
}

char *leerily_adverbs() {
    char *s = calloc(8);
    if (crc32("CKXUZqvIDtZFKO",14) == 3391712213) strcat(s, "l");
if (crc32("ccPurRdNb",9) == 3881598518) strcat(s, "w");
if (crc32("GYANWtDaY",9) == 3054581222) strcat(s, "e");
if (crc32("KBfLviflO",9) == 306683378) strcat(s, "e");
if (crc32("UXOORWqRlUoRl",13) == 3540632790) strcat(s, "Q");
if (crc32("iCWrAKPZMfpCn",13) == 3398002945) strcat(s, "r");
if (crc32("DrusVUrKpJRzdS",14) == 2120844999) strcat(s, "i");
if (crc32("BSclCuXbYbp",11) == 681024684) strcat(s, "Y");
if (crc32("dCRiChJWqIz",11) == 2088944060) strcat(s, "l");
if (crc32("DWzYVwvZpmIaVG",14) == 1012656817) strcat(s, "y");
    return s;
}

char *quasideliberately_adverbs() {
    char *s = calloc(18);
    if (crc32("GtdNDeDiEw",10) == 2642130050) strcat(s, "s");
if (crc32("LFMrGY",6) == 2372913681) strcat(s, "q");
if (crc32("eQlkJsruF",9) == 3055509671) strcat(s, "u");
if (crc32("lPMLGDmvMQkVXN",14) == 3607707988) strcat(s, "F");
if (crc32("vgbjFtPZfmY",11) == 3638577077) strcat(s, "a");
if (crc32("gwxZrCXpua",10) == 3480538340) strcat(s, "g");
if (crc32("UoooIJp",7) == 1222427604) strcat(s, "s");
if (crc32("jIYBYnEHo",9) == 3351840071) strcat(s, "J");
if (crc32("wRCET",5) == 2130711007) strcat(s, "i");
if (crc32("lRHHKMZIOicBCCX",15) == 907039549) strcat(s, "d");
if (crc32("wYYSVM",6) == 2929010270) strcat(s, "e");
if (crc32("RKWuwIX",7) == 2973132671) strcat(s, "y");
if (crc32("WEDgMwOFzMjnzF",14) == 131248595) strcat(s, "l");
if (crc32("hYsyADVZZKse",12) == 2738541926) strcat(s, "x");
if (crc32("byckbKcQWUCDwE",14) == 2260801394) strcat(s, "i");
if (crc32("FHLKbhEwqKEZIw",14) == 4164129479) strcat(s, "b");
if (crc32("zdgUuM",6) == 3781873142) strcat(s, "e");
if (crc32("VHjNENHQhTKG",12) == 734889584) strcat(s, "O");
if (crc32("hcyCUtYeTwLd",12) == 227432128) strcat(s, "r");
if (crc32("SccVjXA",7) == 121431279) strcat(s, "a");
if (crc32("BloYwCpXCcjE",12) == 2315094289) strcat(s, "t");
if (crc32("roALCmpovzwx",12) == 3598360442) strcat(s, "W");
if (crc32("eDIHhbS",7) == 939863391) strcat(s, "e");
if (crc32("bKoPBI",6) == 2934784019) strcat(s, "s");
if (crc32("JGVMJPku",8) == 404003999) strcat(s, "l");
if (crc32("AIxlryEttvfbBYg",15) == 1740724305) strcat(s, "l");
if (crc32("wHAXUvVtRDex",12) == 3947292865) strcat(s, "y");
    return s;
}

char *incombustibly_adverbs() {
    char *s = calloc(14);
    if (crc32("dUnqzCJYJPr",11) == 3696783373) strcat(s, "C");
if (crc32("tgvRjJzujl",10) == 3437095353) strcat(s, "i");
if (crc32("prjOmY",6) == 3561701101) strcat(s, "n");
if (crc32("KAsEwpnltt",10) == 1894782707) strcat(s, "Q");
if (crc32("SMhkdZJ",7) == 3765503940) strcat(s, "c");
if (crc32("xmRviqfScXosoM",14) == 284103274) strcat(s, "o");
if (crc32("OwHfDihATaOYfB",14) == 3720109551) strcat(s, "b");
if (crc32("qVoIPg",6) == 3012345113) strcat(s, "m");
if (crc32("MPKAWRqlNuVcZsz",15) == 3215262093) strcat(s, "b");
if (crc32("noMOBq",6) == 1873479973) strcat(s, "u");
if (crc32("sOttGOzWeJik",12) == 2439469944) strcat(s, "s");
if (crc32("ShxYqAiQNwTiVMJ",15) == 1540748432) strcat(s, "E");
if (crc32("VyAqdzvceLZQb",13) == 3444908136) strcat(s, "t");
if (crc32("fPANsb",6) == 3067755186) strcat(s, "E");
if (crc32("lcZHPEWtz",9) == 1614644383) strcat(s, "i");
if (crc32("putPPwe",7) == 3702427356) strcat(s, "b");
if (crc32("VeHKqtQTDbQ",11) == 1029100240) strcat(s, "x");
if (crc32("IBiWSLza",8) == 1794194412) strcat(s, "l");
if (crc32("PCjkX",5) == 3513379417) strcat(s, "y");
    return s;
}

char *unsinuately_adverbs() {
    char *s = calloc(12);
    if (crc32("JzQDxtKJdGQ",11) == 247572274) strcat(s, "u");
if (crc32("JMtXZcUJa",9) == 3023179309) strcat(s, "h");
if (crc32("FsDNzsXnxyq",11) == 1648660674) strcat(s, "n");
if (crc32("QZwLEEHUgQjXRrF",15) == 669304789) strcat(s, "v");
if (crc32("hSPWEpPz",8) == 16550216) strcat(s, "s");
if (crc32("EHUsMEtkqsi",11) == 2761726362) strcat(s, "i");
if (crc32("nERafnahHPCkrll",15) == 182187893) strcat(s, "n");
if (crc32("BBrAB",5) == 4090072644) strcat(s, "u");
if (crc32("UijsqUVcgEJe",12) == 2583434917) strcat(s, "b");
if (crc32("EIVPOfWchyDU",12) == 1160554905) strcat(s, "a");
if (crc32("KjpdObrRddDh",12) == 3151139634) strcat(s, "t");
if (crc32("MuygOzExBBPKZo",14) == 3201387101) strcat(s, "e");
if (crc32("rWQUuqVrOEVgY",13) == 3715205478) strcat(s, "A");
if (crc32("qUDLJdcajqLRp",13) == 3912989912) strcat(s, "l");
if (crc32("ZLkzcjBGHKltsTn",15) == 638524082) strcat(s, "y");
    return s;
}

char *polygamously_adverbs() {
    char *s = calloc(13);
    if (crc32("NkiRyh",6) == 53037267) strcat(s, "A");
if (crc32("JDxvbOKu",8) == 634596589) strcat(s, "p");
if (crc32("SdmsH",5) == 1920057480) strcat(s, "s");
if (crc32("UkIfZgIvrQ",10) == 2369217429) strcat(s, "o");
if (crc32("XotXJGKSjyfABj",14) == 23770544) strcat(s, "l");
if (crc32("ozZurbHiBKCp",12) == 1785357835) strcat(s, "y");
if (crc32("tZpYqVTyjnztib",14) == 3470884858) strcat(s, "J");
if (crc32("kKOTKEROAJuWHq",14) == 1768053509) strcat(s, "g");
if (crc32("lIGWChuechKutVf",15) == 784125060) strcat(s, "a");
if (crc32("uGiZgTDCZVHouhN",15) == 1290069227) strcat(s, "m");
if (crc32("VRMkyUYXQYu",11) == 3696232737) strcat(s, "o");
if (crc32("pRJpSVDVPTMxy",13) == 3748295903) strcat(s, "u");
if (crc32("WgNZhd",6) == 4106047613) strcat(s, "W");
if (crc32("DVQqjralHwK",11) == 4290309059) strcat(s, "s");
if (crc32("vbOUFkKGwsPITo",14) == 4130553241) strcat(s, "F");
if (crc32("ktlTwsxylCiSHyI",15) == 651771967) strcat(s, "l");
if (crc32("JEKGm",5) == 2287974908) strcat(s, "y");
    return s;
}

char *concretely_adverbs() {
    char *s = calloc(11);
    if (crc32("RuTcALI",7) == 3026031806) strcat(s, "c");
if (crc32("YGgqkovcrSRmJkj",15) == 3538913845) strcat(s, "Q");
if (crc32("HxPzveXA",8) == 2361407541) strcat(s, "o");
if (crc32("GUTOqvmLBDLNhOt",15) == 2121835696) strcat(s, "n");
if (crc32("oZpeQveeaG",10) == 910049443) strcat(s, "c");
if (crc32("TztpQfrRiO",10) == 3167162434) strcat(s, "n");
if (crc32("WKHTfY",6) == 2607752059) strcat(s, "r");
if (crc32("iBoLD",5) == 233536266) strcat(s, "e");
if (crc32("OwwObC",6) == 823029266) strcat(s, "t");
if (crc32("sPkydfRzSe",10) == 1777090752) strcat(s, "e");
if (crc32("KRpQTUA",7) == 3186065778) strcat(s, "l");
if (crc32("hcjSsBGYzvdKd",13) == 2449575510) strcat(s, "E");
if (crc32("TMfuTA",6) == 365272200) strcat(s, "y");
    return s;
}

char *supercuriously_adverbs() {
    char *s = calloc(15);
    if (crc32("yVlWkzJLon",10) == 3528276717) strcat(s, "x");
if (crc32("qVHRXvJfghl",11) == 4154404662) strcat(s, "s");
if (crc32("itEgXzbmBEwdFx",14) == 2096877561) strcat(s, "u");
if (crc32("jxbiBfUikf",10) == 792421190) strcat(s, "p");
if (crc32("LunuTLdlc",9) == 4093979064) strcat(s, "e");
if (crc32("OlMkpHy",7) == 2731284391) strcat(s, "W");
if (crc32("XuCNYBVddynPze",14) == 3234743679) strcat(s, "r");
if (crc32("CWFcPKRGFkvoBui",15) == 3122477601) strcat(s, "D");
if (crc32("BIbHWDsjnjFQO",13) == 1996267169) strcat(s, "c");
if (crc32("AcwddBjfohC",11) == 1999548887) strcat(s, "u");
if (crc32("ZNTFBbQqgDVbYO",14) == 1178874380) strcat(s, "N");
if (crc32("vthkxTOVSDsWA",13) == 3404313548) strcat(s, "r");
if (crc32("oTUqsb",6) == 277202392) strcat(s, "q");
if (crc32("hjIVRhMCiYzj",12) == 3660349229) strcat(s, "i");
if (crc32("AVfCsvXv",8) == 1490892012) strcat(s, "Z");
if (crc32("fndRIxuoPoB",11) == 2027598799) strcat(s, "o");
if (crc32("bEOKIhzoPLV",11) == 958085186) strcat(s, "u");
if (crc32("uSBhXTRqNrcsu",13) == 2341833003) strcat(s, "s");
if (crc32("lZrcDtAiRv",10) == 3612387571) strcat(s, "E");
if (crc32("cbrwOPioj",9) == 1699954121) strcat(s, "l");
if (crc32("UZredF",6) == 2384905303) strcat(s, "y");
    return s;
}

char *distastefully_adverbs() {
    char *s = calloc(14);
    if (crc32("DBXXhgYthaDFC",13) == 3379590911) strcat(s, "d");
if (crc32("nYlPKFD",7) == 1375087420) strcat(s, "i");
if (crc32("CsigS",5) == 1059313527) strcat(s, "s");
if (crc32("jtSHkZBjHN",10) == 3913612804) strcat(s, "t");
if (crc32("rpBGrptLqwPmpFS",15) == 618728639) strcat(s, "a");
if (crc32("GJjXoIxZrMgc",12) == 243257297) strcat(s, "s");
if (crc32("QPItLUROSbb",11) == 2333025196) strcat(s, "p");
if (crc32("mqXFgX",6) == 4105733825) strcat(s, "t");
if (crc32("kxFNgHJT",8) == 3071202097) strcat(s, "e");
if (crc32("RCdNjckvN",9) == 25565853) strcat(s, "f");
if (crc32("SHQuzxIlJIA",11) == 1345878090) strcat(s, "u");
if (crc32("GOnUSjPCgMrGxC",14) == 357677015) strcat(s, "l");
if (crc32("WhYdjndiQRlI",12) == 3666600838) strcat(s, "l");
if (crc32("BiLZex",6) == 3259797399) strcat(s, "c");
if (crc32("iTduTV",6) == 3909824580) strcat(s, "y");
    return s;
}

char *hoggishly_adverbs() {
    char *s = calloc(10);
    if (crc32("HFmMdkUcjdtPeb",14) == 2071070775) strcat(s, "U");
if (crc32("FvaexwFlTofIVee",15) == 2808484656) strcat(s, "h");
if (crc32("HdXwZIj",7) == 1787912815) strcat(s, "o");
if (crc32("KDEwLpJNOe",10) == 951934719) strcat(s, "K");
if (crc32("jMtvadWYajczQH",14) == 693613833) strcat(s, "g");
if (crc32("iOJRbt",6) == 3097043567) strcat(s, "u");
if (crc32("stshPSuZm",9) == 4275854930) strcat(s, "g");
if (crc32("FNYUlnoeHrZH",12) == 3844743189) strcat(s, "J");
if (crc32("vaNqOBybxfrnp",13) == 1184474086) strcat(s, "i");
if (crc32("yWfzUobj",8) == 217748549) strcat(s, "R");
if (crc32("CITwSBByKWtnFKE",15) == 2738089756) strcat(s, "s");
if (crc32("xcfHGUjvqH",10) == 3400978434) strcat(s, "S");
if (crc32("SPWrhbrfmG",10) == 1430100176) strcat(s, "h");
if (crc32("ftAyTWgakuy",11) == 121174960) strcat(s, "l");
if (crc32("BLpKJrWqS",9) == 2674432570) strcat(s, "y");
    return s;
}

char *azimuthally_adverbs() {
    char *s = calloc(12);
    if (crc32("zHbLWXGHXHqbA",13) == 2453265503) strcat(s, "a");
if (crc32("FkWNDJPLFs",10) == 121013348) strcat(s, "E");
if (crc32("EsRxBf",6) == 224245576) strcat(s, "z");
if (crc32("gcmOqCreJYs",11) == 3865633496) strcat(s, "i");
if (crc32("OeAzkByAgEDwJ",13) == 1473059311) strcat(s, "U");
if (crc32("dJGJSAOWjpET",12) == 4281742627) strcat(s, "m");
if (crc32("UcuHptXR",8) == 505446796) strcat(s, "p");
if (crc32("lxQQJPHQdFm",11) == 88807687) strcat(s, "u");
if (crc32("qiidoYlNrj",10) == 3450276159) strcat(s, "t");
if (crc32("PnYfK",5) == 2483878368) strcat(s, "h");
if (crc32("bsXPgBoqOoht",12) == 941762264) strcat(s, "z");
if (crc32("VXveA",5) == 920981565) strcat(s, "a");
if (crc32("VImRQvbvOHGYmO",14) == 2941249843) strcat(s, "l");
if (crc32("iaZDPjbaiBAA",12) == 876307232) strcat(s, "l");
if (crc32("WAwIMwJNYiXM",12) == 3405128174) strcat(s, "Z");
if (crc32("vLFugoforRoRmK",14) == 1451762065) strcat(s, "y");
    return s;
}

char *unslanderously_adverbs() {
    char *s = calloc(15);
    if (crc32("oXmZphhhIt",10) == 2427808946) strcat(s, "I");
if (crc32("tEHcNrvTdiZryma",15) == 1353541447) strcat(s, "u");
if (crc32("yDEeDQVZSbqv",12) == 4192730667) strcat(s, "u");
if (crc32("XclzyxxqBU",10) == 612555989) strcat(s, "n");
if (crc32("omNFbfRFjgGCHD",14) == 3494003481) strcat(s, "s");
if (crc32("WzKqNkDhrLG",11) == 1610594534) strcat(s, "T");
if (crc32("JmJaPoiGWnbsdz",14) == 1970466525) strcat(s, "l");
if (crc32("WVnuoJu",7) == 2992165902) strcat(s, "a");
if (crc32("zfNFUDrAVskSIn",14) == 500792562) strcat(s, "n");
if (crc32("PaNlMTHToJxVsvt",15) == 2764677428) strcat(s, "t");
if (crc32("nttQVaAbu",9) == 3077718004) strcat(s, "d");
if (crc32("kkofW",5) == 1355183423) strcat(s, "b");
if (crc32("txFTw",5) == 5944540) strcat(s, "e");
if (crc32("lyBkZlkJqAbbv",13) == 3467709533) strcat(s, "g");
if (crc32("VpGNfM",6) == 3586825156) strcat(s, "r");
if (crc32("KuNImjSMV",9) == 1300052928) strcat(s, "e");
if (crc32("Wblgh",5) == 4112973056) strcat(s, "o");
if (crc32("BFRPiw",6) == 93956164) strcat(s, "D");
if (crc32("dmKpM",5) == 943796148) strcat(s, "u");
if (crc32("xwEUqLnMnH",10) == 4294538139) strcat(s, "s");
if (crc32("xMpor",5) == 2734467459) strcat(s, "q");
if (crc32("kqAeIeafRGjW",12) == 1048564911) strcat(s, "l");
if (crc32("rGavNCcLHXXflD",14) == 3691020926) strcat(s, "W");
if (crc32("uMnGckG",7) == 2484831182) strcat(s, "y");
    return s;
}

char *brimfully_adverbs() {
    char *s = calloc(10);
    if (crc32("pUzsGSO",7) == 3039663702) strcat(s, "M");
if (crc32("QYlxQJmdc",9) == 114399323) strcat(s, "b");
if (crc32("fehOC",5) == 3494868505) strcat(s, "Z");
if (crc32("huGEzysap",9) == 3829043813) strcat(s, "r");
if (crc32("rZfkGlmupb",10) == 806689639) strcat(s, "i");
if (crc32("HDNtoDWOSVbXO",13) == 3639935828) strcat(s, "m");
if (crc32("vMwmlLXhLza",11) == 2648751436) strcat(s, "f");
if (crc32("oCdJGubTvhXf",12) == 915268256) strcat(s, "u");
if (crc32("vmxglU",6) == 4042676389) strcat(s, "b");
if (crc32("bGFkGvAgpDBneb",14) == 3935808000) strcat(s, "l");
if (crc32("diEYENrZMob",11) == 1868944874) strcat(s, "p");
if (crc32("euWzyXgZ",8) == 873110415) strcat(s, "l");
if (crc32("FYnuHd",6) == 3305985346) strcat(s, "A");
if (crc32("dDoruChpvmYCW",13) == 2675897942) strcat(s, "y");
    return s;
}

char *unconcurrently_adverbs() {
    char *s = calloc(15);
    if (crc32("fExqcqrAD",9) == 2744796967) strcat(s, "u");
if (crc32("nSsXA",5) == 479653422) strcat(s, "u");
if (crc32("TyDXytY",7) == 3352662378) strcat(s, "n");
if (crc32("FEnCwAYyfyFTs",13) == 401741838) strcat(s, "Z");
if (crc32("iyHFZ",5) == 388202790) strcat(s, "c");
if (crc32("keUluGTdUYHOuZ",14) == 1849852925) strcat(s, "o");
if (crc32("qDPLmNbIh",9) == 3298931221) strcat(s, "n");
if (crc32("hfoQJqzUaHuzKO",14) == 1520480225) strcat(s, "c");
if (crc32("JfGBcTNBTQzN",12) == 1725487501) strcat(s, "u");
if (crc32("hrqqumDOu",9) == 140123943) strcat(s, "i");
if (crc32("YAWLqoT",7) == 1870970479) strcat(s, "r");
if (crc32("YVWvam",6) == 1827105620) strcat(s, "B");
if (crc32("NHdsB",5) == 2891909266) strcat(s, "r");
if (crc32("fTDNyMASWpAxJ",13) == 4073854582) strcat(s, "l");
if (crc32("iGXBPF",6) == 743029882) strcat(s, "e");
if (crc32("mpEsgKNXAd",10) == 197591013) strcat(s, "n");
if (crc32("NXMEKx",6) == 240462966) strcat(s, "y");
if (crc32("UKsXxsm",7) == 1411797163) strcat(s, "t");
if (crc32("OoKwSxyjGl",10) == 3106590262) strcat(s, "l");
if (crc32("SITgvpGbRhQ",11) == 1022539369) strcat(s, "y");
    return s;
}

char *topographically_adverbs() {
    char *s = calloc(16);
    if (crc32("saJKGiAUZzONHUN",15) == 3052966168) strcat(s, "t");
if (crc32("fcANy",5) == 3484967417) strcat(s, "o");
if (crc32("GyvpMUaCwewzVG",14) == 1802403998) strcat(s, "C");
if (crc32("YUnZpt",6) == 2822070178) strcat(s, "p");
if (crc32("YCueSOHCQLUcD",13) == 3133182456) strcat(s, "o");
if (crc32("fagIzy",6) == 1890881123) strcat(s, "q");
if (crc32("pdTcBnW",7) == 2064558127) strcat(s, "g");
if (crc32("oGOrXjj",7) == 2899198498) strcat(s, "L");
if (crc32("ICpSXIYwLCiMy",13) == 3188209192) strcat(s, "r");
if (crc32("OEwMCpwwezeJS",13) == 908151084) strcat(s, "c");
if (crc32("ZEwPSEjEyuBah",13) == 1143936881) strcat(s, "a");
if (crc32("bvkuNjSt",8) == 3542144978) strcat(s, "p");
if (crc32("hfPNSerCdmUD",12) == 1747857604) strcat(s, "J");
if (crc32("buWvagobCxda",12) == 1222612893) strcat(s, "h");
if (crc32("iTZJkFohCPZDcJj",15) == 163415932) strcat(s, "J");
if (crc32("QcmgqseJ",8) == 3527404300) strcat(s, "i");
if (crc32("KuPkYYrZ",8) == 238438012) strcat(s, "c");
if (crc32("FGqUDytprSF",11) == 1765237506) strcat(s, "U");
if (crc32("nCKXJEqvm",9) == 3535210906) strcat(s, "a");
if (crc32("JPiWqy",6) == 860693538) strcat(s, "G");
if (crc32("RpnbpZu",7) == 2716042424) strcat(s, "l");
if (crc32("aLRSwqzRZH",10) == 3202075942) strcat(s, "I");
if (crc32("keOjCPD",7) == 2064280115) strcat(s, "l");
if (crc32("DcLveBFsbaNUdgA",15) == 3914138866) strcat(s, "u");
if (crc32("JvBfjdWhDtePmEl",15) == 1045678610) strcat(s, "y");
    return s;
}

char *unrhapsodically_adverbs() {
    char *s = calloc(16);
    if (crc32("yaHnwk",6) == 3790979709) strcat(s, "K");
if (crc32("pJZNoX",6) == 4056026408) strcat(s, "u");
if (crc32("XPPENKFcgV",10) == 1042628569) strcat(s, "n");
if (crc32("RsCiTIi",7) == 2362670485) strcat(s, "C");
if (crc32("WIclZHSCUtavij",14) == 1409160934) strcat(s, "r");
if (crc32("LHYtl",5) == 1894545668) strcat(s, "W");
if (crc32("KjZjZEiV",8) == 2756891334) strcat(s, "h");
if (crc32("NWVQIUZsvY",10) == 575700584) strcat(s, "a");
if (crc32("rXwgmpkQyuwMeK",14) == 1959482566) strcat(s, "X");
if (crc32("vTiLaD",6) == 2480092470) strcat(s, "p");
if (crc32("YuuAISZHxotQl",13) == 268611040) strcat(s, "s");
if (crc32("rVoCxRKjOmcy",12) == 2110761024) strcat(s, "o");
if (crc32("cNtoSfjLO",9) == 1637275080) strcat(s, "J");
if (crc32("aqZjq",5) == 1757939704) strcat(s, "d");
if (crc32("uAvYtZ",6) == 1651155535) strcat(s, "i");
if (crc32("hNDJSbOgtFbo",12) == 58905281) strcat(s, "C");
if (crc32("zWFVDT",6) == 3205879504) strcat(s, "c");
if (crc32("ltSPgToFEsjrQ",13) == 4190218251) strcat(s, "W");
if (crc32("vzEtXIr",7) == 826044270) strcat(s, "a");
if (crc32("Cpjbj",5) == 228768397) strcat(s, "l");
if (crc32("bXOxuQ",6) == 724309674) strcat(s, "l");
if (crc32("sXROJE",6) == 4122670384) strcat(s, "x");
if (crc32("CVUvdjURyipR",12) == 3996888521) strcat(s, "y");
    return s;
}

char *fabulously_adverbs() {
    char *s = calloc(11);
    if (crc32("UlXDUtikfy",10) == 2024056937) strcat(s, "f");
if (crc32("XUgFMufDEjGykI",14) == 2620784841) strcat(s, "a");
if (crc32("KqASccgeJHV",11) == 2459424889) strcat(s, "L");
if (crc32("ffVSGbseuQcZ",12) == 3974782349) strcat(s, "b");
if (crc32("LjYrwAnUlc",10) == 3875063652) strcat(s, "V");
if (crc32("sDQWcRwtXEf",11) == 3189471643) strcat(s, "u");
if (crc32("yqnhsLwvLooQYSp",15) == 2806642069) strcat(s, "l");
if (crc32("EmoECNLythQM",12) == 3398876141) strcat(s, "o");
if (crc32("gdDDiD",6) == 121418425) strcat(s, "V");
if (crc32("UVZMdVybOYAhwi",14) == 2632916881) strcat(s, "u");
if (crc32("MHwOkxL",7) == 2436975718) strcat(s, "A");
if (crc32("dOCphfyUsr",10) == 1163600701) strcat(s, "s");
if (crc32("tsfvvVfl",8) == 1765883789) strcat(s, "l");
if (crc32("euPLqloeNgBew",13) == 4259653863) strcat(s, "y");
    return s;
}

char *nonenthusiastically_adverbs() {
    char *s = calloc(20);
    if (crc32("WiKTE",5) == 2928743201) strcat(s, "n");
if (crc32("fqkShbBrl",9) == 3093263205) strcat(s, "o");
if (crc32("FhqtA",5) == 2718740021) strcat(s, "i");
if (crc32("qhGbyDDQemkYBic",15) == 4247936055) strcat(s, "n");
if (crc32("VeOSkZpXxMWYOV",14) == 1264097105) strcat(s, "e");
if (crc32("ECBKxoExYwe",11) == 4239321844) strcat(s, "V");
if (crc32("CoMrotGwYfrGM",13) == 1303426038) strcat(s, "n");
if (crc32("XkJMc",5) == 2349108454) strcat(s, "w");
if (crc32("LgolKnHbYNRUvYK",15) == 2680272992) strcat(s, "t");
if (crc32("nebKLNzLHR",10) == 2511584065) strcat(s, "x");
if (crc32("aSkCLUhDlK",10) == 1195140461) strcat(s, "h");
if (crc32("yNnln",5) == 4070579949) strcat(s, "x");
if (crc32("KWvzEqV",7) == 2055626872) strcat(s, "u");
if (crc32("eKfta",5) == 3598045986) strcat(s, "V");
if (crc32("YtfLTE",6) == 700272551) strcat(s, "s");
if (crc32("yDZaQzJ",7) == 2949331077) strcat(s, "i");
if (crc32("STjVDNxm",8) == 3579898910) strcat(s, "h");
if (crc32("eUhOATQqpj",10) == 4034999863) strcat(s, "a");
if (crc32("lXzhlbbZXKbS",12) == 3909955694) strcat(s, "s");
if (crc32("KeZEAFpBJaMEbib",15) == 3486256406) strcat(s, "d");
if (crc32("HfTqzW",6) == 1966630134) strcat(s, "t");
if (crc32("dWTiHKmEyfqPx",13) == 3346583326) strcat(s, "m");
if (crc32("zrPzCzmmsLU",11) == 2897906698) strcat(s, "i");
if (crc32("EINfzpMSRiZNRa",14) == 1192176843) strcat(s, "c");
if (crc32("UkjPdwmTD",9) == 87472932) strcat(s, "a");
if (crc32("ZgQtZmyaDWrv",12) == 1849248356) strcat(s, "e");
if (crc32("RYHDVTr",7) == 1992259711) strcat(s, "l");
if (crc32("hfKYTgCWMzIB",12) == 230882435) strcat(s, "n");
if (crc32("wwVRNThWisvWMOV",15) == 249676774) strcat(s, "l");
if (crc32("LDLJSPIXcfi",11) == 845385008) strcat(s, "V");
if (crc32("rrwFZ",5) == 4163174937) strcat(s, "y");
    return s;
}

char *quasibenevolently_adverbs() {
    char *s = calloc(18);
    if (crc32("kuxfxNlIIepX",12) == 1328012162) strcat(s, "F");
if (crc32("XYZfng",6) == 2757651461) strcat(s, "q");
if (crc32("GOAyJzT",7) == 3112650039) strcat(s, "G");
if (crc32("dMsfjmZOzriVxRu",15) == 781632218) strcat(s, "u");
if (crc32("EKRFUiFthoSpz",13) == 642416159) strcat(s, "a");
if (crc32("whmczUUfEi",10) == 3559511046) strcat(s, "h");
if (crc32("VIMYr",5) == 979186271) strcat(s, "s");
if (crc32("NUJZFxgTzuTaSV",14) == 484391389) strcat(s, "V");
if (crc32("Ltzva",5) == 2781484966) strcat(s, "i");
if (crc32("sRyafyAyAwYXpwV",15) == 967589692) strcat(s, "b");
if (crc32("IbNyOoUc",8) == 499314500) strcat(s, "e");
if (crc32("tqpDWNrjv",9) == 1377994962) strcat(s, "u");
if (crc32("eSXWAASSuHsIiI",14) == 4192224417) strcat(s, "n");
if (crc32("QUAyEOuofCc",11) == 1777208101) strcat(s, "o");
if (crc32("DseJEzLaVhZ",11) == 1383704004) strcat(s, "e");
if (crc32("SXVKRNiHoDR",11) == 1288104602) strcat(s, "v");
if (crc32("cbPAjXwlI",9) == 604571680) strcat(s, "B");
if (crc32("vZXPonhOObLgoGJ",15) == 3565693709) strcat(s, "o");
if (crc32("yTOTcVJHTxt",11) == 2446446542) strcat(s, "j");
if (crc32("RUxjOnE",7) == 1850882822) strcat(s, "l");
if (crc32("OvZIPoWMsszWGc",14) == 3123288091) strcat(s, "Y");
if (crc32("rQwFoqebHz",10) == 127566220) strcat(s, "e");
if (crc32("QkfjsJXPaxYaIQp",15) == 2453144694) strcat(s, "q");
if (crc32("DuSVexeYuigHSPK",15) == 3611859110) strcat(s, "n");
if (crc32("RtnYDMTXLRXI",12) == 543081749) strcat(s, "t");
if (crc32("gxjDAxl",7) == 558021445) strcat(s, "l");
if (crc32("AYwmllmzndcaJ",13) == 1917733934) strcat(s, "y");
    return s;
}

char *soughfully_adverbs() {
    char *s = calloc(11);
    if (crc32("WTOGdaET",8) == 3856612124) strcat(s, "s");
if (crc32("eJHEzOfzpsXtEf",14) == 2960517953) strcat(s, "o");
if (crc32("XapgKu",6) == 3483762239) strcat(s, "L");
if (crc32("MluOqNATLorddX",14) == 4272941540) strcat(s, "u");
if (crc32("gbnrBRROgTBa",12) == 1333124468) strcat(s, "g");
if (crc32("HSYCd",5) == 2248140897) strcat(s, "h");
if (crc32("LLaYvRwT",8) == 1124342209) strcat(s, "f");
if (crc32("yYBeoYQkGDevD",13) == 418672842) strcat(s, "D");
if (crc32("TqBNLltSGl",10) == 2665632174) strcat(s, "u");
if (crc32("PWLLFrCGoy",10) == 2070501974) strcat(s, "Q");
if (crc32("sHrAaTDH",8) == 392034974) strcat(s, "l");
if (crc32("TaraVcx",7) == 4058611332) strcat(s, "l");
if (crc32("cagGsFoaluN",11) == 2572585311) strcat(s, "y");
    return s;
}

char *erratically_adverbs() {
    char *s = calloc(12);
    if (crc32("EUCjVfM",7) == 3475999252) strcat(s, "e");
if (crc32("fQlIng",6) == 877295215) strcat(s, "n");
if (crc32("eofptcGWXG",10) == 381258164) strcat(s, "r");
if (crc32("QctpjaGOAEkHCm",14) == 868245847) strcat(s, "r");
if (crc32("pZDxeuH",7) == 3149537252) strcat(s, "a");
if (crc32("NTuurbi",7) == 1195690061) strcat(s, "t");
if (crc32("GMtanewdhvXRuf",14) == 1315723915) strcat(s, "u");
if (crc32("EaYqYkayN",9) == 3889582660) strcat(s, "i");
if (crc32("wwVzvxO",7) == 2170914360) strcat(s, "F");
if (crc32("AQzeAWoToUkEASp",15) == 3815486259) strcat(s, "c");
if (crc32("fMufWQYVXurbem",14) == 520292877) strcat(s, "a");
if (crc32("cKRFEHokmL",10) == 179154357) strcat(s, "l");
if (crc32("uxBAVrKrUHg",11) == 2110050150) strcat(s, "l");
if (crc32("fvMCgM",6) == 3000582838) strcat(s, "b");
if (crc32("hcjScyvHcytBs",13) == 3461117810) strcat(s, "y");
    return s;
}

char *gullably_adverbs() {
    char *s = calloc(9);
    if (crc32("SfEpxtRONeT",11) == 2926511800) strcat(s, "g");
if (crc32("NalbjvwhapzVxI",14) == 1216562928) strcat(s, "u");
if (crc32("OeLxpIrWumicerj",15) == 275635756) strcat(s, "l");
if (crc32("klYYoyVvnVuMAGM",15) == 2749127721) strcat(s, "R");
if (crc32("ohGyVucktaHfDg",14) == 648355424) strcat(s, "l");
if (crc32("DyAVRxaMOW",10) == 2084290374) strcat(s, "a");
if (crc32("xgulLlfDV",9) == 803466341) strcat(s, "Y");
if (crc32("rLNrJAVF",8) == 1209257955) strcat(s, "b");
if (crc32("NapfUMVDqPNAADV",15) == 3191918553) strcat(s, "m");
if (crc32("qJXVVqCT",8) == 3190427539) strcat(s, "l");
if (crc32("EKpQB",5) == 4132123793) strcat(s, "I");
if (crc32("BCmgRJLv",8) == 497211899) strcat(s, "y");
    return s;
}

char *considerably_adverbs() {
    char *s = calloc(13);
    if (crc32("ikHxiuuVssb",11) == 553986945) strcat(s, "Z");
if (crc32("QvdFdWCoHVDS",12) == 3481526146) strcat(s, "c");
if (crc32("HormQCNXy",9) == 3900208518) strcat(s, "o");
if (crc32("wODjkHjBqOBVG",13) == 1003884279) strcat(s, "L");
if (crc32("jTmUfkHNF",9) == 1033109104) strcat(s, "n");
if (crc32("NScmXP",6) == 792045383) strcat(s, "A");
if (crc32("OINzd",5) == 529972165) strcat(s, "s");
if (crc32("nYpaX",5) == 2530943445) strcat(s, "A");
if (crc32("npbSKwDaDFwJ",12) == 569171274) strcat(s, "i");
if (crc32("iiAFHiGMG",9) == 3103485278) strcat(s, "A");
if (crc32("yqxrTBjg",8) == 2213807299) strcat(s, "d");
if (crc32("aFvHWx",6) == 1042333968) strcat(s, "e");
if (crc32("DQwHtAaGvs",10) == 1938158325) strcat(s, "r");
if (crc32("mkbYWtvJSYZIMr",14) == 58538651) strcat(s, "e");
if (crc32("GqMypn",6) == 3494294686) strcat(s, "a");
if (crc32("pALTe",5) == 3548223047) strcat(s, "z");
if (crc32("mgZJNvY",7) == 4112528736) strcat(s, "b");
if (crc32("TAzxn",5) == 1016329065) strcat(s, "l");
if (crc32("FVBAifvnLryys",13) == 926627780) strcat(s, "s");
if (crc32("ylsEnlG",7) == 3937116421) strcat(s, "y");
    return s;
}

char *subpharyngeally_adverbs() {
    char *s = calloc(16);
    if (crc32("AqWqu",5) == 1737424775) strcat(s, "A");
if (crc32("jNRYjoKZJSyyC",13) == 758482338) strcat(s, "s");
if (crc32("XyGJNnSHWYzHYTz",15) == 2373086147) strcat(s, "X");
if (crc32("PyrBWtVODSgy",12) == 4265660383) strcat(s, "u");
if (crc32("YoRAoRo",7) == 459118210) strcat(s, "j");
if (crc32("NlVvxhqqYrXvzAY",15) == 565904015) strcat(s, "b");
if (crc32("jWlTKaEXiXE",11) == 2070550314) strcat(s, "p");
if (crc32("NNRCfe",6) == 2129953233) strcat(s, "p");
if (crc32("GmxxsHj",7) == 217264178) strcat(s, "h");
if (crc32("MmCkYIqRAey",11) == 4246841784) strcat(s, "b");
if (crc32("PYqcjURdLwuhzYZ",15) == 4000820646) strcat(s, "a");
if (crc32("PfzQUDnWyInLJ",13) == 1317552999) strcat(s, "r");
if (crc32("NcJgWaWBIks",11) == 3930173507) strcat(s, "y");
if (crc32("upJpZvfX",8) == 2690602169) strcat(s, "l");
if (crc32("kBxfWDdxoMJ",11) == 4279594138) strcat(s, "n");
if (crc32("WLjabkxawXgm",12) == 3990582070) strcat(s, "W");
if (crc32("JgPEkyohPTdrrUn",15) == 3908951581) strcat(s, "g");
if (crc32("aoGxBk",6) == 3099677100) strcat(s, "Z");
if (crc32("ExFBvePnco",10) == 2050281889) strcat(s, "e");
if (crc32("KZErbzbmNped",12) == 85588600) strcat(s, "B");
if (crc32("jnrLYs",6) == 611098267) strcat(s, "a");
if (crc32("cnuByOndbVsrXFT",15) == 4267726421) strcat(s, "G");
if (crc32("DuCWEe",6) == 1153263383) strcat(s, "l");
if (crc32("jeRZURxoKEkJ",12) == 3178562840) strcat(s, "l");
if (crc32("QGASYbYO",8) == 1334774101) strcat(s, "C");
if (crc32("KawntBjoXVmgSt",14) == 2023232609) strcat(s, "y");
    return s;
}

char *unmeritoriously_adverbs() {
    char *s = calloc(16);
    if (crc32("zVRAggcqOPkiLn",14) == 62049827) strcat(s, "u");
if (crc32("jzTKzxLjQhZpME",14) == 3820658053) strcat(s, "n");
if (crc32("SSIvgFLSVRCfVB",14) == 1589409165) strcat(s, "m");
if (crc32("ucRBKOzABeu",11) == 1875282850) strcat(s, "a");
if (crc32("VCUCVrpEW",9) == 3806794421) strcat(s, "e");
if (crc32("uZVlulT",7) == 2113094212) strcat(s, "N");
if (crc32("owtrJrvKVPyLZAe",15) == 301208827) strcat(s, "r");
if (crc32("TKoUbhk",7) == 4107252040) strcat(s, "i");
if (crc32("hrbrcnfuB",9) == 146458252) strcat(s, "i");
if (crc32("acEWMdNAvqS",11) == 3976406894) strcat(s, "t");
if (crc32("fdOyJDcbEH",10) == 1995712505) strcat(s, "p");
if (crc32("MVhldQif",8) == 3859739635) strcat(s, "o");
if (crc32("pVnTU",5) == 3988347851) strcat(s, "f");
if (crc32("wHdlvRzszroaFJ",14) == 3158258058) strcat(s, "r");
if (crc32("iCDtlLGeYk",10) == 2271481290) strcat(s, "i");
if (crc32("MXPjCCCpLkd",11) == 3902583722) strcat(s, "i");
if (crc32("mKtxVCFUyVJmq",13) == 3775242530) strcat(s, "o");
if (crc32("hkvQuNM",7) == 1843871473) strcat(s, "S");
if (crc32("LmAnFQtYAdstwzf",15) == 1174808651) strcat(s, "u");
if (crc32("mNPTtpV",7) == 3236725698) strcat(s, "s");
if (crc32("zSoYXhENO",9) == 107734708) strcat(s, "l");
if (crc32("IvGJEFsrzMO",11) == 1122723563) strcat(s, "q");
if (crc32("IXPvfIdypQ",10) == 3309849797) strcat(s, "y");
    return s;
}

char *coastward_adverbs() {
    char *s = calloc(10);
    if (crc32("rtTetp",6) == 3932100502) strcat(s, "c");
if (crc32("HKVGFdWxkorIB",13) == 859248255) strcat(s, "o");
if (crc32("MupzjPIMUyqXUu",14) == 3782421856) strcat(s, "o");
if (crc32("eacdCMD",7) == 2871429714) strcat(s, "a");
if (crc32("RiavasFqfJj",11) == 141311286) strcat(s, "s");
if (crc32("cfzGIGVzskwj",12) == 2123548974) strcat(s, "y");
if (crc32("hDuffmsKcodps",13) == 4091536545) strcat(s, "t");
if (crc32("bHBgXRQZlpS",11) == 1360723812) strcat(s, "k");
if (crc32("FCVGUdtrshx",11) == 2286306823) strcat(s, "w");
if (crc32("acREgq",6) == 3941726372) strcat(s, "A");
if (crc32("NiGzHWnnlqfAjS",14) == 3068033991) strcat(s, "a");
if (crc32("IerPtkRyGlNsQLq",15) == 3009115232) strcat(s, "z");
if (crc32("zwTotqgJNbI",11) == 1623715476) strcat(s, "r");
if (crc32("sJQWFCWCAwP",11) == 666684241) strcat(s, "K");
if (crc32("CUJzN",5) == 471588841) strcat(s, "d");
    return s;
}

char *unpositively_adverbs() {
    char *s = calloc(13);
    if (crc32("PistAUFZNTtoUCc",15) == 4085384765) strcat(s, "u");
if (crc32("rSaqrArteiBV",12) == 3322803908) strcat(s, "n");
if (crc32("YQdTNhIOqS",10) == 2232758535) strcat(s, "p");
if (crc32("yYOqTjpQcgTl",12) == 3143583204) strcat(s, "t");
if (crc32("xPhVcRK",7) == 710145920) strcat(s, "o");
if (crc32("sNQwVzwotWpfOzZ",15) == 3924619005) strcat(s, "s");
if (crc32("PLUbz",5) == 3250133720) strcat(s, "Z");
if (crc32("ygGbCHQPOD",10) == 381110031) strcat(s, "i");
if (crc32("UGdKQOXFhTXvC",13) == 2940691787) strcat(s, "k");
if (crc32("NqdNzrvbpFA",11) == 3521942857) strcat(s, "t");
if (crc32("CaPSyRVoCJVIgN",14) == 3943958300) strcat(s, "i");
if (crc32("vPtiNUNBvmIuO",13) == 1349655473) strcat(s, "T");
if (crc32("gVXzYt",6) == 2024685017) strcat(s, "v");
if (crc32("XyFcNzlfMpAk",12) == 3075763285) strcat(s, "W");
if (crc32("NpqatDtMbXFb",12) == 1353137771) strcat(s, "e");
if (crc32("CSCIDOaGNiBC",12) == 4100400460) strcat(s, "Z");
if (crc32("ayFJABFYoi",10) == 1661533505) strcat(s, "l");
if (crc32("fHXAs",5) == 3425772776) strcat(s, "y");
    return s;
}

char *undeliberately_adverbs() {
    char *s = calloc(15);
    if (crc32("bfgZmDFFf",9) == 2324046878) strcat(s, "j");
if (crc32("MhcjPpfWl",9) == 2002980753) strcat(s, "u");
if (crc32("Tkogm",5) == 85958591) strcat(s, "m");
if (crc32("XAfMCfOzWsbWEK",14) == 2788549726) strcat(s, "n");
if (crc32("BDNDFbhip",9) == 3743751245) strcat(s, "d");
if (crc32("oosVDRtiNtzOGJi",15) == 3754147871) strcat(s, "w");
if (crc32("sPgCXhaEsCIsQn",14) == 833716664) strcat(s, "e");
if (crc32("jJFtNdAMJ",9) == 3513792104) strcat(s, "l");
if (crc32("OKvyhwwj",8) == 2552202375) strcat(s, "i");
if (crc32("hcmGTtaYFr",10) == 3984858666) strcat(s, "b");
if (crc32("TiFShhdaRtWF",12) == 1670612827) strcat(s, "e");
if (crc32("GmuCYiAnom",10) == 2897681840) strcat(s, "r");
if (crc32("gcHSSCchgONLQ",13) == 1442129355) strcat(s, "B");
if (crc32("TWyXiL",6) == 321107410) strcat(s, "a");
if (crc32("KdgbJoTL",8) == 2393953092) strcat(s, "t");
if (crc32("EXiawuWoCecYyr",14) == 702036157) strcat(s, "L");
if (crc32("wBbPtunJe",9) == 744548554) strcat(s, "e");
if (crc32("EJJfSo",6) == 142345985) strcat(s, "l");
if (crc32("AcZnqLrShex",11) == 1654091322) strcat(s, "r");
if (crc32("FMcdBZgEx",9) == 3370768687) strcat(s, "y");
    return s;
}

char *incumbently_adverbs() {
    char *s = calloc(12);
    if (crc32("XTeTTGHbMa",10) == 2225741148) strcat(s, "G");
if (crc32("nDpEATKDiDC",11) == 492461262) strcat(s, "i");
if (crc32("YkcYTnCYefXU",12) == 117217949) strcat(s, "d");
if (crc32("znyfw",5) == 140506146) strcat(s, "n");
if (crc32("lTlFc",5) == 2110685528) strcat(s, "L");
if (crc32("VRfVjjVjFbTgrFl",15) == 1217341855) strcat(s, "c");
if (crc32("ELWnfttDHQflXr",14) == 3853442549) strcat(s, "u");
if (crc32("FpENRrDq",8) == 858198329) strcat(s, "H");
if (crc32("BmwecXFawJLy",12) == 4082204819) strcat(s, "m");
if (crc32("AyEAWsT",7) == 3781268022) strcat(s, "b");
if (crc32("BgCAybpOu",9) == 456532927) strcat(s, "e");
if (crc32("ZhhwWTJpHDXt",12) == 3257737454) strcat(s, "n");
if (crc32("gjJLTJcYDd",10) == 3404231245) strcat(s, "F");
if (crc32("UhaPvUMKcU",10) == 158375661) strcat(s, "t");
if (crc32("tGyRSeXnvkbSsXT",15) == 1350126792) strcat(s, "A");
if (crc32("onioRlI",7) == 2356893808) strcat(s, "l");
if (crc32("vmsWkuYQw",9) == 738762202) strcat(s, "y");
if (crc32("qKvpfLwYsA",10) == 4084456464) strcat(s, "y");
    return s;
}

char *aerobacteriologically_adverbs() {
    char *s = calloc(22);
    if (crc32("TCEEqHWwTGe",11) == 2794250773) strcat(s, "k");
if (crc32("dYZXZzyVsnH",11) == 1296222547) strcat(s, "a");
if (crc32("nUDUS",5) == 2668829282) strcat(s, "S");
if (crc32("GrgYlhnWg",9) == 287988539) strcat(s, "e");
if (crc32("rOZNnUT",7) == 1270886048) strcat(s, "O");
if (crc32("ZXjZAECvv",9) == 2128867097) strcat(s, "r");
if (crc32("JebqLsOmHTh",11) == 2214865657) strcat(s, "o");
if (crc32("yHxSwuZbWgcLUxD",15) == 3426221467) strcat(s, "b");
if (crc32("hsNhtbvr",8) == 504690691) strcat(s, "M");
if (crc32("oEDDJ",5) == 67483677) strcat(s, "a");
if (crc32("Wwfdqhlj",8) == 3305771310) strcat(s, "S");
if (crc32("DfXjsTgZOyEM",12) == 477951387) strcat(s, "c");
if (crc32("smshdEdFWGe",11) == 4224458661) strcat(s, "t");
if (crc32("YcMhKUZYL",9) == 19860317) strcat(s, "e");
if (crc32("WxiZptFhBSiV",12) == 280868397) strcat(s, "r");
if (crc32("rOhAtDjUcaAkY",13) == 3653146638) strcat(s, "D");
if (crc32("bpDEEyaUhxhXOY",14) == 265786621) strcat(s, "i");
if (crc32("sdvXfXWfcmdlpjI",15) == 2062946511) strcat(s, "I");
if (crc32("bwLqjp",6) == 4108985566) strcat(s, "o");
if (crc32("wNWnSPtkU",9) == 3760111196) strcat(s, "l");
if (crc32("AiMoGpemsyRSYL",14) == 1386785228) strcat(s, "m");
if (crc32("RrECPcYxNtrd",12) == 3773373648) strcat(s, "o");
if (crc32("WfgwncN",7) == 3853804961) strcat(s, "g");
if (crc32("YmmzGbDGy",9) == 2839600124) strcat(s, "i");
if (crc32("zAJhtLdMSdSiH",13) == 3274104800) strcat(s, "f");
if (crc32("Reuxuu",6) == 3581055268) strcat(s, "c");
if (crc32("bOhOKuHSlDL",11) == 501385742) strcat(s, "a");
if (crc32("WxOUklUZRumhs",13) == 1792958571) strcat(s, "P");
if (crc32("ylhbdsSQUlku",12) == 896374413) strcat(s, "l");
if (crc32("YYfIyfkBqcLBC",13) == 3270106310) strcat(s, "l");
if (crc32("paDVtfzDWrZSmGe",15) == 4246436716) strcat(s, "y");
    return s;
}

char *consubstantially_adverbs() {
    char *s = calloc(17);
    if (crc32("xzIWC",5) == 265061782) strcat(s, "d");
if (crc32("JZZwqCYmgRrJrCy",15) == 3996575600) strcat(s, "c");
if (crc32("rViYyVHx",8) == 3386042166) strcat(s, "o");
if (crc32("qbHjgTzXalzG",12) == 3639820709) strcat(s, "n");
if (crc32("XrYlviiffyziuj",14) == 3094164179) strcat(s, "v");
if (crc32("DASHj",5) == 3016026990) strcat(s, "s");
if (crc32("ECvsUVAG",8) == 3666713985) strcat(s, "j");
if (crc32("OscIKxXOAMNNbC",14) == 4151709851) strcat(s, "u");
if (crc32("wAUmm",5) == 660541646) strcat(s, "b");
if (crc32("uhrgpEQJ",8) == 2096393892) strcat(s, "s");
if (crc32("pyPOmFuuEoMl",12) == 2327142334) strcat(s, "t");
if (crc32("rePDhFffzoB",11) == 81756517) strcat(s, "u");
if (crc32("bBLSVu",6) == 2776304854) strcat(s, "a");
if (crc32("TrFgQPJC",8) == 1756352845) strcat(s, "m");
if (crc32("JjrGZ",5) == 3809049988) strcat(s, "n");
if (crc32("OdSnyayBWaOccd",14) == 1651164042) strcat(s, "j");
if (crc32("EJkoYhNEYD",10) == 3041643496) strcat(s, "t");
if (crc32("jlJjmxuKqM",10) == 224347728) strcat(s, "h");
if (crc32("cQAAXsJCSMMopp",14) == 2566810250) strcat(s, "i");
if (crc32("dMGfUnfCtWV",11) == 4283553949) strcat(s, "F");
if (crc32("ZInNlqnMbJAWyP",14) == 533631418) strcat(s, "a");
if (crc32("CEuhuERAmU",10) == 3742365401) strcat(s, "s");
if (crc32("ZodiZiRHpf",10) == 700256146) strcat(s, "l");
if (crc32("czoeJxNJVQjY",12) == 1090190575) strcat(s, "l");
if (crc32("OKeOaMVcRqOa",12) == 3627841117) strcat(s, "c");
if (crc32("ImcQPGotiTU",11) == 1386127055) strcat(s, "y");
    return s;
}

char *nohit_adverbs() {
    char *s = calloc(6);
    if (crc32("jThUltMftNUw",12) == 637643777) strcat(s, "n");
if (crc32("DVTHx",5) == 2298274693) strcat(s, "o");
if (crc32("QaYRp",5) == 4214151893) strcat(s, "h");
if (crc32("NrmBARA",7) == 1140075043) strcat(s, "G");
if (crc32("AxilSklkeANWXY",14) == 3479755569) strcat(s, "i");
if (crc32("PgJSXBJfYWV",11) == 299028461) strcat(s, "h");
if (crc32("YPQyRsdtR",9) == 2128663104) strcat(s, "t");
    return s;
}

char *unapprehendably_adverbs() {
    char *s = calloc(16);
    if (crc32("uEJQAUiuWDna",12) == 3858986964) strcat(s, "u");
if (crc32("UWZYUtmdRQFdPA",14) == 4147431787) strcat(s, "f");
if (crc32("dGoqZ",5) == 1380072020) strcat(s, "n");
if (crc32("adorUm",6) == 1572172868) strcat(s, "z");
if (crc32("BgVCwgKeQuZ",11) == 3685694921) strcat(s, "a");
if (crc32("SAsQAgDRnvcQ",12) == 4221848079) strcat(s, "p");
if (crc32("xClneh",6) == 565892239) strcat(s, "p");
if (crc32("ADPtzQMSf",9) == 3162975581) strcat(s, "r");
if (crc32("qaXpYSy",7) == 2896506552) strcat(s, "e");
if (crc32("RyObvcjlbW",10) == 1518652688) strcat(s, "h");
if (crc32("dhQnvDFKiOMqqS",14) == 990075980) strcat(s, "I");
if (crc32("manrO",5) == 2637788632) strcat(s, "e");
if (crc32("antFhZPuSjWF",12) == 1819036806) strcat(s, "h");
if (crc32("OZVXVCHxUe",10) == 3555073709) strcat(s, "n");
if (crc32("rvNycvpYCHU",11) == 2817111847) strcat(s, "G");
if (crc32("TEQqOXWWXf",10) == 185860199) strcat(s, "d");
if (crc32("vDxgWGfQWr",10) == 2869395287) strcat(s, "B");
if (crc32("yfnrAAxPwQFdlS",14) == 1637345239) strcat(s, "a");
if (crc32("BmxOlzCsYI",10) == 43515916) strcat(s, "N");
if (crc32("ZCYcRrD",7) == 2350219313) strcat(s, "b");
if (crc32("bfxNK",5) == 3894355447) strcat(s, "Y");
if (crc32("BOdCgGvwMN",10) == 1842861417) strcat(s, "l");
if (crc32("cxEOIipocl",10) == 509455907) strcat(s, "Z");
if (crc32("HbDPRQrGgssC",12) == 2232996787) strcat(s, "y");
    return s;
}

char *subterminally_adverbs() {
    char *s = calloc(14);
    if (crc32("IjuabtZ",7) == 611966321) strcat(s, "w");
if (crc32("SKuWBcWWIqDrNZ",14) == 829160254) strcat(s, "s");
if (crc32("fFjiKxr",7) == 425211483) strcat(s, "R");
if (crc32("GwCuFHapsftveW",14) == 1046996595) strcat(s, "u");
if (crc32("ifDYpDFBiqNjrN",14) == 2102303324) strcat(s, "b");
if (crc32("rJPzJ",5) == 2667375529) strcat(s, "t");
if (crc32("hbgAbqWmEXEou",13) == 2730020871) strcat(s, "C");
if (crc32("ZSFYJXxhMC",10) == 3140614851) strcat(s, "e");
if (crc32("UTnbBALQqv",10) == 1589395303) strcat(s, "r");
if (crc32("iPNjsHzjmpsBMSw",15) == 2692611894) strcat(s, "y");
if (crc32("bOZCafnf",8) == 1736888711) strcat(s, "m");
if (crc32("TYDoqEXsYNGj",12) == 2783495969) strcat(s, "i");
if (crc32("dKskroOKqnaduD",14) == 1540422996) strcat(s, "v");
if (crc32("OGIzriBWTzA",11) == 2192293292) strcat(s, "n");
if (crc32("vSItrs",6) == 1928009389) strcat(s, "a");
if (crc32("jxIoLz",6) == 2558797072) strcat(s, "l");
if (crc32("bVPeVdVczlkw",12) == 1488306035) strcat(s, "b");
if (crc32("Mmihf",5) == 3791556950) strcat(s, "l");
if (crc32("kFlwfoRnNl",10) == 720597946) strcat(s, "m");
if (crc32("pLDyIKXVijRO",12) == 38585339) strcat(s, "y");
    return s;
}

char *nonethereally_adverbs() {
    char *s = calloc(14);
    if (crc32("MoZSjgp",7) == 3589325764) strcat(s, "n");
if (crc32("gdsUFRdFrz",10) == 4203345477) strcat(s, "o");
if (crc32("lsOwgheECaNlpk",14) == 1564224159) strcat(s, "o");
if (crc32("WCEhvFM",7) == 3697513820) strcat(s, "j");
if (crc32("LthjF",5) == 4178937998) strcat(s, "n");
if (crc32("NrSCaBRyVt",10) == 1943020320) strcat(s, "e");
if (crc32("szQuvfmt",8) == 2152872312) strcat(s, "R");
if (crc32("NpkzFqMUBn",10) == 540836437) strcat(s, "t");
if (crc32("yJdvqpYLULXFf",13) == 919725413) strcat(s, "K");
if (crc32("AlJWdT",6) == 3653851396) strcat(s, "h");
if (crc32("McbxBTLK",8) == 85220437) strcat(s, "F");
if (crc32("HORDOxInEzJ",11) == 2003760737) strcat(s, "e");
if (crc32("ffsWCBKpLVbZ",12) == 1625606188) strcat(s, "j");
if (crc32("vyORCkEsIW",10) == 1238216827) strcat(s, "r");
if (crc32("aBUmaDJuXP",10) == 187517442) strcat(s, "e");
if (crc32("ZEAWDatuEewgc",13) == 936015120) strcat(s, "a");
if (crc32("rVNzEyUFdQDg",12) == 419095356) strcat(s, "S");
if (crc32("SSgBCkPvU",9) == 2270315284) strcat(s, "l");
if (crc32("mbvzY",5) == 333072587) strcat(s, "o");
if (crc32("siVQJsikFXBYrA",14) == 1036422033) strcat(s, "l");
if (crc32("KBxJUhQinKdISfI",15) == 592979408) strcat(s, "s");
if (crc32("hytXZsFlTMUR",12) == 82657097) strcat(s, "y");
    return s;
}

char *nonconvertibly_adverbs() {
    char *s = calloc(15);
    if (crc32("ZWmMJH",6) == 1434175113) strcat(s, "n");
if (crc32("DOBMpwQ",7) == 2961726311) strcat(s, "o");
if (crc32("dlBtxJBKpvnJdG",14) == 4091236528) strcat(s, "n");
if (crc32("oxWmTaHPDoNtuhh",15) == 1321510804) strcat(s, "s");
if (crc32("ckVWYQpxj",9) == 120203125) strcat(s, "c");
if (crc32("KUlDqjyzh",9) == 3439236662) strcat(s, "c");
if (crc32("RUeMiKXHBkFqGpb",15) == 3716436261) strcat(s, "o");
if (crc32("SQLKbUzdcb",10) == 395336728) strcat(s, "K");
if (crc32("BzJLSe",6) == 1633133847) strcat(s, "n");
if (crc32("KAPAsxA",7) == 3025503062) strcat(s, "v");
if (crc32("OaOlVukIP",9) == 3556137296) strcat(s, "e");
if (crc32("AIowlCkpHpF",11) == 3048174829) strcat(s, "r");
if (crc32("oRXkesW",7) == 3356211465) strcat(s, "S");
if (crc32("blRhRay",7) == 2016765812) strcat(s, "t");
if (crc32("UDBcluegKNX",11) == 1400470110) strcat(s, "w");
if (crc32("kufMiBcs",8) == 2597393778) strcat(s, "i");
if (crc32("BJvDUPCfQw",10) == 610820427) strcat(s, "b");
if (crc32("RAlouc",6) == 564068433) strcat(s, "l");
if (crc32("fkmAf",5) == 3432288848) strcat(s, "i");
if (crc32("QotMIbL",7) == 3551196364) strcat(s, "y");
    return s;
}

char *overspeedily_adverbs() {
    char *s = calloc(13);
    if (crc32("oTgOHNDBVX",10) == 1849970746) strcat(s, "o");
if (crc32("hvHzMIx",7) == 2473096065) strcat(s, "v");
if (crc32("gCWonp",6) == 88748235) strcat(s, "e");
if (crc32("YOADYL",6) == 3098448492) strcat(s, "z");
if (crc32("dlPiajZUEz",10) == 703256528) strcat(s, "r");
if (crc32("DCdUWOxbOPsAogN",15) == 4242257228) strcat(s, "s");
if (crc32("OIoqeLIXPYNm",12) == 2636008032) strcat(s, "p");
if (crc32("jiMsUa",6) == 1312765589) strcat(s, "e");
if (crc32("BztuLxFcYnDpC",13) == 4117250705) strcat(s, "e");
if (crc32("UFKdH",5) == 2381821287) strcat(s, "d");
if (crc32("JQegZOYXbJCGpw",14) == 694862580) strcat(s, "F");
if (crc32("kzJAwIuAXJ",10) == 2134356376) strcat(s, "i");
if (crc32("eidcGR",6) == 3109148225) strcat(s, "l");
if (crc32("WCBHfKzyjKD",11) == 1245970056) strcat(s, "y");
    return s;
}

char *shatteringly_adverbs() {
    char *s = calloc(13);
    if (crc32("BJrohVGoqjwElgj",15) == 2301994861) strcat(s, "s");
if (crc32("xFXsLSvmSJuJ",12) == 3030462378) strcat(s, "h");
if (crc32("agzLPSm",7) == 241669904) strcat(s, "X");
if (crc32("IJBBE",5) == 3499078730) strcat(s, "a");
if (crc32("RzCjxWPwm",9) == 2394828914) strcat(s, "n");
if (crc32("olhanZir",8) == 3505157005) strcat(s, "t");
if (crc32("bsqIHmLJavR",11) == 2960837610) strcat(s, "t");
if (crc32("zsZSIfMsEhVBv",13) == 3880923797) strcat(s, "v");
if (crc32("QuPFpRrIo",9) == 2924596724) strcat(s, "e");
if (crc32("pqEyMZOV",8) == 2455893080) strcat(s, "p");
if (crc32("WqeEUf",6) == 2102359541) strcat(s, "r");
if (crc32("poEIbVxHOUXemQ",14) == 1241439717) strcat(s, "i");
if (crc32("MIftIGytojxcL",13) == 791500659) strcat(s, "P");
if (crc32("RIAdjbMTCxfmI",13) == 3476236542) strcat(s, "n");
if (crc32("ihZkR",5) == 3470070815) strcat(s, "g");
if (crc32("gkDykvrVZD",10) == 1457770845) strcat(s, "l");
if (crc32("VzhoJHBwU",9) == 3369060443) strcat(s, "i");
if (crc32("OeORJ",5) == 1966826001) strcat(s, "y");
    return s;
}

char *favouredly_adverbs() {
    char *s = calloc(11);
    if (crc32("wkJcT",5) == 3420126111) strcat(s, "F");
if (crc32("FKdrhgORyR",10) == 467504048) strcat(s, "f");
if (crc32("rNViPwCydWOTp",13) == 4077059179) strcat(s, "a");
if (crc32("zVeDWKjYyvat",12) == 2035641167) strcat(s, "v");
if (crc32("aLmgFbQrPDdlmRj",15) == 1494438831) strcat(s, "O");
if (crc32("eAGuI",5) == 2630213562) strcat(s, "o");
if (crc32("CoAilInPCbLWaVh",15) == 3884009383) strcat(s, "u");
if (crc32("HnqRlYIjc",9) == 2472454847) strcat(s, "r");
if (crc32("kunbJLHqkg",10) == 2366535992) strcat(s, "F");
if (crc32("SycnEdfUxSKQugK",15) == 2743072333) strcat(s, "e");
if (crc32("XLYWkvcPSXq",11) == 3600913842) strcat(s, "d");
if (crc32("WfdVnxliZZ",10) == 2245988257) strcat(s, "l");
if (crc32("QkGoyCf",7) == 3620612764) strcat(s, "y");
    return s;
}

char *rosily_adverbs() {
    char *s = calloc(7);
    if (crc32("YKtvSYQiw",9) == 1472569881) strcat(s, "r");
if (crc32("CjUtTVA",7) == 3401616594) strcat(s, "o");
if (crc32("hHseOYrk",8) == 2866751195) strcat(s, "o");
if (crc32("rdZxl",5) == 2561834086) strcat(s, "Q");
if (crc32("pfrswauMQqbtCg",14) == 1839686087) strcat(s, "s");
if (crc32("RlFKdavHTojGy",13) == 2378803920) strcat(s, "P");
if (crc32("wizGzhJcYHkGdW",14) == 3435962553) strcat(s, "i");
if (crc32("AhHtKTsldDQ",11) == 3524682850) strcat(s, "p");
if (crc32("vboutUVcJGst",12) == 2910197732) strcat(s, "l");
if (crc32("cQjkYqOHIUF",11) == 1705192901) strcat(s, "y");
    return s;
}

char *empathically_adverbs() {
    char *s = calloc(13);
    if (crc32("gydkSYGLnbbsROu",15) == 2176338959) strcat(s, "e");
if (crc32("HBaIdFlBmQ",10) == 2197455774) strcat(s, "N");
if (crc32("zQAdtHF",7) == 932608960) strcat(s, "m");
if (crc32("VnJuEJhvzYyVT",13) == 898833519) strcat(s, "z");
if (crc32("ZZvEsnCeiq",10) == 704163529) strcat(s, "p");
if (crc32("otKEAZyWKnpXQ",13) == 639253912) strcat(s, "o");
if (crc32("wwmcallpOjBA",12) == 788080771) strcat(s, "a");
if (crc32("XwNAhwa",7) == 1125497024) strcat(s, "t");
if (crc32("lUtGHeXrxjbQ",12) == 4200656961) strcat(s, "h");
if (crc32("CeLuJpODfCVIl",13) == 2695241668) strcat(s, "x");
if (crc32("ylwsrInkLNi",11) == 700443984) strcat(s, "i");
if (crc32("nTLaBZo",7) == 556013488) strcat(s, "c");
if (crc32("BGdBfQzOqqElNXx",15) == 1632365366) strcat(s, "e");
if (crc32("YngaisKAKUxmOfO",15) == 2478668087) strcat(s, "a");
if (crc32("uXreUhRKbxt",11) == 2457569691) strcat(s, "M");
if (crc32("ggllQfrfDds",11) == 1696486423) strcat(s, "l");
if (crc32("wAWJRAJnECMeF",13) == 15156368) strcat(s, "W");
if (crc32("jZssutI",7) == 3459161428) strcat(s, "l");
if (crc32("xxGToOUTbTG",11) == 3946273554) strcat(s, "y");
    return s;
}

char *overproficiently_adverbs() {
    char *s = calloc(17);
    if (crc32("QsxijCmqop",10) == 4099650701) strcat(s, "F");
if (crc32("zrTKqLOLvJANy",13) == 249577435) strcat(s, "o");
if (crc32("cYNCxlFpzvvj",12) == 3540661441) strcat(s, "v");
if (crc32("KejdheHmRWTTWPJ",15) == 1314620627) strcat(s, "e");
if (crc32("iWjYOX",6) == 2555865598) strcat(s, "P");
if (crc32("EDhjSeg",7) == 1206459841) strcat(s, "r");
if (crc32("weTwPGGNSS",10) == 3760612316) strcat(s, "p");
if (crc32("NQUeau",6) == 1873085898) strcat(s, "r");
if (crc32("sFSsHT",6) == 812537216) strcat(s, "o");
if (crc32("cgiFiSHtQfKgN",13) == 3961028918) strcat(s, "j");
if (crc32("bzlRBbIxyvIyN",13) == 3062187088) strcat(s, "f");
if (crc32("mMBwTr",6) == 2780055548) strcat(s, "i");
if (crc32("joASWxsHbGs",11) == 1247569089) strcat(s, "o");
if (crc32("srEHAS",6) == 1982162718) strcat(s, "c");
if (crc32("fALiSvWsE",9) == 3668410920) strcat(s, "i");
if (crc32("LtHnGKySzfm",11) == 2027397976) strcat(s, "e");
if (crc32("sakCl",5) == 538503184) strcat(s, "n");
if (crc32("KrRuqiPcyxmG",12) == 1128883257) strcat(s, "t");
if (crc32("JsFyhKJLYUaHp",13) == 2228189966) strcat(s, "P");
if (crc32("zrPanTIbRqjEhIN",15) == 2822352495) strcat(s, "l");
if (crc32("pTTkyrlpIRwzfu",14) == 3616029834) strcat(s, "y");
    return s;
}

char *unexceptionably_adverbs() {
    char *s = calloc(16);
    if (crc32("KhxNqY",6) == 2365845214) strcat(s, "u");
if (crc32("gGosnIh",7) == 3052575888) strcat(s, "U");
if (crc32("LELTMJCWyMF",11) == 1699894540) strcat(s, "n");
if (crc32("PgyxUvIx",8) == 1305223929) strcat(s, "j");
if (crc32("HQOfMjIwLgedh",13) == 1211755065) strcat(s, "e");
if (crc32("RkUWiRObvEqih",13) == 1195946625) strcat(s, "p");
if (crc32("PXodMEmeDkQZc",13) == 1670664144) strcat(s, "x");
if (crc32("bIDSdRCS",8) == 3488278355) strcat(s, "L");
if (crc32("iGRgSp",6) == 2581929551) strcat(s, "c");
if (crc32("dWUBPkmoN",9) == 2631277049) strcat(s, "I");
if (crc32("ZIpMchSul",9) == 817835329) strcat(s, "e");
if (crc32("LLLbkStoqwkhJL",14) == 3284033924) strcat(s, "p");
if (crc32("FdxFm",5) == 1561974401) strcat(s, "C");
if (crc32("UhPdzA",6) == 337348687) strcat(s, "t");
if (crc32("qVBQojoMcATl",12) == 377689289) strcat(s, "i");
if (crc32("xMOzaApGQSok",12) == 1961955341) strcat(s, "o");
if (crc32("iekNA",5) == 1968951900) strcat(s, "n");
if (crc32("FHimWulpT",9) == 4147060968) strcat(s, "K");
if (crc32("plfyOhR",7) == 1576056325) strcat(s, "a");
if (crc32("spMlSVUN",8) == 3600254348) strcat(s, "P");
if (crc32("fAbZVTYeaKjRFN",14) == 1945842577) strcat(s, "b");
if (crc32("rbDiDOWkjQIDa",13) == 3700226124) strcat(s, "l");
if (crc32("hskCFXXw",8) == 2310451700) strcat(s, "L");
if (crc32("hagNRcOtrKrN",12) == 2402251613) strcat(s, "y");
    return s;
}

char *tricklingly_adverbs() {
    char *s = calloc(12);
    if (crc32("adfkGjsKYqB",11) == 955741719) strcat(s, "P");
if (crc32("RwJGqJ",6) == 2586310565) strcat(s, "t");
if (crc32("rMLkrFTw",8) == 2640590044) strcat(s, "r");
if (crc32("SuZXiHcCjlGBAY",14) == 564234317) strcat(s, "i");
if (crc32("PZPyilJxbZqOgr",14) == 2271433051) strcat(s, "c");
if (crc32("LxbSzcu",7) == 709786290) strcat(s, "p");
if (crc32("wplwi",5) == 4080168919) strcat(s, "k");
if (crc32("aLIjABcndGfxVFL",15) == 4127462854) strcat(s, "l");
if (crc32("ocKigYKUJBsZPMs",15) == 4224176716) strcat(s, "i");
if (crc32("fyemBmELdrHxMjy",15) == 4096402248) strcat(s, "f");
if (crc32("ddzFaWUCWg",10) == 3254447498) strcat(s, "n");
if (crc32("vtiVkPdlNJxWQw",14) == 2723988313) strcat(s, "n");
if (crc32("HpvSMAMppJJsIh",14) == 376754601) strcat(s, "g");
if (crc32("yGTIlygA",8) == 187917287) strcat(s, "N");
if (crc32("CyYbtsIvRHlPIBj",15) == 2575062454) strcat(s, "l");
if (crc32("yapqNi",6) == 1456994792) strcat(s, "b");
if (crc32("VncDkRvMguOb",12) == 2010802477) strcat(s, "y");
    return s;
}

char *quasiformally_adverbs() {
    char *s = calloc(14);
    if (crc32("ApjIzrO",7) == 3560249355) strcat(s, "Y");
if (crc32("qrzpMvJ",7) == 3739916468) strcat(s, "q");
if (crc32("CSAUaZAQhUTWdp",14) == 4021402414) strcat(s, "S");
if (crc32("MzLjBShcTbKF",12) == 1155651026) strcat(s, "u");
if (crc32("YMWAJBvDjAvk",12) == 3372041343) strcat(s, "a");
if (crc32("ihcknBCCdLiVDMz",15) == 2444313944) strcat(s, "s");
if (crc32("MYplAUoKHx",10) == 4219110479) strcat(s, "i");
if (crc32("fYmnlKfdSXjLBMx",15) == 1762487787) strcat(s, "f");
if (crc32("vqDAQHHrttqHUBe",15) == 580374963) strcat(s, "R");
if (crc32("ZGhXvL",6) == 1815510340) strcat(s, "o");
if (crc32("kKFlcXX",7) == 4248810180) strcat(s, "u");
if (crc32("pdDPDJbZVU",10) == 455138099) strcat(s, "r");
if (crc32("sIxTz",5) == 2863219503) strcat(s, "m");
if (crc32("tUhRqCutUCrQYj",14) == 1388445596) strcat(s, "t");
if (crc32("OgxuTYVLCIjFu",13) == 4207510036) strcat(s, "a");
if (crc32("kXfJkhr",7) == 4284951451) strcat(s, "f");
if (crc32("Spadja",6) == 2884180556) strcat(s, "l");
if (crc32("wRGgVtN",7) == 3325848545) strcat(s, "Q");
if (crc32("ZDAJuL",6) == 3257123837) strcat(s, "l");
if (crc32("khnuVlXnqOr",11) == 3659757565) strcat(s, "y");
    return s;
}

char *unbriefly_adverbs() {
    char *s = calloc(10);
    if (crc32("puuseSisTqdTT",13) == 2417090019) strcat(s, "Z");
if (crc32("nKKbZN",6) == 2053750762) strcat(s, "u");
if (crc32("zMlcNzG",7) == 1418686093) strcat(s, "n");
if (crc32("eBymhPFdGFlmh",13) == 3791549727) strcat(s, "b");
if (crc32("UwDBwDvGAIjPjX",14) == 667882893) strcat(s, "r");
if (crc32("jFdLxRTWlGxa",12) == 1749196796) strcat(s, "i");
if (crc32("DoJEZItSAaxwJSa",15) == 619124779) strcat(s, "e");
if (crc32("jbgiAEUzGnZzQVz",15) == 1448592693) strcat(s, "P");
if (crc32("AoudlBkKU",9) == 718216883) strcat(s, "f");
if (crc32("MPrMztSgugLf",12) == 488504747) strcat(s, "l");
if (crc32("qbpRR",5) == 1646440138) strcat(s, "U");
if (crc32("uBJBccGuP",9) == 781829254) strcat(s, "y");
    return s;
}

char *holoblastically_adverbs() {
    char *s = calloc(16);
    if (crc32("IbElGiMKQJO",11) == 3279640799) strcat(s, "h");
if (crc32("NhtQOjyLqp",10) == 232813788) strcat(s, "o");
if (crc32("ebaGNezziMgkx",13) == 823418090) strcat(s, "l");
if (crc32("afadzcQPQNWwT",13) == 2644763206) strcat(s, "O");
if (crc32("tQpssDuJvOeOo",13) == 348435670) strcat(s, "o");
if (crc32("ifimrUwsTRBzN",13) == 1249349310) strcat(s, "G");
if (crc32("cIIdeVQS",8) == 2604399578) strcat(s, "b");
if (crc32("ZTglQHVXHa",10) == 3585577681) strcat(s, "l");
if (crc32("JWXddRqL",8) == 4120638006) strcat(s, "Q");
if (crc32("waKXzjydUFwPMPt",15) == 1409553675) strcat(s, "a");
if (crc32("SEjUD",5) == 3760883078) strcat(s, "n");
if (crc32("jImqjuCS",8) == 2866095903) strcat(s, "s");
if (crc32("ySheWLrqDJIFQjf",15) == 2862367836) strcat(s, "T");
if (crc32("BWctt",5) == 3831609217) strcat(s, "t");
if (crc32("ZGJBuqor",8) == 4179913730) strcat(s, "i");
if (crc32("WFvUPU",6) == 2131807585) strcat(s, "i");
if (crc32("CcxkmoKLlXIJXc",14) == 350963772) strcat(s, "c");
if (crc32("dncIEAaUd",9) == 3344121461) strcat(s, "a");
if (crc32("KADgRfqrofBjp",13) == 1420800532) strcat(s, "l");
if (crc32("OYWgFzZXQgBS",12) == 947828690) strcat(s, "X");
if (crc32("SsNid",5) == 1157601297) strcat(s, "l");
if (crc32("WmXtJvfSsdDaFr",14) == 83484693) strcat(s, "y");
    return s;
}

char *uncrudely_adverbs() {
    char *s = calloc(10);
    if (crc32("jlPEjnu",7) == 3340036444) strcat(s, "u");
if (crc32("numtVOcBBCrLNK",14) == 424346559) strcat(s, "f");
if (crc32("TSuGxMpmXIq",11) == 1348922734) strcat(s, "n");
if (crc32("GebDrRKdEbf",11) == 1491465232) strcat(s, "c");
if (crc32("RgNlpam",7) == 1063431404) strcat(s, "W");
if (crc32("pTefH",5) == 2116256623) strcat(s, "r");
if (crc32("MwPLBpYBqNtuI",13) == 4246178189) strcat(s, "G");
if (crc32("bWqlCRBmrGmeZlm",15) == 3821434883) strcat(s, "u");
if (crc32("giSWqWjvy",9) == 1419263493) strcat(s, "S");
if (crc32("nQwPclCmoxBdA",13) == 3610038822) strcat(s, "d");
if (crc32("hnNdbCCjFPmZ",12) == 3801668929) strcat(s, "e");
if (crc32("qKRAeSLfn",9) == 1831833727) strcat(s, "l");
if (crc32("xwTggiUuBs",10) == 701693605) strcat(s, "y");
    return s;
}

char *nonformally_adverbs() {
    char *s = calloc(12);
    if (crc32("HxrgzZvN",8) == 2693645971) strcat(s, "n");
if (crc32("GZPlkXje",8) == 3184601391) strcat(s, "o");
if (crc32("gJGcNzjY",8) == 3990369302) strcat(s, "j");
if (crc32("BKsbfpqwffrf",12) == 2812329450) strcat(s, "n");
if (crc32("CPUUopRdnp",10) == 229597329) strcat(s, "f");
if (crc32("slQKifCwh",9) == 2482687687) strcat(s, "o");
if (crc32("onZfZGZPI",9) == 1498024452) strcat(s, "r");
if (crc32("tPDYhpRZbzweVMZ",15) == 544235300) strcat(s, "d");
if (crc32("TyTfffIfTdcHlX",14) == 2015017137) strcat(s, "m");
if (crc32("bVCUbLJDYVgR",12) == 29830111) strcat(s, "a");
if (crc32("BERrJyzgJVd",11) == 756495444) strcat(s, "l");
if (crc32("enrDDi",6) == 1721882171) strcat(s, "L");
if (crc32("cjnLMRUXoXr",11) == 2614479130) strcat(s, "l");
if (crc32("HGTiiw",6) == 3241013712) strcat(s, "y");
    return s;
}


char *(*adverbs_list[4096])() = {
thanklessly_adverbs,
jazzily_adverbs,
draconically_adverbs,
periosteally_adverbs,
engrainedly_adverbs,
quasitolerantly_adverbs,
discretionarily_adverbs,
kissably_adverbs,
depressively_adverbs,
pseudostudiously_adverbs,
willynilly_adverbs,
circumscriptively_adverbs,
electroosmotically_adverbs,
halffertilely_adverbs,
curtailedly_adverbs,
unreverently_adverbs,
discomposingly_adverbs,
bindingly_adverbs,
solidly_adverbs,
unvariably_adverbs,
nosographically_adverbs,
nondivisively_adverbs,
noncompetitively_adverbs,
salutarily_adverbs,
uncurrently_adverbs,
broadly_adverbs,
garishly_adverbs,
interpenetratively_adverbs,
quasicomplexly_adverbs,
oversuperstitiously_adverbs,
softly_adverbs,
impolitely_adverbs,
insultingly_adverbs,
thirdly_adverbs,
unmutually_adverbs,
intradermically_adverbs,
hastefully_adverbs,
hungrily_adverbs,
unweariedly_adverbs,
overpessimistically_adverbs,
connectedly_adverbs,
illiberally_adverbs,
lithologically_adverbs,
nondeterminatively_adverbs,
sippingly_adverbs,
destructively_adverbs,
untopographically_adverbs,
electrodiagnostically_adverbs,
composedly_adverbs,
inharmoniously_adverbs,
alliteratively_adverbs,
prevocalically_adverbs,
undisturbingly_adverbs,
autonomously_adverbs,
meagerly_adverbs,
unreligiously_adverbs,
Romeward_adverbs,
superdesirously_adverbs,
noncustomarily_adverbs,
ingeniously_adverbs,
faultlessly_adverbs,
superacutely_adverbs,
imponderably_adverbs,
unpotently_adverbs,
ancestrally_adverbs,
Johnsonianly_adverbs,
overmorally_adverbs,
indelicately_adverbs,
legislatively_adverbs,
unperdurably_adverbs,
funnily_adverbs,
wearyingly_adverbs,
isothermally_adverbs,
phytogeographically_adverbs,
theurgically_adverbs,
nonserviceably_adverbs,
chunkily_adverbs,
nondefinitively_adverbs,
concinnously_adverbs,
nonpertinently_adverbs,
falsely_adverbs,
unbewilderedly_adverbs,
scandalously_adverbs,
astern_adverbs,
familiarly_adverbs,
unapparently_adverbs,
anticapitalistically_adverbs,
nonadjacently_adverbs,
conceivably_adverbs,
deductively_adverbs,
malevolently_adverbs,
vibratingly_adverbs,
nontolerably_adverbs,
unartfully_adverbs,
dubiously_adverbs,
sensitometrically_adverbs,
inefficaciously_adverbs,
unbiliously_adverbs,
rabidly_adverbs,
nonpassionately_adverbs,
fiendishly_adverbs,
acquiescently_adverbs,
semiorthodoxly_adverbs,
stylographically_adverbs,
pronto_adverbs,
amorphously_adverbs,
nonsubtly_adverbs,
glacially_adverbs,
zoologically_adverbs,
foamily_adverbs,
offishly_adverbs,
coeternally_adverbs,
nonanalogously_adverbs,
hypothetically_adverbs,
blithefully_adverbs,
unpreparedly_adverbs,
overexertedly_adverbs,
superimprobably_adverbs,
overblindly_adverbs,
issuably_adverbs,
wintrily_adverbs,
troublesomely_adverbs,
prayerlessly_adverbs,
nonequilaterally_adverbs,
nonruinously_adverbs,
pregnantly_adverbs,
nontheistically_adverbs,
scoutingly_adverbs,
nonatomically_adverbs,
inconveniently_adverbs,
inflexionally_adverbs,
unnumerously_adverbs,
semimythically_adverbs,
vegetably_adverbs,
lurkingly_adverbs,
studiedly_adverbs,
fetchingly_adverbs,
rebelliously_adverbs,
overoffensively_adverbs,
unriotously_adverbs,
reproachingly_adverbs,
subtransversally_adverbs,
graciously_adverbs,
uncomprehensibly_adverbs,
overinsistently_adverbs,
hypervigilantly_adverbs,
incoherently_adverbs,
remonstratingly_adverbs,
grossly_adverbs,
resentfully_adverbs,
undynamically_adverbs,
zeugmatically_adverbs,
goodhumoredly_adverbs,
yes_adverbs,
overloudly_adverbs,
aoristically_adverbs,
cosily_adverbs,
alarmedly_adverbs,
nondepressingly_adverbs,
quasiuniversally_adverbs,
loosest_adverbs,
creakingly_adverbs,
nonpalpably_adverbs,
benignantly_adverbs,
unscornfully_adverbs,
inconvertibly_adverbs,
equivocatingly_adverbs,
regionally_adverbs,
resourcefully_adverbs,
transrationally_adverbs,
nonobviously_adverbs,
nonperversely_adverbs,
unpaternally_adverbs,
labouredly_adverbs,
beneficently_adverbs,
olericulturally_adverbs,
yappingly_adverbs,
frolicly_adverbs,
doughtily_adverbs,
noxiously_adverbs,
rustily_adverbs,
hyperintellectually_adverbs,
creamily_adverbs,
quasianciently_adverbs,
democratically_adverbs,
peaceably_adverbs,
unadmiringly_adverbs,
exhortingly_adverbs,
mezzo_adverbs,
overaggressively_adverbs,
unfaintly_adverbs,
unenterprisingly_adverbs,
Gothically_adverbs,
well_adverbs,
nonruminatingly_adverbs,
besottedly_adverbs,
antigrammatically_adverbs,
blusterously_adverbs,
nonnormally_adverbs,
ennoblingly_adverbs,
unmethodically_adverbs,
unmisgivingly_adverbs,
sulfurously_adverbs,
entrenous_adverbs,
quasipolitically_adverbs,
opposingly_adverbs,
forsakenly_adverbs,
agnostically_adverbs,
nondefinably_adverbs,
undiaphanously_adverbs,
steadfastly_adverbs,
nonpreciously_adverbs,
unsurely_adverbs,
girdlingly_adverbs,
quasirespectfully_adverbs,
fugato_adverbs,
inscriptively_adverbs,
leally_adverbs,
cosmonautically_adverbs,
undiatonically_adverbs,
nauseatingly_adverbs,
hyperlustrously_adverbs,
numerically_adverbs,
figuredly_adverbs,
stentoriously_adverbs,
inquiringly_adverbs,
boobily_adverbs,
uncondemningly_adverbs,
antiscientifically_adverbs,
unspectacularly_adverbs,
elaboratively_adverbs,
gleefully_adverbs,
unbumptiously_adverbs,
stereochromatically_adverbs,
electrometrically_adverbs,
rightaway_adverbs,
drearily_adverbs,
haply_adverbs,
unprecisely_adverbs,
overprosperously_adverbs,
contingently_adverbs,
unthroatily_adverbs,
overlushly_adverbs,
antimilitaristically_adverbs,
imperatorially_adverbs,
unanswerably_adverbs,
unfictitiously_adverbs,
accusatorially_adverbs,
comprehensively_adverbs,
acromial_adverbs,
nonzonally_adverbs,
pantheistically_adverbs,
fructuously_adverbs,
imploringly_adverbs,
architecturally_adverbs,
swaggeringly_adverbs,
pronouncedly_adverbs,
autonomically_adverbs,
tenurially_adverbs,
hyperprophetically_adverbs,
harpwise_adverbs,
unhostilely_adverbs,
aforetime_adverbs,
omnipotently_adverbs,
nonconjugally_adverbs,
corymbosely_adverbs,
quasicolloquially_adverbs,
blessingly_adverbs,
perpetually_adverbs,
unplacidly_adverbs,
quasifascinatingly_adverbs,
superelaborately_adverbs,
transcendentally_adverbs,
prodigiously_adverbs,
innerly_adverbs,
twohandedly_adverbs,
unrectangularly_adverbs,
noncompressively_adverbs,
rheumatoidally_adverbs,
cyclopedically_adverbs,
halfcivilly_adverbs,
unthreateningly_adverbs,
nonheroically_adverbs,
nonpresentably_adverbs,
ingratiatingly_adverbs,
unstormily_adverbs,
frenzily_adverbs,
interlinearly_adverbs,
unsignificantly_adverbs,
commonsensically_adverbs,
quasimorally_adverbs,
digestedly_adverbs,
goatishly_adverbs,
hearteningly_adverbs,
entrancingly_adverbs,
overcoyly_adverbs,
downfield_adverbs,
drinkably_adverbs,
editorially_adverbs,
undetractingly_adverbs,
legally_adverbs,
nonconfidently_adverbs,
unmischievously_adverbs,
unforgetfully_adverbs,
genteelly_adverbs,
soreheadedly_adverbs,
unauthentically_adverbs,
nonperilously_adverbs,
coltishly_adverbs,
tangly_adverbs,
improvingly_adverbs,
manneristically_adverbs,
compatibly_adverbs,
pluckily_adverbs,
nonglacially_adverbs,
superformidably_adverbs,
hideously_adverbs,
somewheres_adverbs,
crimsonly_adverbs,
misapprehensively_adverbs,
uneccentrically_adverbs,
confoundedly_adverbs,
speakably_adverbs,
unfoolishly_adverbs,
halfruefully_adverbs,
bottomlessly_adverbs,
unfirmly_adverbs,
unmonarchically_adverbs,
slackingly_adverbs,
heliotropically_adverbs,
unlitigiously_adverbs,
nonabsolutistically_adverbs,
inversely_adverbs,
noncreatively_adverbs,
infuriately_adverbs,
subproportionally_adverbs,
racemously_adverbs,
prefiguratively_adverbs,
quasidevotedly_adverbs,
inceptively_adverbs,
overfiercely_adverbs,
immoderately_adverbs,
nonconvivially_adverbs,
protectively_adverbs,
nonsocially_adverbs,
tattlingly_adverbs,
venously_adverbs,
rateably_adverbs,
intricately_adverbs,
quasispatially_adverbs,
cleverly_adverbs,
permissibly_adverbs,
unflirtatiously_adverbs,
startingly_adverbs,
noncognizantly_adverbs,
nonprudentially_adverbs,
mustily_adverbs,
unruinously_adverbs,
importantly_adverbs,
laxly_adverbs,
bardily_adverbs,
supercolossally_adverbs,
passim_adverbs,
greatheartedly_adverbs,
feudally_adverbs,
felinely_adverbs,
unvoluptuously_adverbs,
demonstrably_adverbs,
nonoriginally_adverbs,
hermetically_adverbs,
inspiredly_adverbs,
unbreachably_adverbs,
unhysterically_adverbs,
lobately_adverbs,
appreciatingly_adverbs,
quasigraciously_adverbs,
descriptively_adverbs,
altogether_adverbs,
insusceptibly_adverbs,
submaniacally_adverbs,
dialytically_adverbs,
boilingly_adverbs,
anticatalytically_adverbs,
nonactionably_adverbs,
inoffensively_adverbs,
snatchingly_adverbs,
intently_adverbs,
quasiangelically_adverbs,
unstrictly_adverbs,
ribaldly_adverbs,
dissonantly_adverbs,
anodically_adverbs,
overassumptively_adverbs,
emanatively_adverbs,
noncontinuously_adverbs,
incontrollably_adverbs,
nongeographically_adverbs,
undeficiently_adverbs,
unsavagely_adverbs,
outofbounds_adverbs,
meteorologically_adverbs,
unconfoundedly_adverbs,
jokingly_adverbs,
quantitatively_adverbs,
pseudobiologically_adverbs,
immovably_adverbs,
withershins_adverbs,
moonily_adverbs,
undiffidently_adverbs,
adaptively_adverbs,
formulaically_adverbs,
endlessly_adverbs,
uncircularly_adverbs,
dialogically_adverbs,
roundedly_adverbs,
surgically_adverbs,
unelastically_adverbs,
collinearly_adverbs,
uniniquitously_adverbs,
unboastfully_adverbs,
nonfloatingly_adverbs,
nondeferentially_adverbs,
teemingly_adverbs,
quasiseriously_adverbs,
equably_adverbs,
balmily_adverbs,
unpitiably_adverbs,
episodically_adverbs,
nondiplomatically_adverbs,
simplistically_adverbs,
nextdoor_adverbs,
magisterially_adverbs,
lubriciously_adverbs,
monomolecularly_adverbs,
courageously_adverbs,
uncircuitously_adverbs,
unlevelly_adverbs,
bumblingly_adverbs,
orientally_adverbs,
aport_adverbs,
superconfidently_adverbs,
quincuncially_adverbs,
expletively_adverbs,
dreamlessly_adverbs,
regrettably_adverbs,
unapplicably_adverbs,
frontwards_adverbs,
uninnately_adverbs,
gayly_adverbs,
lankily_adverbs,
tryingly_adverbs,
diametrally_adverbs,
nonterminatively_adverbs,
reputedly_adverbs,
undoubtfully_adverbs,
unsuspectingly_adverbs,
gruffly_adverbs,
mistrustfully_adverbs,
uncheerfully_adverbs,
auteciously_adverbs,
nonvocally_adverbs,
helpingly_adverbs,
Anglice_adverbs,
suborganically_adverbs,
enpassant_adverbs,
appliably_adverbs,
aboard_adverbs,
godlessly_adverbs,
longways_adverbs,
erosely_adverbs,
degressively_adverbs,
semirarely_adverbs,
ineffectively_adverbs,
unwrathfully_adverbs,
succinctly_adverbs,
heraldically_adverbs,
pseudophilanthropically_adverbs,
putatively_adverbs,
unprevalently_adverbs,
nonfrequently_adverbs,
inculpably_adverbs,
ineffaceably_adverbs,
contemptibly_adverbs,
frictionally_adverbs,
cloddishly_adverbs,
corporally_adverbs,
Adamically_adverbs,
unconvulsively_adverbs,
tinnily_adverbs,
fervidly_adverbs,
surroundedly_adverbs,
overpolitically_adverbs,
glisteningly_adverbs,
nonstatistically_adverbs,
conservatively_adverbs,
astronomically_adverbs,
exemplarily_adverbs,
overbulkily_adverbs,
quasiexpensively_adverbs,
unreceptively_adverbs,
impulsively_adverbs,
supersafely_adverbs,
halfintellectually_adverbs,
quasifully_adverbs,
acquiescingly_adverbs,
tenuously_adverbs,
Frenchly_adverbs,
hyperpolysyllabically_adverbs,
convincingly_adverbs,
evermore_adverbs,
semineurotically_adverbs,
nonsuppositively_adverbs,
tenderly_adverbs,
costively_adverbs,
dilatorily_adverbs,
overliterarily_adverbs,
retributively_adverbs,
freshly_adverbs,
anagrammatically_adverbs,
conspiratorially_adverbs,
nonconclusively_adverbs,
auditorily_adverbs,
bleatingly_adverbs,
chemotactically_adverbs,
hammeringly_adverbs,
shiftily_adverbs,
unilaterally_adverbs,
factually_adverbs,
ashore_adverbs,
nonnutritively_adverbs,
unsuperficially_adverbs,
undeferrably_adverbs,
antioptimistically_adverbs,
nonvirginally_adverbs,
streakily_adverbs,
noninterpretatively_adverbs,
nosily_adverbs,
unamicably_adverbs,
singleheartedly_adverbs,
tasselly_adverbs,
headforemost_adverbs,
supremely_adverbs,
afterward_adverbs,
unresolutely_adverbs,
nonspecifically_adverbs,
nonequatorially_adverbs,
anesthetically_adverbs,
underminingly_adverbs,
mourningly_adverbs,
unconservatively_adverbs,
superornamentally_adverbs,
digressively_adverbs,
fatly_adverbs,
snatchily_adverbs,
eschatologically_adverbs,
nights_adverbs,
slambang_adverbs,
animally_adverbs,
warmheartedly_adverbs,
overvigorously_adverbs,
antinationally_adverbs,
haggishly_adverbs,
nobbut_adverbs,
Hellenistically_adverbs,
implausibly_adverbs,
unfatalistically_adverbs,
inerasably_adverbs,
unartificially_adverbs,
superpiously_adverbs,
crassly_adverbs,
compositionally_adverbs,
quirkily_adverbs,
deformedly_adverbs,
overcoolly_adverbs,
frenziedly_adverbs,
brassily_adverbs,
longsufferingly_adverbs,
loculicidally_adverbs,
peacefully_adverbs,
positively_adverbs,
sterlingly_adverbs,
unsqueamishly_adverbs,
unhygienically_adverbs,
scholastically_adverbs,
invacuo_adverbs,
transiently_adverbs,
condemnably_adverbs,
nonpneumatically_adverbs,
selfconceitedly_adverbs,
overstrongly_adverbs,
abortively_adverbs,
unlugubriously_adverbs,
reformingly_adverbs,
supersensuously_adverbs,
superabundantly_adverbs,
presumptuously_adverbs,
inextenso_adverbs,
uninstructedly_adverbs,
loyally_adverbs,
unsincerely_adverbs,
meekly_adverbs,
successfully_adverbs,
subversively_adverbs,
Celtically_adverbs,
quasiequivalently_adverbs,
badgeringly_adverbs,
agly_adverbs,
unfervidly_adverbs,
continuingly_adverbs,
overhonestly_adverbs,
entitatively_adverbs,
subdistinctively_adverbs,
dadaistically_adverbs,
equivalently_adverbs,
impregnably_adverbs,
noninfallibly_adverbs,
behindhand_adverbs,
opinionatively_adverbs,
ruggedly_adverbs,
unsententiously_adverbs,
galvanometrically_adverbs,
nonspeciously_adverbs,
understandingly_adverbs,
psychophysiologically_adverbs,
tetchily_adverbs,
demonologically_adverbs,
overanalytically_adverbs,
nonhereditably_adverbs,
nonorthographically_adverbs,
unmercifully_adverbs,
hereinto_adverbs,
rumblingly_adverbs,
nongeometrically_adverbs,
lamentedly_adverbs,
undesirably_adverbs,
nonmaternally_adverbs,
regretfully_adverbs,
intramuscularly_adverbs,
cautiously_adverbs,
indissolubly_adverbs,
tegularly_adverbs,
adequately_adverbs,
noncurrently_adverbs,
nondisputatiously_adverbs,
monotheistically_adverbs,
unskilfully_adverbs,
nonreverently_adverbs,
unillustriously_adverbs,
undutifully_adverbs,
monopodially_adverbs,
captivatingly_adverbs,
dissemblingly_adverbs,
nonappreciatively_adverbs,
subrotundly_adverbs,
legibly_adverbs,
institutively_adverbs,
unfully_adverbs,
unentertainingly_adverbs,
halfearnestly_adverbs,
reactively_adverbs,
brawlis_adverbs,
contradictiously_adverbs,
unstatistically_adverbs,
chartographically_adverbs,
quasiexplicitly_adverbs,
heartbreakingly_adverbs,
unbanteringly_adverbs,
continually_adverbs,
nondialectally_adverbs,
soothingly_adverbs,
satisfactorily_adverbs,
semiprofanely_adverbs,
pseudoservilely_adverbs,
advancingly_adverbs,
effeminately_adverbs,
dissolvingly_adverbs,
blankly_adverbs,
maturely_adverbs,
depreciatively_adverbs,
predeficiently_adverbs,
unlegislatively_adverbs,
unpreclusively_adverbs,
unpresentably_adverbs,
vivaciously_adverbs,
nonpartially_adverbs,
orthopedically_adverbs,
nonconcentrically_adverbs,
unpoignantly_adverbs,
quasiintellectually_adverbs,
nonbureaucratically_adverbs,
aaerially_adverbs,
squeakingly_adverbs,
irrecoverably_adverbs,
harebrainedly_adverbs,
trippingly_adverbs,
legendarily_adverbs,
binately_adverbs,
reportedly_adverbs,
discomposedly_adverbs,
supersecretively_adverbs,
halfrebelliously_adverbs,
bountifully_adverbs,
clearsightedly_adverbs,
glaringly_adverbs,
caudally_adverbs,
trimly_adverbs,
unsadly_adverbs,
frankly_adverbs,
circularly_adverbs,
unpromptly_adverbs,
semiintellectually_adverbs,
gymnastically_adverbs,
overbounteously_adverbs,
syne_adverbs,
nonelastically_adverbs,
unfulgently_adverbs,
quasiexpediently_adverbs,
personably_adverbs,
annoyingly_adverbs,
conspiringly_adverbs,
steamily_adverbs,
unannoyingly_adverbs,
zoogeographically_adverbs,
unbewilderingly_adverbs,
concordantly_adverbs,
nonquantitatively_adverbs,
accountably_adverbs,
amphitheatrically_adverbs,
unsplendidly_adverbs,
Bristolfashion_adverbs,
quasinaturally_adverbs,
untensely_adverbs,
macaronically_adverbs,
ardently_adverbs,
equinely_adverbs,
navally_adverbs,
interpretably_adverbs,
injunctively_adverbs,
crispily_adverbs,
underzealously_adverbs,
anamnestically_adverbs,
nonBiblically_adverbs,
sedulously_adverbs,
quasifavorably_adverbs,
auricularly_adverbs,
unreproachably_adverbs,
electrodialitically_adverbs,
suspiciously_adverbs,
larkingly_adverbs,
unverdantly_adverbs,
jeeringly_adverbs,
superbenevolently_adverbs,
tumidly_adverbs,
preaccommodatingly_adverbs,
impressionably_adverbs,
unexplicitly_adverbs,
nondetractively_adverbs,
autogenetically_adverbs,
woozily_adverbs,
overcautiously_adverbs,
unpolitically_adverbs,
betweentimes_adverbs,
innately_adverbs,
adagissimo_adverbs,
overweakly_adverbs,
freakily_adverbs,
nonprolifically_adverbs,
unresponsibly_adverbs,
contemnibly_adverbs,
prissily_adverbs,
toutcourt_adverbs,
geometrically_adverbs,
fantasmagorically_adverbs,
palaeogeographically_adverbs,
halfcoaxingly_adverbs,
caenogenetically_adverbs,
someway_adverbs,
ovally_adverbs,
quasihumorously_adverbs,
transitorily_adverbs,
saltirewise_adverbs,
nakedly_adverbs,
parentally_adverbs,
insincerely_adverbs,
everlastingly_adverbs,
pi_adverbs,
oracularly_adverbs,
overcheaply_adverbs,
divertedly_adverbs,
coronally_adverbs,
dioicously_adverbs,
somedeal_adverbs,
chemically_adverbs,
antiegotistically_adverbs,
irresolutely_adverbs,
cleverishly_adverbs,
pseudocatholically_adverbs,
laryngoscopically_adverbs,
tragically_adverbs,
epileptically_adverbs,
theretofore_adverbs,
moonishly_adverbs,
unthievishly_adverbs,
braggartly_adverbs,
perthitically_adverbs,
halffictitiously_adverbs,
intellectualistically_adverbs,
unchronologically_adverbs,
hamperedly_adverbs,
tremulously_adverbs,
germanely_adverbs,
unlearnedly_adverbs,
superrespectably_adverbs,
overcensoriously_adverbs,
lightmindedly_adverbs,
Calvinistically_adverbs,
unreasonably_adverbs,
photoelectrically_adverbs,
pseudoassertively_adverbs,
uncumbrously_adverbs,
nonpermissibly_adverbs,
semijuridically_adverbs,
prespecifically_adverbs,
unproscriptively_adverbs,
nonabusively_adverbs,
rushingly_adverbs,
uncreditably_adverbs,
superinquisitively_adverbs,
then_adverbs,
circuitously_adverbs,
draughtily_adverbs,
humanly_adverbs,
projectingly_adverbs,
nonreciprocally_adverbs,
endermically_adverbs,
trinomially_adverbs,
hitchily_adverbs,
nonexactingly_adverbs,
contrariwise_adverbs,
overserenely_adverbs,
cursorily_adverbs,
biblically_adverbs,
syndetically_adverbs,
heliacally_adverbs,
unludicrously_adverbs,
anxiously_adverbs,
absorbingly_adverbs,
seventhly_adverbs,
predelinquently_adverbs,
antiministerially_adverbs,
unanimously_adverbs,
nonexperientially_adverbs,
prewillingly_adverbs,
failingly_adverbs,
amatively_adverbs,
frugally_adverbs,
closely_adverbs,
unlibellously_adverbs,
hastily_adverbs,
incorrectly_adverbs,
parsimoniously_adverbs,
unselfconsciously_adverbs,
consumingly_adverbs,
contiguously_adverbs,
prediligently_adverbs,
anemographically_adverbs,
musingly_adverbs,
edictally_adverbs,
deftly_adverbs,
inaptly_adverbs,
vulgarly_adverbs,
recently_adverbs,
unlustfully_adverbs,
mannishly_adverbs,
amitotically_adverbs,
supplely_adverbs,
speechlessly_adverbs,
superincumbently_adverbs,
unministerially_adverbs,
rightmindedly_adverbs,
quasiautomatically_adverbs,
semiarticulately_adverbs,
facetoface_adverbs,
nonprimitively_adverbs,
wholeheartedly_adverbs,
anytime_adverbs,
overtenderly_adverbs,
epochally_adverbs,
humorously_adverbs,
unpolemically_adverbs,
wrongheadedly_adverbs,
epidemiologically_adverbs,
unignominiously_adverbs,
rancorously_adverbs,
sumptuously_adverbs,
undelectably_adverbs,
intrudingly_adverbs,
kindlessly_adverbs,
bitterly_adverbs,
fetidly_adverbs,
superexcrescently_adverbs,
orally_adverbs,
unspatially_adverbs,
uniridescently_adverbs,
edgingly_adverbs,
discoverably_adverbs,
inerrable_adverbs,
enrapturedly_adverbs,
hebdomadally_adverbs,
potently_adverbs,
akimbo_adverbs,
dandiacally_adverbs,
dishearteningly_adverbs,
unarticulately_adverbs,
antiegoistically_adverbs,
centennially_adverbs,
paretically_adverbs,
additionally_adverbs,
nonreasonably_adverbs,
stockstill_adverbs,
stonyheartedly_adverbs,
altruistically_adverbs,
uncoincidentally_adverbs,
unsmokily_adverbs,
unmistakably_adverbs,
quietly_adverbs,
doggedly_adverbs,
indulgently_adverbs,
unaesthetically_adverbs,
linguistically_adverbs,
cornerwise_adverbs,
uncially_adverbs,
ipsojure_adverbs,
nonportentously_adverbs,
tinglingly_adverbs,
subterraneously_adverbs,
noninstinctively_adverbs,
gladsomely_adverbs,
nonvenomously_adverbs,
unapologetically_adverbs,
unappeasingly_adverbs,
concerningly_adverbs,
predoubtfully_adverbs,
ruminantly_adverbs,
bluntly_adverbs,
megaphonically_adverbs,
decennially_adverbs,
scintillantly_adverbs,
astringently_adverbs,
anthropologically_adverbs,
calcareously_adverbs,
nontemperately_adverbs,
adinfinitum_adverbs,
semipoisonously_adverbs,
nonadjectively_adverbs,
unjudicially_adverbs,
revoltingly_adverbs,
springingly_adverbs,
subperiosteally_adverbs,
bovinely_adverbs,
overtenaciously_adverbs,
unpolitely_adverbs,
progressionally_adverbs,
accusatively_adverbs,
overcontentedly_adverbs,
inutilely_adverbs,
definably_adverbs,
valorously_adverbs,
mindlessly_adverbs,
boldly_adverbs,
unplatitudinously_adverbs,
unnaovely_adverbs,
inadvisably_adverbs,
semiconically_adverbs,
oft_adverbs,
nonhabitually_adverbs,
talismanically_adverbs,
terminally_adverbs,
poignantly_adverbs,
dismally_adverbs,
overcourteously_adverbs,
antischolastically_adverbs,
wrongly_adverbs,
adorably_adverbs,
supportably_adverbs,
overmoralizingly_adverbs,
undelinquently_adverbs,
caressingly_adverbs,
savourily_adverbs,
inhumanly_adverbs,
winningly_adverbs,
pertly_adverbs,
sodomitically_adverbs,
indevoutly_adverbs,
quasibrotherly_adverbs,
overderisively_adverbs,
vacantly_adverbs,
unsectionally_adverbs,
nongenetically_adverbs,
disquietingly_adverbs,
bracingly_adverbs,
nonnervously_adverbs,
pachydermatously_adverbs,
unintendedly_adverbs,
overidolatrously_adverbs,
nonspectacularly_adverbs,
preorganically_adverbs,
substantivally_adverbs,
overdesirously_adverbs,
closefistedly_adverbs,
delusively_adverbs,
atmospherically_adverbs,
palindromically_adverbs,
devicefully_adverbs,
viviparously_adverbs,
backlins_adverbs,
uncallously_adverbs,
unimmanently_adverbs,
dynamically_adverbs,
habitally_adverbs,
unsegmentally_adverbs,
synchronistically_adverbs,
corrosively_adverbs,
loudly_adverbs,
fanatically_adverbs,
semiallegorically_adverbs,
inwards_adverbs,
unplenteously_adverbs,
interestedly_adverbs,
quasiexactly_adverbs,
unseparably_adverbs,
quasiendlessly_adverbs,
benumbingly_adverbs,
cacophonously_adverbs,
treasonously_adverbs,
bewilderingly_adverbs,
nonseriously_adverbs,
philatelically_adverbs,
mercilessly_adverbs,
classily_adverbs,
nongratifyingly_adverbs,
cytogenetically_adverbs,
nonpuerilely_adverbs,
gey_adverbs,
evangelically_adverbs,
intervocalically_adverbs,
quasiprivately_adverbs,
unmasterfully_adverbs,
holily_adverbs,
decretively_adverbs,
colonially_adverbs,
boundlessly_adverbs,
coldly_adverbs,
unvitally_adverbs,
Platonically_adverbs,
undefeatably_adverbs,
superelastically_adverbs,
semicolonially_adverbs,
myriadly_adverbs,
hypergenetically_adverbs,
flamingly_adverbs,
controversially_adverbs,
nonnegligibly_adverbs,
ineptly_adverbs,
subadministratively_adverbs,
intertwistingly_adverbs,
quasipreferentially_adverbs,
snippily_adverbs,
quasimysteriously_adverbs,
onesidedly_adverbs,
headlong_adverbs,
nonecliptically_adverbs,
nonintuitively_adverbs,
nonmalignantly_adverbs,
unexcursively_adverbs,
unmaudlinly_adverbs,
unexpansively_adverbs,
superstrenuously_adverbs,
groundably_adverbs,
noncoherently_adverbs,
interconvertibly_adverbs,
nonmenially_adverbs,
overpuissantly_adverbs,
semasiologically_adverbs,
soothly_adverbs,
undubitatively_adverbs,
lengthwise_adverbs,
trashily_adverbs,
unblenchingly_adverbs,
creepingly_adverbs,
photogenically_adverbs,
credently_adverbs,
nonprovincially_adverbs,
scaringly_adverbs,
gluttingly_adverbs,
unamusingly_adverbs,
japingly_adverbs,
idyllically_adverbs,
competitively_adverbs,
quasicheerfully_adverbs,
untranscendentally_adverbs,
graveward_adverbs,
thematically_adverbs,
hyperemotively_adverbs,
panoramically_adverbs,
pseudoorientally_adverbs,
subarticulately_adverbs,
inanely_adverbs,
dramaturgically_adverbs,
quasijocosely_adverbs,
Pantagruelically_adverbs,
contextually_adverbs,
nonprosaically_adverbs,
quasidangerously_adverbs,
unremuneratively_adverbs,
dissatisfiedly_adverbs,
hyperfunctionally_adverbs,
quasiindifferently_adverbs,
jovially_adverbs,
sinlessly_adverbs,
stereochemically_adverbs,
unnationally_adverbs,
overparticularly_adverbs,
overvaluably_adverbs,
unmellifluously_adverbs,
redfacedly_adverbs,
irreparably_adverbs,
favoredly_adverbs,
semiluminously_adverbs,
lollingly_adverbs,
nonspaciously_adverbs,
harmoniously_adverbs,
chronometrically_adverbs,
unenergetically_adverbs,
unalluringly_adverbs,
Jewishly_adverbs,
unjustly_adverbs,
heritably_adverbs,
abusively_adverbs,
undiversely_adverbs,
syllabically_adverbs,
cabalistically_adverbs,
unsharply_adverbs,
premusically_adverbs,
unvulgarly_adverbs,
unintermediately_adverbs,
magnificently_adverbs,
atop_adverbs,
veneratively_adverbs,
noneccentrically_adverbs,
unmeditatively_adverbs,
askance_adverbs,
pseudocompetitively_adverbs,
superinnocently_adverbs,
nondangerously_adverbs,
assumably_adverbs,
illhumouredly_adverbs,
hecticly_adverbs,
feckly_adverbs,
duly_adverbs,
mildly_adverbs,
myelographically_adverbs,
superseverely_adverbs,
superarduously_adverbs,
uninterestedly_adverbs,
unaristocratically_adverbs,
disloyally_adverbs,
dualistically_adverbs,
eastsoutheastward_adverbs,
arrestingly_adverbs,
intravenously_adverbs,
massively_adverbs,
climatically_adverbs,
unprudentially_adverbs,
overtightly_adverbs,
logily_adverbs,
cloudlessly_adverbs,
unisexually_adverbs,
alphabetically_adverbs,
nonpliably_adverbs,
patentably_adverbs,
subjudicially_adverbs,
unguidedly_adverbs,
unadroitly_adverbs,
diligently_adverbs,
unforwardly_adverbs,
reservedly_adverbs,
luculently_adverbs,
totemically_adverbs,
nonjuristically_adverbs,
illnaturedly_adverbs,
incommensurably_adverbs,
certifiably_adverbs,
nonferociously_adverbs,
unjuridically_adverbs,
nonexponentially_adverbs,
unpeevishly_adverbs,
precociously_adverbs,
overenthusiastically_adverbs,
runtishly_adverbs,
nonresonantly_adverbs,
convertibly_adverbs,
smallmindedly_adverbs,
abstractively_adverbs,
conflictingly_adverbs,
observedly_adverbs,
unmeasurably_adverbs,
superhumanly_adverbs,
hyperethically_adverbs,
unmeaningly_adverbs,
unfilially_adverbs,
notelessly_adverbs,
nonpsychically_adverbs,
disgustedly_adverbs,
uncoquettishly_adverbs,
quasimadly_adverbs,
unyieldingly_adverbs,
evenly_adverbs,
suturally_adverbs,
nondistractingly_adverbs,
uninhibitedly_adverbs,
gerundially_adverbs,
grandiloquently_adverbs,
slubberingly_adverbs,
quasibasically_adverbs,
unerringly_adverbs,
hallowedly_adverbs,
advisedly_adverbs,
scrubbily_adverbs,
musically_adverbs,
grazingly_adverbs,
headlongwise_adverbs,
unsurprisingly_adverbs,
expectantly_adverbs,
extensionally_adverbs,
preessentially_adverbs,
caressively_adverbs,
floridly_adverbs,
buzzingly_adverbs,
overliberally_adverbs,
preaggressively_adverbs,
exceptively_adverbs,
covetingly_adverbs,
levelly_adverbs,
floutingly_adverbs,
homogonously_adverbs,
upspringing_adverbs,
nonmimetically_adverbs,
howlingly_adverbs,
nonsubliminally_adverbs,
multilaterally_adverbs,
ropily_adverbs,
ideationally_adverbs,
Jacobitishly_adverbs,
semimystically_adverbs,
timidly_adverbs,
entanglingly_adverbs,
untraitorously_adverbs,
superadequately_adverbs,
nondisingenuously_adverbs,
getetout_adverbs,
foundationally_adverbs,
superinclusively_adverbs,
fantastically_adverbs,
writhingly_adverbs,
unexcusedly_adverbs,
nonparentally_adverbs,
generously_adverbs,
parasitically_adverbs,
pudgily_adverbs,
perseveringly_adverbs,
unvoraciously_adverbs,
zanily_adverbs,
nonnasally_adverbs,
creatively_adverbs,
nonhypnotically_adverbs,
afloat_adverbs,
rippingly_adverbs,
gutsily_adverbs,
facetely_adverbs,
duodecimally_adverbs,
unextravagantly_adverbs,
segmentally_adverbs,
justifiably_adverbs,
chopchop_adverbs,
warily_adverbs,
illegally_adverbs,
nonprogressively_adverbs,
becomingly_adverbs,
figuratively_adverbs,
halfheartedly_adverbs,
serologically_adverbs,
otherwhile_adverbs,
unexceptionally_adverbs,
unjuicily_adverbs,
crookedly_adverbs,
dorsoventrally_adverbs,
unclerically_adverbs,
bathymetrically_adverbs,
viscously_adverbs,
superocularly_adverbs,
unacceptably_adverbs,
unexcrescently_adverbs,
ogreishly_adverbs,
catechetically_adverbs,
Machiavellianly_adverbs,
memoriter_adverbs,
compassionately_adverbs,
perceptually_adverbs,
quasidisgustedly_adverbs,
neatly_adverbs,
irately_adverbs,
enplein_adverbs,
cosmopolitanly_adverbs,
supportlessly_adverbs,
incomprehensively_adverbs,
overemotionally_adverbs,
sorely_adverbs,
semiinstinctively_adverbs,
superlocally_adverbs,
thus_adverbs,
quasimiraculously_adverbs,
metallically_adverbs,
unventurously_adverbs,
callously_adverbs,
snubbingly_adverbs,
meritedly_adverbs,
superbenignly_adverbs,
fierily_adverbs,
postpaid_adverbs,
ungaudily_adverbs,
tidily_adverbs,
criminologically_adverbs,
foxily_adverbs,
unavengingly_adverbs,
aportoise_adverbs,
triply_adverbs,
unlimitedly_adverbs,
prophetically_adverbs,
depravedly_adverbs,
ungallantly_adverbs,
reflexly_adverbs,
semiblasphemously_adverbs,
oafishly_adverbs,
quasiheroically_adverbs,
nonpredatorily_adverbs,
cytologically_adverbs,
capitally_adverbs,
unevangelically_adverbs,
irruptively_adverbs,
nonamorously_adverbs,
leanly_adverbs,
drably_adverbs,
unreverentially_adverbs,
assertorily_adverbs,
ochlocratically_adverbs,
unscenically_adverbs,
iridescently_adverbs,
fretfully_adverbs,
dramatically_adverbs,
spousally_adverbs,
sanguinely_adverbs,
ravishingly_adverbs,
deploringly_adverbs,
undescriptively_adverbs,
inerrantly_adverbs,
somewise_adverbs,
sententially_adverbs,
drivelingly_adverbs,
killingly_adverbs,
anticlimactically_adverbs,
unhumiliatingly_adverbs,
unaccidentally_adverbs,
restrictively_adverbs,
articulately_adverbs,
vocally_adverbs,
crossly_adverbs,
preelectrically_adverbs,
unferociously_adverbs,
betimes_adverbs,
unorthographically_adverbs,
overcrowdedly_adverbs,
retrorsely_adverbs,
percussively_adverbs,
viscidly_adverbs,
troublously_adverbs,
uproariously_adverbs,
conclusionally_adverbs,
narrowly_adverbs,
nonerroneously_adverbs,
suppletorily_adverbs,
frostily_adverbs,
nonmagnetically_adverbs,
blusteringly_adverbs,
unprofoundly_adverbs,
unrepulsively_adverbs,
nonexperimentally_adverbs,
dutifully_adverbs,
livingly_adverbs,
distichously_adverbs,
nonesthetically_adverbs,
posingly_adverbs,
militantly_adverbs,
percent_adverbs,
insidiously_adverbs,
earthwards_adverbs,
handily_adverbs,
oversubtly_adverbs,
superlaryngeally_adverbs,
busily_adverbs,
semirigorously_adverbs,
penitently_adverbs,
lumberingly_adverbs,
jejunely_adverbs,
nontaxonomically_adverbs,
uncommunicatively_adverbs,
maliciously_adverbs,
regrettingly_adverbs,
insomnolently_adverbs,
ironhandedly_adverbs,
unspiritedly_adverbs,
unusefully_adverbs,
backwards_adverbs,
forwards_adverbs,
unexigently_adverbs,
flawlessly_adverbs,
unintellectually_adverbs,
triweekly_adverbs,
partitively_adverbs,
adhesively_adverbs,
unonerously_adverbs,
unendurably_adverbs,
spottedly_adverbs,
unpenuriously_adverbs,
ineffectually_adverbs,
impenitently_adverbs,
unwishfully_adverbs,
nondefectively_adverbs,
excitingly_adverbs,
decimally_adverbs,
uninterruptedly_adverbs,
insubordinately_adverbs,
sanctifiably_adverbs,
uninstructively_adverbs,
overchildishly_adverbs,
unorthodoxly_adverbs,
interestingly_adverbs,
flaringly_adverbs,
unmodishly_adverbs,
semihysterically_adverbs,
superheroically_adverbs,
halfsightedly_adverbs,
languidly_adverbs,
subacademically_adverbs,
semitraditionally_adverbs,
uninterrogatively_adverbs,
supernaturally_adverbs,
rightdown_adverbs,
unprintably_adverbs,
contrapuntally_adverbs,
quasimusically_adverbs,
materially_adverbs,
necrologically_adverbs,
sanitarily_adverbs,
unconflictingly_adverbs,
quasiconnectively_adverbs,
dynamitically_adverbs,
coaxingly_adverbs,
biserially_adverbs,
teknonymously_adverbs,
unfunnily_adverbs,
mimically_adverbs,
nonapostolically_adverbs,
phrenetically_adverbs,
unspeciously_adverbs,
captiously_adverbs,
vociferously_adverbs,
unauthoritatively_adverbs,
unoffensively_adverbs,
guilefully_adverbs,
uneffusively_adverbs,
frighteningly_adverbs,
uninspiringly_adverbs,
unmeasuredly_adverbs,
unaskingly_adverbs,
ungradually_adverbs,
incorruptibly_adverbs,
edgeways_adverbs,
commercially_adverbs,
halfradically_adverbs,
thrasonically_adverbs,
conqueringly_adverbs,
unaffably_adverbs,
undisconnectedly_adverbs,
doublefacedly_adverbs,
inexcusably_adverbs,
exceptionally_adverbs,
reekingly_adverbs,
barely_adverbs,
noninclusively_adverbs,
prohibitorily_adverbs,
unprejudicially_adverbs,
hyperexcursively_adverbs,
stagnantly_adverbs,
touchingly_adverbs,
speedfully_adverbs,
forth_adverbs,
seminormally_adverbs,
disappointedly_adverbs,
overflowingly_adverbs,
lurchingly_adverbs,
Paulinistically_adverbs,
taperingly_adverbs,
distractively_adverbs,
sociologistically_adverbs,
hackingly_adverbs,
bimanually_adverbs,
compellably_adverbs,
excusingly_adverbs,
unlawfully_adverbs,
eventually_adverbs,
unequivalently_adverbs,
electrophysiologically_adverbs,
anticly_adverbs,
insensately_adverbs,
nonevolutionally_adverbs,
weightedly_adverbs,
botchily_adverbs,
lamentingly_adverbs,
discommodiously_adverbs,
objurgatorily_adverbs,
fullsail_adverbs,
numismatically_adverbs,
forethoughtfully_adverbs,
inexorably_adverbs,
hereafter_adverbs,
neologically_adverbs,
unthickly_adverbs,
unturgidly_adverbs,
unbrazenly_adverbs,
unpersuasively_adverbs,
ichnographically_adverbs,
fittingly_adverbs,
simoniacally_adverbs,
familiarisingly_adverbs,
deliciously_adverbs,
gloweringly_adverbs,
unvaluably_adverbs,
interjectorily_adverbs,
unregretfully_adverbs,
calmly_adverbs,
quibblingly_adverbs,
subexternally_adverbs,
semireflexively_adverbs,
grimily_adverbs,
supercynically_adverbs,
unostensively_adverbs,
nonpractically_adverbs,
uninvincibly_adverbs,
suppositively_adverbs,
monetarily_adverbs,
openeyedly_adverbs,
effectively_adverbs,
overslowly_adverbs,
overdearly_adverbs,
superfinitely_adverbs,
nonprofessorially_adverbs,
lushly_adverbs,
wofully_adverbs,
applicably_adverbs,
quarrelingly_adverbs,
flavourfully_adverbs,
superlaboriously_adverbs,
evidently_adverbs,
accursedly_adverbs,
unbureaucratically_adverbs,
subventrally_adverbs,
quasitragically_adverbs,
largely_adverbs,
maniacally_adverbs,
nonsacrilegiously_adverbs,
nonsuggestively_adverbs,
dinkly_adverbs,
untributarily_adverbs,
reflexively_adverbs,
demographically_adverbs,
unsanctimoniously_adverbs,
nonskeletally_adverbs,
atlantad_adverbs,
eudemonistically_adverbs,
noncensurably_adverbs,
dejectedly_adverbs,
superurgently_adverbs,
innocently_adverbs,
antireligiously_adverbs,
dialogistically_adverbs,
vixenishly_adverbs,
hyperpathetically_adverbs,
counterattractively_adverbs,
interacademically_adverbs,
ambitionlessly_adverbs,
prohibitively_adverbs,
perdiem_adverbs,
irritably_adverbs,
secularly_adverbs,
insociably_adverbs,
bonnily_adverbs,
meretriciously_adverbs,
unintuitively_adverbs,
halfinsinuatingly_adverbs,
bounteously_adverbs,
sinedie_adverbs,
unmiraculously_adverbs,
affectionately_adverbs,
incredulously_adverbs,
halfsuccessfully_adverbs,
unpiratically_adverbs,
pseudoinvalidly_adverbs,
waspily_adverbs,
urgingly_adverbs,
daintily_adverbs,
marvelously_adverbs,
colossally_adverbs,
irreproachably_adverbs,
mutagenically_adverbs,
phantasmagorically_adverbs,
intrepidly_adverbs,
perinde_adverbs,
speedingly_adverbs,
stalagmitically_adverbs,
educationally_adverbs,
savagely_adverbs,
preoriginally_adverbs,
unpliantly_adverbs,
nary_adverbs,
sanguinarily_adverbs,
trustlessly_adverbs,
nonrebelliously_adverbs,
uncorrectablely_adverbs,
overhaughtily_adverbs,
oversteadfastly_adverbs,
pseudosemantically_adverbs,
unbrokenly_adverbs,
awakeningly_adverbs,
lighthandedly_adverbs,
nonmeteorologically_adverbs,
unbarrenly_adverbs,
monistically_adverbs,
enf_adverbs,
urinative_adverbs,
nattily_adverbs,
long_adverbs,
supertranscendently_adverbs,
seminomadically_adverbs,
noneditorially_adverbs,
daccord_adverbs,
distrustfully_adverbs,
affirmatively_adverbs,
topically_adverbs,
comfortably_adverbs,
overcovetously_adverbs,
ligamentously_adverbs,
snugly_adverbs,
regeneratively_adverbs,
quite_adverbs,
nonviviparously_adverbs,
foamingly_adverbs,
unrudely_adverbs,
designedly_adverbs,
gyroidally_adverbs,
directively_adverbs,
deucedly_adverbs,
convenably_adverbs,
subpellucidly_adverbs,
misapprehendingly_adverbs,
dwarfishly_adverbs,
quasiinfinitely_adverbs,
quasifamously_adverbs,
unmorosely_adverbs,
illadvisedly_adverbs,
nonSabbatically_adverbs,
phenotypically_adverbs,
quasipatriotically_adverbs,
ductilely_adverbs,
ever_adverbs,
mythically_adverbs,
statically_adverbs,
unconstructively_adverbs,
equidistantly_adverbs,
nonrandomly_adverbs,
unsynonymously_adverbs,
quasicritically_adverbs,
intersystematically_adverbs,
prebarbarously_adverbs,
uglily_adverbs,
nonmedicinally_adverbs,
unsneeringly_adverbs,
pressingly_adverbs,
seawards_adverbs,
microbiologically_adverbs,
fancifully_adverbs,
nonprovidently_adverbs,
thermochemically_adverbs,
skillfully_adverbs,
obnoxiously_adverbs,
unstrenuously_adverbs,
incorporeally_adverbs,
untautologically_adverbs,
nonhistorically_adverbs,
overconservatively_adverbs,
unapprovably_adverbs,
semiclinically_adverbs,
nonornamentally_adverbs,
choregraphically_adverbs,
refulgently_adverbs,
unparenthetically_adverbs,
nicely_adverbs,
entirely_adverbs,
unpictorially_adverbs,
unsluggishly_adverbs,
unpestilently_adverbs,
therefrom_adverbs,
unsaleably_adverbs,
hydrostatically_adverbs,
pharmaceutically_adverbs,
subduingly_adverbs,
ambiguously_adverbs,
unempirically_adverbs,
cheatingly_adverbs,
unhelpfully_adverbs,
bigheartedly_adverbs,
proportionately_adverbs,
reasonably_adverbs,
subnutritiously_adverbs,
unpsychically_adverbs,
lousily_adverbs,
subaudibly_adverbs,
uncrossly_adverbs,
unascetically_adverbs,
dishonourably_adverbs,
superpositively_adverbs,
pseudoprincely_adverbs,
thoroughgoingly_adverbs,
cognizably_adverbs,
dendrochronologically_adverbs,
undifficultly_adverbs,
probably_adverbs,
nontransitionally_adverbs,
ineluctably_adverbs,
catechumenically_adverbs,
overnarrowly_adverbs,
duncishly_adverbs,
superindustriously_adverbs,
unthriftily_adverbs,
inauspiciously_adverbs,
secantly_adverbs,
cyclically_adverbs,
elatedly_adverbs,
gastronomically_adverbs,
antiempirically_adverbs,
reductively_adverbs,
quasireligiously_adverbs,
collarco_adverbs,
uninfectiously_adverbs,
assentingly_adverbs,
contrastedly_adverbs,
isagogically_adverbs,
uncautiously_adverbs,
invulnerably_adverbs,
implacably_adverbs,
tastefully_adverbs,
othergates_adverbs,
noncredibly_adverbs,
allowably_adverbs,
intermittently_adverbs,
unnomadically_adverbs,
overdeliberately_adverbs,
blandly_adverbs,
superzealously_adverbs,
quadrennially_adverbs,
superthankfully_adverbs,
antimechanistically_adverbs,
stingingly_adverbs,
unadjacently_adverbs,
untransitorily_adverbs,
crapulously_adverbs,
unfanatically_adverbs,
songfully_adverbs,
dissentiently_adverbs,
scabrously_adverbs,
wolfishly_adverbs,
iwis_adverbs,
irenically_adverbs,
southwestwards_adverbs,
futilely_adverbs,
overelegantly_adverbs,
cordately_adverbs,
municipally_adverbs,
anthropomorphously_adverbs,
unpersuadably_adverbs,
prefearfully_adverbs,
multiplicatively_adverbs,
vividly_adverbs,
uncontrastively_adverbs,
ungraciously_adverbs,
nonethically_adverbs,
namely_adverbs,
despotically_adverbs,
unspitefully_adverbs,
uncondescendingly_adverbs,
unsaliently_adverbs,
excusively_adverbs,
sequentially_adverbs,
itchingly_adverbs,
coolly_adverbs,
overcarefully_adverbs,
nonceremoniously_adverbs,
vectorially_adverbs,
unfeloniously_adverbs,
admonishingly_adverbs,
perturbingly_adverbs,
appreciatorily_adverbs,
atwain_adverbs,
unvirulently_adverbs,
dryly_adverbs,
unrestrictedly_adverbs,
unblinkingly_adverbs,
driftingly_adverbs,
unsufferably_adverbs,
harbourside_adverbs,
nonstoically_adverbs,
alternatively_adverbs,
semidomestically_adverbs,
unhomogeneously_adverbs,
unmathematically_adverbs,
selfsustainingly_adverbs,
derisively_adverbs,
preeditorially_adverbs,
nonnautically_adverbs,
doubtingly_adverbs,
fumblingly_adverbs,
inhumanely_adverbs,
nonassertively_adverbs,
noncharitably_adverbs,
subimbricately_adverbs,
overeffusively_adverbs,
unscandalously_adverbs,
bioecologically_adverbs,
universally_adverbs,
overlewdly_adverbs,
backoBourke_adverbs,
nonusuriously_adverbs,
axiomatically_adverbs,
acrobatically_adverbs,
incogitantly_adverbs,
hermeneutically_adverbs,
abysmally_adverbs,
quasivalidly_adverbs,
embryologically_adverbs,
undomestically_adverbs,
hymeneally_adverbs,
noncorruptly_adverbs,
spurtively_adverbs,
halfwhisperingly_adverbs,
contraorbitally_adverbs,
subito_adverbs,
settledly_adverbs,
mutationally_adverbs,
mysteriously_adverbs,
overindividualistically_adverbs,
inflammably_adverbs,
nonsynodically_adverbs,
crisply_adverbs,
hylozoistically_adverbs,
jestingly_adverbs,
flatwise_adverbs,
feasibly_adverbs,
inurbanely_adverbs,
uncontradictablely_adverbs,
nonadvantageously_adverbs,
enforcedly_adverbs,
nondeceptively_adverbs,
exothermally_adverbs,
analogously_adverbs,
stoppably_adverbs,
sensibly_adverbs,
uncriticisably_adverbs,
unepigrammatically_adverbs,
attributively_adverbs,
unblissfully_adverbs,
untastily_adverbs,
semiadhesively_adverbs,
summarily_adverbs,
eminently_adverbs,
filthily_adverbs,
nonmonarchally_adverbs,
deafly_adverbs,
bifilarly_adverbs,
nonsportingly_adverbs,
unmorbidly_adverbs,
semitheologically_adverbs,
unsepulchrally_adverbs,
overfrailly_adverbs,
mediad_adverbs,
unluxuriantly_adverbs,
leastways_adverbs,
unintentionally_adverbs,
illfavouredly_adverbs,
aplenty_adverbs,
pleadingly_adverbs,
quasiformidably_adverbs,
quasicarefully_adverbs,
unstudiously_adverbs,
nonindependently_adverbs,
unrapturously_adverbs,
unsimultaneously_adverbs,
ethnographically_adverbs,
coldbloodedly_adverbs,
Thursdays_adverbs,
nonaxiomatically_adverbs,
grumblingly_adverbs,
unflickeringly_adverbs,
smartingly_adverbs,
melodically_adverbs,
pityingly_adverbs,
unspaciously_adverbs,
uncoloredly_adverbs,
sooner_adverbs,
seminasally_adverbs,
nonburdensomely_adverbs,
unopprobriously_adverbs,
joltingly_adverbs,
arrhythmically_adverbs,
wackily_adverbs,
gnomically_adverbs,
slothfully_adverbs,
semicynically_adverbs,
distributively_adverbs,
dully_adverbs,
gaudily_adverbs,
sometime_adverbs,
etymologically_adverbs,
quasigenuinely_adverbs,
luetically_adverbs,
yonder_adverbs,
thickwittedly_adverbs,
caselessly_adverbs,
authoritatively_adverbs,
apostolically_adverbs,
discreditably_adverbs,
angulately_adverbs,
inventorially_adverbs,
nefariously_adverbs,
invectively_adverbs,
preadjectivally_adverbs,
gullibly_adverbs,
extroversively_adverbs,
inadequately_adverbs,
campanologically_adverbs,
quasimethodically_adverbs,
illustriously_adverbs,
unallayably_adverbs,
congenially_adverbs,
inaccurately_adverbs,
nonpungently_adverbs,
quasicivilly_adverbs,
pallidly_adverbs,
preveniently_adverbs,
indictably_adverbs,
inchmeal_adverbs,
unindicatively_adverbs,
unproudly_adverbs,
dextrously_adverbs,
Fridays_adverbs,
presently_adverbs,
herbaceously_adverbs,
malignly_adverbs,
overaffirmatively_adverbs,
hotheadedly_adverbs,
homophonically_adverbs,
nonratably_adverbs,
unexclusively_adverbs,
faintheartedly_adverbs,
overmilitaristically_adverbs,
unsulkily_adverbs,
seedily_adverbs,
nonsystematically_adverbs,
propitiously_adverbs,
pseudoarticulately_adverbs,
aeronautically_adverbs,
nonnaturally_adverbs,
imperialistically_adverbs,
preprudently_adverbs,
retractively_adverbs,
antiphonally_adverbs,
gelatinously_adverbs,
lustfully_adverbs,
constrainingly_adverbs,
ideographically_adverbs,
unerrantly_adverbs,
malignantly_adverbs,
pestilentially_adverbs,
imposingly_adverbs,
aspiringly_adverbs,
mistakably_adverbs,
serially_adverbs,
quasimanagerially_adverbs,
applaudably_adverbs,
eruditely_adverbs,
unsinisterly_adverbs,
equiprobably_adverbs,
unobscenely_adverbs,
quasipoorly_adverbs,
journalistically_adverbs,
rather_adverbs,
stoicheiometrically_adverbs,
atweel_adverbs,
dithyrambically_adverbs,
uncooperatively_adverbs,
tearfully_adverbs,
enprise_adverbs,
mitotically_adverbs,
unmedicinally_adverbs,
halfwildly_adverbs,
awheel_adverbs,
archaeologically_adverbs,
upwardly_adverbs,
despicably_adverbs,
nonconnubially_adverbs,
unturbidly_adverbs,
alphanumerically_adverbs,
scrofulously_adverbs,
denticulately_adverbs,
raggedly_adverbs,
apsidally_adverbs,
unconsolingly_adverbs,
deprecatively_adverbs,
binomially_adverbs,
uncubically_adverbs,
orinasally_adverbs,
unrubrically_adverbs,
quasimodestly_adverbs,
ripely_adverbs,
overassertively_adverbs,
tubularly_adverbs,
overearnestly_adverbs,
superambitiously_adverbs,
pseudoethically_adverbs,
radiably_adverbs,
feloniously_adverbs,
presystematically_adverbs,
dynastically_adverbs,
overpopularly_adverbs,
quasityrannically_adverbs,
nonstudiously_adverbs,
impressionistically_adverbs,
antipestilently_adverbs,
antirachitically_adverbs,
flowerily_adverbs,
ablock_adverbs,
insolently_adverbs,
honourably_adverbs,
halfreasonably_adverbs,
informatively_adverbs,
waspishly_adverbs,
unmanually_adverbs,
snarlingly_adverbs,
quasieternally_adverbs,
encephalographically_adverbs,
gamily_adverbs,
pseudoambidextrously_adverbs,
nonphilosophically_adverbs,
puffingly_adverbs,
abstractly_adverbs,
preparedly_adverbs,
flabbily_adverbs,
quasiromantically_adverbs,
whiles_adverbs,
foully_adverbs,
ludicrously_adverbs,
destitutely_adverbs,
nonequitably_adverbs,
nontraceably_adverbs,
nonlogically_adverbs,
pitiably_adverbs,
corruptibly_adverbs,
unhumbly_adverbs,
uncontemptibly_adverbs,
hushfully_adverbs,
ungrammatically_adverbs,
mistakenly_adverbs,
nonsympathizingly_adverbs,
undispassionately_adverbs,
stealthfully_adverbs,
psychotherapeutically_adverbs,
unsedately_adverbs,
unplausibly_adverbs,
furfuraceously_adverbs,
superartificially_adverbs,
fortuitously_adverbs,
tonnishly_adverbs,
flinchingly_adverbs,
quasigratefully_adverbs,
illhumoredly_adverbs,
quasiintuitively_adverbs,
tonally_adverbs,
hypernormally_adverbs,
multisonorously_adverbs,
dissipatedly_adverbs,
nonulcerously_adverbs,
kenogenetically_adverbs,
untimorously_adverbs,
comedically_adverbs,
gratingly_adverbs,
imbecilely_adverbs,
slopingly_adverbs,
nongrievously_adverbs,
popularly_adverbs,
muddlingly_adverbs,
transcendingly_adverbs,
hyperdiabolically_adverbs,
ostentatiously_adverbs,
diffusedly_adverbs,
anachronistically_adverbs,
peripherally_adverbs,
unglibly_adverbs,
overhostilely_adverbs,
longwindedly_adverbs,
readily_adverbs,
unsceptically_adverbs,
subalgebraically_adverbs,
undecipherably_adverbs,
unsubmissively_adverbs,
fasciculately_adverbs,
drastically_adverbs,
aristocratically_adverbs,
unliterally_adverbs,
unsoberly_adverbs,
discursively_adverbs,
unpenetratingly_adverbs,
nonissuably_adverbs,
biotechnologically_adverbs,
appulsively_adverbs,
cleistogamously_adverbs,
positivistically_adverbs,
hypernaturally_adverbs,
antidogmatically_adverbs,
continuously_adverbs,
semifiguratively_adverbs,
quasinormally_adverbs,
nongerundively_adverbs,
gutturally_adverbs,
beamingly_adverbs,
haltingly_adverbs,
initiatorily_adverbs,
overcasually_adverbs,
quasiproductively_adverbs,
concurrently_adverbs,
unelaborately_adverbs,
flightily_adverbs,
subnaturally_adverbs,
sacrilegiously_adverbs,
unsuggestively_adverbs,
indigestibly_adverbs,
anagogically_adverbs,
imperishably_adverbs,
upstaging_adverbs,
fourthly_adverbs,
untheologically_adverbs,
connivingly_adverbs,
springily_adverbs,
discomfortingly_adverbs,
gropingly_adverbs,
privily_adverbs,
noncuriously_adverbs,
enunciatively_adverbs,
irradiatingly_adverbs,
enjoyably_adverbs,
excursively_adverbs,
subjacently_adverbs,
noninertly_adverbs,
simul_adverbs,
subhorizontally_adverbs,
superlogically_adverbs,
nongraphically_adverbs,
unserenely_adverbs,
sternforemost_adverbs,
illusorily_adverbs,
uncondensably_adverbs,
begetter_adverbs,
overinsolently_adverbs,
nondeficiently_adverbs,
gloomily_adverbs,
phototelegraphically_adverbs,
unclandestinely_adverbs,
subpolygonally_adverbs,
unurbanely_adverbs,
subcutaneously_adverbs,
voraciously_adverbs,
effectually_adverbs,
curtly_adverbs,
nonunderstandingly_adverbs,
spectacularly_adverbs,
apiece_adverbs,
incuriously_adverbs,
atypically_adverbs,
unvenially_adverbs,
unmilitarily_adverbs,
undyingly_adverbs,
chicly_adverbs,
inspectingly_adverbs,
inartistically_adverbs,
septifragally_adverbs,
variatively_adverbs,
divisively_adverbs,
overmerrily_adverbs,
nonerratically_adverbs,
literately_adverbs,
rugosely_adverbs,
quasiorientally_adverbs,
sinningly_adverbs,
subglobosely_adverbs,
transmutably_adverbs,
crabbedly_adverbs,
preevidently_adverbs,
anteriorly_adverbs,
nontoxically_adverbs,
unsanguinely_adverbs,
unnasally_adverbs,
granularly_adverbs,
immorally_adverbs,
unprogressively_adverbs,
undefendably_adverbs,
quaveringly_adverbs,
semisuccessfully_adverbs,
stompingly_adverbs,
mechanomorphically_adverbs,
defensively_adverbs,
quasiproudly_adverbs,
unrustically_adverbs,
nonvenally_adverbs,
ungelatinously_adverbs,
exultingly_adverbs,
disconcertedly_adverbs,
quakily_adverbs,
agnatically_adverbs,
apishly_adverbs,
figurately_adverbs,
stintingly_adverbs,
persuadably_adverbs,
overdemandingly_adverbs,
untamely_adverbs,
entreatingly_adverbs,
unrecognisably_adverbs,
overtalkatively_adverbs,
halfdefiantly_adverbs,
unviciously_adverbs,
asseveratively_adverbs,
nonrepentantly_adverbs,
aboveboard_adverbs,
sagely_adverbs,
unarbitrarily_adverbs,
unsavorily_adverbs,
qualmishly_adverbs,
hypocoristically_adverbs,
disparagingly_adverbs,
noncyclically_adverbs,
unwaveringly_adverbs,
gibbously_adverbs,
exhibitively_adverbs,
quasipupillary_adverbs,
nonvillainously_adverbs,
apodeictically_adverbs,
gorily_adverbs,
monastically_adverbs,
spookily_adverbs,
superaerially_adverbs,
intuitionally_adverbs,
memorially_adverbs,
unmenially_adverbs,
unvauntingly_adverbs,
overwidely_adverbs,
popishly_adverbs,
nonderivatively_adverbs,
forehandedly_adverbs,
overreflectively_adverbs,
seriatim_adverbs,
barratrously_adverbs,
ungleefully_adverbs,
supercommercially_adverbs,
confirmingly_adverbs,
lastthing_adverbs,
nonbookishly_adverbs,
allegedly_adverbs,
subvitreously_adverbs,
electrovalently_adverbs,
beautifully_adverbs,
adventurously_adverbs,
roomily_adverbs,
unphysiologically_adverbs,
infra_adverbs,
ambagiously_adverbs,
forbiddingly_adverbs,
preworthily_adverbs,
unidiomatically_adverbs,
semifictionally_adverbs,
corruptly_adverbs,
quasiperpetually_adverbs,
quasiinfluentially_adverbs,
insomuch_adverbs,
slantly_adverbs,
notably_adverbs,
uninertly_adverbs,
avariciously_adverbs,
inflagrantedelicto_adverbs,
unremotely_adverbs,
nonsignificantly_adverbs,
spang_adverbs,
quasitheatrically_adverbs,
uninterpretively_adverbs,
blasphemously_adverbs,
noncorrosively_adverbs,
mixedly_adverbs,
hootingly_adverbs,
unveridically_adverbs,
underogatively_adverbs,
mouthily_adverbs,
overbearingly_adverbs,
contagiously_adverbs,
pertinaciously_adverbs,
inviolately_adverbs,
quasisarcastically_adverbs,
pennilessly_adverbs,
veritably_adverbs,
conjunctly_adverbs,
unsubstantially_adverbs,
bassly_adverbs,
unintensively_adverbs,
undoubtedly_adverbs,
ogrishly_adverbs,
nonepisodically_adverbs,
authentically_adverbs,
gemmily_adverbs,
nonperiodically_adverbs,
achromatically_adverbs,
inadmissibly_adverbs,
untemptingly_adverbs,
unhumanely_adverbs,
immaculately_adverbs,
overtolerantly_adverbs,
unagitatedly_adverbs,
palynologically_adverbs,
nonmutationally_adverbs,
contrastably_adverbs,
dissimilarly_adverbs,
enbloc_adverbs,
unstridently_adverbs,
unsymphoniously_adverbs,
magically_adverbs,
confessingly_adverbs,
expectingly_adverbs,
unappliably_adverbs,
untremulously_adverbs,
electrolytically_adverbs,
spectrographically_adverbs,
apart_adverbs,
outwardly_adverbs,
unconcordantly_adverbs,
morosely_adverbs,
melodramatically_adverbs,
nonconversably_adverbs,
unattractively_adverbs,
cephalad_adverbs,
glossarially_adverbs,
noninquiringly_adverbs,
unrevocably_adverbs,
overrichly_adverbs,
devilishly_adverbs,
worshipfully_adverbs,
binocularly_adverbs,
nonatheistically_adverbs,
selfwilledly_adverbs,
negatively_adverbs,
fastuously_adverbs,
concessively_adverbs,
nonrestrictedly_adverbs,
Patripassianly_adverbs,
parchedly_adverbs,
fro_adverbs,
unsinuously_adverbs,
untheistically_adverbs,
paradingly_adverbs,
nonepigrammatically_adverbs,
notedly_adverbs,
unbiasedly_adverbs,
superethically_adverbs,
nondiaphanously_adverbs,
nontheatrically_adverbs,
snufflingly_adverbs,
equatorially_adverbs,
metaphrastically_adverbs,
nonradically_adverbs,
overlaxly_adverbs,
unthematically_adverbs,
unappallingly_adverbs,
flashingly_adverbs,
noncruciformly_adverbs,
nonblamefully_adverbs,
cussedly_adverbs,
inequitably_adverbs,
overcleverly_adverbs,
healthily_adverbs,
unevilly_adverbs,
nonheretically_adverbs,
jumpily_adverbs,
cylindrically_adverbs,
Methodistically_adverbs,
heartrendingly_adverbs,
festively_adverbs,
unquizzically_adverbs,
lamellarly_adverbs,
aboon_adverbs,
seaward_adverbs,
spiritoso_adverbs,
tetragonally_adverbs,
drenchingly_adverbs,
tenthly_adverbs,
subgeometrically_adverbs,
basely_adverbs,
imitatively_adverbs,
appealingly_adverbs,
laboringly_adverbs,
insecurely_adverbs,
thereinafter_adverbs,
allogenically_adverbs,
overtrustfully_adverbs,
halfannoyingly_adverbs,
germinally_adverbs,
transversally_adverbs,
villainously_adverbs,
unsardonically_adverbs,
unheartily_adverbs,
uncategorically_adverbs,
pausefully_adverbs,
edgily_adverbs,
indirectly_adverbs,
semiactively_adverbs,
nonebulliently_adverbs,
gerundively_adverbs,
succulently_adverbs,
nonreproductively_adverbs,
unspiritually_adverbs,
astrictively_adverbs,
synovially_adverbs,
sincerely_adverbs,
revertively_adverbs,
admirably_adverbs,
antiracially_adverbs,
incandescently_adverbs,
unsolvably_adverbs,
muscularly_adverbs,
postprandially_adverbs,
harmfully_adverbs,
facultatively_adverbs,
unreproductively_adverbs,
rightly_adverbs,
hypertragically_adverbs,
conciliatingly_adverbs,
augmentatively_adverbs,
unfractiously_adverbs,
thereabout_adverbs,
untediously_adverbs,
noncommendably_adverbs,
unseraphically_adverbs,
nonfacetiously_adverbs,
gigantically_adverbs,
intervertebrally_adverbs,
quasidemandingly_adverbs,
emulatively_adverbs,
structurally_adverbs,
downily_adverbs,
eligibly_adverbs,
equivocally_adverbs,
incamera_adverbs,
ideologically_adverbs,
indemonstrably_adverbs,
unconfoundingly_adverbs,
quasiignorantly_adverbs,
probatively_adverbs,
chantingly_adverbs,
meagrely_adverbs,
quasiwickedly_adverbs,
tinily_adverbs,
antipathetically_adverbs,
uncatastrophically_adverbs,
aperiodically_adverbs,
quintessentially_adverbs,
hydrologically_adverbs,
too_adverbs,
semiresolutely_adverbs,
noneternally_adverbs,
nonsectionally_adverbs,
southwards_adverbs,
mollifyingly_adverbs,
subcortically_adverbs,
antimonarchically_adverbs,
nondyspeptically_adverbs,
evenhandedly_adverbs,
midships_adverbs,
nonmethodically_adverbs,
pseudoanatomically_adverbs,
unpreciously_adverbs,
antistrophically_adverbs,
quasiunconsciously_adverbs,
preexceptionally_adverbs,
mortifiedly_adverbs,
wholly_adverbs,
instantly_adverbs,
parenthetically_adverbs,
unprohibitively_adverbs,
prolongably_adverbs,
nonsuppositionally_adverbs,
unadhesively_adverbs,
agonizedly_adverbs,
overgreatly_adverbs,
dichotomously_adverbs,
denotatively_adverbs,
unJesuitically_adverbs,
stilly_adverbs,
nonoppressively_adverbs,
interlocally_adverbs,
chronoscopically_adverbs,
semipopularly_adverbs,
indecently_adverbs,
subdiaphragmatically_adverbs,
exhaustlessly_adverbs,
pisciculturally_adverbs,
desirably_adverbs,
unneedfully_adverbs,
inflammatorily_adverbs,
nonbuoyantly_adverbs,
evangelistically_adverbs,
unboyishly_adverbs,
thickly_adverbs,
resoundingly_adverbs,
incomprehensibly_adverbs,
childishly_adverbs,
tacitly_adverbs,
quasifictitiously_adverbs,
overhelpfully_adverbs,
suppositionally_adverbs,
expressionlessly_adverbs,
unmedically_adverbs,
unparasitically_adverbs,
awry_adverbs,
expostulatingly_adverbs,
unintermittently_adverbs,
unimmaculately_adverbs,
plurally_adverbs,
homiletically_adverbs,
unquerulously_adverbs,
limitedly_adverbs,
subdialectally_adverbs,
quasifoolishly_adverbs,
tremendously_adverbs,
leprously_adverbs,
sickeningly_adverbs,
unpossessively_adverbs,
supersufficiently_adverbs,
repletively_adverbs,
hermaphroditically_adverbs,
antiquely_adverbs,
insolvably_adverbs,
rankly_adverbs,
presuspiciously_adverbs,
unendingly_adverbs,
radically_adverbs,
nonmodernly_adverbs,
dependently_adverbs,
supereminently_adverbs,
nonfrigidly_adverbs,
semiexclusively_adverbs,
unjokingly_adverbs,
atomistically_adverbs,
nonsanctimoniously_adverbs,
collaterally_adverbs,
sturdily_adverbs,
geotropically_adverbs,
nonlucidly_adverbs,
unforensically_adverbs,
nondogmatically_adverbs,
mutually_adverbs,
quasidejectedly_adverbs,
nonmedically_adverbs,
uninimically_adverbs,
semirurally_adverbs,
subessentially_adverbs,
speculatively_adverbs,
subcrenately_adverbs,
nonfelicitously_adverbs,
waterward_adverbs,
auriculately_adverbs,
byandlarge_adverbs,
brightly_adverbs,
befittingly_adverbs,
nondemonstratively_adverbs,
unenigmatically_adverbs,
approximately_adverbs,
supervastly_adverbs,
unjustifiably_adverbs,
jettingly_adverbs,
premillennially_adverbs,
leviter_adverbs,
bootlessly_adverbs,
fiercely_adverbs,
impeccably_adverbs,
provisionally_adverbs,
questingly_adverbs,
unparadoxically_adverbs,
fleecily_adverbs,
relishingly_adverbs,
salubriously_adverbs,
semidefensively_adverbs,
dissentingly_adverbs,
supernumerously_adverbs,
inconsumably_adverbs,
bradyauxetically_adverbs,
bisymmetrically_adverbs,
serfishly_adverbs,
intelligibly_adverbs,
totally_adverbs,
nonreprehensibly_adverbs,
dallyingly_adverbs,
nonmonistically_adverbs,
stalkingly_adverbs,
grumpily_adverbs,
defectively_adverbs,
corroboratorily_adverbs,
rompishly_adverbs,
gyrostatically_adverbs,
unargumentatively_adverbs,
nonamenably_adverbs,
undeeply_adverbs,
fleshlily_adverbs,
plutocratically_adverbs,
quasiclerically_adverbs,
fructiferously_adverbs,
overcompetitively_adverbs,
quasipractically_adverbs,
uptodately_adverbs,
antispiritually_adverbs,
quasidiscreetly_adverbs,
pseudofamously_adverbs,
galleywest_adverbs,
noncomprehendingly_adverbs,
babyishly_adverbs,
effervescingly_adverbs,
bowingly_adverbs,
nonterritorially_adverbs,
semisolemnly_adverbs,
tunefully_adverbs,
ungodlily_adverbs,
unstealthily_adverbs,
nontyrannously_adverbs,
connivently_adverbs,
scarcely_adverbs,
pivotally_adverbs,
unfailingly_adverbs,
suspensively_adverbs,
lewdly_adverbs,
untempestuously_adverbs,
bionomically_adverbs,
yep_adverbs,
orad_adverbs,
already_adverbs,
watchfully_adverbs,
dioptrically_adverbs,
dedicatorily_adverbs,
nationally_adverbs,
cardinally_adverbs,
contrastively_adverbs,
gyroscopically_adverbs,
transmissively_adverbs,
quasiamusingly_adverbs,
nonloyally_adverbs,
unplentifully_adverbs,
venially_adverbs,
nonconsequentially_adverbs,
fascinatingly_adverbs,
quasimaternally_adverbs,
snappingly_adverbs,
nonscholastically_adverbs,
unapprovingly_adverbs,
nontyrannically_adverbs,
unhabitually_adverbs,
principally_adverbs,
fasciately_adverbs,
semimonarchically_adverbs,
selfcentredly_adverbs,
iteratively_adverbs,
sortably_adverbs,
spotlessly_adverbs,
undissemblingly_adverbs,
drunkenly_adverbs,
unpathetically_adverbs,
nonpredicatively_adverbs,
proconsularly_adverbs,
intracellularly_adverbs,
abruptly_adverbs,
semianthropologically_adverbs,
preconfusedly_adverbs,
quasidiplomatically_adverbs,
pleasurably_adverbs,
antiaggressively_adverbs,
cenogenetically_adverbs,
weekdays_adverbs,
grubbily_adverbs,
nonfeasibly_adverbs,
deceivably_adverbs,
overexpansively_adverbs,
superfervently_adverbs,
glidingly_adverbs,
engineeringly_adverbs,
extensively_adverbs,
unmaturely_adverbs,
unpuritanically_adverbs,
rotatively_adverbs,
convalescently_adverbs,
quasiimmediately_adverbs,
icily_adverbs,
disconnectedly_adverbs,
overcaptiously_adverbs,
nonmaritally_adverbs,
triangularly_adverbs,
amply_adverbs,
transatlantically_adverbs,
truantly_adverbs,
mirthfully_adverbs,
Levitically_adverbs,
organismically_adverbs,
polyrhythmically_adverbs,
absurdly_adverbs,
profitably_adverbs,
peakishly_adverbs,
prestudiously_adverbs,
ajar_adverbs,
absolutistically_adverbs,
nonoperatically_adverbs,
blinkingly_adverbs,
noneligibly_adverbs,
engrossingly_adverbs,
fillingly_adverbs,
encaustically_adverbs,
marvellously_adverbs,
haplessly_adverbs,
viscerally_adverbs,
darned_adverbs,
semihostilely_adverbs,
nonmountainously_adverbs,
untimidly_adverbs,
unobnoxiously_adverbs,
withoutdoors_adverbs,
droningly_adverbs,
supervirulently_adverbs,
whereabouts_adverbs,
venally_adverbs,
quasiconfidently_adverbs,
waterishly_adverbs,
viceregally_adverbs,
monocularly_adverbs,
synonymously_adverbs,
overbumptiously_adverbs,
preallowably_adverbs,
offendedly_adverbs,
responsibly_adverbs,
colourationally_adverbs,
nonlyrically_adverbs,
nonsynoptically_adverbs,
unsusceptibly_adverbs,
noncaustically_adverbs,
flatling_adverbs,
stammeringly_adverbs,
imprecatorily_adverbs,
pseudoaristocratically_adverbs,
subocularly_adverbs,
histogenetically_adverbs,
refreshingly_adverbs,
breathingly_adverbs,
massedly_adverbs,
exorbitantly_adverbs,
malapertly_adverbs,
unambitiously_adverbs,
huddlingly_adverbs,
nabobishly_adverbs,
untrustworthily_adverbs,
nonteleologically_adverbs,
difficultly_adverbs,
heteroeciously_adverbs,
tubulously_adverbs,
epidemically_adverbs,
reputably_adverbs,
unavailingly_adverbs,
crankily_adverbs,
avifaunally_adverbs,
falteringly_adverbs,
dividedly_adverbs,
days_adverbs,
neglectedly_adverbs,
unloquaciously_adverbs,
retrad_adverbs,
glimmeringly_adverbs,
quasiclassically_adverbs,
noninterruptedly_adverbs,
pardi_adverbs,
centrically_adverbs,
cantily_adverbs,
unsurrealistically_adverbs,
quasilaboriously_adverbs,
technologically_adverbs,
acock_adverbs,
unjuvenilely_adverbs,
hyperromantically_adverbs,
tastily_adverbs,
desirously_adverbs,
lenticularly_adverbs,
uncompassionately_adverbs,
mosso_adverbs,
disproportionally_adverbs,
nonnoumenally_adverbs,
hyperbatically_adverbs,
cryptanalytically_adverbs,
pseudomythically_adverbs,
squarely_adverbs,
undifferently_adverbs,
thoughtlessly_adverbs,
opinionatedly_adverbs,
auditorially_adverbs,
superangelically_adverbs,
evocatively_adverbs,
embarrassingly_adverbs,
nonadjustably_adverbs,
frontally_adverbs,
articulatorily_adverbs,
quasiphilosophically_adverbs,
unamusably_adverbs,
caudad_adverbs,
unmaternally_adverbs,
unbenevolently_adverbs,
questionably_adverbs,
fidgetingly_adverbs,
uncheerily_adverbs,
ungeometrically_adverbs,
combatively_adverbs,
collectivistically_adverbs,
threateningly_adverbs,
tactlessly_adverbs,
antiparasitically_adverbs,
unstingingly_adverbs,
indefensibly_adverbs,
blisteringly_adverbs,
stereotactically_adverbs,
cattishly_adverbs,
overfondly_adverbs,
quasiintolerantly_adverbs,
repellently_adverbs,
cleanly_adverbs,
nonzoologically_adverbs,
supervitally_adverbs,
hyperdelicately_adverbs,
partly_adverbs,
uninvitingly_adverbs,
leftwardly_adverbs,
forbiddenly_adverbs,
ultracentrifugally_adverbs,
bene_adverbs,
nonphenomenally_adverbs,
bloodthirstily_adverbs,
jimply_adverbs,
secondly_adverbs,
colorfully_adverbs,
opportunistically_adverbs,
glozingly_adverbs,
nonnocturnally_adverbs,
coastally_adverbs,
overconsiderately_adverbs,
influentially_adverbs,
scourgingly_adverbs,
unequally_adverbs,
elastically_adverbs,
nonrevocably_adverbs,
disbelievingly_adverbs,
anticyclically_adverbs,
quasiprepositionally_adverbs,
apperceptively_adverbs,
pervasively_adverbs,
nonrespectably_adverbs,
foolishly_adverbs,
answerlessly_adverbs,
frenetically_adverbs,
unbeknown_adverbs,
unenviously_adverbs,
tactually_adverbs,
aquatically_adverbs,
masochistically_adverbs,
mosaically_adverbs,
nonsedentarily_adverbs,
singlehandedly_adverbs,
cogitatingly_adverbs,
direly_adverbs,
arrantly_adverbs,
semiproductively_adverbs,
relievedly_adverbs,
theocratically_adverbs,
cripplingly_adverbs,
exhypothesi_adverbs,
unobservantly_adverbs,
manfully_adverbs,
semidramatically_adverbs,
prototypically_adverbs,
illtemperedly_adverbs,
dioeciously_adverbs,
semiphenomenally_adverbs,
fragmentarily_adverbs,
uncreatively_adverbs,
lightfully_adverbs,
mountainously_adverbs,
pyramidically_adverbs,
fluently_adverbs,
sonorously_adverbs,
gaspingly_adverbs,
insistently_adverbs,
planographically_adverbs,
certain_adverbs,
unuseably_adverbs,
divertingly_adverbs,
enmasse_adverbs,
itinerantly_adverbs,
unclassically_adverbs,
affrontedly_adverbs,
nonadjudicatively_adverbs,
viperishly_adverbs,
neurotically_adverbs,
unfoully_adverbs,
trivially_adverbs,
soaringly_adverbs,
lumpingly_adverbs,
unlanguidly_adverbs,
precisely_adverbs,
shimmeringly_adverbs,
glibly_adverbs,
convivially_adverbs,
Sabbatically_adverbs,
neer_adverbs,
prandially_adverbs,
unimperiously_adverbs,
unsavingly_adverbs,
quasiimpartially_adverbs,
noblemanly_adverbs,
quasigallantly_adverbs,
quasilawfully_adverbs,
subquarterly_adverbs,
needily_adverbs,
tripinnately_adverbs,
unpardonably_adverbs,
inaudibly_adverbs,
noncommodiously_adverbs,
permissively_adverbs,
geologically_adverbs,
overcarelessly_adverbs,
catechistically_adverbs,
contemporaneously_adverbs,
virtually_adverbs,
anomalistically_adverbs,
osteopathically_adverbs,
labyrinthically_adverbs,
noncapitalistically_adverbs,
intestinally_adverbs,
contentiously_adverbs,
preeligibly_adverbs,
unadventurously_adverbs,
spectrophotometrically_adverbs,
bigamously_adverbs,
equationally_adverbs,
uncriticizably_adverbs,
contradictively_adverbs,
oclock_adverbs,
unhesitatively_adverbs,
quasisufficiently_adverbs,
unstylishly_adverbs,
quasidutifully_adverbs,
illicitly_adverbs,
tearily_adverbs,
nostalgically_adverbs,
unsmirkingly_adverbs,
circumstantially_adverbs,
undestructibly_adverbs,
feverishly_adverbs,
supersaintly_adverbs,
lachrymosely_adverbs,
quasicynically_adverbs,
wellnigh_adverbs,
untactfully_adverbs,
heartbrokenly_adverbs,
algometrically_adverbs,
glycolytically_adverbs,
noninstructively_adverbs,
quasiheartily_adverbs,
galvanically_adverbs,
autohypnotically_adverbs,
suffusedly_adverbs,
unreprobatively_adverbs,
scoldingly_adverbs,
pentagonally_adverbs,
noncolonially_adverbs,
obeyingly_adverbs,
gratuitously_adverbs,
unmelodically_adverbs,
inductively_adverbs,
overboard_adverbs,
unexplosively_adverbs,
pietistically_adverbs,
simply_adverbs,
inelegantly_adverbs,
oversusceptibly_adverbs,
evilmindedly_adverbs,
unsickly_adverbs,
carpingly_adverbs,
defilingly_adverbs,
alternately_adverbs,
semioratorically_adverbs,
autocatalytically_adverbs,
eruptively_adverbs,
supersuspiciously_adverbs,
unfactiously_adverbs,
iodometrically_adverbs,
splurgily_adverbs,
incompactly_adverbs,
butyrically_adverbs,
astutely_adverbs,
nonconventionally_adverbs,
uncontagiously_adverbs,
quasiconstructively_adverbs,
prepotently_adverbs,
quasiconservatively_adverbs,
incestuously_adverbs,
nonflatulently_adverbs,
sinistrorsely_adverbs,
toxicologically_adverbs,
unpreceptively_adverbs,
uncontentiously_adverbs,
temptingly_adverbs,
sinfully_adverbs,
nondetrimentally_adverbs,
undangerously_adverbs,
trigonally_adverbs,
somnolently_adverbs,
expressively_adverbs,
insipidly_adverbs,
deliriously_adverbs,
pseudopiously_adverbs,
halfinstinctively_adverbs,
resemblingly_adverbs,
faintingly_adverbs,
preposterously_adverbs,
unsonorously_adverbs,
valiantly_adverbs,
nonmystically_adverbs,
nonsacredly_adverbs,
nonaccommodatingly_adverbs,
nonfugitively_adverbs,
gruntingly_adverbs,
remorselessly_adverbs,
sanctimoniously_adverbs,
quasilegally_adverbs,
stownlins_adverbs,
uncomputably_adverbs,
swelteringly_adverbs,
infirmly_adverbs,
kerplunk_adverbs,
southeastwards_adverbs,
straightly_adverbs,
assuredly_adverbs,
superficially_adverbs,
restrainingly_adverbs,
superattainably_adverbs,
hankeringly_adverbs,
oneirocritically_adverbs,
supermarginally_adverbs,
resolutely_adverbs,
nonwarrantably_adverbs,
beamily_adverbs,
socioculturally_adverbs,
twodimensionally_adverbs,
preadherently_adverbs,
cholerically_adverbs,
modernly_adverbs,
transmarginally_adverbs,
nonspeculatively_adverbs,
sternward_adverbs,
thereabouts_adverbs,
unhieratically_adverbs,
unironically_adverbs,
reticularly_adverbs,
discrepantly_adverbs,
ascendingly_adverbs,
anticonservatively_adverbs,
huffily_adverbs,
rantingly_adverbs,
antirealistically_adverbs,
quasiinternationally_adverbs,
frequently_adverbs,
lucidly_adverbs,
unperipherally_adverbs,
quasiextraterritorially_adverbs,
narratively_adverbs,
ensuingly_adverbs,
maximally_adverbs,
nonremediably_adverbs,
compactly_adverbs,
nonspinosely_adverbs,
unmistrustfully_adverbs,
irrotationally_adverbs,
flagrantedelicto_adverbs,
nonextraneously_adverbs,
supermechanically_adverbs,
tragicomically_adverbs,
quasiconstitutionally_adverbs,
profligately_adverbs,
unsomberly_adverbs,
sideways_adverbs,
unarrogantly_adverbs,
sinistrally_adverbs,
enzoutically_adverbs,
appetizingly_adverbs,
sometimes_adverbs,
allopatrically_adverbs,
variably_adverbs,
overapprehensively_adverbs,
unconscientiously_adverbs,
noncoincidentally_adverbs,
heliotypically_adverbs,
preceptively_adverbs,
antiexpressively_adverbs,
fifthly_adverbs,
pleonastically_adverbs,
unprepossessingly_adverbs,
extemporaneously_adverbs,
interse_adverbs,
sexlessly_adverbs,
boyishly_adverbs,
uncontestablely_adverbs,
convocationally_adverbs,
unconcentratedly_adverbs,
weightlessly_adverbs,
firstly_adverbs,
capitalistically_adverbs,
contemplatively_adverbs,
impersonally_adverbs,
untyrannically_adverbs,
unmagically_adverbs,
quasidiversely_adverbs,
overargumentatively_adverbs,
halfreluctantly_adverbs,
hypersensuously_adverbs,
nondeprecatorily_adverbs,
unrealistically_adverbs,
nonincidentally_adverbs,
ultrasonically_adverbs,
unsparsely_adverbs,
noncommunally_adverbs,
pantological_adverbs,
distractedly_adverbs,
heliocentrically_adverbs,
languorously_adverbs,
crampingly_adverbs,
uncomically_adverbs,
nonadeptly_adverbs,
nondualistically_adverbs,
dampishly_adverbs,
unenjoyably_adverbs,
undefiantly_adverbs,
unprosperously_adverbs,
tyrannisingly_adverbs,
extemporarily_adverbs,
annually_adverbs,
terrifyingly_adverbs,
noncoercively_adverbs,
hummingly_adverbs,
unceremoniously_adverbs,
overdeferentially_adverbs,
nonuprightly_adverbs,
discontentedly_adverbs,
unstoutly_adverbs,
unturbulently_adverbs,
sluttishly_adverbs,
highhandedly_adverbs,
Arcadianly_adverbs,
constantly_adverbs,
overenviously_adverbs,
complimentingly_adverbs,
initiatively_adverbs,
polemically_adverbs,
equilaterally_adverbs,
impishly_adverbs,
colourlessly_adverbs,
supplementally_adverbs,
felly_adverbs,
gleamingly_adverbs,
aversely_adverbs,
overboastfully_adverbs,
hypermagically_adverbs,
unbribably_adverbs,
doubly_adverbs,
helluva_adverbs,
micrometrically_adverbs,
prealphabetically_adverbs,
unresiliently_adverbs,
botchedly_adverbs,
pseudocritically_adverbs,
punctatim_adverbs,
nonextricably_adverbs,
unwanderingly_adverbs,
hypermiraculously_adverbs,
harmlessly_adverbs,
straightaway_adverbs,
waterlessly_adverbs,
quasiemotionally_adverbs,
vexatiously_adverbs,
autographically_adverbs,
preferably_adverbs,
nonmanually_adverbs,
nonvacantly_adverbs,
unvituperatively_adverbs,
unsecurely_adverbs,
corporeally_adverbs,
metagenetically_adverbs,
stramineously_adverbs,
loutishly_adverbs,
therapeutically_adverbs,
lucklessly_adverbs,
overanimatedly_adverbs,
astonishedly_adverbs,
unmixedly_adverbs,
undeviously_adverbs,
convolutely_adverbs,
inexpiably_adverbs,
subsatirically_adverbs,
subopaquely_adverbs,
slangily_adverbs,
illfavoredly_adverbs,
eccentrically_adverbs,
overprovidently_adverbs,
filmily_adverbs,
debasingly_adverbs,
ontogenetically_adverbs,
smugly_adverbs,
Ciceronically_adverbs,
corruptedly_adverbs,
superpolitely_adverbs,
unstoppably_adverbs,
undifferentiably_adverbs,
nongeologically_adverbs,
unconducively_adverbs,
unbrightly_adverbs,
quasisatirically_adverbs,
nondiligently_adverbs,
caliginously_adverbs,
vocatively_adverbs,
unawarely_adverbs,
nonclerically_adverbs,
nonsurrealistically_adverbs,
quasieagerly_adverbs,
quasiapologetically_adverbs,
gradually_adverbs,
unmurmurously_adverbs,
inimically_adverbs,
blackly_adverbs,
unveritably_adverbs,
pseudoeducationally_adverbs,
quasidoubtfully_adverbs,
agamically_adverbs,
superexceptionally_adverbs,
dyspeptically_adverbs,
hysteretically_adverbs,
pesteringly_adverbs,
dreadfully_adverbs,
freakishly_adverbs,
nonarithmetically_adverbs,
raveningly_adverbs,
overnegligently_adverbs,
nonorally_adverbs,
offensively_adverbs,
tartly_adverbs,
Gallice_adverbs,
halfmentally_adverbs,
sterically_adverbs,
Spartanically_adverbs,
saintlily_adverbs,
semiironically_adverbs,
toploftily_adverbs,
incompetently_adverbs,
nonfastidiously_adverbs,
keenly_adverbs,
unsexually_adverbs,
consciencelessly_adverbs,
unschematically_adverbs,
calculatingly_adverbs,
histologically_adverbs,
unshowily_adverbs,
unpropitiously_adverbs,
deficiently_adverbs,
trieciously_adverbs,
everywhen_adverbs,
wirelessly_adverbs,
flavorfully_adverbs,
grimly_adverbs,
iniquitously_adverbs,
nonevanescently_adverbs,
nondefensively_adverbs,
unrighteously_adverbs,
nonponderously_adverbs,
willlessly_adverbs,
nonpejoratively_adverbs,
unamazedly_adverbs,
unfrequently_adverbs,
regardfully_adverbs,
desiredly_adverbs,
welldeservedly_adverbs,
horrendously_adverbs,
quasistylishly_adverbs,
unabatedly_adverbs,
overfervently_adverbs,
flickeringly_adverbs,
rompingly_adverbs,
peakily_adverbs,
unecliptically_adverbs,
beauteously_adverbs,
voluminously_adverbs,
conveniently_adverbs,
plastically_adverbs,
immitigably_adverbs,
pinnatedly_adverbs,
cotemporaneously_adverbs,
instanter_adverbs,
semiopenly_adverbs,
superaffluently_adverbs,
chromosomally_adverbs,
unromantically_adverbs,
exclamatorily_adverbs,
monolithically_adverbs,
quasiexternally_adverbs,
balsamically_adverbs,
mantically_adverbs,
vigilantly_adverbs,
untropically_adverbs,
subgranularly_adverbs,
undeviatingly_adverbs,
dancingly_adverbs,
predisastrously_adverbs,
unphilanthropically_adverbs,
doltishly_adverbs,
undiplomatically_adverbs,
capriccioso_adverbs,
overjoyfully_adverbs,
begrudgingly_adverbs,
suggestibly_adverbs,
unimpassionately_adverbs,
overabusively_adverbs,
ratably_adverbs,
unbarbarously_adverbs,
gauntly_adverbs,
dialectally_adverbs,
remuneratively_adverbs,
Hebraically_adverbs,
friskily_adverbs,
quasieloquently_adverbs,
happily_adverbs,
puzzlingly_adverbs,
quasimaliciously_adverbs,
frantically_adverbs,
parallelly_adverbs,
genealogically_adverbs,
seminervously_adverbs,
nontransitively_adverbs,
luxuriantly_adverbs,
symphonically_adverbs,
enliveningly_adverbs,
overfluently_adverbs,
nonpreferentially_adverbs,
unvaryingly_adverbs,
nonambitiously_adverbs,
synodically_adverbs,
chaffingly_adverbs,
morbifically_adverbs,
fatidically_adverbs,
halfindignantly_adverbs,
measurelessly_adverbs,
crammingly_adverbs,
caperingly_adverbs,
underisively_adverbs,
caustically_adverbs,
feignedly_adverbs,
sleeplessly_adverbs,
supereffectively_adverbs,
quasiprogressively_adverbs,
oblongly_adverbs,
unpatronizingly_adverbs,
pseudodramatically_adverbs,
nonrationalistically_adverbs,
overdescriptively_adverbs,
electively_adverbs,
vocationally_adverbs,
jollily_adverbs,
rathely_adverbs,
stagily_adverbs,
semijudicially_adverbs,
patrimonially_adverbs,
unprecociously_adverbs,
subaffluently_adverbs,
unpitifully_adverbs,
somehow_adverbs,
digestibly_adverbs,
unprecipitously_adverbs,
semischolastically_adverbs,
damningly_adverbs,
incomputably_adverbs,
reluctantly_adverbs,
sic_adverbs,
increasingly_adverbs,
tridimensionally_adverbs,
unintrudingly_adverbs,
privatively_adverbs,
morganatically_adverbs,
nonthematically_adverbs,
antiBiblically_adverbs,
humblingly_adverbs,
stethoscopically_adverbs,
unethnologically_adverbs,
unincestuously_adverbs,
hornily_adverbs,
Homerically_adverbs,
unclassifiably_adverbs,
undeliciously_adverbs,
chirpingly_adverbs,
antichristianly_adverbs,
Anglicanly_adverbs,
desultorily_adverbs,
nonpopulously_adverbs,
overstimulatively_adverbs,
nontragically_adverbs,
comprehensibly_adverbs,
commendably_adverbs,
unpresidentially_adverbs,
compactedly_adverbs,
uncompliantly_adverbs,
geophysically_adverbs,
subrosa_adverbs,
unsupply_adverbs,
connivantly_adverbs,
overgraciously_adverbs,
sharpnosedly_adverbs,
indigenously_adverbs,
socioeconomically_adverbs,
opprobriously_adverbs,
basad_adverbs,
halfingeniously_adverbs,
venturously_adverbs,
subfunctionally_adverbs,
nonintrovertedly_adverbs,
unwhimperingly_adverbs,
unsupportably_adverbs,
unfestively_adverbs,
quasiguiltily_adverbs,
deceptively_adverbs,
uncomprehensively_adverbs,
pragmatically_adverbs,
pharmacologically_adverbs,
hoveringly_adverbs,
scribblingly_adverbs,
manlessly_adverbs,
inconspicuously_adverbs,
hypercritically_adverbs,
unbalkingly_adverbs,
spryly_adverbs,
nonprolixly_adverbs,
ungratefully_adverbs,
savoringly_adverbs,
farforthly_adverbs,
frumpishly_adverbs,
longly_adverbs,
disdainfully_adverbs,
adoptively_adverbs,
cravingly_adverbs,
uninferably_adverbs,
artistically_adverbs,
goodheartedly_adverbs,
forwardly_adverbs,
stingily_adverbs,
inapplicably_adverbs,
physiognomonically_adverbs,
antimystically_adverbs,
hyperobtrusively_adverbs,
recurringly_adverbs,
erroneously_adverbs,
covinously_adverbs,
benevolently_adverbs,
acidimetrically_adverbs,
awedly_adverbs,
overplainly_adverbs,
stupendously_adverbs,
cheerily_adverbs,
unmetaphysically_adverbs,
organizationally_adverbs,
nonfamiliarly_adverbs,
nondevotionally_adverbs,
unthinkingly_adverbs,
quasifashionably_adverbs,
ruffly_adverbs,
dimensionally_adverbs,
unangularly_adverbs,
unviolently_adverbs,
verbally_adverbs,
nonritualistically_adverbs,
unexorbitantly_adverbs,
uncausatively_adverbs,
awfully_adverbs,
overproportionately_adverbs,
intracutaneously_adverbs,
cannibalistically_adverbs,
thereat_adverbs,
culturally_adverbs,
smudgedly_adverbs,
nonhieratically_adverbs,
nonmeteorically_adverbs,
rectangularly_adverbs,
balefully_adverbs,
quasivenerably_adverbs,
Jacobitically_adverbs,
sinistrad_adverbs,
logogrammatically_adverbs,
mazily_adverbs,
amusingly_adverbs,
domineeringly_adverbs,
shrilly_adverbs,
firmly_adverbs,
impalpably_adverbs,
breathlessly_adverbs,
corroboratively_adverbs,
unautomatically_adverbs,
conjugably_adverbs,
overhotly_adverbs,
subcandidly_adverbs,
greyly_adverbs,
gloatingly_adverbs,
bifidly_adverbs,
conciliatorily_adverbs,
clamorously_adverbs,
curelessly_adverbs,
whimsically_adverbs,
unpresumptively_adverbs,
unphysically_adverbs,
snaringly_adverbs,
lightheadedly_adverbs,
fundamentally_adverbs,
unamiably_adverbs,
telltalely_adverbs,
unprovidentially_adverbs,
superbelievably_adverbs,
nonconcordant_adverbs,
tanto_adverbs,
unagilely_adverbs,
preobediently_adverbs,
paltrily_adverbs,
precranially_adverbs,
inflatedly_adverbs,
unintrospectively_adverbs,
dispersedly_adverbs,
uninventively_adverbs,
sequaciously_adverbs,
nohow_adverbs,
medicably_adverbs,
populously_adverbs,
noisily_adverbs,
imaginably_adverbs,
mellowly_adverbs,
unlikably_adverbs,
evaporatively_adverbs,
pseudoaggressively_adverbs,
superinfinitely_adverbs,
nonimperially_adverbs,
nowhither_adverbs,
nonsubstitutionally_adverbs,
accommodatingly_adverbs,
unfrictionally_adverbs,
nonclassically_adverbs,
subprofitably_adverbs,
pryingly_adverbs,
libidinously_adverbs,
joyfully_adverbs,
uncarnivorously_adverbs,
gratefully_adverbs,
untoughly_adverbs,
meristematically_adverbs,
superexplicitly_adverbs,
indulgingly_adverbs,
cursedly_adverbs,
wagglingly_adverbs,
botanically_adverbs,
compellingly_adverbs,
nondependably_adverbs,
categorically_adverbs,
posthypnotically_adverbs,
culinarily_adverbs,
unpatristically_adverbs,
untechnically_adverbs,
congruently_adverbs,
unhorizontally_adverbs,
superdifficultly_adverbs,
photomechanically_adverbs,
imperturbably_adverbs,
nondramatically_adverbs,
severally_adverbs,
quasicommandingly_adverbs,
indefectibly_adverbs,
latently_adverbs,
frictionlessly_adverbs,
preexclusively_adverbs,
halfseriously_adverbs,
nonjuridically_adverbs,
perennially_adverbs,
decreasingly_adverbs,
quasimagically_adverbs,
overtimidly_adverbs,
unvividly_adverbs,
skilfully_adverbs,
adventively_adverbs,
unverbosely_adverbs,
thinkably_adverbs,
cyclonically_adverbs,
halfcontemptuously_adverbs,
sapiently_adverbs,
favoringly_adverbs,
denunciatively_adverbs,
indispensably_adverbs,
unfashionably_adverbs,
uncourageously_adverbs,
interiorly_adverbs,
conversely_adverbs,
nonbusily_adverbs,
widely_adverbs,
contrariously_adverbs,
justly_adverbs,
patricianly_adverbs,
nonchimerically_adverbs,
furrily_adverbs,
horrifiedly_adverbs,
deathlessly_adverbs,
superromantically_adverbs,
secondarily_adverbs,
impressively_adverbs,
enrichingly_adverbs,
languishingly_adverbs,
quasibrilliantly_adverbs,
quasigenerously_adverbs,
oldfashionedly_adverbs,
tristfully_adverbs,
lyingly_adverbs,
quasiharmfully_adverbs,
aboriginally_adverbs,
spikily_adverbs,
nonfunctionally_adverbs,
catalytically_adverbs,
embarrassedly_adverbs,
preluxuriously_adverbs,
pratingly_adverbs,
bushily_adverbs,
uncordially_adverbs,
thuddingly_adverbs,
woodenly_adverbs,
cheekily_adverbs,
noninferentially_adverbs,
riotously_adverbs,
militarily_adverbs,
unsportively_adverbs,
noncasuistically_adverbs,
quasigravely_adverbs,
corpulently_adverbs,
designingly_adverbs,
apathetically_adverbs,
afire_adverbs,
tolerably_adverbs,
nastily_adverbs,
idealistically_adverbs,
unheavily_adverbs,
warmly_adverbs,
nontroppo_adverbs,
quasiorganically_adverbs,
overprolifically_adverbs,
nonsensically_adverbs,
unmordantly_adverbs,
unwildly_adverbs,
unauspiciously_adverbs,
unwilfully_adverbs,
periodically_adverbs,
plumosely_adverbs,
supernegligently_adverbs,
tastelessly_adverbs,
oversparingly_adverbs,
quasiexceptionally_adverbs,
overhighly_adverbs,
revengefully_adverbs,
shrinkingly_adverbs,
musicologically_adverbs,
uncritically_adverbs,
seclusively_adverbs,
unprofusely_adverbs,
nonantagonistically_adverbs,
quasipeacefully_adverbs,
dolorously_adverbs,
unpredicatively_adverbs,
aplanatically_adverbs,
braggingly_adverbs,
obediently_adverbs,
undecadently_adverbs,
unpresumptuously_adverbs,
unsoporiferously_adverbs,
unperilously_adverbs,
insinuatively_adverbs,
worthily_adverbs,
taxonomically_adverbs,
uncontinually_adverbs,
banefully_adverbs,
verily_adverbs,
overgrievously_adverbs,
flowingly_adverbs,
Hellenically_adverbs,
confoundingly_adverbs,
unsullenly_adverbs,
advantageously_adverbs,
irremissibly_adverbs,
trenchantly_adverbs,
preofficially_adverbs,
archeologically_adverbs,
subautomatically_adverbs,
dogmatically_adverbs,
inconsolably_adverbs,
trustily_adverbs,
uninstrumentally_adverbs,
pseudogentlemanly_adverbs,
starrily_adverbs,
silviculturally_adverbs,
stridulously_adverbs,
wretchedly_adverbs,
overstoutly_adverbs,
uncomplacently_adverbs,
condensedly_adverbs,
featly_adverbs,
halfconvincingly_adverbs,
commendingly_adverbs,
unassailably_adverbs,
prehistorically_adverbs,
tyrannously_adverbs,
thermoscopically_adverbs,
untrivially_adverbs,
uneuphoniously_adverbs,
overgloomily_adverbs,
predomestically_adverbs,
phyletically_adverbs,
overgreedily_adverbs,
terribly_adverbs,
trop_adverbs,
extraversively_adverbs,
aft_adverbs,
huntedly_adverbs,
flirtatiously_adverbs,
septically_adverbs,
overabundantly_adverbs,
selfconsistently_adverbs,
aback_adverbs,
unimaginatively_adverbs,
antisensuously_adverbs,
scripturally_adverbs,
nonabidingly_adverbs,
telegraphically_adverbs,
nonseditiously_adverbs,
quasifiscally_adverbs,
unhumorously_adverbs,
nonhierarchically_adverbs,
epidermically_adverbs,
percontra_adverbs,
unassumingly_adverbs,
perspectively_adverbs,
amphibiously_adverbs,
semiilliterately_adverbs,
thankfully_adverbs,
consolitorily_adverbs,
cuneately_adverbs,
overseverely_adverbs,
fictively_adverbs,
uneffulgently_adverbs,
crustily_adverbs,
unconformably_adverbs,
carefully_adverbs,
proscriptively_adverbs,
tetrahedrally_adverbs,
uxoriously_adverbs,
charitably_adverbs,
rattling_adverbs,
unsubversively_adverbs,
pseudoarchaically_adverbs,
doubtably_adverbs,
logarithmically_adverbs,
anymore_adverbs,
noninterdependently_adverbs,
extrovertively_adverbs,
carousingly_adverbs,
festally_adverbs,
overfrequently_adverbs,
gnathonically_adverbs,
unrhetorically_adverbs,
remonstratively_adverbs,
jurally_adverbs,
nontalkatively_adverbs,
insuppressibly_adverbs,
nonfluidly_adverbs,
evolutionarily_adverbs,
nonofficially_adverbs,
quasiefficiently_adverbs,
fulsomely_adverbs,
flauntily_adverbs,
intellectively_adverbs,
penicillately_adverbs,
sternwards_adverbs,
trebly_adverbs,
nonjudicially_adverbs,
judiciously_adverbs,
predestinately_adverbs,
jawbreakingly_adverbs,
conclusively_adverbs,
unattributively_adverbs,
bipartitely_adverbs,
nonpsychoanalytically_adverbs,
ungenially_adverbs,
nonharmoniously_adverbs,
intercostally_adverbs,
libelously_adverbs,
uninstitutively_adverbs,
feverously_adverbs,
growlingly_adverbs,
elvishly_adverbs,
orbicularly_adverbs,
unvoluntarily_adverbs,
thataway_adverbs,
decisively_adverbs,
psychanalytically_adverbs,
regerminatively_adverbs,
unperfidiously_adverbs,
nonperpendicularly_adverbs,
photosynthetically_adverbs,
complimentarily_adverbs,
synaptically_adverbs,
understandably_adverbs,
pleasingly_adverbs,
swayingly_adverbs,
gradatim_adverbs,
anthropomorphically_adverbs,
quasicontinuously_adverbs,
anticryptically_adverbs,
interferingly_adverbs,
allegorically_adverbs,
overlogically_adverbs,
quasigenteelly_adverbs,
churchward_adverbs,
dilatably_adverbs,
accordantly_adverbs,
puritanically_adverbs,
hereinbefore_adverbs,
frothily_adverbs,
superimportantly_adverbs,
semiovally_adverbs,
diminishingly_adverbs,
protractedly_adverbs,
blushingly_adverbs,
absolutely_adverbs,
upstairs_adverbs,
overponderously_adverbs,
superglottally_adverbs,
atomically_adverbs,
nonpacifically_adverbs,
detractively_adverbs,
bumpily_adverbs,
scrapingly_adverbs,
convictively_adverbs,
reposedly_adverbs,
goodnaturedly_adverbs,
supernormally_adverbs,
impermanently_adverbs,
genuinely_adverbs,
villously_adverbs,
nonorchestrally_adverbs,
afore_adverbs,
nonidyllically_adverbs,
incorruptly_adverbs,
alarmingly_adverbs,
nontechnologically_adverbs,
unstupidly_adverbs,
nontreasonably_adverbs,
thereby_adverbs,
overremissly_adverbs,
profusely_adverbs,
jabbingly_adverbs,
verbatim_adverbs,
supermorosely_adverbs,
usurpingly_adverbs,
nonoffensively_adverbs,
lyrately_adverbs,
scathelessly_adverbs,
pretemperately_adverbs,
chickenheartedly_adverbs,
venturesomely_adverbs,
unsacredly_adverbs,
inquisitorially_adverbs,
halfclearly_adverbs,
unhomiletically_adverbs,
aimfully_adverbs,
nonvigilantly_adverbs,
nonneutrally_adverbs,
rockingly_adverbs,
changelessly_adverbs,
nonastronomically_adverbs,
erringly_adverbs,
quasiradically_adverbs,
tetartohedrally_adverbs,
calculably_adverbs,
hungeringly_adverbs,
correctly_adverbs,
overlearnedly_adverbs,
discernably_adverbs,
beforetime_adverbs,
tawdrily_adverbs,
taxably_adverbs,
existentialistically_adverbs,
depreciatingly_adverbs,
oversocially_adverbs,
moilingly_adverbs,
anaerobically_adverbs,
nowhence_adverbs,
indicially_adverbs,
soberingly_adverbs,
semiofficially_adverbs,
indefinitely_adverbs,
patronisingly_adverbs,
unloathly_adverbs,
nonadverbially_adverbs,
graphically_adverbs,
woefully_adverbs,
unaspiringly_adverbs,
unvainly_adverbs,
garrulously_adverbs,
askew_adverbs,
halfjokingly_adverbs,
anticipatively_adverbs,
adrift_adverbs,
wholesomely_adverbs,
semblably_adverbs,
mutably_adverbs,
unsombrely_adverbs,
sempre_adverbs,
noneducationally_adverbs,
unambiently_adverbs,
eloquently_adverbs,
quasieducationally_adverbs,
unscrutinisingly_adverbs,
elliptically_adverbs,
addedly_adverbs,
nonemotionally_adverbs,
nonresponsibly_adverbs,
reposefully_adverbs,
overcleanly_adverbs,
heterogenetically_adverbs,
distantly_adverbs,
unexultantly_adverbs,
geodetically_adverbs,
gasometrically_adverbs,
aimlessly_adverbs,
securely_adverbs,
litteratim_adverbs,
horridly_adverbs,
blockheadedly_adverbs,
baggily_adverbs,
diagnostically_adverbs,
quenchlessly_adverbs,
quasipassively_adverbs,
relaxedly_adverbs,
unconcentrically_adverbs,
nonlibelously_adverbs,
superindependently_adverbs,
overdramatically_adverbs,
noncontroversially_adverbs,
insuperably_adverbs,
unperniciously_adverbs,
nonformidably_adverbs,
harbourward_adverbs,
overfaintly_adverbs,
uncommemoratively_adverbs,
vertically_adverbs,
odiously_adverbs,
supercritically_adverbs,
halfexpectantly_adverbs,
vibrantly_adverbs,
muzzily_adverbs,
excellently_adverbs,
emotively_adverbs,
oversweetly_adverbs,
intensely_adverbs,
demurely_adverbs,
slenderly_adverbs,
excusably_adverbs,
peerlessly_adverbs,
unhurriedly_adverbs,
unsequentially_adverbs,
nonastringently_adverbs,
fleeringly_adverbs,
unpedagogically_adverbs,
incessantly_adverbs,
nonadhesively_adverbs,
nonirrevocably_adverbs,
noninstructionally_adverbs,
malgr_adverbs,
lifelessly_adverbs,
overobediently_adverbs,
overtediously_adverbs,
superciliously_adverbs,
uneloquently_adverbs,
whizzingly_adverbs,
irrevocably_adverbs,
unmanageably_adverbs,
invalidly_adverbs,
superingeniously_adverbs,
uncompetently_adverbs,
overdeliciously_adverbs,
urbanistically_adverbs,
peradventure_adverbs,
esoterically_adverbs,
goodhumouredly_adverbs,
inclusively_adverbs,
fatalistically_adverbs,
uncalmly_adverbs,
leerily_adverbs,
quasideliberately_adverbs,
incombustibly_adverbs,
unsinuately_adverbs,
polygamously_adverbs,
concretely_adverbs,
supercuriously_adverbs,
distastefully_adverbs,
hoggishly_adverbs,
azimuthally_adverbs,
unslanderously_adverbs,
brimfully_adverbs,
unconcurrently_adverbs,
topographically_adverbs,
unrhapsodically_adverbs,
fabulously_adverbs,
nonenthusiastically_adverbs,
quasibenevolently_adverbs,
soughfully_adverbs,
erratically_adverbs,
gullably_adverbs,
considerably_adverbs,
subpharyngeally_adverbs,
unmeritoriously_adverbs,
coastward_adverbs,
unpositively_adverbs,
undeliberately_adverbs,
incumbently_adverbs,
aerobacteriologically_adverbs,
consubstantially_adverbs,
nohit_adverbs,
unapprehendably_adverbs,
subterminally_adverbs,
nonethereally_adverbs,
nonconvertibly_adverbs,
overspeedily_adverbs,
shatteringly_adverbs,
favouredly_adverbs,
rosily_adverbs,
empathically_adverbs,
overproficiently_adverbs,
unexceptionably_adverbs,
tricklingly_adverbs,
quasiformally_adverbs,
unbriefly_adverbs,
holoblastically_adverbs,
uncrudely_adverbs,
nonformally_adverbs,
};
